#include "tree_sitter/parser.h"

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#ifdef _MSC_VER
#pragma optimize("", off)
#elif defined(__clang__)
#pragma clang optimize off
#elif defined(__GNUC__)
#pragma GCC optimize ("O0")
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 9953
#define LARGE_STATE_COUNT 4431
#define SYMBOL_COUNT 493
#define ALIAS_COUNT 2
#define TOKEN_COUNT 213
#define EXTERNAL_TOKEN_COUNT 9
#define FIELD_COUNT 26
#define MAX_ALIAS_SEQUENCE_LENGTH 15
#define PRODUCTION_ID_COUNT 226

enum ts_symbol_identifiers {
  sym__identifier_token = 1,
  anon_sym_extern = 2,
  anon_sym_alias = 3,
  anon_sym_SEMI = 4,
  anon_sym_global = 5,
  anon_sym_using = 6,
  anon_sym_unsafe = 7,
  anon_sym_EQ = 8,
  anon_sym_static = 9,
  anon_sym_LBRACK = 10,
  anon_sym_assembly = 11,
  anon_sym_module = 12,
  anon_sym_COLON = 13,
  anon_sym_COMMA = 14,
  anon_sym_RBRACK = 15,
  anon_sym_LPAREN = 16,
  anon_sym_RPAREN = 17,
  anon_sym_field = 18,
  anon_sym_event = 19,
  anon_sym_method = 20,
  anon_sym_param = 21,
  anon_sym_property = 22,
  anon_sym_return = 23,
  anon_sym_type = 24,
  anon_sym_namespace = 25,
  anon_sym_class = 26,
  anon_sym_ref = 27,
  anon_sym_struct = 28,
  anon_sym_enum = 29,
  anon_sym_LBRACE = 30,
  anon_sym_RBRACE = 31,
  anon_sym_interface = 32,
  anon_sym_delegate = 33,
  anon_sym_record = 34,
  anon_sym_abstract = 35,
  anon_sym_async = 36,
  anon_sym_const = 37,
  anon_sym_file = 38,
  anon_sym_fixed = 39,
  anon_sym_internal = 40,
  anon_sym_new = 41,
  anon_sym_override = 42,
  anon_sym_partial = 43,
  anon_sym_private = 44,
  anon_sym_protected = 45,
  anon_sym_public = 46,
  anon_sym_readonly = 47,
  anon_sym_required = 48,
  anon_sym_sealed = 49,
  anon_sym_virtual = 50,
  anon_sym_volatile = 51,
  anon_sym_LT = 52,
  anon_sym_GT = 53,
  anon_sym_in = 54,
  anon_sym_out = 55,
  anon_sym_where = 56,
  anon_sym_QMARK = 57,
  anon_sym_notnull = 58,
  anon_sym_unmanaged = 59,
  anon_sym_operator = 60,
  anon_sym_checked = 61,
  anon_sym_BANG = 62,
  anon_sym_TILDE = 63,
  anon_sym_PLUS_PLUS = 64,
  anon_sym_DASH_DASH = 65,
  anon_sym_true = 66,
  anon_sym_false = 67,
  anon_sym_PLUS = 68,
  anon_sym_DASH = 69,
  anon_sym_STAR = 70,
  anon_sym_SLASH = 71,
  anon_sym_PERCENT = 72,
  anon_sym_CARET = 73,
  anon_sym_PIPE = 74,
  anon_sym_AMP = 75,
  anon_sym_LT_LT = 76,
  anon_sym_GT_GT = 77,
  anon_sym_GT_GT_GT = 78,
  anon_sym_EQ_EQ = 79,
  anon_sym_BANG_EQ = 80,
  anon_sym_GT_EQ = 81,
  anon_sym_LT_EQ = 82,
  anon_sym_implicit = 83,
  anon_sym_explicit = 84,
  anon_sym_get = 85,
  anon_sym_set = 86,
  anon_sym_add = 87,
  anon_sym_remove = 88,
  anon_sym_init = 89,
  anon_sym_this = 90,
  anon_sym_DOT = 91,
  anon_sym_scoped = 92,
  anon_sym_params = 93,
  anon_sym_base = 94,
  anon_sym_EQ_GT = 95,
  anon_sym_COLON_COLON = 96,
  anon_sym_var = 97,
  anon_sym_managed = 98,
  anon_sym_Cdecl = 99,
  anon_sym_Stdcall = 100,
  anon_sym_Thiscall = 101,
  anon_sym_Fastcall = 102,
  sym_predefined_type = 103,
  anon_sym_break = 104,
  anon_sym_unchecked = 105,
  anon_sym_continue = 106,
  anon_sym_do = 107,
  anon_sym_while = 108,
  anon_sym_for = 109,
  anon_sym_lock = 110,
  anon_sym_yield = 111,
  anon_sym_switch = 112,
  anon_sym_case = 113,
  anon_sym_default = 114,
  anon_sym_throw = 115,
  anon_sym_try = 116,
  anon_sym_catch = 117,
  anon_sym_when = 118,
  anon_sym_finally = 119,
  anon_sym_await = 120,
  anon_sym_foreach = 121,
  anon_sym_goto = 122,
  anon_sym_if = 123,
  anon_sym_else = 124,
  sym_discard = 125,
  anon_sym_DOT_DOT = 126,
  anon_sym_not = 127,
  anon_sym_and = 128,
  anon_sym_or = 129,
  anon_sym_PLUS_EQ = 130,
  anon_sym_DASH_EQ = 131,
  anon_sym_STAR_EQ = 132,
  anon_sym_SLASH_EQ = 133,
  anon_sym_PERCENT_EQ = 134,
  anon_sym_AMP_EQ = 135,
  anon_sym_CARET_EQ = 136,
  anon_sym_PIPE_EQ = 137,
  anon_sym_LT_LT_EQ = 138,
  anon_sym_GT_GT_EQ = 139,
  anon_sym_GT_GT_GT_EQ = 140,
  anon_sym_QMARK_QMARK_EQ = 141,
  anon_sym_AMP_AMP = 142,
  anon_sym_PIPE_PIPE = 143,
  anon_sym_QMARK_QMARK = 144,
  anon_sym_from = 145,
  anon_sym_into = 146,
  anon_sym_join = 147,
  anon_sym_on = 148,
  anon_sym_equals = 149,
  anon_sym_let = 150,
  anon_sym_orderby = 151,
  anon_sym_ascending = 152,
  anon_sym_descending = 153,
  anon_sym_group = 154,
  anon_sym_by = 155,
  anon_sym_select = 156,
  anon_sym_as = 157,
  anon_sym_is = 158,
  anon_sym_DQUOTE = 159,
  aux_sym_interpolation_format_clause_token1 = 160,
  anon_sym_DASH_GT = 161,
  anon_sym_stackalloc = 162,
  anon_sym_with = 163,
  anon_sym_sizeof = 164,
  anon_sym_typeof = 165,
  anon_sym___makeref = 166,
  anon_sym___reftype = 167,
  anon_sym___refvalue = 168,
  sym_null_literal = 169,
  anon_sym_SQUOTE = 170,
  aux_sym_character_literal_token1 = 171,
  sym_integer_literal = 172,
  sym_real_literal = 173,
  aux_sym_string_literal_content_token1 = 174,
  aux_sym_string_literal_content_token2 = 175,
  sym_escape_sequence = 176,
  sym_string_literal_encoding = 177,
  sym_verbatim_string_literal = 178,
  sym_raw_string_literal = 179,
  aux_sym_preproc_if_token1 = 180,
  aux_sym_preproc_if_token2 = 181,
  aux_sym_preproc_if_token3 = 182,
  aux_sym_preproc_else_token1 = 183,
  aux_sym_preproc_elif_token1 = 184,
  sym_preproc_arg = 185,
  aux_sym_preproc_region_token1 = 186,
  aux_sym_preproc_endregion_token1 = 187,
  aux_sym_preproc_line_token1 = 188,
  anon_sym_hidden = 189,
  aux_sym_preproc_pragma_token1 = 190,
  anon_sym_warning = 191,
  anon_sym_disable = 192,
  anon_sym_restore = 193,
  anon_sym_checksum = 194,
  aux_sym_preproc_nullable_token1 = 195,
  anon_sym_enable = 196,
  anon_sym_annotations = 197,
  anon_sym_warnings = 198,
  aux_sym_preproc_error_token1 = 199,
  aux_sym_preproc_define_token1 = 200,
  aux_sym_preproc_undef_token1 = 201,
  sym_shebang_directive = 202,
  sym_comment = 203,
  sym__optional_semi = 204,
  sym_interpolation_regular_start = 205,
  sym_interpolation_verbatim_start = 206,
  sym_interpolation_raw_start = 207,
  sym_interpolation_start_quote = 208,
  sym_interpolation_end_quote = 209,
  sym_interpolation_open_brace = 210,
  sym_interpolation_close_brace = 211,
  sym_interpolation_string_content = 212,
  sym_compilation_unit = 213,
  sym__top_level_item = 214,
  sym_global_statement = 215,
  sym_extern_alias_directive = 216,
  sym_using_directive = 217,
  sym_global_attribute = 218,
  sym_attribute = 219,
  sym_attribute_argument_list = 220,
  sym_attribute_argument = 221,
  sym_attribute_list = 222,
  sym_attribute_target_specifier = 223,
  sym_namespace_declaration = 224,
  sym_file_scoped_namespace_declaration = 225,
  sym_type_declaration = 226,
  sym_class_declaration = 227,
  sym_struct_declaration = 228,
  sym_enum_declaration = 229,
  sym_enum_member_declaration_list = 230,
  sym_enum_member_declaration = 231,
  sym_interface_declaration = 232,
  sym_delegate_declaration = 233,
  sym_record_declaration = 234,
  sym_record_base = 235,
  sym_primary_constructor_base_type = 236,
  sym_modifier = 237,
  sym_type_parameter_list = 238,
  sym_type_parameter = 239,
  sym_base_list = 240,
  sym_type_parameter_constraints_clause = 241,
  sym_type_parameter_constraint = 242,
  sym_constructor_constraint = 243,
  sym_operator_declaration = 244,
  sym_conversion_operator_declaration = 245,
  sym_declaration_list = 246,
  sym_declaration = 247,
  sym_field_declaration = 248,
  sym_constructor_declaration = 249,
  sym_destructor_declaration = 250,
  sym_method_declaration = 251,
  sym_event_declaration = 252,
  sym_event_field_declaration = 253,
  sym_accessor_list = 254,
  sym_accessor_declaration = 255,
  sym_indexer_declaration = 256,
  sym_bracketed_parameter_list = 257,
  sym_property_declaration = 258,
  sym_explicit_interface_specifier = 259,
  sym_parameter_list = 260,
  sym_parameter = 261,
  sym__parameter_array = 262,
  sym_constructor_initializer = 263,
  sym_argument_list = 264,
  sym_tuple_pattern = 265,
  sym_argument = 266,
  sym_block = 267,
  sym_arrow_expression_clause = 268,
  sym__function_body = 269,
  sym_variable_declaration = 270,
  sym_using_variable_declaration = 271,
  sym_variable_declarator = 272,
  sym_using_variable_declarator = 273,
  sym_bracketed_argument_list = 274,
  sym__name = 275,
  sym_alias_qualified_name = 276,
  sym__simple_name = 277,
  sym_qualified_name = 278,
  sym_generic_name = 279,
  sym_type_argument_list = 280,
  sym_type = 281,
  sym_implicit_type = 282,
  sym_array_type = 283,
  sym__array_base_type = 284,
  sym_array_rank_specifier = 285,
  sym_nullable_type = 286,
  sym_pointer_type = 287,
  sym__pointer_base_type = 288,
  sym_function_pointer_type = 289,
  sym_calling_convention = 290,
  sym_function_pointer_parameter = 291,
  sym_ref_type = 292,
  sym__ref_base_type = 293,
  sym_scoped_type = 294,
  sym__scoped_base_type = 295,
  sym_tuple_type = 296,
  sym_tuple_element = 297,
  sym_statement = 298,
  sym_break_statement = 299,
  sym_checked_statement = 300,
  sym_continue_statement = 301,
  sym_do_statement = 302,
  sym_empty_statement = 303,
  sym_expression_statement = 304,
  sym_fixed_statement = 305,
  sym_for_statement = 306,
  sym_return_statement = 307,
  sym_lock_statement = 308,
  sym_yield_statement = 309,
  sym_switch_statement = 310,
  sym_switch_body = 311,
  sym_switch_section = 312,
  sym_throw_statement = 313,
  sym_try_statement = 314,
  sym_catch_clause = 315,
  sym_catch_declaration = 316,
  sym_catch_filter_clause = 317,
  sym_finally_clause = 318,
  sym_unsafe_statement = 319,
  sym_using_statement = 320,
  sym_foreach_statement = 321,
  sym_goto_statement = 322,
  sym_labeled_statement = 323,
  sym_if_statement = 324,
  sym_while_statement = 325,
  sym_local_declaration_statement = 326,
  sym_local_function_statement = 327,
  sym_pattern = 328,
  sym_constant_pattern = 329,
  sym_parenthesized_pattern = 330,
  sym_var_pattern = 331,
  sym_type_pattern = 332,
  sym_list_pattern = 333,
  sym_recursive_pattern = 334,
  sym_positional_pattern_clause = 335,
  sym_property_pattern_clause = 336,
  sym_subpattern = 337,
  sym_relational_pattern = 338,
  sym_negated_pattern = 339,
  sym_and_pattern = 340,
  sym_or_pattern = 341,
  sym_declaration_pattern = 342,
  sym__variable_designation = 343,
  sym_parenthesized_variable_designation = 344,
  sym_expression = 345,
  sym_non_lvalue_expression = 346,
  sym_lvalue_expression = 347,
  sym__expression_statement_expression = 348,
  sym_assignment_expression = 349,
  sym_binary_expression = 350,
  sym_postfix_unary_expression = 351,
  sym_prefix_unary_expression = 352,
  sym__pointer_indirection_expression = 353,
  sym_query_expression = 354,
  sym_from_clause = 355,
  sym__query_body = 356,
  sym__query_clause = 357,
  sym_join_clause = 358,
  sym__join_header = 359,
  sym__join_body = 360,
  sym_join_into_clause = 361,
  sym_let_clause = 362,
  sym_order_by_clause = 363,
  sym__ordering = 364,
  sym_where_clause = 365,
  sym__select_or_group_clause = 366,
  sym_group_clause = 367,
  sym_select_clause = 368,
  sym_conditional_expression = 369,
  sym_conditional_access_expression = 370,
  sym_as_expression = 371,
  sym_is_expression = 372,
  sym_is_pattern_expression = 373,
  sym_cast_expression = 374,
  sym_checked_expression = 375,
  sym_invocation_expression = 376,
  sym_switch_expression = 377,
  sym_switch_expression_arm = 378,
  sym_when_clause = 379,
  sym_await_expression = 380,
  sym_throw_expression = 381,
  sym_element_access_expression = 382,
  sym_interpolated_string_expression = 383,
  sym__interpolated_string_content = 384,
  sym__interpolated_verbatim_string_content = 385,
  sym__interpolated_raw_string_content = 386,
  sym_interpolation = 387,
  sym_interpolation_alignment_clause = 388,
  sym_interpolation_format_clause = 389,
  sym_member_access_expression = 390,
  sym_member_binding_expression = 391,
  sym_object_creation_expression = 392,
  sym_parenthesized_expression = 393,
  sym__parenthesized_lvalue_expression = 394,
  sym_lambda_expression = 395,
  sym__lambda_parameters = 396,
  sym_array_creation_expression = 397,
  sym_anonymous_method_expression = 398,
  sym_anonymous_object_creation_expression = 399,
  sym__anonymous_object_member_declarator = 400,
  sym_implicit_array_creation_expression = 401,
  sym_implicit_object_creation_expression = 402,
  sym_implicit_stackalloc_expression = 403,
  sym_initializer_expression = 404,
  sym_declaration_expression = 405,
  sym_default_expression = 406,
  sym_with_expression = 407,
  sym_with_initializer = 408,
  sym_sizeof_expression = 409,
  sym_typeof_expression = 410,
  sym_makeref_expression = 411,
  sym_ref_expression = 412,
  sym_reftype_expression = 413,
  sym_refvalue_expression = 414,
  sym_stackalloc_expression = 415,
  sym_range_expression = 416,
  sym_tuple_expression = 417,
  sym_literal = 418,
  sym_character_literal = 419,
  sym_string_literal = 420,
  sym_string_literal_content = 421,
  sym_boolean_literal = 422,
  sym_identifier = 423,
  sym__reserved_identifier = 424,
  sym_preproc_if = 425,
  sym_preproc_else = 426,
  sym_preproc_elif = 427,
  sym_preproc_if_in_top_level = 428,
  sym_preproc_else_in_top_level = 429,
  sym_preproc_elif_in_top_level = 430,
  sym_preproc_if_in_expression = 431,
  sym_preproc_else_in_expression = 432,
  sym_preproc_elif_in_expression = 433,
  sym_preproc_if_in_enum_member_declaration = 434,
  sym_preproc_else_in_enum_member_declaration = 435,
  sym_preproc_elif_in_enum_member_declaration = 436,
  sym__preproc_expression = 437,
  sym_preproc_parenthesized_expression = 438,
  sym_preproc_unary_expression = 439,
  sym_preproc_binary_expression = 440,
  sym_preproc_region = 441,
  sym_preproc_endregion = 442,
  sym_preproc_line = 443,
  sym_preproc_pragma = 444,
  sym_preproc_nullable = 445,
  sym_preproc_error = 446,
  sym_preproc_define = 447,
  sym_preproc_undef = 448,
  aux_sym_compilation_unit_repeat1 = 449,
  aux_sym_global_attribute_repeat1 = 450,
  aux_sym_attribute_argument_list_repeat1 = 451,
  aux_sym_class_declaration_repeat1 = 452,
  aux_sym_class_declaration_repeat2 = 453,
  aux_sym_class_declaration_repeat3 = 454,
  aux_sym_enum_member_declaration_list_repeat1 = 455,
  aux_sym_record_base_repeat1 = 456,
  aux_sym_type_parameter_list_repeat1 = 457,
  aux_sym_base_list_repeat1 = 458,
  aux_sym_type_parameter_constraints_clause_repeat1 = 459,
  aux_sym_declaration_list_repeat1 = 460,
  aux_sym_accessor_list_repeat1 = 461,
  aux_sym_bracketed_parameter_list_repeat1 = 462,
  aux_sym__parameter_type_with_modifiers_repeat1 = 463,
  aux_sym_argument_list_repeat1 = 464,
  aux_sym_tuple_pattern_repeat1 = 465,
  aux_sym_block_repeat1 = 466,
  aux_sym_variable_declaration_repeat1 = 467,
  aux_sym_using_variable_declaration_repeat1 = 468,
  aux_sym_type_argument_list_repeat1 = 469,
  aux_sym_array_rank_specifier_repeat1 = 470,
  aux_sym_function_pointer_type_repeat1 = 471,
  aux_sym_calling_convention_repeat1 = 472,
  aux_sym_tuple_type_repeat1 = 473,
  aux_sym_for_statement_repeat1 = 474,
  aux_sym_switch_body_repeat1 = 475,
  aux_sym_try_statement_repeat1 = 476,
  aux_sym_list_pattern_repeat1 = 477,
  aux_sym_positional_pattern_clause_repeat1 = 478,
  aux_sym_parenthesized_variable_designation_repeat1 = 479,
  aux_sym__query_body_repeat1 = 480,
  aux_sym__query_body_repeat2 = 481,
  aux_sym_order_by_clause_repeat1 = 482,
  aux_sym_switch_expression_repeat1 = 483,
  aux_sym_interpolated_string_expression_repeat1 = 484,
  aux_sym_interpolated_string_expression_repeat2 = 485,
  aux_sym_interpolated_string_expression_repeat3 = 486,
  aux_sym_lambda_expression_repeat1 = 487,
  aux_sym_anonymous_object_creation_expression_repeat1 = 488,
  aux_sym_with_expression_repeat1 = 489,
  aux_sym_string_literal_repeat1 = 490,
  aux_sym_preproc_if_in_top_level_repeat1 = 491,
  aux_sym_preproc_pragma_repeat1 = 492,
  alias_sym_element_binding_expression = 493,
  alias_sym_implicit_parameter = 494,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym__identifier_token] = "_identifier_token",
  [anon_sym_extern] = "extern",
  [anon_sym_alias] = "alias",
  [anon_sym_SEMI] = ";",
  [anon_sym_global] = "global",
  [anon_sym_using] = "using",
  [anon_sym_unsafe] = "unsafe",
  [anon_sym_EQ] = "=",
  [anon_sym_static] = "static",
  [anon_sym_LBRACK] = "[",
  [anon_sym_assembly] = "assembly",
  [anon_sym_module] = "module",
  [anon_sym_COLON] = ":",
  [anon_sym_COMMA] = ",",
  [anon_sym_RBRACK] = "]",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_field] = "field",
  [anon_sym_event] = "event",
  [anon_sym_method] = "method",
  [anon_sym_param] = "param",
  [anon_sym_property] = "property",
  [anon_sym_return] = "return",
  [anon_sym_type] = "type",
  [anon_sym_namespace] = "namespace",
  [anon_sym_class] = "class",
  [anon_sym_ref] = "ref",
  [anon_sym_struct] = "struct",
  [anon_sym_enum] = "enum",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_interface] = "interface",
  [anon_sym_delegate] = "delegate",
  [anon_sym_record] = "record",
  [anon_sym_abstract] = "abstract",
  [anon_sym_async] = "async",
  [anon_sym_const] = "const",
  [anon_sym_file] = "file",
  [anon_sym_fixed] = "fixed",
  [anon_sym_internal] = "internal",
  [anon_sym_new] = "new",
  [anon_sym_override] = "override",
  [anon_sym_partial] = "partial",
  [anon_sym_private] = "private",
  [anon_sym_protected] = "protected",
  [anon_sym_public] = "public",
  [anon_sym_readonly] = "readonly",
  [anon_sym_required] = "required",
  [anon_sym_sealed] = "sealed",
  [anon_sym_virtual] = "virtual",
  [anon_sym_volatile] = "volatile",
  [anon_sym_LT] = "<",
  [anon_sym_GT] = ">",
  [anon_sym_in] = "in",
  [anon_sym_out] = "out",
  [anon_sym_where] = "where",
  [anon_sym_QMARK] = "\?",
  [anon_sym_notnull] = "notnull",
  [anon_sym_unmanaged] = "unmanaged",
  [anon_sym_operator] = "operator",
  [anon_sym_checked] = "checked",
  [anon_sym_BANG] = "!",
  [anon_sym_TILDE] = "~",
  [anon_sym_PLUS_PLUS] = "++",
  [anon_sym_DASH_DASH] = "--",
  [anon_sym_true] = "true",
  [anon_sym_false] = "false",
  [anon_sym_PLUS] = "+",
  [anon_sym_DASH] = "-",
  [anon_sym_STAR] = "*",
  [anon_sym_SLASH] = "/",
  [anon_sym_PERCENT] = "%",
  [anon_sym_CARET] = "^",
  [anon_sym_PIPE] = "|",
  [anon_sym_AMP] = "&",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_GT_GT_GT] = ">>>",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_implicit] = "implicit",
  [anon_sym_explicit] = "explicit",
  [anon_sym_get] = "get",
  [anon_sym_set] = "set",
  [anon_sym_add] = "add",
  [anon_sym_remove] = "remove",
  [anon_sym_init] = "init",
  [anon_sym_this] = "this",
  [anon_sym_DOT] = ".",
  [anon_sym_scoped] = "scoped",
  [anon_sym_params] = "params",
  [anon_sym_base] = "base",
  [anon_sym_EQ_GT] = "=>",
  [anon_sym_COLON_COLON] = "::",
  [anon_sym_var] = "var",
  [anon_sym_managed] = "managed",
  [anon_sym_Cdecl] = "Cdecl",
  [anon_sym_Stdcall] = "Stdcall",
  [anon_sym_Thiscall] = "Thiscall",
  [anon_sym_Fastcall] = "Fastcall",
  [sym_predefined_type] = "predefined_type",
  [anon_sym_break] = "break",
  [anon_sym_unchecked] = "unchecked",
  [anon_sym_continue] = "continue",
  [anon_sym_do] = "do",
  [anon_sym_while] = "while",
  [anon_sym_for] = "for",
  [anon_sym_lock] = "lock",
  [anon_sym_yield] = "yield",
  [anon_sym_switch] = "switch",
  [anon_sym_case] = "case",
  [anon_sym_default] = "default",
  [anon_sym_throw] = "throw",
  [anon_sym_try] = "try",
  [anon_sym_catch] = "catch",
  [anon_sym_when] = "when",
  [anon_sym_finally] = "finally",
  [anon_sym_await] = "await",
  [anon_sym_foreach] = "foreach",
  [anon_sym_goto] = "goto",
  [anon_sym_if] = "if",
  [anon_sym_else] = "else",
  [sym_discard] = "discard",
  [anon_sym_DOT_DOT] = "..",
  [anon_sym_not] = "not",
  [anon_sym_and] = "and",
  [anon_sym_or] = "or",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_AMP_EQ] = "&=",
  [anon_sym_CARET_EQ] = "^=",
  [anon_sym_PIPE_EQ] = "|=",
  [anon_sym_LT_LT_EQ] = "<<=",
  [anon_sym_GT_GT_EQ] = ">>=",
  [anon_sym_GT_GT_GT_EQ] = ">>>=",
  [anon_sym_QMARK_QMARK_EQ] = "\?\?=",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_QMARK_QMARK] = "\?\?",
  [anon_sym_from] = "from",
  [anon_sym_into] = "into",
  [anon_sym_join] = "join",
  [anon_sym_on] = "on",
  [anon_sym_equals] = "equals",
  [anon_sym_let] = "let",
  [anon_sym_orderby] = "orderby",
  [anon_sym_ascending] = "ascending",
  [anon_sym_descending] = "descending",
  [anon_sym_group] = "group",
  [anon_sym_by] = "by",
  [anon_sym_select] = "select",
  [anon_sym_as] = "as",
  [anon_sym_is] = "is",
  [anon_sym_DQUOTE] = "\"",
  [aux_sym_interpolation_format_clause_token1] = "interpolation_format_clause_token1",
  [anon_sym_DASH_GT] = "->",
  [anon_sym_stackalloc] = "stackalloc",
  [anon_sym_with] = "with",
  [anon_sym_sizeof] = "sizeof",
  [anon_sym_typeof] = "typeof",
  [anon_sym___makeref] = "__makeref",
  [anon_sym___reftype] = "__reftype",
  [anon_sym___refvalue] = "__refvalue",
  [sym_null_literal] = "null_literal",
  [anon_sym_SQUOTE] = "'",
  [aux_sym_character_literal_token1] = "character_literal_token1",
  [sym_integer_literal] = "integer_literal",
  [sym_real_literal] = "real_literal",
  [aux_sym_string_literal_content_token1] = "string_literal_content_token1",
  [aux_sym_string_literal_content_token2] = "string_literal_content_token2",
  [sym_escape_sequence] = "escape_sequence",
  [sym_string_literal_encoding] = "string_literal_encoding",
  [sym_verbatim_string_literal] = "verbatim_string_literal",
  [sym_raw_string_literal] = "raw_string_literal",
  [aux_sym_preproc_if_token1] = "#if",
  [aux_sym_preproc_if_token2] = "preproc_if_token2",
  [aux_sym_preproc_if_token3] = "#endif",
  [aux_sym_preproc_else_token1] = "#else",
  [aux_sym_preproc_elif_token1] = "#elif",
  [sym_preproc_arg] = "preproc_arg",
  [aux_sym_preproc_region_token1] = "#region",
  [aux_sym_preproc_endregion_token1] = "#endregion",
  [aux_sym_preproc_line_token1] = "#line",
  [anon_sym_hidden] = "hidden",
  [aux_sym_preproc_pragma_token1] = "#pragma",
  [anon_sym_warning] = "warning",
  [anon_sym_disable] = "disable",
  [anon_sym_restore] = "restore",
  [anon_sym_checksum] = "checksum",
  [aux_sym_preproc_nullable_token1] = "#nullable",
  [anon_sym_enable] = "enable",
  [anon_sym_annotations] = "annotations",
  [anon_sym_warnings] = "warnings",
  [aux_sym_preproc_error_token1] = "#error",
  [aux_sym_preproc_define_token1] = "#define",
  [aux_sym_preproc_undef_token1] = "#undef",
  [sym_shebang_directive] = "shebang_directive",
  [sym_comment] = "comment",
  [sym__optional_semi] = "_optional_semi",
  [sym_interpolation_regular_start] = "interpolation_start",
  [sym_interpolation_verbatim_start] = "interpolation_start",
  [sym_interpolation_raw_start] = "interpolation_start",
  [sym_interpolation_start_quote] = "interpolation_quote",
  [sym_interpolation_end_quote] = "interpolation_quote",
  [sym_interpolation_open_brace] = "interpolation_brace",
  [sym_interpolation_close_brace] = "interpolation_brace",
  [sym_interpolation_string_content] = "string_content",
  [sym_compilation_unit] = "compilation_unit",
  [sym__top_level_item] = "_top_level_item",
  [sym_global_statement] = "global_statement",
  [sym_extern_alias_directive] = "extern_alias_directive",
  [sym_using_directive] = "using_directive",
  [sym_global_attribute] = "global_attribute",
  [sym_attribute] = "attribute",
  [sym_attribute_argument_list] = "attribute_argument_list",
  [sym_attribute_argument] = "attribute_argument",
  [sym_attribute_list] = "attribute_list",
  [sym_attribute_target_specifier] = "attribute_target_specifier",
  [sym_namespace_declaration] = "namespace_declaration",
  [sym_file_scoped_namespace_declaration] = "file_scoped_namespace_declaration",
  [sym_type_declaration] = "type_declaration",
  [sym_class_declaration] = "class_declaration",
  [sym_struct_declaration] = "struct_declaration",
  [sym_enum_declaration] = "enum_declaration",
  [sym_enum_member_declaration_list] = "enum_member_declaration_list",
  [sym_enum_member_declaration] = "enum_member_declaration",
  [sym_interface_declaration] = "interface_declaration",
  [sym_delegate_declaration] = "delegate_declaration",
  [sym_record_declaration] = "record_declaration",
  [sym_record_base] = "base_list",
  [sym_primary_constructor_base_type] = "primary_constructor_base_type",
  [sym_modifier] = "modifier",
  [sym_type_parameter_list] = "type_parameter_list",
  [sym_type_parameter] = "type_parameter",
  [sym_base_list] = "base_list",
  [sym_type_parameter_constraints_clause] = "type_parameter_constraints_clause",
  [sym_type_parameter_constraint] = "type_parameter_constraint",
  [sym_constructor_constraint] = "constructor_constraint",
  [sym_operator_declaration] = "operator_declaration",
  [sym_conversion_operator_declaration] = "conversion_operator_declaration",
  [sym_declaration_list] = "declaration_list",
  [sym_declaration] = "declaration",
  [sym_field_declaration] = "field_declaration",
  [sym_constructor_declaration] = "constructor_declaration",
  [sym_destructor_declaration] = "destructor_declaration",
  [sym_method_declaration] = "method_declaration",
  [sym_event_declaration] = "event_declaration",
  [sym_event_field_declaration] = "event_field_declaration",
  [sym_accessor_list] = "accessor_list",
  [sym_accessor_declaration] = "accessor_declaration",
  [sym_indexer_declaration] = "indexer_declaration",
  [sym_bracketed_parameter_list] = "bracketed_parameter_list",
  [sym_property_declaration] = "property_declaration",
  [sym_explicit_interface_specifier] = "explicit_interface_specifier",
  [sym_parameter_list] = "parameter_list",
  [sym_parameter] = "parameter",
  [sym__parameter_array] = "_parameter_array",
  [sym_constructor_initializer] = "constructor_initializer",
  [sym_argument_list] = "argument_list",
  [sym_tuple_pattern] = "tuple_pattern",
  [sym_argument] = "argument",
  [sym_block] = "block",
  [sym_arrow_expression_clause] = "arrow_expression_clause",
  [sym__function_body] = "_function_body",
  [sym_variable_declaration] = "variable_declaration",
  [sym_using_variable_declaration] = "variable_declaration",
  [sym_variable_declarator] = "variable_declarator",
  [sym_using_variable_declarator] = "variable_declarator",
  [sym_bracketed_argument_list] = "bracketed_argument_list",
  [sym__name] = "_name",
  [sym_alias_qualified_name] = "alias_qualified_name",
  [sym__simple_name] = "_simple_name",
  [sym_qualified_name] = "qualified_name",
  [sym_generic_name] = "generic_name",
  [sym_type_argument_list] = "type_argument_list",
  [sym_type] = "type",
  [sym_implicit_type] = "implicit_type",
  [sym_array_type] = "array_type",
  [sym__array_base_type] = "_array_base_type",
  [sym_array_rank_specifier] = "array_rank_specifier",
  [sym_nullable_type] = "nullable_type",
  [sym_pointer_type] = "pointer_type",
  [sym__pointer_base_type] = "_pointer_base_type",
  [sym_function_pointer_type] = "function_pointer_type",
  [sym_calling_convention] = "calling_convention",
  [sym_function_pointer_parameter] = "function_pointer_parameter",
  [sym_ref_type] = "ref_type",
  [sym__ref_base_type] = "_ref_base_type",
  [sym_scoped_type] = "scoped_type",
  [sym__scoped_base_type] = "_scoped_base_type",
  [sym_tuple_type] = "tuple_type",
  [sym_tuple_element] = "tuple_element",
  [sym_statement] = "statement",
  [sym_break_statement] = "break_statement",
  [sym_checked_statement] = "checked_statement",
  [sym_continue_statement] = "continue_statement",
  [sym_do_statement] = "do_statement",
  [sym_empty_statement] = "empty_statement",
  [sym_expression_statement] = "expression_statement",
  [sym_fixed_statement] = "fixed_statement",
  [sym_for_statement] = "for_statement",
  [sym_return_statement] = "return_statement",
  [sym_lock_statement] = "lock_statement",
  [sym_yield_statement] = "yield_statement",
  [sym_switch_statement] = "switch_statement",
  [sym_switch_body] = "switch_body",
  [sym_switch_section] = "switch_section",
  [sym_throw_statement] = "throw_statement",
  [sym_try_statement] = "try_statement",
  [sym_catch_clause] = "catch_clause",
  [sym_catch_declaration] = "catch_declaration",
  [sym_catch_filter_clause] = "catch_filter_clause",
  [sym_finally_clause] = "finally_clause",
  [sym_unsafe_statement] = "unsafe_statement",
  [sym_using_statement] = "using_statement",
  [sym_foreach_statement] = "foreach_statement",
  [sym_goto_statement] = "goto_statement",
  [sym_labeled_statement] = "labeled_statement",
  [sym_if_statement] = "if_statement",
  [sym_while_statement] = "while_statement",
  [sym_local_declaration_statement] = "local_declaration_statement",
  [sym_local_function_statement] = "local_function_statement",
  [sym_pattern] = "pattern",
  [sym_constant_pattern] = "constant_pattern",
  [sym_parenthesized_pattern] = "parenthesized_pattern",
  [sym_var_pattern] = "var_pattern",
  [sym_type_pattern] = "type_pattern",
  [sym_list_pattern] = "list_pattern",
  [sym_recursive_pattern] = "recursive_pattern",
  [sym_positional_pattern_clause] = "positional_pattern_clause",
  [sym_property_pattern_clause] = "property_pattern_clause",
  [sym_subpattern] = "subpattern",
  [sym_relational_pattern] = "relational_pattern",
  [sym_negated_pattern] = "negated_pattern",
  [sym_and_pattern] = "and_pattern",
  [sym_or_pattern] = "or_pattern",
  [sym_declaration_pattern] = "declaration_pattern",
  [sym__variable_designation] = "_variable_designation",
  [sym_parenthesized_variable_designation] = "parenthesized_variable_designation",
  [sym_expression] = "expression",
  [sym_non_lvalue_expression] = "non_lvalue_expression",
  [sym_lvalue_expression] = "lvalue_expression",
  [sym__expression_statement_expression] = "_expression_statement_expression",
  [sym_assignment_expression] = "assignment_expression",
  [sym_binary_expression] = "binary_expression",
  [sym_postfix_unary_expression] = "postfix_unary_expression",
  [sym_prefix_unary_expression] = "prefix_unary_expression",
  [sym__pointer_indirection_expression] = "prefix_unary_expression",
  [sym_query_expression] = "query_expression",
  [sym_from_clause] = "from_clause",
  [sym__query_body] = "_query_body",
  [sym__query_clause] = "_query_clause",
  [sym_join_clause] = "join_clause",
  [sym__join_header] = "_join_header",
  [sym__join_body] = "_join_body",
  [sym_join_into_clause] = "join_into_clause",
  [sym_let_clause] = "let_clause",
  [sym_order_by_clause] = "order_by_clause",
  [sym__ordering] = "_ordering",
  [sym_where_clause] = "where_clause",
  [sym__select_or_group_clause] = "_select_or_group_clause",
  [sym_group_clause] = "group_clause",
  [sym_select_clause] = "select_clause",
  [sym_conditional_expression] = "conditional_expression",
  [sym_conditional_access_expression] = "conditional_access_expression",
  [sym_as_expression] = "as_expression",
  [sym_is_expression] = "is_expression",
  [sym_is_pattern_expression] = "is_pattern_expression",
  [sym_cast_expression] = "cast_expression",
  [sym_checked_expression] = "checked_expression",
  [sym_invocation_expression] = "invocation_expression",
  [sym_switch_expression] = "switch_expression",
  [sym_switch_expression_arm] = "switch_expression_arm",
  [sym_when_clause] = "when_clause",
  [sym_await_expression] = "await_expression",
  [sym_throw_expression] = "throw_expression",
  [sym_element_access_expression] = "element_access_expression",
  [sym_interpolated_string_expression] = "interpolated_string_expression",
  [sym__interpolated_string_content] = "_interpolated_string_content",
  [sym__interpolated_verbatim_string_content] = "_interpolated_verbatim_string_content",
  [sym__interpolated_raw_string_content] = "_interpolated_raw_string_content",
  [sym_interpolation] = "interpolation",
  [sym_interpolation_alignment_clause] = "interpolation_alignment_clause",
  [sym_interpolation_format_clause] = "interpolation_format_clause",
  [sym_member_access_expression] = "member_access_expression",
  [sym_member_binding_expression] = "member_binding_expression",
  [sym_object_creation_expression] = "object_creation_expression",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym__parenthesized_lvalue_expression] = "parenthesized_expression",
  [sym_lambda_expression] = "lambda_expression",
  [sym__lambda_parameters] = "_lambda_parameters",
  [sym_array_creation_expression] = "array_creation_expression",
  [sym_anonymous_method_expression] = "anonymous_method_expression",
  [sym_anonymous_object_creation_expression] = "anonymous_object_creation_expression",
  [sym__anonymous_object_member_declarator] = "_anonymous_object_member_declarator",
  [sym_implicit_array_creation_expression] = "implicit_array_creation_expression",
  [sym_implicit_object_creation_expression] = "implicit_object_creation_expression",
  [sym_implicit_stackalloc_expression] = "implicit_stackalloc_expression",
  [sym_initializer_expression] = "initializer_expression",
  [sym_declaration_expression] = "declaration_expression",
  [sym_default_expression] = "default_expression",
  [sym_with_expression] = "with_expression",
  [sym_with_initializer] = "with_initializer",
  [sym_sizeof_expression] = "sizeof_expression",
  [sym_typeof_expression] = "typeof_expression",
  [sym_makeref_expression] = "makeref_expression",
  [sym_ref_expression] = "ref_expression",
  [sym_reftype_expression] = "reftype_expression",
  [sym_refvalue_expression] = "refvalue_expression",
  [sym_stackalloc_expression] = "stackalloc_expression",
  [sym_range_expression] = "range_expression",
  [sym_tuple_expression] = "tuple_expression",
  [sym_literal] = "literal",
  [sym_character_literal] = "character_literal",
  [sym_string_literal] = "string_literal",
  [sym_string_literal_content] = "string_literal_content",
  [sym_boolean_literal] = "boolean_literal",
  [sym_identifier] = "identifier",
  [sym__reserved_identifier] = "_reserved_identifier",
  [sym_preproc_if] = "preproc_if",
  [sym_preproc_else] = "preproc_else",
  [sym_preproc_elif] = "preproc_elif",
  [sym_preproc_if_in_top_level] = "preproc_if",
  [sym_preproc_else_in_top_level] = "preproc_else",
  [sym_preproc_elif_in_top_level] = "preproc_elif",
  [sym_preproc_if_in_expression] = "preproc_if",
  [sym_preproc_else_in_expression] = "preproc_else",
  [sym_preproc_elif_in_expression] = "preproc_elif",
  [sym_preproc_if_in_enum_member_declaration] = "preproc_if",
  [sym_preproc_else_in_enum_member_declaration] = "preproc_else",
  [sym_preproc_elif_in_enum_member_declaration] = "preproc_elif",
  [sym__preproc_expression] = "_preproc_expression",
  [sym_preproc_parenthesized_expression] = "parenthesized_expression",
  [sym_preproc_unary_expression] = "unary_expression",
  [sym_preproc_binary_expression] = "binary_expression",
  [sym_preproc_region] = "preproc_region",
  [sym_preproc_endregion] = "preproc_endregion",
  [sym_preproc_line] = "preproc_line",
  [sym_preproc_pragma] = "preproc_pragma",
  [sym_preproc_nullable] = "preproc_nullable",
  [sym_preproc_error] = "preproc_error",
  [sym_preproc_define] = "preproc_define",
  [sym_preproc_undef] = "preproc_undef",
  [aux_sym_compilation_unit_repeat1] = "compilation_unit_repeat1",
  [aux_sym_global_attribute_repeat1] = "global_attribute_repeat1",
  [aux_sym_attribute_argument_list_repeat1] = "attribute_argument_list_repeat1",
  [aux_sym_class_declaration_repeat1] = "class_declaration_repeat1",
  [aux_sym_class_declaration_repeat2] = "class_declaration_repeat2",
  [aux_sym_class_declaration_repeat3] = "class_declaration_repeat3",
  [aux_sym_enum_member_declaration_list_repeat1] = "enum_member_declaration_list_repeat1",
  [aux_sym_record_base_repeat1] = "record_base_repeat1",
  [aux_sym_type_parameter_list_repeat1] = "type_parameter_list_repeat1",
  [aux_sym_base_list_repeat1] = "base_list_repeat1",
  [aux_sym_type_parameter_constraints_clause_repeat1] = "type_parameter_constraints_clause_repeat1",
  [aux_sym_declaration_list_repeat1] = "declaration_list_repeat1",
  [aux_sym_accessor_list_repeat1] = "accessor_list_repeat1",
  [aux_sym_bracketed_parameter_list_repeat1] = "bracketed_parameter_list_repeat1",
  [aux_sym__parameter_type_with_modifiers_repeat1] = "_parameter_type_with_modifiers_repeat1",
  [aux_sym_argument_list_repeat1] = "argument_list_repeat1",
  [aux_sym_tuple_pattern_repeat1] = "tuple_pattern_repeat1",
  [aux_sym_block_repeat1] = "block_repeat1",
  [aux_sym_variable_declaration_repeat1] = "variable_declaration_repeat1",
  [aux_sym_using_variable_declaration_repeat1] = "using_variable_declaration_repeat1",
  [aux_sym_type_argument_list_repeat1] = "type_argument_list_repeat1",
  [aux_sym_array_rank_specifier_repeat1] = "array_rank_specifier_repeat1",
  [aux_sym_function_pointer_type_repeat1] = "function_pointer_type_repeat1",
  [aux_sym_calling_convention_repeat1] = "calling_convention_repeat1",
  [aux_sym_tuple_type_repeat1] = "tuple_type_repeat1",
  [aux_sym_for_statement_repeat1] = "for_statement_repeat1",
  [aux_sym_switch_body_repeat1] = "switch_body_repeat1",
  [aux_sym_try_statement_repeat1] = "try_statement_repeat1",
  [aux_sym_list_pattern_repeat1] = "list_pattern_repeat1",
  [aux_sym_positional_pattern_clause_repeat1] = "positional_pattern_clause_repeat1",
  [aux_sym_parenthesized_variable_designation_repeat1] = "parenthesized_variable_designation_repeat1",
  [aux_sym__query_body_repeat1] = "_query_body_repeat1",
  [aux_sym__query_body_repeat2] = "_query_body_repeat2",
  [aux_sym_order_by_clause_repeat1] = "order_by_clause_repeat1",
  [aux_sym_switch_expression_repeat1] = "switch_expression_repeat1",
  [aux_sym_interpolated_string_expression_repeat1] = "interpolated_string_expression_repeat1",
  [aux_sym_interpolated_string_expression_repeat2] = "interpolated_string_expression_repeat2",
  [aux_sym_interpolated_string_expression_repeat3] = "interpolated_string_expression_repeat3",
  [aux_sym_lambda_expression_repeat1] = "lambda_expression_repeat1",
  [aux_sym_anonymous_object_creation_expression_repeat1] = "anonymous_object_creation_expression_repeat1",
  [aux_sym_with_expression_repeat1] = "with_expression_repeat1",
  [aux_sym_string_literal_repeat1] = "string_literal_repeat1",
  [aux_sym_preproc_if_in_top_level_repeat1] = "preproc_if_in_top_level_repeat1",
  [aux_sym_preproc_pragma_repeat1] = "preproc_pragma_repeat1",
  [alias_sym_element_binding_expression] = "element_binding_expression",
  [alias_sym_implicit_parameter] = "implicit_parameter",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym__identifier_token] = sym__identifier_token,
  [anon_sym_extern] = anon_sym_extern,
  [anon_sym_alias] = anon_sym_alias,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_global] = anon_sym_global,
  [anon_sym_using] = anon_sym_using,
  [anon_sym_unsafe] = anon_sym_unsafe,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_static] = anon_sym_static,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_assembly] = anon_sym_assembly,
  [anon_sym_module] = anon_sym_module,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_field] = anon_sym_field,
  [anon_sym_event] = anon_sym_event,
  [anon_sym_method] = anon_sym_method,
  [anon_sym_param] = anon_sym_param,
  [anon_sym_property] = anon_sym_property,
  [anon_sym_return] = anon_sym_return,
  [anon_sym_type] = anon_sym_type,
  [anon_sym_namespace] = anon_sym_namespace,
  [anon_sym_class] = anon_sym_class,
  [anon_sym_ref] = anon_sym_ref,
  [anon_sym_struct] = anon_sym_struct,
  [anon_sym_enum] = anon_sym_enum,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_interface] = anon_sym_interface,
  [anon_sym_delegate] = anon_sym_delegate,
  [anon_sym_record] = anon_sym_record,
  [anon_sym_abstract] = anon_sym_abstract,
  [anon_sym_async] = anon_sym_async,
  [anon_sym_const] = anon_sym_const,
  [anon_sym_file] = anon_sym_file,
  [anon_sym_fixed] = anon_sym_fixed,
  [anon_sym_internal] = anon_sym_internal,
  [anon_sym_new] = anon_sym_new,
  [anon_sym_override] = anon_sym_override,
  [anon_sym_partial] = anon_sym_partial,
  [anon_sym_private] = anon_sym_private,
  [anon_sym_protected] = anon_sym_protected,
  [anon_sym_public] = anon_sym_public,
  [anon_sym_readonly] = anon_sym_readonly,
  [anon_sym_required] = anon_sym_required,
  [anon_sym_sealed] = anon_sym_sealed,
  [anon_sym_virtual] = anon_sym_virtual,
  [anon_sym_volatile] = anon_sym_volatile,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_in] = anon_sym_in,
  [anon_sym_out] = anon_sym_out,
  [anon_sym_where] = anon_sym_where,
  [anon_sym_QMARK] = anon_sym_QMARK,
  [anon_sym_notnull] = anon_sym_notnull,
  [anon_sym_unmanaged] = anon_sym_unmanaged,
  [anon_sym_operator] = anon_sym_operator,
  [anon_sym_checked] = anon_sym_checked,
  [anon_sym_BANG] = anon_sym_BANG,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [anon_sym_PLUS_PLUS] = anon_sym_PLUS_PLUS,
  [anon_sym_DASH_DASH] = anon_sym_DASH_DASH,
  [anon_sym_true] = anon_sym_true,
  [anon_sym_false] = anon_sym_false,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_CARET] = anon_sym_CARET,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_AMP] = anon_sym_AMP,
  [anon_sym_LT_LT] = anon_sym_LT_LT,
  [anon_sym_GT_GT] = anon_sym_GT_GT,
  [anon_sym_GT_GT_GT] = anon_sym_GT_GT_GT,
  [anon_sym_EQ_EQ] = anon_sym_EQ_EQ,
  [anon_sym_BANG_EQ] = anon_sym_BANG_EQ,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_implicit] = anon_sym_implicit,
  [anon_sym_explicit] = anon_sym_explicit,
  [anon_sym_get] = anon_sym_get,
  [anon_sym_set] = anon_sym_set,
  [anon_sym_add] = anon_sym_add,
  [anon_sym_remove] = anon_sym_remove,
  [anon_sym_init] = anon_sym_init,
  [anon_sym_this] = anon_sym_this,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_scoped] = anon_sym_scoped,
  [anon_sym_params] = anon_sym_params,
  [anon_sym_base] = anon_sym_base,
  [anon_sym_EQ_GT] = anon_sym_EQ_GT,
  [anon_sym_COLON_COLON] = anon_sym_COLON_COLON,
  [anon_sym_var] = anon_sym_var,
  [anon_sym_managed] = anon_sym_managed,
  [anon_sym_Cdecl] = anon_sym_Cdecl,
  [anon_sym_Stdcall] = anon_sym_Stdcall,
  [anon_sym_Thiscall] = anon_sym_Thiscall,
  [anon_sym_Fastcall] = anon_sym_Fastcall,
  [sym_predefined_type] = sym_predefined_type,
  [anon_sym_break] = anon_sym_break,
  [anon_sym_unchecked] = anon_sym_unchecked,
  [anon_sym_continue] = anon_sym_continue,
  [anon_sym_do] = anon_sym_do,
  [anon_sym_while] = anon_sym_while,
  [anon_sym_for] = anon_sym_for,
  [anon_sym_lock] = anon_sym_lock,
  [anon_sym_yield] = anon_sym_yield,
  [anon_sym_switch] = anon_sym_switch,
  [anon_sym_case] = anon_sym_case,
  [anon_sym_default] = anon_sym_default,
  [anon_sym_throw] = anon_sym_throw,
  [anon_sym_try] = anon_sym_try,
  [anon_sym_catch] = anon_sym_catch,
  [anon_sym_when] = anon_sym_when,
  [anon_sym_finally] = anon_sym_finally,
  [anon_sym_await] = anon_sym_await,
  [anon_sym_foreach] = anon_sym_foreach,
  [anon_sym_goto] = anon_sym_goto,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_else] = anon_sym_else,
  [sym_discard] = sym_discard,
  [anon_sym_DOT_DOT] = anon_sym_DOT_DOT,
  [anon_sym_not] = anon_sym_not,
  [anon_sym_and] = anon_sym_and,
  [anon_sym_or] = anon_sym_or,
  [anon_sym_PLUS_EQ] = anon_sym_PLUS_EQ,
  [anon_sym_DASH_EQ] = anon_sym_DASH_EQ,
  [anon_sym_STAR_EQ] = anon_sym_STAR_EQ,
  [anon_sym_SLASH_EQ] = anon_sym_SLASH_EQ,
  [anon_sym_PERCENT_EQ] = anon_sym_PERCENT_EQ,
  [anon_sym_AMP_EQ] = anon_sym_AMP_EQ,
  [anon_sym_CARET_EQ] = anon_sym_CARET_EQ,
  [anon_sym_PIPE_EQ] = anon_sym_PIPE_EQ,
  [anon_sym_LT_LT_EQ] = anon_sym_LT_LT_EQ,
  [anon_sym_GT_GT_EQ] = anon_sym_GT_GT_EQ,
  [anon_sym_GT_GT_GT_EQ] = anon_sym_GT_GT_GT_EQ,
  [anon_sym_QMARK_QMARK_EQ] = anon_sym_QMARK_QMARK_EQ,
  [anon_sym_AMP_AMP] = anon_sym_AMP_AMP,
  [anon_sym_PIPE_PIPE] = anon_sym_PIPE_PIPE,
  [anon_sym_QMARK_QMARK] = anon_sym_QMARK_QMARK,
  [anon_sym_from] = anon_sym_from,
  [anon_sym_into] = anon_sym_into,
  [anon_sym_join] = anon_sym_join,
  [anon_sym_on] = anon_sym_on,
  [anon_sym_equals] = anon_sym_equals,
  [anon_sym_let] = anon_sym_let,
  [anon_sym_orderby] = anon_sym_orderby,
  [anon_sym_ascending] = anon_sym_ascending,
  [anon_sym_descending] = anon_sym_descending,
  [anon_sym_group] = anon_sym_group,
  [anon_sym_by] = anon_sym_by,
  [anon_sym_select] = anon_sym_select,
  [anon_sym_as] = anon_sym_as,
  [anon_sym_is] = anon_sym_is,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [aux_sym_interpolation_format_clause_token1] = aux_sym_interpolation_format_clause_token1,
  [anon_sym_DASH_GT] = anon_sym_DASH_GT,
  [anon_sym_stackalloc] = anon_sym_stackalloc,
  [anon_sym_with] = anon_sym_with,
  [anon_sym_sizeof] = anon_sym_sizeof,
  [anon_sym_typeof] = anon_sym_typeof,
  [anon_sym___makeref] = anon_sym___makeref,
  [anon_sym___reftype] = anon_sym___reftype,
  [anon_sym___refvalue] = anon_sym___refvalue,
  [sym_null_literal] = sym_null_literal,
  [anon_sym_SQUOTE] = anon_sym_SQUOTE,
  [aux_sym_character_literal_token1] = aux_sym_character_literal_token1,
  [sym_integer_literal] = sym_integer_literal,
  [sym_real_literal] = sym_real_literal,
  [aux_sym_string_literal_content_token1] = aux_sym_string_literal_content_token1,
  [aux_sym_string_literal_content_token2] = aux_sym_string_literal_content_token2,
  [sym_escape_sequence] = sym_escape_sequence,
  [sym_string_literal_encoding] = sym_string_literal_encoding,
  [sym_verbatim_string_literal] = sym_verbatim_string_literal,
  [sym_raw_string_literal] = sym_raw_string_literal,
  [aux_sym_preproc_if_token1] = aux_sym_preproc_if_token1,
  [aux_sym_preproc_if_token2] = aux_sym_preproc_if_token2,
  [aux_sym_preproc_if_token3] = aux_sym_preproc_if_token3,
  [aux_sym_preproc_else_token1] = aux_sym_preproc_else_token1,
  [aux_sym_preproc_elif_token1] = aux_sym_preproc_elif_token1,
  [sym_preproc_arg] = sym_preproc_arg,
  [aux_sym_preproc_region_token1] = aux_sym_preproc_region_token1,
  [aux_sym_preproc_endregion_token1] = aux_sym_preproc_endregion_token1,
  [aux_sym_preproc_line_token1] = aux_sym_preproc_line_token1,
  [anon_sym_hidden] = anon_sym_hidden,
  [aux_sym_preproc_pragma_token1] = aux_sym_preproc_pragma_token1,
  [anon_sym_warning] = anon_sym_warning,
  [anon_sym_disable] = anon_sym_disable,
  [anon_sym_restore] = anon_sym_restore,
  [anon_sym_checksum] = anon_sym_checksum,
  [aux_sym_preproc_nullable_token1] = aux_sym_preproc_nullable_token1,
  [anon_sym_enable] = anon_sym_enable,
  [anon_sym_annotations] = anon_sym_annotations,
  [anon_sym_warnings] = anon_sym_warnings,
  [aux_sym_preproc_error_token1] = aux_sym_preproc_error_token1,
  [aux_sym_preproc_define_token1] = aux_sym_preproc_define_token1,
  [aux_sym_preproc_undef_token1] = aux_sym_preproc_undef_token1,
  [sym_shebang_directive] = sym_shebang_directive,
  [sym_comment] = sym_comment,
  [sym__optional_semi] = sym__optional_semi,
  [sym_interpolation_regular_start] = sym_interpolation_regular_start,
  [sym_interpolation_verbatim_start] = sym_interpolation_regular_start,
  [sym_interpolation_raw_start] = sym_interpolation_regular_start,
  [sym_interpolation_start_quote] = sym_interpolation_start_quote,
  [sym_interpolation_end_quote] = sym_interpolation_start_quote,
  [sym_interpolation_open_brace] = sym_interpolation_open_brace,
  [sym_interpolation_close_brace] = sym_interpolation_open_brace,
  [sym_interpolation_string_content] = sym_interpolation_string_content,
  [sym_compilation_unit] = sym_compilation_unit,
  [sym__top_level_item] = sym__top_level_item,
  [sym_global_statement] = sym_global_statement,
  [sym_extern_alias_directive] = sym_extern_alias_directive,
  [sym_using_directive] = sym_using_directive,
  [sym_global_attribute] = sym_global_attribute,
  [sym_attribute] = sym_attribute,
  [sym_attribute_argument_list] = sym_attribute_argument_list,
  [sym_attribute_argument] = sym_attribute_argument,
  [sym_attribute_list] = sym_attribute_list,
  [sym_attribute_target_specifier] = sym_attribute_target_specifier,
  [sym_namespace_declaration] = sym_namespace_declaration,
  [sym_file_scoped_namespace_declaration] = sym_file_scoped_namespace_declaration,
  [sym_type_declaration] = sym_type_declaration,
  [sym_class_declaration] = sym_class_declaration,
  [sym_struct_declaration] = sym_struct_declaration,
  [sym_enum_declaration] = sym_enum_declaration,
  [sym_enum_member_declaration_list] = sym_enum_member_declaration_list,
  [sym_enum_member_declaration] = sym_enum_member_declaration,
  [sym_interface_declaration] = sym_interface_declaration,
  [sym_delegate_declaration] = sym_delegate_declaration,
  [sym_record_declaration] = sym_record_declaration,
  [sym_record_base] = sym_base_list,
  [sym_primary_constructor_base_type] = sym_primary_constructor_base_type,
  [sym_modifier] = sym_modifier,
  [sym_type_parameter_list] = sym_type_parameter_list,
  [sym_type_parameter] = sym_type_parameter,
  [sym_base_list] = sym_base_list,
  [sym_type_parameter_constraints_clause] = sym_type_parameter_constraints_clause,
  [sym_type_parameter_constraint] = sym_type_parameter_constraint,
  [sym_constructor_constraint] = sym_constructor_constraint,
  [sym_operator_declaration] = sym_operator_declaration,
  [sym_conversion_operator_declaration] = sym_conversion_operator_declaration,
  [sym_declaration_list] = sym_declaration_list,
  [sym_declaration] = sym_declaration,
  [sym_field_declaration] = sym_field_declaration,
  [sym_constructor_declaration] = sym_constructor_declaration,
  [sym_destructor_declaration] = sym_destructor_declaration,
  [sym_method_declaration] = sym_method_declaration,
  [sym_event_declaration] = sym_event_declaration,
  [sym_event_field_declaration] = sym_event_field_declaration,
  [sym_accessor_list] = sym_accessor_list,
  [sym_accessor_declaration] = sym_accessor_declaration,
  [sym_indexer_declaration] = sym_indexer_declaration,
  [sym_bracketed_parameter_list] = sym_bracketed_parameter_list,
  [sym_property_declaration] = sym_property_declaration,
  [sym_explicit_interface_specifier] = sym_explicit_interface_specifier,
  [sym_parameter_list] = sym_parameter_list,
  [sym_parameter] = sym_parameter,
  [sym__parameter_array] = sym__parameter_array,
  [sym_constructor_initializer] = sym_constructor_initializer,
  [sym_argument_list] = sym_argument_list,
  [sym_tuple_pattern] = sym_tuple_pattern,
  [sym_argument] = sym_argument,
  [sym_block] = sym_block,
  [sym_arrow_expression_clause] = sym_arrow_expression_clause,
  [sym__function_body] = sym__function_body,
  [sym_variable_declaration] = sym_variable_declaration,
  [sym_using_variable_declaration] = sym_variable_declaration,
  [sym_variable_declarator] = sym_variable_declarator,
  [sym_using_variable_declarator] = sym_variable_declarator,
  [sym_bracketed_argument_list] = sym_bracketed_argument_list,
  [sym__name] = sym__name,
  [sym_alias_qualified_name] = sym_alias_qualified_name,
  [sym__simple_name] = sym__simple_name,
  [sym_qualified_name] = sym_qualified_name,
  [sym_generic_name] = sym_generic_name,
  [sym_type_argument_list] = sym_type_argument_list,
  [sym_type] = sym_type,
  [sym_implicit_type] = sym_implicit_type,
  [sym_array_type] = sym_array_type,
  [sym__array_base_type] = sym__array_base_type,
  [sym_array_rank_specifier] = sym_array_rank_specifier,
  [sym_nullable_type] = sym_nullable_type,
  [sym_pointer_type] = sym_pointer_type,
  [sym__pointer_base_type] = sym__pointer_base_type,
  [sym_function_pointer_type] = sym_function_pointer_type,
  [sym_calling_convention] = sym_calling_convention,
  [sym_function_pointer_parameter] = sym_function_pointer_parameter,
  [sym_ref_type] = sym_ref_type,
  [sym__ref_base_type] = sym__ref_base_type,
  [sym_scoped_type] = sym_scoped_type,
  [sym__scoped_base_type] = sym__scoped_base_type,
  [sym_tuple_type] = sym_tuple_type,
  [sym_tuple_element] = sym_tuple_element,
  [sym_statement] = sym_statement,
  [sym_break_statement] = sym_break_statement,
  [sym_checked_statement] = sym_checked_statement,
  [sym_continue_statement] = sym_continue_statement,
  [sym_do_statement] = sym_do_statement,
  [sym_empty_statement] = sym_empty_statement,
  [sym_expression_statement] = sym_expression_statement,
  [sym_fixed_statement] = sym_fixed_statement,
  [sym_for_statement] = sym_for_statement,
  [sym_return_statement] = sym_return_statement,
  [sym_lock_statement] = sym_lock_statement,
  [sym_yield_statement] = sym_yield_statement,
  [sym_switch_statement] = sym_switch_statement,
  [sym_switch_body] = sym_switch_body,
  [sym_switch_section] = sym_switch_section,
  [sym_throw_statement] = sym_throw_statement,
  [sym_try_statement] = sym_try_statement,
  [sym_catch_clause] = sym_catch_clause,
  [sym_catch_declaration] = sym_catch_declaration,
  [sym_catch_filter_clause] = sym_catch_filter_clause,
  [sym_finally_clause] = sym_finally_clause,
  [sym_unsafe_statement] = sym_unsafe_statement,
  [sym_using_statement] = sym_using_statement,
  [sym_foreach_statement] = sym_foreach_statement,
  [sym_goto_statement] = sym_goto_statement,
  [sym_labeled_statement] = sym_labeled_statement,
  [sym_if_statement] = sym_if_statement,
  [sym_while_statement] = sym_while_statement,
  [sym_local_declaration_statement] = sym_local_declaration_statement,
  [sym_local_function_statement] = sym_local_function_statement,
  [sym_pattern] = sym_pattern,
  [sym_constant_pattern] = sym_constant_pattern,
  [sym_parenthesized_pattern] = sym_parenthesized_pattern,
  [sym_var_pattern] = sym_var_pattern,
  [sym_type_pattern] = sym_type_pattern,
  [sym_list_pattern] = sym_list_pattern,
  [sym_recursive_pattern] = sym_recursive_pattern,
  [sym_positional_pattern_clause] = sym_positional_pattern_clause,
  [sym_property_pattern_clause] = sym_property_pattern_clause,
  [sym_subpattern] = sym_subpattern,
  [sym_relational_pattern] = sym_relational_pattern,
  [sym_negated_pattern] = sym_negated_pattern,
  [sym_and_pattern] = sym_and_pattern,
  [sym_or_pattern] = sym_or_pattern,
  [sym_declaration_pattern] = sym_declaration_pattern,
  [sym__variable_designation] = sym__variable_designation,
  [sym_parenthesized_variable_designation] = sym_parenthesized_variable_designation,
  [sym_expression] = sym_expression,
  [sym_non_lvalue_expression] = sym_non_lvalue_expression,
  [sym_lvalue_expression] = sym_lvalue_expression,
  [sym__expression_statement_expression] = sym__expression_statement_expression,
  [sym_assignment_expression] = sym_assignment_expression,
  [sym_binary_expression] = sym_binary_expression,
  [sym_postfix_unary_expression] = sym_postfix_unary_expression,
  [sym_prefix_unary_expression] = sym_prefix_unary_expression,
  [sym__pointer_indirection_expression] = sym_prefix_unary_expression,
  [sym_query_expression] = sym_query_expression,
  [sym_from_clause] = sym_from_clause,
  [sym__query_body] = sym__query_body,
  [sym__query_clause] = sym__query_clause,
  [sym_join_clause] = sym_join_clause,
  [sym__join_header] = sym__join_header,
  [sym__join_body] = sym__join_body,
  [sym_join_into_clause] = sym_join_into_clause,
  [sym_let_clause] = sym_let_clause,
  [sym_order_by_clause] = sym_order_by_clause,
  [sym__ordering] = sym__ordering,
  [sym_where_clause] = sym_where_clause,
  [sym__select_or_group_clause] = sym__select_or_group_clause,
  [sym_group_clause] = sym_group_clause,
  [sym_select_clause] = sym_select_clause,
  [sym_conditional_expression] = sym_conditional_expression,
  [sym_conditional_access_expression] = sym_conditional_access_expression,
  [sym_as_expression] = sym_as_expression,
  [sym_is_expression] = sym_is_expression,
  [sym_is_pattern_expression] = sym_is_pattern_expression,
  [sym_cast_expression] = sym_cast_expression,
  [sym_checked_expression] = sym_checked_expression,
  [sym_invocation_expression] = sym_invocation_expression,
  [sym_switch_expression] = sym_switch_expression,
  [sym_switch_expression_arm] = sym_switch_expression_arm,
  [sym_when_clause] = sym_when_clause,
  [sym_await_expression] = sym_await_expression,
  [sym_throw_expression] = sym_throw_expression,
  [sym_element_access_expression] = sym_element_access_expression,
  [sym_interpolated_string_expression] = sym_interpolated_string_expression,
  [sym__interpolated_string_content] = sym__interpolated_string_content,
  [sym__interpolated_verbatim_string_content] = sym__interpolated_verbatim_string_content,
  [sym__interpolated_raw_string_content] = sym__interpolated_raw_string_content,
  [sym_interpolation] = sym_interpolation,
  [sym_interpolation_alignment_clause] = sym_interpolation_alignment_clause,
  [sym_interpolation_format_clause] = sym_interpolation_format_clause,
  [sym_member_access_expression] = sym_member_access_expression,
  [sym_member_binding_expression] = sym_member_binding_expression,
  [sym_object_creation_expression] = sym_object_creation_expression,
  [sym_parenthesized_expression] = sym_parenthesized_expression,
  [sym__parenthesized_lvalue_expression] = sym_parenthesized_expression,
  [sym_lambda_expression] = sym_lambda_expression,
  [sym__lambda_parameters] = sym__lambda_parameters,
  [sym_array_creation_expression] = sym_array_creation_expression,
  [sym_anonymous_method_expression] = sym_anonymous_method_expression,
  [sym_anonymous_object_creation_expression] = sym_anonymous_object_creation_expression,
  [sym__anonymous_object_member_declarator] = sym__anonymous_object_member_declarator,
  [sym_implicit_array_creation_expression] = sym_implicit_array_creation_expression,
  [sym_implicit_object_creation_expression] = sym_implicit_object_creation_expression,
  [sym_implicit_stackalloc_expression] = sym_implicit_stackalloc_expression,
  [sym_initializer_expression] = sym_initializer_expression,
  [sym_declaration_expression] = sym_declaration_expression,
  [sym_default_expression] = sym_default_expression,
  [sym_with_expression] = sym_with_expression,
  [sym_with_initializer] = sym_with_initializer,
  [sym_sizeof_expression] = sym_sizeof_expression,
  [sym_typeof_expression] = sym_typeof_expression,
  [sym_makeref_expression] = sym_makeref_expression,
  [sym_ref_expression] = sym_ref_expression,
  [sym_reftype_expression] = sym_reftype_expression,
  [sym_refvalue_expression] = sym_refvalue_expression,
  [sym_stackalloc_expression] = sym_stackalloc_expression,
  [sym_range_expression] = sym_range_expression,
  [sym_tuple_expression] = sym_tuple_expression,
  [sym_literal] = sym_literal,
  [sym_character_literal] = sym_character_literal,
  [sym_string_literal] = sym_string_literal,
  [sym_string_literal_content] = sym_string_literal_content,
  [sym_boolean_literal] = sym_boolean_literal,
  [sym_identifier] = sym_identifier,
  [sym__reserved_identifier] = sym__reserved_identifier,
  [sym_preproc_if] = sym_preproc_if,
  [sym_preproc_else] = sym_preproc_else,
  [sym_preproc_elif] = sym_preproc_elif,
  [sym_preproc_if_in_top_level] = sym_preproc_if,
  [sym_preproc_else_in_top_level] = sym_preproc_else,
  [sym_preproc_elif_in_top_level] = sym_preproc_elif,
  [sym_preproc_if_in_expression] = sym_preproc_if,
  [sym_preproc_else_in_expression] = sym_preproc_else,
  [sym_preproc_elif_in_expression] = sym_preproc_elif,
  [sym_preproc_if_in_enum_member_declaration] = sym_preproc_if,
  [sym_preproc_else_in_enum_member_declaration] = sym_preproc_else,
  [sym_preproc_elif_in_enum_member_declaration] = sym_preproc_elif,
  [sym__preproc_expression] = sym__preproc_expression,
  [sym_preproc_parenthesized_expression] = sym_parenthesized_expression,
  [sym_preproc_unary_expression] = sym_preproc_unary_expression,
  [sym_preproc_binary_expression] = sym_binary_expression,
  [sym_preproc_region] = sym_preproc_region,
  [sym_preproc_endregion] = sym_preproc_endregion,
  [sym_preproc_line] = sym_preproc_line,
  [sym_preproc_pragma] = sym_preproc_pragma,
  [sym_preproc_nullable] = sym_preproc_nullable,
  [sym_preproc_error] = sym_preproc_error,
  [sym_preproc_define] = sym_preproc_define,
  [sym_preproc_undef] = sym_preproc_undef,
  [aux_sym_compilation_unit_repeat1] = aux_sym_compilation_unit_repeat1,
  [aux_sym_global_attribute_repeat1] = aux_sym_global_attribute_repeat1,
  [aux_sym_attribute_argument_list_repeat1] = aux_sym_attribute_argument_list_repeat1,
  [aux_sym_class_declaration_repeat1] = aux_sym_class_declaration_repeat1,
  [aux_sym_class_declaration_repeat2] = aux_sym_class_declaration_repeat2,
  [aux_sym_class_declaration_repeat3] = aux_sym_class_declaration_repeat3,
  [aux_sym_enum_member_declaration_list_repeat1] = aux_sym_enum_member_declaration_list_repeat1,
  [aux_sym_record_base_repeat1] = aux_sym_record_base_repeat1,
  [aux_sym_type_parameter_list_repeat1] = aux_sym_type_parameter_list_repeat1,
  [aux_sym_base_list_repeat1] = aux_sym_base_list_repeat1,
  [aux_sym_type_parameter_constraints_clause_repeat1] = aux_sym_type_parameter_constraints_clause_repeat1,
  [aux_sym_declaration_list_repeat1] = aux_sym_declaration_list_repeat1,
  [aux_sym_accessor_list_repeat1] = aux_sym_accessor_list_repeat1,
  [aux_sym_bracketed_parameter_list_repeat1] = aux_sym_bracketed_parameter_list_repeat1,
  [aux_sym__parameter_type_with_modifiers_repeat1] = aux_sym__parameter_type_with_modifiers_repeat1,
  [aux_sym_argument_list_repeat1] = aux_sym_argument_list_repeat1,
  [aux_sym_tuple_pattern_repeat1] = aux_sym_tuple_pattern_repeat1,
  [aux_sym_block_repeat1] = aux_sym_block_repeat1,
  [aux_sym_variable_declaration_repeat1] = aux_sym_variable_declaration_repeat1,
  [aux_sym_using_variable_declaration_repeat1] = aux_sym_using_variable_declaration_repeat1,
  [aux_sym_type_argument_list_repeat1] = aux_sym_type_argument_list_repeat1,
  [aux_sym_array_rank_specifier_repeat1] = aux_sym_array_rank_specifier_repeat1,
  [aux_sym_function_pointer_type_repeat1] = aux_sym_function_pointer_type_repeat1,
  [aux_sym_calling_convention_repeat1] = aux_sym_calling_convention_repeat1,
  [aux_sym_tuple_type_repeat1] = aux_sym_tuple_type_repeat1,
  [aux_sym_for_statement_repeat1] = aux_sym_for_statement_repeat1,
  [aux_sym_switch_body_repeat1] = aux_sym_switch_body_repeat1,
  [aux_sym_try_statement_repeat1] = aux_sym_try_statement_repeat1,
  [aux_sym_list_pattern_repeat1] = aux_sym_list_pattern_repeat1,
  [aux_sym_positional_pattern_clause_repeat1] = aux_sym_positional_pattern_clause_repeat1,
  [aux_sym_parenthesized_variable_designation_repeat1] = aux_sym_parenthesized_variable_designation_repeat1,
  [aux_sym__query_body_repeat1] = aux_sym__query_body_repeat1,
  [aux_sym__query_body_repeat2] = aux_sym__query_body_repeat2,
  [aux_sym_order_by_clause_repeat1] = aux_sym_order_by_clause_repeat1,
  [aux_sym_switch_expression_repeat1] = aux_sym_switch_expression_repeat1,
  [aux_sym_interpolated_string_expression_repeat1] = aux_sym_interpolated_string_expression_repeat1,
  [aux_sym_interpolated_string_expression_repeat2] = aux_sym_interpolated_string_expression_repeat2,
  [aux_sym_interpolated_string_expression_repeat3] = aux_sym_interpolated_string_expression_repeat3,
  [aux_sym_lambda_expression_repeat1] = aux_sym_lambda_expression_repeat1,
  [aux_sym_anonymous_object_creation_expression_repeat1] = aux_sym_anonymous_object_creation_expression_repeat1,
  [aux_sym_with_expression_repeat1] = aux_sym_with_expression_repeat1,
  [aux_sym_string_literal_repeat1] = aux_sym_string_literal_repeat1,
  [aux_sym_preproc_if_in_top_level_repeat1] = aux_sym_preproc_if_in_top_level_repeat1,
  [aux_sym_preproc_pragma_repeat1] = aux_sym_preproc_pragma_repeat1,
  [alias_sym_element_binding_expression] = alias_sym_element_binding_expression,
  [alias_sym_implicit_parameter] = alias_sym_implicit_parameter,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym__identifier_token] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_extern] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_alias] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_global] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_using] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unsafe] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_static] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_assembly] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_module] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_field] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_event] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_method] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_param] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_property] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_type] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_namespace] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_class] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ref] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_struct] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_enum] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_interface] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_delegate] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_record] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_abstract] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_async] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_const] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_file] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_fixed] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_internal] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_new] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_override] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_partial] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_private] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_protected] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_public] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_readonly] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_required] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sealed] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_virtual] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_volatile] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_out] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_where] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_notnull] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unmanaged] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_operator] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_checked] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_true] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_false] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_implicit] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_explicit] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_get] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_set] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_add] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_remove] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_init] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_this] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_scoped] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_params] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_base] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_var] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_managed] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_Cdecl] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_Stdcall] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_Thiscall] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_Fastcall] = {
    .visible = true,
    .named = false,
  },
  [sym_predefined_type] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_break] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unchecked] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_continue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_lock] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_yield] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_switch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_default] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_throw] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_try] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_catch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_when] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_finally] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_await] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_foreach] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_goto] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [sym_discard] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_not] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_and] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_or] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK_QMARK_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_from] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_into] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_join] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_on] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_equals] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_let] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_orderby] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ascending] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_descending] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_group] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_by] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_select] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_as] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_is] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_interpolation_format_clause_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_DASH_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_stackalloc] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_with] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sizeof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_typeof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___makeref] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___reftype] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___refvalue] = {
    .visible = true,
    .named = false,
  },
  [sym_null_literal] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_character_literal_token1] = {
    .visible = false,
    .named = false,
  },
  [sym_integer_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_real_literal] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_string_literal_content_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_literal_content_token2] = {
    .visible = false,
    .named = false,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [sym_string_literal_encoding] = {
    .visible = true,
    .named = true,
  },
  [sym_verbatim_string_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_raw_string_literal] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_preproc_if_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_if_token2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_if_token3] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_else_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_elif_token1] = {
    .visible = true,
    .named = false,
  },
  [sym_preproc_arg] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_preproc_region_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_endregion_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_line_token1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_hidden] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_pragma_token1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_warning] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_disable] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_restore] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_checksum] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_nullable_token1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_enable] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_annotations] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_warnings] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_error_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_define_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_undef_token1] = {
    .visible = true,
    .named = false,
  },
  [sym_shebang_directive] = {
    .visible = true,
    .named = true,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [sym__optional_semi] = {
    .visible = false,
    .named = true,
  },
  [sym_interpolation_regular_start] = {
    .visible = true,
    .named = true,
  },
  [sym_interpolation_verbatim_start] = {
    .visible = true,
    .named = true,
  },
  [sym_interpolation_raw_start] = {
    .visible = true,
    .named = true,
  },
  [sym_interpolation_start_quote] = {
    .visible = true,
    .named = true,
  },
  [sym_interpolation_end_quote] = {
    .visible = true,
    .named = true,
  },
  [sym_interpolation_open_brace] = {
    .visible = true,
    .named = true,
  },
  [sym_interpolation_close_brace] = {
    .visible = true,
    .named = true,
  },
  [sym_interpolation_string_content] = {
    .visible = true,
    .named = true,
  },
  [sym_compilation_unit] = {
    .visible = true,
    .named = true,
  },
  [sym__top_level_item] = {
    .visible = false,
    .named = true,
  },
  [sym_global_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_extern_alias_directive] = {
    .visible = true,
    .named = true,
  },
  [sym_using_directive] = {
    .visible = true,
    .named = true,
  },
  [sym_global_attribute] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute_argument] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute_list] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute_target_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_namespace_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_file_scoped_namespace_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_type_declaration] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_class_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_struct_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_member_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_member_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_interface_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_delegate_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_record_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_record_base] = {
    .visible = true,
    .named = true,
  },
  [sym_primary_constructor_base_type] = {
    .visible = true,
    .named = true,
  },
  [sym_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameter_list] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_base_list] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameter_constraints_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameter_constraint] = {
    .visible = true,
    .named = true,
  },
  [sym_constructor_constraint] = {
    .visible = true,
    .named = true,
  },
  [sym_operator_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_conversion_operator_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_declaration] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_field_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_constructor_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_destructor_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_method_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_event_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_event_field_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_accessor_list] = {
    .visible = true,
    .named = true,
  },
  [sym_accessor_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_indexer_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_bracketed_parameter_list] = {
    .visible = true,
    .named = true,
  },
  [sym_property_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_explicit_interface_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_parameter_list] = {
    .visible = true,
    .named = true,
  },
  [sym_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym__parameter_array] = {
    .visible = false,
    .named = true,
  },
  [sym_constructor_initializer] = {
    .visible = true,
    .named = true,
  },
  [sym_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_tuple_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_argument] = {
    .visible = true,
    .named = true,
  },
  [sym_block] = {
    .visible = true,
    .named = true,
  },
  [sym_arrow_expression_clause] = {
    .visible = true,
    .named = true,
  },
  [sym__function_body] = {
    .visible = false,
    .named = true,
  },
  [sym_variable_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_using_variable_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_using_variable_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_bracketed_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym__name] = {
    .visible = false,
    .named = true,
  },
  [sym_alias_qualified_name] = {
    .visible = true,
    .named = true,
  },
  [sym__simple_name] = {
    .visible = false,
    .named = true,
  },
  [sym_qualified_name] = {
    .visible = true,
    .named = true,
  },
  [sym_generic_name] = {
    .visible = true,
    .named = true,
  },
  [sym_type_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_type] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_implicit_type] = {
    .visible = true,
    .named = true,
  },
  [sym_array_type] = {
    .visible = true,
    .named = true,
  },
  [sym__array_base_type] = {
    .visible = false,
    .named = true,
  },
  [sym_array_rank_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_nullable_type] = {
    .visible = true,
    .named = true,
  },
  [sym_pointer_type] = {
    .visible = true,
    .named = true,
  },
  [sym__pointer_base_type] = {
    .visible = false,
    .named = true,
  },
  [sym_function_pointer_type] = {
    .visible = true,
    .named = true,
  },
  [sym_calling_convention] = {
    .visible = true,
    .named = true,
  },
  [sym_function_pointer_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_ref_type] = {
    .visible = true,
    .named = true,
  },
  [sym__ref_base_type] = {
    .visible = false,
    .named = true,
  },
  [sym_scoped_type] = {
    .visible = true,
    .named = true,
  },
  [sym__scoped_base_type] = {
    .visible = false,
    .named = true,
  },
  [sym_tuple_type] = {
    .visible = true,
    .named = true,
  },
  [sym_tuple_element] = {
    .visible = true,
    .named = true,
  },
  [sym_statement] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_break_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_checked_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_continue_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_do_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_empty_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_fixed_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_return_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_lock_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_yield_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_body] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_section] = {
    .visible = true,
    .named = true,
  },
  [sym_throw_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_try_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_catch_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_catch_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_catch_filter_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_finally_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_unsafe_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_using_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_foreach_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_goto_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_labeled_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_local_declaration_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_local_function_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_pattern] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_constant_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_var_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_type_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_list_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_recursive_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_positional_pattern_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_property_pattern_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_subpattern] = {
    .visible = true,
    .named = true,
  },
  [sym_relational_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_negated_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_and_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_or_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_declaration_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym__variable_designation] = {
    .visible = false,
    .named = true,
  },
  [sym_parenthesized_variable_designation] = {
    .visible = true,
    .named = true,
  },
  [sym_expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_non_lvalue_expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_lvalue_expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__expression_statement_expression] = {
    .visible = false,
    .named = true,
  },
  [sym_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_postfix_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_prefix_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__pointer_indirection_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_query_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_from_clause] = {
    .visible = true,
    .named = true,
  },
  [sym__query_body] = {
    .visible = false,
    .named = true,
  },
  [sym__query_clause] = {
    .visible = false,
    .named = true,
  },
  [sym_join_clause] = {
    .visible = true,
    .named = true,
  },
  [sym__join_header] = {
    .visible = false,
    .named = true,
  },
  [sym__join_body] = {
    .visible = false,
    .named = true,
  },
  [sym_join_into_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_let_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_order_by_clause] = {
    .visible = true,
    .named = true,
  },
  [sym__ordering] = {
    .visible = false,
    .named = true,
  },
  [sym_where_clause] = {
    .visible = true,
    .named = true,
  },
  [sym__select_or_group_clause] = {
    .visible = false,
    .named = true,
  },
  [sym_group_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_select_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_conditional_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_conditional_access_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_as_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_is_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_is_pattern_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_cast_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_checked_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_invocation_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_expression_arm] = {
    .visible = true,
    .named = true,
  },
  [sym_when_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_await_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_throw_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_element_access_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_interpolated_string_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__interpolated_string_content] = {
    .visible = false,
    .named = true,
  },
  [sym__interpolated_verbatim_string_content] = {
    .visible = false,
    .named = true,
  },
  [sym__interpolated_raw_string_content] = {
    .visible = false,
    .named = true,
  },
  [sym_interpolation] = {
    .visible = true,
    .named = true,
  },
  [sym_interpolation_alignment_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_interpolation_format_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_member_access_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_member_binding_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_object_creation_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__parenthesized_lvalue_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_lambda_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__lambda_parameters] = {
    .visible = false,
    .named = true,
  },
  [sym_array_creation_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_anonymous_method_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_anonymous_object_creation_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__anonymous_object_member_declarator] = {
    .visible = false,
    .named = true,
  },
  [sym_implicit_array_creation_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_implicit_object_creation_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_implicit_stackalloc_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_initializer_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_declaration_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_default_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_with_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_with_initializer] = {
    .visible = true,
    .named = true,
  },
  [sym_sizeof_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_typeof_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_makeref_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_ref_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_reftype_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_refvalue_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_stackalloc_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_range_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_tuple_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_literal] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_character_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_string_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_string_literal_content] = {
    .visible = true,
    .named = true,
  },
  [sym_boolean_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym__reserved_identifier] = {
    .visible = false,
    .named = true,
  },
  [sym_preproc_if] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_else] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elif] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_if_in_top_level] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_else_in_top_level] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elif_in_top_level] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_if_in_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_else_in_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elif_in_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_if_in_enum_member_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_else_in_enum_member_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elif_in_enum_member_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__preproc_expression] = {
    .visible = false,
    .named = true,
  },
  [sym_preproc_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_region] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_endregion] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_line] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_pragma] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_nullable] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_error] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_define] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_undef] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_compilation_unit_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_global_attribute_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_attribute_argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_class_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_class_declaration_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_class_declaration_repeat3] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_enum_member_declaration_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_record_base_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_parameter_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_base_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_parameter_constraints_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_declaration_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_accessor_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_bracketed_parameter_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__parameter_type_with_modifiers_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_tuple_pattern_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_block_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_variable_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_using_variable_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_array_rank_specifier_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_function_pointer_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_calling_convention_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_tuple_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_for_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_switch_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_try_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_list_pattern_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_positional_pattern_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_parenthesized_variable_designation_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__query_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__query_body_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_order_by_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_switch_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_interpolated_string_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_interpolated_string_expression_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_interpolated_string_expression_repeat3] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_lambda_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_anonymous_object_creation_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_with_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_literal_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_if_in_top_level_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_pragma_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_element_binding_expression] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_implicit_parameter] = {
    .visible = true,
    .named = true,
  },
};

enum ts_field_identifiers {
  field_accessors = 1,
  field_alias = 2,
  field_alternative = 3,
  field_argument = 4,
  field_arguments = 5,
  field_body = 6,
  field_condition = 7,
  field_consequence = 8,
  field_content = 9,
  field_expression = 10,
  field_function = 11,
  field_initializer = 12,
  field_left = 13,
  field_name = 14,
  field_operator = 15,
  field_parameters = 16,
  field_pattern = 17,
  field_qualifier = 18,
  field_rank = 19,
  field_returns = 20,
  field_right = 21,
  field_subscript = 22,
  field_type = 23,
  field_type_parameters = 24,
  field_update = 25,
  field_value = 26,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_accessors] = "accessors",
  [field_alias] = "alias",
  [field_alternative] = "alternative",
  [field_argument] = "argument",
  [field_arguments] = "arguments",
  [field_body] = "body",
  [field_condition] = "condition",
  [field_consequence] = "consequence",
  [field_content] = "content",
  [field_expression] = "expression",
  [field_function] = "function",
  [field_initializer] = "initializer",
  [field_left] = "left",
  [field_name] = "name",
  [field_operator] = "operator",
  [field_parameters] = "parameters",
  [field_pattern] = "pattern",
  [field_qualifier] = "qualifier",
  [field_rank] = "rank",
  [field_returns] = "returns",
  [field_right] = "right",
  [field_subscript] = "subscript",
  [field_type] = "type",
  [field_type_parameters] = "type_parameters",
  [field_update] = "update",
  [field_value] = "value",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [4] = {.index = 0, .length = 1},
  [5] = {.index = 1, .length = 1},
  [6] = {.index = 2, .length = 1},
  [7] = {.index = 3, .length = 1},
  [8] = {.index = 4, .length = 2},
  [9] = {.index = 6, .length = 2},
  [10] = {.index = 8, .length = 2},
  [11] = {.index = 10, .length = 1},
  [12] = {.index = 11, .length = 2},
  [13] = {.index = 13, .length = 2},
  [14] = {.index = 15, .length = 1},
  [15] = {.index = 16, .length = 1},
  [16] = {.index = 17, .length = 1},
  [17] = {.index = 18, .length = 2},
  [18] = {.index = 20, .length = 2},
  [19] = {.index = 22, .length = 2},
  [20] = {.index = 24, .length = 2},
  [21] = {.index = 26, .length = 2},
  [22] = {.index = 28, .length = 2},
  [23] = {.index = 30, .length = 3},
  [24] = {.index = 33, .length = 1},
  [25] = {.index = 33, .length = 1},
  [26] = {.index = 34, .length = 2},
  [27] = {.index = 36, .length = 2},
  [28] = {.index = 38, .length = 2},
  [29] = {.index = 40, .length = 1},
  [30] = {.index = 41, .length = 2},
  [31] = {.index = 43, .length = 2},
  [32] = {.index = 45, .length = 4},
  [33] = {.index = 49, .length = 4},
  [34] = {.index = 53, .length = 2},
  [35] = {.index = 55, .length = 2},
  [36] = {.index = 57, .length = 3},
  [37] = {.index = 60, .length = 1},
  [38] = {.index = 61, .length = 3},
  [39] = {.index = 64, .length = 1},
  [40] = {.index = 65, .length = 4},
  [41] = {.index = 69, .length = 1},
  [42] = {.index = 70, .length = 2},
  [43] = {.index = 72, .length = 1},
  [44] = {.index = 73, .length = 2},
  [45] = {.index = 75, .length = 1},
  [46] = {.index = 76, .length = 1},
  [47] = {.index = 77, .length = 2},
  [48] = {.index = 79, .length = 2},
  [49] = {.index = 81, .length = 2},
  [50] = {.index = 83, .length = 3},
  [51] = {.index = 86, .length = 1},
  [52] = {.index = 87, .length = 3},
  [53] = {.index = 90, .length = 2},
  [54] = {.index = 92, .length = 2},
  [55] = {.index = 94, .length = 1},
  [56] = {.index = 95, .length = 2},
  [57] = {.index = 97, .length = 2},
  [58] = {.index = 99, .length = 1},
  [59] = {.index = 100, .length = 2},
  [60] = {.index = 102, .length = 2},
  [61] = {.index = 104, .length = 5},
  [62] = {.index = 109, .length = 4},
  [63] = {.index = 113, .length = 3},
  [64] = {.index = 116, .length = 2},
  [65] = {.index = 118, .length = 3},
  [66] = {.index = 121, .length = 4},
  [67] = {.index = 125, .length = 2},
  [68] = {.index = 127, .length = 3},
  [69] = {.index = 130, .length = 3},
  [70] = {.index = 133, .length = 2},
  [71] = {.index = 135, .length = 2},
  [72] = {.index = 137, .length = 2},
  [73] = {.index = 139, .length = 3},
  [74] = {.index = 142, .length = 1},
  [75] = {.index = 143, .length = 4},
  [76] = {.index = 147, .length = 1},
  [77] = {.index = 148, .length = 1},
  [78] = {.index = 149, .length = 2},
  [79] = {.index = 151, .length = 2},
  [80] = {.index = 153, .length = 5},
  [81] = {.index = 158, .length = 2},
  [82] = {.index = 160, .length = 2},
  [83] = {.index = 162, .length = 3},
  [84] = {.index = 165, .length = 3},
  [85] = {.index = 168, .length = 1},
  [86] = {.index = 169, .length = 5},
  [87] = {.index = 174, .length = 4},
  [88] = {.index = 178, .length = 4},
  [89] = {.index = 182, .length = 3},
  [90] = {.index = 185, .length = 3},
  [91] = {.index = 188, .length = 3},
  [92] = {.index = 191, .length = 3},
  [93] = {.index = 194, .length = 3},
  [94] = {.index = 197, .length = 4},
  [95] = {.index = 201, .length = 3},
  [96] = {.index = 204, .length = 3},
  [97] = {.index = 207, .length = 2},
  [98] = {.index = 209, .length = 2},
  [99] = {.index = 211, .length = 2},
  [100] = {.index = 213, .length = 3},
  [101] = {.index = 216, .length = 1},
  [102] = {.index = 217, .length = 2},
  [103] = {.index = 219, .length = 2},
  [104] = {.index = 221, .length = 2},
  [105] = {.index = 223, .length = 2},
  [106] = {.index = 225, .length = 3},
  [107] = {.index = 228, .length = 3},
  [108] = {.index = 231, .length = 2},
  [109] = {.index = 233, .length = 2},
  [110] = {.index = 235, .length = 3},
  [111] = {.index = 238, .length = 4},
  [112] = {.index = 242, .length = 5},
  [113] = {.index = 247, .length = 2},
  [114] = {.index = 249, .length = 3},
  [115] = {.index = 252, .length = 3},
  [116] = {.index = 255, .length = 1},
  [117] = {.index = 256, .length = 5},
  [118] = {.index = 261, .length = 4},
  [119] = {.index = 265, .length = 3},
  [120] = {.index = 268, .length = 2},
  [121] = {.index = 270, .length = 3},
  [122] = {.index = 273, .length = 3},
  [123] = {.index = 276, .length = 4},
  [124] = {.index = 280, .length = 3},
  [125] = {.index = 283, .length = 3},
  [126] = {.index = 286, .length = 4},
  [127] = {.index = 290, .length = 3},
  [128] = {.index = 293, .length = 2},
  [129] = {.index = 295, .length = 5},
  [130] = {.index = 300, .length = 4},
  [131] = {.index = 304, .length = 3},
  [132] = {.index = 307, .length = 3},
  [133] = {.index = 310, .length = 4},
  [134] = {.index = 314, .length = 3},
  [135] = {.index = 317, .length = 3},
  [136] = {.index = 320, .length = 2},
  [137] = {.index = 322, .length = 2},
  [138] = {.index = 324, .length = 3},
  [139] = {.index = 327, .length = 3},
  [140] = {.index = 330, .length = 3},
  [141] = {.index = 333, .length = 3},
  [142] = {.index = 336, .length = 3},
  [143] = {.index = 339, .length = 3},
  [144] = {.index = 342, .length = 4},
  [145] = {.index = 346, .length = 2},
  [146] = {.index = 348, .length = 3},
  [147] = {.index = 351, .length = 2},
  [148] = {.index = 353, .length = 3},
  [149] = {.index = 356, .length = 4},
  [150] = {.index = 360, .length = 5},
  [151] = {.index = 365, .length = 3},
  [152] = {.index = 368, .length = 4},
  [153] = {.index = 372, .length = 3},
  [154] = {.index = 375, .length = 5},
  [155] = {.index = 380, .length = 4},
  [156] = {.index = 384, .length = 2},
  [157] = {.index = 386, .length = 5},
  [158] = {.index = 391, .length = 4},
  [159] = {.index = 395, .length = 3},
  [160] = {.index = 398, .length = 2},
  [161] = {.index = 400, .length = 3},
  [162] = {.index = 403, .length = 4},
  [163] = {.index = 407, .length = 3},
  [164] = {.index = 410, .length = 3},
  [165] = {.index = 413, .length = 4},
  [166] = {.index = 417, .length = 3},
  [167] = {.index = 420, .length = 5},
  [168] = {.index = 425, .length = 4},
  [169] = {.index = 429, .length = 2},
  [170] = {.index = 431, .length = 3},
  [171] = {.index = 434, .length = 3},
  [172] = {.index = 437, .length = 4},
  [173] = {.index = 441, .length = 3},
  [174] = {.index = 444, .length = 3},
  [175] = {.index = 447, .length = 2},
  [176] = {.index = 449, .length = 4},
  [177] = {.index = 453, .length = 4},
  [178] = {.index = 457, .length = 4},
  [179] = {.index = 461, .length = 4},
  [180] = {.index = 465, .length = 4},
  [181] = {.index = 469, .length = 4},
  [182] = {.index = 473, .length = 2},
  [183] = {.index = 475, .length = 2},
  [184] = {.index = 477, .length = 3},
  [185] = {.index = 480, .length = 3},
  [186] = {.index = 483, .length = 4},
  [187] = {.index = 487, .length = 5},
  [188] = {.index = 492, .length = 4},
  [189] = {.index = 496, .length = 2},
  [190] = {.index = 498, .length = 4},
  [191] = {.index = 502, .length = 3},
  [192] = {.index = 505, .length = 5},
  [193] = {.index = 510, .length = 4},
  [194] = {.index = 514, .length = 5},
  [195] = {.index = 519, .length = 4},
  [196] = {.index = 523, .length = 2},
  [197] = {.index = 525, .length = 3},
  [198] = {.index = 528, .length = 4},
  [199] = {.index = 532, .length = 3},
  [200] = {.index = 535, .length = 3},
  [201] = {.index = 538, .length = 4},
  [202] = {.index = 542, .length = 3},
  [203] = {.index = 545, .length = 5},
  [204] = {.index = 550, .length = 4},
  [205] = {.index = 554, .length = 5},
  [206] = {.index = 559, .length = 5},
  [207] = {.index = 564, .length = 5},
  [208] = {.index = 569, .length = 2},
  [209] = {.index = 571, .length = 2},
  [210] = {.index = 573, .length = 3},
  [211] = {.index = 576, .length = 4},
  [212] = {.index = 580, .length = 5},
  [213] = {.index = 585, .length = 4},
  [214] = {.index = 589, .length = 4},
  [215] = {.index = 593, .length = 3},
  [216] = {.index = 596, .length = 5},
  [217] = {.index = 601, .length = 4},
  [218] = {.index = 605, .length = 5},
  [219] = {.index = 610, .length = 4},
  [220] = {.index = 614, .length = 6},
  [221] = {.index = 620, .length = 2},
  [222] = {.index = 622, .length = 3},
  [223] = {.index = 625, .length = 4},
  [224] = {.index = 629, .length = 5},
  [225] = {.index = 634, .length = 4},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_name, 0},
  [1] =
    {field_type, 0},
  [2] =
    {field_type, 1},
  [3] =
    {field_body, 1},
  [4] =
    {field_rank, 1},
    {field_type, 0},
  [6] =
    {field_arguments, 1},
    {field_function, 0},
  [8] =
    {field_expression, 0},
    {field_subscript, 1},
  [10] =
    {field_content, 1},
  [11] =
    {field_name, 1},
    {field_type, 0},
  [13] =
    {field_name, 1, .inherited = true},
    {field_type, 1, .inherited = true},
  [15] =
    {field_name, 1},
  [16] =
    {field_type, 2},
  [17] =
    {field_parameters, 1},
  [18] =
    {field_arguments, 2},
    {field_type, 1},
  [20] =
    {field_initializer, 2},
    {field_type, 1},
  [22] =
    {field_expression, 0},
    {field_name, 2},
  [24] =
    {field_body, 2},
    {field_value, 1},
  [26] =
    {field_argument, 1},
    {field_operator, 0},
  [28] =
    {field_name, 2},
    {field_qualifier, 0},
  [30] =
    {field_left, 0},
    {field_operator, 1},
    {field_right, 2},
  [33] =
    {field_condition, 0},
  [34] =
    {field_expression, 0},
    {field_pattern, 2},
  [36] =
    {field_body, 2},
    {field_parameters, 0},
  [38] =
    {field_alias, 0},
    {field_name, 2},
  [40] =
    {field_name, 2},
  [41] =
    {field_name, 2},
    {field_type, 1},
  [43] =
    {field_name, 2, .inherited = true},
    {field_type, 2, .inherited = true},
  [45] =
    {field_name, 0, .inherited = true},
    {field_name, 1, .inherited = true},
    {field_type, 0, .inherited = true},
    {field_type, 1, .inherited = true},
  [49] =
    {field_name, 1, .inherited = true},
    {field_name, 2, .inherited = true},
    {field_type, 1, .inherited = true},
    {field_type, 2, .inherited = true},
  [53] =
    {field_type, 1},
    {field_value, 3},
  [55] =
    {field_body, 2},
    {field_name, 1},
  [57] =
    {field_arguments, 2},
    {field_initializer, 3},
    {field_type, 1},
  [60] =
    {field_condition, 1},
  [61] =
    {field_body, 3},
    {field_parameters, 1},
    {field_type, 0},
  [64] =
    {field_body, 0},
  [65] =
    {field_body, 3, .inherited = true},
    {field_name, 1},
    {field_parameters, 2},
    {field_type, 0},
  [69] =
    {field_name, 1, .inherited = true},
  [70] =
    {field_name, 1, .inherited = true},
    {field_type, 0},
  [72] =
    {field_type, 1, .inherited = true},
  [73] =
    {field_body, 3},
    {field_parameters, 1},
  [75] =
    {field_parameters, 2},
  [76] =
    {field_body, 4},
  [77] =
    {field_name, 3},
    {field_type, 2},
  [79] =
    {field_body, 3},
    {field_name, 1},
  [81] =
    {field_body, 3},
    {field_name, 2},
  [83] =
    {field_body, 3},
    {field_name, 1},
    {field_type_parameters, 2},
  [86] =
    {field_returns, 3},
  [87] =
    {field_name, 2},
    {field_parameters, 3},
    {field_type, 1},
  [90] =
    {field_body, 4},
    {field_condition, 2},
  [92] =
    {field_body, 4},
    {field_value, 2},
  [94] =
    {field_body, 2},
  [95] =
    {field_condition, 2},
    {field_consequence, 4},
  [97] =
    {field_alternative, 3},
    {field_condition, 1},
  [99] =
    {field_name, 2, .inherited = true},
  [100] =
    {field_name, 0, .inherited = true},
    {field_name, 1, .inherited = true},
  [102] =
    {field_name, 1},
    {field_name, 2, .inherited = true},
  [104] =
    {field_body, 4, .inherited = true},
    {field_name, 1},
    {field_parameters, 3},
    {field_type, 0},
    {field_type_parameters, 2},
  [109] =
    {field_body, 4, .inherited = true},
    {field_name, 1},
    {field_parameters, 2},
    {field_type, 0},
  [113] =
    {field_alternative, 4},
    {field_condition, 0},
    {field_consequence, 2},
  [116] =
    {field_name, 2, .inherited = true},
    {field_type, 0},
  [118] =
    {field_body, 4},
    {field_parameters, 2},
    {field_type, 1},
  [121] =
    {field_body, 4, .inherited = true},
    {field_name, 2},
    {field_parameters, 3},
    {field_type, 1},
  [125] =
    {field_body, 4},
    {field_parameters, 2},
  [127] =
    {field_accessors, 2},
    {field_name, 1},
    {field_type, 0},
  [130] =
    {field_body, 2, .inherited = true},
    {field_name, 0},
    {field_parameters, 1},
  [133] =
    {field_body, 4},
    {field_name, 1},
  [135] =
    {field_body, 4},
    {field_name, 2},
  [137] =
    {field_name, 0},
    {field_value, 2},
  [139] =
    {field_body, 4},
    {field_name, 1},
    {field_type_parameters, 2},
  [142] =
    {field_returns, 4},
  [143] =
    {field_name, 2},
    {field_parameters, 4},
    {field_type, 1},
    {field_type_parameters, 3},
  [147] =
    {field_body, 5},
  [148] =
    {field_body, 3},
  [149] =
    {field_type, 4},
    {field_value, 2},
  [151] =
    {field_alternative, 4},
    {field_condition, 1},
  [153] =
    {field_body, 5, .inherited = true},
    {field_name, 1},
    {field_parameters, 3},
    {field_type, 0},
    {field_type_parameters, 2},
  [158] =
    {field_name, 3, .inherited = true},
    {field_type, 0},
  [160] =
    {field_body, 4},
    {field_name, 3},
  [162] =
    {field_body, 4},
    {field_name, 2},
    {field_type_parameters, 3},
  [165] =
    {field_name, 3},
    {field_parameters, 4},
    {field_type, 2},
  [168] =
    {field_name, 3},
  [169] =
    {field_body, 5, .inherited = true},
    {field_name, 2},
    {field_parameters, 4},
    {field_type, 1},
    {field_type_parameters, 3},
  [174] =
    {field_body, 5, .inherited = true},
    {field_name, 2},
    {field_parameters, 3},
    {field_type, 1},
  [178] =
    {field_body, 5, .inherited = true},
    {field_name, 3},
    {field_parameters, 4},
    {field_type, 2},
  [182] =
    {field_body, 5},
    {field_parameters, 3},
    {field_type, 2},
  [185] =
    {field_accessors, 3},
    {field_name, 2},
    {field_type, 1},
  [188] =
    {field_body, 3, .inherited = true},
    {field_name, 1},
    {field_parameters, 2},
  [191] =
    {field_accessors, 3},
    {field_parameters, 2},
    {field_type, 0},
  [194] =
    {field_accessors, 3},
    {field_name, 2},
    {field_type, 0},
  [197] =
    {field_body, 3, .inherited = true},
    {field_name, 1},
    {field_parameters, 2},
    {field_returns, 0},
  [201] =
    {field_name, 1},
    {field_type, 0},
    {field_value, 2},
  [204] =
    {field_body, 3, .inherited = true},
    {field_name, 0},
    {field_parameters, 1},
  [207] =
    {field_body, 5},
    {field_name, 1},
  [209] =
    {field_body, 5},
    {field_name, 2},
  [211] =
    {field_name, 1},
    {field_value, 3},
  [213] =
    {field_body, 5},
    {field_name, 1},
    {field_type_parameters, 2},
  [216] =
    {field_returns, 5},
  [217] =
    {field_body, 1},
    {field_condition, 4},
  [219] =
    {field_body, 6},
    {field_update, 4},
  [221] =
    {field_body, 6},
    {field_condition, 3},
  [223] =
    {field_body, 6},
    {field_initializer, 2},
  [225] =
    {field_body, 6},
    {field_left, 2},
    {field_right, 4},
  [228] =
    {field_alternative, 6},
    {field_condition, 2},
    {field_consequence, 4},
  [231] =
    {field_name, 1, .inherited = true},
    {field_name, 2, .inherited = true},
  [233] =
    {field_body, 5},
    {field_name, 3},
  [235] =
    {field_body, 5},
    {field_name, 2},
    {field_type_parameters, 3},
  [238] =
    {field_name, 3},
    {field_parameters, 5},
    {field_type, 2},
    {field_type_parameters, 4},
  [242] =
    {field_body, 6, .inherited = true},
    {field_name, 2},
    {field_parameters, 4},
    {field_type, 1},
    {field_type_parameters, 3},
  [247] =
    {field_body, 5},
    {field_name, 4},
  [249] =
    {field_body, 5},
    {field_name, 3},
    {field_type_parameters, 4},
  [252] =
    {field_name, 4},
    {field_parameters, 5},
    {field_type, 3},
  [255] =
    {field_name, 4},
  [256] =
    {field_body, 6, .inherited = true},
    {field_name, 3},
    {field_parameters, 5},
    {field_type, 2},
    {field_type_parameters, 4},
  [261] =
    {field_body, 6, .inherited = true},
    {field_name, 3},
    {field_parameters, 4},
    {field_type, 2},
  [265] =
    {field_body, 4, .inherited = true},
    {field_name, 2},
    {field_parameters, 3},
  [268] =
    {field_name, 3},
    {field_type, 1},
  [270] =
    {field_accessors, 4},
    {field_name, 3},
    {field_type, 1},
  [273] =
    {field_body, 4, .inherited = true},
    {field_parameters, 3},
    {field_type, 2},
  [276] =
    {field_body, 4, .inherited = true},
    {field_operator, 2},
    {field_parameters, 3},
    {field_type, 0},
  [280] =
    {field_parameters, 2},
    {field_type, 0},
    {field_value, 3},
  [283] =
    {field_accessors, 4},
    {field_parameters, 3},
    {field_type, 0},
  [286] =
    {field_body, 4, .inherited = true},
    {field_name, 2},
    {field_parameters, 3},
    {field_returns, 0},
  [290] =
    {field_name, 2},
    {field_type, 0},
    {field_value, 3},
  [293] =
    {field_body, 1, .inherited = true},
    {field_name, 0},
  [295] =
    {field_body, 4, .inherited = true},
    {field_name, 1},
    {field_parameters, 3},
    {field_returns, 0},
    {field_type_parameters, 2},
  [300] =
    {field_body, 4, .inherited = true},
    {field_name, 1},
    {field_parameters, 2},
    {field_returns, 0},
  [304] =
    {field_accessors, 4},
    {field_name, 3},
    {field_type, 2},
  [307] =
    {field_accessors, 4},
    {field_parameters, 3},
    {field_type, 1},
  [310] =
    {field_body, 4, .inherited = true},
    {field_name, 2},
    {field_parameters, 3},
    {field_returns, 1},
  [314] =
    {field_name, 2},
    {field_type, 1},
    {field_value, 3},
  [317] =
    {field_body, 4, .inherited = true},
    {field_name, 1},
    {field_parameters, 2},
  [320] =
    {field_body, 6},
    {field_name, 1},
  [322] =
    {field_body, 6},
    {field_name, 2},
  [324] =
    {field_body, 7},
    {field_update, 4},
    {field_update, 5},
  [327] =
    {field_body, 7},
    {field_condition, 3},
    {field_update, 5},
  [330] =
    {field_body, 7},
    {field_initializer, 2},
    {field_update, 5},
  [333] =
    {field_body, 7},
    {field_condition, 4},
    {field_initializer, 2},
  [336] =
    {field_body, 7},
    {field_initializer, 2},
    {field_initializer, 3},
  [339] =
    {field_body, 7},
    {field_left, 3},
    {field_right, 5},
  [342] =
    {field_body, 7},
    {field_left, 3},
    {field_right, 5},
    {field_type, 2},
  [346] =
    {field_body, 6},
    {field_name, 3},
  [348] =
    {field_body, 6},
    {field_name, 2},
    {field_type_parameters, 3},
  [351] =
    {field_body, 6},
    {field_name, 4},
  [353] =
    {field_body, 6},
    {field_name, 3},
    {field_type_parameters, 4},
  [356] =
    {field_name, 4},
    {field_parameters, 6},
    {field_type, 3},
    {field_type_parameters, 5},
  [360] =
    {field_body, 7, .inherited = true},
    {field_name, 3},
    {field_parameters, 5},
    {field_type, 2},
    {field_type_parameters, 4},
  [365] =
    {field_body, 5, .inherited = true},
    {field_parameters, 4},
    {field_type, 3},
  [368] =
    {field_body, 5, .inherited = true},
    {field_operator, 3},
    {field_parameters, 4},
    {field_type, 0},
  [372] =
    {field_parameters, 3},
    {field_type, 0},
    {field_value, 4},
  [375] =
    {field_body, 5, .inherited = true},
    {field_name, 2},
    {field_parameters, 4},
    {field_returns, 0},
    {field_type_parameters, 3},
  [380] =
    {field_body, 5, .inherited = true},
    {field_name, 2},
    {field_parameters, 3},
    {field_returns, 0},
  [384] =
    {field_body, 2, .inherited = true},
    {field_name, 1},
  [386] =
    {field_body, 5, .inherited = true},
    {field_name, 1},
    {field_parameters, 3},
    {field_returns, 0},
    {field_type_parameters, 2},
  [391] =
    {field_accessors, 2},
    {field_name, 1},
    {field_type, 0},
    {field_value, 4},
  [395] =
    {field_body, 5, .inherited = true},
    {field_name, 3},
    {field_parameters, 4},
  [398] =
    {field_name, 4},
    {field_type, 2},
  [400] =
    {field_accessors, 5},
    {field_name, 4},
    {field_type, 2},
  [403] =
    {field_body, 5, .inherited = true},
    {field_operator, 3},
    {field_parameters, 4},
    {field_type, 1},
  [407] =
    {field_parameters, 3},
    {field_type, 1},
    {field_value, 4},
  [410] =
    {field_accessors, 5},
    {field_parameters, 4},
    {field_type, 1},
  [413] =
    {field_body, 5, .inherited = true},
    {field_name, 3},
    {field_parameters, 4},
    {field_returns, 1},
  [417] =
    {field_name, 3},
    {field_type, 1},
    {field_value, 4},
  [420] =
    {field_body, 5, .inherited = true},
    {field_name, 2},
    {field_parameters, 4},
    {field_returns, 1},
    {field_type_parameters, 3},
  [425] =
    {field_body, 5, .inherited = true},
    {field_name, 2},
    {field_parameters, 3},
    {field_returns, 1},
  [429] =
    {field_name, 4},
    {field_type, 3},
  [431] =
    {field_accessors, 5},
    {field_name, 4},
    {field_type, 3},
  [434] =
    {field_accessors, 5},
    {field_parameters, 4},
    {field_type, 2},
  [437] =
    {field_body, 5, .inherited = true},
    {field_name, 3},
    {field_parameters, 4},
    {field_returns, 2},
  [441] =
    {field_name, 3},
    {field_type, 2},
    {field_value, 4},
  [444] =
    {field_body, 5, .inherited = true},
    {field_name, 2},
    {field_parameters, 3},
  [447] =
    {field_body, 7},
    {field_name, 2},
  [449] =
    {field_body, 8},
    {field_condition, 3},
    {field_update, 5},
    {field_update, 6},
  [453] =
    {field_body, 8},
    {field_initializer, 2},
    {field_update, 5},
    {field_update, 6},
  [457] =
    {field_body, 8},
    {field_condition, 4},
    {field_initializer, 2},
    {field_update, 6},
  [461] =
    {field_body, 8},
    {field_initializer, 2},
    {field_initializer, 3},
    {field_update, 6},
  [465] =
    {field_body, 8},
    {field_condition, 5},
    {field_initializer, 2},
    {field_initializer, 3},
  [469] =
    {field_body, 8},
    {field_left, 4},
    {field_right, 6},
    {field_type, 3},
  [473] =
    {field_body, 7},
    {field_name, 3},
  [475] =
    {field_body, 7},
    {field_name, 4},
  [477] =
    {field_body, 7},
    {field_name, 3},
    {field_type_parameters, 4},
  [480] =
    {field_body, 6, .inherited = true},
    {field_parameters, 5},
    {field_type, 4},
  [483] =
    {field_body, 6, .inherited = true},
    {field_operator, 4},
    {field_parameters, 5},
    {field_type, 0},
  [487] =
    {field_body, 6, .inherited = true},
    {field_name, 2},
    {field_parameters, 4},
    {field_returns, 0},
    {field_type_parameters, 3},
  [492] =
    {field_accessors, 3},
    {field_name, 2},
    {field_type, 0},
    {field_value, 5},
  [496] =
    {field_body, 3, .inherited = true},
    {field_name, 2},
  [498] =
    {field_body, 6, .inherited = true},
    {field_operator, 4},
    {field_parameters, 5},
    {field_type, 1},
  [502] =
    {field_parameters, 4},
    {field_type, 1},
    {field_value, 5},
  [505] =
    {field_body, 6, .inherited = true},
    {field_name, 3},
    {field_parameters, 5},
    {field_returns, 1},
    {field_type_parameters, 4},
  [510] =
    {field_body, 6, .inherited = true},
    {field_name, 3},
    {field_parameters, 4},
    {field_returns, 1},
  [514] =
    {field_body, 6, .inherited = true},
    {field_name, 2},
    {field_parameters, 4},
    {field_returns, 1},
    {field_type_parameters, 3},
  [519] =
    {field_accessors, 3},
    {field_name, 2},
    {field_type, 1},
    {field_value, 5},
  [523] =
    {field_name, 5},
    {field_type, 3},
  [525] =
    {field_accessors, 6},
    {field_name, 5},
    {field_type, 3},
  [528] =
    {field_body, 6, .inherited = true},
    {field_operator, 4},
    {field_parameters, 5},
    {field_type, 2},
  [532] =
    {field_parameters, 4},
    {field_type, 2},
    {field_value, 5},
  [535] =
    {field_accessors, 6},
    {field_parameters, 5},
    {field_type, 2},
  [538] =
    {field_body, 6, .inherited = true},
    {field_name, 4},
    {field_parameters, 5},
    {field_returns, 2},
  [542] =
    {field_name, 4},
    {field_type, 2},
    {field_value, 5},
  [545] =
    {field_body, 6, .inherited = true},
    {field_name, 3},
    {field_parameters, 5},
    {field_returns, 2},
    {field_type_parameters, 4},
  [550] =
    {field_body, 6, .inherited = true},
    {field_name, 3},
    {field_parameters, 4},
    {field_returns, 2},
  [554] =
    {field_body, 9},
    {field_condition, 4},
    {field_initializer, 2},
    {field_update, 6},
    {field_update, 7},
  [559] =
    {field_body, 9},
    {field_initializer, 2},
    {field_initializer, 3},
    {field_update, 6},
    {field_update, 7},
  [564] =
    {field_body, 9},
    {field_condition, 5},
    {field_initializer, 2},
    {field_initializer, 3},
    {field_update, 7},
  [569] =
    {field_body, 8},
    {field_name, 3},
  [571] =
    {field_body, 8},
    {field_name, 4},
  [573] =
    {field_body, 7, .inherited = true},
    {field_parameters, 6},
    {field_type, 5},
  [576] =
    {field_body, 7, .inherited = true},
    {field_operator, 5},
    {field_parameters, 6},
    {field_type, 1},
  [580] =
    {field_body, 7, .inherited = true},
    {field_name, 3},
    {field_parameters, 5},
    {field_returns, 1},
    {field_type_parameters, 4},
  [585] =
    {field_accessors, 4},
    {field_name, 3},
    {field_type, 1},
    {field_value, 6},
  [589] =
    {field_body, 7, .inherited = true},
    {field_operator, 5},
    {field_parameters, 6},
    {field_type, 2},
  [593] =
    {field_parameters, 5},
    {field_type, 2},
    {field_value, 6},
  [596] =
    {field_body, 7, .inherited = true},
    {field_name, 4},
    {field_parameters, 6},
    {field_returns, 2},
    {field_type_parameters, 5},
  [601] =
    {field_body, 7, .inherited = true},
    {field_name, 4},
    {field_parameters, 5},
    {field_returns, 2},
  [605] =
    {field_body, 7, .inherited = true},
    {field_name, 3},
    {field_parameters, 5},
    {field_returns, 2},
    {field_type_parameters, 4},
  [610] =
    {field_accessors, 4},
    {field_name, 3},
    {field_type, 2},
    {field_value, 6},
  [614] =
    {field_body, 10},
    {field_condition, 5},
    {field_initializer, 2},
    {field_initializer, 3},
    {field_update, 7},
    {field_update, 8},
  [620] =
    {field_body, 9},
    {field_name, 4},
  [622] =
    {field_body, 8, .inherited = true},
    {field_parameters, 7},
    {field_type, 6},
  [625] =
    {field_body, 8, .inherited = true},
    {field_operator, 6},
    {field_parameters, 7},
    {field_type, 2},
  [629] =
    {field_body, 8, .inherited = true},
    {field_name, 4},
    {field_parameters, 6},
    {field_returns, 2},
    {field_type_parameters, 5},
  [634] =
    {field_accessors, 5},
    {field_name, 4},
    {field_type, 2},
    {field_value, 7},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [1] = {
    [0] = sym_modifier,
  },
  [2] = {
    [0] = alias_sym_element_binding_expression,
  },
  [3] = {
    [0] = alias_sym_implicit_parameter,
  },
  [24] = {
    [2] = alias_sym_element_binding_expression,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  sym_bracketed_argument_list, 2,
    sym_bracketed_argument_list,
    alias_sym_element_binding_expression,
  sym_identifier, 2,
    sym_identifier,
    alias_sym_implicit_parameter,
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 2,
  [4] = 4,
  [5] = 2,
  [6] = 2,
  [7] = 7,
  [8] = 8,
  [9] = 9,
  [10] = 7,
  [11] = 7,
  [12] = 7,
  [13] = 13,
  [14] = 14,
  [15] = 15,
  [16] = 16,
  [17] = 17,
  [18] = 18,
  [19] = 19,
  [20] = 20,
  [21] = 21,
  [22] = 22,
  [23] = 23,
  [24] = 24,
  [25] = 24,
  [26] = 24,
  [27] = 27,
  [28] = 28,
  [29] = 24,
  [30] = 24,
  [31] = 24,
  [32] = 24,
  [33] = 24,
  [34] = 24,
  [35] = 35,
  [36] = 24,
  [37] = 37,
  [38] = 38,
  [39] = 38,
  [40] = 40,
  [41] = 40,
  [42] = 40,
  [43] = 40,
  [44] = 38,
  [45] = 38,
  [46] = 40,
  [47] = 40,
  [48] = 38,
  [49] = 38,
  [50] = 40,
  [51] = 40,
  [52] = 38,
  [53] = 40,
  [54] = 38,
  [55] = 40,
  [56] = 38,
  [57] = 38,
  [58] = 40,
  [59] = 38,
  [60] = 60,
  [61] = 61,
  [62] = 62,
  [63] = 63,
  [64] = 64,
  [65] = 65,
  [66] = 66,
  [67] = 67,
  [68] = 68,
  [69] = 69,
  [70] = 70,
  [71] = 71,
  [72] = 72,
  [73] = 69,
  [74] = 67,
  [75] = 75,
  [76] = 70,
  [77] = 75,
  [78] = 75,
  [79] = 70,
  [80] = 69,
  [81] = 72,
  [82] = 72,
  [83] = 68,
  [84] = 66,
  [85] = 63,
  [86] = 65,
  [87] = 64,
  [88] = 65,
  [89] = 89,
  [90] = 89,
  [91] = 62,
  [92] = 64,
  [93] = 66,
  [94] = 68,
  [95] = 62,
  [96] = 96,
  [97] = 69,
  [98] = 70,
  [99] = 75,
  [100] = 72,
  [101] = 71,
  [102] = 102,
  [103] = 65,
  [104] = 104,
  [105] = 62,
  [106] = 106,
  [107] = 107,
  [108] = 104,
  [109] = 109,
  [110] = 104,
  [111] = 106,
  [112] = 96,
  [113] = 113,
  [114] = 107,
  [115] = 115,
  [116] = 60,
  [117] = 117,
  [118] = 109,
  [119] = 113,
  [120] = 61,
  [121] = 115,
  [122] = 89,
  [123] = 63,
  [124] = 67,
  [125] = 125,
  [126] = 126,
  [127] = 127,
  [128] = 125,
  [129] = 117,
  [130] = 130,
  [131] = 131,
  [132] = 132,
  [133] = 102,
  [134] = 127,
  [135] = 96,
  [136] = 130,
  [137] = 106,
  [138] = 126,
  [139] = 139,
  [140] = 96,
  [141] = 131,
  [142] = 67,
  [143] = 107,
  [144] = 68,
  [145] = 61,
  [146] = 126,
  [147] = 109,
  [148] = 113,
  [149] = 125,
  [150] = 104,
  [151] = 139,
  [152] = 132,
  [153] = 139,
  [154] = 89,
  [155] = 115,
  [156] = 106,
  [157] = 71,
  [158] = 60,
  [159] = 117,
  [160] = 71,
  [161] = 107,
  [162] = 102,
  [163] = 109,
  [164] = 139,
  [165] = 113,
  [166] = 126,
  [167] = 115,
  [168] = 66,
  [169] = 60,
  [170] = 127,
  [171] = 64,
  [172] = 63,
  [173] = 61,
  [174] = 125,
  [175] = 117,
  [176] = 130,
  [177] = 102,
  [178] = 131,
  [179] = 132,
  [180] = 131,
  [181] = 127,
  [182] = 132,
  [183] = 130,
  [184] = 184,
  [185] = 184,
  [186] = 186,
  [187] = 184,
  [188] = 184,
  [189] = 186,
  [190] = 184,
  [191] = 191,
  [192] = 192,
  [193] = 193,
  [194] = 193,
  [195] = 193,
  [196] = 193,
  [197] = 193,
  [198] = 193,
  [199] = 193,
  [200] = 193,
  [201] = 193,
  [202] = 193,
  [203] = 193,
  [204] = 193,
  [205] = 193,
  [206] = 193,
  [207] = 193,
  [208] = 193,
  [209] = 193,
  [210] = 193,
  [211] = 193,
  [212] = 193,
  [213] = 193,
  [214] = 193,
  [215] = 193,
  [216] = 193,
  [217] = 193,
  [218] = 193,
  [219] = 193,
  [220] = 193,
  [221] = 193,
  [222] = 192,
  [223] = 223,
  [224] = 223,
  [225] = 191,
  [226] = 192,
  [227] = 191,
  [228] = 192,
  [229] = 192,
  [230] = 192,
  [231] = 191,
  [232] = 191,
  [233] = 191,
  [234] = 191,
  [235] = 192,
  [236] = 192,
  [237] = 191,
  [238] = 191,
  [239] = 192,
  [240] = 191,
  [241] = 192,
  [242] = 192,
  [243] = 191,
  [244] = 191,
  [245] = 192,
  [246] = 192,
  [247] = 191,
  [248] = 248,
  [249] = 248,
  [250] = 248,
  [251] = 192,
  [252] = 191,
  [253] = 192,
  [254] = 191,
  [255] = 191,
  [256] = 192,
  [257] = 248,
  [258] = 191,
  [259] = 191,
  [260] = 191,
  [261] = 191,
  [262] = 191,
  [263] = 191,
  [264] = 192,
  [265] = 192,
  [266] = 192,
  [267] = 192,
  [268] = 192,
  [269] = 191,
  [270] = 192,
  [271] = 248,
  [272] = 191,
  [273] = 192,
  [274] = 191,
  [275] = 192,
  [276] = 192,
  [277] = 192,
  [278] = 191,
  [279] = 192,
  [280] = 192,
  [281] = 192,
  [282] = 191,
  [283] = 192,
  [284] = 192,
  [285] = 191,
  [286] = 191,
  [287] = 192,
  [288] = 191,
  [289] = 192,
  [290] = 191,
  [291] = 191,
  [292] = 191,
  [293] = 192,
  [294] = 191,
  [295] = 295,
  [296] = 192,
  [297] = 297,
  [298] = 298,
  [299] = 299,
  [300] = 298,
  [301] = 297,
  [302] = 302,
  [303] = 303,
  [304] = 297,
  [305] = 299,
  [306] = 299,
  [307] = 191,
  [308] = 191,
  [309] = 298,
  [310] = 192,
  [311] = 297,
  [312] = 299,
  [313] = 297,
  [314] = 191,
  [315] = 298,
  [316] = 191,
  [317] = 191,
  [318] = 297,
  [319] = 192,
  [320] = 302,
  [321] = 191,
  [322] = 192,
  [323] = 192,
  [324] = 192,
  [325] = 191,
  [326] = 326,
  [327] = 327,
  [328] = 327,
  [329] = 329,
  [330] = 326,
  [331] = 326,
  [332] = 327,
  [333] = 191,
  [334] = 192,
  [335] = 327,
  [336] = 191,
  [337] = 337,
  [338] = 327,
  [339] = 192,
  [340] = 191,
  [341] = 327,
  [342] = 326,
  [343] = 192,
  [344] = 191,
  [345] = 192,
  [346] = 192,
  [347] = 191,
  [348] = 191,
  [349] = 192,
  [350] = 326,
  [351] = 192,
  [352] = 337,
  [353] = 191,
  [354] = 329,
  [355] = 192,
  [356] = 326,
  [357] = 357,
  [358] = 358,
  [359] = 358,
  [360] = 358,
  [361] = 358,
  [362] = 362,
  [363] = 363,
  [364] = 364,
  [365] = 362,
  [366] = 358,
  [367] = 364,
  [368] = 363,
  [369] = 363,
  [370] = 362,
  [371] = 362,
  [372] = 362,
  [373] = 363,
  [374] = 363,
  [375] = 375,
  [376] = 376,
  [377] = 377,
  [378] = 377,
  [379] = 379,
  [380] = 380,
  [381] = 377,
  [382] = 376,
  [383] = 379,
  [384] = 375,
  [385] = 376,
  [386] = 375,
  [387] = 379,
  [388] = 377,
  [389] = 377,
  [390] = 376,
  [391] = 377,
  [392] = 379,
  [393] = 379,
  [394] = 375,
  [395] = 376,
  [396] = 379,
  [397] = 376,
  [398] = 375,
  [399] = 375,
  [400] = 376,
  [401] = 375,
  [402] = 376,
  [403] = 376,
  [404] = 379,
  [405] = 377,
  [406] = 377,
  [407] = 407,
  [408] = 376,
  [409] = 379,
  [410] = 375,
  [411] = 376,
  [412] = 376,
  [413] = 376,
  [414] = 375,
  [415] = 377,
  [416] = 376,
  [417] = 379,
  [418] = 375,
  [419] = 375,
  [420] = 379,
  [421] = 376,
  [422] = 379,
  [423] = 377,
  [424] = 375,
  [425] = 377,
  [426] = 379,
  [427] = 377,
  [428] = 376,
  [429] = 379,
  [430] = 376,
  [431] = 379,
  [432] = 376,
  [433] = 376,
  [434] = 376,
  [435] = 375,
  [436] = 376,
  [437] = 375,
  [438] = 377,
  [439] = 377,
  [440] = 375,
  [441] = 379,
  [442] = 379,
  [443] = 376,
  [444] = 377,
  [445] = 376,
  [446] = 375,
  [447] = 376,
  [448] = 375,
  [449] = 379,
  [450] = 377,
  [451] = 376,
  [452] = 376,
  [453] = 379,
  [454] = 376,
  [455] = 375,
  [456] = 379,
  [457] = 376,
  [458] = 377,
  [459] = 377,
  [460] = 376,
  [461] = 375,
  [462] = 379,
  [463] = 376,
  [464] = 376,
  [465] = 376,
  [466] = 376,
  [467] = 377,
  [468] = 377,
  [469] = 377,
  [470] = 377,
  [471] = 377,
  [472] = 379,
  [473] = 375,
  [474] = 375,
  [475] = 377,
  [476] = 375,
  [477] = 376,
  [478] = 379,
  [479] = 379,
  [480] = 379,
  [481] = 375,
  [482] = 375,
  [483] = 376,
  [484] = 377,
  [485] = 375,
  [486] = 379,
  [487] = 377,
  [488] = 376,
  [489] = 376,
  [490] = 375,
  [491] = 491,
  [492] = 376,
  [493] = 375,
  [494] = 379,
  [495] = 379,
  [496] = 377,
  [497] = 377,
  [498] = 491,
  [499] = 376,
  [500] = 376,
  [501] = 376,
  [502] = 376,
  [503] = 376,
  [504] = 379,
  [505] = 375,
  [506] = 376,
  [507] = 377,
  [508] = 375,
  [509] = 376,
  [510] = 376,
  [511] = 379,
  [512] = 512,
  [513] = 512,
  [514] = 514,
  [515] = 514,
  [516] = 514,
  [517] = 514,
  [518] = 514,
  [519] = 514,
  [520] = 514,
  [521] = 521,
  [522] = 521,
  [523] = 521,
  [524] = 521,
  [525] = 521,
  [526] = 526,
  [527] = 521,
  [528] = 521,
  [529] = 521,
  [530] = 521,
  [531] = 521,
  [532] = 521,
  [533] = 521,
  [534] = 521,
  [535] = 521,
  [536] = 521,
  [537] = 521,
  [538] = 521,
  [539] = 521,
  [540] = 521,
  [541] = 521,
  [542] = 521,
  [543] = 521,
  [544] = 521,
  [545] = 521,
  [546] = 521,
  [547] = 521,
  [548] = 521,
  [549] = 521,
  [550] = 521,
  [551] = 521,
  [552] = 521,
  [553] = 521,
  [554] = 521,
  [555] = 521,
  [556] = 521,
  [557] = 521,
  [558] = 521,
  [559] = 521,
  [560] = 521,
  [561] = 521,
  [562] = 521,
  [563] = 521,
  [564] = 521,
  [565] = 521,
  [566] = 521,
  [567] = 521,
  [568] = 521,
  [569] = 521,
  [570] = 521,
  [571] = 521,
  [572] = 521,
  [573] = 521,
  [574] = 521,
  [575] = 521,
  [576] = 521,
  [577] = 521,
  [578] = 578,
  [579] = 578,
  [580] = 578,
  [581] = 578,
  [582] = 578,
  [583] = 578,
  [584] = 578,
  [585] = 585,
  [586] = 585,
  [587] = 587,
  [588] = 585,
  [589] = 587,
  [590] = 587,
  [591] = 585,
  [592] = 592,
  [593] = 587,
  [594] = 587,
  [595] = 587,
  [596] = 585,
  [597] = 597,
  [598] = 598,
  [599] = 599,
  [600] = 597,
  [601] = 599,
  [602] = 602,
  [603] = 597,
  [604] = 597,
  [605] = 597,
  [606] = 606,
  [607] = 599,
  [608] = 598,
  [609] = 597,
  [610] = 599,
  [611] = 606,
  [612] = 612,
  [613] = 613,
  [614] = 613,
  [615] = 612,
  [616] = 616,
  [617] = 612,
  [618] = 612,
  [619] = 613,
  [620] = 612,
  [621] = 621,
  [622] = 613,
  [623] = 613,
  [624] = 612,
  [625] = 613,
  [626] = 612,
  [627] = 612,
  [628] = 628,
  [629] = 628,
  [630] = 628,
  [631] = 631,
  [632] = 628,
  [633] = 633,
  [634] = 633,
  [635] = 631,
  [636] = 636,
  [637] = 628,
  [638] = 638,
  [639] = 628,
  [640] = 640,
  [641] = 641,
  [642] = 628,
  [643] = 641,
  [644] = 628,
  [645] = 636,
  [646] = 628,
  [647] = 628,
  [648] = 628,
  [649] = 649,
  [650] = 628,
  [651] = 651,
  [652] = 628,
  [653] = 628,
  [654] = 628,
  [655] = 628,
  [656] = 633,
  [657] = 628,
  [658] = 628,
  [659] = 628,
  [660] = 640,
  [661] = 631,
  [662] = 640,
  [663] = 638,
  [664] = 628,
  [665] = 628,
  [666] = 666,
  [667] = 636,
  [668] = 628,
  [669] = 666,
  [670] = 628,
  [671] = 628,
  [672] = 628,
  [673] = 638,
  [674] = 641,
  [675] = 638,
  [676] = 628,
  [677] = 641,
  [678] = 628,
  [679] = 679,
  [680] = 628,
  [681] = 638,
  [682] = 628,
  [683] = 666,
  [684] = 633,
  [685] = 628,
  [686] = 628,
  [687] = 628,
  [688] = 628,
  [689] = 628,
  [690] = 628,
  [691] = 636,
  [692] = 628,
  [693] = 651,
  [694] = 631,
  [695] = 631,
  [696] = 666,
  [697] = 697,
  [698] = 633,
  [699] = 699,
  [700] = 628,
  [701] = 651,
  [702] = 628,
  [703] = 628,
  [704] = 638,
  [705] = 628,
  [706] = 628,
  [707] = 628,
  [708] = 628,
  [709] = 628,
  [710] = 628,
  [711] = 628,
  [712] = 651,
  [713] = 649,
  [714] = 628,
  [715] = 628,
  [716] = 640,
  [717] = 633,
  [718] = 631,
  [719] = 719,
  [720] = 720,
  [721] = 721,
  [722] = 722,
  [723] = 720,
  [724] = 722,
  [725] = 719,
  [726] = 726,
  [727] = 727,
  [728] = 728,
  [729] = 728,
  [730] = 720,
  [731] = 731,
  [732] = 732,
  [733] = 733,
  [734] = 728,
  [735] = 722,
  [736] = 719,
  [737] = 726,
  [738] = 733,
  [739] = 727,
  [740] = 721,
  [741] = 726,
  [742] = 720,
  [743] = 743,
  [744] = 744,
  [745] = 728,
  [746] = 727,
  [747] = 727,
  [748] = 726,
  [749] = 719,
  [750] = 719,
  [751] = 751,
  [752] = 752,
  [753] = 731,
  [754] = 732,
  [755] = 720,
  [756] = 733,
  [757] = 722,
  [758] = 722,
  [759] = 759,
  [760] = 722,
  [761] = 722,
  [762] = 762,
  [763] = 722,
  [764] = 759,
  [765] = 726,
  [766] = 752,
  [767] = 727,
  [768] = 751,
  [769] = 719,
  [770] = 720,
  [771] = 722,
  [772] = 733,
  [773] = 733,
  [774] = 720,
  [775] = 728,
  [776] = 722,
  [777] = 720,
  [778] = 728,
  [779] = 727,
  [780] = 722,
  [781] = 719,
  [782] = 726,
  [783] = 727,
  [784] = 726,
  [785] = 719,
  [786] = 728,
  [787] = 720,
  [788] = 733,
  [789] = 727,
  [790] = 744,
  [791] = 733,
  [792] = 743,
  [793] = 726,
  [794] = 794,
  [795] = 733,
  [796] = 796,
  [797] = 722,
  [798] = 722,
  [799] = 726,
  [800] = 727,
  [801] = 720,
  [802] = 802,
  [803] = 733,
  [804] = 728,
  [805] = 731,
  [806] = 759,
  [807] = 727,
  [808] = 732,
  [809] = 720,
  [810] = 810,
  [811] = 728,
  [812] = 728,
  [813] = 722,
  [814] = 814,
  [815] = 726,
  [816] = 727,
  [817] = 810,
  [818] = 802,
  [819] = 720,
  [820] = 722,
  [821] = 719,
  [822] = 726,
  [823] = 727,
  [824] = 726,
  [825] = 719,
  [826] = 719,
  [827] = 722,
  [828] = 733,
  [829] = 720,
  [830] = 728,
  [831] = 726,
  [832] = 722,
  [833] = 720,
  [834] = 728,
  [835] = 733,
  [836] = 719,
  [837] = 727,
  [838] = 727,
  [839] = 726,
  [840] = 721,
  [841] = 726,
  [842] = 719,
  [843] = 722,
  [844] = 722,
  [845] = 733,
  [846] = 727,
  [847] = 794,
  [848] = 719,
  [849] = 728,
  [850] = 719,
  [851] = 722,
  [852] = 728,
  [853] = 733,
  [854] = 854,
  [855] = 720,
  [856] = 733,
  [857] = 720,
  [858] = 814,
  [859] = 719,
  [860] = 726,
  [861] = 722,
  [862] = 722,
  [863] = 762,
  [864] = 733,
  [865] = 727,
  [866] = 814,
  [867] = 733,
  [868] = 728,
  [869] = 722,
  [870] = 719,
  [871] = 726,
  [872] = 721,
  [873] = 727,
  [874] = 720,
  [875] = 728,
  [876] = 720,
  [877] = 733,
  [878] = 810,
  [879] = 722,
  [880] = 719,
  [881] = 720,
  [882] = 733,
  [883] = 728,
  [884] = 720,
  [885] = 731,
  [886] = 722,
  [887] = 733,
  [888] = 728,
  [889] = 719,
  [890] = 727,
  [891] = 727,
  [892] = 726,
  [893] = 726,
  [894] = 733,
  [895] = 727,
  [896] = 728,
  [897] = 719,
  [898] = 720,
  [899] = 733,
  [900] = 726,
  [901] = 722,
  [902] = 902,
  [903] = 794,
  [904] = 722,
  [905] = 719,
  [906] = 726,
  [907] = 728,
  [908] = 727,
  [909] = 733,
  [910] = 720,
  [911] = 728,
  [912] = 728,
  [913] = 796,
  [914] = 720,
  [915] = 727,
  [916] = 733,
  [917] = 719,
  [918] = 722,
  [919] = 726,
  [920] = 719,
  [921] = 733,
  [922] = 722,
  [923] = 814,
  [924] = 722,
  [925] = 720,
  [926] = 728,
  [927] = 733,
  [928] = 733,
  [929] = 728,
  [930] = 727,
  [931] = 727,
  [932] = 726,
  [933] = 719,
  [934] = 762,
  [935] = 722,
  [936] = 733,
  [937] = 937,
  [938] = 810,
  [939] = 722,
  [940] = 722,
  [941] = 733,
  [942] = 720,
  [943] = 719,
  [944] = 722,
  [945] = 802,
  [946] = 726,
  [947] = 722,
  [948] = 720,
  [949] = 727,
  [950] = 728,
  [951] = 728,
  [952] = 722,
  [953] = 759,
  [954] = 722,
  [955] = 722,
  [956] = 719,
  [957] = 726,
  [958] = 727,
  [959] = 728,
  [960] = 727,
  [961] = 728,
  [962] = 720,
  [963] = 722,
  [964] = 733,
  [965] = 719,
  [966] = 727,
  [967] = 752,
  [968] = 751,
  [969] = 726,
  [970] = 726,
  [971] = 727,
  [972] = 719,
  [973] = 726,
  [974] = 728,
  [975] = 722,
  [976] = 720,
  [977] = 722,
  [978] = 978,
  [979] = 733,
  [980] = 733,
  [981] = 722,
  [982] = 720,
  [983] = 719,
  [984] = 726,
  [985] = 720,
  [986] = 727,
  [987] = 722,
  [988] = 728,
  [989] = 728,
  [990] = 720,
  [991] = 733,
  [992] = 733,
  [993] = 752,
  [994] = 728,
  [995] = 751,
  [996] = 722,
  [997] = 719,
  [998] = 998,
  [999] = 726,
  [1000] = 727,
  [1001] = 733,
  [1002] = 721,
  [1003] = 1003,
  [1004] = 727,
  [1005] = 720,
  [1006] = 726,
  [1007] = 719,
  [1008] = 719,
  [1009] = 728,
  [1010] = 726,
  [1011] = 731,
  [1012] = 727,
  [1013] = 726,
  [1014] = 728,
  [1015] = 727,
  [1016] = 726,
  [1017] = 744,
  [1018] = 722,
  [1019] = 719,
  [1020] = 726,
  [1021] = 727,
  [1022] = 743,
  [1023] = 722,
  [1024] = 726,
  [1025] = 719,
  [1026] = 728,
  [1027] = 727,
  [1028] = 732,
  [1029] = 733,
  [1030] = 720,
  [1031] = 722,
  [1032] = 733,
  [1033] = 720,
  [1034] = 733,
  [1035] = 722,
  [1036] = 1036,
  [1037] = 733,
  [1038] = 720,
  [1039] = 728,
  [1040] = 719,
  [1041] = 727,
  [1042] = 726,
  [1043] = 719,
  [1044] = 733,
  [1045] = 722,
  [1046] = 720,
  [1047] = 733,
  [1048] = 720,
  [1049] = 728,
  [1050] = 728,
  [1051] = 727,
  [1052] = 731,
  [1053] = 727,
  [1054] = 722,
  [1055] = 719,
  [1056] = 726,
  [1057] = 719,
  [1058] = 720,
  [1059] = 728,
  [1060] = 719,
  [1061] = 726,
  [1062] = 733,
  [1063] = 727,
  [1064] = 722,
  [1065] = 722,
  [1066] = 720,
  [1067] = 719,
  [1068] = 727,
  [1069] = 726,
  [1070] = 727,
  [1071] = 728,
  [1072] = 726,
  [1073] = 726,
  [1074] = 728,
  [1075] = 720,
  [1076] = 727,
  [1077] = 733,
  [1078] = 726,
  [1079] = 719,
  [1080] = 722,
  [1081] = 722,
  [1082] = 719,
  [1083] = 728,
  [1084] = 720,
  [1085] = 722,
  [1086] = 722,
  [1087] = 728,
  [1088] = 720,
  [1089] = 721,
  [1090] = 733,
  [1091] = 762,
  [1092] = 733,
  [1093] = 720,
  [1094] = 722,
  [1095] = 733,
  [1096] = 728,
  [1097] = 733,
  [1098] = 719,
  [1099] = 726,
  [1100] = 727,
  [1101] = 720,
  [1102] = 728,
  [1103] = 727,
  [1104] = 728,
  [1105] = 720,
  [1106] = 733,
  [1107] = 726,
  [1108] = 727,
  [1109] = 722,
  [1110] = 722,
  [1111] = 726,
  [1112] = 719,
  [1113] = 722,
  [1114] = 794,
  [1115] = 796,
  [1116] = 719,
  [1117] = 720,
  [1118] = 722,
  [1119] = 743,
  [1120] = 744,
  [1121] = 722,
  [1122] = 802,
  [1123] = 722,
  [1124] = 794,
  [1125] = 733,
  [1126] = 722,
  [1127] = 719,
  [1128] = 719,
  [1129] = 720,
  [1130] = 796,
  [1131] = 726,
  [1132] = 719,
  [1133] = 726,
  [1134] = 727,
  [1135] = 728,
  [1136] = 727,
  [1137] = 720,
  [1138] = 728,
  [1139] = 1139,
  [1140] = 1140,
  [1141] = 1141,
  [1142] = 1142,
  [1143] = 1143,
  [1144] = 1144,
  [1145] = 1145,
  [1146] = 1146,
  [1147] = 1147,
  [1148] = 1148,
  [1149] = 1149,
  [1150] = 1150,
  [1151] = 1151,
  [1152] = 1144,
  [1153] = 1153,
  [1154] = 1154,
  [1155] = 1155,
  [1156] = 1156,
  [1157] = 1146,
  [1158] = 1140,
  [1159] = 1159,
  [1160] = 1160,
  [1161] = 1161,
  [1162] = 1162,
  [1163] = 1144,
  [1164] = 1142,
  [1165] = 1165,
  [1166] = 1156,
  [1167] = 1154,
  [1168] = 1168,
  [1169] = 1169,
  [1170] = 1161,
  [1171] = 1141,
  [1172] = 1172,
  [1173] = 1173,
  [1174] = 1142,
  [1175] = 1169,
  [1176] = 1145,
  [1177] = 1155,
  [1178] = 1147,
  [1179] = 1148,
  [1180] = 1151,
  [1181] = 1153,
  [1182] = 1146,
  [1183] = 1168,
  [1184] = 1165,
  [1185] = 1144,
  [1186] = 1155,
  [1187] = 1162,
  [1188] = 1188,
  [1189] = 1160,
  [1190] = 1159,
  [1191] = 1191,
  [1192] = 1140,
  [1193] = 1162,
  [1194] = 1188,
  [1195] = 1154,
  [1196] = 1188,
  [1197] = 1154,
  [1198] = 1188,
  [1199] = 1199,
  [1200] = 1188,
  [1201] = 1140,
  [1202] = 1202,
  [1203] = 1156,
  [1204] = 1160,
  [1205] = 1159,
  [1206] = 1162,
  [1207] = 1153,
  [1208] = 1208,
  [1209] = 1140,
  [1210] = 1210,
  [1211] = 1211,
  [1212] = 1151,
  [1213] = 1165,
  [1214] = 1168,
  [1215] = 1169,
  [1216] = 1148,
  [1217] = 1161,
  [1218] = 1141,
  [1219] = 1142,
  [1220] = 1145,
  [1221] = 1147,
  [1222] = 1148,
  [1223] = 1165,
  [1224] = 1151,
  [1225] = 1168,
  [1226] = 1153,
  [1227] = 1147,
  [1228] = 1169,
  [1229] = 1161,
  [1230] = 1145,
  [1231] = 1159,
  [1232] = 1160,
  [1233] = 1142,
  [1234] = 1141,
  [1235] = 1141,
  [1236] = 1202,
  [1237] = 1199,
  [1238] = 1161,
  [1239] = 1169,
  [1240] = 1142,
  [1241] = 1168,
  [1242] = 1145,
  [1243] = 1165,
  [1244] = 1140,
  [1245] = 1162,
  [1246] = 1147,
  [1247] = 1154,
  [1248] = 1148,
  [1249] = 1154,
  [1250] = 1151,
  [1251] = 1162,
  [1252] = 1252,
  [1253] = 1140,
  [1254] = 1153,
  [1255] = 1165,
  [1256] = 1168,
  [1257] = 1169,
  [1258] = 1199,
  [1259] = 1161,
  [1260] = 1141,
  [1261] = 1142,
  [1262] = 1145,
  [1263] = 1147,
  [1264] = 1148,
  [1265] = 1151,
  [1266] = 1153,
  [1267] = 1159,
  [1268] = 1160,
  [1269] = 1202,
  [1270] = 1188,
  [1271] = 1188,
  [1272] = 1160,
  [1273] = 1159,
  [1274] = 1154,
  [1275] = 1188,
  [1276] = 1153,
  [1277] = 1151,
  [1278] = 1140,
  [1279] = 1148,
  [1280] = 1147,
  [1281] = 1159,
  [1282] = 1160,
  [1283] = 1145,
  [1284] = 1188,
  [1285] = 1188,
  [1286] = 1162,
  [1287] = 1165,
  [1288] = 1168,
  [1289] = 1169,
  [1290] = 1144,
  [1291] = 1161,
  [1292] = 1141,
  [1293] = 1142,
  [1294] = 1145,
  [1295] = 1147,
  [1296] = 1148,
  [1297] = 1151,
  [1298] = 1153,
  [1299] = 1299,
  [1300] = 1162,
  [1301] = 1141,
  [1302] = 1161,
  [1303] = 1154,
  [1304] = 1159,
  [1305] = 1156,
  [1306] = 1160,
  [1307] = 1169,
  [1308] = 1140,
  [1309] = 1188,
  [1310] = 1168,
  [1311] = 1159,
  [1312] = 1160,
  [1313] = 1165,
  [1314] = 1162,
  [1315] = 1140,
  [1316] = 1165,
  [1317] = 1168,
  [1318] = 1169,
  [1319] = 1161,
  [1320] = 1188,
  [1321] = 1141,
  [1322] = 1142,
  [1323] = 1145,
  [1324] = 1147,
  [1325] = 1148,
  [1326] = 1151,
  [1327] = 1153,
  [1328] = 1208,
  [1329] = 1188,
  [1330] = 1156,
  [1331] = 1154,
  [1332] = 1191,
  [1333] = 1153,
  [1334] = 1151,
  [1335] = 1191,
  [1336] = 1148,
  [1337] = 1147,
  [1338] = 1154,
  [1339] = 1145,
  [1340] = 1340,
  [1341] = 1142,
  [1342] = 1141,
  [1343] = 1161,
  [1344] = 1344,
  [1345] = 1156,
  [1346] = 1169,
  [1347] = 1168,
  [1348] = 1348,
  [1349] = 1165,
  [1350] = 1162,
  [1351] = 1160,
  [1352] = 1162,
  [1353] = 1208,
  [1354] = 1140,
  [1355] = 1156,
  [1356] = 1159,
  [1357] = 1165,
  [1358] = 1153,
  [1359] = 1168,
  [1360] = 1169,
  [1361] = 1160,
  [1362] = 1161,
  [1363] = 1141,
  [1364] = 1142,
  [1365] = 1145,
  [1366] = 1147,
  [1367] = 1367,
  [1368] = 1151,
  [1369] = 1148,
  [1370] = 1188,
  [1371] = 1148,
  [1372] = 1151,
  [1373] = 1159,
  [1374] = 1153,
  [1375] = 1344,
  [1376] = 1147,
  [1377] = 1140,
  [1378] = 1145,
  [1379] = 1188,
  [1380] = 1142,
  [1381] = 1141,
  [1382] = 1382,
  [1383] = 1161,
  [1384] = 1159,
  [1385] = 1160,
  [1386] = 1154,
  [1387] = 1169,
  [1388] = 1168,
  [1389] = 1165,
  [1390] = 1390,
  [1391] = 1202,
  [1392] = 1199,
  [1393] = 1160,
  [1394] = 1159,
  [1395] = 1153,
  [1396] = 1140,
  [1397] = 1151,
  [1398] = 1148,
  [1399] = 1147,
  [1400] = 1145,
  [1401] = 1142,
  [1402] = 1141,
  [1403] = 1161,
  [1404] = 1169,
  [1405] = 1168,
  [1406] = 1165,
  [1407] = 1140,
  [1408] = 1162,
  [1409] = 1154,
  [1410] = 1154,
  [1411] = 1199,
  [1412] = 1188,
  [1413] = 1188,
  [1414] = 1414,
  [1415] = 1202,
  [1416] = 1160,
  [1417] = 1159,
  [1418] = 1153,
  [1419] = 1162,
  [1420] = 1153,
  [1421] = 1151,
  [1422] = 1140,
  [1423] = 1199,
  [1424] = 1162,
  [1425] = 1165,
  [1426] = 1168,
  [1427] = 1427,
  [1428] = 1169,
  [1429] = 1148,
  [1430] = 1147,
  [1431] = 1161,
  [1432] = 1141,
  [1433] = 1191,
  [1434] = 1142,
  [1435] = 1145,
  [1436] = 1145,
  [1437] = 1147,
  [1438] = 1165,
  [1439] = 1148,
  [1440] = 1151,
  [1441] = 1162,
  [1442] = 1142,
  [1443] = 1153,
  [1444] = 1159,
  [1445] = 1160,
  [1446] = 1168,
  [1447] = 1447,
  [1448] = 1448,
  [1449] = 1141,
  [1450] = 1450,
  [1451] = 1154,
  [1452] = 1161,
  [1453] = 1169,
  [1454] = 1454,
  [1455] = 1168,
  [1456] = 1140,
  [1457] = 1165,
  [1458] = 1169,
  [1459] = 1156,
  [1460] = 1159,
  [1461] = 1160,
  [1462] = 1140,
  [1463] = 1162,
  [1464] = 1165,
  [1465] = 1161,
  [1466] = 1141,
  [1467] = 1168,
  [1468] = 1169,
  [1469] = 1154,
  [1470] = 1142,
  [1471] = 1161,
  [1472] = 1141,
  [1473] = 1145,
  [1474] = 1142,
  [1475] = 1147,
  [1476] = 1145,
  [1477] = 1147,
  [1478] = 1148,
  [1479] = 1151,
  [1480] = 1153,
  [1481] = 1148,
  [1482] = 1151,
  [1483] = 1208,
  [1484] = 1153,
  [1485] = 1154,
  [1486] = 1140,
  [1487] = 1154,
  [1488] = 1162,
  [1489] = 1160,
  [1490] = 1156,
  [1491] = 1156,
  [1492] = 1154,
  [1493] = 1140,
  [1494] = 1191,
  [1495] = 1159,
  [1496] = 1159,
  [1497] = 1160,
  [1498] = 1160,
  [1499] = 1162,
  [1500] = 1199,
  [1501] = 1165,
  [1502] = 1159,
  [1503] = 1168,
  [1504] = 1169,
  [1505] = 1161,
  [1506] = 1141,
  [1507] = 1142,
  [1508] = 1145,
  [1509] = 1147,
  [1510] = 1148,
  [1511] = 1151,
  [1512] = 1159,
  [1513] = 1153,
  [1514] = 1151,
  [1515] = 1153,
  [1516] = 1148,
  [1517] = 1147,
  [1518] = 1151,
  [1519] = 1148,
  [1520] = 1145,
  [1521] = 1142,
  [1522] = 1141,
  [1523] = 1161,
  [1524] = 1169,
  [1525] = 1168,
  [1526] = 1191,
  [1527] = 1154,
  [1528] = 1165,
  [1529] = 1154,
  [1530] = 1162,
  [1531] = 1147,
  [1532] = 1160,
  [1533] = 1533,
  [1534] = 1145,
  [1535] = 1159,
  [1536] = 1142,
  [1537] = 1141,
  [1538] = 1156,
  [1539] = 1161,
  [1540] = 1540,
  [1541] = 1160,
  [1542] = 1140,
  [1543] = 1154,
  [1544] = 1162,
  [1545] = 1169,
  [1546] = 1546,
  [1547] = 1208,
  [1548] = 1168,
  [1549] = 1140,
  [1550] = 1154,
  [1551] = 1165,
  [1552] = 1168,
  [1553] = 1169,
  [1554] = 1202,
  [1555] = 1161,
  [1556] = 1556,
  [1557] = 1141,
  [1558] = 1142,
  [1559] = 1145,
  [1560] = 1147,
  [1561] = 1148,
  [1562] = 1151,
  [1563] = 1160,
  [1564] = 1153,
  [1565] = 1159,
  [1566] = 1165,
  [1567] = 1140,
  [1568] = 1153,
  [1569] = 1191,
  [1570] = 1151,
  [1571] = 1148,
  [1572] = 1159,
  [1573] = 1160,
  [1574] = 1162,
  [1575] = 1147,
  [1576] = 1145,
  [1577] = 1142,
  [1578] = 1141,
  [1579] = 1202,
  [1580] = 1199,
  [1581] = 1161,
  [1582] = 1169,
  [1583] = 1168,
  [1584] = 1165,
  [1585] = 1585,
  [1586] = 1140,
  [1587] = 1208,
  [1588] = 1588,
  [1589] = 1154,
  [1590] = 1208,
  [1591] = 1162,
  [1592] = 1199,
  [1593] = 1156,
  [1594] = 1156,
  [1595] = 1162,
  [1596] = 1154,
  [1597] = 1191,
  [1598] = 1140,
  [1599] = 1165,
  [1600] = 1168,
  [1601] = 1169,
  [1602] = 1208,
  [1603] = 1161,
  [1604] = 1141,
  [1605] = 1142,
  [1606] = 1145,
  [1607] = 1199,
  [1608] = 1147,
  [1609] = 1148,
  [1610] = 1151,
  [1611] = 1154,
  [1612] = 1344,
  [1613] = 1162,
  [1614] = 1160,
  [1615] = 1153,
  [1616] = 1159,
  [1617] = 1160,
  [1618] = 1159,
  [1619] = 1153,
  [1620] = 1151,
  [1621] = 1154,
  [1622] = 1191,
  [1623] = 1148,
  [1624] = 1147,
  [1625] = 1145,
  [1626] = 1142,
  [1627] = 1153,
  [1628] = 1151,
  [1629] = 1154,
  [1630] = 1141,
  [1631] = 1154,
  [1632] = 1148,
  [1633] = 1161,
  [1634] = 1147,
  [1635] = 1635,
  [1636] = 1145,
  [1637] = 1344,
  [1638] = 1142,
  [1639] = 1141,
  [1640] = 1140,
  [1641] = 1169,
  [1642] = 1161,
  [1643] = 1169,
  [1644] = 1168,
  [1645] = 1165,
  [1646] = 1168,
  [1647] = 1159,
  [1648] = 1160,
  [1649] = 1165,
  [1650] = 1162,
  [1651] = 1160,
  [1652] = 1162,
  [1653] = 1140,
  [1654] = 1165,
  [1655] = 1159,
  [1656] = 1188,
  [1657] = 1168,
  [1658] = 1169,
  [1659] = 1161,
  [1660] = 1141,
  [1661] = 1162,
  [1662] = 1142,
  [1663] = 1145,
  [1664] = 1147,
  [1665] = 1148,
  [1666] = 1165,
  [1667] = 1151,
  [1668] = 1168,
  [1669] = 1153,
  [1670] = 1169,
  [1671] = 1154,
  [1672] = 1140,
  [1673] = 1161,
  [1674] = 1141,
  [1675] = 1142,
  [1676] = 1202,
  [1677] = 1145,
  [1678] = 1154,
  [1679] = 1199,
  [1680] = 1147,
  [1681] = 1156,
  [1682] = 1199,
  [1683] = 1148,
  [1684] = 1208,
  [1685] = 1140,
  [1686] = 1191,
  [1687] = 1199,
  [1688] = 1159,
  [1689] = 1151,
  [1690] = 1153,
  [1691] = 1160,
  [1692] = 1202,
  [1693] = 1693,
  [1694] = 1156,
  [1695] = 1208,
  [1696] = 1162,
  [1697] = 1697,
  [1698] = 1191,
  [1699] = 1699,
  [1700] = 1165,
  [1701] = 1168,
  [1702] = 1169,
  [1703] = 1161,
  [1704] = 1141,
  [1705] = 1162,
  [1706] = 1706,
  [1707] = 1142,
  [1708] = 1140,
  [1709] = 1145,
  [1710] = 1147,
  [1711] = 1148,
  [1712] = 1151,
  [1713] = 1153,
  [1714] = 1199,
  [1715] = 1155,
  [1716] = 1165,
  [1717] = 1202,
  [1718] = 1208,
  [1719] = 1191,
  [1720] = 1199,
  [1721] = 1202,
  [1722] = 1168,
  [1723] = 1208,
  [1724] = 1191,
  [1725] = 1199,
  [1726] = 1202,
  [1727] = 1169,
  [1728] = 1208,
  [1729] = 1191,
  [1730] = 1191,
  [1731] = 1199,
  [1732] = 1732,
  [1733] = 1154,
  [1734] = 1202,
  [1735] = 1208,
  [1736] = 1161,
  [1737] = 1191,
  [1738] = 1199,
  [1739] = 1141,
  [1740] = 1202,
  [1741] = 1199,
  [1742] = 1142,
  [1743] = 1156,
  [1744] = 1202,
  [1745] = 1199,
  [1746] = 1202,
  [1747] = 1199,
  [1748] = 1202,
  [1749] = 1145,
  [1750] = 1147,
  [1751] = 1162,
  [1752] = 1148,
  [1753] = 1208,
  [1754] = 1140,
  [1755] = 1151,
  [1756] = 1165,
  [1757] = 1168,
  [1758] = 1153,
  [1759] = 1169,
  [1760] = 1199,
  [1761] = 1161,
  [1762] = 1762,
  [1763] = 1141,
  [1764] = 1142,
  [1765] = 1145,
  [1766] = 1147,
  [1767] = 1148,
  [1768] = 1151,
  [1769] = 1202,
  [1770] = 1153,
  [1771] = 1199,
  [1772] = 1202,
  [1773] = 1199,
  [1774] = 1202,
  [1775] = 1199,
  [1776] = 1202,
  [1777] = 1199,
  [1778] = 1778,
  [1779] = 1202,
  [1780] = 1199,
  [1781] = 1159,
  [1782] = 1160,
  [1783] = 1202,
  [1784] = 1199,
  [1785] = 1159,
  [1786] = 1160,
  [1787] = 1787,
  [1788] = 1202,
  [1789] = 1144,
  [1790] = 1199,
  [1791] = 1202,
  [1792] = 1202,
  [1793] = 1199,
  [1794] = 1199,
  [1795] = 1153,
  [1796] = 1151,
  [1797] = 1797,
  [1798] = 1202,
  [1799] = 1148,
  [1800] = 1147,
  [1801] = 1145,
  [1802] = 1142,
  [1803] = 1803,
  [1804] = 1141,
  [1805] = 1202,
  [1806] = 1161,
  [1807] = 1199,
  [1808] = 1202,
  [1809] = 1169,
  [1810] = 1199,
  [1811] = 1202,
  [1812] = 1812,
  [1813] = 1199,
  [1814] = 1168,
  [1815] = 1202,
  [1816] = 1165,
  [1817] = 1140,
  [1818] = 1199,
  [1819] = 1202,
  [1820] = 1820,
  [1821] = 1199,
  [1822] = 1822,
  [1823] = 1154,
  [1824] = 1202,
  [1825] = 1787,
  [1826] = 1199,
  [1827] = 1202,
  [1828] = 1820,
  [1829] = 1188,
  [1830] = 1199,
  [1831] = 1208,
  [1832] = 1693,
  [1833] = 1162,
  [1834] = 1787,
  [1835] = 1140,
  [1836] = 1165,
  [1837] = 1820,
  [1838] = 1168,
  [1839] = 1693,
  [1840] = 1169,
  [1841] = 1414,
  [1842] = 1150,
  [1843] = 1199,
  [1844] = 1149,
  [1845] = 1160,
  [1846] = 1159,
  [1847] = 1161,
  [1848] = 1141,
  [1849] = 1142,
  [1850] = 1145,
  [1851] = 1588,
  [1852] = 1147,
  [1853] = 1148,
  [1854] = 1151,
  [1855] = 1787,
  [1856] = 1153,
  [1857] = 1159,
  [1858] = 1160,
  [1859] = 1202,
  [1860] = 1820,
  [1861] = 1778,
  [1862] = 1706,
  [1863] = 1154,
  [1864] = 1699,
  [1865] = 1697,
  [1866] = 1693,
  [1867] = 1140,
  [1868] = 1153,
  [1869] = 1151,
  [1870] = 1159,
  [1871] = 1160,
  [1872] = 1148,
  [1873] = 1162,
  [1874] = 1693,
  [1875] = 1165,
  [1876] = 1168,
  [1877] = 1169,
  [1878] = 1161,
  [1879] = 1141,
  [1880] = 1142,
  [1881] = 1881,
  [1882] = 1145,
  [1883] = 1147,
  [1884] = 1148,
  [1885] = 1151,
  [1886] = 1153,
  [1887] = 1697,
  [1888] = 1699,
  [1889] = 1706,
  [1890] = 1154,
  [1891] = 1147,
  [1892] = 1156,
  [1893] = 1145,
  [1894] = 1778,
  [1895] = 1140,
  [1896] = 1820,
  [1897] = 1142,
  [1898] = 1159,
  [1899] = 1160,
  [1900] = 1141,
  [1901] = 1787,
  [1902] = 1161,
  [1903] = 1188,
  [1904] = 1904,
  [1905] = 1150,
  [1906] = 1162,
  [1907] = 1803,
  [1908] = 1165,
  [1909] = 1169,
  [1910] = 1168,
  [1911] = 1169,
  [1912] = 1168,
  [1913] = 1165,
  [1914] = 1140,
  [1915] = 1208,
  [1916] = 1199,
  [1917] = 1156,
  [1918] = 1162,
  [1919] = 1588,
  [1920] = 1414,
  [1921] = 1149,
  [1922] = 1161,
  [1923] = 1923,
  [1924] = 1150,
  [1925] = 1925,
  [1926] = 1141,
  [1927] = 1149,
  [1928] = 1588,
  [1929] = 1142,
  [1930] = 1145,
  [1931] = 1156,
  [1932] = 1147,
  [1933] = 1787,
  [1934] = 1148,
  [1935] = 1151,
  [1936] = 1820,
  [1937] = 1778,
  [1938] = 1706,
  [1939] = 1699,
  [1940] = 1153,
  [1941] = 1635,
  [1942] = 1546,
  [1943] = 1533,
  [1944] = 1414,
  [1945] = 1154,
  [1946] = 1693,
  [1947] = 1160,
  [1948] = 1159,
  [1949] = 1153,
  [1950] = 1151,
  [1951] = 1148,
  [1952] = 1147,
  [1953] = 1145,
  [1954] = 1142,
  [1955] = 1141,
  [1956] = 1161,
  [1957] = 1169,
  [1958] = 1191,
  [1959] = 1168,
  [1960] = 1165,
  [1961] = 1154,
  [1962] = 1697,
  [1963] = 1191,
  [1964] = 1140,
  [1965] = 1162,
  [1966] = 1154,
  [1967] = 1252,
  [1968] = 1199,
  [1969] = 1199,
  [1970] = 1173,
  [1971] = 1971,
  [1972] = 1156,
  [1973] = 1160,
  [1974] = 1159,
  [1975] = 1199,
  [1976] = 1162,
  [1977] = 1153,
  [1978] = 1151,
  [1979] = 1148,
  [1980] = 1162,
  [1981] = 1199,
  [1982] = 1191,
  [1983] = 1191,
  [1984] = 1147,
  [1985] = 1985,
  [1986] = 1367,
  [1987] = 1208,
  [1988] = 1199,
  [1989] = 1140,
  [1990] = 1145,
  [1991] = 1159,
  [1992] = 1160,
  [1993] = 1208,
  [1994] = 1140,
  [1995] = 1199,
  [1996] = 1165,
  [1997] = 1168,
  [1998] = 1169,
  [1999] = 1202,
  [2000] = 1161,
  [2001] = 1141,
  [2002] = 1142,
  [2003] = 1145,
  [2004] = 1147,
  [2005] = 1148,
  [2006] = 1151,
  [2007] = 1142,
  [2008] = 1153,
  [2009] = 1162,
  [2010] = 1165,
  [2011] = 1141,
  [2012] = 1153,
  [2013] = 1151,
  [2014] = 1148,
  [2015] = 1154,
  [2016] = 1147,
  [2017] = 1156,
  [2018] = 1161,
  [2019] = 1169,
  [2020] = 1168,
  [2021] = 1165,
  [2022] = 1159,
  [2023] = 1160,
  [2024] = 1140,
  [2025] = 1162,
  [2026] = 1145,
  [2027] = 1142,
  [2028] = 1154,
  [2029] = 1141,
  [2030] = 1153,
  [2031] = 1202,
  [2032] = 1199,
  [2033] = 1151,
  [2034] = 1161,
  [2035] = 1199,
  [2036] = 1148,
  [2037] = 1202,
  [2038] = 1169,
  [2039] = 1168,
  [2040] = 1165,
  [2041] = 1168,
  [2042] = 1162,
  [2043] = 1147,
  [2044] = 1169,
  [2045] = 1925,
  [2046] = 1145,
  [2047] = 1142,
  [2048] = 1160,
  [2049] = 1141,
  [2050] = 1159,
  [2051] = 1923,
  [2052] = 1161,
  [2053] = 1161,
  [2054] = 1141,
  [2055] = 1142,
  [2056] = 1169,
  [2057] = 1168,
  [2058] = 1165,
  [2059] = 1145,
  [2060] = 1146,
  [2061] = 1162,
  [2062] = 1147,
  [2063] = 1160,
  [2064] = 1159,
  [2065] = 1140,
  [2066] = 1140,
  [2067] = 1160,
  [2068] = 1159,
  [2069] = 1154,
  [2070] = 1160,
  [2071] = 1148,
  [2072] = 2072,
  [2073] = 1151,
  [2074] = 1154,
  [2075] = 1159,
  [2076] = 1153,
  [2077] = 1156,
  [2078] = 1154,
  [2079] = 1153,
  [2080] = 1151,
  [2081] = 1162,
  [2082] = 1148,
  [2083] = 1140,
  [2084] = 1154,
  [2085] = 1165,
  [2086] = 1168,
  [2087] = 1169,
  [2088] = 1140,
  [2089] = 1161,
  [2090] = 1141,
  [2091] = 1142,
  [2092] = 1159,
  [2093] = 1160,
  [2094] = 1159,
  [2095] = 1153,
  [2096] = 1145,
  [2097] = 1151,
  [2098] = 1147,
  [2099] = 1148,
  [2100] = 1151,
  [2101] = 1153,
  [2102] = 1147,
  [2103] = 1148,
  [2104] = 1159,
  [2105] = 1160,
  [2106] = 1145,
  [2107] = 1153,
  [2108] = 1142,
  [2109] = 1151,
  [2110] = 1148,
  [2111] = 1147,
  [2112] = 1145,
  [2113] = 1142,
  [2114] = 1141,
  [2115] = 1161,
  [2116] = 1153,
  [2117] = 1169,
  [2118] = 1168,
  [2119] = 1165,
  [2120] = 1160,
  [2121] = 1147,
  [2122] = 1145,
  [2123] = 1140,
  [2124] = 1142,
  [2125] = 1208,
  [2126] = 1162,
  [2127] = 1141,
  [2128] = 1154,
  [2129] = 1161,
  [2130] = 1141,
  [2131] = 1161,
  [2132] = 1169,
  [2133] = 1168,
  [2134] = 1162,
  [2135] = 1165,
  [2136] = 1140,
  [2137] = 1165,
  [2138] = 1169,
  [2139] = 1168,
  [2140] = 1169,
  [2141] = 1165,
  [2142] = 1161,
  [2143] = 1141,
  [2144] = 1142,
  [2145] = 1145,
  [2146] = 1147,
  [2147] = 1162,
  [2148] = 1148,
  [2149] = 1151,
  [2150] = 1168,
  [2151] = 1165,
  [2152] = 1153,
  [2153] = 1140,
  [2154] = 1168,
  [2155] = 1159,
  [2156] = 1160,
  [2157] = 1162,
  [2158] = 1140,
  [2159] = 1154,
  [2160] = 1169,
  [2161] = 1154,
  [2162] = 1162,
  [2163] = 1161,
  [2164] = 1156,
  [2165] = 1141,
  [2166] = 1154,
  [2167] = 1142,
  [2168] = 1145,
  [2169] = 1156,
  [2170] = 1147,
  [2171] = 1148,
  [2172] = 1156,
  [2173] = 1151,
  [2174] = 1162,
  [2175] = 1160,
  [2176] = 1160,
  [2177] = 1159,
  [2178] = 1165,
  [2179] = 1168,
  [2180] = 1159,
  [2181] = 1140,
  [2182] = 1169,
  [2183] = 1154,
  [2184] = 1161,
  [2185] = 1141,
  [2186] = 1142,
  [2187] = 1145,
  [2188] = 1147,
  [2189] = 1148,
  [2190] = 1151,
  [2191] = 1153,
  [2192] = 2192,
  [2193] = 2193,
  [2194] = 2193,
  [2195] = 2192,
  [2196] = 2193,
  [2197] = 2192,
  [2198] = 2198,
  [2199] = 2199,
  [2200] = 2200,
  [2201] = 2198,
  [2202] = 2199,
  [2203] = 2200,
  [2204] = 2204,
  [2205] = 2205,
  [2206] = 2206,
  [2207] = 2207,
  [2208] = 2208,
  [2209] = 2209,
  [2210] = 2210,
  [2211] = 2211,
  [2212] = 2212,
  [2213] = 2213,
  [2214] = 2214,
  [2215] = 2215,
  [2216] = 2216,
  [2217] = 2217,
  [2218] = 2218,
  [2219] = 2219,
  [2220] = 2220,
  [2221] = 2221,
  [2222] = 2222,
  [2223] = 2223,
  [2224] = 2208,
  [2225] = 2225,
  [2226] = 2226,
  [2227] = 2227,
  [2228] = 2228,
  [2229] = 2229,
  [2230] = 2230,
  [2231] = 2231,
  [2232] = 2232,
  [2233] = 2233,
  [2234] = 2234,
  [2235] = 2235,
  [2236] = 2236,
  [2237] = 2206,
  [2238] = 2238,
  [2239] = 2239,
  [2240] = 2240,
  [2241] = 2241,
  [2242] = 2242,
  [2243] = 2243,
  [2244] = 2244,
  [2245] = 2245,
  [2246] = 2246,
  [2247] = 2247,
  [2248] = 2248,
  [2249] = 2249,
  [2250] = 2250,
  [2251] = 2251,
  [2252] = 2252,
  [2253] = 2253,
  [2254] = 2254,
  [2255] = 2255,
  [2256] = 2256,
  [2257] = 2257,
  [2258] = 2258,
  [2259] = 2259,
  [2260] = 2260,
  [2261] = 2261,
  [2262] = 2262,
  [2263] = 2263,
  [2264] = 2264,
  [2265] = 2265,
  [2266] = 2266,
  [2267] = 2267,
  [2268] = 2268,
  [2269] = 2269,
  [2270] = 2270,
  [2271] = 2271,
  [2272] = 2272,
  [2273] = 2273,
  [2274] = 2205,
  [2275] = 2275,
  [2276] = 2276,
  [2277] = 2277,
  [2278] = 2209,
  [2279] = 2207,
  [2280] = 2280,
  [2281] = 2281,
  [2282] = 2282,
  [2283] = 2283,
  [2284] = 2284,
  [2285] = 2285,
  [2286] = 2286,
  [2287] = 2287,
  [2288] = 2288,
  [2289] = 2289,
  [2290] = 2290,
  [2291] = 2291,
  [2292] = 2292,
  [2293] = 2293,
  [2294] = 2294,
  [2295] = 2295,
  [2296] = 2204,
  [2297] = 2297,
  [2298] = 2298,
  [2299] = 2299,
  [2300] = 2300,
  [2301] = 2301,
  [2302] = 2302,
  [2303] = 2303,
  [2304] = 2304,
  [2305] = 2305,
  [2306] = 2306,
  [2307] = 2307,
  [2308] = 2308,
  [2309] = 2309,
  [2310] = 2310,
  [2311] = 2311,
  [2312] = 2312,
  [2313] = 2313,
  [2314] = 2314,
  [2315] = 2315,
  [2316] = 2316,
  [2317] = 2317,
  [2318] = 2318,
  [2319] = 2319,
  [2320] = 2320,
  [2321] = 2321,
  [2322] = 2322,
  [2323] = 2323,
  [2324] = 2324,
  [2325] = 2325,
  [2326] = 2326,
  [2327] = 2327,
  [2328] = 2328,
  [2329] = 2329,
  [2330] = 2330,
  [2331] = 2331,
  [2332] = 2332,
  [2333] = 2333,
  [2334] = 2334,
  [2335] = 2335,
  [2336] = 2336,
  [2337] = 2337,
  [2338] = 2338,
  [2339] = 2339,
  [2340] = 2340,
  [2341] = 2341,
  [2342] = 2342,
  [2343] = 2343,
  [2344] = 2344,
  [2345] = 2345,
  [2346] = 2346,
  [2347] = 2347,
  [2348] = 2348,
  [2349] = 2349,
  [2350] = 2350,
  [2351] = 2351,
  [2352] = 2352,
  [2353] = 2353,
  [2354] = 2354,
  [2355] = 2355,
  [2356] = 2356,
  [2357] = 2357,
  [2358] = 2358,
  [2359] = 2359,
  [2360] = 2360,
  [2361] = 2361,
  [2362] = 2362,
  [2363] = 2363,
  [2364] = 2364,
  [2365] = 2365,
  [2366] = 2366,
  [2367] = 2367,
  [2368] = 2368,
  [2369] = 2369,
  [2370] = 2370,
  [2371] = 2371,
  [2372] = 2372,
  [2373] = 2373,
  [2374] = 2374,
  [2375] = 2375,
  [2376] = 2376,
  [2377] = 2377,
  [2378] = 2378,
  [2379] = 2379,
  [2380] = 2380,
  [2381] = 2381,
  [2382] = 2382,
  [2383] = 2383,
  [2384] = 2384,
  [2385] = 2385,
  [2386] = 2386,
  [2387] = 2387,
  [2388] = 2388,
  [2389] = 2389,
  [2390] = 2390,
  [2391] = 2391,
  [2392] = 2392,
  [2393] = 2393,
  [2394] = 2394,
  [2395] = 2395,
  [2396] = 2396,
  [2397] = 2397,
  [2398] = 2398,
  [2399] = 2399,
  [2400] = 2400,
  [2401] = 2401,
  [2402] = 2402,
  [2403] = 2403,
  [2404] = 2404,
  [2405] = 2405,
  [2406] = 2406,
  [2407] = 2407,
  [2408] = 2408,
  [2409] = 2409,
  [2410] = 2410,
  [2411] = 2411,
  [2412] = 2412,
  [2413] = 2413,
  [2414] = 2414,
  [2415] = 2415,
  [2416] = 2416,
  [2417] = 2417,
  [2418] = 2418,
  [2419] = 2419,
  [2420] = 2420,
  [2421] = 2421,
  [2422] = 2422,
  [2423] = 2423,
  [2424] = 2424,
  [2425] = 2275,
  [2426] = 2271,
  [2427] = 2270,
  [2428] = 2269,
  [2429] = 2225,
  [2430] = 2295,
  [2431] = 2289,
  [2432] = 2290,
  [2433] = 2252,
  [2434] = 2240,
  [2435] = 2277,
  [2436] = 2264,
  [2437] = 2265,
  [2438] = 2263,
  [2439] = 2231,
  [2440] = 2294,
  [2441] = 2260,
  [2442] = 2249,
  [2443] = 2242,
  [2444] = 2285,
  [2445] = 2251,
  [2446] = 2282,
  [2447] = 2281,
  [2448] = 2223,
  [2449] = 2222,
  [2450] = 2199,
  [2451] = 2221,
  [2452] = 2219,
  [2453] = 2218,
  [2454] = 2217,
  [2455] = 2248,
  [2456] = 2272,
  [2457] = 2261,
  [2458] = 2226,
  [2459] = 2246,
  [2460] = 2288,
  [2461] = 2227,
  [2462] = 2257,
  [2463] = 2229,
  [2464] = 2230,
  [2465] = 2256,
  [2466] = 2250,
  [2467] = 2241,
  [2468] = 2276,
  [2469] = 2268,
  [2470] = 2280,
  [2471] = 2286,
  [2472] = 2214,
  [2473] = 2243,
  [2474] = 2287,
  [2475] = 2244,
  [2476] = 2215,
  [2477] = 2245,
  [2478] = 2220,
  [2479] = 2198,
  [2480] = 2262,
  [2481] = 2284,
  [2482] = 2266,
  [2483] = 2292,
  [2484] = 2291,
  [2485] = 2293,
  [2486] = 2253,
  [2487] = 2235,
  [2488] = 2228,
  [2489] = 2254,
  [2490] = 2258,
  [2491] = 2216,
  [2492] = 2255,
  [2493] = 2267,
  [2494] = 2259,
  [2495] = 2232,
  [2496] = 2234,
  [2497] = 2238,
  [2498] = 2247,
  [2499] = 2283,
  [2500] = 2236,
  [2501] = 2273,
  [2502] = 2239,
  [2503] = 2402,
  [2504] = 2300,
  [2505] = 2317,
  [2506] = 2367,
  [2507] = 2371,
  [2508] = 2377,
  [2509] = 2315,
  [2510] = 2510,
  [2511] = 2323,
  [2512] = 2314,
  [2513] = 2313,
  [2514] = 2312,
  [2515] = 2409,
  [2516] = 2311,
  [2517] = 2410,
  [2518] = 2310,
  [2519] = 2411,
  [2520] = 2412,
  [2521] = 2413,
  [2522] = 2309,
  [2523] = 2414,
  [2524] = 2415,
  [2525] = 2362,
  [2526] = 2301,
  [2527] = 2328,
  [2528] = 2364,
  [2529] = 2420,
  [2530] = 2421,
  [2531] = 2422,
  [2532] = 2368,
  [2533] = 2423,
  [2534] = 2424,
  [2535] = 2343,
  [2536] = 2382,
  [2537] = 2305,
  [2538] = 2306,
  [2539] = 2395,
  [2540] = 2540,
  [2541] = 2419,
  [2542] = 2316,
  [2543] = 2418,
  [2544] = 2417,
  [2545] = 2329,
  [2546] = 2416,
  [2547] = 2547,
  [2548] = 2396,
  [2549] = 2394,
  [2550] = 2393,
  [2551] = 2384,
  [2552] = 2392,
  [2553] = 2408,
  [2554] = 2365,
  [2555] = 2407,
  [2556] = 2319,
  [2557] = 2557,
  [2558] = 2376,
  [2559] = 2406,
  [2560] = 2378,
  [2561] = 2369,
  [2562] = 2370,
  [2563] = 2373,
  [2564] = 2342,
  [2565] = 2565,
  [2566] = 2405,
  [2567] = 2318,
  [2568] = 2374,
  [2569] = 2375,
  [2570] = 2379,
  [2571] = 2380,
  [2572] = 2307,
  [2573] = 2322,
  [2574] = 2324,
  [2575] = 2325,
  [2576] = 2386,
  [2577] = 2361,
  [2578] = 2326,
  [2579] = 2404,
  [2580] = 2297,
  [2581] = 2308,
  [2582] = 2389,
  [2583] = 2327,
  [2584] = 2335,
  [2585] = 2388,
  [2586] = 2337,
  [2587] = 2344,
  [2588] = 2358,
  [2589] = 2387,
  [2590] = 2304,
  [2591] = 2381,
  [2592] = 2303,
  [2593] = 2299,
  [2594] = 2385,
  [2595] = 2340,
  [2596] = 2336,
  [2597] = 2339,
  [2598] = 2338,
  [2599] = 2302,
  [2600] = 2355,
  [2601] = 2383,
  [2602] = 2602,
  [2603] = 2363,
  [2604] = 2356,
  [2605] = 2298,
  [2606] = 2360,
  [2607] = 2359,
  [2608] = 2357,
  [2609] = 2354,
  [2610] = 2200,
  [2611] = 2403,
  [2612] = 2321,
  [2613] = 2401,
  [2614] = 2353,
  [2615] = 2400,
  [2616] = 2399,
  [2617] = 2320,
  [2618] = 2398,
  [2619] = 2390,
  [2620] = 2397,
  [2621] = 2391,
  [2622] = 2330,
  [2623] = 2352,
  [2624] = 2351,
  [2625] = 2350,
  [2626] = 2626,
  [2627] = 2349,
  [2628] = 2348,
  [2629] = 2331,
  [2630] = 2347,
  [2631] = 2341,
  [2632] = 2632,
  [2633] = 2334,
  [2634] = 2332,
  [2635] = 2366,
  [2636] = 2333,
  [2637] = 2205,
  [2638] = 2206,
  [2639] = 2639,
  [2640] = 2207,
  [2641] = 2209,
  [2642] = 2208,
  [2643] = 2204,
  [2644] = 2291,
  [2645] = 2234,
  [2646] = 2229,
  [2647] = 2220,
  [2648] = 2241,
  [2649] = 2270,
  [2650] = 2269,
  [2651] = 2227,
  [2652] = 2226,
  [2653] = 2286,
  [2654] = 2287,
  [2655] = 2238,
  [2656] = 2230,
  [2657] = 2235,
  [2658] = 2232,
  [2659] = 2236,
  [2660] = 2295,
  [2661] = 2293,
  [2662] = 2284,
  [2663] = 2264,
  [2664] = 2263,
  [2665] = 2239,
  [2666] = 2240,
  [2667] = 2242,
  [2668] = 2247,
  [2669] = 2231,
  [2670] = 2243,
  [2671] = 2250,
  [2672] = 2261,
  [2673] = 2265,
  [2674] = 2285,
  [2675] = 2275,
  [2676] = 2214,
  [2677] = 2246,
  [2678] = 2248,
  [2679] = 2249,
  [2680] = 2639,
  [2681] = 2225,
  [2682] = 2252,
  [2683] = 2273,
  [2684] = 2260,
  [2685] = 2266,
  [2686] = 2223,
  [2687] = 2259,
  [2688] = 2222,
  [2689] = 2221,
  [2690] = 2256,
  [2691] = 2289,
  [2692] = 2277,
  [2693] = 2257,
  [2694] = 2280,
  [2695] = 2276,
  [2696] = 2294,
  [2697] = 2219,
  [2698] = 2258,
  [2699] = 2254,
  [2700] = 2272,
  [2701] = 2292,
  [2702] = 2251,
  [2703] = 2218,
  [2704] = 2217,
  [2705] = 2290,
  [2706] = 2271,
  [2707] = 2268,
  [2708] = 2288,
  [2709] = 2228,
  [2710] = 2267,
  [2711] = 2253,
  [2712] = 2255,
  [2713] = 2281,
  [2714] = 2216,
  [2715] = 2215,
  [2716] = 2282,
  [2717] = 2283,
  [2718] = 2245,
  [2719] = 2244,
  [2720] = 2262,
  [2721] = 2721,
  [2722] = 2372,
  [2723] = 2723,
  [2724] = 2724,
  [2725] = 2724,
  [2726] = 2724,
  [2727] = 2724,
  [2728] = 2728,
  [2729] = 2724,
  [2730] = 2728,
  [2731] = 2724,
  [2732] = 2732,
  [2733] = 2733,
  [2734] = 2734,
  [2735] = 2724,
  [2736] = 2736,
  [2737] = 2737,
  [2738] = 2738,
  [2739] = 2724,
  [2740] = 2740,
  [2741] = 2741,
  [2742] = 2740,
  [2743] = 2743,
  [2744] = 2744,
  [2745] = 2728,
  [2746] = 2746,
  [2747] = 2747,
  [2748] = 2746,
  [2749] = 2747,
  [2750] = 2746,
  [2751] = 2751,
  [2752] = 2746,
  [2753] = 2743,
  [2754] = 2746,
  [2755] = 2751,
  [2756] = 2728,
  [2757] = 2728,
  [2758] = 2746,
  [2759] = 2724,
  [2760] = 2724,
  [2761] = 2751,
  [2762] = 2740,
  [2763] = 2743,
  [2764] = 2728,
  [2765] = 2724,
  [2766] = 2728,
  [2767] = 2767,
  [2768] = 2728,
  [2769] = 2769,
  [2770] = 2728,
  [2771] = 2728,
  [2772] = 2728,
  [2773] = 2773,
  [2774] = 2724,
  [2775] = 2728,
  [2776] = 2740,
  [2777] = 2746,
  [2778] = 2743,
  [2779] = 2751,
  [2780] = 2728,
  [2781] = 2781,
  [2782] = 2782,
  [2783] = 2783,
  [2784] = 2732,
  [2785] = 2785,
  [2786] = 2743,
  [2787] = 2747,
  [2788] = 2788,
  [2789] = 2747,
  [2790] = 2751,
  [2791] = 2746,
  [2792] = 2733,
  [2793] = 2724,
  [2794] = 2788,
  [2795] = 2740,
  [2796] = 2744,
  [2797] = 2785,
  [2798] = 2740,
  [2799] = 2733,
  [2800] = 2800,
  [2801] = 2788,
  [2802] = 2751,
  [2803] = 2788,
  [2804] = 2800,
  [2805] = 2805,
  [2806] = 2732,
  [2807] = 2746,
  [2808] = 2808,
  [2809] = 2809,
  [2810] = 2740,
  [2811] = 2751,
  [2812] = 2746,
  [2813] = 2738,
  [2814] = 2734,
  [2815] = 2747,
  [2816] = 2743,
  [2817] = 2751,
  [2818] = 2732,
  [2819] = 2819,
  [2820] = 2737,
  [2821] = 2740,
  [2822] = 2751,
  [2823] = 2736,
  [2824] = 2747,
  [2825] = 2746,
  [2826] = 2826,
  [2827] = 2733,
  [2828] = 2746,
  [2829] = 2746,
  [2830] = 2805,
  [2831] = 2741,
  [2832] = 2746,
  [2833] = 2833,
  [2834] = 2834,
  [2835] = 2819,
  [2836] = 2743,
  [2837] = 2746,
  [2838] = 2743,
  [2839] = 2747,
  [2840] = 2826,
  [2841] = 2746,
  [2842] = 2809,
  [2843] = 2843,
  [2844] = 2844,
  [2845] = 2747,
  [2846] = 2724,
  [2847] = 2747,
  [2848] = 2805,
  [2849] = 2746,
  [2850] = 2747,
  [2851] = 2851,
  [2852] = 2751,
  [2853] = 2853,
  [2854] = 2751,
  [2855] = 2724,
  [2856] = 2746,
  [2857] = 2746,
  [2858] = 2858,
  [2859] = 2859,
  [2860] = 2747,
  [2861] = 2751,
  [2862] = 2746,
  [2863] = 2743,
  [2864] = 2805,
  [2865] = 2746,
  [2866] = 2746,
  [2867] = 2747,
  [2868] = 2751,
  [2869] = 2869,
  [2870] = 2747,
  [2871] = 2871,
  [2872] = 2724,
  [2873] = 2724,
  [2874] = 2751,
  [2875] = 2746,
  [2876] = 2747,
  [2877] = 2877,
  [2878] = 2747,
  [2879] = 2746,
  [2880] = 2853,
  [2881] = 2881,
  [2882] = 2751,
  [2883] = 2746,
  [2884] = 2808,
  [2885] = 2746,
  [2886] = 2869,
  [2887] = 2746,
  [2888] = 2747,
  [2889] = 2746,
  [2890] = 2819,
  [2891] = 2747,
  [2892] = 2892,
  [2893] = 2851,
  [2894] = 2746,
  [2895] = 2747,
  [2896] = 2859,
  [2897] = 2897,
  [2898] = 2898,
  [2899] = 2899,
  [2900] = 2819,
  [2901] = 2901,
  [2902] = 2746,
  [2903] = 2746,
  [2904] = 2747,
  [2905] = 2746,
  [2906] = 2747,
  [2907] = 2907,
  [2908] = 2751,
  [2909] = 2909,
  [2910] = 2724,
  [2911] = 2751,
  [2912] = 2909,
  [2913] = 2913,
  [2914] = 2733,
  [2915] = 2732,
  [2916] = 2916,
  [2917] = 2743,
  [2918] = 2909,
  [2919] = 2746,
  [2920] = 2920,
  [2921] = 2909,
  [2922] = 2916,
  [2923] = 2746,
  [2924] = 2909,
  [2925] = 2744,
  [2926] = 2724,
  [2927] = 2724,
  [2928] = 2928,
  [2929] = 2929,
  [2930] = 2930,
  [2931] = 2785,
  [2932] = 2746,
  [2933] = 2724,
  [2934] = 2734,
  [2935] = 2751,
  [2936] = 2936,
  [2937] = 2937,
  [2938] = 2746,
  [2939] = 2751,
  [2940] = 2751,
  [2941] = 2746,
  [2942] = 2788,
  [2943] = 2736,
  [2944] = 2751,
  [2945] = 2744,
  [2946] = 2788,
  [2947] = 2737,
  [2948] = 2746,
  [2949] = 2949,
  [2950] = 2950,
  [2951] = 2951,
  [2952] = 2950,
  [2953] = 2741,
  [2954] = 2724,
  [2955] = 2751,
  [2956] = 2738,
  [2957] = 2751,
  [2958] = 2788,
  [2959] = 2959,
  [2960] = 2746,
  [2961] = 2724,
  [2962] = 2962,
  [2963] = 2962,
  [2964] = 2751,
  [2965] = 2788,
  [2966] = 2966,
  [2967] = 2746,
  [2968] = 2751,
  [2969] = 2746,
  [2970] = 2785,
  [2971] = 2971,
  [2972] = 2972,
  [2973] = 2973,
  [2974] = 2974,
  [2975] = 2975,
  [2976] = 2746,
  [2977] = 2977,
  [2978] = 2724,
  [2979] = 2736,
  [2980] = 2980,
  [2981] = 2724,
  [2982] = 2738,
  [2983] = 2983,
  [2984] = 2984,
  [2985] = 2724,
  [2986] = 2724,
  [2987] = 2732,
  [2988] = 2988,
  [2989] = 2724,
  [2990] = 2990,
  [2991] = 2724,
  [2992] = 2992,
  [2993] = 2733,
  [2994] = 2994,
  [2995] = 2992,
  [2996] = 2996,
  [2997] = 2992,
  [2998] = 2741,
  [2999] = 2724,
  [3000] = 3000,
  [3001] = 2724,
  [3002] = 3002,
  [3003] = 3003,
  [3004] = 3004,
  [3005] = 3005,
  [3006] = 3006,
  [3007] = 3007,
  [3008] = 3008,
  [3009] = 3009,
  [3010] = 3010,
  [3011] = 3011,
  [3012] = 2734,
  [3013] = 2737,
  [3014] = 2988,
  [3015] = 3009,
  [3016] = 2788,
  [3017] = 2785,
  [3018] = 2788,
  [3019] = 2785,
  [3020] = 3010,
  [3021] = 2785,
  [3022] = 2788,
  [3023] = 2996,
  [3024] = 2788,
  [3025] = 2788,
  [3026] = 2788,
  [3027] = 2788,
  [3028] = 3000,
  [3029] = 2785,
  [3030] = 2785,
  [3031] = 2788,
  [3032] = 2788,
  [3033] = 2788,
  [3034] = 2785,
  [3035] = 2788,
  [3036] = 2785,
  [3037] = 2788,
  [3038] = 2788,
  [3039] = 3007,
  [3040] = 3003,
  [3041] = 2785,
  [3042] = 3006,
  [3043] = 2788,
  [3044] = 2785,
  [3045] = 2788,
  [3046] = 2788,
  [3047] = 2826,
  [3048] = 2788,
  [3049] = 2785,
  [3050] = 2788,
  [3051] = 2724,
  [3052] = 2788,
  [3053] = 2809,
  [3054] = 2788,
  [3055] = 2788,
  [3056] = 2788,
  [3057] = 2785,
  [3058] = 2785,
  [3059] = 2826,
  [3060] = 2724,
  [3061] = 2785,
  [3062] = 2788,
  [3063] = 2788,
  [3064] = 2785,
  [3065] = 2785,
  [3066] = 2785,
  [3067] = 2724,
  [3068] = 2785,
  [3069] = 2724,
  [3070] = 2809,
  [3071] = 2788,
  [3072] = 2724,
  [3073] = 2788,
  [3074] = 2724,
  [3075] = 2788,
  [3076] = 2788,
  [3077] = 2788,
  [3078] = 2788,
  [3079] = 3079,
  [3080] = 3080,
  [3081] = 2809,
  [3082] = 3082,
  [3083] = 3079,
  [3084] = 3084,
  [3085] = 2920,
  [3086] = 3084,
  [3087] = 3087,
  [3088] = 3082,
  [3089] = 2920,
  [3090] = 3079,
  [3091] = 3091,
  [3092] = 2843,
  [3093] = 3087,
  [3094] = 3087,
  [3095] = 2826,
  [3096] = 2826,
  [3097] = 3084,
  [3098] = 3091,
  [3099] = 3079,
  [3100] = 3082,
  [3101] = 3080,
  [3102] = 2809,
  [3103] = 3087,
  [3104] = 3082,
  [3105] = 3080,
  [3106] = 3080,
  [3107] = 3084,
  [3108] = 2853,
  [3109] = 2809,
  [3110] = 2826,
  [3111] = 2853,
  [3112] = 3112,
  [3113] = 2851,
  [3114] = 2826,
  [3115] = 2869,
  [3116] = 2859,
  [3117] = 2859,
  [3118] = 3112,
  [3119] = 2809,
  [3120] = 2869,
  [3121] = 3112,
  [3122] = 3112,
  [3123] = 2809,
  [3124] = 2851,
  [3125] = 2826,
  [3126] = 2913,
  [3127] = 2733,
  [3128] = 2277,
  [3129] = 2853,
  [3130] = 2869,
  [3131] = 2809,
  [3132] = 2809,
  [3133] = 2913,
  [3134] = 2826,
  [3135] = 2744,
  [3136] = 2826,
  [3137] = 2983,
  [3138] = 2851,
  [3139] = 2809,
  [3140] = 2809,
  [3141] = 2826,
  [3142] = 2250,
  [3143] = 2869,
  [3144] = 2256,
  [3145] = 2826,
  [3146] = 2732,
  [3147] = 2859,
  [3148] = 2851,
  [3149] = 2809,
  [3150] = 2809,
  [3151] = 2809,
  [3152] = 3004,
  [3153] = 2809,
  [3154] = 2826,
  [3155] = 2826,
  [3156] = 2853,
  [3157] = 2826,
  [3158] = 2826,
  [3159] = 2859,
  [3160] = 2936,
  [3161] = 2992,
  [3162] = 2853,
  [3163] = 2733,
  [3164] = 2992,
  [3165] = 2732,
  [3166] = 2734,
  [3167] = 3002,
  [3168] = 2743,
  [3169] = 2869,
  [3170] = 2859,
  [3171] = 2732,
  [3172] = 3011,
  [3173] = 2853,
  [3174] = 3011,
  [3175] = 2859,
  [3176] = 3176,
  [3177] = 2869,
  [3178] = 2992,
  [3179] = 2851,
  [3180] = 3180,
  [3181] = 3181,
  [3182] = 2851,
  [3183] = 3006,
  [3184] = 3008,
  [3185] = 2996,
  [3186] = 3010,
  [3187] = 2733,
  [3188] = 3188,
  [3189] = 3003,
  [3190] = 3007,
  [3191] = 2988,
  [3192] = 2851,
  [3193] = 2959,
  [3194] = 2859,
  [3195] = 2733,
  [3196] = 2853,
  [3197] = 2732,
  [3198] = 3198,
  [3199] = 2869,
  [3200] = 3200,
  [3201] = 2980,
  [3202] = 3202,
  [3203] = 2744,
  [3204] = 2744,
  [3205] = 2738,
  [3206] = 3009,
  [3207] = 2736,
  [3208] = 3208,
  [3209] = 3000,
  [3210] = 2741,
  [3211] = 3211,
  [3212] = 2737,
  [3213] = 2387,
  [3214] = 2362,
  [3215] = 2859,
  [3216] = 2869,
  [3217] = 3217,
  [3218] = 2383,
  [3219] = 2928,
  [3220] = 3220,
  [3221] = 2380,
  [3222] = 2381,
  [3223] = 2390,
  [3224] = 3224,
  [3225] = 2205,
  [3226] = 2308,
  [3227] = 2851,
  [3228] = 3228,
  [3229] = 2333,
  [3230] = 2206,
  [3231] = 2391,
  [3232] = 3232,
  [3233] = 2741,
  [3234] = 3234,
  [3235] = 2307,
  [3236] = 2304,
  [3237] = 3237,
  [3238] = 3238,
  [3239] = 2851,
  [3240] = 2397,
  [3241] = 2398,
  [3242] = 3242,
  [3243] = 2303,
  [3244] = 3244,
  [3245] = 3245,
  [3246] = 3246,
  [3247] = 3247,
  [3248] = 3248,
  [3249] = 3249,
  [3250] = 2399,
  [3251] = 2400,
  [3252] = 2401,
  [3253] = 2402,
  [3254] = 2297,
  [3255] = 2379,
  [3256] = 2302,
  [3257] = 3010,
  [3258] = 3258,
  [3259] = 2405,
  [3260] = 3260,
  [3261] = 3261,
  [3262] = 2300,
  [3263] = 2299,
  [3264] = 2403,
  [3265] = 3265,
  [3266] = 3266,
  [3267] = 3267,
  [3268] = 2859,
  [3269] = 3269,
  [3270] = 2338,
  [3271] = 3271,
  [3272] = 3272,
  [3273] = 2853,
  [3274] = 3274,
  [3275] = 3275,
  [3276] = 2339,
  [3277] = 3202,
  [3278] = 3278,
  [3279] = 2737,
  [3280] = 3280,
  [3281] = 3281,
  [3282] = 3282,
  [3283] = 2406,
  [3284] = 3284,
  [3285] = 2340,
  [3286] = 2407,
  [3287] = 3287,
  [3288] = 3288,
  [3289] = 2342,
  [3290] = 2881,
  [3291] = 2343,
  [3292] = 3292,
  [3293] = 3293,
  [3294] = 3294,
  [3295] = 2408,
  [3296] = 3296,
  [3297] = 3297,
  [3298] = 2409,
  [3299] = 3299,
  [3300] = 3300,
  [3301] = 2328,
  [3302] = 3302,
  [3303] = 2329,
  [3304] = 3304,
  [3305] = 2330,
  [3306] = 2331,
  [3307] = 2332,
  [3308] = 2962,
  [3309] = 2410,
  [3310] = 3310,
  [3311] = 3311,
  [3312] = 2334,
  [3313] = 2336,
  [3314] = 2738,
  [3315] = 3315,
  [3316] = 3316,
  [3317] = 2736,
  [3318] = 2411,
  [3319] = 2992,
  [3320] = 2869,
  [3321] = 2412,
  [3322] = 2413,
  [3323] = 3323,
  [3324] = 3324,
  [3325] = 3325,
  [3326] = 3326,
  [3327] = 3327,
  [3328] = 2414,
  [3329] = 2734,
  [3330] = 3330,
  [3331] = 3331,
  [3332] = 2415,
  [3333] = 2741,
  [3334] = 2375,
  [3335] = 3335,
  [3336] = 2737,
  [3337] = 2992,
  [3338] = 2420,
  [3339] = 2421,
  [3340] = 2871,
  [3341] = 2734,
  [3342] = 2892,
  [3343] = 3343,
  [3344] = 2851,
  [3345] = 2422,
  [3346] = 2859,
  [3347] = 3347,
  [3348] = 2949,
  [3349] = 2853,
  [3350] = 2869,
  [3351] = 3351,
  [3352] = 3352,
  [3353] = 2736,
  [3354] = 2929,
  [3355] = 3355,
  [3356] = 3356,
  [3357] = 2980,
  [3358] = 3358,
  [3359] = 2423,
  [3360] = 2424,
  [3361] = 2419,
  [3362] = 2851,
  [3363] = 2859,
  [3364] = 2355,
  [3365] = 2418,
  [3366] = 3366,
  [3367] = 2417,
  [3368] = 2877,
  [3369] = 2853,
  [3370] = 2869,
  [3371] = 2897,
  [3372] = 2416,
  [3373] = 3373,
  [3374] = 2356,
  [3375] = 2357,
  [3376] = 3376,
  [3377] = 2901,
  [3378] = 2907,
  [3379] = 2899,
  [3380] = 3008,
  [3381] = 3381,
  [3382] = 3382,
  [3383] = 3383,
  [3384] = 3384,
  [3385] = 3385,
  [3386] = 2851,
  [3387] = 3387,
  [3388] = 3388,
  [3389] = 2859,
  [3390] = 2853,
  [3391] = 2869,
  [3392] = 2732,
  [3393] = 2396,
  [3394] = 2358,
  [3395] = 2394,
  [3396] = 2966,
  [3397] = 2733,
  [3398] = 2361,
  [3399] = 2378,
  [3400] = 2364,
  [3401] = 3401,
  [3402] = 2393,
  [3403] = 2898,
  [3404] = 2738,
  [3405] = 2851,
  [3406] = 2368,
  [3407] = 3407,
  [3408] = 2369,
  [3409] = 2859,
  [3410] = 2853,
  [3411] = 2962,
  [3412] = 3412,
  [3413] = 3413,
  [3414] = 2639,
  [3415] = 2370,
  [3416] = 2392,
  [3417] = 2389,
  [3418] = 2869,
  [3419] = 2937,
  [3420] = 3006,
  [3421] = 3007,
  [3422] = 3422,
  [3423] = 2388,
  [3424] = 2385,
  [3425] = 2384,
  [3426] = 2382,
  [3427] = 3427,
  [3428] = 3003,
  [3429] = 2992,
  [3430] = 2977,
  [3431] = 2377,
  [3432] = 2371,
  [3433] = 2367,
  [3434] = 2975,
  [3435] = 2974,
  [3436] = 2973,
  [3437] = 2366,
  [3438] = 2365,
  [3439] = 2363,
  [3440] = 2298,
  [3441] = 3441,
  [3442] = 2360,
  [3443] = 2359,
  [3444] = 2354,
  [3445] = 2972,
  [3446] = 3446,
  [3447] = 3447,
  [3448] = 2353,
  [3449] = 3449,
  [3450] = 3002,
  [3451] = 2869,
  [3452] = 2853,
  [3453] = 3453,
  [3454] = 2859,
  [3455] = 2988,
  [3456] = 3456,
  [3457] = 2951,
  [3458] = 3458,
  [3459] = 3459,
  [3460] = 2352,
  [3461] = 3461,
  [3462] = 2373,
  [3463] = 2351,
  [3464] = 2930,
  [3465] = 3465,
  [3466] = 2851,
  [3467] = 2350,
  [3468] = 3468,
  [3469] = 2349,
  [3470] = 2348,
  [3471] = 2347,
  [3472] = 3472,
  [3473] = 3473,
  [3474] = 3474,
  [3475] = 2341,
  [3476] = 2337,
  [3477] = 2374,
  [3478] = 2335,
  [3479] = 2327,
  [3480] = 2869,
  [3481] = 3009,
  [3482] = 3482,
  [3483] = 2853,
  [3484] = 2859,
  [3485] = 2326,
  [3486] = 2325,
  [3487] = 2851,
  [3488] = 2324,
  [3489] = 2322,
  [3490] = 2319,
  [3491] = 2316,
  [3492] = 2321,
  [3493] = 3000,
  [3494] = 2404,
  [3495] = 2306,
  [3496] = 2996,
  [3497] = 2320,
  [3498] = 2305,
  [3499] = 3499,
  [3500] = 2301,
  [3501] = 2853,
  [3502] = 2309,
  [3503] = 2310,
  [3504] = 2311,
  [3505] = 2312,
  [3506] = 2313,
  [3507] = 2317,
  [3508] = 3508,
  [3509] = 2315,
  [3510] = 3510,
  [3511] = 2314,
  [3512] = 2971,
  [3513] = 2990,
  [3514] = 2983,
  [3515] = 2984,
  [3516] = 3005,
  [3517] = 3004,
  [3518] = 2994,
  [3519] = 2992,
  [3520] = 2992,
  [3521] = 2992,
  [3522] = 2962,
  [3523] = 2992,
  [3524] = 2992,
  [3525] = 2992,
  [3526] = 2959,
  [3527] = 2936,
  [3528] = 2205,
  [3529] = 3000,
  [3530] = 2206,
  [3531] = 2992,
  [3532] = 2992,
  [3533] = 2992,
  [3534] = 2992,
  [3535] = 3535,
  [3536] = 2992,
  [3537] = 2962,
  [3538] = 2992,
  [3539] = 3007,
  [3540] = 2992,
  [3541] = 2992,
  [3542] = 3004,
  [3543] = 2983,
  [3544] = 3010,
  [3545] = 3545,
  [3546] = 3546,
  [3547] = 2744,
  [3548] = 3202,
  [3549] = 3549,
  [3550] = 3550,
  [3551] = 3009,
  [3552] = 2980,
  [3553] = 3553,
  [3554] = 3011,
  [3555] = 2732,
  [3556] = 3556,
  [3557] = 3557,
  [3558] = 2733,
  [3559] = 3003,
  [3560] = 3006,
  [3561] = 3561,
  [3562] = 2988,
  [3563] = 2996,
  [3564] = 3550,
  [3565] = 3565,
  [3566] = 3550,
  [3567] = 2743,
  [3568] = 2733,
  [3569] = 2898,
  [3570] = 2744,
  [3571] = 2901,
  [3572] = 3545,
  [3573] = 2907,
  [3574] = 2899,
  [3575] = 2951,
  [3576] = 3576,
  [3577] = 2972,
  [3578] = 2937,
  [3579] = 2743,
  [3580] = 2897,
  [3581] = 3581,
  [3582] = 3561,
  [3583] = 2973,
  [3584] = 3584,
  [3585] = 2974,
  [3586] = 2741,
  [3587] = 2975,
  [3588] = 3588,
  [3589] = 2930,
  [3590] = 2913,
  [3591] = 2732,
  [3592] = 2977,
  [3593] = 2949,
  [3594] = 3594,
  [3595] = 2877,
  [3596] = 2881,
  [3597] = 3546,
  [3598] = 2892,
  [3599] = 3599,
  [3600] = 2966,
  [3601] = 3601,
  [3602] = 2734,
  [3603] = 2871,
  [3604] = 2737,
  [3605] = 2736,
  [3606] = 3553,
  [3607] = 3561,
  [3608] = 2738,
  [3609] = 3609,
  [3610] = 2971,
  [3611] = 2929,
  [3612] = 3612,
  [3613] = 3613,
  [3614] = 3614,
  [3615] = 3615,
  [3616] = 3616,
  [3617] = 3617,
  [3618] = 2974,
  [3619] = 3619,
  [3620] = 3620,
  [3621] = 3621,
  [3622] = 3622,
  [3623] = 3623,
  [3624] = 3624,
  [3625] = 3625,
  [3626] = 3626,
  [3627] = 3627,
  [3628] = 3628,
  [3629] = 2971,
  [3630] = 3630,
  [3631] = 2737,
  [3632] = 3632,
  [3633] = 2973,
  [3634] = 3634,
  [3635] = 2977,
  [3636] = 2899,
  [3637] = 3637,
  [3638] = 3638,
  [3639] = 3639,
  [3640] = 3640,
  [3641] = 2907,
  [3642] = 2206,
  [3643] = 2901,
  [3644] = 2205,
  [3645] = 3645,
  [3646] = 3646,
  [3647] = 3647,
  [3648] = 2951,
  [3649] = 3649,
  [3650] = 3650,
  [3651] = 3651,
  [3652] = 2877,
  [3653] = 2972,
  [3654] = 3654,
  [3655] = 3655,
  [3656] = 3656,
  [3657] = 2736,
  [3658] = 2937,
  [3659] = 3659,
  [3660] = 3660,
  [3661] = 2975,
  [3662] = 2930,
  [3663] = 2892,
  [3664] = 3664,
  [3665] = 3665,
  [3666] = 2897,
  [3667] = 3667,
  [3668] = 2734,
  [3669] = 3669,
  [3670] = 3670,
  [3671] = 3671,
  [3672] = 3672,
  [3673] = 3673,
  [3674] = 3674,
  [3675] = 3675,
  [3676] = 2929,
  [3677] = 3677,
  [3678] = 3678,
  [3679] = 3679,
  [3680] = 3680,
  [3681] = 3681,
  [3682] = 3682,
  [3683] = 3683,
  [3684] = 3684,
  [3685] = 3685,
  [3686] = 3686,
  [3687] = 2741,
  [3688] = 3688,
  [3689] = 3689,
  [3690] = 3690,
  [3691] = 3561,
  [3692] = 3692,
  [3693] = 3693,
  [3694] = 2966,
  [3695] = 3695,
  [3696] = 2639,
  [3697] = 3697,
  [3698] = 2881,
  [3699] = 2871,
  [3700] = 2949,
  [3701] = 3701,
  [3702] = 3702,
  [3703] = 2192,
  [3704] = 3704,
  [3705] = 3705,
  [3706] = 2898,
  [3707] = 3707,
  [3708] = 2738,
  [3709] = 3709,
  [3710] = 3710,
  [3711] = 3711,
  [3712] = 3712,
  [3713] = 3655,
  [3714] = 3656,
  [3715] = 3684,
  [3716] = 3681,
  [3717] = 3612,
  [3718] = 3679,
  [3719] = 3685,
  [3720] = 3651,
  [3721] = 3639,
  [3722] = 3707,
  [3723] = 3678,
  [3724] = 3711,
  [3725] = 3654,
  [3726] = 3650,
  [3727] = 3645,
  [3728] = 3634,
  [3729] = 3660,
  [3730] = 3730,
  [3731] = 3712,
  [3732] = 3647,
  [3733] = 3675,
  [3734] = 3646,
  [3735] = 3561,
  [3736] = 3561,
  [3737] = 3709,
  [3738] = 3638,
  [3739] = 3739,
  [3740] = 3702,
  [3741] = 3637,
  [3742] = 3630,
  [3743] = 2192,
  [3744] = 3202,
  [3745] = 3667,
  [3746] = 3746,
  [3747] = 3671,
  [3748] = 3672,
  [3749] = 3705,
  [3750] = 3561,
  [3751] = 3615,
  [3752] = 3623,
  [3753] = 3753,
  [3754] = 3622,
  [3755] = 3710,
  [3756] = 3616,
  [3757] = 3757,
  [3758] = 3758,
  [3759] = 3665,
  [3760] = 3620,
  [3761] = 3621,
  [3762] = 3688,
  [3763] = 3686,
  [3764] = 3613,
  [3765] = 3682,
  [3766] = 3766,
  [3767] = 3632,
  [3768] = 3008,
  [3769] = 3683,
  [3770] = 3002,
  [3771] = 3680,
  [3772] = 3625,
  [3773] = 3677,
  [3774] = 3673,
  [3775] = 3202,
  [3776] = 2639,
  [3777] = 3561,
  [3778] = 3778,
  [3779] = 3779,
  [3780] = 3780,
  [3781] = 3781,
  [3782] = 3535,
  [3783] = 3010,
  [3784] = 3784,
  [3785] = 3785,
  [3786] = 3561,
  [3787] = 2913,
  [3788] = 3788,
  [3789] = 3789,
  [3790] = 3546,
  [3791] = 3789,
  [3792] = 3789,
  [3793] = 3789,
  [3794] = 3789,
  [3795] = 3789,
  [3796] = 3561,
  [3797] = 3789,
  [3798] = 3789,
  [3799] = 3789,
  [3800] = 3789,
  [3801] = 3789,
  [3802] = 3789,
  [3803] = 3789,
  [3804] = 3789,
  [3805] = 3789,
  [3806] = 3789,
  [3807] = 3789,
  [3808] = 3789,
  [3809] = 3809,
  [3810] = 3789,
  [3811] = 3789,
  [3812] = 3789,
  [3813] = 3813,
  [3814] = 3789,
  [3815] = 3789,
  [3816] = 3789,
  [3817] = 3789,
  [3818] = 3545,
  [3819] = 3789,
  [3820] = 3789,
  [3821] = 2744,
  [3822] = 3556,
  [3823] = 3601,
  [3824] = 3553,
  [3825] = 3789,
  [3826] = 3565,
  [3827] = 3813,
  [3828] = 3789,
  [3829] = 3561,
  [3830] = 3789,
  [3831] = 3789,
  [3832] = 3789,
  [3833] = 3789,
  [3834] = 3809,
  [3835] = 3789,
  [3836] = 3789,
  [3837] = 3837,
  [3838] = 2733,
  [3839] = 3789,
  [3840] = 3837,
  [3841] = 3789,
  [3842] = 3789,
  [3843] = 3789,
  [3844] = 3789,
  [3845] = 3789,
  [3846] = 3789,
  [3847] = 3535,
  [3848] = 3789,
  [3849] = 3557,
  [3850] = 2732,
  [3851] = 3789,
  [3852] = 3789,
  [3853] = 2744,
  [3854] = 3789,
  [3855] = 3789,
  [3856] = 3202,
  [3857] = 3789,
  [3858] = 3561,
  [3859] = 2743,
  [3860] = 2929,
  [3861] = 2897,
  [3862] = 2980,
  [3863] = 3561,
  [3864] = 2996,
  [3865] = 3594,
  [3866] = 3561,
  [3867] = 3000,
  [3868] = 3546,
  [3869] = 2744,
  [3870] = 3009,
  [3871] = 2639,
  [3872] = 3010,
  [3873] = 2733,
  [3874] = 2738,
  [3875] = 2732,
  [3876] = 2877,
  [3877] = 2736,
  [3878] = 2871,
  [3879] = 2734,
  [3880] = 2741,
  [3881] = 2881,
  [3882] = 3599,
  [3883] = 3609,
  [3884] = 2737,
  [3885] = 2737,
  [3886] = 2988,
  [3887] = 2966,
  [3888] = 2937,
  [3889] = 2972,
  [3890] = 2951,
  [3891] = 2913,
  [3892] = 3576,
  [3893] = 3581,
  [3894] = 2741,
  [3895] = 2734,
  [3896] = 3599,
  [3897] = 2733,
  [3898] = 2732,
  [3899] = 3561,
  [3900] = 3545,
  [3901] = 3556,
  [3902] = 3557,
  [3903] = 3553,
  [3904] = 3581,
  [3905] = 2732,
  [3906] = 3609,
  [3907] = 2971,
  [3908] = 2733,
  [3909] = 2736,
  [3910] = 3594,
  [3911] = 3006,
  [3912] = 2977,
  [3913] = 3202,
  [3914] = 2738,
  [3915] = 2898,
  [3916] = 2975,
  [3917] = 2974,
  [3918] = 2973,
  [3919] = 2949,
  [3920] = 3011,
  [3921] = 3003,
  [3922] = 3565,
  [3923] = 2892,
  [3924] = 3007,
  [3925] = 3002,
  [3926] = 3008,
  [3927] = 2899,
  [3928] = 2743,
  [3929] = 3576,
  [3930] = 2907,
  [3931] = 2901,
  [3932] = 2930,
  [3933] = 3619,
  [3934] = 3632,
  [3935] = 3619,
  [3936] = 2966,
  [3937] = 2974,
  [3938] = 3685,
  [3939] = 3679,
  [3940] = 3672,
  [3941] = 3671,
  [3942] = 3614,
  [3943] = 3624,
  [3944] = 3637,
  [3945] = 2881,
  [3946] = 2929,
  [3947] = 3634,
  [3948] = 3948,
  [3949] = 3628,
  [3950] = 2975,
  [3951] = 2871,
  [3952] = 3952,
  [3953] = 2877,
  [3954] = 2898,
  [3955] = 2977,
  [3956] = 3625,
  [3957] = 3680,
  [3958] = 3958,
  [3959] = 3616,
  [3960] = 3627,
  [3961] = 3656,
  [3962] = 2973,
  [3963] = 2972,
  [3964] = 2951,
  [3965] = 3965,
  [3966] = 3613,
  [3967] = 3692,
  [3968] = 3701,
  [3969] = 3617,
  [3970] = 3664,
  [3971] = 3670,
  [3972] = 3660,
  [3973] = 3681,
  [3974] = 3667,
  [3975] = 3674,
  [3976] = 3711,
  [3977] = 3615,
  [3978] = 3620,
  [3979] = 3979,
  [3980] = 3621,
  [3981] = 3622,
  [3982] = 3693,
  [3983] = 3948,
  [3984] = 3695,
  [3985] = 2971,
  [3986] = 3601,
  [3987] = 3665,
  [3988] = 3649,
  [3989] = 2913,
  [3990] = 3659,
  [3991] = 3673,
  [3992] = 3675,
  [3993] = 3993,
  [3994] = 3623,
  [3995] = 2892,
  [3996] = 3682,
  [3997] = 3997,
  [3998] = 3630,
  [3999] = 2949,
  [4000] = 2937,
  [4001] = 3697,
  [4002] = 3561,
  [4003] = 3638,
  [4004] = 3639,
  [4005] = 4005,
  [4006] = 3626,
  [4007] = 3650,
  [4008] = 3561,
  [4009] = 3958,
  [4010] = 4010,
  [4011] = 4011,
  [4012] = 3647,
  [4013] = 4013,
  [4014] = 3692,
  [4015] = 4015,
  [4016] = 4016,
  [4017] = 4017,
  [4018] = 3646,
  [4019] = 3561,
  [4020] = 4020,
  [4021] = 4021,
  [4022] = 3645,
  [4023] = 4023,
  [4024] = 3678,
  [4025] = 4025,
  [4026] = 2897,
  [4027] = 3684,
  [4028] = 2930,
  [4029] = 3702,
  [4030] = 2734,
  [4031] = 2737,
  [4032] = 3712,
  [4033] = 3710,
  [4034] = 2901,
  [4035] = 4035,
  [4036] = 2907,
  [4037] = 2741,
  [4038] = 4038,
  [4039] = 4039,
  [4040] = 2899,
  [4041] = 3651,
  [4042] = 3709,
  [4043] = 4043,
  [4044] = 2206,
  [4045] = 2205,
  [4046] = 2736,
  [4047] = 2738,
  [4048] = 3707,
  [4049] = 3654,
  [4050] = 3612,
  [4051] = 4051,
  [4052] = 3705,
  [4053] = 4053,
  [4054] = 3561,
  [4055] = 4055,
  [4056] = 4056,
  [4057] = 4057,
  [4058] = 3688,
  [4059] = 4059,
  [4060] = 3655,
  [4061] = 3686,
  [4062] = 3677,
  [4063] = 4063,
  [4064] = 2192,
  [4065] = 3683,
  [4066] = 3638,
  [4067] = 3711,
  [4068] = 4068,
  [4069] = 4069,
  [4070] = 2205,
  [4071] = 2206,
  [4072] = 4072,
  [4073] = 3639,
  [4074] = 4068,
  [4075] = 4072,
  [4076] = 4076,
  [4077] = 4068,
  [4078] = 4068,
  [4079] = 3707,
  [4080] = 4068,
  [4081] = 4072,
  [4082] = 4035,
  [4083] = 4072,
  [4084] = 4068,
  [4085] = 3632,
  [4086] = 4072,
  [4087] = 4068,
  [4088] = 3646,
  [4089] = 4072,
  [4090] = 4072,
  [4091] = 4013,
  [4092] = 4038,
  [4093] = 3630,
  [4094] = 3623,
  [4095] = 3622,
  [4096] = 4068,
  [4097] = 3678,
  [4098] = 3684,
  [4099] = 4068,
  [4100] = 3702,
  [4101] = 4072,
  [4102] = 4068,
  [4103] = 4056,
  [4104] = 3621,
  [4105] = 4072,
  [4106] = 3202,
  [4107] = 3712,
  [4108] = 4072,
  [4109] = 4068,
  [4110] = 3710,
  [4111] = 4068,
  [4112] = 3709,
  [4113] = 4063,
  [4114] = 4072,
  [4115] = 4068,
  [4116] = 3612,
  [4117] = 4016,
  [4118] = 4059,
  [4119] = 4072,
  [4120] = 3561,
  [4121] = 3705,
  [4122] = 4072,
  [4123] = 3965,
  [4124] = 4057,
  [4125] = 3620,
  [4126] = 4068,
  [4127] = 4068,
  [4128] = 4072,
  [4129] = 4072,
  [4130] = 4053,
  [4131] = 3561,
  [4132] = 3615,
  [4133] = 4068,
  [4134] = 4072,
  [4135] = 3660,
  [4136] = 2192,
  [4137] = 4068,
  [4138] = 3688,
  [4139] = 3686,
  [4140] = 4051,
  [4141] = 4072,
  [4142] = 4142,
  [4143] = 4143,
  [4144] = 4072,
  [4145] = 4142,
  [4146] = 4072,
  [4147] = 4068,
  [4148] = 4068,
  [4149] = 4072,
  [4150] = 4068,
  [4151] = 3683,
  [4152] = 4072,
  [4153] = 4068,
  [4154] = 4154,
  [4155] = 4068,
  [4156] = 4142,
  [4157] = 4068,
  [4158] = 4068,
  [4159] = 3680,
  [4160] = 3677,
  [4161] = 4072,
  [4162] = 4072,
  [4163] = 3202,
  [4164] = 3670,
  [4165] = 4072,
  [4166] = 4068,
  [4167] = 4068,
  [4168] = 2723,
  [4169] = 3667,
  [4170] = 3601,
  [4171] = 4072,
  [4172] = 3656,
  [4173] = 3655,
  [4174] = 3654,
  [4175] = 4068,
  [4176] = 3651,
  [4177] = 3674,
  [4178] = 4072,
  [4179] = 3645,
  [4180] = 4072,
  [4181] = 3561,
  [4182] = 4072,
  [4183] = 4142,
  [4184] = 4068,
  [4185] = 4068,
  [4186] = 3647,
  [4187] = 4187,
  [4188] = 3650,
  [4189] = 3561,
  [4190] = 4068,
  [4191] = 4069,
  [4192] = 4076,
  [4193] = 4043,
  [4194] = 4072,
  [4195] = 4187,
  [4196] = 4068,
  [4197] = 4068,
  [4198] = 4068,
  [4199] = 3681,
  [4200] = 2639,
  [4201] = 2723,
  [4202] = 4072,
  [4203] = 3613,
  [4204] = 3685,
  [4205] = 3679,
  [4206] = 4206,
  [4207] = 3672,
  [4208] = 3671,
  [4209] = 4072,
  [4210] = 3561,
  [4211] = 3637,
  [4212] = 3634,
  [4213] = 3701,
  [4214] = 3561,
  [4215] = 3625,
  [4216] = 4072,
  [4217] = 3693,
  [4218] = 3664,
  [4219] = 3584,
  [4220] = 4072,
  [4221] = 4068,
  [4222] = 3616,
  [4223] = 4142,
  [4224] = 3628,
  [4225] = 4069,
  [4226] = 4068,
  [4227] = 4072,
  [4228] = 4076,
  [4229] = 4072,
  [4230] = 4187,
  [4231] = 4069,
  [4232] = 4068,
  [4233] = 4068,
  [4234] = 4072,
  [4235] = 3614,
  [4236] = 4072,
  [4237] = 4068,
  [4238] = 4068,
  [4239] = 3665,
  [4240] = 4068,
  [4241] = 4072,
  [4242] = 4072,
  [4243] = 4068,
  [4244] = 4072,
  [4245] = 4072,
  [4246] = 4025,
  [4247] = 3673,
  [4248] = 3561,
  [4249] = 3675,
  [4250] = 4072,
  [4251] = 3682,
  [4252] = 3695,
  [4253] = 4068,
  [4254] = 4039,
  [4255] = 3697,
  [4256] = 4023,
  [4257] = 3535,
  [4258] = 4187,
  [4259] = 4055,
  [4260] = 4021,
  [4261] = 3624,
  [4262] = 4068,
  [4263] = 4076,
  [4264] = 4076,
  [4265] = 4187,
  [4266] = 4142,
  [4267] = 3008,
  [4268] = 3002,
  [4269] = 4020,
  [4270] = 4017,
  [4271] = 4069,
  [4272] = 4076,
  [4273] = 4072,
  [4274] = 4015,
  [4275] = 4187,
  [4276] = 4068,
  [4277] = 4072,
  [4278] = 4068,
  [4279] = 4187,
  [4280] = 4072,
  [4281] = 4068,
  [4282] = 3617,
  [4283] = 4072,
  [4284] = 4284,
  [4285] = 4076,
  [4286] = 4010,
  [4287] = 4069,
  [4288] = 3561,
  [4289] = 3952,
  [4290] = 3993,
  [4291] = 3561,
  [4292] = 4068,
  [4293] = 4072,
  [4294] = 3997,
  [4295] = 3561,
  [4296] = 4142,
  [4297] = 4069,
  [4298] = 4142,
  [4299] = 4072,
  [4300] = 4076,
  [4301] = 4187,
  [4302] = 3627,
  [4303] = 4068,
  [4304] = 4069,
  [4305] = 4305,
  [4306] = 4306,
  [4307] = 4307,
  [4308] = 3557,
  [4309] = 3565,
  [4310] = 4310,
  [4311] = 4310,
  [4312] = 3561,
  [4313] = 3561,
  [4314] = 3561,
  [4315] = 4315,
  [4316] = 4316,
  [4317] = 3561,
  [4318] = 3561,
  [4319] = 3535,
  [4320] = 2205,
  [4321] = 2206,
  [4322] = 3561,
  [4323] = 3561,
  [4324] = 2724,
  [4325] = 3556,
  [4326] = 3561,
  [4327] = 3008,
  [4328] = 3002,
  [4329] = 3561,
  [4330] = 4330,
  [4331] = 2250,
  [4332] = 2256,
  [4333] = 3584,
  [4334] = 3757,
  [4335] = 2277,
  [4336] = 4336,
  [4337] = 4337,
  [4338] = 4337,
  [4339] = 4337,
  [4340] = 3758,
  [4341] = 3837,
  [4342] = 4337,
  [4343] = 4306,
  [4344] = 3545,
  [4345] = 3557,
  [4346] = 3556,
  [4347] = 3553,
  [4348] = 3746,
  [4349] = 3753,
  [4350] = 3546,
  [4351] = 4337,
  [4352] = 4352,
  [4353] = 4352,
  [4354] = 4354,
  [4355] = 4306,
  [4356] = 4356,
  [4357] = 4357,
  [4358] = 4358,
  [4359] = 4359,
  [4360] = 3757,
  [4361] = 4337,
  [4362] = 4352,
  [4363] = 3739,
  [4364] = 4337,
  [4365] = 3837,
  [4366] = 4337,
  [4367] = 4352,
  [4368] = 4337,
  [4369] = 4369,
  [4370] = 4306,
  [4371] = 4371,
  [4372] = 4352,
  [4373] = 4373,
  [4374] = 3837,
  [4375] = 4337,
  [4376] = 4337,
  [4377] = 4352,
  [4378] = 4352,
  [4379] = 3601,
  [4380] = 3766,
  [4381] = 4337,
  [4382] = 4382,
  [4383] = 4306,
  [4384] = 4384,
  [4385] = 4385,
  [4386] = 4386,
  [4387] = 4387,
  [4388] = 4388,
  [4389] = 4337,
  [4390] = 4390,
  [4391] = 4391,
  [4392] = 4352,
  [4393] = 4393,
  [4394] = 4394,
  [4395] = 4395,
  [4396] = 4396,
  [4397] = 4306,
  [4398] = 4398,
  [4399] = 3561,
  [4400] = 4352,
  [4401] = 4401,
  [4402] = 4402,
  [4403] = 4337,
  [4404] = 4404,
  [4405] = 4337,
  [4406] = 4337,
  [4407] = 4337,
  [4408] = 4352,
  [4409] = 4352,
  [4410] = 4337,
  [4411] = 4337,
  [4412] = 4337,
  [4413] = 3561,
  [4414] = 4337,
  [4415] = 4337,
  [4416] = 3561,
  [4417] = 4352,
  [4418] = 4306,
  [4419] = 4337,
  [4420] = 4420,
  [4421] = 3565,
  [4422] = 4337,
  [4423] = 3561,
  [4424] = 4424,
  [4425] = 4337,
  [4426] = 4352,
  [4427] = 4352,
  [4428] = 4337,
  [4429] = 3837,
  [4430] = 4337,
  [4431] = 4336,
  [4432] = 4401,
  [4433] = 2732,
  [4434] = 4404,
  [4435] = 3609,
  [4436] = 4396,
  [4437] = 4437,
  [4438] = 4402,
  [4439] = 4439,
  [4440] = 4395,
  [4441] = 4394,
  [4442] = 4391,
  [4443] = 2733,
  [4444] = 4336,
  [4445] = 4390,
  [4446] = 3576,
  [4447] = 4447,
  [4448] = 3766,
  [4449] = 4449,
  [4450] = 4450,
  [4451] = 4373,
  [4452] = 4384,
  [4453] = 4382,
  [4454] = 4385,
  [4455] = 4386,
  [4456] = 4387,
  [4457] = 4388,
  [4458] = 3780,
  [4459] = 4459,
  [4460] = 4371,
  [4461] = 3581,
  [4462] = 3561,
  [4463] = 4424,
  [4464] = 4464,
  [4465] = 4420,
  [4466] = 4447,
  [4467] = 3753,
  [4468] = 4354,
  [4469] = 4356,
  [4470] = 4357,
  [4471] = 4358,
  [4472] = 4398,
  [4473] = 3739,
  [4474] = 3758,
  [4475] = 4359,
  [4476] = 4476,
  [4477] = 3561,
  [4478] = 4447,
  [4479] = 4479,
  [4480] = 4449,
  [4481] = 4369,
  [4482] = 3561,
  [4483] = 4404,
  [4484] = 4358,
  [4485] = 4357,
  [4486] = 4356,
  [4487] = 4388,
  [4488] = 4387,
  [4489] = 3599,
  [4490] = 4386,
  [4491] = 4354,
  [4492] = 4385,
  [4493] = 4359,
  [4494] = 4382,
  [4495] = 3561,
  [4496] = 4384,
  [4497] = 4373,
  [4498] = 3561,
  [4499] = 4402,
  [4500] = 3746,
  [4501] = 4391,
  [4502] = 4055,
  [4503] = 4369,
  [4504] = 4398,
  [4505] = 4401,
  [4506] = 3788,
  [4507] = 3561,
  [4508] = 3594,
  [4509] = 4371,
  [4510] = 4510,
  [4511] = 4449,
  [4512] = 4395,
  [4513] = 4394,
  [4514] = 4396,
  [4515] = 4390,
  [4516] = 3672,
  [4517] = 4517,
  [4518] = 4517,
  [4519] = 4013,
  [4520] = 3948,
  [4521] = 3684,
  [4522] = 4016,
  [4523] = 4398,
  [4524] = 4371,
  [4525] = 4525,
  [4526] = 3702,
  [4527] = 4527,
  [4528] = 4517,
  [4529] = 4529,
  [4530] = 4517,
  [4531] = 4005,
  [4532] = 4517,
  [4533] = 3788,
  [4534] = 3617,
  [4535] = 4535,
  [4536] = 4536,
  [4537] = 3948,
  [4538] = 4517,
  [4539] = 3712,
  [4540] = 2206,
  [4541] = 2724,
  [4542] = 3695,
  [4543] = 3693,
  [4544] = 4035,
  [4545] = 3780,
  [4546] = 3621,
  [4547] = 3619,
  [4548] = 4517,
  [4549] = 4388,
  [4550] = 4387,
  [4551] = 4386,
  [4552] = 4385,
  [4553] = 3682,
  [4554] = 4382,
  [4555] = 4384,
  [4556] = 4535,
  [4557] = 4373,
  [4558] = 3675,
  [4559] = 3673,
  [4560] = 4517,
  [4561] = 4535,
  [4562] = 3665,
  [4563] = 4563,
  [4564] = 4517,
  [4565] = 3620,
  [4566] = 4517,
  [4567] = 3710,
  [4568] = 4517,
  [4569] = 4043,
  [4570] = 3701,
  [4571] = 3614,
  [4572] = 4572,
  [4573] = 4573,
  [4574] = 3616,
  [4575] = 3649,
  [4576] = 4517,
  [4577] = 4517,
  [4578] = 4517,
  [4579] = 3678,
  [4580] = 3707,
  [4581] = 3623,
  [4582] = 4063,
  [4583] = 3624,
  [4584] = 4038,
  [4585] = 4039,
  [4586] = 3625,
  [4587] = 3646,
  [4588] = 4517,
  [4589] = 3628,
  [4590] = 3630,
  [4591] = 4591,
  [4592] = 3692,
  [4593] = 3634,
  [4594] = 3637,
  [4595] = 3671,
  [4596] = 4517,
  [4597] = 3659,
  [4598] = 3679,
  [4599] = 3622,
  [4600] = 4535,
  [4601] = 3685,
  [4602] = 4517,
  [4603] = 4437,
  [4604] = 3615,
  [4605] = 4517,
  [4606] = 3660,
  [4607] = 4439,
  [4608] = 4608,
  [4609] = 4517,
  [4610] = 4517,
  [4611] = 4010,
  [4612] = 4591,
  [4613] = 4517,
  [4614] = 4015,
  [4615] = 4017,
  [4616] = 4517,
  [4617] = 3612,
  [4618] = 4517,
  [4619] = 3613,
  [4620] = 3711,
  [4621] = 4535,
  [4622] = 3948,
  [4623] = 4591,
  [4624] = 4020,
  [4625] = 4536,
  [4626] = 4510,
  [4627] = 4517,
  [4628] = 3697,
  [4629] = 4517,
  [4630] = 3681,
  [4631] = 2724,
  [4632] = 4517,
  [4633] = 4517,
  [4634] = 4354,
  [4635] = 4356,
  [4636] = 4357,
  [4637] = 4358,
  [4638] = 4535,
  [4639] = 4535,
  [4640] = 4424,
  [4641] = 3650,
  [4642] = 4021,
  [4643] = 2913,
  [4644] = 4644,
  [4645] = 4608,
  [4646] = 3705,
  [4647] = 3647,
  [4648] = 3627,
  [4649] = 3993,
  [4650] = 4023,
  [4651] = 2205,
  [4652] = 4517,
  [4653] = 4517,
  [4654] = 4517,
  [4655] = 2192,
  [4656] = 4390,
  [4657] = 4336,
  [4658] = 4391,
  [4659] = 4394,
  [4660] = 4395,
  [4661] = 3645,
  [4662] = 4043,
  [4663] = 4025,
  [4664] = 3639,
  [4665] = 4517,
  [4666] = 4420,
  [4667] = 4396,
  [4668] = 4668,
  [4669] = 3626,
  [4670] = 4401,
  [4671] = 4402,
  [4672] = 3651,
  [4673] = 4359,
  [4674] = 4517,
  [4675] = 3709,
  [4676] = 4404,
  [4677] = 3654,
  [4678] = 3655,
  [4679] = 3656,
  [4680] = 3664,
  [4681] = 3667,
  [4682] = 3670,
  [4683] = 4683,
  [4684] = 3674,
  [4685] = 3683,
  [4686] = 4517,
  [4687] = 3677,
  [4688] = 3638,
  [4689] = 3680,
  [4690] = 4059,
  [4691] = 4691,
  [4692] = 3965,
  [4693] = 4057,
  [4694] = 4536,
  [4695] = 3632,
  [4696] = 3686,
  [4697] = 3948,
  [4698] = 3688,
  [4699] = 4056,
  [4700] = 4053,
  [4701] = 4051,
  [4702] = 4535,
  [4703] = 4517,
  [4704] = 4704,
  [4705] = 4517,
  [4706] = 4517,
  [4707] = 4479,
  [4708] = 4536,
  [4709] = 3952,
  [4710] = 4517,
  [4711] = 4476,
  [4712] = 3997,
  [4713] = 4517,
  [4714] = 4517,
  [4715] = 4608,
  [4716] = 4716,
  [4717] = 4402,
  [4718] = 4384,
  [4719] = 4719,
  [4720] = 4720,
  [4721] = 4401,
  [4722] = 4719,
  [4723] = 4723,
  [4724] = 4402,
  [4725] = 4725,
  [4726] = 4719,
  [4727] = 4723,
  [4728] = 4725,
  [4729] = 4729,
  [4730] = 4391,
  [4731] = 4723,
  [4732] = 4354,
  [4733] = 4336,
  [4734] = 4723,
  [4735] = 4382,
  [4736] = 4719,
  [4737] = 4737,
  [4738] = 4719,
  [4739] = 4729,
  [4740] = 4737,
  [4741] = 4741,
  [4742] = 4573,
  [4743] = 4398,
  [4744] = 2743,
  [4745] = 4404,
  [4746] = 4723,
  [4747] = 4719,
  [4748] = 4748,
  [4749] = 4420,
  [4750] = 4737,
  [4751] = 4719,
  [4752] = 4719,
  [4753] = 4394,
  [4754] = 4723,
  [4755] = 4741,
  [4756] = 4756,
  [4757] = 4719,
  [4758] = 4719,
  [4759] = 4723,
  [4760] = 4729,
  [4761] = 4741,
  [4762] = 4723,
  [4763] = 4358,
  [4764] = 4719,
  [4765] = 4359,
  [4766] = 4723,
  [4767] = 4424,
  [4768] = 4719,
  [4769] = 4723,
  [4770] = 4358,
  [4771] = 4771,
  [4772] = 4719,
  [4773] = 4390,
  [4774] = 4723,
  [4775] = 4719,
  [4776] = 4357,
  [4777] = 4356,
  [4778] = 4424,
  [4779] = 4779,
  [4780] = 4388,
  [4781] = 4719,
  [4782] = 4782,
  [4783] = 2744,
  [4784] = 4723,
  [4785] = 4771,
  [4786] = 4387,
  [4787] = 4386,
  [4788] = 3535,
  [4789] = 4719,
  [4790] = 4354,
  [4791] = 4385,
  [4792] = 4719,
  [4793] = 4398,
  [4794] = 4386,
  [4795] = 4373,
  [4796] = 4384,
  [4797] = 4369,
  [4798] = 4395,
  [4799] = 4737,
  [4800] = 4402,
  [4801] = 4719,
  [4802] = 4802,
  [4803] = 4719,
  [4804] = 4382,
  [4805] = 4805,
  [4806] = 4404,
  [4807] = 4382,
  [4808] = 4394,
  [4809] = 4719,
  [4810] = 4719,
  [4811] = 4373,
  [4812] = 4385,
  [4813] = 4386,
  [4814] = 4387,
  [4815] = 4573,
  [4816] = 4729,
  [4817] = 4387,
  [4818] = 4371,
  [4819] = 4741,
  [4820] = 4723,
  [4821] = 4723,
  [4822] = 4719,
  [4823] = 4719,
  [4824] = 4824,
  [4825] = 4824,
  [4826] = 4719,
  [4827] = 4723,
  [4828] = 4719,
  [4829] = 4384,
  [4830] = 4388,
  [4831] = 4371,
  [4832] = 3601,
  [4833] = 4723,
  [4834] = 4771,
  [4835] = 4835,
  [4836] = 4390,
  [4837] = 4756,
  [4838] = 4510,
  [4839] = 4043,
  [4840] = 4354,
  [4841] = 4719,
  [4842] = 4336,
  [4843] = 4391,
  [4844] = 4723,
  [4845] = 4725,
  [4846] = 4824,
  [4847] = 4391,
  [4848] = 4723,
  [4849] = 4723,
  [4850] = 4394,
  [4851] = 4719,
  [4852] = 4395,
  [4853] = 4723,
  [4854] = 4476,
  [4855] = 4479,
  [4856] = 4723,
  [4857] = 4396,
  [4858] = 4385,
  [4859] = 4336,
  [4860] = 4356,
  [4861] = 4737,
  [4862] = 4729,
  [4863] = 4741,
  [4864] = 4401,
  [4865] = 4719,
  [4866] = 4357,
  [4867] = 4867,
  [4868] = 4719,
  [4869] = 4420,
  [4870] = 4723,
  [4871] = 4359,
  [4872] = 4373,
  [4873] = 4401,
  [4874] = 4719,
  [4875] = 4668,
  [4876] = 4771,
  [4877] = 4867,
  [4878] = 4723,
  [4879] = 4719,
  [4880] = 4359,
  [4881] = 4723,
  [4882] = 4404,
  [4883] = 4668,
  [4884] = 4396,
  [4885] = 4885,
  [4886] = 4867,
  [4887] = 4771,
  [4888] = 4358,
  [4889] = 4723,
  [4890] = 4719,
  [4891] = 2724,
  [4892] = 4043,
  [4893] = 4719,
  [4894] = 4437,
  [4895] = 4723,
  [4896] = 4357,
  [4897] = 4390,
  [4898] = 4439,
  [4899] = 4371,
  [4900] = 4756,
  [4901] = 4356,
  [4902] = 4719,
  [4903] = 4720,
  [4904] = 4396,
  [4905] = 4719,
  [4906] = 4388,
  [4907] = 4395,
  [4908] = 4771,
  [4909] = 4719,
  [4910] = 4719,
  [4911] = 4719,
  [4912] = 4398,
  [4913] = 4719,
  [4914] = 4404,
  [4915] = 4390,
  [4916] = 4391,
  [4917] = 4394,
  [4918] = 4388,
  [4919] = 4387,
  [4920] = 4386,
  [4921] = 2913,
  [4922] = 4385,
  [4923] = 4382,
  [4924] = 4384,
  [4925] = 4373,
  [4926] = 4437,
  [4927] = 4439,
  [4928] = 4395,
  [4929] = 4510,
  [4930] = 4371,
  [4931] = 4354,
  [4932] = 4396,
  [4933] = 4359,
  [4934] = 4401,
  [4935] = 4402,
  [4936] = 4356,
  [4937] = 4510,
  [4938] = 4336,
  [4939] = 4476,
  [4940] = 4357,
  [4941] = 4358,
  [4942] = 3565,
  [4943] = 3557,
  [4944] = 4055,
  [4945] = 4437,
  [4946] = 3556,
  [4947] = 4476,
  [4948] = 4479,
  [4949] = 3008,
  [4950] = 4439,
  [4951] = 4398,
  [4952] = 3002,
  [4953] = 4369,
  [4954] = 4479,
  [4955] = 4371,
  [4956] = 4039,
  [4957] = 4015,
  [4958] = 4051,
  [4959] = 2738,
  [4960] = 4424,
  [4961] = 4010,
  [4962] = 4385,
  [4963] = 4354,
  [4964] = 4336,
  [4965] = 4391,
  [4966] = 4394,
  [4967] = 4404,
  [4968] = 2737,
  [4969] = 4017,
  [4970] = 4359,
  [4971] = 4020,
  [4972] = 4056,
  [4973] = 2741,
  [4974] = 4043,
  [4975] = 2977,
  [4976] = 2736,
  [4977] = 4402,
  [4978] = 4401,
  [4979] = 4063,
  [4980] = 4396,
  [4981] = 4398,
  [4982] = 4573,
  [4983] = 4390,
  [4984] = 4053,
  [4985] = 4059,
  [4986] = 4025,
  [4987] = 4043,
  [4988] = 3952,
  [4989] = 4013,
  [4990] = 4382,
  [4991] = 2724,
  [4992] = 4668,
  [4993] = 4038,
  [4994] = 3997,
  [4995] = 3993,
  [4996] = 4395,
  [4997] = 4035,
  [4998] = 4023,
  [4999] = 4999,
  [5000] = 4384,
  [5001] = 4021,
  [5002] = 4358,
  [5003] = 4386,
  [5004] = 4373,
  [5005] = 3965,
  [5006] = 4016,
  [5007] = 4357,
  [5008] = 2951,
  [5009] = 4387,
  [5010] = 4057,
  [5011] = 4388,
  [5012] = 2734,
  [5013] = 4420,
  [5014] = 4356,
  [5015] = 2724,
  [5016] = 4357,
  [5017] = 4356,
  [5018] = 4388,
  [5019] = 4387,
  [5020] = 4386,
  [5021] = 4354,
  [5022] = 4385,
  [5023] = 4391,
  [5024] = 4382,
  [5025] = 4384,
  [5026] = 4373,
  [5027] = 4404,
  [5028] = 4358,
  [5029] = 4402,
  [5030] = 4401,
  [5031] = 4395,
  [5032] = 4396,
  [5033] = 5033,
  [5034] = 2913,
  [5035] = 4398,
  [5036] = 4390,
  [5037] = 4336,
  [5038] = 4359,
  [5039] = 4395,
  [5040] = 4391,
  [5041] = 4394,
  [5042] = 4394,
  [5043] = 4391,
  [5044] = 4373,
  [5045] = 4336,
  [5046] = 4390,
  [5047] = 4384,
  [5048] = 4398,
  [5049] = 4395,
  [5050] = 4382,
  [5051] = 4396,
  [5052] = 4401,
  [5053] = 4385,
  [5054] = 4402,
  [5055] = 4359,
  [5056] = 4401,
  [5057] = 4354,
  [5058] = 4402,
  [5059] = 4386,
  [5060] = 4387,
  [5061] = 3997,
  [5062] = 4388,
  [5063] = 4357,
  [5064] = 4358,
  [5065] = 4387,
  [5066] = 4373,
  [5067] = 4396,
  [5068] = 4384,
  [5069] = 4382,
  [5070] = 4404,
  [5071] = 3993,
  [5072] = 4369,
  [5073] = 4394,
  [5074] = 4479,
  [5075] = 4388,
  [5076] = 4404,
  [5077] = 4476,
  [5078] = 5078,
  [5079] = 4356,
  [5080] = 4668,
  [5081] = 2972,
  [5082] = 4439,
  [5083] = 3535,
  [5084] = 4510,
  [5085] = 4437,
  [5086] = 4386,
  [5087] = 4357,
  [5088] = 4043,
  [5089] = 5089,
  [5090] = 2743,
  [5091] = 5091,
  [5092] = 5092,
  [5093] = 4356,
  [5094] = 4358,
  [5095] = 4371,
  [5096] = 4359,
  [5097] = 4385,
  [5098] = 4354,
  [5099] = 4371,
  [5100] = 4336,
  [5101] = 4573,
  [5102] = 4424,
  [5103] = 4390,
  [5104] = 4398,
  [5105] = 4371,
  [5106] = 4369,
  [5107] = 4420,
  [5108] = 4388,
  [5109] = 5109,
  [5110] = 4402,
  [5111] = 4401,
  [5112] = 4396,
  [5113] = 4385,
  [5114] = 4384,
  [5115] = 5109,
  [5116] = 3545,
  [5117] = 4395,
  [5118] = 4394,
  [5119] = 4382,
  [5120] = 3557,
  [5121] = 2937,
  [5122] = 4359,
  [5123] = 3565,
  [5124] = 3556,
  [5125] = 3553,
  [5126] = 4390,
  [5127] = 4386,
  [5128] = 2733,
  [5129] = 5109,
  [5130] = 2732,
  [5131] = 3546,
  [5132] = 5109,
  [5133] = 5109,
  [5134] = 4382,
  [5135] = 4387,
  [5136] = 2744,
  [5137] = 3601,
  [5138] = 4336,
  [5139] = 4371,
  [5140] = 4388,
  [5141] = 4404,
  [5142] = 4369,
  [5143] = 4391,
  [5144] = 2733,
  [5145] = 4336,
  [5146] = 2743,
  [5147] = 4390,
  [5148] = 4398,
  [5149] = 2732,
  [5150] = 4358,
  [5151] = 4357,
  [5152] = 4391,
  [5153] = 4387,
  [5154] = 4386,
  [5155] = 4354,
  [5156] = 4385,
  [5157] = 4394,
  [5158] = 4369,
  [5159] = 4395,
  [5160] = 4439,
  [5161] = 4396,
  [5162] = 5109,
  [5163] = 4401,
  [5164] = 4402,
  [5165] = 4384,
  [5166] = 4369,
  [5167] = 4404,
  [5168] = 4398,
  [5169] = 4373,
  [5170] = 4354,
  [5171] = 4356,
  [5172] = 4357,
  [5173] = 4358,
  [5174] = 4424,
  [5175] = 4359,
  [5176] = 4390,
  [5177] = 4336,
  [5178] = 4391,
  [5179] = 4420,
  [5180] = 4371,
  [5181] = 4394,
  [5182] = 4398,
  [5183] = 4356,
  [5184] = 4395,
  [5185] = 4396,
  [5186] = 4401,
  [5187] = 4402,
  [5188] = 4510,
  [5189] = 4479,
  [5190] = 4476,
  [5191] = 4358,
  [5192] = 3601,
  [5193] = 4357,
  [5194] = 4359,
  [5195] = 4373,
  [5196] = 4356,
  [5197] = 4388,
  [5198] = 4387,
  [5199] = 4386,
  [5200] = 4354,
  [5201] = 4437,
  [5202] = 4385,
  [5203] = 4382,
  [5204] = 4384,
  [5205] = 2724,
  [5206] = 4373,
  [5207] = 2724,
  [5208] = 4404,
  [5209] = 4371,
  [5210] = 4359,
  [5211] = 2738,
  [5212] = 4479,
  [5213] = 4390,
  [5214] = 4336,
  [5215] = 4391,
  [5216] = 4354,
  [5217] = 4356,
  [5218] = 4357,
  [5219] = 4358,
  [5220] = 4394,
  [5221] = 4395,
  [5222] = 4371,
  [5223] = 5223,
  [5224] = 4476,
  [5225] = 4396,
  [5226] = 4401,
  [5227] = 4402,
  [5228] = 4359,
  [5229] = 4401,
  [5230] = 4358,
  [5231] = 4357,
  [5232] = 4354,
  [5233] = 2744,
  [5234] = 2974,
  [5235] = 4398,
  [5236] = 2724,
  [5237] = 2973,
  [5238] = 4424,
  [5239] = 4420,
  [5240] = 4439,
  [5241] = 4356,
  [5242] = 4402,
  [5243] = 4668,
  [5244] = 4359,
  [5245] = 2930,
  [5246] = 4396,
  [5247] = 4395,
  [5248] = 4394,
  [5249] = 4391,
  [5250] = 4336,
  [5251] = 4390,
  [5252] = 5223,
  [5253] = 5253,
  [5254] = 2736,
  [5255] = 3599,
  [5256] = 4358,
  [5257] = 3002,
  [5258] = 3594,
  [5259] = 4357,
  [5260] = 4356,
  [5261] = 2881,
  [5262] = 2971,
  [5263] = 4388,
  [5264] = 4387,
  [5265] = 4371,
  [5266] = 4398,
  [5267] = 4386,
  [5268] = 4354,
  [5269] = 4385,
  [5270] = 4382,
  [5271] = 2974,
  [5272] = 2929,
  [5273] = 4371,
  [5274] = 4384,
  [5275] = 4373,
  [5276] = 2871,
  [5277] = 3609,
  [5278] = 4420,
  [5279] = 4404,
  [5280] = 4358,
  [5281] = 4357,
  [5282] = 4356,
  [5283] = 4354,
  [5284] = 5223,
  [5285] = 5223,
  [5286] = 4402,
  [5287] = 4401,
  [5288] = 4396,
  [5289] = 4395,
  [5290] = 4394,
  [5291] = 4391,
  [5292] = 4336,
  [5293] = 2973,
  [5294] = 4390,
  [5295] = 4510,
  [5296] = 2975,
  [5297] = 4404,
  [5298] = 4573,
  [5299] = 4398,
  [5300] = 4424,
  [5301] = 2966,
  [5302] = 2977,
  [5303] = 4055,
  [5304] = 2724,
  [5305] = 4369,
  [5306] = 4388,
  [5307] = 4387,
  [5308] = 4396,
  [5309] = 4386,
  [5310] = 4398,
  [5311] = 4385,
  [5312] = 4369,
  [5313] = 3993,
  [5314] = 3997,
  [5315] = 2741,
  [5316] = 4369,
  [5317] = 3581,
  [5318] = 2785,
  [5319] = 2737,
  [5320] = 5223,
  [5321] = 2734,
  [5322] = 4382,
  [5323] = 4384,
  [5324] = 4373,
  [5325] = 4404,
  [5326] = 4404,
  [5327] = 5327,
  [5328] = 4388,
  [5329] = 4387,
  [5330] = 4386,
  [5331] = 5331,
  [5332] = 2913,
  [5333] = 2930,
  [5334] = 4385,
  [5335] = 4420,
  [5336] = 4382,
  [5337] = 4384,
  [5338] = 4668,
  [5339] = 4373,
  [5340] = 4402,
  [5341] = 4401,
  [5342] = 4359,
  [5343] = 4573,
  [5344] = 2966,
  [5345] = 4395,
  [5346] = 4424,
  [5347] = 4043,
  [5348] = 5331,
  [5349] = 4394,
  [5350] = 4391,
  [5351] = 4336,
  [5352] = 4390,
  [5353] = 5353,
  [5354] = 4371,
  [5355] = 4043,
  [5356] = 4437,
  [5357] = 4388,
  [5358] = 3576,
  [5359] = 2877,
  [5360] = 2971,
  [5361] = 2892,
  [5362] = 2949,
  [5363] = 5223,
  [5364] = 2897,
  [5365] = 2951,
  [5366] = 4387,
  [5367] = 4386,
  [5368] = 2913,
  [5369] = 2937,
  [5370] = 4385,
  [5371] = 2901,
  [5372] = 2907,
  [5373] = 2899,
  [5374] = 4382,
  [5375] = 2972,
  [5376] = 3008,
  [5377] = 4384,
  [5378] = 4373,
  [5379] = 2929,
  [5380] = 2898,
  [5381] = 3002,
  [5382] = 4336,
  [5383] = 3709,
  [5384] = 4371,
  [5385] = 3952,
  [5386] = 3692,
  [5387] = 4391,
  [5388] = 4394,
  [5389] = 4010,
  [5390] = 4015,
  [5391] = 4398,
  [5392] = 4017,
  [5393] = 4476,
  [5394] = 4336,
  [5395] = 4479,
  [5396] = 4020,
  [5397] = 4402,
  [5398] = 4021,
  [5399] = 4023,
  [5400] = 4025,
  [5401] = 3617,
  [5402] = 4404,
  [5403] = 3619,
  [5404] = 4051,
  [5405] = 4390,
  [5406] = 4053,
  [5407] = 4056,
  [5408] = 4439,
  [5409] = 4437,
  [5410] = 4057,
  [5411] = 3965,
  [5412] = 4059,
  [5413] = 4063,
  [5414] = 4354,
  [5415] = 4357,
  [5416] = 4358,
  [5417] = 4395,
  [5418] = 4398,
  [5419] = 4371,
  [5420] = 4402,
  [5421] = 4043,
  [5422] = 5422,
  [5423] = 4039,
  [5424] = 4038,
  [5425] = 4035,
  [5426] = 4013,
  [5427] = 3697,
  [5428] = 4396,
  [5429] = 4354,
  [5430] = 2962,
  [5431] = 4358,
  [5432] = 4357,
  [5433] = 4388,
  [5434] = 4387,
  [5435] = 4386,
  [5436] = 4354,
  [5437] = 4043,
  [5438] = 3660,
  [5439] = 4668,
  [5440] = 2205,
  [5441] = 4398,
  [5442] = 4401,
  [5443] = 4373,
  [5444] = 4384,
  [5445] = 4016,
  [5446] = 4382,
  [5447] = 4359,
  [5448] = 4385,
  [5449] = 4402,
  [5450] = 3615,
  [5451] = 4386,
  [5452] = 4387,
  [5453] = 4385,
  [5454] = 4388,
  [5455] = 4356,
  [5456] = 4357,
  [5457] = 4358,
  [5458] = 4382,
  [5459] = 4384,
  [5460] = 3993,
  [5461] = 4373,
  [5462] = 3997,
  [5463] = 3659,
  [5464] = 3620,
  [5465] = 3621,
  [5466] = 3622,
  [5467] = 3623,
  [5468] = 4404,
  [5469] = 4359,
  [5470] = 4402,
  [5471] = 4401,
  [5472] = 5422,
  [5473] = 4356,
  [5474] = 4396,
  [5475] = 4404,
  [5476] = 4369,
  [5477] = 4404,
  [5478] = 4395,
  [5479] = 4394,
  [5480] = 4402,
  [5481] = 4401,
  [5482] = 4358,
  [5483] = 4357,
  [5484] = 4388,
  [5485] = 4387,
  [5486] = 4386,
  [5487] = 4354,
  [5488] = 4385,
  [5489] = 4382,
  [5490] = 4384,
  [5491] = 4373,
  [5492] = 4396,
  [5493] = 4391,
  [5494] = 4395,
  [5495] = 4394,
  [5496] = 4391,
  [5497] = 4336,
  [5498] = 4390,
  [5499] = 4398,
  [5500] = 4336,
  [5501] = 4573,
  [5502] = 4398,
  [5503] = 4404,
  [5504] = 4390,
  [5505] = 3630,
  [5506] = 4398,
  [5507] = 4390,
  [5508] = 3632,
  [5509] = 4439,
  [5510] = 4336,
  [5511] = 4437,
  [5512] = 4476,
  [5513] = 3638,
  [5514] = 4391,
  [5515] = 4573,
  [5516] = 3626,
  [5517] = 4394,
  [5518] = 4395,
  [5519] = 4396,
  [5520] = 4401,
  [5521] = 4402,
  [5522] = 4373,
  [5523] = 4384,
  [5524] = 4382,
  [5525] = 4359,
  [5526] = 4385,
  [5527] = 4386,
  [5528] = 4387,
  [5529] = 4388,
  [5530] = 4404,
  [5531] = 4371,
  [5532] = 4369,
  [5533] = 4420,
  [5534] = 4354,
  [5535] = 4356,
  [5536] = 4357,
  [5537] = 4358,
  [5538] = 4479,
  [5539] = 4390,
  [5540] = 4336,
  [5541] = 4391,
  [5542] = 4420,
  [5543] = 3639,
  [5544] = 4394,
  [5545] = 3710,
  [5546] = 4510,
  [5547] = 4395,
  [5548] = 2975,
  [5549] = 3646,
  [5550] = 3678,
  [5551] = 4396,
  [5552] = 4401,
  [5553] = 4424,
  [5554] = 4402,
  [5555] = 4359,
  [5556] = 3684,
  [5557] = 4404,
  [5558] = 2206,
  [5559] = 4396,
  [5560] = 4356,
  [5561] = 3702,
  [5562] = 4369,
  [5563] = 4371,
  [5564] = 4404,
  [5565] = 4388,
  [5566] = 4387,
  [5567] = 4357,
  [5568] = 4386,
  [5569] = 4385,
  [5570] = 3707,
  [5571] = 4382,
  [5572] = 4384,
  [5573] = 3612,
  [5574] = 4373,
  [5575] = 4402,
  [5576] = 4401,
  [5577] = 4398,
  [5578] = 4395,
  [5579] = 3705,
  [5580] = 4404,
  [5581] = 4394,
  [5582] = 4388,
  [5583] = 4387,
  [5584] = 4386,
  [5585] = 4385,
  [5586] = 4359,
  [5587] = 4382,
  [5588] = 4384,
  [5589] = 4373,
  [5590] = 4402,
  [5591] = 4401,
  [5592] = 4391,
  [5593] = 4396,
  [5594] = 2913,
  [5595] = 2192,
  [5596] = 4395,
  [5597] = 4336,
  [5598] = 4394,
  [5599] = 4391,
  [5600] = 4390,
  [5601] = 4336,
  [5602] = 4390,
  [5603] = 4398,
  [5604] = 3688,
  [5605] = 3686,
  [5606] = 4398,
  [5607] = 3683,
  [5608] = 3680,
  [5609] = 3677,
  [5610] = 4390,
  [5611] = 3674,
  [5612] = 4369,
  [5613] = 3670,
  [5614] = 4424,
  [5615] = 4369,
  [5616] = 4420,
  [5617] = 3667,
  [5618] = 4356,
  [5619] = 4404,
  [5620] = 4388,
  [5621] = 3712,
  [5622] = 3656,
  [5623] = 4387,
  [5624] = 4386,
  [5625] = 4385,
  [5626] = 4382,
  [5627] = 4388,
  [5628] = 4387,
  [5629] = 4386,
  [5630] = 4384,
  [5631] = 4385,
  [5632] = 4373,
  [5633] = 4382,
  [5634] = 4384,
  [5635] = 4373,
  [5636] = 4402,
  [5637] = 4401,
  [5638] = 4396,
  [5639] = 3655,
  [5640] = 4395,
  [5641] = 4394,
  [5642] = 3654,
  [5643] = 3651,
  [5644] = 3645,
  [5645] = 3627,
  [5646] = 4391,
  [5647] = 3647,
  [5648] = 4390,
  [5649] = 3650,
  [5650] = 4043,
  [5651] = 4424,
  [5652] = 4336,
  [5653] = 4391,
  [5654] = 5422,
  [5655] = 3664,
  [5656] = 4439,
  [5657] = 4437,
  [5658] = 4476,
  [5659] = 3711,
  [5660] = 4479,
  [5661] = 4510,
  [5662] = 3613,
  [5663] = 4356,
  [5664] = 4424,
  [5665] = 4358,
  [5666] = 4357,
  [5667] = 4354,
  [5668] = 4359,
  [5669] = 2785,
  [5670] = 4369,
  [5671] = 3685,
  [5672] = 3679,
  [5673] = 3672,
  [5674] = 3671,
  [5675] = 3637,
  [5676] = 4394,
  [5677] = 4420,
  [5678] = 4371,
  [5679] = 3634,
  [5680] = 3628,
  [5681] = 5681,
  [5682] = 3625,
  [5683] = 4371,
  [5684] = 4356,
  [5685] = 4358,
  [5686] = 4043,
  [5687] = 4357,
  [5688] = 4356,
  [5689] = 4668,
  [5690] = 4668,
  [5691] = 4388,
  [5692] = 4424,
  [5693] = 4395,
  [5694] = 4420,
  [5695] = 4387,
  [5696] = 4386,
  [5697] = 4371,
  [5698] = 4356,
  [5699] = 4354,
  [5700] = 4398,
  [5701] = 3624,
  [5702] = 4371,
  [5703] = 4396,
  [5704] = 4385,
  [5705] = 4371,
  [5706] = 4359,
  [5707] = 4359,
  [5708] = 4354,
  [5709] = 5709,
  [5710] = 4357,
  [5711] = 4358,
  [5712] = 4382,
  [5713] = 4384,
  [5714] = 5422,
  [5715] = 4373,
  [5716] = 4573,
  [5717] = 3649,
  [5718] = 4401,
  [5719] = 3616,
  [5720] = 4396,
  [5721] = 3614,
  [5722] = 4395,
  [5723] = 3681,
  [5724] = 4394,
  [5725] = 4371,
  [5726] = 4391,
  [5727] = 4336,
  [5728] = 4390,
  [5729] = 4401,
  [5730] = 3701,
  [5731] = 3665,
  [5732] = 4510,
  [5733] = 3673,
  [5734] = 3675,
  [5735] = 3682,
  [5736] = 4373,
  [5737] = 4384,
  [5738] = 4382,
  [5739] = 4359,
  [5740] = 3693,
  [5741] = 5422,
  [5742] = 3695,
  [5743] = 4358,
  [5744] = 4357,
  [5745] = 4354,
  [5746] = 4385,
  [5747] = 4359,
  [5748] = 4354,
  [5749] = 4358,
  [5750] = 4386,
  [5751] = 4387,
  [5752] = 4388,
  [5753] = 4356,
  [5754] = 4371,
  [5755] = 4386,
  [5756] = 4387,
  [5757] = 4388,
  [5758] = 4357,
  [5759] = 4358,
  [5760] = 5760,
  [5761] = 5761,
  [5762] = 5762,
  [5763] = 5763,
  [5764] = 5764,
  [5765] = 5765,
  [5766] = 5764,
  [5767] = 4369,
  [5768] = 5765,
  [5769] = 4401,
  [5770] = 4354,
  [5771] = 4385,
  [5772] = 4356,
  [5773] = 4371,
  [5774] = 4398,
  [5775] = 4390,
  [5776] = 4336,
  [5777] = 4391,
  [5778] = 4394,
  [5779] = 4395,
  [5780] = 4396,
  [5781] = 4369,
  [5782] = 4404,
  [5783] = 4401,
  [5784] = 5765,
  [5785] = 4402,
  [5786] = 4358,
  [5787] = 4359,
  [5788] = 4404,
  [5789] = 4357,
  [5790] = 4356,
  [5791] = 4388,
  [5792] = 4387,
  [5793] = 4386,
  [5794] = 4354,
  [5795] = 4385,
  [5796] = 5796,
  [5797] = 4359,
  [5798] = 4382,
  [5799] = 4384,
  [5800] = 4373,
  [5801] = 4371,
  [5802] = 5709,
  [5803] = 5803,
  [5804] = 4371,
  [5805] = 5805,
  [5806] = 4382,
  [5807] = 4384,
  [5808] = 5803,
  [5809] = 4401,
  [5810] = 4373,
  [5811] = 4402,
  [5812] = 4373,
  [5813] = 4384,
  [5814] = 5764,
  [5815] = 4382,
  [5816] = 4385,
  [5817] = 4354,
  [5818] = 4356,
  [5819] = 4386,
  [5820] = 4387,
  [5821] = 4398,
  [5822] = 4388,
  [5823] = 4357,
  [5824] = 4358,
  [5825] = 4398,
  [5826] = 4394,
  [5827] = 4404,
  [5828] = 5828,
  [5829] = 5764,
  [5830] = 4359,
  [5831] = 4402,
  [5832] = 4369,
  [5833] = 4398,
  [5834] = 5764,
  [5835] = 4371,
  [5836] = 4396,
  [5837] = 5764,
  [5838] = 4395,
  [5839] = 4396,
  [5840] = 4356,
  [5841] = 5764,
  [5842] = 4394,
  [5843] = 4510,
  [5844] = 4391,
  [5845] = 4336,
  [5846] = 4390,
  [5847] = 5764,
  [5848] = 4398,
  [5849] = 4395,
  [5850] = 4371,
  [5851] = 4356,
  [5852] = 5764,
  [5853] = 5803,
  [5854] = 5764,
  [5855] = 4668,
  [5856] = 4371,
  [5857] = 4356,
  [5858] = 4369,
  [5859] = 5764,
  [5860] = 4395,
  [5861] = 5765,
  [5862] = 5805,
  [5863] = 4573,
  [5864] = 5764,
  [5865] = 5865,
  [5866] = 5764,
  [5867] = 5805,
  [5868] = 4358,
  [5869] = 4357,
  [5870] = 4388,
  [5871] = 4387,
  [5872] = 4356,
  [5873] = 4386,
  [5874] = 4573,
  [5875] = 4394,
  [5876] = 4354,
  [5877] = 4385,
  [5878] = 4382,
  [5879] = 4384,
  [5880] = 4373,
  [5881] = 4391,
  [5882] = 4398,
  [5883] = 4390,
  [5884] = 4391,
  [5885] = 4336,
  [5886] = 4391,
  [5887] = 4336,
  [5888] = 4394,
  [5889] = 4369,
  [5890] = 4395,
  [5891] = 5891,
  [5892] = 5892,
  [5893] = 4404,
  [5894] = 4336,
  [5895] = 4359,
  [5896] = 4396,
  [5897] = 4402,
  [5898] = 4401,
  [5899] = 4401,
  [5900] = 4390,
  [5901] = 4402,
  [5902] = 4359,
  [5903] = 5903,
  [5904] = 5904,
  [5905] = 4404,
  [5906] = 4396,
  [5907] = 5907,
  [5908] = 4371,
  [5909] = 5909,
  [5910] = 5910,
  [5911] = 4396,
  [5912] = 4573,
  [5913] = 5764,
  [5914] = 4479,
  [5915] = 4476,
  [5916] = 5909,
  [5917] = 4369,
  [5918] = 4395,
  [5919] = 4394,
  [5920] = 4391,
  [5921] = 4336,
  [5922] = 4390,
  [5923] = 2785,
  [5924] = 5924,
  [5925] = 4373,
  [5926] = 4384,
  [5927] = 4382,
  [5928] = 4385,
  [5929] = 4354,
  [5930] = 4386,
  [5931] = 5891,
  [5932] = 5892,
  [5933] = 4055,
  [5934] = 5764,
  [5935] = 5764,
  [5936] = 5936,
  [5937] = 5903,
  [5938] = 5904,
  [5939] = 4371,
  [5940] = 4398,
  [5941] = 4387,
  [5942] = 4358,
  [5943] = 4357,
  [5944] = 4437,
  [5945] = 5828,
  [5946] = 4388,
  [5947] = 4387,
  [5948] = 5909,
  [5949] = 4439,
  [5950] = 4387,
  [5951] = 4388,
  [5952] = 4386,
  [5953] = 4357,
  [5954] = 4358,
  [5955] = 4373,
  [5956] = 4384,
  [5957] = 4382,
  [5958] = 4385,
  [5959] = 4354,
  [5960] = 4386,
  [5961] = 5764,
  [5962] = 4391,
  [5963] = 4388,
  [5964] = 4356,
  [5965] = 4357,
  [5966] = 4358,
  [5967] = 4402,
  [5968] = 5764,
  [5969] = 2949,
  [5970] = 5765,
  [5971] = 5828,
  [5972] = 4354,
  [5973] = 5803,
  [5974] = 4668,
  [5975] = 4385,
  [5976] = 4382,
  [5977] = 4384,
  [5978] = 4373,
  [5979] = 4402,
  [5980] = 5891,
  [5981] = 5892,
  [5982] = 4404,
  [5983] = 4404,
  [5984] = 4359,
  [5985] = 4386,
  [5986] = 4401,
  [5987] = 4396,
  [5988] = 4395,
  [5989] = 4390,
  [5990] = 4394,
  [5991] = 4336,
  [5992] = 4437,
  [5993] = 4391,
  [5994] = 5796,
  [5995] = 4394,
  [5996] = 4395,
  [5997] = 5997,
  [5998] = 4336,
  [5999] = 4390,
  [6000] = 4510,
  [6001] = 4398,
  [6002] = 5803,
  [6003] = 5764,
  [6004] = 4398,
  [6005] = 4390,
  [6006] = 4336,
  [6007] = 4479,
  [6008] = 4391,
  [6009] = 4394,
  [6010] = 4476,
  [6011] = 4437,
  [6012] = 4395,
  [6013] = 4396,
  [6014] = 5764,
  [6015] = 4396,
  [6016] = 4401,
  [6017] = 4402,
  [6018] = 4401,
  [6019] = 4402,
  [6020] = 4359,
  [6021] = 5828,
  [6022] = 4404,
  [6023] = 4439,
  [6024] = 5765,
  [6025] = 4510,
  [6026] = 5764,
  [6027] = 4359,
  [6028] = 4479,
  [6029] = 4476,
  [6030] = 6030,
  [6031] = 4439,
  [6032] = 4404,
  [6033] = 5764,
  [6034] = 5764,
  [6035] = 5904,
  [6036] = 4510,
  [6037] = 5903,
  [6038] = 5909,
  [6039] = 4479,
  [6040] = 5765,
  [6041] = 4476,
  [6042] = 4437,
  [6043] = 4358,
  [6044] = 4439,
  [6045] = 4510,
  [6046] = 4357,
  [6047] = 4356,
  [6048] = 4388,
  [6049] = 4479,
  [6050] = 4476,
  [6051] = 4437,
  [6052] = 4390,
  [6053] = 4439,
  [6054] = 6054,
  [6055] = 3601,
  [6056] = 4387,
  [6057] = 4386,
  [6058] = 4385,
  [6059] = 4043,
  [6060] = 5764,
  [6061] = 4359,
  [6062] = 4382,
  [6063] = 4384,
  [6064] = 5765,
  [6065] = 4373,
  [6066] = 5764,
  [6067] = 5904,
  [6068] = 5903,
  [6069] = 4354,
  [6070] = 4354,
  [6071] = 5892,
  [6072] = 5891,
  [6073] = 4401,
  [6074] = 4385,
  [6075] = 4373,
  [6076] = 5803,
  [6077] = 6077,
  [6078] = 4382,
  [6079] = 6079,
  [6080] = 5805,
  [6081] = 4358,
  [6082] = 4668,
  [6083] = 4357,
  [6084] = 4384,
  [6085] = 4388,
  [6086] = 3002,
  [6087] = 3008,
  [6088] = 4387,
  [6089] = 4394,
  [6090] = 6090,
  [6091] = 2785,
  [6092] = 4382,
  [6093] = 4043,
  [6094] = 4668,
  [6095] = 6095,
  [6096] = 4371,
  [6097] = 4573,
  [6098] = 6098,
  [6099] = 4390,
  [6100] = 4043,
  [6101] = 4398,
  [6102] = 4336,
  [6103] = 4391,
  [6104] = 4573,
  [6105] = 6030,
  [6106] = 4394,
  [6107] = 4395,
  [6108] = 4396,
  [6109] = 4420,
  [6110] = 4401,
  [6111] = 4402,
  [6112] = 3997,
  [6113] = 3993,
  [6114] = 4371,
  [6115] = 6115,
  [6116] = 4573,
  [6117] = 4373,
  [6118] = 6118,
  [6119] = 4384,
  [6120] = 6120,
  [6121] = 4354,
  [6122] = 4356,
  [6123] = 4357,
  [6124] = 4358,
  [6125] = 6125,
  [6126] = 4424,
  [6127] = 4359,
  [6128] = 2785,
  [6129] = 6129,
  [6130] = 6115,
  [6131] = 4385,
  [6132] = 4386,
  [6133] = 6118,
  [6134] = 6134,
  [6135] = 6134,
  [6136] = 4387,
  [6137] = 4388,
  [6138] = 4404,
  [6139] = 6139,
  [6140] = 6140,
  [6141] = 2809,
  [6142] = 6142,
  [6143] = 3997,
  [6144] = 3993,
  [6145] = 6145,
  [6146] = 2785,
  [6147] = 6147,
  [6148] = 6148,
  [6149] = 4424,
  [6150] = 6150,
  [6151] = 6129,
  [6152] = 3008,
  [6153] = 6153,
  [6154] = 6095,
  [6155] = 6129,
  [6156] = 6134,
  [6157] = 4043,
  [6158] = 4573,
  [6159] = 6098,
  [6160] = 3008,
  [6161] = 3002,
  [6162] = 2826,
  [6163] = 6147,
  [6164] = 6164,
  [6165] = 6165,
  [6166] = 2992,
  [6167] = 4373,
  [6168] = 4384,
  [6169] = 4382,
  [6170] = 4385,
  [6171] = 4354,
  [6172] = 4386,
  [6173] = 4387,
  [6174] = 4388,
  [6175] = 6175,
  [6176] = 4356,
  [6177] = 4357,
  [6178] = 4668,
  [6179] = 4358,
  [6180] = 6180,
  [6181] = 6181,
  [6182] = 4390,
  [6183] = 4336,
  [6184] = 4668,
  [6185] = 4391,
  [6186] = 4395,
  [6187] = 4396,
  [6188] = 4401,
  [6189] = 4402,
  [6190] = 4359,
  [6191] = 4404,
  [6192] = 4420,
  [6193] = 4424,
  [6194] = 6194,
  [6195] = 6195,
  [6196] = 4404,
  [6197] = 4668,
  [6198] = 6198,
  [6199] = 4420,
  [6200] = 4573,
  [6201] = 4359,
  [6202] = 6147,
  [6203] = 4398,
  [6204] = 6129,
  [6205] = 4371,
  [6206] = 5910,
  [6207] = 4668,
  [6208] = 4402,
  [6209] = 4401,
  [6210] = 6210,
  [6211] = 4398,
  [6212] = 5924,
  [6213] = 6213,
  [6214] = 4396,
  [6215] = 6129,
  [6216] = 6216,
  [6217] = 4395,
  [6218] = 2992,
  [6219] = 6134,
  [6220] = 4394,
  [6221] = 6221,
  [6222] = 6198,
  [6223] = 4424,
  [6224] = 4391,
  [6225] = 4043,
  [6226] = 4336,
  [6227] = 4668,
  [6228] = 4573,
  [6229] = 4390,
  [6230] = 3584,
  [6231] = 6231,
  [6232] = 5796,
  [6233] = 6129,
  [6234] = 4420,
  [6235] = 6221,
  [6236] = 4398,
  [6237] = 4358,
  [6238] = 4357,
  [6239] = 6147,
  [6240] = 4371,
  [6241] = 4388,
  [6242] = 4387,
  [6243] = 4386,
  [6244] = 6244,
  [6245] = 4354,
  [6246] = 4385,
  [6247] = 4382,
  [6248] = 4384,
  [6249] = 4373,
  [6250] = 6250,
  [6251] = 4373,
  [6252] = 4384,
  [6253] = 5936,
  [6254] = 4382,
  [6255] = 4385,
  [6256] = 4354,
  [6257] = 4386,
  [6258] = 4387,
  [6259] = 4388,
  [6260] = 4356,
  [6261] = 4357,
  [6262] = 4358,
  [6263] = 6148,
  [6264] = 4390,
  [6265] = 4336,
  [6266] = 6210,
  [6267] = 4391,
  [6268] = 4394,
  [6269] = 4395,
  [6270] = 4396,
  [6271] = 4401,
  [6272] = 4402,
  [6273] = 4359,
  [6274] = 4404,
  [6275] = 6194,
  [6276] = 4356,
  [6277] = 6277,
  [6278] = 5709,
  [6279] = 4401,
  [6280] = 4043,
  [6281] = 6281,
  [6282] = 4668,
  [6283] = 4373,
  [6284] = 6277,
  [6285] = 6285,
  [6286] = 6285,
  [6287] = 6287,
  [6288] = 4384,
  [6289] = 6289,
  [6290] = 6290,
  [6291] = 4510,
  [6292] = 4382,
  [6293] = 6293,
  [6294] = 4359,
  [6295] = 4385,
  [6296] = 4354,
  [6297] = 4386,
  [6298] = 6290,
  [6299] = 6277,
  [6300] = 6289,
  [6301] = 4387,
  [6302] = 4388,
  [6303] = 6289,
  [6304] = 4356,
  [6305] = 6305,
  [6306] = 6306,
  [6307] = 4357,
  [6308] = 6308,
  [6309] = 6277,
  [6310] = 6277,
  [6311] = 6289,
  [6312] = 4358,
  [6313] = 6277,
  [6314] = 6289,
  [6315] = 6289,
  [6316] = 4396,
  [6317] = 6317,
  [6318] = 6293,
  [6319] = 4668,
  [6320] = 6320,
  [6321] = 6321,
  [6322] = 6277,
  [6323] = 4395,
  [6324] = 6324,
  [6325] = 6277,
  [6326] = 6281,
  [6327] = 6327,
  [6328] = 4390,
  [6329] = 6289,
  [6330] = 6287,
  [6331] = 6331,
  [6332] = 6332,
  [6333] = 4336,
  [6334] = 4391,
  [6335] = 4404,
  [6336] = 4396,
  [6337] = 6337,
  [6338] = 6277,
  [6339] = 6339,
  [6340] = 4510,
  [6341] = 6341,
  [6342] = 6277,
  [6343] = 6305,
  [6344] = 4573,
  [6345] = 6308,
  [6346] = 6346,
  [6347] = 6347,
  [6348] = 6348,
  [6349] = 4573,
  [6350] = 6350,
  [6351] = 6339,
  [6352] = 4394,
  [6353] = 4401,
  [6354] = 6332,
  [6355] = 6289,
  [6356] = 6277,
  [6357] = 4395,
  [6358] = 4439,
  [6359] = 6359,
  [6360] = 6327,
  [6361] = 4437,
  [6362] = 4395,
  [6363] = 6277,
  [6364] = 6364,
  [6365] = 6277,
  [6366] = 6366,
  [6367] = 4394,
  [6368] = 6341,
  [6369] = 6289,
  [6370] = 6289,
  [6371] = 4391,
  [6372] = 6372,
  [6373] = 6346,
  [6374] = 6277,
  [6375] = 4668,
  [6376] = 6293,
  [6377] = 6277,
  [6378] = 6372,
  [6379] = 6289,
  [6380] = 6290,
  [6381] = 6332,
  [6382] = 6348,
  [6383] = 6350,
  [6384] = 6384,
  [6385] = 4043,
  [6386] = 4336,
  [6387] = 6320,
  [6388] = 6324,
  [6389] = 4390,
  [6390] = 6339,
  [6391] = 6391,
  [6392] = 6277,
  [6393] = 6277,
  [6394] = 6277,
  [6395] = 4476,
  [6396] = 6396,
  [6397] = 4510,
  [6398] = 4373,
  [6399] = 6332,
  [6400] = 6331,
  [6401] = 4384,
  [6402] = 4382,
  [6403] = 4404,
  [6404] = 6339,
  [6405] = 2843,
  [6406] = 6289,
  [6407] = 6290,
  [6408] = 6408,
  [6409] = 6289,
  [6410] = 4402,
  [6411] = 6277,
  [6412] = 6277,
  [6413] = 6413,
  [6414] = 6414,
  [6415] = 4479,
  [6416] = 4385,
  [6417] = 4396,
  [6418] = 6337,
  [6419] = 6277,
  [6420] = 6420,
  [6421] = 6277,
  [6422] = 4402,
  [6423] = 4371,
  [6424] = 4359,
  [6425] = 4386,
  [6426] = 4439,
  [6427] = 4437,
  [6428] = 4387,
  [6429] = 4476,
  [6430] = 4398,
  [6431] = 4479,
  [6432] = 4388,
  [6433] = 6364,
  [6434] = 6277,
  [6435] = 6277,
  [6436] = 6289,
  [6437] = 6289,
  [6438] = 6321,
  [6439] = 5709,
  [6440] = 6277,
  [6441] = 4354,
  [6442] = 6366,
  [6443] = 4043,
  [6444] = 6277,
  [6445] = 4394,
  [6446] = 4356,
  [6447] = 4371,
  [6448] = 6277,
  [6449] = 4357,
  [6450] = 4402,
  [6451] = 4358,
  [6452] = 6452,
  [6453] = 4404,
  [6454] = 4398,
  [6455] = 6455,
  [6456] = 6391,
  [6457] = 6331,
  [6458] = 6277,
  [6459] = 6320,
  [6460] = 6460,
  [6461] = 6277,
  [6462] = 6281,
  [6463] = 6320,
  [6464] = 6359,
  [6465] = 6372,
  [6466] = 6391,
  [6467] = 6277,
  [6468] = 6331,
  [6469] = 4358,
  [6470] = 4371,
  [6471] = 6277,
  [6472] = 4357,
  [6473] = 4356,
  [6474] = 4388,
  [6475] = 4387,
  [6476] = 4386,
  [6477] = 4354,
  [6478] = 4385,
  [6479] = 6337,
  [6480] = 4359,
  [6481] = 4382,
  [6482] = 4384,
  [6483] = 4373,
  [6484] = 6460,
  [6485] = 6364,
  [6486] = 4043,
  [6487] = 4510,
  [6488] = 4391,
  [6489] = 4402,
  [6490] = 4401,
  [6491] = 6321,
  [6492] = 4404,
  [6493] = 4573,
  [6494] = 5709,
  [6495] = 6455,
  [6496] = 6277,
  [6497] = 6277,
  [6498] = 4371,
  [6499] = 6277,
  [6500] = 4043,
  [6501] = 6359,
  [6502] = 2913,
  [6503] = 6391,
  [6504] = 6277,
  [6505] = 4396,
  [6506] = 6331,
  [6507] = 6507,
  [6508] = 4439,
  [6509] = 6509,
  [6510] = 4398,
  [6511] = 4668,
  [6512] = 4437,
  [6513] = 4398,
  [6514] = 4573,
  [6515] = 2743,
  [6516] = 6277,
  [6517] = 4371,
  [6518] = 6289,
  [6519] = 4395,
  [6520] = 4476,
  [6521] = 4358,
  [6522] = 4479,
  [6523] = 6277,
  [6524] = 4357,
  [6525] = 4356,
  [6526] = 4394,
  [6527] = 4388,
  [6528] = 6277,
  [6529] = 4573,
  [6530] = 4387,
  [6531] = 6531,
  [6532] = 4391,
  [6533] = 4401,
  [6534] = 4336,
  [6535] = 4336,
  [6536] = 6289,
  [6537] = 4390,
  [6538] = 6538,
  [6539] = 4386,
  [6540] = 6285,
  [6541] = 6366,
  [6542] = 4668,
  [6543] = 6150,
  [6544] = 6320,
  [6545] = 6293,
  [6546] = 6372,
  [6547] = 6364,
  [6548] = 4402,
  [6549] = 6359,
  [6550] = 4390,
  [6551] = 4336,
  [6552] = 4391,
  [6553] = 4394,
  [6554] = 4354,
  [6555] = 4395,
  [6556] = 4385,
  [6557] = 4396,
  [6558] = 6321,
  [6559] = 4401,
  [6560] = 2992,
  [6561] = 4404,
  [6562] = 4373,
  [6563] = 4384,
  [6564] = 4382,
  [6565] = 4359,
  [6566] = 4359,
  [6567] = 4385,
  [6568] = 4354,
  [6569] = 4386,
  [6570] = 4387,
  [6571] = 4479,
  [6572] = 4388,
  [6573] = 4373,
  [6574] = 6320,
  [6575] = 4384,
  [6576] = 4382,
  [6577] = 4356,
  [6578] = 4359,
  [6579] = 4357,
  [6580] = 6277,
  [6581] = 4390,
  [6582] = 4358,
  [6583] = 6460,
  [6584] = 4385,
  [6585] = 4354,
  [6586] = 4386,
  [6587] = 4387,
  [6588] = 4382,
  [6589] = 6277,
  [6590] = 4388,
  [6591] = 6591,
  [6592] = 6366,
  [6593] = 4384,
  [6594] = 6285,
  [6595] = 4402,
  [6596] = 4373,
  [6597] = 4356,
  [6598] = 6598,
  [6599] = 4476,
  [6600] = 4357,
  [6601] = 6277,
  [6602] = 4358,
  [6603] = 4401,
  [6604] = 6281,
  [6605] = 6372,
  [6606] = 6359,
  [6607] = 4437,
  [6608] = 6289,
  [6609] = 6277,
  [6610] = 6337,
  [6611] = 6611,
  [6612] = 6277,
  [6613] = 4396,
  [6614] = 6281,
  [6615] = 6287,
  [6616] = 6341,
  [6617] = 4439,
  [6618] = 6305,
  [6619] = 4395,
  [6620] = 6281,
  [6621] = 6308,
  [6622] = 4394,
  [6623] = 6327,
  [6624] = 4391,
  [6625] = 6348,
  [6626] = 6350,
  [6627] = 4371,
  [6628] = 6287,
  [6629] = 4336,
  [6630] = 4398,
  [6631] = 6277,
  [6632] = 6460,
  [6633] = 4390,
  [6634] = 6289,
  [6635] = 6277,
  [6636] = 6327,
  [6637] = 6341,
  [6638] = 4043,
  [6639] = 6277,
  [6640] = 4668,
  [6641] = 6324,
  [6642] = 6289,
  [6643] = 6277,
  [6644] = 6324,
  [6645] = 6350,
  [6646] = 6308,
  [6647] = 6348,
  [6648] = 6305,
  [6649] = 4404,
  [6650] = 6372,
  [6651] = 4398,
  [6652] = 6359,
  [6653] = 4573,
  [6654] = 6277,
  [6655] = 6655,
  [6656] = 2826,
  [6657] = 2809,
  [6658] = 6655,
  [6659] = 6655,
  [6660] = 6655,
  [6661] = 2843,
  [6662] = 6655,
  [6663] = 6655,
  [6664] = 2992,
  [6665] = 6655,
  [6666] = 2992,
  [6667] = 6655,
  [6668] = 2843,
  [6669] = 2992,
  [6670] = 6655,
  [6671] = 2869,
  [6672] = 2851,
  [6673] = 2992,
  [6674] = 6655,
  [6675] = 6655,
  [6676] = 6655,
  [6677] = 6655,
  [6678] = 3766,
  [6679] = 3739,
  [6680] = 6655,
  [6681] = 2193,
  [6682] = 2192,
  [6683] = 6655,
  [6684] = 2992,
  [6685] = 2992,
  [6686] = 6655,
  [6687] = 6655,
  [6688] = 6655,
  [6689] = 6655,
  [6690] = 6655,
  [6691] = 6655,
  [6692] = 6655,
  [6693] = 6655,
  [6694] = 2732,
  [6695] = 2859,
  [6696] = 2733,
  [6697] = 6655,
  [6698] = 6698,
  [6699] = 6655,
  [6700] = 6700,
  [6701] = 3758,
  [6702] = 3746,
  [6703] = 3753,
  [6704] = 6655,
  [6705] = 6655,
  [6706] = 6655,
  [6707] = 6655,
  [6708] = 2853,
  [6709] = 6655,
  [6710] = 6655,
  [6711] = 6655,
  [6712] = 6712,
  [6713] = 6713,
  [6714] = 6714,
  [6715] = 6715,
  [6716] = 6716,
  [6717] = 6698,
  [6718] = 6150,
  [6719] = 6719,
  [6720] = 6720,
  [6721] = 6721,
  [6722] = 2992,
  [6723] = 2992,
  [6724] = 6150,
  [6725] = 6725,
  [6726] = 2992,
  [6727] = 2992,
  [6728] = 6728,
  [6729] = 6729,
  [6730] = 2808,
  [6731] = 2859,
  [6732] = 6732,
  [6733] = 2913,
  [6734] = 3002,
  [6735] = 2853,
  [6736] = 6729,
  [6737] = 6732,
  [6738] = 6738,
  [6739] = 2869,
  [6740] = 6740,
  [6741] = 2851,
  [6742] = 6509,
  [6743] = 6743,
  [6744] = 6744,
  [6745] = 6745,
  [6746] = 6746,
  [6747] = 6747,
  [6748] = 6748,
  [6749] = 6749,
  [6750] = 6748,
  [6751] = 6751,
  [6752] = 6748,
  [6753] = 6749,
  [6754] = 2740,
  [6755] = 6755,
  [6756] = 6746,
  [6757] = 6745,
  [6758] = 6751,
  [6759] = 6746,
  [6760] = 6760,
  [6761] = 6746,
  [6762] = 6762,
  [6763] = 6745,
  [6764] = 6751,
  [6765] = 6751,
  [6766] = 6744,
  [6767] = 6746,
  [6768] = 6748,
  [6769] = 6748,
  [6770] = 6770,
  [6771] = 6771,
  [6772] = 6751,
  [6773] = 6773,
  [6774] = 6774,
  [6775] = 6775,
  [6776] = 6776,
  [6777] = 6775,
  [6778] = 6774,
  [6779] = 6774,
  [6780] = 6780,
  [6781] = 6781,
  [6782] = 6775,
  [6783] = 2959,
  [6784] = 6784,
  [6785] = 6785,
  [6786] = 6786,
  [6787] = 6787,
  [6788] = 6788,
  [6789] = 6785,
  [6790] = 6775,
  [6791] = 6791,
  [6792] = 6775,
  [6793] = 6793,
  [6794] = 6794,
  [6795] = 6795,
  [6796] = 6796,
  [6797] = 6795,
  [6798] = 6795,
  [6799] = 6795,
  [6800] = 6795,
  [6801] = 6801,
  [6802] = 6795,
  [6803] = 6795,
  [6804] = 6795,
  [6805] = 6795,
  [6806] = 6795,
  [6807] = 6795,
  [6808] = 6795,
  [6809] = 6801,
  [6810] = 6810,
  [6811] = 6811,
  [6812] = 6794,
  [6813] = 6795,
  [6814] = 6795,
  [6815] = 6795,
  [6816] = 6795,
  [6817] = 6795,
  [6818] = 6795,
  [6819] = 6794,
  [6820] = 3008,
  [6821] = 6795,
  [6822] = 6795,
  [6823] = 6795,
  [6824] = 6811,
  [6825] = 6825,
  [6826] = 6795,
  [6827] = 6801,
  [6828] = 6795,
  [6829] = 6795,
  [6830] = 6830,
  [6831] = 6795,
  [6832] = 6810,
  [6833] = 6833,
  [6834] = 6795,
  [6835] = 6795,
  [6836] = 6795,
  [6837] = 6810,
  [6838] = 6795,
  [6839] = 6795,
  [6840] = 6840,
  [6841] = 6801,
  [6842] = 6842,
  [6843] = 6795,
  [6844] = 6795,
  [6845] = 6845,
  [6846] = 6795,
  [6847] = 6847,
  [6848] = 6795,
  [6849] = 6795,
  [6850] = 6847,
  [6851] = 6796,
  [6852] = 6795,
  [6853] = 6795,
  [6854] = 6795,
  [6855] = 6855,
  [6856] = 6795,
  [6857] = 6795,
  [6858] = 6795,
  [6859] = 6796,
  [6860] = 6795,
  [6861] = 6795,
  [6862] = 6795,
  [6863] = 6795,
  [6864] = 6864,
  [6865] = 6795,
  [6866] = 6866,
  [6867] = 6811,
  [6868] = 6795,
  [6869] = 6795,
  [6870] = 6840,
  [6871] = 6810,
  [6872] = 6810,
  [6873] = 6801,
  [6874] = 2992,
  [6875] = 6875,
  [6876] = 6875,
  [6877] = 2992,
  [6878] = 2992,
  [6879] = 2992,
  [6880] = 2992,
  [6881] = 2992,
  [6882] = 2962,
  [6883] = 2962,
  [6884] = 6875,
  [6885] = 6885,
  [6886] = 6886,
  [6887] = 2992,
  [6888] = 2992,
  [6889] = 2992,
  [6890] = 2962,
  [6891] = 6891,
  [6892] = 2962,
  [6893] = 2992,
  [6894] = 2992,
  [6895] = 6895,
  [6896] = 2992,
  [6897] = 2992,
  [6898] = 2992,
  [6899] = 6875,
  [6900] = 6895,
  [6901] = 2992,
  [6902] = 6886,
  [6903] = 6903,
  [6904] = 2992,
  [6905] = 2992,
  [6906] = 6906,
  [6907] = 6907,
  [6908] = 2992,
  [6909] = 2992,
  [6910] = 2992,
  [6911] = 2992,
  [6912] = 6886,
  [6913] = 2992,
  [6914] = 2992,
  [6915] = 6886,
  [6916] = 6916,
  [6917] = 6917,
  [6918] = 2992,
  [6919] = 2992,
  [6920] = 6920,
  [6921] = 6920,
  [6922] = 2843,
  [6923] = 6923,
  [6924] = 6923,
  [6925] = 6925,
  [6926] = 2843,
  [6927] = 6920,
  [6928] = 6923,
  [6929] = 6920,
  [6930] = 6920,
  [6931] = 6920,
  [6932] = 6920,
  [6933] = 2843,
  [6934] = 6923,
  [6935] = 6923,
  [6936] = 6925,
  [6937] = 2843,
  [6938] = 6925,
  [6939] = 6923,
  [6940] = 6920,
  [6941] = 6925,
  [6942] = 6920,
  [6943] = 6920,
  [6944] = 2843,
  [6945] = 6923,
  [6946] = 2843,
  [6947] = 6920,
  [6948] = 6920,
  [6949] = 6923,
  [6950] = 6925,
  [6951] = 2843,
  [6952] = 6925,
  [6953] = 6953,
  [6954] = 2843,
  [6955] = 6923,
  [6956] = 6956,
  [6957] = 6920,
  [6958] = 6925,
  [6959] = 6925,
  [6960] = 6925,
  [6961] = 6925,
  [6962] = 6920,
  [6963] = 6925,
  [6964] = 2843,
  [6965] = 2843,
  [6966] = 2843,
  [6967] = 6925,
  [6968] = 2843,
  [6969] = 6920,
  [6970] = 6920,
  [6971] = 6971,
  [6972] = 6925,
  [6973] = 2843,
  [6974] = 6974,
  [6975] = 6920,
  [6976] = 6923,
  [6977] = 6920,
  [6978] = 6920,
  [6979] = 6923,
  [6980] = 6925,
  [6981] = 6920,
  [6982] = 6923,
  [6983] = 2843,
  [6984] = 6925,
  [6985] = 6920,
  [6986] = 6916,
  [6987] = 6925,
  [6988] = 6920,
  [6989] = 2843,
  [6990] = 6923,
  [6991] = 6925,
  [6992] = 6925,
  [6993] = 6920,
  [6994] = 6994,
  [6995] = 6995,
  [6996] = 2843,
  [6997] = 6997,
  [6998] = 6923,
  [6999] = 6920,
  [7000] = 6925,
  [7001] = 2843,
  [7002] = 6920,
  [7003] = 6923,
  [7004] = 6920,
  [7005] = 2843,
  [7006] = 6925,
  [7007] = 6923,
  [7008] = 2843,
  [7009] = 6925,
  [7010] = 6920,
  [7011] = 6923,
  [7012] = 2843,
  [7013] = 6923,
  [7014] = 6923,
  [7015] = 2843,
  [7016] = 6925,
  [7017] = 6923,
  [7018] = 6923,
  [7019] = 6923,
  [7020] = 2843,
  [7021] = 6923,
  [7022] = 2843,
  [7023] = 6925,
  [7024] = 2843,
  [7025] = 6925,
  [7026] = 6974,
  [7027] = 6925,
  [7028] = 6920,
  [7029] = 6923,
  [7030] = 6920,
  [7031] = 6920,
  [7032] = 6923,
  [7033] = 6920,
  [7034] = 6923,
  [7035] = 6920,
  [7036] = 6923,
  [7037] = 6923,
  [7038] = 6923,
  [7039] = 2843,
  [7040] = 6923,
  [7041] = 6923,
  [7042] = 7042,
  [7043] = 2843,
  [7044] = 6956,
  [7045] = 6997,
  [7046] = 6925,
  [7047] = 6956,
  [7048] = 6925,
  [7049] = 6995,
  [7050] = 6925,
  [7051] = 3584,
  [7052] = 2843,
  [7053] = 6995,
  [7054] = 6923,
  [7055] = 6925,
  [7056] = 6920,
  [7057] = 6923,
  [7058] = 6920,
  [7059] = 2843,
  [7060] = 2843,
  [7061] = 6925,
  [7062] = 6925,
  [7063] = 2843,
  [7064] = 6925,
  [7065] = 7065,
  [7066] = 6925,
  [7067] = 2843,
  [7068] = 6925,
  [7069] = 6920,
  [7070] = 6920,
  [7071] = 6920,
  [7072] = 6925,
  [7073] = 6920,
  [7074] = 6920,
  [7075] = 6925,
  [7076] = 6925,
  [7077] = 6923,
  [7078] = 6923,
  [7079] = 6920,
  [7080] = 6925,
  [7081] = 2843,
  [7082] = 6925,
  [7083] = 2843,
  [7084] = 6923,
  [7085] = 6925,
  [7086] = 6923,
  [7087] = 2843,
  [7088] = 6923,
  [7089] = 6925,
  [7090] = 6997,
  [7091] = 2843,
  [7092] = 2843,
  [7093] = 6923,
  [7094] = 6925,
  [7095] = 2843,
  [7096] = 6925,
  [7097] = 2843,
  [7098] = 2843,
  [7099] = 6920,
  [7100] = 6920,
  [7101] = 6923,
  [7102] = 6956,
  [7103] = 2843,
  [7104] = 6925,
  [7105] = 6994,
  [7106] = 6920,
  [7107] = 6920,
  [7108] = 6925,
  [7109] = 6925,
  [7110] = 6923,
  [7111] = 6995,
  [7112] = 6923,
  [7113] = 6923,
  [7114] = 7065,
  [7115] = 2843,
  [7116] = 6923,
  [7117] = 6923,
  [7118] = 6923,
  [7119] = 6920,
  [7120] = 6923,
  [7121] = 6920,
  [7122] = 6920,
  [7123] = 2843,
  [7124] = 2843,
  [7125] = 6920,
  [7126] = 6925,
  [7127] = 6995,
  [7128] = 6923,
  [7129] = 6925,
  [7130] = 2843,
  [7131] = 7131,
  [7132] = 7132,
  [7133] = 7133,
  [7134] = 7134,
  [7135] = 7133,
  [7136] = 7133,
  [7137] = 7134,
  [7138] = 7133,
  [7139] = 7139,
  [7140] = 7131,
  [7141] = 7133,
  [7142] = 7142,
  [7143] = 7133,
  [7144] = 7133,
  [7145] = 7142,
  [7146] = 7142,
  [7147] = 7133,
  [7148] = 7132,
  [7149] = 7133,
  [7150] = 7134,
  [7151] = 7139,
  [7152] = 7133,
  [7153] = 7133,
  [7154] = 7133,
  [7155] = 7131,
  [7156] = 7133,
  [7157] = 7133,
  [7158] = 7133,
  [7159] = 7134,
  [7160] = 7134,
  [7161] = 7131,
  [7162] = 7133,
  [7163] = 7139,
  [7164] = 7164,
  [7165] = 7139,
  [7166] = 7133,
  [7167] = 7133,
  [7168] = 7168,
  [7169] = 7139,
  [7170] = 7131,
  [7171] = 7133,
  [7172] = 7131,
  [7173] = 7173,
  [7174] = 7131,
  [7175] = 7164,
  [7176] = 7134,
  [7177] = 7133,
  [7178] = 7178,
  [7179] = 7132,
  [7180] = 7131,
  [7181] = 7133,
  [7182] = 7139,
  [7183] = 7133,
  [7184] = 7133,
  [7185] = 7173,
  [7186] = 7133,
  [7187] = 7187,
  [7188] = 7133,
  [7189] = 7133,
  [7190] = 7190,
  [7191] = 7133,
  [7192] = 7134,
  [7193] = 7139,
  [7194] = 7133,
  [7195] = 7133,
  [7196] = 7196,
  [7197] = 7173,
  [7198] = 7198,
  [7199] = 7133,
  [7200] = 7133,
  [7201] = 7133,
  [7202] = 7202,
  [7203] = 7133,
  [7204] = 7204,
  [7205] = 7139,
  [7206] = 7134,
  [7207] = 7133,
  [7208] = 7131,
  [7209] = 7131,
  [7210] = 7190,
  [7211] = 7173,
  [7212] = 7142,
  [7213] = 7133,
  [7214] = 7133,
  [7215] = 7133,
  [7216] = 7173,
  [7217] = 7133,
  [7218] = 7190,
  [7219] = 7142,
  [7220] = 7133,
  [7221] = 7139,
  [7222] = 7139,
  [7223] = 7131,
  [7224] = 7133,
  [7225] = 7225,
  [7226] = 7133,
  [7227] = 7139,
  [7228] = 7164,
  [7229] = 7133,
  [7230] = 7133,
  [7231] = 7131,
  [7232] = 7133,
  [7233] = 7133,
  [7234] = 7133,
  [7235] = 7133,
  [7236] = 7134,
  [7237] = 7133,
  [7238] = 7133,
  [7239] = 7133,
  [7240] = 7133,
  [7241] = 7133,
  [7242] = 7133,
  [7243] = 7133,
  [7244] = 7133,
  [7245] = 7139,
  [7246] = 7142,
  [7247] = 7133,
  [7248] = 7131,
  [7249] = 7131,
  [7250] = 7131,
  [7251] = 7139,
  [7252] = 7139,
  [7253] = 7253,
  [7254] = 7139,
  [7255] = 7255,
  [7256] = 3739,
  [7257] = 7257,
  [7258] = 7258,
  [7259] = 7259,
  [7260] = 3766,
  [7261] = 3753,
  [7262] = 3758,
  [7263] = 7263,
  [7264] = 3746,
  [7265] = 7265,
  [7266] = 7266,
  [7267] = 7267,
  [7268] = 7268,
  [7269] = 7269,
  [7270] = 7270,
  [7271] = 7266,
  [7272] = 7272,
  [7273] = 7266,
  [7274] = 7274,
  [7275] = 7266,
  [7276] = 7276,
  [7277] = 7277,
  [7278] = 7278,
  [7279] = 7279,
  [7280] = 7266,
  [7281] = 7281,
  [7282] = 7282,
  [7283] = 7272,
  [7284] = 7284,
  [7285] = 7285,
  [7286] = 7266,
  [7287] = 7287,
  [7288] = 7266,
  [7289] = 7289,
  [7290] = 7290,
  [7291] = 7291,
  [7292] = 7266,
  [7293] = 7266,
  [7294] = 7294,
  [7295] = 7290,
  [7296] = 7281,
  [7297] = 7266,
  [7298] = 7279,
  [7299] = 7285,
  [7300] = 7267,
  [7301] = 7301,
  [7302] = 7302,
  [7303] = 7303,
  [7304] = 7272,
  [7305] = 7266,
  [7306] = 7306,
  [7307] = 7266,
  [7308] = 7308,
  [7309] = 7284,
  [7310] = 7310,
  [7311] = 7282,
  [7312] = 7312,
  [7313] = 7313,
  [7314] = 7266,
  [7315] = 7285,
  [7316] = 7289,
  [7317] = 7281,
  [7318] = 7310,
  [7319] = 7319,
  [7320] = 7266,
  [7321] = 7291,
  [7322] = 7268,
  [7323] = 7266,
  [7324] = 7324,
  [7325] = 7325,
  [7326] = 7326,
  [7327] = 7289,
  [7328] = 7270,
  [7329] = 7329,
  [7330] = 7330,
  [7331] = 7291,
  [7332] = 7332,
  [7333] = 7270,
  [7334] = 7277,
  [7335] = 7266,
  [7336] = 7313,
  [7337] = 7337,
  [7338] = 7290,
  [7339] = 7312,
  [7340] = 7287,
  [7341] = 7310,
  [7342] = 7266,
  [7343] = 7277,
  [7344] = 7303,
  [7345] = 7325,
  [7346] = 7324,
  [7347] = 7266,
  [7348] = 7287,
  [7349] = 7325,
  [7350] = 7324,
  [7351] = 7284,
  [7352] = 7282,
  [7353] = 7278,
  [7354] = 7313,
  [7355] = 7279,
  [7356] = 7312,
  [7357] = 7303,
  [7358] = 7268,
  [7359] = 7266,
  [7360] = 7270,
  [7361] = 7266,
  [7362] = 7267,
  [7363] = 7363,
  [7364] = 7364,
  [7365] = 7365,
  [7366] = 7366,
  [7367] = 7367,
  [7368] = 7368,
  [7369] = 7369,
  [7370] = 7370,
  [7371] = 7371,
  [7372] = 7372,
  [7373] = 7373,
  [7374] = 7374,
  [7375] = 7375,
  [7376] = 7376,
  [7377] = 7377,
  [7378] = 7377,
  [7379] = 7377,
  [7380] = 7377,
  [7381] = 7377,
  [7382] = 7377,
  [7383] = 7377,
  [7384] = 7377,
  [7385] = 7377,
  [7386] = 7377,
  [7387] = 7377,
  [7388] = 7377,
  [7389] = 7377,
  [7390] = 7377,
  [7391] = 7377,
  [7392] = 7377,
  [7393] = 7377,
  [7394] = 7377,
  [7395] = 7377,
  [7396] = 7377,
  [7397] = 7377,
  [7398] = 7377,
  [7399] = 7377,
  [7400] = 7377,
  [7401] = 7377,
  [7402] = 7377,
  [7403] = 7377,
  [7404] = 7377,
  [7405] = 7377,
  [7406] = 7377,
  [7407] = 7377,
  [7408] = 7377,
  [7409] = 7377,
  [7410] = 7377,
  [7411] = 7377,
  [7412] = 7377,
  [7413] = 7413,
  [7414] = 7414,
  [7415] = 7415,
  [7416] = 7414,
  [7417] = 7415,
  [7418] = 7413,
  [7419] = 7415,
  [7420] = 7413,
  [7421] = 7414,
  [7422] = 7415,
  [7423] = 7415,
  [7424] = 7415,
  [7425] = 7415,
  [7426] = 7415,
  [7427] = 7413,
  [7428] = 7413,
  [7429] = 7415,
  [7430] = 7414,
  [7431] = 7414,
  [7432] = 7413,
  [7433] = 7415,
  [7434] = 7413,
  [7435] = 7415,
  [7436] = 7414,
  [7437] = 7414,
  [7438] = 7413,
  [7439] = 7415,
  [7440] = 7414,
  [7441] = 7414,
  [7442] = 7414,
  [7443] = 7414,
  [7444] = 7413,
  [7445] = 7414,
  [7446] = 7413,
  [7447] = 7413,
  [7448] = 7415,
  [7449] = 7413,
  [7450] = 7414,
  [7451] = 7413,
  [7452] = 7414,
  [7453] = 7414,
  [7454] = 7415,
  [7455] = 7413,
  [7456] = 7413,
  [7457] = 7415,
  [7458] = 7414,
  [7459] = 7414,
  [7460] = 7415,
  [7461] = 7415,
  [7462] = 7413,
  [7463] = 7414,
  [7464] = 7415,
  [7465] = 7413,
  [7466] = 7414,
  [7467] = 7414,
  [7468] = 7413,
  [7469] = 7413,
  [7470] = 7415,
  [7471] = 7415,
  [7472] = 7413,
  [7473] = 7473,
  [7474] = 7474,
  [7475] = 7475,
  [7476] = 7476,
  [7477] = 7477,
  [7478] = 7478,
  [7479] = 7479,
  [7480] = 7478,
  [7481] = 7478,
  [7482] = 7482,
  [7483] = 7477,
  [7484] = 7482,
  [7485] = 7477,
  [7486] = 7482,
  [7487] = 7479,
  [7488] = 7479,
  [7489] = 7489,
  [7490] = 7490,
  [7491] = 7489,
  [7492] = 7492,
  [7493] = 7493,
  [7494] = 7494,
  [7495] = 7495,
  [7496] = 7496,
  [7497] = 7496,
  [7498] = 7495,
  [7499] = 7499,
  [7500] = 7496,
  [7501] = 7492,
  [7502] = 7502,
  [7503] = 7503,
  [7504] = 7503,
  [7505] = 7499,
  [7506] = 7499,
  [7507] = 7492,
  [7508] = 7495,
  [7509] = 7503,
  [7510] = 7502,
  [7511] = 7502,
  [7512] = 7512,
  [7513] = 7489,
  [7514] = 7514,
  [7515] = 7515,
  [7516] = 7515,
  [7517] = 7514,
  [7518] = 7518,
  [7519] = 7519,
  [7520] = 7520,
  [7521] = 7515,
  [7522] = 7518,
  [7523] = 7519,
  [7524] = 7514,
  [7525] = 7518,
  [7526] = 7520,
  [7527] = 7515,
  [7528] = 7520,
  [7529] = 7519,
  [7530] = 7530,
  [7531] = 7531,
  [7532] = 7532,
  [7533] = 7533,
  [7534] = 7534,
  [7535] = 7535,
  [7536] = 7536,
  [7537] = 7537,
  [7538] = 7538,
  [7539] = 7539,
  [7540] = 7540,
  [7541] = 7540,
  [7542] = 7540,
  [7543] = 7543,
  [7544] = 7544,
  [7545] = 7533,
  [7546] = 7546,
  [7547] = 7547,
  [7548] = 7548,
  [7549] = 7549,
  [7550] = 7550,
  [7551] = 7551,
  [7552] = 7552,
  [7553] = 7553,
  [7554] = 7554,
  [7555] = 7555,
  [7556] = 7546,
  [7557] = 7531,
  [7558] = 7558,
  [7559] = 7559,
  [7560] = 7534,
  [7561] = 7549,
  [7562] = 7562,
  [7563] = 7536,
  [7564] = 7564,
  [7565] = 7565,
  [7566] = 7538,
  [7567] = 7555,
  [7568] = 7559,
  [7569] = 7569,
  [7570] = 7570,
  [7571] = 7544,
  [7572] = 7570,
  [7573] = 7573,
  [7574] = 7574,
  [7575] = 7570,
  [7576] = 7576,
  [7577] = 7577,
  [7578] = 7559,
  [7579] = 7579,
  [7580] = 7577,
  [7581] = 7581,
  [7582] = 7535,
  [7583] = 7555,
  [7584] = 7584,
  [7585] = 7585,
  [7586] = 7546,
  [7587] = 7585,
  [7588] = 7537,
  [7589] = 7589,
  [7590] = 7534,
  [7591] = 7548,
  [7592] = 7592,
  [7593] = 7536,
  [7594] = 7548,
  [7595] = 7595,
  [7596] = 7535,
  [7597] = 7531,
  [7598] = 7574,
  [7599] = 7533,
  [7600] = 7558,
  [7601] = 7564,
  [7602] = 7549,
  [7603] = 7603,
  [7604] = 7574,
  [7605] = 7549,
  [7606] = 7531,
  [7607] = 7544,
  [7608] = 7539,
  [7609] = 7603,
  [7610] = 7555,
  [7611] = 7559,
  [7612] = 7537,
  [7613] = 7535,
  [7614] = 7585,
  [7615] = 7577,
  [7616] = 7532,
  [7617] = 7564,
  [7618] = 7603,
  [7619] = 7619,
  [7620] = 7620,
  [7621] = 7558,
  [7622] = 7539,
  [7623] = 7532,
  [7624] = 7570,
  [7625] = 7546,
  [7626] = 7539,
  [7627] = 7627,
  [7628] = 7544,
  [7629] = 7629,
  [7630] = 7603,
  [7631] = 7631,
  [7632] = 7577,
  [7633] = 7537,
  [7634] = 7574,
  [7635] = 7635,
  [7636] = 7636,
  [7637] = 7637,
  [7638] = 7538,
  [7639] = 7639,
  [7640] = 7640,
  [7641] = 7641,
  [7642] = 7642,
  [7643] = 7643,
  [7644] = 7644,
  [7645] = 7644,
  [7646] = 7646,
  [7647] = 7646,
  [7648] = 7648,
  [7649] = 7649,
  [7650] = 7650,
  [7651] = 7648,
  [7652] = 7649,
  [7653] = 7653,
  [7654] = 7654,
  [7655] = 7655,
  [7656] = 7656,
  [7657] = 7648,
  [7658] = 7646,
  [7659] = 7659,
  [7660] = 7656,
  [7661] = 7661,
  [7662] = 7656,
  [7663] = 7644,
  [7664] = 7642,
  [7665] = 7642,
  [7666] = 7641,
  [7667] = 7667,
  [7668] = 7668,
  [7669] = 7649,
  [7670] = 7670,
  [7671] = 7641,
  [7672] = 7667,
  [7673] = 7667,
  [7674] = 7674,
  [7675] = 7675,
  [7676] = 7676,
  [7677] = 7677,
  [7678] = 7678,
  [7679] = 7679,
  [7680] = 7680,
  [7681] = 7680,
  [7682] = 7677,
  [7683] = 7683,
  [7684] = 7684,
  [7685] = 7685,
  [7686] = 7680,
  [7687] = 7687,
  [7688] = 7676,
  [7689] = 7683,
  [7690] = 7679,
  [7691] = 7691,
  [7692] = 7684,
  [7693] = 7674,
  [7694] = 7694,
  [7695] = 7695,
  [7696] = 7696,
  [7697] = 7697,
  [7698] = 7698,
  [7699] = 7697,
  [7700] = 7675,
  [7701] = 2199,
  [7702] = 7695,
  [7703] = 7676,
  [7704] = 7704,
  [7705] = 7705,
  [7706] = 7706,
  [7707] = 7678,
  [7708] = 7698,
  [7709] = 7709,
  [7710] = 7696,
  [7711] = 7691,
  [7712] = 7712,
  [7713] = 7676,
  [7714] = 7683,
  [7715] = 7705,
  [7716] = 7694,
  [7717] = 7676,
  [7718] = 7706,
  [7719] = 2198,
  [7720] = 7677,
  [7721] = 7674,
  [7722] = 7704,
  [7723] = 7679,
  [7724] = 7696,
  [7725] = 7683,
  [7726] = 7691,
  [7727] = 7697,
  [7728] = 7698,
  [7729] = 7694,
  [7730] = 7704,
  [7731] = 7687,
  [7732] = 7706,
  [7733] = 7687,
  [7734] = 7675,
  [7735] = 7735,
  [7736] = 7684,
  [7737] = 7705,
  [7738] = 7683,
  [7739] = 7678,
  [7740] = 7740,
  [7741] = 7695,
  [7742] = 6732,
  [7743] = 7743,
  [7744] = 7744,
  [7745] = 7745,
  [7746] = 7746,
  [7747] = 7747,
  [7748] = 7748,
  [7749] = 7749,
  [7750] = 7750,
  [7751] = 7751,
  [7752] = 7752,
  [7753] = 7753,
  [7754] = 7754,
  [7755] = 7746,
  [7756] = 2200,
  [7757] = 7757,
  [7758] = 7758,
  [7759] = 7759,
  [7760] = 7760,
  [7761] = 7761,
  [7762] = 3002,
  [7763] = 7763,
  [7764] = 7764,
  [7765] = 7765,
  [7766] = 7748,
  [7767] = 7767,
  [7768] = 7768,
  [7769] = 7769,
  [7770] = 7770,
  [7771] = 7771,
  [7772] = 7772,
  [7773] = 7773,
  [7774] = 7774,
  [7775] = 7775,
  [7776] = 7776,
  [7777] = 7775,
  [7778] = 7770,
  [7779] = 7752,
  [7780] = 7771,
  [7781] = 7764,
  [7782] = 7750,
  [7783] = 7774,
  [7784] = 7772,
  [7785] = 7785,
  [7786] = 7763,
  [7787] = 7787,
  [7788] = 7788,
  [7789] = 7789,
  [7790] = 7760,
  [7791] = 7791,
  [7792] = 7758,
  [7793] = 7770,
  [7794] = 7794,
  [7795] = 7795,
  [7796] = 7743,
  [7797] = 7797,
  [7798] = 7768,
  [7799] = 7745,
  [7800] = 7758,
  [7801] = 7801,
  [7802] = 7752,
  [7803] = 7774,
  [7804] = 7747,
  [7805] = 7805,
  [7806] = 7772,
  [7807] = 7807,
  [7808] = 7808,
  [7809] = 7809,
  [7810] = 7810,
  [7811] = 7763,
  [7812] = 7769,
  [7813] = 7750,
  [7814] = 7814,
  [7815] = 7746,
  [7816] = 7814,
  [7817] = 7745,
  [7818] = 7764,
  [7819] = 7748,
  [7820] = 7787,
  [7821] = 7744,
  [7822] = 7822,
  [7823] = 7823,
  [7824] = 7760,
  [7825] = 7744,
  [7826] = 7754,
  [7827] = 7751,
  [7828] = 7791,
  [7829] = 2732,
  [7830] = 7823,
  [7831] = 7831,
  [7832] = 7785,
  [7833] = 7833,
  [7834] = 7776,
  [7835] = 7835,
  [7836] = 7772,
  [7837] = 7808,
  [7838] = 7838,
  [7839] = 7839,
  [7840] = 2733,
  [7841] = 7768,
  [7842] = 7842,
  [7843] = 7787,
  [7844] = 7785,
  [7845] = 7772,
  [7846] = 7846,
  [7847] = 7847,
  [7848] = 7848,
  [7849] = 7849,
  [7850] = 7850,
  [7851] = 7775,
  [7852] = 7791,
  [7853] = 7757,
  [7854] = 7788,
  [7855] = 7855,
  [7856] = 7833,
  [7857] = 7857,
  [7858] = 7833,
  [7859] = 7791,
  [7860] = 7860,
  [7861] = 7758,
  [7862] = 7758,
  [7863] = 7768,
  [7864] = 7787,
  [7865] = 7743,
  [7866] = 7823,
  [7867] = 7846,
  [7868] = 7848,
  [7869] = 7771,
  [7870] = 7870,
  [7871] = 7846,
  [7872] = 7848,
  [7873] = 7757,
  [7874] = 7874,
  [7875] = 7875,
  [7876] = 7876,
  [7877] = 7768,
  [7878] = 7878,
  [7879] = 7879,
  [7880] = 7776,
  [7881] = 7751,
  [7882] = 7882,
  [7883] = 7876,
  [7884] = 7876,
  [7885] = 7878,
  [7886] = 7791,
  [7887] = 7887,
  [7888] = 7878,
  [7889] = 7889,
  [7890] = 7773,
  [7891] = 7814,
  [7892] = 7772,
  [7893] = 7791,
  [7894] = 7808,
  [7895] = 7773,
  [7896] = 7769,
  [7897] = 7897,
  [7898] = 7787,
  [7899] = 7785,
  [7900] = 7754,
  [7901] = 7747,
  [7902] = 7902,
  [7903] = 7788,
  [7904] = 7785,
  [7905] = 7905,
  [7906] = 7753,
  [7907] = 7907,
  [7908] = 7908,
  [7909] = 7909,
  [7910] = 7754,
  [7911] = 7911,
  [7912] = 7753,
  [7913] = 7913,
  [7914] = 7914,
  [7915] = 7915,
  [7916] = 7916,
  [7917] = 7917,
  [7918] = 7918,
  [7919] = 7919,
  [7920] = 7920,
  [7921] = 7921,
  [7922] = 7922,
  [7923] = 7923,
  [7924] = 7924,
  [7925] = 7925,
  [7926] = 7926,
  [7927] = 7927,
  [7928] = 7913,
  [7929] = 7929,
  [7930] = 7930,
  [7931] = 7931,
  [7932] = 7932,
  [7933] = 7933,
  [7934] = 7934,
  [7935] = 7935,
  [7936] = 7936,
  [7937] = 7937,
  [7938] = 7938,
  [7939] = 7939,
  [7940] = 7940,
  [7941] = 7941,
  [7942] = 7942,
  [7943] = 7943,
  [7944] = 7944,
  [7945] = 7945,
  [7946] = 7929,
  [7947] = 7947,
  [7948] = 7947,
  [7949] = 7949,
  [7950] = 7929,
  [7951] = 7951,
  [7952] = 7952,
  [7953] = 7953,
  [7954] = 7954,
  [7955] = 7955,
  [7956] = 7936,
  [7957] = 7957,
  [7958] = 7922,
  [7959] = 7959,
  [7960] = 7917,
  [7961] = 7961,
  [7962] = 7962,
  [7963] = 7963,
  [7964] = 7964,
  [7965] = 7965,
  [7966] = 7966,
  [7967] = 7967,
  [7968] = 7968,
  [7969] = 7969,
  [7970] = 7970,
  [7971] = 7971,
  [7972] = 7972,
  [7973] = 7973,
  [7974] = 7974,
  [7975] = 7975,
  [7976] = 7938,
  [7977] = 7977,
  [7978] = 7978,
  [7979] = 7979,
  [7980] = 7980,
  [7981] = 7981,
  [7982] = 7982,
  [7983] = 7983,
  [7984] = 7926,
  [7985] = 7983,
  [7986] = 7986,
  [7987] = 7987,
  [7988] = 7988,
  [7989] = 7989,
  [7990] = 7990,
  [7991] = 7914,
  [7992] = 7992,
  [7993] = 7993,
  [7994] = 7994,
  [7995] = 7989,
  [7996] = 7994,
  [7997] = 7993,
  [7998] = 7992,
  [7999] = 7999,
  [8000] = 7914,
  [8001] = 7990,
  [8002] = 7988,
  [8003] = 7987,
  [8004] = 7986,
  [8005] = 7968,
  [8006] = 8006,
  [8007] = 7957,
  [8008] = 8008,
  [8009] = 7955,
  [8010] = 7939,
  [8011] = 7954,
  [8012] = 7953,
  [8013] = 7952,
  [8014] = 7951,
  [8015] = 7949,
  [8016] = 8016,
  [8017] = 7982,
  [8018] = 7981,
  [8019] = 7930,
  [8020] = 7977,
  [8021] = 7930,
  [8022] = 7975,
  [8023] = 7919,
  [8024] = 7918,
  [8025] = 7915,
  [8026] = 8026,
  [8027] = 7983,
  [8028] = 8026,
  [8029] = 8029,
  [8030] = 8030,
  [8031] = 7967,
  [8032] = 8032,
  [8033] = 8033,
  [8034] = 7966,
  [8035] = 7965,
  [8036] = 7964,
  [8037] = 8037,
  [8038] = 8038,
  [8039] = 8039,
  [8040] = 8040,
  [8041] = 8041,
  [8042] = 7937,
  [8043] = 8043,
  [8044] = 8044,
  [8045] = 7929,
  [8046] = 7962,
  [8047] = 8047,
  [8048] = 7935,
  [8049] = 7917,
  [8050] = 8050,
  [8051] = 7974,
  [8052] = 7922,
  [8053] = 7913,
  [8054] = 7933,
  [8055] = 7932,
  [8056] = 7980,
  [8057] = 8029,
  [8058] = 8008,
  [8059] = 7949,
  [8060] = 7944,
  [8061] = 8061,
  [8062] = 7926,
  [8063] = 7939,
  [8064] = 7973,
  [8065] = 8065,
  [8066] = 7937,
  [8067] = 7931,
  [8068] = 7936,
  [8069] = 7935,
  [8070] = 7972,
  [8071] = 8071,
  [8072] = 7933,
  [8073] = 7932,
  [8074] = 7931,
  [8075] = 7971,
  [8076] = 8030,
  [8077] = 7964,
  [8078] = 7965,
  [8079] = 8079,
  [8080] = 8080,
  [8081] = 7966,
  [8082] = 7969,
  [8083] = 8083,
  [8084] = 7967,
  [8085] = 7921,
  [8086] = 7920,
  [8087] = 7975,
  [8088] = 7943,
  [8089] = 7977,
  [8090] = 7951,
  [8091] = 7981,
  [8092] = 7942,
  [8093] = 7983,
  [8094] = 7941,
  [8095] = 7982,
  [8096] = 7916,
  [8097] = 8097,
  [8098] = 7938,
  [8099] = 7940,
  [8100] = 8100,
  [8101] = 8079,
  [8102] = 8102,
  [8103] = 8103,
  [8104] = 8032,
  [8105] = 7952,
  [8106] = 8106,
  [8107] = 7953,
  [8108] = 4668,
  [8109] = 8109,
  [8110] = 8033,
  [8111] = 8032,
  [8112] = 7913,
  [8113] = 3617,
  [8114] = 8114,
  [8115] = 8033,
  [8116] = 7954,
  [8117] = 7955,
  [8118] = 7957,
  [8119] = 8030,
  [8120] = 7927,
  [8121] = 7968,
  [8122] = 7938,
  [8123] = 7921,
  [8124] = 7925,
  [8125] = 7920,
  [8126] = 7947,
  [8127] = 7916,
  [8128] = 7990,
  [8129] = 7945,
  [8130] = 7962,
  [8131] = 7992,
  [8132] = 8079,
  [8133] = 7993,
  [8134] = 8134,
  [8135] = 7994,
  [8136] = 8136,
  [8137] = 7924,
  [8138] = 7925,
  [8139] = 8139,
  [8140] = 7927,
  [8141] = 8141,
  [8142] = 8044,
  [8143] = 3697,
  [8144] = 7940,
  [8145] = 8026,
  [8146] = 7924,
  [8147] = 7941,
  [8148] = 7942,
  [8149] = 8149,
  [8150] = 7943,
  [8151] = 7944,
  [8152] = 7945,
  [8153] = 8029,
  [8154] = 8037,
  [8155] = 8155,
  [8156] = 7929,
  [8157] = 7919,
  [8158] = 8158,
  [8159] = 7918,
  [8160] = 8160,
  [8161] = 7915,
  [8162] = 7929,
  [8163] = 7926,
  [8164] = 8044,
  [8165] = 7983,
  [8166] = 7949,
  [8167] = 8041,
  [8168] = 8168,
  [8169] = 8109,
  [8170] = 8170,
  [8171] = 7983,
  [8172] = 8050,
  [8173] = 8039,
  [8174] = 8008,
  [8175] = 7979,
  [8176] = 7938,
  [8177] = 8177,
  [8178] = 7929,
  [8179] = 8065,
  [8180] = 2973,
  [8181] = 7938,
  [8182] = 8182,
  [8183] = 7913,
  [8184] = 7947,
  [8185] = 7986,
  [8186] = 8186,
  [8187] = 8041,
  [8188] = 8040,
  [8189] = 8039,
  [8190] = 7969,
  [8191] = 8155,
  [8192] = 7974,
  [8193] = 8139,
  [8194] = 8134,
  [8195] = 8114,
  [8196] = 8037,
  [8197] = 7970,
  [8198] = 7970,
  [8199] = 7973,
  [8200] = 4573,
  [8201] = 8040,
  [8202] = 8008,
  [8203] = 7971,
  [8204] = 7989,
  [8205] = 7972,
  [8206] = 7988,
  [8207] = 7987,
  [8208] = 8208,
  [8209] = 8209,
  [8210] = 8210,
  [8211] = 8211,
  [8212] = 8212,
  [8213] = 8213,
  [8214] = 8214,
  [8215] = 2975,
  [8216] = 8216,
  [8217] = 8217,
  [8218] = 2877,
  [8219] = 8211,
  [8220] = 2871,
  [8221] = 8209,
  [8222] = 8222,
  [8223] = 8223,
  [8224] = 8224,
  [8225] = 8225,
  [8226] = 8211,
  [8227] = 2207,
  [8228] = 8228,
  [8229] = 2209,
  [8230] = 8230,
  [8231] = 8231,
  [8232] = 8232,
  [8233] = 8233,
  [8234] = 2881,
  [8235] = 8211,
  [8236] = 8236,
  [8237] = 8237,
  [8238] = 8211,
  [8239] = 8228,
  [8240] = 8240,
  [8241] = 4573,
  [8242] = 8242,
  [8243] = 8243,
  [8244] = 8216,
  [8245] = 8245,
  [8246] = 8246,
  [8247] = 8247,
  [8248] = 8248,
  [8249] = 8249,
  [8250] = 8250,
  [8251] = 8251,
  [8252] = 8252,
  [8253] = 8253,
  [8254] = 8237,
  [8255] = 8240,
  [8256] = 8256,
  [8257] = 8257,
  [8258] = 8253,
  [8259] = 8211,
  [8260] = 8260,
  [8261] = 8261,
  [8262] = 8262,
  [8263] = 8210,
  [8264] = 8212,
  [8265] = 8265,
  [8266] = 8266,
  [8267] = 8267,
  [8268] = 8268,
  [8269] = 8211,
  [8270] = 8261,
  [8271] = 8260,
  [8272] = 8272,
  [8273] = 8273,
  [8274] = 8213,
  [8275] = 8248,
  [8276] = 8211,
  [8277] = 8277,
  [8278] = 8278,
  [8279] = 8212,
  [8280] = 2897,
  [8281] = 8281,
  [8282] = 8233,
  [8283] = 8283,
  [8284] = 8230,
  [8285] = 8261,
  [8286] = 8246,
  [8287] = 4573,
  [8288] = 2901,
  [8289] = 8265,
  [8290] = 8257,
  [8291] = 8247,
  [8292] = 8292,
  [8293] = 8245,
  [8294] = 8249,
  [8295] = 8260,
  [8296] = 8296,
  [8297] = 8248,
  [8298] = 8298,
  [8299] = 8299,
  [8300] = 8223,
  [8301] = 8231,
  [8302] = 8253,
  [8303] = 4668,
  [8304] = 8304,
  [8305] = 8305,
  [8306] = 8306,
  [8307] = 8307,
  [8308] = 2208,
  [8309] = 8309,
  [8310] = 8267,
  [8311] = 8272,
  [8312] = 8312,
  [8313] = 8249,
  [8314] = 8314,
  [8315] = 8240,
  [8316] = 8267,
  [8317] = 8253,
  [8318] = 8265,
  [8319] = 8257,
  [8320] = 8320,
  [8321] = 8272,
  [8322] = 4668,
  [8323] = 8323,
  [8324] = 8228,
  [8325] = 8210,
  [8326] = 8213,
  [8327] = 4573,
  [8328] = 8328,
  [8329] = 8253,
  [8330] = 8231,
  [8331] = 8216,
  [8332] = 8332,
  [8333] = 8216,
  [8334] = 8334,
  [8335] = 8245,
  [8336] = 8336,
  [8337] = 8247,
  [8338] = 4668,
  [8339] = 8248,
  [8340] = 2204,
  [8341] = 8223,
  [8342] = 8342,
  [8343] = 8343,
  [8344] = 8246,
  [8345] = 8230,
  [8346] = 8346,
  [8347] = 8347,
  [8348] = 8348,
  [8349] = 8332,
  [8350] = 8350,
  [8351] = 8351,
  [8352] = 8352,
  [8353] = 8353,
  [8354] = 8354,
  [8355] = 8355,
  [8356] = 8356,
  [8357] = 8357,
  [8358] = 8358,
  [8359] = 8359,
  [8360] = 8360,
  [8361] = 8361,
  [8362] = 8362,
  [8363] = 8363,
  [8364] = 8364,
  [8365] = 8365,
  [8366] = 8366,
  [8367] = 8367,
  [8368] = 8368,
  [8369] = 8369,
  [8370] = 8370,
  [8371] = 8371,
  [8372] = 8360,
  [8373] = 8373,
  [8374] = 8374,
  [8375] = 8375,
  [8376] = 8376,
  [8377] = 8346,
  [8378] = 8366,
  [8379] = 8379,
  [8380] = 8380,
  [8381] = 8381,
  [8382] = 8382,
  [8383] = 8361,
  [8384] = 8346,
  [8385] = 8385,
  [8386] = 8386,
  [8387] = 8387,
  [8388] = 8388,
  [8389] = 8358,
  [8390] = 8390,
  [8391] = 8370,
  [8392] = 8277,
  [8393] = 8393,
  [8394] = 8394,
  [8395] = 8359,
  [8396] = 8369,
  [8397] = 8397,
  [8398] = 8398,
  [8399] = 8399,
  [8400] = 8399,
  [8401] = 8401,
  [8402] = 8402,
  [8403] = 8403,
  [8404] = 8361,
  [8405] = 8405,
  [8406] = 8370,
  [8407] = 8369,
  [8408] = 8356,
  [8409] = 8346,
  [8410] = 8365,
  [8411] = 8411,
  [8412] = 8412,
  [8413] = 8386,
  [8414] = 8369,
  [8415] = 8394,
  [8416] = 8416,
  [8417] = 8417,
  [8418] = 8418,
  [8419] = 8366,
  [8420] = 8420,
  [8421] = 8421,
  [8422] = 8422,
  [8423] = 8423,
  [8424] = 8424,
  [8425] = 8402,
  [8426] = 8379,
  [8427] = 8381,
  [8428] = 8428,
  [8429] = 8417,
  [8430] = 8430,
  [8431] = 8431,
  [8432] = 8423,
  [8433] = 8368,
  [8434] = 8434,
  [8435] = 8423,
  [8436] = 8394,
  [8437] = 8437,
  [8438] = 8438,
  [8439] = 8422,
  [8440] = 8440,
  [8441] = 8428,
  [8442] = 8417,
  [8443] = 8443,
  [8444] = 8431,
  [8445] = 8445,
  [8446] = 8445,
  [8447] = 8447,
  [8448] = 8448,
  [8449] = 8368,
  [8450] = 8450,
  [8451] = 8352,
  [8452] = 8346,
  [8453] = 8421,
  [8454] = 8398,
  [8455] = 8455,
  [8456] = 8456,
  [8457] = 8386,
  [8458] = 8356,
  [8459] = 8459,
  [8460] = 8388,
  [8461] = 8366,
  [8462] = 8375,
  [8463] = 8463,
  [8464] = 8358,
  [8465] = 8359,
  [8466] = 8466,
  [8467] = 8366,
  [8468] = 8393,
  [8469] = 8375,
  [8470] = 8399,
  [8471] = 8371,
  [8472] = 8368,
  [8473] = 8430,
  [8474] = 8353,
  [8475] = 8388,
  [8476] = 8370,
  [8477] = 8398,
  [8478] = 8478,
  [8479] = 8369,
  [8480] = 8369,
  [8481] = 8370,
  [8482] = 8482,
  [8483] = 8361,
  [8484] = 8393,
  [8485] = 8393,
  [8486] = 8399,
  [8487] = 8487,
  [8488] = 8346,
  [8489] = 8423,
  [8490] = 8388,
  [8491] = 8491,
  [8492] = 8352,
  [8493] = 8431,
  [8494] = 8371,
  [8495] = 8421,
  [8496] = 8298,
  [8497] = 8497,
  [8498] = 8368,
  [8499] = 8463,
  [8500] = 8463,
  [8501] = 8430,
  [8502] = 8502,
  [8503] = 8503,
  [8504] = 8504,
  [8505] = 8505,
  [8506] = 8506,
  [8507] = 8361,
  [8508] = 8508,
  [8509] = 8370,
  [8510] = 8358,
  [8511] = 8366,
  [8512] = 8366,
  [8513] = 8352,
  [8514] = 8386,
  [8515] = 8515,
  [8516] = 8421,
  [8517] = 8353,
  [8518] = 8518,
  [8519] = 8370,
  [8520] = 8422,
  [8521] = 8366,
  [8522] = 8351,
  [8523] = 8523,
  [8524] = 8365,
  [8525] = 8364,
  [8526] = 8363,
  [8527] = 8359,
  [8528] = 8350,
  [8529] = 8529,
  [8530] = 8370,
  [8531] = 8531,
  [8532] = 8532,
  [8533] = 8369,
  [8534] = 8534,
  [8535] = 8428,
  [8536] = 8536,
  [8537] = 8537,
  [8538] = 8358,
  [8539] = 8402,
  [8540] = 8540,
  [8541] = 8541,
  [8542] = 8445,
  [8543] = 8543,
  [8544] = 8360,
  [8545] = 8545,
  [8546] = 8356,
  [8547] = 8361,
  [8548] = 8369,
  [8549] = 8368,
  [8550] = 8369,
  [8551] = 8250,
  [8552] = 8366,
  [8553] = 8553,
  [8554] = 8351,
  [8555] = 8353,
  [8556] = 8370,
  [8557] = 8369,
  [8558] = 8366,
  [8559] = 8281,
  [8560] = 8445,
  [8561] = 8388,
  [8562] = 8368,
  [8563] = 8371,
  [8564] = 8370,
  [8565] = 8369,
  [8566] = 8375,
  [8567] = 8334,
  [8568] = 8379,
  [8569] = 8366,
  [8570] = 8366,
  [8571] = 8571,
  [8572] = 8572,
  [8573] = 8352,
  [8574] = 8431,
  [8575] = 8430,
  [8576] = 8370,
  [8577] = 8417,
  [8578] = 8428,
  [8579] = 8450,
  [8580] = 8580,
  [8581] = 8423,
  [8582] = 3008,
  [8583] = 8394,
  [8584] = 8402,
  [8585] = 8456,
  [8586] = 8346,
  [8587] = 8366,
  [8588] = 8588,
  [8589] = 8399,
  [8590] = 8370,
  [8591] = 8369,
  [8592] = 8398,
  [8593] = 8386,
  [8594] = 8365,
  [8595] = 8360,
  [8596] = 8356,
  [8597] = 8463,
  [8598] = 8393,
  [8599] = 8366,
  [8600] = 8375,
  [8601] = 8381,
  [8602] = 8381,
  [8603] = 8375,
  [8604] = 8356,
  [8605] = 8360,
  [8606] = 8371,
  [8607] = 8365,
  [8608] = 8491,
  [8609] = 8386,
  [8610] = 8361,
  [8611] = 8502,
  [8612] = 8612,
  [8613] = 8613,
  [8614] = 8614,
  [8615] = 8615,
  [8616] = 8353,
  [8617] = 8351,
  [8618] = 8350,
  [8619] = 8369,
  [8620] = 8370,
  [8621] = 8379,
  [8622] = 8622,
  [8623] = 8370,
  [8624] = 8624,
  [8625] = 8625,
  [8626] = 8361,
  [8627] = 8627,
  [8628] = 8369,
  [8629] = 8350,
  [8630] = 8630,
  [8631] = 8631,
  [8632] = 8632,
  [8633] = 8388,
  [8634] = 8634,
  [8635] = 8393,
  [8636] = 8398,
  [8637] = 8399,
  [8638] = 8346,
  [8639] = 8394,
  [8640] = 8534,
  [8641] = 8641,
  [8642] = 8632,
  [8643] = 8423,
  [8644] = 8402,
  [8645] = 8422,
  [8646] = 8428,
  [8647] = 8417,
  [8648] = 8350,
  [8649] = 8625,
  [8650] = 8487,
  [8651] = 8352,
  [8652] = 8277,
  [8653] = 8541,
  [8654] = 8654,
  [8655] = 8543,
  [8656] = 8545,
  [8657] = 8657,
  [8658] = 8351,
  [8659] = 8358,
  [8660] = 8359,
  [8661] = 8353,
  [8662] = 8662,
  [8663] = 8299,
  [8664] = 8296,
  [8665] = 8251,
  [8666] = 8368,
  [8667] = 8371,
  [8668] = 8668,
  [8669] = 8669,
  [8670] = 8670,
  [8671] = 8671,
  [8672] = 8668,
  [8673] = 3609,
  [8674] = 8674,
  [8675] = 8675,
  [8676] = 8676,
  [8677] = 8677,
  [8678] = 8678,
  [8679] = 8679,
  [8680] = 8680,
  [8681] = 8681,
  [8682] = 8682,
  [8683] = 8683,
  [8684] = 8684,
  [8685] = 3599,
  [8686] = 8686,
  [8687] = 8687,
  [8688] = 8688,
  [8689] = 8689,
  [8690] = 8690,
  [8691] = 8691,
  [8692] = 2216,
  [8693] = 8693,
  [8694] = 8694,
  [8695] = 8695,
  [8696] = 2273,
  [8697] = 8697,
  [8698] = 2267,
  [8699] = 8699,
  [8700] = 2255,
  [8701] = 2254,
  [8702] = 2217,
  [8703] = 8703,
  [8704] = 2898,
  [8705] = 2218,
  [8706] = 8706,
  [8707] = 8707,
  [8708] = 2219,
  [8709] = 2221,
  [8710] = 8694,
  [8711] = 2222,
  [8712] = 8680,
  [8713] = 8713,
  [8714] = 2223,
  [8715] = 2899,
  [8716] = 2907,
  [8717] = 2225,
  [8718] = 8718,
  [8719] = 2226,
  [8720] = 8720,
  [8721] = 8721,
  [8722] = 2227,
  [8723] = 2229,
  [8724] = 8724,
  [8725] = 8725,
  [8726] = 2230,
  [8727] = 8703,
  [8728] = 2235,
  [8729] = 2236,
  [8730] = 2239,
  [8731] = 2242,
  [8732] = 2240,
  [8733] = 2244,
  [8734] = 2245,
  [8735] = 2253,
  [8736] = 2892,
  [8737] = 2258,
  [8738] = 2259,
  [8739] = 2261,
  [8740] = 8720,
  [8741] = 8741,
  [8742] = 8742,
  [8743] = 8743,
  [8744] = 2263,
  [8745] = 8745,
  [8746] = 8703,
  [8747] = 2264,
  [8748] = 8720,
  [8749] = 2269,
  [8750] = 2270,
  [8751] = 2271,
  [8752] = 8752,
  [8753] = 2275,
  [8754] = 2243,
  [8755] = 8680,
  [8756] = 8682,
  [8757] = 2295,
  [8758] = 8758,
  [8759] = 8707,
  [8760] = 8760,
  [8761] = 8706,
  [8762] = 8682,
  [8763] = 8763,
  [8764] = 8689,
  [8765] = 2289,
  [8766] = 8690,
  [8767] = 8767,
  [8768] = 8680,
  [8769] = 8769,
  [8770] = 2294,
  [8771] = 8771,
  [8772] = 2292,
  [8773] = 2291,
  [8774] = 8695,
  [8775] = 2290,
  [8776] = 8776,
  [8777] = 2288,
  [8778] = 8697,
  [8779] = 8779,
  [8780] = 2282,
  [8781] = 2281,
  [8782] = 2268,
  [8783] = 2266,
  [8784] = 2283,
  [8785] = 8760,
  [8786] = 8763,
  [8787] = 8787,
  [8788] = 8788,
  [8789] = 8789,
  [8790] = 8790,
  [8791] = 8791,
  [8792] = 2260,
  [8793] = 8793,
  [8794] = 8794,
  [8795] = 8795,
  [8796] = 8796,
  [8797] = 8797,
  [8798] = 8798,
  [8799] = 8676,
  [8800] = 8800,
  [8801] = 8800,
  [8802] = 8802,
  [8803] = 8671,
  [8804] = 8804,
  [8805] = 2265,
  [8806] = 2257,
  [8807] = 8670,
  [8808] = 8680,
  [8809] = 2241,
  [8810] = 8810,
  [8811] = 8811,
  [8812] = 2238,
  [8813] = 2232,
  [8814] = 8814,
  [8815] = 2293,
  [8816] = 2284,
  [8817] = 2228,
  [8818] = 8669,
  [8819] = 8819,
  [8820] = 8820,
  [8821] = 8821,
  [8822] = 8822,
  [8823] = 8823,
  [8824] = 8697,
  [8825] = 8825,
  [8826] = 8826,
  [8827] = 8760,
  [8828] = 8810,
  [8829] = 8829,
  [8830] = 8690,
  [8831] = 8831,
  [8832] = 8695,
  [8833] = 8680,
  [8834] = 8834,
  [8835] = 2285,
  [8836] = 8707,
  [8837] = 8689,
  [8838] = 2276,
  [8839] = 2280,
  [8840] = 2286,
  [8841] = 8684,
  [8842] = 2287,
  [8843] = 8843,
  [8844] = 2247,
  [8845] = 8674,
  [8846] = 8706,
  [8847] = 2262,
  [8848] = 2215,
  [8849] = 8760,
  [8850] = 8850,
  [8851] = 2252,
  [8852] = 8852,
  [8853] = 8853,
  [8854] = 2249,
  [8855] = 8763,
  [8856] = 8856,
  [8857] = 8857,
  [8858] = 8858,
  [8859] = 8859,
  [8860] = 8860,
  [8861] = 2248,
  [8862] = 8862,
  [8863] = 2246,
  [8864] = 8802,
  [8865] = 8669,
  [8866] = 2214,
  [8867] = 2234,
  [8868] = 8689,
  [8869] = 8869,
  [8870] = 8682,
  [8871] = 2231,
  [8872] = 2220,
  [8873] = 8682,
  [8874] = 2251,
  [8875] = 2272,
  [8876] = 8720,
  [8877] = 8877,
  [8878] = 8800,
  [8879] = 8680,
  [8880] = 8694,
  [8881] = 8881,
  [8882] = 8694,
  [8883] = 8802,
  [8884] = 8884,
  [8885] = 8707,
  [8886] = 8763,
  [8887] = 8706,
  [8888] = 8680,
  [8889] = 8822,
  [8890] = 8823,
  [8891] = 8891,
  [8892] = 8892,
  [8893] = 8893,
  [8894] = 8894,
  [8895] = 8895,
  [8896] = 8697,
  [8897] = 8897,
  [8898] = 8898,
  [8899] = 8899,
  [8900] = 8675,
  [8901] = 8901,
  [8902] = 8682,
  [8903] = 8802,
  [8904] = 8718,
  [8905] = 8674,
  [8906] = 8906,
  [8907] = 8689,
  [8908] = 8908,
  [8909] = 8689,
  [8910] = 8831,
  [8911] = 8911,
  [8912] = 8831,
  [8913] = 8690,
  [8914] = 8914,
  [8915] = 8703,
  [8916] = 8690,
  [8917] = 8720,
  [8918] = 8918,
  [8919] = 8707,
  [8920] = 8831,
  [8921] = 8706,
  [8922] = 8690,
  [8923] = 8695,
  [8924] = 8924,
  [8925] = 8924,
  [8926] = 8684,
  [8927] = 8927,
  [8928] = 8676,
  [8929] = 8695,
  [8930] = 8924,
  [8931] = 8706,
  [8932] = 8932,
  [8933] = 8697,
  [8934] = 8706,
  [8935] = 8676,
  [8936] = 8877,
  [8937] = 8937,
  [8938] = 8800,
  [8939] = 8939,
  [8940] = 8822,
  [8941] = 8671,
  [8942] = 8810,
  [8943] = 8718,
  [8944] = 8859,
  [8945] = 8810,
  [8946] = 8859,
  [8947] = 8668,
  [8948] = 8670,
  [8949] = 8675,
  [8950] = 8720,
  [8951] = 8697,
  [8952] = 8706,
  [8953] = 8823,
  [8954] = 8695,
  [8955] = 8823,
  [8956] = 8822,
  [8957] = 8669,
  [8958] = 8958,
  [8959] = 8959,
  [8960] = 8960,
  [8961] = 8961,
  [8962] = 8962,
  [8963] = 8963,
  [8964] = 8964,
  [8965] = 8965,
  [8966] = 8966,
  [8967] = 8967,
  [8968] = 8968,
  [8969] = 8969,
  [8970] = 8970,
  [8971] = 8971,
  [8972] = 8972,
  [8973] = 8973,
  [8974] = 8974,
  [8975] = 8975,
  [8976] = 8976,
  [8977] = 8977,
  [8978] = 8978,
  [8979] = 8979,
  [8980] = 8980,
  [8981] = 8981,
  [8982] = 8982,
  [8983] = 8983,
  [8984] = 8984,
  [8985] = 8985,
  [8986] = 8958,
  [8987] = 8966,
  [8988] = 8988,
  [8989] = 8989,
  [8990] = 8990,
  [8991] = 8991,
  [8992] = 8992,
  [8993] = 8993,
  [8994] = 8994,
  [8995] = 8995,
  [8996] = 8996,
  [8997] = 8997,
  [8998] = 8998,
  [8999] = 8999,
  [9000] = 9000,
  [9001] = 9001,
  [9002] = 8998,
  [9003] = 9003,
  [9004] = 9001,
  [9005] = 9000,
  [9006] = 8995,
  [9007] = 8994,
  [9008] = 8992,
  [9009] = 8996,
  [9010] = 9010,
  [9011] = 8990,
  [9012] = 8975,
  [9013] = 8974,
  [9014] = 8995,
  [9015] = 8972,
  [9016] = 8991,
  [9017] = 8985,
  [9018] = 8984,
  [9019] = 8971,
  [9020] = 8964,
  [9021] = 8962,
  [9022] = 8997,
  [9023] = 8961,
  [9024] = 8988,
  [9025] = 9025,
  [9026] = 9026,
  [9027] = 8973,
  [9028] = 8982,
  [9029] = 8999,
  [9030] = 9030,
  [9031] = 9031,
  [9032] = 8995,
  [9033] = 8958,
  [9034] = 8989,
  [9035] = 8981,
  [9036] = 9036,
  [9037] = 9037,
  [9038] = 9038,
  [9039] = 9039,
  [9040] = 8980,
  [9041] = 9041,
  [9042] = 8997,
  [9043] = 9043,
  [9044] = 8999,
  [9045] = 9045,
  [9046] = 8979,
  [9047] = 8978,
  [9048] = 8977,
  [9049] = 8995,
  [9050] = 9050,
  [9051] = 8976,
  [9052] = 9052,
  [9053] = 8999,
  [9054] = 8997,
  [9055] = 9055,
  [9056] = 9056,
  [9057] = 9057,
  [9058] = 9058,
  [9059] = 9059,
  [9060] = 8970,
  [9061] = 9061,
  [9062] = 8969,
  [9063] = 8973,
  [9064] = 8968,
  [9065] = 8967,
  [9066] = 9066,
  [9067] = 9067,
  [9068] = 9068,
  [9069] = 9069,
  [9070] = 9070,
  [9071] = 9071,
  [9072] = 8997,
  [9073] = 8958,
  [9074] = 8989,
  [9075] = 9026,
  [9076] = 9076,
  [9077] = 8965,
  [9078] = 9078,
  [9079] = 9079,
  [9080] = 9080,
  [9081] = 8989,
  [9082] = 8997,
  [9083] = 8988,
  [9084] = 8999,
  [9085] = 8963,
  [9086] = 8960,
  [9087] = 9069,
  [9088] = 9088,
  [9089] = 8966,
  [9090] = 8995,
  [9091] = 9057,
  [9092] = 8958,
  [9093] = 8995,
  [9094] = 9094,
  [9095] = 8983,
  [9096] = 9068,
  [9097] = 9097,
  [9098] = 9098,
  [9099] = 8995,
  [9100] = 9100,
  [9101] = 9101,
  [9102] = 8973,
  [9103] = 9103,
  [9104] = 8999,
  [9105] = 9068,
  [9106] = 9106,
  [9107] = 9107,
  [9108] = 9108,
  [9109] = 9109,
  [9110] = 8958,
  [9111] = 8989,
  [9112] = 9112,
  [9113] = 9113,
  [9114] = 9114,
  [9115] = 9115,
  [9116] = 9116,
  [9117] = 8997,
  [9118] = 9118,
  [9119] = 8999,
  [9120] = 8997,
  [9121] = 8973,
  [9122] = 9122,
  [9123] = 8995,
  [9124] = 8999,
  [9125] = 9125,
  [9126] = 8997,
  [9127] = 8958,
  [9128] = 9098,
  [9129] = 9129,
  [9130] = 8973,
  [9131] = 9131,
  [9132] = 9132,
  [9133] = 9133,
  [9134] = 9101,
  [9135] = 9135,
  [9136] = 8995,
  [9137] = 8999,
  [9138] = 8958,
  [9139] = 8989,
  [9140] = 8997,
  [9141] = 8989,
  [9142] = 8958,
  [9143] = 8973,
  [9144] = 9144,
  [9145] = 8997,
  [9146] = 8995,
  [9147] = 8999,
  [9148] = 8999,
  [9149] = 8997,
  [9150] = 8995,
  [9151] = 8989,
  [9152] = 8958,
  [9153] = 9153,
  [9154] = 8973,
  [9155] = 8995,
  [9156] = 8999,
  [9157] = 8997,
  [9158] = 8989,
  [9159] = 8958,
  [9160] = 8973,
  [9161] = 8995,
  [9162] = 8999,
  [9163] = 8997,
  [9164] = 8989,
  [9165] = 8958,
  [9166] = 9098,
  [9167] = 8973,
  [9168] = 9168,
  [9169] = 9101,
  [9170] = 8995,
  [9171] = 8999,
  [9172] = 8997,
  [9173] = 8989,
  [9174] = 8958,
  [9175] = 8973,
  [9176] = 9176,
  [9177] = 9177,
  [9178] = 8995,
  [9179] = 8999,
  [9180] = 9113,
  [9181] = 8997,
  [9182] = 8989,
  [9183] = 8958,
  [9184] = 9113,
  [9185] = 8973,
  [9186] = 8973,
  [9187] = 9187,
  [9188] = 9188,
  [9189] = 8983,
  [9190] = 8995,
  [9191] = 8999,
  [9192] = 8997,
  [9193] = 8989,
  [9194] = 8958,
  [9195] = 9195,
  [9196] = 8995,
  [9197] = 8995,
  [9198] = 8999,
  [9199] = 8997,
  [9200] = 8989,
  [9201] = 8958,
  [9202] = 9202,
  [9203] = 8973,
  [9204] = 8995,
  [9205] = 8999,
  [9206] = 8997,
  [9207] = 8989,
  [9208] = 8958,
  [9209] = 9209,
  [9210] = 8973,
  [9211] = 9211,
  [9212] = 9212,
  [9213] = 9213,
  [9214] = 8995,
  [9215] = 8999,
  [9216] = 8997,
  [9217] = 9217,
  [9218] = 8989,
  [9219] = 8958,
  [9220] = 9220,
  [9221] = 8973,
  [9222] = 9222,
  [9223] = 8995,
  [9224] = 9217,
  [9225] = 9225,
  [9226] = 8999,
  [9227] = 8997,
  [9228] = 9228,
  [9229] = 8989,
  [9230] = 9230,
  [9231] = 8958,
  [9232] = 9232,
  [9233] = 8973,
  [9234] = 8995,
  [9235] = 9235,
  [9236] = 8999,
  [9237] = 8997,
  [9238] = 8989,
  [9239] = 9239,
  [9240] = 9240,
  [9241] = 8958,
  [9242] = 9242,
  [9243] = 9243,
  [9244] = 9244,
  [9245] = 9245,
  [9246] = 8973,
  [9247] = 8995,
  [9248] = 9248,
  [9249] = 8999,
  [9250] = 8997,
  [9251] = 8989,
  [9252] = 9252,
  [9253] = 8958,
  [9254] = 8973,
  [9255] = 9031,
  [9256] = 8995,
  [9257] = 8999,
  [9258] = 8997,
  [9259] = 8989,
  [9260] = 8958,
  [9261] = 9261,
  [9262] = 8973,
  [9263] = 9263,
  [9264] = 8995,
  [9265] = 8999,
  [9266] = 9266,
  [9267] = 8997,
  [9268] = 8989,
  [9269] = 9213,
  [9270] = 9057,
  [9271] = 9271,
  [9272] = 8958,
  [9273] = 9273,
  [9274] = 9066,
  [9275] = 8973,
  [9276] = 9276,
  [9277] = 9036,
  [9278] = 9278,
  [9279] = 9279,
  [9280] = 9280,
  [9281] = 8999,
  [9282] = 8997,
  [9283] = 8989,
  [9284] = 9088,
  [9285] = 8958,
  [9286] = 8973,
  [9287] = 9287,
  [9288] = 9288,
  [9289] = 8995,
  [9290] = 8989,
  [9291] = 9069,
  [9292] = 9292,
  [9293] = 8999,
  [9294] = 8997,
  [9295] = 8989,
  [9296] = 9296,
  [9297] = 9297,
  [9298] = 8958,
  [9299] = 9299,
  [9300] = 8973,
  [9301] = 9301,
  [9302] = 9302,
  [9303] = 9303,
  [9304] = 8995,
  [9305] = 8999,
  [9306] = 8997,
  [9307] = 8989,
  [9308] = 9308,
  [9309] = 8960,
  [9310] = 9310,
  [9311] = 8989,
  [9312] = 8997,
  [9313] = 8973,
  [9314] = 8958,
  [9315] = 9315,
  [9316] = 9316,
  [9317] = 9025,
  [9318] = 9242,
  [9319] = 8995,
  [9320] = 8963,
  [9321] = 9321,
  [9322] = 8999,
  [9323] = 8997,
  [9324] = 8989,
  [9325] = 9325,
  [9326] = 8965,
  [9327] = 8999,
  [9328] = 9328,
  [9329] = 8958,
  [9330] = 9330,
  [9331] = 9331,
  [9332] = 8973,
  [9333] = 9333,
  [9334] = 9334,
  [9335] = 9335,
  [9336] = 9336,
  [9337] = 8995,
  [9338] = 8988,
  [9339] = 8999,
  [9340] = 8997,
  [9341] = 9341,
  [9342] = 8989,
  [9343] = 9328,
  [9344] = 9026,
  [9345] = 8966,
  [9346] = 9325,
  [9347] = 8958,
  [9348] = 8973,
  [9349] = 9321,
  [9350] = 9350,
  [9351] = 9351,
  [9352] = 8995,
  [9353] = 9316,
  [9354] = 9315,
  [9355] = 8999,
  [9356] = 8997,
  [9357] = 8989,
  [9358] = 9280,
  [9359] = 8958,
  [9360] = 9037,
  [9361] = 8958,
  [9362] = 8967,
  [9363] = 8973,
  [9364] = 8968,
  [9365] = 9365,
  [9366] = 9366,
  [9367] = 9225,
  [9368] = 8969,
  [9369] = 9369,
  [9370] = 9038,
  [9371] = 8970,
  [9372] = 9228,
  [9373] = 9373,
  [9374] = 8973,
  [9375] = 8983,
  [9376] = 9039,
  [9377] = 9235,
  [9378] = 9041,
  [9379] = 9043,
  [9380] = 9380,
  [9381] = 9381,
  [9382] = 9382,
  [9383] = 9383,
  [9384] = 8995,
  [9385] = 8973,
  [9386] = 9386,
  [9387] = 9310,
  [9388] = 8976,
  [9389] = 9239,
  [9390] = 8999,
  [9391] = 8981,
  [9392] = 8977,
  [9393] = 9393,
  [9394] = 9394,
  [9395] = 8989,
  [9396] = 9308,
  [9397] = 8958,
  [9398] = 9398,
  [9399] = 8989,
  [9400] = 9303,
  [9401] = 9107,
  [9402] = 9244,
  [9403] = 9330,
  [9404] = 9404,
  [9405] = 9302,
  [9406] = 9299,
  [9407] = 9297,
  [9408] = 9292,
  [9409] = 8958,
  [9410] = 9410,
  [9411] = 9411,
  [9412] = 9412,
  [9413] = 9413,
  [9414] = 8978,
  [9415] = 9415,
  [9416] = 9416,
  [9417] = 9417,
  [9418] = 9418,
  [9419] = 8979,
  [9420] = 8973,
  [9421] = 9288,
  [9422] = 9422,
  [9423] = 9287,
  [9424] = 9424,
  [9425] = 9425,
  [9426] = 9426,
  [9427] = 9427,
  [9428] = 9279,
  [9429] = 9276,
  [9430] = 9430,
  [9431] = 8980,
  [9432] = 9422,
  [9433] = 9410,
  [9434] = 8997,
  [9435] = 9050,
  [9436] = 9436,
  [9437] = 9394,
  [9438] = 8973,
  [9439] = 9386,
  [9440] = 8997,
  [9441] = 8973,
  [9442] = 9336,
  [9443] = 9443,
  [9444] = 8982,
  [9445] = 8995,
  [9446] = 8995,
  [9447] = 9366,
  [9448] = 8999,
  [9449] = 9266,
  [9450] = 9245,
  [9451] = 9129,
  [9452] = 8989,
  [9453] = 9341,
  [9454] = 9454,
  [9455] = 9088,
  [9456] = 9341,
  [9457] = 9131,
  [9458] = 9458,
  [9459] = 9132,
  [9460] = 9248,
  [9461] = 8958,
  [9462] = 9462,
  [9463] = 8984,
  [9464] = 9330,
  [9465] = 9213,
  [9466] = 8973,
  [9467] = 8985,
  [9468] = 9168,
  [9469] = 8991,
  [9470] = 9331,
  [9471] = 9055,
  [9472] = 9217,
  [9473] = 9473,
  [9474] = 9125,
  [9475] = 9052,
  [9476] = 9058,
  [9477] = 9242,
  [9478] = 8995,
  [9479] = 9479,
  [9480] = 9480,
  [9481] = 9481,
  [9482] = 8958,
  [9483] = 9483,
  [9484] = 9059,
  [9485] = 9010,
  [9486] = 9061,
  [9487] = 9071,
  [9488] = 8996,
  [9489] = 9489,
  [9490] = 9225,
  [9491] = 9491,
  [9492] = 8989,
  [9493] = 9066,
  [9494] = 9494,
  [9495] = 9076,
  [9496] = 9078,
  [9497] = 9497,
  [9498] = 9071,
  [9499] = 9393,
  [9500] = 9079,
  [9501] = 8990,
  [9502] = 9080,
  [9503] = 8995,
  [9504] = 9094,
  [9505] = 9505,
  [9506] = 9003,
  [9507] = 8999,
  [9508] = 9473,
  [9509] = 9509,
  [9510] = 9510,
  [9511] = 9266,
  [9512] = 9026,
  [9513] = 9235,
  [9514] = 8999,
  [9515] = 9066,
  [9516] = 8997,
  [9517] = 9097,
  [9518] = 9100,
  [9519] = 8989,
  [9520] = 9103,
  [9521] = 9217,
  [9522] = 9106,
  [9523] = 9239,
  [9524] = 9244,
  [9525] = 9245,
  [9526] = 9187,
  [9527] = 9527,
  [9528] = 9056,
  [9529] = 9529,
  [9530] = 9114,
  [9531] = 9213,
  [9532] = 8998,
  [9533] = 8958,
  [9534] = 9001,
  [9535] = 9000,
  [9536] = 8973,
  [9537] = 9386,
  [9538] = 9115,
  [9539] = 9539,
  [9540] = 8994,
  [9541] = 8992,
  [9542] = 9542,
  [9543] = 9116,
  [9544] = 8990,
  [9545] = 8989,
  [9546] = 8975,
  [9547] = 8974,
  [9548] = 8989,
  [9549] = 9101,
  [9550] = 9098,
  [9551] = 9113,
  [9552] = 8972,
  [9553] = 8971,
  [9554] = 8973,
  [9555] = 9118,
  [9556] = 9509,
  [9557] = 9122,
  [9558] = 8964,
  [9559] = 8962,
  [9560] = 8961,
  [9561] = 9427,
  [9562] = 9248,
  [9563] = 8958,
  [9564] = 8997,
  [9565] = 9565,
  [9566] = 9425,
  [9567] = 8999,
  [9568] = 8982,
  [9569] = 9026,
  [9570] = 8958,
  [9571] = 9366,
  [9572] = 9572,
  [9573] = 8989,
  [9574] = 9574,
  [9575] = 8995,
  [9576] = 8976,
  [9577] = 9071,
  [9578] = 8977,
  [9579] = 8978,
  [9580] = 8990,
  [9581] = 9581,
  [9582] = 8995,
  [9583] = 8979,
  [9584] = 9153,
  [9585] = 8980,
  [9586] = 9586,
  [9587] = 9026,
  [9588] = 9588,
  [9589] = 8999,
  [9590] = 8973,
  [9591] = 8997,
  [9592] = 8958,
  [9593] = 8989,
  [9594] = 8981,
  [9595] = 8997,
  [9596] = 8999,
  [9597] = 8995,
  [9598] = 9333,
  [9599] = 8997,
  [9600] = 8999,
  [9601] = 9601,
  [9602] = 9602,
  [9603] = 9212,
  [9604] = 9133,
  [9605] = 8995,
  [9606] = 9135,
  [9607] = 9144,
  [9608] = 9168,
  [9609] = 8995,
  [9610] = 9176,
  [9611] = 9334,
  [9612] = 8989,
  [9613] = 8990,
  [9614] = 9177,
  [9615] = 9112,
  [9616] = 9030,
  [9617] = 8999,
  [9618] = 8958,
  [9619] = 8964,
  [9620] = 9031,
  [9621] = 8962,
  [9622] = 8961,
  [9623] = 9623,
  [9624] = 9624,
  [9625] = 8973,
  [9626] = 9386,
  [9627] = 9627,
  [9628] = 9036,
  [9629] = 9037,
  [9630] = 9411,
  [9631] = 9412,
  [9632] = 9413,
  [9633] = 9415,
  [9634] = 9416,
  [9635] = 9417,
  [9636] = 9418,
  [9637] = 9038,
  [9638] = 9638,
  [9639] = 8997,
  [9640] = 9427,
  [9641] = 9039,
  [9642] = 9642,
  [9643] = 9041,
  [9644] = 8958,
  [9645] = 9043,
  [9646] = 9107,
  [9647] = 9480,
  [9648] = 9242,
  [9649] = 9050,
  [9650] = 9386,
  [9651] = 9651,
  [9652] = 9398,
  [9653] = 9330,
  [9654] = 8973,
  [9655] = 9071,
  [9656] = 9094,
  [9657] = 9657,
  [9658] = 9228,
  [9659] = 9404,
  [9660] = 9660,
  [9661] = 9661,
  [9662] = 9055,
  [9663] = 8962,
  [9664] = 9480,
  [9665] = 9473,
  [9666] = 9125,
  [9667] = 9341,
  [9668] = 9668,
  [9669] = 9669,
  [9670] = 9273,
  [9671] = 9671,
  [9672] = 9398,
  [9673] = 9673,
  [9674] = 9271,
  [9675] = 9261,
  [9676] = 9252,
  [9677] = 9243,
  [9678] = 9404,
  [9679] = 9240,
  [9680] = 9030,
  [9681] = 9681,
  [9682] = 8989,
  [9683] = 9393,
  [9684] = 9366,
  [9685] = 9685,
  [9686] = 9686,
  [9687] = 9071,
  [9688] = 9509,
  [9689] = 8988,
  [9690] = 8966,
  [9691] = 8973,
  [9692] = 8958,
  [9693] = 8973,
  [9694] = 9694,
  [9695] = 9480,
  [9696] = 9696,
  [9697] = 8964,
  [9698] = 8990,
  [9699] = 8995,
  [9700] = 9700,
  [9701] = 9415,
  [9702] = 9411,
  [9703] = 9412,
  [9704] = 9413,
  [9705] = 9415,
  [9706] = 9416,
  [9707] = 9417,
  [9708] = 9418,
  [9709] = 8981,
  [9710] = 8979,
  [9711] = 9271,
  [9712] = 9427,
  [9713] = 9026,
  [9714] = 8989,
  [9715] = 8983,
  [9716] = 9462,
  [9717] = 8997,
  [9718] = 9209,
  [9719] = 8999,
  [9720] = 9720,
  [9721] = 9386,
  [9722] = 8999,
  [9723] = 8997,
  [9724] = 9211,
  [9725] = 9668,
  [9726] = 9726,
  [9727] = 9473,
  [9728] = 9125,
  [9729] = 3692,
  [9730] = 8995,
  [9731] = 9213,
  [9732] = 9212,
  [9733] = 8973,
  [9734] = 9052,
  [9735] = 8989,
  [9736] = 9058,
  [9737] = 9393,
  [9738] = 8958,
  [9739] = 9509,
  [9740] = 9740,
  [9741] = 9232,
  [9742] = 9059,
  [9743] = 9743,
  [9744] = 8997,
  [9745] = 9220,
  [9746] = 9061,
  [9747] = 9747,
  [9748] = 9071,
  [9749] = 9076,
  [9750] = 8958,
  [9751] = 9415,
  [9752] = 9416,
  [9753] = 9417,
  [9754] = 9418,
  [9755] = 9242,
  [9756] = 9078,
  [9757] = 9427,
  [9758] = 8999,
  [9759] = 9341,
  [9760] = 9079,
  [9761] = 9230,
  [9762] = 8973,
  [9763] = 9386,
  [9764] = 9394,
  [9765] = 9765,
  [9766] = 9766,
  [9767] = 9080,
  [9768] = 9094,
  [9769] = 9473,
  [9770] = 9220,
  [9771] = 8995,
  [9772] = 9772,
  [9773] = 9230,
  [9774] = 9232,
  [9775] = 8973,
  [9776] = 8973,
  [9777] = 9240,
  [9778] = 8958,
  [9779] = 9417,
  [9780] = 9418,
  [9781] = 8989,
  [9782] = 9427,
  [9783] = 9211,
  [9784] = 8997,
  [9785] = 8999,
  [9786] = 9786,
  [9787] = 9209,
  [9788] = 9788,
  [9789] = 8995,
  [9790] = 8973,
  [9791] = 9097,
  [9792] = 9100,
  [9793] = 9473,
  [9794] = 9103,
  [9795] = 8958,
  [9796] = 9106,
  [9797] = 9129,
  [9798] = 9187,
  [9799] = 9131,
  [9800] = 9132,
  [9801] = 8989,
  [9802] = 8997,
  [9803] = 8999,
  [9804] = 8995,
  [9805] = 9056,
  [9806] = 9114,
  [9807] = 9115,
  [9808] = 9480,
  [9809] = 9418,
  [9810] = 9116,
  [9811] = 9278,
  [9812] = 9812,
  [9813] = 9473,
  [9814] = 9417,
  [9815] = 9118,
  [9816] = 9132,
  [9817] = 9817,
  [9818] = 9818,
  [9819] = 9131,
  [9820] = 9243,
  [9821] = 9416,
  [9822] = 9252,
  [9823] = 9129,
  [9824] = 9261,
  [9825] = 9195,
  [9826] = 9273,
  [9827] = 8997,
  [9828] = 9336,
  [9829] = 9276,
  [9830] = 9279,
  [9831] = 9112,
  [9832] = 9473,
  [9833] = 9122,
  [9834] = 9287,
  [9835] = 9288,
  [9836] = 9133,
  [9837] = 9135,
  [9838] = 9292,
  [9839] = 9297,
  [9840] = 9413,
  [9841] = 9177,
  [9842] = 9299,
  [9843] = 9843,
  [9844] = 9302,
  [9845] = 9668,
  [9846] = 9303,
  [9847] = 9847,
  [9848] = 9071,
  [9849] = 8973,
  [9850] = 9394,
  [9851] = 9308,
  [9852] = 8962,
  [9853] = 8964,
  [9854] = 9310,
  [9855] = 9280,
  [9856] = 9856,
  [9857] = 8990,
  [9858] = 9315,
  [9859] = 9412,
  [9860] = 9860,
  [9861] = 9411,
  [9862] = 9410,
  [9863] = 9422,
  [9864] = 9316,
  [9865] = 9025,
  [9866] = 9866,
  [9867] = 8995,
  [9868] = 9321,
  [9869] = 9325,
  [9870] = 9328,
  [9871] = 8981,
  [9872] = 9860,
  [9873] = 8973,
  [9874] = 9572,
  [9875] = 9144,
  [9876] = 8980,
  [9877] = 8979,
  [9878] = 9176,
  [9879] = 9331,
  [9880] = 8958,
  [9881] = 9333,
  [9882] = 9026,
  [9883] = 8989,
  [9884] = 9067,
  [9885] = 9885,
  [9886] = 9334,
  [9887] = 8999,
  [9888] = 9195,
  [9889] = 8997,
  [9890] = 9410,
  [9891] = 8997,
  [9892] = 8999,
  [9893] = 9422,
  [9894] = 8995,
  [9895] = 9895,
  [9896] = 9098,
  [9897] = 9101,
  [9898] = 8983,
  [9899] = 9113,
  [9900] = 9213,
  [9901] = 8958,
  [9902] = 8966,
  [9903] = 9860,
  [9904] = 9572,
  [9905] = 8989,
  [9906] = 9906,
  [9907] = 9266,
  [9908] = 8988,
  [9909] = 9067,
  [9910] = 8989,
  [9911] = 8958,
  [9912] = 9242,
  [9913] = 8989,
  [9914] = 9341,
  [9915] = 9860,
  [9916] = 9572,
  [9917] = 9129,
  [9918] = 9131,
  [9919] = 9067,
  [9920] = 9132,
  [9921] = 8999,
  [9922] = 9922,
  [9923] = 9572,
  [9924] = 9924,
  [9925] = 9572,
  [9926] = 9926,
  [9927] = 9572,
  [9928] = 9572,
  [9929] = 9929,
  [9930] = 9668,
  [9931] = 9480,
  [9932] = 8973,
  [9933] = 9386,
  [9934] = 9404,
  [9935] = 9398,
  [9936] = 3619,
  [9937] = 9937,
  [9938] = 9938,
  [9939] = 9939,
  [9940] = 9940,
  [9941] = 9941,
  [9942] = 9942,
  [9943] = 9943,
  [9944] = 9944,
  [9945] = 9945,
  [9946] = 9946,
  [9947] = 9947,
  [9948] = 9948,
  [9949] = 9949,
  [9950] = 9950,
  [9951] = 9951,
  [9952] = 9952,
};

static TSCharacterRange sym__identifier_token_character_set_2[] = {
  {'A', 'Z'}, {'_', '_'}, {'a', 'z'}, {0xaa, 0xaa}, {0xb5, 0xb5}, {0xba, 0xba}, {0xc0, 0xd6}, {0xd8, 0xf6},
  {0xf8, 0x2c1}, {0x2c6, 0x2d1}, {0x2e0, 0x2e4}, {0x2ec, 0x2ec}, {0x2ee, 0x2ee}, {0x370, 0x374}, {0x376, 0x377}, {0x37a, 0x37d},
  {0x37f, 0x37f}, {0x386, 0x386}, {0x388, 0x38a}, {0x38c, 0x38c}, {0x38e, 0x3a1}, {0x3a3, 0x3f5}, {0x3f7, 0x481}, {0x48a, 0x52f},
  {0x531, 0x556}, {0x559, 0x559}, {0x560, 0x588}, {0x5d0, 0x5ea}, {0x5ef, 0x5f2}, {0x620, 0x64a}, {0x66e, 0x66f}, {0x671, 0x6d3},
  {0x6d5, 0x6d5}, {0x6e5, 0x6e6}, {0x6ee, 0x6ef}, {0x6fa, 0x6fc}, {0x6ff, 0x6ff}, {0x710, 0x710}, {0x712, 0x72f}, {0x74d, 0x7a5},
  {0x7b1, 0x7b1}, {0x7ca, 0x7ea}, {0x7f4, 0x7f5}, {0x7fa, 0x7fa}, {0x800, 0x815}, {0x81a, 0x81a}, {0x824, 0x824}, {0x828, 0x828},
  {0x840, 0x858}, {0x860, 0x86a}, {0x870, 0x887}, {0x889, 0x88e}, {0x8a0, 0x8c9}, {0x904, 0x939}, {0x93d, 0x93d}, {0x950, 0x950},
  {0x958, 0x961}, {0x971, 0x980}, {0x985, 0x98c}, {0x98f, 0x990}, {0x993, 0x9a8}, {0x9aa, 0x9b0}, {0x9b2, 0x9b2}, {0x9b6, 0x9b9},
  {0x9bd, 0x9bd}, {0x9ce, 0x9ce}, {0x9dc, 0x9dd}, {0x9df, 0x9e1}, {0x9f0, 0x9f1}, {0x9fc, 0x9fc}, {0xa05, 0xa0a}, {0xa0f, 0xa10},
  {0xa13, 0xa28}, {0xa2a, 0xa30}, {0xa32, 0xa33}, {0xa35, 0xa36}, {0xa38, 0xa39}, {0xa59, 0xa5c}, {0xa5e, 0xa5e}, {0xa72, 0xa74},
  {0xa85, 0xa8d}, {0xa8f, 0xa91}, {0xa93, 0xaa8}, {0xaaa, 0xab0}, {0xab2, 0xab3}, {0xab5, 0xab9}, {0xabd, 0xabd}, {0xad0, 0xad0},
  {0xae0, 0xae1}, {0xaf9, 0xaf9}, {0xb05, 0xb0c}, {0xb0f, 0xb10}, {0xb13, 0xb28}, {0xb2a, 0xb30}, {0xb32, 0xb33}, {0xb35, 0xb39},
  {0xb3d, 0xb3d}, {0xb5c, 0xb5d}, {0xb5f, 0xb61}, {0xb71, 0xb71}, {0xb83, 0xb83}, {0xb85, 0xb8a}, {0xb8e, 0xb90}, {0xb92, 0xb95},
  {0xb99, 0xb9a}, {0xb9c, 0xb9c}, {0xb9e, 0xb9f}, {0xba3, 0xba4}, {0xba8, 0xbaa}, {0xbae, 0xbb9}, {0xbd0, 0xbd0}, {0xc05, 0xc0c},
  {0xc0e, 0xc10}, {0xc12, 0xc28}, {0xc2a, 0xc39}, {0xc3d, 0xc3d}, {0xc58, 0xc5a}, {0xc5d, 0xc5d}, {0xc60, 0xc61}, {0xc80, 0xc80},
  {0xc85, 0xc8c}, {0xc8e, 0xc90}, {0xc92, 0xca8}, {0xcaa, 0xcb3}, {0xcb5, 0xcb9}, {0xcbd, 0xcbd}, {0xcdd, 0xcde}, {0xce0, 0xce1},
  {0xcf1, 0xcf2}, {0xd04, 0xd0c}, {0xd0e, 0xd10}, {0xd12, 0xd3a}, {0xd3d, 0xd3d}, {0xd4e, 0xd4e}, {0xd54, 0xd56}, {0xd5f, 0xd61},
  {0xd7a, 0xd7f}, {0xd85, 0xd96}, {0xd9a, 0xdb1}, {0xdb3, 0xdbb}, {0xdbd, 0xdbd}, {0xdc0, 0xdc6}, {0xe01, 0xe30}, {0xe32, 0xe33},
  {0xe40, 0xe46}, {0xe81, 0xe82}, {0xe84, 0xe84}, {0xe86, 0xe8a}, {0xe8c, 0xea3}, {0xea5, 0xea5}, {0xea7, 0xeb0}, {0xeb2, 0xeb3},
  {0xebd, 0xebd}, {0xec0, 0xec4}, {0xec6, 0xec6}, {0xedc, 0xedf}, {0xf00, 0xf00}, {0xf40, 0xf47}, {0xf49, 0xf6c}, {0xf88, 0xf8c},
  {0x1000, 0x102a}, {0x103f, 0x103f}, {0x1050, 0x1055}, {0x105a, 0x105d}, {0x1061, 0x1061}, {0x1065, 0x1066}, {0x106e, 0x1070}, {0x1075, 0x1081},
  {0x108e, 0x108e}, {0x10a0, 0x10c5}, {0x10c7, 0x10c7}, {0x10cd, 0x10cd}, {0x10d0, 0x10fa}, {0x10fc, 0x1248}, {0x124a, 0x124d}, {0x1250, 0x1256},
  {0x1258, 0x1258}, {0x125a, 0x125d}, {0x1260, 0x1288}, {0x128a, 0x128d}, {0x1290, 0x12b0}, {0x12b2, 0x12b5}, {0x12b8, 0x12be}, {0x12c0, 0x12c0},
  {0x12c2, 0x12c5}, {0x12c8, 0x12d6}, {0x12d8, 0x1310}, {0x1312, 0x1315}, {0x1318, 0x135a}, {0x1380, 0x138f}, {0x13a0, 0x13f5}, {0x13f8, 0x13fd},
  {0x1401, 0x166c}, {0x166f, 0x167f}, {0x1681, 0x169a}, {0x16a0, 0x16ea}, {0x16ee, 0x16f8}, {0x1700, 0x1711}, {0x171f, 0x1731}, {0x1740, 0x1751},
  {0x1760, 0x176c}, {0x176e, 0x1770}, {0x1780, 0x17b3}, {0x17d7, 0x17d7}, {0x17dc, 0x17dc}, {0x1820, 0x1878}, {0x1880, 0x1884}, {0x1887, 0x18a8},
  {0x18aa, 0x18aa}, {0x18b0, 0x18f5}, {0x1900, 0x191e}, {0x1950, 0x196d}, {0x1970, 0x1974}, {0x1980, 0x19ab}, {0x19b0, 0x19c9}, {0x1a00, 0x1a16},
  {0x1a20, 0x1a54}, {0x1aa7, 0x1aa7}, {0x1b05, 0x1b33}, {0x1b45, 0x1b4c}, {0x1b83, 0x1ba0}, {0x1bae, 0x1baf}, {0x1bba, 0x1be5}, {0x1c00, 0x1c23},
  {0x1c4d, 0x1c4f}, {0x1c5a, 0x1c7d}, {0x1c80, 0x1c88}, {0x1c90, 0x1cba}, {0x1cbd, 0x1cbf}, {0x1ce9, 0x1cec}, {0x1cee, 0x1cf3}, {0x1cf5, 0x1cf6},
  {0x1cfa, 0x1cfa}, {0x1d00, 0x1dbf}, {0x1e00, 0x1f15}, {0x1f18, 0x1f1d}, {0x1f20, 0x1f45}, {0x1f48, 0x1f4d}, {0x1f50, 0x1f57}, {0x1f59, 0x1f59},
  {0x1f5b, 0x1f5b}, {0x1f5d, 0x1f5d}, {0x1f5f, 0x1f7d}, {0x1f80, 0x1fb4}, {0x1fb6, 0x1fbc}, {0x1fbe, 0x1fbe}, {0x1fc2, 0x1fc4}, {0x1fc6, 0x1fcc},
  {0x1fd0, 0x1fd3}, {0x1fd6, 0x1fdb}, {0x1fe0, 0x1fec}, {0x1ff2, 0x1ff4}, {0x1ff6, 0x1ffc}, {0x2071, 0x2071}, {0x207f, 0x207f}, {0x2090, 0x209c},
  {0x2102, 0x2102}, {0x2107, 0x2107}, {0x210a, 0x2113}, {0x2115, 0x2115}, {0x2119, 0x211d}, {0x2124, 0x2124}, {0x2126, 0x2126}, {0x2128, 0x2128},
  {0x212a, 0x212d}, {0x212f, 0x2139}, {0x213c, 0x213f}, {0x2145, 0x2149}, {0x214e, 0x214e}, {0x2160, 0x2188}, {0x2c00, 0x2ce4}, {0x2ceb, 0x2cee},
  {0x2cf2, 0x2cf3}, {0x2d00, 0x2d25}, {0x2d27, 0x2d27}, {0x2d2d, 0x2d2d}, {0x2d30, 0x2d67}, {0x2d6f, 0x2d6f}, {0x2d80, 0x2d96}, {0x2da0, 0x2da6},
  {0x2da8, 0x2dae}, {0x2db0, 0x2db6}, {0x2db8, 0x2dbe}, {0x2dc0, 0x2dc6}, {0x2dc8, 0x2dce}, {0x2dd0, 0x2dd6}, {0x2dd8, 0x2dde}, {0x2e2f, 0x2e2f},
  {0x3005, 0x3007}, {0x3021, 0x3029}, {0x3031, 0x3035}, {0x3038, 0x303c}, {0x3041, 0x3096}, {0x309d, 0x309f}, {0x30a1, 0x30fa}, {0x30fc, 0x30ff},
  {0x3105, 0x312f}, {0x3131, 0x318e}, {0x31a0, 0x31bf}, {0x31f0, 0x31ff}, {0x3400, 0x3400}, {0x4dbf, 0x4dbf}, {0x4e00, 0x4e00}, {0x9fff, 0xa48c},
  {0xa4d0, 0xa4fd}, {0xa500, 0xa60c}, {0xa610, 0xa61f}, {0xa62a, 0xa62b}, {0xa640, 0xa66e}, {0xa67f, 0xa69d}, {0xa6a0, 0xa6ef}, {0xa717, 0xa71f},
  {0xa722, 0xa788}, {0xa78b, 0xa7ca}, {0xa7d0, 0xa7d1}, {0xa7d3, 0xa7d3}, {0xa7d5, 0xa7d9}, {0xa7f2, 0xa801}, {0xa803, 0xa805}, {0xa807, 0xa80a},
  {0xa80c, 0xa822}, {0xa840, 0xa873}, {0xa882, 0xa8b3}, {0xa8f2, 0xa8f7}, {0xa8fb, 0xa8fb}, {0xa8fd, 0xa8fe}, {0xa90a, 0xa925}, {0xa930, 0xa946},
  {0xa960, 0xa97c}, {0xa984, 0xa9b2}, {0xa9cf, 0xa9cf}, {0xa9e0, 0xa9e4}, {0xa9e6, 0xa9ef}, {0xa9fa, 0xa9fe}, {0xaa00, 0xaa28}, {0xaa40, 0xaa42},
  {0xaa44, 0xaa4b}, {0xaa60, 0xaa76}, {0xaa7a, 0xaa7a}, {0xaa7e, 0xaaaf}, {0xaab1, 0xaab1}, {0xaab5, 0xaab6}, {0xaab9, 0xaabd}, {0xaac0, 0xaac0},
  {0xaac2, 0xaac2}, {0xaadb, 0xaadd}, {0xaae0, 0xaaea}, {0xaaf2, 0xaaf4}, {0xab01, 0xab06}, {0xab09, 0xab0e}, {0xab11, 0xab16}, {0xab20, 0xab26},
  {0xab28, 0xab2e}, {0xab30, 0xab5a}, {0xab5c, 0xab69}, {0xab70, 0xabe2}, {0xac00, 0xac00}, {0xd7a3, 0xd7a3}, {0xd7b0, 0xd7c6}, {0xd7cb, 0xd7fb},
  {0xf900, 0xfa6d}, {0xfa70, 0xfad9}, {0xfb00, 0xfb06}, {0xfb13, 0xfb17}, {0xfb1d, 0xfb1d}, {0xfb1f, 0xfb28}, {0xfb2a, 0xfb36}, {0xfb38, 0xfb3c},
  {0xfb3e, 0xfb3e}, {0xfb40, 0xfb41}, {0xfb43, 0xfb44}, {0xfb46, 0xfbb1}, {0xfbd3, 0xfd3d}, {0xfd50, 0xfd8f}, {0xfd92, 0xfdc7}, {0xfdf0, 0xfdfb},
  {0xfe70, 0xfe74}, {0xfe76, 0xfefc}, {0xff21, 0xff3a}, {0xff41, 0xff5a}, {0xff66, 0xffbe}, {0xffc2, 0xffc7}, {0xffca, 0xffcf}, {0xffd2, 0xffd7},
  {0xffda, 0xffdc}, {0x10000, 0x1000b}, {0x1000d, 0x10026}, {0x10028, 0x1003a}, {0x1003c, 0x1003d}, {0x1003f, 0x1004d}, {0x10050, 0x1005d}, {0x10080, 0x100fa},
  {0x10140, 0x10174}, {0x10280, 0x1029c}, {0x102a0, 0x102d0}, {0x10300, 0x1031f}, {0x1032d, 0x1034a}, {0x10350, 0x10375}, {0x10380, 0x1039d}, {0x103a0, 0x103c3},
  {0x103c8, 0x103cf}, {0x103d1, 0x103d5}, {0x10400, 0x1049d}, {0x104b0, 0x104d3}, {0x104d8, 0x104fb}, {0x10500, 0x10527}, {0x10530, 0x10563}, {0x10570, 0x1057a},
  {0x1057c, 0x1058a}, {0x1058c, 0x10592}, {0x10594, 0x10595}, {0x10597, 0x105a1}, {0x105a3, 0x105b1}, {0x105b3, 0x105b9}, {0x105bb, 0x105bc}, {0x10600, 0x10736},
  {0x10740, 0x10755}, {0x10760, 0x10767}, {0x10780, 0x10785}, {0x10787, 0x107b0}, {0x107b2, 0x107ba}, {0x10800, 0x10805}, {0x10808, 0x10808}, {0x1080a, 0x10835},
  {0x10837, 0x10838}, {0x1083c, 0x1083c}, {0x1083f, 0x10855}, {0x10860, 0x10876}, {0x10880, 0x1089e}, {0x108e0, 0x108f2}, {0x108f4, 0x108f5}, {0x10900, 0x10915},
  {0x10920, 0x1092b},
};

static TSCharacterRange sym__identifier_token_character_set_3[] = {
  {'0', '9'}, {'A', 'Z'}, {'_', '_'}, {'a', 'z'}, {0xaa, 0xaa}, {0xad, 0xad}, {0xb5, 0xb5}, {0xba, 0xba},
  {0xc0, 0xd6}, {0xd8, 0xf6}, {0xf8, 0x2c1}, {0x2c6, 0x2d1}, {0x2e0, 0x2e4}, {0x2ec, 0x2ec}, {0x2ee, 0x2ee}, {0x300, 0x374},
  {0x376, 0x377}, {0x37a, 0x37d}, {0x37f, 0x37f}, {0x386, 0x386}, {0x388, 0x38a}, {0x38c, 0x38c}, {0x38e, 0x3a1}, {0x3a3, 0x3f5},
  {0x3f7, 0x481}, {0x483, 0x487}, {0x48a, 0x52f}, {0x531, 0x556}, {0x559, 0x559}, {0x560, 0x588}, {0x591, 0x5bd}, {0x5bf, 0x5bf},
  {0x5c1, 0x5c2}, {0x5c4, 0x5c5}, {0x5c7, 0x5c7}, {0x5d0, 0x5ea}, {0x5ef, 0x5f2}, {0x600, 0x605}, {0x610, 0x61a}, {0x61c, 0x61c},
  {0x620, 0x669}, {0x66e, 0x6d3}, {0x6d5, 0x6dd}, {0x6df, 0x6e8}, {0x6ea, 0x6fc}, {0x6ff, 0x6ff}, {0x70f, 0x74a}, {0x74d, 0x7b1},
  {0x7c0, 0x7f5}, {0x7fa, 0x7fa}, {0x7fd, 0x7fd}, {0x800, 0x82d}, {0x840, 0x85b}, {0x860, 0x86a}, {0x870, 0x887}, {0x889, 0x88e},
  {0x890, 0x891}, {0x898, 0x963}, {0x966, 0x96f}, {0x971, 0x983}, {0x985, 0x98c}, {0x98f, 0x990}, {0x993, 0x9a8}, {0x9aa, 0x9b0},
  {0x9b2, 0x9b2}, {0x9b6, 0x9b9}, {0x9bc, 0x9c4}, {0x9c7, 0x9c8}, {0x9cb, 0x9ce}, {0x9d7, 0x9d7}, {0x9dc, 0x9dd}, {0x9df, 0x9e3},
  {0x9e6, 0x9f1}, {0x9fc, 0x9fc}, {0x9fe, 0x9fe}, {0xa01, 0xa03}, {0xa05, 0xa0a}, {0xa0f, 0xa10}, {0xa13, 0xa28}, {0xa2a, 0xa30},
  {0xa32, 0xa33}, {0xa35, 0xa36}, {0xa38, 0xa39}, {0xa3c, 0xa3c}, {0xa3e, 0xa42}, {0xa47, 0xa48}, {0xa4b, 0xa4d}, {0xa51, 0xa51},
  {0xa59, 0xa5c}, {0xa5e, 0xa5e}, {0xa66, 0xa75}, {0xa81, 0xa83}, {0xa85, 0xa8d}, {0xa8f, 0xa91}, {0xa93, 0xaa8}, {0xaaa, 0xab0},
  {0xab2, 0xab3}, {0xab5, 0xab9}, {0xabc, 0xac5}, {0xac7, 0xac9}, {0xacb, 0xacd}, {0xad0, 0xad0}, {0xae0, 0xae3}, {0xae6, 0xaef},
  {0xaf9, 0xaff}, {0xb01, 0xb03}, {0xb05, 0xb0c}, {0xb0f, 0xb10}, {0xb13, 0xb28}, {0xb2a, 0xb30}, {0xb32, 0xb33}, {0xb35, 0xb39},
  {0xb3c, 0xb44}, {0xb47, 0xb48}, {0xb4b, 0xb4d}, {0xb55, 0xb57}, {0xb5c, 0xb5d}, {0xb5f, 0xb63}, {0xb66, 0xb6f}, {0xb71, 0xb71},
  {0xb82, 0xb83}, {0xb85, 0xb8a}, {0xb8e, 0xb90}, {0xb92, 0xb95}, {0xb99, 0xb9a}, {0xb9c, 0xb9c}, {0xb9e, 0xb9f}, {0xba3, 0xba4},
  {0xba8, 0xbaa}, {0xbae, 0xbb9}, {0xbbe, 0xbc2}, {0xbc6, 0xbc8}, {0xbca, 0xbcd}, {0xbd0, 0xbd0}, {0xbd7, 0xbd7}, {0xbe6, 0xbef},
  {0xc00, 0xc0c}, {0xc0e, 0xc10}, {0xc12, 0xc28}, {0xc2a, 0xc39}, {0xc3c, 0xc44}, {0xc46, 0xc48}, {0xc4a, 0xc4d}, {0xc55, 0xc56},
  {0xc58, 0xc5a}, {0xc5d, 0xc5d}, {0xc60, 0xc63}, {0xc66, 0xc6f}, {0xc80, 0xc83}, {0xc85, 0xc8c}, {0xc8e, 0xc90}, {0xc92, 0xca8},
  {0xcaa, 0xcb3}, {0xcb5, 0xcb9}, {0xcbc, 0xcc4}, {0xcc6, 0xcc8}, {0xcca, 0xccd}, {0xcd5, 0xcd6}, {0xcdd, 0xcde}, {0xce0, 0xce3},
  {0xce6, 0xcef}, {0xcf1, 0xcf2}, {0xd00, 0xd0c}, {0xd0e, 0xd10}, {0xd12, 0xd44}, {0xd46, 0xd48}, {0xd4a, 0xd4e}, {0xd54, 0xd57},
  {0xd5f, 0xd63}, {0xd66, 0xd6f}, {0xd7a, 0xd7f}, {0xd81, 0xd83}, {0xd85, 0xd96}, {0xd9a, 0xdb1}, {0xdb3, 0xdbb}, {0xdbd, 0xdbd},
  {0xdc0, 0xdc6}, {0xdca, 0xdca}, {0xdcf, 0xdd4}, {0xdd6, 0xdd6}, {0xdd8, 0xddf}, {0xde6, 0xdef}, {0xdf2, 0xdf3}, {0xe01, 0xe3a},
  {0xe40, 0xe4e}, {0xe50, 0xe59}, {0xe81, 0xe82}, {0xe84, 0xe84}, {0xe86, 0xe8a}, {0xe8c, 0xea3}, {0xea5, 0xea5}, {0xea7, 0xebd},
  {0xec0, 0xec4}, {0xec6, 0xec6}, {0xec8, 0xecd}, {0xed0, 0xed9}, {0xedc, 0xedf}, {0xf00, 0xf00}, {0xf18, 0xf19}, {0xf20, 0xf29},
  {0xf35, 0xf35}, {0xf37, 0xf37}, {0xf39, 0xf39}, {0xf3e, 0xf47}, {0xf49, 0xf6c}, {0xf71, 0xf84}, {0xf86, 0xf97}, {0xf99, 0xfbc},
  {0xfc6, 0xfc6}, {0x1000, 0x1049}, {0x1050, 0x109d}, {0x10a0, 0x10c5}, {0x10c7, 0x10c7}, {0x10cd, 0x10cd}, {0x10d0, 0x10fa}, {0x10fc, 0x1248},
  {0x124a, 0x124d}, {0x1250, 0x1256}, {0x1258, 0x1258}, {0x125a, 0x125d}, {0x1260, 0x1288}, {0x128a, 0x128d}, {0x1290, 0x12b0}, {0x12b2, 0x12b5},
  {0x12b8, 0x12be}, {0x12c0, 0x12c0}, {0x12c2, 0x12c5}, {0x12c8, 0x12d6}, {0x12d8, 0x1310}, {0x1312, 0x1315}, {0x1318, 0x135a}, {0x135d, 0x135f},
  {0x1380, 0x138f}, {0x13a0, 0x13f5}, {0x13f8, 0x13fd}, {0x1401, 0x166c}, {0x166f, 0x167f}, {0x1681, 0x169a}, {0x16a0, 0x16ea}, {0x16ee, 0x16f8},
  {0x1700, 0x1715}, {0x171f, 0x1734}, {0x1740, 0x1753}, {0x1760, 0x176c}, {0x176e, 0x1770}, {0x1772, 0x1773}, {0x1780, 0x17d3}, {0x17d7, 0x17d7},
  {0x17dc, 0x17dd}, {0x17e0, 0x17e9}, {0x180b, 0x1819}, {0x1820, 0x1878}, {0x1880, 0x18aa}, {0x18b0, 0x18f5}, {0x1900, 0x191e}, {0x1920, 0x192b},
  {0x1930, 0x193b}, {0x1946, 0x196d}, {0x1970, 0x1974}, {0x1980, 0x19ab}, {0x19b0, 0x19c9}, {0x19d0, 0x19d9}, {0x1a00, 0x1a1b}, {0x1a20, 0x1a5e},
  {0x1a60, 0x1a7c}, {0x1a7f, 0x1a89}, {0x1a90, 0x1a99}, {0x1aa7, 0x1aa7}, {0x1ab0, 0x1abd}, {0x1abf, 0x1ace}, {0x1b00, 0x1b4c}, {0x1b50, 0x1b59},
  {0x1b6b, 0x1b73}, {0x1b80, 0x1bf3}, {0x1c00, 0x1c37}, {0x1c40, 0x1c49}, {0x1c4d, 0x1c7d}, {0x1c80, 0x1c88}, {0x1c90, 0x1cba}, {0x1cbd, 0x1cbf},
  {0x1cd0, 0x1cd2}, {0x1cd4, 0x1cfa}, {0x1d00, 0x1f15}, {0x1f18, 0x1f1d}, {0x1f20, 0x1f45}, {0x1f48, 0x1f4d}, {0x1f50, 0x1f57}, {0x1f59, 0x1f59},
  {0x1f5b, 0x1f5b}, {0x1f5d, 0x1f5d}, {0x1f5f, 0x1f7d}, {0x1f80, 0x1fb4}, {0x1fb6, 0x1fbc}, {0x1fbe, 0x1fbe}, {0x1fc2, 0x1fc4}, {0x1fc6, 0x1fcc},
  {0x1fd0, 0x1fd3}, {0x1fd6, 0x1fdb}, {0x1fe0, 0x1fec}, {0x1ff2, 0x1ff4}, {0x1ff6, 0x1ffc}, {0x200b, 0x200f}, {0x202a, 0x202e}, {0x203f, 0x2040},
  {0x2054, 0x2054}, {0x2060, 0x2064}, {0x2066, 0x206f}, {0x2071, 0x2071}, {0x207f, 0x207f}, {0x2090, 0x209c}, {0x20d0, 0x20dc}, {0x20e1, 0x20e1},
  {0x20e5, 0x20f0}, {0x2102, 0x2102}, {0x2107, 0x2107}, {0x210a, 0x2113}, {0x2115, 0x2115}, {0x2119, 0x211d}, {0x2124, 0x2124}, {0x2126, 0x2126},
  {0x2128, 0x2128}, {0x212a, 0x212d}, {0x212f, 0x2139}, {0x213c, 0x213f}, {0x2145, 0x2149}, {0x214e, 0x214e}, {0x2160, 0x2188}, {0x2c00, 0x2ce4},
  {0x2ceb, 0x2cf3}, {0x2d00, 0x2d25}, {0x2d27, 0x2d27}, {0x2d2d, 0x2d2d}, {0x2d30, 0x2d67}, {0x2d6f, 0x2d6f}, {0x2d7f, 0x2d96}, {0x2da0, 0x2da6},
  {0x2da8, 0x2dae}, {0x2db0, 0x2db6}, {0x2db8, 0x2dbe}, {0x2dc0, 0x2dc6}, {0x2dc8, 0x2dce}, {0x2dd0, 0x2dd6}, {0x2dd8, 0x2dde}, {0x2de0, 0x2dff},
  {0x2e2f, 0x2e2f}, {0x3005, 0x3007}, {0x3021, 0x302f}, {0x3031, 0x3035}, {0x3038, 0x303c}, {0x3041, 0x3096}, {0x3099, 0x309a}, {0x309d, 0x309f},
  {0x30a1, 0x30fa}, {0x30fc, 0x30ff}, {0x3105, 0x312f}, {0x3131, 0x318e}, {0x31a0, 0x31bf}, {0x31f0, 0x31ff}, {0x3400, 0x3400}, {0x4dbf, 0x4dbf},
  {0x4e00, 0x4e00}, {0x9fff, 0xa48c}, {0xa4d0, 0xa4fd}, {0xa500, 0xa60c}, {0xa610, 0xa62b}, {0xa640, 0xa66f}, {0xa674, 0xa67d}, {0xa67f, 0xa6f1},
  {0xa717, 0xa71f}, {0xa722, 0xa788}, {0xa78b, 0xa7ca}, {0xa7d0, 0xa7d1}, {0xa7d3, 0xa7d3}, {0xa7d5, 0xa7d9}, {0xa7f2, 0xa827}, {0xa82c, 0xa82c},
  {0xa840, 0xa873}, {0xa880, 0xa8c5}, {0xa8d0, 0xa8d9}, {0xa8e0, 0xa8f7}, {0xa8fb, 0xa8fb}, {0xa8fd, 0xa92d}, {0xa930, 0xa953}, {0xa960, 0xa97c},
  {0xa980, 0xa9c0}, {0xa9cf, 0xa9d9}, {0xa9e0, 0xa9fe}, {0xaa00, 0xaa36}, {0xaa40, 0xaa4d}, {0xaa50, 0xaa59}, {0xaa60, 0xaa76}, {0xaa7a, 0xaac2},
  {0xaadb, 0xaadd}, {0xaae0, 0xaaef}, {0xaaf2, 0xaaf6}, {0xab01, 0xab06}, {0xab09, 0xab0e}, {0xab11, 0xab16}, {0xab20, 0xab26}, {0xab28, 0xab2e},
  {0xab30, 0xab5a}, {0xab5c, 0xab69}, {0xab70, 0xabea}, {0xabec, 0xabed}, {0xabf0, 0xabf9}, {0xac00, 0xac00}, {0xd7a3, 0xd7a3}, {0xd7b0, 0xd7c6},
  {0xd7cb, 0xd7fb}, {0xf900, 0xfa6d}, {0xfa70, 0xfad9}, {0xfb00, 0xfb06}, {0xfb13, 0xfb17}, {0xfb1d, 0xfb28}, {0xfb2a, 0xfb36}, {0xfb38, 0xfb3c},
  {0xfb3e, 0xfb3e}, {0xfb40, 0xfb41}, {0xfb43, 0xfb44}, {0xfb46, 0xfbb1}, {0xfbd3, 0xfd3d}, {0xfd50, 0xfd8f}, {0xfd92, 0xfdc7}, {0xfdf0, 0xfdfb},
  {0xfe00, 0xfe0f}, {0xfe20, 0xfe2f}, {0xfe33, 0xfe34}, {0xfe4d, 0xfe4f}, {0xfe70, 0xfe74}, {0xfe76, 0xfefc}, {0xfeff, 0xfeff}, {0xff10, 0xff19},
  {0xff21, 0xff3a}, {0xff3f, 0xff3f}, {0xff41, 0xff5a}, {0xff66, 0xffbe}, {0xffc2, 0xffc7}, {0xffca, 0xffcf}, {0xffd2, 0xffd7}, {0xffda, 0xffdc},
  {0xfff9, 0xfffb}, {0x10000, 0x1000b}, {0x1000d, 0x10026}, {0x10028, 0x1003a}, {0x1003c, 0x1003d}, {0x1003f, 0x1004d}, {0x10050, 0x1005d}, {0x10080, 0x100fa},
  {0x10140, 0x10174}, {0x101fd, 0x101fd}, {0x10280, 0x1029c}, {0x102a0, 0x102d0}, {0x102e0, 0x102e0}, {0x10300, 0x1031f}, {0x1032d, 0x1034a}, {0x10350, 0x1037a},
  {0x10380, 0x1039d}, {0x103a0, 0x103c3}, {0x103c8, 0x103cf}, {0x103d1, 0x103d5}, {0x10400, 0x1049d}, {0x104a0, 0x104a9}, {0x104b0, 0x104d3}, {0x104d8, 0x104fb},
  {0x10500, 0x10527}, {0x10530, 0x10563}, {0x10570, 0x1057a}, {0x1057c, 0x1058a}, {0x1058c, 0x10592}, {0x10594, 0x10595}, {0x10597, 0x105a1}, {0x105a3, 0x105b1},
  {0x105b3, 0x105b9}, {0x105bb, 0x105bc}, {0x10600, 0x10736}, {0x10740, 0x10755}, {0x10760, 0x10767}, {0x10780, 0x10785}, {0x10787, 0x107b0}, {0x107b2, 0x107ba},
  {0x10800, 0x10805}, {0x10808, 0x10808}, {0x1080a, 0x10835}, {0x10837, 0x10838}, {0x1083c, 0x1083c}, {0x1083f, 0x10855}, {0x10860, 0x10876}, {0x10880, 0x1089e},
  {0x108e0, 0x108f2}, {0x108f4, 0x108f5}, {0x10900, 0x10915}, {0x10920, 0x1092b},
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(114);
      ADVANCE_MAP(
        '!', 139,
        '"', 196,
        '#', 8,
        '%', 154,
        '&', 162,
        '\'', 236,
        '(', 123,
        ')', 124,
        '*', 150,
        '+', 144,
        ',', 121,
        '-', 146,
        '.', 175,
        '/', 152,
        '0', 241,
        ':', 120,
        ';', 115,
        '<', 128,
        '=', 116,
        '>', 133,
        '?', 136,
        '@', 10,
        '[', 118,
        '\\', 37,
        ']', 122,
        '^', 156,
        '{', 125,
        '|', 158,
        '}', 126,
        '~', 140,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x3000 ||
          lookahead == 0xfeff) SKIP(111);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(242);
      if (set_contains(sym__identifier_token_character_set_2, 433, lookahead)) ADVANCE(303);
      END_STATE();
    case 1:
      ADVANCE_MAP(
        '\n', 305,
        '!', 32,
        '"', 195,
        '#', 50,
        '&', 25,
        ',', 121,
        '/', 26,
        '0', 245,
        '=', 33,
        '@', 109,
        '|', 95,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x3000 ||
          lookahead == 0xfeff) SKIP(1);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(246);
      if (set_contains(sym__identifier_token_character_set_2, 433, lookahead)) ADVANCE(303);
      END_STATE();
    case 2:
      if (lookahead == '\n') SKIP(14);
      if (lookahead == '"') ADVANCE(195);
      if (lookahead == '#') ADVANCE(261);
      if (lookahead == '/') ADVANCE(254);
      if (lookahead == '\\') ADVANCE(37);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x3000 ||
          lookahead == 0xfeff) ADVANCE(253);
      if (lookahead != 0) ADVANCE(289);
      END_STATE();
    case 3:
      if (lookahead == '\n') ADVANCE(306);
      if (lookahead == '#') ADVANCE(323);
      if (lookahead == '/') ADVANCE(316);
      if (lookahead == 0xa0 ||
          lookahead == 0x3000 ||
          lookahead == 0xfeff) ADVANCE(312);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(3);
      if (lookahead != 0) ADVANCE(360);
      END_STATE();
    case 4:
      ADVANCE_MAP(
        '!', 139,
        '"', 195,
        '#', 49,
        '%', 154,
        '&', 162,
        '(', 123,
        ')', 124,
        '*', 150,
        '+', 144,
        ',', 121,
        '-', 146,
        '.', 174,
        '/', 152,
        '0', 245,
        ':', 119,
        ';', 115,
        '<', 128,
        '=', 116,
        '>', 133,
        '?', 136,
        '@', 109,
        '[', 118,
        '\\', 38,
        ']', 122,
        '^', 156,
        '{', 125,
        '|', 158,
        '}', 126,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x3000 ||
          lookahead == 0xfeff) SKIP(4);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(246);
      if (set_contains(sym__identifier_token_character_set_2, 433, lookahead)) ADVANCE(303);
      END_STATE();
    case 5:
      ADVANCE_MAP(
        '!', 139,
        '"', 195,
        '#', 49,
        '%', 153,
        '&', 161,
        '(', 123,
        ')', 124,
        '*', 149,
        '+', 143,
        ',', 121,
        '-', 147,
        '.', 174,
        '/', 151,
        ':', 119,
        ';', 115,
        '<', 129,
        '=', 34,
        '>', 134,
        '?', 137,
        '@', 109,
        '[', 118,
        ']', 122,
        '^', 155,
        '|', 159,
        '}', 126,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x3000 ||
          lookahead == 0xfeff) SKIP(5);
      if (set_contains(sym__identifier_token_character_set_2, 433, lookahead)) ADVANCE(303);
      END_STATE();
    case 6:
      ADVANCE_MAP(
        '!', 139,
        '#', 49,
        '%', 153,
        '&', 161,
        '(', 123,
        ')', 124,
        '*', 149,
        '+', 143,
        ',', 121,
        '-', 147,
        '.', 174,
        '/', 151,
        ':', 120,
        ';', 115,
        '<', 129,
        '=', 34,
        '>', 134,
        '?', 137,
        '@', 109,
        '[', 118,
        ']', 122,
        '^', 155,
        '{', 125,
        '|', 159,
        '}', 126,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x3000 ||
          lookahead == 0xfeff) SKIP(6);
      if (set_contains(sym__identifier_token_character_set_2, 433, lookahead)) ADVANCE(303);
      END_STATE();
    case 7:
      ADVANCE_MAP(
        '!', 139,
        '#', 50,
        '%', 153,
        '&', 160,
        '*', 149,
        '+', 143,
        '-', 145,
        '/', 151,
        '<', 129,
        '=', 33,
        '>', 134,
        '@', 109,
        '^', 155,
        '|', 157,
        '~', 140,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x3000 ||
          lookahead == 0xfeff) SKIP(7);
      if (set_contains(sym__identifier_token_character_set_2, 433, lookahead)) ADVANCE(303);
      END_STATE();
    case 8:
      ADVANCE_MAP(
        '!', 370,
        'd', 59,
        'e', 76,
        'i', 62,
        'l', 70,
        'n', 94,
        'p', 90,
        'r', 54,
        'u', 83,
        '\t', 48,
        ' ', 48,
      );
      END_STATE();
    case 9:
      ADVANCE_MAP(
        '!', 138,
        '#', 50,
        '\'', 236,
        '(', 123,
        ')', 124,
        '*', 149,
        ',', 121,
        '-', 148,
        '.', 173,
        '/', 26,
        '0', 245,
        ':', 120,
        ';', 115,
        '<', 127,
        '=', 117,
        '>', 131,
        '?', 135,
        '@', 109,
        '[', 118,
        ']', 122,
        '{', 125,
        '}', 126,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x3000 ||
          lookahead == 0xfeff) SKIP(9);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(246);
      if (set_contains(sym__identifier_token_character_set_2, 433, lookahead)) ADVANCE(303);
      END_STATE();
    case 10:
      if (lookahead == '"') ADVANCE(11);
      if (set_contains(sym__identifier_token_character_set_2, 433, lookahead)) ADVANCE(303);
      END_STATE();
    case 11:
      if (lookahead == '"') ADVANCE(298);
      if (lookahead != 0) ADVANCE(11);
      END_STATE();
    case 12:
      if (lookahead == '"') ADVANCE(300);
      if (lookahead != 0) ADVANCE(20);
      END_STATE();
    case 13:
      if (lookahead == '"') ADVANCE(301);
      if (lookahead != 0) ADVANCE(20);
      END_STATE();
    case 14:
      if (lookahead == '"') ADVANCE(195);
      if (lookahead == '#') ADVANCE(50);
      if (lookahead == '/') ADVANCE(26);
      if (lookahead == '\\') ADVANCE(38);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x3000 ||
          lookahead == 0xfeff) SKIP(14);
      END_STATE();
    case 15:
      if (lookahead == '"') ADVANCE(18);
      END_STATE();
    case 16:
      if (lookahead == '"') ADVANCE(12);
      if (lookahead != 0) ADVANCE(20);
      END_STATE();
    case 17:
      if (lookahead == '"') ADVANCE(13);
      if (lookahead != 0) ADVANCE(20);
      END_STATE();
    case 18:
      if (lookahead == '"') ADVANCE(16);
      if (lookahead != 0) ADVANCE(20);
      END_STATE();
    case 19:
      if (lookahead == '"') ADVANCE(17);
      if (lookahead == '8') ADVANCE(302);
      if (lookahead != 0) ADVANCE(20);
      END_STATE();
    case 20:
      if (lookahead == '"') ADVANCE(17);
      if (lookahead != 0) ADVANCE(20);
      END_STATE();
    case 21:
      if (lookahead == '#') ADVANCE(323);
      if (lookahead == '/') ADVANCE(316);
      if (lookahead == 0xa0 ||
          lookahead == 0x3000 ||
          lookahead == 0xfeff) ADVANCE(313);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(21);
      if (lookahead != 0) ADVANCE(360);
      END_STATE();
    case 22:
      if (lookahead == '#') ADVANCE(239);
      if (lookahead == '/') ADVANCE(238);
      if (lookahead == '\\') ADVANCE(38);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x3000 ||
          lookahead == 0xfeff) ADVANCE(237);
      if (lookahead != 0 &&
          lookahead != '\'') ADVANCE(237);
      END_STATE();
    case 23:
      if (lookahead == '#') ADVANCE(205);
      if (lookahead == '/') ADVANCE(198);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x3000 ||
          lookahead == 0xfeff) ADVANCE(197);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '#' &&
          lookahead != '}') ADVANCE(234);
      END_STATE();
    case 24:
      ADVANCE_MAP(
        '#', 50,
        '(', 123,
        ')', 124,
        '*', 149,
        ',', 121,
        '-', 35,
        '.', 173,
        '/', 26,
        ':', 119,
        ';', 115,
        '<', 127,
        '=', 36,
        '>', 131,
        '?', 135,
        '@', 109,
        '[', 118,
        ']', 122,
        '{', 125,
        '}', 126,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x3000 ||
          lookahead == 0xfeff) SKIP(24);
      if (set_contains(sym__identifier_token_character_set_2, 433, lookahead)) ADVANCE(303);
      END_STATE();
    case 25:
      if (lookahead == '&') ADVANCE(191);
      END_STATE();
    case 26:
      if (lookahead == '*') ADVANCE(28);
      if (lookahead == '/') ADVANCE(375);
      END_STATE();
    case 27:
      if (lookahead == '*') ADVANCE(27);
      if (lookahead == '/') ADVANCE(371);
      if (lookahead != 0) ADVANCE(28);
      END_STATE();
    case 28:
      if (lookahead == '*') ADVANCE(27);
      if (lookahead != 0) ADVANCE(28);
      END_STATE();
    case 29:
      if (lookahead == '*') ADVANCE(27);
      if (lookahead != 0) ADVANCE(311);
      END_STATE();
    case 30:
      if (lookahead == '8') ADVANCE(297);
      END_STATE();
    case 31:
      if (lookahead == '8') ADVANCE(299);
      END_STATE();
    case 32:
      if (lookahead == '=') ADVANCE(170);
      END_STATE();
    case 33:
      if (lookahead == '=') ADVANCE(169);
      END_STATE();
    case 34:
      if (lookahead == '=') ADVANCE(169);
      if (lookahead == '>') ADVANCE(176);
      END_STATE();
    case 35:
      if (lookahead == '>') ADVANCE(235);
      END_STATE();
    case 36:
      if (lookahead == '>') ADVANCE(176);
      END_STATE();
    case 37:
      ADVANCE_MAP(
        'U', 291,
        'u', 293,
        'x', 292,
        '"', 294,
        '\'', 294,
        '0', 294,
        '?', 294,
        '\\', 294,
        'a', 294,
        'b', 294,
        'e', 294,
        'f', 294,
        'n', 294,
        'r', 294,
        't', 294,
        'v', 294,
      );
      if (lookahead != 0) ADVANCE(290);
      END_STATE();
    case 38:
      ADVANCE_MAP(
        'U', 100,
        'u', 105,
        'x', 102,
        '"', 294,
        '\'', 294,
        '0', 294,
        '?', 294,
        '\\', 294,
        'a', 294,
        'b', 294,
        'e', 294,
        'f', 294,
        'n', 294,
        'r', 294,
        't', 294,
        'v', 294,
      );
      END_STATE();
    case 39:
      if (lookahead == '_') ADVANCE(39);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(242);
      END_STATE();
    case 40:
      if (lookahead == '_') ADVANCE(40);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(243);
      END_STATE();
    case 41:
      if (lookahead == '_') ADVANCE(41);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(244);
      END_STATE();
    case 42:
      if (lookahead == '_') ADVANCE(42);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(250);
      END_STATE();
    case 43:
      if (lookahead == '_') ADVANCE(43);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(246);
      END_STATE();
    case 44:
      if (lookahead == 'a') ADVANCE(47);
      END_STATE();
    case 45:
      if (lookahead == 'a') ADVANCE(365);
      END_STATE();
    case 46:
      if (lookahead == 'a') ADVANCE(67);
      END_STATE();
    case 47:
      if (lookahead == 'b') ADVANCE(79);
      END_STATE();
    case 48:
      ADVANCE_MAP(
        'd', 59,
        'e', 76,
        'i', 62,
        'l', 70,
        'n', 94,
        'p', 90,
        'r', 54,
        'u', 83,
        '\t', 48,
        ' ', 48,
      );
      END_STATE();
    case 49:
      ADVANCE_MAP(
        'd', 59,
        'e', 76,
        'l', 70,
        'n', 94,
        'p', 90,
        'r', 54,
        'u', 83,
        '\t', 49,
        ' ', 49,
      );
      END_STATE();
    case 50:
      ADVANCE_MAP(
        'd', 59,
        'e', 84,
        'l', 70,
        'n', 94,
        'p', 90,
        'r', 54,
        'u', 83,
        '\t', 50,
        ' ', 50,
      );
      END_STATE();
    case 51:
      if (lookahead == 'd') ADVANCE(73);
      END_STATE();
    case 52:
      if (lookahead == 'd') ADVANCE(93);
      END_STATE();
    case 53:
      if (lookahead == 'd') ADVANCE(60);
      END_STATE();
    case 54:
      if (lookahead == 'e') ADVANCE(68);
      END_STATE();
    case 55:
      if (lookahead == 'e') ADVANCE(308);
      END_STATE();
    case 56:
      if (lookahead == 'e') ADVANCE(364);
      END_STATE();
    case 57:
      if (lookahead == 'e') ADVANCE(368);
      END_STATE();
    case 58:
      if (lookahead == 'e') ADVANCE(366);
      END_STATE();
    case 59:
      if (lookahead == 'e') ADVANCE(66);
      END_STATE();
    case 60:
      if (lookahead == 'e') ADVANCE(65);
      END_STATE();
    case 61:
      if (lookahead == 'e') ADVANCE(69);
      END_STATE();
    case 62:
      if (lookahead == 'f') ADVANCE(304);
      END_STATE();
    case 63:
      if (lookahead == 'f') ADVANCE(309);
      END_STATE();
    case 64:
      if (lookahead == 'f') ADVANCE(307);
      END_STATE();
    case 65:
      if (lookahead == 'f') ADVANCE(369);
      END_STATE();
    case 66:
      if (lookahead == 'f') ADVANCE(74);
      END_STATE();
    case 67:
      if (lookahead == 'g') ADVANCE(80);
      END_STATE();
    case 68:
      if (lookahead == 'g') ADVANCE(71);
      END_STATE();
    case 69:
      if (lookahead == 'g') ADVANCE(75);
      END_STATE();
    case 70:
      if (lookahead == 'i') ADVANCE(85);
      END_STATE();
    case 71:
      if (lookahead == 'i') ADVANCE(88);
      END_STATE();
    case 72:
      if (lookahead == 'i') ADVANCE(63);
      if (lookahead == 's') ADVANCE(55);
      END_STATE();
    case 73:
      if (lookahead == 'i') ADVANCE(64);
      if (lookahead == 'r') ADVANCE(61);
      END_STATE();
    case 74:
      if (lookahead == 'i') ADVANCE(86);
      END_STATE();
    case 75:
      if (lookahead == 'i') ADVANCE(89);
      END_STATE();
    case 76:
      if (lookahead == 'l') ADVANCE(72);
      if (lookahead == 'n') ADVANCE(51);
      if (lookahead == 'r') ADVANCE(91);
      END_STATE();
    case 77:
      if (lookahead == 'l') ADVANCE(78);
      END_STATE();
    case 78:
      if (lookahead == 'l') ADVANCE(44);
      END_STATE();
    case 79:
      if (lookahead == 'l') ADVANCE(58);
      END_STATE();
    case 80:
      if (lookahead == 'm') ADVANCE(45);
      END_STATE();
    case 81:
      if (lookahead == 'n') ADVANCE(362);
      END_STATE();
    case 82:
      if (lookahead == 'n') ADVANCE(363);
      END_STATE();
    case 83:
      if (lookahead == 'n') ADVANCE(53);
      END_STATE();
    case 84:
      if (lookahead == 'n') ADVANCE(52);
      if (lookahead == 'r') ADVANCE(91);
      END_STATE();
    case 85:
      if (lookahead == 'n') ADVANCE(56);
      END_STATE();
    case 86:
      if (lookahead == 'n') ADVANCE(57);
      END_STATE();
    case 87:
      if (lookahead == 'o') ADVANCE(92);
      END_STATE();
    case 88:
      if (lookahead == 'o') ADVANCE(81);
      END_STATE();
    case 89:
      if (lookahead == 'o') ADVANCE(82);
      END_STATE();
    case 90:
      if (lookahead == 'r') ADVANCE(46);
      END_STATE();
    case 91:
      if (lookahead == 'r') ADVANCE(87);
      END_STATE();
    case 92:
      if (lookahead == 'r') ADVANCE(367);
      END_STATE();
    case 93:
      if (lookahead == 'r') ADVANCE(61);
      END_STATE();
    case 94:
      if (lookahead == 'u') ADVANCE(77);
      END_STATE();
    case 95:
      if (lookahead == '|') ADVANCE(192);
      END_STATE();
    case 96:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(98);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(251);
      END_STATE();
    case 97:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(250);
      END_STATE();
    case 98:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(251);
      END_STATE();
    case 99:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(294);
      END_STATE();
    case 100:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(108);
      END_STATE();
    case 101:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(296);
      END_STATE();
    case 102:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(101);
      END_STATE();
    case 103:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(99);
      END_STATE();
    case 104:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(103);
      END_STATE();
    case 105:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(104);
      END_STATE();
    case 106:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(105);
      END_STATE();
    case 107:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(106);
      END_STATE();
    case 108:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(107);
      END_STATE();
    case 109:
      if (set_contains(sym__identifier_token_character_set_2, 433, lookahead)) ADVANCE(303);
      END_STATE();
    case 110:
      if (lookahead != 0 &&
          lookahead != '*') ADVANCE(360);
      END_STATE();
    case 111:
      if (eof) ADVANCE(114);
      ADVANCE_MAP(
        '!', 139,
        '"', 196,
        '#', 8,
        '%', 154,
        '&', 162,
        '\'', 236,
        '(', 123,
        ')', 124,
        '*', 150,
        '+', 144,
        ',', 121,
        '-', 146,
        '.', 175,
        '/', 152,
        '0', 241,
        ':', 120,
        ';', 115,
        '<', 128,
        '=', 116,
        '>', 133,
        '?', 136,
        '@', 10,
        '[', 118,
        '\\', 38,
        ']', 122,
        '^', 156,
        '{', 125,
        '|', 158,
        '}', 126,
        '~', 140,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x3000 ||
          lookahead == 0xfeff) SKIP(111);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(242);
      if (set_contains(sym__identifier_token_character_set_2, 433, lookahead)) ADVANCE(303);
      END_STATE();
    case 112:
      if (eof) ADVANCE(114);
      ADVANCE_MAP(
        '!', 139,
        '"', 196,
        '#', 48,
        '%', 153,
        '&', 161,
        '\'', 236,
        '(', 123,
        ')', 124,
        '*', 149,
        '+', 143,
        ',', 121,
        '-', 147,
        '.', 175,
        '/', 151,
        '0', 241,
        ':', 119,
        ';', 115,
        '<', 129,
        '=', 34,
        '>', 134,
        '?', 137,
        '@', 10,
        '[', 118,
        ']', 122,
        '^', 155,
        '{', 125,
        '|', 159,
        '}', 126,
        '~', 140,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x3000 ||
          lookahead == 0xfeff) SKIP(112);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(242);
      if (set_contains(sym__identifier_token_character_set_2, 433, lookahead)) ADVANCE(303);
      END_STATE();
    case 113:
      if (eof) ADVANCE(114);
      ADVANCE_MAP(
        '!', 138,
        '"', 196,
        '#', 8,
        '&', 160,
        '\'', 236,
        '(', 123,
        ')', 124,
        '*', 149,
        '+', 143,
        ',', 121,
        '-', 147,
        '.', 175,
        '/', 26,
        '0', 241,
        ':', 120,
        ';', 115,
        '<', 130,
        '=', 117,
        '>', 132,
        '?', 135,
        '@', 10,
        '[', 118,
        ']', 122,
        '^', 155,
        '{', 125,
        '}', 126,
        '~', 140,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x3000 ||
          lookahead == 0xfeff) SKIP(113);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(242);
      if (set_contains(sym__identifier_token_character_set_2, 433, lookahead)) ADVANCE(303);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(169);
      if (lookahead == '>') ADVANCE(176);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '>') ADVANCE(176);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == ':') ADVANCE(177);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(anon_sym_LT);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(164);
      if (lookahead == '=') ADVANCE(172);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(163);
      if (lookahead == '=') ADVANCE(172);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '=') ADVANCE(172);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(anon_sym_GT);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(171);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(171);
      if (lookahead == '>') ADVANCE(165);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(171);
      if (lookahead == '>') ADVANCE(166);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead == '?') ADVANCE(194);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead == '?') ADVANCE(193);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=') ADVANCE(170);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(anon_sym_PLUS_PLUS);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(anon_sym_DASH_DASH);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(141);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(141);
      if (lookahead == '=') ADVANCE(179);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(142);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(142);
      if (lookahead == '=') ADVANCE(180);
      if (lookahead == '>') ADVANCE(235);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(142);
      if (lookahead == '>') ADVANCE(235);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '>') ADVANCE(235);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '=') ADVANCE(181);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(28);
      if (lookahead == '/') ADVANCE(375);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(28);
      if (lookahead == '/') ADVANCE(375);
      if (lookahead == '=') ADVANCE(182);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=') ADVANCE(183);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '=') ADVANCE(185);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(186);
      if (lookahead == '|') ADVANCE(192);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|') ADVANCE(192);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(191);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(191);
      if (lookahead == '=') ADVANCE(184);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '=') ADVANCE(187);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '=') ADVANCE(188);
      if (lookahead == '>') ADVANCE(168);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '>') ADVANCE(167);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT);
      if (lookahead == '=') ADVANCE(189);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      END_STATE();
    case 171:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 172:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 174:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(178);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(178);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(250);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(anon_sym_EQ_GT);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(anon_sym_COLON_COLON);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(anon_sym_DOT_DOT);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 181:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 183:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 184:
      ACCEPT_TOKEN(anon_sym_AMP_EQ);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(anon_sym_CARET_EQ);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(anon_sym_PIPE_EQ);
      END_STATE();
    case 187:
      ACCEPT_TOKEN(anon_sym_LT_LT_EQ);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(anon_sym_GT_GT_EQ);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT_EQ);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(anon_sym_QMARK_QMARK_EQ);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 192:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 193:
      ACCEPT_TOKEN(anon_sym_QMARK_QMARK);
      END_STATE();
    case 194:
      ACCEPT_TOKEN(anon_sym_QMARK_QMARK);
      if (lookahead == '=') ADVANCE(190);
      END_STATE();
    case 195:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 196:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      if (lookahead == '"') ADVANCE(15);
      END_STATE();
    case 197:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == '#') ADVANCE(205);
      if (lookahead == '/') ADVANCE(198);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x3000 ||
          lookahead == 0xfeff) ADVANCE(197);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '#' &&
          lookahead != '}') ADVANCE(234);
      END_STATE();
    case 198:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == '*') ADVANCE(200);
      if (lookahead == '/') ADVANCE(233);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '}') ADVANCE(234);
      END_STATE();
    case 199:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == '*') ADVANCE(199);
      if (lookahead == '/') ADVANCE(234);
      if (lookahead == '"' ||
          lookahead == '}') ADVANCE(28);
      if (lookahead != 0) ADVANCE(200);
      END_STATE();
    case 200:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == '*') ADVANCE(199);
      if (lookahead == '"' ||
          lookahead == '}') ADVANCE(28);
      if (lookahead != 0) ADVANCE(200);
      END_STATE();
    case 201:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == 'a') ADVANCE(234);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '}') ADVANCE(234);
      END_STATE();
    case 202:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == 'a') ADVANCE(204);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '}') ADVANCE(234);
      END_STATE();
    case 203:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == 'a') ADVANCE(214);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '}') ADVANCE(234);
      END_STATE();
    case 204:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == 'b') ADVANCE(220);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '}') ADVANCE(234);
      END_STATE();
    case 205:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      ADVANCE_MAP(
        'd', 209,
        'e', 223,
        'l', 216,
        'n', 232,
        'p', 229,
        'r', 210,
        'u', 224,
        '\t', 205,
        ' ', 205,
      );
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '}') ADVANCE(234);
      END_STATE();
    case 206:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == 'd') ADVANCE(231);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '}') ADVANCE(234);
      END_STATE();
    case 207:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == 'd') ADVANCE(211);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '}') ADVANCE(234);
      END_STATE();
    case 208:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == 'e') ADVANCE(234);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '}') ADVANCE(234);
      END_STATE();
    case 209:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == 'e') ADVANCE(213);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '}') ADVANCE(234);
      END_STATE();
    case 210:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == 'e') ADVANCE(215);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '}') ADVANCE(234);
      END_STATE();
    case 211:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == 'e') ADVANCE(212);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '}') ADVANCE(234);
      END_STATE();
    case 212:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == 'f') ADVANCE(234);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '}') ADVANCE(234);
      END_STATE();
    case 213:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == 'f') ADVANCE(216);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '}') ADVANCE(234);
      END_STATE();
    case 214:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == 'g') ADVANCE(221);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '}') ADVANCE(234);
      END_STATE();
    case 215:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == 'g') ADVANCE(217);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '}') ADVANCE(234);
      END_STATE();
    case 216:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == 'i') ADVANCE(225);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '}') ADVANCE(234);
      END_STATE();
    case 217:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == 'i') ADVANCE(226);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '}') ADVANCE(234);
      END_STATE();
    case 218:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == 'l') ADVANCE(219);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '}') ADVANCE(234);
      END_STATE();
    case 219:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == 'l') ADVANCE(202);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '}') ADVANCE(234);
      END_STATE();
    case 220:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == 'l') ADVANCE(208);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '}') ADVANCE(234);
      END_STATE();
    case 221:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == 'm') ADVANCE(201);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '}') ADVANCE(234);
      END_STATE();
    case 222:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == 'n') ADVANCE(234);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '}') ADVANCE(234);
      END_STATE();
    case 223:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == 'n') ADVANCE(206);
      if (lookahead == 'r') ADVANCE(230);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '}') ADVANCE(234);
      END_STATE();
    case 224:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == 'n') ADVANCE(207);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '}') ADVANCE(234);
      END_STATE();
    case 225:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == 'n') ADVANCE(208);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '}') ADVANCE(234);
      END_STATE();
    case 226:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == 'o') ADVANCE(222);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '}') ADVANCE(234);
      END_STATE();
    case 227:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == 'o') ADVANCE(228);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '}') ADVANCE(234);
      END_STATE();
    case 228:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == 'r') ADVANCE(234);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '}') ADVANCE(234);
      END_STATE();
    case 229:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == 'r') ADVANCE(203);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '}') ADVANCE(234);
      END_STATE();
    case 230:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == 'r') ADVANCE(227);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '}') ADVANCE(234);
      END_STATE();
    case 231:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == 'r') ADVANCE(210);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '}') ADVANCE(234);
      END_STATE();
    case 232:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == 'u') ADVANCE(218);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '}') ADVANCE(234);
      END_STATE();
    case 233:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == '\n' ||
          lookahead == '\r') ADVANCE(234);
      if (lookahead == '"' ||
          lookahead == '}') ADVANCE(375);
      if (lookahead != 0) ADVANCE(233);
      END_STATE();
    case 234:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '}') ADVANCE(234);
      END_STATE();
    case 235:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      END_STATE();
    case 236:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 237:
      ACCEPT_TOKEN(aux_sym_character_literal_token1);
      END_STATE();
    case 238:
      ACCEPT_TOKEN(aux_sym_character_literal_token1);
      if (lookahead == '*') ADVANCE(28);
      if (lookahead == '/') ADVANCE(375);
      END_STATE();
    case 239:
      ACCEPT_TOKEN(aux_sym_character_literal_token1);
      ADVANCE_MAP(
        'd', 59,
        'e', 84,
        'l', 70,
        'n', 94,
        'p', 90,
        'r', 54,
        'u', 83,
        '\t', 50,
        ' ', 50,
      );
      END_STATE();
    case 240:
      ACCEPT_TOKEN(sym_integer_literal);
      END_STATE();
    case 241:
      ACCEPT_TOKEN(sym_integer_literal);
      ADVANCE_MAP(
        '.', 97,
        '_', 39,
        'B', 40,
        'b', 40,
        'E', 96,
        'e', 96,
        'L', 248,
        'l', 248,
        'U', 247,
        'u', 247,
        'X', 41,
        'x', 41,
        'D', 249,
        'F', 249,
        'M', 249,
        'd', 249,
        'f', 249,
        'm', 249,
      );
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(242);
      END_STATE();
    case 242:
      ACCEPT_TOKEN(sym_integer_literal);
      ADVANCE_MAP(
        '.', 97,
        '_', 39,
        'E', 96,
        'e', 96,
        'L', 248,
        'l', 248,
        'U', 247,
        'u', 247,
        'D', 249,
        'F', 249,
        'M', 249,
        'd', 249,
        'f', 249,
        'm', 249,
      );
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(242);
      END_STATE();
    case 243:
      ACCEPT_TOKEN(sym_integer_literal);
      if (lookahead == '_') ADVANCE(40);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(248);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(247);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(243);
      END_STATE();
    case 244:
      ACCEPT_TOKEN(sym_integer_literal);
      if (lookahead == '_') ADVANCE(41);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(248);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(247);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(244);
      END_STATE();
    case 245:
      ACCEPT_TOKEN(sym_integer_literal);
      ADVANCE_MAP(
        '_', 43,
        'B', 40,
        'b', 40,
        'L', 248,
        'l', 248,
        'U', 247,
        'u', 247,
        'X', 41,
        'x', 41,
      );
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(246);
      END_STATE();
    case 246:
      ACCEPT_TOKEN(sym_integer_literal);
      if (lookahead == '_') ADVANCE(43);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(248);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(247);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(246);
      END_STATE();
    case 247:
      ACCEPT_TOKEN(sym_integer_literal);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(240);
      END_STATE();
    case 248:
      ACCEPT_TOKEN(sym_integer_literal);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(240);
      END_STATE();
    case 249:
      ACCEPT_TOKEN(sym_real_literal);
      END_STATE();
    case 250:
      ACCEPT_TOKEN(sym_real_literal);
      ADVANCE_MAP(
        '_', 42,
        'E', 96,
        'e', 96,
        'D', 249,
        'F', 249,
        'M', 249,
        'd', 249,
        'f', 249,
        'm', 249,
      );
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(250);
      END_STATE();
    case 251:
      ACCEPT_TOKEN(sym_real_literal);
      if (lookahead == 'D' ||
          lookahead == 'F' ||
          lookahead == 'M' ||
          lookahead == 'd' ||
          lookahead == 'f' ||
          lookahead == 'm') ADVANCE(249);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(251);
      END_STATE();
    case 252:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      if (lookahead == '\r') ADVANCE(289);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(252);
      END_STATE();
    case 253:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      if (lookahead == '#') ADVANCE(261);
      if (lookahead == '/') ADVANCE(254);
      if (lookahead == '\t' ||
          (0x0b <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x3000 ||
          lookahead == 0xfeff) ADVANCE(253);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != '"' &&
          lookahead != '#' &&
          lookahead != '\\') ADVANCE(289);
      END_STATE();
    case 254:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      if (lookahead == '*') ADVANCE(256);
      if (lookahead == '/') ADVANCE(252);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(289);
      END_STATE();
    case 255:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      if (lookahead == '*') ADVANCE(255);
      if (lookahead == '/') ADVANCE(289);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(256);
      END_STATE();
    case 256:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      if (lookahead == '*') ADVANCE(255);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(256);
      END_STATE();
    case 257:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      if (lookahead == 'a') ADVANCE(289);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(289);
      END_STATE();
    case 258:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      if (lookahead == 'a') ADVANCE(260);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(289);
      END_STATE();
    case 259:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      if (lookahead == 'a') ADVANCE(270);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(289);
      END_STATE();
    case 260:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      if (lookahead == 'b') ADVANCE(276);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(289);
      END_STATE();
    case 261:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      ADVANCE_MAP(
        'd', 265,
        'e', 279,
        'l', 272,
        'n', 288,
        'p', 285,
        'r', 266,
        'u', 280,
        '\t', 261,
        ' ', 261,
      );
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(289);
      END_STATE();
    case 262:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      if (lookahead == 'd') ADVANCE(287);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(289);
      END_STATE();
    case 263:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      if (lookahead == 'd') ADVANCE(267);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(289);
      END_STATE();
    case 264:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      if (lookahead == 'e') ADVANCE(289);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(289);
      END_STATE();
    case 265:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      if (lookahead == 'e') ADVANCE(269);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(289);
      END_STATE();
    case 266:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      if (lookahead == 'e') ADVANCE(271);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(289);
      END_STATE();
    case 267:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      if (lookahead == 'e') ADVANCE(268);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(289);
      END_STATE();
    case 268:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      if (lookahead == 'f') ADVANCE(289);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(289);
      END_STATE();
    case 269:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      if (lookahead == 'f') ADVANCE(272);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(289);
      END_STATE();
    case 270:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      if (lookahead == 'g') ADVANCE(277);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(289);
      END_STATE();
    case 271:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      if (lookahead == 'g') ADVANCE(273);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(289);
      END_STATE();
    case 272:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      if (lookahead == 'i') ADVANCE(281);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(289);
      END_STATE();
    case 273:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      if (lookahead == 'i') ADVANCE(282);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(289);
      END_STATE();
    case 274:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      if (lookahead == 'l') ADVANCE(275);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(289);
      END_STATE();
    case 275:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      if (lookahead == 'l') ADVANCE(258);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(289);
      END_STATE();
    case 276:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      if (lookahead == 'l') ADVANCE(264);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(289);
      END_STATE();
    case 277:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      if (lookahead == 'm') ADVANCE(257);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(289);
      END_STATE();
    case 278:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      if (lookahead == 'n') ADVANCE(289);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(289);
      END_STATE();
    case 279:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      if (lookahead == 'n') ADVANCE(262);
      if (lookahead == 'r') ADVANCE(286);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(289);
      END_STATE();
    case 280:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      if (lookahead == 'n') ADVANCE(263);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(289);
      END_STATE();
    case 281:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      if (lookahead == 'n') ADVANCE(264);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(289);
      END_STATE();
    case 282:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      if (lookahead == 'o') ADVANCE(278);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(289);
      END_STATE();
    case 283:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      if (lookahead == 'o') ADVANCE(284);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(289);
      END_STATE();
    case 284:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      if (lookahead == 'r') ADVANCE(289);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(289);
      END_STATE();
    case 285:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      if (lookahead == 'r') ADVANCE(259);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(289);
      END_STATE();
    case 286:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      if (lookahead == 'r') ADVANCE(283);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(289);
      END_STATE();
    case 287:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      if (lookahead == 'r') ADVANCE(266);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(289);
      END_STATE();
    case 288:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      if (lookahead == 'u') ADVANCE(274);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(289);
      END_STATE();
    case 289:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(289);
      END_STATE();
    case 290:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token2);
      END_STATE();
    case 291:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token2);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(108);
      END_STATE();
    case 292:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token2);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(101);
      END_STATE();
    case 293:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token2);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(104);
      END_STATE();
    case 294:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 295:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(294);
      END_STATE();
    case 296:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(295);
      END_STATE();
    case 297:
      ACCEPT_TOKEN(sym_verbatim_string_literal);
      END_STATE();
    case 298:
      ACCEPT_TOKEN(sym_verbatim_string_literal);
      if (lookahead == '"') ADVANCE(11);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(30);
      END_STATE();
    case 299:
      ACCEPT_TOKEN(sym_raw_string_literal);
      END_STATE();
    case 300:
      ACCEPT_TOKEN(sym_raw_string_literal);
      if (lookahead == '"') ADVANCE(300);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(19);
      if (lookahead != 0) ADVANCE(20);
      END_STATE();
    case 301:
      ACCEPT_TOKEN(sym_raw_string_literal);
      if (lookahead == '"') ADVANCE(301);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(31);
      END_STATE();
    case 302:
      ACCEPT_TOKEN(sym_raw_string_literal);
      if (lookahead == '"') ADVANCE(17);
      if (lookahead != 0) ADVANCE(20);
      END_STATE();
    case 303:
      ACCEPT_TOKEN(sym__identifier_token);
      if (set_contains(sym__identifier_token_character_set_3, 492, lookahead)) ADVANCE(303);
      END_STATE();
    case 304:
      ACCEPT_TOKEN(aux_sym_preproc_if_token1);
      END_STATE();
    case 305:
      ACCEPT_TOKEN(aux_sym_preproc_if_token2);
      if (lookahead == '\n') ADVANCE(305);
      END_STATE();
    case 306:
      ACCEPT_TOKEN(aux_sym_preproc_if_token2);
      if (lookahead == '\n') ADVANCE(306);
      if (lookahead == 0xa0 ||
          lookahead == 0x3000 ||
          lookahead == 0xfeff) ADVANCE(312);
      END_STATE();
    case 307:
      ACCEPT_TOKEN(aux_sym_preproc_if_token3);
      END_STATE();
    case 308:
      ACCEPT_TOKEN(aux_sym_preproc_else_token1);
      END_STATE();
    case 309:
      ACCEPT_TOKEN(aux_sym_preproc_elif_token1);
      END_STATE();
    case 310:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\n') ADVANCE(28);
      if (lookahead == '*') ADVANCE(310);
      if (lookahead == '/') ADVANCE(371);
      if (lookahead == '\\') ADVANCE(315);
      if (lookahead != 0) ADVANCE(311);
      END_STATE();
    case 311:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\n') ADVANCE(28);
      if (lookahead == '*') ADVANCE(310);
      if (lookahead == '/') ADVANCE(29);
      if (lookahead == '\\') ADVANCE(315);
      if (lookahead != 0) ADVANCE(311);
      END_STATE();
    case 312:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\n') ADVANCE(306);
      if (lookahead == '#') ADVANCE(323);
      if (lookahead == '/') ADVANCE(317);
      if (lookahead == '\\') ADVANCE(314);
      if (lookahead == 0xa0 ||
          lookahead == 0x3000 ||
          lookahead == 0xfeff) ADVANCE(312);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(312);
      if (lookahead != 0) ADVANCE(360);
      END_STATE();
    case 313:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\n') SKIP(21);
      if (lookahead == '#') ADVANCE(323);
      if (lookahead == '/') ADVANCE(317);
      if (lookahead == '\\') ADVANCE(314);
      if (lookahead == 0xa0 ||
          lookahead == 0x3000 ||
          lookahead == 0xfeff) ADVANCE(313);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(313);
      if (lookahead != 0) ADVANCE(360);
      END_STATE();
    case 314:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\r') ADVANCE(361);
      if (lookahead == '/') ADVANCE(110);
      if (lookahead == '\\') ADVANCE(314);
      if (lookahead != 0) ADVANCE(360);
      END_STATE();
    case 315:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\r') ADVANCE(318);
      if (lookahead == '*') ADVANCE(310);
      if (lookahead == '/') ADVANCE(29);
      if (lookahead == '\\') ADVANCE(315);
      if (lookahead != 0) ADVANCE(311);
      END_STATE();
    case 316:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '*') ADVANCE(311);
      if (lookahead == '/') ADVANCE(372);
      if (lookahead == '\\') ADVANCE(314);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(360);
      END_STATE();
    case 317:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '*') ADVANCE(311);
      if (lookahead == '/') ADVANCE(374);
      if (lookahead == '\\') ADVANCE(314);
      if (lookahead != 0) ADVANCE(360);
      END_STATE();
    case 318:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '*') ADVANCE(310);
      if (lookahead == '/') ADVANCE(29);
      if (lookahead == '\\') ADVANCE(315);
      if (lookahead != 0) ADVANCE(311);
      END_STATE();
    case 319:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(110);
      if (lookahead == '\\') ADVANCE(314);
      if (lookahead == 'a') ADVANCE(365);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(360);
      END_STATE();
    case 320:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(110);
      if (lookahead == '\\') ADVANCE(314);
      if (lookahead == 'a') ADVANCE(322);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(360);
      END_STATE();
    case 321:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(110);
      if (lookahead == '\\') ADVANCE(314);
      if (lookahead == 'a') ADVANCE(335);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(360);
      END_STATE();
    case 322:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(110);
      if (lookahead == '\\') ADVANCE(314);
      if (lookahead == 'b') ADVANCE(344);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(360);
      END_STATE();
    case 323:
      ACCEPT_TOKEN(sym_preproc_arg);
      ADVANCE_MAP(
        '/', 110,
        '\\', 314,
        'd', 329,
        'e', 348,
        'l', 338,
        'n', 359,
        'p', 356,
        'r', 330,
        'u', 349,
        '\t', 323,
        ' ', 323,
      );
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n') ADVANCE(360);
      END_STATE();
    case 324:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(110);
      if (lookahead == '\\') ADVANCE(314);
      if (lookahead == 'd') ADVANCE(358);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(360);
      END_STATE();
    case 325:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(110);
      if (lookahead == '\\') ADVANCE(314);
      if (lookahead == 'd') ADVANCE(331);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(360);
      END_STATE();
    case 326:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(110);
      if (lookahead == '\\') ADVANCE(314);
      if (lookahead == 'e') ADVANCE(364);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(360);
      END_STATE();
    case 327:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(110);
      if (lookahead == '\\') ADVANCE(314);
      if (lookahead == 'e') ADVANCE(368);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(360);
      END_STATE();
    case 328:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(110);
      if (lookahead == '\\') ADVANCE(314);
      if (lookahead == 'e') ADVANCE(366);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(360);
      END_STATE();
    case 329:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(110);
      if (lookahead == '\\') ADVANCE(314);
      if (lookahead == 'e') ADVANCE(334);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(360);
      END_STATE();
    case 330:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(110);
      if (lookahead == '\\') ADVANCE(314);
      if (lookahead == 'e') ADVANCE(336);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(360);
      END_STATE();
    case 331:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(110);
      if (lookahead == '\\') ADVANCE(314);
      if (lookahead == 'e') ADVANCE(333);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(360);
      END_STATE();
    case 332:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(110);
      if (lookahead == '\\') ADVANCE(314);
      if (lookahead == 'e') ADVANCE(337);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(360);
      END_STATE();
    case 333:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(110);
      if (lookahead == '\\') ADVANCE(314);
      if (lookahead == 'f') ADVANCE(369);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(360);
      END_STATE();
    case 334:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(110);
      if (lookahead == '\\') ADVANCE(314);
      if (lookahead == 'f') ADVANCE(340);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(360);
      END_STATE();
    case 335:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(110);
      if (lookahead == '\\') ADVANCE(314);
      if (lookahead == 'g') ADVANCE(345);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(360);
      END_STATE();
    case 336:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(110);
      if (lookahead == '\\') ADVANCE(314);
      if (lookahead == 'g') ADVANCE(339);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(360);
      END_STATE();
    case 337:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(110);
      if (lookahead == '\\') ADVANCE(314);
      if (lookahead == 'g') ADVANCE(341);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(360);
      END_STATE();
    case 338:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(110);
      if (lookahead == '\\') ADVANCE(314);
      if (lookahead == 'i') ADVANCE(350);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(360);
      END_STATE();
    case 339:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(110);
      if (lookahead == '\\') ADVANCE(314);
      if (lookahead == 'i') ADVANCE(352);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(360);
      END_STATE();
    case 340:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(110);
      if (lookahead == '\\') ADVANCE(314);
      if (lookahead == 'i') ADVANCE(351);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(360);
      END_STATE();
    case 341:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(110);
      if (lookahead == '\\') ADVANCE(314);
      if (lookahead == 'i') ADVANCE(354);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(360);
      END_STATE();
    case 342:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(110);
      if (lookahead == '\\') ADVANCE(314);
      if (lookahead == 'l') ADVANCE(343);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(360);
      END_STATE();
    case 343:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(110);
      if (lookahead == '\\') ADVANCE(314);
      if (lookahead == 'l') ADVANCE(320);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(360);
      END_STATE();
    case 344:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(110);
      if (lookahead == '\\') ADVANCE(314);
      if (lookahead == 'l') ADVANCE(328);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(360);
      END_STATE();
    case 345:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(110);
      if (lookahead == '\\') ADVANCE(314);
      if (lookahead == 'm') ADVANCE(319);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(360);
      END_STATE();
    case 346:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(110);
      if (lookahead == '\\') ADVANCE(314);
      if (lookahead == 'n') ADVANCE(362);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(360);
      END_STATE();
    case 347:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(110);
      if (lookahead == '\\') ADVANCE(314);
      if (lookahead == 'n') ADVANCE(363);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(360);
      END_STATE();
    case 348:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(110);
      if (lookahead == '\\') ADVANCE(314);
      if (lookahead == 'n') ADVANCE(324);
      if (lookahead == 'r') ADVANCE(357);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(360);
      END_STATE();
    case 349:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(110);
      if (lookahead == '\\') ADVANCE(314);
      if (lookahead == 'n') ADVANCE(325);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(360);
      END_STATE();
    case 350:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(110);
      if (lookahead == '\\') ADVANCE(314);
      if (lookahead == 'n') ADVANCE(326);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(360);
      END_STATE();
    case 351:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(110);
      if (lookahead == '\\') ADVANCE(314);
      if (lookahead == 'n') ADVANCE(327);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(360);
      END_STATE();
    case 352:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(110);
      if (lookahead == '\\') ADVANCE(314);
      if (lookahead == 'o') ADVANCE(346);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(360);
      END_STATE();
    case 353:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(110);
      if (lookahead == '\\') ADVANCE(314);
      if (lookahead == 'o') ADVANCE(355);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(360);
      END_STATE();
    case 354:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(110);
      if (lookahead == '\\') ADVANCE(314);
      if (lookahead == 'o') ADVANCE(347);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(360);
      END_STATE();
    case 355:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(110);
      if (lookahead == '\\') ADVANCE(314);
      if (lookahead == 'r') ADVANCE(367);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(360);
      END_STATE();
    case 356:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(110);
      if (lookahead == '\\') ADVANCE(314);
      if (lookahead == 'r') ADVANCE(321);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(360);
      END_STATE();
    case 357:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(110);
      if (lookahead == '\\') ADVANCE(314);
      if (lookahead == 'r') ADVANCE(353);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(360);
      END_STATE();
    case 358:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(110);
      if (lookahead == '\\') ADVANCE(314);
      if (lookahead == 'r') ADVANCE(332);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(360);
      END_STATE();
    case 359:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(110);
      if (lookahead == '\\') ADVANCE(314);
      if (lookahead == 'u') ADVANCE(342);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(360);
      END_STATE();
    case 360:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(110);
      if (lookahead == '\\') ADVANCE(314);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(360);
      END_STATE();
    case 361:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(110);
      if (lookahead == '\\') ADVANCE(314);
      if (lookahead != 0) ADVANCE(360);
      END_STATE();
    case 362:
      ACCEPT_TOKEN(aux_sym_preproc_region_token1);
      END_STATE();
    case 363:
      ACCEPT_TOKEN(aux_sym_preproc_endregion_token1);
      END_STATE();
    case 364:
      ACCEPT_TOKEN(aux_sym_preproc_line_token1);
      END_STATE();
    case 365:
      ACCEPT_TOKEN(aux_sym_preproc_pragma_token1);
      END_STATE();
    case 366:
      ACCEPT_TOKEN(aux_sym_preproc_nullable_token1);
      END_STATE();
    case 367:
      ACCEPT_TOKEN(aux_sym_preproc_error_token1);
      END_STATE();
    case 368:
      ACCEPT_TOKEN(aux_sym_preproc_define_token1);
      END_STATE();
    case 369:
      ACCEPT_TOKEN(aux_sym_preproc_undef_token1);
      END_STATE();
    case 370:
      ACCEPT_TOKEN(sym_shebang_directive);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(370);
      END_STATE();
    case 371:
      ACCEPT_TOKEN(sym_comment);
      END_STATE();
    case 372:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '*') ADVANCE(375);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(373);
      END_STATE();
    case 373:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '/') ADVANCE(372);
      if (lookahead == '\\') ADVANCE(373);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(373);
      END_STATE();
    case 374:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '/') ADVANCE(374);
      if (lookahead == '\\') ADVANCE(373);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(373);
      END_STATE();
    case 375:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(375);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      ADVANCE_MAP(
        'C', 1,
        'F', 2,
        'S', 3,
        'T', 4,
        'U', 5,
        '_', 6,
        'a', 7,
        'b', 8,
        'c', 9,
        'd', 10,
        'e', 11,
        'f', 12,
        'g', 13,
        'h', 14,
        'i', 15,
        'j', 16,
        'l', 17,
        'm', 18,
        'n', 19,
        'o', 20,
        'p', 21,
        'r', 22,
        's', 23,
        't', 24,
        'u', 25,
        'v', 26,
        'w', 27,
        'y', 28,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x3000 ||
          lookahead == 0xfeff) SKIP(29);
      END_STATE();
    case 1:
      if (lookahead == 'd') ADVANCE(30);
      END_STATE();
    case 2:
      if (lookahead == 'a') ADVANCE(31);
      END_STATE();
    case 3:
      if (lookahead == 't') ADVANCE(32);
      END_STATE();
    case 4:
      if (lookahead == 'h') ADVANCE(33);
      END_STATE();
    case 5:
      if (lookahead == '8') ADVANCE(34);
      END_STATE();
    case 6:
      ACCEPT_TOKEN(sym_discard);
      if (lookahead == '_') ADVANCE(35);
      END_STATE();
    case 7:
      if (lookahead == 'b') ADVANCE(36);
      if (lookahead == 'd') ADVANCE(37);
      if (lookahead == 'l') ADVANCE(38);
      if (lookahead == 'n') ADVANCE(39);
      if (lookahead == 's') ADVANCE(40);
      if (lookahead == 'w') ADVANCE(41);
      END_STATE();
    case 8:
      if (lookahead == 'a') ADVANCE(42);
      if (lookahead == 'o') ADVANCE(43);
      if (lookahead == 'r') ADVANCE(44);
      if (lookahead == 'y') ADVANCE(45);
      END_STATE();
    case 9:
      if (lookahead == 'a') ADVANCE(46);
      if (lookahead == 'h') ADVANCE(47);
      if (lookahead == 'l') ADVANCE(48);
      if (lookahead == 'o') ADVANCE(49);
      END_STATE();
    case 10:
      if (lookahead == 'e') ADVANCE(50);
      if (lookahead == 'i') ADVANCE(51);
      if (lookahead == 'o') ADVANCE(52);
      END_STATE();
    case 11:
      if (lookahead == 'l') ADVANCE(53);
      if (lookahead == 'n') ADVANCE(54);
      if (lookahead == 'q') ADVANCE(55);
      if (lookahead == 'v') ADVANCE(56);
      if (lookahead == 'x') ADVANCE(57);
      END_STATE();
    case 12:
      if (lookahead == 'a') ADVANCE(58);
      if (lookahead == 'i') ADVANCE(59);
      if (lookahead == 'l') ADVANCE(60);
      if (lookahead == 'o') ADVANCE(61);
      if (lookahead == 'r') ADVANCE(62);
      END_STATE();
    case 13:
      if (lookahead == 'e') ADVANCE(63);
      if (lookahead == 'l') ADVANCE(64);
      if (lookahead == 'o') ADVANCE(65);
      if (lookahead == 'r') ADVANCE(66);
      END_STATE();
    case 14:
      if (lookahead == 'i') ADVANCE(67);
      END_STATE();
    case 15:
      if (lookahead == 'f') ADVANCE(68);
      if (lookahead == 'm') ADVANCE(69);
      if (lookahead == 'n') ADVANCE(70);
      if (lookahead == 's') ADVANCE(71);
      END_STATE();
    case 16:
      if (lookahead == 'o') ADVANCE(72);
      END_STATE();
    case 17:
      if (lookahead == 'e') ADVANCE(73);
      if (lookahead == 'o') ADVANCE(74);
      END_STATE();
    case 18:
      if (lookahead == 'a') ADVANCE(75);
      if (lookahead == 'e') ADVANCE(76);
      if (lookahead == 'o') ADVANCE(77);
      END_STATE();
    case 19:
      if (lookahead == 'a') ADVANCE(78);
      if (lookahead == 'e') ADVANCE(79);
      if (lookahead == 'i') ADVANCE(80);
      if (lookahead == 'o') ADVANCE(81);
      if (lookahead == 'u') ADVANCE(82);
      END_STATE();
    case 20:
      if (lookahead == 'b') ADVANCE(83);
      if (lookahead == 'n') ADVANCE(84);
      if (lookahead == 'p') ADVANCE(85);
      if (lookahead == 'r') ADVANCE(86);
      if (lookahead == 'u') ADVANCE(87);
      if (lookahead == 'v') ADVANCE(88);
      END_STATE();
    case 21:
      if (lookahead == 'a') ADVANCE(89);
      if (lookahead == 'r') ADVANCE(90);
      if (lookahead == 'u') ADVANCE(91);
      END_STATE();
    case 22:
      if (lookahead == 'e') ADVANCE(92);
      END_STATE();
    case 23:
      if (lookahead == 'b') ADVANCE(93);
      if (lookahead == 'c') ADVANCE(94);
      if (lookahead == 'e') ADVANCE(95);
      if (lookahead == 'h') ADVANCE(96);
      if (lookahead == 'i') ADVANCE(97);
      if (lookahead == 't') ADVANCE(98);
      if (lookahead == 'w') ADVANCE(99);
      END_STATE();
    case 24:
      if (lookahead == 'h') ADVANCE(100);
      if (lookahead == 'r') ADVANCE(101);
      if (lookahead == 'y') ADVANCE(102);
      END_STATE();
    case 25:
      if (lookahead == '8') ADVANCE(34);
      if (lookahead == 'i') ADVANCE(103);
      if (lookahead == 'l') ADVANCE(104);
      if (lookahead == 'n') ADVANCE(105);
      if (lookahead == 's') ADVANCE(106);
      END_STATE();
    case 26:
      if (lookahead == 'a') ADVANCE(107);
      if (lookahead == 'i') ADVANCE(108);
      if (lookahead == 'o') ADVANCE(109);
      END_STATE();
    case 27:
      if (lookahead == 'a') ADVANCE(110);
      if (lookahead == 'h') ADVANCE(111);
      if (lookahead == 'i') ADVANCE(112);
      END_STATE();
    case 28:
      if (lookahead == 'i') ADVANCE(113);
      END_STATE();
    case 29:
      ADVANCE_MAP(
        'C', 1,
        'F', 2,
        'S', 3,
        'T', 4,
        '_', 6,
        'a', 7,
        'b', 8,
        'c', 9,
        'd', 10,
        'e', 11,
        'f', 12,
        'g', 13,
        'h', 14,
        'i', 15,
        'j', 16,
        'l', 17,
        'm', 18,
        'n', 19,
        'o', 20,
        'p', 21,
        'r', 22,
        's', 23,
        't', 24,
        'u', 114,
        'v', 26,
        'w', 27,
        'y', 28,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x3000 ||
          lookahead == 0xfeff) SKIP(29);
      END_STATE();
    case 30:
      if (lookahead == 'e') ADVANCE(115);
      END_STATE();
    case 31:
      if (lookahead == 's') ADVANCE(116);
      END_STATE();
    case 32:
      if (lookahead == 'd') ADVANCE(117);
      END_STATE();
    case 33:
      if (lookahead == 'i') ADVANCE(118);
      END_STATE();
    case 34:
      ACCEPT_TOKEN(sym_string_literal_encoding);
      END_STATE();
    case 35:
      if (lookahead == 'm') ADVANCE(119);
      if (lookahead == 'r') ADVANCE(120);
      END_STATE();
    case 36:
      if (lookahead == 's') ADVANCE(121);
      END_STATE();
    case 37:
      if (lookahead == 'd') ADVANCE(122);
      END_STATE();
    case 38:
      if (lookahead == 'i') ADVANCE(123);
      END_STATE();
    case 39:
      if (lookahead == 'd') ADVANCE(124);
      if (lookahead == 'n') ADVANCE(125);
      END_STATE();
    case 40:
      ACCEPT_TOKEN(anon_sym_as);
      if (lookahead == 'c') ADVANCE(126);
      if (lookahead == 's') ADVANCE(127);
      if (lookahead == 'y') ADVANCE(128);
      END_STATE();
    case 41:
      if (lookahead == 'a') ADVANCE(129);
      END_STATE();
    case 42:
      if (lookahead == 's') ADVANCE(130);
      END_STATE();
    case 43:
      if (lookahead == 'o') ADVANCE(131);
      END_STATE();
    case 44:
      if (lookahead == 'e') ADVANCE(132);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(anon_sym_by);
      if (lookahead == 't') ADVANCE(133);
      END_STATE();
    case 46:
      if (lookahead == 's') ADVANCE(134);
      if (lookahead == 't') ADVANCE(135);
      END_STATE();
    case 47:
      if (lookahead == 'a') ADVANCE(136);
      if (lookahead == 'e') ADVANCE(137);
      END_STATE();
    case 48:
      if (lookahead == 'a') ADVANCE(138);
      END_STATE();
    case 49:
      if (lookahead == 'n') ADVANCE(139);
      END_STATE();
    case 50:
      if (lookahead == 'c') ADVANCE(140);
      if (lookahead == 'f') ADVANCE(141);
      if (lookahead == 'l') ADVANCE(142);
      if (lookahead == 's') ADVANCE(143);
      END_STATE();
    case 51:
      if (lookahead == 's') ADVANCE(144);
      END_STATE();
    case 52:
      ACCEPT_TOKEN(anon_sym_do);
      if (lookahead == 'u') ADVANCE(145);
      END_STATE();
    case 53:
      if (lookahead == 's') ADVANCE(146);
      END_STATE();
    case 54:
      if (lookahead == 'a') ADVANCE(147);
      if (lookahead == 'u') ADVANCE(148);
      END_STATE();
    case 55:
      if (lookahead == 'u') ADVANCE(149);
      END_STATE();
    case 56:
      if (lookahead == 'e') ADVANCE(150);
      END_STATE();
    case 57:
      if (lookahead == 'p') ADVANCE(151);
      if (lookahead == 't') ADVANCE(152);
      END_STATE();
    case 58:
      if (lookahead == 'l') ADVANCE(153);
      END_STATE();
    case 59:
      if (lookahead == 'e') ADVANCE(154);
      if (lookahead == 'l') ADVANCE(155);
      if (lookahead == 'n') ADVANCE(156);
      if (lookahead == 'x') ADVANCE(157);
      END_STATE();
    case 60:
      if (lookahead == 'o') ADVANCE(158);
      END_STATE();
    case 61:
      if (lookahead == 'r') ADVANCE(159);
      END_STATE();
    case 62:
      if (lookahead == 'o') ADVANCE(160);
      END_STATE();
    case 63:
      if (lookahead == 't') ADVANCE(161);
      END_STATE();
    case 64:
      if (lookahead == 'o') ADVANCE(162);
      END_STATE();
    case 65:
      if (lookahead == 't') ADVANCE(163);
      END_STATE();
    case 66:
      if (lookahead == 'o') ADVANCE(164);
      END_STATE();
    case 67:
      if (lookahead == 'd') ADVANCE(165);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 69:
      if (lookahead == 'p') ADVANCE(166);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(anon_sym_in);
      if (lookahead == 'i') ADVANCE(167);
      if (lookahead == 't') ADVANCE(168);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(anon_sym_is);
      END_STATE();
    case 72:
      if (lookahead == 'i') ADVANCE(169);
      END_STATE();
    case 73:
      if (lookahead == 't') ADVANCE(170);
      END_STATE();
    case 74:
      if (lookahead == 'c') ADVANCE(171);
      if (lookahead == 'n') ADVANCE(172);
      END_STATE();
    case 75:
      if (lookahead == 'n') ADVANCE(173);
      END_STATE();
    case 76:
      if (lookahead == 't') ADVANCE(174);
      END_STATE();
    case 77:
      if (lookahead == 'd') ADVANCE(175);
      END_STATE();
    case 78:
      if (lookahead == 'm') ADVANCE(176);
      END_STATE();
    case 79:
      if (lookahead == 'w') ADVANCE(177);
      END_STATE();
    case 80:
      if (lookahead == 'n') ADVANCE(178);
      END_STATE();
    case 81:
      if (lookahead == 't') ADVANCE(179);
      END_STATE();
    case 82:
      if (lookahead == 'i') ADVANCE(180);
      if (lookahead == 'l') ADVANCE(181);
      END_STATE();
    case 83:
      if (lookahead == 'j') ADVANCE(182);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(anon_sym_on);
      END_STATE();
    case 85:
      if (lookahead == 'e') ADVANCE(183);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(anon_sym_or);
      if (lookahead == 'd') ADVANCE(184);
      END_STATE();
    case 87:
      if (lookahead == 't') ADVANCE(185);
      END_STATE();
    case 88:
      if (lookahead == 'e') ADVANCE(186);
      END_STATE();
    case 89:
      if (lookahead == 'r') ADVANCE(187);
      END_STATE();
    case 90:
      if (lookahead == 'i') ADVANCE(188);
      if (lookahead == 'o') ADVANCE(189);
      END_STATE();
    case 91:
      if (lookahead == 'b') ADVANCE(190);
      END_STATE();
    case 92:
      if (lookahead == 'a') ADVANCE(191);
      if (lookahead == 'c') ADVANCE(192);
      if (lookahead == 'f') ADVANCE(193);
      if (lookahead == 'm') ADVANCE(194);
      if (lookahead == 'q') ADVANCE(195);
      if (lookahead == 's') ADVANCE(196);
      if (lookahead == 't') ADVANCE(197);
      END_STATE();
    case 93:
      if (lookahead == 'y') ADVANCE(198);
      END_STATE();
    case 94:
      if (lookahead == 'o') ADVANCE(199);
      END_STATE();
    case 95:
      if (lookahead == 'a') ADVANCE(200);
      if (lookahead == 'l') ADVANCE(201);
      if (lookahead == 't') ADVANCE(202);
      END_STATE();
    case 96:
      if (lookahead == 'o') ADVANCE(203);
      END_STATE();
    case 97:
      if (lookahead == 'z') ADVANCE(204);
      END_STATE();
    case 98:
      if (lookahead == 'a') ADVANCE(205);
      if (lookahead == 'r') ADVANCE(206);
      END_STATE();
    case 99:
      if (lookahead == 'i') ADVANCE(207);
      END_STATE();
    case 100:
      if (lookahead == 'i') ADVANCE(208);
      if (lookahead == 'r') ADVANCE(209);
      END_STATE();
    case 101:
      if (lookahead == 'u') ADVANCE(210);
      if (lookahead == 'y') ADVANCE(211);
      END_STATE();
    case 102:
      if (lookahead == 'p') ADVANCE(212);
      END_STATE();
    case 103:
      if (lookahead == 'n') ADVANCE(213);
      END_STATE();
    case 104:
      if (lookahead == 'o') ADVANCE(214);
      END_STATE();
    case 105:
      if (lookahead == 'c') ADVANCE(215);
      if (lookahead == 'm') ADVANCE(216);
      if (lookahead == 's') ADVANCE(217);
      END_STATE();
    case 106:
      if (lookahead == 'h') ADVANCE(218);
      if (lookahead == 'i') ADVANCE(219);
      END_STATE();
    case 107:
      if (lookahead == 'r') ADVANCE(220);
      END_STATE();
    case 108:
      if (lookahead == 'r') ADVANCE(221);
      END_STATE();
    case 109:
      if (lookahead == 'i') ADVANCE(222);
      if (lookahead == 'l') ADVANCE(223);
      END_STATE();
    case 110:
      if (lookahead == 'r') ADVANCE(224);
      END_STATE();
    case 111:
      if (lookahead == 'e') ADVANCE(225);
      if (lookahead == 'i') ADVANCE(226);
      END_STATE();
    case 112:
      if (lookahead == 't') ADVANCE(227);
      END_STATE();
    case 113:
      if (lookahead == 'e') ADVANCE(228);
      END_STATE();
    case 114:
      if (lookahead == 'i') ADVANCE(103);
      if (lookahead == 'l') ADVANCE(104);
      if (lookahead == 'n') ADVANCE(105);
      if (lookahead == 's') ADVANCE(106);
      END_STATE();
    case 115:
      if (lookahead == 'c') ADVANCE(229);
      END_STATE();
    case 116:
      if (lookahead == 't') ADVANCE(230);
      END_STATE();
    case 117:
      if (lookahead == 'c') ADVANCE(231);
      END_STATE();
    case 118:
      if (lookahead == 's') ADVANCE(232);
      END_STATE();
    case 119:
      if (lookahead == 'a') ADVANCE(233);
      END_STATE();
    case 120:
      if (lookahead == 'e') ADVANCE(234);
      END_STATE();
    case 121:
      if (lookahead == 't') ADVANCE(235);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(anon_sym_add);
      END_STATE();
    case 123:
      if (lookahead == 'a') ADVANCE(236);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(anon_sym_and);
      END_STATE();
    case 125:
      if (lookahead == 'o') ADVANCE(237);
      END_STATE();
    case 126:
      if (lookahead == 'e') ADVANCE(238);
      END_STATE();
    case 127:
      if (lookahead == 'e') ADVANCE(239);
      END_STATE();
    case 128:
      if (lookahead == 'n') ADVANCE(240);
      END_STATE();
    case 129:
      if (lookahead == 'i') ADVANCE(241);
      END_STATE();
    case 130:
      if (lookahead == 'e') ADVANCE(242);
      END_STATE();
    case 131:
      if (lookahead == 'l') ADVANCE(243);
      END_STATE();
    case 132:
      if (lookahead == 'a') ADVANCE(244);
      END_STATE();
    case 133:
      if (lookahead == 'e') ADVANCE(243);
      END_STATE();
    case 134:
      if (lookahead == 'e') ADVANCE(245);
      END_STATE();
    case 135:
      if (lookahead == 'c') ADVANCE(246);
      END_STATE();
    case 136:
      if (lookahead == 'r') ADVANCE(243);
      END_STATE();
    case 137:
      if (lookahead == 'c') ADVANCE(247);
      END_STATE();
    case 138:
      if (lookahead == 's') ADVANCE(248);
      END_STATE();
    case 139:
      if (lookahead == 's') ADVANCE(249);
      if (lookahead == 't') ADVANCE(250);
      END_STATE();
    case 140:
      if (lookahead == 'i') ADVANCE(251);
      END_STATE();
    case 141:
      if (lookahead == 'a') ADVANCE(252);
      END_STATE();
    case 142:
      if (lookahead == 'e') ADVANCE(253);
      END_STATE();
    case 143:
      if (lookahead == 'c') ADVANCE(254);
      END_STATE();
    case 144:
      if (lookahead == 'a') ADVANCE(255);
      END_STATE();
    case 145:
      if (lookahead == 'b') ADVANCE(256);
      END_STATE();
    case 146:
      if (lookahead == 'e') ADVANCE(257);
      END_STATE();
    case 147:
      if (lookahead == 'b') ADVANCE(258);
      END_STATE();
    case 148:
      if (lookahead == 'm') ADVANCE(259);
      END_STATE();
    case 149:
      if (lookahead == 'a') ADVANCE(260);
      END_STATE();
    case 150:
      if (lookahead == 'n') ADVANCE(261);
      END_STATE();
    case 151:
      if (lookahead == 'l') ADVANCE(262);
      END_STATE();
    case 152:
      if (lookahead == 'e') ADVANCE(263);
      END_STATE();
    case 153:
      if (lookahead == 's') ADVANCE(264);
      END_STATE();
    case 154:
      if (lookahead == 'l') ADVANCE(265);
      END_STATE();
    case 155:
      if (lookahead == 'e') ADVANCE(266);
      END_STATE();
    case 156:
      if (lookahead == 'a') ADVANCE(267);
      END_STATE();
    case 157:
      if (lookahead == 'e') ADVANCE(268);
      END_STATE();
    case 158:
      if (lookahead == 'a') ADVANCE(269);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(anon_sym_for);
      if (lookahead == 'e') ADVANCE(270);
      END_STATE();
    case 160:
      if (lookahead == 'm') ADVANCE(271);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(anon_sym_get);
      END_STATE();
    case 162:
      if (lookahead == 'b') ADVANCE(272);
      END_STATE();
    case 163:
      if (lookahead == 'o') ADVANCE(273);
      END_STATE();
    case 164:
      if (lookahead == 'u') ADVANCE(274);
      END_STATE();
    case 165:
      if (lookahead == 'd') ADVANCE(275);
      END_STATE();
    case 166:
      if (lookahead == 'l') ADVANCE(276);
      END_STATE();
    case 167:
      if (lookahead == 't') ADVANCE(277);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(sym_predefined_type);
      if (lookahead == 'e') ADVANCE(278);
      if (lookahead == 'o') ADVANCE(279);
      END_STATE();
    case 169:
      if (lookahead == 'n') ADVANCE(280);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(anon_sym_let);
      END_STATE();
    case 171:
      if (lookahead == 'k') ADVANCE(281);
      END_STATE();
    case 172:
      if (lookahead == 'g') ADVANCE(243);
      END_STATE();
    case 173:
      if (lookahead == 'a') ADVANCE(282);
      END_STATE();
    case 174:
      if (lookahead == 'h') ADVANCE(283);
      END_STATE();
    case 175:
      if (lookahead == 'u') ADVANCE(284);
      END_STATE();
    case 176:
      if (lookahead == 'e') ADVANCE(285);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(anon_sym_new);
      END_STATE();
    case 178:
      if (lookahead == 't') ADVANCE(243);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(anon_sym_not);
      if (lookahead == 'n') ADVANCE(286);
      END_STATE();
    case 180:
      if (lookahead == 'n') ADVANCE(287);
      END_STATE();
    case 181:
      if (lookahead == 'l') ADVANCE(288);
      END_STATE();
    case 182:
      if (lookahead == 'e') ADVANCE(289);
      END_STATE();
    case 183:
      if (lookahead == 'r') ADVANCE(290);
      END_STATE();
    case 184:
      if (lookahead == 'e') ADVANCE(291);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(anon_sym_out);
      END_STATE();
    case 186:
      if (lookahead == 'r') ADVANCE(292);
      END_STATE();
    case 187:
      if (lookahead == 'a') ADVANCE(293);
      if (lookahead == 't') ADVANCE(294);
      END_STATE();
    case 188:
      if (lookahead == 'v') ADVANCE(295);
      END_STATE();
    case 189:
      if (lookahead == 'p') ADVANCE(296);
      if (lookahead == 't') ADVANCE(297);
      END_STATE();
    case 190:
      if (lookahead == 'l') ADVANCE(298);
      END_STATE();
    case 191:
      if (lookahead == 'd') ADVANCE(299);
      END_STATE();
    case 192:
      if (lookahead == 'o') ADVANCE(300);
      END_STATE();
    case 193:
      ACCEPT_TOKEN(anon_sym_ref);
      END_STATE();
    case 194:
      if (lookahead == 'o') ADVANCE(301);
      END_STATE();
    case 195:
      if (lookahead == 'u') ADVANCE(302);
      END_STATE();
    case 196:
      if (lookahead == 't') ADVANCE(303);
      END_STATE();
    case 197:
      if (lookahead == 'u') ADVANCE(304);
      END_STATE();
    case 198:
      if (lookahead == 't') ADVANCE(305);
      END_STATE();
    case 199:
      if (lookahead == 'p') ADVANCE(306);
      END_STATE();
    case 200:
      if (lookahead == 'l') ADVANCE(307);
      END_STATE();
    case 201:
      if (lookahead == 'e') ADVANCE(308);
      END_STATE();
    case 202:
      ACCEPT_TOKEN(anon_sym_set);
      END_STATE();
    case 203:
      if (lookahead == 'r') ADVANCE(309);
      END_STATE();
    case 204:
      if (lookahead == 'e') ADVANCE(310);
      END_STATE();
    case 205:
      if (lookahead == 'c') ADVANCE(311);
      if (lookahead == 't') ADVANCE(312);
      END_STATE();
    case 206:
      if (lookahead == 'i') ADVANCE(313);
      if (lookahead == 'u') ADVANCE(314);
      END_STATE();
    case 207:
      if (lookahead == 't') ADVANCE(315);
      END_STATE();
    case 208:
      if (lookahead == 's') ADVANCE(316);
      END_STATE();
    case 209:
      if (lookahead == 'o') ADVANCE(317);
      END_STATE();
    case 210:
      if (lookahead == 'e') ADVANCE(318);
      END_STATE();
    case 211:
      ACCEPT_TOKEN(anon_sym_try);
      END_STATE();
    case 212:
      if (lookahead == 'e') ADVANCE(319);
      END_STATE();
    case 213:
      if (lookahead == 't') ADVANCE(243);
      END_STATE();
    case 214:
      if (lookahead == 'n') ADVANCE(320);
      END_STATE();
    case 215:
      if (lookahead == 'h') ADVANCE(321);
      END_STATE();
    case 216:
      if (lookahead == 'a') ADVANCE(322);
      END_STATE();
    case 217:
      if (lookahead == 'a') ADVANCE(323);
      END_STATE();
    case 218:
      if (lookahead == 'o') ADVANCE(324);
      END_STATE();
    case 219:
      if (lookahead == 'n') ADVANCE(325);
      END_STATE();
    case 220:
      ACCEPT_TOKEN(anon_sym_var);
      END_STATE();
    case 221:
      if (lookahead == 't') ADVANCE(326);
      END_STATE();
    case 222:
      if (lookahead == 'd') ADVANCE(243);
      END_STATE();
    case 223:
      if (lookahead == 'a') ADVANCE(327);
      END_STATE();
    case 224:
      if (lookahead == 'n') ADVANCE(328);
      END_STATE();
    case 225:
      if (lookahead == 'n') ADVANCE(329);
      if (lookahead == 'r') ADVANCE(330);
      END_STATE();
    case 226:
      if (lookahead == 'l') ADVANCE(331);
      END_STATE();
    case 227:
      if (lookahead == 'h') ADVANCE(332);
      END_STATE();
    case 228:
      if (lookahead == 'l') ADVANCE(333);
      END_STATE();
    case 229:
      if (lookahead == 'l') ADVANCE(334);
      END_STATE();
    case 230:
      if (lookahead == 'c') ADVANCE(335);
      END_STATE();
    case 231:
      if (lookahead == 'a') ADVANCE(336);
      END_STATE();
    case 232:
      if (lookahead == 'c') ADVANCE(337);
      END_STATE();
    case 233:
      if (lookahead == 'k') ADVANCE(338);
      END_STATE();
    case 234:
      if (lookahead == 'f') ADVANCE(339);
      END_STATE();
    case 235:
      if (lookahead == 'r') ADVANCE(340);
      END_STATE();
    case 236:
      if (lookahead == 's') ADVANCE(341);
      END_STATE();
    case 237:
      if (lookahead == 't') ADVANCE(342);
      END_STATE();
    case 238:
      if (lookahead == 'n') ADVANCE(343);
      END_STATE();
    case 239:
      if (lookahead == 'm') ADVANCE(344);
      END_STATE();
    case 240:
      if (lookahead == 'c') ADVANCE(345);
      END_STATE();
    case 241:
      if (lookahead == 't') ADVANCE(346);
      END_STATE();
    case 242:
      ACCEPT_TOKEN(anon_sym_base);
      END_STATE();
    case 243:
      ACCEPT_TOKEN(sym_predefined_type);
      END_STATE();
    case 244:
      if (lookahead == 'k') ADVANCE(347);
      END_STATE();
    case 245:
      ACCEPT_TOKEN(anon_sym_case);
      END_STATE();
    case 246:
      if (lookahead == 'h') ADVANCE(348);
      END_STATE();
    case 247:
      if (lookahead == 'k') ADVANCE(349);
      END_STATE();
    case 248:
      if (lookahead == 's') ADVANCE(350);
      END_STATE();
    case 249:
      if (lookahead == 't') ADVANCE(351);
      END_STATE();
    case 250:
      if (lookahead == 'i') ADVANCE(352);
      END_STATE();
    case 251:
      if (lookahead == 'm') ADVANCE(353);
      END_STATE();
    case 252:
      if (lookahead == 'u') ADVANCE(354);
      END_STATE();
    case 253:
      if (lookahead == 'g') ADVANCE(355);
      END_STATE();
    case 254:
      if (lookahead == 'e') ADVANCE(356);
      END_STATE();
    case 255:
      if (lookahead == 'b') ADVANCE(357);
      END_STATE();
    case 256:
      if (lookahead == 'l') ADVANCE(358);
      END_STATE();
    case 257:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 258:
      if (lookahead == 'l') ADVANCE(359);
      END_STATE();
    case 259:
      ACCEPT_TOKEN(anon_sym_enum);
      END_STATE();
    case 260:
      if (lookahead == 'l') ADVANCE(360);
      END_STATE();
    case 261:
      if (lookahead == 't') ADVANCE(361);
      END_STATE();
    case 262:
      if (lookahead == 'i') ADVANCE(362);
      END_STATE();
    case 263:
      if (lookahead == 'r') ADVANCE(363);
      END_STATE();
    case 264:
      if (lookahead == 'e') ADVANCE(364);
      END_STATE();
    case 265:
      if (lookahead == 'd') ADVANCE(365);
      END_STATE();
    case 266:
      ACCEPT_TOKEN(anon_sym_file);
      END_STATE();
    case 267:
      if (lookahead == 'l') ADVANCE(366);
      END_STATE();
    case 268:
      if (lookahead == 'd') ADVANCE(367);
      END_STATE();
    case 269:
      if (lookahead == 't') ADVANCE(243);
      END_STATE();
    case 270:
      if (lookahead == 'a') ADVANCE(368);
      END_STATE();
    case 271:
      ACCEPT_TOKEN(anon_sym_from);
      END_STATE();
    case 272:
      if (lookahead == 'a') ADVANCE(369);
      END_STATE();
    case 273:
      ACCEPT_TOKEN(anon_sym_goto);
      END_STATE();
    case 274:
      if (lookahead == 'p') ADVANCE(370);
      END_STATE();
    case 275:
      if (lookahead == 'e') ADVANCE(371);
      END_STATE();
    case 276:
      if (lookahead == 'i') ADVANCE(372);
      END_STATE();
    case 277:
      ACCEPT_TOKEN(anon_sym_init);
      END_STATE();
    case 278:
      if (lookahead == 'r') ADVANCE(373);
      END_STATE();
    case 279:
      ACCEPT_TOKEN(anon_sym_into);
      END_STATE();
    case 280:
      ACCEPT_TOKEN(anon_sym_join);
      END_STATE();
    case 281:
      ACCEPT_TOKEN(anon_sym_lock);
      END_STATE();
    case 282:
      if (lookahead == 'g') ADVANCE(374);
      END_STATE();
    case 283:
      if (lookahead == 'o') ADVANCE(375);
      END_STATE();
    case 284:
      if (lookahead == 'l') ADVANCE(376);
      END_STATE();
    case 285:
      if (lookahead == 's') ADVANCE(377);
      END_STATE();
    case 286:
      if (lookahead == 'u') ADVANCE(378);
      END_STATE();
    case 287:
      if (lookahead == 't') ADVANCE(243);
      END_STATE();
    case 288:
      ACCEPT_TOKEN(sym_null_literal);
      END_STATE();
    case 289:
      if (lookahead == 'c') ADVANCE(379);
      END_STATE();
    case 290:
      if (lookahead == 'a') ADVANCE(380);
      END_STATE();
    case 291:
      if (lookahead == 'r') ADVANCE(381);
      END_STATE();
    case 292:
      if (lookahead == 'r') ADVANCE(382);
      END_STATE();
    case 293:
      if (lookahead == 'm') ADVANCE(383);
      END_STATE();
    case 294:
      if (lookahead == 'i') ADVANCE(384);
      END_STATE();
    case 295:
      if (lookahead == 'a') ADVANCE(385);
      END_STATE();
    case 296:
      if (lookahead == 'e') ADVANCE(386);
      END_STATE();
    case 297:
      if (lookahead == 'e') ADVANCE(387);
      END_STATE();
    case 298:
      if (lookahead == 'i') ADVANCE(388);
      END_STATE();
    case 299:
      if (lookahead == 'o') ADVANCE(389);
      END_STATE();
    case 300:
      if (lookahead == 'r') ADVANCE(390);
      END_STATE();
    case 301:
      if (lookahead == 'v') ADVANCE(391);
      END_STATE();
    case 302:
      if (lookahead == 'i') ADVANCE(392);
      END_STATE();
    case 303:
      if (lookahead == 'o') ADVANCE(393);
      END_STATE();
    case 304:
      if (lookahead == 'r') ADVANCE(394);
      END_STATE();
    case 305:
      if (lookahead == 'e') ADVANCE(243);
      END_STATE();
    case 306:
      if (lookahead == 'e') ADVANCE(395);
      END_STATE();
    case 307:
      if (lookahead == 'e') ADVANCE(396);
      END_STATE();
    case 308:
      if (lookahead == 'c') ADVANCE(397);
      END_STATE();
    case 309:
      if (lookahead == 't') ADVANCE(243);
      END_STATE();
    case 310:
      if (lookahead == 'o') ADVANCE(398);
      END_STATE();
    case 311:
      if (lookahead == 'k') ADVANCE(399);
      END_STATE();
    case 312:
      if (lookahead == 'i') ADVANCE(400);
      END_STATE();
    case 313:
      if (lookahead == 'n') ADVANCE(401);
      END_STATE();
    case 314:
      if (lookahead == 'c') ADVANCE(402);
      END_STATE();
    case 315:
      if (lookahead == 'c') ADVANCE(403);
      END_STATE();
    case 316:
      ACCEPT_TOKEN(anon_sym_this);
      END_STATE();
    case 317:
      if (lookahead == 'w') ADVANCE(404);
      END_STATE();
    case 318:
      ACCEPT_TOKEN(anon_sym_true);
      END_STATE();
    case 319:
      ACCEPT_TOKEN(anon_sym_type);
      if (lookahead == 'o') ADVANCE(405);
      END_STATE();
    case 320:
      if (lookahead == 'g') ADVANCE(243);
      END_STATE();
    case 321:
      if (lookahead == 'e') ADVANCE(406);
      END_STATE();
    case 322:
      if (lookahead == 'n') ADVANCE(407);
      END_STATE();
    case 323:
      if (lookahead == 'f') ADVANCE(408);
      END_STATE();
    case 324:
      if (lookahead == 'r') ADVANCE(409);
      END_STATE();
    case 325:
      if (lookahead == 'g') ADVANCE(410);
      END_STATE();
    case 326:
      if (lookahead == 'u') ADVANCE(411);
      END_STATE();
    case 327:
      if (lookahead == 't') ADVANCE(412);
      END_STATE();
    case 328:
      if (lookahead == 'i') ADVANCE(413);
      END_STATE();
    case 329:
      ACCEPT_TOKEN(anon_sym_when);
      END_STATE();
    case 330:
      if (lookahead == 'e') ADVANCE(414);
      END_STATE();
    case 331:
      if (lookahead == 'e') ADVANCE(415);
      END_STATE();
    case 332:
      ACCEPT_TOKEN(anon_sym_with);
      END_STATE();
    case 333:
      if (lookahead == 'd') ADVANCE(416);
      END_STATE();
    case 334:
      ACCEPT_TOKEN(anon_sym_Cdecl);
      END_STATE();
    case 335:
      if (lookahead == 'a') ADVANCE(417);
      END_STATE();
    case 336:
      if (lookahead == 'l') ADVANCE(418);
      END_STATE();
    case 337:
      if (lookahead == 'a') ADVANCE(419);
      END_STATE();
    case 338:
      if (lookahead == 'e') ADVANCE(420);
      END_STATE();
    case 339:
      if (lookahead == 't') ADVANCE(421);
      if (lookahead == 'v') ADVANCE(422);
      END_STATE();
    case 340:
      if (lookahead == 'a') ADVANCE(423);
      END_STATE();
    case 341:
      ACCEPT_TOKEN(anon_sym_alias);
      END_STATE();
    case 342:
      if (lookahead == 'a') ADVANCE(424);
      END_STATE();
    case 343:
      if (lookahead == 'd') ADVANCE(425);
      END_STATE();
    case 344:
      if (lookahead == 'b') ADVANCE(426);
      END_STATE();
    case 345:
      ACCEPT_TOKEN(anon_sym_async);
      END_STATE();
    case 346:
      ACCEPT_TOKEN(anon_sym_await);
      END_STATE();
    case 347:
      ACCEPT_TOKEN(anon_sym_break);
      END_STATE();
    case 348:
      ACCEPT_TOKEN(anon_sym_catch);
      END_STATE();
    case 349:
      if (lookahead == 'e') ADVANCE(427);
      if (lookahead == 's') ADVANCE(428);
      END_STATE();
    case 350:
      ACCEPT_TOKEN(anon_sym_class);
      END_STATE();
    case 351:
      ACCEPT_TOKEN(anon_sym_const);
      END_STATE();
    case 352:
      if (lookahead == 'n') ADVANCE(429);
      END_STATE();
    case 353:
      if (lookahead == 'a') ADVANCE(430);
      END_STATE();
    case 354:
      if (lookahead == 'l') ADVANCE(431);
      END_STATE();
    case 355:
      if (lookahead == 'a') ADVANCE(432);
      END_STATE();
    case 356:
      if (lookahead == 'n') ADVANCE(433);
      END_STATE();
    case 357:
      if (lookahead == 'l') ADVANCE(434);
      END_STATE();
    case 358:
      if (lookahead == 'e') ADVANCE(243);
      END_STATE();
    case 359:
      if (lookahead == 'e') ADVANCE(435);
      END_STATE();
    case 360:
      if (lookahead == 's') ADVANCE(436);
      END_STATE();
    case 361:
      ACCEPT_TOKEN(anon_sym_event);
      END_STATE();
    case 362:
      if (lookahead == 'c') ADVANCE(437);
      END_STATE();
    case 363:
      if (lookahead == 'n') ADVANCE(438);
      END_STATE();
    case 364:
      ACCEPT_TOKEN(anon_sym_false);
      END_STATE();
    case 365:
      ACCEPT_TOKEN(anon_sym_field);
      END_STATE();
    case 366:
      if (lookahead == 'l') ADVANCE(439);
      END_STATE();
    case 367:
      ACCEPT_TOKEN(anon_sym_fixed);
      END_STATE();
    case 368:
      if (lookahead == 'c') ADVANCE(440);
      END_STATE();
    case 369:
      if (lookahead == 'l') ADVANCE(441);
      END_STATE();
    case 370:
      ACCEPT_TOKEN(anon_sym_group);
      END_STATE();
    case 371:
      if (lookahead == 'n') ADVANCE(442);
      END_STATE();
    case 372:
      if (lookahead == 'c') ADVANCE(443);
      END_STATE();
    case 373:
      if (lookahead == 'f') ADVANCE(444);
      if (lookahead == 'n') ADVANCE(445);
      END_STATE();
    case 374:
      if (lookahead == 'e') ADVANCE(446);
      END_STATE();
    case 375:
      if (lookahead == 'd') ADVANCE(447);
      END_STATE();
    case 376:
      if (lookahead == 'e') ADVANCE(448);
      END_STATE();
    case 377:
      if (lookahead == 'p') ADVANCE(449);
      END_STATE();
    case 378:
      if (lookahead == 'l') ADVANCE(450);
      END_STATE();
    case 379:
      if (lookahead == 't') ADVANCE(243);
      END_STATE();
    case 380:
      if (lookahead == 't') ADVANCE(451);
      END_STATE();
    case 381:
      if (lookahead == 'b') ADVANCE(452);
      END_STATE();
    case 382:
      if (lookahead == 'i') ADVANCE(453);
      END_STATE();
    case 383:
      ACCEPT_TOKEN(anon_sym_param);
      if (lookahead == 's') ADVANCE(454);
      END_STATE();
    case 384:
      if (lookahead == 'a') ADVANCE(455);
      END_STATE();
    case 385:
      if (lookahead == 't') ADVANCE(456);
      END_STATE();
    case 386:
      if (lookahead == 'r') ADVANCE(457);
      END_STATE();
    case 387:
      if (lookahead == 'c') ADVANCE(458);
      END_STATE();
    case 388:
      if (lookahead == 'c') ADVANCE(459);
      END_STATE();
    case 389:
      if (lookahead == 'n') ADVANCE(460);
      END_STATE();
    case 390:
      if (lookahead == 'd') ADVANCE(461);
      END_STATE();
    case 391:
      if (lookahead == 'e') ADVANCE(462);
      END_STATE();
    case 392:
      if (lookahead == 'r') ADVANCE(463);
      END_STATE();
    case 393:
      if (lookahead == 'r') ADVANCE(464);
      END_STATE();
    case 394:
      if (lookahead == 'n') ADVANCE(465);
      END_STATE();
    case 395:
      if (lookahead == 'd') ADVANCE(466);
      END_STATE();
    case 396:
      if (lookahead == 'd') ADVANCE(467);
      END_STATE();
    case 397:
      if (lookahead == 't') ADVANCE(468);
      END_STATE();
    case 398:
      if (lookahead == 'f') ADVANCE(469);
      END_STATE();
    case 399:
      if (lookahead == 'a') ADVANCE(470);
      END_STATE();
    case 400:
      if (lookahead == 'c') ADVANCE(471);
      END_STATE();
    case 401:
      if (lookahead == 'g') ADVANCE(243);
      END_STATE();
    case 402:
      if (lookahead == 't') ADVANCE(472);
      END_STATE();
    case 403:
      if (lookahead == 'h') ADVANCE(473);
      END_STATE();
    case 404:
      ACCEPT_TOKEN(anon_sym_throw);
      END_STATE();
    case 405:
      if (lookahead == 'f') ADVANCE(474);
      END_STATE();
    case 406:
      if (lookahead == 'c') ADVANCE(475);
      END_STATE();
    case 407:
      if (lookahead == 'a') ADVANCE(476);
      END_STATE();
    case 408:
      if (lookahead == 'e') ADVANCE(477);
      END_STATE();
    case 409:
      if (lookahead == 't') ADVANCE(243);
      END_STATE();
    case 410:
      ACCEPT_TOKEN(anon_sym_using);
      END_STATE();
    case 411:
      if (lookahead == 'a') ADVANCE(478);
      END_STATE();
    case 412:
      if (lookahead == 'i') ADVANCE(479);
      END_STATE();
    case 413:
      if (lookahead == 'n') ADVANCE(480);
      END_STATE();
    case 414:
      ACCEPT_TOKEN(anon_sym_where);
      END_STATE();
    case 415:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 416:
      ACCEPT_TOKEN(anon_sym_yield);
      END_STATE();
    case 417:
      if (lookahead == 'l') ADVANCE(481);
      END_STATE();
    case 418:
      if (lookahead == 'l') ADVANCE(482);
      END_STATE();
    case 419:
      if (lookahead == 'l') ADVANCE(483);
      END_STATE();
    case 420:
      if (lookahead == 'r') ADVANCE(484);
      END_STATE();
    case 421:
      if (lookahead == 'y') ADVANCE(485);
      END_STATE();
    case 422:
      if (lookahead == 'a') ADVANCE(486);
      END_STATE();
    case 423:
      if (lookahead == 'c') ADVANCE(487);
      END_STATE();
    case 424:
      if (lookahead == 't') ADVANCE(488);
      END_STATE();
    case 425:
      if (lookahead == 'i') ADVANCE(489);
      END_STATE();
    case 426:
      if (lookahead == 'l') ADVANCE(490);
      END_STATE();
    case 427:
      if (lookahead == 'd') ADVANCE(491);
      END_STATE();
    case 428:
      if (lookahead == 'u') ADVANCE(492);
      END_STATE();
    case 429:
      if (lookahead == 'u') ADVANCE(493);
      END_STATE();
    case 430:
      if (lookahead == 'l') ADVANCE(243);
      END_STATE();
    case 431:
      if (lookahead == 't') ADVANCE(494);
      END_STATE();
    case 432:
      if (lookahead == 't') ADVANCE(495);
      END_STATE();
    case 433:
      if (lookahead == 'd') ADVANCE(496);
      END_STATE();
    case 434:
      if (lookahead == 'e') ADVANCE(497);
      END_STATE();
    case 435:
      ACCEPT_TOKEN(anon_sym_enable);
      END_STATE();
    case 436:
      ACCEPT_TOKEN(anon_sym_equals);
      END_STATE();
    case 437:
      if (lookahead == 'i') ADVANCE(498);
      END_STATE();
    case 438:
      ACCEPT_TOKEN(anon_sym_extern);
      END_STATE();
    case 439:
      if (lookahead == 'y') ADVANCE(499);
      END_STATE();
    case 440:
      if (lookahead == 'h') ADVANCE(500);
      END_STATE();
    case 441:
      ACCEPT_TOKEN(anon_sym_global);
      END_STATE();
    case 442:
      ACCEPT_TOKEN(anon_sym_hidden);
      END_STATE();
    case 443:
      if (lookahead == 'i') ADVANCE(501);
      END_STATE();
    case 444:
      if (lookahead == 'a') ADVANCE(502);
      END_STATE();
    case 445:
      if (lookahead == 'a') ADVANCE(503);
      END_STATE();
    case 446:
      if (lookahead == 'd') ADVANCE(504);
      END_STATE();
    case 447:
      ACCEPT_TOKEN(anon_sym_method);
      END_STATE();
    case 448:
      ACCEPT_TOKEN(anon_sym_module);
      END_STATE();
    case 449:
      if (lookahead == 'a') ADVANCE(505);
      END_STATE();
    case 450:
      if (lookahead == 'l') ADVANCE(506);
      END_STATE();
    case 451:
      if (lookahead == 'o') ADVANCE(507);
      END_STATE();
    case 452:
      if (lookahead == 'y') ADVANCE(508);
      END_STATE();
    case 453:
      if (lookahead == 'd') ADVANCE(509);
      END_STATE();
    case 454:
      ACCEPT_TOKEN(anon_sym_params);
      END_STATE();
    case 455:
      if (lookahead == 'l') ADVANCE(510);
      END_STATE();
    case 456:
      if (lookahead == 'e') ADVANCE(511);
      END_STATE();
    case 457:
      if (lookahead == 't') ADVANCE(512);
      END_STATE();
    case 458:
      if (lookahead == 't') ADVANCE(513);
      END_STATE();
    case 459:
      ACCEPT_TOKEN(anon_sym_public);
      END_STATE();
    case 460:
      if (lookahead == 'l') ADVANCE(514);
      END_STATE();
    case 461:
      ACCEPT_TOKEN(anon_sym_record);
      END_STATE();
    case 462:
      ACCEPT_TOKEN(anon_sym_remove);
      END_STATE();
    case 463:
      if (lookahead == 'e') ADVANCE(515);
      END_STATE();
    case 464:
      if (lookahead == 'e') ADVANCE(516);
      END_STATE();
    case 465:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 466:
      ACCEPT_TOKEN(anon_sym_scoped);
      END_STATE();
    case 467:
      ACCEPT_TOKEN(anon_sym_sealed);
      END_STATE();
    case 468:
      ACCEPT_TOKEN(anon_sym_select);
      END_STATE();
    case 469:
      ACCEPT_TOKEN(anon_sym_sizeof);
      END_STATE();
    case 470:
      if (lookahead == 'l') ADVANCE(517);
      END_STATE();
    case 471:
      ACCEPT_TOKEN(anon_sym_static);
      END_STATE();
    case 472:
      ACCEPT_TOKEN(anon_sym_struct);
      END_STATE();
    case 473:
      ACCEPT_TOKEN(anon_sym_switch);
      END_STATE();
    case 474:
      ACCEPT_TOKEN(anon_sym_typeof);
      END_STATE();
    case 475:
      if (lookahead == 'k') ADVANCE(518);
      END_STATE();
    case 476:
      if (lookahead == 'g') ADVANCE(519);
      END_STATE();
    case 477:
      ACCEPT_TOKEN(anon_sym_unsafe);
      END_STATE();
    case 478:
      if (lookahead == 'l') ADVANCE(520);
      END_STATE();
    case 479:
      if (lookahead == 'l') ADVANCE(521);
      END_STATE();
    case 480:
      if (lookahead == 'g') ADVANCE(522);
      END_STATE();
    case 481:
      if (lookahead == 'l') ADVANCE(523);
      END_STATE();
    case 482:
      ACCEPT_TOKEN(anon_sym_Stdcall);
      END_STATE();
    case 483:
      if (lookahead == 'l') ADVANCE(524);
      END_STATE();
    case 484:
      if (lookahead == 'e') ADVANCE(525);
      END_STATE();
    case 485:
      if (lookahead == 'p') ADVANCE(526);
      END_STATE();
    case 486:
      if (lookahead == 'l') ADVANCE(527);
      END_STATE();
    case 487:
      if (lookahead == 't') ADVANCE(528);
      END_STATE();
    case 488:
      if (lookahead == 'i') ADVANCE(529);
      END_STATE();
    case 489:
      if (lookahead == 'n') ADVANCE(530);
      END_STATE();
    case 490:
      if (lookahead == 'y') ADVANCE(531);
      END_STATE();
    case 491:
      ACCEPT_TOKEN(anon_sym_checked);
      END_STATE();
    case 492:
      if (lookahead == 'm') ADVANCE(532);
      END_STATE();
    case 493:
      if (lookahead == 'e') ADVANCE(533);
      END_STATE();
    case 494:
      ACCEPT_TOKEN(anon_sym_default);
      END_STATE();
    case 495:
      if (lookahead == 'e') ADVANCE(534);
      END_STATE();
    case 496:
      if (lookahead == 'i') ADVANCE(535);
      END_STATE();
    case 497:
      ACCEPT_TOKEN(anon_sym_disable);
      END_STATE();
    case 498:
      if (lookahead == 't') ADVANCE(536);
      END_STATE();
    case 499:
      ACCEPT_TOKEN(anon_sym_finally);
      END_STATE();
    case 500:
      ACCEPT_TOKEN(anon_sym_foreach);
      END_STATE();
    case 501:
      if (lookahead == 't') ADVANCE(537);
      END_STATE();
    case 502:
      if (lookahead == 'c') ADVANCE(538);
      END_STATE();
    case 503:
      if (lookahead == 'l') ADVANCE(539);
      END_STATE();
    case 504:
      ACCEPT_TOKEN(anon_sym_managed);
      END_STATE();
    case 505:
      if (lookahead == 'c') ADVANCE(540);
      END_STATE();
    case 506:
      ACCEPT_TOKEN(anon_sym_notnull);
      END_STATE();
    case 507:
      if (lookahead == 'r') ADVANCE(541);
      END_STATE();
    case 508:
      ACCEPT_TOKEN(anon_sym_orderby);
      END_STATE();
    case 509:
      if (lookahead == 'e') ADVANCE(542);
      END_STATE();
    case 510:
      ACCEPT_TOKEN(anon_sym_partial);
      END_STATE();
    case 511:
      ACCEPT_TOKEN(anon_sym_private);
      END_STATE();
    case 512:
      if (lookahead == 'y') ADVANCE(543);
      END_STATE();
    case 513:
      if (lookahead == 'e') ADVANCE(544);
      END_STATE();
    case 514:
      if (lookahead == 'y') ADVANCE(545);
      END_STATE();
    case 515:
      if (lookahead == 'd') ADVANCE(546);
      END_STATE();
    case 516:
      ACCEPT_TOKEN(anon_sym_restore);
      END_STATE();
    case 517:
      if (lookahead == 'l') ADVANCE(547);
      END_STATE();
    case 518:
      if (lookahead == 'e') ADVANCE(548);
      END_STATE();
    case 519:
      if (lookahead == 'e') ADVANCE(549);
      END_STATE();
    case 520:
      ACCEPT_TOKEN(anon_sym_virtual);
      END_STATE();
    case 521:
      if (lookahead == 'e') ADVANCE(550);
      END_STATE();
    case 522:
      ACCEPT_TOKEN(anon_sym_warning);
      if (lookahead == 's') ADVANCE(551);
      END_STATE();
    case 523:
      ACCEPT_TOKEN(anon_sym_Fastcall);
      END_STATE();
    case 524:
      ACCEPT_TOKEN(anon_sym_Thiscall);
      END_STATE();
    case 525:
      if (lookahead == 'f') ADVANCE(552);
      END_STATE();
    case 526:
      if (lookahead == 'e') ADVANCE(553);
      END_STATE();
    case 527:
      if (lookahead == 'u') ADVANCE(554);
      END_STATE();
    case 528:
      ACCEPT_TOKEN(anon_sym_abstract);
      END_STATE();
    case 529:
      if (lookahead == 'o') ADVANCE(555);
      END_STATE();
    case 530:
      if (lookahead == 'g') ADVANCE(556);
      END_STATE();
    case 531:
      ACCEPT_TOKEN(anon_sym_assembly);
      END_STATE();
    case 532:
      ACCEPT_TOKEN(anon_sym_checksum);
      END_STATE();
    case 533:
      ACCEPT_TOKEN(anon_sym_continue);
      END_STATE();
    case 534:
      ACCEPT_TOKEN(anon_sym_delegate);
      END_STATE();
    case 535:
      if (lookahead == 'n') ADVANCE(557);
      END_STATE();
    case 536:
      ACCEPT_TOKEN(anon_sym_explicit);
      END_STATE();
    case 537:
      ACCEPT_TOKEN(anon_sym_implicit);
      END_STATE();
    case 538:
      if (lookahead == 'e') ADVANCE(558);
      END_STATE();
    case 539:
      ACCEPT_TOKEN(anon_sym_internal);
      END_STATE();
    case 540:
      if (lookahead == 'e') ADVANCE(559);
      END_STATE();
    case 541:
      ACCEPT_TOKEN(anon_sym_operator);
      END_STATE();
    case 542:
      ACCEPT_TOKEN(anon_sym_override);
      END_STATE();
    case 543:
      ACCEPT_TOKEN(anon_sym_property);
      END_STATE();
    case 544:
      if (lookahead == 'd') ADVANCE(560);
      END_STATE();
    case 545:
      ACCEPT_TOKEN(anon_sym_readonly);
      END_STATE();
    case 546:
      ACCEPT_TOKEN(anon_sym_required);
      END_STATE();
    case 547:
      if (lookahead == 'o') ADVANCE(561);
      END_STATE();
    case 548:
      if (lookahead == 'd') ADVANCE(562);
      END_STATE();
    case 549:
      if (lookahead == 'd') ADVANCE(563);
      END_STATE();
    case 550:
      ACCEPT_TOKEN(anon_sym_volatile);
      END_STATE();
    case 551:
      ACCEPT_TOKEN(anon_sym_warnings);
      END_STATE();
    case 552:
      ACCEPT_TOKEN(anon_sym___makeref);
      END_STATE();
    case 553:
      ACCEPT_TOKEN(anon_sym___reftype);
      END_STATE();
    case 554:
      if (lookahead == 'e') ADVANCE(564);
      END_STATE();
    case 555:
      if (lookahead == 'n') ADVANCE(565);
      END_STATE();
    case 556:
      ACCEPT_TOKEN(anon_sym_ascending);
      END_STATE();
    case 557:
      if (lookahead == 'g') ADVANCE(566);
      END_STATE();
    case 558:
      ACCEPT_TOKEN(anon_sym_interface);
      END_STATE();
    case 559:
      ACCEPT_TOKEN(anon_sym_namespace);
      END_STATE();
    case 560:
      ACCEPT_TOKEN(anon_sym_protected);
      END_STATE();
    case 561:
      if (lookahead == 'c') ADVANCE(567);
      END_STATE();
    case 562:
      ACCEPT_TOKEN(anon_sym_unchecked);
      END_STATE();
    case 563:
      ACCEPT_TOKEN(anon_sym_unmanaged);
      END_STATE();
    case 564:
      ACCEPT_TOKEN(anon_sym___refvalue);
      END_STATE();
    case 565:
      if (lookahead == 's') ADVANCE(568);
      END_STATE();
    case 566:
      ACCEPT_TOKEN(anon_sym_descending);
      END_STATE();
    case 567:
      ACCEPT_TOKEN(anon_sym_stackalloc);
      END_STATE();
    case 568:
      ACCEPT_TOKEN(anon_sym_annotations);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 113, .external_lex_state = 2},
  [2] = {.lex_state = 113, .external_lex_state = 2},
  [3] = {.lex_state = 113, .external_lex_state = 2},
  [4] = {.lex_state = 113, .external_lex_state = 2},
  [5] = {.lex_state = 113, .external_lex_state = 2},
  [6] = {.lex_state = 113, .external_lex_state = 2},
  [7] = {.lex_state = 113, .external_lex_state = 2},
  [8] = {.lex_state = 113, .external_lex_state = 2},
  [9] = {.lex_state = 113, .external_lex_state = 2},
  [10] = {.lex_state = 113, .external_lex_state = 2},
  [11] = {.lex_state = 113, .external_lex_state = 2},
  [12] = {.lex_state = 113, .external_lex_state = 2},
  [13] = {.lex_state = 113, .external_lex_state = 2},
  [14] = {.lex_state = 113, .external_lex_state = 2},
  [15] = {.lex_state = 113, .external_lex_state = 2},
  [16] = {.lex_state = 113, .external_lex_state = 2},
  [17] = {.lex_state = 113, .external_lex_state = 2},
  [18] = {.lex_state = 113, .external_lex_state = 2},
  [19] = {.lex_state = 113, .external_lex_state = 2},
  [20] = {.lex_state = 113, .external_lex_state = 2},
  [21] = {.lex_state = 113, .external_lex_state = 2},
  [22] = {.lex_state = 113, .external_lex_state = 2},
  [23] = {.lex_state = 113, .external_lex_state = 2},
  [24] = {.lex_state = 113, .external_lex_state = 2},
  [25] = {.lex_state = 113, .external_lex_state = 2},
  [26] = {.lex_state = 113, .external_lex_state = 2},
  [27] = {.lex_state = 113, .external_lex_state = 2},
  [28] = {.lex_state = 113, .external_lex_state = 2},
  [29] = {.lex_state = 113, .external_lex_state = 2},
  [30] = {.lex_state = 113, .external_lex_state = 2},
  [31] = {.lex_state = 113, .external_lex_state = 2},
  [32] = {.lex_state = 113, .external_lex_state = 2},
  [33] = {.lex_state = 113, .external_lex_state = 2},
  [34] = {.lex_state = 113, .external_lex_state = 2},
  [35] = {.lex_state = 113, .external_lex_state = 2},
  [36] = {.lex_state = 113, .external_lex_state = 2},
  [37] = {.lex_state = 113, .external_lex_state = 2},
  [38] = {.lex_state = 113, .external_lex_state = 2},
  [39] = {.lex_state = 113, .external_lex_state = 2},
  [40] = {.lex_state = 113, .external_lex_state = 2},
  [41] = {.lex_state = 113, .external_lex_state = 2},
  [42] = {.lex_state = 113, .external_lex_state = 2},
  [43] = {.lex_state = 113, .external_lex_state = 2},
  [44] = {.lex_state = 113, .external_lex_state = 2},
  [45] = {.lex_state = 113, .external_lex_state = 2},
  [46] = {.lex_state = 113, .external_lex_state = 2},
  [47] = {.lex_state = 113, .external_lex_state = 2},
  [48] = {.lex_state = 113, .external_lex_state = 2},
  [49] = {.lex_state = 113, .external_lex_state = 2},
  [50] = {.lex_state = 113, .external_lex_state = 2},
  [51] = {.lex_state = 113, .external_lex_state = 2},
  [52] = {.lex_state = 113, .external_lex_state = 2},
  [53] = {.lex_state = 113, .external_lex_state = 2},
  [54] = {.lex_state = 113, .external_lex_state = 2},
  [55] = {.lex_state = 113, .external_lex_state = 2},
  [56] = {.lex_state = 113, .external_lex_state = 2},
  [57] = {.lex_state = 113, .external_lex_state = 2},
  [58] = {.lex_state = 113, .external_lex_state = 2},
  [59] = {.lex_state = 113, .external_lex_state = 2},
  [60] = {.lex_state = 113, .external_lex_state = 2},
  [61] = {.lex_state = 113, .external_lex_state = 2},
  [62] = {.lex_state = 113, .external_lex_state = 2},
  [63] = {.lex_state = 113, .external_lex_state = 2},
  [64] = {.lex_state = 113, .external_lex_state = 2},
  [65] = {.lex_state = 113, .external_lex_state = 2},
  [66] = {.lex_state = 113, .external_lex_state = 2},
  [67] = {.lex_state = 113, .external_lex_state = 2},
  [68] = {.lex_state = 113, .external_lex_state = 2},
  [69] = {.lex_state = 113, .external_lex_state = 2},
  [70] = {.lex_state = 113, .external_lex_state = 2},
  [71] = {.lex_state = 113, .external_lex_state = 2},
  [72] = {.lex_state = 113, .external_lex_state = 2},
  [73] = {.lex_state = 113, .external_lex_state = 2},
  [74] = {.lex_state = 113, .external_lex_state = 2},
  [75] = {.lex_state = 113, .external_lex_state = 2},
  [76] = {.lex_state = 113, .external_lex_state = 2},
  [77] = {.lex_state = 113, .external_lex_state = 2},
  [78] = {.lex_state = 113, .external_lex_state = 2},
  [79] = {.lex_state = 113, .external_lex_state = 2},
  [80] = {.lex_state = 113, .external_lex_state = 2},
  [81] = {.lex_state = 113, .external_lex_state = 2},
  [82] = {.lex_state = 113, .external_lex_state = 2},
  [83] = {.lex_state = 113, .external_lex_state = 2},
  [84] = {.lex_state = 113, .external_lex_state = 2},
  [85] = {.lex_state = 113, .external_lex_state = 2},
  [86] = {.lex_state = 113, .external_lex_state = 2},
  [87] = {.lex_state = 113, .external_lex_state = 2},
  [88] = {.lex_state = 113, .external_lex_state = 2},
  [89] = {.lex_state = 113, .external_lex_state = 2},
  [90] = {.lex_state = 113, .external_lex_state = 2},
  [91] = {.lex_state = 113, .external_lex_state = 2},
  [92] = {.lex_state = 113, .external_lex_state = 2},
  [93] = {.lex_state = 113, .external_lex_state = 2},
  [94] = {.lex_state = 113, .external_lex_state = 2},
  [95] = {.lex_state = 113, .external_lex_state = 2},
  [96] = {.lex_state = 113, .external_lex_state = 2},
  [97] = {.lex_state = 113, .external_lex_state = 2},
  [98] = {.lex_state = 113, .external_lex_state = 2},
  [99] = {.lex_state = 113, .external_lex_state = 2},
  [100] = {.lex_state = 113, .external_lex_state = 2},
  [101] = {.lex_state = 113, .external_lex_state = 2},
  [102] = {.lex_state = 113, .external_lex_state = 2},
  [103] = {.lex_state = 113, .external_lex_state = 2},
  [104] = {.lex_state = 113, .external_lex_state = 2},
  [105] = {.lex_state = 113, .external_lex_state = 2},
  [106] = {.lex_state = 113, .external_lex_state = 2},
  [107] = {.lex_state = 113, .external_lex_state = 2},
  [108] = {.lex_state = 113, .external_lex_state = 2},
  [109] = {.lex_state = 113, .external_lex_state = 2},
  [110] = {.lex_state = 113, .external_lex_state = 2},
  [111] = {.lex_state = 113, .external_lex_state = 2},
  [112] = {.lex_state = 113, .external_lex_state = 2},
  [113] = {.lex_state = 113, .external_lex_state = 2},
  [114] = {.lex_state = 113, .external_lex_state = 2},
  [115] = {.lex_state = 113, .external_lex_state = 2},
  [116] = {.lex_state = 113, .external_lex_state = 2},
  [117] = {.lex_state = 113, .external_lex_state = 2},
  [118] = {.lex_state = 113, .external_lex_state = 2},
  [119] = {.lex_state = 113, .external_lex_state = 2},
  [120] = {.lex_state = 113, .external_lex_state = 2},
  [121] = {.lex_state = 113, .external_lex_state = 2},
  [122] = {.lex_state = 113, .external_lex_state = 2},
  [123] = {.lex_state = 113, .external_lex_state = 2},
  [124] = {.lex_state = 113, .external_lex_state = 2},
  [125] = {.lex_state = 113, .external_lex_state = 2},
  [126] = {.lex_state = 113, .external_lex_state = 2},
  [127] = {.lex_state = 113, .external_lex_state = 2},
  [128] = {.lex_state = 113, .external_lex_state = 2},
  [129] = {.lex_state = 113, .external_lex_state = 2},
  [130] = {.lex_state = 113, .external_lex_state = 2},
  [131] = {.lex_state = 113, .external_lex_state = 2},
  [132] = {.lex_state = 113, .external_lex_state = 2},
  [133] = {.lex_state = 113, .external_lex_state = 2},
  [134] = {.lex_state = 113, .external_lex_state = 2},
  [135] = {.lex_state = 113, .external_lex_state = 2},
  [136] = {.lex_state = 113, .external_lex_state = 2},
  [137] = {.lex_state = 113, .external_lex_state = 2},
  [138] = {.lex_state = 113, .external_lex_state = 2},
  [139] = {.lex_state = 113, .external_lex_state = 2},
  [140] = {.lex_state = 113, .external_lex_state = 2},
  [141] = {.lex_state = 113, .external_lex_state = 2},
  [142] = {.lex_state = 113, .external_lex_state = 2},
  [143] = {.lex_state = 113, .external_lex_state = 2},
  [144] = {.lex_state = 113, .external_lex_state = 2},
  [145] = {.lex_state = 113, .external_lex_state = 2},
  [146] = {.lex_state = 113, .external_lex_state = 2},
  [147] = {.lex_state = 113, .external_lex_state = 2},
  [148] = {.lex_state = 113, .external_lex_state = 2},
  [149] = {.lex_state = 113, .external_lex_state = 2},
  [150] = {.lex_state = 113, .external_lex_state = 2},
  [151] = {.lex_state = 113, .external_lex_state = 2},
  [152] = {.lex_state = 113, .external_lex_state = 2},
  [153] = {.lex_state = 113, .external_lex_state = 2},
  [154] = {.lex_state = 113, .external_lex_state = 2},
  [155] = {.lex_state = 113, .external_lex_state = 2},
  [156] = {.lex_state = 113, .external_lex_state = 2},
  [157] = {.lex_state = 113, .external_lex_state = 2},
  [158] = {.lex_state = 113, .external_lex_state = 2},
  [159] = {.lex_state = 113, .external_lex_state = 2},
  [160] = {.lex_state = 113, .external_lex_state = 2},
  [161] = {.lex_state = 113, .external_lex_state = 2},
  [162] = {.lex_state = 113, .external_lex_state = 2},
  [163] = {.lex_state = 113, .external_lex_state = 2},
  [164] = {.lex_state = 113, .external_lex_state = 2},
  [165] = {.lex_state = 113, .external_lex_state = 2},
  [166] = {.lex_state = 113, .external_lex_state = 2},
  [167] = {.lex_state = 113, .external_lex_state = 2},
  [168] = {.lex_state = 113, .external_lex_state = 2},
  [169] = {.lex_state = 113, .external_lex_state = 2},
  [170] = {.lex_state = 113, .external_lex_state = 2},
  [171] = {.lex_state = 113, .external_lex_state = 2},
  [172] = {.lex_state = 113, .external_lex_state = 2},
  [173] = {.lex_state = 113, .external_lex_state = 2},
  [174] = {.lex_state = 113, .external_lex_state = 2},
  [175] = {.lex_state = 113, .external_lex_state = 2},
  [176] = {.lex_state = 113, .external_lex_state = 2},
  [177] = {.lex_state = 113, .external_lex_state = 2},
  [178] = {.lex_state = 113, .external_lex_state = 2},
  [179] = {.lex_state = 113, .external_lex_state = 2},
  [180] = {.lex_state = 113, .external_lex_state = 2},
  [181] = {.lex_state = 113, .external_lex_state = 2},
  [182] = {.lex_state = 113, .external_lex_state = 2},
  [183] = {.lex_state = 113, .external_lex_state = 2},
  [184] = {.lex_state = 113, .external_lex_state = 2},
  [185] = {.lex_state = 113, .external_lex_state = 2},
  [186] = {.lex_state = 113, .external_lex_state = 2},
  [187] = {.lex_state = 113, .external_lex_state = 2},
  [188] = {.lex_state = 113, .external_lex_state = 2},
  [189] = {.lex_state = 113, .external_lex_state = 2},
  [190] = {.lex_state = 113, .external_lex_state = 2},
  [191] = {.lex_state = 112, .external_lex_state = 2},
  [192] = {.lex_state = 112, .external_lex_state = 2},
  [193] = {.lex_state = 113, .external_lex_state = 2},
  [194] = {.lex_state = 113, .external_lex_state = 2},
  [195] = {.lex_state = 113, .external_lex_state = 2},
  [196] = {.lex_state = 113, .external_lex_state = 2},
  [197] = {.lex_state = 113, .external_lex_state = 2},
  [198] = {.lex_state = 113, .external_lex_state = 2},
  [199] = {.lex_state = 113, .external_lex_state = 2},
  [200] = {.lex_state = 113, .external_lex_state = 2},
  [201] = {.lex_state = 113, .external_lex_state = 2},
  [202] = {.lex_state = 113, .external_lex_state = 2},
  [203] = {.lex_state = 113, .external_lex_state = 2},
  [204] = {.lex_state = 113, .external_lex_state = 2},
  [205] = {.lex_state = 113, .external_lex_state = 2},
  [206] = {.lex_state = 113, .external_lex_state = 2},
  [207] = {.lex_state = 113, .external_lex_state = 2},
  [208] = {.lex_state = 113, .external_lex_state = 2},
  [209] = {.lex_state = 113, .external_lex_state = 2},
  [210] = {.lex_state = 113, .external_lex_state = 2},
  [211] = {.lex_state = 113, .external_lex_state = 2},
  [212] = {.lex_state = 113, .external_lex_state = 2},
  [213] = {.lex_state = 113, .external_lex_state = 2},
  [214] = {.lex_state = 113, .external_lex_state = 2},
  [215] = {.lex_state = 113, .external_lex_state = 2},
  [216] = {.lex_state = 113, .external_lex_state = 2},
  [217] = {.lex_state = 113, .external_lex_state = 2},
  [218] = {.lex_state = 113, .external_lex_state = 2},
  [219] = {.lex_state = 113, .external_lex_state = 2},
  [220] = {.lex_state = 113, .external_lex_state = 2},
  [221] = {.lex_state = 113, .external_lex_state = 2},
  [222] = {.lex_state = 112, .external_lex_state = 2},
  [223] = {.lex_state = 113, .external_lex_state = 2},
  [224] = {.lex_state = 113, .external_lex_state = 2},
  [225] = {.lex_state = 112, .external_lex_state = 2},
  [226] = {.lex_state = 112, .external_lex_state = 2},
  [227] = {.lex_state = 112, .external_lex_state = 2},
  [228] = {.lex_state = 112, .external_lex_state = 2},
  [229] = {.lex_state = 112, .external_lex_state = 2},
  [230] = {.lex_state = 112, .external_lex_state = 2},
  [231] = {.lex_state = 112, .external_lex_state = 2},
  [232] = {.lex_state = 112, .external_lex_state = 2},
  [233] = {.lex_state = 112, .external_lex_state = 2},
  [234] = {.lex_state = 112, .external_lex_state = 3},
  [235] = {.lex_state = 112, .external_lex_state = 3},
  [236] = {.lex_state = 112, .external_lex_state = 3},
  [237] = {.lex_state = 112, .external_lex_state = 3},
  [238] = {.lex_state = 112, .external_lex_state = 2},
  [239] = {.lex_state = 112, .external_lex_state = 2},
  [240] = {.lex_state = 112, .external_lex_state = 2},
  [241] = {.lex_state = 112, .external_lex_state = 2},
  [242] = {.lex_state = 112, .external_lex_state = 2},
  [243] = {.lex_state = 112, .external_lex_state = 2},
  [244] = {.lex_state = 112, .external_lex_state = 2},
  [245] = {.lex_state = 112, .external_lex_state = 2},
  [246] = {.lex_state = 112, .external_lex_state = 2},
  [247] = {.lex_state = 112, .external_lex_state = 2},
  [248] = {.lex_state = 112, .external_lex_state = 2},
  [249] = {.lex_state = 112, .external_lex_state = 2},
  [250] = {.lex_state = 112, .external_lex_state = 2},
  [251] = {.lex_state = 112, .external_lex_state = 2},
  [252] = {.lex_state = 112, .external_lex_state = 2},
  [253] = {.lex_state = 112, .external_lex_state = 2},
  [254] = {.lex_state = 112, .external_lex_state = 2},
  [255] = {.lex_state = 112, .external_lex_state = 3},
  [256] = {.lex_state = 112, .external_lex_state = 3},
  [257] = {.lex_state = 112, .external_lex_state = 2},
  [258] = {.lex_state = 112, .external_lex_state = 3},
  [259] = {.lex_state = 112, .external_lex_state = 2},
  [260] = {.lex_state = 112, .external_lex_state = 2},
  [261] = {.lex_state = 112, .external_lex_state = 2},
  [262] = {.lex_state = 112, .external_lex_state = 2},
  [263] = {.lex_state = 112, .external_lex_state = 2},
  [264] = {.lex_state = 112, .external_lex_state = 3},
  [265] = {.lex_state = 112, .external_lex_state = 2},
  [266] = {.lex_state = 112, .external_lex_state = 2},
  [267] = {.lex_state = 112, .external_lex_state = 2},
  [268] = {.lex_state = 112, .external_lex_state = 2},
  [269] = {.lex_state = 112, .external_lex_state = 2},
  [270] = {.lex_state = 112, .external_lex_state = 2},
  [271] = {.lex_state = 112, .external_lex_state = 2},
  [272] = {.lex_state = 112, .external_lex_state = 2},
  [273] = {.lex_state = 112, .external_lex_state = 2},
  [274] = {.lex_state = 112, .external_lex_state = 2},
  [275] = {.lex_state = 112, .external_lex_state = 2},
  [276] = {.lex_state = 112, .external_lex_state = 2},
  [277] = {.lex_state = 112, .external_lex_state = 2},
  [278] = {.lex_state = 112, .external_lex_state = 2},
  [279] = {.lex_state = 112, .external_lex_state = 2},
  [280] = {.lex_state = 112, .external_lex_state = 2},
  [281] = {.lex_state = 112, .external_lex_state = 2},
  [282] = {.lex_state = 112, .external_lex_state = 2},
  [283] = {.lex_state = 112, .external_lex_state = 2},
  [284] = {.lex_state = 112, .external_lex_state = 2},
  [285] = {.lex_state = 112, .external_lex_state = 2},
  [286] = {.lex_state = 112, .external_lex_state = 2},
  [287] = {.lex_state = 112, .external_lex_state = 2},
  [288] = {.lex_state = 112, .external_lex_state = 2},
  [289] = {.lex_state = 112, .external_lex_state = 2},
  [290] = {.lex_state = 112, .external_lex_state = 2},
  [291] = {.lex_state = 112, .external_lex_state = 2},
  [292] = {.lex_state = 112, .external_lex_state = 2},
  [293] = {.lex_state = 112, .external_lex_state = 2},
  [294] = {.lex_state = 112, .external_lex_state = 2},
  [295] = {.lex_state = 112, .external_lex_state = 2},
  [296] = {.lex_state = 112, .external_lex_state = 2},
  [297] = {.lex_state = 113, .external_lex_state = 2},
  [298] = {.lex_state = 112, .external_lex_state = 2},
  [299] = {.lex_state = 113, .external_lex_state = 2},
  [300] = {.lex_state = 112, .external_lex_state = 2},
  [301] = {.lex_state = 113, .external_lex_state = 2},
  [302] = {.lex_state = 113, .external_lex_state = 2},
  [303] = {.lex_state = 112, .external_lex_state = 2},
  [304] = {.lex_state = 113, .external_lex_state = 2},
  [305] = {.lex_state = 113, .external_lex_state = 2},
  [306] = {.lex_state = 113, .external_lex_state = 2},
  [307] = {.lex_state = 112, .external_lex_state = 2},
  [308] = {.lex_state = 112, .external_lex_state = 2},
  [309] = {.lex_state = 112, .external_lex_state = 2},
  [310] = {.lex_state = 112, .external_lex_state = 2},
  [311] = {.lex_state = 113, .external_lex_state = 2},
  [312] = {.lex_state = 113, .external_lex_state = 2},
  [313] = {.lex_state = 113, .external_lex_state = 2},
  [314] = {.lex_state = 112, .external_lex_state = 2},
  [315] = {.lex_state = 112, .external_lex_state = 2},
  [316] = {.lex_state = 112, .external_lex_state = 2},
  [317] = {.lex_state = 112, .external_lex_state = 2},
  [318] = {.lex_state = 113, .external_lex_state = 2},
  [319] = {.lex_state = 112, .external_lex_state = 2},
  [320] = {.lex_state = 113, .external_lex_state = 2},
  [321] = {.lex_state = 112, .external_lex_state = 2},
  [322] = {.lex_state = 112, .external_lex_state = 2},
  [323] = {.lex_state = 112, .external_lex_state = 2},
  [324] = {.lex_state = 112, .external_lex_state = 2},
  [325] = {.lex_state = 112, .external_lex_state = 2},
  [326] = {.lex_state = 113, .external_lex_state = 2},
  [327] = {.lex_state = 113, .external_lex_state = 2},
  [328] = {.lex_state = 113, .external_lex_state = 2},
  [329] = {.lex_state = 113, .external_lex_state = 2},
  [330] = {.lex_state = 113, .external_lex_state = 2},
  [331] = {.lex_state = 113, .external_lex_state = 2},
  [332] = {.lex_state = 113, .external_lex_state = 2},
  [333] = {.lex_state = 112, .external_lex_state = 2},
  [334] = {.lex_state = 112, .external_lex_state = 2},
  [335] = {.lex_state = 113, .external_lex_state = 2},
  [336] = {.lex_state = 112, .external_lex_state = 2},
  [337] = {.lex_state = 113, .external_lex_state = 2},
  [338] = {.lex_state = 113, .external_lex_state = 2},
  [339] = {.lex_state = 112, .external_lex_state = 2},
  [340] = {.lex_state = 112, .external_lex_state = 2},
  [341] = {.lex_state = 113, .external_lex_state = 2},
  [342] = {.lex_state = 113, .external_lex_state = 2},
  [343] = {.lex_state = 112, .external_lex_state = 2},
  [344] = {.lex_state = 112, .external_lex_state = 2},
  [345] = {.lex_state = 112, .external_lex_state = 2},
  [346] = {.lex_state = 112, .external_lex_state = 2},
  [347] = {.lex_state = 112, .external_lex_state = 2},
  [348] = {.lex_state = 112, .external_lex_state = 2},
  [349] = {.lex_state = 112, .external_lex_state = 2},
  [350] = {.lex_state = 113, .external_lex_state = 2},
  [351] = {.lex_state = 112, .external_lex_state = 2},
  [352] = {.lex_state = 113, .external_lex_state = 2},
  [353] = {.lex_state = 112, .external_lex_state = 2},
  [354] = {.lex_state = 113, .external_lex_state = 2},
  [355] = {.lex_state = 112, .external_lex_state = 2},
  [356] = {.lex_state = 113, .external_lex_state = 2},
  [357] = {.lex_state = 113, .external_lex_state = 2},
  [358] = {.lex_state = 113, .external_lex_state = 2},
  [359] = {.lex_state = 113, .external_lex_state = 2},
  [360] = {.lex_state = 113, .external_lex_state = 2},
  [361] = {.lex_state = 113, .external_lex_state = 2},
  [362] = {.lex_state = 113, .external_lex_state = 2},
  [363] = {.lex_state = 113, .external_lex_state = 2},
  [364] = {.lex_state = 113, .external_lex_state = 2},
  [365] = {.lex_state = 113, .external_lex_state = 2},
  [366] = {.lex_state = 113, .external_lex_state = 2},
  [367] = {.lex_state = 113, .external_lex_state = 2},
  [368] = {.lex_state = 113, .external_lex_state = 2},
  [369] = {.lex_state = 113, .external_lex_state = 2},
  [370] = {.lex_state = 113, .external_lex_state = 2},
  [371] = {.lex_state = 113, .external_lex_state = 2},
  [372] = {.lex_state = 113, .external_lex_state = 2},
  [373] = {.lex_state = 113, .external_lex_state = 2},
  [374] = {.lex_state = 113, .external_lex_state = 2},
  [375] = {.lex_state = 113, .external_lex_state = 2},
  [376] = {.lex_state = 113, .external_lex_state = 2},
  [377] = {.lex_state = 113, .external_lex_state = 2},
  [378] = {.lex_state = 113, .external_lex_state = 2},
  [379] = {.lex_state = 113, .external_lex_state = 2},
  [380] = {.lex_state = 113, .external_lex_state = 2},
  [381] = {.lex_state = 113, .external_lex_state = 2},
  [382] = {.lex_state = 113, .external_lex_state = 2},
  [383] = {.lex_state = 113, .external_lex_state = 2},
  [384] = {.lex_state = 113, .external_lex_state = 2},
  [385] = {.lex_state = 113, .external_lex_state = 2},
  [386] = {.lex_state = 113, .external_lex_state = 2},
  [387] = {.lex_state = 113, .external_lex_state = 2},
  [388] = {.lex_state = 113, .external_lex_state = 2},
  [389] = {.lex_state = 113, .external_lex_state = 2},
  [390] = {.lex_state = 113, .external_lex_state = 2},
  [391] = {.lex_state = 113, .external_lex_state = 2},
  [392] = {.lex_state = 113, .external_lex_state = 2},
  [393] = {.lex_state = 113, .external_lex_state = 2},
  [394] = {.lex_state = 113, .external_lex_state = 2},
  [395] = {.lex_state = 113, .external_lex_state = 2},
  [396] = {.lex_state = 113, .external_lex_state = 2},
  [397] = {.lex_state = 113, .external_lex_state = 2},
  [398] = {.lex_state = 113, .external_lex_state = 2},
  [399] = {.lex_state = 113, .external_lex_state = 2},
  [400] = {.lex_state = 113, .external_lex_state = 2},
  [401] = {.lex_state = 113, .external_lex_state = 2},
  [402] = {.lex_state = 113, .external_lex_state = 2},
  [403] = {.lex_state = 113, .external_lex_state = 2},
  [404] = {.lex_state = 113, .external_lex_state = 2},
  [405] = {.lex_state = 113, .external_lex_state = 2},
  [406] = {.lex_state = 113, .external_lex_state = 2},
  [407] = {.lex_state = 113, .external_lex_state = 2},
  [408] = {.lex_state = 113, .external_lex_state = 2},
  [409] = {.lex_state = 113, .external_lex_state = 2},
  [410] = {.lex_state = 113, .external_lex_state = 2},
  [411] = {.lex_state = 113, .external_lex_state = 2},
  [412] = {.lex_state = 113, .external_lex_state = 2},
  [413] = {.lex_state = 113, .external_lex_state = 2},
  [414] = {.lex_state = 113, .external_lex_state = 2},
  [415] = {.lex_state = 113, .external_lex_state = 2},
  [416] = {.lex_state = 113, .external_lex_state = 2},
  [417] = {.lex_state = 113, .external_lex_state = 2},
  [418] = {.lex_state = 113, .external_lex_state = 2},
  [419] = {.lex_state = 113, .external_lex_state = 2},
  [420] = {.lex_state = 113, .external_lex_state = 2},
  [421] = {.lex_state = 113, .external_lex_state = 2},
  [422] = {.lex_state = 113, .external_lex_state = 2},
  [423] = {.lex_state = 113, .external_lex_state = 2},
  [424] = {.lex_state = 113, .external_lex_state = 2},
  [425] = {.lex_state = 113, .external_lex_state = 2},
  [426] = {.lex_state = 113, .external_lex_state = 2},
  [427] = {.lex_state = 113, .external_lex_state = 2},
  [428] = {.lex_state = 113, .external_lex_state = 2},
  [429] = {.lex_state = 113, .external_lex_state = 2},
  [430] = {.lex_state = 113, .external_lex_state = 2},
  [431] = {.lex_state = 113, .external_lex_state = 2},
  [432] = {.lex_state = 113, .external_lex_state = 2},
  [433] = {.lex_state = 113, .external_lex_state = 2},
  [434] = {.lex_state = 113, .external_lex_state = 2},
  [435] = {.lex_state = 113, .external_lex_state = 2},
  [436] = {.lex_state = 113, .external_lex_state = 2},
  [437] = {.lex_state = 113, .external_lex_state = 2},
  [438] = {.lex_state = 113, .external_lex_state = 2},
  [439] = {.lex_state = 113, .external_lex_state = 2},
  [440] = {.lex_state = 113, .external_lex_state = 2},
  [441] = {.lex_state = 113, .external_lex_state = 2},
  [442] = {.lex_state = 113, .external_lex_state = 2},
  [443] = {.lex_state = 113, .external_lex_state = 2},
  [444] = {.lex_state = 113, .external_lex_state = 2},
  [445] = {.lex_state = 113, .external_lex_state = 2},
  [446] = {.lex_state = 113, .external_lex_state = 2},
  [447] = {.lex_state = 113, .external_lex_state = 2},
  [448] = {.lex_state = 113, .external_lex_state = 2},
  [449] = {.lex_state = 113, .external_lex_state = 2},
  [450] = {.lex_state = 113, .external_lex_state = 2},
  [451] = {.lex_state = 113, .external_lex_state = 2},
  [452] = {.lex_state = 113, .external_lex_state = 2},
  [453] = {.lex_state = 113, .external_lex_state = 2},
  [454] = {.lex_state = 113, .external_lex_state = 2},
  [455] = {.lex_state = 113, .external_lex_state = 2},
  [456] = {.lex_state = 113, .external_lex_state = 2},
  [457] = {.lex_state = 113, .external_lex_state = 2},
  [458] = {.lex_state = 113, .external_lex_state = 2},
  [459] = {.lex_state = 113, .external_lex_state = 2},
  [460] = {.lex_state = 113, .external_lex_state = 2},
  [461] = {.lex_state = 113, .external_lex_state = 2},
  [462] = {.lex_state = 113, .external_lex_state = 2},
  [463] = {.lex_state = 113, .external_lex_state = 2},
  [464] = {.lex_state = 113, .external_lex_state = 2},
  [465] = {.lex_state = 113, .external_lex_state = 2},
  [466] = {.lex_state = 113, .external_lex_state = 2},
  [467] = {.lex_state = 113, .external_lex_state = 2},
  [468] = {.lex_state = 113, .external_lex_state = 2},
  [469] = {.lex_state = 113, .external_lex_state = 2},
  [470] = {.lex_state = 113, .external_lex_state = 2},
  [471] = {.lex_state = 113, .external_lex_state = 2},
  [472] = {.lex_state = 113, .external_lex_state = 2},
  [473] = {.lex_state = 113, .external_lex_state = 2},
  [474] = {.lex_state = 113, .external_lex_state = 2},
  [475] = {.lex_state = 113, .external_lex_state = 2},
  [476] = {.lex_state = 113, .external_lex_state = 2},
  [477] = {.lex_state = 113, .external_lex_state = 2},
  [478] = {.lex_state = 113, .external_lex_state = 2},
  [479] = {.lex_state = 113, .external_lex_state = 2},
  [480] = {.lex_state = 113, .external_lex_state = 2},
  [481] = {.lex_state = 113, .external_lex_state = 2},
  [482] = {.lex_state = 113, .external_lex_state = 2},
  [483] = {.lex_state = 113, .external_lex_state = 2},
  [484] = {.lex_state = 113, .external_lex_state = 2},
  [485] = {.lex_state = 113, .external_lex_state = 2},
  [486] = {.lex_state = 113, .external_lex_state = 2},
  [487] = {.lex_state = 113, .external_lex_state = 2},
  [488] = {.lex_state = 113, .external_lex_state = 2},
  [489] = {.lex_state = 113, .external_lex_state = 2},
  [490] = {.lex_state = 113, .external_lex_state = 2},
  [491] = {.lex_state = 113, .external_lex_state = 2},
  [492] = {.lex_state = 113, .external_lex_state = 2},
  [493] = {.lex_state = 113, .external_lex_state = 2},
  [494] = {.lex_state = 113, .external_lex_state = 2},
  [495] = {.lex_state = 113, .external_lex_state = 2},
  [496] = {.lex_state = 113, .external_lex_state = 2},
  [497] = {.lex_state = 113, .external_lex_state = 2},
  [498] = {.lex_state = 113, .external_lex_state = 2},
  [499] = {.lex_state = 113, .external_lex_state = 2},
  [500] = {.lex_state = 113, .external_lex_state = 2},
  [501] = {.lex_state = 113, .external_lex_state = 2},
  [502] = {.lex_state = 113, .external_lex_state = 2},
  [503] = {.lex_state = 113, .external_lex_state = 2},
  [504] = {.lex_state = 113, .external_lex_state = 2},
  [505] = {.lex_state = 113, .external_lex_state = 2},
  [506] = {.lex_state = 113, .external_lex_state = 2},
  [507] = {.lex_state = 113, .external_lex_state = 2},
  [508] = {.lex_state = 113, .external_lex_state = 2},
  [509] = {.lex_state = 113, .external_lex_state = 2},
  [510] = {.lex_state = 113, .external_lex_state = 2},
  [511] = {.lex_state = 113, .external_lex_state = 2},
  [512] = {.lex_state = 113, .external_lex_state = 2},
  [513] = {.lex_state = 113, .external_lex_state = 2},
  [514] = {.lex_state = 113, .external_lex_state = 2},
  [515] = {.lex_state = 113, .external_lex_state = 2},
  [516] = {.lex_state = 113, .external_lex_state = 2},
  [517] = {.lex_state = 113, .external_lex_state = 2},
  [518] = {.lex_state = 113, .external_lex_state = 2},
  [519] = {.lex_state = 113, .external_lex_state = 2},
  [520] = {.lex_state = 113, .external_lex_state = 2},
  [521] = {.lex_state = 113, .external_lex_state = 2},
  [522] = {.lex_state = 113, .external_lex_state = 2},
  [523] = {.lex_state = 113, .external_lex_state = 2},
  [524] = {.lex_state = 113, .external_lex_state = 2},
  [525] = {.lex_state = 113, .external_lex_state = 2},
  [526] = {.lex_state = 113, .external_lex_state = 2},
  [527] = {.lex_state = 113, .external_lex_state = 2},
  [528] = {.lex_state = 113, .external_lex_state = 2},
  [529] = {.lex_state = 113, .external_lex_state = 2},
  [530] = {.lex_state = 113, .external_lex_state = 2},
  [531] = {.lex_state = 113, .external_lex_state = 2},
  [532] = {.lex_state = 113, .external_lex_state = 2},
  [533] = {.lex_state = 113, .external_lex_state = 2},
  [534] = {.lex_state = 113, .external_lex_state = 2},
  [535] = {.lex_state = 113, .external_lex_state = 2},
  [536] = {.lex_state = 113, .external_lex_state = 2},
  [537] = {.lex_state = 113, .external_lex_state = 2},
  [538] = {.lex_state = 113, .external_lex_state = 2},
  [539] = {.lex_state = 113, .external_lex_state = 2},
  [540] = {.lex_state = 113, .external_lex_state = 2},
  [541] = {.lex_state = 113, .external_lex_state = 2},
  [542] = {.lex_state = 113, .external_lex_state = 2},
  [543] = {.lex_state = 113, .external_lex_state = 2},
  [544] = {.lex_state = 113, .external_lex_state = 2},
  [545] = {.lex_state = 113, .external_lex_state = 2},
  [546] = {.lex_state = 113, .external_lex_state = 2},
  [547] = {.lex_state = 113, .external_lex_state = 2},
  [548] = {.lex_state = 113, .external_lex_state = 2},
  [549] = {.lex_state = 113, .external_lex_state = 2},
  [550] = {.lex_state = 113, .external_lex_state = 2},
  [551] = {.lex_state = 113, .external_lex_state = 2},
  [552] = {.lex_state = 113, .external_lex_state = 2},
  [553] = {.lex_state = 113, .external_lex_state = 2},
  [554] = {.lex_state = 113, .external_lex_state = 2},
  [555] = {.lex_state = 113, .external_lex_state = 2},
  [556] = {.lex_state = 113, .external_lex_state = 2},
  [557] = {.lex_state = 113, .external_lex_state = 2},
  [558] = {.lex_state = 113, .external_lex_state = 2},
  [559] = {.lex_state = 113, .external_lex_state = 2},
  [560] = {.lex_state = 113, .external_lex_state = 2},
  [561] = {.lex_state = 113, .external_lex_state = 2},
  [562] = {.lex_state = 113, .external_lex_state = 2},
  [563] = {.lex_state = 113, .external_lex_state = 2},
  [564] = {.lex_state = 113, .external_lex_state = 2},
  [565] = {.lex_state = 113, .external_lex_state = 2},
  [566] = {.lex_state = 113, .external_lex_state = 2},
  [567] = {.lex_state = 113, .external_lex_state = 2},
  [568] = {.lex_state = 113, .external_lex_state = 2},
  [569] = {.lex_state = 113, .external_lex_state = 2},
  [570] = {.lex_state = 113, .external_lex_state = 2},
  [571] = {.lex_state = 113, .external_lex_state = 2},
  [572] = {.lex_state = 113, .external_lex_state = 2},
  [573] = {.lex_state = 113, .external_lex_state = 2},
  [574] = {.lex_state = 113, .external_lex_state = 2},
  [575] = {.lex_state = 113, .external_lex_state = 2},
  [576] = {.lex_state = 113, .external_lex_state = 2},
  [577] = {.lex_state = 113, .external_lex_state = 2},
  [578] = {.lex_state = 113, .external_lex_state = 2},
  [579] = {.lex_state = 113, .external_lex_state = 2},
  [580] = {.lex_state = 113, .external_lex_state = 2},
  [581] = {.lex_state = 113, .external_lex_state = 2},
  [582] = {.lex_state = 113, .external_lex_state = 2},
  [583] = {.lex_state = 113, .external_lex_state = 2},
  [584] = {.lex_state = 113, .external_lex_state = 2},
  [585] = {.lex_state = 113, .external_lex_state = 2},
  [586] = {.lex_state = 113, .external_lex_state = 2},
  [587] = {.lex_state = 113, .external_lex_state = 2},
  [588] = {.lex_state = 113, .external_lex_state = 2},
  [589] = {.lex_state = 113, .external_lex_state = 2},
  [590] = {.lex_state = 113, .external_lex_state = 2},
  [591] = {.lex_state = 113, .external_lex_state = 2},
  [592] = {.lex_state = 113, .external_lex_state = 2},
  [593] = {.lex_state = 113, .external_lex_state = 2},
  [594] = {.lex_state = 113, .external_lex_state = 2},
  [595] = {.lex_state = 113, .external_lex_state = 2},
  [596] = {.lex_state = 113, .external_lex_state = 2},
  [597] = {.lex_state = 113, .external_lex_state = 2},
  [598] = {.lex_state = 113, .external_lex_state = 2},
  [599] = {.lex_state = 113, .external_lex_state = 2},
  [600] = {.lex_state = 113, .external_lex_state = 2},
  [601] = {.lex_state = 113, .external_lex_state = 2},
  [602] = {.lex_state = 113, .external_lex_state = 2},
  [603] = {.lex_state = 113, .external_lex_state = 2},
  [604] = {.lex_state = 113, .external_lex_state = 2},
  [605] = {.lex_state = 113, .external_lex_state = 2},
  [606] = {.lex_state = 113, .external_lex_state = 2},
  [607] = {.lex_state = 113, .external_lex_state = 2},
  [608] = {.lex_state = 113, .external_lex_state = 2},
  [609] = {.lex_state = 113, .external_lex_state = 2},
  [610] = {.lex_state = 113, .external_lex_state = 2},
  [611] = {.lex_state = 113, .external_lex_state = 2},
  [612] = {.lex_state = 113, .external_lex_state = 2},
  [613] = {.lex_state = 113, .external_lex_state = 2},
  [614] = {.lex_state = 113, .external_lex_state = 2},
  [615] = {.lex_state = 113, .external_lex_state = 2},
  [616] = {.lex_state = 113, .external_lex_state = 2},
  [617] = {.lex_state = 113, .external_lex_state = 2},
  [618] = {.lex_state = 113, .external_lex_state = 2},
  [619] = {.lex_state = 113, .external_lex_state = 2},
  [620] = {.lex_state = 113, .external_lex_state = 2},
  [621] = {.lex_state = 113, .external_lex_state = 2},
  [622] = {.lex_state = 113, .external_lex_state = 2},
  [623] = {.lex_state = 113, .external_lex_state = 2},
  [624] = {.lex_state = 113, .external_lex_state = 2},
  [625] = {.lex_state = 113, .external_lex_state = 2},
  [626] = {.lex_state = 113, .external_lex_state = 2},
  [627] = {.lex_state = 113, .external_lex_state = 2},
  [628] = {.lex_state = 113, .external_lex_state = 2},
  [629] = {.lex_state = 113, .external_lex_state = 2},
  [630] = {.lex_state = 113, .external_lex_state = 2},
  [631] = {.lex_state = 113, .external_lex_state = 2},
  [632] = {.lex_state = 113, .external_lex_state = 2},
  [633] = {.lex_state = 113, .external_lex_state = 2},
  [634] = {.lex_state = 113, .external_lex_state = 2},
  [635] = {.lex_state = 113, .external_lex_state = 2},
  [636] = {.lex_state = 113, .external_lex_state = 2},
  [637] = {.lex_state = 113, .external_lex_state = 2},
  [638] = {.lex_state = 113, .external_lex_state = 2},
  [639] = {.lex_state = 113, .external_lex_state = 2},
  [640] = {.lex_state = 113, .external_lex_state = 2},
  [641] = {.lex_state = 113, .external_lex_state = 2},
  [642] = {.lex_state = 113, .external_lex_state = 2},
  [643] = {.lex_state = 113, .external_lex_state = 2},
  [644] = {.lex_state = 113, .external_lex_state = 2},
  [645] = {.lex_state = 113, .external_lex_state = 2},
  [646] = {.lex_state = 113, .external_lex_state = 2},
  [647] = {.lex_state = 113, .external_lex_state = 2},
  [648] = {.lex_state = 113, .external_lex_state = 2},
  [649] = {.lex_state = 113, .external_lex_state = 2},
  [650] = {.lex_state = 113, .external_lex_state = 2},
  [651] = {.lex_state = 113, .external_lex_state = 2},
  [652] = {.lex_state = 113, .external_lex_state = 2},
  [653] = {.lex_state = 113, .external_lex_state = 2},
  [654] = {.lex_state = 113, .external_lex_state = 2},
  [655] = {.lex_state = 113, .external_lex_state = 2},
  [656] = {.lex_state = 113, .external_lex_state = 2},
  [657] = {.lex_state = 113, .external_lex_state = 2},
  [658] = {.lex_state = 113, .external_lex_state = 2},
  [659] = {.lex_state = 113, .external_lex_state = 2},
  [660] = {.lex_state = 113, .external_lex_state = 2},
  [661] = {.lex_state = 113, .external_lex_state = 2},
  [662] = {.lex_state = 113, .external_lex_state = 2},
  [663] = {.lex_state = 113, .external_lex_state = 2},
  [664] = {.lex_state = 113, .external_lex_state = 2},
  [665] = {.lex_state = 113, .external_lex_state = 2},
  [666] = {.lex_state = 113, .external_lex_state = 2},
  [667] = {.lex_state = 113, .external_lex_state = 2},
  [668] = {.lex_state = 113, .external_lex_state = 2},
  [669] = {.lex_state = 113, .external_lex_state = 2},
  [670] = {.lex_state = 113, .external_lex_state = 2},
  [671] = {.lex_state = 113, .external_lex_state = 2},
  [672] = {.lex_state = 113, .external_lex_state = 2},
  [673] = {.lex_state = 113, .external_lex_state = 2},
  [674] = {.lex_state = 113, .external_lex_state = 2},
  [675] = {.lex_state = 113, .external_lex_state = 2},
  [676] = {.lex_state = 113, .external_lex_state = 2},
  [677] = {.lex_state = 113, .external_lex_state = 2},
  [678] = {.lex_state = 113, .external_lex_state = 2},
  [679] = {.lex_state = 113, .external_lex_state = 2},
  [680] = {.lex_state = 113, .external_lex_state = 2},
  [681] = {.lex_state = 113, .external_lex_state = 2},
  [682] = {.lex_state = 113, .external_lex_state = 2},
  [683] = {.lex_state = 113, .external_lex_state = 2},
  [684] = {.lex_state = 113, .external_lex_state = 2},
  [685] = {.lex_state = 113, .external_lex_state = 2},
  [686] = {.lex_state = 113, .external_lex_state = 2},
  [687] = {.lex_state = 113, .external_lex_state = 2},
  [688] = {.lex_state = 113, .external_lex_state = 2},
  [689] = {.lex_state = 113, .external_lex_state = 2},
  [690] = {.lex_state = 113, .external_lex_state = 2},
  [691] = {.lex_state = 113, .external_lex_state = 2},
  [692] = {.lex_state = 113, .external_lex_state = 2},
  [693] = {.lex_state = 113, .external_lex_state = 2},
  [694] = {.lex_state = 113, .external_lex_state = 2},
  [695] = {.lex_state = 113, .external_lex_state = 2},
  [696] = {.lex_state = 113, .external_lex_state = 2},
  [697] = {.lex_state = 113, .external_lex_state = 2},
  [698] = {.lex_state = 113, .external_lex_state = 2},
  [699] = {.lex_state = 113, .external_lex_state = 2},
  [700] = {.lex_state = 113, .external_lex_state = 2},
  [701] = {.lex_state = 113, .external_lex_state = 2},
  [702] = {.lex_state = 113, .external_lex_state = 2},
  [703] = {.lex_state = 113, .external_lex_state = 2},
  [704] = {.lex_state = 113, .external_lex_state = 2},
  [705] = {.lex_state = 113, .external_lex_state = 2},
  [706] = {.lex_state = 113, .external_lex_state = 2},
  [707] = {.lex_state = 113, .external_lex_state = 2},
  [708] = {.lex_state = 113, .external_lex_state = 2},
  [709] = {.lex_state = 113, .external_lex_state = 2},
  [710] = {.lex_state = 113, .external_lex_state = 2},
  [711] = {.lex_state = 113, .external_lex_state = 2},
  [712] = {.lex_state = 113, .external_lex_state = 2},
  [713] = {.lex_state = 113, .external_lex_state = 2},
  [714] = {.lex_state = 113, .external_lex_state = 2},
  [715] = {.lex_state = 113, .external_lex_state = 2},
  [716] = {.lex_state = 113, .external_lex_state = 2},
  [717] = {.lex_state = 113, .external_lex_state = 2},
  [718] = {.lex_state = 113, .external_lex_state = 2},
  [719] = {.lex_state = 113, .external_lex_state = 2},
  [720] = {.lex_state = 113, .external_lex_state = 2},
  [721] = {.lex_state = 113, .external_lex_state = 2},
  [722] = {.lex_state = 113, .external_lex_state = 2},
  [723] = {.lex_state = 113, .external_lex_state = 2},
  [724] = {.lex_state = 113, .external_lex_state = 2},
  [725] = {.lex_state = 113, .external_lex_state = 2},
  [726] = {.lex_state = 113, .external_lex_state = 2},
  [727] = {.lex_state = 113, .external_lex_state = 2},
  [728] = {.lex_state = 113, .external_lex_state = 2},
  [729] = {.lex_state = 113, .external_lex_state = 2},
  [730] = {.lex_state = 113, .external_lex_state = 2},
  [731] = {.lex_state = 113, .external_lex_state = 2},
  [732] = {.lex_state = 113, .external_lex_state = 2},
  [733] = {.lex_state = 113, .external_lex_state = 2},
  [734] = {.lex_state = 113, .external_lex_state = 2},
  [735] = {.lex_state = 113, .external_lex_state = 2},
  [736] = {.lex_state = 113, .external_lex_state = 2},
  [737] = {.lex_state = 113, .external_lex_state = 2},
  [738] = {.lex_state = 113, .external_lex_state = 2},
  [739] = {.lex_state = 113, .external_lex_state = 2},
  [740] = {.lex_state = 113, .external_lex_state = 2},
  [741] = {.lex_state = 113, .external_lex_state = 2},
  [742] = {.lex_state = 113, .external_lex_state = 2},
  [743] = {.lex_state = 113, .external_lex_state = 2},
  [744] = {.lex_state = 113, .external_lex_state = 2},
  [745] = {.lex_state = 113, .external_lex_state = 2},
  [746] = {.lex_state = 113, .external_lex_state = 2},
  [747] = {.lex_state = 113, .external_lex_state = 2},
  [748] = {.lex_state = 113, .external_lex_state = 2},
  [749] = {.lex_state = 113, .external_lex_state = 2},
  [750] = {.lex_state = 113, .external_lex_state = 2},
  [751] = {.lex_state = 113, .external_lex_state = 2},
  [752] = {.lex_state = 113, .external_lex_state = 2},
  [753] = {.lex_state = 113, .external_lex_state = 2},
  [754] = {.lex_state = 113, .external_lex_state = 2},
  [755] = {.lex_state = 113, .external_lex_state = 2},
  [756] = {.lex_state = 113, .external_lex_state = 2},
  [757] = {.lex_state = 113, .external_lex_state = 2},
  [758] = {.lex_state = 113, .external_lex_state = 2},
  [759] = {.lex_state = 113, .external_lex_state = 2},
  [760] = {.lex_state = 113, .external_lex_state = 2},
  [761] = {.lex_state = 113, .external_lex_state = 2},
  [762] = {.lex_state = 113, .external_lex_state = 2},
  [763] = {.lex_state = 113, .external_lex_state = 2},
  [764] = {.lex_state = 113, .external_lex_state = 2},
  [765] = {.lex_state = 113, .external_lex_state = 2},
  [766] = {.lex_state = 113, .external_lex_state = 2},
  [767] = {.lex_state = 113, .external_lex_state = 2},
  [768] = {.lex_state = 113, .external_lex_state = 2},
  [769] = {.lex_state = 113, .external_lex_state = 2},
  [770] = {.lex_state = 113, .external_lex_state = 2},
  [771] = {.lex_state = 113, .external_lex_state = 2},
  [772] = {.lex_state = 113, .external_lex_state = 2},
  [773] = {.lex_state = 113, .external_lex_state = 2},
  [774] = {.lex_state = 113, .external_lex_state = 2},
  [775] = {.lex_state = 113, .external_lex_state = 2},
  [776] = {.lex_state = 113, .external_lex_state = 2},
  [777] = {.lex_state = 113, .external_lex_state = 2},
  [778] = {.lex_state = 113, .external_lex_state = 2},
  [779] = {.lex_state = 113, .external_lex_state = 2},
  [780] = {.lex_state = 113, .external_lex_state = 2},
  [781] = {.lex_state = 113, .external_lex_state = 2},
  [782] = {.lex_state = 113, .external_lex_state = 2},
  [783] = {.lex_state = 113, .external_lex_state = 2},
  [784] = {.lex_state = 113, .external_lex_state = 2},
  [785] = {.lex_state = 113, .external_lex_state = 2},
  [786] = {.lex_state = 113, .external_lex_state = 2},
  [787] = {.lex_state = 113, .external_lex_state = 2},
  [788] = {.lex_state = 113, .external_lex_state = 2},
  [789] = {.lex_state = 113, .external_lex_state = 2},
  [790] = {.lex_state = 113, .external_lex_state = 2},
  [791] = {.lex_state = 113, .external_lex_state = 2},
  [792] = {.lex_state = 113, .external_lex_state = 2},
  [793] = {.lex_state = 113, .external_lex_state = 2},
  [794] = {.lex_state = 113, .external_lex_state = 2},
  [795] = {.lex_state = 113, .external_lex_state = 2},
  [796] = {.lex_state = 113, .external_lex_state = 2},
  [797] = {.lex_state = 113, .external_lex_state = 2},
  [798] = {.lex_state = 113, .external_lex_state = 2},
  [799] = {.lex_state = 113, .external_lex_state = 2},
  [800] = {.lex_state = 113, .external_lex_state = 2},
  [801] = {.lex_state = 113, .external_lex_state = 2},
  [802] = {.lex_state = 113, .external_lex_state = 2},
  [803] = {.lex_state = 113, .external_lex_state = 2},
  [804] = {.lex_state = 113, .external_lex_state = 2},
  [805] = {.lex_state = 113, .external_lex_state = 2},
  [806] = {.lex_state = 113, .external_lex_state = 2},
  [807] = {.lex_state = 113, .external_lex_state = 2},
  [808] = {.lex_state = 113, .external_lex_state = 2},
  [809] = {.lex_state = 113, .external_lex_state = 2},
  [810] = {.lex_state = 113, .external_lex_state = 2},
  [811] = {.lex_state = 113, .external_lex_state = 2},
  [812] = {.lex_state = 113, .external_lex_state = 2},
  [813] = {.lex_state = 113, .external_lex_state = 2},
  [814] = {.lex_state = 113, .external_lex_state = 2},
  [815] = {.lex_state = 113, .external_lex_state = 2},
  [816] = {.lex_state = 113, .external_lex_state = 2},
  [817] = {.lex_state = 113, .external_lex_state = 2},
  [818] = {.lex_state = 113, .external_lex_state = 2},
  [819] = {.lex_state = 113, .external_lex_state = 2},
  [820] = {.lex_state = 113, .external_lex_state = 2},
  [821] = {.lex_state = 113, .external_lex_state = 2},
  [822] = {.lex_state = 113, .external_lex_state = 2},
  [823] = {.lex_state = 113, .external_lex_state = 2},
  [824] = {.lex_state = 113, .external_lex_state = 2},
  [825] = {.lex_state = 113, .external_lex_state = 2},
  [826] = {.lex_state = 113, .external_lex_state = 2},
  [827] = {.lex_state = 113, .external_lex_state = 2},
  [828] = {.lex_state = 113, .external_lex_state = 2},
  [829] = {.lex_state = 113, .external_lex_state = 2},
  [830] = {.lex_state = 113, .external_lex_state = 2},
  [831] = {.lex_state = 113, .external_lex_state = 2},
  [832] = {.lex_state = 113, .external_lex_state = 2},
  [833] = {.lex_state = 113, .external_lex_state = 2},
  [834] = {.lex_state = 113, .external_lex_state = 2},
  [835] = {.lex_state = 113, .external_lex_state = 2},
  [836] = {.lex_state = 113, .external_lex_state = 2},
  [837] = {.lex_state = 113, .external_lex_state = 2},
  [838] = {.lex_state = 113, .external_lex_state = 2},
  [839] = {.lex_state = 113, .external_lex_state = 2},
  [840] = {.lex_state = 113, .external_lex_state = 2},
  [841] = {.lex_state = 113, .external_lex_state = 2},
  [842] = {.lex_state = 113, .external_lex_state = 2},
  [843] = {.lex_state = 113, .external_lex_state = 2},
  [844] = {.lex_state = 113, .external_lex_state = 2},
  [845] = {.lex_state = 113, .external_lex_state = 2},
  [846] = {.lex_state = 113, .external_lex_state = 2},
  [847] = {.lex_state = 113, .external_lex_state = 2},
  [848] = {.lex_state = 113, .external_lex_state = 2},
  [849] = {.lex_state = 113, .external_lex_state = 2},
  [850] = {.lex_state = 113, .external_lex_state = 2},
  [851] = {.lex_state = 113, .external_lex_state = 2},
  [852] = {.lex_state = 113, .external_lex_state = 2},
  [853] = {.lex_state = 113, .external_lex_state = 2},
  [854] = {.lex_state = 113, .external_lex_state = 2},
  [855] = {.lex_state = 113, .external_lex_state = 2},
  [856] = {.lex_state = 113, .external_lex_state = 2},
  [857] = {.lex_state = 113, .external_lex_state = 2},
  [858] = {.lex_state = 113, .external_lex_state = 2},
  [859] = {.lex_state = 113, .external_lex_state = 2},
  [860] = {.lex_state = 113, .external_lex_state = 2},
  [861] = {.lex_state = 113, .external_lex_state = 2},
  [862] = {.lex_state = 113, .external_lex_state = 2},
  [863] = {.lex_state = 113, .external_lex_state = 2},
  [864] = {.lex_state = 113, .external_lex_state = 2},
  [865] = {.lex_state = 113, .external_lex_state = 2},
  [866] = {.lex_state = 113, .external_lex_state = 2},
  [867] = {.lex_state = 113, .external_lex_state = 2},
  [868] = {.lex_state = 113, .external_lex_state = 2},
  [869] = {.lex_state = 113, .external_lex_state = 2},
  [870] = {.lex_state = 113, .external_lex_state = 2},
  [871] = {.lex_state = 113, .external_lex_state = 2},
  [872] = {.lex_state = 113, .external_lex_state = 2},
  [873] = {.lex_state = 113, .external_lex_state = 2},
  [874] = {.lex_state = 113, .external_lex_state = 2},
  [875] = {.lex_state = 113, .external_lex_state = 2},
  [876] = {.lex_state = 113, .external_lex_state = 2},
  [877] = {.lex_state = 113, .external_lex_state = 2},
  [878] = {.lex_state = 113, .external_lex_state = 2},
  [879] = {.lex_state = 113, .external_lex_state = 2},
  [880] = {.lex_state = 113, .external_lex_state = 2},
  [881] = {.lex_state = 113, .external_lex_state = 2},
  [882] = {.lex_state = 113, .external_lex_state = 2},
  [883] = {.lex_state = 113, .external_lex_state = 2},
  [884] = {.lex_state = 113, .external_lex_state = 2},
  [885] = {.lex_state = 113, .external_lex_state = 2},
  [886] = {.lex_state = 113, .external_lex_state = 2},
  [887] = {.lex_state = 113, .external_lex_state = 2},
  [888] = {.lex_state = 113, .external_lex_state = 2},
  [889] = {.lex_state = 113, .external_lex_state = 2},
  [890] = {.lex_state = 113, .external_lex_state = 2},
  [891] = {.lex_state = 113, .external_lex_state = 2},
  [892] = {.lex_state = 113, .external_lex_state = 2},
  [893] = {.lex_state = 113, .external_lex_state = 2},
  [894] = {.lex_state = 113, .external_lex_state = 2},
  [895] = {.lex_state = 113, .external_lex_state = 2},
  [896] = {.lex_state = 113, .external_lex_state = 2},
  [897] = {.lex_state = 113, .external_lex_state = 2},
  [898] = {.lex_state = 113, .external_lex_state = 2},
  [899] = {.lex_state = 113, .external_lex_state = 2},
  [900] = {.lex_state = 113, .external_lex_state = 2},
  [901] = {.lex_state = 113, .external_lex_state = 2},
  [902] = {.lex_state = 113, .external_lex_state = 2},
  [903] = {.lex_state = 113, .external_lex_state = 2},
  [904] = {.lex_state = 113, .external_lex_state = 2},
  [905] = {.lex_state = 113, .external_lex_state = 2},
  [906] = {.lex_state = 113, .external_lex_state = 2},
  [907] = {.lex_state = 113, .external_lex_state = 2},
  [908] = {.lex_state = 113, .external_lex_state = 2},
  [909] = {.lex_state = 113, .external_lex_state = 2},
  [910] = {.lex_state = 113, .external_lex_state = 2},
  [911] = {.lex_state = 113, .external_lex_state = 2},
  [912] = {.lex_state = 113, .external_lex_state = 2},
  [913] = {.lex_state = 113, .external_lex_state = 2},
  [914] = {.lex_state = 113, .external_lex_state = 2},
  [915] = {.lex_state = 113, .external_lex_state = 2},
  [916] = {.lex_state = 113, .external_lex_state = 2},
  [917] = {.lex_state = 113, .external_lex_state = 2},
  [918] = {.lex_state = 113, .external_lex_state = 2},
  [919] = {.lex_state = 113, .external_lex_state = 2},
  [920] = {.lex_state = 113, .external_lex_state = 2},
  [921] = {.lex_state = 113, .external_lex_state = 2},
  [922] = {.lex_state = 113, .external_lex_state = 2},
  [923] = {.lex_state = 113, .external_lex_state = 2},
  [924] = {.lex_state = 113, .external_lex_state = 2},
  [925] = {.lex_state = 113, .external_lex_state = 2},
  [926] = {.lex_state = 113, .external_lex_state = 2},
  [927] = {.lex_state = 113, .external_lex_state = 2},
  [928] = {.lex_state = 113, .external_lex_state = 2},
  [929] = {.lex_state = 113, .external_lex_state = 2},
  [930] = {.lex_state = 113, .external_lex_state = 2},
  [931] = {.lex_state = 113, .external_lex_state = 2},
  [932] = {.lex_state = 113, .external_lex_state = 2},
  [933] = {.lex_state = 113, .external_lex_state = 2},
  [934] = {.lex_state = 113, .external_lex_state = 2},
  [935] = {.lex_state = 113, .external_lex_state = 2},
  [936] = {.lex_state = 113, .external_lex_state = 2},
  [937] = {.lex_state = 113, .external_lex_state = 2},
  [938] = {.lex_state = 113, .external_lex_state = 2},
  [939] = {.lex_state = 113, .external_lex_state = 2},
  [940] = {.lex_state = 113, .external_lex_state = 2},
  [941] = {.lex_state = 113, .external_lex_state = 2},
  [942] = {.lex_state = 113, .external_lex_state = 2},
  [943] = {.lex_state = 113, .external_lex_state = 2},
  [944] = {.lex_state = 113, .external_lex_state = 2},
  [945] = {.lex_state = 113, .external_lex_state = 2},
  [946] = {.lex_state = 113, .external_lex_state = 2},
  [947] = {.lex_state = 113, .external_lex_state = 2},
  [948] = {.lex_state = 113, .external_lex_state = 2},
  [949] = {.lex_state = 113, .external_lex_state = 2},
  [950] = {.lex_state = 113, .external_lex_state = 2},
  [951] = {.lex_state = 113, .external_lex_state = 2},
  [952] = {.lex_state = 113, .external_lex_state = 2},
  [953] = {.lex_state = 113, .external_lex_state = 2},
  [954] = {.lex_state = 113, .external_lex_state = 2},
  [955] = {.lex_state = 113, .external_lex_state = 2},
  [956] = {.lex_state = 113, .external_lex_state = 2},
  [957] = {.lex_state = 113, .external_lex_state = 2},
  [958] = {.lex_state = 113, .external_lex_state = 2},
  [959] = {.lex_state = 113, .external_lex_state = 2},
  [960] = {.lex_state = 113, .external_lex_state = 2},
  [961] = {.lex_state = 113, .external_lex_state = 2},
  [962] = {.lex_state = 113, .external_lex_state = 2},
  [963] = {.lex_state = 113, .external_lex_state = 2},
  [964] = {.lex_state = 113, .external_lex_state = 2},
  [965] = {.lex_state = 113, .external_lex_state = 2},
  [966] = {.lex_state = 113, .external_lex_state = 2},
  [967] = {.lex_state = 113, .external_lex_state = 2},
  [968] = {.lex_state = 113, .external_lex_state = 2},
  [969] = {.lex_state = 113, .external_lex_state = 2},
  [970] = {.lex_state = 113, .external_lex_state = 2},
  [971] = {.lex_state = 113, .external_lex_state = 2},
  [972] = {.lex_state = 113, .external_lex_state = 2},
  [973] = {.lex_state = 113, .external_lex_state = 2},
  [974] = {.lex_state = 113, .external_lex_state = 2},
  [975] = {.lex_state = 113, .external_lex_state = 2},
  [976] = {.lex_state = 113, .external_lex_state = 2},
  [977] = {.lex_state = 113, .external_lex_state = 2},
  [978] = {.lex_state = 113, .external_lex_state = 2},
  [979] = {.lex_state = 113, .external_lex_state = 2},
  [980] = {.lex_state = 113, .external_lex_state = 2},
  [981] = {.lex_state = 113, .external_lex_state = 2},
  [982] = {.lex_state = 113, .external_lex_state = 2},
  [983] = {.lex_state = 113, .external_lex_state = 2},
  [984] = {.lex_state = 113, .external_lex_state = 2},
  [985] = {.lex_state = 113, .external_lex_state = 2},
  [986] = {.lex_state = 113, .external_lex_state = 2},
  [987] = {.lex_state = 113, .external_lex_state = 2},
  [988] = {.lex_state = 113, .external_lex_state = 2},
  [989] = {.lex_state = 113, .external_lex_state = 2},
  [990] = {.lex_state = 113, .external_lex_state = 2},
  [991] = {.lex_state = 113, .external_lex_state = 2},
  [992] = {.lex_state = 113, .external_lex_state = 2},
  [993] = {.lex_state = 113, .external_lex_state = 2},
  [994] = {.lex_state = 113, .external_lex_state = 2},
  [995] = {.lex_state = 113, .external_lex_state = 2},
  [996] = {.lex_state = 113, .external_lex_state = 2},
  [997] = {.lex_state = 113, .external_lex_state = 2},
  [998] = {.lex_state = 113, .external_lex_state = 2},
  [999] = {.lex_state = 113, .external_lex_state = 2},
  [1000] = {.lex_state = 113, .external_lex_state = 2},
  [1001] = {.lex_state = 113, .external_lex_state = 2},
  [1002] = {.lex_state = 113, .external_lex_state = 2},
  [1003] = {.lex_state = 113, .external_lex_state = 2},
  [1004] = {.lex_state = 113, .external_lex_state = 2},
  [1005] = {.lex_state = 113, .external_lex_state = 2},
  [1006] = {.lex_state = 113, .external_lex_state = 2},
  [1007] = {.lex_state = 113, .external_lex_state = 2},
  [1008] = {.lex_state = 113, .external_lex_state = 2},
  [1009] = {.lex_state = 113, .external_lex_state = 2},
  [1010] = {.lex_state = 113, .external_lex_state = 2},
  [1011] = {.lex_state = 113, .external_lex_state = 2},
  [1012] = {.lex_state = 113, .external_lex_state = 2},
  [1013] = {.lex_state = 113, .external_lex_state = 2},
  [1014] = {.lex_state = 113, .external_lex_state = 2},
  [1015] = {.lex_state = 113, .external_lex_state = 2},
  [1016] = {.lex_state = 113, .external_lex_state = 2},
  [1017] = {.lex_state = 113, .external_lex_state = 2},
  [1018] = {.lex_state = 113, .external_lex_state = 2},
  [1019] = {.lex_state = 113, .external_lex_state = 2},
  [1020] = {.lex_state = 113, .external_lex_state = 2},
  [1021] = {.lex_state = 113, .external_lex_state = 2},
  [1022] = {.lex_state = 113, .external_lex_state = 2},
  [1023] = {.lex_state = 113, .external_lex_state = 2},
  [1024] = {.lex_state = 113, .external_lex_state = 2},
  [1025] = {.lex_state = 113, .external_lex_state = 2},
  [1026] = {.lex_state = 113, .external_lex_state = 2},
  [1027] = {.lex_state = 113, .external_lex_state = 2},
  [1028] = {.lex_state = 113, .external_lex_state = 2},
  [1029] = {.lex_state = 113, .external_lex_state = 2},
  [1030] = {.lex_state = 113, .external_lex_state = 2},
  [1031] = {.lex_state = 113, .external_lex_state = 2},
  [1032] = {.lex_state = 113, .external_lex_state = 2},
  [1033] = {.lex_state = 113, .external_lex_state = 2},
  [1034] = {.lex_state = 113, .external_lex_state = 2},
  [1035] = {.lex_state = 113, .external_lex_state = 2},
  [1036] = {.lex_state = 113, .external_lex_state = 2},
  [1037] = {.lex_state = 113, .external_lex_state = 2},
  [1038] = {.lex_state = 113, .external_lex_state = 2},
  [1039] = {.lex_state = 113, .external_lex_state = 2},
  [1040] = {.lex_state = 113, .external_lex_state = 2},
  [1041] = {.lex_state = 113, .external_lex_state = 2},
  [1042] = {.lex_state = 113, .external_lex_state = 2},
  [1043] = {.lex_state = 113, .external_lex_state = 2},
  [1044] = {.lex_state = 113, .external_lex_state = 2},
  [1045] = {.lex_state = 113, .external_lex_state = 2},
  [1046] = {.lex_state = 113, .external_lex_state = 2},
  [1047] = {.lex_state = 113, .external_lex_state = 2},
  [1048] = {.lex_state = 113, .external_lex_state = 2},
  [1049] = {.lex_state = 113, .external_lex_state = 2},
  [1050] = {.lex_state = 113, .external_lex_state = 2},
  [1051] = {.lex_state = 113, .external_lex_state = 2},
  [1052] = {.lex_state = 113, .external_lex_state = 2},
  [1053] = {.lex_state = 113, .external_lex_state = 2},
  [1054] = {.lex_state = 113, .external_lex_state = 2},
  [1055] = {.lex_state = 113, .external_lex_state = 2},
  [1056] = {.lex_state = 113, .external_lex_state = 2},
  [1057] = {.lex_state = 113, .external_lex_state = 2},
  [1058] = {.lex_state = 113, .external_lex_state = 2},
  [1059] = {.lex_state = 113, .external_lex_state = 2},
  [1060] = {.lex_state = 113, .external_lex_state = 2},
  [1061] = {.lex_state = 113, .external_lex_state = 2},
  [1062] = {.lex_state = 113, .external_lex_state = 2},
  [1063] = {.lex_state = 113, .external_lex_state = 2},
  [1064] = {.lex_state = 113, .external_lex_state = 2},
  [1065] = {.lex_state = 113, .external_lex_state = 2},
  [1066] = {.lex_state = 113, .external_lex_state = 2},
  [1067] = {.lex_state = 113, .external_lex_state = 2},
  [1068] = {.lex_state = 113, .external_lex_state = 2},
  [1069] = {.lex_state = 113, .external_lex_state = 2},
  [1070] = {.lex_state = 113, .external_lex_state = 2},
  [1071] = {.lex_state = 113, .external_lex_state = 2},
  [1072] = {.lex_state = 113, .external_lex_state = 2},
  [1073] = {.lex_state = 113, .external_lex_state = 2},
  [1074] = {.lex_state = 113, .external_lex_state = 2},
  [1075] = {.lex_state = 113, .external_lex_state = 2},
  [1076] = {.lex_state = 113, .external_lex_state = 2},
  [1077] = {.lex_state = 113, .external_lex_state = 2},
  [1078] = {.lex_state = 113, .external_lex_state = 2},
  [1079] = {.lex_state = 113, .external_lex_state = 2},
  [1080] = {.lex_state = 113, .external_lex_state = 2},
  [1081] = {.lex_state = 113, .external_lex_state = 2},
  [1082] = {.lex_state = 113, .external_lex_state = 2},
  [1083] = {.lex_state = 113, .external_lex_state = 2},
  [1084] = {.lex_state = 113, .external_lex_state = 2},
  [1085] = {.lex_state = 113, .external_lex_state = 2},
  [1086] = {.lex_state = 113, .external_lex_state = 2},
  [1087] = {.lex_state = 113, .external_lex_state = 2},
  [1088] = {.lex_state = 113, .external_lex_state = 2},
  [1089] = {.lex_state = 113, .external_lex_state = 2},
  [1090] = {.lex_state = 113, .external_lex_state = 2},
  [1091] = {.lex_state = 113, .external_lex_state = 2},
  [1092] = {.lex_state = 113, .external_lex_state = 2},
  [1093] = {.lex_state = 113, .external_lex_state = 2},
  [1094] = {.lex_state = 113, .external_lex_state = 2},
  [1095] = {.lex_state = 113, .external_lex_state = 2},
  [1096] = {.lex_state = 113, .external_lex_state = 2},
  [1097] = {.lex_state = 113, .external_lex_state = 2},
  [1098] = {.lex_state = 113, .external_lex_state = 2},
  [1099] = {.lex_state = 113, .external_lex_state = 2},
  [1100] = {.lex_state = 113, .external_lex_state = 2},
  [1101] = {.lex_state = 113, .external_lex_state = 2},
  [1102] = {.lex_state = 113, .external_lex_state = 2},
  [1103] = {.lex_state = 113, .external_lex_state = 2},
  [1104] = {.lex_state = 113, .external_lex_state = 2},
  [1105] = {.lex_state = 113, .external_lex_state = 2},
  [1106] = {.lex_state = 113, .external_lex_state = 2},
  [1107] = {.lex_state = 113, .external_lex_state = 2},
  [1108] = {.lex_state = 113, .external_lex_state = 2},
  [1109] = {.lex_state = 113, .external_lex_state = 2},
  [1110] = {.lex_state = 113, .external_lex_state = 2},
  [1111] = {.lex_state = 113, .external_lex_state = 2},
  [1112] = {.lex_state = 113, .external_lex_state = 2},
  [1113] = {.lex_state = 113, .external_lex_state = 2},
  [1114] = {.lex_state = 113, .external_lex_state = 2},
  [1115] = {.lex_state = 113, .external_lex_state = 2},
  [1116] = {.lex_state = 113, .external_lex_state = 2},
  [1117] = {.lex_state = 113, .external_lex_state = 2},
  [1118] = {.lex_state = 113, .external_lex_state = 2},
  [1119] = {.lex_state = 113, .external_lex_state = 2},
  [1120] = {.lex_state = 113, .external_lex_state = 2},
  [1121] = {.lex_state = 113, .external_lex_state = 2},
  [1122] = {.lex_state = 113, .external_lex_state = 2},
  [1123] = {.lex_state = 113, .external_lex_state = 2},
  [1124] = {.lex_state = 113, .external_lex_state = 2},
  [1125] = {.lex_state = 113, .external_lex_state = 2},
  [1126] = {.lex_state = 113, .external_lex_state = 2},
  [1127] = {.lex_state = 113, .external_lex_state = 2},
  [1128] = {.lex_state = 113, .external_lex_state = 2},
  [1129] = {.lex_state = 113, .external_lex_state = 2},
  [1130] = {.lex_state = 113, .external_lex_state = 2},
  [1131] = {.lex_state = 113, .external_lex_state = 2},
  [1132] = {.lex_state = 113, .external_lex_state = 2},
  [1133] = {.lex_state = 113, .external_lex_state = 2},
  [1134] = {.lex_state = 113, .external_lex_state = 2},
  [1135] = {.lex_state = 113, .external_lex_state = 2},
  [1136] = {.lex_state = 113, .external_lex_state = 2},
  [1137] = {.lex_state = 113, .external_lex_state = 2},
  [1138] = {.lex_state = 113, .external_lex_state = 2},
  [1139] = {.lex_state = 113, .external_lex_state = 2},
  [1140] = {.lex_state = 113, .external_lex_state = 2},
  [1141] = {.lex_state = 113, .external_lex_state = 2},
  [1142] = {.lex_state = 113, .external_lex_state = 2},
  [1143] = {.lex_state = 113, .external_lex_state = 2},
  [1144] = {.lex_state = 113, .external_lex_state = 2},
  [1145] = {.lex_state = 113, .external_lex_state = 2},
  [1146] = {.lex_state = 113, .external_lex_state = 2},
  [1147] = {.lex_state = 113, .external_lex_state = 2},
  [1148] = {.lex_state = 113, .external_lex_state = 2},
  [1149] = {.lex_state = 113, .external_lex_state = 2},
  [1150] = {.lex_state = 113, .external_lex_state = 2},
  [1151] = {.lex_state = 113, .external_lex_state = 2},
  [1152] = {.lex_state = 113, .external_lex_state = 2},
  [1153] = {.lex_state = 113, .external_lex_state = 2},
  [1154] = {.lex_state = 113, .external_lex_state = 2},
  [1155] = {.lex_state = 113, .external_lex_state = 2},
  [1156] = {.lex_state = 113, .external_lex_state = 2},
  [1157] = {.lex_state = 113, .external_lex_state = 2},
  [1158] = {.lex_state = 113, .external_lex_state = 2},
  [1159] = {.lex_state = 113, .external_lex_state = 2},
  [1160] = {.lex_state = 113, .external_lex_state = 2},
  [1161] = {.lex_state = 113, .external_lex_state = 2},
  [1162] = {.lex_state = 113, .external_lex_state = 2},
  [1163] = {.lex_state = 113, .external_lex_state = 2},
  [1164] = {.lex_state = 113, .external_lex_state = 2},
  [1165] = {.lex_state = 113, .external_lex_state = 2},
  [1166] = {.lex_state = 113, .external_lex_state = 2},
  [1167] = {.lex_state = 113, .external_lex_state = 2},
  [1168] = {.lex_state = 113, .external_lex_state = 2},
  [1169] = {.lex_state = 113, .external_lex_state = 2},
  [1170] = {.lex_state = 113, .external_lex_state = 2},
  [1171] = {.lex_state = 113, .external_lex_state = 2},
  [1172] = {.lex_state = 113, .external_lex_state = 2},
  [1173] = {.lex_state = 113, .external_lex_state = 2},
  [1174] = {.lex_state = 113, .external_lex_state = 2},
  [1175] = {.lex_state = 113, .external_lex_state = 2},
  [1176] = {.lex_state = 113, .external_lex_state = 2},
  [1177] = {.lex_state = 113, .external_lex_state = 2},
  [1178] = {.lex_state = 113, .external_lex_state = 2},
  [1179] = {.lex_state = 113, .external_lex_state = 2},
  [1180] = {.lex_state = 113, .external_lex_state = 2},
  [1181] = {.lex_state = 113, .external_lex_state = 2},
  [1182] = {.lex_state = 113, .external_lex_state = 2},
  [1183] = {.lex_state = 113, .external_lex_state = 2},
  [1184] = {.lex_state = 113, .external_lex_state = 2},
  [1185] = {.lex_state = 113, .external_lex_state = 2},
  [1186] = {.lex_state = 113, .external_lex_state = 2},
  [1187] = {.lex_state = 113, .external_lex_state = 2},
  [1188] = {.lex_state = 113, .external_lex_state = 2},
  [1189] = {.lex_state = 113, .external_lex_state = 2},
  [1190] = {.lex_state = 113, .external_lex_state = 2},
  [1191] = {.lex_state = 113, .external_lex_state = 2},
  [1192] = {.lex_state = 113, .external_lex_state = 2},
  [1193] = {.lex_state = 113, .external_lex_state = 2},
  [1194] = {.lex_state = 113, .external_lex_state = 2},
  [1195] = {.lex_state = 113, .external_lex_state = 2},
  [1196] = {.lex_state = 113, .external_lex_state = 2},
  [1197] = {.lex_state = 113, .external_lex_state = 2},
  [1198] = {.lex_state = 113, .external_lex_state = 2},
  [1199] = {.lex_state = 113, .external_lex_state = 2},
  [1200] = {.lex_state = 113, .external_lex_state = 2},
  [1201] = {.lex_state = 113, .external_lex_state = 2},
  [1202] = {.lex_state = 113, .external_lex_state = 2},
  [1203] = {.lex_state = 113, .external_lex_state = 2},
  [1204] = {.lex_state = 113, .external_lex_state = 2},
  [1205] = {.lex_state = 113, .external_lex_state = 2},
  [1206] = {.lex_state = 113, .external_lex_state = 2},
  [1207] = {.lex_state = 113, .external_lex_state = 2},
  [1208] = {.lex_state = 113, .external_lex_state = 2},
  [1209] = {.lex_state = 113, .external_lex_state = 2},
  [1210] = {.lex_state = 113, .external_lex_state = 2},
  [1211] = {.lex_state = 113, .external_lex_state = 2},
  [1212] = {.lex_state = 113, .external_lex_state = 2},
  [1213] = {.lex_state = 113, .external_lex_state = 2},
  [1214] = {.lex_state = 113, .external_lex_state = 2},
  [1215] = {.lex_state = 113, .external_lex_state = 2},
  [1216] = {.lex_state = 113, .external_lex_state = 2},
  [1217] = {.lex_state = 113, .external_lex_state = 2},
  [1218] = {.lex_state = 113, .external_lex_state = 2},
  [1219] = {.lex_state = 113, .external_lex_state = 2},
  [1220] = {.lex_state = 113, .external_lex_state = 2},
  [1221] = {.lex_state = 113, .external_lex_state = 2},
  [1222] = {.lex_state = 113, .external_lex_state = 2},
  [1223] = {.lex_state = 113, .external_lex_state = 2},
  [1224] = {.lex_state = 113, .external_lex_state = 2},
  [1225] = {.lex_state = 113, .external_lex_state = 2},
  [1226] = {.lex_state = 113, .external_lex_state = 2},
  [1227] = {.lex_state = 113, .external_lex_state = 2},
  [1228] = {.lex_state = 113, .external_lex_state = 2},
  [1229] = {.lex_state = 113, .external_lex_state = 2},
  [1230] = {.lex_state = 113, .external_lex_state = 2},
  [1231] = {.lex_state = 113, .external_lex_state = 2},
  [1232] = {.lex_state = 113, .external_lex_state = 2},
  [1233] = {.lex_state = 113, .external_lex_state = 2},
  [1234] = {.lex_state = 113, .external_lex_state = 2},
  [1235] = {.lex_state = 113, .external_lex_state = 2},
  [1236] = {.lex_state = 113, .external_lex_state = 2},
  [1237] = {.lex_state = 113, .external_lex_state = 2},
  [1238] = {.lex_state = 113, .external_lex_state = 2},
  [1239] = {.lex_state = 113, .external_lex_state = 2},
  [1240] = {.lex_state = 113, .external_lex_state = 2},
  [1241] = {.lex_state = 113, .external_lex_state = 2},
  [1242] = {.lex_state = 113, .external_lex_state = 2},
  [1243] = {.lex_state = 113, .external_lex_state = 2},
  [1244] = {.lex_state = 113, .external_lex_state = 2},
  [1245] = {.lex_state = 113, .external_lex_state = 2},
  [1246] = {.lex_state = 113, .external_lex_state = 2},
  [1247] = {.lex_state = 113, .external_lex_state = 2},
  [1248] = {.lex_state = 113, .external_lex_state = 2},
  [1249] = {.lex_state = 113, .external_lex_state = 2},
  [1250] = {.lex_state = 113, .external_lex_state = 2},
  [1251] = {.lex_state = 113, .external_lex_state = 2},
  [1252] = {.lex_state = 113, .external_lex_state = 2},
  [1253] = {.lex_state = 113, .external_lex_state = 2},
  [1254] = {.lex_state = 113, .external_lex_state = 2},
  [1255] = {.lex_state = 113, .external_lex_state = 2},
  [1256] = {.lex_state = 113, .external_lex_state = 2},
  [1257] = {.lex_state = 113, .external_lex_state = 2},
  [1258] = {.lex_state = 113, .external_lex_state = 2},
  [1259] = {.lex_state = 113, .external_lex_state = 2},
  [1260] = {.lex_state = 113, .external_lex_state = 2},
  [1261] = {.lex_state = 113, .external_lex_state = 2},
  [1262] = {.lex_state = 113, .external_lex_state = 2},
  [1263] = {.lex_state = 113, .external_lex_state = 2},
  [1264] = {.lex_state = 113, .external_lex_state = 2},
  [1265] = {.lex_state = 113, .external_lex_state = 2},
  [1266] = {.lex_state = 113, .external_lex_state = 2},
  [1267] = {.lex_state = 113, .external_lex_state = 2},
  [1268] = {.lex_state = 113, .external_lex_state = 2},
  [1269] = {.lex_state = 113, .external_lex_state = 2},
  [1270] = {.lex_state = 113, .external_lex_state = 2},
  [1271] = {.lex_state = 113, .external_lex_state = 2},
  [1272] = {.lex_state = 113, .external_lex_state = 2},
  [1273] = {.lex_state = 113, .external_lex_state = 2},
  [1274] = {.lex_state = 113, .external_lex_state = 2},
  [1275] = {.lex_state = 113, .external_lex_state = 2},
  [1276] = {.lex_state = 113, .external_lex_state = 2},
  [1277] = {.lex_state = 113, .external_lex_state = 2},
  [1278] = {.lex_state = 113, .external_lex_state = 2},
  [1279] = {.lex_state = 113, .external_lex_state = 2},
  [1280] = {.lex_state = 113, .external_lex_state = 2},
  [1281] = {.lex_state = 113, .external_lex_state = 2},
  [1282] = {.lex_state = 113, .external_lex_state = 2},
  [1283] = {.lex_state = 113, .external_lex_state = 2},
  [1284] = {.lex_state = 113, .external_lex_state = 2},
  [1285] = {.lex_state = 113, .external_lex_state = 2},
  [1286] = {.lex_state = 113, .external_lex_state = 2},
  [1287] = {.lex_state = 113, .external_lex_state = 2},
  [1288] = {.lex_state = 113, .external_lex_state = 2},
  [1289] = {.lex_state = 113, .external_lex_state = 2},
  [1290] = {.lex_state = 113, .external_lex_state = 2},
  [1291] = {.lex_state = 113, .external_lex_state = 2},
  [1292] = {.lex_state = 113, .external_lex_state = 2},
  [1293] = {.lex_state = 113, .external_lex_state = 2},
  [1294] = {.lex_state = 113, .external_lex_state = 2},
  [1295] = {.lex_state = 113, .external_lex_state = 2},
  [1296] = {.lex_state = 113, .external_lex_state = 2},
  [1297] = {.lex_state = 113, .external_lex_state = 2},
  [1298] = {.lex_state = 113, .external_lex_state = 2},
  [1299] = {.lex_state = 113, .external_lex_state = 2},
  [1300] = {.lex_state = 113, .external_lex_state = 2},
  [1301] = {.lex_state = 113, .external_lex_state = 2},
  [1302] = {.lex_state = 113, .external_lex_state = 2},
  [1303] = {.lex_state = 113, .external_lex_state = 2},
  [1304] = {.lex_state = 113, .external_lex_state = 2},
  [1305] = {.lex_state = 113, .external_lex_state = 2},
  [1306] = {.lex_state = 113, .external_lex_state = 2},
  [1307] = {.lex_state = 113, .external_lex_state = 2},
  [1308] = {.lex_state = 113, .external_lex_state = 2},
  [1309] = {.lex_state = 113, .external_lex_state = 2},
  [1310] = {.lex_state = 113, .external_lex_state = 2},
  [1311] = {.lex_state = 113, .external_lex_state = 2},
  [1312] = {.lex_state = 113, .external_lex_state = 2},
  [1313] = {.lex_state = 113, .external_lex_state = 2},
  [1314] = {.lex_state = 113, .external_lex_state = 2},
  [1315] = {.lex_state = 113, .external_lex_state = 2},
  [1316] = {.lex_state = 113, .external_lex_state = 2},
  [1317] = {.lex_state = 113, .external_lex_state = 2},
  [1318] = {.lex_state = 113, .external_lex_state = 2},
  [1319] = {.lex_state = 113, .external_lex_state = 2},
  [1320] = {.lex_state = 113, .external_lex_state = 2},
  [1321] = {.lex_state = 113, .external_lex_state = 2},
  [1322] = {.lex_state = 113, .external_lex_state = 2},
  [1323] = {.lex_state = 113, .external_lex_state = 2},
  [1324] = {.lex_state = 113, .external_lex_state = 2},
  [1325] = {.lex_state = 113, .external_lex_state = 2},
  [1326] = {.lex_state = 113, .external_lex_state = 2},
  [1327] = {.lex_state = 113, .external_lex_state = 2},
  [1328] = {.lex_state = 113, .external_lex_state = 2},
  [1329] = {.lex_state = 113, .external_lex_state = 2},
  [1330] = {.lex_state = 113, .external_lex_state = 2},
  [1331] = {.lex_state = 113, .external_lex_state = 2},
  [1332] = {.lex_state = 113, .external_lex_state = 2},
  [1333] = {.lex_state = 113, .external_lex_state = 2},
  [1334] = {.lex_state = 113, .external_lex_state = 2},
  [1335] = {.lex_state = 113, .external_lex_state = 2},
  [1336] = {.lex_state = 113, .external_lex_state = 2},
  [1337] = {.lex_state = 113, .external_lex_state = 2},
  [1338] = {.lex_state = 113, .external_lex_state = 2},
  [1339] = {.lex_state = 113, .external_lex_state = 2},
  [1340] = {.lex_state = 113, .external_lex_state = 2},
  [1341] = {.lex_state = 113, .external_lex_state = 2},
  [1342] = {.lex_state = 113, .external_lex_state = 2},
  [1343] = {.lex_state = 113, .external_lex_state = 2},
  [1344] = {.lex_state = 113, .external_lex_state = 2},
  [1345] = {.lex_state = 113, .external_lex_state = 2},
  [1346] = {.lex_state = 113, .external_lex_state = 2},
  [1347] = {.lex_state = 113, .external_lex_state = 2},
  [1348] = {.lex_state = 113, .external_lex_state = 2},
  [1349] = {.lex_state = 113, .external_lex_state = 2},
  [1350] = {.lex_state = 113, .external_lex_state = 2},
  [1351] = {.lex_state = 113, .external_lex_state = 2},
  [1352] = {.lex_state = 113, .external_lex_state = 2},
  [1353] = {.lex_state = 113, .external_lex_state = 2},
  [1354] = {.lex_state = 113, .external_lex_state = 2},
  [1355] = {.lex_state = 113, .external_lex_state = 2},
  [1356] = {.lex_state = 113, .external_lex_state = 2},
  [1357] = {.lex_state = 113, .external_lex_state = 2},
  [1358] = {.lex_state = 113, .external_lex_state = 2},
  [1359] = {.lex_state = 113, .external_lex_state = 2},
  [1360] = {.lex_state = 113, .external_lex_state = 2},
  [1361] = {.lex_state = 113, .external_lex_state = 2},
  [1362] = {.lex_state = 113, .external_lex_state = 2},
  [1363] = {.lex_state = 113, .external_lex_state = 2},
  [1364] = {.lex_state = 113, .external_lex_state = 2},
  [1365] = {.lex_state = 113, .external_lex_state = 2},
  [1366] = {.lex_state = 113, .external_lex_state = 2},
  [1367] = {.lex_state = 113, .external_lex_state = 2},
  [1368] = {.lex_state = 113, .external_lex_state = 2},
  [1369] = {.lex_state = 113, .external_lex_state = 2},
  [1370] = {.lex_state = 113, .external_lex_state = 2},
  [1371] = {.lex_state = 113, .external_lex_state = 2},
  [1372] = {.lex_state = 113, .external_lex_state = 2},
  [1373] = {.lex_state = 113, .external_lex_state = 2},
  [1374] = {.lex_state = 113, .external_lex_state = 2},
  [1375] = {.lex_state = 113, .external_lex_state = 2},
  [1376] = {.lex_state = 113, .external_lex_state = 2},
  [1377] = {.lex_state = 113, .external_lex_state = 2},
  [1378] = {.lex_state = 113, .external_lex_state = 2},
  [1379] = {.lex_state = 113, .external_lex_state = 2},
  [1380] = {.lex_state = 113, .external_lex_state = 2},
  [1381] = {.lex_state = 113, .external_lex_state = 2},
  [1382] = {.lex_state = 113, .external_lex_state = 2},
  [1383] = {.lex_state = 113, .external_lex_state = 2},
  [1384] = {.lex_state = 113, .external_lex_state = 2},
  [1385] = {.lex_state = 113, .external_lex_state = 2},
  [1386] = {.lex_state = 113, .external_lex_state = 2},
  [1387] = {.lex_state = 113, .external_lex_state = 2},
  [1388] = {.lex_state = 113, .external_lex_state = 2},
  [1389] = {.lex_state = 113, .external_lex_state = 2},
  [1390] = {.lex_state = 113, .external_lex_state = 2},
  [1391] = {.lex_state = 113, .external_lex_state = 2},
  [1392] = {.lex_state = 113, .external_lex_state = 2},
  [1393] = {.lex_state = 113, .external_lex_state = 2},
  [1394] = {.lex_state = 113, .external_lex_state = 2},
  [1395] = {.lex_state = 113, .external_lex_state = 2},
  [1396] = {.lex_state = 113, .external_lex_state = 2},
  [1397] = {.lex_state = 113, .external_lex_state = 2},
  [1398] = {.lex_state = 113, .external_lex_state = 2},
  [1399] = {.lex_state = 113, .external_lex_state = 2},
  [1400] = {.lex_state = 113, .external_lex_state = 2},
  [1401] = {.lex_state = 113, .external_lex_state = 2},
  [1402] = {.lex_state = 113, .external_lex_state = 2},
  [1403] = {.lex_state = 113, .external_lex_state = 2},
  [1404] = {.lex_state = 113, .external_lex_state = 2},
  [1405] = {.lex_state = 113, .external_lex_state = 2},
  [1406] = {.lex_state = 113, .external_lex_state = 2},
  [1407] = {.lex_state = 113, .external_lex_state = 2},
  [1408] = {.lex_state = 113, .external_lex_state = 2},
  [1409] = {.lex_state = 113, .external_lex_state = 2},
  [1410] = {.lex_state = 113, .external_lex_state = 2},
  [1411] = {.lex_state = 113, .external_lex_state = 2},
  [1412] = {.lex_state = 113, .external_lex_state = 2},
  [1413] = {.lex_state = 113, .external_lex_state = 2},
  [1414] = {.lex_state = 113, .external_lex_state = 2},
  [1415] = {.lex_state = 113, .external_lex_state = 2},
  [1416] = {.lex_state = 113, .external_lex_state = 2},
  [1417] = {.lex_state = 113, .external_lex_state = 2},
  [1418] = {.lex_state = 113, .external_lex_state = 2},
  [1419] = {.lex_state = 113, .external_lex_state = 2},
  [1420] = {.lex_state = 113, .external_lex_state = 2},
  [1421] = {.lex_state = 113, .external_lex_state = 2},
  [1422] = {.lex_state = 113, .external_lex_state = 2},
  [1423] = {.lex_state = 113, .external_lex_state = 2},
  [1424] = {.lex_state = 113, .external_lex_state = 2},
  [1425] = {.lex_state = 113, .external_lex_state = 2},
  [1426] = {.lex_state = 113, .external_lex_state = 2},
  [1427] = {.lex_state = 113, .external_lex_state = 2},
  [1428] = {.lex_state = 113, .external_lex_state = 2},
  [1429] = {.lex_state = 113, .external_lex_state = 2},
  [1430] = {.lex_state = 113, .external_lex_state = 2},
  [1431] = {.lex_state = 113, .external_lex_state = 2},
  [1432] = {.lex_state = 113, .external_lex_state = 2},
  [1433] = {.lex_state = 113, .external_lex_state = 2},
  [1434] = {.lex_state = 113, .external_lex_state = 2},
  [1435] = {.lex_state = 113, .external_lex_state = 2},
  [1436] = {.lex_state = 113, .external_lex_state = 2},
  [1437] = {.lex_state = 113, .external_lex_state = 2},
  [1438] = {.lex_state = 113, .external_lex_state = 2},
  [1439] = {.lex_state = 113, .external_lex_state = 2},
  [1440] = {.lex_state = 113, .external_lex_state = 2},
  [1441] = {.lex_state = 113, .external_lex_state = 2},
  [1442] = {.lex_state = 113, .external_lex_state = 2},
  [1443] = {.lex_state = 113, .external_lex_state = 2},
  [1444] = {.lex_state = 113, .external_lex_state = 2},
  [1445] = {.lex_state = 113, .external_lex_state = 2},
  [1446] = {.lex_state = 113, .external_lex_state = 2},
  [1447] = {.lex_state = 113, .external_lex_state = 2},
  [1448] = {.lex_state = 113, .external_lex_state = 2},
  [1449] = {.lex_state = 113, .external_lex_state = 2},
  [1450] = {.lex_state = 113, .external_lex_state = 2},
  [1451] = {.lex_state = 113, .external_lex_state = 2},
  [1452] = {.lex_state = 113, .external_lex_state = 2},
  [1453] = {.lex_state = 113, .external_lex_state = 2},
  [1454] = {.lex_state = 113, .external_lex_state = 2},
  [1455] = {.lex_state = 113, .external_lex_state = 2},
  [1456] = {.lex_state = 113, .external_lex_state = 2},
  [1457] = {.lex_state = 113, .external_lex_state = 2},
  [1458] = {.lex_state = 113, .external_lex_state = 2},
  [1459] = {.lex_state = 113, .external_lex_state = 2},
  [1460] = {.lex_state = 113, .external_lex_state = 2},
  [1461] = {.lex_state = 113, .external_lex_state = 2},
  [1462] = {.lex_state = 113, .external_lex_state = 2},
  [1463] = {.lex_state = 113, .external_lex_state = 2},
  [1464] = {.lex_state = 113, .external_lex_state = 2},
  [1465] = {.lex_state = 113, .external_lex_state = 2},
  [1466] = {.lex_state = 113, .external_lex_state = 2},
  [1467] = {.lex_state = 113, .external_lex_state = 2},
  [1468] = {.lex_state = 113, .external_lex_state = 2},
  [1469] = {.lex_state = 113, .external_lex_state = 2},
  [1470] = {.lex_state = 113, .external_lex_state = 2},
  [1471] = {.lex_state = 113, .external_lex_state = 2},
  [1472] = {.lex_state = 113, .external_lex_state = 2},
  [1473] = {.lex_state = 113, .external_lex_state = 2},
  [1474] = {.lex_state = 113, .external_lex_state = 2},
  [1475] = {.lex_state = 113, .external_lex_state = 2},
  [1476] = {.lex_state = 113, .external_lex_state = 2},
  [1477] = {.lex_state = 113, .external_lex_state = 2},
  [1478] = {.lex_state = 113, .external_lex_state = 2},
  [1479] = {.lex_state = 113, .external_lex_state = 2},
  [1480] = {.lex_state = 113, .external_lex_state = 2},
  [1481] = {.lex_state = 113, .external_lex_state = 2},
  [1482] = {.lex_state = 113, .external_lex_state = 2},
  [1483] = {.lex_state = 113, .external_lex_state = 2},
  [1484] = {.lex_state = 113, .external_lex_state = 2},
  [1485] = {.lex_state = 113, .external_lex_state = 2},
  [1486] = {.lex_state = 113, .external_lex_state = 2},
  [1487] = {.lex_state = 113, .external_lex_state = 2},
  [1488] = {.lex_state = 113, .external_lex_state = 2},
  [1489] = {.lex_state = 113, .external_lex_state = 2},
  [1490] = {.lex_state = 113, .external_lex_state = 2},
  [1491] = {.lex_state = 113, .external_lex_state = 2},
  [1492] = {.lex_state = 113, .external_lex_state = 2},
  [1493] = {.lex_state = 113, .external_lex_state = 2},
  [1494] = {.lex_state = 113, .external_lex_state = 2},
  [1495] = {.lex_state = 113, .external_lex_state = 2},
  [1496] = {.lex_state = 113, .external_lex_state = 2},
  [1497] = {.lex_state = 113, .external_lex_state = 2},
  [1498] = {.lex_state = 113, .external_lex_state = 2},
  [1499] = {.lex_state = 113, .external_lex_state = 2},
  [1500] = {.lex_state = 113, .external_lex_state = 2},
  [1501] = {.lex_state = 113, .external_lex_state = 2},
  [1502] = {.lex_state = 113, .external_lex_state = 2},
  [1503] = {.lex_state = 113, .external_lex_state = 2},
  [1504] = {.lex_state = 113, .external_lex_state = 2},
  [1505] = {.lex_state = 113, .external_lex_state = 2},
  [1506] = {.lex_state = 113, .external_lex_state = 2},
  [1507] = {.lex_state = 113, .external_lex_state = 2},
  [1508] = {.lex_state = 113, .external_lex_state = 2},
  [1509] = {.lex_state = 113, .external_lex_state = 2},
  [1510] = {.lex_state = 113, .external_lex_state = 2},
  [1511] = {.lex_state = 113, .external_lex_state = 2},
  [1512] = {.lex_state = 113, .external_lex_state = 2},
  [1513] = {.lex_state = 113, .external_lex_state = 2},
  [1514] = {.lex_state = 113, .external_lex_state = 2},
  [1515] = {.lex_state = 113, .external_lex_state = 2},
  [1516] = {.lex_state = 113, .external_lex_state = 2},
  [1517] = {.lex_state = 113, .external_lex_state = 2},
  [1518] = {.lex_state = 113, .external_lex_state = 2},
  [1519] = {.lex_state = 113, .external_lex_state = 2},
  [1520] = {.lex_state = 113, .external_lex_state = 2},
  [1521] = {.lex_state = 113, .external_lex_state = 2},
  [1522] = {.lex_state = 113, .external_lex_state = 2},
  [1523] = {.lex_state = 113, .external_lex_state = 2},
  [1524] = {.lex_state = 113, .external_lex_state = 2},
  [1525] = {.lex_state = 113, .external_lex_state = 2},
  [1526] = {.lex_state = 113, .external_lex_state = 2},
  [1527] = {.lex_state = 113, .external_lex_state = 2},
  [1528] = {.lex_state = 113, .external_lex_state = 2},
  [1529] = {.lex_state = 113, .external_lex_state = 2},
  [1530] = {.lex_state = 113, .external_lex_state = 2},
  [1531] = {.lex_state = 113, .external_lex_state = 2},
  [1532] = {.lex_state = 113, .external_lex_state = 2},
  [1533] = {.lex_state = 113, .external_lex_state = 2},
  [1534] = {.lex_state = 113, .external_lex_state = 2},
  [1535] = {.lex_state = 113, .external_lex_state = 2},
  [1536] = {.lex_state = 113, .external_lex_state = 2},
  [1537] = {.lex_state = 113, .external_lex_state = 2},
  [1538] = {.lex_state = 113, .external_lex_state = 2},
  [1539] = {.lex_state = 113, .external_lex_state = 2},
  [1540] = {.lex_state = 113, .external_lex_state = 2},
  [1541] = {.lex_state = 113, .external_lex_state = 2},
  [1542] = {.lex_state = 113, .external_lex_state = 2},
  [1543] = {.lex_state = 113, .external_lex_state = 2},
  [1544] = {.lex_state = 113, .external_lex_state = 2},
  [1545] = {.lex_state = 113, .external_lex_state = 2},
  [1546] = {.lex_state = 113, .external_lex_state = 2},
  [1547] = {.lex_state = 113, .external_lex_state = 2},
  [1548] = {.lex_state = 113, .external_lex_state = 2},
  [1549] = {.lex_state = 113, .external_lex_state = 2},
  [1550] = {.lex_state = 113, .external_lex_state = 2},
  [1551] = {.lex_state = 113, .external_lex_state = 2},
  [1552] = {.lex_state = 113, .external_lex_state = 2},
  [1553] = {.lex_state = 113, .external_lex_state = 2},
  [1554] = {.lex_state = 113, .external_lex_state = 2},
  [1555] = {.lex_state = 113, .external_lex_state = 2},
  [1556] = {.lex_state = 113, .external_lex_state = 2},
  [1557] = {.lex_state = 113, .external_lex_state = 2},
  [1558] = {.lex_state = 113, .external_lex_state = 2},
  [1559] = {.lex_state = 113, .external_lex_state = 2},
  [1560] = {.lex_state = 113, .external_lex_state = 2},
  [1561] = {.lex_state = 113, .external_lex_state = 2},
  [1562] = {.lex_state = 113, .external_lex_state = 2},
  [1563] = {.lex_state = 113, .external_lex_state = 2},
  [1564] = {.lex_state = 113, .external_lex_state = 2},
  [1565] = {.lex_state = 113, .external_lex_state = 2},
  [1566] = {.lex_state = 113, .external_lex_state = 2},
  [1567] = {.lex_state = 113, .external_lex_state = 2},
  [1568] = {.lex_state = 113, .external_lex_state = 2},
  [1569] = {.lex_state = 113, .external_lex_state = 2},
  [1570] = {.lex_state = 113, .external_lex_state = 2},
  [1571] = {.lex_state = 113, .external_lex_state = 2},
  [1572] = {.lex_state = 113, .external_lex_state = 2},
  [1573] = {.lex_state = 113, .external_lex_state = 2},
  [1574] = {.lex_state = 113, .external_lex_state = 2},
  [1575] = {.lex_state = 113, .external_lex_state = 2},
  [1576] = {.lex_state = 113, .external_lex_state = 2},
  [1577] = {.lex_state = 113, .external_lex_state = 2},
  [1578] = {.lex_state = 113, .external_lex_state = 2},
  [1579] = {.lex_state = 113, .external_lex_state = 2},
  [1580] = {.lex_state = 113, .external_lex_state = 2},
  [1581] = {.lex_state = 113, .external_lex_state = 2},
  [1582] = {.lex_state = 113, .external_lex_state = 2},
  [1583] = {.lex_state = 113, .external_lex_state = 2},
  [1584] = {.lex_state = 113, .external_lex_state = 2},
  [1585] = {.lex_state = 113, .external_lex_state = 2},
  [1586] = {.lex_state = 113, .external_lex_state = 2},
  [1587] = {.lex_state = 113, .external_lex_state = 2},
  [1588] = {.lex_state = 113, .external_lex_state = 2},
  [1589] = {.lex_state = 113, .external_lex_state = 2},
  [1590] = {.lex_state = 113, .external_lex_state = 2},
  [1591] = {.lex_state = 113, .external_lex_state = 2},
  [1592] = {.lex_state = 113, .external_lex_state = 2},
  [1593] = {.lex_state = 113, .external_lex_state = 2},
  [1594] = {.lex_state = 113, .external_lex_state = 2},
  [1595] = {.lex_state = 113, .external_lex_state = 2},
  [1596] = {.lex_state = 113, .external_lex_state = 2},
  [1597] = {.lex_state = 113, .external_lex_state = 2},
  [1598] = {.lex_state = 113, .external_lex_state = 2},
  [1599] = {.lex_state = 113, .external_lex_state = 2},
  [1600] = {.lex_state = 113, .external_lex_state = 2},
  [1601] = {.lex_state = 113, .external_lex_state = 2},
  [1602] = {.lex_state = 113, .external_lex_state = 2},
  [1603] = {.lex_state = 113, .external_lex_state = 2},
  [1604] = {.lex_state = 113, .external_lex_state = 2},
  [1605] = {.lex_state = 113, .external_lex_state = 2},
  [1606] = {.lex_state = 113, .external_lex_state = 2},
  [1607] = {.lex_state = 113, .external_lex_state = 2},
  [1608] = {.lex_state = 113, .external_lex_state = 2},
  [1609] = {.lex_state = 113, .external_lex_state = 2},
  [1610] = {.lex_state = 113, .external_lex_state = 2},
  [1611] = {.lex_state = 113, .external_lex_state = 2},
  [1612] = {.lex_state = 113, .external_lex_state = 2},
  [1613] = {.lex_state = 113, .external_lex_state = 2},
  [1614] = {.lex_state = 113, .external_lex_state = 2},
  [1615] = {.lex_state = 113, .external_lex_state = 2},
  [1616] = {.lex_state = 113, .external_lex_state = 2},
  [1617] = {.lex_state = 113, .external_lex_state = 2},
  [1618] = {.lex_state = 113, .external_lex_state = 2},
  [1619] = {.lex_state = 113, .external_lex_state = 2},
  [1620] = {.lex_state = 113, .external_lex_state = 2},
  [1621] = {.lex_state = 113, .external_lex_state = 2},
  [1622] = {.lex_state = 113, .external_lex_state = 2},
  [1623] = {.lex_state = 113, .external_lex_state = 2},
  [1624] = {.lex_state = 113, .external_lex_state = 2},
  [1625] = {.lex_state = 113, .external_lex_state = 2},
  [1626] = {.lex_state = 113, .external_lex_state = 2},
  [1627] = {.lex_state = 113, .external_lex_state = 2},
  [1628] = {.lex_state = 113, .external_lex_state = 2},
  [1629] = {.lex_state = 113, .external_lex_state = 2},
  [1630] = {.lex_state = 113, .external_lex_state = 2},
  [1631] = {.lex_state = 113, .external_lex_state = 2},
  [1632] = {.lex_state = 113, .external_lex_state = 2},
  [1633] = {.lex_state = 113, .external_lex_state = 2},
  [1634] = {.lex_state = 113, .external_lex_state = 2},
  [1635] = {.lex_state = 113, .external_lex_state = 2},
  [1636] = {.lex_state = 113, .external_lex_state = 2},
  [1637] = {.lex_state = 113, .external_lex_state = 2},
  [1638] = {.lex_state = 113, .external_lex_state = 2},
  [1639] = {.lex_state = 113, .external_lex_state = 2},
  [1640] = {.lex_state = 113, .external_lex_state = 2},
  [1641] = {.lex_state = 113, .external_lex_state = 2},
  [1642] = {.lex_state = 113, .external_lex_state = 2},
  [1643] = {.lex_state = 113, .external_lex_state = 2},
  [1644] = {.lex_state = 113, .external_lex_state = 2},
  [1645] = {.lex_state = 113, .external_lex_state = 2},
  [1646] = {.lex_state = 113, .external_lex_state = 2},
  [1647] = {.lex_state = 113, .external_lex_state = 2},
  [1648] = {.lex_state = 113, .external_lex_state = 2},
  [1649] = {.lex_state = 113, .external_lex_state = 2},
  [1650] = {.lex_state = 113, .external_lex_state = 2},
  [1651] = {.lex_state = 113, .external_lex_state = 2},
  [1652] = {.lex_state = 113, .external_lex_state = 2},
  [1653] = {.lex_state = 113, .external_lex_state = 2},
  [1654] = {.lex_state = 113, .external_lex_state = 2},
  [1655] = {.lex_state = 113, .external_lex_state = 2},
  [1656] = {.lex_state = 113, .external_lex_state = 2},
  [1657] = {.lex_state = 113, .external_lex_state = 2},
  [1658] = {.lex_state = 113, .external_lex_state = 2},
  [1659] = {.lex_state = 113, .external_lex_state = 2},
  [1660] = {.lex_state = 113, .external_lex_state = 2},
  [1661] = {.lex_state = 113, .external_lex_state = 2},
  [1662] = {.lex_state = 113, .external_lex_state = 2},
  [1663] = {.lex_state = 113, .external_lex_state = 2},
  [1664] = {.lex_state = 113, .external_lex_state = 2},
  [1665] = {.lex_state = 113, .external_lex_state = 2},
  [1666] = {.lex_state = 113, .external_lex_state = 2},
  [1667] = {.lex_state = 113, .external_lex_state = 2},
  [1668] = {.lex_state = 113, .external_lex_state = 2},
  [1669] = {.lex_state = 113, .external_lex_state = 2},
  [1670] = {.lex_state = 113, .external_lex_state = 2},
  [1671] = {.lex_state = 113, .external_lex_state = 2},
  [1672] = {.lex_state = 113, .external_lex_state = 2},
  [1673] = {.lex_state = 113, .external_lex_state = 2},
  [1674] = {.lex_state = 113, .external_lex_state = 2},
  [1675] = {.lex_state = 113, .external_lex_state = 2},
  [1676] = {.lex_state = 113, .external_lex_state = 2},
  [1677] = {.lex_state = 113, .external_lex_state = 2},
  [1678] = {.lex_state = 113, .external_lex_state = 2},
  [1679] = {.lex_state = 113, .external_lex_state = 2},
  [1680] = {.lex_state = 113, .external_lex_state = 2},
  [1681] = {.lex_state = 113, .external_lex_state = 2},
  [1682] = {.lex_state = 113, .external_lex_state = 2},
  [1683] = {.lex_state = 113, .external_lex_state = 2},
  [1684] = {.lex_state = 113, .external_lex_state = 2},
  [1685] = {.lex_state = 113, .external_lex_state = 2},
  [1686] = {.lex_state = 113, .external_lex_state = 2},
  [1687] = {.lex_state = 113, .external_lex_state = 2},
  [1688] = {.lex_state = 113, .external_lex_state = 2},
  [1689] = {.lex_state = 113, .external_lex_state = 2},
  [1690] = {.lex_state = 113, .external_lex_state = 2},
  [1691] = {.lex_state = 113, .external_lex_state = 2},
  [1692] = {.lex_state = 113, .external_lex_state = 2},
  [1693] = {.lex_state = 113, .external_lex_state = 2},
  [1694] = {.lex_state = 113, .external_lex_state = 2},
  [1695] = {.lex_state = 113, .external_lex_state = 2},
  [1696] = {.lex_state = 113, .external_lex_state = 2},
  [1697] = {.lex_state = 113, .external_lex_state = 2},
  [1698] = {.lex_state = 113, .external_lex_state = 2},
  [1699] = {.lex_state = 113, .external_lex_state = 2},
  [1700] = {.lex_state = 113, .external_lex_state = 2},
  [1701] = {.lex_state = 113, .external_lex_state = 2},
  [1702] = {.lex_state = 113, .external_lex_state = 2},
  [1703] = {.lex_state = 113, .external_lex_state = 2},
  [1704] = {.lex_state = 113, .external_lex_state = 2},
  [1705] = {.lex_state = 113, .external_lex_state = 2},
  [1706] = {.lex_state = 113, .external_lex_state = 2},
  [1707] = {.lex_state = 113, .external_lex_state = 2},
  [1708] = {.lex_state = 113, .external_lex_state = 2},
  [1709] = {.lex_state = 113, .external_lex_state = 2},
  [1710] = {.lex_state = 113, .external_lex_state = 2},
  [1711] = {.lex_state = 113, .external_lex_state = 2},
  [1712] = {.lex_state = 113, .external_lex_state = 2},
  [1713] = {.lex_state = 113, .external_lex_state = 2},
  [1714] = {.lex_state = 113, .external_lex_state = 2},
  [1715] = {.lex_state = 113, .external_lex_state = 2},
  [1716] = {.lex_state = 113, .external_lex_state = 2},
  [1717] = {.lex_state = 113, .external_lex_state = 2},
  [1718] = {.lex_state = 113, .external_lex_state = 2},
  [1719] = {.lex_state = 113, .external_lex_state = 2},
  [1720] = {.lex_state = 113, .external_lex_state = 2},
  [1721] = {.lex_state = 113, .external_lex_state = 2},
  [1722] = {.lex_state = 113, .external_lex_state = 2},
  [1723] = {.lex_state = 113, .external_lex_state = 2},
  [1724] = {.lex_state = 113, .external_lex_state = 2},
  [1725] = {.lex_state = 113, .external_lex_state = 2},
  [1726] = {.lex_state = 113, .external_lex_state = 2},
  [1727] = {.lex_state = 113, .external_lex_state = 2},
  [1728] = {.lex_state = 113, .external_lex_state = 2},
  [1729] = {.lex_state = 113, .external_lex_state = 2},
  [1730] = {.lex_state = 113, .external_lex_state = 2},
  [1731] = {.lex_state = 113, .external_lex_state = 2},
  [1732] = {.lex_state = 113, .external_lex_state = 2},
  [1733] = {.lex_state = 113, .external_lex_state = 2},
  [1734] = {.lex_state = 113, .external_lex_state = 2},
  [1735] = {.lex_state = 113, .external_lex_state = 2},
  [1736] = {.lex_state = 113, .external_lex_state = 2},
  [1737] = {.lex_state = 113, .external_lex_state = 2},
  [1738] = {.lex_state = 113, .external_lex_state = 2},
  [1739] = {.lex_state = 113, .external_lex_state = 2},
  [1740] = {.lex_state = 113, .external_lex_state = 2},
  [1741] = {.lex_state = 113, .external_lex_state = 2},
  [1742] = {.lex_state = 113, .external_lex_state = 2},
  [1743] = {.lex_state = 113, .external_lex_state = 2},
  [1744] = {.lex_state = 113, .external_lex_state = 2},
  [1745] = {.lex_state = 113, .external_lex_state = 2},
  [1746] = {.lex_state = 113, .external_lex_state = 2},
  [1747] = {.lex_state = 113, .external_lex_state = 2},
  [1748] = {.lex_state = 113, .external_lex_state = 2},
  [1749] = {.lex_state = 113, .external_lex_state = 2},
  [1750] = {.lex_state = 113, .external_lex_state = 2},
  [1751] = {.lex_state = 113, .external_lex_state = 2},
  [1752] = {.lex_state = 113, .external_lex_state = 2},
  [1753] = {.lex_state = 113, .external_lex_state = 2},
  [1754] = {.lex_state = 113, .external_lex_state = 2},
  [1755] = {.lex_state = 113, .external_lex_state = 2},
  [1756] = {.lex_state = 113, .external_lex_state = 2},
  [1757] = {.lex_state = 113, .external_lex_state = 2},
  [1758] = {.lex_state = 113, .external_lex_state = 2},
  [1759] = {.lex_state = 113, .external_lex_state = 2},
  [1760] = {.lex_state = 113, .external_lex_state = 2},
  [1761] = {.lex_state = 113, .external_lex_state = 2},
  [1762] = {.lex_state = 113, .external_lex_state = 2},
  [1763] = {.lex_state = 113, .external_lex_state = 2},
  [1764] = {.lex_state = 113, .external_lex_state = 2},
  [1765] = {.lex_state = 113, .external_lex_state = 2},
  [1766] = {.lex_state = 113, .external_lex_state = 2},
  [1767] = {.lex_state = 113, .external_lex_state = 2},
  [1768] = {.lex_state = 113, .external_lex_state = 2},
  [1769] = {.lex_state = 113, .external_lex_state = 2},
  [1770] = {.lex_state = 113, .external_lex_state = 2},
  [1771] = {.lex_state = 113, .external_lex_state = 2},
  [1772] = {.lex_state = 113, .external_lex_state = 2},
  [1773] = {.lex_state = 113, .external_lex_state = 2},
  [1774] = {.lex_state = 113, .external_lex_state = 2},
  [1775] = {.lex_state = 113, .external_lex_state = 2},
  [1776] = {.lex_state = 113, .external_lex_state = 2},
  [1777] = {.lex_state = 113, .external_lex_state = 2},
  [1778] = {.lex_state = 113, .external_lex_state = 2},
  [1779] = {.lex_state = 113, .external_lex_state = 2},
  [1780] = {.lex_state = 113, .external_lex_state = 2},
  [1781] = {.lex_state = 113, .external_lex_state = 2},
  [1782] = {.lex_state = 113, .external_lex_state = 2},
  [1783] = {.lex_state = 113, .external_lex_state = 2},
  [1784] = {.lex_state = 113, .external_lex_state = 2},
  [1785] = {.lex_state = 113, .external_lex_state = 2},
  [1786] = {.lex_state = 113, .external_lex_state = 2},
  [1787] = {.lex_state = 113, .external_lex_state = 2},
  [1788] = {.lex_state = 113, .external_lex_state = 2},
  [1789] = {.lex_state = 113, .external_lex_state = 2},
  [1790] = {.lex_state = 113, .external_lex_state = 2},
  [1791] = {.lex_state = 113, .external_lex_state = 2},
  [1792] = {.lex_state = 113, .external_lex_state = 2},
  [1793] = {.lex_state = 113, .external_lex_state = 2},
  [1794] = {.lex_state = 113, .external_lex_state = 2},
  [1795] = {.lex_state = 113, .external_lex_state = 2},
  [1796] = {.lex_state = 113, .external_lex_state = 2},
  [1797] = {.lex_state = 113, .external_lex_state = 2},
  [1798] = {.lex_state = 113, .external_lex_state = 2},
  [1799] = {.lex_state = 113, .external_lex_state = 2},
  [1800] = {.lex_state = 113, .external_lex_state = 2},
  [1801] = {.lex_state = 113, .external_lex_state = 2},
  [1802] = {.lex_state = 113, .external_lex_state = 2},
  [1803] = {.lex_state = 113, .external_lex_state = 2},
  [1804] = {.lex_state = 113, .external_lex_state = 2},
  [1805] = {.lex_state = 113, .external_lex_state = 2},
  [1806] = {.lex_state = 113, .external_lex_state = 2},
  [1807] = {.lex_state = 113, .external_lex_state = 2},
  [1808] = {.lex_state = 113, .external_lex_state = 2},
  [1809] = {.lex_state = 113, .external_lex_state = 2},
  [1810] = {.lex_state = 113, .external_lex_state = 2},
  [1811] = {.lex_state = 113, .external_lex_state = 2},
  [1812] = {.lex_state = 113, .external_lex_state = 2},
  [1813] = {.lex_state = 113, .external_lex_state = 2},
  [1814] = {.lex_state = 113, .external_lex_state = 2},
  [1815] = {.lex_state = 113, .external_lex_state = 2},
  [1816] = {.lex_state = 113, .external_lex_state = 2},
  [1817] = {.lex_state = 113, .external_lex_state = 2},
  [1818] = {.lex_state = 113, .external_lex_state = 2},
  [1819] = {.lex_state = 113, .external_lex_state = 2},
  [1820] = {.lex_state = 113, .external_lex_state = 2},
  [1821] = {.lex_state = 113, .external_lex_state = 2},
  [1822] = {.lex_state = 113, .external_lex_state = 2},
  [1823] = {.lex_state = 113, .external_lex_state = 2},
  [1824] = {.lex_state = 113, .external_lex_state = 2},
  [1825] = {.lex_state = 113, .external_lex_state = 2},
  [1826] = {.lex_state = 113, .external_lex_state = 2},
  [1827] = {.lex_state = 113, .external_lex_state = 2},
  [1828] = {.lex_state = 113, .external_lex_state = 2},
  [1829] = {.lex_state = 113, .external_lex_state = 2},
  [1830] = {.lex_state = 113, .external_lex_state = 2},
  [1831] = {.lex_state = 113, .external_lex_state = 2},
  [1832] = {.lex_state = 113, .external_lex_state = 2},
  [1833] = {.lex_state = 113, .external_lex_state = 2},
  [1834] = {.lex_state = 113, .external_lex_state = 2},
  [1835] = {.lex_state = 113, .external_lex_state = 2},
  [1836] = {.lex_state = 113, .external_lex_state = 2},
  [1837] = {.lex_state = 113, .external_lex_state = 2},
  [1838] = {.lex_state = 113, .external_lex_state = 2},
  [1839] = {.lex_state = 113, .external_lex_state = 2},
  [1840] = {.lex_state = 113, .external_lex_state = 2},
  [1841] = {.lex_state = 113, .external_lex_state = 2},
  [1842] = {.lex_state = 113, .external_lex_state = 2},
  [1843] = {.lex_state = 113, .external_lex_state = 2},
  [1844] = {.lex_state = 113, .external_lex_state = 2},
  [1845] = {.lex_state = 113, .external_lex_state = 2},
  [1846] = {.lex_state = 113, .external_lex_state = 2},
  [1847] = {.lex_state = 113, .external_lex_state = 2},
  [1848] = {.lex_state = 113, .external_lex_state = 2},
  [1849] = {.lex_state = 113, .external_lex_state = 2},
  [1850] = {.lex_state = 113, .external_lex_state = 2},
  [1851] = {.lex_state = 113, .external_lex_state = 2},
  [1852] = {.lex_state = 113, .external_lex_state = 2},
  [1853] = {.lex_state = 113, .external_lex_state = 2},
  [1854] = {.lex_state = 113, .external_lex_state = 2},
  [1855] = {.lex_state = 113, .external_lex_state = 2},
  [1856] = {.lex_state = 113, .external_lex_state = 2},
  [1857] = {.lex_state = 113, .external_lex_state = 2},
  [1858] = {.lex_state = 113, .external_lex_state = 2},
  [1859] = {.lex_state = 113, .external_lex_state = 2},
  [1860] = {.lex_state = 113, .external_lex_state = 2},
  [1861] = {.lex_state = 113, .external_lex_state = 2},
  [1862] = {.lex_state = 113, .external_lex_state = 2},
  [1863] = {.lex_state = 113, .external_lex_state = 2},
  [1864] = {.lex_state = 113, .external_lex_state = 2},
  [1865] = {.lex_state = 113, .external_lex_state = 2},
  [1866] = {.lex_state = 113, .external_lex_state = 2},
  [1867] = {.lex_state = 113, .external_lex_state = 2},
  [1868] = {.lex_state = 113, .external_lex_state = 2},
  [1869] = {.lex_state = 113, .external_lex_state = 2},
  [1870] = {.lex_state = 113, .external_lex_state = 2},
  [1871] = {.lex_state = 113, .external_lex_state = 2},
  [1872] = {.lex_state = 113, .external_lex_state = 2},
  [1873] = {.lex_state = 113, .external_lex_state = 2},
  [1874] = {.lex_state = 113, .external_lex_state = 2},
  [1875] = {.lex_state = 113, .external_lex_state = 2},
  [1876] = {.lex_state = 113, .external_lex_state = 2},
  [1877] = {.lex_state = 113, .external_lex_state = 2},
  [1878] = {.lex_state = 113, .external_lex_state = 2},
  [1879] = {.lex_state = 113, .external_lex_state = 2},
  [1880] = {.lex_state = 113, .external_lex_state = 2},
  [1881] = {.lex_state = 113, .external_lex_state = 2},
  [1882] = {.lex_state = 113, .external_lex_state = 2},
  [1883] = {.lex_state = 113, .external_lex_state = 2},
  [1884] = {.lex_state = 113, .external_lex_state = 2},
  [1885] = {.lex_state = 113, .external_lex_state = 2},
  [1886] = {.lex_state = 113, .external_lex_state = 2},
  [1887] = {.lex_state = 113, .external_lex_state = 2},
  [1888] = {.lex_state = 113, .external_lex_state = 2},
  [1889] = {.lex_state = 113, .external_lex_state = 2},
  [1890] = {.lex_state = 113, .external_lex_state = 2},
  [1891] = {.lex_state = 113, .external_lex_state = 2},
  [1892] = {.lex_state = 113, .external_lex_state = 2},
  [1893] = {.lex_state = 113, .external_lex_state = 2},
  [1894] = {.lex_state = 113, .external_lex_state = 2},
  [1895] = {.lex_state = 113, .external_lex_state = 2},
  [1896] = {.lex_state = 113, .external_lex_state = 2},
  [1897] = {.lex_state = 113, .external_lex_state = 2},
  [1898] = {.lex_state = 113, .external_lex_state = 2},
  [1899] = {.lex_state = 113, .external_lex_state = 2},
  [1900] = {.lex_state = 113, .external_lex_state = 2},
  [1901] = {.lex_state = 113, .external_lex_state = 2},
  [1902] = {.lex_state = 113, .external_lex_state = 2},
  [1903] = {.lex_state = 113, .external_lex_state = 2},
  [1904] = {.lex_state = 113, .external_lex_state = 2},
  [1905] = {.lex_state = 113, .external_lex_state = 2},
  [1906] = {.lex_state = 113, .external_lex_state = 2},
  [1907] = {.lex_state = 113, .external_lex_state = 2},
  [1908] = {.lex_state = 113, .external_lex_state = 2},
  [1909] = {.lex_state = 113, .external_lex_state = 2},
  [1910] = {.lex_state = 113, .external_lex_state = 2},
  [1911] = {.lex_state = 113, .external_lex_state = 2},
  [1912] = {.lex_state = 113, .external_lex_state = 2},
  [1913] = {.lex_state = 113, .external_lex_state = 2},
  [1914] = {.lex_state = 113, .external_lex_state = 2},
  [1915] = {.lex_state = 113, .external_lex_state = 2},
  [1916] = {.lex_state = 113, .external_lex_state = 2},
  [1917] = {.lex_state = 113, .external_lex_state = 2},
  [1918] = {.lex_state = 113, .external_lex_state = 2},
  [1919] = {.lex_state = 113, .external_lex_state = 2},
  [1920] = {.lex_state = 113, .external_lex_state = 2},
  [1921] = {.lex_state = 113, .external_lex_state = 2},
  [1922] = {.lex_state = 113, .external_lex_state = 2},
  [1923] = {.lex_state = 113, .external_lex_state = 2},
  [1924] = {.lex_state = 113, .external_lex_state = 2},
  [1925] = {.lex_state = 113, .external_lex_state = 2},
  [1926] = {.lex_state = 113, .external_lex_state = 2},
  [1927] = {.lex_state = 113, .external_lex_state = 2},
  [1928] = {.lex_state = 113, .external_lex_state = 2},
  [1929] = {.lex_state = 113, .external_lex_state = 2},
  [1930] = {.lex_state = 113, .external_lex_state = 2},
  [1931] = {.lex_state = 113, .external_lex_state = 2},
  [1932] = {.lex_state = 113, .external_lex_state = 2},
  [1933] = {.lex_state = 113, .external_lex_state = 2},
  [1934] = {.lex_state = 113, .external_lex_state = 2},
  [1935] = {.lex_state = 113, .external_lex_state = 2},
  [1936] = {.lex_state = 113, .external_lex_state = 2},
  [1937] = {.lex_state = 113, .external_lex_state = 2},
  [1938] = {.lex_state = 113, .external_lex_state = 2},
  [1939] = {.lex_state = 113, .external_lex_state = 2},
  [1940] = {.lex_state = 113, .external_lex_state = 2},
  [1941] = {.lex_state = 113, .external_lex_state = 2},
  [1942] = {.lex_state = 113, .external_lex_state = 2},
  [1943] = {.lex_state = 113, .external_lex_state = 2},
  [1944] = {.lex_state = 113, .external_lex_state = 2},
  [1945] = {.lex_state = 113, .external_lex_state = 2},
  [1946] = {.lex_state = 113, .external_lex_state = 2},
  [1947] = {.lex_state = 113, .external_lex_state = 2},
  [1948] = {.lex_state = 113, .external_lex_state = 2},
  [1949] = {.lex_state = 113, .external_lex_state = 2},
  [1950] = {.lex_state = 113, .external_lex_state = 2},
  [1951] = {.lex_state = 113, .external_lex_state = 2},
  [1952] = {.lex_state = 113, .external_lex_state = 2},
  [1953] = {.lex_state = 113, .external_lex_state = 2},
  [1954] = {.lex_state = 113, .external_lex_state = 2},
  [1955] = {.lex_state = 113, .external_lex_state = 2},
  [1956] = {.lex_state = 113, .external_lex_state = 2},
  [1957] = {.lex_state = 113, .external_lex_state = 2},
  [1958] = {.lex_state = 113, .external_lex_state = 2},
  [1959] = {.lex_state = 113, .external_lex_state = 2},
  [1960] = {.lex_state = 113, .external_lex_state = 2},
  [1961] = {.lex_state = 113, .external_lex_state = 2},
  [1962] = {.lex_state = 113, .external_lex_state = 2},
  [1963] = {.lex_state = 113, .external_lex_state = 2},
  [1964] = {.lex_state = 113, .external_lex_state = 2},
  [1965] = {.lex_state = 113, .external_lex_state = 2},
  [1966] = {.lex_state = 113, .external_lex_state = 2},
  [1967] = {.lex_state = 113, .external_lex_state = 2},
  [1968] = {.lex_state = 113, .external_lex_state = 2},
  [1969] = {.lex_state = 113, .external_lex_state = 2},
  [1970] = {.lex_state = 113, .external_lex_state = 2},
  [1971] = {.lex_state = 113, .external_lex_state = 2},
  [1972] = {.lex_state = 113, .external_lex_state = 2},
  [1973] = {.lex_state = 113, .external_lex_state = 2},
  [1974] = {.lex_state = 113, .external_lex_state = 2},
  [1975] = {.lex_state = 113, .external_lex_state = 2},
  [1976] = {.lex_state = 113, .external_lex_state = 2},
  [1977] = {.lex_state = 113, .external_lex_state = 2},
  [1978] = {.lex_state = 113, .external_lex_state = 2},
  [1979] = {.lex_state = 113, .external_lex_state = 2},
  [1980] = {.lex_state = 113, .external_lex_state = 2},
  [1981] = {.lex_state = 113, .external_lex_state = 2},
  [1982] = {.lex_state = 113, .external_lex_state = 2},
  [1983] = {.lex_state = 113, .external_lex_state = 2},
  [1984] = {.lex_state = 113, .external_lex_state = 2},
  [1985] = {.lex_state = 113, .external_lex_state = 2},
  [1986] = {.lex_state = 113, .external_lex_state = 2},
  [1987] = {.lex_state = 113, .external_lex_state = 2},
  [1988] = {.lex_state = 113, .external_lex_state = 2},
  [1989] = {.lex_state = 113, .external_lex_state = 2},
  [1990] = {.lex_state = 113, .external_lex_state = 2},
  [1991] = {.lex_state = 113, .external_lex_state = 2},
  [1992] = {.lex_state = 113, .external_lex_state = 2},
  [1993] = {.lex_state = 113, .external_lex_state = 2},
  [1994] = {.lex_state = 113, .external_lex_state = 2},
  [1995] = {.lex_state = 113, .external_lex_state = 2},
  [1996] = {.lex_state = 113, .external_lex_state = 2},
  [1997] = {.lex_state = 113, .external_lex_state = 2},
  [1998] = {.lex_state = 113, .external_lex_state = 2},
  [1999] = {.lex_state = 113, .external_lex_state = 2},
  [2000] = {.lex_state = 113, .external_lex_state = 2},
  [2001] = {.lex_state = 113, .external_lex_state = 2},
  [2002] = {.lex_state = 113, .external_lex_state = 2},
  [2003] = {.lex_state = 113, .external_lex_state = 2},
  [2004] = {.lex_state = 113, .external_lex_state = 2},
  [2005] = {.lex_state = 113, .external_lex_state = 2},
  [2006] = {.lex_state = 113, .external_lex_state = 2},
  [2007] = {.lex_state = 113, .external_lex_state = 2},
  [2008] = {.lex_state = 113, .external_lex_state = 2},
  [2009] = {.lex_state = 113, .external_lex_state = 2},
  [2010] = {.lex_state = 113, .external_lex_state = 2},
  [2011] = {.lex_state = 113, .external_lex_state = 2},
  [2012] = {.lex_state = 113, .external_lex_state = 2},
  [2013] = {.lex_state = 113, .external_lex_state = 2},
  [2014] = {.lex_state = 113, .external_lex_state = 2},
  [2015] = {.lex_state = 113, .external_lex_state = 2},
  [2016] = {.lex_state = 113, .external_lex_state = 2},
  [2017] = {.lex_state = 113, .external_lex_state = 2},
  [2018] = {.lex_state = 113, .external_lex_state = 2},
  [2019] = {.lex_state = 113, .external_lex_state = 2},
  [2020] = {.lex_state = 113, .external_lex_state = 2},
  [2021] = {.lex_state = 113, .external_lex_state = 2},
  [2022] = {.lex_state = 113, .external_lex_state = 2},
  [2023] = {.lex_state = 113, .external_lex_state = 2},
  [2024] = {.lex_state = 113, .external_lex_state = 2},
  [2025] = {.lex_state = 113, .external_lex_state = 2},
  [2026] = {.lex_state = 113, .external_lex_state = 2},
  [2027] = {.lex_state = 113, .external_lex_state = 2},
  [2028] = {.lex_state = 113, .external_lex_state = 2},
  [2029] = {.lex_state = 113, .external_lex_state = 2},
  [2030] = {.lex_state = 113, .external_lex_state = 2},
  [2031] = {.lex_state = 113, .external_lex_state = 2},
  [2032] = {.lex_state = 113, .external_lex_state = 2},
  [2033] = {.lex_state = 113, .external_lex_state = 2},
  [2034] = {.lex_state = 113, .external_lex_state = 2},
  [2035] = {.lex_state = 113, .external_lex_state = 2},
  [2036] = {.lex_state = 113, .external_lex_state = 2},
  [2037] = {.lex_state = 113, .external_lex_state = 2},
  [2038] = {.lex_state = 113, .external_lex_state = 2},
  [2039] = {.lex_state = 113, .external_lex_state = 2},
  [2040] = {.lex_state = 113, .external_lex_state = 2},
  [2041] = {.lex_state = 113, .external_lex_state = 2},
  [2042] = {.lex_state = 113, .external_lex_state = 2},
  [2043] = {.lex_state = 113, .external_lex_state = 2},
  [2044] = {.lex_state = 113, .external_lex_state = 2},
  [2045] = {.lex_state = 113, .external_lex_state = 2},
  [2046] = {.lex_state = 113, .external_lex_state = 2},
  [2047] = {.lex_state = 113, .external_lex_state = 2},
  [2048] = {.lex_state = 113, .external_lex_state = 2},
  [2049] = {.lex_state = 113, .external_lex_state = 2},
  [2050] = {.lex_state = 113, .external_lex_state = 2},
  [2051] = {.lex_state = 113, .external_lex_state = 2},
  [2052] = {.lex_state = 113, .external_lex_state = 2},
  [2053] = {.lex_state = 113, .external_lex_state = 2},
  [2054] = {.lex_state = 113, .external_lex_state = 2},
  [2055] = {.lex_state = 113, .external_lex_state = 2},
  [2056] = {.lex_state = 113, .external_lex_state = 2},
  [2057] = {.lex_state = 113, .external_lex_state = 2},
  [2058] = {.lex_state = 113, .external_lex_state = 2},
  [2059] = {.lex_state = 113, .external_lex_state = 2},
  [2060] = {.lex_state = 113, .external_lex_state = 2},
  [2061] = {.lex_state = 113, .external_lex_state = 2},
  [2062] = {.lex_state = 113, .external_lex_state = 2},
  [2063] = {.lex_state = 113, .external_lex_state = 2},
  [2064] = {.lex_state = 113, .external_lex_state = 2},
  [2065] = {.lex_state = 113, .external_lex_state = 2},
  [2066] = {.lex_state = 113, .external_lex_state = 2},
  [2067] = {.lex_state = 113, .external_lex_state = 2},
  [2068] = {.lex_state = 113, .external_lex_state = 2},
  [2069] = {.lex_state = 113, .external_lex_state = 2},
  [2070] = {.lex_state = 113, .external_lex_state = 2},
  [2071] = {.lex_state = 113, .external_lex_state = 2},
  [2072] = {.lex_state = 113, .external_lex_state = 2},
  [2073] = {.lex_state = 113, .external_lex_state = 2},
  [2074] = {.lex_state = 113, .external_lex_state = 2},
  [2075] = {.lex_state = 113, .external_lex_state = 2},
  [2076] = {.lex_state = 113, .external_lex_state = 2},
  [2077] = {.lex_state = 113, .external_lex_state = 2},
  [2078] = {.lex_state = 113, .external_lex_state = 2},
  [2079] = {.lex_state = 113, .external_lex_state = 2},
  [2080] = {.lex_state = 113, .external_lex_state = 2},
  [2081] = {.lex_state = 113, .external_lex_state = 2},
  [2082] = {.lex_state = 113, .external_lex_state = 2},
  [2083] = {.lex_state = 113, .external_lex_state = 2},
  [2084] = {.lex_state = 113, .external_lex_state = 2},
  [2085] = {.lex_state = 113, .external_lex_state = 2},
  [2086] = {.lex_state = 113, .external_lex_state = 2},
  [2087] = {.lex_state = 113, .external_lex_state = 2},
  [2088] = {.lex_state = 113, .external_lex_state = 2},
  [2089] = {.lex_state = 113, .external_lex_state = 2},
  [2090] = {.lex_state = 113, .external_lex_state = 2},
  [2091] = {.lex_state = 113, .external_lex_state = 2},
  [2092] = {.lex_state = 113, .external_lex_state = 2},
  [2093] = {.lex_state = 113, .external_lex_state = 2},
  [2094] = {.lex_state = 113, .external_lex_state = 2},
  [2095] = {.lex_state = 113, .external_lex_state = 2},
  [2096] = {.lex_state = 113, .external_lex_state = 2},
  [2097] = {.lex_state = 113, .external_lex_state = 2},
  [2098] = {.lex_state = 113, .external_lex_state = 2},
  [2099] = {.lex_state = 113, .external_lex_state = 2},
  [2100] = {.lex_state = 113, .external_lex_state = 2},
  [2101] = {.lex_state = 113, .external_lex_state = 2},
  [2102] = {.lex_state = 113, .external_lex_state = 2},
  [2103] = {.lex_state = 113, .external_lex_state = 2},
  [2104] = {.lex_state = 113, .external_lex_state = 2},
  [2105] = {.lex_state = 113, .external_lex_state = 2},
  [2106] = {.lex_state = 113, .external_lex_state = 2},
  [2107] = {.lex_state = 113, .external_lex_state = 2},
  [2108] = {.lex_state = 113, .external_lex_state = 2},
  [2109] = {.lex_state = 113, .external_lex_state = 2},
  [2110] = {.lex_state = 113, .external_lex_state = 2},
  [2111] = {.lex_state = 113, .external_lex_state = 2},
  [2112] = {.lex_state = 113, .external_lex_state = 2},
  [2113] = {.lex_state = 113, .external_lex_state = 2},
  [2114] = {.lex_state = 113, .external_lex_state = 2},
  [2115] = {.lex_state = 113, .external_lex_state = 2},
  [2116] = {.lex_state = 113, .external_lex_state = 2},
  [2117] = {.lex_state = 113, .external_lex_state = 2},
  [2118] = {.lex_state = 113, .external_lex_state = 2},
  [2119] = {.lex_state = 113, .external_lex_state = 2},
  [2120] = {.lex_state = 113, .external_lex_state = 2},
  [2121] = {.lex_state = 113, .external_lex_state = 2},
  [2122] = {.lex_state = 113, .external_lex_state = 2},
  [2123] = {.lex_state = 113, .external_lex_state = 2},
  [2124] = {.lex_state = 113, .external_lex_state = 2},
  [2125] = {.lex_state = 113, .external_lex_state = 2},
  [2126] = {.lex_state = 113, .external_lex_state = 2},
  [2127] = {.lex_state = 113, .external_lex_state = 2},
  [2128] = {.lex_state = 113, .external_lex_state = 2},
  [2129] = {.lex_state = 113, .external_lex_state = 2},
  [2130] = {.lex_state = 113, .external_lex_state = 2},
  [2131] = {.lex_state = 113, .external_lex_state = 2},
  [2132] = {.lex_state = 113, .external_lex_state = 2},
  [2133] = {.lex_state = 113, .external_lex_state = 2},
  [2134] = {.lex_state = 113, .external_lex_state = 2},
  [2135] = {.lex_state = 113, .external_lex_state = 2},
  [2136] = {.lex_state = 113, .external_lex_state = 2},
  [2137] = {.lex_state = 113, .external_lex_state = 2},
  [2138] = {.lex_state = 113, .external_lex_state = 2},
  [2139] = {.lex_state = 113, .external_lex_state = 2},
  [2140] = {.lex_state = 113, .external_lex_state = 2},
  [2141] = {.lex_state = 113, .external_lex_state = 2},
  [2142] = {.lex_state = 113, .external_lex_state = 2},
  [2143] = {.lex_state = 113, .external_lex_state = 2},
  [2144] = {.lex_state = 113, .external_lex_state = 2},
  [2145] = {.lex_state = 113, .external_lex_state = 2},
  [2146] = {.lex_state = 113, .external_lex_state = 2},
  [2147] = {.lex_state = 113, .external_lex_state = 2},
  [2148] = {.lex_state = 113, .external_lex_state = 2},
  [2149] = {.lex_state = 113, .external_lex_state = 2},
  [2150] = {.lex_state = 113, .external_lex_state = 2},
  [2151] = {.lex_state = 113, .external_lex_state = 2},
  [2152] = {.lex_state = 113, .external_lex_state = 2},
  [2153] = {.lex_state = 113, .external_lex_state = 2},
  [2154] = {.lex_state = 113, .external_lex_state = 2},
  [2155] = {.lex_state = 113, .external_lex_state = 2},
  [2156] = {.lex_state = 113, .external_lex_state = 2},
  [2157] = {.lex_state = 113, .external_lex_state = 2},
  [2158] = {.lex_state = 113, .external_lex_state = 2},
  [2159] = {.lex_state = 113, .external_lex_state = 2},
  [2160] = {.lex_state = 113, .external_lex_state = 2},
  [2161] = {.lex_state = 113, .external_lex_state = 2},
  [2162] = {.lex_state = 113, .external_lex_state = 2},
  [2163] = {.lex_state = 113, .external_lex_state = 2},
  [2164] = {.lex_state = 113, .external_lex_state = 2},
  [2165] = {.lex_state = 113, .external_lex_state = 2},
  [2166] = {.lex_state = 113, .external_lex_state = 2},
  [2167] = {.lex_state = 113, .external_lex_state = 2},
  [2168] = {.lex_state = 113, .external_lex_state = 2},
  [2169] = {.lex_state = 113, .external_lex_state = 2},
  [2170] = {.lex_state = 113, .external_lex_state = 2},
  [2171] = {.lex_state = 113, .external_lex_state = 2},
  [2172] = {.lex_state = 113, .external_lex_state = 2},
  [2173] = {.lex_state = 113, .external_lex_state = 2},
  [2174] = {.lex_state = 113, .external_lex_state = 2},
  [2175] = {.lex_state = 113, .external_lex_state = 2},
  [2176] = {.lex_state = 113, .external_lex_state = 2},
  [2177] = {.lex_state = 113, .external_lex_state = 2},
  [2178] = {.lex_state = 113, .external_lex_state = 2},
  [2179] = {.lex_state = 113, .external_lex_state = 2},
  [2180] = {.lex_state = 113, .external_lex_state = 2},
  [2181] = {.lex_state = 113, .external_lex_state = 2},
  [2182] = {.lex_state = 113, .external_lex_state = 2},
  [2183] = {.lex_state = 113, .external_lex_state = 2},
  [2184] = {.lex_state = 113, .external_lex_state = 2},
  [2185] = {.lex_state = 113, .external_lex_state = 2},
  [2186] = {.lex_state = 113, .external_lex_state = 2},
  [2187] = {.lex_state = 113, .external_lex_state = 2},
  [2188] = {.lex_state = 113, .external_lex_state = 2},
  [2189] = {.lex_state = 113, .external_lex_state = 2},
  [2190] = {.lex_state = 113, .external_lex_state = 2},
  [2191] = {.lex_state = 113, .external_lex_state = 2},
  [2192] = {.lex_state = 112, .external_lex_state = 2},
  [2193] = {.lex_state = 112, .external_lex_state = 2},
  [2194] = {.lex_state = 112, .external_lex_state = 2},
  [2195] = {.lex_state = 112, .external_lex_state = 2},
  [2196] = {.lex_state = 112, .external_lex_state = 2},
  [2197] = {.lex_state = 112, .external_lex_state = 2},
  [2198] = {.lex_state = 113, .external_lex_state = 2},
  [2199] = {.lex_state = 113, .external_lex_state = 2},
  [2200] = {.lex_state = 113, .external_lex_state = 2},
  [2201] = {.lex_state = 113, .external_lex_state = 2},
  [2202] = {.lex_state = 113, .external_lex_state = 2},
  [2203] = {.lex_state = 113, .external_lex_state = 2},
  [2204] = {.lex_state = 113, .external_lex_state = 2},
  [2205] = {.lex_state = 113, .external_lex_state = 2},
  [2206] = {.lex_state = 113, .external_lex_state = 2},
  [2207] = {.lex_state = 113, .external_lex_state = 2},
  [2208] = {.lex_state = 113, .external_lex_state = 2},
  [2209] = {.lex_state = 113, .external_lex_state = 2},
  [2210] = {.lex_state = 0},
  [2211] = {.lex_state = 0},
  [2212] = {.lex_state = 0},
  [2213] = {.lex_state = 0},
  [2214] = {.lex_state = 113, .external_lex_state = 2},
  [2215] = {.lex_state = 113, .external_lex_state = 2},
  [2216] = {.lex_state = 113, .external_lex_state = 2},
  [2217] = {.lex_state = 113, .external_lex_state = 2},
  [2218] = {.lex_state = 113, .external_lex_state = 2},
  [2219] = {.lex_state = 113, .external_lex_state = 2},
  [2220] = {.lex_state = 113, .external_lex_state = 2},
  [2221] = {.lex_state = 113, .external_lex_state = 2},
  [2222] = {.lex_state = 113, .external_lex_state = 2},
  [2223] = {.lex_state = 113, .external_lex_state = 2},
  [2224] = {.lex_state = 113, .external_lex_state = 2},
  [2225] = {.lex_state = 113, .external_lex_state = 2},
  [2226] = {.lex_state = 113, .external_lex_state = 2},
  [2227] = {.lex_state = 113, .external_lex_state = 2},
  [2228] = {.lex_state = 113, .external_lex_state = 2},
  [2229] = {.lex_state = 113, .external_lex_state = 2},
  [2230] = {.lex_state = 113, .external_lex_state = 2},
  [2231] = {.lex_state = 113, .external_lex_state = 2},
  [2232] = {.lex_state = 113, .external_lex_state = 2},
  [2233] = {.lex_state = 0},
  [2234] = {.lex_state = 113, .external_lex_state = 2},
  [2235] = {.lex_state = 113, .external_lex_state = 2},
  [2236] = {.lex_state = 113, .external_lex_state = 2},
  [2237] = {.lex_state = 113, .external_lex_state = 2},
  [2238] = {.lex_state = 113, .external_lex_state = 2},
  [2239] = {.lex_state = 113, .external_lex_state = 2},
  [2240] = {.lex_state = 113, .external_lex_state = 2},
  [2241] = {.lex_state = 113, .external_lex_state = 2},
  [2242] = {.lex_state = 113, .external_lex_state = 2},
  [2243] = {.lex_state = 113, .external_lex_state = 2},
  [2244] = {.lex_state = 113, .external_lex_state = 2},
  [2245] = {.lex_state = 113, .external_lex_state = 2},
  [2246] = {.lex_state = 113, .external_lex_state = 2},
  [2247] = {.lex_state = 113, .external_lex_state = 2},
  [2248] = {.lex_state = 113, .external_lex_state = 2},
  [2249] = {.lex_state = 113, .external_lex_state = 2},
  [2250] = {.lex_state = 113, .external_lex_state = 2},
  [2251] = {.lex_state = 113, .external_lex_state = 2},
  [2252] = {.lex_state = 113, .external_lex_state = 2},
  [2253] = {.lex_state = 113, .external_lex_state = 2},
  [2254] = {.lex_state = 113, .external_lex_state = 2},
  [2255] = {.lex_state = 113, .external_lex_state = 2},
  [2256] = {.lex_state = 113, .external_lex_state = 2},
  [2257] = {.lex_state = 113, .external_lex_state = 2},
  [2258] = {.lex_state = 113, .external_lex_state = 2},
  [2259] = {.lex_state = 113, .external_lex_state = 2},
  [2260] = {.lex_state = 113, .external_lex_state = 2},
  [2261] = {.lex_state = 113, .external_lex_state = 2},
  [2262] = {.lex_state = 113, .external_lex_state = 2},
  [2263] = {.lex_state = 113, .external_lex_state = 2},
  [2264] = {.lex_state = 113, .external_lex_state = 2},
  [2265] = {.lex_state = 113, .external_lex_state = 2},
  [2266] = {.lex_state = 113, .external_lex_state = 2},
  [2267] = {.lex_state = 113, .external_lex_state = 2},
  [2268] = {.lex_state = 113, .external_lex_state = 2},
  [2269] = {.lex_state = 113, .external_lex_state = 2},
  [2270] = {.lex_state = 113, .external_lex_state = 2},
  [2271] = {.lex_state = 113, .external_lex_state = 2},
  [2272] = {.lex_state = 113, .external_lex_state = 2},
  [2273] = {.lex_state = 113, .external_lex_state = 2},
  [2274] = {.lex_state = 113, .external_lex_state = 2},
  [2275] = {.lex_state = 113, .external_lex_state = 2},
  [2276] = {.lex_state = 113, .external_lex_state = 2},
  [2277] = {.lex_state = 113, .external_lex_state = 2},
  [2278] = {.lex_state = 113, .external_lex_state = 2},
  [2279] = {.lex_state = 113, .external_lex_state = 2},
  [2280] = {.lex_state = 113, .external_lex_state = 2},
  [2281] = {.lex_state = 113, .external_lex_state = 2},
  [2282] = {.lex_state = 113, .external_lex_state = 2},
  [2283] = {.lex_state = 113, .external_lex_state = 2},
  [2284] = {.lex_state = 113, .external_lex_state = 2},
  [2285] = {.lex_state = 113, .external_lex_state = 2},
  [2286] = {.lex_state = 113, .external_lex_state = 2},
  [2287] = {.lex_state = 113, .external_lex_state = 2},
  [2288] = {.lex_state = 113, .external_lex_state = 2},
  [2289] = {.lex_state = 113, .external_lex_state = 2},
  [2290] = {.lex_state = 113, .external_lex_state = 2},
  [2291] = {.lex_state = 113, .external_lex_state = 2},
  [2292] = {.lex_state = 113, .external_lex_state = 2},
  [2293] = {.lex_state = 113, .external_lex_state = 2},
  [2294] = {.lex_state = 113, .external_lex_state = 2},
  [2295] = {.lex_state = 113, .external_lex_state = 2},
  [2296] = {.lex_state = 113, .external_lex_state = 2},
  [2297] = {.lex_state = 113, .external_lex_state = 2},
  [2298] = {.lex_state = 113, .external_lex_state = 2},
  [2299] = {.lex_state = 113, .external_lex_state = 2},
  [2300] = {.lex_state = 113, .external_lex_state = 2},
  [2301] = {.lex_state = 113, .external_lex_state = 2},
  [2302] = {.lex_state = 113, .external_lex_state = 2},
  [2303] = {.lex_state = 113, .external_lex_state = 2},
  [2304] = {.lex_state = 113, .external_lex_state = 2},
  [2305] = {.lex_state = 113, .external_lex_state = 2},
  [2306] = {.lex_state = 113, .external_lex_state = 2},
  [2307] = {.lex_state = 113, .external_lex_state = 2},
  [2308] = {.lex_state = 113, .external_lex_state = 2},
  [2309] = {.lex_state = 113, .external_lex_state = 2},
  [2310] = {.lex_state = 113, .external_lex_state = 2},
  [2311] = {.lex_state = 113, .external_lex_state = 2},
  [2312] = {.lex_state = 113, .external_lex_state = 2},
  [2313] = {.lex_state = 113, .external_lex_state = 2},
  [2314] = {.lex_state = 113, .external_lex_state = 2},
  [2315] = {.lex_state = 113, .external_lex_state = 2},
  [2316] = {.lex_state = 113, .external_lex_state = 2},
  [2317] = {.lex_state = 113, .external_lex_state = 2},
  [2318] = {.lex_state = 113, .external_lex_state = 2},
  [2319] = {.lex_state = 113, .external_lex_state = 2},
  [2320] = {.lex_state = 113, .external_lex_state = 2},
  [2321] = {.lex_state = 113, .external_lex_state = 2},
  [2322] = {.lex_state = 113, .external_lex_state = 2},
  [2323] = {.lex_state = 113, .external_lex_state = 2},
  [2324] = {.lex_state = 113, .external_lex_state = 2},
  [2325] = {.lex_state = 113, .external_lex_state = 2},
  [2326] = {.lex_state = 113, .external_lex_state = 2},
  [2327] = {.lex_state = 113, .external_lex_state = 2},
  [2328] = {.lex_state = 113, .external_lex_state = 2},
  [2329] = {.lex_state = 113, .external_lex_state = 2},
  [2330] = {.lex_state = 113, .external_lex_state = 2},
  [2331] = {.lex_state = 113, .external_lex_state = 2},
  [2332] = {.lex_state = 113, .external_lex_state = 2},
  [2333] = {.lex_state = 113, .external_lex_state = 2},
  [2334] = {.lex_state = 113, .external_lex_state = 2},
  [2335] = {.lex_state = 113, .external_lex_state = 2},
  [2336] = {.lex_state = 113, .external_lex_state = 2},
  [2337] = {.lex_state = 113, .external_lex_state = 2},
  [2338] = {.lex_state = 113, .external_lex_state = 2},
  [2339] = {.lex_state = 113, .external_lex_state = 2},
  [2340] = {.lex_state = 113, .external_lex_state = 2},
  [2341] = {.lex_state = 113, .external_lex_state = 2},
  [2342] = {.lex_state = 113, .external_lex_state = 2},
  [2343] = {.lex_state = 113, .external_lex_state = 2},
  [2344] = {.lex_state = 113, .external_lex_state = 2},
  [2345] = {.lex_state = 113, .external_lex_state = 2},
  [2346] = {.lex_state = 113, .external_lex_state = 2},
  [2347] = {.lex_state = 113, .external_lex_state = 2},
  [2348] = {.lex_state = 113, .external_lex_state = 2},
  [2349] = {.lex_state = 113, .external_lex_state = 2},
  [2350] = {.lex_state = 113, .external_lex_state = 2},
  [2351] = {.lex_state = 113, .external_lex_state = 2},
  [2352] = {.lex_state = 113, .external_lex_state = 2},
  [2353] = {.lex_state = 113, .external_lex_state = 2},
  [2354] = {.lex_state = 113, .external_lex_state = 2},
  [2355] = {.lex_state = 113, .external_lex_state = 2},
  [2356] = {.lex_state = 113, .external_lex_state = 2},
  [2357] = {.lex_state = 113, .external_lex_state = 2},
  [2358] = {.lex_state = 113, .external_lex_state = 2},
  [2359] = {.lex_state = 113, .external_lex_state = 2},
  [2360] = {.lex_state = 113, .external_lex_state = 2},
  [2361] = {.lex_state = 113, .external_lex_state = 2},
  [2362] = {.lex_state = 113, .external_lex_state = 2},
  [2363] = {.lex_state = 113, .external_lex_state = 2},
  [2364] = {.lex_state = 113, .external_lex_state = 2},
  [2365] = {.lex_state = 113, .external_lex_state = 2},
  [2366] = {.lex_state = 113, .external_lex_state = 2},
  [2367] = {.lex_state = 113, .external_lex_state = 2},
  [2368] = {.lex_state = 113, .external_lex_state = 2},
  [2369] = {.lex_state = 113, .external_lex_state = 2},
  [2370] = {.lex_state = 113, .external_lex_state = 2},
  [2371] = {.lex_state = 113, .external_lex_state = 2},
  [2372] = {.lex_state = 0},
  [2373] = {.lex_state = 113, .external_lex_state = 2},
  [2374] = {.lex_state = 113, .external_lex_state = 2},
  [2375] = {.lex_state = 113, .external_lex_state = 2},
  [2376] = {.lex_state = 113, .external_lex_state = 2},
  [2377] = {.lex_state = 113, .external_lex_state = 2},
  [2378] = {.lex_state = 113, .external_lex_state = 2},
  [2379] = {.lex_state = 113, .external_lex_state = 2},
  [2380] = {.lex_state = 113, .external_lex_state = 2},
  [2381] = {.lex_state = 113, .external_lex_state = 2},
  [2382] = {.lex_state = 113, .external_lex_state = 2},
  [2383] = {.lex_state = 113, .external_lex_state = 2},
  [2384] = {.lex_state = 113, .external_lex_state = 2},
  [2385] = {.lex_state = 113, .external_lex_state = 2},
  [2386] = {.lex_state = 113, .external_lex_state = 2},
  [2387] = {.lex_state = 113, .external_lex_state = 2},
  [2388] = {.lex_state = 113, .external_lex_state = 2},
  [2389] = {.lex_state = 113, .external_lex_state = 2},
  [2390] = {.lex_state = 113, .external_lex_state = 2},
  [2391] = {.lex_state = 113, .external_lex_state = 2},
  [2392] = {.lex_state = 113, .external_lex_state = 2},
  [2393] = {.lex_state = 113, .external_lex_state = 2},
  [2394] = {.lex_state = 113, .external_lex_state = 2},
  [2395] = {.lex_state = 113, .external_lex_state = 2},
  [2396] = {.lex_state = 113, .external_lex_state = 2},
  [2397] = {.lex_state = 113, .external_lex_state = 2},
  [2398] = {.lex_state = 113, .external_lex_state = 2},
  [2399] = {.lex_state = 113, .external_lex_state = 2},
  [2400] = {.lex_state = 113, .external_lex_state = 2},
  [2401] = {.lex_state = 113, .external_lex_state = 2},
  [2402] = {.lex_state = 113, .external_lex_state = 2},
  [2403] = {.lex_state = 113, .external_lex_state = 2},
  [2404] = {.lex_state = 113, .external_lex_state = 2},
  [2405] = {.lex_state = 113, .external_lex_state = 2},
  [2406] = {.lex_state = 113, .external_lex_state = 2},
  [2407] = {.lex_state = 113, .external_lex_state = 2},
  [2408] = {.lex_state = 113, .external_lex_state = 2},
  [2409] = {.lex_state = 113, .external_lex_state = 2},
  [2410] = {.lex_state = 113, .external_lex_state = 2},
  [2411] = {.lex_state = 113, .external_lex_state = 2},
  [2412] = {.lex_state = 113, .external_lex_state = 2},
  [2413] = {.lex_state = 113, .external_lex_state = 2},
  [2414] = {.lex_state = 113, .external_lex_state = 2},
  [2415] = {.lex_state = 113, .external_lex_state = 2},
  [2416] = {.lex_state = 113, .external_lex_state = 2},
  [2417] = {.lex_state = 113, .external_lex_state = 2},
  [2418] = {.lex_state = 113, .external_lex_state = 2},
  [2419] = {.lex_state = 113, .external_lex_state = 2},
  [2420] = {.lex_state = 113, .external_lex_state = 2},
  [2421] = {.lex_state = 113, .external_lex_state = 2},
  [2422] = {.lex_state = 113, .external_lex_state = 2},
  [2423] = {.lex_state = 113, .external_lex_state = 2},
  [2424] = {.lex_state = 113, .external_lex_state = 2},
  [2425] = {.lex_state = 113, .external_lex_state = 2},
  [2426] = {.lex_state = 113, .external_lex_state = 2},
  [2427] = {.lex_state = 113, .external_lex_state = 2},
  [2428] = {.lex_state = 113, .external_lex_state = 2},
  [2429] = {.lex_state = 113, .external_lex_state = 2},
  [2430] = {.lex_state = 113, .external_lex_state = 2},
  [2431] = {.lex_state = 113, .external_lex_state = 2},
  [2432] = {.lex_state = 113, .external_lex_state = 2},
  [2433] = {.lex_state = 113, .external_lex_state = 2},
  [2434] = {.lex_state = 113, .external_lex_state = 2},
  [2435] = {.lex_state = 113, .external_lex_state = 2},
  [2436] = {.lex_state = 113, .external_lex_state = 2},
  [2437] = {.lex_state = 113, .external_lex_state = 2},
  [2438] = {.lex_state = 113, .external_lex_state = 2},
  [2439] = {.lex_state = 113, .external_lex_state = 2},
  [2440] = {.lex_state = 113, .external_lex_state = 2},
  [2441] = {.lex_state = 113, .external_lex_state = 2},
  [2442] = {.lex_state = 113, .external_lex_state = 2},
  [2443] = {.lex_state = 113, .external_lex_state = 2},
  [2444] = {.lex_state = 113, .external_lex_state = 2},
  [2445] = {.lex_state = 113, .external_lex_state = 2},
  [2446] = {.lex_state = 113, .external_lex_state = 2},
  [2447] = {.lex_state = 113, .external_lex_state = 2},
  [2448] = {.lex_state = 113, .external_lex_state = 2},
  [2449] = {.lex_state = 113, .external_lex_state = 2},
  [2450] = {.lex_state = 113, .external_lex_state = 2},
  [2451] = {.lex_state = 113, .external_lex_state = 2},
  [2452] = {.lex_state = 113, .external_lex_state = 2},
  [2453] = {.lex_state = 113, .external_lex_state = 2},
  [2454] = {.lex_state = 113, .external_lex_state = 2},
  [2455] = {.lex_state = 113, .external_lex_state = 2},
  [2456] = {.lex_state = 113, .external_lex_state = 2},
  [2457] = {.lex_state = 113, .external_lex_state = 2},
  [2458] = {.lex_state = 113, .external_lex_state = 2},
  [2459] = {.lex_state = 113, .external_lex_state = 2},
  [2460] = {.lex_state = 113, .external_lex_state = 2},
  [2461] = {.lex_state = 113, .external_lex_state = 2},
  [2462] = {.lex_state = 113, .external_lex_state = 2},
  [2463] = {.lex_state = 113, .external_lex_state = 2},
  [2464] = {.lex_state = 113, .external_lex_state = 2},
  [2465] = {.lex_state = 113, .external_lex_state = 2},
  [2466] = {.lex_state = 113, .external_lex_state = 2},
  [2467] = {.lex_state = 113, .external_lex_state = 2},
  [2468] = {.lex_state = 113, .external_lex_state = 2},
  [2469] = {.lex_state = 113, .external_lex_state = 2},
  [2470] = {.lex_state = 113, .external_lex_state = 2},
  [2471] = {.lex_state = 113, .external_lex_state = 2},
  [2472] = {.lex_state = 113, .external_lex_state = 2},
  [2473] = {.lex_state = 113, .external_lex_state = 2},
  [2474] = {.lex_state = 113, .external_lex_state = 2},
  [2475] = {.lex_state = 113, .external_lex_state = 2},
  [2476] = {.lex_state = 113, .external_lex_state = 2},
  [2477] = {.lex_state = 113, .external_lex_state = 2},
  [2478] = {.lex_state = 113, .external_lex_state = 2},
  [2479] = {.lex_state = 113, .external_lex_state = 2},
  [2480] = {.lex_state = 113, .external_lex_state = 2},
  [2481] = {.lex_state = 113, .external_lex_state = 2},
  [2482] = {.lex_state = 113, .external_lex_state = 2},
  [2483] = {.lex_state = 113, .external_lex_state = 2},
  [2484] = {.lex_state = 113, .external_lex_state = 2},
  [2485] = {.lex_state = 113, .external_lex_state = 2},
  [2486] = {.lex_state = 113, .external_lex_state = 2},
  [2487] = {.lex_state = 113, .external_lex_state = 2},
  [2488] = {.lex_state = 113, .external_lex_state = 2},
  [2489] = {.lex_state = 113, .external_lex_state = 2},
  [2490] = {.lex_state = 113, .external_lex_state = 2},
  [2491] = {.lex_state = 113, .external_lex_state = 2},
  [2492] = {.lex_state = 113, .external_lex_state = 2},
  [2493] = {.lex_state = 113, .external_lex_state = 2},
  [2494] = {.lex_state = 113, .external_lex_state = 2},
  [2495] = {.lex_state = 113, .external_lex_state = 2},
  [2496] = {.lex_state = 113, .external_lex_state = 2},
  [2497] = {.lex_state = 113, .external_lex_state = 2},
  [2498] = {.lex_state = 113, .external_lex_state = 2},
  [2499] = {.lex_state = 113, .external_lex_state = 2},
  [2500] = {.lex_state = 113, .external_lex_state = 2},
  [2501] = {.lex_state = 113, .external_lex_state = 2},
  [2502] = {.lex_state = 113, .external_lex_state = 2},
  [2503] = {.lex_state = 113, .external_lex_state = 2},
  [2504] = {.lex_state = 113, .external_lex_state = 2},
  [2505] = {.lex_state = 113, .external_lex_state = 2},
  [2506] = {.lex_state = 113, .external_lex_state = 2},
  [2507] = {.lex_state = 113, .external_lex_state = 2},
  [2508] = {.lex_state = 113, .external_lex_state = 2},
  [2509] = {.lex_state = 113, .external_lex_state = 2},
  [2510] = {.lex_state = 0},
  [2511] = {.lex_state = 113, .external_lex_state = 2},
  [2512] = {.lex_state = 113, .external_lex_state = 2},
  [2513] = {.lex_state = 113, .external_lex_state = 2},
  [2514] = {.lex_state = 113, .external_lex_state = 2},
  [2515] = {.lex_state = 113, .external_lex_state = 2},
  [2516] = {.lex_state = 113, .external_lex_state = 2},
  [2517] = {.lex_state = 113, .external_lex_state = 2},
  [2518] = {.lex_state = 113, .external_lex_state = 2},
  [2519] = {.lex_state = 113, .external_lex_state = 2},
  [2520] = {.lex_state = 113, .external_lex_state = 2},
  [2521] = {.lex_state = 113, .external_lex_state = 2},
  [2522] = {.lex_state = 113, .external_lex_state = 2},
  [2523] = {.lex_state = 113, .external_lex_state = 2},
  [2524] = {.lex_state = 113, .external_lex_state = 2},
  [2525] = {.lex_state = 113, .external_lex_state = 2},
  [2526] = {.lex_state = 113, .external_lex_state = 2},
  [2527] = {.lex_state = 113, .external_lex_state = 2},
  [2528] = {.lex_state = 113, .external_lex_state = 2},
  [2529] = {.lex_state = 113, .external_lex_state = 2},
  [2530] = {.lex_state = 113, .external_lex_state = 2},
  [2531] = {.lex_state = 113, .external_lex_state = 2},
  [2532] = {.lex_state = 113, .external_lex_state = 2},
  [2533] = {.lex_state = 113, .external_lex_state = 2},
  [2534] = {.lex_state = 113, .external_lex_state = 2},
  [2535] = {.lex_state = 113, .external_lex_state = 2},
  [2536] = {.lex_state = 113, .external_lex_state = 2},
  [2537] = {.lex_state = 113, .external_lex_state = 2},
  [2538] = {.lex_state = 113, .external_lex_state = 2},
  [2539] = {.lex_state = 113, .external_lex_state = 2},
  [2540] = {.lex_state = 113, .external_lex_state = 2},
  [2541] = {.lex_state = 113, .external_lex_state = 2},
  [2542] = {.lex_state = 113, .external_lex_state = 2},
  [2543] = {.lex_state = 113, .external_lex_state = 2},
  [2544] = {.lex_state = 113, .external_lex_state = 2},
  [2545] = {.lex_state = 113, .external_lex_state = 2},
  [2546] = {.lex_state = 113, .external_lex_state = 2},
  [2547] = {.lex_state = 113, .external_lex_state = 2},
  [2548] = {.lex_state = 113, .external_lex_state = 2},
  [2549] = {.lex_state = 113, .external_lex_state = 2},
  [2550] = {.lex_state = 113, .external_lex_state = 2},
  [2551] = {.lex_state = 113, .external_lex_state = 2},
  [2552] = {.lex_state = 113, .external_lex_state = 2},
  [2553] = {.lex_state = 113, .external_lex_state = 2},
  [2554] = {.lex_state = 113, .external_lex_state = 2},
  [2555] = {.lex_state = 113, .external_lex_state = 2},
  [2556] = {.lex_state = 113, .external_lex_state = 2},
  [2557] = {.lex_state = 0},
  [2558] = {.lex_state = 113, .external_lex_state = 2},
  [2559] = {.lex_state = 113, .external_lex_state = 2},
  [2560] = {.lex_state = 113, .external_lex_state = 2},
  [2561] = {.lex_state = 113, .external_lex_state = 2},
  [2562] = {.lex_state = 113, .external_lex_state = 2},
  [2563] = {.lex_state = 113, .external_lex_state = 2},
  [2564] = {.lex_state = 113, .external_lex_state = 2},
  [2565] = {.lex_state = 113, .external_lex_state = 2},
  [2566] = {.lex_state = 113, .external_lex_state = 2},
  [2567] = {.lex_state = 113, .external_lex_state = 2},
  [2568] = {.lex_state = 113, .external_lex_state = 2},
  [2569] = {.lex_state = 113, .external_lex_state = 2},
  [2570] = {.lex_state = 113, .external_lex_state = 2},
  [2571] = {.lex_state = 113, .external_lex_state = 2},
  [2572] = {.lex_state = 113, .external_lex_state = 2},
  [2573] = {.lex_state = 113, .external_lex_state = 2},
  [2574] = {.lex_state = 113, .external_lex_state = 2},
  [2575] = {.lex_state = 113, .external_lex_state = 2},
  [2576] = {.lex_state = 113, .external_lex_state = 2},
  [2577] = {.lex_state = 113, .external_lex_state = 2},
  [2578] = {.lex_state = 113, .external_lex_state = 2},
  [2579] = {.lex_state = 113, .external_lex_state = 2},
  [2580] = {.lex_state = 113, .external_lex_state = 2},
  [2581] = {.lex_state = 113, .external_lex_state = 2},
  [2582] = {.lex_state = 113, .external_lex_state = 2},
  [2583] = {.lex_state = 113, .external_lex_state = 2},
  [2584] = {.lex_state = 113, .external_lex_state = 2},
  [2585] = {.lex_state = 113, .external_lex_state = 2},
  [2586] = {.lex_state = 113, .external_lex_state = 2},
  [2587] = {.lex_state = 113, .external_lex_state = 2},
  [2588] = {.lex_state = 113, .external_lex_state = 2},
  [2589] = {.lex_state = 113, .external_lex_state = 2},
  [2590] = {.lex_state = 113, .external_lex_state = 2},
  [2591] = {.lex_state = 113, .external_lex_state = 2},
  [2592] = {.lex_state = 113, .external_lex_state = 2},
  [2593] = {.lex_state = 113, .external_lex_state = 2},
  [2594] = {.lex_state = 113, .external_lex_state = 2},
  [2595] = {.lex_state = 113, .external_lex_state = 2},
  [2596] = {.lex_state = 113, .external_lex_state = 2},
  [2597] = {.lex_state = 113, .external_lex_state = 2},
  [2598] = {.lex_state = 113, .external_lex_state = 2},
  [2599] = {.lex_state = 113, .external_lex_state = 2},
  [2600] = {.lex_state = 113, .external_lex_state = 2},
  [2601] = {.lex_state = 113, .external_lex_state = 2},
  [2602] = {.lex_state = 113, .external_lex_state = 2},
  [2603] = {.lex_state = 113, .external_lex_state = 2},
  [2604] = {.lex_state = 113, .external_lex_state = 2},
  [2605] = {.lex_state = 113, .external_lex_state = 2},
  [2606] = {.lex_state = 113, .external_lex_state = 2},
  [2607] = {.lex_state = 113, .external_lex_state = 2},
  [2608] = {.lex_state = 113, .external_lex_state = 2},
  [2609] = {.lex_state = 113, .external_lex_state = 2},
  [2610] = {.lex_state = 113, .external_lex_state = 2},
  [2611] = {.lex_state = 113, .external_lex_state = 2},
  [2612] = {.lex_state = 113, .external_lex_state = 2},
  [2613] = {.lex_state = 113, .external_lex_state = 2},
  [2614] = {.lex_state = 113, .external_lex_state = 2},
  [2615] = {.lex_state = 113, .external_lex_state = 2},
  [2616] = {.lex_state = 113, .external_lex_state = 2},
  [2617] = {.lex_state = 113, .external_lex_state = 2},
  [2618] = {.lex_state = 113, .external_lex_state = 2},
  [2619] = {.lex_state = 113, .external_lex_state = 2},
  [2620] = {.lex_state = 113, .external_lex_state = 2},
  [2621] = {.lex_state = 113, .external_lex_state = 2},
  [2622] = {.lex_state = 113, .external_lex_state = 2},
  [2623] = {.lex_state = 113, .external_lex_state = 2},
  [2624] = {.lex_state = 113, .external_lex_state = 2},
  [2625] = {.lex_state = 113, .external_lex_state = 2},
  [2626] = {.lex_state = 0},
  [2627] = {.lex_state = 113, .external_lex_state = 2},
  [2628] = {.lex_state = 113, .external_lex_state = 2},
  [2629] = {.lex_state = 113, .external_lex_state = 2},
  [2630] = {.lex_state = 113, .external_lex_state = 2},
  [2631] = {.lex_state = 113, .external_lex_state = 2},
  [2632] = {.lex_state = 0},
  [2633] = {.lex_state = 113, .external_lex_state = 2},
  [2634] = {.lex_state = 113, .external_lex_state = 2},
  [2635] = {.lex_state = 113, .external_lex_state = 2},
  [2636] = {.lex_state = 113, .external_lex_state = 2},
  [2637] = {.lex_state = 113, .external_lex_state = 2},
  [2638] = {.lex_state = 113, .external_lex_state = 2},
  [2639] = {.lex_state = 0},
  [2640] = {.lex_state = 113, .external_lex_state = 2},
  [2641] = {.lex_state = 113, .external_lex_state = 2},
  [2642] = {.lex_state = 113, .external_lex_state = 2},
  [2643] = {.lex_state = 113, .external_lex_state = 2},
  [2644] = {.lex_state = 113, .external_lex_state = 2},
  [2645] = {.lex_state = 113, .external_lex_state = 2},
  [2646] = {.lex_state = 113, .external_lex_state = 2},
  [2647] = {.lex_state = 113, .external_lex_state = 2},
  [2648] = {.lex_state = 113, .external_lex_state = 2},
  [2649] = {.lex_state = 113, .external_lex_state = 2},
  [2650] = {.lex_state = 113, .external_lex_state = 2},
  [2651] = {.lex_state = 113, .external_lex_state = 2},
  [2652] = {.lex_state = 113, .external_lex_state = 2},
  [2653] = {.lex_state = 113, .external_lex_state = 2},
  [2654] = {.lex_state = 113, .external_lex_state = 2},
  [2655] = {.lex_state = 113, .external_lex_state = 2},
  [2656] = {.lex_state = 113, .external_lex_state = 2},
  [2657] = {.lex_state = 113, .external_lex_state = 2},
  [2658] = {.lex_state = 113, .external_lex_state = 2},
  [2659] = {.lex_state = 113, .external_lex_state = 2},
  [2660] = {.lex_state = 113, .external_lex_state = 2},
  [2661] = {.lex_state = 113, .external_lex_state = 2},
  [2662] = {.lex_state = 113, .external_lex_state = 2},
  [2663] = {.lex_state = 113, .external_lex_state = 2},
  [2664] = {.lex_state = 113, .external_lex_state = 2},
  [2665] = {.lex_state = 113, .external_lex_state = 2},
  [2666] = {.lex_state = 113, .external_lex_state = 2},
  [2667] = {.lex_state = 113, .external_lex_state = 2},
  [2668] = {.lex_state = 113, .external_lex_state = 2},
  [2669] = {.lex_state = 113, .external_lex_state = 2},
  [2670] = {.lex_state = 113, .external_lex_state = 2},
  [2671] = {.lex_state = 113, .external_lex_state = 2},
  [2672] = {.lex_state = 113, .external_lex_state = 2},
  [2673] = {.lex_state = 113, .external_lex_state = 2},
  [2674] = {.lex_state = 113, .external_lex_state = 2},
  [2675] = {.lex_state = 113, .external_lex_state = 2},
  [2676] = {.lex_state = 113, .external_lex_state = 2},
  [2677] = {.lex_state = 113, .external_lex_state = 2},
  [2678] = {.lex_state = 113, .external_lex_state = 2},
  [2679] = {.lex_state = 113, .external_lex_state = 2},
  [2680] = {.lex_state = 0},
  [2681] = {.lex_state = 113, .external_lex_state = 2},
  [2682] = {.lex_state = 113, .external_lex_state = 2},
  [2683] = {.lex_state = 113, .external_lex_state = 2},
  [2684] = {.lex_state = 113, .external_lex_state = 2},
  [2685] = {.lex_state = 113, .external_lex_state = 2},
  [2686] = {.lex_state = 113, .external_lex_state = 2},
  [2687] = {.lex_state = 113, .external_lex_state = 2},
  [2688] = {.lex_state = 113, .external_lex_state = 2},
  [2689] = {.lex_state = 113, .external_lex_state = 2},
  [2690] = {.lex_state = 113, .external_lex_state = 2},
  [2691] = {.lex_state = 113, .external_lex_state = 2},
  [2692] = {.lex_state = 113, .external_lex_state = 2},
  [2693] = {.lex_state = 113, .external_lex_state = 2},
  [2694] = {.lex_state = 113, .external_lex_state = 2},
  [2695] = {.lex_state = 113, .external_lex_state = 2},
  [2696] = {.lex_state = 113, .external_lex_state = 2},
  [2697] = {.lex_state = 113, .external_lex_state = 2},
  [2698] = {.lex_state = 113, .external_lex_state = 2},
  [2699] = {.lex_state = 113, .external_lex_state = 2},
  [2700] = {.lex_state = 113, .external_lex_state = 2},
  [2701] = {.lex_state = 113, .external_lex_state = 2},
  [2702] = {.lex_state = 113, .external_lex_state = 2},
  [2703] = {.lex_state = 113, .external_lex_state = 2},
  [2704] = {.lex_state = 113, .external_lex_state = 2},
  [2705] = {.lex_state = 113, .external_lex_state = 2},
  [2706] = {.lex_state = 113, .external_lex_state = 2},
  [2707] = {.lex_state = 113, .external_lex_state = 2},
  [2708] = {.lex_state = 113, .external_lex_state = 2},
  [2709] = {.lex_state = 113, .external_lex_state = 2},
  [2710] = {.lex_state = 113, .external_lex_state = 2},
  [2711] = {.lex_state = 113, .external_lex_state = 2},
  [2712] = {.lex_state = 113, .external_lex_state = 2},
  [2713] = {.lex_state = 113, .external_lex_state = 2},
  [2714] = {.lex_state = 113, .external_lex_state = 2},
  [2715] = {.lex_state = 113, .external_lex_state = 2},
  [2716] = {.lex_state = 113, .external_lex_state = 2},
  [2717] = {.lex_state = 113, .external_lex_state = 2},
  [2718] = {.lex_state = 113, .external_lex_state = 2},
  [2719] = {.lex_state = 113, .external_lex_state = 2},
  [2720] = {.lex_state = 113, .external_lex_state = 2},
  [2721] = {.lex_state = 113, .external_lex_state = 2},
  [2722] = {.lex_state = 0, .external_lex_state = 4},
  [2723] = {.lex_state = 0},
  [2724] = {.lex_state = 0},
  [2725] = {.lex_state = 0},
  [2726] = {.lex_state = 0},
  [2727] = {.lex_state = 0},
  [2728] = {.lex_state = 0},
  [2729] = {.lex_state = 0, .external_lex_state = 4},
  [2730] = {.lex_state = 0},
  [2731] = {.lex_state = 0},
  [2732] = {.lex_state = 0},
  [2733] = {.lex_state = 0},
  [2734] = {.lex_state = 4},
  [2735] = {.lex_state = 0},
  [2736] = {.lex_state = 4},
  [2737] = {.lex_state = 4},
  [2738] = {.lex_state = 4},
  [2739] = {.lex_state = 0, .external_lex_state = 4},
  [2740] = {.lex_state = 0},
  [2741] = {.lex_state = 4},
  [2742] = {.lex_state = 0},
  [2743] = {.lex_state = 0},
  [2744] = {.lex_state = 4},
  [2745] = {.lex_state = 0},
  [2746] = {.lex_state = 4},
  [2747] = {.lex_state = 4},
  [2748] = {.lex_state = 4},
  [2749] = {.lex_state = 4},
  [2750] = {.lex_state = 4},
  [2751] = {.lex_state = 4},
  [2752] = {.lex_state = 4},
  [2753] = {.lex_state = 0},
  [2754] = {.lex_state = 4},
  [2755] = {.lex_state = 4},
  [2756] = {.lex_state = 0},
  [2757] = {.lex_state = 0, .external_lex_state = 4},
  [2758] = {.lex_state = 4},
  [2759] = {.lex_state = 6},
  [2760] = {.lex_state = 6},
  [2761] = {.lex_state = 4},
  [2762] = {.lex_state = 0},
  [2763] = {.lex_state = 0},
  [2764] = {.lex_state = 0},
  [2765] = {.lex_state = 6},
  [2766] = {.lex_state = 0},
  [2767] = {.lex_state = 0},
  [2768] = {.lex_state = 0},
  [2769] = {.lex_state = 4},
  [2770] = {.lex_state = 0},
  [2771] = {.lex_state = 0},
  [2772] = {.lex_state = 0},
  [2773] = {.lex_state = 0},
  [2774] = {.lex_state = 6},
  [2775] = {.lex_state = 0},
  [2776] = {.lex_state = 0, .external_lex_state = 4},
  [2777] = {.lex_state = 4},
  [2778] = {.lex_state = 0},
  [2779] = {.lex_state = 4},
  [2780] = {.lex_state = 0},
  [2781] = {.lex_state = 0},
  [2782] = {.lex_state = 0},
  [2783] = {.lex_state = 0},
  [2784] = {.lex_state = 0, .external_lex_state = 4},
  [2785] = {.lex_state = 112},
  [2786] = {.lex_state = 0, .external_lex_state = 4},
  [2787] = {.lex_state = 4},
  [2788] = {.lex_state = 112},
  [2789] = {.lex_state = 4},
  [2790] = {.lex_state = 4},
  [2791] = {.lex_state = 4},
  [2792] = {.lex_state = 0, .external_lex_state = 4},
  [2793] = {.lex_state = 6},
  [2794] = {.lex_state = 112},
  [2795] = {.lex_state = 0},
  [2796] = {.lex_state = 4, .external_lex_state = 4},
  [2797] = {.lex_state = 112},
  [2798] = {.lex_state = 0, .external_lex_state = 4},
  [2799] = {.lex_state = 4},
  [2800] = {.lex_state = 0},
  [2801] = {.lex_state = 112},
  [2802] = {.lex_state = 4},
  [2803] = {.lex_state = 112},
  [2804] = {.lex_state = 0},
  [2805] = {.lex_state = 0},
  [2806] = {.lex_state = 4},
  [2807] = {.lex_state = 4, .external_lex_state = 4},
  [2808] = {.lex_state = 0},
  [2809] = {.lex_state = 112},
  [2810] = {.lex_state = 0},
  [2811] = {.lex_state = 4},
  [2812] = {.lex_state = 4, .external_lex_state = 4},
  [2813] = {.lex_state = 4, .external_lex_state = 4},
  [2814] = {.lex_state = 4, .external_lex_state = 4},
  [2815] = {.lex_state = 4, .external_lex_state = 4},
  [2816] = {.lex_state = 0, .external_lex_state = 4},
  [2817] = {.lex_state = 4},
  [2818] = {.lex_state = 4, .external_lex_state = 4},
  [2819] = {.lex_state = 0},
  [2820] = {.lex_state = 4, .external_lex_state = 4},
  [2821] = {.lex_state = 0},
  [2822] = {.lex_state = 4, .external_lex_state = 4},
  [2823] = {.lex_state = 4, .external_lex_state = 4},
  [2824] = {.lex_state = 4, .external_lex_state = 4},
  [2825] = {.lex_state = 4, .external_lex_state = 4},
  [2826] = {.lex_state = 112},
  [2827] = {.lex_state = 4, .external_lex_state = 4},
  [2828] = {.lex_state = 4},
  [2829] = {.lex_state = 4},
  [2830] = {.lex_state = 0},
  [2831] = {.lex_state = 4, .external_lex_state = 4},
  [2832] = {.lex_state = 4},
  [2833] = {.lex_state = 0},
  [2834] = {.lex_state = 0},
  [2835] = {.lex_state = 0},
  [2836] = {.lex_state = 0},
  [2837] = {.lex_state = 4},
  [2838] = {.lex_state = 0},
  [2839] = {.lex_state = 4},
  [2840] = {.lex_state = 112},
  [2841] = {.lex_state = 4},
  [2842] = {.lex_state = 112},
  [2843] = {.lex_state = 112},
  [2844] = {.lex_state = 0},
  [2845] = {.lex_state = 4},
  [2846] = {.lex_state = 6},
  [2847] = {.lex_state = 4},
  [2848] = {.lex_state = 0},
  [2849] = {.lex_state = 4, .external_lex_state = 4},
  [2850] = {.lex_state = 4},
  [2851] = {.lex_state = 112},
  [2852] = {.lex_state = 4},
  [2853] = {.lex_state = 112},
  [2854] = {.lex_state = 4, .external_lex_state = 4},
  [2855] = {.lex_state = 6, .external_lex_state = 4},
  [2856] = {.lex_state = 4},
  [2857] = {.lex_state = 4},
  [2858] = {.lex_state = 0},
  [2859] = {.lex_state = 112},
  [2860] = {.lex_state = 0},
  [2861] = {.lex_state = 4},
  [2862] = {.lex_state = 4, .external_lex_state = 4},
  [2863] = {.lex_state = 0},
  [2864] = {.lex_state = 0},
  [2865] = {.lex_state = 0},
  [2866] = {.lex_state = 0},
  [2867] = {.lex_state = 0},
  [2868] = {.lex_state = 4, .external_lex_state = 4},
  [2869] = {.lex_state = 112},
  [2870] = {.lex_state = 0},
  [2871] = {.lex_state = 112},
  [2872] = {.lex_state = 6, .external_lex_state = 4},
  [2873] = {.lex_state = 6, .external_lex_state = 4},
  [2874] = {.lex_state = 4},
  [2875] = {.lex_state = 0},
  [2876] = {.lex_state = 0},
  [2877] = {.lex_state = 112},
  [2878] = {.lex_state = 0},
  [2879] = {.lex_state = 4},
  [2880] = {.lex_state = 112},
  [2881] = {.lex_state = 112},
  [2882] = {.lex_state = 4},
  [2883] = {.lex_state = 0},
  [2884] = {.lex_state = 0},
  [2885] = {.lex_state = 0},
  [2886] = {.lex_state = 112},
  [2887] = {.lex_state = 0},
  [2888] = {.lex_state = 0},
  [2889] = {.lex_state = 4},
  [2890] = {.lex_state = 0},
  [2891] = {.lex_state = 0},
  [2892] = {.lex_state = 112},
  [2893] = {.lex_state = 112},
  [2894] = {.lex_state = 0},
  [2895] = {.lex_state = 0},
  [2896] = {.lex_state = 112},
  [2897] = {.lex_state = 112},
  [2898] = {.lex_state = 112},
  [2899] = {.lex_state = 112},
  [2900] = {.lex_state = 0},
  [2901] = {.lex_state = 112},
  [2902] = {.lex_state = 0},
  [2903] = {.lex_state = 0},
  [2904] = {.lex_state = 0},
  [2905] = {.lex_state = 0},
  [2906] = {.lex_state = 0},
  [2907] = {.lex_state = 112},
  [2908] = {.lex_state = 0},
  [2909] = {.lex_state = 0},
  [2910] = {.lex_state = 6},
  [2911] = {.lex_state = 0},
  [2912] = {.lex_state = 0},
  [2913] = {.lex_state = 6},
  [2914] = {.lex_state = 6},
  [2915] = {.lex_state = 6},
  [2916] = {.lex_state = 0},
  [2917] = {.lex_state = 6},
  [2918] = {.lex_state = 0},
  [2919] = {.lex_state = 0},
  [2920] = {.lex_state = 0},
  [2921] = {.lex_state = 0},
  [2922] = {.lex_state = 0},
  [2923] = {.lex_state = 0},
  [2924] = {.lex_state = 0},
  [2925] = {.lex_state = 112},
  [2926] = {.lex_state = 6},
  [2927] = {.lex_state = 6},
  [2928] = {.lex_state = 112},
  [2929] = {.lex_state = 112},
  [2930] = {.lex_state = 112},
  [2931] = {.lex_state = 112, .external_lex_state = 4},
  [2932] = {.lex_state = 0},
  [2933] = {.lex_state = 6},
  [2934] = {.lex_state = 112},
  [2935] = {.lex_state = 0},
  [2936] = {.lex_state = 112},
  [2937] = {.lex_state = 112},
  [2938] = {.lex_state = 0},
  [2939] = {.lex_state = 0},
  [2940] = {.lex_state = 0},
  [2941] = {.lex_state = 0},
  [2942] = {.lex_state = 112, .external_lex_state = 4},
  [2943] = {.lex_state = 112},
  [2944] = {.lex_state = 0},
  [2945] = {.lex_state = 4},
  [2946] = {.lex_state = 112, .external_lex_state = 4},
  [2947] = {.lex_state = 112},
  [2948] = {.lex_state = 0},
  [2949] = {.lex_state = 112},
  [2950] = {.lex_state = 0},
  [2951] = {.lex_state = 112},
  [2952] = {.lex_state = 0},
  [2953] = {.lex_state = 112},
  [2954] = {.lex_state = 6},
  [2955] = {.lex_state = 0},
  [2956] = {.lex_state = 112},
  [2957] = {.lex_state = 0},
  [2958] = {.lex_state = 112, .external_lex_state = 4},
  [2959] = {.lex_state = 112},
  [2960] = {.lex_state = 0},
  [2961] = {.lex_state = 6},
  [2962] = {.lex_state = 112},
  [2963] = {.lex_state = 112},
  [2964] = {.lex_state = 0},
  [2965] = {.lex_state = 112, .external_lex_state = 4},
  [2966] = {.lex_state = 112},
  [2967] = {.lex_state = 0},
  [2968] = {.lex_state = 0},
  [2969] = {.lex_state = 0},
  [2970] = {.lex_state = 112, .external_lex_state = 4},
  [2971] = {.lex_state = 112},
  [2972] = {.lex_state = 112},
  [2973] = {.lex_state = 112},
  [2974] = {.lex_state = 112},
  [2975] = {.lex_state = 112},
  [2976] = {.lex_state = 0},
  [2977] = {.lex_state = 112},
  [2978] = {.lex_state = 6},
  [2979] = {.lex_state = 4},
  [2980] = {.lex_state = 4},
  [2981] = {.lex_state = 6},
  [2982] = {.lex_state = 4},
  [2983] = {.lex_state = 112},
  [2984] = {.lex_state = 112},
  [2985] = {.lex_state = 6},
  [2986] = {.lex_state = 6},
  [2987] = {.lex_state = 4},
  [2988] = {.lex_state = 4},
  [2989] = {.lex_state = 6},
  [2990] = {.lex_state = 112},
  [2991] = {.lex_state = 6},
  [2992] = {.lex_state = 112},
  [2993] = {.lex_state = 4},
  [2994] = {.lex_state = 112},
  [2995] = {.lex_state = 112},
  [2996] = {.lex_state = 4},
  [2997] = {.lex_state = 112},
  [2998] = {.lex_state = 4},
  [2999] = {.lex_state = 6},
  [3000] = {.lex_state = 4},
  [3001] = {.lex_state = 6},
  [3002] = {.lex_state = 112},
  [3003] = {.lex_state = 4},
  [3004] = {.lex_state = 112},
  [3005] = {.lex_state = 112},
  [3006] = {.lex_state = 4},
  [3007] = {.lex_state = 4},
  [3008] = {.lex_state = 112},
  [3009] = {.lex_state = 4},
  [3010] = {.lex_state = 4},
  [3011] = {.lex_state = 4},
  [3012] = {.lex_state = 4},
  [3013] = {.lex_state = 4},
  [3014] = {.lex_state = 4},
  [3015] = {.lex_state = 4},
  [3016] = {.lex_state = 112},
  [3017] = {.lex_state = 112},
  [3018] = {.lex_state = 112},
  [3019] = {.lex_state = 112},
  [3020] = {.lex_state = 4},
  [3021] = {.lex_state = 112},
  [3022] = {.lex_state = 112},
  [3023] = {.lex_state = 4},
  [3024] = {.lex_state = 112},
  [3025] = {.lex_state = 112},
  [3026] = {.lex_state = 112},
  [3027] = {.lex_state = 112},
  [3028] = {.lex_state = 4},
  [3029] = {.lex_state = 112},
  [3030] = {.lex_state = 112},
  [3031] = {.lex_state = 112},
  [3032] = {.lex_state = 112},
  [3033] = {.lex_state = 112},
  [3034] = {.lex_state = 112},
  [3035] = {.lex_state = 112},
  [3036] = {.lex_state = 112},
  [3037] = {.lex_state = 112},
  [3038] = {.lex_state = 112},
  [3039] = {.lex_state = 4},
  [3040] = {.lex_state = 4},
  [3041] = {.lex_state = 112},
  [3042] = {.lex_state = 4},
  [3043] = {.lex_state = 112},
  [3044] = {.lex_state = 112},
  [3045] = {.lex_state = 112},
  [3046] = {.lex_state = 112},
  [3047] = {.lex_state = 112, .external_lex_state = 4},
  [3048] = {.lex_state = 112},
  [3049] = {.lex_state = 112},
  [3050] = {.lex_state = 112},
  [3051] = {.lex_state = 6},
  [3052] = {.lex_state = 112},
  [3053] = {.lex_state = 112, .external_lex_state = 4},
  [3054] = {.lex_state = 112},
  [3055] = {.lex_state = 112},
  [3056] = {.lex_state = 112},
  [3057] = {.lex_state = 112},
  [3058] = {.lex_state = 112},
  [3059] = {.lex_state = 112, .external_lex_state = 4},
  [3060] = {.lex_state = 6},
  [3061] = {.lex_state = 112},
  [3062] = {.lex_state = 112},
  [3063] = {.lex_state = 112},
  [3064] = {.lex_state = 112},
  [3065] = {.lex_state = 112},
  [3066] = {.lex_state = 112},
  [3067] = {.lex_state = 6},
  [3068] = {.lex_state = 112},
  [3069] = {.lex_state = 6},
  [3070] = {.lex_state = 112, .external_lex_state = 4},
  [3071] = {.lex_state = 112},
  [3072] = {.lex_state = 6},
  [3073] = {.lex_state = 112},
  [3074] = {.lex_state = 6},
  [3075] = {.lex_state = 112},
  [3076] = {.lex_state = 112},
  [3077] = {.lex_state = 112},
  [3078] = {.lex_state = 112},
  [3079] = {.lex_state = 0},
  [3080] = {.lex_state = 0},
  [3081] = {.lex_state = 112},
  [3082] = {.lex_state = 0},
  [3083] = {.lex_state = 0},
  [3084] = {.lex_state = 0},
  [3085] = {.lex_state = 0},
  [3086] = {.lex_state = 0},
  [3087] = {.lex_state = 0},
  [3088] = {.lex_state = 0},
  [3089] = {.lex_state = 0},
  [3090] = {.lex_state = 0},
  [3091] = {.lex_state = 0},
  [3092] = {.lex_state = 112, .external_lex_state = 4},
  [3093] = {.lex_state = 0},
  [3094] = {.lex_state = 0},
  [3095] = {.lex_state = 112},
  [3096] = {.lex_state = 112},
  [3097] = {.lex_state = 0},
  [3098] = {.lex_state = 0},
  [3099] = {.lex_state = 0},
  [3100] = {.lex_state = 0},
  [3101] = {.lex_state = 0},
  [3102] = {.lex_state = 112},
  [3103] = {.lex_state = 0},
  [3104] = {.lex_state = 0},
  [3105] = {.lex_state = 0},
  [3106] = {.lex_state = 0},
  [3107] = {.lex_state = 0},
  [3108] = {.lex_state = 112, .external_lex_state = 4},
  [3109] = {.lex_state = 112},
  [3110] = {.lex_state = 112},
  [3111] = {.lex_state = 112, .external_lex_state = 4},
  [3112] = {.lex_state = 0},
  [3113] = {.lex_state = 112, .external_lex_state = 4},
  [3114] = {.lex_state = 112},
  [3115] = {.lex_state = 112, .external_lex_state = 4},
  [3116] = {.lex_state = 112, .external_lex_state = 4},
  [3117] = {.lex_state = 112, .external_lex_state = 4},
  [3118] = {.lex_state = 0},
  [3119] = {.lex_state = 112},
  [3120] = {.lex_state = 112, .external_lex_state = 4},
  [3121] = {.lex_state = 0},
  [3122] = {.lex_state = 0},
  [3123] = {.lex_state = 112},
  [3124] = {.lex_state = 112, .external_lex_state = 4},
  [3125] = {.lex_state = 112},
  [3126] = {.lex_state = 6},
  [3127] = {.lex_state = 4},
  [3128] = {.lex_state = 0},
  [3129] = {.lex_state = 112},
  [3130] = {.lex_state = 112},
  [3131] = {.lex_state = 112},
  [3132] = {.lex_state = 112},
  [3133] = {.lex_state = 6, .external_lex_state = 4},
  [3134] = {.lex_state = 112},
  [3135] = {.lex_state = 4},
  [3136] = {.lex_state = 112},
  [3137] = {.lex_state = 112},
  [3138] = {.lex_state = 112},
  [3139] = {.lex_state = 112},
  [3140] = {.lex_state = 112},
  [3141] = {.lex_state = 112},
  [3142] = {.lex_state = 0},
  [3143] = {.lex_state = 112},
  [3144] = {.lex_state = 0},
  [3145] = {.lex_state = 112},
  [3146] = {.lex_state = 4},
  [3147] = {.lex_state = 112},
  [3148] = {.lex_state = 112},
  [3149] = {.lex_state = 112},
  [3150] = {.lex_state = 112},
  [3151] = {.lex_state = 112},
  [3152] = {.lex_state = 112},
  [3153] = {.lex_state = 112},
  [3154] = {.lex_state = 112},
  [3155] = {.lex_state = 112},
  [3156] = {.lex_state = 112},
  [3157] = {.lex_state = 112},
  [3158] = {.lex_state = 112},
  [3159] = {.lex_state = 112},
  [3160] = {.lex_state = 112, .external_lex_state = 4},
  [3161] = {.lex_state = 112},
  [3162] = {.lex_state = 112},
  [3163] = {.lex_state = 6, .external_lex_state = 4},
  [3164] = {.lex_state = 112},
  [3165] = {.lex_state = 4},
  [3166] = {.lex_state = 4},
  [3167] = {.lex_state = 112},
  [3168] = {.lex_state = 6, .external_lex_state = 4},
  [3169] = {.lex_state = 112},
  [3170] = {.lex_state = 112},
  [3171] = {.lex_state = 6, .external_lex_state = 4},
  [3172] = {.lex_state = 4},
  [3173] = {.lex_state = 112},
  [3174] = {.lex_state = 4},
  [3175] = {.lex_state = 112},
  [3176] = {.lex_state = 0},
  [3177] = {.lex_state = 112},
  [3178] = {.lex_state = 112},
  [3179] = {.lex_state = 112},
  [3180] = {.lex_state = 0},
  [3181] = {.lex_state = 0},
  [3182] = {.lex_state = 112},
  [3183] = {.lex_state = 4},
  [3184] = {.lex_state = 112},
  [3185] = {.lex_state = 4},
  [3186] = {.lex_state = 4},
  [3187] = {.lex_state = 4},
  [3188] = {.lex_state = 0},
  [3189] = {.lex_state = 4},
  [3190] = {.lex_state = 4},
  [3191] = {.lex_state = 4},
  [3192] = {.lex_state = 112},
  [3193] = {.lex_state = 112, .external_lex_state = 4},
  [3194] = {.lex_state = 112},
  [3195] = {.lex_state = 112},
  [3196] = {.lex_state = 112},
  [3197] = {.lex_state = 112},
  [3198] = {.lex_state = 0},
  [3199] = {.lex_state = 112},
  [3200] = {.lex_state = 0},
  [3201] = {.lex_state = 4},
  [3202] = {.lex_state = 4},
  [3203] = {.lex_state = 112, .external_lex_state = 4},
  [3204] = {.lex_state = 4},
  [3205] = {.lex_state = 4},
  [3206] = {.lex_state = 4},
  [3207] = {.lex_state = 4},
  [3208] = {.lex_state = 0},
  [3209] = {.lex_state = 4},
  [3210] = {.lex_state = 4},
  [3211] = {.lex_state = 0},
  [3212] = {.lex_state = 4},
  [3213] = {.lex_state = 0},
  [3214] = {.lex_state = 0},
  [3215] = {.lex_state = 112},
  [3216] = {.lex_state = 112},
  [3217] = {.lex_state = 0},
  [3218] = {.lex_state = 0},
  [3219] = {.lex_state = 112, .external_lex_state = 4},
  [3220] = {.lex_state = 0},
  [3221] = {.lex_state = 0},
  [3222] = {.lex_state = 0},
  [3223] = {.lex_state = 0},
  [3224] = {.lex_state = 0},
  [3225] = {.lex_state = 0},
  [3226] = {.lex_state = 0},
  [3227] = {.lex_state = 112},
  [3228] = {.lex_state = 0},
  [3229] = {.lex_state = 0},
  [3230] = {.lex_state = 0},
  [3231] = {.lex_state = 0},
  [3232] = {.lex_state = 0},
  [3233] = {.lex_state = 4},
  [3234] = {.lex_state = 0},
  [3235] = {.lex_state = 0},
  [3236] = {.lex_state = 0},
  [3237] = {.lex_state = 0},
  [3238] = {.lex_state = 0},
  [3239] = {.lex_state = 112},
  [3240] = {.lex_state = 0},
  [3241] = {.lex_state = 0},
  [3242] = {.lex_state = 0},
  [3243] = {.lex_state = 0},
  [3244] = {.lex_state = 0},
  [3245] = {.lex_state = 0},
  [3246] = {.lex_state = 0},
  [3247] = {.lex_state = 0},
  [3248] = {.lex_state = 0},
  [3249] = {.lex_state = 0},
  [3250] = {.lex_state = 0},
  [3251] = {.lex_state = 0},
  [3252] = {.lex_state = 0},
  [3253] = {.lex_state = 0},
  [3254] = {.lex_state = 0},
  [3255] = {.lex_state = 0},
  [3256] = {.lex_state = 0},
  [3257] = {.lex_state = 4},
  [3258] = {.lex_state = 0},
  [3259] = {.lex_state = 0},
  [3260] = {.lex_state = 0},
  [3261] = {.lex_state = 0},
  [3262] = {.lex_state = 0},
  [3263] = {.lex_state = 0},
  [3264] = {.lex_state = 0},
  [3265] = {.lex_state = 0},
  [3266] = {.lex_state = 0},
  [3267] = {.lex_state = 0},
  [3268] = {.lex_state = 112},
  [3269] = {.lex_state = 0},
  [3270] = {.lex_state = 0},
  [3271] = {.lex_state = 0},
  [3272] = {.lex_state = 0},
  [3273] = {.lex_state = 112},
  [3274] = {.lex_state = 0},
  [3275] = {.lex_state = 0},
  [3276] = {.lex_state = 0},
  [3277] = {.lex_state = 4},
  [3278] = {.lex_state = 0},
  [3279] = {.lex_state = 4},
  [3280] = {.lex_state = 0},
  [3281] = {.lex_state = 0},
  [3282] = {.lex_state = 0},
  [3283] = {.lex_state = 0},
  [3284] = {.lex_state = 0},
  [3285] = {.lex_state = 0},
  [3286] = {.lex_state = 0},
  [3287] = {.lex_state = 0},
  [3288] = {.lex_state = 0},
  [3289] = {.lex_state = 0},
  [3290] = {.lex_state = 112, .external_lex_state = 4},
  [3291] = {.lex_state = 0},
  [3292] = {.lex_state = 0},
  [3293] = {.lex_state = 0},
  [3294] = {.lex_state = 0},
  [3295] = {.lex_state = 0},
  [3296] = {.lex_state = 0},
  [3297] = {.lex_state = 0},
  [3298] = {.lex_state = 0},
  [3299] = {.lex_state = 0},
  [3300] = {.lex_state = 0},
  [3301] = {.lex_state = 0},
  [3302] = {.lex_state = 0},
  [3303] = {.lex_state = 0},
  [3304] = {.lex_state = 0},
  [3305] = {.lex_state = 0},
  [3306] = {.lex_state = 0},
  [3307] = {.lex_state = 0},
  [3308] = {.lex_state = 112, .external_lex_state = 4},
  [3309] = {.lex_state = 0},
  [3310] = {.lex_state = 0},
  [3311] = {.lex_state = 0},
  [3312] = {.lex_state = 0},
  [3313] = {.lex_state = 0},
  [3314] = {.lex_state = 112, .external_lex_state = 4},
  [3315] = {.lex_state = 0},
  [3316] = {.lex_state = 0},
  [3317] = {.lex_state = 112, .external_lex_state = 4},
  [3318] = {.lex_state = 0},
  [3319] = {.lex_state = 112, .external_lex_state = 4},
  [3320] = {.lex_state = 112},
  [3321] = {.lex_state = 0},
  [3322] = {.lex_state = 0},
  [3323] = {.lex_state = 0},
  [3324] = {.lex_state = 0},
  [3325] = {.lex_state = 0},
  [3326] = {.lex_state = 0},
  [3327] = {.lex_state = 0},
  [3328] = {.lex_state = 0},
  [3329] = {.lex_state = 4},
  [3330] = {.lex_state = 0},
  [3331] = {.lex_state = 0},
  [3332] = {.lex_state = 0},
  [3333] = {.lex_state = 112, .external_lex_state = 4},
  [3334] = {.lex_state = 0},
  [3335] = {.lex_state = 0},
  [3336] = {.lex_state = 112, .external_lex_state = 4},
  [3337] = {.lex_state = 112, .external_lex_state = 4},
  [3338] = {.lex_state = 0},
  [3339] = {.lex_state = 0},
  [3340] = {.lex_state = 112, .external_lex_state = 4},
  [3341] = {.lex_state = 112, .external_lex_state = 4},
  [3342] = {.lex_state = 112, .external_lex_state = 4},
  [3343] = {.lex_state = 0},
  [3344] = {.lex_state = 112},
  [3345] = {.lex_state = 0},
  [3346] = {.lex_state = 112},
  [3347] = {.lex_state = 0},
  [3348] = {.lex_state = 112, .external_lex_state = 4},
  [3349] = {.lex_state = 112},
  [3350] = {.lex_state = 112},
  [3351] = {.lex_state = 0},
  [3352] = {.lex_state = 0},
  [3353] = {.lex_state = 4},
  [3354] = {.lex_state = 112, .external_lex_state = 4},
  [3355] = {.lex_state = 0},
  [3356] = {.lex_state = 0},
  [3357] = {.lex_state = 4},
  [3358] = {.lex_state = 0},
  [3359] = {.lex_state = 0},
  [3360] = {.lex_state = 0},
  [3361] = {.lex_state = 0},
  [3362] = {.lex_state = 112},
  [3363] = {.lex_state = 112},
  [3364] = {.lex_state = 0},
  [3365] = {.lex_state = 0},
  [3366] = {.lex_state = 0},
  [3367] = {.lex_state = 0},
  [3368] = {.lex_state = 112, .external_lex_state = 4},
  [3369] = {.lex_state = 112},
  [3370] = {.lex_state = 112},
  [3371] = {.lex_state = 112, .external_lex_state = 4},
  [3372] = {.lex_state = 0},
  [3373] = {.lex_state = 0},
  [3374] = {.lex_state = 0},
  [3375] = {.lex_state = 0},
  [3376] = {.lex_state = 0},
  [3377] = {.lex_state = 112, .external_lex_state = 4},
  [3378] = {.lex_state = 112, .external_lex_state = 4},
  [3379] = {.lex_state = 112, .external_lex_state = 4},
  [3380] = {.lex_state = 112, .external_lex_state = 4},
  [3381] = {.lex_state = 0},
  [3382] = {.lex_state = 0},
  [3383] = {.lex_state = 0},
  [3384] = {.lex_state = 0},
  [3385] = {.lex_state = 0},
  [3386] = {.lex_state = 112},
  [3387] = {.lex_state = 0},
  [3388] = {.lex_state = 0},
  [3389] = {.lex_state = 112},
  [3390] = {.lex_state = 112},
  [3391] = {.lex_state = 112},
  [3392] = {.lex_state = 112, .external_lex_state = 4},
  [3393] = {.lex_state = 0},
  [3394] = {.lex_state = 0},
  [3395] = {.lex_state = 0},
  [3396] = {.lex_state = 112, .external_lex_state = 4},
  [3397] = {.lex_state = 112, .external_lex_state = 4},
  [3398] = {.lex_state = 0},
  [3399] = {.lex_state = 0},
  [3400] = {.lex_state = 0},
  [3401] = {.lex_state = 0},
  [3402] = {.lex_state = 0},
  [3403] = {.lex_state = 112, .external_lex_state = 4},
  [3404] = {.lex_state = 4},
  [3405] = {.lex_state = 112},
  [3406] = {.lex_state = 0},
  [3407] = {.lex_state = 0},
  [3408] = {.lex_state = 0},
  [3409] = {.lex_state = 112},
  [3410] = {.lex_state = 112},
  [3411] = {.lex_state = 112, .external_lex_state = 4},
  [3412] = {.lex_state = 0},
  [3413] = {.lex_state = 0},
  [3414] = {.lex_state = 113},
  [3415] = {.lex_state = 0},
  [3416] = {.lex_state = 0},
  [3417] = {.lex_state = 0},
  [3418] = {.lex_state = 112},
  [3419] = {.lex_state = 112, .external_lex_state = 4},
  [3420] = {.lex_state = 4},
  [3421] = {.lex_state = 4},
  [3422] = {.lex_state = 0},
  [3423] = {.lex_state = 0},
  [3424] = {.lex_state = 0},
  [3425] = {.lex_state = 0},
  [3426] = {.lex_state = 0},
  [3427] = {.lex_state = 0},
  [3428] = {.lex_state = 4},
  [3429] = {.lex_state = 112, .external_lex_state = 4},
  [3430] = {.lex_state = 112, .external_lex_state = 4},
  [3431] = {.lex_state = 0},
  [3432] = {.lex_state = 0},
  [3433] = {.lex_state = 0},
  [3434] = {.lex_state = 112, .external_lex_state = 4},
  [3435] = {.lex_state = 112, .external_lex_state = 4},
  [3436] = {.lex_state = 112, .external_lex_state = 4},
  [3437] = {.lex_state = 0},
  [3438] = {.lex_state = 0},
  [3439] = {.lex_state = 0},
  [3440] = {.lex_state = 0},
  [3441] = {.lex_state = 0},
  [3442] = {.lex_state = 0},
  [3443] = {.lex_state = 0},
  [3444] = {.lex_state = 0},
  [3445] = {.lex_state = 112, .external_lex_state = 4},
  [3446] = {.lex_state = 0},
  [3447] = {.lex_state = 0},
  [3448] = {.lex_state = 0},
  [3449] = {.lex_state = 0},
  [3450] = {.lex_state = 112, .external_lex_state = 4},
  [3451] = {.lex_state = 112},
  [3452] = {.lex_state = 112},
  [3453] = {.lex_state = 0},
  [3454] = {.lex_state = 112},
  [3455] = {.lex_state = 4},
  [3456] = {.lex_state = 0},
  [3457] = {.lex_state = 112, .external_lex_state = 4},
  [3458] = {.lex_state = 0},
  [3459] = {.lex_state = 0},
  [3460] = {.lex_state = 0},
  [3461] = {.lex_state = 0},
  [3462] = {.lex_state = 0},
  [3463] = {.lex_state = 0},
  [3464] = {.lex_state = 112, .external_lex_state = 4},
  [3465] = {.lex_state = 0},
  [3466] = {.lex_state = 112},
  [3467] = {.lex_state = 0},
  [3468] = {.lex_state = 0},
  [3469] = {.lex_state = 0},
  [3470] = {.lex_state = 0},
  [3471] = {.lex_state = 0},
  [3472] = {.lex_state = 0},
  [3473] = {.lex_state = 0},
  [3474] = {.lex_state = 0},
  [3475] = {.lex_state = 0},
  [3476] = {.lex_state = 0},
  [3477] = {.lex_state = 0},
  [3478] = {.lex_state = 0},
  [3479] = {.lex_state = 0},
  [3480] = {.lex_state = 112},
  [3481] = {.lex_state = 4},
  [3482] = {.lex_state = 0},
  [3483] = {.lex_state = 112},
  [3484] = {.lex_state = 112},
  [3485] = {.lex_state = 0},
  [3486] = {.lex_state = 0},
  [3487] = {.lex_state = 112},
  [3488] = {.lex_state = 0},
  [3489] = {.lex_state = 0},
  [3490] = {.lex_state = 0},
  [3491] = {.lex_state = 0},
  [3492] = {.lex_state = 0},
  [3493] = {.lex_state = 4},
  [3494] = {.lex_state = 0},
  [3495] = {.lex_state = 0},
  [3496] = {.lex_state = 4},
  [3497] = {.lex_state = 0},
  [3498] = {.lex_state = 0},
  [3499] = {.lex_state = 0},
  [3500] = {.lex_state = 0},
  [3501] = {.lex_state = 112},
  [3502] = {.lex_state = 0},
  [3503] = {.lex_state = 0},
  [3504] = {.lex_state = 0},
  [3505] = {.lex_state = 0},
  [3506] = {.lex_state = 0},
  [3507] = {.lex_state = 0},
  [3508] = {.lex_state = 0},
  [3509] = {.lex_state = 0},
  [3510] = {.lex_state = 0},
  [3511] = {.lex_state = 0},
  [3512] = {.lex_state = 112, .external_lex_state = 4},
  [3513] = {.lex_state = 112, .external_lex_state = 4},
  [3514] = {.lex_state = 112, .external_lex_state = 4},
  [3515] = {.lex_state = 112, .external_lex_state = 4},
  [3516] = {.lex_state = 112, .external_lex_state = 4},
  [3517] = {.lex_state = 112, .external_lex_state = 4},
  [3518] = {.lex_state = 112, .external_lex_state = 4},
  [3519] = {.lex_state = 112},
  [3520] = {.lex_state = 112},
  [3521] = {.lex_state = 112},
  [3522] = {.lex_state = 112},
  [3523] = {.lex_state = 112},
  [3524] = {.lex_state = 112},
  [3525] = {.lex_state = 112},
  [3526] = {.lex_state = 112},
  [3527] = {.lex_state = 112},
  [3528] = {.lex_state = 112},
  [3529] = {.lex_state = 4},
  [3530] = {.lex_state = 112},
  [3531] = {.lex_state = 112},
  [3532] = {.lex_state = 112},
  [3533] = {.lex_state = 112},
  [3534] = {.lex_state = 112},
  [3535] = {.lex_state = 112},
  [3536] = {.lex_state = 112},
  [3537] = {.lex_state = 112},
  [3538] = {.lex_state = 112},
  [3539] = {.lex_state = 4},
  [3540] = {.lex_state = 112},
  [3541] = {.lex_state = 112},
  [3542] = {.lex_state = 112},
  [3543] = {.lex_state = 112},
  [3544] = {.lex_state = 4},
  [3545] = {.lex_state = 112},
  [3546] = {.lex_state = 112},
  [3547] = {.lex_state = 112},
  [3548] = {.lex_state = 0},
  [3549] = {.lex_state = 0},
  [3550] = {.lex_state = 0},
  [3551] = {.lex_state = 0},
  [3552] = {.lex_state = 0},
  [3553] = {.lex_state = 112},
  [3554] = {.lex_state = 0},
  [3555] = {.lex_state = 6},
  [3556] = {.lex_state = 112},
  [3557] = {.lex_state = 112},
  [3558] = {.lex_state = 6},
  [3559] = {.lex_state = 0},
  [3560] = {.lex_state = 0},
  [3561] = {.lex_state = 0},
  [3562] = {.lex_state = 0},
  [3563] = {.lex_state = 0},
  [3564] = {.lex_state = 0},
  [3565] = {.lex_state = 112},
  [3566] = {.lex_state = 0},
  [3567] = {.lex_state = 6},
  [3568] = {.lex_state = 6},
  [3569] = {.lex_state = 112},
  [3570] = {.lex_state = 112},
  [3571] = {.lex_state = 112},
  [3572] = {.lex_state = 112},
  [3573] = {.lex_state = 112},
  [3574] = {.lex_state = 112},
  [3575] = {.lex_state = 112},
  [3576] = {.lex_state = 112},
  [3577] = {.lex_state = 112},
  [3578] = {.lex_state = 112},
  [3579] = {.lex_state = 6},
  [3580] = {.lex_state = 112},
  [3581] = {.lex_state = 112},
  [3582] = {.lex_state = 0},
  [3583] = {.lex_state = 112},
  [3584] = {.lex_state = 0},
  [3585] = {.lex_state = 112},
  [3586] = {.lex_state = 112},
  [3587] = {.lex_state = 112},
  [3588] = {.lex_state = 0},
  [3589] = {.lex_state = 112},
  [3590] = {.lex_state = 6},
  [3591] = {.lex_state = 6},
  [3592] = {.lex_state = 112},
  [3593] = {.lex_state = 112},
  [3594] = {.lex_state = 112},
  [3595] = {.lex_state = 112},
  [3596] = {.lex_state = 112},
  [3597] = {.lex_state = 112},
  [3598] = {.lex_state = 112},
  [3599] = {.lex_state = 112},
  [3600] = {.lex_state = 112},
  [3601] = {.lex_state = 112},
  [3602] = {.lex_state = 112},
  [3603] = {.lex_state = 112},
  [3604] = {.lex_state = 112},
  [3605] = {.lex_state = 112},
  [3606] = {.lex_state = 112},
  [3607] = {.lex_state = 0},
  [3608] = {.lex_state = 112},
  [3609] = {.lex_state = 112},
  [3610] = {.lex_state = 112},
  [3611] = {.lex_state = 112},
  [3612] = {.lex_state = 112},
  [3613] = {.lex_state = 112},
  [3614] = {.lex_state = 112},
  [3615] = {.lex_state = 112},
  [3616] = {.lex_state = 112},
  [3617] = {.lex_state = 112},
  [3618] = {.lex_state = 112},
  [3619] = {.lex_state = 112},
  [3620] = {.lex_state = 112},
  [3621] = {.lex_state = 112},
  [3622] = {.lex_state = 112},
  [3623] = {.lex_state = 112},
  [3624] = {.lex_state = 112},
  [3625] = {.lex_state = 112},
  [3626] = {.lex_state = 112},
  [3627] = {.lex_state = 112},
  [3628] = {.lex_state = 112},
  [3629] = {.lex_state = 112},
  [3630] = {.lex_state = 112},
  [3631] = {.lex_state = 112},
  [3632] = {.lex_state = 112},
  [3633] = {.lex_state = 112},
  [3634] = {.lex_state = 112},
  [3635] = {.lex_state = 112},
  [3636] = {.lex_state = 112},
  [3637] = {.lex_state = 112},
  [3638] = {.lex_state = 112},
  [3639] = {.lex_state = 112},
  [3640] = {.lex_state = 0},
  [3641] = {.lex_state = 112},
  [3642] = {.lex_state = 112},
  [3643] = {.lex_state = 112},
  [3644] = {.lex_state = 112},
  [3645] = {.lex_state = 112},
  [3646] = {.lex_state = 112},
  [3647] = {.lex_state = 112},
  [3648] = {.lex_state = 112},
  [3649] = {.lex_state = 112},
  [3650] = {.lex_state = 112},
  [3651] = {.lex_state = 112},
  [3652] = {.lex_state = 112},
  [3653] = {.lex_state = 112},
  [3654] = {.lex_state = 112},
  [3655] = {.lex_state = 112},
  [3656] = {.lex_state = 112},
  [3657] = {.lex_state = 112},
  [3658] = {.lex_state = 112},
  [3659] = {.lex_state = 112},
  [3660] = {.lex_state = 112},
  [3661] = {.lex_state = 112},
  [3662] = {.lex_state = 112},
  [3663] = {.lex_state = 112},
  [3664] = {.lex_state = 112},
  [3665] = {.lex_state = 112},
  [3666] = {.lex_state = 112},
  [3667] = {.lex_state = 112},
  [3668] = {.lex_state = 112},
  [3669] = {.lex_state = 0},
  [3670] = {.lex_state = 112},
  [3671] = {.lex_state = 112},
  [3672] = {.lex_state = 112},
  [3673] = {.lex_state = 112},
  [3674] = {.lex_state = 112},
  [3675] = {.lex_state = 112},
  [3676] = {.lex_state = 112},
  [3677] = {.lex_state = 112},
  [3678] = {.lex_state = 112},
  [3679] = {.lex_state = 112},
  [3680] = {.lex_state = 112},
  [3681] = {.lex_state = 112},
  [3682] = {.lex_state = 112},
  [3683] = {.lex_state = 112},
  [3684] = {.lex_state = 112},
  [3685] = {.lex_state = 112},
  [3686] = {.lex_state = 112},
  [3687] = {.lex_state = 112},
  [3688] = {.lex_state = 112},
  [3689] = {.lex_state = 0},
  [3690] = {.lex_state = 0},
  [3691] = {.lex_state = 0},
  [3692] = {.lex_state = 112},
  [3693] = {.lex_state = 112},
  [3694] = {.lex_state = 112},
  [3695] = {.lex_state = 112},
  [3696] = {.lex_state = 113},
  [3697] = {.lex_state = 112},
  [3698] = {.lex_state = 112},
  [3699] = {.lex_state = 112},
  [3700] = {.lex_state = 112},
  [3701] = {.lex_state = 112},
  [3702] = {.lex_state = 112},
  [3703] = {.lex_state = 112},
  [3704] = {.lex_state = 0},
  [3705] = {.lex_state = 112},
  [3706] = {.lex_state = 112},
  [3707] = {.lex_state = 112},
  [3708] = {.lex_state = 112},
  [3709] = {.lex_state = 112},
  [3710] = {.lex_state = 112},
  [3711] = {.lex_state = 112},
  [3712] = {.lex_state = 112},
  [3713] = {.lex_state = 112},
  [3714] = {.lex_state = 112},
  [3715] = {.lex_state = 112},
  [3716] = {.lex_state = 112},
  [3717] = {.lex_state = 112},
  [3718] = {.lex_state = 112},
  [3719] = {.lex_state = 112},
  [3720] = {.lex_state = 112},
  [3721] = {.lex_state = 112},
  [3722] = {.lex_state = 112},
  [3723] = {.lex_state = 112},
  [3724] = {.lex_state = 112},
  [3725] = {.lex_state = 112},
  [3726] = {.lex_state = 112},
  [3727] = {.lex_state = 112},
  [3728] = {.lex_state = 112},
  [3729] = {.lex_state = 112},
  [3730] = {.lex_state = 0},
  [3731] = {.lex_state = 112},
  [3732] = {.lex_state = 112},
  [3733] = {.lex_state = 112},
  [3734] = {.lex_state = 112},
  [3735] = {.lex_state = 0},
  [3736] = {.lex_state = 0},
  [3737] = {.lex_state = 112},
  [3738] = {.lex_state = 112},
  [3739] = {.lex_state = 0},
  [3740] = {.lex_state = 112},
  [3741] = {.lex_state = 112},
  [3742] = {.lex_state = 112},
  [3743] = {.lex_state = 112},
  [3744] = {.lex_state = 0},
  [3745] = {.lex_state = 112},
  [3746] = {.lex_state = 0},
  [3747] = {.lex_state = 112},
  [3748] = {.lex_state = 112},
  [3749] = {.lex_state = 112},
  [3750] = {.lex_state = 0},
  [3751] = {.lex_state = 112},
  [3752] = {.lex_state = 112},
  [3753] = {.lex_state = 0},
  [3754] = {.lex_state = 112},
  [3755] = {.lex_state = 112},
  [3756] = {.lex_state = 112},
  [3757] = {.lex_state = 0},
  [3758] = {.lex_state = 0},
  [3759] = {.lex_state = 112},
  [3760] = {.lex_state = 112},
  [3761] = {.lex_state = 112},
  [3762] = {.lex_state = 112},
  [3763] = {.lex_state = 112},
  [3764] = {.lex_state = 112},
  [3765] = {.lex_state = 112},
  [3766] = {.lex_state = 0},
  [3767] = {.lex_state = 112},
  [3768] = {.lex_state = 112},
  [3769] = {.lex_state = 112},
  [3770] = {.lex_state = 112},
  [3771] = {.lex_state = 112},
  [3772] = {.lex_state = 112},
  [3773] = {.lex_state = 112},
  [3774] = {.lex_state = 112},
  [3775] = {.lex_state = 4},
  [3776] = {.lex_state = 113},
  [3777] = {.lex_state = 0},
  [3778] = {.lex_state = 0},
  [3779] = {.lex_state = 0},
  [3780] = {.lex_state = 0},
  [3781] = {.lex_state = 9},
  [3782] = {.lex_state = 112},
  [3783] = {.lex_state = 4},
  [3784] = {.lex_state = 0},
  [3785] = {.lex_state = 0},
  [3786] = {.lex_state = 0},
  [3787] = {.lex_state = 6},
  [3788] = {.lex_state = 0},
  [3789] = {.lex_state = 0},
  [3790] = {.lex_state = 112},
  [3791] = {.lex_state = 0},
  [3792] = {.lex_state = 0},
  [3793] = {.lex_state = 0},
  [3794] = {.lex_state = 0},
  [3795] = {.lex_state = 0},
  [3796] = {.lex_state = 0},
  [3797] = {.lex_state = 0},
  [3798] = {.lex_state = 0},
  [3799] = {.lex_state = 0},
  [3800] = {.lex_state = 0},
  [3801] = {.lex_state = 0},
  [3802] = {.lex_state = 0},
  [3803] = {.lex_state = 0},
  [3804] = {.lex_state = 0},
  [3805] = {.lex_state = 0},
  [3806] = {.lex_state = 0},
  [3807] = {.lex_state = 0},
  [3808] = {.lex_state = 0},
  [3809] = {.lex_state = 0},
  [3810] = {.lex_state = 0},
  [3811] = {.lex_state = 0},
  [3812] = {.lex_state = 0},
  [3813] = {.lex_state = 0},
  [3814] = {.lex_state = 0},
  [3815] = {.lex_state = 0},
  [3816] = {.lex_state = 0},
  [3817] = {.lex_state = 0},
  [3818] = {.lex_state = 112},
  [3819] = {.lex_state = 0},
  [3820] = {.lex_state = 0},
  [3821] = {.lex_state = 112},
  [3822] = {.lex_state = 112},
  [3823] = {.lex_state = 112},
  [3824] = {.lex_state = 112},
  [3825] = {.lex_state = 0},
  [3826] = {.lex_state = 112},
  [3827] = {.lex_state = 0},
  [3828] = {.lex_state = 0},
  [3829] = {.lex_state = 4},
  [3830] = {.lex_state = 0},
  [3831] = {.lex_state = 0},
  [3832] = {.lex_state = 0},
  [3833] = {.lex_state = 0},
  [3834] = {.lex_state = 0},
  [3835] = {.lex_state = 0},
  [3836] = {.lex_state = 0},
  [3837] = {.lex_state = 0},
  [3838] = {.lex_state = 6},
  [3839] = {.lex_state = 0},
  [3840] = {.lex_state = 0},
  [3841] = {.lex_state = 0},
  [3842] = {.lex_state = 0},
  [3843] = {.lex_state = 0},
  [3844] = {.lex_state = 0},
  [3845] = {.lex_state = 0},
  [3846] = {.lex_state = 0},
  [3847] = {.lex_state = 112},
  [3848] = {.lex_state = 0},
  [3849] = {.lex_state = 112},
  [3850] = {.lex_state = 6},
  [3851] = {.lex_state = 0},
  [3852] = {.lex_state = 0},
  [3853] = {.lex_state = 4, .external_lex_state = 4},
  [3854] = {.lex_state = 0},
  [3855] = {.lex_state = 0},
  [3856] = {.lex_state = 4},
  [3857] = {.lex_state = 0},
  [3858] = {.lex_state = 0},
  [3859] = {.lex_state = 6},
  [3860] = {.lex_state = 112},
  [3861] = {.lex_state = 112},
  [3862] = {.lex_state = 4, .external_lex_state = 4},
  [3863] = {.lex_state = 4},
  [3864] = {.lex_state = 4, .external_lex_state = 4},
  [3865] = {.lex_state = 112},
  [3866] = {.lex_state = 0},
  [3867] = {.lex_state = 4, .external_lex_state = 4},
  [3868] = {.lex_state = 112},
  [3869] = {.lex_state = 112},
  [3870] = {.lex_state = 4, .external_lex_state = 4},
  [3871] = {.lex_state = 113},
  [3872] = {.lex_state = 4, .external_lex_state = 4},
  [3873] = {.lex_state = 4, .external_lex_state = 4},
  [3874] = {.lex_state = 112},
  [3875] = {.lex_state = 4, .external_lex_state = 4},
  [3876] = {.lex_state = 112},
  [3877] = {.lex_state = 112},
  [3878] = {.lex_state = 112},
  [3879] = {.lex_state = 4, .external_lex_state = 4},
  [3880] = {.lex_state = 112},
  [3881] = {.lex_state = 112},
  [3882] = {.lex_state = 5},
  [3883] = {.lex_state = 5},
  [3884] = {.lex_state = 4, .external_lex_state = 4},
  [3885] = {.lex_state = 112},
  [3886] = {.lex_state = 4, .external_lex_state = 4},
  [3887] = {.lex_state = 112},
  [3888] = {.lex_state = 112},
  [3889] = {.lex_state = 112},
  [3890] = {.lex_state = 112},
  [3891] = {.lex_state = 6},
  [3892] = {.lex_state = 112},
  [3893] = {.lex_state = 112},
  [3894] = {.lex_state = 4, .external_lex_state = 4},
  [3895] = {.lex_state = 112},
  [3896] = {.lex_state = 112},
  [3897] = {.lex_state = 6},
  [3898] = {.lex_state = 6},
  [3899] = {.lex_state = 4, .external_lex_state = 4},
  [3900] = {.lex_state = 112},
  [3901] = {.lex_state = 112},
  [3902] = {.lex_state = 112},
  [3903] = {.lex_state = 112},
  [3904] = {.lex_state = 112},
  [3905] = {.lex_state = 112},
  [3906] = {.lex_state = 112},
  [3907] = {.lex_state = 112},
  [3908] = {.lex_state = 112},
  [3909] = {.lex_state = 4, .external_lex_state = 4},
  [3910] = {.lex_state = 112},
  [3911] = {.lex_state = 4, .external_lex_state = 4},
  [3912] = {.lex_state = 112},
  [3913] = {.lex_state = 4, .external_lex_state = 4},
  [3914] = {.lex_state = 4, .external_lex_state = 4},
  [3915] = {.lex_state = 112},
  [3916] = {.lex_state = 112},
  [3917] = {.lex_state = 112},
  [3918] = {.lex_state = 112},
  [3919] = {.lex_state = 112},
  [3920] = {.lex_state = 4, .external_lex_state = 4},
  [3921] = {.lex_state = 4, .external_lex_state = 4},
  [3922] = {.lex_state = 112},
  [3923] = {.lex_state = 112},
  [3924] = {.lex_state = 4, .external_lex_state = 4},
  [3925] = {.lex_state = 112},
  [3926] = {.lex_state = 112},
  [3927] = {.lex_state = 112},
  [3928] = {.lex_state = 6},
  [3929] = {.lex_state = 112},
  [3930] = {.lex_state = 112},
  [3931] = {.lex_state = 112},
  [3932] = {.lex_state = 112},
  [3933] = {.lex_state = 5},
  [3934] = {.lex_state = 112},
  [3935] = {.lex_state = 112},
  [3936] = {.lex_state = 112},
  [3937] = {.lex_state = 112},
  [3938] = {.lex_state = 112},
  [3939] = {.lex_state = 112},
  [3940] = {.lex_state = 112},
  [3941] = {.lex_state = 112},
  [3942] = {.lex_state = 112},
  [3943] = {.lex_state = 112},
  [3944] = {.lex_state = 112},
  [3945] = {.lex_state = 112},
  [3946] = {.lex_state = 112},
  [3947] = {.lex_state = 112},
  [3948] = {.lex_state = 0},
  [3949] = {.lex_state = 112},
  [3950] = {.lex_state = 112},
  [3951] = {.lex_state = 112},
  [3952] = {.lex_state = 112},
  [3953] = {.lex_state = 112},
  [3954] = {.lex_state = 112},
  [3955] = {.lex_state = 112},
  [3956] = {.lex_state = 112},
  [3957] = {.lex_state = 112},
  [3958] = {.lex_state = 0},
  [3959] = {.lex_state = 112},
  [3960] = {.lex_state = 112},
  [3961] = {.lex_state = 112},
  [3962] = {.lex_state = 112},
  [3963] = {.lex_state = 112},
  [3964] = {.lex_state = 112},
  [3965] = {.lex_state = 112},
  [3966] = {.lex_state = 112},
  [3967] = {.lex_state = 112},
  [3968] = {.lex_state = 112},
  [3969] = {.lex_state = 112},
  [3970] = {.lex_state = 112},
  [3971] = {.lex_state = 112},
  [3972] = {.lex_state = 112},
  [3973] = {.lex_state = 112},
  [3974] = {.lex_state = 112},
  [3975] = {.lex_state = 112},
  [3976] = {.lex_state = 112},
  [3977] = {.lex_state = 112},
  [3978] = {.lex_state = 112},
  [3979] = {.lex_state = 0},
  [3980] = {.lex_state = 112},
  [3981] = {.lex_state = 112},
  [3982] = {.lex_state = 112},
  [3983] = {.lex_state = 0},
  [3984] = {.lex_state = 112},
  [3985] = {.lex_state = 112},
  [3986] = {.lex_state = 112},
  [3987] = {.lex_state = 112},
  [3988] = {.lex_state = 112},
  [3989] = {.lex_state = 6},
  [3990] = {.lex_state = 112},
  [3991] = {.lex_state = 112},
  [3992] = {.lex_state = 112},
  [3993] = {.lex_state = 112},
  [3994] = {.lex_state = 112},
  [3995] = {.lex_state = 112},
  [3996] = {.lex_state = 112},
  [3997] = {.lex_state = 112},
  [3998] = {.lex_state = 112},
  [3999] = {.lex_state = 112},
  [4000] = {.lex_state = 112},
  [4001] = {.lex_state = 112},
  [4002] = {.lex_state = 0},
  [4003] = {.lex_state = 112},
  [4004] = {.lex_state = 112},
  [4005] = {.lex_state = 0},
  [4006] = {.lex_state = 112},
  [4007] = {.lex_state = 112},
  [4008] = {.lex_state = 4},
  [4009] = {.lex_state = 0},
  [4010] = {.lex_state = 112},
  [4011] = {.lex_state = 0},
  [4012] = {.lex_state = 112},
  [4013] = {.lex_state = 112},
  [4014] = {.lex_state = 5},
  [4015] = {.lex_state = 112},
  [4016] = {.lex_state = 112},
  [4017] = {.lex_state = 112},
  [4018] = {.lex_state = 112},
  [4019] = {.lex_state = 4},
  [4020] = {.lex_state = 112},
  [4021] = {.lex_state = 112},
  [4022] = {.lex_state = 112},
  [4023] = {.lex_state = 112},
  [4024] = {.lex_state = 112},
  [4025] = {.lex_state = 112},
  [4026] = {.lex_state = 112},
  [4027] = {.lex_state = 112},
  [4028] = {.lex_state = 112},
  [4029] = {.lex_state = 112},
  [4030] = {.lex_state = 112},
  [4031] = {.lex_state = 112},
  [4032] = {.lex_state = 112},
  [4033] = {.lex_state = 112},
  [4034] = {.lex_state = 112},
  [4035] = {.lex_state = 112},
  [4036] = {.lex_state = 112},
  [4037] = {.lex_state = 112},
  [4038] = {.lex_state = 112},
  [4039] = {.lex_state = 112},
  [4040] = {.lex_state = 112},
  [4041] = {.lex_state = 112},
  [4042] = {.lex_state = 112},
  [4043] = {.lex_state = 112},
  [4044] = {.lex_state = 112},
  [4045] = {.lex_state = 112},
  [4046] = {.lex_state = 112},
  [4047] = {.lex_state = 112},
  [4048] = {.lex_state = 112},
  [4049] = {.lex_state = 112},
  [4050] = {.lex_state = 112},
  [4051] = {.lex_state = 112},
  [4052] = {.lex_state = 112},
  [4053] = {.lex_state = 112},
  [4054] = {.lex_state = 4, .external_lex_state = 4},
  [4055] = {.lex_state = 112},
  [4056] = {.lex_state = 112},
  [4057] = {.lex_state = 112},
  [4058] = {.lex_state = 112},
  [4059] = {.lex_state = 112},
  [4060] = {.lex_state = 112},
  [4061] = {.lex_state = 112},
  [4062] = {.lex_state = 112},
  [4063] = {.lex_state = 112},
  [4064] = {.lex_state = 112},
  [4065] = {.lex_state = 112},
  [4066] = {.lex_state = 112},
  [4067] = {.lex_state = 112},
  [4068] = {.lex_state = 0},
  [4069] = {.lex_state = 0},
  [4070] = {.lex_state = 112},
  [4071] = {.lex_state = 112},
  [4072] = {.lex_state = 0},
  [4073] = {.lex_state = 112},
  [4074] = {.lex_state = 0},
  [4075] = {.lex_state = 0},
  [4076] = {.lex_state = 0},
  [4077] = {.lex_state = 0},
  [4078] = {.lex_state = 0},
  [4079] = {.lex_state = 112},
  [4080] = {.lex_state = 0},
  [4081] = {.lex_state = 0},
  [4082] = {.lex_state = 112},
  [4083] = {.lex_state = 0},
  [4084] = {.lex_state = 0},
  [4085] = {.lex_state = 112},
  [4086] = {.lex_state = 0},
  [4087] = {.lex_state = 0},
  [4088] = {.lex_state = 112},
  [4089] = {.lex_state = 0},
  [4090] = {.lex_state = 0},
  [4091] = {.lex_state = 112},
  [4092] = {.lex_state = 112},
  [4093] = {.lex_state = 112},
  [4094] = {.lex_state = 112},
  [4095] = {.lex_state = 112},
  [4096] = {.lex_state = 0},
  [4097] = {.lex_state = 112},
  [4098] = {.lex_state = 112},
  [4099] = {.lex_state = 0},
  [4100] = {.lex_state = 112},
  [4101] = {.lex_state = 0},
  [4102] = {.lex_state = 0},
  [4103] = {.lex_state = 112},
  [4104] = {.lex_state = 112},
  [4105] = {.lex_state = 0},
  [4106] = {.lex_state = 4},
  [4107] = {.lex_state = 112},
  [4108] = {.lex_state = 0},
  [4109] = {.lex_state = 0},
  [4110] = {.lex_state = 112},
  [4111] = {.lex_state = 0},
  [4112] = {.lex_state = 112},
  [4113] = {.lex_state = 112},
  [4114] = {.lex_state = 0},
  [4115] = {.lex_state = 0},
  [4116] = {.lex_state = 112},
  [4117] = {.lex_state = 112},
  [4118] = {.lex_state = 112},
  [4119] = {.lex_state = 0},
  [4120] = {.lex_state = 0},
  [4121] = {.lex_state = 112},
  [4122] = {.lex_state = 0},
  [4123] = {.lex_state = 112},
  [4124] = {.lex_state = 112},
  [4125] = {.lex_state = 112},
  [4126] = {.lex_state = 0},
  [4127] = {.lex_state = 0},
  [4128] = {.lex_state = 0},
  [4129] = {.lex_state = 0},
  [4130] = {.lex_state = 112},
  [4131] = {.lex_state = 0},
  [4132] = {.lex_state = 112},
  [4133] = {.lex_state = 0},
  [4134] = {.lex_state = 0},
  [4135] = {.lex_state = 112},
  [4136] = {.lex_state = 112},
  [4137] = {.lex_state = 0},
  [4138] = {.lex_state = 112},
  [4139] = {.lex_state = 112},
  [4140] = {.lex_state = 112},
  [4141] = {.lex_state = 0},
  [4142] = {.lex_state = 0},
  [4143] = {.lex_state = 0},
  [4144] = {.lex_state = 0},
  [4145] = {.lex_state = 0},
  [4146] = {.lex_state = 0},
  [4147] = {.lex_state = 0},
  [4148] = {.lex_state = 0},
  [4149] = {.lex_state = 0},
  [4150] = {.lex_state = 0},
  [4151] = {.lex_state = 112},
  [4152] = {.lex_state = 0},
  [4153] = {.lex_state = 0},
  [4154] = {.lex_state = 0},
  [4155] = {.lex_state = 0},
  [4156] = {.lex_state = 0},
  [4157] = {.lex_state = 0},
  [4158] = {.lex_state = 0},
  [4159] = {.lex_state = 112},
  [4160] = {.lex_state = 112},
  [4161] = {.lex_state = 0},
  [4162] = {.lex_state = 0},
  [4163] = {.lex_state = 4},
  [4164] = {.lex_state = 112},
  [4165] = {.lex_state = 0},
  [4166] = {.lex_state = 0},
  [4167] = {.lex_state = 0},
  [4168] = {.lex_state = 113},
  [4169] = {.lex_state = 112},
  [4170] = {.lex_state = 112},
  [4171] = {.lex_state = 0},
  [4172] = {.lex_state = 112},
  [4173] = {.lex_state = 112},
  [4174] = {.lex_state = 112},
  [4175] = {.lex_state = 0},
  [4176] = {.lex_state = 112},
  [4177] = {.lex_state = 112},
  [4178] = {.lex_state = 0},
  [4179] = {.lex_state = 112},
  [4180] = {.lex_state = 0},
  [4181] = {.lex_state = 0},
  [4182] = {.lex_state = 0},
  [4183] = {.lex_state = 0},
  [4184] = {.lex_state = 0},
  [4185] = {.lex_state = 0},
  [4186] = {.lex_state = 112},
  [4187] = {.lex_state = 0},
  [4188] = {.lex_state = 112},
  [4189] = {.lex_state = 0},
  [4190] = {.lex_state = 0},
  [4191] = {.lex_state = 0},
  [4192] = {.lex_state = 0},
  [4193] = {.lex_state = 112},
  [4194] = {.lex_state = 0},
  [4195] = {.lex_state = 0},
  [4196] = {.lex_state = 0},
  [4197] = {.lex_state = 0},
  [4198] = {.lex_state = 0},
  [4199] = {.lex_state = 112},
  [4200] = {.lex_state = 0},
  [4201] = {.lex_state = 113},
  [4202] = {.lex_state = 0},
  [4203] = {.lex_state = 112},
  [4204] = {.lex_state = 112},
  [4205] = {.lex_state = 112},
  [4206] = {.lex_state = 0},
  [4207] = {.lex_state = 112},
  [4208] = {.lex_state = 112},
  [4209] = {.lex_state = 0},
  [4210] = {.lex_state = 4},
  [4211] = {.lex_state = 112},
  [4212] = {.lex_state = 112},
  [4213] = {.lex_state = 112},
  [4214] = {.lex_state = 0},
  [4215] = {.lex_state = 112},
  [4216] = {.lex_state = 0},
  [4217] = {.lex_state = 112},
  [4218] = {.lex_state = 112},
  [4219] = {.lex_state = 0},
  [4220] = {.lex_state = 0},
  [4221] = {.lex_state = 0},
  [4222] = {.lex_state = 112},
  [4223] = {.lex_state = 0},
  [4224] = {.lex_state = 112},
  [4225] = {.lex_state = 0},
  [4226] = {.lex_state = 0},
  [4227] = {.lex_state = 0},
  [4228] = {.lex_state = 0},
  [4229] = {.lex_state = 0},
  [4230] = {.lex_state = 0},
  [4231] = {.lex_state = 0},
  [4232] = {.lex_state = 0},
  [4233] = {.lex_state = 0},
  [4234] = {.lex_state = 0},
  [4235] = {.lex_state = 112},
  [4236] = {.lex_state = 0},
  [4237] = {.lex_state = 0},
  [4238] = {.lex_state = 0},
  [4239] = {.lex_state = 112},
  [4240] = {.lex_state = 0},
  [4241] = {.lex_state = 0},
  [4242] = {.lex_state = 0},
  [4243] = {.lex_state = 0},
  [4244] = {.lex_state = 0},
  [4245] = {.lex_state = 0},
  [4246] = {.lex_state = 112},
  [4247] = {.lex_state = 112},
  [4248] = {.lex_state = 0},
  [4249] = {.lex_state = 112},
  [4250] = {.lex_state = 0},
  [4251] = {.lex_state = 112},
  [4252] = {.lex_state = 112},
  [4253] = {.lex_state = 0},
  [4254] = {.lex_state = 112},
  [4255] = {.lex_state = 112},
  [4256] = {.lex_state = 112},
  [4257] = {.lex_state = 112},
  [4258] = {.lex_state = 0},
  [4259] = {.lex_state = 112},
  [4260] = {.lex_state = 112},
  [4261] = {.lex_state = 112},
  [4262] = {.lex_state = 0},
  [4263] = {.lex_state = 0},
  [4264] = {.lex_state = 0},
  [4265] = {.lex_state = 0},
  [4266] = {.lex_state = 0},
  [4267] = {.lex_state = 112},
  [4268] = {.lex_state = 112},
  [4269] = {.lex_state = 112},
  [4270] = {.lex_state = 112},
  [4271] = {.lex_state = 0},
  [4272] = {.lex_state = 0},
  [4273] = {.lex_state = 0},
  [4274] = {.lex_state = 112},
  [4275] = {.lex_state = 0},
  [4276] = {.lex_state = 0},
  [4277] = {.lex_state = 0},
  [4278] = {.lex_state = 0},
  [4279] = {.lex_state = 0},
  [4280] = {.lex_state = 0},
  [4281] = {.lex_state = 0},
  [4282] = {.lex_state = 112},
  [4283] = {.lex_state = 0},
  [4284] = {.lex_state = 0},
  [4285] = {.lex_state = 0},
  [4286] = {.lex_state = 112},
  [4287] = {.lex_state = 0},
  [4288] = {.lex_state = 0},
  [4289] = {.lex_state = 112},
  [4290] = {.lex_state = 112},
  [4291] = {.lex_state = 4},
  [4292] = {.lex_state = 0},
  [4293] = {.lex_state = 0},
  [4294] = {.lex_state = 112},
  [4295] = {.lex_state = 4, .external_lex_state = 4},
  [4296] = {.lex_state = 0},
  [4297] = {.lex_state = 0},
  [4298] = {.lex_state = 0},
  [4299] = {.lex_state = 0},
  [4300] = {.lex_state = 0},
  [4301] = {.lex_state = 0},
  [4302] = {.lex_state = 112},
  [4303] = {.lex_state = 0},
  [4304] = {.lex_state = 0},
  [4305] = {.lex_state = 0},
  [4306] = {.lex_state = 4},
  [4307] = {.lex_state = 0},
  [4308] = {.lex_state = 112},
  [4309] = {.lex_state = 112},
  [4310] = {.lex_state = 113},
  [4311] = {.lex_state = 113},
  [4312] = {.lex_state = 4},
  [4313] = {.lex_state = 0},
  [4314] = {.lex_state = 0},
  [4315] = {.lex_state = 0},
  [4316] = {.lex_state = 0},
  [4317] = {.lex_state = 0},
  [4318] = {.lex_state = 0},
  [4319] = {.lex_state = 112},
  [4320] = {.lex_state = 0},
  [4321] = {.lex_state = 0},
  [4322] = {.lex_state = 0},
  [4323] = {.lex_state = 4, .external_lex_state = 4},
  [4324] = {.lex_state = 113},
  [4325] = {.lex_state = 112},
  [4326] = {.lex_state = 0},
  [4327] = {.lex_state = 112},
  [4328] = {.lex_state = 112},
  [4329] = {.lex_state = 0},
  [4330] = {.lex_state = 0},
  [4331] = {.lex_state = 0},
  [4332] = {.lex_state = 0},
  [4333] = {.lex_state = 0},
  [4334] = {.lex_state = 0},
  [4335] = {.lex_state = 0},
  [4336] = {.lex_state = 112},
  [4337] = {.lex_state = 0},
  [4338] = {.lex_state = 0},
  [4339] = {.lex_state = 0},
  [4340] = {.lex_state = 0},
  [4341] = {.lex_state = 0},
  [4342] = {.lex_state = 0},
  [4343] = {.lex_state = 0},
  [4344] = {.lex_state = 112},
  [4345] = {.lex_state = 112},
  [4346] = {.lex_state = 112},
  [4347] = {.lex_state = 112},
  [4348] = {.lex_state = 0},
  [4349] = {.lex_state = 0},
  [4350] = {.lex_state = 112},
  [4351] = {.lex_state = 0},
  [4352] = {.lex_state = 9},
  [4353] = {.lex_state = 9},
  [4354] = {.lex_state = 112},
  [4355] = {.lex_state = 0},
  [4356] = {.lex_state = 112},
  [4357] = {.lex_state = 112},
  [4358] = {.lex_state = 112},
  [4359] = {.lex_state = 112},
  [4360] = {.lex_state = 0},
  [4361] = {.lex_state = 0},
  [4362] = {.lex_state = 9},
  [4363] = {.lex_state = 0},
  [4364] = {.lex_state = 0},
  [4365] = {.lex_state = 0},
  [4366] = {.lex_state = 0},
  [4367] = {.lex_state = 9},
  [4368] = {.lex_state = 0},
  [4369] = {.lex_state = 112},
  [4370] = {.lex_state = 0},
  [4371] = {.lex_state = 112},
  [4372] = {.lex_state = 9},
  [4373] = {.lex_state = 112},
  [4374] = {.lex_state = 0},
  [4375] = {.lex_state = 0},
  [4376] = {.lex_state = 0},
  [4377] = {.lex_state = 9},
  [4378] = {.lex_state = 9},
  [4379] = {.lex_state = 112},
  [4380] = {.lex_state = 0},
  [4381] = {.lex_state = 0},
  [4382] = {.lex_state = 112},
  [4383] = {.lex_state = 0},
  [4384] = {.lex_state = 112},
  [4385] = {.lex_state = 112},
  [4386] = {.lex_state = 112},
  [4387] = {.lex_state = 112},
  [4388] = {.lex_state = 112},
  [4389] = {.lex_state = 0},
  [4390] = {.lex_state = 112},
  [4391] = {.lex_state = 112},
  [4392] = {.lex_state = 9},
  [4393] = {.lex_state = 0},
  [4394] = {.lex_state = 112},
  [4395] = {.lex_state = 112},
  [4396] = {.lex_state = 112},
  [4397] = {.lex_state = 0},
  [4398] = {.lex_state = 112},
  [4399] = {.lex_state = 0},
  [4400] = {.lex_state = 9},
  [4401] = {.lex_state = 112},
  [4402] = {.lex_state = 112},
  [4403] = {.lex_state = 0},
  [4404] = {.lex_state = 112},
  [4405] = {.lex_state = 0},
  [4406] = {.lex_state = 0},
  [4407] = {.lex_state = 0},
  [4408] = {.lex_state = 9},
  [4409] = {.lex_state = 9},
  [4410] = {.lex_state = 0},
  [4411] = {.lex_state = 0},
  [4412] = {.lex_state = 0},
  [4413] = {.lex_state = 0},
  [4414] = {.lex_state = 0},
  [4415] = {.lex_state = 0},
  [4416] = {.lex_state = 0},
  [4417] = {.lex_state = 9},
  [4418] = {.lex_state = 0},
  [4419] = {.lex_state = 0},
  [4420] = {.lex_state = 112},
  [4421] = {.lex_state = 112},
  [4422] = {.lex_state = 0},
  [4423] = {.lex_state = 0},
  [4424] = {.lex_state = 112},
  [4425] = {.lex_state = 0},
  [4426] = {.lex_state = 9},
  [4427] = {.lex_state = 9},
  [4428] = {.lex_state = 0},
  [4429] = {.lex_state = 0},
  [4430] = {.lex_state = 0},
  [4431] = {.lex_state = 112},
  [4432] = {.lex_state = 112},
  [4433] = {.lex_state = 9},
  [4434] = {.lex_state = 112},
  [4435] = {.lex_state = 112},
  [4436] = {.lex_state = 112},
  [4437] = {.lex_state = 112},
  [4438] = {.lex_state = 112},
  [4439] = {.lex_state = 112},
  [4440] = {.lex_state = 112},
  [4441] = {.lex_state = 112},
  [4442] = {.lex_state = 112},
  [4443] = {.lex_state = 9},
  [4444] = {.lex_state = 112},
  [4445] = {.lex_state = 112},
  [4446] = {.lex_state = 112},
  [4447] = {.lex_state = 0},
  [4448] = {.lex_state = 0},
  [4449] = {.lex_state = 0},
  [4450] = {.lex_state = 0},
  [4451] = {.lex_state = 112},
  [4452] = {.lex_state = 112},
  [4453] = {.lex_state = 112},
  [4454] = {.lex_state = 112},
  [4455] = {.lex_state = 112},
  [4456] = {.lex_state = 112},
  [4457] = {.lex_state = 112},
  [4458] = {.lex_state = 0},
  [4459] = {.lex_state = 0},
  [4460] = {.lex_state = 112},
  [4461] = {.lex_state = 112},
  [4462] = {.lex_state = 0},
  [4463] = {.lex_state = 112},
  [4464] = {.lex_state = 0},
  [4465] = {.lex_state = 112},
  [4466] = {.lex_state = 0},
  [4467] = {.lex_state = 0},
  [4468] = {.lex_state = 112},
  [4469] = {.lex_state = 112},
  [4470] = {.lex_state = 112},
  [4471] = {.lex_state = 112},
  [4472] = {.lex_state = 112},
  [4473] = {.lex_state = 0},
  [4474] = {.lex_state = 0},
  [4475] = {.lex_state = 112},
  [4476] = {.lex_state = 112},
  [4477] = {.lex_state = 0},
  [4478] = {.lex_state = 0},
  [4479] = {.lex_state = 112},
  [4480] = {.lex_state = 0},
  [4481] = {.lex_state = 112},
  [4482] = {.lex_state = 4},
  [4483] = {.lex_state = 112},
  [4484] = {.lex_state = 112},
  [4485] = {.lex_state = 112},
  [4486] = {.lex_state = 112},
  [4487] = {.lex_state = 112},
  [4488] = {.lex_state = 112},
  [4489] = {.lex_state = 112},
  [4490] = {.lex_state = 112},
  [4491] = {.lex_state = 112},
  [4492] = {.lex_state = 112},
  [4493] = {.lex_state = 112},
  [4494] = {.lex_state = 112},
  [4495] = {.lex_state = 0},
  [4496] = {.lex_state = 112},
  [4497] = {.lex_state = 112},
  [4498] = {.lex_state = 0},
  [4499] = {.lex_state = 112},
  [4500] = {.lex_state = 0},
  [4501] = {.lex_state = 112},
  [4502] = {.lex_state = 112},
  [4503] = {.lex_state = 112},
  [4504] = {.lex_state = 112},
  [4505] = {.lex_state = 112},
  [4506] = {.lex_state = 0},
  [4507] = {.lex_state = 0},
  [4508] = {.lex_state = 112},
  [4509] = {.lex_state = 112},
  [4510] = {.lex_state = 112},
  [4511] = {.lex_state = 0},
  [4512] = {.lex_state = 112},
  [4513] = {.lex_state = 112},
  [4514] = {.lex_state = 112},
  [4515] = {.lex_state = 112},
  [4516] = {.lex_state = 112},
  [4517] = {.lex_state = 0},
  [4518] = {.lex_state = 0},
  [4519] = {.lex_state = 112},
  [4520] = {.lex_state = 0},
  [4521] = {.lex_state = 112},
  [4522] = {.lex_state = 112},
  [4523] = {.lex_state = 112},
  [4524] = {.lex_state = 112},
  [4525] = {.lex_state = 0},
  [4526] = {.lex_state = 112},
  [4527] = {.lex_state = 0},
  [4528] = {.lex_state = 0},
  [4529] = {.lex_state = 0},
  [4530] = {.lex_state = 0},
  [4531] = {.lex_state = 0},
  [4532] = {.lex_state = 0},
  [4533] = {.lex_state = 0},
  [4534] = {.lex_state = 112},
  [4535] = {.lex_state = 0},
  [4536] = {.lex_state = 0},
  [4537] = {.lex_state = 0},
  [4538] = {.lex_state = 0},
  [4539] = {.lex_state = 112},
  [4540] = {.lex_state = 112},
  [4541] = {.lex_state = 113},
  [4542] = {.lex_state = 112},
  [4543] = {.lex_state = 112},
  [4544] = {.lex_state = 112},
  [4545] = {.lex_state = 0},
  [4546] = {.lex_state = 112},
  [4547] = {.lex_state = 112},
  [4548] = {.lex_state = 0},
  [4549] = {.lex_state = 112},
  [4550] = {.lex_state = 112},
  [4551] = {.lex_state = 112},
  [4552] = {.lex_state = 112},
  [4553] = {.lex_state = 112},
  [4554] = {.lex_state = 112},
  [4555] = {.lex_state = 112},
  [4556] = {.lex_state = 0},
  [4557] = {.lex_state = 112},
  [4558] = {.lex_state = 112},
  [4559] = {.lex_state = 112},
  [4560] = {.lex_state = 0},
  [4561] = {.lex_state = 0},
  [4562] = {.lex_state = 112},
  [4563] = {.lex_state = 113},
  [4564] = {.lex_state = 0},
  [4565] = {.lex_state = 112},
  [4566] = {.lex_state = 0},
  [4567] = {.lex_state = 112},
  [4568] = {.lex_state = 0},
  [4569] = {.lex_state = 112},
  [4570] = {.lex_state = 112},
  [4571] = {.lex_state = 112},
  [4572] = {.lex_state = 0},
  [4573] = {.lex_state = 112},
  [4574] = {.lex_state = 112},
  [4575] = {.lex_state = 112},
  [4576] = {.lex_state = 0},
  [4577] = {.lex_state = 0},
  [4578] = {.lex_state = 0},
  [4579] = {.lex_state = 112},
  [4580] = {.lex_state = 112},
  [4581] = {.lex_state = 112},
  [4582] = {.lex_state = 112},
  [4583] = {.lex_state = 112},
  [4584] = {.lex_state = 112},
  [4585] = {.lex_state = 112},
  [4586] = {.lex_state = 112},
  [4587] = {.lex_state = 112},
  [4588] = {.lex_state = 0},
  [4589] = {.lex_state = 112},
  [4590] = {.lex_state = 112},
  [4591] = {.lex_state = 113},
  [4592] = {.lex_state = 112},
  [4593] = {.lex_state = 112},
  [4594] = {.lex_state = 112},
  [4595] = {.lex_state = 112},
  [4596] = {.lex_state = 0},
  [4597] = {.lex_state = 112},
  [4598] = {.lex_state = 112},
  [4599] = {.lex_state = 112},
  [4600] = {.lex_state = 0},
  [4601] = {.lex_state = 112},
  [4602] = {.lex_state = 0},
  [4603] = {.lex_state = 112},
  [4604] = {.lex_state = 112},
  [4605] = {.lex_state = 0},
  [4606] = {.lex_state = 112},
  [4607] = {.lex_state = 112},
  [4608] = {.lex_state = 113},
  [4609] = {.lex_state = 0},
  [4610] = {.lex_state = 0},
  [4611] = {.lex_state = 112},
  [4612] = {.lex_state = 113},
  [4613] = {.lex_state = 0},
  [4614] = {.lex_state = 112},
  [4615] = {.lex_state = 112},
  [4616] = {.lex_state = 0},
  [4617] = {.lex_state = 112},
  [4618] = {.lex_state = 0},
  [4619] = {.lex_state = 112},
  [4620] = {.lex_state = 112},
  [4621] = {.lex_state = 0},
  [4622] = {.lex_state = 0},
  [4623] = {.lex_state = 113},
  [4624] = {.lex_state = 112},
  [4625] = {.lex_state = 0},
  [4626] = {.lex_state = 112},
  [4627] = {.lex_state = 0},
  [4628] = {.lex_state = 112},
  [4629] = {.lex_state = 0},
  [4630] = {.lex_state = 112},
  [4631] = {.lex_state = 113},
  [4632] = {.lex_state = 0},
  [4633] = {.lex_state = 0},
  [4634] = {.lex_state = 112},
  [4635] = {.lex_state = 112},
  [4636] = {.lex_state = 112},
  [4637] = {.lex_state = 112},
  [4638] = {.lex_state = 0},
  [4639] = {.lex_state = 0},
  [4640] = {.lex_state = 112},
  [4641] = {.lex_state = 112},
  [4642] = {.lex_state = 112},
  [4643] = {.lex_state = 6},
  [4644] = {.lex_state = 0},
  [4645] = {.lex_state = 113},
  [4646] = {.lex_state = 112},
  [4647] = {.lex_state = 112},
  [4648] = {.lex_state = 112},
  [4649] = {.lex_state = 112},
  [4650] = {.lex_state = 112},
  [4651] = {.lex_state = 112},
  [4652] = {.lex_state = 0},
  [4653] = {.lex_state = 0},
  [4654] = {.lex_state = 0},
  [4655] = {.lex_state = 112},
  [4656] = {.lex_state = 112},
  [4657] = {.lex_state = 112},
  [4658] = {.lex_state = 112},
  [4659] = {.lex_state = 112},
  [4660] = {.lex_state = 112},
  [4661] = {.lex_state = 112},
  [4662] = {.lex_state = 112},
  [4663] = {.lex_state = 112},
  [4664] = {.lex_state = 112},
  [4665] = {.lex_state = 0},
  [4666] = {.lex_state = 112},
  [4667] = {.lex_state = 112},
  [4668] = {.lex_state = 112},
  [4669] = {.lex_state = 112},
  [4670] = {.lex_state = 112},
  [4671] = {.lex_state = 112},
  [4672] = {.lex_state = 112},
  [4673] = {.lex_state = 112},
  [4674] = {.lex_state = 0},
  [4675] = {.lex_state = 112},
  [4676] = {.lex_state = 112},
  [4677] = {.lex_state = 112},
  [4678] = {.lex_state = 112},
  [4679] = {.lex_state = 112},
  [4680] = {.lex_state = 112},
  [4681] = {.lex_state = 112},
  [4682] = {.lex_state = 112},
  [4683] = {.lex_state = 0},
  [4684] = {.lex_state = 112},
  [4685] = {.lex_state = 112},
  [4686] = {.lex_state = 0},
  [4687] = {.lex_state = 112},
  [4688] = {.lex_state = 112},
  [4689] = {.lex_state = 112},
  [4690] = {.lex_state = 112},
  [4691] = {.lex_state = 0},
  [4692] = {.lex_state = 112},
  [4693] = {.lex_state = 112},
  [4694] = {.lex_state = 0},
  [4695] = {.lex_state = 112},
  [4696] = {.lex_state = 112},
  [4697] = {.lex_state = 0},
  [4698] = {.lex_state = 112},
  [4699] = {.lex_state = 112},
  [4700] = {.lex_state = 112},
  [4701] = {.lex_state = 112},
  [4702] = {.lex_state = 0},
  [4703] = {.lex_state = 0},
  [4704] = {.lex_state = 0},
  [4705] = {.lex_state = 0},
  [4706] = {.lex_state = 0},
  [4707] = {.lex_state = 112},
  [4708] = {.lex_state = 0},
  [4709] = {.lex_state = 112},
  [4710] = {.lex_state = 0},
  [4711] = {.lex_state = 112},
  [4712] = {.lex_state = 112},
  [4713] = {.lex_state = 0},
  [4714] = {.lex_state = 0},
  [4715] = {.lex_state = 113},
  [4716] = {.lex_state = 0},
  [4717] = {.lex_state = 112},
  [4718] = {.lex_state = 112},
  [4719] = {.lex_state = 0},
  [4720] = {.lex_state = 0},
  [4721] = {.lex_state = 112},
  [4722] = {.lex_state = 0},
  [4723] = {.lex_state = 0},
  [4724] = {.lex_state = 112},
  [4725] = {.lex_state = 0},
  [4726] = {.lex_state = 0},
  [4727] = {.lex_state = 0},
  [4728] = {.lex_state = 0},
  [4729] = {.lex_state = 0},
  [4730] = {.lex_state = 112},
  [4731] = {.lex_state = 0},
  [4732] = {.lex_state = 112},
  [4733] = {.lex_state = 112},
  [4734] = {.lex_state = 0},
  [4735] = {.lex_state = 112},
  [4736] = {.lex_state = 0},
  [4737] = {.lex_state = 0},
  [4738] = {.lex_state = 0},
  [4739] = {.lex_state = 0},
  [4740] = {.lex_state = 0},
  [4741] = {.lex_state = 0},
  [4742] = {.lex_state = 112},
  [4743] = {.lex_state = 112},
  [4744] = {.lex_state = 9},
  [4745] = {.lex_state = 112},
  [4746] = {.lex_state = 0},
  [4747] = {.lex_state = 0},
  [4748] = {.lex_state = 0},
  [4749] = {.lex_state = 112},
  [4750] = {.lex_state = 0},
  [4751] = {.lex_state = 0},
  [4752] = {.lex_state = 0},
  [4753] = {.lex_state = 112},
  [4754] = {.lex_state = 0},
  [4755] = {.lex_state = 0},
  [4756] = {.lex_state = 0},
  [4757] = {.lex_state = 0},
  [4758] = {.lex_state = 0},
  [4759] = {.lex_state = 0},
  [4760] = {.lex_state = 0},
  [4761] = {.lex_state = 0},
  [4762] = {.lex_state = 0},
  [4763] = {.lex_state = 112},
  [4764] = {.lex_state = 0},
  [4765] = {.lex_state = 112},
  [4766] = {.lex_state = 0},
  [4767] = {.lex_state = 112},
  [4768] = {.lex_state = 0},
  [4769] = {.lex_state = 0},
  [4770] = {.lex_state = 112},
  [4771] = {.lex_state = 0},
  [4772] = {.lex_state = 0},
  [4773] = {.lex_state = 112},
  [4774] = {.lex_state = 0},
  [4775] = {.lex_state = 0},
  [4776] = {.lex_state = 112},
  [4777] = {.lex_state = 112},
  [4778] = {.lex_state = 112},
  [4779] = {.lex_state = 112},
  [4780] = {.lex_state = 112},
  [4781] = {.lex_state = 0},
  [4782] = {.lex_state = 0},
  [4783] = {.lex_state = 24},
  [4784] = {.lex_state = 0},
  [4785] = {.lex_state = 0},
  [4786] = {.lex_state = 112},
  [4787] = {.lex_state = 112},
  [4788] = {.lex_state = 112},
  [4789] = {.lex_state = 0},
  [4790] = {.lex_state = 112},
  [4791] = {.lex_state = 112},
  [4792] = {.lex_state = 0},
  [4793] = {.lex_state = 112},
  [4794] = {.lex_state = 112},
  [4795] = {.lex_state = 112},
  [4796] = {.lex_state = 112},
  [4797] = {.lex_state = 112},
  [4798] = {.lex_state = 112},
  [4799] = {.lex_state = 0},
  [4800] = {.lex_state = 112},
  [4801] = {.lex_state = 0},
  [4802] = {.lex_state = 0},
  [4803] = {.lex_state = 0},
  [4804] = {.lex_state = 112},
  [4805] = {.lex_state = 0},
  [4806] = {.lex_state = 112},
  [4807] = {.lex_state = 112},
  [4808] = {.lex_state = 112},
  [4809] = {.lex_state = 0},
  [4810] = {.lex_state = 0},
  [4811] = {.lex_state = 112},
  [4812] = {.lex_state = 112},
  [4813] = {.lex_state = 112},
  [4814] = {.lex_state = 112},
  [4815] = {.lex_state = 112},
  [4816] = {.lex_state = 0},
  [4817] = {.lex_state = 112},
  [4818] = {.lex_state = 112},
  [4819] = {.lex_state = 0},
  [4820] = {.lex_state = 0},
  [4821] = {.lex_state = 0},
  [4822] = {.lex_state = 0},
  [4823] = {.lex_state = 0},
  [4824] = {.lex_state = 0},
  [4825] = {.lex_state = 0},
  [4826] = {.lex_state = 0},
  [4827] = {.lex_state = 0},
  [4828] = {.lex_state = 0},
  [4829] = {.lex_state = 112},
  [4830] = {.lex_state = 112},
  [4831] = {.lex_state = 112},
  [4832] = {.lex_state = 112},
  [4833] = {.lex_state = 0},
  [4834] = {.lex_state = 0},
  [4835] = {.lex_state = 0},
  [4836] = {.lex_state = 112},
  [4837] = {.lex_state = 0},
  [4838] = {.lex_state = 112},
  [4839] = {.lex_state = 112},
  [4840] = {.lex_state = 112},
  [4841] = {.lex_state = 0},
  [4842] = {.lex_state = 112},
  [4843] = {.lex_state = 112},
  [4844] = {.lex_state = 0},
  [4845] = {.lex_state = 0},
  [4846] = {.lex_state = 0},
  [4847] = {.lex_state = 112},
  [4848] = {.lex_state = 0},
  [4849] = {.lex_state = 0},
  [4850] = {.lex_state = 112},
  [4851] = {.lex_state = 0},
  [4852] = {.lex_state = 112},
  [4853] = {.lex_state = 0},
  [4854] = {.lex_state = 112},
  [4855] = {.lex_state = 112},
  [4856] = {.lex_state = 0},
  [4857] = {.lex_state = 112},
  [4858] = {.lex_state = 112},
  [4859] = {.lex_state = 112},
  [4860] = {.lex_state = 112},
  [4861] = {.lex_state = 0},
  [4862] = {.lex_state = 0},
  [4863] = {.lex_state = 0},
  [4864] = {.lex_state = 112},
  [4865] = {.lex_state = 0},
  [4866] = {.lex_state = 112},
  [4867] = {.lex_state = 0},
  [4868] = {.lex_state = 0},
  [4869] = {.lex_state = 112},
  [4870] = {.lex_state = 0},
  [4871] = {.lex_state = 112},
  [4872] = {.lex_state = 112},
  [4873] = {.lex_state = 112},
  [4874] = {.lex_state = 0},
  [4875] = {.lex_state = 112},
  [4876] = {.lex_state = 0},
  [4877] = {.lex_state = 0},
  [4878] = {.lex_state = 0},
  [4879] = {.lex_state = 0},
  [4880] = {.lex_state = 112},
  [4881] = {.lex_state = 0},
  [4882] = {.lex_state = 112},
  [4883] = {.lex_state = 112},
  [4884] = {.lex_state = 112},
  [4885] = {.lex_state = 0},
  [4886] = {.lex_state = 0},
  [4887] = {.lex_state = 0},
  [4888] = {.lex_state = 112},
  [4889] = {.lex_state = 0},
  [4890] = {.lex_state = 0},
  [4891] = {.lex_state = 113},
  [4892] = {.lex_state = 112},
  [4893] = {.lex_state = 0},
  [4894] = {.lex_state = 112},
  [4895] = {.lex_state = 0},
  [4896] = {.lex_state = 112},
  [4897] = {.lex_state = 112},
  [4898] = {.lex_state = 112},
  [4899] = {.lex_state = 112},
  [4900] = {.lex_state = 0},
  [4901] = {.lex_state = 112},
  [4902] = {.lex_state = 0},
  [4903] = {.lex_state = 0},
  [4904] = {.lex_state = 112},
  [4905] = {.lex_state = 0},
  [4906] = {.lex_state = 112},
  [4907] = {.lex_state = 112},
  [4908] = {.lex_state = 0},
  [4909] = {.lex_state = 0},
  [4910] = {.lex_state = 0},
  [4911] = {.lex_state = 0},
  [4912] = {.lex_state = 112},
  [4913] = {.lex_state = 0},
  [4914] = {.lex_state = 112},
  [4915] = {.lex_state = 112},
  [4916] = {.lex_state = 112},
  [4917] = {.lex_state = 112},
  [4918] = {.lex_state = 112},
  [4919] = {.lex_state = 112},
  [4920] = {.lex_state = 112},
  [4921] = {.lex_state = 9},
  [4922] = {.lex_state = 112},
  [4923] = {.lex_state = 112},
  [4924] = {.lex_state = 112},
  [4925] = {.lex_state = 112},
  [4926] = {.lex_state = 112},
  [4927] = {.lex_state = 112},
  [4928] = {.lex_state = 112},
  [4929] = {.lex_state = 112},
  [4930] = {.lex_state = 112},
  [4931] = {.lex_state = 112},
  [4932] = {.lex_state = 112},
  [4933] = {.lex_state = 112},
  [4934] = {.lex_state = 112},
  [4935] = {.lex_state = 112},
  [4936] = {.lex_state = 112},
  [4937] = {.lex_state = 112},
  [4938] = {.lex_state = 112},
  [4939] = {.lex_state = 112},
  [4940] = {.lex_state = 112},
  [4941] = {.lex_state = 112},
  [4942] = {.lex_state = 112},
  [4943] = {.lex_state = 112},
  [4944] = {.lex_state = 112},
  [4945] = {.lex_state = 112},
  [4946] = {.lex_state = 112},
  [4947] = {.lex_state = 112},
  [4948] = {.lex_state = 112},
  [4949] = {.lex_state = 112},
  [4950] = {.lex_state = 112},
  [4951] = {.lex_state = 112},
  [4952] = {.lex_state = 112},
  [4953] = {.lex_state = 112},
  [4954] = {.lex_state = 112},
  [4955] = {.lex_state = 112},
  [4956] = {.lex_state = 112},
  [4957] = {.lex_state = 112},
  [4958] = {.lex_state = 112},
  [4959] = {.lex_state = 24},
  [4960] = {.lex_state = 112},
  [4961] = {.lex_state = 112},
  [4962] = {.lex_state = 112},
  [4963] = {.lex_state = 112},
  [4964] = {.lex_state = 112},
  [4965] = {.lex_state = 112},
  [4966] = {.lex_state = 112},
  [4967] = {.lex_state = 112},
  [4968] = {.lex_state = 24},
  [4969] = {.lex_state = 112},
  [4970] = {.lex_state = 112},
  [4971] = {.lex_state = 112},
  [4972] = {.lex_state = 112},
  [4973] = {.lex_state = 24},
  [4974] = {.lex_state = 112},
  [4975] = {.lex_state = 24},
  [4976] = {.lex_state = 24},
  [4977] = {.lex_state = 112},
  [4978] = {.lex_state = 112},
  [4979] = {.lex_state = 112},
  [4980] = {.lex_state = 112},
  [4981] = {.lex_state = 112},
  [4982] = {.lex_state = 112},
  [4983] = {.lex_state = 112},
  [4984] = {.lex_state = 112},
  [4985] = {.lex_state = 112},
  [4986] = {.lex_state = 112},
  [4987] = {.lex_state = 112},
  [4988] = {.lex_state = 112},
  [4989] = {.lex_state = 112},
  [4990] = {.lex_state = 112},
  [4991] = {.lex_state = 113},
  [4992] = {.lex_state = 112},
  [4993] = {.lex_state = 112},
  [4994] = {.lex_state = 112},
  [4995] = {.lex_state = 112},
  [4996] = {.lex_state = 112},
  [4997] = {.lex_state = 112},
  [4998] = {.lex_state = 112},
  [4999] = {.lex_state = 112},
  [5000] = {.lex_state = 112},
  [5001] = {.lex_state = 112},
  [5002] = {.lex_state = 112},
  [5003] = {.lex_state = 112},
  [5004] = {.lex_state = 112},
  [5005] = {.lex_state = 112},
  [5006] = {.lex_state = 112},
  [5007] = {.lex_state = 112},
  [5008] = {.lex_state = 24},
  [5009] = {.lex_state = 112},
  [5010] = {.lex_state = 112},
  [5011] = {.lex_state = 112},
  [5012] = {.lex_state = 24},
  [5013] = {.lex_state = 112},
  [5014] = {.lex_state = 112},
  [5015] = {.lex_state = 113},
  [5016] = {.lex_state = 112},
  [5017] = {.lex_state = 112},
  [5018] = {.lex_state = 112},
  [5019] = {.lex_state = 112},
  [5020] = {.lex_state = 112},
  [5021] = {.lex_state = 112},
  [5022] = {.lex_state = 112},
  [5023] = {.lex_state = 112},
  [5024] = {.lex_state = 112},
  [5025] = {.lex_state = 112},
  [5026] = {.lex_state = 112},
  [5027] = {.lex_state = 112},
  [5028] = {.lex_state = 112},
  [5029] = {.lex_state = 112},
  [5030] = {.lex_state = 112},
  [5031] = {.lex_state = 112},
  [5032] = {.lex_state = 112},
  [5033] = {.lex_state = 112},
  [5034] = {.lex_state = 6, .external_lex_state = 4},
  [5035] = {.lex_state = 112},
  [5036] = {.lex_state = 112},
  [5037] = {.lex_state = 112},
  [5038] = {.lex_state = 112},
  [5039] = {.lex_state = 112},
  [5040] = {.lex_state = 112},
  [5041] = {.lex_state = 112},
  [5042] = {.lex_state = 112},
  [5043] = {.lex_state = 112},
  [5044] = {.lex_state = 112},
  [5045] = {.lex_state = 112},
  [5046] = {.lex_state = 112},
  [5047] = {.lex_state = 112},
  [5048] = {.lex_state = 112},
  [5049] = {.lex_state = 112},
  [5050] = {.lex_state = 112},
  [5051] = {.lex_state = 112},
  [5052] = {.lex_state = 112},
  [5053] = {.lex_state = 112},
  [5054] = {.lex_state = 112},
  [5055] = {.lex_state = 112},
  [5056] = {.lex_state = 112},
  [5057] = {.lex_state = 112},
  [5058] = {.lex_state = 112},
  [5059] = {.lex_state = 112},
  [5060] = {.lex_state = 112},
  [5061] = {.lex_state = 112},
  [5062] = {.lex_state = 112},
  [5063] = {.lex_state = 112},
  [5064] = {.lex_state = 112},
  [5065] = {.lex_state = 112},
  [5066] = {.lex_state = 112},
  [5067] = {.lex_state = 112},
  [5068] = {.lex_state = 112},
  [5069] = {.lex_state = 112},
  [5070] = {.lex_state = 112},
  [5071] = {.lex_state = 112},
  [5072] = {.lex_state = 112},
  [5073] = {.lex_state = 112},
  [5074] = {.lex_state = 112},
  [5075] = {.lex_state = 112},
  [5076] = {.lex_state = 112},
  [5077] = {.lex_state = 112},
  [5078] = {.lex_state = 112},
  [5079] = {.lex_state = 112},
  [5080] = {.lex_state = 112},
  [5081] = {.lex_state = 24},
  [5082] = {.lex_state = 112},
  [5083] = {.lex_state = 112, .external_lex_state = 4},
  [5084] = {.lex_state = 112},
  [5085] = {.lex_state = 112},
  [5086] = {.lex_state = 112},
  [5087] = {.lex_state = 112},
  [5088] = {.lex_state = 112},
  [5089] = {.lex_state = 112},
  [5090] = {.lex_state = 9},
  [5091] = {.lex_state = 112},
  [5092] = {.lex_state = 0},
  [5093] = {.lex_state = 112},
  [5094] = {.lex_state = 112},
  [5095] = {.lex_state = 112},
  [5096] = {.lex_state = 112},
  [5097] = {.lex_state = 112},
  [5098] = {.lex_state = 112},
  [5099] = {.lex_state = 112},
  [5100] = {.lex_state = 112},
  [5101] = {.lex_state = 112},
  [5102] = {.lex_state = 112},
  [5103] = {.lex_state = 112},
  [5104] = {.lex_state = 112},
  [5105] = {.lex_state = 112},
  [5106] = {.lex_state = 112},
  [5107] = {.lex_state = 112},
  [5108] = {.lex_state = 112},
  [5109] = {.lex_state = 0},
  [5110] = {.lex_state = 112},
  [5111] = {.lex_state = 112},
  [5112] = {.lex_state = 112},
  [5113] = {.lex_state = 112, .external_lex_state = 4},
  [5114] = {.lex_state = 112, .external_lex_state = 4},
  [5115] = {.lex_state = 0},
  [5116] = {.lex_state = 112, .external_lex_state = 4},
  [5117] = {.lex_state = 112},
  [5118] = {.lex_state = 112},
  [5119] = {.lex_state = 112, .external_lex_state = 4},
  [5120] = {.lex_state = 112, .external_lex_state = 4},
  [5121] = {.lex_state = 24},
  [5122] = {.lex_state = 112},
  [5123] = {.lex_state = 112, .external_lex_state = 4},
  [5124] = {.lex_state = 112, .external_lex_state = 4},
  [5125] = {.lex_state = 112, .external_lex_state = 4},
  [5126] = {.lex_state = 112, .external_lex_state = 4},
  [5127] = {.lex_state = 112, .external_lex_state = 4},
  [5128] = {.lex_state = 112, .external_lex_state = 4},
  [5129] = {.lex_state = 0},
  [5130] = {.lex_state = 112, .external_lex_state = 4},
  [5131] = {.lex_state = 112, .external_lex_state = 4},
  [5132] = {.lex_state = 0},
  [5133] = {.lex_state = 0},
  [5134] = {.lex_state = 112},
  [5135] = {.lex_state = 112, .external_lex_state = 4},
  [5136] = {.lex_state = 112, .external_lex_state = 4},
  [5137] = {.lex_state = 112},
  [5138] = {.lex_state = 112},
  [5139] = {.lex_state = 112},
  [5140] = {.lex_state = 112, .external_lex_state = 4},
  [5141] = {.lex_state = 112},
  [5142] = {.lex_state = 112},
  [5143] = {.lex_state = 112},
  [5144] = {.lex_state = 6, .external_lex_state = 4},
  [5145] = {.lex_state = 112, .external_lex_state = 4},
  [5146] = {.lex_state = 6, .external_lex_state = 4},
  [5147] = {.lex_state = 112},
  [5148] = {.lex_state = 112},
  [5149] = {.lex_state = 6, .external_lex_state = 4},
  [5150] = {.lex_state = 112},
  [5151] = {.lex_state = 112},
  [5152] = {.lex_state = 112, .external_lex_state = 4},
  [5153] = {.lex_state = 112},
  [5154] = {.lex_state = 112},
  [5155] = {.lex_state = 112},
  [5156] = {.lex_state = 112},
  [5157] = {.lex_state = 112, .external_lex_state = 4},
  [5158] = {.lex_state = 112},
  [5159] = {.lex_state = 112, .external_lex_state = 4},
  [5160] = {.lex_state = 112},
  [5161] = {.lex_state = 112, .external_lex_state = 4},
  [5162] = {.lex_state = 0},
  [5163] = {.lex_state = 112, .external_lex_state = 4},
  [5164] = {.lex_state = 112, .external_lex_state = 4},
  [5165] = {.lex_state = 112},
  [5166] = {.lex_state = 112, .external_lex_state = 4},
  [5167] = {.lex_state = 112, .external_lex_state = 4},
  [5168] = {.lex_state = 112},
  [5169] = {.lex_state = 112},
  [5170] = {.lex_state = 112, .external_lex_state = 4},
  [5171] = {.lex_state = 112, .external_lex_state = 4},
  [5172] = {.lex_state = 112, .external_lex_state = 4},
  [5173] = {.lex_state = 112, .external_lex_state = 4},
  [5174] = {.lex_state = 112, .external_lex_state = 4},
  [5175] = {.lex_state = 112, .external_lex_state = 4},
  [5176] = {.lex_state = 112},
  [5177] = {.lex_state = 112},
  [5178] = {.lex_state = 112},
  [5179] = {.lex_state = 112, .external_lex_state = 4},
  [5180] = {.lex_state = 112},
  [5181] = {.lex_state = 112},
  [5182] = {.lex_state = 112, .external_lex_state = 4},
  [5183] = {.lex_state = 112},
  [5184] = {.lex_state = 112},
  [5185] = {.lex_state = 112},
  [5186] = {.lex_state = 112},
  [5187] = {.lex_state = 112},
  [5188] = {.lex_state = 112},
  [5189] = {.lex_state = 112},
  [5190] = {.lex_state = 112},
  [5191] = {.lex_state = 112},
  [5192] = {.lex_state = 112, .external_lex_state = 4},
  [5193] = {.lex_state = 112},
  [5194] = {.lex_state = 112},
  [5195] = {.lex_state = 112, .external_lex_state = 4},
  [5196] = {.lex_state = 112},
  [5197] = {.lex_state = 112},
  [5198] = {.lex_state = 112},
  [5199] = {.lex_state = 112},
  [5200] = {.lex_state = 112},
  [5201] = {.lex_state = 112},
  [5202] = {.lex_state = 112},
  [5203] = {.lex_state = 112},
  [5204] = {.lex_state = 112},
  [5205] = {.lex_state = 9},
  [5206] = {.lex_state = 112},
  [5207] = {.lex_state = 9},
  [5208] = {.lex_state = 112},
  [5209] = {.lex_state = 112, .external_lex_state = 4},
  [5210] = {.lex_state = 112},
  [5211] = {.lex_state = 112, .external_lex_state = 4},
  [5212] = {.lex_state = 112, .external_lex_state = 4},
  [5213] = {.lex_state = 112},
  [5214] = {.lex_state = 112},
  [5215] = {.lex_state = 112},
  [5216] = {.lex_state = 112, .external_lex_state = 4},
  [5217] = {.lex_state = 112, .external_lex_state = 4},
  [5218] = {.lex_state = 112, .external_lex_state = 4},
  [5219] = {.lex_state = 112, .external_lex_state = 4},
  [5220] = {.lex_state = 112},
  [5221] = {.lex_state = 112},
  [5222] = {.lex_state = 112},
  [5223] = {.lex_state = 112},
  [5224] = {.lex_state = 112, .external_lex_state = 4},
  [5225] = {.lex_state = 112},
  [5226] = {.lex_state = 112},
  [5227] = {.lex_state = 112},
  [5228] = {.lex_state = 112},
  [5229] = {.lex_state = 112, .external_lex_state = 4},
  [5230] = {.lex_state = 112},
  [5231] = {.lex_state = 112},
  [5232] = {.lex_state = 112},
  [5233] = {.lex_state = 112},
  [5234] = {.lex_state = 24},
  [5235] = {.lex_state = 112, .external_lex_state = 4},
  [5236] = {.lex_state = 113},
  [5237] = {.lex_state = 24},
  [5238] = {.lex_state = 112},
  [5239] = {.lex_state = 112},
  [5240] = {.lex_state = 112, .external_lex_state = 4},
  [5241] = {.lex_state = 112},
  [5242] = {.lex_state = 112, .external_lex_state = 4},
  [5243] = {.lex_state = 112},
  [5244] = {.lex_state = 112, .external_lex_state = 4},
  [5245] = {.lex_state = 112, .external_lex_state = 4},
  [5246] = {.lex_state = 112, .external_lex_state = 4},
  [5247] = {.lex_state = 112, .external_lex_state = 4},
  [5248] = {.lex_state = 112, .external_lex_state = 4},
  [5249] = {.lex_state = 112, .external_lex_state = 4},
  [5250] = {.lex_state = 112, .external_lex_state = 4},
  [5251] = {.lex_state = 112, .external_lex_state = 4},
  [5252] = {.lex_state = 112},
  [5253] = {.lex_state = 0},
  [5254] = {.lex_state = 112, .external_lex_state = 4},
  [5255] = {.lex_state = 112, .external_lex_state = 4},
  [5256] = {.lex_state = 112},
  [5257] = {.lex_state = 112, .external_lex_state = 4},
  [5258] = {.lex_state = 112, .external_lex_state = 4},
  [5259] = {.lex_state = 112},
  [5260] = {.lex_state = 112},
  [5261] = {.lex_state = 112, .external_lex_state = 4},
  [5262] = {.lex_state = 24},
  [5263] = {.lex_state = 112},
  [5264] = {.lex_state = 112},
  [5265] = {.lex_state = 112},
  [5266] = {.lex_state = 112},
  [5267] = {.lex_state = 112},
  [5268] = {.lex_state = 112},
  [5269] = {.lex_state = 112},
  [5270] = {.lex_state = 112},
  [5271] = {.lex_state = 112, .external_lex_state = 4},
  [5272] = {.lex_state = 112, .external_lex_state = 4},
  [5273] = {.lex_state = 112},
  [5274] = {.lex_state = 112},
  [5275] = {.lex_state = 112},
  [5276] = {.lex_state = 112, .external_lex_state = 4},
  [5277] = {.lex_state = 112, .external_lex_state = 4},
  [5278] = {.lex_state = 112},
  [5279] = {.lex_state = 112},
  [5280] = {.lex_state = 112},
  [5281] = {.lex_state = 112},
  [5282] = {.lex_state = 112},
  [5283] = {.lex_state = 112},
  [5284] = {.lex_state = 112},
  [5285] = {.lex_state = 112},
  [5286] = {.lex_state = 112},
  [5287] = {.lex_state = 112},
  [5288] = {.lex_state = 112},
  [5289] = {.lex_state = 112},
  [5290] = {.lex_state = 112},
  [5291] = {.lex_state = 112},
  [5292] = {.lex_state = 112},
  [5293] = {.lex_state = 112, .external_lex_state = 4},
  [5294] = {.lex_state = 112},
  [5295] = {.lex_state = 112, .external_lex_state = 4},
  [5296] = {.lex_state = 112, .external_lex_state = 4},
  [5297] = {.lex_state = 112, .external_lex_state = 4},
  [5298] = {.lex_state = 112},
  [5299] = {.lex_state = 112},
  [5300] = {.lex_state = 112},
  [5301] = {.lex_state = 24},
  [5302] = {.lex_state = 112, .external_lex_state = 4},
  [5303] = {.lex_state = 112, .external_lex_state = 4},
  [5304] = {.lex_state = 113},
  [5305] = {.lex_state = 112, .external_lex_state = 4},
  [5306] = {.lex_state = 112, .external_lex_state = 4},
  [5307] = {.lex_state = 112, .external_lex_state = 4},
  [5308] = {.lex_state = 112},
  [5309] = {.lex_state = 112, .external_lex_state = 4},
  [5310] = {.lex_state = 112},
  [5311] = {.lex_state = 112, .external_lex_state = 4},
  [5312] = {.lex_state = 112},
  [5313] = {.lex_state = 112},
  [5314] = {.lex_state = 112},
  [5315] = {.lex_state = 112, .external_lex_state = 4},
  [5316] = {.lex_state = 112},
  [5317] = {.lex_state = 112, .external_lex_state = 4},
  [5318] = {.lex_state = 0},
  [5319] = {.lex_state = 112, .external_lex_state = 4},
  [5320] = {.lex_state = 112},
  [5321] = {.lex_state = 112, .external_lex_state = 4},
  [5322] = {.lex_state = 112, .external_lex_state = 4},
  [5323] = {.lex_state = 112, .external_lex_state = 4},
  [5324] = {.lex_state = 112, .external_lex_state = 4},
  [5325] = {.lex_state = 112},
  [5326] = {.lex_state = 112},
  [5327] = {.lex_state = 112},
  [5328] = {.lex_state = 112},
  [5329] = {.lex_state = 112},
  [5330] = {.lex_state = 112},
  [5331] = {.lex_state = 112, .external_lex_state = 4},
  [5332] = {.lex_state = 6},
  [5333] = {.lex_state = 24},
  [5334] = {.lex_state = 112},
  [5335] = {.lex_state = 112},
  [5336] = {.lex_state = 112},
  [5337] = {.lex_state = 112},
  [5338] = {.lex_state = 112},
  [5339] = {.lex_state = 112},
  [5340] = {.lex_state = 112},
  [5341] = {.lex_state = 112},
  [5342] = {.lex_state = 112},
  [5343] = {.lex_state = 112},
  [5344] = {.lex_state = 112, .external_lex_state = 4},
  [5345] = {.lex_state = 112},
  [5346] = {.lex_state = 112},
  [5347] = {.lex_state = 112},
  [5348] = {.lex_state = 112, .external_lex_state = 4},
  [5349] = {.lex_state = 112},
  [5350] = {.lex_state = 112},
  [5351] = {.lex_state = 112},
  [5352] = {.lex_state = 112},
  [5353] = {.lex_state = 0},
  [5354] = {.lex_state = 112, .external_lex_state = 4},
  [5355] = {.lex_state = 112},
  [5356] = {.lex_state = 112, .external_lex_state = 4},
  [5357] = {.lex_state = 112},
  [5358] = {.lex_state = 112, .external_lex_state = 4},
  [5359] = {.lex_state = 112, .external_lex_state = 4},
  [5360] = {.lex_state = 112, .external_lex_state = 4},
  [5361] = {.lex_state = 112, .external_lex_state = 4},
  [5362] = {.lex_state = 112, .external_lex_state = 4},
  [5363] = {.lex_state = 112},
  [5364] = {.lex_state = 112, .external_lex_state = 4},
  [5365] = {.lex_state = 112, .external_lex_state = 4},
  [5366] = {.lex_state = 112},
  [5367] = {.lex_state = 112},
  [5368] = {.lex_state = 0},
  [5369] = {.lex_state = 112, .external_lex_state = 4},
  [5370] = {.lex_state = 112},
  [5371] = {.lex_state = 112, .external_lex_state = 4},
  [5372] = {.lex_state = 112, .external_lex_state = 4},
  [5373] = {.lex_state = 112, .external_lex_state = 4},
  [5374] = {.lex_state = 112},
  [5375] = {.lex_state = 112, .external_lex_state = 4},
  [5376] = {.lex_state = 112, .external_lex_state = 4},
  [5377] = {.lex_state = 112},
  [5378] = {.lex_state = 112},
  [5379] = {.lex_state = 24},
  [5380] = {.lex_state = 112, .external_lex_state = 4},
  [5381] = {.lex_state = 113},
  [5382] = {.lex_state = 112},
  [5383] = {.lex_state = 112, .external_lex_state = 4},
  [5384] = {.lex_state = 112},
  [5385] = {.lex_state = 112, .external_lex_state = 4},
  [5386] = {.lex_state = 112, .external_lex_state = 4},
  [5387] = {.lex_state = 112},
  [5388] = {.lex_state = 112},
  [5389] = {.lex_state = 112, .external_lex_state = 4},
  [5390] = {.lex_state = 112, .external_lex_state = 4},
  [5391] = {.lex_state = 112},
  [5392] = {.lex_state = 112, .external_lex_state = 4},
  [5393] = {.lex_state = 112},
  [5394] = {.lex_state = 112},
  [5395] = {.lex_state = 112},
  [5396] = {.lex_state = 112, .external_lex_state = 4},
  [5397] = {.lex_state = 112},
  [5398] = {.lex_state = 112, .external_lex_state = 4},
  [5399] = {.lex_state = 112, .external_lex_state = 4},
  [5400] = {.lex_state = 112, .external_lex_state = 4},
  [5401] = {.lex_state = 112, .external_lex_state = 4},
  [5402] = {.lex_state = 112},
  [5403] = {.lex_state = 112, .external_lex_state = 4},
  [5404] = {.lex_state = 112, .external_lex_state = 4},
  [5405] = {.lex_state = 112},
  [5406] = {.lex_state = 112, .external_lex_state = 4},
  [5407] = {.lex_state = 112, .external_lex_state = 4},
  [5408] = {.lex_state = 112},
  [5409] = {.lex_state = 112},
  [5410] = {.lex_state = 112, .external_lex_state = 4},
  [5411] = {.lex_state = 112, .external_lex_state = 4},
  [5412] = {.lex_state = 112, .external_lex_state = 4},
  [5413] = {.lex_state = 112, .external_lex_state = 4},
  [5414] = {.lex_state = 112},
  [5415] = {.lex_state = 112},
  [5416] = {.lex_state = 112},
  [5417] = {.lex_state = 112},
  [5418] = {.lex_state = 112, .external_lex_state = 4},
  [5419] = {.lex_state = 112, .external_lex_state = 4},
  [5420] = {.lex_state = 112},
  [5421] = {.lex_state = 112},
  [5422] = {.lex_state = 0},
  [5423] = {.lex_state = 112, .external_lex_state = 4},
  [5424] = {.lex_state = 112, .external_lex_state = 4},
  [5425] = {.lex_state = 112, .external_lex_state = 4},
  [5426] = {.lex_state = 112, .external_lex_state = 4},
  [5427] = {.lex_state = 112, .external_lex_state = 4},
  [5428] = {.lex_state = 112},
  [5429] = {.lex_state = 112},
  [5430] = {.lex_state = 24},
  [5431] = {.lex_state = 112},
  [5432] = {.lex_state = 112},
  [5433] = {.lex_state = 112},
  [5434] = {.lex_state = 112},
  [5435] = {.lex_state = 112},
  [5436] = {.lex_state = 112},
  [5437] = {.lex_state = 112, .external_lex_state = 4},
  [5438] = {.lex_state = 112, .external_lex_state = 4},
  [5439] = {.lex_state = 112, .external_lex_state = 4},
  [5440] = {.lex_state = 112, .external_lex_state = 4},
  [5441] = {.lex_state = 112},
  [5442] = {.lex_state = 112},
  [5443] = {.lex_state = 112},
  [5444] = {.lex_state = 112},
  [5445] = {.lex_state = 112, .external_lex_state = 4},
  [5446] = {.lex_state = 112},
  [5447] = {.lex_state = 112},
  [5448] = {.lex_state = 112},
  [5449] = {.lex_state = 112},
  [5450] = {.lex_state = 112, .external_lex_state = 4},
  [5451] = {.lex_state = 112},
  [5452] = {.lex_state = 112},
  [5453] = {.lex_state = 112},
  [5454] = {.lex_state = 112},
  [5455] = {.lex_state = 112},
  [5456] = {.lex_state = 112},
  [5457] = {.lex_state = 112},
  [5458] = {.lex_state = 112},
  [5459] = {.lex_state = 112},
  [5460] = {.lex_state = 112, .external_lex_state = 4},
  [5461] = {.lex_state = 112},
  [5462] = {.lex_state = 112, .external_lex_state = 4},
  [5463] = {.lex_state = 112, .external_lex_state = 4},
  [5464] = {.lex_state = 112, .external_lex_state = 4},
  [5465] = {.lex_state = 112, .external_lex_state = 4},
  [5466] = {.lex_state = 112, .external_lex_state = 4},
  [5467] = {.lex_state = 112, .external_lex_state = 4},
  [5468] = {.lex_state = 112},
  [5469] = {.lex_state = 112},
  [5470] = {.lex_state = 112},
  [5471] = {.lex_state = 112},
  [5472] = {.lex_state = 0},
  [5473] = {.lex_state = 112},
  [5474] = {.lex_state = 112},
  [5475] = {.lex_state = 112},
  [5476] = {.lex_state = 112},
  [5477] = {.lex_state = 112},
  [5478] = {.lex_state = 112},
  [5479] = {.lex_state = 112},
  [5480] = {.lex_state = 112},
  [5481] = {.lex_state = 112},
  [5482] = {.lex_state = 112},
  [5483] = {.lex_state = 112},
  [5484] = {.lex_state = 112},
  [5485] = {.lex_state = 112},
  [5486] = {.lex_state = 112},
  [5487] = {.lex_state = 112},
  [5488] = {.lex_state = 112},
  [5489] = {.lex_state = 112},
  [5490] = {.lex_state = 112},
  [5491] = {.lex_state = 112},
  [5492] = {.lex_state = 112},
  [5493] = {.lex_state = 112},
  [5494] = {.lex_state = 112},
  [5495] = {.lex_state = 112},
  [5496] = {.lex_state = 112},
  [5497] = {.lex_state = 112},
  [5498] = {.lex_state = 112},
  [5499] = {.lex_state = 112},
  [5500] = {.lex_state = 112},
  [5501] = {.lex_state = 112},
  [5502] = {.lex_state = 112},
  [5503] = {.lex_state = 112},
  [5504] = {.lex_state = 112},
  [5505] = {.lex_state = 112, .external_lex_state = 4},
  [5506] = {.lex_state = 112},
  [5507] = {.lex_state = 112},
  [5508] = {.lex_state = 112, .external_lex_state = 4},
  [5509] = {.lex_state = 112},
  [5510] = {.lex_state = 112},
  [5511] = {.lex_state = 112},
  [5512] = {.lex_state = 112},
  [5513] = {.lex_state = 112, .external_lex_state = 4},
  [5514] = {.lex_state = 112},
  [5515] = {.lex_state = 112, .external_lex_state = 4},
  [5516] = {.lex_state = 112, .external_lex_state = 4},
  [5517] = {.lex_state = 112},
  [5518] = {.lex_state = 112},
  [5519] = {.lex_state = 112},
  [5520] = {.lex_state = 112},
  [5521] = {.lex_state = 112},
  [5522] = {.lex_state = 112},
  [5523] = {.lex_state = 112},
  [5524] = {.lex_state = 112},
  [5525] = {.lex_state = 112},
  [5526] = {.lex_state = 112},
  [5527] = {.lex_state = 112},
  [5528] = {.lex_state = 112},
  [5529] = {.lex_state = 112},
  [5530] = {.lex_state = 112},
  [5531] = {.lex_state = 112},
  [5532] = {.lex_state = 112},
  [5533] = {.lex_state = 112, .external_lex_state = 4},
  [5534] = {.lex_state = 112, .external_lex_state = 4},
  [5535] = {.lex_state = 112, .external_lex_state = 4},
  [5536] = {.lex_state = 112, .external_lex_state = 4},
  [5537] = {.lex_state = 112, .external_lex_state = 4},
  [5538] = {.lex_state = 112},
  [5539] = {.lex_state = 112, .external_lex_state = 4},
  [5540] = {.lex_state = 112, .external_lex_state = 4},
  [5541] = {.lex_state = 112, .external_lex_state = 4},
  [5542] = {.lex_state = 112},
  [5543] = {.lex_state = 112, .external_lex_state = 4},
  [5544] = {.lex_state = 112, .external_lex_state = 4},
  [5545] = {.lex_state = 112, .external_lex_state = 4},
  [5546] = {.lex_state = 112},
  [5547] = {.lex_state = 112, .external_lex_state = 4},
  [5548] = {.lex_state = 24},
  [5549] = {.lex_state = 112, .external_lex_state = 4},
  [5550] = {.lex_state = 112, .external_lex_state = 4},
  [5551] = {.lex_state = 112, .external_lex_state = 4},
  [5552] = {.lex_state = 112, .external_lex_state = 4},
  [5553] = {.lex_state = 112},
  [5554] = {.lex_state = 112, .external_lex_state = 4},
  [5555] = {.lex_state = 112, .external_lex_state = 4},
  [5556] = {.lex_state = 112, .external_lex_state = 4},
  [5557] = {.lex_state = 112, .external_lex_state = 4},
  [5558] = {.lex_state = 112, .external_lex_state = 4},
  [5559] = {.lex_state = 112},
  [5560] = {.lex_state = 112},
  [5561] = {.lex_state = 112, .external_lex_state = 4},
  [5562] = {.lex_state = 112},
  [5563] = {.lex_state = 112},
  [5564] = {.lex_state = 112},
  [5565] = {.lex_state = 112},
  [5566] = {.lex_state = 112},
  [5567] = {.lex_state = 112},
  [5568] = {.lex_state = 112},
  [5569] = {.lex_state = 112},
  [5570] = {.lex_state = 112, .external_lex_state = 4},
  [5571] = {.lex_state = 112},
  [5572] = {.lex_state = 112},
  [5573] = {.lex_state = 112, .external_lex_state = 4},
  [5574] = {.lex_state = 112},
  [5575] = {.lex_state = 112},
  [5576] = {.lex_state = 112},
  [5577] = {.lex_state = 112},
  [5578] = {.lex_state = 112},
  [5579] = {.lex_state = 112, .external_lex_state = 4},
  [5580] = {.lex_state = 112},
  [5581] = {.lex_state = 112},
  [5582] = {.lex_state = 112, .external_lex_state = 4},
  [5583] = {.lex_state = 112, .external_lex_state = 4},
  [5584] = {.lex_state = 112, .external_lex_state = 4},
  [5585] = {.lex_state = 112, .external_lex_state = 4},
  [5586] = {.lex_state = 112},
  [5587] = {.lex_state = 112, .external_lex_state = 4},
  [5588] = {.lex_state = 112, .external_lex_state = 4},
  [5589] = {.lex_state = 112, .external_lex_state = 4},
  [5590] = {.lex_state = 112},
  [5591] = {.lex_state = 112},
  [5592] = {.lex_state = 112},
  [5593] = {.lex_state = 112},
  [5594] = {.lex_state = 6},
  [5595] = {.lex_state = 112, .external_lex_state = 4},
  [5596] = {.lex_state = 112},
  [5597] = {.lex_state = 112},
  [5598] = {.lex_state = 112},
  [5599] = {.lex_state = 112},
  [5600] = {.lex_state = 112},
  [5601] = {.lex_state = 112},
  [5602] = {.lex_state = 112},
  [5603] = {.lex_state = 112},
  [5604] = {.lex_state = 112, .external_lex_state = 4},
  [5605] = {.lex_state = 112, .external_lex_state = 4},
  [5606] = {.lex_state = 112},
  [5607] = {.lex_state = 112, .external_lex_state = 4},
  [5608] = {.lex_state = 112, .external_lex_state = 4},
  [5609] = {.lex_state = 112, .external_lex_state = 4},
  [5610] = {.lex_state = 112},
  [5611] = {.lex_state = 112, .external_lex_state = 4},
  [5612] = {.lex_state = 112},
  [5613] = {.lex_state = 112, .external_lex_state = 4},
  [5614] = {.lex_state = 112},
  [5615] = {.lex_state = 112},
  [5616] = {.lex_state = 112},
  [5617] = {.lex_state = 112, .external_lex_state = 4},
  [5618] = {.lex_state = 112},
  [5619] = {.lex_state = 112},
  [5620] = {.lex_state = 112},
  [5621] = {.lex_state = 112, .external_lex_state = 4},
  [5622] = {.lex_state = 112, .external_lex_state = 4},
  [5623] = {.lex_state = 112},
  [5624] = {.lex_state = 112},
  [5625] = {.lex_state = 112},
  [5626] = {.lex_state = 112},
  [5627] = {.lex_state = 112},
  [5628] = {.lex_state = 112},
  [5629] = {.lex_state = 112},
  [5630] = {.lex_state = 112},
  [5631] = {.lex_state = 112},
  [5632] = {.lex_state = 112},
  [5633] = {.lex_state = 112},
  [5634] = {.lex_state = 112},
  [5635] = {.lex_state = 112},
  [5636] = {.lex_state = 112},
  [5637] = {.lex_state = 112},
  [5638] = {.lex_state = 112},
  [5639] = {.lex_state = 112, .external_lex_state = 4},
  [5640] = {.lex_state = 112},
  [5641] = {.lex_state = 112},
  [5642] = {.lex_state = 112, .external_lex_state = 4},
  [5643] = {.lex_state = 112, .external_lex_state = 4},
  [5644] = {.lex_state = 112, .external_lex_state = 4},
  [5645] = {.lex_state = 112, .external_lex_state = 4},
  [5646] = {.lex_state = 112},
  [5647] = {.lex_state = 112, .external_lex_state = 4},
  [5648] = {.lex_state = 112},
  [5649] = {.lex_state = 112, .external_lex_state = 4},
  [5650] = {.lex_state = 112, .external_lex_state = 4},
  [5651] = {.lex_state = 112, .external_lex_state = 4},
  [5652] = {.lex_state = 112},
  [5653] = {.lex_state = 112},
  [5654] = {.lex_state = 0},
  [5655] = {.lex_state = 112, .external_lex_state = 4},
  [5656] = {.lex_state = 112},
  [5657] = {.lex_state = 112},
  [5658] = {.lex_state = 112},
  [5659] = {.lex_state = 112, .external_lex_state = 4},
  [5660] = {.lex_state = 112},
  [5661] = {.lex_state = 112},
  [5662] = {.lex_state = 112, .external_lex_state = 4},
  [5663] = {.lex_state = 112},
  [5664] = {.lex_state = 112},
  [5665] = {.lex_state = 112},
  [5666] = {.lex_state = 112},
  [5667] = {.lex_state = 112},
  [5668] = {.lex_state = 112},
  [5669] = {.lex_state = 0},
  [5670] = {.lex_state = 112},
  [5671] = {.lex_state = 112, .external_lex_state = 4},
  [5672] = {.lex_state = 112, .external_lex_state = 4},
  [5673] = {.lex_state = 112, .external_lex_state = 4},
  [5674] = {.lex_state = 112, .external_lex_state = 4},
  [5675] = {.lex_state = 112, .external_lex_state = 4},
  [5676] = {.lex_state = 112},
  [5677] = {.lex_state = 112},
  [5678] = {.lex_state = 112},
  [5679] = {.lex_state = 112, .external_lex_state = 4},
  [5680] = {.lex_state = 112, .external_lex_state = 4},
  [5681] = {.lex_state = 112},
  [5682] = {.lex_state = 112, .external_lex_state = 4},
  [5683] = {.lex_state = 112},
  [5684] = {.lex_state = 112},
  [5685] = {.lex_state = 112},
  [5686] = {.lex_state = 112},
  [5687] = {.lex_state = 112},
  [5688] = {.lex_state = 112},
  [5689] = {.lex_state = 112},
  [5690] = {.lex_state = 112},
  [5691] = {.lex_state = 112},
  [5692] = {.lex_state = 112},
  [5693] = {.lex_state = 112},
  [5694] = {.lex_state = 112},
  [5695] = {.lex_state = 112},
  [5696] = {.lex_state = 112},
  [5697] = {.lex_state = 112},
  [5698] = {.lex_state = 112},
  [5699] = {.lex_state = 112},
  [5700] = {.lex_state = 112},
  [5701] = {.lex_state = 112, .external_lex_state = 4},
  [5702] = {.lex_state = 112},
  [5703] = {.lex_state = 112},
  [5704] = {.lex_state = 112},
  [5705] = {.lex_state = 112},
  [5706] = {.lex_state = 112},
  [5707] = {.lex_state = 112},
  [5708] = {.lex_state = 112},
  [5709] = {.lex_state = 112},
  [5710] = {.lex_state = 112},
  [5711] = {.lex_state = 112},
  [5712] = {.lex_state = 112},
  [5713] = {.lex_state = 112},
  [5714] = {.lex_state = 0},
  [5715] = {.lex_state = 112},
  [5716] = {.lex_state = 112},
  [5717] = {.lex_state = 112, .external_lex_state = 4},
  [5718] = {.lex_state = 112},
  [5719] = {.lex_state = 112, .external_lex_state = 4},
  [5720] = {.lex_state = 112},
  [5721] = {.lex_state = 112, .external_lex_state = 4},
  [5722] = {.lex_state = 112},
  [5723] = {.lex_state = 112, .external_lex_state = 4},
  [5724] = {.lex_state = 112},
  [5725] = {.lex_state = 112},
  [5726] = {.lex_state = 112},
  [5727] = {.lex_state = 112},
  [5728] = {.lex_state = 112},
  [5729] = {.lex_state = 112},
  [5730] = {.lex_state = 112, .external_lex_state = 4},
  [5731] = {.lex_state = 112, .external_lex_state = 4},
  [5732] = {.lex_state = 112},
  [5733] = {.lex_state = 112, .external_lex_state = 4},
  [5734] = {.lex_state = 112, .external_lex_state = 4},
  [5735] = {.lex_state = 112, .external_lex_state = 4},
  [5736] = {.lex_state = 112},
  [5737] = {.lex_state = 112},
  [5738] = {.lex_state = 112},
  [5739] = {.lex_state = 112},
  [5740] = {.lex_state = 112, .external_lex_state = 4},
  [5741] = {.lex_state = 0},
  [5742] = {.lex_state = 112, .external_lex_state = 4},
  [5743] = {.lex_state = 112},
  [5744] = {.lex_state = 112},
  [5745] = {.lex_state = 112},
  [5746] = {.lex_state = 112},
  [5747] = {.lex_state = 112},
  [5748] = {.lex_state = 112},
  [5749] = {.lex_state = 112},
  [5750] = {.lex_state = 112},
  [5751] = {.lex_state = 112},
  [5752] = {.lex_state = 112},
  [5753] = {.lex_state = 112},
  [5754] = {.lex_state = 112},
  [5755] = {.lex_state = 112},
  [5756] = {.lex_state = 112},
  [5757] = {.lex_state = 112},
  [5758] = {.lex_state = 112},
  [5759] = {.lex_state = 112},
  [5760] = {.lex_state = 112},
  [5761] = {.lex_state = 112},
  [5762] = {.lex_state = 112},
  [5763] = {.lex_state = 112},
  [5764] = {.lex_state = 0},
  [5765] = {.lex_state = 112},
  [5766] = {.lex_state = 0},
  [5767] = {.lex_state = 112},
  [5768] = {.lex_state = 112},
  [5769] = {.lex_state = 112},
  [5770] = {.lex_state = 112},
  [5771] = {.lex_state = 112},
  [5772] = {.lex_state = 112},
  [5773] = {.lex_state = 112},
  [5774] = {.lex_state = 112},
  [5775] = {.lex_state = 112},
  [5776] = {.lex_state = 112},
  [5777] = {.lex_state = 112},
  [5778] = {.lex_state = 112},
  [5779] = {.lex_state = 112},
  [5780] = {.lex_state = 112},
  [5781] = {.lex_state = 112},
  [5782] = {.lex_state = 112},
  [5783] = {.lex_state = 112},
  [5784] = {.lex_state = 112},
  [5785] = {.lex_state = 112},
  [5786] = {.lex_state = 112},
  [5787] = {.lex_state = 112},
  [5788] = {.lex_state = 112},
  [5789] = {.lex_state = 112},
  [5790] = {.lex_state = 112},
  [5791] = {.lex_state = 112},
  [5792] = {.lex_state = 112},
  [5793] = {.lex_state = 112},
  [5794] = {.lex_state = 112},
  [5795] = {.lex_state = 112},
  [5796] = {.lex_state = 112},
  [5797] = {.lex_state = 112},
  [5798] = {.lex_state = 112},
  [5799] = {.lex_state = 112},
  [5800] = {.lex_state = 112},
  [5801] = {.lex_state = 112},
  [5802] = {.lex_state = 112},
  [5803] = {.lex_state = 112},
  [5804] = {.lex_state = 112, .external_lex_state = 4},
  [5805] = {.lex_state = 112},
  [5806] = {.lex_state = 112},
  [5807] = {.lex_state = 112},
  [5808] = {.lex_state = 112},
  [5809] = {.lex_state = 112},
  [5810] = {.lex_state = 112},
  [5811] = {.lex_state = 112},
  [5812] = {.lex_state = 112},
  [5813] = {.lex_state = 112},
  [5814] = {.lex_state = 0},
  [5815] = {.lex_state = 112},
  [5816] = {.lex_state = 112},
  [5817] = {.lex_state = 112},
  [5818] = {.lex_state = 112},
  [5819] = {.lex_state = 112},
  [5820] = {.lex_state = 112},
  [5821] = {.lex_state = 112, .external_lex_state = 4},
  [5822] = {.lex_state = 112},
  [5823] = {.lex_state = 112},
  [5824] = {.lex_state = 112},
  [5825] = {.lex_state = 112},
  [5826] = {.lex_state = 112},
  [5827] = {.lex_state = 112},
  [5828] = {.lex_state = 112},
  [5829] = {.lex_state = 0},
  [5830] = {.lex_state = 112},
  [5831] = {.lex_state = 112},
  [5832] = {.lex_state = 112},
  [5833] = {.lex_state = 112},
  [5834] = {.lex_state = 0},
  [5835] = {.lex_state = 112},
  [5836] = {.lex_state = 112},
  [5837] = {.lex_state = 0},
  [5838] = {.lex_state = 112},
  [5839] = {.lex_state = 112},
  [5840] = {.lex_state = 112},
  [5841] = {.lex_state = 0},
  [5842] = {.lex_state = 112},
  [5843] = {.lex_state = 112, .external_lex_state = 4},
  [5844] = {.lex_state = 112},
  [5845] = {.lex_state = 112},
  [5846] = {.lex_state = 112},
  [5847] = {.lex_state = 0},
  [5848] = {.lex_state = 112},
  [5849] = {.lex_state = 112},
  [5850] = {.lex_state = 112},
  [5851] = {.lex_state = 112},
  [5852] = {.lex_state = 0},
  [5853] = {.lex_state = 112},
  [5854] = {.lex_state = 0},
  [5855] = {.lex_state = 112},
  [5856] = {.lex_state = 112},
  [5857] = {.lex_state = 112},
  [5858] = {.lex_state = 112},
  [5859] = {.lex_state = 0},
  [5860] = {.lex_state = 112},
  [5861] = {.lex_state = 112},
  [5862] = {.lex_state = 112},
  [5863] = {.lex_state = 112},
  [5864] = {.lex_state = 0},
  [5865] = {.lex_state = 0},
  [5866] = {.lex_state = 0},
  [5867] = {.lex_state = 112},
  [5868] = {.lex_state = 112},
  [5869] = {.lex_state = 112},
  [5870] = {.lex_state = 112},
  [5871] = {.lex_state = 112},
  [5872] = {.lex_state = 112},
  [5873] = {.lex_state = 112},
  [5874] = {.lex_state = 112},
  [5875] = {.lex_state = 112},
  [5876] = {.lex_state = 112},
  [5877] = {.lex_state = 112},
  [5878] = {.lex_state = 112},
  [5879] = {.lex_state = 112},
  [5880] = {.lex_state = 112},
  [5881] = {.lex_state = 112},
  [5882] = {.lex_state = 112},
  [5883] = {.lex_state = 112},
  [5884] = {.lex_state = 112},
  [5885] = {.lex_state = 112},
  [5886] = {.lex_state = 112},
  [5887] = {.lex_state = 112},
  [5888] = {.lex_state = 112},
  [5889] = {.lex_state = 112},
  [5890] = {.lex_state = 112},
  [5891] = {.lex_state = 112},
  [5892] = {.lex_state = 112},
  [5893] = {.lex_state = 112},
  [5894] = {.lex_state = 112},
  [5895] = {.lex_state = 112},
  [5896] = {.lex_state = 112},
  [5897] = {.lex_state = 112},
  [5898] = {.lex_state = 112},
  [5899] = {.lex_state = 112},
  [5900] = {.lex_state = 112},
  [5901] = {.lex_state = 112},
  [5902] = {.lex_state = 112},
  [5903] = {.lex_state = 112},
  [5904] = {.lex_state = 112},
  [5905] = {.lex_state = 112},
  [5906] = {.lex_state = 112},
  [5907] = {.lex_state = 112},
  [5908] = {.lex_state = 112},
  [5909] = {.lex_state = 112},
  [5910] = {.lex_state = 112},
  [5911] = {.lex_state = 112},
  [5912] = {.lex_state = 112, .external_lex_state = 4},
  [5913] = {.lex_state = 0},
  [5914] = {.lex_state = 112, .external_lex_state = 4},
  [5915] = {.lex_state = 112, .external_lex_state = 4},
  [5916] = {.lex_state = 112},
  [5917] = {.lex_state = 112},
  [5918] = {.lex_state = 112},
  [5919] = {.lex_state = 112},
  [5920] = {.lex_state = 112},
  [5921] = {.lex_state = 112},
  [5922] = {.lex_state = 112},
  [5923] = {.lex_state = 0},
  [5924] = {.lex_state = 112},
  [5925] = {.lex_state = 112},
  [5926] = {.lex_state = 112},
  [5927] = {.lex_state = 112},
  [5928] = {.lex_state = 112},
  [5929] = {.lex_state = 112},
  [5930] = {.lex_state = 112},
  [5931] = {.lex_state = 112},
  [5932] = {.lex_state = 112},
  [5933] = {.lex_state = 112},
  [5934] = {.lex_state = 0},
  [5935] = {.lex_state = 0},
  [5936] = {.lex_state = 112},
  [5937] = {.lex_state = 112},
  [5938] = {.lex_state = 112},
  [5939] = {.lex_state = 112},
  [5940] = {.lex_state = 112},
  [5941] = {.lex_state = 112},
  [5942] = {.lex_state = 112},
  [5943] = {.lex_state = 112},
  [5944] = {.lex_state = 112, .external_lex_state = 4},
  [5945] = {.lex_state = 112},
  [5946] = {.lex_state = 112},
  [5947] = {.lex_state = 112},
  [5948] = {.lex_state = 112},
  [5949] = {.lex_state = 112, .external_lex_state = 4},
  [5950] = {.lex_state = 112, .external_lex_state = 4},
  [5951] = {.lex_state = 112},
  [5952] = {.lex_state = 112},
  [5953] = {.lex_state = 112},
  [5954] = {.lex_state = 112},
  [5955] = {.lex_state = 112, .external_lex_state = 4},
  [5956] = {.lex_state = 112, .external_lex_state = 4},
  [5957] = {.lex_state = 112, .external_lex_state = 4},
  [5958] = {.lex_state = 112, .external_lex_state = 4},
  [5959] = {.lex_state = 112, .external_lex_state = 4},
  [5960] = {.lex_state = 112, .external_lex_state = 4},
  [5961] = {.lex_state = 0},
  [5962] = {.lex_state = 112, .external_lex_state = 4},
  [5963] = {.lex_state = 112, .external_lex_state = 4},
  [5964] = {.lex_state = 112, .external_lex_state = 4},
  [5965] = {.lex_state = 112, .external_lex_state = 4},
  [5966] = {.lex_state = 112, .external_lex_state = 4},
  [5967] = {.lex_state = 112},
  [5968] = {.lex_state = 0},
  [5969] = {.lex_state = 24},
  [5970] = {.lex_state = 112},
  [5971] = {.lex_state = 112},
  [5972] = {.lex_state = 112},
  [5973] = {.lex_state = 112},
  [5974] = {.lex_state = 112},
  [5975] = {.lex_state = 112},
  [5976] = {.lex_state = 112},
  [5977] = {.lex_state = 112},
  [5978] = {.lex_state = 112},
  [5979] = {.lex_state = 112},
  [5980] = {.lex_state = 112},
  [5981] = {.lex_state = 112},
  [5982] = {.lex_state = 112},
  [5983] = {.lex_state = 112},
  [5984] = {.lex_state = 112},
  [5985] = {.lex_state = 112},
  [5986] = {.lex_state = 112},
  [5987] = {.lex_state = 112},
  [5988] = {.lex_state = 112},
  [5989] = {.lex_state = 112, .external_lex_state = 4},
  [5990] = {.lex_state = 112},
  [5991] = {.lex_state = 112, .external_lex_state = 4},
  [5992] = {.lex_state = 112},
  [5993] = {.lex_state = 112},
  [5994] = {.lex_state = 112},
  [5995] = {.lex_state = 112, .external_lex_state = 4},
  [5996] = {.lex_state = 112, .external_lex_state = 4},
  [5997] = {.lex_state = 112},
  [5998] = {.lex_state = 112},
  [5999] = {.lex_state = 112},
  [6000] = {.lex_state = 112},
  [6001] = {.lex_state = 112},
  [6002] = {.lex_state = 112},
  [6003] = {.lex_state = 0},
  [6004] = {.lex_state = 112},
  [6005] = {.lex_state = 112},
  [6006] = {.lex_state = 112},
  [6007] = {.lex_state = 112},
  [6008] = {.lex_state = 112},
  [6009] = {.lex_state = 112},
  [6010] = {.lex_state = 112},
  [6011] = {.lex_state = 112},
  [6012] = {.lex_state = 112},
  [6013] = {.lex_state = 112, .external_lex_state = 4},
  [6014] = {.lex_state = 0},
  [6015] = {.lex_state = 112},
  [6016] = {.lex_state = 112, .external_lex_state = 4},
  [6017] = {.lex_state = 112, .external_lex_state = 4},
  [6018] = {.lex_state = 112},
  [6019] = {.lex_state = 112},
  [6020] = {.lex_state = 112},
  [6021] = {.lex_state = 112},
  [6022] = {.lex_state = 112},
  [6023] = {.lex_state = 112},
  [6024] = {.lex_state = 112},
  [6025] = {.lex_state = 112},
  [6026] = {.lex_state = 0},
  [6027] = {.lex_state = 112, .external_lex_state = 4},
  [6028] = {.lex_state = 112},
  [6029] = {.lex_state = 112},
  [6030] = {.lex_state = 112},
  [6031] = {.lex_state = 112},
  [6032] = {.lex_state = 112, .external_lex_state = 4},
  [6033] = {.lex_state = 0},
  [6034] = {.lex_state = 0},
  [6035] = {.lex_state = 112},
  [6036] = {.lex_state = 112},
  [6037] = {.lex_state = 112},
  [6038] = {.lex_state = 112},
  [6039] = {.lex_state = 112},
  [6040] = {.lex_state = 112},
  [6041] = {.lex_state = 112},
  [6042] = {.lex_state = 112},
  [6043] = {.lex_state = 112},
  [6044] = {.lex_state = 112},
  [6045] = {.lex_state = 112},
  [6046] = {.lex_state = 112},
  [6047] = {.lex_state = 112},
  [6048] = {.lex_state = 112},
  [6049] = {.lex_state = 112},
  [6050] = {.lex_state = 112},
  [6051] = {.lex_state = 112},
  [6052] = {.lex_state = 112},
  [6053] = {.lex_state = 112},
  [6054] = {.lex_state = 112},
  [6055] = {.lex_state = 112},
  [6056] = {.lex_state = 112},
  [6057] = {.lex_state = 112},
  [6058] = {.lex_state = 112},
  [6059] = {.lex_state = 112, .external_lex_state = 4},
  [6060] = {.lex_state = 0},
  [6061] = {.lex_state = 112},
  [6062] = {.lex_state = 112},
  [6063] = {.lex_state = 112},
  [6064] = {.lex_state = 112},
  [6065] = {.lex_state = 112},
  [6066] = {.lex_state = 0},
  [6067] = {.lex_state = 112},
  [6068] = {.lex_state = 112},
  [6069] = {.lex_state = 112},
  [6070] = {.lex_state = 112},
  [6071] = {.lex_state = 112},
  [6072] = {.lex_state = 112},
  [6073] = {.lex_state = 112},
  [6074] = {.lex_state = 112},
  [6075] = {.lex_state = 112},
  [6076] = {.lex_state = 112},
  [6077] = {.lex_state = 112},
  [6078] = {.lex_state = 112},
  [6079] = {.lex_state = 112},
  [6080] = {.lex_state = 112},
  [6081] = {.lex_state = 112},
  [6082] = {.lex_state = 112, .external_lex_state = 4},
  [6083] = {.lex_state = 112},
  [6084] = {.lex_state = 112},
  [6085] = {.lex_state = 112},
  [6086] = {.lex_state = 112},
  [6087] = {.lex_state = 112},
  [6088] = {.lex_state = 112},
  [6089] = {.lex_state = 112},
  [6090] = {.lex_state = 9},
  [6091] = {.lex_state = 112},
  [6092] = {.lex_state = 112},
  [6093] = {.lex_state = 112},
  [6094] = {.lex_state = 112},
  [6095] = {.lex_state = 112},
  [6096] = {.lex_state = 112},
  [6097] = {.lex_state = 112},
  [6098] = {.lex_state = 112},
  [6099] = {.lex_state = 112},
  [6100] = {.lex_state = 112},
  [6101] = {.lex_state = 112},
  [6102] = {.lex_state = 112},
  [6103] = {.lex_state = 112},
  [6104] = {.lex_state = 112},
  [6105] = {.lex_state = 112},
  [6106] = {.lex_state = 112},
  [6107] = {.lex_state = 112},
  [6108] = {.lex_state = 112},
  [6109] = {.lex_state = 112},
  [6110] = {.lex_state = 112},
  [6111] = {.lex_state = 112},
  [6112] = {.lex_state = 112},
  [6113] = {.lex_state = 112},
  [6114] = {.lex_state = 112},
  [6115] = {.lex_state = 112},
  [6116] = {.lex_state = 112},
  [6117] = {.lex_state = 112},
  [6118] = {.lex_state = 112},
  [6119] = {.lex_state = 112},
  [6120] = {.lex_state = 112},
  [6121] = {.lex_state = 112},
  [6122] = {.lex_state = 112},
  [6123] = {.lex_state = 112},
  [6124] = {.lex_state = 112},
  [6125] = {.lex_state = 9},
  [6126] = {.lex_state = 112},
  [6127] = {.lex_state = 112},
  [6128] = {.lex_state = 112},
  [6129] = {.lex_state = 9},
  [6130] = {.lex_state = 112},
  [6131] = {.lex_state = 112},
  [6132] = {.lex_state = 112},
  [6133] = {.lex_state = 112},
  [6134] = {.lex_state = 112},
  [6135] = {.lex_state = 112},
  [6136] = {.lex_state = 112},
  [6137] = {.lex_state = 112},
  [6138] = {.lex_state = 112},
  [6139] = {.lex_state = 112},
  [6140] = {.lex_state = 9},
  [6141] = {.lex_state = 0},
  [6142] = {.lex_state = 0},
  [6143] = {.lex_state = 112},
  [6144] = {.lex_state = 112},
  [6145] = {.lex_state = 112},
  [6146] = {.lex_state = 0},
  [6147] = {.lex_state = 9},
  [6148] = {.lex_state = 9},
  [6149] = {.lex_state = 112},
  [6150] = {.lex_state = 112},
  [6151] = {.lex_state = 9},
  [6152] = {.lex_state = 112},
  [6153] = {.lex_state = 112},
  [6154] = {.lex_state = 112},
  [6155] = {.lex_state = 9},
  [6156] = {.lex_state = 112},
  [6157] = {.lex_state = 112},
  [6158] = {.lex_state = 112},
  [6159] = {.lex_state = 112},
  [6160] = {.lex_state = 0},
  [6161] = {.lex_state = 112},
  [6162] = {.lex_state = 0},
  [6163] = {.lex_state = 9},
  [6164] = {.lex_state = 9},
  [6165] = {.lex_state = 112, .external_lex_state = 4},
  [6166] = {.lex_state = 113},
  [6167] = {.lex_state = 112},
  [6168] = {.lex_state = 112},
  [6169] = {.lex_state = 112},
  [6170] = {.lex_state = 112},
  [6171] = {.lex_state = 112},
  [6172] = {.lex_state = 112},
  [6173] = {.lex_state = 112},
  [6174] = {.lex_state = 112},
  [6175] = {.lex_state = 9},
  [6176] = {.lex_state = 112},
  [6177] = {.lex_state = 112},
  [6178] = {.lex_state = 112},
  [6179] = {.lex_state = 112},
  [6180] = {.lex_state = 112},
  [6181] = {.lex_state = 112},
  [6182] = {.lex_state = 112},
  [6183] = {.lex_state = 112},
  [6184] = {.lex_state = 112},
  [6185] = {.lex_state = 112},
  [6186] = {.lex_state = 112},
  [6187] = {.lex_state = 112},
  [6188] = {.lex_state = 112},
  [6189] = {.lex_state = 112},
  [6190] = {.lex_state = 112},
  [6191] = {.lex_state = 112},
  [6192] = {.lex_state = 112},
  [6193] = {.lex_state = 112},
  [6194] = {.lex_state = 9},
  [6195] = {.lex_state = 112},
  [6196] = {.lex_state = 112},
  [6197] = {.lex_state = 112},
  [6198] = {.lex_state = 9},
  [6199] = {.lex_state = 112},
  [6200] = {.lex_state = 112},
  [6201] = {.lex_state = 112},
  [6202] = {.lex_state = 9},
  [6203] = {.lex_state = 112},
  [6204] = {.lex_state = 9},
  [6205] = {.lex_state = 112},
  [6206] = {.lex_state = 112},
  [6207] = {.lex_state = 112},
  [6208] = {.lex_state = 112},
  [6209] = {.lex_state = 112},
  [6210] = {.lex_state = 9},
  [6211] = {.lex_state = 112},
  [6212] = {.lex_state = 112},
  [6213] = {.lex_state = 9},
  [6214] = {.lex_state = 112},
  [6215] = {.lex_state = 9},
  [6216] = {.lex_state = 9},
  [6217] = {.lex_state = 112},
  [6218] = {.lex_state = 113},
  [6219] = {.lex_state = 112},
  [6220] = {.lex_state = 112},
  [6221] = {.lex_state = 9},
  [6222] = {.lex_state = 9},
  [6223] = {.lex_state = 112},
  [6224] = {.lex_state = 112},
  [6225] = {.lex_state = 112},
  [6226] = {.lex_state = 112},
  [6227] = {.lex_state = 112},
  [6228] = {.lex_state = 112},
  [6229] = {.lex_state = 112},
  [6230] = {.lex_state = 0},
  [6231] = {.lex_state = 112},
  [6232] = {.lex_state = 112},
  [6233] = {.lex_state = 9},
  [6234] = {.lex_state = 112},
  [6235] = {.lex_state = 9},
  [6236] = {.lex_state = 112},
  [6237] = {.lex_state = 112},
  [6238] = {.lex_state = 112},
  [6239] = {.lex_state = 9},
  [6240] = {.lex_state = 112},
  [6241] = {.lex_state = 112},
  [6242] = {.lex_state = 112},
  [6243] = {.lex_state = 112},
  [6244] = {.lex_state = 112},
  [6245] = {.lex_state = 112},
  [6246] = {.lex_state = 112},
  [6247] = {.lex_state = 112},
  [6248] = {.lex_state = 112},
  [6249] = {.lex_state = 112},
  [6250] = {.lex_state = 112},
  [6251] = {.lex_state = 112},
  [6252] = {.lex_state = 112},
  [6253] = {.lex_state = 112},
  [6254] = {.lex_state = 112},
  [6255] = {.lex_state = 112},
  [6256] = {.lex_state = 112},
  [6257] = {.lex_state = 112},
  [6258] = {.lex_state = 112},
  [6259] = {.lex_state = 112},
  [6260] = {.lex_state = 112},
  [6261] = {.lex_state = 112},
  [6262] = {.lex_state = 112},
  [6263] = {.lex_state = 9},
  [6264] = {.lex_state = 112},
  [6265] = {.lex_state = 112},
  [6266] = {.lex_state = 9},
  [6267] = {.lex_state = 112},
  [6268] = {.lex_state = 112},
  [6269] = {.lex_state = 112},
  [6270] = {.lex_state = 112},
  [6271] = {.lex_state = 112},
  [6272] = {.lex_state = 112},
  [6273] = {.lex_state = 112},
  [6274] = {.lex_state = 112},
  [6275] = {.lex_state = 9},
  [6276] = {.lex_state = 112},
  [6277] = {.lex_state = 112},
  [6278] = {.lex_state = 112},
  [6279] = {.lex_state = 112},
  [6280] = {.lex_state = 112},
  [6281] = {.lex_state = 112},
  [6282] = {.lex_state = 112},
  [6283] = {.lex_state = 112},
  [6284] = {.lex_state = 112},
  [6285] = {.lex_state = 112},
  [6286] = {.lex_state = 112},
  [6287] = {.lex_state = 112},
  [6288] = {.lex_state = 112},
  [6289] = {.lex_state = 112},
  [6290] = {.lex_state = 112},
  [6291] = {.lex_state = 112},
  [6292] = {.lex_state = 112},
  [6293] = {.lex_state = 112},
  [6294] = {.lex_state = 112},
  [6295] = {.lex_state = 112},
  [6296] = {.lex_state = 112},
  [6297] = {.lex_state = 112},
  [6298] = {.lex_state = 112},
  [6299] = {.lex_state = 112},
  [6300] = {.lex_state = 112},
  [6301] = {.lex_state = 112},
  [6302] = {.lex_state = 112},
  [6303] = {.lex_state = 112},
  [6304] = {.lex_state = 112},
  [6305] = {.lex_state = 112},
  [6306] = {.lex_state = 0},
  [6307] = {.lex_state = 112},
  [6308] = {.lex_state = 112},
  [6309] = {.lex_state = 112},
  [6310] = {.lex_state = 112},
  [6311] = {.lex_state = 112},
  [6312] = {.lex_state = 112},
  [6313] = {.lex_state = 112},
  [6314] = {.lex_state = 112},
  [6315] = {.lex_state = 112},
  [6316] = {.lex_state = 112},
  [6317] = {.lex_state = 0},
  [6318] = {.lex_state = 112},
  [6319] = {.lex_state = 112},
  [6320] = {.lex_state = 112},
  [6321] = {.lex_state = 112},
  [6322] = {.lex_state = 112},
  [6323] = {.lex_state = 112},
  [6324] = {.lex_state = 112},
  [6325] = {.lex_state = 112},
  [6326] = {.lex_state = 112},
  [6327] = {.lex_state = 112},
  [6328] = {.lex_state = 112},
  [6329] = {.lex_state = 112},
  [6330] = {.lex_state = 112},
  [6331] = {.lex_state = 112},
  [6332] = {.lex_state = 112},
  [6333] = {.lex_state = 112},
  [6334] = {.lex_state = 112},
  [6335] = {.lex_state = 112},
  [6336] = {.lex_state = 112},
  [6337] = {.lex_state = 112},
  [6338] = {.lex_state = 112},
  [6339] = {.lex_state = 112},
  [6340] = {.lex_state = 112},
  [6341] = {.lex_state = 112},
  [6342] = {.lex_state = 112},
  [6343] = {.lex_state = 112},
  [6344] = {.lex_state = 112},
  [6345] = {.lex_state = 112},
  [6346] = {.lex_state = 112},
  [6347] = {.lex_state = 112},
  [6348] = {.lex_state = 112},
  [6349] = {.lex_state = 112},
  [6350] = {.lex_state = 112},
  [6351] = {.lex_state = 112},
  [6352] = {.lex_state = 112},
  [6353] = {.lex_state = 112},
  [6354] = {.lex_state = 112},
  [6355] = {.lex_state = 112},
  [6356] = {.lex_state = 112},
  [6357] = {.lex_state = 112},
  [6358] = {.lex_state = 112},
  [6359] = {.lex_state = 112},
  [6360] = {.lex_state = 112},
  [6361] = {.lex_state = 112},
  [6362] = {.lex_state = 112},
  [6363] = {.lex_state = 112},
  [6364] = {.lex_state = 112},
  [6365] = {.lex_state = 112},
  [6366] = {.lex_state = 112},
  [6367] = {.lex_state = 112},
  [6368] = {.lex_state = 112},
  [6369] = {.lex_state = 112},
  [6370] = {.lex_state = 112},
  [6371] = {.lex_state = 112},
  [6372] = {.lex_state = 112},
  [6373] = {.lex_state = 112},
  [6374] = {.lex_state = 112},
  [6375] = {.lex_state = 112},
  [6376] = {.lex_state = 112},
  [6377] = {.lex_state = 112},
  [6378] = {.lex_state = 112},
  [6379] = {.lex_state = 112},
  [6380] = {.lex_state = 112},
  [6381] = {.lex_state = 112},
  [6382] = {.lex_state = 112},
  [6383] = {.lex_state = 112},
  [6384] = {.lex_state = 112},
  [6385] = {.lex_state = 112},
  [6386] = {.lex_state = 112},
  [6387] = {.lex_state = 112},
  [6388] = {.lex_state = 112},
  [6389] = {.lex_state = 112},
  [6390] = {.lex_state = 112},
  [6391] = {.lex_state = 112},
  [6392] = {.lex_state = 112},
  [6393] = {.lex_state = 112},
  [6394] = {.lex_state = 112},
  [6395] = {.lex_state = 112},
  [6396] = {.lex_state = 112},
  [6397] = {.lex_state = 112},
  [6398] = {.lex_state = 112},
  [6399] = {.lex_state = 112},
  [6400] = {.lex_state = 112},
  [6401] = {.lex_state = 112},
  [6402] = {.lex_state = 112},
  [6403] = {.lex_state = 112},
  [6404] = {.lex_state = 112},
  [6405] = {.lex_state = 112},
  [6406] = {.lex_state = 112},
  [6407] = {.lex_state = 112},
  [6408] = {.lex_state = 112},
  [6409] = {.lex_state = 112},
  [6410] = {.lex_state = 112},
  [6411] = {.lex_state = 112},
  [6412] = {.lex_state = 112},
  [6413] = {.lex_state = 112},
  [6414] = {.lex_state = 112},
  [6415] = {.lex_state = 112},
  [6416] = {.lex_state = 112},
  [6417] = {.lex_state = 112},
  [6418] = {.lex_state = 112},
  [6419] = {.lex_state = 112},
  [6420] = {.lex_state = 112},
  [6421] = {.lex_state = 112},
  [6422] = {.lex_state = 112},
  [6423] = {.lex_state = 112},
  [6424] = {.lex_state = 112},
  [6425] = {.lex_state = 112},
  [6426] = {.lex_state = 112},
  [6427] = {.lex_state = 112},
  [6428] = {.lex_state = 112},
  [6429] = {.lex_state = 112},
  [6430] = {.lex_state = 112},
  [6431] = {.lex_state = 112},
  [6432] = {.lex_state = 112},
  [6433] = {.lex_state = 112},
  [6434] = {.lex_state = 112},
  [6435] = {.lex_state = 112},
  [6436] = {.lex_state = 112},
  [6437] = {.lex_state = 112},
  [6438] = {.lex_state = 112},
  [6439] = {.lex_state = 112},
  [6440] = {.lex_state = 112},
  [6441] = {.lex_state = 112},
  [6442] = {.lex_state = 112},
  [6443] = {.lex_state = 112},
  [6444] = {.lex_state = 112},
  [6445] = {.lex_state = 112},
  [6446] = {.lex_state = 112},
  [6447] = {.lex_state = 112},
  [6448] = {.lex_state = 112},
  [6449] = {.lex_state = 112},
  [6450] = {.lex_state = 112},
  [6451] = {.lex_state = 112},
  [6452] = {.lex_state = 112},
  [6453] = {.lex_state = 112},
  [6454] = {.lex_state = 112},
  [6455] = {.lex_state = 112},
  [6456] = {.lex_state = 112},
  [6457] = {.lex_state = 112},
  [6458] = {.lex_state = 112},
  [6459] = {.lex_state = 112},
  [6460] = {.lex_state = 112},
  [6461] = {.lex_state = 112},
  [6462] = {.lex_state = 112},
  [6463] = {.lex_state = 112},
  [6464] = {.lex_state = 112},
  [6465] = {.lex_state = 112},
  [6466] = {.lex_state = 112},
  [6467] = {.lex_state = 112},
  [6468] = {.lex_state = 112},
  [6469] = {.lex_state = 112},
  [6470] = {.lex_state = 112},
  [6471] = {.lex_state = 112},
  [6472] = {.lex_state = 112},
  [6473] = {.lex_state = 112},
  [6474] = {.lex_state = 112},
  [6475] = {.lex_state = 112},
  [6476] = {.lex_state = 112},
  [6477] = {.lex_state = 112},
  [6478] = {.lex_state = 112},
  [6479] = {.lex_state = 112},
  [6480] = {.lex_state = 112},
  [6481] = {.lex_state = 112},
  [6482] = {.lex_state = 112},
  [6483] = {.lex_state = 112},
  [6484] = {.lex_state = 112},
  [6485] = {.lex_state = 112},
  [6486] = {.lex_state = 112},
  [6487] = {.lex_state = 112},
  [6488] = {.lex_state = 112},
  [6489] = {.lex_state = 112},
  [6490] = {.lex_state = 112},
  [6491] = {.lex_state = 112},
  [6492] = {.lex_state = 112},
  [6493] = {.lex_state = 112},
  [6494] = {.lex_state = 112},
  [6495] = {.lex_state = 112},
  [6496] = {.lex_state = 112},
  [6497] = {.lex_state = 112},
  [6498] = {.lex_state = 112},
  [6499] = {.lex_state = 112},
  [6500] = {.lex_state = 112},
  [6501] = {.lex_state = 112},
  [6502] = {.lex_state = 113},
  [6503] = {.lex_state = 112},
  [6504] = {.lex_state = 112},
  [6505] = {.lex_state = 112},
  [6506] = {.lex_state = 112},
  [6507] = {.lex_state = 0},
  [6508] = {.lex_state = 112},
  [6509] = {.lex_state = 113},
  [6510] = {.lex_state = 112},
  [6511] = {.lex_state = 112},
  [6512] = {.lex_state = 112},
  [6513] = {.lex_state = 112},
  [6514] = {.lex_state = 112},
  [6515] = {.lex_state = 113},
  [6516] = {.lex_state = 112},
  [6517] = {.lex_state = 112},
  [6518] = {.lex_state = 112},
  [6519] = {.lex_state = 112},
  [6520] = {.lex_state = 112},
  [6521] = {.lex_state = 112},
  [6522] = {.lex_state = 112},
  [6523] = {.lex_state = 112},
  [6524] = {.lex_state = 112},
  [6525] = {.lex_state = 112},
  [6526] = {.lex_state = 112},
  [6527] = {.lex_state = 112},
  [6528] = {.lex_state = 112},
  [6529] = {.lex_state = 112},
  [6530] = {.lex_state = 112},
  [6531] = {.lex_state = 112},
  [6532] = {.lex_state = 112},
  [6533] = {.lex_state = 112},
  [6534] = {.lex_state = 112},
  [6535] = {.lex_state = 112},
  [6536] = {.lex_state = 112},
  [6537] = {.lex_state = 112},
  [6538] = {.lex_state = 112},
  [6539] = {.lex_state = 112},
  [6540] = {.lex_state = 112},
  [6541] = {.lex_state = 112},
  [6542] = {.lex_state = 112},
  [6543] = {.lex_state = 112},
  [6544] = {.lex_state = 112},
  [6545] = {.lex_state = 112},
  [6546] = {.lex_state = 112},
  [6547] = {.lex_state = 112},
  [6548] = {.lex_state = 112},
  [6549] = {.lex_state = 112},
  [6550] = {.lex_state = 112},
  [6551] = {.lex_state = 112},
  [6552] = {.lex_state = 112},
  [6553] = {.lex_state = 112},
  [6554] = {.lex_state = 112},
  [6555] = {.lex_state = 112},
  [6556] = {.lex_state = 112},
  [6557] = {.lex_state = 112},
  [6558] = {.lex_state = 112},
  [6559] = {.lex_state = 112},
  [6560] = {.lex_state = 113},
  [6561] = {.lex_state = 112},
  [6562] = {.lex_state = 112},
  [6563] = {.lex_state = 112},
  [6564] = {.lex_state = 112},
  [6565] = {.lex_state = 112},
  [6566] = {.lex_state = 112},
  [6567] = {.lex_state = 112},
  [6568] = {.lex_state = 112},
  [6569] = {.lex_state = 112},
  [6570] = {.lex_state = 112},
  [6571] = {.lex_state = 112},
  [6572] = {.lex_state = 112},
  [6573] = {.lex_state = 112},
  [6574] = {.lex_state = 112},
  [6575] = {.lex_state = 112},
  [6576] = {.lex_state = 112},
  [6577] = {.lex_state = 112},
  [6578] = {.lex_state = 112},
  [6579] = {.lex_state = 112},
  [6580] = {.lex_state = 112},
  [6581] = {.lex_state = 112},
  [6582] = {.lex_state = 112},
  [6583] = {.lex_state = 112},
  [6584] = {.lex_state = 112},
  [6585] = {.lex_state = 112},
  [6586] = {.lex_state = 112},
  [6587] = {.lex_state = 112},
  [6588] = {.lex_state = 112},
  [6589] = {.lex_state = 112},
  [6590] = {.lex_state = 112},
  [6591] = {.lex_state = 112},
  [6592] = {.lex_state = 112},
  [6593] = {.lex_state = 112},
  [6594] = {.lex_state = 112},
  [6595] = {.lex_state = 112},
  [6596] = {.lex_state = 112},
  [6597] = {.lex_state = 112},
  [6598] = {.lex_state = 112},
  [6599] = {.lex_state = 112},
  [6600] = {.lex_state = 112},
  [6601] = {.lex_state = 112},
  [6602] = {.lex_state = 112},
  [6603] = {.lex_state = 112},
  [6604] = {.lex_state = 112},
  [6605] = {.lex_state = 112},
  [6606] = {.lex_state = 112},
  [6607] = {.lex_state = 112},
  [6608] = {.lex_state = 112},
  [6609] = {.lex_state = 112},
  [6610] = {.lex_state = 112},
  [6611] = {.lex_state = 112},
  [6612] = {.lex_state = 112},
  [6613] = {.lex_state = 112},
  [6614] = {.lex_state = 112},
  [6615] = {.lex_state = 112},
  [6616] = {.lex_state = 112},
  [6617] = {.lex_state = 112},
  [6618] = {.lex_state = 112},
  [6619] = {.lex_state = 112},
  [6620] = {.lex_state = 112},
  [6621] = {.lex_state = 112},
  [6622] = {.lex_state = 112},
  [6623] = {.lex_state = 112},
  [6624] = {.lex_state = 112},
  [6625] = {.lex_state = 112},
  [6626] = {.lex_state = 112},
  [6627] = {.lex_state = 112},
  [6628] = {.lex_state = 112},
  [6629] = {.lex_state = 112},
  [6630] = {.lex_state = 112},
  [6631] = {.lex_state = 112},
  [6632] = {.lex_state = 112},
  [6633] = {.lex_state = 112},
  [6634] = {.lex_state = 112},
  [6635] = {.lex_state = 112},
  [6636] = {.lex_state = 112},
  [6637] = {.lex_state = 112},
  [6638] = {.lex_state = 112},
  [6639] = {.lex_state = 112},
  [6640] = {.lex_state = 112},
  [6641] = {.lex_state = 112},
  [6642] = {.lex_state = 112},
  [6643] = {.lex_state = 112},
  [6644] = {.lex_state = 112},
  [6645] = {.lex_state = 112},
  [6646] = {.lex_state = 112},
  [6647] = {.lex_state = 112},
  [6648] = {.lex_state = 112},
  [6649] = {.lex_state = 112},
  [6650] = {.lex_state = 112},
  [6651] = {.lex_state = 112},
  [6652] = {.lex_state = 112},
  [6653] = {.lex_state = 112},
  [6654] = {.lex_state = 112},
  [6655] = {.lex_state = 112},
  [6656] = {.lex_state = 112},
  [6657] = {.lex_state = 112},
  [6658] = {.lex_state = 112},
  [6659] = {.lex_state = 112},
  [6660] = {.lex_state = 112},
  [6661] = {.lex_state = 0},
  [6662] = {.lex_state = 112},
  [6663] = {.lex_state = 112},
  [6664] = {.lex_state = 113},
  [6665] = {.lex_state = 112},
  [6666] = {.lex_state = 113},
  [6667] = {.lex_state = 112},
  [6668] = {.lex_state = 0},
  [6669] = {.lex_state = 113},
  [6670] = {.lex_state = 112},
  [6671] = {.lex_state = 0},
  [6672] = {.lex_state = 0},
  [6673] = {.lex_state = 113},
  [6674] = {.lex_state = 112},
  [6675] = {.lex_state = 112},
  [6676] = {.lex_state = 112},
  [6677] = {.lex_state = 112},
  [6678] = {.lex_state = 0},
  [6679] = {.lex_state = 0},
  [6680] = {.lex_state = 112},
  [6681] = {.lex_state = 112},
  [6682] = {.lex_state = 112},
  [6683] = {.lex_state = 112},
  [6684] = {.lex_state = 113},
  [6685] = {.lex_state = 113},
  [6686] = {.lex_state = 112},
  [6687] = {.lex_state = 112},
  [6688] = {.lex_state = 112},
  [6689] = {.lex_state = 112},
  [6690] = {.lex_state = 112},
  [6691] = {.lex_state = 112},
  [6692] = {.lex_state = 112},
  [6693] = {.lex_state = 112},
  [6694] = {.lex_state = 24},
  [6695] = {.lex_state = 0},
  [6696] = {.lex_state = 24},
  [6697] = {.lex_state = 112},
  [6698] = {.lex_state = 0},
  [6699] = {.lex_state = 112},
  [6700] = {.lex_state = 113},
  [6701] = {.lex_state = 0},
  [6702] = {.lex_state = 0},
  [6703] = {.lex_state = 0},
  [6704] = {.lex_state = 112},
  [6705] = {.lex_state = 112},
  [6706] = {.lex_state = 112},
  [6707] = {.lex_state = 112},
  [6708] = {.lex_state = 0},
  [6709] = {.lex_state = 112},
  [6710] = {.lex_state = 112},
  [6711] = {.lex_state = 112},
  [6712] = {.lex_state = 0},
  [6713] = {.lex_state = 113},
  [6714] = {.lex_state = 113},
  [6715] = {.lex_state = 0},
  [6716] = {.lex_state = 0},
  [6717] = {.lex_state = 0},
  [6718] = {.lex_state = 112},
  [6719] = {.lex_state = 113},
  [6720] = {.lex_state = 113},
  [6721] = {.lex_state = 0},
  [6722] = {.lex_state = 24},
  [6723] = {.lex_state = 24},
  [6724] = {.lex_state = 112},
  [6725] = {.lex_state = 0},
  [6726] = {.lex_state = 24},
  [6727] = {.lex_state = 113},
  [6728] = {.lex_state = 113},
  [6729] = {.lex_state = 113},
  [6730] = {.lex_state = 113},
  [6731] = {.lex_state = 112},
  [6732] = {.lex_state = 113},
  [6733] = {.lex_state = 0},
  [6734] = {.lex_state = 24},
  [6735] = {.lex_state = 112},
  [6736] = {.lex_state = 113},
  [6737] = {.lex_state = 113},
  [6738] = {.lex_state = 0},
  [6739] = {.lex_state = 112},
  [6740] = {.lex_state = 113},
  [6741] = {.lex_state = 112},
  [6742] = {.lex_state = 113},
  [6743] = {.lex_state = 0},
  [6744] = {.lex_state = 0},
  [6745] = {.lex_state = 0},
  [6746] = {.lex_state = 0},
  [6747] = {.lex_state = 0},
  [6748] = {.lex_state = 0},
  [6749] = {.lex_state = 0},
  [6750] = {.lex_state = 0},
  [6751] = {.lex_state = 0},
  [6752] = {.lex_state = 0},
  [6753] = {.lex_state = 0},
  [6754] = {.lex_state = 113},
  [6755] = {.lex_state = 0},
  [6756] = {.lex_state = 0},
  [6757] = {.lex_state = 0},
  [6758] = {.lex_state = 0},
  [6759] = {.lex_state = 0},
  [6760] = {.lex_state = 0},
  [6761] = {.lex_state = 0},
  [6762] = {.lex_state = 0},
  [6763] = {.lex_state = 0},
  [6764] = {.lex_state = 0},
  [6765] = {.lex_state = 0},
  [6766] = {.lex_state = 0},
  [6767] = {.lex_state = 0},
  [6768] = {.lex_state = 0},
  [6769] = {.lex_state = 0},
  [6770] = {.lex_state = 0},
  [6771] = {.lex_state = 0},
  [6772] = {.lex_state = 0},
  [6773] = {.lex_state = 0},
  [6774] = {.lex_state = 0},
  [6775] = {.lex_state = 0},
  [6776] = {.lex_state = 0},
  [6777] = {.lex_state = 0},
  [6778] = {.lex_state = 0},
  [6779] = {.lex_state = 0},
  [6780] = {.lex_state = 0},
  [6781] = {.lex_state = 0},
  [6782] = {.lex_state = 0},
  [6783] = {.lex_state = 0},
  [6784] = {.lex_state = 113},
  [6785] = {.lex_state = 0},
  [6786] = {.lex_state = 113},
  [6787] = {.lex_state = 0},
  [6788] = {.lex_state = 0},
  [6789] = {.lex_state = 0},
  [6790] = {.lex_state = 0},
  [6791] = {.lex_state = 0},
  [6792] = {.lex_state = 0},
  [6793] = {.lex_state = 0},
  [6794] = {.lex_state = 0},
  [6795] = {.lex_state = 0},
  [6796] = {.lex_state = 0},
  [6797] = {.lex_state = 0},
  [6798] = {.lex_state = 0},
  [6799] = {.lex_state = 0},
  [6800] = {.lex_state = 0},
  [6801] = {.lex_state = 0},
  [6802] = {.lex_state = 0},
  [6803] = {.lex_state = 0},
  [6804] = {.lex_state = 0},
  [6805] = {.lex_state = 0},
  [6806] = {.lex_state = 0},
  [6807] = {.lex_state = 0},
  [6808] = {.lex_state = 0},
  [6809] = {.lex_state = 0},
  [6810] = {.lex_state = 0},
  [6811] = {.lex_state = 0},
  [6812] = {.lex_state = 0},
  [6813] = {.lex_state = 0},
  [6814] = {.lex_state = 0},
  [6815] = {.lex_state = 0},
  [6816] = {.lex_state = 0},
  [6817] = {.lex_state = 0},
  [6818] = {.lex_state = 0},
  [6819] = {.lex_state = 0},
  [6820] = {.lex_state = 112},
  [6821] = {.lex_state = 0},
  [6822] = {.lex_state = 0},
  [6823] = {.lex_state = 0},
  [6824] = {.lex_state = 0},
  [6825] = {.lex_state = 0},
  [6826] = {.lex_state = 0},
  [6827] = {.lex_state = 0},
  [6828] = {.lex_state = 0},
  [6829] = {.lex_state = 0},
  [6830] = {.lex_state = 0},
  [6831] = {.lex_state = 0},
  [6832] = {.lex_state = 0},
  [6833] = {.lex_state = 0},
  [6834] = {.lex_state = 0},
  [6835] = {.lex_state = 0},
  [6836] = {.lex_state = 0},
  [6837] = {.lex_state = 0},
  [6838] = {.lex_state = 0},
  [6839] = {.lex_state = 0},
  [6840] = {.lex_state = 0},
  [6841] = {.lex_state = 0},
  [6842] = {.lex_state = 0},
  [6843] = {.lex_state = 0},
  [6844] = {.lex_state = 0},
  [6845] = {.lex_state = 0},
  [6846] = {.lex_state = 0},
  [6847] = {.lex_state = 0},
  [6848] = {.lex_state = 0},
  [6849] = {.lex_state = 0},
  [6850] = {.lex_state = 0},
  [6851] = {.lex_state = 0},
  [6852] = {.lex_state = 0},
  [6853] = {.lex_state = 0},
  [6854] = {.lex_state = 0},
  [6855] = {.lex_state = 0},
  [6856] = {.lex_state = 0},
  [6857] = {.lex_state = 0},
  [6858] = {.lex_state = 0},
  [6859] = {.lex_state = 0},
  [6860] = {.lex_state = 0},
  [6861] = {.lex_state = 0},
  [6862] = {.lex_state = 0},
  [6863] = {.lex_state = 0},
  [6864] = {.lex_state = 0},
  [6865] = {.lex_state = 0},
  [6866] = {.lex_state = 0},
  [6867] = {.lex_state = 0},
  [6868] = {.lex_state = 0},
  [6869] = {.lex_state = 0},
  [6870] = {.lex_state = 0},
  [6871] = {.lex_state = 0},
  [6872] = {.lex_state = 0},
  [6873] = {.lex_state = 0},
  [6874] = {.lex_state = 113},
  [6875] = {.lex_state = 0},
  [6876] = {.lex_state = 0},
  [6877] = {.lex_state = 113},
  [6878] = {.lex_state = 113},
  [6879] = {.lex_state = 113},
  [6880] = {.lex_state = 113},
  [6881] = {.lex_state = 113},
  [6882] = {.lex_state = 113},
  [6883] = {.lex_state = 113},
  [6884] = {.lex_state = 0},
  [6885] = {.lex_state = 0},
  [6886] = {.lex_state = 0},
  [6887] = {.lex_state = 113},
  [6888] = {.lex_state = 113},
  [6889] = {.lex_state = 113},
  [6890] = {.lex_state = 113},
  [6891] = {.lex_state = 0},
  [6892] = {.lex_state = 113},
  [6893] = {.lex_state = 113},
  [6894] = {.lex_state = 113},
  [6895] = {.lex_state = 113},
  [6896] = {.lex_state = 113},
  [6897] = {.lex_state = 113},
  [6898] = {.lex_state = 113},
  [6899] = {.lex_state = 0},
  [6900] = {.lex_state = 113},
  [6901] = {.lex_state = 113},
  [6902] = {.lex_state = 0},
  [6903] = {.lex_state = 0},
  [6904] = {.lex_state = 113},
  [6905] = {.lex_state = 113},
  [6906] = {.lex_state = 0},
  [6907] = {.lex_state = 0},
  [6908] = {.lex_state = 113},
  [6909] = {.lex_state = 113},
  [6910] = {.lex_state = 113},
  [6911] = {.lex_state = 113},
  [6912] = {.lex_state = 0},
  [6913] = {.lex_state = 113},
  [6914] = {.lex_state = 113},
  [6915] = {.lex_state = 0},
  [6916] = {.lex_state = 0},
  [6917] = {.lex_state = 0},
  [6918] = {.lex_state = 113},
  [6919] = {.lex_state = 113},
  [6920] = {.lex_state = 0},
  [6921] = {.lex_state = 0},
  [6922] = {.lex_state = 0},
  [6923] = {.lex_state = 0},
  [6924] = {.lex_state = 0},
  [6925] = {.lex_state = 0},
  [6926] = {.lex_state = 0},
  [6927] = {.lex_state = 0},
  [6928] = {.lex_state = 0},
  [6929] = {.lex_state = 0},
  [6930] = {.lex_state = 0},
  [6931] = {.lex_state = 0},
  [6932] = {.lex_state = 0},
  [6933] = {.lex_state = 0},
  [6934] = {.lex_state = 0},
  [6935] = {.lex_state = 0},
  [6936] = {.lex_state = 0},
  [6937] = {.lex_state = 0},
  [6938] = {.lex_state = 0},
  [6939] = {.lex_state = 0},
  [6940] = {.lex_state = 0},
  [6941] = {.lex_state = 0},
  [6942] = {.lex_state = 0},
  [6943] = {.lex_state = 0},
  [6944] = {.lex_state = 0},
  [6945] = {.lex_state = 0},
  [6946] = {.lex_state = 0},
  [6947] = {.lex_state = 0},
  [6948] = {.lex_state = 0},
  [6949] = {.lex_state = 0},
  [6950] = {.lex_state = 0},
  [6951] = {.lex_state = 0},
  [6952] = {.lex_state = 0},
  [6953] = {.lex_state = 0},
  [6954] = {.lex_state = 0},
  [6955] = {.lex_state = 0},
  [6956] = {.lex_state = 0},
  [6957] = {.lex_state = 0},
  [6958] = {.lex_state = 0},
  [6959] = {.lex_state = 0},
  [6960] = {.lex_state = 0},
  [6961] = {.lex_state = 0},
  [6962] = {.lex_state = 0},
  [6963] = {.lex_state = 0},
  [6964] = {.lex_state = 0},
  [6965] = {.lex_state = 0},
  [6966] = {.lex_state = 0},
  [6967] = {.lex_state = 0},
  [6968] = {.lex_state = 0},
  [6969] = {.lex_state = 0},
  [6970] = {.lex_state = 0},
  [6971] = {.lex_state = 0},
  [6972] = {.lex_state = 0},
  [6973] = {.lex_state = 0},
  [6974] = {.lex_state = 0},
  [6975] = {.lex_state = 0},
  [6976] = {.lex_state = 0},
  [6977] = {.lex_state = 0},
  [6978] = {.lex_state = 0},
  [6979] = {.lex_state = 0},
  [6980] = {.lex_state = 0},
  [6981] = {.lex_state = 0},
  [6982] = {.lex_state = 0},
  [6983] = {.lex_state = 0},
  [6984] = {.lex_state = 0},
  [6985] = {.lex_state = 0},
  [6986] = {.lex_state = 0},
  [6987] = {.lex_state = 0},
  [6988] = {.lex_state = 0},
  [6989] = {.lex_state = 0},
  [6990] = {.lex_state = 0},
  [6991] = {.lex_state = 0},
  [6992] = {.lex_state = 0},
  [6993] = {.lex_state = 0},
  [6994] = {.lex_state = 0},
  [6995] = {.lex_state = 0},
  [6996] = {.lex_state = 0},
  [6997] = {.lex_state = 0},
  [6998] = {.lex_state = 0},
  [6999] = {.lex_state = 0},
  [7000] = {.lex_state = 0},
  [7001] = {.lex_state = 0},
  [7002] = {.lex_state = 0},
  [7003] = {.lex_state = 0},
  [7004] = {.lex_state = 0},
  [7005] = {.lex_state = 0},
  [7006] = {.lex_state = 0},
  [7007] = {.lex_state = 0},
  [7008] = {.lex_state = 0},
  [7009] = {.lex_state = 0},
  [7010] = {.lex_state = 0},
  [7011] = {.lex_state = 0},
  [7012] = {.lex_state = 0},
  [7013] = {.lex_state = 0},
  [7014] = {.lex_state = 0},
  [7015] = {.lex_state = 0},
  [7016] = {.lex_state = 0},
  [7017] = {.lex_state = 0},
  [7018] = {.lex_state = 0},
  [7019] = {.lex_state = 0},
  [7020] = {.lex_state = 0},
  [7021] = {.lex_state = 0},
  [7022] = {.lex_state = 0},
  [7023] = {.lex_state = 0},
  [7024] = {.lex_state = 0},
  [7025] = {.lex_state = 0},
  [7026] = {.lex_state = 0},
  [7027] = {.lex_state = 0},
  [7028] = {.lex_state = 0},
  [7029] = {.lex_state = 0},
  [7030] = {.lex_state = 0},
  [7031] = {.lex_state = 0},
  [7032] = {.lex_state = 0},
  [7033] = {.lex_state = 0},
  [7034] = {.lex_state = 0},
  [7035] = {.lex_state = 0},
  [7036] = {.lex_state = 0},
  [7037] = {.lex_state = 0},
  [7038] = {.lex_state = 0},
  [7039] = {.lex_state = 0},
  [7040] = {.lex_state = 0},
  [7041] = {.lex_state = 0},
  [7042] = {.lex_state = 0},
  [7043] = {.lex_state = 0},
  [7044] = {.lex_state = 0},
  [7045] = {.lex_state = 0},
  [7046] = {.lex_state = 0},
  [7047] = {.lex_state = 0},
  [7048] = {.lex_state = 0},
  [7049] = {.lex_state = 0},
  [7050] = {.lex_state = 0},
  [7051] = {.lex_state = 0},
  [7052] = {.lex_state = 0},
  [7053] = {.lex_state = 0},
  [7054] = {.lex_state = 0},
  [7055] = {.lex_state = 0},
  [7056] = {.lex_state = 0},
  [7057] = {.lex_state = 0},
  [7058] = {.lex_state = 0},
  [7059] = {.lex_state = 0},
  [7060] = {.lex_state = 0},
  [7061] = {.lex_state = 0},
  [7062] = {.lex_state = 0},
  [7063] = {.lex_state = 0},
  [7064] = {.lex_state = 0},
  [7065] = {.lex_state = 0},
  [7066] = {.lex_state = 0},
  [7067] = {.lex_state = 0},
  [7068] = {.lex_state = 0},
  [7069] = {.lex_state = 0},
  [7070] = {.lex_state = 0},
  [7071] = {.lex_state = 0},
  [7072] = {.lex_state = 0},
  [7073] = {.lex_state = 0},
  [7074] = {.lex_state = 0},
  [7075] = {.lex_state = 0},
  [7076] = {.lex_state = 0},
  [7077] = {.lex_state = 0},
  [7078] = {.lex_state = 0},
  [7079] = {.lex_state = 0},
  [7080] = {.lex_state = 0},
  [7081] = {.lex_state = 0},
  [7082] = {.lex_state = 0},
  [7083] = {.lex_state = 0},
  [7084] = {.lex_state = 0},
  [7085] = {.lex_state = 0},
  [7086] = {.lex_state = 0},
  [7087] = {.lex_state = 0},
  [7088] = {.lex_state = 0},
  [7089] = {.lex_state = 0},
  [7090] = {.lex_state = 0},
  [7091] = {.lex_state = 0},
  [7092] = {.lex_state = 0},
  [7093] = {.lex_state = 0},
  [7094] = {.lex_state = 0},
  [7095] = {.lex_state = 0},
  [7096] = {.lex_state = 0},
  [7097] = {.lex_state = 0},
  [7098] = {.lex_state = 0},
  [7099] = {.lex_state = 0},
  [7100] = {.lex_state = 0},
  [7101] = {.lex_state = 0},
  [7102] = {.lex_state = 0},
  [7103] = {.lex_state = 0},
  [7104] = {.lex_state = 0},
  [7105] = {.lex_state = 0},
  [7106] = {.lex_state = 0},
  [7107] = {.lex_state = 0},
  [7108] = {.lex_state = 0},
  [7109] = {.lex_state = 0},
  [7110] = {.lex_state = 0},
  [7111] = {.lex_state = 0},
  [7112] = {.lex_state = 0},
  [7113] = {.lex_state = 0},
  [7114] = {.lex_state = 0},
  [7115] = {.lex_state = 0},
  [7116] = {.lex_state = 0},
  [7117] = {.lex_state = 0},
  [7118] = {.lex_state = 0},
  [7119] = {.lex_state = 0},
  [7120] = {.lex_state = 0},
  [7121] = {.lex_state = 0},
  [7122] = {.lex_state = 0},
  [7123] = {.lex_state = 0},
  [7124] = {.lex_state = 0},
  [7125] = {.lex_state = 0},
  [7126] = {.lex_state = 0},
  [7127] = {.lex_state = 0},
  [7128] = {.lex_state = 0},
  [7129] = {.lex_state = 0},
  [7130] = {.lex_state = 0},
  [7131] = {.lex_state = 0},
  [7132] = {.lex_state = 0},
  [7133] = {.lex_state = 0},
  [7134] = {.lex_state = 0},
  [7135] = {.lex_state = 0},
  [7136] = {.lex_state = 0},
  [7137] = {.lex_state = 0},
  [7138] = {.lex_state = 0},
  [7139] = {.lex_state = 0},
  [7140] = {.lex_state = 0},
  [7141] = {.lex_state = 0},
  [7142] = {.lex_state = 0},
  [7143] = {.lex_state = 0},
  [7144] = {.lex_state = 0},
  [7145] = {.lex_state = 0},
  [7146] = {.lex_state = 0},
  [7147] = {.lex_state = 0},
  [7148] = {.lex_state = 0},
  [7149] = {.lex_state = 0},
  [7150] = {.lex_state = 0},
  [7151] = {.lex_state = 0},
  [7152] = {.lex_state = 0},
  [7153] = {.lex_state = 0},
  [7154] = {.lex_state = 0},
  [7155] = {.lex_state = 0},
  [7156] = {.lex_state = 0},
  [7157] = {.lex_state = 0},
  [7158] = {.lex_state = 0},
  [7159] = {.lex_state = 0},
  [7160] = {.lex_state = 0},
  [7161] = {.lex_state = 0},
  [7162] = {.lex_state = 0},
  [7163] = {.lex_state = 0},
  [7164] = {.lex_state = 0},
  [7165] = {.lex_state = 0},
  [7166] = {.lex_state = 0},
  [7167] = {.lex_state = 0},
  [7168] = {.lex_state = 113},
  [7169] = {.lex_state = 0},
  [7170] = {.lex_state = 0},
  [7171] = {.lex_state = 0},
  [7172] = {.lex_state = 0},
  [7173] = {.lex_state = 0},
  [7174] = {.lex_state = 0},
  [7175] = {.lex_state = 0},
  [7176] = {.lex_state = 0},
  [7177] = {.lex_state = 0},
  [7178] = {.lex_state = 113},
  [7179] = {.lex_state = 0},
  [7180] = {.lex_state = 0},
  [7181] = {.lex_state = 0},
  [7182] = {.lex_state = 0},
  [7183] = {.lex_state = 0},
  [7184] = {.lex_state = 0},
  [7185] = {.lex_state = 0},
  [7186] = {.lex_state = 0},
  [7187] = {.lex_state = 0},
  [7188] = {.lex_state = 0},
  [7189] = {.lex_state = 0},
  [7190] = {.lex_state = 0},
  [7191] = {.lex_state = 0},
  [7192] = {.lex_state = 0},
  [7193] = {.lex_state = 0},
  [7194] = {.lex_state = 0},
  [7195] = {.lex_state = 0},
  [7196] = {.lex_state = 113},
  [7197] = {.lex_state = 0},
  [7198] = {.lex_state = 1},
  [7199] = {.lex_state = 0},
  [7200] = {.lex_state = 0},
  [7201] = {.lex_state = 0},
  [7202] = {.lex_state = 113},
  [7203] = {.lex_state = 0},
  [7204] = {.lex_state = 0},
  [7205] = {.lex_state = 0},
  [7206] = {.lex_state = 0},
  [7207] = {.lex_state = 0},
  [7208] = {.lex_state = 0},
  [7209] = {.lex_state = 0},
  [7210] = {.lex_state = 0},
  [7211] = {.lex_state = 0},
  [7212] = {.lex_state = 0},
  [7213] = {.lex_state = 0},
  [7214] = {.lex_state = 0},
  [7215] = {.lex_state = 0},
  [7216] = {.lex_state = 0},
  [7217] = {.lex_state = 0},
  [7218] = {.lex_state = 0},
  [7219] = {.lex_state = 0},
  [7220] = {.lex_state = 0},
  [7221] = {.lex_state = 0},
  [7222] = {.lex_state = 0},
  [7223] = {.lex_state = 0},
  [7224] = {.lex_state = 0},
  [7225] = {.lex_state = 0},
  [7226] = {.lex_state = 0},
  [7227] = {.lex_state = 0},
  [7228] = {.lex_state = 0},
  [7229] = {.lex_state = 0},
  [7230] = {.lex_state = 0},
  [7231] = {.lex_state = 0},
  [7232] = {.lex_state = 0},
  [7233] = {.lex_state = 0},
  [7234] = {.lex_state = 0},
  [7235] = {.lex_state = 0},
  [7236] = {.lex_state = 0},
  [7237] = {.lex_state = 0},
  [7238] = {.lex_state = 0},
  [7239] = {.lex_state = 0},
  [7240] = {.lex_state = 0},
  [7241] = {.lex_state = 0},
  [7242] = {.lex_state = 0},
  [7243] = {.lex_state = 0},
  [7244] = {.lex_state = 0},
  [7245] = {.lex_state = 0},
  [7246] = {.lex_state = 0},
  [7247] = {.lex_state = 0},
  [7248] = {.lex_state = 0},
  [7249] = {.lex_state = 0},
  [7250] = {.lex_state = 0},
  [7251] = {.lex_state = 0},
  [7252] = {.lex_state = 0},
  [7253] = {.lex_state = 0},
  [7254] = {.lex_state = 0},
  [7255] = {.lex_state = 0},
  [7256] = {.lex_state = 0},
  [7257] = {.lex_state = 0},
  [7258] = {.lex_state = 4},
  [7259] = {.lex_state = 0},
  [7260] = {.lex_state = 0},
  [7261] = {.lex_state = 0},
  [7262] = {.lex_state = 0},
  [7263] = {.lex_state = 0},
  [7264] = {.lex_state = 0},
  [7265] = {.lex_state = 0},
  [7266] = {.lex_state = 0},
  [7267] = {.lex_state = 0},
  [7268] = {.lex_state = 0},
  [7269] = {.lex_state = 0},
  [7270] = {.lex_state = 0},
  [7271] = {.lex_state = 0},
  [7272] = {.lex_state = 0},
  [7273] = {.lex_state = 0},
  [7274] = {.lex_state = 0},
  [7275] = {.lex_state = 0},
  [7276] = {.lex_state = 0},
  [7277] = {.lex_state = 0},
  [7278] = {.lex_state = 0},
  [7279] = {.lex_state = 0},
  [7280] = {.lex_state = 0},
  [7281] = {.lex_state = 0},
  [7282] = {.lex_state = 0},
  [7283] = {.lex_state = 0},
  [7284] = {.lex_state = 0},
  [7285] = {.lex_state = 0},
  [7286] = {.lex_state = 0},
  [7287] = {.lex_state = 0},
  [7288] = {.lex_state = 0},
  [7289] = {.lex_state = 0},
  [7290] = {.lex_state = 0},
  [7291] = {.lex_state = 0},
  [7292] = {.lex_state = 0},
  [7293] = {.lex_state = 0},
  [7294] = {.lex_state = 0},
  [7295] = {.lex_state = 0},
  [7296] = {.lex_state = 0},
  [7297] = {.lex_state = 0},
  [7298] = {.lex_state = 0},
  [7299] = {.lex_state = 0},
  [7300] = {.lex_state = 0},
  [7301] = {.lex_state = 0},
  [7302] = {.lex_state = 0},
  [7303] = {.lex_state = 0},
  [7304] = {.lex_state = 0},
  [7305] = {.lex_state = 0},
  [7306] = {.lex_state = 0},
  [7307] = {.lex_state = 0},
  [7308] = {.lex_state = 0},
  [7309] = {.lex_state = 0},
  [7310] = {.lex_state = 0},
  [7311] = {.lex_state = 0},
  [7312] = {.lex_state = 0},
  [7313] = {.lex_state = 0},
  [7314] = {.lex_state = 0},
  [7315] = {.lex_state = 0},
  [7316] = {.lex_state = 0},
  [7317] = {.lex_state = 0},
  [7318] = {.lex_state = 0},
  [7319] = {.lex_state = 0},
  [7320] = {.lex_state = 0},
  [7321] = {.lex_state = 0},
  [7322] = {.lex_state = 0},
  [7323] = {.lex_state = 0},
  [7324] = {.lex_state = 0},
  [7325] = {.lex_state = 0},
  [7326] = {.lex_state = 0},
  [7327] = {.lex_state = 0},
  [7328] = {.lex_state = 0},
  [7329] = {.lex_state = 0},
  [7330] = {.lex_state = 0},
  [7331] = {.lex_state = 0},
  [7332] = {.lex_state = 0},
  [7333] = {.lex_state = 0},
  [7334] = {.lex_state = 0},
  [7335] = {.lex_state = 0},
  [7336] = {.lex_state = 0},
  [7337] = {.lex_state = 0},
  [7338] = {.lex_state = 0},
  [7339] = {.lex_state = 0},
  [7340] = {.lex_state = 0},
  [7341] = {.lex_state = 0},
  [7342] = {.lex_state = 0},
  [7343] = {.lex_state = 0},
  [7344] = {.lex_state = 0},
  [7345] = {.lex_state = 0},
  [7346] = {.lex_state = 0},
  [7347] = {.lex_state = 0},
  [7348] = {.lex_state = 0},
  [7349] = {.lex_state = 0},
  [7350] = {.lex_state = 0},
  [7351] = {.lex_state = 0},
  [7352] = {.lex_state = 0},
  [7353] = {.lex_state = 0},
  [7354] = {.lex_state = 0},
  [7355] = {.lex_state = 0},
  [7356] = {.lex_state = 0},
  [7357] = {.lex_state = 0},
  [7358] = {.lex_state = 0},
  [7359] = {.lex_state = 0},
  [7360] = {.lex_state = 0},
  [7361] = {.lex_state = 0},
  [7362] = {.lex_state = 0},
  [7363] = {.lex_state = 0},
  [7364] = {.lex_state = 7},
  [7365] = {.lex_state = 7},
  [7366] = {.lex_state = 7},
  [7367] = {.lex_state = 7},
  [7368] = {.lex_state = 7},
  [7369] = {.lex_state = 7},
  [7370] = {.lex_state = 7},
  [7371] = {.lex_state = 7},
  [7372] = {.lex_state = 7},
  [7373] = {.lex_state = 7},
  [7374] = {.lex_state = 7},
  [7375] = {.lex_state = 0},
  [7376] = {.lex_state = 7},
  [7377] = {.lex_state = 0},
  [7378] = {.lex_state = 0},
  [7379] = {.lex_state = 0},
  [7380] = {.lex_state = 0},
  [7381] = {.lex_state = 0},
  [7382] = {.lex_state = 0},
  [7383] = {.lex_state = 0},
  [7384] = {.lex_state = 0},
  [7385] = {.lex_state = 0},
  [7386] = {.lex_state = 0},
  [7387] = {.lex_state = 0},
  [7388] = {.lex_state = 0},
  [7389] = {.lex_state = 0},
  [7390] = {.lex_state = 0},
  [7391] = {.lex_state = 0},
  [7392] = {.lex_state = 0},
  [7393] = {.lex_state = 0},
  [7394] = {.lex_state = 0},
  [7395] = {.lex_state = 0},
  [7396] = {.lex_state = 0},
  [7397] = {.lex_state = 0},
  [7398] = {.lex_state = 0},
  [7399] = {.lex_state = 0},
  [7400] = {.lex_state = 0},
  [7401] = {.lex_state = 0},
  [7402] = {.lex_state = 0},
  [7403] = {.lex_state = 0},
  [7404] = {.lex_state = 0},
  [7405] = {.lex_state = 0},
  [7406] = {.lex_state = 0},
  [7407] = {.lex_state = 0},
  [7408] = {.lex_state = 0},
  [7409] = {.lex_state = 0},
  [7410] = {.lex_state = 0},
  [7411] = {.lex_state = 0},
  [7412] = {.lex_state = 0},
  [7413] = {.lex_state = 0},
  [7414] = {.lex_state = 0},
  [7415] = {.lex_state = 0},
  [7416] = {.lex_state = 0},
  [7417] = {.lex_state = 0},
  [7418] = {.lex_state = 0},
  [7419] = {.lex_state = 0},
  [7420] = {.lex_state = 0},
  [7421] = {.lex_state = 0},
  [7422] = {.lex_state = 0},
  [7423] = {.lex_state = 0},
  [7424] = {.lex_state = 0},
  [7425] = {.lex_state = 0},
  [7426] = {.lex_state = 0},
  [7427] = {.lex_state = 0},
  [7428] = {.lex_state = 0},
  [7429] = {.lex_state = 0},
  [7430] = {.lex_state = 0},
  [7431] = {.lex_state = 0},
  [7432] = {.lex_state = 0},
  [7433] = {.lex_state = 0},
  [7434] = {.lex_state = 0},
  [7435] = {.lex_state = 0},
  [7436] = {.lex_state = 0},
  [7437] = {.lex_state = 0},
  [7438] = {.lex_state = 0},
  [7439] = {.lex_state = 0},
  [7440] = {.lex_state = 0},
  [7441] = {.lex_state = 0},
  [7442] = {.lex_state = 0},
  [7443] = {.lex_state = 0},
  [7444] = {.lex_state = 0},
  [7445] = {.lex_state = 0},
  [7446] = {.lex_state = 0},
  [7447] = {.lex_state = 0},
  [7448] = {.lex_state = 0},
  [7449] = {.lex_state = 0},
  [7450] = {.lex_state = 0},
  [7451] = {.lex_state = 0},
  [7452] = {.lex_state = 0},
  [7453] = {.lex_state = 0},
  [7454] = {.lex_state = 0},
  [7455] = {.lex_state = 0},
  [7456] = {.lex_state = 0},
  [7457] = {.lex_state = 0},
  [7458] = {.lex_state = 0},
  [7459] = {.lex_state = 0},
  [7460] = {.lex_state = 0},
  [7461] = {.lex_state = 0},
  [7462] = {.lex_state = 0},
  [7463] = {.lex_state = 0},
  [7464] = {.lex_state = 0},
  [7465] = {.lex_state = 0},
  [7466] = {.lex_state = 0},
  [7467] = {.lex_state = 0},
  [7468] = {.lex_state = 0},
  [7469] = {.lex_state = 0},
  [7470] = {.lex_state = 0},
  [7471] = {.lex_state = 0},
  [7472] = {.lex_state = 0},
  [7473] = {.lex_state = 0},
  [7474] = {.lex_state = 0},
  [7475] = {.lex_state = 0},
  [7476] = {.lex_state = 0},
  [7477] = {.lex_state = 112},
  [7478] = {.lex_state = 112},
  [7479] = {.lex_state = 112},
  [7480] = {.lex_state = 112},
  [7481] = {.lex_state = 112},
  [7482] = {.lex_state = 112},
  [7483] = {.lex_state = 112},
  [7484] = {.lex_state = 112},
  [7485] = {.lex_state = 112},
  [7486] = {.lex_state = 112},
  [7487] = {.lex_state = 112},
  [7488] = {.lex_state = 112},
  [7489] = {.lex_state = 112},
  [7490] = {.lex_state = 113},
  [7491] = {.lex_state = 112},
  [7492] = {.lex_state = 112},
  [7493] = {.lex_state = 0},
  [7494] = {.lex_state = 0},
  [7495] = {.lex_state = 112},
  [7496] = {.lex_state = 112},
  [7497] = {.lex_state = 112},
  [7498] = {.lex_state = 112},
  [7499] = {.lex_state = 112},
  [7500] = {.lex_state = 112},
  [7501] = {.lex_state = 112},
  [7502] = {.lex_state = 112},
  [7503] = {.lex_state = 112},
  [7504] = {.lex_state = 112},
  [7505] = {.lex_state = 112},
  [7506] = {.lex_state = 112},
  [7507] = {.lex_state = 112},
  [7508] = {.lex_state = 112},
  [7509] = {.lex_state = 112},
  [7510] = {.lex_state = 112},
  [7511] = {.lex_state = 112},
  [7512] = {.lex_state = 0},
  [7513] = {.lex_state = 112},
  [7514] = {.lex_state = 112},
  [7515] = {.lex_state = 0},
  [7516] = {.lex_state = 0},
  [7517] = {.lex_state = 112},
  [7518] = {.lex_state = 112},
  [7519] = {.lex_state = 112},
  [7520] = {.lex_state = 112},
  [7521] = {.lex_state = 0},
  [7522] = {.lex_state = 112},
  [7523] = {.lex_state = 112},
  [7524] = {.lex_state = 112},
  [7525] = {.lex_state = 112},
  [7526] = {.lex_state = 112},
  [7527] = {.lex_state = 0},
  [7528] = {.lex_state = 112},
  [7529] = {.lex_state = 112},
  [7530] = {.lex_state = 0},
  [7531] = {.lex_state = 0},
  [7532] = {.lex_state = 112},
  [7533] = {.lex_state = 112},
  [7534] = {.lex_state = 112},
  [7535] = {.lex_state = 0},
  [7536] = {.lex_state = 112},
  [7537] = {.lex_state = 0},
  [7538] = {.lex_state = 112},
  [7539] = {.lex_state = 0},
  [7540] = {.lex_state = 112},
  [7541] = {.lex_state = 112},
  [7542] = {.lex_state = 112},
  [7543] = {.lex_state = 0},
  [7544] = {.lex_state = 0},
  [7545] = {.lex_state = 112},
  [7546] = {.lex_state = 0},
  [7547] = {.lex_state = 0},
  [7548] = {.lex_state = 112},
  [7549] = {.lex_state = 0},
  [7550] = {.lex_state = 0},
  [7551] = {.lex_state = 0},
  [7552] = {.lex_state = 0},
  [7553] = {.lex_state = 0},
  [7554] = {.lex_state = 0},
  [7555] = {.lex_state = 0},
  [7556] = {.lex_state = 0},
  [7557] = {.lex_state = 0},
  [7558] = {.lex_state = 112},
  [7559] = {.lex_state = 0},
  [7560] = {.lex_state = 112},
  [7561] = {.lex_state = 0},
  [7562] = {.lex_state = 0},
  [7563] = {.lex_state = 112},
  [7564] = {.lex_state = 112},
  [7565] = {.lex_state = 0},
  [7566] = {.lex_state = 112},
  [7567] = {.lex_state = 0},
  [7568] = {.lex_state = 0},
  [7569] = {.lex_state = 9},
  [7570] = {.lex_state = 0},
  [7571] = {.lex_state = 0},
  [7572] = {.lex_state = 0},
  [7573] = {.lex_state = 0},
  [7574] = {.lex_state = 0},
  [7575] = {.lex_state = 0},
  [7576] = {.lex_state = 0},
  [7577] = {.lex_state = 0},
  [7578] = {.lex_state = 0},
  [7579] = {.lex_state = 0},
  [7580] = {.lex_state = 0},
  [7581] = {.lex_state = 0},
  [7582] = {.lex_state = 0},
  [7583] = {.lex_state = 0},
  [7584] = {.lex_state = 0},
  [7585] = {.lex_state = 112},
  [7586] = {.lex_state = 0},
  [7587] = {.lex_state = 112},
  [7588] = {.lex_state = 0},
  [7589] = {.lex_state = 0},
  [7590] = {.lex_state = 112},
  [7591] = {.lex_state = 112},
  [7592] = {.lex_state = 0},
  [7593] = {.lex_state = 112},
  [7594] = {.lex_state = 112},
  [7595] = {.lex_state = 0},
  [7596] = {.lex_state = 0},
  [7597] = {.lex_state = 0},
  [7598] = {.lex_state = 0},
  [7599] = {.lex_state = 112},
  [7600] = {.lex_state = 112},
  [7601] = {.lex_state = 112},
  [7602] = {.lex_state = 0},
  [7603] = {.lex_state = 0},
  [7604] = {.lex_state = 0},
  [7605] = {.lex_state = 0},
  [7606] = {.lex_state = 0},
  [7607] = {.lex_state = 0},
  [7608] = {.lex_state = 0},
  [7609] = {.lex_state = 0},
  [7610] = {.lex_state = 0},
  [7611] = {.lex_state = 0},
  [7612] = {.lex_state = 0},
  [7613] = {.lex_state = 0},
  [7614] = {.lex_state = 112},
  [7615] = {.lex_state = 0},
  [7616] = {.lex_state = 112},
  [7617] = {.lex_state = 112},
  [7618] = {.lex_state = 0},
  [7619] = {.lex_state = 0},
  [7620] = {.lex_state = 0},
  [7621] = {.lex_state = 112},
  [7622] = {.lex_state = 0},
  [7623] = {.lex_state = 112},
  [7624] = {.lex_state = 0},
  [7625] = {.lex_state = 0},
  [7626] = {.lex_state = 0},
  [7627] = {.lex_state = 0},
  [7628] = {.lex_state = 0},
  [7629] = {.lex_state = 0},
  [7630] = {.lex_state = 0},
  [7631] = {.lex_state = 0},
  [7632] = {.lex_state = 0},
  [7633] = {.lex_state = 0},
  [7634] = {.lex_state = 0},
  [7635] = {.lex_state = 0},
  [7636] = {.lex_state = 0},
  [7637] = {.lex_state = 0},
  [7638] = {.lex_state = 112},
  [7639] = {.lex_state = 0},
  [7640] = {.lex_state = 0},
  [7641] = {.lex_state = 112},
  [7642] = {.lex_state = 112},
  [7643] = {.lex_state = 0},
  [7644] = {.lex_state = 112},
  [7645] = {.lex_state = 112},
  [7646] = {.lex_state = 112},
  [7647] = {.lex_state = 112},
  [7648] = {.lex_state = 112},
  [7649] = {.lex_state = 112},
  [7650] = {.lex_state = 0},
  [7651] = {.lex_state = 112},
  [7652] = {.lex_state = 112},
  [7653] = {.lex_state = 112},
  [7654] = {.lex_state = 0},
  [7655] = {.lex_state = 112},
  [7656] = {.lex_state = 112},
  [7657] = {.lex_state = 112},
  [7658] = {.lex_state = 112},
  [7659] = {.lex_state = 0},
  [7660] = {.lex_state = 112},
  [7661] = {.lex_state = 112},
  [7662] = {.lex_state = 112},
  [7663] = {.lex_state = 112},
  [7664] = {.lex_state = 112},
  [7665] = {.lex_state = 112},
  [7666] = {.lex_state = 112},
  [7667] = {.lex_state = 112},
  [7668] = {.lex_state = 0},
  [7669] = {.lex_state = 112},
  [7670] = {.lex_state = 0},
  [7671] = {.lex_state = 112},
  [7672] = {.lex_state = 112},
  [7673] = {.lex_state = 112},
  [7674] = {.lex_state = 112},
  [7675] = {.lex_state = 112},
  [7676] = {.lex_state = 4, .external_lex_state = 5},
  [7677] = {.lex_state = 112},
  [7678] = {.lex_state = 112},
  [7679] = {.lex_state = 112},
  [7680] = {.lex_state = 112},
  [7681] = {.lex_state = 112},
  [7682] = {.lex_state = 112},
  [7683] = {.lex_state = 4, .external_lex_state = 5},
  [7684] = {.lex_state = 112},
  [7685] = {.lex_state = 0},
  [7686] = {.lex_state = 112},
  [7687] = {.lex_state = 112},
  [7688] = {.lex_state = 4, .external_lex_state = 5},
  [7689] = {.lex_state = 4, .external_lex_state = 5},
  [7690] = {.lex_state = 112},
  [7691] = {.lex_state = 112},
  [7692] = {.lex_state = 112},
  [7693] = {.lex_state = 112},
  [7694] = {.lex_state = 112},
  [7695] = {.lex_state = 112},
  [7696] = {.lex_state = 112},
  [7697] = {.lex_state = 112},
  [7698] = {.lex_state = 112},
  [7699] = {.lex_state = 112},
  [7700] = {.lex_state = 112},
  [7701] = {.lex_state = 0},
  [7702] = {.lex_state = 112},
  [7703] = {.lex_state = 4, .external_lex_state = 5},
  [7704] = {.lex_state = 112},
  [7705] = {.lex_state = 112},
  [7706] = {.lex_state = 112},
  [7707] = {.lex_state = 112},
  [7708] = {.lex_state = 112},
  [7709] = {.lex_state = 0},
  [7710] = {.lex_state = 112},
  [7711] = {.lex_state = 112},
  [7712] = {.lex_state = 4, .external_lex_state = 5},
  [7713] = {.lex_state = 4, .external_lex_state = 5},
  [7714] = {.lex_state = 4, .external_lex_state = 5},
  [7715] = {.lex_state = 112},
  [7716] = {.lex_state = 112},
  [7717] = {.lex_state = 4, .external_lex_state = 5},
  [7718] = {.lex_state = 112},
  [7719] = {.lex_state = 0},
  [7720] = {.lex_state = 112},
  [7721] = {.lex_state = 112},
  [7722] = {.lex_state = 112},
  [7723] = {.lex_state = 112},
  [7724] = {.lex_state = 112},
  [7725] = {.lex_state = 4, .external_lex_state = 5},
  [7726] = {.lex_state = 112},
  [7727] = {.lex_state = 112},
  [7728] = {.lex_state = 112},
  [7729] = {.lex_state = 112},
  [7730] = {.lex_state = 112},
  [7731] = {.lex_state = 112},
  [7732] = {.lex_state = 112},
  [7733] = {.lex_state = 112},
  [7734] = {.lex_state = 112},
  [7735] = {.lex_state = 0},
  [7736] = {.lex_state = 112},
  [7737] = {.lex_state = 112},
  [7738] = {.lex_state = 4, .external_lex_state = 5},
  [7739] = {.lex_state = 112},
  [7740] = {.lex_state = 0},
  [7741] = {.lex_state = 112},
  [7742] = {.lex_state = 0},
  [7743] = {.lex_state = 0},
  [7744] = {.lex_state = 0},
  [7745] = {.lex_state = 0},
  [7746] = {.lex_state = 0},
  [7747] = {.lex_state = 0},
  [7748] = {.lex_state = 0},
  [7749] = {.lex_state = 0},
  [7750] = {.lex_state = 0},
  [7751] = {.lex_state = 0},
  [7752] = {.lex_state = 0},
  [7753] = {.lex_state = 0},
  [7754] = {.lex_state = 0},
  [7755] = {.lex_state = 0},
  [7756] = {.lex_state = 0},
  [7757] = {.lex_state = 0},
  [7758] = {.lex_state = 0, .external_lex_state = 6},
  [7759] = {.lex_state = 9},
  [7760] = {.lex_state = 0},
  [7761] = {.lex_state = 0},
  [7762] = {.lex_state = 9},
  [7763] = {.lex_state = 0},
  [7764] = {.lex_state = 0},
  [7765] = {.lex_state = 0},
  [7766] = {.lex_state = 0},
  [7767] = {.lex_state = 0},
  [7768] = {.lex_state = 4, .external_lex_state = 5},
  [7769] = {.lex_state = 0},
  [7770] = {.lex_state = 0},
  [7771] = {.lex_state = 0},
  [7772] = {.lex_state = 2},
  [7773] = {.lex_state = 0},
  [7774] = {.lex_state = 0},
  [7775] = {.lex_state = 0},
  [7776] = {.lex_state = 0},
  [7777] = {.lex_state = 0},
  [7778] = {.lex_state = 0},
  [7779] = {.lex_state = 0},
  [7780] = {.lex_state = 0},
  [7781] = {.lex_state = 0},
  [7782] = {.lex_state = 0},
  [7783] = {.lex_state = 0},
  [7784] = {.lex_state = 2},
  [7785] = {.lex_state = 0, .external_lex_state = 6},
  [7786] = {.lex_state = 0},
  [7787] = {.lex_state = 4, .external_lex_state = 5},
  [7788] = {.lex_state = 0},
  [7789] = {.lex_state = 0},
  [7790] = {.lex_state = 0},
  [7791] = {.lex_state = 2},
  [7792] = {.lex_state = 0, .external_lex_state = 6},
  [7793] = {.lex_state = 0},
  [7794] = {.lex_state = 113},
  [7795] = {.lex_state = 0, .external_lex_state = 6},
  [7796] = {.lex_state = 0},
  [7797] = {.lex_state = 4, .external_lex_state = 5},
  [7798] = {.lex_state = 4, .external_lex_state = 5},
  [7799] = {.lex_state = 0},
  [7800] = {.lex_state = 0, .external_lex_state = 6},
  [7801] = {.lex_state = 0},
  [7802] = {.lex_state = 0},
  [7803] = {.lex_state = 0},
  [7804] = {.lex_state = 0},
  [7805] = {.lex_state = 0},
  [7806] = {.lex_state = 2},
  [7807] = {.lex_state = 0},
  [7808] = {.lex_state = 0},
  [7809] = {.lex_state = 0},
  [7810] = {.lex_state = 0},
  [7811] = {.lex_state = 0},
  [7812] = {.lex_state = 0},
  [7813] = {.lex_state = 0},
  [7814] = {.lex_state = 0},
  [7815] = {.lex_state = 0},
  [7816] = {.lex_state = 0},
  [7817] = {.lex_state = 0},
  [7818] = {.lex_state = 0},
  [7819] = {.lex_state = 0},
  [7820] = {.lex_state = 4, .external_lex_state = 5},
  [7821] = {.lex_state = 0},
  [7822] = {.lex_state = 0},
  [7823] = {.lex_state = 0},
  [7824] = {.lex_state = 0},
  [7825] = {.lex_state = 0},
  [7826] = {.lex_state = 0},
  [7827] = {.lex_state = 0},
  [7828] = {.lex_state = 2},
  [7829] = {.lex_state = 1},
  [7830] = {.lex_state = 0},
  [7831] = {.lex_state = 0},
  [7832] = {.lex_state = 0, .external_lex_state = 6},
  [7833] = {.lex_state = 0},
  [7834] = {.lex_state = 0},
  [7835] = {.lex_state = 0},
  [7836] = {.lex_state = 2},
  [7837] = {.lex_state = 0},
  [7838] = {.lex_state = 0},
  [7839] = {.lex_state = 0},
  [7840] = {.lex_state = 1},
  [7841] = {.lex_state = 4, .external_lex_state = 5},
  [7842] = {.lex_state = 0},
  [7843] = {.lex_state = 4, .external_lex_state = 5},
  [7844] = {.lex_state = 0, .external_lex_state = 6},
  [7845] = {.lex_state = 2},
  [7846] = {.lex_state = 0},
  [7847] = {.lex_state = 0},
  [7848] = {.lex_state = 0},
  [7849] = {.lex_state = 0},
  [7850] = {.lex_state = 0},
  [7851] = {.lex_state = 0},
  [7852] = {.lex_state = 2},
  [7853] = {.lex_state = 0},
  [7854] = {.lex_state = 0},
  [7855] = {.lex_state = 0},
  [7856] = {.lex_state = 0},
  [7857] = {.lex_state = 0},
  [7858] = {.lex_state = 0},
  [7859] = {.lex_state = 2},
  [7860] = {.lex_state = 0},
  [7861] = {.lex_state = 0, .external_lex_state = 6},
  [7862] = {.lex_state = 0, .external_lex_state = 6},
  [7863] = {.lex_state = 4, .external_lex_state = 5},
  [7864] = {.lex_state = 4, .external_lex_state = 5},
  [7865] = {.lex_state = 0},
  [7866] = {.lex_state = 0},
  [7867] = {.lex_state = 0},
  [7868] = {.lex_state = 0},
  [7869] = {.lex_state = 0},
  [7870] = {.lex_state = 0},
  [7871] = {.lex_state = 0},
  [7872] = {.lex_state = 0},
  [7873] = {.lex_state = 0},
  [7874] = {.lex_state = 0},
  [7875] = {.lex_state = 0},
  [7876] = {.lex_state = 0},
  [7877] = {.lex_state = 4, .external_lex_state = 5},
  [7878] = {.lex_state = 0},
  [7879] = {.lex_state = 0},
  [7880] = {.lex_state = 0},
  [7881] = {.lex_state = 0},
  [7882] = {.lex_state = 2},
  [7883] = {.lex_state = 0},
  [7884] = {.lex_state = 0},
  [7885] = {.lex_state = 0},
  [7886] = {.lex_state = 2},
  [7887] = {.lex_state = 0},
  [7888] = {.lex_state = 0},
  [7889] = {.lex_state = 0},
  [7890] = {.lex_state = 0},
  [7891] = {.lex_state = 0},
  [7892] = {.lex_state = 2},
  [7893] = {.lex_state = 2},
  [7894] = {.lex_state = 0},
  [7895] = {.lex_state = 0},
  [7896] = {.lex_state = 0},
  [7897] = {.lex_state = 0},
  [7898] = {.lex_state = 4, .external_lex_state = 5},
  [7899] = {.lex_state = 0, .external_lex_state = 6},
  [7900] = {.lex_state = 0},
  [7901] = {.lex_state = 0},
  [7902] = {.lex_state = 0},
  [7903] = {.lex_state = 0},
  [7904] = {.lex_state = 0, .external_lex_state = 6},
  [7905] = {.lex_state = 0},
  [7906] = {.lex_state = 0},
  [7907] = {.lex_state = 0},
  [7908] = {.lex_state = 0},
  [7909] = {.lex_state = 0},
  [7910] = {.lex_state = 0},
  [7911] = {.lex_state = 0},
  [7912] = {.lex_state = 0},
  [7913] = {.lex_state = 0},
  [7914] = {.lex_state = 0},
  [7915] = {.lex_state = 0},
  [7916] = {.lex_state = 0},
  [7917] = {.lex_state = 0},
  [7918] = {.lex_state = 0},
  [7919] = {.lex_state = 0},
  [7920] = {.lex_state = 0},
  [7921] = {.lex_state = 0},
  [7922] = {.lex_state = 0},
  [7923] = {.lex_state = 0},
  [7924] = {.lex_state = 0},
  [7925] = {.lex_state = 0},
  [7926] = {.lex_state = 1},
  [7927] = {.lex_state = 0},
  [7928] = {.lex_state = 0},
  [7929] = {.lex_state = 113},
  [7930] = {.lex_state = 0},
  [7931] = {.lex_state = 0},
  [7932] = {.lex_state = 0},
  [7933] = {.lex_state = 0},
  [7934] = {.lex_state = 0},
  [7935] = {.lex_state = 0},
  [7936] = {.lex_state = 0},
  [7937] = {.lex_state = 0},
  [7938] = {.lex_state = 1},
  [7939] = {.lex_state = 0},
  [7940] = {.lex_state = 0},
  [7941] = {.lex_state = 0},
  [7942] = {.lex_state = 0},
  [7943] = {.lex_state = 0},
  [7944] = {.lex_state = 0},
  [7945] = {.lex_state = 0},
  [7946] = {.lex_state = 113},
  [7947] = {.lex_state = 0},
  [7948] = {.lex_state = 0},
  [7949] = {.lex_state = 0},
  [7950] = {.lex_state = 113},
  [7951] = {.lex_state = 0},
  [7952] = {.lex_state = 0},
  [7953] = {.lex_state = 0},
  [7954] = {.lex_state = 0},
  [7955] = {.lex_state = 0},
  [7956] = {.lex_state = 0},
  [7957] = {.lex_state = 0},
  [7958] = {.lex_state = 0},
  [7959] = {.lex_state = 1},
  [7960] = {.lex_state = 0},
  [7961] = {.lex_state = 0},
  [7962] = {.lex_state = 0},
  [7963] = {.lex_state = 112},
  [7964] = {.lex_state = 0},
  [7965] = {.lex_state = 0},
  [7966] = {.lex_state = 0},
  [7967] = {.lex_state = 0},
  [7968] = {.lex_state = 0},
  [7969] = {.lex_state = 0},
  [7970] = {.lex_state = 0},
  [7971] = {.lex_state = 0},
  [7972] = {.lex_state = 0},
  [7973] = {.lex_state = 0},
  [7974] = {.lex_state = 0},
  [7975] = {.lex_state = 0},
  [7976] = {.lex_state = 1},
  [7977] = {.lex_state = 0},
  [7978] = {.lex_state = 0},
  [7979] = {.lex_state = 0},
  [7980] = {.lex_state = 0},
  [7981] = {.lex_state = 0},
  [7982] = {.lex_state = 0},
  [7983] = {.lex_state = 113},
  [7984] = {.lex_state = 1},
  [7985] = {.lex_state = 113},
  [7986] = {.lex_state = 0},
  [7987] = {.lex_state = 0},
  [7988] = {.lex_state = 0},
  [7989] = {.lex_state = 0},
  [7990] = {.lex_state = 0},
  [7991] = {.lex_state = 0},
  [7992] = {.lex_state = 0},
  [7993] = {.lex_state = 0},
  [7994] = {.lex_state = 0},
  [7995] = {.lex_state = 0},
  [7996] = {.lex_state = 0},
  [7997] = {.lex_state = 0},
  [7998] = {.lex_state = 0},
  [7999] = {.lex_state = 112},
  [8000] = {.lex_state = 0},
  [8001] = {.lex_state = 0},
  [8002] = {.lex_state = 0},
  [8003] = {.lex_state = 0},
  [8004] = {.lex_state = 0},
  [8005] = {.lex_state = 0},
  [8006] = {.lex_state = 113},
  [8007] = {.lex_state = 0},
  [8008] = {.lex_state = 0},
  [8009] = {.lex_state = 0},
  [8010] = {.lex_state = 0},
  [8011] = {.lex_state = 0},
  [8012] = {.lex_state = 0},
  [8013] = {.lex_state = 0},
  [8014] = {.lex_state = 0},
  [8015] = {.lex_state = 0},
  [8016] = {.lex_state = 1},
  [8017] = {.lex_state = 0},
  [8018] = {.lex_state = 0},
  [8019] = {.lex_state = 0},
  [8020] = {.lex_state = 0},
  [8021] = {.lex_state = 0},
  [8022] = {.lex_state = 0},
  [8023] = {.lex_state = 0},
  [8024] = {.lex_state = 0},
  [8025] = {.lex_state = 0},
  [8026] = {.lex_state = 0},
  [8027] = {.lex_state = 113},
  [8028] = {.lex_state = 0},
  [8029] = {.lex_state = 0},
  [8030] = {.lex_state = 0},
  [8031] = {.lex_state = 0},
  [8032] = {.lex_state = 0},
  [8033] = {.lex_state = 0},
  [8034] = {.lex_state = 0},
  [8035] = {.lex_state = 0},
  [8036] = {.lex_state = 0},
  [8037] = {.lex_state = 0},
  [8038] = {.lex_state = 112},
  [8039] = {.lex_state = 0},
  [8040] = {.lex_state = 0},
  [8041] = {.lex_state = 0},
  [8042] = {.lex_state = 0},
  [8043] = {.lex_state = 112},
  [8044] = {.lex_state = 0},
  [8045] = {.lex_state = 113},
  [8046] = {.lex_state = 0},
  [8047] = {.lex_state = 1},
  [8048] = {.lex_state = 0},
  [8049] = {.lex_state = 0},
  [8050] = {.lex_state = 0},
  [8051] = {.lex_state = 0},
  [8052] = {.lex_state = 0},
  [8053] = {.lex_state = 0},
  [8054] = {.lex_state = 0},
  [8055] = {.lex_state = 0},
  [8056] = {.lex_state = 0},
  [8057] = {.lex_state = 0},
  [8058] = {.lex_state = 0},
  [8059] = {.lex_state = 0},
  [8060] = {.lex_state = 0},
  [8061] = {.lex_state = 0},
  [8062] = {.lex_state = 1},
  [8063] = {.lex_state = 0},
  [8064] = {.lex_state = 0},
  [8065] = {.lex_state = 1},
  [8066] = {.lex_state = 0},
  [8067] = {.lex_state = 0},
  [8068] = {.lex_state = 0},
  [8069] = {.lex_state = 0},
  [8070] = {.lex_state = 0},
  [8071] = {.lex_state = 112},
  [8072] = {.lex_state = 0},
  [8073] = {.lex_state = 0},
  [8074] = {.lex_state = 0},
  [8075] = {.lex_state = 0},
  [8076] = {.lex_state = 0},
  [8077] = {.lex_state = 0},
  [8078] = {.lex_state = 0},
  [8079] = {.lex_state = 0},
  [8080] = {.lex_state = 112},
  [8081] = {.lex_state = 0},
  [8082] = {.lex_state = 0},
  [8083] = {.lex_state = 112},
  [8084] = {.lex_state = 0},
  [8085] = {.lex_state = 0},
  [8086] = {.lex_state = 0},
  [8087] = {.lex_state = 0},
  [8088] = {.lex_state = 0},
  [8089] = {.lex_state = 0},
  [8090] = {.lex_state = 0},
  [8091] = {.lex_state = 0},
  [8092] = {.lex_state = 0},
  [8093] = {.lex_state = 113},
  [8094] = {.lex_state = 0},
  [8095] = {.lex_state = 0},
  [8096] = {.lex_state = 0},
  [8097] = {.lex_state = 1},
  [8098] = {.lex_state = 1},
  [8099] = {.lex_state = 0},
  [8100] = {.lex_state = 0},
  [8101] = {.lex_state = 0},
  [8102] = {.lex_state = 0},
  [8103] = {.lex_state = 1},
  [8104] = {.lex_state = 0},
  [8105] = {.lex_state = 0},
  [8106] = {.lex_state = 0},
  [8107] = {.lex_state = 0},
  [8108] = {.lex_state = 0},
  [8109] = {.lex_state = 0},
  [8110] = {.lex_state = 0},
  [8111] = {.lex_state = 0},
  [8112] = {.lex_state = 0},
  [8113] = {.lex_state = 1},
  [8114] = {.lex_state = 0},
  [8115] = {.lex_state = 0},
  [8116] = {.lex_state = 0},
  [8117] = {.lex_state = 0},
  [8118] = {.lex_state = 0},
  [8119] = {.lex_state = 0},
  [8120] = {.lex_state = 0},
  [8121] = {.lex_state = 0},
  [8122] = {.lex_state = 1},
  [8123] = {.lex_state = 0},
  [8124] = {.lex_state = 0},
  [8125] = {.lex_state = 0},
  [8126] = {.lex_state = 0},
  [8127] = {.lex_state = 0},
  [8128] = {.lex_state = 0},
  [8129] = {.lex_state = 0},
  [8130] = {.lex_state = 0},
  [8131] = {.lex_state = 0},
  [8132] = {.lex_state = 0},
  [8133] = {.lex_state = 0},
  [8134] = {.lex_state = 0},
  [8135] = {.lex_state = 0},
  [8136] = {.lex_state = 9},
  [8137] = {.lex_state = 0},
  [8138] = {.lex_state = 0},
  [8139] = {.lex_state = 0},
  [8140] = {.lex_state = 0},
  [8141] = {.lex_state = 0},
  [8142] = {.lex_state = 0},
  [8143] = {.lex_state = 1},
  [8144] = {.lex_state = 0},
  [8145] = {.lex_state = 0},
  [8146] = {.lex_state = 0},
  [8147] = {.lex_state = 0},
  [8148] = {.lex_state = 0},
  [8149] = {.lex_state = 0},
  [8150] = {.lex_state = 0},
  [8151] = {.lex_state = 0},
  [8152] = {.lex_state = 0},
  [8153] = {.lex_state = 0},
  [8154] = {.lex_state = 0},
  [8155] = {.lex_state = 0},
  [8156] = {.lex_state = 113},
  [8157] = {.lex_state = 0},
  [8158] = {.lex_state = 1},
  [8159] = {.lex_state = 0},
  [8160] = {.lex_state = 0},
  [8161] = {.lex_state = 0},
  [8162] = {.lex_state = 113},
  [8163] = {.lex_state = 1},
  [8164] = {.lex_state = 0},
  [8165] = {.lex_state = 113},
  [8166] = {.lex_state = 0},
  [8167] = {.lex_state = 0},
  [8168] = {.lex_state = 0},
  [8169] = {.lex_state = 1},
  [8170] = {.lex_state = 112},
  [8171] = {.lex_state = 113},
  [8172] = {.lex_state = 0},
  [8173] = {.lex_state = 0},
  [8174] = {.lex_state = 0},
  [8175] = {.lex_state = 0},
  [8176] = {.lex_state = 1},
  [8177] = {.lex_state = 0},
  [8178] = {.lex_state = 113},
  [8179] = {.lex_state = 0},
  [8180] = {.lex_state = 9},
  [8181] = {.lex_state = 1},
  [8182] = {.lex_state = 0},
  [8183] = {.lex_state = 0},
  [8184] = {.lex_state = 0},
  [8185] = {.lex_state = 0},
  [8186] = {.lex_state = 0},
  [8187] = {.lex_state = 0},
  [8188] = {.lex_state = 0},
  [8189] = {.lex_state = 0},
  [8190] = {.lex_state = 0},
  [8191] = {.lex_state = 1},
  [8192] = {.lex_state = 0},
  [8193] = {.lex_state = 1},
  [8194] = {.lex_state = 1},
  [8195] = {.lex_state = 1},
  [8196] = {.lex_state = 0},
  [8197] = {.lex_state = 0},
  [8198] = {.lex_state = 0},
  [8199] = {.lex_state = 0},
  [8200] = {.lex_state = 0},
  [8201] = {.lex_state = 0},
  [8202] = {.lex_state = 0},
  [8203] = {.lex_state = 0},
  [8204] = {.lex_state = 0},
  [8205] = {.lex_state = 0},
  [8206] = {.lex_state = 0},
  [8207] = {.lex_state = 0},
  [8208] = {.lex_state = 1},
  [8209] = {.lex_state = 0},
  [8210] = {.lex_state = 0},
  [8211] = {.lex_state = 0},
  [8212] = {.lex_state = 0},
  [8213] = {.lex_state = 0},
  [8214] = {.lex_state = 113},
  [8215] = {.lex_state = 9},
  [8216] = {.lex_state = 0},
  [8217] = {.lex_state = 9},
  [8218] = {.lex_state = 9},
  [8219] = {.lex_state = 0},
  [8220] = {.lex_state = 9},
  [8221] = {.lex_state = 0},
  [8222] = {.lex_state = 9},
  [8223] = {.lex_state = 0},
  [8224] = {.lex_state = 0},
  [8225] = {.lex_state = 0},
  [8226] = {.lex_state = 0},
  [8227] = {.lex_state = 0},
  [8228] = {.lex_state = 0},
  [8229] = {.lex_state = 0},
  [8230] = {.lex_state = 0},
  [8231] = {.lex_state = 112},
  [8232] = {.lex_state = 0},
  [8233] = {.lex_state = 0},
  [8234] = {.lex_state = 9},
  [8235] = {.lex_state = 0},
  [8236] = {.lex_state = 9},
  [8237] = {.lex_state = 0},
  [8238] = {.lex_state = 0},
  [8239] = {.lex_state = 0},
  [8240] = {.lex_state = 112},
  [8241] = {.lex_state = 0},
  [8242] = {.lex_state = 2},
  [8243] = {.lex_state = 2},
  [8244] = {.lex_state = 0},
  [8245] = {.lex_state = 0},
  [8246] = {.lex_state = 0},
  [8247] = {.lex_state = 112},
  [8248] = {.lex_state = 0},
  [8249] = {.lex_state = 0},
  [8250] = {.lex_state = 4, .external_lex_state = 5},
  [8251] = {.lex_state = 0},
  [8252] = {.lex_state = 0},
  [8253] = {.lex_state = 0},
  [8254] = {.lex_state = 0},
  [8255] = {.lex_state = 112},
  [8256] = {.lex_state = 0},
  [8257] = {.lex_state = 0},
  [8258] = {.lex_state = 0},
  [8259] = {.lex_state = 0},
  [8260] = {.lex_state = 0},
  [8261] = {.lex_state = 0},
  [8262] = {.lex_state = 0},
  [8263] = {.lex_state = 0},
  [8264] = {.lex_state = 0},
  [8265] = {.lex_state = 0},
  [8266] = {.lex_state = 2},
  [8267] = {.lex_state = 0},
  [8268] = {.lex_state = 0},
  [8269] = {.lex_state = 0},
  [8270] = {.lex_state = 0},
  [8271] = {.lex_state = 0},
  [8272] = {.lex_state = 0},
  [8273] = {.lex_state = 0},
  [8274] = {.lex_state = 0},
  [8275] = {.lex_state = 0},
  [8276] = {.lex_state = 0},
  [8277] = {.lex_state = 0},
  [8278] = {.lex_state = 0},
  [8279] = {.lex_state = 0},
  [8280] = {.lex_state = 9},
  [8281] = {.lex_state = 4, .external_lex_state = 5},
  [8282] = {.lex_state = 0},
  [8283] = {.lex_state = 4, .external_lex_state = 5},
  [8284] = {.lex_state = 0},
  [8285] = {.lex_state = 0},
  [8286] = {.lex_state = 0},
  [8287] = {.lex_state = 0},
  [8288] = {.lex_state = 9},
  [8289] = {.lex_state = 0},
  [8290] = {.lex_state = 0},
  [8291] = {.lex_state = 112},
  [8292] = {.lex_state = 4, .external_lex_state = 5},
  [8293] = {.lex_state = 0},
  [8294] = {.lex_state = 0},
  [8295] = {.lex_state = 0},
  [8296] = {.lex_state = 0},
  [8297] = {.lex_state = 0},
  [8298] = {.lex_state = 4, .external_lex_state = 5},
  [8299] = {.lex_state = 0},
  [8300] = {.lex_state = 0},
  [8301] = {.lex_state = 112},
  [8302] = {.lex_state = 0},
  [8303] = {.lex_state = 0},
  [8304] = {.lex_state = 0},
  [8305] = {.lex_state = 0},
  [8306] = {.lex_state = 4},
  [8307] = {.lex_state = 0},
  [8308] = {.lex_state = 0},
  [8309] = {.lex_state = 0},
  [8310] = {.lex_state = 0},
  [8311] = {.lex_state = 0},
  [8312] = {.lex_state = 0},
  [8313] = {.lex_state = 0},
  [8314] = {.lex_state = 113},
  [8315] = {.lex_state = 112},
  [8316] = {.lex_state = 0},
  [8317] = {.lex_state = 0},
  [8318] = {.lex_state = 0},
  [8319] = {.lex_state = 0},
  [8320] = {.lex_state = 0},
  [8321] = {.lex_state = 0},
  [8322] = {.lex_state = 0},
  [8323] = {.lex_state = 0},
  [8324] = {.lex_state = 0},
  [8325] = {.lex_state = 0},
  [8326] = {.lex_state = 0},
  [8327] = {.lex_state = 112},
  [8328] = {.lex_state = 0},
  [8329] = {.lex_state = 0},
  [8330] = {.lex_state = 112},
  [8331] = {.lex_state = 0},
  [8332] = {.lex_state = 0},
  [8333] = {.lex_state = 0},
  [8334] = {.lex_state = 0},
  [8335] = {.lex_state = 0},
  [8336] = {.lex_state = 0},
  [8337] = {.lex_state = 112},
  [8338] = {.lex_state = 112},
  [8339] = {.lex_state = 0},
  [8340] = {.lex_state = 0},
  [8341] = {.lex_state = 0},
  [8342] = {.lex_state = 0},
  [8343] = {.lex_state = 9},
  [8344] = {.lex_state = 0},
  [8345] = {.lex_state = 0},
  [8346] = {.lex_state = 0},
  [8347] = {.lex_state = 0},
  [8348] = {.lex_state = 0},
  [8349] = {.lex_state = 0},
  [8350] = {.lex_state = 0},
  [8351] = {.lex_state = 0},
  [8352] = {.lex_state = 0},
  [8353] = {.lex_state = 0},
  [8354] = {.lex_state = 113},
  [8355] = {.lex_state = 0},
  [8356] = {.lex_state = 0},
  [8357] = {.lex_state = 9},
  [8358] = {.lex_state = 0},
  [8359] = {.lex_state = 0},
  [8360] = {.lex_state = 0},
  [8361] = {.lex_state = 0},
  [8362] = {.lex_state = 0},
  [8363] = {.lex_state = 0},
  [8364] = {.lex_state = 0},
  [8365] = {.lex_state = 0},
  [8366] = {.lex_state = 9},
  [8367] = {.lex_state = 0},
  [8368] = {.lex_state = 0},
  [8369] = {.lex_state = 9},
  [8370] = {.lex_state = 9},
  [8371] = {.lex_state = 0},
  [8372] = {.lex_state = 0},
  [8373] = {.lex_state = 0},
  [8374] = {.lex_state = 0},
  [8375] = {.lex_state = 0},
  [8376] = {.lex_state = 1},
  [8377] = {.lex_state = 0},
  [8378] = {.lex_state = 9},
  [8379] = {.lex_state = 0},
  [8380] = {.lex_state = 1},
  [8381] = {.lex_state = 0},
  [8382] = {.lex_state = 0},
  [8383] = {.lex_state = 0},
  [8384] = {.lex_state = 0},
  [8385] = {.lex_state = 4},
  [8386] = {.lex_state = 0},
  [8387] = {.lex_state = 0},
  [8388] = {.lex_state = 0},
  [8389] = {.lex_state = 0},
  [8390] = {.lex_state = 0},
  [8391] = {.lex_state = 9},
  [8392] = {.lex_state = 9},
  [8393] = {.lex_state = 0},
  [8394] = {.lex_state = 0},
  [8395] = {.lex_state = 0},
  [8396] = {.lex_state = 9},
  [8397] = {.lex_state = 113},
  [8398] = {.lex_state = 0},
  [8399] = {.lex_state = 0},
  [8400] = {.lex_state = 0},
  [8401] = {.lex_state = 0},
  [8402] = {.lex_state = 0},
  [8403] = {.lex_state = 0},
  [8404] = {.lex_state = 0},
  [8405] = {.lex_state = 0},
  [8406] = {.lex_state = 9},
  [8407] = {.lex_state = 9},
  [8408] = {.lex_state = 0},
  [8409] = {.lex_state = 0},
  [8410] = {.lex_state = 0},
  [8411] = {.lex_state = 4, .external_lex_state = 5},
  [8412] = {.lex_state = 4, .external_lex_state = 5},
  [8413] = {.lex_state = 0},
  [8414] = {.lex_state = 9},
  [8415] = {.lex_state = 0},
  [8416] = {.lex_state = 0, .external_lex_state = 6},
  [8417] = {.lex_state = 0},
  [8418] = {.lex_state = 0, .external_lex_state = 6},
  [8419] = {.lex_state = 9},
  [8420] = {.lex_state = 0},
  [8421] = {.lex_state = 0},
  [8422] = {.lex_state = 0},
  [8423] = {.lex_state = 0},
  [8424] = {.lex_state = 0},
  [8425] = {.lex_state = 0},
  [8426] = {.lex_state = 0},
  [8427] = {.lex_state = 0},
  [8428] = {.lex_state = 0},
  [8429] = {.lex_state = 0},
  [8430] = {.lex_state = 0},
  [8431] = {.lex_state = 0},
  [8432] = {.lex_state = 0},
  [8433] = {.lex_state = 0},
  [8434] = {.lex_state = 1},
  [8435] = {.lex_state = 0},
  [8436] = {.lex_state = 0},
  [8437] = {.lex_state = 0},
  [8438] = {.lex_state = 0},
  [8439] = {.lex_state = 0},
  [8440] = {.lex_state = 0},
  [8441] = {.lex_state = 0},
  [8442] = {.lex_state = 0},
  [8443] = {.lex_state = 0},
  [8444] = {.lex_state = 0},
  [8445] = {.lex_state = 0},
  [8446] = {.lex_state = 0},
  [8447] = {.lex_state = 0},
  [8448] = {.lex_state = 9},
  [8449] = {.lex_state = 0},
  [8450] = {.lex_state = 0},
  [8451] = {.lex_state = 0},
  [8452] = {.lex_state = 0},
  [8453] = {.lex_state = 0},
  [8454] = {.lex_state = 0},
  [8455] = {.lex_state = 0},
  [8456] = {.lex_state = 112, .external_lex_state = 4},
  [8457] = {.lex_state = 0},
  [8458] = {.lex_state = 0},
  [8459] = {.lex_state = 1},
  [8460] = {.lex_state = 0},
  [8461] = {.lex_state = 9},
  [8462] = {.lex_state = 0},
  [8463] = {.lex_state = 0},
  [8464] = {.lex_state = 0},
  [8465] = {.lex_state = 0},
  [8466] = {.lex_state = 0},
  [8467] = {.lex_state = 9},
  [8468] = {.lex_state = 0},
  [8469] = {.lex_state = 0},
  [8470] = {.lex_state = 0},
  [8471] = {.lex_state = 0},
  [8472] = {.lex_state = 0},
  [8473] = {.lex_state = 0},
  [8474] = {.lex_state = 0},
  [8475] = {.lex_state = 0},
  [8476] = {.lex_state = 9},
  [8477] = {.lex_state = 0},
  [8478] = {.lex_state = 9},
  [8479] = {.lex_state = 9},
  [8480] = {.lex_state = 9},
  [8481] = {.lex_state = 9},
  [8482] = {.lex_state = 0},
  [8483] = {.lex_state = 0},
  [8484] = {.lex_state = 0},
  [8485] = {.lex_state = 0},
  [8486] = {.lex_state = 0},
  [8487] = {.lex_state = 0},
  [8488] = {.lex_state = 0},
  [8489] = {.lex_state = 0},
  [8490] = {.lex_state = 0},
  [8491] = {.lex_state = 0},
  [8492] = {.lex_state = 0},
  [8493] = {.lex_state = 0},
  [8494] = {.lex_state = 0},
  [8495] = {.lex_state = 0},
  [8496] = {.lex_state = 0, .external_lex_state = 6},
  [8497] = {.lex_state = 0},
  [8498] = {.lex_state = 0},
  [8499] = {.lex_state = 0},
  [8500] = {.lex_state = 0},
  [8501] = {.lex_state = 0},
  [8502] = {.lex_state = 0},
  [8503] = {.lex_state = 0},
  [8504] = {.lex_state = 0},
  [8505] = {.lex_state = 0},
  [8506] = {.lex_state = 0},
  [8507] = {.lex_state = 0},
  [8508] = {.lex_state = 0},
  [8509] = {.lex_state = 9},
  [8510] = {.lex_state = 0},
  [8511] = {.lex_state = 9},
  [8512] = {.lex_state = 9},
  [8513] = {.lex_state = 0},
  [8514] = {.lex_state = 0},
  [8515] = {.lex_state = 0},
  [8516] = {.lex_state = 0},
  [8517] = {.lex_state = 0},
  [8518] = {.lex_state = 0},
  [8519] = {.lex_state = 9},
  [8520] = {.lex_state = 0},
  [8521] = {.lex_state = 9},
  [8522] = {.lex_state = 0},
  [8523] = {.lex_state = 0},
  [8524] = {.lex_state = 0},
  [8525] = {.lex_state = 0},
  [8526] = {.lex_state = 0},
  [8527] = {.lex_state = 0},
  [8528] = {.lex_state = 0},
  [8529] = {.lex_state = 0},
  [8530] = {.lex_state = 9},
  [8531] = {.lex_state = 0},
  [8532] = {.lex_state = 0},
  [8533] = {.lex_state = 9},
  [8534] = {.lex_state = 0},
  [8535] = {.lex_state = 0},
  [8536] = {.lex_state = 0},
  [8537] = {.lex_state = 0},
  [8538] = {.lex_state = 0},
  [8539] = {.lex_state = 0},
  [8540] = {.lex_state = 0},
  [8541] = {.lex_state = 0},
  [8542] = {.lex_state = 0},
  [8543] = {.lex_state = 0},
  [8544] = {.lex_state = 0},
  [8545] = {.lex_state = 0},
  [8546] = {.lex_state = 0},
  [8547] = {.lex_state = 0},
  [8548] = {.lex_state = 9},
  [8549] = {.lex_state = 0},
  [8550] = {.lex_state = 9},
  [8551] = {.lex_state = 0, .external_lex_state = 6},
  [8552] = {.lex_state = 9},
  [8553] = {.lex_state = 0},
  [8554] = {.lex_state = 0},
  [8555] = {.lex_state = 0},
  [8556] = {.lex_state = 9},
  [8557] = {.lex_state = 9},
  [8558] = {.lex_state = 9},
  [8559] = {.lex_state = 0, .external_lex_state = 6},
  [8560] = {.lex_state = 0},
  [8561] = {.lex_state = 0},
  [8562] = {.lex_state = 0},
  [8563] = {.lex_state = 0},
  [8564] = {.lex_state = 9},
  [8565] = {.lex_state = 9},
  [8566] = {.lex_state = 0},
  [8567] = {.lex_state = 0},
  [8568] = {.lex_state = 0},
  [8569] = {.lex_state = 9},
  [8570] = {.lex_state = 9},
  [8571] = {.lex_state = 0},
  [8572] = {.lex_state = 113},
  [8573] = {.lex_state = 0},
  [8574] = {.lex_state = 0},
  [8575] = {.lex_state = 0},
  [8576] = {.lex_state = 9},
  [8577] = {.lex_state = 0},
  [8578] = {.lex_state = 0},
  [8579] = {.lex_state = 0},
  [8580] = {.lex_state = 0},
  [8581] = {.lex_state = 0},
  [8582] = {.lex_state = 9},
  [8583] = {.lex_state = 0},
  [8584] = {.lex_state = 0},
  [8585] = {.lex_state = 112, .external_lex_state = 4},
  [8586] = {.lex_state = 0},
  [8587] = {.lex_state = 9},
  [8588] = {.lex_state = 9},
  [8589] = {.lex_state = 0},
  [8590] = {.lex_state = 9},
  [8591] = {.lex_state = 9},
  [8592] = {.lex_state = 0},
  [8593] = {.lex_state = 0},
  [8594] = {.lex_state = 0},
  [8595] = {.lex_state = 0},
  [8596] = {.lex_state = 0},
  [8597] = {.lex_state = 0},
  [8598] = {.lex_state = 0},
  [8599] = {.lex_state = 9},
  [8600] = {.lex_state = 0},
  [8601] = {.lex_state = 0},
  [8602] = {.lex_state = 0},
  [8603] = {.lex_state = 0},
  [8604] = {.lex_state = 0},
  [8605] = {.lex_state = 0},
  [8606] = {.lex_state = 0},
  [8607] = {.lex_state = 0},
  [8608] = {.lex_state = 0},
  [8609] = {.lex_state = 0},
  [8610] = {.lex_state = 0},
  [8611] = {.lex_state = 0},
  [8612] = {.lex_state = 0},
  [8613] = {.lex_state = 0},
  [8614] = {.lex_state = 0},
  [8615] = {.lex_state = 0},
  [8616] = {.lex_state = 0},
  [8617] = {.lex_state = 0},
  [8618] = {.lex_state = 0},
  [8619] = {.lex_state = 9},
  [8620] = {.lex_state = 9},
  [8621] = {.lex_state = 0},
  [8622] = {.lex_state = 0},
  [8623] = {.lex_state = 9},
  [8624] = {.lex_state = 0},
  [8625] = {.lex_state = 0},
  [8626] = {.lex_state = 0},
  [8627] = {.lex_state = 0},
  [8628] = {.lex_state = 9},
  [8629] = {.lex_state = 0},
  [8630] = {.lex_state = 0},
  [8631] = {.lex_state = 0},
  [8632] = {.lex_state = 0},
  [8633] = {.lex_state = 0},
  [8634] = {.lex_state = 0},
  [8635] = {.lex_state = 0},
  [8636] = {.lex_state = 0},
  [8637] = {.lex_state = 0},
  [8638] = {.lex_state = 0},
  [8639] = {.lex_state = 0},
  [8640] = {.lex_state = 0},
  [8641] = {.lex_state = 0},
  [8642] = {.lex_state = 0},
  [8643] = {.lex_state = 0},
  [8644] = {.lex_state = 0},
  [8645] = {.lex_state = 0},
  [8646] = {.lex_state = 0},
  [8647] = {.lex_state = 0},
  [8648] = {.lex_state = 0},
  [8649] = {.lex_state = 0},
  [8650] = {.lex_state = 0},
  [8651] = {.lex_state = 0},
  [8652] = {.lex_state = 0},
  [8653] = {.lex_state = 0},
  [8654] = {.lex_state = 0},
  [8655] = {.lex_state = 0},
  [8656] = {.lex_state = 0},
  [8657] = {.lex_state = 1},
  [8658] = {.lex_state = 0},
  [8659] = {.lex_state = 0},
  [8660] = {.lex_state = 0},
  [8661] = {.lex_state = 0},
  [8662] = {.lex_state = 0},
  [8663] = {.lex_state = 0},
  [8664] = {.lex_state = 0},
  [8665] = {.lex_state = 0},
  [8666] = {.lex_state = 0},
  [8667] = {.lex_state = 0},
  [8668] = {.lex_state = 0},
  [8669] = {.lex_state = 0},
  [8670] = {.lex_state = 0},
  [8671] = {.lex_state = 0},
  [8672] = {.lex_state = 0},
  [8673] = {.lex_state = 1},
  [8674] = {.lex_state = 0},
  [8675] = {.lex_state = 0},
  [8676] = {.lex_state = 0},
  [8677] = {.lex_state = 3},
  [8678] = {.lex_state = 0},
  [8679] = {.lex_state = 0},
  [8680] = {.lex_state = 0},
  [8681] = {.lex_state = 0},
  [8682] = {.lex_state = 0},
  [8683] = {.lex_state = 0},
  [8684] = {.lex_state = 0},
  [8685] = {.lex_state = 1},
  [8686] = {.lex_state = 0},
  [8687] = {.lex_state = 0},
  [8688] = {.lex_state = 0},
  [8689] = {.lex_state = 0},
  [8690] = {.lex_state = 0},
  [8691] = {.lex_state = 0},
  [8692] = {.lex_state = 0},
  [8693] = {.lex_state = 0},
  [8694] = {.lex_state = 0},
  [8695] = {.lex_state = 0},
  [8696] = {.lex_state = 0},
  [8697] = {.lex_state = 0},
  [8698] = {.lex_state = 0},
  [8699] = {.lex_state = 0},
  [8700] = {.lex_state = 0},
  [8701] = {.lex_state = 0},
  [8702] = {.lex_state = 0},
  [8703] = {.lex_state = 0},
  [8704] = {.lex_state = 9},
  [8705] = {.lex_state = 0},
  [8706] = {.lex_state = 0},
  [8707] = {.lex_state = 0},
  [8708] = {.lex_state = 0},
  [8709] = {.lex_state = 0},
  [8710] = {.lex_state = 0},
  [8711] = {.lex_state = 0},
  [8712] = {.lex_state = 0},
  [8713] = {.lex_state = 0},
  [8714] = {.lex_state = 0},
  [8715] = {.lex_state = 9},
  [8716] = {.lex_state = 9},
  [8717] = {.lex_state = 0},
  [8718] = {.lex_state = 0},
  [8719] = {.lex_state = 0},
  [8720] = {.lex_state = 22},
  [8721] = {.lex_state = 0},
  [8722] = {.lex_state = 0},
  [8723] = {.lex_state = 0},
  [8724] = {.lex_state = 3},
  [8725] = {.lex_state = 0},
  [8726] = {.lex_state = 0},
  [8727] = {.lex_state = 0},
  [8728] = {.lex_state = 0},
  [8729] = {.lex_state = 0},
  [8730] = {.lex_state = 0},
  [8731] = {.lex_state = 0},
  [8732] = {.lex_state = 0},
  [8733] = {.lex_state = 0},
  [8734] = {.lex_state = 0},
  [8735] = {.lex_state = 0},
  [8736] = {.lex_state = 9},
  [8737] = {.lex_state = 0},
  [8738] = {.lex_state = 0},
  [8739] = {.lex_state = 0},
  [8740] = {.lex_state = 22},
  [8741] = {.lex_state = 0},
  [8742] = {.lex_state = 0},
  [8743] = {.lex_state = 0},
  [8744] = {.lex_state = 0},
  [8745] = {.lex_state = 0},
  [8746] = {.lex_state = 0},
  [8747] = {.lex_state = 0},
  [8748] = {.lex_state = 22},
  [8749] = {.lex_state = 0},
  [8750] = {.lex_state = 0},
  [8751] = {.lex_state = 0},
  [8752] = {.lex_state = 0},
  [8753] = {.lex_state = 0},
  [8754] = {.lex_state = 0},
  [8755] = {.lex_state = 0},
  [8756] = {.lex_state = 0},
  [8757] = {.lex_state = 0},
  [8758] = {.lex_state = 0},
  [8759] = {.lex_state = 0},
  [8760] = {.lex_state = 0},
  [8761] = {.lex_state = 0},
  [8762] = {.lex_state = 0},
  [8763] = {.lex_state = 0},
  [8764] = {.lex_state = 0},
  [8765] = {.lex_state = 0},
  [8766] = {.lex_state = 0},
  [8767] = {.lex_state = 0},
  [8768] = {.lex_state = 0},
  [8769] = {.lex_state = 9},
  [8770] = {.lex_state = 0},
  [8771] = {.lex_state = 4},
  [8772] = {.lex_state = 0},
  [8773] = {.lex_state = 0},
  [8774] = {.lex_state = 0},
  [8775] = {.lex_state = 0},
  [8776] = {.lex_state = 9},
  [8777] = {.lex_state = 0},
  [8778] = {.lex_state = 0},
  [8779] = {.lex_state = 0},
  [8780] = {.lex_state = 0},
  [8781] = {.lex_state = 0},
  [8782] = {.lex_state = 0},
  [8783] = {.lex_state = 0},
  [8784] = {.lex_state = 0},
  [8785] = {.lex_state = 0},
  [8786] = {.lex_state = 0},
  [8787] = {.lex_state = 0},
  [8788] = {.lex_state = 0},
  [8789] = {.lex_state = 0},
  [8790] = {.lex_state = 0},
  [8791] = {.lex_state = 0},
  [8792] = {.lex_state = 0},
  [8793] = {.lex_state = 0},
  [8794] = {.lex_state = 0},
  [8795] = {.lex_state = 0},
  [8796] = {.lex_state = 0},
  [8797] = {.lex_state = 1},
  [8798] = {.lex_state = 4},
  [8799] = {.lex_state = 0},
  [8800] = {.lex_state = 0},
  [8801] = {.lex_state = 0},
  [8802] = {.lex_state = 0},
  [8803] = {.lex_state = 0},
  [8804] = {.lex_state = 0},
  [8805] = {.lex_state = 0},
  [8806] = {.lex_state = 0},
  [8807] = {.lex_state = 0},
  [8808] = {.lex_state = 0},
  [8809] = {.lex_state = 0},
  [8810] = {.lex_state = 0},
  [8811] = {.lex_state = 0},
  [8812] = {.lex_state = 0},
  [8813] = {.lex_state = 0},
  [8814] = {.lex_state = 0},
  [8815] = {.lex_state = 0},
  [8816] = {.lex_state = 0},
  [8817] = {.lex_state = 0},
  [8818] = {.lex_state = 0},
  [8819] = {.lex_state = 0},
  [8820] = {.lex_state = 4},
  [8821] = {.lex_state = 0},
  [8822] = {.lex_state = 0},
  [8823] = {.lex_state = 0},
  [8824] = {.lex_state = 0},
  [8825] = {.lex_state = 0},
  [8826] = {.lex_state = 0},
  [8827] = {.lex_state = 0},
  [8828] = {.lex_state = 0},
  [8829] = {.lex_state = 0},
  [8830] = {.lex_state = 0},
  [8831] = {.lex_state = 0},
  [8832] = {.lex_state = 0},
  [8833] = {.lex_state = 0},
  [8834] = {.lex_state = 9},
  [8835] = {.lex_state = 0},
  [8836] = {.lex_state = 0},
  [8837] = {.lex_state = 0},
  [8838] = {.lex_state = 0},
  [8839] = {.lex_state = 0},
  [8840] = {.lex_state = 0},
  [8841] = {.lex_state = 0},
  [8842] = {.lex_state = 0},
  [8843] = {.lex_state = 0},
  [8844] = {.lex_state = 0},
  [8845] = {.lex_state = 0},
  [8846] = {.lex_state = 0},
  [8847] = {.lex_state = 0},
  [8848] = {.lex_state = 0},
  [8849] = {.lex_state = 0},
  [8850] = {.lex_state = 0},
  [8851] = {.lex_state = 0},
  [8852] = {.lex_state = 0},
  [8853] = {.lex_state = 0},
  [8854] = {.lex_state = 0},
  [8855] = {.lex_state = 0},
  [8856] = {.lex_state = 0},
  [8857] = {.lex_state = 0},
  [8858] = {.lex_state = 0},
  [8859] = {.lex_state = 0},
  [8860] = {.lex_state = 0},
  [8861] = {.lex_state = 0},
  [8862] = {.lex_state = 0},
  [8863] = {.lex_state = 0},
  [8864] = {.lex_state = 0},
  [8865] = {.lex_state = 0},
  [8866] = {.lex_state = 0},
  [8867] = {.lex_state = 0},
  [8868] = {.lex_state = 0},
  [8869] = {.lex_state = 0},
  [8870] = {.lex_state = 0},
  [8871] = {.lex_state = 0},
  [8872] = {.lex_state = 0},
  [8873] = {.lex_state = 0},
  [8874] = {.lex_state = 0},
  [8875] = {.lex_state = 0},
  [8876] = {.lex_state = 22},
  [8877] = {.lex_state = 0},
  [8878] = {.lex_state = 0},
  [8879] = {.lex_state = 0},
  [8880] = {.lex_state = 0},
  [8881] = {.lex_state = 0},
  [8882] = {.lex_state = 0},
  [8883] = {.lex_state = 0},
  [8884] = {.lex_state = 0},
  [8885] = {.lex_state = 0},
  [8886] = {.lex_state = 0},
  [8887] = {.lex_state = 0},
  [8888] = {.lex_state = 0},
  [8889] = {.lex_state = 0},
  [8890] = {.lex_state = 0},
  [8891] = {.lex_state = 0},
  [8892] = {.lex_state = 0},
  [8893] = {.lex_state = 0},
  [8894] = {.lex_state = 0},
  [8895] = {.lex_state = 0},
  [8896] = {.lex_state = 0},
  [8897] = {.lex_state = 0},
  [8898] = {.lex_state = 0},
  [8899] = {.lex_state = 0},
  [8900] = {.lex_state = 0},
  [8901] = {.lex_state = 9},
  [8902] = {.lex_state = 0},
  [8903] = {.lex_state = 0},
  [8904] = {.lex_state = 0},
  [8905] = {.lex_state = 0},
  [8906] = {.lex_state = 113},
  [8907] = {.lex_state = 0},
  [8908] = {.lex_state = 9},
  [8909] = {.lex_state = 0},
  [8910] = {.lex_state = 0},
  [8911] = {.lex_state = 0},
  [8912] = {.lex_state = 0},
  [8913] = {.lex_state = 0},
  [8914] = {.lex_state = 0},
  [8915] = {.lex_state = 0},
  [8916] = {.lex_state = 0},
  [8917] = {.lex_state = 22},
  [8918] = {.lex_state = 0},
  [8919] = {.lex_state = 0},
  [8920] = {.lex_state = 0},
  [8921] = {.lex_state = 0},
  [8922] = {.lex_state = 0},
  [8923] = {.lex_state = 0},
  [8924] = {.lex_state = 0},
  [8925] = {.lex_state = 0},
  [8926] = {.lex_state = 0},
  [8927] = {.lex_state = 4},
  [8928] = {.lex_state = 0},
  [8929] = {.lex_state = 0},
  [8930] = {.lex_state = 0},
  [8931] = {.lex_state = 0},
  [8932] = {.lex_state = 0},
  [8933] = {.lex_state = 0},
  [8934] = {.lex_state = 0},
  [8935] = {.lex_state = 0},
  [8936] = {.lex_state = 0},
  [8937] = {.lex_state = 0},
  [8938] = {.lex_state = 0},
  [8939] = {.lex_state = 0},
  [8940] = {.lex_state = 0},
  [8941] = {.lex_state = 0},
  [8942] = {.lex_state = 0},
  [8943] = {.lex_state = 0},
  [8944] = {.lex_state = 0},
  [8945] = {.lex_state = 0},
  [8946] = {.lex_state = 0},
  [8947] = {.lex_state = 0},
  [8948] = {.lex_state = 0},
  [8949] = {.lex_state = 0},
  [8950] = {.lex_state = 22},
  [8951] = {.lex_state = 0},
  [8952] = {.lex_state = 0},
  [8953] = {.lex_state = 0},
  [8954] = {.lex_state = 0},
  [8955] = {.lex_state = 0},
  [8956] = {.lex_state = 0},
  [8957] = {.lex_state = 0},
  [8958] = {.lex_state = 0},
  [8959] = {.lex_state = 0},
  [8960] = {.lex_state = 0, .external_lex_state = 7},
  [8961] = {.lex_state = 0},
  [8962] = {.lex_state = 0},
  [8963] = {.lex_state = 0, .external_lex_state = 7},
  [8964] = {.lex_state = 0},
  [8965] = {.lex_state = 0, .external_lex_state = 7},
  [8966] = {.lex_state = 0},
  [8967] = {.lex_state = 0, .external_lex_state = 7},
  [8968] = {.lex_state = 0, .external_lex_state = 7},
  [8969] = {.lex_state = 0, .external_lex_state = 7},
  [8970] = {.lex_state = 0, .external_lex_state = 7},
  [8971] = {.lex_state = 0, .external_lex_state = 7},
  [8972] = {.lex_state = 0, .external_lex_state = 7},
  [8973] = {.lex_state = 0},
  [8974] = {.lex_state = 0, .external_lex_state = 7},
  [8975] = {.lex_state = 0, .external_lex_state = 7},
  [8976] = {.lex_state = 0},
  [8977] = {.lex_state = 0},
  [8978] = {.lex_state = 0},
  [8979] = {.lex_state = 0},
  [8980] = {.lex_state = 0},
  [8981] = {.lex_state = 0},
  [8982] = {.lex_state = 0},
  [8983] = {.lex_state = 0},
  [8984] = {.lex_state = 0, .external_lex_state = 7},
  [8985] = {.lex_state = 0, .external_lex_state = 7},
  [8986] = {.lex_state = 0},
  [8987] = {.lex_state = 0},
  [8988] = {.lex_state = 0},
  [8989] = {.lex_state = 0},
  [8990] = {.lex_state = 9},
  [8991] = {.lex_state = 0, .external_lex_state = 7},
  [8992] = {.lex_state = 0, .external_lex_state = 7},
  [8993] = {.lex_state = 0},
  [8994] = {.lex_state = 0, .external_lex_state = 7},
  [8995] = {.lex_state = 0},
  [8996] = {.lex_state = 0},
  [8997] = {.lex_state = 0},
  [8998] = {.lex_state = 0, .external_lex_state = 7},
  [8999] = {.lex_state = 0},
  [9000] = {.lex_state = 0, .external_lex_state = 7},
  [9001] = {.lex_state = 0, .external_lex_state = 7},
  [9002] = {.lex_state = 0, .external_lex_state = 7},
  [9003] = {.lex_state = 0},
  [9004] = {.lex_state = 0, .external_lex_state = 7},
  [9005] = {.lex_state = 0, .external_lex_state = 7},
  [9006] = {.lex_state = 0},
  [9007] = {.lex_state = 0, .external_lex_state = 7},
  [9008] = {.lex_state = 0, .external_lex_state = 7},
  [9009] = {.lex_state = 0},
  [9010] = {.lex_state = 0, .external_lex_state = 4},
  [9011] = {.lex_state = 9},
  [9012] = {.lex_state = 0, .external_lex_state = 7},
  [9013] = {.lex_state = 0, .external_lex_state = 7},
  [9014] = {.lex_state = 0},
  [9015] = {.lex_state = 0, .external_lex_state = 7},
  [9016] = {.lex_state = 0, .external_lex_state = 7},
  [9017] = {.lex_state = 0, .external_lex_state = 7},
  [9018] = {.lex_state = 0, .external_lex_state = 7},
  [9019] = {.lex_state = 0, .external_lex_state = 7},
  [9020] = {.lex_state = 0},
  [9021] = {.lex_state = 0},
  [9022] = {.lex_state = 0},
  [9023] = {.lex_state = 0},
  [9024] = {.lex_state = 0},
  [9025] = {.lex_state = 0, .external_lex_state = 7},
  [9026] = {.lex_state = 9},
  [9027] = {.lex_state = 0},
  [9028] = {.lex_state = 0},
  [9029] = {.lex_state = 0},
  [9030] = {.lex_state = 0, .external_lex_state = 7},
  [9031] = {.lex_state = 0, .external_lex_state = 7},
  [9032] = {.lex_state = 0},
  [9033] = {.lex_state = 0},
  [9034] = {.lex_state = 0},
  [9035] = {.lex_state = 0},
  [9036] = {.lex_state = 0, .external_lex_state = 7},
  [9037] = {.lex_state = 0, .external_lex_state = 7},
  [9038] = {.lex_state = 0, .external_lex_state = 7},
  [9039] = {.lex_state = 0, .external_lex_state = 7},
  [9040] = {.lex_state = 0},
  [9041] = {.lex_state = 0, .external_lex_state = 7},
  [9042] = {.lex_state = 0},
  [9043] = {.lex_state = 0, .external_lex_state = 7},
  [9044] = {.lex_state = 0},
  [9045] = {.lex_state = 4},
  [9046] = {.lex_state = 0},
  [9047] = {.lex_state = 0},
  [9048] = {.lex_state = 0},
  [9049] = {.lex_state = 0},
  [9050] = {.lex_state = 0, .external_lex_state = 7},
  [9051] = {.lex_state = 0},
  [9052] = {.lex_state = 0, .external_lex_state = 7},
  [9053] = {.lex_state = 0},
  [9054] = {.lex_state = 0},
  [9055] = {.lex_state = 0},
  [9056] = {.lex_state = 0, .external_lex_state = 7},
  [9057] = {.lex_state = 0, .external_lex_state = 7},
  [9058] = {.lex_state = 0, .external_lex_state = 7},
  [9059] = {.lex_state = 0, .external_lex_state = 7},
  [9060] = {.lex_state = 0, .external_lex_state = 7},
  [9061] = {.lex_state = 0, .external_lex_state = 7},
  [9062] = {.lex_state = 0, .external_lex_state = 7},
  [9063] = {.lex_state = 0},
  [9064] = {.lex_state = 0, .external_lex_state = 7},
  [9065] = {.lex_state = 0, .external_lex_state = 7},
  [9066] = {.lex_state = 0},
  [9067] = {.lex_state = 0},
  [9068] = {.lex_state = 0},
  [9069] = {.lex_state = 0, .external_lex_state = 7},
  [9070] = {.lex_state = 0},
  [9071] = {.lex_state = 9},
  [9072] = {.lex_state = 0},
  [9073] = {.lex_state = 0},
  [9074] = {.lex_state = 0},
  [9075] = {.lex_state = 9},
  [9076] = {.lex_state = 0, .external_lex_state = 7},
  [9077] = {.lex_state = 0, .external_lex_state = 7},
  [9078] = {.lex_state = 0, .external_lex_state = 7},
  [9079] = {.lex_state = 0, .external_lex_state = 7},
  [9080] = {.lex_state = 0, .external_lex_state = 7},
  [9081] = {.lex_state = 0},
  [9082] = {.lex_state = 0},
  [9083] = {.lex_state = 0},
  [9084] = {.lex_state = 0},
  [9085] = {.lex_state = 0, .external_lex_state = 7},
  [9086] = {.lex_state = 0, .external_lex_state = 7},
  [9087] = {.lex_state = 0, .external_lex_state = 7},
  [9088] = {.lex_state = 0, .external_lex_state = 7},
  [9089] = {.lex_state = 0},
  [9090] = {.lex_state = 0},
  [9091] = {.lex_state = 0, .external_lex_state = 7},
  [9092] = {.lex_state = 0},
  [9093] = {.lex_state = 0},
  [9094] = {.lex_state = 0},
  [9095] = {.lex_state = 0},
  [9096] = {.lex_state = 0},
  [9097] = {.lex_state = 0, .external_lex_state = 7},
  [9098] = {.lex_state = 0},
  [9099] = {.lex_state = 0},
  [9100] = {.lex_state = 0, .external_lex_state = 7},
  [9101] = {.lex_state = 0},
  [9102] = {.lex_state = 0},
  [9103] = {.lex_state = 0, .external_lex_state = 7},
  [9104] = {.lex_state = 0},
  [9105] = {.lex_state = 0},
  [9106] = {.lex_state = 0, .external_lex_state = 7},
  [9107] = {.lex_state = 0, .external_lex_state = 7},
  [9108] = {.lex_state = 0},
  [9109] = {.lex_state = 0},
  [9110] = {.lex_state = 0},
  [9111] = {.lex_state = 0},
  [9112] = {.lex_state = 0, .external_lex_state = 7},
  [9113] = {.lex_state = 0},
  [9114] = {.lex_state = 0, .external_lex_state = 7},
  [9115] = {.lex_state = 0, .external_lex_state = 7},
  [9116] = {.lex_state = 0, .external_lex_state = 7},
  [9117] = {.lex_state = 0},
  [9118] = {.lex_state = 0, .external_lex_state = 7},
  [9119] = {.lex_state = 0},
  [9120] = {.lex_state = 0},
  [9121] = {.lex_state = 0},
  [9122] = {.lex_state = 0, .external_lex_state = 7},
  [9123] = {.lex_state = 0},
  [9124] = {.lex_state = 0},
  [9125] = {.lex_state = 0},
  [9126] = {.lex_state = 0},
  [9127] = {.lex_state = 0},
  [9128] = {.lex_state = 0},
  [9129] = {.lex_state = 0, .external_lex_state = 8},
  [9130] = {.lex_state = 0},
  [9131] = {.lex_state = 4},
  [9132] = {.lex_state = 4},
  [9133] = {.lex_state = 0, .external_lex_state = 7},
  [9134] = {.lex_state = 0},
  [9135] = {.lex_state = 0, .external_lex_state = 7},
  [9136] = {.lex_state = 0},
  [9137] = {.lex_state = 0},
  [9138] = {.lex_state = 0},
  [9139] = {.lex_state = 0},
  [9140] = {.lex_state = 0},
  [9141] = {.lex_state = 0},
  [9142] = {.lex_state = 0},
  [9143] = {.lex_state = 0},
  [9144] = {.lex_state = 0, .external_lex_state = 7},
  [9145] = {.lex_state = 0},
  [9146] = {.lex_state = 0},
  [9147] = {.lex_state = 0},
  [9148] = {.lex_state = 0},
  [9149] = {.lex_state = 0},
  [9150] = {.lex_state = 0},
  [9151] = {.lex_state = 0},
  [9152] = {.lex_state = 0},
  [9153] = {.lex_state = 0},
  [9154] = {.lex_state = 0},
  [9155] = {.lex_state = 0},
  [9156] = {.lex_state = 0},
  [9157] = {.lex_state = 0},
  [9158] = {.lex_state = 0},
  [9159] = {.lex_state = 0},
  [9160] = {.lex_state = 0},
  [9161] = {.lex_state = 0},
  [9162] = {.lex_state = 0},
  [9163] = {.lex_state = 0},
  [9164] = {.lex_state = 0},
  [9165] = {.lex_state = 0},
  [9166] = {.lex_state = 0},
  [9167] = {.lex_state = 0},
  [9168] = {.lex_state = 0, .external_lex_state = 7},
  [9169] = {.lex_state = 0},
  [9170] = {.lex_state = 0},
  [9171] = {.lex_state = 0},
  [9172] = {.lex_state = 0},
  [9173] = {.lex_state = 0},
  [9174] = {.lex_state = 0},
  [9175] = {.lex_state = 0},
  [9176] = {.lex_state = 0, .external_lex_state = 7},
  [9177] = {.lex_state = 0, .external_lex_state = 7},
  [9178] = {.lex_state = 0},
  [9179] = {.lex_state = 0},
  [9180] = {.lex_state = 0},
  [9181] = {.lex_state = 0},
  [9182] = {.lex_state = 0},
  [9183] = {.lex_state = 0},
  [9184] = {.lex_state = 0},
  [9185] = {.lex_state = 0},
  [9186] = {.lex_state = 0},
  [9187] = {.lex_state = 0, .external_lex_state = 7},
  [9188] = {.lex_state = 0, .external_lex_state = 7},
  [9189] = {.lex_state = 0},
  [9190] = {.lex_state = 0},
  [9191] = {.lex_state = 0},
  [9192] = {.lex_state = 0},
  [9193] = {.lex_state = 0},
  [9194] = {.lex_state = 0},
  [9195] = {.lex_state = 0, .external_lex_state = 7},
  [9196] = {.lex_state = 0},
  [9197] = {.lex_state = 0},
  [9198] = {.lex_state = 0},
  [9199] = {.lex_state = 0},
  [9200] = {.lex_state = 0},
  [9201] = {.lex_state = 0},
  [9202] = {.lex_state = 0},
  [9203] = {.lex_state = 0},
  [9204] = {.lex_state = 0},
  [9205] = {.lex_state = 0},
  [9206] = {.lex_state = 0},
  [9207] = {.lex_state = 0},
  [9208] = {.lex_state = 0},
  [9209] = {.lex_state = 0, .external_lex_state = 7},
  [9210] = {.lex_state = 0},
  [9211] = {.lex_state = 0, .external_lex_state = 7},
  [9212] = {.lex_state = 0, .external_lex_state = 7},
  [9213] = {.lex_state = 0},
  [9214] = {.lex_state = 0},
  [9215] = {.lex_state = 0},
  [9216] = {.lex_state = 0},
  [9217] = {.lex_state = 0},
  [9218] = {.lex_state = 0},
  [9219] = {.lex_state = 0},
  [9220] = {.lex_state = 0, .external_lex_state = 7},
  [9221] = {.lex_state = 0},
  [9222] = {.lex_state = 0},
  [9223] = {.lex_state = 0},
  [9224] = {.lex_state = 0},
  [9225] = {.lex_state = 0, .external_lex_state = 7},
  [9226] = {.lex_state = 0},
  [9227] = {.lex_state = 0},
  [9228] = {.lex_state = 0, .external_lex_state = 7},
  [9229] = {.lex_state = 0},
  [9230] = {.lex_state = 0, .external_lex_state = 7},
  [9231] = {.lex_state = 0},
  [9232] = {.lex_state = 0, .external_lex_state = 7},
  [9233] = {.lex_state = 0},
  [9234] = {.lex_state = 0},
  [9235] = {.lex_state = 0, .external_lex_state = 7},
  [9236] = {.lex_state = 0},
  [9237] = {.lex_state = 0},
  [9238] = {.lex_state = 0},
  [9239] = {.lex_state = 0, .external_lex_state = 7},
  [9240] = {.lex_state = 0, .external_lex_state = 7},
  [9241] = {.lex_state = 0},
  [9242] = {.lex_state = 0},
  [9243] = {.lex_state = 0, .external_lex_state = 7},
  [9244] = {.lex_state = 0, .external_lex_state = 7},
  [9245] = {.lex_state = 0, .external_lex_state = 7},
  [9246] = {.lex_state = 0},
  [9247] = {.lex_state = 0},
  [9248] = {.lex_state = 0, .external_lex_state = 7},
  [9249] = {.lex_state = 0},
  [9250] = {.lex_state = 0},
  [9251] = {.lex_state = 0},
  [9252] = {.lex_state = 0, .external_lex_state = 7},
  [9253] = {.lex_state = 0},
  [9254] = {.lex_state = 0},
  [9255] = {.lex_state = 0, .external_lex_state = 7},
  [9256] = {.lex_state = 0},
  [9257] = {.lex_state = 0},
  [9258] = {.lex_state = 0},
  [9259] = {.lex_state = 0},
  [9260] = {.lex_state = 0},
  [9261] = {.lex_state = 0, .external_lex_state = 7},
  [9262] = {.lex_state = 0},
  [9263] = {.lex_state = 112},
  [9264] = {.lex_state = 0},
  [9265] = {.lex_state = 0},
  [9266] = {.lex_state = 0},
  [9267] = {.lex_state = 0},
  [9268] = {.lex_state = 0},
  [9269] = {.lex_state = 0},
  [9270] = {.lex_state = 0, .external_lex_state = 7},
  [9271] = {.lex_state = 0, .external_lex_state = 7},
  [9272] = {.lex_state = 0},
  [9273] = {.lex_state = 0, .external_lex_state = 7},
  [9274] = {.lex_state = 0},
  [9275] = {.lex_state = 0},
  [9276] = {.lex_state = 0, .external_lex_state = 7},
  [9277] = {.lex_state = 0, .external_lex_state = 7},
  [9278] = {.lex_state = 0},
  [9279] = {.lex_state = 0, .external_lex_state = 7},
  [9280] = {.lex_state = 0, .external_lex_state = 7},
  [9281] = {.lex_state = 0},
  [9282] = {.lex_state = 0},
  [9283] = {.lex_state = 0},
  [9284] = {.lex_state = 0, .external_lex_state = 7},
  [9285] = {.lex_state = 0},
  [9286] = {.lex_state = 0},
  [9287] = {.lex_state = 0, .external_lex_state = 7},
  [9288] = {.lex_state = 0, .external_lex_state = 7},
  [9289] = {.lex_state = 0},
  [9290] = {.lex_state = 0},
  [9291] = {.lex_state = 0, .external_lex_state = 7},
  [9292] = {.lex_state = 0, .external_lex_state = 7},
  [9293] = {.lex_state = 0},
  [9294] = {.lex_state = 0},
  [9295] = {.lex_state = 0},
  [9296] = {.lex_state = 0},
  [9297] = {.lex_state = 0, .external_lex_state = 7},
  [9298] = {.lex_state = 0},
  [9299] = {.lex_state = 0, .external_lex_state = 7},
  [9300] = {.lex_state = 0},
  [9301] = {.lex_state = 0, .external_lex_state = 7},
  [9302] = {.lex_state = 0, .external_lex_state = 7},
  [9303] = {.lex_state = 0, .external_lex_state = 7},
  [9304] = {.lex_state = 0},
  [9305] = {.lex_state = 0},
  [9306] = {.lex_state = 0},
  [9307] = {.lex_state = 0},
  [9308] = {.lex_state = 0, .external_lex_state = 7},
  [9309] = {.lex_state = 0, .external_lex_state = 7},
  [9310] = {.lex_state = 0, .external_lex_state = 7},
  [9311] = {.lex_state = 0},
  [9312] = {.lex_state = 0},
  [9313] = {.lex_state = 0},
  [9314] = {.lex_state = 0},
  [9315] = {.lex_state = 0, .external_lex_state = 7},
  [9316] = {.lex_state = 0, .external_lex_state = 7},
  [9317] = {.lex_state = 0, .external_lex_state = 7},
  [9318] = {.lex_state = 0},
  [9319] = {.lex_state = 0},
  [9320] = {.lex_state = 0, .external_lex_state = 7},
  [9321] = {.lex_state = 0, .external_lex_state = 7},
  [9322] = {.lex_state = 0},
  [9323] = {.lex_state = 0},
  [9324] = {.lex_state = 0},
  [9325] = {.lex_state = 0, .external_lex_state = 7},
  [9326] = {.lex_state = 0, .external_lex_state = 7},
  [9327] = {.lex_state = 0},
  [9328] = {.lex_state = 0, .external_lex_state = 7},
  [9329] = {.lex_state = 0},
  [9330] = {.lex_state = 0},
  [9331] = {.lex_state = 0, .external_lex_state = 7},
  [9332] = {.lex_state = 0},
  [9333] = {.lex_state = 0, .external_lex_state = 7},
  [9334] = {.lex_state = 0, .external_lex_state = 7},
  [9335] = {.lex_state = 4},
  [9336] = {.lex_state = 0, .external_lex_state = 7},
  [9337] = {.lex_state = 0},
  [9338] = {.lex_state = 0},
  [9339] = {.lex_state = 0},
  [9340] = {.lex_state = 0},
  [9341] = {.lex_state = 0},
  [9342] = {.lex_state = 0},
  [9343] = {.lex_state = 0, .external_lex_state = 7},
  [9344] = {.lex_state = 9},
  [9345] = {.lex_state = 0},
  [9346] = {.lex_state = 0, .external_lex_state = 7},
  [9347] = {.lex_state = 0},
  [9348] = {.lex_state = 0},
  [9349] = {.lex_state = 0, .external_lex_state = 7},
  [9350] = {.lex_state = 0},
  [9351] = {.lex_state = 0},
  [9352] = {.lex_state = 0},
  [9353] = {.lex_state = 0, .external_lex_state = 7},
  [9354] = {.lex_state = 0, .external_lex_state = 7},
  [9355] = {.lex_state = 0},
  [9356] = {.lex_state = 0},
  [9357] = {.lex_state = 0},
  [9358] = {.lex_state = 0, .external_lex_state = 7},
  [9359] = {.lex_state = 0},
  [9360] = {.lex_state = 0, .external_lex_state = 7},
  [9361] = {.lex_state = 0},
  [9362] = {.lex_state = 0, .external_lex_state = 7},
  [9363] = {.lex_state = 0},
  [9364] = {.lex_state = 0, .external_lex_state = 7},
  [9365] = {.lex_state = 0},
  [9366] = {.lex_state = 0},
  [9367] = {.lex_state = 0, .external_lex_state = 7},
  [9368] = {.lex_state = 0, .external_lex_state = 7},
  [9369] = {.lex_state = 0},
  [9370] = {.lex_state = 0, .external_lex_state = 7},
  [9371] = {.lex_state = 0, .external_lex_state = 7},
  [9372] = {.lex_state = 0, .external_lex_state = 7},
  [9373] = {.lex_state = 0},
  [9374] = {.lex_state = 0},
  [9375] = {.lex_state = 0},
  [9376] = {.lex_state = 0, .external_lex_state = 7},
  [9377] = {.lex_state = 0, .external_lex_state = 7},
  [9378] = {.lex_state = 0, .external_lex_state = 7},
  [9379] = {.lex_state = 0, .external_lex_state = 7},
  [9380] = {.lex_state = 0},
  [9381] = {.lex_state = 0},
  [9382] = {.lex_state = 112},
  [9383] = {.lex_state = 0},
  [9384] = {.lex_state = 0},
  [9385] = {.lex_state = 0},
  [9386] = {.lex_state = 113},
  [9387] = {.lex_state = 0, .external_lex_state = 7},
  [9388] = {.lex_state = 0},
  [9389] = {.lex_state = 0, .external_lex_state = 7},
  [9390] = {.lex_state = 0},
  [9391] = {.lex_state = 0},
  [9392] = {.lex_state = 0},
  [9393] = {.lex_state = 0},
  [9394] = {.lex_state = 0},
  [9395] = {.lex_state = 0},
  [9396] = {.lex_state = 0, .external_lex_state = 7},
  [9397] = {.lex_state = 0},
  [9398] = {.lex_state = 0},
  [9399] = {.lex_state = 0},
  [9400] = {.lex_state = 0, .external_lex_state = 7},
  [9401] = {.lex_state = 0, .external_lex_state = 7},
  [9402] = {.lex_state = 0, .external_lex_state = 7},
  [9403] = {.lex_state = 0},
  [9404] = {.lex_state = 0},
  [9405] = {.lex_state = 0, .external_lex_state = 7},
  [9406] = {.lex_state = 0, .external_lex_state = 7},
  [9407] = {.lex_state = 0, .external_lex_state = 7},
  [9408] = {.lex_state = 0, .external_lex_state = 7},
  [9409] = {.lex_state = 0},
  [9410] = {.lex_state = 0},
  [9411] = {.lex_state = 0},
  [9412] = {.lex_state = 0},
  [9413] = {.lex_state = 0},
  [9414] = {.lex_state = 0},
  [9415] = {.lex_state = 0},
  [9416] = {.lex_state = 0},
  [9417] = {.lex_state = 0},
  [9418] = {.lex_state = 0},
  [9419] = {.lex_state = 0},
  [9420] = {.lex_state = 0},
  [9421] = {.lex_state = 0, .external_lex_state = 7},
  [9422] = {.lex_state = 0},
  [9423] = {.lex_state = 0, .external_lex_state = 7},
  [9424] = {.lex_state = 0},
  [9425] = {.lex_state = 112},
  [9426] = {.lex_state = 0},
  [9427] = {.lex_state = 0},
  [9428] = {.lex_state = 0, .external_lex_state = 7},
  [9429] = {.lex_state = 0, .external_lex_state = 7},
  [9430] = {.lex_state = 0},
  [9431] = {.lex_state = 0},
  [9432] = {.lex_state = 0},
  [9433] = {.lex_state = 0},
  [9434] = {.lex_state = 0},
  [9435] = {.lex_state = 0, .external_lex_state = 7},
  [9436] = {.lex_state = 0},
  [9437] = {.lex_state = 0},
  [9438] = {.lex_state = 0},
  [9439] = {.lex_state = 113},
  [9440] = {.lex_state = 0},
  [9441] = {.lex_state = 0},
  [9442] = {.lex_state = 0, .external_lex_state = 7},
  [9443] = {.lex_state = 0},
  [9444] = {.lex_state = 0},
  [9445] = {.lex_state = 0},
  [9446] = {.lex_state = 0},
  [9447] = {.lex_state = 0},
  [9448] = {.lex_state = 0},
  [9449] = {.lex_state = 0},
  [9450] = {.lex_state = 0, .external_lex_state = 7},
  [9451] = {.lex_state = 0, .external_lex_state = 8},
  [9452] = {.lex_state = 0},
  [9453] = {.lex_state = 0},
  [9454] = {.lex_state = 0},
  [9455] = {.lex_state = 0, .external_lex_state = 7},
  [9456] = {.lex_state = 0},
  [9457] = {.lex_state = 4},
  [9458] = {.lex_state = 0},
  [9459] = {.lex_state = 4},
  [9460] = {.lex_state = 0, .external_lex_state = 7},
  [9461] = {.lex_state = 0},
  [9462] = {.lex_state = 0, .external_lex_state = 4},
  [9463] = {.lex_state = 0, .external_lex_state = 7},
  [9464] = {.lex_state = 0},
  [9465] = {.lex_state = 0},
  [9466] = {.lex_state = 0},
  [9467] = {.lex_state = 0, .external_lex_state = 7},
  [9468] = {.lex_state = 0, .external_lex_state = 7},
  [9469] = {.lex_state = 0, .external_lex_state = 7},
  [9470] = {.lex_state = 0, .external_lex_state = 7},
  [9471] = {.lex_state = 0},
  [9472] = {.lex_state = 0},
  [9473] = {.lex_state = 0},
  [9474] = {.lex_state = 0},
  [9475] = {.lex_state = 0, .external_lex_state = 7},
  [9476] = {.lex_state = 0, .external_lex_state = 7},
  [9477] = {.lex_state = 0},
  [9478] = {.lex_state = 0},
  [9479] = {.lex_state = 0},
  [9480] = {.lex_state = 0},
  [9481] = {.lex_state = 1},
  [9482] = {.lex_state = 0},
  [9483] = {.lex_state = 23},
  [9484] = {.lex_state = 0, .external_lex_state = 7},
  [9485] = {.lex_state = 0, .external_lex_state = 4},
  [9486] = {.lex_state = 0, .external_lex_state = 7},
  [9487] = {.lex_state = 9},
  [9488] = {.lex_state = 0},
  [9489] = {.lex_state = 0},
  [9490] = {.lex_state = 0, .external_lex_state = 7},
  [9491] = {.lex_state = 0},
  [9492] = {.lex_state = 0},
  [9493] = {.lex_state = 0},
  [9494] = {.lex_state = 0},
  [9495] = {.lex_state = 0, .external_lex_state = 7},
  [9496] = {.lex_state = 0, .external_lex_state = 7},
  [9497] = {.lex_state = 0},
  [9498] = {.lex_state = 9},
  [9499] = {.lex_state = 0},
  [9500] = {.lex_state = 0, .external_lex_state = 7},
  [9501] = {.lex_state = 9},
  [9502] = {.lex_state = 0, .external_lex_state = 7},
  [9503] = {.lex_state = 0},
  [9504] = {.lex_state = 0},
  [9505] = {.lex_state = 0},
  [9506] = {.lex_state = 0},
  [9507] = {.lex_state = 0},
  [9508] = {.lex_state = 0},
  [9509] = {.lex_state = 0},
  [9510] = {.lex_state = 0},
  [9511] = {.lex_state = 0},
  [9512] = {.lex_state = 9},
  [9513] = {.lex_state = 0, .external_lex_state = 7},
  [9514] = {.lex_state = 0},
  [9515] = {.lex_state = 0},
  [9516] = {.lex_state = 0},
  [9517] = {.lex_state = 0, .external_lex_state = 7},
  [9518] = {.lex_state = 0, .external_lex_state = 7},
  [9519] = {.lex_state = 0},
  [9520] = {.lex_state = 0, .external_lex_state = 7},
  [9521] = {.lex_state = 0},
  [9522] = {.lex_state = 0, .external_lex_state = 7},
  [9523] = {.lex_state = 0, .external_lex_state = 7},
  [9524] = {.lex_state = 0, .external_lex_state = 7},
  [9525] = {.lex_state = 0, .external_lex_state = 7},
  [9526] = {.lex_state = 0, .external_lex_state = 7},
  [9527] = {.lex_state = 0},
  [9528] = {.lex_state = 0, .external_lex_state = 7},
  [9529] = {.lex_state = 0, .external_lex_state = 7},
  [9530] = {.lex_state = 0, .external_lex_state = 7},
  [9531] = {.lex_state = 0},
  [9532] = {.lex_state = 0, .external_lex_state = 7},
  [9533] = {.lex_state = 0},
  [9534] = {.lex_state = 0, .external_lex_state = 7},
  [9535] = {.lex_state = 0, .external_lex_state = 7},
  [9536] = {.lex_state = 0},
  [9537] = {.lex_state = 113},
  [9538] = {.lex_state = 0, .external_lex_state = 7},
  [9539] = {.lex_state = 0, .external_lex_state = 7},
  [9540] = {.lex_state = 0, .external_lex_state = 7},
  [9541] = {.lex_state = 0, .external_lex_state = 7},
  [9542] = {.lex_state = 0},
  [9543] = {.lex_state = 0, .external_lex_state = 7},
  [9544] = {.lex_state = 9},
  [9545] = {.lex_state = 0},
  [9546] = {.lex_state = 0, .external_lex_state = 7},
  [9547] = {.lex_state = 0, .external_lex_state = 7},
  [9548] = {.lex_state = 0},
  [9549] = {.lex_state = 0},
  [9550] = {.lex_state = 0},
  [9551] = {.lex_state = 0},
  [9552] = {.lex_state = 0, .external_lex_state = 7},
  [9553] = {.lex_state = 0, .external_lex_state = 7},
  [9554] = {.lex_state = 0},
  [9555] = {.lex_state = 0, .external_lex_state = 7},
  [9556] = {.lex_state = 0},
  [9557] = {.lex_state = 0, .external_lex_state = 7},
  [9558] = {.lex_state = 0},
  [9559] = {.lex_state = 0},
  [9560] = {.lex_state = 0},
  [9561] = {.lex_state = 0},
  [9562] = {.lex_state = 0, .external_lex_state = 7},
  [9563] = {.lex_state = 0},
  [9564] = {.lex_state = 0},
  [9565] = {.lex_state = 112},
  [9566] = {.lex_state = 112},
  [9567] = {.lex_state = 0},
  [9568] = {.lex_state = 0},
  [9569] = {.lex_state = 9},
  [9570] = {.lex_state = 0},
  [9571] = {.lex_state = 0},
  [9572] = {.lex_state = 113},
  [9573] = {.lex_state = 0},
  [9574] = {.lex_state = 0},
  [9575] = {.lex_state = 0},
  [9576] = {.lex_state = 0},
  [9577] = {.lex_state = 9},
  [9578] = {.lex_state = 0},
  [9579] = {.lex_state = 0},
  [9580] = {.lex_state = 9},
  [9581] = {.lex_state = 1},
  [9582] = {.lex_state = 0},
  [9583] = {.lex_state = 0},
  [9584] = {.lex_state = 0},
  [9585] = {.lex_state = 0},
  [9586] = {.lex_state = 1},
  [9587] = {.lex_state = 9},
  [9588] = {.lex_state = 1},
  [9589] = {.lex_state = 0},
  [9590] = {.lex_state = 0},
  [9591] = {.lex_state = 0},
  [9592] = {.lex_state = 0},
  [9593] = {.lex_state = 0},
  [9594] = {.lex_state = 0},
  [9595] = {.lex_state = 0},
  [9596] = {.lex_state = 0},
  [9597] = {.lex_state = 0},
  [9598] = {.lex_state = 0, .external_lex_state = 7},
  [9599] = {.lex_state = 0},
  [9600] = {.lex_state = 0},
  [9601] = {.lex_state = 0},
  [9602] = {.lex_state = 1},
  [9603] = {.lex_state = 0, .external_lex_state = 7},
  [9604] = {.lex_state = 0, .external_lex_state = 7},
  [9605] = {.lex_state = 0},
  [9606] = {.lex_state = 0, .external_lex_state = 7},
  [9607] = {.lex_state = 0, .external_lex_state = 7},
  [9608] = {.lex_state = 0, .external_lex_state = 7},
  [9609] = {.lex_state = 0},
  [9610] = {.lex_state = 0, .external_lex_state = 7},
  [9611] = {.lex_state = 0, .external_lex_state = 7},
  [9612] = {.lex_state = 0},
  [9613] = {.lex_state = 9},
  [9614] = {.lex_state = 0, .external_lex_state = 7},
  [9615] = {.lex_state = 0, .external_lex_state = 7},
  [9616] = {.lex_state = 0, .external_lex_state = 7},
  [9617] = {.lex_state = 0},
  [9618] = {.lex_state = 0},
  [9619] = {.lex_state = 0},
  [9620] = {.lex_state = 0, .external_lex_state = 7},
  [9621] = {.lex_state = 0},
  [9622] = {.lex_state = 0},
  [9623] = {.lex_state = 4},
  [9624] = {.lex_state = 1},
  [9625] = {.lex_state = 0},
  [9626] = {.lex_state = 113},
  [9627] = {.lex_state = 0},
  [9628] = {.lex_state = 0, .external_lex_state = 7},
  [9629] = {.lex_state = 0, .external_lex_state = 7},
  [9630] = {.lex_state = 0},
  [9631] = {.lex_state = 0},
  [9632] = {.lex_state = 0},
  [9633] = {.lex_state = 0},
  [9634] = {.lex_state = 0},
  [9635] = {.lex_state = 0},
  [9636] = {.lex_state = 0},
  [9637] = {.lex_state = 0, .external_lex_state = 7},
  [9638] = {.lex_state = 0},
  [9639] = {.lex_state = 0},
  [9640] = {.lex_state = 0},
  [9641] = {.lex_state = 0, .external_lex_state = 7},
  [9642] = {.lex_state = 0},
  [9643] = {.lex_state = 0, .external_lex_state = 7},
  [9644] = {.lex_state = 0},
  [9645] = {.lex_state = 0, .external_lex_state = 7},
  [9646] = {.lex_state = 0, .external_lex_state = 7},
  [9647] = {.lex_state = 0},
  [9648] = {.lex_state = 0},
  [9649] = {.lex_state = 0, .external_lex_state = 7},
  [9650] = {.lex_state = 113},
  [9651] = {.lex_state = 1},
  [9652] = {.lex_state = 0},
  [9653] = {.lex_state = 0},
  [9654] = {.lex_state = 0},
  [9655] = {.lex_state = 9},
  [9656] = {.lex_state = 0},
  [9657] = {.lex_state = 0},
  [9658] = {.lex_state = 0, .external_lex_state = 7},
  [9659] = {.lex_state = 0},
  [9660] = {.lex_state = 0, .external_lex_state = 4},
  [9661] = {.lex_state = 9},
  [9662] = {.lex_state = 0},
  [9663] = {.lex_state = 0},
  [9664] = {.lex_state = 0},
  [9665] = {.lex_state = 0},
  [9666] = {.lex_state = 0},
  [9667] = {.lex_state = 0},
  [9668] = {.lex_state = 0},
  [9669] = {.lex_state = 1},
  [9670] = {.lex_state = 0, .external_lex_state = 7},
  [9671] = {.lex_state = 1},
  [9672] = {.lex_state = 0},
  [9673] = {.lex_state = 4},
  [9674] = {.lex_state = 0, .external_lex_state = 7},
  [9675] = {.lex_state = 0, .external_lex_state = 7},
  [9676] = {.lex_state = 0, .external_lex_state = 7},
  [9677] = {.lex_state = 0, .external_lex_state = 7},
  [9678] = {.lex_state = 0},
  [9679] = {.lex_state = 0, .external_lex_state = 7},
  [9680] = {.lex_state = 0, .external_lex_state = 7},
  [9681] = {.lex_state = 0},
  [9682] = {.lex_state = 0},
  [9683] = {.lex_state = 0},
  [9684] = {.lex_state = 0},
  [9685] = {.lex_state = 0},
  [9686] = {.lex_state = 0},
  [9687] = {.lex_state = 9},
  [9688] = {.lex_state = 0},
  [9689] = {.lex_state = 0},
  [9690] = {.lex_state = 0},
  [9691] = {.lex_state = 0},
  [9692] = {.lex_state = 0},
  [9693] = {.lex_state = 0},
  [9694] = {.lex_state = 0},
  [9695] = {.lex_state = 0},
  [9696] = {.lex_state = 0},
  [9697] = {.lex_state = 0},
  [9698] = {.lex_state = 9},
  [9699] = {.lex_state = 0},
  [9700] = {.lex_state = 0},
  [9701] = {.lex_state = 0},
  [9702] = {.lex_state = 0},
  [9703] = {.lex_state = 0},
  [9704] = {.lex_state = 0},
  [9705] = {.lex_state = 0},
  [9706] = {.lex_state = 0},
  [9707] = {.lex_state = 0},
  [9708] = {.lex_state = 0},
  [9709] = {.lex_state = 0},
  [9710] = {.lex_state = 0},
  [9711] = {.lex_state = 0, .external_lex_state = 7},
  [9712] = {.lex_state = 0},
  [9713] = {.lex_state = 9},
  [9714] = {.lex_state = 0},
  [9715] = {.lex_state = 0},
  [9716] = {.lex_state = 0, .external_lex_state = 4},
  [9717] = {.lex_state = 0},
  [9718] = {.lex_state = 0, .external_lex_state = 7},
  [9719] = {.lex_state = 0},
  [9720] = {.lex_state = 1},
  [9721] = {.lex_state = 113},
  [9722] = {.lex_state = 0},
  [9723] = {.lex_state = 0},
  [9724] = {.lex_state = 0, .external_lex_state = 7},
  [9725] = {.lex_state = 0},
  [9726] = {.lex_state = 1},
  [9727] = {.lex_state = 0},
  [9728] = {.lex_state = 0},
  [9729] = {.lex_state = 1},
  [9730] = {.lex_state = 0},
  [9731] = {.lex_state = 0},
  [9732] = {.lex_state = 0, .external_lex_state = 7},
  [9733] = {.lex_state = 0},
  [9734] = {.lex_state = 0, .external_lex_state = 7},
  [9735] = {.lex_state = 0},
  [9736] = {.lex_state = 0, .external_lex_state = 7},
  [9737] = {.lex_state = 0},
  [9738] = {.lex_state = 0},
  [9739] = {.lex_state = 0},
  [9740] = {.lex_state = 0},
  [9741] = {.lex_state = 0, .external_lex_state = 7},
  [9742] = {.lex_state = 0, .external_lex_state = 7},
  [9743] = {.lex_state = 0, .external_lex_state = 7},
  [9744] = {.lex_state = 0},
  [9745] = {.lex_state = 0, .external_lex_state = 7},
  [9746] = {.lex_state = 0, .external_lex_state = 7},
  [9747] = {.lex_state = 0},
  [9748] = {.lex_state = 9},
  [9749] = {.lex_state = 0, .external_lex_state = 7},
  [9750] = {.lex_state = 0},
  [9751] = {.lex_state = 0},
  [9752] = {.lex_state = 0},
  [9753] = {.lex_state = 0},
  [9754] = {.lex_state = 0},
  [9755] = {.lex_state = 0},
  [9756] = {.lex_state = 0, .external_lex_state = 7},
  [9757] = {.lex_state = 0},
  [9758] = {.lex_state = 0},
  [9759] = {.lex_state = 0},
  [9760] = {.lex_state = 0, .external_lex_state = 7},
  [9761] = {.lex_state = 0, .external_lex_state = 7},
  [9762] = {.lex_state = 0},
  [9763] = {.lex_state = 113},
  [9764] = {.lex_state = 0},
  [9765] = {.lex_state = 0},
  [9766] = {.lex_state = 0},
  [9767] = {.lex_state = 0, .external_lex_state = 7},
  [9768] = {.lex_state = 0},
  [9769] = {.lex_state = 0},
  [9770] = {.lex_state = 0, .external_lex_state = 7},
  [9771] = {.lex_state = 0},
  [9772] = {.lex_state = 112},
  [9773] = {.lex_state = 0, .external_lex_state = 7},
  [9774] = {.lex_state = 0, .external_lex_state = 7},
  [9775] = {.lex_state = 0},
  [9776] = {.lex_state = 0},
  [9777] = {.lex_state = 0, .external_lex_state = 7},
  [9778] = {.lex_state = 0},
  [9779] = {.lex_state = 0},
  [9780] = {.lex_state = 0},
  [9781] = {.lex_state = 0},
  [9782] = {.lex_state = 0},
  [9783] = {.lex_state = 0, .external_lex_state = 7},
  [9784] = {.lex_state = 0},
  [9785] = {.lex_state = 0},
  [9786] = {.lex_state = 0},
  [9787] = {.lex_state = 0, .external_lex_state = 7},
  [9788] = {.lex_state = 0},
  [9789] = {.lex_state = 0},
  [9790] = {.lex_state = 0},
  [9791] = {.lex_state = 0, .external_lex_state = 7},
  [9792] = {.lex_state = 0, .external_lex_state = 7},
  [9793] = {.lex_state = 0},
  [9794] = {.lex_state = 0, .external_lex_state = 7},
  [9795] = {.lex_state = 0},
  [9796] = {.lex_state = 0, .external_lex_state = 7},
  [9797] = {.lex_state = 0, .external_lex_state = 8},
  [9798] = {.lex_state = 0, .external_lex_state = 7},
  [9799] = {.lex_state = 4},
  [9800] = {.lex_state = 4},
  [9801] = {.lex_state = 0},
  [9802] = {.lex_state = 0},
  [9803] = {.lex_state = 0},
  [9804] = {.lex_state = 0},
  [9805] = {.lex_state = 0, .external_lex_state = 7},
  [9806] = {.lex_state = 0, .external_lex_state = 7},
  [9807] = {.lex_state = 0, .external_lex_state = 7},
  [9808] = {.lex_state = 0},
  [9809] = {.lex_state = 0},
  [9810] = {.lex_state = 0, .external_lex_state = 7},
  [9811] = {.lex_state = 0},
  [9812] = {.lex_state = 0},
  [9813] = {.lex_state = 0},
  [9814] = {.lex_state = 0},
  [9815] = {.lex_state = 0, .external_lex_state = 7},
  [9816] = {.lex_state = 4},
  [9817] = {.lex_state = 0},
  [9818] = {.lex_state = 0},
  [9819] = {.lex_state = 4},
  [9820] = {.lex_state = 0, .external_lex_state = 7},
  [9821] = {.lex_state = 0},
  [9822] = {.lex_state = 0, .external_lex_state = 7},
  [9823] = {.lex_state = 0, .external_lex_state = 8},
  [9824] = {.lex_state = 0, .external_lex_state = 7},
  [9825] = {.lex_state = 0, .external_lex_state = 7},
  [9826] = {.lex_state = 0, .external_lex_state = 7},
  [9827] = {.lex_state = 0},
  [9828] = {.lex_state = 0, .external_lex_state = 7},
  [9829] = {.lex_state = 0, .external_lex_state = 7},
  [9830] = {.lex_state = 0, .external_lex_state = 7},
  [9831] = {.lex_state = 0, .external_lex_state = 7},
  [9832] = {.lex_state = 0},
  [9833] = {.lex_state = 0, .external_lex_state = 7},
  [9834] = {.lex_state = 0, .external_lex_state = 7},
  [9835] = {.lex_state = 0, .external_lex_state = 7},
  [9836] = {.lex_state = 0, .external_lex_state = 7},
  [9837] = {.lex_state = 0, .external_lex_state = 7},
  [9838] = {.lex_state = 0, .external_lex_state = 7},
  [9839] = {.lex_state = 0, .external_lex_state = 7},
  [9840] = {.lex_state = 0},
  [9841] = {.lex_state = 0, .external_lex_state = 7},
  [9842] = {.lex_state = 0, .external_lex_state = 7},
  [9843] = {.lex_state = 0},
  [9844] = {.lex_state = 0, .external_lex_state = 7},
  [9845] = {.lex_state = 0},
  [9846] = {.lex_state = 0, .external_lex_state = 7},
  [9847] = {.lex_state = 0},
  [9848] = {.lex_state = 9},
  [9849] = {.lex_state = 0},
  [9850] = {.lex_state = 0},
  [9851] = {.lex_state = 0, .external_lex_state = 7},
  [9852] = {.lex_state = 0},
  [9853] = {.lex_state = 0},
  [9854] = {.lex_state = 0, .external_lex_state = 7},
  [9855] = {.lex_state = 0, .external_lex_state = 7},
  [9856] = {.lex_state = 0, .external_lex_state = 7},
  [9857] = {.lex_state = 9},
  [9858] = {.lex_state = 0, .external_lex_state = 7},
  [9859] = {.lex_state = 0},
  [9860] = {.lex_state = 0},
  [9861] = {.lex_state = 0},
  [9862] = {.lex_state = 0},
  [9863] = {.lex_state = 0},
  [9864] = {.lex_state = 0, .external_lex_state = 7},
  [9865] = {.lex_state = 0, .external_lex_state = 7},
  [9866] = {.lex_state = 0},
  [9867] = {.lex_state = 0},
  [9868] = {.lex_state = 0, .external_lex_state = 7},
  [9869] = {.lex_state = 0, .external_lex_state = 7},
  [9870] = {.lex_state = 0, .external_lex_state = 7},
  [9871] = {.lex_state = 0},
  [9872] = {.lex_state = 0},
  [9873] = {.lex_state = 0},
  [9874] = {.lex_state = 113},
  [9875] = {.lex_state = 0, .external_lex_state = 7},
  [9876] = {.lex_state = 0},
  [9877] = {.lex_state = 0},
  [9878] = {.lex_state = 0, .external_lex_state = 7},
  [9879] = {.lex_state = 0, .external_lex_state = 7},
  [9880] = {.lex_state = 0},
  [9881] = {.lex_state = 0, .external_lex_state = 7},
  [9882] = {.lex_state = 9},
  [9883] = {.lex_state = 0},
  [9884] = {.lex_state = 0},
  [9885] = {.lex_state = 0},
  [9886] = {.lex_state = 0, .external_lex_state = 7},
  [9887] = {.lex_state = 0},
  [9888] = {.lex_state = 0, .external_lex_state = 7},
  [9889] = {.lex_state = 0},
  [9890] = {.lex_state = 0},
  [9891] = {.lex_state = 0},
  [9892] = {.lex_state = 0},
  [9893] = {.lex_state = 0},
  [9894] = {.lex_state = 0},
  [9895] = {.lex_state = 0},
  [9896] = {.lex_state = 0},
  [9897] = {.lex_state = 0},
  [9898] = {.lex_state = 0},
  [9899] = {.lex_state = 0},
  [9900] = {.lex_state = 0},
  [9901] = {.lex_state = 0},
  [9902] = {.lex_state = 0},
  [9903] = {.lex_state = 0},
  [9904] = {.lex_state = 113},
  [9905] = {.lex_state = 0},
  [9906] = {.lex_state = 0},
  [9907] = {.lex_state = 0},
  [9908] = {.lex_state = 0},
  [9909] = {.lex_state = 0},
  [9910] = {.lex_state = 0},
  [9911] = {.lex_state = 0},
  [9912] = {.lex_state = 0},
  [9913] = {.lex_state = 0},
  [9914] = {.lex_state = 0},
  [9915] = {.lex_state = 0},
  [9916] = {.lex_state = 113},
  [9917] = {.lex_state = 0, .external_lex_state = 8},
  [9918] = {.lex_state = 4},
  [9919] = {.lex_state = 0},
  [9920] = {.lex_state = 4},
  [9921] = {.lex_state = 0},
  [9922] = {.lex_state = 0},
  [9923] = {.lex_state = 113},
  [9924] = {.lex_state = 21},
  [9925] = {.lex_state = 113},
  [9926] = {.lex_state = 21},
  [9927] = {.lex_state = 113},
  [9928] = {.lex_state = 113},
  [9929] = {.lex_state = 21},
  [9930] = {.lex_state = 0},
  [9931] = {.lex_state = 0},
  [9932] = {.lex_state = 0},
  [9933] = {.lex_state = 113},
  [9934] = {.lex_state = 0},
  [9935] = {.lex_state = 0},
  [9936] = {.lex_state = 1},
  [9937] = {(TSStateId)(-1)},
  [9938] = {(TSStateId)(-1)},
  [9939] = {(TSStateId)(-1)},
  [9940] = {(TSStateId)(-1)},
  [9941] = {(TSStateId)(-1)},
  [9942] = {(TSStateId)(-1)},
  [9943] = {(TSStateId)(-1)},
  [9944] = {(TSStateId)(-1)},
  [9945] = {(TSStateId)(-1)},
  [9946] = {(TSStateId)(-1)},
  [9947] = {(TSStateId)(-1)},
  [9948] = {(TSStateId)(-1)},
  [9949] = {(TSStateId)(-1)},
  [9950] = {(TSStateId)(-1)},
  [9951] = {(TSStateId)(-1)},
  [9952] = {(TSStateId)(-1)},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [sym_preproc_region] = STATE(0),
    [sym_preproc_endregion] = STATE(0),
    [sym_preproc_line] = STATE(0),
    [sym_preproc_pragma] = STATE(0),
    [sym_preproc_nullable] = STATE(0),
    [sym_preproc_error] = STATE(0),
    [sym_preproc_define] = STATE(0),
    [sym_preproc_undef] = STATE(0),
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym__identifier_token] = ACTIONS(1),
    [anon_sym_extern] = ACTIONS(1),
    [anon_sym_alias] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_global] = ACTIONS(1),
    [anon_sym_using] = ACTIONS(1),
    [anon_sym_unsafe] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_static] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_assembly] = ACTIONS(1),
    [anon_sym_module] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_field] = ACTIONS(1),
    [anon_sym_event] = ACTIONS(1),
    [anon_sym_method] = ACTIONS(1),
    [anon_sym_param] = ACTIONS(1),
    [anon_sym_property] = ACTIONS(1),
    [anon_sym_return] = ACTIONS(1),
    [anon_sym_type] = ACTIONS(1),
    [anon_sym_namespace] = ACTIONS(1),
    [anon_sym_class] = ACTIONS(1),
    [anon_sym_ref] = ACTIONS(1),
    [anon_sym_struct] = ACTIONS(1),
    [anon_sym_enum] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_interface] = ACTIONS(1),
    [anon_sym_delegate] = ACTIONS(1),
    [anon_sym_record] = ACTIONS(1),
    [anon_sym_abstract] = ACTIONS(1),
    [anon_sym_async] = ACTIONS(1),
    [anon_sym_const] = ACTIONS(1),
    [anon_sym_file] = ACTIONS(1),
    [anon_sym_fixed] = ACTIONS(1),
    [anon_sym_internal] = ACTIONS(1),
    [anon_sym_new] = ACTIONS(1),
    [anon_sym_override] = ACTIONS(1),
    [anon_sym_partial] = ACTIONS(1),
    [anon_sym_private] = ACTIONS(1),
    [anon_sym_protected] = ACTIONS(1),
    [anon_sym_public] = ACTIONS(1),
    [anon_sym_readonly] = ACTIONS(1),
    [anon_sym_required] = ACTIONS(1),
    [anon_sym_sealed] = ACTIONS(1),
    [anon_sym_virtual] = ACTIONS(1),
    [anon_sym_volatile] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
    [anon_sym_out] = ACTIONS(1),
    [anon_sym_where] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_notnull] = ACTIONS(1),
    [anon_sym_unmanaged] = ACTIONS(1),
    [anon_sym_operator] = ACTIONS(1),
    [anon_sym_checked] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_PLUS_PLUS] = ACTIONS(1),
    [anon_sym_DASH_DASH] = ACTIONS(1),
    [anon_sym_true] = ACTIONS(1),
    [anon_sym_false] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_GT_GT_GT] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_implicit] = ACTIONS(1),
    [anon_sym_explicit] = ACTIONS(1),
    [anon_sym_get] = ACTIONS(1),
    [anon_sym_set] = ACTIONS(1),
    [anon_sym_add] = ACTIONS(1),
    [anon_sym_remove] = ACTIONS(1),
    [anon_sym_init] = ACTIONS(1),
    [anon_sym_this] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_scoped] = ACTIONS(1),
    [anon_sym_params] = ACTIONS(1),
    [anon_sym_base] = ACTIONS(1),
    [anon_sym_EQ_GT] = ACTIONS(1),
    [anon_sym_COLON_COLON] = ACTIONS(1),
    [anon_sym_var] = ACTIONS(1),
    [anon_sym_managed] = ACTIONS(1),
    [anon_sym_Cdecl] = ACTIONS(1),
    [anon_sym_Stdcall] = ACTIONS(1),
    [anon_sym_Thiscall] = ACTIONS(1),
    [anon_sym_Fastcall] = ACTIONS(1),
    [sym_predefined_type] = ACTIONS(1),
    [anon_sym_break] = ACTIONS(1),
    [anon_sym_unchecked] = ACTIONS(1),
    [anon_sym_continue] = ACTIONS(1),
    [anon_sym_do] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_lock] = ACTIONS(1),
    [anon_sym_yield] = ACTIONS(1),
    [anon_sym_switch] = ACTIONS(1),
    [anon_sym_case] = ACTIONS(1),
    [anon_sym_default] = ACTIONS(1),
    [anon_sym_throw] = ACTIONS(1),
    [anon_sym_try] = ACTIONS(1),
    [anon_sym_catch] = ACTIONS(1),
    [anon_sym_when] = ACTIONS(1),
    [anon_sym_finally] = ACTIONS(1),
    [anon_sym_await] = ACTIONS(1),
    [anon_sym_foreach] = ACTIONS(1),
    [anon_sym_goto] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [sym_discard] = ACTIONS(1),
    [anon_sym_DOT_DOT] = ACTIONS(1),
    [anon_sym_not] = ACTIONS(1),
    [anon_sym_and] = ACTIONS(1),
    [anon_sym_or] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_DASH_EQ] = ACTIONS(1),
    [anon_sym_STAR_EQ] = ACTIONS(1),
    [anon_sym_SLASH_EQ] = ACTIONS(1),
    [anon_sym_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_AMP_EQ] = ACTIONS(1),
    [anon_sym_CARET_EQ] = ACTIONS(1),
    [anon_sym_PIPE_EQ] = ACTIONS(1),
    [anon_sym_LT_LT_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_QMARK_QMARK] = ACTIONS(1),
    [anon_sym_from] = ACTIONS(1),
    [anon_sym_into] = ACTIONS(1),
    [anon_sym_join] = ACTIONS(1),
    [anon_sym_on] = ACTIONS(1),
    [anon_sym_equals] = ACTIONS(1),
    [anon_sym_let] = ACTIONS(1),
    [anon_sym_orderby] = ACTIONS(1),
    [anon_sym_ascending] = ACTIONS(1),
    [anon_sym_descending] = ACTIONS(1),
    [anon_sym_group] = ACTIONS(1),
    [anon_sym_by] = ACTIONS(1),
    [anon_sym_select] = ACTIONS(1),
    [anon_sym_as] = ACTIONS(1),
    [anon_sym_is] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [anon_sym_DASH_GT] = ACTIONS(1),
    [anon_sym_stackalloc] = ACTIONS(1),
    [anon_sym_with] = ACTIONS(1),
    [anon_sym_sizeof] = ACTIONS(1),
    [anon_sym_typeof] = ACTIONS(1),
    [anon_sym___makeref] = ACTIONS(1),
    [anon_sym___reftype] = ACTIONS(1),
    [anon_sym___refvalue] = ACTIONS(1),
    [sym_null_literal] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [sym_integer_literal] = ACTIONS(1),
    [sym_real_literal] = ACTIONS(1),
    [aux_sym_string_literal_content_token2] = ACTIONS(1),
    [sym_escape_sequence] = ACTIONS(1),
    [sym_string_literal_encoding] = ACTIONS(1),
    [sym_verbatim_string_literal] = ACTIONS(1),
    [sym_raw_string_literal] = ACTIONS(1),
    [aux_sym_preproc_if_token1] = ACTIONS(1),
    [aux_sym_preproc_if_token3] = ACTIONS(1),
    [aux_sym_preproc_else_token1] = ACTIONS(1),
    [aux_sym_preproc_elif_token1] = ACTIONS(1),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [anon_sym_hidden] = ACTIONS(1),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [anon_sym_warning] = ACTIONS(1),
    [anon_sym_disable] = ACTIONS(1),
    [anon_sym_restore] = ACTIONS(1),
    [anon_sym_checksum] = ACTIONS(1),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [anon_sym_enable] = ACTIONS(1),
    [anon_sym_annotations] = ACTIONS(1),
    [anon_sym_warnings] = ACTIONS(1),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_shebang_directive] = ACTIONS(1),
    [sym_comment] = ACTIONS(19),
    [sym__optional_semi] = ACTIONS(1),
    [sym_interpolation_regular_start] = ACTIONS(1),
    [sym_interpolation_verbatim_start] = ACTIONS(1),
    [sym_interpolation_raw_start] = ACTIONS(1),
    [sym_interpolation_start_quote] = ACTIONS(1),
    [sym_interpolation_end_quote] = ACTIONS(1),
    [sym_interpolation_open_brace] = ACTIONS(1),
    [sym_interpolation_close_brace] = ACTIONS(1),
    [sym_interpolation_string_content] = ACTIONS(1),
  },
  [1] = {
    [sym_compilation_unit] = STATE(9788),
    [sym__top_level_item] = STATE(2547),
    [sym_global_statement] = STATE(2540),
    [sym_extern_alias_directive] = STATE(2540),
    [sym_using_directive] = STATE(2540),
    [sym_global_attribute] = STATE(2540),
    [sym_attribute_list] = STATE(3753),
    [sym_namespace_declaration] = STATE(2540),
    [sym_file_scoped_namespace_declaration] = STATE(2540),
    [sym_type_declaration] = STATE(2540),
    [sym_class_declaration] = STATE(2539),
    [sym_struct_declaration] = STATE(2539),
    [sym_enum_declaration] = STATE(2539),
    [sym_interface_declaration] = STATE(2539),
    [sym_delegate_declaration] = STATE(2539),
    [sym_record_declaration] = STATE(2539),
    [sym_modifier] = STATE(3780),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2478),
    [sym_variable_declaration] = STATE(9764),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6873),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2565),
    [sym_break_statement] = STATE(2478),
    [sym_checked_statement] = STATE(2478),
    [sym_continue_statement] = STATE(2478),
    [sym_do_statement] = STATE(2478),
    [sym_empty_statement] = STATE(2478),
    [sym_expression_statement] = STATE(2478),
    [sym_fixed_statement] = STATE(2478),
    [sym_for_statement] = STATE(2478),
    [sym_return_statement] = STATE(2478),
    [sym_lock_statement] = STATE(2478),
    [sym_yield_statement] = STATE(2478),
    [sym_switch_statement] = STATE(2478),
    [sym_throw_statement] = STATE(2478),
    [sym_try_statement] = STATE(2478),
    [sym_unsafe_statement] = STATE(2478),
    [sym_using_statement] = STATE(2478),
    [sym_foreach_statement] = STATE(2478),
    [sym_goto_statement] = STATE(2478),
    [sym_labeled_statement] = STATE(2478),
    [sym_if_statement] = STATE(2478),
    [sym_while_statement] = STATE(2478),
    [sym_local_declaration_statement] = STATE(2478),
    [sym_local_function_statement] = STATE(2478),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6724),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2900),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2602),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1),
    [sym_preproc_endregion] = STATE(1),
    [sym_preproc_line] = STATE(1),
    [sym_preproc_pragma] = STATE(1),
    [sym_preproc_nullable] = STATE(1),
    [sym_preproc_error] = STATE(1),
    [sym_preproc_define] = STATE(1),
    [sym_preproc_undef] = STATE(1),
    [aux_sym_compilation_unit_repeat1] = STATE(14),
    [aux_sym_class_declaration_repeat1] = STATE(2804),
    [aux_sym_class_declaration_repeat2] = STATE(2916),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [ts_builtin_sym_end] = ACTIONS(21),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(31),
    [anon_sym_using] = ACTIONS(33),
    [anon_sym_unsafe] = ACTIONS(35),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_namespace] = ACTIONS(45),
    [anon_sym_class] = ACTIONS(47),
    [anon_sym_ref] = ACTIONS(49),
    [anon_sym_struct] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_interface] = ACTIONS(57),
    [anon_sym_delegate] = ACTIONS(59),
    [anon_sym_record] = ACTIONS(61),
    [anon_sym_abstract] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(37),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_file] = ACTIONS(65),
    [anon_sym_fixed] = ACTIONS(67),
    [anon_sym_internal] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(69),
    [anon_sym_override] = ACTIONS(63),
    [anon_sym_partial] = ACTIONS(63),
    [anon_sym_private] = ACTIONS(63),
    [anon_sym_protected] = ACTIONS(63),
    [anon_sym_public] = ACTIONS(63),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_required] = ACTIONS(63),
    [anon_sym_sealed] = ACTIONS(63),
    [anon_sym_virtual] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(71),
    [anon_sym_continue] = ACTIONS(91),
    [anon_sym_do] = ACTIONS(93),
    [anon_sym_while] = ACTIONS(95),
    [anon_sym_for] = ACTIONS(97),
    [anon_sym_lock] = ACTIONS(99),
    [anon_sym_yield] = ACTIONS(101),
    [anon_sym_switch] = ACTIONS(103),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(107),
    [anon_sym_try] = ACTIONS(109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(111),
    [anon_sym_foreach] = ACTIONS(113),
    [anon_sym_goto] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(143),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_shebang_directive] = ACTIONS(145),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [2] = {
    [sym_extern_alias_directive] = STATE(2345),
    [sym_using_directive] = STATE(2345),
    [sym_global_attribute] = STATE(2345),
    [sym_attribute_list] = STATE(3753),
    [sym_namespace_declaration] = STATE(2345),
    [sym_file_scoped_namespace_declaration] = STATE(2345),
    [sym_type_declaration] = STATE(2345),
    [sym_class_declaration] = STATE(2395),
    [sym_struct_declaration] = STATE(2395),
    [sym_enum_declaration] = STATE(2395),
    [sym_interface_declaration] = STATE(2395),
    [sym_delegate_declaration] = STATE(2395),
    [sym_record_declaration] = STATE(2395),
    [sym_modifier] = STATE(3780),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2220),
    [sym_variable_declaration] = STATE(9437),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6809),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2345),
    [sym_break_statement] = STATE(2220),
    [sym_checked_statement] = STATE(2220),
    [sym_continue_statement] = STATE(2220),
    [sym_do_statement] = STATE(2220),
    [sym_empty_statement] = STATE(2220),
    [sym_expression_statement] = STATE(2220),
    [sym_fixed_statement] = STATE(2220),
    [sym_for_statement] = STATE(2220),
    [sym_return_statement] = STATE(2220),
    [sym_lock_statement] = STATE(2220),
    [sym_yield_statement] = STATE(2220),
    [sym_switch_statement] = STATE(2220),
    [sym_throw_statement] = STATE(2220),
    [sym_try_statement] = STATE(2220),
    [sym_unsafe_statement] = STATE(2220),
    [sym_using_statement] = STATE(2220),
    [sym_foreach_statement] = STATE(2220),
    [sym_goto_statement] = STATE(2220),
    [sym_labeled_statement] = STATE(2220),
    [sym_if_statement] = STATE(2220),
    [sym_while_statement] = STATE(2220),
    [sym_local_declaration_statement] = STATE(2220),
    [sym_local_function_statement] = STATE(2220),
    [sym_expression] = STATE(5284),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6150),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2819),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2346),
    [sym_preproc_else_in_top_level] = STATE(9047),
    [sym_preproc_elif_in_top_level] = STATE(9047),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_else_in_expression] = STATE(9419),
    [sym_preproc_elif_in_expression] = STATE(9419),
    [sym_preproc_region] = STATE(2),
    [sym_preproc_endregion] = STATE(2),
    [sym_preproc_line] = STATE(2),
    [sym_preproc_pragma] = STATE(2),
    [sym_preproc_nullable] = STATE(2),
    [sym_preproc_error] = STATE(2),
    [sym_preproc_define] = STATE(2),
    [sym_preproc_undef] = STATE(2),
    [aux_sym_class_declaration_repeat1] = STATE(2800),
    [aux_sym_class_declaration_repeat2] = STATE(2922),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [aux_sym_preproc_if_in_top_level_repeat1] = STATE(10),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(153),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(155),
    [anon_sym_global] = ACTIONS(157),
    [anon_sym_using] = ACTIONS(159),
    [anon_sym_unsafe] = ACTIONS(161),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(165),
    [anon_sym_namespace] = ACTIONS(167),
    [anon_sym_class] = ACTIONS(169),
    [anon_sym_ref] = ACTIONS(171),
    [anon_sym_struct] = ACTIONS(173),
    [anon_sym_enum] = ACTIONS(175),
    [anon_sym_LBRACE] = ACTIONS(177),
    [anon_sym_interface] = ACTIONS(179),
    [anon_sym_delegate] = ACTIONS(181),
    [anon_sym_record] = ACTIONS(183),
    [anon_sym_abstract] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(37),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_file] = ACTIONS(65),
    [anon_sym_fixed] = ACTIONS(185),
    [anon_sym_internal] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(69),
    [anon_sym_override] = ACTIONS(63),
    [anon_sym_partial] = ACTIONS(63),
    [anon_sym_private] = ACTIONS(63),
    [anon_sym_protected] = ACTIONS(63),
    [anon_sym_public] = ACTIONS(63),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_required] = ACTIONS(63),
    [anon_sym_sealed] = ACTIONS(63),
    [anon_sym_virtual] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(187),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(189),
    [anon_sym_unchecked] = ACTIONS(187),
    [anon_sym_continue] = ACTIONS(191),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_while] = ACTIONS(195),
    [anon_sym_for] = ACTIONS(197),
    [anon_sym_lock] = ACTIONS(199),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(205),
    [anon_sym_try] = ACTIONS(207),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(209),
    [anon_sym_foreach] = ACTIONS(211),
    [anon_sym_goto] = ACTIONS(213),
    [anon_sym_if] = ACTIONS(215),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(217),
    [aux_sym_preproc_if_token3] = ACTIONS(219),
    [aux_sym_preproc_else_token1] = ACTIONS(221),
    [aux_sym_preproc_elif_token1] = ACTIONS(223),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [3] = {
    [sym_extern_alias_directive] = STATE(2345),
    [sym_using_directive] = STATE(2345),
    [sym_global_attribute] = STATE(2345),
    [sym_attribute_list] = STATE(3753),
    [sym_namespace_declaration] = STATE(2345),
    [sym_file_scoped_namespace_declaration] = STATE(2345),
    [sym_type_declaration] = STATE(2345),
    [sym_class_declaration] = STATE(2395),
    [sym_struct_declaration] = STATE(2395),
    [sym_enum_declaration] = STATE(2395),
    [sym_interface_declaration] = STATE(2395),
    [sym_delegate_declaration] = STATE(2395),
    [sym_record_declaration] = STATE(2395),
    [sym_modifier] = STATE(3780),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2220),
    [sym_variable_declaration] = STATE(9437),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6809),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2345),
    [sym_break_statement] = STATE(2220),
    [sym_checked_statement] = STATE(2220),
    [sym_continue_statement] = STATE(2220),
    [sym_do_statement] = STATE(2220),
    [sym_empty_statement] = STATE(2220),
    [sym_expression_statement] = STATE(2220),
    [sym_fixed_statement] = STATE(2220),
    [sym_for_statement] = STATE(2220),
    [sym_return_statement] = STATE(2220),
    [sym_lock_statement] = STATE(2220),
    [sym_yield_statement] = STATE(2220),
    [sym_switch_statement] = STATE(2220),
    [sym_throw_statement] = STATE(2220),
    [sym_try_statement] = STATE(2220),
    [sym_unsafe_statement] = STATE(2220),
    [sym_using_statement] = STATE(2220),
    [sym_foreach_statement] = STATE(2220),
    [sym_goto_statement] = STATE(2220),
    [sym_labeled_statement] = STATE(2220),
    [sym_if_statement] = STATE(2220),
    [sym_while_statement] = STATE(2220),
    [sym_local_declaration_statement] = STATE(2220),
    [sym_local_function_statement] = STATE(2220),
    [sym_expression] = STATE(5284),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6150),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2819),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2346),
    [sym_preproc_else_in_top_level] = STATE(8978),
    [sym_preproc_elif_in_top_level] = STATE(8978),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_else_in_expression] = STATE(9419),
    [sym_preproc_elif_in_expression] = STATE(9419),
    [sym_preproc_region] = STATE(3),
    [sym_preproc_endregion] = STATE(3),
    [sym_preproc_line] = STATE(3),
    [sym_preproc_pragma] = STATE(3),
    [sym_preproc_nullable] = STATE(3),
    [sym_preproc_error] = STATE(3),
    [sym_preproc_define] = STATE(3),
    [sym_preproc_undef] = STATE(3),
    [aux_sym_class_declaration_repeat1] = STATE(2800),
    [aux_sym_class_declaration_repeat2] = STATE(2922),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [aux_sym_preproc_if_in_top_level_repeat1] = STATE(12),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(153),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(155),
    [anon_sym_global] = ACTIONS(157),
    [anon_sym_using] = ACTIONS(159),
    [anon_sym_unsafe] = ACTIONS(161),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(165),
    [anon_sym_namespace] = ACTIONS(167),
    [anon_sym_class] = ACTIONS(169),
    [anon_sym_ref] = ACTIONS(171),
    [anon_sym_struct] = ACTIONS(173),
    [anon_sym_enum] = ACTIONS(175),
    [anon_sym_LBRACE] = ACTIONS(177),
    [anon_sym_interface] = ACTIONS(179),
    [anon_sym_delegate] = ACTIONS(181),
    [anon_sym_record] = ACTIONS(183),
    [anon_sym_abstract] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(37),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_file] = ACTIONS(65),
    [anon_sym_fixed] = ACTIONS(185),
    [anon_sym_internal] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(69),
    [anon_sym_override] = ACTIONS(63),
    [anon_sym_partial] = ACTIONS(63),
    [anon_sym_private] = ACTIONS(63),
    [anon_sym_protected] = ACTIONS(63),
    [anon_sym_public] = ACTIONS(63),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_required] = ACTIONS(63),
    [anon_sym_sealed] = ACTIONS(63),
    [anon_sym_virtual] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(187),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(189),
    [anon_sym_unchecked] = ACTIONS(187),
    [anon_sym_continue] = ACTIONS(191),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_while] = ACTIONS(195),
    [anon_sym_for] = ACTIONS(197),
    [anon_sym_lock] = ACTIONS(199),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(205),
    [anon_sym_try] = ACTIONS(207),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(209),
    [anon_sym_foreach] = ACTIONS(211),
    [anon_sym_goto] = ACTIONS(213),
    [anon_sym_if] = ACTIONS(215),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(217),
    [aux_sym_preproc_if_token3] = ACTIONS(225),
    [aux_sym_preproc_else_token1] = ACTIONS(221),
    [aux_sym_preproc_elif_token1] = ACTIONS(223),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [4] = {
    [sym_extern_alias_directive] = STATE(2345),
    [sym_using_directive] = STATE(2345),
    [sym_global_attribute] = STATE(2345),
    [sym_attribute_list] = STATE(3753),
    [sym_namespace_declaration] = STATE(2345),
    [sym_file_scoped_namespace_declaration] = STATE(2345),
    [sym_type_declaration] = STATE(2345),
    [sym_class_declaration] = STATE(2395),
    [sym_struct_declaration] = STATE(2395),
    [sym_enum_declaration] = STATE(2395),
    [sym_interface_declaration] = STATE(2395),
    [sym_delegate_declaration] = STATE(2395),
    [sym_record_declaration] = STATE(2395),
    [sym_modifier] = STATE(3780),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2220),
    [sym_variable_declaration] = STATE(9437),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6809),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2345),
    [sym_break_statement] = STATE(2220),
    [sym_checked_statement] = STATE(2220),
    [sym_continue_statement] = STATE(2220),
    [sym_do_statement] = STATE(2220),
    [sym_empty_statement] = STATE(2220),
    [sym_expression_statement] = STATE(2220),
    [sym_fixed_statement] = STATE(2220),
    [sym_for_statement] = STATE(2220),
    [sym_return_statement] = STATE(2220),
    [sym_lock_statement] = STATE(2220),
    [sym_yield_statement] = STATE(2220),
    [sym_switch_statement] = STATE(2220),
    [sym_throw_statement] = STATE(2220),
    [sym_try_statement] = STATE(2220),
    [sym_unsafe_statement] = STATE(2220),
    [sym_using_statement] = STATE(2220),
    [sym_foreach_statement] = STATE(2220),
    [sym_goto_statement] = STATE(2220),
    [sym_labeled_statement] = STATE(2220),
    [sym_if_statement] = STATE(2220),
    [sym_while_statement] = STATE(2220),
    [sym_local_declaration_statement] = STATE(2220),
    [sym_local_function_statement] = STATE(2220),
    [sym_expression] = STATE(5327),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6150),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2819),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2346),
    [sym_preproc_else_in_top_level] = STATE(9817),
    [sym_preproc_elif_in_top_level] = STATE(9817),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_else_in_expression] = STATE(9812),
    [sym_preproc_elif_in_expression] = STATE(9812),
    [sym_preproc_region] = STATE(4),
    [sym_preproc_endregion] = STATE(4),
    [sym_preproc_line] = STATE(4),
    [sym_preproc_pragma] = STATE(4),
    [sym_preproc_nullable] = STATE(4),
    [sym_preproc_error] = STATE(4),
    [sym_preproc_define] = STATE(4),
    [sym_preproc_undef] = STATE(4),
    [aux_sym_class_declaration_repeat1] = STATE(2800),
    [aux_sym_class_declaration_repeat2] = STATE(2922),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [aux_sym_preproc_if_in_top_level_repeat1] = STATE(9),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(153),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(155),
    [anon_sym_global] = ACTIONS(157),
    [anon_sym_using] = ACTIONS(159),
    [anon_sym_unsafe] = ACTIONS(161),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(165),
    [anon_sym_namespace] = ACTIONS(167),
    [anon_sym_class] = ACTIONS(169),
    [anon_sym_ref] = ACTIONS(171),
    [anon_sym_struct] = ACTIONS(173),
    [anon_sym_enum] = ACTIONS(175),
    [anon_sym_LBRACE] = ACTIONS(177),
    [anon_sym_interface] = ACTIONS(179),
    [anon_sym_delegate] = ACTIONS(181),
    [anon_sym_record] = ACTIONS(183),
    [anon_sym_abstract] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(37),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_file] = ACTIONS(65),
    [anon_sym_fixed] = ACTIONS(185),
    [anon_sym_internal] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(69),
    [anon_sym_override] = ACTIONS(63),
    [anon_sym_partial] = ACTIONS(63),
    [anon_sym_private] = ACTIONS(63),
    [anon_sym_protected] = ACTIONS(63),
    [anon_sym_public] = ACTIONS(63),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_required] = ACTIONS(63),
    [anon_sym_sealed] = ACTIONS(63),
    [anon_sym_virtual] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(187),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(189),
    [anon_sym_unchecked] = ACTIONS(187),
    [anon_sym_continue] = ACTIONS(191),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_while] = ACTIONS(195),
    [anon_sym_for] = ACTIONS(197),
    [anon_sym_lock] = ACTIONS(199),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(205),
    [anon_sym_try] = ACTIONS(207),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(209),
    [anon_sym_foreach] = ACTIONS(211),
    [anon_sym_goto] = ACTIONS(213),
    [anon_sym_if] = ACTIONS(215),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(217),
    [aux_sym_preproc_if_token3] = ACTIONS(227),
    [aux_sym_preproc_else_token1] = ACTIONS(221),
    [aux_sym_preproc_elif_token1] = ACTIONS(223),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [5] = {
    [sym_extern_alias_directive] = STATE(2345),
    [sym_using_directive] = STATE(2345),
    [sym_global_attribute] = STATE(2345),
    [sym_attribute_list] = STATE(3753),
    [sym_namespace_declaration] = STATE(2345),
    [sym_file_scoped_namespace_declaration] = STATE(2345),
    [sym_type_declaration] = STATE(2345),
    [sym_class_declaration] = STATE(2395),
    [sym_struct_declaration] = STATE(2395),
    [sym_enum_declaration] = STATE(2395),
    [sym_interface_declaration] = STATE(2395),
    [sym_delegate_declaration] = STATE(2395),
    [sym_record_declaration] = STATE(2395),
    [sym_modifier] = STATE(3780),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2220),
    [sym_variable_declaration] = STATE(9437),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6809),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2345),
    [sym_break_statement] = STATE(2220),
    [sym_checked_statement] = STATE(2220),
    [sym_continue_statement] = STATE(2220),
    [sym_do_statement] = STATE(2220),
    [sym_empty_statement] = STATE(2220),
    [sym_expression_statement] = STATE(2220),
    [sym_fixed_statement] = STATE(2220),
    [sym_for_statement] = STATE(2220),
    [sym_return_statement] = STATE(2220),
    [sym_lock_statement] = STATE(2220),
    [sym_yield_statement] = STATE(2220),
    [sym_switch_statement] = STATE(2220),
    [sym_throw_statement] = STATE(2220),
    [sym_try_statement] = STATE(2220),
    [sym_unsafe_statement] = STATE(2220),
    [sym_using_statement] = STATE(2220),
    [sym_foreach_statement] = STATE(2220),
    [sym_goto_statement] = STATE(2220),
    [sym_labeled_statement] = STATE(2220),
    [sym_if_statement] = STATE(2220),
    [sym_while_statement] = STATE(2220),
    [sym_local_declaration_statement] = STATE(2220),
    [sym_local_function_statement] = STATE(2220),
    [sym_expression] = STATE(5284),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6150),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2819),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2346),
    [sym_preproc_else_in_top_level] = STATE(9579),
    [sym_preproc_elif_in_top_level] = STATE(9579),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_else_in_expression] = STATE(9419),
    [sym_preproc_elif_in_expression] = STATE(9419),
    [sym_preproc_region] = STATE(5),
    [sym_preproc_endregion] = STATE(5),
    [sym_preproc_line] = STATE(5),
    [sym_preproc_pragma] = STATE(5),
    [sym_preproc_nullable] = STATE(5),
    [sym_preproc_error] = STATE(5),
    [sym_preproc_define] = STATE(5),
    [sym_preproc_undef] = STATE(5),
    [aux_sym_class_declaration_repeat1] = STATE(2800),
    [aux_sym_class_declaration_repeat2] = STATE(2922),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [aux_sym_preproc_if_in_top_level_repeat1] = STATE(7),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(153),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(155),
    [anon_sym_global] = ACTIONS(157),
    [anon_sym_using] = ACTIONS(159),
    [anon_sym_unsafe] = ACTIONS(161),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(165),
    [anon_sym_namespace] = ACTIONS(167),
    [anon_sym_class] = ACTIONS(169),
    [anon_sym_ref] = ACTIONS(171),
    [anon_sym_struct] = ACTIONS(173),
    [anon_sym_enum] = ACTIONS(175),
    [anon_sym_LBRACE] = ACTIONS(177),
    [anon_sym_interface] = ACTIONS(179),
    [anon_sym_delegate] = ACTIONS(181),
    [anon_sym_record] = ACTIONS(183),
    [anon_sym_abstract] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(37),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_file] = ACTIONS(65),
    [anon_sym_fixed] = ACTIONS(185),
    [anon_sym_internal] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(69),
    [anon_sym_override] = ACTIONS(63),
    [anon_sym_partial] = ACTIONS(63),
    [anon_sym_private] = ACTIONS(63),
    [anon_sym_protected] = ACTIONS(63),
    [anon_sym_public] = ACTIONS(63),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_required] = ACTIONS(63),
    [anon_sym_sealed] = ACTIONS(63),
    [anon_sym_virtual] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(187),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(189),
    [anon_sym_unchecked] = ACTIONS(187),
    [anon_sym_continue] = ACTIONS(191),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_while] = ACTIONS(195),
    [anon_sym_for] = ACTIONS(197),
    [anon_sym_lock] = ACTIONS(199),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(205),
    [anon_sym_try] = ACTIONS(207),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(209),
    [anon_sym_foreach] = ACTIONS(211),
    [anon_sym_goto] = ACTIONS(213),
    [anon_sym_if] = ACTIONS(215),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(217),
    [aux_sym_preproc_if_token3] = ACTIONS(229),
    [aux_sym_preproc_else_token1] = ACTIONS(221),
    [aux_sym_preproc_elif_token1] = ACTIONS(223),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [6] = {
    [sym_extern_alias_directive] = STATE(2345),
    [sym_using_directive] = STATE(2345),
    [sym_global_attribute] = STATE(2345),
    [sym_attribute_list] = STATE(3753),
    [sym_namespace_declaration] = STATE(2345),
    [sym_file_scoped_namespace_declaration] = STATE(2345),
    [sym_type_declaration] = STATE(2345),
    [sym_class_declaration] = STATE(2395),
    [sym_struct_declaration] = STATE(2395),
    [sym_enum_declaration] = STATE(2395),
    [sym_interface_declaration] = STATE(2395),
    [sym_delegate_declaration] = STATE(2395),
    [sym_record_declaration] = STATE(2395),
    [sym_modifier] = STATE(3780),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2220),
    [sym_variable_declaration] = STATE(9437),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6809),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2345),
    [sym_break_statement] = STATE(2220),
    [sym_checked_statement] = STATE(2220),
    [sym_continue_statement] = STATE(2220),
    [sym_do_statement] = STATE(2220),
    [sym_empty_statement] = STATE(2220),
    [sym_expression_statement] = STATE(2220),
    [sym_fixed_statement] = STATE(2220),
    [sym_for_statement] = STATE(2220),
    [sym_return_statement] = STATE(2220),
    [sym_lock_statement] = STATE(2220),
    [sym_yield_statement] = STATE(2220),
    [sym_switch_statement] = STATE(2220),
    [sym_throw_statement] = STATE(2220),
    [sym_try_statement] = STATE(2220),
    [sym_unsafe_statement] = STATE(2220),
    [sym_using_statement] = STATE(2220),
    [sym_foreach_statement] = STATE(2220),
    [sym_goto_statement] = STATE(2220),
    [sym_labeled_statement] = STATE(2220),
    [sym_if_statement] = STATE(2220),
    [sym_while_statement] = STATE(2220),
    [sym_local_declaration_statement] = STATE(2220),
    [sym_local_function_statement] = STATE(2220),
    [sym_expression] = STATE(5284),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6150),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2819),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2346),
    [sym_preproc_else_in_top_level] = STATE(9414),
    [sym_preproc_elif_in_top_level] = STATE(9414),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_else_in_expression] = STATE(9419),
    [sym_preproc_elif_in_expression] = STATE(9419),
    [sym_preproc_region] = STATE(6),
    [sym_preproc_endregion] = STATE(6),
    [sym_preproc_line] = STATE(6),
    [sym_preproc_pragma] = STATE(6),
    [sym_preproc_nullable] = STATE(6),
    [sym_preproc_error] = STATE(6),
    [sym_preproc_define] = STATE(6),
    [sym_preproc_undef] = STATE(6),
    [aux_sym_class_declaration_repeat1] = STATE(2800),
    [aux_sym_class_declaration_repeat2] = STATE(2922),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [aux_sym_preproc_if_in_top_level_repeat1] = STATE(11),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(153),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(155),
    [anon_sym_global] = ACTIONS(157),
    [anon_sym_using] = ACTIONS(159),
    [anon_sym_unsafe] = ACTIONS(161),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(165),
    [anon_sym_namespace] = ACTIONS(167),
    [anon_sym_class] = ACTIONS(169),
    [anon_sym_ref] = ACTIONS(171),
    [anon_sym_struct] = ACTIONS(173),
    [anon_sym_enum] = ACTIONS(175),
    [anon_sym_LBRACE] = ACTIONS(177),
    [anon_sym_interface] = ACTIONS(179),
    [anon_sym_delegate] = ACTIONS(181),
    [anon_sym_record] = ACTIONS(183),
    [anon_sym_abstract] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(37),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_file] = ACTIONS(65),
    [anon_sym_fixed] = ACTIONS(185),
    [anon_sym_internal] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(69),
    [anon_sym_override] = ACTIONS(63),
    [anon_sym_partial] = ACTIONS(63),
    [anon_sym_private] = ACTIONS(63),
    [anon_sym_protected] = ACTIONS(63),
    [anon_sym_public] = ACTIONS(63),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_required] = ACTIONS(63),
    [anon_sym_sealed] = ACTIONS(63),
    [anon_sym_virtual] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(187),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(189),
    [anon_sym_unchecked] = ACTIONS(187),
    [anon_sym_continue] = ACTIONS(191),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_while] = ACTIONS(195),
    [anon_sym_for] = ACTIONS(197),
    [anon_sym_lock] = ACTIONS(199),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(205),
    [anon_sym_try] = ACTIONS(207),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(209),
    [anon_sym_foreach] = ACTIONS(211),
    [anon_sym_goto] = ACTIONS(213),
    [anon_sym_if] = ACTIONS(215),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(217),
    [aux_sym_preproc_if_token3] = ACTIONS(231),
    [aux_sym_preproc_else_token1] = ACTIONS(221),
    [aux_sym_preproc_elif_token1] = ACTIONS(223),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [7] = {
    [sym_extern_alias_directive] = STATE(2345),
    [sym_using_directive] = STATE(2345),
    [sym_global_attribute] = STATE(2345),
    [sym_attribute_list] = STATE(3753),
    [sym_namespace_declaration] = STATE(2345),
    [sym_file_scoped_namespace_declaration] = STATE(2345),
    [sym_type_declaration] = STATE(2345),
    [sym_class_declaration] = STATE(2395),
    [sym_struct_declaration] = STATE(2395),
    [sym_enum_declaration] = STATE(2395),
    [sym_interface_declaration] = STATE(2395),
    [sym_delegate_declaration] = STATE(2395),
    [sym_record_declaration] = STATE(2395),
    [sym_modifier] = STATE(3780),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2220),
    [sym_variable_declaration] = STATE(9437),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6809),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2345),
    [sym_break_statement] = STATE(2220),
    [sym_checked_statement] = STATE(2220),
    [sym_continue_statement] = STATE(2220),
    [sym_do_statement] = STATE(2220),
    [sym_empty_statement] = STATE(2220),
    [sym_expression_statement] = STATE(2220),
    [sym_fixed_statement] = STATE(2220),
    [sym_for_statement] = STATE(2220),
    [sym_return_statement] = STATE(2220),
    [sym_lock_statement] = STATE(2220),
    [sym_yield_statement] = STATE(2220),
    [sym_switch_statement] = STATE(2220),
    [sym_throw_statement] = STATE(2220),
    [sym_try_statement] = STATE(2220),
    [sym_unsafe_statement] = STATE(2220),
    [sym_using_statement] = STATE(2220),
    [sym_foreach_statement] = STATE(2220),
    [sym_goto_statement] = STATE(2220),
    [sym_labeled_statement] = STATE(2220),
    [sym_if_statement] = STATE(2220),
    [sym_while_statement] = STATE(2220),
    [sym_local_declaration_statement] = STATE(2220),
    [sym_local_function_statement] = STATE(2220),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6150),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2819),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2346),
    [sym_preproc_else_in_top_level] = STATE(9622),
    [sym_preproc_elif_in_top_level] = STATE(9622),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(7),
    [sym_preproc_endregion] = STATE(7),
    [sym_preproc_line] = STATE(7),
    [sym_preproc_pragma] = STATE(7),
    [sym_preproc_nullable] = STATE(7),
    [sym_preproc_error] = STATE(7),
    [sym_preproc_define] = STATE(7),
    [sym_preproc_undef] = STATE(7),
    [aux_sym_class_declaration_repeat1] = STATE(2800),
    [aux_sym_class_declaration_repeat2] = STATE(2922),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [aux_sym_preproc_if_in_top_level_repeat1] = STATE(17),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(153),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(155),
    [anon_sym_global] = ACTIONS(157),
    [anon_sym_using] = ACTIONS(159),
    [anon_sym_unsafe] = ACTIONS(161),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(165),
    [anon_sym_namespace] = ACTIONS(167),
    [anon_sym_class] = ACTIONS(169),
    [anon_sym_ref] = ACTIONS(171),
    [anon_sym_struct] = ACTIONS(173),
    [anon_sym_enum] = ACTIONS(175),
    [anon_sym_LBRACE] = ACTIONS(177),
    [anon_sym_interface] = ACTIONS(179),
    [anon_sym_delegate] = ACTIONS(181),
    [anon_sym_record] = ACTIONS(183),
    [anon_sym_abstract] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(37),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_file] = ACTIONS(65),
    [anon_sym_fixed] = ACTIONS(185),
    [anon_sym_internal] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(69),
    [anon_sym_override] = ACTIONS(63),
    [anon_sym_partial] = ACTIONS(63),
    [anon_sym_private] = ACTIONS(63),
    [anon_sym_protected] = ACTIONS(63),
    [anon_sym_public] = ACTIONS(63),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_required] = ACTIONS(63),
    [anon_sym_sealed] = ACTIONS(63),
    [anon_sym_virtual] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(187),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(189),
    [anon_sym_unchecked] = ACTIONS(187),
    [anon_sym_continue] = ACTIONS(191),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_while] = ACTIONS(195),
    [anon_sym_for] = ACTIONS(197),
    [anon_sym_lock] = ACTIONS(199),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(205),
    [anon_sym_try] = ACTIONS(207),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(209),
    [anon_sym_foreach] = ACTIONS(211),
    [anon_sym_goto] = ACTIONS(213),
    [anon_sym_if] = ACTIONS(215),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(217),
    [aux_sym_preproc_if_token3] = ACTIONS(233),
    [aux_sym_preproc_else_token1] = ACTIONS(235),
    [aux_sym_preproc_elif_token1] = ACTIONS(237),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [8] = {
    [sym_extern_alias_directive] = STATE(2345),
    [sym_using_directive] = STATE(2345),
    [sym_global_attribute] = STATE(2345),
    [sym_attribute_list] = STATE(3753),
    [sym_namespace_declaration] = STATE(2345),
    [sym_file_scoped_namespace_declaration] = STATE(2345),
    [sym_type_declaration] = STATE(2345),
    [sym_class_declaration] = STATE(2395),
    [sym_struct_declaration] = STATE(2395),
    [sym_enum_declaration] = STATE(2395),
    [sym_interface_declaration] = STATE(2395),
    [sym_delegate_declaration] = STATE(2395),
    [sym_record_declaration] = STATE(2395),
    [sym_modifier] = STATE(3780),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2220),
    [sym_variable_declaration] = STATE(9437),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6809),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2345),
    [sym_break_statement] = STATE(2220),
    [sym_checked_statement] = STATE(2220),
    [sym_continue_statement] = STATE(2220),
    [sym_do_statement] = STATE(2220),
    [sym_empty_statement] = STATE(2220),
    [sym_expression_statement] = STATE(2220),
    [sym_fixed_statement] = STATE(2220),
    [sym_for_statement] = STATE(2220),
    [sym_return_statement] = STATE(2220),
    [sym_lock_statement] = STATE(2220),
    [sym_yield_statement] = STATE(2220),
    [sym_switch_statement] = STATE(2220),
    [sym_throw_statement] = STATE(2220),
    [sym_try_statement] = STATE(2220),
    [sym_unsafe_statement] = STATE(2220),
    [sym_using_statement] = STATE(2220),
    [sym_foreach_statement] = STATE(2220),
    [sym_goto_statement] = STATE(2220),
    [sym_labeled_statement] = STATE(2220),
    [sym_if_statement] = STATE(2220),
    [sym_while_statement] = STATE(2220),
    [sym_local_declaration_statement] = STATE(2220),
    [sym_local_function_statement] = STATE(2220),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6150),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2819),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2346),
    [sym_preproc_else_in_top_level] = STATE(9817),
    [sym_preproc_elif_in_top_level] = STATE(9817),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(8),
    [sym_preproc_endregion] = STATE(8),
    [sym_preproc_line] = STATE(8),
    [sym_preproc_pragma] = STATE(8),
    [sym_preproc_nullable] = STATE(8),
    [sym_preproc_error] = STATE(8),
    [sym_preproc_define] = STATE(8),
    [sym_preproc_undef] = STATE(8),
    [aux_sym_class_declaration_repeat1] = STATE(2800),
    [aux_sym_class_declaration_repeat2] = STATE(2922),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [aux_sym_preproc_if_in_top_level_repeat1] = STATE(9),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(153),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(155),
    [anon_sym_global] = ACTIONS(157),
    [anon_sym_using] = ACTIONS(159),
    [anon_sym_unsafe] = ACTIONS(161),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(165),
    [anon_sym_namespace] = ACTIONS(167),
    [anon_sym_class] = ACTIONS(169),
    [anon_sym_ref] = ACTIONS(171),
    [anon_sym_struct] = ACTIONS(173),
    [anon_sym_enum] = ACTIONS(175),
    [anon_sym_LBRACE] = ACTIONS(177),
    [anon_sym_interface] = ACTIONS(179),
    [anon_sym_delegate] = ACTIONS(181),
    [anon_sym_record] = ACTIONS(183),
    [anon_sym_abstract] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(37),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_file] = ACTIONS(65),
    [anon_sym_fixed] = ACTIONS(185),
    [anon_sym_internal] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(69),
    [anon_sym_override] = ACTIONS(63),
    [anon_sym_partial] = ACTIONS(63),
    [anon_sym_private] = ACTIONS(63),
    [anon_sym_protected] = ACTIONS(63),
    [anon_sym_public] = ACTIONS(63),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_required] = ACTIONS(63),
    [anon_sym_sealed] = ACTIONS(63),
    [anon_sym_virtual] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(187),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(189),
    [anon_sym_unchecked] = ACTIONS(187),
    [anon_sym_continue] = ACTIONS(191),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_while] = ACTIONS(195),
    [anon_sym_for] = ACTIONS(197),
    [anon_sym_lock] = ACTIONS(199),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(205),
    [anon_sym_try] = ACTIONS(207),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(209),
    [anon_sym_foreach] = ACTIONS(211),
    [anon_sym_goto] = ACTIONS(213),
    [anon_sym_if] = ACTIONS(215),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(217),
    [aux_sym_preproc_if_token3] = ACTIONS(227),
    [aux_sym_preproc_else_token1] = ACTIONS(235),
    [aux_sym_preproc_elif_token1] = ACTIONS(237),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [9] = {
    [sym_extern_alias_directive] = STATE(2345),
    [sym_using_directive] = STATE(2345),
    [sym_global_attribute] = STATE(2345),
    [sym_attribute_list] = STATE(3753),
    [sym_namespace_declaration] = STATE(2345),
    [sym_file_scoped_namespace_declaration] = STATE(2345),
    [sym_type_declaration] = STATE(2345),
    [sym_class_declaration] = STATE(2395),
    [sym_struct_declaration] = STATE(2395),
    [sym_enum_declaration] = STATE(2395),
    [sym_interface_declaration] = STATE(2395),
    [sym_delegate_declaration] = STATE(2395),
    [sym_record_declaration] = STATE(2395),
    [sym_modifier] = STATE(3780),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2220),
    [sym_variable_declaration] = STATE(9437),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6809),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2345),
    [sym_break_statement] = STATE(2220),
    [sym_checked_statement] = STATE(2220),
    [sym_continue_statement] = STATE(2220),
    [sym_do_statement] = STATE(2220),
    [sym_empty_statement] = STATE(2220),
    [sym_expression_statement] = STATE(2220),
    [sym_fixed_statement] = STATE(2220),
    [sym_for_statement] = STATE(2220),
    [sym_return_statement] = STATE(2220),
    [sym_lock_statement] = STATE(2220),
    [sym_yield_statement] = STATE(2220),
    [sym_switch_statement] = STATE(2220),
    [sym_throw_statement] = STATE(2220),
    [sym_try_statement] = STATE(2220),
    [sym_unsafe_statement] = STATE(2220),
    [sym_using_statement] = STATE(2220),
    [sym_foreach_statement] = STATE(2220),
    [sym_goto_statement] = STATE(2220),
    [sym_labeled_statement] = STATE(2220),
    [sym_if_statement] = STATE(2220),
    [sym_while_statement] = STATE(2220),
    [sym_local_declaration_statement] = STATE(2220),
    [sym_local_function_statement] = STATE(2220),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6150),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2819),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2346),
    [sym_preproc_else_in_top_level] = STATE(9424),
    [sym_preproc_elif_in_top_level] = STATE(9424),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(9),
    [sym_preproc_endregion] = STATE(9),
    [sym_preproc_line] = STATE(9),
    [sym_preproc_pragma] = STATE(9),
    [sym_preproc_nullable] = STATE(9),
    [sym_preproc_error] = STATE(9),
    [sym_preproc_define] = STATE(9),
    [sym_preproc_undef] = STATE(9),
    [aux_sym_class_declaration_repeat1] = STATE(2800),
    [aux_sym_class_declaration_repeat2] = STATE(2922),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [aux_sym_preproc_if_in_top_level_repeat1] = STATE(17),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(153),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(155),
    [anon_sym_global] = ACTIONS(157),
    [anon_sym_using] = ACTIONS(159),
    [anon_sym_unsafe] = ACTIONS(161),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(165),
    [anon_sym_namespace] = ACTIONS(167),
    [anon_sym_class] = ACTIONS(169),
    [anon_sym_ref] = ACTIONS(171),
    [anon_sym_struct] = ACTIONS(173),
    [anon_sym_enum] = ACTIONS(175),
    [anon_sym_LBRACE] = ACTIONS(177),
    [anon_sym_interface] = ACTIONS(179),
    [anon_sym_delegate] = ACTIONS(181),
    [anon_sym_record] = ACTIONS(183),
    [anon_sym_abstract] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(37),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_file] = ACTIONS(65),
    [anon_sym_fixed] = ACTIONS(185),
    [anon_sym_internal] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(69),
    [anon_sym_override] = ACTIONS(63),
    [anon_sym_partial] = ACTIONS(63),
    [anon_sym_private] = ACTIONS(63),
    [anon_sym_protected] = ACTIONS(63),
    [anon_sym_public] = ACTIONS(63),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_required] = ACTIONS(63),
    [anon_sym_sealed] = ACTIONS(63),
    [anon_sym_virtual] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(187),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(189),
    [anon_sym_unchecked] = ACTIONS(187),
    [anon_sym_continue] = ACTIONS(191),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_while] = ACTIONS(195),
    [anon_sym_for] = ACTIONS(197),
    [anon_sym_lock] = ACTIONS(199),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(205),
    [anon_sym_try] = ACTIONS(207),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(209),
    [anon_sym_foreach] = ACTIONS(211),
    [anon_sym_goto] = ACTIONS(213),
    [anon_sym_if] = ACTIONS(215),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(217),
    [aux_sym_preproc_if_token3] = ACTIONS(239),
    [aux_sym_preproc_else_token1] = ACTIONS(235),
    [aux_sym_preproc_elif_token1] = ACTIONS(237),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [10] = {
    [sym_extern_alias_directive] = STATE(2345),
    [sym_using_directive] = STATE(2345),
    [sym_global_attribute] = STATE(2345),
    [sym_attribute_list] = STATE(3753),
    [sym_namespace_declaration] = STATE(2345),
    [sym_file_scoped_namespace_declaration] = STATE(2345),
    [sym_type_declaration] = STATE(2345),
    [sym_class_declaration] = STATE(2395),
    [sym_struct_declaration] = STATE(2395),
    [sym_enum_declaration] = STATE(2395),
    [sym_interface_declaration] = STATE(2395),
    [sym_delegate_declaration] = STATE(2395),
    [sym_record_declaration] = STATE(2395),
    [sym_modifier] = STATE(3780),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2220),
    [sym_variable_declaration] = STATE(9437),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6809),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2345),
    [sym_break_statement] = STATE(2220),
    [sym_checked_statement] = STATE(2220),
    [sym_continue_statement] = STATE(2220),
    [sym_do_statement] = STATE(2220),
    [sym_empty_statement] = STATE(2220),
    [sym_expression_statement] = STATE(2220),
    [sym_fixed_statement] = STATE(2220),
    [sym_for_statement] = STATE(2220),
    [sym_return_statement] = STATE(2220),
    [sym_lock_statement] = STATE(2220),
    [sym_yield_statement] = STATE(2220),
    [sym_switch_statement] = STATE(2220),
    [sym_throw_statement] = STATE(2220),
    [sym_try_statement] = STATE(2220),
    [sym_unsafe_statement] = STATE(2220),
    [sym_using_statement] = STATE(2220),
    [sym_foreach_statement] = STATE(2220),
    [sym_goto_statement] = STATE(2220),
    [sym_labeled_statement] = STATE(2220),
    [sym_if_statement] = STATE(2220),
    [sym_while_statement] = STATE(2220),
    [sym_local_declaration_statement] = STATE(2220),
    [sym_local_function_statement] = STATE(2220),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6150),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2819),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2346),
    [sym_preproc_else_in_top_level] = STATE(8961),
    [sym_preproc_elif_in_top_level] = STATE(8961),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(10),
    [sym_preproc_endregion] = STATE(10),
    [sym_preproc_line] = STATE(10),
    [sym_preproc_pragma] = STATE(10),
    [sym_preproc_nullable] = STATE(10),
    [sym_preproc_error] = STATE(10),
    [sym_preproc_define] = STATE(10),
    [sym_preproc_undef] = STATE(10),
    [aux_sym_class_declaration_repeat1] = STATE(2800),
    [aux_sym_class_declaration_repeat2] = STATE(2922),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [aux_sym_preproc_if_in_top_level_repeat1] = STATE(17),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(153),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(155),
    [anon_sym_global] = ACTIONS(157),
    [anon_sym_using] = ACTIONS(159),
    [anon_sym_unsafe] = ACTIONS(161),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(165),
    [anon_sym_namespace] = ACTIONS(167),
    [anon_sym_class] = ACTIONS(169),
    [anon_sym_ref] = ACTIONS(171),
    [anon_sym_struct] = ACTIONS(173),
    [anon_sym_enum] = ACTIONS(175),
    [anon_sym_LBRACE] = ACTIONS(177),
    [anon_sym_interface] = ACTIONS(179),
    [anon_sym_delegate] = ACTIONS(181),
    [anon_sym_record] = ACTIONS(183),
    [anon_sym_abstract] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(37),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_file] = ACTIONS(65),
    [anon_sym_fixed] = ACTIONS(185),
    [anon_sym_internal] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(69),
    [anon_sym_override] = ACTIONS(63),
    [anon_sym_partial] = ACTIONS(63),
    [anon_sym_private] = ACTIONS(63),
    [anon_sym_protected] = ACTIONS(63),
    [anon_sym_public] = ACTIONS(63),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_required] = ACTIONS(63),
    [anon_sym_sealed] = ACTIONS(63),
    [anon_sym_virtual] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(187),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(189),
    [anon_sym_unchecked] = ACTIONS(187),
    [anon_sym_continue] = ACTIONS(191),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_while] = ACTIONS(195),
    [anon_sym_for] = ACTIONS(197),
    [anon_sym_lock] = ACTIONS(199),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(205),
    [anon_sym_try] = ACTIONS(207),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(209),
    [anon_sym_foreach] = ACTIONS(211),
    [anon_sym_goto] = ACTIONS(213),
    [anon_sym_if] = ACTIONS(215),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(217),
    [aux_sym_preproc_if_token3] = ACTIONS(241),
    [aux_sym_preproc_else_token1] = ACTIONS(235),
    [aux_sym_preproc_elif_token1] = ACTIONS(237),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [11] = {
    [sym_extern_alias_directive] = STATE(2345),
    [sym_using_directive] = STATE(2345),
    [sym_global_attribute] = STATE(2345),
    [sym_attribute_list] = STATE(3753),
    [sym_namespace_declaration] = STATE(2345),
    [sym_file_scoped_namespace_declaration] = STATE(2345),
    [sym_type_declaration] = STATE(2345),
    [sym_class_declaration] = STATE(2395),
    [sym_struct_declaration] = STATE(2395),
    [sym_enum_declaration] = STATE(2395),
    [sym_interface_declaration] = STATE(2395),
    [sym_delegate_declaration] = STATE(2395),
    [sym_record_declaration] = STATE(2395),
    [sym_modifier] = STATE(3780),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2220),
    [sym_variable_declaration] = STATE(9437),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6809),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2345),
    [sym_break_statement] = STATE(2220),
    [sym_checked_statement] = STATE(2220),
    [sym_continue_statement] = STATE(2220),
    [sym_do_statement] = STATE(2220),
    [sym_empty_statement] = STATE(2220),
    [sym_expression_statement] = STATE(2220),
    [sym_fixed_statement] = STATE(2220),
    [sym_for_statement] = STATE(2220),
    [sym_return_statement] = STATE(2220),
    [sym_lock_statement] = STATE(2220),
    [sym_yield_statement] = STATE(2220),
    [sym_switch_statement] = STATE(2220),
    [sym_throw_statement] = STATE(2220),
    [sym_try_statement] = STATE(2220),
    [sym_unsafe_statement] = STATE(2220),
    [sym_using_statement] = STATE(2220),
    [sym_foreach_statement] = STATE(2220),
    [sym_goto_statement] = STATE(2220),
    [sym_labeled_statement] = STATE(2220),
    [sym_if_statement] = STATE(2220),
    [sym_while_statement] = STATE(2220),
    [sym_local_declaration_statement] = STATE(2220),
    [sym_local_function_statement] = STATE(2220),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6150),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2819),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2346),
    [sym_preproc_else_in_top_level] = STATE(9560),
    [sym_preproc_elif_in_top_level] = STATE(9560),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(11),
    [sym_preproc_endregion] = STATE(11),
    [sym_preproc_line] = STATE(11),
    [sym_preproc_pragma] = STATE(11),
    [sym_preproc_nullable] = STATE(11),
    [sym_preproc_error] = STATE(11),
    [sym_preproc_define] = STATE(11),
    [sym_preproc_undef] = STATE(11),
    [aux_sym_class_declaration_repeat1] = STATE(2800),
    [aux_sym_class_declaration_repeat2] = STATE(2922),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [aux_sym_preproc_if_in_top_level_repeat1] = STATE(17),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(153),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(155),
    [anon_sym_global] = ACTIONS(157),
    [anon_sym_using] = ACTIONS(159),
    [anon_sym_unsafe] = ACTIONS(161),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(165),
    [anon_sym_namespace] = ACTIONS(167),
    [anon_sym_class] = ACTIONS(169),
    [anon_sym_ref] = ACTIONS(171),
    [anon_sym_struct] = ACTIONS(173),
    [anon_sym_enum] = ACTIONS(175),
    [anon_sym_LBRACE] = ACTIONS(177),
    [anon_sym_interface] = ACTIONS(179),
    [anon_sym_delegate] = ACTIONS(181),
    [anon_sym_record] = ACTIONS(183),
    [anon_sym_abstract] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(37),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_file] = ACTIONS(65),
    [anon_sym_fixed] = ACTIONS(185),
    [anon_sym_internal] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(69),
    [anon_sym_override] = ACTIONS(63),
    [anon_sym_partial] = ACTIONS(63),
    [anon_sym_private] = ACTIONS(63),
    [anon_sym_protected] = ACTIONS(63),
    [anon_sym_public] = ACTIONS(63),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_required] = ACTIONS(63),
    [anon_sym_sealed] = ACTIONS(63),
    [anon_sym_virtual] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(187),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(189),
    [anon_sym_unchecked] = ACTIONS(187),
    [anon_sym_continue] = ACTIONS(191),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_while] = ACTIONS(195),
    [anon_sym_for] = ACTIONS(197),
    [anon_sym_lock] = ACTIONS(199),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(205),
    [anon_sym_try] = ACTIONS(207),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(209),
    [anon_sym_foreach] = ACTIONS(211),
    [anon_sym_goto] = ACTIONS(213),
    [anon_sym_if] = ACTIONS(215),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(217),
    [aux_sym_preproc_if_token3] = ACTIONS(243),
    [aux_sym_preproc_else_token1] = ACTIONS(235),
    [aux_sym_preproc_elif_token1] = ACTIONS(237),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [12] = {
    [sym_extern_alias_directive] = STATE(2345),
    [sym_using_directive] = STATE(2345),
    [sym_global_attribute] = STATE(2345),
    [sym_attribute_list] = STATE(3753),
    [sym_namespace_declaration] = STATE(2345),
    [sym_file_scoped_namespace_declaration] = STATE(2345),
    [sym_type_declaration] = STATE(2345),
    [sym_class_declaration] = STATE(2395),
    [sym_struct_declaration] = STATE(2395),
    [sym_enum_declaration] = STATE(2395),
    [sym_interface_declaration] = STATE(2395),
    [sym_delegate_declaration] = STATE(2395),
    [sym_record_declaration] = STATE(2395),
    [sym_modifier] = STATE(3780),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2220),
    [sym_variable_declaration] = STATE(9437),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6809),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2345),
    [sym_break_statement] = STATE(2220),
    [sym_checked_statement] = STATE(2220),
    [sym_continue_statement] = STATE(2220),
    [sym_do_statement] = STATE(2220),
    [sym_empty_statement] = STATE(2220),
    [sym_expression_statement] = STATE(2220),
    [sym_fixed_statement] = STATE(2220),
    [sym_for_statement] = STATE(2220),
    [sym_return_statement] = STATE(2220),
    [sym_lock_statement] = STATE(2220),
    [sym_yield_statement] = STATE(2220),
    [sym_switch_statement] = STATE(2220),
    [sym_throw_statement] = STATE(2220),
    [sym_try_statement] = STATE(2220),
    [sym_unsafe_statement] = STATE(2220),
    [sym_using_statement] = STATE(2220),
    [sym_foreach_statement] = STATE(2220),
    [sym_goto_statement] = STATE(2220),
    [sym_labeled_statement] = STATE(2220),
    [sym_if_statement] = STATE(2220),
    [sym_while_statement] = STATE(2220),
    [sym_local_declaration_statement] = STATE(2220),
    [sym_local_function_statement] = STATE(2220),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6150),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2819),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2346),
    [sym_preproc_else_in_top_level] = STATE(9023),
    [sym_preproc_elif_in_top_level] = STATE(9023),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(12),
    [sym_preproc_endregion] = STATE(12),
    [sym_preproc_line] = STATE(12),
    [sym_preproc_pragma] = STATE(12),
    [sym_preproc_nullable] = STATE(12),
    [sym_preproc_error] = STATE(12),
    [sym_preproc_define] = STATE(12),
    [sym_preproc_undef] = STATE(12),
    [aux_sym_class_declaration_repeat1] = STATE(2800),
    [aux_sym_class_declaration_repeat2] = STATE(2922),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [aux_sym_preproc_if_in_top_level_repeat1] = STATE(17),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(153),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(155),
    [anon_sym_global] = ACTIONS(157),
    [anon_sym_using] = ACTIONS(159),
    [anon_sym_unsafe] = ACTIONS(161),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(165),
    [anon_sym_namespace] = ACTIONS(167),
    [anon_sym_class] = ACTIONS(169),
    [anon_sym_ref] = ACTIONS(171),
    [anon_sym_struct] = ACTIONS(173),
    [anon_sym_enum] = ACTIONS(175),
    [anon_sym_LBRACE] = ACTIONS(177),
    [anon_sym_interface] = ACTIONS(179),
    [anon_sym_delegate] = ACTIONS(181),
    [anon_sym_record] = ACTIONS(183),
    [anon_sym_abstract] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(37),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_file] = ACTIONS(65),
    [anon_sym_fixed] = ACTIONS(185),
    [anon_sym_internal] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(69),
    [anon_sym_override] = ACTIONS(63),
    [anon_sym_partial] = ACTIONS(63),
    [anon_sym_private] = ACTIONS(63),
    [anon_sym_protected] = ACTIONS(63),
    [anon_sym_public] = ACTIONS(63),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_required] = ACTIONS(63),
    [anon_sym_sealed] = ACTIONS(63),
    [anon_sym_virtual] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(187),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(189),
    [anon_sym_unchecked] = ACTIONS(187),
    [anon_sym_continue] = ACTIONS(191),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_while] = ACTIONS(195),
    [anon_sym_for] = ACTIONS(197),
    [anon_sym_lock] = ACTIONS(199),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(205),
    [anon_sym_try] = ACTIONS(207),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(209),
    [anon_sym_foreach] = ACTIONS(211),
    [anon_sym_goto] = ACTIONS(213),
    [anon_sym_if] = ACTIONS(215),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(217),
    [aux_sym_preproc_if_token3] = ACTIONS(245),
    [aux_sym_preproc_else_token1] = ACTIONS(235),
    [aux_sym_preproc_elif_token1] = ACTIONS(237),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [13] = {
    [sym__top_level_item] = STATE(2547),
    [sym_global_statement] = STATE(2540),
    [sym_extern_alias_directive] = STATE(2540),
    [sym_using_directive] = STATE(2540),
    [sym_global_attribute] = STATE(2540),
    [sym_attribute_list] = STATE(3753),
    [sym_namespace_declaration] = STATE(2540),
    [sym_file_scoped_namespace_declaration] = STATE(2540),
    [sym_type_declaration] = STATE(2540),
    [sym_class_declaration] = STATE(2539),
    [sym_struct_declaration] = STATE(2539),
    [sym_enum_declaration] = STATE(2539),
    [sym_interface_declaration] = STATE(2539),
    [sym_delegate_declaration] = STATE(2539),
    [sym_record_declaration] = STATE(2539),
    [sym_modifier] = STATE(3780),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2478),
    [sym_variable_declaration] = STATE(9764),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6873),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2565),
    [sym_break_statement] = STATE(2478),
    [sym_checked_statement] = STATE(2478),
    [sym_continue_statement] = STATE(2478),
    [sym_do_statement] = STATE(2478),
    [sym_empty_statement] = STATE(2478),
    [sym_expression_statement] = STATE(2478),
    [sym_fixed_statement] = STATE(2478),
    [sym_for_statement] = STATE(2478),
    [sym_return_statement] = STATE(2478),
    [sym_lock_statement] = STATE(2478),
    [sym_yield_statement] = STATE(2478),
    [sym_switch_statement] = STATE(2478),
    [sym_throw_statement] = STATE(2478),
    [sym_try_statement] = STATE(2478),
    [sym_unsafe_statement] = STATE(2478),
    [sym_using_statement] = STATE(2478),
    [sym_foreach_statement] = STATE(2478),
    [sym_goto_statement] = STATE(2478),
    [sym_labeled_statement] = STATE(2478),
    [sym_if_statement] = STATE(2478),
    [sym_while_statement] = STATE(2478),
    [sym_local_declaration_statement] = STATE(2478),
    [sym_local_function_statement] = STATE(2478),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6724),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2900),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2602),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(13),
    [sym_preproc_endregion] = STATE(13),
    [sym_preproc_line] = STATE(13),
    [sym_preproc_pragma] = STATE(13),
    [sym_preproc_nullable] = STATE(13),
    [sym_preproc_error] = STATE(13),
    [sym_preproc_define] = STATE(13),
    [sym_preproc_undef] = STATE(13),
    [aux_sym_compilation_unit_repeat1] = STATE(15),
    [aux_sym_class_declaration_repeat1] = STATE(2804),
    [aux_sym_class_declaration_repeat2] = STATE(2916),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [ts_builtin_sym_end] = ACTIONS(247),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(31),
    [anon_sym_using] = ACTIONS(33),
    [anon_sym_unsafe] = ACTIONS(35),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_namespace] = ACTIONS(45),
    [anon_sym_class] = ACTIONS(47),
    [anon_sym_ref] = ACTIONS(49),
    [anon_sym_struct] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_interface] = ACTIONS(57),
    [anon_sym_delegate] = ACTIONS(59),
    [anon_sym_record] = ACTIONS(61),
    [anon_sym_abstract] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(37),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_file] = ACTIONS(65),
    [anon_sym_fixed] = ACTIONS(67),
    [anon_sym_internal] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(69),
    [anon_sym_override] = ACTIONS(63),
    [anon_sym_partial] = ACTIONS(63),
    [anon_sym_private] = ACTIONS(63),
    [anon_sym_protected] = ACTIONS(63),
    [anon_sym_public] = ACTIONS(63),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_required] = ACTIONS(63),
    [anon_sym_sealed] = ACTIONS(63),
    [anon_sym_virtual] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(71),
    [anon_sym_continue] = ACTIONS(91),
    [anon_sym_do] = ACTIONS(93),
    [anon_sym_while] = ACTIONS(95),
    [anon_sym_for] = ACTIONS(97),
    [anon_sym_lock] = ACTIONS(99),
    [anon_sym_yield] = ACTIONS(101),
    [anon_sym_switch] = ACTIONS(103),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(107),
    [anon_sym_try] = ACTIONS(109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(111),
    [anon_sym_foreach] = ACTIONS(113),
    [anon_sym_goto] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(143),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [14] = {
    [sym__top_level_item] = STATE(2547),
    [sym_global_statement] = STATE(2540),
    [sym_extern_alias_directive] = STATE(2540),
    [sym_using_directive] = STATE(2540),
    [sym_global_attribute] = STATE(2540),
    [sym_attribute_list] = STATE(3753),
    [sym_namespace_declaration] = STATE(2540),
    [sym_file_scoped_namespace_declaration] = STATE(2540),
    [sym_type_declaration] = STATE(2540),
    [sym_class_declaration] = STATE(2539),
    [sym_struct_declaration] = STATE(2539),
    [sym_enum_declaration] = STATE(2539),
    [sym_interface_declaration] = STATE(2539),
    [sym_delegate_declaration] = STATE(2539),
    [sym_record_declaration] = STATE(2539),
    [sym_modifier] = STATE(3780),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2478),
    [sym_variable_declaration] = STATE(9764),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6873),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2565),
    [sym_break_statement] = STATE(2478),
    [sym_checked_statement] = STATE(2478),
    [sym_continue_statement] = STATE(2478),
    [sym_do_statement] = STATE(2478),
    [sym_empty_statement] = STATE(2478),
    [sym_expression_statement] = STATE(2478),
    [sym_fixed_statement] = STATE(2478),
    [sym_for_statement] = STATE(2478),
    [sym_return_statement] = STATE(2478),
    [sym_lock_statement] = STATE(2478),
    [sym_yield_statement] = STATE(2478),
    [sym_switch_statement] = STATE(2478),
    [sym_throw_statement] = STATE(2478),
    [sym_try_statement] = STATE(2478),
    [sym_unsafe_statement] = STATE(2478),
    [sym_using_statement] = STATE(2478),
    [sym_foreach_statement] = STATE(2478),
    [sym_goto_statement] = STATE(2478),
    [sym_labeled_statement] = STATE(2478),
    [sym_if_statement] = STATE(2478),
    [sym_while_statement] = STATE(2478),
    [sym_local_declaration_statement] = STATE(2478),
    [sym_local_function_statement] = STATE(2478),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6724),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2900),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2602),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(14),
    [sym_preproc_endregion] = STATE(14),
    [sym_preproc_line] = STATE(14),
    [sym_preproc_pragma] = STATE(14),
    [sym_preproc_nullable] = STATE(14),
    [sym_preproc_error] = STATE(14),
    [sym_preproc_define] = STATE(14),
    [sym_preproc_undef] = STATE(14),
    [aux_sym_compilation_unit_repeat1] = STATE(15),
    [aux_sym_class_declaration_repeat1] = STATE(2804),
    [aux_sym_class_declaration_repeat2] = STATE(2916),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [ts_builtin_sym_end] = ACTIONS(249),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(31),
    [anon_sym_using] = ACTIONS(33),
    [anon_sym_unsafe] = ACTIONS(35),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_namespace] = ACTIONS(45),
    [anon_sym_class] = ACTIONS(47),
    [anon_sym_ref] = ACTIONS(49),
    [anon_sym_struct] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_interface] = ACTIONS(57),
    [anon_sym_delegate] = ACTIONS(59),
    [anon_sym_record] = ACTIONS(61),
    [anon_sym_abstract] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(37),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_file] = ACTIONS(65),
    [anon_sym_fixed] = ACTIONS(67),
    [anon_sym_internal] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(69),
    [anon_sym_override] = ACTIONS(63),
    [anon_sym_partial] = ACTIONS(63),
    [anon_sym_private] = ACTIONS(63),
    [anon_sym_protected] = ACTIONS(63),
    [anon_sym_public] = ACTIONS(63),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_required] = ACTIONS(63),
    [anon_sym_sealed] = ACTIONS(63),
    [anon_sym_virtual] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(71),
    [anon_sym_continue] = ACTIONS(91),
    [anon_sym_do] = ACTIONS(93),
    [anon_sym_while] = ACTIONS(95),
    [anon_sym_for] = ACTIONS(97),
    [anon_sym_lock] = ACTIONS(99),
    [anon_sym_yield] = ACTIONS(101),
    [anon_sym_switch] = ACTIONS(103),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(107),
    [anon_sym_try] = ACTIONS(109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(111),
    [anon_sym_foreach] = ACTIONS(113),
    [anon_sym_goto] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(143),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [15] = {
    [sym__top_level_item] = STATE(2547),
    [sym_global_statement] = STATE(2540),
    [sym_extern_alias_directive] = STATE(2540),
    [sym_using_directive] = STATE(2540),
    [sym_global_attribute] = STATE(2540),
    [sym_attribute_list] = STATE(3753),
    [sym_namespace_declaration] = STATE(2540),
    [sym_file_scoped_namespace_declaration] = STATE(2540),
    [sym_type_declaration] = STATE(2540),
    [sym_class_declaration] = STATE(2539),
    [sym_struct_declaration] = STATE(2539),
    [sym_enum_declaration] = STATE(2539),
    [sym_interface_declaration] = STATE(2539),
    [sym_delegate_declaration] = STATE(2539),
    [sym_record_declaration] = STATE(2539),
    [sym_modifier] = STATE(3780),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2478),
    [sym_variable_declaration] = STATE(9764),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6873),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2565),
    [sym_break_statement] = STATE(2478),
    [sym_checked_statement] = STATE(2478),
    [sym_continue_statement] = STATE(2478),
    [sym_do_statement] = STATE(2478),
    [sym_empty_statement] = STATE(2478),
    [sym_expression_statement] = STATE(2478),
    [sym_fixed_statement] = STATE(2478),
    [sym_for_statement] = STATE(2478),
    [sym_return_statement] = STATE(2478),
    [sym_lock_statement] = STATE(2478),
    [sym_yield_statement] = STATE(2478),
    [sym_switch_statement] = STATE(2478),
    [sym_throw_statement] = STATE(2478),
    [sym_try_statement] = STATE(2478),
    [sym_unsafe_statement] = STATE(2478),
    [sym_using_statement] = STATE(2478),
    [sym_foreach_statement] = STATE(2478),
    [sym_goto_statement] = STATE(2478),
    [sym_labeled_statement] = STATE(2478),
    [sym_if_statement] = STATE(2478),
    [sym_while_statement] = STATE(2478),
    [sym_local_declaration_statement] = STATE(2478),
    [sym_local_function_statement] = STATE(2478),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6724),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2900),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2602),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(15),
    [sym_preproc_endregion] = STATE(15),
    [sym_preproc_line] = STATE(15),
    [sym_preproc_pragma] = STATE(15),
    [sym_preproc_nullable] = STATE(15),
    [sym_preproc_error] = STATE(15),
    [sym_preproc_define] = STATE(15),
    [sym_preproc_undef] = STATE(15),
    [aux_sym_compilation_unit_repeat1] = STATE(15),
    [aux_sym_class_declaration_repeat1] = STATE(2804),
    [aux_sym_class_declaration_repeat2] = STATE(2916),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [ts_builtin_sym_end] = ACTIONS(251),
    [sym__identifier_token] = ACTIONS(253),
    [anon_sym_extern] = ACTIONS(256),
    [anon_sym_alias] = ACTIONS(259),
    [anon_sym_SEMI] = ACTIONS(262),
    [anon_sym_global] = ACTIONS(265),
    [anon_sym_using] = ACTIONS(268),
    [anon_sym_unsafe] = ACTIONS(271),
    [anon_sym_static] = ACTIONS(274),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_LPAREN] = ACTIONS(280),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_namespace] = ACTIONS(286),
    [anon_sym_class] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(292),
    [anon_sym_struct] = ACTIONS(295),
    [anon_sym_enum] = ACTIONS(298),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_interface] = ACTIONS(304),
    [anon_sym_delegate] = ACTIONS(307),
    [anon_sym_record] = ACTIONS(310),
    [anon_sym_abstract] = ACTIONS(313),
    [anon_sym_async] = ACTIONS(274),
    [anon_sym_const] = ACTIONS(313),
    [anon_sym_file] = ACTIONS(316),
    [anon_sym_fixed] = ACTIONS(319),
    [anon_sym_internal] = ACTIONS(313),
    [anon_sym_new] = ACTIONS(322),
    [anon_sym_override] = ACTIONS(313),
    [anon_sym_partial] = ACTIONS(313),
    [anon_sym_private] = ACTIONS(313),
    [anon_sym_protected] = ACTIONS(313),
    [anon_sym_public] = ACTIONS(313),
    [anon_sym_readonly] = ACTIONS(313),
    [anon_sym_required] = ACTIONS(313),
    [anon_sym_sealed] = ACTIONS(313),
    [anon_sym_virtual] = ACTIONS(313),
    [anon_sym_volatile] = ACTIONS(313),
    [anon_sym_where] = ACTIONS(259),
    [anon_sym_notnull] = ACTIONS(259),
    [anon_sym_unmanaged] = ACTIONS(259),
    [anon_sym_checked] = ACTIONS(325),
    [anon_sym_BANG] = ACTIONS(328),
    [anon_sym_TILDE] = ACTIONS(328),
    [anon_sym_PLUS_PLUS] = ACTIONS(328),
    [anon_sym_DASH_DASH] = ACTIONS(328),
    [anon_sym_true] = ACTIONS(331),
    [anon_sym_false] = ACTIONS(331),
    [anon_sym_PLUS] = ACTIONS(334),
    [anon_sym_DASH] = ACTIONS(334),
    [anon_sym_STAR] = ACTIONS(337),
    [anon_sym_CARET] = ACTIONS(328),
    [anon_sym_AMP] = ACTIONS(328),
    [anon_sym_this] = ACTIONS(340),
    [anon_sym_scoped] = ACTIONS(343),
    [anon_sym_var] = ACTIONS(346),
    [sym_predefined_type] = ACTIONS(349),
    [anon_sym_break] = ACTIONS(352),
    [anon_sym_unchecked] = ACTIONS(325),
    [anon_sym_continue] = ACTIONS(355),
    [anon_sym_do] = ACTIONS(358),
    [anon_sym_while] = ACTIONS(361),
    [anon_sym_for] = ACTIONS(364),
    [anon_sym_lock] = ACTIONS(367),
    [anon_sym_yield] = ACTIONS(370),
    [anon_sym_switch] = ACTIONS(373),
    [anon_sym_default] = ACTIONS(376),
    [anon_sym_throw] = ACTIONS(379),
    [anon_sym_try] = ACTIONS(382),
    [anon_sym_when] = ACTIONS(259),
    [anon_sym_await] = ACTIONS(385),
    [anon_sym_foreach] = ACTIONS(388),
    [anon_sym_goto] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(394),
    [anon_sym_DOT_DOT] = ACTIONS(397),
    [anon_sym_from] = ACTIONS(400),
    [anon_sym_into] = ACTIONS(259),
    [anon_sym_join] = ACTIONS(259),
    [anon_sym_on] = ACTIONS(259),
    [anon_sym_equals] = ACTIONS(259),
    [anon_sym_let] = ACTIONS(259),
    [anon_sym_orderby] = ACTIONS(259),
    [anon_sym_ascending] = ACTIONS(259),
    [anon_sym_descending] = ACTIONS(259),
    [anon_sym_group] = ACTIONS(259),
    [anon_sym_by] = ACTIONS(259),
    [anon_sym_select] = ACTIONS(259),
    [anon_sym_DQUOTE] = ACTIONS(403),
    [anon_sym_stackalloc] = ACTIONS(406),
    [anon_sym_sizeof] = ACTIONS(409),
    [anon_sym_typeof] = ACTIONS(412),
    [anon_sym___makeref] = ACTIONS(415),
    [anon_sym___reftype] = ACTIONS(418),
    [anon_sym___refvalue] = ACTIONS(421),
    [sym_null_literal] = ACTIONS(424),
    [anon_sym_SQUOTE] = ACTIONS(427),
    [sym_integer_literal] = ACTIONS(424),
    [sym_real_literal] = ACTIONS(430),
    [sym_verbatim_string_literal] = ACTIONS(430),
    [sym_raw_string_literal] = ACTIONS(430),
    [aux_sym_preproc_if_token1] = ACTIONS(433),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(436),
    [sym_interpolation_verbatim_start] = ACTIONS(439),
    [sym_interpolation_raw_start] = ACTIONS(442),
  },
  [16] = {
    [sym__top_level_item] = STATE(2547),
    [sym_global_statement] = STATE(2540),
    [sym_extern_alias_directive] = STATE(2540),
    [sym_using_directive] = STATE(2540),
    [sym_global_attribute] = STATE(2540),
    [sym_attribute_list] = STATE(3753),
    [sym_namespace_declaration] = STATE(2540),
    [sym_file_scoped_namespace_declaration] = STATE(2540),
    [sym_type_declaration] = STATE(2540),
    [sym_class_declaration] = STATE(2539),
    [sym_struct_declaration] = STATE(2539),
    [sym_enum_declaration] = STATE(2539),
    [sym_interface_declaration] = STATE(2539),
    [sym_delegate_declaration] = STATE(2539),
    [sym_record_declaration] = STATE(2539),
    [sym_modifier] = STATE(3780),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2478),
    [sym_variable_declaration] = STATE(9764),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6873),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2565),
    [sym_break_statement] = STATE(2478),
    [sym_checked_statement] = STATE(2478),
    [sym_continue_statement] = STATE(2478),
    [sym_do_statement] = STATE(2478),
    [sym_empty_statement] = STATE(2478),
    [sym_expression_statement] = STATE(2478),
    [sym_fixed_statement] = STATE(2478),
    [sym_for_statement] = STATE(2478),
    [sym_return_statement] = STATE(2478),
    [sym_lock_statement] = STATE(2478),
    [sym_yield_statement] = STATE(2478),
    [sym_switch_statement] = STATE(2478),
    [sym_throw_statement] = STATE(2478),
    [sym_try_statement] = STATE(2478),
    [sym_unsafe_statement] = STATE(2478),
    [sym_using_statement] = STATE(2478),
    [sym_foreach_statement] = STATE(2478),
    [sym_goto_statement] = STATE(2478),
    [sym_labeled_statement] = STATE(2478),
    [sym_if_statement] = STATE(2478),
    [sym_while_statement] = STATE(2478),
    [sym_local_declaration_statement] = STATE(2478),
    [sym_local_function_statement] = STATE(2478),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6724),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2900),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2602),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(16),
    [sym_preproc_endregion] = STATE(16),
    [sym_preproc_line] = STATE(16),
    [sym_preproc_pragma] = STATE(16),
    [sym_preproc_nullable] = STATE(16),
    [sym_preproc_error] = STATE(16),
    [sym_preproc_define] = STATE(16),
    [sym_preproc_undef] = STATE(16),
    [aux_sym_compilation_unit_repeat1] = STATE(13),
    [aux_sym_class_declaration_repeat1] = STATE(2804),
    [aux_sym_class_declaration_repeat2] = STATE(2916),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [ts_builtin_sym_end] = ACTIONS(249),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(31),
    [anon_sym_using] = ACTIONS(33),
    [anon_sym_unsafe] = ACTIONS(35),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_namespace] = ACTIONS(45),
    [anon_sym_class] = ACTIONS(47),
    [anon_sym_ref] = ACTIONS(49),
    [anon_sym_struct] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_interface] = ACTIONS(57),
    [anon_sym_delegate] = ACTIONS(59),
    [anon_sym_record] = ACTIONS(61),
    [anon_sym_abstract] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(37),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_file] = ACTIONS(65),
    [anon_sym_fixed] = ACTIONS(67),
    [anon_sym_internal] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(69),
    [anon_sym_override] = ACTIONS(63),
    [anon_sym_partial] = ACTIONS(63),
    [anon_sym_private] = ACTIONS(63),
    [anon_sym_protected] = ACTIONS(63),
    [anon_sym_public] = ACTIONS(63),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_required] = ACTIONS(63),
    [anon_sym_sealed] = ACTIONS(63),
    [anon_sym_virtual] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(71),
    [anon_sym_continue] = ACTIONS(91),
    [anon_sym_do] = ACTIONS(93),
    [anon_sym_while] = ACTIONS(95),
    [anon_sym_for] = ACTIONS(97),
    [anon_sym_lock] = ACTIONS(99),
    [anon_sym_yield] = ACTIONS(101),
    [anon_sym_switch] = ACTIONS(103),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(107),
    [anon_sym_try] = ACTIONS(109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(111),
    [anon_sym_foreach] = ACTIONS(113),
    [anon_sym_goto] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(143),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [17] = {
    [sym_extern_alias_directive] = STATE(2345),
    [sym_using_directive] = STATE(2345),
    [sym_global_attribute] = STATE(2345),
    [sym_attribute_list] = STATE(3753),
    [sym_namespace_declaration] = STATE(2345),
    [sym_file_scoped_namespace_declaration] = STATE(2345),
    [sym_type_declaration] = STATE(2345),
    [sym_class_declaration] = STATE(2395),
    [sym_struct_declaration] = STATE(2395),
    [sym_enum_declaration] = STATE(2395),
    [sym_interface_declaration] = STATE(2395),
    [sym_delegate_declaration] = STATE(2395),
    [sym_record_declaration] = STATE(2395),
    [sym_modifier] = STATE(3780),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2220),
    [sym_variable_declaration] = STATE(9437),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6809),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2345),
    [sym_break_statement] = STATE(2220),
    [sym_checked_statement] = STATE(2220),
    [sym_continue_statement] = STATE(2220),
    [sym_do_statement] = STATE(2220),
    [sym_empty_statement] = STATE(2220),
    [sym_expression_statement] = STATE(2220),
    [sym_fixed_statement] = STATE(2220),
    [sym_for_statement] = STATE(2220),
    [sym_return_statement] = STATE(2220),
    [sym_lock_statement] = STATE(2220),
    [sym_yield_statement] = STATE(2220),
    [sym_switch_statement] = STATE(2220),
    [sym_throw_statement] = STATE(2220),
    [sym_try_statement] = STATE(2220),
    [sym_unsafe_statement] = STATE(2220),
    [sym_using_statement] = STATE(2220),
    [sym_foreach_statement] = STATE(2220),
    [sym_goto_statement] = STATE(2220),
    [sym_labeled_statement] = STATE(2220),
    [sym_if_statement] = STATE(2220),
    [sym_while_statement] = STATE(2220),
    [sym_local_declaration_statement] = STATE(2220),
    [sym_local_function_statement] = STATE(2220),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6150),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2819),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2346),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(17),
    [sym_preproc_endregion] = STATE(17),
    [sym_preproc_line] = STATE(17),
    [sym_preproc_pragma] = STATE(17),
    [sym_preproc_nullable] = STATE(17),
    [sym_preproc_error] = STATE(17),
    [sym_preproc_define] = STATE(17),
    [sym_preproc_undef] = STATE(17),
    [aux_sym_class_declaration_repeat1] = STATE(2800),
    [aux_sym_class_declaration_repeat2] = STATE(2922),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [aux_sym_preproc_if_in_top_level_repeat1] = STATE(17),
    [sym__identifier_token] = ACTIONS(445),
    [anon_sym_extern] = ACTIONS(448),
    [anon_sym_alias] = ACTIONS(451),
    [anon_sym_SEMI] = ACTIONS(454),
    [anon_sym_global] = ACTIONS(457),
    [anon_sym_using] = ACTIONS(460),
    [anon_sym_unsafe] = ACTIONS(463),
    [anon_sym_static] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(469),
    [anon_sym_LPAREN] = ACTIONS(472),
    [anon_sym_return] = ACTIONS(475),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_class] = ACTIONS(481),
    [anon_sym_ref] = ACTIONS(484),
    [anon_sym_struct] = ACTIONS(487),
    [anon_sym_enum] = ACTIONS(490),
    [anon_sym_LBRACE] = ACTIONS(493),
    [anon_sym_interface] = ACTIONS(496),
    [anon_sym_delegate] = ACTIONS(499),
    [anon_sym_record] = ACTIONS(502),
    [anon_sym_abstract] = ACTIONS(505),
    [anon_sym_async] = ACTIONS(466),
    [anon_sym_const] = ACTIONS(505),
    [anon_sym_file] = ACTIONS(508),
    [anon_sym_fixed] = ACTIONS(511),
    [anon_sym_internal] = ACTIONS(505),
    [anon_sym_new] = ACTIONS(514),
    [anon_sym_override] = ACTIONS(505),
    [anon_sym_partial] = ACTIONS(505),
    [anon_sym_private] = ACTIONS(505),
    [anon_sym_protected] = ACTIONS(505),
    [anon_sym_public] = ACTIONS(505),
    [anon_sym_readonly] = ACTIONS(505),
    [anon_sym_required] = ACTIONS(505),
    [anon_sym_sealed] = ACTIONS(505),
    [anon_sym_virtual] = ACTIONS(505),
    [anon_sym_volatile] = ACTIONS(505),
    [anon_sym_where] = ACTIONS(451),
    [anon_sym_notnull] = ACTIONS(451),
    [anon_sym_unmanaged] = ACTIONS(451),
    [anon_sym_checked] = ACTIONS(517),
    [anon_sym_BANG] = ACTIONS(520),
    [anon_sym_TILDE] = ACTIONS(520),
    [anon_sym_PLUS_PLUS] = ACTIONS(520),
    [anon_sym_DASH_DASH] = ACTIONS(520),
    [anon_sym_true] = ACTIONS(523),
    [anon_sym_false] = ACTIONS(523),
    [anon_sym_PLUS] = ACTIONS(526),
    [anon_sym_DASH] = ACTIONS(526),
    [anon_sym_STAR] = ACTIONS(529),
    [anon_sym_CARET] = ACTIONS(520),
    [anon_sym_AMP] = ACTIONS(520),
    [anon_sym_this] = ACTIONS(532),
    [anon_sym_scoped] = ACTIONS(535),
    [anon_sym_var] = ACTIONS(538),
    [sym_predefined_type] = ACTIONS(541),
    [anon_sym_break] = ACTIONS(544),
    [anon_sym_unchecked] = ACTIONS(517),
    [anon_sym_continue] = ACTIONS(547),
    [anon_sym_do] = ACTIONS(550),
    [anon_sym_while] = ACTIONS(553),
    [anon_sym_for] = ACTIONS(556),
    [anon_sym_lock] = ACTIONS(559),
    [anon_sym_yield] = ACTIONS(562),
    [anon_sym_switch] = ACTIONS(565),
    [anon_sym_default] = ACTIONS(568),
    [anon_sym_throw] = ACTIONS(571),
    [anon_sym_try] = ACTIONS(574),
    [anon_sym_when] = ACTIONS(451),
    [anon_sym_await] = ACTIONS(577),
    [anon_sym_foreach] = ACTIONS(580),
    [anon_sym_goto] = ACTIONS(583),
    [anon_sym_if] = ACTIONS(586),
    [anon_sym_DOT_DOT] = ACTIONS(589),
    [anon_sym_from] = ACTIONS(592),
    [anon_sym_into] = ACTIONS(451),
    [anon_sym_join] = ACTIONS(451),
    [anon_sym_on] = ACTIONS(451),
    [anon_sym_equals] = ACTIONS(451),
    [anon_sym_let] = ACTIONS(451),
    [anon_sym_orderby] = ACTIONS(451),
    [anon_sym_ascending] = ACTIONS(451),
    [anon_sym_descending] = ACTIONS(451),
    [anon_sym_group] = ACTIONS(451),
    [anon_sym_by] = ACTIONS(451),
    [anon_sym_select] = ACTIONS(451),
    [anon_sym_DQUOTE] = ACTIONS(595),
    [anon_sym_stackalloc] = ACTIONS(598),
    [anon_sym_sizeof] = ACTIONS(601),
    [anon_sym_typeof] = ACTIONS(604),
    [anon_sym___makeref] = ACTIONS(607),
    [anon_sym___reftype] = ACTIONS(610),
    [anon_sym___refvalue] = ACTIONS(613),
    [sym_null_literal] = ACTIONS(616),
    [anon_sym_SQUOTE] = ACTIONS(619),
    [sym_integer_literal] = ACTIONS(616),
    [sym_real_literal] = ACTIONS(622),
    [sym_verbatim_string_literal] = ACTIONS(622),
    [sym_raw_string_literal] = ACTIONS(622),
    [aux_sym_preproc_if_token1] = ACTIONS(625),
    [aux_sym_preproc_if_token3] = ACTIONS(628),
    [aux_sym_preproc_else_token1] = ACTIONS(628),
    [aux_sym_preproc_elif_token1] = ACTIONS(628),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(630),
    [sym_interpolation_verbatim_start] = ACTIONS(633),
    [sym_interpolation_raw_start] = ACTIONS(636),
  },
  [18] = {
    [sym_extern_alias_directive] = STATE(2345),
    [sym_using_directive] = STATE(2345),
    [sym_global_attribute] = STATE(2345),
    [sym_attribute_list] = STATE(3753),
    [sym_namespace_declaration] = STATE(2345),
    [sym_file_scoped_namespace_declaration] = STATE(2345),
    [sym_type_declaration] = STATE(2345),
    [sym_class_declaration] = STATE(2395),
    [sym_struct_declaration] = STATE(2395),
    [sym_enum_declaration] = STATE(2395),
    [sym_interface_declaration] = STATE(2395),
    [sym_delegate_declaration] = STATE(2395),
    [sym_record_declaration] = STATE(2395),
    [sym_modifier] = STATE(3780),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2220),
    [sym_variable_declaration] = STATE(9437),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6809),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2345),
    [sym_break_statement] = STATE(2220),
    [sym_checked_statement] = STATE(2220),
    [sym_continue_statement] = STATE(2220),
    [sym_do_statement] = STATE(2220),
    [sym_empty_statement] = STATE(2220),
    [sym_expression_statement] = STATE(2220),
    [sym_fixed_statement] = STATE(2220),
    [sym_for_statement] = STATE(2220),
    [sym_return_statement] = STATE(2220),
    [sym_lock_statement] = STATE(2220),
    [sym_yield_statement] = STATE(2220),
    [sym_switch_statement] = STATE(2220),
    [sym_throw_statement] = STATE(2220),
    [sym_try_statement] = STATE(2220),
    [sym_unsafe_statement] = STATE(2220),
    [sym_using_statement] = STATE(2220),
    [sym_foreach_statement] = STATE(2220),
    [sym_goto_statement] = STATE(2220),
    [sym_labeled_statement] = STATE(2220),
    [sym_if_statement] = STATE(2220),
    [sym_while_statement] = STATE(2220),
    [sym_local_declaration_statement] = STATE(2220),
    [sym_local_function_statement] = STATE(2220),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6150),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2819),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2346),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(18),
    [sym_preproc_endregion] = STATE(18),
    [sym_preproc_line] = STATE(18),
    [sym_preproc_pragma] = STATE(18),
    [sym_preproc_nullable] = STATE(18),
    [sym_preproc_error] = STATE(18),
    [sym_preproc_define] = STATE(18),
    [sym_preproc_undef] = STATE(18),
    [aux_sym_class_declaration_repeat1] = STATE(2800),
    [aux_sym_class_declaration_repeat2] = STATE(2922),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [aux_sym_preproc_if_in_top_level_repeat1] = STATE(17),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(153),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(155),
    [anon_sym_global] = ACTIONS(157),
    [anon_sym_using] = ACTIONS(159),
    [anon_sym_unsafe] = ACTIONS(161),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(165),
    [anon_sym_namespace] = ACTIONS(167),
    [anon_sym_class] = ACTIONS(169),
    [anon_sym_ref] = ACTIONS(171),
    [anon_sym_struct] = ACTIONS(173),
    [anon_sym_enum] = ACTIONS(175),
    [anon_sym_LBRACE] = ACTIONS(177),
    [anon_sym_interface] = ACTIONS(179),
    [anon_sym_delegate] = ACTIONS(181),
    [anon_sym_record] = ACTIONS(183),
    [anon_sym_abstract] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(37),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_file] = ACTIONS(65),
    [anon_sym_fixed] = ACTIONS(185),
    [anon_sym_internal] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(69),
    [anon_sym_override] = ACTIONS(63),
    [anon_sym_partial] = ACTIONS(63),
    [anon_sym_private] = ACTIONS(63),
    [anon_sym_protected] = ACTIONS(63),
    [anon_sym_public] = ACTIONS(63),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_required] = ACTIONS(63),
    [anon_sym_sealed] = ACTIONS(63),
    [anon_sym_virtual] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(187),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(189),
    [anon_sym_unchecked] = ACTIONS(187),
    [anon_sym_continue] = ACTIONS(191),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_while] = ACTIONS(195),
    [anon_sym_for] = ACTIONS(197),
    [anon_sym_lock] = ACTIONS(199),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(205),
    [anon_sym_try] = ACTIONS(207),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(209),
    [anon_sym_foreach] = ACTIONS(211),
    [anon_sym_goto] = ACTIONS(213),
    [anon_sym_if] = ACTIONS(215),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(217),
    [aux_sym_preproc_if_token3] = ACTIONS(639),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [19] = {
    [sym_extern_alias_directive] = STATE(2345),
    [sym_using_directive] = STATE(2345),
    [sym_global_attribute] = STATE(2345),
    [sym_attribute_list] = STATE(3753),
    [sym_namespace_declaration] = STATE(2345),
    [sym_file_scoped_namespace_declaration] = STATE(2345),
    [sym_type_declaration] = STATE(2345),
    [sym_class_declaration] = STATE(2395),
    [sym_struct_declaration] = STATE(2395),
    [sym_enum_declaration] = STATE(2395),
    [sym_interface_declaration] = STATE(2395),
    [sym_delegate_declaration] = STATE(2395),
    [sym_record_declaration] = STATE(2395),
    [sym_modifier] = STATE(3780),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2220),
    [sym_variable_declaration] = STATE(9437),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6809),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2345),
    [sym_break_statement] = STATE(2220),
    [sym_checked_statement] = STATE(2220),
    [sym_continue_statement] = STATE(2220),
    [sym_do_statement] = STATE(2220),
    [sym_empty_statement] = STATE(2220),
    [sym_expression_statement] = STATE(2220),
    [sym_fixed_statement] = STATE(2220),
    [sym_for_statement] = STATE(2220),
    [sym_return_statement] = STATE(2220),
    [sym_lock_statement] = STATE(2220),
    [sym_yield_statement] = STATE(2220),
    [sym_switch_statement] = STATE(2220),
    [sym_throw_statement] = STATE(2220),
    [sym_try_statement] = STATE(2220),
    [sym_unsafe_statement] = STATE(2220),
    [sym_using_statement] = STATE(2220),
    [sym_foreach_statement] = STATE(2220),
    [sym_goto_statement] = STATE(2220),
    [sym_labeled_statement] = STATE(2220),
    [sym_if_statement] = STATE(2220),
    [sym_while_statement] = STATE(2220),
    [sym_local_declaration_statement] = STATE(2220),
    [sym_local_function_statement] = STATE(2220),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6150),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2819),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2346),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(19),
    [sym_preproc_endregion] = STATE(19),
    [sym_preproc_line] = STATE(19),
    [sym_preproc_pragma] = STATE(19),
    [sym_preproc_nullable] = STATE(19),
    [sym_preproc_error] = STATE(19),
    [sym_preproc_define] = STATE(19),
    [sym_preproc_undef] = STATE(19),
    [aux_sym_class_declaration_repeat1] = STATE(2800),
    [aux_sym_class_declaration_repeat2] = STATE(2922),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [aux_sym_preproc_if_in_top_level_repeat1] = STATE(18),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(153),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(155),
    [anon_sym_global] = ACTIONS(157),
    [anon_sym_using] = ACTIONS(159),
    [anon_sym_unsafe] = ACTIONS(161),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(165),
    [anon_sym_namespace] = ACTIONS(167),
    [anon_sym_class] = ACTIONS(169),
    [anon_sym_ref] = ACTIONS(171),
    [anon_sym_struct] = ACTIONS(173),
    [anon_sym_enum] = ACTIONS(175),
    [anon_sym_LBRACE] = ACTIONS(177),
    [anon_sym_interface] = ACTIONS(179),
    [anon_sym_delegate] = ACTIONS(181),
    [anon_sym_record] = ACTIONS(183),
    [anon_sym_abstract] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(37),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_file] = ACTIONS(65),
    [anon_sym_fixed] = ACTIONS(185),
    [anon_sym_internal] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(69),
    [anon_sym_override] = ACTIONS(63),
    [anon_sym_partial] = ACTIONS(63),
    [anon_sym_private] = ACTIONS(63),
    [anon_sym_protected] = ACTIONS(63),
    [anon_sym_public] = ACTIONS(63),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_required] = ACTIONS(63),
    [anon_sym_sealed] = ACTIONS(63),
    [anon_sym_virtual] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(187),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(189),
    [anon_sym_unchecked] = ACTIONS(187),
    [anon_sym_continue] = ACTIONS(191),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_while] = ACTIONS(195),
    [anon_sym_for] = ACTIONS(197),
    [anon_sym_lock] = ACTIONS(199),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(205),
    [anon_sym_try] = ACTIONS(207),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(209),
    [anon_sym_foreach] = ACTIONS(211),
    [anon_sym_goto] = ACTIONS(213),
    [anon_sym_if] = ACTIONS(215),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(217),
    [aux_sym_preproc_if_token3] = ACTIONS(641),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [20] = {
    [sym_extern_alias_directive] = STATE(2345),
    [sym_using_directive] = STATE(2345),
    [sym_global_attribute] = STATE(2345),
    [sym_attribute_list] = STATE(3753),
    [sym_namespace_declaration] = STATE(2345),
    [sym_file_scoped_namespace_declaration] = STATE(2345),
    [sym_type_declaration] = STATE(2345),
    [sym_class_declaration] = STATE(2395),
    [sym_struct_declaration] = STATE(2395),
    [sym_enum_declaration] = STATE(2395),
    [sym_interface_declaration] = STATE(2395),
    [sym_delegate_declaration] = STATE(2395),
    [sym_record_declaration] = STATE(2395),
    [sym_modifier] = STATE(3780),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2220),
    [sym_variable_declaration] = STATE(9437),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6809),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2345),
    [sym_break_statement] = STATE(2220),
    [sym_checked_statement] = STATE(2220),
    [sym_continue_statement] = STATE(2220),
    [sym_do_statement] = STATE(2220),
    [sym_empty_statement] = STATE(2220),
    [sym_expression_statement] = STATE(2220),
    [sym_fixed_statement] = STATE(2220),
    [sym_for_statement] = STATE(2220),
    [sym_return_statement] = STATE(2220),
    [sym_lock_statement] = STATE(2220),
    [sym_yield_statement] = STATE(2220),
    [sym_switch_statement] = STATE(2220),
    [sym_throw_statement] = STATE(2220),
    [sym_try_statement] = STATE(2220),
    [sym_unsafe_statement] = STATE(2220),
    [sym_using_statement] = STATE(2220),
    [sym_foreach_statement] = STATE(2220),
    [sym_goto_statement] = STATE(2220),
    [sym_labeled_statement] = STATE(2220),
    [sym_if_statement] = STATE(2220),
    [sym_while_statement] = STATE(2220),
    [sym_local_declaration_statement] = STATE(2220),
    [sym_local_function_statement] = STATE(2220),
    [sym_expression] = STATE(6420),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6150),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2819),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2346),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(20),
    [sym_preproc_endregion] = STATE(20),
    [sym_preproc_line] = STATE(20),
    [sym_preproc_pragma] = STATE(20),
    [sym_preproc_nullable] = STATE(20),
    [sym_preproc_error] = STATE(20),
    [sym_preproc_define] = STATE(20),
    [sym_preproc_undef] = STATE(20),
    [aux_sym_class_declaration_repeat1] = STATE(2800),
    [aux_sym_class_declaration_repeat2] = STATE(2922),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [aux_sym_preproc_if_in_top_level_repeat1] = STATE(18),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(153),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(155),
    [anon_sym_global] = ACTIONS(157),
    [anon_sym_using] = ACTIONS(159),
    [anon_sym_unsafe] = ACTIONS(161),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(165),
    [anon_sym_namespace] = ACTIONS(167),
    [anon_sym_class] = ACTIONS(169),
    [anon_sym_ref] = ACTIONS(171),
    [anon_sym_struct] = ACTIONS(173),
    [anon_sym_enum] = ACTIONS(175),
    [anon_sym_LBRACE] = ACTIONS(177),
    [anon_sym_interface] = ACTIONS(179),
    [anon_sym_delegate] = ACTIONS(181),
    [anon_sym_record] = ACTIONS(183),
    [anon_sym_abstract] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(37),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_file] = ACTIONS(65),
    [anon_sym_fixed] = ACTIONS(185),
    [anon_sym_internal] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(69),
    [anon_sym_override] = ACTIONS(63),
    [anon_sym_partial] = ACTIONS(63),
    [anon_sym_private] = ACTIONS(63),
    [anon_sym_protected] = ACTIONS(63),
    [anon_sym_public] = ACTIONS(63),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_required] = ACTIONS(63),
    [anon_sym_sealed] = ACTIONS(63),
    [anon_sym_virtual] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(187),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(189),
    [anon_sym_unchecked] = ACTIONS(187),
    [anon_sym_continue] = ACTIONS(191),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_while] = ACTIONS(195),
    [anon_sym_for] = ACTIONS(197),
    [anon_sym_lock] = ACTIONS(199),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(205),
    [anon_sym_try] = ACTIONS(207),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(209),
    [anon_sym_foreach] = ACTIONS(211),
    [anon_sym_goto] = ACTIONS(213),
    [anon_sym_if] = ACTIONS(215),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(217),
    [aux_sym_preproc_if_token3] = ACTIONS(641),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [21] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2647),
    [sym_variable_declaration] = STATE(9394),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6827),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2721),
    [sym_break_statement] = STATE(2647),
    [sym_checked_statement] = STATE(2647),
    [sym_continue_statement] = STATE(2647),
    [sym_do_statement] = STATE(2647),
    [sym_empty_statement] = STATE(2647),
    [sym_expression_statement] = STATE(2647),
    [sym_fixed_statement] = STATE(2647),
    [sym_for_statement] = STATE(2647),
    [sym_return_statement] = STATE(2647),
    [sym_lock_statement] = STATE(2647),
    [sym_yield_statement] = STATE(2647),
    [sym_switch_statement] = STATE(2647),
    [sym_throw_statement] = STATE(2647),
    [sym_try_statement] = STATE(2647),
    [sym_unsafe_statement] = STATE(2647),
    [sym_using_statement] = STATE(2647),
    [sym_foreach_statement] = STATE(2647),
    [sym_goto_statement] = STATE(2647),
    [sym_labeled_statement] = STATE(2647),
    [sym_if_statement] = STATE(2647),
    [sym_while_statement] = STATE(2647),
    [sym_local_declaration_statement] = STATE(2647),
    [sym_local_function_statement] = STATE(2647),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6543),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2835),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2647),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(21),
    [sym_preproc_endregion] = STATE(21),
    [sym_preproc_line] = STATE(21),
    [sym_preproc_pragma] = STATE(21),
    [sym_preproc_nullable] = STATE(21),
    [sym_preproc_error] = STATE(21),
    [sym_preproc_define] = STATE(21),
    [sym_preproc_undef] = STATE(21),
    [aux_sym_class_declaration_repeat1] = STATE(2918),
    [aux_sym_class_declaration_repeat2] = STATE(3106),
    [aux_sym_block_repeat1] = STATE(22),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(647),
    [anon_sym_unsafe] = ACTIONS(649),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(655),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(659),
    [anon_sym_RBRACE] = ACTIONS(661),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(667),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(671),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(673),
    [anon_sym_unchecked] = ACTIONS(671),
    [anon_sym_continue] = ACTIONS(675),
    [anon_sym_do] = ACTIONS(677),
    [anon_sym_while] = ACTIONS(679),
    [anon_sym_for] = ACTIONS(681),
    [anon_sym_lock] = ACTIONS(683),
    [anon_sym_yield] = ACTIONS(685),
    [anon_sym_switch] = ACTIONS(687),
    [anon_sym_case] = ACTIONS(689),
    [anon_sym_default] = ACTIONS(689),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_try] = ACTIONS(693),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(695),
    [anon_sym_foreach] = ACTIONS(697),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [22] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2647),
    [sym_variable_declaration] = STATE(9394),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6827),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2721),
    [sym_break_statement] = STATE(2647),
    [sym_checked_statement] = STATE(2647),
    [sym_continue_statement] = STATE(2647),
    [sym_do_statement] = STATE(2647),
    [sym_empty_statement] = STATE(2647),
    [sym_expression_statement] = STATE(2647),
    [sym_fixed_statement] = STATE(2647),
    [sym_for_statement] = STATE(2647),
    [sym_return_statement] = STATE(2647),
    [sym_lock_statement] = STATE(2647),
    [sym_yield_statement] = STATE(2647),
    [sym_switch_statement] = STATE(2647),
    [sym_throw_statement] = STATE(2647),
    [sym_try_statement] = STATE(2647),
    [sym_unsafe_statement] = STATE(2647),
    [sym_using_statement] = STATE(2647),
    [sym_foreach_statement] = STATE(2647),
    [sym_goto_statement] = STATE(2647),
    [sym_labeled_statement] = STATE(2647),
    [sym_if_statement] = STATE(2647),
    [sym_while_statement] = STATE(2647),
    [sym_local_declaration_statement] = STATE(2647),
    [sym_local_function_statement] = STATE(2647),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6543),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2835),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2647),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(22),
    [sym_preproc_endregion] = STATE(22),
    [sym_preproc_line] = STATE(22),
    [sym_preproc_pragma] = STATE(22),
    [sym_preproc_nullable] = STATE(22),
    [sym_preproc_error] = STATE(22),
    [sym_preproc_define] = STATE(22),
    [sym_preproc_undef] = STATE(22),
    [aux_sym_class_declaration_repeat1] = STATE(2918),
    [aux_sym_class_declaration_repeat2] = STATE(3106),
    [aux_sym_block_repeat1] = STATE(22),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(705),
    [anon_sym_extern] = ACTIONS(708),
    [anon_sym_alias] = ACTIONS(711),
    [anon_sym_SEMI] = ACTIONS(714),
    [anon_sym_global] = ACTIONS(711),
    [anon_sym_using] = ACTIONS(717),
    [anon_sym_unsafe] = ACTIONS(720),
    [anon_sym_static] = ACTIONS(723),
    [anon_sym_LBRACK] = ACTIONS(726),
    [anon_sym_LPAREN] = ACTIONS(729),
    [anon_sym_return] = ACTIONS(732),
    [anon_sym_ref] = ACTIONS(735),
    [anon_sym_LBRACE] = ACTIONS(738),
    [anon_sym_RBRACE] = ACTIONS(741),
    [anon_sym_delegate] = ACTIONS(743),
    [anon_sym_abstract] = ACTIONS(708),
    [anon_sym_async] = ACTIONS(723),
    [anon_sym_const] = ACTIONS(708),
    [anon_sym_file] = ACTIONS(746),
    [anon_sym_fixed] = ACTIONS(749),
    [anon_sym_internal] = ACTIONS(708),
    [anon_sym_new] = ACTIONS(752),
    [anon_sym_override] = ACTIONS(708),
    [anon_sym_partial] = ACTIONS(708),
    [anon_sym_private] = ACTIONS(708),
    [anon_sym_protected] = ACTIONS(708),
    [anon_sym_public] = ACTIONS(708),
    [anon_sym_readonly] = ACTIONS(708),
    [anon_sym_required] = ACTIONS(708),
    [anon_sym_sealed] = ACTIONS(708),
    [anon_sym_virtual] = ACTIONS(708),
    [anon_sym_volatile] = ACTIONS(708),
    [anon_sym_where] = ACTIONS(711),
    [anon_sym_notnull] = ACTIONS(711),
    [anon_sym_unmanaged] = ACTIONS(711),
    [anon_sym_checked] = ACTIONS(755),
    [anon_sym_BANG] = ACTIONS(758),
    [anon_sym_TILDE] = ACTIONS(758),
    [anon_sym_PLUS_PLUS] = ACTIONS(758),
    [anon_sym_DASH_DASH] = ACTIONS(758),
    [anon_sym_true] = ACTIONS(761),
    [anon_sym_false] = ACTIONS(761),
    [anon_sym_PLUS] = ACTIONS(764),
    [anon_sym_DASH] = ACTIONS(764),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_CARET] = ACTIONS(758),
    [anon_sym_AMP] = ACTIONS(758),
    [anon_sym_this] = ACTIONS(770),
    [anon_sym_scoped] = ACTIONS(773),
    [anon_sym_var] = ACTIONS(776),
    [sym_predefined_type] = ACTIONS(779),
    [anon_sym_break] = ACTIONS(782),
    [anon_sym_unchecked] = ACTIONS(755),
    [anon_sym_continue] = ACTIONS(785),
    [anon_sym_do] = ACTIONS(788),
    [anon_sym_while] = ACTIONS(791),
    [anon_sym_for] = ACTIONS(794),
    [anon_sym_lock] = ACTIONS(797),
    [anon_sym_yield] = ACTIONS(800),
    [anon_sym_switch] = ACTIONS(803),
    [anon_sym_case] = ACTIONS(806),
    [anon_sym_default] = ACTIONS(808),
    [anon_sym_throw] = ACTIONS(811),
    [anon_sym_try] = ACTIONS(814),
    [anon_sym_when] = ACTIONS(711),
    [anon_sym_await] = ACTIONS(817),
    [anon_sym_foreach] = ACTIONS(820),
    [anon_sym_goto] = ACTIONS(823),
    [anon_sym_if] = ACTIONS(826),
    [anon_sym_DOT_DOT] = ACTIONS(829),
    [anon_sym_from] = ACTIONS(832),
    [anon_sym_into] = ACTIONS(711),
    [anon_sym_join] = ACTIONS(711),
    [anon_sym_on] = ACTIONS(711),
    [anon_sym_equals] = ACTIONS(711),
    [anon_sym_let] = ACTIONS(711),
    [anon_sym_orderby] = ACTIONS(711),
    [anon_sym_ascending] = ACTIONS(711),
    [anon_sym_descending] = ACTIONS(711),
    [anon_sym_group] = ACTIONS(711),
    [anon_sym_by] = ACTIONS(711),
    [anon_sym_select] = ACTIONS(711),
    [anon_sym_DQUOTE] = ACTIONS(835),
    [anon_sym_stackalloc] = ACTIONS(838),
    [anon_sym_sizeof] = ACTIONS(841),
    [anon_sym_typeof] = ACTIONS(844),
    [anon_sym___makeref] = ACTIONS(847),
    [anon_sym___reftype] = ACTIONS(850),
    [anon_sym___refvalue] = ACTIONS(853),
    [sym_null_literal] = ACTIONS(856),
    [anon_sym_SQUOTE] = ACTIONS(859),
    [sym_integer_literal] = ACTIONS(856),
    [sym_real_literal] = ACTIONS(862),
    [sym_verbatim_string_literal] = ACTIONS(862),
    [sym_raw_string_literal] = ACTIONS(862),
    [aux_sym_preproc_if_token1] = ACTIONS(865),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(868),
    [sym_interpolation_verbatim_start] = ACTIONS(871),
    [sym_interpolation_raw_start] = ACTIONS(874),
  },
  [23] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2647),
    [sym_variable_declaration] = STATE(9394),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6827),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2721),
    [sym_break_statement] = STATE(2647),
    [sym_checked_statement] = STATE(2647),
    [sym_continue_statement] = STATE(2647),
    [sym_do_statement] = STATE(2647),
    [sym_empty_statement] = STATE(2647),
    [sym_expression_statement] = STATE(2647),
    [sym_fixed_statement] = STATE(2647),
    [sym_for_statement] = STATE(2647),
    [sym_return_statement] = STATE(2647),
    [sym_lock_statement] = STATE(2647),
    [sym_yield_statement] = STATE(2647),
    [sym_switch_statement] = STATE(2647),
    [sym_throw_statement] = STATE(2647),
    [sym_try_statement] = STATE(2647),
    [sym_unsafe_statement] = STATE(2647),
    [sym_using_statement] = STATE(2647),
    [sym_foreach_statement] = STATE(2647),
    [sym_goto_statement] = STATE(2647),
    [sym_labeled_statement] = STATE(2647),
    [sym_if_statement] = STATE(2647),
    [sym_while_statement] = STATE(2647),
    [sym_local_declaration_statement] = STATE(2647),
    [sym_local_function_statement] = STATE(2647),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6543),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2835),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2647),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(23),
    [sym_preproc_endregion] = STATE(23),
    [sym_preproc_line] = STATE(23),
    [sym_preproc_pragma] = STATE(23),
    [sym_preproc_nullable] = STATE(23),
    [sym_preproc_error] = STATE(23),
    [sym_preproc_define] = STATE(23),
    [sym_preproc_undef] = STATE(23),
    [aux_sym_class_declaration_repeat1] = STATE(2918),
    [aux_sym_class_declaration_repeat2] = STATE(3106),
    [aux_sym_block_repeat1] = STATE(37),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(647),
    [anon_sym_unsafe] = ACTIONS(649),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(655),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(659),
    [anon_sym_RBRACE] = ACTIONS(661),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(667),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(671),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(673),
    [anon_sym_unchecked] = ACTIONS(671),
    [anon_sym_continue] = ACTIONS(675),
    [anon_sym_do] = ACTIONS(677),
    [anon_sym_while] = ACTIONS(679),
    [anon_sym_for] = ACTIONS(681),
    [anon_sym_lock] = ACTIONS(683),
    [anon_sym_yield] = ACTIONS(685),
    [anon_sym_switch] = ACTIONS(687),
    [anon_sym_case] = ACTIONS(689),
    [anon_sym_default] = ACTIONS(689),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_try] = ACTIONS(693),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(695),
    [anon_sym_foreach] = ACTIONS(697),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [24] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2647),
    [sym_variable_declaration] = STATE(9394),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6841),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2721),
    [sym_break_statement] = STATE(2647),
    [sym_checked_statement] = STATE(2647),
    [sym_continue_statement] = STATE(2647),
    [sym_do_statement] = STATE(2647),
    [sym_empty_statement] = STATE(2647),
    [sym_expression_statement] = STATE(2647),
    [sym_fixed_statement] = STATE(2647),
    [sym_for_statement] = STATE(2647),
    [sym_return_statement] = STATE(2647),
    [sym_lock_statement] = STATE(2647),
    [sym_yield_statement] = STATE(2647),
    [sym_switch_statement] = STATE(2647),
    [sym_throw_statement] = STATE(2647),
    [sym_try_statement] = STATE(2647),
    [sym_unsafe_statement] = STATE(2647),
    [sym_using_statement] = STATE(2647),
    [sym_foreach_statement] = STATE(2647),
    [sym_goto_statement] = STATE(2647),
    [sym_labeled_statement] = STATE(2647),
    [sym_if_statement] = STATE(2647),
    [sym_while_statement] = STATE(2647),
    [sym_local_declaration_statement] = STATE(2647),
    [sym_local_function_statement] = STATE(2647),
    [sym_expression] = STATE(5808),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4314),
    [sym__expression_statement_expression] = STATE(6543),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2835),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2647),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(24),
    [sym_preproc_endregion] = STATE(24),
    [sym_preproc_line] = STATE(24),
    [sym_preproc_pragma] = STATE(24),
    [sym_preproc_nullable] = STATE(24),
    [sym_preproc_error] = STATE(24),
    [sym_preproc_define] = STATE(24),
    [sym_preproc_undef] = STATE(24),
    [aux_sym_class_declaration_repeat1] = STATE(2912),
    [aux_sym_class_declaration_repeat2] = STATE(3106),
    [aux_sym_block_repeat1] = STATE(49),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(647),
    [anon_sym_unsafe] = ACTIONS(649),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_COMMA] = ACTIONS(877),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_return] = ACTIONS(655),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(659),
    [anon_sym_RBRACE] = ACTIONS(883),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(667),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(671),
    [anon_sym_BANG] = ACTIONS(885),
    [anon_sym_TILDE] = ACTIONS(885),
    [anon_sym_PLUS_PLUS] = ACTIONS(885),
    [anon_sym_DASH_DASH] = ACTIONS(885),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(887),
    [anon_sym_DASH] = ACTIONS(887),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(885),
    [anon_sym_AMP] = ACTIONS(885),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(673),
    [anon_sym_unchecked] = ACTIONS(671),
    [anon_sym_continue] = ACTIONS(675),
    [anon_sym_do] = ACTIONS(677),
    [anon_sym_while] = ACTIONS(679),
    [anon_sym_for] = ACTIONS(681),
    [anon_sym_lock] = ACTIONS(683),
    [anon_sym_yield] = ACTIONS(685),
    [anon_sym_switch] = ACTIONS(687),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(891),
    [anon_sym_try] = ACTIONS(693),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(893),
    [anon_sym_foreach] = ACTIONS(697),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [25] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2647),
    [sym_variable_declaration] = STATE(9394),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6841),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2721),
    [sym_break_statement] = STATE(2647),
    [sym_checked_statement] = STATE(2647),
    [sym_continue_statement] = STATE(2647),
    [sym_do_statement] = STATE(2647),
    [sym_empty_statement] = STATE(2647),
    [sym_expression_statement] = STATE(2647),
    [sym_fixed_statement] = STATE(2647),
    [sym_for_statement] = STATE(2647),
    [sym_return_statement] = STATE(2647),
    [sym_lock_statement] = STATE(2647),
    [sym_yield_statement] = STATE(2647),
    [sym_switch_statement] = STATE(2647),
    [sym_throw_statement] = STATE(2647),
    [sym_try_statement] = STATE(2647),
    [sym_unsafe_statement] = STATE(2647),
    [sym_using_statement] = STATE(2647),
    [sym_foreach_statement] = STATE(2647),
    [sym_goto_statement] = STATE(2647),
    [sym_labeled_statement] = STATE(2647),
    [sym_if_statement] = STATE(2647),
    [sym_while_statement] = STATE(2647),
    [sym_local_declaration_statement] = STATE(2647),
    [sym_local_function_statement] = STATE(2647),
    [sym_expression] = STATE(5808),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4314),
    [sym__expression_statement_expression] = STATE(6543),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2835),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2647),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(25),
    [sym_preproc_endregion] = STATE(25),
    [sym_preproc_line] = STATE(25),
    [sym_preproc_pragma] = STATE(25),
    [sym_preproc_nullable] = STATE(25),
    [sym_preproc_error] = STATE(25),
    [sym_preproc_define] = STATE(25),
    [sym_preproc_undef] = STATE(25),
    [aux_sym_class_declaration_repeat1] = STATE(2912),
    [aux_sym_class_declaration_repeat2] = STATE(3106),
    [aux_sym_block_repeat1] = STATE(59),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(647),
    [anon_sym_unsafe] = ACTIONS(649),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_COMMA] = ACTIONS(877),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_return] = ACTIONS(655),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(659),
    [anon_sym_RBRACE] = ACTIONS(897),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(667),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(671),
    [anon_sym_BANG] = ACTIONS(885),
    [anon_sym_TILDE] = ACTIONS(885),
    [anon_sym_PLUS_PLUS] = ACTIONS(885),
    [anon_sym_DASH_DASH] = ACTIONS(885),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(887),
    [anon_sym_DASH] = ACTIONS(887),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(885),
    [anon_sym_AMP] = ACTIONS(885),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(673),
    [anon_sym_unchecked] = ACTIONS(671),
    [anon_sym_continue] = ACTIONS(675),
    [anon_sym_do] = ACTIONS(677),
    [anon_sym_while] = ACTIONS(679),
    [anon_sym_for] = ACTIONS(681),
    [anon_sym_lock] = ACTIONS(683),
    [anon_sym_yield] = ACTIONS(685),
    [anon_sym_switch] = ACTIONS(687),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(891),
    [anon_sym_try] = ACTIONS(693),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(893),
    [anon_sym_foreach] = ACTIONS(697),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [26] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2647),
    [sym_variable_declaration] = STATE(9394),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6841),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2721),
    [sym_break_statement] = STATE(2647),
    [sym_checked_statement] = STATE(2647),
    [sym_continue_statement] = STATE(2647),
    [sym_do_statement] = STATE(2647),
    [sym_empty_statement] = STATE(2647),
    [sym_expression_statement] = STATE(2647),
    [sym_fixed_statement] = STATE(2647),
    [sym_for_statement] = STATE(2647),
    [sym_return_statement] = STATE(2647),
    [sym_lock_statement] = STATE(2647),
    [sym_yield_statement] = STATE(2647),
    [sym_switch_statement] = STATE(2647),
    [sym_throw_statement] = STATE(2647),
    [sym_try_statement] = STATE(2647),
    [sym_unsafe_statement] = STATE(2647),
    [sym_using_statement] = STATE(2647),
    [sym_foreach_statement] = STATE(2647),
    [sym_goto_statement] = STATE(2647),
    [sym_labeled_statement] = STATE(2647),
    [sym_if_statement] = STATE(2647),
    [sym_while_statement] = STATE(2647),
    [sym_local_declaration_statement] = STATE(2647),
    [sym_local_function_statement] = STATE(2647),
    [sym_expression] = STATE(5808),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4314),
    [sym__expression_statement_expression] = STATE(6543),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2835),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2647),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(26),
    [sym_preproc_endregion] = STATE(26),
    [sym_preproc_line] = STATE(26),
    [sym_preproc_pragma] = STATE(26),
    [sym_preproc_nullable] = STATE(26),
    [sym_preproc_error] = STATE(26),
    [sym_preproc_define] = STATE(26),
    [sym_preproc_undef] = STATE(26),
    [aux_sym_class_declaration_repeat1] = STATE(2912),
    [aux_sym_class_declaration_repeat2] = STATE(3106),
    [aux_sym_block_repeat1] = STATE(49),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(647),
    [anon_sym_unsafe] = ACTIONS(649),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_COMMA] = ACTIONS(877),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_return] = ACTIONS(655),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(659),
    [anon_sym_RBRACE] = ACTIONS(899),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(667),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(671),
    [anon_sym_BANG] = ACTIONS(885),
    [anon_sym_TILDE] = ACTIONS(885),
    [anon_sym_PLUS_PLUS] = ACTIONS(885),
    [anon_sym_DASH_DASH] = ACTIONS(885),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(887),
    [anon_sym_DASH] = ACTIONS(887),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(885),
    [anon_sym_AMP] = ACTIONS(885),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(673),
    [anon_sym_unchecked] = ACTIONS(671),
    [anon_sym_continue] = ACTIONS(675),
    [anon_sym_do] = ACTIONS(677),
    [anon_sym_while] = ACTIONS(679),
    [anon_sym_for] = ACTIONS(681),
    [anon_sym_lock] = ACTIONS(683),
    [anon_sym_yield] = ACTIONS(685),
    [anon_sym_switch] = ACTIONS(687),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(891),
    [anon_sym_try] = ACTIONS(693),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(893),
    [anon_sym_foreach] = ACTIONS(697),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [27] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2647),
    [sym_variable_declaration] = STATE(9394),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6827),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2721),
    [sym_break_statement] = STATE(2647),
    [sym_checked_statement] = STATE(2647),
    [sym_continue_statement] = STATE(2647),
    [sym_do_statement] = STATE(2647),
    [sym_empty_statement] = STATE(2647),
    [sym_expression_statement] = STATE(2647),
    [sym_fixed_statement] = STATE(2647),
    [sym_for_statement] = STATE(2647),
    [sym_return_statement] = STATE(2647),
    [sym_lock_statement] = STATE(2647),
    [sym_yield_statement] = STATE(2647),
    [sym_switch_statement] = STATE(2647),
    [sym_throw_statement] = STATE(2647),
    [sym_try_statement] = STATE(2647),
    [sym_unsafe_statement] = STATE(2647),
    [sym_using_statement] = STATE(2647),
    [sym_foreach_statement] = STATE(2647),
    [sym_goto_statement] = STATE(2647),
    [sym_labeled_statement] = STATE(2647),
    [sym_if_statement] = STATE(2647),
    [sym_while_statement] = STATE(2647),
    [sym_local_declaration_statement] = STATE(2647),
    [sym_local_function_statement] = STATE(2647),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6543),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2835),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2647),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(27),
    [sym_preproc_endregion] = STATE(27),
    [sym_preproc_line] = STATE(27),
    [sym_preproc_pragma] = STATE(27),
    [sym_preproc_nullable] = STATE(27),
    [sym_preproc_error] = STATE(27),
    [sym_preproc_define] = STATE(27),
    [sym_preproc_undef] = STATE(27),
    [aux_sym_class_declaration_repeat1] = STATE(2918),
    [aux_sym_class_declaration_repeat2] = STATE(3106),
    [aux_sym_block_repeat1] = STATE(22),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(647),
    [anon_sym_unsafe] = ACTIONS(649),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(655),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(659),
    [anon_sym_RBRACE] = ACTIONS(901),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(667),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(671),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(673),
    [anon_sym_unchecked] = ACTIONS(671),
    [anon_sym_continue] = ACTIONS(675),
    [anon_sym_do] = ACTIONS(677),
    [anon_sym_while] = ACTIONS(679),
    [anon_sym_for] = ACTIONS(681),
    [anon_sym_lock] = ACTIONS(683),
    [anon_sym_yield] = ACTIONS(685),
    [anon_sym_switch] = ACTIONS(687),
    [anon_sym_case] = ACTIONS(903),
    [anon_sym_default] = ACTIONS(903),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_try] = ACTIONS(693),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(695),
    [anon_sym_foreach] = ACTIONS(697),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [28] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2647),
    [sym_variable_declaration] = STATE(9394),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6827),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2721),
    [sym_break_statement] = STATE(2647),
    [sym_checked_statement] = STATE(2647),
    [sym_continue_statement] = STATE(2647),
    [sym_do_statement] = STATE(2647),
    [sym_empty_statement] = STATE(2647),
    [sym_expression_statement] = STATE(2647),
    [sym_fixed_statement] = STATE(2647),
    [sym_for_statement] = STATE(2647),
    [sym_return_statement] = STATE(2647),
    [sym_lock_statement] = STATE(2647),
    [sym_yield_statement] = STATE(2647),
    [sym_switch_statement] = STATE(2647),
    [sym_throw_statement] = STATE(2647),
    [sym_try_statement] = STATE(2647),
    [sym_unsafe_statement] = STATE(2647),
    [sym_using_statement] = STATE(2647),
    [sym_foreach_statement] = STATE(2647),
    [sym_goto_statement] = STATE(2647),
    [sym_labeled_statement] = STATE(2647),
    [sym_if_statement] = STATE(2647),
    [sym_while_statement] = STATE(2647),
    [sym_local_declaration_statement] = STATE(2647),
    [sym_local_function_statement] = STATE(2647),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6543),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2835),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2647),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(28),
    [sym_preproc_endregion] = STATE(28),
    [sym_preproc_line] = STATE(28),
    [sym_preproc_pragma] = STATE(28),
    [sym_preproc_nullable] = STATE(28),
    [sym_preproc_error] = STATE(28),
    [sym_preproc_define] = STATE(28),
    [sym_preproc_undef] = STATE(28),
    [aux_sym_class_declaration_repeat1] = STATE(2918),
    [aux_sym_class_declaration_repeat2] = STATE(3106),
    [aux_sym_block_repeat1] = STATE(21),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(647),
    [anon_sym_unsafe] = ACTIONS(649),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(655),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(659),
    [anon_sym_RBRACE] = ACTIONS(905),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(667),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(671),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(673),
    [anon_sym_unchecked] = ACTIONS(671),
    [anon_sym_continue] = ACTIONS(675),
    [anon_sym_do] = ACTIONS(677),
    [anon_sym_while] = ACTIONS(679),
    [anon_sym_for] = ACTIONS(681),
    [anon_sym_lock] = ACTIONS(683),
    [anon_sym_yield] = ACTIONS(685),
    [anon_sym_switch] = ACTIONS(687),
    [anon_sym_case] = ACTIONS(907),
    [anon_sym_default] = ACTIONS(907),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_try] = ACTIONS(693),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(695),
    [anon_sym_foreach] = ACTIONS(697),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [29] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2647),
    [sym_variable_declaration] = STATE(9394),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6841),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2721),
    [sym_break_statement] = STATE(2647),
    [sym_checked_statement] = STATE(2647),
    [sym_continue_statement] = STATE(2647),
    [sym_do_statement] = STATE(2647),
    [sym_empty_statement] = STATE(2647),
    [sym_expression_statement] = STATE(2647),
    [sym_fixed_statement] = STATE(2647),
    [sym_for_statement] = STATE(2647),
    [sym_return_statement] = STATE(2647),
    [sym_lock_statement] = STATE(2647),
    [sym_yield_statement] = STATE(2647),
    [sym_switch_statement] = STATE(2647),
    [sym_throw_statement] = STATE(2647),
    [sym_try_statement] = STATE(2647),
    [sym_unsafe_statement] = STATE(2647),
    [sym_using_statement] = STATE(2647),
    [sym_foreach_statement] = STATE(2647),
    [sym_goto_statement] = STATE(2647),
    [sym_labeled_statement] = STATE(2647),
    [sym_if_statement] = STATE(2647),
    [sym_while_statement] = STATE(2647),
    [sym_local_declaration_statement] = STATE(2647),
    [sym_local_function_statement] = STATE(2647),
    [sym_expression] = STATE(6002),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4314),
    [sym__expression_statement_expression] = STATE(6543),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2835),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2647),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(29),
    [sym_preproc_endregion] = STATE(29),
    [sym_preproc_line] = STATE(29),
    [sym_preproc_pragma] = STATE(29),
    [sym_preproc_nullable] = STATE(29),
    [sym_preproc_error] = STATE(29),
    [sym_preproc_define] = STATE(29),
    [sym_preproc_undef] = STATE(29),
    [aux_sym_class_declaration_repeat1] = STATE(2912),
    [aux_sym_class_declaration_repeat2] = STATE(3106),
    [aux_sym_block_repeat1] = STATE(48),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(647),
    [anon_sym_unsafe] = ACTIONS(649),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_return] = ACTIONS(655),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(659),
    [anon_sym_RBRACE] = ACTIONS(911),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(667),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(671),
    [anon_sym_BANG] = ACTIONS(885),
    [anon_sym_TILDE] = ACTIONS(885),
    [anon_sym_PLUS_PLUS] = ACTIONS(885),
    [anon_sym_DASH_DASH] = ACTIONS(885),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(887),
    [anon_sym_DASH] = ACTIONS(887),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(885),
    [anon_sym_AMP] = ACTIONS(885),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(673),
    [anon_sym_unchecked] = ACTIONS(671),
    [anon_sym_continue] = ACTIONS(675),
    [anon_sym_do] = ACTIONS(677),
    [anon_sym_while] = ACTIONS(679),
    [anon_sym_for] = ACTIONS(681),
    [anon_sym_lock] = ACTIONS(683),
    [anon_sym_yield] = ACTIONS(685),
    [anon_sym_switch] = ACTIONS(687),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(891),
    [anon_sym_try] = ACTIONS(693),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(893),
    [anon_sym_foreach] = ACTIONS(697),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [30] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2647),
    [sym_variable_declaration] = STATE(9394),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6841),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2721),
    [sym_break_statement] = STATE(2647),
    [sym_checked_statement] = STATE(2647),
    [sym_continue_statement] = STATE(2647),
    [sym_do_statement] = STATE(2647),
    [sym_empty_statement] = STATE(2647),
    [sym_expression_statement] = STATE(2647),
    [sym_fixed_statement] = STATE(2647),
    [sym_for_statement] = STATE(2647),
    [sym_return_statement] = STATE(2647),
    [sym_lock_statement] = STATE(2647),
    [sym_yield_statement] = STATE(2647),
    [sym_switch_statement] = STATE(2647),
    [sym_throw_statement] = STATE(2647),
    [sym_try_statement] = STATE(2647),
    [sym_unsafe_statement] = STATE(2647),
    [sym_using_statement] = STATE(2647),
    [sym_foreach_statement] = STATE(2647),
    [sym_goto_statement] = STATE(2647),
    [sym_labeled_statement] = STATE(2647),
    [sym_if_statement] = STATE(2647),
    [sym_while_statement] = STATE(2647),
    [sym_local_declaration_statement] = STATE(2647),
    [sym_local_function_statement] = STATE(2647),
    [sym_expression] = STATE(5808),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4314),
    [sym__expression_statement_expression] = STATE(6543),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2835),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2647),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(30),
    [sym_preproc_endregion] = STATE(30),
    [sym_preproc_line] = STATE(30),
    [sym_preproc_pragma] = STATE(30),
    [sym_preproc_nullable] = STATE(30),
    [sym_preproc_error] = STATE(30),
    [sym_preproc_define] = STATE(30),
    [sym_preproc_undef] = STATE(30),
    [aux_sym_class_declaration_repeat1] = STATE(2912),
    [aux_sym_class_declaration_repeat2] = STATE(3106),
    [aux_sym_block_repeat1] = STATE(52),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(647),
    [anon_sym_unsafe] = ACTIONS(649),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_COMMA] = ACTIONS(877),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_return] = ACTIONS(655),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(659),
    [anon_sym_RBRACE] = ACTIONS(913),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(667),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(671),
    [anon_sym_BANG] = ACTIONS(885),
    [anon_sym_TILDE] = ACTIONS(885),
    [anon_sym_PLUS_PLUS] = ACTIONS(885),
    [anon_sym_DASH_DASH] = ACTIONS(885),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(887),
    [anon_sym_DASH] = ACTIONS(887),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(885),
    [anon_sym_AMP] = ACTIONS(885),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(673),
    [anon_sym_unchecked] = ACTIONS(671),
    [anon_sym_continue] = ACTIONS(675),
    [anon_sym_do] = ACTIONS(677),
    [anon_sym_while] = ACTIONS(679),
    [anon_sym_for] = ACTIONS(681),
    [anon_sym_lock] = ACTIONS(683),
    [anon_sym_yield] = ACTIONS(685),
    [anon_sym_switch] = ACTIONS(687),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(891),
    [anon_sym_try] = ACTIONS(693),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(893),
    [anon_sym_foreach] = ACTIONS(697),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [31] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2647),
    [sym_variable_declaration] = STATE(9394),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6841),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2721),
    [sym_break_statement] = STATE(2647),
    [sym_checked_statement] = STATE(2647),
    [sym_continue_statement] = STATE(2647),
    [sym_do_statement] = STATE(2647),
    [sym_empty_statement] = STATE(2647),
    [sym_expression_statement] = STATE(2647),
    [sym_fixed_statement] = STATE(2647),
    [sym_for_statement] = STATE(2647),
    [sym_return_statement] = STATE(2647),
    [sym_lock_statement] = STATE(2647),
    [sym_yield_statement] = STATE(2647),
    [sym_switch_statement] = STATE(2647),
    [sym_throw_statement] = STATE(2647),
    [sym_try_statement] = STATE(2647),
    [sym_unsafe_statement] = STATE(2647),
    [sym_using_statement] = STATE(2647),
    [sym_foreach_statement] = STATE(2647),
    [sym_goto_statement] = STATE(2647),
    [sym_labeled_statement] = STATE(2647),
    [sym_if_statement] = STATE(2647),
    [sym_while_statement] = STATE(2647),
    [sym_local_declaration_statement] = STATE(2647),
    [sym_local_function_statement] = STATE(2647),
    [sym_expression] = STATE(5803),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4314),
    [sym__expression_statement_expression] = STATE(6543),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2835),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2647),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(31),
    [sym_preproc_endregion] = STATE(31),
    [sym_preproc_line] = STATE(31),
    [sym_preproc_pragma] = STATE(31),
    [sym_preproc_nullable] = STATE(31),
    [sym_preproc_error] = STATE(31),
    [sym_preproc_define] = STATE(31),
    [sym_preproc_undef] = STATE(31),
    [aux_sym_class_declaration_repeat1] = STATE(2912),
    [aux_sym_class_declaration_repeat2] = STATE(3106),
    [aux_sym_block_repeat1] = STATE(38),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(647),
    [anon_sym_unsafe] = ACTIONS(649),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_COMMA] = ACTIONS(915),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_return] = ACTIONS(655),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(659),
    [anon_sym_RBRACE] = ACTIONS(917),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(667),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(671),
    [anon_sym_BANG] = ACTIONS(885),
    [anon_sym_TILDE] = ACTIONS(885),
    [anon_sym_PLUS_PLUS] = ACTIONS(885),
    [anon_sym_DASH_DASH] = ACTIONS(885),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(887),
    [anon_sym_DASH] = ACTIONS(887),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(885),
    [anon_sym_AMP] = ACTIONS(885),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(673),
    [anon_sym_unchecked] = ACTIONS(671),
    [anon_sym_continue] = ACTIONS(675),
    [anon_sym_do] = ACTIONS(677),
    [anon_sym_while] = ACTIONS(679),
    [anon_sym_for] = ACTIONS(681),
    [anon_sym_lock] = ACTIONS(683),
    [anon_sym_yield] = ACTIONS(685),
    [anon_sym_switch] = ACTIONS(687),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(891),
    [anon_sym_try] = ACTIONS(693),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(893),
    [anon_sym_foreach] = ACTIONS(697),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [32] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2647),
    [sym_variable_declaration] = STATE(9394),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6841),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2721),
    [sym_break_statement] = STATE(2647),
    [sym_checked_statement] = STATE(2647),
    [sym_continue_statement] = STATE(2647),
    [sym_do_statement] = STATE(2647),
    [sym_empty_statement] = STATE(2647),
    [sym_expression_statement] = STATE(2647),
    [sym_fixed_statement] = STATE(2647),
    [sym_for_statement] = STATE(2647),
    [sym_return_statement] = STATE(2647),
    [sym_lock_statement] = STATE(2647),
    [sym_yield_statement] = STATE(2647),
    [sym_switch_statement] = STATE(2647),
    [sym_throw_statement] = STATE(2647),
    [sym_try_statement] = STATE(2647),
    [sym_unsafe_statement] = STATE(2647),
    [sym_using_statement] = STATE(2647),
    [sym_foreach_statement] = STATE(2647),
    [sym_goto_statement] = STATE(2647),
    [sym_labeled_statement] = STATE(2647),
    [sym_if_statement] = STATE(2647),
    [sym_while_statement] = STATE(2647),
    [sym_local_declaration_statement] = STATE(2647),
    [sym_local_function_statement] = STATE(2647),
    [sym_expression] = STATE(5853),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4314),
    [sym__expression_statement_expression] = STATE(6543),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2835),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2647),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(32),
    [sym_preproc_endregion] = STATE(32),
    [sym_preproc_line] = STATE(32),
    [sym_preproc_pragma] = STATE(32),
    [sym_preproc_nullable] = STATE(32),
    [sym_preproc_error] = STATE(32),
    [sym_preproc_define] = STATE(32),
    [sym_preproc_undef] = STATE(32),
    [aux_sym_class_declaration_repeat1] = STATE(2912),
    [aux_sym_class_declaration_repeat2] = STATE(3106),
    [aux_sym_block_repeat1] = STATE(56),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(647),
    [anon_sym_unsafe] = ACTIONS(649),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_COMMA] = ACTIONS(919),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_return] = ACTIONS(655),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(659),
    [anon_sym_RBRACE] = ACTIONS(921),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(667),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(671),
    [anon_sym_BANG] = ACTIONS(885),
    [anon_sym_TILDE] = ACTIONS(885),
    [anon_sym_PLUS_PLUS] = ACTIONS(885),
    [anon_sym_DASH_DASH] = ACTIONS(885),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(887),
    [anon_sym_DASH] = ACTIONS(887),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(885),
    [anon_sym_AMP] = ACTIONS(885),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(673),
    [anon_sym_unchecked] = ACTIONS(671),
    [anon_sym_continue] = ACTIONS(675),
    [anon_sym_do] = ACTIONS(677),
    [anon_sym_while] = ACTIONS(679),
    [anon_sym_for] = ACTIONS(681),
    [anon_sym_lock] = ACTIONS(683),
    [anon_sym_yield] = ACTIONS(685),
    [anon_sym_switch] = ACTIONS(687),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(891),
    [anon_sym_try] = ACTIONS(693),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(893),
    [anon_sym_foreach] = ACTIONS(697),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [33] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2647),
    [sym_variable_declaration] = STATE(9394),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6841),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2721),
    [sym_break_statement] = STATE(2647),
    [sym_checked_statement] = STATE(2647),
    [sym_continue_statement] = STATE(2647),
    [sym_do_statement] = STATE(2647),
    [sym_empty_statement] = STATE(2647),
    [sym_expression_statement] = STATE(2647),
    [sym_fixed_statement] = STATE(2647),
    [sym_for_statement] = STATE(2647),
    [sym_return_statement] = STATE(2647),
    [sym_lock_statement] = STATE(2647),
    [sym_yield_statement] = STATE(2647),
    [sym_switch_statement] = STATE(2647),
    [sym_throw_statement] = STATE(2647),
    [sym_try_statement] = STATE(2647),
    [sym_unsafe_statement] = STATE(2647),
    [sym_using_statement] = STATE(2647),
    [sym_foreach_statement] = STATE(2647),
    [sym_goto_statement] = STATE(2647),
    [sym_labeled_statement] = STATE(2647),
    [sym_if_statement] = STATE(2647),
    [sym_while_statement] = STATE(2647),
    [sym_local_declaration_statement] = STATE(2647),
    [sym_local_function_statement] = STATE(2647),
    [sym_expression] = STATE(6076),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4314),
    [sym__expression_statement_expression] = STATE(6543),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2835),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2647),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(33),
    [sym_preproc_endregion] = STATE(33),
    [sym_preproc_line] = STATE(33),
    [sym_preproc_pragma] = STATE(33),
    [sym_preproc_nullable] = STATE(33),
    [sym_preproc_error] = STATE(33),
    [sym_preproc_define] = STATE(33),
    [sym_preproc_undef] = STATE(33),
    [aux_sym_class_declaration_repeat1] = STATE(2912),
    [aux_sym_class_declaration_repeat2] = STATE(3106),
    [aux_sym_block_repeat1] = STATE(45),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(647),
    [anon_sym_unsafe] = ACTIONS(649),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_COMMA] = ACTIONS(923),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_return] = ACTIONS(655),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(659),
    [anon_sym_RBRACE] = ACTIONS(925),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(667),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(671),
    [anon_sym_BANG] = ACTIONS(885),
    [anon_sym_TILDE] = ACTIONS(885),
    [anon_sym_PLUS_PLUS] = ACTIONS(885),
    [anon_sym_DASH_DASH] = ACTIONS(885),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(887),
    [anon_sym_DASH] = ACTIONS(887),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(885),
    [anon_sym_AMP] = ACTIONS(885),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(673),
    [anon_sym_unchecked] = ACTIONS(671),
    [anon_sym_continue] = ACTIONS(675),
    [anon_sym_do] = ACTIONS(677),
    [anon_sym_while] = ACTIONS(679),
    [anon_sym_for] = ACTIONS(681),
    [anon_sym_lock] = ACTIONS(683),
    [anon_sym_yield] = ACTIONS(685),
    [anon_sym_switch] = ACTIONS(687),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(891),
    [anon_sym_try] = ACTIONS(693),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(893),
    [anon_sym_foreach] = ACTIONS(697),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [34] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2647),
    [sym_variable_declaration] = STATE(9394),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6841),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2721),
    [sym_break_statement] = STATE(2647),
    [sym_checked_statement] = STATE(2647),
    [sym_continue_statement] = STATE(2647),
    [sym_do_statement] = STATE(2647),
    [sym_empty_statement] = STATE(2647),
    [sym_expression_statement] = STATE(2647),
    [sym_fixed_statement] = STATE(2647),
    [sym_for_statement] = STATE(2647),
    [sym_return_statement] = STATE(2647),
    [sym_lock_statement] = STATE(2647),
    [sym_yield_statement] = STATE(2647),
    [sym_switch_statement] = STATE(2647),
    [sym_throw_statement] = STATE(2647),
    [sym_try_statement] = STATE(2647),
    [sym_unsafe_statement] = STATE(2647),
    [sym_using_statement] = STATE(2647),
    [sym_foreach_statement] = STATE(2647),
    [sym_goto_statement] = STATE(2647),
    [sym_labeled_statement] = STATE(2647),
    [sym_if_statement] = STATE(2647),
    [sym_while_statement] = STATE(2647),
    [sym_local_declaration_statement] = STATE(2647),
    [sym_local_function_statement] = STATE(2647),
    [sym_expression] = STATE(5973),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4314),
    [sym__expression_statement_expression] = STATE(6543),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2835),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2647),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(34),
    [sym_preproc_endregion] = STATE(34),
    [sym_preproc_line] = STATE(34),
    [sym_preproc_pragma] = STATE(34),
    [sym_preproc_nullable] = STATE(34),
    [sym_preproc_error] = STATE(34),
    [sym_preproc_define] = STATE(34),
    [sym_preproc_undef] = STATE(34),
    [aux_sym_class_declaration_repeat1] = STATE(2912),
    [aux_sym_class_declaration_repeat2] = STATE(3106),
    [aux_sym_block_repeat1] = STATE(39),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(647),
    [anon_sym_unsafe] = ACTIONS(649),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_COMMA] = ACTIONS(927),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_return] = ACTIONS(655),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(659),
    [anon_sym_RBRACE] = ACTIONS(929),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(667),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(671),
    [anon_sym_BANG] = ACTIONS(885),
    [anon_sym_TILDE] = ACTIONS(885),
    [anon_sym_PLUS_PLUS] = ACTIONS(885),
    [anon_sym_DASH_DASH] = ACTIONS(885),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(887),
    [anon_sym_DASH] = ACTIONS(887),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(885),
    [anon_sym_AMP] = ACTIONS(885),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(673),
    [anon_sym_unchecked] = ACTIONS(671),
    [anon_sym_continue] = ACTIONS(675),
    [anon_sym_do] = ACTIONS(677),
    [anon_sym_while] = ACTIONS(679),
    [anon_sym_for] = ACTIONS(681),
    [anon_sym_lock] = ACTIONS(683),
    [anon_sym_yield] = ACTIONS(685),
    [anon_sym_switch] = ACTIONS(687),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(891),
    [anon_sym_try] = ACTIONS(693),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(893),
    [anon_sym_foreach] = ACTIONS(697),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [35] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2647),
    [sym_variable_declaration] = STATE(9394),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6827),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2721),
    [sym_break_statement] = STATE(2647),
    [sym_checked_statement] = STATE(2647),
    [sym_continue_statement] = STATE(2647),
    [sym_do_statement] = STATE(2647),
    [sym_empty_statement] = STATE(2647),
    [sym_expression_statement] = STATE(2647),
    [sym_fixed_statement] = STATE(2647),
    [sym_for_statement] = STATE(2647),
    [sym_return_statement] = STATE(2647),
    [sym_lock_statement] = STATE(2647),
    [sym_yield_statement] = STATE(2647),
    [sym_switch_statement] = STATE(2647),
    [sym_throw_statement] = STATE(2647),
    [sym_try_statement] = STATE(2647),
    [sym_unsafe_statement] = STATE(2647),
    [sym_using_statement] = STATE(2647),
    [sym_foreach_statement] = STATE(2647),
    [sym_goto_statement] = STATE(2647),
    [sym_labeled_statement] = STATE(2647),
    [sym_if_statement] = STATE(2647),
    [sym_while_statement] = STATE(2647),
    [sym_local_declaration_statement] = STATE(2647),
    [sym_local_function_statement] = STATE(2647),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6543),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2835),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2647),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(35),
    [sym_preproc_endregion] = STATE(35),
    [sym_preproc_line] = STATE(35),
    [sym_preproc_pragma] = STATE(35),
    [sym_preproc_nullable] = STATE(35),
    [sym_preproc_error] = STATE(35),
    [sym_preproc_define] = STATE(35),
    [sym_preproc_undef] = STATE(35),
    [aux_sym_class_declaration_repeat1] = STATE(2918),
    [aux_sym_class_declaration_repeat2] = STATE(3106),
    [aux_sym_block_repeat1] = STATE(27),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(647),
    [anon_sym_unsafe] = ACTIONS(649),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(655),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(659),
    [anon_sym_RBRACE] = ACTIONS(931),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(667),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(671),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(673),
    [anon_sym_unchecked] = ACTIONS(671),
    [anon_sym_continue] = ACTIONS(675),
    [anon_sym_do] = ACTIONS(677),
    [anon_sym_while] = ACTIONS(679),
    [anon_sym_for] = ACTIONS(681),
    [anon_sym_lock] = ACTIONS(683),
    [anon_sym_yield] = ACTIONS(685),
    [anon_sym_switch] = ACTIONS(687),
    [anon_sym_case] = ACTIONS(933),
    [anon_sym_default] = ACTIONS(933),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_try] = ACTIONS(693),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(695),
    [anon_sym_foreach] = ACTIONS(697),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [36] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2647),
    [sym_variable_declaration] = STATE(9394),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6841),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2721),
    [sym_break_statement] = STATE(2647),
    [sym_checked_statement] = STATE(2647),
    [sym_continue_statement] = STATE(2647),
    [sym_do_statement] = STATE(2647),
    [sym_empty_statement] = STATE(2647),
    [sym_expression_statement] = STATE(2647),
    [sym_fixed_statement] = STATE(2647),
    [sym_for_statement] = STATE(2647),
    [sym_return_statement] = STATE(2647),
    [sym_lock_statement] = STATE(2647),
    [sym_yield_statement] = STATE(2647),
    [sym_switch_statement] = STATE(2647),
    [sym_throw_statement] = STATE(2647),
    [sym_try_statement] = STATE(2647),
    [sym_unsafe_statement] = STATE(2647),
    [sym_using_statement] = STATE(2647),
    [sym_foreach_statement] = STATE(2647),
    [sym_goto_statement] = STATE(2647),
    [sym_labeled_statement] = STATE(2647),
    [sym_if_statement] = STATE(2647),
    [sym_while_statement] = STATE(2647),
    [sym_local_declaration_statement] = STATE(2647),
    [sym_local_function_statement] = STATE(2647),
    [sym_expression] = STATE(5808),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4314),
    [sym__expression_statement_expression] = STATE(6543),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2835),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2647),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(36),
    [sym_preproc_endregion] = STATE(36),
    [sym_preproc_line] = STATE(36),
    [sym_preproc_pragma] = STATE(36),
    [sym_preproc_nullable] = STATE(36),
    [sym_preproc_error] = STATE(36),
    [sym_preproc_define] = STATE(36),
    [sym_preproc_undef] = STATE(36),
    [aux_sym_class_declaration_repeat1] = STATE(2912),
    [aux_sym_class_declaration_repeat2] = STATE(3106),
    [aux_sym_block_repeat1] = STATE(54),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(647),
    [anon_sym_unsafe] = ACTIONS(649),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_COMMA] = ACTIONS(877),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_return] = ACTIONS(655),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(659),
    [anon_sym_RBRACE] = ACTIONS(935),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(667),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(671),
    [anon_sym_BANG] = ACTIONS(885),
    [anon_sym_TILDE] = ACTIONS(885),
    [anon_sym_PLUS_PLUS] = ACTIONS(885),
    [anon_sym_DASH_DASH] = ACTIONS(885),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(887),
    [anon_sym_DASH] = ACTIONS(887),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(885),
    [anon_sym_AMP] = ACTIONS(885),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(673),
    [anon_sym_unchecked] = ACTIONS(671),
    [anon_sym_continue] = ACTIONS(675),
    [anon_sym_do] = ACTIONS(677),
    [anon_sym_while] = ACTIONS(679),
    [anon_sym_for] = ACTIONS(681),
    [anon_sym_lock] = ACTIONS(683),
    [anon_sym_yield] = ACTIONS(685),
    [anon_sym_switch] = ACTIONS(687),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(891),
    [anon_sym_try] = ACTIONS(693),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(893),
    [anon_sym_foreach] = ACTIONS(697),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [37] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2647),
    [sym_variable_declaration] = STATE(9394),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6827),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2721),
    [sym_break_statement] = STATE(2647),
    [sym_checked_statement] = STATE(2647),
    [sym_continue_statement] = STATE(2647),
    [sym_do_statement] = STATE(2647),
    [sym_empty_statement] = STATE(2647),
    [sym_expression_statement] = STATE(2647),
    [sym_fixed_statement] = STATE(2647),
    [sym_for_statement] = STATE(2647),
    [sym_return_statement] = STATE(2647),
    [sym_lock_statement] = STATE(2647),
    [sym_yield_statement] = STATE(2647),
    [sym_switch_statement] = STATE(2647),
    [sym_throw_statement] = STATE(2647),
    [sym_try_statement] = STATE(2647),
    [sym_unsafe_statement] = STATE(2647),
    [sym_using_statement] = STATE(2647),
    [sym_foreach_statement] = STATE(2647),
    [sym_goto_statement] = STATE(2647),
    [sym_labeled_statement] = STATE(2647),
    [sym_if_statement] = STATE(2647),
    [sym_while_statement] = STATE(2647),
    [sym_local_declaration_statement] = STATE(2647),
    [sym_local_function_statement] = STATE(2647),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6543),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2835),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2647),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(37),
    [sym_preproc_endregion] = STATE(37),
    [sym_preproc_line] = STATE(37),
    [sym_preproc_pragma] = STATE(37),
    [sym_preproc_nullable] = STATE(37),
    [sym_preproc_error] = STATE(37),
    [sym_preproc_define] = STATE(37),
    [sym_preproc_undef] = STATE(37),
    [aux_sym_class_declaration_repeat1] = STATE(2918),
    [aux_sym_class_declaration_repeat2] = STATE(3106),
    [aux_sym_block_repeat1] = STATE(22),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(647),
    [anon_sym_unsafe] = ACTIONS(649),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(655),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(659),
    [anon_sym_RBRACE] = ACTIONS(931),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(667),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(671),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(673),
    [anon_sym_unchecked] = ACTIONS(671),
    [anon_sym_continue] = ACTIONS(675),
    [anon_sym_do] = ACTIONS(677),
    [anon_sym_while] = ACTIONS(679),
    [anon_sym_for] = ACTIONS(681),
    [anon_sym_lock] = ACTIONS(683),
    [anon_sym_yield] = ACTIONS(685),
    [anon_sym_switch] = ACTIONS(687),
    [anon_sym_case] = ACTIONS(933),
    [anon_sym_default] = ACTIONS(933),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_try] = ACTIONS(693),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(695),
    [anon_sym_foreach] = ACTIONS(697),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [38] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2647),
    [sym_variable_declaration] = STATE(9394),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6827),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2721),
    [sym_break_statement] = STATE(2647),
    [sym_checked_statement] = STATE(2647),
    [sym_continue_statement] = STATE(2647),
    [sym_do_statement] = STATE(2647),
    [sym_empty_statement] = STATE(2647),
    [sym_expression_statement] = STATE(2647),
    [sym_fixed_statement] = STATE(2647),
    [sym_for_statement] = STATE(2647),
    [sym_return_statement] = STATE(2647),
    [sym_lock_statement] = STATE(2647),
    [sym_yield_statement] = STATE(2647),
    [sym_switch_statement] = STATE(2647),
    [sym_throw_statement] = STATE(2647),
    [sym_try_statement] = STATE(2647),
    [sym_unsafe_statement] = STATE(2647),
    [sym_using_statement] = STATE(2647),
    [sym_foreach_statement] = STATE(2647),
    [sym_goto_statement] = STATE(2647),
    [sym_labeled_statement] = STATE(2647),
    [sym_if_statement] = STATE(2647),
    [sym_while_statement] = STATE(2647),
    [sym_local_declaration_statement] = STATE(2647),
    [sym_local_function_statement] = STATE(2647),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6543),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2835),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2647),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(38),
    [sym_preproc_endregion] = STATE(38),
    [sym_preproc_line] = STATE(38),
    [sym_preproc_pragma] = STATE(38),
    [sym_preproc_nullable] = STATE(38),
    [sym_preproc_error] = STATE(38),
    [sym_preproc_define] = STATE(38),
    [sym_preproc_undef] = STATE(38),
    [aux_sym_class_declaration_repeat1] = STATE(2918),
    [aux_sym_class_declaration_repeat2] = STATE(3106),
    [aux_sym_block_repeat1] = STATE(22),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(647),
    [anon_sym_unsafe] = ACTIONS(649),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(655),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(659),
    [anon_sym_RBRACE] = ACTIONS(937),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(667),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(671),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(673),
    [anon_sym_unchecked] = ACTIONS(671),
    [anon_sym_continue] = ACTIONS(675),
    [anon_sym_do] = ACTIONS(677),
    [anon_sym_while] = ACTIONS(679),
    [anon_sym_for] = ACTIONS(681),
    [anon_sym_lock] = ACTIONS(683),
    [anon_sym_yield] = ACTIONS(685),
    [anon_sym_switch] = ACTIONS(687),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_try] = ACTIONS(693),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(695),
    [anon_sym_foreach] = ACTIONS(697),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [39] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2647),
    [sym_variable_declaration] = STATE(9394),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6827),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2721),
    [sym_break_statement] = STATE(2647),
    [sym_checked_statement] = STATE(2647),
    [sym_continue_statement] = STATE(2647),
    [sym_do_statement] = STATE(2647),
    [sym_empty_statement] = STATE(2647),
    [sym_expression_statement] = STATE(2647),
    [sym_fixed_statement] = STATE(2647),
    [sym_for_statement] = STATE(2647),
    [sym_return_statement] = STATE(2647),
    [sym_lock_statement] = STATE(2647),
    [sym_yield_statement] = STATE(2647),
    [sym_switch_statement] = STATE(2647),
    [sym_throw_statement] = STATE(2647),
    [sym_try_statement] = STATE(2647),
    [sym_unsafe_statement] = STATE(2647),
    [sym_using_statement] = STATE(2647),
    [sym_foreach_statement] = STATE(2647),
    [sym_goto_statement] = STATE(2647),
    [sym_labeled_statement] = STATE(2647),
    [sym_if_statement] = STATE(2647),
    [sym_while_statement] = STATE(2647),
    [sym_local_declaration_statement] = STATE(2647),
    [sym_local_function_statement] = STATE(2647),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6543),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2835),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2647),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(39),
    [sym_preproc_endregion] = STATE(39),
    [sym_preproc_line] = STATE(39),
    [sym_preproc_pragma] = STATE(39),
    [sym_preproc_nullable] = STATE(39),
    [sym_preproc_error] = STATE(39),
    [sym_preproc_define] = STATE(39),
    [sym_preproc_undef] = STATE(39),
    [aux_sym_class_declaration_repeat1] = STATE(2918),
    [aux_sym_class_declaration_repeat2] = STATE(3106),
    [aux_sym_block_repeat1] = STATE(22),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(647),
    [anon_sym_unsafe] = ACTIONS(649),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(655),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(659),
    [anon_sym_RBRACE] = ACTIONS(939),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(667),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(671),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(673),
    [anon_sym_unchecked] = ACTIONS(671),
    [anon_sym_continue] = ACTIONS(675),
    [anon_sym_do] = ACTIONS(677),
    [anon_sym_while] = ACTIONS(679),
    [anon_sym_for] = ACTIONS(681),
    [anon_sym_lock] = ACTIONS(683),
    [anon_sym_yield] = ACTIONS(685),
    [anon_sym_switch] = ACTIONS(687),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_try] = ACTIONS(693),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(695),
    [anon_sym_foreach] = ACTIONS(697),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [40] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2647),
    [sym_variable_declaration] = STATE(9394),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6827),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2721),
    [sym_break_statement] = STATE(2647),
    [sym_checked_statement] = STATE(2647),
    [sym_continue_statement] = STATE(2647),
    [sym_do_statement] = STATE(2647),
    [sym_empty_statement] = STATE(2647),
    [sym_expression_statement] = STATE(2647),
    [sym_fixed_statement] = STATE(2647),
    [sym_for_statement] = STATE(2647),
    [sym_return_statement] = STATE(2647),
    [sym_lock_statement] = STATE(2647),
    [sym_yield_statement] = STATE(2647),
    [sym_switch_statement] = STATE(2647),
    [sym_throw_statement] = STATE(2647),
    [sym_try_statement] = STATE(2647),
    [sym_unsafe_statement] = STATE(2647),
    [sym_using_statement] = STATE(2647),
    [sym_foreach_statement] = STATE(2647),
    [sym_goto_statement] = STATE(2647),
    [sym_labeled_statement] = STATE(2647),
    [sym_if_statement] = STATE(2647),
    [sym_while_statement] = STATE(2647),
    [sym_local_declaration_statement] = STATE(2647),
    [sym_local_function_statement] = STATE(2647),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6543),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2835),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2647),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(40),
    [sym_preproc_endregion] = STATE(40),
    [sym_preproc_line] = STATE(40),
    [sym_preproc_pragma] = STATE(40),
    [sym_preproc_nullable] = STATE(40),
    [sym_preproc_error] = STATE(40),
    [sym_preproc_define] = STATE(40),
    [sym_preproc_undef] = STATE(40),
    [aux_sym_class_declaration_repeat1] = STATE(2918),
    [aux_sym_class_declaration_repeat2] = STATE(3106),
    [aux_sym_block_repeat1] = STATE(56),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(647),
    [anon_sym_unsafe] = ACTIONS(649),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(655),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(659),
    [anon_sym_RBRACE] = ACTIONS(941),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(667),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(671),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(673),
    [anon_sym_unchecked] = ACTIONS(671),
    [anon_sym_continue] = ACTIONS(675),
    [anon_sym_do] = ACTIONS(677),
    [anon_sym_while] = ACTIONS(679),
    [anon_sym_for] = ACTIONS(681),
    [anon_sym_lock] = ACTIONS(683),
    [anon_sym_yield] = ACTIONS(685),
    [anon_sym_switch] = ACTIONS(687),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_try] = ACTIONS(693),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(695),
    [anon_sym_foreach] = ACTIONS(697),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [41] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2647),
    [sym_variable_declaration] = STATE(9394),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6827),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2721),
    [sym_break_statement] = STATE(2647),
    [sym_checked_statement] = STATE(2647),
    [sym_continue_statement] = STATE(2647),
    [sym_do_statement] = STATE(2647),
    [sym_empty_statement] = STATE(2647),
    [sym_expression_statement] = STATE(2647),
    [sym_fixed_statement] = STATE(2647),
    [sym_for_statement] = STATE(2647),
    [sym_return_statement] = STATE(2647),
    [sym_lock_statement] = STATE(2647),
    [sym_yield_statement] = STATE(2647),
    [sym_switch_statement] = STATE(2647),
    [sym_throw_statement] = STATE(2647),
    [sym_try_statement] = STATE(2647),
    [sym_unsafe_statement] = STATE(2647),
    [sym_using_statement] = STATE(2647),
    [sym_foreach_statement] = STATE(2647),
    [sym_goto_statement] = STATE(2647),
    [sym_labeled_statement] = STATE(2647),
    [sym_if_statement] = STATE(2647),
    [sym_while_statement] = STATE(2647),
    [sym_local_declaration_statement] = STATE(2647),
    [sym_local_function_statement] = STATE(2647),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6543),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2835),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2647),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(41),
    [sym_preproc_endregion] = STATE(41),
    [sym_preproc_line] = STATE(41),
    [sym_preproc_pragma] = STATE(41),
    [sym_preproc_nullable] = STATE(41),
    [sym_preproc_error] = STATE(41),
    [sym_preproc_define] = STATE(41),
    [sym_preproc_undef] = STATE(41),
    [aux_sym_class_declaration_repeat1] = STATE(2918),
    [aux_sym_class_declaration_repeat2] = STATE(3106),
    [aux_sym_block_repeat1] = STATE(59),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(647),
    [anon_sym_unsafe] = ACTIONS(649),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(655),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(659),
    [anon_sym_RBRACE] = ACTIONS(943),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(667),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(671),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(673),
    [anon_sym_unchecked] = ACTIONS(671),
    [anon_sym_continue] = ACTIONS(675),
    [anon_sym_do] = ACTIONS(677),
    [anon_sym_while] = ACTIONS(679),
    [anon_sym_for] = ACTIONS(681),
    [anon_sym_lock] = ACTIONS(683),
    [anon_sym_yield] = ACTIONS(685),
    [anon_sym_switch] = ACTIONS(687),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_try] = ACTIONS(693),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(695),
    [anon_sym_foreach] = ACTIONS(697),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [42] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2647),
    [sym_variable_declaration] = STATE(9394),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6827),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2721),
    [sym_break_statement] = STATE(2647),
    [sym_checked_statement] = STATE(2647),
    [sym_continue_statement] = STATE(2647),
    [sym_do_statement] = STATE(2647),
    [sym_empty_statement] = STATE(2647),
    [sym_expression_statement] = STATE(2647),
    [sym_fixed_statement] = STATE(2647),
    [sym_for_statement] = STATE(2647),
    [sym_return_statement] = STATE(2647),
    [sym_lock_statement] = STATE(2647),
    [sym_yield_statement] = STATE(2647),
    [sym_switch_statement] = STATE(2647),
    [sym_throw_statement] = STATE(2647),
    [sym_try_statement] = STATE(2647),
    [sym_unsafe_statement] = STATE(2647),
    [sym_using_statement] = STATE(2647),
    [sym_foreach_statement] = STATE(2647),
    [sym_goto_statement] = STATE(2647),
    [sym_labeled_statement] = STATE(2647),
    [sym_if_statement] = STATE(2647),
    [sym_while_statement] = STATE(2647),
    [sym_local_declaration_statement] = STATE(2647),
    [sym_local_function_statement] = STATE(2647),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6543),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2835),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2647),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(42),
    [sym_preproc_endregion] = STATE(42),
    [sym_preproc_line] = STATE(42),
    [sym_preproc_pragma] = STATE(42),
    [sym_preproc_nullable] = STATE(42),
    [sym_preproc_error] = STATE(42),
    [sym_preproc_define] = STATE(42),
    [sym_preproc_undef] = STATE(42),
    [aux_sym_class_declaration_repeat1] = STATE(2918),
    [aux_sym_class_declaration_repeat2] = STATE(3106),
    [aux_sym_block_repeat1] = STATE(48),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(647),
    [anon_sym_unsafe] = ACTIONS(649),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(655),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(659),
    [anon_sym_RBRACE] = ACTIONS(945),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(667),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(671),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(673),
    [anon_sym_unchecked] = ACTIONS(671),
    [anon_sym_continue] = ACTIONS(675),
    [anon_sym_do] = ACTIONS(677),
    [anon_sym_while] = ACTIONS(679),
    [anon_sym_for] = ACTIONS(681),
    [anon_sym_lock] = ACTIONS(683),
    [anon_sym_yield] = ACTIONS(685),
    [anon_sym_switch] = ACTIONS(687),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_try] = ACTIONS(693),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(695),
    [anon_sym_foreach] = ACTIONS(697),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [43] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2647),
    [sym_variable_declaration] = STATE(9394),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6827),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2721),
    [sym_break_statement] = STATE(2647),
    [sym_checked_statement] = STATE(2647),
    [sym_continue_statement] = STATE(2647),
    [sym_do_statement] = STATE(2647),
    [sym_empty_statement] = STATE(2647),
    [sym_expression_statement] = STATE(2647),
    [sym_fixed_statement] = STATE(2647),
    [sym_for_statement] = STATE(2647),
    [sym_return_statement] = STATE(2647),
    [sym_lock_statement] = STATE(2647),
    [sym_yield_statement] = STATE(2647),
    [sym_switch_statement] = STATE(2647),
    [sym_throw_statement] = STATE(2647),
    [sym_try_statement] = STATE(2647),
    [sym_unsafe_statement] = STATE(2647),
    [sym_using_statement] = STATE(2647),
    [sym_foreach_statement] = STATE(2647),
    [sym_goto_statement] = STATE(2647),
    [sym_labeled_statement] = STATE(2647),
    [sym_if_statement] = STATE(2647),
    [sym_while_statement] = STATE(2647),
    [sym_local_declaration_statement] = STATE(2647),
    [sym_local_function_statement] = STATE(2647),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6543),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2835),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2647),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(43),
    [sym_preproc_endregion] = STATE(43),
    [sym_preproc_line] = STATE(43),
    [sym_preproc_pragma] = STATE(43),
    [sym_preproc_nullable] = STATE(43),
    [sym_preproc_error] = STATE(43),
    [sym_preproc_define] = STATE(43),
    [sym_preproc_undef] = STATE(43),
    [aux_sym_class_declaration_repeat1] = STATE(2918),
    [aux_sym_class_declaration_repeat2] = STATE(3106),
    [aux_sym_block_repeat1] = STATE(44),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(647),
    [anon_sym_unsafe] = ACTIONS(649),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(655),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(659),
    [anon_sym_RBRACE] = ACTIONS(947),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(667),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(671),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(673),
    [anon_sym_unchecked] = ACTIONS(671),
    [anon_sym_continue] = ACTIONS(675),
    [anon_sym_do] = ACTIONS(677),
    [anon_sym_while] = ACTIONS(679),
    [anon_sym_for] = ACTIONS(681),
    [anon_sym_lock] = ACTIONS(683),
    [anon_sym_yield] = ACTIONS(685),
    [anon_sym_switch] = ACTIONS(687),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_try] = ACTIONS(693),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(695),
    [anon_sym_foreach] = ACTIONS(697),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [44] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2647),
    [sym_variable_declaration] = STATE(9394),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6827),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2721),
    [sym_break_statement] = STATE(2647),
    [sym_checked_statement] = STATE(2647),
    [sym_continue_statement] = STATE(2647),
    [sym_do_statement] = STATE(2647),
    [sym_empty_statement] = STATE(2647),
    [sym_expression_statement] = STATE(2647),
    [sym_fixed_statement] = STATE(2647),
    [sym_for_statement] = STATE(2647),
    [sym_return_statement] = STATE(2647),
    [sym_lock_statement] = STATE(2647),
    [sym_yield_statement] = STATE(2647),
    [sym_switch_statement] = STATE(2647),
    [sym_throw_statement] = STATE(2647),
    [sym_try_statement] = STATE(2647),
    [sym_unsafe_statement] = STATE(2647),
    [sym_using_statement] = STATE(2647),
    [sym_foreach_statement] = STATE(2647),
    [sym_goto_statement] = STATE(2647),
    [sym_labeled_statement] = STATE(2647),
    [sym_if_statement] = STATE(2647),
    [sym_while_statement] = STATE(2647),
    [sym_local_declaration_statement] = STATE(2647),
    [sym_local_function_statement] = STATE(2647),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6543),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2835),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2647),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(44),
    [sym_preproc_endregion] = STATE(44),
    [sym_preproc_line] = STATE(44),
    [sym_preproc_pragma] = STATE(44),
    [sym_preproc_nullable] = STATE(44),
    [sym_preproc_error] = STATE(44),
    [sym_preproc_define] = STATE(44),
    [sym_preproc_undef] = STATE(44),
    [aux_sym_class_declaration_repeat1] = STATE(2918),
    [aux_sym_class_declaration_repeat2] = STATE(3106),
    [aux_sym_block_repeat1] = STATE(22),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(647),
    [anon_sym_unsafe] = ACTIONS(649),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(655),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(659),
    [anon_sym_RBRACE] = ACTIONS(949),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(667),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(671),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(673),
    [anon_sym_unchecked] = ACTIONS(671),
    [anon_sym_continue] = ACTIONS(675),
    [anon_sym_do] = ACTIONS(677),
    [anon_sym_while] = ACTIONS(679),
    [anon_sym_for] = ACTIONS(681),
    [anon_sym_lock] = ACTIONS(683),
    [anon_sym_yield] = ACTIONS(685),
    [anon_sym_switch] = ACTIONS(687),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_try] = ACTIONS(693),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(695),
    [anon_sym_foreach] = ACTIONS(697),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [45] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2647),
    [sym_variable_declaration] = STATE(9394),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6827),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2721),
    [sym_break_statement] = STATE(2647),
    [sym_checked_statement] = STATE(2647),
    [sym_continue_statement] = STATE(2647),
    [sym_do_statement] = STATE(2647),
    [sym_empty_statement] = STATE(2647),
    [sym_expression_statement] = STATE(2647),
    [sym_fixed_statement] = STATE(2647),
    [sym_for_statement] = STATE(2647),
    [sym_return_statement] = STATE(2647),
    [sym_lock_statement] = STATE(2647),
    [sym_yield_statement] = STATE(2647),
    [sym_switch_statement] = STATE(2647),
    [sym_throw_statement] = STATE(2647),
    [sym_try_statement] = STATE(2647),
    [sym_unsafe_statement] = STATE(2647),
    [sym_using_statement] = STATE(2647),
    [sym_foreach_statement] = STATE(2647),
    [sym_goto_statement] = STATE(2647),
    [sym_labeled_statement] = STATE(2647),
    [sym_if_statement] = STATE(2647),
    [sym_while_statement] = STATE(2647),
    [sym_local_declaration_statement] = STATE(2647),
    [sym_local_function_statement] = STATE(2647),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6543),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2835),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2647),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(45),
    [sym_preproc_endregion] = STATE(45),
    [sym_preproc_line] = STATE(45),
    [sym_preproc_pragma] = STATE(45),
    [sym_preproc_nullable] = STATE(45),
    [sym_preproc_error] = STATE(45),
    [sym_preproc_define] = STATE(45),
    [sym_preproc_undef] = STATE(45),
    [aux_sym_class_declaration_repeat1] = STATE(2918),
    [aux_sym_class_declaration_repeat2] = STATE(3106),
    [aux_sym_block_repeat1] = STATE(22),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(647),
    [anon_sym_unsafe] = ACTIONS(649),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(655),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(659),
    [anon_sym_RBRACE] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(667),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(671),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(673),
    [anon_sym_unchecked] = ACTIONS(671),
    [anon_sym_continue] = ACTIONS(675),
    [anon_sym_do] = ACTIONS(677),
    [anon_sym_while] = ACTIONS(679),
    [anon_sym_for] = ACTIONS(681),
    [anon_sym_lock] = ACTIONS(683),
    [anon_sym_yield] = ACTIONS(685),
    [anon_sym_switch] = ACTIONS(687),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_try] = ACTIONS(693),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(695),
    [anon_sym_foreach] = ACTIONS(697),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [46] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2647),
    [sym_variable_declaration] = STATE(9394),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6827),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2721),
    [sym_break_statement] = STATE(2647),
    [sym_checked_statement] = STATE(2647),
    [sym_continue_statement] = STATE(2647),
    [sym_do_statement] = STATE(2647),
    [sym_empty_statement] = STATE(2647),
    [sym_expression_statement] = STATE(2647),
    [sym_fixed_statement] = STATE(2647),
    [sym_for_statement] = STATE(2647),
    [sym_return_statement] = STATE(2647),
    [sym_lock_statement] = STATE(2647),
    [sym_yield_statement] = STATE(2647),
    [sym_switch_statement] = STATE(2647),
    [sym_throw_statement] = STATE(2647),
    [sym_try_statement] = STATE(2647),
    [sym_unsafe_statement] = STATE(2647),
    [sym_using_statement] = STATE(2647),
    [sym_foreach_statement] = STATE(2647),
    [sym_goto_statement] = STATE(2647),
    [sym_labeled_statement] = STATE(2647),
    [sym_if_statement] = STATE(2647),
    [sym_while_statement] = STATE(2647),
    [sym_local_declaration_statement] = STATE(2647),
    [sym_local_function_statement] = STATE(2647),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6543),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2835),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2647),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(46),
    [sym_preproc_endregion] = STATE(46),
    [sym_preproc_line] = STATE(46),
    [sym_preproc_pragma] = STATE(46),
    [sym_preproc_nullable] = STATE(46),
    [sym_preproc_error] = STATE(46),
    [sym_preproc_define] = STATE(46),
    [sym_preproc_undef] = STATE(46),
    [aux_sym_class_declaration_repeat1] = STATE(2918),
    [aux_sym_class_declaration_repeat2] = STATE(3106),
    [aux_sym_block_repeat1] = STATE(45),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(647),
    [anon_sym_unsafe] = ACTIONS(649),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(655),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(659),
    [anon_sym_RBRACE] = ACTIONS(953),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(667),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(671),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(673),
    [anon_sym_unchecked] = ACTIONS(671),
    [anon_sym_continue] = ACTIONS(675),
    [anon_sym_do] = ACTIONS(677),
    [anon_sym_while] = ACTIONS(679),
    [anon_sym_for] = ACTIONS(681),
    [anon_sym_lock] = ACTIONS(683),
    [anon_sym_yield] = ACTIONS(685),
    [anon_sym_switch] = ACTIONS(687),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_try] = ACTIONS(693),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(695),
    [anon_sym_foreach] = ACTIONS(697),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [47] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2647),
    [sym_variable_declaration] = STATE(9394),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6827),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2721),
    [sym_break_statement] = STATE(2647),
    [sym_checked_statement] = STATE(2647),
    [sym_continue_statement] = STATE(2647),
    [sym_do_statement] = STATE(2647),
    [sym_empty_statement] = STATE(2647),
    [sym_expression_statement] = STATE(2647),
    [sym_fixed_statement] = STATE(2647),
    [sym_for_statement] = STATE(2647),
    [sym_return_statement] = STATE(2647),
    [sym_lock_statement] = STATE(2647),
    [sym_yield_statement] = STATE(2647),
    [sym_switch_statement] = STATE(2647),
    [sym_throw_statement] = STATE(2647),
    [sym_try_statement] = STATE(2647),
    [sym_unsafe_statement] = STATE(2647),
    [sym_using_statement] = STATE(2647),
    [sym_foreach_statement] = STATE(2647),
    [sym_goto_statement] = STATE(2647),
    [sym_labeled_statement] = STATE(2647),
    [sym_if_statement] = STATE(2647),
    [sym_while_statement] = STATE(2647),
    [sym_local_declaration_statement] = STATE(2647),
    [sym_local_function_statement] = STATE(2647),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6543),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2835),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2647),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(47),
    [sym_preproc_endregion] = STATE(47),
    [sym_preproc_line] = STATE(47),
    [sym_preproc_pragma] = STATE(47),
    [sym_preproc_nullable] = STATE(47),
    [sym_preproc_error] = STATE(47),
    [sym_preproc_define] = STATE(47),
    [sym_preproc_undef] = STATE(47),
    [aux_sym_class_declaration_repeat1] = STATE(2918),
    [aux_sym_class_declaration_repeat2] = STATE(3106),
    [aux_sym_block_repeat1] = STATE(49),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(647),
    [anon_sym_unsafe] = ACTIONS(649),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(655),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(659),
    [anon_sym_RBRACE] = ACTIONS(955),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(667),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(671),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(673),
    [anon_sym_unchecked] = ACTIONS(671),
    [anon_sym_continue] = ACTIONS(675),
    [anon_sym_do] = ACTIONS(677),
    [anon_sym_while] = ACTIONS(679),
    [anon_sym_for] = ACTIONS(681),
    [anon_sym_lock] = ACTIONS(683),
    [anon_sym_yield] = ACTIONS(685),
    [anon_sym_switch] = ACTIONS(687),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_try] = ACTIONS(693),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(695),
    [anon_sym_foreach] = ACTIONS(697),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [48] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2647),
    [sym_variable_declaration] = STATE(9394),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6827),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2721),
    [sym_break_statement] = STATE(2647),
    [sym_checked_statement] = STATE(2647),
    [sym_continue_statement] = STATE(2647),
    [sym_do_statement] = STATE(2647),
    [sym_empty_statement] = STATE(2647),
    [sym_expression_statement] = STATE(2647),
    [sym_fixed_statement] = STATE(2647),
    [sym_for_statement] = STATE(2647),
    [sym_return_statement] = STATE(2647),
    [sym_lock_statement] = STATE(2647),
    [sym_yield_statement] = STATE(2647),
    [sym_switch_statement] = STATE(2647),
    [sym_throw_statement] = STATE(2647),
    [sym_try_statement] = STATE(2647),
    [sym_unsafe_statement] = STATE(2647),
    [sym_using_statement] = STATE(2647),
    [sym_foreach_statement] = STATE(2647),
    [sym_goto_statement] = STATE(2647),
    [sym_labeled_statement] = STATE(2647),
    [sym_if_statement] = STATE(2647),
    [sym_while_statement] = STATE(2647),
    [sym_local_declaration_statement] = STATE(2647),
    [sym_local_function_statement] = STATE(2647),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6543),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2835),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2647),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(48),
    [sym_preproc_endregion] = STATE(48),
    [sym_preproc_line] = STATE(48),
    [sym_preproc_pragma] = STATE(48),
    [sym_preproc_nullable] = STATE(48),
    [sym_preproc_error] = STATE(48),
    [sym_preproc_define] = STATE(48),
    [sym_preproc_undef] = STATE(48),
    [aux_sym_class_declaration_repeat1] = STATE(2918),
    [aux_sym_class_declaration_repeat2] = STATE(3106),
    [aux_sym_block_repeat1] = STATE(22),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(647),
    [anon_sym_unsafe] = ACTIONS(649),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(655),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(659),
    [anon_sym_RBRACE] = ACTIONS(957),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(667),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(671),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(673),
    [anon_sym_unchecked] = ACTIONS(671),
    [anon_sym_continue] = ACTIONS(675),
    [anon_sym_do] = ACTIONS(677),
    [anon_sym_while] = ACTIONS(679),
    [anon_sym_for] = ACTIONS(681),
    [anon_sym_lock] = ACTIONS(683),
    [anon_sym_yield] = ACTIONS(685),
    [anon_sym_switch] = ACTIONS(687),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_try] = ACTIONS(693),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(695),
    [anon_sym_foreach] = ACTIONS(697),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [49] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2647),
    [sym_variable_declaration] = STATE(9394),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6827),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2721),
    [sym_break_statement] = STATE(2647),
    [sym_checked_statement] = STATE(2647),
    [sym_continue_statement] = STATE(2647),
    [sym_do_statement] = STATE(2647),
    [sym_empty_statement] = STATE(2647),
    [sym_expression_statement] = STATE(2647),
    [sym_fixed_statement] = STATE(2647),
    [sym_for_statement] = STATE(2647),
    [sym_return_statement] = STATE(2647),
    [sym_lock_statement] = STATE(2647),
    [sym_yield_statement] = STATE(2647),
    [sym_switch_statement] = STATE(2647),
    [sym_throw_statement] = STATE(2647),
    [sym_try_statement] = STATE(2647),
    [sym_unsafe_statement] = STATE(2647),
    [sym_using_statement] = STATE(2647),
    [sym_foreach_statement] = STATE(2647),
    [sym_goto_statement] = STATE(2647),
    [sym_labeled_statement] = STATE(2647),
    [sym_if_statement] = STATE(2647),
    [sym_while_statement] = STATE(2647),
    [sym_local_declaration_statement] = STATE(2647),
    [sym_local_function_statement] = STATE(2647),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6543),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2835),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2647),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(49),
    [sym_preproc_endregion] = STATE(49),
    [sym_preproc_line] = STATE(49),
    [sym_preproc_pragma] = STATE(49),
    [sym_preproc_nullable] = STATE(49),
    [sym_preproc_error] = STATE(49),
    [sym_preproc_define] = STATE(49),
    [sym_preproc_undef] = STATE(49),
    [aux_sym_class_declaration_repeat1] = STATE(2918),
    [aux_sym_class_declaration_repeat2] = STATE(3106),
    [aux_sym_block_repeat1] = STATE(22),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(647),
    [anon_sym_unsafe] = ACTIONS(649),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(655),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(659),
    [anon_sym_RBRACE] = ACTIONS(959),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(667),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(671),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(673),
    [anon_sym_unchecked] = ACTIONS(671),
    [anon_sym_continue] = ACTIONS(675),
    [anon_sym_do] = ACTIONS(677),
    [anon_sym_while] = ACTIONS(679),
    [anon_sym_for] = ACTIONS(681),
    [anon_sym_lock] = ACTIONS(683),
    [anon_sym_yield] = ACTIONS(685),
    [anon_sym_switch] = ACTIONS(687),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_try] = ACTIONS(693),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(695),
    [anon_sym_foreach] = ACTIONS(697),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [50] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2647),
    [sym_variable_declaration] = STATE(9394),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6827),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2721),
    [sym_break_statement] = STATE(2647),
    [sym_checked_statement] = STATE(2647),
    [sym_continue_statement] = STATE(2647),
    [sym_do_statement] = STATE(2647),
    [sym_empty_statement] = STATE(2647),
    [sym_expression_statement] = STATE(2647),
    [sym_fixed_statement] = STATE(2647),
    [sym_for_statement] = STATE(2647),
    [sym_return_statement] = STATE(2647),
    [sym_lock_statement] = STATE(2647),
    [sym_yield_statement] = STATE(2647),
    [sym_switch_statement] = STATE(2647),
    [sym_throw_statement] = STATE(2647),
    [sym_try_statement] = STATE(2647),
    [sym_unsafe_statement] = STATE(2647),
    [sym_using_statement] = STATE(2647),
    [sym_foreach_statement] = STATE(2647),
    [sym_goto_statement] = STATE(2647),
    [sym_labeled_statement] = STATE(2647),
    [sym_if_statement] = STATE(2647),
    [sym_while_statement] = STATE(2647),
    [sym_local_declaration_statement] = STATE(2647),
    [sym_local_function_statement] = STATE(2647),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6543),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2835),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2647),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(50),
    [sym_preproc_endregion] = STATE(50),
    [sym_preproc_line] = STATE(50),
    [sym_preproc_pragma] = STATE(50),
    [sym_preproc_nullable] = STATE(50),
    [sym_preproc_error] = STATE(50),
    [sym_preproc_define] = STATE(50),
    [sym_preproc_undef] = STATE(50),
    [aux_sym_class_declaration_repeat1] = STATE(2918),
    [aux_sym_class_declaration_repeat2] = STATE(3106),
    [aux_sym_block_repeat1] = STATE(52),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(647),
    [anon_sym_unsafe] = ACTIONS(649),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(655),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(659),
    [anon_sym_RBRACE] = ACTIONS(961),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(667),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(671),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(673),
    [anon_sym_unchecked] = ACTIONS(671),
    [anon_sym_continue] = ACTIONS(675),
    [anon_sym_do] = ACTIONS(677),
    [anon_sym_while] = ACTIONS(679),
    [anon_sym_for] = ACTIONS(681),
    [anon_sym_lock] = ACTIONS(683),
    [anon_sym_yield] = ACTIONS(685),
    [anon_sym_switch] = ACTIONS(687),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_try] = ACTIONS(693),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(695),
    [anon_sym_foreach] = ACTIONS(697),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [51] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2647),
    [sym_variable_declaration] = STATE(9394),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6827),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2721),
    [sym_break_statement] = STATE(2647),
    [sym_checked_statement] = STATE(2647),
    [sym_continue_statement] = STATE(2647),
    [sym_do_statement] = STATE(2647),
    [sym_empty_statement] = STATE(2647),
    [sym_expression_statement] = STATE(2647),
    [sym_fixed_statement] = STATE(2647),
    [sym_for_statement] = STATE(2647),
    [sym_return_statement] = STATE(2647),
    [sym_lock_statement] = STATE(2647),
    [sym_yield_statement] = STATE(2647),
    [sym_switch_statement] = STATE(2647),
    [sym_throw_statement] = STATE(2647),
    [sym_try_statement] = STATE(2647),
    [sym_unsafe_statement] = STATE(2647),
    [sym_using_statement] = STATE(2647),
    [sym_foreach_statement] = STATE(2647),
    [sym_goto_statement] = STATE(2647),
    [sym_labeled_statement] = STATE(2647),
    [sym_if_statement] = STATE(2647),
    [sym_while_statement] = STATE(2647),
    [sym_local_declaration_statement] = STATE(2647),
    [sym_local_function_statement] = STATE(2647),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6543),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2835),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2647),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(51),
    [sym_preproc_endregion] = STATE(51),
    [sym_preproc_line] = STATE(51),
    [sym_preproc_pragma] = STATE(51),
    [sym_preproc_nullable] = STATE(51),
    [sym_preproc_error] = STATE(51),
    [sym_preproc_define] = STATE(51),
    [sym_preproc_undef] = STATE(51),
    [aux_sym_class_declaration_repeat1] = STATE(2918),
    [aux_sym_class_declaration_repeat2] = STATE(3106),
    [aux_sym_block_repeat1] = STATE(38),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(647),
    [anon_sym_unsafe] = ACTIONS(649),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(655),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(659),
    [anon_sym_RBRACE] = ACTIONS(963),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(667),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(671),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(673),
    [anon_sym_unchecked] = ACTIONS(671),
    [anon_sym_continue] = ACTIONS(675),
    [anon_sym_do] = ACTIONS(677),
    [anon_sym_while] = ACTIONS(679),
    [anon_sym_for] = ACTIONS(681),
    [anon_sym_lock] = ACTIONS(683),
    [anon_sym_yield] = ACTIONS(685),
    [anon_sym_switch] = ACTIONS(687),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_try] = ACTIONS(693),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(695),
    [anon_sym_foreach] = ACTIONS(697),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [52] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2647),
    [sym_variable_declaration] = STATE(9394),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6827),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2721),
    [sym_break_statement] = STATE(2647),
    [sym_checked_statement] = STATE(2647),
    [sym_continue_statement] = STATE(2647),
    [sym_do_statement] = STATE(2647),
    [sym_empty_statement] = STATE(2647),
    [sym_expression_statement] = STATE(2647),
    [sym_fixed_statement] = STATE(2647),
    [sym_for_statement] = STATE(2647),
    [sym_return_statement] = STATE(2647),
    [sym_lock_statement] = STATE(2647),
    [sym_yield_statement] = STATE(2647),
    [sym_switch_statement] = STATE(2647),
    [sym_throw_statement] = STATE(2647),
    [sym_try_statement] = STATE(2647),
    [sym_unsafe_statement] = STATE(2647),
    [sym_using_statement] = STATE(2647),
    [sym_foreach_statement] = STATE(2647),
    [sym_goto_statement] = STATE(2647),
    [sym_labeled_statement] = STATE(2647),
    [sym_if_statement] = STATE(2647),
    [sym_while_statement] = STATE(2647),
    [sym_local_declaration_statement] = STATE(2647),
    [sym_local_function_statement] = STATE(2647),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6543),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2835),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2647),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(52),
    [sym_preproc_endregion] = STATE(52),
    [sym_preproc_line] = STATE(52),
    [sym_preproc_pragma] = STATE(52),
    [sym_preproc_nullable] = STATE(52),
    [sym_preproc_error] = STATE(52),
    [sym_preproc_define] = STATE(52),
    [sym_preproc_undef] = STATE(52),
    [aux_sym_class_declaration_repeat1] = STATE(2918),
    [aux_sym_class_declaration_repeat2] = STATE(3106),
    [aux_sym_block_repeat1] = STATE(22),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(647),
    [anon_sym_unsafe] = ACTIONS(649),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(655),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(659),
    [anon_sym_RBRACE] = ACTIONS(965),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(667),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(671),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(673),
    [anon_sym_unchecked] = ACTIONS(671),
    [anon_sym_continue] = ACTIONS(675),
    [anon_sym_do] = ACTIONS(677),
    [anon_sym_while] = ACTIONS(679),
    [anon_sym_for] = ACTIONS(681),
    [anon_sym_lock] = ACTIONS(683),
    [anon_sym_yield] = ACTIONS(685),
    [anon_sym_switch] = ACTIONS(687),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_try] = ACTIONS(693),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(695),
    [anon_sym_foreach] = ACTIONS(697),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [53] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2647),
    [sym_variable_declaration] = STATE(9394),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6827),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2721),
    [sym_break_statement] = STATE(2647),
    [sym_checked_statement] = STATE(2647),
    [sym_continue_statement] = STATE(2647),
    [sym_do_statement] = STATE(2647),
    [sym_empty_statement] = STATE(2647),
    [sym_expression_statement] = STATE(2647),
    [sym_fixed_statement] = STATE(2647),
    [sym_for_statement] = STATE(2647),
    [sym_return_statement] = STATE(2647),
    [sym_lock_statement] = STATE(2647),
    [sym_yield_statement] = STATE(2647),
    [sym_switch_statement] = STATE(2647),
    [sym_throw_statement] = STATE(2647),
    [sym_try_statement] = STATE(2647),
    [sym_unsafe_statement] = STATE(2647),
    [sym_using_statement] = STATE(2647),
    [sym_foreach_statement] = STATE(2647),
    [sym_goto_statement] = STATE(2647),
    [sym_labeled_statement] = STATE(2647),
    [sym_if_statement] = STATE(2647),
    [sym_while_statement] = STATE(2647),
    [sym_local_declaration_statement] = STATE(2647),
    [sym_local_function_statement] = STATE(2647),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6543),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2835),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2647),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(53),
    [sym_preproc_endregion] = STATE(53),
    [sym_preproc_line] = STATE(53),
    [sym_preproc_pragma] = STATE(53),
    [sym_preproc_nullable] = STATE(53),
    [sym_preproc_error] = STATE(53),
    [sym_preproc_define] = STATE(53),
    [sym_preproc_undef] = STATE(53),
    [aux_sym_class_declaration_repeat1] = STATE(2918),
    [aux_sym_class_declaration_repeat2] = STATE(3106),
    [aux_sym_block_repeat1] = STATE(39),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(647),
    [anon_sym_unsafe] = ACTIONS(649),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(655),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(659),
    [anon_sym_RBRACE] = ACTIONS(967),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(667),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(671),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(673),
    [anon_sym_unchecked] = ACTIONS(671),
    [anon_sym_continue] = ACTIONS(675),
    [anon_sym_do] = ACTIONS(677),
    [anon_sym_while] = ACTIONS(679),
    [anon_sym_for] = ACTIONS(681),
    [anon_sym_lock] = ACTIONS(683),
    [anon_sym_yield] = ACTIONS(685),
    [anon_sym_switch] = ACTIONS(687),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_try] = ACTIONS(693),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(695),
    [anon_sym_foreach] = ACTIONS(697),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [54] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2647),
    [sym_variable_declaration] = STATE(9394),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6827),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2721),
    [sym_break_statement] = STATE(2647),
    [sym_checked_statement] = STATE(2647),
    [sym_continue_statement] = STATE(2647),
    [sym_do_statement] = STATE(2647),
    [sym_empty_statement] = STATE(2647),
    [sym_expression_statement] = STATE(2647),
    [sym_fixed_statement] = STATE(2647),
    [sym_for_statement] = STATE(2647),
    [sym_return_statement] = STATE(2647),
    [sym_lock_statement] = STATE(2647),
    [sym_yield_statement] = STATE(2647),
    [sym_switch_statement] = STATE(2647),
    [sym_throw_statement] = STATE(2647),
    [sym_try_statement] = STATE(2647),
    [sym_unsafe_statement] = STATE(2647),
    [sym_using_statement] = STATE(2647),
    [sym_foreach_statement] = STATE(2647),
    [sym_goto_statement] = STATE(2647),
    [sym_labeled_statement] = STATE(2647),
    [sym_if_statement] = STATE(2647),
    [sym_while_statement] = STATE(2647),
    [sym_local_declaration_statement] = STATE(2647),
    [sym_local_function_statement] = STATE(2647),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6543),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2835),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2647),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(54),
    [sym_preproc_endregion] = STATE(54),
    [sym_preproc_line] = STATE(54),
    [sym_preproc_pragma] = STATE(54),
    [sym_preproc_nullable] = STATE(54),
    [sym_preproc_error] = STATE(54),
    [sym_preproc_define] = STATE(54),
    [sym_preproc_undef] = STATE(54),
    [aux_sym_class_declaration_repeat1] = STATE(2918),
    [aux_sym_class_declaration_repeat2] = STATE(3106),
    [aux_sym_block_repeat1] = STATE(22),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(647),
    [anon_sym_unsafe] = ACTIONS(649),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(655),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(659),
    [anon_sym_RBRACE] = ACTIONS(969),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(667),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(671),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(673),
    [anon_sym_unchecked] = ACTIONS(671),
    [anon_sym_continue] = ACTIONS(675),
    [anon_sym_do] = ACTIONS(677),
    [anon_sym_while] = ACTIONS(679),
    [anon_sym_for] = ACTIONS(681),
    [anon_sym_lock] = ACTIONS(683),
    [anon_sym_yield] = ACTIONS(685),
    [anon_sym_switch] = ACTIONS(687),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_try] = ACTIONS(693),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(695),
    [anon_sym_foreach] = ACTIONS(697),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [55] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2647),
    [sym_variable_declaration] = STATE(9394),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6827),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2721),
    [sym_break_statement] = STATE(2647),
    [sym_checked_statement] = STATE(2647),
    [sym_continue_statement] = STATE(2647),
    [sym_do_statement] = STATE(2647),
    [sym_empty_statement] = STATE(2647),
    [sym_expression_statement] = STATE(2647),
    [sym_fixed_statement] = STATE(2647),
    [sym_for_statement] = STATE(2647),
    [sym_return_statement] = STATE(2647),
    [sym_lock_statement] = STATE(2647),
    [sym_yield_statement] = STATE(2647),
    [sym_switch_statement] = STATE(2647),
    [sym_throw_statement] = STATE(2647),
    [sym_try_statement] = STATE(2647),
    [sym_unsafe_statement] = STATE(2647),
    [sym_using_statement] = STATE(2647),
    [sym_foreach_statement] = STATE(2647),
    [sym_goto_statement] = STATE(2647),
    [sym_labeled_statement] = STATE(2647),
    [sym_if_statement] = STATE(2647),
    [sym_while_statement] = STATE(2647),
    [sym_local_declaration_statement] = STATE(2647),
    [sym_local_function_statement] = STATE(2647),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6543),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2835),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2647),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(55),
    [sym_preproc_endregion] = STATE(55),
    [sym_preproc_line] = STATE(55),
    [sym_preproc_pragma] = STATE(55),
    [sym_preproc_nullable] = STATE(55),
    [sym_preproc_error] = STATE(55),
    [sym_preproc_define] = STATE(55),
    [sym_preproc_undef] = STATE(55),
    [aux_sym_class_declaration_repeat1] = STATE(2918),
    [aux_sym_class_declaration_repeat2] = STATE(3106),
    [aux_sym_block_repeat1] = STATE(57),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(647),
    [anon_sym_unsafe] = ACTIONS(649),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(655),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(659),
    [anon_sym_RBRACE] = ACTIONS(971),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(667),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(671),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(673),
    [anon_sym_unchecked] = ACTIONS(671),
    [anon_sym_continue] = ACTIONS(675),
    [anon_sym_do] = ACTIONS(677),
    [anon_sym_while] = ACTIONS(679),
    [anon_sym_for] = ACTIONS(681),
    [anon_sym_lock] = ACTIONS(683),
    [anon_sym_yield] = ACTIONS(685),
    [anon_sym_switch] = ACTIONS(687),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_try] = ACTIONS(693),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(695),
    [anon_sym_foreach] = ACTIONS(697),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [56] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2647),
    [sym_variable_declaration] = STATE(9394),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6827),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2721),
    [sym_break_statement] = STATE(2647),
    [sym_checked_statement] = STATE(2647),
    [sym_continue_statement] = STATE(2647),
    [sym_do_statement] = STATE(2647),
    [sym_empty_statement] = STATE(2647),
    [sym_expression_statement] = STATE(2647),
    [sym_fixed_statement] = STATE(2647),
    [sym_for_statement] = STATE(2647),
    [sym_return_statement] = STATE(2647),
    [sym_lock_statement] = STATE(2647),
    [sym_yield_statement] = STATE(2647),
    [sym_switch_statement] = STATE(2647),
    [sym_throw_statement] = STATE(2647),
    [sym_try_statement] = STATE(2647),
    [sym_unsafe_statement] = STATE(2647),
    [sym_using_statement] = STATE(2647),
    [sym_foreach_statement] = STATE(2647),
    [sym_goto_statement] = STATE(2647),
    [sym_labeled_statement] = STATE(2647),
    [sym_if_statement] = STATE(2647),
    [sym_while_statement] = STATE(2647),
    [sym_local_declaration_statement] = STATE(2647),
    [sym_local_function_statement] = STATE(2647),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6543),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2835),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2647),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(56),
    [sym_preproc_endregion] = STATE(56),
    [sym_preproc_line] = STATE(56),
    [sym_preproc_pragma] = STATE(56),
    [sym_preproc_nullable] = STATE(56),
    [sym_preproc_error] = STATE(56),
    [sym_preproc_define] = STATE(56),
    [sym_preproc_undef] = STATE(56),
    [aux_sym_class_declaration_repeat1] = STATE(2918),
    [aux_sym_class_declaration_repeat2] = STATE(3106),
    [aux_sym_block_repeat1] = STATE(22),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(647),
    [anon_sym_unsafe] = ACTIONS(649),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(655),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(659),
    [anon_sym_RBRACE] = ACTIONS(973),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(667),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(671),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(673),
    [anon_sym_unchecked] = ACTIONS(671),
    [anon_sym_continue] = ACTIONS(675),
    [anon_sym_do] = ACTIONS(677),
    [anon_sym_while] = ACTIONS(679),
    [anon_sym_for] = ACTIONS(681),
    [anon_sym_lock] = ACTIONS(683),
    [anon_sym_yield] = ACTIONS(685),
    [anon_sym_switch] = ACTIONS(687),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_try] = ACTIONS(693),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(695),
    [anon_sym_foreach] = ACTIONS(697),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [57] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2647),
    [sym_variable_declaration] = STATE(9394),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6827),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2721),
    [sym_break_statement] = STATE(2647),
    [sym_checked_statement] = STATE(2647),
    [sym_continue_statement] = STATE(2647),
    [sym_do_statement] = STATE(2647),
    [sym_empty_statement] = STATE(2647),
    [sym_expression_statement] = STATE(2647),
    [sym_fixed_statement] = STATE(2647),
    [sym_for_statement] = STATE(2647),
    [sym_return_statement] = STATE(2647),
    [sym_lock_statement] = STATE(2647),
    [sym_yield_statement] = STATE(2647),
    [sym_switch_statement] = STATE(2647),
    [sym_throw_statement] = STATE(2647),
    [sym_try_statement] = STATE(2647),
    [sym_unsafe_statement] = STATE(2647),
    [sym_using_statement] = STATE(2647),
    [sym_foreach_statement] = STATE(2647),
    [sym_goto_statement] = STATE(2647),
    [sym_labeled_statement] = STATE(2647),
    [sym_if_statement] = STATE(2647),
    [sym_while_statement] = STATE(2647),
    [sym_local_declaration_statement] = STATE(2647),
    [sym_local_function_statement] = STATE(2647),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6543),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2835),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2647),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(57),
    [sym_preproc_endregion] = STATE(57),
    [sym_preproc_line] = STATE(57),
    [sym_preproc_pragma] = STATE(57),
    [sym_preproc_nullable] = STATE(57),
    [sym_preproc_error] = STATE(57),
    [sym_preproc_define] = STATE(57),
    [sym_preproc_undef] = STATE(57),
    [aux_sym_class_declaration_repeat1] = STATE(2918),
    [aux_sym_class_declaration_repeat2] = STATE(3106),
    [aux_sym_block_repeat1] = STATE(22),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(647),
    [anon_sym_unsafe] = ACTIONS(649),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(655),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(659),
    [anon_sym_RBRACE] = ACTIONS(975),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(667),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(671),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(673),
    [anon_sym_unchecked] = ACTIONS(671),
    [anon_sym_continue] = ACTIONS(675),
    [anon_sym_do] = ACTIONS(677),
    [anon_sym_while] = ACTIONS(679),
    [anon_sym_for] = ACTIONS(681),
    [anon_sym_lock] = ACTIONS(683),
    [anon_sym_yield] = ACTIONS(685),
    [anon_sym_switch] = ACTIONS(687),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_try] = ACTIONS(693),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(695),
    [anon_sym_foreach] = ACTIONS(697),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [58] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2647),
    [sym_variable_declaration] = STATE(9394),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6827),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2721),
    [sym_break_statement] = STATE(2647),
    [sym_checked_statement] = STATE(2647),
    [sym_continue_statement] = STATE(2647),
    [sym_do_statement] = STATE(2647),
    [sym_empty_statement] = STATE(2647),
    [sym_expression_statement] = STATE(2647),
    [sym_fixed_statement] = STATE(2647),
    [sym_for_statement] = STATE(2647),
    [sym_return_statement] = STATE(2647),
    [sym_lock_statement] = STATE(2647),
    [sym_yield_statement] = STATE(2647),
    [sym_switch_statement] = STATE(2647),
    [sym_throw_statement] = STATE(2647),
    [sym_try_statement] = STATE(2647),
    [sym_unsafe_statement] = STATE(2647),
    [sym_using_statement] = STATE(2647),
    [sym_foreach_statement] = STATE(2647),
    [sym_goto_statement] = STATE(2647),
    [sym_labeled_statement] = STATE(2647),
    [sym_if_statement] = STATE(2647),
    [sym_while_statement] = STATE(2647),
    [sym_local_declaration_statement] = STATE(2647),
    [sym_local_function_statement] = STATE(2647),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6543),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2835),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2647),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(58),
    [sym_preproc_endregion] = STATE(58),
    [sym_preproc_line] = STATE(58),
    [sym_preproc_pragma] = STATE(58),
    [sym_preproc_nullable] = STATE(58),
    [sym_preproc_error] = STATE(58),
    [sym_preproc_define] = STATE(58),
    [sym_preproc_undef] = STATE(58),
    [aux_sym_class_declaration_repeat1] = STATE(2918),
    [aux_sym_class_declaration_repeat2] = STATE(3106),
    [aux_sym_block_repeat1] = STATE(54),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(647),
    [anon_sym_unsafe] = ACTIONS(649),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(655),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(659),
    [anon_sym_RBRACE] = ACTIONS(977),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(667),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(671),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(673),
    [anon_sym_unchecked] = ACTIONS(671),
    [anon_sym_continue] = ACTIONS(675),
    [anon_sym_do] = ACTIONS(677),
    [anon_sym_while] = ACTIONS(679),
    [anon_sym_for] = ACTIONS(681),
    [anon_sym_lock] = ACTIONS(683),
    [anon_sym_yield] = ACTIONS(685),
    [anon_sym_switch] = ACTIONS(687),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_try] = ACTIONS(693),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(695),
    [anon_sym_foreach] = ACTIONS(697),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [59] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2647),
    [sym_variable_declaration] = STATE(9394),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6827),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2721),
    [sym_break_statement] = STATE(2647),
    [sym_checked_statement] = STATE(2647),
    [sym_continue_statement] = STATE(2647),
    [sym_do_statement] = STATE(2647),
    [sym_empty_statement] = STATE(2647),
    [sym_expression_statement] = STATE(2647),
    [sym_fixed_statement] = STATE(2647),
    [sym_for_statement] = STATE(2647),
    [sym_return_statement] = STATE(2647),
    [sym_lock_statement] = STATE(2647),
    [sym_yield_statement] = STATE(2647),
    [sym_switch_statement] = STATE(2647),
    [sym_throw_statement] = STATE(2647),
    [sym_try_statement] = STATE(2647),
    [sym_unsafe_statement] = STATE(2647),
    [sym_using_statement] = STATE(2647),
    [sym_foreach_statement] = STATE(2647),
    [sym_goto_statement] = STATE(2647),
    [sym_labeled_statement] = STATE(2647),
    [sym_if_statement] = STATE(2647),
    [sym_while_statement] = STATE(2647),
    [sym_local_declaration_statement] = STATE(2647),
    [sym_local_function_statement] = STATE(2647),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6543),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2835),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2647),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(59),
    [sym_preproc_endregion] = STATE(59),
    [sym_preproc_line] = STATE(59),
    [sym_preproc_pragma] = STATE(59),
    [sym_preproc_nullable] = STATE(59),
    [sym_preproc_error] = STATE(59),
    [sym_preproc_define] = STATE(59),
    [sym_preproc_undef] = STATE(59),
    [aux_sym_class_declaration_repeat1] = STATE(2918),
    [aux_sym_class_declaration_repeat2] = STATE(3106),
    [aux_sym_block_repeat1] = STATE(22),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(647),
    [anon_sym_unsafe] = ACTIONS(649),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(655),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(659),
    [anon_sym_RBRACE] = ACTIONS(979),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(667),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(671),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(673),
    [anon_sym_unchecked] = ACTIONS(671),
    [anon_sym_continue] = ACTIONS(675),
    [anon_sym_do] = ACTIONS(677),
    [anon_sym_while] = ACTIONS(679),
    [anon_sym_for] = ACTIONS(681),
    [anon_sym_lock] = ACTIONS(683),
    [anon_sym_yield] = ACTIONS(685),
    [anon_sym_switch] = ACTIONS(687),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_try] = ACTIONS(693),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(695),
    [anon_sym_foreach] = ACTIONS(697),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [60] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(8872),
    [sym_variable_declaration] = STATE(9850),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6801),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(8730),
    [sym_break_statement] = STATE(8872),
    [sym_checked_statement] = STATE(8872),
    [sym_continue_statement] = STATE(8872),
    [sym_do_statement] = STATE(8872),
    [sym_empty_statement] = STATE(8872),
    [sym_expression_statement] = STATE(8872),
    [sym_fixed_statement] = STATE(8872),
    [sym_for_statement] = STATE(8872),
    [sym_return_statement] = STATE(8872),
    [sym_lock_statement] = STATE(8872),
    [sym_yield_statement] = STATE(8872),
    [sym_switch_statement] = STATE(8872),
    [sym_throw_statement] = STATE(8872),
    [sym_try_statement] = STATE(8872),
    [sym_unsafe_statement] = STATE(8872),
    [sym_using_statement] = STATE(8872),
    [sym_foreach_statement] = STATE(8872),
    [sym_goto_statement] = STATE(8872),
    [sym_labeled_statement] = STATE(8872),
    [sym_if_statement] = STATE(8872),
    [sym_while_statement] = STATE(8872),
    [sym_local_declaration_statement] = STATE(8872),
    [sym_local_function_statement] = STATE(8872),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6718),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2890),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(8872),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(60),
    [sym_preproc_endregion] = STATE(60),
    [sym_preproc_line] = STATE(60),
    [sym_preproc_pragma] = STATE(60),
    [sym_preproc_nullable] = STATE(60),
    [sym_preproc_error] = STATE(60),
    [sym_preproc_define] = STATE(60),
    [sym_preproc_undef] = STATE(60),
    [aux_sym_class_declaration_repeat1] = STATE(2909),
    [aux_sym_class_declaration_repeat2] = STATE(3101),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(981),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(983),
    [anon_sym_unsafe] = ACTIONS(985),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(987),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(989),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(991),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(993),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(995),
    [anon_sym_unchecked] = ACTIONS(993),
    [anon_sym_continue] = ACTIONS(997),
    [anon_sym_do] = ACTIONS(999),
    [anon_sym_while] = ACTIONS(1001),
    [anon_sym_for] = ACTIONS(1003),
    [anon_sym_lock] = ACTIONS(1005),
    [anon_sym_yield] = ACTIONS(1007),
    [anon_sym_switch] = ACTIONS(1009),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1011),
    [anon_sym_try] = ACTIONS(1013),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1015),
    [anon_sym_foreach] = ACTIONS(1017),
    [anon_sym_goto] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(1021),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1023),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [61] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(8872),
    [sym_variable_declaration] = STATE(9850),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6801),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(8733),
    [sym_break_statement] = STATE(8872),
    [sym_checked_statement] = STATE(8872),
    [sym_continue_statement] = STATE(8872),
    [sym_do_statement] = STATE(8872),
    [sym_empty_statement] = STATE(8872),
    [sym_expression_statement] = STATE(8872),
    [sym_fixed_statement] = STATE(8872),
    [sym_for_statement] = STATE(8872),
    [sym_return_statement] = STATE(8872),
    [sym_lock_statement] = STATE(8872),
    [sym_yield_statement] = STATE(8872),
    [sym_switch_statement] = STATE(8872),
    [sym_throw_statement] = STATE(8872),
    [sym_try_statement] = STATE(8872),
    [sym_unsafe_statement] = STATE(8872),
    [sym_using_statement] = STATE(8872),
    [sym_foreach_statement] = STATE(8872),
    [sym_goto_statement] = STATE(8872),
    [sym_labeled_statement] = STATE(8872),
    [sym_if_statement] = STATE(8872),
    [sym_while_statement] = STATE(8872),
    [sym_local_declaration_statement] = STATE(8872),
    [sym_local_function_statement] = STATE(8872),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6718),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2890),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(8872),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(61),
    [sym_preproc_endregion] = STATE(61),
    [sym_preproc_line] = STATE(61),
    [sym_preproc_pragma] = STATE(61),
    [sym_preproc_nullable] = STATE(61),
    [sym_preproc_error] = STATE(61),
    [sym_preproc_define] = STATE(61),
    [sym_preproc_undef] = STATE(61),
    [aux_sym_class_declaration_repeat1] = STATE(2909),
    [aux_sym_class_declaration_repeat2] = STATE(3101),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(981),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(983),
    [anon_sym_unsafe] = ACTIONS(985),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(987),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(989),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(991),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(993),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(995),
    [anon_sym_unchecked] = ACTIONS(993),
    [anon_sym_continue] = ACTIONS(997),
    [anon_sym_do] = ACTIONS(999),
    [anon_sym_while] = ACTIONS(1001),
    [anon_sym_for] = ACTIONS(1003),
    [anon_sym_lock] = ACTIONS(1005),
    [anon_sym_yield] = ACTIONS(1007),
    [anon_sym_switch] = ACTIONS(1009),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1011),
    [anon_sym_try] = ACTIONS(1013),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1015),
    [anon_sym_foreach] = ACTIONS(1017),
    [anon_sym_goto] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(1021),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1023),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [62] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2220),
    [sym_variable_declaration] = STATE(9437),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6809),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2223),
    [sym_break_statement] = STATE(2220),
    [sym_checked_statement] = STATE(2220),
    [sym_continue_statement] = STATE(2220),
    [sym_do_statement] = STATE(2220),
    [sym_empty_statement] = STATE(2220),
    [sym_expression_statement] = STATE(2220),
    [sym_fixed_statement] = STATE(2220),
    [sym_for_statement] = STATE(2220),
    [sym_return_statement] = STATE(2220),
    [sym_lock_statement] = STATE(2220),
    [sym_yield_statement] = STATE(2220),
    [sym_switch_statement] = STATE(2220),
    [sym_throw_statement] = STATE(2220),
    [sym_try_statement] = STATE(2220),
    [sym_unsafe_statement] = STATE(2220),
    [sym_using_statement] = STATE(2220),
    [sym_foreach_statement] = STATE(2220),
    [sym_goto_statement] = STATE(2220),
    [sym_labeled_statement] = STATE(2220),
    [sym_if_statement] = STATE(2220),
    [sym_while_statement] = STATE(2220),
    [sym_local_declaration_statement] = STATE(2220),
    [sym_local_function_statement] = STATE(2220),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6150),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2819),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2220),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(62),
    [sym_preproc_endregion] = STATE(62),
    [sym_preproc_line] = STATE(62),
    [sym_preproc_pragma] = STATE(62),
    [sym_preproc_nullable] = STATE(62),
    [sym_preproc_error] = STATE(62),
    [sym_preproc_define] = STATE(62),
    [sym_preproc_undef] = STATE(62),
    [aux_sym_class_declaration_repeat1] = STATE(2924),
    [aux_sym_class_declaration_repeat2] = STATE(3080),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(155),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1025),
    [anon_sym_unsafe] = ACTIONS(1027),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(165),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(177),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(1029),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(187),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(189),
    [anon_sym_unchecked] = ACTIONS(187),
    [anon_sym_continue] = ACTIONS(191),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_while] = ACTIONS(195),
    [anon_sym_for] = ACTIONS(197),
    [anon_sym_lock] = ACTIONS(199),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(205),
    [anon_sym_try] = ACTIONS(207),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(209),
    [anon_sym_foreach] = ACTIONS(211),
    [anon_sym_goto] = ACTIONS(213),
    [anon_sym_if] = ACTIONS(215),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(217),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [63] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2647),
    [sym_variable_declaration] = STATE(9394),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6827),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2709),
    [sym_break_statement] = STATE(2647),
    [sym_checked_statement] = STATE(2647),
    [sym_continue_statement] = STATE(2647),
    [sym_do_statement] = STATE(2647),
    [sym_empty_statement] = STATE(2647),
    [sym_expression_statement] = STATE(2647),
    [sym_fixed_statement] = STATE(2647),
    [sym_for_statement] = STATE(2647),
    [sym_return_statement] = STATE(2647),
    [sym_lock_statement] = STATE(2647),
    [sym_yield_statement] = STATE(2647),
    [sym_switch_statement] = STATE(2647),
    [sym_throw_statement] = STATE(2647),
    [sym_try_statement] = STATE(2647),
    [sym_unsafe_statement] = STATE(2647),
    [sym_using_statement] = STATE(2647),
    [sym_foreach_statement] = STATE(2647),
    [sym_goto_statement] = STATE(2647),
    [sym_labeled_statement] = STATE(2647),
    [sym_if_statement] = STATE(2647),
    [sym_while_statement] = STATE(2647),
    [sym_local_declaration_statement] = STATE(2647),
    [sym_local_function_statement] = STATE(2647),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6543),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2835),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2647),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(63),
    [sym_preproc_endregion] = STATE(63),
    [sym_preproc_line] = STATE(63),
    [sym_preproc_pragma] = STATE(63),
    [sym_preproc_nullable] = STATE(63),
    [sym_preproc_error] = STATE(63),
    [sym_preproc_define] = STATE(63),
    [sym_preproc_undef] = STATE(63),
    [aux_sym_class_declaration_repeat1] = STATE(2918),
    [aux_sym_class_declaration_repeat2] = STATE(3106),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(647),
    [anon_sym_unsafe] = ACTIONS(649),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(655),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(659),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(667),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(671),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(673),
    [anon_sym_unchecked] = ACTIONS(671),
    [anon_sym_continue] = ACTIONS(675),
    [anon_sym_do] = ACTIONS(677),
    [anon_sym_while] = ACTIONS(679),
    [anon_sym_for] = ACTIONS(681),
    [anon_sym_lock] = ACTIONS(683),
    [anon_sym_yield] = ACTIONS(685),
    [anon_sym_switch] = ACTIONS(687),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_try] = ACTIONS(693),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(695),
    [anon_sym_foreach] = ACTIONS(697),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [64] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2647),
    [sym_variable_declaration] = STATE(9394),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6827),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2710),
    [sym_break_statement] = STATE(2647),
    [sym_checked_statement] = STATE(2647),
    [sym_continue_statement] = STATE(2647),
    [sym_do_statement] = STATE(2647),
    [sym_empty_statement] = STATE(2647),
    [sym_expression_statement] = STATE(2647),
    [sym_fixed_statement] = STATE(2647),
    [sym_for_statement] = STATE(2647),
    [sym_return_statement] = STATE(2647),
    [sym_lock_statement] = STATE(2647),
    [sym_yield_statement] = STATE(2647),
    [sym_switch_statement] = STATE(2647),
    [sym_throw_statement] = STATE(2647),
    [sym_try_statement] = STATE(2647),
    [sym_unsafe_statement] = STATE(2647),
    [sym_using_statement] = STATE(2647),
    [sym_foreach_statement] = STATE(2647),
    [sym_goto_statement] = STATE(2647),
    [sym_labeled_statement] = STATE(2647),
    [sym_if_statement] = STATE(2647),
    [sym_while_statement] = STATE(2647),
    [sym_local_declaration_statement] = STATE(2647),
    [sym_local_function_statement] = STATE(2647),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6543),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2835),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2647),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(64),
    [sym_preproc_endregion] = STATE(64),
    [sym_preproc_line] = STATE(64),
    [sym_preproc_pragma] = STATE(64),
    [sym_preproc_nullable] = STATE(64),
    [sym_preproc_error] = STATE(64),
    [sym_preproc_define] = STATE(64),
    [sym_preproc_undef] = STATE(64),
    [aux_sym_class_declaration_repeat1] = STATE(2918),
    [aux_sym_class_declaration_repeat2] = STATE(3106),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(647),
    [anon_sym_unsafe] = ACTIONS(649),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(655),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(659),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(667),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(671),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(673),
    [anon_sym_unchecked] = ACTIONS(671),
    [anon_sym_continue] = ACTIONS(675),
    [anon_sym_do] = ACTIONS(677),
    [anon_sym_while] = ACTIONS(679),
    [anon_sym_for] = ACTIONS(681),
    [anon_sym_lock] = ACTIONS(683),
    [anon_sym_yield] = ACTIONS(685),
    [anon_sym_switch] = ACTIONS(687),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_try] = ACTIONS(693),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(695),
    [anon_sym_foreach] = ACTIONS(697),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [65] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2220),
    [sym_variable_declaration] = STATE(9437),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6809),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2222),
    [sym_break_statement] = STATE(2220),
    [sym_checked_statement] = STATE(2220),
    [sym_continue_statement] = STATE(2220),
    [sym_do_statement] = STATE(2220),
    [sym_empty_statement] = STATE(2220),
    [sym_expression_statement] = STATE(2220),
    [sym_fixed_statement] = STATE(2220),
    [sym_for_statement] = STATE(2220),
    [sym_return_statement] = STATE(2220),
    [sym_lock_statement] = STATE(2220),
    [sym_yield_statement] = STATE(2220),
    [sym_switch_statement] = STATE(2220),
    [sym_throw_statement] = STATE(2220),
    [sym_try_statement] = STATE(2220),
    [sym_unsafe_statement] = STATE(2220),
    [sym_using_statement] = STATE(2220),
    [sym_foreach_statement] = STATE(2220),
    [sym_goto_statement] = STATE(2220),
    [sym_labeled_statement] = STATE(2220),
    [sym_if_statement] = STATE(2220),
    [sym_while_statement] = STATE(2220),
    [sym_local_declaration_statement] = STATE(2220),
    [sym_local_function_statement] = STATE(2220),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6150),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2819),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2220),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(65),
    [sym_preproc_endregion] = STATE(65),
    [sym_preproc_line] = STATE(65),
    [sym_preproc_pragma] = STATE(65),
    [sym_preproc_nullable] = STATE(65),
    [sym_preproc_error] = STATE(65),
    [sym_preproc_define] = STATE(65),
    [sym_preproc_undef] = STATE(65),
    [aux_sym_class_declaration_repeat1] = STATE(2924),
    [aux_sym_class_declaration_repeat2] = STATE(3080),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(155),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1025),
    [anon_sym_unsafe] = ACTIONS(1027),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(165),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(177),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(1029),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(187),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(189),
    [anon_sym_unchecked] = ACTIONS(187),
    [anon_sym_continue] = ACTIONS(191),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_while] = ACTIONS(195),
    [anon_sym_for] = ACTIONS(197),
    [anon_sym_lock] = ACTIONS(199),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(205),
    [anon_sym_try] = ACTIONS(207),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(209),
    [anon_sym_foreach] = ACTIONS(211),
    [anon_sym_goto] = ACTIONS(213),
    [anon_sym_if] = ACTIONS(215),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(217),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [66] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2647),
    [sym_variable_declaration] = STATE(9394),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6827),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2712),
    [sym_break_statement] = STATE(2647),
    [sym_checked_statement] = STATE(2647),
    [sym_continue_statement] = STATE(2647),
    [sym_do_statement] = STATE(2647),
    [sym_empty_statement] = STATE(2647),
    [sym_expression_statement] = STATE(2647),
    [sym_fixed_statement] = STATE(2647),
    [sym_for_statement] = STATE(2647),
    [sym_return_statement] = STATE(2647),
    [sym_lock_statement] = STATE(2647),
    [sym_yield_statement] = STATE(2647),
    [sym_switch_statement] = STATE(2647),
    [sym_throw_statement] = STATE(2647),
    [sym_try_statement] = STATE(2647),
    [sym_unsafe_statement] = STATE(2647),
    [sym_using_statement] = STATE(2647),
    [sym_foreach_statement] = STATE(2647),
    [sym_goto_statement] = STATE(2647),
    [sym_labeled_statement] = STATE(2647),
    [sym_if_statement] = STATE(2647),
    [sym_while_statement] = STATE(2647),
    [sym_local_declaration_statement] = STATE(2647),
    [sym_local_function_statement] = STATE(2647),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6543),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2835),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2647),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(66),
    [sym_preproc_endregion] = STATE(66),
    [sym_preproc_line] = STATE(66),
    [sym_preproc_pragma] = STATE(66),
    [sym_preproc_nullable] = STATE(66),
    [sym_preproc_error] = STATE(66),
    [sym_preproc_define] = STATE(66),
    [sym_preproc_undef] = STATE(66),
    [aux_sym_class_declaration_repeat1] = STATE(2918),
    [aux_sym_class_declaration_repeat2] = STATE(3106),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(647),
    [anon_sym_unsafe] = ACTIONS(649),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(655),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(659),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(667),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(671),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(673),
    [anon_sym_unchecked] = ACTIONS(671),
    [anon_sym_continue] = ACTIONS(675),
    [anon_sym_do] = ACTIONS(677),
    [anon_sym_while] = ACTIONS(679),
    [anon_sym_for] = ACTIONS(681),
    [anon_sym_lock] = ACTIONS(683),
    [anon_sym_yield] = ACTIONS(685),
    [anon_sym_switch] = ACTIONS(687),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_try] = ACTIONS(693),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(695),
    [anon_sym_foreach] = ACTIONS(697),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [67] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(8872),
    [sym_variable_declaration] = STATE(9850),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6801),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(9678),
    [sym_break_statement] = STATE(8872),
    [sym_checked_statement] = STATE(8872),
    [sym_continue_statement] = STATE(8872),
    [sym_do_statement] = STATE(8872),
    [sym_empty_statement] = STATE(8872),
    [sym_expression_statement] = STATE(8872),
    [sym_fixed_statement] = STATE(8872),
    [sym_for_statement] = STATE(8872),
    [sym_return_statement] = STATE(8872),
    [sym_lock_statement] = STATE(8872),
    [sym_yield_statement] = STATE(8872),
    [sym_switch_statement] = STATE(8872),
    [sym_throw_statement] = STATE(8872),
    [sym_try_statement] = STATE(8872),
    [sym_unsafe_statement] = STATE(8872),
    [sym_using_statement] = STATE(8872),
    [sym_foreach_statement] = STATE(8872),
    [sym_goto_statement] = STATE(8872),
    [sym_labeled_statement] = STATE(8872),
    [sym_if_statement] = STATE(8872),
    [sym_while_statement] = STATE(8872),
    [sym_local_declaration_statement] = STATE(8872),
    [sym_local_function_statement] = STATE(8872),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6718),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2890),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(8872),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(67),
    [sym_preproc_endregion] = STATE(67),
    [sym_preproc_line] = STATE(67),
    [sym_preproc_pragma] = STATE(67),
    [sym_preproc_nullable] = STATE(67),
    [sym_preproc_error] = STATE(67),
    [sym_preproc_define] = STATE(67),
    [sym_preproc_undef] = STATE(67),
    [aux_sym_class_declaration_repeat1] = STATE(2909),
    [aux_sym_class_declaration_repeat2] = STATE(3101),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(981),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(983),
    [anon_sym_unsafe] = ACTIONS(985),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(987),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(989),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(991),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(993),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(995),
    [anon_sym_unchecked] = ACTIONS(993),
    [anon_sym_continue] = ACTIONS(997),
    [anon_sym_do] = ACTIONS(999),
    [anon_sym_while] = ACTIONS(1001),
    [anon_sym_for] = ACTIONS(1003),
    [anon_sym_lock] = ACTIONS(1005),
    [anon_sym_yield] = ACTIONS(1007),
    [anon_sym_switch] = ACTIONS(1009),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1011),
    [anon_sym_try] = ACTIONS(1013),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1015),
    [anon_sym_foreach] = ACTIONS(1017),
    [anon_sym_goto] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(1021),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1023),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [68] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2647),
    [sym_variable_declaration] = STATE(9394),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6827),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2714),
    [sym_break_statement] = STATE(2647),
    [sym_checked_statement] = STATE(2647),
    [sym_continue_statement] = STATE(2647),
    [sym_do_statement] = STATE(2647),
    [sym_empty_statement] = STATE(2647),
    [sym_expression_statement] = STATE(2647),
    [sym_fixed_statement] = STATE(2647),
    [sym_for_statement] = STATE(2647),
    [sym_return_statement] = STATE(2647),
    [sym_lock_statement] = STATE(2647),
    [sym_yield_statement] = STATE(2647),
    [sym_switch_statement] = STATE(2647),
    [sym_throw_statement] = STATE(2647),
    [sym_try_statement] = STATE(2647),
    [sym_unsafe_statement] = STATE(2647),
    [sym_using_statement] = STATE(2647),
    [sym_foreach_statement] = STATE(2647),
    [sym_goto_statement] = STATE(2647),
    [sym_labeled_statement] = STATE(2647),
    [sym_if_statement] = STATE(2647),
    [sym_while_statement] = STATE(2647),
    [sym_local_declaration_statement] = STATE(2647),
    [sym_local_function_statement] = STATE(2647),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6543),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2835),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2647),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(68),
    [sym_preproc_endregion] = STATE(68),
    [sym_preproc_line] = STATE(68),
    [sym_preproc_pragma] = STATE(68),
    [sym_preproc_nullable] = STATE(68),
    [sym_preproc_error] = STATE(68),
    [sym_preproc_define] = STATE(68),
    [sym_preproc_undef] = STATE(68),
    [aux_sym_class_declaration_repeat1] = STATE(2918),
    [aux_sym_class_declaration_repeat2] = STATE(3106),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(647),
    [anon_sym_unsafe] = ACTIONS(649),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(655),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(659),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(667),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(671),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(673),
    [anon_sym_unchecked] = ACTIONS(671),
    [anon_sym_continue] = ACTIONS(675),
    [anon_sym_do] = ACTIONS(677),
    [anon_sym_while] = ACTIONS(679),
    [anon_sym_for] = ACTIONS(681),
    [anon_sym_lock] = ACTIONS(683),
    [anon_sym_yield] = ACTIONS(685),
    [anon_sym_switch] = ACTIONS(687),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_try] = ACTIONS(693),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(695),
    [anon_sym_foreach] = ACTIONS(697),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [69] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2647),
    [sym_variable_declaration] = STATE(9394),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6827),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2704),
    [sym_break_statement] = STATE(2647),
    [sym_checked_statement] = STATE(2647),
    [sym_continue_statement] = STATE(2647),
    [sym_do_statement] = STATE(2647),
    [sym_empty_statement] = STATE(2647),
    [sym_expression_statement] = STATE(2647),
    [sym_fixed_statement] = STATE(2647),
    [sym_for_statement] = STATE(2647),
    [sym_return_statement] = STATE(2647),
    [sym_lock_statement] = STATE(2647),
    [sym_yield_statement] = STATE(2647),
    [sym_switch_statement] = STATE(2647),
    [sym_throw_statement] = STATE(2647),
    [sym_try_statement] = STATE(2647),
    [sym_unsafe_statement] = STATE(2647),
    [sym_using_statement] = STATE(2647),
    [sym_foreach_statement] = STATE(2647),
    [sym_goto_statement] = STATE(2647),
    [sym_labeled_statement] = STATE(2647),
    [sym_if_statement] = STATE(2647),
    [sym_while_statement] = STATE(2647),
    [sym_local_declaration_statement] = STATE(2647),
    [sym_local_function_statement] = STATE(2647),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6543),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2835),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2647),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(69),
    [sym_preproc_endregion] = STATE(69),
    [sym_preproc_line] = STATE(69),
    [sym_preproc_pragma] = STATE(69),
    [sym_preproc_nullable] = STATE(69),
    [sym_preproc_error] = STATE(69),
    [sym_preproc_define] = STATE(69),
    [sym_preproc_undef] = STATE(69),
    [aux_sym_class_declaration_repeat1] = STATE(2918),
    [aux_sym_class_declaration_repeat2] = STATE(3106),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(647),
    [anon_sym_unsafe] = ACTIONS(649),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(655),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(659),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(667),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(671),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(673),
    [anon_sym_unchecked] = ACTIONS(671),
    [anon_sym_continue] = ACTIONS(675),
    [anon_sym_do] = ACTIONS(677),
    [anon_sym_while] = ACTIONS(679),
    [anon_sym_for] = ACTIONS(681),
    [anon_sym_lock] = ACTIONS(683),
    [anon_sym_yield] = ACTIONS(685),
    [anon_sym_switch] = ACTIONS(687),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_try] = ACTIONS(693),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(695),
    [anon_sym_foreach] = ACTIONS(697),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [70] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2647),
    [sym_variable_declaration] = STATE(9394),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6827),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2703),
    [sym_break_statement] = STATE(2647),
    [sym_checked_statement] = STATE(2647),
    [sym_continue_statement] = STATE(2647),
    [sym_do_statement] = STATE(2647),
    [sym_empty_statement] = STATE(2647),
    [sym_expression_statement] = STATE(2647),
    [sym_fixed_statement] = STATE(2647),
    [sym_for_statement] = STATE(2647),
    [sym_return_statement] = STATE(2647),
    [sym_lock_statement] = STATE(2647),
    [sym_yield_statement] = STATE(2647),
    [sym_switch_statement] = STATE(2647),
    [sym_throw_statement] = STATE(2647),
    [sym_try_statement] = STATE(2647),
    [sym_unsafe_statement] = STATE(2647),
    [sym_using_statement] = STATE(2647),
    [sym_foreach_statement] = STATE(2647),
    [sym_goto_statement] = STATE(2647),
    [sym_labeled_statement] = STATE(2647),
    [sym_if_statement] = STATE(2647),
    [sym_while_statement] = STATE(2647),
    [sym_local_declaration_statement] = STATE(2647),
    [sym_local_function_statement] = STATE(2647),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6543),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2835),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2647),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(70),
    [sym_preproc_endregion] = STATE(70),
    [sym_preproc_line] = STATE(70),
    [sym_preproc_pragma] = STATE(70),
    [sym_preproc_nullable] = STATE(70),
    [sym_preproc_error] = STATE(70),
    [sym_preproc_define] = STATE(70),
    [sym_preproc_undef] = STATE(70),
    [aux_sym_class_declaration_repeat1] = STATE(2918),
    [aux_sym_class_declaration_repeat2] = STATE(3106),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(647),
    [anon_sym_unsafe] = ACTIONS(649),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(655),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(659),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(667),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(671),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(673),
    [anon_sym_unchecked] = ACTIONS(671),
    [anon_sym_continue] = ACTIONS(675),
    [anon_sym_do] = ACTIONS(677),
    [anon_sym_while] = ACTIONS(679),
    [anon_sym_for] = ACTIONS(681),
    [anon_sym_lock] = ACTIONS(683),
    [anon_sym_yield] = ACTIONS(685),
    [anon_sym_switch] = ACTIONS(687),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_try] = ACTIONS(693),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(695),
    [anon_sym_foreach] = ACTIONS(697),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [71] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2478),
    [sym_variable_declaration] = STATE(9764),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6873),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2425),
    [sym_break_statement] = STATE(2478),
    [sym_checked_statement] = STATE(2478),
    [sym_continue_statement] = STATE(2478),
    [sym_do_statement] = STATE(2478),
    [sym_empty_statement] = STATE(2478),
    [sym_expression_statement] = STATE(2478),
    [sym_fixed_statement] = STATE(2478),
    [sym_for_statement] = STATE(2478),
    [sym_return_statement] = STATE(2478),
    [sym_lock_statement] = STATE(2478),
    [sym_yield_statement] = STATE(2478),
    [sym_switch_statement] = STATE(2478),
    [sym_throw_statement] = STATE(2478),
    [sym_try_statement] = STATE(2478),
    [sym_unsafe_statement] = STATE(2478),
    [sym_using_statement] = STATE(2478),
    [sym_foreach_statement] = STATE(2478),
    [sym_goto_statement] = STATE(2478),
    [sym_labeled_statement] = STATE(2478),
    [sym_if_statement] = STATE(2478),
    [sym_while_statement] = STATE(2478),
    [sym_local_declaration_statement] = STATE(2478),
    [sym_local_function_statement] = STATE(2478),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6724),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2900),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2478),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(71),
    [sym_preproc_endregion] = STATE(71),
    [sym_preproc_line] = STATE(71),
    [sym_preproc_pragma] = STATE(71),
    [sym_preproc_nullable] = STATE(71),
    [sym_preproc_error] = STATE(71),
    [sym_preproc_define] = STATE(71),
    [sym_preproc_undef] = STATE(71),
    [aux_sym_class_declaration_repeat1] = STATE(2921),
    [aux_sym_class_declaration_repeat2] = STATE(3105),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1031),
    [anon_sym_unsafe] = ACTIONS(1033),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(1035),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(71),
    [anon_sym_continue] = ACTIONS(91),
    [anon_sym_do] = ACTIONS(93),
    [anon_sym_while] = ACTIONS(95),
    [anon_sym_for] = ACTIONS(97),
    [anon_sym_lock] = ACTIONS(99),
    [anon_sym_yield] = ACTIONS(101),
    [anon_sym_switch] = ACTIONS(103),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(107),
    [anon_sym_try] = ACTIONS(109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(111),
    [anon_sym_foreach] = ACTIONS(113),
    [anon_sym_goto] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(143),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [72] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2220),
    [sym_variable_declaration] = STATE(9437),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6809),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2221),
    [sym_break_statement] = STATE(2220),
    [sym_checked_statement] = STATE(2220),
    [sym_continue_statement] = STATE(2220),
    [sym_do_statement] = STATE(2220),
    [sym_empty_statement] = STATE(2220),
    [sym_expression_statement] = STATE(2220),
    [sym_fixed_statement] = STATE(2220),
    [sym_for_statement] = STATE(2220),
    [sym_return_statement] = STATE(2220),
    [sym_lock_statement] = STATE(2220),
    [sym_yield_statement] = STATE(2220),
    [sym_switch_statement] = STATE(2220),
    [sym_throw_statement] = STATE(2220),
    [sym_try_statement] = STATE(2220),
    [sym_unsafe_statement] = STATE(2220),
    [sym_using_statement] = STATE(2220),
    [sym_foreach_statement] = STATE(2220),
    [sym_goto_statement] = STATE(2220),
    [sym_labeled_statement] = STATE(2220),
    [sym_if_statement] = STATE(2220),
    [sym_while_statement] = STATE(2220),
    [sym_local_declaration_statement] = STATE(2220),
    [sym_local_function_statement] = STATE(2220),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6150),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2819),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2220),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(72),
    [sym_preproc_endregion] = STATE(72),
    [sym_preproc_line] = STATE(72),
    [sym_preproc_pragma] = STATE(72),
    [sym_preproc_nullable] = STATE(72),
    [sym_preproc_error] = STATE(72),
    [sym_preproc_define] = STATE(72),
    [sym_preproc_undef] = STATE(72),
    [aux_sym_class_declaration_repeat1] = STATE(2924),
    [aux_sym_class_declaration_repeat2] = STATE(3080),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(155),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1025),
    [anon_sym_unsafe] = ACTIONS(1027),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(165),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(177),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(1029),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(187),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(189),
    [anon_sym_unchecked] = ACTIONS(187),
    [anon_sym_continue] = ACTIONS(191),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_while] = ACTIONS(195),
    [anon_sym_for] = ACTIONS(197),
    [anon_sym_lock] = ACTIONS(199),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(205),
    [anon_sym_try] = ACTIONS(207),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(209),
    [anon_sym_foreach] = ACTIONS(211),
    [anon_sym_goto] = ACTIONS(213),
    [anon_sym_if] = ACTIONS(215),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(217),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [73] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2478),
    [sym_variable_declaration] = STATE(9764),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6873),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2454),
    [sym_break_statement] = STATE(2478),
    [sym_checked_statement] = STATE(2478),
    [sym_continue_statement] = STATE(2478),
    [sym_do_statement] = STATE(2478),
    [sym_empty_statement] = STATE(2478),
    [sym_expression_statement] = STATE(2478),
    [sym_fixed_statement] = STATE(2478),
    [sym_for_statement] = STATE(2478),
    [sym_return_statement] = STATE(2478),
    [sym_lock_statement] = STATE(2478),
    [sym_yield_statement] = STATE(2478),
    [sym_switch_statement] = STATE(2478),
    [sym_throw_statement] = STATE(2478),
    [sym_try_statement] = STATE(2478),
    [sym_unsafe_statement] = STATE(2478),
    [sym_using_statement] = STATE(2478),
    [sym_foreach_statement] = STATE(2478),
    [sym_goto_statement] = STATE(2478),
    [sym_labeled_statement] = STATE(2478),
    [sym_if_statement] = STATE(2478),
    [sym_while_statement] = STATE(2478),
    [sym_local_declaration_statement] = STATE(2478),
    [sym_local_function_statement] = STATE(2478),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6724),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2900),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2478),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(73),
    [sym_preproc_endregion] = STATE(73),
    [sym_preproc_line] = STATE(73),
    [sym_preproc_pragma] = STATE(73),
    [sym_preproc_nullable] = STATE(73),
    [sym_preproc_error] = STATE(73),
    [sym_preproc_define] = STATE(73),
    [sym_preproc_undef] = STATE(73),
    [aux_sym_class_declaration_repeat1] = STATE(2921),
    [aux_sym_class_declaration_repeat2] = STATE(3105),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1031),
    [anon_sym_unsafe] = ACTIONS(1033),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(1035),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(71),
    [anon_sym_continue] = ACTIONS(91),
    [anon_sym_do] = ACTIONS(93),
    [anon_sym_while] = ACTIONS(95),
    [anon_sym_for] = ACTIONS(97),
    [anon_sym_lock] = ACTIONS(99),
    [anon_sym_yield] = ACTIONS(101),
    [anon_sym_switch] = ACTIONS(103),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(107),
    [anon_sym_try] = ACTIONS(109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(111),
    [anon_sym_foreach] = ACTIONS(113),
    [anon_sym_goto] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(143),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [74] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(8872),
    [sym_variable_declaration] = STATE(9850),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6801),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(9934),
    [sym_break_statement] = STATE(8872),
    [sym_checked_statement] = STATE(8872),
    [sym_continue_statement] = STATE(8872),
    [sym_do_statement] = STATE(8872),
    [sym_empty_statement] = STATE(8872),
    [sym_expression_statement] = STATE(8872),
    [sym_fixed_statement] = STATE(8872),
    [sym_for_statement] = STATE(8872),
    [sym_return_statement] = STATE(8872),
    [sym_lock_statement] = STATE(8872),
    [sym_yield_statement] = STATE(8872),
    [sym_switch_statement] = STATE(8872),
    [sym_throw_statement] = STATE(8872),
    [sym_try_statement] = STATE(8872),
    [sym_unsafe_statement] = STATE(8872),
    [sym_using_statement] = STATE(8872),
    [sym_foreach_statement] = STATE(8872),
    [sym_goto_statement] = STATE(8872),
    [sym_labeled_statement] = STATE(8872),
    [sym_if_statement] = STATE(8872),
    [sym_while_statement] = STATE(8872),
    [sym_local_declaration_statement] = STATE(8872),
    [sym_local_function_statement] = STATE(8872),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6718),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2890),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(8872),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(74),
    [sym_preproc_endregion] = STATE(74),
    [sym_preproc_line] = STATE(74),
    [sym_preproc_pragma] = STATE(74),
    [sym_preproc_nullable] = STATE(74),
    [sym_preproc_error] = STATE(74),
    [sym_preproc_define] = STATE(74),
    [sym_preproc_undef] = STATE(74),
    [aux_sym_class_declaration_repeat1] = STATE(2909),
    [aux_sym_class_declaration_repeat2] = STATE(3101),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(981),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(983),
    [anon_sym_unsafe] = ACTIONS(985),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(987),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(989),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(991),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(993),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(995),
    [anon_sym_unchecked] = ACTIONS(993),
    [anon_sym_continue] = ACTIONS(997),
    [anon_sym_do] = ACTIONS(999),
    [anon_sym_while] = ACTIONS(1001),
    [anon_sym_for] = ACTIONS(1003),
    [anon_sym_lock] = ACTIONS(1005),
    [anon_sym_yield] = ACTIONS(1007),
    [anon_sym_switch] = ACTIONS(1009),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1011),
    [anon_sym_try] = ACTIONS(1013),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1015),
    [anon_sym_foreach] = ACTIONS(1017),
    [anon_sym_goto] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(1021),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1023),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [75] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2220),
    [sym_variable_declaration] = STATE(9437),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6809),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2219),
    [sym_break_statement] = STATE(2220),
    [sym_checked_statement] = STATE(2220),
    [sym_continue_statement] = STATE(2220),
    [sym_do_statement] = STATE(2220),
    [sym_empty_statement] = STATE(2220),
    [sym_expression_statement] = STATE(2220),
    [sym_fixed_statement] = STATE(2220),
    [sym_for_statement] = STATE(2220),
    [sym_return_statement] = STATE(2220),
    [sym_lock_statement] = STATE(2220),
    [sym_yield_statement] = STATE(2220),
    [sym_switch_statement] = STATE(2220),
    [sym_throw_statement] = STATE(2220),
    [sym_try_statement] = STATE(2220),
    [sym_unsafe_statement] = STATE(2220),
    [sym_using_statement] = STATE(2220),
    [sym_foreach_statement] = STATE(2220),
    [sym_goto_statement] = STATE(2220),
    [sym_labeled_statement] = STATE(2220),
    [sym_if_statement] = STATE(2220),
    [sym_while_statement] = STATE(2220),
    [sym_local_declaration_statement] = STATE(2220),
    [sym_local_function_statement] = STATE(2220),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6150),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2819),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2220),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(75),
    [sym_preproc_endregion] = STATE(75),
    [sym_preproc_line] = STATE(75),
    [sym_preproc_pragma] = STATE(75),
    [sym_preproc_nullable] = STATE(75),
    [sym_preproc_error] = STATE(75),
    [sym_preproc_define] = STATE(75),
    [sym_preproc_undef] = STATE(75),
    [aux_sym_class_declaration_repeat1] = STATE(2924),
    [aux_sym_class_declaration_repeat2] = STATE(3080),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(155),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1025),
    [anon_sym_unsafe] = ACTIONS(1027),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(165),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(177),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(1029),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(187),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(189),
    [anon_sym_unchecked] = ACTIONS(187),
    [anon_sym_continue] = ACTIONS(191),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_while] = ACTIONS(195),
    [anon_sym_for] = ACTIONS(197),
    [anon_sym_lock] = ACTIONS(199),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(205),
    [anon_sym_try] = ACTIONS(207),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(209),
    [anon_sym_foreach] = ACTIONS(211),
    [anon_sym_goto] = ACTIONS(213),
    [anon_sym_if] = ACTIONS(215),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(217),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [76] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2478),
    [sym_variable_declaration] = STATE(9764),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6873),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2453),
    [sym_break_statement] = STATE(2478),
    [sym_checked_statement] = STATE(2478),
    [sym_continue_statement] = STATE(2478),
    [sym_do_statement] = STATE(2478),
    [sym_empty_statement] = STATE(2478),
    [sym_expression_statement] = STATE(2478),
    [sym_fixed_statement] = STATE(2478),
    [sym_for_statement] = STATE(2478),
    [sym_return_statement] = STATE(2478),
    [sym_lock_statement] = STATE(2478),
    [sym_yield_statement] = STATE(2478),
    [sym_switch_statement] = STATE(2478),
    [sym_throw_statement] = STATE(2478),
    [sym_try_statement] = STATE(2478),
    [sym_unsafe_statement] = STATE(2478),
    [sym_using_statement] = STATE(2478),
    [sym_foreach_statement] = STATE(2478),
    [sym_goto_statement] = STATE(2478),
    [sym_labeled_statement] = STATE(2478),
    [sym_if_statement] = STATE(2478),
    [sym_while_statement] = STATE(2478),
    [sym_local_declaration_statement] = STATE(2478),
    [sym_local_function_statement] = STATE(2478),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6724),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2900),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2478),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(76),
    [sym_preproc_endregion] = STATE(76),
    [sym_preproc_line] = STATE(76),
    [sym_preproc_pragma] = STATE(76),
    [sym_preproc_nullable] = STATE(76),
    [sym_preproc_error] = STATE(76),
    [sym_preproc_define] = STATE(76),
    [sym_preproc_undef] = STATE(76),
    [aux_sym_class_declaration_repeat1] = STATE(2921),
    [aux_sym_class_declaration_repeat2] = STATE(3105),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1031),
    [anon_sym_unsafe] = ACTIONS(1033),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(1035),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(71),
    [anon_sym_continue] = ACTIONS(91),
    [anon_sym_do] = ACTIONS(93),
    [anon_sym_while] = ACTIONS(95),
    [anon_sym_for] = ACTIONS(97),
    [anon_sym_lock] = ACTIONS(99),
    [anon_sym_yield] = ACTIONS(101),
    [anon_sym_switch] = ACTIONS(103),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(107),
    [anon_sym_try] = ACTIONS(109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(111),
    [anon_sym_foreach] = ACTIONS(113),
    [anon_sym_goto] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(143),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [77] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2478),
    [sym_variable_declaration] = STATE(9764),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6873),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2452),
    [sym_break_statement] = STATE(2478),
    [sym_checked_statement] = STATE(2478),
    [sym_continue_statement] = STATE(2478),
    [sym_do_statement] = STATE(2478),
    [sym_empty_statement] = STATE(2478),
    [sym_expression_statement] = STATE(2478),
    [sym_fixed_statement] = STATE(2478),
    [sym_for_statement] = STATE(2478),
    [sym_return_statement] = STATE(2478),
    [sym_lock_statement] = STATE(2478),
    [sym_yield_statement] = STATE(2478),
    [sym_switch_statement] = STATE(2478),
    [sym_throw_statement] = STATE(2478),
    [sym_try_statement] = STATE(2478),
    [sym_unsafe_statement] = STATE(2478),
    [sym_using_statement] = STATE(2478),
    [sym_foreach_statement] = STATE(2478),
    [sym_goto_statement] = STATE(2478),
    [sym_labeled_statement] = STATE(2478),
    [sym_if_statement] = STATE(2478),
    [sym_while_statement] = STATE(2478),
    [sym_local_declaration_statement] = STATE(2478),
    [sym_local_function_statement] = STATE(2478),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6724),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2900),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2478),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(77),
    [sym_preproc_endregion] = STATE(77),
    [sym_preproc_line] = STATE(77),
    [sym_preproc_pragma] = STATE(77),
    [sym_preproc_nullable] = STATE(77),
    [sym_preproc_error] = STATE(77),
    [sym_preproc_define] = STATE(77),
    [sym_preproc_undef] = STATE(77),
    [aux_sym_class_declaration_repeat1] = STATE(2921),
    [aux_sym_class_declaration_repeat2] = STATE(3105),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1031),
    [anon_sym_unsafe] = ACTIONS(1033),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(1035),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(71),
    [anon_sym_continue] = ACTIONS(91),
    [anon_sym_do] = ACTIONS(93),
    [anon_sym_while] = ACTIONS(95),
    [anon_sym_for] = ACTIONS(97),
    [anon_sym_lock] = ACTIONS(99),
    [anon_sym_yield] = ACTIONS(101),
    [anon_sym_switch] = ACTIONS(103),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(107),
    [anon_sym_try] = ACTIONS(109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(111),
    [anon_sym_foreach] = ACTIONS(113),
    [anon_sym_goto] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(143),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [78] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2647),
    [sym_variable_declaration] = STATE(9394),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6827),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2697),
    [sym_break_statement] = STATE(2647),
    [sym_checked_statement] = STATE(2647),
    [sym_continue_statement] = STATE(2647),
    [sym_do_statement] = STATE(2647),
    [sym_empty_statement] = STATE(2647),
    [sym_expression_statement] = STATE(2647),
    [sym_fixed_statement] = STATE(2647),
    [sym_for_statement] = STATE(2647),
    [sym_return_statement] = STATE(2647),
    [sym_lock_statement] = STATE(2647),
    [sym_yield_statement] = STATE(2647),
    [sym_switch_statement] = STATE(2647),
    [sym_throw_statement] = STATE(2647),
    [sym_try_statement] = STATE(2647),
    [sym_unsafe_statement] = STATE(2647),
    [sym_using_statement] = STATE(2647),
    [sym_foreach_statement] = STATE(2647),
    [sym_goto_statement] = STATE(2647),
    [sym_labeled_statement] = STATE(2647),
    [sym_if_statement] = STATE(2647),
    [sym_while_statement] = STATE(2647),
    [sym_local_declaration_statement] = STATE(2647),
    [sym_local_function_statement] = STATE(2647),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6543),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2835),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2647),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(78),
    [sym_preproc_endregion] = STATE(78),
    [sym_preproc_line] = STATE(78),
    [sym_preproc_pragma] = STATE(78),
    [sym_preproc_nullable] = STATE(78),
    [sym_preproc_error] = STATE(78),
    [sym_preproc_define] = STATE(78),
    [sym_preproc_undef] = STATE(78),
    [aux_sym_class_declaration_repeat1] = STATE(2918),
    [aux_sym_class_declaration_repeat2] = STATE(3106),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(647),
    [anon_sym_unsafe] = ACTIONS(649),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(655),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(659),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(667),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(671),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(673),
    [anon_sym_unchecked] = ACTIONS(671),
    [anon_sym_continue] = ACTIONS(675),
    [anon_sym_do] = ACTIONS(677),
    [anon_sym_while] = ACTIONS(679),
    [anon_sym_for] = ACTIONS(681),
    [anon_sym_lock] = ACTIONS(683),
    [anon_sym_yield] = ACTIONS(685),
    [anon_sym_switch] = ACTIONS(687),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_try] = ACTIONS(693),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(695),
    [anon_sym_foreach] = ACTIONS(697),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [79] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2220),
    [sym_variable_declaration] = STATE(9437),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6809),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2218),
    [sym_break_statement] = STATE(2220),
    [sym_checked_statement] = STATE(2220),
    [sym_continue_statement] = STATE(2220),
    [sym_do_statement] = STATE(2220),
    [sym_empty_statement] = STATE(2220),
    [sym_expression_statement] = STATE(2220),
    [sym_fixed_statement] = STATE(2220),
    [sym_for_statement] = STATE(2220),
    [sym_return_statement] = STATE(2220),
    [sym_lock_statement] = STATE(2220),
    [sym_yield_statement] = STATE(2220),
    [sym_switch_statement] = STATE(2220),
    [sym_throw_statement] = STATE(2220),
    [sym_try_statement] = STATE(2220),
    [sym_unsafe_statement] = STATE(2220),
    [sym_using_statement] = STATE(2220),
    [sym_foreach_statement] = STATE(2220),
    [sym_goto_statement] = STATE(2220),
    [sym_labeled_statement] = STATE(2220),
    [sym_if_statement] = STATE(2220),
    [sym_while_statement] = STATE(2220),
    [sym_local_declaration_statement] = STATE(2220),
    [sym_local_function_statement] = STATE(2220),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6150),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2819),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2220),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(79),
    [sym_preproc_endregion] = STATE(79),
    [sym_preproc_line] = STATE(79),
    [sym_preproc_pragma] = STATE(79),
    [sym_preproc_nullable] = STATE(79),
    [sym_preproc_error] = STATE(79),
    [sym_preproc_define] = STATE(79),
    [sym_preproc_undef] = STATE(79),
    [aux_sym_class_declaration_repeat1] = STATE(2924),
    [aux_sym_class_declaration_repeat2] = STATE(3080),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(155),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1025),
    [anon_sym_unsafe] = ACTIONS(1027),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(165),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(177),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(1029),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(187),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(189),
    [anon_sym_unchecked] = ACTIONS(187),
    [anon_sym_continue] = ACTIONS(191),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_while] = ACTIONS(195),
    [anon_sym_for] = ACTIONS(197),
    [anon_sym_lock] = ACTIONS(199),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(205),
    [anon_sym_try] = ACTIONS(207),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(209),
    [anon_sym_foreach] = ACTIONS(211),
    [anon_sym_goto] = ACTIONS(213),
    [anon_sym_if] = ACTIONS(215),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(217),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [80] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2220),
    [sym_variable_declaration] = STATE(9437),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6809),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2217),
    [sym_break_statement] = STATE(2220),
    [sym_checked_statement] = STATE(2220),
    [sym_continue_statement] = STATE(2220),
    [sym_do_statement] = STATE(2220),
    [sym_empty_statement] = STATE(2220),
    [sym_expression_statement] = STATE(2220),
    [sym_fixed_statement] = STATE(2220),
    [sym_for_statement] = STATE(2220),
    [sym_return_statement] = STATE(2220),
    [sym_lock_statement] = STATE(2220),
    [sym_yield_statement] = STATE(2220),
    [sym_switch_statement] = STATE(2220),
    [sym_throw_statement] = STATE(2220),
    [sym_try_statement] = STATE(2220),
    [sym_unsafe_statement] = STATE(2220),
    [sym_using_statement] = STATE(2220),
    [sym_foreach_statement] = STATE(2220),
    [sym_goto_statement] = STATE(2220),
    [sym_labeled_statement] = STATE(2220),
    [sym_if_statement] = STATE(2220),
    [sym_while_statement] = STATE(2220),
    [sym_local_declaration_statement] = STATE(2220),
    [sym_local_function_statement] = STATE(2220),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6150),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2819),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2220),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(80),
    [sym_preproc_endregion] = STATE(80),
    [sym_preproc_line] = STATE(80),
    [sym_preproc_pragma] = STATE(80),
    [sym_preproc_nullable] = STATE(80),
    [sym_preproc_error] = STATE(80),
    [sym_preproc_define] = STATE(80),
    [sym_preproc_undef] = STATE(80),
    [aux_sym_class_declaration_repeat1] = STATE(2924),
    [aux_sym_class_declaration_repeat2] = STATE(3080),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(155),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1025),
    [anon_sym_unsafe] = ACTIONS(1027),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(165),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(177),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(1029),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(187),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(189),
    [anon_sym_unchecked] = ACTIONS(187),
    [anon_sym_continue] = ACTIONS(191),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_while] = ACTIONS(195),
    [anon_sym_for] = ACTIONS(197),
    [anon_sym_lock] = ACTIONS(199),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(205),
    [anon_sym_try] = ACTIONS(207),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(209),
    [anon_sym_foreach] = ACTIONS(211),
    [anon_sym_goto] = ACTIONS(213),
    [anon_sym_if] = ACTIONS(215),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(217),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [81] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2478),
    [sym_variable_declaration] = STATE(9764),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6873),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2451),
    [sym_break_statement] = STATE(2478),
    [sym_checked_statement] = STATE(2478),
    [sym_continue_statement] = STATE(2478),
    [sym_do_statement] = STATE(2478),
    [sym_empty_statement] = STATE(2478),
    [sym_expression_statement] = STATE(2478),
    [sym_fixed_statement] = STATE(2478),
    [sym_for_statement] = STATE(2478),
    [sym_return_statement] = STATE(2478),
    [sym_lock_statement] = STATE(2478),
    [sym_yield_statement] = STATE(2478),
    [sym_switch_statement] = STATE(2478),
    [sym_throw_statement] = STATE(2478),
    [sym_try_statement] = STATE(2478),
    [sym_unsafe_statement] = STATE(2478),
    [sym_using_statement] = STATE(2478),
    [sym_foreach_statement] = STATE(2478),
    [sym_goto_statement] = STATE(2478),
    [sym_labeled_statement] = STATE(2478),
    [sym_if_statement] = STATE(2478),
    [sym_while_statement] = STATE(2478),
    [sym_local_declaration_statement] = STATE(2478),
    [sym_local_function_statement] = STATE(2478),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6724),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2900),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2478),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(81),
    [sym_preproc_endregion] = STATE(81),
    [sym_preproc_line] = STATE(81),
    [sym_preproc_pragma] = STATE(81),
    [sym_preproc_nullable] = STATE(81),
    [sym_preproc_error] = STATE(81),
    [sym_preproc_define] = STATE(81),
    [sym_preproc_undef] = STATE(81),
    [aux_sym_class_declaration_repeat1] = STATE(2921),
    [aux_sym_class_declaration_repeat2] = STATE(3105),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1031),
    [anon_sym_unsafe] = ACTIONS(1033),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(1035),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(71),
    [anon_sym_continue] = ACTIONS(91),
    [anon_sym_do] = ACTIONS(93),
    [anon_sym_while] = ACTIONS(95),
    [anon_sym_for] = ACTIONS(97),
    [anon_sym_lock] = ACTIONS(99),
    [anon_sym_yield] = ACTIONS(101),
    [anon_sym_switch] = ACTIONS(103),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(107),
    [anon_sym_try] = ACTIONS(109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(111),
    [anon_sym_foreach] = ACTIONS(113),
    [anon_sym_goto] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(143),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [82] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2647),
    [sym_variable_declaration] = STATE(9394),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6827),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2689),
    [sym_break_statement] = STATE(2647),
    [sym_checked_statement] = STATE(2647),
    [sym_continue_statement] = STATE(2647),
    [sym_do_statement] = STATE(2647),
    [sym_empty_statement] = STATE(2647),
    [sym_expression_statement] = STATE(2647),
    [sym_fixed_statement] = STATE(2647),
    [sym_for_statement] = STATE(2647),
    [sym_return_statement] = STATE(2647),
    [sym_lock_statement] = STATE(2647),
    [sym_yield_statement] = STATE(2647),
    [sym_switch_statement] = STATE(2647),
    [sym_throw_statement] = STATE(2647),
    [sym_try_statement] = STATE(2647),
    [sym_unsafe_statement] = STATE(2647),
    [sym_using_statement] = STATE(2647),
    [sym_foreach_statement] = STATE(2647),
    [sym_goto_statement] = STATE(2647),
    [sym_labeled_statement] = STATE(2647),
    [sym_if_statement] = STATE(2647),
    [sym_while_statement] = STATE(2647),
    [sym_local_declaration_statement] = STATE(2647),
    [sym_local_function_statement] = STATE(2647),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6543),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2835),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2647),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(82),
    [sym_preproc_endregion] = STATE(82),
    [sym_preproc_line] = STATE(82),
    [sym_preproc_pragma] = STATE(82),
    [sym_preproc_nullable] = STATE(82),
    [sym_preproc_error] = STATE(82),
    [sym_preproc_define] = STATE(82),
    [sym_preproc_undef] = STATE(82),
    [aux_sym_class_declaration_repeat1] = STATE(2918),
    [aux_sym_class_declaration_repeat2] = STATE(3106),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(647),
    [anon_sym_unsafe] = ACTIONS(649),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(655),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(659),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(667),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(671),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(673),
    [anon_sym_unchecked] = ACTIONS(671),
    [anon_sym_continue] = ACTIONS(675),
    [anon_sym_do] = ACTIONS(677),
    [anon_sym_while] = ACTIONS(679),
    [anon_sym_for] = ACTIONS(681),
    [anon_sym_lock] = ACTIONS(683),
    [anon_sym_yield] = ACTIONS(685),
    [anon_sym_switch] = ACTIONS(687),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_try] = ACTIONS(693),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(695),
    [anon_sym_foreach] = ACTIONS(697),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [83] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2220),
    [sym_variable_declaration] = STATE(9437),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6809),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2216),
    [sym_break_statement] = STATE(2220),
    [sym_checked_statement] = STATE(2220),
    [sym_continue_statement] = STATE(2220),
    [sym_do_statement] = STATE(2220),
    [sym_empty_statement] = STATE(2220),
    [sym_expression_statement] = STATE(2220),
    [sym_fixed_statement] = STATE(2220),
    [sym_for_statement] = STATE(2220),
    [sym_return_statement] = STATE(2220),
    [sym_lock_statement] = STATE(2220),
    [sym_yield_statement] = STATE(2220),
    [sym_switch_statement] = STATE(2220),
    [sym_throw_statement] = STATE(2220),
    [sym_try_statement] = STATE(2220),
    [sym_unsafe_statement] = STATE(2220),
    [sym_using_statement] = STATE(2220),
    [sym_foreach_statement] = STATE(2220),
    [sym_goto_statement] = STATE(2220),
    [sym_labeled_statement] = STATE(2220),
    [sym_if_statement] = STATE(2220),
    [sym_while_statement] = STATE(2220),
    [sym_local_declaration_statement] = STATE(2220),
    [sym_local_function_statement] = STATE(2220),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6150),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2819),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2220),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(83),
    [sym_preproc_endregion] = STATE(83),
    [sym_preproc_line] = STATE(83),
    [sym_preproc_pragma] = STATE(83),
    [sym_preproc_nullable] = STATE(83),
    [sym_preproc_error] = STATE(83),
    [sym_preproc_define] = STATE(83),
    [sym_preproc_undef] = STATE(83),
    [aux_sym_class_declaration_repeat1] = STATE(2924),
    [aux_sym_class_declaration_repeat2] = STATE(3080),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(155),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1025),
    [anon_sym_unsafe] = ACTIONS(1027),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(165),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(177),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(1029),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(187),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(189),
    [anon_sym_unchecked] = ACTIONS(187),
    [anon_sym_continue] = ACTIONS(191),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_while] = ACTIONS(195),
    [anon_sym_for] = ACTIONS(197),
    [anon_sym_lock] = ACTIONS(199),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(205),
    [anon_sym_try] = ACTIONS(207),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(209),
    [anon_sym_foreach] = ACTIONS(211),
    [anon_sym_goto] = ACTIONS(213),
    [anon_sym_if] = ACTIONS(215),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(217),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [84] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2220),
    [sym_variable_declaration] = STATE(9437),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6809),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2255),
    [sym_break_statement] = STATE(2220),
    [sym_checked_statement] = STATE(2220),
    [sym_continue_statement] = STATE(2220),
    [sym_do_statement] = STATE(2220),
    [sym_empty_statement] = STATE(2220),
    [sym_expression_statement] = STATE(2220),
    [sym_fixed_statement] = STATE(2220),
    [sym_for_statement] = STATE(2220),
    [sym_return_statement] = STATE(2220),
    [sym_lock_statement] = STATE(2220),
    [sym_yield_statement] = STATE(2220),
    [sym_switch_statement] = STATE(2220),
    [sym_throw_statement] = STATE(2220),
    [sym_try_statement] = STATE(2220),
    [sym_unsafe_statement] = STATE(2220),
    [sym_using_statement] = STATE(2220),
    [sym_foreach_statement] = STATE(2220),
    [sym_goto_statement] = STATE(2220),
    [sym_labeled_statement] = STATE(2220),
    [sym_if_statement] = STATE(2220),
    [sym_while_statement] = STATE(2220),
    [sym_local_declaration_statement] = STATE(2220),
    [sym_local_function_statement] = STATE(2220),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6150),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2819),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2220),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(84),
    [sym_preproc_endregion] = STATE(84),
    [sym_preproc_line] = STATE(84),
    [sym_preproc_pragma] = STATE(84),
    [sym_preproc_nullable] = STATE(84),
    [sym_preproc_error] = STATE(84),
    [sym_preproc_define] = STATE(84),
    [sym_preproc_undef] = STATE(84),
    [aux_sym_class_declaration_repeat1] = STATE(2924),
    [aux_sym_class_declaration_repeat2] = STATE(3080),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(155),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1025),
    [anon_sym_unsafe] = ACTIONS(1027),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(165),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(177),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(1029),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(187),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(189),
    [anon_sym_unchecked] = ACTIONS(187),
    [anon_sym_continue] = ACTIONS(191),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_while] = ACTIONS(195),
    [anon_sym_for] = ACTIONS(197),
    [anon_sym_lock] = ACTIONS(199),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(205),
    [anon_sym_try] = ACTIONS(207),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(209),
    [anon_sym_foreach] = ACTIONS(211),
    [anon_sym_goto] = ACTIONS(213),
    [anon_sym_if] = ACTIONS(215),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(217),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [85] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(8872),
    [sym_variable_declaration] = STATE(9850),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6801),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(8817),
    [sym_break_statement] = STATE(8872),
    [sym_checked_statement] = STATE(8872),
    [sym_continue_statement] = STATE(8872),
    [sym_do_statement] = STATE(8872),
    [sym_empty_statement] = STATE(8872),
    [sym_expression_statement] = STATE(8872),
    [sym_fixed_statement] = STATE(8872),
    [sym_for_statement] = STATE(8872),
    [sym_return_statement] = STATE(8872),
    [sym_lock_statement] = STATE(8872),
    [sym_yield_statement] = STATE(8872),
    [sym_switch_statement] = STATE(8872),
    [sym_throw_statement] = STATE(8872),
    [sym_try_statement] = STATE(8872),
    [sym_unsafe_statement] = STATE(8872),
    [sym_using_statement] = STATE(8872),
    [sym_foreach_statement] = STATE(8872),
    [sym_goto_statement] = STATE(8872),
    [sym_labeled_statement] = STATE(8872),
    [sym_if_statement] = STATE(8872),
    [sym_while_statement] = STATE(8872),
    [sym_local_declaration_statement] = STATE(8872),
    [sym_local_function_statement] = STATE(8872),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6718),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2890),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(8872),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(85),
    [sym_preproc_endregion] = STATE(85),
    [sym_preproc_line] = STATE(85),
    [sym_preproc_pragma] = STATE(85),
    [sym_preproc_nullable] = STATE(85),
    [sym_preproc_error] = STATE(85),
    [sym_preproc_define] = STATE(85),
    [sym_preproc_undef] = STATE(85),
    [aux_sym_class_declaration_repeat1] = STATE(2909),
    [aux_sym_class_declaration_repeat2] = STATE(3101),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(981),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(983),
    [anon_sym_unsafe] = ACTIONS(985),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(987),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(989),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(991),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(993),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(995),
    [anon_sym_unchecked] = ACTIONS(993),
    [anon_sym_continue] = ACTIONS(997),
    [anon_sym_do] = ACTIONS(999),
    [anon_sym_while] = ACTIONS(1001),
    [anon_sym_for] = ACTIONS(1003),
    [anon_sym_lock] = ACTIONS(1005),
    [anon_sym_yield] = ACTIONS(1007),
    [anon_sym_switch] = ACTIONS(1009),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1011),
    [anon_sym_try] = ACTIONS(1013),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1015),
    [anon_sym_foreach] = ACTIONS(1017),
    [anon_sym_goto] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(1021),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1023),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [86] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2647),
    [sym_variable_declaration] = STATE(9394),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6827),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2688),
    [sym_break_statement] = STATE(2647),
    [sym_checked_statement] = STATE(2647),
    [sym_continue_statement] = STATE(2647),
    [sym_do_statement] = STATE(2647),
    [sym_empty_statement] = STATE(2647),
    [sym_expression_statement] = STATE(2647),
    [sym_fixed_statement] = STATE(2647),
    [sym_for_statement] = STATE(2647),
    [sym_return_statement] = STATE(2647),
    [sym_lock_statement] = STATE(2647),
    [sym_yield_statement] = STATE(2647),
    [sym_switch_statement] = STATE(2647),
    [sym_throw_statement] = STATE(2647),
    [sym_try_statement] = STATE(2647),
    [sym_unsafe_statement] = STATE(2647),
    [sym_using_statement] = STATE(2647),
    [sym_foreach_statement] = STATE(2647),
    [sym_goto_statement] = STATE(2647),
    [sym_labeled_statement] = STATE(2647),
    [sym_if_statement] = STATE(2647),
    [sym_while_statement] = STATE(2647),
    [sym_local_declaration_statement] = STATE(2647),
    [sym_local_function_statement] = STATE(2647),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6543),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2835),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2647),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(86),
    [sym_preproc_endregion] = STATE(86),
    [sym_preproc_line] = STATE(86),
    [sym_preproc_pragma] = STATE(86),
    [sym_preproc_nullable] = STATE(86),
    [sym_preproc_error] = STATE(86),
    [sym_preproc_define] = STATE(86),
    [sym_preproc_undef] = STATE(86),
    [aux_sym_class_declaration_repeat1] = STATE(2918),
    [aux_sym_class_declaration_repeat2] = STATE(3106),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(647),
    [anon_sym_unsafe] = ACTIONS(649),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(655),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(659),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(667),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(671),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(673),
    [anon_sym_unchecked] = ACTIONS(671),
    [anon_sym_continue] = ACTIONS(675),
    [anon_sym_do] = ACTIONS(677),
    [anon_sym_while] = ACTIONS(679),
    [anon_sym_for] = ACTIONS(681),
    [anon_sym_lock] = ACTIONS(683),
    [anon_sym_yield] = ACTIONS(685),
    [anon_sym_switch] = ACTIONS(687),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_try] = ACTIONS(693),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(695),
    [anon_sym_foreach] = ACTIONS(697),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [87] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2220),
    [sym_variable_declaration] = STATE(9437),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6809),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2267),
    [sym_break_statement] = STATE(2220),
    [sym_checked_statement] = STATE(2220),
    [sym_continue_statement] = STATE(2220),
    [sym_do_statement] = STATE(2220),
    [sym_empty_statement] = STATE(2220),
    [sym_expression_statement] = STATE(2220),
    [sym_fixed_statement] = STATE(2220),
    [sym_for_statement] = STATE(2220),
    [sym_return_statement] = STATE(2220),
    [sym_lock_statement] = STATE(2220),
    [sym_yield_statement] = STATE(2220),
    [sym_switch_statement] = STATE(2220),
    [sym_throw_statement] = STATE(2220),
    [sym_try_statement] = STATE(2220),
    [sym_unsafe_statement] = STATE(2220),
    [sym_using_statement] = STATE(2220),
    [sym_foreach_statement] = STATE(2220),
    [sym_goto_statement] = STATE(2220),
    [sym_labeled_statement] = STATE(2220),
    [sym_if_statement] = STATE(2220),
    [sym_while_statement] = STATE(2220),
    [sym_local_declaration_statement] = STATE(2220),
    [sym_local_function_statement] = STATE(2220),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6150),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2819),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2220),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(87),
    [sym_preproc_endregion] = STATE(87),
    [sym_preproc_line] = STATE(87),
    [sym_preproc_pragma] = STATE(87),
    [sym_preproc_nullable] = STATE(87),
    [sym_preproc_error] = STATE(87),
    [sym_preproc_define] = STATE(87),
    [sym_preproc_undef] = STATE(87),
    [aux_sym_class_declaration_repeat1] = STATE(2924),
    [aux_sym_class_declaration_repeat2] = STATE(3080),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(155),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1025),
    [anon_sym_unsafe] = ACTIONS(1027),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(165),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(177),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(1029),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(187),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(189),
    [anon_sym_unchecked] = ACTIONS(187),
    [anon_sym_continue] = ACTIONS(191),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_while] = ACTIONS(195),
    [anon_sym_for] = ACTIONS(197),
    [anon_sym_lock] = ACTIONS(199),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(205),
    [anon_sym_try] = ACTIONS(207),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(209),
    [anon_sym_foreach] = ACTIONS(211),
    [anon_sym_goto] = ACTIONS(213),
    [anon_sym_if] = ACTIONS(215),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(217),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [88] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2478),
    [sym_variable_declaration] = STATE(9764),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6873),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2449),
    [sym_break_statement] = STATE(2478),
    [sym_checked_statement] = STATE(2478),
    [sym_continue_statement] = STATE(2478),
    [sym_do_statement] = STATE(2478),
    [sym_empty_statement] = STATE(2478),
    [sym_expression_statement] = STATE(2478),
    [sym_fixed_statement] = STATE(2478),
    [sym_for_statement] = STATE(2478),
    [sym_return_statement] = STATE(2478),
    [sym_lock_statement] = STATE(2478),
    [sym_yield_statement] = STATE(2478),
    [sym_switch_statement] = STATE(2478),
    [sym_throw_statement] = STATE(2478),
    [sym_try_statement] = STATE(2478),
    [sym_unsafe_statement] = STATE(2478),
    [sym_using_statement] = STATE(2478),
    [sym_foreach_statement] = STATE(2478),
    [sym_goto_statement] = STATE(2478),
    [sym_labeled_statement] = STATE(2478),
    [sym_if_statement] = STATE(2478),
    [sym_while_statement] = STATE(2478),
    [sym_local_declaration_statement] = STATE(2478),
    [sym_local_function_statement] = STATE(2478),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6724),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2900),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2478),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(88),
    [sym_preproc_endregion] = STATE(88),
    [sym_preproc_line] = STATE(88),
    [sym_preproc_pragma] = STATE(88),
    [sym_preproc_nullable] = STATE(88),
    [sym_preproc_error] = STATE(88),
    [sym_preproc_define] = STATE(88),
    [sym_preproc_undef] = STATE(88),
    [aux_sym_class_declaration_repeat1] = STATE(2921),
    [aux_sym_class_declaration_repeat2] = STATE(3105),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1031),
    [anon_sym_unsafe] = ACTIONS(1033),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(1035),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(71),
    [anon_sym_continue] = ACTIONS(91),
    [anon_sym_do] = ACTIONS(93),
    [anon_sym_while] = ACTIONS(95),
    [anon_sym_for] = ACTIONS(97),
    [anon_sym_lock] = ACTIONS(99),
    [anon_sym_yield] = ACTIONS(101),
    [anon_sym_switch] = ACTIONS(103),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(107),
    [anon_sym_try] = ACTIONS(109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(111),
    [anon_sym_foreach] = ACTIONS(113),
    [anon_sym_goto] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(143),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [89] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2220),
    [sym_variable_declaration] = STATE(9437),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6809),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2273),
    [sym_break_statement] = STATE(2220),
    [sym_checked_statement] = STATE(2220),
    [sym_continue_statement] = STATE(2220),
    [sym_do_statement] = STATE(2220),
    [sym_empty_statement] = STATE(2220),
    [sym_expression_statement] = STATE(2220),
    [sym_fixed_statement] = STATE(2220),
    [sym_for_statement] = STATE(2220),
    [sym_return_statement] = STATE(2220),
    [sym_lock_statement] = STATE(2220),
    [sym_yield_statement] = STATE(2220),
    [sym_switch_statement] = STATE(2220),
    [sym_throw_statement] = STATE(2220),
    [sym_try_statement] = STATE(2220),
    [sym_unsafe_statement] = STATE(2220),
    [sym_using_statement] = STATE(2220),
    [sym_foreach_statement] = STATE(2220),
    [sym_goto_statement] = STATE(2220),
    [sym_labeled_statement] = STATE(2220),
    [sym_if_statement] = STATE(2220),
    [sym_while_statement] = STATE(2220),
    [sym_local_declaration_statement] = STATE(2220),
    [sym_local_function_statement] = STATE(2220),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6150),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2819),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2220),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(89),
    [sym_preproc_endregion] = STATE(89),
    [sym_preproc_line] = STATE(89),
    [sym_preproc_pragma] = STATE(89),
    [sym_preproc_nullable] = STATE(89),
    [sym_preproc_error] = STATE(89),
    [sym_preproc_define] = STATE(89),
    [sym_preproc_undef] = STATE(89),
    [aux_sym_class_declaration_repeat1] = STATE(2924),
    [aux_sym_class_declaration_repeat2] = STATE(3080),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(155),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1025),
    [anon_sym_unsafe] = ACTIONS(1027),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(165),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(177),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(1029),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(187),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(189),
    [anon_sym_unchecked] = ACTIONS(187),
    [anon_sym_continue] = ACTIONS(191),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_while] = ACTIONS(195),
    [anon_sym_for] = ACTIONS(197),
    [anon_sym_lock] = ACTIONS(199),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(205),
    [anon_sym_try] = ACTIONS(207),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(209),
    [anon_sym_foreach] = ACTIONS(211),
    [anon_sym_goto] = ACTIONS(213),
    [anon_sym_if] = ACTIONS(215),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(217),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [90] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(8872),
    [sym_variable_declaration] = STATE(9850),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6801),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(8696),
    [sym_break_statement] = STATE(8872),
    [sym_checked_statement] = STATE(8872),
    [sym_continue_statement] = STATE(8872),
    [sym_do_statement] = STATE(8872),
    [sym_empty_statement] = STATE(8872),
    [sym_expression_statement] = STATE(8872),
    [sym_fixed_statement] = STATE(8872),
    [sym_for_statement] = STATE(8872),
    [sym_return_statement] = STATE(8872),
    [sym_lock_statement] = STATE(8872),
    [sym_yield_statement] = STATE(8872),
    [sym_switch_statement] = STATE(8872),
    [sym_throw_statement] = STATE(8872),
    [sym_try_statement] = STATE(8872),
    [sym_unsafe_statement] = STATE(8872),
    [sym_using_statement] = STATE(8872),
    [sym_foreach_statement] = STATE(8872),
    [sym_goto_statement] = STATE(8872),
    [sym_labeled_statement] = STATE(8872),
    [sym_if_statement] = STATE(8872),
    [sym_while_statement] = STATE(8872),
    [sym_local_declaration_statement] = STATE(8872),
    [sym_local_function_statement] = STATE(8872),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6718),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2890),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(8872),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(90),
    [sym_preproc_endregion] = STATE(90),
    [sym_preproc_line] = STATE(90),
    [sym_preproc_pragma] = STATE(90),
    [sym_preproc_nullable] = STATE(90),
    [sym_preproc_error] = STATE(90),
    [sym_preproc_define] = STATE(90),
    [sym_preproc_undef] = STATE(90),
    [aux_sym_class_declaration_repeat1] = STATE(2909),
    [aux_sym_class_declaration_repeat2] = STATE(3101),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(981),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(983),
    [anon_sym_unsafe] = ACTIONS(985),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(987),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(989),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(991),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(993),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(995),
    [anon_sym_unchecked] = ACTIONS(993),
    [anon_sym_continue] = ACTIONS(997),
    [anon_sym_do] = ACTIONS(999),
    [anon_sym_while] = ACTIONS(1001),
    [anon_sym_for] = ACTIONS(1003),
    [anon_sym_lock] = ACTIONS(1005),
    [anon_sym_yield] = ACTIONS(1007),
    [anon_sym_switch] = ACTIONS(1009),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1011),
    [anon_sym_try] = ACTIONS(1013),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1015),
    [anon_sym_foreach] = ACTIONS(1017),
    [anon_sym_goto] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(1021),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1023),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [91] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2478),
    [sym_variable_declaration] = STATE(9764),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6873),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2448),
    [sym_break_statement] = STATE(2478),
    [sym_checked_statement] = STATE(2478),
    [sym_continue_statement] = STATE(2478),
    [sym_do_statement] = STATE(2478),
    [sym_empty_statement] = STATE(2478),
    [sym_expression_statement] = STATE(2478),
    [sym_fixed_statement] = STATE(2478),
    [sym_for_statement] = STATE(2478),
    [sym_return_statement] = STATE(2478),
    [sym_lock_statement] = STATE(2478),
    [sym_yield_statement] = STATE(2478),
    [sym_switch_statement] = STATE(2478),
    [sym_throw_statement] = STATE(2478),
    [sym_try_statement] = STATE(2478),
    [sym_unsafe_statement] = STATE(2478),
    [sym_using_statement] = STATE(2478),
    [sym_foreach_statement] = STATE(2478),
    [sym_goto_statement] = STATE(2478),
    [sym_labeled_statement] = STATE(2478),
    [sym_if_statement] = STATE(2478),
    [sym_while_statement] = STATE(2478),
    [sym_local_declaration_statement] = STATE(2478),
    [sym_local_function_statement] = STATE(2478),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6724),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2900),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2478),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(91),
    [sym_preproc_endregion] = STATE(91),
    [sym_preproc_line] = STATE(91),
    [sym_preproc_pragma] = STATE(91),
    [sym_preproc_nullable] = STATE(91),
    [sym_preproc_error] = STATE(91),
    [sym_preproc_define] = STATE(91),
    [sym_preproc_undef] = STATE(91),
    [aux_sym_class_declaration_repeat1] = STATE(2921),
    [aux_sym_class_declaration_repeat2] = STATE(3105),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1031),
    [anon_sym_unsafe] = ACTIONS(1033),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(1035),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(71),
    [anon_sym_continue] = ACTIONS(91),
    [anon_sym_do] = ACTIONS(93),
    [anon_sym_while] = ACTIONS(95),
    [anon_sym_for] = ACTIONS(97),
    [anon_sym_lock] = ACTIONS(99),
    [anon_sym_yield] = ACTIONS(101),
    [anon_sym_switch] = ACTIONS(103),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(107),
    [anon_sym_try] = ACTIONS(109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(111),
    [anon_sym_foreach] = ACTIONS(113),
    [anon_sym_goto] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(143),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [92] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(8872),
    [sym_variable_declaration] = STATE(9850),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6801),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(8698),
    [sym_break_statement] = STATE(8872),
    [sym_checked_statement] = STATE(8872),
    [sym_continue_statement] = STATE(8872),
    [sym_do_statement] = STATE(8872),
    [sym_empty_statement] = STATE(8872),
    [sym_expression_statement] = STATE(8872),
    [sym_fixed_statement] = STATE(8872),
    [sym_for_statement] = STATE(8872),
    [sym_return_statement] = STATE(8872),
    [sym_lock_statement] = STATE(8872),
    [sym_yield_statement] = STATE(8872),
    [sym_switch_statement] = STATE(8872),
    [sym_throw_statement] = STATE(8872),
    [sym_try_statement] = STATE(8872),
    [sym_unsafe_statement] = STATE(8872),
    [sym_using_statement] = STATE(8872),
    [sym_foreach_statement] = STATE(8872),
    [sym_goto_statement] = STATE(8872),
    [sym_labeled_statement] = STATE(8872),
    [sym_if_statement] = STATE(8872),
    [sym_while_statement] = STATE(8872),
    [sym_local_declaration_statement] = STATE(8872),
    [sym_local_function_statement] = STATE(8872),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6718),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2890),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(8872),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(92),
    [sym_preproc_endregion] = STATE(92),
    [sym_preproc_line] = STATE(92),
    [sym_preproc_pragma] = STATE(92),
    [sym_preproc_nullable] = STATE(92),
    [sym_preproc_error] = STATE(92),
    [sym_preproc_define] = STATE(92),
    [sym_preproc_undef] = STATE(92),
    [aux_sym_class_declaration_repeat1] = STATE(2909),
    [aux_sym_class_declaration_repeat2] = STATE(3101),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(981),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(983),
    [anon_sym_unsafe] = ACTIONS(985),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(987),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(989),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(991),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(993),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(995),
    [anon_sym_unchecked] = ACTIONS(993),
    [anon_sym_continue] = ACTIONS(997),
    [anon_sym_do] = ACTIONS(999),
    [anon_sym_while] = ACTIONS(1001),
    [anon_sym_for] = ACTIONS(1003),
    [anon_sym_lock] = ACTIONS(1005),
    [anon_sym_yield] = ACTIONS(1007),
    [anon_sym_switch] = ACTIONS(1009),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1011),
    [anon_sym_try] = ACTIONS(1013),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1015),
    [anon_sym_foreach] = ACTIONS(1017),
    [anon_sym_goto] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(1021),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1023),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [93] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(8872),
    [sym_variable_declaration] = STATE(9850),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6801),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(8700),
    [sym_break_statement] = STATE(8872),
    [sym_checked_statement] = STATE(8872),
    [sym_continue_statement] = STATE(8872),
    [sym_do_statement] = STATE(8872),
    [sym_empty_statement] = STATE(8872),
    [sym_expression_statement] = STATE(8872),
    [sym_fixed_statement] = STATE(8872),
    [sym_for_statement] = STATE(8872),
    [sym_return_statement] = STATE(8872),
    [sym_lock_statement] = STATE(8872),
    [sym_yield_statement] = STATE(8872),
    [sym_switch_statement] = STATE(8872),
    [sym_throw_statement] = STATE(8872),
    [sym_try_statement] = STATE(8872),
    [sym_unsafe_statement] = STATE(8872),
    [sym_using_statement] = STATE(8872),
    [sym_foreach_statement] = STATE(8872),
    [sym_goto_statement] = STATE(8872),
    [sym_labeled_statement] = STATE(8872),
    [sym_if_statement] = STATE(8872),
    [sym_while_statement] = STATE(8872),
    [sym_local_declaration_statement] = STATE(8872),
    [sym_local_function_statement] = STATE(8872),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6718),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2890),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(8872),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(93),
    [sym_preproc_endregion] = STATE(93),
    [sym_preproc_line] = STATE(93),
    [sym_preproc_pragma] = STATE(93),
    [sym_preproc_nullable] = STATE(93),
    [sym_preproc_error] = STATE(93),
    [sym_preproc_define] = STATE(93),
    [sym_preproc_undef] = STATE(93),
    [aux_sym_class_declaration_repeat1] = STATE(2909),
    [aux_sym_class_declaration_repeat2] = STATE(3101),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(981),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(983),
    [anon_sym_unsafe] = ACTIONS(985),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(987),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(989),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(991),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(993),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(995),
    [anon_sym_unchecked] = ACTIONS(993),
    [anon_sym_continue] = ACTIONS(997),
    [anon_sym_do] = ACTIONS(999),
    [anon_sym_while] = ACTIONS(1001),
    [anon_sym_for] = ACTIONS(1003),
    [anon_sym_lock] = ACTIONS(1005),
    [anon_sym_yield] = ACTIONS(1007),
    [anon_sym_switch] = ACTIONS(1009),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1011),
    [anon_sym_try] = ACTIONS(1013),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1015),
    [anon_sym_foreach] = ACTIONS(1017),
    [anon_sym_goto] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(1021),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1023),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [94] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(8872),
    [sym_variable_declaration] = STATE(9850),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6801),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(8692),
    [sym_break_statement] = STATE(8872),
    [sym_checked_statement] = STATE(8872),
    [sym_continue_statement] = STATE(8872),
    [sym_do_statement] = STATE(8872),
    [sym_empty_statement] = STATE(8872),
    [sym_expression_statement] = STATE(8872),
    [sym_fixed_statement] = STATE(8872),
    [sym_for_statement] = STATE(8872),
    [sym_return_statement] = STATE(8872),
    [sym_lock_statement] = STATE(8872),
    [sym_yield_statement] = STATE(8872),
    [sym_switch_statement] = STATE(8872),
    [sym_throw_statement] = STATE(8872),
    [sym_try_statement] = STATE(8872),
    [sym_unsafe_statement] = STATE(8872),
    [sym_using_statement] = STATE(8872),
    [sym_foreach_statement] = STATE(8872),
    [sym_goto_statement] = STATE(8872),
    [sym_labeled_statement] = STATE(8872),
    [sym_if_statement] = STATE(8872),
    [sym_while_statement] = STATE(8872),
    [sym_local_declaration_statement] = STATE(8872),
    [sym_local_function_statement] = STATE(8872),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6718),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2890),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(8872),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(94),
    [sym_preproc_endregion] = STATE(94),
    [sym_preproc_line] = STATE(94),
    [sym_preproc_pragma] = STATE(94),
    [sym_preproc_nullable] = STATE(94),
    [sym_preproc_error] = STATE(94),
    [sym_preproc_define] = STATE(94),
    [sym_preproc_undef] = STATE(94),
    [aux_sym_class_declaration_repeat1] = STATE(2909),
    [aux_sym_class_declaration_repeat2] = STATE(3101),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(981),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(983),
    [anon_sym_unsafe] = ACTIONS(985),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(987),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(989),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(991),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(993),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(995),
    [anon_sym_unchecked] = ACTIONS(993),
    [anon_sym_continue] = ACTIONS(997),
    [anon_sym_do] = ACTIONS(999),
    [anon_sym_while] = ACTIONS(1001),
    [anon_sym_for] = ACTIONS(1003),
    [anon_sym_lock] = ACTIONS(1005),
    [anon_sym_yield] = ACTIONS(1007),
    [anon_sym_switch] = ACTIONS(1009),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1011),
    [anon_sym_try] = ACTIONS(1013),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1015),
    [anon_sym_foreach] = ACTIONS(1017),
    [anon_sym_goto] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(1021),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1023),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [95] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2647),
    [sym_variable_declaration] = STATE(9394),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6827),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2686),
    [sym_break_statement] = STATE(2647),
    [sym_checked_statement] = STATE(2647),
    [sym_continue_statement] = STATE(2647),
    [sym_do_statement] = STATE(2647),
    [sym_empty_statement] = STATE(2647),
    [sym_expression_statement] = STATE(2647),
    [sym_fixed_statement] = STATE(2647),
    [sym_for_statement] = STATE(2647),
    [sym_return_statement] = STATE(2647),
    [sym_lock_statement] = STATE(2647),
    [sym_yield_statement] = STATE(2647),
    [sym_switch_statement] = STATE(2647),
    [sym_throw_statement] = STATE(2647),
    [sym_try_statement] = STATE(2647),
    [sym_unsafe_statement] = STATE(2647),
    [sym_using_statement] = STATE(2647),
    [sym_foreach_statement] = STATE(2647),
    [sym_goto_statement] = STATE(2647),
    [sym_labeled_statement] = STATE(2647),
    [sym_if_statement] = STATE(2647),
    [sym_while_statement] = STATE(2647),
    [sym_local_declaration_statement] = STATE(2647),
    [sym_local_function_statement] = STATE(2647),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6543),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2835),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2647),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(95),
    [sym_preproc_endregion] = STATE(95),
    [sym_preproc_line] = STATE(95),
    [sym_preproc_pragma] = STATE(95),
    [sym_preproc_nullable] = STATE(95),
    [sym_preproc_error] = STATE(95),
    [sym_preproc_define] = STATE(95),
    [sym_preproc_undef] = STATE(95),
    [aux_sym_class_declaration_repeat1] = STATE(2918),
    [aux_sym_class_declaration_repeat2] = STATE(3106),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(647),
    [anon_sym_unsafe] = ACTIONS(649),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(655),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(659),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(667),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(671),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(673),
    [anon_sym_unchecked] = ACTIONS(671),
    [anon_sym_continue] = ACTIONS(675),
    [anon_sym_do] = ACTIONS(677),
    [anon_sym_while] = ACTIONS(679),
    [anon_sym_for] = ACTIONS(681),
    [anon_sym_lock] = ACTIONS(683),
    [anon_sym_yield] = ACTIONS(685),
    [anon_sym_switch] = ACTIONS(687),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_try] = ACTIONS(693),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(695),
    [anon_sym_foreach] = ACTIONS(697),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [96] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(8872),
    [sym_variable_declaration] = STATE(9850),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6801),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(8805),
    [sym_break_statement] = STATE(8872),
    [sym_checked_statement] = STATE(8872),
    [sym_continue_statement] = STATE(8872),
    [sym_do_statement] = STATE(8872),
    [sym_empty_statement] = STATE(8872),
    [sym_expression_statement] = STATE(8872),
    [sym_fixed_statement] = STATE(8872),
    [sym_for_statement] = STATE(8872),
    [sym_return_statement] = STATE(8872),
    [sym_lock_statement] = STATE(8872),
    [sym_yield_statement] = STATE(8872),
    [sym_switch_statement] = STATE(8872),
    [sym_throw_statement] = STATE(8872),
    [sym_try_statement] = STATE(8872),
    [sym_unsafe_statement] = STATE(8872),
    [sym_using_statement] = STATE(8872),
    [sym_foreach_statement] = STATE(8872),
    [sym_goto_statement] = STATE(8872),
    [sym_labeled_statement] = STATE(8872),
    [sym_if_statement] = STATE(8872),
    [sym_while_statement] = STATE(8872),
    [sym_local_declaration_statement] = STATE(8872),
    [sym_local_function_statement] = STATE(8872),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6718),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2890),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(8872),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(96),
    [sym_preproc_endregion] = STATE(96),
    [sym_preproc_line] = STATE(96),
    [sym_preproc_pragma] = STATE(96),
    [sym_preproc_nullable] = STATE(96),
    [sym_preproc_error] = STATE(96),
    [sym_preproc_define] = STATE(96),
    [sym_preproc_undef] = STATE(96),
    [aux_sym_class_declaration_repeat1] = STATE(2909),
    [aux_sym_class_declaration_repeat2] = STATE(3101),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(981),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(983),
    [anon_sym_unsafe] = ACTIONS(985),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(987),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(989),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(991),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(993),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(995),
    [anon_sym_unchecked] = ACTIONS(993),
    [anon_sym_continue] = ACTIONS(997),
    [anon_sym_do] = ACTIONS(999),
    [anon_sym_while] = ACTIONS(1001),
    [anon_sym_for] = ACTIONS(1003),
    [anon_sym_lock] = ACTIONS(1005),
    [anon_sym_yield] = ACTIONS(1007),
    [anon_sym_switch] = ACTIONS(1009),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1011),
    [anon_sym_try] = ACTIONS(1013),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1015),
    [anon_sym_foreach] = ACTIONS(1017),
    [anon_sym_goto] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(1021),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1023),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [97] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(8872),
    [sym_variable_declaration] = STATE(9850),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6801),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(8702),
    [sym_break_statement] = STATE(8872),
    [sym_checked_statement] = STATE(8872),
    [sym_continue_statement] = STATE(8872),
    [sym_do_statement] = STATE(8872),
    [sym_empty_statement] = STATE(8872),
    [sym_expression_statement] = STATE(8872),
    [sym_fixed_statement] = STATE(8872),
    [sym_for_statement] = STATE(8872),
    [sym_return_statement] = STATE(8872),
    [sym_lock_statement] = STATE(8872),
    [sym_yield_statement] = STATE(8872),
    [sym_switch_statement] = STATE(8872),
    [sym_throw_statement] = STATE(8872),
    [sym_try_statement] = STATE(8872),
    [sym_unsafe_statement] = STATE(8872),
    [sym_using_statement] = STATE(8872),
    [sym_foreach_statement] = STATE(8872),
    [sym_goto_statement] = STATE(8872),
    [sym_labeled_statement] = STATE(8872),
    [sym_if_statement] = STATE(8872),
    [sym_while_statement] = STATE(8872),
    [sym_local_declaration_statement] = STATE(8872),
    [sym_local_function_statement] = STATE(8872),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6718),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2890),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(8872),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(97),
    [sym_preproc_endregion] = STATE(97),
    [sym_preproc_line] = STATE(97),
    [sym_preproc_pragma] = STATE(97),
    [sym_preproc_nullable] = STATE(97),
    [sym_preproc_error] = STATE(97),
    [sym_preproc_define] = STATE(97),
    [sym_preproc_undef] = STATE(97),
    [aux_sym_class_declaration_repeat1] = STATE(2909),
    [aux_sym_class_declaration_repeat2] = STATE(3101),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(981),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(983),
    [anon_sym_unsafe] = ACTIONS(985),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(987),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(989),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(991),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(993),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(995),
    [anon_sym_unchecked] = ACTIONS(993),
    [anon_sym_continue] = ACTIONS(997),
    [anon_sym_do] = ACTIONS(999),
    [anon_sym_while] = ACTIONS(1001),
    [anon_sym_for] = ACTIONS(1003),
    [anon_sym_lock] = ACTIONS(1005),
    [anon_sym_yield] = ACTIONS(1007),
    [anon_sym_switch] = ACTIONS(1009),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1011),
    [anon_sym_try] = ACTIONS(1013),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1015),
    [anon_sym_foreach] = ACTIONS(1017),
    [anon_sym_goto] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(1021),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1023),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [98] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(8872),
    [sym_variable_declaration] = STATE(9850),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6801),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(8705),
    [sym_break_statement] = STATE(8872),
    [sym_checked_statement] = STATE(8872),
    [sym_continue_statement] = STATE(8872),
    [sym_do_statement] = STATE(8872),
    [sym_empty_statement] = STATE(8872),
    [sym_expression_statement] = STATE(8872),
    [sym_fixed_statement] = STATE(8872),
    [sym_for_statement] = STATE(8872),
    [sym_return_statement] = STATE(8872),
    [sym_lock_statement] = STATE(8872),
    [sym_yield_statement] = STATE(8872),
    [sym_switch_statement] = STATE(8872),
    [sym_throw_statement] = STATE(8872),
    [sym_try_statement] = STATE(8872),
    [sym_unsafe_statement] = STATE(8872),
    [sym_using_statement] = STATE(8872),
    [sym_foreach_statement] = STATE(8872),
    [sym_goto_statement] = STATE(8872),
    [sym_labeled_statement] = STATE(8872),
    [sym_if_statement] = STATE(8872),
    [sym_while_statement] = STATE(8872),
    [sym_local_declaration_statement] = STATE(8872),
    [sym_local_function_statement] = STATE(8872),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6718),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2890),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(8872),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(98),
    [sym_preproc_endregion] = STATE(98),
    [sym_preproc_line] = STATE(98),
    [sym_preproc_pragma] = STATE(98),
    [sym_preproc_nullable] = STATE(98),
    [sym_preproc_error] = STATE(98),
    [sym_preproc_define] = STATE(98),
    [sym_preproc_undef] = STATE(98),
    [aux_sym_class_declaration_repeat1] = STATE(2909),
    [aux_sym_class_declaration_repeat2] = STATE(3101),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(981),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(983),
    [anon_sym_unsafe] = ACTIONS(985),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(987),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(989),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(991),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(993),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(995),
    [anon_sym_unchecked] = ACTIONS(993),
    [anon_sym_continue] = ACTIONS(997),
    [anon_sym_do] = ACTIONS(999),
    [anon_sym_while] = ACTIONS(1001),
    [anon_sym_for] = ACTIONS(1003),
    [anon_sym_lock] = ACTIONS(1005),
    [anon_sym_yield] = ACTIONS(1007),
    [anon_sym_switch] = ACTIONS(1009),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1011),
    [anon_sym_try] = ACTIONS(1013),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1015),
    [anon_sym_foreach] = ACTIONS(1017),
    [anon_sym_goto] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(1021),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1023),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [99] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(8872),
    [sym_variable_declaration] = STATE(9850),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6801),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(8708),
    [sym_break_statement] = STATE(8872),
    [sym_checked_statement] = STATE(8872),
    [sym_continue_statement] = STATE(8872),
    [sym_do_statement] = STATE(8872),
    [sym_empty_statement] = STATE(8872),
    [sym_expression_statement] = STATE(8872),
    [sym_fixed_statement] = STATE(8872),
    [sym_for_statement] = STATE(8872),
    [sym_return_statement] = STATE(8872),
    [sym_lock_statement] = STATE(8872),
    [sym_yield_statement] = STATE(8872),
    [sym_switch_statement] = STATE(8872),
    [sym_throw_statement] = STATE(8872),
    [sym_try_statement] = STATE(8872),
    [sym_unsafe_statement] = STATE(8872),
    [sym_using_statement] = STATE(8872),
    [sym_foreach_statement] = STATE(8872),
    [sym_goto_statement] = STATE(8872),
    [sym_labeled_statement] = STATE(8872),
    [sym_if_statement] = STATE(8872),
    [sym_while_statement] = STATE(8872),
    [sym_local_declaration_statement] = STATE(8872),
    [sym_local_function_statement] = STATE(8872),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6718),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2890),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(8872),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(99),
    [sym_preproc_endregion] = STATE(99),
    [sym_preproc_line] = STATE(99),
    [sym_preproc_pragma] = STATE(99),
    [sym_preproc_nullable] = STATE(99),
    [sym_preproc_error] = STATE(99),
    [sym_preproc_define] = STATE(99),
    [sym_preproc_undef] = STATE(99),
    [aux_sym_class_declaration_repeat1] = STATE(2909),
    [aux_sym_class_declaration_repeat2] = STATE(3101),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(981),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(983),
    [anon_sym_unsafe] = ACTIONS(985),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(987),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(989),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(991),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(993),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(995),
    [anon_sym_unchecked] = ACTIONS(993),
    [anon_sym_continue] = ACTIONS(997),
    [anon_sym_do] = ACTIONS(999),
    [anon_sym_while] = ACTIONS(1001),
    [anon_sym_for] = ACTIONS(1003),
    [anon_sym_lock] = ACTIONS(1005),
    [anon_sym_yield] = ACTIONS(1007),
    [anon_sym_switch] = ACTIONS(1009),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1011),
    [anon_sym_try] = ACTIONS(1013),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1015),
    [anon_sym_foreach] = ACTIONS(1017),
    [anon_sym_goto] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(1021),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1023),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [100] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(8872),
    [sym_variable_declaration] = STATE(9850),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6801),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(8709),
    [sym_break_statement] = STATE(8872),
    [sym_checked_statement] = STATE(8872),
    [sym_continue_statement] = STATE(8872),
    [sym_do_statement] = STATE(8872),
    [sym_empty_statement] = STATE(8872),
    [sym_expression_statement] = STATE(8872),
    [sym_fixed_statement] = STATE(8872),
    [sym_for_statement] = STATE(8872),
    [sym_return_statement] = STATE(8872),
    [sym_lock_statement] = STATE(8872),
    [sym_yield_statement] = STATE(8872),
    [sym_switch_statement] = STATE(8872),
    [sym_throw_statement] = STATE(8872),
    [sym_try_statement] = STATE(8872),
    [sym_unsafe_statement] = STATE(8872),
    [sym_using_statement] = STATE(8872),
    [sym_foreach_statement] = STATE(8872),
    [sym_goto_statement] = STATE(8872),
    [sym_labeled_statement] = STATE(8872),
    [sym_if_statement] = STATE(8872),
    [sym_while_statement] = STATE(8872),
    [sym_local_declaration_statement] = STATE(8872),
    [sym_local_function_statement] = STATE(8872),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6718),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2890),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(8872),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(100),
    [sym_preproc_endregion] = STATE(100),
    [sym_preproc_line] = STATE(100),
    [sym_preproc_pragma] = STATE(100),
    [sym_preproc_nullable] = STATE(100),
    [sym_preproc_error] = STATE(100),
    [sym_preproc_define] = STATE(100),
    [sym_preproc_undef] = STATE(100),
    [aux_sym_class_declaration_repeat1] = STATE(2909),
    [aux_sym_class_declaration_repeat2] = STATE(3101),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(981),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(983),
    [anon_sym_unsafe] = ACTIONS(985),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(987),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(989),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(991),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(993),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(995),
    [anon_sym_unchecked] = ACTIONS(993),
    [anon_sym_continue] = ACTIONS(997),
    [anon_sym_do] = ACTIONS(999),
    [anon_sym_while] = ACTIONS(1001),
    [anon_sym_for] = ACTIONS(1003),
    [anon_sym_lock] = ACTIONS(1005),
    [anon_sym_yield] = ACTIONS(1007),
    [anon_sym_switch] = ACTIONS(1009),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1011),
    [anon_sym_try] = ACTIONS(1013),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1015),
    [anon_sym_foreach] = ACTIONS(1017),
    [anon_sym_goto] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(1021),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1023),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [101] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2220),
    [sym_variable_declaration] = STATE(9437),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6809),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2275),
    [sym_break_statement] = STATE(2220),
    [sym_checked_statement] = STATE(2220),
    [sym_continue_statement] = STATE(2220),
    [sym_do_statement] = STATE(2220),
    [sym_empty_statement] = STATE(2220),
    [sym_expression_statement] = STATE(2220),
    [sym_fixed_statement] = STATE(2220),
    [sym_for_statement] = STATE(2220),
    [sym_return_statement] = STATE(2220),
    [sym_lock_statement] = STATE(2220),
    [sym_yield_statement] = STATE(2220),
    [sym_switch_statement] = STATE(2220),
    [sym_throw_statement] = STATE(2220),
    [sym_try_statement] = STATE(2220),
    [sym_unsafe_statement] = STATE(2220),
    [sym_using_statement] = STATE(2220),
    [sym_foreach_statement] = STATE(2220),
    [sym_goto_statement] = STATE(2220),
    [sym_labeled_statement] = STATE(2220),
    [sym_if_statement] = STATE(2220),
    [sym_while_statement] = STATE(2220),
    [sym_local_declaration_statement] = STATE(2220),
    [sym_local_function_statement] = STATE(2220),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6150),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2819),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2220),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(101),
    [sym_preproc_endregion] = STATE(101),
    [sym_preproc_line] = STATE(101),
    [sym_preproc_pragma] = STATE(101),
    [sym_preproc_nullable] = STATE(101),
    [sym_preproc_error] = STATE(101),
    [sym_preproc_define] = STATE(101),
    [sym_preproc_undef] = STATE(101),
    [aux_sym_class_declaration_repeat1] = STATE(2924),
    [aux_sym_class_declaration_repeat2] = STATE(3080),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(155),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1025),
    [anon_sym_unsafe] = ACTIONS(1027),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(165),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(177),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(1029),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(187),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(189),
    [anon_sym_unchecked] = ACTIONS(187),
    [anon_sym_continue] = ACTIONS(191),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_while] = ACTIONS(195),
    [anon_sym_for] = ACTIONS(197),
    [anon_sym_lock] = ACTIONS(199),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(205),
    [anon_sym_try] = ACTIONS(207),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(209),
    [anon_sym_foreach] = ACTIONS(211),
    [anon_sym_goto] = ACTIONS(213),
    [anon_sym_if] = ACTIONS(215),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(217),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [102] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2220),
    [sym_variable_declaration] = STATE(9437),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6809),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2281),
    [sym_break_statement] = STATE(2220),
    [sym_checked_statement] = STATE(2220),
    [sym_continue_statement] = STATE(2220),
    [sym_do_statement] = STATE(2220),
    [sym_empty_statement] = STATE(2220),
    [sym_expression_statement] = STATE(2220),
    [sym_fixed_statement] = STATE(2220),
    [sym_for_statement] = STATE(2220),
    [sym_return_statement] = STATE(2220),
    [sym_lock_statement] = STATE(2220),
    [sym_yield_statement] = STATE(2220),
    [sym_switch_statement] = STATE(2220),
    [sym_throw_statement] = STATE(2220),
    [sym_try_statement] = STATE(2220),
    [sym_unsafe_statement] = STATE(2220),
    [sym_using_statement] = STATE(2220),
    [sym_foreach_statement] = STATE(2220),
    [sym_goto_statement] = STATE(2220),
    [sym_labeled_statement] = STATE(2220),
    [sym_if_statement] = STATE(2220),
    [sym_while_statement] = STATE(2220),
    [sym_local_declaration_statement] = STATE(2220),
    [sym_local_function_statement] = STATE(2220),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6150),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2819),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2220),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(102),
    [sym_preproc_endregion] = STATE(102),
    [sym_preproc_line] = STATE(102),
    [sym_preproc_pragma] = STATE(102),
    [sym_preproc_nullable] = STATE(102),
    [sym_preproc_error] = STATE(102),
    [sym_preproc_define] = STATE(102),
    [sym_preproc_undef] = STATE(102),
    [aux_sym_class_declaration_repeat1] = STATE(2924),
    [aux_sym_class_declaration_repeat2] = STATE(3080),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(155),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1025),
    [anon_sym_unsafe] = ACTIONS(1027),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(165),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(177),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(1029),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(187),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(189),
    [anon_sym_unchecked] = ACTIONS(187),
    [anon_sym_continue] = ACTIONS(191),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_while] = ACTIONS(195),
    [anon_sym_for] = ACTIONS(197),
    [anon_sym_lock] = ACTIONS(199),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(205),
    [anon_sym_try] = ACTIONS(207),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(209),
    [anon_sym_foreach] = ACTIONS(211),
    [anon_sym_goto] = ACTIONS(213),
    [anon_sym_if] = ACTIONS(215),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(217),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [103] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(8872),
    [sym_variable_declaration] = STATE(9850),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6801),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(8711),
    [sym_break_statement] = STATE(8872),
    [sym_checked_statement] = STATE(8872),
    [sym_continue_statement] = STATE(8872),
    [sym_do_statement] = STATE(8872),
    [sym_empty_statement] = STATE(8872),
    [sym_expression_statement] = STATE(8872),
    [sym_fixed_statement] = STATE(8872),
    [sym_for_statement] = STATE(8872),
    [sym_return_statement] = STATE(8872),
    [sym_lock_statement] = STATE(8872),
    [sym_yield_statement] = STATE(8872),
    [sym_switch_statement] = STATE(8872),
    [sym_throw_statement] = STATE(8872),
    [sym_try_statement] = STATE(8872),
    [sym_unsafe_statement] = STATE(8872),
    [sym_using_statement] = STATE(8872),
    [sym_foreach_statement] = STATE(8872),
    [sym_goto_statement] = STATE(8872),
    [sym_labeled_statement] = STATE(8872),
    [sym_if_statement] = STATE(8872),
    [sym_while_statement] = STATE(8872),
    [sym_local_declaration_statement] = STATE(8872),
    [sym_local_function_statement] = STATE(8872),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6718),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2890),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(8872),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(103),
    [sym_preproc_endregion] = STATE(103),
    [sym_preproc_line] = STATE(103),
    [sym_preproc_pragma] = STATE(103),
    [sym_preproc_nullable] = STATE(103),
    [sym_preproc_error] = STATE(103),
    [sym_preproc_define] = STATE(103),
    [sym_preproc_undef] = STATE(103),
    [aux_sym_class_declaration_repeat1] = STATE(2909),
    [aux_sym_class_declaration_repeat2] = STATE(3101),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(981),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(983),
    [anon_sym_unsafe] = ACTIONS(985),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(987),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(989),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(991),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(993),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(995),
    [anon_sym_unchecked] = ACTIONS(993),
    [anon_sym_continue] = ACTIONS(997),
    [anon_sym_do] = ACTIONS(999),
    [anon_sym_while] = ACTIONS(1001),
    [anon_sym_for] = ACTIONS(1003),
    [anon_sym_lock] = ACTIONS(1005),
    [anon_sym_yield] = ACTIONS(1007),
    [anon_sym_switch] = ACTIONS(1009),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1011),
    [anon_sym_try] = ACTIONS(1013),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1015),
    [anon_sym_foreach] = ACTIONS(1017),
    [anon_sym_goto] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(1021),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1023),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [104] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2647),
    [sym_variable_declaration] = STATE(9394),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6827),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2652),
    [sym_break_statement] = STATE(2647),
    [sym_checked_statement] = STATE(2647),
    [sym_continue_statement] = STATE(2647),
    [sym_do_statement] = STATE(2647),
    [sym_empty_statement] = STATE(2647),
    [sym_expression_statement] = STATE(2647),
    [sym_fixed_statement] = STATE(2647),
    [sym_for_statement] = STATE(2647),
    [sym_return_statement] = STATE(2647),
    [sym_lock_statement] = STATE(2647),
    [sym_yield_statement] = STATE(2647),
    [sym_switch_statement] = STATE(2647),
    [sym_throw_statement] = STATE(2647),
    [sym_try_statement] = STATE(2647),
    [sym_unsafe_statement] = STATE(2647),
    [sym_using_statement] = STATE(2647),
    [sym_foreach_statement] = STATE(2647),
    [sym_goto_statement] = STATE(2647),
    [sym_labeled_statement] = STATE(2647),
    [sym_if_statement] = STATE(2647),
    [sym_while_statement] = STATE(2647),
    [sym_local_declaration_statement] = STATE(2647),
    [sym_local_function_statement] = STATE(2647),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6543),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2835),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2647),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(104),
    [sym_preproc_endregion] = STATE(104),
    [sym_preproc_line] = STATE(104),
    [sym_preproc_pragma] = STATE(104),
    [sym_preproc_nullable] = STATE(104),
    [sym_preproc_error] = STATE(104),
    [sym_preproc_define] = STATE(104),
    [sym_preproc_undef] = STATE(104),
    [aux_sym_class_declaration_repeat1] = STATE(2918),
    [aux_sym_class_declaration_repeat2] = STATE(3106),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(647),
    [anon_sym_unsafe] = ACTIONS(649),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(655),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(659),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(667),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(671),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(673),
    [anon_sym_unchecked] = ACTIONS(671),
    [anon_sym_continue] = ACTIONS(675),
    [anon_sym_do] = ACTIONS(677),
    [anon_sym_while] = ACTIONS(679),
    [anon_sym_for] = ACTIONS(681),
    [anon_sym_lock] = ACTIONS(683),
    [anon_sym_yield] = ACTIONS(685),
    [anon_sym_switch] = ACTIONS(687),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_try] = ACTIONS(693),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(695),
    [anon_sym_foreach] = ACTIONS(697),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [105] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(8872),
    [sym_variable_declaration] = STATE(9850),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6801),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(8714),
    [sym_break_statement] = STATE(8872),
    [sym_checked_statement] = STATE(8872),
    [sym_continue_statement] = STATE(8872),
    [sym_do_statement] = STATE(8872),
    [sym_empty_statement] = STATE(8872),
    [sym_expression_statement] = STATE(8872),
    [sym_fixed_statement] = STATE(8872),
    [sym_for_statement] = STATE(8872),
    [sym_return_statement] = STATE(8872),
    [sym_lock_statement] = STATE(8872),
    [sym_yield_statement] = STATE(8872),
    [sym_switch_statement] = STATE(8872),
    [sym_throw_statement] = STATE(8872),
    [sym_try_statement] = STATE(8872),
    [sym_unsafe_statement] = STATE(8872),
    [sym_using_statement] = STATE(8872),
    [sym_foreach_statement] = STATE(8872),
    [sym_goto_statement] = STATE(8872),
    [sym_labeled_statement] = STATE(8872),
    [sym_if_statement] = STATE(8872),
    [sym_while_statement] = STATE(8872),
    [sym_local_declaration_statement] = STATE(8872),
    [sym_local_function_statement] = STATE(8872),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6718),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2890),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(8872),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(105),
    [sym_preproc_endregion] = STATE(105),
    [sym_preproc_line] = STATE(105),
    [sym_preproc_pragma] = STATE(105),
    [sym_preproc_nullable] = STATE(105),
    [sym_preproc_error] = STATE(105),
    [sym_preproc_define] = STATE(105),
    [sym_preproc_undef] = STATE(105),
    [aux_sym_class_declaration_repeat1] = STATE(2909),
    [aux_sym_class_declaration_repeat2] = STATE(3101),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(981),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(983),
    [anon_sym_unsafe] = ACTIONS(985),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(987),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(989),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(991),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(993),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(995),
    [anon_sym_unchecked] = ACTIONS(993),
    [anon_sym_continue] = ACTIONS(997),
    [anon_sym_do] = ACTIONS(999),
    [anon_sym_while] = ACTIONS(1001),
    [anon_sym_for] = ACTIONS(1003),
    [anon_sym_lock] = ACTIONS(1005),
    [anon_sym_yield] = ACTIONS(1007),
    [anon_sym_switch] = ACTIONS(1009),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1011),
    [anon_sym_try] = ACTIONS(1013),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1015),
    [anon_sym_foreach] = ACTIONS(1017),
    [anon_sym_goto] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(1021),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1023),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [106] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2647),
    [sym_variable_declaration] = STATE(9394),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6827),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2651),
    [sym_break_statement] = STATE(2647),
    [sym_checked_statement] = STATE(2647),
    [sym_continue_statement] = STATE(2647),
    [sym_do_statement] = STATE(2647),
    [sym_empty_statement] = STATE(2647),
    [sym_expression_statement] = STATE(2647),
    [sym_fixed_statement] = STATE(2647),
    [sym_for_statement] = STATE(2647),
    [sym_return_statement] = STATE(2647),
    [sym_lock_statement] = STATE(2647),
    [sym_yield_statement] = STATE(2647),
    [sym_switch_statement] = STATE(2647),
    [sym_throw_statement] = STATE(2647),
    [sym_try_statement] = STATE(2647),
    [sym_unsafe_statement] = STATE(2647),
    [sym_using_statement] = STATE(2647),
    [sym_foreach_statement] = STATE(2647),
    [sym_goto_statement] = STATE(2647),
    [sym_labeled_statement] = STATE(2647),
    [sym_if_statement] = STATE(2647),
    [sym_while_statement] = STATE(2647),
    [sym_local_declaration_statement] = STATE(2647),
    [sym_local_function_statement] = STATE(2647),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6543),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2835),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2647),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(106),
    [sym_preproc_endregion] = STATE(106),
    [sym_preproc_line] = STATE(106),
    [sym_preproc_pragma] = STATE(106),
    [sym_preproc_nullable] = STATE(106),
    [sym_preproc_error] = STATE(106),
    [sym_preproc_define] = STATE(106),
    [sym_preproc_undef] = STATE(106),
    [aux_sym_class_declaration_repeat1] = STATE(2918),
    [aux_sym_class_declaration_repeat2] = STATE(3106),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(647),
    [anon_sym_unsafe] = ACTIONS(649),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(655),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(659),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(667),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(671),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(673),
    [anon_sym_unchecked] = ACTIONS(671),
    [anon_sym_continue] = ACTIONS(675),
    [anon_sym_do] = ACTIONS(677),
    [anon_sym_while] = ACTIONS(679),
    [anon_sym_for] = ACTIONS(681),
    [anon_sym_lock] = ACTIONS(683),
    [anon_sym_yield] = ACTIONS(685),
    [anon_sym_switch] = ACTIONS(687),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_try] = ACTIONS(693),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(695),
    [anon_sym_foreach] = ACTIONS(697),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [107] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2647),
    [sym_variable_declaration] = STATE(9394),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6827),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2646),
    [sym_break_statement] = STATE(2647),
    [sym_checked_statement] = STATE(2647),
    [sym_continue_statement] = STATE(2647),
    [sym_do_statement] = STATE(2647),
    [sym_empty_statement] = STATE(2647),
    [sym_expression_statement] = STATE(2647),
    [sym_fixed_statement] = STATE(2647),
    [sym_for_statement] = STATE(2647),
    [sym_return_statement] = STATE(2647),
    [sym_lock_statement] = STATE(2647),
    [sym_yield_statement] = STATE(2647),
    [sym_switch_statement] = STATE(2647),
    [sym_throw_statement] = STATE(2647),
    [sym_try_statement] = STATE(2647),
    [sym_unsafe_statement] = STATE(2647),
    [sym_using_statement] = STATE(2647),
    [sym_foreach_statement] = STATE(2647),
    [sym_goto_statement] = STATE(2647),
    [sym_labeled_statement] = STATE(2647),
    [sym_if_statement] = STATE(2647),
    [sym_while_statement] = STATE(2647),
    [sym_local_declaration_statement] = STATE(2647),
    [sym_local_function_statement] = STATE(2647),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6543),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2835),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2647),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(107),
    [sym_preproc_endregion] = STATE(107),
    [sym_preproc_line] = STATE(107),
    [sym_preproc_pragma] = STATE(107),
    [sym_preproc_nullable] = STATE(107),
    [sym_preproc_error] = STATE(107),
    [sym_preproc_define] = STATE(107),
    [sym_preproc_undef] = STATE(107),
    [aux_sym_class_declaration_repeat1] = STATE(2918),
    [aux_sym_class_declaration_repeat2] = STATE(3106),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(647),
    [anon_sym_unsafe] = ACTIONS(649),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(655),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(659),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(667),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(671),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(673),
    [anon_sym_unchecked] = ACTIONS(671),
    [anon_sym_continue] = ACTIONS(675),
    [anon_sym_do] = ACTIONS(677),
    [anon_sym_while] = ACTIONS(679),
    [anon_sym_for] = ACTIONS(681),
    [anon_sym_lock] = ACTIONS(683),
    [anon_sym_yield] = ACTIONS(685),
    [anon_sym_switch] = ACTIONS(687),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_try] = ACTIONS(693),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(695),
    [anon_sym_foreach] = ACTIONS(697),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [108] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2220),
    [sym_variable_declaration] = STATE(9437),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6809),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2226),
    [sym_break_statement] = STATE(2220),
    [sym_checked_statement] = STATE(2220),
    [sym_continue_statement] = STATE(2220),
    [sym_do_statement] = STATE(2220),
    [sym_empty_statement] = STATE(2220),
    [sym_expression_statement] = STATE(2220),
    [sym_fixed_statement] = STATE(2220),
    [sym_for_statement] = STATE(2220),
    [sym_return_statement] = STATE(2220),
    [sym_lock_statement] = STATE(2220),
    [sym_yield_statement] = STATE(2220),
    [sym_switch_statement] = STATE(2220),
    [sym_throw_statement] = STATE(2220),
    [sym_try_statement] = STATE(2220),
    [sym_unsafe_statement] = STATE(2220),
    [sym_using_statement] = STATE(2220),
    [sym_foreach_statement] = STATE(2220),
    [sym_goto_statement] = STATE(2220),
    [sym_labeled_statement] = STATE(2220),
    [sym_if_statement] = STATE(2220),
    [sym_while_statement] = STATE(2220),
    [sym_local_declaration_statement] = STATE(2220),
    [sym_local_function_statement] = STATE(2220),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6150),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2819),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2220),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(108),
    [sym_preproc_endregion] = STATE(108),
    [sym_preproc_line] = STATE(108),
    [sym_preproc_pragma] = STATE(108),
    [sym_preproc_nullable] = STATE(108),
    [sym_preproc_error] = STATE(108),
    [sym_preproc_define] = STATE(108),
    [sym_preproc_undef] = STATE(108),
    [aux_sym_class_declaration_repeat1] = STATE(2924),
    [aux_sym_class_declaration_repeat2] = STATE(3080),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(155),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1025),
    [anon_sym_unsafe] = ACTIONS(1027),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(165),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(177),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(1029),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(187),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(189),
    [anon_sym_unchecked] = ACTIONS(187),
    [anon_sym_continue] = ACTIONS(191),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_while] = ACTIONS(195),
    [anon_sym_for] = ACTIONS(197),
    [anon_sym_lock] = ACTIONS(199),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(205),
    [anon_sym_try] = ACTIONS(207),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(209),
    [anon_sym_foreach] = ACTIONS(211),
    [anon_sym_goto] = ACTIONS(213),
    [anon_sym_if] = ACTIONS(215),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(217),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [109] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2647),
    [sym_variable_declaration] = STATE(9394),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6827),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2656),
    [sym_break_statement] = STATE(2647),
    [sym_checked_statement] = STATE(2647),
    [sym_continue_statement] = STATE(2647),
    [sym_do_statement] = STATE(2647),
    [sym_empty_statement] = STATE(2647),
    [sym_expression_statement] = STATE(2647),
    [sym_fixed_statement] = STATE(2647),
    [sym_for_statement] = STATE(2647),
    [sym_return_statement] = STATE(2647),
    [sym_lock_statement] = STATE(2647),
    [sym_yield_statement] = STATE(2647),
    [sym_switch_statement] = STATE(2647),
    [sym_throw_statement] = STATE(2647),
    [sym_try_statement] = STATE(2647),
    [sym_unsafe_statement] = STATE(2647),
    [sym_using_statement] = STATE(2647),
    [sym_foreach_statement] = STATE(2647),
    [sym_goto_statement] = STATE(2647),
    [sym_labeled_statement] = STATE(2647),
    [sym_if_statement] = STATE(2647),
    [sym_while_statement] = STATE(2647),
    [sym_local_declaration_statement] = STATE(2647),
    [sym_local_function_statement] = STATE(2647),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6543),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2835),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2647),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(109),
    [sym_preproc_endregion] = STATE(109),
    [sym_preproc_line] = STATE(109),
    [sym_preproc_pragma] = STATE(109),
    [sym_preproc_nullable] = STATE(109),
    [sym_preproc_error] = STATE(109),
    [sym_preproc_define] = STATE(109),
    [sym_preproc_undef] = STATE(109),
    [aux_sym_class_declaration_repeat1] = STATE(2918),
    [aux_sym_class_declaration_repeat2] = STATE(3106),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(647),
    [anon_sym_unsafe] = ACTIONS(649),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(655),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(659),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(667),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(671),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(673),
    [anon_sym_unchecked] = ACTIONS(671),
    [anon_sym_continue] = ACTIONS(675),
    [anon_sym_do] = ACTIONS(677),
    [anon_sym_while] = ACTIONS(679),
    [anon_sym_for] = ACTIONS(681),
    [anon_sym_lock] = ACTIONS(683),
    [anon_sym_yield] = ACTIONS(685),
    [anon_sym_switch] = ACTIONS(687),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_try] = ACTIONS(693),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(695),
    [anon_sym_foreach] = ACTIONS(697),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [110] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(8872),
    [sym_variable_declaration] = STATE(9850),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6801),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(8719),
    [sym_break_statement] = STATE(8872),
    [sym_checked_statement] = STATE(8872),
    [sym_continue_statement] = STATE(8872),
    [sym_do_statement] = STATE(8872),
    [sym_empty_statement] = STATE(8872),
    [sym_expression_statement] = STATE(8872),
    [sym_fixed_statement] = STATE(8872),
    [sym_for_statement] = STATE(8872),
    [sym_return_statement] = STATE(8872),
    [sym_lock_statement] = STATE(8872),
    [sym_yield_statement] = STATE(8872),
    [sym_switch_statement] = STATE(8872),
    [sym_throw_statement] = STATE(8872),
    [sym_try_statement] = STATE(8872),
    [sym_unsafe_statement] = STATE(8872),
    [sym_using_statement] = STATE(8872),
    [sym_foreach_statement] = STATE(8872),
    [sym_goto_statement] = STATE(8872),
    [sym_labeled_statement] = STATE(8872),
    [sym_if_statement] = STATE(8872),
    [sym_while_statement] = STATE(8872),
    [sym_local_declaration_statement] = STATE(8872),
    [sym_local_function_statement] = STATE(8872),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6718),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2890),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(8872),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(110),
    [sym_preproc_endregion] = STATE(110),
    [sym_preproc_line] = STATE(110),
    [sym_preproc_pragma] = STATE(110),
    [sym_preproc_nullable] = STATE(110),
    [sym_preproc_error] = STATE(110),
    [sym_preproc_define] = STATE(110),
    [sym_preproc_undef] = STATE(110),
    [aux_sym_class_declaration_repeat1] = STATE(2909),
    [aux_sym_class_declaration_repeat2] = STATE(3101),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(981),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(983),
    [anon_sym_unsafe] = ACTIONS(985),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(987),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(989),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(991),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(993),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(995),
    [anon_sym_unchecked] = ACTIONS(993),
    [anon_sym_continue] = ACTIONS(997),
    [anon_sym_do] = ACTIONS(999),
    [anon_sym_while] = ACTIONS(1001),
    [anon_sym_for] = ACTIONS(1003),
    [anon_sym_lock] = ACTIONS(1005),
    [anon_sym_yield] = ACTIONS(1007),
    [anon_sym_switch] = ACTIONS(1009),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1011),
    [anon_sym_try] = ACTIONS(1013),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1015),
    [anon_sym_foreach] = ACTIONS(1017),
    [anon_sym_goto] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(1021),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1023),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [111] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(8872),
    [sym_variable_declaration] = STATE(9850),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6801),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(8722),
    [sym_break_statement] = STATE(8872),
    [sym_checked_statement] = STATE(8872),
    [sym_continue_statement] = STATE(8872),
    [sym_do_statement] = STATE(8872),
    [sym_empty_statement] = STATE(8872),
    [sym_expression_statement] = STATE(8872),
    [sym_fixed_statement] = STATE(8872),
    [sym_for_statement] = STATE(8872),
    [sym_return_statement] = STATE(8872),
    [sym_lock_statement] = STATE(8872),
    [sym_yield_statement] = STATE(8872),
    [sym_switch_statement] = STATE(8872),
    [sym_throw_statement] = STATE(8872),
    [sym_try_statement] = STATE(8872),
    [sym_unsafe_statement] = STATE(8872),
    [sym_using_statement] = STATE(8872),
    [sym_foreach_statement] = STATE(8872),
    [sym_goto_statement] = STATE(8872),
    [sym_labeled_statement] = STATE(8872),
    [sym_if_statement] = STATE(8872),
    [sym_while_statement] = STATE(8872),
    [sym_local_declaration_statement] = STATE(8872),
    [sym_local_function_statement] = STATE(8872),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6718),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2890),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(8872),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(111),
    [sym_preproc_endregion] = STATE(111),
    [sym_preproc_line] = STATE(111),
    [sym_preproc_pragma] = STATE(111),
    [sym_preproc_nullable] = STATE(111),
    [sym_preproc_error] = STATE(111),
    [sym_preproc_define] = STATE(111),
    [sym_preproc_undef] = STATE(111),
    [aux_sym_class_declaration_repeat1] = STATE(2909),
    [aux_sym_class_declaration_repeat2] = STATE(3101),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(981),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(983),
    [anon_sym_unsafe] = ACTIONS(985),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(987),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(989),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(991),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(993),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(995),
    [anon_sym_unchecked] = ACTIONS(993),
    [anon_sym_continue] = ACTIONS(997),
    [anon_sym_do] = ACTIONS(999),
    [anon_sym_while] = ACTIONS(1001),
    [anon_sym_for] = ACTIONS(1003),
    [anon_sym_lock] = ACTIONS(1005),
    [anon_sym_yield] = ACTIONS(1007),
    [anon_sym_switch] = ACTIONS(1009),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1011),
    [anon_sym_try] = ACTIONS(1013),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1015),
    [anon_sym_foreach] = ACTIONS(1017),
    [anon_sym_goto] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(1021),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1023),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [112] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2647),
    [sym_variable_declaration] = STATE(9394),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6827),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2673),
    [sym_break_statement] = STATE(2647),
    [sym_checked_statement] = STATE(2647),
    [sym_continue_statement] = STATE(2647),
    [sym_do_statement] = STATE(2647),
    [sym_empty_statement] = STATE(2647),
    [sym_expression_statement] = STATE(2647),
    [sym_fixed_statement] = STATE(2647),
    [sym_for_statement] = STATE(2647),
    [sym_return_statement] = STATE(2647),
    [sym_lock_statement] = STATE(2647),
    [sym_yield_statement] = STATE(2647),
    [sym_switch_statement] = STATE(2647),
    [sym_throw_statement] = STATE(2647),
    [sym_try_statement] = STATE(2647),
    [sym_unsafe_statement] = STATE(2647),
    [sym_using_statement] = STATE(2647),
    [sym_foreach_statement] = STATE(2647),
    [sym_goto_statement] = STATE(2647),
    [sym_labeled_statement] = STATE(2647),
    [sym_if_statement] = STATE(2647),
    [sym_while_statement] = STATE(2647),
    [sym_local_declaration_statement] = STATE(2647),
    [sym_local_function_statement] = STATE(2647),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6543),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2835),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2647),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(112),
    [sym_preproc_endregion] = STATE(112),
    [sym_preproc_line] = STATE(112),
    [sym_preproc_pragma] = STATE(112),
    [sym_preproc_nullable] = STATE(112),
    [sym_preproc_error] = STATE(112),
    [sym_preproc_define] = STATE(112),
    [sym_preproc_undef] = STATE(112),
    [aux_sym_class_declaration_repeat1] = STATE(2918),
    [aux_sym_class_declaration_repeat2] = STATE(3106),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(647),
    [anon_sym_unsafe] = ACTIONS(649),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(655),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(659),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(667),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(671),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(673),
    [anon_sym_unchecked] = ACTIONS(671),
    [anon_sym_continue] = ACTIONS(675),
    [anon_sym_do] = ACTIONS(677),
    [anon_sym_while] = ACTIONS(679),
    [anon_sym_for] = ACTIONS(681),
    [anon_sym_lock] = ACTIONS(683),
    [anon_sym_yield] = ACTIONS(685),
    [anon_sym_switch] = ACTIONS(687),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_try] = ACTIONS(693),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(695),
    [anon_sym_foreach] = ACTIONS(697),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [113] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2647),
    [sym_variable_declaration] = STATE(9394),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6827),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2657),
    [sym_break_statement] = STATE(2647),
    [sym_checked_statement] = STATE(2647),
    [sym_continue_statement] = STATE(2647),
    [sym_do_statement] = STATE(2647),
    [sym_empty_statement] = STATE(2647),
    [sym_expression_statement] = STATE(2647),
    [sym_fixed_statement] = STATE(2647),
    [sym_for_statement] = STATE(2647),
    [sym_return_statement] = STATE(2647),
    [sym_lock_statement] = STATE(2647),
    [sym_yield_statement] = STATE(2647),
    [sym_switch_statement] = STATE(2647),
    [sym_throw_statement] = STATE(2647),
    [sym_try_statement] = STATE(2647),
    [sym_unsafe_statement] = STATE(2647),
    [sym_using_statement] = STATE(2647),
    [sym_foreach_statement] = STATE(2647),
    [sym_goto_statement] = STATE(2647),
    [sym_labeled_statement] = STATE(2647),
    [sym_if_statement] = STATE(2647),
    [sym_while_statement] = STATE(2647),
    [sym_local_declaration_statement] = STATE(2647),
    [sym_local_function_statement] = STATE(2647),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6543),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2835),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2647),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(113),
    [sym_preproc_endregion] = STATE(113),
    [sym_preproc_line] = STATE(113),
    [sym_preproc_pragma] = STATE(113),
    [sym_preproc_nullable] = STATE(113),
    [sym_preproc_error] = STATE(113),
    [sym_preproc_define] = STATE(113),
    [sym_preproc_undef] = STATE(113),
    [aux_sym_class_declaration_repeat1] = STATE(2918),
    [aux_sym_class_declaration_repeat2] = STATE(3106),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(647),
    [anon_sym_unsafe] = ACTIONS(649),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(655),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(659),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(667),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(671),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(673),
    [anon_sym_unchecked] = ACTIONS(671),
    [anon_sym_continue] = ACTIONS(675),
    [anon_sym_do] = ACTIONS(677),
    [anon_sym_while] = ACTIONS(679),
    [anon_sym_for] = ACTIONS(681),
    [anon_sym_lock] = ACTIONS(683),
    [anon_sym_yield] = ACTIONS(685),
    [anon_sym_switch] = ACTIONS(687),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_try] = ACTIONS(693),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(695),
    [anon_sym_foreach] = ACTIONS(697),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [114] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(8872),
    [sym_variable_declaration] = STATE(9850),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6801),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(8723),
    [sym_break_statement] = STATE(8872),
    [sym_checked_statement] = STATE(8872),
    [sym_continue_statement] = STATE(8872),
    [sym_do_statement] = STATE(8872),
    [sym_empty_statement] = STATE(8872),
    [sym_expression_statement] = STATE(8872),
    [sym_fixed_statement] = STATE(8872),
    [sym_for_statement] = STATE(8872),
    [sym_return_statement] = STATE(8872),
    [sym_lock_statement] = STATE(8872),
    [sym_yield_statement] = STATE(8872),
    [sym_switch_statement] = STATE(8872),
    [sym_throw_statement] = STATE(8872),
    [sym_try_statement] = STATE(8872),
    [sym_unsafe_statement] = STATE(8872),
    [sym_using_statement] = STATE(8872),
    [sym_foreach_statement] = STATE(8872),
    [sym_goto_statement] = STATE(8872),
    [sym_labeled_statement] = STATE(8872),
    [sym_if_statement] = STATE(8872),
    [sym_while_statement] = STATE(8872),
    [sym_local_declaration_statement] = STATE(8872),
    [sym_local_function_statement] = STATE(8872),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6718),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2890),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(8872),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(114),
    [sym_preproc_endregion] = STATE(114),
    [sym_preproc_line] = STATE(114),
    [sym_preproc_pragma] = STATE(114),
    [sym_preproc_nullable] = STATE(114),
    [sym_preproc_error] = STATE(114),
    [sym_preproc_define] = STATE(114),
    [sym_preproc_undef] = STATE(114),
    [aux_sym_class_declaration_repeat1] = STATE(2909),
    [aux_sym_class_declaration_repeat2] = STATE(3101),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(981),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(983),
    [anon_sym_unsafe] = ACTIONS(985),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(987),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(989),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(991),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(993),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(995),
    [anon_sym_unchecked] = ACTIONS(993),
    [anon_sym_continue] = ACTIONS(997),
    [anon_sym_do] = ACTIONS(999),
    [anon_sym_while] = ACTIONS(1001),
    [anon_sym_for] = ACTIONS(1003),
    [anon_sym_lock] = ACTIONS(1005),
    [anon_sym_yield] = ACTIONS(1007),
    [anon_sym_switch] = ACTIONS(1009),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1011),
    [anon_sym_try] = ACTIONS(1013),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1015),
    [anon_sym_foreach] = ACTIONS(1017),
    [anon_sym_goto] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(1021),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1023),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [115] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2647),
    [sym_variable_declaration] = STATE(9394),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6827),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2659),
    [sym_break_statement] = STATE(2647),
    [sym_checked_statement] = STATE(2647),
    [sym_continue_statement] = STATE(2647),
    [sym_do_statement] = STATE(2647),
    [sym_empty_statement] = STATE(2647),
    [sym_expression_statement] = STATE(2647),
    [sym_fixed_statement] = STATE(2647),
    [sym_for_statement] = STATE(2647),
    [sym_return_statement] = STATE(2647),
    [sym_lock_statement] = STATE(2647),
    [sym_yield_statement] = STATE(2647),
    [sym_switch_statement] = STATE(2647),
    [sym_throw_statement] = STATE(2647),
    [sym_try_statement] = STATE(2647),
    [sym_unsafe_statement] = STATE(2647),
    [sym_using_statement] = STATE(2647),
    [sym_foreach_statement] = STATE(2647),
    [sym_goto_statement] = STATE(2647),
    [sym_labeled_statement] = STATE(2647),
    [sym_if_statement] = STATE(2647),
    [sym_while_statement] = STATE(2647),
    [sym_local_declaration_statement] = STATE(2647),
    [sym_local_function_statement] = STATE(2647),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6543),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2835),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2647),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(115),
    [sym_preproc_endregion] = STATE(115),
    [sym_preproc_line] = STATE(115),
    [sym_preproc_pragma] = STATE(115),
    [sym_preproc_nullable] = STATE(115),
    [sym_preproc_error] = STATE(115),
    [sym_preproc_define] = STATE(115),
    [sym_preproc_undef] = STATE(115),
    [aux_sym_class_declaration_repeat1] = STATE(2918),
    [aux_sym_class_declaration_repeat2] = STATE(3106),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(647),
    [anon_sym_unsafe] = ACTIONS(649),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(655),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(659),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(667),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(671),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(673),
    [anon_sym_unchecked] = ACTIONS(671),
    [anon_sym_continue] = ACTIONS(675),
    [anon_sym_do] = ACTIONS(677),
    [anon_sym_while] = ACTIONS(679),
    [anon_sym_for] = ACTIONS(681),
    [anon_sym_lock] = ACTIONS(683),
    [anon_sym_yield] = ACTIONS(685),
    [anon_sym_switch] = ACTIONS(687),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_try] = ACTIONS(693),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(695),
    [anon_sym_foreach] = ACTIONS(697),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [116] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2647),
    [sym_variable_declaration] = STATE(9394),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6827),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2665),
    [sym_break_statement] = STATE(2647),
    [sym_checked_statement] = STATE(2647),
    [sym_continue_statement] = STATE(2647),
    [sym_do_statement] = STATE(2647),
    [sym_empty_statement] = STATE(2647),
    [sym_expression_statement] = STATE(2647),
    [sym_fixed_statement] = STATE(2647),
    [sym_for_statement] = STATE(2647),
    [sym_return_statement] = STATE(2647),
    [sym_lock_statement] = STATE(2647),
    [sym_yield_statement] = STATE(2647),
    [sym_switch_statement] = STATE(2647),
    [sym_throw_statement] = STATE(2647),
    [sym_try_statement] = STATE(2647),
    [sym_unsafe_statement] = STATE(2647),
    [sym_using_statement] = STATE(2647),
    [sym_foreach_statement] = STATE(2647),
    [sym_goto_statement] = STATE(2647),
    [sym_labeled_statement] = STATE(2647),
    [sym_if_statement] = STATE(2647),
    [sym_while_statement] = STATE(2647),
    [sym_local_declaration_statement] = STATE(2647),
    [sym_local_function_statement] = STATE(2647),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6543),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2835),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2647),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(116),
    [sym_preproc_endregion] = STATE(116),
    [sym_preproc_line] = STATE(116),
    [sym_preproc_pragma] = STATE(116),
    [sym_preproc_nullable] = STATE(116),
    [sym_preproc_error] = STATE(116),
    [sym_preproc_define] = STATE(116),
    [sym_preproc_undef] = STATE(116),
    [aux_sym_class_declaration_repeat1] = STATE(2918),
    [aux_sym_class_declaration_repeat2] = STATE(3106),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(647),
    [anon_sym_unsafe] = ACTIONS(649),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(655),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(659),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(667),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(671),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(673),
    [anon_sym_unchecked] = ACTIONS(671),
    [anon_sym_continue] = ACTIONS(675),
    [anon_sym_do] = ACTIONS(677),
    [anon_sym_while] = ACTIONS(679),
    [anon_sym_for] = ACTIONS(681),
    [anon_sym_lock] = ACTIONS(683),
    [anon_sym_yield] = ACTIONS(685),
    [anon_sym_switch] = ACTIONS(687),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_try] = ACTIONS(693),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(695),
    [anon_sym_foreach] = ACTIONS(697),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [117] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2220),
    [sym_variable_declaration] = STATE(9437),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6809),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2268),
    [sym_break_statement] = STATE(2220),
    [sym_checked_statement] = STATE(2220),
    [sym_continue_statement] = STATE(2220),
    [sym_do_statement] = STATE(2220),
    [sym_empty_statement] = STATE(2220),
    [sym_expression_statement] = STATE(2220),
    [sym_fixed_statement] = STATE(2220),
    [sym_for_statement] = STATE(2220),
    [sym_return_statement] = STATE(2220),
    [sym_lock_statement] = STATE(2220),
    [sym_yield_statement] = STATE(2220),
    [sym_switch_statement] = STATE(2220),
    [sym_throw_statement] = STATE(2220),
    [sym_try_statement] = STATE(2220),
    [sym_unsafe_statement] = STATE(2220),
    [sym_using_statement] = STATE(2220),
    [sym_foreach_statement] = STATE(2220),
    [sym_goto_statement] = STATE(2220),
    [sym_labeled_statement] = STATE(2220),
    [sym_if_statement] = STATE(2220),
    [sym_while_statement] = STATE(2220),
    [sym_local_declaration_statement] = STATE(2220),
    [sym_local_function_statement] = STATE(2220),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6150),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2819),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2220),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(117),
    [sym_preproc_endregion] = STATE(117),
    [sym_preproc_line] = STATE(117),
    [sym_preproc_pragma] = STATE(117),
    [sym_preproc_nullable] = STATE(117),
    [sym_preproc_error] = STATE(117),
    [sym_preproc_define] = STATE(117),
    [sym_preproc_undef] = STATE(117),
    [aux_sym_class_declaration_repeat1] = STATE(2924),
    [aux_sym_class_declaration_repeat2] = STATE(3080),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(155),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1025),
    [anon_sym_unsafe] = ACTIONS(1027),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(165),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(177),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(1029),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(187),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(189),
    [anon_sym_unchecked] = ACTIONS(187),
    [anon_sym_continue] = ACTIONS(191),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_while] = ACTIONS(195),
    [anon_sym_for] = ACTIONS(197),
    [anon_sym_lock] = ACTIONS(199),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(205),
    [anon_sym_try] = ACTIONS(207),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(209),
    [anon_sym_foreach] = ACTIONS(211),
    [anon_sym_goto] = ACTIONS(213),
    [anon_sym_if] = ACTIONS(215),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(217),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [118] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(8872),
    [sym_variable_declaration] = STATE(9850),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6801),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(8726),
    [sym_break_statement] = STATE(8872),
    [sym_checked_statement] = STATE(8872),
    [sym_continue_statement] = STATE(8872),
    [sym_do_statement] = STATE(8872),
    [sym_empty_statement] = STATE(8872),
    [sym_expression_statement] = STATE(8872),
    [sym_fixed_statement] = STATE(8872),
    [sym_for_statement] = STATE(8872),
    [sym_return_statement] = STATE(8872),
    [sym_lock_statement] = STATE(8872),
    [sym_yield_statement] = STATE(8872),
    [sym_switch_statement] = STATE(8872),
    [sym_throw_statement] = STATE(8872),
    [sym_try_statement] = STATE(8872),
    [sym_unsafe_statement] = STATE(8872),
    [sym_using_statement] = STATE(8872),
    [sym_foreach_statement] = STATE(8872),
    [sym_goto_statement] = STATE(8872),
    [sym_labeled_statement] = STATE(8872),
    [sym_if_statement] = STATE(8872),
    [sym_while_statement] = STATE(8872),
    [sym_local_declaration_statement] = STATE(8872),
    [sym_local_function_statement] = STATE(8872),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6718),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2890),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(8872),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(118),
    [sym_preproc_endregion] = STATE(118),
    [sym_preproc_line] = STATE(118),
    [sym_preproc_pragma] = STATE(118),
    [sym_preproc_nullable] = STATE(118),
    [sym_preproc_error] = STATE(118),
    [sym_preproc_define] = STATE(118),
    [sym_preproc_undef] = STATE(118),
    [aux_sym_class_declaration_repeat1] = STATE(2909),
    [aux_sym_class_declaration_repeat2] = STATE(3101),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(981),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(983),
    [anon_sym_unsafe] = ACTIONS(985),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(987),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(989),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(991),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(993),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(995),
    [anon_sym_unchecked] = ACTIONS(993),
    [anon_sym_continue] = ACTIONS(997),
    [anon_sym_do] = ACTIONS(999),
    [anon_sym_while] = ACTIONS(1001),
    [anon_sym_for] = ACTIONS(1003),
    [anon_sym_lock] = ACTIONS(1005),
    [anon_sym_yield] = ACTIONS(1007),
    [anon_sym_switch] = ACTIONS(1009),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1011),
    [anon_sym_try] = ACTIONS(1013),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1015),
    [anon_sym_foreach] = ACTIONS(1017),
    [anon_sym_goto] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(1021),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1023),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [119] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(8872),
    [sym_variable_declaration] = STATE(9850),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6801),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(8728),
    [sym_break_statement] = STATE(8872),
    [sym_checked_statement] = STATE(8872),
    [sym_continue_statement] = STATE(8872),
    [sym_do_statement] = STATE(8872),
    [sym_empty_statement] = STATE(8872),
    [sym_expression_statement] = STATE(8872),
    [sym_fixed_statement] = STATE(8872),
    [sym_for_statement] = STATE(8872),
    [sym_return_statement] = STATE(8872),
    [sym_lock_statement] = STATE(8872),
    [sym_yield_statement] = STATE(8872),
    [sym_switch_statement] = STATE(8872),
    [sym_throw_statement] = STATE(8872),
    [sym_try_statement] = STATE(8872),
    [sym_unsafe_statement] = STATE(8872),
    [sym_using_statement] = STATE(8872),
    [sym_foreach_statement] = STATE(8872),
    [sym_goto_statement] = STATE(8872),
    [sym_labeled_statement] = STATE(8872),
    [sym_if_statement] = STATE(8872),
    [sym_while_statement] = STATE(8872),
    [sym_local_declaration_statement] = STATE(8872),
    [sym_local_function_statement] = STATE(8872),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6718),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2890),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(8872),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(119),
    [sym_preproc_endregion] = STATE(119),
    [sym_preproc_line] = STATE(119),
    [sym_preproc_pragma] = STATE(119),
    [sym_preproc_nullable] = STATE(119),
    [sym_preproc_error] = STATE(119),
    [sym_preproc_define] = STATE(119),
    [sym_preproc_undef] = STATE(119),
    [aux_sym_class_declaration_repeat1] = STATE(2909),
    [aux_sym_class_declaration_repeat2] = STATE(3101),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(981),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(983),
    [anon_sym_unsafe] = ACTIONS(985),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(987),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(989),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(991),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(993),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(995),
    [anon_sym_unchecked] = ACTIONS(993),
    [anon_sym_continue] = ACTIONS(997),
    [anon_sym_do] = ACTIONS(999),
    [anon_sym_while] = ACTIONS(1001),
    [anon_sym_for] = ACTIONS(1003),
    [anon_sym_lock] = ACTIONS(1005),
    [anon_sym_yield] = ACTIONS(1007),
    [anon_sym_switch] = ACTIONS(1009),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1011),
    [anon_sym_try] = ACTIONS(1013),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1015),
    [anon_sym_foreach] = ACTIONS(1017),
    [anon_sym_goto] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(1021),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1023),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [120] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2647),
    [sym_variable_declaration] = STATE(9394),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6827),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2719),
    [sym_break_statement] = STATE(2647),
    [sym_checked_statement] = STATE(2647),
    [sym_continue_statement] = STATE(2647),
    [sym_do_statement] = STATE(2647),
    [sym_empty_statement] = STATE(2647),
    [sym_expression_statement] = STATE(2647),
    [sym_fixed_statement] = STATE(2647),
    [sym_for_statement] = STATE(2647),
    [sym_return_statement] = STATE(2647),
    [sym_lock_statement] = STATE(2647),
    [sym_yield_statement] = STATE(2647),
    [sym_switch_statement] = STATE(2647),
    [sym_throw_statement] = STATE(2647),
    [sym_try_statement] = STATE(2647),
    [sym_unsafe_statement] = STATE(2647),
    [sym_using_statement] = STATE(2647),
    [sym_foreach_statement] = STATE(2647),
    [sym_goto_statement] = STATE(2647),
    [sym_labeled_statement] = STATE(2647),
    [sym_if_statement] = STATE(2647),
    [sym_while_statement] = STATE(2647),
    [sym_local_declaration_statement] = STATE(2647),
    [sym_local_function_statement] = STATE(2647),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6543),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2835),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2647),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(120),
    [sym_preproc_endregion] = STATE(120),
    [sym_preproc_line] = STATE(120),
    [sym_preproc_pragma] = STATE(120),
    [sym_preproc_nullable] = STATE(120),
    [sym_preproc_error] = STATE(120),
    [sym_preproc_define] = STATE(120),
    [sym_preproc_undef] = STATE(120),
    [aux_sym_class_declaration_repeat1] = STATE(2918),
    [aux_sym_class_declaration_repeat2] = STATE(3106),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(647),
    [anon_sym_unsafe] = ACTIONS(649),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(655),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(659),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(667),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(671),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(673),
    [anon_sym_unchecked] = ACTIONS(671),
    [anon_sym_continue] = ACTIONS(675),
    [anon_sym_do] = ACTIONS(677),
    [anon_sym_while] = ACTIONS(679),
    [anon_sym_for] = ACTIONS(681),
    [anon_sym_lock] = ACTIONS(683),
    [anon_sym_yield] = ACTIONS(685),
    [anon_sym_switch] = ACTIONS(687),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_try] = ACTIONS(693),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(695),
    [anon_sym_foreach] = ACTIONS(697),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [121] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(8872),
    [sym_variable_declaration] = STATE(9850),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6801),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(8729),
    [sym_break_statement] = STATE(8872),
    [sym_checked_statement] = STATE(8872),
    [sym_continue_statement] = STATE(8872),
    [sym_do_statement] = STATE(8872),
    [sym_empty_statement] = STATE(8872),
    [sym_expression_statement] = STATE(8872),
    [sym_fixed_statement] = STATE(8872),
    [sym_for_statement] = STATE(8872),
    [sym_return_statement] = STATE(8872),
    [sym_lock_statement] = STATE(8872),
    [sym_yield_statement] = STATE(8872),
    [sym_switch_statement] = STATE(8872),
    [sym_throw_statement] = STATE(8872),
    [sym_try_statement] = STATE(8872),
    [sym_unsafe_statement] = STATE(8872),
    [sym_using_statement] = STATE(8872),
    [sym_foreach_statement] = STATE(8872),
    [sym_goto_statement] = STATE(8872),
    [sym_labeled_statement] = STATE(8872),
    [sym_if_statement] = STATE(8872),
    [sym_while_statement] = STATE(8872),
    [sym_local_declaration_statement] = STATE(8872),
    [sym_local_function_statement] = STATE(8872),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6718),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2890),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(8872),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(121),
    [sym_preproc_endregion] = STATE(121),
    [sym_preproc_line] = STATE(121),
    [sym_preproc_pragma] = STATE(121),
    [sym_preproc_nullable] = STATE(121),
    [sym_preproc_error] = STATE(121),
    [sym_preproc_define] = STATE(121),
    [sym_preproc_undef] = STATE(121),
    [aux_sym_class_declaration_repeat1] = STATE(2909),
    [aux_sym_class_declaration_repeat2] = STATE(3101),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(981),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(983),
    [anon_sym_unsafe] = ACTIONS(985),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(987),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(989),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(991),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(993),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(995),
    [anon_sym_unchecked] = ACTIONS(993),
    [anon_sym_continue] = ACTIONS(997),
    [anon_sym_do] = ACTIONS(999),
    [anon_sym_while] = ACTIONS(1001),
    [anon_sym_for] = ACTIONS(1003),
    [anon_sym_lock] = ACTIONS(1005),
    [anon_sym_yield] = ACTIONS(1007),
    [anon_sym_switch] = ACTIONS(1009),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1011),
    [anon_sym_try] = ACTIONS(1013),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1015),
    [anon_sym_foreach] = ACTIONS(1017),
    [anon_sym_goto] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(1021),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1023),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [122] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2647),
    [sym_variable_declaration] = STATE(9394),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6827),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2683),
    [sym_break_statement] = STATE(2647),
    [sym_checked_statement] = STATE(2647),
    [sym_continue_statement] = STATE(2647),
    [sym_do_statement] = STATE(2647),
    [sym_empty_statement] = STATE(2647),
    [sym_expression_statement] = STATE(2647),
    [sym_fixed_statement] = STATE(2647),
    [sym_for_statement] = STATE(2647),
    [sym_return_statement] = STATE(2647),
    [sym_lock_statement] = STATE(2647),
    [sym_yield_statement] = STATE(2647),
    [sym_switch_statement] = STATE(2647),
    [sym_throw_statement] = STATE(2647),
    [sym_try_statement] = STATE(2647),
    [sym_unsafe_statement] = STATE(2647),
    [sym_using_statement] = STATE(2647),
    [sym_foreach_statement] = STATE(2647),
    [sym_goto_statement] = STATE(2647),
    [sym_labeled_statement] = STATE(2647),
    [sym_if_statement] = STATE(2647),
    [sym_while_statement] = STATE(2647),
    [sym_local_declaration_statement] = STATE(2647),
    [sym_local_function_statement] = STATE(2647),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6543),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2835),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2647),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(122),
    [sym_preproc_endregion] = STATE(122),
    [sym_preproc_line] = STATE(122),
    [sym_preproc_pragma] = STATE(122),
    [sym_preproc_nullable] = STATE(122),
    [sym_preproc_error] = STATE(122),
    [sym_preproc_define] = STATE(122),
    [sym_preproc_undef] = STATE(122),
    [aux_sym_class_declaration_repeat1] = STATE(2918),
    [aux_sym_class_declaration_repeat2] = STATE(3106),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(647),
    [anon_sym_unsafe] = ACTIONS(649),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(655),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(659),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(667),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(671),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(673),
    [anon_sym_unchecked] = ACTIONS(671),
    [anon_sym_continue] = ACTIONS(675),
    [anon_sym_do] = ACTIONS(677),
    [anon_sym_while] = ACTIONS(679),
    [anon_sym_for] = ACTIONS(681),
    [anon_sym_lock] = ACTIONS(683),
    [anon_sym_yield] = ACTIONS(685),
    [anon_sym_switch] = ACTIONS(687),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_try] = ACTIONS(693),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(695),
    [anon_sym_foreach] = ACTIONS(697),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [123] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2478),
    [sym_variable_declaration] = STATE(9764),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6873),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2488),
    [sym_break_statement] = STATE(2478),
    [sym_checked_statement] = STATE(2478),
    [sym_continue_statement] = STATE(2478),
    [sym_do_statement] = STATE(2478),
    [sym_empty_statement] = STATE(2478),
    [sym_expression_statement] = STATE(2478),
    [sym_fixed_statement] = STATE(2478),
    [sym_for_statement] = STATE(2478),
    [sym_return_statement] = STATE(2478),
    [sym_lock_statement] = STATE(2478),
    [sym_yield_statement] = STATE(2478),
    [sym_switch_statement] = STATE(2478),
    [sym_throw_statement] = STATE(2478),
    [sym_try_statement] = STATE(2478),
    [sym_unsafe_statement] = STATE(2478),
    [sym_using_statement] = STATE(2478),
    [sym_foreach_statement] = STATE(2478),
    [sym_goto_statement] = STATE(2478),
    [sym_labeled_statement] = STATE(2478),
    [sym_if_statement] = STATE(2478),
    [sym_while_statement] = STATE(2478),
    [sym_local_declaration_statement] = STATE(2478),
    [sym_local_function_statement] = STATE(2478),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6724),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2900),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2478),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(123),
    [sym_preproc_endregion] = STATE(123),
    [sym_preproc_line] = STATE(123),
    [sym_preproc_pragma] = STATE(123),
    [sym_preproc_nullable] = STATE(123),
    [sym_preproc_error] = STATE(123),
    [sym_preproc_define] = STATE(123),
    [sym_preproc_undef] = STATE(123),
    [aux_sym_class_declaration_repeat1] = STATE(2921),
    [aux_sym_class_declaration_repeat2] = STATE(3105),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1031),
    [anon_sym_unsafe] = ACTIONS(1033),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(1035),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(71),
    [anon_sym_continue] = ACTIONS(91),
    [anon_sym_do] = ACTIONS(93),
    [anon_sym_while] = ACTIONS(95),
    [anon_sym_for] = ACTIONS(97),
    [anon_sym_lock] = ACTIONS(99),
    [anon_sym_yield] = ACTIONS(101),
    [anon_sym_switch] = ACTIONS(103),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(107),
    [anon_sym_try] = ACTIONS(109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(111),
    [anon_sym_foreach] = ACTIONS(113),
    [anon_sym_goto] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(143),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [124] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(8872),
    [sym_variable_declaration] = STATE(9850),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6801),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(9659),
    [sym_break_statement] = STATE(8872),
    [sym_checked_statement] = STATE(8872),
    [sym_continue_statement] = STATE(8872),
    [sym_do_statement] = STATE(8872),
    [sym_empty_statement] = STATE(8872),
    [sym_expression_statement] = STATE(8872),
    [sym_fixed_statement] = STATE(8872),
    [sym_for_statement] = STATE(8872),
    [sym_return_statement] = STATE(8872),
    [sym_lock_statement] = STATE(8872),
    [sym_yield_statement] = STATE(8872),
    [sym_switch_statement] = STATE(8872),
    [sym_throw_statement] = STATE(8872),
    [sym_try_statement] = STATE(8872),
    [sym_unsafe_statement] = STATE(8872),
    [sym_using_statement] = STATE(8872),
    [sym_foreach_statement] = STATE(8872),
    [sym_goto_statement] = STATE(8872),
    [sym_labeled_statement] = STATE(8872),
    [sym_if_statement] = STATE(8872),
    [sym_while_statement] = STATE(8872),
    [sym_local_declaration_statement] = STATE(8872),
    [sym_local_function_statement] = STATE(8872),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6718),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2890),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(8872),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(124),
    [sym_preproc_endregion] = STATE(124),
    [sym_preproc_line] = STATE(124),
    [sym_preproc_pragma] = STATE(124),
    [sym_preproc_nullable] = STATE(124),
    [sym_preproc_error] = STATE(124),
    [sym_preproc_define] = STATE(124),
    [sym_preproc_undef] = STATE(124),
    [aux_sym_class_declaration_repeat1] = STATE(2909),
    [aux_sym_class_declaration_repeat2] = STATE(3101),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(981),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(983),
    [anon_sym_unsafe] = ACTIONS(985),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(987),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(989),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(991),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(993),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(995),
    [anon_sym_unchecked] = ACTIONS(993),
    [anon_sym_continue] = ACTIONS(997),
    [anon_sym_do] = ACTIONS(999),
    [anon_sym_while] = ACTIONS(1001),
    [anon_sym_for] = ACTIONS(1003),
    [anon_sym_lock] = ACTIONS(1005),
    [anon_sym_yield] = ACTIONS(1007),
    [anon_sym_switch] = ACTIONS(1009),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1011),
    [anon_sym_try] = ACTIONS(1013),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1015),
    [anon_sym_foreach] = ACTIONS(1017),
    [anon_sym_goto] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(1021),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1023),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [125] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2647),
    [sym_variable_declaration] = STATE(9394),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6827),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2718),
    [sym_break_statement] = STATE(2647),
    [sym_checked_statement] = STATE(2647),
    [sym_continue_statement] = STATE(2647),
    [sym_do_statement] = STATE(2647),
    [sym_empty_statement] = STATE(2647),
    [sym_expression_statement] = STATE(2647),
    [sym_fixed_statement] = STATE(2647),
    [sym_for_statement] = STATE(2647),
    [sym_return_statement] = STATE(2647),
    [sym_lock_statement] = STATE(2647),
    [sym_yield_statement] = STATE(2647),
    [sym_switch_statement] = STATE(2647),
    [sym_throw_statement] = STATE(2647),
    [sym_try_statement] = STATE(2647),
    [sym_unsafe_statement] = STATE(2647),
    [sym_using_statement] = STATE(2647),
    [sym_foreach_statement] = STATE(2647),
    [sym_goto_statement] = STATE(2647),
    [sym_labeled_statement] = STATE(2647),
    [sym_if_statement] = STATE(2647),
    [sym_while_statement] = STATE(2647),
    [sym_local_declaration_statement] = STATE(2647),
    [sym_local_function_statement] = STATE(2647),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6543),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2835),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2647),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(125),
    [sym_preproc_endregion] = STATE(125),
    [sym_preproc_line] = STATE(125),
    [sym_preproc_pragma] = STATE(125),
    [sym_preproc_nullable] = STATE(125),
    [sym_preproc_error] = STATE(125),
    [sym_preproc_define] = STATE(125),
    [sym_preproc_undef] = STATE(125),
    [aux_sym_class_declaration_repeat1] = STATE(2918),
    [aux_sym_class_declaration_repeat2] = STATE(3106),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(647),
    [anon_sym_unsafe] = ACTIONS(649),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(655),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(659),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(667),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(671),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(673),
    [anon_sym_unchecked] = ACTIONS(671),
    [anon_sym_continue] = ACTIONS(675),
    [anon_sym_do] = ACTIONS(677),
    [anon_sym_while] = ACTIONS(679),
    [anon_sym_for] = ACTIONS(681),
    [anon_sym_lock] = ACTIONS(683),
    [anon_sym_yield] = ACTIONS(685),
    [anon_sym_switch] = ACTIONS(687),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_try] = ACTIONS(693),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(695),
    [anon_sym_foreach] = ACTIONS(697),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [126] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2647),
    [sym_variable_declaration] = STATE(9394),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6827),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2685),
    [sym_break_statement] = STATE(2647),
    [sym_checked_statement] = STATE(2647),
    [sym_continue_statement] = STATE(2647),
    [sym_do_statement] = STATE(2647),
    [sym_empty_statement] = STATE(2647),
    [sym_expression_statement] = STATE(2647),
    [sym_fixed_statement] = STATE(2647),
    [sym_for_statement] = STATE(2647),
    [sym_return_statement] = STATE(2647),
    [sym_lock_statement] = STATE(2647),
    [sym_yield_statement] = STATE(2647),
    [sym_switch_statement] = STATE(2647),
    [sym_throw_statement] = STATE(2647),
    [sym_try_statement] = STATE(2647),
    [sym_unsafe_statement] = STATE(2647),
    [sym_using_statement] = STATE(2647),
    [sym_foreach_statement] = STATE(2647),
    [sym_goto_statement] = STATE(2647),
    [sym_labeled_statement] = STATE(2647),
    [sym_if_statement] = STATE(2647),
    [sym_while_statement] = STATE(2647),
    [sym_local_declaration_statement] = STATE(2647),
    [sym_local_function_statement] = STATE(2647),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6543),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2835),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2647),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(126),
    [sym_preproc_endregion] = STATE(126),
    [sym_preproc_line] = STATE(126),
    [sym_preproc_pragma] = STATE(126),
    [sym_preproc_nullable] = STATE(126),
    [sym_preproc_error] = STATE(126),
    [sym_preproc_define] = STATE(126),
    [sym_preproc_undef] = STATE(126),
    [aux_sym_class_declaration_repeat1] = STATE(2918),
    [aux_sym_class_declaration_repeat2] = STATE(3106),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(647),
    [anon_sym_unsafe] = ACTIONS(649),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(655),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(659),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(667),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(671),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(673),
    [anon_sym_unchecked] = ACTIONS(671),
    [anon_sym_continue] = ACTIONS(675),
    [anon_sym_do] = ACTIONS(677),
    [anon_sym_while] = ACTIONS(679),
    [anon_sym_for] = ACTIONS(681),
    [anon_sym_lock] = ACTIONS(683),
    [anon_sym_yield] = ACTIONS(685),
    [anon_sym_switch] = ACTIONS(687),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_try] = ACTIONS(693),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(695),
    [anon_sym_foreach] = ACTIONS(697),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [127] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2220),
    [sym_variable_declaration] = STATE(9437),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6809),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2290),
    [sym_break_statement] = STATE(2220),
    [sym_checked_statement] = STATE(2220),
    [sym_continue_statement] = STATE(2220),
    [sym_do_statement] = STATE(2220),
    [sym_empty_statement] = STATE(2220),
    [sym_expression_statement] = STATE(2220),
    [sym_fixed_statement] = STATE(2220),
    [sym_for_statement] = STATE(2220),
    [sym_return_statement] = STATE(2220),
    [sym_lock_statement] = STATE(2220),
    [sym_yield_statement] = STATE(2220),
    [sym_switch_statement] = STATE(2220),
    [sym_throw_statement] = STATE(2220),
    [sym_try_statement] = STATE(2220),
    [sym_unsafe_statement] = STATE(2220),
    [sym_using_statement] = STATE(2220),
    [sym_foreach_statement] = STATE(2220),
    [sym_goto_statement] = STATE(2220),
    [sym_labeled_statement] = STATE(2220),
    [sym_if_statement] = STATE(2220),
    [sym_while_statement] = STATE(2220),
    [sym_local_declaration_statement] = STATE(2220),
    [sym_local_function_statement] = STATE(2220),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6150),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2819),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2220),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(127),
    [sym_preproc_endregion] = STATE(127),
    [sym_preproc_line] = STATE(127),
    [sym_preproc_pragma] = STATE(127),
    [sym_preproc_nullable] = STATE(127),
    [sym_preproc_error] = STATE(127),
    [sym_preproc_define] = STATE(127),
    [sym_preproc_undef] = STATE(127),
    [aux_sym_class_declaration_repeat1] = STATE(2924),
    [aux_sym_class_declaration_repeat2] = STATE(3080),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(155),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1025),
    [anon_sym_unsafe] = ACTIONS(1027),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(165),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(177),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(1029),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(187),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(189),
    [anon_sym_unchecked] = ACTIONS(187),
    [anon_sym_continue] = ACTIONS(191),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_while] = ACTIONS(195),
    [anon_sym_for] = ACTIONS(197),
    [anon_sym_lock] = ACTIONS(199),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(205),
    [anon_sym_try] = ACTIONS(207),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(209),
    [anon_sym_foreach] = ACTIONS(211),
    [anon_sym_goto] = ACTIONS(213),
    [anon_sym_if] = ACTIONS(215),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(217),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [128] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(8872),
    [sym_variable_declaration] = STATE(9850),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6801),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(8734),
    [sym_break_statement] = STATE(8872),
    [sym_checked_statement] = STATE(8872),
    [sym_continue_statement] = STATE(8872),
    [sym_do_statement] = STATE(8872),
    [sym_empty_statement] = STATE(8872),
    [sym_expression_statement] = STATE(8872),
    [sym_fixed_statement] = STATE(8872),
    [sym_for_statement] = STATE(8872),
    [sym_return_statement] = STATE(8872),
    [sym_lock_statement] = STATE(8872),
    [sym_yield_statement] = STATE(8872),
    [sym_switch_statement] = STATE(8872),
    [sym_throw_statement] = STATE(8872),
    [sym_try_statement] = STATE(8872),
    [sym_unsafe_statement] = STATE(8872),
    [sym_using_statement] = STATE(8872),
    [sym_foreach_statement] = STATE(8872),
    [sym_goto_statement] = STATE(8872),
    [sym_labeled_statement] = STATE(8872),
    [sym_if_statement] = STATE(8872),
    [sym_while_statement] = STATE(8872),
    [sym_local_declaration_statement] = STATE(8872),
    [sym_local_function_statement] = STATE(8872),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6718),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2890),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(8872),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(128),
    [sym_preproc_endregion] = STATE(128),
    [sym_preproc_line] = STATE(128),
    [sym_preproc_pragma] = STATE(128),
    [sym_preproc_nullable] = STATE(128),
    [sym_preproc_error] = STATE(128),
    [sym_preproc_define] = STATE(128),
    [sym_preproc_undef] = STATE(128),
    [aux_sym_class_declaration_repeat1] = STATE(2909),
    [aux_sym_class_declaration_repeat2] = STATE(3101),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(981),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(983),
    [anon_sym_unsafe] = ACTIONS(985),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(987),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(989),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(991),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(993),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(995),
    [anon_sym_unchecked] = ACTIONS(993),
    [anon_sym_continue] = ACTIONS(997),
    [anon_sym_do] = ACTIONS(999),
    [anon_sym_while] = ACTIONS(1001),
    [anon_sym_for] = ACTIONS(1003),
    [anon_sym_lock] = ACTIONS(1005),
    [anon_sym_yield] = ACTIONS(1007),
    [anon_sym_switch] = ACTIONS(1009),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1011),
    [anon_sym_try] = ACTIONS(1013),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1015),
    [anon_sym_foreach] = ACTIONS(1017),
    [anon_sym_goto] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(1021),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1023),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [129] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2647),
    [sym_variable_declaration] = STATE(9394),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6827),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2707),
    [sym_break_statement] = STATE(2647),
    [sym_checked_statement] = STATE(2647),
    [sym_continue_statement] = STATE(2647),
    [sym_do_statement] = STATE(2647),
    [sym_empty_statement] = STATE(2647),
    [sym_expression_statement] = STATE(2647),
    [sym_fixed_statement] = STATE(2647),
    [sym_for_statement] = STATE(2647),
    [sym_return_statement] = STATE(2647),
    [sym_lock_statement] = STATE(2647),
    [sym_yield_statement] = STATE(2647),
    [sym_switch_statement] = STATE(2647),
    [sym_throw_statement] = STATE(2647),
    [sym_try_statement] = STATE(2647),
    [sym_unsafe_statement] = STATE(2647),
    [sym_using_statement] = STATE(2647),
    [sym_foreach_statement] = STATE(2647),
    [sym_goto_statement] = STATE(2647),
    [sym_labeled_statement] = STATE(2647),
    [sym_if_statement] = STATE(2647),
    [sym_while_statement] = STATE(2647),
    [sym_local_declaration_statement] = STATE(2647),
    [sym_local_function_statement] = STATE(2647),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6543),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2835),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2647),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(129),
    [sym_preproc_endregion] = STATE(129),
    [sym_preproc_line] = STATE(129),
    [sym_preproc_pragma] = STATE(129),
    [sym_preproc_nullable] = STATE(129),
    [sym_preproc_error] = STATE(129),
    [sym_preproc_define] = STATE(129),
    [sym_preproc_undef] = STATE(129),
    [aux_sym_class_declaration_repeat1] = STATE(2918),
    [aux_sym_class_declaration_repeat2] = STATE(3106),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(647),
    [anon_sym_unsafe] = ACTIONS(649),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(655),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(659),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(667),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(671),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(673),
    [anon_sym_unchecked] = ACTIONS(671),
    [anon_sym_continue] = ACTIONS(675),
    [anon_sym_do] = ACTIONS(677),
    [anon_sym_while] = ACTIONS(679),
    [anon_sym_for] = ACTIONS(681),
    [anon_sym_lock] = ACTIONS(683),
    [anon_sym_yield] = ACTIONS(685),
    [anon_sym_switch] = ACTIONS(687),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_try] = ACTIONS(693),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(695),
    [anon_sym_foreach] = ACTIONS(697),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [130] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(8872),
    [sym_variable_declaration] = STATE(9850),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6801),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(8735),
    [sym_break_statement] = STATE(8872),
    [sym_checked_statement] = STATE(8872),
    [sym_continue_statement] = STATE(8872),
    [sym_do_statement] = STATE(8872),
    [sym_empty_statement] = STATE(8872),
    [sym_expression_statement] = STATE(8872),
    [sym_fixed_statement] = STATE(8872),
    [sym_for_statement] = STATE(8872),
    [sym_return_statement] = STATE(8872),
    [sym_lock_statement] = STATE(8872),
    [sym_yield_statement] = STATE(8872),
    [sym_switch_statement] = STATE(8872),
    [sym_throw_statement] = STATE(8872),
    [sym_try_statement] = STATE(8872),
    [sym_unsafe_statement] = STATE(8872),
    [sym_using_statement] = STATE(8872),
    [sym_foreach_statement] = STATE(8872),
    [sym_goto_statement] = STATE(8872),
    [sym_labeled_statement] = STATE(8872),
    [sym_if_statement] = STATE(8872),
    [sym_while_statement] = STATE(8872),
    [sym_local_declaration_statement] = STATE(8872),
    [sym_local_function_statement] = STATE(8872),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6718),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2890),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(8872),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(130),
    [sym_preproc_endregion] = STATE(130),
    [sym_preproc_line] = STATE(130),
    [sym_preproc_pragma] = STATE(130),
    [sym_preproc_nullable] = STATE(130),
    [sym_preproc_error] = STATE(130),
    [sym_preproc_define] = STATE(130),
    [sym_preproc_undef] = STATE(130),
    [aux_sym_class_declaration_repeat1] = STATE(2909),
    [aux_sym_class_declaration_repeat2] = STATE(3101),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(981),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(983),
    [anon_sym_unsafe] = ACTIONS(985),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(987),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(989),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(991),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(993),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(995),
    [anon_sym_unchecked] = ACTIONS(993),
    [anon_sym_continue] = ACTIONS(997),
    [anon_sym_do] = ACTIONS(999),
    [anon_sym_while] = ACTIONS(1001),
    [anon_sym_for] = ACTIONS(1003),
    [anon_sym_lock] = ACTIONS(1005),
    [anon_sym_yield] = ACTIONS(1007),
    [anon_sym_switch] = ACTIONS(1009),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1011),
    [anon_sym_try] = ACTIONS(1013),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1015),
    [anon_sym_foreach] = ACTIONS(1017),
    [anon_sym_goto] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(1021),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1023),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [131] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(8872),
    [sym_variable_declaration] = STATE(9850),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6801),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(8701),
    [sym_break_statement] = STATE(8872),
    [sym_checked_statement] = STATE(8872),
    [sym_continue_statement] = STATE(8872),
    [sym_do_statement] = STATE(8872),
    [sym_empty_statement] = STATE(8872),
    [sym_expression_statement] = STATE(8872),
    [sym_fixed_statement] = STATE(8872),
    [sym_for_statement] = STATE(8872),
    [sym_return_statement] = STATE(8872),
    [sym_lock_statement] = STATE(8872),
    [sym_yield_statement] = STATE(8872),
    [sym_switch_statement] = STATE(8872),
    [sym_throw_statement] = STATE(8872),
    [sym_try_statement] = STATE(8872),
    [sym_unsafe_statement] = STATE(8872),
    [sym_using_statement] = STATE(8872),
    [sym_foreach_statement] = STATE(8872),
    [sym_goto_statement] = STATE(8872),
    [sym_labeled_statement] = STATE(8872),
    [sym_if_statement] = STATE(8872),
    [sym_while_statement] = STATE(8872),
    [sym_local_declaration_statement] = STATE(8872),
    [sym_local_function_statement] = STATE(8872),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6718),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2890),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(8872),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(131),
    [sym_preproc_endregion] = STATE(131),
    [sym_preproc_line] = STATE(131),
    [sym_preproc_pragma] = STATE(131),
    [sym_preproc_nullable] = STATE(131),
    [sym_preproc_error] = STATE(131),
    [sym_preproc_define] = STATE(131),
    [sym_preproc_undef] = STATE(131),
    [aux_sym_class_declaration_repeat1] = STATE(2909),
    [aux_sym_class_declaration_repeat2] = STATE(3101),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(981),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(983),
    [anon_sym_unsafe] = ACTIONS(985),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(987),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(989),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(991),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(993),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(995),
    [anon_sym_unchecked] = ACTIONS(993),
    [anon_sym_continue] = ACTIONS(997),
    [anon_sym_do] = ACTIONS(999),
    [anon_sym_while] = ACTIONS(1001),
    [anon_sym_for] = ACTIONS(1003),
    [anon_sym_lock] = ACTIONS(1005),
    [anon_sym_yield] = ACTIONS(1007),
    [anon_sym_switch] = ACTIONS(1009),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1011),
    [anon_sym_try] = ACTIONS(1013),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1015),
    [anon_sym_foreach] = ACTIONS(1017),
    [anon_sym_goto] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(1021),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1023),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [132] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(8872),
    [sym_variable_declaration] = STATE(9850),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6801),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(8737),
    [sym_break_statement] = STATE(8872),
    [sym_checked_statement] = STATE(8872),
    [sym_continue_statement] = STATE(8872),
    [sym_do_statement] = STATE(8872),
    [sym_empty_statement] = STATE(8872),
    [sym_expression_statement] = STATE(8872),
    [sym_fixed_statement] = STATE(8872),
    [sym_for_statement] = STATE(8872),
    [sym_return_statement] = STATE(8872),
    [sym_lock_statement] = STATE(8872),
    [sym_yield_statement] = STATE(8872),
    [sym_switch_statement] = STATE(8872),
    [sym_throw_statement] = STATE(8872),
    [sym_try_statement] = STATE(8872),
    [sym_unsafe_statement] = STATE(8872),
    [sym_using_statement] = STATE(8872),
    [sym_foreach_statement] = STATE(8872),
    [sym_goto_statement] = STATE(8872),
    [sym_labeled_statement] = STATE(8872),
    [sym_if_statement] = STATE(8872),
    [sym_while_statement] = STATE(8872),
    [sym_local_declaration_statement] = STATE(8872),
    [sym_local_function_statement] = STATE(8872),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6718),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2890),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(8872),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(132),
    [sym_preproc_endregion] = STATE(132),
    [sym_preproc_line] = STATE(132),
    [sym_preproc_pragma] = STATE(132),
    [sym_preproc_nullable] = STATE(132),
    [sym_preproc_error] = STATE(132),
    [sym_preproc_define] = STATE(132),
    [sym_preproc_undef] = STATE(132),
    [aux_sym_class_declaration_repeat1] = STATE(2909),
    [aux_sym_class_declaration_repeat2] = STATE(3101),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(981),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(983),
    [anon_sym_unsafe] = ACTIONS(985),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(987),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(989),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(991),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(993),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(995),
    [anon_sym_unchecked] = ACTIONS(993),
    [anon_sym_continue] = ACTIONS(997),
    [anon_sym_do] = ACTIONS(999),
    [anon_sym_while] = ACTIONS(1001),
    [anon_sym_for] = ACTIONS(1003),
    [anon_sym_lock] = ACTIONS(1005),
    [anon_sym_yield] = ACTIONS(1007),
    [anon_sym_switch] = ACTIONS(1009),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1011),
    [anon_sym_try] = ACTIONS(1013),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1015),
    [anon_sym_foreach] = ACTIONS(1017),
    [anon_sym_goto] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(1021),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1023),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [133] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2647),
    [sym_variable_declaration] = STATE(9394),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6827),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2713),
    [sym_break_statement] = STATE(2647),
    [sym_checked_statement] = STATE(2647),
    [sym_continue_statement] = STATE(2647),
    [sym_do_statement] = STATE(2647),
    [sym_empty_statement] = STATE(2647),
    [sym_expression_statement] = STATE(2647),
    [sym_fixed_statement] = STATE(2647),
    [sym_for_statement] = STATE(2647),
    [sym_return_statement] = STATE(2647),
    [sym_lock_statement] = STATE(2647),
    [sym_yield_statement] = STATE(2647),
    [sym_switch_statement] = STATE(2647),
    [sym_throw_statement] = STATE(2647),
    [sym_try_statement] = STATE(2647),
    [sym_unsafe_statement] = STATE(2647),
    [sym_using_statement] = STATE(2647),
    [sym_foreach_statement] = STATE(2647),
    [sym_goto_statement] = STATE(2647),
    [sym_labeled_statement] = STATE(2647),
    [sym_if_statement] = STATE(2647),
    [sym_while_statement] = STATE(2647),
    [sym_local_declaration_statement] = STATE(2647),
    [sym_local_function_statement] = STATE(2647),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6543),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2835),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2647),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(133),
    [sym_preproc_endregion] = STATE(133),
    [sym_preproc_line] = STATE(133),
    [sym_preproc_pragma] = STATE(133),
    [sym_preproc_nullable] = STATE(133),
    [sym_preproc_error] = STATE(133),
    [sym_preproc_define] = STATE(133),
    [sym_preproc_undef] = STATE(133),
    [aux_sym_class_declaration_repeat1] = STATE(2918),
    [aux_sym_class_declaration_repeat2] = STATE(3106),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(647),
    [anon_sym_unsafe] = ACTIONS(649),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(655),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(659),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(667),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(671),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(673),
    [anon_sym_unchecked] = ACTIONS(671),
    [anon_sym_continue] = ACTIONS(675),
    [anon_sym_do] = ACTIONS(677),
    [anon_sym_while] = ACTIONS(679),
    [anon_sym_for] = ACTIONS(681),
    [anon_sym_lock] = ACTIONS(683),
    [anon_sym_yield] = ACTIONS(685),
    [anon_sym_switch] = ACTIONS(687),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_try] = ACTIONS(693),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(695),
    [anon_sym_foreach] = ACTIONS(697),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [134] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2647),
    [sym_variable_declaration] = STATE(9394),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6827),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2705),
    [sym_break_statement] = STATE(2647),
    [sym_checked_statement] = STATE(2647),
    [sym_continue_statement] = STATE(2647),
    [sym_do_statement] = STATE(2647),
    [sym_empty_statement] = STATE(2647),
    [sym_expression_statement] = STATE(2647),
    [sym_fixed_statement] = STATE(2647),
    [sym_for_statement] = STATE(2647),
    [sym_return_statement] = STATE(2647),
    [sym_lock_statement] = STATE(2647),
    [sym_yield_statement] = STATE(2647),
    [sym_switch_statement] = STATE(2647),
    [sym_throw_statement] = STATE(2647),
    [sym_try_statement] = STATE(2647),
    [sym_unsafe_statement] = STATE(2647),
    [sym_using_statement] = STATE(2647),
    [sym_foreach_statement] = STATE(2647),
    [sym_goto_statement] = STATE(2647),
    [sym_labeled_statement] = STATE(2647),
    [sym_if_statement] = STATE(2647),
    [sym_while_statement] = STATE(2647),
    [sym_local_declaration_statement] = STATE(2647),
    [sym_local_function_statement] = STATE(2647),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6543),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2835),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2647),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(134),
    [sym_preproc_endregion] = STATE(134),
    [sym_preproc_line] = STATE(134),
    [sym_preproc_pragma] = STATE(134),
    [sym_preproc_nullable] = STATE(134),
    [sym_preproc_error] = STATE(134),
    [sym_preproc_define] = STATE(134),
    [sym_preproc_undef] = STATE(134),
    [aux_sym_class_declaration_repeat1] = STATE(2918),
    [aux_sym_class_declaration_repeat2] = STATE(3106),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(647),
    [anon_sym_unsafe] = ACTIONS(649),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(655),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(659),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(667),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(671),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(673),
    [anon_sym_unchecked] = ACTIONS(671),
    [anon_sym_continue] = ACTIONS(675),
    [anon_sym_do] = ACTIONS(677),
    [anon_sym_while] = ACTIONS(679),
    [anon_sym_for] = ACTIONS(681),
    [anon_sym_lock] = ACTIONS(683),
    [anon_sym_yield] = ACTIONS(685),
    [anon_sym_switch] = ACTIONS(687),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_try] = ACTIONS(693),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(695),
    [anon_sym_foreach] = ACTIONS(697),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [135] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2478),
    [sym_variable_declaration] = STATE(9764),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6873),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2437),
    [sym_break_statement] = STATE(2478),
    [sym_checked_statement] = STATE(2478),
    [sym_continue_statement] = STATE(2478),
    [sym_do_statement] = STATE(2478),
    [sym_empty_statement] = STATE(2478),
    [sym_expression_statement] = STATE(2478),
    [sym_fixed_statement] = STATE(2478),
    [sym_for_statement] = STATE(2478),
    [sym_return_statement] = STATE(2478),
    [sym_lock_statement] = STATE(2478),
    [sym_yield_statement] = STATE(2478),
    [sym_switch_statement] = STATE(2478),
    [sym_throw_statement] = STATE(2478),
    [sym_try_statement] = STATE(2478),
    [sym_unsafe_statement] = STATE(2478),
    [sym_using_statement] = STATE(2478),
    [sym_foreach_statement] = STATE(2478),
    [sym_goto_statement] = STATE(2478),
    [sym_labeled_statement] = STATE(2478),
    [sym_if_statement] = STATE(2478),
    [sym_while_statement] = STATE(2478),
    [sym_local_declaration_statement] = STATE(2478),
    [sym_local_function_statement] = STATE(2478),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6724),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2900),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2478),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(135),
    [sym_preproc_endregion] = STATE(135),
    [sym_preproc_line] = STATE(135),
    [sym_preproc_pragma] = STATE(135),
    [sym_preproc_nullable] = STATE(135),
    [sym_preproc_error] = STATE(135),
    [sym_preproc_define] = STATE(135),
    [sym_preproc_undef] = STATE(135),
    [aux_sym_class_declaration_repeat1] = STATE(2921),
    [aux_sym_class_declaration_repeat2] = STATE(3105),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1031),
    [anon_sym_unsafe] = ACTIONS(1033),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(1035),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(71),
    [anon_sym_continue] = ACTIONS(91),
    [anon_sym_do] = ACTIONS(93),
    [anon_sym_while] = ACTIONS(95),
    [anon_sym_for] = ACTIONS(97),
    [anon_sym_lock] = ACTIONS(99),
    [anon_sym_yield] = ACTIONS(101),
    [anon_sym_switch] = ACTIONS(103),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(107),
    [anon_sym_try] = ACTIONS(109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(111),
    [anon_sym_foreach] = ACTIONS(113),
    [anon_sym_goto] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(143),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [136] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2647),
    [sym_variable_declaration] = STATE(9394),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6827),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2711),
    [sym_break_statement] = STATE(2647),
    [sym_checked_statement] = STATE(2647),
    [sym_continue_statement] = STATE(2647),
    [sym_do_statement] = STATE(2647),
    [sym_empty_statement] = STATE(2647),
    [sym_expression_statement] = STATE(2647),
    [sym_fixed_statement] = STATE(2647),
    [sym_for_statement] = STATE(2647),
    [sym_return_statement] = STATE(2647),
    [sym_lock_statement] = STATE(2647),
    [sym_yield_statement] = STATE(2647),
    [sym_switch_statement] = STATE(2647),
    [sym_throw_statement] = STATE(2647),
    [sym_try_statement] = STATE(2647),
    [sym_unsafe_statement] = STATE(2647),
    [sym_using_statement] = STATE(2647),
    [sym_foreach_statement] = STATE(2647),
    [sym_goto_statement] = STATE(2647),
    [sym_labeled_statement] = STATE(2647),
    [sym_if_statement] = STATE(2647),
    [sym_while_statement] = STATE(2647),
    [sym_local_declaration_statement] = STATE(2647),
    [sym_local_function_statement] = STATE(2647),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6543),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2835),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2647),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(136),
    [sym_preproc_endregion] = STATE(136),
    [sym_preproc_line] = STATE(136),
    [sym_preproc_pragma] = STATE(136),
    [sym_preproc_nullable] = STATE(136),
    [sym_preproc_error] = STATE(136),
    [sym_preproc_define] = STATE(136),
    [sym_preproc_undef] = STATE(136),
    [aux_sym_class_declaration_repeat1] = STATE(2918),
    [aux_sym_class_declaration_repeat2] = STATE(3106),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(647),
    [anon_sym_unsafe] = ACTIONS(649),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(655),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(659),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(667),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(671),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(673),
    [anon_sym_unchecked] = ACTIONS(671),
    [anon_sym_continue] = ACTIONS(675),
    [anon_sym_do] = ACTIONS(677),
    [anon_sym_while] = ACTIONS(679),
    [anon_sym_for] = ACTIONS(681),
    [anon_sym_lock] = ACTIONS(683),
    [anon_sym_yield] = ACTIONS(685),
    [anon_sym_switch] = ACTIONS(687),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_try] = ACTIONS(693),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(695),
    [anon_sym_foreach] = ACTIONS(697),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [137] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2220),
    [sym_variable_declaration] = STATE(9437),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6809),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2227),
    [sym_break_statement] = STATE(2220),
    [sym_checked_statement] = STATE(2220),
    [sym_continue_statement] = STATE(2220),
    [sym_do_statement] = STATE(2220),
    [sym_empty_statement] = STATE(2220),
    [sym_expression_statement] = STATE(2220),
    [sym_fixed_statement] = STATE(2220),
    [sym_for_statement] = STATE(2220),
    [sym_return_statement] = STATE(2220),
    [sym_lock_statement] = STATE(2220),
    [sym_yield_statement] = STATE(2220),
    [sym_switch_statement] = STATE(2220),
    [sym_throw_statement] = STATE(2220),
    [sym_try_statement] = STATE(2220),
    [sym_unsafe_statement] = STATE(2220),
    [sym_using_statement] = STATE(2220),
    [sym_foreach_statement] = STATE(2220),
    [sym_goto_statement] = STATE(2220),
    [sym_labeled_statement] = STATE(2220),
    [sym_if_statement] = STATE(2220),
    [sym_while_statement] = STATE(2220),
    [sym_local_declaration_statement] = STATE(2220),
    [sym_local_function_statement] = STATE(2220),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6150),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2819),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2220),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(137),
    [sym_preproc_endregion] = STATE(137),
    [sym_preproc_line] = STATE(137),
    [sym_preproc_pragma] = STATE(137),
    [sym_preproc_nullable] = STATE(137),
    [sym_preproc_error] = STATE(137),
    [sym_preproc_define] = STATE(137),
    [sym_preproc_undef] = STATE(137),
    [aux_sym_class_declaration_repeat1] = STATE(2924),
    [aux_sym_class_declaration_repeat2] = STATE(3080),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(155),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1025),
    [anon_sym_unsafe] = ACTIONS(1027),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(165),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(177),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(1029),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(187),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(189),
    [anon_sym_unchecked] = ACTIONS(187),
    [anon_sym_continue] = ACTIONS(191),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_while] = ACTIONS(195),
    [anon_sym_for] = ACTIONS(197),
    [anon_sym_lock] = ACTIONS(199),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(205),
    [anon_sym_try] = ACTIONS(207),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(209),
    [anon_sym_foreach] = ACTIONS(211),
    [anon_sym_goto] = ACTIONS(213),
    [anon_sym_if] = ACTIONS(215),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(217),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [138] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2220),
    [sym_variable_declaration] = STATE(9437),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6809),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2266),
    [sym_break_statement] = STATE(2220),
    [sym_checked_statement] = STATE(2220),
    [sym_continue_statement] = STATE(2220),
    [sym_do_statement] = STATE(2220),
    [sym_empty_statement] = STATE(2220),
    [sym_expression_statement] = STATE(2220),
    [sym_fixed_statement] = STATE(2220),
    [sym_for_statement] = STATE(2220),
    [sym_return_statement] = STATE(2220),
    [sym_lock_statement] = STATE(2220),
    [sym_yield_statement] = STATE(2220),
    [sym_switch_statement] = STATE(2220),
    [sym_throw_statement] = STATE(2220),
    [sym_try_statement] = STATE(2220),
    [sym_unsafe_statement] = STATE(2220),
    [sym_using_statement] = STATE(2220),
    [sym_foreach_statement] = STATE(2220),
    [sym_goto_statement] = STATE(2220),
    [sym_labeled_statement] = STATE(2220),
    [sym_if_statement] = STATE(2220),
    [sym_while_statement] = STATE(2220),
    [sym_local_declaration_statement] = STATE(2220),
    [sym_local_function_statement] = STATE(2220),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6150),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2819),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2220),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(138),
    [sym_preproc_endregion] = STATE(138),
    [sym_preproc_line] = STATE(138),
    [sym_preproc_pragma] = STATE(138),
    [sym_preproc_nullable] = STATE(138),
    [sym_preproc_error] = STATE(138),
    [sym_preproc_define] = STATE(138),
    [sym_preproc_undef] = STATE(138),
    [aux_sym_class_declaration_repeat1] = STATE(2924),
    [aux_sym_class_declaration_repeat2] = STATE(3080),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(155),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1025),
    [anon_sym_unsafe] = ACTIONS(1027),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(165),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(177),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(1029),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(187),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(189),
    [anon_sym_unchecked] = ACTIONS(187),
    [anon_sym_continue] = ACTIONS(191),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_while] = ACTIONS(195),
    [anon_sym_for] = ACTIONS(197),
    [anon_sym_lock] = ACTIONS(199),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(205),
    [anon_sym_try] = ACTIONS(207),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(209),
    [anon_sym_foreach] = ACTIONS(211),
    [anon_sym_goto] = ACTIONS(213),
    [anon_sym_if] = ACTIONS(215),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(217),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [139] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2220),
    [sym_variable_declaration] = STATE(9437),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6809),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2271),
    [sym_break_statement] = STATE(2220),
    [sym_checked_statement] = STATE(2220),
    [sym_continue_statement] = STATE(2220),
    [sym_do_statement] = STATE(2220),
    [sym_empty_statement] = STATE(2220),
    [sym_expression_statement] = STATE(2220),
    [sym_fixed_statement] = STATE(2220),
    [sym_for_statement] = STATE(2220),
    [sym_return_statement] = STATE(2220),
    [sym_lock_statement] = STATE(2220),
    [sym_yield_statement] = STATE(2220),
    [sym_switch_statement] = STATE(2220),
    [sym_throw_statement] = STATE(2220),
    [sym_try_statement] = STATE(2220),
    [sym_unsafe_statement] = STATE(2220),
    [sym_using_statement] = STATE(2220),
    [sym_foreach_statement] = STATE(2220),
    [sym_goto_statement] = STATE(2220),
    [sym_labeled_statement] = STATE(2220),
    [sym_if_statement] = STATE(2220),
    [sym_while_statement] = STATE(2220),
    [sym_local_declaration_statement] = STATE(2220),
    [sym_local_function_statement] = STATE(2220),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6150),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2819),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2220),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(139),
    [sym_preproc_endregion] = STATE(139),
    [sym_preproc_line] = STATE(139),
    [sym_preproc_pragma] = STATE(139),
    [sym_preproc_nullable] = STATE(139),
    [sym_preproc_error] = STATE(139),
    [sym_preproc_define] = STATE(139),
    [sym_preproc_undef] = STATE(139),
    [aux_sym_class_declaration_repeat1] = STATE(2924),
    [aux_sym_class_declaration_repeat2] = STATE(3080),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(155),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1025),
    [anon_sym_unsafe] = ACTIONS(1027),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(165),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(177),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(1029),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(187),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(189),
    [anon_sym_unchecked] = ACTIONS(187),
    [anon_sym_continue] = ACTIONS(191),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_while] = ACTIONS(195),
    [anon_sym_for] = ACTIONS(197),
    [anon_sym_lock] = ACTIONS(199),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(205),
    [anon_sym_try] = ACTIONS(207),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(209),
    [anon_sym_foreach] = ACTIONS(211),
    [anon_sym_goto] = ACTIONS(213),
    [anon_sym_if] = ACTIONS(215),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(217),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [140] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2220),
    [sym_variable_declaration] = STATE(9437),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6809),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2265),
    [sym_break_statement] = STATE(2220),
    [sym_checked_statement] = STATE(2220),
    [sym_continue_statement] = STATE(2220),
    [sym_do_statement] = STATE(2220),
    [sym_empty_statement] = STATE(2220),
    [sym_expression_statement] = STATE(2220),
    [sym_fixed_statement] = STATE(2220),
    [sym_for_statement] = STATE(2220),
    [sym_return_statement] = STATE(2220),
    [sym_lock_statement] = STATE(2220),
    [sym_yield_statement] = STATE(2220),
    [sym_switch_statement] = STATE(2220),
    [sym_throw_statement] = STATE(2220),
    [sym_try_statement] = STATE(2220),
    [sym_unsafe_statement] = STATE(2220),
    [sym_using_statement] = STATE(2220),
    [sym_foreach_statement] = STATE(2220),
    [sym_goto_statement] = STATE(2220),
    [sym_labeled_statement] = STATE(2220),
    [sym_if_statement] = STATE(2220),
    [sym_while_statement] = STATE(2220),
    [sym_local_declaration_statement] = STATE(2220),
    [sym_local_function_statement] = STATE(2220),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6150),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2819),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2220),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(140),
    [sym_preproc_endregion] = STATE(140),
    [sym_preproc_line] = STATE(140),
    [sym_preproc_pragma] = STATE(140),
    [sym_preproc_nullable] = STATE(140),
    [sym_preproc_error] = STATE(140),
    [sym_preproc_define] = STATE(140),
    [sym_preproc_undef] = STATE(140),
    [aux_sym_class_declaration_repeat1] = STATE(2924),
    [aux_sym_class_declaration_repeat2] = STATE(3080),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(155),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1025),
    [anon_sym_unsafe] = ACTIONS(1027),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(165),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(177),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(1029),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(187),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(189),
    [anon_sym_unchecked] = ACTIONS(187),
    [anon_sym_continue] = ACTIONS(191),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_while] = ACTIONS(195),
    [anon_sym_for] = ACTIONS(197),
    [anon_sym_lock] = ACTIONS(199),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(205),
    [anon_sym_try] = ACTIONS(207),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(209),
    [anon_sym_foreach] = ACTIONS(211),
    [anon_sym_goto] = ACTIONS(213),
    [anon_sym_if] = ACTIONS(215),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(217),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [141] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2647),
    [sym_variable_declaration] = STATE(9394),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6827),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2699),
    [sym_break_statement] = STATE(2647),
    [sym_checked_statement] = STATE(2647),
    [sym_continue_statement] = STATE(2647),
    [sym_do_statement] = STATE(2647),
    [sym_empty_statement] = STATE(2647),
    [sym_expression_statement] = STATE(2647),
    [sym_fixed_statement] = STATE(2647),
    [sym_for_statement] = STATE(2647),
    [sym_return_statement] = STATE(2647),
    [sym_lock_statement] = STATE(2647),
    [sym_yield_statement] = STATE(2647),
    [sym_switch_statement] = STATE(2647),
    [sym_throw_statement] = STATE(2647),
    [sym_try_statement] = STATE(2647),
    [sym_unsafe_statement] = STATE(2647),
    [sym_using_statement] = STATE(2647),
    [sym_foreach_statement] = STATE(2647),
    [sym_goto_statement] = STATE(2647),
    [sym_labeled_statement] = STATE(2647),
    [sym_if_statement] = STATE(2647),
    [sym_while_statement] = STATE(2647),
    [sym_local_declaration_statement] = STATE(2647),
    [sym_local_function_statement] = STATE(2647),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6543),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2835),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2647),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(141),
    [sym_preproc_endregion] = STATE(141),
    [sym_preproc_line] = STATE(141),
    [sym_preproc_pragma] = STATE(141),
    [sym_preproc_nullable] = STATE(141),
    [sym_preproc_error] = STATE(141),
    [sym_preproc_define] = STATE(141),
    [sym_preproc_undef] = STATE(141),
    [aux_sym_class_declaration_repeat1] = STATE(2918),
    [aux_sym_class_declaration_repeat2] = STATE(3106),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(647),
    [anon_sym_unsafe] = ACTIONS(649),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(655),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(659),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(667),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(671),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(673),
    [anon_sym_unchecked] = ACTIONS(671),
    [anon_sym_continue] = ACTIONS(675),
    [anon_sym_do] = ACTIONS(677),
    [anon_sym_while] = ACTIONS(679),
    [anon_sym_for] = ACTIONS(681),
    [anon_sym_lock] = ACTIONS(683),
    [anon_sym_yield] = ACTIONS(685),
    [anon_sym_switch] = ACTIONS(687),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_try] = ACTIONS(693),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(695),
    [anon_sym_foreach] = ACTIONS(697),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [142] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(8872),
    [sym_variable_declaration] = STATE(9850),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6801),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(9404),
    [sym_break_statement] = STATE(8872),
    [sym_checked_statement] = STATE(8872),
    [sym_continue_statement] = STATE(8872),
    [sym_do_statement] = STATE(8872),
    [sym_empty_statement] = STATE(8872),
    [sym_expression_statement] = STATE(8872),
    [sym_fixed_statement] = STATE(8872),
    [sym_for_statement] = STATE(8872),
    [sym_return_statement] = STATE(8872),
    [sym_lock_statement] = STATE(8872),
    [sym_yield_statement] = STATE(8872),
    [sym_switch_statement] = STATE(8872),
    [sym_throw_statement] = STATE(8872),
    [sym_try_statement] = STATE(8872),
    [sym_unsafe_statement] = STATE(8872),
    [sym_using_statement] = STATE(8872),
    [sym_foreach_statement] = STATE(8872),
    [sym_goto_statement] = STATE(8872),
    [sym_labeled_statement] = STATE(8872),
    [sym_if_statement] = STATE(8872),
    [sym_while_statement] = STATE(8872),
    [sym_local_declaration_statement] = STATE(8872),
    [sym_local_function_statement] = STATE(8872),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6718),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2890),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(8872),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(142),
    [sym_preproc_endregion] = STATE(142),
    [sym_preproc_line] = STATE(142),
    [sym_preproc_pragma] = STATE(142),
    [sym_preproc_nullable] = STATE(142),
    [sym_preproc_error] = STATE(142),
    [sym_preproc_define] = STATE(142),
    [sym_preproc_undef] = STATE(142),
    [aux_sym_class_declaration_repeat1] = STATE(2909),
    [aux_sym_class_declaration_repeat2] = STATE(3101),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(981),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(983),
    [anon_sym_unsafe] = ACTIONS(985),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(987),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(989),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(991),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(993),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(995),
    [anon_sym_unchecked] = ACTIONS(993),
    [anon_sym_continue] = ACTIONS(997),
    [anon_sym_do] = ACTIONS(999),
    [anon_sym_while] = ACTIONS(1001),
    [anon_sym_for] = ACTIONS(1003),
    [anon_sym_lock] = ACTIONS(1005),
    [anon_sym_yield] = ACTIONS(1007),
    [anon_sym_switch] = ACTIONS(1009),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1011),
    [anon_sym_try] = ACTIONS(1013),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1015),
    [anon_sym_foreach] = ACTIONS(1017),
    [anon_sym_goto] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(1021),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1023),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [143] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2220),
    [sym_variable_declaration] = STATE(9437),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6809),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2229),
    [sym_break_statement] = STATE(2220),
    [sym_checked_statement] = STATE(2220),
    [sym_continue_statement] = STATE(2220),
    [sym_do_statement] = STATE(2220),
    [sym_empty_statement] = STATE(2220),
    [sym_expression_statement] = STATE(2220),
    [sym_fixed_statement] = STATE(2220),
    [sym_for_statement] = STATE(2220),
    [sym_return_statement] = STATE(2220),
    [sym_lock_statement] = STATE(2220),
    [sym_yield_statement] = STATE(2220),
    [sym_switch_statement] = STATE(2220),
    [sym_throw_statement] = STATE(2220),
    [sym_try_statement] = STATE(2220),
    [sym_unsafe_statement] = STATE(2220),
    [sym_using_statement] = STATE(2220),
    [sym_foreach_statement] = STATE(2220),
    [sym_goto_statement] = STATE(2220),
    [sym_labeled_statement] = STATE(2220),
    [sym_if_statement] = STATE(2220),
    [sym_while_statement] = STATE(2220),
    [sym_local_declaration_statement] = STATE(2220),
    [sym_local_function_statement] = STATE(2220),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6150),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2819),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2220),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(143),
    [sym_preproc_endregion] = STATE(143),
    [sym_preproc_line] = STATE(143),
    [sym_preproc_pragma] = STATE(143),
    [sym_preproc_nullable] = STATE(143),
    [sym_preproc_error] = STATE(143),
    [sym_preproc_define] = STATE(143),
    [sym_preproc_undef] = STATE(143),
    [aux_sym_class_declaration_repeat1] = STATE(2924),
    [aux_sym_class_declaration_repeat2] = STATE(3080),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(155),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1025),
    [anon_sym_unsafe] = ACTIONS(1027),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(165),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(177),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(1029),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(187),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(189),
    [anon_sym_unchecked] = ACTIONS(187),
    [anon_sym_continue] = ACTIONS(191),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_while] = ACTIONS(195),
    [anon_sym_for] = ACTIONS(197),
    [anon_sym_lock] = ACTIONS(199),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(205),
    [anon_sym_try] = ACTIONS(207),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(209),
    [anon_sym_foreach] = ACTIONS(211),
    [anon_sym_goto] = ACTIONS(213),
    [anon_sym_if] = ACTIONS(215),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(217),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [144] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2478),
    [sym_variable_declaration] = STATE(9764),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6873),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2491),
    [sym_break_statement] = STATE(2478),
    [sym_checked_statement] = STATE(2478),
    [sym_continue_statement] = STATE(2478),
    [sym_do_statement] = STATE(2478),
    [sym_empty_statement] = STATE(2478),
    [sym_expression_statement] = STATE(2478),
    [sym_fixed_statement] = STATE(2478),
    [sym_for_statement] = STATE(2478),
    [sym_return_statement] = STATE(2478),
    [sym_lock_statement] = STATE(2478),
    [sym_yield_statement] = STATE(2478),
    [sym_switch_statement] = STATE(2478),
    [sym_throw_statement] = STATE(2478),
    [sym_try_statement] = STATE(2478),
    [sym_unsafe_statement] = STATE(2478),
    [sym_using_statement] = STATE(2478),
    [sym_foreach_statement] = STATE(2478),
    [sym_goto_statement] = STATE(2478),
    [sym_labeled_statement] = STATE(2478),
    [sym_if_statement] = STATE(2478),
    [sym_while_statement] = STATE(2478),
    [sym_local_declaration_statement] = STATE(2478),
    [sym_local_function_statement] = STATE(2478),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6724),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2900),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2478),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(144),
    [sym_preproc_endregion] = STATE(144),
    [sym_preproc_line] = STATE(144),
    [sym_preproc_pragma] = STATE(144),
    [sym_preproc_nullable] = STATE(144),
    [sym_preproc_error] = STATE(144),
    [sym_preproc_define] = STATE(144),
    [sym_preproc_undef] = STATE(144),
    [aux_sym_class_declaration_repeat1] = STATE(2921),
    [aux_sym_class_declaration_repeat2] = STATE(3105),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1031),
    [anon_sym_unsafe] = ACTIONS(1033),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(1035),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(71),
    [anon_sym_continue] = ACTIONS(91),
    [anon_sym_do] = ACTIONS(93),
    [anon_sym_while] = ACTIONS(95),
    [anon_sym_for] = ACTIONS(97),
    [anon_sym_lock] = ACTIONS(99),
    [anon_sym_yield] = ACTIONS(101),
    [anon_sym_switch] = ACTIONS(103),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(107),
    [anon_sym_try] = ACTIONS(109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(111),
    [anon_sym_foreach] = ACTIONS(113),
    [anon_sym_goto] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(143),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [145] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2478),
    [sym_variable_declaration] = STATE(9764),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6873),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2475),
    [sym_break_statement] = STATE(2478),
    [sym_checked_statement] = STATE(2478),
    [sym_continue_statement] = STATE(2478),
    [sym_do_statement] = STATE(2478),
    [sym_empty_statement] = STATE(2478),
    [sym_expression_statement] = STATE(2478),
    [sym_fixed_statement] = STATE(2478),
    [sym_for_statement] = STATE(2478),
    [sym_return_statement] = STATE(2478),
    [sym_lock_statement] = STATE(2478),
    [sym_yield_statement] = STATE(2478),
    [sym_switch_statement] = STATE(2478),
    [sym_throw_statement] = STATE(2478),
    [sym_try_statement] = STATE(2478),
    [sym_unsafe_statement] = STATE(2478),
    [sym_using_statement] = STATE(2478),
    [sym_foreach_statement] = STATE(2478),
    [sym_goto_statement] = STATE(2478),
    [sym_labeled_statement] = STATE(2478),
    [sym_if_statement] = STATE(2478),
    [sym_while_statement] = STATE(2478),
    [sym_local_declaration_statement] = STATE(2478),
    [sym_local_function_statement] = STATE(2478),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6724),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2900),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2478),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(145),
    [sym_preproc_endregion] = STATE(145),
    [sym_preproc_line] = STATE(145),
    [sym_preproc_pragma] = STATE(145),
    [sym_preproc_nullable] = STATE(145),
    [sym_preproc_error] = STATE(145),
    [sym_preproc_define] = STATE(145),
    [sym_preproc_undef] = STATE(145),
    [aux_sym_class_declaration_repeat1] = STATE(2921),
    [aux_sym_class_declaration_repeat2] = STATE(3105),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1031),
    [anon_sym_unsafe] = ACTIONS(1033),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(1035),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(71),
    [anon_sym_continue] = ACTIONS(91),
    [anon_sym_do] = ACTIONS(93),
    [anon_sym_while] = ACTIONS(95),
    [anon_sym_for] = ACTIONS(97),
    [anon_sym_lock] = ACTIONS(99),
    [anon_sym_yield] = ACTIONS(101),
    [anon_sym_switch] = ACTIONS(103),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(107),
    [anon_sym_try] = ACTIONS(109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(111),
    [anon_sym_foreach] = ACTIONS(113),
    [anon_sym_goto] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(143),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [146] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2478),
    [sym_variable_declaration] = STATE(9764),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6873),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2482),
    [sym_break_statement] = STATE(2478),
    [sym_checked_statement] = STATE(2478),
    [sym_continue_statement] = STATE(2478),
    [sym_do_statement] = STATE(2478),
    [sym_empty_statement] = STATE(2478),
    [sym_expression_statement] = STATE(2478),
    [sym_fixed_statement] = STATE(2478),
    [sym_for_statement] = STATE(2478),
    [sym_return_statement] = STATE(2478),
    [sym_lock_statement] = STATE(2478),
    [sym_yield_statement] = STATE(2478),
    [sym_switch_statement] = STATE(2478),
    [sym_throw_statement] = STATE(2478),
    [sym_try_statement] = STATE(2478),
    [sym_unsafe_statement] = STATE(2478),
    [sym_using_statement] = STATE(2478),
    [sym_foreach_statement] = STATE(2478),
    [sym_goto_statement] = STATE(2478),
    [sym_labeled_statement] = STATE(2478),
    [sym_if_statement] = STATE(2478),
    [sym_while_statement] = STATE(2478),
    [sym_local_declaration_statement] = STATE(2478),
    [sym_local_function_statement] = STATE(2478),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6724),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2900),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2478),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(146),
    [sym_preproc_endregion] = STATE(146),
    [sym_preproc_line] = STATE(146),
    [sym_preproc_pragma] = STATE(146),
    [sym_preproc_nullable] = STATE(146),
    [sym_preproc_error] = STATE(146),
    [sym_preproc_define] = STATE(146),
    [sym_preproc_undef] = STATE(146),
    [aux_sym_class_declaration_repeat1] = STATE(2921),
    [aux_sym_class_declaration_repeat2] = STATE(3105),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1031),
    [anon_sym_unsafe] = ACTIONS(1033),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(1035),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(71),
    [anon_sym_continue] = ACTIONS(91),
    [anon_sym_do] = ACTIONS(93),
    [anon_sym_while] = ACTIONS(95),
    [anon_sym_for] = ACTIONS(97),
    [anon_sym_lock] = ACTIONS(99),
    [anon_sym_yield] = ACTIONS(101),
    [anon_sym_switch] = ACTIONS(103),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(107),
    [anon_sym_try] = ACTIONS(109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(111),
    [anon_sym_foreach] = ACTIONS(113),
    [anon_sym_goto] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(143),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [147] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2220),
    [sym_variable_declaration] = STATE(9437),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6809),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2230),
    [sym_break_statement] = STATE(2220),
    [sym_checked_statement] = STATE(2220),
    [sym_continue_statement] = STATE(2220),
    [sym_do_statement] = STATE(2220),
    [sym_empty_statement] = STATE(2220),
    [sym_expression_statement] = STATE(2220),
    [sym_fixed_statement] = STATE(2220),
    [sym_for_statement] = STATE(2220),
    [sym_return_statement] = STATE(2220),
    [sym_lock_statement] = STATE(2220),
    [sym_yield_statement] = STATE(2220),
    [sym_switch_statement] = STATE(2220),
    [sym_throw_statement] = STATE(2220),
    [sym_try_statement] = STATE(2220),
    [sym_unsafe_statement] = STATE(2220),
    [sym_using_statement] = STATE(2220),
    [sym_foreach_statement] = STATE(2220),
    [sym_goto_statement] = STATE(2220),
    [sym_labeled_statement] = STATE(2220),
    [sym_if_statement] = STATE(2220),
    [sym_while_statement] = STATE(2220),
    [sym_local_declaration_statement] = STATE(2220),
    [sym_local_function_statement] = STATE(2220),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6150),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2819),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2220),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(147),
    [sym_preproc_endregion] = STATE(147),
    [sym_preproc_line] = STATE(147),
    [sym_preproc_pragma] = STATE(147),
    [sym_preproc_nullable] = STATE(147),
    [sym_preproc_error] = STATE(147),
    [sym_preproc_define] = STATE(147),
    [sym_preproc_undef] = STATE(147),
    [aux_sym_class_declaration_repeat1] = STATE(2924),
    [aux_sym_class_declaration_repeat2] = STATE(3080),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(155),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1025),
    [anon_sym_unsafe] = ACTIONS(1027),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(165),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(177),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(1029),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(187),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(189),
    [anon_sym_unchecked] = ACTIONS(187),
    [anon_sym_continue] = ACTIONS(191),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_while] = ACTIONS(195),
    [anon_sym_for] = ACTIONS(197),
    [anon_sym_lock] = ACTIONS(199),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(205),
    [anon_sym_try] = ACTIONS(207),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(209),
    [anon_sym_foreach] = ACTIONS(211),
    [anon_sym_goto] = ACTIONS(213),
    [anon_sym_if] = ACTIONS(215),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(217),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [148] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2220),
    [sym_variable_declaration] = STATE(9437),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6809),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2235),
    [sym_break_statement] = STATE(2220),
    [sym_checked_statement] = STATE(2220),
    [sym_continue_statement] = STATE(2220),
    [sym_do_statement] = STATE(2220),
    [sym_empty_statement] = STATE(2220),
    [sym_expression_statement] = STATE(2220),
    [sym_fixed_statement] = STATE(2220),
    [sym_for_statement] = STATE(2220),
    [sym_return_statement] = STATE(2220),
    [sym_lock_statement] = STATE(2220),
    [sym_yield_statement] = STATE(2220),
    [sym_switch_statement] = STATE(2220),
    [sym_throw_statement] = STATE(2220),
    [sym_try_statement] = STATE(2220),
    [sym_unsafe_statement] = STATE(2220),
    [sym_using_statement] = STATE(2220),
    [sym_foreach_statement] = STATE(2220),
    [sym_goto_statement] = STATE(2220),
    [sym_labeled_statement] = STATE(2220),
    [sym_if_statement] = STATE(2220),
    [sym_while_statement] = STATE(2220),
    [sym_local_declaration_statement] = STATE(2220),
    [sym_local_function_statement] = STATE(2220),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6150),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2819),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2220),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(148),
    [sym_preproc_endregion] = STATE(148),
    [sym_preproc_line] = STATE(148),
    [sym_preproc_pragma] = STATE(148),
    [sym_preproc_nullable] = STATE(148),
    [sym_preproc_error] = STATE(148),
    [sym_preproc_define] = STATE(148),
    [sym_preproc_undef] = STATE(148),
    [aux_sym_class_declaration_repeat1] = STATE(2924),
    [aux_sym_class_declaration_repeat2] = STATE(3080),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(155),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1025),
    [anon_sym_unsafe] = ACTIONS(1027),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(165),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(177),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(1029),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(187),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(189),
    [anon_sym_unchecked] = ACTIONS(187),
    [anon_sym_continue] = ACTIONS(191),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_while] = ACTIONS(195),
    [anon_sym_for] = ACTIONS(197),
    [anon_sym_lock] = ACTIONS(199),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(205),
    [anon_sym_try] = ACTIONS(207),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(209),
    [anon_sym_foreach] = ACTIONS(211),
    [anon_sym_goto] = ACTIONS(213),
    [anon_sym_if] = ACTIONS(215),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(217),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [149] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2478),
    [sym_variable_declaration] = STATE(9764),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6873),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2477),
    [sym_break_statement] = STATE(2478),
    [sym_checked_statement] = STATE(2478),
    [sym_continue_statement] = STATE(2478),
    [sym_do_statement] = STATE(2478),
    [sym_empty_statement] = STATE(2478),
    [sym_expression_statement] = STATE(2478),
    [sym_fixed_statement] = STATE(2478),
    [sym_for_statement] = STATE(2478),
    [sym_return_statement] = STATE(2478),
    [sym_lock_statement] = STATE(2478),
    [sym_yield_statement] = STATE(2478),
    [sym_switch_statement] = STATE(2478),
    [sym_throw_statement] = STATE(2478),
    [sym_try_statement] = STATE(2478),
    [sym_unsafe_statement] = STATE(2478),
    [sym_using_statement] = STATE(2478),
    [sym_foreach_statement] = STATE(2478),
    [sym_goto_statement] = STATE(2478),
    [sym_labeled_statement] = STATE(2478),
    [sym_if_statement] = STATE(2478),
    [sym_while_statement] = STATE(2478),
    [sym_local_declaration_statement] = STATE(2478),
    [sym_local_function_statement] = STATE(2478),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6724),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2900),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2478),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(149),
    [sym_preproc_endregion] = STATE(149),
    [sym_preproc_line] = STATE(149),
    [sym_preproc_pragma] = STATE(149),
    [sym_preproc_nullable] = STATE(149),
    [sym_preproc_error] = STATE(149),
    [sym_preproc_define] = STATE(149),
    [sym_preproc_undef] = STATE(149),
    [aux_sym_class_declaration_repeat1] = STATE(2921),
    [aux_sym_class_declaration_repeat2] = STATE(3105),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1031),
    [anon_sym_unsafe] = ACTIONS(1033),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(1035),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(71),
    [anon_sym_continue] = ACTIONS(91),
    [anon_sym_do] = ACTIONS(93),
    [anon_sym_while] = ACTIONS(95),
    [anon_sym_for] = ACTIONS(97),
    [anon_sym_lock] = ACTIONS(99),
    [anon_sym_yield] = ACTIONS(101),
    [anon_sym_switch] = ACTIONS(103),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(107),
    [anon_sym_try] = ACTIONS(109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(111),
    [anon_sym_foreach] = ACTIONS(113),
    [anon_sym_goto] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(143),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [150] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2478),
    [sym_variable_declaration] = STATE(9764),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6873),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2458),
    [sym_break_statement] = STATE(2478),
    [sym_checked_statement] = STATE(2478),
    [sym_continue_statement] = STATE(2478),
    [sym_do_statement] = STATE(2478),
    [sym_empty_statement] = STATE(2478),
    [sym_expression_statement] = STATE(2478),
    [sym_fixed_statement] = STATE(2478),
    [sym_for_statement] = STATE(2478),
    [sym_return_statement] = STATE(2478),
    [sym_lock_statement] = STATE(2478),
    [sym_yield_statement] = STATE(2478),
    [sym_switch_statement] = STATE(2478),
    [sym_throw_statement] = STATE(2478),
    [sym_try_statement] = STATE(2478),
    [sym_unsafe_statement] = STATE(2478),
    [sym_using_statement] = STATE(2478),
    [sym_foreach_statement] = STATE(2478),
    [sym_goto_statement] = STATE(2478),
    [sym_labeled_statement] = STATE(2478),
    [sym_if_statement] = STATE(2478),
    [sym_while_statement] = STATE(2478),
    [sym_local_declaration_statement] = STATE(2478),
    [sym_local_function_statement] = STATE(2478),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6724),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2900),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2478),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(150),
    [sym_preproc_endregion] = STATE(150),
    [sym_preproc_line] = STATE(150),
    [sym_preproc_pragma] = STATE(150),
    [sym_preproc_nullable] = STATE(150),
    [sym_preproc_error] = STATE(150),
    [sym_preproc_define] = STATE(150),
    [sym_preproc_undef] = STATE(150),
    [aux_sym_class_declaration_repeat1] = STATE(2921),
    [aux_sym_class_declaration_repeat2] = STATE(3105),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1031),
    [anon_sym_unsafe] = ACTIONS(1033),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(1035),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(71),
    [anon_sym_continue] = ACTIONS(91),
    [anon_sym_do] = ACTIONS(93),
    [anon_sym_while] = ACTIONS(95),
    [anon_sym_for] = ACTIONS(97),
    [anon_sym_lock] = ACTIONS(99),
    [anon_sym_yield] = ACTIONS(101),
    [anon_sym_switch] = ACTIONS(103),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(107),
    [anon_sym_try] = ACTIONS(109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(111),
    [anon_sym_foreach] = ACTIONS(113),
    [anon_sym_goto] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(143),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [151] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2478),
    [sym_variable_declaration] = STATE(9764),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6873),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2426),
    [sym_break_statement] = STATE(2478),
    [sym_checked_statement] = STATE(2478),
    [sym_continue_statement] = STATE(2478),
    [sym_do_statement] = STATE(2478),
    [sym_empty_statement] = STATE(2478),
    [sym_expression_statement] = STATE(2478),
    [sym_fixed_statement] = STATE(2478),
    [sym_for_statement] = STATE(2478),
    [sym_return_statement] = STATE(2478),
    [sym_lock_statement] = STATE(2478),
    [sym_yield_statement] = STATE(2478),
    [sym_switch_statement] = STATE(2478),
    [sym_throw_statement] = STATE(2478),
    [sym_try_statement] = STATE(2478),
    [sym_unsafe_statement] = STATE(2478),
    [sym_using_statement] = STATE(2478),
    [sym_foreach_statement] = STATE(2478),
    [sym_goto_statement] = STATE(2478),
    [sym_labeled_statement] = STATE(2478),
    [sym_if_statement] = STATE(2478),
    [sym_while_statement] = STATE(2478),
    [sym_local_declaration_statement] = STATE(2478),
    [sym_local_function_statement] = STATE(2478),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6724),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2900),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2478),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(151),
    [sym_preproc_endregion] = STATE(151),
    [sym_preproc_line] = STATE(151),
    [sym_preproc_pragma] = STATE(151),
    [sym_preproc_nullable] = STATE(151),
    [sym_preproc_error] = STATE(151),
    [sym_preproc_define] = STATE(151),
    [sym_preproc_undef] = STATE(151),
    [aux_sym_class_declaration_repeat1] = STATE(2921),
    [aux_sym_class_declaration_repeat2] = STATE(3105),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1031),
    [anon_sym_unsafe] = ACTIONS(1033),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(1035),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(71),
    [anon_sym_continue] = ACTIONS(91),
    [anon_sym_do] = ACTIONS(93),
    [anon_sym_while] = ACTIONS(95),
    [anon_sym_for] = ACTIONS(97),
    [anon_sym_lock] = ACTIONS(99),
    [anon_sym_yield] = ACTIONS(101),
    [anon_sym_switch] = ACTIONS(103),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(107),
    [anon_sym_try] = ACTIONS(109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(111),
    [anon_sym_foreach] = ACTIONS(113),
    [anon_sym_goto] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(143),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [152] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2647),
    [sym_variable_declaration] = STATE(9394),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6827),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2698),
    [sym_break_statement] = STATE(2647),
    [sym_checked_statement] = STATE(2647),
    [sym_continue_statement] = STATE(2647),
    [sym_do_statement] = STATE(2647),
    [sym_empty_statement] = STATE(2647),
    [sym_expression_statement] = STATE(2647),
    [sym_fixed_statement] = STATE(2647),
    [sym_for_statement] = STATE(2647),
    [sym_return_statement] = STATE(2647),
    [sym_lock_statement] = STATE(2647),
    [sym_yield_statement] = STATE(2647),
    [sym_switch_statement] = STATE(2647),
    [sym_throw_statement] = STATE(2647),
    [sym_try_statement] = STATE(2647),
    [sym_unsafe_statement] = STATE(2647),
    [sym_using_statement] = STATE(2647),
    [sym_foreach_statement] = STATE(2647),
    [sym_goto_statement] = STATE(2647),
    [sym_labeled_statement] = STATE(2647),
    [sym_if_statement] = STATE(2647),
    [sym_while_statement] = STATE(2647),
    [sym_local_declaration_statement] = STATE(2647),
    [sym_local_function_statement] = STATE(2647),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6543),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2835),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2647),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(152),
    [sym_preproc_endregion] = STATE(152),
    [sym_preproc_line] = STATE(152),
    [sym_preproc_pragma] = STATE(152),
    [sym_preproc_nullable] = STATE(152),
    [sym_preproc_error] = STATE(152),
    [sym_preproc_define] = STATE(152),
    [sym_preproc_undef] = STATE(152),
    [aux_sym_class_declaration_repeat1] = STATE(2918),
    [aux_sym_class_declaration_repeat2] = STATE(3106),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(647),
    [anon_sym_unsafe] = ACTIONS(649),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(655),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(659),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(667),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(671),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(673),
    [anon_sym_unchecked] = ACTIONS(671),
    [anon_sym_continue] = ACTIONS(675),
    [anon_sym_do] = ACTIONS(677),
    [anon_sym_while] = ACTIONS(679),
    [anon_sym_for] = ACTIONS(681),
    [anon_sym_lock] = ACTIONS(683),
    [anon_sym_yield] = ACTIONS(685),
    [anon_sym_switch] = ACTIONS(687),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_try] = ACTIONS(693),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(695),
    [anon_sym_foreach] = ACTIONS(697),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [153] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(8872),
    [sym_variable_declaration] = STATE(9850),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6801),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(8751),
    [sym_break_statement] = STATE(8872),
    [sym_checked_statement] = STATE(8872),
    [sym_continue_statement] = STATE(8872),
    [sym_do_statement] = STATE(8872),
    [sym_empty_statement] = STATE(8872),
    [sym_expression_statement] = STATE(8872),
    [sym_fixed_statement] = STATE(8872),
    [sym_for_statement] = STATE(8872),
    [sym_return_statement] = STATE(8872),
    [sym_lock_statement] = STATE(8872),
    [sym_yield_statement] = STATE(8872),
    [sym_switch_statement] = STATE(8872),
    [sym_throw_statement] = STATE(8872),
    [sym_try_statement] = STATE(8872),
    [sym_unsafe_statement] = STATE(8872),
    [sym_using_statement] = STATE(8872),
    [sym_foreach_statement] = STATE(8872),
    [sym_goto_statement] = STATE(8872),
    [sym_labeled_statement] = STATE(8872),
    [sym_if_statement] = STATE(8872),
    [sym_while_statement] = STATE(8872),
    [sym_local_declaration_statement] = STATE(8872),
    [sym_local_function_statement] = STATE(8872),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6718),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2890),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(8872),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(153),
    [sym_preproc_endregion] = STATE(153),
    [sym_preproc_line] = STATE(153),
    [sym_preproc_pragma] = STATE(153),
    [sym_preproc_nullable] = STATE(153),
    [sym_preproc_error] = STATE(153),
    [sym_preproc_define] = STATE(153),
    [sym_preproc_undef] = STATE(153),
    [aux_sym_class_declaration_repeat1] = STATE(2909),
    [aux_sym_class_declaration_repeat2] = STATE(3101),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(981),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(983),
    [anon_sym_unsafe] = ACTIONS(985),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(987),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(989),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(991),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(993),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(995),
    [anon_sym_unchecked] = ACTIONS(993),
    [anon_sym_continue] = ACTIONS(997),
    [anon_sym_do] = ACTIONS(999),
    [anon_sym_while] = ACTIONS(1001),
    [anon_sym_for] = ACTIONS(1003),
    [anon_sym_lock] = ACTIONS(1005),
    [anon_sym_yield] = ACTIONS(1007),
    [anon_sym_switch] = ACTIONS(1009),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1011),
    [anon_sym_try] = ACTIONS(1013),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1015),
    [anon_sym_foreach] = ACTIONS(1017),
    [anon_sym_goto] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(1021),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1023),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [154] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2478),
    [sym_variable_declaration] = STATE(9764),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6873),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2501),
    [sym_break_statement] = STATE(2478),
    [sym_checked_statement] = STATE(2478),
    [sym_continue_statement] = STATE(2478),
    [sym_do_statement] = STATE(2478),
    [sym_empty_statement] = STATE(2478),
    [sym_expression_statement] = STATE(2478),
    [sym_fixed_statement] = STATE(2478),
    [sym_for_statement] = STATE(2478),
    [sym_return_statement] = STATE(2478),
    [sym_lock_statement] = STATE(2478),
    [sym_yield_statement] = STATE(2478),
    [sym_switch_statement] = STATE(2478),
    [sym_throw_statement] = STATE(2478),
    [sym_try_statement] = STATE(2478),
    [sym_unsafe_statement] = STATE(2478),
    [sym_using_statement] = STATE(2478),
    [sym_foreach_statement] = STATE(2478),
    [sym_goto_statement] = STATE(2478),
    [sym_labeled_statement] = STATE(2478),
    [sym_if_statement] = STATE(2478),
    [sym_while_statement] = STATE(2478),
    [sym_local_declaration_statement] = STATE(2478),
    [sym_local_function_statement] = STATE(2478),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6724),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2900),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2478),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(154),
    [sym_preproc_endregion] = STATE(154),
    [sym_preproc_line] = STATE(154),
    [sym_preproc_pragma] = STATE(154),
    [sym_preproc_nullable] = STATE(154),
    [sym_preproc_error] = STATE(154),
    [sym_preproc_define] = STATE(154),
    [sym_preproc_undef] = STATE(154),
    [aux_sym_class_declaration_repeat1] = STATE(2921),
    [aux_sym_class_declaration_repeat2] = STATE(3105),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1031),
    [anon_sym_unsafe] = ACTIONS(1033),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(1035),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(71),
    [anon_sym_continue] = ACTIONS(91),
    [anon_sym_do] = ACTIONS(93),
    [anon_sym_while] = ACTIONS(95),
    [anon_sym_for] = ACTIONS(97),
    [anon_sym_lock] = ACTIONS(99),
    [anon_sym_yield] = ACTIONS(101),
    [anon_sym_switch] = ACTIONS(103),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(107),
    [anon_sym_try] = ACTIONS(109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(111),
    [anon_sym_foreach] = ACTIONS(113),
    [anon_sym_goto] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(143),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [155] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2220),
    [sym_variable_declaration] = STATE(9437),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6809),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2236),
    [sym_break_statement] = STATE(2220),
    [sym_checked_statement] = STATE(2220),
    [sym_continue_statement] = STATE(2220),
    [sym_do_statement] = STATE(2220),
    [sym_empty_statement] = STATE(2220),
    [sym_expression_statement] = STATE(2220),
    [sym_fixed_statement] = STATE(2220),
    [sym_for_statement] = STATE(2220),
    [sym_return_statement] = STATE(2220),
    [sym_lock_statement] = STATE(2220),
    [sym_yield_statement] = STATE(2220),
    [sym_switch_statement] = STATE(2220),
    [sym_throw_statement] = STATE(2220),
    [sym_try_statement] = STATE(2220),
    [sym_unsafe_statement] = STATE(2220),
    [sym_using_statement] = STATE(2220),
    [sym_foreach_statement] = STATE(2220),
    [sym_goto_statement] = STATE(2220),
    [sym_labeled_statement] = STATE(2220),
    [sym_if_statement] = STATE(2220),
    [sym_while_statement] = STATE(2220),
    [sym_local_declaration_statement] = STATE(2220),
    [sym_local_function_statement] = STATE(2220),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6150),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2819),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2220),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(155),
    [sym_preproc_endregion] = STATE(155),
    [sym_preproc_line] = STATE(155),
    [sym_preproc_pragma] = STATE(155),
    [sym_preproc_nullable] = STATE(155),
    [sym_preproc_error] = STATE(155),
    [sym_preproc_define] = STATE(155),
    [sym_preproc_undef] = STATE(155),
    [aux_sym_class_declaration_repeat1] = STATE(2924),
    [aux_sym_class_declaration_repeat2] = STATE(3080),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(155),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1025),
    [anon_sym_unsafe] = ACTIONS(1027),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(165),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(177),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(1029),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(187),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(189),
    [anon_sym_unchecked] = ACTIONS(187),
    [anon_sym_continue] = ACTIONS(191),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_while] = ACTIONS(195),
    [anon_sym_for] = ACTIONS(197),
    [anon_sym_lock] = ACTIONS(199),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(205),
    [anon_sym_try] = ACTIONS(207),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(209),
    [anon_sym_foreach] = ACTIONS(211),
    [anon_sym_goto] = ACTIONS(213),
    [anon_sym_if] = ACTIONS(215),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(217),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [156] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2478),
    [sym_variable_declaration] = STATE(9764),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6873),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2461),
    [sym_break_statement] = STATE(2478),
    [sym_checked_statement] = STATE(2478),
    [sym_continue_statement] = STATE(2478),
    [sym_do_statement] = STATE(2478),
    [sym_empty_statement] = STATE(2478),
    [sym_expression_statement] = STATE(2478),
    [sym_fixed_statement] = STATE(2478),
    [sym_for_statement] = STATE(2478),
    [sym_return_statement] = STATE(2478),
    [sym_lock_statement] = STATE(2478),
    [sym_yield_statement] = STATE(2478),
    [sym_switch_statement] = STATE(2478),
    [sym_throw_statement] = STATE(2478),
    [sym_try_statement] = STATE(2478),
    [sym_unsafe_statement] = STATE(2478),
    [sym_using_statement] = STATE(2478),
    [sym_foreach_statement] = STATE(2478),
    [sym_goto_statement] = STATE(2478),
    [sym_labeled_statement] = STATE(2478),
    [sym_if_statement] = STATE(2478),
    [sym_while_statement] = STATE(2478),
    [sym_local_declaration_statement] = STATE(2478),
    [sym_local_function_statement] = STATE(2478),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6724),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2900),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2478),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(156),
    [sym_preproc_endregion] = STATE(156),
    [sym_preproc_line] = STATE(156),
    [sym_preproc_pragma] = STATE(156),
    [sym_preproc_nullable] = STATE(156),
    [sym_preproc_error] = STATE(156),
    [sym_preproc_define] = STATE(156),
    [sym_preproc_undef] = STATE(156),
    [aux_sym_class_declaration_repeat1] = STATE(2921),
    [aux_sym_class_declaration_repeat2] = STATE(3105),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1031),
    [anon_sym_unsafe] = ACTIONS(1033),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(1035),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(71),
    [anon_sym_continue] = ACTIONS(91),
    [anon_sym_do] = ACTIONS(93),
    [anon_sym_while] = ACTIONS(95),
    [anon_sym_for] = ACTIONS(97),
    [anon_sym_lock] = ACTIONS(99),
    [anon_sym_yield] = ACTIONS(101),
    [anon_sym_switch] = ACTIONS(103),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(107),
    [anon_sym_try] = ACTIONS(109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(111),
    [anon_sym_foreach] = ACTIONS(113),
    [anon_sym_goto] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(143),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [157] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(8872),
    [sym_variable_declaration] = STATE(9850),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6801),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(8753),
    [sym_break_statement] = STATE(8872),
    [sym_checked_statement] = STATE(8872),
    [sym_continue_statement] = STATE(8872),
    [sym_do_statement] = STATE(8872),
    [sym_empty_statement] = STATE(8872),
    [sym_expression_statement] = STATE(8872),
    [sym_fixed_statement] = STATE(8872),
    [sym_for_statement] = STATE(8872),
    [sym_return_statement] = STATE(8872),
    [sym_lock_statement] = STATE(8872),
    [sym_yield_statement] = STATE(8872),
    [sym_switch_statement] = STATE(8872),
    [sym_throw_statement] = STATE(8872),
    [sym_try_statement] = STATE(8872),
    [sym_unsafe_statement] = STATE(8872),
    [sym_using_statement] = STATE(8872),
    [sym_foreach_statement] = STATE(8872),
    [sym_goto_statement] = STATE(8872),
    [sym_labeled_statement] = STATE(8872),
    [sym_if_statement] = STATE(8872),
    [sym_while_statement] = STATE(8872),
    [sym_local_declaration_statement] = STATE(8872),
    [sym_local_function_statement] = STATE(8872),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6718),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2890),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(8872),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(157),
    [sym_preproc_endregion] = STATE(157),
    [sym_preproc_line] = STATE(157),
    [sym_preproc_pragma] = STATE(157),
    [sym_preproc_nullable] = STATE(157),
    [sym_preproc_error] = STATE(157),
    [sym_preproc_define] = STATE(157),
    [sym_preproc_undef] = STATE(157),
    [aux_sym_class_declaration_repeat1] = STATE(2909),
    [aux_sym_class_declaration_repeat2] = STATE(3101),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(981),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(983),
    [anon_sym_unsafe] = ACTIONS(985),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(987),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(989),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(991),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(993),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(995),
    [anon_sym_unchecked] = ACTIONS(993),
    [anon_sym_continue] = ACTIONS(997),
    [anon_sym_do] = ACTIONS(999),
    [anon_sym_while] = ACTIONS(1001),
    [anon_sym_for] = ACTIONS(1003),
    [anon_sym_lock] = ACTIONS(1005),
    [anon_sym_yield] = ACTIONS(1007),
    [anon_sym_switch] = ACTIONS(1009),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1011),
    [anon_sym_try] = ACTIONS(1013),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1015),
    [anon_sym_foreach] = ACTIONS(1017),
    [anon_sym_goto] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(1021),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1023),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [158] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2220),
    [sym_variable_declaration] = STATE(9437),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6809),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2239),
    [sym_break_statement] = STATE(2220),
    [sym_checked_statement] = STATE(2220),
    [sym_continue_statement] = STATE(2220),
    [sym_do_statement] = STATE(2220),
    [sym_empty_statement] = STATE(2220),
    [sym_expression_statement] = STATE(2220),
    [sym_fixed_statement] = STATE(2220),
    [sym_for_statement] = STATE(2220),
    [sym_return_statement] = STATE(2220),
    [sym_lock_statement] = STATE(2220),
    [sym_yield_statement] = STATE(2220),
    [sym_switch_statement] = STATE(2220),
    [sym_throw_statement] = STATE(2220),
    [sym_try_statement] = STATE(2220),
    [sym_unsafe_statement] = STATE(2220),
    [sym_using_statement] = STATE(2220),
    [sym_foreach_statement] = STATE(2220),
    [sym_goto_statement] = STATE(2220),
    [sym_labeled_statement] = STATE(2220),
    [sym_if_statement] = STATE(2220),
    [sym_while_statement] = STATE(2220),
    [sym_local_declaration_statement] = STATE(2220),
    [sym_local_function_statement] = STATE(2220),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6150),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2819),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2220),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(158),
    [sym_preproc_endregion] = STATE(158),
    [sym_preproc_line] = STATE(158),
    [sym_preproc_pragma] = STATE(158),
    [sym_preproc_nullable] = STATE(158),
    [sym_preproc_error] = STATE(158),
    [sym_preproc_define] = STATE(158),
    [sym_preproc_undef] = STATE(158),
    [aux_sym_class_declaration_repeat1] = STATE(2924),
    [aux_sym_class_declaration_repeat2] = STATE(3080),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(155),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1025),
    [anon_sym_unsafe] = ACTIONS(1027),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(165),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(177),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(1029),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(187),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(189),
    [anon_sym_unchecked] = ACTIONS(187),
    [anon_sym_continue] = ACTIONS(191),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_while] = ACTIONS(195),
    [anon_sym_for] = ACTIONS(197),
    [anon_sym_lock] = ACTIONS(199),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(205),
    [anon_sym_try] = ACTIONS(207),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(209),
    [anon_sym_foreach] = ACTIONS(211),
    [anon_sym_goto] = ACTIONS(213),
    [anon_sym_if] = ACTIONS(215),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(217),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [159] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2478),
    [sym_variable_declaration] = STATE(9764),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6873),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2469),
    [sym_break_statement] = STATE(2478),
    [sym_checked_statement] = STATE(2478),
    [sym_continue_statement] = STATE(2478),
    [sym_do_statement] = STATE(2478),
    [sym_empty_statement] = STATE(2478),
    [sym_expression_statement] = STATE(2478),
    [sym_fixed_statement] = STATE(2478),
    [sym_for_statement] = STATE(2478),
    [sym_return_statement] = STATE(2478),
    [sym_lock_statement] = STATE(2478),
    [sym_yield_statement] = STATE(2478),
    [sym_switch_statement] = STATE(2478),
    [sym_throw_statement] = STATE(2478),
    [sym_try_statement] = STATE(2478),
    [sym_unsafe_statement] = STATE(2478),
    [sym_using_statement] = STATE(2478),
    [sym_foreach_statement] = STATE(2478),
    [sym_goto_statement] = STATE(2478),
    [sym_labeled_statement] = STATE(2478),
    [sym_if_statement] = STATE(2478),
    [sym_while_statement] = STATE(2478),
    [sym_local_declaration_statement] = STATE(2478),
    [sym_local_function_statement] = STATE(2478),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6724),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2900),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2478),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(159),
    [sym_preproc_endregion] = STATE(159),
    [sym_preproc_line] = STATE(159),
    [sym_preproc_pragma] = STATE(159),
    [sym_preproc_nullable] = STATE(159),
    [sym_preproc_error] = STATE(159),
    [sym_preproc_define] = STATE(159),
    [sym_preproc_undef] = STATE(159),
    [aux_sym_class_declaration_repeat1] = STATE(2921),
    [aux_sym_class_declaration_repeat2] = STATE(3105),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1031),
    [anon_sym_unsafe] = ACTIONS(1033),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(1035),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(71),
    [anon_sym_continue] = ACTIONS(91),
    [anon_sym_do] = ACTIONS(93),
    [anon_sym_while] = ACTIONS(95),
    [anon_sym_for] = ACTIONS(97),
    [anon_sym_lock] = ACTIONS(99),
    [anon_sym_yield] = ACTIONS(101),
    [anon_sym_switch] = ACTIONS(103),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(107),
    [anon_sym_try] = ACTIONS(109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(111),
    [anon_sym_foreach] = ACTIONS(113),
    [anon_sym_goto] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(143),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [160] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2647),
    [sym_variable_declaration] = STATE(9394),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6827),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2675),
    [sym_break_statement] = STATE(2647),
    [sym_checked_statement] = STATE(2647),
    [sym_continue_statement] = STATE(2647),
    [sym_do_statement] = STATE(2647),
    [sym_empty_statement] = STATE(2647),
    [sym_expression_statement] = STATE(2647),
    [sym_fixed_statement] = STATE(2647),
    [sym_for_statement] = STATE(2647),
    [sym_return_statement] = STATE(2647),
    [sym_lock_statement] = STATE(2647),
    [sym_yield_statement] = STATE(2647),
    [sym_switch_statement] = STATE(2647),
    [sym_throw_statement] = STATE(2647),
    [sym_try_statement] = STATE(2647),
    [sym_unsafe_statement] = STATE(2647),
    [sym_using_statement] = STATE(2647),
    [sym_foreach_statement] = STATE(2647),
    [sym_goto_statement] = STATE(2647),
    [sym_labeled_statement] = STATE(2647),
    [sym_if_statement] = STATE(2647),
    [sym_while_statement] = STATE(2647),
    [sym_local_declaration_statement] = STATE(2647),
    [sym_local_function_statement] = STATE(2647),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6543),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2835),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2647),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(160),
    [sym_preproc_endregion] = STATE(160),
    [sym_preproc_line] = STATE(160),
    [sym_preproc_pragma] = STATE(160),
    [sym_preproc_nullable] = STATE(160),
    [sym_preproc_error] = STATE(160),
    [sym_preproc_define] = STATE(160),
    [sym_preproc_undef] = STATE(160),
    [aux_sym_class_declaration_repeat1] = STATE(2918),
    [aux_sym_class_declaration_repeat2] = STATE(3106),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(647),
    [anon_sym_unsafe] = ACTIONS(649),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(655),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(659),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(667),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(671),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(673),
    [anon_sym_unchecked] = ACTIONS(671),
    [anon_sym_continue] = ACTIONS(675),
    [anon_sym_do] = ACTIONS(677),
    [anon_sym_while] = ACTIONS(679),
    [anon_sym_for] = ACTIONS(681),
    [anon_sym_lock] = ACTIONS(683),
    [anon_sym_yield] = ACTIONS(685),
    [anon_sym_switch] = ACTIONS(687),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_try] = ACTIONS(693),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(695),
    [anon_sym_foreach] = ACTIONS(697),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [161] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2478),
    [sym_variable_declaration] = STATE(9764),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6873),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2463),
    [sym_break_statement] = STATE(2478),
    [sym_checked_statement] = STATE(2478),
    [sym_continue_statement] = STATE(2478),
    [sym_do_statement] = STATE(2478),
    [sym_empty_statement] = STATE(2478),
    [sym_expression_statement] = STATE(2478),
    [sym_fixed_statement] = STATE(2478),
    [sym_for_statement] = STATE(2478),
    [sym_return_statement] = STATE(2478),
    [sym_lock_statement] = STATE(2478),
    [sym_yield_statement] = STATE(2478),
    [sym_switch_statement] = STATE(2478),
    [sym_throw_statement] = STATE(2478),
    [sym_try_statement] = STATE(2478),
    [sym_unsafe_statement] = STATE(2478),
    [sym_using_statement] = STATE(2478),
    [sym_foreach_statement] = STATE(2478),
    [sym_goto_statement] = STATE(2478),
    [sym_labeled_statement] = STATE(2478),
    [sym_if_statement] = STATE(2478),
    [sym_while_statement] = STATE(2478),
    [sym_local_declaration_statement] = STATE(2478),
    [sym_local_function_statement] = STATE(2478),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6724),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2900),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2478),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(161),
    [sym_preproc_endregion] = STATE(161),
    [sym_preproc_line] = STATE(161),
    [sym_preproc_pragma] = STATE(161),
    [sym_preproc_nullable] = STATE(161),
    [sym_preproc_error] = STATE(161),
    [sym_preproc_define] = STATE(161),
    [sym_preproc_undef] = STATE(161),
    [aux_sym_class_declaration_repeat1] = STATE(2921),
    [aux_sym_class_declaration_repeat2] = STATE(3105),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1031),
    [anon_sym_unsafe] = ACTIONS(1033),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(1035),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(71),
    [anon_sym_continue] = ACTIONS(91),
    [anon_sym_do] = ACTIONS(93),
    [anon_sym_while] = ACTIONS(95),
    [anon_sym_for] = ACTIONS(97),
    [anon_sym_lock] = ACTIONS(99),
    [anon_sym_yield] = ACTIONS(101),
    [anon_sym_switch] = ACTIONS(103),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(107),
    [anon_sym_try] = ACTIONS(109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(111),
    [anon_sym_foreach] = ACTIONS(113),
    [anon_sym_goto] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(143),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [162] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2478),
    [sym_variable_declaration] = STATE(9764),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6873),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2447),
    [sym_break_statement] = STATE(2478),
    [sym_checked_statement] = STATE(2478),
    [sym_continue_statement] = STATE(2478),
    [sym_do_statement] = STATE(2478),
    [sym_empty_statement] = STATE(2478),
    [sym_expression_statement] = STATE(2478),
    [sym_fixed_statement] = STATE(2478),
    [sym_for_statement] = STATE(2478),
    [sym_return_statement] = STATE(2478),
    [sym_lock_statement] = STATE(2478),
    [sym_yield_statement] = STATE(2478),
    [sym_switch_statement] = STATE(2478),
    [sym_throw_statement] = STATE(2478),
    [sym_try_statement] = STATE(2478),
    [sym_unsafe_statement] = STATE(2478),
    [sym_using_statement] = STATE(2478),
    [sym_foreach_statement] = STATE(2478),
    [sym_goto_statement] = STATE(2478),
    [sym_labeled_statement] = STATE(2478),
    [sym_if_statement] = STATE(2478),
    [sym_while_statement] = STATE(2478),
    [sym_local_declaration_statement] = STATE(2478),
    [sym_local_function_statement] = STATE(2478),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6724),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2900),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2478),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(162),
    [sym_preproc_endregion] = STATE(162),
    [sym_preproc_line] = STATE(162),
    [sym_preproc_pragma] = STATE(162),
    [sym_preproc_nullable] = STATE(162),
    [sym_preproc_error] = STATE(162),
    [sym_preproc_define] = STATE(162),
    [sym_preproc_undef] = STATE(162),
    [aux_sym_class_declaration_repeat1] = STATE(2921),
    [aux_sym_class_declaration_repeat2] = STATE(3105),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1031),
    [anon_sym_unsafe] = ACTIONS(1033),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(1035),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(71),
    [anon_sym_continue] = ACTIONS(91),
    [anon_sym_do] = ACTIONS(93),
    [anon_sym_while] = ACTIONS(95),
    [anon_sym_for] = ACTIONS(97),
    [anon_sym_lock] = ACTIONS(99),
    [anon_sym_yield] = ACTIONS(101),
    [anon_sym_switch] = ACTIONS(103),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(107),
    [anon_sym_try] = ACTIONS(109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(111),
    [anon_sym_foreach] = ACTIONS(113),
    [anon_sym_goto] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(143),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [163] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2478),
    [sym_variable_declaration] = STATE(9764),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6873),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2464),
    [sym_break_statement] = STATE(2478),
    [sym_checked_statement] = STATE(2478),
    [sym_continue_statement] = STATE(2478),
    [sym_do_statement] = STATE(2478),
    [sym_empty_statement] = STATE(2478),
    [sym_expression_statement] = STATE(2478),
    [sym_fixed_statement] = STATE(2478),
    [sym_for_statement] = STATE(2478),
    [sym_return_statement] = STATE(2478),
    [sym_lock_statement] = STATE(2478),
    [sym_yield_statement] = STATE(2478),
    [sym_switch_statement] = STATE(2478),
    [sym_throw_statement] = STATE(2478),
    [sym_try_statement] = STATE(2478),
    [sym_unsafe_statement] = STATE(2478),
    [sym_using_statement] = STATE(2478),
    [sym_foreach_statement] = STATE(2478),
    [sym_goto_statement] = STATE(2478),
    [sym_labeled_statement] = STATE(2478),
    [sym_if_statement] = STATE(2478),
    [sym_while_statement] = STATE(2478),
    [sym_local_declaration_statement] = STATE(2478),
    [sym_local_function_statement] = STATE(2478),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6724),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2900),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2478),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(163),
    [sym_preproc_endregion] = STATE(163),
    [sym_preproc_line] = STATE(163),
    [sym_preproc_pragma] = STATE(163),
    [sym_preproc_nullable] = STATE(163),
    [sym_preproc_error] = STATE(163),
    [sym_preproc_define] = STATE(163),
    [sym_preproc_undef] = STATE(163),
    [aux_sym_class_declaration_repeat1] = STATE(2921),
    [aux_sym_class_declaration_repeat2] = STATE(3105),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1031),
    [anon_sym_unsafe] = ACTIONS(1033),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(1035),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(71),
    [anon_sym_continue] = ACTIONS(91),
    [anon_sym_do] = ACTIONS(93),
    [anon_sym_while] = ACTIONS(95),
    [anon_sym_for] = ACTIONS(97),
    [anon_sym_lock] = ACTIONS(99),
    [anon_sym_yield] = ACTIONS(101),
    [anon_sym_switch] = ACTIONS(103),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(107),
    [anon_sym_try] = ACTIONS(109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(111),
    [anon_sym_foreach] = ACTIONS(113),
    [anon_sym_goto] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(143),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [164] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2647),
    [sym_variable_declaration] = STATE(9394),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6827),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2706),
    [sym_break_statement] = STATE(2647),
    [sym_checked_statement] = STATE(2647),
    [sym_continue_statement] = STATE(2647),
    [sym_do_statement] = STATE(2647),
    [sym_empty_statement] = STATE(2647),
    [sym_expression_statement] = STATE(2647),
    [sym_fixed_statement] = STATE(2647),
    [sym_for_statement] = STATE(2647),
    [sym_return_statement] = STATE(2647),
    [sym_lock_statement] = STATE(2647),
    [sym_yield_statement] = STATE(2647),
    [sym_switch_statement] = STATE(2647),
    [sym_throw_statement] = STATE(2647),
    [sym_try_statement] = STATE(2647),
    [sym_unsafe_statement] = STATE(2647),
    [sym_using_statement] = STATE(2647),
    [sym_foreach_statement] = STATE(2647),
    [sym_goto_statement] = STATE(2647),
    [sym_labeled_statement] = STATE(2647),
    [sym_if_statement] = STATE(2647),
    [sym_while_statement] = STATE(2647),
    [sym_local_declaration_statement] = STATE(2647),
    [sym_local_function_statement] = STATE(2647),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6543),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2835),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2647),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(164),
    [sym_preproc_endregion] = STATE(164),
    [sym_preproc_line] = STATE(164),
    [sym_preproc_pragma] = STATE(164),
    [sym_preproc_nullable] = STATE(164),
    [sym_preproc_error] = STATE(164),
    [sym_preproc_define] = STATE(164),
    [sym_preproc_undef] = STATE(164),
    [aux_sym_class_declaration_repeat1] = STATE(2918),
    [aux_sym_class_declaration_repeat2] = STATE(3106),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(647),
    [anon_sym_unsafe] = ACTIONS(649),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(655),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(659),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(667),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(671),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(673),
    [anon_sym_unchecked] = ACTIONS(671),
    [anon_sym_continue] = ACTIONS(675),
    [anon_sym_do] = ACTIONS(677),
    [anon_sym_while] = ACTIONS(679),
    [anon_sym_for] = ACTIONS(681),
    [anon_sym_lock] = ACTIONS(683),
    [anon_sym_yield] = ACTIONS(685),
    [anon_sym_switch] = ACTIONS(687),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_try] = ACTIONS(693),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(695),
    [anon_sym_foreach] = ACTIONS(697),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [165] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2478),
    [sym_variable_declaration] = STATE(9764),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6873),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2487),
    [sym_break_statement] = STATE(2478),
    [sym_checked_statement] = STATE(2478),
    [sym_continue_statement] = STATE(2478),
    [sym_do_statement] = STATE(2478),
    [sym_empty_statement] = STATE(2478),
    [sym_expression_statement] = STATE(2478),
    [sym_fixed_statement] = STATE(2478),
    [sym_for_statement] = STATE(2478),
    [sym_return_statement] = STATE(2478),
    [sym_lock_statement] = STATE(2478),
    [sym_yield_statement] = STATE(2478),
    [sym_switch_statement] = STATE(2478),
    [sym_throw_statement] = STATE(2478),
    [sym_try_statement] = STATE(2478),
    [sym_unsafe_statement] = STATE(2478),
    [sym_using_statement] = STATE(2478),
    [sym_foreach_statement] = STATE(2478),
    [sym_goto_statement] = STATE(2478),
    [sym_labeled_statement] = STATE(2478),
    [sym_if_statement] = STATE(2478),
    [sym_while_statement] = STATE(2478),
    [sym_local_declaration_statement] = STATE(2478),
    [sym_local_function_statement] = STATE(2478),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6724),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2900),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2478),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(165),
    [sym_preproc_endregion] = STATE(165),
    [sym_preproc_line] = STATE(165),
    [sym_preproc_pragma] = STATE(165),
    [sym_preproc_nullable] = STATE(165),
    [sym_preproc_error] = STATE(165),
    [sym_preproc_define] = STATE(165),
    [sym_preproc_undef] = STATE(165),
    [aux_sym_class_declaration_repeat1] = STATE(2921),
    [aux_sym_class_declaration_repeat2] = STATE(3105),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1031),
    [anon_sym_unsafe] = ACTIONS(1033),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(1035),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(71),
    [anon_sym_continue] = ACTIONS(91),
    [anon_sym_do] = ACTIONS(93),
    [anon_sym_while] = ACTIONS(95),
    [anon_sym_for] = ACTIONS(97),
    [anon_sym_lock] = ACTIONS(99),
    [anon_sym_yield] = ACTIONS(101),
    [anon_sym_switch] = ACTIONS(103),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(107),
    [anon_sym_try] = ACTIONS(109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(111),
    [anon_sym_foreach] = ACTIONS(113),
    [anon_sym_goto] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(143),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [166] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(8872),
    [sym_variable_declaration] = STATE(9850),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6801),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(8783),
    [sym_break_statement] = STATE(8872),
    [sym_checked_statement] = STATE(8872),
    [sym_continue_statement] = STATE(8872),
    [sym_do_statement] = STATE(8872),
    [sym_empty_statement] = STATE(8872),
    [sym_expression_statement] = STATE(8872),
    [sym_fixed_statement] = STATE(8872),
    [sym_for_statement] = STATE(8872),
    [sym_return_statement] = STATE(8872),
    [sym_lock_statement] = STATE(8872),
    [sym_yield_statement] = STATE(8872),
    [sym_switch_statement] = STATE(8872),
    [sym_throw_statement] = STATE(8872),
    [sym_try_statement] = STATE(8872),
    [sym_unsafe_statement] = STATE(8872),
    [sym_using_statement] = STATE(8872),
    [sym_foreach_statement] = STATE(8872),
    [sym_goto_statement] = STATE(8872),
    [sym_labeled_statement] = STATE(8872),
    [sym_if_statement] = STATE(8872),
    [sym_while_statement] = STATE(8872),
    [sym_local_declaration_statement] = STATE(8872),
    [sym_local_function_statement] = STATE(8872),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6718),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2890),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(8872),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(166),
    [sym_preproc_endregion] = STATE(166),
    [sym_preproc_line] = STATE(166),
    [sym_preproc_pragma] = STATE(166),
    [sym_preproc_nullable] = STATE(166),
    [sym_preproc_error] = STATE(166),
    [sym_preproc_define] = STATE(166),
    [sym_preproc_undef] = STATE(166),
    [aux_sym_class_declaration_repeat1] = STATE(2909),
    [aux_sym_class_declaration_repeat2] = STATE(3101),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(981),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(983),
    [anon_sym_unsafe] = ACTIONS(985),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(987),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(989),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(991),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(993),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(995),
    [anon_sym_unchecked] = ACTIONS(993),
    [anon_sym_continue] = ACTIONS(997),
    [anon_sym_do] = ACTIONS(999),
    [anon_sym_while] = ACTIONS(1001),
    [anon_sym_for] = ACTIONS(1003),
    [anon_sym_lock] = ACTIONS(1005),
    [anon_sym_yield] = ACTIONS(1007),
    [anon_sym_switch] = ACTIONS(1009),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1011),
    [anon_sym_try] = ACTIONS(1013),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1015),
    [anon_sym_foreach] = ACTIONS(1017),
    [anon_sym_goto] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(1021),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1023),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [167] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2478),
    [sym_variable_declaration] = STATE(9764),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6873),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2500),
    [sym_break_statement] = STATE(2478),
    [sym_checked_statement] = STATE(2478),
    [sym_continue_statement] = STATE(2478),
    [sym_do_statement] = STATE(2478),
    [sym_empty_statement] = STATE(2478),
    [sym_expression_statement] = STATE(2478),
    [sym_fixed_statement] = STATE(2478),
    [sym_for_statement] = STATE(2478),
    [sym_return_statement] = STATE(2478),
    [sym_lock_statement] = STATE(2478),
    [sym_yield_statement] = STATE(2478),
    [sym_switch_statement] = STATE(2478),
    [sym_throw_statement] = STATE(2478),
    [sym_try_statement] = STATE(2478),
    [sym_unsafe_statement] = STATE(2478),
    [sym_using_statement] = STATE(2478),
    [sym_foreach_statement] = STATE(2478),
    [sym_goto_statement] = STATE(2478),
    [sym_labeled_statement] = STATE(2478),
    [sym_if_statement] = STATE(2478),
    [sym_while_statement] = STATE(2478),
    [sym_local_declaration_statement] = STATE(2478),
    [sym_local_function_statement] = STATE(2478),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6724),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2900),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2478),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(167),
    [sym_preproc_endregion] = STATE(167),
    [sym_preproc_line] = STATE(167),
    [sym_preproc_pragma] = STATE(167),
    [sym_preproc_nullable] = STATE(167),
    [sym_preproc_error] = STATE(167),
    [sym_preproc_define] = STATE(167),
    [sym_preproc_undef] = STATE(167),
    [aux_sym_class_declaration_repeat1] = STATE(2921),
    [aux_sym_class_declaration_repeat2] = STATE(3105),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1031),
    [anon_sym_unsafe] = ACTIONS(1033),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(1035),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(71),
    [anon_sym_continue] = ACTIONS(91),
    [anon_sym_do] = ACTIONS(93),
    [anon_sym_while] = ACTIONS(95),
    [anon_sym_for] = ACTIONS(97),
    [anon_sym_lock] = ACTIONS(99),
    [anon_sym_yield] = ACTIONS(101),
    [anon_sym_switch] = ACTIONS(103),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(107),
    [anon_sym_try] = ACTIONS(109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(111),
    [anon_sym_foreach] = ACTIONS(113),
    [anon_sym_goto] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(143),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [168] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2478),
    [sym_variable_declaration] = STATE(9764),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6873),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2492),
    [sym_break_statement] = STATE(2478),
    [sym_checked_statement] = STATE(2478),
    [sym_continue_statement] = STATE(2478),
    [sym_do_statement] = STATE(2478),
    [sym_empty_statement] = STATE(2478),
    [sym_expression_statement] = STATE(2478),
    [sym_fixed_statement] = STATE(2478),
    [sym_for_statement] = STATE(2478),
    [sym_return_statement] = STATE(2478),
    [sym_lock_statement] = STATE(2478),
    [sym_yield_statement] = STATE(2478),
    [sym_switch_statement] = STATE(2478),
    [sym_throw_statement] = STATE(2478),
    [sym_try_statement] = STATE(2478),
    [sym_unsafe_statement] = STATE(2478),
    [sym_using_statement] = STATE(2478),
    [sym_foreach_statement] = STATE(2478),
    [sym_goto_statement] = STATE(2478),
    [sym_labeled_statement] = STATE(2478),
    [sym_if_statement] = STATE(2478),
    [sym_while_statement] = STATE(2478),
    [sym_local_declaration_statement] = STATE(2478),
    [sym_local_function_statement] = STATE(2478),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6724),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2900),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2478),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(168),
    [sym_preproc_endregion] = STATE(168),
    [sym_preproc_line] = STATE(168),
    [sym_preproc_pragma] = STATE(168),
    [sym_preproc_nullable] = STATE(168),
    [sym_preproc_error] = STATE(168),
    [sym_preproc_define] = STATE(168),
    [sym_preproc_undef] = STATE(168),
    [aux_sym_class_declaration_repeat1] = STATE(2921),
    [aux_sym_class_declaration_repeat2] = STATE(3105),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1031),
    [anon_sym_unsafe] = ACTIONS(1033),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(1035),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(71),
    [anon_sym_continue] = ACTIONS(91),
    [anon_sym_do] = ACTIONS(93),
    [anon_sym_while] = ACTIONS(95),
    [anon_sym_for] = ACTIONS(97),
    [anon_sym_lock] = ACTIONS(99),
    [anon_sym_yield] = ACTIONS(101),
    [anon_sym_switch] = ACTIONS(103),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(107),
    [anon_sym_try] = ACTIONS(109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(111),
    [anon_sym_foreach] = ACTIONS(113),
    [anon_sym_goto] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(143),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [169] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2478),
    [sym_variable_declaration] = STATE(9764),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6873),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2502),
    [sym_break_statement] = STATE(2478),
    [sym_checked_statement] = STATE(2478),
    [sym_continue_statement] = STATE(2478),
    [sym_do_statement] = STATE(2478),
    [sym_empty_statement] = STATE(2478),
    [sym_expression_statement] = STATE(2478),
    [sym_fixed_statement] = STATE(2478),
    [sym_for_statement] = STATE(2478),
    [sym_return_statement] = STATE(2478),
    [sym_lock_statement] = STATE(2478),
    [sym_yield_statement] = STATE(2478),
    [sym_switch_statement] = STATE(2478),
    [sym_throw_statement] = STATE(2478),
    [sym_try_statement] = STATE(2478),
    [sym_unsafe_statement] = STATE(2478),
    [sym_using_statement] = STATE(2478),
    [sym_foreach_statement] = STATE(2478),
    [sym_goto_statement] = STATE(2478),
    [sym_labeled_statement] = STATE(2478),
    [sym_if_statement] = STATE(2478),
    [sym_while_statement] = STATE(2478),
    [sym_local_declaration_statement] = STATE(2478),
    [sym_local_function_statement] = STATE(2478),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6724),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2900),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2478),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(169),
    [sym_preproc_endregion] = STATE(169),
    [sym_preproc_line] = STATE(169),
    [sym_preproc_pragma] = STATE(169),
    [sym_preproc_nullable] = STATE(169),
    [sym_preproc_error] = STATE(169),
    [sym_preproc_define] = STATE(169),
    [sym_preproc_undef] = STATE(169),
    [aux_sym_class_declaration_repeat1] = STATE(2921),
    [aux_sym_class_declaration_repeat2] = STATE(3105),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1031),
    [anon_sym_unsafe] = ACTIONS(1033),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(1035),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(71),
    [anon_sym_continue] = ACTIONS(91),
    [anon_sym_do] = ACTIONS(93),
    [anon_sym_while] = ACTIONS(95),
    [anon_sym_for] = ACTIONS(97),
    [anon_sym_lock] = ACTIONS(99),
    [anon_sym_yield] = ACTIONS(101),
    [anon_sym_switch] = ACTIONS(103),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(107),
    [anon_sym_try] = ACTIONS(109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(111),
    [anon_sym_foreach] = ACTIONS(113),
    [anon_sym_goto] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(143),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [170] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2478),
    [sym_variable_declaration] = STATE(9764),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6873),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2432),
    [sym_break_statement] = STATE(2478),
    [sym_checked_statement] = STATE(2478),
    [sym_continue_statement] = STATE(2478),
    [sym_do_statement] = STATE(2478),
    [sym_empty_statement] = STATE(2478),
    [sym_expression_statement] = STATE(2478),
    [sym_fixed_statement] = STATE(2478),
    [sym_for_statement] = STATE(2478),
    [sym_return_statement] = STATE(2478),
    [sym_lock_statement] = STATE(2478),
    [sym_yield_statement] = STATE(2478),
    [sym_switch_statement] = STATE(2478),
    [sym_throw_statement] = STATE(2478),
    [sym_try_statement] = STATE(2478),
    [sym_unsafe_statement] = STATE(2478),
    [sym_using_statement] = STATE(2478),
    [sym_foreach_statement] = STATE(2478),
    [sym_goto_statement] = STATE(2478),
    [sym_labeled_statement] = STATE(2478),
    [sym_if_statement] = STATE(2478),
    [sym_while_statement] = STATE(2478),
    [sym_local_declaration_statement] = STATE(2478),
    [sym_local_function_statement] = STATE(2478),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6724),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2900),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2478),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(170),
    [sym_preproc_endregion] = STATE(170),
    [sym_preproc_line] = STATE(170),
    [sym_preproc_pragma] = STATE(170),
    [sym_preproc_nullable] = STATE(170),
    [sym_preproc_error] = STATE(170),
    [sym_preproc_define] = STATE(170),
    [sym_preproc_undef] = STATE(170),
    [aux_sym_class_declaration_repeat1] = STATE(2921),
    [aux_sym_class_declaration_repeat2] = STATE(3105),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1031),
    [anon_sym_unsafe] = ACTIONS(1033),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(1035),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(71),
    [anon_sym_continue] = ACTIONS(91),
    [anon_sym_do] = ACTIONS(93),
    [anon_sym_while] = ACTIONS(95),
    [anon_sym_for] = ACTIONS(97),
    [anon_sym_lock] = ACTIONS(99),
    [anon_sym_yield] = ACTIONS(101),
    [anon_sym_switch] = ACTIONS(103),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(107),
    [anon_sym_try] = ACTIONS(109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(111),
    [anon_sym_foreach] = ACTIONS(113),
    [anon_sym_goto] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(143),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [171] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2478),
    [sym_variable_declaration] = STATE(9764),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6873),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2493),
    [sym_break_statement] = STATE(2478),
    [sym_checked_statement] = STATE(2478),
    [sym_continue_statement] = STATE(2478),
    [sym_do_statement] = STATE(2478),
    [sym_empty_statement] = STATE(2478),
    [sym_expression_statement] = STATE(2478),
    [sym_fixed_statement] = STATE(2478),
    [sym_for_statement] = STATE(2478),
    [sym_return_statement] = STATE(2478),
    [sym_lock_statement] = STATE(2478),
    [sym_yield_statement] = STATE(2478),
    [sym_switch_statement] = STATE(2478),
    [sym_throw_statement] = STATE(2478),
    [sym_try_statement] = STATE(2478),
    [sym_unsafe_statement] = STATE(2478),
    [sym_using_statement] = STATE(2478),
    [sym_foreach_statement] = STATE(2478),
    [sym_goto_statement] = STATE(2478),
    [sym_labeled_statement] = STATE(2478),
    [sym_if_statement] = STATE(2478),
    [sym_while_statement] = STATE(2478),
    [sym_local_declaration_statement] = STATE(2478),
    [sym_local_function_statement] = STATE(2478),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6724),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2900),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2478),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(171),
    [sym_preproc_endregion] = STATE(171),
    [sym_preproc_line] = STATE(171),
    [sym_preproc_pragma] = STATE(171),
    [sym_preproc_nullable] = STATE(171),
    [sym_preproc_error] = STATE(171),
    [sym_preproc_define] = STATE(171),
    [sym_preproc_undef] = STATE(171),
    [aux_sym_class_declaration_repeat1] = STATE(2921),
    [aux_sym_class_declaration_repeat2] = STATE(3105),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1031),
    [anon_sym_unsafe] = ACTIONS(1033),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(1035),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(71),
    [anon_sym_continue] = ACTIONS(91),
    [anon_sym_do] = ACTIONS(93),
    [anon_sym_while] = ACTIONS(95),
    [anon_sym_for] = ACTIONS(97),
    [anon_sym_lock] = ACTIONS(99),
    [anon_sym_yield] = ACTIONS(101),
    [anon_sym_switch] = ACTIONS(103),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(107),
    [anon_sym_try] = ACTIONS(109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(111),
    [anon_sym_foreach] = ACTIONS(113),
    [anon_sym_goto] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(143),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [172] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2220),
    [sym_variable_declaration] = STATE(9437),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6809),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2228),
    [sym_break_statement] = STATE(2220),
    [sym_checked_statement] = STATE(2220),
    [sym_continue_statement] = STATE(2220),
    [sym_do_statement] = STATE(2220),
    [sym_empty_statement] = STATE(2220),
    [sym_expression_statement] = STATE(2220),
    [sym_fixed_statement] = STATE(2220),
    [sym_for_statement] = STATE(2220),
    [sym_return_statement] = STATE(2220),
    [sym_lock_statement] = STATE(2220),
    [sym_yield_statement] = STATE(2220),
    [sym_switch_statement] = STATE(2220),
    [sym_throw_statement] = STATE(2220),
    [sym_try_statement] = STATE(2220),
    [sym_unsafe_statement] = STATE(2220),
    [sym_using_statement] = STATE(2220),
    [sym_foreach_statement] = STATE(2220),
    [sym_goto_statement] = STATE(2220),
    [sym_labeled_statement] = STATE(2220),
    [sym_if_statement] = STATE(2220),
    [sym_while_statement] = STATE(2220),
    [sym_local_declaration_statement] = STATE(2220),
    [sym_local_function_statement] = STATE(2220),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6150),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2819),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2220),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(172),
    [sym_preproc_endregion] = STATE(172),
    [sym_preproc_line] = STATE(172),
    [sym_preproc_pragma] = STATE(172),
    [sym_preproc_nullable] = STATE(172),
    [sym_preproc_error] = STATE(172),
    [sym_preproc_define] = STATE(172),
    [sym_preproc_undef] = STATE(172),
    [aux_sym_class_declaration_repeat1] = STATE(2924),
    [aux_sym_class_declaration_repeat2] = STATE(3080),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(155),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1025),
    [anon_sym_unsafe] = ACTIONS(1027),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(165),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(177),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(1029),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(187),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(189),
    [anon_sym_unchecked] = ACTIONS(187),
    [anon_sym_continue] = ACTIONS(191),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_while] = ACTIONS(195),
    [anon_sym_for] = ACTIONS(197),
    [anon_sym_lock] = ACTIONS(199),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(205),
    [anon_sym_try] = ACTIONS(207),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(209),
    [anon_sym_foreach] = ACTIONS(211),
    [anon_sym_goto] = ACTIONS(213),
    [anon_sym_if] = ACTIONS(215),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(217),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [173] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2220),
    [sym_variable_declaration] = STATE(9437),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6809),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2244),
    [sym_break_statement] = STATE(2220),
    [sym_checked_statement] = STATE(2220),
    [sym_continue_statement] = STATE(2220),
    [sym_do_statement] = STATE(2220),
    [sym_empty_statement] = STATE(2220),
    [sym_expression_statement] = STATE(2220),
    [sym_fixed_statement] = STATE(2220),
    [sym_for_statement] = STATE(2220),
    [sym_return_statement] = STATE(2220),
    [sym_lock_statement] = STATE(2220),
    [sym_yield_statement] = STATE(2220),
    [sym_switch_statement] = STATE(2220),
    [sym_throw_statement] = STATE(2220),
    [sym_try_statement] = STATE(2220),
    [sym_unsafe_statement] = STATE(2220),
    [sym_using_statement] = STATE(2220),
    [sym_foreach_statement] = STATE(2220),
    [sym_goto_statement] = STATE(2220),
    [sym_labeled_statement] = STATE(2220),
    [sym_if_statement] = STATE(2220),
    [sym_while_statement] = STATE(2220),
    [sym_local_declaration_statement] = STATE(2220),
    [sym_local_function_statement] = STATE(2220),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6150),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2819),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2220),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(173),
    [sym_preproc_endregion] = STATE(173),
    [sym_preproc_line] = STATE(173),
    [sym_preproc_pragma] = STATE(173),
    [sym_preproc_nullable] = STATE(173),
    [sym_preproc_error] = STATE(173),
    [sym_preproc_define] = STATE(173),
    [sym_preproc_undef] = STATE(173),
    [aux_sym_class_declaration_repeat1] = STATE(2924),
    [aux_sym_class_declaration_repeat2] = STATE(3080),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(155),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1025),
    [anon_sym_unsafe] = ACTIONS(1027),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(165),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(177),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(1029),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(187),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(189),
    [anon_sym_unchecked] = ACTIONS(187),
    [anon_sym_continue] = ACTIONS(191),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_while] = ACTIONS(195),
    [anon_sym_for] = ACTIONS(197),
    [anon_sym_lock] = ACTIONS(199),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(205),
    [anon_sym_try] = ACTIONS(207),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(209),
    [anon_sym_foreach] = ACTIONS(211),
    [anon_sym_goto] = ACTIONS(213),
    [anon_sym_if] = ACTIONS(215),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(217),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [174] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2220),
    [sym_variable_declaration] = STATE(9437),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6809),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2245),
    [sym_break_statement] = STATE(2220),
    [sym_checked_statement] = STATE(2220),
    [sym_continue_statement] = STATE(2220),
    [sym_do_statement] = STATE(2220),
    [sym_empty_statement] = STATE(2220),
    [sym_expression_statement] = STATE(2220),
    [sym_fixed_statement] = STATE(2220),
    [sym_for_statement] = STATE(2220),
    [sym_return_statement] = STATE(2220),
    [sym_lock_statement] = STATE(2220),
    [sym_yield_statement] = STATE(2220),
    [sym_switch_statement] = STATE(2220),
    [sym_throw_statement] = STATE(2220),
    [sym_try_statement] = STATE(2220),
    [sym_unsafe_statement] = STATE(2220),
    [sym_using_statement] = STATE(2220),
    [sym_foreach_statement] = STATE(2220),
    [sym_goto_statement] = STATE(2220),
    [sym_labeled_statement] = STATE(2220),
    [sym_if_statement] = STATE(2220),
    [sym_while_statement] = STATE(2220),
    [sym_local_declaration_statement] = STATE(2220),
    [sym_local_function_statement] = STATE(2220),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6150),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2819),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2220),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(174),
    [sym_preproc_endregion] = STATE(174),
    [sym_preproc_line] = STATE(174),
    [sym_preproc_pragma] = STATE(174),
    [sym_preproc_nullable] = STATE(174),
    [sym_preproc_error] = STATE(174),
    [sym_preproc_define] = STATE(174),
    [sym_preproc_undef] = STATE(174),
    [aux_sym_class_declaration_repeat1] = STATE(2924),
    [aux_sym_class_declaration_repeat2] = STATE(3080),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(155),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1025),
    [anon_sym_unsafe] = ACTIONS(1027),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(165),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(177),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(1029),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(187),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(189),
    [anon_sym_unchecked] = ACTIONS(187),
    [anon_sym_continue] = ACTIONS(191),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_while] = ACTIONS(195),
    [anon_sym_for] = ACTIONS(197),
    [anon_sym_lock] = ACTIONS(199),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(205),
    [anon_sym_try] = ACTIONS(207),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(209),
    [anon_sym_foreach] = ACTIONS(211),
    [anon_sym_goto] = ACTIONS(213),
    [anon_sym_if] = ACTIONS(215),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(217),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [175] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(8872),
    [sym_variable_declaration] = STATE(9850),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6801),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(8782),
    [sym_break_statement] = STATE(8872),
    [sym_checked_statement] = STATE(8872),
    [sym_continue_statement] = STATE(8872),
    [sym_do_statement] = STATE(8872),
    [sym_empty_statement] = STATE(8872),
    [sym_expression_statement] = STATE(8872),
    [sym_fixed_statement] = STATE(8872),
    [sym_for_statement] = STATE(8872),
    [sym_return_statement] = STATE(8872),
    [sym_lock_statement] = STATE(8872),
    [sym_yield_statement] = STATE(8872),
    [sym_switch_statement] = STATE(8872),
    [sym_throw_statement] = STATE(8872),
    [sym_try_statement] = STATE(8872),
    [sym_unsafe_statement] = STATE(8872),
    [sym_using_statement] = STATE(8872),
    [sym_foreach_statement] = STATE(8872),
    [sym_goto_statement] = STATE(8872),
    [sym_labeled_statement] = STATE(8872),
    [sym_if_statement] = STATE(8872),
    [sym_while_statement] = STATE(8872),
    [sym_local_declaration_statement] = STATE(8872),
    [sym_local_function_statement] = STATE(8872),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6718),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2890),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(8872),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(175),
    [sym_preproc_endregion] = STATE(175),
    [sym_preproc_line] = STATE(175),
    [sym_preproc_pragma] = STATE(175),
    [sym_preproc_nullable] = STATE(175),
    [sym_preproc_error] = STATE(175),
    [sym_preproc_define] = STATE(175),
    [sym_preproc_undef] = STATE(175),
    [aux_sym_class_declaration_repeat1] = STATE(2909),
    [aux_sym_class_declaration_repeat2] = STATE(3101),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(981),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(983),
    [anon_sym_unsafe] = ACTIONS(985),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(987),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(989),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(991),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(993),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(995),
    [anon_sym_unchecked] = ACTIONS(993),
    [anon_sym_continue] = ACTIONS(997),
    [anon_sym_do] = ACTIONS(999),
    [anon_sym_while] = ACTIONS(1001),
    [anon_sym_for] = ACTIONS(1003),
    [anon_sym_lock] = ACTIONS(1005),
    [anon_sym_yield] = ACTIONS(1007),
    [anon_sym_switch] = ACTIONS(1009),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1011),
    [anon_sym_try] = ACTIONS(1013),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1015),
    [anon_sym_foreach] = ACTIONS(1017),
    [anon_sym_goto] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(1021),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1023),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [176] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2220),
    [sym_variable_declaration] = STATE(9437),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6809),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2253),
    [sym_break_statement] = STATE(2220),
    [sym_checked_statement] = STATE(2220),
    [sym_continue_statement] = STATE(2220),
    [sym_do_statement] = STATE(2220),
    [sym_empty_statement] = STATE(2220),
    [sym_expression_statement] = STATE(2220),
    [sym_fixed_statement] = STATE(2220),
    [sym_for_statement] = STATE(2220),
    [sym_return_statement] = STATE(2220),
    [sym_lock_statement] = STATE(2220),
    [sym_yield_statement] = STATE(2220),
    [sym_switch_statement] = STATE(2220),
    [sym_throw_statement] = STATE(2220),
    [sym_try_statement] = STATE(2220),
    [sym_unsafe_statement] = STATE(2220),
    [sym_using_statement] = STATE(2220),
    [sym_foreach_statement] = STATE(2220),
    [sym_goto_statement] = STATE(2220),
    [sym_labeled_statement] = STATE(2220),
    [sym_if_statement] = STATE(2220),
    [sym_while_statement] = STATE(2220),
    [sym_local_declaration_statement] = STATE(2220),
    [sym_local_function_statement] = STATE(2220),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6150),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2819),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2220),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(176),
    [sym_preproc_endregion] = STATE(176),
    [sym_preproc_line] = STATE(176),
    [sym_preproc_pragma] = STATE(176),
    [sym_preproc_nullable] = STATE(176),
    [sym_preproc_error] = STATE(176),
    [sym_preproc_define] = STATE(176),
    [sym_preproc_undef] = STATE(176),
    [aux_sym_class_declaration_repeat1] = STATE(2924),
    [aux_sym_class_declaration_repeat2] = STATE(3080),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(155),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1025),
    [anon_sym_unsafe] = ACTIONS(1027),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(165),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(177),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(1029),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(187),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(189),
    [anon_sym_unchecked] = ACTIONS(187),
    [anon_sym_continue] = ACTIONS(191),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_while] = ACTIONS(195),
    [anon_sym_for] = ACTIONS(197),
    [anon_sym_lock] = ACTIONS(199),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(205),
    [anon_sym_try] = ACTIONS(207),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(209),
    [anon_sym_foreach] = ACTIONS(211),
    [anon_sym_goto] = ACTIONS(213),
    [anon_sym_if] = ACTIONS(215),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(217),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [177] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(8872),
    [sym_variable_declaration] = STATE(9850),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6801),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(8781),
    [sym_break_statement] = STATE(8872),
    [sym_checked_statement] = STATE(8872),
    [sym_continue_statement] = STATE(8872),
    [sym_do_statement] = STATE(8872),
    [sym_empty_statement] = STATE(8872),
    [sym_expression_statement] = STATE(8872),
    [sym_fixed_statement] = STATE(8872),
    [sym_for_statement] = STATE(8872),
    [sym_return_statement] = STATE(8872),
    [sym_lock_statement] = STATE(8872),
    [sym_yield_statement] = STATE(8872),
    [sym_switch_statement] = STATE(8872),
    [sym_throw_statement] = STATE(8872),
    [sym_try_statement] = STATE(8872),
    [sym_unsafe_statement] = STATE(8872),
    [sym_using_statement] = STATE(8872),
    [sym_foreach_statement] = STATE(8872),
    [sym_goto_statement] = STATE(8872),
    [sym_labeled_statement] = STATE(8872),
    [sym_if_statement] = STATE(8872),
    [sym_while_statement] = STATE(8872),
    [sym_local_declaration_statement] = STATE(8872),
    [sym_local_function_statement] = STATE(8872),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6718),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2890),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(8872),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(177),
    [sym_preproc_endregion] = STATE(177),
    [sym_preproc_line] = STATE(177),
    [sym_preproc_pragma] = STATE(177),
    [sym_preproc_nullable] = STATE(177),
    [sym_preproc_error] = STATE(177),
    [sym_preproc_define] = STATE(177),
    [sym_preproc_undef] = STATE(177),
    [aux_sym_class_declaration_repeat1] = STATE(2909),
    [aux_sym_class_declaration_repeat2] = STATE(3101),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(981),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(983),
    [anon_sym_unsafe] = ACTIONS(985),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(987),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(989),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(991),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(993),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(995),
    [anon_sym_unchecked] = ACTIONS(993),
    [anon_sym_continue] = ACTIONS(997),
    [anon_sym_do] = ACTIONS(999),
    [anon_sym_while] = ACTIONS(1001),
    [anon_sym_for] = ACTIONS(1003),
    [anon_sym_lock] = ACTIONS(1005),
    [anon_sym_yield] = ACTIONS(1007),
    [anon_sym_switch] = ACTIONS(1009),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1011),
    [anon_sym_try] = ACTIONS(1013),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1015),
    [anon_sym_foreach] = ACTIONS(1017),
    [anon_sym_goto] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(1021),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1023),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [178] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2220),
    [sym_variable_declaration] = STATE(9437),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6809),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2254),
    [sym_break_statement] = STATE(2220),
    [sym_checked_statement] = STATE(2220),
    [sym_continue_statement] = STATE(2220),
    [sym_do_statement] = STATE(2220),
    [sym_empty_statement] = STATE(2220),
    [sym_expression_statement] = STATE(2220),
    [sym_fixed_statement] = STATE(2220),
    [sym_for_statement] = STATE(2220),
    [sym_return_statement] = STATE(2220),
    [sym_lock_statement] = STATE(2220),
    [sym_yield_statement] = STATE(2220),
    [sym_switch_statement] = STATE(2220),
    [sym_throw_statement] = STATE(2220),
    [sym_try_statement] = STATE(2220),
    [sym_unsafe_statement] = STATE(2220),
    [sym_using_statement] = STATE(2220),
    [sym_foreach_statement] = STATE(2220),
    [sym_goto_statement] = STATE(2220),
    [sym_labeled_statement] = STATE(2220),
    [sym_if_statement] = STATE(2220),
    [sym_while_statement] = STATE(2220),
    [sym_local_declaration_statement] = STATE(2220),
    [sym_local_function_statement] = STATE(2220),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6150),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2819),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2220),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(178),
    [sym_preproc_endregion] = STATE(178),
    [sym_preproc_line] = STATE(178),
    [sym_preproc_pragma] = STATE(178),
    [sym_preproc_nullable] = STATE(178),
    [sym_preproc_error] = STATE(178),
    [sym_preproc_define] = STATE(178),
    [sym_preproc_undef] = STATE(178),
    [aux_sym_class_declaration_repeat1] = STATE(2924),
    [aux_sym_class_declaration_repeat2] = STATE(3080),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(155),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1025),
    [anon_sym_unsafe] = ACTIONS(1027),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(165),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(177),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(1029),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(187),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(189),
    [anon_sym_unchecked] = ACTIONS(187),
    [anon_sym_continue] = ACTIONS(191),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_while] = ACTIONS(195),
    [anon_sym_for] = ACTIONS(197),
    [anon_sym_lock] = ACTIONS(199),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(205),
    [anon_sym_try] = ACTIONS(207),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(209),
    [anon_sym_foreach] = ACTIONS(211),
    [anon_sym_goto] = ACTIONS(213),
    [anon_sym_if] = ACTIONS(215),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(217),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [179] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2478),
    [sym_variable_declaration] = STATE(9764),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6873),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2490),
    [sym_break_statement] = STATE(2478),
    [sym_checked_statement] = STATE(2478),
    [sym_continue_statement] = STATE(2478),
    [sym_do_statement] = STATE(2478),
    [sym_empty_statement] = STATE(2478),
    [sym_expression_statement] = STATE(2478),
    [sym_fixed_statement] = STATE(2478),
    [sym_for_statement] = STATE(2478),
    [sym_return_statement] = STATE(2478),
    [sym_lock_statement] = STATE(2478),
    [sym_yield_statement] = STATE(2478),
    [sym_switch_statement] = STATE(2478),
    [sym_throw_statement] = STATE(2478),
    [sym_try_statement] = STATE(2478),
    [sym_unsafe_statement] = STATE(2478),
    [sym_using_statement] = STATE(2478),
    [sym_foreach_statement] = STATE(2478),
    [sym_goto_statement] = STATE(2478),
    [sym_labeled_statement] = STATE(2478),
    [sym_if_statement] = STATE(2478),
    [sym_while_statement] = STATE(2478),
    [sym_local_declaration_statement] = STATE(2478),
    [sym_local_function_statement] = STATE(2478),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6724),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2900),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2478),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(179),
    [sym_preproc_endregion] = STATE(179),
    [sym_preproc_line] = STATE(179),
    [sym_preproc_pragma] = STATE(179),
    [sym_preproc_nullable] = STATE(179),
    [sym_preproc_error] = STATE(179),
    [sym_preproc_define] = STATE(179),
    [sym_preproc_undef] = STATE(179),
    [aux_sym_class_declaration_repeat1] = STATE(2921),
    [aux_sym_class_declaration_repeat2] = STATE(3105),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1031),
    [anon_sym_unsafe] = ACTIONS(1033),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(1035),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(71),
    [anon_sym_continue] = ACTIONS(91),
    [anon_sym_do] = ACTIONS(93),
    [anon_sym_while] = ACTIONS(95),
    [anon_sym_for] = ACTIONS(97),
    [anon_sym_lock] = ACTIONS(99),
    [anon_sym_yield] = ACTIONS(101),
    [anon_sym_switch] = ACTIONS(103),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(107),
    [anon_sym_try] = ACTIONS(109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(111),
    [anon_sym_foreach] = ACTIONS(113),
    [anon_sym_goto] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(143),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [180] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2478),
    [sym_variable_declaration] = STATE(9764),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6873),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2489),
    [sym_break_statement] = STATE(2478),
    [sym_checked_statement] = STATE(2478),
    [sym_continue_statement] = STATE(2478),
    [sym_do_statement] = STATE(2478),
    [sym_empty_statement] = STATE(2478),
    [sym_expression_statement] = STATE(2478),
    [sym_fixed_statement] = STATE(2478),
    [sym_for_statement] = STATE(2478),
    [sym_return_statement] = STATE(2478),
    [sym_lock_statement] = STATE(2478),
    [sym_yield_statement] = STATE(2478),
    [sym_switch_statement] = STATE(2478),
    [sym_throw_statement] = STATE(2478),
    [sym_try_statement] = STATE(2478),
    [sym_unsafe_statement] = STATE(2478),
    [sym_using_statement] = STATE(2478),
    [sym_foreach_statement] = STATE(2478),
    [sym_goto_statement] = STATE(2478),
    [sym_labeled_statement] = STATE(2478),
    [sym_if_statement] = STATE(2478),
    [sym_while_statement] = STATE(2478),
    [sym_local_declaration_statement] = STATE(2478),
    [sym_local_function_statement] = STATE(2478),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6724),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2900),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2478),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(180),
    [sym_preproc_endregion] = STATE(180),
    [sym_preproc_line] = STATE(180),
    [sym_preproc_pragma] = STATE(180),
    [sym_preproc_nullable] = STATE(180),
    [sym_preproc_error] = STATE(180),
    [sym_preproc_define] = STATE(180),
    [sym_preproc_undef] = STATE(180),
    [aux_sym_class_declaration_repeat1] = STATE(2921),
    [aux_sym_class_declaration_repeat2] = STATE(3105),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1031),
    [anon_sym_unsafe] = ACTIONS(1033),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(1035),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(71),
    [anon_sym_continue] = ACTIONS(91),
    [anon_sym_do] = ACTIONS(93),
    [anon_sym_while] = ACTIONS(95),
    [anon_sym_for] = ACTIONS(97),
    [anon_sym_lock] = ACTIONS(99),
    [anon_sym_yield] = ACTIONS(101),
    [anon_sym_switch] = ACTIONS(103),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(107),
    [anon_sym_try] = ACTIONS(109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(111),
    [anon_sym_foreach] = ACTIONS(113),
    [anon_sym_goto] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(143),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [181] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(8872),
    [sym_variable_declaration] = STATE(9850),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6801),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(8775),
    [sym_break_statement] = STATE(8872),
    [sym_checked_statement] = STATE(8872),
    [sym_continue_statement] = STATE(8872),
    [sym_do_statement] = STATE(8872),
    [sym_empty_statement] = STATE(8872),
    [sym_expression_statement] = STATE(8872),
    [sym_fixed_statement] = STATE(8872),
    [sym_for_statement] = STATE(8872),
    [sym_return_statement] = STATE(8872),
    [sym_lock_statement] = STATE(8872),
    [sym_yield_statement] = STATE(8872),
    [sym_switch_statement] = STATE(8872),
    [sym_throw_statement] = STATE(8872),
    [sym_try_statement] = STATE(8872),
    [sym_unsafe_statement] = STATE(8872),
    [sym_using_statement] = STATE(8872),
    [sym_foreach_statement] = STATE(8872),
    [sym_goto_statement] = STATE(8872),
    [sym_labeled_statement] = STATE(8872),
    [sym_if_statement] = STATE(8872),
    [sym_while_statement] = STATE(8872),
    [sym_local_declaration_statement] = STATE(8872),
    [sym_local_function_statement] = STATE(8872),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6718),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2890),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(8872),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(181),
    [sym_preproc_endregion] = STATE(181),
    [sym_preproc_line] = STATE(181),
    [sym_preproc_pragma] = STATE(181),
    [sym_preproc_nullable] = STATE(181),
    [sym_preproc_error] = STATE(181),
    [sym_preproc_define] = STATE(181),
    [sym_preproc_undef] = STATE(181),
    [aux_sym_class_declaration_repeat1] = STATE(2909),
    [aux_sym_class_declaration_repeat2] = STATE(3101),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(981),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(983),
    [anon_sym_unsafe] = ACTIONS(985),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(987),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(989),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(991),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(993),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(995),
    [anon_sym_unchecked] = ACTIONS(993),
    [anon_sym_continue] = ACTIONS(997),
    [anon_sym_do] = ACTIONS(999),
    [anon_sym_while] = ACTIONS(1001),
    [anon_sym_for] = ACTIONS(1003),
    [anon_sym_lock] = ACTIONS(1005),
    [anon_sym_yield] = ACTIONS(1007),
    [anon_sym_switch] = ACTIONS(1009),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1011),
    [anon_sym_try] = ACTIONS(1013),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1015),
    [anon_sym_foreach] = ACTIONS(1017),
    [anon_sym_goto] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(1021),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1023),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [182] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2220),
    [sym_variable_declaration] = STATE(9437),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6809),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2258),
    [sym_break_statement] = STATE(2220),
    [sym_checked_statement] = STATE(2220),
    [sym_continue_statement] = STATE(2220),
    [sym_do_statement] = STATE(2220),
    [sym_empty_statement] = STATE(2220),
    [sym_expression_statement] = STATE(2220),
    [sym_fixed_statement] = STATE(2220),
    [sym_for_statement] = STATE(2220),
    [sym_return_statement] = STATE(2220),
    [sym_lock_statement] = STATE(2220),
    [sym_yield_statement] = STATE(2220),
    [sym_switch_statement] = STATE(2220),
    [sym_throw_statement] = STATE(2220),
    [sym_try_statement] = STATE(2220),
    [sym_unsafe_statement] = STATE(2220),
    [sym_using_statement] = STATE(2220),
    [sym_foreach_statement] = STATE(2220),
    [sym_goto_statement] = STATE(2220),
    [sym_labeled_statement] = STATE(2220),
    [sym_if_statement] = STATE(2220),
    [sym_while_statement] = STATE(2220),
    [sym_local_declaration_statement] = STATE(2220),
    [sym_local_function_statement] = STATE(2220),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6150),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2819),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2220),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(182),
    [sym_preproc_endregion] = STATE(182),
    [sym_preproc_line] = STATE(182),
    [sym_preproc_pragma] = STATE(182),
    [sym_preproc_nullable] = STATE(182),
    [sym_preproc_error] = STATE(182),
    [sym_preproc_define] = STATE(182),
    [sym_preproc_undef] = STATE(182),
    [aux_sym_class_declaration_repeat1] = STATE(2924),
    [aux_sym_class_declaration_repeat2] = STATE(3080),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(155),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1025),
    [anon_sym_unsafe] = ACTIONS(1027),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(165),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(177),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(1029),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(187),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(189),
    [anon_sym_unchecked] = ACTIONS(187),
    [anon_sym_continue] = ACTIONS(191),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_while] = ACTIONS(195),
    [anon_sym_for] = ACTIONS(197),
    [anon_sym_lock] = ACTIONS(199),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(205),
    [anon_sym_try] = ACTIONS(207),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(209),
    [anon_sym_foreach] = ACTIONS(211),
    [anon_sym_goto] = ACTIONS(213),
    [anon_sym_if] = ACTIONS(215),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(217),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [183] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(2478),
    [sym_variable_declaration] = STATE(9764),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6873),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_statement] = STATE(2486),
    [sym_break_statement] = STATE(2478),
    [sym_checked_statement] = STATE(2478),
    [sym_continue_statement] = STATE(2478),
    [sym_do_statement] = STATE(2478),
    [sym_empty_statement] = STATE(2478),
    [sym_expression_statement] = STATE(2478),
    [sym_fixed_statement] = STATE(2478),
    [sym_for_statement] = STATE(2478),
    [sym_return_statement] = STATE(2478),
    [sym_lock_statement] = STATE(2478),
    [sym_yield_statement] = STATE(2478),
    [sym_switch_statement] = STATE(2478),
    [sym_throw_statement] = STATE(2478),
    [sym_try_statement] = STATE(2478),
    [sym_unsafe_statement] = STATE(2478),
    [sym_using_statement] = STATE(2478),
    [sym_foreach_statement] = STATE(2478),
    [sym_goto_statement] = STATE(2478),
    [sym_labeled_statement] = STATE(2478),
    [sym_if_statement] = STATE(2478),
    [sym_while_statement] = STATE(2478),
    [sym_local_declaration_statement] = STATE(2478),
    [sym_local_function_statement] = STATE(2478),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(6724),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2900),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_top_level] = STATE(2478),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(183),
    [sym_preproc_endregion] = STATE(183),
    [sym_preproc_line] = STATE(183),
    [sym_preproc_pragma] = STATE(183),
    [sym_preproc_nullable] = STATE(183),
    [sym_preproc_error] = STATE(183),
    [sym_preproc_define] = STATE(183),
    [sym_preproc_undef] = STATE(183),
    [aux_sym_class_declaration_repeat1] = STATE(2921),
    [aux_sym_class_declaration_repeat2] = STATE(3105),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1031),
    [anon_sym_unsafe] = ACTIONS(1033),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(1035),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(669),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(71),
    [anon_sym_continue] = ACTIONS(91),
    [anon_sym_do] = ACTIONS(93),
    [anon_sym_while] = ACTIONS(95),
    [anon_sym_for] = ACTIONS(97),
    [anon_sym_lock] = ACTIONS(99),
    [anon_sym_yield] = ACTIONS(101),
    [anon_sym_switch] = ACTIONS(103),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(107),
    [anon_sym_try] = ACTIONS(109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(111),
    [anon_sym_foreach] = ACTIONS(113),
    [anon_sym_goto] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(143),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [184] = {
    [sym_attribute] = STATE(8527),
    [sym_attribute_list] = STATE(6703),
    [sym_attribute_target_specifier] = STATE(6777),
    [sym_parameter_list] = STATE(9765),
    [sym_argument] = STATE(8389),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6509),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2787),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(5865),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_pattern] = STATE(7928),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(6141),
    [sym_property_pattern_clause] = STATE(6672),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6206),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(5071),
    [sym_postfix_unary_expression] = STATE(5061),
    [sym_prefix_unary_expression] = STATE(5061),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(5071),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(5061),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(5071),
    [sym_member_access_expression] = STATE(3775),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(5061),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(5071),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(5071),
    [sym_typeof_expression] = STATE(5071),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3775),
    [sym_literal] = STATE(5071),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2767),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(184),
    [sym_preproc_endregion] = STATE(184),
    [sym_preproc_line] = STATE(184),
    [sym_preproc_pragma] = STATE(184),
    [sym_preproc_nullable] = STATE(184),
    [sym_preproc_error] = STATE(184),
    [sym_preproc_define] = STATE(184),
    [sym_preproc_undef] = STATE(184),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_RBRACK] = ACTIONS(1041),
    [anon_sym_LPAREN] = ACTIONS(1043),
    [anon_sym_field] = ACTIONS(1045),
    [anon_sym_event] = ACTIONS(1045),
    [anon_sym_method] = ACTIONS(1045),
    [anon_sym_param] = ACTIONS(1045),
    [anon_sym_property] = ACTIONS(1045),
    [anon_sym_return] = ACTIONS(1045),
    [anon_sym_type] = ACTIONS(1045),
    [anon_sym_ref] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1053),
    [anon_sym_in] = ACTIONS(1055),
    [anon_sym_out] = ACTIONS(1055),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1059),
    [anon_sym_TILDE] = ACTIONS(1059),
    [anon_sym_PLUS_PLUS] = ACTIONS(1059),
    [anon_sym_DASH_DASH] = ACTIONS(1059),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1061),
    [anon_sym_DASH] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_GT_EQ] = ACTIONS(1063),
    [anon_sym_LT_EQ] = ACTIONS(1063),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1065),
    [anon_sym_var] = ACTIONS(1067),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(1075),
    [anon_sym_not] = ACTIONS(1077),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [185] = {
    [sym_attribute] = STATE(8527),
    [sym_attribute_list] = STATE(6703),
    [sym_attribute_target_specifier] = STATE(6777),
    [sym_parameter_list] = STATE(9765),
    [sym_argument] = STATE(8389),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6509),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2787),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(5865),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_pattern] = STATE(8112),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(6141),
    [sym_property_pattern_clause] = STATE(6672),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6206),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(5071),
    [sym_postfix_unary_expression] = STATE(5061),
    [sym_prefix_unary_expression] = STATE(5061),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(5071),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(5061),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(5071),
    [sym_member_access_expression] = STATE(3775),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(5061),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(5071),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(5071),
    [sym_typeof_expression] = STATE(5071),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3775),
    [sym_literal] = STATE(5071),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2767),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(185),
    [sym_preproc_endregion] = STATE(185),
    [sym_preproc_line] = STATE(185),
    [sym_preproc_pragma] = STATE(185),
    [sym_preproc_nullable] = STATE(185),
    [sym_preproc_error] = STATE(185),
    [sym_preproc_define] = STATE(185),
    [sym_preproc_undef] = STATE(185),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_RBRACK] = ACTIONS(1081),
    [anon_sym_LPAREN] = ACTIONS(1043),
    [anon_sym_field] = ACTIONS(1045),
    [anon_sym_event] = ACTIONS(1045),
    [anon_sym_method] = ACTIONS(1045),
    [anon_sym_param] = ACTIONS(1045),
    [anon_sym_property] = ACTIONS(1045),
    [anon_sym_return] = ACTIONS(1045),
    [anon_sym_type] = ACTIONS(1045),
    [anon_sym_ref] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1053),
    [anon_sym_in] = ACTIONS(1055),
    [anon_sym_out] = ACTIONS(1055),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1059),
    [anon_sym_TILDE] = ACTIONS(1059),
    [anon_sym_PLUS_PLUS] = ACTIONS(1059),
    [anon_sym_DASH_DASH] = ACTIONS(1059),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1061),
    [anon_sym_DASH] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_GT_EQ] = ACTIONS(1063),
    [anon_sym_LT_EQ] = ACTIONS(1063),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1065),
    [anon_sym_var] = ACTIONS(1067),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(1083),
    [anon_sym_not] = ACTIONS(1077),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [186] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_parameter] = STATE(8382),
    [sym__parameter_array] = STATE(8390),
    [sym_argument] = STATE(8836),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2787),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(5935),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_tuple_element] = STATE(8846),
    [sym_pattern] = STATE(8253),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(6141),
    [sym_property_pattern_clause] = STATE(6672),
    [sym_subpattern] = STATE(8877),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym__variable_designation] = STATE(8365),
    [sym_parenthesized_variable_designation] = STATE(4274),
    [sym_expression] = STATE(6145),
    [sym_non_lvalue_expression] = STATE(6331),
    [sym_lvalue_expression] = STATE(4306),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(5071),
    [sym_postfix_unary_expression] = STATE(5061),
    [sym_prefix_unary_expression] = STATE(5061),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(5071),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(5061),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(5071),
    [sym_member_access_expression] = STATE(3775),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(5061),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9027),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(5071),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(5071),
    [sym_typeof_expression] = STATE(5071),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3775),
    [sym_literal] = STATE(5071),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2783),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(186),
    [sym_preproc_endregion] = STATE(186),
    [sym_preproc_line] = STATE(186),
    [sym_preproc_pragma] = STATE(186),
    [sym_preproc_nullable] = STATE(186),
    [sym_preproc_error] = STATE(186),
    [sym_preproc_define] = STATE(186),
    [sym_preproc_undef] = STATE(186),
    [aux_sym_class_declaration_repeat1] = STATE(3550),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4143),
    [aux_sym_lambda_expression_repeat1] = STATE(4220),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(1085),
    [anon_sym_RPAREN] = ACTIONS(1087),
    [anon_sym_ref] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_readonly] = ACTIONS(1093),
    [anon_sym_LT] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1053),
    [anon_sym_in] = ACTIONS(1095),
    [anon_sym_out] = ACTIONS(1095),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1097),
    [anon_sym_TILDE] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1099),
    [anon_sym_DASH] = ACTIONS(1099),
    [anon_sym_STAR] = ACTIONS(1101),
    [anon_sym_CARET] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1097),
    [anon_sym_GT_EQ] = ACTIONS(1063),
    [anon_sym_LT_EQ] = ACTIONS(1063),
    [anon_sym_this] = ACTIONS(1103),
    [anon_sym_scoped] = ACTIONS(1105),
    [anon_sym_params] = ACTIONS(1107),
    [anon_sym_var] = ACTIONS(1067),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1111),
    [sym_discard] = ACTIONS(1113),
    [anon_sym_DOT_DOT] = ACTIONS(1115),
    [anon_sym_not] = ACTIONS(1117),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [187] = {
    [sym_attribute] = STATE(8527),
    [sym_attribute_list] = STATE(6703),
    [sym_attribute_target_specifier] = STATE(6777),
    [sym_parameter_list] = STATE(9765),
    [sym_argument] = STATE(8389),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6509),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2787),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(5865),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_pattern] = STATE(8183),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(6141),
    [sym_property_pattern_clause] = STATE(6672),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6206),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(5071),
    [sym_postfix_unary_expression] = STATE(5061),
    [sym_prefix_unary_expression] = STATE(5061),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(5071),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(5061),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(5071),
    [sym_member_access_expression] = STATE(3775),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(5061),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(5071),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(5071),
    [sym_typeof_expression] = STATE(5071),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3775),
    [sym_literal] = STATE(5071),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2767),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(187),
    [sym_preproc_endregion] = STATE(187),
    [sym_preproc_line] = STATE(187),
    [sym_preproc_pragma] = STATE(187),
    [sym_preproc_nullable] = STATE(187),
    [sym_preproc_error] = STATE(187),
    [sym_preproc_define] = STATE(187),
    [sym_preproc_undef] = STATE(187),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_RBRACK] = ACTIONS(1119),
    [anon_sym_LPAREN] = ACTIONS(1043),
    [anon_sym_field] = ACTIONS(1045),
    [anon_sym_event] = ACTIONS(1045),
    [anon_sym_method] = ACTIONS(1045),
    [anon_sym_param] = ACTIONS(1045),
    [anon_sym_property] = ACTIONS(1045),
    [anon_sym_return] = ACTIONS(1045),
    [anon_sym_type] = ACTIONS(1045),
    [anon_sym_ref] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1053),
    [anon_sym_in] = ACTIONS(1055),
    [anon_sym_out] = ACTIONS(1055),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1059),
    [anon_sym_TILDE] = ACTIONS(1059),
    [anon_sym_PLUS_PLUS] = ACTIONS(1059),
    [anon_sym_DASH_DASH] = ACTIONS(1059),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1061),
    [anon_sym_DASH] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_GT_EQ] = ACTIONS(1063),
    [anon_sym_LT_EQ] = ACTIONS(1063),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1065),
    [anon_sym_var] = ACTIONS(1067),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(1121),
    [anon_sym_not] = ACTIONS(1077),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [188] = {
    [sym_attribute] = STATE(8527),
    [sym_attribute_list] = STATE(6703),
    [sym_attribute_target_specifier] = STATE(6777),
    [sym_parameter_list] = STATE(9765),
    [sym_argument] = STATE(8389),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6509),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2787),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(5865),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_pattern] = STATE(7913),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(6141),
    [sym_property_pattern_clause] = STATE(6672),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6206),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(5071),
    [sym_postfix_unary_expression] = STATE(5061),
    [sym_prefix_unary_expression] = STATE(5061),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(5071),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(5061),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(5071),
    [sym_member_access_expression] = STATE(3775),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(5061),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(5071),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(5071),
    [sym_typeof_expression] = STATE(5071),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3775),
    [sym_literal] = STATE(5071),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2767),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(188),
    [sym_preproc_endregion] = STATE(188),
    [sym_preproc_line] = STATE(188),
    [sym_preproc_pragma] = STATE(188),
    [sym_preproc_nullable] = STATE(188),
    [sym_preproc_error] = STATE(188),
    [sym_preproc_define] = STATE(188),
    [sym_preproc_undef] = STATE(188),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_RBRACK] = ACTIONS(1123),
    [anon_sym_LPAREN] = ACTIONS(1043),
    [anon_sym_field] = ACTIONS(1045),
    [anon_sym_event] = ACTIONS(1045),
    [anon_sym_method] = ACTIONS(1045),
    [anon_sym_param] = ACTIONS(1045),
    [anon_sym_property] = ACTIONS(1045),
    [anon_sym_return] = ACTIONS(1045),
    [anon_sym_type] = ACTIONS(1045),
    [anon_sym_ref] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1053),
    [anon_sym_in] = ACTIONS(1055),
    [anon_sym_out] = ACTIONS(1055),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1059),
    [anon_sym_TILDE] = ACTIONS(1059),
    [anon_sym_PLUS_PLUS] = ACTIONS(1059),
    [anon_sym_DASH_DASH] = ACTIONS(1059),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1061),
    [anon_sym_DASH] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_GT_EQ] = ACTIONS(1063),
    [anon_sym_LT_EQ] = ACTIONS(1063),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1065),
    [anon_sym_var] = ACTIONS(1067),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(1125),
    [anon_sym_not] = ACTIONS(1077),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [189] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_parameter] = STATE(8382),
    [sym__parameter_array] = STATE(8390),
    [sym_argument] = STATE(8836),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2787),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(5935),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_tuple_element] = STATE(8846),
    [sym_pattern] = STATE(8253),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(6141),
    [sym_property_pattern_clause] = STATE(6672),
    [sym_subpattern] = STATE(8877),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym__variable_designation] = STATE(8365),
    [sym_parenthesized_variable_designation] = STATE(4274),
    [sym_expression] = STATE(6145),
    [sym_non_lvalue_expression] = STATE(6331),
    [sym_lvalue_expression] = STATE(4306),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(5071),
    [sym_postfix_unary_expression] = STATE(5061),
    [sym_prefix_unary_expression] = STATE(5061),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(5071),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(5061),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(5071),
    [sym_member_access_expression] = STATE(3775),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(5061),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9027),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(5071),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(5071),
    [sym_typeof_expression] = STATE(5071),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3775),
    [sym_literal] = STATE(5071),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2783),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(189),
    [sym_preproc_endregion] = STATE(189),
    [sym_preproc_line] = STATE(189),
    [sym_preproc_pragma] = STATE(189),
    [sym_preproc_nullable] = STATE(189),
    [sym_preproc_error] = STATE(189),
    [sym_preproc_define] = STATE(189),
    [sym_preproc_undef] = STATE(189),
    [aux_sym_class_declaration_repeat1] = STATE(3550),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4143),
    [aux_sym_lambda_expression_repeat1] = STATE(4220),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(1085),
    [anon_sym_RPAREN] = ACTIONS(1127),
    [anon_sym_ref] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_readonly] = ACTIONS(1093),
    [anon_sym_LT] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1053),
    [anon_sym_in] = ACTIONS(1095),
    [anon_sym_out] = ACTIONS(1095),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1097),
    [anon_sym_TILDE] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1099),
    [anon_sym_DASH] = ACTIONS(1099),
    [anon_sym_STAR] = ACTIONS(1101),
    [anon_sym_CARET] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1097),
    [anon_sym_GT_EQ] = ACTIONS(1063),
    [anon_sym_LT_EQ] = ACTIONS(1063),
    [anon_sym_this] = ACTIONS(1103),
    [anon_sym_scoped] = ACTIONS(1105),
    [anon_sym_params] = ACTIONS(1107),
    [anon_sym_var] = ACTIONS(1067),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1111),
    [sym_discard] = ACTIONS(1113),
    [anon_sym_DOT_DOT] = ACTIONS(1115),
    [anon_sym_not] = ACTIONS(1117),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [190] = {
    [sym_attribute] = STATE(8527),
    [sym_attribute_list] = STATE(6703),
    [sym_attribute_target_specifier] = STATE(6777),
    [sym_parameter_list] = STATE(9765),
    [sym_argument] = STATE(8389),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6509),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2787),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(5865),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_pattern] = STATE(8053),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(6141),
    [sym_property_pattern_clause] = STATE(6672),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6206),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(5071),
    [sym_postfix_unary_expression] = STATE(5061),
    [sym_prefix_unary_expression] = STATE(5061),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(5071),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(5061),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(5071),
    [sym_member_access_expression] = STATE(3775),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(5061),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(5071),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(5071),
    [sym_typeof_expression] = STATE(5071),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3775),
    [sym_literal] = STATE(5071),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2767),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(190),
    [sym_preproc_endregion] = STATE(190),
    [sym_preproc_line] = STATE(190),
    [sym_preproc_pragma] = STATE(190),
    [sym_preproc_nullable] = STATE(190),
    [sym_preproc_error] = STATE(190),
    [sym_preproc_define] = STATE(190),
    [sym_preproc_undef] = STATE(190),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_RBRACK] = ACTIONS(1129),
    [anon_sym_LPAREN] = ACTIONS(1043),
    [anon_sym_field] = ACTIONS(1045),
    [anon_sym_event] = ACTIONS(1045),
    [anon_sym_method] = ACTIONS(1045),
    [anon_sym_param] = ACTIONS(1045),
    [anon_sym_property] = ACTIONS(1045),
    [anon_sym_return] = ACTIONS(1045),
    [anon_sym_type] = ACTIONS(1045),
    [anon_sym_ref] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1053),
    [anon_sym_in] = ACTIONS(1055),
    [anon_sym_out] = ACTIONS(1055),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1059),
    [anon_sym_TILDE] = ACTIONS(1059),
    [anon_sym_PLUS_PLUS] = ACTIONS(1059),
    [anon_sym_DASH_DASH] = ACTIONS(1059),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1061),
    [anon_sym_DASH] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_GT_EQ] = ACTIONS(1063),
    [anon_sym_LT_EQ] = ACTIONS(1063),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1065),
    [anon_sym_var] = ACTIONS(1067),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(1131),
    [anon_sym_not] = ACTIONS(1077),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [191] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6913),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7016),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4493),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(3582),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7407),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9275),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(191),
    [sym_preproc_endregion] = STATE(191),
    [sym_preproc_line] = STATE(191),
    [sym_preproc_pragma] = STATE(191),
    [sym_preproc_nullable] = STATE(191),
    [sym_preproc_error] = STATE(191),
    [sym_preproc_define] = STATE(191),
    [sym_preproc_undef] = STATE(191),
    [aux_sym_class_declaration_repeat1] = STATE(3789),
    [aux_sym_lambda_expression_repeat1] = STATE(4086),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(1133),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_COMMA] = ACTIONS(1133),
    [anon_sym_RBRACK] = ACTIONS(1133),
    [anon_sym_LPAREN] = ACTIONS(1137),
    [anon_sym_RPAREN] = ACTIONS(1133),
    [anon_sym_ref] = ACTIONS(1139),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_RBRACE] = ACTIONS(1133),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1145),
    [anon_sym_LT] = ACTIONS(1147),
    [anon_sym_GT] = ACTIONS(1147),
    [anon_sym_in] = ACTIONS(1147),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1147),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1151),
    [anon_sym_TILDE] = ACTIONS(1153),
    [anon_sym_PLUS_PLUS] = ACTIONS(1153),
    [anon_sym_DASH_DASH] = ACTIONS(1153),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1151),
    [anon_sym_DASH] = ACTIONS(1151),
    [anon_sym_STAR] = ACTIONS(1157),
    [anon_sym_SLASH] = ACTIONS(1147),
    [anon_sym_PERCENT] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(1153),
    [anon_sym_PIPE] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(1151),
    [anon_sym_LT_LT] = ACTIONS(1133),
    [anon_sym_GT_GT] = ACTIONS(1147),
    [anon_sym_GT_GT_GT] = ACTIONS(1133),
    [anon_sym_EQ_EQ] = ACTIONS(1133),
    [anon_sym_BANG_EQ] = ACTIONS(1133),
    [anon_sym_GT_EQ] = ACTIONS(1133),
    [anon_sym_LT_EQ] = ACTIONS(1133),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_DOT] = ACTIONS(1147),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1147),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1165),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1167),
    [anon_sym_DOT_DOT] = ACTIONS(1169),
    [anon_sym_and] = ACTIONS(1147),
    [anon_sym_or] = ACTIONS(1147),
    [anon_sym_AMP_AMP] = ACTIONS(1133),
    [anon_sym_PIPE_PIPE] = ACTIONS(1133),
    [anon_sym_QMARK_QMARK] = ACTIONS(1133),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1147),
    [anon_sym_is] = ACTIONS(1147),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_DASH_GT] = ACTIONS(1133),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_with] = ACTIONS(1147),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_if_token3] = ACTIONS(1133),
    [aux_sym_preproc_else_token1] = ACTIONS(1133),
    [aux_sym_preproc_elif_token1] = ACTIONS(1133),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [192] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6913),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7016),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4460),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(3582),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7407),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9275),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(192),
    [sym_preproc_endregion] = STATE(192),
    [sym_preproc_line] = STATE(192),
    [sym_preproc_pragma] = STATE(192),
    [sym_preproc_nullable] = STATE(192),
    [sym_preproc_error] = STATE(192),
    [sym_preproc_define] = STATE(192),
    [sym_preproc_undef] = STATE(192),
    [aux_sym_class_declaration_repeat1] = STATE(3789),
    [aux_sym_lambda_expression_repeat1] = STATE(4086),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(1199),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_COMMA] = ACTIONS(1199),
    [anon_sym_RBRACK] = ACTIONS(1199),
    [anon_sym_LPAREN] = ACTIONS(1137),
    [anon_sym_RPAREN] = ACTIONS(1199),
    [anon_sym_ref] = ACTIONS(1139),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_RBRACE] = ACTIONS(1199),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1145),
    [anon_sym_LT] = ACTIONS(1201),
    [anon_sym_GT] = ACTIONS(1201),
    [anon_sym_in] = ACTIONS(1201),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1201),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1151),
    [anon_sym_TILDE] = ACTIONS(1153),
    [anon_sym_PLUS_PLUS] = ACTIONS(1153),
    [anon_sym_DASH_DASH] = ACTIONS(1153),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1151),
    [anon_sym_DASH] = ACTIONS(1151),
    [anon_sym_STAR] = ACTIONS(1157),
    [anon_sym_SLASH] = ACTIONS(1201),
    [anon_sym_PERCENT] = ACTIONS(1199),
    [anon_sym_CARET] = ACTIONS(1153),
    [anon_sym_PIPE] = ACTIONS(1201),
    [anon_sym_AMP] = ACTIONS(1151),
    [anon_sym_LT_LT] = ACTIONS(1199),
    [anon_sym_GT_GT] = ACTIONS(1201),
    [anon_sym_GT_GT_GT] = ACTIONS(1199),
    [anon_sym_EQ_EQ] = ACTIONS(1199),
    [anon_sym_BANG_EQ] = ACTIONS(1199),
    [anon_sym_GT_EQ] = ACTIONS(1199),
    [anon_sym_LT_EQ] = ACTIONS(1199),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_DOT] = ACTIONS(1201),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1201),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1165),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1167),
    [anon_sym_DOT_DOT] = ACTIONS(1169),
    [anon_sym_and] = ACTIONS(1201),
    [anon_sym_or] = ACTIONS(1201),
    [anon_sym_AMP_AMP] = ACTIONS(1199),
    [anon_sym_PIPE_PIPE] = ACTIONS(1199),
    [anon_sym_QMARK_QMARK] = ACTIONS(1199),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1201),
    [anon_sym_is] = ACTIONS(1201),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_DASH_GT] = ACTIONS(1199),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_with] = ACTIONS(1201),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_if_token3] = ACTIONS(1199),
    [aux_sym_preproc_else_token1] = ACTIONS(1199),
    [aux_sym_preproc_elif_token1] = ACTIONS(1199),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [193] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_parameter] = STATE(8382),
    [sym__parameter_array] = STATE(8390),
    [sym_argument] = STATE(8885),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2787),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6034),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_tuple_element] = STATE(8706),
    [sym_pattern] = STATE(8317),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(6141),
    [sym_property_pattern_clause] = STATE(6672),
    [sym_subpattern] = STATE(8877),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6145),
    [sym_non_lvalue_expression] = STATE(6400),
    [sym_lvalue_expression] = STATE(4306),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(5071),
    [sym_postfix_unary_expression] = STATE(5061),
    [sym_prefix_unary_expression] = STATE(5061),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(5071),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(5061),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(5071),
    [sym_member_access_expression] = STATE(3775),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(5061),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9027),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(5071),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(5071),
    [sym_typeof_expression] = STATE(5071),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3775),
    [sym_literal] = STATE(5071),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2773),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(193),
    [sym_preproc_endregion] = STATE(193),
    [sym_preproc_line] = STATE(193),
    [sym_preproc_pragma] = STATE(193),
    [sym_preproc_nullable] = STATE(193),
    [sym_preproc_error] = STATE(193),
    [sym_preproc_define] = STATE(193),
    [sym_preproc_undef] = STATE(193),
    [aux_sym_class_declaration_repeat1] = STATE(3550),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4143),
    [aux_sym_lambda_expression_repeat1] = STATE(4220),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(1203),
    [anon_sym_RPAREN] = ACTIONS(1205),
    [anon_sym_ref] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_readonly] = ACTIONS(1093),
    [anon_sym_LT] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1053),
    [anon_sym_in] = ACTIONS(1095),
    [anon_sym_out] = ACTIONS(1095),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1097),
    [anon_sym_TILDE] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1099),
    [anon_sym_DASH] = ACTIONS(1099),
    [anon_sym_STAR] = ACTIONS(1101),
    [anon_sym_CARET] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1097),
    [anon_sym_GT_EQ] = ACTIONS(1063),
    [anon_sym_LT_EQ] = ACTIONS(1063),
    [anon_sym_this] = ACTIONS(1103),
    [anon_sym_scoped] = ACTIONS(1105),
    [anon_sym_params] = ACTIONS(1107),
    [anon_sym_var] = ACTIONS(1067),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1111),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(1115),
    [anon_sym_not] = ACTIONS(1117),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [194] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_parameter] = STATE(8382),
    [sym__parameter_array] = STATE(8390),
    [sym_argument] = STATE(8836),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2787),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(5859),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_tuple_element] = STATE(8706),
    [sym_pattern] = STATE(8253),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(6141),
    [sym_property_pattern_clause] = STATE(6672),
    [sym_subpattern] = STATE(8877),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6145),
    [sym_non_lvalue_expression] = STATE(6331),
    [sym_lvalue_expression] = STATE(4306),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(5071),
    [sym_postfix_unary_expression] = STATE(5061),
    [sym_prefix_unary_expression] = STATE(5061),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(5071),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(5061),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(5071),
    [sym_member_access_expression] = STATE(3775),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(5061),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9027),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(5071),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(5071),
    [sym_typeof_expression] = STATE(5071),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3775),
    [sym_literal] = STATE(5071),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2773),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(194),
    [sym_preproc_endregion] = STATE(194),
    [sym_preproc_line] = STATE(194),
    [sym_preproc_pragma] = STATE(194),
    [sym_preproc_nullable] = STATE(194),
    [sym_preproc_error] = STATE(194),
    [sym_preproc_define] = STATE(194),
    [sym_preproc_undef] = STATE(194),
    [aux_sym_class_declaration_repeat1] = STATE(3550),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4143),
    [aux_sym_lambda_expression_repeat1] = STATE(4220),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(1203),
    [anon_sym_RPAREN] = ACTIONS(1207),
    [anon_sym_ref] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_readonly] = ACTIONS(1093),
    [anon_sym_LT] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1053),
    [anon_sym_in] = ACTIONS(1095),
    [anon_sym_out] = ACTIONS(1095),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1097),
    [anon_sym_TILDE] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1099),
    [anon_sym_DASH] = ACTIONS(1099),
    [anon_sym_STAR] = ACTIONS(1101),
    [anon_sym_CARET] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1097),
    [anon_sym_GT_EQ] = ACTIONS(1063),
    [anon_sym_LT_EQ] = ACTIONS(1063),
    [anon_sym_this] = ACTIONS(1103),
    [anon_sym_scoped] = ACTIONS(1105),
    [anon_sym_params] = ACTIONS(1107),
    [anon_sym_var] = ACTIONS(1067),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1111),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(1115),
    [anon_sym_not] = ACTIONS(1117),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [195] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_parameter] = STATE(8382),
    [sym__parameter_array] = STATE(8390),
    [sym_argument] = STATE(8836),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2787),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(5913),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_tuple_element] = STATE(8706),
    [sym_pattern] = STATE(8253),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(6141),
    [sym_property_pattern_clause] = STATE(6672),
    [sym_subpattern] = STATE(8877),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6145),
    [sym_non_lvalue_expression] = STATE(6331),
    [sym_lvalue_expression] = STATE(4306),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(5071),
    [sym_postfix_unary_expression] = STATE(5061),
    [sym_prefix_unary_expression] = STATE(5061),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(5071),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(5061),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(5071),
    [sym_member_access_expression] = STATE(3775),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(5061),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9027),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(5071),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(5071),
    [sym_typeof_expression] = STATE(5071),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3775),
    [sym_literal] = STATE(5071),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2773),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(195),
    [sym_preproc_endregion] = STATE(195),
    [sym_preproc_line] = STATE(195),
    [sym_preproc_pragma] = STATE(195),
    [sym_preproc_nullable] = STATE(195),
    [sym_preproc_error] = STATE(195),
    [sym_preproc_define] = STATE(195),
    [sym_preproc_undef] = STATE(195),
    [aux_sym_class_declaration_repeat1] = STATE(3550),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4143),
    [aux_sym_lambda_expression_repeat1] = STATE(4220),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(1203),
    [anon_sym_RPAREN] = ACTIONS(1207),
    [anon_sym_ref] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_readonly] = ACTIONS(1093),
    [anon_sym_LT] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1053),
    [anon_sym_in] = ACTIONS(1095),
    [anon_sym_out] = ACTIONS(1095),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1097),
    [anon_sym_TILDE] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1099),
    [anon_sym_DASH] = ACTIONS(1099),
    [anon_sym_STAR] = ACTIONS(1101),
    [anon_sym_CARET] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1097),
    [anon_sym_GT_EQ] = ACTIONS(1063),
    [anon_sym_LT_EQ] = ACTIONS(1063),
    [anon_sym_this] = ACTIONS(1103),
    [anon_sym_scoped] = ACTIONS(1105),
    [anon_sym_params] = ACTIONS(1107),
    [anon_sym_var] = ACTIONS(1067),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1111),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(1115),
    [anon_sym_not] = ACTIONS(1117),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [196] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_parameter] = STATE(8382),
    [sym__parameter_array] = STATE(8390),
    [sym_argument] = STATE(8836),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2787),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(5834),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_tuple_element] = STATE(8706),
    [sym_pattern] = STATE(8253),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(6141),
    [sym_property_pattern_clause] = STATE(6672),
    [sym_subpattern] = STATE(8877),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6145),
    [sym_non_lvalue_expression] = STATE(6331),
    [sym_lvalue_expression] = STATE(4306),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(5071),
    [sym_postfix_unary_expression] = STATE(5061),
    [sym_prefix_unary_expression] = STATE(5061),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(5071),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(5061),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(5071),
    [sym_member_access_expression] = STATE(3775),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(5061),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9027),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(5071),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(5071),
    [sym_typeof_expression] = STATE(5071),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3775),
    [sym_literal] = STATE(5071),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2773),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(196),
    [sym_preproc_endregion] = STATE(196),
    [sym_preproc_line] = STATE(196),
    [sym_preproc_pragma] = STATE(196),
    [sym_preproc_nullable] = STATE(196),
    [sym_preproc_error] = STATE(196),
    [sym_preproc_define] = STATE(196),
    [sym_preproc_undef] = STATE(196),
    [aux_sym_class_declaration_repeat1] = STATE(3550),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4143),
    [aux_sym_lambda_expression_repeat1] = STATE(4220),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(1203),
    [anon_sym_RPAREN] = ACTIONS(1207),
    [anon_sym_ref] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_readonly] = ACTIONS(1093),
    [anon_sym_LT] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1053),
    [anon_sym_in] = ACTIONS(1095),
    [anon_sym_out] = ACTIONS(1095),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1097),
    [anon_sym_TILDE] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1099),
    [anon_sym_DASH] = ACTIONS(1099),
    [anon_sym_STAR] = ACTIONS(1101),
    [anon_sym_CARET] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1097),
    [anon_sym_GT_EQ] = ACTIONS(1063),
    [anon_sym_LT_EQ] = ACTIONS(1063),
    [anon_sym_this] = ACTIONS(1103),
    [anon_sym_scoped] = ACTIONS(1105),
    [anon_sym_params] = ACTIONS(1107),
    [anon_sym_var] = ACTIONS(1067),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1111),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(1115),
    [anon_sym_not] = ACTIONS(1117),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [197] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_parameter] = STATE(8382),
    [sym__parameter_array] = STATE(8390),
    [sym_argument] = STATE(8885),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2787),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(5864),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_tuple_element] = STATE(8706),
    [sym_pattern] = STATE(8317),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(6141),
    [sym_property_pattern_clause] = STATE(6672),
    [sym_subpattern] = STATE(8877),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6145),
    [sym_non_lvalue_expression] = STATE(6400),
    [sym_lvalue_expression] = STATE(4306),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(5071),
    [sym_postfix_unary_expression] = STATE(5061),
    [sym_prefix_unary_expression] = STATE(5061),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(5071),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(5061),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(5071),
    [sym_member_access_expression] = STATE(3775),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(5061),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9027),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(5071),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(5071),
    [sym_typeof_expression] = STATE(5071),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3775),
    [sym_literal] = STATE(5071),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2773),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(197),
    [sym_preproc_endregion] = STATE(197),
    [sym_preproc_line] = STATE(197),
    [sym_preproc_pragma] = STATE(197),
    [sym_preproc_nullable] = STATE(197),
    [sym_preproc_error] = STATE(197),
    [sym_preproc_define] = STATE(197),
    [sym_preproc_undef] = STATE(197),
    [aux_sym_class_declaration_repeat1] = STATE(3550),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4143),
    [aux_sym_lambda_expression_repeat1] = STATE(4220),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(1203),
    [anon_sym_RPAREN] = ACTIONS(1207),
    [anon_sym_ref] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_readonly] = ACTIONS(1093),
    [anon_sym_LT] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1053),
    [anon_sym_in] = ACTIONS(1095),
    [anon_sym_out] = ACTIONS(1095),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1097),
    [anon_sym_TILDE] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1099),
    [anon_sym_DASH] = ACTIONS(1099),
    [anon_sym_STAR] = ACTIONS(1101),
    [anon_sym_CARET] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1097),
    [anon_sym_GT_EQ] = ACTIONS(1063),
    [anon_sym_LT_EQ] = ACTIONS(1063),
    [anon_sym_this] = ACTIONS(1103),
    [anon_sym_scoped] = ACTIONS(1105),
    [anon_sym_params] = ACTIONS(1107),
    [anon_sym_var] = ACTIONS(1067),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1111),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(1115),
    [anon_sym_not] = ACTIONS(1117),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [198] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_parameter] = STATE(8382),
    [sym__parameter_array] = STATE(8390),
    [sym_argument] = STATE(8836),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2787),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(5968),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_tuple_element] = STATE(8846),
    [sym_pattern] = STATE(8253),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(6141),
    [sym_property_pattern_clause] = STATE(6672),
    [sym_subpattern] = STATE(8877),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6145),
    [sym_non_lvalue_expression] = STATE(6331),
    [sym_lvalue_expression] = STATE(4306),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(5071),
    [sym_postfix_unary_expression] = STATE(5061),
    [sym_prefix_unary_expression] = STATE(5061),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(5071),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(5061),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(5071),
    [sym_member_access_expression] = STATE(3775),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(5061),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9027),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(5071),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(5071),
    [sym_typeof_expression] = STATE(5071),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3775),
    [sym_literal] = STATE(5071),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2773),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(198),
    [sym_preproc_endregion] = STATE(198),
    [sym_preproc_line] = STATE(198),
    [sym_preproc_pragma] = STATE(198),
    [sym_preproc_nullable] = STATE(198),
    [sym_preproc_error] = STATE(198),
    [sym_preproc_define] = STATE(198),
    [sym_preproc_undef] = STATE(198),
    [aux_sym_class_declaration_repeat1] = STATE(3550),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4143),
    [aux_sym_lambda_expression_repeat1] = STATE(4220),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(1203),
    [anon_sym_RPAREN] = ACTIONS(1205),
    [anon_sym_ref] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_readonly] = ACTIONS(1093),
    [anon_sym_LT] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1053),
    [anon_sym_in] = ACTIONS(1095),
    [anon_sym_out] = ACTIONS(1095),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1097),
    [anon_sym_TILDE] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1099),
    [anon_sym_DASH] = ACTIONS(1099),
    [anon_sym_STAR] = ACTIONS(1101),
    [anon_sym_CARET] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1097),
    [anon_sym_GT_EQ] = ACTIONS(1063),
    [anon_sym_LT_EQ] = ACTIONS(1063),
    [anon_sym_this] = ACTIONS(1103),
    [anon_sym_scoped] = ACTIONS(1105),
    [anon_sym_params] = ACTIONS(1107),
    [anon_sym_var] = ACTIONS(1067),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1111),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(1115),
    [anon_sym_not] = ACTIONS(1117),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [199] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_parameter] = STATE(8382),
    [sym__parameter_array] = STATE(8390),
    [sym_argument] = STATE(8836),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2787),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(5841),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_tuple_element] = STATE(8706),
    [sym_pattern] = STATE(8253),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(6141),
    [sym_property_pattern_clause] = STATE(6672),
    [sym_subpattern] = STATE(8877),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6145),
    [sym_non_lvalue_expression] = STATE(6331),
    [sym_lvalue_expression] = STATE(4306),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(5071),
    [sym_postfix_unary_expression] = STATE(5061),
    [sym_prefix_unary_expression] = STATE(5061),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(5071),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(5061),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(5071),
    [sym_member_access_expression] = STATE(3775),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(5061),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9027),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(5071),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(5071),
    [sym_typeof_expression] = STATE(5071),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3775),
    [sym_literal] = STATE(5071),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2773),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(199),
    [sym_preproc_endregion] = STATE(199),
    [sym_preproc_line] = STATE(199),
    [sym_preproc_pragma] = STATE(199),
    [sym_preproc_nullable] = STATE(199),
    [sym_preproc_error] = STATE(199),
    [sym_preproc_define] = STATE(199),
    [sym_preproc_undef] = STATE(199),
    [aux_sym_class_declaration_repeat1] = STATE(3550),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4143),
    [aux_sym_lambda_expression_repeat1] = STATE(4220),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(1203),
    [anon_sym_RPAREN] = ACTIONS(1207),
    [anon_sym_ref] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_readonly] = ACTIONS(1093),
    [anon_sym_LT] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1053),
    [anon_sym_in] = ACTIONS(1095),
    [anon_sym_out] = ACTIONS(1095),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1097),
    [anon_sym_TILDE] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1099),
    [anon_sym_DASH] = ACTIONS(1099),
    [anon_sym_STAR] = ACTIONS(1101),
    [anon_sym_CARET] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1097),
    [anon_sym_GT_EQ] = ACTIONS(1063),
    [anon_sym_LT_EQ] = ACTIONS(1063),
    [anon_sym_this] = ACTIONS(1103),
    [anon_sym_scoped] = ACTIONS(1105),
    [anon_sym_params] = ACTIONS(1107),
    [anon_sym_var] = ACTIONS(1067),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1111),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(1115),
    [anon_sym_not] = ACTIONS(1117),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [200] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_parameter] = STATE(8382),
    [sym__parameter_array] = STATE(8390),
    [sym_argument] = STATE(8836),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2787),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(5829),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_tuple_element] = STATE(8706),
    [sym_pattern] = STATE(8253),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(6141),
    [sym_property_pattern_clause] = STATE(6672),
    [sym_subpattern] = STATE(8877),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6145),
    [sym_non_lvalue_expression] = STATE(6331),
    [sym_lvalue_expression] = STATE(4306),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(5071),
    [sym_postfix_unary_expression] = STATE(5061),
    [sym_prefix_unary_expression] = STATE(5061),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(5071),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(5061),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(5071),
    [sym_member_access_expression] = STATE(3775),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(5061),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9027),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(5071),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(5071),
    [sym_typeof_expression] = STATE(5071),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3775),
    [sym_literal] = STATE(5071),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2773),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(200),
    [sym_preproc_endregion] = STATE(200),
    [sym_preproc_line] = STATE(200),
    [sym_preproc_pragma] = STATE(200),
    [sym_preproc_nullable] = STATE(200),
    [sym_preproc_error] = STATE(200),
    [sym_preproc_define] = STATE(200),
    [sym_preproc_undef] = STATE(200),
    [aux_sym_class_declaration_repeat1] = STATE(3550),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4143),
    [aux_sym_lambda_expression_repeat1] = STATE(4220),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(1203),
    [anon_sym_RPAREN] = ACTIONS(1207),
    [anon_sym_ref] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_readonly] = ACTIONS(1093),
    [anon_sym_LT] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1053),
    [anon_sym_in] = ACTIONS(1095),
    [anon_sym_out] = ACTIONS(1095),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1097),
    [anon_sym_TILDE] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1099),
    [anon_sym_DASH] = ACTIONS(1099),
    [anon_sym_STAR] = ACTIONS(1101),
    [anon_sym_CARET] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1097),
    [anon_sym_GT_EQ] = ACTIONS(1063),
    [anon_sym_LT_EQ] = ACTIONS(1063),
    [anon_sym_this] = ACTIONS(1103),
    [anon_sym_scoped] = ACTIONS(1105),
    [anon_sym_params] = ACTIONS(1107),
    [anon_sym_var] = ACTIONS(1067),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1111),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(1115),
    [anon_sym_not] = ACTIONS(1117),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [201] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_parameter] = STATE(8382),
    [sym__parameter_array] = STATE(8390),
    [sym_argument] = STATE(8759),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2787),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6060),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_tuple_element] = STATE(8952),
    [sym_pattern] = STATE(8302),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(6141),
    [sym_property_pattern_clause] = STATE(6672),
    [sym_subpattern] = STATE(8936),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6145),
    [sym_non_lvalue_expression] = STATE(6506),
    [sym_lvalue_expression] = STATE(4306),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(5071),
    [sym_postfix_unary_expression] = STATE(5061),
    [sym_prefix_unary_expression] = STATE(5061),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(5071),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(5061),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(5071),
    [sym_member_access_expression] = STATE(3775),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(5061),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9027),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(5071),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(5071),
    [sym_typeof_expression] = STATE(5071),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3775),
    [sym_literal] = STATE(5071),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2773),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(201),
    [sym_preproc_endregion] = STATE(201),
    [sym_preproc_line] = STATE(201),
    [sym_preproc_pragma] = STATE(201),
    [sym_preproc_nullable] = STATE(201),
    [sym_preproc_error] = STATE(201),
    [sym_preproc_define] = STATE(201),
    [sym_preproc_undef] = STATE(201),
    [aux_sym_class_declaration_repeat1] = STATE(3550),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4143),
    [aux_sym_lambda_expression_repeat1] = STATE(4220),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(1203),
    [anon_sym_RPAREN] = ACTIONS(1209),
    [anon_sym_ref] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_readonly] = ACTIONS(1093),
    [anon_sym_LT] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1053),
    [anon_sym_in] = ACTIONS(1095),
    [anon_sym_out] = ACTIONS(1095),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1097),
    [anon_sym_TILDE] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1099),
    [anon_sym_DASH] = ACTIONS(1099),
    [anon_sym_STAR] = ACTIONS(1101),
    [anon_sym_CARET] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1097),
    [anon_sym_GT_EQ] = ACTIONS(1063),
    [anon_sym_LT_EQ] = ACTIONS(1063),
    [anon_sym_this] = ACTIONS(1103),
    [anon_sym_scoped] = ACTIONS(1105),
    [anon_sym_params] = ACTIONS(1107),
    [anon_sym_var] = ACTIONS(1067),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1111),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(1115),
    [anon_sym_not] = ACTIONS(1117),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [202] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_parameter] = STATE(8382),
    [sym__parameter_array] = STATE(8390),
    [sym_argument] = STATE(8836),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2787),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(5866),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_tuple_element] = STATE(8706),
    [sym_pattern] = STATE(8253),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(6141),
    [sym_property_pattern_clause] = STATE(6672),
    [sym_subpattern] = STATE(8877),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6145),
    [sym_non_lvalue_expression] = STATE(6331),
    [sym_lvalue_expression] = STATE(4306),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(5071),
    [sym_postfix_unary_expression] = STATE(5061),
    [sym_prefix_unary_expression] = STATE(5061),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(5071),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(5061),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(5071),
    [sym_member_access_expression] = STATE(3775),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(5061),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9027),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(5071),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(5071),
    [sym_typeof_expression] = STATE(5071),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3775),
    [sym_literal] = STATE(5071),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2773),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(202),
    [sym_preproc_endregion] = STATE(202),
    [sym_preproc_line] = STATE(202),
    [sym_preproc_pragma] = STATE(202),
    [sym_preproc_nullable] = STATE(202),
    [sym_preproc_error] = STATE(202),
    [sym_preproc_define] = STATE(202),
    [sym_preproc_undef] = STATE(202),
    [aux_sym_class_declaration_repeat1] = STATE(3550),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4143),
    [aux_sym_lambda_expression_repeat1] = STATE(4220),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(1203),
    [anon_sym_RPAREN] = ACTIONS(1207),
    [anon_sym_ref] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_readonly] = ACTIONS(1093),
    [anon_sym_LT] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1053),
    [anon_sym_in] = ACTIONS(1095),
    [anon_sym_out] = ACTIONS(1095),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1097),
    [anon_sym_TILDE] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1099),
    [anon_sym_DASH] = ACTIONS(1099),
    [anon_sym_STAR] = ACTIONS(1101),
    [anon_sym_CARET] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1097),
    [anon_sym_GT_EQ] = ACTIONS(1063),
    [anon_sym_LT_EQ] = ACTIONS(1063),
    [anon_sym_this] = ACTIONS(1103),
    [anon_sym_scoped] = ACTIONS(1105),
    [anon_sym_params] = ACTIONS(1107),
    [anon_sym_var] = ACTIONS(1067),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1111),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(1115),
    [anon_sym_not] = ACTIONS(1117),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [203] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_parameter] = STATE(8382),
    [sym__parameter_array] = STATE(8390),
    [sym_argument] = STATE(8836),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2787),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(5968),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_tuple_element] = STATE(8706),
    [sym_pattern] = STATE(8253),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(6141),
    [sym_property_pattern_clause] = STATE(6672),
    [sym_subpattern] = STATE(8877),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6145),
    [sym_non_lvalue_expression] = STATE(6331),
    [sym_lvalue_expression] = STATE(4306),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(5071),
    [sym_postfix_unary_expression] = STATE(5061),
    [sym_prefix_unary_expression] = STATE(5061),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(5071),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(5061),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(5071),
    [sym_member_access_expression] = STATE(3775),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(5061),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9027),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(5071),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(5071),
    [sym_typeof_expression] = STATE(5071),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3775),
    [sym_literal] = STATE(5071),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2773),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(203),
    [sym_preproc_endregion] = STATE(203),
    [sym_preproc_line] = STATE(203),
    [sym_preproc_pragma] = STATE(203),
    [sym_preproc_nullable] = STATE(203),
    [sym_preproc_error] = STATE(203),
    [sym_preproc_define] = STATE(203),
    [sym_preproc_undef] = STATE(203),
    [aux_sym_class_declaration_repeat1] = STATE(3550),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4143),
    [aux_sym_lambda_expression_repeat1] = STATE(4220),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(1203),
    [anon_sym_RPAREN] = ACTIONS(1205),
    [anon_sym_ref] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_readonly] = ACTIONS(1093),
    [anon_sym_LT] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1053),
    [anon_sym_in] = ACTIONS(1095),
    [anon_sym_out] = ACTIONS(1095),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1097),
    [anon_sym_TILDE] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1099),
    [anon_sym_DASH] = ACTIONS(1099),
    [anon_sym_STAR] = ACTIONS(1101),
    [anon_sym_CARET] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1097),
    [anon_sym_GT_EQ] = ACTIONS(1063),
    [anon_sym_LT_EQ] = ACTIONS(1063),
    [anon_sym_this] = ACTIONS(1103),
    [anon_sym_scoped] = ACTIONS(1105),
    [anon_sym_params] = ACTIONS(1107),
    [anon_sym_var] = ACTIONS(1067),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1111),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(1115),
    [anon_sym_not] = ACTIONS(1117),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [204] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_parameter] = STATE(8382),
    [sym__parameter_array] = STATE(8390),
    [sym_argument] = STATE(8836),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2787),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(5935),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_tuple_element] = STATE(8706),
    [sym_pattern] = STATE(8253),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(6141),
    [sym_property_pattern_clause] = STATE(6672),
    [sym_subpattern] = STATE(8877),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6145),
    [sym_non_lvalue_expression] = STATE(6331),
    [sym_lvalue_expression] = STATE(4306),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(5071),
    [sym_postfix_unary_expression] = STATE(5061),
    [sym_prefix_unary_expression] = STATE(5061),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(5071),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(5061),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(5071),
    [sym_member_access_expression] = STATE(3775),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(5061),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9027),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(5071),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(5071),
    [sym_typeof_expression] = STATE(5071),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3775),
    [sym_literal] = STATE(5071),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2773),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(204),
    [sym_preproc_endregion] = STATE(204),
    [sym_preproc_line] = STATE(204),
    [sym_preproc_pragma] = STATE(204),
    [sym_preproc_nullable] = STATE(204),
    [sym_preproc_error] = STATE(204),
    [sym_preproc_define] = STATE(204),
    [sym_preproc_undef] = STATE(204),
    [aux_sym_class_declaration_repeat1] = STATE(3550),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4143),
    [aux_sym_lambda_expression_repeat1] = STATE(4220),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(1203),
    [anon_sym_RPAREN] = ACTIONS(1207),
    [anon_sym_ref] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_readonly] = ACTIONS(1093),
    [anon_sym_LT] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1053),
    [anon_sym_in] = ACTIONS(1095),
    [anon_sym_out] = ACTIONS(1095),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1097),
    [anon_sym_TILDE] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1099),
    [anon_sym_DASH] = ACTIONS(1099),
    [anon_sym_STAR] = ACTIONS(1101),
    [anon_sym_CARET] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1097),
    [anon_sym_GT_EQ] = ACTIONS(1063),
    [anon_sym_LT_EQ] = ACTIONS(1063),
    [anon_sym_this] = ACTIONS(1103),
    [anon_sym_scoped] = ACTIONS(1105),
    [anon_sym_params] = ACTIONS(1107),
    [anon_sym_var] = ACTIONS(1067),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1111),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(1115),
    [anon_sym_not] = ACTIONS(1117),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [205] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_parameter] = STATE(8382),
    [sym__parameter_array] = STATE(8390),
    [sym_argument] = STATE(8919),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2787),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(5854),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_tuple_element] = STATE(8706),
    [sym_pattern] = STATE(8329),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(6141),
    [sym_property_pattern_clause] = STATE(6672),
    [sym_subpattern] = STATE(8877),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6145),
    [sym_non_lvalue_expression] = STATE(6468),
    [sym_lvalue_expression] = STATE(4306),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(5071),
    [sym_postfix_unary_expression] = STATE(5061),
    [sym_prefix_unary_expression] = STATE(5061),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(5071),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(5061),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(5071),
    [sym_member_access_expression] = STATE(3775),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(5061),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9027),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(5071),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(5071),
    [sym_typeof_expression] = STATE(5071),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3775),
    [sym_literal] = STATE(5071),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2773),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(205),
    [sym_preproc_endregion] = STATE(205),
    [sym_preproc_line] = STATE(205),
    [sym_preproc_pragma] = STATE(205),
    [sym_preproc_nullable] = STATE(205),
    [sym_preproc_error] = STATE(205),
    [sym_preproc_define] = STATE(205),
    [sym_preproc_undef] = STATE(205),
    [aux_sym_class_declaration_repeat1] = STATE(3550),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4143),
    [aux_sym_lambda_expression_repeat1] = STATE(4220),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(1203),
    [anon_sym_RPAREN] = ACTIONS(1207),
    [anon_sym_ref] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_readonly] = ACTIONS(1093),
    [anon_sym_LT] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1053),
    [anon_sym_in] = ACTIONS(1095),
    [anon_sym_out] = ACTIONS(1095),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1097),
    [anon_sym_TILDE] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1099),
    [anon_sym_DASH] = ACTIONS(1099),
    [anon_sym_STAR] = ACTIONS(1101),
    [anon_sym_CARET] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1097),
    [anon_sym_GT_EQ] = ACTIONS(1063),
    [anon_sym_LT_EQ] = ACTIONS(1063),
    [anon_sym_this] = ACTIONS(1103),
    [anon_sym_scoped] = ACTIONS(1105),
    [anon_sym_params] = ACTIONS(1107),
    [anon_sym_var] = ACTIONS(1067),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1111),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(1115),
    [anon_sym_not] = ACTIONS(1117),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [206] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_parameter] = STATE(8382),
    [sym__parameter_array] = STATE(8390),
    [sym_argument] = STATE(8836),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2787),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(5852),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_tuple_element] = STATE(8706),
    [sym_pattern] = STATE(8253),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(6141),
    [sym_property_pattern_clause] = STATE(6672),
    [sym_subpattern] = STATE(8877),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6145),
    [sym_non_lvalue_expression] = STATE(6331),
    [sym_lvalue_expression] = STATE(4306),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(5071),
    [sym_postfix_unary_expression] = STATE(5061),
    [sym_prefix_unary_expression] = STATE(5061),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(5071),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(5061),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(5071),
    [sym_member_access_expression] = STATE(3775),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(5061),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9027),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(5071),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(5071),
    [sym_typeof_expression] = STATE(5071),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3775),
    [sym_literal] = STATE(5071),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2773),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(206),
    [sym_preproc_endregion] = STATE(206),
    [sym_preproc_line] = STATE(206),
    [sym_preproc_pragma] = STATE(206),
    [sym_preproc_nullable] = STATE(206),
    [sym_preproc_error] = STATE(206),
    [sym_preproc_define] = STATE(206),
    [sym_preproc_undef] = STATE(206),
    [aux_sym_class_declaration_repeat1] = STATE(3550),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4143),
    [aux_sym_lambda_expression_repeat1] = STATE(4220),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(1203),
    [anon_sym_RPAREN] = ACTIONS(1207),
    [anon_sym_ref] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_readonly] = ACTIONS(1093),
    [anon_sym_LT] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1053),
    [anon_sym_in] = ACTIONS(1095),
    [anon_sym_out] = ACTIONS(1095),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1097),
    [anon_sym_TILDE] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1099),
    [anon_sym_DASH] = ACTIONS(1099),
    [anon_sym_STAR] = ACTIONS(1101),
    [anon_sym_CARET] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1097),
    [anon_sym_GT_EQ] = ACTIONS(1063),
    [anon_sym_LT_EQ] = ACTIONS(1063),
    [anon_sym_this] = ACTIONS(1103),
    [anon_sym_scoped] = ACTIONS(1105),
    [anon_sym_params] = ACTIONS(1107),
    [anon_sym_var] = ACTIONS(1067),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1111),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(1115),
    [anon_sym_not] = ACTIONS(1117),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [207] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_parameter] = STATE(8382),
    [sym__parameter_array] = STATE(8390),
    [sym_argument] = STATE(8836),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2787),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(5913),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_tuple_element] = STATE(8846),
    [sym_pattern] = STATE(8253),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(6141),
    [sym_property_pattern_clause] = STATE(6672),
    [sym_subpattern] = STATE(8877),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6145),
    [sym_non_lvalue_expression] = STATE(6331),
    [sym_lvalue_expression] = STATE(4306),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(5071),
    [sym_postfix_unary_expression] = STATE(5061),
    [sym_prefix_unary_expression] = STATE(5061),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(5071),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(5061),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(5071),
    [sym_member_access_expression] = STATE(3775),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(5061),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9027),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(5071),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(5071),
    [sym_typeof_expression] = STATE(5071),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3775),
    [sym_literal] = STATE(5071),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2773),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(207),
    [sym_preproc_endregion] = STATE(207),
    [sym_preproc_line] = STATE(207),
    [sym_preproc_pragma] = STATE(207),
    [sym_preproc_nullable] = STATE(207),
    [sym_preproc_error] = STATE(207),
    [sym_preproc_define] = STATE(207),
    [sym_preproc_undef] = STATE(207),
    [aux_sym_class_declaration_repeat1] = STATE(3550),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4143),
    [aux_sym_lambda_expression_repeat1] = STATE(4220),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(1203),
    [anon_sym_RPAREN] = ACTIONS(1207),
    [anon_sym_ref] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_readonly] = ACTIONS(1093),
    [anon_sym_LT] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1053),
    [anon_sym_in] = ACTIONS(1095),
    [anon_sym_out] = ACTIONS(1095),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1097),
    [anon_sym_TILDE] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1099),
    [anon_sym_DASH] = ACTIONS(1099),
    [anon_sym_STAR] = ACTIONS(1101),
    [anon_sym_CARET] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1097),
    [anon_sym_GT_EQ] = ACTIONS(1063),
    [anon_sym_LT_EQ] = ACTIONS(1063),
    [anon_sym_this] = ACTIONS(1103),
    [anon_sym_scoped] = ACTIONS(1105),
    [anon_sym_params] = ACTIONS(1107),
    [anon_sym_var] = ACTIONS(1067),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1111),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(1115),
    [anon_sym_not] = ACTIONS(1117),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [208] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_parameter] = STATE(8382),
    [sym__parameter_array] = STATE(8390),
    [sym_argument] = STATE(8885),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2787),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(5847),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_tuple_element] = STATE(8706),
    [sym_pattern] = STATE(8317),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(6141),
    [sym_property_pattern_clause] = STATE(6672),
    [sym_subpattern] = STATE(8877),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6145),
    [sym_non_lvalue_expression] = STATE(6400),
    [sym_lvalue_expression] = STATE(4306),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(5071),
    [sym_postfix_unary_expression] = STATE(5061),
    [sym_prefix_unary_expression] = STATE(5061),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(5071),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(5061),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(5071),
    [sym_member_access_expression] = STATE(3775),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(5061),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9027),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(5071),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(5071),
    [sym_typeof_expression] = STATE(5071),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3775),
    [sym_literal] = STATE(5071),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2773),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(208),
    [sym_preproc_endregion] = STATE(208),
    [sym_preproc_line] = STATE(208),
    [sym_preproc_pragma] = STATE(208),
    [sym_preproc_nullable] = STATE(208),
    [sym_preproc_error] = STATE(208),
    [sym_preproc_define] = STATE(208),
    [sym_preproc_undef] = STATE(208),
    [aux_sym_class_declaration_repeat1] = STATE(3550),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4143),
    [aux_sym_lambda_expression_repeat1] = STATE(4220),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(1203),
    [anon_sym_RPAREN] = ACTIONS(1207),
    [anon_sym_ref] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_readonly] = ACTIONS(1093),
    [anon_sym_LT] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1053),
    [anon_sym_in] = ACTIONS(1095),
    [anon_sym_out] = ACTIONS(1095),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1097),
    [anon_sym_TILDE] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1099),
    [anon_sym_DASH] = ACTIONS(1099),
    [anon_sym_STAR] = ACTIONS(1101),
    [anon_sym_CARET] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1097),
    [anon_sym_GT_EQ] = ACTIONS(1063),
    [anon_sym_LT_EQ] = ACTIONS(1063),
    [anon_sym_this] = ACTIONS(1103),
    [anon_sym_scoped] = ACTIONS(1105),
    [anon_sym_params] = ACTIONS(1107),
    [anon_sym_var] = ACTIONS(1067),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1111),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(1115),
    [anon_sym_not] = ACTIONS(1117),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [209] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_parameter] = STATE(8382),
    [sym__parameter_array] = STATE(8390),
    [sym_argument] = STATE(8836),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2787),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(5814),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_tuple_element] = STATE(8706),
    [sym_pattern] = STATE(8253),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(6141),
    [sym_property_pattern_clause] = STATE(6672),
    [sym_subpattern] = STATE(8877),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6145),
    [sym_non_lvalue_expression] = STATE(6331),
    [sym_lvalue_expression] = STATE(4306),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(5071),
    [sym_postfix_unary_expression] = STATE(5061),
    [sym_prefix_unary_expression] = STATE(5061),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(5071),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(5061),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(5071),
    [sym_member_access_expression] = STATE(3775),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(5061),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9027),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(5071),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(5071),
    [sym_typeof_expression] = STATE(5071),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3775),
    [sym_literal] = STATE(5071),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2773),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(209),
    [sym_preproc_endregion] = STATE(209),
    [sym_preproc_line] = STATE(209),
    [sym_preproc_pragma] = STATE(209),
    [sym_preproc_nullable] = STATE(209),
    [sym_preproc_error] = STATE(209),
    [sym_preproc_define] = STATE(209),
    [sym_preproc_undef] = STATE(209),
    [aux_sym_class_declaration_repeat1] = STATE(3550),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4143),
    [aux_sym_lambda_expression_repeat1] = STATE(4220),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(1203),
    [anon_sym_RPAREN] = ACTIONS(1207),
    [anon_sym_ref] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_readonly] = ACTIONS(1093),
    [anon_sym_LT] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1053),
    [anon_sym_in] = ACTIONS(1095),
    [anon_sym_out] = ACTIONS(1095),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1097),
    [anon_sym_TILDE] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1099),
    [anon_sym_DASH] = ACTIONS(1099),
    [anon_sym_STAR] = ACTIONS(1101),
    [anon_sym_CARET] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1097),
    [anon_sym_GT_EQ] = ACTIONS(1063),
    [anon_sym_LT_EQ] = ACTIONS(1063),
    [anon_sym_this] = ACTIONS(1103),
    [anon_sym_scoped] = ACTIONS(1105),
    [anon_sym_params] = ACTIONS(1107),
    [anon_sym_var] = ACTIONS(1067),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1111),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(1115),
    [anon_sym_not] = ACTIONS(1117),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [210] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_parameter] = STATE(8382),
    [sym__parameter_array] = STATE(8390),
    [sym_argument] = STATE(8707),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2787),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6066),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_tuple_element] = STATE(8706),
    [sym_pattern] = STATE(8258),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(6141),
    [sym_property_pattern_clause] = STATE(6672),
    [sym_subpattern] = STATE(8877),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6145),
    [sym_non_lvalue_expression] = STATE(6457),
    [sym_lvalue_expression] = STATE(4306),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(5071),
    [sym_postfix_unary_expression] = STATE(5061),
    [sym_prefix_unary_expression] = STATE(5061),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(5071),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(5061),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(5071),
    [sym_member_access_expression] = STATE(3775),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(5061),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9027),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(5071),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(5071),
    [sym_typeof_expression] = STATE(5071),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3775),
    [sym_literal] = STATE(5071),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2773),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(210),
    [sym_preproc_endregion] = STATE(210),
    [sym_preproc_line] = STATE(210),
    [sym_preproc_pragma] = STATE(210),
    [sym_preproc_nullable] = STATE(210),
    [sym_preproc_error] = STATE(210),
    [sym_preproc_define] = STATE(210),
    [sym_preproc_undef] = STATE(210),
    [aux_sym_class_declaration_repeat1] = STATE(3550),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4143),
    [aux_sym_lambda_expression_repeat1] = STATE(4220),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(1203),
    [anon_sym_RPAREN] = ACTIONS(1207),
    [anon_sym_ref] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_readonly] = ACTIONS(1093),
    [anon_sym_LT] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1053),
    [anon_sym_in] = ACTIONS(1095),
    [anon_sym_out] = ACTIONS(1095),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1097),
    [anon_sym_TILDE] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1099),
    [anon_sym_DASH] = ACTIONS(1099),
    [anon_sym_STAR] = ACTIONS(1101),
    [anon_sym_CARET] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1097),
    [anon_sym_GT_EQ] = ACTIONS(1063),
    [anon_sym_LT_EQ] = ACTIONS(1063),
    [anon_sym_this] = ACTIONS(1103),
    [anon_sym_scoped] = ACTIONS(1105),
    [anon_sym_params] = ACTIONS(1107),
    [anon_sym_var] = ACTIONS(1067),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1111),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(1115),
    [anon_sym_not] = ACTIONS(1117),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [211] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_parameter] = STATE(8382),
    [sym__parameter_array] = STATE(8390),
    [sym_argument] = STATE(8919),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2787),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(5837),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_tuple_element] = STATE(8706),
    [sym_pattern] = STATE(8329),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(6141),
    [sym_property_pattern_clause] = STATE(6672),
    [sym_subpattern] = STATE(8877),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6145),
    [sym_non_lvalue_expression] = STATE(6468),
    [sym_lvalue_expression] = STATE(4306),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(5071),
    [sym_postfix_unary_expression] = STATE(5061),
    [sym_prefix_unary_expression] = STATE(5061),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(5071),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(5061),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(5071),
    [sym_member_access_expression] = STATE(3775),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(5061),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9027),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(5071),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(5071),
    [sym_typeof_expression] = STATE(5071),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3775),
    [sym_literal] = STATE(5071),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2773),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(211),
    [sym_preproc_endregion] = STATE(211),
    [sym_preproc_line] = STATE(211),
    [sym_preproc_pragma] = STATE(211),
    [sym_preproc_nullable] = STATE(211),
    [sym_preproc_error] = STATE(211),
    [sym_preproc_define] = STATE(211),
    [sym_preproc_undef] = STATE(211),
    [aux_sym_class_declaration_repeat1] = STATE(3550),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4143),
    [aux_sym_lambda_expression_repeat1] = STATE(4220),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(1203),
    [anon_sym_RPAREN] = ACTIONS(1207),
    [anon_sym_ref] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_readonly] = ACTIONS(1093),
    [anon_sym_LT] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1053),
    [anon_sym_in] = ACTIONS(1095),
    [anon_sym_out] = ACTIONS(1095),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1097),
    [anon_sym_TILDE] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1099),
    [anon_sym_DASH] = ACTIONS(1099),
    [anon_sym_STAR] = ACTIONS(1101),
    [anon_sym_CARET] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1097),
    [anon_sym_GT_EQ] = ACTIONS(1063),
    [anon_sym_LT_EQ] = ACTIONS(1063),
    [anon_sym_this] = ACTIONS(1103),
    [anon_sym_scoped] = ACTIONS(1105),
    [anon_sym_params] = ACTIONS(1107),
    [anon_sym_var] = ACTIONS(1067),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1111),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(1115),
    [anon_sym_not] = ACTIONS(1117),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [212] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_parameter] = STATE(8382),
    [sym__parameter_array] = STATE(8390),
    [sym_argument] = STATE(8885),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2787),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(5961),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_tuple_element] = STATE(8706),
    [sym_pattern] = STATE(8317),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(6141),
    [sym_property_pattern_clause] = STATE(6672),
    [sym_subpattern] = STATE(8877),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6145),
    [sym_non_lvalue_expression] = STATE(6400),
    [sym_lvalue_expression] = STATE(4306),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(5071),
    [sym_postfix_unary_expression] = STATE(5061),
    [sym_prefix_unary_expression] = STATE(5061),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(5071),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(5061),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(5071),
    [sym_member_access_expression] = STATE(3775),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(5061),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9027),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(5071),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(5071),
    [sym_typeof_expression] = STATE(5071),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3775),
    [sym_literal] = STATE(5071),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2773),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(212),
    [sym_preproc_endregion] = STATE(212),
    [sym_preproc_line] = STATE(212),
    [sym_preproc_pragma] = STATE(212),
    [sym_preproc_nullable] = STATE(212),
    [sym_preproc_error] = STATE(212),
    [sym_preproc_define] = STATE(212),
    [sym_preproc_undef] = STATE(212),
    [aux_sym_class_declaration_repeat1] = STATE(3550),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4143),
    [aux_sym_lambda_expression_repeat1] = STATE(4220),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(1203),
    [anon_sym_RPAREN] = ACTIONS(1207),
    [anon_sym_ref] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_readonly] = ACTIONS(1093),
    [anon_sym_LT] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1053),
    [anon_sym_in] = ACTIONS(1095),
    [anon_sym_out] = ACTIONS(1095),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1097),
    [anon_sym_TILDE] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1099),
    [anon_sym_DASH] = ACTIONS(1099),
    [anon_sym_STAR] = ACTIONS(1101),
    [anon_sym_CARET] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1097),
    [anon_sym_GT_EQ] = ACTIONS(1063),
    [anon_sym_LT_EQ] = ACTIONS(1063),
    [anon_sym_this] = ACTIONS(1103),
    [anon_sym_scoped] = ACTIONS(1105),
    [anon_sym_params] = ACTIONS(1107),
    [anon_sym_var] = ACTIONS(1067),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1111),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(1115),
    [anon_sym_not] = ACTIONS(1117),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [213] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_parameter] = STATE(8382),
    [sym__parameter_array] = STATE(8390),
    [sym_argument] = STATE(8707),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2787),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(5764),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_tuple_element] = STATE(8706),
    [sym_pattern] = STATE(8258),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(6141),
    [sym_property_pattern_clause] = STATE(6672),
    [sym_subpattern] = STATE(8877),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6145),
    [sym_non_lvalue_expression] = STATE(6457),
    [sym_lvalue_expression] = STATE(4306),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(5071),
    [sym_postfix_unary_expression] = STATE(5061),
    [sym_prefix_unary_expression] = STATE(5061),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(5071),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(5061),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(5071),
    [sym_member_access_expression] = STATE(3775),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(5061),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9027),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(5071),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(5071),
    [sym_typeof_expression] = STATE(5071),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3775),
    [sym_literal] = STATE(5071),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2773),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(213),
    [sym_preproc_endregion] = STATE(213),
    [sym_preproc_line] = STATE(213),
    [sym_preproc_pragma] = STATE(213),
    [sym_preproc_nullable] = STATE(213),
    [sym_preproc_error] = STATE(213),
    [sym_preproc_define] = STATE(213),
    [sym_preproc_undef] = STATE(213),
    [aux_sym_class_declaration_repeat1] = STATE(3550),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4143),
    [aux_sym_lambda_expression_repeat1] = STATE(4220),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(1203),
    [anon_sym_RPAREN] = ACTIONS(1207),
    [anon_sym_ref] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_readonly] = ACTIONS(1093),
    [anon_sym_LT] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1053),
    [anon_sym_in] = ACTIONS(1095),
    [anon_sym_out] = ACTIONS(1095),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1097),
    [anon_sym_TILDE] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1099),
    [anon_sym_DASH] = ACTIONS(1099),
    [anon_sym_STAR] = ACTIONS(1101),
    [anon_sym_CARET] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1097),
    [anon_sym_GT_EQ] = ACTIONS(1063),
    [anon_sym_LT_EQ] = ACTIONS(1063),
    [anon_sym_this] = ACTIONS(1103),
    [anon_sym_scoped] = ACTIONS(1105),
    [anon_sym_params] = ACTIONS(1107),
    [anon_sym_var] = ACTIONS(1067),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1111),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(1115),
    [anon_sym_not] = ACTIONS(1117),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [214] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_parameter] = STATE(8382),
    [sym__parameter_array] = STATE(8390),
    [sym_argument] = STATE(8836),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2787),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(5766),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_tuple_element] = STATE(8706),
    [sym_pattern] = STATE(8253),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(6141),
    [sym_property_pattern_clause] = STATE(6672),
    [sym_subpattern] = STATE(8877),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6145),
    [sym_non_lvalue_expression] = STATE(6331),
    [sym_lvalue_expression] = STATE(4306),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(5071),
    [sym_postfix_unary_expression] = STATE(5061),
    [sym_prefix_unary_expression] = STATE(5061),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(5071),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(5061),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(5071),
    [sym_member_access_expression] = STATE(3775),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(5061),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9027),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(5071),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(5071),
    [sym_typeof_expression] = STATE(5071),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3775),
    [sym_literal] = STATE(5071),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2773),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(214),
    [sym_preproc_endregion] = STATE(214),
    [sym_preproc_line] = STATE(214),
    [sym_preproc_pragma] = STATE(214),
    [sym_preproc_nullable] = STATE(214),
    [sym_preproc_error] = STATE(214),
    [sym_preproc_define] = STATE(214),
    [sym_preproc_undef] = STATE(214),
    [aux_sym_class_declaration_repeat1] = STATE(3550),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4143),
    [aux_sym_lambda_expression_repeat1] = STATE(4220),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(1203),
    [anon_sym_RPAREN] = ACTIONS(1205),
    [anon_sym_ref] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_readonly] = ACTIONS(1093),
    [anon_sym_LT] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1053),
    [anon_sym_in] = ACTIONS(1095),
    [anon_sym_out] = ACTIONS(1095),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1097),
    [anon_sym_TILDE] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1099),
    [anon_sym_DASH] = ACTIONS(1099),
    [anon_sym_STAR] = ACTIONS(1101),
    [anon_sym_CARET] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1097),
    [anon_sym_GT_EQ] = ACTIONS(1063),
    [anon_sym_LT_EQ] = ACTIONS(1063),
    [anon_sym_this] = ACTIONS(1103),
    [anon_sym_scoped] = ACTIONS(1105),
    [anon_sym_params] = ACTIONS(1107),
    [anon_sym_var] = ACTIONS(1067),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1111),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(1115),
    [anon_sym_not] = ACTIONS(1117),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [215] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_parameter] = STATE(8382),
    [sym__parameter_array] = STATE(8390),
    [sym_argument] = STATE(8836),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2787),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(5935),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_tuple_element] = STATE(8846),
    [sym_pattern] = STATE(8253),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(6141),
    [sym_property_pattern_clause] = STATE(6672),
    [sym_subpattern] = STATE(8877),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6145),
    [sym_non_lvalue_expression] = STATE(6331),
    [sym_lvalue_expression] = STATE(4306),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(5071),
    [sym_postfix_unary_expression] = STATE(5061),
    [sym_prefix_unary_expression] = STATE(5061),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(5071),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(5061),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(5071),
    [sym_member_access_expression] = STATE(3775),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(5061),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9027),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(5071),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(5071),
    [sym_typeof_expression] = STATE(5071),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3775),
    [sym_literal] = STATE(5071),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2773),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(215),
    [sym_preproc_endregion] = STATE(215),
    [sym_preproc_line] = STATE(215),
    [sym_preproc_pragma] = STATE(215),
    [sym_preproc_nullable] = STATE(215),
    [sym_preproc_error] = STATE(215),
    [sym_preproc_define] = STATE(215),
    [sym_preproc_undef] = STATE(215),
    [aux_sym_class_declaration_repeat1] = STATE(3550),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4143),
    [aux_sym_lambda_expression_repeat1] = STATE(4220),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(1203),
    [anon_sym_RPAREN] = ACTIONS(1207),
    [anon_sym_ref] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_readonly] = ACTIONS(1093),
    [anon_sym_LT] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1053),
    [anon_sym_in] = ACTIONS(1095),
    [anon_sym_out] = ACTIONS(1095),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1097),
    [anon_sym_TILDE] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1099),
    [anon_sym_DASH] = ACTIONS(1099),
    [anon_sym_STAR] = ACTIONS(1101),
    [anon_sym_CARET] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1097),
    [anon_sym_GT_EQ] = ACTIONS(1063),
    [anon_sym_LT_EQ] = ACTIONS(1063),
    [anon_sym_this] = ACTIONS(1103),
    [anon_sym_scoped] = ACTIONS(1105),
    [anon_sym_params] = ACTIONS(1107),
    [anon_sym_var] = ACTIONS(1067),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1111),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(1115),
    [anon_sym_not] = ACTIONS(1117),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [216] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_parameter] = STATE(8382),
    [sym__parameter_array] = STATE(8390),
    [sym_argument] = STATE(8836),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2787),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(5814),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_tuple_element] = STATE(8846),
    [sym_pattern] = STATE(8253),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(6141),
    [sym_property_pattern_clause] = STATE(6672),
    [sym_subpattern] = STATE(8877),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6145),
    [sym_non_lvalue_expression] = STATE(6331),
    [sym_lvalue_expression] = STATE(4306),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(5071),
    [sym_postfix_unary_expression] = STATE(5061),
    [sym_prefix_unary_expression] = STATE(5061),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(5071),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(5061),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(5071),
    [sym_member_access_expression] = STATE(3775),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(5061),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9027),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(5071),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(5071),
    [sym_typeof_expression] = STATE(5071),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3775),
    [sym_literal] = STATE(5071),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2773),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(216),
    [sym_preproc_endregion] = STATE(216),
    [sym_preproc_line] = STATE(216),
    [sym_preproc_pragma] = STATE(216),
    [sym_preproc_nullable] = STATE(216),
    [sym_preproc_error] = STATE(216),
    [sym_preproc_define] = STATE(216),
    [sym_preproc_undef] = STATE(216),
    [aux_sym_class_declaration_repeat1] = STATE(3550),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4143),
    [aux_sym_lambda_expression_repeat1] = STATE(4220),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(1203),
    [anon_sym_RPAREN] = ACTIONS(1207),
    [anon_sym_ref] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_readonly] = ACTIONS(1093),
    [anon_sym_LT] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1053),
    [anon_sym_in] = ACTIONS(1095),
    [anon_sym_out] = ACTIONS(1095),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1097),
    [anon_sym_TILDE] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1099),
    [anon_sym_DASH] = ACTIONS(1099),
    [anon_sym_STAR] = ACTIONS(1101),
    [anon_sym_CARET] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1097),
    [anon_sym_GT_EQ] = ACTIONS(1063),
    [anon_sym_LT_EQ] = ACTIONS(1063),
    [anon_sym_this] = ACTIONS(1103),
    [anon_sym_scoped] = ACTIONS(1105),
    [anon_sym_params] = ACTIONS(1107),
    [anon_sym_var] = ACTIONS(1067),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1111),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(1115),
    [anon_sym_not] = ACTIONS(1117),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [217] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_parameter] = STATE(8382),
    [sym__parameter_array] = STATE(8390),
    [sym_argument] = STATE(8759),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2787),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(5934),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_tuple_element] = STATE(8952),
    [sym_pattern] = STATE(8302),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(6141),
    [sym_property_pattern_clause] = STATE(6672),
    [sym_subpattern] = STATE(8936),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6145),
    [sym_non_lvalue_expression] = STATE(6506),
    [sym_lvalue_expression] = STATE(4306),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(5071),
    [sym_postfix_unary_expression] = STATE(5061),
    [sym_prefix_unary_expression] = STATE(5061),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(5071),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(5061),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(5071),
    [sym_member_access_expression] = STATE(3775),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(5061),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9027),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(5071),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(5071),
    [sym_typeof_expression] = STATE(5071),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3775),
    [sym_literal] = STATE(5071),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2773),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(217),
    [sym_preproc_endregion] = STATE(217),
    [sym_preproc_line] = STATE(217),
    [sym_preproc_pragma] = STATE(217),
    [sym_preproc_nullable] = STATE(217),
    [sym_preproc_error] = STATE(217),
    [sym_preproc_define] = STATE(217),
    [sym_preproc_undef] = STATE(217),
    [aux_sym_class_declaration_repeat1] = STATE(3550),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4143),
    [aux_sym_lambda_expression_repeat1] = STATE(4220),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(1203),
    [anon_sym_RPAREN] = ACTIONS(1209),
    [anon_sym_ref] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_readonly] = ACTIONS(1093),
    [anon_sym_LT] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1053),
    [anon_sym_in] = ACTIONS(1095),
    [anon_sym_out] = ACTIONS(1095),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1097),
    [anon_sym_TILDE] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1099),
    [anon_sym_DASH] = ACTIONS(1099),
    [anon_sym_STAR] = ACTIONS(1101),
    [anon_sym_CARET] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1097),
    [anon_sym_GT_EQ] = ACTIONS(1063),
    [anon_sym_LT_EQ] = ACTIONS(1063),
    [anon_sym_this] = ACTIONS(1103),
    [anon_sym_scoped] = ACTIONS(1105),
    [anon_sym_params] = ACTIONS(1107),
    [anon_sym_var] = ACTIONS(1067),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1111),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(1115),
    [anon_sym_not] = ACTIONS(1117),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [218] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_parameter] = STATE(8382),
    [sym__parameter_array] = STATE(8390),
    [sym_argument] = STATE(8885),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2787),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6003),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_tuple_element] = STATE(8706),
    [sym_pattern] = STATE(8317),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(6141),
    [sym_property_pattern_clause] = STATE(6672),
    [sym_subpattern] = STATE(8877),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6145),
    [sym_non_lvalue_expression] = STATE(6400),
    [sym_lvalue_expression] = STATE(4306),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(5071),
    [sym_postfix_unary_expression] = STATE(5061),
    [sym_prefix_unary_expression] = STATE(5061),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(5071),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(5061),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(5071),
    [sym_member_access_expression] = STATE(3775),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(5061),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9027),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(5071),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(5071),
    [sym_typeof_expression] = STATE(5071),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3775),
    [sym_literal] = STATE(5071),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2773),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(218),
    [sym_preproc_endregion] = STATE(218),
    [sym_preproc_line] = STATE(218),
    [sym_preproc_pragma] = STATE(218),
    [sym_preproc_nullable] = STATE(218),
    [sym_preproc_error] = STATE(218),
    [sym_preproc_define] = STATE(218),
    [sym_preproc_undef] = STATE(218),
    [aux_sym_class_declaration_repeat1] = STATE(3550),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4143),
    [aux_sym_lambda_expression_repeat1] = STATE(4220),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(1203),
    [anon_sym_RPAREN] = ACTIONS(1205),
    [anon_sym_ref] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_readonly] = ACTIONS(1093),
    [anon_sym_LT] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1053),
    [anon_sym_in] = ACTIONS(1095),
    [anon_sym_out] = ACTIONS(1095),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1097),
    [anon_sym_TILDE] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1099),
    [anon_sym_DASH] = ACTIONS(1099),
    [anon_sym_STAR] = ACTIONS(1101),
    [anon_sym_CARET] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1097),
    [anon_sym_GT_EQ] = ACTIONS(1063),
    [anon_sym_LT_EQ] = ACTIONS(1063),
    [anon_sym_this] = ACTIONS(1103),
    [anon_sym_scoped] = ACTIONS(1105),
    [anon_sym_params] = ACTIONS(1107),
    [anon_sym_var] = ACTIONS(1067),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1111),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(1115),
    [anon_sym_not] = ACTIONS(1117),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [219] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_parameter] = STATE(8382),
    [sym__parameter_array] = STATE(8390),
    [sym_argument] = STATE(8885),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2787),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6014),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_tuple_element] = STATE(8706),
    [sym_pattern] = STATE(8317),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(6141),
    [sym_property_pattern_clause] = STATE(6672),
    [sym_subpattern] = STATE(8877),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6145),
    [sym_non_lvalue_expression] = STATE(6400),
    [sym_lvalue_expression] = STATE(4306),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(5071),
    [sym_postfix_unary_expression] = STATE(5061),
    [sym_prefix_unary_expression] = STATE(5061),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(5071),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(5061),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(5071),
    [sym_member_access_expression] = STATE(3775),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(5061),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9027),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(5071),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(5071),
    [sym_typeof_expression] = STATE(5071),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3775),
    [sym_literal] = STATE(5071),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2773),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(219),
    [sym_preproc_endregion] = STATE(219),
    [sym_preproc_line] = STATE(219),
    [sym_preproc_pragma] = STATE(219),
    [sym_preproc_nullable] = STATE(219),
    [sym_preproc_error] = STATE(219),
    [sym_preproc_define] = STATE(219),
    [sym_preproc_undef] = STATE(219),
    [aux_sym_class_declaration_repeat1] = STATE(3550),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4143),
    [aux_sym_lambda_expression_repeat1] = STATE(4220),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(1203),
    [anon_sym_RPAREN] = ACTIONS(1207),
    [anon_sym_ref] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_readonly] = ACTIONS(1093),
    [anon_sym_LT] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1053),
    [anon_sym_in] = ACTIONS(1095),
    [anon_sym_out] = ACTIONS(1095),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1097),
    [anon_sym_TILDE] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1099),
    [anon_sym_DASH] = ACTIONS(1099),
    [anon_sym_STAR] = ACTIONS(1101),
    [anon_sym_CARET] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1097),
    [anon_sym_GT_EQ] = ACTIONS(1063),
    [anon_sym_LT_EQ] = ACTIONS(1063),
    [anon_sym_this] = ACTIONS(1103),
    [anon_sym_scoped] = ACTIONS(1105),
    [anon_sym_params] = ACTIONS(1107),
    [anon_sym_var] = ACTIONS(1067),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1111),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(1115),
    [anon_sym_not] = ACTIONS(1117),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [220] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_parameter] = STATE(8382),
    [sym__parameter_array] = STATE(8390),
    [sym_argument] = STATE(8885),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2787),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6026),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_tuple_element] = STATE(8706),
    [sym_pattern] = STATE(8317),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(6141),
    [sym_property_pattern_clause] = STATE(6672),
    [sym_subpattern] = STATE(8877),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6145),
    [sym_non_lvalue_expression] = STATE(6400),
    [sym_lvalue_expression] = STATE(4306),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(5071),
    [sym_postfix_unary_expression] = STATE(5061),
    [sym_prefix_unary_expression] = STATE(5061),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(5071),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(5061),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(5071),
    [sym_member_access_expression] = STATE(3775),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(5061),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9027),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(5071),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(5071),
    [sym_typeof_expression] = STATE(5071),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3775),
    [sym_literal] = STATE(5071),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2773),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(220),
    [sym_preproc_endregion] = STATE(220),
    [sym_preproc_line] = STATE(220),
    [sym_preproc_pragma] = STATE(220),
    [sym_preproc_nullable] = STATE(220),
    [sym_preproc_error] = STATE(220),
    [sym_preproc_define] = STATE(220),
    [sym_preproc_undef] = STATE(220),
    [aux_sym_class_declaration_repeat1] = STATE(3550),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4143),
    [aux_sym_lambda_expression_repeat1] = STATE(4220),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(1203),
    [anon_sym_RPAREN] = ACTIONS(1207),
    [anon_sym_ref] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_readonly] = ACTIONS(1093),
    [anon_sym_LT] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1053),
    [anon_sym_in] = ACTIONS(1095),
    [anon_sym_out] = ACTIONS(1095),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1097),
    [anon_sym_TILDE] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1099),
    [anon_sym_DASH] = ACTIONS(1099),
    [anon_sym_STAR] = ACTIONS(1101),
    [anon_sym_CARET] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1097),
    [anon_sym_GT_EQ] = ACTIONS(1063),
    [anon_sym_LT_EQ] = ACTIONS(1063),
    [anon_sym_this] = ACTIONS(1103),
    [anon_sym_scoped] = ACTIONS(1105),
    [anon_sym_params] = ACTIONS(1107),
    [anon_sym_var] = ACTIONS(1067),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1111),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(1115),
    [anon_sym_not] = ACTIONS(1117),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [221] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_parameter] = STATE(8382),
    [sym__parameter_array] = STATE(8390),
    [sym_argument] = STATE(8885),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2787),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6033),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_tuple_element] = STATE(8706),
    [sym_pattern] = STATE(8317),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(6141),
    [sym_property_pattern_clause] = STATE(6672),
    [sym_subpattern] = STATE(8877),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6145),
    [sym_non_lvalue_expression] = STATE(6400),
    [sym_lvalue_expression] = STATE(4306),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(5071),
    [sym_postfix_unary_expression] = STATE(5061),
    [sym_prefix_unary_expression] = STATE(5061),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(5071),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(5061),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(5071),
    [sym_member_access_expression] = STATE(3775),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(5061),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9027),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(5071),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(5071),
    [sym_typeof_expression] = STATE(5071),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3775),
    [sym_literal] = STATE(5071),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2773),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(221),
    [sym_preproc_endregion] = STATE(221),
    [sym_preproc_line] = STATE(221),
    [sym_preproc_pragma] = STATE(221),
    [sym_preproc_nullable] = STATE(221),
    [sym_preproc_error] = STATE(221),
    [sym_preproc_define] = STATE(221),
    [sym_preproc_undef] = STATE(221),
    [aux_sym_class_declaration_repeat1] = STATE(3550),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4143),
    [aux_sym_lambda_expression_repeat1] = STATE(4220),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(1203),
    [anon_sym_RPAREN] = ACTIONS(1207),
    [anon_sym_ref] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_readonly] = ACTIONS(1093),
    [anon_sym_LT] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1053),
    [anon_sym_in] = ACTIONS(1095),
    [anon_sym_out] = ACTIONS(1095),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1097),
    [anon_sym_TILDE] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1099),
    [anon_sym_DASH] = ACTIONS(1099),
    [anon_sym_STAR] = ACTIONS(1101),
    [anon_sym_CARET] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1097),
    [anon_sym_GT_EQ] = ACTIONS(1063),
    [anon_sym_LT_EQ] = ACTIONS(1063),
    [anon_sym_this] = ACTIONS(1103),
    [anon_sym_scoped] = ACTIONS(1105),
    [anon_sym_params] = ACTIONS(1107),
    [anon_sym_var] = ACTIONS(1067),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1111),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(1115),
    [anon_sym_not] = ACTIONS(1117),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [222] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6918),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7126),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4899),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(3736),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7377),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9441),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(222),
    [sym_preproc_endregion] = STATE(222),
    [sym_preproc_line] = STATE(222),
    [sym_preproc_pragma] = STATE(222),
    [sym_preproc_nullable] = STATE(222),
    [sym_preproc_error] = STATE(222),
    [sym_preproc_define] = STATE(222),
    [sym_preproc_undef] = STATE(222),
    [aux_sym_class_declaration_repeat1] = STATE(3848),
    [aux_sym_lambda_expression_repeat1] = STATE(4242),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(1199),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_COMMA] = ACTIONS(1199),
    [anon_sym_RBRACK] = ACTIONS(1199),
    [anon_sym_LPAREN] = ACTIONS(1213),
    [anon_sym_RPAREN] = ACTIONS(1199),
    [anon_sym_ref] = ACTIONS(1215),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_RBRACE] = ACTIONS(1199),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1221),
    [anon_sym_LT] = ACTIONS(1201),
    [anon_sym_GT] = ACTIONS(1201),
    [anon_sym_in] = ACTIONS(1201),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1201),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1225),
    [anon_sym_TILDE] = ACTIONS(1227),
    [anon_sym_PLUS_PLUS] = ACTIONS(1227),
    [anon_sym_DASH_DASH] = ACTIONS(1227),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1225),
    [anon_sym_DASH] = ACTIONS(1225),
    [anon_sym_STAR] = ACTIONS(1231),
    [anon_sym_SLASH] = ACTIONS(1201),
    [anon_sym_PERCENT] = ACTIONS(1199),
    [anon_sym_CARET] = ACTIONS(1227),
    [anon_sym_PIPE] = ACTIONS(1201),
    [anon_sym_AMP] = ACTIONS(1225),
    [anon_sym_LT_LT] = ACTIONS(1199),
    [anon_sym_GT_GT] = ACTIONS(1201),
    [anon_sym_GT_GT_GT] = ACTIONS(1199),
    [anon_sym_EQ_EQ] = ACTIONS(1199),
    [anon_sym_BANG_EQ] = ACTIONS(1199),
    [anon_sym_GT_EQ] = ACTIONS(1199),
    [anon_sym_LT_EQ] = ACTIONS(1199),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_DOT] = ACTIONS(1201),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1201),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1239),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1241),
    [anon_sym_DOT_DOT] = ACTIONS(1243),
    [anon_sym_AMP_AMP] = ACTIONS(1199),
    [anon_sym_PIPE_PIPE] = ACTIONS(1199),
    [anon_sym_QMARK_QMARK] = ACTIONS(1199),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1201),
    [anon_sym_is] = ACTIONS(1201),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_DASH_GT] = ACTIONS(1199),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_with] = ACTIONS(1201),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_if_token3] = ACTIONS(1199),
    [aux_sym_preproc_else_token1] = ACTIONS(1199),
    [aux_sym_preproc_elif_token1] = ACTIONS(1199),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [223] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_parameter] = STATE(8382),
    [sym__parameter_array] = STATE(8390),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2789),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6142),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_pattern] = STATE(8221),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(6141),
    [sym_property_pattern_clause] = STATE(6672),
    [sym_subpattern] = STATE(8877),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym__variable_designation] = STATE(8365),
    [sym_parenthesized_variable_designation] = STATE(4274),
    [sym_expression] = STATE(6495),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4482),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(5313),
    [sym_postfix_unary_expression] = STATE(5314),
    [sym_prefix_unary_expression] = STATE(5314),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(5313),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(5314),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(5313),
    [sym_member_access_expression] = STATE(3856),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(5314),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9438),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(5313),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(5313),
    [sym_typeof_expression] = STATE(5313),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3856),
    [sym_literal] = STATE(5313),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2781),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(223),
    [sym_preproc_endregion] = STATE(223),
    [sym_preproc_line] = STATE(223),
    [sym_preproc_pragma] = STATE(223),
    [sym_preproc_nullable] = STATE(223),
    [sym_preproc_error] = STATE(223),
    [sym_preproc_define] = STATE(223),
    [sym_preproc_undef] = STATE(223),
    [aux_sym_class_declaration_repeat1] = STATE(3566),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4143),
    [aux_sym_lambda_expression_repeat1] = STATE(4134),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(1273),
    [anon_sym_RPAREN] = ACTIONS(1087),
    [anon_sym_ref] = ACTIONS(1275),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_readonly] = ACTIONS(1093),
    [anon_sym_LT] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1053),
    [anon_sym_in] = ACTIONS(1093),
    [anon_sym_out] = ACTIONS(1093),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1097),
    [anon_sym_TILDE] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1099),
    [anon_sym_DASH] = ACTIONS(1099),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1097),
    [anon_sym_GT_EQ] = ACTIONS(1063),
    [anon_sym_LT_EQ] = ACTIONS(1063),
    [anon_sym_this] = ACTIONS(1103),
    [anon_sym_scoped] = ACTIONS(1105),
    [anon_sym_params] = ACTIONS(1107),
    [anon_sym_var] = ACTIONS(1279),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1281),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1283),
    [sym_discard] = ACTIONS(1113),
    [anon_sym_DOT_DOT] = ACTIONS(1285),
    [anon_sym_not] = ACTIONS(1077),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [224] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_parameter] = STATE(8382),
    [sym__parameter_array] = STATE(8390),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2789),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6142),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_pattern] = STATE(8221),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(6141),
    [sym_property_pattern_clause] = STATE(6672),
    [sym_subpattern] = STATE(8877),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym__variable_designation] = STATE(8365),
    [sym_parenthesized_variable_designation] = STATE(4274),
    [sym_expression] = STATE(6495),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4482),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(5313),
    [sym_postfix_unary_expression] = STATE(5314),
    [sym_prefix_unary_expression] = STATE(5314),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(5313),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(5314),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(5313),
    [sym_member_access_expression] = STATE(3856),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(5314),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9438),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(5313),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(5313),
    [sym_typeof_expression] = STATE(5313),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3856),
    [sym_literal] = STATE(5313),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2781),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(224),
    [sym_preproc_endregion] = STATE(224),
    [sym_preproc_line] = STATE(224),
    [sym_preproc_pragma] = STATE(224),
    [sym_preproc_nullable] = STATE(224),
    [sym_preproc_error] = STATE(224),
    [sym_preproc_define] = STATE(224),
    [sym_preproc_undef] = STATE(224),
    [aux_sym_class_declaration_repeat1] = STATE(3566),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4143),
    [aux_sym_lambda_expression_repeat1] = STATE(4134),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(1273),
    [anon_sym_RPAREN] = ACTIONS(1287),
    [anon_sym_ref] = ACTIONS(1275),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_readonly] = ACTIONS(1093),
    [anon_sym_LT] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1053),
    [anon_sym_in] = ACTIONS(1093),
    [anon_sym_out] = ACTIONS(1093),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1097),
    [anon_sym_TILDE] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1099),
    [anon_sym_DASH] = ACTIONS(1099),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1097),
    [anon_sym_GT_EQ] = ACTIONS(1063),
    [anon_sym_LT_EQ] = ACTIONS(1063),
    [anon_sym_this] = ACTIONS(1103),
    [anon_sym_scoped] = ACTIONS(1105),
    [anon_sym_params] = ACTIONS(1107),
    [anon_sym_var] = ACTIONS(1279),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1281),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1283),
    [sym_discard] = ACTIONS(1113),
    [anon_sym_DOT_DOT] = ACTIONS(1285),
    [anon_sym_not] = ACTIONS(1077),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [225] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6918),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7126),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4765),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(3736),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7377),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9441),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(225),
    [sym_preproc_endregion] = STATE(225),
    [sym_preproc_line] = STATE(225),
    [sym_preproc_pragma] = STATE(225),
    [sym_preproc_nullable] = STATE(225),
    [sym_preproc_error] = STATE(225),
    [sym_preproc_define] = STATE(225),
    [sym_preproc_undef] = STATE(225),
    [aux_sym_class_declaration_repeat1] = STATE(3848),
    [aux_sym_lambda_expression_repeat1] = STATE(4242),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(1133),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_COMMA] = ACTIONS(1133),
    [anon_sym_RBRACK] = ACTIONS(1133),
    [anon_sym_LPAREN] = ACTIONS(1213),
    [anon_sym_RPAREN] = ACTIONS(1133),
    [anon_sym_ref] = ACTIONS(1215),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_RBRACE] = ACTIONS(1133),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1221),
    [anon_sym_LT] = ACTIONS(1147),
    [anon_sym_GT] = ACTIONS(1147),
    [anon_sym_in] = ACTIONS(1147),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1147),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1225),
    [anon_sym_TILDE] = ACTIONS(1227),
    [anon_sym_PLUS_PLUS] = ACTIONS(1227),
    [anon_sym_DASH_DASH] = ACTIONS(1227),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1225),
    [anon_sym_DASH] = ACTIONS(1225),
    [anon_sym_STAR] = ACTIONS(1231),
    [anon_sym_SLASH] = ACTIONS(1147),
    [anon_sym_PERCENT] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(1227),
    [anon_sym_PIPE] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(1225),
    [anon_sym_LT_LT] = ACTIONS(1133),
    [anon_sym_GT_GT] = ACTIONS(1147),
    [anon_sym_GT_GT_GT] = ACTIONS(1133),
    [anon_sym_EQ_EQ] = ACTIONS(1133),
    [anon_sym_BANG_EQ] = ACTIONS(1133),
    [anon_sym_GT_EQ] = ACTIONS(1133),
    [anon_sym_LT_EQ] = ACTIONS(1133),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_DOT] = ACTIONS(1147),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1147),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1239),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1241),
    [anon_sym_DOT_DOT] = ACTIONS(1243),
    [anon_sym_AMP_AMP] = ACTIONS(1133),
    [anon_sym_PIPE_PIPE] = ACTIONS(1133),
    [anon_sym_QMARK_QMARK] = ACTIONS(1133),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1147),
    [anon_sym_is] = ACTIONS(1147),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_DASH_GT] = ACTIONS(1133),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_with] = ACTIONS(1147),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_if_token3] = ACTIONS(1133),
    [aux_sym_preproc_else_token1] = ACTIONS(1133),
    [aux_sym_preproc_elif_token1] = ACTIONS(1133),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [226] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6967),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5105),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(3858),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7382),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9625),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(226),
    [sym_preproc_endregion] = STATE(226),
    [sym_preproc_line] = STATE(226),
    [sym_preproc_pragma] = STATE(226),
    [sym_preproc_nullable] = STATE(226),
    [sym_preproc_error] = STATE(226),
    [sym_preproc_define] = STATE(226),
    [sym_preproc_undef] = STATE(226),
    [aux_sym_class_declaration_repeat1] = STATE(3851),
    [aux_sym_lambda_expression_repeat1] = STATE(4234),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(1199),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_COMMA] = ACTIONS(1199),
    [anon_sym_RBRACK] = ACTIONS(1199),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_RPAREN] = ACTIONS(1199),
    [anon_sym_ref] = ACTIONS(1293),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_RBRACE] = ACTIONS(1199),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(1201),
    [anon_sym_GT] = ACTIONS(1201),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1201),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1061),
    [anon_sym_TILDE] = ACTIONS(1059),
    [anon_sym_PLUS_PLUS] = ACTIONS(1059),
    [anon_sym_DASH_DASH] = ACTIONS(1059),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1061),
    [anon_sym_DASH] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(1303),
    [anon_sym_SLASH] = ACTIONS(1201),
    [anon_sym_PERCENT] = ACTIONS(1199),
    [anon_sym_CARET] = ACTIONS(1059),
    [anon_sym_PIPE] = ACTIONS(1201),
    [anon_sym_AMP] = ACTIONS(1061),
    [anon_sym_LT_LT] = ACTIONS(1199),
    [anon_sym_GT_GT] = ACTIONS(1201),
    [anon_sym_GT_GT_GT] = ACTIONS(1199),
    [anon_sym_EQ_EQ] = ACTIONS(1199),
    [anon_sym_BANG_EQ] = ACTIONS(1199),
    [anon_sym_GT_EQ] = ACTIONS(1199),
    [anon_sym_LT_EQ] = ACTIONS(1199),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_DOT] = ACTIONS(1201),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1201),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1307),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1309),
    [anon_sym_DOT_DOT] = ACTIONS(1311),
    [anon_sym_and] = ACTIONS(1201),
    [anon_sym_or] = ACTIONS(1201),
    [anon_sym_AMP_AMP] = ACTIONS(1199),
    [anon_sym_PIPE_PIPE] = ACTIONS(1199),
    [anon_sym_QMARK_QMARK] = ACTIONS(1199),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1201),
    [anon_sym_is] = ACTIONS(1201),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_DASH_GT] = ACTIONS(1199),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_with] = ACTIONS(1201),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [227] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6967),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5055),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(3858),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7382),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9625),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(227),
    [sym_preproc_endregion] = STATE(227),
    [sym_preproc_line] = STATE(227),
    [sym_preproc_pragma] = STATE(227),
    [sym_preproc_nullable] = STATE(227),
    [sym_preproc_error] = STATE(227),
    [sym_preproc_define] = STATE(227),
    [sym_preproc_undef] = STATE(227),
    [aux_sym_class_declaration_repeat1] = STATE(3851),
    [aux_sym_lambda_expression_repeat1] = STATE(4234),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(1133),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_COMMA] = ACTIONS(1133),
    [anon_sym_RBRACK] = ACTIONS(1133),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_RPAREN] = ACTIONS(1133),
    [anon_sym_ref] = ACTIONS(1293),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_RBRACE] = ACTIONS(1133),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(1147),
    [anon_sym_GT] = ACTIONS(1147),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1147),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1061),
    [anon_sym_TILDE] = ACTIONS(1059),
    [anon_sym_PLUS_PLUS] = ACTIONS(1059),
    [anon_sym_DASH_DASH] = ACTIONS(1059),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1061),
    [anon_sym_DASH] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(1303),
    [anon_sym_SLASH] = ACTIONS(1147),
    [anon_sym_PERCENT] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(1059),
    [anon_sym_PIPE] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(1061),
    [anon_sym_LT_LT] = ACTIONS(1133),
    [anon_sym_GT_GT] = ACTIONS(1147),
    [anon_sym_GT_GT_GT] = ACTIONS(1133),
    [anon_sym_EQ_EQ] = ACTIONS(1133),
    [anon_sym_BANG_EQ] = ACTIONS(1133),
    [anon_sym_GT_EQ] = ACTIONS(1133),
    [anon_sym_LT_EQ] = ACTIONS(1133),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_DOT] = ACTIONS(1147),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1147),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1307),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1309),
    [anon_sym_DOT_DOT] = ACTIONS(1311),
    [anon_sym_and] = ACTIONS(1147),
    [anon_sym_or] = ACTIONS(1147),
    [anon_sym_AMP_AMP] = ACTIONS(1133),
    [anon_sym_PIPE_PIPE] = ACTIONS(1133),
    [anon_sym_QMARK_QMARK] = ACTIONS(1133),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1147),
    [anon_sym_is] = ACTIONS(1147),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_DASH_GT] = ACTIONS(1133),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_with] = ACTIONS(1147),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [228] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6911),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6992),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5099),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(3829),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7391),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9246),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(228),
    [sym_preproc_endregion] = STATE(228),
    [sym_preproc_line] = STATE(228),
    [sym_preproc_pragma] = STATE(228),
    [sym_preproc_nullable] = STATE(228),
    [sym_preproc_error] = STATE(228),
    [sym_preproc_define] = STATE(228),
    [sym_preproc_undef] = STATE(228),
    [aux_sym_class_declaration_repeat1] = STATE(3800),
    [aux_sym_lambda_expression_repeat1] = STATE(4089),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(1199),
    [anon_sym_COMMA] = ACTIONS(1199),
    [anon_sym_LPAREN] = ACTIONS(1323),
    [anon_sym_RPAREN] = ACTIONS(1199),
    [anon_sym_ref] = ACTIONS(1325),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_RBRACE] = ACTIONS(1199),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1145),
    [anon_sym_LT] = ACTIONS(1201),
    [anon_sym_GT] = ACTIONS(1201),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1201),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1327),
    [anon_sym_TILDE] = ACTIONS(1329),
    [anon_sym_PLUS_PLUS] = ACTIONS(1329),
    [anon_sym_DASH_DASH] = ACTIONS(1329),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1327),
    [anon_sym_DASH] = ACTIONS(1327),
    [anon_sym_STAR] = ACTIONS(1331),
    [anon_sym_SLASH] = ACTIONS(1201),
    [anon_sym_PERCENT] = ACTIONS(1199),
    [anon_sym_CARET] = ACTIONS(1329),
    [anon_sym_PIPE] = ACTIONS(1201),
    [anon_sym_AMP] = ACTIONS(1327),
    [anon_sym_LT_LT] = ACTIONS(1199),
    [anon_sym_GT_GT] = ACTIONS(1201),
    [anon_sym_GT_GT_GT] = ACTIONS(1199),
    [anon_sym_EQ_EQ] = ACTIONS(1199),
    [anon_sym_BANG_EQ] = ACTIONS(1199),
    [anon_sym_GT_EQ] = ACTIONS(1199),
    [anon_sym_LT_EQ] = ACTIONS(1199),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_DOT] = ACTIONS(1201),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1201),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1333),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1335),
    [anon_sym_DOT_DOT] = ACTIONS(1337),
    [anon_sym_and] = ACTIONS(1201),
    [anon_sym_or] = ACTIONS(1201),
    [anon_sym_AMP_AMP] = ACTIONS(1199),
    [anon_sym_PIPE_PIPE] = ACTIONS(1199),
    [anon_sym_QMARK_QMARK] = ACTIONS(1199),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1201),
    [anon_sym_is] = ACTIONS(1201),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_DASH_GT] = ACTIONS(1199),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_with] = ACTIONS(1201),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [229] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6880),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7104),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5180),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(3863),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7380),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9420),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(229),
    [sym_preproc_endregion] = STATE(229),
    [sym_preproc_line] = STATE(229),
    [sym_preproc_pragma] = STATE(229),
    [sym_preproc_nullable] = STATE(229),
    [sym_preproc_error] = STATE(229),
    [sym_preproc_define] = STATE(229),
    [sym_preproc_undef] = STATE(229),
    [aux_sym_class_declaration_repeat1] = STATE(3820),
    [aux_sym_lambda_expression_repeat1] = STATE(4165),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_COLON] = ACTIONS(1199),
    [anon_sym_COMMA] = ACTIONS(1199),
    [anon_sym_LPAREN] = ACTIONS(1339),
    [anon_sym_RPAREN] = ACTIONS(1199),
    [anon_sym_ref] = ACTIONS(1341),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_RBRACE] = ACTIONS(1199),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(1201),
    [anon_sym_GT] = ACTIONS(1201),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1201),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1099),
    [anon_sym_TILDE] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1099),
    [anon_sym_DASH] = ACTIONS(1099),
    [anon_sym_STAR] = ACTIONS(1343),
    [anon_sym_SLASH] = ACTIONS(1201),
    [anon_sym_PERCENT] = ACTIONS(1199),
    [anon_sym_CARET] = ACTIONS(1097),
    [anon_sym_PIPE] = ACTIONS(1201),
    [anon_sym_AMP] = ACTIONS(1099),
    [anon_sym_LT_LT] = ACTIONS(1199),
    [anon_sym_GT_GT] = ACTIONS(1201),
    [anon_sym_GT_GT_GT] = ACTIONS(1199),
    [anon_sym_EQ_EQ] = ACTIONS(1199),
    [anon_sym_BANG_EQ] = ACTIONS(1199),
    [anon_sym_GT_EQ] = ACTIONS(1199),
    [anon_sym_LT_EQ] = ACTIONS(1199),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_DOT] = ACTIONS(1201),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1201),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1345),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1347),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym_and] = ACTIONS(1201),
    [anon_sym_or] = ACTIONS(1201),
    [anon_sym_AMP_AMP] = ACTIONS(1199),
    [anon_sym_PIPE_PIPE] = ACTIONS(1199),
    [anon_sym_QMARK_QMARK] = ACTIONS(1199),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1201),
    [anon_sym_is] = ACTIONS(1201),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_DASH_GT] = ACTIONS(1199),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_with] = ACTIONS(1201),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [230] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7064),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5139),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(3866),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7382),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9762),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(230),
    [sym_preproc_endregion] = STATE(230),
    [sym_preproc_line] = STATE(230),
    [sym_preproc_pragma] = STATE(230),
    [sym_preproc_nullable] = STATE(230),
    [sym_preproc_error] = STATE(230),
    [sym_preproc_define] = STATE(230),
    [sym_preproc_undef] = STATE(230),
    [aux_sym_class_declaration_repeat1] = STATE(3842),
    [aux_sym_lambda_expression_repeat1] = STATE(4280),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(1199),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1351),
    [anon_sym_ref] = ACTIONS(1353),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(1201),
    [anon_sym_GT] = ACTIONS(1201),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1201),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1355),
    [anon_sym_TILDE] = ACTIONS(1357),
    [anon_sym_PLUS_PLUS] = ACTIONS(1357),
    [anon_sym_DASH_DASH] = ACTIONS(1357),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1355),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_SLASH] = ACTIONS(1201),
    [anon_sym_PERCENT] = ACTIONS(1199),
    [anon_sym_CARET] = ACTIONS(1357),
    [anon_sym_PIPE] = ACTIONS(1201),
    [anon_sym_AMP] = ACTIONS(1355),
    [anon_sym_LT_LT] = ACTIONS(1199),
    [anon_sym_GT_GT] = ACTIONS(1201),
    [anon_sym_GT_GT_GT] = ACTIONS(1199),
    [anon_sym_EQ_EQ] = ACTIONS(1199),
    [anon_sym_BANG_EQ] = ACTIONS(1199),
    [anon_sym_GT_EQ] = ACTIONS(1199),
    [anon_sym_LT_EQ] = ACTIONS(1199),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_DOT] = ACTIONS(1201),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1201),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1361),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1363),
    [anon_sym_DOT_DOT] = ACTIONS(1365),
    [anon_sym_and] = ACTIONS(1201),
    [anon_sym_or] = ACTIONS(1201),
    [anon_sym_AMP_AMP] = ACTIONS(1199),
    [anon_sym_PIPE_PIPE] = ACTIONS(1199),
    [anon_sym_QMARK_QMARK] = ACTIONS(1199),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1201),
    [anon_sym_is] = ACTIONS(1201),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_DASH_GT] = ACTIONS(1199),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_with] = ACTIONS(1201),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_if_token3] = ACTIONS(1199),
    [aux_sym_preproc_else_token1] = ACTIONS(1199),
    [aux_sym_preproc_elif_token1] = ACTIONS(1199),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [231] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7064),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5194),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(3866),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7382),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9762),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(231),
    [sym_preproc_endregion] = STATE(231),
    [sym_preproc_line] = STATE(231),
    [sym_preproc_pragma] = STATE(231),
    [sym_preproc_nullable] = STATE(231),
    [sym_preproc_error] = STATE(231),
    [sym_preproc_define] = STATE(231),
    [sym_preproc_undef] = STATE(231),
    [aux_sym_class_declaration_repeat1] = STATE(3842),
    [aux_sym_lambda_expression_repeat1] = STATE(4280),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(1133),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1351),
    [anon_sym_ref] = ACTIONS(1353),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(1147),
    [anon_sym_GT] = ACTIONS(1147),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1147),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1355),
    [anon_sym_TILDE] = ACTIONS(1357),
    [anon_sym_PLUS_PLUS] = ACTIONS(1357),
    [anon_sym_DASH_DASH] = ACTIONS(1357),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1355),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_SLASH] = ACTIONS(1147),
    [anon_sym_PERCENT] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(1357),
    [anon_sym_PIPE] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(1355),
    [anon_sym_LT_LT] = ACTIONS(1133),
    [anon_sym_GT_GT] = ACTIONS(1147),
    [anon_sym_GT_GT_GT] = ACTIONS(1133),
    [anon_sym_EQ_EQ] = ACTIONS(1133),
    [anon_sym_BANG_EQ] = ACTIONS(1133),
    [anon_sym_GT_EQ] = ACTIONS(1133),
    [anon_sym_LT_EQ] = ACTIONS(1133),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_DOT] = ACTIONS(1147),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1147),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1361),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1363),
    [anon_sym_DOT_DOT] = ACTIONS(1365),
    [anon_sym_and] = ACTIONS(1147),
    [anon_sym_or] = ACTIONS(1147),
    [anon_sym_AMP_AMP] = ACTIONS(1133),
    [anon_sym_PIPE_PIPE] = ACTIONS(1133),
    [anon_sym_QMARK_QMARK] = ACTIONS(1133),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1147),
    [anon_sym_is] = ACTIONS(1147),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_DASH_GT] = ACTIONS(1133),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_with] = ACTIONS(1147),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_if_token3] = ACTIONS(1133),
    [aux_sym_preproc_else_token1] = ACTIONS(1133),
    [aux_sym_preproc_elif_token1] = ACTIONS(1133),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [232] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6911),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6992),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5038),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(3829),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7391),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9246),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(232),
    [sym_preproc_endregion] = STATE(232),
    [sym_preproc_line] = STATE(232),
    [sym_preproc_pragma] = STATE(232),
    [sym_preproc_nullable] = STATE(232),
    [sym_preproc_error] = STATE(232),
    [sym_preproc_define] = STATE(232),
    [sym_preproc_undef] = STATE(232),
    [aux_sym_class_declaration_repeat1] = STATE(3800),
    [aux_sym_lambda_expression_repeat1] = STATE(4089),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(1133),
    [anon_sym_COMMA] = ACTIONS(1133),
    [anon_sym_LPAREN] = ACTIONS(1323),
    [anon_sym_RPAREN] = ACTIONS(1133),
    [anon_sym_ref] = ACTIONS(1325),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_RBRACE] = ACTIONS(1133),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1145),
    [anon_sym_LT] = ACTIONS(1147),
    [anon_sym_GT] = ACTIONS(1147),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1147),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1327),
    [anon_sym_TILDE] = ACTIONS(1329),
    [anon_sym_PLUS_PLUS] = ACTIONS(1329),
    [anon_sym_DASH_DASH] = ACTIONS(1329),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1327),
    [anon_sym_DASH] = ACTIONS(1327),
    [anon_sym_STAR] = ACTIONS(1331),
    [anon_sym_SLASH] = ACTIONS(1147),
    [anon_sym_PERCENT] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(1329),
    [anon_sym_PIPE] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(1327),
    [anon_sym_LT_LT] = ACTIONS(1133),
    [anon_sym_GT_GT] = ACTIONS(1147),
    [anon_sym_GT_GT_GT] = ACTIONS(1133),
    [anon_sym_EQ_EQ] = ACTIONS(1133),
    [anon_sym_BANG_EQ] = ACTIONS(1133),
    [anon_sym_GT_EQ] = ACTIONS(1133),
    [anon_sym_LT_EQ] = ACTIONS(1133),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_DOT] = ACTIONS(1147),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1147),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1333),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1335),
    [anon_sym_DOT_DOT] = ACTIONS(1337),
    [anon_sym_and] = ACTIONS(1147),
    [anon_sym_or] = ACTIONS(1147),
    [anon_sym_AMP_AMP] = ACTIONS(1133),
    [anon_sym_PIPE_PIPE] = ACTIONS(1133),
    [anon_sym_QMARK_QMARK] = ACTIONS(1133),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1147),
    [anon_sym_is] = ACTIONS(1147),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_DASH_GT] = ACTIONS(1133),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_with] = ACTIONS(1147),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [233] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6880),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7104),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5122),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(3863),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7380),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9420),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(233),
    [sym_preproc_endregion] = STATE(233),
    [sym_preproc_line] = STATE(233),
    [sym_preproc_pragma] = STATE(233),
    [sym_preproc_nullable] = STATE(233),
    [sym_preproc_error] = STATE(233),
    [sym_preproc_define] = STATE(233),
    [sym_preproc_undef] = STATE(233),
    [aux_sym_class_declaration_repeat1] = STATE(3820),
    [aux_sym_lambda_expression_repeat1] = STATE(4165),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_COLON] = ACTIONS(1133),
    [anon_sym_COMMA] = ACTIONS(1133),
    [anon_sym_LPAREN] = ACTIONS(1339),
    [anon_sym_RPAREN] = ACTIONS(1133),
    [anon_sym_ref] = ACTIONS(1341),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_RBRACE] = ACTIONS(1133),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(1147),
    [anon_sym_GT] = ACTIONS(1147),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1147),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1099),
    [anon_sym_TILDE] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1099),
    [anon_sym_DASH] = ACTIONS(1099),
    [anon_sym_STAR] = ACTIONS(1343),
    [anon_sym_SLASH] = ACTIONS(1147),
    [anon_sym_PERCENT] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(1097),
    [anon_sym_PIPE] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(1099),
    [anon_sym_LT_LT] = ACTIONS(1133),
    [anon_sym_GT_GT] = ACTIONS(1147),
    [anon_sym_GT_GT_GT] = ACTIONS(1133),
    [anon_sym_EQ_EQ] = ACTIONS(1133),
    [anon_sym_BANG_EQ] = ACTIONS(1133),
    [anon_sym_GT_EQ] = ACTIONS(1133),
    [anon_sym_LT_EQ] = ACTIONS(1133),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_DOT] = ACTIONS(1147),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1147),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1345),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1347),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym_and] = ACTIONS(1147),
    [anon_sym_or] = ACTIONS(1147),
    [anon_sym_AMP_AMP] = ACTIONS(1133),
    [anon_sym_PIPE_PIPE] = ACTIONS(1133),
    [anon_sym_QMARK_QMARK] = ACTIONS(1133),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1147),
    [anon_sym_is] = ACTIONS(1147),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_DASH_GT] = ACTIONS(1133),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_with] = ACTIONS(1147),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [234] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3921),
    [sym__name] = STATE(6919),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2868),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(6950),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5244),
    [sym_non_lvalue_expression] = STATE(5735),
    [sym_lvalue_expression] = STATE(4054),
    [sym__expression_statement_expression] = STATE(5733),
    [sym_assignment_expression] = STATE(5734),
    [sym_binary_expression] = STATE(5733),
    [sym_postfix_unary_expression] = STATE(5734),
    [sym_prefix_unary_expression] = STATE(5734),
    [sym__pointer_indirection_expression] = STATE(3911),
    [sym_query_expression] = STATE(5733),
    [sym_from_clause] = STATE(7400),
    [sym_conditional_expression] = STATE(5733),
    [sym_conditional_access_expression] = STATE(5733),
    [sym_as_expression] = STATE(5733),
    [sym_is_expression] = STATE(5733),
    [sym_is_pattern_expression] = STATE(5733),
    [sym_cast_expression] = STATE(5733),
    [sym_checked_expression] = STATE(5733),
    [sym_invocation_expression] = STATE(5734),
    [sym_switch_expression] = STATE(5733),
    [sym_await_expression] = STATE(5734),
    [sym_throw_expression] = STATE(5733),
    [sym_element_access_expression] = STATE(3911),
    [sym_interpolated_string_expression] = STATE(5733),
    [sym_member_access_expression] = STATE(3911),
    [sym_object_creation_expression] = STATE(5734),
    [sym_parenthesized_expression] = STATE(5734),
    [sym__parenthesized_lvalue_expression] = STATE(3911),
    [sym_lambda_expression] = STATE(5733),
    [sym__lambda_parameters] = STATE(9693),
    [sym_array_creation_expression] = STATE(5733),
    [sym_anonymous_method_expression] = STATE(5733),
    [sym_anonymous_object_creation_expression] = STATE(5733),
    [sym_implicit_array_creation_expression] = STATE(5733),
    [sym_implicit_object_creation_expression] = STATE(5733),
    [sym_implicit_stackalloc_expression] = STATE(5733),
    [sym_initializer_expression] = STATE(5733),
    [sym_default_expression] = STATE(5733),
    [sym_with_expression] = STATE(5733),
    [sym_sizeof_expression] = STATE(5733),
    [sym_typeof_expression] = STATE(5733),
    [sym_makeref_expression] = STATE(5733),
    [sym_ref_expression] = STATE(5733),
    [sym_reftype_expression] = STATE(5733),
    [sym_refvalue_expression] = STATE(5733),
    [sym_stackalloc_expression] = STATE(5733),
    [sym_range_expression] = STATE(5733),
    [sym_tuple_expression] = STATE(3911),
    [sym_literal] = STATE(5733),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2798),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(5733),
    [sym_preproc_region] = STATE(234),
    [sym_preproc_endregion] = STATE(234),
    [sym_preproc_line] = STATE(234),
    [sym_preproc_pragma] = STATE(234),
    [sym_preproc_nullable] = STATE(234),
    [sym_preproc_error] = STATE(234),
    [sym_preproc_define] = STATE(234),
    [sym_preproc_undef] = STATE(234),
    [aux_sym_class_declaration_repeat1] = STATE(3791),
    [aux_sym_lambda_expression_repeat1] = STATE(4075),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_COLON] = ACTIONS(1133),
    [anon_sym_COMMA] = ACTIONS(1133),
    [anon_sym_LPAREN] = ACTIONS(1373),
    [anon_sym_ref] = ACTIONS(1375),
    [anon_sym_LBRACE] = ACTIONS(1377),
    [anon_sym_delegate] = ACTIONS(1379),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1381),
    [anon_sym_LT] = ACTIONS(1147),
    [anon_sym_GT] = ACTIONS(1147),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_QMARK] = ACTIONS(1147),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1385),
    [anon_sym_TILDE] = ACTIONS(1387),
    [anon_sym_PLUS_PLUS] = ACTIONS(1387),
    [anon_sym_DASH_DASH] = ACTIONS(1387),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1385),
    [anon_sym_DASH] = ACTIONS(1385),
    [anon_sym_STAR] = ACTIONS(1391),
    [anon_sym_SLASH] = ACTIONS(1147),
    [anon_sym_PERCENT] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(1387),
    [anon_sym_PIPE] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(1385),
    [anon_sym_LT_LT] = ACTIONS(1133),
    [anon_sym_GT_GT] = ACTIONS(1147),
    [anon_sym_GT_GT_GT] = ACTIONS(1133),
    [anon_sym_EQ_EQ] = ACTIONS(1133),
    [anon_sym_BANG_EQ] = ACTIONS(1133),
    [anon_sym_GT_EQ] = ACTIONS(1133),
    [anon_sym_LT_EQ] = ACTIONS(1133),
    [anon_sym_this] = ACTIONS(1393),
    [anon_sym_DOT] = ACTIONS(1147),
    [anon_sym_scoped] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1397),
    [sym_predefined_type] = ACTIONS(1399),
    [anon_sym_unchecked] = ACTIONS(1383),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_switch] = ACTIONS(1147),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1403),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1405),
    [anon_sym_DOT_DOT] = ACTIONS(1407),
    [anon_sym_and] = ACTIONS(1147),
    [anon_sym_or] = ACTIONS(1147),
    [anon_sym_AMP_AMP] = ACTIONS(1133),
    [anon_sym_PIPE_PIPE] = ACTIONS(1133),
    [anon_sym_QMARK_QMARK] = ACTIONS(1133),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_as] = ACTIONS(1147),
    [anon_sym_is] = ACTIONS(1147),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_DASH_GT] = ACTIONS(1133),
    [anon_sym_stackalloc] = ACTIONS(1413),
    [anon_sym_with] = ACTIONS(1147),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(1419),
    [anon_sym___reftype] = ACTIONS(1421),
    [anon_sym___refvalue] = ACTIONS(1423),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
    [sym_interpolation_close_brace] = ACTIONS(1133),
  },
  [235] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3921),
    [sym__name] = STATE(6919),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2868),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(6950),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5354),
    [sym_non_lvalue_expression] = STATE(5735),
    [sym_lvalue_expression] = STATE(4054),
    [sym__expression_statement_expression] = STATE(5733),
    [sym_assignment_expression] = STATE(5734),
    [sym_binary_expression] = STATE(5733),
    [sym_postfix_unary_expression] = STATE(5734),
    [sym_prefix_unary_expression] = STATE(5734),
    [sym__pointer_indirection_expression] = STATE(3911),
    [sym_query_expression] = STATE(5733),
    [sym_from_clause] = STATE(7400),
    [sym_conditional_expression] = STATE(5733),
    [sym_conditional_access_expression] = STATE(5733),
    [sym_as_expression] = STATE(5733),
    [sym_is_expression] = STATE(5733),
    [sym_is_pattern_expression] = STATE(5733),
    [sym_cast_expression] = STATE(5733),
    [sym_checked_expression] = STATE(5733),
    [sym_invocation_expression] = STATE(5734),
    [sym_switch_expression] = STATE(5733),
    [sym_await_expression] = STATE(5734),
    [sym_throw_expression] = STATE(5733),
    [sym_element_access_expression] = STATE(3911),
    [sym_interpolated_string_expression] = STATE(5733),
    [sym_member_access_expression] = STATE(3911),
    [sym_object_creation_expression] = STATE(5734),
    [sym_parenthesized_expression] = STATE(5734),
    [sym__parenthesized_lvalue_expression] = STATE(3911),
    [sym_lambda_expression] = STATE(5733),
    [sym__lambda_parameters] = STATE(9693),
    [sym_array_creation_expression] = STATE(5733),
    [sym_anonymous_method_expression] = STATE(5733),
    [sym_anonymous_object_creation_expression] = STATE(5733),
    [sym_implicit_array_creation_expression] = STATE(5733),
    [sym_implicit_object_creation_expression] = STATE(5733),
    [sym_implicit_stackalloc_expression] = STATE(5733),
    [sym_initializer_expression] = STATE(5733),
    [sym_default_expression] = STATE(5733),
    [sym_with_expression] = STATE(5733),
    [sym_sizeof_expression] = STATE(5733),
    [sym_typeof_expression] = STATE(5733),
    [sym_makeref_expression] = STATE(5733),
    [sym_ref_expression] = STATE(5733),
    [sym_reftype_expression] = STATE(5733),
    [sym_refvalue_expression] = STATE(5733),
    [sym_stackalloc_expression] = STATE(5733),
    [sym_range_expression] = STATE(5733),
    [sym_tuple_expression] = STATE(3911),
    [sym_literal] = STATE(5733),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2798),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(5733),
    [sym_preproc_region] = STATE(235),
    [sym_preproc_endregion] = STATE(235),
    [sym_preproc_line] = STATE(235),
    [sym_preproc_pragma] = STATE(235),
    [sym_preproc_nullable] = STATE(235),
    [sym_preproc_error] = STATE(235),
    [sym_preproc_define] = STATE(235),
    [sym_preproc_undef] = STATE(235),
    [aux_sym_class_declaration_repeat1] = STATE(3791),
    [aux_sym_lambda_expression_repeat1] = STATE(4075),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_COLON] = ACTIONS(1199),
    [anon_sym_COMMA] = ACTIONS(1199),
    [anon_sym_LPAREN] = ACTIONS(1373),
    [anon_sym_ref] = ACTIONS(1375),
    [anon_sym_LBRACE] = ACTIONS(1377),
    [anon_sym_delegate] = ACTIONS(1379),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1381),
    [anon_sym_LT] = ACTIONS(1201),
    [anon_sym_GT] = ACTIONS(1201),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_QMARK] = ACTIONS(1201),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1385),
    [anon_sym_TILDE] = ACTIONS(1387),
    [anon_sym_PLUS_PLUS] = ACTIONS(1387),
    [anon_sym_DASH_DASH] = ACTIONS(1387),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1385),
    [anon_sym_DASH] = ACTIONS(1385),
    [anon_sym_STAR] = ACTIONS(1391),
    [anon_sym_SLASH] = ACTIONS(1201),
    [anon_sym_PERCENT] = ACTIONS(1199),
    [anon_sym_CARET] = ACTIONS(1387),
    [anon_sym_PIPE] = ACTIONS(1201),
    [anon_sym_AMP] = ACTIONS(1385),
    [anon_sym_LT_LT] = ACTIONS(1199),
    [anon_sym_GT_GT] = ACTIONS(1201),
    [anon_sym_GT_GT_GT] = ACTIONS(1199),
    [anon_sym_EQ_EQ] = ACTIONS(1199),
    [anon_sym_BANG_EQ] = ACTIONS(1199),
    [anon_sym_GT_EQ] = ACTIONS(1199),
    [anon_sym_LT_EQ] = ACTIONS(1199),
    [anon_sym_this] = ACTIONS(1393),
    [anon_sym_DOT] = ACTIONS(1201),
    [anon_sym_scoped] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1397),
    [sym_predefined_type] = ACTIONS(1399),
    [anon_sym_unchecked] = ACTIONS(1383),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_switch] = ACTIONS(1201),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1403),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1405),
    [anon_sym_DOT_DOT] = ACTIONS(1407),
    [anon_sym_and] = ACTIONS(1201),
    [anon_sym_or] = ACTIONS(1201),
    [anon_sym_AMP_AMP] = ACTIONS(1199),
    [anon_sym_PIPE_PIPE] = ACTIONS(1199),
    [anon_sym_QMARK_QMARK] = ACTIONS(1199),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_as] = ACTIONS(1201),
    [anon_sym_is] = ACTIONS(1201),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_DASH_GT] = ACTIONS(1199),
    [anon_sym_stackalloc] = ACTIONS(1413),
    [anon_sym_with] = ACTIONS(1201),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(1419),
    [anon_sym___reftype] = ACTIONS(1421),
    [anon_sym___refvalue] = ACTIONS(1423),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
    [sym_interpolation_close_brace] = ACTIONS(1199),
  },
  [236] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3921),
    [sym__name] = STATE(6889),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2854),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(7061),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5209),
    [sym_non_lvalue_expression] = STATE(5735),
    [sym_lvalue_expression] = STATE(3899),
    [sym__expression_statement_expression] = STATE(5733),
    [sym_assignment_expression] = STATE(5734),
    [sym_binary_expression] = STATE(5733),
    [sym_postfix_unary_expression] = STATE(5734),
    [sym_prefix_unary_expression] = STATE(5734),
    [sym__pointer_indirection_expression] = STATE(3911),
    [sym_query_expression] = STATE(5733),
    [sym_from_clause] = STATE(7400),
    [sym_conditional_expression] = STATE(5733),
    [sym_conditional_access_expression] = STATE(5733),
    [sym_as_expression] = STATE(5733),
    [sym_is_expression] = STATE(5733),
    [sym_is_pattern_expression] = STATE(5733),
    [sym_cast_expression] = STATE(5733),
    [sym_checked_expression] = STATE(5733),
    [sym_invocation_expression] = STATE(5734),
    [sym_switch_expression] = STATE(5733),
    [sym_await_expression] = STATE(5734),
    [sym_throw_expression] = STATE(5733),
    [sym_element_access_expression] = STATE(3911),
    [sym_interpolated_string_expression] = STATE(5733),
    [sym_member_access_expression] = STATE(3911),
    [sym_object_creation_expression] = STATE(5734),
    [sym_parenthesized_expression] = STATE(5734),
    [sym__parenthesized_lvalue_expression] = STATE(3911),
    [sym_lambda_expression] = STATE(5733),
    [sym__lambda_parameters] = STATE(9790),
    [sym_array_creation_expression] = STATE(5733),
    [sym_anonymous_method_expression] = STATE(5733),
    [sym_anonymous_object_creation_expression] = STATE(5733),
    [sym_implicit_array_creation_expression] = STATE(5733),
    [sym_implicit_object_creation_expression] = STATE(5733),
    [sym_implicit_stackalloc_expression] = STATE(5733),
    [sym_initializer_expression] = STATE(5733),
    [sym_default_expression] = STATE(5733),
    [sym_with_expression] = STATE(5733),
    [sym_sizeof_expression] = STATE(5733),
    [sym_typeof_expression] = STATE(5733),
    [sym_makeref_expression] = STATE(5733),
    [sym_ref_expression] = STATE(5733),
    [sym_reftype_expression] = STATE(5733),
    [sym_refvalue_expression] = STATE(5733),
    [sym_stackalloc_expression] = STATE(5733),
    [sym_range_expression] = STATE(5733),
    [sym_tuple_expression] = STATE(3911),
    [sym_literal] = STATE(5733),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2798),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(5733),
    [sym_preproc_region] = STATE(236),
    [sym_preproc_endregion] = STATE(236),
    [sym_preproc_line] = STATE(236),
    [sym_preproc_pragma] = STATE(236),
    [sym_preproc_nullable] = STATE(236),
    [sym_preproc_error] = STATE(236),
    [sym_preproc_define] = STATE(236),
    [sym_preproc_undef] = STATE(236),
    [aux_sym_class_declaration_repeat1] = STATE(3833),
    [aux_sym_lambda_expression_repeat1] = STATE(4182),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_COLON] = ACTIONS(1199),
    [anon_sym_COMMA] = ACTIONS(1199),
    [anon_sym_LPAREN] = ACTIONS(1439),
    [anon_sym_ref] = ACTIONS(1441),
    [anon_sym_LBRACE] = ACTIONS(1377),
    [anon_sym_delegate] = ACTIONS(1379),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1443),
    [anon_sym_LT] = ACTIONS(1201),
    [anon_sym_GT] = ACTIONS(1201),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_QMARK] = ACTIONS(1201),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1445),
    [anon_sym_TILDE] = ACTIONS(1447),
    [anon_sym_PLUS_PLUS] = ACTIONS(1447),
    [anon_sym_DASH_DASH] = ACTIONS(1447),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1445),
    [anon_sym_DASH] = ACTIONS(1445),
    [anon_sym_STAR] = ACTIONS(1449),
    [anon_sym_SLASH] = ACTIONS(1201),
    [anon_sym_PERCENT] = ACTIONS(1199),
    [anon_sym_CARET] = ACTIONS(1447),
    [anon_sym_PIPE] = ACTIONS(1201),
    [anon_sym_AMP] = ACTIONS(1445),
    [anon_sym_LT_LT] = ACTIONS(1199),
    [anon_sym_GT_GT] = ACTIONS(1201),
    [anon_sym_GT_GT_GT] = ACTIONS(1199),
    [anon_sym_EQ_EQ] = ACTIONS(1199),
    [anon_sym_BANG_EQ] = ACTIONS(1199),
    [anon_sym_GT_EQ] = ACTIONS(1199),
    [anon_sym_LT_EQ] = ACTIONS(1199),
    [anon_sym_this] = ACTIONS(1393),
    [anon_sym_DOT] = ACTIONS(1201),
    [anon_sym_scoped] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1397),
    [sym_predefined_type] = ACTIONS(1399),
    [anon_sym_unchecked] = ACTIONS(1383),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_switch] = ACTIONS(1201),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1451),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1453),
    [anon_sym_DOT_DOT] = ACTIONS(1455),
    [anon_sym_and] = ACTIONS(1201),
    [anon_sym_or] = ACTIONS(1201),
    [anon_sym_AMP_AMP] = ACTIONS(1199),
    [anon_sym_PIPE_PIPE] = ACTIONS(1199),
    [anon_sym_QMARK_QMARK] = ACTIONS(1199),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_as] = ACTIONS(1201),
    [anon_sym_is] = ACTIONS(1201),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_DASH_GT] = ACTIONS(1199),
    [anon_sym_stackalloc] = ACTIONS(1413),
    [anon_sym_with] = ACTIONS(1201),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(1419),
    [anon_sym___reftype] = ACTIONS(1421),
    [anon_sym___refvalue] = ACTIONS(1423),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
    [sym_interpolation_close_brace] = ACTIONS(1199),
  },
  [237] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3921),
    [sym__name] = STATE(6889),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2854),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(7061),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5175),
    [sym_non_lvalue_expression] = STATE(5735),
    [sym_lvalue_expression] = STATE(3899),
    [sym__expression_statement_expression] = STATE(5733),
    [sym_assignment_expression] = STATE(5734),
    [sym_binary_expression] = STATE(5733),
    [sym_postfix_unary_expression] = STATE(5734),
    [sym_prefix_unary_expression] = STATE(5734),
    [sym__pointer_indirection_expression] = STATE(3911),
    [sym_query_expression] = STATE(5733),
    [sym_from_clause] = STATE(7400),
    [sym_conditional_expression] = STATE(5733),
    [sym_conditional_access_expression] = STATE(5733),
    [sym_as_expression] = STATE(5733),
    [sym_is_expression] = STATE(5733),
    [sym_is_pattern_expression] = STATE(5733),
    [sym_cast_expression] = STATE(5733),
    [sym_checked_expression] = STATE(5733),
    [sym_invocation_expression] = STATE(5734),
    [sym_switch_expression] = STATE(5733),
    [sym_await_expression] = STATE(5734),
    [sym_throw_expression] = STATE(5733),
    [sym_element_access_expression] = STATE(3911),
    [sym_interpolated_string_expression] = STATE(5733),
    [sym_member_access_expression] = STATE(3911),
    [sym_object_creation_expression] = STATE(5734),
    [sym_parenthesized_expression] = STATE(5734),
    [sym__parenthesized_lvalue_expression] = STATE(3911),
    [sym_lambda_expression] = STATE(5733),
    [sym__lambda_parameters] = STATE(9790),
    [sym_array_creation_expression] = STATE(5733),
    [sym_anonymous_method_expression] = STATE(5733),
    [sym_anonymous_object_creation_expression] = STATE(5733),
    [sym_implicit_array_creation_expression] = STATE(5733),
    [sym_implicit_object_creation_expression] = STATE(5733),
    [sym_implicit_stackalloc_expression] = STATE(5733),
    [sym_initializer_expression] = STATE(5733),
    [sym_default_expression] = STATE(5733),
    [sym_with_expression] = STATE(5733),
    [sym_sizeof_expression] = STATE(5733),
    [sym_typeof_expression] = STATE(5733),
    [sym_makeref_expression] = STATE(5733),
    [sym_ref_expression] = STATE(5733),
    [sym_reftype_expression] = STATE(5733),
    [sym_refvalue_expression] = STATE(5733),
    [sym_stackalloc_expression] = STATE(5733),
    [sym_range_expression] = STATE(5733),
    [sym_tuple_expression] = STATE(3911),
    [sym_literal] = STATE(5733),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2798),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(5733),
    [sym_preproc_region] = STATE(237),
    [sym_preproc_endregion] = STATE(237),
    [sym_preproc_line] = STATE(237),
    [sym_preproc_pragma] = STATE(237),
    [sym_preproc_nullable] = STATE(237),
    [sym_preproc_error] = STATE(237),
    [sym_preproc_define] = STATE(237),
    [sym_preproc_undef] = STATE(237),
    [aux_sym_class_declaration_repeat1] = STATE(3833),
    [aux_sym_lambda_expression_repeat1] = STATE(4182),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_COLON] = ACTIONS(1133),
    [anon_sym_COMMA] = ACTIONS(1133),
    [anon_sym_LPAREN] = ACTIONS(1439),
    [anon_sym_ref] = ACTIONS(1441),
    [anon_sym_LBRACE] = ACTIONS(1377),
    [anon_sym_delegate] = ACTIONS(1379),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1443),
    [anon_sym_LT] = ACTIONS(1147),
    [anon_sym_GT] = ACTIONS(1147),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_QMARK] = ACTIONS(1147),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1445),
    [anon_sym_TILDE] = ACTIONS(1447),
    [anon_sym_PLUS_PLUS] = ACTIONS(1447),
    [anon_sym_DASH_DASH] = ACTIONS(1447),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1445),
    [anon_sym_DASH] = ACTIONS(1445),
    [anon_sym_STAR] = ACTIONS(1449),
    [anon_sym_SLASH] = ACTIONS(1147),
    [anon_sym_PERCENT] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(1447),
    [anon_sym_PIPE] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(1445),
    [anon_sym_LT_LT] = ACTIONS(1133),
    [anon_sym_GT_GT] = ACTIONS(1147),
    [anon_sym_GT_GT_GT] = ACTIONS(1133),
    [anon_sym_EQ_EQ] = ACTIONS(1133),
    [anon_sym_BANG_EQ] = ACTIONS(1133),
    [anon_sym_GT_EQ] = ACTIONS(1133),
    [anon_sym_LT_EQ] = ACTIONS(1133),
    [anon_sym_this] = ACTIONS(1393),
    [anon_sym_DOT] = ACTIONS(1147),
    [anon_sym_scoped] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1397),
    [sym_predefined_type] = ACTIONS(1399),
    [anon_sym_unchecked] = ACTIONS(1383),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_switch] = ACTIONS(1147),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1451),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1453),
    [anon_sym_DOT_DOT] = ACTIONS(1455),
    [anon_sym_and] = ACTIONS(1147),
    [anon_sym_or] = ACTIONS(1147),
    [anon_sym_AMP_AMP] = ACTIONS(1133),
    [anon_sym_PIPE_PIPE] = ACTIONS(1133),
    [anon_sym_QMARK_QMARK] = ACTIONS(1133),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_as] = ACTIONS(1147),
    [anon_sym_is] = ACTIONS(1147),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_DASH_GT] = ACTIONS(1133),
    [anon_sym_stackalloc] = ACTIONS(1413),
    [anon_sym_with] = ACTIONS(1147),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(1419),
    [anon_sym___reftype] = ACTIONS(1421),
    [anon_sym___refvalue] = ACTIONS(1423),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
    [sym_interpolation_close_brace] = ACTIONS(1133),
  },
  [238] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6961),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5447),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9849),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(238),
    [sym_preproc_endregion] = STATE(238),
    [sym_preproc_line] = STATE(238),
    [sym_preproc_pragma] = STATE(238),
    [sym_preproc_nullable] = STATE(238),
    [sym_preproc_error] = STATE(238),
    [sym_preproc_define] = STATE(238),
    [sym_preproc_undef] = STATE(238),
    [aux_sym_class_declaration_repeat1] = STATE(3841),
    [aux_sym_lambda_expression_repeat1] = STATE(4283),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(1133),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1459),
    [anon_sym_ref] = ACTIONS(1461),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1465),
    [anon_sym_LT] = ACTIONS(1147),
    [anon_sym_GT] = ACTIONS(1147),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1147),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_SLASH] = ACTIONS(1147),
    [anon_sym_PERCENT] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_PIPE] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(77),
    [anon_sym_LT_LT] = ACTIONS(1133),
    [anon_sym_GT_GT] = ACTIONS(1147),
    [anon_sym_GT_GT_GT] = ACTIONS(1133),
    [anon_sym_EQ_EQ] = ACTIONS(1133),
    [anon_sym_BANG_EQ] = ACTIONS(1133),
    [anon_sym_GT_EQ] = ACTIONS(1133),
    [anon_sym_LT_EQ] = ACTIONS(1133),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(1147),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1147),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1467),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1469),
    [anon_sym_DOT_DOT] = ACTIONS(1471),
    [anon_sym_AMP_AMP] = ACTIONS(1133),
    [anon_sym_PIPE_PIPE] = ACTIONS(1133),
    [anon_sym_QMARK_QMARK] = ACTIONS(1133),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1147),
    [anon_sym_is] = ACTIONS(1147),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_DASH_GT] = ACTIONS(1133),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_with] = ACTIONS(1147),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_if_token3] = ACTIONS(1133),
    [aux_sym_preproc_else_token1] = ACTIONS(1133),
    [aux_sym_preproc_elif_token1] = ACTIONS(1133),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [239] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6880),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7072),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5702),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4210),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9027),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(239),
    [sym_preproc_endregion] = STATE(239),
    [sym_preproc_line] = STATE(239),
    [sym_preproc_pragma] = STATE(239),
    [sym_preproc_nullable] = STATE(239),
    [sym_preproc_error] = STATE(239),
    [sym_preproc_define] = STATE(239),
    [sym_preproc_undef] = STATE(239),
    [aux_sym_class_declaration_repeat1] = STATE(3852),
    [aux_sym_lambda_expression_repeat1] = STATE(4220),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_COLON] = ACTIONS(1199),
    [anon_sym_COMMA] = ACTIONS(1199),
    [anon_sym_LPAREN] = ACTIONS(1473),
    [anon_sym_RPAREN] = ACTIONS(1199),
    [anon_sym_ref] = ACTIONS(1475),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_RBRACE] = ACTIONS(1199),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1201),
    [anon_sym_GT] = ACTIONS(1201),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1201),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1477),
    [anon_sym_TILDE] = ACTIONS(1479),
    [anon_sym_PLUS_PLUS] = ACTIONS(1479),
    [anon_sym_DASH_DASH] = ACTIONS(1479),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1477),
    [anon_sym_DASH] = ACTIONS(1477),
    [anon_sym_STAR] = ACTIONS(1101),
    [anon_sym_SLASH] = ACTIONS(1201),
    [anon_sym_PERCENT] = ACTIONS(1199),
    [anon_sym_CARET] = ACTIONS(1479),
    [anon_sym_PIPE] = ACTIONS(1201),
    [anon_sym_AMP] = ACTIONS(1477),
    [anon_sym_LT_LT] = ACTIONS(1199),
    [anon_sym_GT_GT] = ACTIONS(1201),
    [anon_sym_GT_GT_GT] = ACTIONS(1199),
    [anon_sym_EQ_EQ] = ACTIONS(1199),
    [anon_sym_BANG_EQ] = ACTIONS(1199),
    [anon_sym_GT_EQ] = ACTIONS(1199),
    [anon_sym_LT_EQ] = ACTIONS(1199),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(1201),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1201),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1111),
    [anon_sym_DOT_DOT] = ACTIONS(1115),
    [anon_sym_AMP_AMP] = ACTIONS(1199),
    [anon_sym_PIPE_PIPE] = ACTIONS(1199),
    [anon_sym_QMARK_QMARK] = ACTIONS(1199),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1201),
    [anon_sym_is] = ACTIONS(1201),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_DASH_GT] = ACTIONS(1199),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_with] = ACTIONS(1201),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [240] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5739),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(240),
    [sym_preproc_endregion] = STATE(240),
    [sym_preproc_line] = STATE(240),
    [sym_preproc_pragma] = STATE(240),
    [sym_preproc_nullable] = STATE(240),
    [sym_preproc_error] = STATE(240),
    [sym_preproc_define] = STATE(240),
    [sym_preproc_undef] = STATE(240),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_COMMA] = ACTIONS(1133),
    [anon_sym_RBRACK] = ACTIONS(1133),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_RPAREN] = ACTIONS(1133),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_RBRACE] = ACTIONS(1133),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(1147),
    [anon_sym_GT] = ACTIONS(1147),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1147),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1481),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_SLASH] = ACTIONS(1147),
    [anon_sym_PERCENT] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_PIPE] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(1481),
    [anon_sym_LT_LT] = ACTIONS(1133),
    [anon_sym_GT_GT] = ACTIONS(1147),
    [anon_sym_GT_GT_GT] = ACTIONS(1133),
    [anon_sym_EQ_EQ] = ACTIONS(1133),
    [anon_sym_BANG_EQ] = ACTIONS(1133),
    [anon_sym_GT_EQ] = ACTIONS(1133),
    [anon_sym_LT_EQ] = ACTIONS(1133),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(1147),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1147),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_AMP_AMP] = ACTIONS(1133),
    [anon_sym_PIPE_PIPE] = ACTIONS(1133),
    [anon_sym_QMARK_QMARK] = ACTIONS(1133),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1147),
    [anon_sym_is] = ACTIONS(1147),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_DASH_GT] = ACTIONS(1133),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_with] = ACTIONS(1147),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [241] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5384),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(241),
    [sym_preproc_endregion] = STATE(241),
    [sym_preproc_line] = STATE(241),
    [sym_preproc_pragma] = STATE(241),
    [sym_preproc_nullable] = STATE(241),
    [sym_preproc_error] = STATE(241),
    [sym_preproc_define] = STATE(241),
    [sym_preproc_undef] = STATE(241),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_COMMA] = ACTIONS(1199),
    [anon_sym_RBRACK] = ACTIONS(1199),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_RPAREN] = ACTIONS(1199),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_RBRACE] = ACTIONS(1199),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(1201),
    [anon_sym_GT] = ACTIONS(1201),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1201),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1481),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_SLASH] = ACTIONS(1201),
    [anon_sym_PERCENT] = ACTIONS(1199),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_PIPE] = ACTIONS(1201),
    [anon_sym_AMP] = ACTIONS(1481),
    [anon_sym_LT_LT] = ACTIONS(1199),
    [anon_sym_GT_GT] = ACTIONS(1201),
    [anon_sym_GT_GT_GT] = ACTIONS(1199),
    [anon_sym_EQ_EQ] = ACTIONS(1199),
    [anon_sym_BANG_EQ] = ACTIONS(1199),
    [anon_sym_GT_EQ] = ACTIONS(1199),
    [anon_sym_LT_EQ] = ACTIONS(1199),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(1201),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1201),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_AMP_AMP] = ACTIONS(1199),
    [anon_sym_PIPE_PIPE] = ACTIONS(1199),
    [anon_sym_QMARK_QMARK] = ACTIONS(1199),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1201),
    [anon_sym_is] = ACTIONS(1201),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_DASH_GT] = ACTIONS(1199),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_with] = ACTIONS(1201),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [242] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6904),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7009),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5265),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4008),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7381),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9536),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(242),
    [sym_preproc_endregion] = STATE(242),
    [sym_preproc_line] = STATE(242),
    [sym_preproc_pragma] = STATE(242),
    [sym_preproc_nullable] = STATE(242),
    [sym_preproc_error] = STATE(242),
    [sym_preproc_define] = STATE(242),
    [sym_preproc_undef] = STATE(242),
    [aux_sym_class_declaration_repeat1] = STATE(3832),
    [aux_sym_lambda_expression_repeat1] = STATE(4090),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_COLON] = ACTIONS(1199),
    [anon_sym_COMMA] = ACTIONS(1199),
    [anon_sym_LPAREN] = ACTIONS(1485),
    [anon_sym_RPAREN] = ACTIONS(1199),
    [anon_sym_ref] = ACTIONS(1487),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_RBRACE] = ACTIONS(1199),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1221),
    [anon_sym_LT] = ACTIONS(1201),
    [anon_sym_GT] = ACTIONS(1201),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1201),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1489),
    [anon_sym_TILDE] = ACTIONS(1491),
    [anon_sym_PLUS_PLUS] = ACTIONS(1491),
    [anon_sym_DASH_DASH] = ACTIONS(1491),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1489),
    [anon_sym_DASH] = ACTIONS(1489),
    [anon_sym_STAR] = ACTIONS(1493),
    [anon_sym_SLASH] = ACTIONS(1201),
    [anon_sym_PERCENT] = ACTIONS(1199),
    [anon_sym_CARET] = ACTIONS(1491),
    [anon_sym_PIPE] = ACTIONS(1201),
    [anon_sym_AMP] = ACTIONS(1489),
    [anon_sym_LT_LT] = ACTIONS(1199),
    [anon_sym_GT_GT] = ACTIONS(1201),
    [anon_sym_GT_GT_GT] = ACTIONS(1199),
    [anon_sym_EQ_EQ] = ACTIONS(1199),
    [anon_sym_BANG_EQ] = ACTIONS(1199),
    [anon_sym_GT_EQ] = ACTIONS(1199),
    [anon_sym_LT_EQ] = ACTIONS(1199),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_DOT] = ACTIONS(1201),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1201),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1495),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1497),
    [anon_sym_DOT_DOT] = ACTIONS(1499),
    [anon_sym_AMP_AMP] = ACTIONS(1199),
    [anon_sym_PIPE_PIPE] = ACTIONS(1199),
    [anon_sym_QMARK_QMARK] = ACTIONS(1199),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1201),
    [anon_sym_is] = ACTIONS(1201),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_DASH_GT] = ACTIONS(1199),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_with] = ACTIONS(1201),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [243] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6904),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7009),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5228),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4008),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7381),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9536),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(243),
    [sym_preproc_endregion] = STATE(243),
    [sym_preproc_line] = STATE(243),
    [sym_preproc_pragma] = STATE(243),
    [sym_preproc_nullable] = STATE(243),
    [sym_preproc_error] = STATE(243),
    [sym_preproc_define] = STATE(243),
    [sym_preproc_undef] = STATE(243),
    [aux_sym_class_declaration_repeat1] = STATE(3832),
    [aux_sym_lambda_expression_repeat1] = STATE(4090),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_COLON] = ACTIONS(1133),
    [anon_sym_COMMA] = ACTIONS(1133),
    [anon_sym_LPAREN] = ACTIONS(1485),
    [anon_sym_RPAREN] = ACTIONS(1133),
    [anon_sym_ref] = ACTIONS(1487),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_RBRACE] = ACTIONS(1133),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1221),
    [anon_sym_LT] = ACTIONS(1147),
    [anon_sym_GT] = ACTIONS(1147),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1147),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1489),
    [anon_sym_TILDE] = ACTIONS(1491),
    [anon_sym_PLUS_PLUS] = ACTIONS(1491),
    [anon_sym_DASH_DASH] = ACTIONS(1491),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1489),
    [anon_sym_DASH] = ACTIONS(1489),
    [anon_sym_STAR] = ACTIONS(1493),
    [anon_sym_SLASH] = ACTIONS(1147),
    [anon_sym_PERCENT] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(1491),
    [anon_sym_PIPE] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(1489),
    [anon_sym_LT_LT] = ACTIONS(1133),
    [anon_sym_GT_GT] = ACTIONS(1147),
    [anon_sym_GT_GT_GT] = ACTIONS(1133),
    [anon_sym_EQ_EQ] = ACTIONS(1133),
    [anon_sym_BANG_EQ] = ACTIONS(1133),
    [anon_sym_GT_EQ] = ACTIONS(1133),
    [anon_sym_LT_EQ] = ACTIONS(1133),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_DOT] = ACTIONS(1147),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1147),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1495),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1497),
    [anon_sym_DOT_DOT] = ACTIONS(1499),
    [anon_sym_AMP_AMP] = ACTIONS(1133),
    [anon_sym_PIPE_PIPE] = ACTIONS(1133),
    [anon_sym_QMARK_QMARK] = ACTIONS(1133),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1147),
    [anon_sym_is] = ACTIONS(1147),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_DASH_GT] = ACTIONS(1133),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_with] = ACTIONS(1147),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [244] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6880),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7072),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5706),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4210),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9027),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(244),
    [sym_preproc_endregion] = STATE(244),
    [sym_preproc_line] = STATE(244),
    [sym_preproc_pragma] = STATE(244),
    [sym_preproc_nullable] = STATE(244),
    [sym_preproc_error] = STATE(244),
    [sym_preproc_define] = STATE(244),
    [sym_preproc_undef] = STATE(244),
    [aux_sym_class_declaration_repeat1] = STATE(3852),
    [aux_sym_lambda_expression_repeat1] = STATE(4220),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_COLON] = ACTIONS(1133),
    [anon_sym_COMMA] = ACTIONS(1133),
    [anon_sym_LPAREN] = ACTIONS(1473),
    [anon_sym_RPAREN] = ACTIONS(1133),
    [anon_sym_ref] = ACTIONS(1475),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_RBRACE] = ACTIONS(1133),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1147),
    [anon_sym_GT] = ACTIONS(1147),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1147),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1477),
    [anon_sym_TILDE] = ACTIONS(1479),
    [anon_sym_PLUS_PLUS] = ACTIONS(1479),
    [anon_sym_DASH_DASH] = ACTIONS(1479),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1477),
    [anon_sym_DASH] = ACTIONS(1477),
    [anon_sym_STAR] = ACTIONS(1101),
    [anon_sym_SLASH] = ACTIONS(1147),
    [anon_sym_PERCENT] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(1479),
    [anon_sym_PIPE] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(1477),
    [anon_sym_LT_LT] = ACTIONS(1133),
    [anon_sym_GT_GT] = ACTIONS(1147),
    [anon_sym_GT_GT_GT] = ACTIONS(1133),
    [anon_sym_EQ_EQ] = ACTIONS(1133),
    [anon_sym_BANG_EQ] = ACTIONS(1133),
    [anon_sym_GT_EQ] = ACTIONS(1133),
    [anon_sym_LT_EQ] = ACTIONS(1133),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(1147),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1147),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1111),
    [anon_sym_DOT_DOT] = ACTIONS(1115),
    [anon_sym_AMP_AMP] = ACTIONS(1133),
    [anon_sym_PIPE_PIPE] = ACTIONS(1133),
    [anon_sym_QMARK_QMARK] = ACTIONS(1133),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1147),
    [anon_sym_is] = ACTIONS(1147),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_DASH_GT] = ACTIONS(1133),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_with] = ACTIONS(1147),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [245] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6961),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5531),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9849),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(245),
    [sym_preproc_endregion] = STATE(245),
    [sym_preproc_line] = STATE(245),
    [sym_preproc_pragma] = STATE(245),
    [sym_preproc_nullable] = STATE(245),
    [sym_preproc_error] = STATE(245),
    [sym_preproc_define] = STATE(245),
    [sym_preproc_undef] = STATE(245),
    [aux_sym_class_declaration_repeat1] = STATE(3841),
    [aux_sym_lambda_expression_repeat1] = STATE(4283),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(1199),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1459),
    [anon_sym_ref] = ACTIONS(1461),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1465),
    [anon_sym_LT] = ACTIONS(1201),
    [anon_sym_GT] = ACTIONS(1201),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1201),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_SLASH] = ACTIONS(1201),
    [anon_sym_PERCENT] = ACTIONS(1199),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_PIPE] = ACTIONS(1201),
    [anon_sym_AMP] = ACTIONS(77),
    [anon_sym_LT_LT] = ACTIONS(1199),
    [anon_sym_GT_GT] = ACTIONS(1201),
    [anon_sym_GT_GT_GT] = ACTIONS(1199),
    [anon_sym_EQ_EQ] = ACTIONS(1199),
    [anon_sym_BANG_EQ] = ACTIONS(1199),
    [anon_sym_GT_EQ] = ACTIONS(1199),
    [anon_sym_LT_EQ] = ACTIONS(1199),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(1201),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1201),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1467),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1469),
    [anon_sym_DOT_DOT] = ACTIONS(1471),
    [anon_sym_AMP_AMP] = ACTIONS(1199),
    [anon_sym_PIPE_PIPE] = ACTIONS(1199),
    [anon_sym_QMARK_QMARK] = ACTIONS(1199),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1201),
    [anon_sym_is] = ACTIONS(1201),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_DASH_GT] = ACTIONS(1199),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_with] = ACTIONS(1201),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_if_token3] = ACTIONS(1199),
    [aux_sym_preproc_else_token1] = ACTIONS(1199),
    [aux_sym_preproc_elif_token1] = ACTIONS(1199),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [246] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6909),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2874),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7062),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5678),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4291),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7411),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9300),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(246),
    [sym_preproc_endregion] = STATE(246),
    [sym_preproc_line] = STATE(246),
    [sym_preproc_pragma] = STATE(246),
    [sym_preproc_nullable] = STATE(246),
    [sym_preproc_error] = STATE(246),
    [sym_preproc_define] = STATE(246),
    [sym_preproc_undef] = STATE(246),
    [aux_sym_class_declaration_repeat1] = STATE(3804),
    [aux_sym_lambda_expression_repeat1] = STATE(4114),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_COLON] = ACTIONS(1199),
    [anon_sym_LPAREN] = ACTIONS(1501),
    [anon_sym_ref] = ACTIONS(1503),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1505),
    [anon_sym_LT] = ACTIONS(1201),
    [anon_sym_GT] = ACTIONS(1201),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1201),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1507),
    [anon_sym_TILDE] = ACTIONS(1509),
    [anon_sym_PLUS_PLUS] = ACTIONS(1509),
    [anon_sym_DASH_DASH] = ACTIONS(1509),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1507),
    [anon_sym_DASH] = ACTIONS(1507),
    [anon_sym_STAR] = ACTIONS(1511),
    [anon_sym_SLASH] = ACTIONS(1201),
    [anon_sym_PERCENT] = ACTIONS(1199),
    [anon_sym_CARET] = ACTIONS(1509),
    [anon_sym_PIPE] = ACTIONS(1201),
    [anon_sym_AMP] = ACTIONS(1507),
    [anon_sym_LT_LT] = ACTIONS(1199),
    [anon_sym_GT_GT] = ACTIONS(1201),
    [anon_sym_GT_GT_GT] = ACTIONS(1199),
    [anon_sym_EQ_EQ] = ACTIONS(1199),
    [anon_sym_BANG_EQ] = ACTIONS(1199),
    [anon_sym_GT_EQ] = ACTIONS(1199),
    [anon_sym_LT_EQ] = ACTIONS(1199),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_DOT] = ACTIONS(1201),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1201),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1513),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1515),
    [anon_sym_DOT_DOT] = ACTIONS(1517),
    [anon_sym_and] = ACTIONS(1201),
    [anon_sym_or] = ACTIONS(1201),
    [anon_sym_AMP_AMP] = ACTIONS(1199),
    [anon_sym_PIPE_PIPE] = ACTIONS(1199),
    [anon_sym_QMARK_QMARK] = ACTIONS(1199),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1201),
    [anon_sym_is] = ACTIONS(1201),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_DASH_GT] = ACTIONS(1199),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_with] = ACTIONS(1201),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [247] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7108),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6020),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4313),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7382),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9733),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(247),
    [sym_preproc_endregion] = STATE(247),
    [sym_preproc_line] = STATE(247),
    [sym_preproc_pragma] = STATE(247),
    [sym_preproc_nullable] = STATE(247),
    [sym_preproc_error] = STATE(247),
    [sym_preproc_define] = STATE(247),
    [sym_preproc_undef] = STATE(247),
    [aux_sym_class_declaration_repeat1] = STATE(3802),
    [aux_sym_lambda_expression_repeat1] = STATE(4108),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1519),
    [anon_sym_ref] = ACTIONS(1521),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1523),
    [anon_sym_LT] = ACTIONS(1147),
    [anon_sym_GT] = ACTIONS(1147),
    [anon_sym_in] = ACTIONS(1147),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1147),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1525),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_SLASH] = ACTIONS(1147),
    [anon_sym_PERCENT] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_PIPE] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(1525),
    [anon_sym_LT_LT] = ACTIONS(1133),
    [anon_sym_GT_GT] = ACTIONS(1147),
    [anon_sym_GT_GT_GT] = ACTIONS(1133),
    [anon_sym_EQ_EQ] = ACTIONS(1133),
    [anon_sym_BANG_EQ] = ACTIONS(1133),
    [anon_sym_GT_EQ] = ACTIONS(1133),
    [anon_sym_LT_EQ] = ACTIONS(1133),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_DOT] = ACTIONS(1147),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1147),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1529),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1531),
    [anon_sym_DOT_DOT] = ACTIONS(1533),
    [anon_sym_and] = ACTIONS(1147),
    [anon_sym_or] = ACTIONS(1147),
    [anon_sym_AMP_AMP] = ACTIONS(1133),
    [anon_sym_PIPE_PIPE] = ACTIONS(1133),
    [anon_sym_QMARK_QMARK] = ACTIONS(1133),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1147),
    [anon_sym_is] = ACTIONS(1147),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_DASH_GT] = ACTIONS(1133),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_with] = ACTIONS(1147),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [248] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5384),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(248),
    [sym_preproc_endregion] = STATE(248),
    [sym_preproc_line] = STATE(248),
    [sym_preproc_pragma] = STATE(248),
    [sym_preproc_nullable] = STATE(248),
    [sym_preproc_error] = STATE(248),
    [sym_preproc_define] = STATE(248),
    [sym_preproc_undef] = STATE(248),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_list_pattern_repeat1] = STATE(8595),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_COMMA] = ACTIONS(1199),
    [anon_sym_RBRACK] = ACTIONS(1199),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(1201),
    [anon_sym_GT] = ACTIONS(1201),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1201),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1481),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_SLASH] = ACTIONS(1201),
    [anon_sym_PERCENT] = ACTIONS(1199),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_PIPE] = ACTIONS(1201),
    [anon_sym_AMP] = ACTIONS(1481),
    [anon_sym_LT_LT] = ACTIONS(1199),
    [anon_sym_GT_GT] = ACTIONS(1201),
    [anon_sym_GT_GT_GT] = ACTIONS(1199),
    [anon_sym_EQ_EQ] = ACTIONS(1199),
    [anon_sym_BANG_EQ] = ACTIONS(1199),
    [anon_sym_GT_EQ] = ACTIONS(1199),
    [anon_sym_LT_EQ] = ACTIONS(1199),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(1201),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1201),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_AMP_AMP] = ACTIONS(1199),
    [anon_sym_PIPE_PIPE] = ACTIONS(1199),
    [anon_sym_QMARK_QMARK] = ACTIONS(1199),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1201),
    [anon_sym_is] = ACTIONS(1201),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_DASH_GT] = ACTIONS(1199),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_with] = ACTIONS(1201),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [249] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5384),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(249),
    [sym_preproc_endregion] = STATE(249),
    [sym_preproc_line] = STATE(249),
    [sym_preproc_pragma] = STATE(249),
    [sym_preproc_nullable] = STATE(249),
    [sym_preproc_error] = STATE(249),
    [sym_preproc_define] = STATE(249),
    [sym_preproc_undef] = STATE(249),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_list_pattern_repeat1] = STATE(8360),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_COMMA] = ACTIONS(1199),
    [anon_sym_RBRACK] = ACTIONS(1199),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(1201),
    [anon_sym_GT] = ACTIONS(1201),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1201),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1481),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_SLASH] = ACTIONS(1201),
    [anon_sym_PERCENT] = ACTIONS(1199),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_PIPE] = ACTIONS(1201),
    [anon_sym_AMP] = ACTIONS(1481),
    [anon_sym_LT_LT] = ACTIONS(1199),
    [anon_sym_GT_GT] = ACTIONS(1201),
    [anon_sym_GT_GT_GT] = ACTIONS(1199),
    [anon_sym_EQ_EQ] = ACTIONS(1199),
    [anon_sym_BANG_EQ] = ACTIONS(1199),
    [anon_sym_GT_EQ] = ACTIONS(1199),
    [anon_sym_LT_EQ] = ACTIONS(1199),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(1201),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1201),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_AMP_AMP] = ACTIONS(1199),
    [anon_sym_PIPE_PIPE] = ACTIONS(1199),
    [anon_sym_QMARK_QMARK] = ACTIONS(1199),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1201),
    [anon_sym_is] = ACTIONS(1201),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_DASH_GT] = ACTIONS(1199),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_with] = ACTIONS(1201),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [250] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5384),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(250),
    [sym_preproc_endregion] = STATE(250),
    [sym_preproc_line] = STATE(250),
    [sym_preproc_pragma] = STATE(250),
    [sym_preproc_nullable] = STATE(250),
    [sym_preproc_error] = STATE(250),
    [sym_preproc_define] = STATE(250),
    [sym_preproc_undef] = STATE(250),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_list_pattern_repeat1] = STATE(8372),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_COMMA] = ACTIONS(1199),
    [anon_sym_RBRACK] = ACTIONS(1199),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(1201),
    [anon_sym_GT] = ACTIONS(1201),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1201),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1481),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_SLASH] = ACTIONS(1201),
    [anon_sym_PERCENT] = ACTIONS(1199),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_PIPE] = ACTIONS(1201),
    [anon_sym_AMP] = ACTIONS(1481),
    [anon_sym_LT_LT] = ACTIONS(1199),
    [anon_sym_GT_GT] = ACTIONS(1201),
    [anon_sym_GT_GT_GT] = ACTIONS(1199),
    [anon_sym_EQ_EQ] = ACTIONS(1199),
    [anon_sym_BANG_EQ] = ACTIONS(1199),
    [anon_sym_GT_EQ] = ACTIONS(1199),
    [anon_sym_LT_EQ] = ACTIONS(1199),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(1201),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1201),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_AMP_AMP] = ACTIONS(1199),
    [anon_sym_PIPE_PIPE] = ACTIONS(1199),
    [anon_sym_QMARK_QMARK] = ACTIONS(1199),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1201),
    [anon_sym_is] = ACTIONS(1201),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_DASH_GT] = ACTIONS(1199),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_with] = ACTIONS(1201),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [251] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7076),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5939),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4314),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9775),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(251),
    [sym_preproc_endregion] = STATE(251),
    [sym_preproc_line] = STATE(251),
    [sym_preproc_pragma] = STATE(251),
    [sym_preproc_nullable] = STATE(251),
    [sym_preproc_error] = STATE(251),
    [sym_preproc_define] = STATE(251),
    [sym_preproc_undef] = STATE(251),
    [aux_sym_class_declaration_repeat1] = STATE(3835),
    [aux_sym_lambda_expression_repeat1] = STATE(4236),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(1199),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_COMMA] = ACTIONS(1199),
    [anon_sym_LPAREN] = ACTIONS(1535),
    [anon_sym_ref] = ACTIONS(1537),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_RBRACE] = ACTIONS(1199),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1465),
    [anon_sym_LT] = ACTIONS(1201),
    [anon_sym_GT] = ACTIONS(1201),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1201),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(887),
    [anon_sym_TILDE] = ACTIONS(885),
    [anon_sym_PLUS_PLUS] = ACTIONS(885),
    [anon_sym_DASH_DASH] = ACTIONS(885),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(887),
    [anon_sym_DASH] = ACTIONS(887),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_SLASH] = ACTIONS(1201),
    [anon_sym_PERCENT] = ACTIONS(1199),
    [anon_sym_CARET] = ACTIONS(885),
    [anon_sym_PIPE] = ACTIONS(1201),
    [anon_sym_AMP] = ACTIONS(887),
    [anon_sym_LT_LT] = ACTIONS(1199),
    [anon_sym_GT_GT] = ACTIONS(1201),
    [anon_sym_GT_GT_GT] = ACTIONS(1199),
    [anon_sym_EQ_EQ] = ACTIONS(1199),
    [anon_sym_BANG_EQ] = ACTIONS(1199),
    [anon_sym_GT_EQ] = ACTIONS(1199),
    [anon_sym_LT_EQ] = ACTIONS(1199),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(1201),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1201),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1539),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1541),
    [anon_sym_DOT_DOT] = ACTIONS(1543),
    [anon_sym_AMP_AMP] = ACTIONS(1199),
    [anon_sym_PIPE_PIPE] = ACTIONS(1199),
    [anon_sym_QMARK_QMARK] = ACTIONS(1199),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1201),
    [anon_sym_is] = ACTIONS(1201),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_DASH_GT] = ACTIONS(1199),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_with] = ACTIONS(1201),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [252] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6880),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7055),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5902),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4312),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7380),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9286),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(252),
    [sym_preproc_endregion] = STATE(252),
    [sym_preproc_line] = STATE(252),
    [sym_preproc_pragma] = STATE(252),
    [sym_preproc_nullable] = STATE(252),
    [sym_preproc_error] = STATE(252),
    [sym_preproc_define] = STATE(252),
    [sym_preproc_undef] = STATE(252),
    [aux_sym_class_declaration_repeat1] = STATE(3799),
    [aux_sym_lambda_expression_repeat1] = STATE(4101),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_COLON] = ACTIONS(1133),
    [anon_sym_LPAREN] = ACTIONS(1545),
    [anon_sym_ref] = ACTIONS(1547),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(1147),
    [anon_sym_GT] = ACTIONS(1147),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1147),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1549),
    [anon_sym_TILDE] = ACTIONS(1551),
    [anon_sym_PLUS_PLUS] = ACTIONS(1551),
    [anon_sym_DASH_DASH] = ACTIONS(1551),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1549),
    [anon_sym_DASH] = ACTIONS(1549),
    [anon_sym_STAR] = ACTIONS(1553),
    [anon_sym_SLASH] = ACTIONS(1147),
    [anon_sym_PERCENT] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(1551),
    [anon_sym_PIPE] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(1549),
    [anon_sym_LT_LT] = ACTIONS(1133),
    [anon_sym_GT_GT] = ACTIONS(1147),
    [anon_sym_GT_GT_GT] = ACTIONS(1133),
    [anon_sym_EQ_EQ] = ACTIONS(1133),
    [anon_sym_BANG_EQ] = ACTIONS(1133),
    [anon_sym_GT_EQ] = ACTIONS(1133),
    [anon_sym_LT_EQ] = ACTIONS(1133),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_DOT] = ACTIONS(1147),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1147),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1555),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1557),
    [anon_sym_DOT_DOT] = ACTIONS(1559),
    [anon_sym_and] = ACTIONS(1147),
    [anon_sym_or] = ACTIONS(1147),
    [anon_sym_AMP_AMP] = ACTIONS(1133),
    [anon_sym_PIPE_PIPE] = ACTIONS(1133),
    [anon_sym_QMARK_QMARK] = ACTIONS(1133),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1147),
    [anon_sym_is] = ACTIONS(1147),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_DASH_GT] = ACTIONS(1133),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_with] = ACTIONS(1147),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [253] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6880),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7055),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5856),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4312),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7380),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9286),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(253),
    [sym_preproc_endregion] = STATE(253),
    [sym_preproc_line] = STATE(253),
    [sym_preproc_pragma] = STATE(253),
    [sym_preproc_nullable] = STATE(253),
    [sym_preproc_error] = STATE(253),
    [sym_preproc_define] = STATE(253),
    [sym_preproc_undef] = STATE(253),
    [aux_sym_class_declaration_repeat1] = STATE(3799),
    [aux_sym_lambda_expression_repeat1] = STATE(4101),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_COLON] = ACTIONS(1199),
    [anon_sym_LPAREN] = ACTIONS(1545),
    [anon_sym_ref] = ACTIONS(1547),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(1201),
    [anon_sym_GT] = ACTIONS(1201),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1201),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1549),
    [anon_sym_TILDE] = ACTIONS(1551),
    [anon_sym_PLUS_PLUS] = ACTIONS(1551),
    [anon_sym_DASH_DASH] = ACTIONS(1551),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1549),
    [anon_sym_DASH] = ACTIONS(1549),
    [anon_sym_STAR] = ACTIONS(1553),
    [anon_sym_SLASH] = ACTIONS(1201),
    [anon_sym_PERCENT] = ACTIONS(1199),
    [anon_sym_CARET] = ACTIONS(1551),
    [anon_sym_PIPE] = ACTIONS(1201),
    [anon_sym_AMP] = ACTIONS(1549),
    [anon_sym_LT_LT] = ACTIONS(1199),
    [anon_sym_GT_GT] = ACTIONS(1201),
    [anon_sym_GT_GT_GT] = ACTIONS(1199),
    [anon_sym_EQ_EQ] = ACTIONS(1199),
    [anon_sym_BANG_EQ] = ACTIONS(1199),
    [anon_sym_GT_EQ] = ACTIONS(1199),
    [anon_sym_LT_EQ] = ACTIONS(1199),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_DOT] = ACTIONS(1201),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1201),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1555),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1557),
    [anon_sym_DOT_DOT] = ACTIONS(1559),
    [anon_sym_and] = ACTIONS(1201),
    [anon_sym_or] = ACTIONS(1201),
    [anon_sym_AMP_AMP] = ACTIONS(1199),
    [anon_sym_PIPE_PIPE] = ACTIONS(1199),
    [anon_sym_QMARK_QMARK] = ACTIONS(1199),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1201),
    [anon_sym_is] = ACTIONS(1201),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_DASH_GT] = ACTIONS(1199),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_with] = ACTIONS(1201),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [254] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6913),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7000),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5707),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4181),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7384),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9143),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(254),
    [sym_preproc_endregion] = STATE(254),
    [sym_preproc_line] = STATE(254),
    [sym_preproc_pragma] = STATE(254),
    [sym_preproc_nullable] = STATE(254),
    [sym_preproc_error] = STATE(254),
    [sym_preproc_define] = STATE(254),
    [sym_preproc_undef] = STATE(254),
    [aux_sym_class_declaration_repeat1] = STATE(3814),
    [aux_sym_lambda_expression_repeat1] = STATE(4171),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1561),
    [anon_sym_ref] = ACTIONS(1563),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1145),
    [anon_sym_LT] = ACTIONS(1147),
    [anon_sym_GT] = ACTIONS(1147),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1147),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1565),
    [anon_sym_TILDE] = ACTIONS(1567),
    [anon_sym_PLUS_PLUS] = ACTIONS(1567),
    [anon_sym_DASH_DASH] = ACTIONS(1567),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1565),
    [anon_sym_DASH] = ACTIONS(1565),
    [anon_sym_STAR] = ACTIONS(1569),
    [anon_sym_SLASH] = ACTIONS(1147),
    [anon_sym_PERCENT] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(1567),
    [anon_sym_PIPE] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(1565),
    [anon_sym_LT_LT] = ACTIONS(1133),
    [anon_sym_GT_GT] = ACTIONS(1147),
    [anon_sym_GT_GT_GT] = ACTIONS(1133),
    [anon_sym_EQ_EQ] = ACTIONS(1133),
    [anon_sym_BANG_EQ] = ACTIONS(1133),
    [anon_sym_GT_EQ] = ACTIONS(1133),
    [anon_sym_LT_EQ] = ACTIONS(1133),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_DOT] = ACTIONS(1147),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(1133),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1147),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1571),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1573),
    [anon_sym_DOT_DOT] = ACTIONS(1575),
    [anon_sym_and] = ACTIONS(1147),
    [anon_sym_or] = ACTIONS(1147),
    [anon_sym_AMP_AMP] = ACTIONS(1133),
    [anon_sym_PIPE_PIPE] = ACTIONS(1133),
    [anon_sym_QMARK_QMARK] = ACTIONS(1133),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1147),
    [anon_sym_is] = ACTIONS(1147),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_DASH_GT] = ACTIONS(1133),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_with] = ACTIONS(1147),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [255] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3921),
    [sym__name] = STATE(6919),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2868),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(7068),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6027),
    [sym_non_lvalue_expression] = STATE(5735),
    [sym_lvalue_expression] = STATE(4323),
    [sym__expression_statement_expression] = STATE(5733),
    [sym_assignment_expression] = STATE(5734),
    [sym_binary_expression] = STATE(5733),
    [sym_postfix_unary_expression] = STATE(5734),
    [sym_prefix_unary_expression] = STATE(5734),
    [sym__pointer_indirection_expression] = STATE(3911),
    [sym_query_expression] = STATE(5733),
    [sym_from_clause] = STATE(7393),
    [sym_conditional_expression] = STATE(5733),
    [sym_conditional_access_expression] = STATE(5733),
    [sym_as_expression] = STATE(5733),
    [sym_is_expression] = STATE(5733),
    [sym_is_pattern_expression] = STATE(5733),
    [sym_cast_expression] = STATE(5733),
    [sym_checked_expression] = STATE(5733),
    [sym_invocation_expression] = STATE(5734),
    [sym_switch_expression] = STATE(5733),
    [sym_await_expression] = STATE(5734),
    [sym_throw_expression] = STATE(5733),
    [sym_element_access_expression] = STATE(3911),
    [sym_interpolated_string_expression] = STATE(5733),
    [sym_member_access_expression] = STATE(3911),
    [sym_object_creation_expression] = STATE(5734),
    [sym_parenthesized_expression] = STATE(5734),
    [sym__parenthesized_lvalue_expression] = STATE(3911),
    [sym_lambda_expression] = STATE(5733),
    [sym__lambda_parameters] = STATE(9932),
    [sym_array_creation_expression] = STATE(5733),
    [sym_anonymous_method_expression] = STATE(5733),
    [sym_anonymous_object_creation_expression] = STATE(5733),
    [sym_implicit_array_creation_expression] = STATE(5733),
    [sym_implicit_object_creation_expression] = STATE(5733),
    [sym_implicit_stackalloc_expression] = STATE(5733),
    [sym_initializer_expression] = STATE(5733),
    [sym_default_expression] = STATE(5733),
    [sym_with_expression] = STATE(5733),
    [sym_sizeof_expression] = STATE(5733),
    [sym_typeof_expression] = STATE(5733),
    [sym_makeref_expression] = STATE(5733),
    [sym_ref_expression] = STATE(5733),
    [sym_reftype_expression] = STATE(5733),
    [sym_refvalue_expression] = STATE(5733),
    [sym_stackalloc_expression] = STATE(5733),
    [sym_range_expression] = STATE(5733),
    [sym_tuple_expression] = STATE(3911),
    [sym_literal] = STATE(5733),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2798),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(5733),
    [sym_preproc_region] = STATE(255),
    [sym_preproc_endregion] = STATE(255),
    [sym_preproc_line] = STATE(255),
    [sym_preproc_pragma] = STATE(255),
    [sym_preproc_nullable] = STATE(255),
    [sym_preproc_error] = STATE(255),
    [sym_preproc_define] = STATE(255),
    [sym_preproc_undef] = STATE(255),
    [aux_sym_class_declaration_repeat1] = STATE(3831),
    [aux_sym_lambda_expression_repeat1] = STATE(4227),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_COLON] = ACTIONS(1133),
    [anon_sym_COMMA] = ACTIONS(1133),
    [anon_sym_LPAREN] = ACTIONS(1577),
    [anon_sym_ref] = ACTIONS(1579),
    [anon_sym_LBRACE] = ACTIONS(1377),
    [anon_sym_delegate] = ACTIONS(1379),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1381),
    [anon_sym_LT] = ACTIONS(1147),
    [anon_sym_GT] = ACTIONS(1147),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_QMARK] = ACTIONS(1147),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1581),
    [anon_sym_TILDE] = ACTIONS(1583),
    [anon_sym_PLUS_PLUS] = ACTIONS(1583),
    [anon_sym_DASH_DASH] = ACTIONS(1583),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1581),
    [anon_sym_DASH] = ACTIONS(1581),
    [anon_sym_STAR] = ACTIONS(1391),
    [anon_sym_SLASH] = ACTIONS(1147),
    [anon_sym_PERCENT] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(1583),
    [anon_sym_PIPE] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(1581),
    [anon_sym_LT_LT] = ACTIONS(1133),
    [anon_sym_GT_GT] = ACTIONS(1147),
    [anon_sym_GT_GT_GT] = ACTIONS(1133),
    [anon_sym_EQ_EQ] = ACTIONS(1133),
    [anon_sym_BANG_EQ] = ACTIONS(1133),
    [anon_sym_GT_EQ] = ACTIONS(1133),
    [anon_sym_LT_EQ] = ACTIONS(1133),
    [anon_sym_this] = ACTIONS(1393),
    [anon_sym_DOT] = ACTIONS(1147),
    [anon_sym_scoped] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1397),
    [sym_predefined_type] = ACTIONS(1399),
    [anon_sym_unchecked] = ACTIONS(1383),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_switch] = ACTIONS(1147),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1585),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1587),
    [anon_sym_DOT_DOT] = ACTIONS(1589),
    [anon_sym_AMP_AMP] = ACTIONS(1133),
    [anon_sym_PIPE_PIPE] = ACTIONS(1133),
    [anon_sym_QMARK_QMARK] = ACTIONS(1133),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_as] = ACTIONS(1147),
    [anon_sym_is] = ACTIONS(1147),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_DASH_GT] = ACTIONS(1133),
    [anon_sym_stackalloc] = ACTIONS(1413),
    [anon_sym_with] = ACTIONS(1147),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(1419),
    [anon_sym___reftype] = ACTIONS(1421),
    [anon_sym___refvalue] = ACTIONS(1423),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
    [sym_interpolation_close_brace] = ACTIONS(1133),
  },
  [256] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3921),
    [sym__name] = STATE(6889),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2854),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(6991),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5419),
    [sym_non_lvalue_expression] = STATE(5735),
    [sym_lvalue_expression] = STATE(4295),
    [sym__expression_statement_expression] = STATE(5733),
    [sym_assignment_expression] = STATE(5734),
    [sym_binary_expression] = STATE(5733),
    [sym_postfix_unary_expression] = STATE(5734),
    [sym_prefix_unary_expression] = STATE(5734),
    [sym__pointer_indirection_expression] = STATE(3911),
    [sym_query_expression] = STATE(5733),
    [sym_from_clause] = STATE(7393),
    [sym_conditional_expression] = STATE(5733),
    [sym_conditional_access_expression] = STATE(5733),
    [sym_as_expression] = STATE(5733),
    [sym_is_expression] = STATE(5733),
    [sym_is_pattern_expression] = STATE(5733),
    [sym_cast_expression] = STATE(5733),
    [sym_checked_expression] = STATE(5733),
    [sym_invocation_expression] = STATE(5734),
    [sym_switch_expression] = STATE(5733),
    [sym_await_expression] = STATE(5734),
    [sym_throw_expression] = STATE(5733),
    [sym_element_access_expression] = STATE(3911),
    [sym_interpolated_string_expression] = STATE(5733),
    [sym_member_access_expression] = STATE(3911),
    [sym_object_creation_expression] = STATE(5734),
    [sym_parenthesized_expression] = STATE(5734),
    [sym__parenthesized_lvalue_expression] = STATE(3911),
    [sym_lambda_expression] = STATE(5733),
    [sym__lambda_parameters] = STATE(9313),
    [sym_array_creation_expression] = STATE(5733),
    [sym_anonymous_method_expression] = STATE(5733),
    [sym_anonymous_object_creation_expression] = STATE(5733),
    [sym_implicit_array_creation_expression] = STATE(5733),
    [sym_implicit_object_creation_expression] = STATE(5733),
    [sym_implicit_stackalloc_expression] = STATE(5733),
    [sym_initializer_expression] = STATE(5733),
    [sym_default_expression] = STATE(5733),
    [sym_with_expression] = STATE(5733),
    [sym_sizeof_expression] = STATE(5733),
    [sym_typeof_expression] = STATE(5733),
    [sym_makeref_expression] = STATE(5733),
    [sym_ref_expression] = STATE(5733),
    [sym_reftype_expression] = STATE(5733),
    [sym_refvalue_expression] = STATE(5733),
    [sym_stackalloc_expression] = STATE(5733),
    [sym_range_expression] = STATE(5733),
    [sym_tuple_expression] = STATE(3911),
    [sym_literal] = STATE(5733),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2798),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(5733),
    [sym_preproc_region] = STATE(256),
    [sym_preproc_endregion] = STATE(256),
    [sym_preproc_line] = STATE(256),
    [sym_preproc_pragma] = STATE(256),
    [sym_preproc_nullable] = STATE(256),
    [sym_preproc_error] = STATE(256),
    [sym_preproc_define] = STATE(256),
    [sym_preproc_undef] = STATE(256),
    [aux_sym_class_declaration_repeat1] = STATE(3805),
    [aux_sym_lambda_expression_repeat1] = STATE(4122),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_COLON] = ACTIONS(1199),
    [anon_sym_COMMA] = ACTIONS(1199),
    [anon_sym_LPAREN] = ACTIONS(1591),
    [anon_sym_ref] = ACTIONS(1593),
    [anon_sym_LBRACE] = ACTIONS(1377),
    [anon_sym_delegate] = ACTIONS(1379),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1443),
    [anon_sym_LT] = ACTIONS(1201),
    [anon_sym_GT] = ACTIONS(1201),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_QMARK] = ACTIONS(1201),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1595),
    [anon_sym_TILDE] = ACTIONS(1597),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1595),
    [anon_sym_DASH] = ACTIONS(1595),
    [anon_sym_STAR] = ACTIONS(1449),
    [anon_sym_SLASH] = ACTIONS(1201),
    [anon_sym_PERCENT] = ACTIONS(1199),
    [anon_sym_CARET] = ACTIONS(1597),
    [anon_sym_PIPE] = ACTIONS(1201),
    [anon_sym_AMP] = ACTIONS(1595),
    [anon_sym_LT_LT] = ACTIONS(1199),
    [anon_sym_GT_GT] = ACTIONS(1201),
    [anon_sym_GT_GT_GT] = ACTIONS(1199),
    [anon_sym_EQ_EQ] = ACTIONS(1199),
    [anon_sym_BANG_EQ] = ACTIONS(1199),
    [anon_sym_GT_EQ] = ACTIONS(1199),
    [anon_sym_LT_EQ] = ACTIONS(1199),
    [anon_sym_this] = ACTIONS(1393),
    [anon_sym_DOT] = ACTIONS(1201),
    [anon_sym_scoped] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1397),
    [sym_predefined_type] = ACTIONS(1399),
    [anon_sym_unchecked] = ACTIONS(1383),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_switch] = ACTIONS(1201),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1599),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1601),
    [anon_sym_DOT_DOT] = ACTIONS(1603),
    [anon_sym_AMP_AMP] = ACTIONS(1199),
    [anon_sym_PIPE_PIPE] = ACTIONS(1199),
    [anon_sym_QMARK_QMARK] = ACTIONS(1199),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_as] = ACTIONS(1201),
    [anon_sym_is] = ACTIONS(1201),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_DASH_GT] = ACTIONS(1199),
    [anon_sym_stackalloc] = ACTIONS(1413),
    [anon_sym_with] = ACTIONS(1201),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(1419),
    [anon_sym___reftype] = ACTIONS(1421),
    [anon_sym___refvalue] = ACTIONS(1423),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
    [sym_interpolation_close_brace] = ACTIONS(1199),
  },
  [257] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5384),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(257),
    [sym_preproc_endregion] = STATE(257),
    [sym_preproc_line] = STATE(257),
    [sym_preproc_pragma] = STATE(257),
    [sym_preproc_nullable] = STATE(257),
    [sym_preproc_error] = STATE(257),
    [sym_preproc_define] = STATE(257),
    [sym_preproc_undef] = STATE(257),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_list_pattern_repeat1] = STATE(8605),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_COMMA] = ACTIONS(1199),
    [anon_sym_RBRACK] = ACTIONS(1199),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(1201),
    [anon_sym_GT] = ACTIONS(1201),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1201),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1481),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_SLASH] = ACTIONS(1201),
    [anon_sym_PERCENT] = ACTIONS(1199),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_PIPE] = ACTIONS(1201),
    [anon_sym_AMP] = ACTIONS(1481),
    [anon_sym_LT_LT] = ACTIONS(1199),
    [anon_sym_GT_GT] = ACTIONS(1201),
    [anon_sym_GT_GT_GT] = ACTIONS(1199),
    [anon_sym_EQ_EQ] = ACTIONS(1199),
    [anon_sym_BANG_EQ] = ACTIONS(1199),
    [anon_sym_GT_EQ] = ACTIONS(1199),
    [anon_sym_LT_EQ] = ACTIONS(1199),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(1201),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1201),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_AMP_AMP] = ACTIONS(1199),
    [anon_sym_PIPE_PIPE] = ACTIONS(1199),
    [anon_sym_QMARK_QMARK] = ACTIONS(1199),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1201),
    [anon_sym_is] = ACTIONS(1201),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_DASH_GT] = ACTIONS(1199),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_with] = ACTIONS(1201),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [258] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3921),
    [sym__name] = STATE(6889),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2854),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(6991),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5555),
    [sym_non_lvalue_expression] = STATE(5735),
    [sym_lvalue_expression] = STATE(4295),
    [sym__expression_statement_expression] = STATE(5733),
    [sym_assignment_expression] = STATE(5734),
    [sym_binary_expression] = STATE(5733),
    [sym_postfix_unary_expression] = STATE(5734),
    [sym_prefix_unary_expression] = STATE(5734),
    [sym__pointer_indirection_expression] = STATE(3911),
    [sym_query_expression] = STATE(5733),
    [sym_from_clause] = STATE(7393),
    [sym_conditional_expression] = STATE(5733),
    [sym_conditional_access_expression] = STATE(5733),
    [sym_as_expression] = STATE(5733),
    [sym_is_expression] = STATE(5733),
    [sym_is_pattern_expression] = STATE(5733),
    [sym_cast_expression] = STATE(5733),
    [sym_checked_expression] = STATE(5733),
    [sym_invocation_expression] = STATE(5734),
    [sym_switch_expression] = STATE(5733),
    [sym_await_expression] = STATE(5734),
    [sym_throw_expression] = STATE(5733),
    [sym_element_access_expression] = STATE(3911),
    [sym_interpolated_string_expression] = STATE(5733),
    [sym_member_access_expression] = STATE(3911),
    [sym_object_creation_expression] = STATE(5734),
    [sym_parenthesized_expression] = STATE(5734),
    [sym__parenthesized_lvalue_expression] = STATE(3911),
    [sym_lambda_expression] = STATE(5733),
    [sym__lambda_parameters] = STATE(9313),
    [sym_array_creation_expression] = STATE(5733),
    [sym_anonymous_method_expression] = STATE(5733),
    [sym_anonymous_object_creation_expression] = STATE(5733),
    [sym_implicit_array_creation_expression] = STATE(5733),
    [sym_implicit_object_creation_expression] = STATE(5733),
    [sym_implicit_stackalloc_expression] = STATE(5733),
    [sym_initializer_expression] = STATE(5733),
    [sym_default_expression] = STATE(5733),
    [sym_with_expression] = STATE(5733),
    [sym_sizeof_expression] = STATE(5733),
    [sym_typeof_expression] = STATE(5733),
    [sym_makeref_expression] = STATE(5733),
    [sym_ref_expression] = STATE(5733),
    [sym_reftype_expression] = STATE(5733),
    [sym_refvalue_expression] = STATE(5733),
    [sym_stackalloc_expression] = STATE(5733),
    [sym_range_expression] = STATE(5733),
    [sym_tuple_expression] = STATE(3911),
    [sym_literal] = STATE(5733),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2798),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(5733),
    [sym_preproc_region] = STATE(258),
    [sym_preproc_endregion] = STATE(258),
    [sym_preproc_line] = STATE(258),
    [sym_preproc_pragma] = STATE(258),
    [sym_preproc_nullable] = STATE(258),
    [sym_preproc_error] = STATE(258),
    [sym_preproc_define] = STATE(258),
    [sym_preproc_undef] = STATE(258),
    [aux_sym_class_declaration_repeat1] = STATE(3805),
    [aux_sym_lambda_expression_repeat1] = STATE(4122),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_COLON] = ACTIONS(1133),
    [anon_sym_COMMA] = ACTIONS(1133),
    [anon_sym_LPAREN] = ACTIONS(1591),
    [anon_sym_ref] = ACTIONS(1593),
    [anon_sym_LBRACE] = ACTIONS(1377),
    [anon_sym_delegate] = ACTIONS(1379),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1443),
    [anon_sym_LT] = ACTIONS(1147),
    [anon_sym_GT] = ACTIONS(1147),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_QMARK] = ACTIONS(1147),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1595),
    [anon_sym_TILDE] = ACTIONS(1597),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1595),
    [anon_sym_DASH] = ACTIONS(1595),
    [anon_sym_STAR] = ACTIONS(1449),
    [anon_sym_SLASH] = ACTIONS(1147),
    [anon_sym_PERCENT] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(1597),
    [anon_sym_PIPE] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(1595),
    [anon_sym_LT_LT] = ACTIONS(1133),
    [anon_sym_GT_GT] = ACTIONS(1147),
    [anon_sym_GT_GT_GT] = ACTIONS(1133),
    [anon_sym_EQ_EQ] = ACTIONS(1133),
    [anon_sym_BANG_EQ] = ACTIONS(1133),
    [anon_sym_GT_EQ] = ACTIONS(1133),
    [anon_sym_LT_EQ] = ACTIONS(1133),
    [anon_sym_this] = ACTIONS(1393),
    [anon_sym_DOT] = ACTIONS(1147),
    [anon_sym_scoped] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1397),
    [sym_predefined_type] = ACTIONS(1399),
    [anon_sym_unchecked] = ACTIONS(1383),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_switch] = ACTIONS(1147),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1599),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1601),
    [anon_sym_DOT_DOT] = ACTIONS(1603),
    [anon_sym_AMP_AMP] = ACTIONS(1133),
    [anon_sym_PIPE_PIPE] = ACTIONS(1133),
    [anon_sym_QMARK_QMARK] = ACTIONS(1133),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_as] = ACTIONS(1147),
    [anon_sym_is] = ACTIONS(1147),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_DASH_GT] = ACTIONS(1133),
    [anon_sym_stackalloc] = ACTIONS(1413),
    [anon_sym_with] = ACTIONS(1147),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(1419),
    [anon_sym___reftype] = ACTIONS(1421),
    [anon_sym___refvalue] = ACTIONS(1423),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
    [sym_interpolation_close_brace] = ACTIONS(1133),
  },
  [259] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7076),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5797),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4314),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9775),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(259),
    [sym_preproc_endregion] = STATE(259),
    [sym_preproc_line] = STATE(259),
    [sym_preproc_pragma] = STATE(259),
    [sym_preproc_nullable] = STATE(259),
    [sym_preproc_error] = STATE(259),
    [sym_preproc_define] = STATE(259),
    [sym_preproc_undef] = STATE(259),
    [aux_sym_class_declaration_repeat1] = STATE(3835),
    [aux_sym_lambda_expression_repeat1] = STATE(4236),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(1133),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_COMMA] = ACTIONS(1133),
    [anon_sym_LPAREN] = ACTIONS(1535),
    [anon_sym_ref] = ACTIONS(1537),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_RBRACE] = ACTIONS(1133),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1465),
    [anon_sym_LT] = ACTIONS(1147),
    [anon_sym_GT] = ACTIONS(1147),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1147),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(887),
    [anon_sym_TILDE] = ACTIONS(885),
    [anon_sym_PLUS_PLUS] = ACTIONS(885),
    [anon_sym_DASH_DASH] = ACTIONS(885),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(887),
    [anon_sym_DASH] = ACTIONS(887),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_SLASH] = ACTIONS(1147),
    [anon_sym_PERCENT] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(885),
    [anon_sym_PIPE] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(887),
    [anon_sym_LT_LT] = ACTIONS(1133),
    [anon_sym_GT_GT] = ACTIONS(1147),
    [anon_sym_GT_GT_GT] = ACTIONS(1133),
    [anon_sym_EQ_EQ] = ACTIONS(1133),
    [anon_sym_BANG_EQ] = ACTIONS(1133),
    [anon_sym_GT_EQ] = ACTIONS(1133),
    [anon_sym_LT_EQ] = ACTIONS(1133),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(1147),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1147),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1539),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1541),
    [anon_sym_DOT_DOT] = ACTIONS(1543),
    [anon_sym_AMP_AMP] = ACTIONS(1133),
    [anon_sym_PIPE_PIPE] = ACTIONS(1133),
    [anon_sym_QMARK_QMARK] = ACTIONS(1133),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1147),
    [anon_sym_is] = ACTIONS(1147),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_DASH_GT] = ACTIONS(1133),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_with] = ACTIONS(1147),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [260] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3559),
    [sym__name] = STATE(6878),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2911),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6960),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4475),
    [sym_non_lvalue_expression] = STATE(4553),
    [sym_lvalue_expression] = STATE(3607),
    [sym__expression_statement_expression] = STATE(4559),
    [sym_assignment_expression] = STATE(4558),
    [sym_binary_expression] = STATE(4559),
    [sym_postfix_unary_expression] = STATE(4558),
    [sym_prefix_unary_expression] = STATE(4558),
    [sym__pointer_indirection_expression] = STATE(3560),
    [sym_query_expression] = STATE(4559),
    [sym_from_clause] = STATE(7385),
    [sym_conditional_expression] = STATE(4559),
    [sym_conditional_access_expression] = STATE(4559),
    [sym_as_expression] = STATE(4559),
    [sym_is_expression] = STATE(4559),
    [sym_is_pattern_expression] = STATE(4559),
    [sym_cast_expression] = STATE(4559),
    [sym_checked_expression] = STATE(4559),
    [sym_invocation_expression] = STATE(4558),
    [sym_switch_expression] = STATE(4559),
    [sym_await_expression] = STATE(4558),
    [sym_throw_expression] = STATE(4559),
    [sym_element_access_expression] = STATE(3560),
    [sym_interpolated_string_expression] = STATE(4559),
    [sym_member_access_expression] = STATE(3560),
    [sym_object_creation_expression] = STATE(4558),
    [sym_parenthesized_expression] = STATE(4558),
    [sym__parenthesized_lvalue_expression] = STATE(3560),
    [sym_lambda_expression] = STATE(4559),
    [sym__lambda_parameters] = STATE(9554),
    [sym_array_creation_expression] = STATE(4559),
    [sym_anonymous_method_expression] = STATE(4559),
    [sym_anonymous_object_creation_expression] = STATE(4559),
    [sym_implicit_array_creation_expression] = STATE(4559),
    [sym_implicit_object_creation_expression] = STATE(4559),
    [sym_implicit_stackalloc_expression] = STATE(4559),
    [sym_initializer_expression] = STATE(4559),
    [sym_default_expression] = STATE(4559),
    [sym_with_expression] = STATE(4559),
    [sym_sizeof_expression] = STATE(4559),
    [sym_typeof_expression] = STATE(4559),
    [sym_makeref_expression] = STATE(4559),
    [sym_ref_expression] = STATE(4559),
    [sym_reftype_expression] = STATE(4559),
    [sym_refvalue_expression] = STATE(4559),
    [sym_stackalloc_expression] = STATE(4559),
    [sym_range_expression] = STATE(4559),
    [sym_tuple_expression] = STATE(3560),
    [sym_literal] = STATE(4559),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4559),
    [sym_preproc_region] = STATE(260),
    [sym_preproc_endregion] = STATE(260),
    [sym_preproc_line] = STATE(260),
    [sym_preproc_pragma] = STATE(260),
    [sym_preproc_nullable] = STATE(260),
    [sym_preproc_error] = STATE(260),
    [sym_preproc_define] = STATE(260),
    [sym_preproc_undef] = STATE(260),
    [aux_sym_class_declaration_repeat1] = STATE(3792),
    [aux_sym_lambda_expression_repeat1] = STATE(4202),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_COMMA] = ACTIONS(1133),
    [anon_sym_LPAREN] = ACTIONS(1607),
    [anon_sym_ref] = ACTIONS(1609),
    [anon_sym_LBRACE] = ACTIONS(1611),
    [anon_sym_delegate] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1615),
    [anon_sym_LT] = ACTIONS(1147),
    [anon_sym_GT] = ACTIONS(1147),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1147),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(1619),
    [anon_sym_TILDE] = ACTIONS(1621),
    [anon_sym_PLUS_PLUS] = ACTIONS(1621),
    [anon_sym_DASH_DASH] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(1619),
    [anon_sym_DASH] = ACTIONS(1619),
    [anon_sym_STAR] = ACTIONS(1625),
    [anon_sym_SLASH] = ACTIONS(1147),
    [anon_sym_PERCENT] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(1621),
    [anon_sym_PIPE] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(1619),
    [anon_sym_LT_LT] = ACTIONS(1133),
    [anon_sym_GT_GT] = ACTIONS(1147),
    [anon_sym_GT_GT_GT] = ACTIONS(1133),
    [anon_sym_EQ_EQ] = ACTIONS(1133),
    [anon_sym_BANG_EQ] = ACTIONS(1133),
    [anon_sym_GT_EQ] = ACTIONS(1133),
    [anon_sym_LT_EQ] = ACTIONS(1133),
    [anon_sym_this] = ACTIONS(1627),
    [anon_sym_DOT] = ACTIONS(1147),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1629),
    [anon_sym_unchecked] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1147),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [anon_sym_DOT_DOT] = ACTIONS(1637),
    [anon_sym_and] = ACTIONS(1147),
    [anon_sym_or] = ACTIONS(1147),
    [anon_sym_AMP_AMP] = ACTIONS(1133),
    [anon_sym_PIPE_PIPE] = ACTIONS(1133),
    [anon_sym_QMARK_QMARK] = ACTIONS(1133),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1147),
    [anon_sym_is] = ACTIONS(1147),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_DASH_GT] = ACTIONS(1133),
    [anon_sym_stackalloc] = ACTIONS(1641),
    [anon_sym_with] = ACTIONS(1147),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(1647),
    [anon_sym___reftype] = ACTIONS(1649),
    [anon_sym___refvalue] = ACTIONS(1651),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1659),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [261] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7094),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6061),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(261),
    [sym_preproc_endregion] = STATE(261),
    [sym_preproc_line] = STATE(261),
    [sym_preproc_pragma] = STATE(261),
    [sym_preproc_nullable] = STATE(261),
    [sym_preproc_error] = STATE(261),
    [sym_preproc_define] = STATE(261),
    [sym_preproc_undef] = STATE(261),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(1147),
    [anon_sym_GT] = ACTIONS(1147),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1147),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1667),
    [anon_sym_TILDE] = ACTIONS(1669),
    [anon_sym_PLUS_PLUS] = ACTIONS(1669),
    [anon_sym_DASH_DASH] = ACTIONS(1669),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1667),
    [anon_sym_DASH] = ACTIONS(1667),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_SLASH] = ACTIONS(1147),
    [anon_sym_PERCENT] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(1669),
    [anon_sym_PIPE] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(1667),
    [anon_sym_LT_LT] = ACTIONS(1133),
    [anon_sym_GT_GT] = ACTIONS(1147),
    [anon_sym_GT_GT_GT] = ACTIONS(1133),
    [anon_sym_EQ_EQ] = ACTIONS(1133),
    [anon_sym_BANG_EQ] = ACTIONS(1133),
    [anon_sym_GT_EQ] = ACTIONS(1133),
    [anon_sym_LT_EQ] = ACTIONS(1133),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(1147),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1147),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_AMP_AMP] = ACTIONS(1133),
    [anon_sym_PIPE_PIPE] = ACTIONS(1133),
    [anon_sym_QMARK_QMARK] = ACTIONS(1133),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1147),
    [anon_sym_is] = ACTIONS(1147),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_DASH_GT] = ACTIONS(1133),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_with] = ACTIONS(1147),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_if_token3] = ACTIONS(1133),
    [aux_sym_preproc_else_token1] = ACTIONS(1133),
    [aux_sym_preproc_elif_token1] = ACTIONS(1133),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [262] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3559),
    [sym__name] = STATE(6877),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2908),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7129),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4359),
    [sym_non_lvalue_expression] = STATE(4553),
    [sym_lvalue_expression] = STATE(3561),
    [sym__expression_statement_expression] = STATE(4559),
    [sym_assignment_expression] = STATE(4558),
    [sym_binary_expression] = STATE(4559),
    [sym_postfix_unary_expression] = STATE(4558),
    [sym_prefix_unary_expression] = STATE(4558),
    [sym__pointer_indirection_expression] = STATE(3560),
    [sym_query_expression] = STATE(4559),
    [sym_from_clause] = STATE(7385),
    [sym_conditional_expression] = STATE(4559),
    [sym_conditional_access_expression] = STATE(4559),
    [sym_as_expression] = STATE(4559),
    [sym_is_expression] = STATE(4559),
    [sym_is_pattern_expression] = STATE(4559),
    [sym_cast_expression] = STATE(4559),
    [sym_checked_expression] = STATE(4559),
    [sym_invocation_expression] = STATE(4558),
    [sym_switch_expression] = STATE(4559),
    [sym_await_expression] = STATE(4558),
    [sym_throw_expression] = STATE(4559),
    [sym_element_access_expression] = STATE(3560),
    [sym_interpolated_string_expression] = STATE(4559),
    [sym_member_access_expression] = STATE(3560),
    [sym_object_creation_expression] = STATE(4558),
    [sym_parenthesized_expression] = STATE(4558),
    [sym__parenthesized_lvalue_expression] = STATE(3560),
    [sym_lambda_expression] = STATE(4559),
    [sym__lambda_parameters] = STATE(9776),
    [sym_array_creation_expression] = STATE(4559),
    [sym_anonymous_method_expression] = STATE(4559),
    [sym_anonymous_object_creation_expression] = STATE(4559),
    [sym_implicit_array_creation_expression] = STATE(4559),
    [sym_implicit_object_creation_expression] = STATE(4559),
    [sym_implicit_stackalloc_expression] = STATE(4559),
    [sym_initializer_expression] = STATE(4559),
    [sym_default_expression] = STATE(4559),
    [sym_with_expression] = STATE(4559),
    [sym_sizeof_expression] = STATE(4559),
    [sym_typeof_expression] = STATE(4559),
    [sym_makeref_expression] = STATE(4559),
    [sym_ref_expression] = STATE(4559),
    [sym_reftype_expression] = STATE(4559),
    [sym_refvalue_expression] = STATE(4559),
    [sym_stackalloc_expression] = STATE(4559),
    [sym_range_expression] = STATE(4559),
    [sym_tuple_expression] = STATE(3560),
    [sym_literal] = STATE(4559),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4559),
    [sym_preproc_region] = STATE(262),
    [sym_preproc_endregion] = STATE(262),
    [sym_preproc_line] = STATE(262),
    [sym_preproc_pragma] = STATE(262),
    [sym_preproc_nullable] = STATE(262),
    [sym_preproc_error] = STATE(262),
    [sym_preproc_define] = STATE(262),
    [sym_preproc_undef] = STATE(262),
    [aux_sym_class_declaration_repeat1] = STATE(3843),
    [aux_sym_lambda_expression_repeat1] = STATE(4277),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_COMMA] = ACTIONS(1133),
    [anon_sym_LPAREN] = ACTIONS(1675),
    [anon_sym_ref] = ACTIONS(1677),
    [anon_sym_LBRACE] = ACTIONS(1611),
    [anon_sym_delegate] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1679),
    [anon_sym_LT] = ACTIONS(1147),
    [anon_sym_GT] = ACTIONS(1147),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1147),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(1681),
    [anon_sym_TILDE] = ACTIONS(1683),
    [anon_sym_PLUS_PLUS] = ACTIONS(1683),
    [anon_sym_DASH_DASH] = ACTIONS(1683),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_DASH] = ACTIONS(1681),
    [anon_sym_STAR] = ACTIONS(1685),
    [anon_sym_SLASH] = ACTIONS(1147),
    [anon_sym_PERCENT] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PIPE] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1133),
    [anon_sym_GT_GT] = ACTIONS(1147),
    [anon_sym_GT_GT_GT] = ACTIONS(1133),
    [anon_sym_EQ_EQ] = ACTIONS(1133),
    [anon_sym_BANG_EQ] = ACTIONS(1133),
    [anon_sym_GT_EQ] = ACTIONS(1133),
    [anon_sym_LT_EQ] = ACTIONS(1133),
    [anon_sym_this] = ACTIONS(1627),
    [anon_sym_DOT] = ACTIONS(1147),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1629),
    [anon_sym_unchecked] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1147),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(1687),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1689),
    [anon_sym_DOT_DOT] = ACTIONS(1691),
    [anon_sym_and] = ACTIONS(1147),
    [anon_sym_or] = ACTIONS(1147),
    [anon_sym_AMP_AMP] = ACTIONS(1133),
    [anon_sym_PIPE_PIPE] = ACTIONS(1133),
    [anon_sym_QMARK_QMARK] = ACTIONS(1133),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1147),
    [anon_sym_is] = ACTIONS(1147),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_DASH_GT] = ACTIONS(1133),
    [anon_sym_stackalloc] = ACTIONS(1641),
    [anon_sym_with] = ACTIONS(1147),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(1647),
    [anon_sym___reftype] = ACTIONS(1649),
    [anon_sym___refvalue] = ACTIONS(1651),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1659),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [263] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7027),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5984),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4329),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7402),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9167),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(263),
    [sym_preproc_endregion] = STATE(263),
    [sym_preproc_line] = STATE(263),
    [sym_preproc_pragma] = STATE(263),
    [sym_preproc_nullable] = STATE(263),
    [sym_preproc_error] = STATE(263),
    [sym_preproc_define] = STATE(263),
    [sym_preproc_undef] = STATE(263),
    [aux_sym_class_declaration_repeat1] = STATE(3794),
    [aux_sym_lambda_expression_repeat1] = STATE(4293),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1693),
    [anon_sym_ref] = ACTIONS(1695),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(1147),
    [anon_sym_GT] = ACTIONS(1147),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1147),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1697),
    [anon_sym_TILDE] = ACTIONS(1699),
    [anon_sym_PLUS_PLUS] = ACTIONS(1699),
    [anon_sym_DASH_DASH] = ACTIONS(1699),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1697),
    [anon_sym_DASH] = ACTIONS(1697),
    [anon_sym_STAR] = ACTIONS(1701),
    [anon_sym_SLASH] = ACTIONS(1147),
    [anon_sym_PERCENT] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(1699),
    [anon_sym_PIPE] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(1697),
    [anon_sym_LT_LT] = ACTIONS(1133),
    [anon_sym_GT_GT] = ACTIONS(1147),
    [anon_sym_GT_GT_GT] = ACTIONS(1133),
    [anon_sym_EQ_EQ] = ACTIONS(1133),
    [anon_sym_BANG_EQ] = ACTIONS(1133),
    [anon_sym_GT_EQ] = ACTIONS(1133),
    [anon_sym_LT_EQ] = ACTIONS(1133),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_DOT] = ACTIONS(1147),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(1133),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1147),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1703),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1705),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_and] = ACTIONS(1147),
    [anon_sym_or] = ACTIONS(1147),
    [anon_sym_AMP_AMP] = ACTIONS(1133),
    [anon_sym_PIPE_PIPE] = ACTIONS(1133),
    [anon_sym_QMARK_QMARK] = ACTIONS(1133),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1147),
    [anon_sym_is] = ACTIONS(1147),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_DASH_GT] = ACTIONS(1133),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_with] = ACTIONS(1147),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [264] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3921),
    [sym__name] = STATE(6919),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2868),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(7068),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5804),
    [sym_non_lvalue_expression] = STATE(5735),
    [sym_lvalue_expression] = STATE(4323),
    [sym__expression_statement_expression] = STATE(5733),
    [sym_assignment_expression] = STATE(5734),
    [sym_binary_expression] = STATE(5733),
    [sym_postfix_unary_expression] = STATE(5734),
    [sym_prefix_unary_expression] = STATE(5734),
    [sym__pointer_indirection_expression] = STATE(3911),
    [sym_query_expression] = STATE(5733),
    [sym_from_clause] = STATE(7393),
    [sym_conditional_expression] = STATE(5733),
    [sym_conditional_access_expression] = STATE(5733),
    [sym_as_expression] = STATE(5733),
    [sym_is_expression] = STATE(5733),
    [sym_is_pattern_expression] = STATE(5733),
    [sym_cast_expression] = STATE(5733),
    [sym_checked_expression] = STATE(5733),
    [sym_invocation_expression] = STATE(5734),
    [sym_switch_expression] = STATE(5733),
    [sym_await_expression] = STATE(5734),
    [sym_throw_expression] = STATE(5733),
    [sym_element_access_expression] = STATE(3911),
    [sym_interpolated_string_expression] = STATE(5733),
    [sym_member_access_expression] = STATE(3911),
    [sym_object_creation_expression] = STATE(5734),
    [sym_parenthesized_expression] = STATE(5734),
    [sym__parenthesized_lvalue_expression] = STATE(3911),
    [sym_lambda_expression] = STATE(5733),
    [sym__lambda_parameters] = STATE(9932),
    [sym_array_creation_expression] = STATE(5733),
    [sym_anonymous_method_expression] = STATE(5733),
    [sym_anonymous_object_creation_expression] = STATE(5733),
    [sym_implicit_array_creation_expression] = STATE(5733),
    [sym_implicit_object_creation_expression] = STATE(5733),
    [sym_implicit_stackalloc_expression] = STATE(5733),
    [sym_initializer_expression] = STATE(5733),
    [sym_default_expression] = STATE(5733),
    [sym_with_expression] = STATE(5733),
    [sym_sizeof_expression] = STATE(5733),
    [sym_typeof_expression] = STATE(5733),
    [sym_makeref_expression] = STATE(5733),
    [sym_ref_expression] = STATE(5733),
    [sym_reftype_expression] = STATE(5733),
    [sym_refvalue_expression] = STATE(5733),
    [sym_stackalloc_expression] = STATE(5733),
    [sym_range_expression] = STATE(5733),
    [sym_tuple_expression] = STATE(3911),
    [sym_literal] = STATE(5733),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2798),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(5733),
    [sym_preproc_region] = STATE(264),
    [sym_preproc_endregion] = STATE(264),
    [sym_preproc_line] = STATE(264),
    [sym_preproc_pragma] = STATE(264),
    [sym_preproc_nullable] = STATE(264),
    [sym_preproc_error] = STATE(264),
    [sym_preproc_define] = STATE(264),
    [sym_preproc_undef] = STATE(264),
    [aux_sym_class_declaration_repeat1] = STATE(3831),
    [aux_sym_lambda_expression_repeat1] = STATE(4227),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_COLON] = ACTIONS(1199),
    [anon_sym_COMMA] = ACTIONS(1199),
    [anon_sym_LPAREN] = ACTIONS(1577),
    [anon_sym_ref] = ACTIONS(1579),
    [anon_sym_LBRACE] = ACTIONS(1377),
    [anon_sym_delegate] = ACTIONS(1379),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1381),
    [anon_sym_LT] = ACTIONS(1201),
    [anon_sym_GT] = ACTIONS(1201),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_QMARK] = ACTIONS(1201),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1581),
    [anon_sym_TILDE] = ACTIONS(1583),
    [anon_sym_PLUS_PLUS] = ACTIONS(1583),
    [anon_sym_DASH_DASH] = ACTIONS(1583),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1581),
    [anon_sym_DASH] = ACTIONS(1581),
    [anon_sym_STAR] = ACTIONS(1391),
    [anon_sym_SLASH] = ACTIONS(1201),
    [anon_sym_PERCENT] = ACTIONS(1199),
    [anon_sym_CARET] = ACTIONS(1583),
    [anon_sym_PIPE] = ACTIONS(1201),
    [anon_sym_AMP] = ACTIONS(1581),
    [anon_sym_LT_LT] = ACTIONS(1199),
    [anon_sym_GT_GT] = ACTIONS(1201),
    [anon_sym_GT_GT_GT] = ACTIONS(1199),
    [anon_sym_EQ_EQ] = ACTIONS(1199),
    [anon_sym_BANG_EQ] = ACTIONS(1199),
    [anon_sym_GT_EQ] = ACTIONS(1199),
    [anon_sym_LT_EQ] = ACTIONS(1199),
    [anon_sym_this] = ACTIONS(1393),
    [anon_sym_DOT] = ACTIONS(1201),
    [anon_sym_scoped] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1397),
    [sym_predefined_type] = ACTIONS(1399),
    [anon_sym_unchecked] = ACTIONS(1383),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_switch] = ACTIONS(1201),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1585),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1587),
    [anon_sym_DOT_DOT] = ACTIONS(1589),
    [anon_sym_AMP_AMP] = ACTIONS(1199),
    [anon_sym_PIPE_PIPE] = ACTIONS(1199),
    [anon_sym_QMARK_QMARK] = ACTIONS(1199),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_as] = ACTIONS(1201),
    [anon_sym_is] = ACTIONS(1201),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_DASH_GT] = ACTIONS(1199),
    [anon_sym_stackalloc] = ACTIONS(1413),
    [anon_sym_with] = ACTIONS(1201),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(1419),
    [anon_sym___reftype] = ACTIONS(1421),
    [anon_sym___refvalue] = ACTIONS(1423),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
    [sym_interpolation_close_brace] = ACTIONS(1199),
  },
  [265] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3559),
    [sym__name] = STATE(6878),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2911),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6960),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4509),
    [sym_non_lvalue_expression] = STATE(4553),
    [sym_lvalue_expression] = STATE(3607),
    [sym__expression_statement_expression] = STATE(4559),
    [sym_assignment_expression] = STATE(4558),
    [sym_binary_expression] = STATE(4559),
    [sym_postfix_unary_expression] = STATE(4558),
    [sym_prefix_unary_expression] = STATE(4558),
    [sym__pointer_indirection_expression] = STATE(3560),
    [sym_query_expression] = STATE(4559),
    [sym_from_clause] = STATE(7385),
    [sym_conditional_expression] = STATE(4559),
    [sym_conditional_access_expression] = STATE(4559),
    [sym_as_expression] = STATE(4559),
    [sym_is_expression] = STATE(4559),
    [sym_is_pattern_expression] = STATE(4559),
    [sym_cast_expression] = STATE(4559),
    [sym_checked_expression] = STATE(4559),
    [sym_invocation_expression] = STATE(4558),
    [sym_switch_expression] = STATE(4559),
    [sym_await_expression] = STATE(4558),
    [sym_throw_expression] = STATE(4559),
    [sym_element_access_expression] = STATE(3560),
    [sym_interpolated_string_expression] = STATE(4559),
    [sym_member_access_expression] = STATE(3560),
    [sym_object_creation_expression] = STATE(4558),
    [sym_parenthesized_expression] = STATE(4558),
    [sym__parenthesized_lvalue_expression] = STATE(3560),
    [sym_lambda_expression] = STATE(4559),
    [sym__lambda_parameters] = STATE(9554),
    [sym_array_creation_expression] = STATE(4559),
    [sym_anonymous_method_expression] = STATE(4559),
    [sym_anonymous_object_creation_expression] = STATE(4559),
    [sym_implicit_array_creation_expression] = STATE(4559),
    [sym_implicit_object_creation_expression] = STATE(4559),
    [sym_implicit_stackalloc_expression] = STATE(4559),
    [sym_initializer_expression] = STATE(4559),
    [sym_default_expression] = STATE(4559),
    [sym_with_expression] = STATE(4559),
    [sym_sizeof_expression] = STATE(4559),
    [sym_typeof_expression] = STATE(4559),
    [sym_makeref_expression] = STATE(4559),
    [sym_ref_expression] = STATE(4559),
    [sym_reftype_expression] = STATE(4559),
    [sym_refvalue_expression] = STATE(4559),
    [sym_stackalloc_expression] = STATE(4559),
    [sym_range_expression] = STATE(4559),
    [sym_tuple_expression] = STATE(3560),
    [sym_literal] = STATE(4559),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4559),
    [sym_preproc_region] = STATE(265),
    [sym_preproc_endregion] = STATE(265),
    [sym_preproc_line] = STATE(265),
    [sym_preproc_pragma] = STATE(265),
    [sym_preproc_nullable] = STATE(265),
    [sym_preproc_error] = STATE(265),
    [sym_preproc_define] = STATE(265),
    [sym_preproc_undef] = STATE(265),
    [aux_sym_class_declaration_repeat1] = STATE(3792),
    [aux_sym_lambda_expression_repeat1] = STATE(4202),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_COMMA] = ACTIONS(1199),
    [anon_sym_LPAREN] = ACTIONS(1607),
    [anon_sym_ref] = ACTIONS(1609),
    [anon_sym_LBRACE] = ACTIONS(1611),
    [anon_sym_delegate] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1615),
    [anon_sym_LT] = ACTIONS(1201),
    [anon_sym_GT] = ACTIONS(1201),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1201),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(1619),
    [anon_sym_TILDE] = ACTIONS(1621),
    [anon_sym_PLUS_PLUS] = ACTIONS(1621),
    [anon_sym_DASH_DASH] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(1619),
    [anon_sym_DASH] = ACTIONS(1619),
    [anon_sym_STAR] = ACTIONS(1625),
    [anon_sym_SLASH] = ACTIONS(1201),
    [anon_sym_PERCENT] = ACTIONS(1199),
    [anon_sym_CARET] = ACTIONS(1621),
    [anon_sym_PIPE] = ACTIONS(1201),
    [anon_sym_AMP] = ACTIONS(1619),
    [anon_sym_LT_LT] = ACTIONS(1199),
    [anon_sym_GT_GT] = ACTIONS(1201),
    [anon_sym_GT_GT_GT] = ACTIONS(1199),
    [anon_sym_EQ_EQ] = ACTIONS(1199),
    [anon_sym_BANG_EQ] = ACTIONS(1199),
    [anon_sym_GT_EQ] = ACTIONS(1199),
    [anon_sym_LT_EQ] = ACTIONS(1199),
    [anon_sym_this] = ACTIONS(1627),
    [anon_sym_DOT] = ACTIONS(1201),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1629),
    [anon_sym_unchecked] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1201),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [anon_sym_DOT_DOT] = ACTIONS(1637),
    [anon_sym_and] = ACTIONS(1201),
    [anon_sym_or] = ACTIONS(1201),
    [anon_sym_AMP_AMP] = ACTIONS(1199),
    [anon_sym_PIPE_PIPE] = ACTIONS(1199),
    [anon_sym_QMARK_QMARK] = ACTIONS(1199),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1201),
    [anon_sym_is] = ACTIONS(1201),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_DASH_GT] = ACTIONS(1199),
    [anon_sym_stackalloc] = ACTIONS(1641),
    [anon_sym_with] = ACTIONS(1201),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(1647),
    [anon_sym___reftype] = ACTIONS(1649),
    [anon_sym___refvalue] = ACTIONS(1651),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1659),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [266] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6913),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7000),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5725),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4181),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7384),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9143),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(266),
    [sym_preproc_endregion] = STATE(266),
    [sym_preproc_line] = STATE(266),
    [sym_preproc_pragma] = STATE(266),
    [sym_preproc_nullable] = STATE(266),
    [sym_preproc_error] = STATE(266),
    [sym_preproc_define] = STATE(266),
    [sym_preproc_undef] = STATE(266),
    [aux_sym_class_declaration_repeat1] = STATE(3814),
    [aux_sym_lambda_expression_repeat1] = STATE(4171),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1561),
    [anon_sym_ref] = ACTIONS(1563),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1145),
    [anon_sym_LT] = ACTIONS(1201),
    [anon_sym_GT] = ACTIONS(1201),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1201),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1565),
    [anon_sym_TILDE] = ACTIONS(1567),
    [anon_sym_PLUS_PLUS] = ACTIONS(1567),
    [anon_sym_DASH_DASH] = ACTIONS(1567),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1565),
    [anon_sym_DASH] = ACTIONS(1565),
    [anon_sym_STAR] = ACTIONS(1569),
    [anon_sym_SLASH] = ACTIONS(1201),
    [anon_sym_PERCENT] = ACTIONS(1199),
    [anon_sym_CARET] = ACTIONS(1567),
    [anon_sym_PIPE] = ACTIONS(1201),
    [anon_sym_AMP] = ACTIONS(1565),
    [anon_sym_LT_LT] = ACTIONS(1199),
    [anon_sym_GT_GT] = ACTIONS(1201),
    [anon_sym_GT_GT_GT] = ACTIONS(1199),
    [anon_sym_EQ_EQ] = ACTIONS(1199),
    [anon_sym_BANG_EQ] = ACTIONS(1199),
    [anon_sym_GT_EQ] = ACTIONS(1199),
    [anon_sym_LT_EQ] = ACTIONS(1199),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_DOT] = ACTIONS(1201),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(1199),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1201),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1571),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1573),
    [anon_sym_DOT_DOT] = ACTIONS(1575),
    [anon_sym_and] = ACTIONS(1201),
    [anon_sym_or] = ACTIONS(1201),
    [anon_sym_AMP_AMP] = ACTIONS(1199),
    [anon_sym_PIPE_PIPE] = ACTIONS(1199),
    [anon_sym_QMARK_QMARK] = ACTIONS(1199),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1201),
    [anon_sym_is] = ACTIONS(1201),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_DASH_GT] = ACTIONS(1199),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_with] = ACTIONS(1201),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [267] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7094),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5801),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(267),
    [sym_preproc_endregion] = STATE(267),
    [sym_preproc_line] = STATE(267),
    [sym_preproc_pragma] = STATE(267),
    [sym_preproc_nullable] = STATE(267),
    [sym_preproc_error] = STATE(267),
    [sym_preproc_define] = STATE(267),
    [sym_preproc_undef] = STATE(267),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(1201),
    [anon_sym_GT] = ACTIONS(1201),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1201),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1667),
    [anon_sym_TILDE] = ACTIONS(1669),
    [anon_sym_PLUS_PLUS] = ACTIONS(1669),
    [anon_sym_DASH_DASH] = ACTIONS(1669),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1667),
    [anon_sym_DASH] = ACTIONS(1667),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_SLASH] = ACTIONS(1201),
    [anon_sym_PERCENT] = ACTIONS(1199),
    [anon_sym_CARET] = ACTIONS(1669),
    [anon_sym_PIPE] = ACTIONS(1201),
    [anon_sym_AMP] = ACTIONS(1667),
    [anon_sym_LT_LT] = ACTIONS(1199),
    [anon_sym_GT_GT] = ACTIONS(1201),
    [anon_sym_GT_GT_GT] = ACTIONS(1199),
    [anon_sym_EQ_EQ] = ACTIONS(1199),
    [anon_sym_BANG_EQ] = ACTIONS(1199),
    [anon_sym_GT_EQ] = ACTIONS(1199),
    [anon_sym_LT_EQ] = ACTIONS(1199),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(1201),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1201),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_AMP_AMP] = ACTIONS(1199),
    [anon_sym_PIPE_PIPE] = ACTIONS(1199),
    [anon_sym_QMARK_QMARK] = ACTIONS(1199),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1201),
    [anon_sym_is] = ACTIONS(1201),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_DASH_GT] = ACTIONS(1199),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_with] = ACTIONS(1201),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_if_token3] = ACTIONS(1199),
    [aux_sym_preproc_else_token1] = ACTIONS(1199),
    [aux_sym_preproc_elif_token1] = ACTIONS(1199),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [268] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6888),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2882),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7048),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5273),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4019),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7409),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9210),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(268),
    [sym_preproc_endregion] = STATE(268),
    [sym_preproc_line] = STATE(268),
    [sym_preproc_pragma] = STATE(268),
    [sym_preproc_nullable] = STATE(268),
    [sym_preproc_error] = STATE(268),
    [sym_preproc_define] = STATE(268),
    [sym_preproc_undef] = STATE(268),
    [aux_sym_class_declaration_repeat1] = STATE(3812),
    [aux_sym_lambda_expression_repeat1] = STATE(4146),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(1199),
    [anon_sym_LPAREN] = ACTIONS(1709),
    [anon_sym_ref] = ACTIONS(1711),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1713),
    [anon_sym_LT] = ACTIONS(1201),
    [anon_sym_GT] = ACTIONS(1201),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1201),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1715),
    [anon_sym_TILDE] = ACTIONS(1717),
    [anon_sym_PLUS_PLUS] = ACTIONS(1717),
    [anon_sym_DASH_DASH] = ACTIONS(1717),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1715),
    [anon_sym_DASH] = ACTIONS(1715),
    [anon_sym_STAR] = ACTIONS(1719),
    [anon_sym_SLASH] = ACTIONS(1201),
    [anon_sym_PERCENT] = ACTIONS(1199),
    [anon_sym_CARET] = ACTIONS(1717),
    [anon_sym_PIPE] = ACTIONS(1201),
    [anon_sym_AMP] = ACTIONS(1715),
    [anon_sym_LT_LT] = ACTIONS(1199),
    [anon_sym_GT_GT] = ACTIONS(1201),
    [anon_sym_GT_GT_GT] = ACTIONS(1199),
    [anon_sym_EQ_EQ] = ACTIONS(1199),
    [anon_sym_BANG_EQ] = ACTIONS(1199),
    [anon_sym_GT_EQ] = ACTIONS(1199),
    [anon_sym_LT_EQ] = ACTIONS(1199),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_DOT] = ACTIONS(1201),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1201),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1721),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1723),
    [anon_sym_DOT_DOT] = ACTIONS(1725),
    [anon_sym_and] = ACTIONS(1201),
    [anon_sym_or] = ACTIONS(1201),
    [anon_sym_AMP_AMP] = ACTIONS(1199),
    [anon_sym_PIPE_PIPE] = ACTIONS(1199),
    [anon_sym_QMARK_QMARK] = ACTIONS(1199),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1201),
    [anon_sym_is] = ACTIONS(1201),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_DASH_GT] = ACTIONS(1199),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_with] = ACTIONS(1201),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [269] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6888),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2882),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7048),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5210),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4019),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7409),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9210),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(269),
    [sym_preproc_endregion] = STATE(269),
    [sym_preproc_line] = STATE(269),
    [sym_preproc_pragma] = STATE(269),
    [sym_preproc_nullable] = STATE(269),
    [sym_preproc_error] = STATE(269),
    [sym_preproc_define] = STATE(269),
    [sym_preproc_undef] = STATE(269),
    [aux_sym_class_declaration_repeat1] = STATE(3812),
    [aux_sym_lambda_expression_repeat1] = STATE(4146),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(1133),
    [anon_sym_LPAREN] = ACTIONS(1709),
    [anon_sym_ref] = ACTIONS(1711),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1713),
    [anon_sym_LT] = ACTIONS(1147),
    [anon_sym_GT] = ACTIONS(1147),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1147),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1715),
    [anon_sym_TILDE] = ACTIONS(1717),
    [anon_sym_PLUS_PLUS] = ACTIONS(1717),
    [anon_sym_DASH_DASH] = ACTIONS(1717),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1715),
    [anon_sym_DASH] = ACTIONS(1715),
    [anon_sym_STAR] = ACTIONS(1719),
    [anon_sym_SLASH] = ACTIONS(1147),
    [anon_sym_PERCENT] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(1717),
    [anon_sym_PIPE] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(1715),
    [anon_sym_LT_LT] = ACTIONS(1133),
    [anon_sym_GT_GT] = ACTIONS(1147),
    [anon_sym_GT_GT_GT] = ACTIONS(1133),
    [anon_sym_EQ_EQ] = ACTIONS(1133),
    [anon_sym_BANG_EQ] = ACTIONS(1133),
    [anon_sym_GT_EQ] = ACTIONS(1133),
    [anon_sym_LT_EQ] = ACTIONS(1133),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_DOT] = ACTIONS(1147),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1147),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1721),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1723),
    [anon_sym_DOT_DOT] = ACTIONS(1725),
    [anon_sym_and] = ACTIONS(1147),
    [anon_sym_or] = ACTIONS(1147),
    [anon_sym_AMP_AMP] = ACTIONS(1133),
    [anon_sym_PIPE_PIPE] = ACTIONS(1133),
    [anon_sym_QMARK_QMARK] = ACTIONS(1133),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1147),
    [anon_sym_is] = ACTIONS(1147),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_DASH_GT] = ACTIONS(1133),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_with] = ACTIONS(1147),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [270] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7108),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5908),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4313),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7382),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9733),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(270),
    [sym_preproc_endregion] = STATE(270),
    [sym_preproc_line] = STATE(270),
    [sym_preproc_pragma] = STATE(270),
    [sym_preproc_nullable] = STATE(270),
    [sym_preproc_error] = STATE(270),
    [sym_preproc_define] = STATE(270),
    [sym_preproc_undef] = STATE(270),
    [aux_sym_class_declaration_repeat1] = STATE(3802),
    [aux_sym_lambda_expression_repeat1] = STATE(4108),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1519),
    [anon_sym_ref] = ACTIONS(1521),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1523),
    [anon_sym_LT] = ACTIONS(1201),
    [anon_sym_GT] = ACTIONS(1201),
    [anon_sym_in] = ACTIONS(1201),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1201),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1525),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_SLASH] = ACTIONS(1201),
    [anon_sym_PERCENT] = ACTIONS(1199),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_PIPE] = ACTIONS(1201),
    [anon_sym_AMP] = ACTIONS(1525),
    [anon_sym_LT_LT] = ACTIONS(1199),
    [anon_sym_GT_GT] = ACTIONS(1201),
    [anon_sym_GT_GT_GT] = ACTIONS(1199),
    [anon_sym_EQ_EQ] = ACTIONS(1199),
    [anon_sym_BANG_EQ] = ACTIONS(1199),
    [anon_sym_GT_EQ] = ACTIONS(1199),
    [anon_sym_LT_EQ] = ACTIONS(1199),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_DOT] = ACTIONS(1201),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1201),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1529),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1531),
    [anon_sym_DOT_DOT] = ACTIONS(1533),
    [anon_sym_and] = ACTIONS(1201),
    [anon_sym_or] = ACTIONS(1201),
    [anon_sym_AMP_AMP] = ACTIONS(1199),
    [anon_sym_PIPE_PIPE] = ACTIONS(1199),
    [anon_sym_QMARK_QMARK] = ACTIONS(1199),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1201),
    [anon_sym_is] = ACTIONS(1201),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_DASH_GT] = ACTIONS(1199),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_with] = ACTIONS(1201),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [271] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5384),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(271),
    [sym_preproc_endregion] = STATE(271),
    [sym_preproc_line] = STATE(271),
    [sym_preproc_pragma] = STATE(271),
    [sym_preproc_nullable] = STATE(271),
    [sym_preproc_error] = STATE(271),
    [sym_preproc_define] = STATE(271),
    [sym_preproc_undef] = STATE(271),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_list_pattern_repeat1] = STATE(8544),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_COMMA] = ACTIONS(1199),
    [anon_sym_RBRACK] = ACTIONS(1199),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(1201),
    [anon_sym_GT] = ACTIONS(1201),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1201),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1481),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_SLASH] = ACTIONS(1201),
    [anon_sym_PERCENT] = ACTIONS(1199),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_PIPE] = ACTIONS(1201),
    [anon_sym_AMP] = ACTIONS(1481),
    [anon_sym_LT_LT] = ACTIONS(1199),
    [anon_sym_GT_GT] = ACTIONS(1201),
    [anon_sym_GT_GT_GT] = ACTIONS(1199),
    [anon_sym_EQ_EQ] = ACTIONS(1199),
    [anon_sym_BANG_EQ] = ACTIONS(1199),
    [anon_sym_GT_EQ] = ACTIONS(1199),
    [anon_sym_LT_EQ] = ACTIONS(1199),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(1201),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1201),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_AMP_AMP] = ACTIONS(1199),
    [anon_sym_PIPE_PIPE] = ACTIONS(1199),
    [anon_sym_QMARK_QMARK] = ACTIONS(1199),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1201),
    [anon_sym_is] = ACTIONS(1201),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_DASH_GT] = ACTIONS(1199),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_with] = ACTIONS(1201),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [272] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6914),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2882),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6963),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5342),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4002),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7386),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9254),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(272),
    [sym_preproc_endregion] = STATE(272),
    [sym_preproc_line] = STATE(272),
    [sym_preproc_pragma] = STATE(272),
    [sym_preproc_nullable] = STATE(272),
    [sym_preproc_error] = STATE(272),
    [sym_preproc_define] = STATE(272),
    [sym_preproc_undef] = STATE(272),
    [aux_sym_class_declaration_repeat1] = STATE(3797),
    [aux_sym_lambda_expression_repeat1] = STATE(4081),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1727),
    [anon_sym_ref] = ACTIONS(1729),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1713),
    [anon_sym_LT] = ACTIONS(1147),
    [anon_sym_GT] = ACTIONS(1147),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1147),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1731),
    [anon_sym_TILDE] = ACTIONS(1733),
    [anon_sym_PLUS_PLUS] = ACTIONS(1733),
    [anon_sym_DASH_DASH] = ACTIONS(1733),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1731),
    [anon_sym_DASH] = ACTIONS(1731),
    [anon_sym_STAR] = ACTIONS(1735),
    [anon_sym_SLASH] = ACTIONS(1147),
    [anon_sym_PERCENT] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(1733),
    [anon_sym_PIPE] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(1731),
    [anon_sym_LT_LT] = ACTIONS(1133),
    [anon_sym_GT_GT] = ACTIONS(1147),
    [anon_sym_GT_GT_GT] = ACTIONS(1133),
    [anon_sym_EQ_EQ] = ACTIONS(1133),
    [anon_sym_BANG_EQ] = ACTIONS(1133),
    [anon_sym_GT_EQ] = ACTIONS(1133),
    [anon_sym_LT_EQ] = ACTIONS(1133),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_DOT] = ACTIONS(1147),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(1133),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1147),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1737),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1739),
    [anon_sym_DOT_DOT] = ACTIONS(1741),
    [anon_sym_and] = ACTIONS(1147),
    [anon_sym_or] = ACTIONS(1147),
    [anon_sym_AMP_AMP] = ACTIONS(1133),
    [anon_sym_PIPE_PIPE] = ACTIONS(1133),
    [anon_sym_QMARK_QMARK] = ACTIONS(1133),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1147),
    [anon_sym_is] = ACTIONS(1147),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_DASH_GT] = ACTIONS(1133),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_with] = ACTIONS(1147),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [273] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7027),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5773),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4329),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7402),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9167),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(273),
    [sym_preproc_endregion] = STATE(273),
    [sym_preproc_line] = STATE(273),
    [sym_preproc_pragma] = STATE(273),
    [sym_preproc_nullable] = STATE(273),
    [sym_preproc_error] = STATE(273),
    [sym_preproc_define] = STATE(273),
    [sym_preproc_undef] = STATE(273),
    [aux_sym_class_declaration_repeat1] = STATE(3794),
    [aux_sym_lambda_expression_repeat1] = STATE(4293),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1693),
    [anon_sym_ref] = ACTIONS(1695),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(1201),
    [anon_sym_GT] = ACTIONS(1201),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1201),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1697),
    [anon_sym_TILDE] = ACTIONS(1699),
    [anon_sym_PLUS_PLUS] = ACTIONS(1699),
    [anon_sym_DASH_DASH] = ACTIONS(1699),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1697),
    [anon_sym_DASH] = ACTIONS(1697),
    [anon_sym_STAR] = ACTIONS(1701),
    [anon_sym_SLASH] = ACTIONS(1201),
    [anon_sym_PERCENT] = ACTIONS(1199),
    [anon_sym_CARET] = ACTIONS(1699),
    [anon_sym_PIPE] = ACTIONS(1201),
    [anon_sym_AMP] = ACTIONS(1697),
    [anon_sym_LT_LT] = ACTIONS(1199),
    [anon_sym_GT_GT] = ACTIONS(1201),
    [anon_sym_GT_GT_GT] = ACTIONS(1199),
    [anon_sym_EQ_EQ] = ACTIONS(1199),
    [anon_sym_BANG_EQ] = ACTIONS(1199),
    [anon_sym_GT_EQ] = ACTIONS(1199),
    [anon_sym_LT_EQ] = ACTIONS(1199),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_DOT] = ACTIONS(1201),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(1199),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1201),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1703),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1705),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_and] = ACTIONS(1201),
    [anon_sym_or] = ACTIONS(1201),
    [anon_sym_AMP_AMP] = ACTIONS(1199),
    [anon_sym_PIPE_PIPE] = ACTIONS(1199),
    [anon_sym_QMARK_QMARK] = ACTIONS(1199),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1201),
    [anon_sym_is] = ACTIONS(1201),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_DASH_GT] = ACTIONS(1199),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_with] = ACTIONS(1201),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [274] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6908),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2874),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7082),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5586),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4189),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7388),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9466),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(274),
    [sym_preproc_endregion] = STATE(274),
    [sym_preproc_line] = STATE(274),
    [sym_preproc_pragma] = STATE(274),
    [sym_preproc_nullable] = STATE(274),
    [sym_preproc_error] = STATE(274),
    [sym_preproc_define] = STATE(274),
    [sym_preproc_undef] = STATE(274),
    [aux_sym_class_declaration_repeat1] = STATE(3825),
    [aux_sym_lambda_expression_repeat1] = STATE(4178),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1743),
    [anon_sym_ref] = ACTIONS(1745),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1505),
    [anon_sym_LT] = ACTIONS(1147),
    [anon_sym_GT] = ACTIONS(1147),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1147),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1747),
    [anon_sym_TILDE] = ACTIONS(1749),
    [anon_sym_PLUS_PLUS] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1749),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1747),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_SLASH] = ACTIONS(1147),
    [anon_sym_PERCENT] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(1749),
    [anon_sym_PIPE] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(1747),
    [anon_sym_LT_LT] = ACTIONS(1133),
    [anon_sym_GT_GT] = ACTIONS(1147),
    [anon_sym_GT_GT_GT] = ACTIONS(1133),
    [anon_sym_EQ_EQ] = ACTIONS(1133),
    [anon_sym_BANG_EQ] = ACTIONS(1133),
    [anon_sym_GT_EQ] = ACTIONS(1133),
    [anon_sym_LT_EQ] = ACTIONS(1133),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_DOT] = ACTIONS(1147),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(1133),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1147),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1753),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1755),
    [anon_sym_DOT_DOT] = ACTIONS(1757),
    [anon_sym_and] = ACTIONS(1147),
    [anon_sym_or] = ACTIONS(1147),
    [anon_sym_AMP_AMP] = ACTIONS(1133),
    [anon_sym_PIPE_PIPE] = ACTIONS(1133),
    [anon_sym_QMARK_QMARK] = ACTIONS(1133),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1147),
    [anon_sym_is] = ACTIONS(1147),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_DASH_GT] = ACTIONS(1133),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_with] = ACTIONS(1147),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [275] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6914),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2882),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6963),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5222),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4002),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7386),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9254),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(275),
    [sym_preproc_endregion] = STATE(275),
    [sym_preproc_line] = STATE(275),
    [sym_preproc_pragma] = STATE(275),
    [sym_preproc_nullable] = STATE(275),
    [sym_preproc_error] = STATE(275),
    [sym_preproc_define] = STATE(275),
    [sym_preproc_undef] = STATE(275),
    [aux_sym_class_declaration_repeat1] = STATE(3797),
    [aux_sym_lambda_expression_repeat1] = STATE(4081),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1727),
    [anon_sym_ref] = ACTIONS(1729),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1713),
    [anon_sym_LT] = ACTIONS(1201),
    [anon_sym_GT] = ACTIONS(1201),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1201),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1731),
    [anon_sym_TILDE] = ACTIONS(1733),
    [anon_sym_PLUS_PLUS] = ACTIONS(1733),
    [anon_sym_DASH_DASH] = ACTIONS(1733),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1731),
    [anon_sym_DASH] = ACTIONS(1731),
    [anon_sym_STAR] = ACTIONS(1735),
    [anon_sym_SLASH] = ACTIONS(1201),
    [anon_sym_PERCENT] = ACTIONS(1199),
    [anon_sym_CARET] = ACTIONS(1733),
    [anon_sym_PIPE] = ACTIONS(1201),
    [anon_sym_AMP] = ACTIONS(1731),
    [anon_sym_LT_LT] = ACTIONS(1199),
    [anon_sym_GT_GT] = ACTIONS(1201),
    [anon_sym_GT_GT_GT] = ACTIONS(1199),
    [anon_sym_EQ_EQ] = ACTIONS(1199),
    [anon_sym_BANG_EQ] = ACTIONS(1199),
    [anon_sym_GT_EQ] = ACTIONS(1199),
    [anon_sym_LT_EQ] = ACTIONS(1199),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_DOT] = ACTIONS(1201),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(1199),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1201),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1737),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1739),
    [anon_sym_DOT_DOT] = ACTIONS(1741),
    [anon_sym_and] = ACTIONS(1201),
    [anon_sym_or] = ACTIONS(1201),
    [anon_sym_AMP_AMP] = ACTIONS(1199),
    [anon_sym_PIPE_PIPE] = ACTIONS(1199),
    [anon_sym_QMARK_QMARK] = ACTIONS(1199),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1201),
    [anon_sym_is] = ACTIONS(1201),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_DASH_GT] = ACTIONS(1199),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_with] = ACTIONS(1201),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [276] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3559),
    [sym__name] = STATE(6877),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2908),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7129),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4371),
    [sym_non_lvalue_expression] = STATE(4553),
    [sym_lvalue_expression] = STATE(3561),
    [sym__expression_statement_expression] = STATE(4559),
    [sym_assignment_expression] = STATE(4558),
    [sym_binary_expression] = STATE(4559),
    [sym_postfix_unary_expression] = STATE(4558),
    [sym_prefix_unary_expression] = STATE(4558),
    [sym__pointer_indirection_expression] = STATE(3560),
    [sym_query_expression] = STATE(4559),
    [sym_from_clause] = STATE(7385),
    [sym_conditional_expression] = STATE(4559),
    [sym_conditional_access_expression] = STATE(4559),
    [sym_as_expression] = STATE(4559),
    [sym_is_expression] = STATE(4559),
    [sym_is_pattern_expression] = STATE(4559),
    [sym_cast_expression] = STATE(4559),
    [sym_checked_expression] = STATE(4559),
    [sym_invocation_expression] = STATE(4558),
    [sym_switch_expression] = STATE(4559),
    [sym_await_expression] = STATE(4558),
    [sym_throw_expression] = STATE(4559),
    [sym_element_access_expression] = STATE(3560),
    [sym_interpolated_string_expression] = STATE(4559),
    [sym_member_access_expression] = STATE(3560),
    [sym_object_creation_expression] = STATE(4558),
    [sym_parenthesized_expression] = STATE(4558),
    [sym__parenthesized_lvalue_expression] = STATE(3560),
    [sym_lambda_expression] = STATE(4559),
    [sym__lambda_parameters] = STATE(9776),
    [sym_array_creation_expression] = STATE(4559),
    [sym_anonymous_method_expression] = STATE(4559),
    [sym_anonymous_object_creation_expression] = STATE(4559),
    [sym_implicit_array_creation_expression] = STATE(4559),
    [sym_implicit_object_creation_expression] = STATE(4559),
    [sym_implicit_stackalloc_expression] = STATE(4559),
    [sym_initializer_expression] = STATE(4559),
    [sym_default_expression] = STATE(4559),
    [sym_with_expression] = STATE(4559),
    [sym_sizeof_expression] = STATE(4559),
    [sym_typeof_expression] = STATE(4559),
    [sym_makeref_expression] = STATE(4559),
    [sym_ref_expression] = STATE(4559),
    [sym_reftype_expression] = STATE(4559),
    [sym_refvalue_expression] = STATE(4559),
    [sym_stackalloc_expression] = STATE(4559),
    [sym_range_expression] = STATE(4559),
    [sym_tuple_expression] = STATE(3560),
    [sym_literal] = STATE(4559),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4559),
    [sym_preproc_region] = STATE(276),
    [sym_preproc_endregion] = STATE(276),
    [sym_preproc_line] = STATE(276),
    [sym_preproc_pragma] = STATE(276),
    [sym_preproc_nullable] = STATE(276),
    [sym_preproc_error] = STATE(276),
    [sym_preproc_define] = STATE(276),
    [sym_preproc_undef] = STATE(276),
    [aux_sym_class_declaration_repeat1] = STATE(3843),
    [aux_sym_lambda_expression_repeat1] = STATE(4277),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_COMMA] = ACTIONS(1199),
    [anon_sym_LPAREN] = ACTIONS(1675),
    [anon_sym_ref] = ACTIONS(1677),
    [anon_sym_LBRACE] = ACTIONS(1611),
    [anon_sym_delegate] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1679),
    [anon_sym_LT] = ACTIONS(1201),
    [anon_sym_GT] = ACTIONS(1201),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1201),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(1681),
    [anon_sym_TILDE] = ACTIONS(1683),
    [anon_sym_PLUS_PLUS] = ACTIONS(1683),
    [anon_sym_DASH_DASH] = ACTIONS(1683),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_DASH] = ACTIONS(1681),
    [anon_sym_STAR] = ACTIONS(1685),
    [anon_sym_SLASH] = ACTIONS(1201),
    [anon_sym_PERCENT] = ACTIONS(1199),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PIPE] = ACTIONS(1201),
    [anon_sym_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1199),
    [anon_sym_GT_GT] = ACTIONS(1201),
    [anon_sym_GT_GT_GT] = ACTIONS(1199),
    [anon_sym_EQ_EQ] = ACTIONS(1199),
    [anon_sym_BANG_EQ] = ACTIONS(1199),
    [anon_sym_GT_EQ] = ACTIONS(1199),
    [anon_sym_LT_EQ] = ACTIONS(1199),
    [anon_sym_this] = ACTIONS(1627),
    [anon_sym_DOT] = ACTIONS(1201),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1629),
    [anon_sym_unchecked] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1201),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(1687),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1689),
    [anon_sym_DOT_DOT] = ACTIONS(1691),
    [anon_sym_and] = ACTIONS(1201),
    [anon_sym_or] = ACTIONS(1201),
    [anon_sym_AMP_AMP] = ACTIONS(1199),
    [anon_sym_PIPE_PIPE] = ACTIONS(1199),
    [anon_sym_QMARK_QMARK] = ACTIONS(1199),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1201),
    [anon_sym_is] = ACTIONS(1201),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_DASH_GT] = ACTIONS(1199),
    [anon_sym_stackalloc] = ACTIONS(1641),
    [anon_sym_with] = ACTIONS(1201),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(1647),
    [anon_sym___reftype] = ACTIONS(1649),
    [anon_sym___refvalue] = ACTIONS(1651),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1659),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [277] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6908),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2874),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7082),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5563),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4189),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7388),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9466),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(277),
    [sym_preproc_endregion] = STATE(277),
    [sym_preproc_line] = STATE(277),
    [sym_preproc_pragma] = STATE(277),
    [sym_preproc_nullable] = STATE(277),
    [sym_preproc_error] = STATE(277),
    [sym_preproc_define] = STATE(277),
    [sym_preproc_undef] = STATE(277),
    [aux_sym_class_declaration_repeat1] = STATE(3825),
    [aux_sym_lambda_expression_repeat1] = STATE(4178),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1743),
    [anon_sym_ref] = ACTIONS(1745),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1505),
    [anon_sym_LT] = ACTIONS(1201),
    [anon_sym_GT] = ACTIONS(1201),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1201),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1747),
    [anon_sym_TILDE] = ACTIONS(1749),
    [anon_sym_PLUS_PLUS] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1749),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1747),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_SLASH] = ACTIONS(1201),
    [anon_sym_PERCENT] = ACTIONS(1199),
    [anon_sym_CARET] = ACTIONS(1749),
    [anon_sym_PIPE] = ACTIONS(1201),
    [anon_sym_AMP] = ACTIONS(1747),
    [anon_sym_LT_LT] = ACTIONS(1199),
    [anon_sym_GT_GT] = ACTIONS(1201),
    [anon_sym_GT_GT_GT] = ACTIONS(1199),
    [anon_sym_EQ_EQ] = ACTIONS(1199),
    [anon_sym_BANG_EQ] = ACTIONS(1199),
    [anon_sym_GT_EQ] = ACTIONS(1199),
    [anon_sym_LT_EQ] = ACTIONS(1199),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_DOT] = ACTIONS(1201),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(1199),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1201),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1753),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1755),
    [anon_sym_DOT_DOT] = ACTIONS(1757),
    [anon_sym_and] = ACTIONS(1201),
    [anon_sym_or] = ACTIONS(1201),
    [anon_sym_AMP_AMP] = ACTIONS(1199),
    [anon_sym_PIPE_PIPE] = ACTIONS(1199),
    [anon_sym_QMARK_QMARK] = ACTIONS(1199),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1201),
    [anon_sym_is] = ACTIONS(1201),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_DASH_GT] = ACTIONS(1199),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_with] = ACTIONS(1201),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [278] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6909),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2874),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7062),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5469),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4291),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7411),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9300),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(278),
    [sym_preproc_endregion] = STATE(278),
    [sym_preproc_line] = STATE(278),
    [sym_preproc_pragma] = STATE(278),
    [sym_preproc_nullable] = STATE(278),
    [sym_preproc_error] = STATE(278),
    [sym_preproc_define] = STATE(278),
    [sym_preproc_undef] = STATE(278),
    [aux_sym_class_declaration_repeat1] = STATE(3804),
    [aux_sym_lambda_expression_repeat1] = STATE(4114),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_COLON] = ACTIONS(1133),
    [anon_sym_LPAREN] = ACTIONS(1501),
    [anon_sym_ref] = ACTIONS(1503),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1505),
    [anon_sym_LT] = ACTIONS(1147),
    [anon_sym_GT] = ACTIONS(1147),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1147),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1507),
    [anon_sym_TILDE] = ACTIONS(1509),
    [anon_sym_PLUS_PLUS] = ACTIONS(1509),
    [anon_sym_DASH_DASH] = ACTIONS(1509),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1507),
    [anon_sym_DASH] = ACTIONS(1507),
    [anon_sym_STAR] = ACTIONS(1511),
    [anon_sym_SLASH] = ACTIONS(1147),
    [anon_sym_PERCENT] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(1509),
    [anon_sym_PIPE] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(1507),
    [anon_sym_LT_LT] = ACTIONS(1133),
    [anon_sym_GT_GT] = ACTIONS(1147),
    [anon_sym_GT_GT_GT] = ACTIONS(1133),
    [anon_sym_EQ_EQ] = ACTIONS(1133),
    [anon_sym_BANG_EQ] = ACTIONS(1133),
    [anon_sym_GT_EQ] = ACTIONS(1133),
    [anon_sym_LT_EQ] = ACTIONS(1133),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_DOT] = ACTIONS(1147),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1147),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1513),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1515),
    [anon_sym_DOT_DOT] = ACTIONS(1517),
    [anon_sym_and] = ACTIONS(1147),
    [anon_sym_or] = ACTIONS(1147),
    [anon_sym_AMP_AMP] = ACTIONS(1133),
    [anon_sym_PIPE_PIPE] = ACTIONS(1133),
    [anon_sym_QMARK_QMARK] = ACTIONS(1133),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1147),
    [anon_sym_is] = ACTIONS(1147),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_DASH_GT] = ACTIONS(1133),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_with] = ACTIONS(1147),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [279] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6901),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2939),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7085),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5835),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4322),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7392),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9185),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(279),
    [sym_preproc_endregion] = STATE(279),
    [sym_preproc_line] = STATE(279),
    [sym_preproc_pragma] = STATE(279),
    [sym_preproc_nullable] = STATE(279),
    [sym_preproc_error] = STATE(279),
    [sym_preproc_define] = STATE(279),
    [sym_preproc_undef] = STATE(279),
    [aux_sym_class_declaration_repeat1] = STATE(3819),
    [aux_sym_lambda_expression_repeat1] = STATE(4161),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_ref] = ACTIONS(1761),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1763),
    [anon_sym_LT] = ACTIONS(1201),
    [anon_sym_GT] = ACTIONS(1201),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1201),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(1767),
    [anon_sym_PLUS_PLUS] = ACTIONS(1767),
    [anon_sym_DASH_DASH] = ACTIONS(1767),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1765),
    [anon_sym_STAR] = ACTIONS(1769),
    [anon_sym_SLASH] = ACTIONS(1201),
    [anon_sym_PERCENT] = ACTIONS(1199),
    [anon_sym_CARET] = ACTIONS(1767),
    [anon_sym_PIPE] = ACTIONS(1201),
    [anon_sym_AMP] = ACTIONS(1765),
    [anon_sym_LT_LT] = ACTIONS(1199),
    [anon_sym_GT_GT] = ACTIONS(1201),
    [anon_sym_GT_GT_GT] = ACTIONS(1199),
    [anon_sym_EQ_EQ] = ACTIONS(1199),
    [anon_sym_BANG_EQ] = ACTIONS(1199),
    [anon_sym_GT_EQ] = ACTIONS(1199),
    [anon_sym_LT_EQ] = ACTIONS(1199),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_DOT] = ACTIONS(1201),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1201),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1771),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1773),
    [anon_sym_DOT_DOT] = ACTIONS(1775),
    [anon_sym_and] = ACTIONS(1201),
    [anon_sym_or] = ACTIONS(1201),
    [anon_sym_AMP_AMP] = ACTIONS(1199),
    [anon_sym_PIPE_PIPE] = ACTIONS(1199),
    [anon_sym_QMARK_QMARK] = ACTIONS(1199),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1201),
    [anon_sym_is] = ACTIONS(1201),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_DASH_GT] = ACTIONS(1199),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_with] = ACTIONS(1201),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [280] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6874),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2968),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6941),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5705),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4214),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7412),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9154),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(280),
    [sym_preproc_endregion] = STATE(280),
    [sym_preproc_line] = STATE(280),
    [sym_preproc_pragma] = STATE(280),
    [sym_preproc_nullable] = STATE(280),
    [sym_preproc_error] = STATE(280),
    [sym_preproc_define] = STATE(280),
    [sym_preproc_undef] = STATE(280),
    [aux_sym_class_declaration_repeat1] = STATE(3798),
    [aux_sym_lambda_expression_repeat1] = STATE(4162),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1777),
    [anon_sym_ref] = ACTIONS(1779),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1781),
    [anon_sym_LT] = ACTIONS(1201),
    [anon_sym_GT] = ACTIONS(1201),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1201),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1785),
    [anon_sym_PLUS_PLUS] = ACTIONS(1785),
    [anon_sym_DASH_DASH] = ACTIONS(1785),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_STAR] = ACTIONS(1787),
    [anon_sym_SLASH] = ACTIONS(1201),
    [anon_sym_PERCENT] = ACTIONS(1199),
    [anon_sym_CARET] = ACTIONS(1785),
    [anon_sym_PIPE] = ACTIONS(1201),
    [anon_sym_AMP] = ACTIONS(1783),
    [anon_sym_LT_LT] = ACTIONS(1199),
    [anon_sym_GT_GT] = ACTIONS(1201),
    [anon_sym_GT_GT_GT] = ACTIONS(1199),
    [anon_sym_EQ_EQ] = ACTIONS(1199),
    [anon_sym_BANG_EQ] = ACTIONS(1199),
    [anon_sym_GT_EQ] = ACTIONS(1199),
    [anon_sym_LT_EQ] = ACTIONS(1199),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_DOT] = ACTIONS(1201),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1201),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1789),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1791),
    [anon_sym_DOT_DOT] = ACTIONS(1793),
    [anon_sym_and] = ACTIONS(1201),
    [anon_sym_or] = ACTIONS(1201),
    [anon_sym_AMP_AMP] = ACTIONS(1199),
    [anon_sym_PIPE_PIPE] = ACTIONS(1199),
    [anon_sym_QMARK_QMARK] = ACTIONS(1199),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1201),
    [anon_sym_is] = ACTIONS(1201),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_DASH_GT] = ACTIONS(1199),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_with] = ACTIONS(1201),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [281] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6910),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2957),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6984),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4930),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(3777),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7387),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9385),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(281),
    [sym_preproc_endregion] = STATE(281),
    [sym_preproc_line] = STATE(281),
    [sym_preproc_pragma] = STATE(281),
    [sym_preproc_nullable] = STATE(281),
    [sym_preproc_error] = STATE(281),
    [sym_preproc_define] = STATE(281),
    [sym_preproc_undef] = STATE(281),
    [aux_sym_class_declaration_repeat1] = STATE(3793),
    [aux_sym_lambda_expression_repeat1] = STATE(4083),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1795),
    [anon_sym_ref] = ACTIONS(1797),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1799),
    [anon_sym_LT] = ACTIONS(1201),
    [anon_sym_GT] = ACTIONS(1201),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1201),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1801),
    [anon_sym_TILDE] = ACTIONS(1803),
    [anon_sym_PLUS_PLUS] = ACTIONS(1803),
    [anon_sym_DASH_DASH] = ACTIONS(1803),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1801),
    [anon_sym_DASH] = ACTIONS(1801),
    [anon_sym_STAR] = ACTIONS(1805),
    [anon_sym_SLASH] = ACTIONS(1201),
    [anon_sym_PERCENT] = ACTIONS(1199),
    [anon_sym_CARET] = ACTIONS(1803),
    [anon_sym_PIPE] = ACTIONS(1201),
    [anon_sym_AMP] = ACTIONS(1801),
    [anon_sym_LT_LT] = ACTIONS(1199),
    [anon_sym_GT_GT] = ACTIONS(1201),
    [anon_sym_GT_GT_GT] = ACTIONS(1199),
    [anon_sym_EQ_EQ] = ACTIONS(1199),
    [anon_sym_BANG_EQ] = ACTIONS(1199),
    [anon_sym_GT_EQ] = ACTIONS(1199),
    [anon_sym_LT_EQ] = ACTIONS(1199),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(1201),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1201),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1807),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1809),
    [anon_sym_DOT_DOT] = ACTIONS(1811),
    [anon_sym_and] = ACTIONS(1201),
    [anon_sym_or] = ACTIONS(1201),
    [anon_sym_AMP_AMP] = ACTIONS(1199),
    [anon_sym_PIPE_PIPE] = ACTIONS(1199),
    [anon_sym_QMARK_QMARK] = ACTIONS(1199),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1201),
    [anon_sym_is] = ACTIONS(1201),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_DASH_GT] = ACTIONS(1199),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_with] = ACTIONS(1201),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [282] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6901),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2939),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7085),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5830),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4322),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7392),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9185),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(282),
    [sym_preproc_endregion] = STATE(282),
    [sym_preproc_line] = STATE(282),
    [sym_preproc_pragma] = STATE(282),
    [sym_preproc_nullable] = STATE(282),
    [sym_preproc_error] = STATE(282),
    [sym_preproc_define] = STATE(282),
    [sym_preproc_undef] = STATE(282),
    [aux_sym_class_declaration_repeat1] = STATE(3819),
    [aux_sym_lambda_expression_repeat1] = STATE(4161),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_ref] = ACTIONS(1761),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1763),
    [anon_sym_LT] = ACTIONS(1147),
    [anon_sym_GT] = ACTIONS(1147),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1147),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(1767),
    [anon_sym_PLUS_PLUS] = ACTIONS(1767),
    [anon_sym_DASH_DASH] = ACTIONS(1767),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1765),
    [anon_sym_STAR] = ACTIONS(1769),
    [anon_sym_SLASH] = ACTIONS(1147),
    [anon_sym_PERCENT] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(1767),
    [anon_sym_PIPE] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(1765),
    [anon_sym_LT_LT] = ACTIONS(1133),
    [anon_sym_GT_GT] = ACTIONS(1147),
    [anon_sym_GT_GT_GT] = ACTIONS(1133),
    [anon_sym_EQ_EQ] = ACTIONS(1133),
    [anon_sym_BANG_EQ] = ACTIONS(1133),
    [anon_sym_GT_EQ] = ACTIONS(1133),
    [anon_sym_LT_EQ] = ACTIONS(1133),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_DOT] = ACTIONS(1147),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1147),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1771),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1773),
    [anon_sym_DOT_DOT] = ACTIONS(1775),
    [anon_sym_and] = ACTIONS(1147),
    [anon_sym_or] = ACTIONS(1147),
    [anon_sym_AMP_AMP] = ACTIONS(1133),
    [anon_sym_PIPE_PIPE] = ACTIONS(1133),
    [anon_sym_QMARK_QMARK] = ACTIONS(1133),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1147),
    [anon_sym_is] = ACTIONS(1147),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_DASH_GT] = ACTIONS(1133),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_with] = ACTIONS(1147),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [283] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6881),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2964),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7109),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5754),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4326),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7394),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9186),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(283),
    [sym_preproc_endregion] = STATE(283),
    [sym_preproc_line] = STATE(283),
    [sym_preproc_pragma] = STATE(283),
    [sym_preproc_nullable] = STATE(283),
    [sym_preproc_error] = STATE(283),
    [sym_preproc_define] = STATE(283),
    [sym_preproc_undef] = STATE(283),
    [aux_sym_class_declaration_repeat1] = STATE(3828),
    [aux_sym_lambda_expression_repeat1] = STATE(4180),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1813),
    [anon_sym_ref] = ACTIONS(1815),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1817),
    [anon_sym_LT] = ACTIONS(1201),
    [anon_sym_GT] = ACTIONS(1201),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1201),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1819),
    [anon_sym_TILDE] = ACTIONS(1821),
    [anon_sym_PLUS_PLUS] = ACTIONS(1821),
    [anon_sym_DASH_DASH] = ACTIONS(1821),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1819),
    [anon_sym_DASH] = ACTIONS(1819),
    [anon_sym_STAR] = ACTIONS(1823),
    [anon_sym_SLASH] = ACTIONS(1201),
    [anon_sym_PERCENT] = ACTIONS(1199),
    [anon_sym_CARET] = ACTIONS(1821),
    [anon_sym_PIPE] = ACTIONS(1201),
    [anon_sym_AMP] = ACTIONS(1819),
    [anon_sym_LT_LT] = ACTIONS(1199),
    [anon_sym_GT_GT] = ACTIONS(1201),
    [anon_sym_GT_GT_GT] = ACTIONS(1199),
    [anon_sym_EQ_EQ] = ACTIONS(1199),
    [anon_sym_BANG_EQ] = ACTIONS(1199),
    [anon_sym_GT_EQ] = ACTIONS(1199),
    [anon_sym_LT_EQ] = ACTIONS(1199),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_DOT] = ACTIONS(1201),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1201),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1825),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1827),
    [anon_sym_DOT_DOT] = ACTIONS(1829),
    [anon_sym_and] = ACTIONS(1201),
    [anon_sym_or] = ACTIONS(1201),
    [anon_sym_AMP_AMP] = ACTIONS(1199),
    [anon_sym_PIPE_PIPE] = ACTIONS(1199),
    [anon_sym_QMARK_QMARK] = ACTIONS(1199),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1201),
    [anon_sym_is] = ACTIONS(1201),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_DASH_GT] = ACTIONS(1199),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_with] = ACTIONS(1201),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [284] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6896),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2944),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6952),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5697),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4248),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7396),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9160),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(284),
    [sym_preproc_endregion] = STATE(284),
    [sym_preproc_line] = STATE(284),
    [sym_preproc_pragma] = STATE(284),
    [sym_preproc_nullable] = STATE(284),
    [sym_preproc_error] = STATE(284),
    [sym_preproc_define] = STATE(284),
    [sym_preproc_undef] = STATE(284),
    [aux_sym_class_declaration_repeat1] = STATE(3795),
    [aux_sym_lambda_expression_repeat1] = STATE(4144),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1831),
    [anon_sym_ref] = ACTIONS(1833),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1835),
    [anon_sym_LT] = ACTIONS(1201),
    [anon_sym_GT] = ACTIONS(1201),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1201),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1837),
    [anon_sym_TILDE] = ACTIONS(1839),
    [anon_sym_PLUS_PLUS] = ACTIONS(1839),
    [anon_sym_DASH_DASH] = ACTIONS(1839),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1837),
    [anon_sym_DASH] = ACTIONS(1837),
    [anon_sym_STAR] = ACTIONS(1841),
    [anon_sym_SLASH] = ACTIONS(1201),
    [anon_sym_PERCENT] = ACTIONS(1199),
    [anon_sym_CARET] = ACTIONS(1839),
    [anon_sym_PIPE] = ACTIONS(1201),
    [anon_sym_AMP] = ACTIONS(1837),
    [anon_sym_LT_LT] = ACTIONS(1199),
    [anon_sym_GT_GT] = ACTIONS(1201),
    [anon_sym_GT_GT_GT] = ACTIONS(1199),
    [anon_sym_EQ_EQ] = ACTIONS(1199),
    [anon_sym_BANG_EQ] = ACTIONS(1199),
    [anon_sym_GT_EQ] = ACTIONS(1199),
    [anon_sym_LT_EQ] = ACTIONS(1199),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_DOT] = ACTIONS(1201),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1201),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1843),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1845),
    [anon_sym_DOT_DOT] = ACTIONS(1847),
    [anon_sym_and] = ACTIONS(1201),
    [anon_sym_or] = ACTIONS(1201),
    [anon_sym_AMP_AMP] = ACTIONS(1199),
    [anon_sym_PIPE_PIPE] = ACTIONS(1199),
    [anon_sym_QMARK_QMARK] = ACTIONS(1199),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1201),
    [anon_sym_is] = ACTIONS(1201),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_DASH_GT] = ACTIONS(1199),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_with] = ACTIONS(1201),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [285] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6896),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2944),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6952),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5668),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4248),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7396),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9160),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(285),
    [sym_preproc_endregion] = STATE(285),
    [sym_preproc_line] = STATE(285),
    [sym_preproc_pragma] = STATE(285),
    [sym_preproc_nullable] = STATE(285),
    [sym_preproc_error] = STATE(285),
    [sym_preproc_define] = STATE(285),
    [sym_preproc_undef] = STATE(285),
    [aux_sym_class_declaration_repeat1] = STATE(3795),
    [aux_sym_lambda_expression_repeat1] = STATE(4144),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1831),
    [anon_sym_ref] = ACTIONS(1833),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1835),
    [anon_sym_LT] = ACTIONS(1147),
    [anon_sym_GT] = ACTIONS(1147),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1147),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1837),
    [anon_sym_TILDE] = ACTIONS(1839),
    [anon_sym_PLUS_PLUS] = ACTIONS(1839),
    [anon_sym_DASH_DASH] = ACTIONS(1839),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1837),
    [anon_sym_DASH] = ACTIONS(1837),
    [anon_sym_STAR] = ACTIONS(1841),
    [anon_sym_SLASH] = ACTIONS(1147),
    [anon_sym_PERCENT] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(1839),
    [anon_sym_PIPE] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(1837),
    [anon_sym_LT_LT] = ACTIONS(1133),
    [anon_sym_GT_GT] = ACTIONS(1147),
    [anon_sym_GT_GT_GT] = ACTIONS(1133),
    [anon_sym_EQ_EQ] = ACTIONS(1133),
    [anon_sym_BANG_EQ] = ACTIONS(1133),
    [anon_sym_GT_EQ] = ACTIONS(1133),
    [anon_sym_LT_EQ] = ACTIONS(1133),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_DOT] = ACTIONS(1147),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1147),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1843),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1845),
    [anon_sym_DOT_DOT] = ACTIONS(1847),
    [anon_sym_and] = ACTIONS(1147),
    [anon_sym_or] = ACTIONS(1147),
    [anon_sym_AMP_AMP] = ACTIONS(1133),
    [anon_sym_PIPE_PIPE] = ACTIONS(1133),
    [anon_sym_QMARK_QMARK] = ACTIONS(1133),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1147),
    [anon_sym_is] = ACTIONS(1147),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_DASH_GT] = ACTIONS(1133),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_with] = ACTIONS(1147),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [286] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6894),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2955),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7025),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4871),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(3735),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7397),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9590),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(286),
    [sym_preproc_endregion] = STATE(286),
    [sym_preproc_line] = STATE(286),
    [sym_preproc_pragma] = STATE(286),
    [sym_preproc_nullable] = STATE(286),
    [sym_preproc_error] = STATE(286),
    [sym_preproc_define] = STATE(286),
    [sym_preproc_undef] = STATE(286),
    [aux_sym_class_declaration_repeat1] = STATE(3844),
    [aux_sym_lambda_expression_repeat1] = STATE(4245),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1849),
    [anon_sym_ref] = ACTIONS(1851),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1853),
    [anon_sym_LT] = ACTIONS(1147),
    [anon_sym_GT] = ACTIONS(1147),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1147),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1855),
    [anon_sym_TILDE] = ACTIONS(1857),
    [anon_sym_PLUS_PLUS] = ACTIONS(1857),
    [anon_sym_DASH_DASH] = ACTIONS(1857),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1855),
    [anon_sym_DASH] = ACTIONS(1855),
    [anon_sym_STAR] = ACTIONS(1859),
    [anon_sym_SLASH] = ACTIONS(1147),
    [anon_sym_PERCENT] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(1857),
    [anon_sym_PIPE] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(1855),
    [anon_sym_LT_LT] = ACTIONS(1133),
    [anon_sym_GT_GT] = ACTIONS(1147),
    [anon_sym_GT_GT_GT] = ACTIONS(1133),
    [anon_sym_EQ_EQ] = ACTIONS(1133),
    [anon_sym_BANG_EQ] = ACTIONS(1133),
    [anon_sym_GT_EQ] = ACTIONS(1133),
    [anon_sym_LT_EQ] = ACTIONS(1133),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_DOT] = ACTIONS(1147),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1147),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1861),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1863),
    [anon_sym_DOT_DOT] = ACTIONS(1865),
    [anon_sym_and] = ACTIONS(1147),
    [anon_sym_or] = ACTIONS(1147),
    [anon_sym_AMP_AMP] = ACTIONS(1133),
    [anon_sym_PIPE_PIPE] = ACTIONS(1133),
    [anon_sym_QMARK_QMARK] = ACTIONS(1133),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1147),
    [anon_sym_is] = ACTIONS(1147),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_DASH_GT] = ACTIONS(1133),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_with] = ACTIONS(1147),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [287] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6879),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2935),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7096),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5683),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4288),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7379),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9175),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(287),
    [sym_preproc_endregion] = STATE(287),
    [sym_preproc_line] = STATE(287),
    [sym_preproc_pragma] = STATE(287),
    [sym_preproc_nullable] = STATE(287),
    [sym_preproc_error] = STATE(287),
    [sym_preproc_define] = STATE(287),
    [sym_preproc_undef] = STATE(287),
    [aux_sym_class_declaration_repeat1] = STATE(3816),
    [aux_sym_lambda_expression_repeat1] = STATE(4119),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1867),
    [anon_sym_ref] = ACTIONS(1869),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1871),
    [anon_sym_LT] = ACTIONS(1201),
    [anon_sym_GT] = ACTIONS(1201),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1201),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1873),
    [anon_sym_TILDE] = ACTIONS(1875),
    [anon_sym_PLUS_PLUS] = ACTIONS(1875),
    [anon_sym_DASH_DASH] = ACTIONS(1875),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1873),
    [anon_sym_DASH] = ACTIONS(1873),
    [anon_sym_STAR] = ACTIONS(1877),
    [anon_sym_SLASH] = ACTIONS(1201),
    [anon_sym_PERCENT] = ACTIONS(1199),
    [anon_sym_CARET] = ACTIONS(1875),
    [anon_sym_PIPE] = ACTIONS(1201),
    [anon_sym_AMP] = ACTIONS(1873),
    [anon_sym_LT_LT] = ACTIONS(1199),
    [anon_sym_GT_GT] = ACTIONS(1201),
    [anon_sym_GT_GT_GT] = ACTIONS(1199),
    [anon_sym_EQ_EQ] = ACTIONS(1199),
    [anon_sym_BANG_EQ] = ACTIONS(1199),
    [anon_sym_GT_EQ] = ACTIONS(1199),
    [anon_sym_LT_EQ] = ACTIONS(1199),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_DOT] = ACTIONS(1201),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1201),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1879),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1881),
    [anon_sym_DOT_DOT] = ACTIONS(1883),
    [anon_sym_and] = ACTIONS(1201),
    [anon_sym_or] = ACTIONS(1201),
    [anon_sym_AMP_AMP] = ACTIONS(1199),
    [anon_sym_PIPE_PIPE] = ACTIONS(1199),
    [anon_sym_QMARK_QMARK] = ACTIONS(1199),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1201),
    [anon_sym_is] = ACTIONS(1201),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_DASH_GT] = ACTIONS(1199),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_with] = ACTIONS(1201),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [288] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6910),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2957),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6984),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4933),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(3777),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7387),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9385),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(288),
    [sym_preproc_endregion] = STATE(288),
    [sym_preproc_line] = STATE(288),
    [sym_preproc_pragma] = STATE(288),
    [sym_preproc_nullable] = STATE(288),
    [sym_preproc_error] = STATE(288),
    [sym_preproc_define] = STATE(288),
    [sym_preproc_undef] = STATE(288),
    [aux_sym_class_declaration_repeat1] = STATE(3793),
    [aux_sym_lambda_expression_repeat1] = STATE(4083),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1795),
    [anon_sym_ref] = ACTIONS(1797),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1799),
    [anon_sym_LT] = ACTIONS(1147),
    [anon_sym_GT] = ACTIONS(1147),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1147),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1801),
    [anon_sym_TILDE] = ACTIONS(1803),
    [anon_sym_PLUS_PLUS] = ACTIONS(1803),
    [anon_sym_DASH_DASH] = ACTIONS(1803),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1801),
    [anon_sym_DASH] = ACTIONS(1801),
    [anon_sym_STAR] = ACTIONS(1805),
    [anon_sym_SLASH] = ACTIONS(1147),
    [anon_sym_PERCENT] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(1803),
    [anon_sym_PIPE] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(1801),
    [anon_sym_LT_LT] = ACTIONS(1133),
    [anon_sym_GT_GT] = ACTIONS(1147),
    [anon_sym_GT_GT_GT] = ACTIONS(1133),
    [anon_sym_EQ_EQ] = ACTIONS(1133),
    [anon_sym_BANG_EQ] = ACTIONS(1133),
    [anon_sym_GT_EQ] = ACTIONS(1133),
    [anon_sym_LT_EQ] = ACTIONS(1133),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(1147),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1147),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1807),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1809),
    [anon_sym_DOT_DOT] = ACTIONS(1811),
    [anon_sym_and] = ACTIONS(1147),
    [anon_sym_or] = ACTIONS(1147),
    [anon_sym_AMP_AMP] = ACTIONS(1133),
    [anon_sym_PIPE_PIPE] = ACTIONS(1133),
    [anon_sym_QMARK_QMARK] = ACTIONS(1133),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1147),
    [anon_sym_is] = ACTIONS(1147),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_DASH_GT] = ACTIONS(1133),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_with] = ACTIONS(1147),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [289] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6898),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2940),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6936),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5850),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4318),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7401),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9262),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(289),
    [sym_preproc_endregion] = STATE(289),
    [sym_preproc_line] = STATE(289),
    [sym_preproc_pragma] = STATE(289),
    [sym_preproc_nullable] = STATE(289),
    [sym_preproc_error] = STATE(289),
    [sym_preproc_define] = STATE(289),
    [sym_preproc_undef] = STATE(289),
    [aux_sym_class_declaration_repeat1] = STATE(3815),
    [aux_sym_lambda_expression_repeat1] = STATE(4072),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1885),
    [anon_sym_ref] = ACTIONS(1887),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1889),
    [anon_sym_LT] = ACTIONS(1201),
    [anon_sym_GT] = ACTIONS(1201),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1201),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1891),
    [anon_sym_TILDE] = ACTIONS(1893),
    [anon_sym_PLUS_PLUS] = ACTIONS(1893),
    [anon_sym_DASH_DASH] = ACTIONS(1893),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1891),
    [anon_sym_DASH] = ACTIONS(1891),
    [anon_sym_STAR] = ACTIONS(1895),
    [anon_sym_SLASH] = ACTIONS(1201),
    [anon_sym_PERCENT] = ACTIONS(1199),
    [anon_sym_CARET] = ACTIONS(1893),
    [anon_sym_PIPE] = ACTIONS(1201),
    [anon_sym_AMP] = ACTIONS(1891),
    [anon_sym_LT_LT] = ACTIONS(1199),
    [anon_sym_GT_GT] = ACTIONS(1201),
    [anon_sym_GT_GT_GT] = ACTIONS(1199),
    [anon_sym_EQ_EQ] = ACTIONS(1199),
    [anon_sym_BANG_EQ] = ACTIONS(1199),
    [anon_sym_GT_EQ] = ACTIONS(1199),
    [anon_sym_LT_EQ] = ACTIONS(1199),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_DOT] = ACTIONS(1201),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1201),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1897),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1899),
    [anon_sym_DOT_DOT] = ACTIONS(1901),
    [anon_sym_and] = ACTIONS(1201),
    [anon_sym_or] = ACTIONS(1201),
    [anon_sym_AMP_AMP] = ACTIONS(1199),
    [anon_sym_PIPE_PIPE] = ACTIONS(1199),
    [anon_sym_QMARK_QMARK] = ACTIONS(1199),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1201),
    [anon_sym_is] = ACTIONS(1201),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_DASH_GT] = ACTIONS(1199),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_with] = ACTIONS(1201),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [290] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6879),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2935),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7096),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5525),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4288),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7379),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9175),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(290),
    [sym_preproc_endregion] = STATE(290),
    [sym_preproc_line] = STATE(290),
    [sym_preproc_pragma] = STATE(290),
    [sym_preproc_nullable] = STATE(290),
    [sym_preproc_error] = STATE(290),
    [sym_preproc_define] = STATE(290),
    [sym_preproc_undef] = STATE(290),
    [aux_sym_class_declaration_repeat1] = STATE(3816),
    [aux_sym_lambda_expression_repeat1] = STATE(4119),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1867),
    [anon_sym_ref] = ACTIONS(1869),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1871),
    [anon_sym_LT] = ACTIONS(1147),
    [anon_sym_GT] = ACTIONS(1147),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1147),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1873),
    [anon_sym_TILDE] = ACTIONS(1875),
    [anon_sym_PLUS_PLUS] = ACTIONS(1875),
    [anon_sym_DASH_DASH] = ACTIONS(1875),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1873),
    [anon_sym_DASH] = ACTIONS(1873),
    [anon_sym_STAR] = ACTIONS(1877),
    [anon_sym_SLASH] = ACTIONS(1147),
    [anon_sym_PERCENT] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(1875),
    [anon_sym_PIPE] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(1873),
    [anon_sym_LT_LT] = ACTIONS(1133),
    [anon_sym_GT_GT] = ACTIONS(1147),
    [anon_sym_GT_GT_GT] = ACTIONS(1133),
    [anon_sym_EQ_EQ] = ACTIONS(1133),
    [anon_sym_BANG_EQ] = ACTIONS(1133),
    [anon_sym_GT_EQ] = ACTIONS(1133),
    [anon_sym_LT_EQ] = ACTIONS(1133),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_DOT] = ACTIONS(1147),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1147),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1879),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1881),
    [anon_sym_DOT_DOT] = ACTIONS(1883),
    [anon_sym_and] = ACTIONS(1147),
    [anon_sym_or] = ACTIONS(1147),
    [anon_sym_AMP_AMP] = ACTIONS(1133),
    [anon_sym_PIPE_PIPE] = ACTIONS(1133),
    [anon_sym_QMARK_QMARK] = ACTIONS(1133),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1147),
    [anon_sym_is] = ACTIONS(1147),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_DASH_GT] = ACTIONS(1133),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_with] = ACTIONS(1147),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [291] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6881),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2964),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7109),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5895),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4326),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7394),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9186),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(291),
    [sym_preproc_endregion] = STATE(291),
    [sym_preproc_line] = STATE(291),
    [sym_preproc_pragma] = STATE(291),
    [sym_preproc_nullable] = STATE(291),
    [sym_preproc_error] = STATE(291),
    [sym_preproc_define] = STATE(291),
    [sym_preproc_undef] = STATE(291),
    [aux_sym_class_declaration_repeat1] = STATE(3828),
    [aux_sym_lambda_expression_repeat1] = STATE(4180),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1813),
    [anon_sym_ref] = ACTIONS(1815),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1817),
    [anon_sym_LT] = ACTIONS(1147),
    [anon_sym_GT] = ACTIONS(1147),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1147),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1819),
    [anon_sym_TILDE] = ACTIONS(1821),
    [anon_sym_PLUS_PLUS] = ACTIONS(1821),
    [anon_sym_DASH_DASH] = ACTIONS(1821),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1819),
    [anon_sym_DASH] = ACTIONS(1819),
    [anon_sym_STAR] = ACTIONS(1823),
    [anon_sym_SLASH] = ACTIONS(1147),
    [anon_sym_PERCENT] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(1821),
    [anon_sym_PIPE] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(1819),
    [anon_sym_LT_LT] = ACTIONS(1133),
    [anon_sym_GT_GT] = ACTIONS(1147),
    [anon_sym_GT_GT_GT] = ACTIONS(1133),
    [anon_sym_EQ_EQ] = ACTIONS(1133),
    [anon_sym_BANG_EQ] = ACTIONS(1133),
    [anon_sym_GT_EQ] = ACTIONS(1133),
    [anon_sym_LT_EQ] = ACTIONS(1133),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_DOT] = ACTIONS(1147),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1147),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1825),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1827),
    [anon_sym_DOT_DOT] = ACTIONS(1829),
    [anon_sym_and] = ACTIONS(1147),
    [anon_sym_or] = ACTIONS(1147),
    [anon_sym_AMP_AMP] = ACTIONS(1133),
    [anon_sym_PIPE_PIPE] = ACTIONS(1133),
    [anon_sym_QMARK_QMARK] = ACTIONS(1133),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1147),
    [anon_sym_is] = ACTIONS(1147),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_DASH_GT] = ACTIONS(1133),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_with] = ACTIONS(1147),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [292] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6898),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2940),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6936),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5787),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4318),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7401),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9262),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(292),
    [sym_preproc_endregion] = STATE(292),
    [sym_preproc_line] = STATE(292),
    [sym_preproc_pragma] = STATE(292),
    [sym_preproc_nullable] = STATE(292),
    [sym_preproc_error] = STATE(292),
    [sym_preproc_define] = STATE(292),
    [sym_preproc_undef] = STATE(292),
    [aux_sym_class_declaration_repeat1] = STATE(3815),
    [aux_sym_lambda_expression_repeat1] = STATE(4072),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1885),
    [anon_sym_ref] = ACTIONS(1887),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1889),
    [anon_sym_LT] = ACTIONS(1147),
    [anon_sym_GT] = ACTIONS(1147),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1147),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1891),
    [anon_sym_TILDE] = ACTIONS(1893),
    [anon_sym_PLUS_PLUS] = ACTIONS(1893),
    [anon_sym_DASH_DASH] = ACTIONS(1893),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1891),
    [anon_sym_DASH] = ACTIONS(1891),
    [anon_sym_STAR] = ACTIONS(1895),
    [anon_sym_SLASH] = ACTIONS(1147),
    [anon_sym_PERCENT] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(1893),
    [anon_sym_PIPE] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(1891),
    [anon_sym_LT_LT] = ACTIONS(1133),
    [anon_sym_GT_GT] = ACTIONS(1147),
    [anon_sym_GT_GT_GT] = ACTIONS(1133),
    [anon_sym_EQ_EQ] = ACTIONS(1133),
    [anon_sym_BANG_EQ] = ACTIONS(1133),
    [anon_sym_GT_EQ] = ACTIONS(1133),
    [anon_sym_LT_EQ] = ACTIONS(1133),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_DOT] = ACTIONS(1147),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1147),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1897),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1899),
    [anon_sym_DOT_DOT] = ACTIONS(1901),
    [anon_sym_and] = ACTIONS(1147),
    [anon_sym_or] = ACTIONS(1147),
    [anon_sym_AMP_AMP] = ACTIONS(1133),
    [anon_sym_PIPE_PIPE] = ACTIONS(1133),
    [anon_sym_QMARK_QMARK] = ACTIONS(1133),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1147),
    [anon_sym_is] = ACTIONS(1147),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_DASH_GT] = ACTIONS(1133),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_with] = ACTIONS(1147),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [293] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6894),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2955),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7025),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4831),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(3735),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7397),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9590),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(293),
    [sym_preproc_endregion] = STATE(293),
    [sym_preproc_line] = STATE(293),
    [sym_preproc_pragma] = STATE(293),
    [sym_preproc_nullable] = STATE(293),
    [sym_preproc_error] = STATE(293),
    [sym_preproc_define] = STATE(293),
    [sym_preproc_undef] = STATE(293),
    [aux_sym_class_declaration_repeat1] = STATE(3844),
    [aux_sym_lambda_expression_repeat1] = STATE(4245),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1849),
    [anon_sym_ref] = ACTIONS(1851),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1853),
    [anon_sym_LT] = ACTIONS(1201),
    [anon_sym_GT] = ACTIONS(1201),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1201),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1855),
    [anon_sym_TILDE] = ACTIONS(1857),
    [anon_sym_PLUS_PLUS] = ACTIONS(1857),
    [anon_sym_DASH_DASH] = ACTIONS(1857),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1855),
    [anon_sym_DASH] = ACTIONS(1855),
    [anon_sym_STAR] = ACTIONS(1859),
    [anon_sym_SLASH] = ACTIONS(1201),
    [anon_sym_PERCENT] = ACTIONS(1199),
    [anon_sym_CARET] = ACTIONS(1857),
    [anon_sym_PIPE] = ACTIONS(1201),
    [anon_sym_AMP] = ACTIONS(1855),
    [anon_sym_LT_LT] = ACTIONS(1199),
    [anon_sym_GT_GT] = ACTIONS(1201),
    [anon_sym_GT_GT_GT] = ACTIONS(1199),
    [anon_sym_EQ_EQ] = ACTIONS(1199),
    [anon_sym_BANG_EQ] = ACTIONS(1199),
    [anon_sym_GT_EQ] = ACTIONS(1199),
    [anon_sym_LT_EQ] = ACTIONS(1199),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_DOT] = ACTIONS(1201),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1201),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1861),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1863),
    [anon_sym_DOT_DOT] = ACTIONS(1865),
    [anon_sym_and] = ACTIONS(1201),
    [anon_sym_or] = ACTIONS(1201),
    [anon_sym_AMP_AMP] = ACTIONS(1199),
    [anon_sym_PIPE_PIPE] = ACTIONS(1199),
    [anon_sym_QMARK_QMARK] = ACTIONS(1199),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1201),
    [anon_sym_is] = ACTIONS(1201),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_DASH_GT] = ACTIONS(1199),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_with] = ACTIONS(1201),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [294] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6874),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2968),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6941),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5747),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4214),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7412),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9154),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(294),
    [sym_preproc_endregion] = STATE(294),
    [sym_preproc_line] = STATE(294),
    [sym_preproc_pragma] = STATE(294),
    [sym_preproc_nullable] = STATE(294),
    [sym_preproc_error] = STATE(294),
    [sym_preproc_define] = STATE(294),
    [sym_preproc_undef] = STATE(294),
    [aux_sym_class_declaration_repeat1] = STATE(3798),
    [aux_sym_lambda_expression_repeat1] = STATE(4162),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1777),
    [anon_sym_ref] = ACTIONS(1779),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1781),
    [anon_sym_LT] = ACTIONS(1147),
    [anon_sym_GT] = ACTIONS(1147),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1147),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1785),
    [anon_sym_PLUS_PLUS] = ACTIONS(1785),
    [anon_sym_DASH_DASH] = ACTIONS(1785),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_STAR] = ACTIONS(1787),
    [anon_sym_SLASH] = ACTIONS(1147),
    [anon_sym_PERCENT] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(1785),
    [anon_sym_PIPE] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(1783),
    [anon_sym_LT_LT] = ACTIONS(1133),
    [anon_sym_GT_GT] = ACTIONS(1147),
    [anon_sym_GT_GT_GT] = ACTIONS(1133),
    [anon_sym_EQ_EQ] = ACTIONS(1133),
    [anon_sym_BANG_EQ] = ACTIONS(1133),
    [anon_sym_GT_EQ] = ACTIONS(1133),
    [anon_sym_LT_EQ] = ACTIONS(1133),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_DOT] = ACTIONS(1147),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1147),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1789),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1791),
    [anon_sym_DOT_DOT] = ACTIONS(1793),
    [anon_sym_and] = ACTIONS(1147),
    [anon_sym_or] = ACTIONS(1147),
    [anon_sym_AMP_AMP] = ACTIONS(1133),
    [anon_sym_PIPE_PIPE] = ACTIONS(1133),
    [anon_sym_QMARK_QMARK] = ACTIONS(1133),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1147),
    [anon_sym_is] = ACTIONS(1147),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_DASH_GT] = ACTIONS(1133),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_with] = ACTIONS(1147),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [295] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7094),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5801),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(295),
    [sym_preproc_endregion] = STATE(295),
    [sym_preproc_line] = STATE(295),
    [sym_preproc_pragma] = STATE(295),
    [sym_preproc_nullable] = STATE(295),
    [sym_preproc_error] = STATE(295),
    [sym_preproc_define] = STATE(295),
    [sym_preproc_undef] = STATE(295),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_COMMA] = ACTIONS(1903),
    [anon_sym_RBRACK] = ACTIONS(1903),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(1201),
    [anon_sym_GT] = ACTIONS(1201),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1201),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1667),
    [anon_sym_TILDE] = ACTIONS(1669),
    [anon_sym_PLUS_PLUS] = ACTIONS(1669),
    [anon_sym_DASH_DASH] = ACTIONS(1669),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1667),
    [anon_sym_DASH] = ACTIONS(1667),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_SLASH] = ACTIONS(1201),
    [anon_sym_PERCENT] = ACTIONS(1199),
    [anon_sym_CARET] = ACTIONS(1669),
    [anon_sym_PIPE] = ACTIONS(1201),
    [anon_sym_AMP] = ACTIONS(1667),
    [anon_sym_LT_LT] = ACTIONS(1199),
    [anon_sym_GT_GT] = ACTIONS(1201),
    [anon_sym_GT_GT_GT] = ACTIONS(1199),
    [anon_sym_EQ_EQ] = ACTIONS(1199),
    [anon_sym_BANG_EQ] = ACTIONS(1199),
    [anon_sym_GT_EQ] = ACTIONS(1199),
    [anon_sym_LT_EQ] = ACTIONS(1199),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(1201),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1201),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_AMP_AMP] = ACTIONS(1199),
    [anon_sym_PIPE_PIPE] = ACTIONS(1199),
    [anon_sym_QMARK_QMARK] = ACTIONS(1199),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1201),
    [anon_sym_is] = ACTIONS(1201),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_DASH_GT] = ACTIONS(1199),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_with] = ACTIONS(1201),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [296] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6918),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7066),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6114),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4423),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7383),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9203),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(296),
    [sym_preproc_endregion] = STATE(296),
    [sym_preproc_line] = STATE(296),
    [sym_preproc_pragma] = STATE(296),
    [sym_preproc_nullable] = STATE(296),
    [sym_preproc_error] = STATE(296),
    [sym_preproc_define] = STATE(296),
    [sym_preproc_undef] = STATE(296),
    [aux_sym_class_declaration_repeat1] = STATE(3817),
    [aux_sym_lambda_expression_repeat1] = STATE(4152),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1905),
    [anon_sym_ref] = ACTIONS(1907),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1221),
    [anon_sym_LT] = ACTIONS(1201),
    [anon_sym_GT] = ACTIONS(1201),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1201),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1909),
    [anon_sym_TILDE] = ACTIONS(1911),
    [anon_sym_PLUS_PLUS] = ACTIONS(1911),
    [anon_sym_DASH_DASH] = ACTIONS(1911),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1909),
    [anon_sym_DASH] = ACTIONS(1909),
    [anon_sym_STAR] = ACTIONS(1913),
    [anon_sym_SLASH] = ACTIONS(1201),
    [anon_sym_PERCENT] = ACTIONS(1199),
    [anon_sym_CARET] = ACTIONS(1911),
    [anon_sym_PIPE] = ACTIONS(1201),
    [anon_sym_AMP] = ACTIONS(1909),
    [anon_sym_LT_LT] = ACTIONS(1199),
    [anon_sym_GT_GT] = ACTIONS(1201),
    [anon_sym_GT_GT_GT] = ACTIONS(1199),
    [anon_sym_EQ_EQ] = ACTIONS(1199),
    [anon_sym_BANG_EQ] = ACTIONS(1199),
    [anon_sym_GT_EQ] = ACTIONS(1199),
    [anon_sym_LT_EQ] = ACTIONS(1199),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_DOT] = ACTIONS(1201),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(1199),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1201),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1915),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1917),
    [anon_sym_DOT_DOT] = ACTIONS(1919),
    [anon_sym_AMP_AMP] = ACTIONS(1199),
    [anon_sym_PIPE_PIPE] = ACTIONS(1199),
    [anon_sym_QMARK_QMARK] = ACTIONS(1199),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1201),
    [anon_sym_is] = ACTIONS(1201),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_DASH_GT] = ACTIONS(1199),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_with] = ACTIONS(1201),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [297] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6727),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2839),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6146),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_pattern] = STATE(8186),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(6657),
    [sym_property_pattern_clause] = STATE(6741),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6659),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(5071),
    [sym_postfix_unary_expression] = STATE(5061),
    [sym_prefix_unary_expression] = STATE(5061),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(5071),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(5061),
    [sym_switch_expression] = STATE(3774),
    [sym_switch_expression_arm] = STATE(8667),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(5071),
    [sym_member_access_expression] = STATE(3775),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(5061),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(5071),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(5071),
    [sym_typeof_expression] = STATE(5071),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3775),
    [sym_literal] = STATE(5071),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(297),
    [sym_preproc_endregion] = STATE(297),
    [sym_preproc_line] = STATE(297),
    [sym_preproc_pragma] = STATE(297),
    [sym_preproc_nullable] = STATE(297),
    [sym_preproc_error] = STATE(297),
    [sym_preproc_define] = STATE(297),
    [sym_preproc_undef] = STATE(297),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_COMMA] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_ref] = ACTIONS(1925),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_RBRACE] = ACTIONS(1927),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(1929),
    [anon_sym_GT] = ACTIONS(1929),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1749),
    [anon_sym_TILDE] = ACTIONS(1749),
    [anon_sym_PLUS_PLUS] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1749),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1747),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1749),
    [anon_sym_AMP] = ACTIONS(1749),
    [anon_sym_GT_EQ] = ACTIONS(1931),
    [anon_sym_LT_EQ] = ACTIONS(1931),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1065),
    [anon_sym_var] = ACTIONS(1933),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(1935),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [298] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6961),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6327),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9849),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(298),
    [sym_preproc_endregion] = STATE(298),
    [sym_preproc_line] = STATE(298),
    [sym_preproc_pragma] = STATE(298),
    [sym_preproc_nullable] = STATE(298),
    [sym_preproc_error] = STATE(298),
    [sym_preproc_define] = STATE(298),
    [sym_preproc_undef] = STATE(298),
    [aux_sym_class_declaration_repeat1] = STATE(3841),
    [aux_sym_lambda_expression_repeat1] = STATE(4283),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(1937),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1939),
    [anon_sym_ref] = ACTIONS(1461),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1465),
    [anon_sym_LT] = ACTIONS(1941),
    [anon_sym_GT] = ACTIONS(1941),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1941),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_SLASH] = ACTIONS(1941),
    [anon_sym_PERCENT] = ACTIONS(1943),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_PIPE] = ACTIONS(1941),
    [anon_sym_AMP] = ACTIONS(77),
    [anon_sym_LT_LT] = ACTIONS(1943),
    [anon_sym_GT_GT] = ACTIONS(1941),
    [anon_sym_GT_GT_GT] = ACTIONS(1943),
    [anon_sym_EQ_EQ] = ACTIONS(1943),
    [anon_sym_BANG_EQ] = ACTIONS(1943),
    [anon_sym_GT_EQ] = ACTIONS(1943),
    [anon_sym_LT_EQ] = ACTIONS(1943),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(1941),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1941),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1467),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1469),
    [anon_sym_DOT_DOT] = ACTIONS(1471),
    [anon_sym_AMP_AMP] = ACTIONS(1943),
    [anon_sym_PIPE_PIPE] = ACTIONS(1943),
    [anon_sym_QMARK_QMARK] = ACTIONS(1943),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1941),
    [anon_sym_is] = ACTIONS(1941),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_DASH_GT] = ACTIONS(1943),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_with] = ACTIONS(1941),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [299] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2787),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(5923),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_pattern] = STATE(8221),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(6141),
    [sym_property_pattern_clause] = STATE(6672),
    [sym_subpattern] = STATE(8487),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(5681),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4210),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(5071),
    [sym_postfix_unary_expression] = STATE(5061),
    [sym_prefix_unary_expression] = STATE(5061),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(5071),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(5061),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(5071),
    [sym_member_access_expression] = STATE(3775),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(5061),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9027),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(5071),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(5071),
    [sym_typeof_expression] = STATE(5071),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3775),
    [sym_literal] = STATE(5071),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(299),
    [sym_preproc_endregion] = STATE(299),
    [sym_preproc_line] = STATE(299),
    [sym_preproc_pragma] = STATE(299),
    [sym_preproc_nullable] = STATE(299),
    [sym_preproc_error] = STATE(299),
    [sym_preproc_define] = STATE(299),
    [sym_preproc_undef] = STATE(299),
    [aux_sym_class_declaration_repeat1] = STATE(3852),
    [aux_sym_lambda_expression_repeat1] = STATE(4220),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_COMMA] = ACTIONS(1945),
    [anon_sym_LPAREN] = ACTIONS(1203),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_RBRACE] = ACTIONS(1949),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1053),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1097),
    [anon_sym_TILDE] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1099),
    [anon_sym_DASH] = ACTIONS(1099),
    [anon_sym_STAR] = ACTIONS(1101),
    [anon_sym_CARET] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1097),
    [anon_sym_GT_EQ] = ACTIONS(1063),
    [anon_sym_LT_EQ] = ACTIONS(1063),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1065),
    [anon_sym_var] = ACTIONS(1067),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1111),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(1115),
    [anon_sym_not] = ACTIONS(1077),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [300] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6961),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6360),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9849),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(300),
    [sym_preproc_endregion] = STATE(300),
    [sym_preproc_line] = STATE(300),
    [sym_preproc_pragma] = STATE(300),
    [sym_preproc_nullable] = STATE(300),
    [sym_preproc_error] = STATE(300),
    [sym_preproc_define] = STATE(300),
    [sym_preproc_undef] = STATE(300),
    [aux_sym_class_declaration_repeat1] = STATE(3841),
    [aux_sym_lambda_expression_repeat1] = STATE(4283),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(1951),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1939),
    [anon_sym_ref] = ACTIONS(1461),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1465),
    [anon_sym_LT] = ACTIONS(1941),
    [anon_sym_GT] = ACTIONS(1941),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1941),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_SLASH] = ACTIONS(1941),
    [anon_sym_PERCENT] = ACTIONS(1943),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_PIPE] = ACTIONS(1941),
    [anon_sym_AMP] = ACTIONS(77),
    [anon_sym_LT_LT] = ACTIONS(1943),
    [anon_sym_GT_GT] = ACTIONS(1941),
    [anon_sym_GT_GT_GT] = ACTIONS(1943),
    [anon_sym_EQ_EQ] = ACTIONS(1943),
    [anon_sym_BANG_EQ] = ACTIONS(1943),
    [anon_sym_GT_EQ] = ACTIONS(1943),
    [anon_sym_LT_EQ] = ACTIONS(1943),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(1941),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1941),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1467),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1469),
    [anon_sym_DOT_DOT] = ACTIONS(1471),
    [anon_sym_AMP_AMP] = ACTIONS(1943),
    [anon_sym_PIPE_PIPE] = ACTIONS(1943),
    [anon_sym_QMARK_QMARK] = ACTIONS(1943),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1941),
    [anon_sym_is] = ACTIONS(1941),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_DASH_GT] = ACTIONS(1943),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_with] = ACTIONS(1941),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [301] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6727),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2839),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6146),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_pattern] = STATE(8186),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(6657),
    [sym_property_pattern_clause] = STATE(6741),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6659),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(5071),
    [sym_postfix_unary_expression] = STATE(5061),
    [sym_prefix_unary_expression] = STATE(5061),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(5071),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(5061),
    [sym_switch_expression] = STATE(3774),
    [sym_switch_expression_arm] = STATE(8563),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(5071),
    [sym_member_access_expression] = STATE(3775),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(5061),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(5071),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(5071),
    [sym_typeof_expression] = STATE(5071),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3775),
    [sym_literal] = STATE(5071),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(301),
    [sym_preproc_endregion] = STATE(301),
    [sym_preproc_line] = STATE(301),
    [sym_preproc_pragma] = STATE(301),
    [sym_preproc_nullable] = STATE(301),
    [sym_preproc_error] = STATE(301),
    [sym_preproc_define] = STATE(301),
    [sym_preproc_undef] = STATE(301),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_COMMA] = ACTIONS(1953),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_ref] = ACTIONS(1925),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_RBRACE] = ACTIONS(1955),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(1929),
    [anon_sym_GT] = ACTIONS(1929),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1749),
    [anon_sym_TILDE] = ACTIONS(1749),
    [anon_sym_PLUS_PLUS] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1749),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1747),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1749),
    [anon_sym_AMP] = ACTIONS(1749),
    [anon_sym_GT_EQ] = ACTIONS(1931),
    [anon_sym_LT_EQ] = ACTIONS(1931),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1065),
    [anon_sym_var] = ACTIONS(1933),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(1935),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [302] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2789),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(5669),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_pattern] = STATE(8221),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(6141),
    [sym_property_pattern_clause] = STATE(6672),
    [sym_subpattern] = STATE(8650),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6495),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4482),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(5313),
    [sym_postfix_unary_expression] = STATE(5314),
    [sym_prefix_unary_expression] = STATE(5314),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(5313),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(5314),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(5313),
    [sym_member_access_expression] = STATE(3856),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(5314),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9438),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(5313),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(5313),
    [sym_typeof_expression] = STATE(5313),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3856),
    [sym_literal] = STATE(5313),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(302),
    [sym_preproc_endregion] = STATE(302),
    [sym_preproc_line] = STATE(302),
    [sym_preproc_pragma] = STATE(302),
    [sym_preproc_nullable] = STATE(302),
    [sym_preproc_error] = STATE(302),
    [sym_preproc_define] = STATE(302),
    [sym_preproc_undef] = STATE(302),
    [aux_sym_class_declaration_repeat1] = STATE(3801),
    [aux_sym_lambda_expression_repeat1] = STATE(4134),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_COMMA] = ACTIONS(1957),
    [anon_sym_LPAREN] = ACTIONS(1203),
    [anon_sym_ref] = ACTIONS(1959),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_RBRACE] = ACTIONS(1961),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1053),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1097),
    [anon_sym_TILDE] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1099),
    [anon_sym_DASH] = ACTIONS(1099),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1097),
    [anon_sym_GT_EQ] = ACTIONS(1063),
    [anon_sym_LT_EQ] = ACTIONS(1063),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1065),
    [anon_sym_var] = ACTIONS(1067),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1281),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1283),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(1285),
    [anon_sym_not] = ACTIONS(1077),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [303] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6961),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4309),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9849),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(303),
    [sym_preproc_endregion] = STATE(303),
    [sym_preproc_line] = STATE(303),
    [sym_preproc_pragma] = STATE(303),
    [sym_preproc_nullable] = STATE(303),
    [sym_preproc_error] = STATE(303),
    [sym_preproc_define] = STATE(303),
    [sym_preproc_undef] = STATE(303),
    [aux_sym_class_declaration_repeat1] = STATE(3841),
    [aux_sym_lambda_expression_repeat1] = STATE(4283),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(1963),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1459),
    [anon_sym_ref] = ACTIONS(1461),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1465),
    [anon_sym_LT] = ACTIONS(1965),
    [anon_sym_GT] = ACTIONS(1965),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1965),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_SLASH] = ACTIONS(1965),
    [anon_sym_PERCENT] = ACTIONS(1963),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_PIPE] = ACTIONS(1965),
    [anon_sym_AMP] = ACTIONS(77),
    [anon_sym_LT_LT] = ACTIONS(1963),
    [anon_sym_GT_GT] = ACTIONS(1965),
    [anon_sym_GT_GT_GT] = ACTIONS(1963),
    [anon_sym_EQ_EQ] = ACTIONS(1963),
    [anon_sym_BANG_EQ] = ACTIONS(1963),
    [anon_sym_GT_EQ] = ACTIONS(1963),
    [anon_sym_LT_EQ] = ACTIONS(1963),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(1965),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1965),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1467),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1469),
    [anon_sym_DOT_DOT] = ACTIONS(1471),
    [anon_sym_AMP_AMP] = ACTIONS(1963),
    [anon_sym_PIPE_PIPE] = ACTIONS(1963),
    [anon_sym_QMARK_QMARK] = ACTIONS(1963),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1965),
    [anon_sym_is] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_DASH_GT] = ACTIONS(1963),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_with] = ACTIONS(1965),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [304] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6727),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2839),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6146),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_pattern] = STATE(8186),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(6657),
    [sym_property_pattern_clause] = STATE(6741),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6659),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(5071),
    [sym_postfix_unary_expression] = STATE(5061),
    [sym_prefix_unary_expression] = STATE(5061),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(5071),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(5061),
    [sym_switch_expression] = STATE(3774),
    [sym_switch_expression_arm] = STATE(8371),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(5071),
    [sym_member_access_expression] = STATE(3775),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(5061),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(5071),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(5071),
    [sym_typeof_expression] = STATE(5071),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3775),
    [sym_literal] = STATE(5071),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(304),
    [sym_preproc_endregion] = STATE(304),
    [sym_preproc_line] = STATE(304),
    [sym_preproc_pragma] = STATE(304),
    [sym_preproc_nullable] = STATE(304),
    [sym_preproc_error] = STATE(304),
    [sym_preproc_define] = STATE(304),
    [sym_preproc_undef] = STATE(304),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_COMMA] = ACTIONS(1967),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_ref] = ACTIONS(1925),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_RBRACE] = ACTIONS(1969),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(1929),
    [anon_sym_GT] = ACTIONS(1929),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1749),
    [anon_sym_TILDE] = ACTIONS(1749),
    [anon_sym_PLUS_PLUS] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1749),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1747),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1749),
    [anon_sym_AMP] = ACTIONS(1749),
    [anon_sym_GT_EQ] = ACTIONS(1931),
    [anon_sym_LT_EQ] = ACTIONS(1931),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1065),
    [anon_sym_var] = ACTIONS(1933),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(1935),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [305] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2787),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(5923),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_pattern] = STATE(8221),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(6141),
    [sym_property_pattern_clause] = STATE(6672),
    [sym_subpattern] = STATE(8487),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(5681),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4210),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(5071),
    [sym_postfix_unary_expression] = STATE(5061),
    [sym_prefix_unary_expression] = STATE(5061),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(5071),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(5061),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(5071),
    [sym_member_access_expression] = STATE(3775),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(5061),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9027),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(5071),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(5071),
    [sym_typeof_expression] = STATE(5071),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3775),
    [sym_literal] = STATE(5071),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(305),
    [sym_preproc_endregion] = STATE(305),
    [sym_preproc_line] = STATE(305),
    [sym_preproc_pragma] = STATE(305),
    [sym_preproc_nullable] = STATE(305),
    [sym_preproc_error] = STATE(305),
    [sym_preproc_define] = STATE(305),
    [sym_preproc_undef] = STATE(305),
    [aux_sym_class_declaration_repeat1] = STATE(3852),
    [aux_sym_lambda_expression_repeat1] = STATE(4220),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_COMMA] = ACTIONS(1971),
    [anon_sym_LPAREN] = ACTIONS(1203),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_RBRACE] = ACTIONS(1973),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1053),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1097),
    [anon_sym_TILDE] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1099),
    [anon_sym_DASH] = ACTIONS(1099),
    [anon_sym_STAR] = ACTIONS(1101),
    [anon_sym_CARET] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1097),
    [anon_sym_GT_EQ] = ACTIONS(1063),
    [anon_sym_LT_EQ] = ACTIONS(1063),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1065),
    [anon_sym_var] = ACTIONS(1067),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1111),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(1115),
    [anon_sym_not] = ACTIONS(1077),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [306] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2787),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(5923),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_pattern] = STATE(8221),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(6141),
    [sym_property_pattern_clause] = STATE(6672),
    [sym_subpattern] = STATE(8650),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(5681),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4210),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(5071),
    [sym_postfix_unary_expression] = STATE(5061),
    [sym_prefix_unary_expression] = STATE(5061),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(5071),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(5061),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(5071),
    [sym_member_access_expression] = STATE(3775),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(5061),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9027),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(5071),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(5071),
    [sym_typeof_expression] = STATE(5071),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3775),
    [sym_literal] = STATE(5071),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(306),
    [sym_preproc_endregion] = STATE(306),
    [sym_preproc_line] = STATE(306),
    [sym_preproc_pragma] = STATE(306),
    [sym_preproc_nullable] = STATE(306),
    [sym_preproc_error] = STATE(306),
    [sym_preproc_define] = STATE(306),
    [sym_preproc_undef] = STATE(306),
    [aux_sym_class_declaration_repeat1] = STATE(3852),
    [aux_sym_lambda_expression_repeat1] = STATE(4220),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_COMMA] = ACTIONS(1975),
    [anon_sym_LPAREN] = ACTIONS(1203),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_RBRACE] = ACTIONS(1977),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1053),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1097),
    [anon_sym_TILDE] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1099),
    [anon_sym_DASH] = ACTIONS(1099),
    [anon_sym_STAR] = ACTIONS(1101),
    [anon_sym_CARET] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1097),
    [anon_sym_GT_EQ] = ACTIONS(1063),
    [anon_sym_LT_EQ] = ACTIONS(1063),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1065),
    [anon_sym_var] = ACTIONS(1067),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1111),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(1115),
    [anon_sym_not] = ACTIONS(1077),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [307] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7080),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6424),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4477),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9873),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(307),
    [sym_preproc_endregion] = STATE(307),
    [sym_preproc_line] = STATE(307),
    [sym_preproc_pragma] = STATE(307),
    [sym_preproc_nullable] = STATE(307),
    [sym_preproc_error] = STATE(307),
    [sym_preproc_define] = STATE(307),
    [sym_preproc_undef] = STATE(307),
    [aux_sym_class_declaration_repeat1] = STATE(3845),
    [aux_sym_lambda_expression_repeat1] = STATE(4299),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1979),
    [anon_sym_ref] = ACTIONS(1981),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(1147),
    [anon_sym_GT] = ACTIONS(1147),
    [anon_sym_in] = ACTIONS(1147),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1147),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1983),
    [anon_sym_TILDE] = ACTIONS(1985),
    [anon_sym_PLUS_PLUS] = ACTIONS(1985),
    [anon_sym_DASH_DASH] = ACTIONS(1985),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1983),
    [anon_sym_DASH] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_SLASH] = ACTIONS(1147),
    [anon_sym_PERCENT] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(1985),
    [anon_sym_PIPE] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(1983),
    [anon_sym_LT_LT] = ACTIONS(1133),
    [anon_sym_GT_GT] = ACTIONS(1147),
    [anon_sym_GT_GT_GT] = ACTIONS(1133),
    [anon_sym_EQ_EQ] = ACTIONS(1133),
    [anon_sym_BANG_EQ] = ACTIONS(1133),
    [anon_sym_GT_EQ] = ACTIONS(1133),
    [anon_sym_LT_EQ] = ACTIONS(1133),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(1147),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1147),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1987),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1989),
    [anon_sym_DOT_DOT] = ACTIONS(1991),
    [anon_sym_AMP_AMP] = ACTIONS(1133),
    [anon_sym_PIPE_PIPE] = ACTIONS(1133),
    [anon_sym_QMARK_QMARK] = ACTIONS(1133),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1147),
    [anon_sym_is] = ACTIONS(1147),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_DASH_GT] = ACTIONS(1133),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_with] = ACTIONS(1147),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [308] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6980),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6578),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4482),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9438),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(308),
    [sym_preproc_endregion] = STATE(308),
    [sym_preproc_line] = STATE(308),
    [sym_preproc_pragma] = STATE(308),
    [sym_preproc_nullable] = STATE(308),
    [sym_preproc_error] = STATE(308),
    [sym_preproc_define] = STATE(308),
    [sym_preproc_undef] = STATE(308),
    [aux_sym_class_declaration_repeat1] = STATE(3801),
    [aux_sym_lambda_expression_repeat1] = STATE(4134),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_COLON] = ACTIONS(1133),
    [anon_sym_LPAREN] = ACTIONS(1993),
    [anon_sym_ref] = ACTIONS(1995),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1147),
    [anon_sym_GT] = ACTIONS(1147),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1147),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1997),
    [anon_sym_TILDE] = ACTIONS(1999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1999),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_SLASH] = ACTIONS(1147),
    [anon_sym_PERCENT] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_PIPE] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(1997),
    [anon_sym_LT_LT] = ACTIONS(1133),
    [anon_sym_GT_GT] = ACTIONS(1147),
    [anon_sym_GT_GT_GT] = ACTIONS(1133),
    [anon_sym_EQ_EQ] = ACTIONS(1133),
    [anon_sym_BANG_EQ] = ACTIONS(1133),
    [anon_sym_GT_EQ] = ACTIONS(1133),
    [anon_sym_LT_EQ] = ACTIONS(1133),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(1147),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1147),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1281),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1283),
    [anon_sym_DOT_DOT] = ACTIONS(1285),
    [anon_sym_AMP_AMP] = ACTIONS(1133),
    [anon_sym_PIPE_PIPE] = ACTIONS(1133),
    [anon_sym_QMARK_QMARK] = ACTIONS(1133),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1147),
    [anon_sym_is] = ACTIONS(1147),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_DASH_GT] = ACTIONS(1133),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_with] = ACTIONS(1147),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [309] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6961),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6636),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9849),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(309),
    [sym_preproc_endregion] = STATE(309),
    [sym_preproc_line] = STATE(309),
    [sym_preproc_pragma] = STATE(309),
    [sym_preproc_nullable] = STATE(309),
    [sym_preproc_error] = STATE(309),
    [sym_preproc_define] = STATE(309),
    [sym_preproc_undef] = STATE(309),
    [aux_sym_class_declaration_repeat1] = STATE(3841),
    [aux_sym_lambda_expression_repeat1] = STATE(4283),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(2001),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1939),
    [anon_sym_ref] = ACTIONS(1461),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1465),
    [anon_sym_LT] = ACTIONS(1941),
    [anon_sym_GT] = ACTIONS(1941),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1941),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_SLASH] = ACTIONS(1941),
    [anon_sym_PERCENT] = ACTIONS(1943),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_PIPE] = ACTIONS(1941),
    [anon_sym_AMP] = ACTIONS(77),
    [anon_sym_LT_LT] = ACTIONS(1943),
    [anon_sym_GT_GT] = ACTIONS(1941),
    [anon_sym_GT_GT_GT] = ACTIONS(1943),
    [anon_sym_EQ_EQ] = ACTIONS(1943),
    [anon_sym_BANG_EQ] = ACTIONS(1943),
    [anon_sym_GT_EQ] = ACTIONS(1943),
    [anon_sym_LT_EQ] = ACTIONS(1943),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(1941),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1941),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1467),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1469),
    [anon_sym_DOT_DOT] = ACTIONS(1471),
    [anon_sym_AMP_AMP] = ACTIONS(1943),
    [anon_sym_PIPE_PIPE] = ACTIONS(1943),
    [anon_sym_QMARK_QMARK] = ACTIONS(1943),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1941),
    [anon_sym_is] = ACTIONS(1941),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_DASH_GT] = ACTIONS(1943),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_with] = ACTIONS(1941),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [310] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3559),
    [sym__name] = STATE(6878),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2911),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6938),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4818),
    [sym_non_lvalue_expression] = STATE(4553),
    [sym_lvalue_expression] = STATE(3750),
    [sym__expression_statement_expression] = STATE(4559),
    [sym_assignment_expression] = STATE(4558),
    [sym_binary_expression] = STATE(4559),
    [sym_postfix_unary_expression] = STATE(4558),
    [sym_prefix_unary_expression] = STATE(4558),
    [sym__pointer_indirection_expression] = STATE(3560),
    [sym_query_expression] = STATE(4559),
    [sym_from_clause] = STATE(7406),
    [sym_conditional_expression] = STATE(4559),
    [sym_conditional_access_expression] = STATE(4559),
    [sym_as_expression] = STATE(4559),
    [sym_is_expression] = STATE(4559),
    [sym_is_pattern_expression] = STATE(4559),
    [sym_cast_expression] = STATE(4559),
    [sym_checked_expression] = STATE(4559),
    [sym_invocation_expression] = STATE(4558),
    [sym_switch_expression] = STATE(4559),
    [sym_await_expression] = STATE(4558),
    [sym_throw_expression] = STATE(4559),
    [sym_element_access_expression] = STATE(3560),
    [sym_interpolated_string_expression] = STATE(4559),
    [sym_member_access_expression] = STATE(3560),
    [sym_object_creation_expression] = STATE(4558),
    [sym_parenthesized_expression] = STATE(4558),
    [sym__parenthesized_lvalue_expression] = STATE(3560),
    [sym_lambda_expression] = STATE(4559),
    [sym__lambda_parameters] = STATE(9691),
    [sym_array_creation_expression] = STATE(4559),
    [sym_anonymous_method_expression] = STATE(4559),
    [sym_anonymous_object_creation_expression] = STATE(4559),
    [sym_implicit_array_creation_expression] = STATE(4559),
    [sym_implicit_object_creation_expression] = STATE(4559),
    [sym_implicit_stackalloc_expression] = STATE(4559),
    [sym_initializer_expression] = STATE(4559),
    [sym_default_expression] = STATE(4559),
    [sym_with_expression] = STATE(4559),
    [sym_sizeof_expression] = STATE(4559),
    [sym_typeof_expression] = STATE(4559),
    [sym_makeref_expression] = STATE(4559),
    [sym_ref_expression] = STATE(4559),
    [sym_reftype_expression] = STATE(4559),
    [sym_refvalue_expression] = STATE(4559),
    [sym_stackalloc_expression] = STATE(4559),
    [sym_range_expression] = STATE(4559),
    [sym_tuple_expression] = STATE(3560),
    [sym_literal] = STATE(4559),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4559),
    [sym_preproc_region] = STATE(310),
    [sym_preproc_endregion] = STATE(310),
    [sym_preproc_line] = STATE(310),
    [sym_preproc_pragma] = STATE(310),
    [sym_preproc_nullable] = STATE(310),
    [sym_preproc_error] = STATE(310),
    [sym_preproc_define] = STATE(310),
    [sym_preproc_undef] = STATE(310),
    [aux_sym_class_declaration_repeat1] = STATE(3836),
    [aux_sym_lambda_expression_repeat1] = STATE(4216),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_COMMA] = ACTIONS(1199),
    [anon_sym_LPAREN] = ACTIONS(2003),
    [anon_sym_ref] = ACTIONS(2005),
    [anon_sym_LBRACE] = ACTIONS(1611),
    [anon_sym_delegate] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1615),
    [anon_sym_LT] = ACTIONS(1201),
    [anon_sym_GT] = ACTIONS(1201),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1201),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(2007),
    [anon_sym_TILDE] = ACTIONS(2009),
    [anon_sym_PLUS_PLUS] = ACTIONS(2009),
    [anon_sym_DASH_DASH] = ACTIONS(2009),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(2007),
    [anon_sym_DASH] = ACTIONS(2007),
    [anon_sym_STAR] = ACTIONS(1625),
    [anon_sym_SLASH] = ACTIONS(1201),
    [anon_sym_PERCENT] = ACTIONS(1199),
    [anon_sym_CARET] = ACTIONS(2009),
    [anon_sym_PIPE] = ACTIONS(1201),
    [anon_sym_AMP] = ACTIONS(2007),
    [anon_sym_LT_LT] = ACTIONS(1199),
    [anon_sym_GT_GT] = ACTIONS(1201),
    [anon_sym_GT_GT_GT] = ACTIONS(1199),
    [anon_sym_EQ_EQ] = ACTIONS(1199),
    [anon_sym_BANG_EQ] = ACTIONS(1199),
    [anon_sym_GT_EQ] = ACTIONS(1199),
    [anon_sym_LT_EQ] = ACTIONS(1199),
    [anon_sym_this] = ACTIONS(1627),
    [anon_sym_DOT] = ACTIONS(1201),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1629),
    [anon_sym_unchecked] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1201),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(2011),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2013),
    [anon_sym_DOT_DOT] = ACTIONS(2015),
    [anon_sym_AMP_AMP] = ACTIONS(1199),
    [anon_sym_PIPE_PIPE] = ACTIONS(1199),
    [anon_sym_QMARK_QMARK] = ACTIONS(1199),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1201),
    [anon_sym_is] = ACTIONS(1201),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_DASH_GT] = ACTIONS(1199),
    [anon_sym_stackalloc] = ACTIONS(1641),
    [anon_sym_with] = ACTIONS(1201),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(1647),
    [anon_sym___reftype] = ACTIONS(1649),
    [anon_sym___refvalue] = ACTIONS(1651),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1659),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [311] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6727),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2839),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6146),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_pattern] = STATE(8186),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(6657),
    [sym_property_pattern_clause] = STATE(6741),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6659),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(5071),
    [sym_postfix_unary_expression] = STATE(5061),
    [sym_prefix_unary_expression] = STATE(5061),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(5071),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(5061),
    [sym_switch_expression] = STATE(3774),
    [sym_switch_expression_arm] = STATE(8471),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(5071),
    [sym_member_access_expression] = STATE(3775),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(5061),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(5071),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(5071),
    [sym_typeof_expression] = STATE(5071),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3775),
    [sym_literal] = STATE(5071),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(311),
    [sym_preproc_endregion] = STATE(311),
    [sym_preproc_line] = STATE(311),
    [sym_preproc_pragma] = STATE(311),
    [sym_preproc_nullable] = STATE(311),
    [sym_preproc_error] = STATE(311),
    [sym_preproc_define] = STATE(311),
    [sym_preproc_undef] = STATE(311),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_COMMA] = ACTIONS(2017),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_ref] = ACTIONS(1925),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_RBRACE] = ACTIONS(2019),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(1929),
    [anon_sym_GT] = ACTIONS(1929),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1749),
    [anon_sym_TILDE] = ACTIONS(1749),
    [anon_sym_PLUS_PLUS] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1749),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1747),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1749),
    [anon_sym_AMP] = ACTIONS(1749),
    [anon_sym_GT_EQ] = ACTIONS(1931),
    [anon_sym_LT_EQ] = ACTIONS(1931),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1065),
    [anon_sym_var] = ACTIONS(1933),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(1935),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [312] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2787),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(5923),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_pattern] = STATE(8221),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(6141),
    [sym_property_pattern_clause] = STATE(6672),
    [sym_subpattern] = STATE(8487),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(5681),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4210),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(5071),
    [sym_postfix_unary_expression] = STATE(5061),
    [sym_prefix_unary_expression] = STATE(5061),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(5071),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(5061),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(5071),
    [sym_member_access_expression] = STATE(3775),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(5061),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9027),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(5071),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(5071),
    [sym_typeof_expression] = STATE(5071),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3775),
    [sym_literal] = STATE(5071),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(312),
    [sym_preproc_endregion] = STATE(312),
    [sym_preproc_line] = STATE(312),
    [sym_preproc_pragma] = STATE(312),
    [sym_preproc_nullable] = STATE(312),
    [sym_preproc_error] = STATE(312),
    [sym_preproc_define] = STATE(312),
    [sym_preproc_undef] = STATE(312),
    [aux_sym_class_declaration_repeat1] = STATE(3852),
    [aux_sym_lambda_expression_repeat1] = STATE(4220),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_COMMA] = ACTIONS(2021),
    [anon_sym_LPAREN] = ACTIONS(1203),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_RBRACE] = ACTIONS(2023),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1053),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1097),
    [anon_sym_TILDE] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1099),
    [anon_sym_DASH] = ACTIONS(1099),
    [anon_sym_STAR] = ACTIONS(1101),
    [anon_sym_CARET] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1097),
    [anon_sym_GT_EQ] = ACTIONS(1063),
    [anon_sym_LT_EQ] = ACTIONS(1063),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1065),
    [anon_sym_var] = ACTIONS(1067),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1111),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(1115),
    [anon_sym_not] = ACTIONS(1077),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [313] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6727),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2839),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6146),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_pattern] = STATE(8186),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(6657),
    [sym_property_pattern_clause] = STATE(6741),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6659),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(5071),
    [sym_postfix_unary_expression] = STATE(5061),
    [sym_prefix_unary_expression] = STATE(5061),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(5071),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(5061),
    [sym_switch_expression] = STATE(3774),
    [sym_switch_expression_arm] = STATE(8606),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(5071),
    [sym_member_access_expression] = STATE(3775),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(5061),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(5071),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(5071),
    [sym_typeof_expression] = STATE(5071),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3775),
    [sym_literal] = STATE(5071),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(313),
    [sym_preproc_endregion] = STATE(313),
    [sym_preproc_line] = STATE(313),
    [sym_preproc_pragma] = STATE(313),
    [sym_preproc_nullable] = STATE(313),
    [sym_preproc_error] = STATE(313),
    [sym_preproc_define] = STATE(313),
    [sym_preproc_undef] = STATE(313),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_COMMA] = ACTIONS(2025),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_ref] = ACTIONS(1925),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_RBRACE] = ACTIONS(2027),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(1929),
    [anon_sym_GT] = ACTIONS(1929),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1749),
    [anon_sym_TILDE] = ACTIONS(1749),
    [anon_sym_PLUS_PLUS] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1749),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1747),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1749),
    [anon_sym_AMP] = ACTIONS(1749),
    [anon_sym_GT_EQ] = ACTIONS(1931),
    [anon_sym_LT_EQ] = ACTIONS(1931),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1065),
    [anon_sym_var] = ACTIONS(1933),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(1935),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [314] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6918),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7066),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6127),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4423),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7383),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9203),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(314),
    [sym_preproc_endregion] = STATE(314),
    [sym_preproc_line] = STATE(314),
    [sym_preproc_pragma] = STATE(314),
    [sym_preproc_nullable] = STATE(314),
    [sym_preproc_error] = STATE(314),
    [sym_preproc_define] = STATE(314),
    [sym_preproc_undef] = STATE(314),
    [aux_sym_class_declaration_repeat1] = STATE(3817),
    [aux_sym_lambda_expression_repeat1] = STATE(4152),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1905),
    [anon_sym_ref] = ACTIONS(1907),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1221),
    [anon_sym_LT] = ACTIONS(1147),
    [anon_sym_GT] = ACTIONS(1147),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1147),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1909),
    [anon_sym_TILDE] = ACTIONS(1911),
    [anon_sym_PLUS_PLUS] = ACTIONS(1911),
    [anon_sym_DASH_DASH] = ACTIONS(1911),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1909),
    [anon_sym_DASH] = ACTIONS(1909),
    [anon_sym_STAR] = ACTIONS(1913),
    [anon_sym_SLASH] = ACTIONS(1147),
    [anon_sym_PERCENT] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(1911),
    [anon_sym_PIPE] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(1909),
    [anon_sym_LT_LT] = ACTIONS(1133),
    [anon_sym_GT_GT] = ACTIONS(1147),
    [anon_sym_GT_GT_GT] = ACTIONS(1133),
    [anon_sym_EQ_EQ] = ACTIONS(1133),
    [anon_sym_BANG_EQ] = ACTIONS(1133),
    [anon_sym_GT_EQ] = ACTIONS(1133),
    [anon_sym_LT_EQ] = ACTIONS(1133),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_DOT] = ACTIONS(1147),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(1133),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1147),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1915),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1917),
    [anon_sym_DOT_DOT] = ACTIONS(1919),
    [anon_sym_AMP_AMP] = ACTIONS(1133),
    [anon_sym_PIPE_PIPE] = ACTIONS(1133),
    [anon_sym_QMARK_QMARK] = ACTIONS(1133),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1147),
    [anon_sym_is] = ACTIONS(1147),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_DASH_GT] = ACTIONS(1133),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_with] = ACTIONS(1147),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [315] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6961),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6623),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9849),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(315),
    [sym_preproc_endregion] = STATE(315),
    [sym_preproc_line] = STATE(315),
    [sym_preproc_pragma] = STATE(315),
    [sym_preproc_nullable] = STATE(315),
    [sym_preproc_error] = STATE(315),
    [sym_preproc_define] = STATE(315),
    [sym_preproc_undef] = STATE(315),
    [aux_sym_class_declaration_repeat1] = STATE(3841),
    [aux_sym_lambda_expression_repeat1] = STATE(4283),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(2029),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1939),
    [anon_sym_ref] = ACTIONS(1461),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1465),
    [anon_sym_LT] = ACTIONS(1941),
    [anon_sym_GT] = ACTIONS(1941),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1941),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_SLASH] = ACTIONS(1941),
    [anon_sym_PERCENT] = ACTIONS(1943),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_PIPE] = ACTIONS(1941),
    [anon_sym_AMP] = ACTIONS(77),
    [anon_sym_LT_LT] = ACTIONS(1943),
    [anon_sym_GT_GT] = ACTIONS(1941),
    [anon_sym_GT_GT_GT] = ACTIONS(1943),
    [anon_sym_EQ_EQ] = ACTIONS(1943),
    [anon_sym_BANG_EQ] = ACTIONS(1943),
    [anon_sym_GT_EQ] = ACTIONS(1943),
    [anon_sym_LT_EQ] = ACTIONS(1943),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(1941),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1941),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1467),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1469),
    [anon_sym_DOT_DOT] = ACTIONS(1471),
    [anon_sym_AMP_AMP] = ACTIONS(1943),
    [anon_sym_PIPE_PIPE] = ACTIONS(1943),
    [anon_sym_QMARK_QMARK] = ACTIONS(1943),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1941),
    [anon_sym_is] = ACTIONS(1941),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_DASH_GT] = ACTIONS(1943),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_with] = ACTIONS(1941),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [316] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6987),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6566),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4462),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7405),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9130),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(316),
    [sym_preproc_endregion] = STATE(316),
    [sym_preproc_line] = STATE(316),
    [sym_preproc_pragma] = STATE(316),
    [sym_preproc_nullable] = STATE(316),
    [sym_preproc_error] = STATE(316),
    [sym_preproc_define] = STATE(316),
    [sym_preproc_undef] = STATE(316),
    [aux_sym_class_declaration_repeat1] = STATE(3855),
    [aux_sym_lambda_expression_repeat1] = STATE(4244),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2031),
    [anon_sym_ref] = ACTIONS(2033),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(1147),
    [anon_sym_GT] = ACTIONS(1147),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1147),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2035),
    [anon_sym_TILDE] = ACTIONS(2037),
    [anon_sym_PLUS_PLUS] = ACTIONS(2037),
    [anon_sym_DASH_DASH] = ACTIONS(2037),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2035),
    [anon_sym_DASH] = ACTIONS(2035),
    [anon_sym_STAR] = ACTIONS(2039),
    [anon_sym_SLASH] = ACTIONS(1147),
    [anon_sym_PERCENT] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(2037),
    [anon_sym_PIPE] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(2035),
    [anon_sym_LT_LT] = ACTIONS(1133),
    [anon_sym_GT_GT] = ACTIONS(1147),
    [anon_sym_GT_GT_GT] = ACTIONS(1133),
    [anon_sym_EQ_EQ] = ACTIONS(1133),
    [anon_sym_BANG_EQ] = ACTIONS(1133),
    [anon_sym_GT_EQ] = ACTIONS(1133),
    [anon_sym_LT_EQ] = ACTIONS(1133),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(1147),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(1133),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1147),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2041),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2043),
    [anon_sym_DOT_DOT] = ACTIONS(2045),
    [anon_sym_AMP_AMP] = ACTIONS(1133),
    [anon_sym_PIPE_PIPE] = ACTIONS(1133),
    [anon_sym_QMARK_QMARK] = ACTIONS(1133),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1147),
    [anon_sym_is] = ACTIONS(1147),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_DASH_GT] = ACTIONS(1133),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_with] = ACTIONS(1147),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [317] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3559),
    [sym__name] = STATE(6877),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2908),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6958),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4673),
    [sym_non_lvalue_expression] = STATE(4553),
    [sym_lvalue_expression] = STATE(3691),
    [sym__expression_statement_expression] = STATE(4559),
    [sym_assignment_expression] = STATE(4558),
    [sym_binary_expression] = STATE(4559),
    [sym_postfix_unary_expression] = STATE(4558),
    [sym_prefix_unary_expression] = STATE(4558),
    [sym__pointer_indirection_expression] = STATE(3560),
    [sym_query_expression] = STATE(4559),
    [sym_from_clause] = STATE(7406),
    [sym_conditional_expression] = STATE(4559),
    [sym_conditional_access_expression] = STATE(4559),
    [sym_as_expression] = STATE(4559),
    [sym_is_expression] = STATE(4559),
    [sym_is_pattern_expression] = STATE(4559),
    [sym_cast_expression] = STATE(4559),
    [sym_checked_expression] = STATE(4559),
    [sym_invocation_expression] = STATE(4558),
    [sym_switch_expression] = STATE(4559),
    [sym_await_expression] = STATE(4558),
    [sym_throw_expression] = STATE(4559),
    [sym_element_access_expression] = STATE(3560),
    [sym_interpolated_string_expression] = STATE(4559),
    [sym_member_access_expression] = STATE(3560),
    [sym_object_creation_expression] = STATE(4558),
    [sym_parenthesized_expression] = STATE(4558),
    [sym__parenthesized_lvalue_expression] = STATE(3560),
    [sym_lambda_expression] = STATE(4559),
    [sym__lambda_parameters] = STATE(9348),
    [sym_array_creation_expression] = STATE(4559),
    [sym_anonymous_method_expression] = STATE(4559),
    [sym_anonymous_object_creation_expression] = STATE(4559),
    [sym_implicit_array_creation_expression] = STATE(4559),
    [sym_implicit_object_creation_expression] = STATE(4559),
    [sym_implicit_stackalloc_expression] = STATE(4559),
    [sym_initializer_expression] = STATE(4559),
    [sym_default_expression] = STATE(4559),
    [sym_with_expression] = STATE(4559),
    [sym_sizeof_expression] = STATE(4559),
    [sym_typeof_expression] = STATE(4559),
    [sym_makeref_expression] = STATE(4559),
    [sym_ref_expression] = STATE(4559),
    [sym_reftype_expression] = STATE(4559),
    [sym_refvalue_expression] = STATE(4559),
    [sym_stackalloc_expression] = STATE(4559),
    [sym_range_expression] = STATE(4559),
    [sym_tuple_expression] = STATE(3560),
    [sym_literal] = STATE(4559),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4559),
    [sym_preproc_region] = STATE(317),
    [sym_preproc_endregion] = STATE(317),
    [sym_preproc_line] = STATE(317),
    [sym_preproc_pragma] = STATE(317),
    [sym_preproc_nullable] = STATE(317),
    [sym_preproc_error] = STATE(317),
    [sym_preproc_define] = STATE(317),
    [sym_preproc_undef] = STATE(317),
    [aux_sym_class_declaration_repeat1] = STATE(3810),
    [aux_sym_lambda_expression_repeat1] = STATE(4141),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_COMMA] = ACTIONS(1133),
    [anon_sym_LPAREN] = ACTIONS(2047),
    [anon_sym_ref] = ACTIONS(2049),
    [anon_sym_LBRACE] = ACTIONS(1611),
    [anon_sym_delegate] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1679),
    [anon_sym_LT] = ACTIONS(1147),
    [anon_sym_GT] = ACTIONS(1147),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1147),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(2051),
    [anon_sym_TILDE] = ACTIONS(2053),
    [anon_sym_PLUS_PLUS] = ACTIONS(2053),
    [anon_sym_DASH_DASH] = ACTIONS(2053),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(2051),
    [anon_sym_DASH] = ACTIONS(2051),
    [anon_sym_STAR] = ACTIONS(1685),
    [anon_sym_SLASH] = ACTIONS(1147),
    [anon_sym_PERCENT] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(2053),
    [anon_sym_PIPE] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_LT_LT] = ACTIONS(1133),
    [anon_sym_GT_GT] = ACTIONS(1147),
    [anon_sym_GT_GT_GT] = ACTIONS(1133),
    [anon_sym_EQ_EQ] = ACTIONS(1133),
    [anon_sym_BANG_EQ] = ACTIONS(1133),
    [anon_sym_GT_EQ] = ACTIONS(1133),
    [anon_sym_LT_EQ] = ACTIONS(1133),
    [anon_sym_this] = ACTIONS(1627),
    [anon_sym_DOT] = ACTIONS(1147),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1629),
    [anon_sym_unchecked] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1147),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(2055),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2057),
    [anon_sym_DOT_DOT] = ACTIONS(2059),
    [anon_sym_AMP_AMP] = ACTIONS(1133),
    [anon_sym_PIPE_PIPE] = ACTIONS(1133),
    [anon_sym_QMARK_QMARK] = ACTIONS(1133),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1147),
    [anon_sym_is] = ACTIONS(1147),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_DASH_GT] = ACTIONS(1133),
    [anon_sym_stackalloc] = ACTIONS(1641),
    [anon_sym_with] = ACTIONS(1147),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(1647),
    [anon_sym___reftype] = ACTIONS(1649),
    [anon_sym___refvalue] = ACTIONS(1651),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1659),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [318] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6727),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2839),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6146),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_pattern] = STATE(8186),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(6657),
    [sym_property_pattern_clause] = STATE(6741),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6659),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(5071),
    [sym_postfix_unary_expression] = STATE(5061),
    [sym_prefix_unary_expression] = STATE(5061),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(5071),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(5061),
    [sym_switch_expression] = STATE(3774),
    [sym_switch_expression_arm] = STATE(8494),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(5071),
    [sym_member_access_expression] = STATE(3775),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(5061),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(5071),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(5071),
    [sym_typeof_expression] = STATE(5071),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3775),
    [sym_literal] = STATE(5071),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(318),
    [sym_preproc_endregion] = STATE(318),
    [sym_preproc_line] = STATE(318),
    [sym_preproc_pragma] = STATE(318),
    [sym_preproc_nullable] = STATE(318),
    [sym_preproc_error] = STATE(318),
    [sym_preproc_define] = STATE(318),
    [sym_preproc_undef] = STATE(318),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_COMMA] = ACTIONS(2061),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_ref] = ACTIONS(1925),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_RBRACE] = ACTIONS(2063),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(1929),
    [anon_sym_GT] = ACTIONS(1929),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1749),
    [anon_sym_TILDE] = ACTIONS(1749),
    [anon_sym_PLUS_PLUS] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1749),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1747),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1749),
    [anon_sym_AMP] = ACTIONS(1749),
    [anon_sym_GT_EQ] = ACTIONS(1931),
    [anon_sym_LT_EQ] = ACTIONS(1931),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1065),
    [anon_sym_var] = ACTIONS(1933),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(1935),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [319] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7080),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6447),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4477),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9873),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(319),
    [sym_preproc_endregion] = STATE(319),
    [sym_preproc_line] = STATE(319),
    [sym_preproc_pragma] = STATE(319),
    [sym_preproc_nullable] = STATE(319),
    [sym_preproc_error] = STATE(319),
    [sym_preproc_define] = STATE(319),
    [sym_preproc_undef] = STATE(319),
    [aux_sym_class_declaration_repeat1] = STATE(3845),
    [aux_sym_lambda_expression_repeat1] = STATE(4299),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1979),
    [anon_sym_ref] = ACTIONS(1981),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(1201),
    [anon_sym_GT] = ACTIONS(1201),
    [anon_sym_in] = ACTIONS(1201),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1201),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1983),
    [anon_sym_TILDE] = ACTIONS(1985),
    [anon_sym_PLUS_PLUS] = ACTIONS(1985),
    [anon_sym_DASH_DASH] = ACTIONS(1985),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1983),
    [anon_sym_DASH] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_SLASH] = ACTIONS(1201),
    [anon_sym_PERCENT] = ACTIONS(1199),
    [anon_sym_CARET] = ACTIONS(1985),
    [anon_sym_PIPE] = ACTIONS(1201),
    [anon_sym_AMP] = ACTIONS(1983),
    [anon_sym_LT_LT] = ACTIONS(1199),
    [anon_sym_GT_GT] = ACTIONS(1201),
    [anon_sym_GT_GT_GT] = ACTIONS(1199),
    [anon_sym_EQ_EQ] = ACTIONS(1199),
    [anon_sym_BANG_EQ] = ACTIONS(1199),
    [anon_sym_GT_EQ] = ACTIONS(1199),
    [anon_sym_LT_EQ] = ACTIONS(1199),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(1201),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1201),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1987),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1989),
    [anon_sym_DOT_DOT] = ACTIONS(1991),
    [anon_sym_AMP_AMP] = ACTIONS(1199),
    [anon_sym_PIPE_PIPE] = ACTIONS(1199),
    [anon_sym_QMARK_QMARK] = ACTIONS(1199),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1201),
    [anon_sym_is] = ACTIONS(1201),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_DASH_GT] = ACTIONS(1199),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_with] = ACTIONS(1201),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [320] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2789),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(5669),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_pattern] = STATE(8221),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(6141),
    [sym_property_pattern_clause] = STATE(6672),
    [sym_subpattern] = STATE(8487),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6495),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4482),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(5313),
    [sym_postfix_unary_expression] = STATE(5314),
    [sym_prefix_unary_expression] = STATE(5314),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(5313),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(5314),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(5313),
    [sym_member_access_expression] = STATE(3856),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(5314),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9438),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(5313),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(5313),
    [sym_typeof_expression] = STATE(5313),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3856),
    [sym_literal] = STATE(5313),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(320),
    [sym_preproc_endregion] = STATE(320),
    [sym_preproc_line] = STATE(320),
    [sym_preproc_pragma] = STATE(320),
    [sym_preproc_nullable] = STATE(320),
    [sym_preproc_error] = STATE(320),
    [sym_preproc_define] = STATE(320),
    [sym_preproc_undef] = STATE(320),
    [aux_sym_class_declaration_repeat1] = STATE(3801),
    [aux_sym_lambda_expression_repeat1] = STATE(4134),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_COMMA] = ACTIONS(2065),
    [anon_sym_LPAREN] = ACTIONS(1203),
    [anon_sym_ref] = ACTIONS(1959),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_RBRACE] = ACTIONS(2067),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1053),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1097),
    [anon_sym_TILDE] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1099),
    [anon_sym_DASH] = ACTIONS(1099),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1097),
    [anon_sym_GT_EQ] = ACTIONS(1063),
    [anon_sym_LT_EQ] = ACTIONS(1063),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1065),
    [anon_sym_var] = ACTIONS(1067),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1281),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1283),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(1285),
    [anon_sym_not] = ACTIONS(1077),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [321] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3559),
    [sym__name] = STATE(6878),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2911),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6938),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4880),
    [sym_non_lvalue_expression] = STATE(4553),
    [sym_lvalue_expression] = STATE(3750),
    [sym__expression_statement_expression] = STATE(4559),
    [sym_assignment_expression] = STATE(4558),
    [sym_binary_expression] = STATE(4559),
    [sym_postfix_unary_expression] = STATE(4558),
    [sym_prefix_unary_expression] = STATE(4558),
    [sym__pointer_indirection_expression] = STATE(3560),
    [sym_query_expression] = STATE(4559),
    [sym_from_clause] = STATE(7406),
    [sym_conditional_expression] = STATE(4559),
    [sym_conditional_access_expression] = STATE(4559),
    [sym_as_expression] = STATE(4559),
    [sym_is_expression] = STATE(4559),
    [sym_is_pattern_expression] = STATE(4559),
    [sym_cast_expression] = STATE(4559),
    [sym_checked_expression] = STATE(4559),
    [sym_invocation_expression] = STATE(4558),
    [sym_switch_expression] = STATE(4559),
    [sym_await_expression] = STATE(4558),
    [sym_throw_expression] = STATE(4559),
    [sym_element_access_expression] = STATE(3560),
    [sym_interpolated_string_expression] = STATE(4559),
    [sym_member_access_expression] = STATE(3560),
    [sym_object_creation_expression] = STATE(4558),
    [sym_parenthesized_expression] = STATE(4558),
    [sym__parenthesized_lvalue_expression] = STATE(3560),
    [sym_lambda_expression] = STATE(4559),
    [sym__lambda_parameters] = STATE(9691),
    [sym_array_creation_expression] = STATE(4559),
    [sym_anonymous_method_expression] = STATE(4559),
    [sym_anonymous_object_creation_expression] = STATE(4559),
    [sym_implicit_array_creation_expression] = STATE(4559),
    [sym_implicit_object_creation_expression] = STATE(4559),
    [sym_implicit_stackalloc_expression] = STATE(4559),
    [sym_initializer_expression] = STATE(4559),
    [sym_default_expression] = STATE(4559),
    [sym_with_expression] = STATE(4559),
    [sym_sizeof_expression] = STATE(4559),
    [sym_typeof_expression] = STATE(4559),
    [sym_makeref_expression] = STATE(4559),
    [sym_ref_expression] = STATE(4559),
    [sym_reftype_expression] = STATE(4559),
    [sym_refvalue_expression] = STATE(4559),
    [sym_stackalloc_expression] = STATE(4559),
    [sym_range_expression] = STATE(4559),
    [sym_tuple_expression] = STATE(3560),
    [sym_literal] = STATE(4559),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4559),
    [sym_preproc_region] = STATE(321),
    [sym_preproc_endregion] = STATE(321),
    [sym_preproc_line] = STATE(321),
    [sym_preproc_pragma] = STATE(321),
    [sym_preproc_nullable] = STATE(321),
    [sym_preproc_error] = STATE(321),
    [sym_preproc_define] = STATE(321),
    [sym_preproc_undef] = STATE(321),
    [aux_sym_class_declaration_repeat1] = STATE(3836),
    [aux_sym_lambda_expression_repeat1] = STATE(4216),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_COMMA] = ACTIONS(1133),
    [anon_sym_LPAREN] = ACTIONS(2003),
    [anon_sym_ref] = ACTIONS(2005),
    [anon_sym_LBRACE] = ACTIONS(1611),
    [anon_sym_delegate] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1615),
    [anon_sym_LT] = ACTIONS(1147),
    [anon_sym_GT] = ACTIONS(1147),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1147),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(2007),
    [anon_sym_TILDE] = ACTIONS(2009),
    [anon_sym_PLUS_PLUS] = ACTIONS(2009),
    [anon_sym_DASH_DASH] = ACTIONS(2009),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(2007),
    [anon_sym_DASH] = ACTIONS(2007),
    [anon_sym_STAR] = ACTIONS(1625),
    [anon_sym_SLASH] = ACTIONS(1147),
    [anon_sym_PERCENT] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(2009),
    [anon_sym_PIPE] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(2007),
    [anon_sym_LT_LT] = ACTIONS(1133),
    [anon_sym_GT_GT] = ACTIONS(1147),
    [anon_sym_GT_GT_GT] = ACTIONS(1133),
    [anon_sym_EQ_EQ] = ACTIONS(1133),
    [anon_sym_BANG_EQ] = ACTIONS(1133),
    [anon_sym_GT_EQ] = ACTIONS(1133),
    [anon_sym_LT_EQ] = ACTIONS(1133),
    [anon_sym_this] = ACTIONS(1627),
    [anon_sym_DOT] = ACTIONS(1147),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1629),
    [anon_sym_unchecked] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1147),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(2011),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2013),
    [anon_sym_DOT_DOT] = ACTIONS(2015),
    [anon_sym_AMP_AMP] = ACTIONS(1133),
    [anon_sym_PIPE_PIPE] = ACTIONS(1133),
    [anon_sym_QMARK_QMARK] = ACTIONS(1133),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1147),
    [anon_sym_is] = ACTIONS(1147),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_DASH_GT] = ACTIONS(1133),
    [anon_sym_stackalloc] = ACTIONS(1641),
    [anon_sym_with] = ACTIONS(1147),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(1647),
    [anon_sym___reftype] = ACTIONS(1649),
    [anon_sym___refvalue] = ACTIONS(1651),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1659),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [322] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3559),
    [sym__name] = STATE(6877),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2908),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6958),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4524),
    [sym_non_lvalue_expression] = STATE(4553),
    [sym_lvalue_expression] = STATE(3691),
    [sym__expression_statement_expression] = STATE(4559),
    [sym_assignment_expression] = STATE(4558),
    [sym_binary_expression] = STATE(4559),
    [sym_postfix_unary_expression] = STATE(4558),
    [sym_prefix_unary_expression] = STATE(4558),
    [sym__pointer_indirection_expression] = STATE(3560),
    [sym_query_expression] = STATE(4559),
    [sym_from_clause] = STATE(7406),
    [sym_conditional_expression] = STATE(4559),
    [sym_conditional_access_expression] = STATE(4559),
    [sym_as_expression] = STATE(4559),
    [sym_is_expression] = STATE(4559),
    [sym_is_pattern_expression] = STATE(4559),
    [sym_cast_expression] = STATE(4559),
    [sym_checked_expression] = STATE(4559),
    [sym_invocation_expression] = STATE(4558),
    [sym_switch_expression] = STATE(4559),
    [sym_await_expression] = STATE(4558),
    [sym_throw_expression] = STATE(4559),
    [sym_element_access_expression] = STATE(3560),
    [sym_interpolated_string_expression] = STATE(4559),
    [sym_member_access_expression] = STATE(3560),
    [sym_object_creation_expression] = STATE(4558),
    [sym_parenthesized_expression] = STATE(4558),
    [sym__parenthesized_lvalue_expression] = STATE(3560),
    [sym_lambda_expression] = STATE(4559),
    [sym__lambda_parameters] = STATE(9348),
    [sym_array_creation_expression] = STATE(4559),
    [sym_anonymous_method_expression] = STATE(4559),
    [sym_anonymous_object_creation_expression] = STATE(4559),
    [sym_implicit_array_creation_expression] = STATE(4559),
    [sym_implicit_object_creation_expression] = STATE(4559),
    [sym_implicit_stackalloc_expression] = STATE(4559),
    [sym_initializer_expression] = STATE(4559),
    [sym_default_expression] = STATE(4559),
    [sym_with_expression] = STATE(4559),
    [sym_sizeof_expression] = STATE(4559),
    [sym_typeof_expression] = STATE(4559),
    [sym_makeref_expression] = STATE(4559),
    [sym_ref_expression] = STATE(4559),
    [sym_reftype_expression] = STATE(4559),
    [sym_refvalue_expression] = STATE(4559),
    [sym_stackalloc_expression] = STATE(4559),
    [sym_range_expression] = STATE(4559),
    [sym_tuple_expression] = STATE(3560),
    [sym_literal] = STATE(4559),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4559),
    [sym_preproc_region] = STATE(322),
    [sym_preproc_endregion] = STATE(322),
    [sym_preproc_line] = STATE(322),
    [sym_preproc_pragma] = STATE(322),
    [sym_preproc_nullable] = STATE(322),
    [sym_preproc_error] = STATE(322),
    [sym_preproc_define] = STATE(322),
    [sym_preproc_undef] = STATE(322),
    [aux_sym_class_declaration_repeat1] = STATE(3810),
    [aux_sym_lambda_expression_repeat1] = STATE(4141),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_COMMA] = ACTIONS(1199),
    [anon_sym_LPAREN] = ACTIONS(2047),
    [anon_sym_ref] = ACTIONS(2049),
    [anon_sym_LBRACE] = ACTIONS(1611),
    [anon_sym_delegate] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1679),
    [anon_sym_LT] = ACTIONS(1201),
    [anon_sym_GT] = ACTIONS(1201),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1201),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(2051),
    [anon_sym_TILDE] = ACTIONS(2053),
    [anon_sym_PLUS_PLUS] = ACTIONS(2053),
    [anon_sym_DASH_DASH] = ACTIONS(2053),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(2051),
    [anon_sym_DASH] = ACTIONS(2051),
    [anon_sym_STAR] = ACTIONS(1685),
    [anon_sym_SLASH] = ACTIONS(1201),
    [anon_sym_PERCENT] = ACTIONS(1199),
    [anon_sym_CARET] = ACTIONS(2053),
    [anon_sym_PIPE] = ACTIONS(1201),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_LT_LT] = ACTIONS(1199),
    [anon_sym_GT_GT] = ACTIONS(1201),
    [anon_sym_GT_GT_GT] = ACTIONS(1199),
    [anon_sym_EQ_EQ] = ACTIONS(1199),
    [anon_sym_BANG_EQ] = ACTIONS(1199),
    [anon_sym_GT_EQ] = ACTIONS(1199),
    [anon_sym_LT_EQ] = ACTIONS(1199),
    [anon_sym_this] = ACTIONS(1627),
    [anon_sym_DOT] = ACTIONS(1201),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1629),
    [anon_sym_unchecked] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1201),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(2055),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2057),
    [anon_sym_DOT_DOT] = ACTIONS(2059),
    [anon_sym_AMP_AMP] = ACTIONS(1199),
    [anon_sym_PIPE_PIPE] = ACTIONS(1199),
    [anon_sym_QMARK_QMARK] = ACTIONS(1199),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1201),
    [anon_sym_is] = ACTIONS(1201),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_DASH_GT] = ACTIONS(1199),
    [anon_sym_stackalloc] = ACTIONS(1641),
    [anon_sym_with] = ACTIONS(1201),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(1647),
    [anon_sym___reftype] = ACTIONS(1649),
    [anon_sym___refvalue] = ACTIONS(1651),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1659),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [323] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6987),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6498),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4462),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7405),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9130),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(323),
    [sym_preproc_endregion] = STATE(323),
    [sym_preproc_line] = STATE(323),
    [sym_preproc_pragma] = STATE(323),
    [sym_preproc_nullable] = STATE(323),
    [sym_preproc_error] = STATE(323),
    [sym_preproc_define] = STATE(323),
    [sym_preproc_undef] = STATE(323),
    [aux_sym_class_declaration_repeat1] = STATE(3855),
    [aux_sym_lambda_expression_repeat1] = STATE(4244),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2031),
    [anon_sym_ref] = ACTIONS(2033),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(1201),
    [anon_sym_GT] = ACTIONS(1201),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1201),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2035),
    [anon_sym_TILDE] = ACTIONS(2037),
    [anon_sym_PLUS_PLUS] = ACTIONS(2037),
    [anon_sym_DASH_DASH] = ACTIONS(2037),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2035),
    [anon_sym_DASH] = ACTIONS(2035),
    [anon_sym_STAR] = ACTIONS(2039),
    [anon_sym_SLASH] = ACTIONS(1201),
    [anon_sym_PERCENT] = ACTIONS(1199),
    [anon_sym_CARET] = ACTIONS(2037),
    [anon_sym_PIPE] = ACTIONS(1201),
    [anon_sym_AMP] = ACTIONS(2035),
    [anon_sym_LT_LT] = ACTIONS(1199),
    [anon_sym_GT_GT] = ACTIONS(1201),
    [anon_sym_GT_GT_GT] = ACTIONS(1199),
    [anon_sym_EQ_EQ] = ACTIONS(1199),
    [anon_sym_BANG_EQ] = ACTIONS(1199),
    [anon_sym_GT_EQ] = ACTIONS(1199),
    [anon_sym_LT_EQ] = ACTIONS(1199),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(1201),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_EQ_GT] = ACTIONS(1199),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1201),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2041),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2043),
    [anon_sym_DOT_DOT] = ACTIONS(2045),
    [anon_sym_AMP_AMP] = ACTIONS(1199),
    [anon_sym_PIPE_PIPE] = ACTIONS(1199),
    [anon_sym_QMARK_QMARK] = ACTIONS(1199),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1201),
    [anon_sym_is] = ACTIONS(1201),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_DASH_GT] = ACTIONS(1199),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_with] = ACTIONS(1201),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [324] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6980),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6517),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4482),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9438),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(324),
    [sym_preproc_endregion] = STATE(324),
    [sym_preproc_line] = STATE(324),
    [sym_preproc_pragma] = STATE(324),
    [sym_preproc_nullable] = STATE(324),
    [sym_preproc_error] = STATE(324),
    [sym_preproc_define] = STATE(324),
    [sym_preproc_undef] = STATE(324),
    [aux_sym_class_declaration_repeat1] = STATE(3801),
    [aux_sym_lambda_expression_repeat1] = STATE(4134),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_COLON] = ACTIONS(1199),
    [anon_sym_LPAREN] = ACTIONS(1993),
    [anon_sym_ref] = ACTIONS(1995),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1201),
    [anon_sym_GT] = ACTIONS(1201),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1201),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1997),
    [anon_sym_TILDE] = ACTIONS(1999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1999),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_SLASH] = ACTIONS(1201),
    [anon_sym_PERCENT] = ACTIONS(1199),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_PIPE] = ACTIONS(1201),
    [anon_sym_AMP] = ACTIONS(1997),
    [anon_sym_LT_LT] = ACTIONS(1199),
    [anon_sym_GT_GT] = ACTIONS(1201),
    [anon_sym_GT_GT_GT] = ACTIONS(1199),
    [anon_sym_EQ_EQ] = ACTIONS(1199),
    [anon_sym_BANG_EQ] = ACTIONS(1199),
    [anon_sym_GT_EQ] = ACTIONS(1199),
    [anon_sym_LT_EQ] = ACTIONS(1199),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(1201),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1201),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1281),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1283),
    [anon_sym_DOT_DOT] = ACTIONS(1285),
    [anon_sym_AMP_AMP] = ACTIONS(1199),
    [anon_sym_PIPE_PIPE] = ACTIONS(1199),
    [anon_sym_QMARK_QMARK] = ACTIONS(1199),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1201),
    [anon_sym_is] = ACTIONS(1201),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_DASH_GT] = ACTIONS(1199),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_with] = ACTIONS(1201),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [325] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6894),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2955),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7046),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4970),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(3786),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7408),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9363),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(325),
    [sym_preproc_endregion] = STATE(325),
    [sym_preproc_line] = STATE(325),
    [sym_preproc_pragma] = STATE(325),
    [sym_preproc_nullable] = STATE(325),
    [sym_preproc_error] = STATE(325),
    [sym_preproc_define] = STATE(325),
    [sym_preproc_undef] = STATE(325),
    [aux_sym_class_declaration_repeat1] = STATE(3811),
    [aux_sym_lambda_expression_repeat1] = STATE(4149),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2069),
    [anon_sym_ref] = ACTIONS(2071),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1853),
    [anon_sym_LT] = ACTIONS(1147),
    [anon_sym_GT] = ACTIONS(1147),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1147),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2075),
    [anon_sym_PLUS_PLUS] = ACTIONS(2075),
    [anon_sym_DASH_DASH] = ACTIONS(2075),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2073),
    [anon_sym_DASH] = ACTIONS(2073),
    [anon_sym_STAR] = ACTIONS(1859),
    [anon_sym_SLASH] = ACTIONS(1147),
    [anon_sym_PERCENT] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(2075),
    [anon_sym_PIPE] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(2073),
    [anon_sym_LT_LT] = ACTIONS(1133),
    [anon_sym_GT_GT] = ACTIONS(1147),
    [anon_sym_GT_GT_GT] = ACTIONS(1133),
    [anon_sym_EQ_EQ] = ACTIONS(1133),
    [anon_sym_BANG_EQ] = ACTIONS(1133),
    [anon_sym_GT_EQ] = ACTIONS(1133),
    [anon_sym_LT_EQ] = ACTIONS(1133),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_DOT] = ACTIONS(1147),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1147),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2077),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2079),
    [anon_sym_DOT_DOT] = ACTIONS(2081),
    [anon_sym_AMP_AMP] = ACTIONS(1133),
    [anon_sym_PIPE_PIPE] = ACTIONS(1133),
    [anon_sym_QMARK_QMARK] = ACTIONS(1133),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1147),
    [anon_sym_is] = ACTIONS(1147),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_DASH_GT] = ACTIONS(1133),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_with] = ACTIONS(1147),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [326] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6727),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2839),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6146),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_pattern] = STATE(8186),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(6657),
    [sym_property_pattern_clause] = STATE(6741),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6659),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(5071),
    [sym_postfix_unary_expression] = STATE(5061),
    [sym_prefix_unary_expression] = STATE(5061),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(5071),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(5061),
    [sym_switch_expression] = STATE(3774),
    [sym_switch_expression_arm] = STATE(8743),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(5071),
    [sym_member_access_expression] = STATE(3775),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(5061),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(5071),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(5071),
    [sym_typeof_expression] = STATE(5071),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3775),
    [sym_literal] = STATE(5071),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(326),
    [sym_preproc_endregion] = STATE(326),
    [sym_preproc_line] = STATE(326),
    [sym_preproc_pragma] = STATE(326),
    [sym_preproc_nullable] = STATE(326),
    [sym_preproc_error] = STATE(326),
    [sym_preproc_define] = STATE(326),
    [sym_preproc_undef] = STATE(326),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_ref] = ACTIONS(1925),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_RBRACE] = ACTIONS(2083),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(1929),
    [anon_sym_GT] = ACTIONS(1929),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1749),
    [anon_sym_TILDE] = ACTIONS(1749),
    [anon_sym_PLUS_PLUS] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1749),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1747),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1749),
    [anon_sym_AMP] = ACTIONS(1749),
    [anon_sym_GT_EQ] = ACTIONS(1931),
    [anon_sym_LT_EQ] = ACTIONS(1931),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1065),
    [anon_sym_var] = ACTIONS(1933),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(1935),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [327] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6727),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2839),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6146),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_pattern] = STATE(8186),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(6657),
    [sym_property_pattern_clause] = STATE(6741),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6659),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(5071),
    [sym_postfix_unary_expression] = STATE(5061),
    [sym_prefix_unary_expression] = STATE(5061),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(5071),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(5061),
    [sym_switch_expression] = STATE(3774),
    [sym_switch_expression_arm] = STATE(8743),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(5071),
    [sym_member_access_expression] = STATE(3775),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(5061),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(5071),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(5071),
    [sym_typeof_expression] = STATE(5071),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3775),
    [sym_literal] = STATE(5071),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(327),
    [sym_preproc_endregion] = STATE(327),
    [sym_preproc_line] = STATE(327),
    [sym_preproc_pragma] = STATE(327),
    [sym_preproc_nullable] = STATE(327),
    [sym_preproc_error] = STATE(327),
    [sym_preproc_define] = STATE(327),
    [sym_preproc_undef] = STATE(327),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_ref] = ACTIONS(1925),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_RBRACE] = ACTIONS(2085),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(1929),
    [anon_sym_GT] = ACTIONS(1929),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1749),
    [anon_sym_TILDE] = ACTIONS(1749),
    [anon_sym_PLUS_PLUS] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1749),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1747),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1749),
    [anon_sym_AMP] = ACTIONS(1749),
    [anon_sym_GT_EQ] = ACTIONS(1931),
    [anon_sym_LT_EQ] = ACTIONS(1931),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1065),
    [anon_sym_var] = ACTIONS(1933),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(1935),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [328] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6727),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2839),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6146),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_pattern] = STATE(8186),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(6657),
    [sym_property_pattern_clause] = STATE(6741),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6659),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(5071),
    [sym_postfix_unary_expression] = STATE(5061),
    [sym_prefix_unary_expression] = STATE(5061),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(5071),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(5061),
    [sym_switch_expression] = STATE(3774),
    [sym_switch_expression_arm] = STATE(8743),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(5071),
    [sym_member_access_expression] = STATE(3775),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(5061),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(5071),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(5071),
    [sym_typeof_expression] = STATE(5071),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3775),
    [sym_literal] = STATE(5071),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(328),
    [sym_preproc_endregion] = STATE(328),
    [sym_preproc_line] = STATE(328),
    [sym_preproc_pragma] = STATE(328),
    [sym_preproc_nullable] = STATE(328),
    [sym_preproc_error] = STATE(328),
    [sym_preproc_define] = STATE(328),
    [sym_preproc_undef] = STATE(328),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_ref] = ACTIONS(1925),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_RBRACE] = ACTIONS(2087),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(1929),
    [anon_sym_GT] = ACTIONS(1929),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1749),
    [anon_sym_TILDE] = ACTIONS(1749),
    [anon_sym_PLUS_PLUS] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1749),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1747),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1749),
    [anon_sym_AMP] = ACTIONS(1749),
    [anon_sym_GT_EQ] = ACTIONS(1931),
    [anon_sym_LT_EQ] = ACTIONS(1931),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1065),
    [anon_sym_var] = ACTIONS(1933),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(1935),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [329] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2789),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(5669),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_pattern] = STATE(8221),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(6141),
    [sym_property_pattern_clause] = STATE(6672),
    [sym_subpattern] = STATE(8532),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6495),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4482),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(5313),
    [sym_postfix_unary_expression] = STATE(5314),
    [sym_prefix_unary_expression] = STATE(5314),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(5313),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(5314),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(5313),
    [sym_member_access_expression] = STATE(3856),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(5314),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9438),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(5313),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(5313),
    [sym_typeof_expression] = STATE(5313),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3856),
    [sym_literal] = STATE(5313),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(329),
    [sym_preproc_endregion] = STATE(329),
    [sym_preproc_line] = STATE(329),
    [sym_preproc_pragma] = STATE(329),
    [sym_preproc_nullable] = STATE(329),
    [sym_preproc_error] = STATE(329),
    [sym_preproc_define] = STATE(329),
    [sym_preproc_undef] = STATE(329),
    [aux_sym_class_declaration_repeat1] = STATE(3801),
    [aux_sym_lambda_expression_repeat1] = STATE(4134),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(1203),
    [anon_sym_ref] = ACTIONS(1959),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_RBRACE] = ACTIONS(2089),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1053),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1097),
    [anon_sym_TILDE] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1099),
    [anon_sym_DASH] = ACTIONS(1099),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1097),
    [anon_sym_GT_EQ] = ACTIONS(1063),
    [anon_sym_LT_EQ] = ACTIONS(1063),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1065),
    [anon_sym_var] = ACTIONS(1067),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1281),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1283),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(1285),
    [anon_sym_not] = ACTIONS(1077),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [330] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6727),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2839),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6146),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_pattern] = STATE(8186),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(6657),
    [sym_property_pattern_clause] = STATE(6741),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6659),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(5071),
    [sym_postfix_unary_expression] = STATE(5061),
    [sym_prefix_unary_expression] = STATE(5061),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(5071),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(5061),
    [sym_switch_expression] = STATE(3774),
    [sym_switch_expression_arm] = STATE(8743),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(5071),
    [sym_member_access_expression] = STATE(3775),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(5061),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(5071),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(5071),
    [sym_typeof_expression] = STATE(5071),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3775),
    [sym_literal] = STATE(5071),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(330),
    [sym_preproc_endregion] = STATE(330),
    [sym_preproc_line] = STATE(330),
    [sym_preproc_pragma] = STATE(330),
    [sym_preproc_nullable] = STATE(330),
    [sym_preproc_error] = STATE(330),
    [sym_preproc_define] = STATE(330),
    [sym_preproc_undef] = STATE(330),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_ref] = ACTIONS(1925),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_RBRACE] = ACTIONS(2091),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(1929),
    [anon_sym_GT] = ACTIONS(1929),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1749),
    [anon_sym_TILDE] = ACTIONS(1749),
    [anon_sym_PLUS_PLUS] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1749),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1747),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1749),
    [anon_sym_AMP] = ACTIONS(1749),
    [anon_sym_GT_EQ] = ACTIONS(1931),
    [anon_sym_LT_EQ] = ACTIONS(1931),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1065),
    [anon_sym_var] = ACTIONS(1933),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(1935),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [331] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6727),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2839),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6146),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_pattern] = STATE(8186),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(6657),
    [sym_property_pattern_clause] = STATE(6741),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6659),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(5071),
    [sym_postfix_unary_expression] = STATE(5061),
    [sym_prefix_unary_expression] = STATE(5061),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(5071),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(5061),
    [sym_switch_expression] = STATE(3774),
    [sym_switch_expression_arm] = STATE(8743),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(5071),
    [sym_member_access_expression] = STATE(3775),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(5061),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(5071),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(5071),
    [sym_typeof_expression] = STATE(5071),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3775),
    [sym_literal] = STATE(5071),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(331),
    [sym_preproc_endregion] = STATE(331),
    [sym_preproc_line] = STATE(331),
    [sym_preproc_pragma] = STATE(331),
    [sym_preproc_nullable] = STATE(331),
    [sym_preproc_error] = STATE(331),
    [sym_preproc_define] = STATE(331),
    [sym_preproc_undef] = STATE(331),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_ref] = ACTIONS(1925),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_RBRACE] = ACTIONS(2093),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(1929),
    [anon_sym_GT] = ACTIONS(1929),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1749),
    [anon_sym_TILDE] = ACTIONS(1749),
    [anon_sym_PLUS_PLUS] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1749),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1747),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1749),
    [anon_sym_AMP] = ACTIONS(1749),
    [anon_sym_GT_EQ] = ACTIONS(1931),
    [anon_sym_LT_EQ] = ACTIONS(1931),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1065),
    [anon_sym_var] = ACTIONS(1933),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(1935),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [332] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6727),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2839),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6146),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_pattern] = STATE(8186),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(6657),
    [sym_property_pattern_clause] = STATE(6741),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6659),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(5071),
    [sym_postfix_unary_expression] = STATE(5061),
    [sym_prefix_unary_expression] = STATE(5061),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(5071),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(5061),
    [sym_switch_expression] = STATE(3774),
    [sym_switch_expression_arm] = STATE(8743),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(5071),
    [sym_member_access_expression] = STATE(3775),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(5061),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(5071),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(5071),
    [sym_typeof_expression] = STATE(5071),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3775),
    [sym_literal] = STATE(5071),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(332),
    [sym_preproc_endregion] = STATE(332),
    [sym_preproc_line] = STATE(332),
    [sym_preproc_pragma] = STATE(332),
    [sym_preproc_nullable] = STATE(332),
    [sym_preproc_error] = STATE(332),
    [sym_preproc_define] = STATE(332),
    [sym_preproc_undef] = STATE(332),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_ref] = ACTIONS(1925),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_RBRACE] = ACTIONS(2095),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(1929),
    [anon_sym_GT] = ACTIONS(1929),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1749),
    [anon_sym_TILDE] = ACTIONS(1749),
    [anon_sym_PLUS_PLUS] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1749),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1747),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1749),
    [anon_sym_AMP] = ACTIONS(1749),
    [anon_sym_GT_EQ] = ACTIONS(1931),
    [anon_sym_LT_EQ] = ACTIONS(1931),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1065),
    [anon_sym_var] = ACTIONS(1933),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(1935),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [333] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6881),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2964),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6972),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6565),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4495),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7398),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9102),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(333),
    [sym_preproc_endregion] = STATE(333),
    [sym_preproc_line] = STATE(333),
    [sym_preproc_pragma] = STATE(333),
    [sym_preproc_nullable] = STATE(333),
    [sym_preproc_error] = STATE(333),
    [sym_preproc_define] = STATE(333),
    [sym_preproc_undef] = STATE(333),
    [aux_sym_class_declaration_repeat1] = STATE(3857),
    [aux_sym_lambda_expression_repeat1] = STATE(4241),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2097),
    [anon_sym_ref] = ACTIONS(2099),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2101),
    [anon_sym_LT] = ACTIONS(1147),
    [anon_sym_GT] = ACTIONS(1147),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1147),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2103),
    [anon_sym_TILDE] = ACTIONS(2105),
    [anon_sym_PLUS_PLUS] = ACTIONS(2105),
    [anon_sym_DASH_DASH] = ACTIONS(2105),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2103),
    [anon_sym_DASH] = ACTIONS(2103),
    [anon_sym_STAR] = ACTIONS(2107),
    [anon_sym_SLASH] = ACTIONS(1147),
    [anon_sym_PERCENT] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(2105),
    [anon_sym_PIPE] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(2103),
    [anon_sym_LT_LT] = ACTIONS(1133),
    [anon_sym_GT_GT] = ACTIONS(1147),
    [anon_sym_GT_GT_GT] = ACTIONS(1133),
    [anon_sym_EQ_EQ] = ACTIONS(1133),
    [anon_sym_BANG_EQ] = ACTIONS(1133),
    [anon_sym_GT_EQ] = ACTIONS(1133),
    [anon_sym_LT_EQ] = ACTIONS(1133),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(1147),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1147),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2111),
    [anon_sym_DOT_DOT] = ACTIONS(2113),
    [anon_sym_AMP_AMP] = ACTIONS(1133),
    [anon_sym_PIPE_PIPE] = ACTIONS(1133),
    [anon_sym_QMARK_QMARK] = ACTIONS(1133),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1147),
    [anon_sym_is] = ACTIONS(1147),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_DASH_GT] = ACTIONS(1133),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_with] = ACTIONS(1147),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [334] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6887),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2935),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6959),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6096),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4399),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7410),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9332),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(334),
    [sym_preproc_endregion] = STATE(334),
    [sym_preproc_line] = STATE(334),
    [sym_preproc_pragma] = STATE(334),
    [sym_preproc_nullable] = STATE(334),
    [sym_preproc_error] = STATE(334),
    [sym_preproc_define] = STATE(334),
    [sym_preproc_undef] = STATE(334),
    [aux_sym_class_declaration_repeat1] = STATE(3807),
    [aux_sym_lambda_expression_repeat1] = STATE(4128),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2115),
    [anon_sym_ref] = ACTIONS(2117),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2119),
    [anon_sym_LT] = ACTIONS(1201),
    [anon_sym_GT] = ACTIONS(1201),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1201),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(2121),
    [anon_sym_TILDE] = ACTIONS(2123),
    [anon_sym_PLUS_PLUS] = ACTIONS(2123),
    [anon_sym_DASH_DASH] = ACTIONS(2123),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2121),
    [anon_sym_DASH] = ACTIONS(2121),
    [anon_sym_STAR] = ACTIONS(2125),
    [anon_sym_SLASH] = ACTIONS(1201),
    [anon_sym_PERCENT] = ACTIONS(1199),
    [anon_sym_CARET] = ACTIONS(2123),
    [anon_sym_PIPE] = ACTIONS(1201),
    [anon_sym_AMP] = ACTIONS(2121),
    [anon_sym_LT_LT] = ACTIONS(1199),
    [anon_sym_GT_GT] = ACTIONS(1201),
    [anon_sym_GT_GT_GT] = ACTIONS(1199),
    [anon_sym_EQ_EQ] = ACTIONS(1199),
    [anon_sym_BANG_EQ] = ACTIONS(1199),
    [anon_sym_GT_EQ] = ACTIONS(1199),
    [anon_sym_LT_EQ] = ACTIONS(1199),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_DOT] = ACTIONS(1201),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1201),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2127),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2129),
    [anon_sym_DOT_DOT] = ACTIONS(2131),
    [anon_sym_AMP_AMP] = ACTIONS(1199),
    [anon_sym_PIPE_PIPE] = ACTIONS(1199),
    [anon_sym_QMARK_QMARK] = ACTIONS(1199),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1201),
    [anon_sym_is] = ACTIONS(1201),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_DASH_GT] = ACTIONS(1199),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_with] = ACTIONS(1201),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [335] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6727),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2839),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6146),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_pattern] = STATE(8186),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(6657),
    [sym_property_pattern_clause] = STATE(6741),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6659),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(5071),
    [sym_postfix_unary_expression] = STATE(5061),
    [sym_prefix_unary_expression] = STATE(5061),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(5071),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(5061),
    [sym_switch_expression] = STATE(3774),
    [sym_switch_expression_arm] = STATE(8743),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(5071),
    [sym_member_access_expression] = STATE(3775),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(5061),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(5071),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(5071),
    [sym_typeof_expression] = STATE(5071),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3775),
    [sym_literal] = STATE(5071),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(335),
    [sym_preproc_endregion] = STATE(335),
    [sym_preproc_line] = STATE(335),
    [sym_preproc_pragma] = STATE(335),
    [sym_preproc_nullable] = STATE(335),
    [sym_preproc_error] = STATE(335),
    [sym_preproc_define] = STATE(335),
    [sym_preproc_undef] = STATE(335),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_ref] = ACTIONS(1925),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_RBRACE] = ACTIONS(2133),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(1929),
    [anon_sym_GT] = ACTIONS(1929),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1749),
    [anon_sym_TILDE] = ACTIONS(1749),
    [anon_sym_PLUS_PLUS] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1749),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1747),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1749),
    [anon_sym_AMP] = ACTIONS(1749),
    [anon_sym_GT_EQ] = ACTIONS(1931),
    [anon_sym_LT_EQ] = ACTIONS(1931),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1065),
    [anon_sym_var] = ACTIONS(1933),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(1935),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [336] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6887),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2935),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6959),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6201),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4399),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7410),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9332),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(336),
    [sym_preproc_endregion] = STATE(336),
    [sym_preproc_line] = STATE(336),
    [sym_preproc_pragma] = STATE(336),
    [sym_preproc_nullable] = STATE(336),
    [sym_preproc_error] = STATE(336),
    [sym_preproc_define] = STATE(336),
    [sym_preproc_undef] = STATE(336),
    [aux_sym_class_declaration_repeat1] = STATE(3807),
    [aux_sym_lambda_expression_repeat1] = STATE(4128),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2115),
    [anon_sym_ref] = ACTIONS(2117),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2119),
    [anon_sym_LT] = ACTIONS(1147),
    [anon_sym_GT] = ACTIONS(1147),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1147),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(2121),
    [anon_sym_TILDE] = ACTIONS(2123),
    [anon_sym_PLUS_PLUS] = ACTIONS(2123),
    [anon_sym_DASH_DASH] = ACTIONS(2123),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2121),
    [anon_sym_DASH] = ACTIONS(2121),
    [anon_sym_STAR] = ACTIONS(2125),
    [anon_sym_SLASH] = ACTIONS(1147),
    [anon_sym_PERCENT] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(2123),
    [anon_sym_PIPE] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(2121),
    [anon_sym_LT_LT] = ACTIONS(1133),
    [anon_sym_GT_GT] = ACTIONS(1147),
    [anon_sym_GT_GT_GT] = ACTIONS(1133),
    [anon_sym_EQ_EQ] = ACTIONS(1133),
    [anon_sym_BANG_EQ] = ACTIONS(1133),
    [anon_sym_GT_EQ] = ACTIONS(1133),
    [anon_sym_LT_EQ] = ACTIONS(1133),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_DOT] = ACTIONS(1147),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1147),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2127),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2129),
    [anon_sym_DOT_DOT] = ACTIONS(2131),
    [anon_sym_AMP_AMP] = ACTIONS(1133),
    [anon_sym_PIPE_PIPE] = ACTIONS(1133),
    [anon_sym_QMARK_QMARK] = ACTIONS(1133),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1147),
    [anon_sym_is] = ACTIONS(1147),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_DASH_GT] = ACTIONS(1133),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_with] = ACTIONS(1147),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [337] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2789),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(5669),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_pattern] = STATE(8221),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(6141),
    [sym_property_pattern_clause] = STATE(6672),
    [sym_subpattern] = STATE(8532),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6495),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4482),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(5313),
    [sym_postfix_unary_expression] = STATE(5314),
    [sym_prefix_unary_expression] = STATE(5314),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(5313),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(5314),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(5313),
    [sym_member_access_expression] = STATE(3856),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(5314),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9438),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(5313),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(5313),
    [sym_typeof_expression] = STATE(5313),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3856),
    [sym_literal] = STATE(5313),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(337),
    [sym_preproc_endregion] = STATE(337),
    [sym_preproc_line] = STATE(337),
    [sym_preproc_pragma] = STATE(337),
    [sym_preproc_nullable] = STATE(337),
    [sym_preproc_error] = STATE(337),
    [sym_preproc_define] = STATE(337),
    [sym_preproc_undef] = STATE(337),
    [aux_sym_class_declaration_repeat1] = STATE(3801),
    [aux_sym_lambda_expression_repeat1] = STATE(4134),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(1203),
    [anon_sym_ref] = ACTIONS(1959),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_RBRACE] = ACTIONS(2135),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1053),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1097),
    [anon_sym_TILDE] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1099),
    [anon_sym_DASH] = ACTIONS(1099),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1097),
    [anon_sym_GT_EQ] = ACTIONS(1063),
    [anon_sym_LT_EQ] = ACTIONS(1063),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1065),
    [anon_sym_var] = ACTIONS(1067),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1281),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1283),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(1285),
    [anon_sym_not] = ACTIONS(1077),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [338] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6727),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2839),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6146),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_pattern] = STATE(8186),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(6657),
    [sym_property_pattern_clause] = STATE(6741),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6659),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(5071),
    [sym_postfix_unary_expression] = STATE(5061),
    [sym_prefix_unary_expression] = STATE(5061),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(5071),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(5061),
    [sym_switch_expression] = STATE(3774),
    [sym_switch_expression_arm] = STATE(8743),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(5071),
    [sym_member_access_expression] = STATE(3775),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(5061),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(5071),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(5071),
    [sym_typeof_expression] = STATE(5071),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3775),
    [sym_literal] = STATE(5071),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(338),
    [sym_preproc_endregion] = STATE(338),
    [sym_preproc_line] = STATE(338),
    [sym_preproc_pragma] = STATE(338),
    [sym_preproc_nullable] = STATE(338),
    [sym_preproc_error] = STATE(338),
    [sym_preproc_define] = STATE(338),
    [sym_preproc_undef] = STATE(338),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_ref] = ACTIONS(1925),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_RBRACE] = ACTIONS(2137),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(1929),
    [anon_sym_GT] = ACTIONS(1929),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1749),
    [anon_sym_TILDE] = ACTIONS(1749),
    [anon_sym_PLUS_PLUS] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1749),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1747),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1749),
    [anon_sym_AMP] = ACTIONS(1749),
    [anon_sym_GT_EQ] = ACTIONS(1931),
    [anon_sym_LT_EQ] = ACTIONS(1931),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1065),
    [anon_sym_var] = ACTIONS(1933),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(1935),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [339] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6910),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2957),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7089),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5095),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(3796),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7395),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9374),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(339),
    [sym_preproc_endregion] = STATE(339),
    [sym_preproc_line] = STATE(339),
    [sym_preproc_pragma] = STATE(339),
    [sym_preproc_nullable] = STATE(339),
    [sym_preproc_error] = STATE(339),
    [sym_preproc_define] = STATE(339),
    [sym_preproc_undef] = STATE(339),
    [aux_sym_class_declaration_repeat1] = STATE(3839),
    [aux_sym_lambda_expression_repeat1] = STATE(4209),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2139),
    [anon_sym_ref] = ACTIONS(2141),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1799),
    [anon_sym_LT] = ACTIONS(1201),
    [anon_sym_GT] = ACTIONS(1201),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1201),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2143),
    [anon_sym_TILDE] = ACTIONS(2145),
    [anon_sym_PLUS_PLUS] = ACTIONS(2145),
    [anon_sym_DASH_DASH] = ACTIONS(2145),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2143),
    [anon_sym_DASH] = ACTIONS(2143),
    [anon_sym_STAR] = ACTIONS(1805),
    [anon_sym_SLASH] = ACTIONS(1201),
    [anon_sym_PERCENT] = ACTIONS(1199),
    [anon_sym_CARET] = ACTIONS(2145),
    [anon_sym_PIPE] = ACTIONS(1201),
    [anon_sym_AMP] = ACTIONS(2143),
    [anon_sym_LT_LT] = ACTIONS(1199),
    [anon_sym_GT_GT] = ACTIONS(1201),
    [anon_sym_GT_GT_GT] = ACTIONS(1199),
    [anon_sym_EQ_EQ] = ACTIONS(1199),
    [anon_sym_BANG_EQ] = ACTIONS(1199),
    [anon_sym_GT_EQ] = ACTIONS(1199),
    [anon_sym_LT_EQ] = ACTIONS(1199),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(1201),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1201),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2147),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2149),
    [anon_sym_DOT_DOT] = ACTIONS(2151),
    [anon_sym_AMP_AMP] = ACTIONS(1199),
    [anon_sym_PIPE_PIPE] = ACTIONS(1199),
    [anon_sym_QMARK_QMARK] = ACTIONS(1199),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1201),
    [anon_sym_is] = ACTIONS(1201),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_DASH_GT] = ACTIONS(1199),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_with] = ACTIONS(1201),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [340] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6898),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2940),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6925),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6480),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4498),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7403),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(8973),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(340),
    [sym_preproc_endregion] = STATE(340),
    [sym_preproc_line] = STATE(340),
    [sym_preproc_pragma] = STATE(340),
    [sym_preproc_nullable] = STATE(340),
    [sym_preproc_error] = STATE(340),
    [sym_preproc_define] = STATE(340),
    [sym_preproc_undef] = STATE(340),
    [aux_sym_class_declaration_repeat1] = STATE(3830),
    [aux_sym_lambda_expression_repeat1] = STATE(4194),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2153),
    [anon_sym_ref] = ACTIONS(2155),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2157),
    [anon_sym_LT] = ACTIONS(1147),
    [anon_sym_GT] = ACTIONS(1147),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1147),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2159),
    [anon_sym_TILDE] = ACTIONS(2161),
    [anon_sym_PLUS_PLUS] = ACTIONS(2161),
    [anon_sym_DASH_DASH] = ACTIONS(2161),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2159),
    [anon_sym_DASH] = ACTIONS(2159),
    [anon_sym_STAR] = ACTIONS(2163),
    [anon_sym_SLASH] = ACTIONS(1147),
    [anon_sym_PERCENT] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(2161),
    [anon_sym_PIPE] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(2159),
    [anon_sym_LT_LT] = ACTIONS(1133),
    [anon_sym_GT_GT] = ACTIONS(1147),
    [anon_sym_GT_GT_GT] = ACTIONS(1133),
    [anon_sym_EQ_EQ] = ACTIONS(1133),
    [anon_sym_BANG_EQ] = ACTIONS(1133),
    [anon_sym_GT_EQ] = ACTIONS(1133),
    [anon_sym_LT_EQ] = ACTIONS(1133),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(1147),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1147),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2165),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2167),
    [anon_sym_DOT_DOT] = ACTIONS(2169),
    [anon_sym_AMP_AMP] = ACTIONS(1133),
    [anon_sym_PIPE_PIPE] = ACTIONS(1133),
    [anon_sym_QMARK_QMARK] = ACTIONS(1133),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1147),
    [anon_sym_is] = ACTIONS(1147),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_DASH_GT] = ACTIONS(1133),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_with] = ACTIONS(1147),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [341] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6727),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2839),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6146),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_pattern] = STATE(8186),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(6657),
    [sym_property_pattern_clause] = STATE(6741),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6659),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(5071),
    [sym_postfix_unary_expression] = STATE(5061),
    [sym_prefix_unary_expression] = STATE(5061),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(5071),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(5061),
    [sym_switch_expression] = STATE(3774),
    [sym_switch_expression_arm] = STATE(8743),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(5071),
    [sym_member_access_expression] = STATE(3775),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(5061),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(5071),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(5071),
    [sym_typeof_expression] = STATE(5071),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3775),
    [sym_literal] = STATE(5071),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(341),
    [sym_preproc_endregion] = STATE(341),
    [sym_preproc_line] = STATE(341),
    [sym_preproc_pragma] = STATE(341),
    [sym_preproc_nullable] = STATE(341),
    [sym_preproc_error] = STATE(341),
    [sym_preproc_define] = STATE(341),
    [sym_preproc_undef] = STATE(341),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_ref] = ACTIONS(1925),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_RBRACE] = ACTIONS(2171),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(1929),
    [anon_sym_GT] = ACTIONS(1929),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1749),
    [anon_sym_TILDE] = ACTIONS(1749),
    [anon_sym_PLUS_PLUS] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1749),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1747),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1749),
    [anon_sym_AMP] = ACTIONS(1749),
    [anon_sym_GT_EQ] = ACTIONS(1931),
    [anon_sym_LT_EQ] = ACTIONS(1931),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1065),
    [anon_sym_var] = ACTIONS(1933),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(1935),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [342] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6727),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2839),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6146),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_pattern] = STATE(8186),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(6657),
    [sym_property_pattern_clause] = STATE(6741),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6659),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(5071),
    [sym_postfix_unary_expression] = STATE(5061),
    [sym_prefix_unary_expression] = STATE(5061),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(5071),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(5061),
    [sym_switch_expression] = STATE(3774),
    [sym_switch_expression_arm] = STATE(8743),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(5071),
    [sym_member_access_expression] = STATE(3775),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(5061),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(5071),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(5071),
    [sym_typeof_expression] = STATE(5071),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3775),
    [sym_literal] = STATE(5071),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(342),
    [sym_preproc_endregion] = STATE(342),
    [sym_preproc_line] = STATE(342),
    [sym_preproc_pragma] = STATE(342),
    [sym_preproc_nullable] = STATE(342),
    [sym_preproc_error] = STATE(342),
    [sym_preproc_define] = STATE(342),
    [sym_preproc_undef] = STATE(342),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_ref] = ACTIONS(1925),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_RBRACE] = ACTIONS(2173),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(1929),
    [anon_sym_GT] = ACTIONS(1929),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1749),
    [anon_sym_TILDE] = ACTIONS(1749),
    [anon_sym_PLUS_PLUS] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1749),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1747),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1749),
    [anon_sym_AMP] = ACTIONS(1749),
    [anon_sym_GT_EQ] = ACTIONS(1931),
    [anon_sym_LT_EQ] = ACTIONS(1931),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1065),
    [anon_sym_var] = ACTIONS(1933),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(1935),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [343] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6894),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2955),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7046),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4955),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(3786),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7408),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9363),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(343),
    [sym_preproc_endregion] = STATE(343),
    [sym_preproc_line] = STATE(343),
    [sym_preproc_pragma] = STATE(343),
    [sym_preproc_nullable] = STATE(343),
    [sym_preproc_error] = STATE(343),
    [sym_preproc_define] = STATE(343),
    [sym_preproc_undef] = STATE(343),
    [aux_sym_class_declaration_repeat1] = STATE(3811),
    [aux_sym_lambda_expression_repeat1] = STATE(4149),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2069),
    [anon_sym_ref] = ACTIONS(2071),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1853),
    [anon_sym_LT] = ACTIONS(1201),
    [anon_sym_GT] = ACTIONS(1201),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1201),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2075),
    [anon_sym_PLUS_PLUS] = ACTIONS(2075),
    [anon_sym_DASH_DASH] = ACTIONS(2075),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2073),
    [anon_sym_DASH] = ACTIONS(2073),
    [anon_sym_STAR] = ACTIONS(1859),
    [anon_sym_SLASH] = ACTIONS(1201),
    [anon_sym_PERCENT] = ACTIONS(1199),
    [anon_sym_CARET] = ACTIONS(2075),
    [anon_sym_PIPE] = ACTIONS(1201),
    [anon_sym_AMP] = ACTIONS(2073),
    [anon_sym_LT_LT] = ACTIONS(1199),
    [anon_sym_GT_GT] = ACTIONS(1201),
    [anon_sym_GT_GT_GT] = ACTIONS(1199),
    [anon_sym_EQ_EQ] = ACTIONS(1199),
    [anon_sym_BANG_EQ] = ACTIONS(1199),
    [anon_sym_GT_EQ] = ACTIONS(1199),
    [anon_sym_LT_EQ] = ACTIONS(1199),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_DOT] = ACTIONS(1201),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1201),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2077),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2079),
    [anon_sym_DOT_DOT] = ACTIONS(2081),
    [anon_sym_AMP_AMP] = ACTIONS(1199),
    [anon_sym_PIPE_PIPE] = ACTIONS(1199),
    [anon_sym_QMARK_QMARK] = ACTIONS(1199),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1201),
    [anon_sym_is] = ACTIONS(1201),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_DASH_GT] = ACTIONS(1199),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_with] = ACTIONS(1201),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [344] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6910),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2957),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7089),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5096),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(3796),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7395),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9374),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(344),
    [sym_preproc_endregion] = STATE(344),
    [sym_preproc_line] = STATE(344),
    [sym_preproc_pragma] = STATE(344),
    [sym_preproc_nullable] = STATE(344),
    [sym_preproc_error] = STATE(344),
    [sym_preproc_define] = STATE(344),
    [sym_preproc_undef] = STATE(344),
    [aux_sym_class_declaration_repeat1] = STATE(3839),
    [aux_sym_lambda_expression_repeat1] = STATE(4209),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2139),
    [anon_sym_ref] = ACTIONS(2141),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1799),
    [anon_sym_LT] = ACTIONS(1147),
    [anon_sym_GT] = ACTIONS(1147),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1147),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2143),
    [anon_sym_TILDE] = ACTIONS(2145),
    [anon_sym_PLUS_PLUS] = ACTIONS(2145),
    [anon_sym_DASH_DASH] = ACTIONS(2145),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2143),
    [anon_sym_DASH] = ACTIONS(2143),
    [anon_sym_STAR] = ACTIONS(1805),
    [anon_sym_SLASH] = ACTIONS(1147),
    [anon_sym_PERCENT] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(2145),
    [anon_sym_PIPE] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(2143),
    [anon_sym_LT_LT] = ACTIONS(1133),
    [anon_sym_GT_GT] = ACTIONS(1147),
    [anon_sym_GT_GT_GT] = ACTIONS(1133),
    [anon_sym_EQ_EQ] = ACTIONS(1133),
    [anon_sym_BANG_EQ] = ACTIONS(1133),
    [anon_sym_GT_EQ] = ACTIONS(1133),
    [anon_sym_LT_EQ] = ACTIONS(1133),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(1147),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1147),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2147),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2149),
    [anon_sym_DOT_DOT] = ACTIONS(2151),
    [anon_sym_AMP_AMP] = ACTIONS(1133),
    [anon_sym_PIPE_PIPE] = ACTIONS(1133),
    [anon_sym_QMARK_QMARK] = ACTIONS(1133),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1147),
    [anon_sym_is] = ACTIONS(1147),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_DASH_GT] = ACTIONS(1133),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_with] = ACTIONS(1147),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [345] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6905),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2944),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7006),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6205),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4413),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7404),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9233),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(345),
    [sym_preproc_endregion] = STATE(345),
    [sym_preproc_line] = STATE(345),
    [sym_preproc_pragma] = STATE(345),
    [sym_preproc_nullable] = STATE(345),
    [sym_preproc_error] = STATE(345),
    [sym_preproc_define] = STATE(345),
    [sym_preproc_undef] = STATE(345),
    [aux_sym_class_declaration_repeat1] = STATE(3803),
    [aux_sym_lambda_expression_repeat1] = STATE(4105),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2175),
    [anon_sym_ref] = ACTIONS(2177),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2179),
    [anon_sym_LT] = ACTIONS(1201),
    [anon_sym_GT] = ACTIONS(1201),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1201),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(2181),
    [anon_sym_TILDE] = ACTIONS(2183),
    [anon_sym_PLUS_PLUS] = ACTIONS(2183),
    [anon_sym_DASH_DASH] = ACTIONS(2183),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2181),
    [anon_sym_DASH] = ACTIONS(2181),
    [anon_sym_STAR] = ACTIONS(2185),
    [anon_sym_SLASH] = ACTIONS(1201),
    [anon_sym_PERCENT] = ACTIONS(1199),
    [anon_sym_CARET] = ACTIONS(2183),
    [anon_sym_PIPE] = ACTIONS(1201),
    [anon_sym_AMP] = ACTIONS(2181),
    [anon_sym_LT_LT] = ACTIONS(1199),
    [anon_sym_GT_GT] = ACTIONS(1201),
    [anon_sym_GT_GT_GT] = ACTIONS(1199),
    [anon_sym_EQ_EQ] = ACTIONS(1199),
    [anon_sym_BANG_EQ] = ACTIONS(1199),
    [anon_sym_GT_EQ] = ACTIONS(1199),
    [anon_sym_LT_EQ] = ACTIONS(1199),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_DOT] = ACTIONS(1201),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1201),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2187),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2189),
    [anon_sym_DOT_DOT] = ACTIONS(2191),
    [anon_sym_AMP_AMP] = ACTIONS(1199),
    [anon_sym_PIPE_PIPE] = ACTIONS(1199),
    [anon_sym_QMARK_QMARK] = ACTIONS(1199),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1201),
    [anon_sym_is] = ACTIONS(1201),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_DASH_GT] = ACTIONS(1199),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_with] = ACTIONS(1201),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [346] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6881),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2964),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6972),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6627),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4495),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7398),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9102),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(346),
    [sym_preproc_endregion] = STATE(346),
    [sym_preproc_line] = STATE(346),
    [sym_preproc_pragma] = STATE(346),
    [sym_preproc_nullable] = STATE(346),
    [sym_preproc_error] = STATE(346),
    [sym_preproc_define] = STATE(346),
    [sym_preproc_undef] = STATE(346),
    [aux_sym_class_declaration_repeat1] = STATE(3857),
    [aux_sym_lambda_expression_repeat1] = STATE(4241),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2097),
    [anon_sym_ref] = ACTIONS(2099),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2101),
    [anon_sym_LT] = ACTIONS(1201),
    [anon_sym_GT] = ACTIONS(1201),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1201),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2103),
    [anon_sym_TILDE] = ACTIONS(2105),
    [anon_sym_PLUS_PLUS] = ACTIONS(2105),
    [anon_sym_DASH_DASH] = ACTIONS(2105),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2103),
    [anon_sym_DASH] = ACTIONS(2103),
    [anon_sym_STAR] = ACTIONS(2107),
    [anon_sym_SLASH] = ACTIONS(1201),
    [anon_sym_PERCENT] = ACTIONS(1199),
    [anon_sym_CARET] = ACTIONS(2105),
    [anon_sym_PIPE] = ACTIONS(1201),
    [anon_sym_AMP] = ACTIONS(2103),
    [anon_sym_LT_LT] = ACTIONS(1199),
    [anon_sym_GT_GT] = ACTIONS(1201),
    [anon_sym_GT_GT_GT] = ACTIONS(1199),
    [anon_sym_EQ_EQ] = ACTIONS(1199),
    [anon_sym_BANG_EQ] = ACTIONS(1199),
    [anon_sym_GT_EQ] = ACTIONS(1199),
    [anon_sym_LT_EQ] = ACTIONS(1199),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(1201),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1201),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2111),
    [anon_sym_DOT_DOT] = ACTIONS(2113),
    [anon_sym_AMP_AMP] = ACTIONS(1199),
    [anon_sym_PIPE_PIPE] = ACTIONS(1199),
    [anon_sym_QMARK_QMARK] = ACTIONS(1199),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1201),
    [anon_sym_is] = ACTIONS(1201),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_DASH_GT] = ACTIONS(1199),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_with] = ACTIONS(1201),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [347] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6901),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2939),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7050),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6294),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4507),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7378),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9063),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(347),
    [sym_preproc_endregion] = STATE(347),
    [sym_preproc_line] = STATE(347),
    [sym_preproc_pragma] = STATE(347),
    [sym_preproc_nullable] = STATE(347),
    [sym_preproc_error] = STATE(347),
    [sym_preproc_define] = STATE(347),
    [sym_preproc_undef] = STATE(347),
    [aux_sym_class_declaration_repeat1] = STATE(3854),
    [aux_sym_lambda_expression_repeat1] = STATE(4229),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2193),
    [anon_sym_ref] = ACTIONS(2195),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2197),
    [anon_sym_LT] = ACTIONS(1147),
    [anon_sym_GT] = ACTIONS(1147),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1147),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2199),
    [anon_sym_TILDE] = ACTIONS(2201),
    [anon_sym_PLUS_PLUS] = ACTIONS(2201),
    [anon_sym_DASH_DASH] = ACTIONS(2201),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2199),
    [anon_sym_DASH] = ACTIONS(2199),
    [anon_sym_STAR] = ACTIONS(2203),
    [anon_sym_SLASH] = ACTIONS(1147),
    [anon_sym_PERCENT] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(2201),
    [anon_sym_PIPE] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(2199),
    [anon_sym_LT_LT] = ACTIONS(1133),
    [anon_sym_GT_GT] = ACTIONS(1147),
    [anon_sym_GT_GT_GT] = ACTIONS(1133),
    [anon_sym_EQ_EQ] = ACTIONS(1133),
    [anon_sym_BANG_EQ] = ACTIONS(1133),
    [anon_sym_GT_EQ] = ACTIONS(1133),
    [anon_sym_LT_EQ] = ACTIONS(1133),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(1147),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1147),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2205),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2207),
    [anon_sym_DOT_DOT] = ACTIONS(2209),
    [anon_sym_AMP_AMP] = ACTIONS(1133),
    [anon_sym_PIPE_PIPE] = ACTIONS(1133),
    [anon_sym_QMARK_QMARK] = ACTIONS(1133),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1147),
    [anon_sym_is] = ACTIONS(1147),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_DASH_GT] = ACTIONS(1133),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_with] = ACTIONS(1147),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [348] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6905),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2944),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7006),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6273),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4413),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7404),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9233),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(348),
    [sym_preproc_endregion] = STATE(348),
    [sym_preproc_line] = STATE(348),
    [sym_preproc_pragma] = STATE(348),
    [sym_preproc_nullable] = STATE(348),
    [sym_preproc_error] = STATE(348),
    [sym_preproc_define] = STATE(348),
    [sym_preproc_undef] = STATE(348),
    [aux_sym_class_declaration_repeat1] = STATE(3803),
    [aux_sym_lambda_expression_repeat1] = STATE(4105),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2175),
    [anon_sym_ref] = ACTIONS(2177),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2179),
    [anon_sym_LT] = ACTIONS(1147),
    [anon_sym_GT] = ACTIONS(1147),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1147),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(2181),
    [anon_sym_TILDE] = ACTIONS(2183),
    [anon_sym_PLUS_PLUS] = ACTIONS(2183),
    [anon_sym_DASH_DASH] = ACTIONS(2183),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2181),
    [anon_sym_DASH] = ACTIONS(2181),
    [anon_sym_STAR] = ACTIONS(2185),
    [anon_sym_SLASH] = ACTIONS(1147),
    [anon_sym_PERCENT] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(2183),
    [anon_sym_PIPE] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(2181),
    [anon_sym_LT_LT] = ACTIONS(1133),
    [anon_sym_GT_GT] = ACTIONS(1147),
    [anon_sym_GT_GT_GT] = ACTIONS(1133),
    [anon_sym_EQ_EQ] = ACTIONS(1133),
    [anon_sym_BANG_EQ] = ACTIONS(1133),
    [anon_sym_GT_EQ] = ACTIONS(1133),
    [anon_sym_LT_EQ] = ACTIONS(1133),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_DOT] = ACTIONS(1147),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1147),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2187),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2189),
    [anon_sym_DOT_DOT] = ACTIONS(2191),
    [anon_sym_AMP_AMP] = ACTIONS(1133),
    [anon_sym_PIPE_PIPE] = ACTIONS(1133),
    [anon_sym_QMARK_QMARK] = ACTIONS(1133),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1147),
    [anon_sym_is] = ACTIONS(1147),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_DASH_GT] = ACTIONS(1133),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_with] = ACTIONS(1147),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [349] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6898),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2940),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6925),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6423),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4498),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7403),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(8973),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(349),
    [sym_preproc_endregion] = STATE(349),
    [sym_preproc_line] = STATE(349),
    [sym_preproc_pragma] = STATE(349),
    [sym_preproc_nullable] = STATE(349),
    [sym_preproc_error] = STATE(349),
    [sym_preproc_define] = STATE(349),
    [sym_preproc_undef] = STATE(349),
    [aux_sym_class_declaration_repeat1] = STATE(3830),
    [aux_sym_lambda_expression_repeat1] = STATE(4194),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2153),
    [anon_sym_ref] = ACTIONS(2155),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2157),
    [anon_sym_LT] = ACTIONS(1201),
    [anon_sym_GT] = ACTIONS(1201),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1201),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2159),
    [anon_sym_TILDE] = ACTIONS(2161),
    [anon_sym_PLUS_PLUS] = ACTIONS(2161),
    [anon_sym_DASH_DASH] = ACTIONS(2161),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2159),
    [anon_sym_DASH] = ACTIONS(2159),
    [anon_sym_STAR] = ACTIONS(2163),
    [anon_sym_SLASH] = ACTIONS(1201),
    [anon_sym_PERCENT] = ACTIONS(1199),
    [anon_sym_CARET] = ACTIONS(2161),
    [anon_sym_PIPE] = ACTIONS(1201),
    [anon_sym_AMP] = ACTIONS(2159),
    [anon_sym_LT_LT] = ACTIONS(1199),
    [anon_sym_GT_GT] = ACTIONS(1201),
    [anon_sym_GT_GT_GT] = ACTIONS(1199),
    [anon_sym_EQ_EQ] = ACTIONS(1199),
    [anon_sym_BANG_EQ] = ACTIONS(1199),
    [anon_sym_GT_EQ] = ACTIONS(1199),
    [anon_sym_LT_EQ] = ACTIONS(1199),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(1201),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1201),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2165),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2167),
    [anon_sym_DOT_DOT] = ACTIONS(2169),
    [anon_sym_AMP_AMP] = ACTIONS(1199),
    [anon_sym_PIPE_PIPE] = ACTIONS(1199),
    [anon_sym_QMARK_QMARK] = ACTIONS(1199),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1201),
    [anon_sym_is] = ACTIONS(1201),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_DASH_GT] = ACTIONS(1199),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_with] = ACTIONS(1201),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [350] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6727),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2839),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6146),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_pattern] = STATE(8186),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(6657),
    [sym_property_pattern_clause] = STATE(6741),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6659),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(5071),
    [sym_postfix_unary_expression] = STATE(5061),
    [sym_prefix_unary_expression] = STATE(5061),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(5071),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(5061),
    [sym_switch_expression] = STATE(3774),
    [sym_switch_expression_arm] = STATE(8743),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(5071),
    [sym_member_access_expression] = STATE(3775),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(5061),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(5071),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(5071),
    [sym_typeof_expression] = STATE(5071),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3775),
    [sym_literal] = STATE(5071),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(350),
    [sym_preproc_endregion] = STATE(350),
    [sym_preproc_line] = STATE(350),
    [sym_preproc_pragma] = STATE(350),
    [sym_preproc_nullable] = STATE(350),
    [sym_preproc_error] = STATE(350),
    [sym_preproc_define] = STATE(350),
    [sym_preproc_undef] = STATE(350),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_ref] = ACTIONS(1925),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_RBRACE] = ACTIONS(2211),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(1929),
    [anon_sym_GT] = ACTIONS(1929),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1749),
    [anon_sym_TILDE] = ACTIONS(1749),
    [anon_sym_PLUS_PLUS] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1749),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1747),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1749),
    [anon_sym_AMP] = ACTIONS(1749),
    [anon_sym_GT_EQ] = ACTIONS(1931),
    [anon_sym_LT_EQ] = ACTIONS(1931),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1065),
    [anon_sym_var] = ACTIONS(1933),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(1935),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [351] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6901),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2939),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7050),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6470),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4507),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7378),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9063),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(351),
    [sym_preproc_endregion] = STATE(351),
    [sym_preproc_line] = STATE(351),
    [sym_preproc_pragma] = STATE(351),
    [sym_preproc_nullable] = STATE(351),
    [sym_preproc_error] = STATE(351),
    [sym_preproc_define] = STATE(351),
    [sym_preproc_undef] = STATE(351),
    [aux_sym_class_declaration_repeat1] = STATE(3854),
    [aux_sym_lambda_expression_repeat1] = STATE(4229),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2193),
    [anon_sym_ref] = ACTIONS(2195),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2197),
    [anon_sym_LT] = ACTIONS(1201),
    [anon_sym_GT] = ACTIONS(1201),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1201),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2199),
    [anon_sym_TILDE] = ACTIONS(2201),
    [anon_sym_PLUS_PLUS] = ACTIONS(2201),
    [anon_sym_DASH_DASH] = ACTIONS(2201),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2199),
    [anon_sym_DASH] = ACTIONS(2199),
    [anon_sym_STAR] = ACTIONS(2203),
    [anon_sym_SLASH] = ACTIONS(1201),
    [anon_sym_PERCENT] = ACTIONS(1199),
    [anon_sym_CARET] = ACTIONS(2201),
    [anon_sym_PIPE] = ACTIONS(1201),
    [anon_sym_AMP] = ACTIONS(2199),
    [anon_sym_LT_LT] = ACTIONS(1199),
    [anon_sym_GT_GT] = ACTIONS(1201),
    [anon_sym_GT_GT_GT] = ACTIONS(1199),
    [anon_sym_EQ_EQ] = ACTIONS(1199),
    [anon_sym_BANG_EQ] = ACTIONS(1199),
    [anon_sym_GT_EQ] = ACTIONS(1199),
    [anon_sym_LT_EQ] = ACTIONS(1199),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(1201),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1201),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2205),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2207),
    [anon_sym_DOT_DOT] = ACTIONS(2209),
    [anon_sym_AMP_AMP] = ACTIONS(1199),
    [anon_sym_PIPE_PIPE] = ACTIONS(1199),
    [anon_sym_QMARK_QMARK] = ACTIONS(1199),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1201),
    [anon_sym_is] = ACTIONS(1201),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_DASH_GT] = ACTIONS(1199),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_with] = ACTIONS(1201),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [352] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2789),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(5669),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_pattern] = STATE(8221),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(6141),
    [sym_property_pattern_clause] = STATE(6672),
    [sym_subpattern] = STATE(8532),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6495),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4482),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(5313),
    [sym_postfix_unary_expression] = STATE(5314),
    [sym_prefix_unary_expression] = STATE(5314),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(5313),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(5314),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(5313),
    [sym_member_access_expression] = STATE(3856),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(5314),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9438),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(5313),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(5313),
    [sym_typeof_expression] = STATE(5313),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3856),
    [sym_literal] = STATE(5313),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(352),
    [sym_preproc_endregion] = STATE(352),
    [sym_preproc_line] = STATE(352),
    [sym_preproc_pragma] = STATE(352),
    [sym_preproc_nullable] = STATE(352),
    [sym_preproc_error] = STATE(352),
    [sym_preproc_define] = STATE(352),
    [sym_preproc_undef] = STATE(352),
    [aux_sym_class_declaration_repeat1] = STATE(3801),
    [aux_sym_lambda_expression_repeat1] = STATE(4134),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(1203),
    [anon_sym_ref] = ACTIONS(1959),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_RBRACE] = ACTIONS(2213),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1053),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1097),
    [anon_sym_TILDE] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1099),
    [anon_sym_DASH] = ACTIONS(1099),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1097),
    [anon_sym_GT_EQ] = ACTIONS(1063),
    [anon_sym_LT_EQ] = ACTIONS(1063),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1065),
    [anon_sym_var] = ACTIONS(1067),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1281),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1283),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(1285),
    [anon_sym_not] = ACTIONS(1077),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [353] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6893),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2968),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7023),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6190),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4416),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7390),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9221),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(353),
    [sym_preproc_endregion] = STATE(353),
    [sym_preproc_line] = STATE(353),
    [sym_preproc_pragma] = STATE(353),
    [sym_preproc_nullable] = STATE(353),
    [sym_preproc_error] = STATE(353),
    [sym_preproc_define] = STATE(353),
    [sym_preproc_undef] = STATE(353),
    [aux_sym_class_declaration_repeat1] = STATE(3808),
    [aux_sym_lambda_expression_repeat1] = STATE(4129),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_ref] = ACTIONS(2217),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_LT] = ACTIONS(1147),
    [anon_sym_GT] = ACTIONS(1147),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1147),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(2221),
    [anon_sym_TILDE] = ACTIONS(2223),
    [anon_sym_PLUS_PLUS] = ACTIONS(2223),
    [anon_sym_DASH_DASH] = ACTIONS(2223),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2221),
    [anon_sym_DASH] = ACTIONS(2221),
    [anon_sym_STAR] = ACTIONS(2225),
    [anon_sym_SLASH] = ACTIONS(1147),
    [anon_sym_PERCENT] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(2223),
    [anon_sym_PIPE] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(2221),
    [anon_sym_LT_LT] = ACTIONS(1133),
    [anon_sym_GT_GT] = ACTIONS(1147),
    [anon_sym_GT_GT_GT] = ACTIONS(1133),
    [anon_sym_EQ_EQ] = ACTIONS(1133),
    [anon_sym_BANG_EQ] = ACTIONS(1133),
    [anon_sym_GT_EQ] = ACTIONS(1133),
    [anon_sym_LT_EQ] = ACTIONS(1133),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_DOT] = ACTIONS(1147),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1147),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2227),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2229),
    [anon_sym_DOT_DOT] = ACTIONS(2231),
    [anon_sym_AMP_AMP] = ACTIONS(1133),
    [anon_sym_PIPE_PIPE] = ACTIONS(1133),
    [anon_sym_QMARK_QMARK] = ACTIONS(1133),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1147),
    [anon_sym_is] = ACTIONS(1147),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_DASH_GT] = ACTIONS(1133),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_with] = ACTIONS(1147),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [354] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2789),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(5669),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_pattern] = STATE(8221),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(6141),
    [sym_property_pattern_clause] = STATE(6672),
    [sym_subpattern] = STATE(8532),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6495),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4482),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(5313),
    [sym_postfix_unary_expression] = STATE(5314),
    [sym_prefix_unary_expression] = STATE(5314),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(5313),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(5314),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(5313),
    [sym_member_access_expression] = STATE(3856),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(5314),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9438),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(5313),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(5313),
    [sym_typeof_expression] = STATE(5313),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3856),
    [sym_literal] = STATE(5313),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(354),
    [sym_preproc_endregion] = STATE(354),
    [sym_preproc_line] = STATE(354),
    [sym_preproc_pragma] = STATE(354),
    [sym_preproc_nullable] = STATE(354),
    [sym_preproc_error] = STATE(354),
    [sym_preproc_define] = STATE(354),
    [sym_preproc_undef] = STATE(354),
    [aux_sym_class_declaration_repeat1] = STATE(3801),
    [aux_sym_lambda_expression_repeat1] = STATE(4134),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(1203),
    [anon_sym_ref] = ACTIONS(1959),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_RBRACE] = ACTIONS(2233),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1053),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1097),
    [anon_sym_TILDE] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1099),
    [anon_sym_DASH] = ACTIONS(1099),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1097),
    [anon_sym_GT_EQ] = ACTIONS(1063),
    [anon_sym_LT_EQ] = ACTIONS(1063),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1065),
    [anon_sym_var] = ACTIONS(1067),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1281),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1283),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(1285),
    [anon_sym_not] = ACTIONS(1077),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [355] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6893),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2968),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7023),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6240),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4416),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7390),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9221),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(355),
    [sym_preproc_endregion] = STATE(355),
    [sym_preproc_line] = STATE(355),
    [sym_preproc_pragma] = STATE(355),
    [sym_preproc_nullable] = STATE(355),
    [sym_preproc_error] = STATE(355),
    [sym_preproc_define] = STATE(355),
    [sym_preproc_undef] = STATE(355),
    [aux_sym_class_declaration_repeat1] = STATE(3808),
    [aux_sym_lambda_expression_repeat1] = STATE(4129),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_ref] = ACTIONS(2217),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_LT] = ACTIONS(1201),
    [anon_sym_GT] = ACTIONS(1201),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1201),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(2221),
    [anon_sym_TILDE] = ACTIONS(2223),
    [anon_sym_PLUS_PLUS] = ACTIONS(2223),
    [anon_sym_DASH_DASH] = ACTIONS(2223),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2221),
    [anon_sym_DASH] = ACTIONS(2221),
    [anon_sym_STAR] = ACTIONS(2225),
    [anon_sym_SLASH] = ACTIONS(1201),
    [anon_sym_PERCENT] = ACTIONS(1199),
    [anon_sym_CARET] = ACTIONS(2223),
    [anon_sym_PIPE] = ACTIONS(1201),
    [anon_sym_AMP] = ACTIONS(2221),
    [anon_sym_LT_LT] = ACTIONS(1199),
    [anon_sym_GT_GT] = ACTIONS(1201),
    [anon_sym_GT_GT_GT] = ACTIONS(1199),
    [anon_sym_EQ_EQ] = ACTIONS(1199),
    [anon_sym_BANG_EQ] = ACTIONS(1199),
    [anon_sym_GT_EQ] = ACTIONS(1199),
    [anon_sym_LT_EQ] = ACTIONS(1199),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_DOT] = ACTIONS(1201),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1201),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2227),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2229),
    [anon_sym_DOT_DOT] = ACTIONS(2231),
    [anon_sym_AMP_AMP] = ACTIONS(1199),
    [anon_sym_PIPE_PIPE] = ACTIONS(1199),
    [anon_sym_QMARK_QMARK] = ACTIONS(1199),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1201),
    [anon_sym_is] = ACTIONS(1201),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_DASH_GT] = ACTIONS(1199),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_with] = ACTIONS(1201),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [356] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6727),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2839),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6146),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_pattern] = STATE(8186),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(6657),
    [sym_property_pattern_clause] = STATE(6741),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6659),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(5071),
    [sym_postfix_unary_expression] = STATE(5061),
    [sym_prefix_unary_expression] = STATE(5061),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(5071),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(5061),
    [sym_switch_expression] = STATE(3774),
    [sym_switch_expression_arm] = STATE(8743),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(5071),
    [sym_member_access_expression] = STATE(3775),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(5061),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(5071),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(5071),
    [sym_typeof_expression] = STATE(5071),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3775),
    [sym_literal] = STATE(5071),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(356),
    [sym_preproc_endregion] = STATE(356),
    [sym_preproc_line] = STATE(356),
    [sym_preproc_pragma] = STATE(356),
    [sym_preproc_nullable] = STATE(356),
    [sym_preproc_error] = STATE(356),
    [sym_preproc_define] = STATE(356),
    [sym_preproc_undef] = STATE(356),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_ref] = ACTIONS(1925),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_RBRACE] = ACTIONS(2235),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(1929),
    [anon_sym_GT] = ACTIONS(1929),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1749),
    [anon_sym_TILDE] = ACTIONS(1749),
    [anon_sym_PLUS_PLUS] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1749),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1747),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1749),
    [anon_sym_AMP] = ACTIONS(1749),
    [anon_sym_GT_EQ] = ACTIONS(1931),
    [anon_sym_LT_EQ] = ACTIONS(1931),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1065),
    [anon_sym_var] = ACTIONS(1933),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(1935),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [357] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6727),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2839),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6146),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_pattern] = STATE(8186),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(6657),
    [sym_property_pattern_clause] = STATE(6741),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6659),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(5071),
    [sym_postfix_unary_expression] = STATE(5061),
    [sym_prefix_unary_expression] = STATE(5061),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(5071),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(5061),
    [sym_switch_expression] = STATE(3774),
    [sym_switch_expression_arm] = STATE(8743),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(5071),
    [sym_member_access_expression] = STATE(3775),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(5061),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(5071),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(5071),
    [sym_typeof_expression] = STATE(5071),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3775),
    [sym_literal] = STATE(5071),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(357),
    [sym_preproc_endregion] = STATE(357),
    [sym_preproc_line] = STATE(357),
    [sym_preproc_pragma] = STATE(357),
    [sym_preproc_nullable] = STATE(357),
    [sym_preproc_error] = STATE(357),
    [sym_preproc_define] = STATE(357),
    [sym_preproc_undef] = STATE(357),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_ref] = ACTIONS(1925),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(1929),
    [anon_sym_GT] = ACTIONS(1929),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1749),
    [anon_sym_TILDE] = ACTIONS(1749),
    [anon_sym_PLUS_PLUS] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1749),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1747),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1749),
    [anon_sym_AMP] = ACTIONS(1749),
    [anon_sym_GT_EQ] = ACTIONS(1931),
    [anon_sym_LT_EQ] = ACTIONS(1931),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1065),
    [anon_sym_var] = ACTIONS(1933),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(1935),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [358] = {
    [sym_attribute_list] = STATE(6703),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_variable_declaration] = STATE(9447),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6870),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4325),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9849),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(358),
    [sym_preproc_endregion] = STATE(358),
    [sym_preproc_line] = STATE(358),
    [sym_preproc_pragma] = STATE(358),
    [sym_preproc_nullable] = STATE(358),
    [sym_preproc_error] = STATE(358),
    [sym_preproc_define] = STATE(358),
    [sym_preproc_undef] = STATE(358),
    [aux_sym_class_declaration_repeat1] = STATE(3841),
    [aux_sym_class_declaration_repeat2] = STATE(3099),
    [aux_sym_lambda_expression_repeat1] = STATE(4283),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(2237),
    [anon_sym_unsafe] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1459),
    [anon_sym_ref] = ACTIONS(1461),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(643),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(2239),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1467),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1469),
    [anon_sym_foreach] = ACTIONS(2241),
    [anon_sym_DOT_DOT] = ACTIONS(1471),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [359] = {
    [sym_attribute_list] = STATE(6703),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_variable_declaration] = STATE(9684),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6870),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4325),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9849),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(359),
    [sym_preproc_endregion] = STATE(359),
    [sym_preproc_line] = STATE(359),
    [sym_preproc_pragma] = STATE(359),
    [sym_preproc_nullable] = STATE(359),
    [sym_preproc_error] = STATE(359),
    [sym_preproc_define] = STATE(359),
    [sym_preproc_undef] = STATE(359),
    [aux_sym_class_declaration_repeat1] = STATE(3841),
    [aux_sym_class_declaration_repeat2] = STATE(3083),
    [aux_sym_lambda_expression_repeat1] = STATE(4283),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(2243),
    [anon_sym_unsafe] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1459),
    [anon_sym_ref] = ACTIONS(1461),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(643),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(2239),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1467),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1469),
    [anon_sym_foreach] = ACTIONS(2245),
    [anon_sym_DOT_DOT] = ACTIONS(1471),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [360] = {
    [sym_attribute_list] = STATE(6703),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_variable_declaration] = STATE(9571),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6870),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4325),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9849),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(360),
    [sym_preproc_endregion] = STATE(360),
    [sym_preproc_line] = STATE(360),
    [sym_preproc_pragma] = STATE(360),
    [sym_preproc_nullable] = STATE(360),
    [sym_preproc_error] = STATE(360),
    [sym_preproc_define] = STATE(360),
    [sym_preproc_undef] = STATE(360),
    [aux_sym_class_declaration_repeat1] = STATE(3841),
    [aux_sym_class_declaration_repeat2] = STATE(3090),
    [aux_sym_lambda_expression_repeat1] = STATE(4283),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(2247),
    [anon_sym_unsafe] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1459),
    [anon_sym_ref] = ACTIONS(1461),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(643),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(2239),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1467),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1469),
    [anon_sym_foreach] = ACTIONS(2249),
    [anon_sym_DOT_DOT] = ACTIONS(1471),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [361] = {
    [sym_attribute_list] = STATE(6703),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_variable_declaration] = STATE(9366),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6870),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4325),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9849),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(361),
    [sym_preproc_endregion] = STATE(361),
    [sym_preproc_line] = STATE(361),
    [sym_preproc_pragma] = STATE(361),
    [sym_preproc_nullable] = STATE(361),
    [sym_preproc_error] = STATE(361),
    [sym_preproc_define] = STATE(361),
    [sym_preproc_undef] = STATE(361),
    [aux_sym_class_declaration_repeat1] = STATE(3841),
    [aux_sym_class_declaration_repeat2] = STATE(3079),
    [aux_sym_lambda_expression_repeat1] = STATE(4283),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(2251),
    [anon_sym_unsafe] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1459),
    [anon_sym_ref] = ACTIONS(1461),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(643),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(2239),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1467),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1469),
    [anon_sym_foreach] = ACTIONS(2253),
    [anon_sym_DOT_DOT] = ACTIONS(1471),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [362] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2789),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(5318),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_pattern] = STATE(8232),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(6141),
    [sym_property_pattern_clause] = STATE(6672),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6667),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(5313),
    [sym_postfix_unary_expression] = STATE(5314),
    [sym_prefix_unary_expression] = STATE(5314),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(5313),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(5314),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(5313),
    [sym_member_access_expression] = STATE(3856),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(5314),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(5313),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(5313),
    [sym_typeof_expression] = STATE(5313),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3856),
    [sym_literal] = STATE(5313),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(362),
    [sym_preproc_endregion] = STATE(362),
    [sym_preproc_line] = STATE(362),
    [sym_preproc_pragma] = STATE(362),
    [sym_preproc_nullable] = STATE(362),
    [sym_preproc_error] = STATE(362),
    [sym_preproc_define] = STATE(362),
    [sym_preproc_undef] = STATE(362),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_RBRACK] = ACTIONS(2255),
    [anon_sym_LPAREN] = ACTIONS(1043),
    [anon_sym_ref] = ACTIONS(2257),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1053),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1059),
    [anon_sym_TILDE] = ACTIONS(1059),
    [anon_sym_PLUS_PLUS] = ACTIONS(1059),
    [anon_sym_DASH_DASH] = ACTIONS(1059),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1061),
    [anon_sym_DASH] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_GT_EQ] = ACTIONS(1063),
    [anon_sym_LT_EQ] = ACTIONS(1063),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1065),
    [anon_sym_var] = ACTIONS(1067),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(2259),
    [anon_sym_not] = ACTIONS(1077),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [363] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2789),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(5318),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_pattern] = STATE(8232),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(6141),
    [sym_property_pattern_clause] = STATE(6672),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6667),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(5313),
    [sym_postfix_unary_expression] = STATE(5314),
    [sym_prefix_unary_expression] = STATE(5314),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(5313),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(5314),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(5313),
    [sym_member_access_expression] = STATE(3856),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(5314),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(5313),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(5313),
    [sym_typeof_expression] = STATE(5313),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3856),
    [sym_literal] = STATE(5313),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(363),
    [sym_preproc_endregion] = STATE(363),
    [sym_preproc_line] = STATE(363),
    [sym_preproc_pragma] = STATE(363),
    [sym_preproc_nullable] = STATE(363),
    [sym_preproc_error] = STATE(363),
    [sym_preproc_define] = STATE(363),
    [sym_preproc_undef] = STATE(363),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_RBRACK] = ACTIONS(2261),
    [anon_sym_LPAREN] = ACTIONS(1043),
    [anon_sym_ref] = ACTIONS(2257),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1053),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1059),
    [anon_sym_TILDE] = ACTIONS(1059),
    [anon_sym_PLUS_PLUS] = ACTIONS(1059),
    [anon_sym_DASH_DASH] = ACTIONS(1059),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1061),
    [anon_sym_DASH] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_GT_EQ] = ACTIONS(1063),
    [anon_sym_LT_EQ] = ACTIONS(1063),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1065),
    [anon_sym_var] = ACTIONS(1067),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(2259),
    [anon_sym_not] = ACTIONS(1077),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [364] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2789),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(5669),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_pattern] = STATE(8209),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(6141),
    [sym_property_pattern_clause] = STATE(6672),
    [sym_subpattern] = STATE(8532),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6455),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4482),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(5313),
    [sym_postfix_unary_expression] = STATE(5314),
    [sym_prefix_unary_expression] = STATE(5314),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(5313),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(5314),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(5313),
    [sym_member_access_expression] = STATE(3856),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(5314),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9438),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(5313),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(5313),
    [sym_typeof_expression] = STATE(5313),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3856),
    [sym_literal] = STATE(5313),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(364),
    [sym_preproc_endregion] = STATE(364),
    [sym_preproc_line] = STATE(364),
    [sym_preproc_pragma] = STATE(364),
    [sym_preproc_nullable] = STATE(364),
    [sym_preproc_error] = STATE(364),
    [sym_preproc_define] = STATE(364),
    [sym_preproc_undef] = STATE(364),
    [aux_sym_class_declaration_repeat1] = STATE(3801),
    [aux_sym_lambda_expression_repeat1] = STATE(4134),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(1203),
    [anon_sym_ref] = ACTIONS(2263),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1053),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1097),
    [anon_sym_TILDE] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1099),
    [anon_sym_DASH] = ACTIONS(1099),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1097),
    [anon_sym_GT_EQ] = ACTIONS(1063),
    [anon_sym_LT_EQ] = ACTIONS(1063),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2265),
    [anon_sym_var] = ACTIONS(1067),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1281),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1283),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(1285),
    [anon_sym_not] = ACTIONS(1117),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [365] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2789),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(5318),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_pattern] = STATE(8232),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(6141),
    [sym_property_pattern_clause] = STATE(6672),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6667),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(5313),
    [sym_postfix_unary_expression] = STATE(5314),
    [sym_prefix_unary_expression] = STATE(5314),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(5313),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(5314),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(5313),
    [sym_member_access_expression] = STATE(3856),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(5314),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(5313),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(5313),
    [sym_typeof_expression] = STATE(5313),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3856),
    [sym_literal] = STATE(5313),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(365),
    [sym_preproc_endregion] = STATE(365),
    [sym_preproc_line] = STATE(365),
    [sym_preproc_pragma] = STATE(365),
    [sym_preproc_nullable] = STATE(365),
    [sym_preproc_error] = STATE(365),
    [sym_preproc_define] = STATE(365),
    [sym_preproc_undef] = STATE(365),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_RBRACK] = ACTIONS(2267),
    [anon_sym_LPAREN] = ACTIONS(1043),
    [anon_sym_ref] = ACTIONS(2257),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1053),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1059),
    [anon_sym_TILDE] = ACTIONS(1059),
    [anon_sym_PLUS_PLUS] = ACTIONS(1059),
    [anon_sym_DASH_DASH] = ACTIONS(1059),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1061),
    [anon_sym_DASH] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_GT_EQ] = ACTIONS(1063),
    [anon_sym_LT_EQ] = ACTIONS(1063),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1065),
    [anon_sym_var] = ACTIONS(1067),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(2259),
    [anon_sym_not] = ACTIONS(1077),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [366] = {
    [sym_attribute_list] = STATE(6703),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym_variable_declaration] = STATE(9366),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6840),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4325),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4314),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9775),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(366),
    [sym_preproc_endregion] = STATE(366),
    [sym_preproc_line] = STATE(366),
    [sym_preproc_pragma] = STATE(366),
    [sym_preproc_nullable] = STATE(366),
    [sym_preproc_error] = STATE(366),
    [sym_preproc_define] = STATE(366),
    [sym_preproc_undef] = STATE(366),
    [aux_sym_class_declaration_repeat1] = STATE(3835),
    [aux_sym_class_declaration_repeat2] = STATE(3079),
    [aux_sym_lambda_expression_repeat1] = STATE(4236),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(2251),
    [anon_sym_unsafe] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1535),
    [anon_sym_ref] = ACTIONS(1537),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(643),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(2239),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(885),
    [anon_sym_TILDE] = ACTIONS(885),
    [anon_sym_PLUS_PLUS] = ACTIONS(885),
    [anon_sym_DASH_DASH] = ACTIONS(885),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(887),
    [anon_sym_DASH] = ACTIONS(887),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(885),
    [anon_sym_AMP] = ACTIONS(885),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1539),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1541),
    [anon_sym_foreach] = ACTIONS(2253),
    [anon_sym_DOT_DOT] = ACTIONS(1543),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [367] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2789),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(5669),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_pattern] = STATE(8221),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(6141),
    [sym_property_pattern_clause] = STATE(6672),
    [sym_subpattern] = STATE(8532),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6495),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4482),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(5313),
    [sym_postfix_unary_expression] = STATE(5314),
    [sym_prefix_unary_expression] = STATE(5314),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(5313),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(5314),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(5313),
    [sym_member_access_expression] = STATE(3856),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(5314),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9438),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(5313),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(5313),
    [sym_typeof_expression] = STATE(5313),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3856),
    [sym_literal] = STATE(5313),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(367),
    [sym_preproc_endregion] = STATE(367),
    [sym_preproc_line] = STATE(367),
    [sym_preproc_pragma] = STATE(367),
    [sym_preproc_nullable] = STATE(367),
    [sym_preproc_error] = STATE(367),
    [sym_preproc_define] = STATE(367),
    [sym_preproc_undef] = STATE(367),
    [aux_sym_class_declaration_repeat1] = STATE(3801),
    [aux_sym_lambda_expression_repeat1] = STATE(4134),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(1203),
    [anon_sym_ref] = ACTIONS(1959),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1053),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1097),
    [anon_sym_TILDE] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1099),
    [anon_sym_DASH] = ACTIONS(1099),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1097),
    [anon_sym_GT_EQ] = ACTIONS(1063),
    [anon_sym_LT_EQ] = ACTIONS(1063),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1065),
    [anon_sym_var] = ACTIONS(1067),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1281),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1283),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(1285),
    [anon_sym_not] = ACTIONS(1077),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [368] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2789),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(5318),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_pattern] = STATE(8232),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(6141),
    [sym_property_pattern_clause] = STATE(6672),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6667),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(5313),
    [sym_postfix_unary_expression] = STATE(5314),
    [sym_prefix_unary_expression] = STATE(5314),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(5313),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(5314),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(5313),
    [sym_member_access_expression] = STATE(3856),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(5314),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(5313),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(5313),
    [sym_typeof_expression] = STATE(5313),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3856),
    [sym_literal] = STATE(5313),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(368),
    [sym_preproc_endregion] = STATE(368),
    [sym_preproc_line] = STATE(368),
    [sym_preproc_pragma] = STATE(368),
    [sym_preproc_nullable] = STATE(368),
    [sym_preproc_error] = STATE(368),
    [sym_preproc_define] = STATE(368),
    [sym_preproc_undef] = STATE(368),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_RBRACK] = ACTIONS(2269),
    [anon_sym_LPAREN] = ACTIONS(1043),
    [anon_sym_ref] = ACTIONS(2257),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1053),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1059),
    [anon_sym_TILDE] = ACTIONS(1059),
    [anon_sym_PLUS_PLUS] = ACTIONS(1059),
    [anon_sym_DASH_DASH] = ACTIONS(1059),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1061),
    [anon_sym_DASH] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_GT_EQ] = ACTIONS(1063),
    [anon_sym_LT_EQ] = ACTIONS(1063),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1065),
    [anon_sym_var] = ACTIONS(1067),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(2259),
    [anon_sym_not] = ACTIONS(1077),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [369] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2789),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(5318),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_pattern] = STATE(8232),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(6141),
    [sym_property_pattern_clause] = STATE(6672),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6667),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(5313),
    [sym_postfix_unary_expression] = STATE(5314),
    [sym_prefix_unary_expression] = STATE(5314),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(5313),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(5314),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(5313),
    [sym_member_access_expression] = STATE(3856),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(5314),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(5313),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(5313),
    [sym_typeof_expression] = STATE(5313),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3856),
    [sym_literal] = STATE(5313),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(369),
    [sym_preproc_endregion] = STATE(369),
    [sym_preproc_line] = STATE(369),
    [sym_preproc_pragma] = STATE(369),
    [sym_preproc_nullable] = STATE(369),
    [sym_preproc_error] = STATE(369),
    [sym_preproc_define] = STATE(369),
    [sym_preproc_undef] = STATE(369),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_RBRACK] = ACTIONS(2271),
    [anon_sym_LPAREN] = ACTIONS(1043),
    [anon_sym_ref] = ACTIONS(2257),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1053),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1059),
    [anon_sym_TILDE] = ACTIONS(1059),
    [anon_sym_PLUS_PLUS] = ACTIONS(1059),
    [anon_sym_DASH_DASH] = ACTIONS(1059),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1061),
    [anon_sym_DASH] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_GT_EQ] = ACTIONS(1063),
    [anon_sym_LT_EQ] = ACTIONS(1063),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1065),
    [anon_sym_var] = ACTIONS(1067),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(2259),
    [anon_sym_not] = ACTIONS(1077),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [370] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2789),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(5318),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_pattern] = STATE(8232),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(6141),
    [sym_property_pattern_clause] = STATE(6672),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6667),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(5313),
    [sym_postfix_unary_expression] = STATE(5314),
    [sym_prefix_unary_expression] = STATE(5314),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(5313),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(5314),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(5313),
    [sym_member_access_expression] = STATE(3856),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(5314),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(5313),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(5313),
    [sym_typeof_expression] = STATE(5313),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3856),
    [sym_literal] = STATE(5313),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(370),
    [sym_preproc_endregion] = STATE(370),
    [sym_preproc_line] = STATE(370),
    [sym_preproc_pragma] = STATE(370),
    [sym_preproc_nullable] = STATE(370),
    [sym_preproc_error] = STATE(370),
    [sym_preproc_define] = STATE(370),
    [sym_preproc_undef] = STATE(370),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_RBRACK] = ACTIONS(2273),
    [anon_sym_LPAREN] = ACTIONS(1043),
    [anon_sym_ref] = ACTIONS(2257),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1053),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1059),
    [anon_sym_TILDE] = ACTIONS(1059),
    [anon_sym_PLUS_PLUS] = ACTIONS(1059),
    [anon_sym_DASH_DASH] = ACTIONS(1059),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1061),
    [anon_sym_DASH] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_GT_EQ] = ACTIONS(1063),
    [anon_sym_LT_EQ] = ACTIONS(1063),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1065),
    [anon_sym_var] = ACTIONS(1067),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(2259),
    [anon_sym_not] = ACTIONS(1077),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [371] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2789),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(5318),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_pattern] = STATE(8232),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(6141),
    [sym_property_pattern_clause] = STATE(6672),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6667),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(5313),
    [sym_postfix_unary_expression] = STATE(5314),
    [sym_prefix_unary_expression] = STATE(5314),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(5313),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(5314),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(5313),
    [sym_member_access_expression] = STATE(3856),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(5314),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(5313),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(5313),
    [sym_typeof_expression] = STATE(5313),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3856),
    [sym_literal] = STATE(5313),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(371),
    [sym_preproc_endregion] = STATE(371),
    [sym_preproc_line] = STATE(371),
    [sym_preproc_pragma] = STATE(371),
    [sym_preproc_nullable] = STATE(371),
    [sym_preproc_error] = STATE(371),
    [sym_preproc_define] = STATE(371),
    [sym_preproc_undef] = STATE(371),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_RBRACK] = ACTIONS(2275),
    [anon_sym_LPAREN] = ACTIONS(1043),
    [anon_sym_ref] = ACTIONS(2257),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1053),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1059),
    [anon_sym_TILDE] = ACTIONS(1059),
    [anon_sym_PLUS_PLUS] = ACTIONS(1059),
    [anon_sym_DASH_DASH] = ACTIONS(1059),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1061),
    [anon_sym_DASH] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_GT_EQ] = ACTIONS(1063),
    [anon_sym_LT_EQ] = ACTIONS(1063),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1065),
    [anon_sym_var] = ACTIONS(1067),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(2259),
    [anon_sym_not] = ACTIONS(1077),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [372] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2789),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(5318),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_pattern] = STATE(8232),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(6141),
    [sym_property_pattern_clause] = STATE(6672),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6667),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(5313),
    [sym_postfix_unary_expression] = STATE(5314),
    [sym_prefix_unary_expression] = STATE(5314),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(5313),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(5314),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(5313),
    [sym_member_access_expression] = STATE(3856),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(5314),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(5313),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(5313),
    [sym_typeof_expression] = STATE(5313),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3856),
    [sym_literal] = STATE(5313),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(372),
    [sym_preproc_endregion] = STATE(372),
    [sym_preproc_line] = STATE(372),
    [sym_preproc_pragma] = STATE(372),
    [sym_preproc_nullable] = STATE(372),
    [sym_preproc_error] = STATE(372),
    [sym_preproc_define] = STATE(372),
    [sym_preproc_undef] = STATE(372),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_RBRACK] = ACTIONS(2277),
    [anon_sym_LPAREN] = ACTIONS(1043),
    [anon_sym_ref] = ACTIONS(2257),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1053),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1059),
    [anon_sym_TILDE] = ACTIONS(1059),
    [anon_sym_PLUS_PLUS] = ACTIONS(1059),
    [anon_sym_DASH_DASH] = ACTIONS(1059),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1061),
    [anon_sym_DASH] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_GT_EQ] = ACTIONS(1063),
    [anon_sym_LT_EQ] = ACTIONS(1063),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1065),
    [anon_sym_var] = ACTIONS(1067),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(2259),
    [anon_sym_not] = ACTIONS(1077),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [373] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2789),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(5318),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_pattern] = STATE(8232),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(6141),
    [sym_property_pattern_clause] = STATE(6672),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6667),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(5313),
    [sym_postfix_unary_expression] = STATE(5314),
    [sym_prefix_unary_expression] = STATE(5314),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(5313),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(5314),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(5313),
    [sym_member_access_expression] = STATE(3856),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(5314),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(5313),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(5313),
    [sym_typeof_expression] = STATE(5313),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3856),
    [sym_literal] = STATE(5313),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(373),
    [sym_preproc_endregion] = STATE(373),
    [sym_preproc_line] = STATE(373),
    [sym_preproc_pragma] = STATE(373),
    [sym_preproc_nullable] = STATE(373),
    [sym_preproc_error] = STATE(373),
    [sym_preproc_define] = STATE(373),
    [sym_preproc_undef] = STATE(373),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_RBRACK] = ACTIONS(2279),
    [anon_sym_LPAREN] = ACTIONS(1043),
    [anon_sym_ref] = ACTIONS(2257),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1053),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1059),
    [anon_sym_TILDE] = ACTIONS(1059),
    [anon_sym_PLUS_PLUS] = ACTIONS(1059),
    [anon_sym_DASH_DASH] = ACTIONS(1059),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1061),
    [anon_sym_DASH] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_GT_EQ] = ACTIONS(1063),
    [anon_sym_LT_EQ] = ACTIONS(1063),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1065),
    [anon_sym_var] = ACTIONS(1067),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(2259),
    [anon_sym_not] = ACTIONS(1077),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [374] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2789),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(5318),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_pattern] = STATE(8232),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(6141),
    [sym_property_pattern_clause] = STATE(6672),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6667),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(5313),
    [sym_postfix_unary_expression] = STATE(5314),
    [sym_prefix_unary_expression] = STATE(5314),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(5313),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(5314),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(5313),
    [sym_member_access_expression] = STATE(3856),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(5314),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(5313),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(5313),
    [sym_typeof_expression] = STATE(5313),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3856),
    [sym_literal] = STATE(5313),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(374),
    [sym_preproc_endregion] = STATE(374),
    [sym_preproc_line] = STATE(374),
    [sym_preproc_pragma] = STATE(374),
    [sym_preproc_nullable] = STATE(374),
    [sym_preproc_error] = STATE(374),
    [sym_preproc_define] = STATE(374),
    [sym_preproc_undef] = STATE(374),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_RBRACK] = ACTIONS(2281),
    [anon_sym_LPAREN] = ACTIONS(1043),
    [anon_sym_ref] = ACTIONS(2257),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1053),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1059),
    [anon_sym_TILDE] = ACTIONS(1059),
    [anon_sym_PLUS_PLUS] = ACTIONS(1059),
    [anon_sym_DASH_DASH] = ACTIONS(1059),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1061),
    [anon_sym_DASH] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_GT_EQ] = ACTIONS(1063),
    [anon_sym_LT_EQ] = ACTIONS(1063),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1065),
    [anon_sym_var] = ACTIONS(1067),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(2259),
    [anon_sym_not] = ACTIONS(1077),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [375] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(3534),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2895),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(3049),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(2975),
    [sym__array_base_type] = STATE(8712),
    [sym_nullable_type] = STATE(2974),
    [sym_pointer_type] = STATE(2974),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(2974),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(2973),
    [sym_pattern] = STATE(6158),
    [sym_constant_pattern] = STATE(3952),
    [sym_parenthesized_pattern] = STATE(3952),
    [sym_var_pattern] = STATE(3952),
    [sym_type_pattern] = STATE(3952),
    [sym_list_pattern] = STATE(3952),
    [sym_recursive_pattern] = STATE(3952),
    [sym_positional_pattern_clause] = STATE(3153),
    [sym_property_pattern_clause] = STATE(3405),
    [sym_relational_pattern] = STATE(3952),
    [sym_negated_pattern] = STATE(3952),
    [sym_and_pattern] = STATE(3952),
    [sym_or_pattern] = STATE(3952),
    [sym_declaration_pattern] = STATE(3952),
    [sym_expression] = STATE(6660),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3993),
    [sym_postfix_unary_expression] = STATE(3997),
    [sym_prefix_unary_expression] = STATE(3997),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3993),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3997),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3993),
    [sym_member_access_expression] = STATE(3202),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3997),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3993),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3993),
    [sym_typeof_expression] = STATE(3993),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3202),
    [sym_literal] = STATE(3993),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2742),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(375),
    [sym_preproc_endregion] = STATE(375),
    [sym_preproc_line] = STATE(375),
    [sym_preproc_pragma] = STATE(375),
    [sym_preproc_nullable] = STATE(375),
    [sym_preproc_error] = STATE(375),
    [sym_preproc_define] = STATE(375),
    [sym_preproc_undef] = STATE(375),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(2283),
    [anon_sym_LPAREN] = ACTIONS(2285),
    [anon_sym_ref] = ACTIONS(2287),
    [anon_sym_LBRACE] = ACTIONS(2289),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(2291),
    [anon_sym_GT] = ACTIONS(2291),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1875),
    [anon_sym_TILDE] = ACTIONS(1875),
    [anon_sym_PLUS_PLUS] = ACTIONS(1875),
    [anon_sym_DASH_DASH] = ACTIONS(1875),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1873),
    [anon_sym_DASH] = ACTIONS(1873),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1875),
    [anon_sym_AMP] = ACTIONS(1875),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2293),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2295),
    [anon_sym_var] = ACTIONS(2297),
    [sym_predefined_type] = ACTIONS(2299),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(2301),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2303),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [376] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(2997),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2749),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(2803),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(2975),
    [sym__array_base_type] = STATE(8712),
    [sym_nullable_type] = STATE(2974),
    [sym_pointer_type] = STATE(2974),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(2974),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(2973),
    [sym_pattern] = STATE(4193),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(2842),
    [sym_property_pattern_clause] = STATE(2893),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6710),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(4290),
    [sym_postfix_unary_expression] = STATE(4294),
    [sym_prefix_unary_expression] = STATE(4294),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(4290),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(4294),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(4290),
    [sym_member_access_expression] = STATE(3277),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(4294),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(4290),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(4290),
    [sym_typeof_expression] = STATE(4290),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3277),
    [sym_literal] = STATE(4290),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2742),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(376),
    [sym_preproc_endregion] = STATE(376),
    [sym_preproc_line] = STATE(376),
    [sym_preproc_pragma] = STATE(376),
    [sym_preproc_nullable] = STATE(376),
    [sym_preproc_error] = STATE(376),
    [sym_preproc_define] = STATE(376),
    [sym_preproc_undef] = STATE(376),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(2305),
    [anon_sym_ref] = ACTIONS(2287),
    [anon_sym_LBRACE] = ACTIONS(2289),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(2307),
    [anon_sym_GT] = ACTIONS(2307),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1357),
    [anon_sym_TILDE] = ACTIONS(1357),
    [anon_sym_PLUS_PLUS] = ACTIONS(1357),
    [anon_sym_DASH_DASH] = ACTIONS(1357),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1355),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1357),
    [anon_sym_AMP] = ACTIONS(1357),
    [anon_sym_GT_EQ] = ACTIONS(2309),
    [anon_sym_LT_EQ] = ACTIONS(2309),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2295),
    [anon_sym_var] = ACTIONS(2311),
    [sym_predefined_type] = ACTIONS(2313),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2315),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [377] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6723),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2850),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6128),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_pattern] = STATE(8338),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(6657),
    [sym_property_pattern_clause] = STATE(6741),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6688),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(6113),
    [sym_postfix_unary_expression] = STATE(6112),
    [sym_prefix_unary_expression] = STATE(6112),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(6113),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(6112),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(6113),
    [sym_member_access_expression] = STATE(4106),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(6112),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(6113),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(6113),
    [sym_typeof_expression] = STATE(6113),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(4106),
    [sym_literal] = STATE(6113),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2795),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(377),
    [sym_preproc_endregion] = STATE(377),
    [sym_preproc_line] = STATE(377),
    [sym_preproc_pragma] = STATE(377),
    [sym_preproc_nullable] = STATE(377),
    [sym_preproc_error] = STATE(377),
    [sym_preproc_define] = STATE(377),
    [sym_preproc_undef] = STATE(377),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(2317),
    [anon_sym_ref] = ACTIONS(2319),
    [anon_sym_LBRACE] = ACTIONS(2321),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(2323),
    [anon_sym_GT] = ACTIONS(2323),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1509),
    [anon_sym_PLUS_PLUS] = ACTIONS(1509),
    [anon_sym_DASH_DASH] = ACTIONS(1509),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1507),
    [anon_sym_DASH] = ACTIONS(1507),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1509),
    [anon_sym_AMP] = ACTIONS(1509),
    [anon_sym_GT_EQ] = ACTIONS(2325),
    [anon_sym_LT_EQ] = ACTIONS(2325),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2327),
    [anon_sym_var] = ACTIONS(2329),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2331),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [378] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(2997),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2749),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(2797),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(2975),
    [sym__array_base_type] = STATE(8712),
    [sym_nullable_type] = STATE(2974),
    [sym_pointer_type] = STATE(2974),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(2974),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(2973),
    [sym_pattern] = STATE(5338),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(2842),
    [sym_property_pattern_clause] = STATE(2893),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6667),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(4290),
    [sym_postfix_unary_expression] = STATE(4294),
    [sym_prefix_unary_expression] = STATE(4294),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(4290),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(4294),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(4290),
    [sym_member_access_expression] = STATE(3277),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(4294),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(4290),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(4290),
    [sym_typeof_expression] = STATE(4290),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3277),
    [sym_literal] = STATE(4290),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2742),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(378),
    [sym_preproc_endregion] = STATE(378),
    [sym_preproc_line] = STATE(378),
    [sym_preproc_pragma] = STATE(378),
    [sym_preproc_nullable] = STATE(378),
    [sym_preproc_error] = STATE(378),
    [sym_preproc_define] = STATE(378),
    [sym_preproc_undef] = STATE(378),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(2333),
    [anon_sym_ref] = ACTIONS(2287),
    [anon_sym_LBRACE] = ACTIONS(2289),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1053),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1059),
    [anon_sym_TILDE] = ACTIONS(1059),
    [anon_sym_PLUS_PLUS] = ACTIONS(1059),
    [anon_sym_DASH_DASH] = ACTIONS(1059),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1061),
    [anon_sym_DASH] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_GT_EQ] = ACTIONS(1063),
    [anon_sym_LT_EQ] = ACTIONS(1063),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2295),
    [anon_sym_var] = ACTIONS(2311),
    [sym_predefined_type] = ACTIONS(2313),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2335),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [379] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(3524),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2867),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(3029),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(2975),
    [sym__array_base_type] = STATE(8712),
    [sym_nullable_type] = STATE(2974),
    [sym_pointer_type] = STATE(2974),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(2974),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(2973),
    [sym_pattern] = STATE(4690),
    [sym_constant_pattern] = STATE(4709),
    [sym_parenthesized_pattern] = STATE(4709),
    [sym_var_pattern] = STATE(4709),
    [sym_type_pattern] = STATE(4709),
    [sym_list_pattern] = STATE(4709),
    [sym_recursive_pattern] = STATE(4709),
    [sym_positional_pattern_clause] = STATE(3123),
    [sym_property_pattern_clause] = STATE(3179),
    [sym_relational_pattern] = STATE(4709),
    [sym_negated_pattern] = STATE(4709),
    [sym_and_pattern] = STATE(4709),
    [sym_or_pattern] = STATE(4709),
    [sym_declaration_pattern] = STATE(4709),
    [sym_expression] = STATE(6707),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(4649),
    [sym_postfix_unary_expression] = STATE(4712),
    [sym_prefix_unary_expression] = STATE(4712),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(4649),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(4712),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(4649),
    [sym_member_access_expression] = STATE(3548),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(4712),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(4649),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(4649),
    [sym_typeof_expression] = STATE(4649),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3548),
    [sym_literal] = STATE(4649),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2742),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(379),
    [sym_preproc_endregion] = STATE(379),
    [sym_preproc_line] = STATE(379),
    [sym_preproc_pragma] = STATE(379),
    [sym_preproc_nullable] = STATE(379),
    [sym_preproc_error] = STATE(379),
    [sym_preproc_define] = STATE(379),
    [sym_preproc_undef] = STATE(379),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(2337),
    [anon_sym_LPAREN] = ACTIONS(2339),
    [anon_sym_ref] = ACTIONS(2287),
    [anon_sym_LBRACE] = ACTIONS(2289),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(2341),
    [anon_sym_GT] = ACTIONS(2341),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1621),
    [anon_sym_TILDE] = ACTIONS(1621),
    [anon_sym_PLUS_PLUS] = ACTIONS(1621),
    [anon_sym_DASH_DASH] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(1619),
    [anon_sym_DASH] = ACTIONS(1619),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1621),
    [anon_sym_AMP] = ACTIONS(1621),
    [anon_sym_GT_EQ] = ACTIONS(2343),
    [anon_sym_LT_EQ] = ACTIONS(2343),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2295),
    [anon_sym_var] = ACTIONS(2345),
    [sym_predefined_type] = ACTIONS(2347),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(2349),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2351),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [380] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6723),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2839),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6091),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_pattern] = STATE(7963),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(6657),
    [sym_property_pattern_clause] = STATE(6741),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6413),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4482),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(6144),
    [sym_postfix_unary_expression] = STATE(6143),
    [sym_prefix_unary_expression] = STATE(6143),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(6144),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(6143),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(6144),
    [sym_member_access_expression] = STATE(4163),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(6143),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9438),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(6144),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(6144),
    [sym_typeof_expression] = STATE(6144),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(4163),
    [sym_literal] = STATE(6144),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2795),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(380),
    [sym_preproc_endregion] = STATE(380),
    [sym_preproc_line] = STATE(380),
    [sym_preproc_pragma] = STATE(380),
    [sym_preproc_nullable] = STATE(380),
    [sym_preproc_error] = STATE(380),
    [sym_preproc_define] = STATE(380),
    [sym_preproc_undef] = STATE(380),
    [aux_sym_class_declaration_repeat1] = STATE(3801),
    [aux_sym_lambda_expression_repeat1] = STATE(4134),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(2317),
    [anon_sym_ref] = ACTIONS(2353),
    [anon_sym_LBRACE] = ACTIONS(2321),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(2323),
    [anon_sym_GT] = ACTIONS(2323),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1509),
    [anon_sym_PLUS_PLUS] = ACTIONS(1509),
    [anon_sym_DASH_DASH] = ACTIONS(1509),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1507),
    [anon_sym_DASH] = ACTIONS(1507),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1509),
    [anon_sym_AMP] = ACTIONS(1509),
    [anon_sym_GT_EQ] = ACTIONS(2325),
    [anon_sym_LT_EQ] = ACTIONS(2325),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2327),
    [anon_sym_var] = ACTIONS(2329),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1281),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1283),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(1285),
    [anon_sym_not] = ACTIONS(2331),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [381] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(3532),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2904),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(3064),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(2975),
    [sym__array_base_type] = STATE(8712),
    [sym_nullable_type] = STATE(2974),
    [sym_pointer_type] = STATE(2974),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(2974),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(2973),
    [sym_pattern] = STATE(6319),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(3150),
    [sym_property_pattern_clause] = STATE(3362),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6693),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(4290),
    [sym_postfix_unary_expression] = STATE(4294),
    [sym_prefix_unary_expression] = STATE(4294),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(4290),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(4294),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(4290),
    [sym_member_access_expression] = STATE(3277),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(4294),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(4290),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(4290),
    [sym_typeof_expression] = STATE(4290),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3277),
    [sym_literal] = STATE(4290),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2742),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(381),
    [sym_preproc_endregion] = STATE(381),
    [sym_preproc_line] = STATE(381),
    [sym_preproc_pragma] = STATE(381),
    [sym_preproc_nullable] = STATE(381),
    [sym_preproc_error] = STATE(381),
    [sym_preproc_define] = STATE(381),
    [sym_preproc_undef] = STATE(381),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(2355),
    [anon_sym_ref] = ACTIONS(2287),
    [anon_sym_LBRACE] = ACTIONS(2289),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(2357),
    [anon_sym_GT] = ACTIONS(2357),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1767),
    [anon_sym_TILDE] = ACTIONS(1767),
    [anon_sym_PLUS_PLUS] = ACTIONS(1767),
    [anon_sym_DASH_DASH] = ACTIONS(1767),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1765),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(1767),
    [anon_sym_GT_EQ] = ACTIONS(2359),
    [anon_sym_LT_EQ] = ACTIONS(2359),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2295),
    [anon_sym_var] = ACTIONS(2311),
    [sym_predefined_type] = ACTIONS(2313),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2361),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [382] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(2997),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2749),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(3026),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(2975),
    [sym__array_base_type] = STATE(8712),
    [sym_nullable_type] = STATE(2974),
    [sym_pointer_type] = STATE(2974),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(2974),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(2973),
    [sym_pattern] = STATE(6385),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(3119),
    [sym_property_pattern_clause] = STATE(3182),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6706),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(4290),
    [sym_postfix_unary_expression] = STATE(4294),
    [sym_prefix_unary_expression] = STATE(4294),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(4290),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(4294),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(4290),
    [sym_member_access_expression] = STATE(3277),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(4294),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(4290),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(4290),
    [sym_typeof_expression] = STATE(4290),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3277),
    [sym_literal] = STATE(4290),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2742),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(382),
    [sym_preproc_endregion] = STATE(382),
    [sym_preproc_line] = STATE(382),
    [sym_preproc_pragma] = STATE(382),
    [sym_preproc_nullable] = STATE(382),
    [sym_preproc_error] = STATE(382),
    [sym_preproc_define] = STATE(382),
    [sym_preproc_undef] = STATE(382),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(2363),
    [anon_sym_ref] = ACTIONS(2287),
    [anon_sym_LBRACE] = ACTIONS(2289),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(2365),
    [anon_sym_GT] = ACTIONS(2365),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_GT_EQ] = ACTIONS(2367),
    [anon_sym_LT_EQ] = ACTIONS(2367),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2295),
    [anon_sym_var] = ACTIONS(2369),
    [sym_predefined_type] = ACTIONS(2313),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2371),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [383] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(3532),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2904),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(3064),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(2975),
    [sym__array_base_type] = STATE(8712),
    [sym_nullable_type] = STATE(2974),
    [sym_pointer_type] = STATE(2974),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(2974),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(2973),
    [sym_pattern] = STATE(4118),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(3150),
    [sym_property_pattern_clause] = STATE(3362),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6693),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(4290),
    [sym_postfix_unary_expression] = STATE(4294),
    [sym_prefix_unary_expression] = STATE(4294),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(4290),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(4294),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(4290),
    [sym_member_access_expression] = STATE(3277),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(4294),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(4290),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(4290),
    [sym_typeof_expression] = STATE(4290),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3277),
    [sym_literal] = STATE(4290),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2742),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(383),
    [sym_preproc_endregion] = STATE(383),
    [sym_preproc_line] = STATE(383),
    [sym_preproc_pragma] = STATE(383),
    [sym_preproc_nullable] = STATE(383),
    [sym_preproc_error] = STATE(383),
    [sym_preproc_define] = STATE(383),
    [sym_preproc_undef] = STATE(383),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(2355),
    [anon_sym_ref] = ACTIONS(2287),
    [anon_sym_LBRACE] = ACTIONS(2289),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(2357),
    [anon_sym_GT] = ACTIONS(2357),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1767),
    [anon_sym_TILDE] = ACTIONS(1767),
    [anon_sym_PLUS_PLUS] = ACTIONS(1767),
    [anon_sym_DASH_DASH] = ACTIONS(1767),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1765),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(1767),
    [anon_sym_GT_EQ] = ACTIONS(2359),
    [anon_sym_LT_EQ] = ACTIONS(2359),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2295),
    [anon_sym_var] = ACTIONS(2311),
    [sym_predefined_type] = ACTIONS(2313),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2361),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [384] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(3532),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2904),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(3064),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(2975),
    [sym__array_base_type] = STATE(8712),
    [sym_nullable_type] = STATE(2974),
    [sym_pointer_type] = STATE(2974),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(2974),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(2973),
    [sym_pattern] = STATE(6529),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(3150),
    [sym_property_pattern_clause] = STATE(3362),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6693),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(4290),
    [sym_postfix_unary_expression] = STATE(4294),
    [sym_prefix_unary_expression] = STATE(4294),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(4290),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(4294),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(4290),
    [sym_member_access_expression] = STATE(3277),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(4294),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(4290),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(4290),
    [sym_typeof_expression] = STATE(4290),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3277),
    [sym_literal] = STATE(4290),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2742),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(384),
    [sym_preproc_endregion] = STATE(384),
    [sym_preproc_line] = STATE(384),
    [sym_preproc_pragma] = STATE(384),
    [sym_preproc_nullable] = STATE(384),
    [sym_preproc_error] = STATE(384),
    [sym_preproc_define] = STATE(384),
    [sym_preproc_undef] = STATE(384),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(2355),
    [anon_sym_ref] = ACTIONS(2287),
    [anon_sym_LBRACE] = ACTIONS(2289),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(2357),
    [anon_sym_GT] = ACTIONS(2357),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1767),
    [anon_sym_TILDE] = ACTIONS(1767),
    [anon_sym_PLUS_PLUS] = ACTIONS(1767),
    [anon_sym_DASH_DASH] = ACTIONS(1767),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1765),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(1767),
    [anon_sym_GT_EQ] = ACTIONS(2359),
    [anon_sym_LT_EQ] = ACTIONS(2359),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2295),
    [anon_sym_var] = ACTIONS(2311),
    [sym_predefined_type] = ACTIONS(2313),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2361),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [385] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(3161),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2747),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(2794),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(2975),
    [sym__array_base_type] = STATE(8712),
    [sym_nullable_type] = STATE(2974),
    [sym_pointer_type] = STATE(2974),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(2974),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(2973),
    [sym_pattern] = STATE(4043),
    [sym_constant_pattern] = STATE(3952),
    [sym_parenthesized_pattern] = STATE(3952),
    [sym_var_pattern] = STATE(3952),
    [sym_type_pattern] = STATE(3952),
    [sym_list_pattern] = STATE(3952),
    [sym_recursive_pattern] = STATE(3952),
    [sym_positional_pattern_clause] = STATE(2809),
    [sym_property_pattern_clause] = STATE(2851),
    [sym_relational_pattern] = STATE(3952),
    [sym_negated_pattern] = STATE(3952),
    [sym_and_pattern] = STATE(3952),
    [sym_or_pattern] = STATE(3952),
    [sym_declaration_pattern] = STATE(3952),
    [sym_expression] = STATE(6704),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3993),
    [sym_postfix_unary_expression] = STATE(3997),
    [sym_prefix_unary_expression] = STATE(3997),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3993),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3997),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3993),
    [sym_member_access_expression] = STATE(3202),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3997),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3993),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3993),
    [sym_typeof_expression] = STATE(3993),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3202),
    [sym_literal] = STATE(3993),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2762),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(385),
    [sym_preproc_endregion] = STATE(385),
    [sym_preproc_line] = STATE(385),
    [sym_preproc_pragma] = STATE(385),
    [sym_preproc_nullable] = STATE(385),
    [sym_preproc_error] = STATE(385),
    [sym_preproc_define] = STATE(385),
    [sym_preproc_undef] = STATE(385),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(2283),
    [anon_sym_LPAREN] = ACTIONS(2373),
    [anon_sym_ref] = ACTIONS(2375),
    [anon_sym_LBRACE] = ACTIONS(2289),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(2377),
    [anon_sym_GT] = ACTIONS(2377),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1329),
    [anon_sym_TILDE] = ACTIONS(1329),
    [anon_sym_PLUS_PLUS] = ACTIONS(1329),
    [anon_sym_DASH_DASH] = ACTIONS(1329),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1327),
    [anon_sym_DASH] = ACTIONS(1327),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1329),
    [anon_sym_AMP] = ACTIONS(1329),
    [anon_sym_GT_EQ] = ACTIONS(2379),
    [anon_sym_LT_EQ] = ACTIONS(2379),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2381),
    [anon_sym_var] = ACTIONS(2297),
    [sym_predefined_type] = ACTIONS(2299),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(2301),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2383),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [386] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(3520),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2847),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(3021),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(2975),
    [sym__array_base_type] = STATE(8712),
    [sym_nullable_type] = STATE(2974),
    [sym_pointer_type] = STATE(2974),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(2974),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(2973),
    [sym_pattern] = STATE(6116),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(3081),
    [sym_property_pattern_clause] = STATE(3148),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6688),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(4290),
    [sym_postfix_unary_expression] = STATE(4294),
    [sym_prefix_unary_expression] = STATE(4294),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(4290),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(4294),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(4290),
    [sym_member_access_expression] = STATE(3277),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(4294),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(4290),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(4290),
    [sym_typeof_expression] = STATE(4290),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3277),
    [sym_literal] = STATE(4290),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2762),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(386),
    [sym_preproc_endregion] = STATE(386),
    [sym_preproc_line] = STATE(386),
    [sym_preproc_pragma] = STATE(386),
    [sym_preproc_nullable] = STATE(386),
    [sym_preproc_error] = STATE(386),
    [sym_preproc_define] = STATE(386),
    [sym_preproc_undef] = STATE(386),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(2385),
    [anon_sym_ref] = ACTIONS(2375),
    [anon_sym_LBRACE] = ACTIONS(2289),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(2323),
    [anon_sym_GT] = ACTIONS(2323),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1509),
    [anon_sym_PLUS_PLUS] = ACTIONS(1509),
    [anon_sym_DASH_DASH] = ACTIONS(1509),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1507),
    [anon_sym_DASH] = ACTIONS(1507),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1509),
    [anon_sym_AMP] = ACTIONS(1509),
    [anon_sym_GT_EQ] = ACTIONS(2325),
    [anon_sym_LT_EQ] = ACTIONS(2325),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2381),
    [anon_sym_var] = ACTIONS(2311),
    [sym_predefined_type] = ACTIONS(2313),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2387),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [387] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(3520),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2847),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(3021),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(2975),
    [sym__array_base_type] = STATE(8712),
    [sym_nullable_type] = STATE(2974),
    [sym_pointer_type] = STATE(2974),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(2974),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(2973),
    [sym_pattern] = STATE(4118),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(3081),
    [sym_property_pattern_clause] = STATE(3148),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6688),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(4290),
    [sym_postfix_unary_expression] = STATE(4294),
    [sym_prefix_unary_expression] = STATE(4294),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(4290),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(4294),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(4290),
    [sym_member_access_expression] = STATE(3277),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(4294),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(4290),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(4290),
    [sym_typeof_expression] = STATE(4290),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3277),
    [sym_literal] = STATE(4290),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2762),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(387),
    [sym_preproc_endregion] = STATE(387),
    [sym_preproc_line] = STATE(387),
    [sym_preproc_pragma] = STATE(387),
    [sym_preproc_nullable] = STATE(387),
    [sym_preproc_error] = STATE(387),
    [sym_preproc_define] = STATE(387),
    [sym_preproc_undef] = STATE(387),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(2385),
    [anon_sym_ref] = ACTIONS(2375),
    [anon_sym_LBRACE] = ACTIONS(2289),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(2323),
    [anon_sym_GT] = ACTIONS(2323),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1509),
    [anon_sym_PLUS_PLUS] = ACTIONS(1509),
    [anon_sym_DASH_DASH] = ACTIONS(1509),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1507),
    [anon_sym_DASH] = ACTIONS(1507),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1509),
    [anon_sym_AMP] = ACTIONS(1509),
    [anon_sym_GT_EQ] = ACTIONS(2325),
    [anon_sym_LT_EQ] = ACTIONS(2325),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2381),
    [anon_sym_var] = ACTIONS(2311),
    [sym_predefined_type] = ACTIONS(2313),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2387),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [388] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(3520),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2847),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(3021),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(2975),
    [sym__array_base_type] = STATE(8712),
    [sym_nullable_type] = STATE(2974),
    [sym_pointer_type] = STATE(2974),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(2974),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(2973),
    [sym_pattern] = STATE(6178),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(3081),
    [sym_property_pattern_clause] = STATE(3148),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6688),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(4290),
    [sym_postfix_unary_expression] = STATE(4294),
    [sym_prefix_unary_expression] = STATE(4294),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(4290),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(4294),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(4290),
    [sym_member_access_expression] = STATE(3277),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(4294),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(4290),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(4290),
    [sym_typeof_expression] = STATE(4290),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3277),
    [sym_literal] = STATE(4290),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2762),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(388),
    [sym_preproc_endregion] = STATE(388),
    [sym_preproc_line] = STATE(388),
    [sym_preproc_pragma] = STATE(388),
    [sym_preproc_nullable] = STATE(388),
    [sym_preproc_error] = STATE(388),
    [sym_preproc_define] = STATE(388),
    [sym_preproc_undef] = STATE(388),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(2385),
    [anon_sym_ref] = ACTIONS(2375),
    [anon_sym_LBRACE] = ACTIONS(2289),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(2323),
    [anon_sym_GT] = ACTIONS(2323),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1509),
    [anon_sym_PLUS_PLUS] = ACTIONS(1509),
    [anon_sym_DASH_DASH] = ACTIONS(1509),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1507),
    [anon_sym_DASH] = ACTIONS(1507),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1509),
    [anon_sym_AMP] = ACTIONS(1509),
    [anon_sym_GT_EQ] = ACTIONS(2325),
    [anon_sym_LT_EQ] = ACTIONS(2325),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2381),
    [anon_sym_var] = ACTIONS(2311),
    [sym_predefined_type] = ACTIONS(2313),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2387),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [389] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(3524),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2867),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(3029),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(2975),
    [sym__array_base_type] = STATE(8712),
    [sym_nullable_type] = STATE(2974),
    [sym_pointer_type] = STATE(2974),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(2974),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(2973),
    [sym_pattern] = STATE(4883),
    [sym_constant_pattern] = STATE(4709),
    [sym_parenthesized_pattern] = STATE(4709),
    [sym_var_pattern] = STATE(4709),
    [sym_type_pattern] = STATE(4709),
    [sym_list_pattern] = STATE(4709),
    [sym_recursive_pattern] = STATE(4709),
    [sym_positional_pattern_clause] = STATE(3123),
    [sym_property_pattern_clause] = STATE(3179),
    [sym_relational_pattern] = STATE(4709),
    [sym_negated_pattern] = STATE(4709),
    [sym_and_pattern] = STATE(4709),
    [sym_or_pattern] = STATE(4709),
    [sym_declaration_pattern] = STATE(4709),
    [sym_expression] = STATE(6707),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(4649),
    [sym_postfix_unary_expression] = STATE(4712),
    [sym_prefix_unary_expression] = STATE(4712),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(4649),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(4712),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(4649),
    [sym_member_access_expression] = STATE(3548),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(4712),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(4649),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(4649),
    [sym_typeof_expression] = STATE(4649),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3548),
    [sym_literal] = STATE(4649),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2742),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(389),
    [sym_preproc_endregion] = STATE(389),
    [sym_preproc_line] = STATE(389),
    [sym_preproc_pragma] = STATE(389),
    [sym_preproc_nullable] = STATE(389),
    [sym_preproc_error] = STATE(389),
    [sym_preproc_define] = STATE(389),
    [sym_preproc_undef] = STATE(389),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(2337),
    [anon_sym_LPAREN] = ACTIONS(2339),
    [anon_sym_ref] = ACTIONS(2287),
    [anon_sym_LBRACE] = ACTIONS(2289),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(2341),
    [anon_sym_GT] = ACTIONS(2341),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1621),
    [anon_sym_TILDE] = ACTIONS(1621),
    [anon_sym_PLUS_PLUS] = ACTIONS(1621),
    [anon_sym_DASH_DASH] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(1619),
    [anon_sym_DASH] = ACTIONS(1619),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1621),
    [anon_sym_AMP] = ACTIONS(1621),
    [anon_sym_GT_EQ] = ACTIONS(2343),
    [anon_sym_LT_EQ] = ACTIONS(2343),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2295),
    [anon_sym_var] = ACTIONS(2345),
    [sym_predefined_type] = ACTIONS(2347),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(2349),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2351),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [390] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(3523),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2847),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(3025),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(2975),
    [sym__array_base_type] = STATE(8712),
    [sym_nullable_type] = STATE(2974),
    [sym_pointer_type] = STATE(2974),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(2974),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(2973),
    [sym_pattern] = STATE(4193),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(3081),
    [sym_property_pattern_clause] = STATE(3148),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6659),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(4290),
    [sym_postfix_unary_expression] = STATE(4294),
    [sym_prefix_unary_expression] = STATE(4294),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(4290),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(4294),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(4290),
    [sym_member_access_expression] = STATE(3277),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(4294),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(4290),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(4290),
    [sym_typeof_expression] = STATE(4290),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3277),
    [sym_literal] = STATE(4290),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2810),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(390),
    [sym_preproc_endregion] = STATE(390),
    [sym_preproc_line] = STATE(390),
    [sym_preproc_pragma] = STATE(390),
    [sym_preproc_nullable] = STATE(390),
    [sym_preproc_error] = STATE(390),
    [sym_preproc_define] = STATE(390),
    [sym_preproc_undef] = STATE(390),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(2389),
    [anon_sym_ref] = ACTIONS(2391),
    [anon_sym_LBRACE] = ACTIONS(2289),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(1929),
    [anon_sym_GT] = ACTIONS(1929),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1749),
    [anon_sym_TILDE] = ACTIONS(1749),
    [anon_sym_PLUS_PLUS] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1749),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1747),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1749),
    [anon_sym_AMP] = ACTIONS(1749),
    [anon_sym_GT_EQ] = ACTIONS(1931),
    [anon_sym_LT_EQ] = ACTIONS(1931),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2295),
    [anon_sym_var] = ACTIONS(2393),
    [sym_predefined_type] = ACTIONS(2313),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2395),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [391] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(3540),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2906),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(3061),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(2975),
    [sym__array_base_type] = STATE(8712),
    [sym_nullable_type] = STATE(2974),
    [sym_pointer_type] = STATE(2974),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(2974),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(2973),
    [sym_pattern] = STATE(6094),
    [sym_constant_pattern] = STATE(3952),
    [sym_parenthesized_pattern] = STATE(3952),
    [sym_var_pattern] = STATE(3952),
    [sym_type_pattern] = STATE(3952),
    [sym_list_pattern] = STATE(3952),
    [sym_recursive_pattern] = STATE(3952),
    [sym_positional_pattern_clause] = STATE(3132),
    [sym_property_pattern_clause] = STATE(3487),
    [sym_relational_pattern] = STATE(3952),
    [sym_negated_pattern] = STATE(3952),
    [sym_and_pattern] = STATE(3952),
    [sym_or_pattern] = STATE(3952),
    [sym_declaration_pattern] = STATE(3952),
    [sym_expression] = STATE(6686),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3993),
    [sym_postfix_unary_expression] = STATE(3997),
    [sym_prefix_unary_expression] = STATE(3997),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3993),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3997),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3993),
    [sym_member_access_expression] = STATE(3202),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3997),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3993),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3993),
    [sym_typeof_expression] = STATE(3993),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3202),
    [sym_literal] = STATE(3993),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2742),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(391),
    [sym_preproc_endregion] = STATE(391),
    [sym_preproc_line] = STATE(391),
    [sym_preproc_pragma] = STATE(391),
    [sym_preproc_nullable] = STATE(391),
    [sym_preproc_error] = STATE(391),
    [sym_preproc_define] = STATE(391),
    [sym_preproc_undef] = STATE(391),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(2283),
    [anon_sym_LPAREN] = ACTIONS(2397),
    [anon_sym_ref] = ACTIONS(2287),
    [anon_sym_LBRACE] = ACTIONS(2289),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(2399),
    [anon_sym_GT] = ACTIONS(2399),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1839),
    [anon_sym_TILDE] = ACTIONS(1839),
    [anon_sym_PLUS_PLUS] = ACTIONS(1839),
    [anon_sym_DASH_DASH] = ACTIONS(1839),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1837),
    [anon_sym_DASH] = ACTIONS(1837),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1839),
    [anon_sym_AMP] = ACTIONS(1839),
    [anon_sym_GT_EQ] = ACTIONS(2401),
    [anon_sym_LT_EQ] = ACTIONS(2401),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2295),
    [anon_sym_var] = ACTIONS(2297),
    [sym_predefined_type] = ACTIONS(2299),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(2301),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2403),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [392] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(3540),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2906),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(3061),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(2975),
    [sym__array_base_type] = STATE(8712),
    [sym_nullable_type] = STATE(2974),
    [sym_pointer_type] = STATE(2974),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(2974),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(2973),
    [sym_pattern] = STATE(4059),
    [sym_constant_pattern] = STATE(3952),
    [sym_parenthesized_pattern] = STATE(3952),
    [sym_var_pattern] = STATE(3952),
    [sym_type_pattern] = STATE(3952),
    [sym_list_pattern] = STATE(3952),
    [sym_recursive_pattern] = STATE(3952),
    [sym_positional_pattern_clause] = STATE(3132),
    [sym_property_pattern_clause] = STATE(3487),
    [sym_relational_pattern] = STATE(3952),
    [sym_negated_pattern] = STATE(3952),
    [sym_and_pattern] = STATE(3952),
    [sym_or_pattern] = STATE(3952),
    [sym_declaration_pattern] = STATE(3952),
    [sym_expression] = STATE(6686),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3993),
    [sym_postfix_unary_expression] = STATE(3997),
    [sym_prefix_unary_expression] = STATE(3997),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3993),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3997),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3993),
    [sym_member_access_expression] = STATE(3202),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3997),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3993),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3993),
    [sym_typeof_expression] = STATE(3993),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3202),
    [sym_literal] = STATE(3993),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2742),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(392),
    [sym_preproc_endregion] = STATE(392),
    [sym_preproc_line] = STATE(392),
    [sym_preproc_pragma] = STATE(392),
    [sym_preproc_nullable] = STATE(392),
    [sym_preproc_error] = STATE(392),
    [sym_preproc_define] = STATE(392),
    [sym_preproc_undef] = STATE(392),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(2283),
    [anon_sym_LPAREN] = ACTIONS(2397),
    [anon_sym_ref] = ACTIONS(2287),
    [anon_sym_LBRACE] = ACTIONS(2289),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(2399),
    [anon_sym_GT] = ACTIONS(2399),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1839),
    [anon_sym_TILDE] = ACTIONS(1839),
    [anon_sym_PLUS_PLUS] = ACTIONS(1839),
    [anon_sym_DASH_DASH] = ACTIONS(1839),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1837),
    [anon_sym_DASH] = ACTIONS(1837),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1839),
    [anon_sym_AMP] = ACTIONS(1839),
    [anon_sym_GT_EQ] = ACTIONS(2401),
    [anon_sym_LT_EQ] = ACTIONS(2401),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2295),
    [anon_sym_var] = ACTIONS(2297),
    [sym_predefined_type] = ACTIONS(2299),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(2301),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2403),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [393] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(2997),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2749),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(2797),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(2975),
    [sym__array_base_type] = STATE(8712),
    [sym_nullable_type] = STATE(2974),
    [sym_pointer_type] = STATE(2974),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(2974),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(2973),
    [sym_pattern] = STATE(4118),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(2842),
    [sym_property_pattern_clause] = STATE(2893),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6667),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(4290),
    [sym_postfix_unary_expression] = STATE(4294),
    [sym_prefix_unary_expression] = STATE(4294),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(4290),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(4294),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(4290),
    [sym_member_access_expression] = STATE(3277),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(4294),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(4290),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(4290),
    [sym_typeof_expression] = STATE(4290),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3277),
    [sym_literal] = STATE(4290),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2742),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(393),
    [sym_preproc_endregion] = STATE(393),
    [sym_preproc_line] = STATE(393),
    [sym_preproc_pragma] = STATE(393),
    [sym_preproc_nullable] = STATE(393),
    [sym_preproc_error] = STATE(393),
    [sym_preproc_define] = STATE(393),
    [sym_preproc_undef] = STATE(393),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(2333),
    [anon_sym_ref] = ACTIONS(2287),
    [anon_sym_LBRACE] = ACTIONS(2289),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1053),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1059),
    [anon_sym_TILDE] = ACTIONS(1059),
    [anon_sym_PLUS_PLUS] = ACTIONS(1059),
    [anon_sym_DASH_DASH] = ACTIONS(1059),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1061),
    [anon_sym_DASH] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_GT_EQ] = ACTIONS(1063),
    [anon_sym_LT_EQ] = ACTIONS(1063),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2295),
    [anon_sym_var] = ACTIONS(2311),
    [sym_predefined_type] = ACTIONS(2313),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2335),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [394] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(2997),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2749),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(2797),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(2975),
    [sym__array_base_type] = STATE(8712),
    [sym_nullable_type] = STATE(2974),
    [sym_pointer_type] = STATE(2974),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(2974),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(2973),
    [sym_pattern] = STATE(5298),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(2842),
    [sym_property_pattern_clause] = STATE(2893),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6667),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(4290),
    [sym_postfix_unary_expression] = STATE(4294),
    [sym_prefix_unary_expression] = STATE(4294),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(4290),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(4294),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(4290),
    [sym_member_access_expression] = STATE(3277),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(4294),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(4290),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(4290),
    [sym_typeof_expression] = STATE(4290),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3277),
    [sym_literal] = STATE(4290),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2742),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(394),
    [sym_preproc_endregion] = STATE(394),
    [sym_preproc_line] = STATE(394),
    [sym_preproc_pragma] = STATE(394),
    [sym_preproc_nullable] = STATE(394),
    [sym_preproc_error] = STATE(394),
    [sym_preproc_define] = STATE(394),
    [sym_preproc_undef] = STATE(394),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(2333),
    [anon_sym_ref] = ACTIONS(2287),
    [anon_sym_LBRACE] = ACTIONS(2289),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1053),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1059),
    [anon_sym_TILDE] = ACTIONS(1059),
    [anon_sym_PLUS_PLUS] = ACTIONS(1059),
    [anon_sym_DASH_DASH] = ACTIONS(1059),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1061),
    [anon_sym_DASH] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_GT_EQ] = ACTIONS(1063),
    [anon_sym_LT_EQ] = ACTIONS(1063),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2295),
    [anon_sym_var] = ACTIONS(2311),
    [sym_predefined_type] = ACTIONS(2313),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2335),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [395] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(2992),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2747),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(2794),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(2975),
    [sym__array_base_type] = STATE(8712),
    [sym_nullable_type] = STATE(2974),
    [sym_pointer_type] = STATE(2974),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(2974),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(2973),
    [sym_pattern] = STATE(4043),
    [sym_constant_pattern] = STATE(3952),
    [sym_parenthesized_pattern] = STATE(3952),
    [sym_var_pattern] = STATE(3952),
    [sym_type_pattern] = STATE(3952),
    [sym_list_pattern] = STATE(3952),
    [sym_recursive_pattern] = STATE(3952),
    [sym_positional_pattern_clause] = STATE(2809),
    [sym_property_pattern_clause] = STATE(2851),
    [sym_relational_pattern] = STATE(3952),
    [sym_negated_pattern] = STATE(3952),
    [sym_and_pattern] = STATE(3952),
    [sym_or_pattern] = STATE(3952),
    [sym_declaration_pattern] = STATE(3952),
    [sym_expression] = STATE(6662),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3993),
    [sym_postfix_unary_expression] = STATE(3997),
    [sym_prefix_unary_expression] = STATE(3997),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3993),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3997),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3993),
    [sym_member_access_expression] = STATE(3202),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3997),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3993),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3993),
    [sym_typeof_expression] = STATE(3993),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3202),
    [sym_literal] = STATE(3993),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2742),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(395),
    [sym_preproc_endregion] = STATE(395),
    [sym_preproc_line] = STATE(395),
    [sym_preproc_pragma] = STATE(395),
    [sym_preproc_nullable] = STATE(395),
    [sym_preproc_error] = STATE(395),
    [sym_preproc_define] = STATE(395),
    [sym_preproc_undef] = STATE(395),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(2283),
    [anon_sym_LPAREN] = ACTIONS(2405),
    [anon_sym_ref] = ACTIONS(2287),
    [anon_sym_LBRACE] = ACTIONS(2289),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(2407),
    [anon_sym_GT] = ACTIONS(2407),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1153),
    [anon_sym_TILDE] = ACTIONS(1153),
    [anon_sym_PLUS_PLUS] = ACTIONS(1153),
    [anon_sym_DASH_DASH] = ACTIONS(1153),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1151),
    [anon_sym_DASH] = ACTIONS(1151),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1153),
    [anon_sym_AMP] = ACTIONS(1153),
    [anon_sym_GT_EQ] = ACTIONS(2409),
    [anon_sym_LT_EQ] = ACTIONS(2409),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2295),
    [anon_sym_var] = ACTIONS(2297),
    [sym_predefined_type] = ACTIONS(2299),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(2301),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2411),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [396] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6723),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2850),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6128),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_pattern] = STATE(4118),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(6657),
    [sym_property_pattern_clause] = STATE(6741),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6688),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(6113),
    [sym_postfix_unary_expression] = STATE(6112),
    [sym_prefix_unary_expression] = STATE(6112),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(6113),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(6112),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(6113),
    [sym_member_access_expression] = STATE(4106),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(6112),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(6113),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(6113),
    [sym_typeof_expression] = STATE(6113),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(4106),
    [sym_literal] = STATE(6113),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2795),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(396),
    [sym_preproc_endregion] = STATE(396),
    [sym_preproc_line] = STATE(396),
    [sym_preproc_pragma] = STATE(396),
    [sym_preproc_nullable] = STATE(396),
    [sym_preproc_error] = STATE(396),
    [sym_preproc_define] = STATE(396),
    [sym_preproc_undef] = STATE(396),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(2317),
    [anon_sym_ref] = ACTIONS(2319),
    [anon_sym_LBRACE] = ACTIONS(2321),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(2323),
    [anon_sym_GT] = ACTIONS(2323),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1509),
    [anon_sym_PLUS_PLUS] = ACTIONS(1509),
    [anon_sym_DASH_DASH] = ACTIONS(1509),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1507),
    [anon_sym_DASH] = ACTIONS(1507),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1509),
    [anon_sym_AMP] = ACTIONS(1509),
    [anon_sym_GT_EQ] = ACTIONS(2325),
    [anon_sym_LT_EQ] = ACTIONS(2325),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2327),
    [anon_sym_var] = ACTIONS(2329),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2331),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [397] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(3533),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2888),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(3075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(2975),
    [sym__array_base_type] = STATE(8712),
    [sym_nullable_type] = STATE(2974),
    [sym_pointer_type] = STATE(2974),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(2974),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(2973),
    [sym_pattern] = STATE(6225),
    [sym_constant_pattern] = STATE(3952),
    [sym_parenthesized_pattern] = STATE(3952),
    [sym_var_pattern] = STATE(3952),
    [sym_type_pattern] = STATE(3952),
    [sym_list_pattern] = STATE(3952),
    [sym_recursive_pattern] = STATE(3952),
    [sym_positional_pattern_clause] = STATE(3149),
    [sym_property_pattern_clause] = STATE(3466),
    [sym_relational_pattern] = STATE(3952),
    [sym_negated_pattern] = STATE(3952),
    [sym_and_pattern] = STATE(3952),
    [sym_or_pattern] = STATE(3952),
    [sym_declaration_pattern] = STATE(3952),
    [sym_expression] = STATE(6705),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3993),
    [sym_postfix_unary_expression] = STATE(3997),
    [sym_prefix_unary_expression] = STATE(3997),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3993),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3997),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3993),
    [sym_member_access_expression] = STATE(3202),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3997),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3993),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3993),
    [sym_typeof_expression] = STATE(3993),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3202),
    [sym_literal] = STATE(3993),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2742),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(397),
    [sym_preproc_endregion] = STATE(397),
    [sym_preproc_line] = STATE(397),
    [sym_preproc_pragma] = STATE(397),
    [sym_preproc_nullable] = STATE(397),
    [sym_preproc_error] = STATE(397),
    [sym_preproc_define] = STATE(397),
    [sym_preproc_undef] = STATE(397),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(2283),
    [anon_sym_LPAREN] = ACTIONS(2413),
    [anon_sym_ref] = ACTIONS(2287),
    [anon_sym_LBRACE] = ACTIONS(2289),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(2415),
    [anon_sym_GT] = ACTIONS(2415),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1785),
    [anon_sym_TILDE] = ACTIONS(1785),
    [anon_sym_PLUS_PLUS] = ACTIONS(1785),
    [anon_sym_DASH_DASH] = ACTIONS(1785),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1785),
    [anon_sym_AMP] = ACTIONS(1785),
    [anon_sym_GT_EQ] = ACTIONS(2417),
    [anon_sym_LT_EQ] = ACTIONS(2417),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2295),
    [anon_sym_var] = ACTIONS(2297),
    [sym_predefined_type] = ACTIONS(2299),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(2301),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2419),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [398] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(2997),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2749),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(3036),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(2975),
    [sym__array_base_type] = STATE(8712),
    [sym_nullable_type] = STATE(2974),
    [sym_pointer_type] = STATE(2974),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(2974),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(2973),
    [sym_pattern] = STATE(6349),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(3119),
    [sym_property_pattern_clause] = STATE(3182),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6706),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(4290),
    [sym_postfix_unary_expression] = STATE(4294),
    [sym_prefix_unary_expression] = STATE(4294),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(4290),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(4294),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(4290),
    [sym_member_access_expression] = STATE(3277),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(4294),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(4290),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(4290),
    [sym_typeof_expression] = STATE(4290),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3277),
    [sym_literal] = STATE(4290),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2742),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(398),
    [sym_preproc_endregion] = STATE(398),
    [sym_preproc_line] = STATE(398),
    [sym_preproc_pragma] = STATE(398),
    [sym_preproc_nullable] = STATE(398),
    [sym_preproc_error] = STATE(398),
    [sym_preproc_define] = STATE(398),
    [sym_preproc_undef] = STATE(398),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(2363),
    [anon_sym_ref] = ACTIONS(2287),
    [anon_sym_LBRACE] = ACTIONS(2289),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(2365),
    [anon_sym_GT] = ACTIONS(2365),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_GT_EQ] = ACTIONS(2367),
    [anon_sym_LT_EQ] = ACTIONS(2367),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2295),
    [anon_sym_var] = ACTIONS(2369),
    [sym_predefined_type] = ACTIONS(2313),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2371),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [399] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(3540),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2906),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(3061),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(2975),
    [sym__array_base_type] = STATE(8712),
    [sym_nullable_type] = STATE(2974),
    [sym_pointer_type] = STATE(2974),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(2974),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(2973),
    [sym_pattern] = STATE(6097),
    [sym_constant_pattern] = STATE(3952),
    [sym_parenthesized_pattern] = STATE(3952),
    [sym_var_pattern] = STATE(3952),
    [sym_type_pattern] = STATE(3952),
    [sym_list_pattern] = STATE(3952),
    [sym_recursive_pattern] = STATE(3952),
    [sym_positional_pattern_clause] = STATE(3132),
    [sym_property_pattern_clause] = STATE(3487),
    [sym_relational_pattern] = STATE(3952),
    [sym_negated_pattern] = STATE(3952),
    [sym_and_pattern] = STATE(3952),
    [sym_or_pattern] = STATE(3952),
    [sym_declaration_pattern] = STATE(3952),
    [sym_expression] = STATE(6686),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3993),
    [sym_postfix_unary_expression] = STATE(3997),
    [sym_prefix_unary_expression] = STATE(3997),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3993),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3997),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3993),
    [sym_member_access_expression] = STATE(3202),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3997),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3993),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3993),
    [sym_typeof_expression] = STATE(3993),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3202),
    [sym_literal] = STATE(3993),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2742),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(399),
    [sym_preproc_endregion] = STATE(399),
    [sym_preproc_line] = STATE(399),
    [sym_preproc_pragma] = STATE(399),
    [sym_preproc_nullable] = STATE(399),
    [sym_preproc_error] = STATE(399),
    [sym_preproc_define] = STATE(399),
    [sym_preproc_undef] = STATE(399),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(2283),
    [anon_sym_LPAREN] = ACTIONS(2397),
    [anon_sym_ref] = ACTIONS(2287),
    [anon_sym_LBRACE] = ACTIONS(2289),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(2399),
    [anon_sym_GT] = ACTIONS(2399),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1839),
    [anon_sym_TILDE] = ACTIONS(1839),
    [anon_sym_PLUS_PLUS] = ACTIONS(1839),
    [anon_sym_DASH_DASH] = ACTIONS(1839),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1837),
    [anon_sym_DASH] = ACTIONS(1837),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1839),
    [anon_sym_AMP] = ACTIONS(1839),
    [anon_sym_GT_EQ] = ACTIONS(2401),
    [anon_sym_LT_EQ] = ACTIONS(2401),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2295),
    [anon_sym_var] = ACTIONS(2297),
    [sym_predefined_type] = ACTIONS(2299),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(2301),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2403),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [400] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(3520),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2847),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(3022),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(2975),
    [sym__array_base_type] = STATE(8712),
    [sym_nullable_type] = STATE(2974),
    [sym_pointer_type] = STATE(2974),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(2974),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(2973),
    [sym_pattern] = STATE(4193),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(3081),
    [sym_property_pattern_clause] = STATE(3148),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6688),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(4290),
    [sym_postfix_unary_expression] = STATE(4294),
    [sym_prefix_unary_expression] = STATE(4294),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(4290),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(4294),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(4290),
    [sym_member_access_expression] = STATE(3277),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(4294),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(4290),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(4290),
    [sym_typeof_expression] = STATE(4290),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3277),
    [sym_literal] = STATE(4290),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2762),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(400),
    [sym_preproc_endregion] = STATE(400),
    [sym_preproc_line] = STATE(400),
    [sym_preproc_pragma] = STATE(400),
    [sym_preproc_nullable] = STATE(400),
    [sym_preproc_error] = STATE(400),
    [sym_preproc_define] = STATE(400),
    [sym_preproc_undef] = STATE(400),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(2385),
    [anon_sym_ref] = ACTIONS(2375),
    [anon_sym_LBRACE] = ACTIONS(2289),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(2323),
    [anon_sym_GT] = ACTIONS(2323),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1509),
    [anon_sym_PLUS_PLUS] = ACTIONS(1509),
    [anon_sym_DASH_DASH] = ACTIONS(1509),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1507),
    [anon_sym_DASH] = ACTIONS(1507),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1509),
    [anon_sym_AMP] = ACTIONS(1509),
    [anon_sym_GT_EQ] = ACTIONS(2325),
    [anon_sym_LT_EQ] = ACTIONS(2325),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2381),
    [anon_sym_var] = ACTIONS(2311),
    [sym_predefined_type] = ACTIONS(2313),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2387),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [401] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2789),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(5318),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_pattern] = STATE(8200),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(6141),
    [sym_property_pattern_clause] = STATE(6672),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6667),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(5313),
    [sym_postfix_unary_expression] = STATE(5314),
    [sym_prefix_unary_expression] = STATE(5314),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(5313),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(5314),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(5313),
    [sym_member_access_expression] = STATE(3856),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(5314),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(5313),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(5313),
    [sym_typeof_expression] = STATE(5313),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3856),
    [sym_literal] = STATE(5313),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(401),
    [sym_preproc_endregion] = STATE(401),
    [sym_preproc_line] = STATE(401),
    [sym_preproc_pragma] = STATE(401),
    [sym_preproc_nullable] = STATE(401),
    [sym_preproc_error] = STATE(401),
    [sym_preproc_define] = STATE(401),
    [sym_preproc_undef] = STATE(401),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(1043),
    [anon_sym_ref] = ACTIONS(2257),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1053),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1059),
    [anon_sym_TILDE] = ACTIONS(1059),
    [anon_sym_PLUS_PLUS] = ACTIONS(1059),
    [anon_sym_DASH_DASH] = ACTIONS(1059),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1061),
    [anon_sym_DASH] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_GT_EQ] = ACTIONS(1063),
    [anon_sym_LT_EQ] = ACTIONS(1063),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1065),
    [anon_sym_var] = ACTIONS(1067),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(1077),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [402] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(3178),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2749),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(2801),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(2975),
    [sym__array_base_type] = STATE(8712),
    [sym_nullable_type] = STATE(2974),
    [sym_pointer_type] = STATE(2974),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(2974),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(2973),
    [sym_pattern] = STATE(6443),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(2842),
    [sym_property_pattern_clause] = STATE(2893),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6690),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(4290),
    [sym_postfix_unary_expression] = STATE(4294),
    [sym_prefix_unary_expression] = STATE(4294),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(4290),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(4294),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(4290),
    [sym_member_access_expression] = STATE(3277),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(4294),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(4290),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(4290),
    [sym_typeof_expression] = STATE(4290),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3277),
    [sym_literal] = STATE(4290),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2762),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(402),
    [sym_preproc_endregion] = STATE(402),
    [sym_preproc_line] = STATE(402),
    [sym_preproc_pragma] = STATE(402),
    [sym_preproc_nullable] = STATE(402),
    [sym_preproc_error] = STATE(402),
    [sym_preproc_define] = STATE(402),
    [sym_preproc_undef] = STATE(402),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(2421),
    [anon_sym_ref] = ACTIONS(2375),
    [anon_sym_LBRACE] = ACTIONS(2289),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(2423),
    [anon_sym_GT] = ACTIONS(2423),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1551),
    [anon_sym_TILDE] = ACTIONS(1551),
    [anon_sym_PLUS_PLUS] = ACTIONS(1551),
    [anon_sym_DASH_DASH] = ACTIONS(1551),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1549),
    [anon_sym_DASH] = ACTIONS(1549),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1551),
    [anon_sym_AMP] = ACTIONS(1551),
    [anon_sym_GT_EQ] = ACTIONS(2425),
    [anon_sym_LT_EQ] = ACTIONS(2425),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2381),
    [anon_sym_var] = ACTIONS(2311),
    [sym_predefined_type] = ACTIONS(2313),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2427),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [403] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(3532),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2904),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(3056),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(2975),
    [sym__array_base_type] = STATE(8712),
    [sym_nullable_type] = STATE(2974),
    [sym_pointer_type] = STATE(2974),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(2974),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(2973),
    [sym_pattern] = STATE(6280),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(3150),
    [sym_property_pattern_clause] = STATE(3362),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6693),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(4290),
    [sym_postfix_unary_expression] = STATE(4294),
    [sym_prefix_unary_expression] = STATE(4294),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(4290),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(4294),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(4290),
    [sym_member_access_expression] = STATE(3277),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(4294),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(4290),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(4290),
    [sym_typeof_expression] = STATE(4290),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3277),
    [sym_literal] = STATE(4290),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2742),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(403),
    [sym_preproc_endregion] = STATE(403),
    [sym_preproc_line] = STATE(403),
    [sym_preproc_pragma] = STATE(403),
    [sym_preproc_nullable] = STATE(403),
    [sym_preproc_error] = STATE(403),
    [sym_preproc_define] = STATE(403),
    [sym_preproc_undef] = STATE(403),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(2355),
    [anon_sym_ref] = ACTIONS(2287),
    [anon_sym_LBRACE] = ACTIONS(2289),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(2357),
    [anon_sym_GT] = ACTIONS(2357),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1767),
    [anon_sym_TILDE] = ACTIONS(1767),
    [anon_sym_PLUS_PLUS] = ACTIONS(1767),
    [anon_sym_DASH_DASH] = ACTIONS(1767),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1765),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(1767),
    [anon_sym_GT_EQ] = ACTIONS(2359),
    [anon_sym_LT_EQ] = ACTIONS(2359),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2295),
    [anon_sym_var] = ACTIONS(2311),
    [sym_predefined_type] = ACTIONS(2313),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2361),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [404] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2789),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(5318),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_pattern] = STATE(4118),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(6141),
    [sym_property_pattern_clause] = STATE(6672),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6667),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(5313),
    [sym_postfix_unary_expression] = STATE(5314),
    [sym_prefix_unary_expression] = STATE(5314),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(5313),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(5314),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(5313),
    [sym_member_access_expression] = STATE(3856),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(5314),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(5313),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(5313),
    [sym_typeof_expression] = STATE(5313),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3856),
    [sym_literal] = STATE(5313),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(404),
    [sym_preproc_endregion] = STATE(404),
    [sym_preproc_line] = STATE(404),
    [sym_preproc_pragma] = STATE(404),
    [sym_preproc_nullable] = STATE(404),
    [sym_preproc_error] = STATE(404),
    [sym_preproc_define] = STATE(404),
    [sym_preproc_undef] = STATE(404),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(1043),
    [anon_sym_ref] = ACTIONS(2257),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1053),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1059),
    [anon_sym_TILDE] = ACTIONS(1059),
    [anon_sym_PLUS_PLUS] = ACTIONS(1059),
    [anon_sym_DASH_DASH] = ACTIONS(1059),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1061),
    [anon_sym_DASH] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_GT_EQ] = ACTIONS(1063),
    [anon_sym_LT_EQ] = ACTIONS(1063),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1065),
    [anon_sym_var] = ACTIONS(1067),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(1077),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [405] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2789),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(5318),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_pattern] = STATE(8322),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(6141),
    [sym_property_pattern_clause] = STATE(6672),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6667),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(5313),
    [sym_postfix_unary_expression] = STATE(5314),
    [sym_prefix_unary_expression] = STATE(5314),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(5313),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(5314),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(5313),
    [sym_member_access_expression] = STATE(3856),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(5314),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(5313),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(5313),
    [sym_typeof_expression] = STATE(5313),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3856),
    [sym_literal] = STATE(5313),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(405),
    [sym_preproc_endregion] = STATE(405),
    [sym_preproc_line] = STATE(405),
    [sym_preproc_pragma] = STATE(405),
    [sym_preproc_nullable] = STATE(405),
    [sym_preproc_error] = STATE(405),
    [sym_preproc_define] = STATE(405),
    [sym_preproc_undef] = STATE(405),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(1043),
    [anon_sym_ref] = ACTIONS(2429),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1053),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1059),
    [anon_sym_TILDE] = ACTIONS(1059),
    [anon_sym_PLUS_PLUS] = ACTIONS(1059),
    [anon_sym_DASH_DASH] = ACTIONS(1059),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1061),
    [anon_sym_DASH] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_GT_EQ] = ACTIONS(1063),
    [anon_sym_LT_EQ] = ACTIONS(1063),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2265),
    [anon_sym_var] = ACTIONS(1067),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(1117),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [406] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(2992),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2747),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(2785),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(2975),
    [sym__array_base_type] = STATE(8712),
    [sym_nullable_type] = STATE(2974),
    [sym_pointer_type] = STATE(2974),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(2974),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(2973),
    [sym_pattern] = STATE(4875),
    [sym_constant_pattern] = STATE(3952),
    [sym_parenthesized_pattern] = STATE(3952),
    [sym_var_pattern] = STATE(3952),
    [sym_type_pattern] = STATE(3952),
    [sym_list_pattern] = STATE(3952),
    [sym_recursive_pattern] = STATE(3952),
    [sym_positional_pattern_clause] = STATE(2809),
    [sym_property_pattern_clause] = STATE(2851),
    [sym_relational_pattern] = STATE(3952),
    [sym_negated_pattern] = STATE(3952),
    [sym_and_pattern] = STATE(3952),
    [sym_or_pattern] = STATE(3952),
    [sym_declaration_pattern] = STATE(3952),
    [sym_expression] = STATE(6662),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3993),
    [sym_postfix_unary_expression] = STATE(3997),
    [sym_prefix_unary_expression] = STATE(3997),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3993),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3997),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3993),
    [sym_member_access_expression] = STATE(3202),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3997),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3993),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3993),
    [sym_typeof_expression] = STATE(3993),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3202),
    [sym_literal] = STATE(3993),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2742),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(406),
    [sym_preproc_endregion] = STATE(406),
    [sym_preproc_line] = STATE(406),
    [sym_preproc_pragma] = STATE(406),
    [sym_preproc_nullable] = STATE(406),
    [sym_preproc_error] = STATE(406),
    [sym_preproc_define] = STATE(406),
    [sym_preproc_undef] = STATE(406),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(2283),
    [anon_sym_LPAREN] = ACTIONS(2405),
    [anon_sym_ref] = ACTIONS(2287),
    [anon_sym_LBRACE] = ACTIONS(2289),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(2407),
    [anon_sym_GT] = ACTIONS(2407),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1153),
    [anon_sym_TILDE] = ACTIONS(1153),
    [anon_sym_PLUS_PLUS] = ACTIONS(1153),
    [anon_sym_DASH_DASH] = ACTIONS(1153),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1151),
    [anon_sym_DASH] = ACTIONS(1151),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1153),
    [anon_sym_AMP] = ACTIONS(1153),
    [anon_sym_GT_EQ] = ACTIONS(2409),
    [anon_sym_LT_EQ] = ACTIONS(2409),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2295),
    [anon_sym_var] = ACTIONS(2297),
    [sym_predefined_type] = ACTIONS(2299),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(2301),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2411),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [407] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2789),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(5318),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_pattern] = STATE(8232),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(6141),
    [sym_property_pattern_clause] = STATE(6672),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6667),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(5313),
    [sym_postfix_unary_expression] = STATE(5314),
    [sym_prefix_unary_expression] = STATE(5314),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(5313),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(5314),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(5313),
    [sym_member_access_expression] = STATE(3856),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(5314),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(5313),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(5313),
    [sym_typeof_expression] = STATE(5313),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3856),
    [sym_literal] = STATE(5313),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(407),
    [sym_preproc_endregion] = STATE(407),
    [sym_preproc_line] = STATE(407),
    [sym_preproc_pragma] = STATE(407),
    [sym_preproc_nullable] = STATE(407),
    [sym_preproc_error] = STATE(407),
    [sym_preproc_define] = STATE(407),
    [sym_preproc_undef] = STATE(407),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(1043),
    [anon_sym_ref] = ACTIONS(2257),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1053),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1059),
    [anon_sym_TILDE] = ACTIONS(1059),
    [anon_sym_PLUS_PLUS] = ACTIONS(1059),
    [anon_sym_DASH_DASH] = ACTIONS(1059),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1061),
    [anon_sym_DASH] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_GT_EQ] = ACTIONS(1063),
    [anon_sym_LT_EQ] = ACTIONS(1063),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1065),
    [anon_sym_var] = ACTIONS(1067),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(2259),
    [anon_sym_not] = ACTIONS(1077),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [408] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(3536),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2891),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(3054),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(2975),
    [sym__array_base_type] = STATE(8712),
    [sym_nullable_type] = STATE(2974),
    [sym_pointer_type] = STATE(2974),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(2974),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(2973),
    [sym_pattern] = STATE(6638),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(3140),
    [sym_property_pattern_clause] = STATE(3227),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6670),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(4290),
    [sym_postfix_unary_expression] = STATE(4294),
    [sym_prefix_unary_expression] = STATE(4294),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(4290),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(4294),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(4290),
    [sym_member_access_expression] = STATE(3277),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(4294),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(4290),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(4290),
    [sym_typeof_expression] = STATE(4290),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3277),
    [sym_literal] = STATE(4290),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2742),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(408),
    [sym_preproc_endregion] = STATE(408),
    [sym_preproc_line] = STATE(408),
    [sym_preproc_pragma] = STATE(408),
    [sym_preproc_nullable] = STATE(408),
    [sym_preproc_error] = STATE(408),
    [sym_preproc_define] = STATE(408),
    [sym_preproc_undef] = STATE(408),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(2431),
    [anon_sym_ref] = ACTIONS(2287),
    [anon_sym_LBRACE] = ACTIONS(2289),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(2433),
    [anon_sym_GT] = ACTIONS(2433),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1893),
    [anon_sym_TILDE] = ACTIONS(1893),
    [anon_sym_PLUS_PLUS] = ACTIONS(1893),
    [anon_sym_DASH_DASH] = ACTIONS(1893),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1891),
    [anon_sym_DASH] = ACTIONS(1891),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1893),
    [anon_sym_AMP] = ACTIONS(1893),
    [anon_sym_GT_EQ] = ACTIONS(2435),
    [anon_sym_LT_EQ] = ACTIONS(2435),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2295),
    [anon_sym_var] = ACTIONS(2311),
    [sym_predefined_type] = ACTIONS(2313),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2437),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [409] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(2992),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2747),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(2785),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(2975),
    [sym__array_base_type] = STATE(8712),
    [sym_nullable_type] = STATE(2974),
    [sym_pointer_type] = STATE(2974),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(2974),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(2973),
    [sym_pattern] = STATE(4059),
    [sym_constant_pattern] = STATE(3952),
    [sym_parenthesized_pattern] = STATE(3952),
    [sym_var_pattern] = STATE(3952),
    [sym_type_pattern] = STATE(3952),
    [sym_list_pattern] = STATE(3952),
    [sym_recursive_pattern] = STATE(3952),
    [sym_positional_pattern_clause] = STATE(2809),
    [sym_property_pattern_clause] = STATE(2851),
    [sym_relational_pattern] = STATE(3952),
    [sym_negated_pattern] = STATE(3952),
    [sym_and_pattern] = STATE(3952),
    [sym_or_pattern] = STATE(3952),
    [sym_declaration_pattern] = STATE(3952),
    [sym_expression] = STATE(6662),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3993),
    [sym_postfix_unary_expression] = STATE(3997),
    [sym_prefix_unary_expression] = STATE(3997),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3993),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3997),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3993),
    [sym_member_access_expression] = STATE(3202),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3997),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3993),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3993),
    [sym_typeof_expression] = STATE(3993),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3202),
    [sym_literal] = STATE(3993),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2742),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(409),
    [sym_preproc_endregion] = STATE(409),
    [sym_preproc_line] = STATE(409),
    [sym_preproc_pragma] = STATE(409),
    [sym_preproc_nullable] = STATE(409),
    [sym_preproc_error] = STATE(409),
    [sym_preproc_define] = STATE(409),
    [sym_preproc_undef] = STATE(409),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(2283),
    [anon_sym_LPAREN] = ACTIONS(2405),
    [anon_sym_ref] = ACTIONS(2287),
    [anon_sym_LBRACE] = ACTIONS(2289),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(2407),
    [anon_sym_GT] = ACTIONS(2407),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1153),
    [anon_sym_TILDE] = ACTIONS(1153),
    [anon_sym_PLUS_PLUS] = ACTIONS(1153),
    [anon_sym_DASH_DASH] = ACTIONS(1153),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1151),
    [anon_sym_DASH] = ACTIONS(1151),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1153),
    [anon_sym_AMP] = ACTIONS(1153),
    [anon_sym_GT_EQ] = ACTIONS(2409),
    [anon_sym_LT_EQ] = ACTIONS(2409),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2295),
    [anon_sym_var] = ACTIONS(2297),
    [sym_predefined_type] = ACTIONS(2299),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(2301),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2411),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [410] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(2992),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2747),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(2785),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(2975),
    [sym__array_base_type] = STATE(8712),
    [sym_nullable_type] = STATE(2974),
    [sym_pointer_type] = STATE(2974),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(2974),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(2973),
    [sym_pattern] = STATE(4742),
    [sym_constant_pattern] = STATE(3952),
    [sym_parenthesized_pattern] = STATE(3952),
    [sym_var_pattern] = STATE(3952),
    [sym_type_pattern] = STATE(3952),
    [sym_list_pattern] = STATE(3952),
    [sym_recursive_pattern] = STATE(3952),
    [sym_positional_pattern_clause] = STATE(2809),
    [sym_property_pattern_clause] = STATE(2851),
    [sym_relational_pattern] = STATE(3952),
    [sym_negated_pattern] = STATE(3952),
    [sym_and_pattern] = STATE(3952),
    [sym_or_pattern] = STATE(3952),
    [sym_declaration_pattern] = STATE(3952),
    [sym_expression] = STATE(6662),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3993),
    [sym_postfix_unary_expression] = STATE(3997),
    [sym_prefix_unary_expression] = STATE(3997),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3993),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3997),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3993),
    [sym_member_access_expression] = STATE(3202),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3997),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3993),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3993),
    [sym_typeof_expression] = STATE(3993),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3202),
    [sym_literal] = STATE(3993),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2742),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(410),
    [sym_preproc_endregion] = STATE(410),
    [sym_preproc_line] = STATE(410),
    [sym_preproc_pragma] = STATE(410),
    [sym_preproc_nullable] = STATE(410),
    [sym_preproc_error] = STATE(410),
    [sym_preproc_define] = STATE(410),
    [sym_preproc_undef] = STATE(410),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(2283),
    [anon_sym_LPAREN] = ACTIONS(2405),
    [anon_sym_ref] = ACTIONS(2287),
    [anon_sym_LBRACE] = ACTIONS(2289),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(2407),
    [anon_sym_GT] = ACTIONS(2407),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1153),
    [anon_sym_TILDE] = ACTIONS(1153),
    [anon_sym_PLUS_PLUS] = ACTIONS(1153),
    [anon_sym_DASH_DASH] = ACTIONS(1153),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1151),
    [anon_sym_DASH] = ACTIONS(1151),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1153),
    [anon_sym_AMP] = ACTIONS(1153),
    [anon_sym_GT_EQ] = ACTIONS(2409),
    [anon_sym_LT_EQ] = ACTIONS(2409),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2295),
    [anon_sym_var] = ACTIONS(2297),
    [sym_predefined_type] = ACTIONS(2299),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(2301),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2411),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [411] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(2997),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2749),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(3032),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(2975),
    [sym__array_base_type] = STATE(8712),
    [sym_nullable_type] = STATE(2974),
    [sym_pointer_type] = STATE(2974),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(2974),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(2973),
    [sym_pattern] = STATE(4193),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(3119),
    [sym_property_pattern_clause] = STATE(3182),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6706),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(4290),
    [sym_postfix_unary_expression] = STATE(4294),
    [sym_prefix_unary_expression] = STATE(4294),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(4290),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(4294),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(4290),
    [sym_member_access_expression] = STATE(3277),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(4294),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(4290),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(4290),
    [sym_typeof_expression] = STATE(4290),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3277),
    [sym_literal] = STATE(4290),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2742),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(411),
    [sym_preproc_endregion] = STATE(411),
    [sym_preproc_line] = STATE(411),
    [sym_preproc_pragma] = STATE(411),
    [sym_preproc_nullable] = STATE(411),
    [sym_preproc_error] = STATE(411),
    [sym_preproc_define] = STATE(411),
    [sym_preproc_undef] = STATE(411),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(2363),
    [anon_sym_ref] = ACTIONS(2287),
    [anon_sym_LBRACE] = ACTIONS(2289),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(2365),
    [anon_sym_GT] = ACTIONS(2365),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_GT_EQ] = ACTIONS(2367),
    [anon_sym_LT_EQ] = ACTIONS(2367),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2295),
    [anon_sym_var] = ACTIONS(2369),
    [sym_predefined_type] = ACTIONS(2313),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2371),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [412] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(2997),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2749),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(2803),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(2975),
    [sym__array_base_type] = STATE(8712),
    [sym_nullable_type] = STATE(2974),
    [sym_pointer_type] = STATE(2974),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(2974),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(2973),
    [sym_pattern] = STATE(4193),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(2842),
    [sym_property_pattern_clause] = STATE(2893),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6667),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(4290),
    [sym_postfix_unary_expression] = STATE(4294),
    [sym_prefix_unary_expression] = STATE(4294),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(4290),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(4294),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(4290),
    [sym_member_access_expression] = STATE(3277),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(4294),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(4290),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(4290),
    [sym_typeof_expression] = STATE(4290),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3277),
    [sym_literal] = STATE(4290),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2742),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(412),
    [sym_preproc_endregion] = STATE(412),
    [sym_preproc_line] = STATE(412),
    [sym_preproc_pragma] = STATE(412),
    [sym_preproc_nullable] = STATE(412),
    [sym_preproc_error] = STATE(412),
    [sym_preproc_define] = STATE(412),
    [sym_preproc_undef] = STATE(412),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(2333),
    [anon_sym_ref] = ACTIONS(2287),
    [anon_sym_LBRACE] = ACTIONS(2289),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1053),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1059),
    [anon_sym_TILDE] = ACTIONS(1059),
    [anon_sym_PLUS_PLUS] = ACTIONS(1059),
    [anon_sym_DASH_DASH] = ACTIONS(1059),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1061),
    [anon_sym_DASH] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_GT_EQ] = ACTIONS(1063),
    [anon_sym_LT_EQ] = ACTIONS(1063),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2295),
    [anon_sym_var] = ACTIONS(2311),
    [sym_predefined_type] = ACTIONS(2313),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2335),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [413] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(3519),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2845),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(3024),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(2975),
    [sym__array_base_type] = STATE(8712),
    [sym_nullable_type] = STATE(2974),
    [sym_pointer_type] = STATE(2974),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(2974),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(2973),
    [sym_pattern] = STATE(4043),
    [sym_constant_pattern] = STATE(3952),
    [sym_parenthesized_pattern] = STATE(3952),
    [sym_var_pattern] = STATE(3952),
    [sym_type_pattern] = STATE(3952),
    [sym_list_pattern] = STATE(3952),
    [sym_recursive_pattern] = STATE(3952),
    [sym_positional_pattern_clause] = STATE(3102),
    [sym_property_pattern_clause] = STATE(3138),
    [sym_relational_pattern] = STATE(3952),
    [sym_negated_pattern] = STATE(3952),
    [sym_and_pattern] = STATE(3952),
    [sym_or_pattern] = STATE(3952),
    [sym_declaration_pattern] = STATE(3952),
    [sym_expression] = STATE(6655),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3993),
    [sym_postfix_unary_expression] = STATE(3997),
    [sym_prefix_unary_expression] = STATE(3997),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3993),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3997),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3993),
    [sym_member_access_expression] = STATE(3202),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3997),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3993),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3993),
    [sym_typeof_expression] = STATE(3993),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3202),
    [sym_literal] = STATE(3993),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2762),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(413),
    [sym_preproc_endregion] = STATE(413),
    [sym_preproc_line] = STATE(413),
    [sym_preproc_pragma] = STATE(413),
    [sym_preproc_nullable] = STATE(413),
    [sym_preproc_error] = STATE(413),
    [sym_preproc_define] = STATE(413),
    [sym_preproc_undef] = STATE(413),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(2283),
    [anon_sym_LPAREN] = ACTIONS(2439),
    [anon_sym_ref] = ACTIONS(2375),
    [anon_sym_LBRACE] = ACTIONS(2289),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(2441),
    [anon_sym_GT] = ACTIONS(2441),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1717),
    [anon_sym_TILDE] = ACTIONS(1717),
    [anon_sym_PLUS_PLUS] = ACTIONS(1717),
    [anon_sym_DASH_DASH] = ACTIONS(1717),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1715),
    [anon_sym_DASH] = ACTIONS(1715),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1717),
    [anon_sym_AMP] = ACTIONS(1717),
    [anon_sym_GT_EQ] = ACTIONS(2443),
    [anon_sym_LT_EQ] = ACTIONS(2443),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2381),
    [anon_sym_var] = ACTIONS(2297),
    [sym_predefined_type] = ACTIONS(2299),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(2301),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2445),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [414] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(3533),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2888),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(3065),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(2975),
    [sym__array_base_type] = STATE(8712),
    [sym_nullable_type] = STATE(2974),
    [sym_pointer_type] = STATE(2974),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(2974),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(2973),
    [sym_pattern] = STATE(6228),
    [sym_constant_pattern] = STATE(3952),
    [sym_parenthesized_pattern] = STATE(3952),
    [sym_var_pattern] = STATE(3952),
    [sym_type_pattern] = STATE(3952),
    [sym_list_pattern] = STATE(3952),
    [sym_recursive_pattern] = STATE(3952),
    [sym_positional_pattern_clause] = STATE(3149),
    [sym_property_pattern_clause] = STATE(3466),
    [sym_relational_pattern] = STATE(3952),
    [sym_negated_pattern] = STATE(3952),
    [sym_and_pattern] = STATE(3952),
    [sym_or_pattern] = STATE(3952),
    [sym_declaration_pattern] = STATE(3952),
    [sym_expression] = STATE(6705),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3993),
    [sym_postfix_unary_expression] = STATE(3997),
    [sym_prefix_unary_expression] = STATE(3997),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3993),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3997),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3993),
    [sym_member_access_expression] = STATE(3202),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3997),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3993),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3993),
    [sym_typeof_expression] = STATE(3993),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3202),
    [sym_literal] = STATE(3993),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2742),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(414),
    [sym_preproc_endregion] = STATE(414),
    [sym_preproc_line] = STATE(414),
    [sym_preproc_pragma] = STATE(414),
    [sym_preproc_nullable] = STATE(414),
    [sym_preproc_error] = STATE(414),
    [sym_preproc_define] = STATE(414),
    [sym_preproc_undef] = STATE(414),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(2283),
    [anon_sym_LPAREN] = ACTIONS(2413),
    [anon_sym_ref] = ACTIONS(2287),
    [anon_sym_LBRACE] = ACTIONS(2289),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(2415),
    [anon_sym_GT] = ACTIONS(2415),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1785),
    [anon_sym_TILDE] = ACTIONS(1785),
    [anon_sym_PLUS_PLUS] = ACTIONS(1785),
    [anon_sym_DASH_DASH] = ACTIONS(1785),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1785),
    [anon_sym_AMP] = ACTIONS(1785),
    [anon_sym_GT_EQ] = ACTIONS(2417),
    [anon_sym_LT_EQ] = ACTIONS(2417),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2295),
    [anon_sym_var] = ACTIONS(2297),
    [sym_predefined_type] = ACTIONS(2299),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(2301),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2419),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [415] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(3429),
    [sym_alias_qualified_name] = STATE(3430),
    [sym__simple_name] = STATE(2824),
    [sym_qualified_name] = STATE(3430),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(2931),
    [sym_implicit_type] = STATE(3403),
    [sym_array_type] = STATE(3434),
    [sym__array_base_type] = STATE(8808),
    [sym_nullable_type] = STATE(3435),
    [sym_pointer_type] = STATE(3435),
    [sym__pointer_base_type] = STATE(9626),
    [sym_function_pointer_type] = STATE(3435),
    [sym_ref_type] = STATE(3403),
    [sym_scoped_type] = STATE(3403),
    [sym_tuple_type] = STATE(3436),
    [sym_pattern] = STATE(6082),
    [sym_constant_pattern] = STATE(5385),
    [sym_parenthesized_pattern] = STATE(5385),
    [sym_var_pattern] = STATE(5385),
    [sym_type_pattern] = STATE(5385),
    [sym_list_pattern] = STATE(5385),
    [sym_recursive_pattern] = STATE(5385),
    [sym_positional_pattern_clause] = STATE(3070),
    [sym_property_pattern_clause] = STATE(3113),
    [sym_relational_pattern] = STATE(5385),
    [sym_negated_pattern] = STATE(5385),
    [sym_and_pattern] = STATE(5385),
    [sym_or_pattern] = STATE(5385),
    [sym_declaration_pattern] = STATE(5385),
    [sym_expression] = STATE(6674),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(5460),
    [sym_postfix_unary_expression] = STATE(5462),
    [sym_prefix_unary_expression] = STATE(5462),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(5460),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(5462),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(5460),
    [sym_member_access_expression] = STATE(3913),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(5462),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(5460),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(5460),
    [sym_typeof_expression] = STATE(5460),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3913),
    [sym_literal] = STATE(5460),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2776),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(415),
    [sym_preproc_endregion] = STATE(415),
    [sym_preproc_line] = STATE(415),
    [sym_preproc_pragma] = STATE(415),
    [sym_preproc_nullable] = STATE(415),
    [sym_preproc_error] = STATE(415),
    [sym_preproc_define] = STATE(415),
    [sym_preproc_undef] = STATE(415),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(2447),
    [anon_sym_LPAREN] = ACTIONS(2449),
    [anon_sym_ref] = ACTIONS(2451),
    [anon_sym_LBRACE] = ACTIONS(2453),
    [anon_sym_delegate] = ACTIONS(2455),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(2457),
    [anon_sym_GT] = ACTIONS(2457),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1387),
    [anon_sym_TILDE] = ACTIONS(1387),
    [anon_sym_PLUS_PLUS] = ACTIONS(1387),
    [anon_sym_DASH_DASH] = ACTIONS(1387),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1385),
    [anon_sym_DASH] = ACTIONS(1385),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1387),
    [anon_sym_AMP] = ACTIONS(1387),
    [anon_sym_GT_EQ] = ACTIONS(2459),
    [anon_sym_LT_EQ] = ACTIONS(2459),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2461),
    [anon_sym_var] = ACTIONS(2463),
    [sym_predefined_type] = ACTIONS(2465),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(2467),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2469),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
  },
  [416] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(3319),
    [sym_alias_qualified_name] = STATE(3430),
    [sym__simple_name] = STATE(2815),
    [sym_qualified_name] = STATE(3430),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(2958),
    [sym_implicit_type] = STATE(3403),
    [sym_array_type] = STATE(3434),
    [sym__array_base_type] = STATE(8808),
    [sym_nullable_type] = STATE(3435),
    [sym_pointer_type] = STATE(3435),
    [sym__pointer_base_type] = STATE(9626),
    [sym_function_pointer_type] = STATE(3435),
    [sym_ref_type] = STATE(3403),
    [sym_scoped_type] = STATE(3403),
    [sym_tuple_type] = STATE(3436),
    [sym_pattern] = STATE(5650),
    [sym_constant_pattern] = STATE(5385),
    [sym_parenthesized_pattern] = STATE(5385),
    [sym_var_pattern] = STATE(5385),
    [sym_type_pattern] = STATE(5385),
    [sym_list_pattern] = STATE(5385),
    [sym_recursive_pattern] = STATE(5385),
    [sym_positional_pattern_clause] = STATE(3053),
    [sym_property_pattern_clause] = STATE(3124),
    [sym_relational_pattern] = STATE(5385),
    [sym_negated_pattern] = STATE(5385),
    [sym_and_pattern] = STATE(5385),
    [sym_or_pattern] = STATE(5385),
    [sym_declaration_pattern] = STATE(5385),
    [sym_expression] = STATE(6658),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(5460),
    [sym_postfix_unary_expression] = STATE(5462),
    [sym_prefix_unary_expression] = STATE(5462),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(5460),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(5462),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(5460),
    [sym_member_access_expression] = STATE(3913),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(5462),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(5460),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(5460),
    [sym_typeof_expression] = STATE(5460),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3913),
    [sym_literal] = STATE(5460),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2776),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(416),
    [sym_preproc_endregion] = STATE(416),
    [sym_preproc_line] = STATE(416),
    [sym_preproc_pragma] = STATE(416),
    [sym_preproc_nullable] = STATE(416),
    [sym_preproc_error] = STATE(416),
    [sym_preproc_define] = STATE(416),
    [sym_preproc_undef] = STATE(416),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(2447),
    [anon_sym_LPAREN] = ACTIONS(2471),
    [anon_sym_ref] = ACTIONS(2451),
    [anon_sym_LBRACE] = ACTIONS(2453),
    [anon_sym_delegate] = ACTIONS(2455),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(2473),
    [anon_sym_GT] = ACTIONS(2473),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1447),
    [anon_sym_TILDE] = ACTIONS(1447),
    [anon_sym_PLUS_PLUS] = ACTIONS(1447),
    [anon_sym_DASH_DASH] = ACTIONS(1447),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1445),
    [anon_sym_DASH] = ACTIONS(1445),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1447),
    [anon_sym_AMP] = ACTIONS(1447),
    [anon_sym_GT_EQ] = ACTIONS(2475),
    [anon_sym_LT_EQ] = ACTIONS(2475),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2461),
    [anon_sym_var] = ACTIONS(2463),
    [sym_predefined_type] = ACTIONS(2465),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(2467),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2477),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
  },
  [417] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(3533),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2888),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(3065),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(2975),
    [sym__array_base_type] = STATE(8712),
    [sym_nullable_type] = STATE(2974),
    [sym_pointer_type] = STATE(2974),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(2974),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(2973),
    [sym_pattern] = STATE(4059),
    [sym_constant_pattern] = STATE(3952),
    [sym_parenthesized_pattern] = STATE(3952),
    [sym_var_pattern] = STATE(3952),
    [sym_type_pattern] = STATE(3952),
    [sym_list_pattern] = STATE(3952),
    [sym_recursive_pattern] = STATE(3952),
    [sym_positional_pattern_clause] = STATE(3149),
    [sym_property_pattern_clause] = STATE(3466),
    [sym_relational_pattern] = STATE(3952),
    [sym_negated_pattern] = STATE(3952),
    [sym_and_pattern] = STATE(3952),
    [sym_or_pattern] = STATE(3952),
    [sym_declaration_pattern] = STATE(3952),
    [sym_expression] = STATE(6705),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3993),
    [sym_postfix_unary_expression] = STATE(3997),
    [sym_prefix_unary_expression] = STATE(3997),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3993),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3997),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3993),
    [sym_member_access_expression] = STATE(3202),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3997),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3993),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3993),
    [sym_typeof_expression] = STATE(3993),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3202),
    [sym_literal] = STATE(3993),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2742),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(417),
    [sym_preproc_endregion] = STATE(417),
    [sym_preproc_line] = STATE(417),
    [sym_preproc_pragma] = STATE(417),
    [sym_preproc_nullable] = STATE(417),
    [sym_preproc_error] = STATE(417),
    [sym_preproc_define] = STATE(417),
    [sym_preproc_undef] = STATE(417),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(2283),
    [anon_sym_LPAREN] = ACTIONS(2413),
    [anon_sym_ref] = ACTIONS(2287),
    [anon_sym_LBRACE] = ACTIONS(2289),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(2415),
    [anon_sym_GT] = ACTIONS(2415),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1785),
    [anon_sym_TILDE] = ACTIONS(1785),
    [anon_sym_PLUS_PLUS] = ACTIONS(1785),
    [anon_sym_DASH_DASH] = ACTIONS(1785),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1785),
    [anon_sym_AMP] = ACTIONS(1785),
    [anon_sym_GT_EQ] = ACTIONS(2417),
    [anon_sym_LT_EQ] = ACTIONS(2417),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2295),
    [anon_sym_var] = ACTIONS(2297),
    [sym_predefined_type] = ACTIONS(2299),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(2301),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2419),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [418] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6723),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2850),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6128),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_pattern] = STATE(8327),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(6657),
    [sym_property_pattern_clause] = STATE(6741),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6688),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(6113),
    [sym_postfix_unary_expression] = STATE(6112),
    [sym_prefix_unary_expression] = STATE(6112),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(6113),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(6112),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(6113),
    [sym_member_access_expression] = STATE(4106),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(6112),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(6113),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(6113),
    [sym_typeof_expression] = STATE(6113),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(4106),
    [sym_literal] = STATE(6113),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2795),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(418),
    [sym_preproc_endregion] = STATE(418),
    [sym_preproc_line] = STATE(418),
    [sym_preproc_pragma] = STATE(418),
    [sym_preproc_nullable] = STATE(418),
    [sym_preproc_error] = STATE(418),
    [sym_preproc_define] = STATE(418),
    [sym_preproc_undef] = STATE(418),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(2317),
    [anon_sym_ref] = ACTIONS(2319),
    [anon_sym_LBRACE] = ACTIONS(2321),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(2323),
    [anon_sym_GT] = ACTIONS(2323),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1509),
    [anon_sym_PLUS_PLUS] = ACTIONS(1509),
    [anon_sym_DASH_DASH] = ACTIONS(1509),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1507),
    [anon_sym_DASH] = ACTIONS(1507),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1509),
    [anon_sym_AMP] = ACTIONS(1509),
    [anon_sym_GT_EQ] = ACTIONS(2325),
    [anon_sym_LT_EQ] = ACTIONS(2325),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2327),
    [anon_sym_var] = ACTIONS(2329),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2331),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [419] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(3178),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2749),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(2797),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(2975),
    [sym__array_base_type] = STATE(8712),
    [sym_nullable_type] = STATE(2974),
    [sym_pointer_type] = STATE(2974),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(2974),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(2973),
    [sym_pattern] = STATE(5501),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(2842),
    [sym_property_pattern_clause] = STATE(2893),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6689),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(4290),
    [sym_postfix_unary_expression] = STATE(4294),
    [sym_prefix_unary_expression] = STATE(4294),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(4290),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(4294),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(4290),
    [sym_member_access_expression] = STATE(3277),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(4294),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(4290),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(4290),
    [sym_typeof_expression] = STATE(4290),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3277),
    [sym_literal] = STATE(4290),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2762),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(419),
    [sym_preproc_endregion] = STATE(419),
    [sym_preproc_line] = STATE(419),
    [sym_preproc_pragma] = STATE(419),
    [sym_preproc_nullable] = STATE(419),
    [sym_preproc_error] = STATE(419),
    [sym_preproc_define] = STATE(419),
    [sym_preproc_undef] = STATE(419),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(2479),
    [anon_sym_ref] = ACTIONS(2375),
    [anon_sym_LBRACE] = ACTIONS(2289),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_GT] = ACTIONS(2481),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1097),
    [anon_sym_TILDE] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1099),
    [anon_sym_DASH] = ACTIONS(1099),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1097),
    [anon_sym_GT_EQ] = ACTIONS(2483),
    [anon_sym_LT_EQ] = ACTIONS(2483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2381),
    [anon_sym_var] = ACTIONS(2311),
    [sym_predefined_type] = ACTIONS(2313),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2485),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [420] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(3429),
    [sym_alias_qualified_name] = STATE(3430),
    [sym__simple_name] = STATE(2824),
    [sym_qualified_name] = STATE(3430),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(2931),
    [sym_implicit_type] = STATE(3403),
    [sym_array_type] = STATE(3434),
    [sym__array_base_type] = STATE(8808),
    [sym_nullable_type] = STATE(3435),
    [sym_pointer_type] = STATE(3435),
    [sym__pointer_base_type] = STATE(9626),
    [sym_function_pointer_type] = STATE(3435),
    [sym_ref_type] = STATE(3403),
    [sym_scoped_type] = STATE(3403),
    [sym_tuple_type] = STATE(3436),
    [sym_pattern] = STATE(5412),
    [sym_constant_pattern] = STATE(5385),
    [sym_parenthesized_pattern] = STATE(5385),
    [sym_var_pattern] = STATE(5385),
    [sym_type_pattern] = STATE(5385),
    [sym_list_pattern] = STATE(5385),
    [sym_recursive_pattern] = STATE(5385),
    [sym_positional_pattern_clause] = STATE(3070),
    [sym_property_pattern_clause] = STATE(3113),
    [sym_relational_pattern] = STATE(5385),
    [sym_negated_pattern] = STATE(5385),
    [sym_and_pattern] = STATE(5385),
    [sym_or_pattern] = STATE(5385),
    [sym_declaration_pattern] = STATE(5385),
    [sym_expression] = STATE(6674),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(5460),
    [sym_postfix_unary_expression] = STATE(5462),
    [sym_prefix_unary_expression] = STATE(5462),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(5460),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(5462),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(5460),
    [sym_member_access_expression] = STATE(3913),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(5462),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(5460),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(5460),
    [sym_typeof_expression] = STATE(5460),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3913),
    [sym_literal] = STATE(5460),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2776),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(420),
    [sym_preproc_endregion] = STATE(420),
    [sym_preproc_line] = STATE(420),
    [sym_preproc_pragma] = STATE(420),
    [sym_preproc_nullable] = STATE(420),
    [sym_preproc_error] = STATE(420),
    [sym_preproc_define] = STATE(420),
    [sym_preproc_undef] = STATE(420),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(2447),
    [anon_sym_LPAREN] = ACTIONS(2449),
    [anon_sym_ref] = ACTIONS(2451),
    [anon_sym_LBRACE] = ACTIONS(2453),
    [anon_sym_delegate] = ACTIONS(2455),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(2457),
    [anon_sym_GT] = ACTIONS(2457),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1387),
    [anon_sym_TILDE] = ACTIONS(1387),
    [anon_sym_PLUS_PLUS] = ACTIONS(1387),
    [anon_sym_DASH_DASH] = ACTIONS(1387),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1385),
    [anon_sym_DASH] = ACTIONS(1385),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1387),
    [anon_sym_AMP] = ACTIONS(1387),
    [anon_sym_GT_EQ] = ACTIONS(2459),
    [anon_sym_LT_EQ] = ACTIONS(2459),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2461),
    [anon_sym_var] = ACTIONS(2463),
    [sym_predefined_type] = ACTIONS(2465),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(2467),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2469),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
  },
  [421] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(3178),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2749),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(2803),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(2975),
    [sym__array_base_type] = STATE(8712),
    [sym_nullable_type] = STATE(2974),
    [sym_pointer_type] = STATE(2974),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(2974),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(2973),
    [sym_pattern] = STATE(4193),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(2842),
    [sym_property_pattern_clause] = STATE(2893),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6690),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(4290),
    [sym_postfix_unary_expression] = STATE(4294),
    [sym_prefix_unary_expression] = STATE(4294),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(4290),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(4294),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(4290),
    [sym_member_access_expression] = STATE(3277),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(4294),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(4290),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(4290),
    [sym_typeof_expression] = STATE(4290),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3277),
    [sym_literal] = STATE(4290),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2762),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(421),
    [sym_preproc_endregion] = STATE(421),
    [sym_preproc_line] = STATE(421),
    [sym_preproc_pragma] = STATE(421),
    [sym_preproc_nullable] = STATE(421),
    [sym_preproc_error] = STATE(421),
    [sym_preproc_define] = STATE(421),
    [sym_preproc_undef] = STATE(421),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(2421),
    [anon_sym_ref] = ACTIONS(2375),
    [anon_sym_LBRACE] = ACTIONS(2289),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(2423),
    [anon_sym_GT] = ACTIONS(2423),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1551),
    [anon_sym_TILDE] = ACTIONS(1551),
    [anon_sym_PLUS_PLUS] = ACTIONS(1551),
    [anon_sym_DASH_DASH] = ACTIONS(1551),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1549),
    [anon_sym_DASH] = ACTIONS(1549),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1551),
    [anon_sym_AMP] = ACTIONS(1551),
    [anon_sym_GT_EQ] = ACTIONS(2425),
    [anon_sym_LT_EQ] = ACTIONS(2425),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2381),
    [anon_sym_var] = ACTIONS(2311),
    [sym_predefined_type] = ACTIONS(2313),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2427),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [422] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(3178),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2749),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(2797),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(2975),
    [sym__array_base_type] = STATE(8712),
    [sym_nullable_type] = STATE(2974),
    [sym_pointer_type] = STATE(2974),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(2974),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(2973),
    [sym_pattern] = STATE(4118),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(2842),
    [sym_property_pattern_clause] = STATE(2893),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6689),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(4290),
    [sym_postfix_unary_expression] = STATE(4294),
    [sym_prefix_unary_expression] = STATE(4294),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(4290),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(4294),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(4290),
    [sym_member_access_expression] = STATE(3277),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(4294),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(4290),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(4290),
    [sym_typeof_expression] = STATE(4290),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3277),
    [sym_literal] = STATE(4290),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2762),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(422),
    [sym_preproc_endregion] = STATE(422),
    [sym_preproc_line] = STATE(422),
    [sym_preproc_pragma] = STATE(422),
    [sym_preproc_nullable] = STATE(422),
    [sym_preproc_error] = STATE(422),
    [sym_preproc_define] = STATE(422),
    [sym_preproc_undef] = STATE(422),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(2479),
    [anon_sym_ref] = ACTIONS(2375),
    [anon_sym_LBRACE] = ACTIONS(2289),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_GT] = ACTIONS(2481),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1097),
    [anon_sym_TILDE] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1099),
    [anon_sym_DASH] = ACTIONS(1099),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1097),
    [anon_sym_GT_EQ] = ACTIONS(2483),
    [anon_sym_LT_EQ] = ACTIONS(2483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2381),
    [anon_sym_var] = ACTIONS(2311),
    [sym_predefined_type] = ACTIONS(2313),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2485),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [423] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(3178),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2749),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(2797),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(2975),
    [sym__array_base_type] = STATE(8712),
    [sym_nullable_type] = STATE(2974),
    [sym_pointer_type] = STATE(2974),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(2974),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(2973),
    [sym_pattern] = STATE(5690),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(2842),
    [sym_property_pattern_clause] = STATE(2893),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6689),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(4290),
    [sym_postfix_unary_expression] = STATE(4294),
    [sym_prefix_unary_expression] = STATE(4294),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(4290),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(4294),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(4290),
    [sym_member_access_expression] = STATE(3277),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(4294),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(4290),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(4290),
    [sym_typeof_expression] = STATE(4290),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3277),
    [sym_literal] = STATE(4290),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2762),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(423),
    [sym_preproc_endregion] = STATE(423),
    [sym_preproc_line] = STATE(423),
    [sym_preproc_pragma] = STATE(423),
    [sym_preproc_nullable] = STATE(423),
    [sym_preproc_error] = STATE(423),
    [sym_preproc_define] = STATE(423),
    [sym_preproc_undef] = STATE(423),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(2479),
    [anon_sym_ref] = ACTIONS(2375),
    [anon_sym_LBRACE] = ACTIONS(2289),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_GT] = ACTIONS(2481),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1097),
    [anon_sym_TILDE] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1099),
    [anon_sym_DASH] = ACTIONS(1099),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1097),
    [anon_sym_GT_EQ] = ACTIONS(2483),
    [anon_sym_LT_EQ] = ACTIONS(2483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2381),
    [anon_sym_var] = ACTIONS(2311),
    [sym_predefined_type] = ACTIONS(2313),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2485),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [424] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6727),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2839),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6146),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_pattern] = STATE(8287),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(6657),
    [sym_property_pattern_clause] = STATE(6741),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6659),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(5071),
    [sym_postfix_unary_expression] = STATE(5061),
    [sym_prefix_unary_expression] = STATE(5061),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(5071),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(5061),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(5071),
    [sym_member_access_expression] = STATE(3775),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(5061),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(5071),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(5071),
    [sym_typeof_expression] = STATE(5071),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3775),
    [sym_literal] = STATE(5071),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(424),
    [sym_preproc_endregion] = STATE(424),
    [sym_preproc_line] = STATE(424),
    [sym_preproc_pragma] = STATE(424),
    [sym_preproc_nullable] = STATE(424),
    [sym_preproc_error] = STATE(424),
    [sym_preproc_define] = STATE(424),
    [sym_preproc_undef] = STATE(424),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_ref] = ACTIONS(1925),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(1929),
    [anon_sym_GT] = ACTIONS(1929),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1749),
    [anon_sym_TILDE] = ACTIONS(1749),
    [anon_sym_PLUS_PLUS] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1749),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1747),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1749),
    [anon_sym_AMP] = ACTIONS(1749),
    [anon_sym_GT_EQ] = ACTIONS(1931),
    [anon_sym_LT_EQ] = ACTIONS(1931),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1065),
    [anon_sym_var] = ACTIONS(1933),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(1935),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [425] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(3536),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2891),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(3068),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(2975),
    [sym__array_base_type] = STATE(8712),
    [sym_nullable_type] = STATE(2974),
    [sym_pointer_type] = STATE(2974),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(2974),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(2973),
    [sym_pattern] = STATE(6542),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(3140),
    [sym_property_pattern_clause] = STATE(3227),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6670),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(4290),
    [sym_postfix_unary_expression] = STATE(4294),
    [sym_prefix_unary_expression] = STATE(4294),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(4290),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(4294),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(4290),
    [sym_member_access_expression] = STATE(3277),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(4294),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(4290),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(4290),
    [sym_typeof_expression] = STATE(4290),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3277),
    [sym_literal] = STATE(4290),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2742),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(425),
    [sym_preproc_endregion] = STATE(425),
    [sym_preproc_line] = STATE(425),
    [sym_preproc_pragma] = STATE(425),
    [sym_preproc_nullable] = STATE(425),
    [sym_preproc_error] = STATE(425),
    [sym_preproc_define] = STATE(425),
    [sym_preproc_undef] = STATE(425),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(2431),
    [anon_sym_ref] = ACTIONS(2287),
    [anon_sym_LBRACE] = ACTIONS(2289),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(2433),
    [anon_sym_GT] = ACTIONS(2433),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1893),
    [anon_sym_TILDE] = ACTIONS(1893),
    [anon_sym_PLUS_PLUS] = ACTIONS(1893),
    [anon_sym_DASH_DASH] = ACTIONS(1893),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1891),
    [anon_sym_DASH] = ACTIONS(1891),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1893),
    [anon_sym_AMP] = ACTIONS(1893),
    [anon_sym_GT_EQ] = ACTIONS(2435),
    [anon_sym_LT_EQ] = ACTIONS(2435),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2295),
    [anon_sym_var] = ACTIONS(2311),
    [sym_predefined_type] = ACTIONS(2313),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2437),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [426] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6727),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2839),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6146),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_pattern] = STATE(4118),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(6657),
    [sym_property_pattern_clause] = STATE(6741),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6659),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(5071),
    [sym_postfix_unary_expression] = STATE(5061),
    [sym_prefix_unary_expression] = STATE(5061),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(5071),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(5061),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(5071),
    [sym_member_access_expression] = STATE(3775),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(5061),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(5071),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(5071),
    [sym_typeof_expression] = STATE(5071),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3775),
    [sym_literal] = STATE(5071),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(426),
    [sym_preproc_endregion] = STATE(426),
    [sym_preproc_line] = STATE(426),
    [sym_preproc_pragma] = STATE(426),
    [sym_preproc_nullable] = STATE(426),
    [sym_preproc_error] = STATE(426),
    [sym_preproc_define] = STATE(426),
    [sym_preproc_undef] = STATE(426),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_ref] = ACTIONS(1925),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(1929),
    [anon_sym_GT] = ACTIONS(1929),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1749),
    [anon_sym_TILDE] = ACTIONS(1749),
    [anon_sym_PLUS_PLUS] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1749),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1747),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1749),
    [anon_sym_AMP] = ACTIONS(1749),
    [anon_sym_GT_EQ] = ACTIONS(1931),
    [anon_sym_LT_EQ] = ACTIONS(1931),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1065),
    [anon_sym_var] = ACTIONS(1933),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(1935),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [427] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(3533),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2888),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(3065),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(2975),
    [sym__array_base_type] = STATE(8712),
    [sym_nullable_type] = STATE(2974),
    [sym_pointer_type] = STATE(2974),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(2974),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(2973),
    [sym_pattern] = STATE(6207),
    [sym_constant_pattern] = STATE(3952),
    [sym_parenthesized_pattern] = STATE(3952),
    [sym_var_pattern] = STATE(3952),
    [sym_type_pattern] = STATE(3952),
    [sym_list_pattern] = STATE(3952),
    [sym_recursive_pattern] = STATE(3952),
    [sym_positional_pattern_clause] = STATE(3149),
    [sym_property_pattern_clause] = STATE(3466),
    [sym_relational_pattern] = STATE(3952),
    [sym_negated_pattern] = STATE(3952),
    [sym_and_pattern] = STATE(3952),
    [sym_or_pattern] = STATE(3952),
    [sym_declaration_pattern] = STATE(3952),
    [sym_expression] = STATE(6705),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3993),
    [sym_postfix_unary_expression] = STATE(3997),
    [sym_prefix_unary_expression] = STATE(3997),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3993),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3997),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3993),
    [sym_member_access_expression] = STATE(3202),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3997),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3993),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3993),
    [sym_typeof_expression] = STATE(3993),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3202),
    [sym_literal] = STATE(3993),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2742),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(427),
    [sym_preproc_endregion] = STATE(427),
    [sym_preproc_line] = STATE(427),
    [sym_preproc_pragma] = STATE(427),
    [sym_preproc_nullable] = STATE(427),
    [sym_preproc_error] = STATE(427),
    [sym_preproc_define] = STATE(427),
    [sym_preproc_undef] = STATE(427),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(2283),
    [anon_sym_LPAREN] = ACTIONS(2413),
    [anon_sym_ref] = ACTIONS(2287),
    [anon_sym_LBRACE] = ACTIONS(2289),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(2415),
    [anon_sym_GT] = ACTIONS(2415),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1785),
    [anon_sym_TILDE] = ACTIONS(1785),
    [anon_sym_PLUS_PLUS] = ACTIONS(1785),
    [anon_sym_DASH_DASH] = ACTIONS(1785),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1785),
    [anon_sym_AMP] = ACTIONS(1785),
    [anon_sym_GT_EQ] = ACTIONS(2417),
    [anon_sym_LT_EQ] = ACTIONS(2417),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2295),
    [anon_sym_var] = ACTIONS(2297),
    [sym_predefined_type] = ACTIONS(2299),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(2301),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2419),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [428] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(3525),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2860),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(3035),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(2975),
    [sym__array_base_type] = STATE(8712),
    [sym_nullable_type] = STATE(2974),
    [sym_pointer_type] = STATE(2974),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(2974),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(2973),
    [sym_pattern] = STATE(4569),
    [sym_constant_pattern] = STATE(4709),
    [sym_parenthesized_pattern] = STATE(4709),
    [sym_var_pattern] = STATE(4709),
    [sym_type_pattern] = STATE(4709),
    [sym_list_pattern] = STATE(4709),
    [sym_recursive_pattern] = STATE(4709),
    [sym_positional_pattern_clause] = STATE(3109),
    [sym_property_pattern_clause] = STATE(3192),
    [sym_relational_pattern] = STATE(4709),
    [sym_negated_pattern] = STATE(4709),
    [sym_and_pattern] = STATE(4709),
    [sym_or_pattern] = STATE(4709),
    [sym_declaration_pattern] = STATE(4709),
    [sym_expression] = STATE(6665),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(4649),
    [sym_postfix_unary_expression] = STATE(4712),
    [sym_prefix_unary_expression] = STATE(4712),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(4649),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(4712),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(4649),
    [sym_member_access_expression] = STATE(3548),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(4712),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(4649),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(4649),
    [sym_typeof_expression] = STATE(4649),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3548),
    [sym_literal] = STATE(4649),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2742),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(428),
    [sym_preproc_endregion] = STATE(428),
    [sym_preproc_line] = STATE(428),
    [sym_preproc_pragma] = STATE(428),
    [sym_preproc_nullable] = STATE(428),
    [sym_preproc_error] = STATE(428),
    [sym_preproc_define] = STATE(428),
    [sym_preproc_undef] = STATE(428),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(2337),
    [anon_sym_LPAREN] = ACTIONS(2487),
    [anon_sym_ref] = ACTIONS(2287),
    [anon_sym_LBRACE] = ACTIONS(2289),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(2489),
    [anon_sym_GT] = ACTIONS(2489),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1683),
    [anon_sym_TILDE] = ACTIONS(1683),
    [anon_sym_PLUS_PLUS] = ACTIONS(1683),
    [anon_sym_DASH_DASH] = ACTIONS(1683),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_DASH] = ACTIONS(1681),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1683),
    [anon_sym_GT_EQ] = ACTIONS(2491),
    [anon_sym_LT_EQ] = ACTIONS(2491),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2295),
    [anon_sym_var] = ACTIONS(2345),
    [sym_predefined_type] = ACTIONS(2347),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(2349),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2493),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [429] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(3536),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2891),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(3068),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(2975),
    [sym__array_base_type] = STATE(8712),
    [sym_nullable_type] = STATE(2974),
    [sym_pointer_type] = STATE(2974),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(2974),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(2973),
    [sym_pattern] = STATE(4118),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(3140),
    [sym_property_pattern_clause] = STATE(3227),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6670),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(4290),
    [sym_postfix_unary_expression] = STATE(4294),
    [sym_prefix_unary_expression] = STATE(4294),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(4290),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(4294),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(4290),
    [sym_member_access_expression] = STATE(3277),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(4294),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(4290),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(4290),
    [sym_typeof_expression] = STATE(4290),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3277),
    [sym_literal] = STATE(4290),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2742),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(429),
    [sym_preproc_endregion] = STATE(429),
    [sym_preproc_line] = STATE(429),
    [sym_preproc_pragma] = STATE(429),
    [sym_preproc_nullable] = STATE(429),
    [sym_preproc_error] = STATE(429),
    [sym_preproc_define] = STATE(429),
    [sym_preproc_undef] = STATE(429),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(2431),
    [anon_sym_ref] = ACTIONS(2287),
    [anon_sym_LBRACE] = ACTIONS(2289),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(2433),
    [anon_sym_GT] = ACTIONS(2433),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1893),
    [anon_sym_TILDE] = ACTIONS(1893),
    [anon_sym_PLUS_PLUS] = ACTIONS(1893),
    [anon_sym_DASH_DASH] = ACTIONS(1893),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1891),
    [anon_sym_DASH] = ACTIONS(1891),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1893),
    [anon_sym_AMP] = ACTIONS(1893),
    [anon_sym_GT_EQ] = ACTIONS(2435),
    [anon_sym_LT_EQ] = ACTIONS(2435),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2295),
    [anon_sym_var] = ACTIONS(2311),
    [sym_predefined_type] = ACTIONS(2313),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2437),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [430] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(3540),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2906),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(3073),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(2975),
    [sym__array_base_type] = STATE(8712),
    [sym_nullable_type] = STATE(2974),
    [sym_pointer_type] = STATE(2974),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(2974),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(2973),
    [sym_pattern] = STATE(6100),
    [sym_constant_pattern] = STATE(3952),
    [sym_parenthesized_pattern] = STATE(3952),
    [sym_var_pattern] = STATE(3952),
    [sym_type_pattern] = STATE(3952),
    [sym_list_pattern] = STATE(3952),
    [sym_recursive_pattern] = STATE(3952),
    [sym_positional_pattern_clause] = STATE(3132),
    [sym_property_pattern_clause] = STATE(3487),
    [sym_relational_pattern] = STATE(3952),
    [sym_negated_pattern] = STATE(3952),
    [sym_and_pattern] = STATE(3952),
    [sym_or_pattern] = STATE(3952),
    [sym_declaration_pattern] = STATE(3952),
    [sym_expression] = STATE(6686),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3993),
    [sym_postfix_unary_expression] = STATE(3997),
    [sym_prefix_unary_expression] = STATE(3997),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3993),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3997),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3993),
    [sym_member_access_expression] = STATE(3202),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3997),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3993),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3993),
    [sym_typeof_expression] = STATE(3993),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3202),
    [sym_literal] = STATE(3993),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2742),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(430),
    [sym_preproc_endregion] = STATE(430),
    [sym_preproc_line] = STATE(430),
    [sym_preproc_pragma] = STATE(430),
    [sym_preproc_nullable] = STATE(430),
    [sym_preproc_error] = STATE(430),
    [sym_preproc_define] = STATE(430),
    [sym_preproc_undef] = STATE(430),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(2283),
    [anon_sym_LPAREN] = ACTIONS(2397),
    [anon_sym_ref] = ACTIONS(2287),
    [anon_sym_LBRACE] = ACTIONS(2289),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(2399),
    [anon_sym_GT] = ACTIONS(2399),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1839),
    [anon_sym_TILDE] = ACTIONS(1839),
    [anon_sym_PLUS_PLUS] = ACTIONS(1839),
    [anon_sym_DASH_DASH] = ACTIONS(1839),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1837),
    [anon_sym_DASH] = ACTIONS(1837),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1839),
    [anon_sym_AMP] = ACTIONS(1839),
    [anon_sym_GT_EQ] = ACTIONS(2401),
    [anon_sym_LT_EQ] = ACTIONS(2401),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2295),
    [anon_sym_var] = ACTIONS(2297),
    [sym_predefined_type] = ACTIONS(2299),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(2301),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2403),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [431] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2789),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(5318),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_pattern] = STATE(4118),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(6141),
    [sym_property_pattern_clause] = STATE(6672),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6667),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(5313),
    [sym_postfix_unary_expression] = STATE(5314),
    [sym_prefix_unary_expression] = STATE(5314),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(5313),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(5314),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(5313),
    [sym_member_access_expression] = STATE(3856),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(5314),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(5313),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(5313),
    [sym_typeof_expression] = STATE(5313),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3856),
    [sym_literal] = STATE(5313),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(431),
    [sym_preproc_endregion] = STATE(431),
    [sym_preproc_line] = STATE(431),
    [sym_preproc_pragma] = STATE(431),
    [sym_preproc_nullable] = STATE(431),
    [sym_preproc_error] = STATE(431),
    [sym_preproc_define] = STATE(431),
    [sym_preproc_undef] = STATE(431),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(1043),
    [anon_sym_ref] = ACTIONS(2429),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1053),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1059),
    [anon_sym_TILDE] = ACTIONS(1059),
    [anon_sym_PLUS_PLUS] = ACTIONS(1059),
    [anon_sym_DASH_DASH] = ACTIONS(1059),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1061),
    [anon_sym_DASH] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_GT_EQ] = ACTIONS(1063),
    [anon_sym_LT_EQ] = ACTIONS(1063),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2265),
    [anon_sym_var] = ACTIONS(1067),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(1117),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [432] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(3531),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2870),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(3046),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(2975),
    [sym__array_base_type] = STATE(8712),
    [sym_nullable_type] = STATE(2974),
    [sym_pointer_type] = STATE(2974),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(2974),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(2973),
    [sym_pattern] = STATE(4974),
    [sym_constant_pattern] = STATE(4988),
    [sym_parenthesized_pattern] = STATE(4988),
    [sym_var_pattern] = STATE(4988),
    [sym_type_pattern] = STATE(4988),
    [sym_list_pattern] = STATE(4988),
    [sym_recursive_pattern] = STATE(4988),
    [sym_positional_pattern_clause] = STATE(3131),
    [sym_property_pattern_clause] = STATE(3344),
    [sym_relational_pattern] = STATE(4988),
    [sym_negated_pattern] = STATE(4988),
    [sym_and_pattern] = STATE(4988),
    [sym_or_pattern] = STATE(4988),
    [sym_declaration_pattern] = STATE(4988),
    [sym_expression] = STATE(6711),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(4995),
    [sym_postfix_unary_expression] = STATE(4994),
    [sym_prefix_unary_expression] = STATE(4994),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(4995),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(4994),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(4995),
    [sym_member_access_expression] = STATE(3744),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(4994),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(4995),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(4995),
    [sym_typeof_expression] = STATE(4995),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3744),
    [sym_literal] = STATE(4995),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2742),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(432),
    [sym_preproc_endregion] = STATE(432),
    [sym_preproc_line] = STATE(432),
    [sym_preproc_pragma] = STATE(432),
    [sym_preproc_nullable] = STATE(432),
    [sym_preproc_error] = STATE(432),
    [sym_preproc_define] = STATE(432),
    [sym_preproc_undef] = STATE(432),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(2495),
    [anon_sym_LPAREN] = ACTIONS(2497),
    [anon_sym_ref] = ACTIONS(2287),
    [anon_sym_LBRACE] = ACTIONS(2289),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(2499),
    [anon_sym_GT] = ACTIONS(2499),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1857),
    [anon_sym_TILDE] = ACTIONS(1857),
    [anon_sym_PLUS_PLUS] = ACTIONS(1857),
    [anon_sym_DASH_DASH] = ACTIONS(1857),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1855),
    [anon_sym_DASH] = ACTIONS(1855),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1857),
    [anon_sym_AMP] = ACTIONS(1857),
    [anon_sym_GT_EQ] = ACTIONS(2501),
    [anon_sym_LT_EQ] = ACTIONS(2501),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2295),
    [anon_sym_var] = ACTIONS(2503),
    [sym_predefined_type] = ACTIONS(2505),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(2507),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2509),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [433] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(3531),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2870),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(3071),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(2975),
    [sym__array_base_type] = STATE(8712),
    [sym_nullable_type] = STATE(2974),
    [sym_pointer_type] = STATE(2974),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(2974),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(2973),
    [sym_pattern] = STATE(4987),
    [sym_constant_pattern] = STATE(4988),
    [sym_parenthesized_pattern] = STATE(4988),
    [sym_var_pattern] = STATE(4988),
    [sym_type_pattern] = STATE(4988),
    [sym_list_pattern] = STATE(4988),
    [sym_recursive_pattern] = STATE(4988),
    [sym_positional_pattern_clause] = STATE(3131),
    [sym_property_pattern_clause] = STATE(3344),
    [sym_relational_pattern] = STATE(4988),
    [sym_negated_pattern] = STATE(4988),
    [sym_and_pattern] = STATE(4988),
    [sym_or_pattern] = STATE(4988),
    [sym_declaration_pattern] = STATE(4988),
    [sym_expression] = STATE(6711),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(4995),
    [sym_postfix_unary_expression] = STATE(4994),
    [sym_prefix_unary_expression] = STATE(4994),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(4995),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(4994),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(4995),
    [sym_member_access_expression] = STATE(3744),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(4994),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(4995),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(4995),
    [sym_typeof_expression] = STATE(4995),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3744),
    [sym_literal] = STATE(4995),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2742),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(433),
    [sym_preproc_endregion] = STATE(433),
    [sym_preproc_line] = STATE(433),
    [sym_preproc_pragma] = STATE(433),
    [sym_preproc_nullable] = STATE(433),
    [sym_preproc_error] = STATE(433),
    [sym_preproc_define] = STATE(433),
    [sym_preproc_undef] = STATE(433),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(2495),
    [anon_sym_LPAREN] = ACTIONS(2497),
    [anon_sym_ref] = ACTIONS(2287),
    [anon_sym_LBRACE] = ACTIONS(2289),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(2499),
    [anon_sym_GT] = ACTIONS(2499),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1857),
    [anon_sym_TILDE] = ACTIONS(1857),
    [anon_sym_PLUS_PLUS] = ACTIONS(1857),
    [anon_sym_DASH_DASH] = ACTIONS(1857),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1855),
    [anon_sym_DASH] = ACTIONS(1855),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1857),
    [anon_sym_AMP] = ACTIONS(1857),
    [anon_sym_GT_EQ] = ACTIONS(2501),
    [anon_sym_LT_EQ] = ACTIONS(2501),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2295),
    [anon_sym_var] = ACTIONS(2503),
    [sym_predefined_type] = ACTIONS(2505),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(2507),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2509),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [434] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(2997),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2749),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(3027),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(2975),
    [sym__array_base_type] = STATE(8712),
    [sym_nullable_type] = STATE(2974),
    [sym_pointer_type] = STATE(2974),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(2974),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(2973),
    [sym_pattern] = STATE(6486),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(2842),
    [sym_property_pattern_clause] = STATE(2893),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6663),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(4290),
    [sym_postfix_unary_expression] = STATE(4294),
    [sym_prefix_unary_expression] = STATE(4294),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(4290),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(4294),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(4290),
    [sym_member_access_expression] = STATE(3277),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(4294),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(4290),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(4290),
    [sym_typeof_expression] = STATE(4290),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3277),
    [sym_literal] = STATE(4290),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2810),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(434),
    [sym_preproc_endregion] = STATE(434),
    [sym_preproc_line] = STATE(434),
    [sym_preproc_pragma] = STATE(434),
    [sym_preproc_nullable] = STATE(434),
    [sym_preproc_error] = STATE(434),
    [sym_preproc_define] = STATE(434),
    [sym_preproc_undef] = STATE(434),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(2511),
    [anon_sym_ref] = ACTIONS(2391),
    [anon_sym_LBRACE] = ACTIONS(2289),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(2513),
    [anon_sym_GT] = ACTIONS(2513),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1699),
    [anon_sym_TILDE] = ACTIONS(1699),
    [anon_sym_PLUS_PLUS] = ACTIONS(1699),
    [anon_sym_DASH_DASH] = ACTIONS(1699),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1697),
    [anon_sym_DASH] = ACTIONS(1697),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1699),
    [anon_sym_AMP] = ACTIONS(1699),
    [anon_sym_GT_EQ] = ACTIONS(2515),
    [anon_sym_LT_EQ] = ACTIONS(2515),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2295),
    [anon_sym_var] = ACTIONS(2393),
    [sym_predefined_type] = ACTIONS(2313),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2517),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [435] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2789),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(5318),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_pattern] = STATE(8241),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(6141),
    [sym_property_pattern_clause] = STATE(6672),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6667),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(5313),
    [sym_postfix_unary_expression] = STATE(5314),
    [sym_prefix_unary_expression] = STATE(5314),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(5313),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(5314),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(5313),
    [sym_member_access_expression] = STATE(3856),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(5314),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(5313),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(5313),
    [sym_typeof_expression] = STATE(5313),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3856),
    [sym_literal] = STATE(5313),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(435),
    [sym_preproc_endregion] = STATE(435),
    [sym_preproc_line] = STATE(435),
    [sym_preproc_pragma] = STATE(435),
    [sym_preproc_nullable] = STATE(435),
    [sym_preproc_error] = STATE(435),
    [sym_preproc_define] = STATE(435),
    [sym_preproc_undef] = STATE(435),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(1043),
    [anon_sym_ref] = ACTIONS(2429),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1053),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1059),
    [anon_sym_TILDE] = ACTIONS(1059),
    [anon_sym_PLUS_PLUS] = ACTIONS(1059),
    [anon_sym_DASH_DASH] = ACTIONS(1059),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1061),
    [anon_sym_DASH] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_GT_EQ] = ACTIONS(1063),
    [anon_sym_LT_EQ] = ACTIONS(1063),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2265),
    [anon_sym_var] = ACTIONS(1067),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(1117),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [436] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(2992),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2747),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(2788),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(2975),
    [sym__array_base_type] = STATE(8712),
    [sym_nullable_type] = STATE(2974),
    [sym_pointer_type] = STATE(2974),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(2974),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(2973),
    [sym_pattern] = STATE(4892),
    [sym_constant_pattern] = STATE(3952),
    [sym_parenthesized_pattern] = STATE(3952),
    [sym_var_pattern] = STATE(3952),
    [sym_type_pattern] = STATE(3952),
    [sym_list_pattern] = STATE(3952),
    [sym_recursive_pattern] = STATE(3952),
    [sym_positional_pattern_clause] = STATE(2809),
    [sym_property_pattern_clause] = STATE(2851),
    [sym_relational_pattern] = STATE(3952),
    [sym_negated_pattern] = STATE(3952),
    [sym_and_pattern] = STATE(3952),
    [sym_or_pattern] = STATE(3952),
    [sym_declaration_pattern] = STATE(3952),
    [sym_expression] = STATE(6662),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3993),
    [sym_postfix_unary_expression] = STATE(3997),
    [sym_prefix_unary_expression] = STATE(3997),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3993),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3997),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3993),
    [sym_member_access_expression] = STATE(3202),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3997),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3993),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3993),
    [sym_typeof_expression] = STATE(3993),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3202),
    [sym_literal] = STATE(3993),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2742),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(436),
    [sym_preproc_endregion] = STATE(436),
    [sym_preproc_line] = STATE(436),
    [sym_preproc_pragma] = STATE(436),
    [sym_preproc_nullable] = STATE(436),
    [sym_preproc_error] = STATE(436),
    [sym_preproc_define] = STATE(436),
    [sym_preproc_undef] = STATE(436),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(2283),
    [anon_sym_LPAREN] = ACTIONS(2405),
    [anon_sym_ref] = ACTIONS(2287),
    [anon_sym_LBRACE] = ACTIONS(2289),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(2407),
    [anon_sym_GT] = ACTIONS(2407),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1153),
    [anon_sym_TILDE] = ACTIONS(1153),
    [anon_sym_PLUS_PLUS] = ACTIONS(1153),
    [anon_sym_DASH_DASH] = ACTIONS(1153),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1151),
    [anon_sym_DASH] = ACTIONS(1151),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1153),
    [anon_sym_AMP] = ACTIONS(1153),
    [anon_sym_GT_EQ] = ACTIONS(2409),
    [anon_sym_LT_EQ] = ACTIONS(2409),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2295),
    [anon_sym_var] = ACTIONS(2297),
    [sym_predefined_type] = ACTIONS(2299),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(2301),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2411),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [437] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(3429),
    [sym_alias_qualified_name] = STATE(3430),
    [sym__simple_name] = STATE(2824),
    [sym_qualified_name] = STATE(3430),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(2931),
    [sym_implicit_type] = STATE(3403),
    [sym_array_type] = STATE(3434),
    [sym__array_base_type] = STATE(8808),
    [sym_nullable_type] = STATE(3435),
    [sym_pointer_type] = STATE(3435),
    [sym__pointer_base_type] = STATE(9626),
    [sym_function_pointer_type] = STATE(3435),
    [sym_ref_type] = STATE(3403),
    [sym_scoped_type] = STATE(3403),
    [sym_tuple_type] = STATE(3436),
    [sym_pattern] = STATE(5912),
    [sym_constant_pattern] = STATE(5385),
    [sym_parenthesized_pattern] = STATE(5385),
    [sym_var_pattern] = STATE(5385),
    [sym_type_pattern] = STATE(5385),
    [sym_list_pattern] = STATE(5385),
    [sym_recursive_pattern] = STATE(5385),
    [sym_positional_pattern_clause] = STATE(3070),
    [sym_property_pattern_clause] = STATE(3113),
    [sym_relational_pattern] = STATE(5385),
    [sym_negated_pattern] = STATE(5385),
    [sym_and_pattern] = STATE(5385),
    [sym_or_pattern] = STATE(5385),
    [sym_declaration_pattern] = STATE(5385),
    [sym_expression] = STATE(6674),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(5460),
    [sym_postfix_unary_expression] = STATE(5462),
    [sym_prefix_unary_expression] = STATE(5462),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(5460),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(5462),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(5460),
    [sym_member_access_expression] = STATE(3913),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(5462),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(5460),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(5460),
    [sym_typeof_expression] = STATE(5460),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3913),
    [sym_literal] = STATE(5460),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2776),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(437),
    [sym_preproc_endregion] = STATE(437),
    [sym_preproc_line] = STATE(437),
    [sym_preproc_pragma] = STATE(437),
    [sym_preproc_nullable] = STATE(437),
    [sym_preproc_error] = STATE(437),
    [sym_preproc_define] = STATE(437),
    [sym_preproc_undef] = STATE(437),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(2447),
    [anon_sym_LPAREN] = ACTIONS(2449),
    [anon_sym_ref] = ACTIONS(2451),
    [anon_sym_LBRACE] = ACTIONS(2453),
    [anon_sym_delegate] = ACTIONS(2455),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(2457),
    [anon_sym_GT] = ACTIONS(2457),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1387),
    [anon_sym_TILDE] = ACTIONS(1387),
    [anon_sym_PLUS_PLUS] = ACTIONS(1387),
    [anon_sym_DASH_DASH] = ACTIONS(1387),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1385),
    [anon_sym_DASH] = ACTIONS(1385),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1387),
    [anon_sym_AMP] = ACTIONS(1387),
    [anon_sym_GT_EQ] = ACTIONS(2459),
    [anon_sym_LT_EQ] = ACTIONS(2459),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2461),
    [anon_sym_var] = ACTIONS(2463),
    [sym_predefined_type] = ACTIONS(2465),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(2467),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2469),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
  },
  [438] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2789),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(5318),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_pattern] = STATE(8108),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(6141),
    [sym_property_pattern_clause] = STATE(6672),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6667),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(5313),
    [sym_postfix_unary_expression] = STATE(5314),
    [sym_prefix_unary_expression] = STATE(5314),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(5313),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(5314),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(5313),
    [sym_member_access_expression] = STATE(3856),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(5314),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(5313),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(5313),
    [sym_typeof_expression] = STATE(5313),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3856),
    [sym_literal] = STATE(5313),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(438),
    [sym_preproc_endregion] = STATE(438),
    [sym_preproc_line] = STATE(438),
    [sym_preproc_pragma] = STATE(438),
    [sym_preproc_nullable] = STATE(438),
    [sym_preproc_error] = STATE(438),
    [sym_preproc_define] = STATE(438),
    [sym_preproc_undef] = STATE(438),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(1043),
    [anon_sym_ref] = ACTIONS(2257),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1053),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1059),
    [anon_sym_TILDE] = ACTIONS(1059),
    [anon_sym_PLUS_PLUS] = ACTIONS(1059),
    [anon_sym_DASH_DASH] = ACTIONS(1059),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1061),
    [anon_sym_DASH] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_GT_EQ] = ACTIONS(1063),
    [anon_sym_LT_EQ] = ACTIONS(1063),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1065),
    [anon_sym_var] = ACTIONS(1067),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(1077),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [439] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(3523),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2847),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(3034),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(2975),
    [sym__array_base_type] = STATE(8712),
    [sym_nullable_type] = STATE(2974),
    [sym_pointer_type] = STATE(2974),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(2974),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(2973),
    [sym_pattern] = STATE(6227),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(3081),
    [sym_property_pattern_clause] = STATE(3148),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6659),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(4290),
    [sym_postfix_unary_expression] = STATE(4294),
    [sym_prefix_unary_expression] = STATE(4294),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(4290),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(4294),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(4290),
    [sym_member_access_expression] = STATE(3277),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(4294),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(4290),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(4290),
    [sym_typeof_expression] = STATE(4290),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3277),
    [sym_literal] = STATE(4290),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2810),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(439),
    [sym_preproc_endregion] = STATE(439),
    [sym_preproc_line] = STATE(439),
    [sym_preproc_pragma] = STATE(439),
    [sym_preproc_nullable] = STATE(439),
    [sym_preproc_error] = STATE(439),
    [sym_preproc_define] = STATE(439),
    [sym_preproc_undef] = STATE(439),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(2389),
    [anon_sym_ref] = ACTIONS(2391),
    [anon_sym_LBRACE] = ACTIONS(2289),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(1929),
    [anon_sym_GT] = ACTIONS(1929),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1749),
    [anon_sym_TILDE] = ACTIONS(1749),
    [anon_sym_PLUS_PLUS] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1749),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1747),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1749),
    [anon_sym_AMP] = ACTIONS(1749),
    [anon_sym_GT_EQ] = ACTIONS(1931),
    [anon_sym_LT_EQ] = ACTIONS(1931),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2295),
    [anon_sym_var] = ACTIONS(2393),
    [sym_predefined_type] = ACTIONS(2313),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2395),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [440] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(3541),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2878),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(3058),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(2975),
    [sym__array_base_type] = STATE(8712),
    [sym_nullable_type] = STATE(2974),
    [sym_pointer_type] = STATE(2974),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(2974),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(2973),
    [sym_pattern] = STATE(5101),
    [sym_constant_pattern] = STATE(4988),
    [sym_parenthesized_pattern] = STATE(4988),
    [sym_var_pattern] = STATE(4988),
    [sym_type_pattern] = STATE(4988),
    [sym_list_pattern] = STATE(4988),
    [sym_recursive_pattern] = STATE(4988),
    [sym_positional_pattern_clause] = STATE(3139),
    [sym_property_pattern_clause] = STATE(3239),
    [sym_relational_pattern] = STATE(4988),
    [sym_negated_pattern] = STATE(4988),
    [sym_and_pattern] = STATE(4988),
    [sym_or_pattern] = STATE(4988),
    [sym_declaration_pattern] = STATE(4988),
    [sym_expression] = STATE(6683),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(4995),
    [sym_postfix_unary_expression] = STATE(4994),
    [sym_prefix_unary_expression] = STATE(4994),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(4995),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(4994),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(4995),
    [sym_member_access_expression] = STATE(3744),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(4994),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(4995),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(4995),
    [sym_typeof_expression] = STATE(4995),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3744),
    [sym_literal] = STATE(4995),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2742),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(440),
    [sym_preproc_endregion] = STATE(440),
    [sym_preproc_line] = STATE(440),
    [sym_preproc_pragma] = STATE(440),
    [sym_preproc_nullable] = STATE(440),
    [sym_preproc_error] = STATE(440),
    [sym_preproc_define] = STATE(440),
    [sym_preproc_undef] = STATE(440),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(2495),
    [anon_sym_LPAREN] = ACTIONS(2519),
    [anon_sym_ref] = ACTIONS(2287),
    [anon_sym_LBRACE] = ACTIONS(2289),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(2521),
    [anon_sym_GT] = ACTIONS(2521),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1803),
    [anon_sym_TILDE] = ACTIONS(1803),
    [anon_sym_PLUS_PLUS] = ACTIONS(1803),
    [anon_sym_DASH_DASH] = ACTIONS(1803),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1801),
    [anon_sym_DASH] = ACTIONS(1801),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1803),
    [anon_sym_AMP] = ACTIONS(1803),
    [anon_sym_GT_EQ] = ACTIONS(2523),
    [anon_sym_LT_EQ] = ACTIONS(2523),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2295),
    [anon_sym_var] = ACTIONS(2525),
    [sym_predefined_type] = ACTIONS(2505),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(2507),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2527),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [441] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(3519),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2845),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(3017),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(2975),
    [sym__array_base_type] = STATE(8712),
    [sym_nullable_type] = STATE(2974),
    [sym_pointer_type] = STATE(2974),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(2974),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(2973),
    [sym_pattern] = STATE(4059),
    [sym_constant_pattern] = STATE(3952),
    [sym_parenthesized_pattern] = STATE(3952),
    [sym_var_pattern] = STATE(3952),
    [sym_type_pattern] = STATE(3952),
    [sym_list_pattern] = STATE(3952),
    [sym_recursive_pattern] = STATE(3952),
    [sym_positional_pattern_clause] = STATE(3102),
    [sym_property_pattern_clause] = STATE(3138),
    [sym_relational_pattern] = STATE(3952),
    [sym_negated_pattern] = STATE(3952),
    [sym_and_pattern] = STATE(3952),
    [sym_or_pattern] = STATE(3952),
    [sym_declaration_pattern] = STATE(3952),
    [sym_expression] = STATE(6655),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3993),
    [sym_postfix_unary_expression] = STATE(3997),
    [sym_prefix_unary_expression] = STATE(3997),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3993),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3997),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3993),
    [sym_member_access_expression] = STATE(3202),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3997),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3993),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3993),
    [sym_typeof_expression] = STATE(3993),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3202),
    [sym_literal] = STATE(3993),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2762),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(441),
    [sym_preproc_endregion] = STATE(441),
    [sym_preproc_line] = STATE(441),
    [sym_preproc_pragma] = STATE(441),
    [sym_preproc_nullable] = STATE(441),
    [sym_preproc_error] = STATE(441),
    [sym_preproc_define] = STATE(441),
    [sym_preproc_undef] = STATE(441),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(2283),
    [anon_sym_LPAREN] = ACTIONS(2439),
    [anon_sym_ref] = ACTIONS(2375),
    [anon_sym_LBRACE] = ACTIONS(2289),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(2441),
    [anon_sym_GT] = ACTIONS(2441),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1717),
    [anon_sym_TILDE] = ACTIONS(1717),
    [anon_sym_PLUS_PLUS] = ACTIONS(1717),
    [anon_sym_DASH_DASH] = ACTIONS(1717),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1715),
    [anon_sym_DASH] = ACTIONS(1715),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1717),
    [anon_sym_AMP] = ACTIONS(1717),
    [anon_sym_GT_EQ] = ACTIONS(2443),
    [anon_sym_LT_EQ] = ACTIONS(2443),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2381),
    [anon_sym_var] = ACTIONS(2297),
    [sym_predefined_type] = ACTIONS(2299),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(2301),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2445),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [442] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(3523),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2847),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(3034),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(2975),
    [sym__array_base_type] = STATE(8712),
    [sym_nullable_type] = STATE(2974),
    [sym_pointer_type] = STATE(2974),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(2974),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(2973),
    [sym_pattern] = STATE(4118),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(3081),
    [sym_property_pattern_clause] = STATE(3148),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6659),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(4290),
    [sym_postfix_unary_expression] = STATE(4294),
    [sym_prefix_unary_expression] = STATE(4294),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(4290),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(4294),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(4290),
    [sym_member_access_expression] = STATE(3277),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(4294),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(4290),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(4290),
    [sym_typeof_expression] = STATE(4290),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3277),
    [sym_literal] = STATE(4290),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2810),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(442),
    [sym_preproc_endregion] = STATE(442),
    [sym_preproc_line] = STATE(442),
    [sym_preproc_pragma] = STATE(442),
    [sym_preproc_nullable] = STATE(442),
    [sym_preproc_error] = STATE(442),
    [sym_preproc_define] = STATE(442),
    [sym_preproc_undef] = STATE(442),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(2389),
    [anon_sym_ref] = ACTIONS(2391),
    [anon_sym_LBRACE] = ACTIONS(2289),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(1929),
    [anon_sym_GT] = ACTIONS(1929),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1749),
    [anon_sym_TILDE] = ACTIONS(1749),
    [anon_sym_PLUS_PLUS] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1749),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1747),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1749),
    [anon_sym_AMP] = ACTIONS(1749),
    [anon_sym_GT_EQ] = ACTIONS(1931),
    [anon_sym_LT_EQ] = ACTIONS(1931),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2295),
    [anon_sym_var] = ACTIONS(2393),
    [sym_predefined_type] = ACTIONS(2313),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2395),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [443] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(3525),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2860),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(3031),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(2975),
    [sym__array_base_type] = STATE(8712),
    [sym_nullable_type] = STATE(2974),
    [sym_pointer_type] = STATE(2974),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(2974),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(2973),
    [sym_pattern] = STATE(4662),
    [sym_constant_pattern] = STATE(4709),
    [sym_parenthesized_pattern] = STATE(4709),
    [sym_var_pattern] = STATE(4709),
    [sym_type_pattern] = STATE(4709),
    [sym_list_pattern] = STATE(4709),
    [sym_recursive_pattern] = STATE(4709),
    [sym_positional_pattern_clause] = STATE(3109),
    [sym_property_pattern_clause] = STATE(3192),
    [sym_relational_pattern] = STATE(4709),
    [sym_negated_pattern] = STATE(4709),
    [sym_and_pattern] = STATE(4709),
    [sym_or_pattern] = STATE(4709),
    [sym_declaration_pattern] = STATE(4709),
    [sym_expression] = STATE(6665),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(4649),
    [sym_postfix_unary_expression] = STATE(4712),
    [sym_prefix_unary_expression] = STATE(4712),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(4649),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(4712),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(4649),
    [sym_member_access_expression] = STATE(3548),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(4712),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(4649),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(4649),
    [sym_typeof_expression] = STATE(4649),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3548),
    [sym_literal] = STATE(4649),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2742),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(443),
    [sym_preproc_endregion] = STATE(443),
    [sym_preproc_line] = STATE(443),
    [sym_preproc_pragma] = STATE(443),
    [sym_preproc_nullable] = STATE(443),
    [sym_preproc_error] = STATE(443),
    [sym_preproc_define] = STATE(443),
    [sym_preproc_undef] = STATE(443),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(2337),
    [anon_sym_LPAREN] = ACTIONS(2487),
    [anon_sym_ref] = ACTIONS(2287),
    [anon_sym_LBRACE] = ACTIONS(2289),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(2489),
    [anon_sym_GT] = ACTIONS(2489),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1683),
    [anon_sym_TILDE] = ACTIONS(1683),
    [anon_sym_PLUS_PLUS] = ACTIONS(1683),
    [anon_sym_DASH_DASH] = ACTIONS(1683),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_DASH] = ACTIONS(1681),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1683),
    [anon_sym_GT_EQ] = ACTIONS(2491),
    [anon_sym_LT_EQ] = ACTIONS(2491),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2295),
    [anon_sym_var] = ACTIONS(2345),
    [sym_predefined_type] = ACTIONS(2347),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(2349),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2493),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [444] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(3519),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2845),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(3017),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(2975),
    [sym__array_base_type] = STATE(8712),
    [sym_nullable_type] = STATE(2974),
    [sym_pointer_type] = STATE(2974),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(2974),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(2973),
    [sym_pattern] = STATE(5855),
    [sym_constant_pattern] = STATE(3952),
    [sym_parenthesized_pattern] = STATE(3952),
    [sym_var_pattern] = STATE(3952),
    [sym_type_pattern] = STATE(3952),
    [sym_list_pattern] = STATE(3952),
    [sym_recursive_pattern] = STATE(3952),
    [sym_positional_pattern_clause] = STATE(3102),
    [sym_property_pattern_clause] = STATE(3138),
    [sym_relational_pattern] = STATE(3952),
    [sym_negated_pattern] = STATE(3952),
    [sym_and_pattern] = STATE(3952),
    [sym_or_pattern] = STATE(3952),
    [sym_declaration_pattern] = STATE(3952),
    [sym_expression] = STATE(6655),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3993),
    [sym_postfix_unary_expression] = STATE(3997),
    [sym_prefix_unary_expression] = STATE(3997),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3993),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3997),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3993),
    [sym_member_access_expression] = STATE(3202),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3997),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3993),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3993),
    [sym_typeof_expression] = STATE(3993),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3202),
    [sym_literal] = STATE(3993),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2762),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(444),
    [sym_preproc_endregion] = STATE(444),
    [sym_preproc_line] = STATE(444),
    [sym_preproc_pragma] = STATE(444),
    [sym_preproc_nullable] = STATE(444),
    [sym_preproc_error] = STATE(444),
    [sym_preproc_define] = STATE(444),
    [sym_preproc_undef] = STATE(444),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(2283),
    [anon_sym_LPAREN] = ACTIONS(2439),
    [anon_sym_ref] = ACTIONS(2375),
    [anon_sym_LBRACE] = ACTIONS(2289),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(2441),
    [anon_sym_GT] = ACTIONS(2441),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1717),
    [anon_sym_TILDE] = ACTIONS(1717),
    [anon_sym_PLUS_PLUS] = ACTIONS(1717),
    [anon_sym_DASH_DASH] = ACTIONS(1717),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1715),
    [anon_sym_DASH] = ACTIONS(1715),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1717),
    [anon_sym_AMP] = ACTIONS(1717),
    [anon_sym_GT_EQ] = ACTIONS(2443),
    [anon_sym_LT_EQ] = ACTIONS(2443),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2381),
    [anon_sym_var] = ACTIONS(2297),
    [sym_predefined_type] = ACTIONS(2299),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(2301),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2445),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [445] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(3534),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2895),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(3076),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(2975),
    [sym__array_base_type] = STATE(8712),
    [sym_nullable_type] = STATE(2974),
    [sym_pointer_type] = STATE(2974),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(2974),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(2973),
    [sym_pattern] = STATE(4043),
    [sym_constant_pattern] = STATE(3952),
    [sym_parenthesized_pattern] = STATE(3952),
    [sym_var_pattern] = STATE(3952),
    [sym_type_pattern] = STATE(3952),
    [sym_list_pattern] = STATE(3952),
    [sym_recursive_pattern] = STATE(3952),
    [sym_positional_pattern_clause] = STATE(3153),
    [sym_property_pattern_clause] = STATE(3405),
    [sym_relational_pattern] = STATE(3952),
    [sym_negated_pattern] = STATE(3952),
    [sym_and_pattern] = STATE(3952),
    [sym_or_pattern] = STATE(3952),
    [sym_declaration_pattern] = STATE(3952),
    [sym_expression] = STATE(6660),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3993),
    [sym_postfix_unary_expression] = STATE(3997),
    [sym_prefix_unary_expression] = STATE(3997),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3993),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3997),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3993),
    [sym_member_access_expression] = STATE(3202),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3997),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3993),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3993),
    [sym_typeof_expression] = STATE(3993),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3202),
    [sym_literal] = STATE(3993),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2742),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(445),
    [sym_preproc_endregion] = STATE(445),
    [sym_preproc_line] = STATE(445),
    [sym_preproc_pragma] = STATE(445),
    [sym_preproc_nullable] = STATE(445),
    [sym_preproc_error] = STATE(445),
    [sym_preproc_define] = STATE(445),
    [sym_preproc_undef] = STATE(445),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(2283),
    [anon_sym_LPAREN] = ACTIONS(2285),
    [anon_sym_ref] = ACTIONS(2287),
    [anon_sym_LBRACE] = ACTIONS(2289),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(2291),
    [anon_sym_GT] = ACTIONS(2291),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1875),
    [anon_sym_TILDE] = ACTIONS(1875),
    [anon_sym_PLUS_PLUS] = ACTIONS(1875),
    [anon_sym_DASH_DASH] = ACTIONS(1875),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1873),
    [anon_sym_DASH] = ACTIONS(1873),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1875),
    [anon_sym_AMP] = ACTIONS(1875),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2293),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2295),
    [anon_sym_var] = ACTIONS(2297),
    [sym_predefined_type] = ACTIONS(2299),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(2301),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2303),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [446] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(3519),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2845),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(3017),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(2975),
    [sym__array_base_type] = STATE(8712),
    [sym_nullable_type] = STATE(2974),
    [sym_pointer_type] = STATE(2974),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(2974),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(2973),
    [sym_pattern] = STATE(5874),
    [sym_constant_pattern] = STATE(3952),
    [sym_parenthesized_pattern] = STATE(3952),
    [sym_var_pattern] = STATE(3952),
    [sym_type_pattern] = STATE(3952),
    [sym_list_pattern] = STATE(3952),
    [sym_recursive_pattern] = STATE(3952),
    [sym_positional_pattern_clause] = STATE(3102),
    [sym_property_pattern_clause] = STATE(3138),
    [sym_relational_pattern] = STATE(3952),
    [sym_negated_pattern] = STATE(3952),
    [sym_and_pattern] = STATE(3952),
    [sym_or_pattern] = STATE(3952),
    [sym_declaration_pattern] = STATE(3952),
    [sym_expression] = STATE(6655),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3993),
    [sym_postfix_unary_expression] = STATE(3997),
    [sym_prefix_unary_expression] = STATE(3997),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3993),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3997),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3993),
    [sym_member_access_expression] = STATE(3202),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3997),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3993),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3993),
    [sym_typeof_expression] = STATE(3993),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3202),
    [sym_literal] = STATE(3993),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2762),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(446),
    [sym_preproc_endregion] = STATE(446),
    [sym_preproc_line] = STATE(446),
    [sym_preproc_pragma] = STATE(446),
    [sym_preproc_nullable] = STATE(446),
    [sym_preproc_error] = STATE(446),
    [sym_preproc_define] = STATE(446),
    [sym_preproc_undef] = STATE(446),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(2283),
    [anon_sym_LPAREN] = ACTIONS(2439),
    [anon_sym_ref] = ACTIONS(2375),
    [anon_sym_LBRACE] = ACTIONS(2289),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(2441),
    [anon_sym_GT] = ACTIONS(2441),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1717),
    [anon_sym_TILDE] = ACTIONS(1717),
    [anon_sym_PLUS_PLUS] = ACTIONS(1717),
    [anon_sym_DASH_DASH] = ACTIONS(1717),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1715),
    [anon_sym_DASH] = ACTIONS(1715),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1717),
    [anon_sym_AMP] = ACTIONS(1717),
    [anon_sym_GT_EQ] = ACTIONS(2443),
    [anon_sym_LT_EQ] = ACTIONS(2443),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2381),
    [anon_sym_var] = ACTIONS(2297),
    [sym_predefined_type] = ACTIONS(2299),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(2301),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2445),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [447] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(3536),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2891),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(3045),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(2975),
    [sym__array_base_type] = STATE(8712),
    [sym_nullable_type] = STATE(2974),
    [sym_pointer_type] = STATE(2974),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(2974),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(2973),
    [sym_pattern] = STATE(4193),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(3140),
    [sym_property_pattern_clause] = STATE(3227),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6670),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(4290),
    [sym_postfix_unary_expression] = STATE(4294),
    [sym_prefix_unary_expression] = STATE(4294),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(4290),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(4294),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(4290),
    [sym_member_access_expression] = STATE(3277),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(4294),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(4290),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(4290),
    [sym_typeof_expression] = STATE(4290),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3277),
    [sym_literal] = STATE(4290),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2742),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(447),
    [sym_preproc_endregion] = STATE(447),
    [sym_preproc_line] = STATE(447),
    [sym_preproc_pragma] = STATE(447),
    [sym_preproc_nullable] = STATE(447),
    [sym_preproc_error] = STATE(447),
    [sym_preproc_define] = STATE(447),
    [sym_preproc_undef] = STATE(447),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(2431),
    [anon_sym_ref] = ACTIONS(2287),
    [anon_sym_LBRACE] = ACTIONS(2289),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(2433),
    [anon_sym_GT] = ACTIONS(2433),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1893),
    [anon_sym_TILDE] = ACTIONS(1893),
    [anon_sym_PLUS_PLUS] = ACTIONS(1893),
    [anon_sym_DASH_DASH] = ACTIONS(1893),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1891),
    [anon_sym_DASH] = ACTIONS(1891),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1893),
    [anon_sym_AMP] = ACTIONS(1893),
    [anon_sym_GT_EQ] = ACTIONS(2435),
    [anon_sym_LT_EQ] = ACTIONS(2435),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2295),
    [anon_sym_var] = ACTIONS(2311),
    [sym_predefined_type] = ACTIONS(2313),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2437),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [448] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(3536),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2891),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(3068),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(2975),
    [sym__array_base_type] = STATE(8712),
    [sym_nullable_type] = STATE(2974),
    [sym_pointer_type] = STATE(2974),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(2974),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(2973),
    [sym_pattern] = STATE(6344),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(3140),
    [sym_property_pattern_clause] = STATE(3227),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6670),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(4290),
    [sym_postfix_unary_expression] = STATE(4294),
    [sym_prefix_unary_expression] = STATE(4294),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(4290),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(4294),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(4290),
    [sym_member_access_expression] = STATE(3277),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(4294),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(4290),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(4290),
    [sym_typeof_expression] = STATE(4290),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3277),
    [sym_literal] = STATE(4290),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2742),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(448),
    [sym_preproc_endregion] = STATE(448),
    [sym_preproc_line] = STATE(448),
    [sym_preproc_pragma] = STATE(448),
    [sym_preproc_nullable] = STATE(448),
    [sym_preproc_error] = STATE(448),
    [sym_preproc_define] = STATE(448),
    [sym_preproc_undef] = STATE(448),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(2431),
    [anon_sym_ref] = ACTIONS(2287),
    [anon_sym_LBRACE] = ACTIONS(2289),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(2433),
    [anon_sym_GT] = ACTIONS(2433),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1893),
    [anon_sym_TILDE] = ACTIONS(1893),
    [anon_sym_PLUS_PLUS] = ACTIONS(1893),
    [anon_sym_DASH_DASH] = ACTIONS(1893),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1891),
    [anon_sym_DASH] = ACTIONS(1891),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1893),
    [anon_sym_AMP] = ACTIONS(1893),
    [anon_sym_GT_EQ] = ACTIONS(2435),
    [anon_sym_LT_EQ] = ACTIONS(2435),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2295),
    [anon_sym_var] = ACTIONS(2311),
    [sym_predefined_type] = ACTIONS(2313),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2437),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [449] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(2997),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2749),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(3036),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(2975),
    [sym__array_base_type] = STATE(8712),
    [sym_nullable_type] = STATE(2974),
    [sym_pointer_type] = STATE(2974),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(2974),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(2973),
    [sym_pattern] = STATE(4118),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(3119),
    [sym_property_pattern_clause] = STATE(3182),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6706),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(4290),
    [sym_postfix_unary_expression] = STATE(4294),
    [sym_prefix_unary_expression] = STATE(4294),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(4290),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(4294),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(4290),
    [sym_member_access_expression] = STATE(3277),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(4294),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(4290),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(4290),
    [sym_typeof_expression] = STATE(4290),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3277),
    [sym_literal] = STATE(4290),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2742),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(449),
    [sym_preproc_endregion] = STATE(449),
    [sym_preproc_line] = STATE(449),
    [sym_preproc_pragma] = STATE(449),
    [sym_preproc_nullable] = STATE(449),
    [sym_preproc_error] = STATE(449),
    [sym_preproc_define] = STATE(449),
    [sym_preproc_undef] = STATE(449),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(2363),
    [anon_sym_ref] = ACTIONS(2287),
    [anon_sym_LBRACE] = ACTIONS(2289),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(2365),
    [anon_sym_GT] = ACTIONS(2365),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_GT_EQ] = ACTIONS(2367),
    [anon_sym_LT_EQ] = ACTIONS(2367),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2295),
    [anon_sym_var] = ACTIONS(2369),
    [sym_predefined_type] = ACTIONS(2313),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2371),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [450] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(2997),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2749),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(3036),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(2975),
    [sym__array_base_type] = STATE(8712),
    [sym_nullable_type] = STATE(2974),
    [sym_pointer_type] = STATE(2974),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(2974),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(2973),
    [sym_pattern] = STATE(6282),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(3119),
    [sym_property_pattern_clause] = STATE(3182),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6706),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(4290),
    [sym_postfix_unary_expression] = STATE(4294),
    [sym_prefix_unary_expression] = STATE(4294),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(4290),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(4294),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(4290),
    [sym_member_access_expression] = STATE(3277),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(4294),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(4290),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(4290),
    [sym_typeof_expression] = STATE(4290),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3277),
    [sym_literal] = STATE(4290),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2742),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(450),
    [sym_preproc_endregion] = STATE(450),
    [sym_preproc_line] = STATE(450),
    [sym_preproc_pragma] = STATE(450),
    [sym_preproc_nullable] = STATE(450),
    [sym_preproc_error] = STATE(450),
    [sym_preproc_define] = STATE(450),
    [sym_preproc_undef] = STATE(450),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(2363),
    [anon_sym_ref] = ACTIONS(2287),
    [anon_sym_LBRACE] = ACTIONS(2289),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(2365),
    [anon_sym_GT] = ACTIONS(2365),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_GT_EQ] = ACTIONS(2367),
    [anon_sym_LT_EQ] = ACTIONS(2367),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2295),
    [anon_sym_var] = ACTIONS(2369),
    [sym_predefined_type] = ACTIONS(2313),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2371),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [451] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(3540),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2906),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(3063),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(2975),
    [sym__array_base_type] = STATE(8712),
    [sym_nullable_type] = STATE(2974),
    [sym_pointer_type] = STATE(2974),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(2974),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(2973),
    [sym_pattern] = STATE(4043),
    [sym_constant_pattern] = STATE(3952),
    [sym_parenthesized_pattern] = STATE(3952),
    [sym_var_pattern] = STATE(3952),
    [sym_type_pattern] = STATE(3952),
    [sym_list_pattern] = STATE(3952),
    [sym_recursive_pattern] = STATE(3952),
    [sym_positional_pattern_clause] = STATE(3132),
    [sym_property_pattern_clause] = STATE(3487),
    [sym_relational_pattern] = STATE(3952),
    [sym_negated_pattern] = STATE(3952),
    [sym_and_pattern] = STATE(3952),
    [sym_or_pattern] = STATE(3952),
    [sym_declaration_pattern] = STATE(3952),
    [sym_expression] = STATE(6686),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3993),
    [sym_postfix_unary_expression] = STATE(3997),
    [sym_prefix_unary_expression] = STATE(3997),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3993),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3997),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3993),
    [sym_member_access_expression] = STATE(3202),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3997),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3993),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3993),
    [sym_typeof_expression] = STATE(3993),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3202),
    [sym_literal] = STATE(3993),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2742),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(451),
    [sym_preproc_endregion] = STATE(451),
    [sym_preproc_line] = STATE(451),
    [sym_preproc_pragma] = STATE(451),
    [sym_preproc_nullable] = STATE(451),
    [sym_preproc_error] = STATE(451),
    [sym_preproc_define] = STATE(451),
    [sym_preproc_undef] = STATE(451),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(2283),
    [anon_sym_LPAREN] = ACTIONS(2397),
    [anon_sym_ref] = ACTIONS(2287),
    [anon_sym_LBRACE] = ACTIONS(2289),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(2399),
    [anon_sym_GT] = ACTIONS(2399),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1839),
    [anon_sym_TILDE] = ACTIONS(1839),
    [anon_sym_PLUS_PLUS] = ACTIONS(1839),
    [anon_sym_DASH_DASH] = ACTIONS(1839),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1837),
    [anon_sym_DASH] = ACTIONS(1837),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1839),
    [anon_sym_AMP] = ACTIONS(1839),
    [anon_sym_GT_EQ] = ACTIONS(2401),
    [anon_sym_LT_EQ] = ACTIONS(2401),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2295),
    [anon_sym_var] = ACTIONS(2297),
    [sym_predefined_type] = ACTIONS(2299),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(2301),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2403),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [452] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(3532),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2904),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(3078),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(2975),
    [sym__array_base_type] = STATE(8712),
    [sym_nullable_type] = STATE(2974),
    [sym_pointer_type] = STATE(2974),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(2974),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(2973),
    [sym_pattern] = STATE(4193),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(3150),
    [sym_property_pattern_clause] = STATE(3362),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6693),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(4290),
    [sym_postfix_unary_expression] = STATE(4294),
    [sym_prefix_unary_expression] = STATE(4294),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(4290),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(4294),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(4290),
    [sym_member_access_expression] = STATE(3277),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(4294),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(4290),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(4290),
    [sym_typeof_expression] = STATE(4290),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3277),
    [sym_literal] = STATE(4290),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2742),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(452),
    [sym_preproc_endregion] = STATE(452),
    [sym_preproc_line] = STATE(452),
    [sym_preproc_pragma] = STATE(452),
    [sym_preproc_nullable] = STATE(452),
    [sym_preproc_error] = STATE(452),
    [sym_preproc_define] = STATE(452),
    [sym_preproc_undef] = STATE(452),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(2355),
    [anon_sym_ref] = ACTIONS(2287),
    [anon_sym_LBRACE] = ACTIONS(2289),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(2357),
    [anon_sym_GT] = ACTIONS(2357),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1767),
    [anon_sym_TILDE] = ACTIONS(1767),
    [anon_sym_PLUS_PLUS] = ACTIONS(1767),
    [anon_sym_DASH_DASH] = ACTIONS(1767),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1765),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(1767),
    [anon_sym_GT_EQ] = ACTIONS(2359),
    [anon_sym_LT_EQ] = ACTIONS(2359),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2295),
    [anon_sym_var] = ACTIONS(2311),
    [sym_predefined_type] = ACTIONS(2313),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2361),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [453] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(3541),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2878),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(3058),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(2975),
    [sym__array_base_type] = STATE(8712),
    [sym_nullable_type] = STATE(2974),
    [sym_pointer_type] = STATE(2974),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(2974),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(2973),
    [sym_pattern] = STATE(4985),
    [sym_constant_pattern] = STATE(4988),
    [sym_parenthesized_pattern] = STATE(4988),
    [sym_var_pattern] = STATE(4988),
    [sym_type_pattern] = STATE(4988),
    [sym_list_pattern] = STATE(4988),
    [sym_recursive_pattern] = STATE(4988),
    [sym_positional_pattern_clause] = STATE(3139),
    [sym_property_pattern_clause] = STATE(3239),
    [sym_relational_pattern] = STATE(4988),
    [sym_negated_pattern] = STATE(4988),
    [sym_and_pattern] = STATE(4988),
    [sym_or_pattern] = STATE(4988),
    [sym_declaration_pattern] = STATE(4988),
    [sym_expression] = STATE(6683),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(4995),
    [sym_postfix_unary_expression] = STATE(4994),
    [sym_prefix_unary_expression] = STATE(4994),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(4995),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(4994),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(4995),
    [sym_member_access_expression] = STATE(3744),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(4994),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(4995),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(4995),
    [sym_typeof_expression] = STATE(4995),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3744),
    [sym_literal] = STATE(4995),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2742),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(453),
    [sym_preproc_endregion] = STATE(453),
    [sym_preproc_line] = STATE(453),
    [sym_preproc_pragma] = STATE(453),
    [sym_preproc_nullable] = STATE(453),
    [sym_preproc_error] = STATE(453),
    [sym_preproc_define] = STATE(453),
    [sym_preproc_undef] = STATE(453),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(2495),
    [anon_sym_LPAREN] = ACTIONS(2519),
    [anon_sym_ref] = ACTIONS(2287),
    [anon_sym_LBRACE] = ACTIONS(2289),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(2521),
    [anon_sym_GT] = ACTIONS(2521),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1803),
    [anon_sym_TILDE] = ACTIONS(1803),
    [anon_sym_PLUS_PLUS] = ACTIONS(1803),
    [anon_sym_DASH_DASH] = ACTIONS(1803),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1801),
    [anon_sym_DASH] = ACTIONS(1801),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1803),
    [anon_sym_AMP] = ACTIONS(1803),
    [anon_sym_GT_EQ] = ACTIONS(2523),
    [anon_sym_LT_EQ] = ACTIONS(2523),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2295),
    [anon_sym_var] = ACTIONS(2525),
    [sym_predefined_type] = ACTIONS(2505),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(2507),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2527),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [454] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(3533),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2888),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(3055),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(2975),
    [sym__array_base_type] = STATE(8712),
    [sym_nullable_type] = STATE(2974),
    [sym_pointer_type] = STATE(2974),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(2974),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(2973),
    [sym_pattern] = STATE(4043),
    [sym_constant_pattern] = STATE(3952),
    [sym_parenthesized_pattern] = STATE(3952),
    [sym_var_pattern] = STATE(3952),
    [sym_type_pattern] = STATE(3952),
    [sym_list_pattern] = STATE(3952),
    [sym_recursive_pattern] = STATE(3952),
    [sym_positional_pattern_clause] = STATE(3149),
    [sym_property_pattern_clause] = STATE(3466),
    [sym_relational_pattern] = STATE(3952),
    [sym_negated_pattern] = STATE(3952),
    [sym_and_pattern] = STATE(3952),
    [sym_or_pattern] = STATE(3952),
    [sym_declaration_pattern] = STATE(3952),
    [sym_expression] = STATE(6705),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3993),
    [sym_postfix_unary_expression] = STATE(3997),
    [sym_prefix_unary_expression] = STATE(3997),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3993),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3997),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3993),
    [sym_member_access_expression] = STATE(3202),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3997),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3993),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3993),
    [sym_typeof_expression] = STATE(3993),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3202),
    [sym_literal] = STATE(3993),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2742),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(454),
    [sym_preproc_endregion] = STATE(454),
    [sym_preproc_line] = STATE(454),
    [sym_preproc_pragma] = STATE(454),
    [sym_preproc_nullable] = STATE(454),
    [sym_preproc_error] = STATE(454),
    [sym_preproc_define] = STATE(454),
    [sym_preproc_undef] = STATE(454),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(2283),
    [anon_sym_LPAREN] = ACTIONS(2413),
    [anon_sym_ref] = ACTIONS(2287),
    [anon_sym_LBRACE] = ACTIONS(2289),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(2415),
    [anon_sym_GT] = ACTIONS(2415),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1785),
    [anon_sym_TILDE] = ACTIONS(1785),
    [anon_sym_PLUS_PLUS] = ACTIONS(1785),
    [anon_sym_DASH_DASH] = ACTIONS(1785),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1785),
    [anon_sym_AMP] = ACTIONS(1785),
    [anon_sym_GT_EQ] = ACTIONS(2417),
    [anon_sym_LT_EQ] = ACTIONS(2417),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2295),
    [anon_sym_var] = ACTIONS(2297),
    [sym_predefined_type] = ACTIONS(2299),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(2301),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2419),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [455] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(3178),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2749),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(2797),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(2975),
    [sym__array_base_type] = STATE(8712),
    [sym_nullable_type] = STATE(2974),
    [sym_pointer_type] = STATE(2974),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(2974),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(2973),
    [sym_pattern] = STATE(6653),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(2842),
    [sym_property_pattern_clause] = STATE(2893),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6690),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(4290),
    [sym_postfix_unary_expression] = STATE(4294),
    [sym_prefix_unary_expression] = STATE(4294),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(4290),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(4294),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(4290),
    [sym_member_access_expression] = STATE(3277),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(4294),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(4290),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(4290),
    [sym_typeof_expression] = STATE(4290),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3277),
    [sym_literal] = STATE(4290),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2762),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(455),
    [sym_preproc_endregion] = STATE(455),
    [sym_preproc_line] = STATE(455),
    [sym_preproc_pragma] = STATE(455),
    [sym_preproc_nullable] = STATE(455),
    [sym_preproc_error] = STATE(455),
    [sym_preproc_define] = STATE(455),
    [sym_preproc_undef] = STATE(455),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(2421),
    [anon_sym_ref] = ACTIONS(2375),
    [anon_sym_LBRACE] = ACTIONS(2289),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(2423),
    [anon_sym_GT] = ACTIONS(2423),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1551),
    [anon_sym_TILDE] = ACTIONS(1551),
    [anon_sym_PLUS_PLUS] = ACTIONS(1551),
    [anon_sym_DASH_DASH] = ACTIONS(1551),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1549),
    [anon_sym_DASH] = ACTIONS(1549),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1551),
    [anon_sym_AMP] = ACTIONS(1551),
    [anon_sym_GT_EQ] = ACTIONS(2425),
    [anon_sym_LT_EQ] = ACTIONS(2425),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2381),
    [anon_sym_var] = ACTIONS(2311),
    [sym_predefined_type] = ACTIONS(2313),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2427),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [456] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(3178),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2749),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(2797),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(2975),
    [sym__array_base_type] = STATE(8712),
    [sym_nullable_type] = STATE(2974),
    [sym_pointer_type] = STATE(2974),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(2974),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(2973),
    [sym_pattern] = STATE(4118),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(2842),
    [sym_property_pattern_clause] = STATE(2893),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6690),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(4290),
    [sym_postfix_unary_expression] = STATE(4294),
    [sym_prefix_unary_expression] = STATE(4294),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(4290),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(4294),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(4290),
    [sym_member_access_expression] = STATE(3277),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(4294),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(4290),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(4290),
    [sym_typeof_expression] = STATE(4290),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3277),
    [sym_literal] = STATE(4290),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2762),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(456),
    [sym_preproc_endregion] = STATE(456),
    [sym_preproc_line] = STATE(456),
    [sym_preproc_pragma] = STATE(456),
    [sym_preproc_nullable] = STATE(456),
    [sym_preproc_error] = STATE(456),
    [sym_preproc_define] = STATE(456),
    [sym_preproc_undef] = STATE(456),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(2421),
    [anon_sym_ref] = ACTIONS(2375),
    [anon_sym_LBRACE] = ACTIONS(2289),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(2423),
    [anon_sym_GT] = ACTIONS(2423),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1551),
    [anon_sym_TILDE] = ACTIONS(1551),
    [anon_sym_PLUS_PLUS] = ACTIONS(1551),
    [anon_sym_DASH_DASH] = ACTIONS(1551),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1549),
    [anon_sym_DASH] = ACTIONS(1549),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1551),
    [anon_sym_AMP] = ACTIONS(1551),
    [anon_sym_GT_EQ] = ACTIONS(2425),
    [anon_sym_LT_EQ] = ACTIONS(2425),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2381),
    [anon_sym_var] = ACTIONS(2311),
    [sym_predefined_type] = ACTIONS(2313),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2427),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [457] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(3538),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2876),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(3077),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(2975),
    [sym__array_base_type] = STATE(8712),
    [sym_nullable_type] = STATE(2974),
    [sym_pointer_type] = STATE(2974),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(2974),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(2973),
    [sym_pattern] = STATE(4193),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(3151),
    [sym_property_pattern_clause] = STATE(3386),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6675),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(4290),
    [sym_postfix_unary_expression] = STATE(4294),
    [sym_prefix_unary_expression] = STATE(4294),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(4290),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(4294),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(4290),
    [sym_member_access_expression] = STATE(3277),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(4294),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(4290),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(4290),
    [sym_typeof_expression] = STATE(4290),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3277),
    [sym_literal] = STATE(4290),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2742),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(457),
    [sym_preproc_endregion] = STATE(457),
    [sym_preproc_line] = STATE(457),
    [sym_preproc_pragma] = STATE(457),
    [sym_preproc_nullable] = STATE(457),
    [sym_preproc_error] = STATE(457),
    [sym_preproc_define] = STATE(457),
    [sym_preproc_undef] = STATE(457),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(2529),
    [anon_sym_ref] = ACTIONS(2287),
    [anon_sym_LBRACE] = ACTIONS(2289),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(2531),
    [anon_sym_GT] = ACTIONS(2531),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1821),
    [anon_sym_TILDE] = ACTIONS(1821),
    [anon_sym_PLUS_PLUS] = ACTIONS(1821),
    [anon_sym_DASH_DASH] = ACTIONS(1821),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1819),
    [anon_sym_DASH] = ACTIONS(1819),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1821),
    [anon_sym_AMP] = ACTIONS(1821),
    [anon_sym_GT_EQ] = ACTIONS(2533),
    [anon_sym_LT_EQ] = ACTIONS(2533),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2295),
    [anon_sym_var] = ACTIONS(2311),
    [sym_predefined_type] = ACTIONS(2313),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2535),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [458] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(3541),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2878),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(3058),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(2975),
    [sym__array_base_type] = STATE(8712),
    [sym_nullable_type] = STATE(2974),
    [sym_pointer_type] = STATE(2974),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(2974),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(2973),
    [sym_pattern] = STATE(5080),
    [sym_constant_pattern] = STATE(4988),
    [sym_parenthesized_pattern] = STATE(4988),
    [sym_var_pattern] = STATE(4988),
    [sym_type_pattern] = STATE(4988),
    [sym_list_pattern] = STATE(4988),
    [sym_recursive_pattern] = STATE(4988),
    [sym_positional_pattern_clause] = STATE(3139),
    [sym_property_pattern_clause] = STATE(3239),
    [sym_relational_pattern] = STATE(4988),
    [sym_negated_pattern] = STATE(4988),
    [sym_and_pattern] = STATE(4988),
    [sym_or_pattern] = STATE(4988),
    [sym_declaration_pattern] = STATE(4988),
    [sym_expression] = STATE(6683),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(4995),
    [sym_postfix_unary_expression] = STATE(4994),
    [sym_prefix_unary_expression] = STATE(4994),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(4995),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(4994),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(4995),
    [sym_member_access_expression] = STATE(3744),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(4994),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(4995),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(4995),
    [sym_typeof_expression] = STATE(4995),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3744),
    [sym_literal] = STATE(4995),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2742),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(458),
    [sym_preproc_endregion] = STATE(458),
    [sym_preproc_line] = STATE(458),
    [sym_preproc_pragma] = STATE(458),
    [sym_preproc_nullable] = STATE(458),
    [sym_preproc_error] = STATE(458),
    [sym_preproc_define] = STATE(458),
    [sym_preproc_undef] = STATE(458),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(2495),
    [anon_sym_LPAREN] = ACTIONS(2519),
    [anon_sym_ref] = ACTIONS(2287),
    [anon_sym_LBRACE] = ACTIONS(2289),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(2521),
    [anon_sym_GT] = ACTIONS(2521),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1803),
    [anon_sym_TILDE] = ACTIONS(1803),
    [anon_sym_PLUS_PLUS] = ACTIONS(1803),
    [anon_sym_DASH_DASH] = ACTIONS(1803),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1801),
    [anon_sym_DASH] = ACTIONS(1801),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1803),
    [anon_sym_AMP] = ACTIONS(1803),
    [anon_sym_GT_EQ] = ACTIONS(2523),
    [anon_sym_LT_EQ] = ACTIONS(2523),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2295),
    [anon_sym_var] = ACTIONS(2525),
    [sym_predefined_type] = ACTIONS(2505),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(2507),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2527),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [459] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(2997),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2749),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(2797),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(2975),
    [sym__array_base_type] = STATE(8712),
    [sym_nullable_type] = STATE(2974),
    [sym_pointer_type] = STATE(2974),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(2974),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(2973),
    [sym_pattern] = STATE(5689),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(2842),
    [sym_property_pattern_clause] = STATE(2893),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6710),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(4290),
    [sym_postfix_unary_expression] = STATE(4294),
    [sym_prefix_unary_expression] = STATE(4294),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(4290),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(4294),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(4290),
    [sym_member_access_expression] = STATE(3277),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(4294),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(4290),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(4290),
    [sym_typeof_expression] = STATE(4290),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3277),
    [sym_literal] = STATE(4290),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2742),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(459),
    [sym_preproc_endregion] = STATE(459),
    [sym_preproc_line] = STATE(459),
    [sym_preproc_pragma] = STATE(459),
    [sym_preproc_nullable] = STATE(459),
    [sym_preproc_error] = STATE(459),
    [sym_preproc_define] = STATE(459),
    [sym_preproc_undef] = STATE(459),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(2305),
    [anon_sym_ref] = ACTIONS(2287),
    [anon_sym_LBRACE] = ACTIONS(2289),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(2307),
    [anon_sym_GT] = ACTIONS(2307),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1357),
    [anon_sym_TILDE] = ACTIONS(1357),
    [anon_sym_PLUS_PLUS] = ACTIONS(1357),
    [anon_sym_DASH_DASH] = ACTIONS(1357),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1355),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1357),
    [anon_sym_AMP] = ACTIONS(1357),
    [anon_sym_GT_EQ] = ACTIONS(2309),
    [anon_sym_LT_EQ] = ACTIONS(2309),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2295),
    [anon_sym_var] = ACTIONS(2311),
    [sym_predefined_type] = ACTIONS(2313),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2315),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [460] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(3534),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2895),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(3052),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(2975),
    [sym__array_base_type] = STATE(8712),
    [sym_nullable_type] = STATE(2974),
    [sym_pointer_type] = STATE(2974),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(2974),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(2973),
    [sym_pattern] = STATE(6157),
    [sym_constant_pattern] = STATE(3952),
    [sym_parenthesized_pattern] = STATE(3952),
    [sym_var_pattern] = STATE(3952),
    [sym_type_pattern] = STATE(3952),
    [sym_list_pattern] = STATE(3952),
    [sym_recursive_pattern] = STATE(3952),
    [sym_positional_pattern_clause] = STATE(3153),
    [sym_property_pattern_clause] = STATE(3405),
    [sym_relational_pattern] = STATE(3952),
    [sym_negated_pattern] = STATE(3952),
    [sym_and_pattern] = STATE(3952),
    [sym_or_pattern] = STATE(3952),
    [sym_declaration_pattern] = STATE(3952),
    [sym_expression] = STATE(6660),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3993),
    [sym_postfix_unary_expression] = STATE(3997),
    [sym_prefix_unary_expression] = STATE(3997),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3993),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3997),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3993),
    [sym_member_access_expression] = STATE(3202),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3997),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3993),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3993),
    [sym_typeof_expression] = STATE(3993),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3202),
    [sym_literal] = STATE(3993),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2742),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(460),
    [sym_preproc_endregion] = STATE(460),
    [sym_preproc_line] = STATE(460),
    [sym_preproc_pragma] = STATE(460),
    [sym_preproc_nullable] = STATE(460),
    [sym_preproc_error] = STATE(460),
    [sym_preproc_define] = STATE(460),
    [sym_preproc_undef] = STATE(460),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(2283),
    [anon_sym_LPAREN] = ACTIONS(2285),
    [anon_sym_ref] = ACTIONS(2287),
    [anon_sym_LBRACE] = ACTIONS(2289),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(2291),
    [anon_sym_GT] = ACTIONS(2291),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1875),
    [anon_sym_TILDE] = ACTIONS(1875),
    [anon_sym_PLUS_PLUS] = ACTIONS(1875),
    [anon_sym_DASH_DASH] = ACTIONS(1875),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1873),
    [anon_sym_DASH] = ACTIONS(1873),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1875),
    [anon_sym_AMP] = ACTIONS(1875),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2293),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2295),
    [anon_sym_var] = ACTIONS(2297),
    [sym_predefined_type] = ACTIONS(2299),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(2301),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2303),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [461] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(2992),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2747),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(3030),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(2975),
    [sym__array_base_type] = STATE(8712),
    [sym_nullable_type] = STATE(2974),
    [sym_pointer_type] = STATE(2974),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(2974),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(2973),
    [sym_pattern] = STATE(6200),
    [sym_constant_pattern] = STATE(3952),
    [sym_parenthesized_pattern] = STATE(3952),
    [sym_var_pattern] = STATE(3952),
    [sym_type_pattern] = STATE(3952),
    [sym_list_pattern] = STATE(3952),
    [sym_recursive_pattern] = STATE(3952),
    [sym_positional_pattern_clause] = STATE(2809),
    [sym_property_pattern_clause] = STATE(2851),
    [sym_relational_pattern] = STATE(3952),
    [sym_negated_pattern] = STATE(3952),
    [sym_and_pattern] = STATE(3952),
    [sym_or_pattern] = STATE(3952),
    [sym_declaration_pattern] = STATE(3952),
    [sym_expression] = STATE(6697),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3993),
    [sym_postfix_unary_expression] = STATE(3997),
    [sym_prefix_unary_expression] = STATE(3997),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3993),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3997),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3993),
    [sym_member_access_expression] = STATE(3202),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3997),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3993),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3993),
    [sym_typeof_expression] = STATE(3993),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3202),
    [sym_literal] = STATE(3993),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2810),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(461),
    [sym_preproc_endregion] = STATE(461),
    [sym_preproc_line] = STATE(461),
    [sym_preproc_pragma] = STATE(461),
    [sym_preproc_nullable] = STATE(461),
    [sym_preproc_error] = STATE(461),
    [sym_preproc_define] = STATE(461),
    [sym_preproc_undef] = STATE(461),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(2283),
    [anon_sym_LPAREN] = ACTIONS(2537),
    [anon_sym_ref] = ACTIONS(2391),
    [anon_sym_LBRACE] = ACTIONS(2289),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(2539),
    [anon_sym_GT] = ACTIONS(2539),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(1567),
    [anon_sym_PLUS_PLUS] = ACTIONS(1567),
    [anon_sym_DASH_DASH] = ACTIONS(1567),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1565),
    [anon_sym_DASH] = ACTIONS(1565),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1567),
    [anon_sym_AMP] = ACTIONS(1567),
    [anon_sym_GT_EQ] = ACTIONS(2541),
    [anon_sym_LT_EQ] = ACTIONS(2541),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2295),
    [anon_sym_var] = ACTIONS(2543),
    [sym_predefined_type] = ACTIONS(2299),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(2301),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2545),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [462] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(2992),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2747),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(3030),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(2975),
    [sym__array_base_type] = STATE(8712),
    [sym_nullable_type] = STATE(2974),
    [sym_pointer_type] = STATE(2974),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(2974),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(2973),
    [sym_pattern] = STATE(4059),
    [sym_constant_pattern] = STATE(3952),
    [sym_parenthesized_pattern] = STATE(3952),
    [sym_var_pattern] = STATE(3952),
    [sym_type_pattern] = STATE(3952),
    [sym_list_pattern] = STATE(3952),
    [sym_recursive_pattern] = STATE(3952),
    [sym_positional_pattern_clause] = STATE(2809),
    [sym_property_pattern_clause] = STATE(2851),
    [sym_relational_pattern] = STATE(3952),
    [sym_negated_pattern] = STATE(3952),
    [sym_and_pattern] = STATE(3952),
    [sym_or_pattern] = STATE(3952),
    [sym_declaration_pattern] = STATE(3952),
    [sym_expression] = STATE(6697),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3993),
    [sym_postfix_unary_expression] = STATE(3997),
    [sym_prefix_unary_expression] = STATE(3997),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3993),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3997),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3993),
    [sym_member_access_expression] = STATE(3202),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3997),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3993),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3993),
    [sym_typeof_expression] = STATE(3993),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3202),
    [sym_literal] = STATE(3993),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2810),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(462),
    [sym_preproc_endregion] = STATE(462),
    [sym_preproc_line] = STATE(462),
    [sym_preproc_pragma] = STATE(462),
    [sym_preproc_nullable] = STATE(462),
    [sym_preproc_error] = STATE(462),
    [sym_preproc_define] = STATE(462),
    [sym_preproc_undef] = STATE(462),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(2283),
    [anon_sym_LPAREN] = ACTIONS(2537),
    [anon_sym_ref] = ACTIONS(2391),
    [anon_sym_LBRACE] = ACTIONS(2289),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(2539),
    [anon_sym_GT] = ACTIONS(2539),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(1567),
    [anon_sym_PLUS_PLUS] = ACTIONS(1567),
    [anon_sym_DASH_DASH] = ACTIONS(1567),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1565),
    [anon_sym_DASH] = ACTIONS(1565),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1567),
    [anon_sym_AMP] = ACTIONS(1567),
    [anon_sym_GT_EQ] = ACTIONS(2541),
    [anon_sym_LT_EQ] = ACTIONS(2541),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2295),
    [anon_sym_var] = ACTIONS(2543),
    [sym_predefined_type] = ACTIONS(2299),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(2301),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2545),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [463] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(3178),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2749),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(2803),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(2975),
    [sym__array_base_type] = STATE(8712),
    [sym_nullable_type] = STATE(2974),
    [sym_pointer_type] = STATE(2974),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(2974),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(2973),
    [sym_pattern] = STATE(4193),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(2842),
    [sym_property_pattern_clause] = STATE(2893),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6689),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(4290),
    [sym_postfix_unary_expression] = STATE(4294),
    [sym_prefix_unary_expression] = STATE(4294),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(4290),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(4294),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(4290),
    [sym_member_access_expression] = STATE(3277),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(4294),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(4290),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(4290),
    [sym_typeof_expression] = STATE(4290),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3277),
    [sym_literal] = STATE(4290),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2762),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(463),
    [sym_preproc_endregion] = STATE(463),
    [sym_preproc_line] = STATE(463),
    [sym_preproc_pragma] = STATE(463),
    [sym_preproc_nullable] = STATE(463),
    [sym_preproc_error] = STATE(463),
    [sym_preproc_define] = STATE(463),
    [sym_preproc_undef] = STATE(463),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(2479),
    [anon_sym_ref] = ACTIONS(2375),
    [anon_sym_LBRACE] = ACTIONS(2289),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_GT] = ACTIONS(2481),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1097),
    [anon_sym_TILDE] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1099),
    [anon_sym_DASH] = ACTIONS(1099),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1097),
    [anon_sym_GT_EQ] = ACTIONS(2483),
    [anon_sym_LT_EQ] = ACTIONS(2483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2381),
    [anon_sym_var] = ACTIONS(2311),
    [sym_predefined_type] = ACTIONS(2313),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2485),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [464] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(3521),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2845),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(3037),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(2975),
    [sym__array_base_type] = STATE(8712),
    [sym_nullable_type] = STATE(2974),
    [sym_pointer_type] = STATE(2974),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(2974),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(2973),
    [sym_pattern] = STATE(4043),
    [sym_constant_pattern] = STATE(3952),
    [sym_parenthesized_pattern] = STATE(3952),
    [sym_var_pattern] = STATE(3952),
    [sym_type_pattern] = STATE(3952),
    [sym_list_pattern] = STATE(3952),
    [sym_recursive_pattern] = STATE(3952),
    [sym_positional_pattern_clause] = STATE(3102),
    [sym_property_pattern_clause] = STATE(3138),
    [sym_relational_pattern] = STATE(3952),
    [sym_negated_pattern] = STATE(3952),
    [sym_and_pattern] = STATE(3952),
    [sym_or_pattern] = STATE(3952),
    [sym_declaration_pattern] = STATE(3952),
    [sym_expression] = STATE(6680),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3993),
    [sym_postfix_unary_expression] = STATE(3997),
    [sym_prefix_unary_expression] = STATE(3997),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3993),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3997),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3993),
    [sym_member_access_expression] = STATE(3202),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3997),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3993),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3993),
    [sym_typeof_expression] = STATE(3993),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3202),
    [sym_literal] = STATE(3993),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2810),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(464),
    [sym_preproc_endregion] = STATE(464),
    [sym_preproc_line] = STATE(464),
    [sym_preproc_pragma] = STATE(464),
    [sym_preproc_nullable] = STATE(464),
    [sym_preproc_error] = STATE(464),
    [sym_preproc_define] = STATE(464),
    [sym_preproc_undef] = STATE(464),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(2283),
    [anon_sym_LPAREN] = ACTIONS(2547),
    [anon_sym_ref] = ACTIONS(2391),
    [anon_sym_LBRACE] = ACTIONS(2289),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(2549),
    [anon_sym_GT] = ACTIONS(2549),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1733),
    [anon_sym_TILDE] = ACTIONS(1733),
    [anon_sym_PLUS_PLUS] = ACTIONS(1733),
    [anon_sym_DASH_DASH] = ACTIONS(1733),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1731),
    [anon_sym_DASH] = ACTIONS(1731),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1733),
    [anon_sym_AMP] = ACTIONS(1733),
    [anon_sym_GT_EQ] = ACTIONS(2551),
    [anon_sym_LT_EQ] = ACTIONS(2551),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2295),
    [anon_sym_var] = ACTIONS(2543),
    [sym_predefined_type] = ACTIONS(2299),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(2301),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2553),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [465] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(3319),
    [sym_alias_qualified_name] = STATE(3430),
    [sym__simple_name] = STATE(2815),
    [sym_qualified_name] = STATE(3430),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(2965),
    [sym_implicit_type] = STATE(3403),
    [sym_array_type] = STATE(3434),
    [sym__array_base_type] = STATE(8808),
    [sym_nullable_type] = STATE(3435),
    [sym_pointer_type] = STATE(3435),
    [sym__pointer_base_type] = STATE(9626),
    [sym_function_pointer_type] = STATE(3435),
    [sym_ref_type] = STATE(3403),
    [sym_scoped_type] = STATE(3403),
    [sym_tuple_type] = STATE(3436),
    [sym_pattern] = STATE(5437),
    [sym_constant_pattern] = STATE(5385),
    [sym_parenthesized_pattern] = STATE(5385),
    [sym_var_pattern] = STATE(5385),
    [sym_type_pattern] = STATE(5385),
    [sym_list_pattern] = STATE(5385),
    [sym_recursive_pattern] = STATE(5385),
    [sym_positional_pattern_clause] = STATE(3053),
    [sym_property_pattern_clause] = STATE(3124),
    [sym_relational_pattern] = STATE(5385),
    [sym_negated_pattern] = STATE(5385),
    [sym_and_pattern] = STATE(5385),
    [sym_or_pattern] = STATE(5385),
    [sym_declaration_pattern] = STATE(5385),
    [sym_expression] = STATE(6658),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(5460),
    [sym_postfix_unary_expression] = STATE(5462),
    [sym_prefix_unary_expression] = STATE(5462),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(5460),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(5462),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(5460),
    [sym_member_access_expression] = STATE(3913),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(5462),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(5460),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(5460),
    [sym_typeof_expression] = STATE(5460),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3913),
    [sym_literal] = STATE(5460),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2776),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(465),
    [sym_preproc_endregion] = STATE(465),
    [sym_preproc_line] = STATE(465),
    [sym_preproc_pragma] = STATE(465),
    [sym_preproc_nullable] = STATE(465),
    [sym_preproc_error] = STATE(465),
    [sym_preproc_define] = STATE(465),
    [sym_preproc_undef] = STATE(465),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(2447),
    [anon_sym_LPAREN] = ACTIONS(2471),
    [anon_sym_ref] = ACTIONS(2451),
    [anon_sym_LBRACE] = ACTIONS(2453),
    [anon_sym_delegate] = ACTIONS(2455),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(2473),
    [anon_sym_GT] = ACTIONS(2473),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1447),
    [anon_sym_TILDE] = ACTIONS(1447),
    [anon_sym_PLUS_PLUS] = ACTIONS(1447),
    [anon_sym_DASH_DASH] = ACTIONS(1447),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1445),
    [anon_sym_DASH] = ACTIONS(1445),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1447),
    [anon_sym_AMP] = ACTIONS(1447),
    [anon_sym_GT_EQ] = ACTIONS(2475),
    [anon_sym_LT_EQ] = ACTIONS(2475),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2461),
    [anon_sym_var] = ACTIONS(2463),
    [sym_predefined_type] = ACTIONS(2465),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(2467),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2477),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
  },
  [466] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(2997),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2749),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(3033),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(2975),
    [sym__array_base_type] = STATE(8712),
    [sym_nullable_type] = STATE(2974),
    [sym_pointer_type] = STATE(2974),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(2974),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(2973),
    [sym_pattern] = STATE(4193),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(2842),
    [sym_property_pattern_clause] = STATE(2893),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6663),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(4290),
    [sym_postfix_unary_expression] = STATE(4294),
    [sym_prefix_unary_expression] = STATE(4294),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(4290),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(4294),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(4290),
    [sym_member_access_expression] = STATE(3277),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(4294),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(4290),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(4290),
    [sym_typeof_expression] = STATE(4290),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3277),
    [sym_literal] = STATE(4290),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2810),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(466),
    [sym_preproc_endregion] = STATE(466),
    [sym_preproc_line] = STATE(466),
    [sym_preproc_pragma] = STATE(466),
    [sym_preproc_nullable] = STATE(466),
    [sym_preproc_error] = STATE(466),
    [sym_preproc_define] = STATE(466),
    [sym_preproc_undef] = STATE(466),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(2511),
    [anon_sym_ref] = ACTIONS(2391),
    [anon_sym_LBRACE] = ACTIONS(2289),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(2513),
    [anon_sym_GT] = ACTIONS(2513),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1699),
    [anon_sym_TILDE] = ACTIONS(1699),
    [anon_sym_PLUS_PLUS] = ACTIONS(1699),
    [anon_sym_DASH_DASH] = ACTIONS(1699),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1697),
    [anon_sym_DASH] = ACTIONS(1697),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1699),
    [anon_sym_AMP] = ACTIONS(1699),
    [anon_sym_GT_EQ] = ACTIONS(2515),
    [anon_sym_LT_EQ] = ACTIONS(2515),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2295),
    [anon_sym_var] = ACTIONS(2393),
    [sym_predefined_type] = ACTIONS(2313),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2517),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [467] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(3178),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2749),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(2797),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(2975),
    [sym__array_base_type] = STATE(8712),
    [sym_nullable_type] = STATE(2974),
    [sym_pointer_type] = STATE(2974),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(2974),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(2973),
    [sym_pattern] = STATE(6375),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(2842),
    [sym_property_pattern_clause] = STATE(2893),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6690),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(4290),
    [sym_postfix_unary_expression] = STATE(4294),
    [sym_prefix_unary_expression] = STATE(4294),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(4290),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(4294),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(4290),
    [sym_member_access_expression] = STATE(3277),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(4294),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(4290),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(4290),
    [sym_typeof_expression] = STATE(4290),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3277),
    [sym_literal] = STATE(4290),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2762),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(467),
    [sym_preproc_endregion] = STATE(467),
    [sym_preproc_line] = STATE(467),
    [sym_preproc_pragma] = STATE(467),
    [sym_preproc_nullable] = STATE(467),
    [sym_preproc_error] = STATE(467),
    [sym_preproc_define] = STATE(467),
    [sym_preproc_undef] = STATE(467),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(2421),
    [anon_sym_ref] = ACTIONS(2375),
    [anon_sym_LBRACE] = ACTIONS(2289),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(2423),
    [anon_sym_GT] = ACTIONS(2423),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1551),
    [anon_sym_TILDE] = ACTIONS(1551),
    [anon_sym_PLUS_PLUS] = ACTIONS(1551),
    [anon_sym_DASH_DASH] = ACTIONS(1551),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1549),
    [anon_sym_DASH] = ACTIONS(1549),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1551),
    [anon_sym_AMP] = ACTIONS(1551),
    [anon_sym_GT_EQ] = ACTIONS(2425),
    [anon_sym_LT_EQ] = ACTIONS(2425),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2381),
    [anon_sym_var] = ACTIONS(2311),
    [sym_predefined_type] = ACTIONS(2313),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2427),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [468] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(2992),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2747),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(3030),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(2975),
    [sym__array_base_type] = STATE(8712),
    [sym_nullable_type] = STATE(2974),
    [sym_pointer_type] = STATE(2974),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(2974),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(2973),
    [sym_pattern] = STATE(6197),
    [sym_constant_pattern] = STATE(3952),
    [sym_parenthesized_pattern] = STATE(3952),
    [sym_var_pattern] = STATE(3952),
    [sym_type_pattern] = STATE(3952),
    [sym_list_pattern] = STATE(3952),
    [sym_recursive_pattern] = STATE(3952),
    [sym_positional_pattern_clause] = STATE(2809),
    [sym_property_pattern_clause] = STATE(2851),
    [sym_relational_pattern] = STATE(3952),
    [sym_negated_pattern] = STATE(3952),
    [sym_and_pattern] = STATE(3952),
    [sym_or_pattern] = STATE(3952),
    [sym_declaration_pattern] = STATE(3952),
    [sym_expression] = STATE(6697),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3993),
    [sym_postfix_unary_expression] = STATE(3997),
    [sym_prefix_unary_expression] = STATE(3997),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3993),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3997),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3993),
    [sym_member_access_expression] = STATE(3202),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3997),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3993),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3993),
    [sym_typeof_expression] = STATE(3993),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3202),
    [sym_literal] = STATE(3993),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2810),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(468),
    [sym_preproc_endregion] = STATE(468),
    [sym_preproc_line] = STATE(468),
    [sym_preproc_pragma] = STATE(468),
    [sym_preproc_nullable] = STATE(468),
    [sym_preproc_error] = STATE(468),
    [sym_preproc_define] = STATE(468),
    [sym_preproc_undef] = STATE(468),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(2283),
    [anon_sym_LPAREN] = ACTIONS(2537),
    [anon_sym_ref] = ACTIONS(2391),
    [anon_sym_LBRACE] = ACTIONS(2289),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(2539),
    [anon_sym_GT] = ACTIONS(2539),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(1567),
    [anon_sym_PLUS_PLUS] = ACTIONS(1567),
    [anon_sym_DASH_DASH] = ACTIONS(1567),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1565),
    [anon_sym_DASH] = ACTIONS(1565),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1567),
    [anon_sym_AMP] = ACTIONS(1567),
    [anon_sym_GT_EQ] = ACTIONS(2541),
    [anon_sym_LT_EQ] = ACTIONS(2541),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2295),
    [anon_sym_var] = ACTIONS(2543),
    [sym_predefined_type] = ACTIONS(2299),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(2301),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2545),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [469] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6727),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2839),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6146),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_pattern] = STATE(8303),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(6657),
    [sym_property_pattern_clause] = STATE(6741),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6659),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(5071),
    [sym_postfix_unary_expression] = STATE(5061),
    [sym_prefix_unary_expression] = STATE(5061),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(5071),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(5061),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(5071),
    [sym_member_access_expression] = STATE(3775),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(5061),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(5071),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(5071),
    [sym_typeof_expression] = STATE(5071),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3775),
    [sym_literal] = STATE(5071),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(469),
    [sym_preproc_endregion] = STATE(469),
    [sym_preproc_line] = STATE(469),
    [sym_preproc_pragma] = STATE(469),
    [sym_preproc_nullable] = STATE(469),
    [sym_preproc_error] = STATE(469),
    [sym_preproc_define] = STATE(469),
    [sym_preproc_undef] = STATE(469),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_ref] = ACTIONS(1925),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(1929),
    [anon_sym_GT] = ACTIONS(1929),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1749),
    [anon_sym_TILDE] = ACTIONS(1749),
    [anon_sym_PLUS_PLUS] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1749),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1747),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1749),
    [anon_sym_AMP] = ACTIONS(1749),
    [anon_sym_GT_EQ] = ACTIONS(1931),
    [anon_sym_LT_EQ] = ACTIONS(1931),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1065),
    [anon_sym_var] = ACTIONS(1933),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(1935),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [470] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(3538),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2876),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(3066),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(2975),
    [sym__array_base_type] = STATE(8712),
    [sym_nullable_type] = STATE(2974),
    [sym_pointer_type] = STATE(2974),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(2974),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(2973),
    [sym_pattern] = STATE(6640),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(3151),
    [sym_property_pattern_clause] = STATE(3386),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6675),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(4290),
    [sym_postfix_unary_expression] = STATE(4294),
    [sym_prefix_unary_expression] = STATE(4294),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(4290),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(4294),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(4290),
    [sym_member_access_expression] = STATE(3277),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(4294),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(4290),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(4290),
    [sym_typeof_expression] = STATE(4290),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3277),
    [sym_literal] = STATE(4290),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2742),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(470),
    [sym_preproc_endregion] = STATE(470),
    [sym_preproc_line] = STATE(470),
    [sym_preproc_pragma] = STATE(470),
    [sym_preproc_nullable] = STATE(470),
    [sym_preproc_error] = STATE(470),
    [sym_preproc_define] = STATE(470),
    [sym_preproc_undef] = STATE(470),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(2529),
    [anon_sym_ref] = ACTIONS(2287),
    [anon_sym_LBRACE] = ACTIONS(2289),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(2531),
    [anon_sym_GT] = ACTIONS(2531),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1821),
    [anon_sym_TILDE] = ACTIONS(1821),
    [anon_sym_PLUS_PLUS] = ACTIONS(1821),
    [anon_sym_DASH_DASH] = ACTIONS(1821),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1819),
    [anon_sym_DASH] = ACTIONS(1819),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1821),
    [anon_sym_AMP] = ACTIONS(1821),
    [anon_sym_GT_EQ] = ACTIONS(2533),
    [anon_sym_LT_EQ] = ACTIONS(2533),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2295),
    [anon_sym_var] = ACTIONS(2311),
    [sym_predefined_type] = ACTIONS(2313),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2535),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [471] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(3531),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2870),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(3057),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(2975),
    [sym__array_base_type] = STATE(8712),
    [sym_nullable_type] = STATE(2974),
    [sym_pointer_type] = STATE(2974),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(2974),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(2973),
    [sym_pattern] = STATE(4992),
    [sym_constant_pattern] = STATE(4988),
    [sym_parenthesized_pattern] = STATE(4988),
    [sym_var_pattern] = STATE(4988),
    [sym_type_pattern] = STATE(4988),
    [sym_list_pattern] = STATE(4988),
    [sym_recursive_pattern] = STATE(4988),
    [sym_positional_pattern_clause] = STATE(3131),
    [sym_property_pattern_clause] = STATE(3344),
    [sym_relational_pattern] = STATE(4988),
    [sym_negated_pattern] = STATE(4988),
    [sym_and_pattern] = STATE(4988),
    [sym_or_pattern] = STATE(4988),
    [sym_declaration_pattern] = STATE(4988),
    [sym_expression] = STATE(6711),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(4995),
    [sym_postfix_unary_expression] = STATE(4994),
    [sym_prefix_unary_expression] = STATE(4994),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(4995),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(4994),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(4995),
    [sym_member_access_expression] = STATE(3744),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(4994),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(4995),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(4995),
    [sym_typeof_expression] = STATE(4995),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3744),
    [sym_literal] = STATE(4995),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2742),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(471),
    [sym_preproc_endregion] = STATE(471),
    [sym_preproc_line] = STATE(471),
    [sym_preproc_pragma] = STATE(471),
    [sym_preproc_nullable] = STATE(471),
    [sym_preproc_error] = STATE(471),
    [sym_preproc_define] = STATE(471),
    [sym_preproc_undef] = STATE(471),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(2495),
    [anon_sym_LPAREN] = ACTIONS(2497),
    [anon_sym_ref] = ACTIONS(2287),
    [anon_sym_LBRACE] = ACTIONS(2289),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(2499),
    [anon_sym_GT] = ACTIONS(2499),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1857),
    [anon_sym_TILDE] = ACTIONS(1857),
    [anon_sym_PLUS_PLUS] = ACTIONS(1857),
    [anon_sym_DASH_DASH] = ACTIONS(1857),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1855),
    [anon_sym_DASH] = ACTIONS(1855),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1857),
    [anon_sym_AMP] = ACTIONS(1857),
    [anon_sym_GT_EQ] = ACTIONS(2501),
    [anon_sym_LT_EQ] = ACTIONS(2501),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2295),
    [anon_sym_var] = ACTIONS(2503),
    [sym_predefined_type] = ACTIONS(2505),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(2507),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2509),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [472] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(3531),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2870),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(3057),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(2975),
    [sym__array_base_type] = STATE(8712),
    [sym_nullable_type] = STATE(2974),
    [sym_pointer_type] = STATE(2974),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(2974),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(2973),
    [sym_pattern] = STATE(4985),
    [sym_constant_pattern] = STATE(4988),
    [sym_parenthesized_pattern] = STATE(4988),
    [sym_var_pattern] = STATE(4988),
    [sym_type_pattern] = STATE(4988),
    [sym_list_pattern] = STATE(4988),
    [sym_recursive_pattern] = STATE(4988),
    [sym_positional_pattern_clause] = STATE(3131),
    [sym_property_pattern_clause] = STATE(3344),
    [sym_relational_pattern] = STATE(4988),
    [sym_negated_pattern] = STATE(4988),
    [sym_and_pattern] = STATE(4988),
    [sym_or_pattern] = STATE(4988),
    [sym_declaration_pattern] = STATE(4988),
    [sym_expression] = STATE(6711),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(4995),
    [sym_postfix_unary_expression] = STATE(4994),
    [sym_prefix_unary_expression] = STATE(4994),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(4995),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(4994),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(4995),
    [sym_member_access_expression] = STATE(3744),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(4994),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(4995),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(4995),
    [sym_typeof_expression] = STATE(4995),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3744),
    [sym_literal] = STATE(4995),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2742),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(472),
    [sym_preproc_endregion] = STATE(472),
    [sym_preproc_line] = STATE(472),
    [sym_preproc_pragma] = STATE(472),
    [sym_preproc_nullable] = STATE(472),
    [sym_preproc_error] = STATE(472),
    [sym_preproc_define] = STATE(472),
    [sym_preproc_undef] = STATE(472),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(2495),
    [anon_sym_LPAREN] = ACTIONS(2497),
    [anon_sym_ref] = ACTIONS(2287),
    [anon_sym_LBRACE] = ACTIONS(2289),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(2499),
    [anon_sym_GT] = ACTIONS(2499),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1857),
    [anon_sym_TILDE] = ACTIONS(1857),
    [anon_sym_PLUS_PLUS] = ACTIONS(1857),
    [anon_sym_DASH_DASH] = ACTIONS(1857),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1855),
    [anon_sym_DASH] = ACTIONS(1855),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1857),
    [anon_sym_AMP] = ACTIONS(1857),
    [anon_sym_GT_EQ] = ACTIONS(2501),
    [anon_sym_LT_EQ] = ACTIONS(2501),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2295),
    [anon_sym_var] = ACTIONS(2503),
    [sym_predefined_type] = ACTIONS(2505),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(2507),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2509),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [473] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(3531),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2870),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(3057),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(2975),
    [sym__array_base_type] = STATE(8712),
    [sym_nullable_type] = STATE(2974),
    [sym_pointer_type] = STATE(2974),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(2974),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(2973),
    [sym_pattern] = STATE(4982),
    [sym_constant_pattern] = STATE(4988),
    [sym_parenthesized_pattern] = STATE(4988),
    [sym_var_pattern] = STATE(4988),
    [sym_type_pattern] = STATE(4988),
    [sym_list_pattern] = STATE(4988),
    [sym_recursive_pattern] = STATE(4988),
    [sym_positional_pattern_clause] = STATE(3131),
    [sym_property_pattern_clause] = STATE(3344),
    [sym_relational_pattern] = STATE(4988),
    [sym_negated_pattern] = STATE(4988),
    [sym_and_pattern] = STATE(4988),
    [sym_or_pattern] = STATE(4988),
    [sym_declaration_pattern] = STATE(4988),
    [sym_expression] = STATE(6711),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(4995),
    [sym_postfix_unary_expression] = STATE(4994),
    [sym_prefix_unary_expression] = STATE(4994),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(4995),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(4994),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(4995),
    [sym_member_access_expression] = STATE(3744),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(4994),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(4995),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(4995),
    [sym_typeof_expression] = STATE(4995),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3744),
    [sym_literal] = STATE(4995),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2742),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(473),
    [sym_preproc_endregion] = STATE(473),
    [sym_preproc_line] = STATE(473),
    [sym_preproc_pragma] = STATE(473),
    [sym_preproc_nullable] = STATE(473),
    [sym_preproc_error] = STATE(473),
    [sym_preproc_define] = STATE(473),
    [sym_preproc_undef] = STATE(473),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(2495),
    [anon_sym_LPAREN] = ACTIONS(2497),
    [anon_sym_ref] = ACTIONS(2287),
    [anon_sym_LBRACE] = ACTIONS(2289),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(2499),
    [anon_sym_GT] = ACTIONS(2499),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1857),
    [anon_sym_TILDE] = ACTIONS(1857),
    [anon_sym_PLUS_PLUS] = ACTIONS(1857),
    [anon_sym_DASH_DASH] = ACTIONS(1857),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1855),
    [anon_sym_DASH] = ACTIONS(1855),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1857),
    [anon_sym_AMP] = ACTIONS(1857),
    [anon_sym_GT_EQ] = ACTIONS(2501),
    [anon_sym_LT_EQ] = ACTIONS(2501),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2295),
    [anon_sym_var] = ACTIONS(2503),
    [sym_predefined_type] = ACTIONS(2505),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(2507),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2509),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [474] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(2997),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2749),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(3044),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(2975),
    [sym__array_base_type] = STATE(8712),
    [sym_nullable_type] = STATE(2974),
    [sym_pointer_type] = STATE(2974),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(2974),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(2973),
    [sym_pattern] = STATE(6514),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(2842),
    [sym_property_pattern_clause] = STATE(2893),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6663),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(4290),
    [sym_postfix_unary_expression] = STATE(4294),
    [sym_prefix_unary_expression] = STATE(4294),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(4290),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(4294),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(4290),
    [sym_member_access_expression] = STATE(3277),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(4294),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(4290),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(4290),
    [sym_typeof_expression] = STATE(4290),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3277),
    [sym_literal] = STATE(4290),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2810),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(474),
    [sym_preproc_endregion] = STATE(474),
    [sym_preproc_line] = STATE(474),
    [sym_preproc_pragma] = STATE(474),
    [sym_preproc_nullable] = STATE(474),
    [sym_preproc_error] = STATE(474),
    [sym_preproc_define] = STATE(474),
    [sym_preproc_undef] = STATE(474),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(2511),
    [anon_sym_ref] = ACTIONS(2391),
    [anon_sym_LBRACE] = ACTIONS(2289),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(2513),
    [anon_sym_GT] = ACTIONS(2513),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1699),
    [anon_sym_TILDE] = ACTIONS(1699),
    [anon_sym_PLUS_PLUS] = ACTIONS(1699),
    [anon_sym_DASH_DASH] = ACTIONS(1699),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1697),
    [anon_sym_DASH] = ACTIONS(1697),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1699),
    [anon_sym_AMP] = ACTIONS(1699),
    [anon_sym_GT_EQ] = ACTIONS(2515),
    [anon_sym_LT_EQ] = ACTIONS(2515),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2295),
    [anon_sym_var] = ACTIONS(2393),
    [sym_predefined_type] = ACTIONS(2313),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2517),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [475] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(3521),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2845),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(3019),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(2975),
    [sym__array_base_type] = STATE(8712),
    [sym_nullable_type] = STATE(2974),
    [sym_pointer_type] = STATE(2974),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(2974),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(2973),
    [sym_pattern] = STATE(5974),
    [sym_constant_pattern] = STATE(3952),
    [sym_parenthesized_pattern] = STATE(3952),
    [sym_var_pattern] = STATE(3952),
    [sym_type_pattern] = STATE(3952),
    [sym_list_pattern] = STATE(3952),
    [sym_recursive_pattern] = STATE(3952),
    [sym_positional_pattern_clause] = STATE(3102),
    [sym_property_pattern_clause] = STATE(3138),
    [sym_relational_pattern] = STATE(3952),
    [sym_negated_pattern] = STATE(3952),
    [sym_and_pattern] = STATE(3952),
    [sym_or_pattern] = STATE(3952),
    [sym_declaration_pattern] = STATE(3952),
    [sym_expression] = STATE(6680),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3993),
    [sym_postfix_unary_expression] = STATE(3997),
    [sym_prefix_unary_expression] = STATE(3997),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3993),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3997),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3993),
    [sym_member_access_expression] = STATE(3202),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3997),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3993),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3993),
    [sym_typeof_expression] = STATE(3993),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3202),
    [sym_literal] = STATE(3993),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2810),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(475),
    [sym_preproc_endregion] = STATE(475),
    [sym_preproc_line] = STATE(475),
    [sym_preproc_pragma] = STATE(475),
    [sym_preproc_nullable] = STATE(475),
    [sym_preproc_error] = STATE(475),
    [sym_preproc_define] = STATE(475),
    [sym_preproc_undef] = STATE(475),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(2283),
    [anon_sym_LPAREN] = ACTIONS(2547),
    [anon_sym_ref] = ACTIONS(2391),
    [anon_sym_LBRACE] = ACTIONS(2289),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(2549),
    [anon_sym_GT] = ACTIONS(2549),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1733),
    [anon_sym_TILDE] = ACTIONS(1733),
    [anon_sym_PLUS_PLUS] = ACTIONS(1733),
    [anon_sym_DASH_DASH] = ACTIONS(1733),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1731),
    [anon_sym_DASH] = ACTIONS(1731),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1733),
    [anon_sym_AMP] = ACTIONS(1733),
    [anon_sym_GT_EQ] = ACTIONS(2551),
    [anon_sym_LT_EQ] = ACTIONS(2551),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2295),
    [anon_sym_var] = ACTIONS(2543),
    [sym_predefined_type] = ACTIONS(2299),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(2301),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2553),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [476] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(3524),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2867),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(3029),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(2975),
    [sym__array_base_type] = STATE(8712),
    [sym_nullable_type] = STATE(2974),
    [sym_pointer_type] = STATE(2974),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(2974),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(2973),
    [sym_pattern] = STATE(4815),
    [sym_constant_pattern] = STATE(4709),
    [sym_parenthesized_pattern] = STATE(4709),
    [sym_var_pattern] = STATE(4709),
    [sym_type_pattern] = STATE(4709),
    [sym_list_pattern] = STATE(4709),
    [sym_recursive_pattern] = STATE(4709),
    [sym_positional_pattern_clause] = STATE(3123),
    [sym_property_pattern_clause] = STATE(3179),
    [sym_relational_pattern] = STATE(4709),
    [sym_negated_pattern] = STATE(4709),
    [sym_and_pattern] = STATE(4709),
    [sym_or_pattern] = STATE(4709),
    [sym_declaration_pattern] = STATE(4709),
    [sym_expression] = STATE(6707),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(4649),
    [sym_postfix_unary_expression] = STATE(4712),
    [sym_prefix_unary_expression] = STATE(4712),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(4649),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(4712),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(4649),
    [sym_member_access_expression] = STATE(3548),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(4712),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(4649),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(4649),
    [sym_typeof_expression] = STATE(4649),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3548),
    [sym_literal] = STATE(4649),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2742),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(476),
    [sym_preproc_endregion] = STATE(476),
    [sym_preproc_line] = STATE(476),
    [sym_preproc_pragma] = STATE(476),
    [sym_preproc_nullable] = STATE(476),
    [sym_preproc_error] = STATE(476),
    [sym_preproc_define] = STATE(476),
    [sym_preproc_undef] = STATE(476),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(2337),
    [anon_sym_LPAREN] = ACTIONS(2339),
    [anon_sym_ref] = ACTIONS(2287),
    [anon_sym_LBRACE] = ACTIONS(2289),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(2341),
    [anon_sym_GT] = ACTIONS(2341),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1621),
    [anon_sym_TILDE] = ACTIONS(1621),
    [anon_sym_PLUS_PLUS] = ACTIONS(1621),
    [anon_sym_DASH_DASH] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(1619),
    [anon_sym_DASH] = ACTIONS(1619),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1621),
    [anon_sym_AMP] = ACTIONS(1621),
    [anon_sym_GT_EQ] = ACTIONS(2343),
    [anon_sym_LT_EQ] = ACTIONS(2343),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2295),
    [anon_sym_var] = ACTIONS(2345),
    [sym_predefined_type] = ACTIONS(2347),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(2349),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2351),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [477] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(2997),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2749),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(2801),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(2975),
    [sym__array_base_type] = STATE(8712),
    [sym_nullable_type] = STATE(2974),
    [sym_pointer_type] = STATE(2974),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(2974),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(2973),
    [sym_pattern] = STATE(5421),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(2842),
    [sym_property_pattern_clause] = STATE(2893),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6710),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(4290),
    [sym_postfix_unary_expression] = STATE(4294),
    [sym_prefix_unary_expression] = STATE(4294),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(4290),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(4294),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(4290),
    [sym_member_access_expression] = STATE(3277),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(4294),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(4290),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(4290),
    [sym_typeof_expression] = STATE(4290),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3277),
    [sym_literal] = STATE(4290),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2742),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(477),
    [sym_preproc_endregion] = STATE(477),
    [sym_preproc_line] = STATE(477),
    [sym_preproc_pragma] = STATE(477),
    [sym_preproc_nullable] = STATE(477),
    [sym_preproc_error] = STATE(477),
    [sym_preproc_define] = STATE(477),
    [sym_preproc_undef] = STATE(477),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(2305),
    [anon_sym_ref] = ACTIONS(2287),
    [anon_sym_LBRACE] = ACTIONS(2289),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(2307),
    [anon_sym_GT] = ACTIONS(2307),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1357),
    [anon_sym_TILDE] = ACTIONS(1357),
    [anon_sym_PLUS_PLUS] = ACTIONS(1357),
    [anon_sym_DASH_DASH] = ACTIONS(1357),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1355),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1357),
    [anon_sym_AMP] = ACTIONS(1357),
    [anon_sym_GT_EQ] = ACTIONS(2309),
    [anon_sym_LT_EQ] = ACTIONS(2309),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2295),
    [anon_sym_var] = ACTIONS(2311),
    [sym_predefined_type] = ACTIONS(2313),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2315),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [478] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(2997),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2749),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(3044),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(2975),
    [sym__array_base_type] = STATE(8712),
    [sym_nullable_type] = STATE(2974),
    [sym_pointer_type] = STATE(2974),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(2974),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(2973),
    [sym_pattern] = STATE(4118),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(2842),
    [sym_property_pattern_clause] = STATE(2893),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6663),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(4290),
    [sym_postfix_unary_expression] = STATE(4294),
    [sym_prefix_unary_expression] = STATE(4294),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(4290),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(4294),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(4290),
    [sym_member_access_expression] = STATE(3277),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(4294),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(4290),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(4290),
    [sym_typeof_expression] = STATE(4290),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3277),
    [sym_literal] = STATE(4290),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2810),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(478),
    [sym_preproc_endregion] = STATE(478),
    [sym_preproc_line] = STATE(478),
    [sym_preproc_pragma] = STATE(478),
    [sym_preproc_nullable] = STATE(478),
    [sym_preproc_error] = STATE(478),
    [sym_preproc_define] = STATE(478),
    [sym_preproc_undef] = STATE(478),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(2511),
    [anon_sym_ref] = ACTIONS(2391),
    [anon_sym_LBRACE] = ACTIONS(2289),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(2513),
    [anon_sym_GT] = ACTIONS(2513),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1699),
    [anon_sym_TILDE] = ACTIONS(1699),
    [anon_sym_PLUS_PLUS] = ACTIONS(1699),
    [anon_sym_DASH_DASH] = ACTIONS(1699),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1697),
    [anon_sym_DASH] = ACTIONS(1697),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1699),
    [anon_sym_AMP] = ACTIONS(1699),
    [anon_sym_GT_EQ] = ACTIONS(2515),
    [anon_sym_LT_EQ] = ACTIONS(2515),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2295),
    [anon_sym_var] = ACTIONS(2393),
    [sym_predefined_type] = ACTIONS(2313),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2517),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [479] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(3521),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2845),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(3019),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(2975),
    [sym__array_base_type] = STATE(8712),
    [sym_nullable_type] = STATE(2974),
    [sym_pointer_type] = STATE(2974),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(2974),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(2973),
    [sym_pattern] = STATE(4059),
    [sym_constant_pattern] = STATE(3952),
    [sym_parenthesized_pattern] = STATE(3952),
    [sym_var_pattern] = STATE(3952),
    [sym_type_pattern] = STATE(3952),
    [sym_list_pattern] = STATE(3952),
    [sym_recursive_pattern] = STATE(3952),
    [sym_positional_pattern_clause] = STATE(3102),
    [sym_property_pattern_clause] = STATE(3138),
    [sym_relational_pattern] = STATE(3952),
    [sym_negated_pattern] = STATE(3952),
    [sym_and_pattern] = STATE(3952),
    [sym_or_pattern] = STATE(3952),
    [sym_declaration_pattern] = STATE(3952),
    [sym_expression] = STATE(6680),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3993),
    [sym_postfix_unary_expression] = STATE(3997),
    [sym_prefix_unary_expression] = STATE(3997),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3993),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3997),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3993),
    [sym_member_access_expression] = STATE(3202),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3997),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3993),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3993),
    [sym_typeof_expression] = STATE(3993),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3202),
    [sym_literal] = STATE(3993),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2810),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(479),
    [sym_preproc_endregion] = STATE(479),
    [sym_preproc_line] = STATE(479),
    [sym_preproc_pragma] = STATE(479),
    [sym_preproc_nullable] = STATE(479),
    [sym_preproc_error] = STATE(479),
    [sym_preproc_define] = STATE(479),
    [sym_preproc_undef] = STATE(479),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(2283),
    [anon_sym_LPAREN] = ACTIONS(2547),
    [anon_sym_ref] = ACTIONS(2391),
    [anon_sym_LBRACE] = ACTIONS(2289),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(2549),
    [anon_sym_GT] = ACTIONS(2549),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1733),
    [anon_sym_TILDE] = ACTIONS(1733),
    [anon_sym_PLUS_PLUS] = ACTIONS(1733),
    [anon_sym_DASH_DASH] = ACTIONS(1733),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1731),
    [anon_sym_DASH] = ACTIONS(1731),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1733),
    [anon_sym_AMP] = ACTIONS(1733),
    [anon_sym_GT_EQ] = ACTIONS(2551),
    [anon_sym_LT_EQ] = ACTIONS(2551),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2295),
    [anon_sym_var] = ACTIONS(2543),
    [sym_predefined_type] = ACTIONS(2299),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(2301),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2553),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [480] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(3538),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2876),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(3066),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(2975),
    [sym__array_base_type] = STATE(8712),
    [sym_nullable_type] = STATE(2974),
    [sym_pointer_type] = STATE(2974),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(2974),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(2973),
    [sym_pattern] = STATE(4118),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(3151),
    [sym_property_pattern_clause] = STATE(3386),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6675),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(4290),
    [sym_postfix_unary_expression] = STATE(4294),
    [sym_prefix_unary_expression] = STATE(4294),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(4290),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(4294),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(4290),
    [sym_member_access_expression] = STATE(3277),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(4294),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(4290),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(4290),
    [sym_typeof_expression] = STATE(4290),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3277),
    [sym_literal] = STATE(4290),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2742),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(480),
    [sym_preproc_endregion] = STATE(480),
    [sym_preproc_line] = STATE(480),
    [sym_preproc_pragma] = STATE(480),
    [sym_preproc_nullable] = STATE(480),
    [sym_preproc_error] = STATE(480),
    [sym_preproc_define] = STATE(480),
    [sym_preproc_undef] = STATE(480),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(2529),
    [anon_sym_ref] = ACTIONS(2287),
    [anon_sym_LBRACE] = ACTIONS(2289),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(2531),
    [anon_sym_GT] = ACTIONS(2531),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1821),
    [anon_sym_TILDE] = ACTIONS(1821),
    [anon_sym_PLUS_PLUS] = ACTIONS(1821),
    [anon_sym_DASH_DASH] = ACTIONS(1821),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1819),
    [anon_sym_DASH] = ACTIONS(1819),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1821),
    [anon_sym_AMP] = ACTIONS(1821),
    [anon_sym_GT_EQ] = ACTIONS(2533),
    [anon_sym_LT_EQ] = ACTIONS(2533),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2295),
    [anon_sym_var] = ACTIONS(2311),
    [sym_predefined_type] = ACTIONS(2313),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2535),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [481] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(3521),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2845),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(3019),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(2975),
    [sym__array_base_type] = STATE(8712),
    [sym_nullable_type] = STATE(2974),
    [sym_pointer_type] = STATE(2974),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(2974),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(2973),
    [sym_pattern] = STATE(5863),
    [sym_constant_pattern] = STATE(3952),
    [sym_parenthesized_pattern] = STATE(3952),
    [sym_var_pattern] = STATE(3952),
    [sym_type_pattern] = STATE(3952),
    [sym_list_pattern] = STATE(3952),
    [sym_recursive_pattern] = STATE(3952),
    [sym_positional_pattern_clause] = STATE(3102),
    [sym_property_pattern_clause] = STATE(3138),
    [sym_relational_pattern] = STATE(3952),
    [sym_negated_pattern] = STATE(3952),
    [sym_and_pattern] = STATE(3952),
    [sym_or_pattern] = STATE(3952),
    [sym_declaration_pattern] = STATE(3952),
    [sym_expression] = STATE(6680),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3993),
    [sym_postfix_unary_expression] = STATE(3997),
    [sym_prefix_unary_expression] = STATE(3997),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3993),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3997),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3993),
    [sym_member_access_expression] = STATE(3202),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3997),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3993),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3993),
    [sym_typeof_expression] = STATE(3993),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3202),
    [sym_literal] = STATE(3993),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2810),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(481),
    [sym_preproc_endregion] = STATE(481),
    [sym_preproc_line] = STATE(481),
    [sym_preproc_pragma] = STATE(481),
    [sym_preproc_nullable] = STATE(481),
    [sym_preproc_error] = STATE(481),
    [sym_preproc_define] = STATE(481),
    [sym_preproc_undef] = STATE(481),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(2283),
    [anon_sym_LPAREN] = ACTIONS(2547),
    [anon_sym_ref] = ACTIONS(2391),
    [anon_sym_LBRACE] = ACTIONS(2289),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(2549),
    [anon_sym_GT] = ACTIONS(2549),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1733),
    [anon_sym_TILDE] = ACTIONS(1733),
    [anon_sym_PLUS_PLUS] = ACTIONS(1733),
    [anon_sym_DASH_DASH] = ACTIONS(1733),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1731),
    [anon_sym_DASH] = ACTIONS(1731),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1733),
    [anon_sym_AMP] = ACTIONS(1733),
    [anon_sym_GT_EQ] = ACTIONS(2551),
    [anon_sym_LT_EQ] = ACTIONS(2551),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2295),
    [anon_sym_var] = ACTIONS(2543),
    [sym_predefined_type] = ACTIONS(2299),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(2301),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2553),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [482] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(3538),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2876),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(3066),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(2975),
    [sym__array_base_type] = STATE(8712),
    [sym_nullable_type] = STATE(2974),
    [sym_pointer_type] = STATE(2974),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(2974),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(2973),
    [sym_pattern] = STATE(6493),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(3151),
    [sym_property_pattern_clause] = STATE(3386),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6675),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(4290),
    [sym_postfix_unary_expression] = STATE(4294),
    [sym_prefix_unary_expression] = STATE(4294),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(4290),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(4294),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(4290),
    [sym_member_access_expression] = STATE(3277),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(4294),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(4290),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(4290),
    [sym_typeof_expression] = STATE(4290),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3277),
    [sym_literal] = STATE(4290),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2742),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(482),
    [sym_preproc_endregion] = STATE(482),
    [sym_preproc_line] = STATE(482),
    [sym_preproc_pragma] = STATE(482),
    [sym_preproc_nullable] = STATE(482),
    [sym_preproc_error] = STATE(482),
    [sym_preproc_define] = STATE(482),
    [sym_preproc_undef] = STATE(482),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(2529),
    [anon_sym_ref] = ACTIONS(2287),
    [anon_sym_LBRACE] = ACTIONS(2289),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(2531),
    [anon_sym_GT] = ACTIONS(2531),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1821),
    [anon_sym_TILDE] = ACTIONS(1821),
    [anon_sym_PLUS_PLUS] = ACTIONS(1821),
    [anon_sym_DASH_DASH] = ACTIONS(1821),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1819),
    [anon_sym_DASH] = ACTIONS(1819),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1821),
    [anon_sym_AMP] = ACTIONS(1821),
    [anon_sym_GT_EQ] = ACTIONS(2533),
    [anon_sym_LT_EQ] = ACTIONS(2533),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2295),
    [anon_sym_var] = ACTIONS(2311),
    [sym_predefined_type] = ACTIONS(2313),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2535),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [483] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(2992),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2747),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(3043),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(2975),
    [sym__array_base_type] = STATE(8712),
    [sym_nullable_type] = STATE(2974),
    [sym_pointer_type] = STATE(2974),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(2974),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(2973),
    [sym_pattern] = STATE(6093),
    [sym_constant_pattern] = STATE(3952),
    [sym_parenthesized_pattern] = STATE(3952),
    [sym_var_pattern] = STATE(3952),
    [sym_type_pattern] = STATE(3952),
    [sym_list_pattern] = STATE(3952),
    [sym_recursive_pattern] = STATE(3952),
    [sym_positional_pattern_clause] = STATE(2809),
    [sym_property_pattern_clause] = STATE(2851),
    [sym_relational_pattern] = STATE(3952),
    [sym_negated_pattern] = STATE(3952),
    [sym_and_pattern] = STATE(3952),
    [sym_or_pattern] = STATE(3952),
    [sym_declaration_pattern] = STATE(3952),
    [sym_expression] = STATE(6697),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3993),
    [sym_postfix_unary_expression] = STATE(3997),
    [sym_prefix_unary_expression] = STATE(3997),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3993),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3997),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3993),
    [sym_member_access_expression] = STATE(3202),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3997),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3993),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3993),
    [sym_typeof_expression] = STATE(3993),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3202),
    [sym_literal] = STATE(3993),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2810),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(483),
    [sym_preproc_endregion] = STATE(483),
    [sym_preproc_line] = STATE(483),
    [sym_preproc_pragma] = STATE(483),
    [sym_preproc_nullable] = STATE(483),
    [sym_preproc_error] = STATE(483),
    [sym_preproc_define] = STATE(483),
    [sym_preproc_undef] = STATE(483),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(2283),
    [anon_sym_LPAREN] = ACTIONS(2537),
    [anon_sym_ref] = ACTIONS(2391),
    [anon_sym_LBRACE] = ACTIONS(2289),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(2539),
    [anon_sym_GT] = ACTIONS(2539),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(1567),
    [anon_sym_PLUS_PLUS] = ACTIONS(1567),
    [anon_sym_DASH_DASH] = ACTIONS(1567),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1565),
    [anon_sym_DASH] = ACTIONS(1565),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1567),
    [anon_sym_AMP] = ACTIONS(1567),
    [anon_sym_GT_EQ] = ACTIONS(2541),
    [anon_sym_LT_EQ] = ACTIONS(2541),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2295),
    [anon_sym_var] = ACTIONS(2543),
    [sym_predefined_type] = ACTIONS(2299),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(2301),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2545),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [484] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(2997),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2749),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(3044),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(2975),
    [sym__array_base_type] = STATE(8712),
    [sym_nullable_type] = STATE(2974),
    [sym_pointer_type] = STATE(2974),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(2974),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(2973),
    [sym_pattern] = STATE(6511),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(2842),
    [sym_property_pattern_clause] = STATE(2893),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6663),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(4290),
    [sym_postfix_unary_expression] = STATE(4294),
    [sym_prefix_unary_expression] = STATE(4294),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(4290),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(4294),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(4290),
    [sym_member_access_expression] = STATE(3277),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(4294),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(4290),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(4290),
    [sym_typeof_expression] = STATE(4290),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3277),
    [sym_literal] = STATE(4290),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2810),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(484),
    [sym_preproc_endregion] = STATE(484),
    [sym_preproc_line] = STATE(484),
    [sym_preproc_pragma] = STATE(484),
    [sym_preproc_nullable] = STATE(484),
    [sym_preproc_error] = STATE(484),
    [sym_preproc_define] = STATE(484),
    [sym_preproc_undef] = STATE(484),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(2511),
    [anon_sym_ref] = ACTIONS(2391),
    [anon_sym_LBRACE] = ACTIONS(2289),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(2513),
    [anon_sym_GT] = ACTIONS(2513),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1699),
    [anon_sym_TILDE] = ACTIONS(1699),
    [anon_sym_PLUS_PLUS] = ACTIONS(1699),
    [anon_sym_DASH_DASH] = ACTIONS(1699),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1697),
    [anon_sym_DASH] = ACTIONS(1697),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1699),
    [anon_sym_AMP] = ACTIONS(1699),
    [anon_sym_GT_EQ] = ACTIONS(2515),
    [anon_sym_LT_EQ] = ACTIONS(2515),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2295),
    [anon_sym_var] = ACTIONS(2393),
    [sym_predefined_type] = ACTIONS(2313),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2517),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [485] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(3319),
    [sym_alias_qualified_name] = STATE(3430),
    [sym__simple_name] = STATE(2815),
    [sym_qualified_name] = STATE(3430),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(2970),
    [sym_implicit_type] = STATE(3403),
    [sym_array_type] = STATE(3434),
    [sym__array_base_type] = STATE(8808),
    [sym_nullable_type] = STATE(3435),
    [sym_pointer_type] = STATE(3435),
    [sym__pointer_base_type] = STATE(9626),
    [sym_function_pointer_type] = STATE(3435),
    [sym_ref_type] = STATE(3403),
    [sym_scoped_type] = STATE(3403),
    [sym_tuple_type] = STATE(3436),
    [sym_pattern] = STATE(5515),
    [sym_constant_pattern] = STATE(5385),
    [sym_parenthesized_pattern] = STATE(5385),
    [sym_var_pattern] = STATE(5385),
    [sym_type_pattern] = STATE(5385),
    [sym_list_pattern] = STATE(5385),
    [sym_recursive_pattern] = STATE(5385),
    [sym_positional_pattern_clause] = STATE(3053),
    [sym_property_pattern_clause] = STATE(3124),
    [sym_relational_pattern] = STATE(5385),
    [sym_negated_pattern] = STATE(5385),
    [sym_and_pattern] = STATE(5385),
    [sym_or_pattern] = STATE(5385),
    [sym_declaration_pattern] = STATE(5385),
    [sym_expression] = STATE(6658),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(5460),
    [sym_postfix_unary_expression] = STATE(5462),
    [sym_prefix_unary_expression] = STATE(5462),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(5460),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(5462),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(5460),
    [sym_member_access_expression] = STATE(3913),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(5462),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(5460),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(5460),
    [sym_typeof_expression] = STATE(5460),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3913),
    [sym_literal] = STATE(5460),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2776),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(485),
    [sym_preproc_endregion] = STATE(485),
    [sym_preproc_line] = STATE(485),
    [sym_preproc_pragma] = STATE(485),
    [sym_preproc_nullable] = STATE(485),
    [sym_preproc_error] = STATE(485),
    [sym_preproc_define] = STATE(485),
    [sym_preproc_undef] = STATE(485),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(2447),
    [anon_sym_LPAREN] = ACTIONS(2471),
    [anon_sym_ref] = ACTIONS(2451),
    [anon_sym_LBRACE] = ACTIONS(2453),
    [anon_sym_delegate] = ACTIONS(2455),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(2473),
    [anon_sym_GT] = ACTIONS(2473),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1447),
    [anon_sym_TILDE] = ACTIONS(1447),
    [anon_sym_PLUS_PLUS] = ACTIONS(1447),
    [anon_sym_DASH_DASH] = ACTIONS(1447),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1445),
    [anon_sym_DASH] = ACTIONS(1445),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1447),
    [anon_sym_AMP] = ACTIONS(1447),
    [anon_sym_GT_EQ] = ACTIONS(2475),
    [anon_sym_LT_EQ] = ACTIONS(2475),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2461),
    [anon_sym_var] = ACTIONS(2463),
    [sym_predefined_type] = ACTIONS(2465),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(2467),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2477),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
  },
  [486] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(3319),
    [sym_alias_qualified_name] = STATE(3430),
    [sym__simple_name] = STATE(2815),
    [sym_qualified_name] = STATE(3430),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(2970),
    [sym_implicit_type] = STATE(3403),
    [sym_array_type] = STATE(3434),
    [sym__array_base_type] = STATE(8808),
    [sym_nullable_type] = STATE(3435),
    [sym_pointer_type] = STATE(3435),
    [sym__pointer_base_type] = STATE(9626),
    [sym_function_pointer_type] = STATE(3435),
    [sym_ref_type] = STATE(3403),
    [sym_scoped_type] = STATE(3403),
    [sym_tuple_type] = STATE(3436),
    [sym_pattern] = STATE(5412),
    [sym_constant_pattern] = STATE(5385),
    [sym_parenthesized_pattern] = STATE(5385),
    [sym_var_pattern] = STATE(5385),
    [sym_type_pattern] = STATE(5385),
    [sym_list_pattern] = STATE(5385),
    [sym_recursive_pattern] = STATE(5385),
    [sym_positional_pattern_clause] = STATE(3053),
    [sym_property_pattern_clause] = STATE(3124),
    [sym_relational_pattern] = STATE(5385),
    [sym_negated_pattern] = STATE(5385),
    [sym_and_pattern] = STATE(5385),
    [sym_or_pattern] = STATE(5385),
    [sym_declaration_pattern] = STATE(5385),
    [sym_expression] = STATE(6658),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(5460),
    [sym_postfix_unary_expression] = STATE(5462),
    [sym_prefix_unary_expression] = STATE(5462),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(5460),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(5462),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(5460),
    [sym_member_access_expression] = STATE(3913),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(5462),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(5460),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(5460),
    [sym_typeof_expression] = STATE(5460),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3913),
    [sym_literal] = STATE(5460),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2776),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(486),
    [sym_preproc_endregion] = STATE(486),
    [sym_preproc_line] = STATE(486),
    [sym_preproc_pragma] = STATE(486),
    [sym_preproc_nullable] = STATE(486),
    [sym_preproc_error] = STATE(486),
    [sym_preproc_define] = STATE(486),
    [sym_preproc_undef] = STATE(486),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(2447),
    [anon_sym_LPAREN] = ACTIONS(2471),
    [anon_sym_ref] = ACTIONS(2451),
    [anon_sym_LBRACE] = ACTIONS(2453),
    [anon_sym_delegate] = ACTIONS(2455),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(2473),
    [anon_sym_GT] = ACTIONS(2473),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1447),
    [anon_sym_TILDE] = ACTIONS(1447),
    [anon_sym_PLUS_PLUS] = ACTIONS(1447),
    [anon_sym_DASH_DASH] = ACTIONS(1447),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1445),
    [anon_sym_DASH] = ACTIONS(1445),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1447),
    [anon_sym_AMP] = ACTIONS(1447),
    [anon_sym_GT_EQ] = ACTIONS(2475),
    [anon_sym_LT_EQ] = ACTIONS(2475),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2461),
    [anon_sym_var] = ACTIONS(2463),
    [sym_predefined_type] = ACTIONS(2465),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(2467),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2477),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
  },
  [487] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(3319),
    [sym_alias_qualified_name] = STATE(3430),
    [sym__simple_name] = STATE(2815),
    [sym_qualified_name] = STATE(3430),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(2970),
    [sym_implicit_type] = STATE(3403),
    [sym_array_type] = STATE(3434),
    [sym__array_base_type] = STATE(8808),
    [sym_nullable_type] = STATE(3435),
    [sym_pointer_type] = STATE(3435),
    [sym__pointer_base_type] = STATE(9626),
    [sym_function_pointer_type] = STATE(3435),
    [sym_ref_type] = STATE(3403),
    [sym_scoped_type] = STATE(3403),
    [sym_tuple_type] = STATE(3436),
    [sym_pattern] = STATE(5439),
    [sym_constant_pattern] = STATE(5385),
    [sym_parenthesized_pattern] = STATE(5385),
    [sym_var_pattern] = STATE(5385),
    [sym_type_pattern] = STATE(5385),
    [sym_list_pattern] = STATE(5385),
    [sym_recursive_pattern] = STATE(5385),
    [sym_positional_pattern_clause] = STATE(3053),
    [sym_property_pattern_clause] = STATE(3124),
    [sym_relational_pattern] = STATE(5385),
    [sym_negated_pattern] = STATE(5385),
    [sym_and_pattern] = STATE(5385),
    [sym_or_pattern] = STATE(5385),
    [sym_declaration_pattern] = STATE(5385),
    [sym_expression] = STATE(6658),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(5460),
    [sym_postfix_unary_expression] = STATE(5462),
    [sym_prefix_unary_expression] = STATE(5462),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(5460),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(5462),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(5460),
    [sym_member_access_expression] = STATE(3913),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(5462),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(5460),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(5460),
    [sym_typeof_expression] = STATE(5460),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3913),
    [sym_literal] = STATE(5460),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2776),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(487),
    [sym_preproc_endregion] = STATE(487),
    [sym_preproc_line] = STATE(487),
    [sym_preproc_pragma] = STATE(487),
    [sym_preproc_nullable] = STATE(487),
    [sym_preproc_error] = STATE(487),
    [sym_preproc_define] = STATE(487),
    [sym_preproc_undef] = STATE(487),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(2447),
    [anon_sym_LPAREN] = ACTIONS(2471),
    [anon_sym_ref] = ACTIONS(2451),
    [anon_sym_LBRACE] = ACTIONS(2453),
    [anon_sym_delegate] = ACTIONS(2455),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(2473),
    [anon_sym_GT] = ACTIONS(2473),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1447),
    [anon_sym_TILDE] = ACTIONS(1447),
    [anon_sym_PLUS_PLUS] = ACTIONS(1447),
    [anon_sym_DASH_DASH] = ACTIONS(1447),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1445),
    [anon_sym_DASH] = ACTIONS(1445),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1447),
    [anon_sym_AMP] = ACTIONS(1447),
    [anon_sym_GT_EQ] = ACTIONS(2475),
    [anon_sym_LT_EQ] = ACTIONS(2475),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2461),
    [anon_sym_var] = ACTIONS(2463),
    [sym_predefined_type] = ACTIONS(2465),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(2467),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2477),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
  },
  [488] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(3178),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2749),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(2801),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(2975),
    [sym__array_base_type] = STATE(8712),
    [sym_nullable_type] = STATE(2974),
    [sym_pointer_type] = STATE(2974),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(2974),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(2973),
    [sym_pattern] = STATE(5686),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(2842),
    [sym_property_pattern_clause] = STATE(2893),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6689),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(4290),
    [sym_postfix_unary_expression] = STATE(4294),
    [sym_prefix_unary_expression] = STATE(4294),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(4290),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(4294),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(4290),
    [sym_member_access_expression] = STATE(3277),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(4294),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(4290),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(4290),
    [sym_typeof_expression] = STATE(4290),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3277),
    [sym_literal] = STATE(4290),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2762),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(488),
    [sym_preproc_endregion] = STATE(488),
    [sym_preproc_line] = STATE(488),
    [sym_preproc_pragma] = STATE(488),
    [sym_preproc_nullable] = STATE(488),
    [sym_preproc_error] = STATE(488),
    [sym_preproc_define] = STATE(488),
    [sym_preproc_undef] = STATE(488),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(2479),
    [anon_sym_ref] = ACTIONS(2375),
    [anon_sym_LBRACE] = ACTIONS(2289),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_GT] = ACTIONS(2481),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1097),
    [anon_sym_TILDE] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1099),
    [anon_sym_DASH] = ACTIONS(1099),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1097),
    [anon_sym_GT_EQ] = ACTIONS(2483),
    [anon_sym_LT_EQ] = ACTIONS(2483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2381),
    [anon_sym_var] = ACTIONS(2311),
    [sym_predefined_type] = ACTIONS(2313),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2485),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [489] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(3541),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2878),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(3048),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(2975),
    [sym__array_base_type] = STATE(8712),
    [sym_nullable_type] = STATE(2974),
    [sym_pointer_type] = STATE(2974),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(2974),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(2973),
    [sym_pattern] = STATE(4974),
    [sym_constant_pattern] = STATE(4988),
    [sym_parenthesized_pattern] = STATE(4988),
    [sym_var_pattern] = STATE(4988),
    [sym_type_pattern] = STATE(4988),
    [sym_list_pattern] = STATE(4988),
    [sym_recursive_pattern] = STATE(4988),
    [sym_positional_pattern_clause] = STATE(3139),
    [sym_property_pattern_clause] = STATE(3239),
    [sym_relational_pattern] = STATE(4988),
    [sym_negated_pattern] = STATE(4988),
    [sym_and_pattern] = STATE(4988),
    [sym_or_pattern] = STATE(4988),
    [sym_declaration_pattern] = STATE(4988),
    [sym_expression] = STATE(6683),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(4995),
    [sym_postfix_unary_expression] = STATE(4994),
    [sym_prefix_unary_expression] = STATE(4994),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(4995),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(4994),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(4995),
    [sym_member_access_expression] = STATE(3744),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(4994),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(4995),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(4995),
    [sym_typeof_expression] = STATE(4995),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3744),
    [sym_literal] = STATE(4995),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2742),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(489),
    [sym_preproc_endregion] = STATE(489),
    [sym_preproc_line] = STATE(489),
    [sym_preproc_pragma] = STATE(489),
    [sym_preproc_nullable] = STATE(489),
    [sym_preproc_error] = STATE(489),
    [sym_preproc_define] = STATE(489),
    [sym_preproc_undef] = STATE(489),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(2495),
    [anon_sym_LPAREN] = ACTIONS(2519),
    [anon_sym_ref] = ACTIONS(2287),
    [anon_sym_LBRACE] = ACTIONS(2289),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(2521),
    [anon_sym_GT] = ACTIONS(2521),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1803),
    [anon_sym_TILDE] = ACTIONS(1803),
    [anon_sym_PLUS_PLUS] = ACTIONS(1803),
    [anon_sym_DASH_DASH] = ACTIONS(1803),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1801),
    [anon_sym_DASH] = ACTIONS(1801),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1803),
    [anon_sym_AMP] = ACTIONS(1803),
    [anon_sym_GT_EQ] = ACTIONS(2523),
    [anon_sym_LT_EQ] = ACTIONS(2523),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2295),
    [anon_sym_var] = ACTIONS(2525),
    [sym_predefined_type] = ACTIONS(2505),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(2507),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2527),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [490] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(3523),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2847),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(3034),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(2975),
    [sym__array_base_type] = STATE(8712),
    [sym_nullable_type] = STATE(2974),
    [sym_pointer_type] = STATE(2974),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(2974),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(2973),
    [sym_pattern] = STATE(6104),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(3081),
    [sym_property_pattern_clause] = STATE(3148),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6659),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(4290),
    [sym_postfix_unary_expression] = STATE(4294),
    [sym_prefix_unary_expression] = STATE(4294),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(4290),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(4294),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(4290),
    [sym_member_access_expression] = STATE(3277),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(4294),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(4290),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(4290),
    [sym_typeof_expression] = STATE(4290),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3277),
    [sym_literal] = STATE(4290),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2810),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(490),
    [sym_preproc_endregion] = STATE(490),
    [sym_preproc_line] = STATE(490),
    [sym_preproc_pragma] = STATE(490),
    [sym_preproc_nullable] = STATE(490),
    [sym_preproc_error] = STATE(490),
    [sym_preproc_define] = STATE(490),
    [sym_preproc_undef] = STATE(490),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(2389),
    [anon_sym_ref] = ACTIONS(2391),
    [anon_sym_LBRACE] = ACTIONS(2289),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(1929),
    [anon_sym_GT] = ACTIONS(1929),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1749),
    [anon_sym_TILDE] = ACTIONS(1749),
    [anon_sym_PLUS_PLUS] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1749),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1747),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1749),
    [anon_sym_AMP] = ACTIONS(1749),
    [anon_sym_GT_EQ] = ACTIONS(1931),
    [anon_sym_LT_EQ] = ACTIONS(1931),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2295),
    [anon_sym_var] = ACTIONS(2393),
    [sym_predefined_type] = ACTIONS(2313),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2395),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [491] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2789),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(5318),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_pattern] = STATE(8282),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(6141),
    [sym_property_pattern_clause] = STATE(6672),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6667),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(5313),
    [sym_postfix_unary_expression] = STATE(5314),
    [sym_prefix_unary_expression] = STATE(5314),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(5313),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(5314),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(5313),
    [sym_member_access_expression] = STATE(3856),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(5314),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(5313),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(5313),
    [sym_typeof_expression] = STATE(5313),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3856),
    [sym_literal] = STATE(5313),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(491),
    [sym_preproc_endregion] = STATE(491),
    [sym_preproc_line] = STATE(491),
    [sym_preproc_pragma] = STATE(491),
    [sym_preproc_nullable] = STATE(491),
    [sym_preproc_error] = STATE(491),
    [sym_preproc_define] = STATE(491),
    [sym_preproc_undef] = STATE(491),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(1043),
    [anon_sym_ref] = ACTIONS(2429),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1053),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1059),
    [anon_sym_TILDE] = ACTIONS(1059),
    [anon_sym_PLUS_PLUS] = ACTIONS(1059),
    [anon_sym_DASH_DASH] = ACTIONS(1059),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1061),
    [anon_sym_DASH] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_GT_EQ] = ACTIONS(1063),
    [anon_sym_LT_EQ] = ACTIONS(1063),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2265),
    [anon_sym_var] = ACTIONS(1067),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(1117),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [492] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(3429),
    [sym_alias_qualified_name] = STATE(3430),
    [sym__simple_name] = STATE(2824),
    [sym_qualified_name] = STATE(3430),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(2946),
    [sym_implicit_type] = STATE(3403),
    [sym_array_type] = STATE(3434),
    [sym__array_base_type] = STATE(8808),
    [sym_nullable_type] = STATE(3435),
    [sym_pointer_type] = STATE(3435),
    [sym__pointer_base_type] = STATE(9626),
    [sym_function_pointer_type] = STATE(3435),
    [sym_ref_type] = STATE(3403),
    [sym_scoped_type] = STATE(3403),
    [sym_tuple_type] = STATE(3436),
    [sym_pattern] = STATE(6059),
    [sym_constant_pattern] = STATE(5385),
    [sym_parenthesized_pattern] = STATE(5385),
    [sym_var_pattern] = STATE(5385),
    [sym_type_pattern] = STATE(5385),
    [sym_list_pattern] = STATE(5385),
    [sym_recursive_pattern] = STATE(5385),
    [sym_positional_pattern_clause] = STATE(3070),
    [sym_property_pattern_clause] = STATE(3113),
    [sym_relational_pattern] = STATE(5385),
    [sym_negated_pattern] = STATE(5385),
    [sym_and_pattern] = STATE(5385),
    [sym_or_pattern] = STATE(5385),
    [sym_declaration_pattern] = STATE(5385),
    [sym_expression] = STATE(6674),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(5460),
    [sym_postfix_unary_expression] = STATE(5462),
    [sym_prefix_unary_expression] = STATE(5462),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(5460),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(5462),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(5460),
    [sym_member_access_expression] = STATE(3913),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(5462),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(5460),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(5460),
    [sym_typeof_expression] = STATE(5460),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3913),
    [sym_literal] = STATE(5460),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2776),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(492),
    [sym_preproc_endregion] = STATE(492),
    [sym_preproc_line] = STATE(492),
    [sym_preproc_pragma] = STATE(492),
    [sym_preproc_nullable] = STATE(492),
    [sym_preproc_error] = STATE(492),
    [sym_preproc_define] = STATE(492),
    [sym_preproc_undef] = STATE(492),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(2447),
    [anon_sym_LPAREN] = ACTIONS(2449),
    [anon_sym_ref] = ACTIONS(2451),
    [anon_sym_LBRACE] = ACTIONS(2453),
    [anon_sym_delegate] = ACTIONS(2455),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(2457),
    [anon_sym_GT] = ACTIONS(2457),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1387),
    [anon_sym_TILDE] = ACTIONS(1387),
    [anon_sym_PLUS_PLUS] = ACTIONS(1387),
    [anon_sym_DASH_DASH] = ACTIONS(1387),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1385),
    [anon_sym_DASH] = ACTIONS(1385),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1387),
    [anon_sym_AMP] = ACTIONS(1387),
    [anon_sym_GT_EQ] = ACTIONS(2459),
    [anon_sym_LT_EQ] = ACTIONS(2459),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2461),
    [anon_sym_var] = ACTIONS(2463),
    [sym_predefined_type] = ACTIONS(2465),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(2467),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2469),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
  },
  [493] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(3161),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2747),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(2785),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(2975),
    [sym__array_base_type] = STATE(8712),
    [sym_nullable_type] = STATE(2974),
    [sym_pointer_type] = STATE(2974),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(2974),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(2973),
    [sym_pattern] = STATE(5343),
    [sym_constant_pattern] = STATE(3952),
    [sym_parenthesized_pattern] = STATE(3952),
    [sym_var_pattern] = STATE(3952),
    [sym_type_pattern] = STATE(3952),
    [sym_list_pattern] = STATE(3952),
    [sym_recursive_pattern] = STATE(3952),
    [sym_positional_pattern_clause] = STATE(2809),
    [sym_property_pattern_clause] = STATE(2851),
    [sym_relational_pattern] = STATE(3952),
    [sym_negated_pattern] = STATE(3952),
    [sym_and_pattern] = STATE(3952),
    [sym_or_pattern] = STATE(3952),
    [sym_declaration_pattern] = STATE(3952),
    [sym_expression] = STATE(6704),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3993),
    [sym_postfix_unary_expression] = STATE(3997),
    [sym_prefix_unary_expression] = STATE(3997),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3993),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3997),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3993),
    [sym_member_access_expression] = STATE(3202),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3997),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3993),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3993),
    [sym_typeof_expression] = STATE(3993),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3202),
    [sym_literal] = STATE(3993),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2762),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(493),
    [sym_preproc_endregion] = STATE(493),
    [sym_preproc_line] = STATE(493),
    [sym_preproc_pragma] = STATE(493),
    [sym_preproc_nullable] = STATE(493),
    [sym_preproc_error] = STATE(493),
    [sym_preproc_define] = STATE(493),
    [sym_preproc_undef] = STATE(493),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(2283),
    [anon_sym_LPAREN] = ACTIONS(2373),
    [anon_sym_ref] = ACTIONS(2375),
    [anon_sym_LBRACE] = ACTIONS(2289),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(2377),
    [anon_sym_GT] = ACTIONS(2377),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1329),
    [anon_sym_TILDE] = ACTIONS(1329),
    [anon_sym_PLUS_PLUS] = ACTIONS(1329),
    [anon_sym_DASH_DASH] = ACTIONS(1329),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1327),
    [anon_sym_DASH] = ACTIONS(1327),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1329),
    [anon_sym_AMP] = ACTIONS(1329),
    [anon_sym_GT_EQ] = ACTIONS(2379),
    [anon_sym_LT_EQ] = ACTIONS(2379),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2381),
    [anon_sym_var] = ACTIONS(2297),
    [sym_predefined_type] = ACTIONS(2299),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(2301),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2383),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [494] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(3161),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2747),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(2785),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(2975),
    [sym__array_base_type] = STATE(8712),
    [sym_nullable_type] = STATE(2974),
    [sym_pointer_type] = STATE(2974),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(2974),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(2973),
    [sym_pattern] = STATE(4059),
    [sym_constant_pattern] = STATE(3952),
    [sym_parenthesized_pattern] = STATE(3952),
    [sym_var_pattern] = STATE(3952),
    [sym_type_pattern] = STATE(3952),
    [sym_list_pattern] = STATE(3952),
    [sym_recursive_pattern] = STATE(3952),
    [sym_positional_pattern_clause] = STATE(2809),
    [sym_property_pattern_clause] = STATE(2851),
    [sym_relational_pattern] = STATE(3952),
    [sym_negated_pattern] = STATE(3952),
    [sym_and_pattern] = STATE(3952),
    [sym_or_pattern] = STATE(3952),
    [sym_declaration_pattern] = STATE(3952),
    [sym_expression] = STATE(6704),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3993),
    [sym_postfix_unary_expression] = STATE(3997),
    [sym_prefix_unary_expression] = STATE(3997),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3993),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3997),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3993),
    [sym_member_access_expression] = STATE(3202),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3997),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3993),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3993),
    [sym_typeof_expression] = STATE(3993),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3202),
    [sym_literal] = STATE(3993),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2762),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(494),
    [sym_preproc_endregion] = STATE(494),
    [sym_preproc_line] = STATE(494),
    [sym_preproc_pragma] = STATE(494),
    [sym_preproc_nullable] = STATE(494),
    [sym_preproc_error] = STATE(494),
    [sym_preproc_define] = STATE(494),
    [sym_preproc_undef] = STATE(494),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(2283),
    [anon_sym_LPAREN] = ACTIONS(2373),
    [anon_sym_ref] = ACTIONS(2375),
    [anon_sym_LBRACE] = ACTIONS(2289),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(2377),
    [anon_sym_GT] = ACTIONS(2377),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1329),
    [anon_sym_TILDE] = ACTIONS(1329),
    [anon_sym_PLUS_PLUS] = ACTIONS(1329),
    [anon_sym_DASH_DASH] = ACTIONS(1329),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1327),
    [anon_sym_DASH] = ACTIONS(1327),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1329),
    [anon_sym_AMP] = ACTIONS(1329),
    [anon_sym_GT_EQ] = ACTIONS(2379),
    [anon_sym_LT_EQ] = ACTIONS(2379),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2381),
    [anon_sym_var] = ACTIONS(2297),
    [sym_predefined_type] = ACTIONS(2299),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(2301),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2383),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [495] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(3534),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2895),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(3049),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(2975),
    [sym__array_base_type] = STATE(8712),
    [sym_nullable_type] = STATE(2974),
    [sym_pointer_type] = STATE(2974),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(2974),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(2973),
    [sym_pattern] = STATE(4059),
    [sym_constant_pattern] = STATE(3952),
    [sym_parenthesized_pattern] = STATE(3952),
    [sym_var_pattern] = STATE(3952),
    [sym_type_pattern] = STATE(3952),
    [sym_list_pattern] = STATE(3952),
    [sym_recursive_pattern] = STATE(3952),
    [sym_positional_pattern_clause] = STATE(3153),
    [sym_property_pattern_clause] = STATE(3405),
    [sym_relational_pattern] = STATE(3952),
    [sym_negated_pattern] = STATE(3952),
    [sym_and_pattern] = STATE(3952),
    [sym_or_pattern] = STATE(3952),
    [sym_declaration_pattern] = STATE(3952),
    [sym_expression] = STATE(6660),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3993),
    [sym_postfix_unary_expression] = STATE(3997),
    [sym_prefix_unary_expression] = STATE(3997),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3993),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3997),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3993),
    [sym_member_access_expression] = STATE(3202),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3997),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3993),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3993),
    [sym_typeof_expression] = STATE(3993),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3202),
    [sym_literal] = STATE(3993),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2742),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(495),
    [sym_preproc_endregion] = STATE(495),
    [sym_preproc_line] = STATE(495),
    [sym_preproc_pragma] = STATE(495),
    [sym_preproc_nullable] = STATE(495),
    [sym_preproc_error] = STATE(495),
    [sym_preproc_define] = STATE(495),
    [sym_preproc_undef] = STATE(495),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(2283),
    [anon_sym_LPAREN] = ACTIONS(2285),
    [anon_sym_ref] = ACTIONS(2287),
    [anon_sym_LBRACE] = ACTIONS(2289),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(2291),
    [anon_sym_GT] = ACTIONS(2291),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1875),
    [anon_sym_TILDE] = ACTIONS(1875),
    [anon_sym_PLUS_PLUS] = ACTIONS(1875),
    [anon_sym_DASH_DASH] = ACTIONS(1875),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1873),
    [anon_sym_DASH] = ACTIONS(1873),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1875),
    [anon_sym_AMP] = ACTIONS(1875),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2293),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2295),
    [anon_sym_var] = ACTIONS(2297),
    [sym_predefined_type] = ACTIONS(2299),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(2301),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2303),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [496] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(3534),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2895),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(3049),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(2975),
    [sym__array_base_type] = STATE(8712),
    [sym_nullable_type] = STATE(2974),
    [sym_pointer_type] = STATE(2974),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(2974),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(2973),
    [sym_pattern] = STATE(6184),
    [sym_constant_pattern] = STATE(3952),
    [sym_parenthesized_pattern] = STATE(3952),
    [sym_var_pattern] = STATE(3952),
    [sym_type_pattern] = STATE(3952),
    [sym_list_pattern] = STATE(3952),
    [sym_recursive_pattern] = STATE(3952),
    [sym_positional_pattern_clause] = STATE(3153),
    [sym_property_pattern_clause] = STATE(3405),
    [sym_relational_pattern] = STATE(3952),
    [sym_negated_pattern] = STATE(3952),
    [sym_and_pattern] = STATE(3952),
    [sym_or_pattern] = STATE(3952),
    [sym_declaration_pattern] = STATE(3952),
    [sym_expression] = STATE(6660),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3993),
    [sym_postfix_unary_expression] = STATE(3997),
    [sym_prefix_unary_expression] = STATE(3997),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3993),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3997),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3993),
    [sym_member_access_expression] = STATE(3202),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3997),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3993),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3993),
    [sym_typeof_expression] = STATE(3993),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3202),
    [sym_literal] = STATE(3993),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2742),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(496),
    [sym_preproc_endregion] = STATE(496),
    [sym_preproc_line] = STATE(496),
    [sym_preproc_pragma] = STATE(496),
    [sym_preproc_nullable] = STATE(496),
    [sym_preproc_error] = STATE(496),
    [sym_preproc_define] = STATE(496),
    [sym_preproc_undef] = STATE(496),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(2283),
    [anon_sym_LPAREN] = ACTIONS(2285),
    [anon_sym_ref] = ACTIONS(2287),
    [anon_sym_LBRACE] = ACTIONS(2289),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(2291),
    [anon_sym_GT] = ACTIONS(2291),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1875),
    [anon_sym_TILDE] = ACTIONS(1875),
    [anon_sym_PLUS_PLUS] = ACTIONS(1875),
    [anon_sym_DASH_DASH] = ACTIONS(1875),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1873),
    [anon_sym_DASH] = ACTIONS(1873),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1875),
    [anon_sym_AMP] = ACTIONS(1875),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2293),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2295),
    [anon_sym_var] = ACTIONS(2297),
    [sym_predefined_type] = ACTIONS(2299),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(2301),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2303),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [497] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(3161),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2747),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(2785),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(2975),
    [sym__array_base_type] = STATE(8712),
    [sym_nullable_type] = STATE(2974),
    [sym_pointer_type] = STATE(2974),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(2974),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(2973),
    [sym_pattern] = STATE(5243),
    [sym_constant_pattern] = STATE(3952),
    [sym_parenthesized_pattern] = STATE(3952),
    [sym_var_pattern] = STATE(3952),
    [sym_type_pattern] = STATE(3952),
    [sym_list_pattern] = STATE(3952),
    [sym_recursive_pattern] = STATE(3952),
    [sym_positional_pattern_clause] = STATE(2809),
    [sym_property_pattern_clause] = STATE(2851),
    [sym_relational_pattern] = STATE(3952),
    [sym_negated_pattern] = STATE(3952),
    [sym_and_pattern] = STATE(3952),
    [sym_or_pattern] = STATE(3952),
    [sym_declaration_pattern] = STATE(3952),
    [sym_expression] = STATE(6704),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3993),
    [sym_postfix_unary_expression] = STATE(3997),
    [sym_prefix_unary_expression] = STATE(3997),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3993),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3997),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3993),
    [sym_member_access_expression] = STATE(3202),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3997),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3993),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3993),
    [sym_typeof_expression] = STATE(3993),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3202),
    [sym_literal] = STATE(3993),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2762),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(497),
    [sym_preproc_endregion] = STATE(497),
    [sym_preproc_line] = STATE(497),
    [sym_preproc_pragma] = STATE(497),
    [sym_preproc_nullable] = STATE(497),
    [sym_preproc_error] = STATE(497),
    [sym_preproc_define] = STATE(497),
    [sym_preproc_undef] = STATE(497),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(2283),
    [anon_sym_LPAREN] = ACTIONS(2373),
    [anon_sym_ref] = ACTIONS(2375),
    [anon_sym_LBRACE] = ACTIONS(2289),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(2377),
    [anon_sym_GT] = ACTIONS(2377),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1329),
    [anon_sym_TILDE] = ACTIONS(1329),
    [anon_sym_PLUS_PLUS] = ACTIONS(1329),
    [anon_sym_DASH_DASH] = ACTIONS(1329),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1327),
    [anon_sym_DASH] = ACTIONS(1327),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1329),
    [anon_sym_AMP] = ACTIONS(1329),
    [anon_sym_GT_EQ] = ACTIONS(2379),
    [anon_sym_LT_EQ] = ACTIONS(2379),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2381),
    [anon_sym_var] = ACTIONS(2297),
    [sym_predefined_type] = ACTIONS(2299),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(2301),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2383),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [498] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2789),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(5318),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_pattern] = STATE(8233),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(6141),
    [sym_property_pattern_clause] = STATE(6672),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6667),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(5313),
    [sym_postfix_unary_expression] = STATE(5314),
    [sym_prefix_unary_expression] = STATE(5314),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(5313),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(5314),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(5313),
    [sym_member_access_expression] = STATE(3856),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(5314),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(5313),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(5313),
    [sym_typeof_expression] = STATE(5313),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3856),
    [sym_literal] = STATE(5313),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(498),
    [sym_preproc_endregion] = STATE(498),
    [sym_preproc_line] = STATE(498),
    [sym_preproc_pragma] = STATE(498),
    [sym_preproc_nullable] = STATE(498),
    [sym_preproc_error] = STATE(498),
    [sym_preproc_define] = STATE(498),
    [sym_preproc_undef] = STATE(498),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(1043),
    [anon_sym_ref] = ACTIONS(2257),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1053),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1059),
    [anon_sym_TILDE] = ACTIONS(1059),
    [anon_sym_PLUS_PLUS] = ACTIONS(1059),
    [anon_sym_DASH_DASH] = ACTIONS(1059),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1061),
    [anon_sym_DASH] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_GT_EQ] = ACTIONS(1063),
    [anon_sym_LT_EQ] = ACTIONS(1063),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1065),
    [anon_sym_var] = ACTIONS(1067),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(1077),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [499] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(3524),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2867),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(3038),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(2975),
    [sym__array_base_type] = STATE(8712),
    [sym_nullable_type] = STATE(2974),
    [sym_pointer_type] = STATE(2974),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(2974),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(2973),
    [sym_pattern] = STATE(4839),
    [sym_constant_pattern] = STATE(4709),
    [sym_parenthesized_pattern] = STATE(4709),
    [sym_var_pattern] = STATE(4709),
    [sym_type_pattern] = STATE(4709),
    [sym_list_pattern] = STATE(4709),
    [sym_recursive_pattern] = STATE(4709),
    [sym_positional_pattern_clause] = STATE(3123),
    [sym_property_pattern_clause] = STATE(3179),
    [sym_relational_pattern] = STATE(4709),
    [sym_negated_pattern] = STATE(4709),
    [sym_and_pattern] = STATE(4709),
    [sym_or_pattern] = STATE(4709),
    [sym_declaration_pattern] = STATE(4709),
    [sym_expression] = STATE(6707),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(4649),
    [sym_postfix_unary_expression] = STATE(4712),
    [sym_prefix_unary_expression] = STATE(4712),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(4649),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(4712),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(4649),
    [sym_member_access_expression] = STATE(3548),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(4712),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(4649),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(4649),
    [sym_typeof_expression] = STATE(4649),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3548),
    [sym_literal] = STATE(4649),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2742),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(499),
    [sym_preproc_endregion] = STATE(499),
    [sym_preproc_line] = STATE(499),
    [sym_preproc_pragma] = STATE(499),
    [sym_preproc_nullable] = STATE(499),
    [sym_preproc_error] = STATE(499),
    [sym_preproc_define] = STATE(499),
    [sym_preproc_undef] = STATE(499),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(2337),
    [anon_sym_LPAREN] = ACTIONS(2339),
    [anon_sym_ref] = ACTIONS(2287),
    [anon_sym_LBRACE] = ACTIONS(2289),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(2341),
    [anon_sym_GT] = ACTIONS(2341),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1621),
    [anon_sym_TILDE] = ACTIONS(1621),
    [anon_sym_PLUS_PLUS] = ACTIONS(1621),
    [anon_sym_DASH_DASH] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(1619),
    [anon_sym_DASH] = ACTIONS(1619),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1621),
    [anon_sym_AMP] = ACTIONS(1621),
    [anon_sym_GT_EQ] = ACTIONS(2343),
    [anon_sym_LT_EQ] = ACTIONS(2343),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2295),
    [anon_sym_var] = ACTIONS(2345),
    [sym_predefined_type] = ACTIONS(2347),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(2349),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2351),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [500] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(3161),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2747),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(2788),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(2975),
    [sym__array_base_type] = STATE(8712),
    [sym_nullable_type] = STATE(2974),
    [sym_pointer_type] = STATE(2974),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(2974),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(2973),
    [sym_pattern] = STATE(5355),
    [sym_constant_pattern] = STATE(3952),
    [sym_parenthesized_pattern] = STATE(3952),
    [sym_var_pattern] = STATE(3952),
    [sym_type_pattern] = STATE(3952),
    [sym_list_pattern] = STATE(3952),
    [sym_recursive_pattern] = STATE(3952),
    [sym_positional_pattern_clause] = STATE(2809),
    [sym_property_pattern_clause] = STATE(2851),
    [sym_relational_pattern] = STATE(3952),
    [sym_negated_pattern] = STATE(3952),
    [sym_and_pattern] = STATE(3952),
    [sym_or_pattern] = STATE(3952),
    [sym_declaration_pattern] = STATE(3952),
    [sym_expression] = STATE(6704),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3993),
    [sym_postfix_unary_expression] = STATE(3997),
    [sym_prefix_unary_expression] = STATE(3997),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3993),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3997),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3993),
    [sym_member_access_expression] = STATE(3202),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3997),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3993),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3993),
    [sym_typeof_expression] = STATE(3993),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3202),
    [sym_literal] = STATE(3993),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2762),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(500),
    [sym_preproc_endregion] = STATE(500),
    [sym_preproc_line] = STATE(500),
    [sym_preproc_pragma] = STATE(500),
    [sym_preproc_nullable] = STATE(500),
    [sym_preproc_error] = STATE(500),
    [sym_preproc_define] = STATE(500),
    [sym_preproc_undef] = STATE(500),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(2283),
    [anon_sym_LPAREN] = ACTIONS(2373),
    [anon_sym_ref] = ACTIONS(2375),
    [anon_sym_LBRACE] = ACTIONS(2289),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(2377),
    [anon_sym_GT] = ACTIONS(2377),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1329),
    [anon_sym_TILDE] = ACTIONS(1329),
    [anon_sym_PLUS_PLUS] = ACTIONS(1329),
    [anon_sym_DASH_DASH] = ACTIONS(1329),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1327),
    [anon_sym_DASH] = ACTIONS(1327),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1329),
    [anon_sym_AMP] = ACTIONS(1329),
    [anon_sym_GT_EQ] = ACTIONS(2379),
    [anon_sym_LT_EQ] = ACTIONS(2379),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2381),
    [anon_sym_var] = ACTIONS(2297),
    [sym_predefined_type] = ACTIONS(2299),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(2301),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2383),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [501] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(3524),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2867),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(3016),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(2975),
    [sym__array_base_type] = STATE(8712),
    [sym_nullable_type] = STATE(2974),
    [sym_pointer_type] = STATE(2974),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(2974),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(2973),
    [sym_pattern] = STATE(4569),
    [sym_constant_pattern] = STATE(4709),
    [sym_parenthesized_pattern] = STATE(4709),
    [sym_var_pattern] = STATE(4709),
    [sym_type_pattern] = STATE(4709),
    [sym_list_pattern] = STATE(4709),
    [sym_recursive_pattern] = STATE(4709),
    [sym_positional_pattern_clause] = STATE(3123),
    [sym_property_pattern_clause] = STATE(3179),
    [sym_relational_pattern] = STATE(4709),
    [sym_negated_pattern] = STATE(4709),
    [sym_and_pattern] = STATE(4709),
    [sym_or_pattern] = STATE(4709),
    [sym_declaration_pattern] = STATE(4709),
    [sym_expression] = STATE(6707),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(4649),
    [sym_postfix_unary_expression] = STATE(4712),
    [sym_prefix_unary_expression] = STATE(4712),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(4649),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(4712),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(4649),
    [sym_member_access_expression] = STATE(3548),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(4712),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(4649),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(4649),
    [sym_typeof_expression] = STATE(4649),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3548),
    [sym_literal] = STATE(4649),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2742),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(501),
    [sym_preproc_endregion] = STATE(501),
    [sym_preproc_line] = STATE(501),
    [sym_preproc_pragma] = STATE(501),
    [sym_preproc_nullable] = STATE(501),
    [sym_preproc_error] = STATE(501),
    [sym_preproc_define] = STATE(501),
    [sym_preproc_undef] = STATE(501),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(2337),
    [anon_sym_LPAREN] = ACTIONS(2339),
    [anon_sym_ref] = ACTIONS(2287),
    [anon_sym_LBRACE] = ACTIONS(2289),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(2341),
    [anon_sym_GT] = ACTIONS(2341),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1621),
    [anon_sym_TILDE] = ACTIONS(1621),
    [anon_sym_PLUS_PLUS] = ACTIONS(1621),
    [anon_sym_DASH_DASH] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(1619),
    [anon_sym_DASH] = ACTIONS(1619),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1621),
    [anon_sym_AMP] = ACTIONS(1621),
    [anon_sym_GT_EQ] = ACTIONS(2343),
    [anon_sym_LT_EQ] = ACTIONS(2343),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2295),
    [anon_sym_var] = ACTIONS(2345),
    [sym_predefined_type] = ACTIONS(2347),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(2349),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2351),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [502] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(2997),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2749),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(2801),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(2975),
    [sym__array_base_type] = STATE(8712),
    [sym_nullable_type] = STATE(2974),
    [sym_pointer_type] = STATE(2974),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(2974),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(2973),
    [sym_pattern] = STATE(5347),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(2842),
    [sym_property_pattern_clause] = STATE(2893),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6667),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(4290),
    [sym_postfix_unary_expression] = STATE(4294),
    [sym_prefix_unary_expression] = STATE(4294),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(4290),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(4294),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(4290),
    [sym_member_access_expression] = STATE(3277),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(4294),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(4290),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(4290),
    [sym_typeof_expression] = STATE(4290),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3277),
    [sym_literal] = STATE(4290),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2742),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(502),
    [sym_preproc_endregion] = STATE(502),
    [sym_preproc_line] = STATE(502),
    [sym_preproc_pragma] = STATE(502),
    [sym_preproc_nullable] = STATE(502),
    [sym_preproc_error] = STATE(502),
    [sym_preproc_define] = STATE(502),
    [sym_preproc_undef] = STATE(502),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(2333),
    [anon_sym_ref] = ACTIONS(2287),
    [anon_sym_LBRACE] = ACTIONS(2289),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1053),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1059),
    [anon_sym_TILDE] = ACTIONS(1059),
    [anon_sym_PLUS_PLUS] = ACTIONS(1059),
    [anon_sym_DASH_DASH] = ACTIONS(1059),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1061),
    [anon_sym_DASH] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_GT_EQ] = ACTIONS(1063),
    [anon_sym_LT_EQ] = ACTIONS(1063),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2295),
    [anon_sym_var] = ACTIONS(2311),
    [sym_predefined_type] = ACTIONS(2313),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2335),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [503] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(3541),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2878),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(3050),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(2975),
    [sym__array_base_type] = STATE(8712),
    [sym_nullable_type] = STATE(2974),
    [sym_pointer_type] = STATE(2974),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(2974),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(2973),
    [sym_pattern] = STATE(5088),
    [sym_constant_pattern] = STATE(4988),
    [sym_parenthesized_pattern] = STATE(4988),
    [sym_var_pattern] = STATE(4988),
    [sym_type_pattern] = STATE(4988),
    [sym_list_pattern] = STATE(4988),
    [sym_recursive_pattern] = STATE(4988),
    [sym_positional_pattern_clause] = STATE(3139),
    [sym_property_pattern_clause] = STATE(3239),
    [sym_relational_pattern] = STATE(4988),
    [sym_negated_pattern] = STATE(4988),
    [sym_and_pattern] = STATE(4988),
    [sym_or_pattern] = STATE(4988),
    [sym_declaration_pattern] = STATE(4988),
    [sym_expression] = STATE(6683),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(4995),
    [sym_postfix_unary_expression] = STATE(4994),
    [sym_prefix_unary_expression] = STATE(4994),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(4995),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(4994),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(4995),
    [sym_member_access_expression] = STATE(3744),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(4994),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(4995),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(4995),
    [sym_typeof_expression] = STATE(4995),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3744),
    [sym_literal] = STATE(4995),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2742),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(503),
    [sym_preproc_endregion] = STATE(503),
    [sym_preproc_line] = STATE(503),
    [sym_preproc_pragma] = STATE(503),
    [sym_preproc_nullable] = STATE(503),
    [sym_preproc_error] = STATE(503),
    [sym_preproc_define] = STATE(503),
    [sym_preproc_undef] = STATE(503),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(2495),
    [anon_sym_LPAREN] = ACTIONS(2519),
    [anon_sym_ref] = ACTIONS(2287),
    [anon_sym_LBRACE] = ACTIONS(2289),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(2521),
    [anon_sym_GT] = ACTIONS(2521),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1803),
    [anon_sym_TILDE] = ACTIONS(1803),
    [anon_sym_PLUS_PLUS] = ACTIONS(1803),
    [anon_sym_DASH_DASH] = ACTIONS(1803),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1801),
    [anon_sym_DASH] = ACTIONS(1801),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1803),
    [anon_sym_AMP] = ACTIONS(1803),
    [anon_sym_GT_EQ] = ACTIONS(2523),
    [anon_sym_LT_EQ] = ACTIONS(2523),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2295),
    [anon_sym_var] = ACTIONS(2525),
    [sym_predefined_type] = ACTIONS(2505),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(2507),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2527),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [504] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(2997),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2749),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(2797),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(2975),
    [sym__array_base_type] = STATE(8712),
    [sym_nullable_type] = STATE(2974),
    [sym_pointer_type] = STATE(2974),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(2974),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(2973),
    [sym_pattern] = STATE(4118),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(2842),
    [sym_property_pattern_clause] = STATE(2893),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6710),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(4290),
    [sym_postfix_unary_expression] = STATE(4294),
    [sym_prefix_unary_expression] = STATE(4294),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(4290),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(4294),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(4290),
    [sym_member_access_expression] = STATE(3277),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(4294),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(4290),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(4290),
    [sym_typeof_expression] = STATE(4290),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3277),
    [sym_literal] = STATE(4290),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2742),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(504),
    [sym_preproc_endregion] = STATE(504),
    [sym_preproc_line] = STATE(504),
    [sym_preproc_pragma] = STATE(504),
    [sym_preproc_nullable] = STATE(504),
    [sym_preproc_error] = STATE(504),
    [sym_preproc_define] = STATE(504),
    [sym_preproc_undef] = STATE(504),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(2305),
    [anon_sym_ref] = ACTIONS(2287),
    [anon_sym_LBRACE] = ACTIONS(2289),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(2307),
    [anon_sym_GT] = ACTIONS(2307),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1357),
    [anon_sym_TILDE] = ACTIONS(1357),
    [anon_sym_PLUS_PLUS] = ACTIONS(1357),
    [anon_sym_DASH_DASH] = ACTIONS(1357),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1355),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1357),
    [anon_sym_AMP] = ACTIONS(1357),
    [anon_sym_GT_EQ] = ACTIONS(2309),
    [anon_sym_LT_EQ] = ACTIONS(2309),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2295),
    [anon_sym_var] = ACTIONS(2311),
    [sym_predefined_type] = ACTIONS(2313),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2315),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [505] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(2997),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2749),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(2797),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(2975),
    [sym__array_base_type] = STATE(8712),
    [sym_nullable_type] = STATE(2974),
    [sym_pointer_type] = STATE(2974),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(2974),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(2973),
    [sym_pattern] = STATE(5716),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(2842),
    [sym_property_pattern_clause] = STATE(2893),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6710),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(4290),
    [sym_postfix_unary_expression] = STATE(4294),
    [sym_prefix_unary_expression] = STATE(4294),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(4290),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(4294),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(4290),
    [sym_member_access_expression] = STATE(3277),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(4294),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(4290),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(4290),
    [sym_typeof_expression] = STATE(4290),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3277),
    [sym_literal] = STATE(4290),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2742),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(505),
    [sym_preproc_endregion] = STATE(505),
    [sym_preproc_line] = STATE(505),
    [sym_preproc_pragma] = STATE(505),
    [sym_preproc_nullable] = STATE(505),
    [sym_preproc_error] = STATE(505),
    [sym_preproc_define] = STATE(505),
    [sym_preproc_undef] = STATE(505),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(2305),
    [anon_sym_ref] = ACTIONS(2287),
    [anon_sym_LBRACE] = ACTIONS(2289),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(2307),
    [anon_sym_GT] = ACTIONS(2307),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1357),
    [anon_sym_TILDE] = ACTIONS(1357),
    [anon_sym_PLUS_PLUS] = ACTIONS(1357),
    [anon_sym_DASH_DASH] = ACTIONS(1357),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1355),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1357),
    [anon_sym_AMP] = ACTIONS(1357),
    [anon_sym_GT_EQ] = ACTIONS(2309),
    [anon_sym_LT_EQ] = ACTIONS(2309),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2295),
    [anon_sym_var] = ACTIONS(2311),
    [sym_predefined_type] = ACTIONS(2313),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2315),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [506] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(3429),
    [sym_alias_qualified_name] = STATE(3430),
    [sym__simple_name] = STATE(2824),
    [sym_qualified_name] = STATE(3430),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(2942),
    [sym_implicit_type] = STATE(3403),
    [sym_array_type] = STATE(3434),
    [sym__array_base_type] = STATE(8808),
    [sym_nullable_type] = STATE(3435),
    [sym_pointer_type] = STATE(3435),
    [sym__pointer_base_type] = STATE(9626),
    [sym_function_pointer_type] = STATE(3435),
    [sym_ref_type] = STATE(3403),
    [sym_scoped_type] = STATE(3403),
    [sym_tuple_type] = STATE(3436),
    [sym_pattern] = STATE(5650),
    [sym_constant_pattern] = STATE(5385),
    [sym_parenthesized_pattern] = STATE(5385),
    [sym_var_pattern] = STATE(5385),
    [sym_type_pattern] = STATE(5385),
    [sym_list_pattern] = STATE(5385),
    [sym_recursive_pattern] = STATE(5385),
    [sym_positional_pattern_clause] = STATE(3070),
    [sym_property_pattern_clause] = STATE(3113),
    [sym_relational_pattern] = STATE(5385),
    [sym_negated_pattern] = STATE(5385),
    [sym_and_pattern] = STATE(5385),
    [sym_or_pattern] = STATE(5385),
    [sym_declaration_pattern] = STATE(5385),
    [sym_expression] = STATE(6674),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(5460),
    [sym_postfix_unary_expression] = STATE(5462),
    [sym_prefix_unary_expression] = STATE(5462),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(5460),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(5462),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(5460),
    [sym_member_access_expression] = STATE(3913),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(5462),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(5460),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(5460),
    [sym_typeof_expression] = STATE(5460),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3913),
    [sym_literal] = STATE(5460),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2776),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(506),
    [sym_preproc_endregion] = STATE(506),
    [sym_preproc_line] = STATE(506),
    [sym_preproc_pragma] = STATE(506),
    [sym_preproc_nullable] = STATE(506),
    [sym_preproc_error] = STATE(506),
    [sym_preproc_define] = STATE(506),
    [sym_preproc_undef] = STATE(506),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(2447),
    [anon_sym_LPAREN] = ACTIONS(2449),
    [anon_sym_ref] = ACTIONS(2451),
    [anon_sym_LBRACE] = ACTIONS(2453),
    [anon_sym_delegate] = ACTIONS(2455),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(2457),
    [anon_sym_GT] = ACTIONS(2457),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1387),
    [anon_sym_TILDE] = ACTIONS(1387),
    [anon_sym_PLUS_PLUS] = ACTIONS(1387),
    [anon_sym_DASH_DASH] = ACTIONS(1387),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1385),
    [anon_sym_DASH] = ACTIONS(1385),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1387),
    [anon_sym_AMP] = ACTIONS(1387),
    [anon_sym_GT_EQ] = ACTIONS(2459),
    [anon_sym_LT_EQ] = ACTIONS(2459),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2461),
    [anon_sym_var] = ACTIONS(2463),
    [sym_predefined_type] = ACTIONS(2465),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(2467),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2469),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
  },
  [507] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(3525),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2860),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(3041),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(2975),
    [sym__array_base_type] = STATE(8712),
    [sym_nullable_type] = STATE(2974),
    [sym_pointer_type] = STATE(2974),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(2974),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(2973),
    [sym_pattern] = STATE(4668),
    [sym_constant_pattern] = STATE(4709),
    [sym_parenthesized_pattern] = STATE(4709),
    [sym_var_pattern] = STATE(4709),
    [sym_type_pattern] = STATE(4709),
    [sym_list_pattern] = STATE(4709),
    [sym_recursive_pattern] = STATE(4709),
    [sym_positional_pattern_clause] = STATE(3109),
    [sym_property_pattern_clause] = STATE(3192),
    [sym_relational_pattern] = STATE(4709),
    [sym_negated_pattern] = STATE(4709),
    [sym_and_pattern] = STATE(4709),
    [sym_or_pattern] = STATE(4709),
    [sym_declaration_pattern] = STATE(4709),
    [sym_expression] = STATE(6665),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(4649),
    [sym_postfix_unary_expression] = STATE(4712),
    [sym_prefix_unary_expression] = STATE(4712),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(4649),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(4712),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(4649),
    [sym_member_access_expression] = STATE(3548),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(4712),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(4649),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(4649),
    [sym_typeof_expression] = STATE(4649),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3548),
    [sym_literal] = STATE(4649),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2742),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(507),
    [sym_preproc_endregion] = STATE(507),
    [sym_preproc_line] = STATE(507),
    [sym_preproc_pragma] = STATE(507),
    [sym_preproc_nullable] = STATE(507),
    [sym_preproc_error] = STATE(507),
    [sym_preproc_define] = STATE(507),
    [sym_preproc_undef] = STATE(507),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(2337),
    [anon_sym_LPAREN] = ACTIONS(2487),
    [anon_sym_ref] = ACTIONS(2287),
    [anon_sym_LBRACE] = ACTIONS(2289),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(2489),
    [anon_sym_GT] = ACTIONS(2489),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1683),
    [anon_sym_TILDE] = ACTIONS(1683),
    [anon_sym_PLUS_PLUS] = ACTIONS(1683),
    [anon_sym_DASH_DASH] = ACTIONS(1683),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_DASH] = ACTIONS(1681),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1683),
    [anon_sym_GT_EQ] = ACTIONS(2491),
    [anon_sym_LT_EQ] = ACTIONS(2491),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2295),
    [anon_sym_var] = ACTIONS(2345),
    [sym_predefined_type] = ACTIONS(2347),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(2349),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2493),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [508] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(3525),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2860),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(3041),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(2975),
    [sym__array_base_type] = STATE(8712),
    [sym_nullable_type] = STATE(2974),
    [sym_pointer_type] = STATE(2974),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(2974),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(2973),
    [sym_pattern] = STATE(4573),
    [sym_constant_pattern] = STATE(4709),
    [sym_parenthesized_pattern] = STATE(4709),
    [sym_var_pattern] = STATE(4709),
    [sym_type_pattern] = STATE(4709),
    [sym_list_pattern] = STATE(4709),
    [sym_recursive_pattern] = STATE(4709),
    [sym_positional_pattern_clause] = STATE(3109),
    [sym_property_pattern_clause] = STATE(3192),
    [sym_relational_pattern] = STATE(4709),
    [sym_negated_pattern] = STATE(4709),
    [sym_and_pattern] = STATE(4709),
    [sym_or_pattern] = STATE(4709),
    [sym_declaration_pattern] = STATE(4709),
    [sym_expression] = STATE(6665),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(4649),
    [sym_postfix_unary_expression] = STATE(4712),
    [sym_prefix_unary_expression] = STATE(4712),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(4649),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(4712),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(4649),
    [sym_member_access_expression] = STATE(3548),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(4712),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(4649),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(4649),
    [sym_typeof_expression] = STATE(4649),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3548),
    [sym_literal] = STATE(4649),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2742),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(508),
    [sym_preproc_endregion] = STATE(508),
    [sym_preproc_line] = STATE(508),
    [sym_preproc_pragma] = STATE(508),
    [sym_preproc_nullable] = STATE(508),
    [sym_preproc_error] = STATE(508),
    [sym_preproc_define] = STATE(508),
    [sym_preproc_undef] = STATE(508),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(2337),
    [anon_sym_LPAREN] = ACTIONS(2487),
    [anon_sym_ref] = ACTIONS(2287),
    [anon_sym_LBRACE] = ACTIONS(2289),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(2489),
    [anon_sym_GT] = ACTIONS(2489),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1683),
    [anon_sym_TILDE] = ACTIONS(1683),
    [anon_sym_PLUS_PLUS] = ACTIONS(1683),
    [anon_sym_DASH_DASH] = ACTIONS(1683),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_DASH] = ACTIONS(1681),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1683),
    [anon_sym_GT_EQ] = ACTIONS(2491),
    [anon_sym_LT_EQ] = ACTIONS(2491),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2295),
    [anon_sym_var] = ACTIONS(2345),
    [sym_predefined_type] = ACTIONS(2347),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(2349),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2493),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [509] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(2992),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2747),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(3018),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(2975),
    [sym__array_base_type] = STATE(8712),
    [sym_nullable_type] = STATE(2974),
    [sym_pointer_type] = STATE(2974),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(2974),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(2973),
    [sym_pattern] = STATE(4043),
    [sym_constant_pattern] = STATE(3952),
    [sym_parenthesized_pattern] = STATE(3952),
    [sym_var_pattern] = STATE(3952),
    [sym_type_pattern] = STATE(3952),
    [sym_list_pattern] = STATE(3952),
    [sym_recursive_pattern] = STATE(3952),
    [sym_positional_pattern_clause] = STATE(2809),
    [sym_property_pattern_clause] = STATE(2851),
    [sym_relational_pattern] = STATE(3952),
    [sym_negated_pattern] = STATE(3952),
    [sym_and_pattern] = STATE(3952),
    [sym_or_pattern] = STATE(3952),
    [sym_declaration_pattern] = STATE(3952),
    [sym_expression] = STATE(6697),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3993),
    [sym_postfix_unary_expression] = STATE(3997),
    [sym_prefix_unary_expression] = STATE(3997),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3993),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3997),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3993),
    [sym_member_access_expression] = STATE(3202),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3997),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3993),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3993),
    [sym_typeof_expression] = STATE(3993),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3202),
    [sym_literal] = STATE(3993),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2810),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(509),
    [sym_preproc_endregion] = STATE(509),
    [sym_preproc_line] = STATE(509),
    [sym_preproc_pragma] = STATE(509),
    [sym_preproc_nullable] = STATE(509),
    [sym_preproc_error] = STATE(509),
    [sym_preproc_define] = STATE(509),
    [sym_preproc_undef] = STATE(509),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(2283),
    [anon_sym_LPAREN] = ACTIONS(2537),
    [anon_sym_ref] = ACTIONS(2391),
    [anon_sym_LBRACE] = ACTIONS(2289),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(2539),
    [anon_sym_GT] = ACTIONS(2539),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(1567),
    [anon_sym_PLUS_PLUS] = ACTIONS(1567),
    [anon_sym_DASH_DASH] = ACTIONS(1567),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1565),
    [anon_sym_DASH] = ACTIONS(1565),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1567),
    [anon_sym_AMP] = ACTIONS(1567),
    [anon_sym_GT_EQ] = ACTIONS(2541),
    [anon_sym_LT_EQ] = ACTIONS(2541),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2295),
    [anon_sym_var] = ACTIONS(2543),
    [sym_predefined_type] = ACTIONS(2299),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(2301),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2545),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [510] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(3538),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2876),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(3062),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(2975),
    [sym__array_base_type] = STATE(8712),
    [sym_nullable_type] = STATE(2974),
    [sym_pointer_type] = STATE(2974),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(2974),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(2973),
    [sym_pattern] = STATE(6500),
    [sym_constant_pattern] = STATE(4289),
    [sym_parenthesized_pattern] = STATE(4289),
    [sym_var_pattern] = STATE(4289),
    [sym_type_pattern] = STATE(4289),
    [sym_list_pattern] = STATE(4289),
    [sym_recursive_pattern] = STATE(4289),
    [sym_positional_pattern_clause] = STATE(3151),
    [sym_property_pattern_clause] = STATE(3386),
    [sym_relational_pattern] = STATE(4289),
    [sym_negated_pattern] = STATE(4289),
    [sym_and_pattern] = STATE(4289),
    [sym_or_pattern] = STATE(4289),
    [sym_declaration_pattern] = STATE(4289),
    [sym_expression] = STATE(6675),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(4290),
    [sym_postfix_unary_expression] = STATE(4294),
    [sym_prefix_unary_expression] = STATE(4294),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(4290),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(4294),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(4290),
    [sym_member_access_expression] = STATE(3277),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(4294),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(4290),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(4290),
    [sym_typeof_expression] = STATE(4290),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3277),
    [sym_literal] = STATE(4290),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2742),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(510),
    [sym_preproc_endregion] = STATE(510),
    [sym_preproc_line] = STATE(510),
    [sym_preproc_pragma] = STATE(510),
    [sym_preproc_nullable] = STATE(510),
    [sym_preproc_error] = STATE(510),
    [sym_preproc_define] = STATE(510),
    [sym_preproc_undef] = STATE(510),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(2529),
    [anon_sym_ref] = ACTIONS(2287),
    [anon_sym_LBRACE] = ACTIONS(2289),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(2531),
    [anon_sym_GT] = ACTIONS(2531),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1821),
    [anon_sym_TILDE] = ACTIONS(1821),
    [anon_sym_PLUS_PLUS] = ACTIONS(1821),
    [anon_sym_DASH_DASH] = ACTIONS(1821),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1819),
    [anon_sym_DASH] = ACTIONS(1819),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1821),
    [anon_sym_AMP] = ACTIONS(1821),
    [anon_sym_GT_EQ] = ACTIONS(2533),
    [anon_sym_LT_EQ] = ACTIONS(2533),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2295),
    [anon_sym_var] = ACTIONS(2311),
    [sym_predefined_type] = ACTIONS(2313),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2535),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [511] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(3525),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2860),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(3041),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(2975),
    [sym__array_base_type] = STATE(8712),
    [sym_nullable_type] = STATE(2974),
    [sym_pointer_type] = STATE(2974),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(2974),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(2973),
    [sym_pattern] = STATE(4690),
    [sym_constant_pattern] = STATE(4709),
    [sym_parenthesized_pattern] = STATE(4709),
    [sym_var_pattern] = STATE(4709),
    [sym_type_pattern] = STATE(4709),
    [sym_list_pattern] = STATE(4709),
    [sym_recursive_pattern] = STATE(4709),
    [sym_positional_pattern_clause] = STATE(3109),
    [sym_property_pattern_clause] = STATE(3192),
    [sym_relational_pattern] = STATE(4709),
    [sym_negated_pattern] = STATE(4709),
    [sym_and_pattern] = STATE(4709),
    [sym_or_pattern] = STATE(4709),
    [sym_declaration_pattern] = STATE(4709),
    [sym_expression] = STATE(6665),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(4649),
    [sym_postfix_unary_expression] = STATE(4712),
    [sym_prefix_unary_expression] = STATE(4712),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(4649),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(4712),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(4649),
    [sym_member_access_expression] = STATE(3548),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(4712),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(4649),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(4649),
    [sym_typeof_expression] = STATE(4649),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3548),
    [sym_literal] = STATE(4649),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2742),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(511),
    [sym_preproc_endregion] = STATE(511),
    [sym_preproc_line] = STATE(511),
    [sym_preproc_pragma] = STATE(511),
    [sym_preproc_nullable] = STATE(511),
    [sym_preproc_error] = STATE(511),
    [sym_preproc_define] = STATE(511),
    [sym_preproc_undef] = STATE(511),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(2337),
    [anon_sym_LPAREN] = ACTIONS(2487),
    [anon_sym_ref] = ACTIONS(2287),
    [anon_sym_LBRACE] = ACTIONS(2289),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(2489),
    [anon_sym_GT] = ACTIONS(2489),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1683),
    [anon_sym_TILDE] = ACTIONS(1683),
    [anon_sym_PLUS_PLUS] = ACTIONS(1683),
    [anon_sym_DASH_DASH] = ACTIONS(1683),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_DASH] = ACTIONS(1681),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1683),
    [anon_sym_GT_EQ] = ACTIONS(2491),
    [anon_sym_LT_EQ] = ACTIONS(2491),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2295),
    [anon_sym_var] = ACTIONS(2345),
    [sym_predefined_type] = ACTIONS(2347),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [sym_discard] = ACTIONS(2349),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(2493),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [512] = {
    [sym_attribute] = STATE(8395),
    [sym_attribute_list] = STATE(6703),
    [sym_attribute_target_specifier] = STATE(6792),
    [sym_parameter_list] = STATE(9765),
    [sym_argument] = STATE(8389),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6742),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6971),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5910),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2767),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(512),
    [sym_preproc_endregion] = STATE(512),
    [sym_preproc_line] = STATE(512),
    [sym_preproc_pragma] = STATE(512),
    [sym_preproc_nullable] = STATE(512),
    [sym_preproc_error] = STATE(512),
    [sym_preproc_define] = STATE(512),
    [sym_preproc_undef] = STATE(512),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_assembly] = ACTIONS(2555),
    [anon_sym_module] = ACTIONS(2555),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_field] = ACTIONS(1045),
    [anon_sym_event] = ACTIONS(1045),
    [anon_sym_method] = ACTIONS(1045),
    [anon_sym_param] = ACTIONS(1045),
    [anon_sym_property] = ACTIONS(1045),
    [anon_sym_return] = ACTIONS(1045),
    [anon_sym_type] = ACTIONS(1045),
    [anon_sym_ref] = ACTIONS(2557),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_in] = ACTIONS(1055),
    [anon_sym_out] = ACTIONS(1055),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [513] = {
    [sym_attribute] = STATE(8395),
    [sym_attribute_list] = STATE(6703),
    [sym_attribute_target_specifier] = STATE(6792),
    [sym_parameter_list] = STATE(9765),
    [sym_argument] = STATE(8389),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6742),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6971),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5910),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2767),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(513),
    [sym_preproc_endregion] = STATE(513),
    [sym_preproc_line] = STATE(513),
    [sym_preproc_pragma] = STATE(513),
    [sym_preproc_nullable] = STATE(513),
    [sym_preproc_error] = STATE(513),
    [sym_preproc_define] = STATE(513),
    [sym_preproc_undef] = STATE(513),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_assembly] = ACTIONS(2559),
    [anon_sym_module] = ACTIONS(2559),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_field] = ACTIONS(1045),
    [anon_sym_event] = ACTIONS(1045),
    [anon_sym_method] = ACTIONS(1045),
    [anon_sym_param] = ACTIONS(1045),
    [anon_sym_property] = ACTIONS(1045),
    [anon_sym_return] = ACTIONS(1045),
    [anon_sym_type] = ACTIONS(1045),
    [anon_sym_ref] = ACTIONS(2557),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_in] = ACTIONS(1055),
    [anon_sym_out] = ACTIONS(1055),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [514] = {
    [sym_attribute] = STATE(8527),
    [sym_attribute_list] = STATE(6703),
    [sym_attribute_target_specifier] = STATE(6777),
    [sym_parameter_list] = STATE(9765),
    [sym_argument] = STATE(8538),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6742),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6971),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5910),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2767),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(514),
    [sym_preproc_endregion] = STATE(514),
    [sym_preproc_line] = STATE(514),
    [sym_preproc_pragma] = STATE(514),
    [sym_preproc_nullable] = STATE(514),
    [sym_preproc_error] = STATE(514),
    [sym_preproc_define] = STATE(514),
    [sym_preproc_undef] = STATE(514),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_field] = ACTIONS(1045),
    [anon_sym_event] = ACTIONS(1045),
    [anon_sym_method] = ACTIONS(1045),
    [anon_sym_param] = ACTIONS(1045),
    [anon_sym_property] = ACTIONS(1045),
    [anon_sym_return] = ACTIONS(1045),
    [anon_sym_type] = ACTIONS(1045),
    [anon_sym_ref] = ACTIONS(2557),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_in] = ACTIONS(1055),
    [anon_sym_out] = ACTIONS(1055),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [515] = {
    [sym_attribute] = STATE(8527),
    [sym_attribute_list] = STATE(6703),
    [sym_attribute_target_specifier] = STATE(6777),
    [sym_parameter_list] = STATE(9765),
    [sym_argument] = STATE(8358),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6742),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6971),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5910),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2767),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(515),
    [sym_preproc_endregion] = STATE(515),
    [sym_preproc_line] = STATE(515),
    [sym_preproc_pragma] = STATE(515),
    [sym_preproc_nullable] = STATE(515),
    [sym_preproc_error] = STATE(515),
    [sym_preproc_define] = STATE(515),
    [sym_preproc_undef] = STATE(515),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_field] = ACTIONS(1045),
    [anon_sym_event] = ACTIONS(1045),
    [anon_sym_method] = ACTIONS(1045),
    [anon_sym_param] = ACTIONS(1045),
    [anon_sym_property] = ACTIONS(1045),
    [anon_sym_return] = ACTIONS(1045),
    [anon_sym_type] = ACTIONS(1045),
    [anon_sym_ref] = ACTIONS(2557),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_in] = ACTIONS(1055),
    [anon_sym_out] = ACTIONS(1055),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [516] = {
    [sym_attribute] = STATE(8527),
    [sym_attribute_list] = STATE(6703),
    [sym_attribute_target_specifier] = STATE(6777),
    [sym_parameter_list] = STATE(9765),
    [sym_argument] = STATE(8389),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6742),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6971),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5910),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2767),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(516),
    [sym_preproc_endregion] = STATE(516),
    [sym_preproc_line] = STATE(516),
    [sym_preproc_pragma] = STATE(516),
    [sym_preproc_nullable] = STATE(516),
    [sym_preproc_error] = STATE(516),
    [sym_preproc_define] = STATE(516),
    [sym_preproc_undef] = STATE(516),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_field] = ACTIONS(1045),
    [anon_sym_event] = ACTIONS(1045),
    [anon_sym_method] = ACTIONS(1045),
    [anon_sym_param] = ACTIONS(1045),
    [anon_sym_property] = ACTIONS(1045),
    [anon_sym_return] = ACTIONS(1045),
    [anon_sym_type] = ACTIONS(1045),
    [anon_sym_ref] = ACTIONS(2557),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_in] = ACTIONS(1055),
    [anon_sym_out] = ACTIONS(1055),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [517] = {
    [sym_attribute] = STATE(8359),
    [sym_attribute_list] = STATE(6703),
    [sym_attribute_target_specifier] = STATE(6782),
    [sym_parameter_list] = STATE(9765),
    [sym_argument] = STATE(8389),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6742),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6971),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5910),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2767),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(517),
    [sym_preproc_endregion] = STATE(517),
    [sym_preproc_line] = STATE(517),
    [sym_preproc_pragma] = STATE(517),
    [sym_preproc_nullable] = STATE(517),
    [sym_preproc_error] = STATE(517),
    [sym_preproc_define] = STATE(517),
    [sym_preproc_undef] = STATE(517),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_field] = ACTIONS(1045),
    [anon_sym_event] = ACTIONS(1045),
    [anon_sym_method] = ACTIONS(1045),
    [anon_sym_param] = ACTIONS(1045),
    [anon_sym_property] = ACTIONS(1045),
    [anon_sym_return] = ACTIONS(1045),
    [anon_sym_type] = ACTIONS(1045),
    [anon_sym_ref] = ACTIONS(2557),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_in] = ACTIONS(1055),
    [anon_sym_out] = ACTIONS(1055),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [518] = {
    [sym_attribute] = STATE(8527),
    [sym_attribute_list] = STATE(6703),
    [sym_attribute_target_specifier] = STATE(6777),
    [sym_parameter_list] = STATE(9765),
    [sym_argument] = STATE(8464),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6742),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6971),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5910),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2767),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(518),
    [sym_preproc_endregion] = STATE(518),
    [sym_preproc_line] = STATE(518),
    [sym_preproc_pragma] = STATE(518),
    [sym_preproc_nullable] = STATE(518),
    [sym_preproc_error] = STATE(518),
    [sym_preproc_define] = STATE(518),
    [sym_preproc_undef] = STATE(518),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_field] = ACTIONS(1045),
    [anon_sym_event] = ACTIONS(1045),
    [anon_sym_method] = ACTIONS(1045),
    [anon_sym_param] = ACTIONS(1045),
    [anon_sym_property] = ACTIONS(1045),
    [anon_sym_return] = ACTIONS(1045),
    [anon_sym_type] = ACTIONS(1045),
    [anon_sym_ref] = ACTIONS(2557),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_in] = ACTIONS(1055),
    [anon_sym_out] = ACTIONS(1055),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [519] = {
    [sym_attribute] = STATE(8527),
    [sym_attribute_list] = STATE(6703),
    [sym_attribute_target_specifier] = STATE(6777),
    [sym_parameter_list] = STATE(9765),
    [sym_argument] = STATE(8659),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6742),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6971),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5910),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2767),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(519),
    [sym_preproc_endregion] = STATE(519),
    [sym_preproc_line] = STATE(519),
    [sym_preproc_pragma] = STATE(519),
    [sym_preproc_nullable] = STATE(519),
    [sym_preproc_error] = STATE(519),
    [sym_preproc_define] = STATE(519),
    [sym_preproc_undef] = STATE(519),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_field] = ACTIONS(1045),
    [anon_sym_event] = ACTIONS(1045),
    [anon_sym_method] = ACTIONS(1045),
    [anon_sym_param] = ACTIONS(1045),
    [anon_sym_property] = ACTIONS(1045),
    [anon_sym_return] = ACTIONS(1045),
    [anon_sym_type] = ACTIONS(1045),
    [anon_sym_ref] = ACTIONS(2557),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_in] = ACTIONS(1055),
    [anon_sym_out] = ACTIONS(1055),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [520] = {
    [sym_attribute] = STATE(8527),
    [sym_attribute_list] = STATE(6703),
    [sym_attribute_target_specifier] = STATE(6777),
    [sym_parameter_list] = STATE(9765),
    [sym_argument] = STATE(8510),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6742),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6971),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5910),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2767),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(520),
    [sym_preproc_endregion] = STATE(520),
    [sym_preproc_line] = STATE(520),
    [sym_preproc_pragma] = STATE(520),
    [sym_preproc_nullable] = STATE(520),
    [sym_preproc_error] = STATE(520),
    [sym_preproc_define] = STATE(520),
    [sym_preproc_undef] = STATE(520),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_field] = ACTIONS(1045),
    [anon_sym_event] = ACTIONS(1045),
    [anon_sym_method] = ACTIONS(1045),
    [anon_sym_param] = ACTIONS(1045),
    [anon_sym_property] = ACTIONS(1045),
    [anon_sym_return] = ACTIONS(1045),
    [anon_sym_type] = ACTIONS(1045),
    [anon_sym_ref] = ACTIONS(2557),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_in] = ACTIONS(1055),
    [anon_sym_out] = ACTIONS(1055),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [521] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_parameter] = STATE(8382),
    [sym__parameter_array] = STATE(8390),
    [sym_argument] = STATE(8836),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6806),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_tuple_element] = STATE(8846),
    [sym_expression] = STATE(5910),
    [sym_non_lvalue_expression] = STATE(6331),
    [sym_lvalue_expression] = STATE(4397),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2773),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(521),
    [sym_preproc_endregion] = STATE(521),
    [sym_preproc_line] = STATE(521),
    [sym_preproc_pragma] = STATE(521),
    [sym_preproc_nullable] = STATE(521),
    [sym_preproc_error] = STATE(521),
    [sym_preproc_define] = STATE(521),
    [sym_preproc_undef] = STATE(521),
    [aux_sym_class_declaration_repeat1] = STATE(3564),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4143),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_RPAREN] = ACTIONS(2561),
    [anon_sym_ref] = ACTIONS(2563),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_readonly] = ACTIONS(1093),
    [anon_sym_in] = ACTIONS(1095),
    [anon_sym_out] = ACTIONS(1095),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(1103),
    [anon_sym_scoped] = ACTIONS(1105),
    [anon_sym_params] = ACTIONS(1107),
    [anon_sym_var] = ACTIONS(2565),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [522] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_parameter] = STATE(8382),
    [sym__parameter_array] = STATE(8390),
    [sym_argument] = STATE(8707),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6829),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_tuple_element] = STATE(8846),
    [sym_expression] = STATE(5910),
    [sym_non_lvalue_expression] = STATE(6331),
    [sym_lvalue_expression] = STATE(4355),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2773),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(522),
    [sym_preproc_endregion] = STATE(522),
    [sym_preproc_line] = STATE(522),
    [sym_preproc_pragma] = STATE(522),
    [sym_preproc_nullable] = STATE(522),
    [sym_preproc_error] = STATE(522),
    [sym_preproc_define] = STATE(522),
    [sym_preproc_undef] = STATE(522),
    [aux_sym_class_declaration_repeat1] = STATE(3564),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4143),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_RPAREN] = ACTIONS(2561),
    [anon_sym_ref] = ACTIONS(2563),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_readonly] = ACTIONS(1093),
    [anon_sym_in] = ACTIONS(1095),
    [anon_sym_out] = ACTIONS(1095),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(1103),
    [anon_sym_scoped] = ACTIONS(1105),
    [anon_sym_params] = ACTIONS(1107),
    [anon_sym_var] = ACTIONS(2565),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [523] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_parameter] = STATE(8382),
    [sym__parameter_array] = STATE(8390),
    [sym_argument] = STATE(8836),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6857),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_tuple_element] = STATE(8846),
    [sym_expression] = STATE(5910),
    [sym_non_lvalue_expression] = STATE(6331),
    [sym_lvalue_expression] = STATE(4383),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2773),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(523),
    [sym_preproc_endregion] = STATE(523),
    [sym_preproc_line] = STATE(523),
    [sym_preproc_pragma] = STATE(523),
    [sym_preproc_nullable] = STATE(523),
    [sym_preproc_error] = STATE(523),
    [sym_preproc_define] = STATE(523),
    [sym_preproc_undef] = STATE(523),
    [aux_sym_class_declaration_repeat1] = STATE(3564),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4143),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_RPAREN] = ACTIONS(2561),
    [anon_sym_ref] = ACTIONS(2563),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_readonly] = ACTIONS(1093),
    [anon_sym_in] = ACTIONS(1095),
    [anon_sym_out] = ACTIONS(1095),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(1103),
    [anon_sym_scoped] = ACTIONS(1105),
    [anon_sym_params] = ACTIONS(1107),
    [anon_sym_var] = ACTIONS(2565),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [524] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_parameter] = STATE(8382),
    [sym__parameter_array] = STATE(8390),
    [sym_argument] = STATE(8836),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6822),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_tuple_element] = STATE(8846),
    [sym_expression] = STATE(5910),
    [sym_non_lvalue_expression] = STATE(6331),
    [sym_lvalue_expression] = STATE(4397),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2773),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(524),
    [sym_preproc_endregion] = STATE(524),
    [sym_preproc_line] = STATE(524),
    [sym_preproc_pragma] = STATE(524),
    [sym_preproc_nullable] = STATE(524),
    [sym_preproc_error] = STATE(524),
    [sym_preproc_define] = STATE(524),
    [sym_preproc_undef] = STATE(524),
    [aux_sym_class_declaration_repeat1] = STATE(3564),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4143),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_RPAREN] = ACTIONS(2561),
    [anon_sym_ref] = ACTIONS(2563),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_readonly] = ACTIONS(1093),
    [anon_sym_in] = ACTIONS(1095),
    [anon_sym_out] = ACTIONS(1095),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(1103),
    [anon_sym_scoped] = ACTIONS(1105),
    [anon_sym_params] = ACTIONS(1107),
    [anon_sym_var] = ACTIONS(2565),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [525] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_parameter] = STATE(8382),
    [sym__parameter_array] = STATE(8390),
    [sym_argument] = STATE(8759),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6800),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_tuple_element] = STATE(8846),
    [sym_expression] = STATE(5910),
    [sym_non_lvalue_expression] = STATE(6506),
    [sym_lvalue_expression] = STATE(4418),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2773),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(525),
    [sym_preproc_endregion] = STATE(525),
    [sym_preproc_line] = STATE(525),
    [sym_preproc_pragma] = STATE(525),
    [sym_preproc_nullable] = STATE(525),
    [sym_preproc_error] = STATE(525),
    [sym_preproc_define] = STATE(525),
    [sym_preproc_undef] = STATE(525),
    [aux_sym_class_declaration_repeat1] = STATE(3564),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4143),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_RPAREN] = ACTIONS(2561),
    [anon_sym_ref] = ACTIONS(2563),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_readonly] = ACTIONS(1093),
    [anon_sym_in] = ACTIONS(1095),
    [anon_sym_out] = ACTIONS(1095),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(1103),
    [anon_sym_scoped] = ACTIONS(1105),
    [anon_sym_params] = ACTIONS(1107),
    [anon_sym_var] = ACTIONS(2565),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [526] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_parameter] = STATE(8382),
    [sym__parameter_array] = STATE(8390),
    [sym_argument] = STATE(8836),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6866),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_tuple_element] = STATE(8846),
    [sym_expression] = STATE(5910),
    [sym_non_lvalue_expression] = STATE(6331),
    [sym_lvalue_expression] = STATE(4397),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2773),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(526),
    [sym_preproc_endregion] = STATE(526),
    [sym_preproc_line] = STATE(526),
    [sym_preproc_pragma] = STATE(526),
    [sym_preproc_nullable] = STATE(526),
    [sym_preproc_error] = STATE(526),
    [sym_preproc_define] = STATE(526),
    [sym_preproc_undef] = STATE(526),
    [aux_sym_class_declaration_repeat1] = STATE(3564),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4143),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_RPAREN] = ACTIONS(2561),
    [anon_sym_ref] = ACTIONS(2563),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_readonly] = ACTIONS(1093),
    [anon_sym_in] = ACTIONS(1095),
    [anon_sym_out] = ACTIONS(1095),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(1103),
    [anon_sym_scoped] = ACTIONS(1105),
    [anon_sym_params] = ACTIONS(1107),
    [anon_sym_var] = ACTIONS(2565),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [527] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_parameter] = STATE(8382),
    [sym__parameter_array] = STATE(8390),
    [sym_argument] = STATE(8919),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6805),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_tuple_element] = STATE(8846),
    [sym_expression] = STATE(5910),
    [sym_non_lvalue_expression] = STATE(6468),
    [sym_lvalue_expression] = STATE(4397),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2773),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(527),
    [sym_preproc_endregion] = STATE(527),
    [sym_preproc_line] = STATE(527),
    [sym_preproc_pragma] = STATE(527),
    [sym_preproc_nullable] = STATE(527),
    [sym_preproc_error] = STATE(527),
    [sym_preproc_define] = STATE(527),
    [sym_preproc_undef] = STATE(527),
    [aux_sym_class_declaration_repeat1] = STATE(3564),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4143),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_RPAREN] = ACTIONS(2561),
    [anon_sym_ref] = ACTIONS(2563),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_readonly] = ACTIONS(1093),
    [anon_sym_in] = ACTIONS(1095),
    [anon_sym_out] = ACTIONS(1095),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(1103),
    [anon_sym_scoped] = ACTIONS(1105),
    [anon_sym_params] = ACTIONS(1107),
    [anon_sym_var] = ACTIONS(2565),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [528] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_parameter] = STATE(8382),
    [sym__parameter_array] = STATE(8390),
    [sym_argument] = STATE(8836),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6838),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_tuple_element] = STATE(8846),
    [sym_expression] = STATE(5910),
    [sym_non_lvalue_expression] = STATE(6331),
    [sym_lvalue_expression] = STATE(4397),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2773),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(528),
    [sym_preproc_endregion] = STATE(528),
    [sym_preproc_line] = STATE(528),
    [sym_preproc_pragma] = STATE(528),
    [sym_preproc_nullable] = STATE(528),
    [sym_preproc_error] = STATE(528),
    [sym_preproc_define] = STATE(528),
    [sym_preproc_undef] = STATE(528),
    [aux_sym_class_declaration_repeat1] = STATE(3564),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4143),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_RPAREN] = ACTIONS(2561),
    [anon_sym_ref] = ACTIONS(2563),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_readonly] = ACTIONS(1093),
    [anon_sym_in] = ACTIONS(1095),
    [anon_sym_out] = ACTIONS(1095),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(1103),
    [anon_sym_scoped] = ACTIONS(1105),
    [anon_sym_params] = ACTIONS(1107),
    [anon_sym_var] = ACTIONS(2565),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [529] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_parameter] = STATE(8382),
    [sym__parameter_array] = STATE(8390),
    [sym_argument] = STATE(8836),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6829),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_tuple_element] = STATE(8846),
    [sym_expression] = STATE(5910),
    [sym_non_lvalue_expression] = STATE(6331),
    [sym_lvalue_expression] = STATE(4383),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2773),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(529),
    [sym_preproc_endregion] = STATE(529),
    [sym_preproc_line] = STATE(529),
    [sym_preproc_pragma] = STATE(529),
    [sym_preproc_nullable] = STATE(529),
    [sym_preproc_error] = STATE(529),
    [sym_preproc_define] = STATE(529),
    [sym_preproc_undef] = STATE(529),
    [aux_sym_class_declaration_repeat1] = STATE(3564),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4143),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_RPAREN] = ACTIONS(2561),
    [anon_sym_ref] = ACTIONS(2563),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_readonly] = ACTIONS(1093),
    [anon_sym_in] = ACTIONS(1095),
    [anon_sym_out] = ACTIONS(1095),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(1103),
    [anon_sym_scoped] = ACTIONS(1105),
    [anon_sym_params] = ACTIONS(1107),
    [anon_sym_var] = ACTIONS(2565),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [530] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_parameter] = STATE(8382),
    [sym__parameter_array] = STATE(8390),
    [sym_argument] = STATE(8836),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6854),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_tuple_element] = STATE(8846),
    [sym_expression] = STATE(5910),
    [sym_non_lvalue_expression] = STATE(6331),
    [sym_lvalue_expression] = STATE(4383),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2773),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(530),
    [sym_preproc_endregion] = STATE(530),
    [sym_preproc_line] = STATE(530),
    [sym_preproc_pragma] = STATE(530),
    [sym_preproc_nullable] = STATE(530),
    [sym_preproc_error] = STATE(530),
    [sym_preproc_define] = STATE(530),
    [sym_preproc_undef] = STATE(530),
    [aux_sym_class_declaration_repeat1] = STATE(3564),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4143),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_RPAREN] = ACTIONS(2561),
    [anon_sym_ref] = ACTIONS(2563),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_readonly] = ACTIONS(1093),
    [anon_sym_in] = ACTIONS(1095),
    [anon_sym_out] = ACTIONS(1095),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(1103),
    [anon_sym_scoped] = ACTIONS(1105),
    [anon_sym_params] = ACTIONS(1107),
    [anon_sym_var] = ACTIONS(2565),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [531] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_parameter] = STATE(8382),
    [sym__parameter_array] = STATE(8390),
    [sym_argument] = STATE(8919),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6829),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_tuple_element] = STATE(8846),
    [sym_expression] = STATE(5910),
    [sym_non_lvalue_expression] = STATE(6331),
    [sym_lvalue_expression] = STATE(4397),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2773),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(531),
    [sym_preproc_endregion] = STATE(531),
    [sym_preproc_line] = STATE(531),
    [sym_preproc_pragma] = STATE(531),
    [sym_preproc_nullable] = STATE(531),
    [sym_preproc_error] = STATE(531),
    [sym_preproc_define] = STATE(531),
    [sym_preproc_undef] = STATE(531),
    [aux_sym_class_declaration_repeat1] = STATE(3564),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4143),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_RPAREN] = ACTIONS(2561),
    [anon_sym_ref] = ACTIONS(2563),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_readonly] = ACTIONS(1093),
    [anon_sym_in] = ACTIONS(1095),
    [anon_sym_out] = ACTIONS(1095),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(1103),
    [anon_sym_scoped] = ACTIONS(1105),
    [anon_sym_params] = ACTIONS(1107),
    [anon_sym_var] = ACTIONS(2565),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [532] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_parameter] = STATE(8382),
    [sym__parameter_array] = STATE(8390),
    [sym_argument] = STATE(8919),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6839),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_tuple_element] = STATE(8846),
    [sym_expression] = STATE(5910),
    [sym_non_lvalue_expression] = STATE(6468),
    [sym_lvalue_expression] = STATE(4343),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2773),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(532),
    [sym_preproc_endregion] = STATE(532),
    [sym_preproc_line] = STATE(532),
    [sym_preproc_pragma] = STATE(532),
    [sym_preproc_nullable] = STATE(532),
    [sym_preproc_error] = STATE(532),
    [sym_preproc_define] = STATE(532),
    [sym_preproc_undef] = STATE(532),
    [aux_sym_class_declaration_repeat1] = STATE(3564),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4143),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_RPAREN] = ACTIONS(2561),
    [anon_sym_ref] = ACTIONS(2563),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_readonly] = ACTIONS(1093),
    [anon_sym_in] = ACTIONS(1095),
    [anon_sym_out] = ACTIONS(1095),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(1103),
    [anon_sym_scoped] = ACTIONS(1105),
    [anon_sym_params] = ACTIONS(1107),
    [anon_sym_var] = ACTIONS(2565),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [533] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_parameter] = STATE(8382),
    [sym__parameter_array] = STATE(8390),
    [sym_argument] = STATE(8836),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6829),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_tuple_element] = STATE(8952),
    [sym_expression] = STATE(5910),
    [sym_non_lvalue_expression] = STATE(6331),
    [sym_lvalue_expression] = STATE(4397),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2773),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(533),
    [sym_preproc_endregion] = STATE(533),
    [sym_preproc_line] = STATE(533),
    [sym_preproc_pragma] = STATE(533),
    [sym_preproc_nullable] = STATE(533),
    [sym_preproc_error] = STATE(533),
    [sym_preproc_define] = STATE(533),
    [sym_preproc_undef] = STATE(533),
    [aux_sym_class_declaration_repeat1] = STATE(3564),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4143),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_RPAREN] = ACTIONS(2561),
    [anon_sym_ref] = ACTIONS(2563),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_readonly] = ACTIONS(1093),
    [anon_sym_in] = ACTIONS(1095),
    [anon_sym_out] = ACTIONS(1095),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(1103),
    [anon_sym_scoped] = ACTIONS(1105),
    [anon_sym_params] = ACTIONS(1107),
    [anon_sym_var] = ACTIONS(2565),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [534] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_parameter] = STATE(8382),
    [sym__parameter_array] = STATE(8390),
    [sym_argument] = STATE(8836),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6861),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_tuple_element] = STATE(8846),
    [sym_expression] = STATE(5910),
    [sym_non_lvalue_expression] = STATE(6331),
    [sym_lvalue_expression] = STATE(4383),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2773),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(534),
    [sym_preproc_endregion] = STATE(534),
    [sym_preproc_line] = STATE(534),
    [sym_preproc_pragma] = STATE(534),
    [sym_preproc_nullable] = STATE(534),
    [sym_preproc_error] = STATE(534),
    [sym_preproc_define] = STATE(534),
    [sym_preproc_undef] = STATE(534),
    [aux_sym_class_declaration_repeat1] = STATE(3564),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4143),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_RPAREN] = ACTIONS(2561),
    [anon_sym_ref] = ACTIONS(2563),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_readonly] = ACTIONS(1093),
    [anon_sym_in] = ACTIONS(1095),
    [anon_sym_out] = ACTIONS(1095),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(1103),
    [anon_sym_scoped] = ACTIONS(1105),
    [anon_sym_params] = ACTIONS(1107),
    [anon_sym_var] = ACTIONS(2565),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [535] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_parameter] = STATE(8382),
    [sym__parameter_array] = STATE(8390),
    [sym_argument] = STATE(8707),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6795),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_tuple_element] = STATE(8846),
    [sym_expression] = STATE(5910),
    [sym_non_lvalue_expression] = STATE(6457),
    [sym_lvalue_expression] = STATE(4355),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2773),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(535),
    [sym_preproc_endregion] = STATE(535),
    [sym_preproc_line] = STATE(535),
    [sym_preproc_pragma] = STATE(535),
    [sym_preproc_nullable] = STATE(535),
    [sym_preproc_error] = STATE(535),
    [sym_preproc_define] = STATE(535),
    [sym_preproc_undef] = STATE(535),
    [aux_sym_class_declaration_repeat1] = STATE(3564),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4143),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_RPAREN] = ACTIONS(2561),
    [anon_sym_ref] = ACTIONS(2563),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_readonly] = ACTIONS(1093),
    [anon_sym_in] = ACTIONS(1095),
    [anon_sym_out] = ACTIONS(1095),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(1103),
    [anon_sym_scoped] = ACTIONS(1105),
    [anon_sym_params] = ACTIONS(1107),
    [anon_sym_var] = ACTIONS(2565),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [536] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_parameter] = STATE(8382),
    [sym__parameter_array] = STATE(8390),
    [sym_argument] = STATE(8836),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6829),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_tuple_element] = STATE(8706),
    [sym_expression] = STATE(5910),
    [sym_non_lvalue_expression] = STATE(6331),
    [sym_lvalue_expression] = STATE(4397),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2773),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(536),
    [sym_preproc_endregion] = STATE(536),
    [sym_preproc_line] = STATE(536),
    [sym_preproc_pragma] = STATE(536),
    [sym_preproc_nullable] = STATE(536),
    [sym_preproc_error] = STATE(536),
    [sym_preproc_define] = STATE(536),
    [sym_preproc_undef] = STATE(536),
    [aux_sym_class_declaration_repeat1] = STATE(3564),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4143),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_RPAREN] = ACTIONS(2561),
    [anon_sym_ref] = ACTIONS(2563),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_readonly] = ACTIONS(1093),
    [anon_sym_in] = ACTIONS(1095),
    [anon_sym_out] = ACTIONS(1095),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(1103),
    [anon_sym_scoped] = ACTIONS(1105),
    [anon_sym_params] = ACTIONS(1107),
    [anon_sym_var] = ACTIONS(2565),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [537] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_parameter] = STATE(8382),
    [sym__parameter_array] = STATE(8390),
    [sym_argument] = STATE(8919),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6798),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_tuple_element] = STATE(8846),
    [sym_expression] = STATE(5910),
    [sym_non_lvalue_expression] = STATE(6468),
    [sym_lvalue_expression] = STATE(4343),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2773),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(537),
    [sym_preproc_endregion] = STATE(537),
    [sym_preproc_line] = STATE(537),
    [sym_preproc_pragma] = STATE(537),
    [sym_preproc_nullable] = STATE(537),
    [sym_preproc_error] = STATE(537),
    [sym_preproc_define] = STATE(537),
    [sym_preproc_undef] = STATE(537),
    [aux_sym_class_declaration_repeat1] = STATE(3564),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4143),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_RPAREN] = ACTIONS(2561),
    [anon_sym_ref] = ACTIONS(2563),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_readonly] = ACTIONS(1093),
    [anon_sym_in] = ACTIONS(1095),
    [anon_sym_out] = ACTIONS(1095),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(1103),
    [anon_sym_scoped] = ACTIONS(1105),
    [anon_sym_params] = ACTIONS(1107),
    [anon_sym_var] = ACTIONS(2565),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [538] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_parameter] = STATE(8382),
    [sym__parameter_array] = STATE(8390),
    [sym_argument] = STATE(8759),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6808),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_tuple_element] = STATE(8846),
    [sym_expression] = STATE(5910),
    [sym_non_lvalue_expression] = STATE(6506),
    [sym_lvalue_expression] = STATE(4418),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2773),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(538),
    [sym_preproc_endregion] = STATE(538),
    [sym_preproc_line] = STATE(538),
    [sym_preproc_pragma] = STATE(538),
    [sym_preproc_nullable] = STATE(538),
    [sym_preproc_error] = STATE(538),
    [sym_preproc_define] = STATE(538),
    [sym_preproc_undef] = STATE(538),
    [aux_sym_class_declaration_repeat1] = STATE(3564),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4143),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_RPAREN] = ACTIONS(2561),
    [anon_sym_ref] = ACTIONS(2563),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_readonly] = ACTIONS(1093),
    [anon_sym_in] = ACTIONS(1095),
    [anon_sym_out] = ACTIONS(1095),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(1103),
    [anon_sym_scoped] = ACTIONS(1105),
    [anon_sym_params] = ACTIONS(1107),
    [anon_sym_var] = ACTIONS(2565),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [539] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_parameter] = STATE(8382),
    [sym__parameter_array] = STATE(8390),
    [sym_argument] = STATE(8885),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6843),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_tuple_element] = STATE(8846),
    [sym_expression] = STATE(5910),
    [sym_non_lvalue_expression] = STATE(6400),
    [sym_lvalue_expression] = STATE(4370),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2773),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(539),
    [sym_preproc_endregion] = STATE(539),
    [sym_preproc_line] = STATE(539),
    [sym_preproc_pragma] = STATE(539),
    [sym_preproc_nullable] = STATE(539),
    [sym_preproc_error] = STATE(539),
    [sym_preproc_define] = STATE(539),
    [sym_preproc_undef] = STATE(539),
    [aux_sym_class_declaration_repeat1] = STATE(3564),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4143),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_RPAREN] = ACTIONS(2561),
    [anon_sym_ref] = ACTIONS(2563),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_readonly] = ACTIONS(1093),
    [anon_sym_in] = ACTIONS(1095),
    [anon_sym_out] = ACTIONS(1095),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(1103),
    [anon_sym_scoped] = ACTIONS(1105),
    [anon_sym_params] = ACTIONS(1107),
    [anon_sym_var] = ACTIONS(2565),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [540] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_parameter] = STATE(8382),
    [sym__parameter_array] = STATE(8390),
    [sym_argument] = STATE(8836),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6814),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_tuple_element] = STATE(8846),
    [sym_expression] = STATE(5910),
    [sym_non_lvalue_expression] = STATE(6331),
    [sym_lvalue_expression] = STATE(4383),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2773),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(540),
    [sym_preproc_endregion] = STATE(540),
    [sym_preproc_line] = STATE(540),
    [sym_preproc_pragma] = STATE(540),
    [sym_preproc_nullable] = STATE(540),
    [sym_preproc_error] = STATE(540),
    [sym_preproc_define] = STATE(540),
    [sym_preproc_undef] = STATE(540),
    [aux_sym_class_declaration_repeat1] = STATE(3564),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4143),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_RPAREN] = ACTIONS(2561),
    [anon_sym_ref] = ACTIONS(2563),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_readonly] = ACTIONS(1093),
    [anon_sym_in] = ACTIONS(1095),
    [anon_sym_out] = ACTIONS(1095),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(1103),
    [anon_sym_scoped] = ACTIONS(1105),
    [anon_sym_params] = ACTIONS(1107),
    [anon_sym_var] = ACTIONS(2565),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [541] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_parameter] = STATE(8382),
    [sym__parameter_array] = STATE(8390),
    [sym_argument] = STATE(8836),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6868),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_tuple_element] = STATE(8846),
    [sym_expression] = STATE(5910),
    [sym_non_lvalue_expression] = STATE(6331),
    [sym_lvalue_expression] = STATE(4383),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2773),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(541),
    [sym_preproc_endregion] = STATE(541),
    [sym_preproc_line] = STATE(541),
    [sym_preproc_pragma] = STATE(541),
    [sym_preproc_nullable] = STATE(541),
    [sym_preproc_error] = STATE(541),
    [sym_preproc_define] = STATE(541),
    [sym_preproc_undef] = STATE(541),
    [aux_sym_class_declaration_repeat1] = STATE(3564),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4143),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_RPAREN] = ACTIONS(2561),
    [anon_sym_ref] = ACTIONS(2563),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_readonly] = ACTIONS(1093),
    [anon_sym_in] = ACTIONS(1095),
    [anon_sym_out] = ACTIONS(1095),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(1103),
    [anon_sym_scoped] = ACTIONS(1105),
    [anon_sym_params] = ACTIONS(1107),
    [anon_sym_var] = ACTIONS(2565),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [542] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_parameter] = STATE(8382),
    [sym__parameter_array] = STATE(8390),
    [sym_argument] = STATE(8836),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6818),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_tuple_element] = STATE(8846),
    [sym_expression] = STATE(5910),
    [sym_non_lvalue_expression] = STATE(6331),
    [sym_lvalue_expression] = STATE(4383),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2773),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(542),
    [sym_preproc_endregion] = STATE(542),
    [sym_preproc_line] = STATE(542),
    [sym_preproc_pragma] = STATE(542),
    [sym_preproc_nullable] = STATE(542),
    [sym_preproc_error] = STATE(542),
    [sym_preproc_define] = STATE(542),
    [sym_preproc_undef] = STATE(542),
    [aux_sym_class_declaration_repeat1] = STATE(3564),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4143),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_RPAREN] = ACTIONS(2561),
    [anon_sym_ref] = ACTIONS(2563),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_readonly] = ACTIONS(1093),
    [anon_sym_in] = ACTIONS(1095),
    [anon_sym_out] = ACTIONS(1095),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(1103),
    [anon_sym_scoped] = ACTIONS(1105),
    [anon_sym_params] = ACTIONS(1107),
    [anon_sym_var] = ACTIONS(2565),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [543] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_parameter] = STATE(8382),
    [sym__parameter_array] = STATE(8390),
    [sym_argument] = STATE(8885),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6836),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_tuple_element] = STATE(8846),
    [sym_expression] = STATE(5910),
    [sym_non_lvalue_expression] = STATE(6400),
    [sym_lvalue_expression] = STATE(4370),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2773),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(543),
    [sym_preproc_endregion] = STATE(543),
    [sym_preproc_line] = STATE(543),
    [sym_preproc_pragma] = STATE(543),
    [sym_preproc_nullable] = STATE(543),
    [sym_preproc_error] = STATE(543),
    [sym_preproc_define] = STATE(543),
    [sym_preproc_undef] = STATE(543),
    [aux_sym_class_declaration_repeat1] = STATE(3564),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4143),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_RPAREN] = ACTIONS(2561),
    [anon_sym_ref] = ACTIONS(2563),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_readonly] = ACTIONS(1093),
    [anon_sym_in] = ACTIONS(1095),
    [anon_sym_out] = ACTIONS(1095),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(1103),
    [anon_sym_scoped] = ACTIONS(1105),
    [anon_sym_params] = ACTIONS(1107),
    [anon_sym_var] = ACTIONS(2565),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [544] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_parameter] = STATE(8382),
    [sym__parameter_array] = STATE(8390),
    [sym_argument] = STATE(8836),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6860),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_tuple_element] = STATE(8846),
    [sym_expression] = STATE(5910),
    [sym_non_lvalue_expression] = STATE(6331),
    [sym_lvalue_expression] = STATE(4397),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2773),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(544),
    [sym_preproc_endregion] = STATE(544),
    [sym_preproc_line] = STATE(544),
    [sym_preproc_pragma] = STATE(544),
    [sym_preproc_nullable] = STATE(544),
    [sym_preproc_error] = STATE(544),
    [sym_preproc_define] = STATE(544),
    [sym_preproc_undef] = STATE(544),
    [aux_sym_class_declaration_repeat1] = STATE(3564),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4143),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_RPAREN] = ACTIONS(2561),
    [anon_sym_ref] = ACTIONS(2563),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_readonly] = ACTIONS(1093),
    [anon_sym_in] = ACTIONS(1095),
    [anon_sym_out] = ACTIONS(1095),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(1103),
    [anon_sym_scoped] = ACTIONS(1105),
    [anon_sym_params] = ACTIONS(1107),
    [anon_sym_var] = ACTIONS(2565),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [545] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_parameter] = STATE(8382),
    [sym__parameter_array] = STATE(8390),
    [sym_argument] = STATE(8885),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6821),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_tuple_element] = STATE(8846),
    [sym_expression] = STATE(5910),
    [sym_non_lvalue_expression] = STATE(6400),
    [sym_lvalue_expression] = STATE(4370),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2773),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(545),
    [sym_preproc_endregion] = STATE(545),
    [sym_preproc_line] = STATE(545),
    [sym_preproc_pragma] = STATE(545),
    [sym_preproc_nullable] = STATE(545),
    [sym_preproc_error] = STATE(545),
    [sym_preproc_define] = STATE(545),
    [sym_preproc_undef] = STATE(545),
    [aux_sym_class_declaration_repeat1] = STATE(3564),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4143),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_RPAREN] = ACTIONS(2561),
    [anon_sym_ref] = ACTIONS(2563),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_readonly] = ACTIONS(1093),
    [anon_sym_in] = ACTIONS(1095),
    [anon_sym_out] = ACTIONS(1095),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(1103),
    [anon_sym_scoped] = ACTIONS(1105),
    [anon_sym_params] = ACTIONS(1107),
    [anon_sym_var] = ACTIONS(2565),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [546] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_parameter] = STATE(8382),
    [sym__parameter_array] = STATE(8390),
    [sym_argument] = STATE(8919),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6828),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_tuple_element] = STATE(8846),
    [sym_expression] = STATE(5910),
    [sym_non_lvalue_expression] = STATE(6468),
    [sym_lvalue_expression] = STATE(4397),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2773),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(546),
    [sym_preproc_endregion] = STATE(546),
    [sym_preproc_line] = STATE(546),
    [sym_preproc_pragma] = STATE(546),
    [sym_preproc_nullable] = STATE(546),
    [sym_preproc_error] = STATE(546),
    [sym_preproc_define] = STATE(546),
    [sym_preproc_undef] = STATE(546),
    [aux_sym_class_declaration_repeat1] = STATE(3564),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4143),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_RPAREN] = ACTIONS(2561),
    [anon_sym_ref] = ACTIONS(2563),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_readonly] = ACTIONS(1093),
    [anon_sym_in] = ACTIONS(1095),
    [anon_sym_out] = ACTIONS(1095),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(1103),
    [anon_sym_scoped] = ACTIONS(1105),
    [anon_sym_params] = ACTIONS(1107),
    [anon_sym_var] = ACTIONS(2565),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [547] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_parameter] = STATE(8382),
    [sym__parameter_array] = STATE(8390),
    [sym_argument] = STATE(8885),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6797),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_tuple_element] = STATE(8846),
    [sym_expression] = STATE(5910),
    [sym_non_lvalue_expression] = STATE(6400),
    [sym_lvalue_expression] = STATE(4370),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2773),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(547),
    [sym_preproc_endregion] = STATE(547),
    [sym_preproc_line] = STATE(547),
    [sym_preproc_pragma] = STATE(547),
    [sym_preproc_nullable] = STATE(547),
    [sym_preproc_error] = STATE(547),
    [sym_preproc_define] = STATE(547),
    [sym_preproc_undef] = STATE(547),
    [aux_sym_class_declaration_repeat1] = STATE(3564),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4143),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_RPAREN] = ACTIONS(2561),
    [anon_sym_ref] = ACTIONS(2563),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_readonly] = ACTIONS(1093),
    [anon_sym_in] = ACTIONS(1095),
    [anon_sym_out] = ACTIONS(1095),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(1103),
    [anon_sym_scoped] = ACTIONS(1105),
    [anon_sym_params] = ACTIONS(1107),
    [anon_sym_var] = ACTIONS(2565),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [548] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_parameter] = STATE(8382),
    [sym__parameter_array] = STATE(8390),
    [sym_argument] = STATE(8836),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6815),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_tuple_element] = STATE(8846),
    [sym_expression] = STATE(5910),
    [sym_non_lvalue_expression] = STATE(6331),
    [sym_lvalue_expression] = STATE(4397),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2773),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(548),
    [sym_preproc_endregion] = STATE(548),
    [sym_preproc_line] = STATE(548),
    [sym_preproc_pragma] = STATE(548),
    [sym_preproc_nullable] = STATE(548),
    [sym_preproc_error] = STATE(548),
    [sym_preproc_define] = STATE(548),
    [sym_preproc_undef] = STATE(548),
    [aux_sym_class_declaration_repeat1] = STATE(3564),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4143),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_RPAREN] = ACTIONS(2561),
    [anon_sym_ref] = ACTIONS(2563),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_readonly] = ACTIONS(1093),
    [anon_sym_in] = ACTIONS(1095),
    [anon_sym_out] = ACTIONS(1095),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(1103),
    [anon_sym_scoped] = ACTIONS(1105),
    [anon_sym_params] = ACTIONS(1107),
    [anon_sym_var] = ACTIONS(2565),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [549] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_parameter] = STATE(8382),
    [sym__parameter_array] = STATE(8390),
    [sym_argument] = STATE(8919),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6829),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_tuple_element] = STATE(8846),
    [sym_expression] = STATE(5910),
    [sym_non_lvalue_expression] = STATE(6331),
    [sym_lvalue_expression] = STATE(4343),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2773),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(549),
    [sym_preproc_endregion] = STATE(549),
    [sym_preproc_line] = STATE(549),
    [sym_preproc_pragma] = STATE(549),
    [sym_preproc_nullable] = STATE(549),
    [sym_preproc_error] = STATE(549),
    [sym_preproc_define] = STATE(549),
    [sym_preproc_undef] = STATE(549),
    [aux_sym_class_declaration_repeat1] = STATE(3564),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4143),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_RPAREN] = ACTIONS(2561),
    [anon_sym_ref] = ACTIONS(2563),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_readonly] = ACTIONS(1093),
    [anon_sym_in] = ACTIONS(1095),
    [anon_sym_out] = ACTIONS(1095),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(1103),
    [anon_sym_scoped] = ACTIONS(1105),
    [anon_sym_params] = ACTIONS(1107),
    [anon_sym_var] = ACTIONS(2565),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [550] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_parameter] = STATE(8382),
    [sym__parameter_array] = STATE(8390),
    [sym_argument] = STATE(8885),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6862),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_tuple_element] = STATE(8846),
    [sym_expression] = STATE(5910),
    [sym_non_lvalue_expression] = STATE(6400),
    [sym_lvalue_expression] = STATE(4370),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2773),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(550),
    [sym_preproc_endregion] = STATE(550),
    [sym_preproc_line] = STATE(550),
    [sym_preproc_pragma] = STATE(550),
    [sym_preproc_nullable] = STATE(550),
    [sym_preproc_error] = STATE(550),
    [sym_preproc_define] = STATE(550),
    [sym_preproc_undef] = STATE(550),
    [aux_sym_class_declaration_repeat1] = STATE(3564),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4143),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_RPAREN] = ACTIONS(2561),
    [anon_sym_ref] = ACTIONS(2563),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_readonly] = ACTIONS(1093),
    [anon_sym_in] = ACTIONS(1095),
    [anon_sym_out] = ACTIONS(1095),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(1103),
    [anon_sym_scoped] = ACTIONS(1105),
    [anon_sym_params] = ACTIONS(1107),
    [anon_sym_var] = ACTIONS(2565),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [551] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_parameter] = STATE(8382),
    [sym__parameter_array] = STATE(8390),
    [sym_argument] = STATE(8836),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6852),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_tuple_element] = STATE(8846),
    [sym_expression] = STATE(5910),
    [sym_non_lvalue_expression] = STATE(6331),
    [sym_lvalue_expression] = STATE(4397),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2773),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(551),
    [sym_preproc_endregion] = STATE(551),
    [sym_preproc_line] = STATE(551),
    [sym_preproc_pragma] = STATE(551),
    [sym_preproc_nullable] = STATE(551),
    [sym_preproc_error] = STATE(551),
    [sym_preproc_define] = STATE(551),
    [sym_preproc_undef] = STATE(551),
    [aux_sym_class_declaration_repeat1] = STATE(3564),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4143),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_RPAREN] = ACTIONS(2561),
    [anon_sym_ref] = ACTIONS(2563),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_readonly] = ACTIONS(1093),
    [anon_sym_in] = ACTIONS(1095),
    [anon_sym_out] = ACTIONS(1095),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(1103),
    [anon_sym_scoped] = ACTIONS(1105),
    [anon_sym_params] = ACTIONS(1107),
    [anon_sym_var] = ACTIONS(2565),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [552] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_parameter] = STATE(8382),
    [sym__parameter_array] = STATE(8390),
    [sym_argument] = STATE(8707),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6863),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_tuple_element] = STATE(8846),
    [sym_expression] = STATE(5910),
    [sym_non_lvalue_expression] = STATE(6457),
    [sym_lvalue_expression] = STATE(4355),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2773),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(552),
    [sym_preproc_endregion] = STATE(552),
    [sym_preproc_line] = STATE(552),
    [sym_preproc_pragma] = STATE(552),
    [sym_preproc_nullable] = STATE(552),
    [sym_preproc_error] = STATE(552),
    [sym_preproc_define] = STATE(552),
    [sym_preproc_undef] = STATE(552),
    [aux_sym_class_declaration_repeat1] = STATE(3564),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4143),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_RPAREN] = ACTIONS(2561),
    [anon_sym_ref] = ACTIONS(2563),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_readonly] = ACTIONS(1093),
    [anon_sym_in] = ACTIONS(1095),
    [anon_sym_out] = ACTIONS(1095),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(1103),
    [anon_sym_scoped] = ACTIONS(1105),
    [anon_sym_params] = ACTIONS(1107),
    [anon_sym_var] = ACTIONS(2565),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [553] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_parameter] = STATE(8382),
    [sym__parameter_array] = STATE(8390),
    [sym_argument] = STATE(8836),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6835),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_tuple_element] = STATE(8846),
    [sym_expression] = STATE(5910),
    [sym_non_lvalue_expression] = STATE(6331),
    [sym_lvalue_expression] = STATE(4397),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2773),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(553),
    [sym_preproc_endregion] = STATE(553),
    [sym_preproc_line] = STATE(553),
    [sym_preproc_pragma] = STATE(553),
    [sym_preproc_nullable] = STATE(553),
    [sym_preproc_error] = STATE(553),
    [sym_preproc_define] = STATE(553),
    [sym_preproc_undef] = STATE(553),
    [aux_sym_class_declaration_repeat1] = STATE(3564),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4143),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_RPAREN] = ACTIONS(2561),
    [anon_sym_ref] = ACTIONS(2563),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_readonly] = ACTIONS(1093),
    [anon_sym_in] = ACTIONS(1095),
    [anon_sym_out] = ACTIONS(1095),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(1103),
    [anon_sym_scoped] = ACTIONS(1105),
    [anon_sym_params] = ACTIONS(1107),
    [anon_sym_var] = ACTIONS(2565),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [554] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_parameter] = STATE(8382),
    [sym__parameter_array] = STATE(8390),
    [sym_argument] = STATE(8836),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6858),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_tuple_element] = STATE(8846),
    [sym_expression] = STATE(5910),
    [sym_non_lvalue_expression] = STATE(6331),
    [sym_lvalue_expression] = STATE(4397),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2773),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(554),
    [sym_preproc_endregion] = STATE(554),
    [sym_preproc_line] = STATE(554),
    [sym_preproc_pragma] = STATE(554),
    [sym_preproc_nullable] = STATE(554),
    [sym_preproc_error] = STATE(554),
    [sym_preproc_define] = STATE(554),
    [sym_preproc_undef] = STATE(554),
    [aux_sym_class_declaration_repeat1] = STATE(3564),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4143),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_RPAREN] = ACTIONS(2561),
    [anon_sym_ref] = ACTIONS(2563),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_readonly] = ACTIONS(1093),
    [anon_sym_in] = ACTIONS(1095),
    [anon_sym_out] = ACTIONS(1095),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(1103),
    [anon_sym_scoped] = ACTIONS(1105),
    [anon_sym_params] = ACTIONS(1107),
    [anon_sym_var] = ACTIONS(2565),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [555] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_parameter] = STATE(8382),
    [sym__parameter_array] = STATE(8390),
    [sym_argument] = STATE(8919),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6831),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_tuple_element] = STATE(8846),
    [sym_expression] = STATE(5910),
    [sym_non_lvalue_expression] = STATE(6468),
    [sym_lvalue_expression] = STATE(4343),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2773),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(555),
    [sym_preproc_endregion] = STATE(555),
    [sym_preproc_line] = STATE(555),
    [sym_preproc_pragma] = STATE(555),
    [sym_preproc_nullable] = STATE(555),
    [sym_preproc_error] = STATE(555),
    [sym_preproc_define] = STATE(555),
    [sym_preproc_undef] = STATE(555),
    [aux_sym_class_declaration_repeat1] = STATE(3564),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4143),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_RPAREN] = ACTIONS(2561),
    [anon_sym_ref] = ACTIONS(2563),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_readonly] = ACTIONS(1093),
    [anon_sym_in] = ACTIONS(1095),
    [anon_sym_out] = ACTIONS(1095),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(1103),
    [anon_sym_scoped] = ACTIONS(1105),
    [anon_sym_params] = ACTIONS(1107),
    [anon_sym_var] = ACTIONS(2565),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [556] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_parameter] = STATE(8382),
    [sym__parameter_array] = STATE(8390),
    [sym_argument] = STATE(8836),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6829),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_tuple_element] = STATE(8846),
    [sym_expression] = STATE(5910),
    [sym_non_lvalue_expression] = STATE(6331),
    [sym_lvalue_expression] = STATE(4397),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2773),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(556),
    [sym_preproc_endregion] = STATE(556),
    [sym_preproc_line] = STATE(556),
    [sym_preproc_pragma] = STATE(556),
    [sym_preproc_nullable] = STATE(556),
    [sym_preproc_error] = STATE(556),
    [sym_preproc_define] = STATE(556),
    [sym_preproc_undef] = STATE(556),
    [aux_sym_class_declaration_repeat1] = STATE(3564),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4143),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_RPAREN] = ACTIONS(2561),
    [anon_sym_ref] = ACTIONS(2563),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_readonly] = ACTIONS(1093),
    [anon_sym_in] = ACTIONS(1095),
    [anon_sym_out] = ACTIONS(1095),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(1103),
    [anon_sym_scoped] = ACTIONS(1105),
    [anon_sym_params] = ACTIONS(1107),
    [anon_sym_var] = ACTIONS(2565),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [557] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_parameter] = STATE(8382),
    [sym__parameter_array] = STATE(8390),
    [sym_argument] = STATE(8836),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6849),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_tuple_element] = STATE(8846),
    [sym_expression] = STATE(5910),
    [sym_non_lvalue_expression] = STATE(6331),
    [sym_lvalue_expression] = STATE(4383),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2773),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(557),
    [sym_preproc_endregion] = STATE(557),
    [sym_preproc_line] = STATE(557),
    [sym_preproc_pragma] = STATE(557),
    [sym_preproc_nullable] = STATE(557),
    [sym_preproc_error] = STATE(557),
    [sym_preproc_define] = STATE(557),
    [sym_preproc_undef] = STATE(557),
    [aux_sym_class_declaration_repeat1] = STATE(3564),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4143),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_RPAREN] = ACTIONS(2561),
    [anon_sym_ref] = ACTIONS(2563),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_readonly] = ACTIONS(1093),
    [anon_sym_in] = ACTIONS(1095),
    [anon_sym_out] = ACTIONS(1095),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(1103),
    [anon_sym_scoped] = ACTIONS(1105),
    [anon_sym_params] = ACTIONS(1107),
    [anon_sym_var] = ACTIONS(2565),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [558] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_parameter] = STATE(8382),
    [sym__parameter_array] = STATE(8390),
    [sym_argument] = STATE(8759),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6844),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_tuple_element] = STATE(8846),
    [sym_expression] = STATE(5910),
    [sym_non_lvalue_expression] = STATE(6506),
    [sym_lvalue_expression] = STATE(4418),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2773),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(558),
    [sym_preproc_endregion] = STATE(558),
    [sym_preproc_line] = STATE(558),
    [sym_preproc_pragma] = STATE(558),
    [sym_preproc_nullable] = STATE(558),
    [sym_preproc_error] = STATE(558),
    [sym_preproc_define] = STATE(558),
    [sym_preproc_undef] = STATE(558),
    [aux_sym_class_declaration_repeat1] = STATE(3564),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4143),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_RPAREN] = ACTIONS(2561),
    [anon_sym_ref] = ACTIONS(2563),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_readonly] = ACTIONS(1093),
    [anon_sym_in] = ACTIONS(1095),
    [anon_sym_out] = ACTIONS(1095),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(1103),
    [anon_sym_scoped] = ACTIONS(1105),
    [anon_sym_params] = ACTIONS(1107),
    [anon_sym_var] = ACTIONS(2565),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [559] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_parameter] = STATE(8382),
    [sym__parameter_array] = STATE(8390),
    [sym_argument] = STATE(8836),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6817),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_tuple_element] = STATE(8846),
    [sym_expression] = STATE(5910),
    [sym_non_lvalue_expression] = STATE(6331),
    [sym_lvalue_expression] = STATE(4383),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2773),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(559),
    [sym_preproc_endregion] = STATE(559),
    [sym_preproc_line] = STATE(559),
    [sym_preproc_pragma] = STATE(559),
    [sym_preproc_nullable] = STATE(559),
    [sym_preproc_error] = STATE(559),
    [sym_preproc_define] = STATE(559),
    [sym_preproc_undef] = STATE(559),
    [aux_sym_class_declaration_repeat1] = STATE(3564),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4143),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_RPAREN] = ACTIONS(2561),
    [anon_sym_ref] = ACTIONS(2563),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_readonly] = ACTIONS(1093),
    [anon_sym_in] = ACTIONS(1095),
    [anon_sym_out] = ACTIONS(1095),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(1103),
    [anon_sym_scoped] = ACTIONS(1105),
    [anon_sym_params] = ACTIONS(1107),
    [anon_sym_var] = ACTIONS(2565),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [560] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_parameter] = STATE(8382),
    [sym__parameter_array] = STATE(8390),
    [sym_argument] = STATE(8885),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6865),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_tuple_element] = STATE(8846),
    [sym_expression] = STATE(5910),
    [sym_non_lvalue_expression] = STATE(6400),
    [sym_lvalue_expression] = STATE(4370),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2773),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(560),
    [sym_preproc_endregion] = STATE(560),
    [sym_preproc_line] = STATE(560),
    [sym_preproc_pragma] = STATE(560),
    [sym_preproc_nullable] = STATE(560),
    [sym_preproc_error] = STATE(560),
    [sym_preproc_define] = STATE(560),
    [sym_preproc_undef] = STATE(560),
    [aux_sym_class_declaration_repeat1] = STATE(3564),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4143),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_RPAREN] = ACTIONS(2561),
    [anon_sym_ref] = ACTIONS(2563),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_readonly] = ACTIONS(1093),
    [anon_sym_in] = ACTIONS(1095),
    [anon_sym_out] = ACTIONS(1095),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(1103),
    [anon_sym_scoped] = ACTIONS(1105),
    [anon_sym_params] = ACTIONS(1107),
    [anon_sym_var] = ACTIONS(2565),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [561] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_parameter] = STATE(8382),
    [sym__parameter_array] = STATE(8390),
    [sym_argument] = STATE(8885),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6853),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_tuple_element] = STATE(8846),
    [sym_expression] = STATE(5910),
    [sym_non_lvalue_expression] = STATE(6400),
    [sym_lvalue_expression] = STATE(4370),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2773),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(561),
    [sym_preproc_endregion] = STATE(561),
    [sym_preproc_line] = STATE(561),
    [sym_preproc_pragma] = STATE(561),
    [sym_preproc_nullable] = STATE(561),
    [sym_preproc_error] = STATE(561),
    [sym_preproc_define] = STATE(561),
    [sym_preproc_undef] = STATE(561),
    [aux_sym_class_declaration_repeat1] = STATE(3564),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4143),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_RPAREN] = ACTIONS(2561),
    [anon_sym_ref] = ACTIONS(2563),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_readonly] = ACTIONS(1093),
    [anon_sym_in] = ACTIONS(1095),
    [anon_sym_out] = ACTIONS(1095),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(1103),
    [anon_sym_scoped] = ACTIONS(1105),
    [anon_sym_params] = ACTIONS(1107),
    [anon_sym_var] = ACTIONS(2565),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [562] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_parameter] = STATE(8382),
    [sym__parameter_array] = STATE(8390),
    [sym_argument] = STATE(8885),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6829),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_tuple_element] = STATE(8846),
    [sym_expression] = STATE(5910),
    [sym_non_lvalue_expression] = STATE(6331),
    [sym_lvalue_expression] = STATE(4370),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2773),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(562),
    [sym_preproc_endregion] = STATE(562),
    [sym_preproc_line] = STATE(562),
    [sym_preproc_pragma] = STATE(562),
    [sym_preproc_nullable] = STATE(562),
    [sym_preproc_error] = STATE(562),
    [sym_preproc_define] = STATE(562),
    [sym_preproc_undef] = STATE(562),
    [aux_sym_class_declaration_repeat1] = STATE(3564),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4143),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_RPAREN] = ACTIONS(2561),
    [anon_sym_ref] = ACTIONS(2563),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_readonly] = ACTIONS(1093),
    [anon_sym_in] = ACTIONS(1095),
    [anon_sym_out] = ACTIONS(1095),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(1103),
    [anon_sym_scoped] = ACTIONS(1105),
    [anon_sym_params] = ACTIONS(1107),
    [anon_sym_var] = ACTIONS(2565),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [563] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_parameter] = STATE(8382),
    [sym__parameter_array] = STATE(8390),
    [sym_argument] = STATE(8919),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6856),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_tuple_element] = STATE(8846),
    [sym_expression] = STATE(5910),
    [sym_non_lvalue_expression] = STATE(6468),
    [sym_lvalue_expression] = STATE(4343),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2773),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(563),
    [sym_preproc_endregion] = STATE(563),
    [sym_preproc_line] = STATE(563),
    [sym_preproc_pragma] = STATE(563),
    [sym_preproc_nullable] = STATE(563),
    [sym_preproc_error] = STATE(563),
    [sym_preproc_define] = STATE(563),
    [sym_preproc_undef] = STATE(563),
    [aux_sym_class_declaration_repeat1] = STATE(3564),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4143),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_RPAREN] = ACTIONS(2561),
    [anon_sym_ref] = ACTIONS(2563),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_readonly] = ACTIONS(1093),
    [anon_sym_in] = ACTIONS(1095),
    [anon_sym_out] = ACTIONS(1095),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(1103),
    [anon_sym_scoped] = ACTIONS(1105),
    [anon_sym_params] = ACTIONS(1107),
    [anon_sym_var] = ACTIONS(2565),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [564] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_parameter] = STATE(8382),
    [sym__parameter_array] = STATE(8390),
    [sym_argument] = STATE(8836),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6807),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_tuple_element] = STATE(8846),
    [sym_expression] = STATE(5910),
    [sym_non_lvalue_expression] = STATE(6331),
    [sym_lvalue_expression] = STATE(4383),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2773),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(564),
    [sym_preproc_endregion] = STATE(564),
    [sym_preproc_line] = STATE(564),
    [sym_preproc_pragma] = STATE(564),
    [sym_preproc_nullable] = STATE(564),
    [sym_preproc_error] = STATE(564),
    [sym_preproc_define] = STATE(564),
    [sym_preproc_undef] = STATE(564),
    [aux_sym_class_declaration_repeat1] = STATE(3564),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4143),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_RPAREN] = ACTIONS(2561),
    [anon_sym_ref] = ACTIONS(2563),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_readonly] = ACTIONS(1093),
    [anon_sym_in] = ACTIONS(1095),
    [anon_sym_out] = ACTIONS(1095),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(1103),
    [anon_sym_scoped] = ACTIONS(1105),
    [anon_sym_params] = ACTIONS(1107),
    [anon_sym_var] = ACTIONS(2565),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [565] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_parameter] = STATE(8382),
    [sym__parameter_array] = STATE(8390),
    [sym_argument] = STATE(8836),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6813),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_tuple_element] = STATE(8846),
    [sym_expression] = STATE(5910),
    [sym_non_lvalue_expression] = STATE(6331),
    [sym_lvalue_expression] = STATE(4397),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2773),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(565),
    [sym_preproc_endregion] = STATE(565),
    [sym_preproc_line] = STATE(565),
    [sym_preproc_pragma] = STATE(565),
    [sym_preproc_nullable] = STATE(565),
    [sym_preproc_error] = STATE(565),
    [sym_preproc_define] = STATE(565),
    [sym_preproc_undef] = STATE(565),
    [aux_sym_class_declaration_repeat1] = STATE(3564),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4143),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_RPAREN] = ACTIONS(2561),
    [anon_sym_ref] = ACTIONS(2563),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_readonly] = ACTIONS(1093),
    [anon_sym_in] = ACTIONS(1095),
    [anon_sym_out] = ACTIONS(1095),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(1103),
    [anon_sym_scoped] = ACTIONS(1105),
    [anon_sym_params] = ACTIONS(1107),
    [anon_sym_var] = ACTIONS(2565),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [566] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_parameter] = STATE(8382),
    [sym__parameter_array] = STATE(8390),
    [sym_argument] = STATE(8919),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6826),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_tuple_element] = STATE(8846),
    [sym_expression] = STATE(5910),
    [sym_non_lvalue_expression] = STATE(6468),
    [sym_lvalue_expression] = STATE(4343),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2773),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(566),
    [sym_preproc_endregion] = STATE(566),
    [sym_preproc_line] = STATE(566),
    [sym_preproc_pragma] = STATE(566),
    [sym_preproc_nullable] = STATE(566),
    [sym_preproc_error] = STATE(566),
    [sym_preproc_define] = STATE(566),
    [sym_preproc_undef] = STATE(566),
    [aux_sym_class_declaration_repeat1] = STATE(3564),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4143),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_RPAREN] = ACTIONS(2561),
    [anon_sym_ref] = ACTIONS(2563),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_readonly] = ACTIONS(1093),
    [anon_sym_in] = ACTIONS(1095),
    [anon_sym_out] = ACTIONS(1095),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(1103),
    [anon_sym_scoped] = ACTIONS(1105),
    [anon_sym_params] = ACTIONS(1107),
    [anon_sym_var] = ACTIONS(2565),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [567] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_parameter] = STATE(8382),
    [sym__parameter_array] = STATE(8390),
    [sym_argument] = STATE(8919),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6804),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_tuple_element] = STATE(8846),
    [sym_expression] = STATE(5910),
    [sym_non_lvalue_expression] = STATE(6468),
    [sym_lvalue_expression] = STATE(4343),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2773),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(567),
    [sym_preproc_endregion] = STATE(567),
    [sym_preproc_line] = STATE(567),
    [sym_preproc_pragma] = STATE(567),
    [sym_preproc_nullable] = STATE(567),
    [sym_preproc_error] = STATE(567),
    [sym_preproc_define] = STATE(567),
    [sym_preproc_undef] = STATE(567),
    [aux_sym_class_declaration_repeat1] = STATE(3564),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4143),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_RPAREN] = ACTIONS(2561),
    [anon_sym_ref] = ACTIONS(2563),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_readonly] = ACTIONS(1093),
    [anon_sym_in] = ACTIONS(1095),
    [anon_sym_out] = ACTIONS(1095),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(1103),
    [anon_sym_scoped] = ACTIONS(1105),
    [anon_sym_params] = ACTIONS(1107),
    [anon_sym_var] = ACTIONS(2565),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [568] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_parameter] = STATE(8382),
    [sym__parameter_array] = STATE(8390),
    [sym_argument] = STATE(8836),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6848),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_tuple_element] = STATE(8846),
    [sym_expression] = STATE(5910),
    [sym_non_lvalue_expression] = STATE(6331),
    [sym_lvalue_expression] = STATE(4383),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2773),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(568),
    [sym_preproc_endregion] = STATE(568),
    [sym_preproc_line] = STATE(568),
    [sym_preproc_pragma] = STATE(568),
    [sym_preproc_nullable] = STATE(568),
    [sym_preproc_error] = STATE(568),
    [sym_preproc_define] = STATE(568),
    [sym_preproc_undef] = STATE(568),
    [aux_sym_class_declaration_repeat1] = STATE(3564),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4143),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_RPAREN] = ACTIONS(2561),
    [anon_sym_ref] = ACTIONS(2563),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_readonly] = ACTIONS(1093),
    [anon_sym_in] = ACTIONS(1095),
    [anon_sym_out] = ACTIONS(1095),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(1103),
    [anon_sym_scoped] = ACTIONS(1105),
    [anon_sym_params] = ACTIONS(1107),
    [anon_sym_var] = ACTIONS(2565),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [569] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_parameter] = STATE(8382),
    [sym__parameter_array] = STATE(8390),
    [sym_argument] = STATE(8759),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6823),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_tuple_element] = STATE(8846),
    [sym_expression] = STATE(5910),
    [sym_non_lvalue_expression] = STATE(6506),
    [sym_lvalue_expression] = STATE(4418),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2773),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(569),
    [sym_preproc_endregion] = STATE(569),
    [sym_preproc_line] = STATE(569),
    [sym_preproc_pragma] = STATE(569),
    [sym_preproc_nullable] = STATE(569),
    [sym_preproc_error] = STATE(569),
    [sym_preproc_define] = STATE(569),
    [sym_preproc_undef] = STATE(569),
    [aux_sym_class_declaration_repeat1] = STATE(3564),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4143),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_RPAREN] = ACTIONS(2561),
    [anon_sym_ref] = ACTIONS(2563),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_readonly] = ACTIONS(1093),
    [anon_sym_in] = ACTIONS(1095),
    [anon_sym_out] = ACTIONS(1095),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(1103),
    [anon_sym_scoped] = ACTIONS(1105),
    [anon_sym_params] = ACTIONS(1107),
    [anon_sym_var] = ACTIONS(2565),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [570] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_parameter] = STATE(8382),
    [sym__parameter_array] = STATE(8390),
    [sym_argument] = STATE(8836),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6869),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_tuple_element] = STATE(8846),
    [sym_expression] = STATE(5910),
    [sym_non_lvalue_expression] = STATE(6331),
    [sym_lvalue_expression] = STATE(4397),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2773),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(570),
    [sym_preproc_endregion] = STATE(570),
    [sym_preproc_line] = STATE(570),
    [sym_preproc_pragma] = STATE(570),
    [sym_preproc_nullable] = STATE(570),
    [sym_preproc_error] = STATE(570),
    [sym_preproc_define] = STATE(570),
    [sym_preproc_undef] = STATE(570),
    [aux_sym_class_declaration_repeat1] = STATE(3564),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4143),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_RPAREN] = ACTIONS(2561),
    [anon_sym_ref] = ACTIONS(2563),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_readonly] = ACTIONS(1093),
    [anon_sym_in] = ACTIONS(1095),
    [anon_sym_out] = ACTIONS(1095),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(1103),
    [anon_sym_scoped] = ACTIONS(1105),
    [anon_sym_params] = ACTIONS(1107),
    [anon_sym_var] = ACTIONS(2565),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [571] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_parameter] = STATE(8382),
    [sym__parameter_array] = STATE(8390),
    [sym_argument] = STATE(8707),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6846),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_tuple_element] = STATE(8846),
    [sym_expression] = STATE(5910),
    [sym_non_lvalue_expression] = STATE(6457),
    [sym_lvalue_expression] = STATE(4355),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2773),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(571),
    [sym_preproc_endregion] = STATE(571),
    [sym_preproc_line] = STATE(571),
    [sym_preproc_pragma] = STATE(571),
    [sym_preproc_nullable] = STATE(571),
    [sym_preproc_error] = STATE(571),
    [sym_preproc_define] = STATE(571),
    [sym_preproc_undef] = STATE(571),
    [aux_sym_class_declaration_repeat1] = STATE(3564),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4143),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_RPAREN] = ACTIONS(2561),
    [anon_sym_ref] = ACTIONS(2563),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_readonly] = ACTIONS(1093),
    [anon_sym_in] = ACTIONS(1095),
    [anon_sym_out] = ACTIONS(1095),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(1103),
    [anon_sym_scoped] = ACTIONS(1105),
    [anon_sym_params] = ACTIONS(1107),
    [anon_sym_var] = ACTIONS(2565),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [572] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_parameter] = STATE(8382),
    [sym__parameter_array] = STATE(8390),
    [sym_argument] = STATE(8759),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6829),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_tuple_element] = STATE(8846),
    [sym_expression] = STATE(5910),
    [sym_non_lvalue_expression] = STATE(6331),
    [sym_lvalue_expression] = STATE(4418),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2773),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(572),
    [sym_preproc_endregion] = STATE(572),
    [sym_preproc_line] = STATE(572),
    [sym_preproc_pragma] = STATE(572),
    [sym_preproc_nullable] = STATE(572),
    [sym_preproc_error] = STATE(572),
    [sym_preproc_define] = STATE(572),
    [sym_preproc_undef] = STATE(572),
    [aux_sym_class_declaration_repeat1] = STATE(3564),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4143),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_RPAREN] = ACTIONS(2561),
    [anon_sym_ref] = ACTIONS(2563),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_readonly] = ACTIONS(1093),
    [anon_sym_in] = ACTIONS(1095),
    [anon_sym_out] = ACTIONS(1095),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(1103),
    [anon_sym_scoped] = ACTIONS(1105),
    [anon_sym_params] = ACTIONS(1107),
    [anon_sym_var] = ACTIONS(2565),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [573] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_parameter] = STATE(8382),
    [sym__parameter_array] = STATE(8390),
    [sym_argument] = STATE(8919),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6834),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_tuple_element] = STATE(8846),
    [sym_expression] = STATE(5910),
    [sym_non_lvalue_expression] = STATE(6468),
    [sym_lvalue_expression] = STATE(4343),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2773),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(573),
    [sym_preproc_endregion] = STATE(573),
    [sym_preproc_line] = STATE(573),
    [sym_preproc_pragma] = STATE(573),
    [sym_preproc_nullable] = STATE(573),
    [sym_preproc_error] = STATE(573),
    [sym_preproc_define] = STATE(573),
    [sym_preproc_undef] = STATE(573),
    [aux_sym_class_declaration_repeat1] = STATE(3564),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4143),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_RPAREN] = ACTIONS(2561),
    [anon_sym_ref] = ACTIONS(2563),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_readonly] = ACTIONS(1093),
    [anon_sym_in] = ACTIONS(1095),
    [anon_sym_out] = ACTIONS(1095),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(1103),
    [anon_sym_scoped] = ACTIONS(1105),
    [anon_sym_params] = ACTIONS(1107),
    [anon_sym_var] = ACTIONS(2565),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [574] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_parameter] = STATE(8382),
    [sym__parameter_array] = STATE(8390),
    [sym_argument] = STATE(8707),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6802),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_tuple_element] = STATE(8846),
    [sym_expression] = STATE(5910),
    [sym_non_lvalue_expression] = STATE(6457),
    [sym_lvalue_expression] = STATE(4355),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2773),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(574),
    [sym_preproc_endregion] = STATE(574),
    [sym_preproc_line] = STATE(574),
    [sym_preproc_pragma] = STATE(574),
    [sym_preproc_nullable] = STATE(574),
    [sym_preproc_error] = STATE(574),
    [sym_preproc_define] = STATE(574),
    [sym_preproc_undef] = STATE(574),
    [aux_sym_class_declaration_repeat1] = STATE(3564),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4143),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_RPAREN] = ACTIONS(2561),
    [anon_sym_ref] = ACTIONS(2563),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_readonly] = ACTIONS(1093),
    [anon_sym_in] = ACTIONS(1095),
    [anon_sym_out] = ACTIONS(1095),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(1103),
    [anon_sym_scoped] = ACTIONS(1105),
    [anon_sym_params] = ACTIONS(1107),
    [anon_sym_var] = ACTIONS(2565),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [575] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_parameter] = STATE(8382),
    [sym__parameter_array] = STATE(8390),
    [sym_argument] = STATE(8885),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6799),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_tuple_element] = STATE(8846),
    [sym_expression] = STATE(5910),
    [sym_non_lvalue_expression] = STATE(6400),
    [sym_lvalue_expression] = STATE(4370),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2773),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(575),
    [sym_preproc_endregion] = STATE(575),
    [sym_preproc_line] = STATE(575),
    [sym_preproc_pragma] = STATE(575),
    [sym_preproc_nullable] = STATE(575),
    [sym_preproc_error] = STATE(575),
    [sym_preproc_define] = STATE(575),
    [sym_preproc_undef] = STATE(575),
    [aux_sym_class_declaration_repeat1] = STATE(3564),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4143),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_RPAREN] = ACTIONS(2561),
    [anon_sym_ref] = ACTIONS(2563),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_readonly] = ACTIONS(1093),
    [anon_sym_in] = ACTIONS(1095),
    [anon_sym_out] = ACTIONS(1095),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(1103),
    [anon_sym_scoped] = ACTIONS(1105),
    [anon_sym_params] = ACTIONS(1107),
    [anon_sym_var] = ACTIONS(2565),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [576] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_parameter] = STATE(8382),
    [sym__parameter_array] = STATE(8390),
    [sym_argument] = STATE(8836),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6816),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_tuple_element] = STATE(8846),
    [sym_expression] = STATE(5910),
    [sym_non_lvalue_expression] = STATE(6331),
    [sym_lvalue_expression] = STATE(4383),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2773),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(576),
    [sym_preproc_endregion] = STATE(576),
    [sym_preproc_line] = STATE(576),
    [sym_preproc_pragma] = STATE(576),
    [sym_preproc_nullable] = STATE(576),
    [sym_preproc_error] = STATE(576),
    [sym_preproc_define] = STATE(576),
    [sym_preproc_undef] = STATE(576),
    [aux_sym_class_declaration_repeat1] = STATE(3564),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4143),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_RPAREN] = ACTIONS(2561),
    [anon_sym_ref] = ACTIONS(2563),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_readonly] = ACTIONS(1093),
    [anon_sym_in] = ACTIONS(1095),
    [anon_sym_out] = ACTIONS(1095),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(1103),
    [anon_sym_scoped] = ACTIONS(1105),
    [anon_sym_params] = ACTIONS(1107),
    [anon_sym_var] = ACTIONS(2565),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [577] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_parameter] = STATE(8382),
    [sym__parameter_array] = STATE(8390),
    [sym_argument] = STATE(8919),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6803),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_tuple_element] = STATE(8846),
    [sym_expression] = STATE(5910),
    [sym_non_lvalue_expression] = STATE(6468),
    [sym_lvalue_expression] = STATE(4343),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2773),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(577),
    [sym_preproc_endregion] = STATE(577),
    [sym_preproc_line] = STATE(577),
    [sym_preproc_pragma] = STATE(577),
    [sym_preproc_nullable] = STATE(577),
    [sym_preproc_error] = STATE(577),
    [sym_preproc_define] = STATE(577),
    [sym_preproc_undef] = STATE(577),
    [aux_sym_class_declaration_repeat1] = STATE(3564),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4143),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_RPAREN] = ACTIONS(2561),
    [anon_sym_ref] = ACTIONS(2563),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_readonly] = ACTIONS(1093),
    [anon_sym_in] = ACTIONS(1095),
    [anon_sym_out] = ACTIONS(1095),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(1103),
    [anon_sym_scoped] = ACTIONS(1105),
    [anon_sym_params] = ACTIONS(1107),
    [anon_sym_var] = ACTIONS(2565),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [578] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_argument] = STATE(8636),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6664),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2790),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6906),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_tuple_element] = STATE(8931),
    [sym_expression] = STATE(5910),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2767),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(578),
    [sym_preproc_endregion] = STATE(578),
    [sym_preproc_line] = STATE(578),
    [sym_preproc_pragma] = STATE(578),
    [sym_preproc_nullable] = STATE(578),
    [sym_preproc_error] = STATE(578),
    [sym_preproc_define] = STATE(578),
    [sym_preproc_undef] = STATE(578),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_RPAREN] = ACTIONS(2567),
    [anon_sym_ref] = ACTIONS(2569),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_in] = ACTIONS(1055),
    [anon_sym_out] = ACTIONS(1055),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1065),
    [anon_sym_var] = ACTIONS(2571),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [579] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_argument] = STATE(8454),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6664),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2790),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6906),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_tuple_element] = STATE(8934),
    [sym_expression] = STATE(5910),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2767),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(579),
    [sym_preproc_endregion] = STATE(579),
    [sym_preproc_line] = STATE(579),
    [sym_preproc_pragma] = STATE(579),
    [sym_preproc_nullable] = STATE(579),
    [sym_preproc_error] = STATE(579),
    [sym_preproc_define] = STATE(579),
    [sym_preproc_undef] = STATE(579),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_RPAREN] = ACTIONS(2573),
    [anon_sym_ref] = ACTIONS(2569),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_in] = ACTIONS(1055),
    [anon_sym_out] = ACTIONS(1055),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1065),
    [anon_sym_var] = ACTIONS(2571),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [580] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_argument] = STATE(8454),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6664),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2790),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6906),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_tuple_element] = STATE(8921),
    [sym_expression] = STATE(5910),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2767),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(580),
    [sym_preproc_endregion] = STATE(580),
    [sym_preproc_line] = STATE(580),
    [sym_preproc_pragma] = STATE(580),
    [sym_preproc_nullable] = STATE(580),
    [sym_preproc_error] = STATE(580),
    [sym_preproc_define] = STATE(580),
    [sym_preproc_undef] = STATE(580),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_RPAREN] = ACTIONS(2573),
    [anon_sym_ref] = ACTIONS(2569),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_in] = ACTIONS(1055),
    [anon_sym_out] = ACTIONS(1055),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1065),
    [anon_sym_var] = ACTIONS(2571),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [581] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_argument] = STATE(8398),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6664),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2790),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6906),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_tuple_element] = STATE(8887),
    [sym_expression] = STATE(5910),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2767),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(581),
    [sym_preproc_endregion] = STATE(581),
    [sym_preproc_line] = STATE(581),
    [sym_preproc_pragma] = STATE(581),
    [sym_preproc_nullable] = STATE(581),
    [sym_preproc_error] = STATE(581),
    [sym_preproc_define] = STATE(581),
    [sym_preproc_undef] = STATE(581),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_RPAREN] = ACTIONS(2575),
    [anon_sym_ref] = ACTIONS(2569),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_in] = ACTIONS(1055),
    [anon_sym_out] = ACTIONS(1055),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1065),
    [anon_sym_var] = ACTIONS(2571),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [582] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_argument] = STATE(8592),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6664),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2790),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6906),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_tuple_element] = STATE(8761),
    [sym_expression] = STATE(5910),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2767),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(582),
    [sym_preproc_endregion] = STATE(582),
    [sym_preproc_line] = STATE(582),
    [sym_preproc_pragma] = STATE(582),
    [sym_preproc_nullable] = STATE(582),
    [sym_preproc_error] = STATE(582),
    [sym_preproc_define] = STATE(582),
    [sym_preproc_undef] = STATE(582),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_RPAREN] = ACTIONS(2577),
    [anon_sym_ref] = ACTIONS(2569),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_in] = ACTIONS(1055),
    [anon_sym_out] = ACTIONS(1055),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1065),
    [anon_sym_var] = ACTIONS(2571),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [583] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_argument] = STATE(8592),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6664),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2790),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6906),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_tuple_element] = STATE(8921),
    [sym_expression] = STATE(5910),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2767),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(583),
    [sym_preproc_endregion] = STATE(583),
    [sym_preproc_line] = STATE(583),
    [sym_preproc_pragma] = STATE(583),
    [sym_preproc_nullable] = STATE(583),
    [sym_preproc_error] = STATE(583),
    [sym_preproc_define] = STATE(583),
    [sym_preproc_undef] = STATE(583),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_RPAREN] = ACTIONS(2577),
    [anon_sym_ref] = ACTIONS(2569),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_in] = ACTIONS(1055),
    [anon_sym_out] = ACTIONS(1055),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1065),
    [anon_sym_var] = ACTIONS(2571),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [584] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_argument] = STATE(8477),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6664),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2790),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6906),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_tuple_element] = STATE(8706),
    [sym_expression] = STATE(5910),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2767),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(584),
    [sym_preproc_endregion] = STATE(584),
    [sym_preproc_line] = STATE(584),
    [sym_preproc_pragma] = STATE(584),
    [sym_preproc_nullable] = STATE(584),
    [sym_preproc_error] = STATE(584),
    [sym_preproc_define] = STATE(584),
    [sym_preproc_undef] = STATE(584),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_RPAREN] = ACTIONS(2579),
    [anon_sym_ref] = ACTIONS(2569),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_in] = ACTIONS(1055),
    [anon_sym_out] = ACTIONS(1055),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1065),
    [anon_sym_var] = ACTIONS(2571),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [585] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_argument] = STATE(8636),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6971),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5910),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2767),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(585),
    [sym_preproc_endregion] = STATE(585),
    [sym_preproc_line] = STATE(585),
    [sym_preproc_pragma] = STATE(585),
    [sym_preproc_nullable] = STATE(585),
    [sym_preproc_error] = STATE(585),
    [sym_preproc_define] = STATE(585),
    [sym_preproc_undef] = STATE(585),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_RPAREN] = ACTIONS(2567),
    [anon_sym_ref] = ACTIONS(2581),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_in] = ACTIONS(1055),
    [anon_sym_out] = ACTIONS(1055),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [586] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_argument] = STATE(8398),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6971),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5910),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2767),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(586),
    [sym_preproc_endregion] = STATE(586),
    [sym_preproc_line] = STATE(586),
    [sym_preproc_pragma] = STATE(586),
    [sym_preproc_nullable] = STATE(586),
    [sym_preproc_error] = STATE(586),
    [sym_preproc_define] = STATE(586),
    [sym_preproc_undef] = STATE(586),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_RPAREN] = ACTIONS(2575),
    [anon_sym_ref] = ACTIONS(2581),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_in] = ACTIONS(1055),
    [anon_sym_out] = ACTIONS(1055),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [587] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7094),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5252),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_else_in_expression] = STATE(9710),
    [sym_preproc_elif_in_expression] = STATE(9710),
    [sym_preproc_region] = STATE(587),
    [sym_preproc_endregion] = STATE(587),
    [sym_preproc_line] = STATE(587),
    [sym_preproc_pragma] = STATE(587),
    [sym_preproc_nullable] = STATE(587),
    [sym_preproc_error] = STATE(587),
    [sym_preproc_define] = STATE(587),
    [sym_preproc_undef] = STATE(587),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1669),
    [anon_sym_TILDE] = ACTIONS(1669),
    [anon_sym_PLUS_PLUS] = ACTIONS(1669),
    [anon_sym_DASH_DASH] = ACTIONS(1669),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1667),
    [anon_sym_DASH] = ACTIONS(1667),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1669),
    [anon_sym_AMP] = ACTIONS(1669),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_if_token3] = ACTIONS(2583),
    [aux_sym_preproc_else_token1] = ACTIONS(2585),
    [aux_sym_preproc_elif_token1] = ACTIONS(2587),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [588] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_argument] = STATE(8454),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6971),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5910),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2767),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(588),
    [sym_preproc_endregion] = STATE(588),
    [sym_preproc_line] = STATE(588),
    [sym_preproc_pragma] = STATE(588),
    [sym_preproc_nullable] = STATE(588),
    [sym_preproc_error] = STATE(588),
    [sym_preproc_define] = STATE(588),
    [sym_preproc_undef] = STATE(588),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_RPAREN] = ACTIONS(2573),
    [anon_sym_ref] = ACTIONS(2581),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_in] = ACTIONS(1055),
    [anon_sym_out] = ACTIONS(1055),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [589] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7094),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5320),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_else_in_expression] = STATE(9046),
    [sym_preproc_elif_in_expression] = STATE(9046),
    [sym_preproc_region] = STATE(589),
    [sym_preproc_endregion] = STATE(589),
    [sym_preproc_line] = STATE(589),
    [sym_preproc_pragma] = STATE(589),
    [sym_preproc_nullable] = STATE(589),
    [sym_preproc_error] = STATE(589),
    [sym_preproc_define] = STATE(589),
    [sym_preproc_undef] = STATE(589),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1669),
    [anon_sym_TILDE] = ACTIONS(1669),
    [anon_sym_PLUS_PLUS] = ACTIONS(1669),
    [anon_sym_DASH_DASH] = ACTIONS(1669),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1667),
    [anon_sym_DASH] = ACTIONS(1667),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1669),
    [anon_sym_AMP] = ACTIONS(1669),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_if_token3] = ACTIONS(2589),
    [aux_sym_preproc_else_token1] = ACTIONS(2585),
    [aux_sym_preproc_elif_token1] = ACTIONS(2587),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [590] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7094),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5363),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_else_in_expression] = STATE(9583),
    [sym_preproc_elif_in_expression] = STATE(9583),
    [sym_preproc_region] = STATE(590),
    [sym_preproc_endregion] = STATE(590),
    [sym_preproc_line] = STATE(590),
    [sym_preproc_pragma] = STATE(590),
    [sym_preproc_nullable] = STATE(590),
    [sym_preproc_error] = STATE(590),
    [sym_preproc_define] = STATE(590),
    [sym_preproc_undef] = STATE(590),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1669),
    [anon_sym_TILDE] = ACTIONS(1669),
    [anon_sym_PLUS_PLUS] = ACTIONS(1669),
    [anon_sym_DASH_DASH] = ACTIONS(1669),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1667),
    [anon_sym_DASH] = ACTIONS(1667),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1669),
    [anon_sym_AMP] = ACTIONS(1669),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_if_token3] = ACTIONS(2591),
    [aux_sym_preproc_else_token1] = ACTIONS(2585),
    [aux_sym_preproc_elif_token1] = ACTIONS(2587),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [591] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_argument] = STATE(8592),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6971),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5910),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2767),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(591),
    [sym_preproc_endregion] = STATE(591),
    [sym_preproc_line] = STATE(591),
    [sym_preproc_pragma] = STATE(591),
    [sym_preproc_nullable] = STATE(591),
    [sym_preproc_error] = STATE(591),
    [sym_preproc_define] = STATE(591),
    [sym_preproc_undef] = STATE(591),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_RPAREN] = ACTIONS(2577),
    [anon_sym_ref] = ACTIONS(2581),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_in] = ACTIONS(1055),
    [anon_sym_out] = ACTIONS(1055),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [592] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7094),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5327),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_else_in_expression] = STATE(9812),
    [sym_preproc_elif_in_expression] = STATE(9812),
    [sym_preproc_region] = STATE(592),
    [sym_preproc_endregion] = STATE(592),
    [sym_preproc_line] = STATE(592),
    [sym_preproc_pragma] = STATE(592),
    [sym_preproc_nullable] = STATE(592),
    [sym_preproc_error] = STATE(592),
    [sym_preproc_define] = STATE(592),
    [sym_preproc_undef] = STATE(592),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1669),
    [anon_sym_TILDE] = ACTIONS(1669),
    [anon_sym_PLUS_PLUS] = ACTIONS(1669),
    [anon_sym_DASH_DASH] = ACTIONS(1669),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1667),
    [anon_sym_DASH] = ACTIONS(1667),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1669),
    [anon_sym_AMP] = ACTIONS(1669),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_if_token3] = ACTIONS(2593),
    [aux_sym_preproc_else_token1] = ACTIONS(2585),
    [aux_sym_preproc_elif_token1] = ACTIONS(2587),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [593] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7094),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5223),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_else_in_expression] = STATE(9877),
    [sym_preproc_elif_in_expression] = STATE(9877),
    [sym_preproc_region] = STATE(593),
    [sym_preproc_endregion] = STATE(593),
    [sym_preproc_line] = STATE(593),
    [sym_preproc_pragma] = STATE(593),
    [sym_preproc_nullable] = STATE(593),
    [sym_preproc_error] = STATE(593),
    [sym_preproc_define] = STATE(593),
    [sym_preproc_undef] = STATE(593),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1669),
    [anon_sym_TILDE] = ACTIONS(1669),
    [anon_sym_PLUS_PLUS] = ACTIONS(1669),
    [anon_sym_DASH_DASH] = ACTIONS(1669),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1667),
    [anon_sym_DASH] = ACTIONS(1667),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1669),
    [anon_sym_AMP] = ACTIONS(1669),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_if_token3] = ACTIONS(2595),
    [aux_sym_preproc_else_token1] = ACTIONS(2585),
    [aux_sym_preproc_elif_token1] = ACTIONS(2587),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [594] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7094),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5285),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_else_in_expression] = STATE(8979),
    [sym_preproc_elif_in_expression] = STATE(8979),
    [sym_preproc_region] = STATE(594),
    [sym_preproc_endregion] = STATE(594),
    [sym_preproc_line] = STATE(594),
    [sym_preproc_pragma] = STATE(594),
    [sym_preproc_nullable] = STATE(594),
    [sym_preproc_error] = STATE(594),
    [sym_preproc_define] = STATE(594),
    [sym_preproc_undef] = STATE(594),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1669),
    [anon_sym_TILDE] = ACTIONS(1669),
    [anon_sym_PLUS_PLUS] = ACTIONS(1669),
    [anon_sym_DASH_DASH] = ACTIONS(1669),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1667),
    [anon_sym_DASH] = ACTIONS(1667),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1669),
    [anon_sym_AMP] = ACTIONS(1669),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_if_token3] = ACTIONS(2597),
    [aux_sym_preproc_else_token1] = ACTIONS(2585),
    [aux_sym_preproc_elif_token1] = ACTIONS(2587),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [595] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7094),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5284),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_else_in_expression] = STATE(9419),
    [sym_preproc_elif_in_expression] = STATE(9419),
    [sym_preproc_region] = STATE(595),
    [sym_preproc_endregion] = STATE(595),
    [sym_preproc_line] = STATE(595),
    [sym_preproc_pragma] = STATE(595),
    [sym_preproc_nullable] = STATE(595),
    [sym_preproc_error] = STATE(595),
    [sym_preproc_define] = STATE(595),
    [sym_preproc_undef] = STATE(595),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1669),
    [anon_sym_TILDE] = ACTIONS(1669),
    [anon_sym_PLUS_PLUS] = ACTIONS(1669),
    [anon_sym_DASH_DASH] = ACTIONS(1669),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1667),
    [anon_sym_DASH] = ACTIONS(1667),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1669),
    [anon_sym_AMP] = ACTIONS(1669),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_if_token3] = ACTIONS(2599),
    [aux_sym_preproc_else_token1] = ACTIONS(2585),
    [aux_sym_preproc_elif_token1] = ACTIONS(2587),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [596] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_argument] = STATE(8477),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6971),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5910),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2767),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(596),
    [sym_preproc_endregion] = STATE(596),
    [sym_preproc_line] = STATE(596),
    [sym_preproc_pragma] = STATE(596),
    [sym_preproc_nullable] = STATE(596),
    [sym_preproc_error] = STATE(596),
    [sym_preproc_define] = STATE(596),
    [sym_preproc_undef] = STATE(596),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_RPAREN] = ACTIONS(2579),
    [anon_sym_ref] = ACTIONS(2581),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_in] = ACTIONS(1055),
    [anon_sym_out] = ACTIONS(1055),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [597] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_argument] = STATE(8389),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6971),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5910),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2767),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(597),
    [sym_preproc_endregion] = STATE(597),
    [sym_preproc_line] = STATE(597),
    [sym_preproc_pragma] = STATE(597),
    [sym_preproc_nullable] = STATE(597),
    [sym_preproc_error] = STATE(597),
    [sym_preproc_define] = STATE(597),
    [sym_preproc_undef] = STATE(597),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(2557),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_in] = ACTIONS(1055),
    [anon_sym_out] = ACTIONS(1055),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [598] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6698),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5994),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8466),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(598),
    [sym_preproc_endregion] = STATE(598),
    [sym_preproc_line] = STATE(598),
    [sym_preproc_pragma] = STATE(598),
    [sym_preproc_nullable] = STATE(598),
    [sym_preproc_error] = STATE(598),
    [sym_preproc_define] = STATE(598),
    [sym_preproc_undef] = STATE(598),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(2601),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_readonly] = ACTIONS(2603),
    [anon_sym_in] = ACTIONS(2603),
    [anon_sym_out] = ACTIONS(2603),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2265),
    [anon_sym_var] = ACTIONS(2565),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [599] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_argument] = STATE(8836),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6971),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6219),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2767),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(599),
    [sym_preproc_endregion] = STATE(599),
    [sym_preproc_line] = STATE(599),
    [sym_preproc_pragma] = STATE(599),
    [sym_preproc_nullable] = STATE(599),
    [sym_preproc_error] = STATE(599),
    [sym_preproc_define] = STATE(599),
    [sym_preproc_undef] = STATE(599),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(2557),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_in] = ACTIONS(1055),
    [anon_sym_out] = ACTIONS(1055),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [600] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_argument] = STATE(8510),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6971),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5910),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2767),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(600),
    [sym_preproc_endregion] = STATE(600),
    [sym_preproc_line] = STATE(600),
    [sym_preproc_pragma] = STATE(600),
    [sym_preproc_nullable] = STATE(600),
    [sym_preproc_error] = STATE(600),
    [sym_preproc_define] = STATE(600),
    [sym_preproc_undef] = STATE(600),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(2557),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_in] = ACTIONS(1055),
    [anon_sym_out] = ACTIONS(1055),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [601] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_argument] = STATE(8836),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6971),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6156),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2767),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(601),
    [sym_preproc_endregion] = STATE(601),
    [sym_preproc_line] = STATE(601),
    [sym_preproc_pragma] = STATE(601),
    [sym_preproc_nullable] = STATE(601),
    [sym_preproc_error] = STATE(601),
    [sym_preproc_define] = STATE(601),
    [sym_preproc_undef] = STATE(601),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(2557),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_in] = ACTIONS(1055),
    [anon_sym_out] = ACTIONS(1055),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [602] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6971),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5997),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8466),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(602),
    [sym_preproc_endregion] = STATE(602),
    [sym_preproc_line] = STATE(602),
    [sym_preproc_pragma] = STATE(602),
    [sym_preproc_nullable] = STATE(602),
    [sym_preproc_error] = STATE(602),
    [sym_preproc_define] = STATE(602),
    [sym_preproc_undef] = STATE(602),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_readonly] = ACTIONS(2603),
    [anon_sym_in] = ACTIONS(2603),
    [anon_sym_out] = ACTIONS(2603),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [603] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_argument] = STATE(8358),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6971),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5910),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2767),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(603),
    [sym_preproc_endregion] = STATE(603),
    [sym_preproc_line] = STATE(603),
    [sym_preproc_pragma] = STATE(603),
    [sym_preproc_nullable] = STATE(603),
    [sym_preproc_error] = STATE(603),
    [sym_preproc_define] = STATE(603),
    [sym_preproc_undef] = STATE(603),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(2557),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_in] = ACTIONS(1055),
    [anon_sym_out] = ACTIONS(1055),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [604] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_argument] = STATE(8659),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6971),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5910),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2767),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(604),
    [sym_preproc_endregion] = STATE(604),
    [sym_preproc_line] = STATE(604),
    [sym_preproc_pragma] = STATE(604),
    [sym_preproc_nullable] = STATE(604),
    [sym_preproc_error] = STATE(604),
    [sym_preproc_define] = STATE(604),
    [sym_preproc_undef] = STATE(604),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(2557),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_in] = ACTIONS(1055),
    [anon_sym_out] = ACTIONS(1055),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [605] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_argument] = STATE(8464),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6971),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5910),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2767),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(605),
    [sym_preproc_endregion] = STATE(605),
    [sym_preproc_line] = STATE(605),
    [sym_preproc_pragma] = STATE(605),
    [sym_preproc_nullable] = STATE(605),
    [sym_preproc_error] = STATE(605),
    [sym_preproc_define] = STATE(605),
    [sym_preproc_undef] = STATE(605),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(2557),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_in] = ACTIONS(1055),
    [anon_sym_out] = ACTIONS(1055),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [606] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_argument] = STATE(8627),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6971),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5910),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2767),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(606),
    [sym_preproc_endregion] = STATE(606),
    [sym_preproc_line] = STATE(606),
    [sym_preproc_pragma] = STATE(606),
    [sym_preproc_nullable] = STATE(606),
    [sym_preproc_error] = STATE(606),
    [sym_preproc_define] = STATE(606),
    [sym_preproc_undef] = STATE(606),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(2557),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_in] = ACTIONS(1055),
    [anon_sym_out] = ACTIONS(1055),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [607] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_argument] = STATE(8836),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6971),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6135),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2767),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(607),
    [sym_preproc_endregion] = STATE(607),
    [sym_preproc_line] = STATE(607),
    [sym_preproc_pragma] = STATE(607),
    [sym_preproc_nullable] = STATE(607),
    [sym_preproc_error] = STATE(607),
    [sym_preproc_define] = STATE(607),
    [sym_preproc_undef] = STATE(607),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(2557),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_in] = ACTIONS(1055),
    [anon_sym_out] = ACTIONS(1055),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [608] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6673),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2817),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6717),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5796),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4210),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9027),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8466),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(608),
    [sym_preproc_endregion] = STATE(608),
    [sym_preproc_line] = STATE(608),
    [sym_preproc_pragma] = STATE(608),
    [sym_preproc_nullable] = STATE(608),
    [sym_preproc_error] = STATE(608),
    [sym_preproc_define] = STATE(608),
    [sym_preproc_undef] = STATE(608),
    [aux_sym_class_declaration_repeat1] = STATE(3852),
    [aux_sym_lambda_expression_repeat1] = STATE(4220),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1473),
    [anon_sym_ref] = ACTIONS(2605),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_readonly] = ACTIONS(2603),
    [anon_sym_in] = ACTIONS(2603),
    [anon_sym_out] = ACTIONS(2603),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(1479),
    [anon_sym_PLUS_PLUS] = ACTIONS(1479),
    [anon_sym_DASH_DASH] = ACTIONS(1479),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1477),
    [anon_sym_DASH] = ACTIONS(1477),
    [anon_sym_STAR] = ACTIONS(1101),
    [anon_sym_CARET] = ACTIONS(1479),
    [anon_sym_AMP] = ACTIONS(1479),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2265),
    [anon_sym_var] = ACTIONS(2565),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1111),
    [anon_sym_DOT_DOT] = ACTIONS(1115),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [609] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_argument] = STATE(8538),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6971),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5910),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2767),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(609),
    [sym_preproc_endregion] = STATE(609),
    [sym_preproc_line] = STATE(609),
    [sym_preproc_pragma] = STATE(609),
    [sym_preproc_nullable] = STATE(609),
    [sym_preproc_error] = STATE(609),
    [sym_preproc_define] = STATE(609),
    [sym_preproc_undef] = STATE(609),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(2557),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_in] = ACTIONS(1055),
    [anon_sym_out] = ACTIONS(1055),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [610] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_argument] = STATE(8836),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6971),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6134),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2767),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(610),
    [sym_preproc_endregion] = STATE(610),
    [sym_preproc_line] = STATE(610),
    [sym_preproc_pragma] = STATE(610),
    [sym_preproc_nullable] = STATE(610),
    [sym_preproc_error] = STATE(610),
    [sym_preproc_define] = STATE(610),
    [sym_preproc_undef] = STATE(610),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(2557),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_in] = ACTIONS(1055),
    [anon_sym_out] = ACTIONS(1055),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [611] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_argument] = STATE(8627),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6971),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5910),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8355),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2767),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(611),
    [sym_preproc_endregion] = STATE(611),
    [sym_preproc_line] = STATE(611),
    [sym_preproc_pragma] = STATE(611),
    [sym_preproc_nullable] = STATE(611),
    [sym_preproc_error] = STATE(611),
    [sym_preproc_define] = STATE(611),
    [sym_preproc_undef] = STATE(611),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(2581),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_in] = ACTIONS(1055),
    [anon_sym_out] = ACTIONS(1055),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [612] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5765),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(612),
    [sym_preproc_endregion] = STATE(612),
    [sym_preproc_line] = STATE(612),
    [sym_preproc_pragma] = STATE(612),
    [sym_preproc_nullable] = STATE(612),
    [sym_preproc_error] = STATE(612),
    [sym_preproc_define] = STATE(612),
    [sym_preproc_undef] = STATE(612),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_array_rank_specifier_repeat1] = STATE(8404),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_COMMA] = ACTIONS(2607),
    [anon_sym_RBRACK] = ACTIONS(2609),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [613] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6139),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym__anonymous_object_member_declarator] = STATE(8635),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2858),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(613),
    [sym_preproc_endregion] = STATE(613),
    [sym_preproc_line] = STATE(613),
    [sym_preproc_pragma] = STATE(613),
    [sym_preproc_nullable] = STATE(613),
    [sym_preproc_error] = STATE(613),
    [sym_preproc_define] = STATE(613),
    [sym_preproc_undef] = STATE(613),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_COMMA] = ACTIONS(2611),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_RBRACE] = ACTIONS(2613),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [614] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6139),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym__anonymous_object_member_declarator] = STATE(8485),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2858),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(614),
    [sym_preproc_endregion] = STATE(614),
    [sym_preproc_line] = STATE(614),
    [sym_preproc_pragma] = STATE(614),
    [sym_preproc_nullable] = STATE(614),
    [sym_preproc_error] = STATE(614),
    [sym_preproc_define] = STATE(614),
    [sym_preproc_undef] = STATE(614),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_COMMA] = ACTIONS(2615),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_RBRACE] = ACTIONS(2617),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [615] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5970),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(615),
    [sym_preproc_endregion] = STATE(615),
    [sym_preproc_line] = STATE(615),
    [sym_preproc_pragma] = STATE(615),
    [sym_preproc_nullable] = STATE(615),
    [sym_preproc_error] = STATE(615),
    [sym_preproc_define] = STATE(615),
    [sym_preproc_undef] = STATE(615),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_array_rank_specifier_repeat1] = STATE(8483),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_COMMA] = ACTIONS(2607),
    [anon_sym_RBRACK] = ACTIONS(2619),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [616] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6669),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2779),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6405),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6513),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4482),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9438),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(616),
    [sym_preproc_endregion] = STATE(616),
    [sym_preproc_line] = STATE(616),
    [sym_preproc_pragma] = STATE(616),
    [sym_preproc_nullable] = STATE(616),
    [sym_preproc_error] = STATE(616),
    [sym_preproc_define] = STATE(616),
    [sym_preproc_undef] = STATE(616),
    [aux_sym_class_declaration_repeat1] = STATE(3801),
    [aux_sym_lambda_expression_repeat1] = STATE(4134),
    [sym__identifier_token] = ACTIONS(2603),
    [anon_sym_alias] = ACTIONS(2603),
    [anon_sym_global] = ACTIONS(2603),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_ref] = ACTIONS(2603),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(2603),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2603),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_readonly] = ACTIONS(2603),
    [anon_sym_in] = ACTIONS(2603),
    [anon_sym_out] = ACTIONS(2603),
    [anon_sym_where] = ACTIONS(2603),
    [anon_sym_notnull] = ACTIONS(2603),
    [anon_sym_unmanaged] = ACTIONS(2603),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1999),
    [anon_sym_TILDE] = ACTIONS(1999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1999),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_AMP] = ACTIONS(1999),
    [anon_sym_this] = ACTIONS(2603),
    [anon_sym_scoped] = ACTIONS(2603),
    [anon_sym_var] = ACTIONS(2603),
    [sym_predefined_type] = ACTIONS(2603),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(2603),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1281),
    [anon_sym_when] = ACTIONS(2603),
    [anon_sym_await] = ACTIONS(1283),
    [anon_sym_DOT_DOT] = ACTIONS(1285),
    [anon_sym_from] = ACTIONS(2603),
    [anon_sym_into] = ACTIONS(2603),
    [anon_sym_join] = ACTIONS(2603),
    [anon_sym_on] = ACTIONS(2603),
    [anon_sym_equals] = ACTIONS(2603),
    [anon_sym_let] = ACTIONS(2603),
    [anon_sym_orderby] = ACTIONS(2603),
    [anon_sym_ascending] = ACTIONS(2603),
    [anon_sym_descending] = ACTIONS(2603),
    [anon_sym_group] = ACTIONS(2603),
    [anon_sym_by] = ACTIONS(2603),
    [anon_sym_select] = ACTIONS(2603),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [617] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6064),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(617),
    [sym_preproc_endregion] = STATE(617),
    [sym_preproc_line] = STATE(617),
    [sym_preproc_pragma] = STATE(617),
    [sym_preproc_nullable] = STATE(617),
    [sym_preproc_error] = STATE(617),
    [sym_preproc_define] = STATE(617),
    [sym_preproc_undef] = STATE(617),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_array_rank_specifier_repeat1] = STATE(8626),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_COMMA] = ACTIONS(2607),
    [anon_sym_RBRACK] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [618] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5861),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(618),
    [sym_preproc_endregion] = STATE(618),
    [sym_preproc_line] = STATE(618),
    [sym_preproc_pragma] = STATE(618),
    [sym_preproc_nullable] = STATE(618),
    [sym_preproc_error] = STATE(618),
    [sym_preproc_define] = STATE(618),
    [sym_preproc_undef] = STATE(618),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_array_rank_specifier_repeat1] = STATE(8383),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_COMMA] = ACTIONS(2607),
    [anon_sym_RBRACK] = ACTIONS(2625),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [619] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6139),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym__anonymous_object_member_declarator] = STATE(8598),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2858),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(619),
    [sym_preproc_endregion] = STATE(619),
    [sym_preproc_line] = STATE(619),
    [sym_preproc_pragma] = STATE(619),
    [sym_preproc_nullable] = STATE(619),
    [sym_preproc_error] = STATE(619),
    [sym_preproc_define] = STATE(619),
    [sym_preproc_undef] = STATE(619),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_COMMA] = ACTIONS(2627),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_RBRACE] = ACTIONS(2629),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [620] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6024),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(620),
    [sym_preproc_endregion] = STATE(620),
    [sym_preproc_line] = STATE(620),
    [sym_preproc_pragma] = STATE(620),
    [sym_preproc_nullable] = STATE(620),
    [sym_preproc_error] = STATE(620),
    [sym_preproc_define] = STATE(620),
    [sym_preproc_undef] = STATE(620),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_array_rank_specifier_repeat1] = STATE(8507),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_COMMA] = ACTIONS(2607),
    [anon_sym_RBRACK] = ACTIONS(2631),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [621] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6971),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6079),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8615),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(621),
    [sym_preproc_endregion] = STATE(621),
    [sym_preproc_line] = STATE(621),
    [sym_preproc_pragma] = STATE(621),
    [sym_preproc_nullable] = STATE(621),
    [sym_preproc_error] = STATE(621),
    [sym_preproc_define] = STATE(621),
    [sym_preproc_undef] = STATE(621),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(2633),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_in] = ACTIONS(2635),
    [anon_sym_out] = ACTIONS(2635),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [622] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6139),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym__anonymous_object_member_declarator] = STATE(8468),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2858),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(622),
    [sym_preproc_endregion] = STATE(622),
    [sym_preproc_line] = STATE(622),
    [sym_preproc_pragma] = STATE(622),
    [sym_preproc_nullable] = STATE(622),
    [sym_preproc_error] = STATE(622),
    [sym_preproc_define] = STATE(622),
    [sym_preproc_undef] = STATE(622),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_COMMA] = ACTIONS(2637),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_RBRACE] = ACTIONS(2639),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [623] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6139),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym__anonymous_object_member_declarator] = STATE(8484),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2858),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(623),
    [sym_preproc_endregion] = STATE(623),
    [sym_preproc_line] = STATE(623),
    [sym_preproc_pragma] = STATE(623),
    [sym_preproc_nullable] = STATE(623),
    [sym_preproc_error] = STATE(623),
    [sym_preproc_define] = STATE(623),
    [sym_preproc_undef] = STATE(623),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_COMMA] = ACTIONS(2641),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_RBRACE] = ACTIONS(2643),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [624] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6040),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(624),
    [sym_preproc_endregion] = STATE(624),
    [sym_preproc_line] = STATE(624),
    [sym_preproc_pragma] = STATE(624),
    [sym_preproc_nullable] = STATE(624),
    [sym_preproc_error] = STATE(624),
    [sym_preproc_define] = STATE(624),
    [sym_preproc_undef] = STATE(624),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_array_rank_specifier_repeat1] = STATE(8547),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_COMMA] = ACTIONS(2607),
    [anon_sym_RBRACK] = ACTIONS(2645),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [625] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6139),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym__anonymous_object_member_declarator] = STATE(8393),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2858),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(625),
    [sym_preproc_endregion] = STATE(625),
    [sym_preproc_line] = STATE(625),
    [sym_preproc_pragma] = STATE(625),
    [sym_preproc_nullable] = STATE(625),
    [sym_preproc_error] = STATE(625),
    [sym_preproc_define] = STATE(625),
    [sym_preproc_undef] = STATE(625),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_COMMA] = ACTIONS(2647),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_RBRACE] = ACTIONS(2649),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [626] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5784),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(626),
    [sym_preproc_endregion] = STATE(626),
    [sym_preproc_line] = STATE(626),
    [sym_preproc_pragma] = STATE(626),
    [sym_preproc_nullable] = STATE(626),
    [sym_preproc_error] = STATE(626),
    [sym_preproc_define] = STATE(626),
    [sym_preproc_undef] = STATE(626),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_array_rank_specifier_repeat1] = STATE(8361),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_COMMA] = ACTIONS(2607),
    [anon_sym_RBRACK] = ACTIONS(2651),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [627] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5768),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(627),
    [sym_preproc_endregion] = STATE(627),
    [sym_preproc_line] = STATE(627),
    [sym_preproc_pragma] = STATE(627),
    [sym_preproc_nullable] = STATE(627),
    [sym_preproc_error] = STATE(627),
    [sym_preproc_define] = STATE(627),
    [sym_preproc_undef] = STATE(627),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_array_rank_specifier_repeat1] = STATE(8610),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_COMMA] = ACTIONS(2607),
    [anon_sym_RBRACK] = ACTIONS(2653),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [628] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3010),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6980),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6299),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4482),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_member_binding_expression] = STATE(3711),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9438),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(628),
    [sym_preproc_endregion] = STATE(628),
    [sym_preproc_line] = STATE(628),
    [sym_preproc_pragma] = STATE(628),
    [sym_preproc_nullable] = STATE(628),
    [sym_preproc_error] = STATE(628),
    [sym_preproc_define] = STATE(628),
    [sym_preproc_undef] = STATE(628),
    [aux_sym_class_declaration_repeat1] = STATE(3801),
    [aux_sym_lambda_expression_repeat1] = STATE(4134),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1993),
    [anon_sym_ref] = ACTIONS(1995),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1999),
    [anon_sym_TILDE] = ACTIONS(1999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1999),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_AMP] = ACTIONS(1999),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(2655),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1281),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1283),
    [anon_sym_DOT_DOT] = ACTIONS(1285),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [629] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3010),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6980),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6516),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4482),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_member_binding_expression] = STATE(3711),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9438),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(629),
    [sym_preproc_endregion] = STATE(629),
    [sym_preproc_line] = STATE(629),
    [sym_preproc_pragma] = STATE(629),
    [sym_preproc_nullable] = STATE(629),
    [sym_preproc_error] = STATE(629),
    [sym_preproc_define] = STATE(629),
    [sym_preproc_undef] = STATE(629),
    [aux_sym_class_declaration_repeat1] = STATE(3801),
    [aux_sym_lambda_expression_repeat1] = STATE(4134),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1993),
    [anon_sym_ref] = ACTIONS(1995),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1999),
    [anon_sym_TILDE] = ACTIONS(1999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1999),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_AMP] = ACTIONS(1999),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(2657),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1281),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1283),
    [anon_sym_DOT_DOT] = ACTIONS(1285),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [630] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3544),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6980),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6363),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4482),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_member_binding_expression] = STATE(4620),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9438),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(630),
    [sym_preproc_endregion] = STATE(630),
    [sym_preproc_line] = STATE(630),
    [sym_preproc_pragma] = STATE(630),
    [sym_preproc_nullable] = STATE(630),
    [sym_preproc_error] = STATE(630),
    [sym_preproc_define] = STATE(630),
    [sym_preproc_undef] = STATE(630),
    [aux_sym_class_declaration_repeat1] = STATE(3801),
    [aux_sym_lambda_expression_repeat1] = STATE(4134),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(1993),
    [anon_sym_ref] = ACTIONS(1995),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1999),
    [anon_sym_TILDE] = ACTIONS(1999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1999),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_AMP] = ACTIONS(1999),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(2659),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1281),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1283),
    [anon_sym_DOT_DOT] = ACTIONS(1285),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [631] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6139),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym__anonymous_object_member_declarator] = STATE(8829),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2858),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(631),
    [sym_preproc_endregion] = STATE(631),
    [sym_preproc_line] = STATE(631),
    [sym_preproc_pragma] = STATE(631),
    [sym_preproc_nullable] = STATE(631),
    [sym_preproc_error] = STATE(631),
    [sym_preproc_define] = STATE(631),
    [sym_preproc_undef] = STATE(631),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_RBRACE] = ACTIONS(2661),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [632] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3783),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6980),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6435),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4482),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_member_binding_expression] = STATE(3724),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9438),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(632),
    [sym_preproc_endregion] = STATE(632),
    [sym_preproc_line] = STATE(632),
    [sym_preproc_pragma] = STATE(632),
    [sym_preproc_nullable] = STATE(632),
    [sym_preproc_error] = STATE(632),
    [sym_preproc_define] = STATE(632),
    [sym_preproc_undef] = STATE(632),
    [aux_sym_class_declaration_repeat1] = STATE(3801),
    [aux_sym_lambda_expression_repeat1] = STATE(4134),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1993),
    [anon_sym_ref] = ACTIONS(1995),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1999),
    [anon_sym_TILDE] = ACTIONS(1999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1999),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_AMP] = ACTIONS(1999),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(2663),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1281),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1283),
    [anon_sym_DOT_DOT] = ACTIONS(1285),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [633] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6139),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym__anonymous_object_member_declarator] = STATE(8829),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2858),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(633),
    [sym_preproc_endregion] = STATE(633),
    [sym_preproc_line] = STATE(633),
    [sym_preproc_pragma] = STATE(633),
    [sym_preproc_nullable] = STATE(633),
    [sym_preproc_error] = STATE(633),
    [sym_preproc_define] = STATE(633),
    [sym_preproc_undef] = STATE(633),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_RBRACE] = ACTIONS(2665),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [634] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6139),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym__anonymous_object_member_declarator] = STATE(8829),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2858),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(634),
    [sym_preproc_endregion] = STATE(634),
    [sym_preproc_line] = STATE(634),
    [sym_preproc_pragma] = STATE(634),
    [sym_preproc_nullable] = STATE(634),
    [sym_preproc_error] = STATE(634),
    [sym_preproc_define] = STATE(634),
    [sym_preproc_undef] = STATE(634),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_RBRACE] = ACTIONS(2667),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [635] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6139),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym__anonymous_object_member_declarator] = STATE(8829),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2858),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(635),
    [sym_preproc_endregion] = STATE(635),
    [sym_preproc_line] = STATE(635),
    [sym_preproc_pragma] = STATE(635),
    [sym_preproc_nullable] = STATE(635),
    [sym_preproc_error] = STATE(635),
    [sym_preproc_define] = STATE(635),
    [sym_preproc_undef] = STATE(635),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_RBRACE] = ACTIONS(2669),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [636] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_using_variable_declaration] = STATE(9388),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6166),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2779),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6830),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_tuple_element] = STATE(8846),
    [sym_expression] = STATE(6558),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(636),
    [sym_preproc_endregion] = STATE(636),
    [sym_preproc_line] = STATE(636),
    [sym_preproc_pragma] = STATE(636),
    [sym_preproc_nullable] = STATE(636),
    [sym_preproc_error] = STATE(636),
    [sym_preproc_define] = STATE(636),
    [sym_preproc_undef] = STATE(636),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(2671),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1065),
    [anon_sym_var] = ACTIONS(2673),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [637] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3257),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6980),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6471),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4482),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_member_binding_expression] = STATE(4067),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9438),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(637),
    [sym_preproc_endregion] = STATE(637),
    [sym_preproc_line] = STATE(637),
    [sym_preproc_pragma] = STATE(637),
    [sym_preproc_nullable] = STATE(637),
    [sym_preproc_error] = STATE(637),
    [sym_preproc_define] = STATE(637),
    [sym_preproc_undef] = STATE(637),
    [aux_sym_class_declaration_repeat1] = STATE(3801),
    [aux_sym_lambda_expression_repeat1] = STATE(4134),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1993),
    [anon_sym_ref] = ACTIONS(1995),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1999),
    [anon_sym_TILDE] = ACTIONS(1999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1999),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_AMP] = ACTIONS(1999),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(2675),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1281),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1283),
    [anon_sym_DOT_DOT] = ACTIONS(1285),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [638] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5973),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(638),
    [sym_preproc_endregion] = STATE(638),
    [sym_preproc_line] = STATE(638),
    [sym_preproc_pragma] = STATE(638),
    [sym_preproc_nullable] = STATE(638),
    [sym_preproc_error] = STATE(638),
    [sym_preproc_define] = STATE(638),
    [sym_preproc_undef] = STATE(638),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_COMMA] = ACTIONS(927),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_RBRACE] = ACTIONS(2677),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [639] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3020),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6980),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6643),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4482),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_member_binding_expression] = STATE(3724),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9438),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(639),
    [sym_preproc_endregion] = STATE(639),
    [sym_preproc_line] = STATE(639),
    [sym_preproc_pragma] = STATE(639),
    [sym_preproc_nullable] = STATE(639),
    [sym_preproc_error] = STATE(639),
    [sym_preproc_define] = STATE(639),
    [sym_preproc_undef] = STATE(639),
    [aux_sym_class_declaration_repeat1] = STATE(3801),
    [aux_sym_lambda_expression_repeat1] = STATE(4134),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1993),
    [anon_sym_ref] = ACTIONS(1995),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1999),
    [anon_sym_TILDE] = ACTIONS(1999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1999),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_AMP] = ACTIONS(1999),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(2679),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1281),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1283),
    [anon_sym_DOT_DOT] = ACTIONS(1285),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [640] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6664),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2790),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6698),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6232),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8466),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(640),
    [sym_preproc_endregion] = STATE(640),
    [sym_preproc_line] = STATE(640),
    [sym_preproc_pragma] = STATE(640),
    [sym_preproc_nullable] = STATE(640),
    [sym_preproc_error] = STATE(640),
    [sym_preproc_define] = STATE(640),
    [sym_preproc_undef] = STATE(640),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(2681),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_readonly] = ACTIONS(2683),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1065),
    [anon_sym_var] = ACTIONS(2673),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [641] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_variable_declaration] = STATE(9474),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6840),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5828),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4314),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9775),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(641),
    [sym_preproc_endregion] = STATE(641),
    [sym_preproc_line] = STATE(641),
    [sym_preproc_pragma] = STATE(641),
    [sym_preproc_nullable] = STATE(641),
    [sym_preproc_error] = STATE(641),
    [sym_preproc_define] = STATE(641),
    [sym_preproc_undef] = STATE(641),
    [aux_sym_class_declaration_repeat1] = STATE(3835),
    [aux_sym_lambda_expression_repeat1] = STATE(4236),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(2685),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1535),
    [anon_sym_ref] = ACTIONS(1537),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1465),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(885),
    [anon_sym_TILDE] = ACTIONS(885),
    [anon_sym_PLUS_PLUS] = ACTIONS(885),
    [anon_sym_DASH_DASH] = ACTIONS(885),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(887),
    [anon_sym_DASH] = ACTIONS(887),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(885),
    [anon_sym_AMP] = ACTIONS(885),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1539),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1541),
    [anon_sym_DOT_DOT] = ACTIONS(1543),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [642] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3186),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6980),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6377),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4482),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_member_binding_expression] = STATE(3976),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9438),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(642),
    [sym_preproc_endregion] = STATE(642),
    [sym_preproc_line] = STATE(642),
    [sym_preproc_pragma] = STATE(642),
    [sym_preproc_nullable] = STATE(642),
    [sym_preproc_error] = STATE(642),
    [sym_preproc_define] = STATE(642),
    [sym_preproc_undef] = STATE(642),
    [aux_sym_class_declaration_repeat1] = STATE(3801),
    [aux_sym_lambda_expression_repeat1] = STATE(4134),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1993),
    [anon_sym_ref] = ACTIONS(1995),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1999),
    [anon_sym_TILDE] = ACTIONS(1999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1999),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_AMP] = ACTIONS(1999),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(2687),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1281),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1283),
    [anon_sym_DOT_DOT] = ACTIONS(1285),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [643] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_variable_declaration] = STATE(9125),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6840),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6021),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4314),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9775),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(643),
    [sym_preproc_endregion] = STATE(643),
    [sym_preproc_line] = STATE(643),
    [sym_preproc_pragma] = STATE(643),
    [sym_preproc_nullable] = STATE(643),
    [sym_preproc_error] = STATE(643),
    [sym_preproc_define] = STATE(643),
    [sym_preproc_undef] = STATE(643),
    [aux_sym_class_declaration_repeat1] = STATE(3835),
    [aux_sym_lambda_expression_repeat1] = STATE(4236),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(2689),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1535),
    [anon_sym_ref] = ACTIONS(1537),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1465),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(885),
    [anon_sym_TILDE] = ACTIONS(885),
    [anon_sym_PLUS_PLUS] = ACTIONS(885),
    [anon_sym_DASH_DASH] = ACTIONS(885),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(887),
    [anon_sym_DASH] = ACTIONS(887),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(885),
    [anon_sym_AMP] = ACTIONS(885),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1539),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1541),
    [anon_sym_DOT_DOT] = ACTIONS(1543),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [644] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3020),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6980),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6458),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4482),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_member_binding_expression] = STATE(3724),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9438),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(644),
    [sym_preproc_endregion] = STATE(644),
    [sym_preproc_line] = STATE(644),
    [sym_preproc_pragma] = STATE(644),
    [sym_preproc_nullable] = STATE(644),
    [sym_preproc_error] = STATE(644),
    [sym_preproc_define] = STATE(644),
    [sym_preproc_undef] = STATE(644),
    [aux_sym_class_declaration_repeat1] = STATE(3801),
    [aux_sym_lambda_expression_repeat1] = STATE(4134),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1993),
    [anon_sym_ref] = ACTIONS(1995),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1999),
    [anon_sym_TILDE] = ACTIONS(1999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1999),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_AMP] = ACTIONS(1999),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(2679),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1281),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1283),
    [anon_sym_DOT_DOT] = ACTIONS(1285),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [645] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_using_variable_declaration] = STATE(9051),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6166),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2779),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6830),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_tuple_element] = STATE(8846),
    [sym_expression] = STATE(6321),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(645),
    [sym_preproc_endregion] = STATE(645),
    [sym_preproc_line] = STATE(645),
    [sym_preproc_pragma] = STATE(645),
    [sym_preproc_nullable] = STATE(645),
    [sym_preproc_error] = STATE(645),
    [sym_preproc_define] = STATE(645),
    [sym_preproc_undef] = STATE(645),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(2671),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1065),
    [anon_sym_var] = ACTIONS(2673),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [646] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3257),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6980),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6325),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4482),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_member_binding_expression] = STATE(4067),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9438),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(646),
    [sym_preproc_endregion] = STATE(646),
    [sym_preproc_line] = STATE(646),
    [sym_preproc_pragma] = STATE(646),
    [sym_preproc_nullable] = STATE(646),
    [sym_preproc_error] = STATE(646),
    [sym_preproc_define] = STATE(646),
    [sym_preproc_undef] = STATE(646),
    [aux_sym_class_declaration_repeat1] = STATE(3801),
    [aux_sym_lambda_expression_repeat1] = STATE(4134),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1993),
    [anon_sym_ref] = ACTIONS(1995),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1999),
    [anon_sym_TILDE] = ACTIONS(1999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1999),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_AMP] = ACTIONS(1999),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(2675),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1281),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1283),
    [anon_sym_DOT_DOT] = ACTIONS(1285),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [647] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3186),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6980),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6496),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4482),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_member_binding_expression] = STATE(3976),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9438),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(647),
    [sym_preproc_endregion] = STATE(647),
    [sym_preproc_line] = STATE(647),
    [sym_preproc_pragma] = STATE(647),
    [sym_preproc_nullable] = STATE(647),
    [sym_preproc_error] = STATE(647),
    [sym_preproc_define] = STATE(647),
    [sym_preproc_undef] = STATE(647),
    [aux_sym_class_declaration_repeat1] = STATE(3801),
    [aux_sym_lambda_expression_repeat1] = STATE(4134),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1993),
    [anon_sym_ref] = ACTIONS(1995),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1999),
    [anon_sym_TILDE] = ACTIONS(1999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1999),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_AMP] = ACTIONS(1999),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(2687),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1281),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1283),
    [anon_sym_DOT_DOT] = ACTIONS(1285),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [648] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3257),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6980),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6309),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4482),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_member_binding_expression] = STATE(4067),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9438),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(648),
    [sym_preproc_endregion] = STATE(648),
    [sym_preproc_line] = STATE(648),
    [sym_preproc_pragma] = STATE(648),
    [sym_preproc_nullable] = STATE(648),
    [sym_preproc_error] = STATE(648),
    [sym_preproc_define] = STATE(648),
    [sym_preproc_undef] = STATE(648),
    [aux_sym_class_declaration_repeat1] = STATE(3801),
    [aux_sym_lambda_expression_repeat1] = STATE(4134),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1993),
    [anon_sym_ref] = ACTIONS(1995),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1999),
    [anon_sym_TILDE] = ACTIONS(1999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1999),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_AMP] = ACTIONS(1999),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(2675),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1281),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1283),
    [anon_sym_DOT_DOT] = ACTIONS(1285),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [649] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(2843),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5825),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(649),
    [sym_preproc_endregion] = STATE(649),
    [sym_preproc_line] = STATE(649),
    [sym_preproc_pragma] = STATE(649),
    [sym_preproc_nullable] = STATE(649),
    [sym_preproc_error] = STATE(649),
    [sym_preproc_define] = STATE(649),
    [sym_preproc_undef] = STATE(649),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_struct] = ACTIONS(2691),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_readonly] = ACTIONS(2693),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1669),
    [anon_sym_TILDE] = ACTIONS(1669),
    [anon_sym_PLUS_PLUS] = ACTIONS(1669),
    [anon_sym_DASH_DASH] = ACTIONS(1669),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1667),
    [anon_sym_DASH] = ACTIONS(1667),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1669),
    [anon_sym_AMP] = ACTIONS(1669),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [650] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3020),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6980),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6434),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4482),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_member_binding_expression] = STATE(3724),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9438),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(650),
    [sym_preproc_endregion] = STATE(650),
    [sym_preproc_line] = STATE(650),
    [sym_preproc_pragma] = STATE(650),
    [sym_preproc_nullable] = STATE(650),
    [sym_preproc_error] = STATE(650),
    [sym_preproc_define] = STATE(650),
    [sym_preproc_undef] = STATE(650),
    [aux_sym_class_declaration_repeat1] = STATE(3801),
    [aux_sym_lambda_expression_repeat1] = STATE(4134),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1993),
    [anon_sym_ref] = ACTIONS(1995),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1999),
    [anon_sym_TILDE] = ACTIONS(1999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1999),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_AMP] = ACTIONS(1999),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(2679),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1281),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1283),
    [anon_sym_DOT_DOT] = ACTIONS(1285),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [651] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6961),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6433),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9849),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(651),
    [sym_preproc_endregion] = STATE(651),
    [sym_preproc_line] = STATE(651),
    [sym_preproc_pragma] = STATE(651),
    [sym_preproc_nullable] = STATE(651),
    [sym_preproc_error] = STATE(651),
    [sym_preproc_define] = STATE(651),
    [sym_preproc_undef] = STATE(651),
    [aux_sym_class_declaration_repeat1] = STATE(3841),
    [aux_sym_lambda_expression_repeat1] = STATE(4283),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(2695),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1459),
    [anon_sym_ref] = ACTIONS(1461),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1465),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_case] = ACTIONS(2697),
    [anon_sym_default] = ACTIONS(2699),
    [anon_sym_throw] = ACTIONS(1467),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1469),
    [anon_sym_DOT_DOT] = ACTIONS(1471),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [652] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3186),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6980),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6419),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4482),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_member_binding_expression] = STATE(3976),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9438),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(652),
    [sym_preproc_endregion] = STATE(652),
    [sym_preproc_line] = STATE(652),
    [sym_preproc_pragma] = STATE(652),
    [sym_preproc_nullable] = STATE(652),
    [sym_preproc_error] = STATE(652),
    [sym_preproc_define] = STATE(652),
    [sym_preproc_undef] = STATE(652),
    [aux_sym_class_declaration_repeat1] = STATE(3801),
    [aux_sym_lambda_expression_repeat1] = STATE(4134),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1993),
    [anon_sym_ref] = ACTIONS(1995),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1999),
    [anon_sym_TILDE] = ACTIONS(1999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1999),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_AMP] = ACTIONS(1999),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(2687),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1281),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1283),
    [anon_sym_DOT_DOT] = ACTIONS(1285),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [653] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3257),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6980),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6365),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4482),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_member_binding_expression] = STATE(4067),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9438),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(653),
    [sym_preproc_endregion] = STATE(653),
    [sym_preproc_line] = STATE(653),
    [sym_preproc_pragma] = STATE(653),
    [sym_preproc_nullable] = STATE(653),
    [sym_preproc_error] = STATE(653),
    [sym_preproc_define] = STATE(653),
    [sym_preproc_undef] = STATE(653),
    [aux_sym_class_declaration_repeat1] = STATE(3801),
    [aux_sym_lambda_expression_repeat1] = STATE(4134),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1993),
    [anon_sym_ref] = ACTIONS(1995),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1999),
    [anon_sym_TILDE] = ACTIONS(1999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1999),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_AMP] = ACTIONS(1999),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(2675),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1281),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1283),
    [anon_sym_DOT_DOT] = ACTIONS(1285),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [654] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3783),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6980),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6580),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4482),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_member_binding_expression] = STATE(4067),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9438),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(654),
    [sym_preproc_endregion] = STATE(654),
    [sym_preproc_line] = STATE(654),
    [sym_preproc_pragma] = STATE(654),
    [sym_preproc_nullable] = STATE(654),
    [sym_preproc_error] = STATE(654),
    [sym_preproc_define] = STATE(654),
    [sym_preproc_undef] = STATE(654),
    [aux_sym_class_declaration_repeat1] = STATE(3801),
    [aux_sym_lambda_expression_repeat1] = STATE(4134),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1993),
    [anon_sym_ref] = ACTIONS(1995),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1999),
    [anon_sym_TILDE] = ACTIONS(1999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1999),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_AMP] = ACTIONS(1999),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(2675),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1281),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1283),
    [anon_sym_DOT_DOT] = ACTIONS(1285),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [655] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3010),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6980),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6277),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4482),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_member_binding_expression] = STATE(3711),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9438),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(655),
    [sym_preproc_endregion] = STATE(655),
    [sym_preproc_line] = STATE(655),
    [sym_preproc_pragma] = STATE(655),
    [sym_preproc_nullable] = STATE(655),
    [sym_preproc_error] = STATE(655),
    [sym_preproc_define] = STATE(655),
    [sym_preproc_undef] = STATE(655),
    [aux_sym_class_declaration_repeat1] = STATE(3801),
    [aux_sym_lambda_expression_repeat1] = STATE(4134),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1993),
    [anon_sym_ref] = ACTIONS(1995),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1999),
    [anon_sym_TILDE] = ACTIONS(1999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1999),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_AMP] = ACTIONS(1999),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(2655),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1281),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1283),
    [anon_sym_DOT_DOT] = ACTIONS(1285),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [656] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6139),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym__anonymous_object_member_declarator] = STATE(8829),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2858),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(656),
    [sym_preproc_endregion] = STATE(656),
    [sym_preproc_line] = STATE(656),
    [sym_preproc_pragma] = STATE(656),
    [sym_preproc_nullable] = STATE(656),
    [sym_preproc_error] = STATE(656),
    [sym_preproc_define] = STATE(656),
    [sym_preproc_undef] = STATE(656),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_RBRACE] = ACTIONS(2701),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [657] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3186),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6980),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6374),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4482),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_member_binding_expression] = STATE(3976),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9438),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(657),
    [sym_preproc_endregion] = STATE(657),
    [sym_preproc_line] = STATE(657),
    [sym_preproc_pragma] = STATE(657),
    [sym_preproc_nullable] = STATE(657),
    [sym_preproc_error] = STATE(657),
    [sym_preproc_define] = STATE(657),
    [sym_preproc_undef] = STATE(657),
    [aux_sym_class_declaration_repeat1] = STATE(3801),
    [aux_sym_lambda_expression_repeat1] = STATE(4134),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1993),
    [anon_sym_ref] = ACTIONS(1995),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1999),
    [anon_sym_TILDE] = ACTIONS(1999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1999),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_AMP] = ACTIONS(1999),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(2687),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1281),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1283),
    [anon_sym_DOT_DOT] = ACTIONS(1285),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [658] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3257),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6980),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6631),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4482),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_member_binding_expression] = STATE(4067),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9438),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(658),
    [sym_preproc_endregion] = STATE(658),
    [sym_preproc_line] = STATE(658),
    [sym_preproc_pragma] = STATE(658),
    [sym_preproc_nullable] = STATE(658),
    [sym_preproc_error] = STATE(658),
    [sym_preproc_define] = STATE(658),
    [sym_preproc_undef] = STATE(658),
    [aux_sym_class_declaration_repeat1] = STATE(3801),
    [aux_sym_lambda_expression_repeat1] = STATE(4134),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1993),
    [anon_sym_ref] = ACTIONS(1995),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1999),
    [anon_sym_TILDE] = ACTIONS(1999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1999),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_AMP] = ACTIONS(1999),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(2703),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1281),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1283),
    [anon_sym_DOT_DOT] = ACTIONS(1285),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [659] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3010),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6980),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6313),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4482),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_member_binding_expression] = STATE(3711),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9438),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(659),
    [sym_preproc_endregion] = STATE(659),
    [sym_preproc_line] = STATE(659),
    [sym_preproc_pragma] = STATE(659),
    [sym_preproc_nullable] = STATE(659),
    [sym_preproc_error] = STATE(659),
    [sym_preproc_define] = STATE(659),
    [sym_preproc_undef] = STATE(659),
    [aux_sym_class_declaration_repeat1] = STATE(3801),
    [aux_sym_lambda_expression_repeat1] = STATE(4134),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1993),
    [anon_sym_ref] = ACTIONS(1995),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1999),
    [anon_sym_TILDE] = ACTIONS(1999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1999),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_AMP] = ACTIONS(1999),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(2655),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1281),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1283),
    [anon_sym_DOT_DOT] = ACTIONS(1285),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [660] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6698),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6232),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8466),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(660),
    [sym_preproc_endregion] = STATE(660),
    [sym_preproc_line] = STATE(660),
    [sym_preproc_pragma] = STATE(660),
    [sym_preproc_nullable] = STATE(660),
    [sym_preproc_error] = STATE(660),
    [sym_preproc_define] = STATE(660),
    [sym_preproc_undef] = STATE(660),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_readonly] = ACTIONS(2693),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [661] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6139),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym__anonymous_object_member_declarator] = STATE(8829),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2858),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(661),
    [sym_preproc_endregion] = STATE(661),
    [sym_preproc_line] = STATE(661),
    [sym_preproc_pragma] = STATE(661),
    [sym_preproc_nullable] = STATE(661),
    [sym_preproc_error] = STATE(661),
    [sym_preproc_define] = STATE(661),
    [sym_preproc_undef] = STATE(661),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_RBRACE] = ACTIONS(2705),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [662] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6698),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5994),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8466),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(662),
    [sym_preproc_endregion] = STATE(662),
    [sym_preproc_line] = STATE(662),
    [sym_preproc_pragma] = STATE(662),
    [sym_preproc_nullable] = STATE(662),
    [sym_preproc_error] = STATE(662),
    [sym_preproc_define] = STATE(662),
    [sym_preproc_undef] = STATE(662),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_readonly] = ACTIONS(2693),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [663] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5803),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(663),
    [sym_preproc_endregion] = STATE(663),
    [sym_preproc_line] = STATE(663),
    [sym_preproc_pragma] = STATE(663),
    [sym_preproc_nullable] = STATE(663),
    [sym_preproc_error] = STATE(663),
    [sym_preproc_define] = STATE(663),
    [sym_preproc_undef] = STATE(663),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_COMMA] = ACTIONS(915),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_RBRACE] = ACTIONS(2707),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [664] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3020),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6980),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6504),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4482),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_member_binding_expression] = STATE(3724),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9438),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(664),
    [sym_preproc_endregion] = STATE(664),
    [sym_preproc_line] = STATE(664),
    [sym_preproc_pragma] = STATE(664),
    [sym_preproc_nullable] = STATE(664),
    [sym_preproc_error] = STATE(664),
    [sym_preproc_define] = STATE(664),
    [sym_preproc_undef] = STATE(664),
    [aux_sym_class_declaration_repeat1] = STATE(3801),
    [aux_sym_lambda_expression_repeat1] = STATE(4134),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1993),
    [anon_sym_ref] = ACTIONS(1995),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1999),
    [anon_sym_TILDE] = ACTIONS(1999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1999),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_AMP] = ACTIONS(1999),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(2679),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1281),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1283),
    [anon_sym_DOT_DOT] = ACTIONS(1285),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [665] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3257),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6980),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6356),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4482),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_member_binding_expression] = STATE(4067),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9438),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(665),
    [sym_preproc_endregion] = STATE(665),
    [sym_preproc_line] = STATE(665),
    [sym_preproc_pragma] = STATE(665),
    [sym_preproc_nullable] = STATE(665),
    [sym_preproc_error] = STATE(665),
    [sym_preproc_define] = STATE(665),
    [sym_preproc_undef] = STATE(665),
    [aux_sym_class_declaration_repeat1] = STATE(3801),
    [aux_sym_lambda_expression_repeat1] = STATE(4134),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1993),
    [anon_sym_ref] = ACTIONS(1995),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1999),
    [anon_sym_TILDE] = ACTIONS(1999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1999),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_AMP] = ACTIONS(1999),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(2675),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1281),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1283),
    [anon_sym_DOT_DOT] = ACTIONS(1285),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [666] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_using_variable_declaration] = STATE(9066),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6166),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2779),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6830),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_tuple_element] = STATE(8846),
    [sym_expression] = STATE(6290),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(666),
    [sym_preproc_endregion] = STATE(666),
    [sym_preproc_line] = STATE(666),
    [sym_preproc_pragma] = STATE(666),
    [sym_preproc_nullable] = STATE(666),
    [sym_preproc_error] = STATE(666),
    [sym_preproc_define] = STATE(666),
    [sym_preproc_undef] = STATE(666),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(2671),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1065),
    [anon_sym_var] = ACTIONS(2673),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [667] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_using_variable_declaration] = STATE(9576),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6166),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2779),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6830),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_tuple_element] = STATE(8846),
    [sym_expression] = STATE(6491),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(667),
    [sym_preproc_endregion] = STATE(667),
    [sym_preproc_line] = STATE(667),
    [sym_preproc_pragma] = STATE(667),
    [sym_preproc_nullable] = STATE(667),
    [sym_preproc_error] = STATE(667),
    [sym_preproc_define] = STATE(667),
    [sym_preproc_undef] = STATE(667),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(2671),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1065),
    [anon_sym_var] = ACTIONS(2673),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [668] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3872),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6980),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6589),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4482),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_member_binding_expression] = STATE(5659),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9438),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(668),
    [sym_preproc_endregion] = STATE(668),
    [sym_preproc_line] = STATE(668),
    [sym_preproc_pragma] = STATE(668),
    [sym_preproc_nullable] = STATE(668),
    [sym_preproc_error] = STATE(668),
    [sym_preproc_define] = STATE(668),
    [sym_preproc_undef] = STATE(668),
    [aux_sym_class_declaration_repeat1] = STATE(3801),
    [aux_sym_lambda_expression_repeat1] = STATE(4134),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_LPAREN] = ACTIONS(1993),
    [anon_sym_ref] = ACTIONS(1995),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1999),
    [anon_sym_TILDE] = ACTIONS(1999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1999),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_AMP] = ACTIONS(1999),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(2709),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1281),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1283),
    [anon_sym_DOT_DOT] = ACTIONS(1285),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [669] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_using_variable_declaration] = STATE(9274),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6166),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2779),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6830),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_tuple_element] = STATE(8846),
    [sym_expression] = STATE(6380),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(669),
    [sym_preproc_endregion] = STATE(669),
    [sym_preproc_line] = STATE(669),
    [sym_preproc_pragma] = STATE(669),
    [sym_preproc_nullable] = STATE(669),
    [sym_preproc_error] = STATE(669),
    [sym_preproc_define] = STATE(669),
    [sym_preproc_undef] = STATE(669),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(2671),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1065),
    [anon_sym_var] = ACTIONS(2673),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [670] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3783),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6980),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6310),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4482),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_member_binding_expression] = STATE(3711),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9438),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(670),
    [sym_preproc_endregion] = STATE(670),
    [sym_preproc_line] = STATE(670),
    [sym_preproc_pragma] = STATE(670),
    [sym_preproc_nullable] = STATE(670),
    [sym_preproc_error] = STATE(670),
    [sym_preproc_define] = STATE(670),
    [sym_preproc_undef] = STATE(670),
    [aux_sym_class_declaration_repeat1] = STATE(3801),
    [aux_sym_lambda_expression_repeat1] = STATE(4134),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1993),
    [anon_sym_ref] = ACTIONS(1995),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1999),
    [anon_sym_TILDE] = ACTIONS(1999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1999),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_AMP] = ACTIONS(1999),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(2655),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1281),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1283),
    [anon_sym_DOT_DOT] = ACTIONS(1285),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [671] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3872),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6980),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6601),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4482),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_member_binding_expression] = STATE(5659),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9438),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(671),
    [sym_preproc_endregion] = STATE(671),
    [sym_preproc_line] = STATE(671),
    [sym_preproc_pragma] = STATE(671),
    [sym_preproc_nullable] = STATE(671),
    [sym_preproc_error] = STATE(671),
    [sym_preproc_define] = STATE(671),
    [sym_preproc_undef] = STATE(671),
    [aux_sym_class_declaration_repeat1] = STATE(3801),
    [aux_sym_lambda_expression_repeat1] = STATE(4134),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_LPAREN] = ACTIONS(1993),
    [anon_sym_ref] = ACTIONS(1995),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1999),
    [anon_sym_TILDE] = ACTIONS(1999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1999),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_AMP] = ACTIONS(1999),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(2709),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1281),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1283),
    [anon_sym_DOT_DOT] = ACTIONS(1285),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [672] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3544),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6980),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6612),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4482),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_member_binding_expression] = STATE(4620),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9438),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(672),
    [sym_preproc_endregion] = STATE(672),
    [sym_preproc_line] = STATE(672),
    [sym_preproc_pragma] = STATE(672),
    [sym_preproc_nullable] = STATE(672),
    [sym_preproc_error] = STATE(672),
    [sym_preproc_define] = STATE(672),
    [sym_preproc_undef] = STATE(672),
    [aux_sym_class_declaration_repeat1] = STATE(3801),
    [aux_sym_lambda_expression_repeat1] = STATE(4134),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(1993),
    [anon_sym_ref] = ACTIONS(1995),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1999),
    [anon_sym_TILDE] = ACTIONS(1999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1999),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_AMP] = ACTIONS(1999),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(2659),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1281),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1283),
    [anon_sym_DOT_DOT] = ACTIONS(1285),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [673] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5808),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(673),
    [sym_preproc_endregion] = STATE(673),
    [sym_preproc_line] = STATE(673),
    [sym_preproc_pragma] = STATE(673),
    [sym_preproc_nullable] = STATE(673),
    [sym_preproc_error] = STATE(673),
    [sym_preproc_define] = STATE(673),
    [sym_preproc_undef] = STATE(673),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_COMMA] = ACTIONS(877),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_RBRACE] = ACTIONS(2711),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [674] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_variable_declaration] = STATE(9666),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6840),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5945),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4314),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9775),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(674),
    [sym_preproc_endregion] = STATE(674),
    [sym_preproc_line] = STATE(674),
    [sym_preproc_pragma] = STATE(674),
    [sym_preproc_nullable] = STATE(674),
    [sym_preproc_error] = STATE(674),
    [sym_preproc_define] = STATE(674),
    [sym_preproc_undef] = STATE(674),
    [aux_sym_class_declaration_repeat1] = STATE(3835),
    [aux_sym_lambda_expression_repeat1] = STATE(4236),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(2713),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1535),
    [anon_sym_ref] = ACTIONS(1537),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1465),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(885),
    [anon_sym_TILDE] = ACTIONS(885),
    [anon_sym_PLUS_PLUS] = ACTIONS(885),
    [anon_sym_DASH_DASH] = ACTIONS(885),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(887),
    [anon_sym_DASH] = ACTIONS(887),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(885),
    [anon_sym_AMP] = ACTIONS(885),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1539),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1541),
    [anon_sym_DOT_DOT] = ACTIONS(1543),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [675] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6002),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(675),
    [sym_preproc_endregion] = STATE(675),
    [sym_preproc_line] = STATE(675),
    [sym_preproc_pragma] = STATE(675),
    [sym_preproc_nullable] = STATE(675),
    [sym_preproc_error] = STATE(675),
    [sym_preproc_define] = STATE(675),
    [sym_preproc_undef] = STATE(675),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_RBRACE] = ACTIONS(2715),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [676] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3020),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6980),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6393),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4482),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_member_binding_expression] = STATE(3724),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9438),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(676),
    [sym_preproc_endregion] = STATE(676),
    [sym_preproc_line] = STATE(676),
    [sym_preproc_pragma] = STATE(676),
    [sym_preproc_nullable] = STATE(676),
    [sym_preproc_error] = STATE(676),
    [sym_preproc_define] = STATE(676),
    [sym_preproc_undef] = STATE(676),
    [aux_sym_class_declaration_repeat1] = STATE(3801),
    [aux_sym_lambda_expression_repeat1] = STATE(4134),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1993),
    [anon_sym_ref] = ACTIONS(1995),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1999),
    [anon_sym_TILDE] = ACTIONS(1999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1999),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_AMP] = ACTIONS(1999),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(2679),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1281),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1283),
    [anon_sym_DOT_DOT] = ACTIONS(1285),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [677] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_variable_declaration] = STATE(9728),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6840),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5971),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4314),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9775),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(677),
    [sym_preproc_endregion] = STATE(677),
    [sym_preproc_line] = STATE(677),
    [sym_preproc_pragma] = STATE(677),
    [sym_preproc_nullable] = STATE(677),
    [sym_preproc_error] = STATE(677),
    [sym_preproc_define] = STATE(677),
    [sym_preproc_undef] = STATE(677),
    [aux_sym_class_declaration_repeat1] = STATE(3835),
    [aux_sym_lambda_expression_repeat1] = STATE(4236),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(2717),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1535),
    [anon_sym_ref] = ACTIONS(1537),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1465),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(885),
    [anon_sym_TILDE] = ACTIONS(885),
    [anon_sym_PLUS_PLUS] = ACTIONS(885),
    [anon_sym_DASH_DASH] = ACTIONS(885),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(887),
    [anon_sym_DASH] = ACTIONS(887),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(885),
    [anon_sym_AMP] = ACTIONS(885),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1539),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1541),
    [anon_sym_DOT_DOT] = ACTIONS(1543),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [678] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3783),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6980),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6322),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4482),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_member_binding_expression] = STATE(3976),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9438),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(678),
    [sym_preproc_endregion] = STATE(678),
    [sym_preproc_line] = STATE(678),
    [sym_preproc_pragma] = STATE(678),
    [sym_preproc_nullable] = STATE(678),
    [sym_preproc_error] = STATE(678),
    [sym_preproc_define] = STATE(678),
    [sym_preproc_undef] = STATE(678),
    [aux_sym_class_declaration_repeat1] = STATE(3801),
    [aux_sym_lambda_expression_repeat1] = STATE(4134),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1993),
    [anon_sym_ref] = ACTIONS(1995),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1999),
    [anon_sym_TILDE] = ACTIONS(1999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1999),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_AMP] = ACTIONS(1999),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(2687),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1281),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1283),
    [anon_sym_DOT_DOT] = ACTIONS(1285),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [679] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6698),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5760),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8440),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(679),
    [sym_preproc_endregion] = STATE(679),
    [sym_preproc_line] = STATE(679),
    [sym_preproc_pragma] = STATE(679),
    [sym_preproc_nullable] = STATE(679),
    [sym_preproc_error] = STATE(679),
    [sym_preproc_define] = STATE(679),
    [sym_preproc_undef] = STATE(679),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_readonly] = ACTIONS(2693),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [680] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3020),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6980),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6444),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4482),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_member_binding_expression] = STATE(3724),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9438),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(680),
    [sym_preproc_endregion] = STATE(680),
    [sym_preproc_line] = STATE(680),
    [sym_preproc_pragma] = STATE(680),
    [sym_preproc_nullable] = STATE(680),
    [sym_preproc_error] = STATE(680),
    [sym_preproc_define] = STATE(680),
    [sym_preproc_undef] = STATE(680),
    [aux_sym_class_declaration_repeat1] = STATE(3801),
    [aux_sym_lambda_expression_repeat1] = STATE(4134),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1993),
    [anon_sym_ref] = ACTIONS(1995),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1999),
    [anon_sym_TILDE] = ACTIONS(1999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1999),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_AMP] = ACTIONS(1999),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(2679),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1281),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1283),
    [anon_sym_DOT_DOT] = ACTIONS(1285),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [681] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6076),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(681),
    [sym_preproc_endregion] = STATE(681),
    [sym_preproc_line] = STATE(681),
    [sym_preproc_pragma] = STATE(681),
    [sym_preproc_nullable] = STATE(681),
    [sym_preproc_error] = STATE(681),
    [sym_preproc_define] = STATE(681),
    [sym_preproc_undef] = STATE(681),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_COMMA] = ACTIONS(923),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_RBRACE] = ACTIONS(2719),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [682] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3783),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6980),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6635),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4482),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_member_binding_expression] = STATE(3724),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9438),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(682),
    [sym_preproc_endregion] = STATE(682),
    [sym_preproc_line] = STATE(682),
    [sym_preproc_pragma] = STATE(682),
    [sym_preproc_nullable] = STATE(682),
    [sym_preproc_error] = STATE(682),
    [sym_preproc_define] = STATE(682),
    [sym_preproc_undef] = STATE(682),
    [aux_sym_class_declaration_repeat1] = STATE(3801),
    [aux_sym_lambda_expression_repeat1] = STATE(4134),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1993),
    [anon_sym_ref] = ACTIONS(1995),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1999),
    [anon_sym_TILDE] = ACTIONS(1999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1999),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_AMP] = ACTIONS(1999),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(2663),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1281),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1283),
    [anon_sym_DOT_DOT] = ACTIONS(1285),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [683] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_using_variable_declaration] = STATE(9493),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6166),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2779),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6830),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_tuple_element] = STATE(8846),
    [sym_expression] = STATE(6407),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(683),
    [sym_preproc_endregion] = STATE(683),
    [sym_preproc_line] = STATE(683),
    [sym_preproc_pragma] = STATE(683),
    [sym_preproc_nullable] = STATE(683),
    [sym_preproc_error] = STATE(683),
    [sym_preproc_define] = STATE(683),
    [sym_preproc_undef] = STATE(683),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(2671),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1065),
    [anon_sym_var] = ACTIONS(2673),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [684] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6139),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym__anonymous_object_member_declarator] = STATE(8829),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2858),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(684),
    [sym_preproc_endregion] = STATE(684),
    [sym_preproc_line] = STATE(684),
    [sym_preproc_pragma] = STATE(684),
    [sym_preproc_nullable] = STATE(684),
    [sym_preproc_error] = STATE(684),
    [sym_preproc_define] = STATE(684),
    [sym_preproc_undef] = STATE(684),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_RBRACE] = ACTIONS(2721),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [685] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3186),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6980),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6342),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4482),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_member_binding_expression] = STATE(3976),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9438),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(685),
    [sym_preproc_endregion] = STATE(685),
    [sym_preproc_line] = STATE(685),
    [sym_preproc_pragma] = STATE(685),
    [sym_preproc_nullable] = STATE(685),
    [sym_preproc_error] = STATE(685),
    [sym_preproc_define] = STATE(685),
    [sym_preproc_undef] = STATE(685),
    [aux_sym_class_declaration_repeat1] = STATE(3801),
    [aux_sym_lambda_expression_repeat1] = STATE(4134),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1993),
    [anon_sym_ref] = ACTIONS(1995),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1999),
    [anon_sym_TILDE] = ACTIONS(1999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1999),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_AMP] = ACTIONS(1999),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(2687),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1281),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1283),
    [anon_sym_DOT_DOT] = ACTIONS(1285),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [686] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3783),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6980),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6394),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4482),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_member_binding_expression] = STATE(4067),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9438),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(686),
    [sym_preproc_endregion] = STATE(686),
    [sym_preproc_line] = STATE(686),
    [sym_preproc_pragma] = STATE(686),
    [sym_preproc_nullable] = STATE(686),
    [sym_preproc_error] = STATE(686),
    [sym_preproc_define] = STATE(686),
    [sym_preproc_undef] = STATE(686),
    [aux_sym_class_declaration_repeat1] = STATE(3801),
    [aux_sym_lambda_expression_repeat1] = STATE(4134),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1993),
    [anon_sym_ref] = ACTIONS(1995),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1999),
    [anon_sym_TILDE] = ACTIONS(1999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1999),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_AMP] = ACTIONS(1999),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(2675),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1281),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1283),
    [anon_sym_DOT_DOT] = ACTIONS(1285),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [687] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3257),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6980),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6523),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4482),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_member_binding_expression] = STATE(4067),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9438),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(687),
    [sym_preproc_endregion] = STATE(687),
    [sym_preproc_line] = STATE(687),
    [sym_preproc_pragma] = STATE(687),
    [sym_preproc_nullable] = STATE(687),
    [sym_preproc_error] = STATE(687),
    [sym_preproc_define] = STATE(687),
    [sym_preproc_undef] = STATE(687),
    [aux_sym_class_declaration_repeat1] = STATE(3801),
    [aux_sym_lambda_expression_repeat1] = STATE(4134),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1993),
    [anon_sym_ref] = ACTIONS(1995),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1999),
    [anon_sym_TILDE] = ACTIONS(1999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1999),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_AMP] = ACTIONS(1999),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(2675),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1281),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1283),
    [anon_sym_DOT_DOT] = ACTIONS(1285),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [688] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3872),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6980),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6639),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4482),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_member_binding_expression] = STATE(5659),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9438),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(688),
    [sym_preproc_endregion] = STATE(688),
    [sym_preproc_line] = STATE(688),
    [sym_preproc_pragma] = STATE(688),
    [sym_preproc_nullable] = STATE(688),
    [sym_preproc_error] = STATE(688),
    [sym_preproc_define] = STATE(688),
    [sym_preproc_undef] = STATE(688),
    [aux_sym_class_declaration_repeat1] = STATE(3801),
    [aux_sym_lambda_expression_repeat1] = STATE(4134),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_LPAREN] = ACTIONS(1993),
    [anon_sym_ref] = ACTIONS(1995),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1999),
    [anon_sym_TILDE] = ACTIONS(1999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1999),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_AMP] = ACTIONS(1999),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(2709),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1281),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1283),
    [anon_sym_DOT_DOT] = ACTIONS(1285),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [689] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3010),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6980),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6440),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4482),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_member_binding_expression] = STATE(3711),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9438),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(689),
    [sym_preproc_endregion] = STATE(689),
    [sym_preproc_line] = STATE(689),
    [sym_preproc_pragma] = STATE(689),
    [sym_preproc_nullable] = STATE(689),
    [sym_preproc_error] = STATE(689),
    [sym_preproc_define] = STATE(689),
    [sym_preproc_undef] = STATE(689),
    [aux_sym_class_declaration_repeat1] = STATE(3801),
    [aux_sym_lambda_expression_repeat1] = STATE(4134),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1993),
    [anon_sym_ref] = ACTIONS(1995),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1999),
    [anon_sym_TILDE] = ACTIONS(1999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1999),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_AMP] = ACTIONS(1999),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(2655),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1281),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1283),
    [anon_sym_DOT_DOT] = ACTIONS(1285),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [690] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3544),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6980),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6654),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4482),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_member_binding_expression] = STATE(4620),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9438),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(690),
    [sym_preproc_endregion] = STATE(690),
    [sym_preproc_line] = STATE(690),
    [sym_preproc_pragma] = STATE(690),
    [sym_preproc_nullable] = STATE(690),
    [sym_preproc_error] = STATE(690),
    [sym_preproc_define] = STATE(690),
    [sym_preproc_undef] = STATE(690),
    [aux_sym_class_declaration_repeat1] = STATE(3801),
    [aux_sym_lambda_expression_repeat1] = STATE(4134),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(1993),
    [anon_sym_ref] = ACTIONS(1995),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1999),
    [anon_sym_TILDE] = ACTIONS(1999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1999),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_AMP] = ACTIONS(1999),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(2659),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1281),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1283),
    [anon_sym_DOT_DOT] = ACTIONS(1285),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [691] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_using_variable_declaration] = STATE(8976),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6166),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2779),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6830),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_tuple_element] = STATE(8846),
    [sym_expression] = STATE(6438),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(691),
    [sym_preproc_endregion] = STATE(691),
    [sym_preproc_line] = STATE(691),
    [sym_preproc_pragma] = STATE(691),
    [sym_preproc_nullable] = STATE(691),
    [sym_preproc_error] = STATE(691),
    [sym_preproc_define] = STATE(691),
    [sym_preproc_undef] = STATE(691),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(2671),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1065),
    [anon_sym_var] = ACTIONS(2673),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [692] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3020),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6980),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6467),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4482),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_member_binding_expression] = STATE(3724),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9438),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(692),
    [sym_preproc_endregion] = STATE(692),
    [sym_preproc_line] = STATE(692),
    [sym_preproc_pragma] = STATE(692),
    [sym_preproc_nullable] = STATE(692),
    [sym_preproc_error] = STATE(692),
    [sym_preproc_define] = STATE(692),
    [sym_preproc_undef] = STATE(692),
    [aux_sym_class_declaration_repeat1] = STATE(3801),
    [aux_sym_lambda_expression_repeat1] = STATE(4134),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1993),
    [anon_sym_ref] = ACTIONS(1995),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1999),
    [anon_sym_TILDE] = ACTIONS(1999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1999),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_AMP] = ACTIONS(1999),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(2679),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1281),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1283),
    [anon_sym_DOT_DOT] = ACTIONS(1285),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [693] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6961),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6364),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9849),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(693),
    [sym_preproc_endregion] = STATE(693),
    [sym_preproc_line] = STATE(693),
    [sym_preproc_pragma] = STATE(693),
    [sym_preproc_nullable] = STATE(693),
    [sym_preproc_error] = STATE(693),
    [sym_preproc_define] = STATE(693),
    [sym_preproc_undef] = STATE(693),
    [aux_sym_class_declaration_repeat1] = STATE(3841),
    [aux_sym_lambda_expression_repeat1] = STATE(4283),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(2723),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1459),
    [anon_sym_ref] = ACTIONS(1461),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1465),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_case] = ACTIONS(2725),
    [anon_sym_default] = ACTIONS(2727),
    [anon_sym_throw] = ACTIONS(1467),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1469),
    [anon_sym_DOT_DOT] = ACTIONS(1471),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [694] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6139),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym__anonymous_object_member_declarator] = STATE(8829),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2858),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(694),
    [sym_preproc_endregion] = STATE(694),
    [sym_preproc_line] = STATE(694),
    [sym_preproc_pragma] = STATE(694),
    [sym_preproc_nullable] = STATE(694),
    [sym_preproc_error] = STATE(694),
    [sym_preproc_define] = STATE(694),
    [sym_preproc_undef] = STATE(694),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_RBRACE] = ACTIONS(2729),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [695] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6139),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym__anonymous_object_member_declarator] = STATE(8829),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2858),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(695),
    [sym_preproc_endregion] = STATE(695),
    [sym_preproc_line] = STATE(695),
    [sym_preproc_pragma] = STATE(695),
    [sym_preproc_nullable] = STATE(695),
    [sym_preproc_error] = STATE(695),
    [sym_preproc_define] = STATE(695),
    [sym_preproc_undef] = STATE(695),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_RBRACE] = ACTIONS(2731),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [696] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_using_variable_declaration] = STATE(9515),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6166),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2779),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6830),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_tuple_element] = STATE(8846),
    [sym_expression] = STATE(6298),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(696),
    [sym_preproc_endregion] = STATE(696),
    [sym_preproc_line] = STATE(696),
    [sym_preproc_pragma] = STATE(696),
    [sym_preproc_nullable] = STATE(696),
    [sym_preproc_error] = STATE(696),
    [sym_preproc_define] = STATE(696),
    [sym_preproc_undef] = STATE(696),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(2671),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1065),
    [anon_sym_var] = ACTIONS(2673),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [697] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6153),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(697),
    [sym_preproc_endregion] = STATE(697),
    [sym_preproc_line] = STATE(697),
    [sym_preproc_pragma] = STATE(697),
    [sym_preproc_nullable] = STATE(697),
    [sym_preproc_error] = STATE(697),
    [sym_preproc_define] = STATE(697),
    [sym_preproc_undef] = STATE(697),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_COMMA] = ACTIONS(2733),
    [anon_sym_RBRACK] = ACTIONS(2733),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [698] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6139),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym__anonymous_object_member_declarator] = STATE(8829),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2858),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(698),
    [sym_preproc_endregion] = STATE(698),
    [sym_preproc_line] = STATE(698),
    [sym_preproc_pragma] = STATE(698),
    [sym_preproc_nullable] = STATE(698),
    [sym_preproc_error] = STATE(698),
    [sym_preproc_define] = STATE(698),
    [sym_preproc_undef] = STATE(698),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_RBRACE] = ACTIONS(2735),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [699] = {
    [sym_attribute_argument] = STATE(8631),
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6195),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2833),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(699),
    [sym_preproc_endregion] = STATE(699),
    [sym_preproc_line] = STATE(699),
    [sym_preproc_pragma] = STATE(699),
    [sym_preproc_nullable] = STATE(699),
    [sym_preproc_error] = STATE(699),
    [sym_preproc_define] = STATE(699),
    [sym_preproc_undef] = STATE(699),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_RPAREN] = ACTIONS(2737),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [700] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3020),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6980),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6411),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4482),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_member_binding_expression] = STATE(3724),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9438),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(700),
    [sym_preproc_endregion] = STATE(700),
    [sym_preproc_line] = STATE(700),
    [sym_preproc_pragma] = STATE(700),
    [sym_preproc_nullable] = STATE(700),
    [sym_preproc_error] = STATE(700),
    [sym_preproc_define] = STATE(700),
    [sym_preproc_undef] = STATE(700),
    [aux_sym_class_declaration_repeat1] = STATE(3801),
    [aux_sym_lambda_expression_repeat1] = STATE(4134),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1993),
    [anon_sym_ref] = ACTIONS(1995),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1999),
    [anon_sym_TILDE] = ACTIONS(1999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1999),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_AMP] = ACTIONS(1999),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(2679),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1281),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1283),
    [anon_sym_DOT_DOT] = ACTIONS(1285),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [701] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6961),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6485),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9849),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(701),
    [sym_preproc_endregion] = STATE(701),
    [sym_preproc_line] = STATE(701),
    [sym_preproc_pragma] = STATE(701),
    [sym_preproc_nullable] = STATE(701),
    [sym_preproc_error] = STATE(701),
    [sym_preproc_define] = STATE(701),
    [sym_preproc_undef] = STATE(701),
    [aux_sym_class_declaration_repeat1] = STATE(3841),
    [aux_sym_lambda_expression_repeat1] = STATE(4283),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(2739),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1459),
    [anon_sym_ref] = ACTIONS(1461),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1465),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_case] = ACTIONS(2741),
    [anon_sym_default] = ACTIONS(2743),
    [anon_sym_throw] = ACTIONS(1467),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1469),
    [anon_sym_DOT_DOT] = ACTIONS(1471),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [702] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3783),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6980),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6284),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4482),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_member_binding_expression] = STATE(3976),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9438),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(702),
    [sym_preproc_endregion] = STATE(702),
    [sym_preproc_line] = STATE(702),
    [sym_preproc_pragma] = STATE(702),
    [sym_preproc_nullable] = STATE(702),
    [sym_preproc_error] = STATE(702),
    [sym_preproc_define] = STATE(702),
    [sym_preproc_undef] = STATE(702),
    [aux_sym_class_declaration_repeat1] = STATE(3801),
    [aux_sym_lambda_expression_repeat1] = STATE(4134),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1993),
    [anon_sym_ref] = ACTIONS(1995),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1999),
    [anon_sym_TILDE] = ACTIONS(1999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1999),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_AMP] = ACTIONS(1999),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(2687),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1281),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1283),
    [anon_sym_DOT_DOT] = ACTIONS(1285),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [703] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3186),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6980),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6338),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4482),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_member_binding_expression] = STATE(3976),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9438),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(703),
    [sym_preproc_endregion] = STATE(703),
    [sym_preproc_line] = STATE(703),
    [sym_preproc_pragma] = STATE(703),
    [sym_preproc_nullable] = STATE(703),
    [sym_preproc_error] = STATE(703),
    [sym_preproc_define] = STATE(703),
    [sym_preproc_undef] = STATE(703),
    [aux_sym_class_declaration_repeat1] = STATE(3801),
    [aux_sym_lambda_expression_repeat1] = STATE(4134),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1993),
    [anon_sym_ref] = ACTIONS(1995),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1999),
    [anon_sym_TILDE] = ACTIONS(1999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1999),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_AMP] = ACTIONS(1999),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(2687),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1281),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1283),
    [anon_sym_DOT_DOT] = ACTIONS(1285),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [704] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5853),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(704),
    [sym_preproc_endregion] = STATE(704),
    [sym_preproc_line] = STATE(704),
    [sym_preproc_pragma] = STATE(704),
    [sym_preproc_nullable] = STATE(704),
    [sym_preproc_error] = STATE(704),
    [sym_preproc_define] = STATE(704),
    [sym_preproc_undef] = STATE(704),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_COMMA] = ACTIONS(919),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_RBRACE] = ACTIONS(2745),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [705] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3783),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6980),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6412),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4482),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_member_binding_expression] = STATE(4067),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9438),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(705),
    [sym_preproc_endregion] = STATE(705),
    [sym_preproc_line] = STATE(705),
    [sym_preproc_pragma] = STATE(705),
    [sym_preproc_nullable] = STATE(705),
    [sym_preproc_error] = STATE(705),
    [sym_preproc_define] = STATE(705),
    [sym_preproc_undef] = STATE(705),
    [aux_sym_class_declaration_repeat1] = STATE(3801),
    [aux_sym_lambda_expression_repeat1] = STATE(4134),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1993),
    [anon_sym_ref] = ACTIONS(1995),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1999),
    [anon_sym_TILDE] = ACTIONS(1999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1999),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_AMP] = ACTIONS(1999),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(2675),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1281),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1283),
    [anon_sym_DOT_DOT] = ACTIONS(1285),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [706] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3257),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6980),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6528),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4482),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_member_binding_expression] = STATE(4067),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9438),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(706),
    [sym_preproc_endregion] = STATE(706),
    [sym_preproc_line] = STATE(706),
    [sym_preproc_pragma] = STATE(706),
    [sym_preproc_nullable] = STATE(706),
    [sym_preproc_error] = STATE(706),
    [sym_preproc_define] = STATE(706),
    [sym_preproc_undef] = STATE(706),
    [aux_sym_class_declaration_repeat1] = STATE(3801),
    [aux_sym_lambda_expression_repeat1] = STATE(4134),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1993),
    [anon_sym_ref] = ACTIONS(1995),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1999),
    [anon_sym_TILDE] = ACTIONS(1999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1999),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_AMP] = ACTIONS(1999),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(2675),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1281),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1283),
    [anon_sym_DOT_DOT] = ACTIONS(1285),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [707] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3020),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6980),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6497),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4482),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_member_binding_expression] = STATE(3724),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9438),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(707),
    [sym_preproc_endregion] = STATE(707),
    [sym_preproc_line] = STATE(707),
    [sym_preproc_pragma] = STATE(707),
    [sym_preproc_nullable] = STATE(707),
    [sym_preproc_error] = STATE(707),
    [sym_preproc_define] = STATE(707),
    [sym_preproc_undef] = STATE(707),
    [aux_sym_class_declaration_repeat1] = STATE(3801),
    [aux_sym_lambda_expression_repeat1] = STATE(4134),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1993),
    [anon_sym_ref] = ACTIONS(1995),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1999),
    [anon_sym_TILDE] = ACTIONS(1999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1999),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_AMP] = ACTIONS(1999),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(2679),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1281),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1283),
    [anon_sym_DOT_DOT] = ACTIONS(1285),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [708] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3020),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6980),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6609),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4482),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_member_binding_expression] = STATE(3724),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9438),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(708),
    [sym_preproc_endregion] = STATE(708),
    [sym_preproc_line] = STATE(708),
    [sym_preproc_pragma] = STATE(708),
    [sym_preproc_nullable] = STATE(708),
    [sym_preproc_error] = STATE(708),
    [sym_preproc_define] = STATE(708),
    [sym_preproc_undef] = STATE(708),
    [aux_sym_class_declaration_repeat1] = STATE(3801),
    [aux_sym_lambda_expression_repeat1] = STATE(4134),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1993),
    [anon_sym_ref] = ACTIONS(1995),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1999),
    [anon_sym_TILDE] = ACTIONS(1999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1999),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_AMP] = ACTIONS(1999),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(2679),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1281),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1283),
    [anon_sym_DOT_DOT] = ACTIONS(1285),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [709] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3872),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6980),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6421),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4482),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_member_binding_expression] = STATE(5659),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9438),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(709),
    [sym_preproc_endregion] = STATE(709),
    [sym_preproc_line] = STATE(709),
    [sym_preproc_pragma] = STATE(709),
    [sym_preproc_nullable] = STATE(709),
    [sym_preproc_error] = STATE(709),
    [sym_preproc_define] = STATE(709),
    [sym_preproc_undef] = STATE(709),
    [aux_sym_class_declaration_repeat1] = STATE(3801),
    [aux_sym_lambda_expression_repeat1] = STATE(4134),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_LPAREN] = ACTIONS(1993),
    [anon_sym_ref] = ACTIONS(1995),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1999),
    [anon_sym_TILDE] = ACTIONS(1999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1999),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_AMP] = ACTIONS(1999),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(2709),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1281),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1283),
    [anon_sym_DOT_DOT] = ACTIONS(1285),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [710] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3010),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6980),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6499),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4482),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_member_binding_expression] = STATE(3711),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9438),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(710),
    [sym_preproc_endregion] = STATE(710),
    [sym_preproc_line] = STATE(710),
    [sym_preproc_pragma] = STATE(710),
    [sym_preproc_nullable] = STATE(710),
    [sym_preproc_error] = STATE(710),
    [sym_preproc_define] = STATE(710),
    [sym_preproc_undef] = STATE(710),
    [aux_sym_class_declaration_repeat1] = STATE(3801),
    [aux_sym_lambda_expression_repeat1] = STATE(4134),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1993),
    [anon_sym_ref] = ACTIONS(1995),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1999),
    [anon_sym_TILDE] = ACTIONS(1999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1999),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_AMP] = ACTIONS(1999),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(2657),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1281),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1283),
    [anon_sym_DOT_DOT] = ACTIONS(1285),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [711] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3020),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6980),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6448),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4482),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_member_binding_expression] = STATE(3724),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9438),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(711),
    [sym_preproc_endregion] = STATE(711),
    [sym_preproc_line] = STATE(711),
    [sym_preproc_pragma] = STATE(711),
    [sym_preproc_nullable] = STATE(711),
    [sym_preproc_error] = STATE(711),
    [sym_preproc_define] = STATE(711),
    [sym_preproc_undef] = STATE(711),
    [aux_sym_class_declaration_repeat1] = STATE(3801),
    [aux_sym_lambda_expression_repeat1] = STATE(4134),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1993),
    [anon_sym_ref] = ACTIONS(1995),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1999),
    [anon_sym_TILDE] = ACTIONS(1999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1999),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_AMP] = ACTIONS(1999),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(2679),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1281),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1283),
    [anon_sym_DOT_DOT] = ACTIONS(1285),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [712] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6961),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6547),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9849),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(712),
    [sym_preproc_endregion] = STATE(712),
    [sym_preproc_line] = STATE(712),
    [sym_preproc_pragma] = STATE(712),
    [sym_preproc_nullable] = STATE(712),
    [sym_preproc_error] = STATE(712),
    [sym_preproc_define] = STATE(712),
    [sym_preproc_undef] = STATE(712),
    [aux_sym_class_declaration_repeat1] = STATE(3841),
    [aux_sym_lambda_expression_repeat1] = STATE(4283),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(2747),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1459),
    [anon_sym_ref] = ACTIONS(1461),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1465),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_case] = ACTIONS(2749),
    [anon_sym_default] = ACTIONS(2751),
    [anon_sym_throw] = ACTIONS(1467),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1469),
    [anon_sym_DOT_DOT] = ACTIONS(1471),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [713] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(2843),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5825),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(713),
    [sym_preproc_endregion] = STATE(713),
    [sym_preproc_line] = STATE(713),
    [sym_preproc_pragma] = STATE(713),
    [sym_preproc_nullable] = STATE(713),
    [sym_preproc_error] = STATE(713),
    [sym_preproc_define] = STATE(713),
    [sym_preproc_undef] = STATE(713),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_struct] = ACTIONS(2753),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_readonly] = ACTIONS(2693),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1669),
    [anon_sym_TILDE] = ACTIONS(1669),
    [anon_sym_PLUS_PLUS] = ACTIONS(1669),
    [anon_sym_DASH_DASH] = ACTIONS(1669),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1667),
    [anon_sym_DASH] = ACTIONS(1667),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1669),
    [anon_sym_AMP] = ACTIONS(1669),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [714] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3010),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6980),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6392),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4482),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_member_binding_expression] = STATE(3711),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9438),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(714),
    [sym_preproc_endregion] = STATE(714),
    [sym_preproc_line] = STATE(714),
    [sym_preproc_pragma] = STATE(714),
    [sym_preproc_nullable] = STATE(714),
    [sym_preproc_error] = STATE(714),
    [sym_preproc_define] = STATE(714),
    [sym_preproc_undef] = STATE(714),
    [aux_sym_class_declaration_repeat1] = STATE(3801),
    [aux_sym_lambda_expression_repeat1] = STATE(4134),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1993),
    [anon_sym_ref] = ACTIONS(1995),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1999),
    [anon_sym_TILDE] = ACTIONS(1999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1999),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_AMP] = ACTIONS(1999),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(2655),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1281),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1283),
    [anon_sym_DOT_DOT] = ACTIONS(1285),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [715] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3544),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6980),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6461),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4482),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_member_binding_expression] = STATE(4620),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9438),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(715),
    [sym_preproc_endregion] = STATE(715),
    [sym_preproc_line] = STATE(715),
    [sym_preproc_pragma] = STATE(715),
    [sym_preproc_nullable] = STATE(715),
    [sym_preproc_error] = STATE(715),
    [sym_preproc_define] = STATE(715),
    [sym_preproc_undef] = STATE(715),
    [aux_sym_class_declaration_repeat1] = STATE(3801),
    [aux_sym_lambda_expression_repeat1] = STATE(4134),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(1993),
    [anon_sym_ref] = ACTIONS(1995),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1999),
    [anon_sym_TILDE] = ACTIONS(1999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1999),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_AMP] = ACTIONS(1999),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(2659),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1281),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1283),
    [anon_sym_DOT_DOT] = ACTIONS(1285),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [716] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6664),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2790),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6698),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5994),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8466),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(716),
    [sym_preproc_endregion] = STATE(716),
    [sym_preproc_line] = STATE(716),
    [sym_preproc_pragma] = STATE(716),
    [sym_preproc_nullable] = STATE(716),
    [sym_preproc_error] = STATE(716),
    [sym_preproc_define] = STATE(716),
    [sym_preproc_undef] = STATE(716),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(2681),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_readonly] = ACTIONS(2683),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1065),
    [anon_sym_var] = ACTIONS(2673),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [717] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6139),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym__anonymous_object_member_declarator] = STATE(8829),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2858),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(717),
    [sym_preproc_endregion] = STATE(717),
    [sym_preproc_line] = STATE(717),
    [sym_preproc_pragma] = STATE(717),
    [sym_preproc_nullable] = STATE(717),
    [sym_preproc_error] = STATE(717),
    [sym_preproc_define] = STATE(717),
    [sym_preproc_undef] = STATE(717),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_RBRACE] = ACTIONS(2755),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [718] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6139),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym__anonymous_object_member_declarator] = STATE(8829),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2858),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(718),
    [sym_preproc_endregion] = STATE(718),
    [sym_preproc_line] = STATE(718),
    [sym_preproc_pragma] = STATE(718),
    [sym_preproc_nullable] = STATE(718),
    [sym_preproc_error] = STATE(718),
    [sym_preproc_define] = STATE(718),
    [sym_preproc_undef] = STATE(718),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_RBRACE] = ACTIONS(2757),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [719] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4604),
    [sym_bracketed_argument_list] = STATE(3559),
    [sym__name] = STATE(6877),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2908),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7129),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4390),
    [sym_non_lvalue_expression] = STATE(4553),
    [sym_lvalue_expression] = STATE(3561),
    [sym__expression_statement_expression] = STATE(4559),
    [sym_assignment_expression] = STATE(4558),
    [sym_binary_expression] = STATE(4559),
    [sym_postfix_unary_expression] = STATE(4558),
    [sym_prefix_unary_expression] = STATE(4558),
    [sym__pointer_indirection_expression] = STATE(3560),
    [sym_query_expression] = STATE(4559),
    [sym_from_clause] = STATE(7385),
    [sym_conditional_expression] = STATE(4559),
    [sym_conditional_access_expression] = STATE(4559),
    [sym_as_expression] = STATE(4559),
    [sym_is_expression] = STATE(4559),
    [sym_is_pattern_expression] = STATE(4559),
    [sym_cast_expression] = STATE(4559),
    [sym_checked_expression] = STATE(4559),
    [sym_invocation_expression] = STATE(4558),
    [sym_switch_expression] = STATE(4559),
    [sym_await_expression] = STATE(4558),
    [sym_throw_expression] = STATE(4559),
    [sym_element_access_expression] = STATE(3560),
    [sym_interpolated_string_expression] = STATE(4559),
    [sym_member_access_expression] = STATE(3560),
    [sym_object_creation_expression] = STATE(4558),
    [sym_parenthesized_expression] = STATE(4558),
    [sym__parenthesized_lvalue_expression] = STATE(3560),
    [sym_lambda_expression] = STATE(4559),
    [sym__lambda_parameters] = STATE(9776),
    [sym_array_creation_expression] = STATE(4559),
    [sym_anonymous_method_expression] = STATE(4559),
    [sym_anonymous_object_creation_expression] = STATE(4559),
    [sym_implicit_array_creation_expression] = STATE(4559),
    [sym_implicit_object_creation_expression] = STATE(4559),
    [sym_implicit_stackalloc_expression] = STATE(4559),
    [sym_initializer_expression] = STATE(4559),
    [sym_default_expression] = STATE(4559),
    [sym_with_expression] = STATE(4559),
    [sym_sizeof_expression] = STATE(4559),
    [sym_typeof_expression] = STATE(4559),
    [sym_makeref_expression] = STATE(4559),
    [sym_ref_expression] = STATE(4559),
    [sym_reftype_expression] = STATE(4559),
    [sym_refvalue_expression] = STATE(4559),
    [sym_stackalloc_expression] = STATE(4559),
    [sym_range_expression] = STATE(4559),
    [sym_tuple_expression] = STATE(3560),
    [sym_literal] = STATE(4559),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4559),
    [sym_preproc_region] = STATE(719),
    [sym_preproc_endregion] = STATE(719),
    [sym_preproc_line] = STATE(719),
    [sym_preproc_pragma] = STATE(719),
    [sym_preproc_nullable] = STATE(719),
    [sym_preproc_error] = STATE(719),
    [sym_preproc_define] = STATE(719),
    [sym_preproc_undef] = STATE(719),
    [aux_sym_class_declaration_repeat1] = STATE(3843),
    [aux_sym_lambda_expression_repeat1] = STATE(4277),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(1675),
    [anon_sym_ref] = ACTIONS(1677),
    [anon_sym_LBRACE] = ACTIONS(2759),
    [anon_sym_delegate] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1679),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(1683),
    [anon_sym_TILDE] = ACTIONS(1683),
    [anon_sym_PLUS_PLUS] = ACTIONS(1683),
    [anon_sym_DASH_DASH] = ACTIONS(1683),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_DASH] = ACTIONS(1681),
    [anon_sym_STAR] = ACTIONS(1685),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1683),
    [anon_sym_this] = ACTIONS(1627),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1629),
    [anon_sym_unchecked] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(1687),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1689),
    [anon_sym_DOT_DOT] = ACTIONS(1691),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_stackalloc] = ACTIONS(1641),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(1647),
    [anon_sym___reftype] = ACTIONS(1649),
    [anon_sym___refvalue] = ACTIONS(1651),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1659),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [720] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4151),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6909),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2874),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7062),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5474),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4291),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7411),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9300),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(720),
    [sym_preproc_endregion] = STATE(720),
    [sym_preproc_line] = STATE(720),
    [sym_preproc_pragma] = STATE(720),
    [sym_preproc_nullable] = STATE(720),
    [sym_preproc_error] = STATE(720),
    [sym_preproc_define] = STATE(720),
    [sym_preproc_undef] = STATE(720),
    [aux_sym_class_declaration_repeat1] = STATE(3804),
    [aux_sym_lambda_expression_repeat1] = STATE(4114),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1501),
    [anon_sym_ref] = ACTIONS(1503),
    [anon_sym_LBRACE] = ACTIONS(2761),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1505),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1509),
    [anon_sym_PLUS_PLUS] = ACTIONS(1509),
    [anon_sym_DASH_DASH] = ACTIONS(1509),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1507),
    [anon_sym_DASH] = ACTIONS(1507),
    [anon_sym_STAR] = ACTIONS(1511),
    [anon_sym_CARET] = ACTIONS(1509),
    [anon_sym_AMP] = ACTIONS(1509),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1513),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1515),
    [anon_sym_DOT_DOT] = ACTIONS(1517),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [721] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6030),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(721),
    [sym_preproc_endregion] = STATE(721),
    [sym_preproc_line] = STATE(721),
    [sym_preproc_pragma] = STATE(721),
    [sym_preproc_nullable] = STATE(721),
    [sym_preproc_error] = STATE(721),
    [sym_preproc_define] = STATE(721),
    [sym_preproc_undef] = STATE(721),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_RBRACE] = ACTIONS(2763),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [722] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3559),
    [sym__name] = STATE(6878),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2911),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6954),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4472),
    [sym_non_lvalue_expression] = STATE(4553),
    [sym_lvalue_expression] = STATE(3607),
    [sym__expression_statement_expression] = STATE(4559),
    [sym_assignment_expression] = STATE(4558),
    [sym_binary_expression] = STATE(4559),
    [sym_postfix_unary_expression] = STATE(4558),
    [sym_prefix_unary_expression] = STATE(4558),
    [sym__pointer_indirection_expression] = STATE(3560),
    [sym_query_expression] = STATE(4559),
    [sym_from_clause] = STATE(7385),
    [sym_conditional_expression] = STATE(4559),
    [sym_conditional_access_expression] = STATE(4559),
    [sym_as_expression] = STATE(4559),
    [sym_is_expression] = STATE(4559),
    [sym_is_pattern_expression] = STATE(4559),
    [sym_cast_expression] = STATE(4559),
    [sym_checked_expression] = STATE(4559),
    [sym_invocation_expression] = STATE(4558),
    [sym_switch_expression] = STATE(4559),
    [sym_await_expression] = STATE(4558),
    [sym_throw_expression] = STATE(4559),
    [sym_element_access_expression] = STATE(3560),
    [sym_interpolated_string_expression] = STATE(4559),
    [sym_member_access_expression] = STATE(3560),
    [sym_object_creation_expression] = STATE(4558),
    [sym_parenthesized_expression] = STATE(4558),
    [sym__parenthesized_lvalue_expression] = STATE(3560),
    [sym_lambda_expression] = STATE(4559),
    [sym__lambda_parameters] = STATE(9554),
    [sym_array_creation_expression] = STATE(4559),
    [sym_anonymous_method_expression] = STATE(4559),
    [sym_anonymous_object_creation_expression] = STATE(4559),
    [sym_implicit_array_creation_expression] = STATE(4559),
    [sym_implicit_object_creation_expression] = STATE(4559),
    [sym_implicit_stackalloc_expression] = STATE(4559),
    [sym_initializer_expression] = STATE(4559),
    [sym_default_expression] = STATE(4559),
    [sym_with_expression] = STATE(4559),
    [sym_sizeof_expression] = STATE(4559),
    [sym_typeof_expression] = STATE(4559),
    [sym_makeref_expression] = STATE(4559),
    [sym_ref_expression] = STATE(4559),
    [sym_reftype_expression] = STATE(4559),
    [sym_refvalue_expression] = STATE(4559),
    [sym_stackalloc_expression] = STATE(4559),
    [sym_range_expression] = STATE(4559),
    [sym_tuple_expression] = STATE(3560),
    [sym_literal] = STATE(4559),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4559),
    [sym_preproc_region] = STATE(722),
    [sym_preproc_endregion] = STATE(722),
    [sym_preproc_line] = STATE(722),
    [sym_preproc_pragma] = STATE(722),
    [sym_preproc_nullable] = STATE(722),
    [sym_preproc_error] = STATE(722),
    [sym_preproc_define] = STATE(722),
    [sym_preproc_undef] = STATE(722),
    [aux_sym_class_declaration_repeat1] = STATE(3792),
    [aux_sym_lambda_expression_repeat1] = STATE(4202),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(1607),
    [anon_sym_ref] = ACTIONS(1609),
    [anon_sym_LBRACE] = ACTIONS(1611),
    [anon_sym_delegate] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1615),
    [anon_sym_readonly] = ACTIONS(2693),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(1621),
    [anon_sym_TILDE] = ACTIONS(1621),
    [anon_sym_PLUS_PLUS] = ACTIONS(1621),
    [anon_sym_DASH_DASH] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(1619),
    [anon_sym_DASH] = ACTIONS(1619),
    [anon_sym_STAR] = ACTIONS(1625),
    [anon_sym_CARET] = ACTIONS(1621),
    [anon_sym_AMP] = ACTIONS(1621),
    [anon_sym_this] = ACTIONS(1627),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1629),
    [anon_sym_unchecked] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [anon_sym_DOT_DOT] = ACTIONS(1637),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_stackalloc] = ACTIONS(1641),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(1647),
    [anon_sym___reftype] = ACTIONS(1649),
    [anon_sym___refvalue] = ACTIONS(1651),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1659),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [723] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3769),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7076),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5839),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4314),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9775),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(723),
    [sym_preproc_endregion] = STATE(723),
    [sym_preproc_line] = STATE(723),
    [sym_preproc_pragma] = STATE(723),
    [sym_preproc_nullable] = STATE(723),
    [sym_preproc_error] = STATE(723),
    [sym_preproc_define] = STATE(723),
    [sym_preproc_undef] = STATE(723),
    [aux_sym_class_declaration_repeat1] = STATE(3835),
    [aux_sym_lambda_expression_repeat1] = STATE(4236),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1535),
    [anon_sym_ref] = ACTIONS(1537),
    [anon_sym_LBRACE] = ACTIONS(2765),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1465),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(885),
    [anon_sym_TILDE] = ACTIONS(885),
    [anon_sym_PLUS_PLUS] = ACTIONS(885),
    [anon_sym_DASH_DASH] = ACTIONS(885),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(887),
    [anon_sym_DASH] = ACTIONS(887),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(885),
    [anon_sym_AMP] = ACTIONS(885),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1539),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1541),
    [anon_sym_DOT_DOT] = ACTIONS(1543),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [724] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3559),
    [sym__name] = STATE(6877),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2908),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6933),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4523),
    [sym_non_lvalue_expression] = STATE(4553),
    [sym_lvalue_expression] = STATE(3691),
    [sym__expression_statement_expression] = STATE(4559),
    [sym_assignment_expression] = STATE(4558),
    [sym_binary_expression] = STATE(4559),
    [sym_postfix_unary_expression] = STATE(4558),
    [sym_prefix_unary_expression] = STATE(4558),
    [sym__pointer_indirection_expression] = STATE(3560),
    [sym_query_expression] = STATE(4559),
    [sym_from_clause] = STATE(7406),
    [sym_conditional_expression] = STATE(4559),
    [sym_conditional_access_expression] = STATE(4559),
    [sym_as_expression] = STATE(4559),
    [sym_is_expression] = STATE(4559),
    [sym_is_pattern_expression] = STATE(4559),
    [sym_cast_expression] = STATE(4559),
    [sym_checked_expression] = STATE(4559),
    [sym_invocation_expression] = STATE(4558),
    [sym_switch_expression] = STATE(4559),
    [sym_await_expression] = STATE(4558),
    [sym_throw_expression] = STATE(4559),
    [sym_element_access_expression] = STATE(3560),
    [sym_interpolated_string_expression] = STATE(4559),
    [sym_member_access_expression] = STATE(3560),
    [sym_object_creation_expression] = STATE(4558),
    [sym_parenthesized_expression] = STATE(4558),
    [sym__parenthesized_lvalue_expression] = STATE(3560),
    [sym_lambda_expression] = STATE(4559),
    [sym__lambda_parameters] = STATE(9348),
    [sym_array_creation_expression] = STATE(4559),
    [sym_anonymous_method_expression] = STATE(4559),
    [sym_anonymous_object_creation_expression] = STATE(4559),
    [sym_implicit_array_creation_expression] = STATE(4559),
    [sym_implicit_object_creation_expression] = STATE(4559),
    [sym_implicit_stackalloc_expression] = STATE(4559),
    [sym_initializer_expression] = STATE(4559),
    [sym_default_expression] = STATE(4559),
    [sym_with_expression] = STATE(4559),
    [sym_sizeof_expression] = STATE(4559),
    [sym_typeof_expression] = STATE(4559),
    [sym_makeref_expression] = STATE(4559),
    [sym_ref_expression] = STATE(4559),
    [sym_reftype_expression] = STATE(4559),
    [sym_refvalue_expression] = STATE(4559),
    [sym_stackalloc_expression] = STATE(4559),
    [sym_range_expression] = STATE(4559),
    [sym_tuple_expression] = STATE(3560),
    [sym_literal] = STATE(4559),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4559),
    [sym_preproc_region] = STATE(724),
    [sym_preproc_endregion] = STATE(724),
    [sym_preproc_line] = STATE(724),
    [sym_preproc_pragma] = STATE(724),
    [sym_preproc_nullable] = STATE(724),
    [sym_preproc_error] = STATE(724),
    [sym_preproc_define] = STATE(724),
    [sym_preproc_undef] = STATE(724),
    [aux_sym_class_declaration_repeat1] = STATE(3810),
    [aux_sym_lambda_expression_repeat1] = STATE(4141),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(2047),
    [anon_sym_ref] = ACTIONS(2049),
    [anon_sym_LBRACE] = ACTIONS(1611),
    [anon_sym_delegate] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1679),
    [anon_sym_readonly] = ACTIONS(2693),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(2053),
    [anon_sym_TILDE] = ACTIONS(2053),
    [anon_sym_PLUS_PLUS] = ACTIONS(2053),
    [anon_sym_DASH_DASH] = ACTIONS(2053),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(2051),
    [anon_sym_DASH] = ACTIONS(2051),
    [anon_sym_STAR] = ACTIONS(1685),
    [anon_sym_CARET] = ACTIONS(2053),
    [anon_sym_AMP] = ACTIONS(2053),
    [anon_sym_this] = ACTIONS(1627),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1629),
    [anon_sym_unchecked] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(2055),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2057),
    [anon_sym_DOT_DOT] = ACTIONS(2059),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_stackalloc] = ACTIONS(1641),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(1647),
    [anon_sym___reftype] = ACTIONS(1649),
    [anon_sym___refvalue] = ACTIONS(1651),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1659),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [725] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3615),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6904),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7009),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5213),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4008),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7381),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9536),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(725),
    [sym_preproc_endregion] = STATE(725),
    [sym_preproc_line] = STATE(725),
    [sym_preproc_pragma] = STATE(725),
    [sym_preproc_nullable] = STATE(725),
    [sym_preproc_error] = STATE(725),
    [sym_preproc_define] = STATE(725),
    [sym_preproc_undef] = STATE(725),
    [aux_sym_class_declaration_repeat1] = STATE(3832),
    [aux_sym_lambda_expression_repeat1] = STATE(4090),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1485),
    [anon_sym_ref] = ACTIONS(1487),
    [anon_sym_LBRACE] = ACTIONS(2767),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1221),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1491),
    [anon_sym_TILDE] = ACTIONS(1491),
    [anon_sym_PLUS_PLUS] = ACTIONS(1491),
    [anon_sym_DASH_DASH] = ACTIONS(1491),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1489),
    [anon_sym_DASH] = ACTIONS(1489),
    [anon_sym_STAR] = ACTIONS(1493),
    [anon_sym_CARET] = ACTIONS(1491),
    [anon_sym_AMP] = ACTIONS(1491),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1495),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1497),
    [anon_sym_DOT_DOT] = ACTIONS(1499),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [726] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3632),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6904),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7009),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5214),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4008),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7381),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9536),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(726),
    [sym_preproc_endregion] = STATE(726),
    [sym_preproc_line] = STATE(726),
    [sym_preproc_pragma] = STATE(726),
    [sym_preproc_nullable] = STATE(726),
    [sym_preproc_error] = STATE(726),
    [sym_preproc_define] = STATE(726),
    [sym_preproc_undef] = STATE(726),
    [aux_sym_class_declaration_repeat1] = STATE(3832),
    [aux_sym_lambda_expression_repeat1] = STATE(4090),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1485),
    [anon_sym_ref] = ACTIONS(1487),
    [anon_sym_LBRACE] = ACTIONS(2767),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1221),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1491),
    [anon_sym_TILDE] = ACTIONS(1491),
    [anon_sym_PLUS_PLUS] = ACTIONS(1491),
    [anon_sym_DASH_DASH] = ACTIONS(1491),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1489),
    [anon_sym_DASH] = ACTIONS(1489),
    [anon_sym_STAR] = ACTIONS(1493),
    [anon_sym_CARET] = ACTIONS(1491),
    [anon_sym_AMP] = ACTIONS(1491),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1495),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1497),
    [anon_sym_DOT_DOT] = ACTIONS(1499),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [727] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3638),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6904),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7009),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5215),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4008),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7381),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9536),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(727),
    [sym_preproc_endregion] = STATE(727),
    [sym_preproc_line] = STATE(727),
    [sym_preproc_pragma] = STATE(727),
    [sym_preproc_nullable] = STATE(727),
    [sym_preproc_error] = STATE(727),
    [sym_preproc_define] = STATE(727),
    [sym_preproc_undef] = STATE(727),
    [aux_sym_class_declaration_repeat1] = STATE(3832),
    [aux_sym_lambda_expression_repeat1] = STATE(4090),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1485),
    [anon_sym_ref] = ACTIONS(1487),
    [anon_sym_LBRACE] = ACTIONS(2767),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1221),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1491),
    [anon_sym_TILDE] = ACTIONS(1491),
    [anon_sym_PLUS_PLUS] = ACTIONS(1491),
    [anon_sym_DASH_DASH] = ACTIONS(1491),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1489),
    [anon_sym_DASH] = ACTIONS(1489),
    [anon_sym_STAR] = ACTIONS(1493),
    [anon_sym_CARET] = ACTIONS(1491),
    [anon_sym_AMP] = ACTIONS(1491),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1495),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1497),
    [anon_sym_DOT_DOT] = ACTIONS(1499),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [728] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3612),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6904),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7009),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5221),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4008),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7381),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9536),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(728),
    [sym_preproc_endregion] = STATE(728),
    [sym_preproc_line] = STATE(728),
    [sym_preproc_pragma] = STATE(728),
    [sym_preproc_nullable] = STATE(728),
    [sym_preproc_error] = STATE(728),
    [sym_preproc_define] = STATE(728),
    [sym_preproc_undef] = STATE(728),
    [aux_sym_class_declaration_repeat1] = STATE(3832),
    [aux_sym_lambda_expression_repeat1] = STATE(4090),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1485),
    [anon_sym_ref] = ACTIONS(1487),
    [anon_sym_LBRACE] = ACTIONS(2767),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1221),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1491),
    [anon_sym_TILDE] = ACTIONS(1491),
    [anon_sym_PLUS_PLUS] = ACTIONS(1491),
    [anon_sym_DASH_DASH] = ACTIONS(1491),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1489),
    [anon_sym_DASH] = ACTIONS(1489),
    [anon_sym_STAR] = ACTIONS(1493),
    [anon_sym_CARET] = ACTIONS(1491),
    [anon_sym_AMP] = ACTIONS(1491),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1495),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1497),
    [anon_sym_DOT_DOT] = ACTIONS(1499),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [729] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3717),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7076),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5860),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4314),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9775),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(729),
    [sym_preproc_endregion] = STATE(729),
    [sym_preproc_line] = STATE(729),
    [sym_preproc_pragma] = STATE(729),
    [sym_preproc_nullable] = STATE(729),
    [sym_preproc_error] = STATE(729),
    [sym_preproc_define] = STATE(729),
    [sym_preproc_undef] = STATE(729),
    [aux_sym_class_declaration_repeat1] = STATE(3835),
    [aux_sym_lambda_expression_repeat1] = STATE(4236),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1535),
    [anon_sym_ref] = ACTIONS(1537),
    [anon_sym_LBRACE] = ACTIONS(2765),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1465),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(885),
    [anon_sym_TILDE] = ACTIONS(885),
    [anon_sym_PLUS_PLUS] = ACTIONS(885),
    [anon_sym_DASH_DASH] = ACTIONS(885),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(887),
    [anon_sym_DASH] = ACTIONS(887),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(885),
    [anon_sym_AMP] = ACTIONS(885),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1539),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1541),
    [anon_sym_DOT_DOT] = ACTIONS(1543),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [730] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3683),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6904),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7009),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5225),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4008),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7381),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9536),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(730),
    [sym_preproc_endregion] = STATE(730),
    [sym_preproc_line] = STATE(730),
    [sym_preproc_pragma] = STATE(730),
    [sym_preproc_nullable] = STATE(730),
    [sym_preproc_error] = STATE(730),
    [sym_preproc_define] = STATE(730),
    [sym_preproc_undef] = STATE(730),
    [aux_sym_class_declaration_repeat1] = STATE(3832),
    [aux_sym_lambda_expression_repeat1] = STATE(4090),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1485),
    [anon_sym_ref] = ACTIONS(1487),
    [anon_sym_LBRACE] = ACTIONS(2767),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1221),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1491),
    [anon_sym_TILDE] = ACTIONS(1491),
    [anon_sym_PLUS_PLUS] = ACTIONS(1491),
    [anon_sym_DASH_DASH] = ACTIONS(1491),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1489),
    [anon_sym_DASH] = ACTIONS(1489),
    [anon_sym_STAR] = ACTIONS(1493),
    [anon_sym_CARET] = ACTIONS(1491),
    [anon_sym_AMP] = ACTIONS(1491),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1495),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1497),
    [anon_sym_DOT_DOT] = ACTIONS(1499),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [731] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6030),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(731),
    [sym_preproc_endregion] = STATE(731),
    [sym_preproc_line] = STATE(731),
    [sym_preproc_pragma] = STATE(731),
    [sym_preproc_nullable] = STATE(731),
    [sym_preproc_error] = STATE(731),
    [sym_preproc_define] = STATE(731),
    [sym_preproc_undef] = STATE(731),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_RBRACE] = ACTIONS(2769),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [732] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5867),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(732),
    [sym_preproc_endregion] = STATE(732),
    [sym_preproc_line] = STATE(732),
    [sym_preproc_pragma] = STATE(732),
    [sym_preproc_nullable] = STATE(732),
    [sym_preproc_error] = STATE(732),
    [sym_preproc_define] = STATE(732),
    [sym_preproc_undef] = STATE(732),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_RPAREN] = ACTIONS(2771),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [733] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3650),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6904),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7009),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5226),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4008),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7381),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9536),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(733),
    [sym_preproc_endregion] = STATE(733),
    [sym_preproc_line] = STATE(733),
    [sym_preproc_pragma] = STATE(733),
    [sym_preproc_nullable] = STATE(733),
    [sym_preproc_error] = STATE(733),
    [sym_preproc_define] = STATE(733),
    [sym_preproc_undef] = STATE(733),
    [aux_sym_class_declaration_repeat1] = STATE(3832),
    [aux_sym_lambda_expression_repeat1] = STATE(4090),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1485),
    [anon_sym_ref] = ACTIONS(1487),
    [anon_sym_LBRACE] = ACTIONS(2767),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1221),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1491),
    [anon_sym_TILDE] = ACTIONS(1491),
    [anon_sym_PLUS_PLUS] = ACTIONS(1491),
    [anon_sym_DASH_DASH] = ACTIONS(1491),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1489),
    [anon_sym_DASH] = ACTIONS(1489),
    [anon_sym_STAR] = ACTIONS(1493),
    [anon_sym_CARET] = ACTIONS(1491),
    [anon_sym_AMP] = ACTIONS(1491),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1495),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1497),
    [anon_sym_DOT_DOT] = ACTIONS(1499),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [734] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3717),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6910),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2957),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7089),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5031),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(3796),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7395),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9374),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(734),
    [sym_preproc_endregion] = STATE(734),
    [sym_preproc_line] = STATE(734),
    [sym_preproc_pragma] = STATE(734),
    [sym_preproc_nullable] = STATE(734),
    [sym_preproc_error] = STATE(734),
    [sym_preproc_define] = STATE(734),
    [sym_preproc_undef] = STATE(734),
    [aux_sym_class_declaration_repeat1] = STATE(3839),
    [aux_sym_lambda_expression_repeat1] = STATE(4209),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2139),
    [anon_sym_ref] = ACTIONS(2141),
    [anon_sym_LBRACE] = ACTIONS(2765),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1799),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2145),
    [anon_sym_TILDE] = ACTIONS(2145),
    [anon_sym_PLUS_PLUS] = ACTIONS(2145),
    [anon_sym_DASH_DASH] = ACTIONS(2145),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2143),
    [anon_sym_DASH] = ACTIONS(2143),
    [anon_sym_STAR] = ACTIONS(1805),
    [anon_sym_CARET] = ACTIONS(2145),
    [anon_sym_AMP] = ACTIONS(2145),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2147),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2149),
    [anon_sym_DOT_DOT] = ACTIONS(2151),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [735] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3559),
    [sym__name] = STATE(6877),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2908),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7130),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4398),
    [sym_non_lvalue_expression] = STATE(4553),
    [sym_lvalue_expression] = STATE(3561),
    [sym__expression_statement_expression] = STATE(4559),
    [sym_assignment_expression] = STATE(4558),
    [sym_binary_expression] = STATE(4559),
    [sym_postfix_unary_expression] = STATE(4558),
    [sym_prefix_unary_expression] = STATE(4558),
    [sym__pointer_indirection_expression] = STATE(3560),
    [sym_query_expression] = STATE(4559),
    [sym_from_clause] = STATE(7385),
    [sym_conditional_expression] = STATE(4559),
    [sym_conditional_access_expression] = STATE(4559),
    [sym_as_expression] = STATE(4559),
    [sym_is_expression] = STATE(4559),
    [sym_is_pattern_expression] = STATE(4559),
    [sym_cast_expression] = STATE(4559),
    [sym_checked_expression] = STATE(4559),
    [sym_invocation_expression] = STATE(4558),
    [sym_switch_expression] = STATE(4559),
    [sym_await_expression] = STATE(4558),
    [sym_throw_expression] = STATE(4559),
    [sym_element_access_expression] = STATE(3560),
    [sym_interpolated_string_expression] = STATE(4559),
    [sym_member_access_expression] = STATE(3560),
    [sym_object_creation_expression] = STATE(4558),
    [sym_parenthesized_expression] = STATE(4558),
    [sym__parenthesized_lvalue_expression] = STATE(3560),
    [sym_lambda_expression] = STATE(4559),
    [sym__lambda_parameters] = STATE(9776),
    [sym_array_creation_expression] = STATE(4559),
    [sym_anonymous_method_expression] = STATE(4559),
    [sym_anonymous_object_creation_expression] = STATE(4559),
    [sym_implicit_array_creation_expression] = STATE(4559),
    [sym_implicit_object_creation_expression] = STATE(4559),
    [sym_implicit_stackalloc_expression] = STATE(4559),
    [sym_initializer_expression] = STATE(4559),
    [sym_default_expression] = STATE(4559),
    [sym_with_expression] = STATE(4559),
    [sym_sizeof_expression] = STATE(4559),
    [sym_typeof_expression] = STATE(4559),
    [sym_makeref_expression] = STATE(4559),
    [sym_ref_expression] = STATE(4559),
    [sym_reftype_expression] = STATE(4559),
    [sym_refvalue_expression] = STATE(4559),
    [sym_stackalloc_expression] = STATE(4559),
    [sym_range_expression] = STATE(4559),
    [sym_tuple_expression] = STATE(3560),
    [sym_literal] = STATE(4559),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4559),
    [sym_preproc_region] = STATE(735),
    [sym_preproc_endregion] = STATE(735),
    [sym_preproc_line] = STATE(735),
    [sym_preproc_pragma] = STATE(735),
    [sym_preproc_nullable] = STATE(735),
    [sym_preproc_error] = STATE(735),
    [sym_preproc_define] = STATE(735),
    [sym_preproc_undef] = STATE(735),
    [aux_sym_class_declaration_repeat1] = STATE(3843),
    [aux_sym_lambda_expression_repeat1] = STATE(4277),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(1675),
    [anon_sym_ref] = ACTIONS(1677),
    [anon_sym_LBRACE] = ACTIONS(1611),
    [anon_sym_delegate] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1679),
    [anon_sym_readonly] = ACTIONS(2693),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(1683),
    [anon_sym_TILDE] = ACTIONS(1683),
    [anon_sym_PLUS_PLUS] = ACTIONS(1683),
    [anon_sym_DASH_DASH] = ACTIONS(1683),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_DASH] = ACTIONS(1681),
    [anon_sym_STAR] = ACTIONS(1685),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1683),
    [anon_sym_this] = ACTIONS(1627),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1629),
    [anon_sym_unchecked] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(1687),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1689),
    [anon_sym_DOT_DOT] = ACTIONS(1691),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_stackalloc] = ACTIONS(1641),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(1647),
    [anon_sym___reftype] = ACTIONS(1649),
    [anon_sym___refvalue] = ACTIONS(1651),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1659),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [736] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4604),
    [sym_bracketed_argument_list] = STATE(3559),
    [sym__name] = STATE(6877),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2908),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6958),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4656),
    [sym_non_lvalue_expression] = STATE(4553),
    [sym_lvalue_expression] = STATE(3691),
    [sym__expression_statement_expression] = STATE(4559),
    [sym_assignment_expression] = STATE(4558),
    [sym_binary_expression] = STATE(4559),
    [sym_postfix_unary_expression] = STATE(4558),
    [sym_prefix_unary_expression] = STATE(4558),
    [sym__pointer_indirection_expression] = STATE(3560),
    [sym_query_expression] = STATE(4559),
    [sym_from_clause] = STATE(7406),
    [sym_conditional_expression] = STATE(4559),
    [sym_conditional_access_expression] = STATE(4559),
    [sym_as_expression] = STATE(4559),
    [sym_is_expression] = STATE(4559),
    [sym_is_pattern_expression] = STATE(4559),
    [sym_cast_expression] = STATE(4559),
    [sym_checked_expression] = STATE(4559),
    [sym_invocation_expression] = STATE(4558),
    [sym_switch_expression] = STATE(4559),
    [sym_await_expression] = STATE(4558),
    [sym_throw_expression] = STATE(4559),
    [sym_element_access_expression] = STATE(3560),
    [sym_interpolated_string_expression] = STATE(4559),
    [sym_member_access_expression] = STATE(3560),
    [sym_object_creation_expression] = STATE(4558),
    [sym_parenthesized_expression] = STATE(4558),
    [sym__parenthesized_lvalue_expression] = STATE(3560),
    [sym_lambda_expression] = STATE(4559),
    [sym__lambda_parameters] = STATE(9348),
    [sym_array_creation_expression] = STATE(4559),
    [sym_anonymous_method_expression] = STATE(4559),
    [sym_anonymous_object_creation_expression] = STATE(4559),
    [sym_implicit_array_creation_expression] = STATE(4559),
    [sym_implicit_object_creation_expression] = STATE(4559),
    [sym_implicit_stackalloc_expression] = STATE(4559),
    [sym_initializer_expression] = STATE(4559),
    [sym_default_expression] = STATE(4559),
    [sym_with_expression] = STATE(4559),
    [sym_sizeof_expression] = STATE(4559),
    [sym_typeof_expression] = STATE(4559),
    [sym_makeref_expression] = STATE(4559),
    [sym_ref_expression] = STATE(4559),
    [sym_reftype_expression] = STATE(4559),
    [sym_refvalue_expression] = STATE(4559),
    [sym_stackalloc_expression] = STATE(4559),
    [sym_range_expression] = STATE(4559),
    [sym_tuple_expression] = STATE(3560),
    [sym_literal] = STATE(4559),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4559),
    [sym_preproc_region] = STATE(736),
    [sym_preproc_endregion] = STATE(736),
    [sym_preproc_line] = STATE(736),
    [sym_preproc_pragma] = STATE(736),
    [sym_preproc_nullable] = STATE(736),
    [sym_preproc_error] = STATE(736),
    [sym_preproc_define] = STATE(736),
    [sym_preproc_undef] = STATE(736),
    [aux_sym_class_declaration_repeat1] = STATE(3810),
    [aux_sym_lambda_expression_repeat1] = STATE(4141),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(2047),
    [anon_sym_ref] = ACTIONS(2049),
    [anon_sym_LBRACE] = ACTIONS(2759),
    [anon_sym_delegate] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1679),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(2053),
    [anon_sym_TILDE] = ACTIONS(2053),
    [anon_sym_PLUS_PLUS] = ACTIONS(2053),
    [anon_sym_DASH_DASH] = ACTIONS(2053),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(2051),
    [anon_sym_DASH] = ACTIONS(2051),
    [anon_sym_STAR] = ACTIONS(1685),
    [anon_sym_CARET] = ACTIONS(2053),
    [anon_sym_AMP] = ACTIONS(2053),
    [anon_sym_this] = ACTIONS(1627),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1629),
    [anon_sym_unchecked] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(2055),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2057),
    [anon_sym_DOT_DOT] = ACTIONS(2059),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_stackalloc] = ACTIONS(1641),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(1647),
    [anon_sym___reftype] = ACTIONS(1649),
    [anon_sym___refvalue] = ACTIONS(1651),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1659),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [737] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4695),
    [sym_bracketed_argument_list] = STATE(3559),
    [sym__name] = STATE(6877),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2908),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6958),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4657),
    [sym_non_lvalue_expression] = STATE(4553),
    [sym_lvalue_expression] = STATE(3691),
    [sym__expression_statement_expression] = STATE(4559),
    [sym_assignment_expression] = STATE(4558),
    [sym_binary_expression] = STATE(4559),
    [sym_postfix_unary_expression] = STATE(4558),
    [sym_prefix_unary_expression] = STATE(4558),
    [sym__pointer_indirection_expression] = STATE(3560),
    [sym_query_expression] = STATE(4559),
    [sym_from_clause] = STATE(7406),
    [sym_conditional_expression] = STATE(4559),
    [sym_conditional_access_expression] = STATE(4559),
    [sym_as_expression] = STATE(4559),
    [sym_is_expression] = STATE(4559),
    [sym_is_pattern_expression] = STATE(4559),
    [sym_cast_expression] = STATE(4559),
    [sym_checked_expression] = STATE(4559),
    [sym_invocation_expression] = STATE(4558),
    [sym_switch_expression] = STATE(4559),
    [sym_await_expression] = STATE(4558),
    [sym_throw_expression] = STATE(4559),
    [sym_element_access_expression] = STATE(3560),
    [sym_interpolated_string_expression] = STATE(4559),
    [sym_member_access_expression] = STATE(3560),
    [sym_object_creation_expression] = STATE(4558),
    [sym_parenthesized_expression] = STATE(4558),
    [sym__parenthesized_lvalue_expression] = STATE(3560),
    [sym_lambda_expression] = STATE(4559),
    [sym__lambda_parameters] = STATE(9348),
    [sym_array_creation_expression] = STATE(4559),
    [sym_anonymous_method_expression] = STATE(4559),
    [sym_anonymous_object_creation_expression] = STATE(4559),
    [sym_implicit_array_creation_expression] = STATE(4559),
    [sym_implicit_object_creation_expression] = STATE(4559),
    [sym_implicit_stackalloc_expression] = STATE(4559),
    [sym_initializer_expression] = STATE(4559),
    [sym_default_expression] = STATE(4559),
    [sym_with_expression] = STATE(4559),
    [sym_sizeof_expression] = STATE(4559),
    [sym_typeof_expression] = STATE(4559),
    [sym_makeref_expression] = STATE(4559),
    [sym_ref_expression] = STATE(4559),
    [sym_reftype_expression] = STATE(4559),
    [sym_refvalue_expression] = STATE(4559),
    [sym_stackalloc_expression] = STATE(4559),
    [sym_range_expression] = STATE(4559),
    [sym_tuple_expression] = STATE(3560),
    [sym_literal] = STATE(4559),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4559),
    [sym_preproc_region] = STATE(737),
    [sym_preproc_endregion] = STATE(737),
    [sym_preproc_line] = STATE(737),
    [sym_preproc_pragma] = STATE(737),
    [sym_preproc_nullable] = STATE(737),
    [sym_preproc_error] = STATE(737),
    [sym_preproc_define] = STATE(737),
    [sym_preproc_undef] = STATE(737),
    [aux_sym_class_declaration_repeat1] = STATE(3810),
    [aux_sym_lambda_expression_repeat1] = STATE(4141),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(2047),
    [anon_sym_ref] = ACTIONS(2049),
    [anon_sym_LBRACE] = ACTIONS(2759),
    [anon_sym_delegate] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1679),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(2053),
    [anon_sym_TILDE] = ACTIONS(2053),
    [anon_sym_PLUS_PLUS] = ACTIONS(2053),
    [anon_sym_DASH_DASH] = ACTIONS(2053),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(2051),
    [anon_sym_DASH] = ACTIONS(2051),
    [anon_sym_STAR] = ACTIONS(1685),
    [anon_sym_CARET] = ACTIONS(2053),
    [anon_sym_AMP] = ACTIONS(2053),
    [anon_sym_this] = ACTIONS(1627),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1629),
    [anon_sym_unchecked] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(2055),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2057),
    [anon_sym_DOT_DOT] = ACTIONS(2059),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_stackalloc] = ACTIONS(1641),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(1647),
    [anon_sym___reftype] = ACTIONS(1649),
    [anon_sym___refvalue] = ACTIONS(1651),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1659),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [738] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(5649),
    [sym_bracketed_argument_list] = STATE(3921),
    [sym__name] = STATE(6889),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2854),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(7061),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5163),
    [sym_non_lvalue_expression] = STATE(5735),
    [sym_lvalue_expression] = STATE(3899),
    [sym__expression_statement_expression] = STATE(5733),
    [sym_assignment_expression] = STATE(5734),
    [sym_binary_expression] = STATE(5733),
    [sym_postfix_unary_expression] = STATE(5734),
    [sym_prefix_unary_expression] = STATE(5734),
    [sym__pointer_indirection_expression] = STATE(3911),
    [sym_query_expression] = STATE(5733),
    [sym_from_clause] = STATE(7400),
    [sym_conditional_expression] = STATE(5733),
    [sym_conditional_access_expression] = STATE(5733),
    [sym_as_expression] = STATE(5733),
    [sym_is_expression] = STATE(5733),
    [sym_is_pattern_expression] = STATE(5733),
    [sym_cast_expression] = STATE(5733),
    [sym_checked_expression] = STATE(5733),
    [sym_invocation_expression] = STATE(5734),
    [sym_switch_expression] = STATE(5733),
    [sym_await_expression] = STATE(5734),
    [sym_throw_expression] = STATE(5733),
    [sym_element_access_expression] = STATE(3911),
    [sym_interpolated_string_expression] = STATE(5733),
    [sym_member_access_expression] = STATE(3911),
    [sym_object_creation_expression] = STATE(5734),
    [sym_parenthesized_expression] = STATE(5734),
    [sym__parenthesized_lvalue_expression] = STATE(3911),
    [sym_lambda_expression] = STATE(5733),
    [sym__lambda_parameters] = STATE(9790),
    [sym_array_creation_expression] = STATE(5733),
    [sym_anonymous_method_expression] = STATE(5733),
    [sym_anonymous_object_creation_expression] = STATE(5733),
    [sym_implicit_array_creation_expression] = STATE(5733),
    [sym_implicit_object_creation_expression] = STATE(5733),
    [sym_implicit_stackalloc_expression] = STATE(5733),
    [sym_initializer_expression] = STATE(5733),
    [sym_default_expression] = STATE(5733),
    [sym_with_expression] = STATE(5733),
    [sym_sizeof_expression] = STATE(5733),
    [sym_typeof_expression] = STATE(5733),
    [sym_makeref_expression] = STATE(5733),
    [sym_ref_expression] = STATE(5733),
    [sym_reftype_expression] = STATE(5733),
    [sym_refvalue_expression] = STATE(5733),
    [sym_stackalloc_expression] = STATE(5733),
    [sym_range_expression] = STATE(5733),
    [sym_tuple_expression] = STATE(3911),
    [sym_literal] = STATE(5733),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2798),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(5733),
    [sym_preproc_region] = STATE(738),
    [sym_preproc_endregion] = STATE(738),
    [sym_preproc_line] = STATE(738),
    [sym_preproc_pragma] = STATE(738),
    [sym_preproc_nullable] = STATE(738),
    [sym_preproc_error] = STATE(738),
    [sym_preproc_define] = STATE(738),
    [sym_preproc_undef] = STATE(738),
    [aux_sym_class_declaration_repeat1] = STATE(3833),
    [aux_sym_lambda_expression_repeat1] = STATE(4182),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_LPAREN] = ACTIONS(1439),
    [anon_sym_ref] = ACTIONS(1441),
    [anon_sym_LBRACE] = ACTIONS(2773),
    [anon_sym_delegate] = ACTIONS(1379),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1443),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1447),
    [anon_sym_TILDE] = ACTIONS(1447),
    [anon_sym_PLUS_PLUS] = ACTIONS(1447),
    [anon_sym_DASH_DASH] = ACTIONS(1447),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1445),
    [anon_sym_DASH] = ACTIONS(1445),
    [anon_sym_STAR] = ACTIONS(1449),
    [anon_sym_CARET] = ACTIONS(1447),
    [anon_sym_AMP] = ACTIONS(1447),
    [anon_sym_this] = ACTIONS(1393),
    [anon_sym_scoped] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1397),
    [sym_predefined_type] = ACTIONS(1399),
    [anon_sym_unchecked] = ACTIONS(1383),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1451),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1453),
    [anon_sym_DOT_DOT] = ACTIONS(1455),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_stackalloc] = ACTIONS(1413),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(1419),
    [anon_sym___reftype] = ACTIONS(1421),
    [anon_sym___refvalue] = ACTIONS(1423),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
  },
  [739] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3738),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7076),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5884),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4314),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9775),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(739),
    [sym_preproc_endregion] = STATE(739),
    [sym_preproc_line] = STATE(739),
    [sym_preproc_pragma] = STATE(739),
    [sym_preproc_nullable] = STATE(739),
    [sym_preproc_error] = STATE(739),
    [sym_preproc_define] = STATE(739),
    [sym_preproc_undef] = STATE(739),
    [aux_sym_class_declaration_repeat1] = STATE(3835),
    [aux_sym_lambda_expression_repeat1] = STATE(4236),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1535),
    [anon_sym_ref] = ACTIONS(1537),
    [anon_sym_LBRACE] = ACTIONS(2765),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1465),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(885),
    [anon_sym_TILDE] = ACTIONS(885),
    [anon_sym_PLUS_PLUS] = ACTIONS(885),
    [anon_sym_DASH_DASH] = ACTIONS(885),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(887),
    [anon_sym_DASH] = ACTIONS(887),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(885),
    [anon_sym_AMP] = ACTIONS(885),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1539),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1541),
    [anon_sym_DOT_DOT] = ACTIONS(1543),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [740] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6030),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(740),
    [sym_preproc_endregion] = STATE(740),
    [sym_preproc_line] = STATE(740),
    [sym_preproc_pragma] = STATE(740),
    [sym_preproc_nullable] = STATE(740),
    [sym_preproc_error] = STATE(740),
    [sym_preproc_define] = STATE(740),
    [sym_preproc_undef] = STATE(740),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_RBRACE] = ACTIONS(2775),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [741] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3767),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7076),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5887),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4314),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9775),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(741),
    [sym_preproc_endregion] = STATE(741),
    [sym_preproc_line] = STATE(741),
    [sym_preproc_pragma] = STATE(741),
    [sym_preproc_nullable] = STATE(741),
    [sym_preproc_error] = STATE(741),
    [sym_preproc_define] = STATE(741),
    [sym_preproc_undef] = STATE(741),
    [aux_sym_class_declaration_repeat1] = STATE(3835),
    [aux_sym_lambda_expression_repeat1] = STATE(4236),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1535),
    [anon_sym_ref] = ACTIONS(1537),
    [anon_sym_LBRACE] = ACTIONS(2765),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1465),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(885),
    [anon_sym_TILDE] = ACTIONS(885),
    [anon_sym_PLUS_PLUS] = ACTIONS(885),
    [anon_sym_DASH_DASH] = ACTIONS(885),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(887),
    [anon_sym_DASH] = ACTIONS(887),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(885),
    [anon_sym_AMP] = ACTIONS(885),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1539),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1541),
    [anon_sym_DOT_DOT] = ACTIONS(1543),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [742] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(5607),
    [sym_bracketed_argument_list] = STATE(3921),
    [sym__name] = STATE(6889),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2854),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(7061),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5161),
    [sym_non_lvalue_expression] = STATE(5735),
    [sym_lvalue_expression] = STATE(3899),
    [sym__expression_statement_expression] = STATE(5733),
    [sym_assignment_expression] = STATE(5734),
    [sym_binary_expression] = STATE(5733),
    [sym_postfix_unary_expression] = STATE(5734),
    [sym_prefix_unary_expression] = STATE(5734),
    [sym__pointer_indirection_expression] = STATE(3911),
    [sym_query_expression] = STATE(5733),
    [sym_from_clause] = STATE(7400),
    [sym_conditional_expression] = STATE(5733),
    [sym_conditional_access_expression] = STATE(5733),
    [sym_as_expression] = STATE(5733),
    [sym_is_expression] = STATE(5733),
    [sym_is_pattern_expression] = STATE(5733),
    [sym_cast_expression] = STATE(5733),
    [sym_checked_expression] = STATE(5733),
    [sym_invocation_expression] = STATE(5734),
    [sym_switch_expression] = STATE(5733),
    [sym_await_expression] = STATE(5734),
    [sym_throw_expression] = STATE(5733),
    [sym_element_access_expression] = STATE(3911),
    [sym_interpolated_string_expression] = STATE(5733),
    [sym_member_access_expression] = STATE(3911),
    [sym_object_creation_expression] = STATE(5734),
    [sym_parenthesized_expression] = STATE(5734),
    [sym__parenthesized_lvalue_expression] = STATE(3911),
    [sym_lambda_expression] = STATE(5733),
    [sym__lambda_parameters] = STATE(9790),
    [sym_array_creation_expression] = STATE(5733),
    [sym_anonymous_method_expression] = STATE(5733),
    [sym_anonymous_object_creation_expression] = STATE(5733),
    [sym_implicit_array_creation_expression] = STATE(5733),
    [sym_implicit_object_creation_expression] = STATE(5733),
    [sym_implicit_stackalloc_expression] = STATE(5733),
    [sym_initializer_expression] = STATE(5733),
    [sym_default_expression] = STATE(5733),
    [sym_with_expression] = STATE(5733),
    [sym_sizeof_expression] = STATE(5733),
    [sym_typeof_expression] = STATE(5733),
    [sym_makeref_expression] = STATE(5733),
    [sym_ref_expression] = STATE(5733),
    [sym_reftype_expression] = STATE(5733),
    [sym_refvalue_expression] = STATE(5733),
    [sym_stackalloc_expression] = STATE(5733),
    [sym_range_expression] = STATE(5733),
    [sym_tuple_expression] = STATE(3911),
    [sym_literal] = STATE(5733),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2798),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(5733),
    [sym_preproc_region] = STATE(742),
    [sym_preproc_endregion] = STATE(742),
    [sym_preproc_line] = STATE(742),
    [sym_preproc_pragma] = STATE(742),
    [sym_preproc_nullable] = STATE(742),
    [sym_preproc_error] = STATE(742),
    [sym_preproc_define] = STATE(742),
    [sym_preproc_undef] = STATE(742),
    [aux_sym_class_declaration_repeat1] = STATE(3833),
    [aux_sym_lambda_expression_repeat1] = STATE(4182),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_LPAREN] = ACTIONS(1439),
    [anon_sym_ref] = ACTIONS(1441),
    [anon_sym_LBRACE] = ACTIONS(2773),
    [anon_sym_delegate] = ACTIONS(1379),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1443),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1447),
    [anon_sym_TILDE] = ACTIONS(1447),
    [anon_sym_PLUS_PLUS] = ACTIONS(1447),
    [anon_sym_DASH_DASH] = ACTIONS(1447),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1445),
    [anon_sym_DASH] = ACTIONS(1445),
    [anon_sym_STAR] = ACTIONS(1449),
    [anon_sym_CARET] = ACTIONS(1447),
    [anon_sym_AMP] = ACTIONS(1447),
    [anon_sym_this] = ACTIONS(1393),
    [anon_sym_scoped] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1397),
    [sym_predefined_type] = ACTIONS(1399),
    [anon_sym_unchecked] = ACTIONS(1383),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1451),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1453),
    [anon_sym_DOT_DOT] = ACTIONS(1455),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_stackalloc] = ACTIONS(1413),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(1419),
    [anon_sym___reftype] = ACTIONS(1421),
    [anon_sym___refvalue] = ACTIONS(1423),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
  },
  [743] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5891),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(743),
    [sym_preproc_endregion] = STATE(743),
    [sym_preproc_line] = STATE(743),
    [sym_preproc_pragma] = STATE(743),
    [sym_preproc_nullable] = STATE(743),
    [sym_preproc_error] = STATE(743),
    [sym_preproc_define] = STATE(743),
    [sym_preproc_undef] = STATE(743),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_RPAREN] = ACTIONS(2777),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [744] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5892),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(744),
    [sym_preproc_endregion] = STATE(744),
    [sym_preproc_line] = STATE(744),
    [sym_preproc_pragma] = STATE(744),
    [sym_preproc_nullable] = STATE(744),
    [sym_preproc_error] = STATE(744),
    [sym_preproc_define] = STATE(744),
    [sym_preproc_undef] = STATE(744),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_RPAREN] = ACTIONS(2779),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [745] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(5573),
    [sym_bracketed_argument_list] = STATE(3921),
    [sym__name] = STATE(6889),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2854),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(7061),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5159),
    [sym_non_lvalue_expression] = STATE(5735),
    [sym_lvalue_expression] = STATE(3899),
    [sym__expression_statement_expression] = STATE(5733),
    [sym_assignment_expression] = STATE(5734),
    [sym_binary_expression] = STATE(5733),
    [sym_postfix_unary_expression] = STATE(5734),
    [sym_prefix_unary_expression] = STATE(5734),
    [sym__pointer_indirection_expression] = STATE(3911),
    [sym_query_expression] = STATE(5733),
    [sym_from_clause] = STATE(7400),
    [sym_conditional_expression] = STATE(5733),
    [sym_conditional_access_expression] = STATE(5733),
    [sym_as_expression] = STATE(5733),
    [sym_is_expression] = STATE(5733),
    [sym_is_pattern_expression] = STATE(5733),
    [sym_cast_expression] = STATE(5733),
    [sym_checked_expression] = STATE(5733),
    [sym_invocation_expression] = STATE(5734),
    [sym_switch_expression] = STATE(5733),
    [sym_await_expression] = STATE(5734),
    [sym_throw_expression] = STATE(5733),
    [sym_element_access_expression] = STATE(3911),
    [sym_interpolated_string_expression] = STATE(5733),
    [sym_member_access_expression] = STATE(3911),
    [sym_object_creation_expression] = STATE(5734),
    [sym_parenthesized_expression] = STATE(5734),
    [sym__parenthesized_lvalue_expression] = STATE(3911),
    [sym_lambda_expression] = STATE(5733),
    [sym__lambda_parameters] = STATE(9790),
    [sym_array_creation_expression] = STATE(5733),
    [sym_anonymous_method_expression] = STATE(5733),
    [sym_anonymous_object_creation_expression] = STATE(5733),
    [sym_implicit_array_creation_expression] = STATE(5733),
    [sym_implicit_object_creation_expression] = STATE(5733),
    [sym_implicit_stackalloc_expression] = STATE(5733),
    [sym_initializer_expression] = STATE(5733),
    [sym_default_expression] = STATE(5733),
    [sym_with_expression] = STATE(5733),
    [sym_sizeof_expression] = STATE(5733),
    [sym_typeof_expression] = STATE(5733),
    [sym_makeref_expression] = STATE(5733),
    [sym_ref_expression] = STATE(5733),
    [sym_reftype_expression] = STATE(5733),
    [sym_refvalue_expression] = STATE(5733),
    [sym_stackalloc_expression] = STATE(5733),
    [sym_range_expression] = STATE(5733),
    [sym_tuple_expression] = STATE(3911),
    [sym_literal] = STATE(5733),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2798),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(5733),
    [sym_preproc_region] = STATE(745),
    [sym_preproc_endregion] = STATE(745),
    [sym_preproc_line] = STATE(745),
    [sym_preproc_pragma] = STATE(745),
    [sym_preproc_nullable] = STATE(745),
    [sym_preproc_error] = STATE(745),
    [sym_preproc_define] = STATE(745),
    [sym_preproc_undef] = STATE(745),
    [aux_sym_class_declaration_repeat1] = STATE(3833),
    [aux_sym_lambda_expression_repeat1] = STATE(4182),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_LPAREN] = ACTIONS(1439),
    [anon_sym_ref] = ACTIONS(1441),
    [anon_sym_LBRACE] = ACTIONS(2773),
    [anon_sym_delegate] = ACTIONS(1379),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1443),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1447),
    [anon_sym_TILDE] = ACTIONS(1447),
    [anon_sym_PLUS_PLUS] = ACTIONS(1447),
    [anon_sym_DASH_DASH] = ACTIONS(1447),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1445),
    [anon_sym_DASH] = ACTIONS(1445),
    [anon_sym_STAR] = ACTIONS(1449),
    [anon_sym_CARET] = ACTIONS(1447),
    [anon_sym_AMP] = ACTIONS(1447),
    [anon_sym_this] = ACTIONS(1393),
    [anon_sym_scoped] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1397),
    [sym_predefined_type] = ACTIONS(1399),
    [anon_sym_unchecked] = ACTIONS(1383),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1451),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1453),
    [anon_sym_DOT_DOT] = ACTIONS(1455),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_stackalloc] = ACTIONS(1413),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(1419),
    [anon_sym___reftype] = ACTIONS(1421),
    [anon_sym___refvalue] = ACTIONS(1423),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
  },
  [746] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4688),
    [sym_bracketed_argument_list] = STATE(3559),
    [sym__name] = STATE(6877),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2908),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6958),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4658),
    [sym_non_lvalue_expression] = STATE(4553),
    [sym_lvalue_expression] = STATE(3691),
    [sym__expression_statement_expression] = STATE(4559),
    [sym_assignment_expression] = STATE(4558),
    [sym_binary_expression] = STATE(4559),
    [sym_postfix_unary_expression] = STATE(4558),
    [sym_prefix_unary_expression] = STATE(4558),
    [sym__pointer_indirection_expression] = STATE(3560),
    [sym_query_expression] = STATE(4559),
    [sym_from_clause] = STATE(7406),
    [sym_conditional_expression] = STATE(4559),
    [sym_conditional_access_expression] = STATE(4559),
    [sym_as_expression] = STATE(4559),
    [sym_is_expression] = STATE(4559),
    [sym_is_pattern_expression] = STATE(4559),
    [sym_cast_expression] = STATE(4559),
    [sym_checked_expression] = STATE(4559),
    [sym_invocation_expression] = STATE(4558),
    [sym_switch_expression] = STATE(4559),
    [sym_await_expression] = STATE(4558),
    [sym_throw_expression] = STATE(4559),
    [sym_element_access_expression] = STATE(3560),
    [sym_interpolated_string_expression] = STATE(4559),
    [sym_member_access_expression] = STATE(3560),
    [sym_object_creation_expression] = STATE(4558),
    [sym_parenthesized_expression] = STATE(4558),
    [sym__parenthesized_lvalue_expression] = STATE(3560),
    [sym_lambda_expression] = STATE(4559),
    [sym__lambda_parameters] = STATE(9348),
    [sym_array_creation_expression] = STATE(4559),
    [sym_anonymous_method_expression] = STATE(4559),
    [sym_anonymous_object_creation_expression] = STATE(4559),
    [sym_implicit_array_creation_expression] = STATE(4559),
    [sym_implicit_object_creation_expression] = STATE(4559),
    [sym_implicit_stackalloc_expression] = STATE(4559),
    [sym_initializer_expression] = STATE(4559),
    [sym_default_expression] = STATE(4559),
    [sym_with_expression] = STATE(4559),
    [sym_sizeof_expression] = STATE(4559),
    [sym_typeof_expression] = STATE(4559),
    [sym_makeref_expression] = STATE(4559),
    [sym_ref_expression] = STATE(4559),
    [sym_reftype_expression] = STATE(4559),
    [sym_refvalue_expression] = STATE(4559),
    [sym_stackalloc_expression] = STATE(4559),
    [sym_range_expression] = STATE(4559),
    [sym_tuple_expression] = STATE(3560),
    [sym_literal] = STATE(4559),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4559),
    [sym_preproc_region] = STATE(746),
    [sym_preproc_endregion] = STATE(746),
    [sym_preproc_line] = STATE(746),
    [sym_preproc_pragma] = STATE(746),
    [sym_preproc_nullable] = STATE(746),
    [sym_preproc_error] = STATE(746),
    [sym_preproc_define] = STATE(746),
    [sym_preproc_undef] = STATE(746),
    [aux_sym_class_declaration_repeat1] = STATE(3810),
    [aux_sym_lambda_expression_repeat1] = STATE(4141),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(2047),
    [anon_sym_ref] = ACTIONS(2049),
    [anon_sym_LBRACE] = ACTIONS(2759),
    [anon_sym_delegate] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1679),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(2053),
    [anon_sym_TILDE] = ACTIONS(2053),
    [anon_sym_PLUS_PLUS] = ACTIONS(2053),
    [anon_sym_DASH_DASH] = ACTIONS(2053),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(2051),
    [anon_sym_DASH] = ACTIONS(2051),
    [anon_sym_STAR] = ACTIONS(1685),
    [anon_sym_CARET] = ACTIONS(2053),
    [anon_sym_AMP] = ACTIONS(2053),
    [anon_sym_this] = ACTIONS(1627),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1629),
    [anon_sym_unchecked] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(2055),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2057),
    [anon_sym_DOT_DOT] = ACTIONS(2059),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_stackalloc] = ACTIONS(1641),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(1647),
    [anon_sym___reftype] = ACTIONS(1649),
    [anon_sym___refvalue] = ACTIONS(1651),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1659),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [747] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(5513),
    [sym_bracketed_argument_list] = STATE(3921),
    [sym__name] = STATE(6889),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2854),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(7061),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5152),
    [sym_non_lvalue_expression] = STATE(5735),
    [sym_lvalue_expression] = STATE(3899),
    [sym__expression_statement_expression] = STATE(5733),
    [sym_assignment_expression] = STATE(5734),
    [sym_binary_expression] = STATE(5733),
    [sym_postfix_unary_expression] = STATE(5734),
    [sym_prefix_unary_expression] = STATE(5734),
    [sym__pointer_indirection_expression] = STATE(3911),
    [sym_query_expression] = STATE(5733),
    [sym_from_clause] = STATE(7400),
    [sym_conditional_expression] = STATE(5733),
    [sym_conditional_access_expression] = STATE(5733),
    [sym_as_expression] = STATE(5733),
    [sym_is_expression] = STATE(5733),
    [sym_is_pattern_expression] = STATE(5733),
    [sym_cast_expression] = STATE(5733),
    [sym_checked_expression] = STATE(5733),
    [sym_invocation_expression] = STATE(5734),
    [sym_switch_expression] = STATE(5733),
    [sym_await_expression] = STATE(5734),
    [sym_throw_expression] = STATE(5733),
    [sym_element_access_expression] = STATE(3911),
    [sym_interpolated_string_expression] = STATE(5733),
    [sym_member_access_expression] = STATE(3911),
    [sym_object_creation_expression] = STATE(5734),
    [sym_parenthesized_expression] = STATE(5734),
    [sym__parenthesized_lvalue_expression] = STATE(3911),
    [sym_lambda_expression] = STATE(5733),
    [sym__lambda_parameters] = STATE(9790),
    [sym_array_creation_expression] = STATE(5733),
    [sym_anonymous_method_expression] = STATE(5733),
    [sym_anonymous_object_creation_expression] = STATE(5733),
    [sym_implicit_array_creation_expression] = STATE(5733),
    [sym_implicit_object_creation_expression] = STATE(5733),
    [sym_implicit_stackalloc_expression] = STATE(5733),
    [sym_initializer_expression] = STATE(5733),
    [sym_default_expression] = STATE(5733),
    [sym_with_expression] = STATE(5733),
    [sym_sizeof_expression] = STATE(5733),
    [sym_typeof_expression] = STATE(5733),
    [sym_makeref_expression] = STATE(5733),
    [sym_ref_expression] = STATE(5733),
    [sym_reftype_expression] = STATE(5733),
    [sym_refvalue_expression] = STATE(5733),
    [sym_stackalloc_expression] = STATE(5733),
    [sym_range_expression] = STATE(5733),
    [sym_tuple_expression] = STATE(3911),
    [sym_literal] = STATE(5733),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2798),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(5733),
    [sym_preproc_region] = STATE(747),
    [sym_preproc_endregion] = STATE(747),
    [sym_preproc_line] = STATE(747),
    [sym_preproc_pragma] = STATE(747),
    [sym_preproc_nullable] = STATE(747),
    [sym_preproc_error] = STATE(747),
    [sym_preproc_define] = STATE(747),
    [sym_preproc_undef] = STATE(747),
    [aux_sym_class_declaration_repeat1] = STATE(3833),
    [aux_sym_lambda_expression_repeat1] = STATE(4182),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_LPAREN] = ACTIONS(1439),
    [anon_sym_ref] = ACTIONS(1441),
    [anon_sym_LBRACE] = ACTIONS(2773),
    [anon_sym_delegate] = ACTIONS(1379),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1443),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1447),
    [anon_sym_TILDE] = ACTIONS(1447),
    [anon_sym_PLUS_PLUS] = ACTIONS(1447),
    [anon_sym_DASH_DASH] = ACTIONS(1447),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1445),
    [anon_sym_DASH] = ACTIONS(1445),
    [anon_sym_STAR] = ACTIONS(1449),
    [anon_sym_CARET] = ACTIONS(1447),
    [anon_sym_AMP] = ACTIONS(1447),
    [anon_sym_this] = ACTIONS(1393),
    [anon_sym_scoped] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1397),
    [sym_predefined_type] = ACTIONS(1399),
    [anon_sym_unchecked] = ACTIONS(1383),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1451),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1453),
    [anon_sym_DOT_DOT] = ACTIONS(1455),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_stackalloc] = ACTIONS(1413),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(1419),
    [anon_sym___reftype] = ACTIONS(1421),
    [anon_sym___refvalue] = ACTIONS(1423),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
  },
  [748] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(5508),
    [sym_bracketed_argument_list] = STATE(3921),
    [sym__name] = STATE(6889),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2854),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(7061),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5145),
    [sym_non_lvalue_expression] = STATE(5735),
    [sym_lvalue_expression] = STATE(3899),
    [sym__expression_statement_expression] = STATE(5733),
    [sym_assignment_expression] = STATE(5734),
    [sym_binary_expression] = STATE(5733),
    [sym_postfix_unary_expression] = STATE(5734),
    [sym_prefix_unary_expression] = STATE(5734),
    [sym__pointer_indirection_expression] = STATE(3911),
    [sym_query_expression] = STATE(5733),
    [sym_from_clause] = STATE(7400),
    [sym_conditional_expression] = STATE(5733),
    [sym_conditional_access_expression] = STATE(5733),
    [sym_as_expression] = STATE(5733),
    [sym_is_expression] = STATE(5733),
    [sym_is_pattern_expression] = STATE(5733),
    [sym_cast_expression] = STATE(5733),
    [sym_checked_expression] = STATE(5733),
    [sym_invocation_expression] = STATE(5734),
    [sym_switch_expression] = STATE(5733),
    [sym_await_expression] = STATE(5734),
    [sym_throw_expression] = STATE(5733),
    [sym_element_access_expression] = STATE(3911),
    [sym_interpolated_string_expression] = STATE(5733),
    [sym_member_access_expression] = STATE(3911),
    [sym_object_creation_expression] = STATE(5734),
    [sym_parenthesized_expression] = STATE(5734),
    [sym__parenthesized_lvalue_expression] = STATE(3911),
    [sym_lambda_expression] = STATE(5733),
    [sym__lambda_parameters] = STATE(9790),
    [sym_array_creation_expression] = STATE(5733),
    [sym_anonymous_method_expression] = STATE(5733),
    [sym_anonymous_object_creation_expression] = STATE(5733),
    [sym_implicit_array_creation_expression] = STATE(5733),
    [sym_implicit_object_creation_expression] = STATE(5733),
    [sym_implicit_stackalloc_expression] = STATE(5733),
    [sym_initializer_expression] = STATE(5733),
    [sym_default_expression] = STATE(5733),
    [sym_with_expression] = STATE(5733),
    [sym_sizeof_expression] = STATE(5733),
    [sym_typeof_expression] = STATE(5733),
    [sym_makeref_expression] = STATE(5733),
    [sym_ref_expression] = STATE(5733),
    [sym_reftype_expression] = STATE(5733),
    [sym_refvalue_expression] = STATE(5733),
    [sym_stackalloc_expression] = STATE(5733),
    [sym_range_expression] = STATE(5733),
    [sym_tuple_expression] = STATE(3911),
    [sym_literal] = STATE(5733),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2798),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(5733),
    [sym_preproc_region] = STATE(748),
    [sym_preproc_endregion] = STATE(748),
    [sym_preproc_line] = STATE(748),
    [sym_preproc_pragma] = STATE(748),
    [sym_preproc_nullable] = STATE(748),
    [sym_preproc_error] = STATE(748),
    [sym_preproc_define] = STATE(748),
    [sym_preproc_undef] = STATE(748),
    [aux_sym_class_declaration_repeat1] = STATE(3833),
    [aux_sym_lambda_expression_repeat1] = STATE(4182),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_LPAREN] = ACTIONS(1439),
    [anon_sym_ref] = ACTIONS(1441),
    [anon_sym_LBRACE] = ACTIONS(2773),
    [anon_sym_delegate] = ACTIONS(1379),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1443),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1447),
    [anon_sym_TILDE] = ACTIONS(1447),
    [anon_sym_PLUS_PLUS] = ACTIONS(1447),
    [anon_sym_DASH_DASH] = ACTIONS(1447),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1445),
    [anon_sym_DASH] = ACTIONS(1445),
    [anon_sym_STAR] = ACTIONS(1449),
    [anon_sym_CARET] = ACTIONS(1447),
    [anon_sym_AMP] = ACTIONS(1447),
    [anon_sym_this] = ACTIONS(1393),
    [anon_sym_scoped] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1397),
    [sym_predefined_type] = ACTIONS(1399),
    [anon_sym_unchecked] = ACTIONS(1383),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1451),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1453),
    [anon_sym_DOT_DOT] = ACTIONS(1455),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_stackalloc] = ACTIONS(1413),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(1419),
    [anon_sym___reftype] = ACTIONS(1421),
    [anon_sym___refvalue] = ACTIONS(1423),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
  },
  [749] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3751),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7076),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5900),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4314),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9775),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(749),
    [sym_preproc_endregion] = STATE(749),
    [sym_preproc_line] = STATE(749),
    [sym_preproc_pragma] = STATE(749),
    [sym_preproc_nullable] = STATE(749),
    [sym_preproc_error] = STATE(749),
    [sym_preproc_define] = STATE(749),
    [sym_preproc_undef] = STATE(749),
    [aux_sym_class_declaration_repeat1] = STATE(3835),
    [aux_sym_lambda_expression_repeat1] = STATE(4236),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1535),
    [anon_sym_ref] = ACTIONS(1537),
    [anon_sym_LBRACE] = ACTIONS(2765),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1465),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(885),
    [anon_sym_TILDE] = ACTIONS(885),
    [anon_sym_PLUS_PLUS] = ACTIONS(885),
    [anon_sym_DASH_DASH] = ACTIONS(885),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(887),
    [anon_sym_DASH] = ACTIONS(887),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(885),
    [anon_sym_AMP] = ACTIONS(885),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1539),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1541),
    [anon_sym_DOT_DOT] = ACTIONS(1543),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [750] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(5450),
    [sym_bracketed_argument_list] = STATE(3921),
    [sym__name] = STATE(6889),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2854),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(7061),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5126),
    [sym_non_lvalue_expression] = STATE(5735),
    [sym_lvalue_expression] = STATE(3899),
    [sym__expression_statement_expression] = STATE(5733),
    [sym_assignment_expression] = STATE(5734),
    [sym_binary_expression] = STATE(5733),
    [sym_postfix_unary_expression] = STATE(5734),
    [sym_prefix_unary_expression] = STATE(5734),
    [sym__pointer_indirection_expression] = STATE(3911),
    [sym_query_expression] = STATE(5733),
    [sym_from_clause] = STATE(7400),
    [sym_conditional_expression] = STATE(5733),
    [sym_conditional_access_expression] = STATE(5733),
    [sym_as_expression] = STATE(5733),
    [sym_is_expression] = STATE(5733),
    [sym_is_pattern_expression] = STATE(5733),
    [sym_cast_expression] = STATE(5733),
    [sym_checked_expression] = STATE(5733),
    [sym_invocation_expression] = STATE(5734),
    [sym_switch_expression] = STATE(5733),
    [sym_await_expression] = STATE(5734),
    [sym_throw_expression] = STATE(5733),
    [sym_element_access_expression] = STATE(3911),
    [sym_interpolated_string_expression] = STATE(5733),
    [sym_member_access_expression] = STATE(3911),
    [sym_object_creation_expression] = STATE(5734),
    [sym_parenthesized_expression] = STATE(5734),
    [sym__parenthesized_lvalue_expression] = STATE(3911),
    [sym_lambda_expression] = STATE(5733),
    [sym__lambda_parameters] = STATE(9790),
    [sym_array_creation_expression] = STATE(5733),
    [sym_anonymous_method_expression] = STATE(5733),
    [sym_anonymous_object_creation_expression] = STATE(5733),
    [sym_implicit_array_creation_expression] = STATE(5733),
    [sym_implicit_object_creation_expression] = STATE(5733),
    [sym_implicit_stackalloc_expression] = STATE(5733),
    [sym_initializer_expression] = STATE(5733),
    [sym_default_expression] = STATE(5733),
    [sym_with_expression] = STATE(5733),
    [sym_sizeof_expression] = STATE(5733),
    [sym_typeof_expression] = STATE(5733),
    [sym_makeref_expression] = STATE(5733),
    [sym_ref_expression] = STATE(5733),
    [sym_reftype_expression] = STATE(5733),
    [sym_refvalue_expression] = STATE(5733),
    [sym_stackalloc_expression] = STATE(5733),
    [sym_range_expression] = STATE(5733),
    [sym_tuple_expression] = STATE(3911),
    [sym_literal] = STATE(5733),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2798),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(5733),
    [sym_preproc_region] = STATE(750),
    [sym_preproc_endregion] = STATE(750),
    [sym_preproc_line] = STATE(750),
    [sym_preproc_pragma] = STATE(750),
    [sym_preproc_nullable] = STATE(750),
    [sym_preproc_error] = STATE(750),
    [sym_preproc_define] = STATE(750),
    [sym_preproc_undef] = STATE(750),
    [aux_sym_class_declaration_repeat1] = STATE(3833),
    [aux_sym_lambda_expression_repeat1] = STATE(4182),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_LPAREN] = ACTIONS(1439),
    [anon_sym_ref] = ACTIONS(1441),
    [anon_sym_LBRACE] = ACTIONS(2773),
    [anon_sym_delegate] = ACTIONS(1379),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1443),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1447),
    [anon_sym_TILDE] = ACTIONS(1447),
    [anon_sym_PLUS_PLUS] = ACTIONS(1447),
    [anon_sym_DASH_DASH] = ACTIONS(1447),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1445),
    [anon_sym_DASH] = ACTIONS(1445),
    [anon_sym_STAR] = ACTIONS(1449),
    [anon_sym_CARET] = ACTIONS(1447),
    [anon_sym_AMP] = ACTIONS(1447),
    [anon_sym_this] = ACTIONS(1393),
    [anon_sym_scoped] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1397),
    [sym_predefined_type] = ACTIONS(1399),
    [anon_sym_unchecked] = ACTIONS(1383),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1451),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1453),
    [anon_sym_DOT_DOT] = ACTIONS(1455),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_stackalloc] = ACTIONS(1413),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(1419),
    [anon_sym___reftype] = ACTIONS(1421),
    [anon_sym___refvalue] = ACTIONS(1423),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
  },
  [751] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5903),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(751),
    [sym_preproc_endregion] = STATE(751),
    [sym_preproc_line] = STATE(751),
    [sym_preproc_pragma] = STATE(751),
    [sym_preproc_nullable] = STATE(751),
    [sym_preproc_error] = STATE(751),
    [sym_preproc_define] = STATE(751),
    [sym_preproc_undef] = STATE(751),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_RPAREN] = ACTIONS(2781),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [752] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5904),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(752),
    [sym_preproc_endregion] = STATE(752),
    [sym_preproc_line] = STATE(752),
    [sym_preproc_pragma] = STATE(752),
    [sym_preproc_nullable] = STATE(752),
    [sym_preproc_error] = STATE(752),
    [sym_preproc_define] = STATE(752),
    [sym_preproc_undef] = STATE(752),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_RPAREN] = ACTIONS(2783),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [753] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6030),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(753),
    [sym_preproc_endregion] = STATE(753),
    [sym_preproc_line] = STATE(753),
    [sym_preproc_pragma] = STATE(753),
    [sym_preproc_nullable] = STATE(753),
    [sym_preproc_error] = STATE(753),
    [sym_preproc_define] = STATE(753),
    [sym_preproc_undef] = STATE(753),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_RBRACE] = ACTIONS(2785),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [754] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5862),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(754),
    [sym_preproc_endregion] = STATE(754),
    [sym_preproc_line] = STATE(754),
    [sym_preproc_pragma] = STATE(754),
    [sym_preproc_nullable] = STATE(754),
    [sym_preproc_error] = STATE(754),
    [sym_preproc_define] = STATE(754),
    [sym_preproc_undef] = STATE(754),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_RPAREN] = ACTIONS(2787),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [755] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4685),
    [sym_bracketed_argument_list] = STATE(3559),
    [sym__name] = STATE(6877),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2908),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6958),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4667),
    [sym_non_lvalue_expression] = STATE(4553),
    [sym_lvalue_expression] = STATE(3691),
    [sym__expression_statement_expression] = STATE(4559),
    [sym_assignment_expression] = STATE(4558),
    [sym_binary_expression] = STATE(4559),
    [sym_postfix_unary_expression] = STATE(4558),
    [sym_prefix_unary_expression] = STATE(4558),
    [sym__pointer_indirection_expression] = STATE(3560),
    [sym_query_expression] = STATE(4559),
    [sym_from_clause] = STATE(7406),
    [sym_conditional_expression] = STATE(4559),
    [sym_conditional_access_expression] = STATE(4559),
    [sym_as_expression] = STATE(4559),
    [sym_is_expression] = STATE(4559),
    [sym_is_pattern_expression] = STATE(4559),
    [sym_cast_expression] = STATE(4559),
    [sym_checked_expression] = STATE(4559),
    [sym_invocation_expression] = STATE(4558),
    [sym_switch_expression] = STATE(4559),
    [sym_await_expression] = STATE(4558),
    [sym_throw_expression] = STATE(4559),
    [sym_element_access_expression] = STATE(3560),
    [sym_interpolated_string_expression] = STATE(4559),
    [sym_member_access_expression] = STATE(3560),
    [sym_object_creation_expression] = STATE(4558),
    [sym_parenthesized_expression] = STATE(4558),
    [sym__parenthesized_lvalue_expression] = STATE(3560),
    [sym_lambda_expression] = STATE(4559),
    [sym__lambda_parameters] = STATE(9348),
    [sym_array_creation_expression] = STATE(4559),
    [sym_anonymous_method_expression] = STATE(4559),
    [sym_anonymous_object_creation_expression] = STATE(4559),
    [sym_implicit_array_creation_expression] = STATE(4559),
    [sym_implicit_object_creation_expression] = STATE(4559),
    [sym_implicit_stackalloc_expression] = STATE(4559),
    [sym_initializer_expression] = STATE(4559),
    [sym_default_expression] = STATE(4559),
    [sym_with_expression] = STATE(4559),
    [sym_sizeof_expression] = STATE(4559),
    [sym_typeof_expression] = STATE(4559),
    [sym_makeref_expression] = STATE(4559),
    [sym_ref_expression] = STATE(4559),
    [sym_reftype_expression] = STATE(4559),
    [sym_refvalue_expression] = STATE(4559),
    [sym_stackalloc_expression] = STATE(4559),
    [sym_range_expression] = STATE(4559),
    [sym_tuple_expression] = STATE(3560),
    [sym_literal] = STATE(4559),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4559),
    [sym_preproc_region] = STATE(755),
    [sym_preproc_endregion] = STATE(755),
    [sym_preproc_line] = STATE(755),
    [sym_preproc_pragma] = STATE(755),
    [sym_preproc_nullable] = STATE(755),
    [sym_preproc_error] = STATE(755),
    [sym_preproc_define] = STATE(755),
    [sym_preproc_undef] = STATE(755),
    [aux_sym_class_declaration_repeat1] = STATE(3810),
    [aux_sym_lambda_expression_repeat1] = STATE(4141),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(2047),
    [anon_sym_ref] = ACTIONS(2049),
    [anon_sym_LBRACE] = ACTIONS(2759),
    [anon_sym_delegate] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1679),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(2053),
    [anon_sym_TILDE] = ACTIONS(2053),
    [anon_sym_PLUS_PLUS] = ACTIONS(2053),
    [anon_sym_DASH_DASH] = ACTIONS(2053),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(2051),
    [anon_sym_DASH] = ACTIONS(2051),
    [anon_sym_STAR] = ACTIONS(1685),
    [anon_sym_CARET] = ACTIONS(2053),
    [anon_sym_AMP] = ACTIONS(2053),
    [anon_sym_this] = ACTIONS(1627),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1629),
    [anon_sym_unchecked] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(2055),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2057),
    [anon_sym_DOT_DOT] = ACTIONS(2059),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_stackalloc] = ACTIONS(1641),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(1647),
    [anon_sym___reftype] = ACTIONS(1649),
    [anon_sym___refvalue] = ACTIONS(1651),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1659),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [756] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4641),
    [sym_bracketed_argument_list] = STATE(3559),
    [sym__name] = STATE(6877),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2908),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6958),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4670),
    [sym_non_lvalue_expression] = STATE(4553),
    [sym_lvalue_expression] = STATE(3691),
    [sym__expression_statement_expression] = STATE(4559),
    [sym_assignment_expression] = STATE(4558),
    [sym_binary_expression] = STATE(4559),
    [sym_postfix_unary_expression] = STATE(4558),
    [sym_prefix_unary_expression] = STATE(4558),
    [sym__pointer_indirection_expression] = STATE(3560),
    [sym_query_expression] = STATE(4559),
    [sym_from_clause] = STATE(7406),
    [sym_conditional_expression] = STATE(4559),
    [sym_conditional_access_expression] = STATE(4559),
    [sym_as_expression] = STATE(4559),
    [sym_is_expression] = STATE(4559),
    [sym_is_pattern_expression] = STATE(4559),
    [sym_cast_expression] = STATE(4559),
    [sym_checked_expression] = STATE(4559),
    [sym_invocation_expression] = STATE(4558),
    [sym_switch_expression] = STATE(4559),
    [sym_await_expression] = STATE(4558),
    [sym_throw_expression] = STATE(4559),
    [sym_element_access_expression] = STATE(3560),
    [sym_interpolated_string_expression] = STATE(4559),
    [sym_member_access_expression] = STATE(3560),
    [sym_object_creation_expression] = STATE(4558),
    [sym_parenthesized_expression] = STATE(4558),
    [sym__parenthesized_lvalue_expression] = STATE(3560),
    [sym_lambda_expression] = STATE(4559),
    [sym__lambda_parameters] = STATE(9348),
    [sym_array_creation_expression] = STATE(4559),
    [sym_anonymous_method_expression] = STATE(4559),
    [sym_anonymous_object_creation_expression] = STATE(4559),
    [sym_implicit_array_creation_expression] = STATE(4559),
    [sym_implicit_object_creation_expression] = STATE(4559),
    [sym_implicit_stackalloc_expression] = STATE(4559),
    [sym_initializer_expression] = STATE(4559),
    [sym_default_expression] = STATE(4559),
    [sym_with_expression] = STATE(4559),
    [sym_sizeof_expression] = STATE(4559),
    [sym_typeof_expression] = STATE(4559),
    [sym_makeref_expression] = STATE(4559),
    [sym_ref_expression] = STATE(4559),
    [sym_reftype_expression] = STATE(4559),
    [sym_refvalue_expression] = STATE(4559),
    [sym_stackalloc_expression] = STATE(4559),
    [sym_range_expression] = STATE(4559),
    [sym_tuple_expression] = STATE(3560),
    [sym_literal] = STATE(4559),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4559),
    [sym_preproc_region] = STATE(756),
    [sym_preproc_endregion] = STATE(756),
    [sym_preproc_line] = STATE(756),
    [sym_preproc_pragma] = STATE(756),
    [sym_preproc_nullable] = STATE(756),
    [sym_preproc_error] = STATE(756),
    [sym_preproc_define] = STATE(756),
    [sym_preproc_undef] = STATE(756),
    [aux_sym_class_declaration_repeat1] = STATE(3810),
    [aux_sym_lambda_expression_repeat1] = STATE(4141),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(2047),
    [anon_sym_ref] = ACTIONS(2049),
    [anon_sym_LBRACE] = ACTIONS(2759),
    [anon_sym_delegate] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1679),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(2053),
    [anon_sym_TILDE] = ACTIONS(2053),
    [anon_sym_PLUS_PLUS] = ACTIONS(2053),
    [anon_sym_DASH_DASH] = ACTIONS(2053),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(2051),
    [anon_sym_DASH] = ACTIONS(2051),
    [anon_sym_STAR] = ACTIONS(1685),
    [anon_sym_CARET] = ACTIONS(2053),
    [anon_sym_AMP] = ACTIONS(2053),
    [anon_sym_this] = ACTIONS(1627),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1629),
    [anon_sym_unchecked] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(2055),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2057),
    [anon_sym_DOT_DOT] = ACTIONS(2059),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_stackalloc] = ACTIONS(1641),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(1647),
    [anon_sym___reftype] = ACTIONS(1649),
    [anon_sym___refvalue] = ACTIONS(1651),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1659),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [757] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(3164),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2751),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(2843),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(2975),
    [sym__array_base_type] = STATE(8712),
    [sym_nullable_type] = STATE(2974),
    [sym_pointer_type] = STATE(2974),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(2974),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(2973),
    [sym_expression] = STATE(5825),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2762),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(757),
    [sym_preproc_endregion] = STATE(757),
    [sym_preproc_line] = STATE(757),
    [sym_preproc_pragma] = STATE(757),
    [sym_preproc_nullable] = STATE(757),
    [sym_preproc_error] = STATE(757),
    [sym_preproc_define] = STATE(757),
    [sym_preproc_undef] = STATE(757),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2789),
    [anon_sym_ref] = ACTIONS(2375),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_readonly] = ACTIONS(2791),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1669),
    [anon_sym_TILDE] = ACTIONS(1669),
    [anon_sym_PLUS_PLUS] = ACTIONS(1669),
    [anon_sym_DASH_DASH] = ACTIONS(1669),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1667),
    [anon_sym_DASH] = ACTIONS(1667),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1669),
    [anon_sym_AMP] = ACTIONS(1669),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2381),
    [anon_sym_var] = ACTIONS(2793),
    [sym_predefined_type] = ACTIONS(2313),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [758] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6668),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5502),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(758),
    [sym_preproc_endregion] = STATE(758),
    [sym_preproc_line] = STATE(758),
    [sym_preproc_pragma] = STATE(758),
    [sym_preproc_nullable] = STATE(758),
    [sym_preproc_error] = STATE(758),
    [sym_preproc_define] = STATE(758),
    [sym_preproc_undef] = STATE(758),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(2601),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_readonly] = ACTIONS(2795),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2265),
    [anon_sym_var] = ACTIONS(2565),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [759] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5909),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(759),
    [sym_preproc_endregion] = STATE(759),
    [sym_preproc_line] = STATE(759),
    [sym_preproc_pragma] = STATE(759),
    [sym_preproc_nullable] = STATE(759),
    [sym_preproc_error] = STATE(759),
    [sym_preproc_define] = STATE(759),
    [sym_preproc_undef] = STATE(759),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_RPAREN] = ACTIONS(2797),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [760] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6166),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2779),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(2843),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5825),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(760),
    [sym_preproc_endregion] = STATE(760),
    [sym_preproc_line] = STATE(760),
    [sym_preproc_pragma] = STATE(760),
    [sym_preproc_nullable] = STATE(760),
    [sym_preproc_error] = STATE(760),
    [sym_preproc_define] = STATE(760),
    [sym_preproc_undef] = STATE(760),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_ref] = ACTIONS(1925),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_readonly] = ACTIONS(2683),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1669),
    [anon_sym_TILDE] = ACTIONS(1669),
    [anon_sym_PLUS_PLUS] = ACTIONS(1669),
    [anon_sym_DASH_DASH] = ACTIONS(1669),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1667),
    [anon_sym_DASH] = ACTIONS(1667),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1669),
    [anon_sym_AMP] = ACTIONS(1669),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1065),
    [anon_sym_var] = ACTIONS(2799),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [761] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3921),
    [sym__name] = STATE(6889),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2854),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(7059),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5182),
    [sym_non_lvalue_expression] = STATE(5735),
    [sym_lvalue_expression] = STATE(3899),
    [sym__expression_statement_expression] = STATE(5733),
    [sym_assignment_expression] = STATE(5734),
    [sym_binary_expression] = STATE(5733),
    [sym_postfix_unary_expression] = STATE(5734),
    [sym_prefix_unary_expression] = STATE(5734),
    [sym__pointer_indirection_expression] = STATE(3911),
    [sym_query_expression] = STATE(5733),
    [sym_from_clause] = STATE(7400),
    [sym_conditional_expression] = STATE(5733),
    [sym_conditional_access_expression] = STATE(5733),
    [sym_as_expression] = STATE(5733),
    [sym_is_expression] = STATE(5733),
    [sym_is_pattern_expression] = STATE(5733),
    [sym_cast_expression] = STATE(5733),
    [sym_checked_expression] = STATE(5733),
    [sym_invocation_expression] = STATE(5734),
    [sym_switch_expression] = STATE(5733),
    [sym_await_expression] = STATE(5734),
    [sym_throw_expression] = STATE(5733),
    [sym_element_access_expression] = STATE(3911),
    [sym_interpolated_string_expression] = STATE(5733),
    [sym_member_access_expression] = STATE(3911),
    [sym_object_creation_expression] = STATE(5734),
    [sym_parenthesized_expression] = STATE(5734),
    [sym__parenthesized_lvalue_expression] = STATE(3911),
    [sym_lambda_expression] = STATE(5733),
    [sym__lambda_parameters] = STATE(9790),
    [sym_array_creation_expression] = STATE(5733),
    [sym_anonymous_method_expression] = STATE(5733),
    [sym_anonymous_object_creation_expression] = STATE(5733),
    [sym_implicit_array_creation_expression] = STATE(5733),
    [sym_implicit_object_creation_expression] = STATE(5733),
    [sym_implicit_stackalloc_expression] = STATE(5733),
    [sym_initializer_expression] = STATE(5733),
    [sym_default_expression] = STATE(5733),
    [sym_with_expression] = STATE(5733),
    [sym_sizeof_expression] = STATE(5733),
    [sym_typeof_expression] = STATE(5733),
    [sym_makeref_expression] = STATE(5733),
    [sym_ref_expression] = STATE(5733),
    [sym_reftype_expression] = STATE(5733),
    [sym_refvalue_expression] = STATE(5733),
    [sym_stackalloc_expression] = STATE(5733),
    [sym_range_expression] = STATE(5733),
    [sym_tuple_expression] = STATE(3911),
    [sym_literal] = STATE(5733),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2798),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(5733),
    [sym_preproc_region] = STATE(761),
    [sym_preproc_endregion] = STATE(761),
    [sym_preproc_line] = STATE(761),
    [sym_preproc_pragma] = STATE(761),
    [sym_preproc_nullable] = STATE(761),
    [sym_preproc_error] = STATE(761),
    [sym_preproc_define] = STATE(761),
    [sym_preproc_undef] = STATE(761),
    [aux_sym_class_declaration_repeat1] = STATE(3833),
    [aux_sym_lambda_expression_repeat1] = STATE(4182),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_LPAREN] = ACTIONS(1439),
    [anon_sym_ref] = ACTIONS(1441),
    [anon_sym_LBRACE] = ACTIONS(1377),
    [anon_sym_delegate] = ACTIONS(1379),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1443),
    [anon_sym_readonly] = ACTIONS(2693),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1447),
    [anon_sym_TILDE] = ACTIONS(1447),
    [anon_sym_PLUS_PLUS] = ACTIONS(1447),
    [anon_sym_DASH_DASH] = ACTIONS(1447),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1445),
    [anon_sym_DASH] = ACTIONS(1445),
    [anon_sym_STAR] = ACTIONS(1449),
    [anon_sym_CARET] = ACTIONS(1447),
    [anon_sym_AMP] = ACTIONS(1447),
    [anon_sym_this] = ACTIONS(1393),
    [anon_sym_scoped] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1397),
    [sym_predefined_type] = ACTIONS(1399),
    [anon_sym_unchecked] = ACTIONS(1383),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1451),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1453),
    [anon_sym_DOT_DOT] = ACTIONS(1455),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_stackalloc] = ACTIONS(1413),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(1419),
    [anon_sym___reftype] = ACTIONS(1421),
    [anon_sym___refvalue] = ACTIONS(1423),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
  },
  [762] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6961),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6360),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9849),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(762),
    [sym_preproc_endregion] = STATE(762),
    [sym_preproc_line] = STATE(762),
    [sym_preproc_pragma] = STATE(762),
    [sym_preproc_nullable] = STATE(762),
    [sym_preproc_error] = STATE(762),
    [sym_preproc_define] = STATE(762),
    [sym_preproc_undef] = STATE(762),
    [aux_sym_class_declaration_repeat1] = STATE(3841),
    [aux_sym_lambda_expression_repeat1] = STATE(4283),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(1951),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1459),
    [anon_sym_ref] = ACTIONS(1461),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1465),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1467),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1469),
    [anon_sym_DOT_DOT] = ACTIONS(1471),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [763] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6684),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2811),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6405),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6513),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4482),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9438),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(763),
    [sym_preproc_endregion] = STATE(763),
    [sym_preproc_line] = STATE(763),
    [sym_preproc_pragma] = STATE(763),
    [sym_preproc_nullable] = STATE(763),
    [sym_preproc_error] = STATE(763),
    [sym_preproc_define] = STATE(763),
    [sym_preproc_undef] = STATE(763),
    [aux_sym_class_declaration_repeat1] = STATE(3801),
    [aux_sym_lambda_expression_repeat1] = STATE(4134),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1993),
    [anon_sym_ref] = ACTIONS(2263),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_readonly] = ACTIONS(2795),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1999),
    [anon_sym_TILDE] = ACTIONS(1999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1999),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_AMP] = ACTIONS(1999),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2265),
    [anon_sym_var] = ACTIONS(2565),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1281),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1283),
    [anon_sym_DOT_DOT] = ACTIONS(1285),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [764] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5948),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(764),
    [sym_preproc_endregion] = STATE(764),
    [sym_preproc_line] = STATE(764),
    [sym_preproc_pragma] = STATE(764),
    [sym_preproc_nullable] = STATE(764),
    [sym_preproc_error] = STATE(764),
    [sym_preproc_define] = STATE(764),
    [sym_preproc_undef] = STATE(764),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_RPAREN] = ACTIONS(2801),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [765] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4695),
    [sym_bracketed_argument_list] = STATE(3559),
    [sym__name] = STATE(6877),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2908),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7129),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4336),
    [sym_non_lvalue_expression] = STATE(4553),
    [sym_lvalue_expression] = STATE(3561),
    [sym__expression_statement_expression] = STATE(4559),
    [sym_assignment_expression] = STATE(4558),
    [sym_binary_expression] = STATE(4559),
    [sym_postfix_unary_expression] = STATE(4558),
    [sym_prefix_unary_expression] = STATE(4558),
    [sym__pointer_indirection_expression] = STATE(3560),
    [sym_query_expression] = STATE(4559),
    [sym_from_clause] = STATE(7385),
    [sym_conditional_expression] = STATE(4559),
    [sym_conditional_access_expression] = STATE(4559),
    [sym_as_expression] = STATE(4559),
    [sym_is_expression] = STATE(4559),
    [sym_is_pattern_expression] = STATE(4559),
    [sym_cast_expression] = STATE(4559),
    [sym_checked_expression] = STATE(4559),
    [sym_invocation_expression] = STATE(4558),
    [sym_switch_expression] = STATE(4559),
    [sym_await_expression] = STATE(4558),
    [sym_throw_expression] = STATE(4559),
    [sym_element_access_expression] = STATE(3560),
    [sym_interpolated_string_expression] = STATE(4559),
    [sym_member_access_expression] = STATE(3560),
    [sym_object_creation_expression] = STATE(4558),
    [sym_parenthesized_expression] = STATE(4558),
    [sym__parenthesized_lvalue_expression] = STATE(3560),
    [sym_lambda_expression] = STATE(4559),
    [sym__lambda_parameters] = STATE(9776),
    [sym_array_creation_expression] = STATE(4559),
    [sym_anonymous_method_expression] = STATE(4559),
    [sym_anonymous_object_creation_expression] = STATE(4559),
    [sym_implicit_array_creation_expression] = STATE(4559),
    [sym_implicit_object_creation_expression] = STATE(4559),
    [sym_implicit_stackalloc_expression] = STATE(4559),
    [sym_initializer_expression] = STATE(4559),
    [sym_default_expression] = STATE(4559),
    [sym_with_expression] = STATE(4559),
    [sym_sizeof_expression] = STATE(4559),
    [sym_typeof_expression] = STATE(4559),
    [sym_makeref_expression] = STATE(4559),
    [sym_ref_expression] = STATE(4559),
    [sym_reftype_expression] = STATE(4559),
    [sym_refvalue_expression] = STATE(4559),
    [sym_stackalloc_expression] = STATE(4559),
    [sym_range_expression] = STATE(4559),
    [sym_tuple_expression] = STATE(3560),
    [sym_literal] = STATE(4559),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4559),
    [sym_preproc_region] = STATE(765),
    [sym_preproc_endregion] = STATE(765),
    [sym_preproc_line] = STATE(765),
    [sym_preproc_pragma] = STATE(765),
    [sym_preproc_nullable] = STATE(765),
    [sym_preproc_error] = STATE(765),
    [sym_preproc_define] = STATE(765),
    [sym_preproc_undef] = STATE(765),
    [aux_sym_class_declaration_repeat1] = STATE(3843),
    [aux_sym_lambda_expression_repeat1] = STATE(4277),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(1675),
    [anon_sym_ref] = ACTIONS(1677),
    [anon_sym_LBRACE] = ACTIONS(2759),
    [anon_sym_delegate] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1679),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(1683),
    [anon_sym_TILDE] = ACTIONS(1683),
    [anon_sym_PLUS_PLUS] = ACTIONS(1683),
    [anon_sym_DASH_DASH] = ACTIONS(1683),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_DASH] = ACTIONS(1681),
    [anon_sym_STAR] = ACTIONS(1685),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1683),
    [anon_sym_this] = ACTIONS(1627),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1629),
    [anon_sym_unchecked] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(1687),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1689),
    [anon_sym_DOT_DOT] = ACTIONS(1691),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_stackalloc] = ACTIONS(1641),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(1647),
    [anon_sym___reftype] = ACTIONS(1649),
    [anon_sym___refvalue] = ACTIONS(1651),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1659),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [766] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5938),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(766),
    [sym_preproc_endregion] = STATE(766),
    [sym_preproc_line] = STATE(766),
    [sym_preproc_pragma] = STATE(766),
    [sym_preproc_nullable] = STATE(766),
    [sym_preproc_error] = STATE(766),
    [sym_preproc_define] = STATE(766),
    [sym_preproc_undef] = STATE(766),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_RPAREN] = ACTIONS(2803),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [767] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4688),
    [sym_bracketed_argument_list] = STATE(3559),
    [sym__name] = STATE(6877),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2908),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7129),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4391),
    [sym_non_lvalue_expression] = STATE(4553),
    [sym_lvalue_expression] = STATE(3561),
    [sym__expression_statement_expression] = STATE(4559),
    [sym_assignment_expression] = STATE(4558),
    [sym_binary_expression] = STATE(4559),
    [sym_postfix_unary_expression] = STATE(4558),
    [sym_prefix_unary_expression] = STATE(4558),
    [sym__pointer_indirection_expression] = STATE(3560),
    [sym_query_expression] = STATE(4559),
    [sym_from_clause] = STATE(7385),
    [sym_conditional_expression] = STATE(4559),
    [sym_conditional_access_expression] = STATE(4559),
    [sym_as_expression] = STATE(4559),
    [sym_is_expression] = STATE(4559),
    [sym_is_pattern_expression] = STATE(4559),
    [sym_cast_expression] = STATE(4559),
    [sym_checked_expression] = STATE(4559),
    [sym_invocation_expression] = STATE(4558),
    [sym_switch_expression] = STATE(4559),
    [sym_await_expression] = STATE(4558),
    [sym_throw_expression] = STATE(4559),
    [sym_element_access_expression] = STATE(3560),
    [sym_interpolated_string_expression] = STATE(4559),
    [sym_member_access_expression] = STATE(3560),
    [sym_object_creation_expression] = STATE(4558),
    [sym_parenthesized_expression] = STATE(4558),
    [sym__parenthesized_lvalue_expression] = STATE(3560),
    [sym_lambda_expression] = STATE(4559),
    [sym__lambda_parameters] = STATE(9776),
    [sym_array_creation_expression] = STATE(4559),
    [sym_anonymous_method_expression] = STATE(4559),
    [sym_anonymous_object_creation_expression] = STATE(4559),
    [sym_implicit_array_creation_expression] = STATE(4559),
    [sym_implicit_object_creation_expression] = STATE(4559),
    [sym_implicit_stackalloc_expression] = STATE(4559),
    [sym_initializer_expression] = STATE(4559),
    [sym_default_expression] = STATE(4559),
    [sym_with_expression] = STATE(4559),
    [sym_sizeof_expression] = STATE(4559),
    [sym_typeof_expression] = STATE(4559),
    [sym_makeref_expression] = STATE(4559),
    [sym_ref_expression] = STATE(4559),
    [sym_reftype_expression] = STATE(4559),
    [sym_refvalue_expression] = STATE(4559),
    [sym_stackalloc_expression] = STATE(4559),
    [sym_range_expression] = STATE(4559),
    [sym_tuple_expression] = STATE(3560),
    [sym_literal] = STATE(4559),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4559),
    [sym_preproc_region] = STATE(767),
    [sym_preproc_endregion] = STATE(767),
    [sym_preproc_line] = STATE(767),
    [sym_preproc_pragma] = STATE(767),
    [sym_preproc_nullable] = STATE(767),
    [sym_preproc_error] = STATE(767),
    [sym_preproc_define] = STATE(767),
    [sym_preproc_undef] = STATE(767),
    [aux_sym_class_declaration_repeat1] = STATE(3843),
    [aux_sym_lambda_expression_repeat1] = STATE(4277),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(1675),
    [anon_sym_ref] = ACTIONS(1677),
    [anon_sym_LBRACE] = ACTIONS(2759),
    [anon_sym_delegate] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1679),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(1683),
    [anon_sym_TILDE] = ACTIONS(1683),
    [anon_sym_PLUS_PLUS] = ACTIONS(1683),
    [anon_sym_DASH_DASH] = ACTIONS(1683),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_DASH] = ACTIONS(1681),
    [anon_sym_STAR] = ACTIONS(1685),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1683),
    [anon_sym_this] = ACTIONS(1627),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1629),
    [anon_sym_unchecked] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(1687),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1689),
    [anon_sym_DOT_DOT] = ACTIONS(1691),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_stackalloc] = ACTIONS(1641),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(1647),
    [anon_sym___reftype] = ACTIONS(1649),
    [anon_sym___refvalue] = ACTIONS(1651),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1659),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [768] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5937),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(768),
    [sym_preproc_endregion] = STATE(768),
    [sym_preproc_line] = STATE(768),
    [sym_preproc_pragma] = STATE(768),
    [sym_preproc_nullable] = STATE(768),
    [sym_preproc_error] = STATE(768),
    [sym_preproc_define] = STATE(768),
    [sym_preproc_undef] = STATE(768),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_RPAREN] = ACTIONS(2805),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [769] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3751),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5610),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(769),
    [sym_preproc_endregion] = STATE(769),
    [sym_preproc_line] = STATE(769),
    [sym_preproc_pragma] = STATE(769),
    [sym_preproc_nullable] = STATE(769),
    [sym_preproc_error] = STATE(769),
    [sym_preproc_define] = STATE(769),
    [sym_preproc_undef] = STATE(769),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(2765),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [770] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3769),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6910),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2957),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7089),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5067),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(3796),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7395),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9374),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(770),
    [sym_preproc_endregion] = STATE(770),
    [sym_preproc_line] = STATE(770),
    [sym_preproc_pragma] = STATE(770),
    [sym_preproc_nullable] = STATE(770),
    [sym_preproc_error] = STATE(770),
    [sym_preproc_define] = STATE(770),
    [sym_preproc_undef] = STATE(770),
    [aux_sym_class_declaration_repeat1] = STATE(3839),
    [aux_sym_lambda_expression_repeat1] = STATE(4209),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2139),
    [anon_sym_ref] = ACTIONS(2141),
    [anon_sym_LBRACE] = ACTIONS(2765),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1799),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2145),
    [anon_sym_TILDE] = ACTIONS(2145),
    [anon_sym_PLUS_PLUS] = ACTIONS(2145),
    [anon_sym_DASH_DASH] = ACTIONS(2145),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2143),
    [anon_sym_DASH] = ACTIONS(2143),
    [anon_sym_STAR] = ACTIONS(1805),
    [anon_sym_CARET] = ACTIONS(2145),
    [anon_sym_AMP] = ACTIONS(2145),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2147),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2149),
    [anon_sym_DOT_DOT] = ACTIONS(2151),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [771] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6726),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2852),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(2843),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5825),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2795),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(771),
    [sym_preproc_endregion] = STATE(771),
    [sym_preproc_line] = STATE(771),
    [sym_preproc_pragma] = STATE(771),
    [sym_preproc_nullable] = STATE(771),
    [sym_preproc_error] = STATE(771),
    [sym_preproc_define] = STATE(771),
    [sym_preproc_undef] = STATE(771),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_ref] = ACTIONS(2319),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_readonly] = ACTIONS(2807),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1669),
    [anon_sym_TILDE] = ACTIONS(1669),
    [anon_sym_PLUS_PLUS] = ACTIONS(1669),
    [anon_sym_DASH_DASH] = ACTIONS(1669),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1667),
    [anon_sym_DASH] = ACTIONS(1667),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1669),
    [anon_sym_AMP] = ACTIONS(1669),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2327),
    [anon_sym_var] = ACTIONS(2673),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [772] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3650),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6887),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2935),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6959),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6209),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4399),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7410),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9332),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(772),
    [sym_preproc_endregion] = STATE(772),
    [sym_preproc_line] = STATE(772),
    [sym_preproc_pragma] = STATE(772),
    [sym_preproc_nullable] = STATE(772),
    [sym_preproc_error] = STATE(772),
    [sym_preproc_define] = STATE(772),
    [sym_preproc_undef] = STATE(772),
    [aux_sym_class_declaration_repeat1] = STATE(3807),
    [aux_sym_lambda_expression_repeat1] = STATE(4128),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2115),
    [anon_sym_ref] = ACTIONS(2117),
    [anon_sym_LBRACE] = ACTIONS(2767),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2119),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(2123),
    [anon_sym_TILDE] = ACTIONS(2123),
    [anon_sym_PLUS_PLUS] = ACTIONS(2123),
    [anon_sym_DASH_DASH] = ACTIONS(2123),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2121),
    [anon_sym_DASH] = ACTIONS(2121),
    [anon_sym_STAR] = ACTIONS(2125),
    [anon_sym_CARET] = ACTIONS(2123),
    [anon_sym_AMP] = ACTIONS(2123),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2127),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2129),
    [anon_sym_DOT_DOT] = ACTIONS(2131),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [773] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4188),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6967),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5052),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(3858),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7382),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9625),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(773),
    [sym_preproc_endregion] = STATE(773),
    [sym_preproc_line] = STATE(773),
    [sym_preproc_pragma] = STATE(773),
    [sym_preproc_nullable] = STATE(773),
    [sym_preproc_error] = STATE(773),
    [sym_preproc_define] = STATE(773),
    [sym_preproc_undef] = STATE(773),
    [aux_sym_class_declaration_repeat1] = STATE(3851),
    [aux_sym_lambda_expression_repeat1] = STATE(4234),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_ref] = ACTIONS(1293),
    [anon_sym_LBRACE] = ACTIONS(2761),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1059),
    [anon_sym_TILDE] = ACTIONS(1059),
    [anon_sym_PLUS_PLUS] = ACTIONS(1059),
    [anon_sym_DASH_DASH] = ACTIONS(1059),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1061),
    [anon_sym_DASH] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(1303),
    [anon_sym_CARET] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1307),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1309),
    [anon_sym_DOT_DOT] = ACTIONS(1311),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [774] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3683),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6887),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2935),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6959),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6214),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4399),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7410),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9332),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(774),
    [sym_preproc_endregion] = STATE(774),
    [sym_preproc_line] = STATE(774),
    [sym_preproc_pragma] = STATE(774),
    [sym_preproc_nullable] = STATE(774),
    [sym_preproc_error] = STATE(774),
    [sym_preproc_define] = STATE(774),
    [sym_preproc_undef] = STATE(774),
    [aux_sym_class_declaration_repeat1] = STATE(3807),
    [aux_sym_lambda_expression_repeat1] = STATE(4128),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2115),
    [anon_sym_ref] = ACTIONS(2117),
    [anon_sym_LBRACE] = ACTIONS(2767),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2119),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(2123),
    [anon_sym_TILDE] = ACTIONS(2123),
    [anon_sym_PLUS_PLUS] = ACTIONS(2123),
    [anon_sym_DASH_DASH] = ACTIONS(2123),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2121),
    [anon_sym_DASH] = ACTIONS(2121),
    [anon_sym_STAR] = ACTIONS(2125),
    [anon_sym_CARET] = ACTIONS(2123),
    [anon_sym_AMP] = ACTIONS(2123),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2127),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2129),
    [anon_sym_DOT_DOT] = ACTIONS(2131),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [775] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4617),
    [sym_bracketed_argument_list] = STATE(3559),
    [sym__name] = STATE(6877),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2908),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7129),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4395),
    [sym_non_lvalue_expression] = STATE(4553),
    [sym_lvalue_expression] = STATE(3561),
    [sym__expression_statement_expression] = STATE(4559),
    [sym_assignment_expression] = STATE(4558),
    [sym_binary_expression] = STATE(4559),
    [sym_postfix_unary_expression] = STATE(4558),
    [sym_prefix_unary_expression] = STATE(4558),
    [sym__pointer_indirection_expression] = STATE(3560),
    [sym_query_expression] = STATE(4559),
    [sym_from_clause] = STATE(7385),
    [sym_conditional_expression] = STATE(4559),
    [sym_conditional_access_expression] = STATE(4559),
    [sym_as_expression] = STATE(4559),
    [sym_is_expression] = STATE(4559),
    [sym_is_pattern_expression] = STATE(4559),
    [sym_cast_expression] = STATE(4559),
    [sym_checked_expression] = STATE(4559),
    [sym_invocation_expression] = STATE(4558),
    [sym_switch_expression] = STATE(4559),
    [sym_await_expression] = STATE(4558),
    [sym_throw_expression] = STATE(4559),
    [sym_element_access_expression] = STATE(3560),
    [sym_interpolated_string_expression] = STATE(4559),
    [sym_member_access_expression] = STATE(3560),
    [sym_object_creation_expression] = STATE(4558),
    [sym_parenthesized_expression] = STATE(4558),
    [sym__parenthesized_lvalue_expression] = STATE(3560),
    [sym_lambda_expression] = STATE(4559),
    [sym__lambda_parameters] = STATE(9776),
    [sym_array_creation_expression] = STATE(4559),
    [sym_anonymous_method_expression] = STATE(4559),
    [sym_anonymous_object_creation_expression] = STATE(4559),
    [sym_implicit_array_creation_expression] = STATE(4559),
    [sym_implicit_object_creation_expression] = STATE(4559),
    [sym_implicit_stackalloc_expression] = STATE(4559),
    [sym_initializer_expression] = STATE(4559),
    [sym_default_expression] = STATE(4559),
    [sym_with_expression] = STATE(4559),
    [sym_sizeof_expression] = STATE(4559),
    [sym_typeof_expression] = STATE(4559),
    [sym_makeref_expression] = STATE(4559),
    [sym_ref_expression] = STATE(4559),
    [sym_reftype_expression] = STATE(4559),
    [sym_refvalue_expression] = STATE(4559),
    [sym_stackalloc_expression] = STATE(4559),
    [sym_range_expression] = STATE(4559),
    [sym_tuple_expression] = STATE(3560),
    [sym_literal] = STATE(4559),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4559),
    [sym_preproc_region] = STATE(775),
    [sym_preproc_endregion] = STATE(775),
    [sym_preproc_line] = STATE(775),
    [sym_preproc_pragma] = STATE(775),
    [sym_preproc_nullable] = STATE(775),
    [sym_preproc_error] = STATE(775),
    [sym_preproc_define] = STATE(775),
    [sym_preproc_undef] = STATE(775),
    [aux_sym_class_declaration_repeat1] = STATE(3843),
    [aux_sym_lambda_expression_repeat1] = STATE(4277),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(1675),
    [anon_sym_ref] = ACTIONS(1677),
    [anon_sym_LBRACE] = ACTIONS(2759),
    [anon_sym_delegate] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1679),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(1683),
    [anon_sym_TILDE] = ACTIONS(1683),
    [anon_sym_PLUS_PLUS] = ACTIONS(1683),
    [anon_sym_DASH_DASH] = ACTIONS(1683),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_DASH] = ACTIONS(1681),
    [anon_sym_STAR] = ACTIONS(1685),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1683),
    [anon_sym_this] = ACTIONS(1627),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1629),
    [anon_sym_unchecked] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(1687),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1689),
    [anon_sym_DOT_DOT] = ACTIONS(1691),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_stackalloc] = ACTIONS(1641),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(1647),
    [anon_sym___reftype] = ACTIONS(1649),
    [anon_sym___refvalue] = ACTIONS(1651),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1659),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [776] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7091),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5940),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4314),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9775),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(776),
    [sym_preproc_endregion] = STATE(776),
    [sym_preproc_line] = STATE(776),
    [sym_preproc_pragma] = STATE(776),
    [sym_preproc_nullable] = STATE(776),
    [sym_preproc_error] = STATE(776),
    [sym_preproc_define] = STATE(776),
    [sym_preproc_undef] = STATE(776),
    [aux_sym_class_declaration_repeat1] = STATE(3835),
    [aux_sym_lambda_expression_repeat1] = STATE(4236),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1535),
    [anon_sym_ref] = ACTIONS(1537),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1465),
    [anon_sym_readonly] = ACTIONS(2693),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(885),
    [anon_sym_TILDE] = ACTIONS(885),
    [anon_sym_PLUS_PLUS] = ACTIONS(885),
    [anon_sym_DASH_DASH] = ACTIONS(885),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(887),
    [anon_sym_DASH] = ACTIONS(887),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(885),
    [anon_sym_AMP] = ACTIONS(885),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1539),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1541),
    [anon_sym_DOT_DOT] = ACTIONS(1543),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [777] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4685),
    [sym_bracketed_argument_list] = STATE(3559),
    [sym__name] = STATE(6877),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2908),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7129),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4396),
    [sym_non_lvalue_expression] = STATE(4553),
    [sym_lvalue_expression] = STATE(3561),
    [sym__expression_statement_expression] = STATE(4559),
    [sym_assignment_expression] = STATE(4558),
    [sym_binary_expression] = STATE(4559),
    [sym_postfix_unary_expression] = STATE(4558),
    [sym_prefix_unary_expression] = STATE(4558),
    [sym__pointer_indirection_expression] = STATE(3560),
    [sym_query_expression] = STATE(4559),
    [sym_from_clause] = STATE(7385),
    [sym_conditional_expression] = STATE(4559),
    [sym_conditional_access_expression] = STATE(4559),
    [sym_as_expression] = STATE(4559),
    [sym_is_expression] = STATE(4559),
    [sym_is_pattern_expression] = STATE(4559),
    [sym_cast_expression] = STATE(4559),
    [sym_checked_expression] = STATE(4559),
    [sym_invocation_expression] = STATE(4558),
    [sym_switch_expression] = STATE(4559),
    [sym_await_expression] = STATE(4558),
    [sym_throw_expression] = STATE(4559),
    [sym_element_access_expression] = STATE(3560),
    [sym_interpolated_string_expression] = STATE(4559),
    [sym_member_access_expression] = STATE(3560),
    [sym_object_creation_expression] = STATE(4558),
    [sym_parenthesized_expression] = STATE(4558),
    [sym__parenthesized_lvalue_expression] = STATE(3560),
    [sym_lambda_expression] = STATE(4559),
    [sym__lambda_parameters] = STATE(9776),
    [sym_array_creation_expression] = STATE(4559),
    [sym_anonymous_method_expression] = STATE(4559),
    [sym_anonymous_object_creation_expression] = STATE(4559),
    [sym_implicit_array_creation_expression] = STATE(4559),
    [sym_implicit_object_creation_expression] = STATE(4559),
    [sym_implicit_stackalloc_expression] = STATE(4559),
    [sym_initializer_expression] = STATE(4559),
    [sym_default_expression] = STATE(4559),
    [sym_with_expression] = STATE(4559),
    [sym_sizeof_expression] = STATE(4559),
    [sym_typeof_expression] = STATE(4559),
    [sym_makeref_expression] = STATE(4559),
    [sym_ref_expression] = STATE(4559),
    [sym_reftype_expression] = STATE(4559),
    [sym_refvalue_expression] = STATE(4559),
    [sym_stackalloc_expression] = STATE(4559),
    [sym_range_expression] = STATE(4559),
    [sym_tuple_expression] = STATE(3560),
    [sym_literal] = STATE(4559),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4559),
    [sym_preproc_region] = STATE(777),
    [sym_preproc_endregion] = STATE(777),
    [sym_preproc_line] = STATE(777),
    [sym_preproc_pragma] = STATE(777),
    [sym_preproc_nullable] = STATE(777),
    [sym_preproc_error] = STATE(777),
    [sym_preproc_define] = STATE(777),
    [sym_preproc_undef] = STATE(777),
    [aux_sym_class_declaration_repeat1] = STATE(3843),
    [aux_sym_lambda_expression_repeat1] = STATE(4277),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(1675),
    [anon_sym_ref] = ACTIONS(1677),
    [anon_sym_LBRACE] = ACTIONS(2759),
    [anon_sym_delegate] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1679),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(1683),
    [anon_sym_TILDE] = ACTIONS(1683),
    [anon_sym_PLUS_PLUS] = ACTIONS(1683),
    [anon_sym_DASH_DASH] = ACTIONS(1683),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_DASH] = ACTIONS(1681),
    [anon_sym_STAR] = ACTIONS(1685),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1683),
    [anon_sym_this] = ACTIONS(1627),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1629),
    [anon_sym_unchecked] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(1687),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1689),
    [anon_sym_DOT_DOT] = ACTIONS(1691),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_stackalloc] = ACTIONS(1641),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(1647),
    [anon_sym___reftype] = ACTIONS(1649),
    [anon_sym___refvalue] = ACTIONS(1651),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1659),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [778] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3612),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6887),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2935),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6959),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6217),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4399),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7410),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9332),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(778),
    [sym_preproc_endregion] = STATE(778),
    [sym_preproc_line] = STATE(778),
    [sym_preproc_pragma] = STATE(778),
    [sym_preproc_nullable] = STATE(778),
    [sym_preproc_error] = STATE(778),
    [sym_preproc_define] = STATE(778),
    [sym_preproc_undef] = STATE(778),
    [aux_sym_class_declaration_repeat1] = STATE(3807),
    [aux_sym_lambda_expression_repeat1] = STATE(4128),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2115),
    [anon_sym_ref] = ACTIONS(2117),
    [anon_sym_LBRACE] = ACTIONS(2767),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2119),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(2123),
    [anon_sym_TILDE] = ACTIONS(2123),
    [anon_sym_PLUS_PLUS] = ACTIONS(2123),
    [anon_sym_DASH_DASH] = ACTIONS(2123),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2121),
    [anon_sym_DASH] = ACTIONS(2121),
    [anon_sym_STAR] = ACTIONS(2125),
    [anon_sym_CARET] = ACTIONS(2123),
    [anon_sym_AMP] = ACTIONS(2123),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2127),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2129),
    [anon_sym_DOT_DOT] = ACTIONS(2131),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [779] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3638),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6887),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2935),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6959),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6224),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4399),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7410),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9332),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(779),
    [sym_preproc_endregion] = STATE(779),
    [sym_preproc_line] = STATE(779),
    [sym_preproc_pragma] = STATE(779),
    [sym_preproc_nullable] = STATE(779),
    [sym_preproc_error] = STATE(779),
    [sym_preproc_define] = STATE(779),
    [sym_preproc_undef] = STATE(779),
    [aux_sym_class_declaration_repeat1] = STATE(3807),
    [aux_sym_lambda_expression_repeat1] = STATE(4128),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2115),
    [anon_sym_ref] = ACTIONS(2117),
    [anon_sym_LBRACE] = ACTIONS(2767),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2119),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(2123),
    [anon_sym_TILDE] = ACTIONS(2123),
    [anon_sym_PLUS_PLUS] = ACTIONS(2123),
    [anon_sym_DASH_DASH] = ACTIONS(2123),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2121),
    [anon_sym_DASH] = ACTIONS(2121),
    [anon_sym_STAR] = ACTIONS(2125),
    [anon_sym_CARET] = ACTIONS(2123),
    [anon_sym_AMP] = ACTIONS(2123),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2127),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2129),
    [anon_sym_DOT_DOT] = ACTIONS(2131),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [780] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7022),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6001),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4329),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7402),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9167),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(780),
    [sym_preproc_endregion] = STATE(780),
    [sym_preproc_line] = STATE(780),
    [sym_preproc_pragma] = STATE(780),
    [sym_preproc_nullable] = STATE(780),
    [sym_preproc_error] = STATE(780),
    [sym_preproc_define] = STATE(780),
    [sym_preproc_undef] = STATE(780),
    [aux_sym_class_declaration_repeat1] = STATE(3794),
    [aux_sym_lambda_expression_repeat1] = STATE(4293),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1693),
    [anon_sym_ref] = ACTIONS(1695),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_readonly] = ACTIONS(2693),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1699),
    [anon_sym_TILDE] = ACTIONS(1699),
    [anon_sym_PLUS_PLUS] = ACTIONS(1699),
    [anon_sym_DASH_DASH] = ACTIONS(1699),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1697),
    [anon_sym_DASH] = ACTIONS(1697),
    [anon_sym_STAR] = ACTIONS(1701),
    [anon_sym_CARET] = ACTIONS(1699),
    [anon_sym_AMP] = ACTIONS(1699),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1703),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1705),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [781] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4132),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7027),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5999),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4329),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7402),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9167),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(781),
    [sym_preproc_endregion] = STATE(781),
    [sym_preproc_line] = STATE(781),
    [sym_preproc_pragma] = STATE(781),
    [sym_preproc_nullable] = STATE(781),
    [sym_preproc_error] = STATE(781),
    [sym_preproc_define] = STATE(781),
    [sym_preproc_undef] = STATE(781),
    [aux_sym_class_declaration_repeat1] = STATE(3794),
    [aux_sym_lambda_expression_repeat1] = STATE(4293),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1693),
    [anon_sym_ref] = ACTIONS(1695),
    [anon_sym_LBRACE] = ACTIONS(2761),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1699),
    [anon_sym_TILDE] = ACTIONS(1699),
    [anon_sym_PLUS_PLUS] = ACTIONS(1699),
    [anon_sym_DASH_DASH] = ACTIONS(1699),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1697),
    [anon_sym_DASH] = ACTIONS(1697),
    [anon_sym_STAR] = ACTIONS(1701),
    [anon_sym_CARET] = ACTIONS(1699),
    [anon_sym_AMP] = ACTIONS(1699),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1703),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1705),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [782] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4085),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7027),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5998),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4329),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7402),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9167),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(782),
    [sym_preproc_endregion] = STATE(782),
    [sym_preproc_line] = STATE(782),
    [sym_preproc_pragma] = STATE(782),
    [sym_preproc_nullable] = STATE(782),
    [sym_preproc_error] = STATE(782),
    [sym_preproc_define] = STATE(782),
    [sym_preproc_undef] = STATE(782),
    [aux_sym_class_declaration_repeat1] = STATE(3794),
    [aux_sym_lambda_expression_repeat1] = STATE(4293),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1693),
    [anon_sym_ref] = ACTIONS(1695),
    [anon_sym_LBRACE] = ACTIONS(2761),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1699),
    [anon_sym_TILDE] = ACTIONS(1699),
    [anon_sym_PLUS_PLUS] = ACTIONS(1699),
    [anon_sym_DASH_DASH] = ACTIONS(1699),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1697),
    [anon_sym_DASH] = ACTIONS(1697),
    [anon_sym_STAR] = ACTIONS(1701),
    [anon_sym_CARET] = ACTIONS(1699),
    [anon_sym_AMP] = ACTIONS(1699),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1703),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1705),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [783] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4066),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7027),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5993),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4329),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7402),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9167),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(783),
    [sym_preproc_endregion] = STATE(783),
    [sym_preproc_line] = STATE(783),
    [sym_preproc_pragma] = STATE(783),
    [sym_preproc_nullable] = STATE(783),
    [sym_preproc_error] = STATE(783),
    [sym_preproc_define] = STATE(783),
    [sym_preproc_undef] = STATE(783),
    [aux_sym_class_declaration_repeat1] = STATE(3794),
    [aux_sym_lambda_expression_repeat1] = STATE(4293),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1693),
    [anon_sym_ref] = ACTIONS(1695),
    [anon_sym_LBRACE] = ACTIONS(2761),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1699),
    [anon_sym_TILDE] = ACTIONS(1699),
    [anon_sym_PLUS_PLUS] = ACTIONS(1699),
    [anon_sym_DASH_DASH] = ACTIONS(1699),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1697),
    [anon_sym_DASH] = ACTIONS(1697),
    [anon_sym_STAR] = ACTIONS(1701),
    [anon_sym_CARET] = ACTIONS(1699),
    [anon_sym_AMP] = ACTIONS(1699),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1703),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1705),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [784] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3632),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6887),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2935),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6959),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6226),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4399),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7410),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9332),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(784),
    [sym_preproc_endregion] = STATE(784),
    [sym_preproc_line] = STATE(784),
    [sym_preproc_pragma] = STATE(784),
    [sym_preproc_nullable] = STATE(784),
    [sym_preproc_error] = STATE(784),
    [sym_preproc_define] = STATE(784),
    [sym_preproc_undef] = STATE(784),
    [aux_sym_class_declaration_repeat1] = STATE(3807),
    [aux_sym_lambda_expression_repeat1] = STATE(4128),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2115),
    [anon_sym_ref] = ACTIONS(2117),
    [anon_sym_LBRACE] = ACTIONS(2767),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2119),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(2123),
    [anon_sym_TILDE] = ACTIONS(2123),
    [anon_sym_PLUS_PLUS] = ACTIONS(2123),
    [anon_sym_DASH_DASH] = ACTIONS(2123),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2121),
    [anon_sym_DASH] = ACTIONS(2121),
    [anon_sym_STAR] = ACTIONS(2125),
    [anon_sym_CARET] = ACTIONS(2123),
    [anon_sym_AMP] = ACTIONS(2123),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2127),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2129),
    [anon_sym_DOT_DOT] = ACTIONS(2131),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [785] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3615),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6887),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2935),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6959),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6229),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4399),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7410),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9332),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(785),
    [sym_preproc_endregion] = STATE(785),
    [sym_preproc_line] = STATE(785),
    [sym_preproc_pragma] = STATE(785),
    [sym_preproc_nullable] = STATE(785),
    [sym_preproc_error] = STATE(785),
    [sym_preproc_define] = STATE(785),
    [sym_preproc_undef] = STATE(785),
    [aux_sym_class_declaration_repeat1] = STATE(3807),
    [aux_sym_lambda_expression_repeat1] = STATE(4128),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2115),
    [anon_sym_ref] = ACTIONS(2117),
    [anon_sym_LBRACE] = ACTIONS(2767),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2119),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(2123),
    [anon_sym_TILDE] = ACTIONS(2123),
    [anon_sym_PLUS_PLUS] = ACTIONS(2123),
    [anon_sym_DASH_DASH] = ACTIONS(2123),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2121),
    [anon_sym_DASH] = ACTIONS(2121),
    [anon_sym_STAR] = ACTIONS(2125),
    [anon_sym_CARET] = ACTIONS(2123),
    [anon_sym_AMP] = ACTIONS(2123),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2127),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2129),
    [anon_sym_DOT_DOT] = ACTIONS(2131),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [786] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4116),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7027),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5988),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4329),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7402),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9167),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(786),
    [sym_preproc_endregion] = STATE(786),
    [sym_preproc_line] = STATE(786),
    [sym_preproc_pragma] = STATE(786),
    [sym_preproc_nullable] = STATE(786),
    [sym_preproc_error] = STATE(786),
    [sym_preproc_define] = STATE(786),
    [sym_preproc_undef] = STATE(786),
    [aux_sym_class_declaration_repeat1] = STATE(3794),
    [aux_sym_lambda_expression_repeat1] = STATE(4293),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1693),
    [anon_sym_ref] = ACTIONS(1695),
    [anon_sym_LBRACE] = ACTIONS(2761),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1699),
    [anon_sym_TILDE] = ACTIONS(1699),
    [anon_sym_PLUS_PLUS] = ACTIONS(1699),
    [anon_sym_DASH_DASH] = ACTIONS(1699),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1697),
    [anon_sym_DASH] = ACTIONS(1697),
    [anon_sym_STAR] = ACTIONS(1701),
    [anon_sym_CARET] = ACTIONS(1699),
    [anon_sym_AMP] = ACTIONS(1699),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1703),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1705),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [787] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4151),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7027),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5987),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4329),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7402),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9167),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(787),
    [sym_preproc_endregion] = STATE(787),
    [sym_preproc_line] = STATE(787),
    [sym_preproc_pragma] = STATE(787),
    [sym_preproc_nullable] = STATE(787),
    [sym_preproc_error] = STATE(787),
    [sym_preproc_define] = STATE(787),
    [sym_preproc_undef] = STATE(787),
    [aux_sym_class_declaration_repeat1] = STATE(3794),
    [aux_sym_lambda_expression_repeat1] = STATE(4293),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1693),
    [anon_sym_ref] = ACTIONS(1695),
    [anon_sym_LBRACE] = ACTIONS(2761),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1699),
    [anon_sym_TILDE] = ACTIONS(1699),
    [anon_sym_PLUS_PLUS] = ACTIONS(1699),
    [anon_sym_DASH_DASH] = ACTIONS(1699),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1697),
    [anon_sym_DASH] = ACTIONS(1697),
    [anon_sym_STAR] = ACTIONS(1701),
    [anon_sym_CARET] = ACTIONS(1699),
    [anon_sym_AMP] = ACTIONS(1699),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1703),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1705),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [788] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4188),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7027),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5986),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4329),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7402),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9167),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(788),
    [sym_preproc_endregion] = STATE(788),
    [sym_preproc_line] = STATE(788),
    [sym_preproc_pragma] = STATE(788),
    [sym_preproc_nullable] = STATE(788),
    [sym_preproc_error] = STATE(788),
    [sym_preproc_define] = STATE(788),
    [sym_preproc_undef] = STATE(788),
    [aux_sym_class_declaration_repeat1] = STATE(3794),
    [aux_sym_lambda_expression_repeat1] = STATE(4293),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1693),
    [anon_sym_ref] = ACTIONS(1695),
    [anon_sym_LBRACE] = ACTIONS(2761),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1699),
    [anon_sym_TILDE] = ACTIONS(1699),
    [anon_sym_PLUS_PLUS] = ACTIONS(1699),
    [anon_sym_DASH_DASH] = ACTIONS(1699),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1697),
    [anon_sym_DASH] = ACTIONS(1697),
    [anon_sym_STAR] = ACTIONS(1701),
    [anon_sym_CARET] = ACTIONS(1699),
    [anon_sym_AMP] = ACTIONS(1699),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1703),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1705),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [789] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3738),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6910),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2957),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7089),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5023),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(3796),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7395),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9374),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(789),
    [sym_preproc_endregion] = STATE(789),
    [sym_preproc_line] = STATE(789),
    [sym_preproc_pragma] = STATE(789),
    [sym_preproc_nullable] = STATE(789),
    [sym_preproc_error] = STATE(789),
    [sym_preproc_define] = STATE(789),
    [sym_preproc_undef] = STATE(789),
    [aux_sym_class_declaration_repeat1] = STATE(3839),
    [aux_sym_lambda_expression_repeat1] = STATE(4209),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2139),
    [anon_sym_ref] = ACTIONS(2141),
    [anon_sym_LBRACE] = ACTIONS(2765),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1799),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2145),
    [anon_sym_TILDE] = ACTIONS(2145),
    [anon_sym_PLUS_PLUS] = ACTIONS(2145),
    [anon_sym_DASH_DASH] = ACTIONS(2145),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2143),
    [anon_sym_DASH] = ACTIONS(2143),
    [anon_sym_STAR] = ACTIONS(1805),
    [anon_sym_CARET] = ACTIONS(2145),
    [anon_sym_AMP] = ACTIONS(2145),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2147),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2149),
    [anon_sym_DOT_DOT] = ACTIONS(2151),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [790] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5932),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(790),
    [sym_preproc_endregion] = STATE(790),
    [sym_preproc_line] = STATE(790),
    [sym_preproc_pragma] = STATE(790),
    [sym_preproc_nullable] = STATE(790),
    [sym_preproc_error] = STATE(790),
    [sym_preproc_define] = STATE(790),
    [sym_preproc_undef] = STATE(790),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_RPAREN] = ACTIONS(2809),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [791] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4641),
    [sym_bracketed_argument_list] = STATE(3559),
    [sym__name] = STATE(6877),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2908),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7129),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4401),
    [sym_non_lvalue_expression] = STATE(4553),
    [sym_lvalue_expression] = STATE(3561),
    [sym__expression_statement_expression] = STATE(4559),
    [sym_assignment_expression] = STATE(4558),
    [sym_binary_expression] = STATE(4559),
    [sym_postfix_unary_expression] = STATE(4558),
    [sym_prefix_unary_expression] = STATE(4558),
    [sym__pointer_indirection_expression] = STATE(3560),
    [sym_query_expression] = STATE(4559),
    [sym_from_clause] = STATE(7385),
    [sym_conditional_expression] = STATE(4559),
    [sym_conditional_access_expression] = STATE(4559),
    [sym_as_expression] = STATE(4559),
    [sym_is_expression] = STATE(4559),
    [sym_is_pattern_expression] = STATE(4559),
    [sym_cast_expression] = STATE(4559),
    [sym_checked_expression] = STATE(4559),
    [sym_invocation_expression] = STATE(4558),
    [sym_switch_expression] = STATE(4559),
    [sym_await_expression] = STATE(4558),
    [sym_throw_expression] = STATE(4559),
    [sym_element_access_expression] = STATE(3560),
    [sym_interpolated_string_expression] = STATE(4559),
    [sym_member_access_expression] = STATE(3560),
    [sym_object_creation_expression] = STATE(4558),
    [sym_parenthesized_expression] = STATE(4558),
    [sym__parenthesized_lvalue_expression] = STATE(3560),
    [sym_lambda_expression] = STATE(4559),
    [sym__lambda_parameters] = STATE(9776),
    [sym_array_creation_expression] = STATE(4559),
    [sym_anonymous_method_expression] = STATE(4559),
    [sym_anonymous_object_creation_expression] = STATE(4559),
    [sym_implicit_array_creation_expression] = STATE(4559),
    [sym_implicit_object_creation_expression] = STATE(4559),
    [sym_implicit_stackalloc_expression] = STATE(4559),
    [sym_initializer_expression] = STATE(4559),
    [sym_default_expression] = STATE(4559),
    [sym_with_expression] = STATE(4559),
    [sym_sizeof_expression] = STATE(4559),
    [sym_typeof_expression] = STATE(4559),
    [sym_makeref_expression] = STATE(4559),
    [sym_ref_expression] = STATE(4559),
    [sym_reftype_expression] = STATE(4559),
    [sym_refvalue_expression] = STATE(4559),
    [sym_stackalloc_expression] = STATE(4559),
    [sym_range_expression] = STATE(4559),
    [sym_tuple_expression] = STATE(3560),
    [sym_literal] = STATE(4559),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4559),
    [sym_preproc_region] = STATE(791),
    [sym_preproc_endregion] = STATE(791),
    [sym_preproc_line] = STATE(791),
    [sym_preproc_pragma] = STATE(791),
    [sym_preproc_nullable] = STATE(791),
    [sym_preproc_error] = STATE(791),
    [sym_preproc_define] = STATE(791),
    [sym_preproc_undef] = STATE(791),
    [aux_sym_class_declaration_repeat1] = STATE(3843),
    [aux_sym_lambda_expression_repeat1] = STATE(4277),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(1675),
    [anon_sym_ref] = ACTIONS(1677),
    [anon_sym_LBRACE] = ACTIONS(2759),
    [anon_sym_delegate] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1679),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(1683),
    [anon_sym_TILDE] = ACTIONS(1683),
    [anon_sym_PLUS_PLUS] = ACTIONS(1683),
    [anon_sym_DASH_DASH] = ACTIONS(1683),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_DASH] = ACTIONS(1681),
    [anon_sym_STAR] = ACTIONS(1685),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1683),
    [anon_sym_this] = ACTIONS(1627),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1629),
    [anon_sym_unchecked] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(1687),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1689),
    [anon_sym_DOT_DOT] = ACTIONS(1691),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_stackalloc] = ACTIONS(1641),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(1647),
    [anon_sym___reftype] = ACTIONS(1649),
    [anon_sym___refvalue] = ACTIONS(1651),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1659),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [792] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5931),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(792),
    [sym_preproc_endregion] = STATE(792),
    [sym_preproc_line] = STATE(792),
    [sym_preproc_pragma] = STATE(792),
    [sym_preproc_nullable] = STATE(792),
    [sym_preproc_error] = STATE(792),
    [sym_preproc_define] = STATE(792),
    [sym_preproc_undef] = STATE(792),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_RPAREN] = ACTIONS(2811),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [793] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3767),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6910),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2957),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7089),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5100),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(3796),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7395),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9374),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(793),
    [sym_preproc_endregion] = STATE(793),
    [sym_preproc_line] = STATE(793),
    [sym_preproc_pragma] = STATE(793),
    [sym_preproc_nullable] = STATE(793),
    [sym_preproc_error] = STATE(793),
    [sym_preproc_define] = STATE(793),
    [sym_preproc_undef] = STATE(793),
    [aux_sym_class_declaration_repeat1] = STATE(3839),
    [aux_sym_lambda_expression_repeat1] = STATE(4209),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2139),
    [anon_sym_ref] = ACTIONS(2141),
    [anon_sym_LBRACE] = ACTIONS(2765),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1799),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2145),
    [anon_sym_TILDE] = ACTIONS(2145),
    [anon_sym_PLUS_PLUS] = ACTIONS(2145),
    [anon_sym_DASH_DASH] = ACTIONS(2145),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2143),
    [anon_sym_DASH] = ACTIONS(2143),
    [anon_sym_STAR] = ACTIONS(1805),
    [anon_sym_CARET] = ACTIONS(2145),
    [anon_sym_AMP] = ACTIONS(2145),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2147),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2149),
    [anon_sym_DOT_DOT] = ACTIONS(2151),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [794] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6961),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6494),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9849),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(794),
    [sym_preproc_endregion] = STATE(794),
    [sym_preproc_line] = STATE(794),
    [sym_preproc_pragma] = STATE(794),
    [sym_preproc_nullable] = STATE(794),
    [sym_preproc_error] = STATE(794),
    [sym_preproc_define] = STATE(794),
    [sym_preproc_undef] = STATE(794),
    [aux_sym_class_declaration_repeat1] = STATE(3841),
    [aux_sym_lambda_expression_repeat1] = STATE(4283),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(2813),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1459),
    [anon_sym_ref] = ACTIONS(1461),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1465),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1467),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1469),
    [anon_sym_DOT_DOT] = ACTIONS(1471),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [795] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(5649),
    [sym_bracketed_argument_list] = STATE(3921),
    [sym__name] = STATE(6889),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2854),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(6991),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5552),
    [sym_non_lvalue_expression] = STATE(5735),
    [sym_lvalue_expression] = STATE(4295),
    [sym__expression_statement_expression] = STATE(5733),
    [sym_assignment_expression] = STATE(5734),
    [sym_binary_expression] = STATE(5733),
    [sym_postfix_unary_expression] = STATE(5734),
    [sym_prefix_unary_expression] = STATE(5734),
    [sym__pointer_indirection_expression] = STATE(3911),
    [sym_query_expression] = STATE(5733),
    [sym_from_clause] = STATE(7393),
    [sym_conditional_expression] = STATE(5733),
    [sym_conditional_access_expression] = STATE(5733),
    [sym_as_expression] = STATE(5733),
    [sym_is_expression] = STATE(5733),
    [sym_is_pattern_expression] = STATE(5733),
    [sym_cast_expression] = STATE(5733),
    [sym_checked_expression] = STATE(5733),
    [sym_invocation_expression] = STATE(5734),
    [sym_switch_expression] = STATE(5733),
    [sym_await_expression] = STATE(5734),
    [sym_throw_expression] = STATE(5733),
    [sym_element_access_expression] = STATE(3911),
    [sym_interpolated_string_expression] = STATE(5733),
    [sym_member_access_expression] = STATE(3911),
    [sym_object_creation_expression] = STATE(5734),
    [sym_parenthesized_expression] = STATE(5734),
    [sym__parenthesized_lvalue_expression] = STATE(3911),
    [sym_lambda_expression] = STATE(5733),
    [sym__lambda_parameters] = STATE(9313),
    [sym_array_creation_expression] = STATE(5733),
    [sym_anonymous_method_expression] = STATE(5733),
    [sym_anonymous_object_creation_expression] = STATE(5733),
    [sym_implicit_array_creation_expression] = STATE(5733),
    [sym_implicit_object_creation_expression] = STATE(5733),
    [sym_implicit_stackalloc_expression] = STATE(5733),
    [sym_initializer_expression] = STATE(5733),
    [sym_default_expression] = STATE(5733),
    [sym_with_expression] = STATE(5733),
    [sym_sizeof_expression] = STATE(5733),
    [sym_typeof_expression] = STATE(5733),
    [sym_makeref_expression] = STATE(5733),
    [sym_ref_expression] = STATE(5733),
    [sym_reftype_expression] = STATE(5733),
    [sym_refvalue_expression] = STATE(5733),
    [sym_stackalloc_expression] = STATE(5733),
    [sym_range_expression] = STATE(5733),
    [sym_tuple_expression] = STATE(3911),
    [sym_literal] = STATE(5733),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2798),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(5733),
    [sym_preproc_region] = STATE(795),
    [sym_preproc_endregion] = STATE(795),
    [sym_preproc_line] = STATE(795),
    [sym_preproc_pragma] = STATE(795),
    [sym_preproc_nullable] = STATE(795),
    [sym_preproc_error] = STATE(795),
    [sym_preproc_define] = STATE(795),
    [sym_preproc_undef] = STATE(795),
    [aux_sym_class_declaration_repeat1] = STATE(3805),
    [aux_sym_lambda_expression_repeat1] = STATE(4122),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_LPAREN] = ACTIONS(1591),
    [anon_sym_ref] = ACTIONS(1593),
    [anon_sym_LBRACE] = ACTIONS(2773),
    [anon_sym_delegate] = ACTIONS(1379),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1443),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1597),
    [anon_sym_TILDE] = ACTIONS(1597),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1595),
    [anon_sym_DASH] = ACTIONS(1595),
    [anon_sym_STAR] = ACTIONS(1449),
    [anon_sym_CARET] = ACTIONS(1597),
    [anon_sym_AMP] = ACTIONS(1597),
    [anon_sym_this] = ACTIONS(1393),
    [anon_sym_scoped] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1397),
    [sym_predefined_type] = ACTIONS(1399),
    [anon_sym_unchecked] = ACTIONS(1383),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1599),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1601),
    [anon_sym_DOT_DOT] = ACTIONS(1603),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_stackalloc] = ACTIONS(1413),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(1419),
    [anon_sym___reftype] = ACTIONS(1421),
    [anon_sym___refvalue] = ACTIONS(1423),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
  },
  [796] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6961),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6503),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9849),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(796),
    [sym_preproc_endregion] = STATE(796),
    [sym_preproc_line] = STATE(796),
    [sym_preproc_pragma] = STATE(796),
    [sym_preproc_nullable] = STATE(796),
    [sym_preproc_error] = STATE(796),
    [sym_preproc_define] = STATE(796),
    [sym_preproc_undef] = STATE(796),
    [aux_sym_class_declaration_repeat1] = STATE(3841),
    [aux_sym_lambda_expression_repeat1] = STATE(4283),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(2815),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1459),
    [anon_sym_ref] = ACTIONS(1461),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1465),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1467),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1469),
    [anon_sym_DOT_DOT] = ACTIONS(1471),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [797] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6911),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6996),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5048),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(3829),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7391),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9246),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(797),
    [sym_preproc_endregion] = STATE(797),
    [sym_preproc_line] = STATE(797),
    [sym_preproc_pragma] = STATE(797),
    [sym_preproc_nullable] = STATE(797),
    [sym_preproc_error] = STATE(797),
    [sym_preproc_define] = STATE(797),
    [sym_preproc_undef] = STATE(797),
    [aux_sym_class_declaration_repeat1] = STATE(3800),
    [aux_sym_lambda_expression_repeat1] = STATE(4089),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1323),
    [anon_sym_ref] = ACTIONS(1325),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1145),
    [anon_sym_readonly] = ACTIONS(2693),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1329),
    [anon_sym_TILDE] = ACTIONS(1329),
    [anon_sym_PLUS_PLUS] = ACTIONS(1329),
    [anon_sym_DASH_DASH] = ACTIONS(1329),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1327),
    [anon_sym_DASH] = ACTIONS(1327),
    [anon_sym_STAR] = ACTIONS(1331),
    [anon_sym_CARET] = ACTIONS(1329),
    [anon_sym_AMP] = ACTIONS(1329),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1333),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1335),
    [anon_sym_DOT_DOT] = ACTIONS(1337),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [798] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6887),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2935),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6973),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6101),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4399),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7410),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9332),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(798),
    [sym_preproc_endregion] = STATE(798),
    [sym_preproc_line] = STATE(798),
    [sym_preproc_pragma] = STATE(798),
    [sym_preproc_nullable] = STATE(798),
    [sym_preproc_error] = STATE(798),
    [sym_preproc_define] = STATE(798),
    [sym_preproc_undef] = STATE(798),
    [aux_sym_class_declaration_repeat1] = STATE(3807),
    [aux_sym_lambda_expression_repeat1] = STATE(4128),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2115),
    [anon_sym_ref] = ACTIONS(2117),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2119),
    [anon_sym_readonly] = ACTIONS(2693),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(2123),
    [anon_sym_TILDE] = ACTIONS(2123),
    [anon_sym_PLUS_PLUS] = ACTIONS(2123),
    [anon_sym_DASH_DASH] = ACTIONS(2123),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2121),
    [anon_sym_DASH] = ACTIONS(2121),
    [anon_sym_STAR] = ACTIONS(2125),
    [anon_sym_CARET] = ACTIONS(2123),
    [anon_sym_AMP] = ACTIONS(2123),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2127),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2129),
    [anon_sym_DOT_DOT] = ACTIONS(2131),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [799] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3767),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5652),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(799),
    [sym_preproc_endregion] = STATE(799),
    [sym_preproc_line] = STATE(799),
    [sym_preproc_pragma] = STATE(799),
    [sym_preproc_nullable] = STATE(799),
    [sym_preproc_error] = STATE(799),
    [sym_preproc_define] = STATE(799),
    [sym_preproc_undef] = STATE(799),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(2765),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [800] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3738),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5653),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(800),
    [sym_preproc_endregion] = STATE(800),
    [sym_preproc_line] = STATE(800),
    [sym_preproc_pragma] = STATE(800),
    [sym_preproc_nullable] = STATE(800),
    [sym_preproc_error] = STATE(800),
    [sym_preproc_define] = STATE(800),
    [sym_preproc_undef] = STATE(800),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(2765),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [801] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(5607),
    [sym_bracketed_argument_list] = STATE(3921),
    [sym__name] = STATE(6889),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2854),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(6991),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5551),
    [sym_non_lvalue_expression] = STATE(5735),
    [sym_lvalue_expression] = STATE(4295),
    [sym__expression_statement_expression] = STATE(5733),
    [sym_assignment_expression] = STATE(5734),
    [sym_binary_expression] = STATE(5733),
    [sym_postfix_unary_expression] = STATE(5734),
    [sym_prefix_unary_expression] = STATE(5734),
    [sym__pointer_indirection_expression] = STATE(3911),
    [sym_query_expression] = STATE(5733),
    [sym_from_clause] = STATE(7393),
    [sym_conditional_expression] = STATE(5733),
    [sym_conditional_access_expression] = STATE(5733),
    [sym_as_expression] = STATE(5733),
    [sym_is_expression] = STATE(5733),
    [sym_is_pattern_expression] = STATE(5733),
    [sym_cast_expression] = STATE(5733),
    [sym_checked_expression] = STATE(5733),
    [sym_invocation_expression] = STATE(5734),
    [sym_switch_expression] = STATE(5733),
    [sym_await_expression] = STATE(5734),
    [sym_throw_expression] = STATE(5733),
    [sym_element_access_expression] = STATE(3911),
    [sym_interpolated_string_expression] = STATE(5733),
    [sym_member_access_expression] = STATE(3911),
    [sym_object_creation_expression] = STATE(5734),
    [sym_parenthesized_expression] = STATE(5734),
    [sym__parenthesized_lvalue_expression] = STATE(3911),
    [sym_lambda_expression] = STATE(5733),
    [sym__lambda_parameters] = STATE(9313),
    [sym_array_creation_expression] = STATE(5733),
    [sym_anonymous_method_expression] = STATE(5733),
    [sym_anonymous_object_creation_expression] = STATE(5733),
    [sym_implicit_array_creation_expression] = STATE(5733),
    [sym_implicit_object_creation_expression] = STATE(5733),
    [sym_implicit_stackalloc_expression] = STATE(5733),
    [sym_initializer_expression] = STATE(5733),
    [sym_default_expression] = STATE(5733),
    [sym_with_expression] = STATE(5733),
    [sym_sizeof_expression] = STATE(5733),
    [sym_typeof_expression] = STATE(5733),
    [sym_makeref_expression] = STATE(5733),
    [sym_ref_expression] = STATE(5733),
    [sym_reftype_expression] = STATE(5733),
    [sym_refvalue_expression] = STATE(5733),
    [sym_stackalloc_expression] = STATE(5733),
    [sym_range_expression] = STATE(5733),
    [sym_tuple_expression] = STATE(3911),
    [sym_literal] = STATE(5733),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2798),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(5733),
    [sym_preproc_region] = STATE(801),
    [sym_preproc_endregion] = STATE(801),
    [sym_preproc_line] = STATE(801),
    [sym_preproc_pragma] = STATE(801),
    [sym_preproc_nullable] = STATE(801),
    [sym_preproc_error] = STATE(801),
    [sym_preproc_define] = STATE(801),
    [sym_preproc_undef] = STATE(801),
    [aux_sym_class_declaration_repeat1] = STATE(3805),
    [aux_sym_lambda_expression_repeat1] = STATE(4122),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_LPAREN] = ACTIONS(1591),
    [anon_sym_ref] = ACTIONS(1593),
    [anon_sym_LBRACE] = ACTIONS(2773),
    [anon_sym_delegate] = ACTIONS(1379),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1443),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1597),
    [anon_sym_TILDE] = ACTIONS(1597),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1595),
    [anon_sym_DASH] = ACTIONS(1595),
    [anon_sym_STAR] = ACTIONS(1449),
    [anon_sym_CARET] = ACTIONS(1597),
    [anon_sym_AMP] = ACTIONS(1597),
    [anon_sym_this] = ACTIONS(1393),
    [anon_sym_scoped] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1397),
    [sym_predefined_type] = ACTIONS(1399),
    [anon_sym_unchecked] = ACTIONS(1383),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1599),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1601),
    [anon_sym_DOT_DOT] = ACTIONS(1603),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_stackalloc] = ACTIONS(1413),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(1419),
    [anon_sym___reftype] = ACTIONS(1421),
    [anon_sym___refvalue] = ACTIONS(1423),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
  },
  [802] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6961),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6324),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9849),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(802),
    [sym_preproc_endregion] = STATE(802),
    [sym_preproc_line] = STATE(802),
    [sym_preproc_pragma] = STATE(802),
    [sym_preproc_nullable] = STATE(802),
    [sym_preproc_error] = STATE(802),
    [sym_preproc_define] = STATE(802),
    [sym_preproc_undef] = STATE(802),
    [aux_sym_class_declaration_repeat1] = STATE(3841),
    [aux_sym_lambda_expression_repeat1] = STATE(4283),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(2817),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1459),
    [anon_sym_ref] = ACTIONS(1461),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1465),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1467),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1469),
    [anon_sym_DOT_DOT] = ACTIONS(1471),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [803] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4188),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6880),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7104),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5111),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(3863),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7380),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9420),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(803),
    [sym_preproc_endregion] = STATE(803),
    [sym_preproc_line] = STATE(803),
    [sym_preproc_pragma] = STATE(803),
    [sym_preproc_nullable] = STATE(803),
    [sym_preproc_error] = STATE(803),
    [sym_preproc_define] = STATE(803),
    [sym_preproc_undef] = STATE(803),
    [aux_sym_class_declaration_repeat1] = STATE(3820),
    [aux_sym_lambda_expression_repeat1] = STATE(4165),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1339),
    [anon_sym_ref] = ACTIONS(1341),
    [anon_sym_LBRACE] = ACTIONS(2761),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1097),
    [anon_sym_TILDE] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1099),
    [anon_sym_DASH] = ACTIONS(1099),
    [anon_sym_STAR] = ACTIONS(1343),
    [anon_sym_CARET] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1097),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1345),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1347),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [804] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(5573),
    [sym_bracketed_argument_list] = STATE(3921),
    [sym__name] = STATE(6889),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2854),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(6991),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5547),
    [sym_non_lvalue_expression] = STATE(5735),
    [sym_lvalue_expression] = STATE(4295),
    [sym__expression_statement_expression] = STATE(5733),
    [sym_assignment_expression] = STATE(5734),
    [sym_binary_expression] = STATE(5733),
    [sym_postfix_unary_expression] = STATE(5734),
    [sym_prefix_unary_expression] = STATE(5734),
    [sym__pointer_indirection_expression] = STATE(3911),
    [sym_query_expression] = STATE(5733),
    [sym_from_clause] = STATE(7393),
    [sym_conditional_expression] = STATE(5733),
    [sym_conditional_access_expression] = STATE(5733),
    [sym_as_expression] = STATE(5733),
    [sym_is_expression] = STATE(5733),
    [sym_is_pattern_expression] = STATE(5733),
    [sym_cast_expression] = STATE(5733),
    [sym_checked_expression] = STATE(5733),
    [sym_invocation_expression] = STATE(5734),
    [sym_switch_expression] = STATE(5733),
    [sym_await_expression] = STATE(5734),
    [sym_throw_expression] = STATE(5733),
    [sym_element_access_expression] = STATE(3911),
    [sym_interpolated_string_expression] = STATE(5733),
    [sym_member_access_expression] = STATE(3911),
    [sym_object_creation_expression] = STATE(5734),
    [sym_parenthesized_expression] = STATE(5734),
    [sym__parenthesized_lvalue_expression] = STATE(3911),
    [sym_lambda_expression] = STATE(5733),
    [sym__lambda_parameters] = STATE(9313),
    [sym_array_creation_expression] = STATE(5733),
    [sym_anonymous_method_expression] = STATE(5733),
    [sym_anonymous_object_creation_expression] = STATE(5733),
    [sym_implicit_array_creation_expression] = STATE(5733),
    [sym_implicit_object_creation_expression] = STATE(5733),
    [sym_implicit_stackalloc_expression] = STATE(5733),
    [sym_initializer_expression] = STATE(5733),
    [sym_default_expression] = STATE(5733),
    [sym_with_expression] = STATE(5733),
    [sym_sizeof_expression] = STATE(5733),
    [sym_typeof_expression] = STATE(5733),
    [sym_makeref_expression] = STATE(5733),
    [sym_ref_expression] = STATE(5733),
    [sym_reftype_expression] = STATE(5733),
    [sym_refvalue_expression] = STATE(5733),
    [sym_stackalloc_expression] = STATE(5733),
    [sym_range_expression] = STATE(5733),
    [sym_tuple_expression] = STATE(3911),
    [sym_literal] = STATE(5733),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2798),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(5733),
    [sym_preproc_region] = STATE(804),
    [sym_preproc_endregion] = STATE(804),
    [sym_preproc_line] = STATE(804),
    [sym_preproc_pragma] = STATE(804),
    [sym_preproc_nullable] = STATE(804),
    [sym_preproc_error] = STATE(804),
    [sym_preproc_define] = STATE(804),
    [sym_preproc_undef] = STATE(804),
    [aux_sym_class_declaration_repeat1] = STATE(3805),
    [aux_sym_lambda_expression_repeat1] = STATE(4122),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_LPAREN] = ACTIONS(1591),
    [anon_sym_ref] = ACTIONS(1593),
    [anon_sym_LBRACE] = ACTIONS(2773),
    [anon_sym_delegate] = ACTIONS(1379),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1443),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1597),
    [anon_sym_TILDE] = ACTIONS(1597),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1595),
    [anon_sym_DASH] = ACTIONS(1595),
    [anon_sym_STAR] = ACTIONS(1449),
    [anon_sym_CARET] = ACTIONS(1597),
    [anon_sym_AMP] = ACTIONS(1597),
    [anon_sym_this] = ACTIONS(1393),
    [anon_sym_scoped] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1397),
    [sym_predefined_type] = ACTIONS(1399),
    [anon_sym_unchecked] = ACTIONS(1383),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1599),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1601),
    [anon_sym_DOT_DOT] = ACTIONS(1603),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_stackalloc] = ACTIONS(1413),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(1419),
    [anon_sym___reftype] = ACTIONS(1421),
    [anon_sym___refvalue] = ACTIONS(1423),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
  },
  [805] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6030),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(805),
    [sym_preproc_endregion] = STATE(805),
    [sym_preproc_line] = STATE(805),
    [sym_preproc_pragma] = STATE(805),
    [sym_preproc_nullable] = STATE(805),
    [sym_preproc_error] = STATE(805),
    [sym_preproc_define] = STATE(805),
    [sym_preproc_undef] = STATE(805),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_RBRACE] = ACTIONS(2819),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [806] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5916),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(806),
    [sym_preproc_endregion] = STATE(806),
    [sym_preproc_line] = STATE(806),
    [sym_preproc_pragma] = STATE(806),
    [sym_preproc_nullable] = STATE(806),
    [sym_preproc_error] = STATE(806),
    [sym_preproc_define] = STATE(806),
    [sym_preproc_undef] = STATE(806),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_RPAREN] = ACTIONS(2821),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [807] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(5513),
    [sym_bracketed_argument_list] = STATE(3921),
    [sym__name] = STATE(6889),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2854),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(6991),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5541),
    [sym_non_lvalue_expression] = STATE(5735),
    [sym_lvalue_expression] = STATE(4295),
    [sym__expression_statement_expression] = STATE(5733),
    [sym_assignment_expression] = STATE(5734),
    [sym_binary_expression] = STATE(5733),
    [sym_postfix_unary_expression] = STATE(5734),
    [sym_prefix_unary_expression] = STATE(5734),
    [sym__pointer_indirection_expression] = STATE(3911),
    [sym_query_expression] = STATE(5733),
    [sym_from_clause] = STATE(7393),
    [sym_conditional_expression] = STATE(5733),
    [sym_conditional_access_expression] = STATE(5733),
    [sym_as_expression] = STATE(5733),
    [sym_is_expression] = STATE(5733),
    [sym_is_pattern_expression] = STATE(5733),
    [sym_cast_expression] = STATE(5733),
    [sym_checked_expression] = STATE(5733),
    [sym_invocation_expression] = STATE(5734),
    [sym_switch_expression] = STATE(5733),
    [sym_await_expression] = STATE(5734),
    [sym_throw_expression] = STATE(5733),
    [sym_element_access_expression] = STATE(3911),
    [sym_interpolated_string_expression] = STATE(5733),
    [sym_member_access_expression] = STATE(3911),
    [sym_object_creation_expression] = STATE(5734),
    [sym_parenthesized_expression] = STATE(5734),
    [sym__parenthesized_lvalue_expression] = STATE(3911),
    [sym_lambda_expression] = STATE(5733),
    [sym__lambda_parameters] = STATE(9313),
    [sym_array_creation_expression] = STATE(5733),
    [sym_anonymous_method_expression] = STATE(5733),
    [sym_anonymous_object_creation_expression] = STATE(5733),
    [sym_implicit_array_creation_expression] = STATE(5733),
    [sym_implicit_object_creation_expression] = STATE(5733),
    [sym_implicit_stackalloc_expression] = STATE(5733),
    [sym_initializer_expression] = STATE(5733),
    [sym_default_expression] = STATE(5733),
    [sym_with_expression] = STATE(5733),
    [sym_sizeof_expression] = STATE(5733),
    [sym_typeof_expression] = STATE(5733),
    [sym_makeref_expression] = STATE(5733),
    [sym_ref_expression] = STATE(5733),
    [sym_reftype_expression] = STATE(5733),
    [sym_refvalue_expression] = STATE(5733),
    [sym_stackalloc_expression] = STATE(5733),
    [sym_range_expression] = STATE(5733),
    [sym_tuple_expression] = STATE(3911),
    [sym_literal] = STATE(5733),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2798),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(5733),
    [sym_preproc_region] = STATE(807),
    [sym_preproc_endregion] = STATE(807),
    [sym_preproc_line] = STATE(807),
    [sym_preproc_pragma] = STATE(807),
    [sym_preproc_nullable] = STATE(807),
    [sym_preproc_error] = STATE(807),
    [sym_preproc_define] = STATE(807),
    [sym_preproc_undef] = STATE(807),
    [aux_sym_class_declaration_repeat1] = STATE(3805),
    [aux_sym_lambda_expression_repeat1] = STATE(4122),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_LPAREN] = ACTIONS(1591),
    [anon_sym_ref] = ACTIONS(1593),
    [anon_sym_LBRACE] = ACTIONS(2773),
    [anon_sym_delegate] = ACTIONS(1379),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1443),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1597),
    [anon_sym_TILDE] = ACTIONS(1597),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1595),
    [anon_sym_DASH] = ACTIONS(1595),
    [anon_sym_STAR] = ACTIONS(1449),
    [anon_sym_CARET] = ACTIONS(1597),
    [anon_sym_AMP] = ACTIONS(1597),
    [anon_sym_this] = ACTIONS(1393),
    [anon_sym_scoped] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1397),
    [sym_predefined_type] = ACTIONS(1399),
    [anon_sym_unchecked] = ACTIONS(1383),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1599),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1601),
    [anon_sym_DOT_DOT] = ACTIONS(1603),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_stackalloc] = ACTIONS(1413),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(1419),
    [anon_sym___reftype] = ACTIONS(1421),
    [anon_sym___refvalue] = ACTIONS(1423),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
  },
  [808] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5805),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(808),
    [sym_preproc_endregion] = STATE(808),
    [sym_preproc_line] = STATE(808),
    [sym_preproc_pragma] = STATE(808),
    [sym_preproc_nullable] = STATE(808),
    [sym_preproc_error] = STATE(808),
    [sym_preproc_define] = STATE(808),
    [sym_preproc_undef] = STATE(808),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_RPAREN] = ACTIONS(2823),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [809] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4151),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6880),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7104),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5112),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(3863),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7380),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9420),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(809),
    [sym_preproc_endregion] = STATE(809),
    [sym_preproc_line] = STATE(809),
    [sym_preproc_pragma] = STATE(809),
    [sym_preproc_nullable] = STATE(809),
    [sym_preproc_error] = STATE(809),
    [sym_preproc_define] = STATE(809),
    [sym_preproc_undef] = STATE(809),
    [aux_sym_class_declaration_repeat1] = STATE(3820),
    [aux_sym_lambda_expression_repeat1] = STATE(4165),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1339),
    [anon_sym_ref] = ACTIONS(1341),
    [anon_sym_LBRACE] = ACTIONS(2761),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1097),
    [anon_sym_TILDE] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1099),
    [anon_sym_DASH] = ACTIONS(1099),
    [anon_sym_STAR] = ACTIONS(1343),
    [anon_sym_CARET] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1097),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1345),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1347),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [810] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6961),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6404),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9849),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(810),
    [sym_preproc_endregion] = STATE(810),
    [sym_preproc_line] = STATE(810),
    [sym_preproc_pragma] = STATE(810),
    [sym_preproc_nullable] = STATE(810),
    [sym_preproc_error] = STATE(810),
    [sym_preproc_define] = STATE(810),
    [sym_preproc_undef] = STATE(810),
    [aux_sym_class_declaration_repeat1] = STATE(3841),
    [aux_sym_lambda_expression_repeat1] = STATE(4283),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(2825),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1459),
    [anon_sym_ref] = ACTIONS(1461),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1465),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1467),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1469),
    [anon_sym_DOT_DOT] = ACTIONS(1471),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [811] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3717),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5693),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(811),
    [sym_preproc_endregion] = STATE(811),
    [sym_preproc_line] = STATE(811),
    [sym_preproc_pragma] = STATE(811),
    [sym_preproc_nullable] = STATE(811),
    [sym_preproc_error] = STATE(811),
    [sym_preproc_define] = STATE(811),
    [sym_preproc_undef] = STATE(811),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(2765),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [812] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4116),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6880),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7104),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5117),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(3863),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7380),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9420),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(812),
    [sym_preproc_endregion] = STATE(812),
    [sym_preproc_line] = STATE(812),
    [sym_preproc_pragma] = STATE(812),
    [sym_preproc_nullable] = STATE(812),
    [sym_preproc_error] = STATE(812),
    [sym_preproc_define] = STATE(812),
    [sym_preproc_undef] = STATE(812),
    [aux_sym_class_declaration_repeat1] = STATE(3820),
    [aux_sym_lambda_expression_repeat1] = STATE(4165),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1339),
    [anon_sym_ref] = ACTIONS(1341),
    [anon_sym_LBRACE] = ACTIONS(2761),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1097),
    [anon_sym_TILDE] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1099),
    [anon_sym_DASH] = ACTIONS(1099),
    [anon_sym_STAR] = ACTIONS(1343),
    [anon_sym_CARET] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1097),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1345),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1347),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [813] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6908),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2874),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7092),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5606),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4189),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7388),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9466),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(813),
    [sym_preproc_endregion] = STATE(813),
    [sym_preproc_line] = STATE(813),
    [sym_preproc_pragma] = STATE(813),
    [sym_preproc_nullable] = STATE(813),
    [sym_preproc_error] = STATE(813),
    [sym_preproc_define] = STATE(813),
    [sym_preproc_undef] = STATE(813),
    [aux_sym_class_declaration_repeat1] = STATE(3825),
    [aux_sym_lambda_expression_repeat1] = STATE(4178),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1743),
    [anon_sym_ref] = ACTIONS(1745),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1505),
    [anon_sym_readonly] = ACTIONS(2693),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1749),
    [anon_sym_TILDE] = ACTIONS(1749),
    [anon_sym_PLUS_PLUS] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1749),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1747),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_CARET] = ACTIONS(1749),
    [anon_sym_AMP] = ACTIONS(1749),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1753),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1755),
    [anon_sym_DOT_DOT] = ACTIONS(1757),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [814] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6961),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6293),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9849),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(814),
    [sym_preproc_endregion] = STATE(814),
    [sym_preproc_line] = STATE(814),
    [sym_preproc_pragma] = STATE(814),
    [sym_preproc_nullable] = STATE(814),
    [sym_preproc_error] = STATE(814),
    [sym_preproc_define] = STATE(814),
    [sym_preproc_undef] = STATE(814),
    [aux_sym_class_declaration_repeat1] = STATE(3841),
    [aux_sym_lambda_expression_repeat1] = STATE(4283),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(2827),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1459),
    [anon_sym_ref] = ACTIONS(1461),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1465),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1467),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1469),
    [anon_sym_DOT_DOT] = ACTIONS(1471),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [815] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(5508),
    [sym_bracketed_argument_list] = STATE(3921),
    [sym__name] = STATE(6889),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2854),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(6991),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5540),
    [sym_non_lvalue_expression] = STATE(5735),
    [sym_lvalue_expression] = STATE(4295),
    [sym__expression_statement_expression] = STATE(5733),
    [sym_assignment_expression] = STATE(5734),
    [sym_binary_expression] = STATE(5733),
    [sym_postfix_unary_expression] = STATE(5734),
    [sym_prefix_unary_expression] = STATE(5734),
    [sym__pointer_indirection_expression] = STATE(3911),
    [sym_query_expression] = STATE(5733),
    [sym_from_clause] = STATE(7393),
    [sym_conditional_expression] = STATE(5733),
    [sym_conditional_access_expression] = STATE(5733),
    [sym_as_expression] = STATE(5733),
    [sym_is_expression] = STATE(5733),
    [sym_is_pattern_expression] = STATE(5733),
    [sym_cast_expression] = STATE(5733),
    [sym_checked_expression] = STATE(5733),
    [sym_invocation_expression] = STATE(5734),
    [sym_switch_expression] = STATE(5733),
    [sym_await_expression] = STATE(5734),
    [sym_throw_expression] = STATE(5733),
    [sym_element_access_expression] = STATE(3911),
    [sym_interpolated_string_expression] = STATE(5733),
    [sym_member_access_expression] = STATE(3911),
    [sym_object_creation_expression] = STATE(5734),
    [sym_parenthesized_expression] = STATE(5734),
    [sym__parenthesized_lvalue_expression] = STATE(3911),
    [sym_lambda_expression] = STATE(5733),
    [sym__lambda_parameters] = STATE(9313),
    [sym_array_creation_expression] = STATE(5733),
    [sym_anonymous_method_expression] = STATE(5733),
    [sym_anonymous_object_creation_expression] = STATE(5733),
    [sym_implicit_array_creation_expression] = STATE(5733),
    [sym_implicit_object_creation_expression] = STATE(5733),
    [sym_implicit_stackalloc_expression] = STATE(5733),
    [sym_initializer_expression] = STATE(5733),
    [sym_default_expression] = STATE(5733),
    [sym_with_expression] = STATE(5733),
    [sym_sizeof_expression] = STATE(5733),
    [sym_typeof_expression] = STATE(5733),
    [sym_makeref_expression] = STATE(5733),
    [sym_ref_expression] = STATE(5733),
    [sym_reftype_expression] = STATE(5733),
    [sym_refvalue_expression] = STATE(5733),
    [sym_stackalloc_expression] = STATE(5733),
    [sym_range_expression] = STATE(5733),
    [sym_tuple_expression] = STATE(3911),
    [sym_literal] = STATE(5733),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2798),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(5733),
    [sym_preproc_region] = STATE(815),
    [sym_preproc_endregion] = STATE(815),
    [sym_preproc_line] = STATE(815),
    [sym_preproc_pragma] = STATE(815),
    [sym_preproc_nullable] = STATE(815),
    [sym_preproc_error] = STATE(815),
    [sym_preproc_define] = STATE(815),
    [sym_preproc_undef] = STATE(815),
    [aux_sym_class_declaration_repeat1] = STATE(3805),
    [aux_sym_lambda_expression_repeat1] = STATE(4122),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_LPAREN] = ACTIONS(1591),
    [anon_sym_ref] = ACTIONS(1593),
    [anon_sym_LBRACE] = ACTIONS(2773),
    [anon_sym_delegate] = ACTIONS(1379),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1443),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1597),
    [anon_sym_TILDE] = ACTIONS(1597),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1595),
    [anon_sym_DASH] = ACTIONS(1595),
    [anon_sym_STAR] = ACTIONS(1449),
    [anon_sym_CARET] = ACTIONS(1597),
    [anon_sym_AMP] = ACTIONS(1597),
    [anon_sym_this] = ACTIONS(1393),
    [anon_sym_scoped] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1397),
    [sym_predefined_type] = ACTIONS(1399),
    [anon_sym_unchecked] = ACTIONS(1383),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1599),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1601),
    [anon_sym_DOT_DOT] = ACTIONS(1603),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_stackalloc] = ACTIONS(1413),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(1419),
    [anon_sym___reftype] = ACTIONS(1421),
    [anon_sym___refvalue] = ACTIONS(1423),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
  },
  [816] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4066),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6880),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7104),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5143),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(3863),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7380),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9420),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(816),
    [sym_preproc_endregion] = STATE(816),
    [sym_preproc_line] = STATE(816),
    [sym_preproc_pragma] = STATE(816),
    [sym_preproc_nullable] = STATE(816),
    [sym_preproc_error] = STATE(816),
    [sym_preproc_define] = STATE(816),
    [sym_preproc_undef] = STATE(816),
    [aux_sym_class_declaration_repeat1] = STATE(3820),
    [aux_sym_lambda_expression_repeat1] = STATE(4165),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1339),
    [anon_sym_ref] = ACTIONS(1341),
    [anon_sym_LBRACE] = ACTIONS(2761),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1097),
    [anon_sym_TILDE] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1099),
    [anon_sym_DASH] = ACTIONS(1099),
    [anon_sym_STAR] = ACTIONS(1343),
    [anon_sym_CARET] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1097),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1345),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1347),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [817] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6961),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6390),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9849),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(817),
    [sym_preproc_endregion] = STATE(817),
    [sym_preproc_line] = STATE(817),
    [sym_preproc_pragma] = STATE(817),
    [sym_preproc_nullable] = STATE(817),
    [sym_preproc_error] = STATE(817),
    [sym_preproc_define] = STATE(817),
    [sym_preproc_undef] = STATE(817),
    [aux_sym_class_declaration_repeat1] = STATE(3841),
    [aux_sym_lambda_expression_repeat1] = STATE(4283),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(2829),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1459),
    [anon_sym_ref] = ACTIONS(1461),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1465),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1467),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1469),
    [anon_sym_DOT_DOT] = ACTIONS(1471),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [818] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6961),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6641),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9849),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(818),
    [sym_preproc_endregion] = STATE(818),
    [sym_preproc_line] = STATE(818),
    [sym_preproc_pragma] = STATE(818),
    [sym_preproc_nullable] = STATE(818),
    [sym_preproc_error] = STATE(818),
    [sym_preproc_define] = STATE(818),
    [sym_preproc_undef] = STATE(818),
    [aux_sym_class_declaration_repeat1] = STATE(3841),
    [aux_sym_lambda_expression_repeat1] = STATE(4283),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(2831),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1459),
    [anon_sym_ref] = ACTIONS(1461),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1465),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1467),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1469),
    [anon_sym_DOT_DOT] = ACTIONS(1471),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [819] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3769),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5703),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(819),
    [sym_preproc_endregion] = STATE(819),
    [sym_preproc_line] = STATE(819),
    [sym_preproc_pragma] = STATE(819),
    [sym_preproc_nullable] = STATE(819),
    [sym_preproc_error] = STATE(819),
    [sym_preproc_define] = STATE(819),
    [sym_preproc_undef] = STATE(819),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(2765),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [820] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6669),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2779),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6405),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6513),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4482),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9438),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(820),
    [sym_preproc_endregion] = STATE(820),
    [sym_preproc_line] = STATE(820),
    [sym_preproc_pragma] = STATE(820),
    [sym_preproc_nullable] = STATE(820),
    [sym_preproc_error] = STATE(820),
    [sym_preproc_define] = STATE(820),
    [sym_preproc_undef] = STATE(820),
    [aux_sym_class_declaration_repeat1] = STATE(3801),
    [aux_sym_lambda_expression_repeat1] = STATE(4134),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1993),
    [anon_sym_ref] = ACTIONS(1959),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_readonly] = ACTIONS(2683),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1999),
    [anon_sym_TILDE] = ACTIONS(1999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1999),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_AMP] = ACTIONS(1999),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1065),
    [anon_sym_var] = ACTIONS(2565),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1281),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1283),
    [anon_sym_DOT_DOT] = ACTIONS(1285),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [821] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3751),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6987),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6550),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4462),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7405),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9130),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(821),
    [sym_preproc_endregion] = STATE(821),
    [sym_preproc_line] = STATE(821),
    [sym_preproc_pragma] = STATE(821),
    [sym_preproc_nullable] = STATE(821),
    [sym_preproc_error] = STATE(821),
    [sym_preproc_define] = STATE(821),
    [sym_preproc_undef] = STATE(821),
    [aux_sym_class_declaration_repeat1] = STATE(3855),
    [aux_sym_lambda_expression_repeat1] = STATE(4244),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2031),
    [anon_sym_ref] = ACTIONS(2033),
    [anon_sym_LBRACE] = ACTIONS(2765),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2037),
    [anon_sym_TILDE] = ACTIONS(2037),
    [anon_sym_PLUS_PLUS] = ACTIONS(2037),
    [anon_sym_DASH_DASH] = ACTIONS(2037),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2035),
    [anon_sym_DASH] = ACTIONS(2035),
    [anon_sym_STAR] = ACTIONS(2039),
    [anon_sym_CARET] = ACTIONS(2037),
    [anon_sym_AMP] = ACTIONS(2037),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2041),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2043),
    [anon_sym_DOT_DOT] = ACTIONS(2045),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [822] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3767),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6987),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6551),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4462),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7405),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9130),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(822),
    [sym_preproc_endregion] = STATE(822),
    [sym_preproc_line] = STATE(822),
    [sym_preproc_pragma] = STATE(822),
    [sym_preproc_nullable] = STATE(822),
    [sym_preproc_error] = STATE(822),
    [sym_preproc_define] = STATE(822),
    [sym_preproc_undef] = STATE(822),
    [aux_sym_class_declaration_repeat1] = STATE(3855),
    [aux_sym_lambda_expression_repeat1] = STATE(4244),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2031),
    [anon_sym_ref] = ACTIONS(2033),
    [anon_sym_LBRACE] = ACTIONS(2765),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2037),
    [anon_sym_TILDE] = ACTIONS(2037),
    [anon_sym_PLUS_PLUS] = ACTIONS(2037),
    [anon_sym_DASH_DASH] = ACTIONS(2037),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2035),
    [anon_sym_DASH] = ACTIONS(2035),
    [anon_sym_STAR] = ACTIONS(2039),
    [anon_sym_CARET] = ACTIONS(2037),
    [anon_sym_AMP] = ACTIONS(2037),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2041),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2043),
    [anon_sym_DOT_DOT] = ACTIONS(2045),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [823] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3738),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6987),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6552),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4462),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7405),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9130),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(823),
    [sym_preproc_endregion] = STATE(823),
    [sym_preproc_line] = STATE(823),
    [sym_preproc_pragma] = STATE(823),
    [sym_preproc_nullable] = STATE(823),
    [sym_preproc_error] = STATE(823),
    [sym_preproc_define] = STATE(823),
    [sym_preproc_undef] = STATE(823),
    [aux_sym_class_declaration_repeat1] = STATE(3855),
    [aux_sym_lambda_expression_repeat1] = STATE(4244),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2031),
    [anon_sym_ref] = ACTIONS(2033),
    [anon_sym_LBRACE] = ACTIONS(2765),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2037),
    [anon_sym_TILDE] = ACTIONS(2037),
    [anon_sym_PLUS_PLUS] = ACTIONS(2037),
    [anon_sym_DASH_DASH] = ACTIONS(2037),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2035),
    [anon_sym_DASH] = ACTIONS(2035),
    [anon_sym_STAR] = ACTIONS(2039),
    [anon_sym_CARET] = ACTIONS(2037),
    [anon_sym_AMP] = ACTIONS(2037),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2041),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2043),
    [anon_sym_DOT_DOT] = ACTIONS(2045),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [824] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4085),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6880),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7104),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5138),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(3863),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7380),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9420),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(824),
    [sym_preproc_endregion] = STATE(824),
    [sym_preproc_line] = STATE(824),
    [sym_preproc_pragma] = STATE(824),
    [sym_preproc_nullable] = STATE(824),
    [sym_preproc_error] = STATE(824),
    [sym_preproc_define] = STATE(824),
    [sym_preproc_undef] = STATE(824),
    [aux_sym_class_declaration_repeat1] = STATE(3820),
    [aux_sym_lambda_expression_repeat1] = STATE(4165),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1339),
    [anon_sym_ref] = ACTIONS(1341),
    [anon_sym_LBRACE] = ACTIONS(2761),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1097),
    [anon_sym_TILDE] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1099),
    [anon_sym_DASH] = ACTIONS(1099),
    [anon_sym_STAR] = ACTIONS(1343),
    [anon_sym_CARET] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1097),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1345),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1347),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [825] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4132),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6880),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7104),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5147),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(3863),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7380),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9420),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(825),
    [sym_preproc_endregion] = STATE(825),
    [sym_preproc_line] = STATE(825),
    [sym_preproc_pragma] = STATE(825),
    [sym_preproc_nullable] = STATE(825),
    [sym_preproc_error] = STATE(825),
    [sym_preproc_define] = STATE(825),
    [sym_preproc_undef] = STATE(825),
    [aux_sym_class_declaration_repeat1] = STATE(3820),
    [aux_sym_lambda_expression_repeat1] = STATE(4165),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1339),
    [anon_sym_ref] = ACTIONS(1341),
    [anon_sym_LBRACE] = ACTIONS(2761),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1097),
    [anon_sym_TILDE] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1099),
    [anon_sym_DASH] = ACTIONS(1099),
    [anon_sym_STAR] = ACTIONS(1343),
    [anon_sym_CARET] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1097),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1345),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1347),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [826] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3977),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6911),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6992),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5046),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(3829),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7391),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9246),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(826),
    [sym_preproc_endregion] = STATE(826),
    [sym_preproc_line] = STATE(826),
    [sym_preproc_pragma] = STATE(826),
    [sym_preproc_nullable] = STATE(826),
    [sym_preproc_error] = STATE(826),
    [sym_preproc_define] = STATE(826),
    [sym_preproc_undef] = STATE(826),
    [aux_sym_class_declaration_repeat1] = STATE(3800),
    [aux_sym_lambda_expression_repeat1] = STATE(4089),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1323),
    [anon_sym_ref] = ACTIONS(1325),
    [anon_sym_LBRACE] = ACTIONS(2833),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1145),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1329),
    [anon_sym_TILDE] = ACTIONS(1329),
    [anon_sym_PLUS_PLUS] = ACTIONS(1329),
    [anon_sym_DASH_DASH] = ACTIONS(1329),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1327),
    [anon_sym_DASH] = ACTIONS(1327),
    [anon_sym_STAR] = ACTIONS(1331),
    [anon_sym_CARET] = ACTIONS(1329),
    [anon_sym_AMP] = ACTIONS(1329),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1333),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1335),
    [anon_sym_DOT_DOT] = ACTIONS(1337),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [827] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7098),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6004),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4313),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7382),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9733),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(827),
    [sym_preproc_endregion] = STATE(827),
    [sym_preproc_line] = STATE(827),
    [sym_preproc_pragma] = STATE(827),
    [sym_preproc_nullable] = STATE(827),
    [sym_preproc_error] = STATE(827),
    [sym_preproc_define] = STATE(827),
    [sym_preproc_undef] = STATE(827),
    [aux_sym_class_declaration_repeat1] = STATE(3802),
    [aux_sym_lambda_expression_repeat1] = STATE(4108),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1519),
    [anon_sym_ref] = ACTIONS(1521),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1523),
    [anon_sym_readonly] = ACTIONS(2693),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1529),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1531),
    [anon_sym_DOT_DOT] = ACTIONS(1533),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [828] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4007),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6888),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2882),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7048),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5287),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4019),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7409),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9210),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(828),
    [sym_preproc_endregion] = STATE(828),
    [sym_preproc_line] = STATE(828),
    [sym_preproc_pragma] = STATE(828),
    [sym_preproc_nullable] = STATE(828),
    [sym_preproc_error] = STATE(828),
    [sym_preproc_define] = STATE(828),
    [sym_preproc_undef] = STATE(828),
    [aux_sym_class_declaration_repeat1] = STATE(3812),
    [aux_sym_lambda_expression_repeat1] = STATE(4146),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1709),
    [anon_sym_ref] = ACTIONS(1711),
    [anon_sym_LBRACE] = ACTIONS(2833),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1713),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1717),
    [anon_sym_TILDE] = ACTIONS(1717),
    [anon_sym_PLUS_PLUS] = ACTIONS(1717),
    [anon_sym_DASH_DASH] = ACTIONS(1717),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1715),
    [anon_sym_DASH] = ACTIONS(1715),
    [anon_sym_STAR] = ACTIONS(1719),
    [anon_sym_CARET] = ACTIONS(1717),
    [anon_sym_AMP] = ACTIONS(1717),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1721),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1723),
    [anon_sym_DOT_DOT] = ACTIONS(1725),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [829] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4065),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6888),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2882),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7048),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5288),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4019),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7409),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9210),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(829),
    [sym_preproc_endregion] = STATE(829),
    [sym_preproc_line] = STATE(829),
    [sym_preproc_pragma] = STATE(829),
    [sym_preproc_nullable] = STATE(829),
    [sym_preproc_error] = STATE(829),
    [sym_preproc_define] = STATE(829),
    [sym_preproc_undef] = STATE(829),
    [aux_sym_class_declaration_repeat1] = STATE(3812),
    [aux_sym_lambda_expression_repeat1] = STATE(4146),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1709),
    [anon_sym_ref] = ACTIONS(1711),
    [anon_sym_LBRACE] = ACTIONS(2833),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1713),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1717),
    [anon_sym_TILDE] = ACTIONS(1717),
    [anon_sym_PLUS_PLUS] = ACTIONS(1717),
    [anon_sym_DASH_DASH] = ACTIONS(1717),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1715),
    [anon_sym_DASH] = ACTIONS(1715),
    [anon_sym_STAR] = ACTIONS(1719),
    [anon_sym_CARET] = ACTIONS(1717),
    [anon_sym_AMP] = ACTIONS(1717),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1721),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1723),
    [anon_sym_DOT_DOT] = ACTIONS(1725),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [830] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3717),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6987),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6555),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4462),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7405),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9130),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(830),
    [sym_preproc_endregion] = STATE(830),
    [sym_preproc_line] = STATE(830),
    [sym_preproc_pragma] = STATE(830),
    [sym_preproc_nullable] = STATE(830),
    [sym_preproc_error] = STATE(830),
    [sym_preproc_define] = STATE(830),
    [sym_preproc_undef] = STATE(830),
    [aux_sym_class_declaration_repeat1] = STATE(3855),
    [aux_sym_lambda_expression_repeat1] = STATE(4244),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2031),
    [anon_sym_ref] = ACTIONS(2033),
    [anon_sym_LBRACE] = ACTIONS(2765),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2037),
    [anon_sym_TILDE] = ACTIONS(2037),
    [anon_sym_PLUS_PLUS] = ACTIONS(2037),
    [anon_sym_DASH_DASH] = ACTIONS(2037),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2035),
    [anon_sym_DASH] = ACTIONS(2035),
    [anon_sym_STAR] = ACTIONS(2039),
    [anon_sym_CARET] = ACTIONS(2037),
    [anon_sym_AMP] = ACTIONS(2037),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2041),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2043),
    [anon_sym_DOT_DOT] = ACTIONS(2045),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [831] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3934),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6911),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6992),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5045),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(3829),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7391),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9246),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(831),
    [sym_preproc_endregion] = STATE(831),
    [sym_preproc_line] = STATE(831),
    [sym_preproc_pragma] = STATE(831),
    [sym_preproc_nullable] = STATE(831),
    [sym_preproc_error] = STATE(831),
    [sym_preproc_define] = STATE(831),
    [sym_preproc_undef] = STATE(831),
    [aux_sym_class_declaration_repeat1] = STATE(3800),
    [aux_sym_lambda_expression_repeat1] = STATE(4089),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1323),
    [anon_sym_ref] = ACTIONS(1325),
    [anon_sym_LBRACE] = ACTIONS(2833),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1145),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1329),
    [anon_sym_TILDE] = ACTIONS(1329),
    [anon_sym_PLUS_PLUS] = ACTIONS(1329),
    [anon_sym_DASH_DASH] = ACTIONS(1329),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1327),
    [anon_sym_DASH] = ACTIONS(1327),
    [anon_sym_STAR] = ACTIONS(1331),
    [anon_sym_CARET] = ACTIONS(1329),
    [anon_sym_AMP] = ACTIONS(1329),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1333),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1335),
    [anon_sym_DOT_DOT] = ACTIONS(1337),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [832] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3921),
    [sym__name] = STATE(6919),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2868),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(6951),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5235),
    [sym_non_lvalue_expression] = STATE(5735),
    [sym_lvalue_expression] = STATE(4054),
    [sym__expression_statement_expression] = STATE(5733),
    [sym_assignment_expression] = STATE(5734),
    [sym_binary_expression] = STATE(5733),
    [sym_postfix_unary_expression] = STATE(5734),
    [sym_prefix_unary_expression] = STATE(5734),
    [sym__pointer_indirection_expression] = STATE(3911),
    [sym_query_expression] = STATE(5733),
    [sym_from_clause] = STATE(7400),
    [sym_conditional_expression] = STATE(5733),
    [sym_conditional_access_expression] = STATE(5733),
    [sym_as_expression] = STATE(5733),
    [sym_is_expression] = STATE(5733),
    [sym_is_pattern_expression] = STATE(5733),
    [sym_cast_expression] = STATE(5733),
    [sym_checked_expression] = STATE(5733),
    [sym_invocation_expression] = STATE(5734),
    [sym_switch_expression] = STATE(5733),
    [sym_await_expression] = STATE(5734),
    [sym_throw_expression] = STATE(5733),
    [sym_element_access_expression] = STATE(3911),
    [sym_interpolated_string_expression] = STATE(5733),
    [sym_member_access_expression] = STATE(3911),
    [sym_object_creation_expression] = STATE(5734),
    [sym_parenthesized_expression] = STATE(5734),
    [sym__parenthesized_lvalue_expression] = STATE(3911),
    [sym_lambda_expression] = STATE(5733),
    [sym__lambda_parameters] = STATE(9693),
    [sym_array_creation_expression] = STATE(5733),
    [sym_anonymous_method_expression] = STATE(5733),
    [sym_anonymous_object_creation_expression] = STATE(5733),
    [sym_implicit_array_creation_expression] = STATE(5733),
    [sym_implicit_object_creation_expression] = STATE(5733),
    [sym_implicit_stackalloc_expression] = STATE(5733),
    [sym_initializer_expression] = STATE(5733),
    [sym_default_expression] = STATE(5733),
    [sym_with_expression] = STATE(5733),
    [sym_sizeof_expression] = STATE(5733),
    [sym_typeof_expression] = STATE(5733),
    [sym_makeref_expression] = STATE(5733),
    [sym_ref_expression] = STATE(5733),
    [sym_reftype_expression] = STATE(5733),
    [sym_refvalue_expression] = STATE(5733),
    [sym_stackalloc_expression] = STATE(5733),
    [sym_range_expression] = STATE(5733),
    [sym_tuple_expression] = STATE(3911),
    [sym_literal] = STATE(5733),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2798),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(5733),
    [sym_preproc_region] = STATE(832),
    [sym_preproc_endregion] = STATE(832),
    [sym_preproc_line] = STATE(832),
    [sym_preproc_pragma] = STATE(832),
    [sym_preproc_nullable] = STATE(832),
    [sym_preproc_error] = STATE(832),
    [sym_preproc_define] = STATE(832),
    [sym_preproc_undef] = STATE(832),
    [aux_sym_class_declaration_repeat1] = STATE(3791),
    [aux_sym_lambda_expression_repeat1] = STATE(4075),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_LPAREN] = ACTIONS(1373),
    [anon_sym_ref] = ACTIONS(1375),
    [anon_sym_LBRACE] = ACTIONS(1377),
    [anon_sym_delegate] = ACTIONS(1379),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1381),
    [anon_sym_readonly] = ACTIONS(2693),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1387),
    [anon_sym_TILDE] = ACTIONS(1387),
    [anon_sym_PLUS_PLUS] = ACTIONS(1387),
    [anon_sym_DASH_DASH] = ACTIONS(1387),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1385),
    [anon_sym_DASH] = ACTIONS(1385),
    [anon_sym_STAR] = ACTIONS(1391),
    [anon_sym_CARET] = ACTIONS(1387),
    [anon_sym_AMP] = ACTIONS(1387),
    [anon_sym_this] = ACTIONS(1393),
    [anon_sym_scoped] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1397),
    [sym_predefined_type] = ACTIONS(1399),
    [anon_sym_unchecked] = ACTIONS(1383),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1403),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1405),
    [anon_sym_DOT_DOT] = ACTIONS(1407),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_stackalloc] = ACTIONS(1413),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(1419),
    [anon_sym___reftype] = ACTIONS(1421),
    [anon_sym___refvalue] = ACTIONS(1423),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
  },
  [833] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3769),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6987),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6557),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4462),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7405),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9130),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(833),
    [sym_preproc_endregion] = STATE(833),
    [sym_preproc_line] = STATE(833),
    [sym_preproc_pragma] = STATE(833),
    [sym_preproc_nullable] = STATE(833),
    [sym_preproc_error] = STATE(833),
    [sym_preproc_define] = STATE(833),
    [sym_preproc_undef] = STATE(833),
    [aux_sym_class_declaration_repeat1] = STATE(3855),
    [aux_sym_lambda_expression_repeat1] = STATE(4244),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2031),
    [anon_sym_ref] = ACTIONS(2033),
    [anon_sym_LBRACE] = ACTIONS(2765),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2037),
    [anon_sym_TILDE] = ACTIONS(2037),
    [anon_sym_PLUS_PLUS] = ACTIONS(2037),
    [anon_sym_DASH_DASH] = ACTIONS(2037),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2035),
    [anon_sym_DASH] = ACTIONS(2035),
    [anon_sym_STAR] = ACTIONS(2039),
    [anon_sym_CARET] = ACTIONS(2037),
    [anon_sym_AMP] = ACTIONS(2037),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2041),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2043),
    [anon_sym_DOT_DOT] = ACTIONS(2045),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [834] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4050),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6888),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2882),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7048),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5289),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4019),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7409),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9210),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(834),
    [sym_preproc_endregion] = STATE(834),
    [sym_preproc_line] = STATE(834),
    [sym_preproc_pragma] = STATE(834),
    [sym_preproc_nullable] = STATE(834),
    [sym_preproc_error] = STATE(834),
    [sym_preproc_define] = STATE(834),
    [sym_preproc_undef] = STATE(834),
    [aux_sym_class_declaration_repeat1] = STATE(3812),
    [aux_sym_lambda_expression_repeat1] = STATE(4146),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1709),
    [anon_sym_ref] = ACTIONS(1711),
    [anon_sym_LBRACE] = ACTIONS(2833),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1713),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1717),
    [anon_sym_TILDE] = ACTIONS(1717),
    [anon_sym_PLUS_PLUS] = ACTIONS(1717),
    [anon_sym_DASH_DASH] = ACTIONS(1717),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1715),
    [anon_sym_DASH] = ACTIONS(1715),
    [anon_sym_STAR] = ACTIONS(1719),
    [anon_sym_CARET] = ACTIONS(1717),
    [anon_sym_AMP] = ACTIONS(1717),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1721),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1723),
    [anon_sym_DOT_DOT] = ACTIONS(1725),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [835] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3726),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6987),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6559),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4462),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7405),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9130),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(835),
    [sym_preproc_endregion] = STATE(835),
    [sym_preproc_line] = STATE(835),
    [sym_preproc_pragma] = STATE(835),
    [sym_preproc_nullable] = STATE(835),
    [sym_preproc_error] = STATE(835),
    [sym_preproc_define] = STATE(835),
    [sym_preproc_undef] = STATE(835),
    [aux_sym_class_declaration_repeat1] = STATE(3855),
    [aux_sym_lambda_expression_repeat1] = STATE(4244),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2031),
    [anon_sym_ref] = ACTIONS(2033),
    [anon_sym_LBRACE] = ACTIONS(2765),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2037),
    [anon_sym_TILDE] = ACTIONS(2037),
    [anon_sym_PLUS_PLUS] = ACTIONS(2037),
    [anon_sym_DASH_DASH] = ACTIONS(2037),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2035),
    [anon_sym_DASH] = ACTIONS(2035),
    [anon_sym_STAR] = ACTIONS(2039),
    [anon_sym_CARET] = ACTIONS(2037),
    [anon_sym_AMP] = ACTIONS(2037),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2041),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2043),
    [anon_sym_DOT_DOT] = ACTIONS(2045),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [836] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4132),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7108),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6005),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4313),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7382),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9733),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(836),
    [sym_preproc_endregion] = STATE(836),
    [sym_preproc_line] = STATE(836),
    [sym_preproc_pragma] = STATE(836),
    [sym_preproc_nullable] = STATE(836),
    [sym_preproc_error] = STATE(836),
    [sym_preproc_define] = STATE(836),
    [sym_preproc_undef] = STATE(836),
    [aux_sym_class_declaration_repeat1] = STATE(3802),
    [aux_sym_lambda_expression_repeat1] = STATE(4108),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1519),
    [anon_sym_ref] = ACTIONS(1521),
    [anon_sym_LBRACE] = ACTIONS(2761),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1523),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1529),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1531),
    [anon_sym_DOT_DOT] = ACTIONS(1533),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [837] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4003),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6911),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6992),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5043),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(3829),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7391),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9246),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(837),
    [sym_preproc_endregion] = STATE(837),
    [sym_preproc_line] = STATE(837),
    [sym_preproc_pragma] = STATE(837),
    [sym_preproc_nullable] = STATE(837),
    [sym_preproc_error] = STATE(837),
    [sym_preproc_define] = STATE(837),
    [sym_preproc_undef] = STATE(837),
    [aux_sym_class_declaration_repeat1] = STATE(3800),
    [aux_sym_lambda_expression_repeat1] = STATE(4089),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1323),
    [anon_sym_ref] = ACTIONS(1325),
    [anon_sym_LBRACE] = ACTIONS(2833),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1145),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1329),
    [anon_sym_TILDE] = ACTIONS(1329),
    [anon_sym_PLUS_PLUS] = ACTIONS(1329),
    [anon_sym_DASH_DASH] = ACTIONS(1329),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1327),
    [anon_sym_DASH] = ACTIONS(1327),
    [anon_sym_STAR] = ACTIONS(1331),
    [anon_sym_CARET] = ACTIONS(1329),
    [anon_sym_AMP] = ACTIONS(1329),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1333),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1335),
    [anon_sym_DOT_DOT] = ACTIONS(1337),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [838] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4003),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6888),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2882),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7048),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5291),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4019),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7409),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9210),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(838),
    [sym_preproc_endregion] = STATE(838),
    [sym_preproc_line] = STATE(838),
    [sym_preproc_pragma] = STATE(838),
    [sym_preproc_nullable] = STATE(838),
    [sym_preproc_error] = STATE(838),
    [sym_preproc_define] = STATE(838),
    [sym_preproc_undef] = STATE(838),
    [aux_sym_class_declaration_repeat1] = STATE(3812),
    [aux_sym_lambda_expression_repeat1] = STATE(4146),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1709),
    [anon_sym_ref] = ACTIONS(1711),
    [anon_sym_LBRACE] = ACTIONS(2833),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1713),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1717),
    [anon_sym_TILDE] = ACTIONS(1717),
    [anon_sym_PLUS_PLUS] = ACTIONS(1717),
    [anon_sym_DASH_DASH] = ACTIONS(1717),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1715),
    [anon_sym_DASH] = ACTIONS(1715),
    [anon_sym_STAR] = ACTIONS(1719),
    [anon_sym_CARET] = ACTIONS(1717),
    [anon_sym_AMP] = ACTIONS(1717),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1721),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1723),
    [anon_sym_DOT_DOT] = ACTIONS(1725),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [839] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3934),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6888),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2882),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7048),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5292),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4019),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7409),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9210),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(839),
    [sym_preproc_endregion] = STATE(839),
    [sym_preproc_line] = STATE(839),
    [sym_preproc_pragma] = STATE(839),
    [sym_preproc_nullable] = STATE(839),
    [sym_preproc_error] = STATE(839),
    [sym_preproc_define] = STATE(839),
    [sym_preproc_undef] = STATE(839),
    [aux_sym_class_declaration_repeat1] = STATE(3812),
    [aux_sym_lambda_expression_repeat1] = STATE(4146),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1709),
    [anon_sym_ref] = ACTIONS(1711),
    [anon_sym_LBRACE] = ACTIONS(2833),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1713),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1717),
    [anon_sym_TILDE] = ACTIONS(1717),
    [anon_sym_PLUS_PLUS] = ACTIONS(1717),
    [anon_sym_DASH_DASH] = ACTIONS(1717),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1715),
    [anon_sym_DASH] = ACTIONS(1715),
    [anon_sym_STAR] = ACTIONS(1719),
    [anon_sym_CARET] = ACTIONS(1717),
    [anon_sym_AMP] = ACTIONS(1717),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1721),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1723),
    [anon_sym_DOT_DOT] = ACTIONS(1725),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [840] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6030),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(840),
    [sym_preproc_endregion] = STATE(840),
    [sym_preproc_line] = STATE(840),
    [sym_preproc_pragma] = STATE(840),
    [sym_preproc_nullable] = STATE(840),
    [sym_preproc_error] = STATE(840),
    [sym_preproc_define] = STATE(840),
    [sym_preproc_undef] = STATE(840),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_RBRACE] = ACTIONS(2835),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [841] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4085),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7108),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6006),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4313),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7382),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9733),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(841),
    [sym_preproc_endregion] = STATE(841),
    [sym_preproc_line] = STATE(841),
    [sym_preproc_pragma] = STATE(841),
    [sym_preproc_nullable] = STATE(841),
    [sym_preproc_error] = STATE(841),
    [sym_preproc_define] = STATE(841),
    [sym_preproc_undef] = STATE(841),
    [aux_sym_class_declaration_repeat1] = STATE(3802),
    [aux_sym_lambda_expression_repeat1] = STATE(4108),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1519),
    [anon_sym_ref] = ACTIONS(1521),
    [anon_sym_LBRACE] = ACTIONS(2761),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1523),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1529),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1531),
    [anon_sym_DOT_DOT] = ACTIONS(1533),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [842] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3977),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6888),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2882),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7048),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5294),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4019),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7409),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9210),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(842),
    [sym_preproc_endregion] = STATE(842),
    [sym_preproc_line] = STATE(842),
    [sym_preproc_pragma] = STATE(842),
    [sym_preproc_nullable] = STATE(842),
    [sym_preproc_error] = STATE(842),
    [sym_preproc_define] = STATE(842),
    [sym_preproc_undef] = STATE(842),
    [aux_sym_class_declaration_repeat1] = STATE(3812),
    [aux_sym_lambda_expression_repeat1] = STATE(4146),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1709),
    [anon_sym_ref] = ACTIONS(1711),
    [anon_sym_LBRACE] = ACTIONS(2833),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1713),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1717),
    [anon_sym_TILDE] = ACTIONS(1717),
    [anon_sym_PLUS_PLUS] = ACTIONS(1717),
    [anon_sym_DASH_DASH] = ACTIONS(1717),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1715),
    [anon_sym_DASH] = ACTIONS(1715),
    [anon_sym_STAR] = ACTIONS(1719),
    [anon_sym_CARET] = ACTIONS(1717),
    [anon_sym_AMP] = ACTIONS(1717),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1721),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1723),
    [anon_sym_DOT_DOT] = ACTIONS(1725),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [843] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6880),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7103),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5148),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(3863),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7380),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9420),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(843),
    [sym_preproc_endregion] = STATE(843),
    [sym_preproc_line] = STATE(843),
    [sym_preproc_pragma] = STATE(843),
    [sym_preproc_nullable] = STATE(843),
    [sym_preproc_error] = STATE(843),
    [sym_preproc_define] = STATE(843),
    [sym_preproc_undef] = STATE(843),
    [aux_sym_class_declaration_repeat1] = STATE(3820),
    [aux_sym_lambda_expression_repeat1] = STATE(4165),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1339),
    [anon_sym_ref] = ACTIONS(1341),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_readonly] = ACTIONS(2693),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1097),
    [anon_sym_TILDE] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1099),
    [anon_sym_DASH] = ACTIONS(1099),
    [anon_sym_STAR] = ACTIONS(1343),
    [anon_sym_CARET] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1097),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1345),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1347),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [844] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6888),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2882),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7052),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5299),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4019),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7409),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9210),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(844),
    [sym_preproc_endregion] = STATE(844),
    [sym_preproc_line] = STATE(844),
    [sym_preproc_pragma] = STATE(844),
    [sym_preproc_nullable] = STATE(844),
    [sym_preproc_error] = STATE(844),
    [sym_preproc_define] = STATE(844),
    [sym_preproc_undef] = STATE(844),
    [aux_sym_class_declaration_repeat1] = STATE(3812),
    [aux_sym_lambda_expression_repeat1] = STATE(4146),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1709),
    [anon_sym_ref] = ACTIONS(1711),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1713),
    [anon_sym_readonly] = ACTIONS(2693),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1717),
    [anon_sym_TILDE] = ACTIONS(1717),
    [anon_sym_PLUS_PLUS] = ACTIONS(1717),
    [anon_sym_DASH_DASH] = ACTIONS(1717),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1715),
    [anon_sym_DASH] = ACTIONS(1715),
    [anon_sym_STAR] = ACTIONS(1719),
    [anon_sym_CARET] = ACTIONS(1717),
    [anon_sym_AMP] = ACTIONS(1717),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1721),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1723),
    [anon_sym_DOT_DOT] = ACTIONS(1725),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [845] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3726),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5729),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(845),
    [sym_preproc_endregion] = STATE(845),
    [sym_preproc_line] = STATE(845),
    [sym_preproc_pragma] = STATE(845),
    [sym_preproc_nullable] = STATE(845),
    [sym_preproc_error] = STATE(845),
    [sym_preproc_define] = STATE(845),
    [sym_preproc_undef] = STATE(845),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(2765),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [846] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4066),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7108),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6008),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4313),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7382),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9733),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(846),
    [sym_preproc_endregion] = STATE(846),
    [sym_preproc_line] = STATE(846),
    [sym_preproc_pragma] = STATE(846),
    [sym_preproc_nullable] = STATE(846),
    [sym_preproc_error] = STATE(846),
    [sym_preproc_define] = STATE(846),
    [sym_preproc_undef] = STATE(846),
    [aux_sym_class_declaration_repeat1] = STATE(3802),
    [aux_sym_lambda_expression_repeat1] = STATE(4108),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1519),
    [anon_sym_ref] = ACTIONS(1521),
    [anon_sym_LBRACE] = ACTIONS(2761),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1523),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1529),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1531),
    [anon_sym_DOT_DOT] = ACTIONS(1533),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [847] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6961),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5709),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9849),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(847),
    [sym_preproc_endregion] = STATE(847),
    [sym_preproc_line] = STATE(847),
    [sym_preproc_pragma] = STATE(847),
    [sym_preproc_nullable] = STATE(847),
    [sym_preproc_error] = STATE(847),
    [sym_preproc_define] = STATE(847),
    [sym_preproc_undef] = STATE(847),
    [aux_sym_class_declaration_repeat1] = STATE(3841),
    [aux_sym_lambda_expression_repeat1] = STATE(4283),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(2837),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1459),
    [anon_sym_ref] = ACTIONS(1461),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1465),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1467),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1469),
    [anon_sym_DOT_DOT] = ACTIONS(1471),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [848] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3751),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6910),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2957),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7089),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5103),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(3796),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7395),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9374),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(848),
    [sym_preproc_endregion] = STATE(848),
    [sym_preproc_line] = STATE(848),
    [sym_preproc_pragma] = STATE(848),
    [sym_preproc_nullable] = STATE(848),
    [sym_preproc_error] = STATE(848),
    [sym_preproc_define] = STATE(848),
    [sym_preproc_undef] = STATE(848),
    [aux_sym_class_declaration_repeat1] = STATE(3839),
    [aux_sym_lambda_expression_repeat1] = STATE(4209),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2139),
    [anon_sym_ref] = ACTIONS(2141),
    [anon_sym_LBRACE] = ACTIONS(2765),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1799),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2145),
    [anon_sym_TILDE] = ACTIONS(2145),
    [anon_sym_PLUS_PLUS] = ACTIONS(2145),
    [anon_sym_DASH_DASH] = ACTIONS(2145),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2143),
    [anon_sym_DASH] = ACTIONS(2143),
    [anon_sym_STAR] = ACTIONS(1805),
    [anon_sym_CARET] = ACTIONS(2145),
    [anon_sym_AMP] = ACTIONS(2145),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2147),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2149),
    [anon_sym_DOT_DOT] = ACTIONS(2151),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [849] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4050),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6911),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6992),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5039),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(3829),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7391),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9246),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(849),
    [sym_preproc_endregion] = STATE(849),
    [sym_preproc_line] = STATE(849),
    [sym_preproc_pragma] = STATE(849),
    [sym_preproc_nullable] = STATE(849),
    [sym_preproc_error] = STATE(849),
    [sym_preproc_define] = STATE(849),
    [sym_preproc_undef] = STATE(849),
    [aux_sym_class_declaration_repeat1] = STATE(3800),
    [aux_sym_lambda_expression_repeat1] = STATE(4089),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1323),
    [anon_sym_ref] = ACTIONS(1325),
    [anon_sym_LBRACE] = ACTIONS(2833),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1145),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1329),
    [anon_sym_TILDE] = ACTIONS(1329),
    [anon_sym_PLUS_PLUS] = ACTIONS(1329),
    [anon_sym_DASH_DASH] = ACTIONS(1329),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1327),
    [anon_sym_DASH] = ACTIONS(1327),
    [anon_sym_STAR] = ACTIONS(1331),
    [anon_sym_CARET] = ACTIONS(1329),
    [anon_sym_AMP] = ACTIONS(1329),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1333),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1335),
    [anon_sym_DOT_DOT] = ACTIONS(1337),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [850] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(5450),
    [sym_bracketed_argument_list] = STATE(3921),
    [sym__name] = STATE(6889),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2854),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(6991),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5539),
    [sym_non_lvalue_expression] = STATE(5735),
    [sym_lvalue_expression] = STATE(4295),
    [sym__expression_statement_expression] = STATE(5733),
    [sym_assignment_expression] = STATE(5734),
    [sym_binary_expression] = STATE(5733),
    [sym_postfix_unary_expression] = STATE(5734),
    [sym_prefix_unary_expression] = STATE(5734),
    [sym__pointer_indirection_expression] = STATE(3911),
    [sym_query_expression] = STATE(5733),
    [sym_from_clause] = STATE(7393),
    [sym_conditional_expression] = STATE(5733),
    [sym_conditional_access_expression] = STATE(5733),
    [sym_as_expression] = STATE(5733),
    [sym_is_expression] = STATE(5733),
    [sym_is_pattern_expression] = STATE(5733),
    [sym_cast_expression] = STATE(5733),
    [sym_checked_expression] = STATE(5733),
    [sym_invocation_expression] = STATE(5734),
    [sym_switch_expression] = STATE(5733),
    [sym_await_expression] = STATE(5734),
    [sym_throw_expression] = STATE(5733),
    [sym_element_access_expression] = STATE(3911),
    [sym_interpolated_string_expression] = STATE(5733),
    [sym_member_access_expression] = STATE(3911),
    [sym_object_creation_expression] = STATE(5734),
    [sym_parenthesized_expression] = STATE(5734),
    [sym__parenthesized_lvalue_expression] = STATE(3911),
    [sym_lambda_expression] = STATE(5733),
    [sym__lambda_parameters] = STATE(9313),
    [sym_array_creation_expression] = STATE(5733),
    [sym_anonymous_method_expression] = STATE(5733),
    [sym_anonymous_object_creation_expression] = STATE(5733),
    [sym_implicit_array_creation_expression] = STATE(5733),
    [sym_implicit_object_creation_expression] = STATE(5733),
    [sym_implicit_stackalloc_expression] = STATE(5733),
    [sym_initializer_expression] = STATE(5733),
    [sym_default_expression] = STATE(5733),
    [sym_with_expression] = STATE(5733),
    [sym_sizeof_expression] = STATE(5733),
    [sym_typeof_expression] = STATE(5733),
    [sym_makeref_expression] = STATE(5733),
    [sym_ref_expression] = STATE(5733),
    [sym_reftype_expression] = STATE(5733),
    [sym_refvalue_expression] = STATE(5733),
    [sym_stackalloc_expression] = STATE(5733),
    [sym_range_expression] = STATE(5733),
    [sym_tuple_expression] = STATE(3911),
    [sym_literal] = STATE(5733),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2798),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(5733),
    [sym_preproc_region] = STATE(850),
    [sym_preproc_endregion] = STATE(850),
    [sym_preproc_line] = STATE(850),
    [sym_preproc_pragma] = STATE(850),
    [sym_preproc_nullable] = STATE(850),
    [sym_preproc_error] = STATE(850),
    [sym_preproc_define] = STATE(850),
    [sym_preproc_undef] = STATE(850),
    [aux_sym_class_declaration_repeat1] = STATE(3805),
    [aux_sym_lambda_expression_repeat1] = STATE(4122),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_LPAREN] = ACTIONS(1591),
    [anon_sym_ref] = ACTIONS(1593),
    [anon_sym_LBRACE] = ACTIONS(2773),
    [anon_sym_delegate] = ACTIONS(1379),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1443),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1597),
    [anon_sym_TILDE] = ACTIONS(1597),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1595),
    [anon_sym_DASH] = ACTIONS(1595),
    [anon_sym_STAR] = ACTIONS(1449),
    [anon_sym_CARET] = ACTIONS(1597),
    [anon_sym_AMP] = ACTIONS(1597),
    [anon_sym_this] = ACTIONS(1393),
    [anon_sym_scoped] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1397),
    [sym_predefined_type] = ACTIONS(1399),
    [anon_sym_unchecked] = ACTIONS(1383),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1599),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1601),
    [anon_sym_DOT_DOT] = ACTIONS(1603),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_stackalloc] = ACTIONS(1413),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(1419),
    [anon_sym___reftype] = ACTIONS(1421),
    [anon_sym___refvalue] = ACTIONS(1423),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
  },
  [851] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6405),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6513),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4482),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9438),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(851),
    [sym_preproc_endregion] = STATE(851),
    [sym_preproc_line] = STATE(851),
    [sym_preproc_pragma] = STATE(851),
    [sym_preproc_nullable] = STATE(851),
    [sym_preproc_error] = STATE(851),
    [sym_preproc_define] = STATE(851),
    [sym_preproc_undef] = STATE(851),
    [aux_sym_class_declaration_repeat1] = STATE(3801),
    [aux_sym_lambda_expression_repeat1] = STATE(4134),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1993),
    [anon_sym_ref] = ACTIONS(1995),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_readonly] = ACTIONS(2693),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1999),
    [anon_sym_TILDE] = ACTIONS(1999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1999),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_AMP] = ACTIONS(1999),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1281),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1283),
    [anon_sym_DOT_DOT] = ACTIONS(1285),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [852] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4116),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7108),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6012),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4313),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7382),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9733),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(852),
    [sym_preproc_endregion] = STATE(852),
    [sym_preproc_line] = STATE(852),
    [sym_preproc_pragma] = STATE(852),
    [sym_preproc_nullable] = STATE(852),
    [sym_preproc_error] = STATE(852),
    [sym_preproc_define] = STATE(852),
    [sym_preproc_undef] = STATE(852),
    [aux_sym_class_declaration_repeat1] = STATE(3802),
    [aux_sym_lambda_expression_repeat1] = STATE(4108),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1519),
    [anon_sym_ref] = ACTIONS(1521),
    [anon_sym_LBRACE] = ACTIONS(2761),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1523),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1529),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1531),
    [anon_sym_DOT_DOT] = ACTIONS(1533),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [853] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3650),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6918),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7066),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6110),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4423),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7383),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9203),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(853),
    [sym_preproc_endregion] = STATE(853),
    [sym_preproc_line] = STATE(853),
    [sym_preproc_pragma] = STATE(853),
    [sym_preproc_nullable] = STATE(853),
    [sym_preproc_error] = STATE(853),
    [sym_preproc_define] = STATE(853),
    [sym_preproc_undef] = STATE(853),
    [aux_sym_class_declaration_repeat1] = STATE(3817),
    [aux_sym_lambda_expression_repeat1] = STATE(4152),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1905),
    [anon_sym_ref] = ACTIONS(1907),
    [anon_sym_LBRACE] = ACTIONS(2767),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1221),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1911),
    [anon_sym_TILDE] = ACTIONS(1911),
    [anon_sym_PLUS_PLUS] = ACTIONS(1911),
    [anon_sym_DASH_DASH] = ACTIONS(1911),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1909),
    [anon_sym_DASH] = ACTIONS(1909),
    [anon_sym_STAR] = ACTIONS(1913),
    [anon_sym_CARET] = ACTIONS(1911),
    [anon_sym_AMP] = ACTIONS(1911),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1915),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1917),
    [anon_sym_DOT_DOT] = ACTIONS(1919),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [854] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6971),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5761),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8440),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(854),
    [sym_preproc_endregion] = STATE(854),
    [sym_preproc_line] = STATE(854),
    [sym_preproc_pragma] = STATE(854),
    [sym_preproc_nullable] = STATE(854),
    [sym_preproc_error] = STATE(854),
    [sym_preproc_define] = STATE(854),
    [sym_preproc_undef] = STATE(854),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [855] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4065),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6911),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6992),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5032),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(3829),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7391),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9246),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(855),
    [sym_preproc_endregion] = STATE(855),
    [sym_preproc_line] = STATE(855),
    [sym_preproc_pragma] = STATE(855),
    [sym_preproc_nullable] = STATE(855),
    [sym_preproc_error] = STATE(855),
    [sym_preproc_define] = STATE(855),
    [sym_preproc_undef] = STATE(855),
    [aux_sym_class_declaration_repeat1] = STATE(3800),
    [aux_sym_lambda_expression_repeat1] = STATE(4089),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1323),
    [anon_sym_ref] = ACTIONS(1325),
    [anon_sym_LBRACE] = ACTIONS(2833),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1145),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1329),
    [anon_sym_TILDE] = ACTIONS(1329),
    [anon_sym_PLUS_PLUS] = ACTIONS(1329),
    [anon_sym_DASH_DASH] = ACTIONS(1329),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1327),
    [anon_sym_DASH] = ACTIONS(1327),
    [anon_sym_STAR] = ACTIONS(1331),
    [anon_sym_CARET] = ACTIONS(1329),
    [anon_sym_AMP] = ACTIONS(1329),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1333),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1335),
    [anon_sym_DOT_DOT] = ACTIONS(1337),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [856] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4007),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6911),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6992),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5030),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(3829),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7391),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9246),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(856),
    [sym_preproc_endregion] = STATE(856),
    [sym_preproc_line] = STATE(856),
    [sym_preproc_pragma] = STATE(856),
    [sym_preproc_nullable] = STATE(856),
    [sym_preproc_error] = STATE(856),
    [sym_preproc_define] = STATE(856),
    [sym_preproc_undef] = STATE(856),
    [aux_sym_class_declaration_repeat1] = STATE(3800),
    [aux_sym_lambda_expression_repeat1] = STATE(4089),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1323),
    [anon_sym_ref] = ACTIONS(1325),
    [anon_sym_LBRACE] = ACTIONS(2833),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1145),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1329),
    [anon_sym_TILDE] = ACTIONS(1329),
    [anon_sym_PLUS_PLUS] = ACTIONS(1329),
    [anon_sym_DASH_DASH] = ACTIONS(1329),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1327),
    [anon_sym_DASH] = ACTIONS(1327),
    [anon_sym_STAR] = ACTIONS(1331),
    [anon_sym_CARET] = ACTIONS(1329),
    [anon_sym_AMP] = ACTIONS(1329),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1333),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1335),
    [anon_sym_DOT_DOT] = ACTIONS(1337),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [857] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4151),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7108),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6015),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4313),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7382),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9733),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(857),
    [sym_preproc_endregion] = STATE(857),
    [sym_preproc_line] = STATE(857),
    [sym_preproc_pragma] = STATE(857),
    [sym_preproc_nullable] = STATE(857),
    [sym_preproc_error] = STATE(857),
    [sym_preproc_define] = STATE(857),
    [sym_preproc_undef] = STATE(857),
    [aux_sym_class_declaration_repeat1] = STATE(3802),
    [aux_sym_lambda_expression_repeat1] = STATE(4108),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1519),
    [anon_sym_ref] = ACTIONS(1521),
    [anon_sym_LBRACE] = ACTIONS(2761),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1523),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1529),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1531),
    [anon_sym_DOT_DOT] = ACTIONS(1533),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [858] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6961),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6545),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9849),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(858),
    [sym_preproc_endregion] = STATE(858),
    [sym_preproc_line] = STATE(858),
    [sym_preproc_pragma] = STATE(858),
    [sym_preproc_nullable] = STATE(858),
    [sym_preproc_error] = STATE(858),
    [sym_preproc_define] = STATE(858),
    [sym_preproc_undef] = STATE(858),
    [aux_sym_class_declaration_repeat1] = STATE(3841),
    [aux_sym_lambda_expression_repeat1] = STATE(4283),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(2839),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1459),
    [anon_sym_ref] = ACTIONS(1461),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1465),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1467),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1469),
    [anon_sym_DOT_DOT] = ACTIONS(1471),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [859] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4132),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6908),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2874),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7082),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5602),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4189),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7388),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9466),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(859),
    [sym_preproc_endregion] = STATE(859),
    [sym_preproc_line] = STATE(859),
    [sym_preproc_pragma] = STATE(859),
    [sym_preproc_nullable] = STATE(859),
    [sym_preproc_error] = STATE(859),
    [sym_preproc_define] = STATE(859),
    [sym_preproc_undef] = STATE(859),
    [aux_sym_class_declaration_repeat1] = STATE(3825),
    [aux_sym_lambda_expression_repeat1] = STATE(4178),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1743),
    [anon_sym_ref] = ACTIONS(1745),
    [anon_sym_LBRACE] = ACTIONS(2761),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1505),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1749),
    [anon_sym_TILDE] = ACTIONS(1749),
    [anon_sym_PLUS_PLUS] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1749),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1747),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_CARET] = ACTIONS(1749),
    [anon_sym_AMP] = ACTIONS(1749),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1753),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1755),
    [anon_sym_DOT_DOT] = ACTIONS(1757),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [860] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4085),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6908),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2874),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7082),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5601),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4189),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7388),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9466),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(860),
    [sym_preproc_endregion] = STATE(860),
    [sym_preproc_line] = STATE(860),
    [sym_preproc_pragma] = STATE(860),
    [sym_preproc_nullable] = STATE(860),
    [sym_preproc_error] = STATE(860),
    [sym_preproc_define] = STATE(860),
    [sym_preproc_undef] = STATE(860),
    [aux_sym_class_declaration_repeat1] = STATE(3825),
    [aux_sym_lambda_expression_repeat1] = STATE(4178),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1743),
    [anon_sym_ref] = ACTIONS(1745),
    [anon_sym_LBRACE] = ACTIONS(2761),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1505),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1749),
    [anon_sym_TILDE] = ACTIONS(1749),
    [anon_sym_PLUS_PLUS] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1749),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1747),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_CARET] = ACTIONS(1749),
    [anon_sym_AMP] = ACTIONS(1749),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1753),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1755),
    [anon_sym_DOT_DOT] = ACTIONS(1757),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [861] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6989),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6510),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4462),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7405),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9130),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(861),
    [sym_preproc_endregion] = STATE(861),
    [sym_preproc_line] = STATE(861),
    [sym_preproc_pragma] = STATE(861),
    [sym_preproc_nullable] = STATE(861),
    [sym_preproc_error] = STATE(861),
    [sym_preproc_define] = STATE(861),
    [sym_preproc_undef] = STATE(861),
    [aux_sym_class_declaration_repeat1] = STATE(3855),
    [aux_sym_lambda_expression_repeat1] = STATE(4244),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2031),
    [anon_sym_ref] = ACTIONS(2033),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_readonly] = ACTIONS(2693),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2037),
    [anon_sym_TILDE] = ACTIONS(2037),
    [anon_sym_PLUS_PLUS] = ACTIONS(2037),
    [anon_sym_DASH_DASH] = ACTIONS(2037),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2035),
    [anon_sym_DASH] = ACTIONS(2035),
    [anon_sym_STAR] = ACTIONS(2039),
    [anon_sym_CARET] = ACTIONS(2037),
    [anon_sym_AMP] = ACTIONS(2037),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2041),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2043),
    [anon_sym_DOT_DOT] = ACTIONS(2045),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [862] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6904),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7012),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5266),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4008),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7381),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9536),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(862),
    [sym_preproc_endregion] = STATE(862),
    [sym_preproc_line] = STATE(862),
    [sym_preproc_pragma] = STATE(862),
    [sym_preproc_nullable] = STATE(862),
    [sym_preproc_error] = STATE(862),
    [sym_preproc_define] = STATE(862),
    [sym_preproc_undef] = STATE(862),
    [aux_sym_class_declaration_repeat1] = STATE(3832),
    [aux_sym_lambda_expression_repeat1] = STATE(4090),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1485),
    [anon_sym_ref] = ACTIONS(1487),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1221),
    [anon_sym_readonly] = ACTIONS(2693),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1491),
    [anon_sym_TILDE] = ACTIONS(1491),
    [anon_sym_PLUS_PLUS] = ACTIONS(1491),
    [anon_sym_DASH_DASH] = ACTIONS(1491),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1489),
    [anon_sym_DASH] = ACTIONS(1489),
    [anon_sym_STAR] = ACTIONS(1493),
    [anon_sym_CARET] = ACTIONS(1491),
    [anon_sym_AMP] = ACTIONS(1491),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1495),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1497),
    [anon_sym_DOT_DOT] = ACTIONS(1499),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [863] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6961),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6327),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9849),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(863),
    [sym_preproc_endregion] = STATE(863),
    [sym_preproc_line] = STATE(863),
    [sym_preproc_pragma] = STATE(863),
    [sym_preproc_nullable] = STATE(863),
    [sym_preproc_error] = STATE(863),
    [sym_preproc_define] = STATE(863),
    [sym_preproc_undef] = STATE(863),
    [aux_sym_class_declaration_repeat1] = STATE(3841),
    [aux_sym_lambda_expression_repeat1] = STATE(4283),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(1937),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1459),
    [anon_sym_ref] = ACTIONS(1461),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1465),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1467),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1469),
    [anon_sym_DOT_DOT] = ACTIONS(1471),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [864] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4188),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7108),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6018),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4313),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7382),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9733),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(864),
    [sym_preproc_endregion] = STATE(864),
    [sym_preproc_line] = STATE(864),
    [sym_preproc_pragma] = STATE(864),
    [sym_preproc_nullable] = STATE(864),
    [sym_preproc_error] = STATE(864),
    [sym_preproc_define] = STATE(864),
    [sym_preproc_undef] = STATE(864),
    [aux_sym_class_declaration_repeat1] = STATE(3802),
    [aux_sym_lambda_expression_repeat1] = STATE(4108),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1519),
    [anon_sym_ref] = ACTIONS(1521),
    [anon_sym_LBRACE] = ACTIONS(2761),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1523),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1529),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1531),
    [anon_sym_DOT_DOT] = ACTIONS(1533),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [865] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4066),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6908),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2874),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7082),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5599),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4189),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7388),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9466),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(865),
    [sym_preproc_endregion] = STATE(865),
    [sym_preproc_line] = STATE(865),
    [sym_preproc_pragma] = STATE(865),
    [sym_preproc_nullable] = STATE(865),
    [sym_preproc_error] = STATE(865),
    [sym_preproc_define] = STATE(865),
    [sym_preproc_undef] = STATE(865),
    [aux_sym_class_declaration_repeat1] = STATE(3825),
    [aux_sym_lambda_expression_repeat1] = STATE(4178),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1743),
    [anon_sym_ref] = ACTIONS(1745),
    [anon_sym_LBRACE] = ACTIONS(2761),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1505),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1749),
    [anon_sym_TILDE] = ACTIONS(1749),
    [anon_sym_PLUS_PLUS] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1749),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1747),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_CARET] = ACTIONS(1749),
    [anon_sym_AMP] = ACTIONS(1749),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1753),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1755),
    [anon_sym_DOT_DOT] = ACTIONS(1757),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [866] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6961),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6376),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9849),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(866),
    [sym_preproc_endregion] = STATE(866),
    [sym_preproc_line] = STATE(866),
    [sym_preproc_pragma] = STATE(866),
    [sym_preproc_nullable] = STATE(866),
    [sym_preproc_error] = STATE(866),
    [sym_preproc_define] = STATE(866),
    [sym_preproc_undef] = STATE(866),
    [aux_sym_class_declaration_repeat1] = STATE(3841),
    [aux_sym_lambda_expression_repeat1] = STATE(4283),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(2841),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1459),
    [anon_sym_ref] = ACTIONS(1461),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1465),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1467),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1469),
    [anon_sym_DOT_DOT] = ACTIONS(1471),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [867] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3726),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6980),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6533),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4482),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9438),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(867),
    [sym_preproc_endregion] = STATE(867),
    [sym_preproc_line] = STATE(867),
    [sym_preproc_pragma] = STATE(867),
    [sym_preproc_nullable] = STATE(867),
    [sym_preproc_error] = STATE(867),
    [sym_preproc_define] = STATE(867),
    [sym_preproc_undef] = STATE(867),
    [aux_sym_class_declaration_repeat1] = STATE(3801),
    [aux_sym_lambda_expression_repeat1] = STATE(4134),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1993),
    [anon_sym_ref] = ACTIONS(1995),
    [anon_sym_LBRACE] = ACTIONS(2765),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1999),
    [anon_sym_TILDE] = ACTIONS(1999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1999),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_AMP] = ACTIONS(1999),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1281),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1283),
    [anon_sym_DOT_DOT] = ACTIONS(1285),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [868] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4116),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6908),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2874),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7082),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5596),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4189),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7388),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9466),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(868),
    [sym_preproc_endregion] = STATE(868),
    [sym_preproc_line] = STATE(868),
    [sym_preproc_pragma] = STATE(868),
    [sym_preproc_nullable] = STATE(868),
    [sym_preproc_error] = STATE(868),
    [sym_preproc_define] = STATE(868),
    [sym_preproc_undef] = STATE(868),
    [aux_sym_class_declaration_repeat1] = STATE(3825),
    [aux_sym_lambda_expression_repeat1] = STATE(4178),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1743),
    [anon_sym_ref] = ACTIONS(1745),
    [anon_sym_LBRACE] = ACTIONS(2761),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1505),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1749),
    [anon_sym_TILDE] = ACTIONS(1749),
    [anon_sym_PLUS_PLUS] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1749),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1747),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_CARET] = ACTIONS(1749),
    [anon_sym_AMP] = ACTIONS(1749),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1753),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1755),
    [anon_sym_DOT_DOT] = ACTIONS(1757),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [869] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6881),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2964),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7115),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5833),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4326),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7394),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9186),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(869),
    [sym_preproc_endregion] = STATE(869),
    [sym_preproc_line] = STATE(869),
    [sym_preproc_pragma] = STATE(869),
    [sym_preproc_nullable] = STATE(869),
    [sym_preproc_error] = STATE(869),
    [sym_preproc_define] = STATE(869),
    [sym_preproc_undef] = STATE(869),
    [aux_sym_class_declaration_repeat1] = STATE(3828),
    [aux_sym_lambda_expression_repeat1] = STATE(4180),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1813),
    [anon_sym_ref] = ACTIONS(1815),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1817),
    [anon_sym_readonly] = ACTIONS(2693),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1821),
    [anon_sym_TILDE] = ACTIONS(1821),
    [anon_sym_PLUS_PLUS] = ACTIONS(1821),
    [anon_sym_DASH_DASH] = ACTIONS(1821),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1819),
    [anon_sym_DASH] = ACTIONS(1819),
    [anon_sym_STAR] = ACTIONS(1823),
    [anon_sym_CARET] = ACTIONS(1821),
    [anon_sym_AMP] = ACTIONS(1821),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1825),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1827),
    [anon_sym_DOT_DOT] = ACTIONS(1829),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [870] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4132),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6881),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2964),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7109),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5922),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4326),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7394),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9186),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(870),
    [sym_preproc_endregion] = STATE(870),
    [sym_preproc_line] = STATE(870),
    [sym_preproc_pragma] = STATE(870),
    [sym_preproc_nullable] = STATE(870),
    [sym_preproc_error] = STATE(870),
    [sym_preproc_define] = STATE(870),
    [sym_preproc_undef] = STATE(870),
    [aux_sym_class_declaration_repeat1] = STATE(3828),
    [aux_sym_lambda_expression_repeat1] = STATE(4180),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1813),
    [anon_sym_ref] = ACTIONS(1815),
    [anon_sym_LBRACE] = ACTIONS(2761),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1817),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1821),
    [anon_sym_TILDE] = ACTIONS(1821),
    [anon_sym_PLUS_PLUS] = ACTIONS(1821),
    [anon_sym_DASH_DASH] = ACTIONS(1821),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1819),
    [anon_sym_DASH] = ACTIONS(1819),
    [anon_sym_STAR] = ACTIONS(1823),
    [anon_sym_CARET] = ACTIONS(1821),
    [anon_sym_AMP] = ACTIONS(1821),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1825),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1827),
    [anon_sym_DOT_DOT] = ACTIONS(1829),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [871] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4085),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6881),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2964),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7109),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5921),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4326),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7394),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9186),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(871),
    [sym_preproc_endregion] = STATE(871),
    [sym_preproc_line] = STATE(871),
    [sym_preproc_pragma] = STATE(871),
    [sym_preproc_nullable] = STATE(871),
    [sym_preproc_error] = STATE(871),
    [sym_preproc_define] = STATE(871),
    [sym_preproc_undef] = STATE(871),
    [aux_sym_class_declaration_repeat1] = STATE(3828),
    [aux_sym_lambda_expression_repeat1] = STATE(4180),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1813),
    [anon_sym_ref] = ACTIONS(1815),
    [anon_sym_LBRACE] = ACTIONS(2761),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1817),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1821),
    [anon_sym_TILDE] = ACTIONS(1821),
    [anon_sym_PLUS_PLUS] = ACTIONS(1821),
    [anon_sym_DASH_DASH] = ACTIONS(1821),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1819),
    [anon_sym_DASH] = ACTIONS(1819),
    [anon_sym_STAR] = ACTIONS(1823),
    [anon_sym_CARET] = ACTIONS(1821),
    [anon_sym_AMP] = ACTIONS(1821),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1825),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1827),
    [anon_sym_DOT_DOT] = ACTIONS(1829),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [872] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6030),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(872),
    [sym_preproc_endregion] = STATE(872),
    [sym_preproc_line] = STATE(872),
    [sym_preproc_pragma] = STATE(872),
    [sym_preproc_nullable] = STATE(872),
    [sym_preproc_error] = STATE(872),
    [sym_preproc_define] = STATE(872),
    [sym_preproc_undef] = STATE(872),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_RBRACE] = ACTIONS(2843),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [873] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4066),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6881),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2964),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7109),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5920),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4326),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7394),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9186),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(873),
    [sym_preproc_endregion] = STATE(873),
    [sym_preproc_line] = STATE(873),
    [sym_preproc_pragma] = STATE(873),
    [sym_preproc_nullable] = STATE(873),
    [sym_preproc_error] = STATE(873),
    [sym_preproc_define] = STATE(873),
    [sym_preproc_undef] = STATE(873),
    [aux_sym_class_declaration_repeat1] = STATE(3828),
    [aux_sym_lambda_expression_repeat1] = STATE(4180),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1813),
    [anon_sym_ref] = ACTIONS(1815),
    [anon_sym_LBRACE] = ACTIONS(2761),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1817),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1821),
    [anon_sym_TILDE] = ACTIONS(1821),
    [anon_sym_PLUS_PLUS] = ACTIONS(1821),
    [anon_sym_DASH_DASH] = ACTIONS(1821),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1819),
    [anon_sym_DASH] = ACTIONS(1819),
    [anon_sym_STAR] = ACTIONS(1823),
    [anon_sym_CARET] = ACTIONS(1821),
    [anon_sym_AMP] = ACTIONS(1821),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1825),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1827),
    [anon_sym_DOT_DOT] = ACTIONS(1829),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [874] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3769),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6980),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6417),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4482),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9438),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(874),
    [sym_preproc_endregion] = STATE(874),
    [sym_preproc_line] = STATE(874),
    [sym_preproc_pragma] = STATE(874),
    [sym_preproc_nullable] = STATE(874),
    [sym_preproc_error] = STATE(874),
    [sym_preproc_define] = STATE(874),
    [sym_preproc_undef] = STATE(874),
    [aux_sym_class_declaration_repeat1] = STATE(3801),
    [aux_sym_lambda_expression_repeat1] = STATE(4134),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1993),
    [anon_sym_ref] = ACTIONS(1995),
    [anon_sym_LBRACE] = ACTIONS(2765),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1999),
    [anon_sym_TILDE] = ACTIONS(1999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1999),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_AMP] = ACTIONS(1999),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1281),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1283),
    [anon_sym_DOT_DOT] = ACTIONS(1285),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [875] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4116),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6881),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2964),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7109),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5918),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4326),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7394),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9186),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(875),
    [sym_preproc_endregion] = STATE(875),
    [sym_preproc_line] = STATE(875),
    [sym_preproc_pragma] = STATE(875),
    [sym_preproc_nullable] = STATE(875),
    [sym_preproc_error] = STATE(875),
    [sym_preproc_define] = STATE(875),
    [sym_preproc_undef] = STATE(875),
    [aux_sym_class_declaration_repeat1] = STATE(3828),
    [aux_sym_lambda_expression_repeat1] = STATE(4180),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1813),
    [anon_sym_ref] = ACTIONS(1815),
    [anon_sym_LBRACE] = ACTIONS(2761),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1817),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1821),
    [anon_sym_TILDE] = ACTIONS(1821),
    [anon_sym_PLUS_PLUS] = ACTIONS(1821),
    [anon_sym_DASH_DASH] = ACTIONS(1821),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1819),
    [anon_sym_DASH] = ACTIONS(1819),
    [anon_sym_STAR] = ACTIONS(1823),
    [anon_sym_CARET] = ACTIONS(1821),
    [anon_sym_AMP] = ACTIONS(1821),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1825),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1827),
    [anon_sym_DOT_DOT] = ACTIONS(1829),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [876] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4151),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6881),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2964),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7109),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5911),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4326),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7394),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9186),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(876),
    [sym_preproc_endregion] = STATE(876),
    [sym_preproc_line] = STATE(876),
    [sym_preproc_pragma] = STATE(876),
    [sym_preproc_nullable] = STATE(876),
    [sym_preproc_error] = STATE(876),
    [sym_preproc_define] = STATE(876),
    [sym_preproc_undef] = STATE(876),
    [aux_sym_class_declaration_repeat1] = STATE(3828),
    [aux_sym_lambda_expression_repeat1] = STATE(4180),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1813),
    [anon_sym_ref] = ACTIONS(1815),
    [anon_sym_LBRACE] = ACTIONS(2761),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1817),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1821),
    [anon_sym_TILDE] = ACTIONS(1821),
    [anon_sym_PLUS_PLUS] = ACTIONS(1821),
    [anon_sym_DASH_DASH] = ACTIONS(1821),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1819),
    [anon_sym_DASH] = ACTIONS(1819),
    [anon_sym_STAR] = ACTIONS(1823),
    [anon_sym_CARET] = ACTIONS(1821),
    [anon_sym_AMP] = ACTIONS(1821),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1825),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1827),
    [anon_sym_DOT_DOT] = ACTIONS(1829),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [877] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4188),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6881),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2964),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7109),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5898),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4326),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7394),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9186),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(877),
    [sym_preproc_endregion] = STATE(877),
    [sym_preproc_line] = STATE(877),
    [sym_preproc_pragma] = STATE(877),
    [sym_preproc_nullable] = STATE(877),
    [sym_preproc_error] = STATE(877),
    [sym_preproc_define] = STATE(877),
    [sym_preproc_undef] = STATE(877),
    [aux_sym_class_declaration_repeat1] = STATE(3828),
    [aux_sym_lambda_expression_repeat1] = STATE(4180),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1813),
    [anon_sym_ref] = ACTIONS(1815),
    [anon_sym_LBRACE] = ACTIONS(2761),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1817),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1821),
    [anon_sym_TILDE] = ACTIONS(1821),
    [anon_sym_PLUS_PLUS] = ACTIONS(1821),
    [anon_sym_DASH_DASH] = ACTIONS(1821),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1819),
    [anon_sym_DASH] = ACTIONS(1819),
    [anon_sym_STAR] = ACTIONS(1823),
    [anon_sym_CARET] = ACTIONS(1821),
    [anon_sym_AMP] = ACTIONS(1821),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1825),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1827),
    [anon_sym_DOT_DOT] = ACTIONS(1829),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [878] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6961),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6351),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9849),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(878),
    [sym_preproc_endregion] = STATE(878),
    [sym_preproc_line] = STATE(878),
    [sym_preproc_pragma] = STATE(878),
    [sym_preproc_nullable] = STATE(878),
    [sym_preproc_error] = STATE(878),
    [sym_preproc_define] = STATE(878),
    [sym_preproc_undef] = STATE(878),
    [aux_sym_class_declaration_repeat1] = STATE(3841),
    [aux_sym_lambda_expression_repeat1] = STATE(4283),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(2845),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1459),
    [anon_sym_ref] = ACTIONS(1461),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1465),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1467),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1469),
    [anon_sym_DOT_DOT] = ACTIONS(1471),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [879] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(2843),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5825),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(879),
    [sym_preproc_endregion] = STATE(879),
    [sym_preproc_line] = STATE(879),
    [sym_preproc_pragma] = STATE(879),
    [sym_preproc_nullable] = STATE(879),
    [sym_preproc_error] = STATE(879),
    [sym_preproc_define] = STATE(879),
    [sym_preproc_undef] = STATE(879),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_readonly] = ACTIONS(2693),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1669),
    [anon_sym_TILDE] = ACTIONS(1669),
    [anon_sym_PLUS_PLUS] = ACTIONS(1669),
    [anon_sym_DASH_DASH] = ACTIONS(1669),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1667),
    [anon_sym_DASH] = ACTIONS(1667),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1669),
    [anon_sym_AMP] = ACTIONS(1669),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [880] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3751),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6961),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5405),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9849),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(880),
    [sym_preproc_endregion] = STATE(880),
    [sym_preproc_line] = STATE(880),
    [sym_preproc_pragma] = STATE(880),
    [sym_preproc_nullable] = STATE(880),
    [sym_preproc_error] = STATE(880),
    [sym_preproc_define] = STATE(880),
    [sym_preproc_undef] = STATE(880),
    [aux_sym_class_declaration_repeat1] = STATE(3841),
    [aux_sym_lambda_expression_repeat1] = STATE(4283),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1459),
    [anon_sym_ref] = ACTIONS(1461),
    [anon_sym_LBRACE] = ACTIONS(2765),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1465),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1467),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1469),
    [anon_sym_DOT_DOT] = ACTIONS(1471),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [881] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4151),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6908),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2874),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7082),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5593),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4189),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7388),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9466),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(881),
    [sym_preproc_endregion] = STATE(881),
    [sym_preproc_line] = STATE(881),
    [sym_preproc_pragma] = STATE(881),
    [sym_preproc_nullable] = STATE(881),
    [sym_preproc_error] = STATE(881),
    [sym_preproc_define] = STATE(881),
    [sym_preproc_undef] = STATE(881),
    [aux_sym_class_declaration_repeat1] = STATE(3825),
    [aux_sym_lambda_expression_repeat1] = STATE(4178),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1743),
    [anon_sym_ref] = ACTIONS(1745),
    [anon_sym_LBRACE] = ACTIONS(2761),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1505),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1749),
    [anon_sym_TILDE] = ACTIONS(1749),
    [anon_sym_PLUS_PLUS] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1749),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1747),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_CARET] = ACTIONS(1749),
    [anon_sym_AMP] = ACTIONS(1749),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1753),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1755),
    [anon_sym_DOT_DOT] = ACTIONS(1757),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [882] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4188),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6908),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2874),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7082),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5591),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4189),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7388),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9466),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(882),
    [sym_preproc_endregion] = STATE(882),
    [sym_preproc_line] = STATE(882),
    [sym_preproc_pragma] = STATE(882),
    [sym_preproc_nullable] = STATE(882),
    [sym_preproc_error] = STATE(882),
    [sym_preproc_define] = STATE(882),
    [sym_preproc_undef] = STATE(882),
    [aux_sym_class_declaration_repeat1] = STATE(3825),
    [aux_sym_lambda_expression_repeat1] = STATE(4178),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1743),
    [anon_sym_ref] = ACTIONS(1745),
    [anon_sym_LBRACE] = ACTIONS(2761),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1505),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1749),
    [anon_sym_TILDE] = ACTIONS(1749),
    [anon_sym_PLUS_PLUS] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1749),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1747),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_CARET] = ACTIONS(1749),
    [anon_sym_AMP] = ACTIONS(1749),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1753),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1755),
    [anon_sym_DOT_DOT] = ACTIONS(1757),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [883] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3717),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6980),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6362),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4482),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9438),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(883),
    [sym_preproc_endregion] = STATE(883),
    [sym_preproc_line] = STATE(883),
    [sym_preproc_pragma] = STATE(883),
    [sym_preproc_nullable] = STATE(883),
    [sym_preproc_error] = STATE(883),
    [sym_preproc_define] = STATE(883),
    [sym_preproc_undef] = STATE(883),
    [aux_sym_class_declaration_repeat1] = STATE(3801),
    [aux_sym_lambda_expression_repeat1] = STATE(4134),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1993),
    [anon_sym_ref] = ACTIONS(1995),
    [anon_sym_LBRACE] = ACTIONS(2765),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1999),
    [anon_sym_TILDE] = ACTIONS(1999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1999),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_AMP] = ACTIONS(1999),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1281),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1283),
    [anon_sym_DOT_DOT] = ACTIONS(1285),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [884] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4151),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6967),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5051),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(3858),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7382),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9625),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(884),
    [sym_preproc_endregion] = STATE(884),
    [sym_preproc_line] = STATE(884),
    [sym_preproc_pragma] = STATE(884),
    [sym_preproc_nullable] = STATE(884),
    [sym_preproc_error] = STATE(884),
    [sym_preproc_define] = STATE(884),
    [sym_preproc_undef] = STATE(884),
    [aux_sym_class_declaration_repeat1] = STATE(3851),
    [aux_sym_lambda_expression_repeat1] = STATE(4234),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_ref] = ACTIONS(1293),
    [anon_sym_LBRACE] = ACTIONS(2761),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1059),
    [anon_sym_TILDE] = ACTIONS(1059),
    [anon_sym_PLUS_PLUS] = ACTIONS(1059),
    [anon_sym_DASH_DASH] = ACTIONS(1059),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1061),
    [anon_sym_DASH] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(1303),
    [anon_sym_CARET] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1307),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1309),
    [anon_sym_DOT_DOT] = ACTIONS(1311),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [885] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6030),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(885),
    [sym_preproc_endregion] = STATE(885),
    [sym_preproc_line] = STATE(885),
    [sym_preproc_pragma] = STATE(885),
    [sym_preproc_nullable] = STATE(885),
    [sym_preproc_error] = STATE(885),
    [sym_preproc_define] = STATE(885),
    [sym_preproc_undef] = STATE(885),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_RBRACE] = ACTIONS(2847),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [886] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6894),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2955),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7020),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4981),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(3786),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7408),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9363),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(886),
    [sym_preproc_endregion] = STATE(886),
    [sym_preproc_line] = STATE(886),
    [sym_preproc_pragma] = STATE(886),
    [sym_preproc_nullable] = STATE(886),
    [sym_preproc_error] = STATE(886),
    [sym_preproc_define] = STATE(886),
    [sym_preproc_undef] = STATE(886),
    [aux_sym_class_declaration_repeat1] = STATE(3811),
    [aux_sym_lambda_expression_repeat1] = STATE(4149),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2069),
    [anon_sym_ref] = ACTIONS(2071),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1853),
    [anon_sym_readonly] = ACTIONS(2693),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(2075),
    [anon_sym_TILDE] = ACTIONS(2075),
    [anon_sym_PLUS_PLUS] = ACTIONS(2075),
    [anon_sym_DASH_DASH] = ACTIONS(2075),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2073),
    [anon_sym_DASH] = ACTIONS(2073),
    [anon_sym_STAR] = ACTIONS(1859),
    [anon_sym_CARET] = ACTIONS(2075),
    [anon_sym_AMP] = ACTIONS(2075),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2077),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2079),
    [anon_sym_DOT_DOT] = ACTIONS(2081),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [887] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3726),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6910),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2957),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7089),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5056),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(3796),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7395),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9374),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(887),
    [sym_preproc_endregion] = STATE(887),
    [sym_preproc_line] = STATE(887),
    [sym_preproc_pragma] = STATE(887),
    [sym_preproc_nullable] = STATE(887),
    [sym_preproc_error] = STATE(887),
    [sym_preproc_define] = STATE(887),
    [sym_preproc_undef] = STATE(887),
    [aux_sym_class_declaration_repeat1] = STATE(3839),
    [aux_sym_lambda_expression_repeat1] = STATE(4209),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2139),
    [anon_sym_ref] = ACTIONS(2141),
    [anon_sym_LBRACE] = ACTIONS(2765),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1799),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2145),
    [anon_sym_TILDE] = ACTIONS(2145),
    [anon_sym_PLUS_PLUS] = ACTIONS(2145),
    [anon_sym_DASH_DASH] = ACTIONS(2145),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2143),
    [anon_sym_DASH] = ACTIONS(2143),
    [anon_sym_STAR] = ACTIONS(1805),
    [anon_sym_CARET] = ACTIONS(2145),
    [anon_sym_AMP] = ACTIONS(2145),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2147),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2149),
    [anon_sym_DOT_DOT] = ACTIONS(2151),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [888] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4116),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6967),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5049),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(3858),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7382),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9625),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(888),
    [sym_preproc_endregion] = STATE(888),
    [sym_preproc_line] = STATE(888),
    [sym_preproc_pragma] = STATE(888),
    [sym_preproc_nullable] = STATE(888),
    [sym_preproc_error] = STATE(888),
    [sym_preproc_define] = STATE(888),
    [sym_preproc_undef] = STATE(888),
    [aux_sym_class_declaration_repeat1] = STATE(3851),
    [aux_sym_lambda_expression_repeat1] = STATE(4234),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_ref] = ACTIONS(1293),
    [anon_sym_LBRACE] = ACTIONS(2761),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1059),
    [anon_sym_TILDE] = ACTIONS(1059),
    [anon_sym_PLUS_PLUS] = ACTIONS(1059),
    [anon_sym_DASH_DASH] = ACTIONS(1059),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1061),
    [anon_sym_DASH] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(1303),
    [anon_sym_CARET] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1307),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1309),
    [anon_sym_DOT_DOT] = ACTIONS(1311),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [889] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3615),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6894),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2955),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7046),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4983),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(3786),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7408),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9363),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(889),
    [sym_preproc_endregion] = STATE(889),
    [sym_preproc_line] = STATE(889),
    [sym_preproc_pragma] = STATE(889),
    [sym_preproc_nullable] = STATE(889),
    [sym_preproc_error] = STATE(889),
    [sym_preproc_define] = STATE(889),
    [sym_preproc_undef] = STATE(889),
    [aux_sym_class_declaration_repeat1] = STATE(3811),
    [aux_sym_lambda_expression_repeat1] = STATE(4149),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2069),
    [anon_sym_ref] = ACTIONS(2071),
    [anon_sym_LBRACE] = ACTIONS(2767),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1853),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(2075),
    [anon_sym_TILDE] = ACTIONS(2075),
    [anon_sym_PLUS_PLUS] = ACTIONS(2075),
    [anon_sym_DASH_DASH] = ACTIONS(2075),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2073),
    [anon_sym_DASH] = ACTIONS(2073),
    [anon_sym_STAR] = ACTIONS(1859),
    [anon_sym_CARET] = ACTIONS(2075),
    [anon_sym_AMP] = ACTIONS(2075),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2077),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2079),
    [anon_sym_DOT_DOT] = ACTIONS(2081),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [890] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4066),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6967),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5040),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(3858),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7382),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9625),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(890),
    [sym_preproc_endregion] = STATE(890),
    [sym_preproc_line] = STATE(890),
    [sym_preproc_pragma] = STATE(890),
    [sym_preproc_nullable] = STATE(890),
    [sym_preproc_error] = STATE(890),
    [sym_preproc_define] = STATE(890),
    [sym_preproc_undef] = STATE(890),
    [aux_sym_class_declaration_repeat1] = STATE(3851),
    [aux_sym_lambda_expression_repeat1] = STATE(4234),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_ref] = ACTIONS(1293),
    [anon_sym_LBRACE] = ACTIONS(2761),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1059),
    [anon_sym_TILDE] = ACTIONS(1059),
    [anon_sym_PLUS_PLUS] = ACTIONS(1059),
    [anon_sym_DASH_DASH] = ACTIONS(1059),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1061),
    [anon_sym_DASH] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(1303),
    [anon_sym_CARET] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1307),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1309),
    [anon_sym_DOT_DOT] = ACTIONS(1311),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [891] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3738),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6980),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6334),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4482),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9438),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(891),
    [sym_preproc_endregion] = STATE(891),
    [sym_preproc_line] = STATE(891),
    [sym_preproc_pragma] = STATE(891),
    [sym_preproc_nullable] = STATE(891),
    [sym_preproc_error] = STATE(891),
    [sym_preproc_define] = STATE(891),
    [sym_preproc_undef] = STATE(891),
    [aux_sym_class_declaration_repeat1] = STATE(3801),
    [aux_sym_lambda_expression_repeat1] = STATE(4134),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1993),
    [anon_sym_ref] = ACTIONS(1995),
    [anon_sym_LBRACE] = ACTIONS(2765),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1999),
    [anon_sym_TILDE] = ACTIONS(1999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1999),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_AMP] = ACTIONS(1999),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1281),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1283),
    [anon_sym_DOT_DOT] = ACTIONS(1285),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [892] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3767),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6980),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6333),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4482),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9438),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(892),
    [sym_preproc_endregion] = STATE(892),
    [sym_preproc_line] = STATE(892),
    [sym_preproc_pragma] = STATE(892),
    [sym_preproc_nullable] = STATE(892),
    [sym_preproc_error] = STATE(892),
    [sym_preproc_define] = STATE(892),
    [sym_preproc_undef] = STATE(892),
    [aux_sym_class_declaration_repeat1] = STATE(3801),
    [aux_sym_lambda_expression_repeat1] = STATE(4134),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1993),
    [anon_sym_ref] = ACTIONS(1995),
    [anon_sym_LBRACE] = ACTIONS(2765),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1999),
    [anon_sym_TILDE] = ACTIONS(1999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1999),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_AMP] = ACTIONS(1999),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1281),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1283),
    [anon_sym_DOT_DOT] = ACTIONS(1285),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [893] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3632),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6894),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2955),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7046),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4964),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(3786),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7408),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9363),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(893),
    [sym_preproc_endregion] = STATE(893),
    [sym_preproc_line] = STATE(893),
    [sym_preproc_pragma] = STATE(893),
    [sym_preproc_nullable] = STATE(893),
    [sym_preproc_error] = STATE(893),
    [sym_preproc_define] = STATE(893),
    [sym_preproc_undef] = STATE(893),
    [aux_sym_class_declaration_repeat1] = STATE(3811),
    [aux_sym_lambda_expression_repeat1] = STATE(4149),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2069),
    [anon_sym_ref] = ACTIONS(2071),
    [anon_sym_LBRACE] = ACTIONS(2767),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1853),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(2075),
    [anon_sym_TILDE] = ACTIONS(2075),
    [anon_sym_PLUS_PLUS] = ACTIONS(2075),
    [anon_sym_DASH_DASH] = ACTIONS(2075),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2073),
    [anon_sym_DASH] = ACTIONS(2073),
    [anon_sym_STAR] = ACTIONS(1859),
    [anon_sym_CARET] = ACTIONS(2075),
    [anon_sym_AMP] = ACTIONS(2075),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2077),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2079),
    [anon_sym_DOT_DOT] = ACTIONS(2081),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [894] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3726),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7094),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6073),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(894),
    [sym_preproc_endregion] = STATE(894),
    [sym_preproc_line] = STATE(894),
    [sym_preproc_pragma] = STATE(894),
    [sym_preproc_nullable] = STATE(894),
    [sym_preproc_error] = STATE(894),
    [sym_preproc_define] = STATE(894),
    [sym_preproc_undef] = STATE(894),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(2765),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1669),
    [anon_sym_TILDE] = ACTIONS(1669),
    [anon_sym_PLUS_PLUS] = ACTIONS(1669),
    [anon_sym_DASH_DASH] = ACTIONS(1669),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1667),
    [anon_sym_DASH] = ACTIONS(1667),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1669),
    [anon_sym_AMP] = ACTIONS(1669),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [895] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3638),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6894),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2955),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7046),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4965),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(3786),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7408),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9363),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(895),
    [sym_preproc_endregion] = STATE(895),
    [sym_preproc_line] = STATE(895),
    [sym_preproc_pragma] = STATE(895),
    [sym_preproc_nullable] = STATE(895),
    [sym_preproc_error] = STATE(895),
    [sym_preproc_define] = STATE(895),
    [sym_preproc_undef] = STATE(895),
    [aux_sym_class_declaration_repeat1] = STATE(3811),
    [aux_sym_lambda_expression_repeat1] = STATE(4149),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2069),
    [anon_sym_ref] = ACTIONS(2071),
    [anon_sym_LBRACE] = ACTIONS(2767),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1853),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(2075),
    [anon_sym_TILDE] = ACTIONS(2075),
    [anon_sym_PLUS_PLUS] = ACTIONS(2075),
    [anon_sym_DASH_DASH] = ACTIONS(2075),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2073),
    [anon_sym_DASH] = ACTIONS(2073),
    [anon_sym_STAR] = ACTIONS(1859),
    [anon_sym_CARET] = ACTIONS(2075),
    [anon_sym_AMP] = ACTIONS(2075),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2077),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2079),
    [anon_sym_DOT_DOT] = ACTIONS(2081),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [896] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3612),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6894),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2955),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7046),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4996),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(3786),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7408),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9363),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(896),
    [sym_preproc_endregion] = STATE(896),
    [sym_preproc_line] = STATE(896),
    [sym_preproc_pragma] = STATE(896),
    [sym_preproc_nullable] = STATE(896),
    [sym_preproc_error] = STATE(896),
    [sym_preproc_define] = STATE(896),
    [sym_preproc_undef] = STATE(896),
    [aux_sym_class_declaration_repeat1] = STATE(3811),
    [aux_sym_lambda_expression_repeat1] = STATE(4149),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2069),
    [anon_sym_ref] = ACTIONS(2071),
    [anon_sym_LBRACE] = ACTIONS(2767),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1853),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(2075),
    [anon_sym_TILDE] = ACTIONS(2075),
    [anon_sym_PLUS_PLUS] = ACTIONS(2075),
    [anon_sym_DASH_DASH] = ACTIONS(2075),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2073),
    [anon_sym_DASH] = ACTIONS(2073),
    [anon_sym_STAR] = ACTIONS(1859),
    [anon_sym_CARET] = ACTIONS(2075),
    [anon_sym_AMP] = ACTIONS(2075),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2077),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2079),
    [anon_sym_DOT_DOT] = ACTIONS(2081),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [897] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3751),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6980),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6328),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4482),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9438),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(897),
    [sym_preproc_endregion] = STATE(897),
    [sym_preproc_line] = STATE(897),
    [sym_preproc_pragma] = STATE(897),
    [sym_preproc_nullable] = STATE(897),
    [sym_preproc_error] = STATE(897),
    [sym_preproc_define] = STATE(897),
    [sym_preproc_undef] = STATE(897),
    [aux_sym_class_declaration_repeat1] = STATE(3801),
    [aux_sym_lambda_expression_repeat1] = STATE(4134),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1993),
    [anon_sym_ref] = ACTIONS(1995),
    [anon_sym_LBRACE] = ACTIONS(2765),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1999),
    [anon_sym_TILDE] = ACTIONS(1999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1999),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_AMP] = ACTIONS(1999),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1281),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1283),
    [anon_sym_DOT_DOT] = ACTIONS(1285),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [898] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3683),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6894),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2955),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7046),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4980),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(3786),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7408),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9363),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(898),
    [sym_preproc_endregion] = STATE(898),
    [sym_preproc_line] = STATE(898),
    [sym_preproc_pragma] = STATE(898),
    [sym_preproc_nullable] = STATE(898),
    [sym_preproc_error] = STATE(898),
    [sym_preproc_define] = STATE(898),
    [sym_preproc_undef] = STATE(898),
    [aux_sym_class_declaration_repeat1] = STATE(3811),
    [aux_sym_lambda_expression_repeat1] = STATE(4149),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2069),
    [anon_sym_ref] = ACTIONS(2071),
    [anon_sym_LBRACE] = ACTIONS(2767),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1853),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(2075),
    [anon_sym_TILDE] = ACTIONS(2075),
    [anon_sym_PLUS_PLUS] = ACTIONS(2075),
    [anon_sym_DASH_DASH] = ACTIONS(2075),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2073),
    [anon_sym_DASH] = ACTIONS(2073),
    [anon_sym_STAR] = ACTIONS(1859),
    [anon_sym_CARET] = ACTIONS(2075),
    [anon_sym_AMP] = ACTIONS(2075),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2077),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2079),
    [anon_sym_DOT_DOT] = ACTIONS(2081),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [899] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3650),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6894),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2955),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7046),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4978),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(3786),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7408),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9363),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(899),
    [sym_preproc_endregion] = STATE(899),
    [sym_preproc_line] = STATE(899),
    [sym_preproc_pragma] = STATE(899),
    [sym_preproc_nullable] = STATE(899),
    [sym_preproc_error] = STATE(899),
    [sym_preproc_define] = STATE(899),
    [sym_preproc_undef] = STATE(899),
    [aux_sym_class_declaration_repeat1] = STATE(3811),
    [aux_sym_lambda_expression_repeat1] = STATE(4149),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2069),
    [anon_sym_ref] = ACTIONS(2071),
    [anon_sym_LBRACE] = ACTIONS(2767),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1853),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(2075),
    [anon_sym_TILDE] = ACTIONS(2075),
    [anon_sym_PLUS_PLUS] = ACTIONS(2075),
    [anon_sym_DASH_DASH] = ACTIONS(2075),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2073),
    [anon_sym_DASH] = ACTIONS(2073),
    [anon_sym_STAR] = ACTIONS(1859),
    [anon_sym_CARET] = ACTIONS(2075),
    [anon_sym_AMP] = ACTIONS(2075),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2077),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2079),
    [anon_sym_DOT_DOT] = ACTIONS(2081),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [900] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4085),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6967),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5037),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(3858),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7382),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9625),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(900),
    [sym_preproc_endregion] = STATE(900),
    [sym_preproc_line] = STATE(900),
    [sym_preproc_pragma] = STATE(900),
    [sym_preproc_nullable] = STATE(900),
    [sym_preproc_error] = STATE(900),
    [sym_preproc_define] = STATE(900),
    [sym_preproc_undef] = STATE(900),
    [aux_sym_class_declaration_repeat1] = STATE(3851),
    [aux_sym_lambda_expression_repeat1] = STATE(4234),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_ref] = ACTIONS(1293),
    [anon_sym_LBRACE] = ACTIONS(2761),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1059),
    [anon_sym_TILDE] = ACTIONS(1059),
    [anon_sym_PLUS_PLUS] = ACTIONS(1059),
    [anon_sym_DASH_DASH] = ACTIONS(1059),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1061),
    [anon_sym_DASH] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(1303),
    [anon_sym_CARET] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1307),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1309),
    [anon_sym_DOT_DOT] = ACTIONS(1311),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [901] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6685),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2790),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6661),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5700),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4210),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9027),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(901),
    [sym_preproc_endregion] = STATE(901),
    [sym_preproc_line] = STATE(901),
    [sym_preproc_pragma] = STATE(901),
    [sym_preproc_nullable] = STATE(901),
    [sym_preproc_error] = STATE(901),
    [sym_preproc_define] = STATE(901),
    [sym_preproc_undef] = STATE(901),
    [aux_sym_class_declaration_repeat1] = STATE(3852),
    [aux_sym_lambda_expression_repeat1] = STATE(4220),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1473),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_readonly] = ACTIONS(2683),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(1479),
    [anon_sym_PLUS_PLUS] = ACTIONS(1479),
    [anon_sym_DASH_DASH] = ACTIONS(1479),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1477),
    [anon_sym_DASH] = ACTIONS(1477),
    [anon_sym_STAR] = ACTIONS(1101),
    [anon_sym_CARET] = ACTIONS(1479),
    [anon_sym_AMP] = ACTIONS(1479),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1065),
    [anon_sym_var] = ACTIONS(2565),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1111),
    [anon_sym_DOT_DOT] = ACTIONS(1115),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [902] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3559),
    [sym__name] = STATE(6878),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2911),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6938),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4779),
    [sym_non_lvalue_expression] = STATE(4553),
    [sym_lvalue_expression] = STATE(3750),
    [sym__expression_statement_expression] = STATE(4559),
    [sym_assignment_expression] = STATE(4558),
    [sym_binary_expression] = STATE(4559),
    [sym_postfix_unary_expression] = STATE(4558),
    [sym_prefix_unary_expression] = STATE(4558),
    [sym__pointer_indirection_expression] = STATE(3560),
    [sym_query_expression] = STATE(4559),
    [sym_from_clause] = STATE(7406),
    [sym__ordering] = STATE(7553),
    [sym_conditional_expression] = STATE(4559),
    [sym_conditional_access_expression] = STATE(4559),
    [sym_as_expression] = STATE(4559),
    [sym_is_expression] = STATE(4559),
    [sym_is_pattern_expression] = STATE(4559),
    [sym_cast_expression] = STATE(4559),
    [sym_checked_expression] = STATE(4559),
    [sym_invocation_expression] = STATE(4558),
    [sym_switch_expression] = STATE(4559),
    [sym_await_expression] = STATE(4558),
    [sym_throw_expression] = STATE(4559),
    [sym_element_access_expression] = STATE(3560),
    [sym_interpolated_string_expression] = STATE(4559),
    [sym_member_access_expression] = STATE(3560),
    [sym_object_creation_expression] = STATE(4558),
    [sym_parenthesized_expression] = STATE(4558),
    [sym__parenthesized_lvalue_expression] = STATE(3560),
    [sym_lambda_expression] = STATE(4559),
    [sym__lambda_parameters] = STATE(9691),
    [sym_array_creation_expression] = STATE(4559),
    [sym_anonymous_method_expression] = STATE(4559),
    [sym_anonymous_object_creation_expression] = STATE(4559),
    [sym_implicit_array_creation_expression] = STATE(4559),
    [sym_implicit_object_creation_expression] = STATE(4559),
    [sym_implicit_stackalloc_expression] = STATE(4559),
    [sym_initializer_expression] = STATE(4559),
    [sym_default_expression] = STATE(4559),
    [sym_with_expression] = STATE(4559),
    [sym_sizeof_expression] = STATE(4559),
    [sym_typeof_expression] = STATE(4559),
    [sym_makeref_expression] = STATE(4559),
    [sym_ref_expression] = STATE(4559),
    [sym_reftype_expression] = STATE(4559),
    [sym_refvalue_expression] = STATE(4559),
    [sym_stackalloc_expression] = STATE(4559),
    [sym_range_expression] = STATE(4559),
    [sym_tuple_expression] = STATE(3560),
    [sym_literal] = STATE(4559),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4559),
    [sym_preproc_region] = STATE(902),
    [sym_preproc_endregion] = STATE(902),
    [sym_preproc_line] = STATE(902),
    [sym_preproc_pragma] = STATE(902),
    [sym_preproc_nullable] = STATE(902),
    [sym_preproc_error] = STATE(902),
    [sym_preproc_define] = STATE(902),
    [sym_preproc_undef] = STATE(902),
    [aux_sym_class_declaration_repeat1] = STATE(3836),
    [aux_sym_lambda_expression_repeat1] = STATE(4216),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(2003),
    [anon_sym_ref] = ACTIONS(2005),
    [anon_sym_LBRACE] = ACTIONS(1611),
    [anon_sym_delegate] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1615),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(2009),
    [anon_sym_TILDE] = ACTIONS(2009),
    [anon_sym_PLUS_PLUS] = ACTIONS(2009),
    [anon_sym_DASH_DASH] = ACTIONS(2009),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(2007),
    [anon_sym_DASH] = ACTIONS(2007),
    [anon_sym_STAR] = ACTIONS(1625),
    [anon_sym_CARET] = ACTIONS(2009),
    [anon_sym_AMP] = ACTIONS(2009),
    [anon_sym_this] = ACTIONS(1627),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1629),
    [anon_sym_unchecked] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(2011),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2013),
    [anon_sym_DOT_DOT] = ACTIONS(2015),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_stackalloc] = ACTIONS(1641),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(1647),
    [anon_sym___reftype] = ACTIONS(1649),
    [anon_sym___refvalue] = ACTIONS(1651),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1659),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [903] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7076),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5802),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4314),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9775),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(903),
    [sym_preproc_endregion] = STATE(903),
    [sym_preproc_line] = STATE(903),
    [sym_preproc_pragma] = STATE(903),
    [sym_preproc_nullable] = STATE(903),
    [sym_preproc_error] = STATE(903),
    [sym_preproc_define] = STATE(903),
    [sym_preproc_undef] = STATE(903),
    [aux_sym_class_declaration_repeat1] = STATE(3835),
    [aux_sym_lambda_expression_repeat1] = STATE(4236),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(2813),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1535),
    [anon_sym_ref] = ACTIONS(1537),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1465),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(885),
    [anon_sym_TILDE] = ACTIONS(885),
    [anon_sym_PLUS_PLUS] = ACTIONS(885),
    [anon_sym_DASH_DASH] = ACTIONS(885),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(887),
    [anon_sym_DASH] = ACTIONS(887),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(885),
    [anon_sym_AMP] = ACTIONS(885),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1539),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1541),
    [anon_sym_DOT_DOT] = ACTIONS(1543),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [904] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6666),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2811),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(2843),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5825),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(904),
    [sym_preproc_endregion] = STATE(904),
    [sym_preproc_line] = STATE(904),
    [sym_preproc_pragma] = STATE(904),
    [sym_preproc_nullable] = STATE(904),
    [sym_preproc_error] = STATE(904),
    [sym_preproc_define] = STATE(904),
    [sym_preproc_undef] = STATE(904),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_ref] = ACTIONS(2429),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_readonly] = ACTIONS(2795),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1669),
    [anon_sym_TILDE] = ACTIONS(1669),
    [anon_sym_PLUS_PLUS] = ACTIONS(1669),
    [anon_sym_DASH_DASH] = ACTIONS(1669),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1667),
    [anon_sym_DASH] = ACTIONS(1667),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1669),
    [anon_sym_AMP] = ACTIONS(1669),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2265),
    [anon_sym_var] = ACTIONS(2565),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [905] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3751),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6881),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2964),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6972),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6633),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4495),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7398),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9102),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(905),
    [sym_preproc_endregion] = STATE(905),
    [sym_preproc_line] = STATE(905),
    [sym_preproc_pragma] = STATE(905),
    [sym_preproc_nullable] = STATE(905),
    [sym_preproc_error] = STATE(905),
    [sym_preproc_define] = STATE(905),
    [sym_preproc_undef] = STATE(905),
    [aux_sym_class_declaration_repeat1] = STATE(3857),
    [aux_sym_lambda_expression_repeat1] = STATE(4241),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2097),
    [anon_sym_ref] = ACTIONS(2099),
    [anon_sym_LBRACE] = ACTIONS(2765),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2101),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2105),
    [anon_sym_TILDE] = ACTIONS(2105),
    [anon_sym_PLUS_PLUS] = ACTIONS(2105),
    [anon_sym_DASH_DASH] = ACTIONS(2105),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2103),
    [anon_sym_DASH] = ACTIONS(2103),
    [anon_sym_STAR] = ACTIONS(2107),
    [anon_sym_CARET] = ACTIONS(2105),
    [anon_sym_AMP] = ACTIONS(2105),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2111),
    [anon_sym_DOT_DOT] = ACTIONS(2113),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [906] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3767),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6881),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2964),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6972),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6629),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4495),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7398),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9102),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(906),
    [sym_preproc_endregion] = STATE(906),
    [sym_preproc_line] = STATE(906),
    [sym_preproc_pragma] = STATE(906),
    [sym_preproc_nullable] = STATE(906),
    [sym_preproc_error] = STATE(906),
    [sym_preproc_define] = STATE(906),
    [sym_preproc_undef] = STATE(906),
    [aux_sym_class_declaration_repeat1] = STATE(3857),
    [aux_sym_lambda_expression_repeat1] = STATE(4241),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2097),
    [anon_sym_ref] = ACTIONS(2099),
    [anon_sym_LBRACE] = ACTIONS(2765),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2101),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2105),
    [anon_sym_TILDE] = ACTIONS(2105),
    [anon_sym_PLUS_PLUS] = ACTIONS(2105),
    [anon_sym_DASH_DASH] = ACTIONS(2105),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2103),
    [anon_sym_DASH] = ACTIONS(2103),
    [anon_sym_STAR] = ACTIONS(2107),
    [anon_sym_CARET] = ACTIONS(2105),
    [anon_sym_AMP] = ACTIONS(2105),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2111),
    [anon_sym_DOT_DOT] = ACTIONS(2113),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [907] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4617),
    [sym_bracketed_argument_list] = STATE(3559),
    [sym__name] = STATE(6877),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2908),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6958),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4660),
    [sym_non_lvalue_expression] = STATE(4553),
    [sym_lvalue_expression] = STATE(3691),
    [sym__expression_statement_expression] = STATE(4559),
    [sym_assignment_expression] = STATE(4558),
    [sym_binary_expression] = STATE(4559),
    [sym_postfix_unary_expression] = STATE(4558),
    [sym_prefix_unary_expression] = STATE(4558),
    [sym__pointer_indirection_expression] = STATE(3560),
    [sym_query_expression] = STATE(4559),
    [sym_from_clause] = STATE(7406),
    [sym_conditional_expression] = STATE(4559),
    [sym_conditional_access_expression] = STATE(4559),
    [sym_as_expression] = STATE(4559),
    [sym_is_expression] = STATE(4559),
    [sym_is_pattern_expression] = STATE(4559),
    [sym_cast_expression] = STATE(4559),
    [sym_checked_expression] = STATE(4559),
    [sym_invocation_expression] = STATE(4558),
    [sym_switch_expression] = STATE(4559),
    [sym_await_expression] = STATE(4558),
    [sym_throw_expression] = STATE(4559),
    [sym_element_access_expression] = STATE(3560),
    [sym_interpolated_string_expression] = STATE(4559),
    [sym_member_access_expression] = STATE(3560),
    [sym_object_creation_expression] = STATE(4558),
    [sym_parenthesized_expression] = STATE(4558),
    [sym__parenthesized_lvalue_expression] = STATE(3560),
    [sym_lambda_expression] = STATE(4559),
    [sym__lambda_parameters] = STATE(9348),
    [sym_array_creation_expression] = STATE(4559),
    [sym_anonymous_method_expression] = STATE(4559),
    [sym_anonymous_object_creation_expression] = STATE(4559),
    [sym_implicit_array_creation_expression] = STATE(4559),
    [sym_implicit_object_creation_expression] = STATE(4559),
    [sym_implicit_stackalloc_expression] = STATE(4559),
    [sym_initializer_expression] = STATE(4559),
    [sym_default_expression] = STATE(4559),
    [sym_with_expression] = STATE(4559),
    [sym_sizeof_expression] = STATE(4559),
    [sym_typeof_expression] = STATE(4559),
    [sym_makeref_expression] = STATE(4559),
    [sym_ref_expression] = STATE(4559),
    [sym_reftype_expression] = STATE(4559),
    [sym_refvalue_expression] = STATE(4559),
    [sym_stackalloc_expression] = STATE(4559),
    [sym_range_expression] = STATE(4559),
    [sym_tuple_expression] = STATE(3560),
    [sym_literal] = STATE(4559),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4559),
    [sym_preproc_region] = STATE(907),
    [sym_preproc_endregion] = STATE(907),
    [sym_preproc_line] = STATE(907),
    [sym_preproc_pragma] = STATE(907),
    [sym_preproc_nullable] = STATE(907),
    [sym_preproc_error] = STATE(907),
    [sym_preproc_define] = STATE(907),
    [sym_preproc_undef] = STATE(907),
    [aux_sym_class_declaration_repeat1] = STATE(3810),
    [aux_sym_lambda_expression_repeat1] = STATE(4141),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(2047),
    [anon_sym_ref] = ACTIONS(2049),
    [anon_sym_LBRACE] = ACTIONS(2759),
    [anon_sym_delegate] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1679),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(2053),
    [anon_sym_TILDE] = ACTIONS(2053),
    [anon_sym_PLUS_PLUS] = ACTIONS(2053),
    [anon_sym_DASH_DASH] = ACTIONS(2053),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(2051),
    [anon_sym_DASH] = ACTIONS(2051),
    [anon_sym_STAR] = ACTIONS(1685),
    [anon_sym_CARET] = ACTIONS(2053),
    [anon_sym_AMP] = ACTIONS(2053),
    [anon_sym_this] = ACTIONS(1627),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1629),
    [anon_sym_unchecked] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(2055),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2057),
    [anon_sym_DOT_DOT] = ACTIONS(2059),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_stackalloc] = ACTIONS(1641),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(1647),
    [anon_sym___reftype] = ACTIONS(1649),
    [anon_sym___refvalue] = ACTIONS(1651),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1659),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [908] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3738),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6881),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2964),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6972),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6624),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4495),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7398),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9102),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(908),
    [sym_preproc_endregion] = STATE(908),
    [sym_preproc_line] = STATE(908),
    [sym_preproc_pragma] = STATE(908),
    [sym_preproc_nullable] = STATE(908),
    [sym_preproc_error] = STATE(908),
    [sym_preproc_define] = STATE(908),
    [sym_preproc_undef] = STATE(908),
    [aux_sym_class_declaration_repeat1] = STATE(3857),
    [aux_sym_lambda_expression_repeat1] = STATE(4241),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2097),
    [anon_sym_ref] = ACTIONS(2099),
    [anon_sym_LBRACE] = ACTIONS(2765),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2101),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2105),
    [anon_sym_TILDE] = ACTIONS(2105),
    [anon_sym_PLUS_PLUS] = ACTIONS(2105),
    [anon_sym_DASH_DASH] = ACTIONS(2105),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2103),
    [anon_sym_DASH] = ACTIONS(2103),
    [anon_sym_STAR] = ACTIONS(2107),
    [anon_sym_CARET] = ACTIONS(2105),
    [anon_sym_AMP] = ACTIONS(2105),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2111),
    [anon_sym_DOT_DOT] = ACTIONS(2113),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [909] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3650),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6905),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2944),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7006),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6271),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4413),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7404),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9233),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(909),
    [sym_preproc_endregion] = STATE(909),
    [sym_preproc_line] = STATE(909),
    [sym_preproc_pragma] = STATE(909),
    [sym_preproc_nullable] = STATE(909),
    [sym_preproc_error] = STATE(909),
    [sym_preproc_define] = STATE(909),
    [sym_preproc_undef] = STATE(909),
    [aux_sym_class_declaration_repeat1] = STATE(3803),
    [aux_sym_lambda_expression_repeat1] = STATE(4105),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2175),
    [anon_sym_ref] = ACTIONS(2177),
    [anon_sym_LBRACE] = ACTIONS(2767),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2179),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(2183),
    [anon_sym_TILDE] = ACTIONS(2183),
    [anon_sym_PLUS_PLUS] = ACTIONS(2183),
    [anon_sym_DASH_DASH] = ACTIONS(2183),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2181),
    [anon_sym_DASH] = ACTIONS(2181),
    [anon_sym_STAR] = ACTIONS(2185),
    [anon_sym_CARET] = ACTIONS(2183),
    [anon_sym_AMP] = ACTIONS(2183),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2187),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2189),
    [anon_sym_DOT_DOT] = ACTIONS(2191),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [910] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3683),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6905),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2944),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7006),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6270),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4413),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7404),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9233),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(910),
    [sym_preproc_endregion] = STATE(910),
    [sym_preproc_line] = STATE(910),
    [sym_preproc_pragma] = STATE(910),
    [sym_preproc_nullable] = STATE(910),
    [sym_preproc_error] = STATE(910),
    [sym_preproc_define] = STATE(910),
    [sym_preproc_undef] = STATE(910),
    [aux_sym_class_declaration_repeat1] = STATE(3803),
    [aux_sym_lambda_expression_repeat1] = STATE(4105),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2175),
    [anon_sym_ref] = ACTIONS(2177),
    [anon_sym_LBRACE] = ACTIONS(2767),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2179),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(2183),
    [anon_sym_TILDE] = ACTIONS(2183),
    [anon_sym_PLUS_PLUS] = ACTIONS(2183),
    [anon_sym_DASH_DASH] = ACTIONS(2183),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2181),
    [anon_sym_DASH] = ACTIONS(2181),
    [anon_sym_STAR] = ACTIONS(2185),
    [anon_sym_CARET] = ACTIONS(2183),
    [anon_sym_AMP] = ACTIONS(2183),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2187),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2189),
    [anon_sym_DOT_DOT] = ACTIONS(2191),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [911] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3717),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6881),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2964),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6972),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6619),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4495),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7398),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9102),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(911),
    [sym_preproc_endregion] = STATE(911),
    [sym_preproc_line] = STATE(911),
    [sym_preproc_pragma] = STATE(911),
    [sym_preproc_nullable] = STATE(911),
    [sym_preproc_error] = STATE(911),
    [sym_preproc_define] = STATE(911),
    [sym_preproc_undef] = STATE(911),
    [aux_sym_class_declaration_repeat1] = STATE(3857),
    [aux_sym_lambda_expression_repeat1] = STATE(4241),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2097),
    [anon_sym_ref] = ACTIONS(2099),
    [anon_sym_LBRACE] = ACTIONS(2765),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2101),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2105),
    [anon_sym_TILDE] = ACTIONS(2105),
    [anon_sym_PLUS_PLUS] = ACTIONS(2105),
    [anon_sym_DASH_DASH] = ACTIONS(2105),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2103),
    [anon_sym_DASH] = ACTIONS(2103),
    [anon_sym_STAR] = ACTIONS(2107),
    [anon_sym_CARET] = ACTIONS(2105),
    [anon_sym_AMP] = ACTIONS(2105),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2111),
    [anon_sym_DOT_DOT] = ACTIONS(2113),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [912] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3612),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6905),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2944),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7006),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6269),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4413),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7404),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9233),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(912),
    [sym_preproc_endregion] = STATE(912),
    [sym_preproc_line] = STATE(912),
    [sym_preproc_pragma] = STATE(912),
    [sym_preproc_nullable] = STATE(912),
    [sym_preproc_error] = STATE(912),
    [sym_preproc_define] = STATE(912),
    [sym_preproc_undef] = STATE(912),
    [aux_sym_class_declaration_repeat1] = STATE(3803),
    [aux_sym_lambda_expression_repeat1] = STATE(4105),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2175),
    [anon_sym_ref] = ACTIONS(2177),
    [anon_sym_LBRACE] = ACTIONS(2767),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2179),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(2183),
    [anon_sym_TILDE] = ACTIONS(2183),
    [anon_sym_PLUS_PLUS] = ACTIONS(2183),
    [anon_sym_DASH_DASH] = ACTIONS(2183),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2181),
    [anon_sym_DASH] = ACTIONS(2181),
    [anon_sym_STAR] = ACTIONS(2185),
    [anon_sym_CARET] = ACTIONS(2183),
    [anon_sym_AMP] = ACTIONS(2183),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2187),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2189),
    [anon_sym_DOT_DOT] = ACTIONS(2191),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [913] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6961),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6466),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9849),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(913),
    [sym_preproc_endregion] = STATE(913),
    [sym_preproc_line] = STATE(913),
    [sym_preproc_pragma] = STATE(913),
    [sym_preproc_nullable] = STATE(913),
    [sym_preproc_error] = STATE(913),
    [sym_preproc_define] = STATE(913),
    [sym_preproc_undef] = STATE(913),
    [aux_sym_class_declaration_repeat1] = STATE(3841),
    [aux_sym_lambda_expression_repeat1] = STATE(4283),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(2849),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1459),
    [anon_sym_ref] = ACTIONS(1461),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1465),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1467),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1469),
    [anon_sym_DOT_DOT] = ACTIONS(1471),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [914] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3769),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6881),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2964),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6972),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6613),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4495),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7398),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9102),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(914),
    [sym_preproc_endregion] = STATE(914),
    [sym_preproc_line] = STATE(914),
    [sym_preproc_pragma] = STATE(914),
    [sym_preproc_nullable] = STATE(914),
    [sym_preproc_error] = STATE(914),
    [sym_preproc_define] = STATE(914),
    [sym_preproc_undef] = STATE(914),
    [aux_sym_class_declaration_repeat1] = STATE(3857),
    [aux_sym_lambda_expression_repeat1] = STATE(4241),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2097),
    [anon_sym_ref] = ACTIONS(2099),
    [anon_sym_LBRACE] = ACTIONS(2765),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2101),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2105),
    [anon_sym_TILDE] = ACTIONS(2105),
    [anon_sym_PLUS_PLUS] = ACTIONS(2105),
    [anon_sym_DASH_DASH] = ACTIONS(2105),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2103),
    [anon_sym_DASH] = ACTIONS(2103),
    [anon_sym_STAR] = ACTIONS(2107),
    [anon_sym_CARET] = ACTIONS(2105),
    [anon_sym_AMP] = ACTIONS(2105),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2111),
    [anon_sym_DOT_DOT] = ACTIONS(2113),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [915] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3638),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6905),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2944),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7006),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6267),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4413),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7404),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9233),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(915),
    [sym_preproc_endregion] = STATE(915),
    [sym_preproc_line] = STATE(915),
    [sym_preproc_pragma] = STATE(915),
    [sym_preproc_nullable] = STATE(915),
    [sym_preproc_error] = STATE(915),
    [sym_preproc_define] = STATE(915),
    [sym_preproc_undef] = STATE(915),
    [aux_sym_class_declaration_repeat1] = STATE(3803),
    [aux_sym_lambda_expression_repeat1] = STATE(4105),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2175),
    [anon_sym_ref] = ACTIONS(2177),
    [anon_sym_LBRACE] = ACTIONS(2767),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2179),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(2183),
    [anon_sym_TILDE] = ACTIONS(2183),
    [anon_sym_PLUS_PLUS] = ACTIONS(2183),
    [anon_sym_DASH_DASH] = ACTIONS(2183),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2181),
    [anon_sym_DASH] = ACTIONS(2181),
    [anon_sym_STAR] = ACTIONS(2185),
    [anon_sym_CARET] = ACTIONS(2183),
    [anon_sym_AMP] = ACTIONS(2183),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2187),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2189),
    [anon_sym_DOT_DOT] = ACTIONS(2191),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [916] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3726),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6881),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2964),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6972),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6603),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4495),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7398),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9102),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(916),
    [sym_preproc_endregion] = STATE(916),
    [sym_preproc_line] = STATE(916),
    [sym_preproc_pragma] = STATE(916),
    [sym_preproc_nullable] = STATE(916),
    [sym_preproc_error] = STATE(916),
    [sym_preproc_define] = STATE(916),
    [sym_preproc_undef] = STATE(916),
    [aux_sym_class_declaration_repeat1] = STATE(3857),
    [aux_sym_lambda_expression_repeat1] = STATE(4241),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2097),
    [anon_sym_ref] = ACTIONS(2099),
    [anon_sym_LBRACE] = ACTIONS(2765),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2101),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2105),
    [anon_sym_TILDE] = ACTIONS(2105),
    [anon_sym_PLUS_PLUS] = ACTIONS(2105),
    [anon_sym_DASH_DASH] = ACTIONS(2105),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2103),
    [anon_sym_DASH] = ACTIONS(2103),
    [anon_sym_STAR] = ACTIONS(2107),
    [anon_sym_CARET] = ACTIONS(2105),
    [anon_sym_AMP] = ACTIONS(2105),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2111),
    [anon_sym_DOT_DOT] = ACTIONS(2113),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [917] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4132),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6967),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5036),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(3858),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7382),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9625),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(917),
    [sym_preproc_endregion] = STATE(917),
    [sym_preproc_line] = STATE(917),
    [sym_preproc_pragma] = STATE(917),
    [sym_preproc_nullable] = STATE(917),
    [sym_preproc_error] = STATE(917),
    [sym_preproc_define] = STATE(917),
    [sym_preproc_undef] = STATE(917),
    [aux_sym_class_declaration_repeat1] = STATE(3851),
    [aux_sym_lambda_expression_repeat1] = STATE(4234),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_ref] = ACTIONS(1293),
    [anon_sym_LBRACE] = ACTIONS(2761),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1059),
    [anon_sym_TILDE] = ACTIONS(1059),
    [anon_sym_PLUS_PLUS] = ACTIONS(1059),
    [anon_sym_DASH_DASH] = ACTIONS(1059),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1061),
    [anon_sym_DASH] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(1303),
    [anon_sym_CARET] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1307),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1309),
    [anon_sym_DOT_DOT] = ACTIONS(1311),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [918] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3921),
    [sym__name] = STATE(6889),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2854),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(7005),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5418),
    [sym_non_lvalue_expression] = STATE(5735),
    [sym_lvalue_expression] = STATE(4295),
    [sym__expression_statement_expression] = STATE(5733),
    [sym_assignment_expression] = STATE(5734),
    [sym_binary_expression] = STATE(5733),
    [sym_postfix_unary_expression] = STATE(5734),
    [sym_prefix_unary_expression] = STATE(5734),
    [sym__pointer_indirection_expression] = STATE(3911),
    [sym_query_expression] = STATE(5733),
    [sym_from_clause] = STATE(7393),
    [sym_conditional_expression] = STATE(5733),
    [sym_conditional_access_expression] = STATE(5733),
    [sym_as_expression] = STATE(5733),
    [sym_is_expression] = STATE(5733),
    [sym_is_pattern_expression] = STATE(5733),
    [sym_cast_expression] = STATE(5733),
    [sym_checked_expression] = STATE(5733),
    [sym_invocation_expression] = STATE(5734),
    [sym_switch_expression] = STATE(5733),
    [sym_await_expression] = STATE(5734),
    [sym_throw_expression] = STATE(5733),
    [sym_element_access_expression] = STATE(3911),
    [sym_interpolated_string_expression] = STATE(5733),
    [sym_member_access_expression] = STATE(3911),
    [sym_object_creation_expression] = STATE(5734),
    [sym_parenthesized_expression] = STATE(5734),
    [sym__parenthesized_lvalue_expression] = STATE(3911),
    [sym_lambda_expression] = STATE(5733),
    [sym__lambda_parameters] = STATE(9313),
    [sym_array_creation_expression] = STATE(5733),
    [sym_anonymous_method_expression] = STATE(5733),
    [sym_anonymous_object_creation_expression] = STATE(5733),
    [sym_implicit_array_creation_expression] = STATE(5733),
    [sym_implicit_object_creation_expression] = STATE(5733),
    [sym_implicit_stackalloc_expression] = STATE(5733),
    [sym_initializer_expression] = STATE(5733),
    [sym_default_expression] = STATE(5733),
    [sym_with_expression] = STATE(5733),
    [sym_sizeof_expression] = STATE(5733),
    [sym_typeof_expression] = STATE(5733),
    [sym_makeref_expression] = STATE(5733),
    [sym_ref_expression] = STATE(5733),
    [sym_reftype_expression] = STATE(5733),
    [sym_refvalue_expression] = STATE(5733),
    [sym_stackalloc_expression] = STATE(5733),
    [sym_range_expression] = STATE(5733),
    [sym_tuple_expression] = STATE(3911),
    [sym_literal] = STATE(5733),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2798),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(5733),
    [sym_preproc_region] = STATE(918),
    [sym_preproc_endregion] = STATE(918),
    [sym_preproc_line] = STATE(918),
    [sym_preproc_pragma] = STATE(918),
    [sym_preproc_nullable] = STATE(918),
    [sym_preproc_error] = STATE(918),
    [sym_preproc_define] = STATE(918),
    [sym_preproc_undef] = STATE(918),
    [aux_sym_class_declaration_repeat1] = STATE(3805),
    [aux_sym_lambda_expression_repeat1] = STATE(4122),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_LPAREN] = ACTIONS(1591),
    [anon_sym_ref] = ACTIONS(1593),
    [anon_sym_LBRACE] = ACTIONS(1377),
    [anon_sym_delegate] = ACTIONS(1379),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1443),
    [anon_sym_readonly] = ACTIONS(2693),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1597),
    [anon_sym_TILDE] = ACTIONS(1597),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1595),
    [anon_sym_DASH] = ACTIONS(1595),
    [anon_sym_STAR] = ACTIONS(1449),
    [anon_sym_CARET] = ACTIONS(1597),
    [anon_sym_AMP] = ACTIONS(1597),
    [anon_sym_this] = ACTIONS(1393),
    [anon_sym_scoped] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1397),
    [sym_predefined_type] = ACTIONS(1399),
    [anon_sym_unchecked] = ACTIONS(1383),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1599),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1601),
    [anon_sym_DOT_DOT] = ACTIONS(1603),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_stackalloc] = ACTIONS(1413),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(1419),
    [anon_sym___reftype] = ACTIONS(1421),
    [anon_sym___refvalue] = ACTIONS(1423),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
  },
  [919] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3632),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6905),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2944),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7006),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6265),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4413),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7404),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9233),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(919),
    [sym_preproc_endregion] = STATE(919),
    [sym_preproc_line] = STATE(919),
    [sym_preproc_pragma] = STATE(919),
    [sym_preproc_nullable] = STATE(919),
    [sym_preproc_error] = STATE(919),
    [sym_preproc_define] = STATE(919),
    [sym_preproc_undef] = STATE(919),
    [aux_sym_class_declaration_repeat1] = STATE(3803),
    [aux_sym_lambda_expression_repeat1] = STATE(4105),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2175),
    [anon_sym_ref] = ACTIONS(2177),
    [anon_sym_LBRACE] = ACTIONS(2767),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2179),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(2183),
    [anon_sym_TILDE] = ACTIONS(2183),
    [anon_sym_PLUS_PLUS] = ACTIONS(2183),
    [anon_sym_DASH_DASH] = ACTIONS(2183),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2181),
    [anon_sym_DASH] = ACTIONS(2181),
    [anon_sym_STAR] = ACTIONS(2185),
    [anon_sym_CARET] = ACTIONS(2183),
    [anon_sym_AMP] = ACTIONS(2183),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2187),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2189),
    [anon_sym_DOT_DOT] = ACTIONS(2191),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [920] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3615),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6905),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2944),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7006),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6264),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4413),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7404),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9233),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(920),
    [sym_preproc_endregion] = STATE(920),
    [sym_preproc_line] = STATE(920),
    [sym_preproc_pragma] = STATE(920),
    [sym_preproc_nullable] = STATE(920),
    [sym_preproc_error] = STATE(920),
    [sym_preproc_define] = STATE(920),
    [sym_preproc_undef] = STATE(920),
    [aux_sym_class_declaration_repeat1] = STATE(3803),
    [aux_sym_lambda_expression_repeat1] = STATE(4105),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2175),
    [anon_sym_ref] = ACTIONS(2177),
    [anon_sym_LBRACE] = ACTIONS(2767),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2179),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(2183),
    [anon_sym_TILDE] = ACTIONS(2183),
    [anon_sym_PLUS_PLUS] = ACTIONS(2183),
    [anon_sym_DASH_DASH] = ACTIONS(2183),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2181),
    [anon_sym_DASH] = ACTIONS(2181),
    [anon_sym_STAR] = ACTIONS(2185),
    [anon_sym_CARET] = ACTIONS(2183),
    [anon_sym_AMP] = ACTIONS(2183),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2187),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2189),
    [anon_sym_DOT_DOT] = ACTIONS(2191),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [921] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4007),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6914),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2882),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6963),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5341),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4002),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7386),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9254),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(921),
    [sym_preproc_endregion] = STATE(921),
    [sym_preproc_line] = STATE(921),
    [sym_preproc_pragma] = STATE(921),
    [sym_preproc_nullable] = STATE(921),
    [sym_preproc_error] = STATE(921),
    [sym_preproc_define] = STATE(921),
    [sym_preproc_undef] = STATE(921),
    [aux_sym_class_declaration_repeat1] = STATE(3797),
    [aux_sym_lambda_expression_repeat1] = STATE(4081),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1727),
    [anon_sym_ref] = ACTIONS(1729),
    [anon_sym_LBRACE] = ACTIONS(2833),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1713),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1733),
    [anon_sym_TILDE] = ACTIONS(1733),
    [anon_sym_PLUS_PLUS] = ACTIONS(1733),
    [anon_sym_DASH_DASH] = ACTIONS(1733),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1731),
    [anon_sym_DASH] = ACTIONS(1731),
    [anon_sym_STAR] = ACTIONS(1735),
    [anon_sym_CARET] = ACTIONS(1733),
    [anon_sym_AMP] = ACTIONS(1733),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1737),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1739),
    [anon_sym_DOT_DOT] = ACTIONS(1741),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [922] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6905),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2944),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7008),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6203),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4413),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7404),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9233),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(922),
    [sym_preproc_endregion] = STATE(922),
    [sym_preproc_line] = STATE(922),
    [sym_preproc_pragma] = STATE(922),
    [sym_preproc_nullable] = STATE(922),
    [sym_preproc_error] = STATE(922),
    [sym_preproc_define] = STATE(922),
    [sym_preproc_undef] = STATE(922),
    [aux_sym_class_declaration_repeat1] = STATE(3803),
    [aux_sym_lambda_expression_repeat1] = STATE(4105),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2175),
    [anon_sym_ref] = ACTIONS(2177),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2179),
    [anon_sym_readonly] = ACTIONS(2693),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(2183),
    [anon_sym_TILDE] = ACTIONS(2183),
    [anon_sym_PLUS_PLUS] = ACTIONS(2183),
    [anon_sym_DASH_DASH] = ACTIONS(2183),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2181),
    [anon_sym_DASH] = ACTIONS(2181),
    [anon_sym_STAR] = ACTIONS(2185),
    [anon_sym_CARET] = ACTIONS(2183),
    [anon_sym_AMP] = ACTIONS(2183),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2187),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2189),
    [anon_sym_DOT_DOT] = ACTIONS(2191),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [923] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6961),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6318),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9849),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(923),
    [sym_preproc_endregion] = STATE(923),
    [sym_preproc_line] = STATE(923),
    [sym_preproc_pragma] = STATE(923),
    [sym_preproc_nullable] = STATE(923),
    [sym_preproc_error] = STATE(923),
    [sym_preproc_define] = STATE(923),
    [sym_preproc_undef] = STATE(923),
    [aux_sym_class_declaration_repeat1] = STATE(3841),
    [aux_sym_lambda_expression_repeat1] = STATE(4283),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(2851),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1459),
    [anon_sym_ref] = ACTIONS(1461),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1465),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1467),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1469),
    [anon_sym_DOT_DOT] = ACTIONS(1471),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [924] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(2995),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2751),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(2843),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(2975),
    [sym__array_base_type] = STATE(8712),
    [sym_nullable_type] = STATE(2974),
    [sym_pointer_type] = STATE(2974),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(2974),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(2973),
    [sym_expression] = STATE(5825),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2810),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(924),
    [sym_preproc_endregion] = STATE(924),
    [sym_preproc_line] = STATE(924),
    [sym_preproc_pragma] = STATE(924),
    [sym_preproc_nullable] = STATE(924),
    [sym_preproc_error] = STATE(924),
    [sym_preproc_define] = STATE(924),
    [sym_preproc_undef] = STATE(924),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2789),
    [anon_sym_ref] = ACTIONS(2391),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_readonly] = ACTIONS(2853),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1669),
    [anon_sym_TILDE] = ACTIONS(1669),
    [anon_sym_PLUS_PLUS] = ACTIONS(1669),
    [anon_sym_DASH_DASH] = ACTIONS(1669),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1667),
    [anon_sym_DASH] = ACTIONS(1667),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1669),
    [anon_sym_AMP] = ACTIONS(1669),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2295),
    [anon_sym_var] = ACTIONS(2855),
    [sym_predefined_type] = ACTIONS(2313),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [925] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4065),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6914),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2882),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6963),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5308),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4002),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7386),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9254),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(925),
    [sym_preproc_endregion] = STATE(925),
    [sym_preproc_line] = STATE(925),
    [sym_preproc_pragma] = STATE(925),
    [sym_preproc_nullable] = STATE(925),
    [sym_preproc_error] = STATE(925),
    [sym_preproc_define] = STATE(925),
    [sym_preproc_undef] = STATE(925),
    [aux_sym_class_declaration_repeat1] = STATE(3797),
    [aux_sym_lambda_expression_repeat1] = STATE(4081),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1727),
    [anon_sym_ref] = ACTIONS(1729),
    [anon_sym_LBRACE] = ACTIONS(2833),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1713),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1733),
    [anon_sym_TILDE] = ACTIONS(1733),
    [anon_sym_PLUS_PLUS] = ACTIONS(1733),
    [anon_sym_DASH_DASH] = ACTIONS(1733),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1731),
    [anon_sym_DASH] = ACTIONS(1731),
    [anon_sym_STAR] = ACTIONS(1735),
    [anon_sym_CARET] = ACTIONS(1733),
    [anon_sym_AMP] = ACTIONS(1733),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1737),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1739),
    [anon_sym_DOT_DOT] = ACTIONS(1741),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [926] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4050),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6914),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2882),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6963),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5345),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4002),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7386),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9254),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(926),
    [sym_preproc_endregion] = STATE(926),
    [sym_preproc_line] = STATE(926),
    [sym_preproc_pragma] = STATE(926),
    [sym_preproc_nullable] = STATE(926),
    [sym_preproc_error] = STATE(926),
    [sym_preproc_define] = STATE(926),
    [sym_preproc_undef] = STATE(926),
    [aux_sym_class_declaration_repeat1] = STATE(3797),
    [aux_sym_lambda_expression_repeat1] = STATE(4081),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1727),
    [anon_sym_ref] = ACTIONS(1729),
    [anon_sym_LBRACE] = ACTIONS(2833),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1713),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1733),
    [anon_sym_TILDE] = ACTIONS(1733),
    [anon_sym_PLUS_PLUS] = ACTIONS(1733),
    [anon_sym_DASH_DASH] = ACTIONS(1733),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1731),
    [anon_sym_DASH] = ACTIONS(1731),
    [anon_sym_STAR] = ACTIONS(1735),
    [anon_sym_CARET] = ACTIONS(1733),
    [anon_sym_AMP] = ACTIONS(1733),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1737),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1739),
    [anon_sym_DOT_DOT] = ACTIONS(1741),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [927] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4188),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6909),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2874),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7062),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5471),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4291),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7411),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9300),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(927),
    [sym_preproc_endregion] = STATE(927),
    [sym_preproc_line] = STATE(927),
    [sym_preproc_pragma] = STATE(927),
    [sym_preproc_nullable] = STATE(927),
    [sym_preproc_error] = STATE(927),
    [sym_preproc_define] = STATE(927),
    [sym_preproc_undef] = STATE(927),
    [aux_sym_class_declaration_repeat1] = STATE(3804),
    [aux_sym_lambda_expression_repeat1] = STATE(4114),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1501),
    [anon_sym_ref] = ACTIONS(1503),
    [anon_sym_LBRACE] = ACTIONS(2761),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1505),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1509),
    [anon_sym_PLUS_PLUS] = ACTIONS(1509),
    [anon_sym_DASH_DASH] = ACTIONS(1509),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1507),
    [anon_sym_DASH] = ACTIONS(1507),
    [anon_sym_STAR] = ACTIONS(1511),
    [anon_sym_CARET] = ACTIONS(1509),
    [anon_sym_AMP] = ACTIONS(1509),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1513),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1515),
    [anon_sym_DOT_DOT] = ACTIONS(1517),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [928] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3726),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7076),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5809),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4314),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9775),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(928),
    [sym_preproc_endregion] = STATE(928),
    [sym_preproc_line] = STATE(928),
    [sym_preproc_pragma] = STATE(928),
    [sym_preproc_nullable] = STATE(928),
    [sym_preproc_error] = STATE(928),
    [sym_preproc_define] = STATE(928),
    [sym_preproc_undef] = STATE(928),
    [aux_sym_class_declaration_repeat1] = STATE(3835),
    [aux_sym_lambda_expression_repeat1] = STATE(4236),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1535),
    [anon_sym_ref] = ACTIONS(1537),
    [anon_sym_LBRACE] = ACTIONS(2765),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1465),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(885),
    [anon_sym_TILDE] = ACTIONS(885),
    [anon_sym_PLUS_PLUS] = ACTIONS(885),
    [anon_sym_DASH_DASH] = ACTIONS(885),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(887),
    [anon_sym_DASH] = ACTIONS(887),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(885),
    [anon_sym_AMP] = ACTIONS(885),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1539),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1541),
    [anon_sym_DOT_DOT] = ACTIONS(1543),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [929] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4116),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6909),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2874),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7062),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5478),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4291),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7411),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9300),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(929),
    [sym_preproc_endregion] = STATE(929),
    [sym_preproc_line] = STATE(929),
    [sym_preproc_pragma] = STATE(929),
    [sym_preproc_nullable] = STATE(929),
    [sym_preproc_error] = STATE(929),
    [sym_preproc_define] = STATE(929),
    [sym_preproc_undef] = STATE(929),
    [aux_sym_class_declaration_repeat1] = STATE(3804),
    [aux_sym_lambda_expression_repeat1] = STATE(4114),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1501),
    [anon_sym_ref] = ACTIONS(1503),
    [anon_sym_LBRACE] = ACTIONS(2761),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1505),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1509),
    [anon_sym_PLUS_PLUS] = ACTIONS(1509),
    [anon_sym_DASH_DASH] = ACTIONS(1509),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1507),
    [anon_sym_DASH] = ACTIONS(1507),
    [anon_sym_STAR] = ACTIONS(1511),
    [anon_sym_CARET] = ACTIONS(1509),
    [anon_sym_AMP] = ACTIONS(1509),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1513),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1515),
    [anon_sym_DOT_DOT] = ACTIONS(1517),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [930] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4688),
    [sym_bracketed_argument_list] = STATE(3559),
    [sym__name] = STATE(6878),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2911),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6938),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4843),
    [sym_non_lvalue_expression] = STATE(4553),
    [sym_lvalue_expression] = STATE(3750),
    [sym__expression_statement_expression] = STATE(4559),
    [sym_assignment_expression] = STATE(4558),
    [sym_binary_expression] = STATE(4559),
    [sym_postfix_unary_expression] = STATE(4558),
    [sym_prefix_unary_expression] = STATE(4558),
    [sym__pointer_indirection_expression] = STATE(3560),
    [sym_query_expression] = STATE(4559),
    [sym_from_clause] = STATE(7406),
    [sym_conditional_expression] = STATE(4559),
    [sym_conditional_access_expression] = STATE(4559),
    [sym_as_expression] = STATE(4559),
    [sym_is_expression] = STATE(4559),
    [sym_is_pattern_expression] = STATE(4559),
    [sym_cast_expression] = STATE(4559),
    [sym_checked_expression] = STATE(4559),
    [sym_invocation_expression] = STATE(4558),
    [sym_switch_expression] = STATE(4559),
    [sym_await_expression] = STATE(4558),
    [sym_throw_expression] = STATE(4559),
    [sym_element_access_expression] = STATE(3560),
    [sym_interpolated_string_expression] = STATE(4559),
    [sym_member_access_expression] = STATE(3560),
    [sym_object_creation_expression] = STATE(4558),
    [sym_parenthesized_expression] = STATE(4558),
    [sym__parenthesized_lvalue_expression] = STATE(3560),
    [sym_lambda_expression] = STATE(4559),
    [sym__lambda_parameters] = STATE(9691),
    [sym_array_creation_expression] = STATE(4559),
    [sym_anonymous_method_expression] = STATE(4559),
    [sym_anonymous_object_creation_expression] = STATE(4559),
    [sym_implicit_array_creation_expression] = STATE(4559),
    [sym_implicit_object_creation_expression] = STATE(4559),
    [sym_implicit_stackalloc_expression] = STATE(4559),
    [sym_initializer_expression] = STATE(4559),
    [sym_default_expression] = STATE(4559),
    [sym_with_expression] = STATE(4559),
    [sym_sizeof_expression] = STATE(4559),
    [sym_typeof_expression] = STATE(4559),
    [sym_makeref_expression] = STATE(4559),
    [sym_ref_expression] = STATE(4559),
    [sym_reftype_expression] = STATE(4559),
    [sym_refvalue_expression] = STATE(4559),
    [sym_stackalloc_expression] = STATE(4559),
    [sym_range_expression] = STATE(4559),
    [sym_tuple_expression] = STATE(3560),
    [sym_literal] = STATE(4559),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4559),
    [sym_preproc_region] = STATE(930),
    [sym_preproc_endregion] = STATE(930),
    [sym_preproc_line] = STATE(930),
    [sym_preproc_pragma] = STATE(930),
    [sym_preproc_nullable] = STATE(930),
    [sym_preproc_error] = STATE(930),
    [sym_preproc_define] = STATE(930),
    [sym_preproc_undef] = STATE(930),
    [aux_sym_class_declaration_repeat1] = STATE(3836),
    [aux_sym_lambda_expression_repeat1] = STATE(4216),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(2003),
    [anon_sym_ref] = ACTIONS(2005),
    [anon_sym_LBRACE] = ACTIONS(2759),
    [anon_sym_delegate] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1615),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(2009),
    [anon_sym_TILDE] = ACTIONS(2009),
    [anon_sym_PLUS_PLUS] = ACTIONS(2009),
    [anon_sym_DASH_DASH] = ACTIONS(2009),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(2007),
    [anon_sym_DASH] = ACTIONS(2007),
    [anon_sym_STAR] = ACTIONS(1625),
    [anon_sym_CARET] = ACTIONS(2009),
    [anon_sym_AMP] = ACTIONS(2009),
    [anon_sym_this] = ACTIONS(1627),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1629),
    [anon_sym_unchecked] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(2011),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2013),
    [anon_sym_DOT_DOT] = ACTIONS(2015),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_stackalloc] = ACTIONS(1641),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(1647),
    [anon_sym___reftype] = ACTIONS(1649),
    [anon_sym___refvalue] = ACTIONS(1651),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1659),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [931] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4066),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6909),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2874),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7062),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5493),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4291),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7411),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9300),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(931),
    [sym_preproc_endregion] = STATE(931),
    [sym_preproc_line] = STATE(931),
    [sym_preproc_pragma] = STATE(931),
    [sym_preproc_nullable] = STATE(931),
    [sym_preproc_error] = STATE(931),
    [sym_preproc_define] = STATE(931),
    [sym_preproc_undef] = STATE(931),
    [aux_sym_class_declaration_repeat1] = STATE(3804),
    [aux_sym_lambda_expression_repeat1] = STATE(4114),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1501),
    [anon_sym_ref] = ACTIONS(1503),
    [anon_sym_LBRACE] = ACTIONS(2761),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1505),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1509),
    [anon_sym_PLUS_PLUS] = ACTIONS(1509),
    [anon_sym_DASH_DASH] = ACTIONS(1509),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1507),
    [anon_sym_DASH] = ACTIONS(1507),
    [anon_sym_STAR] = ACTIONS(1511),
    [anon_sym_CARET] = ACTIONS(1509),
    [anon_sym_AMP] = ACTIONS(1509),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1513),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1515),
    [anon_sym_DOT_DOT] = ACTIONS(1517),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [932] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4085),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6909),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2874),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7062),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5500),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4291),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7411),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9300),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(932),
    [sym_preproc_endregion] = STATE(932),
    [sym_preproc_line] = STATE(932),
    [sym_preproc_pragma] = STATE(932),
    [sym_preproc_nullable] = STATE(932),
    [sym_preproc_error] = STATE(932),
    [sym_preproc_define] = STATE(932),
    [sym_preproc_undef] = STATE(932),
    [aux_sym_class_declaration_repeat1] = STATE(3804),
    [aux_sym_lambda_expression_repeat1] = STATE(4114),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1501),
    [anon_sym_ref] = ACTIONS(1503),
    [anon_sym_LBRACE] = ACTIONS(2761),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1505),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1509),
    [anon_sym_PLUS_PLUS] = ACTIONS(1509),
    [anon_sym_DASH_DASH] = ACTIONS(1509),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1507),
    [anon_sym_DASH] = ACTIONS(1507),
    [anon_sym_STAR] = ACTIONS(1511),
    [anon_sym_CARET] = ACTIONS(1509),
    [anon_sym_AMP] = ACTIONS(1509),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1513),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1515),
    [anon_sym_DOT_DOT] = ACTIONS(1517),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [933] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4132),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6909),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2874),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7062),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5504),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4291),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7411),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9300),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(933),
    [sym_preproc_endregion] = STATE(933),
    [sym_preproc_line] = STATE(933),
    [sym_preproc_pragma] = STATE(933),
    [sym_preproc_nullable] = STATE(933),
    [sym_preproc_error] = STATE(933),
    [sym_preproc_define] = STATE(933),
    [sym_preproc_undef] = STATE(933),
    [aux_sym_class_declaration_repeat1] = STATE(3804),
    [aux_sym_lambda_expression_repeat1] = STATE(4114),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1501),
    [anon_sym_ref] = ACTIONS(1503),
    [anon_sym_LBRACE] = ACTIONS(2761),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1505),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1509),
    [anon_sym_PLUS_PLUS] = ACTIONS(1509),
    [anon_sym_DASH_DASH] = ACTIONS(1509),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1507),
    [anon_sym_DASH] = ACTIONS(1507),
    [anon_sym_STAR] = ACTIONS(1511),
    [anon_sym_CARET] = ACTIONS(1509),
    [anon_sym_AMP] = ACTIONS(1509),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1513),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1515),
    [anon_sym_DOT_DOT] = ACTIONS(1517),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [934] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6961),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6623),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9849),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(934),
    [sym_preproc_endregion] = STATE(934),
    [sym_preproc_line] = STATE(934),
    [sym_preproc_pragma] = STATE(934),
    [sym_preproc_nullable] = STATE(934),
    [sym_preproc_error] = STATE(934),
    [sym_preproc_define] = STATE(934),
    [sym_preproc_undef] = STATE(934),
    [aux_sym_class_declaration_repeat1] = STATE(3841),
    [aux_sym_lambda_expression_repeat1] = STATE(4283),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(2029),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1459),
    [anon_sym_ref] = ACTIONS(1461),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1465),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1467),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1469),
    [anon_sym_DOT_DOT] = ACTIONS(1471),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [935] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(2995),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2751),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(2843),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(2975),
    [sym__array_base_type] = STATE(8712),
    [sym_nullable_type] = STATE(2974),
    [sym_pointer_type] = STATE(2974),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(2974),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(2973),
    [sym_expression] = STATE(5825),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2742),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(935),
    [sym_preproc_endregion] = STATE(935),
    [sym_preproc_line] = STATE(935),
    [sym_preproc_pragma] = STATE(935),
    [sym_preproc_nullable] = STATE(935),
    [sym_preproc_error] = STATE(935),
    [sym_preproc_define] = STATE(935),
    [sym_preproc_undef] = STATE(935),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2789),
    [anon_sym_ref] = ACTIONS(2287),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_readonly] = ACTIONS(2853),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1669),
    [anon_sym_TILDE] = ACTIONS(1669),
    [anon_sym_PLUS_PLUS] = ACTIONS(1669),
    [anon_sym_DASH_DASH] = ACTIONS(1669),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1667),
    [anon_sym_DASH] = ACTIONS(1667),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1669),
    [anon_sym_AMP] = ACTIONS(1669),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2295),
    [anon_sym_var] = ACTIONS(2793),
    [sym_predefined_type] = ACTIONS(2313),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [936] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4641),
    [sym_bracketed_argument_list] = STATE(3559),
    [sym__name] = STATE(6878),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2911),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6938),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4873),
    [sym_non_lvalue_expression] = STATE(4553),
    [sym_lvalue_expression] = STATE(3750),
    [sym__expression_statement_expression] = STATE(4559),
    [sym_assignment_expression] = STATE(4558),
    [sym_binary_expression] = STATE(4559),
    [sym_postfix_unary_expression] = STATE(4558),
    [sym_prefix_unary_expression] = STATE(4558),
    [sym__pointer_indirection_expression] = STATE(3560),
    [sym_query_expression] = STATE(4559),
    [sym_from_clause] = STATE(7406),
    [sym_conditional_expression] = STATE(4559),
    [sym_conditional_access_expression] = STATE(4559),
    [sym_as_expression] = STATE(4559),
    [sym_is_expression] = STATE(4559),
    [sym_is_pattern_expression] = STATE(4559),
    [sym_cast_expression] = STATE(4559),
    [sym_checked_expression] = STATE(4559),
    [sym_invocation_expression] = STATE(4558),
    [sym_switch_expression] = STATE(4559),
    [sym_await_expression] = STATE(4558),
    [sym_throw_expression] = STATE(4559),
    [sym_element_access_expression] = STATE(3560),
    [sym_interpolated_string_expression] = STATE(4559),
    [sym_member_access_expression] = STATE(3560),
    [sym_object_creation_expression] = STATE(4558),
    [sym_parenthesized_expression] = STATE(4558),
    [sym__parenthesized_lvalue_expression] = STATE(3560),
    [sym_lambda_expression] = STATE(4559),
    [sym__lambda_parameters] = STATE(9691),
    [sym_array_creation_expression] = STATE(4559),
    [sym_anonymous_method_expression] = STATE(4559),
    [sym_anonymous_object_creation_expression] = STATE(4559),
    [sym_implicit_array_creation_expression] = STATE(4559),
    [sym_implicit_object_creation_expression] = STATE(4559),
    [sym_implicit_stackalloc_expression] = STATE(4559),
    [sym_initializer_expression] = STATE(4559),
    [sym_default_expression] = STATE(4559),
    [sym_with_expression] = STATE(4559),
    [sym_sizeof_expression] = STATE(4559),
    [sym_typeof_expression] = STATE(4559),
    [sym_makeref_expression] = STATE(4559),
    [sym_ref_expression] = STATE(4559),
    [sym_reftype_expression] = STATE(4559),
    [sym_refvalue_expression] = STATE(4559),
    [sym_stackalloc_expression] = STATE(4559),
    [sym_range_expression] = STATE(4559),
    [sym_tuple_expression] = STATE(3560),
    [sym_literal] = STATE(4559),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4559),
    [sym_preproc_region] = STATE(936),
    [sym_preproc_endregion] = STATE(936),
    [sym_preproc_line] = STATE(936),
    [sym_preproc_pragma] = STATE(936),
    [sym_preproc_nullable] = STATE(936),
    [sym_preproc_error] = STATE(936),
    [sym_preproc_define] = STATE(936),
    [sym_preproc_undef] = STATE(936),
    [aux_sym_class_declaration_repeat1] = STATE(3836),
    [aux_sym_lambda_expression_repeat1] = STATE(4216),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(2003),
    [anon_sym_ref] = ACTIONS(2005),
    [anon_sym_LBRACE] = ACTIONS(2759),
    [anon_sym_delegate] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1615),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(2009),
    [anon_sym_TILDE] = ACTIONS(2009),
    [anon_sym_PLUS_PLUS] = ACTIONS(2009),
    [anon_sym_DASH_DASH] = ACTIONS(2009),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(2007),
    [anon_sym_DASH] = ACTIONS(2007),
    [anon_sym_STAR] = ACTIONS(1625),
    [anon_sym_CARET] = ACTIONS(2009),
    [anon_sym_AMP] = ACTIONS(2009),
    [anon_sym_this] = ACTIONS(1627),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1629),
    [anon_sym_unchecked] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(2011),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2013),
    [anon_sym_DOT_DOT] = ACTIONS(2015),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_stackalloc] = ACTIONS(1641),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(1647),
    [anon_sym___reftype] = ACTIONS(1649),
    [anon_sym___refvalue] = ACTIONS(1651),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1659),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [937] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3559),
    [sym__name] = STATE(6878),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2911),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6938),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4779),
    [sym_non_lvalue_expression] = STATE(4553),
    [sym_lvalue_expression] = STATE(3750),
    [sym__expression_statement_expression] = STATE(4559),
    [sym_assignment_expression] = STATE(4558),
    [sym_binary_expression] = STATE(4559),
    [sym_postfix_unary_expression] = STATE(4558),
    [sym_prefix_unary_expression] = STATE(4558),
    [sym__pointer_indirection_expression] = STATE(3560),
    [sym_query_expression] = STATE(4559),
    [sym_from_clause] = STATE(7406),
    [sym__ordering] = STATE(7643),
    [sym_conditional_expression] = STATE(4559),
    [sym_conditional_access_expression] = STATE(4559),
    [sym_as_expression] = STATE(4559),
    [sym_is_expression] = STATE(4559),
    [sym_is_pattern_expression] = STATE(4559),
    [sym_cast_expression] = STATE(4559),
    [sym_checked_expression] = STATE(4559),
    [sym_invocation_expression] = STATE(4558),
    [sym_switch_expression] = STATE(4559),
    [sym_await_expression] = STATE(4558),
    [sym_throw_expression] = STATE(4559),
    [sym_element_access_expression] = STATE(3560),
    [sym_interpolated_string_expression] = STATE(4559),
    [sym_member_access_expression] = STATE(3560),
    [sym_object_creation_expression] = STATE(4558),
    [sym_parenthesized_expression] = STATE(4558),
    [sym__parenthesized_lvalue_expression] = STATE(3560),
    [sym_lambda_expression] = STATE(4559),
    [sym__lambda_parameters] = STATE(9691),
    [sym_array_creation_expression] = STATE(4559),
    [sym_anonymous_method_expression] = STATE(4559),
    [sym_anonymous_object_creation_expression] = STATE(4559),
    [sym_implicit_array_creation_expression] = STATE(4559),
    [sym_implicit_object_creation_expression] = STATE(4559),
    [sym_implicit_stackalloc_expression] = STATE(4559),
    [sym_initializer_expression] = STATE(4559),
    [sym_default_expression] = STATE(4559),
    [sym_with_expression] = STATE(4559),
    [sym_sizeof_expression] = STATE(4559),
    [sym_typeof_expression] = STATE(4559),
    [sym_makeref_expression] = STATE(4559),
    [sym_ref_expression] = STATE(4559),
    [sym_reftype_expression] = STATE(4559),
    [sym_refvalue_expression] = STATE(4559),
    [sym_stackalloc_expression] = STATE(4559),
    [sym_range_expression] = STATE(4559),
    [sym_tuple_expression] = STATE(3560),
    [sym_literal] = STATE(4559),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4559),
    [sym_preproc_region] = STATE(937),
    [sym_preproc_endregion] = STATE(937),
    [sym_preproc_line] = STATE(937),
    [sym_preproc_pragma] = STATE(937),
    [sym_preproc_nullable] = STATE(937),
    [sym_preproc_error] = STATE(937),
    [sym_preproc_define] = STATE(937),
    [sym_preproc_undef] = STATE(937),
    [aux_sym_class_declaration_repeat1] = STATE(3836),
    [aux_sym_lambda_expression_repeat1] = STATE(4216),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(2003),
    [anon_sym_ref] = ACTIONS(2005),
    [anon_sym_LBRACE] = ACTIONS(1611),
    [anon_sym_delegate] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1615),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(2009),
    [anon_sym_TILDE] = ACTIONS(2009),
    [anon_sym_PLUS_PLUS] = ACTIONS(2009),
    [anon_sym_DASH_DASH] = ACTIONS(2009),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(2007),
    [anon_sym_DASH] = ACTIONS(2007),
    [anon_sym_STAR] = ACTIONS(1625),
    [anon_sym_CARET] = ACTIONS(2009),
    [anon_sym_AMP] = ACTIONS(2009),
    [anon_sym_this] = ACTIONS(1627),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1629),
    [anon_sym_unchecked] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(2011),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2013),
    [anon_sym_DOT_DOT] = ACTIONS(2015),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_stackalloc] = ACTIONS(1641),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(1647),
    [anon_sym___reftype] = ACTIONS(1649),
    [anon_sym___refvalue] = ACTIONS(1651),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1659),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [938] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6961),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6339),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9849),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(938),
    [sym_preproc_endregion] = STATE(938),
    [sym_preproc_line] = STATE(938),
    [sym_preproc_pragma] = STATE(938),
    [sym_preproc_nullable] = STATE(938),
    [sym_preproc_error] = STATE(938),
    [sym_preproc_define] = STATE(938),
    [sym_preproc_undef] = STATE(938),
    [aux_sym_class_declaration_repeat1] = STATE(3841),
    [aux_sym_lambda_expression_repeat1] = STATE(4283),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(2857),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1459),
    [anon_sym_ref] = ACTIONS(1461),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1465),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1467),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1469),
    [anon_sym_DOT_DOT] = ACTIONS(1471),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [939] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6166),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2779),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6668),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5502),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(939),
    [sym_preproc_endregion] = STATE(939),
    [sym_preproc_line] = STATE(939),
    [sym_preproc_pragma] = STATE(939),
    [sym_preproc_nullable] = STATE(939),
    [sym_preproc_error] = STATE(939),
    [sym_preproc_define] = STATE(939),
    [sym_preproc_undef] = STATE(939),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(2671),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_readonly] = ACTIONS(2683),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1065),
    [anon_sym_var] = ACTIONS(2673),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [940] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6913),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7015),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4504),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(3582),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7407),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9275),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(940),
    [sym_preproc_endregion] = STATE(940),
    [sym_preproc_line] = STATE(940),
    [sym_preproc_pragma] = STATE(940),
    [sym_preproc_nullable] = STATE(940),
    [sym_preproc_error] = STATE(940),
    [sym_preproc_define] = STATE(940),
    [sym_preproc_undef] = STATE(940),
    [aux_sym_class_declaration_repeat1] = STATE(3789),
    [aux_sym_lambda_expression_repeat1] = STATE(4086),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1137),
    [anon_sym_ref] = ACTIONS(1139),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1145),
    [anon_sym_readonly] = ACTIONS(2693),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1153),
    [anon_sym_TILDE] = ACTIONS(1153),
    [anon_sym_PLUS_PLUS] = ACTIONS(1153),
    [anon_sym_DASH_DASH] = ACTIONS(1153),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1151),
    [anon_sym_DASH] = ACTIONS(1151),
    [anon_sym_STAR] = ACTIONS(1157),
    [anon_sym_CARET] = ACTIONS(1153),
    [anon_sym_AMP] = ACTIONS(1153),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1165),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1167),
    [anon_sym_DOT_DOT] = ACTIONS(1169),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [941] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4007),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6879),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2935),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7096),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5481),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4288),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7379),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9175),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(941),
    [sym_preproc_endregion] = STATE(941),
    [sym_preproc_line] = STATE(941),
    [sym_preproc_pragma] = STATE(941),
    [sym_preproc_nullable] = STATE(941),
    [sym_preproc_error] = STATE(941),
    [sym_preproc_define] = STATE(941),
    [sym_preproc_undef] = STATE(941),
    [aux_sym_class_declaration_repeat1] = STATE(3816),
    [aux_sym_lambda_expression_repeat1] = STATE(4119),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1867),
    [anon_sym_ref] = ACTIONS(1869),
    [anon_sym_LBRACE] = ACTIONS(2833),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1871),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1875),
    [anon_sym_TILDE] = ACTIONS(1875),
    [anon_sym_PLUS_PLUS] = ACTIONS(1875),
    [anon_sym_DASH_DASH] = ACTIONS(1875),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1873),
    [anon_sym_DASH] = ACTIONS(1873),
    [anon_sym_STAR] = ACTIONS(1877),
    [anon_sym_CARET] = ACTIONS(1875),
    [anon_sym_AMP] = ACTIONS(1875),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1879),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1881),
    [anon_sym_DOT_DOT] = ACTIONS(1883),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [942] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4685),
    [sym_bracketed_argument_list] = STATE(3559),
    [sym__name] = STATE(6878),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2911),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6938),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4904),
    [sym_non_lvalue_expression] = STATE(4553),
    [sym_lvalue_expression] = STATE(3750),
    [sym__expression_statement_expression] = STATE(4559),
    [sym_assignment_expression] = STATE(4558),
    [sym_binary_expression] = STATE(4559),
    [sym_postfix_unary_expression] = STATE(4558),
    [sym_prefix_unary_expression] = STATE(4558),
    [sym__pointer_indirection_expression] = STATE(3560),
    [sym_query_expression] = STATE(4559),
    [sym_from_clause] = STATE(7406),
    [sym_conditional_expression] = STATE(4559),
    [sym_conditional_access_expression] = STATE(4559),
    [sym_as_expression] = STATE(4559),
    [sym_is_expression] = STATE(4559),
    [sym_is_pattern_expression] = STATE(4559),
    [sym_cast_expression] = STATE(4559),
    [sym_checked_expression] = STATE(4559),
    [sym_invocation_expression] = STATE(4558),
    [sym_switch_expression] = STATE(4559),
    [sym_await_expression] = STATE(4558),
    [sym_throw_expression] = STATE(4559),
    [sym_element_access_expression] = STATE(3560),
    [sym_interpolated_string_expression] = STATE(4559),
    [sym_member_access_expression] = STATE(3560),
    [sym_object_creation_expression] = STATE(4558),
    [sym_parenthesized_expression] = STATE(4558),
    [sym__parenthesized_lvalue_expression] = STATE(3560),
    [sym_lambda_expression] = STATE(4559),
    [sym__lambda_parameters] = STATE(9691),
    [sym_array_creation_expression] = STATE(4559),
    [sym_anonymous_method_expression] = STATE(4559),
    [sym_anonymous_object_creation_expression] = STATE(4559),
    [sym_implicit_array_creation_expression] = STATE(4559),
    [sym_implicit_object_creation_expression] = STATE(4559),
    [sym_implicit_stackalloc_expression] = STATE(4559),
    [sym_initializer_expression] = STATE(4559),
    [sym_default_expression] = STATE(4559),
    [sym_with_expression] = STATE(4559),
    [sym_sizeof_expression] = STATE(4559),
    [sym_typeof_expression] = STATE(4559),
    [sym_makeref_expression] = STATE(4559),
    [sym_ref_expression] = STATE(4559),
    [sym_reftype_expression] = STATE(4559),
    [sym_refvalue_expression] = STATE(4559),
    [sym_stackalloc_expression] = STATE(4559),
    [sym_range_expression] = STATE(4559),
    [sym_tuple_expression] = STATE(3560),
    [sym_literal] = STATE(4559),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4559),
    [sym_preproc_region] = STATE(942),
    [sym_preproc_endregion] = STATE(942),
    [sym_preproc_line] = STATE(942),
    [sym_preproc_pragma] = STATE(942),
    [sym_preproc_nullable] = STATE(942),
    [sym_preproc_error] = STATE(942),
    [sym_preproc_define] = STATE(942),
    [sym_preproc_undef] = STATE(942),
    [aux_sym_class_declaration_repeat1] = STATE(3836),
    [aux_sym_lambda_expression_repeat1] = STATE(4216),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(2003),
    [anon_sym_ref] = ACTIONS(2005),
    [anon_sym_LBRACE] = ACTIONS(2759),
    [anon_sym_delegate] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1615),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(2009),
    [anon_sym_TILDE] = ACTIONS(2009),
    [anon_sym_PLUS_PLUS] = ACTIONS(2009),
    [anon_sym_DASH_DASH] = ACTIONS(2009),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(2007),
    [anon_sym_DASH] = ACTIONS(2007),
    [anon_sym_STAR] = ACTIONS(1625),
    [anon_sym_CARET] = ACTIONS(2009),
    [anon_sym_AMP] = ACTIONS(2009),
    [anon_sym_this] = ACTIONS(1627),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1629),
    [anon_sym_unchecked] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(2011),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2013),
    [anon_sym_DOT_DOT] = ACTIONS(2015),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_stackalloc] = ACTIONS(1641),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(1647),
    [anon_sym___reftype] = ACTIONS(1649),
    [anon_sym___refvalue] = ACTIONS(1651),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1659),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [943] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(5450),
    [sym_bracketed_argument_list] = STATE(3921),
    [sym__name] = STATE(6919),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2868),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(6950),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5251),
    [sym_non_lvalue_expression] = STATE(5735),
    [sym_lvalue_expression] = STATE(4054),
    [sym__expression_statement_expression] = STATE(5733),
    [sym_assignment_expression] = STATE(5734),
    [sym_binary_expression] = STATE(5733),
    [sym_postfix_unary_expression] = STATE(5734),
    [sym_prefix_unary_expression] = STATE(5734),
    [sym__pointer_indirection_expression] = STATE(3911),
    [sym_query_expression] = STATE(5733),
    [sym_from_clause] = STATE(7400),
    [sym_conditional_expression] = STATE(5733),
    [sym_conditional_access_expression] = STATE(5733),
    [sym_as_expression] = STATE(5733),
    [sym_is_expression] = STATE(5733),
    [sym_is_pattern_expression] = STATE(5733),
    [sym_cast_expression] = STATE(5733),
    [sym_checked_expression] = STATE(5733),
    [sym_invocation_expression] = STATE(5734),
    [sym_switch_expression] = STATE(5733),
    [sym_await_expression] = STATE(5734),
    [sym_throw_expression] = STATE(5733),
    [sym_element_access_expression] = STATE(3911),
    [sym_interpolated_string_expression] = STATE(5733),
    [sym_member_access_expression] = STATE(3911),
    [sym_object_creation_expression] = STATE(5734),
    [sym_parenthesized_expression] = STATE(5734),
    [sym__parenthesized_lvalue_expression] = STATE(3911),
    [sym_lambda_expression] = STATE(5733),
    [sym__lambda_parameters] = STATE(9693),
    [sym_array_creation_expression] = STATE(5733),
    [sym_anonymous_method_expression] = STATE(5733),
    [sym_anonymous_object_creation_expression] = STATE(5733),
    [sym_implicit_array_creation_expression] = STATE(5733),
    [sym_implicit_object_creation_expression] = STATE(5733),
    [sym_implicit_stackalloc_expression] = STATE(5733),
    [sym_initializer_expression] = STATE(5733),
    [sym_default_expression] = STATE(5733),
    [sym_with_expression] = STATE(5733),
    [sym_sizeof_expression] = STATE(5733),
    [sym_typeof_expression] = STATE(5733),
    [sym_makeref_expression] = STATE(5733),
    [sym_ref_expression] = STATE(5733),
    [sym_reftype_expression] = STATE(5733),
    [sym_refvalue_expression] = STATE(5733),
    [sym_stackalloc_expression] = STATE(5733),
    [sym_range_expression] = STATE(5733),
    [sym_tuple_expression] = STATE(3911),
    [sym_literal] = STATE(5733),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2798),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(5733),
    [sym_preproc_region] = STATE(943),
    [sym_preproc_endregion] = STATE(943),
    [sym_preproc_line] = STATE(943),
    [sym_preproc_pragma] = STATE(943),
    [sym_preproc_nullable] = STATE(943),
    [sym_preproc_error] = STATE(943),
    [sym_preproc_define] = STATE(943),
    [sym_preproc_undef] = STATE(943),
    [aux_sym_class_declaration_repeat1] = STATE(3791),
    [aux_sym_lambda_expression_repeat1] = STATE(4075),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_LPAREN] = ACTIONS(1373),
    [anon_sym_ref] = ACTIONS(1375),
    [anon_sym_LBRACE] = ACTIONS(2773),
    [anon_sym_delegate] = ACTIONS(1379),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1381),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1387),
    [anon_sym_TILDE] = ACTIONS(1387),
    [anon_sym_PLUS_PLUS] = ACTIONS(1387),
    [anon_sym_DASH_DASH] = ACTIONS(1387),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1385),
    [anon_sym_DASH] = ACTIONS(1385),
    [anon_sym_STAR] = ACTIONS(1391),
    [anon_sym_CARET] = ACTIONS(1387),
    [anon_sym_AMP] = ACTIONS(1387),
    [anon_sym_this] = ACTIONS(1393),
    [anon_sym_scoped] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1397),
    [sym_predefined_type] = ACTIONS(1399),
    [anon_sym_unchecked] = ACTIONS(1383),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1403),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1405),
    [anon_sym_DOT_DOT] = ACTIONS(1407),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_stackalloc] = ACTIONS(1413),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(1419),
    [anon_sym___reftype] = ACTIONS(1421),
    [anon_sym___refvalue] = ACTIONS(1423),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
  },
  [944] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(3337),
    [sym_alias_qualified_name] = STATE(3430),
    [sym__simple_name] = STATE(2822),
    [sym_qualified_name] = STATE(3430),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(3092),
    [sym_implicit_type] = STATE(3403),
    [sym_array_type] = STATE(3434),
    [sym__array_base_type] = STATE(8808),
    [sym_nullable_type] = STATE(3435),
    [sym_pointer_type] = STATE(3435),
    [sym__pointer_base_type] = STATE(9626),
    [sym_function_pointer_type] = STATE(3435),
    [sym_ref_type] = STATE(3403),
    [sym_scoped_type] = STATE(3403),
    [sym_tuple_type] = STATE(3436),
    [sym_expression] = STATE(5825),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2776),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(944),
    [sym_preproc_endregion] = STATE(944),
    [sym_preproc_line] = STATE(944),
    [sym_preproc_pragma] = STATE(944),
    [sym_preproc_nullable] = STATE(944),
    [sym_preproc_error] = STATE(944),
    [sym_preproc_define] = STATE(944),
    [sym_preproc_undef] = STATE(944),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2859),
    [anon_sym_ref] = ACTIONS(2451),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(2455),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_readonly] = ACTIONS(2861),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1669),
    [anon_sym_TILDE] = ACTIONS(1669),
    [anon_sym_PLUS_PLUS] = ACTIONS(1669),
    [anon_sym_DASH_DASH] = ACTIONS(1669),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1667),
    [anon_sym_DASH] = ACTIONS(1667),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1669),
    [anon_sym_AMP] = ACTIONS(1669),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2461),
    [anon_sym_var] = ACTIONS(2863),
    [sym_predefined_type] = ACTIONS(2865),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1673),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [945] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6961),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6644),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9849),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(945),
    [sym_preproc_endregion] = STATE(945),
    [sym_preproc_line] = STATE(945),
    [sym_preproc_pragma] = STATE(945),
    [sym_preproc_nullable] = STATE(945),
    [sym_preproc_error] = STATE(945),
    [sym_preproc_define] = STATE(945),
    [sym_preproc_undef] = STATE(945),
    [aux_sym_class_declaration_repeat1] = STATE(3841),
    [aux_sym_lambda_expression_repeat1] = STATE(4283),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(2867),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1459),
    [anon_sym_ref] = ACTIONS(1461),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1465),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1467),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1469),
    [anon_sym_DOT_DOT] = ACTIONS(1471),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [946] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(5508),
    [sym_bracketed_argument_list] = STATE(3921),
    [sym__name] = STATE(6919),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2868),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(6950),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5250),
    [sym_non_lvalue_expression] = STATE(5735),
    [sym_lvalue_expression] = STATE(4054),
    [sym__expression_statement_expression] = STATE(5733),
    [sym_assignment_expression] = STATE(5734),
    [sym_binary_expression] = STATE(5733),
    [sym_postfix_unary_expression] = STATE(5734),
    [sym_prefix_unary_expression] = STATE(5734),
    [sym__pointer_indirection_expression] = STATE(3911),
    [sym_query_expression] = STATE(5733),
    [sym_from_clause] = STATE(7400),
    [sym_conditional_expression] = STATE(5733),
    [sym_conditional_access_expression] = STATE(5733),
    [sym_as_expression] = STATE(5733),
    [sym_is_expression] = STATE(5733),
    [sym_is_pattern_expression] = STATE(5733),
    [sym_cast_expression] = STATE(5733),
    [sym_checked_expression] = STATE(5733),
    [sym_invocation_expression] = STATE(5734),
    [sym_switch_expression] = STATE(5733),
    [sym_await_expression] = STATE(5734),
    [sym_throw_expression] = STATE(5733),
    [sym_element_access_expression] = STATE(3911),
    [sym_interpolated_string_expression] = STATE(5733),
    [sym_member_access_expression] = STATE(3911),
    [sym_object_creation_expression] = STATE(5734),
    [sym_parenthesized_expression] = STATE(5734),
    [sym__parenthesized_lvalue_expression] = STATE(3911),
    [sym_lambda_expression] = STATE(5733),
    [sym__lambda_parameters] = STATE(9693),
    [sym_array_creation_expression] = STATE(5733),
    [sym_anonymous_method_expression] = STATE(5733),
    [sym_anonymous_object_creation_expression] = STATE(5733),
    [sym_implicit_array_creation_expression] = STATE(5733),
    [sym_implicit_object_creation_expression] = STATE(5733),
    [sym_implicit_stackalloc_expression] = STATE(5733),
    [sym_initializer_expression] = STATE(5733),
    [sym_default_expression] = STATE(5733),
    [sym_with_expression] = STATE(5733),
    [sym_sizeof_expression] = STATE(5733),
    [sym_typeof_expression] = STATE(5733),
    [sym_makeref_expression] = STATE(5733),
    [sym_ref_expression] = STATE(5733),
    [sym_reftype_expression] = STATE(5733),
    [sym_refvalue_expression] = STATE(5733),
    [sym_stackalloc_expression] = STATE(5733),
    [sym_range_expression] = STATE(5733),
    [sym_tuple_expression] = STATE(3911),
    [sym_literal] = STATE(5733),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2798),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(5733),
    [sym_preproc_region] = STATE(946),
    [sym_preproc_endregion] = STATE(946),
    [sym_preproc_line] = STATE(946),
    [sym_preproc_pragma] = STATE(946),
    [sym_preproc_nullable] = STATE(946),
    [sym_preproc_error] = STATE(946),
    [sym_preproc_define] = STATE(946),
    [sym_preproc_undef] = STATE(946),
    [aux_sym_class_declaration_repeat1] = STATE(3791),
    [aux_sym_lambda_expression_repeat1] = STATE(4075),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_LPAREN] = ACTIONS(1373),
    [anon_sym_ref] = ACTIONS(1375),
    [anon_sym_LBRACE] = ACTIONS(2773),
    [anon_sym_delegate] = ACTIONS(1379),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1381),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1387),
    [anon_sym_TILDE] = ACTIONS(1387),
    [anon_sym_PLUS_PLUS] = ACTIONS(1387),
    [anon_sym_DASH_DASH] = ACTIONS(1387),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1385),
    [anon_sym_DASH] = ACTIONS(1385),
    [anon_sym_STAR] = ACTIONS(1391),
    [anon_sym_CARET] = ACTIONS(1387),
    [anon_sym_AMP] = ACTIONS(1387),
    [anon_sym_this] = ACTIONS(1393),
    [anon_sym_scoped] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1397),
    [sym_predefined_type] = ACTIONS(1399),
    [anon_sym_unchecked] = ACTIONS(1383),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1403),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1405),
    [anon_sym_DOT_DOT] = ACTIONS(1407),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_stackalloc] = ACTIONS(1413),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(1419),
    [anon_sym___reftype] = ACTIONS(1421),
    [anon_sym___refvalue] = ACTIONS(1423),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
  },
  [947] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6881),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2964),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6922),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6630),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4495),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7398),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9102),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(947),
    [sym_preproc_endregion] = STATE(947),
    [sym_preproc_line] = STATE(947),
    [sym_preproc_pragma] = STATE(947),
    [sym_preproc_nullable] = STATE(947),
    [sym_preproc_error] = STATE(947),
    [sym_preproc_define] = STATE(947),
    [sym_preproc_undef] = STATE(947),
    [aux_sym_class_declaration_repeat1] = STATE(3857),
    [aux_sym_lambda_expression_repeat1] = STATE(4241),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2097),
    [anon_sym_ref] = ACTIONS(2099),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2101),
    [anon_sym_readonly] = ACTIONS(2693),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2105),
    [anon_sym_TILDE] = ACTIONS(2105),
    [anon_sym_PLUS_PLUS] = ACTIONS(2105),
    [anon_sym_DASH_DASH] = ACTIONS(2105),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2103),
    [anon_sym_DASH] = ACTIONS(2103),
    [anon_sym_STAR] = ACTIONS(2107),
    [anon_sym_CARET] = ACTIONS(2105),
    [anon_sym_AMP] = ACTIONS(2105),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2111),
    [anon_sym_DOT_DOT] = ACTIONS(2113),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [948] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4065),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6879),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2935),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7096),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5492),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4288),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7379),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9175),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(948),
    [sym_preproc_endregion] = STATE(948),
    [sym_preproc_line] = STATE(948),
    [sym_preproc_pragma] = STATE(948),
    [sym_preproc_nullable] = STATE(948),
    [sym_preproc_error] = STATE(948),
    [sym_preproc_define] = STATE(948),
    [sym_preproc_undef] = STATE(948),
    [aux_sym_class_declaration_repeat1] = STATE(3816),
    [aux_sym_lambda_expression_repeat1] = STATE(4119),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1867),
    [anon_sym_ref] = ACTIONS(1869),
    [anon_sym_LBRACE] = ACTIONS(2833),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1871),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1875),
    [anon_sym_TILDE] = ACTIONS(1875),
    [anon_sym_PLUS_PLUS] = ACTIONS(1875),
    [anon_sym_DASH_DASH] = ACTIONS(1875),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1873),
    [anon_sym_DASH] = ACTIONS(1873),
    [anon_sym_STAR] = ACTIONS(1877),
    [anon_sym_CARET] = ACTIONS(1875),
    [anon_sym_AMP] = ACTIONS(1875),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1879),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1881),
    [anon_sym_DOT_DOT] = ACTIONS(1883),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [949] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(5513),
    [sym_bracketed_argument_list] = STATE(3921),
    [sym__name] = STATE(6919),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2868),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(6950),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5249),
    [sym_non_lvalue_expression] = STATE(5735),
    [sym_lvalue_expression] = STATE(4054),
    [sym__expression_statement_expression] = STATE(5733),
    [sym_assignment_expression] = STATE(5734),
    [sym_binary_expression] = STATE(5733),
    [sym_postfix_unary_expression] = STATE(5734),
    [sym_prefix_unary_expression] = STATE(5734),
    [sym__pointer_indirection_expression] = STATE(3911),
    [sym_query_expression] = STATE(5733),
    [sym_from_clause] = STATE(7400),
    [sym_conditional_expression] = STATE(5733),
    [sym_conditional_access_expression] = STATE(5733),
    [sym_as_expression] = STATE(5733),
    [sym_is_expression] = STATE(5733),
    [sym_is_pattern_expression] = STATE(5733),
    [sym_cast_expression] = STATE(5733),
    [sym_checked_expression] = STATE(5733),
    [sym_invocation_expression] = STATE(5734),
    [sym_switch_expression] = STATE(5733),
    [sym_await_expression] = STATE(5734),
    [sym_throw_expression] = STATE(5733),
    [sym_element_access_expression] = STATE(3911),
    [sym_interpolated_string_expression] = STATE(5733),
    [sym_member_access_expression] = STATE(3911),
    [sym_object_creation_expression] = STATE(5734),
    [sym_parenthesized_expression] = STATE(5734),
    [sym__parenthesized_lvalue_expression] = STATE(3911),
    [sym_lambda_expression] = STATE(5733),
    [sym__lambda_parameters] = STATE(9693),
    [sym_array_creation_expression] = STATE(5733),
    [sym_anonymous_method_expression] = STATE(5733),
    [sym_anonymous_object_creation_expression] = STATE(5733),
    [sym_implicit_array_creation_expression] = STATE(5733),
    [sym_implicit_object_creation_expression] = STATE(5733),
    [sym_implicit_stackalloc_expression] = STATE(5733),
    [sym_initializer_expression] = STATE(5733),
    [sym_default_expression] = STATE(5733),
    [sym_with_expression] = STATE(5733),
    [sym_sizeof_expression] = STATE(5733),
    [sym_typeof_expression] = STATE(5733),
    [sym_makeref_expression] = STATE(5733),
    [sym_ref_expression] = STATE(5733),
    [sym_reftype_expression] = STATE(5733),
    [sym_refvalue_expression] = STATE(5733),
    [sym_stackalloc_expression] = STATE(5733),
    [sym_range_expression] = STATE(5733),
    [sym_tuple_expression] = STATE(3911),
    [sym_literal] = STATE(5733),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2798),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(5733),
    [sym_preproc_region] = STATE(949),
    [sym_preproc_endregion] = STATE(949),
    [sym_preproc_line] = STATE(949),
    [sym_preproc_pragma] = STATE(949),
    [sym_preproc_nullable] = STATE(949),
    [sym_preproc_error] = STATE(949),
    [sym_preproc_define] = STATE(949),
    [sym_preproc_undef] = STATE(949),
    [aux_sym_class_declaration_repeat1] = STATE(3791),
    [aux_sym_lambda_expression_repeat1] = STATE(4075),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_LPAREN] = ACTIONS(1373),
    [anon_sym_ref] = ACTIONS(1375),
    [anon_sym_LBRACE] = ACTIONS(2773),
    [anon_sym_delegate] = ACTIONS(1379),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1381),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1387),
    [anon_sym_TILDE] = ACTIONS(1387),
    [anon_sym_PLUS_PLUS] = ACTIONS(1387),
    [anon_sym_DASH_DASH] = ACTIONS(1387),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1385),
    [anon_sym_DASH] = ACTIONS(1385),
    [anon_sym_STAR] = ACTIONS(1391),
    [anon_sym_CARET] = ACTIONS(1387),
    [anon_sym_AMP] = ACTIONS(1387),
    [anon_sym_this] = ACTIONS(1393),
    [anon_sym_scoped] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1397),
    [sym_predefined_type] = ACTIONS(1399),
    [anon_sym_unchecked] = ACTIONS(1383),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1403),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1405),
    [anon_sym_DOT_DOT] = ACTIONS(1407),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_stackalloc] = ACTIONS(1413),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(1419),
    [anon_sym___reftype] = ACTIONS(1421),
    [anon_sym___refvalue] = ACTIONS(1423),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
  },
  [950] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(5573),
    [sym_bracketed_argument_list] = STATE(3921),
    [sym__name] = STATE(6919),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2868),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(6950),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5247),
    [sym_non_lvalue_expression] = STATE(5735),
    [sym_lvalue_expression] = STATE(4054),
    [sym__expression_statement_expression] = STATE(5733),
    [sym_assignment_expression] = STATE(5734),
    [sym_binary_expression] = STATE(5733),
    [sym_postfix_unary_expression] = STATE(5734),
    [sym_prefix_unary_expression] = STATE(5734),
    [sym__pointer_indirection_expression] = STATE(3911),
    [sym_query_expression] = STATE(5733),
    [sym_from_clause] = STATE(7400),
    [sym_conditional_expression] = STATE(5733),
    [sym_conditional_access_expression] = STATE(5733),
    [sym_as_expression] = STATE(5733),
    [sym_is_expression] = STATE(5733),
    [sym_is_pattern_expression] = STATE(5733),
    [sym_cast_expression] = STATE(5733),
    [sym_checked_expression] = STATE(5733),
    [sym_invocation_expression] = STATE(5734),
    [sym_switch_expression] = STATE(5733),
    [sym_await_expression] = STATE(5734),
    [sym_throw_expression] = STATE(5733),
    [sym_element_access_expression] = STATE(3911),
    [sym_interpolated_string_expression] = STATE(5733),
    [sym_member_access_expression] = STATE(3911),
    [sym_object_creation_expression] = STATE(5734),
    [sym_parenthesized_expression] = STATE(5734),
    [sym__parenthesized_lvalue_expression] = STATE(3911),
    [sym_lambda_expression] = STATE(5733),
    [sym__lambda_parameters] = STATE(9693),
    [sym_array_creation_expression] = STATE(5733),
    [sym_anonymous_method_expression] = STATE(5733),
    [sym_anonymous_object_creation_expression] = STATE(5733),
    [sym_implicit_array_creation_expression] = STATE(5733),
    [sym_implicit_object_creation_expression] = STATE(5733),
    [sym_implicit_stackalloc_expression] = STATE(5733),
    [sym_initializer_expression] = STATE(5733),
    [sym_default_expression] = STATE(5733),
    [sym_with_expression] = STATE(5733),
    [sym_sizeof_expression] = STATE(5733),
    [sym_typeof_expression] = STATE(5733),
    [sym_makeref_expression] = STATE(5733),
    [sym_ref_expression] = STATE(5733),
    [sym_reftype_expression] = STATE(5733),
    [sym_refvalue_expression] = STATE(5733),
    [sym_stackalloc_expression] = STATE(5733),
    [sym_range_expression] = STATE(5733),
    [sym_tuple_expression] = STATE(3911),
    [sym_literal] = STATE(5733),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2798),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(5733),
    [sym_preproc_region] = STATE(950),
    [sym_preproc_endregion] = STATE(950),
    [sym_preproc_line] = STATE(950),
    [sym_preproc_pragma] = STATE(950),
    [sym_preproc_nullable] = STATE(950),
    [sym_preproc_error] = STATE(950),
    [sym_preproc_define] = STATE(950),
    [sym_preproc_undef] = STATE(950),
    [aux_sym_class_declaration_repeat1] = STATE(3791),
    [aux_sym_lambda_expression_repeat1] = STATE(4075),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_LPAREN] = ACTIONS(1373),
    [anon_sym_ref] = ACTIONS(1375),
    [anon_sym_LBRACE] = ACTIONS(2773),
    [anon_sym_delegate] = ACTIONS(1379),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1381),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1387),
    [anon_sym_TILDE] = ACTIONS(1387),
    [anon_sym_PLUS_PLUS] = ACTIONS(1387),
    [anon_sym_DASH_DASH] = ACTIONS(1387),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1385),
    [anon_sym_DASH] = ACTIONS(1385),
    [anon_sym_STAR] = ACTIONS(1391),
    [anon_sym_CARET] = ACTIONS(1387),
    [anon_sym_AMP] = ACTIONS(1387),
    [anon_sym_this] = ACTIONS(1393),
    [anon_sym_scoped] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1397),
    [sym_predefined_type] = ACTIONS(1399),
    [anon_sym_unchecked] = ACTIONS(1383),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1403),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1405),
    [anon_sym_DOT_DOT] = ACTIONS(1407),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_stackalloc] = ACTIONS(1413),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(1419),
    [anon_sym___reftype] = ACTIONS(1421),
    [anon_sym___refvalue] = ACTIONS(1423),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
  },
  [951] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4050),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6879),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2935),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7096),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5494),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4288),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7379),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9175),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(951),
    [sym_preproc_endregion] = STATE(951),
    [sym_preproc_line] = STATE(951),
    [sym_preproc_pragma] = STATE(951),
    [sym_preproc_nullable] = STATE(951),
    [sym_preproc_error] = STATE(951),
    [sym_preproc_define] = STATE(951),
    [sym_preproc_undef] = STATE(951),
    [aux_sym_class_declaration_repeat1] = STATE(3816),
    [aux_sym_lambda_expression_repeat1] = STATE(4119),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1867),
    [anon_sym_ref] = ACTIONS(1869),
    [anon_sym_LBRACE] = ACTIONS(2833),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1871),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1875),
    [anon_sym_TILDE] = ACTIONS(1875),
    [anon_sym_PLUS_PLUS] = ACTIONS(1875),
    [anon_sym_DASH_DASH] = ACTIONS(1875),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1873),
    [anon_sym_DASH] = ACTIONS(1873),
    [anon_sym_STAR] = ACTIONS(1877),
    [anon_sym_CARET] = ACTIONS(1875),
    [anon_sym_AMP] = ACTIONS(1875),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1879),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1881),
    [anon_sym_DOT_DOT] = ACTIONS(1883),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [952] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6664),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2790),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6668),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5502),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(952),
    [sym_preproc_endregion] = STATE(952),
    [sym_preproc_line] = STATE(952),
    [sym_preproc_pragma] = STATE(952),
    [sym_preproc_nullable] = STATE(952),
    [sym_preproc_error] = STATE(952),
    [sym_preproc_define] = STATE(952),
    [sym_preproc_undef] = STATE(952),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(2681),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_readonly] = ACTIONS(2683),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1065),
    [anon_sym_var] = ACTIONS(2673),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [953] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6038),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(953),
    [sym_preproc_endregion] = STATE(953),
    [sym_preproc_line] = STATE(953),
    [sym_preproc_pragma] = STATE(953),
    [sym_preproc_nullable] = STATE(953),
    [sym_preproc_error] = STATE(953),
    [sym_preproc_define] = STATE(953),
    [sym_preproc_undef] = STATE(953),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_RPAREN] = ACTIONS(2869),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [954] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6913),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7001),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5441),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4181),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7384),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9143),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(954),
    [sym_preproc_endregion] = STATE(954),
    [sym_preproc_line] = STATE(954),
    [sym_preproc_pragma] = STATE(954),
    [sym_preproc_nullable] = STATE(954),
    [sym_preproc_error] = STATE(954),
    [sym_preproc_define] = STATE(954),
    [sym_preproc_undef] = STATE(954),
    [aux_sym_class_declaration_repeat1] = STATE(3814),
    [aux_sym_lambda_expression_repeat1] = STATE(4171),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1561),
    [anon_sym_ref] = ACTIONS(1563),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1145),
    [anon_sym_readonly] = ACTIONS(2693),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(1567),
    [anon_sym_PLUS_PLUS] = ACTIONS(1567),
    [anon_sym_DASH_DASH] = ACTIONS(1567),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1565),
    [anon_sym_DASH] = ACTIONS(1565),
    [anon_sym_STAR] = ACTIONS(1569),
    [anon_sym_CARET] = ACTIONS(1567),
    [anon_sym_AMP] = ACTIONS(1567),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1571),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1573),
    [anon_sym_DOT_DOT] = ACTIONS(1575),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [955] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6901),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2939),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7087),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5848),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4322),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7392),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9185),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(955),
    [sym_preproc_endregion] = STATE(955),
    [sym_preproc_line] = STATE(955),
    [sym_preproc_pragma] = STATE(955),
    [sym_preproc_nullable] = STATE(955),
    [sym_preproc_error] = STATE(955),
    [sym_preproc_define] = STATE(955),
    [sym_preproc_undef] = STATE(955),
    [aux_sym_class_declaration_repeat1] = STATE(3819),
    [aux_sym_lambda_expression_repeat1] = STATE(4161),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_ref] = ACTIONS(1761),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1763),
    [anon_sym_readonly] = ACTIONS(2693),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1767),
    [anon_sym_TILDE] = ACTIONS(1767),
    [anon_sym_PLUS_PLUS] = ACTIONS(1767),
    [anon_sym_DASH_DASH] = ACTIONS(1767),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1765),
    [anon_sym_STAR] = ACTIONS(1769),
    [anon_sym_CARET] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(1767),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1771),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1773),
    [anon_sym_DOT_DOT] = ACTIONS(1775),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [956] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3977),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6913),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7000),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5507),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4181),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7384),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9143),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(956),
    [sym_preproc_endregion] = STATE(956),
    [sym_preproc_line] = STATE(956),
    [sym_preproc_pragma] = STATE(956),
    [sym_preproc_nullable] = STATE(956),
    [sym_preproc_error] = STATE(956),
    [sym_preproc_define] = STATE(956),
    [sym_preproc_undef] = STATE(956),
    [aux_sym_class_declaration_repeat1] = STATE(3814),
    [aux_sym_lambda_expression_repeat1] = STATE(4171),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1561),
    [anon_sym_ref] = ACTIONS(1563),
    [anon_sym_LBRACE] = ACTIONS(2833),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1145),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(1567),
    [anon_sym_PLUS_PLUS] = ACTIONS(1567),
    [anon_sym_DASH_DASH] = ACTIONS(1567),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1565),
    [anon_sym_DASH] = ACTIONS(1565),
    [anon_sym_STAR] = ACTIONS(1569),
    [anon_sym_CARET] = ACTIONS(1567),
    [anon_sym_AMP] = ACTIONS(1567),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1571),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1573),
    [anon_sym_DOT_DOT] = ACTIONS(1575),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [957] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3934),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6913),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7000),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5510),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4181),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7384),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9143),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(957),
    [sym_preproc_endregion] = STATE(957),
    [sym_preproc_line] = STATE(957),
    [sym_preproc_pragma] = STATE(957),
    [sym_preproc_nullable] = STATE(957),
    [sym_preproc_error] = STATE(957),
    [sym_preproc_define] = STATE(957),
    [sym_preproc_undef] = STATE(957),
    [aux_sym_class_declaration_repeat1] = STATE(3814),
    [aux_sym_lambda_expression_repeat1] = STATE(4171),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1561),
    [anon_sym_ref] = ACTIONS(1563),
    [anon_sym_LBRACE] = ACTIONS(2833),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1145),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(1567),
    [anon_sym_PLUS_PLUS] = ACTIONS(1567),
    [anon_sym_DASH_DASH] = ACTIONS(1567),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1565),
    [anon_sym_DASH] = ACTIONS(1565),
    [anon_sym_STAR] = ACTIONS(1569),
    [anon_sym_CARET] = ACTIONS(1567),
    [anon_sym_AMP] = ACTIONS(1567),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1571),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1573),
    [anon_sym_DOT_DOT] = ACTIONS(1575),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [958] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4003),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6913),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7000),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5514),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4181),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7384),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9143),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(958),
    [sym_preproc_endregion] = STATE(958),
    [sym_preproc_line] = STATE(958),
    [sym_preproc_pragma] = STATE(958),
    [sym_preproc_nullable] = STATE(958),
    [sym_preproc_error] = STATE(958),
    [sym_preproc_define] = STATE(958),
    [sym_preproc_undef] = STATE(958),
    [aux_sym_class_declaration_repeat1] = STATE(3814),
    [aux_sym_lambda_expression_repeat1] = STATE(4171),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1561),
    [anon_sym_ref] = ACTIONS(1563),
    [anon_sym_LBRACE] = ACTIONS(2833),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1145),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(1567),
    [anon_sym_PLUS_PLUS] = ACTIONS(1567),
    [anon_sym_DASH_DASH] = ACTIONS(1567),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1565),
    [anon_sym_DASH] = ACTIONS(1565),
    [anon_sym_STAR] = ACTIONS(1569),
    [anon_sym_CARET] = ACTIONS(1567),
    [anon_sym_AMP] = ACTIONS(1567),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1571),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1573),
    [anon_sym_DOT_DOT] = ACTIONS(1575),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [959] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4617),
    [sym_bracketed_argument_list] = STATE(3559),
    [sym__name] = STATE(6878),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2911),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6938),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4798),
    [sym_non_lvalue_expression] = STATE(4553),
    [sym_lvalue_expression] = STATE(3750),
    [sym__expression_statement_expression] = STATE(4559),
    [sym_assignment_expression] = STATE(4558),
    [sym_binary_expression] = STATE(4559),
    [sym_postfix_unary_expression] = STATE(4558),
    [sym_prefix_unary_expression] = STATE(4558),
    [sym__pointer_indirection_expression] = STATE(3560),
    [sym_query_expression] = STATE(4559),
    [sym_from_clause] = STATE(7406),
    [sym_conditional_expression] = STATE(4559),
    [sym_conditional_access_expression] = STATE(4559),
    [sym_as_expression] = STATE(4559),
    [sym_is_expression] = STATE(4559),
    [sym_is_pattern_expression] = STATE(4559),
    [sym_cast_expression] = STATE(4559),
    [sym_checked_expression] = STATE(4559),
    [sym_invocation_expression] = STATE(4558),
    [sym_switch_expression] = STATE(4559),
    [sym_await_expression] = STATE(4558),
    [sym_throw_expression] = STATE(4559),
    [sym_element_access_expression] = STATE(3560),
    [sym_interpolated_string_expression] = STATE(4559),
    [sym_member_access_expression] = STATE(3560),
    [sym_object_creation_expression] = STATE(4558),
    [sym_parenthesized_expression] = STATE(4558),
    [sym__parenthesized_lvalue_expression] = STATE(3560),
    [sym_lambda_expression] = STATE(4559),
    [sym__lambda_parameters] = STATE(9691),
    [sym_array_creation_expression] = STATE(4559),
    [sym_anonymous_method_expression] = STATE(4559),
    [sym_anonymous_object_creation_expression] = STATE(4559),
    [sym_implicit_array_creation_expression] = STATE(4559),
    [sym_implicit_object_creation_expression] = STATE(4559),
    [sym_implicit_stackalloc_expression] = STATE(4559),
    [sym_initializer_expression] = STATE(4559),
    [sym_default_expression] = STATE(4559),
    [sym_with_expression] = STATE(4559),
    [sym_sizeof_expression] = STATE(4559),
    [sym_typeof_expression] = STATE(4559),
    [sym_makeref_expression] = STATE(4559),
    [sym_ref_expression] = STATE(4559),
    [sym_reftype_expression] = STATE(4559),
    [sym_refvalue_expression] = STATE(4559),
    [sym_stackalloc_expression] = STATE(4559),
    [sym_range_expression] = STATE(4559),
    [sym_tuple_expression] = STATE(3560),
    [sym_literal] = STATE(4559),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4559),
    [sym_preproc_region] = STATE(959),
    [sym_preproc_endregion] = STATE(959),
    [sym_preproc_line] = STATE(959),
    [sym_preproc_pragma] = STATE(959),
    [sym_preproc_nullable] = STATE(959),
    [sym_preproc_error] = STATE(959),
    [sym_preproc_define] = STATE(959),
    [sym_preproc_undef] = STATE(959),
    [aux_sym_class_declaration_repeat1] = STATE(3836),
    [aux_sym_lambda_expression_repeat1] = STATE(4216),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(2003),
    [anon_sym_ref] = ACTIONS(2005),
    [anon_sym_LBRACE] = ACTIONS(2759),
    [anon_sym_delegate] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1615),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(2009),
    [anon_sym_TILDE] = ACTIONS(2009),
    [anon_sym_PLUS_PLUS] = ACTIONS(2009),
    [anon_sym_DASH_DASH] = ACTIONS(2009),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(2007),
    [anon_sym_DASH] = ACTIONS(2007),
    [anon_sym_STAR] = ACTIONS(1625),
    [anon_sym_CARET] = ACTIONS(2009),
    [anon_sym_AMP] = ACTIONS(2009),
    [anon_sym_this] = ACTIONS(1627),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1629),
    [anon_sym_unchecked] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(2011),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2013),
    [anon_sym_DOT_DOT] = ACTIONS(2015),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_stackalloc] = ACTIONS(1641),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(1647),
    [anon_sym___reftype] = ACTIONS(1649),
    [anon_sym___refvalue] = ACTIONS(1651),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1659),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [960] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3738),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7094),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5881),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(960),
    [sym_preproc_endregion] = STATE(960),
    [sym_preproc_line] = STATE(960),
    [sym_preproc_pragma] = STATE(960),
    [sym_preproc_nullable] = STATE(960),
    [sym_preproc_error] = STATE(960),
    [sym_preproc_define] = STATE(960),
    [sym_preproc_undef] = STATE(960),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(2765),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1669),
    [anon_sym_TILDE] = ACTIONS(1669),
    [anon_sym_PLUS_PLUS] = ACTIONS(1669),
    [anon_sym_DASH_DASH] = ACTIONS(1669),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1667),
    [anon_sym_DASH] = ACTIONS(1667),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1669),
    [anon_sym_AMP] = ACTIONS(1669),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [961] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4050),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6913),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7000),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5518),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4181),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7384),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9143),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(961),
    [sym_preproc_endregion] = STATE(961),
    [sym_preproc_line] = STATE(961),
    [sym_preproc_pragma] = STATE(961),
    [sym_preproc_nullable] = STATE(961),
    [sym_preproc_error] = STATE(961),
    [sym_preproc_define] = STATE(961),
    [sym_preproc_undef] = STATE(961),
    [aux_sym_class_declaration_repeat1] = STATE(3814),
    [aux_sym_lambda_expression_repeat1] = STATE(4171),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1561),
    [anon_sym_ref] = ACTIONS(1563),
    [anon_sym_LBRACE] = ACTIONS(2833),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1145),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(1567),
    [anon_sym_PLUS_PLUS] = ACTIONS(1567),
    [anon_sym_DASH_DASH] = ACTIONS(1567),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1565),
    [anon_sym_DASH] = ACTIONS(1565),
    [anon_sym_STAR] = ACTIONS(1569),
    [anon_sym_CARET] = ACTIONS(1567),
    [anon_sym_AMP] = ACTIONS(1567),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1571),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1573),
    [anon_sym_DOT_DOT] = ACTIONS(1575),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [962] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4065),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6913),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7000),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5519),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4181),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7384),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9143),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(962),
    [sym_preproc_endregion] = STATE(962),
    [sym_preproc_line] = STATE(962),
    [sym_preproc_pragma] = STATE(962),
    [sym_preproc_nullable] = STATE(962),
    [sym_preproc_error] = STATE(962),
    [sym_preproc_define] = STATE(962),
    [sym_preproc_undef] = STATE(962),
    [aux_sym_class_declaration_repeat1] = STATE(3814),
    [aux_sym_lambda_expression_repeat1] = STATE(4171),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1561),
    [anon_sym_ref] = ACTIONS(1563),
    [anon_sym_LBRACE] = ACTIONS(2833),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1145),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(1567),
    [anon_sym_PLUS_PLUS] = ACTIONS(1567),
    [anon_sym_DASH_DASH] = ACTIONS(1567),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1565),
    [anon_sym_DASH] = ACTIONS(1565),
    [anon_sym_STAR] = ACTIONS(1569),
    [anon_sym_CARET] = ACTIONS(1567),
    [anon_sym_AMP] = ACTIONS(1567),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1571),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1573),
    [anon_sym_DOT_DOT] = ACTIONS(1575),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [963] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7060),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5168),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(3866),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7382),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9762),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(963),
    [sym_preproc_endregion] = STATE(963),
    [sym_preproc_line] = STATE(963),
    [sym_preproc_pragma] = STATE(963),
    [sym_preproc_nullable] = STATE(963),
    [sym_preproc_error] = STATE(963),
    [sym_preproc_define] = STATE(963),
    [sym_preproc_undef] = STATE(963),
    [aux_sym_class_declaration_repeat1] = STATE(3842),
    [aux_sym_lambda_expression_repeat1] = STATE(4280),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1351),
    [anon_sym_ref] = ACTIONS(1353),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_readonly] = ACTIONS(2693),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1357),
    [anon_sym_TILDE] = ACTIONS(1357),
    [anon_sym_PLUS_PLUS] = ACTIONS(1357),
    [anon_sym_DASH_DASH] = ACTIONS(1357),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1355),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(1357),
    [anon_sym_AMP] = ACTIONS(1357),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1361),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1363),
    [anon_sym_DOT_DOT] = ACTIONS(1365),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [964] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4007),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6913),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7000),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5520),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4181),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7384),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9143),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(964),
    [sym_preproc_endregion] = STATE(964),
    [sym_preproc_line] = STATE(964),
    [sym_preproc_pragma] = STATE(964),
    [sym_preproc_nullable] = STATE(964),
    [sym_preproc_error] = STATE(964),
    [sym_preproc_define] = STATE(964),
    [sym_preproc_undef] = STATE(964),
    [aux_sym_class_declaration_repeat1] = STATE(3814),
    [aux_sym_lambda_expression_repeat1] = STATE(4171),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1561),
    [anon_sym_ref] = ACTIONS(1563),
    [anon_sym_LBRACE] = ACTIONS(2833),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1145),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(1567),
    [anon_sym_PLUS_PLUS] = ACTIONS(1567),
    [anon_sym_DASH_DASH] = ACTIONS(1567),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1565),
    [anon_sym_DASH] = ACTIONS(1565),
    [anon_sym_STAR] = ACTIONS(1569),
    [anon_sym_CARET] = ACTIONS(1567),
    [anon_sym_AMP] = ACTIONS(1567),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1571),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1573),
    [anon_sym_DOT_DOT] = ACTIONS(1575),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [965] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3977),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6913),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7016),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4515),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(3582),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7407),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9275),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(965),
    [sym_preproc_endregion] = STATE(965),
    [sym_preproc_line] = STATE(965),
    [sym_preproc_pragma] = STATE(965),
    [sym_preproc_nullable] = STATE(965),
    [sym_preproc_error] = STATE(965),
    [sym_preproc_define] = STATE(965),
    [sym_preproc_undef] = STATE(965),
    [aux_sym_class_declaration_repeat1] = STATE(3789),
    [aux_sym_lambda_expression_repeat1] = STATE(4086),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1137),
    [anon_sym_ref] = ACTIONS(1139),
    [anon_sym_LBRACE] = ACTIONS(2833),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1145),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1153),
    [anon_sym_TILDE] = ACTIONS(1153),
    [anon_sym_PLUS_PLUS] = ACTIONS(1153),
    [anon_sym_DASH_DASH] = ACTIONS(1153),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1151),
    [anon_sym_DASH] = ACTIONS(1151),
    [anon_sym_STAR] = ACTIONS(1157),
    [anon_sym_CARET] = ACTIONS(1153),
    [anon_sym_AMP] = ACTIONS(1153),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1165),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1167),
    [anon_sym_DOT_DOT] = ACTIONS(1169),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [966] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4003),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6879),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2935),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7096),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5496),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4288),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7379),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9175),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(966),
    [sym_preproc_endregion] = STATE(966),
    [sym_preproc_line] = STATE(966),
    [sym_preproc_pragma] = STATE(966),
    [sym_preproc_nullable] = STATE(966),
    [sym_preproc_error] = STATE(966),
    [sym_preproc_define] = STATE(966),
    [sym_preproc_undef] = STATE(966),
    [aux_sym_class_declaration_repeat1] = STATE(3816),
    [aux_sym_lambda_expression_repeat1] = STATE(4119),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1867),
    [anon_sym_ref] = ACTIONS(1869),
    [anon_sym_LBRACE] = ACTIONS(2833),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1871),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1875),
    [anon_sym_TILDE] = ACTIONS(1875),
    [anon_sym_PLUS_PLUS] = ACTIONS(1875),
    [anon_sym_DASH_DASH] = ACTIONS(1875),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1873),
    [anon_sym_DASH] = ACTIONS(1873),
    [anon_sym_STAR] = ACTIONS(1877),
    [anon_sym_CARET] = ACTIONS(1875),
    [anon_sym_AMP] = ACTIONS(1875),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1879),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1881),
    [anon_sym_DOT_DOT] = ACTIONS(1883),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [967] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6035),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(967),
    [sym_preproc_endregion] = STATE(967),
    [sym_preproc_line] = STATE(967),
    [sym_preproc_pragma] = STATE(967),
    [sym_preproc_nullable] = STATE(967),
    [sym_preproc_error] = STATE(967),
    [sym_preproc_define] = STATE(967),
    [sym_preproc_undef] = STATE(967),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_RPAREN] = ACTIONS(2871),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [968] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6037),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(968),
    [sym_preproc_endregion] = STATE(968),
    [sym_preproc_line] = STATE(968),
    [sym_preproc_pragma] = STATE(968),
    [sym_preproc_nullable] = STATE(968),
    [sym_preproc_error] = STATE(968),
    [sym_preproc_define] = STATE(968),
    [sym_preproc_undef] = STATE(968),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_RPAREN] = ACTIONS(2873),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [969] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3934),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6913),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7016),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4431),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(3582),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7407),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9275),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(969),
    [sym_preproc_endregion] = STATE(969),
    [sym_preproc_line] = STATE(969),
    [sym_preproc_pragma] = STATE(969),
    [sym_preproc_nullable] = STATE(969),
    [sym_preproc_error] = STATE(969),
    [sym_preproc_define] = STATE(969),
    [sym_preproc_undef] = STATE(969),
    [aux_sym_class_declaration_repeat1] = STATE(3789),
    [aux_sym_lambda_expression_repeat1] = STATE(4086),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1137),
    [anon_sym_ref] = ACTIONS(1139),
    [anon_sym_LBRACE] = ACTIONS(2833),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1145),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1153),
    [anon_sym_TILDE] = ACTIONS(1153),
    [anon_sym_PLUS_PLUS] = ACTIONS(1153),
    [anon_sym_DASH_DASH] = ACTIONS(1153),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1151),
    [anon_sym_DASH] = ACTIONS(1151),
    [anon_sym_STAR] = ACTIONS(1157),
    [anon_sym_CARET] = ACTIONS(1153),
    [anon_sym_AMP] = ACTIONS(1153),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1165),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1167),
    [anon_sym_DOT_DOT] = ACTIONS(1169),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [970] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3934),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6879),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2935),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7096),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5497),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4288),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7379),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9175),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(970),
    [sym_preproc_endregion] = STATE(970),
    [sym_preproc_line] = STATE(970),
    [sym_preproc_pragma] = STATE(970),
    [sym_preproc_nullable] = STATE(970),
    [sym_preproc_error] = STATE(970),
    [sym_preproc_define] = STATE(970),
    [sym_preproc_undef] = STATE(970),
    [aux_sym_class_declaration_repeat1] = STATE(3816),
    [aux_sym_lambda_expression_repeat1] = STATE(4119),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1867),
    [anon_sym_ref] = ACTIONS(1869),
    [anon_sym_LBRACE] = ACTIONS(2833),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1871),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1875),
    [anon_sym_TILDE] = ACTIONS(1875),
    [anon_sym_PLUS_PLUS] = ACTIONS(1875),
    [anon_sym_DASH_DASH] = ACTIONS(1875),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1873),
    [anon_sym_DASH] = ACTIONS(1873),
    [anon_sym_STAR] = ACTIONS(1877),
    [anon_sym_CARET] = ACTIONS(1875),
    [anon_sym_AMP] = ACTIONS(1875),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1879),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1881),
    [anon_sym_DOT_DOT] = ACTIONS(1883),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [971] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4003),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6913),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7016),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4501),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(3582),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7407),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9275),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(971),
    [sym_preproc_endregion] = STATE(971),
    [sym_preproc_line] = STATE(971),
    [sym_preproc_pragma] = STATE(971),
    [sym_preproc_nullable] = STATE(971),
    [sym_preproc_error] = STATE(971),
    [sym_preproc_define] = STATE(971),
    [sym_preproc_undef] = STATE(971),
    [aux_sym_class_declaration_repeat1] = STATE(3789),
    [aux_sym_lambda_expression_repeat1] = STATE(4086),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1137),
    [anon_sym_ref] = ACTIONS(1139),
    [anon_sym_LBRACE] = ACTIONS(2833),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1145),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1153),
    [anon_sym_TILDE] = ACTIONS(1153),
    [anon_sym_PLUS_PLUS] = ACTIONS(1153),
    [anon_sym_DASH_DASH] = ACTIONS(1153),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1151),
    [anon_sym_DASH] = ACTIONS(1151),
    [anon_sym_STAR] = ACTIONS(1157),
    [anon_sym_CARET] = ACTIONS(1153),
    [anon_sym_AMP] = ACTIONS(1153),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1165),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1167),
    [anon_sym_DOT_DOT] = ACTIONS(1169),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [972] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3977),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6879),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2935),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7096),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5498),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4288),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7379),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9175),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(972),
    [sym_preproc_endregion] = STATE(972),
    [sym_preproc_line] = STATE(972),
    [sym_preproc_pragma] = STATE(972),
    [sym_preproc_nullable] = STATE(972),
    [sym_preproc_error] = STATE(972),
    [sym_preproc_define] = STATE(972),
    [sym_preproc_undef] = STATE(972),
    [aux_sym_class_declaration_repeat1] = STATE(3816),
    [aux_sym_lambda_expression_repeat1] = STATE(4119),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1867),
    [anon_sym_ref] = ACTIONS(1869),
    [anon_sym_LBRACE] = ACTIONS(2833),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1871),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1875),
    [anon_sym_TILDE] = ACTIONS(1875),
    [anon_sym_PLUS_PLUS] = ACTIONS(1875),
    [anon_sym_DASH_DASH] = ACTIONS(1875),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1873),
    [anon_sym_DASH] = ACTIONS(1873),
    [anon_sym_STAR] = ACTIONS(1877),
    [anon_sym_CARET] = ACTIONS(1875),
    [anon_sym_AMP] = ACTIONS(1875),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1879),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1881),
    [anon_sym_DOT_DOT] = ACTIONS(1883),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [973] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3767),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7094),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5894),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(973),
    [sym_preproc_endregion] = STATE(973),
    [sym_preproc_line] = STATE(973),
    [sym_preproc_pragma] = STATE(973),
    [sym_preproc_nullable] = STATE(973),
    [sym_preproc_error] = STATE(973),
    [sym_preproc_define] = STATE(973),
    [sym_preproc_undef] = STATE(973),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(2765),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1669),
    [anon_sym_TILDE] = ACTIONS(1669),
    [anon_sym_PLUS_PLUS] = ACTIONS(1669),
    [anon_sym_DASH_DASH] = ACTIONS(1669),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1667),
    [anon_sym_DASH] = ACTIONS(1667),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1669),
    [anon_sym_AMP] = ACTIONS(1669),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [974] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4050),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6913),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7016),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4512),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(3582),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7407),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9275),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(974),
    [sym_preproc_endregion] = STATE(974),
    [sym_preproc_line] = STATE(974),
    [sym_preproc_pragma] = STATE(974),
    [sym_preproc_nullable] = STATE(974),
    [sym_preproc_error] = STATE(974),
    [sym_preproc_define] = STATE(974),
    [sym_preproc_undef] = STATE(974),
    [aux_sym_class_declaration_repeat1] = STATE(3789),
    [aux_sym_lambda_expression_repeat1] = STATE(4086),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1137),
    [anon_sym_ref] = ACTIONS(1139),
    [anon_sym_LBRACE] = ACTIONS(2833),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1145),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1153),
    [anon_sym_TILDE] = ACTIONS(1153),
    [anon_sym_PLUS_PLUS] = ACTIONS(1153),
    [anon_sym_DASH_DASH] = ACTIONS(1153),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1151),
    [anon_sym_DASH] = ACTIONS(1151),
    [anon_sym_STAR] = ACTIONS(1157),
    [anon_sym_CARET] = ACTIONS(1153),
    [anon_sym_AMP] = ACTIONS(1153),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1165),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1167),
    [anon_sym_DOT_DOT] = ACTIONS(1169),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [975] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6909),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2874),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7063),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5506),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4291),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7411),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9300),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(975),
    [sym_preproc_endregion] = STATE(975),
    [sym_preproc_line] = STATE(975),
    [sym_preproc_pragma] = STATE(975),
    [sym_preproc_nullable] = STATE(975),
    [sym_preproc_error] = STATE(975),
    [sym_preproc_define] = STATE(975),
    [sym_preproc_undef] = STATE(975),
    [aux_sym_class_declaration_repeat1] = STATE(3804),
    [aux_sym_lambda_expression_repeat1] = STATE(4114),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1501),
    [anon_sym_ref] = ACTIONS(1503),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1505),
    [anon_sym_readonly] = ACTIONS(2693),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1509),
    [anon_sym_PLUS_PLUS] = ACTIONS(1509),
    [anon_sym_DASH_DASH] = ACTIONS(1509),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1507),
    [anon_sym_DASH] = ACTIONS(1507),
    [anon_sym_STAR] = ACTIONS(1511),
    [anon_sym_CARET] = ACTIONS(1509),
    [anon_sym_AMP] = ACTIONS(1509),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1513),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1515),
    [anon_sym_DOT_DOT] = ACTIONS(1517),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [976] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4065),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6913),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7016),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4514),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(3582),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7407),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9275),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(976),
    [sym_preproc_endregion] = STATE(976),
    [sym_preproc_line] = STATE(976),
    [sym_preproc_pragma] = STATE(976),
    [sym_preproc_nullable] = STATE(976),
    [sym_preproc_error] = STATE(976),
    [sym_preproc_define] = STATE(976),
    [sym_preproc_undef] = STATE(976),
    [aux_sym_class_declaration_repeat1] = STATE(3789),
    [aux_sym_lambda_expression_repeat1] = STATE(4086),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1137),
    [anon_sym_ref] = ACTIONS(1139),
    [anon_sym_LBRACE] = ACTIONS(2833),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1145),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1153),
    [anon_sym_TILDE] = ACTIONS(1153),
    [anon_sym_PLUS_PLUS] = ACTIONS(1153),
    [anon_sym_DASH_DASH] = ACTIONS(1153),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1151),
    [anon_sym_DASH] = ACTIONS(1151),
    [anon_sym_STAR] = ACTIONS(1157),
    [anon_sym_CARET] = ACTIONS(1153),
    [anon_sym_AMP] = ACTIONS(1153),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1165),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1167),
    [anon_sym_DOT_DOT] = ACTIONS(1169),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [977] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6879),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2935),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7095),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5499),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4288),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7379),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9175),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(977),
    [sym_preproc_endregion] = STATE(977),
    [sym_preproc_line] = STATE(977),
    [sym_preproc_pragma] = STATE(977),
    [sym_preproc_nullable] = STATE(977),
    [sym_preproc_error] = STATE(977),
    [sym_preproc_define] = STATE(977),
    [sym_preproc_undef] = STATE(977),
    [aux_sym_class_declaration_repeat1] = STATE(3816),
    [aux_sym_lambda_expression_repeat1] = STATE(4119),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1867),
    [anon_sym_ref] = ACTIONS(1869),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1871),
    [anon_sym_readonly] = ACTIONS(2693),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1875),
    [anon_sym_TILDE] = ACTIONS(1875),
    [anon_sym_PLUS_PLUS] = ACTIONS(1875),
    [anon_sym_DASH_DASH] = ACTIONS(1875),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1873),
    [anon_sym_DASH] = ACTIONS(1873),
    [anon_sym_STAR] = ACTIONS(1877),
    [anon_sym_CARET] = ACTIONS(1875),
    [anon_sym_AMP] = ACTIONS(1875),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1879),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1881),
    [anon_sym_DOT_DOT] = ACTIONS(1883),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [978] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6139),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym__anonymous_object_member_declarator] = STATE(8829),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2858),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(978),
    [sym_preproc_endregion] = STATE(978),
    [sym_preproc_line] = STATE(978),
    [sym_preproc_pragma] = STATE(978),
    [sym_preproc_nullable] = STATE(978),
    [sym_preproc_error] = STATE(978),
    [sym_preproc_define] = STATE(978),
    [sym_preproc_undef] = STATE(978),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [979] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3726),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7080),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6353),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4477),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9873),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(979),
    [sym_preproc_endregion] = STATE(979),
    [sym_preproc_line] = STATE(979),
    [sym_preproc_pragma] = STATE(979),
    [sym_preproc_nullable] = STATE(979),
    [sym_preproc_error] = STATE(979),
    [sym_preproc_define] = STATE(979),
    [sym_preproc_undef] = STATE(979),
    [aux_sym_class_declaration_repeat1] = STATE(3845),
    [aux_sym_lambda_expression_repeat1] = STATE(4299),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1979),
    [anon_sym_ref] = ACTIONS(1981),
    [anon_sym_LBRACE] = ACTIONS(2765),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1985),
    [anon_sym_TILDE] = ACTIONS(1985),
    [anon_sym_PLUS_PLUS] = ACTIONS(1985),
    [anon_sym_DASH_DASH] = ACTIONS(1985),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1983),
    [anon_sym_DASH] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1985),
    [anon_sym_AMP] = ACTIONS(1985),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1987),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1989),
    [anon_sym_DOT_DOT] = ACTIONS(1991),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [980] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4007),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6913),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7016),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4505),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(3582),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7407),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9275),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(980),
    [sym_preproc_endregion] = STATE(980),
    [sym_preproc_line] = STATE(980),
    [sym_preproc_pragma] = STATE(980),
    [sym_preproc_nullable] = STATE(980),
    [sym_preproc_error] = STATE(980),
    [sym_preproc_define] = STATE(980),
    [sym_preproc_undef] = STATE(980),
    [aux_sym_class_declaration_repeat1] = STATE(3789),
    [aux_sym_lambda_expression_repeat1] = STATE(4086),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1137),
    [anon_sym_ref] = ACTIONS(1139),
    [anon_sym_LBRACE] = ACTIONS(2833),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1145),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1153),
    [anon_sym_TILDE] = ACTIONS(1153),
    [anon_sym_PLUS_PLUS] = ACTIONS(1153),
    [anon_sym_DASH_DASH] = ACTIONS(1153),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1151),
    [anon_sym_DASH] = ACTIONS(1151),
    [anon_sym_STAR] = ACTIONS(1157),
    [anon_sym_CARET] = ACTIONS(1153),
    [anon_sym_AMP] = ACTIONS(1153),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1165),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1167),
    [anon_sym_DOT_DOT] = ACTIONS(1169),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [981] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3921),
    [sym__name] = STATE(6919),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2868),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(7083),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5821),
    [sym_non_lvalue_expression] = STATE(5735),
    [sym_lvalue_expression] = STATE(4323),
    [sym__expression_statement_expression] = STATE(5733),
    [sym_assignment_expression] = STATE(5734),
    [sym_binary_expression] = STATE(5733),
    [sym_postfix_unary_expression] = STATE(5734),
    [sym_prefix_unary_expression] = STATE(5734),
    [sym__pointer_indirection_expression] = STATE(3911),
    [sym_query_expression] = STATE(5733),
    [sym_from_clause] = STATE(7393),
    [sym_conditional_expression] = STATE(5733),
    [sym_conditional_access_expression] = STATE(5733),
    [sym_as_expression] = STATE(5733),
    [sym_is_expression] = STATE(5733),
    [sym_is_pattern_expression] = STATE(5733),
    [sym_cast_expression] = STATE(5733),
    [sym_checked_expression] = STATE(5733),
    [sym_invocation_expression] = STATE(5734),
    [sym_switch_expression] = STATE(5733),
    [sym_await_expression] = STATE(5734),
    [sym_throw_expression] = STATE(5733),
    [sym_element_access_expression] = STATE(3911),
    [sym_interpolated_string_expression] = STATE(5733),
    [sym_member_access_expression] = STATE(3911),
    [sym_object_creation_expression] = STATE(5734),
    [sym_parenthesized_expression] = STATE(5734),
    [sym__parenthesized_lvalue_expression] = STATE(3911),
    [sym_lambda_expression] = STATE(5733),
    [sym__lambda_parameters] = STATE(9932),
    [sym_array_creation_expression] = STATE(5733),
    [sym_anonymous_method_expression] = STATE(5733),
    [sym_anonymous_object_creation_expression] = STATE(5733),
    [sym_implicit_array_creation_expression] = STATE(5733),
    [sym_implicit_object_creation_expression] = STATE(5733),
    [sym_implicit_stackalloc_expression] = STATE(5733),
    [sym_initializer_expression] = STATE(5733),
    [sym_default_expression] = STATE(5733),
    [sym_with_expression] = STATE(5733),
    [sym_sizeof_expression] = STATE(5733),
    [sym_typeof_expression] = STATE(5733),
    [sym_makeref_expression] = STATE(5733),
    [sym_ref_expression] = STATE(5733),
    [sym_reftype_expression] = STATE(5733),
    [sym_refvalue_expression] = STATE(5733),
    [sym_stackalloc_expression] = STATE(5733),
    [sym_range_expression] = STATE(5733),
    [sym_tuple_expression] = STATE(3911),
    [sym_literal] = STATE(5733),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2798),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(5733),
    [sym_preproc_region] = STATE(981),
    [sym_preproc_endregion] = STATE(981),
    [sym_preproc_line] = STATE(981),
    [sym_preproc_pragma] = STATE(981),
    [sym_preproc_nullable] = STATE(981),
    [sym_preproc_error] = STATE(981),
    [sym_preproc_define] = STATE(981),
    [sym_preproc_undef] = STATE(981),
    [aux_sym_class_declaration_repeat1] = STATE(3831),
    [aux_sym_lambda_expression_repeat1] = STATE(4227),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_LPAREN] = ACTIONS(1577),
    [anon_sym_ref] = ACTIONS(1579),
    [anon_sym_LBRACE] = ACTIONS(1377),
    [anon_sym_delegate] = ACTIONS(1379),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1381),
    [anon_sym_readonly] = ACTIONS(2693),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1583),
    [anon_sym_TILDE] = ACTIONS(1583),
    [anon_sym_PLUS_PLUS] = ACTIONS(1583),
    [anon_sym_DASH_DASH] = ACTIONS(1583),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1581),
    [anon_sym_DASH] = ACTIONS(1581),
    [anon_sym_STAR] = ACTIONS(1391),
    [anon_sym_CARET] = ACTIONS(1583),
    [anon_sym_AMP] = ACTIONS(1583),
    [anon_sym_this] = ACTIONS(1393),
    [anon_sym_scoped] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1397),
    [sym_predefined_type] = ACTIONS(1399),
    [anon_sym_unchecked] = ACTIONS(1383),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1585),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1587),
    [anon_sym_DOT_DOT] = ACTIONS(1589),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_stackalloc] = ACTIONS(1413),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(1419),
    [anon_sym___reftype] = ACTIONS(1421),
    [anon_sym___refvalue] = ACTIONS(1423),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
  },
  [982] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3769),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7080),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6316),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4477),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9873),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(982),
    [sym_preproc_endregion] = STATE(982),
    [sym_preproc_line] = STATE(982),
    [sym_preproc_pragma] = STATE(982),
    [sym_preproc_nullable] = STATE(982),
    [sym_preproc_error] = STATE(982),
    [sym_preproc_define] = STATE(982),
    [sym_preproc_undef] = STATE(982),
    [aux_sym_class_declaration_repeat1] = STATE(3845),
    [aux_sym_lambda_expression_repeat1] = STATE(4299),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1979),
    [anon_sym_ref] = ACTIONS(1981),
    [anon_sym_LBRACE] = ACTIONS(2765),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1985),
    [anon_sym_TILDE] = ACTIONS(1985),
    [anon_sym_PLUS_PLUS] = ACTIONS(1985),
    [anon_sym_DASH_DASH] = ACTIONS(1985),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1983),
    [anon_sym_DASH] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1985),
    [anon_sym_AMP] = ACTIONS(1985),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1987),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1989),
    [anon_sym_DOT_DOT] = ACTIONS(1991),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [983] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4132),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6901),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2939),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7085),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5846),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4322),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7392),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9185),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(983),
    [sym_preproc_endregion] = STATE(983),
    [sym_preproc_line] = STATE(983),
    [sym_preproc_pragma] = STATE(983),
    [sym_preproc_nullable] = STATE(983),
    [sym_preproc_error] = STATE(983),
    [sym_preproc_define] = STATE(983),
    [sym_preproc_undef] = STATE(983),
    [aux_sym_class_declaration_repeat1] = STATE(3819),
    [aux_sym_lambda_expression_repeat1] = STATE(4161),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_ref] = ACTIONS(1761),
    [anon_sym_LBRACE] = ACTIONS(2761),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1763),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1767),
    [anon_sym_TILDE] = ACTIONS(1767),
    [anon_sym_PLUS_PLUS] = ACTIONS(1767),
    [anon_sym_DASH_DASH] = ACTIONS(1767),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1765),
    [anon_sym_STAR] = ACTIONS(1769),
    [anon_sym_CARET] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(1767),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1771),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1773),
    [anon_sym_DOT_DOT] = ACTIONS(1775),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [984] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4085),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6901),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2939),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7085),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5845),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4322),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7392),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9185),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(984),
    [sym_preproc_endregion] = STATE(984),
    [sym_preproc_line] = STATE(984),
    [sym_preproc_pragma] = STATE(984),
    [sym_preproc_nullable] = STATE(984),
    [sym_preproc_error] = STATE(984),
    [sym_preproc_define] = STATE(984),
    [sym_preproc_undef] = STATE(984),
    [aux_sym_class_declaration_repeat1] = STATE(3819),
    [aux_sym_lambda_expression_repeat1] = STATE(4161),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_ref] = ACTIONS(1761),
    [anon_sym_LBRACE] = ACTIONS(2761),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1763),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1767),
    [anon_sym_TILDE] = ACTIONS(1767),
    [anon_sym_PLUS_PLUS] = ACTIONS(1767),
    [anon_sym_DASH_DASH] = ACTIONS(1767),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1765),
    [anon_sym_STAR] = ACTIONS(1769),
    [anon_sym_CARET] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(1767),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1771),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1773),
    [anon_sym_DOT_DOT] = ACTIONS(1775),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [985] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(5607),
    [sym_bracketed_argument_list] = STATE(3921),
    [sym__name] = STATE(6919),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2868),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(6950),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5246),
    [sym_non_lvalue_expression] = STATE(5735),
    [sym_lvalue_expression] = STATE(4054),
    [sym__expression_statement_expression] = STATE(5733),
    [sym_assignment_expression] = STATE(5734),
    [sym_binary_expression] = STATE(5733),
    [sym_postfix_unary_expression] = STATE(5734),
    [sym_prefix_unary_expression] = STATE(5734),
    [sym__pointer_indirection_expression] = STATE(3911),
    [sym_query_expression] = STATE(5733),
    [sym_from_clause] = STATE(7400),
    [sym_conditional_expression] = STATE(5733),
    [sym_conditional_access_expression] = STATE(5733),
    [sym_as_expression] = STATE(5733),
    [sym_is_expression] = STATE(5733),
    [sym_is_pattern_expression] = STATE(5733),
    [sym_cast_expression] = STATE(5733),
    [sym_checked_expression] = STATE(5733),
    [sym_invocation_expression] = STATE(5734),
    [sym_switch_expression] = STATE(5733),
    [sym_await_expression] = STATE(5734),
    [sym_throw_expression] = STATE(5733),
    [sym_element_access_expression] = STATE(3911),
    [sym_interpolated_string_expression] = STATE(5733),
    [sym_member_access_expression] = STATE(3911),
    [sym_object_creation_expression] = STATE(5734),
    [sym_parenthesized_expression] = STATE(5734),
    [sym__parenthesized_lvalue_expression] = STATE(3911),
    [sym_lambda_expression] = STATE(5733),
    [sym__lambda_parameters] = STATE(9693),
    [sym_array_creation_expression] = STATE(5733),
    [sym_anonymous_method_expression] = STATE(5733),
    [sym_anonymous_object_creation_expression] = STATE(5733),
    [sym_implicit_array_creation_expression] = STATE(5733),
    [sym_implicit_object_creation_expression] = STATE(5733),
    [sym_implicit_stackalloc_expression] = STATE(5733),
    [sym_initializer_expression] = STATE(5733),
    [sym_default_expression] = STATE(5733),
    [sym_with_expression] = STATE(5733),
    [sym_sizeof_expression] = STATE(5733),
    [sym_typeof_expression] = STATE(5733),
    [sym_makeref_expression] = STATE(5733),
    [sym_ref_expression] = STATE(5733),
    [sym_reftype_expression] = STATE(5733),
    [sym_refvalue_expression] = STATE(5733),
    [sym_stackalloc_expression] = STATE(5733),
    [sym_range_expression] = STATE(5733),
    [sym_tuple_expression] = STATE(3911),
    [sym_literal] = STATE(5733),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2798),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(5733),
    [sym_preproc_region] = STATE(985),
    [sym_preproc_endregion] = STATE(985),
    [sym_preproc_line] = STATE(985),
    [sym_preproc_pragma] = STATE(985),
    [sym_preproc_nullable] = STATE(985),
    [sym_preproc_error] = STATE(985),
    [sym_preproc_define] = STATE(985),
    [sym_preproc_undef] = STATE(985),
    [aux_sym_class_declaration_repeat1] = STATE(3791),
    [aux_sym_lambda_expression_repeat1] = STATE(4075),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_LPAREN] = ACTIONS(1373),
    [anon_sym_ref] = ACTIONS(1375),
    [anon_sym_LBRACE] = ACTIONS(2773),
    [anon_sym_delegate] = ACTIONS(1379),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1381),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1387),
    [anon_sym_TILDE] = ACTIONS(1387),
    [anon_sym_PLUS_PLUS] = ACTIONS(1387),
    [anon_sym_DASH_DASH] = ACTIONS(1387),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1385),
    [anon_sym_DASH] = ACTIONS(1385),
    [anon_sym_STAR] = ACTIONS(1391),
    [anon_sym_CARET] = ACTIONS(1387),
    [anon_sym_AMP] = ACTIONS(1387),
    [anon_sym_this] = ACTIONS(1393),
    [anon_sym_scoped] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1397),
    [sym_predefined_type] = ACTIONS(1399),
    [anon_sym_unchecked] = ACTIONS(1383),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1403),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1405),
    [anon_sym_DOT_DOT] = ACTIONS(1407),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_stackalloc] = ACTIONS(1413),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(1419),
    [anon_sym___reftype] = ACTIONS(1421),
    [anon_sym___refvalue] = ACTIONS(1423),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
  },
  [986] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4066),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6901),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2939),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7085),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5844),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4322),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7392),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9185),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(986),
    [sym_preproc_endregion] = STATE(986),
    [sym_preproc_line] = STATE(986),
    [sym_preproc_pragma] = STATE(986),
    [sym_preproc_nullable] = STATE(986),
    [sym_preproc_error] = STATE(986),
    [sym_preproc_define] = STATE(986),
    [sym_preproc_undef] = STATE(986),
    [aux_sym_class_declaration_repeat1] = STATE(3819),
    [aux_sym_lambda_expression_repeat1] = STATE(4161),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_ref] = ACTIONS(1761),
    [anon_sym_LBRACE] = ACTIONS(2761),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1763),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1767),
    [anon_sym_TILDE] = ACTIONS(1767),
    [anon_sym_PLUS_PLUS] = ACTIONS(1767),
    [anon_sym_DASH_DASH] = ACTIONS(1767),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1765),
    [anon_sym_STAR] = ACTIONS(1769),
    [anon_sym_CARET] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(1767),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1771),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1773),
    [anon_sym_DOT_DOT] = ACTIONS(1775),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [987] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6898),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2940),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6968),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6430),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4498),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7403),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(8973),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(987),
    [sym_preproc_endregion] = STATE(987),
    [sym_preproc_line] = STATE(987),
    [sym_preproc_pragma] = STATE(987),
    [sym_preproc_nullable] = STATE(987),
    [sym_preproc_error] = STATE(987),
    [sym_preproc_define] = STATE(987),
    [sym_preproc_undef] = STATE(987),
    [aux_sym_class_declaration_repeat1] = STATE(3830),
    [aux_sym_lambda_expression_repeat1] = STATE(4194),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2153),
    [anon_sym_ref] = ACTIONS(2155),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2157),
    [anon_sym_readonly] = ACTIONS(2693),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2161),
    [anon_sym_TILDE] = ACTIONS(2161),
    [anon_sym_PLUS_PLUS] = ACTIONS(2161),
    [anon_sym_DASH_DASH] = ACTIONS(2161),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2159),
    [anon_sym_DASH] = ACTIONS(2159),
    [anon_sym_STAR] = ACTIONS(2163),
    [anon_sym_CARET] = ACTIONS(2161),
    [anon_sym_AMP] = ACTIONS(2161),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2165),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2167),
    [anon_sym_DOT_DOT] = ACTIONS(2169),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [988] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4116),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6901),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2939),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7085),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5838),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4322),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7392),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9185),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(988),
    [sym_preproc_endregion] = STATE(988),
    [sym_preproc_line] = STATE(988),
    [sym_preproc_pragma] = STATE(988),
    [sym_preproc_nullable] = STATE(988),
    [sym_preproc_error] = STATE(988),
    [sym_preproc_define] = STATE(988),
    [sym_preproc_undef] = STATE(988),
    [aux_sym_class_declaration_repeat1] = STATE(3819),
    [aux_sym_lambda_expression_repeat1] = STATE(4161),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_ref] = ACTIONS(1761),
    [anon_sym_LBRACE] = ACTIONS(2761),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1763),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1767),
    [anon_sym_TILDE] = ACTIONS(1767),
    [anon_sym_PLUS_PLUS] = ACTIONS(1767),
    [anon_sym_DASH_DASH] = ACTIONS(1767),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1765),
    [anon_sym_STAR] = ACTIONS(1769),
    [anon_sym_CARET] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(1767),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1771),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1773),
    [anon_sym_DOT_DOT] = ACTIONS(1775),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [989] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3717),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7080),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6323),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4477),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9873),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(989),
    [sym_preproc_endregion] = STATE(989),
    [sym_preproc_line] = STATE(989),
    [sym_preproc_pragma] = STATE(989),
    [sym_preproc_nullable] = STATE(989),
    [sym_preproc_error] = STATE(989),
    [sym_preproc_define] = STATE(989),
    [sym_preproc_undef] = STATE(989),
    [aux_sym_class_declaration_repeat1] = STATE(3845),
    [aux_sym_lambda_expression_repeat1] = STATE(4299),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1979),
    [anon_sym_ref] = ACTIONS(1981),
    [anon_sym_LBRACE] = ACTIONS(2765),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1985),
    [anon_sym_TILDE] = ACTIONS(1985),
    [anon_sym_PLUS_PLUS] = ACTIONS(1985),
    [anon_sym_DASH_DASH] = ACTIONS(1985),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1983),
    [anon_sym_DASH] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1985),
    [anon_sym_AMP] = ACTIONS(1985),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1987),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1989),
    [anon_sym_DOT_DOT] = ACTIONS(1991),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [990] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4151),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6901),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2939),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7085),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5836),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4322),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7392),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9185),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(990),
    [sym_preproc_endregion] = STATE(990),
    [sym_preproc_line] = STATE(990),
    [sym_preproc_pragma] = STATE(990),
    [sym_preproc_nullable] = STATE(990),
    [sym_preproc_error] = STATE(990),
    [sym_preproc_define] = STATE(990),
    [sym_preproc_undef] = STATE(990),
    [aux_sym_class_declaration_repeat1] = STATE(3819),
    [aux_sym_lambda_expression_repeat1] = STATE(4161),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_ref] = ACTIONS(1761),
    [anon_sym_LBRACE] = ACTIONS(2761),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1763),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1767),
    [anon_sym_TILDE] = ACTIONS(1767),
    [anon_sym_PLUS_PLUS] = ACTIONS(1767),
    [anon_sym_DASH_DASH] = ACTIONS(1767),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1765),
    [anon_sym_STAR] = ACTIONS(1769),
    [anon_sym_CARET] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(1767),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1771),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1773),
    [anon_sym_DOT_DOT] = ACTIONS(1775),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [991] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4188),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6901),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2939),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7085),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5769),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4322),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7392),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9185),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(991),
    [sym_preproc_endregion] = STATE(991),
    [sym_preproc_line] = STATE(991),
    [sym_preproc_pragma] = STATE(991),
    [sym_preproc_nullable] = STATE(991),
    [sym_preproc_error] = STATE(991),
    [sym_preproc_define] = STATE(991),
    [sym_preproc_undef] = STATE(991),
    [aux_sym_class_declaration_repeat1] = STATE(3819),
    [aux_sym_lambda_expression_repeat1] = STATE(4161),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_ref] = ACTIONS(1761),
    [anon_sym_LBRACE] = ACTIONS(2761),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1763),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1767),
    [anon_sym_TILDE] = ACTIONS(1767),
    [anon_sym_PLUS_PLUS] = ACTIONS(1767),
    [anon_sym_DASH_DASH] = ACTIONS(1767),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1765),
    [anon_sym_STAR] = ACTIONS(1769),
    [anon_sym_CARET] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(1767),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1771),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1773),
    [anon_sym_DOT_DOT] = ACTIONS(1775),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [992] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(5649),
    [sym_bracketed_argument_list] = STATE(3921),
    [sym__name] = STATE(6919),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2868),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(6950),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5229),
    [sym_non_lvalue_expression] = STATE(5735),
    [sym_lvalue_expression] = STATE(4054),
    [sym__expression_statement_expression] = STATE(5733),
    [sym_assignment_expression] = STATE(5734),
    [sym_binary_expression] = STATE(5733),
    [sym_postfix_unary_expression] = STATE(5734),
    [sym_prefix_unary_expression] = STATE(5734),
    [sym__pointer_indirection_expression] = STATE(3911),
    [sym_query_expression] = STATE(5733),
    [sym_from_clause] = STATE(7400),
    [sym_conditional_expression] = STATE(5733),
    [sym_conditional_access_expression] = STATE(5733),
    [sym_as_expression] = STATE(5733),
    [sym_is_expression] = STATE(5733),
    [sym_is_pattern_expression] = STATE(5733),
    [sym_cast_expression] = STATE(5733),
    [sym_checked_expression] = STATE(5733),
    [sym_invocation_expression] = STATE(5734),
    [sym_switch_expression] = STATE(5733),
    [sym_await_expression] = STATE(5734),
    [sym_throw_expression] = STATE(5733),
    [sym_element_access_expression] = STATE(3911),
    [sym_interpolated_string_expression] = STATE(5733),
    [sym_member_access_expression] = STATE(3911),
    [sym_object_creation_expression] = STATE(5734),
    [sym_parenthesized_expression] = STATE(5734),
    [sym__parenthesized_lvalue_expression] = STATE(3911),
    [sym_lambda_expression] = STATE(5733),
    [sym__lambda_parameters] = STATE(9693),
    [sym_array_creation_expression] = STATE(5733),
    [sym_anonymous_method_expression] = STATE(5733),
    [sym_anonymous_object_creation_expression] = STATE(5733),
    [sym_implicit_array_creation_expression] = STATE(5733),
    [sym_implicit_object_creation_expression] = STATE(5733),
    [sym_implicit_stackalloc_expression] = STATE(5733),
    [sym_initializer_expression] = STATE(5733),
    [sym_default_expression] = STATE(5733),
    [sym_with_expression] = STATE(5733),
    [sym_sizeof_expression] = STATE(5733),
    [sym_typeof_expression] = STATE(5733),
    [sym_makeref_expression] = STATE(5733),
    [sym_ref_expression] = STATE(5733),
    [sym_reftype_expression] = STATE(5733),
    [sym_refvalue_expression] = STATE(5733),
    [sym_stackalloc_expression] = STATE(5733),
    [sym_range_expression] = STATE(5733),
    [sym_tuple_expression] = STATE(3911),
    [sym_literal] = STATE(5733),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2798),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(5733),
    [sym_preproc_region] = STATE(992),
    [sym_preproc_endregion] = STATE(992),
    [sym_preproc_line] = STATE(992),
    [sym_preproc_pragma] = STATE(992),
    [sym_preproc_nullable] = STATE(992),
    [sym_preproc_error] = STATE(992),
    [sym_preproc_define] = STATE(992),
    [sym_preproc_undef] = STATE(992),
    [aux_sym_class_declaration_repeat1] = STATE(3791),
    [aux_sym_lambda_expression_repeat1] = STATE(4075),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_LPAREN] = ACTIONS(1373),
    [anon_sym_ref] = ACTIONS(1375),
    [anon_sym_LBRACE] = ACTIONS(2773),
    [anon_sym_delegate] = ACTIONS(1379),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1381),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1387),
    [anon_sym_TILDE] = ACTIONS(1387),
    [anon_sym_PLUS_PLUS] = ACTIONS(1387),
    [anon_sym_DASH_DASH] = ACTIONS(1387),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1385),
    [anon_sym_DASH] = ACTIONS(1385),
    [anon_sym_STAR] = ACTIONS(1391),
    [anon_sym_CARET] = ACTIONS(1387),
    [anon_sym_AMP] = ACTIONS(1387),
    [anon_sym_this] = ACTIONS(1393),
    [anon_sym_scoped] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1397),
    [sym_predefined_type] = ACTIONS(1399),
    [anon_sym_unchecked] = ACTIONS(1383),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1403),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1405),
    [anon_sym_DOT_DOT] = ACTIONS(1407),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_stackalloc] = ACTIONS(1413),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(1419),
    [anon_sym___reftype] = ACTIONS(1421),
    [anon_sym___refvalue] = ACTIONS(1423),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
  },
  [993] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6067),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(993),
    [sym_preproc_endregion] = STATE(993),
    [sym_preproc_line] = STATE(993),
    [sym_preproc_pragma] = STATE(993),
    [sym_preproc_nullable] = STATE(993),
    [sym_preproc_error] = STATE(993),
    [sym_preproc_define] = STATE(993),
    [sym_preproc_undef] = STATE(993),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_RPAREN] = ACTIONS(2875),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [994] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3717),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7094),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5849),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(994),
    [sym_preproc_endregion] = STATE(994),
    [sym_preproc_line] = STATE(994),
    [sym_preproc_pragma] = STATE(994),
    [sym_preproc_nullable] = STATE(994),
    [sym_preproc_error] = STATE(994),
    [sym_preproc_define] = STATE(994),
    [sym_preproc_undef] = STATE(994),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(2765),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1669),
    [anon_sym_TILDE] = ACTIONS(1669),
    [anon_sym_PLUS_PLUS] = ACTIONS(1669),
    [anon_sym_DASH_DASH] = ACTIONS(1669),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1667),
    [anon_sym_DASH] = ACTIONS(1667),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1669),
    [anon_sym_AMP] = ACTIONS(1669),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [995] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6068),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(995),
    [sym_preproc_endregion] = STATE(995),
    [sym_preproc_line] = STATE(995),
    [sym_preproc_pragma] = STATE(995),
    [sym_preproc_nullable] = STATE(995),
    [sym_preproc_error] = STATE(995),
    [sym_preproc_define] = STATE(995),
    [sym_preproc_undef] = STATE(995),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_RPAREN] = ACTIONS(2877),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [996] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7097),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5391),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9849),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(996),
    [sym_preproc_endregion] = STATE(996),
    [sym_preproc_line] = STATE(996),
    [sym_preproc_pragma] = STATE(996),
    [sym_preproc_nullable] = STATE(996),
    [sym_preproc_error] = STATE(996),
    [sym_preproc_define] = STATE(996),
    [sym_preproc_undef] = STATE(996),
    [aux_sym_class_declaration_repeat1] = STATE(3841),
    [aux_sym_lambda_expression_repeat1] = STATE(4283),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1459),
    [anon_sym_ref] = ACTIONS(1461),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1465),
    [anon_sym_readonly] = ACTIONS(2693),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1467),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1469),
    [anon_sym_DOT_DOT] = ACTIONS(1471),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [997] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4132),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7064),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5176),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(3866),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7382),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9762),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(997),
    [sym_preproc_endregion] = STATE(997),
    [sym_preproc_line] = STATE(997),
    [sym_preproc_pragma] = STATE(997),
    [sym_preproc_nullable] = STATE(997),
    [sym_preproc_error] = STATE(997),
    [sym_preproc_define] = STATE(997),
    [sym_preproc_undef] = STATE(997),
    [aux_sym_class_declaration_repeat1] = STATE(3842),
    [aux_sym_lambda_expression_repeat1] = STATE(4280),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1351),
    [anon_sym_ref] = ACTIONS(1353),
    [anon_sym_LBRACE] = ACTIONS(2761),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1357),
    [anon_sym_TILDE] = ACTIONS(1357),
    [anon_sym_PLUS_PLUS] = ACTIONS(1357),
    [anon_sym_DASH_DASH] = ACTIONS(1357),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1355),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(1357),
    [anon_sym_AMP] = ACTIONS(1357),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1361),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1363),
    [anon_sym_DOT_DOT] = ACTIONS(1365),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [998] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7094),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6420),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(998),
    [sym_preproc_endregion] = STATE(998),
    [sym_preproc_line] = STATE(998),
    [sym_preproc_pragma] = STATE(998),
    [sym_preproc_nullable] = STATE(998),
    [sym_preproc_error] = STATE(998),
    [sym_preproc_define] = STATE(998),
    [sym_preproc_undef] = STATE(998),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1669),
    [anon_sym_TILDE] = ACTIONS(1669),
    [anon_sym_PLUS_PLUS] = ACTIONS(1669),
    [anon_sym_DASH_DASH] = ACTIONS(1669),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1667),
    [anon_sym_DASH] = ACTIONS(1667),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1669),
    [anon_sym_AMP] = ACTIONS(1669),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_if_token3] = ACTIONS(2879),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [999] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4085),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7064),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5177),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(3866),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7382),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9762),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(999),
    [sym_preproc_endregion] = STATE(999),
    [sym_preproc_line] = STATE(999),
    [sym_preproc_pragma] = STATE(999),
    [sym_preproc_nullable] = STATE(999),
    [sym_preproc_error] = STATE(999),
    [sym_preproc_define] = STATE(999),
    [sym_preproc_undef] = STATE(999),
    [aux_sym_class_declaration_repeat1] = STATE(3842),
    [aux_sym_lambda_expression_repeat1] = STATE(4280),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1351),
    [anon_sym_ref] = ACTIONS(1353),
    [anon_sym_LBRACE] = ACTIONS(2761),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1357),
    [anon_sym_TILDE] = ACTIONS(1357),
    [anon_sym_PLUS_PLUS] = ACTIONS(1357),
    [anon_sym_DASH_DASH] = ACTIONS(1357),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1355),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(1357),
    [anon_sym_AMP] = ACTIONS(1357),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1361),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1363),
    [anon_sym_DOT_DOT] = ACTIONS(1365),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1000] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3738),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7080),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6488),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4477),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9873),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1000),
    [sym_preproc_endregion] = STATE(1000),
    [sym_preproc_line] = STATE(1000),
    [sym_preproc_pragma] = STATE(1000),
    [sym_preproc_nullable] = STATE(1000),
    [sym_preproc_error] = STATE(1000),
    [sym_preproc_define] = STATE(1000),
    [sym_preproc_undef] = STATE(1000),
    [aux_sym_class_declaration_repeat1] = STATE(3845),
    [aux_sym_lambda_expression_repeat1] = STATE(4299),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1979),
    [anon_sym_ref] = ACTIONS(1981),
    [anon_sym_LBRACE] = ACTIONS(2765),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1985),
    [anon_sym_TILDE] = ACTIONS(1985),
    [anon_sym_PLUS_PLUS] = ACTIONS(1985),
    [anon_sym_DASH_DASH] = ACTIONS(1985),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1983),
    [anon_sym_DASH] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1985),
    [anon_sym_AMP] = ACTIONS(1985),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1987),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1989),
    [anon_sym_DOT_DOT] = ACTIONS(1991),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1001] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3726),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6898),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2940),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6925),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6490),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4498),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7403),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(8973),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1001),
    [sym_preproc_endregion] = STATE(1001),
    [sym_preproc_line] = STATE(1001),
    [sym_preproc_pragma] = STATE(1001),
    [sym_preproc_nullable] = STATE(1001),
    [sym_preproc_error] = STATE(1001),
    [sym_preproc_define] = STATE(1001),
    [sym_preproc_undef] = STATE(1001),
    [aux_sym_class_declaration_repeat1] = STATE(3830),
    [aux_sym_lambda_expression_repeat1] = STATE(4194),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2153),
    [anon_sym_ref] = ACTIONS(2155),
    [anon_sym_LBRACE] = ACTIONS(2765),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2157),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2161),
    [anon_sym_TILDE] = ACTIONS(2161),
    [anon_sym_PLUS_PLUS] = ACTIONS(2161),
    [anon_sym_DASH_DASH] = ACTIONS(2161),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2159),
    [anon_sym_DASH] = ACTIONS(2159),
    [anon_sym_STAR] = ACTIONS(2163),
    [anon_sym_CARET] = ACTIONS(2161),
    [anon_sym_AMP] = ACTIONS(2161),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2165),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2167),
    [anon_sym_DOT_DOT] = ACTIONS(2169),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1002] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6030),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1002),
    [sym_preproc_endregion] = STATE(1002),
    [sym_preproc_line] = STATE(1002),
    [sym_preproc_pragma] = STATE(1002),
    [sym_preproc_nullable] = STATE(1002),
    [sym_preproc_error] = STATE(1002),
    [sym_preproc_define] = STATE(1002),
    [sym_preproc_undef] = STATE(1002),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_RBRACE] = ACTIONS(2881),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1003] = {
    [sym_attribute_argument] = STATE(8796),
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6195),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2833),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1003),
    [sym_preproc_endregion] = STATE(1003),
    [sym_preproc_line] = STATE(1003),
    [sym_preproc_pragma] = STATE(1003),
    [sym_preproc_nullable] = STATE(1003),
    [sym_preproc_error] = STATE(1003),
    [sym_preproc_define] = STATE(1003),
    [sym_preproc_undef] = STATE(1003),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1004] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4066),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7064),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5178),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(3866),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7382),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9762),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1004),
    [sym_preproc_endregion] = STATE(1004),
    [sym_preproc_line] = STATE(1004),
    [sym_preproc_pragma] = STATE(1004),
    [sym_preproc_nullable] = STATE(1004),
    [sym_preproc_error] = STATE(1004),
    [sym_preproc_define] = STATE(1004),
    [sym_preproc_undef] = STATE(1004),
    [aux_sym_class_declaration_repeat1] = STATE(3842),
    [aux_sym_lambda_expression_repeat1] = STATE(4280),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1351),
    [anon_sym_ref] = ACTIONS(1353),
    [anon_sym_LBRACE] = ACTIONS(2761),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1357),
    [anon_sym_TILDE] = ACTIONS(1357),
    [anon_sym_PLUS_PLUS] = ACTIONS(1357),
    [anon_sym_DASH_DASH] = ACTIONS(1357),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1355),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(1357),
    [anon_sym_AMP] = ACTIONS(1357),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1361),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1363),
    [anon_sym_DOT_DOT] = ACTIONS(1365),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1005] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3769),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6898),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2940),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6925),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6505),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4498),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7403),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(8973),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1005),
    [sym_preproc_endregion] = STATE(1005),
    [sym_preproc_line] = STATE(1005),
    [sym_preproc_pragma] = STATE(1005),
    [sym_preproc_nullable] = STATE(1005),
    [sym_preproc_error] = STATE(1005),
    [sym_preproc_define] = STATE(1005),
    [sym_preproc_undef] = STATE(1005),
    [aux_sym_class_declaration_repeat1] = STATE(3830),
    [aux_sym_lambda_expression_repeat1] = STATE(4194),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2153),
    [anon_sym_ref] = ACTIONS(2155),
    [anon_sym_LBRACE] = ACTIONS(2765),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2157),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2161),
    [anon_sym_TILDE] = ACTIONS(2161),
    [anon_sym_PLUS_PLUS] = ACTIONS(2161),
    [anon_sym_DASH_DASH] = ACTIONS(2161),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2159),
    [anon_sym_DASH] = ACTIONS(2159),
    [anon_sym_STAR] = ACTIONS(2163),
    [anon_sym_CARET] = ACTIONS(2161),
    [anon_sym_AMP] = ACTIONS(2161),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2165),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2167),
    [anon_sym_DOT_DOT] = ACTIONS(2169),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1006] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3767),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7080),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6535),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4477),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9873),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1006),
    [sym_preproc_endregion] = STATE(1006),
    [sym_preproc_line] = STATE(1006),
    [sym_preproc_pragma] = STATE(1006),
    [sym_preproc_nullable] = STATE(1006),
    [sym_preproc_error] = STATE(1006),
    [sym_preproc_define] = STATE(1006),
    [sym_preproc_undef] = STATE(1006),
    [aux_sym_class_declaration_repeat1] = STATE(3845),
    [aux_sym_lambda_expression_repeat1] = STATE(4299),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1979),
    [anon_sym_ref] = ACTIONS(1981),
    [anon_sym_LBRACE] = ACTIONS(2765),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1985),
    [anon_sym_TILDE] = ACTIONS(1985),
    [anon_sym_PLUS_PLUS] = ACTIONS(1985),
    [anon_sym_DASH_DASH] = ACTIONS(1985),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1983),
    [anon_sym_DASH] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1985),
    [anon_sym_AMP] = ACTIONS(1985),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1987),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1989),
    [anon_sym_DOT_DOT] = ACTIONS(1991),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1007] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3751),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7080),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6581),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4477),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9873),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1007),
    [sym_preproc_endregion] = STATE(1007),
    [sym_preproc_line] = STATE(1007),
    [sym_preproc_pragma] = STATE(1007),
    [sym_preproc_nullable] = STATE(1007),
    [sym_preproc_error] = STATE(1007),
    [sym_preproc_define] = STATE(1007),
    [sym_preproc_undef] = STATE(1007),
    [aux_sym_class_declaration_repeat1] = STATE(3845),
    [aux_sym_lambda_expression_repeat1] = STATE(4299),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1979),
    [anon_sym_ref] = ACTIONS(1981),
    [anon_sym_LBRACE] = ACTIONS(2765),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1985),
    [anon_sym_TILDE] = ACTIONS(1985),
    [anon_sym_PLUS_PLUS] = ACTIONS(1985),
    [anon_sym_DASH_DASH] = ACTIONS(1985),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1983),
    [anon_sym_DASH] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1985),
    [anon_sym_AMP] = ACTIONS(1985),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1987),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1989),
    [anon_sym_DOT_DOT] = ACTIONS(1991),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1008] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3615),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6894),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2955),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7025),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4836),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(3735),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7397),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9590),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1008),
    [sym_preproc_endregion] = STATE(1008),
    [sym_preproc_line] = STATE(1008),
    [sym_preproc_pragma] = STATE(1008),
    [sym_preproc_nullable] = STATE(1008),
    [sym_preproc_error] = STATE(1008),
    [sym_preproc_define] = STATE(1008),
    [sym_preproc_undef] = STATE(1008),
    [aux_sym_class_declaration_repeat1] = STATE(3844),
    [aux_sym_lambda_expression_repeat1] = STATE(4245),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1849),
    [anon_sym_ref] = ACTIONS(1851),
    [anon_sym_LBRACE] = ACTIONS(2767),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1853),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1857),
    [anon_sym_TILDE] = ACTIONS(1857),
    [anon_sym_PLUS_PLUS] = ACTIONS(1857),
    [anon_sym_DASH_DASH] = ACTIONS(1857),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1855),
    [anon_sym_DASH] = ACTIONS(1855),
    [anon_sym_STAR] = ACTIONS(1859),
    [anon_sym_CARET] = ACTIONS(1857),
    [anon_sym_AMP] = ACTIONS(1857),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1861),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1863),
    [anon_sym_DOT_DOT] = ACTIONS(1865),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1009] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3717),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6898),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2940),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6925),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6519),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4498),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7403),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(8973),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1009),
    [sym_preproc_endregion] = STATE(1009),
    [sym_preproc_line] = STATE(1009),
    [sym_preproc_pragma] = STATE(1009),
    [sym_preproc_nullable] = STATE(1009),
    [sym_preproc_error] = STATE(1009),
    [sym_preproc_define] = STATE(1009),
    [sym_preproc_undef] = STATE(1009),
    [aux_sym_class_declaration_repeat1] = STATE(3830),
    [aux_sym_lambda_expression_repeat1] = STATE(4194),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2153),
    [anon_sym_ref] = ACTIONS(2155),
    [anon_sym_LBRACE] = ACTIONS(2765),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2157),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2161),
    [anon_sym_TILDE] = ACTIONS(2161),
    [anon_sym_PLUS_PLUS] = ACTIONS(2161),
    [anon_sym_DASH_DASH] = ACTIONS(2161),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2159),
    [anon_sym_DASH] = ACTIONS(2159),
    [anon_sym_STAR] = ACTIONS(2163),
    [anon_sym_CARET] = ACTIONS(2161),
    [anon_sym_AMP] = ACTIONS(2161),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2165),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2167),
    [anon_sym_DOT_DOT] = ACTIONS(2169),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1010] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3934),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6914),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2882),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6963),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5351),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4002),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7386),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9254),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1010),
    [sym_preproc_endregion] = STATE(1010),
    [sym_preproc_line] = STATE(1010),
    [sym_preproc_pragma] = STATE(1010),
    [sym_preproc_nullable] = STATE(1010),
    [sym_preproc_error] = STATE(1010),
    [sym_preproc_define] = STATE(1010),
    [sym_preproc_undef] = STATE(1010),
    [aux_sym_class_declaration_repeat1] = STATE(3797),
    [aux_sym_lambda_expression_repeat1] = STATE(4081),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1727),
    [anon_sym_ref] = ACTIONS(1729),
    [anon_sym_LBRACE] = ACTIONS(2833),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1713),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1733),
    [anon_sym_TILDE] = ACTIONS(1733),
    [anon_sym_PLUS_PLUS] = ACTIONS(1733),
    [anon_sym_DASH_DASH] = ACTIONS(1733),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1731),
    [anon_sym_DASH] = ACTIONS(1731),
    [anon_sym_STAR] = ACTIONS(1735),
    [anon_sym_CARET] = ACTIONS(1733),
    [anon_sym_AMP] = ACTIONS(1733),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1737),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1739),
    [anon_sym_DOT_DOT] = ACTIONS(1741),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1011] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6030),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1011),
    [sym_preproc_endregion] = STATE(1011),
    [sym_preproc_line] = STATE(1011),
    [sym_preproc_pragma] = STATE(1011),
    [sym_preproc_nullable] = STATE(1011),
    [sym_preproc_error] = STATE(1011),
    [sym_preproc_define] = STATE(1011),
    [sym_preproc_undef] = STATE(1011),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_RBRACE] = ACTIONS(2883),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1012] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4003),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6914),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2882),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6963),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5350),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4002),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7386),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9254),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1012),
    [sym_preproc_endregion] = STATE(1012),
    [sym_preproc_line] = STATE(1012),
    [sym_preproc_pragma] = STATE(1012),
    [sym_preproc_nullable] = STATE(1012),
    [sym_preproc_error] = STATE(1012),
    [sym_preproc_define] = STATE(1012),
    [sym_preproc_undef] = STATE(1012),
    [aux_sym_class_declaration_repeat1] = STATE(3797),
    [aux_sym_lambda_expression_repeat1] = STATE(4081),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1727),
    [anon_sym_ref] = ACTIONS(1729),
    [anon_sym_LBRACE] = ACTIONS(2833),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1713),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1733),
    [anon_sym_TILDE] = ACTIONS(1733),
    [anon_sym_PLUS_PLUS] = ACTIONS(1733),
    [anon_sym_DASH_DASH] = ACTIONS(1733),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1731),
    [anon_sym_DASH] = ACTIONS(1731),
    [anon_sym_STAR] = ACTIONS(1735),
    [anon_sym_CARET] = ACTIONS(1733),
    [anon_sym_AMP] = ACTIONS(1733),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1737),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1739),
    [anon_sym_DOT_DOT] = ACTIONS(1741),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1013] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4695),
    [sym_bracketed_argument_list] = STATE(3559),
    [sym__name] = STATE(6878),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2911),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6938),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4859),
    [sym_non_lvalue_expression] = STATE(4553),
    [sym_lvalue_expression] = STATE(3750),
    [sym__expression_statement_expression] = STATE(4559),
    [sym_assignment_expression] = STATE(4558),
    [sym_binary_expression] = STATE(4559),
    [sym_postfix_unary_expression] = STATE(4558),
    [sym_prefix_unary_expression] = STATE(4558),
    [sym__pointer_indirection_expression] = STATE(3560),
    [sym_query_expression] = STATE(4559),
    [sym_from_clause] = STATE(7406),
    [sym_conditional_expression] = STATE(4559),
    [sym_conditional_access_expression] = STATE(4559),
    [sym_as_expression] = STATE(4559),
    [sym_is_expression] = STATE(4559),
    [sym_is_pattern_expression] = STATE(4559),
    [sym_cast_expression] = STATE(4559),
    [sym_checked_expression] = STATE(4559),
    [sym_invocation_expression] = STATE(4558),
    [sym_switch_expression] = STATE(4559),
    [sym_await_expression] = STATE(4558),
    [sym_throw_expression] = STATE(4559),
    [sym_element_access_expression] = STATE(3560),
    [sym_interpolated_string_expression] = STATE(4559),
    [sym_member_access_expression] = STATE(3560),
    [sym_object_creation_expression] = STATE(4558),
    [sym_parenthesized_expression] = STATE(4558),
    [sym__parenthesized_lvalue_expression] = STATE(3560),
    [sym_lambda_expression] = STATE(4559),
    [sym__lambda_parameters] = STATE(9691),
    [sym_array_creation_expression] = STATE(4559),
    [sym_anonymous_method_expression] = STATE(4559),
    [sym_anonymous_object_creation_expression] = STATE(4559),
    [sym_implicit_array_creation_expression] = STATE(4559),
    [sym_implicit_object_creation_expression] = STATE(4559),
    [sym_implicit_stackalloc_expression] = STATE(4559),
    [sym_initializer_expression] = STATE(4559),
    [sym_default_expression] = STATE(4559),
    [sym_with_expression] = STATE(4559),
    [sym_sizeof_expression] = STATE(4559),
    [sym_typeof_expression] = STATE(4559),
    [sym_makeref_expression] = STATE(4559),
    [sym_ref_expression] = STATE(4559),
    [sym_reftype_expression] = STATE(4559),
    [sym_refvalue_expression] = STATE(4559),
    [sym_stackalloc_expression] = STATE(4559),
    [sym_range_expression] = STATE(4559),
    [sym_tuple_expression] = STATE(3560),
    [sym_literal] = STATE(4559),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4559),
    [sym_preproc_region] = STATE(1013),
    [sym_preproc_endregion] = STATE(1013),
    [sym_preproc_line] = STATE(1013),
    [sym_preproc_pragma] = STATE(1013),
    [sym_preproc_nullable] = STATE(1013),
    [sym_preproc_error] = STATE(1013),
    [sym_preproc_define] = STATE(1013),
    [sym_preproc_undef] = STATE(1013),
    [aux_sym_class_declaration_repeat1] = STATE(3836),
    [aux_sym_lambda_expression_repeat1] = STATE(4216),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(2003),
    [anon_sym_ref] = ACTIONS(2005),
    [anon_sym_LBRACE] = ACTIONS(2759),
    [anon_sym_delegate] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1615),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(2009),
    [anon_sym_TILDE] = ACTIONS(2009),
    [anon_sym_PLUS_PLUS] = ACTIONS(2009),
    [anon_sym_DASH_DASH] = ACTIONS(2009),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(2007),
    [anon_sym_DASH] = ACTIONS(2007),
    [anon_sym_STAR] = ACTIONS(1625),
    [anon_sym_CARET] = ACTIONS(2009),
    [anon_sym_AMP] = ACTIONS(2009),
    [anon_sym_this] = ACTIONS(1627),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1629),
    [anon_sym_unchecked] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(2011),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2013),
    [anon_sym_DOT_DOT] = ACTIONS(2015),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_stackalloc] = ACTIONS(1641),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(1647),
    [anon_sym___reftype] = ACTIONS(1649),
    [anon_sym___refvalue] = ACTIONS(1651),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1659),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [1014] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4116),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7064),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5184),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(3866),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7382),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9762),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1014),
    [sym_preproc_endregion] = STATE(1014),
    [sym_preproc_line] = STATE(1014),
    [sym_preproc_pragma] = STATE(1014),
    [sym_preproc_nullable] = STATE(1014),
    [sym_preproc_error] = STATE(1014),
    [sym_preproc_define] = STATE(1014),
    [sym_preproc_undef] = STATE(1014),
    [aux_sym_class_declaration_repeat1] = STATE(3842),
    [aux_sym_lambda_expression_repeat1] = STATE(4280),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1351),
    [anon_sym_ref] = ACTIONS(1353),
    [anon_sym_LBRACE] = ACTIONS(2761),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1357),
    [anon_sym_TILDE] = ACTIONS(1357),
    [anon_sym_PLUS_PLUS] = ACTIONS(1357),
    [anon_sym_DASH_DASH] = ACTIONS(1357),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1355),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(1357),
    [anon_sym_AMP] = ACTIONS(1357),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1361),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1363),
    [anon_sym_DOT_DOT] = ACTIONS(1365),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1015] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3738),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6898),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2940),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6925),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6532),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4498),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7403),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(8973),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1015),
    [sym_preproc_endregion] = STATE(1015),
    [sym_preproc_line] = STATE(1015),
    [sym_preproc_pragma] = STATE(1015),
    [sym_preproc_nullable] = STATE(1015),
    [sym_preproc_error] = STATE(1015),
    [sym_preproc_define] = STATE(1015),
    [sym_preproc_undef] = STATE(1015),
    [aux_sym_class_declaration_repeat1] = STATE(3830),
    [aux_sym_lambda_expression_repeat1] = STATE(4194),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2153),
    [anon_sym_ref] = ACTIONS(2155),
    [anon_sym_LBRACE] = ACTIONS(2765),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2157),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2161),
    [anon_sym_TILDE] = ACTIONS(2161),
    [anon_sym_PLUS_PLUS] = ACTIONS(2161),
    [anon_sym_DASH_DASH] = ACTIONS(2161),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2159),
    [anon_sym_DASH] = ACTIONS(2159),
    [anon_sym_STAR] = ACTIONS(2163),
    [anon_sym_CARET] = ACTIONS(2161),
    [anon_sym_AMP] = ACTIONS(2161),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2165),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2167),
    [anon_sym_DOT_DOT] = ACTIONS(2169),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1016] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3767),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6898),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2940),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6925),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6534),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4498),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7403),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(8973),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1016),
    [sym_preproc_endregion] = STATE(1016),
    [sym_preproc_line] = STATE(1016),
    [sym_preproc_pragma] = STATE(1016),
    [sym_preproc_nullable] = STATE(1016),
    [sym_preproc_error] = STATE(1016),
    [sym_preproc_define] = STATE(1016),
    [sym_preproc_undef] = STATE(1016),
    [aux_sym_class_declaration_repeat1] = STATE(3830),
    [aux_sym_lambda_expression_repeat1] = STATE(4194),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2153),
    [anon_sym_ref] = ACTIONS(2155),
    [anon_sym_LBRACE] = ACTIONS(2765),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2157),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2161),
    [anon_sym_TILDE] = ACTIONS(2161),
    [anon_sym_PLUS_PLUS] = ACTIONS(2161),
    [anon_sym_DASH_DASH] = ACTIONS(2161),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2159),
    [anon_sym_DASH] = ACTIONS(2159),
    [anon_sym_STAR] = ACTIONS(2163),
    [anon_sym_CARET] = ACTIONS(2161),
    [anon_sym_AMP] = ACTIONS(2161),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2165),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2167),
    [anon_sym_DOT_DOT] = ACTIONS(2169),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1017] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6071),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1017),
    [sym_preproc_endregion] = STATE(1017),
    [sym_preproc_line] = STATE(1017),
    [sym_preproc_pragma] = STATE(1017),
    [sym_preproc_nullable] = STATE(1017),
    [sym_preproc_error] = STATE(1017),
    [sym_preproc_define] = STATE(1017),
    [sym_preproc_undef] = STATE(1017),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_RPAREN] = ACTIONS(2885),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1018] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6673),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2817),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6661),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5700),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4210),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9027),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1018),
    [sym_preproc_endregion] = STATE(1018),
    [sym_preproc_line] = STATE(1018),
    [sym_preproc_pragma] = STATE(1018),
    [sym_preproc_nullable] = STATE(1018),
    [sym_preproc_error] = STATE(1018),
    [sym_preproc_define] = STATE(1018),
    [sym_preproc_undef] = STATE(1018),
    [aux_sym_class_declaration_repeat1] = STATE(3852),
    [aux_sym_lambda_expression_repeat1] = STATE(4220),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1473),
    [anon_sym_ref] = ACTIONS(2605),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_readonly] = ACTIONS(2795),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(1479),
    [anon_sym_PLUS_PLUS] = ACTIONS(1479),
    [anon_sym_DASH_DASH] = ACTIONS(1479),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1477),
    [anon_sym_DASH] = ACTIONS(1477),
    [anon_sym_STAR] = ACTIONS(1101),
    [anon_sym_CARET] = ACTIONS(1479),
    [anon_sym_AMP] = ACTIONS(1479),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2265),
    [anon_sym_var] = ACTIONS(2565),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1111),
    [anon_sym_DOT_DOT] = ACTIONS(1115),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1019] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3751),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6901),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2939),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7050),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6389),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4507),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7378),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9063),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1019),
    [sym_preproc_endregion] = STATE(1019),
    [sym_preproc_line] = STATE(1019),
    [sym_preproc_pragma] = STATE(1019),
    [sym_preproc_nullable] = STATE(1019),
    [sym_preproc_error] = STATE(1019),
    [sym_preproc_define] = STATE(1019),
    [sym_preproc_undef] = STATE(1019),
    [aux_sym_class_declaration_repeat1] = STATE(3854),
    [aux_sym_lambda_expression_repeat1] = STATE(4229),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2193),
    [anon_sym_ref] = ACTIONS(2195),
    [anon_sym_LBRACE] = ACTIONS(2765),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2197),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2201),
    [anon_sym_TILDE] = ACTIONS(2201),
    [anon_sym_PLUS_PLUS] = ACTIONS(2201),
    [anon_sym_DASH_DASH] = ACTIONS(2201),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2199),
    [anon_sym_DASH] = ACTIONS(2199),
    [anon_sym_STAR] = ACTIONS(2203),
    [anon_sym_CARET] = ACTIONS(2201),
    [anon_sym_AMP] = ACTIONS(2201),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2205),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2207),
    [anon_sym_DOT_DOT] = ACTIONS(2209),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1020] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3767),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6901),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2939),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7050),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6386),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4507),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7378),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9063),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1020),
    [sym_preproc_endregion] = STATE(1020),
    [sym_preproc_line] = STATE(1020),
    [sym_preproc_pragma] = STATE(1020),
    [sym_preproc_nullable] = STATE(1020),
    [sym_preproc_error] = STATE(1020),
    [sym_preproc_define] = STATE(1020),
    [sym_preproc_undef] = STATE(1020),
    [aux_sym_class_declaration_repeat1] = STATE(3854),
    [aux_sym_lambda_expression_repeat1] = STATE(4229),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2193),
    [anon_sym_ref] = ACTIONS(2195),
    [anon_sym_LBRACE] = ACTIONS(2765),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2197),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2201),
    [anon_sym_TILDE] = ACTIONS(2201),
    [anon_sym_PLUS_PLUS] = ACTIONS(2201),
    [anon_sym_DASH_DASH] = ACTIONS(2201),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2199),
    [anon_sym_DASH] = ACTIONS(2199),
    [anon_sym_STAR] = ACTIONS(2203),
    [anon_sym_CARET] = ACTIONS(2201),
    [anon_sym_AMP] = ACTIONS(2201),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2205),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2207),
    [anon_sym_DOT_DOT] = ACTIONS(2209),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1021] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3738),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6901),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2939),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7050),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6371),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4507),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7378),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9063),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1021),
    [sym_preproc_endregion] = STATE(1021),
    [sym_preproc_line] = STATE(1021),
    [sym_preproc_pragma] = STATE(1021),
    [sym_preproc_nullable] = STATE(1021),
    [sym_preproc_error] = STATE(1021),
    [sym_preproc_define] = STATE(1021),
    [sym_preproc_undef] = STATE(1021),
    [aux_sym_class_declaration_repeat1] = STATE(3854),
    [aux_sym_lambda_expression_repeat1] = STATE(4229),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2193),
    [anon_sym_ref] = ACTIONS(2195),
    [anon_sym_LBRACE] = ACTIONS(2765),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2197),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2201),
    [anon_sym_TILDE] = ACTIONS(2201),
    [anon_sym_PLUS_PLUS] = ACTIONS(2201),
    [anon_sym_DASH_DASH] = ACTIONS(2201),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2199),
    [anon_sym_DASH] = ACTIONS(2199),
    [anon_sym_STAR] = ACTIONS(2203),
    [anon_sym_CARET] = ACTIONS(2201),
    [anon_sym_AMP] = ACTIONS(2201),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2205),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2207),
    [anon_sym_DOT_DOT] = ACTIONS(2209),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1022] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6072),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1022),
    [sym_preproc_endregion] = STATE(1022),
    [sym_preproc_line] = STATE(1022),
    [sym_preproc_pragma] = STATE(1022),
    [sym_preproc_nullable] = STATE(1022),
    [sym_preproc_error] = STATE(1022),
    [sym_preproc_define] = STATE(1022),
    [sym_preproc_undef] = STATE(1022),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_RPAREN] = ACTIONS(2887),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1023] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6964),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6651),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4477),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9873),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1023),
    [sym_preproc_endregion] = STATE(1023),
    [sym_preproc_line] = STATE(1023),
    [sym_preproc_pragma] = STATE(1023),
    [sym_preproc_nullable] = STATE(1023),
    [sym_preproc_error] = STATE(1023),
    [sym_preproc_define] = STATE(1023),
    [sym_preproc_undef] = STATE(1023),
    [aux_sym_class_declaration_repeat1] = STATE(3845),
    [aux_sym_lambda_expression_repeat1] = STATE(4299),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1979),
    [anon_sym_ref] = ACTIONS(1981),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_readonly] = ACTIONS(2693),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1985),
    [anon_sym_TILDE] = ACTIONS(1985),
    [anon_sym_PLUS_PLUS] = ACTIONS(1985),
    [anon_sym_DASH_DASH] = ACTIONS(1985),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1983),
    [anon_sym_DASH] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1985),
    [anon_sym_AMP] = ACTIONS(1985),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1987),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1989),
    [anon_sym_DOT_DOT] = ACTIONS(1991),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1024] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3767),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6961),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5394),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9849),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1024),
    [sym_preproc_endregion] = STATE(1024),
    [sym_preproc_line] = STATE(1024),
    [sym_preproc_pragma] = STATE(1024),
    [sym_preproc_nullable] = STATE(1024),
    [sym_preproc_error] = STATE(1024),
    [sym_preproc_define] = STATE(1024),
    [sym_preproc_undef] = STATE(1024),
    [aux_sym_class_declaration_repeat1] = STATE(3841),
    [aux_sym_lambda_expression_repeat1] = STATE(4283),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1459),
    [anon_sym_ref] = ACTIONS(1461),
    [anon_sym_LBRACE] = ACTIONS(2765),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1465),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1467),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1469),
    [anon_sym_DOT_DOT] = ACTIONS(1471),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1025] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3751),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6898),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2940),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6925),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6537),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4498),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7403),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(8973),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1025),
    [sym_preproc_endregion] = STATE(1025),
    [sym_preproc_line] = STATE(1025),
    [sym_preproc_pragma] = STATE(1025),
    [sym_preproc_nullable] = STATE(1025),
    [sym_preproc_error] = STATE(1025),
    [sym_preproc_define] = STATE(1025),
    [sym_preproc_undef] = STATE(1025),
    [aux_sym_class_declaration_repeat1] = STATE(3830),
    [aux_sym_lambda_expression_repeat1] = STATE(4194),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2153),
    [anon_sym_ref] = ACTIONS(2155),
    [anon_sym_LBRACE] = ACTIONS(2765),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2157),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2161),
    [anon_sym_TILDE] = ACTIONS(2161),
    [anon_sym_PLUS_PLUS] = ACTIONS(2161),
    [anon_sym_DASH_DASH] = ACTIONS(2161),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2159),
    [anon_sym_DASH] = ACTIONS(2159),
    [anon_sym_STAR] = ACTIONS(2163),
    [anon_sym_CARET] = ACTIONS(2161),
    [anon_sym_AMP] = ACTIONS(2161),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2165),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2167),
    [anon_sym_DOT_DOT] = ACTIONS(2169),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1026] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3717),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6901),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2939),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7050),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6357),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4507),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7378),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9063),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1026),
    [sym_preproc_endregion] = STATE(1026),
    [sym_preproc_line] = STATE(1026),
    [sym_preproc_pragma] = STATE(1026),
    [sym_preproc_nullable] = STATE(1026),
    [sym_preproc_error] = STATE(1026),
    [sym_preproc_define] = STATE(1026),
    [sym_preproc_undef] = STATE(1026),
    [aux_sym_class_declaration_repeat1] = STATE(3854),
    [aux_sym_lambda_expression_repeat1] = STATE(4229),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2193),
    [anon_sym_ref] = ACTIONS(2195),
    [anon_sym_LBRACE] = ACTIONS(2765),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2197),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2201),
    [anon_sym_TILDE] = ACTIONS(2201),
    [anon_sym_PLUS_PLUS] = ACTIONS(2201),
    [anon_sym_DASH_DASH] = ACTIONS(2201),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2199),
    [anon_sym_DASH] = ACTIONS(2199),
    [anon_sym_STAR] = ACTIONS(2203),
    [anon_sym_CARET] = ACTIONS(2201),
    [anon_sym_AMP] = ACTIONS(2201),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2205),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2207),
    [anon_sym_DOT_DOT] = ACTIONS(2209),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1027] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3738),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6961),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5387),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9849),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1027),
    [sym_preproc_endregion] = STATE(1027),
    [sym_preproc_line] = STATE(1027),
    [sym_preproc_pragma] = STATE(1027),
    [sym_preproc_nullable] = STATE(1027),
    [sym_preproc_error] = STATE(1027),
    [sym_preproc_define] = STATE(1027),
    [sym_preproc_undef] = STATE(1027),
    [aux_sym_class_declaration_repeat1] = STATE(3841),
    [aux_sym_lambda_expression_repeat1] = STATE(4283),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1459),
    [anon_sym_ref] = ACTIONS(1461),
    [anon_sym_LBRACE] = ACTIONS(2765),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1465),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1467),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1469),
    [anon_sym_DOT_DOT] = ACTIONS(1471),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1028] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6080),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1028),
    [sym_preproc_endregion] = STATE(1028),
    [sym_preproc_line] = STATE(1028),
    [sym_preproc_pragma] = STATE(1028),
    [sym_preproc_nullable] = STATE(1028),
    [sym_preproc_error] = STATE(1028),
    [sym_preproc_define] = STATE(1028),
    [sym_preproc_undef] = STATE(1028),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_RPAREN] = ACTIONS(2889),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1029] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3726),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6910),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2957),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6984),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4934),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(3777),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7387),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9385),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1029),
    [sym_preproc_endregion] = STATE(1029),
    [sym_preproc_line] = STATE(1029),
    [sym_preproc_pragma] = STATE(1029),
    [sym_preproc_nullable] = STATE(1029),
    [sym_preproc_error] = STATE(1029),
    [sym_preproc_define] = STATE(1029),
    [sym_preproc_undef] = STATE(1029),
    [aux_sym_class_declaration_repeat1] = STATE(3793),
    [aux_sym_lambda_expression_repeat1] = STATE(4083),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1795),
    [anon_sym_ref] = ACTIONS(1797),
    [anon_sym_LBRACE] = ACTIONS(2765),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1799),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1803),
    [anon_sym_TILDE] = ACTIONS(1803),
    [anon_sym_PLUS_PLUS] = ACTIONS(1803),
    [anon_sym_DASH_DASH] = ACTIONS(1803),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1801),
    [anon_sym_DASH] = ACTIONS(1801),
    [anon_sym_STAR] = ACTIONS(1805),
    [anon_sym_CARET] = ACTIONS(1803),
    [anon_sym_AMP] = ACTIONS(1803),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1807),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1809),
    [anon_sym_DOT_DOT] = ACTIONS(1811),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1030] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3769),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6901),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2939),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7050),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6336),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4507),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7378),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9063),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1030),
    [sym_preproc_endregion] = STATE(1030),
    [sym_preproc_line] = STATE(1030),
    [sym_preproc_pragma] = STATE(1030),
    [sym_preproc_nullable] = STATE(1030),
    [sym_preproc_error] = STATE(1030),
    [sym_preproc_define] = STATE(1030),
    [sym_preproc_undef] = STATE(1030),
    [aux_sym_class_declaration_repeat1] = STATE(3854),
    [aux_sym_lambda_expression_repeat1] = STATE(4229),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2193),
    [anon_sym_ref] = ACTIONS(2195),
    [anon_sym_LBRACE] = ACTIONS(2765),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2197),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2201),
    [anon_sym_TILDE] = ACTIONS(2201),
    [anon_sym_PLUS_PLUS] = ACTIONS(2201),
    [anon_sym_DASH_DASH] = ACTIONS(2201),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2199),
    [anon_sym_DASH] = ACTIONS(2199),
    [anon_sym_STAR] = ACTIONS(2203),
    [anon_sym_CARET] = ACTIONS(2201),
    [anon_sym_AMP] = ACTIONS(2201),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2205),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2207),
    [anon_sym_DOT_DOT] = ACTIONS(2209),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1031] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6722),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2861),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6405),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6513),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4482),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9438),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2795),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1031),
    [sym_preproc_endregion] = STATE(1031),
    [sym_preproc_line] = STATE(1031),
    [sym_preproc_pragma] = STATE(1031),
    [sym_preproc_nullable] = STATE(1031),
    [sym_preproc_error] = STATE(1031),
    [sym_preproc_define] = STATE(1031),
    [sym_preproc_undef] = STATE(1031),
    [aux_sym_class_declaration_repeat1] = STATE(3801),
    [aux_sym_lambda_expression_repeat1] = STATE(4134),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1993),
    [anon_sym_ref] = ACTIONS(2353),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_readonly] = ACTIONS(2807),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1999),
    [anon_sym_TILDE] = ACTIONS(1999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1999),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_AMP] = ACTIONS(1999),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2327),
    [anon_sym_var] = ACTIONS(2673),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1281),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1283),
    [anon_sym_DOT_DOT] = ACTIONS(1285),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1032] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3726),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6901),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2939),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7050),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6279),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4507),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7378),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9063),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1032),
    [sym_preproc_endregion] = STATE(1032),
    [sym_preproc_line] = STATE(1032),
    [sym_preproc_pragma] = STATE(1032),
    [sym_preproc_nullable] = STATE(1032),
    [sym_preproc_error] = STATE(1032),
    [sym_preproc_define] = STATE(1032),
    [sym_preproc_undef] = STATE(1032),
    [aux_sym_class_declaration_repeat1] = STATE(3854),
    [aux_sym_lambda_expression_repeat1] = STATE(4229),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2193),
    [anon_sym_ref] = ACTIONS(2195),
    [anon_sym_LBRACE] = ACTIONS(2765),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2197),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2201),
    [anon_sym_TILDE] = ACTIONS(2201),
    [anon_sym_PLUS_PLUS] = ACTIONS(2201),
    [anon_sym_DASH_DASH] = ACTIONS(2201),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2199),
    [anon_sym_DASH] = ACTIONS(2199),
    [anon_sym_STAR] = ACTIONS(2203),
    [anon_sym_CARET] = ACTIONS(2201),
    [anon_sym_AMP] = ACTIONS(2201),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2205),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2207),
    [anon_sym_DOT_DOT] = ACTIONS(2209),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1033] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4151),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7064),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5185),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(3866),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7382),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9762),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1033),
    [sym_preproc_endregion] = STATE(1033),
    [sym_preproc_line] = STATE(1033),
    [sym_preproc_pragma] = STATE(1033),
    [sym_preproc_nullable] = STATE(1033),
    [sym_preproc_error] = STATE(1033),
    [sym_preproc_define] = STATE(1033),
    [sym_preproc_undef] = STATE(1033),
    [aux_sym_class_declaration_repeat1] = STATE(3842),
    [aux_sym_lambda_expression_repeat1] = STATE(4280),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1351),
    [anon_sym_ref] = ACTIONS(1353),
    [anon_sym_LBRACE] = ACTIONS(2761),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1357),
    [anon_sym_TILDE] = ACTIONS(1357),
    [anon_sym_PLUS_PLUS] = ACTIONS(1357),
    [anon_sym_DASH_DASH] = ACTIONS(1357),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1355),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(1357),
    [anon_sym_AMP] = ACTIONS(1357),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1361),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1363),
    [anon_sym_DOT_DOT] = ACTIONS(1365),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1034] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4188),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7064),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5186),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(3866),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7382),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9762),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1034),
    [sym_preproc_endregion] = STATE(1034),
    [sym_preproc_line] = STATE(1034),
    [sym_preproc_pragma] = STATE(1034),
    [sym_preproc_nullable] = STATE(1034),
    [sym_preproc_error] = STATE(1034),
    [sym_preproc_define] = STATE(1034),
    [sym_preproc_undef] = STATE(1034),
    [aux_sym_class_declaration_repeat1] = STATE(3842),
    [aux_sym_lambda_expression_repeat1] = STATE(4280),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1351),
    [anon_sym_ref] = ACTIONS(1353),
    [anon_sym_LBRACE] = ACTIONS(2761),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1357),
    [anon_sym_TILDE] = ACTIONS(1357),
    [anon_sym_PLUS_PLUS] = ACTIONS(1357),
    [anon_sym_DASH_DASH] = ACTIONS(1357),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1355),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(1357),
    [anon_sym_AMP] = ACTIONS(1357),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1361),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1363),
    [anon_sym_DOT_DOT] = ACTIONS(1365),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1035] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6918),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7124),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4912),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(3736),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7377),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9441),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1035),
    [sym_preproc_endregion] = STATE(1035),
    [sym_preproc_line] = STATE(1035),
    [sym_preproc_pragma] = STATE(1035),
    [sym_preproc_nullable] = STATE(1035),
    [sym_preproc_error] = STATE(1035),
    [sym_preproc_define] = STATE(1035),
    [sym_preproc_undef] = STATE(1035),
    [aux_sym_class_declaration_repeat1] = STATE(3848),
    [aux_sym_lambda_expression_repeat1] = STATE(4242),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1213),
    [anon_sym_ref] = ACTIONS(1215),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1221),
    [anon_sym_readonly] = ACTIONS(2693),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1227),
    [anon_sym_TILDE] = ACTIONS(1227),
    [anon_sym_PLUS_PLUS] = ACTIONS(1227),
    [anon_sym_DASH_DASH] = ACTIONS(1227),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1225),
    [anon_sym_DASH] = ACTIONS(1225),
    [anon_sym_STAR] = ACTIONS(1231),
    [anon_sym_CARET] = ACTIONS(1227),
    [anon_sym_AMP] = ACTIONS(1227),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1239),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1241),
    [anon_sym_DOT_DOT] = ACTIONS(1243),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1036] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6971),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5997),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_declaration_expression] = STATE(8466),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1036),
    [sym_preproc_endregion] = STATE(1036),
    [sym_preproc_line] = STATE(1036),
    [sym_preproc_pragma] = STATE(1036),
    [sym_preproc_nullable] = STATE(1036),
    [sym_preproc_error] = STATE(1036),
    [sym_preproc_define] = STATE(1036),
    [sym_preproc_undef] = STATE(1036),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1037] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3650),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6893),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2968),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7023),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6188),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4416),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7390),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9221),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1037),
    [sym_preproc_endregion] = STATE(1037),
    [sym_preproc_line] = STATE(1037),
    [sym_preproc_pragma] = STATE(1037),
    [sym_preproc_nullable] = STATE(1037),
    [sym_preproc_error] = STATE(1037),
    [sym_preproc_define] = STATE(1037),
    [sym_preproc_undef] = STATE(1037),
    [aux_sym_class_declaration_repeat1] = STATE(3808),
    [aux_sym_lambda_expression_repeat1] = STATE(4129),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_ref] = ACTIONS(2217),
    [anon_sym_LBRACE] = ACTIONS(2767),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(2223),
    [anon_sym_TILDE] = ACTIONS(2223),
    [anon_sym_PLUS_PLUS] = ACTIONS(2223),
    [anon_sym_DASH_DASH] = ACTIONS(2223),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2221),
    [anon_sym_DASH] = ACTIONS(2221),
    [anon_sym_STAR] = ACTIONS(2225),
    [anon_sym_CARET] = ACTIONS(2223),
    [anon_sym_AMP] = ACTIONS(2223),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2227),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2229),
    [anon_sym_DOT_DOT] = ACTIONS(2231),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1038] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3683),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6893),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2968),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7023),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6187),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4416),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7390),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9221),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1038),
    [sym_preproc_endregion] = STATE(1038),
    [sym_preproc_line] = STATE(1038),
    [sym_preproc_pragma] = STATE(1038),
    [sym_preproc_nullable] = STATE(1038),
    [sym_preproc_error] = STATE(1038),
    [sym_preproc_define] = STATE(1038),
    [sym_preproc_undef] = STATE(1038),
    [aux_sym_class_declaration_repeat1] = STATE(3808),
    [aux_sym_lambda_expression_repeat1] = STATE(4129),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_ref] = ACTIONS(2217),
    [anon_sym_LBRACE] = ACTIONS(2767),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(2223),
    [anon_sym_TILDE] = ACTIONS(2223),
    [anon_sym_PLUS_PLUS] = ACTIONS(2223),
    [anon_sym_DASH_DASH] = ACTIONS(2223),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2221),
    [anon_sym_DASH] = ACTIONS(2221),
    [anon_sym_STAR] = ACTIONS(2225),
    [anon_sym_CARET] = ACTIONS(2223),
    [anon_sym_AMP] = ACTIONS(2223),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2227),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2229),
    [anon_sym_DOT_DOT] = ACTIONS(2231),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1039] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3612),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6893),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2968),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7023),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6186),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4416),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7390),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9221),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1039),
    [sym_preproc_endregion] = STATE(1039),
    [sym_preproc_line] = STATE(1039),
    [sym_preproc_pragma] = STATE(1039),
    [sym_preproc_nullable] = STATE(1039),
    [sym_preproc_error] = STATE(1039),
    [sym_preproc_define] = STATE(1039),
    [sym_preproc_undef] = STATE(1039),
    [aux_sym_class_declaration_repeat1] = STATE(3808),
    [aux_sym_lambda_expression_repeat1] = STATE(4129),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_ref] = ACTIONS(2217),
    [anon_sym_LBRACE] = ACTIONS(2767),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(2223),
    [anon_sym_TILDE] = ACTIONS(2223),
    [anon_sym_PLUS_PLUS] = ACTIONS(2223),
    [anon_sym_DASH_DASH] = ACTIONS(2223),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2221),
    [anon_sym_DASH] = ACTIONS(2221),
    [anon_sym_STAR] = ACTIONS(2225),
    [anon_sym_CARET] = ACTIONS(2223),
    [anon_sym_AMP] = ACTIONS(2223),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2227),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2229),
    [anon_sym_DOT_DOT] = ACTIONS(2231),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1040] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4604),
    [sym_bracketed_argument_list] = STATE(3559),
    [sym__name] = STATE(6878),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2911),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6938),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4773),
    [sym_non_lvalue_expression] = STATE(4553),
    [sym_lvalue_expression] = STATE(3750),
    [sym__expression_statement_expression] = STATE(4559),
    [sym_assignment_expression] = STATE(4558),
    [sym_binary_expression] = STATE(4559),
    [sym_postfix_unary_expression] = STATE(4558),
    [sym_prefix_unary_expression] = STATE(4558),
    [sym__pointer_indirection_expression] = STATE(3560),
    [sym_query_expression] = STATE(4559),
    [sym_from_clause] = STATE(7406),
    [sym_conditional_expression] = STATE(4559),
    [sym_conditional_access_expression] = STATE(4559),
    [sym_as_expression] = STATE(4559),
    [sym_is_expression] = STATE(4559),
    [sym_is_pattern_expression] = STATE(4559),
    [sym_cast_expression] = STATE(4559),
    [sym_checked_expression] = STATE(4559),
    [sym_invocation_expression] = STATE(4558),
    [sym_switch_expression] = STATE(4559),
    [sym_await_expression] = STATE(4558),
    [sym_throw_expression] = STATE(4559),
    [sym_element_access_expression] = STATE(3560),
    [sym_interpolated_string_expression] = STATE(4559),
    [sym_member_access_expression] = STATE(3560),
    [sym_object_creation_expression] = STATE(4558),
    [sym_parenthesized_expression] = STATE(4558),
    [sym__parenthesized_lvalue_expression] = STATE(3560),
    [sym_lambda_expression] = STATE(4559),
    [sym__lambda_parameters] = STATE(9691),
    [sym_array_creation_expression] = STATE(4559),
    [sym_anonymous_method_expression] = STATE(4559),
    [sym_anonymous_object_creation_expression] = STATE(4559),
    [sym_implicit_array_creation_expression] = STATE(4559),
    [sym_implicit_object_creation_expression] = STATE(4559),
    [sym_implicit_stackalloc_expression] = STATE(4559),
    [sym_initializer_expression] = STATE(4559),
    [sym_default_expression] = STATE(4559),
    [sym_with_expression] = STATE(4559),
    [sym_sizeof_expression] = STATE(4559),
    [sym_typeof_expression] = STATE(4559),
    [sym_makeref_expression] = STATE(4559),
    [sym_ref_expression] = STATE(4559),
    [sym_reftype_expression] = STATE(4559),
    [sym_refvalue_expression] = STATE(4559),
    [sym_stackalloc_expression] = STATE(4559),
    [sym_range_expression] = STATE(4559),
    [sym_tuple_expression] = STATE(3560),
    [sym_literal] = STATE(4559),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4559),
    [sym_preproc_region] = STATE(1040),
    [sym_preproc_endregion] = STATE(1040),
    [sym_preproc_line] = STATE(1040),
    [sym_preproc_pragma] = STATE(1040),
    [sym_preproc_nullable] = STATE(1040),
    [sym_preproc_error] = STATE(1040),
    [sym_preproc_define] = STATE(1040),
    [sym_preproc_undef] = STATE(1040),
    [aux_sym_class_declaration_repeat1] = STATE(3836),
    [aux_sym_lambda_expression_repeat1] = STATE(4216),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(2003),
    [anon_sym_ref] = ACTIONS(2005),
    [anon_sym_LBRACE] = ACTIONS(2759),
    [anon_sym_delegate] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1615),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(2009),
    [anon_sym_TILDE] = ACTIONS(2009),
    [anon_sym_PLUS_PLUS] = ACTIONS(2009),
    [anon_sym_DASH_DASH] = ACTIONS(2009),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(2007),
    [anon_sym_DASH] = ACTIONS(2007),
    [anon_sym_STAR] = ACTIONS(1625),
    [anon_sym_CARET] = ACTIONS(2009),
    [anon_sym_AMP] = ACTIONS(2009),
    [anon_sym_this] = ACTIONS(1627),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1629),
    [anon_sym_unchecked] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(2011),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2013),
    [anon_sym_DOT_DOT] = ACTIONS(2015),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_stackalloc] = ACTIONS(1641),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(1647),
    [anon_sym___reftype] = ACTIONS(1649),
    [anon_sym___refvalue] = ACTIONS(1651),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1659),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [1041] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3638),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6893),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2968),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7023),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6185),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4416),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7390),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9221),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1041),
    [sym_preproc_endregion] = STATE(1041),
    [sym_preproc_line] = STATE(1041),
    [sym_preproc_pragma] = STATE(1041),
    [sym_preproc_nullable] = STATE(1041),
    [sym_preproc_error] = STATE(1041),
    [sym_preproc_define] = STATE(1041),
    [sym_preproc_undef] = STATE(1041),
    [aux_sym_class_declaration_repeat1] = STATE(3808),
    [aux_sym_lambda_expression_repeat1] = STATE(4129),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_ref] = ACTIONS(2217),
    [anon_sym_LBRACE] = ACTIONS(2767),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(2223),
    [anon_sym_TILDE] = ACTIONS(2223),
    [anon_sym_PLUS_PLUS] = ACTIONS(2223),
    [anon_sym_DASH_DASH] = ACTIONS(2223),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2221),
    [anon_sym_DASH] = ACTIONS(2221),
    [anon_sym_STAR] = ACTIONS(2225),
    [anon_sym_CARET] = ACTIONS(2223),
    [anon_sym_AMP] = ACTIONS(2223),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2227),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2229),
    [anon_sym_DOT_DOT] = ACTIONS(2231),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1042] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3632),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6893),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2968),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7023),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6183),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4416),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7390),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9221),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1042),
    [sym_preproc_endregion] = STATE(1042),
    [sym_preproc_line] = STATE(1042),
    [sym_preproc_pragma] = STATE(1042),
    [sym_preproc_nullable] = STATE(1042),
    [sym_preproc_error] = STATE(1042),
    [sym_preproc_define] = STATE(1042),
    [sym_preproc_undef] = STATE(1042),
    [aux_sym_class_declaration_repeat1] = STATE(3808),
    [aux_sym_lambda_expression_repeat1] = STATE(4129),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_ref] = ACTIONS(2217),
    [anon_sym_LBRACE] = ACTIONS(2767),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(2223),
    [anon_sym_TILDE] = ACTIONS(2223),
    [anon_sym_PLUS_PLUS] = ACTIONS(2223),
    [anon_sym_DASH_DASH] = ACTIONS(2223),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2221),
    [anon_sym_DASH] = ACTIONS(2221),
    [anon_sym_STAR] = ACTIONS(2225),
    [anon_sym_CARET] = ACTIONS(2223),
    [anon_sym_AMP] = ACTIONS(2223),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2227),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2229),
    [anon_sym_DOT_DOT] = ACTIONS(2231),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1043] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3615),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6893),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2968),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7023),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6182),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4416),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7390),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9221),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1043),
    [sym_preproc_endregion] = STATE(1043),
    [sym_preproc_line] = STATE(1043),
    [sym_preproc_pragma] = STATE(1043),
    [sym_preproc_nullable] = STATE(1043),
    [sym_preproc_error] = STATE(1043),
    [sym_preproc_define] = STATE(1043),
    [sym_preproc_undef] = STATE(1043),
    [aux_sym_class_declaration_repeat1] = STATE(3808),
    [aux_sym_lambda_expression_repeat1] = STATE(4129),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_ref] = ACTIONS(2217),
    [anon_sym_LBRACE] = ACTIONS(2767),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(2223),
    [anon_sym_TILDE] = ACTIONS(2223),
    [anon_sym_PLUS_PLUS] = ACTIONS(2223),
    [anon_sym_DASH_DASH] = ACTIONS(2223),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2221),
    [anon_sym_DASH] = ACTIONS(2221),
    [anon_sym_STAR] = ACTIONS(2225),
    [anon_sym_CARET] = ACTIONS(2223),
    [anon_sym_AMP] = ACTIONS(2223),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2227),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2229),
    [anon_sym_DOT_DOT] = ACTIONS(2231),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1044] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3650),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6894),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2955),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7025),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4864),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(3735),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7397),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9590),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1044),
    [sym_preproc_endregion] = STATE(1044),
    [sym_preproc_line] = STATE(1044),
    [sym_preproc_pragma] = STATE(1044),
    [sym_preproc_nullable] = STATE(1044),
    [sym_preproc_error] = STATE(1044),
    [sym_preproc_define] = STATE(1044),
    [sym_preproc_undef] = STATE(1044),
    [aux_sym_class_declaration_repeat1] = STATE(3844),
    [aux_sym_lambda_expression_repeat1] = STATE(4245),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1849),
    [anon_sym_ref] = ACTIONS(1851),
    [anon_sym_LBRACE] = ACTIONS(2767),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1853),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1857),
    [anon_sym_TILDE] = ACTIONS(1857),
    [anon_sym_PLUS_PLUS] = ACTIONS(1857),
    [anon_sym_DASH_DASH] = ACTIONS(1857),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1855),
    [anon_sym_DASH] = ACTIONS(1855),
    [anon_sym_STAR] = ACTIONS(1859),
    [anon_sym_CARET] = ACTIONS(1857),
    [anon_sym_AMP] = ACTIONS(1857),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1861),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1863),
    [anon_sym_DOT_DOT] = ACTIONS(1865),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1045] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6893),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2968),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7024),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6236),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4416),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7390),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9221),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1045),
    [sym_preproc_endregion] = STATE(1045),
    [sym_preproc_line] = STATE(1045),
    [sym_preproc_pragma] = STATE(1045),
    [sym_preproc_nullable] = STATE(1045),
    [sym_preproc_error] = STATE(1045),
    [sym_preproc_define] = STATE(1045),
    [sym_preproc_undef] = STATE(1045),
    [aux_sym_class_declaration_repeat1] = STATE(3808),
    [aux_sym_lambda_expression_repeat1] = STATE(4129),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_ref] = ACTIONS(2217),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_readonly] = ACTIONS(2693),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(2223),
    [anon_sym_TILDE] = ACTIONS(2223),
    [anon_sym_PLUS_PLUS] = ACTIONS(2223),
    [anon_sym_DASH_DASH] = ACTIONS(2223),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2221),
    [anon_sym_DASH] = ACTIONS(2221),
    [anon_sym_STAR] = ACTIONS(2225),
    [anon_sym_CARET] = ACTIONS(2223),
    [anon_sym_AMP] = ACTIONS(2223),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2227),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2229),
    [anon_sym_DOT_DOT] = ACTIONS(2231),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1046] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3769),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6910),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2957),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6984),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4932),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(3777),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7387),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9385),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1046),
    [sym_preproc_endregion] = STATE(1046),
    [sym_preproc_line] = STATE(1046),
    [sym_preproc_pragma] = STATE(1046),
    [sym_preproc_nullable] = STATE(1046),
    [sym_preproc_error] = STATE(1046),
    [sym_preproc_define] = STATE(1046),
    [sym_preproc_undef] = STATE(1046),
    [aux_sym_class_declaration_repeat1] = STATE(3793),
    [aux_sym_lambda_expression_repeat1] = STATE(4083),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1795),
    [anon_sym_ref] = ACTIONS(1797),
    [anon_sym_LBRACE] = ACTIONS(2765),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1799),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1803),
    [anon_sym_TILDE] = ACTIONS(1803),
    [anon_sym_PLUS_PLUS] = ACTIONS(1803),
    [anon_sym_DASH_DASH] = ACTIONS(1803),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1801),
    [anon_sym_DASH] = ACTIONS(1801),
    [anon_sym_STAR] = ACTIONS(1805),
    [anon_sym_CARET] = ACTIONS(1803),
    [anon_sym_AMP] = ACTIONS(1803),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1807),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1809),
    [anon_sym_DOT_DOT] = ACTIONS(1811),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1047] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4188),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6880),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7055),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5899),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4312),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7380),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9286),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1047),
    [sym_preproc_endregion] = STATE(1047),
    [sym_preproc_line] = STATE(1047),
    [sym_preproc_pragma] = STATE(1047),
    [sym_preproc_nullable] = STATE(1047),
    [sym_preproc_error] = STATE(1047),
    [sym_preproc_define] = STATE(1047),
    [sym_preproc_undef] = STATE(1047),
    [aux_sym_class_declaration_repeat1] = STATE(3799),
    [aux_sym_lambda_expression_repeat1] = STATE(4101),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1545),
    [anon_sym_ref] = ACTIONS(1547),
    [anon_sym_LBRACE] = ACTIONS(2761),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1551),
    [anon_sym_TILDE] = ACTIONS(1551),
    [anon_sym_PLUS_PLUS] = ACTIONS(1551),
    [anon_sym_DASH_DASH] = ACTIONS(1551),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1549),
    [anon_sym_DASH] = ACTIONS(1549),
    [anon_sym_STAR] = ACTIONS(1553),
    [anon_sym_CARET] = ACTIONS(1551),
    [anon_sym_AMP] = ACTIONS(1551),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1555),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1557),
    [anon_sym_DOT_DOT] = ACTIONS(1559),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1048] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4151),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6880),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7055),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5896),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4312),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7380),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9286),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1048),
    [sym_preproc_endregion] = STATE(1048),
    [sym_preproc_line] = STATE(1048),
    [sym_preproc_pragma] = STATE(1048),
    [sym_preproc_nullable] = STATE(1048),
    [sym_preproc_error] = STATE(1048),
    [sym_preproc_define] = STATE(1048),
    [sym_preproc_undef] = STATE(1048),
    [aux_sym_class_declaration_repeat1] = STATE(3799),
    [aux_sym_lambda_expression_repeat1] = STATE(4101),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1545),
    [anon_sym_ref] = ACTIONS(1547),
    [anon_sym_LBRACE] = ACTIONS(2761),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1551),
    [anon_sym_TILDE] = ACTIONS(1551),
    [anon_sym_PLUS_PLUS] = ACTIONS(1551),
    [anon_sym_DASH_DASH] = ACTIONS(1551),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1549),
    [anon_sym_DASH] = ACTIONS(1549),
    [anon_sym_STAR] = ACTIONS(1553),
    [anon_sym_CARET] = ACTIONS(1551),
    [anon_sym_AMP] = ACTIONS(1551),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1555),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1557),
    [anon_sym_DOT_DOT] = ACTIONS(1559),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1049] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3717),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6910),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2957),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6984),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4928),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(3777),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7387),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9385),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1049),
    [sym_preproc_endregion] = STATE(1049),
    [sym_preproc_line] = STATE(1049),
    [sym_preproc_pragma] = STATE(1049),
    [sym_preproc_nullable] = STATE(1049),
    [sym_preproc_error] = STATE(1049),
    [sym_preproc_define] = STATE(1049),
    [sym_preproc_undef] = STATE(1049),
    [aux_sym_class_declaration_repeat1] = STATE(3793),
    [aux_sym_lambda_expression_repeat1] = STATE(4083),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1795),
    [anon_sym_ref] = ACTIONS(1797),
    [anon_sym_LBRACE] = ACTIONS(2765),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1799),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1803),
    [anon_sym_TILDE] = ACTIONS(1803),
    [anon_sym_PLUS_PLUS] = ACTIONS(1803),
    [anon_sym_DASH_DASH] = ACTIONS(1803),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1801),
    [anon_sym_DASH] = ACTIONS(1801),
    [anon_sym_STAR] = ACTIONS(1805),
    [anon_sym_CARET] = ACTIONS(1803),
    [anon_sym_AMP] = ACTIONS(1803),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1807),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1809),
    [anon_sym_DOT_DOT] = ACTIONS(1811),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1050] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4116),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6880),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7055),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5890),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4312),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7380),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9286),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1050),
    [sym_preproc_endregion] = STATE(1050),
    [sym_preproc_line] = STATE(1050),
    [sym_preproc_pragma] = STATE(1050),
    [sym_preproc_nullable] = STATE(1050),
    [sym_preproc_error] = STATE(1050),
    [sym_preproc_define] = STATE(1050),
    [sym_preproc_undef] = STATE(1050),
    [aux_sym_class_declaration_repeat1] = STATE(3799),
    [aux_sym_lambda_expression_repeat1] = STATE(4101),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1545),
    [anon_sym_ref] = ACTIONS(1547),
    [anon_sym_LBRACE] = ACTIONS(2761),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1551),
    [anon_sym_TILDE] = ACTIONS(1551),
    [anon_sym_PLUS_PLUS] = ACTIONS(1551),
    [anon_sym_DASH_DASH] = ACTIONS(1551),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1549),
    [anon_sym_DASH] = ACTIONS(1549),
    [anon_sym_STAR] = ACTIONS(1553),
    [anon_sym_CARET] = ACTIONS(1551),
    [anon_sym_AMP] = ACTIONS(1551),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1555),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1557),
    [anon_sym_DOT_DOT] = ACTIONS(1559),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1051] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4066),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6880),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7055),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5886),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4312),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7380),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9286),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1051),
    [sym_preproc_endregion] = STATE(1051),
    [sym_preproc_line] = STATE(1051),
    [sym_preproc_pragma] = STATE(1051),
    [sym_preproc_nullable] = STATE(1051),
    [sym_preproc_error] = STATE(1051),
    [sym_preproc_define] = STATE(1051),
    [sym_preproc_undef] = STATE(1051),
    [aux_sym_class_declaration_repeat1] = STATE(3799),
    [aux_sym_lambda_expression_repeat1] = STATE(4101),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1545),
    [anon_sym_ref] = ACTIONS(1547),
    [anon_sym_LBRACE] = ACTIONS(2761),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1551),
    [anon_sym_TILDE] = ACTIONS(1551),
    [anon_sym_PLUS_PLUS] = ACTIONS(1551),
    [anon_sym_DASH_DASH] = ACTIONS(1551),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1549),
    [anon_sym_DASH] = ACTIONS(1549),
    [anon_sym_STAR] = ACTIONS(1553),
    [anon_sym_CARET] = ACTIONS(1551),
    [anon_sym_AMP] = ACTIONS(1551),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1555),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1557),
    [anon_sym_DOT_DOT] = ACTIONS(1559),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1052] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6030),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1052),
    [sym_preproc_endregion] = STATE(1052),
    [sym_preproc_line] = STATE(1052),
    [sym_preproc_pragma] = STATE(1052),
    [sym_preproc_nullable] = STATE(1052),
    [sym_preproc_error] = STATE(1052),
    [sym_preproc_define] = STATE(1052),
    [sym_preproc_undef] = STATE(1052),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_RBRACE] = ACTIONS(2891),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1053] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3738),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6910),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2957),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6984),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4916),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(3777),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7387),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9385),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1053),
    [sym_preproc_endregion] = STATE(1053),
    [sym_preproc_line] = STATE(1053),
    [sym_preproc_pragma] = STATE(1053),
    [sym_preproc_nullable] = STATE(1053),
    [sym_preproc_error] = STATE(1053),
    [sym_preproc_define] = STATE(1053),
    [sym_preproc_undef] = STATE(1053),
    [aux_sym_class_declaration_repeat1] = STATE(3793),
    [aux_sym_lambda_expression_repeat1] = STATE(4083),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1795),
    [anon_sym_ref] = ACTIONS(1797),
    [anon_sym_LBRACE] = ACTIONS(2765),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1799),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1803),
    [anon_sym_TILDE] = ACTIONS(1803),
    [anon_sym_PLUS_PLUS] = ACTIONS(1803),
    [anon_sym_DASH_DASH] = ACTIONS(1803),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1801),
    [anon_sym_DASH] = ACTIONS(1801),
    [anon_sym_STAR] = ACTIONS(1805),
    [anon_sym_CARET] = ACTIONS(1803),
    [anon_sym_AMP] = ACTIONS(1803),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1807),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1809),
    [anon_sym_DOT_DOT] = ACTIONS(1811),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1054] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6901),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2939),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7043),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6454),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4507),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7378),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9063),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1054),
    [sym_preproc_endregion] = STATE(1054),
    [sym_preproc_line] = STATE(1054),
    [sym_preproc_pragma] = STATE(1054),
    [sym_preproc_nullable] = STATE(1054),
    [sym_preproc_error] = STATE(1054),
    [sym_preproc_define] = STATE(1054),
    [sym_preproc_undef] = STATE(1054),
    [aux_sym_class_declaration_repeat1] = STATE(3854),
    [aux_sym_lambda_expression_repeat1] = STATE(4229),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2193),
    [anon_sym_ref] = ACTIONS(2195),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2197),
    [anon_sym_readonly] = ACTIONS(2693),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2201),
    [anon_sym_TILDE] = ACTIONS(2201),
    [anon_sym_PLUS_PLUS] = ACTIONS(2201),
    [anon_sym_DASH_DASH] = ACTIONS(2201),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2199),
    [anon_sym_DASH] = ACTIONS(2199),
    [anon_sym_STAR] = ACTIONS(2203),
    [anon_sym_CARET] = ACTIONS(2201),
    [anon_sym_AMP] = ACTIONS(2201),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2205),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2207),
    [anon_sym_DOT_DOT] = ACTIONS(2209),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1055] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3751),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7094),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6052),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1055),
    [sym_preproc_endregion] = STATE(1055),
    [sym_preproc_line] = STATE(1055),
    [sym_preproc_pragma] = STATE(1055),
    [sym_preproc_nullable] = STATE(1055),
    [sym_preproc_error] = STATE(1055),
    [sym_preproc_define] = STATE(1055),
    [sym_preproc_undef] = STATE(1055),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(2765),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1669),
    [anon_sym_TILDE] = ACTIONS(1669),
    [anon_sym_PLUS_PLUS] = ACTIONS(1669),
    [anon_sym_DASH_DASH] = ACTIONS(1669),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1667),
    [anon_sym_DASH] = ACTIONS(1667),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1669),
    [anon_sym_AMP] = ACTIONS(1669),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1056] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4085),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6880),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7055),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5885),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4312),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7380),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9286),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1056),
    [sym_preproc_endregion] = STATE(1056),
    [sym_preproc_line] = STATE(1056),
    [sym_preproc_pragma] = STATE(1056),
    [sym_preproc_nullable] = STATE(1056),
    [sym_preproc_error] = STATE(1056),
    [sym_preproc_define] = STATE(1056),
    [sym_preproc_undef] = STATE(1056),
    [aux_sym_class_declaration_repeat1] = STATE(3799),
    [aux_sym_lambda_expression_repeat1] = STATE(4101),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1545),
    [anon_sym_ref] = ACTIONS(1547),
    [anon_sym_LBRACE] = ACTIONS(2761),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1551),
    [anon_sym_TILDE] = ACTIONS(1551),
    [anon_sym_PLUS_PLUS] = ACTIONS(1551),
    [anon_sym_DASH_DASH] = ACTIONS(1551),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1549),
    [anon_sym_DASH] = ACTIONS(1549),
    [anon_sym_STAR] = ACTIONS(1553),
    [anon_sym_CARET] = ACTIONS(1551),
    [anon_sym_AMP] = ACTIONS(1551),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1555),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1557),
    [anon_sym_DOT_DOT] = ACTIONS(1559),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1057] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4132),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6880),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7055),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5883),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4312),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7380),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9286),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1057),
    [sym_preproc_endregion] = STATE(1057),
    [sym_preproc_line] = STATE(1057),
    [sym_preproc_pragma] = STATE(1057),
    [sym_preproc_nullable] = STATE(1057),
    [sym_preproc_error] = STATE(1057),
    [sym_preproc_define] = STATE(1057),
    [sym_preproc_undef] = STATE(1057),
    [aux_sym_class_declaration_repeat1] = STATE(3799),
    [aux_sym_lambda_expression_repeat1] = STATE(4101),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1545),
    [anon_sym_ref] = ACTIONS(1547),
    [anon_sym_LBRACE] = ACTIONS(2761),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1551),
    [anon_sym_TILDE] = ACTIONS(1551),
    [anon_sym_PLUS_PLUS] = ACTIONS(1551),
    [anon_sym_DASH_DASH] = ACTIONS(1551),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1549),
    [anon_sym_DASH] = ACTIONS(1549),
    [anon_sym_STAR] = ACTIONS(1553),
    [anon_sym_CARET] = ACTIONS(1551),
    [anon_sym_AMP] = ACTIONS(1551),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1555),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1557),
    [anon_sym_DOT_DOT] = ACTIONS(1559),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1058] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3683),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6894),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2955),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7025),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4857),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(3735),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7397),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9590),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1058),
    [sym_preproc_endregion] = STATE(1058),
    [sym_preproc_line] = STATE(1058),
    [sym_preproc_pragma] = STATE(1058),
    [sym_preproc_nullable] = STATE(1058),
    [sym_preproc_error] = STATE(1058),
    [sym_preproc_define] = STATE(1058),
    [sym_preproc_undef] = STATE(1058),
    [aux_sym_class_declaration_repeat1] = STATE(3844),
    [aux_sym_lambda_expression_repeat1] = STATE(4245),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1849),
    [anon_sym_ref] = ACTIONS(1851),
    [anon_sym_LBRACE] = ACTIONS(2767),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1853),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1857),
    [anon_sym_TILDE] = ACTIONS(1857),
    [anon_sym_PLUS_PLUS] = ACTIONS(1857),
    [anon_sym_DASH_DASH] = ACTIONS(1857),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1855),
    [anon_sym_DASH] = ACTIONS(1855),
    [anon_sym_STAR] = ACTIONS(1859),
    [anon_sym_CARET] = ACTIONS(1857),
    [anon_sym_AMP] = ACTIONS(1857),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1861),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1863),
    [anon_sym_DOT_DOT] = ACTIONS(1865),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1059] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3612),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6894),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2955),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7025),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4852),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(3735),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7397),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9590),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1059),
    [sym_preproc_endregion] = STATE(1059),
    [sym_preproc_line] = STATE(1059),
    [sym_preproc_pragma] = STATE(1059),
    [sym_preproc_nullable] = STATE(1059),
    [sym_preproc_error] = STATE(1059),
    [sym_preproc_define] = STATE(1059),
    [sym_preproc_undef] = STATE(1059),
    [aux_sym_class_declaration_repeat1] = STATE(3844),
    [aux_sym_lambda_expression_repeat1] = STATE(4245),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1849),
    [anon_sym_ref] = ACTIONS(1851),
    [anon_sym_LBRACE] = ACTIONS(2767),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1853),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1857),
    [anon_sym_TILDE] = ACTIONS(1857),
    [anon_sym_PLUS_PLUS] = ACTIONS(1857),
    [anon_sym_DASH_DASH] = ACTIONS(1857),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1855),
    [anon_sym_DASH] = ACTIONS(1855),
    [anon_sym_STAR] = ACTIONS(1859),
    [anon_sym_CARET] = ACTIONS(1857),
    [anon_sym_AMP] = ACTIONS(1857),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1861),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1863),
    [anon_sym_DOT_DOT] = ACTIONS(1865),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1060] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(5450),
    [sym_bracketed_argument_list] = STATE(3921),
    [sym__name] = STATE(6919),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2868),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(7068),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5989),
    [sym_non_lvalue_expression] = STATE(5735),
    [sym_lvalue_expression] = STATE(4323),
    [sym__expression_statement_expression] = STATE(5733),
    [sym_assignment_expression] = STATE(5734),
    [sym_binary_expression] = STATE(5733),
    [sym_postfix_unary_expression] = STATE(5734),
    [sym_prefix_unary_expression] = STATE(5734),
    [sym__pointer_indirection_expression] = STATE(3911),
    [sym_query_expression] = STATE(5733),
    [sym_from_clause] = STATE(7393),
    [sym_conditional_expression] = STATE(5733),
    [sym_conditional_access_expression] = STATE(5733),
    [sym_as_expression] = STATE(5733),
    [sym_is_expression] = STATE(5733),
    [sym_is_pattern_expression] = STATE(5733),
    [sym_cast_expression] = STATE(5733),
    [sym_checked_expression] = STATE(5733),
    [sym_invocation_expression] = STATE(5734),
    [sym_switch_expression] = STATE(5733),
    [sym_await_expression] = STATE(5734),
    [sym_throw_expression] = STATE(5733),
    [sym_element_access_expression] = STATE(3911),
    [sym_interpolated_string_expression] = STATE(5733),
    [sym_member_access_expression] = STATE(3911),
    [sym_object_creation_expression] = STATE(5734),
    [sym_parenthesized_expression] = STATE(5734),
    [sym__parenthesized_lvalue_expression] = STATE(3911),
    [sym_lambda_expression] = STATE(5733),
    [sym__lambda_parameters] = STATE(9932),
    [sym_array_creation_expression] = STATE(5733),
    [sym_anonymous_method_expression] = STATE(5733),
    [sym_anonymous_object_creation_expression] = STATE(5733),
    [sym_implicit_array_creation_expression] = STATE(5733),
    [sym_implicit_object_creation_expression] = STATE(5733),
    [sym_implicit_stackalloc_expression] = STATE(5733),
    [sym_initializer_expression] = STATE(5733),
    [sym_default_expression] = STATE(5733),
    [sym_with_expression] = STATE(5733),
    [sym_sizeof_expression] = STATE(5733),
    [sym_typeof_expression] = STATE(5733),
    [sym_makeref_expression] = STATE(5733),
    [sym_ref_expression] = STATE(5733),
    [sym_reftype_expression] = STATE(5733),
    [sym_refvalue_expression] = STATE(5733),
    [sym_stackalloc_expression] = STATE(5733),
    [sym_range_expression] = STATE(5733),
    [sym_tuple_expression] = STATE(3911),
    [sym_literal] = STATE(5733),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2798),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(5733),
    [sym_preproc_region] = STATE(1060),
    [sym_preproc_endregion] = STATE(1060),
    [sym_preproc_line] = STATE(1060),
    [sym_preproc_pragma] = STATE(1060),
    [sym_preproc_nullable] = STATE(1060),
    [sym_preproc_error] = STATE(1060),
    [sym_preproc_define] = STATE(1060),
    [sym_preproc_undef] = STATE(1060),
    [aux_sym_class_declaration_repeat1] = STATE(3831),
    [aux_sym_lambda_expression_repeat1] = STATE(4227),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_LPAREN] = ACTIONS(1577),
    [anon_sym_ref] = ACTIONS(1579),
    [anon_sym_LBRACE] = ACTIONS(2773),
    [anon_sym_delegate] = ACTIONS(1379),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1381),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1583),
    [anon_sym_TILDE] = ACTIONS(1583),
    [anon_sym_PLUS_PLUS] = ACTIONS(1583),
    [anon_sym_DASH_DASH] = ACTIONS(1583),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1581),
    [anon_sym_DASH] = ACTIONS(1581),
    [anon_sym_STAR] = ACTIONS(1391),
    [anon_sym_CARET] = ACTIONS(1583),
    [anon_sym_AMP] = ACTIONS(1583),
    [anon_sym_this] = ACTIONS(1393),
    [anon_sym_scoped] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1397),
    [sym_predefined_type] = ACTIONS(1399),
    [anon_sym_unchecked] = ACTIONS(1383),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1585),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1587),
    [anon_sym_DOT_DOT] = ACTIONS(1589),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_stackalloc] = ACTIONS(1413),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(1419),
    [anon_sym___reftype] = ACTIONS(1421),
    [anon_sym___refvalue] = ACTIONS(1423),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
  },
  [1061] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(5508),
    [sym_bracketed_argument_list] = STATE(3921),
    [sym__name] = STATE(6919),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2868),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(7068),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5991),
    [sym_non_lvalue_expression] = STATE(5735),
    [sym_lvalue_expression] = STATE(4323),
    [sym__expression_statement_expression] = STATE(5733),
    [sym_assignment_expression] = STATE(5734),
    [sym_binary_expression] = STATE(5733),
    [sym_postfix_unary_expression] = STATE(5734),
    [sym_prefix_unary_expression] = STATE(5734),
    [sym__pointer_indirection_expression] = STATE(3911),
    [sym_query_expression] = STATE(5733),
    [sym_from_clause] = STATE(7393),
    [sym_conditional_expression] = STATE(5733),
    [sym_conditional_access_expression] = STATE(5733),
    [sym_as_expression] = STATE(5733),
    [sym_is_expression] = STATE(5733),
    [sym_is_pattern_expression] = STATE(5733),
    [sym_cast_expression] = STATE(5733),
    [sym_checked_expression] = STATE(5733),
    [sym_invocation_expression] = STATE(5734),
    [sym_switch_expression] = STATE(5733),
    [sym_await_expression] = STATE(5734),
    [sym_throw_expression] = STATE(5733),
    [sym_element_access_expression] = STATE(3911),
    [sym_interpolated_string_expression] = STATE(5733),
    [sym_member_access_expression] = STATE(3911),
    [sym_object_creation_expression] = STATE(5734),
    [sym_parenthesized_expression] = STATE(5734),
    [sym__parenthesized_lvalue_expression] = STATE(3911),
    [sym_lambda_expression] = STATE(5733),
    [sym__lambda_parameters] = STATE(9932),
    [sym_array_creation_expression] = STATE(5733),
    [sym_anonymous_method_expression] = STATE(5733),
    [sym_anonymous_object_creation_expression] = STATE(5733),
    [sym_implicit_array_creation_expression] = STATE(5733),
    [sym_implicit_object_creation_expression] = STATE(5733),
    [sym_implicit_stackalloc_expression] = STATE(5733),
    [sym_initializer_expression] = STATE(5733),
    [sym_default_expression] = STATE(5733),
    [sym_with_expression] = STATE(5733),
    [sym_sizeof_expression] = STATE(5733),
    [sym_typeof_expression] = STATE(5733),
    [sym_makeref_expression] = STATE(5733),
    [sym_ref_expression] = STATE(5733),
    [sym_reftype_expression] = STATE(5733),
    [sym_refvalue_expression] = STATE(5733),
    [sym_stackalloc_expression] = STATE(5733),
    [sym_range_expression] = STATE(5733),
    [sym_tuple_expression] = STATE(3911),
    [sym_literal] = STATE(5733),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2798),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(5733),
    [sym_preproc_region] = STATE(1061),
    [sym_preproc_endregion] = STATE(1061),
    [sym_preproc_line] = STATE(1061),
    [sym_preproc_pragma] = STATE(1061),
    [sym_preproc_nullable] = STATE(1061),
    [sym_preproc_error] = STATE(1061),
    [sym_preproc_define] = STATE(1061),
    [sym_preproc_undef] = STATE(1061),
    [aux_sym_class_declaration_repeat1] = STATE(3831),
    [aux_sym_lambda_expression_repeat1] = STATE(4227),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_LPAREN] = ACTIONS(1577),
    [anon_sym_ref] = ACTIONS(1579),
    [anon_sym_LBRACE] = ACTIONS(2773),
    [anon_sym_delegate] = ACTIONS(1379),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1381),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1583),
    [anon_sym_TILDE] = ACTIONS(1583),
    [anon_sym_PLUS_PLUS] = ACTIONS(1583),
    [anon_sym_DASH_DASH] = ACTIONS(1583),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1581),
    [anon_sym_DASH] = ACTIONS(1581),
    [anon_sym_STAR] = ACTIONS(1391),
    [anon_sym_CARET] = ACTIONS(1583),
    [anon_sym_AMP] = ACTIONS(1583),
    [anon_sym_this] = ACTIONS(1393),
    [anon_sym_scoped] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1397),
    [sym_predefined_type] = ACTIONS(1399),
    [anon_sym_unchecked] = ACTIONS(1383),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1585),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1587),
    [anon_sym_DOT_DOT] = ACTIONS(1589),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_stackalloc] = ACTIONS(1413),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(1419),
    [anon_sym___reftype] = ACTIONS(1421),
    [anon_sym___refvalue] = ACTIONS(1423),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
  },
  [1062] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4007),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6896),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2944),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6952),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5576),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4248),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7396),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9160),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1062),
    [sym_preproc_endregion] = STATE(1062),
    [sym_preproc_line] = STATE(1062),
    [sym_preproc_pragma] = STATE(1062),
    [sym_preproc_nullable] = STATE(1062),
    [sym_preproc_error] = STATE(1062),
    [sym_preproc_define] = STATE(1062),
    [sym_preproc_undef] = STATE(1062),
    [aux_sym_class_declaration_repeat1] = STATE(3795),
    [aux_sym_lambda_expression_repeat1] = STATE(4144),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1831),
    [anon_sym_ref] = ACTIONS(1833),
    [anon_sym_LBRACE] = ACTIONS(2833),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1835),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1839),
    [anon_sym_TILDE] = ACTIONS(1839),
    [anon_sym_PLUS_PLUS] = ACTIONS(1839),
    [anon_sym_DASH_DASH] = ACTIONS(1839),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1837),
    [anon_sym_DASH] = ACTIONS(1837),
    [anon_sym_STAR] = ACTIONS(1841),
    [anon_sym_CARET] = ACTIONS(1839),
    [anon_sym_AMP] = ACTIONS(1839),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1843),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1845),
    [anon_sym_DOT_DOT] = ACTIONS(1847),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1063] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(5513),
    [sym_bracketed_argument_list] = STATE(3921),
    [sym__name] = STATE(6919),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2868),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(7068),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5962),
    [sym_non_lvalue_expression] = STATE(5735),
    [sym_lvalue_expression] = STATE(4323),
    [sym__expression_statement_expression] = STATE(5733),
    [sym_assignment_expression] = STATE(5734),
    [sym_binary_expression] = STATE(5733),
    [sym_postfix_unary_expression] = STATE(5734),
    [sym_prefix_unary_expression] = STATE(5734),
    [sym__pointer_indirection_expression] = STATE(3911),
    [sym_query_expression] = STATE(5733),
    [sym_from_clause] = STATE(7393),
    [sym_conditional_expression] = STATE(5733),
    [sym_conditional_access_expression] = STATE(5733),
    [sym_as_expression] = STATE(5733),
    [sym_is_expression] = STATE(5733),
    [sym_is_pattern_expression] = STATE(5733),
    [sym_cast_expression] = STATE(5733),
    [sym_checked_expression] = STATE(5733),
    [sym_invocation_expression] = STATE(5734),
    [sym_switch_expression] = STATE(5733),
    [sym_await_expression] = STATE(5734),
    [sym_throw_expression] = STATE(5733),
    [sym_element_access_expression] = STATE(3911),
    [sym_interpolated_string_expression] = STATE(5733),
    [sym_member_access_expression] = STATE(3911),
    [sym_object_creation_expression] = STATE(5734),
    [sym_parenthesized_expression] = STATE(5734),
    [sym__parenthesized_lvalue_expression] = STATE(3911),
    [sym_lambda_expression] = STATE(5733),
    [sym__lambda_parameters] = STATE(9932),
    [sym_array_creation_expression] = STATE(5733),
    [sym_anonymous_method_expression] = STATE(5733),
    [sym_anonymous_object_creation_expression] = STATE(5733),
    [sym_implicit_array_creation_expression] = STATE(5733),
    [sym_implicit_object_creation_expression] = STATE(5733),
    [sym_implicit_stackalloc_expression] = STATE(5733),
    [sym_initializer_expression] = STATE(5733),
    [sym_default_expression] = STATE(5733),
    [sym_with_expression] = STATE(5733),
    [sym_sizeof_expression] = STATE(5733),
    [sym_typeof_expression] = STATE(5733),
    [sym_makeref_expression] = STATE(5733),
    [sym_ref_expression] = STATE(5733),
    [sym_reftype_expression] = STATE(5733),
    [sym_refvalue_expression] = STATE(5733),
    [sym_stackalloc_expression] = STATE(5733),
    [sym_range_expression] = STATE(5733),
    [sym_tuple_expression] = STATE(3911),
    [sym_literal] = STATE(5733),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2798),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(5733),
    [sym_preproc_region] = STATE(1063),
    [sym_preproc_endregion] = STATE(1063),
    [sym_preproc_line] = STATE(1063),
    [sym_preproc_pragma] = STATE(1063),
    [sym_preproc_nullable] = STATE(1063),
    [sym_preproc_error] = STATE(1063),
    [sym_preproc_define] = STATE(1063),
    [sym_preproc_undef] = STATE(1063),
    [aux_sym_class_declaration_repeat1] = STATE(3831),
    [aux_sym_lambda_expression_repeat1] = STATE(4227),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_LPAREN] = ACTIONS(1577),
    [anon_sym_ref] = ACTIONS(1579),
    [anon_sym_LBRACE] = ACTIONS(2773),
    [anon_sym_delegate] = ACTIONS(1379),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1381),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1583),
    [anon_sym_TILDE] = ACTIONS(1583),
    [anon_sym_PLUS_PLUS] = ACTIONS(1583),
    [anon_sym_DASH_DASH] = ACTIONS(1583),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1581),
    [anon_sym_DASH] = ACTIONS(1581),
    [anon_sym_STAR] = ACTIONS(1391),
    [anon_sym_CARET] = ACTIONS(1583),
    [anon_sym_AMP] = ACTIONS(1583),
    [anon_sym_this] = ACTIONS(1393),
    [anon_sym_scoped] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1397),
    [sym_predefined_type] = ACTIONS(1399),
    [anon_sym_unchecked] = ACTIONS(1383),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1585),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1587),
    [anon_sym_DOT_DOT] = ACTIONS(1589),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_stackalloc] = ACTIONS(1413),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(1419),
    [anon_sym___reftype] = ACTIONS(1421),
    [anon_sym___refvalue] = ACTIONS(1423),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
  },
  [1064] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6874),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2968),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6944),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5577),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4214),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7412),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9154),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1064),
    [sym_preproc_endregion] = STATE(1064),
    [sym_preproc_line] = STATE(1064),
    [sym_preproc_pragma] = STATE(1064),
    [sym_preproc_nullable] = STATE(1064),
    [sym_preproc_error] = STATE(1064),
    [sym_preproc_define] = STATE(1064),
    [sym_preproc_undef] = STATE(1064),
    [aux_sym_class_declaration_repeat1] = STATE(3798),
    [aux_sym_lambda_expression_repeat1] = STATE(4162),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1777),
    [anon_sym_ref] = ACTIONS(1779),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1781),
    [anon_sym_readonly] = ACTIONS(2693),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1785),
    [anon_sym_TILDE] = ACTIONS(1785),
    [anon_sym_PLUS_PLUS] = ACTIONS(1785),
    [anon_sym_DASH_DASH] = ACTIONS(1785),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_STAR] = ACTIONS(1787),
    [anon_sym_CARET] = ACTIONS(1785),
    [anon_sym_AMP] = ACTIONS(1785),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1789),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1791),
    [anon_sym_DOT_DOT] = ACTIONS(1793),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1065] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6898),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2940),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6937),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5774),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4318),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7401),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9262),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1065),
    [sym_preproc_endregion] = STATE(1065),
    [sym_preproc_line] = STATE(1065),
    [sym_preproc_pragma] = STATE(1065),
    [sym_preproc_nullable] = STATE(1065),
    [sym_preproc_error] = STATE(1065),
    [sym_preproc_define] = STATE(1065),
    [sym_preproc_undef] = STATE(1065),
    [aux_sym_class_declaration_repeat1] = STATE(3815),
    [aux_sym_lambda_expression_repeat1] = STATE(4072),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1885),
    [anon_sym_ref] = ACTIONS(1887),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1889),
    [anon_sym_readonly] = ACTIONS(2693),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1893),
    [anon_sym_TILDE] = ACTIONS(1893),
    [anon_sym_PLUS_PLUS] = ACTIONS(1893),
    [anon_sym_DASH_DASH] = ACTIONS(1893),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1891),
    [anon_sym_DASH] = ACTIONS(1891),
    [anon_sym_STAR] = ACTIONS(1895),
    [anon_sym_CARET] = ACTIONS(1893),
    [anon_sym_AMP] = ACTIONS(1893),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1897),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1899),
    [anon_sym_DOT_DOT] = ACTIONS(1901),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1066] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4065),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6896),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2944),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6952),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5559),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4248),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7396),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9160),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1066),
    [sym_preproc_endregion] = STATE(1066),
    [sym_preproc_line] = STATE(1066),
    [sym_preproc_pragma] = STATE(1066),
    [sym_preproc_nullable] = STATE(1066),
    [sym_preproc_error] = STATE(1066),
    [sym_preproc_define] = STATE(1066),
    [sym_preproc_undef] = STATE(1066),
    [aux_sym_class_declaration_repeat1] = STATE(3795),
    [aux_sym_lambda_expression_repeat1] = STATE(4144),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1831),
    [anon_sym_ref] = ACTIONS(1833),
    [anon_sym_LBRACE] = ACTIONS(2833),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1835),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1839),
    [anon_sym_TILDE] = ACTIONS(1839),
    [anon_sym_PLUS_PLUS] = ACTIONS(1839),
    [anon_sym_DASH_DASH] = ACTIONS(1839),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1837),
    [anon_sym_DASH] = ACTIONS(1837),
    [anon_sym_STAR] = ACTIONS(1841),
    [anon_sym_CARET] = ACTIONS(1839),
    [anon_sym_AMP] = ACTIONS(1839),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1843),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1845),
    [anon_sym_DOT_DOT] = ACTIONS(1847),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1067] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3977),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6874),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2968),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6941),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5648),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4214),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7412),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9154),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1067),
    [sym_preproc_endregion] = STATE(1067),
    [sym_preproc_line] = STATE(1067),
    [sym_preproc_pragma] = STATE(1067),
    [sym_preproc_nullable] = STATE(1067),
    [sym_preproc_error] = STATE(1067),
    [sym_preproc_define] = STATE(1067),
    [sym_preproc_undef] = STATE(1067),
    [aux_sym_class_declaration_repeat1] = STATE(3798),
    [aux_sym_lambda_expression_repeat1] = STATE(4162),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1777),
    [anon_sym_ref] = ACTIONS(1779),
    [anon_sym_LBRACE] = ACTIONS(2833),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1781),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1785),
    [anon_sym_TILDE] = ACTIONS(1785),
    [anon_sym_PLUS_PLUS] = ACTIONS(1785),
    [anon_sym_DASH_DASH] = ACTIONS(1785),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_STAR] = ACTIONS(1787),
    [anon_sym_CARET] = ACTIONS(1785),
    [anon_sym_AMP] = ACTIONS(1785),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1789),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1791),
    [anon_sym_DOT_DOT] = ACTIONS(1793),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1068] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3638),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6894),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2955),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7025),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4847),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(3735),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7397),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9590),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1068),
    [sym_preproc_endregion] = STATE(1068),
    [sym_preproc_line] = STATE(1068),
    [sym_preproc_pragma] = STATE(1068),
    [sym_preproc_nullable] = STATE(1068),
    [sym_preproc_error] = STATE(1068),
    [sym_preproc_define] = STATE(1068),
    [sym_preproc_undef] = STATE(1068),
    [aux_sym_class_declaration_repeat1] = STATE(3844),
    [aux_sym_lambda_expression_repeat1] = STATE(4245),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1849),
    [anon_sym_ref] = ACTIONS(1851),
    [anon_sym_LBRACE] = ACTIONS(2767),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1853),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1857),
    [anon_sym_TILDE] = ACTIONS(1857),
    [anon_sym_PLUS_PLUS] = ACTIONS(1857),
    [anon_sym_DASH_DASH] = ACTIONS(1857),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1855),
    [anon_sym_DASH] = ACTIONS(1855),
    [anon_sym_STAR] = ACTIONS(1859),
    [anon_sym_CARET] = ACTIONS(1857),
    [anon_sym_AMP] = ACTIONS(1857),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1861),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1863),
    [anon_sym_DOT_DOT] = ACTIONS(1865),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1069] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3934),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6874),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2968),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6941),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5382),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4214),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7412),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9154),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1069),
    [sym_preproc_endregion] = STATE(1069),
    [sym_preproc_line] = STATE(1069),
    [sym_preproc_pragma] = STATE(1069),
    [sym_preproc_nullable] = STATE(1069),
    [sym_preproc_error] = STATE(1069),
    [sym_preproc_define] = STATE(1069),
    [sym_preproc_undef] = STATE(1069),
    [aux_sym_class_declaration_repeat1] = STATE(3798),
    [aux_sym_lambda_expression_repeat1] = STATE(4162),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1777),
    [anon_sym_ref] = ACTIONS(1779),
    [anon_sym_LBRACE] = ACTIONS(2833),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1781),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1785),
    [anon_sym_TILDE] = ACTIONS(1785),
    [anon_sym_PLUS_PLUS] = ACTIONS(1785),
    [anon_sym_DASH_DASH] = ACTIONS(1785),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_STAR] = ACTIONS(1787),
    [anon_sym_CARET] = ACTIONS(1785),
    [anon_sym_AMP] = ACTIONS(1785),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1789),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1791),
    [anon_sym_DOT_DOT] = ACTIONS(1793),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1070] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4003),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6874),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2968),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6941),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5646),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4214),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7412),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9154),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1070),
    [sym_preproc_endregion] = STATE(1070),
    [sym_preproc_line] = STATE(1070),
    [sym_preproc_pragma] = STATE(1070),
    [sym_preproc_nullable] = STATE(1070),
    [sym_preproc_error] = STATE(1070),
    [sym_preproc_define] = STATE(1070),
    [sym_preproc_undef] = STATE(1070),
    [aux_sym_class_declaration_repeat1] = STATE(3798),
    [aux_sym_lambda_expression_repeat1] = STATE(4162),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1777),
    [anon_sym_ref] = ACTIONS(1779),
    [anon_sym_LBRACE] = ACTIONS(2833),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1781),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1785),
    [anon_sym_TILDE] = ACTIONS(1785),
    [anon_sym_PLUS_PLUS] = ACTIONS(1785),
    [anon_sym_DASH_DASH] = ACTIONS(1785),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_STAR] = ACTIONS(1787),
    [anon_sym_CARET] = ACTIONS(1785),
    [anon_sym_AMP] = ACTIONS(1785),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1789),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1791),
    [anon_sym_DOT_DOT] = ACTIONS(1793),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1071] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4050),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6896),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2944),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6952),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5578),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4248),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7396),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9160),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1071),
    [sym_preproc_endregion] = STATE(1071),
    [sym_preproc_line] = STATE(1071),
    [sym_preproc_pragma] = STATE(1071),
    [sym_preproc_nullable] = STATE(1071),
    [sym_preproc_error] = STATE(1071),
    [sym_preproc_define] = STATE(1071),
    [sym_preproc_undef] = STATE(1071),
    [aux_sym_class_declaration_repeat1] = STATE(3795),
    [aux_sym_lambda_expression_repeat1] = STATE(4144),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1831),
    [anon_sym_ref] = ACTIONS(1833),
    [anon_sym_LBRACE] = ACTIONS(2833),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1835),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1839),
    [anon_sym_TILDE] = ACTIONS(1839),
    [anon_sym_PLUS_PLUS] = ACTIONS(1839),
    [anon_sym_DASH_DASH] = ACTIONS(1839),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1837),
    [anon_sym_DASH] = ACTIONS(1837),
    [anon_sym_STAR] = ACTIONS(1841),
    [anon_sym_CARET] = ACTIONS(1839),
    [anon_sym_AMP] = ACTIONS(1839),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1843),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1845),
    [anon_sym_DOT_DOT] = ACTIONS(1847),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1072] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3632),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6894),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2955),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7025),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4842),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(3735),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7397),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9590),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1072),
    [sym_preproc_endregion] = STATE(1072),
    [sym_preproc_line] = STATE(1072),
    [sym_preproc_pragma] = STATE(1072),
    [sym_preproc_nullable] = STATE(1072),
    [sym_preproc_error] = STATE(1072),
    [sym_preproc_define] = STATE(1072),
    [sym_preproc_undef] = STATE(1072),
    [aux_sym_class_declaration_repeat1] = STATE(3844),
    [aux_sym_lambda_expression_repeat1] = STATE(4245),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1849),
    [anon_sym_ref] = ACTIONS(1851),
    [anon_sym_LBRACE] = ACTIONS(2767),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1853),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1857),
    [anon_sym_TILDE] = ACTIONS(1857),
    [anon_sym_PLUS_PLUS] = ACTIONS(1857),
    [anon_sym_DASH_DASH] = ACTIONS(1857),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1855),
    [anon_sym_DASH] = ACTIONS(1855),
    [anon_sym_STAR] = ACTIONS(1859),
    [anon_sym_CARET] = ACTIONS(1857),
    [anon_sym_AMP] = ACTIONS(1857),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1861),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1863),
    [anon_sym_DOT_DOT] = ACTIONS(1865),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1073] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3767),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6910),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2957),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6984),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4938),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(3777),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7387),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9385),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1073),
    [sym_preproc_endregion] = STATE(1073),
    [sym_preproc_line] = STATE(1073),
    [sym_preproc_pragma] = STATE(1073),
    [sym_preproc_nullable] = STATE(1073),
    [sym_preproc_error] = STATE(1073),
    [sym_preproc_define] = STATE(1073),
    [sym_preproc_undef] = STATE(1073),
    [aux_sym_class_declaration_repeat1] = STATE(3793),
    [aux_sym_lambda_expression_repeat1] = STATE(4083),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1795),
    [anon_sym_ref] = ACTIONS(1797),
    [anon_sym_LBRACE] = ACTIONS(2765),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1799),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1803),
    [anon_sym_TILDE] = ACTIONS(1803),
    [anon_sym_PLUS_PLUS] = ACTIONS(1803),
    [anon_sym_DASH_DASH] = ACTIONS(1803),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1801),
    [anon_sym_DASH] = ACTIONS(1801),
    [anon_sym_STAR] = ACTIONS(1805),
    [anon_sym_CARET] = ACTIONS(1803),
    [anon_sym_AMP] = ACTIONS(1803),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1807),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1809),
    [anon_sym_DOT_DOT] = ACTIONS(1811),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1074] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4050),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6874),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2968),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6941),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5640),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4214),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7412),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9154),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1074),
    [sym_preproc_endregion] = STATE(1074),
    [sym_preproc_line] = STATE(1074),
    [sym_preproc_pragma] = STATE(1074),
    [sym_preproc_nullable] = STATE(1074),
    [sym_preproc_error] = STATE(1074),
    [sym_preproc_define] = STATE(1074),
    [sym_preproc_undef] = STATE(1074),
    [aux_sym_class_declaration_repeat1] = STATE(3798),
    [aux_sym_lambda_expression_repeat1] = STATE(4162),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1777),
    [anon_sym_ref] = ACTIONS(1779),
    [anon_sym_LBRACE] = ACTIONS(2833),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1781),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1785),
    [anon_sym_TILDE] = ACTIONS(1785),
    [anon_sym_PLUS_PLUS] = ACTIONS(1785),
    [anon_sym_DASH_DASH] = ACTIONS(1785),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_STAR] = ACTIONS(1787),
    [anon_sym_CARET] = ACTIONS(1785),
    [anon_sym_AMP] = ACTIONS(1785),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1789),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1791),
    [anon_sym_DOT_DOT] = ACTIONS(1793),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1075] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4065),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6874),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2968),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6941),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5638),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4214),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7412),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9154),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1075),
    [sym_preproc_endregion] = STATE(1075),
    [sym_preproc_line] = STATE(1075),
    [sym_preproc_pragma] = STATE(1075),
    [sym_preproc_nullable] = STATE(1075),
    [sym_preproc_error] = STATE(1075),
    [sym_preproc_define] = STATE(1075),
    [sym_preproc_undef] = STATE(1075),
    [aux_sym_class_declaration_repeat1] = STATE(3798),
    [aux_sym_lambda_expression_repeat1] = STATE(4162),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1777),
    [anon_sym_ref] = ACTIONS(1779),
    [anon_sym_LBRACE] = ACTIONS(2833),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1781),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1785),
    [anon_sym_TILDE] = ACTIONS(1785),
    [anon_sym_PLUS_PLUS] = ACTIONS(1785),
    [anon_sym_DASH_DASH] = ACTIONS(1785),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_STAR] = ACTIONS(1787),
    [anon_sym_CARET] = ACTIONS(1785),
    [anon_sym_AMP] = ACTIONS(1785),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1789),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1791),
    [anon_sym_DOT_DOT] = ACTIONS(1793),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1076] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4003),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6896),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2944),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6952),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5592),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4248),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7396),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9160),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1076),
    [sym_preproc_endregion] = STATE(1076),
    [sym_preproc_line] = STATE(1076),
    [sym_preproc_pragma] = STATE(1076),
    [sym_preproc_nullable] = STATE(1076),
    [sym_preproc_error] = STATE(1076),
    [sym_preproc_define] = STATE(1076),
    [sym_preproc_undef] = STATE(1076),
    [aux_sym_class_declaration_repeat1] = STATE(3795),
    [aux_sym_lambda_expression_repeat1] = STATE(4144),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1831),
    [anon_sym_ref] = ACTIONS(1833),
    [anon_sym_LBRACE] = ACTIONS(2833),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1835),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1839),
    [anon_sym_TILDE] = ACTIONS(1839),
    [anon_sym_PLUS_PLUS] = ACTIONS(1839),
    [anon_sym_DASH_DASH] = ACTIONS(1839),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1837),
    [anon_sym_DASH] = ACTIONS(1837),
    [anon_sym_STAR] = ACTIONS(1841),
    [anon_sym_CARET] = ACTIONS(1839),
    [anon_sym_AMP] = ACTIONS(1839),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1843),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1845),
    [anon_sym_DOT_DOT] = ACTIONS(1847),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1077] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4007),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6874),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2968),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6941),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5637),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4214),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7412),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9154),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1077),
    [sym_preproc_endregion] = STATE(1077),
    [sym_preproc_line] = STATE(1077),
    [sym_preproc_pragma] = STATE(1077),
    [sym_preproc_nullable] = STATE(1077),
    [sym_preproc_error] = STATE(1077),
    [sym_preproc_define] = STATE(1077),
    [sym_preproc_undef] = STATE(1077),
    [aux_sym_class_declaration_repeat1] = STATE(3798),
    [aux_sym_lambda_expression_repeat1] = STATE(4162),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1777),
    [anon_sym_ref] = ACTIONS(1779),
    [anon_sym_LBRACE] = ACTIONS(2833),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1781),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1785),
    [anon_sym_TILDE] = ACTIONS(1785),
    [anon_sym_PLUS_PLUS] = ACTIONS(1785),
    [anon_sym_DASH_DASH] = ACTIONS(1785),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_STAR] = ACTIONS(1787),
    [anon_sym_CARET] = ACTIONS(1785),
    [anon_sym_AMP] = ACTIONS(1785),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1789),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1791),
    [anon_sym_DOT_DOT] = ACTIONS(1793),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1078] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3934),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6896),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2944),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6952),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5597),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4248),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7396),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9160),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1078),
    [sym_preproc_endregion] = STATE(1078),
    [sym_preproc_line] = STATE(1078),
    [sym_preproc_pragma] = STATE(1078),
    [sym_preproc_nullable] = STATE(1078),
    [sym_preproc_error] = STATE(1078),
    [sym_preproc_define] = STATE(1078),
    [sym_preproc_undef] = STATE(1078),
    [aux_sym_class_declaration_repeat1] = STATE(3795),
    [aux_sym_lambda_expression_repeat1] = STATE(4144),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1831),
    [anon_sym_ref] = ACTIONS(1833),
    [anon_sym_LBRACE] = ACTIONS(2833),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1835),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1839),
    [anon_sym_TILDE] = ACTIONS(1839),
    [anon_sym_PLUS_PLUS] = ACTIONS(1839),
    [anon_sym_DASH_DASH] = ACTIONS(1839),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1837),
    [anon_sym_DASH] = ACTIONS(1837),
    [anon_sym_STAR] = ACTIONS(1841),
    [anon_sym_CARET] = ACTIONS(1839),
    [anon_sym_AMP] = ACTIONS(1839),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1843),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1845),
    [anon_sym_DOT_DOT] = ACTIONS(1847),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1079] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3977),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6896),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2944),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6952),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5600),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4248),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7396),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9160),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1079),
    [sym_preproc_endregion] = STATE(1079),
    [sym_preproc_line] = STATE(1079),
    [sym_preproc_pragma] = STATE(1079),
    [sym_preproc_nullable] = STATE(1079),
    [sym_preproc_error] = STATE(1079),
    [sym_preproc_define] = STATE(1079),
    [sym_preproc_undef] = STATE(1079),
    [aux_sym_class_declaration_repeat1] = STATE(3795),
    [aux_sym_lambda_expression_repeat1] = STATE(4144),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1831),
    [anon_sym_ref] = ACTIONS(1833),
    [anon_sym_LBRACE] = ACTIONS(2833),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1835),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1839),
    [anon_sym_TILDE] = ACTIONS(1839),
    [anon_sym_PLUS_PLUS] = ACTIONS(1839),
    [anon_sym_DASH_DASH] = ACTIONS(1839),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1837),
    [anon_sym_DASH] = ACTIONS(1837),
    [anon_sym_STAR] = ACTIONS(1841),
    [anon_sym_CARET] = ACTIONS(1839),
    [anon_sym_AMP] = ACTIONS(1839),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1843),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1845),
    [anon_sym_DOT_DOT] = ACTIONS(1847),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1080] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6880),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7039),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5882),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4312),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7380),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9286),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1080),
    [sym_preproc_endregion] = STATE(1080),
    [sym_preproc_line] = STATE(1080),
    [sym_preproc_pragma] = STATE(1080),
    [sym_preproc_nullable] = STATE(1080),
    [sym_preproc_error] = STATE(1080),
    [sym_preproc_define] = STATE(1080),
    [sym_preproc_undef] = STATE(1080),
    [aux_sym_class_declaration_repeat1] = STATE(3799),
    [aux_sym_lambda_expression_repeat1] = STATE(4101),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1545),
    [anon_sym_ref] = ACTIONS(1547),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_readonly] = ACTIONS(2693),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1551),
    [anon_sym_TILDE] = ACTIONS(1551),
    [anon_sym_PLUS_PLUS] = ACTIONS(1551),
    [anon_sym_DASH_DASH] = ACTIONS(1551),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1549),
    [anon_sym_DASH] = ACTIONS(1549),
    [anon_sym_STAR] = ACTIONS(1553),
    [anon_sym_CARET] = ACTIONS(1551),
    [anon_sym_AMP] = ACTIONS(1551),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1555),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1557),
    [anon_sym_DOT_DOT] = ACTIONS(1559),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1081] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6896),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2944),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6946),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5603),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4248),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7396),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9160),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1081),
    [sym_preproc_endregion] = STATE(1081),
    [sym_preproc_line] = STATE(1081),
    [sym_preproc_pragma] = STATE(1081),
    [sym_preproc_nullable] = STATE(1081),
    [sym_preproc_error] = STATE(1081),
    [sym_preproc_define] = STATE(1081),
    [sym_preproc_undef] = STATE(1081),
    [aux_sym_class_declaration_repeat1] = STATE(3795),
    [aux_sym_lambda_expression_repeat1] = STATE(4144),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1831),
    [anon_sym_ref] = ACTIONS(1833),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1835),
    [anon_sym_readonly] = ACTIONS(2693),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1839),
    [anon_sym_TILDE] = ACTIONS(1839),
    [anon_sym_PLUS_PLUS] = ACTIONS(1839),
    [anon_sym_DASH_DASH] = ACTIONS(1839),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1837),
    [anon_sym_DASH] = ACTIONS(1837),
    [anon_sym_STAR] = ACTIONS(1841),
    [anon_sym_CARET] = ACTIONS(1839),
    [anon_sym_AMP] = ACTIONS(1839),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1843),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1845),
    [anon_sym_DOT_DOT] = ACTIONS(1847),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1082] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3751),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6910),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2957),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6984),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4915),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(3777),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7387),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9385),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1082),
    [sym_preproc_endregion] = STATE(1082),
    [sym_preproc_line] = STATE(1082),
    [sym_preproc_pragma] = STATE(1082),
    [sym_preproc_nullable] = STATE(1082),
    [sym_preproc_error] = STATE(1082),
    [sym_preproc_define] = STATE(1082),
    [sym_preproc_undef] = STATE(1082),
    [aux_sym_class_declaration_repeat1] = STATE(3793),
    [aux_sym_lambda_expression_repeat1] = STATE(4083),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1795),
    [anon_sym_ref] = ACTIONS(1797),
    [anon_sym_LBRACE] = ACTIONS(2765),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1799),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1803),
    [anon_sym_TILDE] = ACTIONS(1803),
    [anon_sym_PLUS_PLUS] = ACTIONS(1803),
    [anon_sym_DASH_DASH] = ACTIONS(1803),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1801),
    [anon_sym_DASH] = ACTIONS(1801),
    [anon_sym_STAR] = ACTIONS(1805),
    [anon_sym_CARET] = ACTIONS(1803),
    [anon_sym_AMP] = ACTIONS(1803),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1807),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1809),
    [anon_sym_DOT_DOT] = ACTIONS(1811),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1083] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(5573),
    [sym_bracketed_argument_list] = STATE(3921),
    [sym__name] = STATE(6919),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2868),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(7068),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5996),
    [sym_non_lvalue_expression] = STATE(5735),
    [sym_lvalue_expression] = STATE(4323),
    [sym__expression_statement_expression] = STATE(5733),
    [sym_assignment_expression] = STATE(5734),
    [sym_binary_expression] = STATE(5733),
    [sym_postfix_unary_expression] = STATE(5734),
    [sym_prefix_unary_expression] = STATE(5734),
    [sym__pointer_indirection_expression] = STATE(3911),
    [sym_query_expression] = STATE(5733),
    [sym_from_clause] = STATE(7393),
    [sym_conditional_expression] = STATE(5733),
    [sym_conditional_access_expression] = STATE(5733),
    [sym_as_expression] = STATE(5733),
    [sym_is_expression] = STATE(5733),
    [sym_is_pattern_expression] = STATE(5733),
    [sym_cast_expression] = STATE(5733),
    [sym_checked_expression] = STATE(5733),
    [sym_invocation_expression] = STATE(5734),
    [sym_switch_expression] = STATE(5733),
    [sym_await_expression] = STATE(5734),
    [sym_throw_expression] = STATE(5733),
    [sym_element_access_expression] = STATE(3911),
    [sym_interpolated_string_expression] = STATE(5733),
    [sym_member_access_expression] = STATE(3911),
    [sym_object_creation_expression] = STATE(5734),
    [sym_parenthesized_expression] = STATE(5734),
    [sym__parenthesized_lvalue_expression] = STATE(3911),
    [sym_lambda_expression] = STATE(5733),
    [sym__lambda_parameters] = STATE(9932),
    [sym_array_creation_expression] = STATE(5733),
    [sym_anonymous_method_expression] = STATE(5733),
    [sym_anonymous_object_creation_expression] = STATE(5733),
    [sym_implicit_array_creation_expression] = STATE(5733),
    [sym_implicit_object_creation_expression] = STATE(5733),
    [sym_implicit_stackalloc_expression] = STATE(5733),
    [sym_initializer_expression] = STATE(5733),
    [sym_default_expression] = STATE(5733),
    [sym_with_expression] = STATE(5733),
    [sym_sizeof_expression] = STATE(5733),
    [sym_typeof_expression] = STATE(5733),
    [sym_makeref_expression] = STATE(5733),
    [sym_ref_expression] = STATE(5733),
    [sym_reftype_expression] = STATE(5733),
    [sym_refvalue_expression] = STATE(5733),
    [sym_stackalloc_expression] = STATE(5733),
    [sym_range_expression] = STATE(5733),
    [sym_tuple_expression] = STATE(3911),
    [sym_literal] = STATE(5733),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2798),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(5733),
    [sym_preproc_region] = STATE(1083),
    [sym_preproc_endregion] = STATE(1083),
    [sym_preproc_line] = STATE(1083),
    [sym_preproc_pragma] = STATE(1083),
    [sym_preproc_nullable] = STATE(1083),
    [sym_preproc_error] = STATE(1083),
    [sym_preproc_define] = STATE(1083),
    [sym_preproc_undef] = STATE(1083),
    [aux_sym_class_declaration_repeat1] = STATE(3831),
    [aux_sym_lambda_expression_repeat1] = STATE(4227),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_LPAREN] = ACTIONS(1577),
    [anon_sym_ref] = ACTIONS(1579),
    [anon_sym_LBRACE] = ACTIONS(2773),
    [anon_sym_delegate] = ACTIONS(1379),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1381),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1583),
    [anon_sym_TILDE] = ACTIONS(1583),
    [anon_sym_PLUS_PLUS] = ACTIONS(1583),
    [anon_sym_DASH_DASH] = ACTIONS(1583),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1581),
    [anon_sym_DASH] = ACTIONS(1581),
    [anon_sym_STAR] = ACTIONS(1391),
    [anon_sym_CARET] = ACTIONS(1583),
    [anon_sym_AMP] = ACTIONS(1583),
    [anon_sym_this] = ACTIONS(1393),
    [anon_sym_scoped] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1397),
    [sym_predefined_type] = ACTIONS(1399),
    [anon_sym_unchecked] = ACTIONS(1383),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1585),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1587),
    [anon_sym_DOT_DOT] = ACTIONS(1589),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_stackalloc] = ACTIONS(1413),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(1419),
    [anon_sym___reftype] = ACTIONS(1421),
    [anon_sym___refvalue] = ACTIONS(1423),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
  },
  [1084] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(5607),
    [sym_bracketed_argument_list] = STATE(3921),
    [sym__name] = STATE(6919),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2868),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(7068),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6013),
    [sym_non_lvalue_expression] = STATE(5735),
    [sym_lvalue_expression] = STATE(4323),
    [sym__expression_statement_expression] = STATE(5733),
    [sym_assignment_expression] = STATE(5734),
    [sym_binary_expression] = STATE(5733),
    [sym_postfix_unary_expression] = STATE(5734),
    [sym_prefix_unary_expression] = STATE(5734),
    [sym__pointer_indirection_expression] = STATE(3911),
    [sym_query_expression] = STATE(5733),
    [sym_from_clause] = STATE(7393),
    [sym_conditional_expression] = STATE(5733),
    [sym_conditional_access_expression] = STATE(5733),
    [sym_as_expression] = STATE(5733),
    [sym_is_expression] = STATE(5733),
    [sym_is_pattern_expression] = STATE(5733),
    [sym_cast_expression] = STATE(5733),
    [sym_checked_expression] = STATE(5733),
    [sym_invocation_expression] = STATE(5734),
    [sym_switch_expression] = STATE(5733),
    [sym_await_expression] = STATE(5734),
    [sym_throw_expression] = STATE(5733),
    [sym_element_access_expression] = STATE(3911),
    [sym_interpolated_string_expression] = STATE(5733),
    [sym_member_access_expression] = STATE(3911),
    [sym_object_creation_expression] = STATE(5734),
    [sym_parenthesized_expression] = STATE(5734),
    [sym__parenthesized_lvalue_expression] = STATE(3911),
    [sym_lambda_expression] = STATE(5733),
    [sym__lambda_parameters] = STATE(9932),
    [sym_array_creation_expression] = STATE(5733),
    [sym_anonymous_method_expression] = STATE(5733),
    [sym_anonymous_object_creation_expression] = STATE(5733),
    [sym_implicit_array_creation_expression] = STATE(5733),
    [sym_implicit_object_creation_expression] = STATE(5733),
    [sym_implicit_stackalloc_expression] = STATE(5733),
    [sym_initializer_expression] = STATE(5733),
    [sym_default_expression] = STATE(5733),
    [sym_with_expression] = STATE(5733),
    [sym_sizeof_expression] = STATE(5733),
    [sym_typeof_expression] = STATE(5733),
    [sym_makeref_expression] = STATE(5733),
    [sym_ref_expression] = STATE(5733),
    [sym_reftype_expression] = STATE(5733),
    [sym_refvalue_expression] = STATE(5733),
    [sym_stackalloc_expression] = STATE(5733),
    [sym_range_expression] = STATE(5733),
    [sym_tuple_expression] = STATE(3911),
    [sym_literal] = STATE(5733),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2798),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(5733),
    [sym_preproc_region] = STATE(1084),
    [sym_preproc_endregion] = STATE(1084),
    [sym_preproc_line] = STATE(1084),
    [sym_preproc_pragma] = STATE(1084),
    [sym_preproc_nullable] = STATE(1084),
    [sym_preproc_error] = STATE(1084),
    [sym_preproc_define] = STATE(1084),
    [sym_preproc_undef] = STATE(1084),
    [aux_sym_class_declaration_repeat1] = STATE(3831),
    [aux_sym_lambda_expression_repeat1] = STATE(4227),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_LPAREN] = ACTIONS(1577),
    [anon_sym_ref] = ACTIONS(1579),
    [anon_sym_LBRACE] = ACTIONS(2773),
    [anon_sym_delegate] = ACTIONS(1379),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1381),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1583),
    [anon_sym_TILDE] = ACTIONS(1583),
    [anon_sym_PLUS_PLUS] = ACTIONS(1583),
    [anon_sym_DASH_DASH] = ACTIONS(1583),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1581),
    [anon_sym_DASH] = ACTIONS(1581),
    [anon_sym_STAR] = ACTIONS(1391),
    [anon_sym_CARET] = ACTIONS(1583),
    [anon_sym_AMP] = ACTIONS(1583),
    [anon_sym_this] = ACTIONS(1393),
    [anon_sym_scoped] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1397),
    [sym_predefined_type] = ACTIONS(1399),
    [anon_sym_unchecked] = ACTIONS(1383),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1585),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1587),
    [anon_sym_DOT_DOT] = ACTIONS(1589),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_stackalloc] = ACTIONS(1413),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(1419),
    [anon_sym___reftype] = ACTIONS(1421),
    [anon_sym___refvalue] = ACTIONS(1423),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
  },
  [1085] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6894),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2955),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7123),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4743),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(3735),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7397),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9590),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1085),
    [sym_preproc_endregion] = STATE(1085),
    [sym_preproc_line] = STATE(1085),
    [sym_preproc_pragma] = STATE(1085),
    [sym_preproc_nullable] = STATE(1085),
    [sym_preproc_error] = STATE(1085),
    [sym_preproc_define] = STATE(1085),
    [sym_preproc_undef] = STATE(1085),
    [aux_sym_class_declaration_repeat1] = STATE(3844),
    [aux_sym_lambda_expression_repeat1] = STATE(4245),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1849),
    [anon_sym_ref] = ACTIONS(1851),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1853),
    [anon_sym_readonly] = ACTIONS(2693),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1857),
    [anon_sym_TILDE] = ACTIONS(1857),
    [anon_sym_PLUS_PLUS] = ACTIONS(1857),
    [anon_sym_DASH_DASH] = ACTIONS(1857),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1855),
    [anon_sym_DASH] = ACTIONS(1855),
    [anon_sym_STAR] = ACTIONS(1859),
    [anon_sym_CARET] = ACTIONS(1857),
    [anon_sym_AMP] = ACTIONS(1857),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1861),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1863),
    [anon_sym_DOT_DOT] = ACTIONS(1865),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1086] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6880),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6661),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5700),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4210),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9027),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1086),
    [sym_preproc_endregion] = STATE(1086),
    [sym_preproc_line] = STATE(1086),
    [sym_preproc_pragma] = STATE(1086),
    [sym_preproc_nullable] = STATE(1086),
    [sym_preproc_error] = STATE(1086),
    [sym_preproc_define] = STATE(1086),
    [sym_preproc_undef] = STATE(1086),
    [aux_sym_class_declaration_repeat1] = STATE(3852),
    [aux_sym_lambda_expression_repeat1] = STATE(4220),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1473),
    [anon_sym_ref] = ACTIONS(1475),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_readonly] = ACTIONS(2693),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(1479),
    [anon_sym_PLUS_PLUS] = ACTIONS(1479),
    [anon_sym_DASH_DASH] = ACTIONS(1479),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1477),
    [anon_sym_DASH] = ACTIONS(1477),
    [anon_sym_STAR] = ACTIONS(1101),
    [anon_sym_CARET] = ACTIONS(1479),
    [anon_sym_AMP] = ACTIONS(1479),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1111),
    [anon_sym_DOT_DOT] = ACTIONS(1115),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1087] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3717),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6961),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5417),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9849),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1087),
    [sym_preproc_endregion] = STATE(1087),
    [sym_preproc_line] = STATE(1087),
    [sym_preproc_pragma] = STATE(1087),
    [sym_preproc_nullable] = STATE(1087),
    [sym_preproc_error] = STATE(1087),
    [sym_preproc_define] = STATE(1087),
    [sym_preproc_undef] = STATE(1087),
    [aux_sym_class_declaration_repeat1] = STATE(3841),
    [aux_sym_lambda_expression_repeat1] = STATE(4283),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1459),
    [anon_sym_ref] = ACTIONS(1461),
    [anon_sym_LBRACE] = ACTIONS(2765),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1465),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1467),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1469),
    [anon_sym_DOT_DOT] = ACTIONS(1471),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1088] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3769),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6961),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5428),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9849),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1088),
    [sym_preproc_endregion] = STATE(1088),
    [sym_preproc_line] = STATE(1088),
    [sym_preproc_pragma] = STATE(1088),
    [sym_preproc_nullable] = STATE(1088),
    [sym_preproc_error] = STATE(1088),
    [sym_preproc_define] = STATE(1088),
    [sym_preproc_undef] = STATE(1088),
    [aux_sym_class_declaration_repeat1] = STATE(3841),
    [aux_sym_lambda_expression_repeat1] = STATE(4283),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1459),
    [anon_sym_ref] = ACTIONS(1461),
    [anon_sym_LBRACE] = ACTIONS(2765),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1465),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1467),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1469),
    [anon_sym_DOT_DOT] = ACTIONS(1471),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1089] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6030),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1089),
    [sym_preproc_endregion] = STATE(1089),
    [sym_preproc_line] = STATE(1089),
    [sym_preproc_pragma] = STATE(1089),
    [sym_preproc_nullable] = STATE(1089),
    [sym_preproc_error] = STATE(1089),
    [sym_preproc_define] = STATE(1089),
    [sym_preproc_undef] = STATE(1089),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_RBRACE] = ACTIONS(2893),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1090] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3726),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6961),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5442),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9849),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1090),
    [sym_preproc_endregion] = STATE(1090),
    [sym_preproc_line] = STATE(1090),
    [sym_preproc_pragma] = STATE(1090),
    [sym_preproc_nullable] = STATE(1090),
    [sym_preproc_error] = STATE(1090),
    [sym_preproc_define] = STATE(1090),
    [sym_preproc_undef] = STATE(1090),
    [aux_sym_class_declaration_repeat1] = STATE(3841),
    [aux_sym_lambda_expression_repeat1] = STATE(4283),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1459),
    [anon_sym_ref] = ACTIONS(1461),
    [anon_sym_LBRACE] = ACTIONS(2765),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1465),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1467),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1469),
    [anon_sym_DOT_DOT] = ACTIONS(1471),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1091] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6961),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6636),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9849),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1091),
    [sym_preproc_endregion] = STATE(1091),
    [sym_preproc_line] = STATE(1091),
    [sym_preproc_pragma] = STATE(1091),
    [sym_preproc_nullable] = STATE(1091),
    [sym_preproc_error] = STATE(1091),
    [sym_preproc_define] = STATE(1091),
    [sym_preproc_undef] = STATE(1091),
    [aux_sym_class_declaration_repeat1] = STATE(3841),
    [aux_sym_lambda_expression_repeat1] = STATE(4283),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(2001),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1459),
    [anon_sym_ref] = ACTIONS(1461),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1465),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1467),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1469),
    [anon_sym_DOT_DOT] = ACTIONS(1471),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1092] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3726),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6880),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7072),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5718),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4210),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9027),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1092),
    [sym_preproc_endregion] = STATE(1092),
    [sym_preproc_line] = STATE(1092),
    [sym_preproc_pragma] = STATE(1092),
    [sym_preproc_nullable] = STATE(1092),
    [sym_preproc_error] = STATE(1092),
    [sym_preproc_define] = STATE(1092),
    [sym_preproc_undef] = STATE(1092),
    [aux_sym_class_declaration_repeat1] = STATE(3852),
    [aux_sym_lambda_expression_repeat1] = STATE(4220),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1473),
    [anon_sym_ref] = ACTIONS(1475),
    [anon_sym_LBRACE] = ACTIONS(2765),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(1479),
    [anon_sym_PLUS_PLUS] = ACTIONS(1479),
    [anon_sym_DASH_DASH] = ACTIONS(1479),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1477),
    [anon_sym_DASH] = ACTIONS(1477),
    [anon_sym_STAR] = ACTIONS(1101),
    [anon_sym_CARET] = ACTIONS(1479),
    [anon_sym_AMP] = ACTIONS(1479),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1111),
    [anon_sym_DOT_DOT] = ACTIONS(1115),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1093] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3769),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6880),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7072),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5720),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4210),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9027),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1093),
    [sym_preproc_endregion] = STATE(1093),
    [sym_preproc_line] = STATE(1093),
    [sym_preproc_pragma] = STATE(1093),
    [sym_preproc_nullable] = STATE(1093),
    [sym_preproc_error] = STATE(1093),
    [sym_preproc_define] = STATE(1093),
    [sym_preproc_undef] = STATE(1093),
    [aux_sym_class_declaration_repeat1] = STATE(3852),
    [aux_sym_lambda_expression_repeat1] = STATE(4220),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1473),
    [anon_sym_ref] = ACTIONS(1475),
    [anon_sym_LBRACE] = ACTIONS(2765),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(1479),
    [anon_sym_PLUS_PLUS] = ACTIONS(1479),
    [anon_sym_DASH_DASH] = ACTIONS(1479),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1477),
    [anon_sym_DASH] = ACTIONS(1477),
    [anon_sym_STAR] = ACTIONS(1101),
    [anon_sym_CARET] = ACTIONS(1479),
    [anon_sym_AMP] = ACTIONS(1479),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1111),
    [anon_sym_DOT_DOT] = ACTIONS(1115),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1094] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6668),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5502),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1094),
    [sym_preproc_endregion] = STATE(1094),
    [sym_preproc_line] = STATE(1094),
    [sym_preproc_pragma] = STATE(1094),
    [sym_preproc_nullable] = STATE(1094),
    [sym_preproc_error] = STATE(1094),
    [sym_preproc_define] = STATE(1094),
    [sym_preproc_undef] = STATE(1094),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_readonly] = ACTIONS(2693),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1095] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(5649),
    [sym_bracketed_argument_list] = STATE(3921),
    [sym__name] = STATE(6919),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2868),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(7068),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6016),
    [sym_non_lvalue_expression] = STATE(5735),
    [sym_lvalue_expression] = STATE(4323),
    [sym__expression_statement_expression] = STATE(5733),
    [sym_assignment_expression] = STATE(5734),
    [sym_binary_expression] = STATE(5733),
    [sym_postfix_unary_expression] = STATE(5734),
    [sym_prefix_unary_expression] = STATE(5734),
    [sym__pointer_indirection_expression] = STATE(3911),
    [sym_query_expression] = STATE(5733),
    [sym_from_clause] = STATE(7393),
    [sym_conditional_expression] = STATE(5733),
    [sym_conditional_access_expression] = STATE(5733),
    [sym_as_expression] = STATE(5733),
    [sym_is_expression] = STATE(5733),
    [sym_is_pattern_expression] = STATE(5733),
    [sym_cast_expression] = STATE(5733),
    [sym_checked_expression] = STATE(5733),
    [sym_invocation_expression] = STATE(5734),
    [sym_switch_expression] = STATE(5733),
    [sym_await_expression] = STATE(5734),
    [sym_throw_expression] = STATE(5733),
    [sym_element_access_expression] = STATE(3911),
    [sym_interpolated_string_expression] = STATE(5733),
    [sym_member_access_expression] = STATE(3911),
    [sym_object_creation_expression] = STATE(5734),
    [sym_parenthesized_expression] = STATE(5734),
    [sym__parenthesized_lvalue_expression] = STATE(3911),
    [sym_lambda_expression] = STATE(5733),
    [sym__lambda_parameters] = STATE(9932),
    [sym_array_creation_expression] = STATE(5733),
    [sym_anonymous_method_expression] = STATE(5733),
    [sym_anonymous_object_creation_expression] = STATE(5733),
    [sym_implicit_array_creation_expression] = STATE(5733),
    [sym_implicit_object_creation_expression] = STATE(5733),
    [sym_implicit_stackalloc_expression] = STATE(5733),
    [sym_initializer_expression] = STATE(5733),
    [sym_default_expression] = STATE(5733),
    [sym_with_expression] = STATE(5733),
    [sym_sizeof_expression] = STATE(5733),
    [sym_typeof_expression] = STATE(5733),
    [sym_makeref_expression] = STATE(5733),
    [sym_ref_expression] = STATE(5733),
    [sym_reftype_expression] = STATE(5733),
    [sym_refvalue_expression] = STATE(5733),
    [sym_stackalloc_expression] = STATE(5733),
    [sym_range_expression] = STATE(5733),
    [sym_tuple_expression] = STATE(3911),
    [sym_literal] = STATE(5733),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2798),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(5733),
    [sym_preproc_region] = STATE(1095),
    [sym_preproc_endregion] = STATE(1095),
    [sym_preproc_line] = STATE(1095),
    [sym_preproc_pragma] = STATE(1095),
    [sym_preproc_nullable] = STATE(1095),
    [sym_preproc_error] = STATE(1095),
    [sym_preproc_define] = STATE(1095),
    [sym_preproc_undef] = STATE(1095),
    [aux_sym_class_declaration_repeat1] = STATE(3831),
    [aux_sym_lambda_expression_repeat1] = STATE(4227),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_LPAREN] = ACTIONS(1577),
    [anon_sym_ref] = ACTIONS(1579),
    [anon_sym_LBRACE] = ACTIONS(2773),
    [anon_sym_delegate] = ACTIONS(1379),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1381),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1583),
    [anon_sym_TILDE] = ACTIONS(1583),
    [anon_sym_PLUS_PLUS] = ACTIONS(1583),
    [anon_sym_DASH_DASH] = ACTIONS(1583),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1581),
    [anon_sym_DASH] = ACTIONS(1581),
    [anon_sym_STAR] = ACTIONS(1391),
    [anon_sym_CARET] = ACTIONS(1583),
    [anon_sym_AMP] = ACTIONS(1583),
    [anon_sym_this] = ACTIONS(1393),
    [anon_sym_scoped] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1397),
    [sym_predefined_type] = ACTIONS(1399),
    [anon_sym_unchecked] = ACTIONS(1383),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1585),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1587),
    [anon_sym_DOT_DOT] = ACTIONS(1589),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_stackalloc] = ACTIONS(1413),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(1419),
    [anon_sym___reftype] = ACTIONS(1421),
    [anon_sym___refvalue] = ACTIONS(1423),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
  },
  [1096] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3717),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6880),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7072),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5722),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4210),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9027),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1096),
    [sym_preproc_endregion] = STATE(1096),
    [sym_preproc_line] = STATE(1096),
    [sym_preproc_pragma] = STATE(1096),
    [sym_preproc_nullable] = STATE(1096),
    [sym_preproc_error] = STATE(1096),
    [sym_preproc_define] = STATE(1096),
    [sym_preproc_undef] = STATE(1096),
    [aux_sym_class_declaration_repeat1] = STATE(3852),
    [aux_sym_lambda_expression_repeat1] = STATE(4220),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1473),
    [anon_sym_ref] = ACTIONS(1475),
    [anon_sym_LBRACE] = ACTIONS(2765),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(1479),
    [anon_sym_PLUS_PLUS] = ACTIONS(1479),
    [anon_sym_DASH_DASH] = ACTIONS(1479),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1477),
    [anon_sym_DASH] = ACTIONS(1477),
    [anon_sym_STAR] = ACTIONS(1101),
    [anon_sym_CARET] = ACTIONS(1479),
    [anon_sym_AMP] = ACTIONS(1479),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1111),
    [anon_sym_DOT_DOT] = ACTIONS(1115),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1097] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4641),
    [sym_bracketed_argument_list] = STATE(3559),
    [sym__name] = STATE(6878),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2911),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6960),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4432),
    [sym_non_lvalue_expression] = STATE(4553),
    [sym_lvalue_expression] = STATE(3607),
    [sym__expression_statement_expression] = STATE(4559),
    [sym_assignment_expression] = STATE(4558),
    [sym_binary_expression] = STATE(4559),
    [sym_postfix_unary_expression] = STATE(4558),
    [sym_prefix_unary_expression] = STATE(4558),
    [sym__pointer_indirection_expression] = STATE(3560),
    [sym_query_expression] = STATE(4559),
    [sym_from_clause] = STATE(7385),
    [sym_conditional_expression] = STATE(4559),
    [sym_conditional_access_expression] = STATE(4559),
    [sym_as_expression] = STATE(4559),
    [sym_is_expression] = STATE(4559),
    [sym_is_pattern_expression] = STATE(4559),
    [sym_cast_expression] = STATE(4559),
    [sym_checked_expression] = STATE(4559),
    [sym_invocation_expression] = STATE(4558),
    [sym_switch_expression] = STATE(4559),
    [sym_await_expression] = STATE(4558),
    [sym_throw_expression] = STATE(4559),
    [sym_element_access_expression] = STATE(3560),
    [sym_interpolated_string_expression] = STATE(4559),
    [sym_member_access_expression] = STATE(3560),
    [sym_object_creation_expression] = STATE(4558),
    [sym_parenthesized_expression] = STATE(4558),
    [sym__parenthesized_lvalue_expression] = STATE(3560),
    [sym_lambda_expression] = STATE(4559),
    [sym__lambda_parameters] = STATE(9554),
    [sym_array_creation_expression] = STATE(4559),
    [sym_anonymous_method_expression] = STATE(4559),
    [sym_anonymous_object_creation_expression] = STATE(4559),
    [sym_implicit_array_creation_expression] = STATE(4559),
    [sym_implicit_object_creation_expression] = STATE(4559),
    [sym_implicit_stackalloc_expression] = STATE(4559),
    [sym_initializer_expression] = STATE(4559),
    [sym_default_expression] = STATE(4559),
    [sym_with_expression] = STATE(4559),
    [sym_sizeof_expression] = STATE(4559),
    [sym_typeof_expression] = STATE(4559),
    [sym_makeref_expression] = STATE(4559),
    [sym_ref_expression] = STATE(4559),
    [sym_reftype_expression] = STATE(4559),
    [sym_refvalue_expression] = STATE(4559),
    [sym_stackalloc_expression] = STATE(4559),
    [sym_range_expression] = STATE(4559),
    [sym_tuple_expression] = STATE(3560),
    [sym_literal] = STATE(4559),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4559),
    [sym_preproc_region] = STATE(1097),
    [sym_preproc_endregion] = STATE(1097),
    [sym_preproc_line] = STATE(1097),
    [sym_preproc_pragma] = STATE(1097),
    [sym_preproc_nullable] = STATE(1097),
    [sym_preproc_error] = STATE(1097),
    [sym_preproc_define] = STATE(1097),
    [sym_preproc_undef] = STATE(1097),
    [aux_sym_class_declaration_repeat1] = STATE(3792),
    [aux_sym_lambda_expression_repeat1] = STATE(4202),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(1607),
    [anon_sym_ref] = ACTIONS(1609),
    [anon_sym_LBRACE] = ACTIONS(2759),
    [anon_sym_delegate] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1615),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(1621),
    [anon_sym_TILDE] = ACTIONS(1621),
    [anon_sym_PLUS_PLUS] = ACTIONS(1621),
    [anon_sym_DASH_DASH] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(1619),
    [anon_sym_DASH] = ACTIONS(1619),
    [anon_sym_STAR] = ACTIONS(1625),
    [anon_sym_CARET] = ACTIONS(1621),
    [anon_sym_AMP] = ACTIONS(1621),
    [anon_sym_this] = ACTIONS(1627),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1629),
    [anon_sym_unchecked] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [anon_sym_DOT_DOT] = ACTIONS(1637),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_stackalloc] = ACTIONS(1641),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(1647),
    [anon_sym___reftype] = ACTIONS(1649),
    [anon_sym___refvalue] = ACTIONS(1651),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1659),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [1098] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4132),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6898),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2940),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6936),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5775),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4318),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7401),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9262),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1098),
    [sym_preproc_endregion] = STATE(1098),
    [sym_preproc_line] = STATE(1098),
    [sym_preproc_pragma] = STATE(1098),
    [sym_preproc_nullable] = STATE(1098),
    [sym_preproc_error] = STATE(1098),
    [sym_preproc_define] = STATE(1098),
    [sym_preproc_undef] = STATE(1098),
    [aux_sym_class_declaration_repeat1] = STATE(3815),
    [aux_sym_lambda_expression_repeat1] = STATE(4072),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1885),
    [anon_sym_ref] = ACTIONS(1887),
    [anon_sym_LBRACE] = ACTIONS(2761),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1889),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1893),
    [anon_sym_TILDE] = ACTIONS(1893),
    [anon_sym_PLUS_PLUS] = ACTIONS(1893),
    [anon_sym_DASH_DASH] = ACTIONS(1893),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1891),
    [anon_sym_DASH] = ACTIONS(1891),
    [anon_sym_STAR] = ACTIONS(1895),
    [anon_sym_CARET] = ACTIONS(1893),
    [anon_sym_AMP] = ACTIONS(1893),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1897),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1899),
    [anon_sym_DOT_DOT] = ACTIONS(1901),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1099] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4085),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6898),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2940),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6936),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5776),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4318),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7401),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9262),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1099),
    [sym_preproc_endregion] = STATE(1099),
    [sym_preproc_line] = STATE(1099),
    [sym_preproc_pragma] = STATE(1099),
    [sym_preproc_nullable] = STATE(1099),
    [sym_preproc_error] = STATE(1099),
    [sym_preproc_define] = STATE(1099),
    [sym_preproc_undef] = STATE(1099),
    [aux_sym_class_declaration_repeat1] = STATE(3815),
    [aux_sym_lambda_expression_repeat1] = STATE(4072),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1885),
    [anon_sym_ref] = ACTIONS(1887),
    [anon_sym_LBRACE] = ACTIONS(2761),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1889),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1893),
    [anon_sym_TILDE] = ACTIONS(1893),
    [anon_sym_PLUS_PLUS] = ACTIONS(1893),
    [anon_sym_DASH_DASH] = ACTIONS(1893),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1891),
    [anon_sym_DASH] = ACTIONS(1891),
    [anon_sym_STAR] = ACTIONS(1895),
    [anon_sym_CARET] = ACTIONS(1893),
    [anon_sym_AMP] = ACTIONS(1893),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1897),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1899),
    [anon_sym_DOT_DOT] = ACTIONS(1901),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1100] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4066),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6898),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2940),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6936),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5777),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4318),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7401),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9262),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1100),
    [sym_preproc_endregion] = STATE(1100),
    [sym_preproc_line] = STATE(1100),
    [sym_preproc_pragma] = STATE(1100),
    [sym_preproc_nullable] = STATE(1100),
    [sym_preproc_error] = STATE(1100),
    [sym_preproc_define] = STATE(1100),
    [sym_preproc_undef] = STATE(1100),
    [aux_sym_class_declaration_repeat1] = STATE(3815),
    [aux_sym_lambda_expression_repeat1] = STATE(4072),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1885),
    [anon_sym_ref] = ACTIONS(1887),
    [anon_sym_LBRACE] = ACTIONS(2761),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1889),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1893),
    [anon_sym_TILDE] = ACTIONS(1893),
    [anon_sym_PLUS_PLUS] = ACTIONS(1893),
    [anon_sym_DASH_DASH] = ACTIONS(1893),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1891),
    [anon_sym_DASH] = ACTIONS(1891),
    [anon_sym_STAR] = ACTIONS(1895),
    [anon_sym_CARET] = ACTIONS(1893),
    [anon_sym_AMP] = ACTIONS(1893),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1897),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1899),
    [anon_sym_DOT_DOT] = ACTIONS(1901),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1101] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4685),
    [sym_bracketed_argument_list] = STATE(3559),
    [sym__name] = STATE(6878),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2911),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6960),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4436),
    [sym_non_lvalue_expression] = STATE(4553),
    [sym_lvalue_expression] = STATE(3607),
    [sym__expression_statement_expression] = STATE(4559),
    [sym_assignment_expression] = STATE(4558),
    [sym_binary_expression] = STATE(4559),
    [sym_postfix_unary_expression] = STATE(4558),
    [sym_prefix_unary_expression] = STATE(4558),
    [sym__pointer_indirection_expression] = STATE(3560),
    [sym_query_expression] = STATE(4559),
    [sym_from_clause] = STATE(7385),
    [sym_conditional_expression] = STATE(4559),
    [sym_conditional_access_expression] = STATE(4559),
    [sym_as_expression] = STATE(4559),
    [sym_is_expression] = STATE(4559),
    [sym_is_pattern_expression] = STATE(4559),
    [sym_cast_expression] = STATE(4559),
    [sym_checked_expression] = STATE(4559),
    [sym_invocation_expression] = STATE(4558),
    [sym_switch_expression] = STATE(4559),
    [sym_await_expression] = STATE(4558),
    [sym_throw_expression] = STATE(4559),
    [sym_element_access_expression] = STATE(3560),
    [sym_interpolated_string_expression] = STATE(4559),
    [sym_member_access_expression] = STATE(3560),
    [sym_object_creation_expression] = STATE(4558),
    [sym_parenthesized_expression] = STATE(4558),
    [sym__parenthesized_lvalue_expression] = STATE(3560),
    [sym_lambda_expression] = STATE(4559),
    [sym__lambda_parameters] = STATE(9554),
    [sym_array_creation_expression] = STATE(4559),
    [sym_anonymous_method_expression] = STATE(4559),
    [sym_anonymous_object_creation_expression] = STATE(4559),
    [sym_implicit_array_creation_expression] = STATE(4559),
    [sym_implicit_object_creation_expression] = STATE(4559),
    [sym_implicit_stackalloc_expression] = STATE(4559),
    [sym_initializer_expression] = STATE(4559),
    [sym_default_expression] = STATE(4559),
    [sym_with_expression] = STATE(4559),
    [sym_sizeof_expression] = STATE(4559),
    [sym_typeof_expression] = STATE(4559),
    [sym_makeref_expression] = STATE(4559),
    [sym_ref_expression] = STATE(4559),
    [sym_reftype_expression] = STATE(4559),
    [sym_refvalue_expression] = STATE(4559),
    [sym_stackalloc_expression] = STATE(4559),
    [sym_range_expression] = STATE(4559),
    [sym_tuple_expression] = STATE(3560),
    [sym_literal] = STATE(4559),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4559),
    [sym_preproc_region] = STATE(1101),
    [sym_preproc_endregion] = STATE(1101),
    [sym_preproc_line] = STATE(1101),
    [sym_preproc_pragma] = STATE(1101),
    [sym_preproc_nullable] = STATE(1101),
    [sym_preproc_error] = STATE(1101),
    [sym_preproc_define] = STATE(1101),
    [sym_preproc_undef] = STATE(1101),
    [aux_sym_class_declaration_repeat1] = STATE(3792),
    [aux_sym_lambda_expression_repeat1] = STATE(4202),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(1607),
    [anon_sym_ref] = ACTIONS(1609),
    [anon_sym_LBRACE] = ACTIONS(2759),
    [anon_sym_delegate] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1615),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(1621),
    [anon_sym_TILDE] = ACTIONS(1621),
    [anon_sym_PLUS_PLUS] = ACTIONS(1621),
    [anon_sym_DASH_DASH] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(1619),
    [anon_sym_DASH] = ACTIONS(1619),
    [anon_sym_STAR] = ACTIONS(1625),
    [anon_sym_CARET] = ACTIONS(1621),
    [anon_sym_AMP] = ACTIONS(1621),
    [anon_sym_this] = ACTIONS(1627),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1629),
    [anon_sym_unchecked] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [anon_sym_DOT_DOT] = ACTIONS(1637),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_stackalloc] = ACTIONS(1641),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(1647),
    [anon_sym___reftype] = ACTIONS(1649),
    [anon_sym___refvalue] = ACTIONS(1651),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1659),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [1102] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4617),
    [sym_bracketed_argument_list] = STATE(3559),
    [sym__name] = STATE(6878),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2911),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6960),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4440),
    [sym_non_lvalue_expression] = STATE(4553),
    [sym_lvalue_expression] = STATE(3607),
    [sym__expression_statement_expression] = STATE(4559),
    [sym_assignment_expression] = STATE(4558),
    [sym_binary_expression] = STATE(4559),
    [sym_postfix_unary_expression] = STATE(4558),
    [sym_prefix_unary_expression] = STATE(4558),
    [sym__pointer_indirection_expression] = STATE(3560),
    [sym_query_expression] = STATE(4559),
    [sym_from_clause] = STATE(7385),
    [sym_conditional_expression] = STATE(4559),
    [sym_conditional_access_expression] = STATE(4559),
    [sym_as_expression] = STATE(4559),
    [sym_is_expression] = STATE(4559),
    [sym_is_pattern_expression] = STATE(4559),
    [sym_cast_expression] = STATE(4559),
    [sym_checked_expression] = STATE(4559),
    [sym_invocation_expression] = STATE(4558),
    [sym_switch_expression] = STATE(4559),
    [sym_await_expression] = STATE(4558),
    [sym_throw_expression] = STATE(4559),
    [sym_element_access_expression] = STATE(3560),
    [sym_interpolated_string_expression] = STATE(4559),
    [sym_member_access_expression] = STATE(3560),
    [sym_object_creation_expression] = STATE(4558),
    [sym_parenthesized_expression] = STATE(4558),
    [sym__parenthesized_lvalue_expression] = STATE(3560),
    [sym_lambda_expression] = STATE(4559),
    [sym__lambda_parameters] = STATE(9554),
    [sym_array_creation_expression] = STATE(4559),
    [sym_anonymous_method_expression] = STATE(4559),
    [sym_anonymous_object_creation_expression] = STATE(4559),
    [sym_implicit_array_creation_expression] = STATE(4559),
    [sym_implicit_object_creation_expression] = STATE(4559),
    [sym_implicit_stackalloc_expression] = STATE(4559),
    [sym_initializer_expression] = STATE(4559),
    [sym_default_expression] = STATE(4559),
    [sym_with_expression] = STATE(4559),
    [sym_sizeof_expression] = STATE(4559),
    [sym_typeof_expression] = STATE(4559),
    [sym_makeref_expression] = STATE(4559),
    [sym_ref_expression] = STATE(4559),
    [sym_reftype_expression] = STATE(4559),
    [sym_refvalue_expression] = STATE(4559),
    [sym_stackalloc_expression] = STATE(4559),
    [sym_range_expression] = STATE(4559),
    [sym_tuple_expression] = STATE(3560),
    [sym_literal] = STATE(4559),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4559),
    [sym_preproc_region] = STATE(1102),
    [sym_preproc_endregion] = STATE(1102),
    [sym_preproc_line] = STATE(1102),
    [sym_preproc_pragma] = STATE(1102),
    [sym_preproc_nullable] = STATE(1102),
    [sym_preproc_error] = STATE(1102),
    [sym_preproc_define] = STATE(1102),
    [sym_preproc_undef] = STATE(1102),
    [aux_sym_class_declaration_repeat1] = STATE(3792),
    [aux_sym_lambda_expression_repeat1] = STATE(4202),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(1607),
    [anon_sym_ref] = ACTIONS(1609),
    [anon_sym_LBRACE] = ACTIONS(2759),
    [anon_sym_delegate] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1615),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(1621),
    [anon_sym_TILDE] = ACTIONS(1621),
    [anon_sym_PLUS_PLUS] = ACTIONS(1621),
    [anon_sym_DASH_DASH] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(1619),
    [anon_sym_DASH] = ACTIONS(1619),
    [anon_sym_STAR] = ACTIONS(1625),
    [anon_sym_CARET] = ACTIONS(1621),
    [anon_sym_AMP] = ACTIONS(1621),
    [anon_sym_this] = ACTIONS(1627),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1629),
    [anon_sym_unchecked] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [anon_sym_DOT_DOT] = ACTIONS(1637),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_stackalloc] = ACTIONS(1641),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(1647),
    [anon_sym___reftype] = ACTIONS(1649),
    [anon_sym___refvalue] = ACTIONS(1651),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1659),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [1103] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4688),
    [sym_bracketed_argument_list] = STATE(3559),
    [sym__name] = STATE(6878),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2911),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6960),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4442),
    [sym_non_lvalue_expression] = STATE(4553),
    [sym_lvalue_expression] = STATE(3607),
    [sym__expression_statement_expression] = STATE(4559),
    [sym_assignment_expression] = STATE(4558),
    [sym_binary_expression] = STATE(4559),
    [sym_postfix_unary_expression] = STATE(4558),
    [sym_prefix_unary_expression] = STATE(4558),
    [sym__pointer_indirection_expression] = STATE(3560),
    [sym_query_expression] = STATE(4559),
    [sym_from_clause] = STATE(7385),
    [sym_conditional_expression] = STATE(4559),
    [sym_conditional_access_expression] = STATE(4559),
    [sym_as_expression] = STATE(4559),
    [sym_is_expression] = STATE(4559),
    [sym_is_pattern_expression] = STATE(4559),
    [sym_cast_expression] = STATE(4559),
    [sym_checked_expression] = STATE(4559),
    [sym_invocation_expression] = STATE(4558),
    [sym_switch_expression] = STATE(4559),
    [sym_await_expression] = STATE(4558),
    [sym_throw_expression] = STATE(4559),
    [sym_element_access_expression] = STATE(3560),
    [sym_interpolated_string_expression] = STATE(4559),
    [sym_member_access_expression] = STATE(3560),
    [sym_object_creation_expression] = STATE(4558),
    [sym_parenthesized_expression] = STATE(4558),
    [sym__parenthesized_lvalue_expression] = STATE(3560),
    [sym_lambda_expression] = STATE(4559),
    [sym__lambda_parameters] = STATE(9554),
    [sym_array_creation_expression] = STATE(4559),
    [sym_anonymous_method_expression] = STATE(4559),
    [sym_anonymous_object_creation_expression] = STATE(4559),
    [sym_implicit_array_creation_expression] = STATE(4559),
    [sym_implicit_object_creation_expression] = STATE(4559),
    [sym_implicit_stackalloc_expression] = STATE(4559),
    [sym_initializer_expression] = STATE(4559),
    [sym_default_expression] = STATE(4559),
    [sym_with_expression] = STATE(4559),
    [sym_sizeof_expression] = STATE(4559),
    [sym_typeof_expression] = STATE(4559),
    [sym_makeref_expression] = STATE(4559),
    [sym_ref_expression] = STATE(4559),
    [sym_reftype_expression] = STATE(4559),
    [sym_refvalue_expression] = STATE(4559),
    [sym_stackalloc_expression] = STATE(4559),
    [sym_range_expression] = STATE(4559),
    [sym_tuple_expression] = STATE(3560),
    [sym_literal] = STATE(4559),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4559),
    [sym_preproc_region] = STATE(1103),
    [sym_preproc_endregion] = STATE(1103),
    [sym_preproc_line] = STATE(1103),
    [sym_preproc_pragma] = STATE(1103),
    [sym_preproc_nullable] = STATE(1103),
    [sym_preproc_error] = STATE(1103),
    [sym_preproc_define] = STATE(1103),
    [sym_preproc_undef] = STATE(1103),
    [aux_sym_class_declaration_repeat1] = STATE(3792),
    [aux_sym_lambda_expression_repeat1] = STATE(4202),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(1607),
    [anon_sym_ref] = ACTIONS(1609),
    [anon_sym_LBRACE] = ACTIONS(2759),
    [anon_sym_delegate] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1615),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(1621),
    [anon_sym_TILDE] = ACTIONS(1621),
    [anon_sym_PLUS_PLUS] = ACTIONS(1621),
    [anon_sym_DASH_DASH] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(1619),
    [anon_sym_DASH] = ACTIONS(1619),
    [anon_sym_STAR] = ACTIONS(1625),
    [anon_sym_CARET] = ACTIONS(1621),
    [anon_sym_AMP] = ACTIONS(1621),
    [anon_sym_this] = ACTIONS(1627),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1629),
    [anon_sym_unchecked] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [anon_sym_DOT_DOT] = ACTIONS(1637),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_stackalloc] = ACTIONS(1641),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(1647),
    [anon_sym___reftype] = ACTIONS(1649),
    [anon_sym___refvalue] = ACTIONS(1651),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1659),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [1104] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4116),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6898),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2940),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6936),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5779),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4318),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7401),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9262),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1104),
    [sym_preproc_endregion] = STATE(1104),
    [sym_preproc_line] = STATE(1104),
    [sym_preproc_pragma] = STATE(1104),
    [sym_preproc_nullable] = STATE(1104),
    [sym_preproc_error] = STATE(1104),
    [sym_preproc_define] = STATE(1104),
    [sym_preproc_undef] = STATE(1104),
    [aux_sym_class_declaration_repeat1] = STATE(3815),
    [aux_sym_lambda_expression_repeat1] = STATE(4072),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1885),
    [anon_sym_ref] = ACTIONS(1887),
    [anon_sym_LBRACE] = ACTIONS(2761),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1889),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1893),
    [anon_sym_TILDE] = ACTIONS(1893),
    [anon_sym_PLUS_PLUS] = ACTIONS(1893),
    [anon_sym_DASH_DASH] = ACTIONS(1893),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1891),
    [anon_sym_DASH] = ACTIONS(1891),
    [anon_sym_STAR] = ACTIONS(1895),
    [anon_sym_CARET] = ACTIONS(1893),
    [anon_sym_AMP] = ACTIONS(1893),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1897),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1899),
    [anon_sym_DOT_DOT] = ACTIONS(1901),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1105] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4151),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6898),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2940),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6936),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5780),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4318),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7401),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9262),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1105),
    [sym_preproc_endregion] = STATE(1105),
    [sym_preproc_line] = STATE(1105),
    [sym_preproc_pragma] = STATE(1105),
    [sym_preproc_nullable] = STATE(1105),
    [sym_preproc_error] = STATE(1105),
    [sym_preproc_define] = STATE(1105),
    [sym_preproc_undef] = STATE(1105),
    [aux_sym_class_declaration_repeat1] = STATE(3815),
    [aux_sym_lambda_expression_repeat1] = STATE(4072),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1885),
    [anon_sym_ref] = ACTIONS(1887),
    [anon_sym_LBRACE] = ACTIONS(2761),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1889),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1893),
    [anon_sym_TILDE] = ACTIONS(1893),
    [anon_sym_PLUS_PLUS] = ACTIONS(1893),
    [anon_sym_DASH_DASH] = ACTIONS(1893),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1891),
    [anon_sym_DASH] = ACTIONS(1891),
    [anon_sym_STAR] = ACTIONS(1895),
    [anon_sym_CARET] = ACTIONS(1893),
    [anon_sym_AMP] = ACTIONS(1893),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1897),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1899),
    [anon_sym_DOT_DOT] = ACTIONS(1901),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1106] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4188),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6898),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2940),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6936),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5783),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4318),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7401),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9262),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1106),
    [sym_preproc_endregion] = STATE(1106),
    [sym_preproc_line] = STATE(1106),
    [sym_preproc_pragma] = STATE(1106),
    [sym_preproc_nullable] = STATE(1106),
    [sym_preproc_error] = STATE(1106),
    [sym_preproc_define] = STATE(1106),
    [sym_preproc_undef] = STATE(1106),
    [aux_sym_class_declaration_repeat1] = STATE(3815),
    [aux_sym_lambda_expression_repeat1] = STATE(4072),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1885),
    [anon_sym_ref] = ACTIONS(1887),
    [anon_sym_LBRACE] = ACTIONS(2761),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1889),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1893),
    [anon_sym_TILDE] = ACTIONS(1893),
    [anon_sym_PLUS_PLUS] = ACTIONS(1893),
    [anon_sym_DASH_DASH] = ACTIONS(1893),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1891),
    [anon_sym_DASH] = ACTIONS(1891),
    [anon_sym_STAR] = ACTIONS(1895),
    [anon_sym_CARET] = ACTIONS(1893),
    [anon_sym_AMP] = ACTIONS(1893),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1897),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1899),
    [anon_sym_DOT_DOT] = ACTIONS(1901),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1107] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4695),
    [sym_bracketed_argument_list] = STATE(3559),
    [sym__name] = STATE(6878),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2911),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6960),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4444),
    [sym_non_lvalue_expression] = STATE(4553),
    [sym_lvalue_expression] = STATE(3607),
    [sym__expression_statement_expression] = STATE(4559),
    [sym_assignment_expression] = STATE(4558),
    [sym_binary_expression] = STATE(4559),
    [sym_postfix_unary_expression] = STATE(4558),
    [sym_prefix_unary_expression] = STATE(4558),
    [sym__pointer_indirection_expression] = STATE(3560),
    [sym_query_expression] = STATE(4559),
    [sym_from_clause] = STATE(7385),
    [sym_conditional_expression] = STATE(4559),
    [sym_conditional_access_expression] = STATE(4559),
    [sym_as_expression] = STATE(4559),
    [sym_is_expression] = STATE(4559),
    [sym_is_pattern_expression] = STATE(4559),
    [sym_cast_expression] = STATE(4559),
    [sym_checked_expression] = STATE(4559),
    [sym_invocation_expression] = STATE(4558),
    [sym_switch_expression] = STATE(4559),
    [sym_await_expression] = STATE(4558),
    [sym_throw_expression] = STATE(4559),
    [sym_element_access_expression] = STATE(3560),
    [sym_interpolated_string_expression] = STATE(4559),
    [sym_member_access_expression] = STATE(3560),
    [sym_object_creation_expression] = STATE(4558),
    [sym_parenthesized_expression] = STATE(4558),
    [sym__parenthesized_lvalue_expression] = STATE(3560),
    [sym_lambda_expression] = STATE(4559),
    [sym__lambda_parameters] = STATE(9554),
    [sym_array_creation_expression] = STATE(4559),
    [sym_anonymous_method_expression] = STATE(4559),
    [sym_anonymous_object_creation_expression] = STATE(4559),
    [sym_implicit_array_creation_expression] = STATE(4559),
    [sym_implicit_object_creation_expression] = STATE(4559),
    [sym_implicit_stackalloc_expression] = STATE(4559),
    [sym_initializer_expression] = STATE(4559),
    [sym_default_expression] = STATE(4559),
    [sym_with_expression] = STATE(4559),
    [sym_sizeof_expression] = STATE(4559),
    [sym_typeof_expression] = STATE(4559),
    [sym_makeref_expression] = STATE(4559),
    [sym_ref_expression] = STATE(4559),
    [sym_reftype_expression] = STATE(4559),
    [sym_refvalue_expression] = STATE(4559),
    [sym_stackalloc_expression] = STATE(4559),
    [sym_range_expression] = STATE(4559),
    [sym_tuple_expression] = STATE(3560),
    [sym_literal] = STATE(4559),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4559),
    [sym_preproc_region] = STATE(1107),
    [sym_preproc_endregion] = STATE(1107),
    [sym_preproc_line] = STATE(1107),
    [sym_preproc_pragma] = STATE(1107),
    [sym_preproc_nullable] = STATE(1107),
    [sym_preproc_error] = STATE(1107),
    [sym_preproc_define] = STATE(1107),
    [sym_preproc_undef] = STATE(1107),
    [aux_sym_class_declaration_repeat1] = STATE(3792),
    [aux_sym_lambda_expression_repeat1] = STATE(4202),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(1607),
    [anon_sym_ref] = ACTIONS(1609),
    [anon_sym_LBRACE] = ACTIONS(2759),
    [anon_sym_delegate] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1615),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(1621),
    [anon_sym_TILDE] = ACTIONS(1621),
    [anon_sym_PLUS_PLUS] = ACTIONS(1621),
    [anon_sym_DASH_DASH] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(1619),
    [anon_sym_DASH] = ACTIONS(1619),
    [anon_sym_STAR] = ACTIONS(1625),
    [anon_sym_CARET] = ACTIONS(1621),
    [anon_sym_AMP] = ACTIONS(1621),
    [anon_sym_this] = ACTIONS(1627),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1629),
    [anon_sym_unchecked] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [anon_sym_DOT_DOT] = ACTIONS(1637),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_stackalloc] = ACTIONS(1641),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(1647),
    [anon_sym___reftype] = ACTIONS(1649),
    [anon_sym___refvalue] = ACTIONS(1651),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1659),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [1108] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3738),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6880),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7072),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5726),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4210),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9027),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1108),
    [sym_preproc_endregion] = STATE(1108),
    [sym_preproc_line] = STATE(1108),
    [sym_preproc_pragma] = STATE(1108),
    [sym_preproc_nullable] = STATE(1108),
    [sym_preproc_error] = STATE(1108),
    [sym_preproc_define] = STATE(1108),
    [sym_preproc_undef] = STATE(1108),
    [aux_sym_class_declaration_repeat1] = STATE(3852),
    [aux_sym_lambda_expression_repeat1] = STATE(4220),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1473),
    [anon_sym_ref] = ACTIONS(1475),
    [anon_sym_LBRACE] = ACTIONS(2765),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(1479),
    [anon_sym_PLUS_PLUS] = ACTIONS(1479),
    [anon_sym_DASH_DASH] = ACTIONS(1479),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1477),
    [anon_sym_DASH] = ACTIONS(1477),
    [anon_sym_STAR] = ACTIONS(1101),
    [anon_sym_CARET] = ACTIONS(1479),
    [anon_sym_AMP] = ACTIONS(1479),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1111),
    [anon_sym_DOT_DOT] = ACTIONS(1115),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1109] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3559),
    [sym__name] = STATE(6878),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2911),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6926),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4793),
    [sym_non_lvalue_expression] = STATE(4553),
    [sym_lvalue_expression] = STATE(3750),
    [sym__expression_statement_expression] = STATE(4559),
    [sym_assignment_expression] = STATE(4558),
    [sym_binary_expression] = STATE(4559),
    [sym_postfix_unary_expression] = STATE(4558),
    [sym_prefix_unary_expression] = STATE(4558),
    [sym__pointer_indirection_expression] = STATE(3560),
    [sym_query_expression] = STATE(4559),
    [sym_from_clause] = STATE(7406),
    [sym_conditional_expression] = STATE(4559),
    [sym_conditional_access_expression] = STATE(4559),
    [sym_as_expression] = STATE(4559),
    [sym_is_expression] = STATE(4559),
    [sym_is_pattern_expression] = STATE(4559),
    [sym_cast_expression] = STATE(4559),
    [sym_checked_expression] = STATE(4559),
    [sym_invocation_expression] = STATE(4558),
    [sym_switch_expression] = STATE(4559),
    [sym_await_expression] = STATE(4558),
    [sym_throw_expression] = STATE(4559),
    [sym_element_access_expression] = STATE(3560),
    [sym_interpolated_string_expression] = STATE(4559),
    [sym_member_access_expression] = STATE(3560),
    [sym_object_creation_expression] = STATE(4558),
    [sym_parenthesized_expression] = STATE(4558),
    [sym__parenthesized_lvalue_expression] = STATE(3560),
    [sym_lambda_expression] = STATE(4559),
    [sym__lambda_parameters] = STATE(9691),
    [sym_array_creation_expression] = STATE(4559),
    [sym_anonymous_method_expression] = STATE(4559),
    [sym_anonymous_object_creation_expression] = STATE(4559),
    [sym_implicit_array_creation_expression] = STATE(4559),
    [sym_implicit_object_creation_expression] = STATE(4559),
    [sym_implicit_stackalloc_expression] = STATE(4559),
    [sym_initializer_expression] = STATE(4559),
    [sym_default_expression] = STATE(4559),
    [sym_with_expression] = STATE(4559),
    [sym_sizeof_expression] = STATE(4559),
    [sym_typeof_expression] = STATE(4559),
    [sym_makeref_expression] = STATE(4559),
    [sym_ref_expression] = STATE(4559),
    [sym_reftype_expression] = STATE(4559),
    [sym_refvalue_expression] = STATE(4559),
    [sym_stackalloc_expression] = STATE(4559),
    [sym_range_expression] = STATE(4559),
    [sym_tuple_expression] = STATE(3560),
    [sym_literal] = STATE(4559),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4559),
    [sym_preproc_region] = STATE(1109),
    [sym_preproc_endregion] = STATE(1109),
    [sym_preproc_line] = STATE(1109),
    [sym_preproc_pragma] = STATE(1109),
    [sym_preproc_nullable] = STATE(1109),
    [sym_preproc_error] = STATE(1109),
    [sym_preproc_define] = STATE(1109),
    [sym_preproc_undef] = STATE(1109),
    [aux_sym_class_declaration_repeat1] = STATE(3836),
    [aux_sym_lambda_expression_repeat1] = STATE(4216),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(2003),
    [anon_sym_ref] = ACTIONS(2005),
    [anon_sym_LBRACE] = ACTIONS(1611),
    [anon_sym_delegate] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1615),
    [anon_sym_readonly] = ACTIONS(2693),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(2009),
    [anon_sym_TILDE] = ACTIONS(2009),
    [anon_sym_PLUS_PLUS] = ACTIONS(2009),
    [anon_sym_DASH_DASH] = ACTIONS(2009),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(2007),
    [anon_sym_DASH] = ACTIONS(2007),
    [anon_sym_STAR] = ACTIONS(1625),
    [anon_sym_CARET] = ACTIONS(2009),
    [anon_sym_AMP] = ACTIONS(2009),
    [anon_sym_this] = ACTIONS(1627),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1629),
    [anon_sym_unchecked] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(2011),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2013),
    [anon_sym_DOT_DOT] = ACTIONS(2015),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_stackalloc] = ACTIONS(1641),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(1647),
    [anon_sym___reftype] = ACTIONS(1649),
    [anon_sym___refvalue] = ACTIONS(1651),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1659),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [1110] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6918),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7067),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6211),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4423),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7383),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9203),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1110),
    [sym_preproc_endregion] = STATE(1110),
    [sym_preproc_line] = STATE(1110),
    [sym_preproc_pragma] = STATE(1110),
    [sym_preproc_nullable] = STATE(1110),
    [sym_preproc_error] = STATE(1110),
    [sym_preproc_define] = STATE(1110),
    [sym_preproc_undef] = STATE(1110),
    [aux_sym_class_declaration_repeat1] = STATE(3817),
    [aux_sym_lambda_expression_repeat1] = STATE(4152),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1905),
    [anon_sym_ref] = ACTIONS(1907),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1221),
    [anon_sym_readonly] = ACTIONS(2693),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1911),
    [anon_sym_TILDE] = ACTIONS(1911),
    [anon_sym_PLUS_PLUS] = ACTIONS(1911),
    [anon_sym_DASH_DASH] = ACTIONS(1911),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1909),
    [anon_sym_DASH] = ACTIONS(1909),
    [anon_sym_STAR] = ACTIONS(1913),
    [anon_sym_CARET] = ACTIONS(1911),
    [anon_sym_AMP] = ACTIONS(1911),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1915),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1917),
    [anon_sym_DOT_DOT] = ACTIONS(1919),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1111] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3767),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6880),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7072),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5727),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4210),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9027),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1111),
    [sym_preproc_endregion] = STATE(1111),
    [sym_preproc_line] = STATE(1111),
    [sym_preproc_pragma] = STATE(1111),
    [sym_preproc_nullable] = STATE(1111),
    [sym_preproc_error] = STATE(1111),
    [sym_preproc_define] = STATE(1111),
    [sym_preproc_undef] = STATE(1111),
    [aux_sym_class_declaration_repeat1] = STATE(3852),
    [aux_sym_lambda_expression_repeat1] = STATE(4220),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1473),
    [anon_sym_ref] = ACTIONS(1475),
    [anon_sym_LBRACE] = ACTIONS(2765),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(1479),
    [anon_sym_PLUS_PLUS] = ACTIONS(1479),
    [anon_sym_DASH_DASH] = ACTIONS(1479),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1477),
    [anon_sym_DASH] = ACTIONS(1477),
    [anon_sym_STAR] = ACTIONS(1101),
    [anon_sym_CARET] = ACTIONS(1479),
    [anon_sym_AMP] = ACTIONS(1479),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1111),
    [anon_sym_DOT_DOT] = ACTIONS(1115),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1112] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(4604),
    [sym_bracketed_argument_list] = STATE(3559),
    [sym__name] = STATE(6878),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2911),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6960),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4445),
    [sym_non_lvalue_expression] = STATE(4553),
    [sym_lvalue_expression] = STATE(3607),
    [sym__expression_statement_expression] = STATE(4559),
    [sym_assignment_expression] = STATE(4558),
    [sym_binary_expression] = STATE(4559),
    [sym_postfix_unary_expression] = STATE(4558),
    [sym_prefix_unary_expression] = STATE(4558),
    [sym__pointer_indirection_expression] = STATE(3560),
    [sym_query_expression] = STATE(4559),
    [sym_from_clause] = STATE(7385),
    [sym_conditional_expression] = STATE(4559),
    [sym_conditional_access_expression] = STATE(4559),
    [sym_as_expression] = STATE(4559),
    [sym_is_expression] = STATE(4559),
    [sym_is_pattern_expression] = STATE(4559),
    [sym_cast_expression] = STATE(4559),
    [sym_checked_expression] = STATE(4559),
    [sym_invocation_expression] = STATE(4558),
    [sym_switch_expression] = STATE(4559),
    [sym_await_expression] = STATE(4558),
    [sym_throw_expression] = STATE(4559),
    [sym_element_access_expression] = STATE(3560),
    [sym_interpolated_string_expression] = STATE(4559),
    [sym_member_access_expression] = STATE(3560),
    [sym_object_creation_expression] = STATE(4558),
    [sym_parenthesized_expression] = STATE(4558),
    [sym__parenthesized_lvalue_expression] = STATE(3560),
    [sym_lambda_expression] = STATE(4559),
    [sym__lambda_parameters] = STATE(9554),
    [sym_array_creation_expression] = STATE(4559),
    [sym_anonymous_method_expression] = STATE(4559),
    [sym_anonymous_object_creation_expression] = STATE(4559),
    [sym_implicit_array_creation_expression] = STATE(4559),
    [sym_implicit_object_creation_expression] = STATE(4559),
    [sym_implicit_stackalloc_expression] = STATE(4559),
    [sym_initializer_expression] = STATE(4559),
    [sym_default_expression] = STATE(4559),
    [sym_with_expression] = STATE(4559),
    [sym_sizeof_expression] = STATE(4559),
    [sym_typeof_expression] = STATE(4559),
    [sym_makeref_expression] = STATE(4559),
    [sym_ref_expression] = STATE(4559),
    [sym_reftype_expression] = STATE(4559),
    [sym_refvalue_expression] = STATE(4559),
    [sym_stackalloc_expression] = STATE(4559),
    [sym_range_expression] = STATE(4559),
    [sym_tuple_expression] = STATE(3560),
    [sym_literal] = STATE(4559),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4559),
    [sym_preproc_region] = STATE(1112),
    [sym_preproc_endregion] = STATE(1112),
    [sym_preproc_line] = STATE(1112),
    [sym_preproc_pragma] = STATE(1112),
    [sym_preproc_nullable] = STATE(1112),
    [sym_preproc_error] = STATE(1112),
    [sym_preproc_define] = STATE(1112),
    [sym_preproc_undef] = STATE(1112),
    [aux_sym_class_declaration_repeat1] = STATE(3792),
    [aux_sym_lambda_expression_repeat1] = STATE(4202),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(1607),
    [anon_sym_ref] = ACTIONS(1609),
    [anon_sym_LBRACE] = ACTIONS(2759),
    [anon_sym_delegate] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1615),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(1621),
    [anon_sym_TILDE] = ACTIONS(1621),
    [anon_sym_PLUS_PLUS] = ACTIONS(1621),
    [anon_sym_DASH_DASH] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(1619),
    [anon_sym_DASH] = ACTIONS(1619),
    [anon_sym_STAR] = ACTIONS(1625),
    [anon_sym_CARET] = ACTIONS(1621),
    [anon_sym_AMP] = ACTIONS(1621),
    [anon_sym_this] = ACTIONS(1627),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1629),
    [anon_sym_unchecked] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [anon_sym_DOT_DOT] = ACTIONS(1637),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_stackalloc] = ACTIONS(1641),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(1647),
    [anon_sym___reftype] = ACTIONS(1649),
    [anon_sym___refvalue] = ACTIONS(1651),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1659),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [1113] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6910),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2957),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6983),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4951),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(3777),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7387),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9385),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1113),
    [sym_preproc_endregion] = STATE(1113),
    [sym_preproc_line] = STATE(1113),
    [sym_preproc_pragma] = STATE(1113),
    [sym_preproc_nullable] = STATE(1113),
    [sym_preproc_error] = STATE(1113),
    [sym_preproc_define] = STATE(1113),
    [sym_preproc_undef] = STATE(1113),
    [aux_sym_class_declaration_repeat1] = STATE(3793),
    [aux_sym_lambda_expression_repeat1] = STATE(4083),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1795),
    [anon_sym_ref] = ACTIONS(1797),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1799),
    [anon_sym_readonly] = ACTIONS(2693),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1803),
    [anon_sym_TILDE] = ACTIONS(1803),
    [anon_sym_PLUS_PLUS] = ACTIONS(1803),
    [anon_sym_DASH_DASH] = ACTIONS(1803),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1801),
    [anon_sym_DASH] = ACTIONS(1801),
    [anon_sym_STAR] = ACTIONS(1805),
    [anon_sym_CARET] = ACTIONS(1803),
    [anon_sym_AMP] = ACTIONS(1803),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1807),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1809),
    [anon_sym_DOT_DOT] = ACTIONS(1811),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1114] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6961),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6439),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9849),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1114),
    [sym_preproc_endregion] = STATE(1114),
    [sym_preproc_line] = STATE(1114),
    [sym_preproc_pragma] = STATE(1114),
    [sym_preproc_nullable] = STATE(1114),
    [sym_preproc_error] = STATE(1114),
    [sym_preproc_define] = STATE(1114),
    [sym_preproc_undef] = STATE(1114),
    [aux_sym_class_declaration_repeat1] = STATE(3841),
    [aux_sym_lambda_expression_repeat1] = STATE(4283),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(2895),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1459),
    [anon_sym_ref] = ACTIONS(1461),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1465),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1467),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1469),
    [anon_sym_DOT_DOT] = ACTIONS(1471),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1115] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6961),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6456),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9849),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1115),
    [sym_preproc_endregion] = STATE(1115),
    [sym_preproc_line] = STATE(1115),
    [sym_preproc_pragma] = STATE(1115),
    [sym_preproc_nullable] = STATE(1115),
    [sym_preproc_error] = STATE(1115),
    [sym_preproc_define] = STATE(1115),
    [sym_preproc_undef] = STATE(1115),
    [aux_sym_class_declaration_repeat1] = STATE(3841),
    [aux_sym_lambda_expression_repeat1] = STATE(4283),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(2897),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1459),
    [anon_sym_ref] = ACTIONS(1461),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1465),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1467),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1469),
    [anon_sym_DOT_DOT] = ACTIONS(1471),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1116] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3751),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6880),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7072),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5728),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4210),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9027),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1116),
    [sym_preproc_endregion] = STATE(1116),
    [sym_preproc_line] = STATE(1116),
    [sym_preproc_pragma] = STATE(1116),
    [sym_preproc_nullable] = STATE(1116),
    [sym_preproc_error] = STATE(1116),
    [sym_preproc_define] = STATE(1116),
    [sym_preproc_undef] = STATE(1116),
    [aux_sym_class_declaration_repeat1] = STATE(3852),
    [aux_sym_lambda_expression_repeat1] = STATE(4220),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1473),
    [anon_sym_ref] = ACTIONS(1475),
    [anon_sym_LBRACE] = ACTIONS(2765),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(1479),
    [anon_sym_PLUS_PLUS] = ACTIONS(1479),
    [anon_sym_DASH_DASH] = ACTIONS(1479),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1477),
    [anon_sym_DASH] = ACTIONS(1477),
    [anon_sym_STAR] = ACTIONS(1101),
    [anon_sym_CARET] = ACTIONS(1479),
    [anon_sym_AMP] = ACTIONS(1479),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1111),
    [anon_sym_DOT_DOT] = ACTIONS(1115),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1117] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3769),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7094),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5906),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1117),
    [sym_preproc_endregion] = STATE(1117),
    [sym_preproc_line] = STATE(1117),
    [sym_preproc_pragma] = STATE(1117),
    [sym_preproc_nullable] = STATE(1117),
    [sym_preproc_error] = STATE(1117),
    [sym_preproc_define] = STATE(1117),
    [sym_preproc_undef] = STATE(1117),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(2765),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1669),
    [anon_sym_TILDE] = ACTIONS(1669),
    [anon_sym_PLUS_PLUS] = ACTIONS(1669),
    [anon_sym_DASH_DASH] = ACTIONS(1669),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1667),
    [anon_sym_DASH] = ACTIONS(1667),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1669),
    [anon_sym_AMP] = ACTIONS(1669),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1118] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6910),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2957),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7081),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5104),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(3796),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7395),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9374),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1118),
    [sym_preproc_endregion] = STATE(1118),
    [sym_preproc_line] = STATE(1118),
    [sym_preproc_pragma] = STATE(1118),
    [sym_preproc_nullable] = STATE(1118),
    [sym_preproc_error] = STATE(1118),
    [sym_preproc_define] = STATE(1118),
    [sym_preproc_undef] = STATE(1118),
    [aux_sym_class_declaration_repeat1] = STATE(3839),
    [aux_sym_lambda_expression_repeat1] = STATE(4209),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2139),
    [anon_sym_ref] = ACTIONS(2141),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1799),
    [anon_sym_readonly] = ACTIONS(2693),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2145),
    [anon_sym_TILDE] = ACTIONS(2145),
    [anon_sym_PLUS_PLUS] = ACTIONS(2145),
    [anon_sym_DASH_DASH] = ACTIONS(2145),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2143),
    [anon_sym_DASH] = ACTIONS(2143),
    [anon_sym_STAR] = ACTIONS(1805),
    [anon_sym_CARET] = ACTIONS(2145),
    [anon_sym_AMP] = ACTIONS(2145),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2147),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2149),
    [anon_sym_DOT_DOT] = ACTIONS(2151),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1119] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5980),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1119),
    [sym_preproc_endregion] = STATE(1119),
    [sym_preproc_line] = STATE(1119),
    [sym_preproc_pragma] = STATE(1119),
    [sym_preproc_nullable] = STATE(1119),
    [sym_preproc_error] = STATE(1119),
    [sym_preproc_define] = STATE(1119),
    [sym_preproc_undef] = STATE(1119),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_RPAREN] = ACTIONS(2899),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1120] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5981),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1120),
    [sym_preproc_endregion] = STATE(1120),
    [sym_preproc_line] = STATE(1120),
    [sym_preproc_pragma] = STATE(1120),
    [sym_preproc_nullable] = STATE(1120),
    [sym_preproc_error] = STATE(1120),
    [sym_preproc_define] = STATE(1120),
    [sym_preproc_undef] = STATE(1120),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_RPAREN] = ACTIONS(2901),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1121] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6166),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2779),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(2843),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5825),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1121),
    [sym_preproc_endregion] = STATE(1121),
    [sym_preproc_line] = STATE(1121),
    [sym_preproc_pragma] = STATE(1121),
    [sym_preproc_nullable] = STATE(1121),
    [sym_preproc_error] = STATE(1121),
    [sym_preproc_define] = STATE(1121),
    [sym_preproc_undef] = STATE(1121),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_ref] = ACTIONS(2257),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_readonly] = ACTIONS(2683),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1669),
    [anon_sym_TILDE] = ACTIONS(1669),
    [anon_sym_PLUS_PLUS] = ACTIONS(1669),
    [anon_sym_DASH_DASH] = ACTIONS(1669),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1667),
    [anon_sym_DASH] = ACTIONS(1667),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1669),
    [anon_sym_AMP] = ACTIONS(1669),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1065),
    [anon_sym_var] = ACTIONS(2673),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1122] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6961),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6388),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9849),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1122),
    [sym_preproc_endregion] = STATE(1122),
    [sym_preproc_line] = STATE(1122),
    [sym_preproc_pragma] = STATE(1122),
    [sym_preproc_nullable] = STATE(1122),
    [sym_preproc_error] = STATE(1122),
    [sym_preproc_define] = STATE(1122),
    [sym_preproc_undef] = STATE(1122),
    [aux_sym_class_declaration_repeat1] = STATE(3841),
    [aux_sym_lambda_expression_repeat1] = STATE(4283),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(2903),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1459),
    [anon_sym_ref] = ACTIONS(1461),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1465),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1467),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1469),
    [anon_sym_DOT_DOT] = ACTIONS(1471),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1123] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6914),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2882),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6966),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5310),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4002),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7386),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9254),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1123),
    [sym_preproc_endregion] = STATE(1123),
    [sym_preproc_line] = STATE(1123),
    [sym_preproc_pragma] = STATE(1123),
    [sym_preproc_nullable] = STATE(1123),
    [sym_preproc_error] = STATE(1123),
    [sym_preproc_define] = STATE(1123),
    [sym_preproc_undef] = STATE(1123),
    [aux_sym_class_declaration_repeat1] = STATE(3797),
    [aux_sym_lambda_expression_repeat1] = STATE(4081),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1727),
    [anon_sym_ref] = ACTIONS(1729),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1713),
    [anon_sym_readonly] = ACTIONS(2693),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1733),
    [anon_sym_TILDE] = ACTIONS(1733),
    [anon_sym_PLUS_PLUS] = ACTIONS(1733),
    [anon_sym_DASH_DASH] = ACTIONS(1733),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1731),
    [anon_sym_DASH] = ACTIONS(1731),
    [anon_sym_STAR] = ACTIONS(1735),
    [anon_sym_CARET] = ACTIONS(1733),
    [anon_sym_AMP] = ACTIONS(1733),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1737),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1739),
    [anon_sym_DOT_DOT] = ACTIONS(1741),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1124] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6961),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6278),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9849),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1124),
    [sym_preproc_endregion] = STATE(1124),
    [sym_preproc_line] = STATE(1124),
    [sym_preproc_pragma] = STATE(1124),
    [sym_preproc_nullable] = STATE(1124),
    [sym_preproc_error] = STATE(1124),
    [sym_preproc_define] = STATE(1124),
    [sym_preproc_undef] = STATE(1124),
    [aux_sym_class_declaration_repeat1] = STATE(3841),
    [aux_sym_lambda_expression_repeat1] = STATE(4283),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(2905),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1459),
    [anon_sym_ref] = ACTIONS(1461),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1465),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1467),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1469),
    [anon_sym_DOT_DOT] = ACTIONS(1471),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1125] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3650),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6918),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7126),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4721),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(3736),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7377),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9441),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1125),
    [sym_preproc_endregion] = STATE(1125),
    [sym_preproc_line] = STATE(1125),
    [sym_preproc_pragma] = STATE(1125),
    [sym_preproc_nullable] = STATE(1125),
    [sym_preproc_error] = STATE(1125),
    [sym_preproc_define] = STATE(1125),
    [sym_preproc_undef] = STATE(1125),
    [aux_sym_class_declaration_repeat1] = STATE(3848),
    [aux_sym_lambda_expression_repeat1] = STATE(4242),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1213),
    [anon_sym_ref] = ACTIONS(1215),
    [anon_sym_LBRACE] = ACTIONS(2767),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1221),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1227),
    [anon_sym_TILDE] = ACTIONS(1227),
    [anon_sym_PLUS_PLUS] = ACTIONS(1227),
    [anon_sym_DASH_DASH] = ACTIONS(1227),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1225),
    [anon_sym_DASH] = ACTIONS(1225),
    [anon_sym_STAR] = ACTIONS(1231),
    [anon_sym_CARET] = ACTIONS(1227),
    [anon_sym_AMP] = ACTIONS(1227),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1239),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1241),
    [anon_sym_DOT_DOT] = ACTIONS(1243),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1126] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6965),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5035),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(3858),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7382),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9625),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1126),
    [sym_preproc_endregion] = STATE(1126),
    [sym_preproc_line] = STATE(1126),
    [sym_preproc_pragma] = STATE(1126),
    [sym_preproc_nullable] = STATE(1126),
    [sym_preproc_error] = STATE(1126),
    [sym_preproc_define] = STATE(1126),
    [sym_preproc_undef] = STATE(1126),
    [aux_sym_class_declaration_repeat1] = STATE(3851),
    [aux_sym_lambda_expression_repeat1] = STATE(4234),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_ref] = ACTIONS(1293),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_readonly] = ACTIONS(2693),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1059),
    [anon_sym_TILDE] = ACTIONS(1059),
    [anon_sym_PLUS_PLUS] = ACTIONS(1059),
    [anon_sym_DASH_DASH] = ACTIONS(1059),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1061),
    [anon_sym_DASH] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(1303),
    [anon_sym_CARET] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1307),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1309),
    [anon_sym_DOT_DOT] = ACTIONS(1311),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1127] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3615),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6918),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7126),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4897),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(3736),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7377),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9441),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1127),
    [sym_preproc_endregion] = STATE(1127),
    [sym_preproc_line] = STATE(1127),
    [sym_preproc_pragma] = STATE(1127),
    [sym_preproc_nullable] = STATE(1127),
    [sym_preproc_error] = STATE(1127),
    [sym_preproc_define] = STATE(1127),
    [sym_preproc_undef] = STATE(1127),
    [aux_sym_class_declaration_repeat1] = STATE(3848),
    [aux_sym_lambda_expression_repeat1] = STATE(4242),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1213),
    [anon_sym_ref] = ACTIONS(1215),
    [anon_sym_LBRACE] = ACTIONS(2767),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1221),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1227),
    [anon_sym_TILDE] = ACTIONS(1227),
    [anon_sym_PLUS_PLUS] = ACTIONS(1227),
    [anon_sym_DASH_DASH] = ACTIONS(1227),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1225),
    [anon_sym_DASH] = ACTIONS(1225),
    [anon_sym_STAR] = ACTIONS(1231),
    [anon_sym_CARET] = ACTIONS(1227),
    [anon_sym_AMP] = ACTIONS(1227),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1239),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1241),
    [anon_sym_DOT_DOT] = ACTIONS(1243),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1128] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3977),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6914),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2882),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6963),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5352),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4002),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7386),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9254),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1128),
    [sym_preproc_endregion] = STATE(1128),
    [sym_preproc_line] = STATE(1128),
    [sym_preproc_pragma] = STATE(1128),
    [sym_preproc_nullable] = STATE(1128),
    [sym_preproc_error] = STATE(1128),
    [sym_preproc_define] = STATE(1128),
    [sym_preproc_undef] = STATE(1128),
    [aux_sym_class_declaration_repeat1] = STATE(3797),
    [aux_sym_lambda_expression_repeat1] = STATE(4081),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1727),
    [anon_sym_ref] = ACTIONS(1729),
    [anon_sym_LBRACE] = ACTIONS(2833),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1713),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1733),
    [anon_sym_TILDE] = ACTIONS(1733),
    [anon_sym_PLUS_PLUS] = ACTIONS(1733),
    [anon_sym_DASH_DASH] = ACTIONS(1733),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1731),
    [anon_sym_DASH] = ACTIONS(1731),
    [anon_sym_STAR] = ACTIONS(1735),
    [anon_sym_CARET] = ACTIONS(1733),
    [anon_sym_AMP] = ACTIONS(1733),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1737),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1739),
    [anon_sym_DOT_DOT] = ACTIONS(1741),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1129] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3683),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6918),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7126),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4884),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(3736),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7377),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9441),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1129),
    [sym_preproc_endregion] = STATE(1129),
    [sym_preproc_line] = STATE(1129),
    [sym_preproc_pragma] = STATE(1129),
    [sym_preproc_nullable] = STATE(1129),
    [sym_preproc_error] = STATE(1129),
    [sym_preproc_define] = STATE(1129),
    [sym_preproc_undef] = STATE(1129),
    [aux_sym_class_declaration_repeat1] = STATE(3848),
    [aux_sym_lambda_expression_repeat1] = STATE(4242),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1213),
    [anon_sym_ref] = ACTIONS(1215),
    [anon_sym_LBRACE] = ACTIONS(2767),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1221),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1227),
    [anon_sym_TILDE] = ACTIONS(1227),
    [anon_sym_PLUS_PLUS] = ACTIONS(1227),
    [anon_sym_DASH_DASH] = ACTIONS(1227),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1225),
    [anon_sym_DASH] = ACTIONS(1225),
    [anon_sym_STAR] = ACTIONS(1231),
    [anon_sym_CARET] = ACTIONS(1227),
    [anon_sym_AMP] = ACTIONS(1227),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1239),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1241),
    [anon_sym_DOT_DOT] = ACTIONS(1243),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1130] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6961),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6391),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9849),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1130),
    [sym_preproc_endregion] = STATE(1130),
    [sym_preproc_line] = STATE(1130),
    [sym_preproc_pragma] = STATE(1130),
    [sym_preproc_nullable] = STATE(1130),
    [sym_preproc_error] = STATE(1130),
    [sym_preproc_define] = STATE(1130),
    [sym_preproc_undef] = STATE(1130),
    [aux_sym_class_declaration_repeat1] = STATE(3841),
    [aux_sym_lambda_expression_repeat1] = STATE(4283),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(2907),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1459),
    [anon_sym_ref] = ACTIONS(1461),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1465),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1467),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1469),
    [anon_sym_DOT_DOT] = ACTIONS(1471),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1131] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3632),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6918),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7126),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4733),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(3736),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7377),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9441),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1131),
    [sym_preproc_endregion] = STATE(1131),
    [sym_preproc_line] = STATE(1131),
    [sym_preproc_pragma] = STATE(1131),
    [sym_preproc_nullable] = STATE(1131),
    [sym_preproc_error] = STATE(1131),
    [sym_preproc_define] = STATE(1131),
    [sym_preproc_undef] = STATE(1131),
    [aux_sym_class_declaration_repeat1] = STATE(3848),
    [aux_sym_lambda_expression_repeat1] = STATE(4242),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1213),
    [anon_sym_ref] = ACTIONS(1215),
    [anon_sym_LBRACE] = ACTIONS(2767),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1221),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1227),
    [anon_sym_TILDE] = ACTIONS(1227),
    [anon_sym_PLUS_PLUS] = ACTIONS(1227),
    [anon_sym_DASH_DASH] = ACTIONS(1227),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1225),
    [anon_sym_DASH] = ACTIONS(1225),
    [anon_sym_STAR] = ACTIONS(1231),
    [anon_sym_CARET] = ACTIONS(1227),
    [anon_sym_AMP] = ACTIONS(1227),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1239),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1241),
    [anon_sym_DOT_DOT] = ACTIONS(1243),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1132] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3615),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6918),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7066),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6099),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4423),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7383),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9203),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1132),
    [sym_preproc_endregion] = STATE(1132),
    [sym_preproc_line] = STATE(1132),
    [sym_preproc_pragma] = STATE(1132),
    [sym_preproc_nullable] = STATE(1132),
    [sym_preproc_error] = STATE(1132),
    [sym_preproc_define] = STATE(1132),
    [sym_preproc_undef] = STATE(1132),
    [aux_sym_class_declaration_repeat1] = STATE(3817),
    [aux_sym_lambda_expression_repeat1] = STATE(4152),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1905),
    [anon_sym_ref] = ACTIONS(1907),
    [anon_sym_LBRACE] = ACTIONS(2767),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1221),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1911),
    [anon_sym_TILDE] = ACTIONS(1911),
    [anon_sym_PLUS_PLUS] = ACTIONS(1911),
    [anon_sym_DASH_DASH] = ACTIONS(1911),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1909),
    [anon_sym_DASH] = ACTIONS(1909),
    [anon_sym_STAR] = ACTIONS(1913),
    [anon_sym_CARET] = ACTIONS(1911),
    [anon_sym_AMP] = ACTIONS(1911),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1915),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1917),
    [anon_sym_DOT_DOT] = ACTIONS(1919),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1133] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3632),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6918),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7066),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6102),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4423),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7383),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9203),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1133),
    [sym_preproc_endregion] = STATE(1133),
    [sym_preproc_line] = STATE(1133),
    [sym_preproc_pragma] = STATE(1133),
    [sym_preproc_nullable] = STATE(1133),
    [sym_preproc_error] = STATE(1133),
    [sym_preproc_define] = STATE(1133),
    [sym_preproc_undef] = STATE(1133),
    [aux_sym_class_declaration_repeat1] = STATE(3817),
    [aux_sym_lambda_expression_repeat1] = STATE(4152),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1905),
    [anon_sym_ref] = ACTIONS(1907),
    [anon_sym_LBRACE] = ACTIONS(2767),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1221),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1911),
    [anon_sym_TILDE] = ACTIONS(1911),
    [anon_sym_PLUS_PLUS] = ACTIONS(1911),
    [anon_sym_DASH_DASH] = ACTIONS(1911),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1909),
    [anon_sym_DASH] = ACTIONS(1909),
    [anon_sym_STAR] = ACTIONS(1913),
    [anon_sym_CARET] = ACTIONS(1911),
    [anon_sym_AMP] = ACTIONS(1911),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1915),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1917),
    [anon_sym_DOT_DOT] = ACTIONS(1919),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1134] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3638),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6918),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7126),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4730),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(3736),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7377),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9441),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1134),
    [sym_preproc_endregion] = STATE(1134),
    [sym_preproc_line] = STATE(1134),
    [sym_preproc_pragma] = STATE(1134),
    [sym_preproc_nullable] = STATE(1134),
    [sym_preproc_error] = STATE(1134),
    [sym_preproc_define] = STATE(1134),
    [sym_preproc_undef] = STATE(1134),
    [aux_sym_class_declaration_repeat1] = STATE(3848),
    [aux_sym_lambda_expression_repeat1] = STATE(4242),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1213),
    [anon_sym_ref] = ACTIONS(1215),
    [anon_sym_LBRACE] = ACTIONS(2767),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1221),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1227),
    [anon_sym_TILDE] = ACTIONS(1227),
    [anon_sym_PLUS_PLUS] = ACTIONS(1227),
    [anon_sym_DASH_DASH] = ACTIONS(1227),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1225),
    [anon_sym_DASH] = ACTIONS(1225),
    [anon_sym_STAR] = ACTIONS(1231),
    [anon_sym_CARET] = ACTIONS(1227),
    [anon_sym_AMP] = ACTIONS(1227),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1239),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1241),
    [anon_sym_DOT_DOT] = ACTIONS(1243),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1135] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3612),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6918),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7126),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4907),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(3736),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7377),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9441),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1135),
    [sym_preproc_endregion] = STATE(1135),
    [sym_preproc_line] = STATE(1135),
    [sym_preproc_pragma] = STATE(1135),
    [sym_preproc_nullable] = STATE(1135),
    [sym_preproc_error] = STATE(1135),
    [sym_preproc_define] = STATE(1135),
    [sym_preproc_undef] = STATE(1135),
    [aux_sym_class_declaration_repeat1] = STATE(3848),
    [aux_sym_lambda_expression_repeat1] = STATE(4242),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1213),
    [anon_sym_ref] = ACTIONS(1215),
    [anon_sym_LBRACE] = ACTIONS(2767),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1221),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1227),
    [anon_sym_TILDE] = ACTIONS(1227),
    [anon_sym_PLUS_PLUS] = ACTIONS(1227),
    [anon_sym_DASH_DASH] = ACTIONS(1227),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1225),
    [anon_sym_DASH] = ACTIONS(1225),
    [anon_sym_STAR] = ACTIONS(1231),
    [anon_sym_CARET] = ACTIONS(1227),
    [anon_sym_AMP] = ACTIONS(1227),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1239),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1241),
    [anon_sym_DOT_DOT] = ACTIONS(1243),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1136] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3638),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6918),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7066),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6103),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4423),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7383),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9203),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1136),
    [sym_preproc_endregion] = STATE(1136),
    [sym_preproc_line] = STATE(1136),
    [sym_preproc_pragma] = STATE(1136),
    [sym_preproc_nullable] = STATE(1136),
    [sym_preproc_error] = STATE(1136),
    [sym_preproc_define] = STATE(1136),
    [sym_preproc_undef] = STATE(1136),
    [aux_sym_class_declaration_repeat1] = STATE(3817),
    [aux_sym_lambda_expression_repeat1] = STATE(4152),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1905),
    [anon_sym_ref] = ACTIONS(1907),
    [anon_sym_LBRACE] = ACTIONS(2767),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1221),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1911),
    [anon_sym_TILDE] = ACTIONS(1911),
    [anon_sym_PLUS_PLUS] = ACTIONS(1911),
    [anon_sym_DASH_DASH] = ACTIONS(1911),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1909),
    [anon_sym_DASH] = ACTIONS(1909),
    [anon_sym_STAR] = ACTIONS(1913),
    [anon_sym_CARET] = ACTIONS(1911),
    [anon_sym_AMP] = ACTIONS(1911),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1915),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1917),
    [anon_sym_DOT_DOT] = ACTIONS(1919),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1137] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3683),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6918),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7066),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6108),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4423),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7383),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9203),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1137),
    [sym_preproc_endregion] = STATE(1137),
    [sym_preproc_line] = STATE(1137),
    [sym_preproc_pragma] = STATE(1137),
    [sym_preproc_nullable] = STATE(1137),
    [sym_preproc_error] = STATE(1137),
    [sym_preproc_define] = STATE(1137),
    [sym_preproc_undef] = STATE(1137),
    [aux_sym_class_declaration_repeat1] = STATE(3817),
    [aux_sym_lambda_expression_repeat1] = STATE(4152),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1905),
    [anon_sym_ref] = ACTIONS(1907),
    [anon_sym_LBRACE] = ACTIONS(2767),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1221),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1911),
    [anon_sym_TILDE] = ACTIONS(1911),
    [anon_sym_PLUS_PLUS] = ACTIONS(1911),
    [anon_sym_DASH_DASH] = ACTIONS(1911),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1909),
    [anon_sym_DASH] = ACTIONS(1909),
    [anon_sym_STAR] = ACTIONS(1913),
    [anon_sym_CARET] = ACTIONS(1911),
    [anon_sym_AMP] = ACTIONS(1911),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1915),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1917),
    [anon_sym_DOT_DOT] = ACTIONS(1919),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1138] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_block] = STATE(3612),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6918),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7066),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6107),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4423),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7383),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9203),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1138),
    [sym_preproc_endregion] = STATE(1138),
    [sym_preproc_line] = STATE(1138),
    [sym_preproc_pragma] = STATE(1138),
    [sym_preproc_nullable] = STATE(1138),
    [sym_preproc_error] = STATE(1138),
    [sym_preproc_define] = STATE(1138),
    [sym_preproc_undef] = STATE(1138),
    [aux_sym_class_declaration_repeat1] = STATE(3817),
    [aux_sym_lambda_expression_repeat1] = STATE(4152),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1905),
    [anon_sym_ref] = ACTIONS(1907),
    [anon_sym_LBRACE] = ACTIONS(2767),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1221),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1911),
    [anon_sym_TILDE] = ACTIONS(1911),
    [anon_sym_PLUS_PLUS] = ACTIONS(1911),
    [anon_sym_DASH_DASH] = ACTIONS(1911),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1909),
    [anon_sym_DASH] = ACTIONS(1909),
    [anon_sym_STAR] = ACTIONS(1913),
    [anon_sym_CARET] = ACTIONS(1911),
    [anon_sym_AMP] = ACTIONS(1911),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1915),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1917),
    [anon_sym_DOT_DOT] = ACTIONS(1919),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1139] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6120),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1139),
    [sym_preproc_endregion] = STATE(1139),
    [sym_preproc_line] = STATE(1139),
    [sym_preproc_pragma] = STATE(1139),
    [sym_preproc_nullable] = STATE(1139),
    [sym_preproc_error] = STATE(1139),
    [sym_preproc_define] = STATE(1139),
    [sym_preproc_undef] = STATE(1139),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1140] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3921),
    [sym__name] = STATE(6889),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2854),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(6991),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5554),
    [sym_non_lvalue_expression] = STATE(5735),
    [sym_lvalue_expression] = STATE(4295),
    [sym__expression_statement_expression] = STATE(5733),
    [sym_assignment_expression] = STATE(5734),
    [sym_binary_expression] = STATE(5733),
    [sym_postfix_unary_expression] = STATE(5734),
    [sym_prefix_unary_expression] = STATE(5734),
    [sym__pointer_indirection_expression] = STATE(3911),
    [sym_query_expression] = STATE(5733),
    [sym_from_clause] = STATE(7393),
    [sym_conditional_expression] = STATE(5733),
    [sym_conditional_access_expression] = STATE(5733),
    [sym_as_expression] = STATE(5733),
    [sym_is_expression] = STATE(5733),
    [sym_is_pattern_expression] = STATE(5733),
    [sym_cast_expression] = STATE(5733),
    [sym_checked_expression] = STATE(5733),
    [sym_invocation_expression] = STATE(5734),
    [sym_switch_expression] = STATE(5733),
    [sym_await_expression] = STATE(5734),
    [sym_throw_expression] = STATE(5733),
    [sym_element_access_expression] = STATE(3911),
    [sym_interpolated_string_expression] = STATE(5733),
    [sym_member_access_expression] = STATE(3911),
    [sym_object_creation_expression] = STATE(5734),
    [sym_parenthesized_expression] = STATE(5734),
    [sym__parenthesized_lvalue_expression] = STATE(3911),
    [sym_lambda_expression] = STATE(5733),
    [sym__lambda_parameters] = STATE(9313),
    [sym_array_creation_expression] = STATE(5733),
    [sym_anonymous_method_expression] = STATE(5733),
    [sym_anonymous_object_creation_expression] = STATE(5733),
    [sym_implicit_array_creation_expression] = STATE(5733),
    [sym_implicit_object_creation_expression] = STATE(5733),
    [sym_implicit_stackalloc_expression] = STATE(5733),
    [sym_initializer_expression] = STATE(5733),
    [sym_default_expression] = STATE(5733),
    [sym_with_expression] = STATE(5733),
    [sym_sizeof_expression] = STATE(5733),
    [sym_typeof_expression] = STATE(5733),
    [sym_makeref_expression] = STATE(5733),
    [sym_ref_expression] = STATE(5733),
    [sym_reftype_expression] = STATE(5733),
    [sym_refvalue_expression] = STATE(5733),
    [sym_stackalloc_expression] = STATE(5733),
    [sym_range_expression] = STATE(5733),
    [sym_tuple_expression] = STATE(3911),
    [sym_literal] = STATE(5733),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2798),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(5733),
    [sym_preproc_region] = STATE(1140),
    [sym_preproc_endregion] = STATE(1140),
    [sym_preproc_line] = STATE(1140),
    [sym_preproc_pragma] = STATE(1140),
    [sym_preproc_nullable] = STATE(1140),
    [sym_preproc_error] = STATE(1140),
    [sym_preproc_define] = STATE(1140),
    [sym_preproc_undef] = STATE(1140),
    [aux_sym_class_declaration_repeat1] = STATE(3805),
    [aux_sym_lambda_expression_repeat1] = STATE(4122),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_LPAREN] = ACTIONS(1591),
    [anon_sym_ref] = ACTIONS(1593),
    [anon_sym_LBRACE] = ACTIONS(1377),
    [anon_sym_delegate] = ACTIONS(1379),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1443),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1597),
    [anon_sym_TILDE] = ACTIONS(1597),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1595),
    [anon_sym_DASH] = ACTIONS(1595),
    [anon_sym_STAR] = ACTIONS(1449),
    [anon_sym_CARET] = ACTIONS(1597),
    [anon_sym_AMP] = ACTIONS(1597),
    [anon_sym_this] = ACTIONS(1393),
    [anon_sym_scoped] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1397),
    [sym_predefined_type] = ACTIONS(1399),
    [anon_sym_unchecked] = ACTIONS(1383),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1599),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1601),
    [anon_sym_DOT_DOT] = ACTIONS(1603),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_stackalloc] = ACTIONS(1413),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(1419),
    [anon_sym___reftype] = ACTIONS(1421),
    [anon_sym___refvalue] = ACTIONS(1423),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
  },
  [1141] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6918),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7066),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6121),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4423),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7383),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9203),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1141),
    [sym_preproc_endregion] = STATE(1141),
    [sym_preproc_line] = STATE(1141),
    [sym_preproc_pragma] = STATE(1141),
    [sym_preproc_nullable] = STATE(1141),
    [sym_preproc_error] = STATE(1141),
    [sym_preproc_define] = STATE(1141),
    [sym_preproc_undef] = STATE(1141),
    [aux_sym_class_declaration_repeat1] = STATE(3817),
    [aux_sym_lambda_expression_repeat1] = STATE(4152),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1905),
    [anon_sym_ref] = ACTIONS(1907),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1221),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1911),
    [anon_sym_TILDE] = ACTIONS(1911),
    [anon_sym_PLUS_PLUS] = ACTIONS(1911),
    [anon_sym_DASH_DASH] = ACTIONS(1911),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1909),
    [anon_sym_DASH] = ACTIONS(1909),
    [anon_sym_STAR] = ACTIONS(1913),
    [anon_sym_CARET] = ACTIONS(1911),
    [anon_sym_AMP] = ACTIONS(1911),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1915),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1917),
    [anon_sym_DOT_DOT] = ACTIONS(1919),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1142] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6918),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7066),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6132),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4423),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7383),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9203),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1142),
    [sym_preproc_endregion] = STATE(1142),
    [sym_preproc_line] = STATE(1142),
    [sym_preproc_pragma] = STATE(1142),
    [sym_preproc_nullable] = STATE(1142),
    [sym_preproc_error] = STATE(1142),
    [sym_preproc_define] = STATE(1142),
    [sym_preproc_undef] = STATE(1142),
    [aux_sym_class_declaration_repeat1] = STATE(3817),
    [aux_sym_lambda_expression_repeat1] = STATE(4152),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1905),
    [anon_sym_ref] = ACTIONS(1907),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1221),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1911),
    [anon_sym_TILDE] = ACTIONS(1911),
    [anon_sym_PLUS_PLUS] = ACTIONS(1911),
    [anon_sym_DASH_DASH] = ACTIONS(1911),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1909),
    [anon_sym_DASH] = ACTIONS(1909),
    [anon_sym_STAR] = ACTIONS(1913),
    [anon_sym_CARET] = ACTIONS(1911),
    [anon_sym_AMP] = ACTIONS(1911),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1915),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1917),
    [anon_sym_DOT_DOT] = ACTIONS(1919),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1143] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6384),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1143),
    [sym_preproc_endregion] = STATE(1143),
    [sym_preproc_line] = STATE(1143),
    [sym_preproc_pragma] = STATE(1143),
    [sym_preproc_nullable] = STATE(1143),
    [sym_preproc_error] = STATE(1143),
    [sym_preproc_define] = STATE(1143),
    [sym_preproc_undef] = STATE(1143),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1144] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6387),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1144),
    [sym_preproc_endregion] = STATE(1144),
    [sym_preproc_line] = STATE(1144),
    [sym_preproc_pragma] = STATE(1144),
    [sym_preproc_nullable] = STATE(1144),
    [sym_preproc_error] = STATE(1144),
    [sym_preproc_define] = STATE(1144),
    [sym_preproc_undef] = STATE(1144),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1145] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6918),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7066),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6136),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4423),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7383),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9203),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1145),
    [sym_preproc_endregion] = STATE(1145),
    [sym_preproc_line] = STATE(1145),
    [sym_preproc_pragma] = STATE(1145),
    [sym_preproc_nullable] = STATE(1145),
    [sym_preproc_error] = STATE(1145),
    [sym_preproc_define] = STATE(1145),
    [sym_preproc_undef] = STATE(1145),
    [aux_sym_class_declaration_repeat1] = STATE(3817),
    [aux_sym_lambda_expression_repeat1] = STATE(4152),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1905),
    [anon_sym_ref] = ACTIONS(1907),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1221),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1911),
    [anon_sym_TILDE] = ACTIONS(1911),
    [anon_sym_PLUS_PLUS] = ACTIONS(1911),
    [anon_sym_DASH_DASH] = ACTIONS(1911),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1909),
    [anon_sym_DASH] = ACTIONS(1909),
    [anon_sym_STAR] = ACTIONS(1913),
    [anon_sym_CARET] = ACTIONS(1911),
    [anon_sym_AMP] = ACTIONS(1911),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1915),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1917),
    [anon_sym_DOT_DOT] = ACTIONS(1919),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1146] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6876),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6442),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4477),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9873),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1146),
    [sym_preproc_endregion] = STATE(1146),
    [sym_preproc_line] = STATE(1146),
    [sym_preproc_pragma] = STATE(1146),
    [sym_preproc_nullable] = STATE(1146),
    [sym_preproc_error] = STATE(1146),
    [sym_preproc_define] = STATE(1146),
    [sym_preproc_undef] = STATE(1146),
    [aux_sym_class_declaration_repeat1] = STATE(3845),
    [aux_sym_lambda_expression_repeat1] = STATE(4299),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1979),
    [anon_sym_ref] = ACTIONS(1981),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1985),
    [anon_sym_TILDE] = ACTIONS(1985),
    [anon_sym_PLUS_PLUS] = ACTIONS(1985),
    [anon_sym_DASH_DASH] = ACTIONS(1985),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1983),
    [anon_sym_DASH] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1985),
    [anon_sym_AMP] = ACTIONS(1985),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1987),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1989),
    [anon_sym_DOT_DOT] = ACTIONS(1991),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1147] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6918),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7066),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6137),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4423),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7383),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9203),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1147),
    [sym_preproc_endregion] = STATE(1147),
    [sym_preproc_line] = STATE(1147),
    [sym_preproc_pragma] = STATE(1147),
    [sym_preproc_nullable] = STATE(1147),
    [sym_preproc_error] = STATE(1147),
    [sym_preproc_define] = STATE(1147),
    [sym_preproc_undef] = STATE(1147),
    [aux_sym_class_declaration_repeat1] = STATE(3817),
    [aux_sym_lambda_expression_repeat1] = STATE(4152),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1905),
    [anon_sym_ref] = ACTIONS(1907),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1221),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1911),
    [anon_sym_TILDE] = ACTIONS(1911),
    [anon_sym_PLUS_PLUS] = ACTIONS(1911),
    [anon_sym_DASH_DASH] = ACTIONS(1911),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1909),
    [anon_sym_DASH] = ACTIONS(1909),
    [anon_sym_STAR] = ACTIONS(1913),
    [anon_sym_CARET] = ACTIONS(1911),
    [anon_sym_AMP] = ACTIONS(1911),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1915),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1917),
    [anon_sym_DOT_DOT] = ACTIONS(1919),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1148] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6918),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7066),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6122),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4423),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7383),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9203),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1148),
    [sym_preproc_endregion] = STATE(1148),
    [sym_preproc_line] = STATE(1148),
    [sym_preproc_pragma] = STATE(1148),
    [sym_preproc_nullable] = STATE(1148),
    [sym_preproc_error] = STATE(1148),
    [sym_preproc_define] = STATE(1148),
    [sym_preproc_undef] = STATE(1148),
    [aux_sym_class_declaration_repeat1] = STATE(3817),
    [aux_sym_lambda_expression_repeat1] = STATE(4152),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1905),
    [anon_sym_ref] = ACTIONS(1907),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1221),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1911),
    [anon_sym_TILDE] = ACTIONS(1911),
    [anon_sym_PLUS_PLUS] = ACTIONS(1911),
    [anon_sym_DASH_DASH] = ACTIONS(1911),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1909),
    [anon_sym_DASH] = ACTIONS(1909),
    [anon_sym_STAR] = ACTIONS(1913),
    [anon_sym_CARET] = ACTIONS(1911),
    [anon_sym_AMP] = ACTIONS(1911),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1915),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1917),
    [anon_sym_DOT_DOT] = ACTIONS(1919),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1149] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6383),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1149),
    [sym_preproc_endregion] = STATE(1149),
    [sym_preproc_line] = STATE(1149),
    [sym_preproc_pragma] = STATE(1149),
    [sym_preproc_nullable] = STATE(1149),
    [sym_preproc_error] = STATE(1149),
    [sym_preproc_define] = STATE(1149),
    [sym_preproc_undef] = STATE(1149),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1150] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6382),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1150),
    [sym_preproc_endregion] = STATE(1150),
    [sym_preproc_line] = STATE(1150),
    [sym_preproc_pragma] = STATE(1150),
    [sym_preproc_nullable] = STATE(1150),
    [sym_preproc_error] = STATE(1150),
    [sym_preproc_define] = STATE(1150),
    [sym_preproc_undef] = STATE(1150),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1151] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6918),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7066),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6123),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4423),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7383),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9203),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1151),
    [sym_preproc_endregion] = STATE(1151),
    [sym_preproc_line] = STATE(1151),
    [sym_preproc_pragma] = STATE(1151),
    [sym_preproc_nullable] = STATE(1151),
    [sym_preproc_error] = STATE(1151),
    [sym_preproc_define] = STATE(1151),
    [sym_preproc_undef] = STATE(1151),
    [aux_sym_class_declaration_repeat1] = STATE(3817),
    [aux_sym_lambda_expression_repeat1] = STATE(4152),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1905),
    [anon_sym_ref] = ACTIONS(1907),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1221),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1911),
    [anon_sym_TILDE] = ACTIONS(1911),
    [anon_sym_PLUS_PLUS] = ACTIONS(1911),
    [anon_sym_DASH_DASH] = ACTIONS(1911),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1909),
    [anon_sym_DASH] = ACTIONS(1909),
    [anon_sym_STAR] = ACTIONS(1913),
    [anon_sym_CARET] = ACTIONS(1911),
    [anon_sym_AMP] = ACTIONS(1911),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1915),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1917),
    [anon_sym_DOT_DOT] = ACTIONS(1919),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1152] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6459),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1152),
    [sym_preproc_endregion] = STATE(1152),
    [sym_preproc_line] = STATE(1152),
    [sym_preproc_pragma] = STATE(1152),
    [sym_preproc_nullable] = STATE(1152),
    [sym_preproc_error] = STATE(1152),
    [sym_preproc_define] = STATE(1152),
    [sym_preproc_undef] = STATE(1152),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1153] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6918),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7066),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6124),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4423),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7383),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9203),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1153),
    [sym_preproc_endregion] = STATE(1153),
    [sym_preproc_line] = STATE(1153),
    [sym_preproc_pragma] = STATE(1153),
    [sym_preproc_nullable] = STATE(1153),
    [sym_preproc_error] = STATE(1153),
    [sym_preproc_define] = STATE(1153),
    [sym_preproc_undef] = STATE(1153),
    [aux_sym_class_declaration_repeat1] = STATE(3817),
    [aux_sym_lambda_expression_repeat1] = STATE(4152),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1905),
    [anon_sym_ref] = ACTIONS(1907),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1221),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1911),
    [anon_sym_TILDE] = ACTIONS(1911),
    [anon_sym_PLUS_PLUS] = ACTIONS(1911),
    [anon_sym_DASH_DASH] = ACTIONS(1911),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1909),
    [anon_sym_DASH] = ACTIONS(1909),
    [anon_sym_STAR] = ACTIONS(1913),
    [anon_sym_CARET] = ACTIONS(1911),
    [anon_sym_AMP] = ACTIONS(1911),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1915),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1917),
    [anon_sym_DOT_DOT] = ACTIONS(1919),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1154] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6918),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7066),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6106),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4423),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7383),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9203),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1154),
    [sym_preproc_endregion] = STATE(1154),
    [sym_preproc_line] = STATE(1154),
    [sym_preproc_pragma] = STATE(1154),
    [sym_preproc_nullable] = STATE(1154),
    [sym_preproc_error] = STATE(1154),
    [sym_preproc_define] = STATE(1154),
    [sym_preproc_undef] = STATE(1154),
    [aux_sym_class_declaration_repeat1] = STATE(3817),
    [aux_sym_lambda_expression_repeat1] = STATE(4152),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1905),
    [anon_sym_ref] = ACTIONS(1907),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1221),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1911),
    [anon_sym_TILDE] = ACTIONS(1911),
    [anon_sym_PLUS_PLUS] = ACTIONS(1911),
    [anon_sym_DASH_DASH] = ACTIONS(1911),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1909),
    [anon_sym_DASH] = ACTIONS(1909),
    [anon_sym_STAR] = ACTIONS(1913),
    [anon_sym_CARET] = ACTIONS(1911),
    [anon_sym_AMP] = ACTIONS(1911),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1915),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1917),
    [anon_sym_DOT_DOT] = ACTIONS(1919),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1155] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6886),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6460),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4477),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9873),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1155),
    [sym_preproc_endregion] = STATE(1155),
    [sym_preproc_line] = STATE(1155),
    [sym_preproc_pragma] = STATE(1155),
    [sym_preproc_nullable] = STATE(1155),
    [sym_preproc_error] = STATE(1155),
    [sym_preproc_define] = STATE(1155),
    [sym_preproc_undef] = STATE(1155),
    [aux_sym_class_declaration_repeat1] = STATE(3845),
    [aux_sym_lambda_expression_repeat1] = STATE(4299),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1979),
    [anon_sym_ref] = ACTIONS(1981),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1985),
    [anon_sym_TILDE] = ACTIONS(1985),
    [anon_sym_PLUS_PLUS] = ACTIONS(1985),
    [anon_sym_DASH_DASH] = ACTIONS(1985),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1983),
    [anon_sym_DASH] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1985),
    [anon_sym_AMP] = ACTIONS(1985),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1987),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1989),
    [anon_sym_DOT_DOT] = ACTIONS(1991),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1156] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6888),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2882),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7048),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5312),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4019),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7409),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9210),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1156),
    [sym_preproc_endregion] = STATE(1156),
    [sym_preproc_line] = STATE(1156),
    [sym_preproc_pragma] = STATE(1156),
    [sym_preproc_nullable] = STATE(1156),
    [sym_preproc_error] = STATE(1156),
    [sym_preproc_define] = STATE(1156),
    [sym_preproc_undef] = STATE(1156),
    [aux_sym_class_declaration_repeat1] = STATE(3812),
    [aux_sym_lambda_expression_repeat1] = STATE(4146),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1709),
    [anon_sym_ref] = ACTIONS(1711),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1713),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1717),
    [anon_sym_TILDE] = ACTIONS(1717),
    [anon_sym_PLUS_PLUS] = ACTIONS(1717),
    [anon_sym_DASH_DASH] = ACTIONS(1717),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1715),
    [anon_sym_DASH] = ACTIONS(1715),
    [anon_sym_STAR] = ACTIONS(1719),
    [anon_sym_CARET] = ACTIONS(1717),
    [anon_sym_AMP] = ACTIONS(1717),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1721),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1723),
    [anon_sym_DOT_DOT] = ACTIONS(1725),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1157] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6899),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6541),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4477),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9873),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1157),
    [sym_preproc_endregion] = STATE(1157),
    [sym_preproc_line] = STATE(1157),
    [sym_preproc_pragma] = STATE(1157),
    [sym_preproc_nullable] = STATE(1157),
    [sym_preproc_error] = STATE(1157),
    [sym_preproc_define] = STATE(1157),
    [sym_preproc_undef] = STATE(1157),
    [aux_sym_class_declaration_repeat1] = STATE(3845),
    [aux_sym_lambda_expression_repeat1] = STATE(4299),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1979),
    [anon_sym_ref] = ACTIONS(1981),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1985),
    [anon_sym_TILDE] = ACTIONS(1985),
    [anon_sym_PLUS_PLUS] = ACTIONS(1985),
    [anon_sym_DASH_DASH] = ACTIONS(1985),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1983),
    [anon_sym_DASH] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1985),
    [anon_sym_AMP] = ACTIONS(1985),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1987),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1989),
    [anon_sym_DOT_DOT] = ACTIONS(1991),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1158] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6918),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7066),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6111),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4423),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7383),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9203),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1158),
    [sym_preproc_endregion] = STATE(1158),
    [sym_preproc_line] = STATE(1158),
    [sym_preproc_pragma] = STATE(1158),
    [sym_preproc_nullable] = STATE(1158),
    [sym_preproc_error] = STATE(1158),
    [sym_preproc_define] = STATE(1158),
    [sym_preproc_undef] = STATE(1158),
    [aux_sym_class_declaration_repeat1] = STATE(3817),
    [aux_sym_lambda_expression_repeat1] = STATE(4152),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1905),
    [anon_sym_ref] = ACTIONS(1907),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1221),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1911),
    [anon_sym_TILDE] = ACTIONS(1911),
    [anon_sym_PLUS_PLUS] = ACTIONS(1911),
    [anon_sym_DASH_DASH] = ACTIONS(1911),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1909),
    [anon_sym_DASH] = ACTIONS(1909),
    [anon_sym_STAR] = ACTIONS(1913),
    [anon_sym_CARET] = ACTIONS(1911),
    [anon_sym_AMP] = ACTIONS(1911),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1915),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1917),
    [anon_sym_DOT_DOT] = ACTIONS(1919),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1159] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6918),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7066),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(3556),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4423),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7383),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9203),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1159),
    [sym_preproc_endregion] = STATE(1159),
    [sym_preproc_line] = STATE(1159),
    [sym_preproc_pragma] = STATE(1159),
    [sym_preproc_nullable] = STATE(1159),
    [sym_preproc_error] = STATE(1159),
    [sym_preproc_define] = STATE(1159),
    [sym_preproc_undef] = STATE(1159),
    [aux_sym_class_declaration_repeat1] = STATE(3817),
    [aux_sym_lambda_expression_repeat1] = STATE(4152),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1905),
    [anon_sym_ref] = ACTIONS(1907),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1221),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1911),
    [anon_sym_TILDE] = ACTIONS(1911),
    [anon_sym_PLUS_PLUS] = ACTIONS(1911),
    [anon_sym_DASH_DASH] = ACTIONS(1911),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1909),
    [anon_sym_DASH] = ACTIONS(1909),
    [anon_sym_STAR] = ACTIONS(1913),
    [anon_sym_CARET] = ACTIONS(1911),
    [anon_sym_AMP] = ACTIONS(1911),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1915),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1917),
    [anon_sym_DOT_DOT] = ACTIONS(1919),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1160] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6918),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7066),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6138),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4423),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7383),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9203),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1160),
    [sym_preproc_endregion] = STATE(1160),
    [sym_preproc_line] = STATE(1160),
    [sym_preproc_pragma] = STATE(1160),
    [sym_preproc_nullable] = STATE(1160),
    [sym_preproc_error] = STATE(1160),
    [sym_preproc_define] = STATE(1160),
    [sym_preproc_undef] = STATE(1160),
    [aux_sym_class_declaration_repeat1] = STATE(3817),
    [aux_sym_lambda_expression_repeat1] = STATE(4152),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1905),
    [anon_sym_ref] = ACTIONS(1907),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1221),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1911),
    [anon_sym_TILDE] = ACTIONS(1911),
    [anon_sym_PLUS_PLUS] = ACTIONS(1911),
    [anon_sym_DASH_DASH] = ACTIONS(1911),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1909),
    [anon_sym_DASH] = ACTIONS(1909),
    [anon_sym_STAR] = ACTIONS(1913),
    [anon_sym_CARET] = ACTIONS(1911),
    [anon_sym_AMP] = ACTIONS(1911),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1915),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1917),
    [anon_sym_DOT_DOT] = ACTIONS(1919),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1161] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6918),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7066),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6131),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4423),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7383),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9203),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1161),
    [sym_preproc_endregion] = STATE(1161),
    [sym_preproc_line] = STATE(1161),
    [sym_preproc_pragma] = STATE(1161),
    [sym_preproc_nullable] = STATE(1161),
    [sym_preproc_error] = STATE(1161),
    [sym_preproc_define] = STATE(1161),
    [sym_preproc_undef] = STATE(1161),
    [aux_sym_class_declaration_repeat1] = STATE(3817),
    [aux_sym_lambda_expression_repeat1] = STATE(4152),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1905),
    [anon_sym_ref] = ACTIONS(1907),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1221),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1911),
    [anon_sym_TILDE] = ACTIONS(1911),
    [anon_sym_PLUS_PLUS] = ACTIONS(1911),
    [anon_sym_DASH_DASH] = ACTIONS(1911),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1909),
    [anon_sym_DASH] = ACTIONS(1909),
    [anon_sym_STAR] = ACTIONS(1913),
    [anon_sym_CARET] = ACTIONS(1911),
    [anon_sym_AMP] = ACTIONS(1911),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1915),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1917),
    [anon_sym_DOT_DOT] = ACTIONS(1919),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1162] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6898),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2940),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6936),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(3922),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4318),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7401),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9262),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1162),
    [sym_preproc_endregion] = STATE(1162),
    [sym_preproc_line] = STATE(1162),
    [sym_preproc_pragma] = STATE(1162),
    [sym_preproc_nullable] = STATE(1162),
    [sym_preproc_error] = STATE(1162),
    [sym_preproc_define] = STATE(1162),
    [sym_preproc_undef] = STATE(1162),
    [aux_sym_class_declaration_repeat1] = STATE(3815),
    [aux_sym_lambda_expression_repeat1] = STATE(4072),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1885),
    [anon_sym_ref] = ACTIONS(1887),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1889),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1893),
    [anon_sym_TILDE] = ACTIONS(1893),
    [anon_sym_PLUS_PLUS] = ACTIONS(1893),
    [anon_sym_DASH_DASH] = ACTIONS(1893),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1891),
    [anon_sym_DASH] = ACTIONS(1891),
    [anon_sym_STAR] = ACTIONS(1895),
    [anon_sym_CARET] = ACTIONS(1893),
    [anon_sym_AMP] = ACTIONS(1893),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1897),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1899),
    [anon_sym_DOT_DOT] = ACTIONS(1901),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1163] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6574),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1163),
    [sym_preproc_endregion] = STATE(1163),
    [sym_preproc_line] = STATE(1163),
    [sym_preproc_pragma] = STATE(1163),
    [sym_preproc_nullable] = STATE(1163),
    [sym_preproc_error] = STATE(1163),
    [sym_preproc_define] = STATE(1163),
    [sym_preproc_undef] = STATE(1163),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1164] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6901),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2939),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7050),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6297),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4507),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7378),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9063),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1164),
    [sym_preproc_endregion] = STATE(1164),
    [sym_preproc_line] = STATE(1164),
    [sym_preproc_pragma] = STATE(1164),
    [sym_preproc_nullable] = STATE(1164),
    [sym_preproc_error] = STATE(1164),
    [sym_preproc_define] = STATE(1164),
    [sym_preproc_undef] = STATE(1164),
    [aux_sym_class_declaration_repeat1] = STATE(3854),
    [aux_sym_lambda_expression_repeat1] = STATE(4229),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2193),
    [anon_sym_ref] = ACTIONS(2195),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2197),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2201),
    [anon_sym_TILDE] = ACTIONS(2201),
    [anon_sym_PLUS_PLUS] = ACTIONS(2201),
    [anon_sym_DASH_DASH] = ACTIONS(2201),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2199),
    [anon_sym_DASH] = ACTIONS(2199),
    [anon_sym_STAR] = ACTIONS(2203),
    [anon_sym_CARET] = ACTIONS(2201),
    [anon_sym_AMP] = ACTIONS(2201),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2205),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2207),
    [anon_sym_DOT_DOT] = ACTIONS(2209),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1165] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6898),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2940),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6936),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5812),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4318),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7401),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9262),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1165),
    [sym_preproc_endregion] = STATE(1165),
    [sym_preproc_line] = STATE(1165),
    [sym_preproc_pragma] = STATE(1165),
    [sym_preproc_nullable] = STATE(1165),
    [sym_preproc_error] = STATE(1165),
    [sym_preproc_define] = STATE(1165),
    [sym_preproc_undef] = STATE(1165),
    [aux_sym_class_declaration_repeat1] = STATE(3815),
    [aux_sym_lambda_expression_repeat1] = STATE(4072),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1885),
    [anon_sym_ref] = ACTIONS(1887),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1889),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1893),
    [anon_sym_TILDE] = ACTIONS(1893),
    [anon_sym_PLUS_PLUS] = ACTIONS(1893),
    [anon_sym_DASH_DASH] = ACTIONS(1893),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1891),
    [anon_sym_DASH] = ACTIONS(1891),
    [anon_sym_STAR] = ACTIONS(1895),
    [anon_sym_CARET] = ACTIONS(1893),
    [anon_sym_AMP] = ACTIONS(1893),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1897),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1899),
    [anon_sym_DOT_DOT] = ACTIONS(1901),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1166] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6913),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7016),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4503),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(3582),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7407),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9275),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1166),
    [sym_preproc_endregion] = STATE(1166),
    [sym_preproc_line] = STATE(1166),
    [sym_preproc_pragma] = STATE(1166),
    [sym_preproc_nullable] = STATE(1166),
    [sym_preproc_error] = STATE(1166),
    [sym_preproc_define] = STATE(1166),
    [sym_preproc_undef] = STATE(1166),
    [aux_sym_class_declaration_repeat1] = STATE(3789),
    [aux_sym_lambda_expression_repeat1] = STATE(4086),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1137),
    [anon_sym_ref] = ACTIONS(1139),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1145),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1153),
    [anon_sym_TILDE] = ACTIONS(1153),
    [anon_sym_PLUS_PLUS] = ACTIONS(1153),
    [anon_sym_DASH_DASH] = ACTIONS(1153),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1151),
    [anon_sym_DASH] = ACTIONS(1151),
    [anon_sym_STAR] = ACTIONS(1157),
    [anon_sym_CARET] = ACTIONS(1153),
    [anon_sym_AMP] = ACTIONS(1153),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1165),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1167),
    [anon_sym_DOT_DOT] = ACTIONS(1169),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1167] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6918),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7126),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4808),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(3736),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7377),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9441),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1167),
    [sym_preproc_endregion] = STATE(1167),
    [sym_preproc_line] = STATE(1167),
    [sym_preproc_pragma] = STATE(1167),
    [sym_preproc_nullable] = STATE(1167),
    [sym_preproc_error] = STATE(1167),
    [sym_preproc_define] = STATE(1167),
    [sym_preproc_undef] = STATE(1167),
    [aux_sym_class_declaration_repeat1] = STATE(3848),
    [aux_sym_lambda_expression_repeat1] = STATE(4242),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1213),
    [anon_sym_ref] = ACTIONS(1215),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1221),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1227),
    [anon_sym_TILDE] = ACTIONS(1227),
    [anon_sym_PLUS_PLUS] = ACTIONS(1227),
    [anon_sym_DASH_DASH] = ACTIONS(1227),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1225),
    [anon_sym_DASH] = ACTIONS(1225),
    [anon_sym_STAR] = ACTIONS(1231),
    [anon_sym_CARET] = ACTIONS(1227),
    [anon_sym_AMP] = ACTIONS(1227),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1239),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1241),
    [anon_sym_DOT_DOT] = ACTIONS(1243),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1168] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6898),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2940),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6936),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5813),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4318),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7401),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9262),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1168),
    [sym_preproc_endregion] = STATE(1168),
    [sym_preproc_line] = STATE(1168),
    [sym_preproc_pragma] = STATE(1168),
    [sym_preproc_nullable] = STATE(1168),
    [sym_preproc_error] = STATE(1168),
    [sym_preproc_define] = STATE(1168),
    [sym_preproc_undef] = STATE(1168),
    [aux_sym_class_declaration_repeat1] = STATE(3815),
    [aux_sym_lambda_expression_repeat1] = STATE(4072),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1885),
    [anon_sym_ref] = ACTIONS(1887),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1889),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1893),
    [anon_sym_TILDE] = ACTIONS(1893),
    [anon_sym_PLUS_PLUS] = ACTIONS(1893),
    [anon_sym_DASH_DASH] = ACTIONS(1893),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1891),
    [anon_sym_DASH] = ACTIONS(1891),
    [anon_sym_STAR] = ACTIONS(1895),
    [anon_sym_CARET] = ACTIONS(1893),
    [anon_sym_AMP] = ACTIONS(1893),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1897),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1899),
    [anon_sym_DOT_DOT] = ACTIONS(1901),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1169] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6898),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2940),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6936),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5815),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4318),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7401),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9262),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1169),
    [sym_preproc_endregion] = STATE(1169),
    [sym_preproc_line] = STATE(1169),
    [sym_preproc_pragma] = STATE(1169),
    [sym_preproc_nullable] = STATE(1169),
    [sym_preproc_error] = STATE(1169),
    [sym_preproc_define] = STATE(1169),
    [sym_preproc_undef] = STATE(1169),
    [aux_sym_class_declaration_repeat1] = STATE(3815),
    [aux_sym_lambda_expression_repeat1] = STATE(4072),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1885),
    [anon_sym_ref] = ACTIONS(1887),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1889),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1893),
    [anon_sym_TILDE] = ACTIONS(1893),
    [anon_sym_PLUS_PLUS] = ACTIONS(1893),
    [anon_sym_DASH_DASH] = ACTIONS(1893),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1891),
    [anon_sym_DASH] = ACTIONS(1891),
    [anon_sym_STAR] = ACTIONS(1895),
    [anon_sym_CARET] = ACTIONS(1893),
    [anon_sym_AMP] = ACTIONS(1893),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1897),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1899),
    [anon_sym_DOT_DOT] = ACTIONS(1901),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1170] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6898),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2940),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6936),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5816),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4318),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7401),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9262),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1170),
    [sym_preproc_endregion] = STATE(1170),
    [sym_preproc_line] = STATE(1170),
    [sym_preproc_pragma] = STATE(1170),
    [sym_preproc_nullable] = STATE(1170),
    [sym_preproc_error] = STATE(1170),
    [sym_preproc_define] = STATE(1170),
    [sym_preproc_undef] = STATE(1170),
    [aux_sym_class_declaration_repeat1] = STATE(3815),
    [aux_sym_lambda_expression_repeat1] = STATE(4072),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1885),
    [anon_sym_ref] = ACTIONS(1887),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1889),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1893),
    [anon_sym_TILDE] = ACTIONS(1893),
    [anon_sym_PLUS_PLUS] = ACTIONS(1893),
    [anon_sym_DASH_DASH] = ACTIONS(1893),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1891),
    [anon_sym_DASH] = ACTIONS(1891),
    [anon_sym_STAR] = ACTIONS(1895),
    [anon_sym_CARET] = ACTIONS(1893),
    [anon_sym_AMP] = ACTIONS(1893),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1897),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1899),
    [anon_sym_DOT_DOT] = ACTIONS(1901),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1171] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6898),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2940),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6936),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5817),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4318),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7401),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9262),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1171),
    [sym_preproc_endregion] = STATE(1171),
    [sym_preproc_line] = STATE(1171),
    [sym_preproc_pragma] = STATE(1171),
    [sym_preproc_nullable] = STATE(1171),
    [sym_preproc_error] = STATE(1171),
    [sym_preproc_define] = STATE(1171),
    [sym_preproc_undef] = STATE(1171),
    [aux_sym_class_declaration_repeat1] = STATE(3815),
    [aux_sym_lambda_expression_repeat1] = STATE(4072),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1885),
    [anon_sym_ref] = ACTIONS(1887),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1889),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1893),
    [anon_sym_TILDE] = ACTIONS(1893),
    [anon_sym_PLUS_PLUS] = ACTIONS(1893),
    [anon_sym_DASH_DASH] = ACTIONS(1893),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1891),
    [anon_sym_DASH] = ACTIONS(1891),
    [anon_sym_STAR] = ACTIONS(1895),
    [anon_sym_CARET] = ACTIONS(1893),
    [anon_sym_AMP] = ACTIONS(1893),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1897),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1899),
    [anon_sym_DOT_DOT] = ACTIONS(1901),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1172] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6231),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1172),
    [sym_preproc_endregion] = STATE(1172),
    [sym_preproc_line] = STATE(1172),
    [sym_preproc_pragma] = STATE(1172),
    [sym_preproc_nullable] = STATE(1172),
    [sym_preproc_error] = STATE(1172),
    [sym_preproc_define] = STATE(1172),
    [sym_preproc_undef] = STATE(1172),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1173] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6987),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6373),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4462),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7405),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9130),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1173),
    [sym_preproc_endregion] = STATE(1173),
    [sym_preproc_line] = STATE(1173),
    [sym_preproc_pragma] = STATE(1173),
    [sym_preproc_nullable] = STATE(1173),
    [sym_preproc_error] = STATE(1173),
    [sym_preproc_define] = STATE(1173),
    [sym_preproc_undef] = STATE(1173),
    [aux_sym_class_declaration_repeat1] = STATE(3855),
    [aux_sym_lambda_expression_repeat1] = STATE(4244),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2031),
    [anon_sym_ref] = ACTIONS(2033),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2037),
    [anon_sym_TILDE] = ACTIONS(2037),
    [anon_sym_PLUS_PLUS] = ACTIONS(2037),
    [anon_sym_DASH_DASH] = ACTIONS(2037),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2035),
    [anon_sym_DASH] = ACTIONS(2035),
    [anon_sym_STAR] = ACTIONS(2039),
    [anon_sym_CARET] = ACTIONS(2037),
    [anon_sym_AMP] = ACTIONS(2037),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2041),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2043),
    [anon_sym_DOT_DOT] = ACTIONS(2045),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1174] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6898),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2940),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6936),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5819),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4318),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7401),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9262),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1174),
    [sym_preproc_endregion] = STATE(1174),
    [sym_preproc_line] = STATE(1174),
    [sym_preproc_pragma] = STATE(1174),
    [sym_preproc_nullable] = STATE(1174),
    [sym_preproc_error] = STATE(1174),
    [sym_preproc_define] = STATE(1174),
    [sym_preproc_undef] = STATE(1174),
    [aux_sym_class_declaration_repeat1] = STATE(3815),
    [aux_sym_lambda_expression_repeat1] = STATE(4072),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1885),
    [anon_sym_ref] = ACTIONS(1887),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1889),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1893),
    [anon_sym_TILDE] = ACTIONS(1893),
    [anon_sym_PLUS_PLUS] = ACTIONS(1893),
    [anon_sym_DASH_DASH] = ACTIONS(1893),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1891),
    [anon_sym_DASH] = ACTIONS(1891),
    [anon_sym_STAR] = ACTIONS(1895),
    [anon_sym_CARET] = ACTIONS(1893),
    [anon_sym_AMP] = ACTIONS(1893),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1897),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1899),
    [anon_sym_DOT_DOT] = ACTIONS(1901),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1175] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6918),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7066),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6092),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4423),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7383),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9203),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1175),
    [sym_preproc_endregion] = STATE(1175),
    [sym_preproc_line] = STATE(1175),
    [sym_preproc_pragma] = STATE(1175),
    [sym_preproc_nullable] = STATE(1175),
    [sym_preproc_error] = STATE(1175),
    [sym_preproc_define] = STATE(1175),
    [sym_preproc_undef] = STATE(1175),
    [aux_sym_class_declaration_repeat1] = STATE(3817),
    [aux_sym_lambda_expression_repeat1] = STATE(4152),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1905),
    [anon_sym_ref] = ACTIONS(1907),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1221),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1911),
    [anon_sym_TILDE] = ACTIONS(1911),
    [anon_sym_PLUS_PLUS] = ACTIONS(1911),
    [anon_sym_DASH_DASH] = ACTIONS(1911),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1909),
    [anon_sym_DASH] = ACTIONS(1909),
    [anon_sym_STAR] = ACTIONS(1913),
    [anon_sym_CARET] = ACTIONS(1911),
    [anon_sym_AMP] = ACTIONS(1911),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1915),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1917),
    [anon_sym_DOT_DOT] = ACTIONS(1919),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1176] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6898),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2940),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6936),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5820),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4318),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7401),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9262),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1176),
    [sym_preproc_endregion] = STATE(1176),
    [sym_preproc_line] = STATE(1176),
    [sym_preproc_pragma] = STATE(1176),
    [sym_preproc_nullable] = STATE(1176),
    [sym_preproc_error] = STATE(1176),
    [sym_preproc_define] = STATE(1176),
    [sym_preproc_undef] = STATE(1176),
    [aux_sym_class_declaration_repeat1] = STATE(3815),
    [aux_sym_lambda_expression_repeat1] = STATE(4072),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1885),
    [anon_sym_ref] = ACTIONS(1887),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1889),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1893),
    [anon_sym_TILDE] = ACTIONS(1893),
    [anon_sym_PLUS_PLUS] = ACTIONS(1893),
    [anon_sym_DASH_DASH] = ACTIONS(1893),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1891),
    [anon_sym_DASH] = ACTIONS(1891),
    [anon_sym_STAR] = ACTIONS(1895),
    [anon_sym_CARET] = ACTIONS(1893),
    [anon_sym_AMP] = ACTIONS(1893),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1897),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1899),
    [anon_sym_DOT_DOT] = ACTIONS(1901),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1177] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6915),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6583),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4477),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9873),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1177),
    [sym_preproc_endregion] = STATE(1177),
    [sym_preproc_line] = STATE(1177),
    [sym_preproc_pragma] = STATE(1177),
    [sym_preproc_nullable] = STATE(1177),
    [sym_preproc_error] = STATE(1177),
    [sym_preproc_define] = STATE(1177),
    [sym_preproc_undef] = STATE(1177),
    [aux_sym_class_declaration_repeat1] = STATE(3845),
    [aux_sym_lambda_expression_repeat1] = STATE(4299),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1979),
    [anon_sym_ref] = ACTIONS(1981),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1985),
    [anon_sym_TILDE] = ACTIONS(1985),
    [anon_sym_PLUS_PLUS] = ACTIONS(1985),
    [anon_sym_DASH_DASH] = ACTIONS(1985),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1983),
    [anon_sym_DASH] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1985),
    [anon_sym_AMP] = ACTIONS(1985),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1987),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1989),
    [anon_sym_DOT_DOT] = ACTIONS(1991),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1178] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6898),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2940),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6936),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5822),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4318),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7401),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9262),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1178),
    [sym_preproc_endregion] = STATE(1178),
    [sym_preproc_line] = STATE(1178),
    [sym_preproc_pragma] = STATE(1178),
    [sym_preproc_nullable] = STATE(1178),
    [sym_preproc_error] = STATE(1178),
    [sym_preproc_define] = STATE(1178),
    [sym_preproc_undef] = STATE(1178),
    [aux_sym_class_declaration_repeat1] = STATE(3815),
    [aux_sym_lambda_expression_repeat1] = STATE(4072),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1885),
    [anon_sym_ref] = ACTIONS(1887),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1889),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1893),
    [anon_sym_TILDE] = ACTIONS(1893),
    [anon_sym_PLUS_PLUS] = ACTIONS(1893),
    [anon_sym_DASH_DASH] = ACTIONS(1893),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1891),
    [anon_sym_DASH] = ACTIONS(1891),
    [anon_sym_STAR] = ACTIONS(1895),
    [anon_sym_CARET] = ACTIONS(1893),
    [anon_sym_AMP] = ACTIONS(1893),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1897),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1899),
    [anon_sym_DOT_DOT] = ACTIONS(1901),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1179] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6898),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2940),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6936),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5851),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4318),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7401),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9262),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1179),
    [sym_preproc_endregion] = STATE(1179),
    [sym_preproc_line] = STATE(1179),
    [sym_preproc_pragma] = STATE(1179),
    [sym_preproc_nullable] = STATE(1179),
    [sym_preproc_error] = STATE(1179),
    [sym_preproc_define] = STATE(1179),
    [sym_preproc_undef] = STATE(1179),
    [aux_sym_class_declaration_repeat1] = STATE(3815),
    [aux_sym_lambda_expression_repeat1] = STATE(4072),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1885),
    [anon_sym_ref] = ACTIONS(1887),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1889),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1893),
    [anon_sym_TILDE] = ACTIONS(1893),
    [anon_sym_PLUS_PLUS] = ACTIONS(1893),
    [anon_sym_DASH_DASH] = ACTIONS(1893),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1891),
    [anon_sym_DASH] = ACTIONS(1891),
    [anon_sym_STAR] = ACTIONS(1895),
    [anon_sym_CARET] = ACTIONS(1893),
    [anon_sym_AMP] = ACTIONS(1893),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1897),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1899),
    [anon_sym_DOT_DOT] = ACTIONS(1901),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1180] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6898),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2940),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6936),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5823),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4318),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7401),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9262),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1180),
    [sym_preproc_endregion] = STATE(1180),
    [sym_preproc_line] = STATE(1180),
    [sym_preproc_pragma] = STATE(1180),
    [sym_preproc_nullable] = STATE(1180),
    [sym_preproc_error] = STATE(1180),
    [sym_preproc_define] = STATE(1180),
    [sym_preproc_undef] = STATE(1180),
    [aux_sym_class_declaration_repeat1] = STATE(3815),
    [aux_sym_lambda_expression_repeat1] = STATE(4072),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1885),
    [anon_sym_ref] = ACTIONS(1887),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1889),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1893),
    [anon_sym_TILDE] = ACTIONS(1893),
    [anon_sym_PLUS_PLUS] = ACTIONS(1893),
    [anon_sym_DASH_DASH] = ACTIONS(1893),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1891),
    [anon_sym_DASH] = ACTIONS(1891),
    [anon_sym_STAR] = ACTIONS(1895),
    [anon_sym_CARET] = ACTIONS(1893),
    [anon_sym_AMP] = ACTIONS(1893),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1897),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1899),
    [anon_sym_DOT_DOT] = ACTIONS(1901),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1181] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6898),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2940),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6936),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5824),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4318),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7401),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9262),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1181),
    [sym_preproc_endregion] = STATE(1181),
    [sym_preproc_line] = STATE(1181),
    [sym_preproc_pragma] = STATE(1181),
    [sym_preproc_nullable] = STATE(1181),
    [sym_preproc_error] = STATE(1181),
    [sym_preproc_define] = STATE(1181),
    [sym_preproc_undef] = STATE(1181),
    [aux_sym_class_declaration_repeat1] = STATE(3815),
    [aux_sym_lambda_expression_repeat1] = STATE(4072),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1885),
    [anon_sym_ref] = ACTIONS(1887),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1889),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1893),
    [anon_sym_TILDE] = ACTIONS(1893),
    [anon_sym_PLUS_PLUS] = ACTIONS(1893),
    [anon_sym_DASH_DASH] = ACTIONS(1893),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1891),
    [anon_sym_DASH] = ACTIONS(1891),
    [anon_sym_STAR] = ACTIONS(1895),
    [anon_sym_CARET] = ACTIONS(1893),
    [anon_sym_AMP] = ACTIONS(1893),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1897),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1899),
    [anon_sym_DOT_DOT] = ACTIONS(1901),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1182] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6884),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6366),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4477),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9873),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1182),
    [sym_preproc_endregion] = STATE(1182),
    [sym_preproc_line] = STATE(1182),
    [sym_preproc_pragma] = STATE(1182),
    [sym_preproc_nullable] = STATE(1182),
    [sym_preproc_error] = STATE(1182),
    [sym_preproc_define] = STATE(1182),
    [sym_preproc_undef] = STATE(1182),
    [aux_sym_class_declaration_repeat1] = STATE(3845),
    [aux_sym_lambda_expression_repeat1] = STATE(4299),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1979),
    [anon_sym_ref] = ACTIONS(1981),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1985),
    [anon_sym_TILDE] = ACTIONS(1985),
    [anon_sym_PLUS_PLUS] = ACTIONS(1985),
    [anon_sym_DASH_DASH] = ACTIONS(1985),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1983),
    [anon_sym_DASH] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1985),
    [anon_sym_AMP] = ACTIONS(1985),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1987),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1989),
    [anon_sym_DOT_DOT] = ACTIONS(1991),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1183] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6918),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7066),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6119),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4423),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7383),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9203),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1183),
    [sym_preproc_endregion] = STATE(1183),
    [sym_preproc_line] = STATE(1183),
    [sym_preproc_pragma] = STATE(1183),
    [sym_preproc_nullable] = STATE(1183),
    [sym_preproc_error] = STATE(1183),
    [sym_preproc_define] = STATE(1183),
    [sym_preproc_undef] = STATE(1183),
    [aux_sym_class_declaration_repeat1] = STATE(3817),
    [aux_sym_lambda_expression_repeat1] = STATE(4152),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1905),
    [anon_sym_ref] = ACTIONS(1907),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1221),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1911),
    [anon_sym_TILDE] = ACTIONS(1911),
    [anon_sym_PLUS_PLUS] = ACTIONS(1911),
    [anon_sym_DASH_DASH] = ACTIONS(1911),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1909),
    [anon_sym_DASH] = ACTIONS(1909),
    [anon_sym_STAR] = ACTIONS(1913),
    [anon_sym_CARET] = ACTIONS(1911),
    [anon_sym_AMP] = ACTIONS(1911),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1915),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1917),
    [anon_sym_DOT_DOT] = ACTIONS(1919),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1184] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6918),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7066),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6117),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4423),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7383),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9203),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1184),
    [sym_preproc_endregion] = STATE(1184),
    [sym_preproc_line] = STATE(1184),
    [sym_preproc_pragma] = STATE(1184),
    [sym_preproc_nullable] = STATE(1184),
    [sym_preproc_error] = STATE(1184),
    [sym_preproc_define] = STATE(1184),
    [sym_preproc_undef] = STATE(1184),
    [aux_sym_class_declaration_repeat1] = STATE(3817),
    [aux_sym_lambda_expression_repeat1] = STATE(4152),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1905),
    [anon_sym_ref] = ACTIONS(1907),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1221),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1911),
    [anon_sym_TILDE] = ACTIONS(1911),
    [anon_sym_PLUS_PLUS] = ACTIONS(1911),
    [anon_sym_DASH_DASH] = ACTIONS(1911),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1909),
    [anon_sym_DASH] = ACTIONS(1909),
    [anon_sym_STAR] = ACTIONS(1913),
    [anon_sym_CARET] = ACTIONS(1911),
    [anon_sym_AMP] = ACTIONS(1911),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1915),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1917),
    [anon_sym_DOT_DOT] = ACTIONS(1919),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1185] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6463),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1185),
    [sym_preproc_endregion] = STATE(1185),
    [sym_preproc_line] = STATE(1185),
    [sym_preproc_pragma] = STATE(1185),
    [sym_preproc_nullable] = STATE(1185),
    [sym_preproc_error] = STATE(1185),
    [sym_preproc_define] = STATE(1185),
    [sym_preproc_undef] = STATE(1185),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1186] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6902),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6484),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4477),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9873),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1186),
    [sym_preproc_endregion] = STATE(1186),
    [sym_preproc_line] = STATE(1186),
    [sym_preproc_pragma] = STATE(1186),
    [sym_preproc_nullable] = STATE(1186),
    [sym_preproc_error] = STATE(1186),
    [sym_preproc_define] = STATE(1186),
    [sym_preproc_undef] = STATE(1186),
    [aux_sym_class_declaration_repeat1] = STATE(3845),
    [aux_sym_lambda_expression_repeat1] = STATE(4299),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1979),
    [anon_sym_ref] = ACTIONS(1981),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1985),
    [anon_sym_TILDE] = ACTIONS(1985),
    [anon_sym_PLUS_PLUS] = ACTIONS(1985),
    [anon_sym_DASH_DASH] = ACTIONS(1985),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1983),
    [anon_sym_DASH] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1985),
    [anon_sym_AMP] = ACTIONS(1985),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1987),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1989),
    [anon_sym_DOT_DOT] = ACTIONS(1991),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1187] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6918),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7066),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(3565),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4423),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7383),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9203),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1187),
    [sym_preproc_endregion] = STATE(1187),
    [sym_preproc_line] = STATE(1187),
    [sym_preproc_pragma] = STATE(1187),
    [sym_preproc_nullable] = STATE(1187),
    [sym_preproc_error] = STATE(1187),
    [sym_preproc_define] = STATE(1187),
    [sym_preproc_undef] = STATE(1187),
    [aux_sym_class_declaration_repeat1] = STATE(3817),
    [aux_sym_lambda_expression_repeat1] = STATE(4152),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1905),
    [anon_sym_ref] = ACTIONS(1907),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1221),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1911),
    [anon_sym_TILDE] = ACTIONS(1911),
    [anon_sym_PLUS_PLUS] = ACTIONS(1911),
    [anon_sym_DASH_DASH] = ACTIONS(1911),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1909),
    [anon_sym_DASH] = ACTIONS(1909),
    [anon_sym_STAR] = ACTIONS(1913),
    [anon_sym_CARET] = ACTIONS(1911),
    [anon_sym_AMP] = ACTIONS(1911),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1915),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1917),
    [anon_sym_DOT_DOT] = ACTIONS(1919),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1188] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6898),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2940),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6925),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6314),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4498),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7403),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(8973),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1188),
    [sym_preproc_endregion] = STATE(1188),
    [sym_preproc_line] = STATE(1188),
    [sym_preproc_pragma] = STATE(1188),
    [sym_preproc_nullable] = STATE(1188),
    [sym_preproc_error] = STATE(1188),
    [sym_preproc_define] = STATE(1188),
    [sym_preproc_undef] = STATE(1188),
    [aux_sym_class_declaration_repeat1] = STATE(3830),
    [aux_sym_lambda_expression_repeat1] = STATE(4194),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2153),
    [anon_sym_ref] = ACTIONS(2155),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2157),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2161),
    [anon_sym_TILDE] = ACTIONS(2161),
    [anon_sym_PLUS_PLUS] = ACTIONS(2161),
    [anon_sym_DASH_DASH] = ACTIONS(2161),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2159),
    [anon_sym_DASH] = ACTIONS(2159),
    [anon_sym_STAR] = ACTIONS(2163),
    [anon_sym_CARET] = ACTIONS(2161),
    [anon_sym_AMP] = ACTIONS(2161),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2165),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2167),
    [anon_sym_DOT_DOT] = ACTIONS(2169),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1189] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6898),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2940),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6936),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5788),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4318),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7401),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9262),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1189),
    [sym_preproc_endregion] = STATE(1189),
    [sym_preproc_line] = STATE(1189),
    [sym_preproc_pragma] = STATE(1189),
    [sym_preproc_nullable] = STATE(1189),
    [sym_preproc_error] = STATE(1189),
    [sym_preproc_define] = STATE(1189),
    [sym_preproc_undef] = STATE(1189),
    [aux_sym_class_declaration_repeat1] = STATE(3815),
    [aux_sym_lambda_expression_repeat1] = STATE(4072),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1885),
    [anon_sym_ref] = ACTIONS(1887),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1889),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1893),
    [anon_sym_TILDE] = ACTIONS(1893),
    [anon_sym_PLUS_PLUS] = ACTIONS(1893),
    [anon_sym_DASH_DASH] = ACTIONS(1893),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1891),
    [anon_sym_DASH] = ACTIONS(1891),
    [anon_sym_STAR] = ACTIONS(1895),
    [anon_sym_CARET] = ACTIONS(1893),
    [anon_sym_AMP] = ACTIONS(1893),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1897),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1899),
    [anon_sym_DOT_DOT] = ACTIONS(1901),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1190] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6898),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2940),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6936),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(3901),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4318),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7401),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9262),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1190),
    [sym_preproc_endregion] = STATE(1190),
    [sym_preproc_line] = STATE(1190),
    [sym_preproc_pragma] = STATE(1190),
    [sym_preproc_nullable] = STATE(1190),
    [sym_preproc_error] = STATE(1190),
    [sym_preproc_define] = STATE(1190),
    [sym_preproc_undef] = STATE(1190),
    [aux_sym_class_declaration_repeat1] = STATE(3815),
    [aux_sym_lambda_expression_repeat1] = STATE(4072),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1885),
    [anon_sym_ref] = ACTIONS(1887),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1889),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1893),
    [anon_sym_TILDE] = ACTIONS(1893),
    [anon_sym_PLUS_PLUS] = ACTIONS(1893),
    [anon_sym_DASH_DASH] = ACTIONS(1893),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1891),
    [anon_sym_DASH] = ACTIONS(1891),
    [anon_sym_STAR] = ACTIONS(1895),
    [anon_sym_CARET] = ACTIONS(1893),
    [anon_sym_AMP] = ACTIONS(1893),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1897),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1899),
    [anon_sym_DOT_DOT] = ACTIONS(1901),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1191] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6914),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2882),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6963),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5278),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4002),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7386),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9254),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1191),
    [sym_preproc_endregion] = STATE(1191),
    [sym_preproc_line] = STATE(1191),
    [sym_preproc_pragma] = STATE(1191),
    [sym_preproc_nullable] = STATE(1191),
    [sym_preproc_error] = STATE(1191),
    [sym_preproc_define] = STATE(1191),
    [sym_preproc_undef] = STATE(1191),
    [aux_sym_class_declaration_repeat1] = STATE(3797),
    [aux_sym_lambda_expression_repeat1] = STATE(4081),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1727),
    [anon_sym_ref] = ACTIONS(1729),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1713),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1733),
    [anon_sym_TILDE] = ACTIONS(1733),
    [anon_sym_PLUS_PLUS] = ACTIONS(1733),
    [anon_sym_DASH_DASH] = ACTIONS(1733),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1731),
    [anon_sym_DASH] = ACTIONS(1731),
    [anon_sym_STAR] = ACTIONS(1735),
    [anon_sym_CARET] = ACTIONS(1733),
    [anon_sym_AMP] = ACTIONS(1733),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1737),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1739),
    [anon_sym_DOT_DOT] = ACTIONS(1741),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1192] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6898),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2940),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6936),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5785),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4318),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7401),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9262),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1192),
    [sym_preproc_endregion] = STATE(1192),
    [sym_preproc_line] = STATE(1192),
    [sym_preproc_pragma] = STATE(1192),
    [sym_preproc_nullable] = STATE(1192),
    [sym_preproc_error] = STATE(1192),
    [sym_preproc_define] = STATE(1192),
    [sym_preproc_undef] = STATE(1192),
    [aux_sym_class_declaration_repeat1] = STATE(3815),
    [aux_sym_lambda_expression_repeat1] = STATE(4072),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1885),
    [anon_sym_ref] = ACTIONS(1887),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1889),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1893),
    [anon_sym_TILDE] = ACTIONS(1893),
    [anon_sym_PLUS_PLUS] = ACTIONS(1893),
    [anon_sym_DASH_DASH] = ACTIONS(1893),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1891),
    [anon_sym_DASH] = ACTIONS(1891),
    [anon_sym_STAR] = ACTIONS(1895),
    [anon_sym_CARET] = ACTIONS(1893),
    [anon_sym_AMP] = ACTIONS(1893),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1897),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1899),
    [anon_sym_DOT_DOT] = ACTIONS(1901),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1193] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3559),
    [sym__name] = STATE(6878),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2911),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6938),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4421),
    [sym_non_lvalue_expression] = STATE(4553),
    [sym_lvalue_expression] = STATE(3750),
    [sym__expression_statement_expression] = STATE(4559),
    [sym_assignment_expression] = STATE(4558),
    [sym_binary_expression] = STATE(4559),
    [sym_postfix_unary_expression] = STATE(4558),
    [sym_prefix_unary_expression] = STATE(4558),
    [sym__pointer_indirection_expression] = STATE(3560),
    [sym_query_expression] = STATE(4559),
    [sym_from_clause] = STATE(7406),
    [sym_conditional_expression] = STATE(4559),
    [sym_conditional_access_expression] = STATE(4559),
    [sym_as_expression] = STATE(4559),
    [sym_is_expression] = STATE(4559),
    [sym_is_pattern_expression] = STATE(4559),
    [sym_cast_expression] = STATE(4559),
    [sym_checked_expression] = STATE(4559),
    [sym_invocation_expression] = STATE(4558),
    [sym_switch_expression] = STATE(4559),
    [sym_await_expression] = STATE(4558),
    [sym_throw_expression] = STATE(4559),
    [sym_element_access_expression] = STATE(3560),
    [sym_interpolated_string_expression] = STATE(4559),
    [sym_member_access_expression] = STATE(3560),
    [sym_object_creation_expression] = STATE(4558),
    [sym_parenthesized_expression] = STATE(4558),
    [sym__parenthesized_lvalue_expression] = STATE(3560),
    [sym_lambda_expression] = STATE(4559),
    [sym__lambda_parameters] = STATE(9691),
    [sym_array_creation_expression] = STATE(4559),
    [sym_anonymous_method_expression] = STATE(4559),
    [sym_anonymous_object_creation_expression] = STATE(4559),
    [sym_implicit_array_creation_expression] = STATE(4559),
    [sym_implicit_object_creation_expression] = STATE(4559),
    [sym_implicit_stackalloc_expression] = STATE(4559),
    [sym_initializer_expression] = STATE(4559),
    [sym_default_expression] = STATE(4559),
    [sym_with_expression] = STATE(4559),
    [sym_sizeof_expression] = STATE(4559),
    [sym_typeof_expression] = STATE(4559),
    [sym_makeref_expression] = STATE(4559),
    [sym_ref_expression] = STATE(4559),
    [sym_reftype_expression] = STATE(4559),
    [sym_refvalue_expression] = STATE(4559),
    [sym_stackalloc_expression] = STATE(4559),
    [sym_range_expression] = STATE(4559),
    [sym_tuple_expression] = STATE(3560),
    [sym_literal] = STATE(4559),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4559),
    [sym_preproc_region] = STATE(1193),
    [sym_preproc_endregion] = STATE(1193),
    [sym_preproc_line] = STATE(1193),
    [sym_preproc_pragma] = STATE(1193),
    [sym_preproc_nullable] = STATE(1193),
    [sym_preproc_error] = STATE(1193),
    [sym_preproc_define] = STATE(1193),
    [sym_preproc_undef] = STATE(1193),
    [aux_sym_class_declaration_repeat1] = STATE(3836),
    [aux_sym_lambda_expression_repeat1] = STATE(4216),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(2003),
    [anon_sym_ref] = ACTIONS(2005),
    [anon_sym_LBRACE] = ACTIONS(1611),
    [anon_sym_delegate] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1615),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(2009),
    [anon_sym_TILDE] = ACTIONS(2009),
    [anon_sym_PLUS_PLUS] = ACTIONS(2009),
    [anon_sym_DASH_DASH] = ACTIONS(2009),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(2007),
    [anon_sym_DASH] = ACTIONS(2007),
    [anon_sym_STAR] = ACTIONS(1625),
    [anon_sym_CARET] = ACTIONS(2009),
    [anon_sym_AMP] = ACTIONS(2009),
    [anon_sym_this] = ACTIONS(1627),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1629),
    [anon_sym_unchecked] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(2011),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2013),
    [anon_sym_DOT_DOT] = ACTIONS(2015),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_stackalloc] = ACTIONS(1641),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(1647),
    [anon_sym___reftype] = ACTIONS(1649),
    [anon_sym___refvalue] = ACTIONS(1651),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1659),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [1194] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6898),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2940),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6925),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6303),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4498),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7403),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(8973),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1194),
    [sym_preproc_endregion] = STATE(1194),
    [sym_preproc_line] = STATE(1194),
    [sym_preproc_pragma] = STATE(1194),
    [sym_preproc_nullable] = STATE(1194),
    [sym_preproc_error] = STATE(1194),
    [sym_preproc_define] = STATE(1194),
    [sym_preproc_undef] = STATE(1194),
    [aux_sym_class_declaration_repeat1] = STATE(3830),
    [aux_sym_lambda_expression_repeat1] = STATE(4194),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2153),
    [anon_sym_ref] = ACTIONS(2155),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2157),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2161),
    [anon_sym_TILDE] = ACTIONS(2161),
    [anon_sym_PLUS_PLUS] = ACTIONS(2161),
    [anon_sym_DASH_DASH] = ACTIONS(2161),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2159),
    [anon_sym_DASH] = ACTIONS(2159),
    [anon_sym_STAR] = ACTIONS(2163),
    [anon_sym_CARET] = ACTIONS(2161),
    [anon_sym_AMP] = ACTIONS(2161),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2165),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2167),
    [anon_sym_DOT_DOT] = ACTIONS(2169),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1195] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6898),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2940),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6936),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5778),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4318),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7401),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9262),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1195),
    [sym_preproc_endregion] = STATE(1195),
    [sym_preproc_line] = STATE(1195),
    [sym_preproc_pragma] = STATE(1195),
    [sym_preproc_nullable] = STATE(1195),
    [sym_preproc_error] = STATE(1195),
    [sym_preproc_define] = STATE(1195),
    [sym_preproc_undef] = STATE(1195),
    [aux_sym_class_declaration_repeat1] = STATE(3815),
    [aux_sym_lambda_expression_repeat1] = STATE(4072),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1885),
    [anon_sym_ref] = ACTIONS(1887),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1889),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1893),
    [anon_sym_TILDE] = ACTIONS(1893),
    [anon_sym_PLUS_PLUS] = ACTIONS(1893),
    [anon_sym_DASH_DASH] = ACTIONS(1893),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1891),
    [anon_sym_DASH] = ACTIONS(1891),
    [anon_sym_STAR] = ACTIONS(1895),
    [anon_sym_CARET] = ACTIONS(1893),
    [anon_sym_AMP] = ACTIONS(1893),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1897),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1899),
    [anon_sym_DOT_DOT] = ACTIONS(1901),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1196] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6898),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2940),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6925),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6289),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4498),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7403),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(8973),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1196),
    [sym_preproc_endregion] = STATE(1196),
    [sym_preproc_line] = STATE(1196),
    [sym_preproc_pragma] = STATE(1196),
    [sym_preproc_nullable] = STATE(1196),
    [sym_preproc_error] = STATE(1196),
    [sym_preproc_define] = STATE(1196),
    [sym_preproc_undef] = STATE(1196),
    [aux_sym_class_declaration_repeat1] = STATE(3830),
    [aux_sym_lambda_expression_repeat1] = STATE(4194),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2153),
    [anon_sym_ref] = ACTIONS(2155),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2157),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2161),
    [anon_sym_TILDE] = ACTIONS(2161),
    [anon_sym_PLUS_PLUS] = ACTIONS(2161),
    [anon_sym_DASH_DASH] = ACTIONS(2161),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2159),
    [anon_sym_DASH] = ACTIONS(2159),
    [anon_sym_STAR] = ACTIONS(2163),
    [anon_sym_CARET] = ACTIONS(2161),
    [anon_sym_AMP] = ACTIONS(2161),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2165),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2167),
    [anon_sym_DOT_DOT] = ACTIONS(2169),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1197] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6880),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7072),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5724),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4210),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9027),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1197),
    [sym_preproc_endregion] = STATE(1197),
    [sym_preproc_line] = STATE(1197),
    [sym_preproc_pragma] = STATE(1197),
    [sym_preproc_nullable] = STATE(1197),
    [sym_preproc_error] = STATE(1197),
    [sym_preproc_define] = STATE(1197),
    [sym_preproc_undef] = STATE(1197),
    [aux_sym_class_declaration_repeat1] = STATE(3852),
    [aux_sym_lambda_expression_repeat1] = STATE(4220),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1473),
    [anon_sym_ref] = ACTIONS(1475),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(1479),
    [anon_sym_PLUS_PLUS] = ACTIONS(1479),
    [anon_sym_DASH_DASH] = ACTIONS(1479),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1477),
    [anon_sym_DASH] = ACTIONS(1477),
    [anon_sym_STAR] = ACTIONS(1101),
    [anon_sym_CARET] = ACTIONS(1479),
    [anon_sym_AMP] = ACTIONS(1479),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1111),
    [anon_sym_DOT_DOT] = ACTIONS(1115),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1198] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6898),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2940),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6925),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6300),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4498),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7403),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(8973),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1198),
    [sym_preproc_endregion] = STATE(1198),
    [sym_preproc_line] = STATE(1198),
    [sym_preproc_pragma] = STATE(1198),
    [sym_preproc_nullable] = STATE(1198),
    [sym_preproc_error] = STATE(1198),
    [sym_preproc_define] = STATE(1198),
    [sym_preproc_undef] = STATE(1198),
    [aux_sym_class_declaration_repeat1] = STATE(3830),
    [aux_sym_lambda_expression_repeat1] = STATE(4194),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2153),
    [anon_sym_ref] = ACTIONS(2155),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2157),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2161),
    [anon_sym_TILDE] = ACTIONS(2161),
    [anon_sym_PLUS_PLUS] = ACTIONS(2161),
    [anon_sym_DASH_DASH] = ACTIONS(2161),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2159),
    [anon_sym_DASH] = ACTIONS(2159),
    [anon_sym_STAR] = ACTIONS(2163),
    [anon_sym_CARET] = ACTIONS(2161),
    [anon_sym_AMP] = ACTIONS(2161),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2165),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2167),
    [anon_sym_DOT_DOT] = ACTIONS(2169),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1199] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6961),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4308),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9849),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1199),
    [sym_preproc_endregion] = STATE(1199),
    [sym_preproc_line] = STATE(1199),
    [sym_preproc_pragma] = STATE(1199),
    [sym_preproc_nullable] = STATE(1199),
    [sym_preproc_error] = STATE(1199),
    [sym_preproc_define] = STATE(1199),
    [sym_preproc_undef] = STATE(1199),
    [aux_sym_class_declaration_repeat1] = STATE(3841),
    [aux_sym_lambda_expression_repeat1] = STATE(4283),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1459),
    [anon_sym_ref] = ACTIONS(1461),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1465),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1467),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1469),
    [anon_sym_DOT_DOT] = ACTIONS(1471),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1200] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6898),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2940),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6925),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6311),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4498),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7403),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(8973),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1200),
    [sym_preproc_endregion] = STATE(1200),
    [sym_preproc_line] = STATE(1200),
    [sym_preproc_pragma] = STATE(1200),
    [sym_preproc_nullable] = STATE(1200),
    [sym_preproc_error] = STATE(1200),
    [sym_preproc_define] = STATE(1200),
    [sym_preproc_undef] = STATE(1200),
    [aux_sym_class_declaration_repeat1] = STATE(3830),
    [aux_sym_lambda_expression_repeat1] = STATE(4194),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2153),
    [anon_sym_ref] = ACTIONS(2155),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2157),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2161),
    [anon_sym_TILDE] = ACTIONS(2161),
    [anon_sym_PLUS_PLUS] = ACTIONS(2161),
    [anon_sym_DASH_DASH] = ACTIONS(2161),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2159),
    [anon_sym_DASH] = ACTIONS(2159),
    [anon_sym_STAR] = ACTIONS(2163),
    [anon_sym_CARET] = ACTIONS(2161),
    [anon_sym_AMP] = ACTIONS(2161),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2165),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2167),
    [anon_sym_DOT_DOT] = ACTIONS(2169),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1201] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6918),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7126),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4724),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(3736),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7377),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9441),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1201),
    [sym_preproc_endregion] = STATE(1201),
    [sym_preproc_line] = STATE(1201),
    [sym_preproc_pragma] = STATE(1201),
    [sym_preproc_nullable] = STATE(1201),
    [sym_preproc_error] = STATE(1201),
    [sym_preproc_define] = STATE(1201),
    [sym_preproc_undef] = STATE(1201),
    [aux_sym_class_declaration_repeat1] = STATE(3848),
    [aux_sym_lambda_expression_repeat1] = STATE(4242),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1213),
    [anon_sym_ref] = ACTIONS(1215),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1221),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1227),
    [anon_sym_TILDE] = ACTIONS(1227),
    [anon_sym_PLUS_PLUS] = ACTIONS(1227),
    [anon_sym_DASH_DASH] = ACTIONS(1227),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1225),
    [anon_sym_DASH] = ACTIONS(1225),
    [anon_sym_STAR] = ACTIONS(1231),
    [anon_sym_CARET] = ACTIONS(1227),
    [anon_sym_AMP] = ACTIONS(1227),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1239),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1241),
    [anon_sym_DOT_DOT] = ACTIONS(1243),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1202] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7094),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(3014),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1202),
    [sym_preproc_endregion] = STATE(1202),
    [sym_preproc_line] = STATE(1202),
    [sym_preproc_pragma] = STATE(1202),
    [sym_preproc_nullable] = STATE(1202),
    [sym_preproc_error] = STATE(1202),
    [sym_preproc_define] = STATE(1202),
    [sym_preproc_undef] = STATE(1202),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1669),
    [anon_sym_TILDE] = ACTIONS(1669),
    [anon_sym_PLUS_PLUS] = ACTIONS(1669),
    [anon_sym_DASH_DASH] = ACTIONS(1669),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1667),
    [anon_sym_DASH] = ACTIONS(1667),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1669),
    [anon_sym_AMP] = ACTIONS(1669),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1203] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6880),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7104),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5142),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(3863),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7380),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9420),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1203),
    [sym_preproc_endregion] = STATE(1203),
    [sym_preproc_line] = STATE(1203),
    [sym_preproc_pragma] = STATE(1203),
    [sym_preproc_nullable] = STATE(1203),
    [sym_preproc_error] = STATE(1203),
    [sym_preproc_define] = STATE(1203),
    [sym_preproc_undef] = STATE(1203),
    [aux_sym_class_declaration_repeat1] = STATE(3820),
    [aux_sym_lambda_expression_repeat1] = STATE(4165),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1339),
    [anon_sym_ref] = ACTIONS(1341),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1097),
    [anon_sym_TILDE] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1099),
    [anon_sym_DASH] = ACTIONS(1099),
    [anon_sym_STAR] = ACTIONS(1343),
    [anon_sym_CARET] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1097),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1345),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1347),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1204] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6874),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2968),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6941),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5619),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4214),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7412),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9154),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1204),
    [sym_preproc_endregion] = STATE(1204),
    [sym_preproc_line] = STATE(1204),
    [sym_preproc_pragma] = STATE(1204),
    [sym_preproc_nullable] = STATE(1204),
    [sym_preproc_error] = STATE(1204),
    [sym_preproc_define] = STATE(1204),
    [sym_preproc_undef] = STATE(1204),
    [aux_sym_class_declaration_repeat1] = STATE(3798),
    [aux_sym_lambda_expression_repeat1] = STATE(4162),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1777),
    [anon_sym_ref] = ACTIONS(1779),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1781),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1785),
    [anon_sym_TILDE] = ACTIONS(1785),
    [anon_sym_PLUS_PLUS] = ACTIONS(1785),
    [anon_sym_DASH_DASH] = ACTIONS(1785),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_STAR] = ACTIONS(1787),
    [anon_sym_CARET] = ACTIONS(1785),
    [anon_sym_AMP] = ACTIONS(1785),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1789),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1791),
    [anon_sym_DOT_DOT] = ACTIONS(1793),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1205] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6874),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2968),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6941),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(3822),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4214),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7412),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9154),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1205),
    [sym_preproc_endregion] = STATE(1205),
    [sym_preproc_line] = STATE(1205),
    [sym_preproc_pragma] = STATE(1205),
    [sym_preproc_nullable] = STATE(1205),
    [sym_preproc_error] = STATE(1205),
    [sym_preproc_define] = STATE(1205),
    [sym_preproc_undef] = STATE(1205),
    [aux_sym_class_declaration_repeat1] = STATE(3798),
    [aux_sym_lambda_expression_repeat1] = STATE(4162),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1777),
    [anon_sym_ref] = ACTIONS(1779),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1781),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1785),
    [anon_sym_TILDE] = ACTIONS(1785),
    [anon_sym_PLUS_PLUS] = ACTIONS(1785),
    [anon_sym_DASH_DASH] = ACTIONS(1785),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_STAR] = ACTIONS(1787),
    [anon_sym_CARET] = ACTIONS(1785),
    [anon_sym_AMP] = ACTIONS(1785),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1789),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1791),
    [anon_sym_DOT_DOT] = ACTIONS(1793),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1206] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6880),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7072),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4309),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4210),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9027),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1206),
    [sym_preproc_endregion] = STATE(1206),
    [sym_preproc_line] = STATE(1206),
    [sym_preproc_pragma] = STATE(1206),
    [sym_preproc_nullable] = STATE(1206),
    [sym_preproc_error] = STATE(1206),
    [sym_preproc_define] = STATE(1206),
    [sym_preproc_undef] = STATE(1206),
    [aux_sym_class_declaration_repeat1] = STATE(3852),
    [aux_sym_lambda_expression_repeat1] = STATE(4220),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1473),
    [anon_sym_ref] = ACTIONS(1475),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(1479),
    [anon_sym_PLUS_PLUS] = ACTIONS(1479),
    [anon_sym_DASH_DASH] = ACTIONS(1479),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1477),
    [anon_sym_DASH] = ACTIONS(1477),
    [anon_sym_STAR] = ACTIONS(1101),
    [anon_sym_CARET] = ACTIONS(1479),
    [anon_sym_AMP] = ACTIONS(1479),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1111),
    [anon_sym_DOT_DOT] = ACTIONS(1115),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1207] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6874),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2968),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6941),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5743),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4214),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7412),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9154),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1207),
    [sym_preproc_endregion] = STATE(1207),
    [sym_preproc_line] = STATE(1207),
    [sym_preproc_pragma] = STATE(1207),
    [sym_preproc_nullable] = STATE(1207),
    [sym_preproc_error] = STATE(1207),
    [sym_preproc_define] = STATE(1207),
    [sym_preproc_undef] = STATE(1207),
    [aux_sym_class_declaration_repeat1] = STATE(3798),
    [aux_sym_lambda_expression_repeat1] = STATE(4162),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1777),
    [anon_sym_ref] = ACTIONS(1779),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1781),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1785),
    [anon_sym_TILDE] = ACTIONS(1785),
    [anon_sym_PLUS_PLUS] = ACTIONS(1785),
    [anon_sym_DASH_DASH] = ACTIONS(1785),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_STAR] = ACTIONS(1787),
    [anon_sym_CARET] = ACTIONS(1785),
    [anon_sym_AMP] = ACTIONS(1785),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1789),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1791),
    [anon_sym_DOT_DOT] = ACTIONS(1793),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1208] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6914),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2882),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6963),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5300),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4002),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7386),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9254),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1208),
    [sym_preproc_endregion] = STATE(1208),
    [sym_preproc_line] = STATE(1208),
    [sym_preproc_pragma] = STATE(1208),
    [sym_preproc_nullable] = STATE(1208),
    [sym_preproc_error] = STATE(1208),
    [sym_preproc_define] = STATE(1208),
    [sym_preproc_undef] = STATE(1208),
    [aux_sym_class_declaration_repeat1] = STATE(3797),
    [aux_sym_lambda_expression_repeat1] = STATE(4081),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1727),
    [anon_sym_ref] = ACTIONS(1729),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1713),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1733),
    [anon_sym_TILDE] = ACTIONS(1733),
    [anon_sym_PLUS_PLUS] = ACTIONS(1733),
    [anon_sym_DASH_DASH] = ACTIONS(1733),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1731),
    [anon_sym_DASH] = ACTIONS(1731),
    [anon_sym_STAR] = ACTIONS(1735),
    [anon_sym_CARET] = ACTIONS(1733),
    [anon_sym_AMP] = ACTIONS(1733),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1737),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1739),
    [anon_sym_DOT_DOT] = ACTIONS(1741),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1209] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6880),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7072),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5449),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4210),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9027),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1209),
    [sym_preproc_endregion] = STATE(1209),
    [sym_preproc_line] = STATE(1209),
    [sym_preproc_pragma] = STATE(1209),
    [sym_preproc_nullable] = STATE(1209),
    [sym_preproc_error] = STATE(1209),
    [sym_preproc_define] = STATE(1209),
    [sym_preproc_undef] = STATE(1209),
    [aux_sym_class_declaration_repeat1] = STATE(3852),
    [aux_sym_lambda_expression_repeat1] = STATE(4220),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1473),
    [anon_sym_ref] = ACTIONS(1475),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(1479),
    [anon_sym_PLUS_PLUS] = ACTIONS(1479),
    [anon_sym_DASH_DASH] = ACTIONS(1479),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1477),
    [anon_sym_DASH] = ACTIONS(1477),
    [anon_sym_STAR] = ACTIONS(1101),
    [anon_sym_CARET] = ACTIONS(1479),
    [anon_sym_AMP] = ACTIONS(1479),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1111),
    [anon_sym_DOT_DOT] = ACTIONS(1115),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1210] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6244),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1210),
    [sym_preproc_endregion] = STATE(1210),
    [sym_preproc_line] = STATE(1210),
    [sym_preproc_pragma] = STATE(1210),
    [sym_preproc_nullable] = STATE(1210),
    [sym_preproc_error] = STATE(1210),
    [sym_preproc_define] = STATE(1210),
    [sym_preproc_undef] = STATE(1210),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1211] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6881),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2964),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6972),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6347),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4495),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7398),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9102),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1211),
    [sym_preproc_endregion] = STATE(1211),
    [sym_preproc_line] = STATE(1211),
    [sym_preproc_pragma] = STATE(1211),
    [sym_preproc_nullable] = STATE(1211),
    [sym_preproc_error] = STATE(1211),
    [sym_preproc_define] = STATE(1211),
    [sym_preproc_undef] = STATE(1211),
    [aux_sym_class_declaration_repeat1] = STATE(3857),
    [aux_sym_lambda_expression_repeat1] = STATE(4241),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2097),
    [anon_sym_ref] = ACTIONS(2099),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2101),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2105),
    [anon_sym_TILDE] = ACTIONS(2105),
    [anon_sym_PLUS_PLUS] = ACTIONS(2105),
    [anon_sym_DASH_DASH] = ACTIONS(2105),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2103),
    [anon_sym_DASH] = ACTIONS(2103),
    [anon_sym_STAR] = ACTIONS(2107),
    [anon_sym_CARET] = ACTIONS(2105),
    [anon_sym_AMP] = ACTIONS(2105),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2111),
    [anon_sym_DOT_DOT] = ACTIONS(2113),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1212] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6874),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2968),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6941),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5744),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4214),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7412),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9154),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1212),
    [sym_preproc_endregion] = STATE(1212),
    [sym_preproc_line] = STATE(1212),
    [sym_preproc_pragma] = STATE(1212),
    [sym_preproc_nullable] = STATE(1212),
    [sym_preproc_error] = STATE(1212),
    [sym_preproc_define] = STATE(1212),
    [sym_preproc_undef] = STATE(1212),
    [aux_sym_class_declaration_repeat1] = STATE(3798),
    [aux_sym_lambda_expression_repeat1] = STATE(4162),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1777),
    [anon_sym_ref] = ACTIONS(1779),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1781),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1785),
    [anon_sym_TILDE] = ACTIONS(1785),
    [anon_sym_PLUS_PLUS] = ACTIONS(1785),
    [anon_sym_DASH_DASH] = ACTIONS(1785),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_STAR] = ACTIONS(1787),
    [anon_sym_CARET] = ACTIONS(1785),
    [anon_sym_AMP] = ACTIONS(1785),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1789),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1791),
    [anon_sym_DOT_DOT] = ACTIONS(1793),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1213] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6880),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7072),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5715),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4210),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9027),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1213),
    [sym_preproc_endregion] = STATE(1213),
    [sym_preproc_line] = STATE(1213),
    [sym_preproc_pragma] = STATE(1213),
    [sym_preproc_nullable] = STATE(1213),
    [sym_preproc_error] = STATE(1213),
    [sym_preproc_define] = STATE(1213),
    [sym_preproc_undef] = STATE(1213),
    [aux_sym_class_declaration_repeat1] = STATE(3852),
    [aux_sym_lambda_expression_repeat1] = STATE(4220),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1473),
    [anon_sym_ref] = ACTIONS(1475),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(1479),
    [anon_sym_PLUS_PLUS] = ACTIONS(1479),
    [anon_sym_DASH_DASH] = ACTIONS(1479),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1477),
    [anon_sym_DASH] = ACTIONS(1477),
    [anon_sym_STAR] = ACTIONS(1101),
    [anon_sym_CARET] = ACTIONS(1479),
    [anon_sym_AMP] = ACTIONS(1479),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1111),
    [anon_sym_DOT_DOT] = ACTIONS(1115),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1214] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6880),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7072),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5713),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4210),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9027),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1214),
    [sym_preproc_endregion] = STATE(1214),
    [sym_preproc_line] = STATE(1214),
    [sym_preproc_pragma] = STATE(1214),
    [sym_preproc_nullable] = STATE(1214),
    [sym_preproc_error] = STATE(1214),
    [sym_preproc_define] = STATE(1214),
    [sym_preproc_undef] = STATE(1214),
    [aux_sym_class_declaration_repeat1] = STATE(3852),
    [aux_sym_lambda_expression_repeat1] = STATE(4220),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1473),
    [anon_sym_ref] = ACTIONS(1475),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(1479),
    [anon_sym_PLUS_PLUS] = ACTIONS(1479),
    [anon_sym_DASH_DASH] = ACTIONS(1479),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1477),
    [anon_sym_DASH] = ACTIONS(1477),
    [anon_sym_STAR] = ACTIONS(1101),
    [anon_sym_CARET] = ACTIONS(1479),
    [anon_sym_AMP] = ACTIONS(1479),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1111),
    [anon_sym_DOT_DOT] = ACTIONS(1115),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1215] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6880),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7072),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5712),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4210),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9027),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1215),
    [sym_preproc_endregion] = STATE(1215),
    [sym_preproc_line] = STATE(1215),
    [sym_preproc_pragma] = STATE(1215),
    [sym_preproc_nullable] = STATE(1215),
    [sym_preproc_error] = STATE(1215),
    [sym_preproc_define] = STATE(1215),
    [sym_preproc_undef] = STATE(1215),
    [aux_sym_class_declaration_repeat1] = STATE(3852),
    [aux_sym_lambda_expression_repeat1] = STATE(4220),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1473),
    [anon_sym_ref] = ACTIONS(1475),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(1479),
    [anon_sym_PLUS_PLUS] = ACTIONS(1479),
    [anon_sym_DASH_DASH] = ACTIONS(1479),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1477),
    [anon_sym_DASH] = ACTIONS(1477),
    [anon_sym_STAR] = ACTIONS(1101),
    [anon_sym_CARET] = ACTIONS(1479),
    [anon_sym_AMP] = ACTIONS(1479),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1111),
    [anon_sym_DOT_DOT] = ACTIONS(1115),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1216] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6874),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2968),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6941),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5684),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4214),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7412),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9154),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1216),
    [sym_preproc_endregion] = STATE(1216),
    [sym_preproc_line] = STATE(1216),
    [sym_preproc_pragma] = STATE(1216),
    [sym_preproc_nullable] = STATE(1216),
    [sym_preproc_error] = STATE(1216),
    [sym_preproc_define] = STATE(1216),
    [sym_preproc_undef] = STATE(1216),
    [aux_sym_class_declaration_repeat1] = STATE(3798),
    [aux_sym_lambda_expression_repeat1] = STATE(4162),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1777),
    [anon_sym_ref] = ACTIONS(1779),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1781),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1785),
    [anon_sym_TILDE] = ACTIONS(1785),
    [anon_sym_PLUS_PLUS] = ACTIONS(1785),
    [anon_sym_DASH_DASH] = ACTIONS(1785),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_STAR] = ACTIONS(1787),
    [anon_sym_CARET] = ACTIONS(1785),
    [anon_sym_AMP] = ACTIONS(1785),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1789),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1791),
    [anon_sym_DOT_DOT] = ACTIONS(1793),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1217] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6880),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7072),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5704),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4210),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9027),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1217),
    [sym_preproc_endregion] = STATE(1217),
    [sym_preproc_line] = STATE(1217),
    [sym_preproc_pragma] = STATE(1217),
    [sym_preproc_nullable] = STATE(1217),
    [sym_preproc_error] = STATE(1217),
    [sym_preproc_define] = STATE(1217),
    [sym_preproc_undef] = STATE(1217),
    [aux_sym_class_declaration_repeat1] = STATE(3852),
    [aux_sym_lambda_expression_repeat1] = STATE(4220),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1473),
    [anon_sym_ref] = ACTIONS(1475),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(1479),
    [anon_sym_PLUS_PLUS] = ACTIONS(1479),
    [anon_sym_DASH_DASH] = ACTIONS(1479),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1477),
    [anon_sym_DASH] = ACTIONS(1477),
    [anon_sym_STAR] = ACTIONS(1101),
    [anon_sym_CARET] = ACTIONS(1479),
    [anon_sym_AMP] = ACTIONS(1479),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1111),
    [anon_sym_DOT_DOT] = ACTIONS(1115),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1218] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6880),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7072),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5699),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4210),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9027),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1218),
    [sym_preproc_endregion] = STATE(1218),
    [sym_preproc_line] = STATE(1218),
    [sym_preproc_pragma] = STATE(1218),
    [sym_preproc_nullable] = STATE(1218),
    [sym_preproc_error] = STATE(1218),
    [sym_preproc_define] = STATE(1218),
    [sym_preproc_undef] = STATE(1218),
    [aux_sym_class_declaration_repeat1] = STATE(3852),
    [aux_sym_lambda_expression_repeat1] = STATE(4220),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1473),
    [anon_sym_ref] = ACTIONS(1475),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(1479),
    [anon_sym_PLUS_PLUS] = ACTIONS(1479),
    [anon_sym_DASH_DASH] = ACTIONS(1479),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1477),
    [anon_sym_DASH] = ACTIONS(1477),
    [anon_sym_STAR] = ACTIONS(1101),
    [anon_sym_CARET] = ACTIONS(1479),
    [anon_sym_AMP] = ACTIONS(1479),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1111),
    [anon_sym_DOT_DOT] = ACTIONS(1115),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1219] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6880),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7072),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5696),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4210),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9027),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1219),
    [sym_preproc_endregion] = STATE(1219),
    [sym_preproc_line] = STATE(1219),
    [sym_preproc_pragma] = STATE(1219),
    [sym_preproc_nullable] = STATE(1219),
    [sym_preproc_error] = STATE(1219),
    [sym_preproc_define] = STATE(1219),
    [sym_preproc_undef] = STATE(1219),
    [aux_sym_class_declaration_repeat1] = STATE(3852),
    [aux_sym_lambda_expression_repeat1] = STATE(4220),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1473),
    [anon_sym_ref] = ACTIONS(1475),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(1479),
    [anon_sym_PLUS_PLUS] = ACTIONS(1479),
    [anon_sym_DASH_DASH] = ACTIONS(1479),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1477),
    [anon_sym_DASH] = ACTIONS(1477),
    [anon_sym_STAR] = ACTIONS(1101),
    [anon_sym_CARET] = ACTIONS(1479),
    [anon_sym_AMP] = ACTIONS(1479),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1111),
    [anon_sym_DOT_DOT] = ACTIONS(1115),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1220] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6880),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7072),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5695),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4210),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9027),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1220),
    [sym_preproc_endregion] = STATE(1220),
    [sym_preproc_line] = STATE(1220),
    [sym_preproc_pragma] = STATE(1220),
    [sym_preproc_nullable] = STATE(1220),
    [sym_preproc_error] = STATE(1220),
    [sym_preproc_define] = STATE(1220),
    [sym_preproc_undef] = STATE(1220),
    [aux_sym_class_declaration_repeat1] = STATE(3852),
    [aux_sym_lambda_expression_repeat1] = STATE(4220),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1473),
    [anon_sym_ref] = ACTIONS(1475),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(1479),
    [anon_sym_PLUS_PLUS] = ACTIONS(1479),
    [anon_sym_DASH_DASH] = ACTIONS(1479),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1477),
    [anon_sym_DASH] = ACTIONS(1477),
    [anon_sym_STAR] = ACTIONS(1101),
    [anon_sym_CARET] = ACTIONS(1479),
    [anon_sym_AMP] = ACTIONS(1479),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1111),
    [anon_sym_DOT_DOT] = ACTIONS(1115),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1221] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6880),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7072),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5691),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4210),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9027),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1221),
    [sym_preproc_endregion] = STATE(1221),
    [sym_preproc_line] = STATE(1221),
    [sym_preproc_pragma] = STATE(1221),
    [sym_preproc_nullable] = STATE(1221),
    [sym_preproc_error] = STATE(1221),
    [sym_preproc_define] = STATE(1221),
    [sym_preproc_undef] = STATE(1221),
    [aux_sym_class_declaration_repeat1] = STATE(3852),
    [aux_sym_lambda_expression_repeat1] = STATE(4220),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1473),
    [anon_sym_ref] = ACTIONS(1475),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(1479),
    [anon_sym_PLUS_PLUS] = ACTIONS(1479),
    [anon_sym_DASH_DASH] = ACTIONS(1479),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1477),
    [anon_sym_DASH] = ACTIONS(1477),
    [anon_sym_STAR] = ACTIONS(1101),
    [anon_sym_CARET] = ACTIONS(1479),
    [anon_sym_AMP] = ACTIONS(1479),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1111),
    [anon_sym_DOT_DOT] = ACTIONS(1115),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1222] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6880),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7072),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5688),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4210),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9027),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1222),
    [sym_preproc_endregion] = STATE(1222),
    [sym_preproc_line] = STATE(1222),
    [sym_preproc_pragma] = STATE(1222),
    [sym_preproc_nullable] = STATE(1222),
    [sym_preproc_error] = STATE(1222),
    [sym_preproc_define] = STATE(1222),
    [sym_preproc_undef] = STATE(1222),
    [aux_sym_class_declaration_repeat1] = STATE(3852),
    [aux_sym_lambda_expression_repeat1] = STATE(4220),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1473),
    [anon_sym_ref] = ACTIONS(1475),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(1479),
    [anon_sym_PLUS_PLUS] = ACTIONS(1479),
    [anon_sym_DASH_DASH] = ACTIONS(1479),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1477),
    [anon_sym_DASH] = ACTIONS(1477),
    [anon_sym_STAR] = ACTIONS(1101),
    [anon_sym_CARET] = ACTIONS(1479),
    [anon_sym_AMP] = ACTIONS(1479),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1111),
    [anon_sym_DOT_DOT] = ACTIONS(1115),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1223] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3559),
    [sym__name] = STATE(6878),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2911),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6938),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4872),
    [sym_non_lvalue_expression] = STATE(4553),
    [sym_lvalue_expression] = STATE(3750),
    [sym__expression_statement_expression] = STATE(4559),
    [sym_assignment_expression] = STATE(4558),
    [sym_binary_expression] = STATE(4559),
    [sym_postfix_unary_expression] = STATE(4558),
    [sym_prefix_unary_expression] = STATE(4558),
    [sym__pointer_indirection_expression] = STATE(3560),
    [sym_query_expression] = STATE(4559),
    [sym_from_clause] = STATE(7406),
    [sym_conditional_expression] = STATE(4559),
    [sym_conditional_access_expression] = STATE(4559),
    [sym_as_expression] = STATE(4559),
    [sym_is_expression] = STATE(4559),
    [sym_is_pattern_expression] = STATE(4559),
    [sym_cast_expression] = STATE(4559),
    [sym_checked_expression] = STATE(4559),
    [sym_invocation_expression] = STATE(4558),
    [sym_switch_expression] = STATE(4559),
    [sym_await_expression] = STATE(4558),
    [sym_throw_expression] = STATE(4559),
    [sym_element_access_expression] = STATE(3560),
    [sym_interpolated_string_expression] = STATE(4559),
    [sym_member_access_expression] = STATE(3560),
    [sym_object_creation_expression] = STATE(4558),
    [sym_parenthesized_expression] = STATE(4558),
    [sym__parenthesized_lvalue_expression] = STATE(3560),
    [sym_lambda_expression] = STATE(4559),
    [sym__lambda_parameters] = STATE(9691),
    [sym_array_creation_expression] = STATE(4559),
    [sym_anonymous_method_expression] = STATE(4559),
    [sym_anonymous_object_creation_expression] = STATE(4559),
    [sym_implicit_array_creation_expression] = STATE(4559),
    [sym_implicit_object_creation_expression] = STATE(4559),
    [sym_implicit_stackalloc_expression] = STATE(4559),
    [sym_initializer_expression] = STATE(4559),
    [sym_default_expression] = STATE(4559),
    [sym_with_expression] = STATE(4559),
    [sym_sizeof_expression] = STATE(4559),
    [sym_typeof_expression] = STATE(4559),
    [sym_makeref_expression] = STATE(4559),
    [sym_ref_expression] = STATE(4559),
    [sym_reftype_expression] = STATE(4559),
    [sym_refvalue_expression] = STATE(4559),
    [sym_stackalloc_expression] = STATE(4559),
    [sym_range_expression] = STATE(4559),
    [sym_tuple_expression] = STATE(3560),
    [sym_literal] = STATE(4559),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4559),
    [sym_preproc_region] = STATE(1223),
    [sym_preproc_endregion] = STATE(1223),
    [sym_preproc_line] = STATE(1223),
    [sym_preproc_pragma] = STATE(1223),
    [sym_preproc_nullable] = STATE(1223),
    [sym_preproc_error] = STATE(1223),
    [sym_preproc_define] = STATE(1223),
    [sym_preproc_undef] = STATE(1223),
    [aux_sym_class_declaration_repeat1] = STATE(3836),
    [aux_sym_lambda_expression_repeat1] = STATE(4216),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(2003),
    [anon_sym_ref] = ACTIONS(2005),
    [anon_sym_LBRACE] = ACTIONS(1611),
    [anon_sym_delegate] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1615),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(2009),
    [anon_sym_TILDE] = ACTIONS(2009),
    [anon_sym_PLUS_PLUS] = ACTIONS(2009),
    [anon_sym_DASH_DASH] = ACTIONS(2009),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(2007),
    [anon_sym_DASH] = ACTIONS(2007),
    [anon_sym_STAR] = ACTIONS(1625),
    [anon_sym_CARET] = ACTIONS(2009),
    [anon_sym_AMP] = ACTIONS(2009),
    [anon_sym_this] = ACTIONS(1627),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1629),
    [anon_sym_unchecked] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(2011),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2013),
    [anon_sym_DOT_DOT] = ACTIONS(2015),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_stackalloc] = ACTIONS(1641),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(1647),
    [anon_sym___reftype] = ACTIONS(1649),
    [anon_sym___refvalue] = ACTIONS(1651),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1659),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [1224] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6880),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7072),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5687),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4210),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9027),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1224),
    [sym_preproc_endregion] = STATE(1224),
    [sym_preproc_line] = STATE(1224),
    [sym_preproc_pragma] = STATE(1224),
    [sym_preproc_nullable] = STATE(1224),
    [sym_preproc_error] = STATE(1224),
    [sym_preproc_define] = STATE(1224),
    [sym_preproc_undef] = STATE(1224),
    [aux_sym_class_declaration_repeat1] = STATE(3852),
    [aux_sym_lambda_expression_repeat1] = STATE(4220),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1473),
    [anon_sym_ref] = ACTIONS(1475),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(1479),
    [anon_sym_PLUS_PLUS] = ACTIONS(1479),
    [anon_sym_DASH_DASH] = ACTIONS(1479),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1477),
    [anon_sym_DASH] = ACTIONS(1477),
    [anon_sym_STAR] = ACTIONS(1101),
    [anon_sym_CARET] = ACTIONS(1479),
    [anon_sym_AMP] = ACTIONS(1479),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1111),
    [anon_sym_DOT_DOT] = ACTIONS(1115),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1225] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3559),
    [sym__name] = STATE(6878),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2911),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6938),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4829),
    [sym_non_lvalue_expression] = STATE(4553),
    [sym_lvalue_expression] = STATE(3750),
    [sym__expression_statement_expression] = STATE(4559),
    [sym_assignment_expression] = STATE(4558),
    [sym_binary_expression] = STATE(4559),
    [sym_postfix_unary_expression] = STATE(4558),
    [sym_prefix_unary_expression] = STATE(4558),
    [sym__pointer_indirection_expression] = STATE(3560),
    [sym_query_expression] = STATE(4559),
    [sym_from_clause] = STATE(7406),
    [sym_conditional_expression] = STATE(4559),
    [sym_conditional_access_expression] = STATE(4559),
    [sym_as_expression] = STATE(4559),
    [sym_is_expression] = STATE(4559),
    [sym_is_pattern_expression] = STATE(4559),
    [sym_cast_expression] = STATE(4559),
    [sym_checked_expression] = STATE(4559),
    [sym_invocation_expression] = STATE(4558),
    [sym_switch_expression] = STATE(4559),
    [sym_await_expression] = STATE(4558),
    [sym_throw_expression] = STATE(4559),
    [sym_element_access_expression] = STATE(3560),
    [sym_interpolated_string_expression] = STATE(4559),
    [sym_member_access_expression] = STATE(3560),
    [sym_object_creation_expression] = STATE(4558),
    [sym_parenthesized_expression] = STATE(4558),
    [sym__parenthesized_lvalue_expression] = STATE(3560),
    [sym_lambda_expression] = STATE(4559),
    [sym__lambda_parameters] = STATE(9691),
    [sym_array_creation_expression] = STATE(4559),
    [sym_anonymous_method_expression] = STATE(4559),
    [sym_anonymous_object_creation_expression] = STATE(4559),
    [sym_implicit_array_creation_expression] = STATE(4559),
    [sym_implicit_object_creation_expression] = STATE(4559),
    [sym_implicit_stackalloc_expression] = STATE(4559),
    [sym_initializer_expression] = STATE(4559),
    [sym_default_expression] = STATE(4559),
    [sym_with_expression] = STATE(4559),
    [sym_sizeof_expression] = STATE(4559),
    [sym_typeof_expression] = STATE(4559),
    [sym_makeref_expression] = STATE(4559),
    [sym_ref_expression] = STATE(4559),
    [sym_reftype_expression] = STATE(4559),
    [sym_refvalue_expression] = STATE(4559),
    [sym_stackalloc_expression] = STATE(4559),
    [sym_range_expression] = STATE(4559),
    [sym_tuple_expression] = STATE(3560),
    [sym_literal] = STATE(4559),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4559),
    [sym_preproc_region] = STATE(1225),
    [sym_preproc_endregion] = STATE(1225),
    [sym_preproc_line] = STATE(1225),
    [sym_preproc_pragma] = STATE(1225),
    [sym_preproc_nullable] = STATE(1225),
    [sym_preproc_error] = STATE(1225),
    [sym_preproc_define] = STATE(1225),
    [sym_preproc_undef] = STATE(1225),
    [aux_sym_class_declaration_repeat1] = STATE(3836),
    [aux_sym_lambda_expression_repeat1] = STATE(4216),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(2003),
    [anon_sym_ref] = ACTIONS(2005),
    [anon_sym_LBRACE] = ACTIONS(1611),
    [anon_sym_delegate] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1615),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(2009),
    [anon_sym_TILDE] = ACTIONS(2009),
    [anon_sym_PLUS_PLUS] = ACTIONS(2009),
    [anon_sym_DASH_DASH] = ACTIONS(2009),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(2007),
    [anon_sym_DASH] = ACTIONS(2007),
    [anon_sym_STAR] = ACTIONS(1625),
    [anon_sym_CARET] = ACTIONS(2009),
    [anon_sym_AMP] = ACTIONS(2009),
    [anon_sym_this] = ACTIONS(1627),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1629),
    [anon_sym_unchecked] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(2011),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2013),
    [anon_sym_DOT_DOT] = ACTIONS(2015),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_stackalloc] = ACTIONS(1641),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(1647),
    [anon_sym___reftype] = ACTIONS(1649),
    [anon_sym___refvalue] = ACTIONS(1651),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1659),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [1226] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6880),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7072),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5685),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4210),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9027),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1226),
    [sym_preproc_endregion] = STATE(1226),
    [sym_preproc_line] = STATE(1226),
    [sym_preproc_pragma] = STATE(1226),
    [sym_preproc_nullable] = STATE(1226),
    [sym_preproc_error] = STATE(1226),
    [sym_preproc_define] = STATE(1226),
    [sym_preproc_undef] = STATE(1226),
    [aux_sym_class_declaration_repeat1] = STATE(3852),
    [aux_sym_lambda_expression_repeat1] = STATE(4220),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1473),
    [anon_sym_ref] = ACTIONS(1475),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(1479),
    [anon_sym_PLUS_PLUS] = ACTIONS(1479),
    [anon_sym_DASH_DASH] = ACTIONS(1479),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1477),
    [anon_sym_DASH] = ACTIONS(1477),
    [anon_sym_STAR] = ACTIONS(1101),
    [anon_sym_CARET] = ACTIONS(1479),
    [anon_sym_AMP] = ACTIONS(1479),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1111),
    [anon_sym_DOT_DOT] = ACTIONS(1115),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1227] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6874),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2968),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6941),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5620),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4214),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7412),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9154),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1227),
    [sym_preproc_endregion] = STATE(1227),
    [sym_preproc_line] = STATE(1227),
    [sym_preproc_pragma] = STATE(1227),
    [sym_preproc_nullable] = STATE(1227),
    [sym_preproc_error] = STATE(1227),
    [sym_preproc_define] = STATE(1227),
    [sym_preproc_undef] = STATE(1227),
    [aux_sym_class_declaration_repeat1] = STATE(3798),
    [aux_sym_lambda_expression_repeat1] = STATE(4162),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1777),
    [anon_sym_ref] = ACTIONS(1779),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1781),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1785),
    [anon_sym_TILDE] = ACTIONS(1785),
    [anon_sym_PLUS_PLUS] = ACTIONS(1785),
    [anon_sym_DASH_DASH] = ACTIONS(1785),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_STAR] = ACTIONS(1787),
    [anon_sym_CARET] = ACTIONS(1785),
    [anon_sym_AMP] = ACTIONS(1785),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1789),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1791),
    [anon_sym_DOT_DOT] = ACTIONS(1793),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1228] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3559),
    [sym__name] = STATE(6878),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2911),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6938),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4735),
    [sym_non_lvalue_expression] = STATE(4553),
    [sym_lvalue_expression] = STATE(3750),
    [sym__expression_statement_expression] = STATE(4559),
    [sym_assignment_expression] = STATE(4558),
    [sym_binary_expression] = STATE(4559),
    [sym_postfix_unary_expression] = STATE(4558),
    [sym_prefix_unary_expression] = STATE(4558),
    [sym__pointer_indirection_expression] = STATE(3560),
    [sym_query_expression] = STATE(4559),
    [sym_from_clause] = STATE(7406),
    [sym_conditional_expression] = STATE(4559),
    [sym_conditional_access_expression] = STATE(4559),
    [sym_as_expression] = STATE(4559),
    [sym_is_expression] = STATE(4559),
    [sym_is_pattern_expression] = STATE(4559),
    [sym_cast_expression] = STATE(4559),
    [sym_checked_expression] = STATE(4559),
    [sym_invocation_expression] = STATE(4558),
    [sym_switch_expression] = STATE(4559),
    [sym_await_expression] = STATE(4558),
    [sym_throw_expression] = STATE(4559),
    [sym_element_access_expression] = STATE(3560),
    [sym_interpolated_string_expression] = STATE(4559),
    [sym_member_access_expression] = STATE(3560),
    [sym_object_creation_expression] = STATE(4558),
    [sym_parenthesized_expression] = STATE(4558),
    [sym__parenthesized_lvalue_expression] = STATE(3560),
    [sym_lambda_expression] = STATE(4559),
    [sym__lambda_parameters] = STATE(9691),
    [sym_array_creation_expression] = STATE(4559),
    [sym_anonymous_method_expression] = STATE(4559),
    [sym_anonymous_object_creation_expression] = STATE(4559),
    [sym_implicit_array_creation_expression] = STATE(4559),
    [sym_implicit_object_creation_expression] = STATE(4559),
    [sym_implicit_stackalloc_expression] = STATE(4559),
    [sym_initializer_expression] = STATE(4559),
    [sym_default_expression] = STATE(4559),
    [sym_with_expression] = STATE(4559),
    [sym_sizeof_expression] = STATE(4559),
    [sym_typeof_expression] = STATE(4559),
    [sym_makeref_expression] = STATE(4559),
    [sym_ref_expression] = STATE(4559),
    [sym_reftype_expression] = STATE(4559),
    [sym_refvalue_expression] = STATE(4559),
    [sym_stackalloc_expression] = STATE(4559),
    [sym_range_expression] = STATE(4559),
    [sym_tuple_expression] = STATE(3560),
    [sym_literal] = STATE(4559),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4559),
    [sym_preproc_region] = STATE(1228),
    [sym_preproc_endregion] = STATE(1228),
    [sym_preproc_line] = STATE(1228),
    [sym_preproc_pragma] = STATE(1228),
    [sym_preproc_nullable] = STATE(1228),
    [sym_preproc_error] = STATE(1228),
    [sym_preproc_define] = STATE(1228),
    [sym_preproc_undef] = STATE(1228),
    [aux_sym_class_declaration_repeat1] = STATE(3836),
    [aux_sym_lambda_expression_repeat1] = STATE(4216),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(2003),
    [anon_sym_ref] = ACTIONS(2005),
    [anon_sym_LBRACE] = ACTIONS(1611),
    [anon_sym_delegate] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1615),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(2009),
    [anon_sym_TILDE] = ACTIONS(2009),
    [anon_sym_PLUS_PLUS] = ACTIONS(2009),
    [anon_sym_DASH_DASH] = ACTIONS(2009),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(2007),
    [anon_sym_DASH] = ACTIONS(2007),
    [anon_sym_STAR] = ACTIONS(1625),
    [anon_sym_CARET] = ACTIONS(2009),
    [anon_sym_AMP] = ACTIONS(2009),
    [anon_sym_this] = ACTIONS(1627),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1629),
    [anon_sym_unchecked] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(2011),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2013),
    [anon_sym_DOT_DOT] = ACTIONS(2015),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_stackalloc] = ACTIONS(1641),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(1647),
    [anon_sym___reftype] = ACTIONS(1649),
    [anon_sym___refvalue] = ACTIONS(1651),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1659),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [1229] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3559),
    [sym__name] = STATE(6878),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2911),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6938),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4858),
    [sym_non_lvalue_expression] = STATE(4553),
    [sym_lvalue_expression] = STATE(3750),
    [sym__expression_statement_expression] = STATE(4559),
    [sym_assignment_expression] = STATE(4558),
    [sym_binary_expression] = STATE(4559),
    [sym_postfix_unary_expression] = STATE(4558),
    [sym_prefix_unary_expression] = STATE(4558),
    [sym__pointer_indirection_expression] = STATE(3560),
    [sym_query_expression] = STATE(4559),
    [sym_from_clause] = STATE(7406),
    [sym_conditional_expression] = STATE(4559),
    [sym_conditional_access_expression] = STATE(4559),
    [sym_as_expression] = STATE(4559),
    [sym_is_expression] = STATE(4559),
    [sym_is_pattern_expression] = STATE(4559),
    [sym_cast_expression] = STATE(4559),
    [sym_checked_expression] = STATE(4559),
    [sym_invocation_expression] = STATE(4558),
    [sym_switch_expression] = STATE(4559),
    [sym_await_expression] = STATE(4558),
    [sym_throw_expression] = STATE(4559),
    [sym_element_access_expression] = STATE(3560),
    [sym_interpolated_string_expression] = STATE(4559),
    [sym_member_access_expression] = STATE(3560),
    [sym_object_creation_expression] = STATE(4558),
    [sym_parenthesized_expression] = STATE(4558),
    [sym__parenthesized_lvalue_expression] = STATE(3560),
    [sym_lambda_expression] = STATE(4559),
    [sym__lambda_parameters] = STATE(9691),
    [sym_array_creation_expression] = STATE(4559),
    [sym_anonymous_method_expression] = STATE(4559),
    [sym_anonymous_object_creation_expression] = STATE(4559),
    [sym_implicit_array_creation_expression] = STATE(4559),
    [sym_implicit_object_creation_expression] = STATE(4559),
    [sym_implicit_stackalloc_expression] = STATE(4559),
    [sym_initializer_expression] = STATE(4559),
    [sym_default_expression] = STATE(4559),
    [sym_with_expression] = STATE(4559),
    [sym_sizeof_expression] = STATE(4559),
    [sym_typeof_expression] = STATE(4559),
    [sym_makeref_expression] = STATE(4559),
    [sym_ref_expression] = STATE(4559),
    [sym_reftype_expression] = STATE(4559),
    [sym_refvalue_expression] = STATE(4559),
    [sym_stackalloc_expression] = STATE(4559),
    [sym_range_expression] = STATE(4559),
    [sym_tuple_expression] = STATE(3560),
    [sym_literal] = STATE(4559),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4559),
    [sym_preproc_region] = STATE(1229),
    [sym_preproc_endregion] = STATE(1229),
    [sym_preproc_line] = STATE(1229),
    [sym_preproc_pragma] = STATE(1229),
    [sym_preproc_nullable] = STATE(1229),
    [sym_preproc_error] = STATE(1229),
    [sym_preproc_define] = STATE(1229),
    [sym_preproc_undef] = STATE(1229),
    [aux_sym_class_declaration_repeat1] = STATE(3836),
    [aux_sym_lambda_expression_repeat1] = STATE(4216),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(2003),
    [anon_sym_ref] = ACTIONS(2005),
    [anon_sym_LBRACE] = ACTIONS(1611),
    [anon_sym_delegate] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1615),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(2009),
    [anon_sym_TILDE] = ACTIONS(2009),
    [anon_sym_PLUS_PLUS] = ACTIONS(2009),
    [anon_sym_DASH_DASH] = ACTIONS(2009),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(2007),
    [anon_sym_DASH] = ACTIONS(2007),
    [anon_sym_STAR] = ACTIONS(1625),
    [anon_sym_CARET] = ACTIONS(2009),
    [anon_sym_AMP] = ACTIONS(2009),
    [anon_sym_this] = ACTIONS(1627),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1629),
    [anon_sym_unchecked] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(2011),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2013),
    [anon_sym_DOT_DOT] = ACTIONS(2015),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_stackalloc] = ACTIONS(1641),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(1647),
    [anon_sym___reftype] = ACTIONS(1649),
    [anon_sym___refvalue] = ACTIONS(1651),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1659),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [1230] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6874),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2968),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6941),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5623),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4214),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7412),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9154),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1230),
    [sym_preproc_endregion] = STATE(1230),
    [sym_preproc_line] = STATE(1230),
    [sym_preproc_pragma] = STATE(1230),
    [sym_preproc_nullable] = STATE(1230),
    [sym_preproc_error] = STATE(1230),
    [sym_preproc_define] = STATE(1230),
    [sym_preproc_undef] = STATE(1230),
    [aux_sym_class_declaration_repeat1] = STATE(3798),
    [aux_sym_lambda_expression_repeat1] = STATE(4162),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1777),
    [anon_sym_ref] = ACTIONS(1779),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1781),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1785),
    [anon_sym_TILDE] = ACTIONS(1785),
    [anon_sym_PLUS_PLUS] = ACTIONS(1785),
    [anon_sym_DASH_DASH] = ACTIONS(1785),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_STAR] = ACTIONS(1787),
    [anon_sym_CARET] = ACTIONS(1785),
    [anon_sym_AMP] = ACTIONS(1785),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1789),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1791),
    [anon_sym_DOT_DOT] = ACTIONS(1793),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1231] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6880),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7072),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4325),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4210),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9027),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1231),
    [sym_preproc_endregion] = STATE(1231),
    [sym_preproc_line] = STATE(1231),
    [sym_preproc_pragma] = STATE(1231),
    [sym_preproc_nullable] = STATE(1231),
    [sym_preproc_error] = STATE(1231),
    [sym_preproc_define] = STATE(1231),
    [sym_preproc_undef] = STATE(1231),
    [aux_sym_class_declaration_repeat1] = STATE(3852),
    [aux_sym_lambda_expression_repeat1] = STATE(4220),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1473),
    [anon_sym_ref] = ACTIONS(1475),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(1479),
    [anon_sym_PLUS_PLUS] = ACTIONS(1479),
    [anon_sym_DASH_DASH] = ACTIONS(1479),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1477),
    [anon_sym_DASH] = ACTIONS(1477),
    [anon_sym_STAR] = ACTIONS(1101),
    [anon_sym_CARET] = ACTIONS(1479),
    [anon_sym_AMP] = ACTIONS(1479),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1111),
    [anon_sym_DOT_DOT] = ACTIONS(1115),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1232] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6880),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7072),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5475),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4210),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9027),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1232),
    [sym_preproc_endregion] = STATE(1232),
    [sym_preproc_line] = STATE(1232),
    [sym_preproc_pragma] = STATE(1232),
    [sym_preproc_nullable] = STATE(1232),
    [sym_preproc_error] = STATE(1232),
    [sym_preproc_define] = STATE(1232),
    [sym_preproc_undef] = STATE(1232),
    [aux_sym_class_declaration_repeat1] = STATE(3852),
    [aux_sym_lambda_expression_repeat1] = STATE(4220),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1473),
    [anon_sym_ref] = ACTIONS(1475),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(1479),
    [anon_sym_PLUS_PLUS] = ACTIONS(1479),
    [anon_sym_DASH_DASH] = ACTIONS(1479),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1477),
    [anon_sym_DASH] = ACTIONS(1477),
    [anon_sym_STAR] = ACTIONS(1101),
    [anon_sym_CARET] = ACTIONS(1479),
    [anon_sym_AMP] = ACTIONS(1479),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1111),
    [anon_sym_DOT_DOT] = ACTIONS(1115),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1233] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6874),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2968),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6941),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5624),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4214),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7412),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9154),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1233),
    [sym_preproc_endregion] = STATE(1233),
    [sym_preproc_line] = STATE(1233),
    [sym_preproc_pragma] = STATE(1233),
    [sym_preproc_nullable] = STATE(1233),
    [sym_preproc_error] = STATE(1233),
    [sym_preproc_define] = STATE(1233),
    [sym_preproc_undef] = STATE(1233),
    [aux_sym_class_declaration_repeat1] = STATE(3798),
    [aux_sym_lambda_expression_repeat1] = STATE(4162),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1777),
    [anon_sym_ref] = ACTIONS(1779),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1781),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1785),
    [anon_sym_TILDE] = ACTIONS(1785),
    [anon_sym_PLUS_PLUS] = ACTIONS(1785),
    [anon_sym_DASH_DASH] = ACTIONS(1785),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_STAR] = ACTIONS(1787),
    [anon_sym_CARET] = ACTIONS(1785),
    [anon_sym_AMP] = ACTIONS(1785),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1789),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1791),
    [anon_sym_DOT_DOT] = ACTIONS(1793),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1234] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6874),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2968),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6941),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5745),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4214),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7412),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9154),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1234),
    [sym_preproc_endregion] = STATE(1234),
    [sym_preproc_line] = STATE(1234),
    [sym_preproc_pragma] = STATE(1234),
    [sym_preproc_nullable] = STATE(1234),
    [sym_preproc_error] = STATE(1234),
    [sym_preproc_define] = STATE(1234),
    [sym_preproc_undef] = STATE(1234),
    [aux_sym_class_declaration_repeat1] = STATE(3798),
    [aux_sym_lambda_expression_repeat1] = STATE(4162),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1777),
    [anon_sym_ref] = ACTIONS(1779),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1781),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1785),
    [anon_sym_TILDE] = ACTIONS(1785),
    [anon_sym_PLUS_PLUS] = ACTIONS(1785),
    [anon_sym_DASH_DASH] = ACTIONS(1785),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_STAR] = ACTIONS(1787),
    [anon_sym_CARET] = ACTIONS(1785),
    [anon_sym_AMP] = ACTIONS(1785),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1789),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1791),
    [anon_sym_DOT_DOT] = ACTIONS(1793),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1235] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3559),
    [sym__name] = STATE(6878),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2911),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6938),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4732),
    [sym_non_lvalue_expression] = STATE(4553),
    [sym_lvalue_expression] = STATE(3750),
    [sym__expression_statement_expression] = STATE(4559),
    [sym_assignment_expression] = STATE(4558),
    [sym_binary_expression] = STATE(4559),
    [sym_postfix_unary_expression] = STATE(4558),
    [sym_prefix_unary_expression] = STATE(4558),
    [sym__pointer_indirection_expression] = STATE(3560),
    [sym_query_expression] = STATE(4559),
    [sym_from_clause] = STATE(7406),
    [sym_conditional_expression] = STATE(4559),
    [sym_conditional_access_expression] = STATE(4559),
    [sym_as_expression] = STATE(4559),
    [sym_is_expression] = STATE(4559),
    [sym_is_pattern_expression] = STATE(4559),
    [sym_cast_expression] = STATE(4559),
    [sym_checked_expression] = STATE(4559),
    [sym_invocation_expression] = STATE(4558),
    [sym_switch_expression] = STATE(4559),
    [sym_await_expression] = STATE(4558),
    [sym_throw_expression] = STATE(4559),
    [sym_element_access_expression] = STATE(3560),
    [sym_interpolated_string_expression] = STATE(4559),
    [sym_member_access_expression] = STATE(3560),
    [sym_object_creation_expression] = STATE(4558),
    [sym_parenthesized_expression] = STATE(4558),
    [sym__parenthesized_lvalue_expression] = STATE(3560),
    [sym_lambda_expression] = STATE(4559),
    [sym__lambda_parameters] = STATE(9691),
    [sym_array_creation_expression] = STATE(4559),
    [sym_anonymous_method_expression] = STATE(4559),
    [sym_anonymous_object_creation_expression] = STATE(4559),
    [sym_implicit_array_creation_expression] = STATE(4559),
    [sym_implicit_object_creation_expression] = STATE(4559),
    [sym_implicit_stackalloc_expression] = STATE(4559),
    [sym_initializer_expression] = STATE(4559),
    [sym_default_expression] = STATE(4559),
    [sym_with_expression] = STATE(4559),
    [sym_sizeof_expression] = STATE(4559),
    [sym_typeof_expression] = STATE(4559),
    [sym_makeref_expression] = STATE(4559),
    [sym_ref_expression] = STATE(4559),
    [sym_reftype_expression] = STATE(4559),
    [sym_refvalue_expression] = STATE(4559),
    [sym_stackalloc_expression] = STATE(4559),
    [sym_range_expression] = STATE(4559),
    [sym_tuple_expression] = STATE(3560),
    [sym_literal] = STATE(4559),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4559),
    [sym_preproc_region] = STATE(1235),
    [sym_preproc_endregion] = STATE(1235),
    [sym_preproc_line] = STATE(1235),
    [sym_preproc_pragma] = STATE(1235),
    [sym_preproc_nullable] = STATE(1235),
    [sym_preproc_error] = STATE(1235),
    [sym_preproc_define] = STATE(1235),
    [sym_preproc_undef] = STATE(1235),
    [aux_sym_class_declaration_repeat1] = STATE(3836),
    [aux_sym_lambda_expression_repeat1] = STATE(4216),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(2003),
    [anon_sym_ref] = ACTIONS(2005),
    [anon_sym_LBRACE] = ACTIONS(1611),
    [anon_sym_delegate] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1615),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(2009),
    [anon_sym_TILDE] = ACTIONS(2009),
    [anon_sym_PLUS_PLUS] = ACTIONS(2009),
    [anon_sym_DASH_DASH] = ACTIONS(2009),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(2007),
    [anon_sym_DASH] = ACTIONS(2007),
    [anon_sym_STAR] = ACTIONS(1625),
    [anon_sym_CARET] = ACTIONS(2009),
    [anon_sym_AMP] = ACTIONS(2009),
    [anon_sym_this] = ACTIONS(1627),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1629),
    [anon_sym_unchecked] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(2011),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2013),
    [anon_sym_DOT_DOT] = ACTIONS(2015),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_stackalloc] = ACTIONS(1641),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(1647),
    [anon_sym___reftype] = ACTIONS(1649),
    [anon_sym___refvalue] = ACTIONS(1651),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1659),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [1236] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6880),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7094),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(3014),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1236),
    [sym_preproc_endregion] = STATE(1236),
    [sym_preproc_line] = STATE(1236),
    [sym_preproc_pragma] = STATE(1236),
    [sym_preproc_nullable] = STATE(1236),
    [sym_preproc_error] = STATE(1236),
    [sym_preproc_define] = STATE(1236),
    [sym_preproc_undef] = STATE(1236),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1669),
    [anon_sym_TILDE] = ACTIONS(1669),
    [anon_sym_PLUS_PLUS] = ACTIONS(1669),
    [anon_sym_DASH_DASH] = ACTIONS(1669),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1667),
    [anon_sym_DASH] = ACTIONS(1667),
    [anon_sym_STAR] = ACTIONS(1101),
    [anon_sym_CARET] = ACTIONS(1669),
    [anon_sym_AMP] = ACTIONS(1669),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1237] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6898),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2940),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6925),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4308),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4498),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7403),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(8973),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1237),
    [sym_preproc_endregion] = STATE(1237),
    [sym_preproc_line] = STATE(1237),
    [sym_preproc_pragma] = STATE(1237),
    [sym_preproc_nullable] = STATE(1237),
    [sym_preproc_error] = STATE(1237),
    [sym_preproc_define] = STATE(1237),
    [sym_preproc_undef] = STATE(1237),
    [aux_sym_class_declaration_repeat1] = STATE(3830),
    [aux_sym_lambda_expression_repeat1] = STATE(4194),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2153),
    [anon_sym_ref] = ACTIONS(2155),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2157),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2161),
    [anon_sym_TILDE] = ACTIONS(2161),
    [anon_sym_PLUS_PLUS] = ACTIONS(2161),
    [anon_sym_DASH_DASH] = ACTIONS(2161),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2159),
    [anon_sym_DASH] = ACTIONS(2159),
    [anon_sym_STAR] = ACTIONS(2163),
    [anon_sym_CARET] = ACTIONS(2161),
    [anon_sym_AMP] = ACTIONS(2161),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2165),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2167),
    [anon_sym_DOT_DOT] = ACTIONS(2169),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1238] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6874),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2968),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6941),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5625),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4214),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7412),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9154),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1238),
    [sym_preproc_endregion] = STATE(1238),
    [sym_preproc_line] = STATE(1238),
    [sym_preproc_pragma] = STATE(1238),
    [sym_preproc_nullable] = STATE(1238),
    [sym_preproc_error] = STATE(1238),
    [sym_preproc_define] = STATE(1238),
    [sym_preproc_undef] = STATE(1238),
    [aux_sym_class_declaration_repeat1] = STATE(3798),
    [aux_sym_lambda_expression_repeat1] = STATE(4162),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1777),
    [anon_sym_ref] = ACTIONS(1779),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1781),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1785),
    [anon_sym_TILDE] = ACTIONS(1785),
    [anon_sym_PLUS_PLUS] = ACTIONS(1785),
    [anon_sym_DASH_DASH] = ACTIONS(1785),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_STAR] = ACTIONS(1787),
    [anon_sym_CARET] = ACTIONS(1785),
    [anon_sym_AMP] = ACTIONS(1785),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1789),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1791),
    [anon_sym_DOT_DOT] = ACTIONS(1793),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1239] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6874),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2968),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6941),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5626),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4214),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7412),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9154),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1239),
    [sym_preproc_endregion] = STATE(1239),
    [sym_preproc_line] = STATE(1239),
    [sym_preproc_pragma] = STATE(1239),
    [sym_preproc_nullable] = STATE(1239),
    [sym_preproc_error] = STATE(1239),
    [sym_preproc_define] = STATE(1239),
    [sym_preproc_undef] = STATE(1239),
    [aux_sym_class_declaration_repeat1] = STATE(3798),
    [aux_sym_lambda_expression_repeat1] = STATE(4162),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1777),
    [anon_sym_ref] = ACTIONS(1779),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1781),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1785),
    [anon_sym_TILDE] = ACTIONS(1785),
    [anon_sym_PLUS_PLUS] = ACTIONS(1785),
    [anon_sym_DASH_DASH] = ACTIONS(1785),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_STAR] = ACTIONS(1787),
    [anon_sym_CARET] = ACTIONS(1785),
    [anon_sym_AMP] = ACTIONS(1785),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1789),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1791),
    [anon_sym_DOT_DOT] = ACTIONS(1793),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1240] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3559),
    [sym__name] = STATE(6878),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2911),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6938),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4794),
    [sym_non_lvalue_expression] = STATE(4553),
    [sym_lvalue_expression] = STATE(3750),
    [sym__expression_statement_expression] = STATE(4559),
    [sym_assignment_expression] = STATE(4558),
    [sym_binary_expression] = STATE(4559),
    [sym_postfix_unary_expression] = STATE(4558),
    [sym_prefix_unary_expression] = STATE(4558),
    [sym__pointer_indirection_expression] = STATE(3560),
    [sym_query_expression] = STATE(4559),
    [sym_from_clause] = STATE(7406),
    [sym_conditional_expression] = STATE(4559),
    [sym_conditional_access_expression] = STATE(4559),
    [sym_as_expression] = STATE(4559),
    [sym_is_expression] = STATE(4559),
    [sym_is_pattern_expression] = STATE(4559),
    [sym_cast_expression] = STATE(4559),
    [sym_checked_expression] = STATE(4559),
    [sym_invocation_expression] = STATE(4558),
    [sym_switch_expression] = STATE(4559),
    [sym_await_expression] = STATE(4558),
    [sym_throw_expression] = STATE(4559),
    [sym_element_access_expression] = STATE(3560),
    [sym_interpolated_string_expression] = STATE(4559),
    [sym_member_access_expression] = STATE(3560),
    [sym_object_creation_expression] = STATE(4558),
    [sym_parenthesized_expression] = STATE(4558),
    [sym__parenthesized_lvalue_expression] = STATE(3560),
    [sym_lambda_expression] = STATE(4559),
    [sym__lambda_parameters] = STATE(9691),
    [sym_array_creation_expression] = STATE(4559),
    [sym_anonymous_method_expression] = STATE(4559),
    [sym_anonymous_object_creation_expression] = STATE(4559),
    [sym_implicit_array_creation_expression] = STATE(4559),
    [sym_implicit_object_creation_expression] = STATE(4559),
    [sym_implicit_stackalloc_expression] = STATE(4559),
    [sym_initializer_expression] = STATE(4559),
    [sym_default_expression] = STATE(4559),
    [sym_with_expression] = STATE(4559),
    [sym_sizeof_expression] = STATE(4559),
    [sym_typeof_expression] = STATE(4559),
    [sym_makeref_expression] = STATE(4559),
    [sym_ref_expression] = STATE(4559),
    [sym_reftype_expression] = STATE(4559),
    [sym_refvalue_expression] = STATE(4559),
    [sym_stackalloc_expression] = STATE(4559),
    [sym_range_expression] = STATE(4559),
    [sym_tuple_expression] = STATE(3560),
    [sym_literal] = STATE(4559),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4559),
    [sym_preproc_region] = STATE(1240),
    [sym_preproc_endregion] = STATE(1240),
    [sym_preproc_line] = STATE(1240),
    [sym_preproc_pragma] = STATE(1240),
    [sym_preproc_nullable] = STATE(1240),
    [sym_preproc_error] = STATE(1240),
    [sym_preproc_define] = STATE(1240),
    [sym_preproc_undef] = STATE(1240),
    [aux_sym_class_declaration_repeat1] = STATE(3836),
    [aux_sym_lambda_expression_repeat1] = STATE(4216),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(2003),
    [anon_sym_ref] = ACTIONS(2005),
    [anon_sym_LBRACE] = ACTIONS(1611),
    [anon_sym_delegate] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1615),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(2009),
    [anon_sym_TILDE] = ACTIONS(2009),
    [anon_sym_PLUS_PLUS] = ACTIONS(2009),
    [anon_sym_DASH_DASH] = ACTIONS(2009),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(2007),
    [anon_sym_DASH] = ACTIONS(2007),
    [anon_sym_STAR] = ACTIONS(1625),
    [anon_sym_CARET] = ACTIONS(2009),
    [anon_sym_AMP] = ACTIONS(2009),
    [anon_sym_this] = ACTIONS(1627),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1629),
    [anon_sym_unchecked] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(2011),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2013),
    [anon_sym_DOT_DOT] = ACTIONS(2015),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_stackalloc] = ACTIONS(1641),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(1647),
    [anon_sym___reftype] = ACTIONS(1649),
    [anon_sym___refvalue] = ACTIONS(1651),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1659),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [1241] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6874),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2968),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6941),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5630),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4214),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7412),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9154),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1241),
    [sym_preproc_endregion] = STATE(1241),
    [sym_preproc_line] = STATE(1241),
    [sym_preproc_pragma] = STATE(1241),
    [sym_preproc_nullable] = STATE(1241),
    [sym_preproc_error] = STATE(1241),
    [sym_preproc_define] = STATE(1241),
    [sym_preproc_undef] = STATE(1241),
    [aux_sym_class_declaration_repeat1] = STATE(3798),
    [aux_sym_lambda_expression_repeat1] = STATE(4162),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1777),
    [anon_sym_ref] = ACTIONS(1779),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1781),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1785),
    [anon_sym_TILDE] = ACTIONS(1785),
    [anon_sym_PLUS_PLUS] = ACTIONS(1785),
    [anon_sym_DASH_DASH] = ACTIONS(1785),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_STAR] = ACTIONS(1787),
    [anon_sym_CARET] = ACTIONS(1785),
    [anon_sym_AMP] = ACTIONS(1785),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1789),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1791),
    [anon_sym_DOT_DOT] = ACTIONS(1793),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1242] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3559),
    [sym__name] = STATE(6878),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2911),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6938),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4817),
    [sym_non_lvalue_expression] = STATE(4553),
    [sym_lvalue_expression] = STATE(3750),
    [sym__expression_statement_expression] = STATE(4559),
    [sym_assignment_expression] = STATE(4558),
    [sym_binary_expression] = STATE(4559),
    [sym_postfix_unary_expression] = STATE(4558),
    [sym_prefix_unary_expression] = STATE(4558),
    [sym__pointer_indirection_expression] = STATE(3560),
    [sym_query_expression] = STATE(4559),
    [sym_from_clause] = STATE(7406),
    [sym_conditional_expression] = STATE(4559),
    [sym_conditional_access_expression] = STATE(4559),
    [sym_as_expression] = STATE(4559),
    [sym_is_expression] = STATE(4559),
    [sym_is_pattern_expression] = STATE(4559),
    [sym_cast_expression] = STATE(4559),
    [sym_checked_expression] = STATE(4559),
    [sym_invocation_expression] = STATE(4558),
    [sym_switch_expression] = STATE(4559),
    [sym_await_expression] = STATE(4558),
    [sym_throw_expression] = STATE(4559),
    [sym_element_access_expression] = STATE(3560),
    [sym_interpolated_string_expression] = STATE(4559),
    [sym_member_access_expression] = STATE(3560),
    [sym_object_creation_expression] = STATE(4558),
    [sym_parenthesized_expression] = STATE(4558),
    [sym__parenthesized_lvalue_expression] = STATE(3560),
    [sym_lambda_expression] = STATE(4559),
    [sym__lambda_parameters] = STATE(9691),
    [sym_array_creation_expression] = STATE(4559),
    [sym_anonymous_method_expression] = STATE(4559),
    [sym_anonymous_object_creation_expression] = STATE(4559),
    [sym_implicit_array_creation_expression] = STATE(4559),
    [sym_implicit_object_creation_expression] = STATE(4559),
    [sym_implicit_stackalloc_expression] = STATE(4559),
    [sym_initializer_expression] = STATE(4559),
    [sym_default_expression] = STATE(4559),
    [sym_with_expression] = STATE(4559),
    [sym_sizeof_expression] = STATE(4559),
    [sym_typeof_expression] = STATE(4559),
    [sym_makeref_expression] = STATE(4559),
    [sym_ref_expression] = STATE(4559),
    [sym_reftype_expression] = STATE(4559),
    [sym_refvalue_expression] = STATE(4559),
    [sym_stackalloc_expression] = STATE(4559),
    [sym_range_expression] = STATE(4559),
    [sym_tuple_expression] = STATE(3560),
    [sym_literal] = STATE(4559),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4559),
    [sym_preproc_region] = STATE(1242),
    [sym_preproc_endregion] = STATE(1242),
    [sym_preproc_line] = STATE(1242),
    [sym_preproc_pragma] = STATE(1242),
    [sym_preproc_nullable] = STATE(1242),
    [sym_preproc_error] = STATE(1242),
    [sym_preproc_define] = STATE(1242),
    [sym_preproc_undef] = STATE(1242),
    [aux_sym_class_declaration_repeat1] = STATE(3836),
    [aux_sym_lambda_expression_repeat1] = STATE(4216),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(2003),
    [anon_sym_ref] = ACTIONS(2005),
    [anon_sym_LBRACE] = ACTIONS(1611),
    [anon_sym_delegate] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1615),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(2009),
    [anon_sym_TILDE] = ACTIONS(2009),
    [anon_sym_PLUS_PLUS] = ACTIONS(2009),
    [anon_sym_DASH_DASH] = ACTIONS(2009),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(2007),
    [anon_sym_DASH] = ACTIONS(2007),
    [anon_sym_STAR] = ACTIONS(1625),
    [anon_sym_CARET] = ACTIONS(2009),
    [anon_sym_AMP] = ACTIONS(2009),
    [anon_sym_this] = ACTIONS(1627),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1629),
    [anon_sym_unchecked] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(2011),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2013),
    [anon_sym_DOT_DOT] = ACTIONS(2015),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_stackalloc] = ACTIONS(1641),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(1647),
    [anon_sym___reftype] = ACTIONS(1649),
    [anon_sym___refvalue] = ACTIONS(1651),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1659),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [1243] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6874),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2968),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6941),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5632),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4214),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7412),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9154),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1243),
    [sym_preproc_endregion] = STATE(1243),
    [sym_preproc_line] = STATE(1243),
    [sym_preproc_pragma] = STATE(1243),
    [sym_preproc_nullable] = STATE(1243),
    [sym_preproc_error] = STATE(1243),
    [sym_preproc_define] = STATE(1243),
    [sym_preproc_undef] = STATE(1243),
    [aux_sym_class_declaration_repeat1] = STATE(3798),
    [aux_sym_lambda_expression_repeat1] = STATE(4162),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1777),
    [anon_sym_ref] = ACTIONS(1779),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1781),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1785),
    [anon_sym_TILDE] = ACTIONS(1785),
    [anon_sym_PLUS_PLUS] = ACTIONS(1785),
    [anon_sym_DASH_DASH] = ACTIONS(1785),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_STAR] = ACTIONS(1787),
    [anon_sym_CARET] = ACTIONS(1785),
    [anon_sym_AMP] = ACTIONS(1785),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1789),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1791),
    [anon_sym_DOT_DOT] = ACTIONS(1793),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1244] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6874),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2968),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6941),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5636),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4214),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7412),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9154),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1244),
    [sym_preproc_endregion] = STATE(1244),
    [sym_preproc_line] = STATE(1244),
    [sym_preproc_pragma] = STATE(1244),
    [sym_preproc_nullable] = STATE(1244),
    [sym_preproc_error] = STATE(1244),
    [sym_preproc_define] = STATE(1244),
    [sym_preproc_undef] = STATE(1244),
    [aux_sym_class_declaration_repeat1] = STATE(3798),
    [aux_sym_lambda_expression_repeat1] = STATE(4162),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1777),
    [anon_sym_ref] = ACTIONS(1779),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1781),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1785),
    [anon_sym_TILDE] = ACTIONS(1785),
    [anon_sym_PLUS_PLUS] = ACTIONS(1785),
    [anon_sym_DASH_DASH] = ACTIONS(1785),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_STAR] = ACTIONS(1787),
    [anon_sym_CARET] = ACTIONS(1785),
    [anon_sym_AMP] = ACTIONS(1785),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1789),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1791),
    [anon_sym_DOT_DOT] = ACTIONS(1793),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1245] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6874),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2968),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6941),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(3826),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4214),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7412),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9154),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1245),
    [sym_preproc_endregion] = STATE(1245),
    [sym_preproc_line] = STATE(1245),
    [sym_preproc_pragma] = STATE(1245),
    [sym_preproc_nullable] = STATE(1245),
    [sym_preproc_error] = STATE(1245),
    [sym_preproc_define] = STATE(1245),
    [sym_preproc_undef] = STATE(1245),
    [aux_sym_class_declaration_repeat1] = STATE(3798),
    [aux_sym_lambda_expression_repeat1] = STATE(4162),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1777),
    [anon_sym_ref] = ACTIONS(1779),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1781),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1785),
    [anon_sym_TILDE] = ACTIONS(1785),
    [anon_sym_PLUS_PLUS] = ACTIONS(1785),
    [anon_sym_DASH_DASH] = ACTIONS(1785),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_STAR] = ACTIONS(1787),
    [anon_sym_CARET] = ACTIONS(1785),
    [anon_sym_AMP] = ACTIONS(1785),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1789),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1791),
    [anon_sym_DOT_DOT] = ACTIONS(1793),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1246] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3559),
    [sym__name] = STATE(6878),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2911),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6938),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4906),
    [sym_non_lvalue_expression] = STATE(4553),
    [sym_lvalue_expression] = STATE(3750),
    [sym__expression_statement_expression] = STATE(4559),
    [sym_assignment_expression] = STATE(4558),
    [sym_binary_expression] = STATE(4559),
    [sym_postfix_unary_expression] = STATE(4558),
    [sym_prefix_unary_expression] = STATE(4558),
    [sym__pointer_indirection_expression] = STATE(3560),
    [sym_query_expression] = STATE(4559),
    [sym_from_clause] = STATE(7406),
    [sym_conditional_expression] = STATE(4559),
    [sym_conditional_access_expression] = STATE(4559),
    [sym_as_expression] = STATE(4559),
    [sym_is_expression] = STATE(4559),
    [sym_is_pattern_expression] = STATE(4559),
    [sym_cast_expression] = STATE(4559),
    [sym_checked_expression] = STATE(4559),
    [sym_invocation_expression] = STATE(4558),
    [sym_switch_expression] = STATE(4559),
    [sym_await_expression] = STATE(4558),
    [sym_throw_expression] = STATE(4559),
    [sym_element_access_expression] = STATE(3560),
    [sym_interpolated_string_expression] = STATE(4559),
    [sym_member_access_expression] = STATE(3560),
    [sym_object_creation_expression] = STATE(4558),
    [sym_parenthesized_expression] = STATE(4558),
    [sym__parenthesized_lvalue_expression] = STATE(3560),
    [sym_lambda_expression] = STATE(4559),
    [sym__lambda_parameters] = STATE(9691),
    [sym_array_creation_expression] = STATE(4559),
    [sym_anonymous_method_expression] = STATE(4559),
    [sym_anonymous_object_creation_expression] = STATE(4559),
    [sym_implicit_array_creation_expression] = STATE(4559),
    [sym_implicit_object_creation_expression] = STATE(4559),
    [sym_implicit_stackalloc_expression] = STATE(4559),
    [sym_initializer_expression] = STATE(4559),
    [sym_default_expression] = STATE(4559),
    [sym_with_expression] = STATE(4559),
    [sym_sizeof_expression] = STATE(4559),
    [sym_typeof_expression] = STATE(4559),
    [sym_makeref_expression] = STATE(4559),
    [sym_ref_expression] = STATE(4559),
    [sym_reftype_expression] = STATE(4559),
    [sym_refvalue_expression] = STATE(4559),
    [sym_stackalloc_expression] = STATE(4559),
    [sym_range_expression] = STATE(4559),
    [sym_tuple_expression] = STATE(3560),
    [sym_literal] = STATE(4559),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4559),
    [sym_preproc_region] = STATE(1246),
    [sym_preproc_endregion] = STATE(1246),
    [sym_preproc_line] = STATE(1246),
    [sym_preproc_pragma] = STATE(1246),
    [sym_preproc_nullable] = STATE(1246),
    [sym_preproc_error] = STATE(1246),
    [sym_preproc_define] = STATE(1246),
    [sym_preproc_undef] = STATE(1246),
    [aux_sym_class_declaration_repeat1] = STATE(3836),
    [aux_sym_lambda_expression_repeat1] = STATE(4216),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(2003),
    [anon_sym_ref] = ACTIONS(2005),
    [anon_sym_LBRACE] = ACTIONS(1611),
    [anon_sym_delegate] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1615),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(2009),
    [anon_sym_TILDE] = ACTIONS(2009),
    [anon_sym_PLUS_PLUS] = ACTIONS(2009),
    [anon_sym_DASH_DASH] = ACTIONS(2009),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(2007),
    [anon_sym_DASH] = ACTIONS(2007),
    [anon_sym_STAR] = ACTIONS(1625),
    [anon_sym_CARET] = ACTIONS(2009),
    [anon_sym_AMP] = ACTIONS(2009),
    [anon_sym_this] = ACTIONS(1627),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1629),
    [anon_sym_unchecked] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(2011),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2013),
    [anon_sym_DOT_DOT] = ACTIONS(2015),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_stackalloc] = ACTIONS(1641),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(1647),
    [anon_sym___reftype] = ACTIONS(1649),
    [anon_sym___refvalue] = ACTIONS(1651),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1659),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [1247] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6896),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2944),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6952),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5581),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4248),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7396),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9160),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1247),
    [sym_preproc_endregion] = STATE(1247),
    [sym_preproc_line] = STATE(1247),
    [sym_preproc_pragma] = STATE(1247),
    [sym_preproc_nullable] = STATE(1247),
    [sym_preproc_error] = STATE(1247),
    [sym_preproc_define] = STATE(1247),
    [sym_preproc_undef] = STATE(1247),
    [aux_sym_class_declaration_repeat1] = STATE(3795),
    [aux_sym_lambda_expression_repeat1] = STATE(4144),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1831),
    [anon_sym_ref] = ACTIONS(1833),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1835),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1839),
    [anon_sym_TILDE] = ACTIONS(1839),
    [anon_sym_PLUS_PLUS] = ACTIONS(1839),
    [anon_sym_DASH_DASH] = ACTIONS(1839),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1837),
    [anon_sym_DASH] = ACTIONS(1837),
    [anon_sym_STAR] = ACTIONS(1841),
    [anon_sym_CARET] = ACTIONS(1839),
    [anon_sym_AMP] = ACTIONS(1839),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1843),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1845),
    [anon_sym_DOT_DOT] = ACTIONS(1847),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1248] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3559),
    [sym__name] = STATE(6878),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2911),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6938),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4901),
    [sym_non_lvalue_expression] = STATE(4553),
    [sym_lvalue_expression] = STATE(3750),
    [sym__expression_statement_expression] = STATE(4559),
    [sym_assignment_expression] = STATE(4558),
    [sym_binary_expression] = STATE(4559),
    [sym_postfix_unary_expression] = STATE(4558),
    [sym_prefix_unary_expression] = STATE(4558),
    [sym__pointer_indirection_expression] = STATE(3560),
    [sym_query_expression] = STATE(4559),
    [sym_from_clause] = STATE(7406),
    [sym_conditional_expression] = STATE(4559),
    [sym_conditional_access_expression] = STATE(4559),
    [sym_as_expression] = STATE(4559),
    [sym_is_expression] = STATE(4559),
    [sym_is_pattern_expression] = STATE(4559),
    [sym_cast_expression] = STATE(4559),
    [sym_checked_expression] = STATE(4559),
    [sym_invocation_expression] = STATE(4558),
    [sym_switch_expression] = STATE(4559),
    [sym_await_expression] = STATE(4558),
    [sym_throw_expression] = STATE(4559),
    [sym_element_access_expression] = STATE(3560),
    [sym_interpolated_string_expression] = STATE(4559),
    [sym_member_access_expression] = STATE(3560),
    [sym_object_creation_expression] = STATE(4558),
    [sym_parenthesized_expression] = STATE(4558),
    [sym__parenthesized_lvalue_expression] = STATE(3560),
    [sym_lambda_expression] = STATE(4559),
    [sym__lambda_parameters] = STATE(9691),
    [sym_array_creation_expression] = STATE(4559),
    [sym_anonymous_method_expression] = STATE(4559),
    [sym_anonymous_object_creation_expression] = STATE(4559),
    [sym_implicit_array_creation_expression] = STATE(4559),
    [sym_implicit_object_creation_expression] = STATE(4559),
    [sym_implicit_stackalloc_expression] = STATE(4559),
    [sym_initializer_expression] = STATE(4559),
    [sym_default_expression] = STATE(4559),
    [sym_with_expression] = STATE(4559),
    [sym_sizeof_expression] = STATE(4559),
    [sym_typeof_expression] = STATE(4559),
    [sym_makeref_expression] = STATE(4559),
    [sym_ref_expression] = STATE(4559),
    [sym_reftype_expression] = STATE(4559),
    [sym_refvalue_expression] = STATE(4559),
    [sym_stackalloc_expression] = STATE(4559),
    [sym_range_expression] = STATE(4559),
    [sym_tuple_expression] = STATE(3560),
    [sym_literal] = STATE(4559),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4559),
    [sym_preproc_region] = STATE(1248),
    [sym_preproc_endregion] = STATE(1248),
    [sym_preproc_line] = STATE(1248),
    [sym_preproc_pragma] = STATE(1248),
    [sym_preproc_nullable] = STATE(1248),
    [sym_preproc_error] = STATE(1248),
    [sym_preproc_define] = STATE(1248),
    [sym_preproc_undef] = STATE(1248),
    [aux_sym_class_declaration_repeat1] = STATE(3836),
    [aux_sym_lambda_expression_repeat1] = STATE(4216),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(2003),
    [anon_sym_ref] = ACTIONS(2005),
    [anon_sym_LBRACE] = ACTIONS(1611),
    [anon_sym_delegate] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1615),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(2009),
    [anon_sym_TILDE] = ACTIONS(2009),
    [anon_sym_PLUS_PLUS] = ACTIONS(2009),
    [anon_sym_DASH_DASH] = ACTIONS(2009),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(2007),
    [anon_sym_DASH] = ACTIONS(2007),
    [anon_sym_STAR] = ACTIONS(1625),
    [anon_sym_CARET] = ACTIONS(2009),
    [anon_sym_AMP] = ACTIONS(2009),
    [anon_sym_this] = ACTIONS(1627),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1629),
    [anon_sym_unchecked] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(2011),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2013),
    [anon_sym_DOT_DOT] = ACTIONS(2015),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_stackalloc] = ACTIONS(1641),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(1647),
    [anon_sym___reftype] = ACTIONS(1649),
    [anon_sym___refvalue] = ACTIONS(1651),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1659),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [1249] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6874),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2968),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6941),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5641),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4214),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7412),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9154),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1249),
    [sym_preproc_endregion] = STATE(1249),
    [sym_preproc_line] = STATE(1249),
    [sym_preproc_pragma] = STATE(1249),
    [sym_preproc_nullable] = STATE(1249),
    [sym_preproc_error] = STATE(1249),
    [sym_preproc_define] = STATE(1249),
    [sym_preproc_undef] = STATE(1249),
    [aux_sym_class_declaration_repeat1] = STATE(3798),
    [aux_sym_lambda_expression_repeat1] = STATE(4162),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1777),
    [anon_sym_ref] = ACTIONS(1779),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1781),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1785),
    [anon_sym_TILDE] = ACTIONS(1785),
    [anon_sym_PLUS_PLUS] = ACTIONS(1785),
    [anon_sym_DASH_DASH] = ACTIONS(1785),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_STAR] = ACTIONS(1787),
    [anon_sym_CARET] = ACTIONS(1785),
    [anon_sym_AMP] = ACTIONS(1785),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1789),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1791),
    [anon_sym_DOT_DOT] = ACTIONS(1793),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1250] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3559),
    [sym__name] = STATE(6878),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2911),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6938),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4896),
    [sym_non_lvalue_expression] = STATE(4553),
    [sym_lvalue_expression] = STATE(3750),
    [sym__expression_statement_expression] = STATE(4559),
    [sym_assignment_expression] = STATE(4558),
    [sym_binary_expression] = STATE(4559),
    [sym_postfix_unary_expression] = STATE(4558),
    [sym_prefix_unary_expression] = STATE(4558),
    [sym__pointer_indirection_expression] = STATE(3560),
    [sym_query_expression] = STATE(4559),
    [sym_from_clause] = STATE(7406),
    [sym_conditional_expression] = STATE(4559),
    [sym_conditional_access_expression] = STATE(4559),
    [sym_as_expression] = STATE(4559),
    [sym_is_expression] = STATE(4559),
    [sym_is_pattern_expression] = STATE(4559),
    [sym_cast_expression] = STATE(4559),
    [sym_checked_expression] = STATE(4559),
    [sym_invocation_expression] = STATE(4558),
    [sym_switch_expression] = STATE(4559),
    [sym_await_expression] = STATE(4558),
    [sym_throw_expression] = STATE(4559),
    [sym_element_access_expression] = STATE(3560),
    [sym_interpolated_string_expression] = STATE(4559),
    [sym_member_access_expression] = STATE(3560),
    [sym_object_creation_expression] = STATE(4558),
    [sym_parenthesized_expression] = STATE(4558),
    [sym__parenthesized_lvalue_expression] = STATE(3560),
    [sym_lambda_expression] = STATE(4559),
    [sym__lambda_parameters] = STATE(9691),
    [sym_array_creation_expression] = STATE(4559),
    [sym_anonymous_method_expression] = STATE(4559),
    [sym_anonymous_object_creation_expression] = STATE(4559),
    [sym_implicit_array_creation_expression] = STATE(4559),
    [sym_implicit_object_creation_expression] = STATE(4559),
    [sym_implicit_stackalloc_expression] = STATE(4559),
    [sym_initializer_expression] = STATE(4559),
    [sym_default_expression] = STATE(4559),
    [sym_with_expression] = STATE(4559),
    [sym_sizeof_expression] = STATE(4559),
    [sym_typeof_expression] = STATE(4559),
    [sym_makeref_expression] = STATE(4559),
    [sym_ref_expression] = STATE(4559),
    [sym_reftype_expression] = STATE(4559),
    [sym_refvalue_expression] = STATE(4559),
    [sym_stackalloc_expression] = STATE(4559),
    [sym_range_expression] = STATE(4559),
    [sym_tuple_expression] = STATE(3560),
    [sym_literal] = STATE(4559),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4559),
    [sym_preproc_region] = STATE(1250),
    [sym_preproc_endregion] = STATE(1250),
    [sym_preproc_line] = STATE(1250),
    [sym_preproc_pragma] = STATE(1250),
    [sym_preproc_nullable] = STATE(1250),
    [sym_preproc_error] = STATE(1250),
    [sym_preproc_define] = STATE(1250),
    [sym_preproc_undef] = STATE(1250),
    [aux_sym_class_declaration_repeat1] = STATE(3836),
    [aux_sym_lambda_expression_repeat1] = STATE(4216),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(2003),
    [anon_sym_ref] = ACTIONS(2005),
    [anon_sym_LBRACE] = ACTIONS(1611),
    [anon_sym_delegate] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1615),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(2009),
    [anon_sym_TILDE] = ACTIONS(2009),
    [anon_sym_PLUS_PLUS] = ACTIONS(2009),
    [anon_sym_DASH_DASH] = ACTIONS(2009),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(2007),
    [anon_sym_DASH] = ACTIONS(2007),
    [anon_sym_STAR] = ACTIONS(1625),
    [anon_sym_CARET] = ACTIONS(2009),
    [anon_sym_AMP] = ACTIONS(2009),
    [anon_sym_this] = ACTIONS(1627),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1629),
    [anon_sym_unchecked] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(2011),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2013),
    [anon_sym_DOT_DOT] = ACTIONS(2015),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_stackalloc] = ACTIONS(1641),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(1647),
    [anon_sym___reftype] = ACTIONS(1649),
    [anon_sym___refvalue] = ACTIONS(1651),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1659),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [1251] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6896),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2944),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6952),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(3826),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4248),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7396),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9160),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1251),
    [sym_preproc_endregion] = STATE(1251),
    [sym_preproc_line] = STATE(1251),
    [sym_preproc_pragma] = STATE(1251),
    [sym_preproc_nullable] = STATE(1251),
    [sym_preproc_error] = STATE(1251),
    [sym_preproc_define] = STATE(1251),
    [sym_preproc_undef] = STATE(1251),
    [aux_sym_class_declaration_repeat1] = STATE(3795),
    [aux_sym_lambda_expression_repeat1] = STATE(4144),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1831),
    [anon_sym_ref] = ACTIONS(1833),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1835),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1839),
    [anon_sym_TILDE] = ACTIONS(1839),
    [anon_sym_PLUS_PLUS] = ACTIONS(1839),
    [anon_sym_DASH_DASH] = ACTIONS(1839),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1837),
    [anon_sym_DASH] = ACTIONS(1837),
    [anon_sym_STAR] = ACTIONS(1841),
    [anon_sym_CARET] = ACTIONS(1839),
    [anon_sym_AMP] = ACTIONS(1839),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1843),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1845),
    [anon_sym_DOT_DOT] = ACTIONS(1847),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1252] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6212),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1252),
    [sym_preproc_endregion] = STATE(1252),
    [sym_preproc_line] = STATE(1252),
    [sym_preproc_pragma] = STATE(1252),
    [sym_preproc_nullable] = STATE(1252),
    [sym_preproc_error] = STATE(1252),
    [sym_preproc_define] = STATE(1252),
    [sym_preproc_undef] = STATE(1252),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1253] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6896),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2944),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6952),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5575),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4248),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7396),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9160),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1253),
    [sym_preproc_endregion] = STATE(1253),
    [sym_preproc_line] = STATE(1253),
    [sym_preproc_pragma] = STATE(1253),
    [sym_preproc_nullable] = STATE(1253),
    [sym_preproc_error] = STATE(1253),
    [sym_preproc_define] = STATE(1253),
    [sym_preproc_undef] = STATE(1253),
    [aux_sym_class_declaration_repeat1] = STATE(3795),
    [aux_sym_lambda_expression_repeat1] = STATE(4144),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1831),
    [anon_sym_ref] = ACTIONS(1833),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1835),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1839),
    [anon_sym_TILDE] = ACTIONS(1839),
    [anon_sym_PLUS_PLUS] = ACTIONS(1839),
    [anon_sym_DASH_DASH] = ACTIONS(1839),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1837),
    [anon_sym_DASH] = ACTIONS(1837),
    [anon_sym_STAR] = ACTIONS(1841),
    [anon_sym_CARET] = ACTIONS(1839),
    [anon_sym_AMP] = ACTIONS(1839),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1843),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1845),
    [anon_sym_DOT_DOT] = ACTIONS(1847),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1254] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3559),
    [sym__name] = STATE(6878),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2911),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6938),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4888),
    [sym_non_lvalue_expression] = STATE(4553),
    [sym_lvalue_expression] = STATE(3750),
    [sym__expression_statement_expression] = STATE(4559),
    [sym_assignment_expression] = STATE(4558),
    [sym_binary_expression] = STATE(4559),
    [sym_postfix_unary_expression] = STATE(4558),
    [sym_prefix_unary_expression] = STATE(4558),
    [sym__pointer_indirection_expression] = STATE(3560),
    [sym_query_expression] = STATE(4559),
    [sym_from_clause] = STATE(7406),
    [sym_conditional_expression] = STATE(4559),
    [sym_conditional_access_expression] = STATE(4559),
    [sym_as_expression] = STATE(4559),
    [sym_is_expression] = STATE(4559),
    [sym_is_pattern_expression] = STATE(4559),
    [sym_cast_expression] = STATE(4559),
    [sym_checked_expression] = STATE(4559),
    [sym_invocation_expression] = STATE(4558),
    [sym_switch_expression] = STATE(4559),
    [sym_await_expression] = STATE(4558),
    [sym_throw_expression] = STATE(4559),
    [sym_element_access_expression] = STATE(3560),
    [sym_interpolated_string_expression] = STATE(4559),
    [sym_member_access_expression] = STATE(3560),
    [sym_object_creation_expression] = STATE(4558),
    [sym_parenthesized_expression] = STATE(4558),
    [sym__parenthesized_lvalue_expression] = STATE(3560),
    [sym_lambda_expression] = STATE(4559),
    [sym__lambda_parameters] = STATE(9691),
    [sym_array_creation_expression] = STATE(4559),
    [sym_anonymous_method_expression] = STATE(4559),
    [sym_anonymous_object_creation_expression] = STATE(4559),
    [sym_implicit_array_creation_expression] = STATE(4559),
    [sym_implicit_object_creation_expression] = STATE(4559),
    [sym_implicit_stackalloc_expression] = STATE(4559),
    [sym_initializer_expression] = STATE(4559),
    [sym_default_expression] = STATE(4559),
    [sym_with_expression] = STATE(4559),
    [sym_sizeof_expression] = STATE(4559),
    [sym_typeof_expression] = STATE(4559),
    [sym_makeref_expression] = STATE(4559),
    [sym_ref_expression] = STATE(4559),
    [sym_reftype_expression] = STATE(4559),
    [sym_refvalue_expression] = STATE(4559),
    [sym_stackalloc_expression] = STATE(4559),
    [sym_range_expression] = STATE(4559),
    [sym_tuple_expression] = STATE(3560),
    [sym_literal] = STATE(4559),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4559),
    [sym_preproc_region] = STATE(1254),
    [sym_preproc_endregion] = STATE(1254),
    [sym_preproc_line] = STATE(1254),
    [sym_preproc_pragma] = STATE(1254),
    [sym_preproc_nullable] = STATE(1254),
    [sym_preproc_error] = STATE(1254),
    [sym_preproc_define] = STATE(1254),
    [sym_preproc_undef] = STATE(1254),
    [aux_sym_class_declaration_repeat1] = STATE(3836),
    [aux_sym_lambda_expression_repeat1] = STATE(4216),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(2003),
    [anon_sym_ref] = ACTIONS(2005),
    [anon_sym_LBRACE] = ACTIONS(1611),
    [anon_sym_delegate] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1615),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(2009),
    [anon_sym_TILDE] = ACTIONS(2009),
    [anon_sym_PLUS_PLUS] = ACTIONS(2009),
    [anon_sym_DASH_DASH] = ACTIONS(2009),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(2007),
    [anon_sym_DASH] = ACTIONS(2007),
    [anon_sym_STAR] = ACTIONS(1625),
    [anon_sym_CARET] = ACTIONS(2009),
    [anon_sym_AMP] = ACTIONS(2009),
    [anon_sym_this] = ACTIONS(1627),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1629),
    [anon_sym_unchecked] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(2011),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2013),
    [anon_sym_DOT_DOT] = ACTIONS(2015),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_stackalloc] = ACTIONS(1641),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(1647),
    [anon_sym___reftype] = ACTIONS(1649),
    [anon_sym___refvalue] = ACTIONS(1651),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1659),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [1255] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6896),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2944),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6952),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5574),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4248),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7396),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9160),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1255),
    [sym_preproc_endregion] = STATE(1255),
    [sym_preproc_line] = STATE(1255),
    [sym_preproc_pragma] = STATE(1255),
    [sym_preproc_nullable] = STATE(1255),
    [sym_preproc_error] = STATE(1255),
    [sym_preproc_define] = STATE(1255),
    [sym_preproc_undef] = STATE(1255),
    [aux_sym_class_declaration_repeat1] = STATE(3795),
    [aux_sym_lambda_expression_repeat1] = STATE(4144),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1831),
    [anon_sym_ref] = ACTIONS(1833),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1835),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1839),
    [anon_sym_TILDE] = ACTIONS(1839),
    [anon_sym_PLUS_PLUS] = ACTIONS(1839),
    [anon_sym_DASH_DASH] = ACTIONS(1839),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1837),
    [anon_sym_DASH] = ACTIONS(1837),
    [anon_sym_STAR] = ACTIONS(1841),
    [anon_sym_CARET] = ACTIONS(1839),
    [anon_sym_AMP] = ACTIONS(1839),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1843),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1845),
    [anon_sym_DOT_DOT] = ACTIONS(1847),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1256] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6896),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2944),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6952),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5572),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4248),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7396),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9160),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1256),
    [sym_preproc_endregion] = STATE(1256),
    [sym_preproc_line] = STATE(1256),
    [sym_preproc_pragma] = STATE(1256),
    [sym_preproc_nullable] = STATE(1256),
    [sym_preproc_error] = STATE(1256),
    [sym_preproc_define] = STATE(1256),
    [sym_preproc_undef] = STATE(1256),
    [aux_sym_class_declaration_repeat1] = STATE(3795),
    [aux_sym_lambda_expression_repeat1] = STATE(4144),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1831),
    [anon_sym_ref] = ACTIONS(1833),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1835),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1839),
    [anon_sym_TILDE] = ACTIONS(1839),
    [anon_sym_PLUS_PLUS] = ACTIONS(1839),
    [anon_sym_DASH_DASH] = ACTIONS(1839),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1837),
    [anon_sym_DASH] = ACTIONS(1837),
    [anon_sym_STAR] = ACTIONS(1841),
    [anon_sym_CARET] = ACTIONS(1839),
    [anon_sym_AMP] = ACTIONS(1839),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1843),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1845),
    [anon_sym_DOT_DOT] = ACTIONS(1847),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1257] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6896),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2944),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6952),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5571),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4248),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7396),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9160),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1257),
    [sym_preproc_endregion] = STATE(1257),
    [sym_preproc_line] = STATE(1257),
    [sym_preproc_pragma] = STATE(1257),
    [sym_preproc_nullable] = STATE(1257),
    [sym_preproc_error] = STATE(1257),
    [sym_preproc_define] = STATE(1257),
    [sym_preproc_undef] = STATE(1257),
    [aux_sym_class_declaration_repeat1] = STATE(3795),
    [aux_sym_lambda_expression_repeat1] = STATE(4144),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1831),
    [anon_sym_ref] = ACTIONS(1833),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1835),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1839),
    [anon_sym_TILDE] = ACTIONS(1839),
    [anon_sym_PLUS_PLUS] = ACTIONS(1839),
    [anon_sym_DASH_DASH] = ACTIONS(1839),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1837),
    [anon_sym_DASH] = ACTIONS(1837),
    [anon_sym_STAR] = ACTIONS(1841),
    [anon_sym_CARET] = ACTIONS(1839),
    [anon_sym_AMP] = ACTIONS(1839),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1843),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1845),
    [anon_sym_DOT_DOT] = ACTIONS(1847),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1258] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6918),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7126),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(3557),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(3736),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7377),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9441),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1258),
    [sym_preproc_endregion] = STATE(1258),
    [sym_preproc_line] = STATE(1258),
    [sym_preproc_pragma] = STATE(1258),
    [sym_preproc_nullable] = STATE(1258),
    [sym_preproc_error] = STATE(1258),
    [sym_preproc_define] = STATE(1258),
    [sym_preproc_undef] = STATE(1258),
    [aux_sym_class_declaration_repeat1] = STATE(3848),
    [aux_sym_lambda_expression_repeat1] = STATE(4242),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1213),
    [anon_sym_ref] = ACTIONS(1215),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1221),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1227),
    [anon_sym_TILDE] = ACTIONS(1227),
    [anon_sym_PLUS_PLUS] = ACTIONS(1227),
    [anon_sym_DASH_DASH] = ACTIONS(1227),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1225),
    [anon_sym_DASH] = ACTIONS(1225),
    [anon_sym_STAR] = ACTIONS(1231),
    [anon_sym_CARET] = ACTIONS(1227),
    [anon_sym_AMP] = ACTIONS(1227),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1239),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1241),
    [anon_sym_DOT_DOT] = ACTIONS(1243),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1259] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6896),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2944),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6952),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5569),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4248),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7396),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9160),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1259),
    [sym_preproc_endregion] = STATE(1259),
    [sym_preproc_line] = STATE(1259),
    [sym_preproc_pragma] = STATE(1259),
    [sym_preproc_nullable] = STATE(1259),
    [sym_preproc_error] = STATE(1259),
    [sym_preproc_define] = STATE(1259),
    [sym_preproc_undef] = STATE(1259),
    [aux_sym_class_declaration_repeat1] = STATE(3795),
    [aux_sym_lambda_expression_repeat1] = STATE(4144),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1831),
    [anon_sym_ref] = ACTIONS(1833),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1835),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1839),
    [anon_sym_TILDE] = ACTIONS(1839),
    [anon_sym_PLUS_PLUS] = ACTIONS(1839),
    [anon_sym_DASH_DASH] = ACTIONS(1839),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1837),
    [anon_sym_DASH] = ACTIONS(1837),
    [anon_sym_STAR] = ACTIONS(1841),
    [anon_sym_CARET] = ACTIONS(1839),
    [anon_sym_AMP] = ACTIONS(1839),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1843),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1845),
    [anon_sym_DOT_DOT] = ACTIONS(1847),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1260] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6896),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2944),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6952),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5667),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4248),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7396),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9160),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1260),
    [sym_preproc_endregion] = STATE(1260),
    [sym_preproc_line] = STATE(1260),
    [sym_preproc_pragma] = STATE(1260),
    [sym_preproc_nullable] = STATE(1260),
    [sym_preproc_error] = STATE(1260),
    [sym_preproc_define] = STATE(1260),
    [sym_preproc_undef] = STATE(1260),
    [aux_sym_class_declaration_repeat1] = STATE(3795),
    [aux_sym_lambda_expression_repeat1] = STATE(4144),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1831),
    [anon_sym_ref] = ACTIONS(1833),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1835),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1839),
    [anon_sym_TILDE] = ACTIONS(1839),
    [anon_sym_PLUS_PLUS] = ACTIONS(1839),
    [anon_sym_DASH_DASH] = ACTIONS(1839),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1837),
    [anon_sym_DASH] = ACTIONS(1837),
    [anon_sym_STAR] = ACTIONS(1841),
    [anon_sym_CARET] = ACTIONS(1839),
    [anon_sym_AMP] = ACTIONS(1839),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1843),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1845),
    [anon_sym_DOT_DOT] = ACTIONS(1847),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1261] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6896),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2944),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6952),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5568),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4248),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7396),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9160),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1261),
    [sym_preproc_endregion] = STATE(1261),
    [sym_preproc_line] = STATE(1261),
    [sym_preproc_pragma] = STATE(1261),
    [sym_preproc_nullable] = STATE(1261),
    [sym_preproc_error] = STATE(1261),
    [sym_preproc_define] = STATE(1261),
    [sym_preproc_undef] = STATE(1261),
    [aux_sym_class_declaration_repeat1] = STATE(3795),
    [aux_sym_lambda_expression_repeat1] = STATE(4144),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1831),
    [anon_sym_ref] = ACTIONS(1833),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1835),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1839),
    [anon_sym_TILDE] = ACTIONS(1839),
    [anon_sym_PLUS_PLUS] = ACTIONS(1839),
    [anon_sym_DASH_DASH] = ACTIONS(1839),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1837),
    [anon_sym_DASH] = ACTIONS(1837),
    [anon_sym_STAR] = ACTIONS(1841),
    [anon_sym_CARET] = ACTIONS(1839),
    [anon_sym_AMP] = ACTIONS(1839),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1843),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1845),
    [anon_sym_DOT_DOT] = ACTIONS(1847),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1262] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6896),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2944),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6952),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5566),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4248),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7396),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9160),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1262),
    [sym_preproc_endregion] = STATE(1262),
    [sym_preproc_line] = STATE(1262),
    [sym_preproc_pragma] = STATE(1262),
    [sym_preproc_nullable] = STATE(1262),
    [sym_preproc_error] = STATE(1262),
    [sym_preproc_define] = STATE(1262),
    [sym_preproc_undef] = STATE(1262),
    [aux_sym_class_declaration_repeat1] = STATE(3795),
    [aux_sym_lambda_expression_repeat1] = STATE(4144),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1831),
    [anon_sym_ref] = ACTIONS(1833),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1835),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1839),
    [anon_sym_TILDE] = ACTIONS(1839),
    [anon_sym_PLUS_PLUS] = ACTIONS(1839),
    [anon_sym_DASH_DASH] = ACTIONS(1839),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1837),
    [anon_sym_DASH] = ACTIONS(1837),
    [anon_sym_STAR] = ACTIONS(1841),
    [anon_sym_CARET] = ACTIONS(1839),
    [anon_sym_AMP] = ACTIONS(1839),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1843),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1845),
    [anon_sym_DOT_DOT] = ACTIONS(1847),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1263] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6896),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2944),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6952),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5565),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4248),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7396),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9160),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1263),
    [sym_preproc_endregion] = STATE(1263),
    [sym_preproc_line] = STATE(1263),
    [sym_preproc_pragma] = STATE(1263),
    [sym_preproc_nullable] = STATE(1263),
    [sym_preproc_error] = STATE(1263),
    [sym_preproc_define] = STATE(1263),
    [sym_preproc_undef] = STATE(1263),
    [aux_sym_class_declaration_repeat1] = STATE(3795),
    [aux_sym_lambda_expression_repeat1] = STATE(4144),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1831),
    [anon_sym_ref] = ACTIONS(1833),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1835),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1839),
    [anon_sym_TILDE] = ACTIONS(1839),
    [anon_sym_PLUS_PLUS] = ACTIONS(1839),
    [anon_sym_DASH_DASH] = ACTIONS(1839),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1837),
    [anon_sym_DASH] = ACTIONS(1837),
    [anon_sym_STAR] = ACTIONS(1841),
    [anon_sym_CARET] = ACTIONS(1839),
    [anon_sym_AMP] = ACTIONS(1839),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1843),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1845),
    [anon_sym_DOT_DOT] = ACTIONS(1847),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1264] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6896),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2944),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6952),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5618),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4248),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7396),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9160),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1264),
    [sym_preproc_endregion] = STATE(1264),
    [sym_preproc_line] = STATE(1264),
    [sym_preproc_pragma] = STATE(1264),
    [sym_preproc_nullable] = STATE(1264),
    [sym_preproc_error] = STATE(1264),
    [sym_preproc_define] = STATE(1264),
    [sym_preproc_undef] = STATE(1264),
    [aux_sym_class_declaration_repeat1] = STATE(3795),
    [aux_sym_lambda_expression_repeat1] = STATE(4144),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1831),
    [anon_sym_ref] = ACTIONS(1833),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1835),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1839),
    [anon_sym_TILDE] = ACTIONS(1839),
    [anon_sym_PLUS_PLUS] = ACTIONS(1839),
    [anon_sym_DASH_DASH] = ACTIONS(1839),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1837),
    [anon_sym_DASH] = ACTIONS(1837),
    [anon_sym_STAR] = ACTIONS(1841),
    [anon_sym_CARET] = ACTIONS(1839),
    [anon_sym_AMP] = ACTIONS(1839),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1843),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1845),
    [anon_sym_DOT_DOT] = ACTIONS(1847),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1265] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6896),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2944),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6952),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5666),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4248),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7396),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9160),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1265),
    [sym_preproc_endregion] = STATE(1265),
    [sym_preproc_line] = STATE(1265),
    [sym_preproc_pragma] = STATE(1265),
    [sym_preproc_nullable] = STATE(1265),
    [sym_preproc_error] = STATE(1265),
    [sym_preproc_define] = STATE(1265),
    [sym_preproc_undef] = STATE(1265),
    [aux_sym_class_declaration_repeat1] = STATE(3795),
    [aux_sym_lambda_expression_repeat1] = STATE(4144),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1831),
    [anon_sym_ref] = ACTIONS(1833),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1835),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1839),
    [anon_sym_TILDE] = ACTIONS(1839),
    [anon_sym_PLUS_PLUS] = ACTIONS(1839),
    [anon_sym_DASH_DASH] = ACTIONS(1839),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1837),
    [anon_sym_DASH] = ACTIONS(1837),
    [anon_sym_STAR] = ACTIONS(1841),
    [anon_sym_CARET] = ACTIONS(1839),
    [anon_sym_AMP] = ACTIONS(1839),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1843),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1845),
    [anon_sym_DOT_DOT] = ACTIONS(1847),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1266] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6896),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2944),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6952),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5665),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4248),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7396),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9160),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1266),
    [sym_preproc_endregion] = STATE(1266),
    [sym_preproc_line] = STATE(1266),
    [sym_preproc_pragma] = STATE(1266),
    [sym_preproc_nullable] = STATE(1266),
    [sym_preproc_error] = STATE(1266),
    [sym_preproc_define] = STATE(1266),
    [sym_preproc_undef] = STATE(1266),
    [aux_sym_class_declaration_repeat1] = STATE(3795),
    [aux_sym_lambda_expression_repeat1] = STATE(4144),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1831),
    [anon_sym_ref] = ACTIONS(1833),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1835),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1839),
    [anon_sym_TILDE] = ACTIONS(1839),
    [anon_sym_PLUS_PLUS] = ACTIONS(1839),
    [anon_sym_DASH_DASH] = ACTIONS(1839),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1837),
    [anon_sym_DASH] = ACTIONS(1837),
    [anon_sym_STAR] = ACTIONS(1841),
    [anon_sym_CARET] = ACTIONS(1839),
    [anon_sym_AMP] = ACTIONS(1839),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1843),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1845),
    [anon_sym_DOT_DOT] = ACTIONS(1847),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1267] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6896),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2944),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6952),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(3822),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4248),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7396),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9160),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1267),
    [sym_preproc_endregion] = STATE(1267),
    [sym_preproc_line] = STATE(1267),
    [sym_preproc_pragma] = STATE(1267),
    [sym_preproc_nullable] = STATE(1267),
    [sym_preproc_error] = STATE(1267),
    [sym_preproc_define] = STATE(1267),
    [sym_preproc_undef] = STATE(1267),
    [aux_sym_class_declaration_repeat1] = STATE(3795),
    [aux_sym_lambda_expression_repeat1] = STATE(4144),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1831),
    [anon_sym_ref] = ACTIONS(1833),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1835),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1839),
    [anon_sym_TILDE] = ACTIONS(1839),
    [anon_sym_PLUS_PLUS] = ACTIONS(1839),
    [anon_sym_DASH_DASH] = ACTIONS(1839),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1837),
    [anon_sym_DASH] = ACTIONS(1837),
    [anon_sym_STAR] = ACTIONS(1841),
    [anon_sym_CARET] = ACTIONS(1839),
    [anon_sym_AMP] = ACTIONS(1839),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1843),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1845),
    [anon_sym_DOT_DOT] = ACTIONS(1847),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1268] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6896),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2944),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6952),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5564),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4248),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7396),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9160),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1268),
    [sym_preproc_endregion] = STATE(1268),
    [sym_preproc_line] = STATE(1268),
    [sym_preproc_pragma] = STATE(1268),
    [sym_preproc_nullable] = STATE(1268),
    [sym_preproc_error] = STATE(1268),
    [sym_preproc_define] = STATE(1268),
    [sym_preproc_undef] = STATE(1268),
    [aux_sym_class_declaration_repeat1] = STATE(3795),
    [aux_sym_lambda_expression_repeat1] = STATE(4144),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1831),
    [anon_sym_ref] = ACTIONS(1833),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1835),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1839),
    [anon_sym_TILDE] = ACTIONS(1839),
    [anon_sym_PLUS_PLUS] = ACTIONS(1839),
    [anon_sym_DASH_DASH] = ACTIONS(1839),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1837),
    [anon_sym_DASH] = ACTIONS(1837),
    [anon_sym_STAR] = ACTIONS(1841),
    [anon_sym_CARET] = ACTIONS(1839),
    [anon_sym_AMP] = ACTIONS(1839),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1843),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1845),
    [anon_sym_DOT_DOT] = ACTIONS(1847),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1269] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7094),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6687),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(3455),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1269),
    [sym_preproc_endregion] = STATE(1269),
    [sym_preproc_line] = STATE(1269),
    [sym_preproc_pragma] = STATE(1269),
    [sym_preproc_nullable] = STATE(1269),
    [sym_preproc_error] = STATE(1269),
    [sym_preproc_define] = STATE(1269),
    [sym_preproc_undef] = STATE(1269),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(2909),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1669),
    [anon_sym_TILDE] = ACTIONS(1669),
    [anon_sym_PLUS_PLUS] = ACTIONS(1669),
    [anon_sym_DASH_DASH] = ACTIONS(1669),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1667),
    [anon_sym_DASH] = ACTIONS(1667),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(1669),
    [anon_sym_AMP] = ACTIONS(1669),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1270] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6898),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2940),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6925),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6536),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4498),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7403),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(8973),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1270),
    [sym_preproc_endregion] = STATE(1270),
    [sym_preproc_line] = STATE(1270),
    [sym_preproc_pragma] = STATE(1270),
    [sym_preproc_nullable] = STATE(1270),
    [sym_preproc_error] = STATE(1270),
    [sym_preproc_define] = STATE(1270),
    [sym_preproc_undef] = STATE(1270),
    [aux_sym_class_declaration_repeat1] = STATE(3830),
    [aux_sym_lambda_expression_repeat1] = STATE(4194),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2153),
    [anon_sym_ref] = ACTIONS(2155),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2157),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2161),
    [anon_sym_TILDE] = ACTIONS(2161),
    [anon_sym_PLUS_PLUS] = ACTIONS(2161),
    [anon_sym_DASH_DASH] = ACTIONS(2161),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2159),
    [anon_sym_DASH] = ACTIONS(2159),
    [anon_sym_STAR] = ACTIONS(2163),
    [anon_sym_CARET] = ACTIONS(2161),
    [anon_sym_AMP] = ACTIONS(2161),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2165),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2167),
    [anon_sym_DOT_DOT] = ACTIONS(2169),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1271] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6898),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2940),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6925),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6329),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4498),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7403),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(8973),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1271),
    [sym_preproc_endregion] = STATE(1271),
    [sym_preproc_line] = STATE(1271),
    [sym_preproc_pragma] = STATE(1271),
    [sym_preproc_nullable] = STATE(1271),
    [sym_preproc_error] = STATE(1271),
    [sym_preproc_define] = STATE(1271),
    [sym_preproc_undef] = STATE(1271),
    [aux_sym_class_declaration_repeat1] = STATE(3830),
    [aux_sym_lambda_expression_repeat1] = STATE(4194),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2153),
    [anon_sym_ref] = ACTIONS(2155),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2157),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2161),
    [anon_sym_TILDE] = ACTIONS(2161),
    [anon_sym_PLUS_PLUS] = ACTIONS(2161),
    [anon_sym_DASH_DASH] = ACTIONS(2161),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2159),
    [anon_sym_DASH] = ACTIONS(2159),
    [anon_sym_STAR] = ACTIONS(2163),
    [anon_sym_CARET] = ACTIONS(2161),
    [anon_sym_AMP] = ACTIONS(2161),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2165),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2167),
    [anon_sym_DOT_DOT] = ACTIONS(2169),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1272] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6901),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2939),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7050),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6649),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4507),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7378),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9063),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1272),
    [sym_preproc_endregion] = STATE(1272),
    [sym_preproc_line] = STATE(1272),
    [sym_preproc_pragma] = STATE(1272),
    [sym_preproc_nullable] = STATE(1272),
    [sym_preproc_error] = STATE(1272),
    [sym_preproc_define] = STATE(1272),
    [sym_preproc_undef] = STATE(1272),
    [aux_sym_class_declaration_repeat1] = STATE(3854),
    [aux_sym_lambda_expression_repeat1] = STATE(4229),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2193),
    [anon_sym_ref] = ACTIONS(2195),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2197),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2201),
    [anon_sym_TILDE] = ACTIONS(2201),
    [anon_sym_PLUS_PLUS] = ACTIONS(2201),
    [anon_sym_DASH_DASH] = ACTIONS(2201),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2199),
    [anon_sym_DASH] = ACTIONS(2199),
    [anon_sym_STAR] = ACTIONS(2203),
    [anon_sym_CARET] = ACTIONS(2201),
    [anon_sym_AMP] = ACTIONS(2201),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2205),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2207),
    [anon_sym_DOT_DOT] = ACTIONS(2209),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1273] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6901),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2939),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7050),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4325),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4507),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7378),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9063),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1273),
    [sym_preproc_endregion] = STATE(1273),
    [sym_preproc_line] = STATE(1273),
    [sym_preproc_pragma] = STATE(1273),
    [sym_preproc_nullable] = STATE(1273),
    [sym_preproc_error] = STATE(1273),
    [sym_preproc_define] = STATE(1273),
    [sym_preproc_undef] = STATE(1273),
    [aux_sym_class_declaration_repeat1] = STATE(3854),
    [aux_sym_lambda_expression_repeat1] = STATE(4229),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2193),
    [anon_sym_ref] = ACTIONS(2195),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2197),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2201),
    [anon_sym_TILDE] = ACTIONS(2201),
    [anon_sym_PLUS_PLUS] = ACTIONS(2201),
    [anon_sym_DASH_DASH] = ACTIONS(2201),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2199),
    [anon_sym_DASH] = ACTIONS(2199),
    [anon_sym_STAR] = ACTIONS(2203),
    [anon_sym_CARET] = ACTIONS(2201),
    [anon_sym_AMP] = ACTIONS(2201),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2205),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2207),
    [anon_sym_DOT_DOT] = ACTIONS(2209),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1274] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6880),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7055),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5888),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4312),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7380),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9286),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1274),
    [sym_preproc_endregion] = STATE(1274),
    [sym_preproc_line] = STATE(1274),
    [sym_preproc_pragma] = STATE(1274),
    [sym_preproc_nullable] = STATE(1274),
    [sym_preproc_error] = STATE(1274),
    [sym_preproc_define] = STATE(1274),
    [sym_preproc_undef] = STATE(1274),
    [aux_sym_class_declaration_repeat1] = STATE(3799),
    [aux_sym_lambda_expression_repeat1] = STATE(4101),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1545),
    [anon_sym_ref] = ACTIONS(1547),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1551),
    [anon_sym_TILDE] = ACTIONS(1551),
    [anon_sym_PLUS_PLUS] = ACTIONS(1551),
    [anon_sym_DASH_DASH] = ACTIONS(1551),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1549),
    [anon_sym_DASH] = ACTIONS(1549),
    [anon_sym_STAR] = ACTIONS(1553),
    [anon_sym_CARET] = ACTIONS(1551),
    [anon_sym_AMP] = ACTIONS(1551),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1555),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1557),
    [anon_sym_DOT_DOT] = ACTIONS(1559),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1275] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6898),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2940),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6925),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6355),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4498),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7403),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(8973),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1275),
    [sym_preproc_endregion] = STATE(1275),
    [sym_preproc_line] = STATE(1275),
    [sym_preproc_pragma] = STATE(1275),
    [sym_preproc_nullable] = STATE(1275),
    [sym_preproc_error] = STATE(1275),
    [sym_preproc_define] = STATE(1275),
    [sym_preproc_undef] = STATE(1275),
    [aux_sym_class_declaration_repeat1] = STATE(3830),
    [aux_sym_lambda_expression_repeat1] = STATE(4194),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2153),
    [anon_sym_ref] = ACTIONS(2155),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2157),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2161),
    [anon_sym_TILDE] = ACTIONS(2161),
    [anon_sym_PLUS_PLUS] = ACTIONS(2161),
    [anon_sym_DASH_DASH] = ACTIONS(2161),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2159),
    [anon_sym_DASH] = ACTIONS(2159),
    [anon_sym_STAR] = ACTIONS(2163),
    [anon_sym_CARET] = ACTIONS(2161),
    [anon_sym_AMP] = ACTIONS(2161),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2165),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2167),
    [anon_sym_DOT_DOT] = ACTIONS(2169),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1276] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6901),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2939),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7050),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6312),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4507),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7378),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9063),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1276),
    [sym_preproc_endregion] = STATE(1276),
    [sym_preproc_line] = STATE(1276),
    [sym_preproc_pragma] = STATE(1276),
    [sym_preproc_nullable] = STATE(1276),
    [sym_preproc_error] = STATE(1276),
    [sym_preproc_define] = STATE(1276),
    [sym_preproc_undef] = STATE(1276),
    [aux_sym_class_declaration_repeat1] = STATE(3854),
    [aux_sym_lambda_expression_repeat1] = STATE(4229),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2193),
    [anon_sym_ref] = ACTIONS(2195),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2197),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2201),
    [anon_sym_TILDE] = ACTIONS(2201),
    [anon_sym_PLUS_PLUS] = ACTIONS(2201),
    [anon_sym_DASH_DASH] = ACTIONS(2201),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2199),
    [anon_sym_DASH] = ACTIONS(2199),
    [anon_sym_STAR] = ACTIONS(2203),
    [anon_sym_CARET] = ACTIONS(2201),
    [anon_sym_AMP] = ACTIONS(2201),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2205),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2207),
    [anon_sym_DOT_DOT] = ACTIONS(2209),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1277] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6901),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2939),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7050),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6307),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4507),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7378),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9063),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1277),
    [sym_preproc_endregion] = STATE(1277),
    [sym_preproc_line] = STATE(1277),
    [sym_preproc_pragma] = STATE(1277),
    [sym_preproc_nullable] = STATE(1277),
    [sym_preproc_error] = STATE(1277),
    [sym_preproc_define] = STATE(1277),
    [sym_preproc_undef] = STATE(1277),
    [aux_sym_class_declaration_repeat1] = STATE(3854),
    [aux_sym_lambda_expression_repeat1] = STATE(4229),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2193),
    [anon_sym_ref] = ACTIONS(2195),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2197),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2201),
    [anon_sym_TILDE] = ACTIONS(2201),
    [anon_sym_PLUS_PLUS] = ACTIONS(2201),
    [anon_sym_DASH_DASH] = ACTIONS(2201),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2199),
    [anon_sym_DASH] = ACTIONS(2199),
    [anon_sym_STAR] = ACTIONS(2203),
    [anon_sym_CARET] = ACTIONS(2201),
    [anon_sym_AMP] = ACTIONS(2201),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2205),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2207),
    [anon_sym_DOT_DOT] = ACTIONS(2209),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1278] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6880),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7055),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5901),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4312),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7380),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9286),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1278),
    [sym_preproc_endregion] = STATE(1278),
    [sym_preproc_line] = STATE(1278),
    [sym_preproc_pragma] = STATE(1278),
    [sym_preproc_nullable] = STATE(1278),
    [sym_preproc_error] = STATE(1278),
    [sym_preproc_define] = STATE(1278),
    [sym_preproc_undef] = STATE(1278),
    [aux_sym_class_declaration_repeat1] = STATE(3799),
    [aux_sym_lambda_expression_repeat1] = STATE(4101),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1545),
    [anon_sym_ref] = ACTIONS(1547),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1551),
    [anon_sym_TILDE] = ACTIONS(1551),
    [anon_sym_PLUS_PLUS] = ACTIONS(1551),
    [anon_sym_DASH_DASH] = ACTIONS(1551),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1549),
    [anon_sym_DASH] = ACTIONS(1549),
    [anon_sym_STAR] = ACTIONS(1553),
    [anon_sym_CARET] = ACTIONS(1551),
    [anon_sym_AMP] = ACTIONS(1551),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1555),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1557),
    [anon_sym_DOT_DOT] = ACTIONS(1559),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1279] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6901),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2939),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7050),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6304),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4507),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7378),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9063),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1279),
    [sym_preproc_endregion] = STATE(1279),
    [sym_preproc_line] = STATE(1279),
    [sym_preproc_pragma] = STATE(1279),
    [sym_preproc_nullable] = STATE(1279),
    [sym_preproc_error] = STATE(1279),
    [sym_preproc_define] = STATE(1279),
    [sym_preproc_undef] = STATE(1279),
    [aux_sym_class_declaration_repeat1] = STATE(3854),
    [aux_sym_lambda_expression_repeat1] = STATE(4229),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2193),
    [anon_sym_ref] = ACTIONS(2195),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2197),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2201),
    [anon_sym_TILDE] = ACTIONS(2201),
    [anon_sym_PLUS_PLUS] = ACTIONS(2201),
    [anon_sym_DASH_DASH] = ACTIONS(2201),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2199),
    [anon_sym_DASH] = ACTIONS(2199),
    [anon_sym_STAR] = ACTIONS(2203),
    [anon_sym_CARET] = ACTIONS(2201),
    [anon_sym_AMP] = ACTIONS(2201),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2205),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2207),
    [anon_sym_DOT_DOT] = ACTIONS(2209),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1280] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6901),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2939),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7050),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6302),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4507),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7378),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9063),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1280),
    [sym_preproc_endregion] = STATE(1280),
    [sym_preproc_line] = STATE(1280),
    [sym_preproc_pragma] = STATE(1280),
    [sym_preproc_nullable] = STATE(1280),
    [sym_preproc_error] = STATE(1280),
    [sym_preproc_define] = STATE(1280),
    [sym_preproc_undef] = STATE(1280),
    [aux_sym_class_declaration_repeat1] = STATE(3854),
    [aux_sym_lambda_expression_repeat1] = STATE(4229),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2193),
    [anon_sym_ref] = ACTIONS(2195),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2197),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2201),
    [anon_sym_TILDE] = ACTIONS(2201),
    [anon_sym_PLUS_PLUS] = ACTIONS(2201),
    [anon_sym_DASH_DASH] = ACTIONS(2201),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2199),
    [anon_sym_DASH] = ACTIONS(2199),
    [anon_sym_STAR] = ACTIONS(2203),
    [anon_sym_CARET] = ACTIONS(2201),
    [anon_sym_AMP] = ACTIONS(2201),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2205),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2207),
    [anon_sym_DOT_DOT] = ACTIONS(2209),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1281] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6880),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7055),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(3901),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4312),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7380),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9286),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1281),
    [sym_preproc_endregion] = STATE(1281),
    [sym_preproc_line] = STATE(1281),
    [sym_preproc_pragma] = STATE(1281),
    [sym_preproc_nullable] = STATE(1281),
    [sym_preproc_error] = STATE(1281),
    [sym_preproc_define] = STATE(1281),
    [sym_preproc_undef] = STATE(1281),
    [aux_sym_class_declaration_repeat1] = STATE(3799),
    [aux_sym_lambda_expression_repeat1] = STATE(4101),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1545),
    [anon_sym_ref] = ACTIONS(1547),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1551),
    [anon_sym_TILDE] = ACTIONS(1551),
    [anon_sym_PLUS_PLUS] = ACTIONS(1551),
    [anon_sym_DASH_DASH] = ACTIONS(1551),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1549),
    [anon_sym_DASH] = ACTIONS(1549),
    [anon_sym_STAR] = ACTIONS(1553),
    [anon_sym_CARET] = ACTIONS(1551),
    [anon_sym_AMP] = ACTIONS(1551),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1555),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1557),
    [anon_sym_DOT_DOT] = ACTIONS(1559),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1282] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6880),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7055),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5905),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4312),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7380),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9286),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1282),
    [sym_preproc_endregion] = STATE(1282),
    [sym_preproc_line] = STATE(1282),
    [sym_preproc_pragma] = STATE(1282),
    [sym_preproc_nullable] = STATE(1282),
    [sym_preproc_error] = STATE(1282),
    [sym_preproc_define] = STATE(1282),
    [sym_preproc_undef] = STATE(1282),
    [aux_sym_class_declaration_repeat1] = STATE(3799),
    [aux_sym_lambda_expression_repeat1] = STATE(4101),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1545),
    [anon_sym_ref] = ACTIONS(1547),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1551),
    [anon_sym_TILDE] = ACTIONS(1551),
    [anon_sym_PLUS_PLUS] = ACTIONS(1551),
    [anon_sym_DASH_DASH] = ACTIONS(1551),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1549),
    [anon_sym_DASH] = ACTIONS(1549),
    [anon_sym_STAR] = ACTIONS(1553),
    [anon_sym_CARET] = ACTIONS(1551),
    [anon_sym_AMP] = ACTIONS(1551),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1555),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1557),
    [anon_sym_DOT_DOT] = ACTIONS(1559),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1283] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6901),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2939),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7050),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6301),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4507),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7378),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9063),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1283),
    [sym_preproc_endregion] = STATE(1283),
    [sym_preproc_line] = STATE(1283),
    [sym_preproc_pragma] = STATE(1283),
    [sym_preproc_nullable] = STATE(1283),
    [sym_preproc_error] = STATE(1283),
    [sym_preproc_define] = STATE(1283),
    [sym_preproc_undef] = STATE(1283),
    [aux_sym_class_declaration_repeat1] = STATE(3854),
    [aux_sym_lambda_expression_repeat1] = STATE(4229),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2193),
    [anon_sym_ref] = ACTIONS(2195),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2197),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2201),
    [anon_sym_TILDE] = ACTIONS(2201),
    [anon_sym_PLUS_PLUS] = ACTIONS(2201),
    [anon_sym_DASH_DASH] = ACTIONS(2201),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2199),
    [anon_sym_DASH] = ACTIONS(2199),
    [anon_sym_STAR] = ACTIONS(2203),
    [anon_sym_CARET] = ACTIONS(2201),
    [anon_sym_AMP] = ACTIONS(2201),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2205),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2207),
    [anon_sym_DOT_DOT] = ACTIONS(2209),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1284] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6898),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2940),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6925),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6437),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4498),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7403),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(8973),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1284),
    [sym_preproc_endregion] = STATE(1284),
    [sym_preproc_line] = STATE(1284),
    [sym_preproc_pragma] = STATE(1284),
    [sym_preproc_nullable] = STATE(1284),
    [sym_preproc_error] = STATE(1284),
    [sym_preproc_define] = STATE(1284),
    [sym_preproc_undef] = STATE(1284),
    [aux_sym_class_declaration_repeat1] = STATE(3830),
    [aux_sym_lambda_expression_repeat1] = STATE(4194),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2153),
    [anon_sym_ref] = ACTIONS(2155),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2157),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2161),
    [anon_sym_TILDE] = ACTIONS(2161),
    [anon_sym_PLUS_PLUS] = ACTIONS(2161),
    [anon_sym_DASH_DASH] = ACTIONS(2161),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2159),
    [anon_sym_DASH] = ACTIONS(2159),
    [anon_sym_STAR] = ACTIONS(2163),
    [anon_sym_CARET] = ACTIONS(2161),
    [anon_sym_AMP] = ACTIONS(2161),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2165),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2167),
    [anon_sym_DOT_DOT] = ACTIONS(2169),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1285] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6898),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2940),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6925),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6608),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4498),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7403),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(8973),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1285),
    [sym_preproc_endregion] = STATE(1285),
    [sym_preproc_line] = STATE(1285),
    [sym_preproc_pragma] = STATE(1285),
    [sym_preproc_nullable] = STATE(1285),
    [sym_preproc_error] = STATE(1285),
    [sym_preproc_define] = STATE(1285),
    [sym_preproc_undef] = STATE(1285),
    [aux_sym_class_declaration_repeat1] = STATE(3830),
    [aux_sym_lambda_expression_repeat1] = STATE(4194),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2153),
    [anon_sym_ref] = ACTIONS(2155),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2157),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2161),
    [anon_sym_TILDE] = ACTIONS(2161),
    [anon_sym_PLUS_PLUS] = ACTIONS(2161),
    [anon_sym_DASH_DASH] = ACTIONS(2161),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2159),
    [anon_sym_DASH] = ACTIONS(2159),
    [anon_sym_STAR] = ACTIONS(2163),
    [anon_sym_CARET] = ACTIONS(2161),
    [anon_sym_AMP] = ACTIONS(2161),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2165),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2167),
    [anon_sym_DOT_DOT] = ACTIONS(2169),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1286] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6893),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2968),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7023),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(3565),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4416),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7390),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9221),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1286),
    [sym_preproc_endregion] = STATE(1286),
    [sym_preproc_line] = STATE(1286),
    [sym_preproc_pragma] = STATE(1286),
    [sym_preproc_nullable] = STATE(1286),
    [sym_preproc_error] = STATE(1286),
    [sym_preproc_define] = STATE(1286),
    [sym_preproc_undef] = STATE(1286),
    [aux_sym_class_declaration_repeat1] = STATE(3808),
    [aux_sym_lambda_expression_repeat1] = STATE(4129),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_ref] = ACTIONS(2217),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(2223),
    [anon_sym_TILDE] = ACTIONS(2223),
    [anon_sym_PLUS_PLUS] = ACTIONS(2223),
    [anon_sym_DASH_DASH] = ACTIONS(2223),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2221),
    [anon_sym_DASH] = ACTIONS(2221),
    [anon_sym_STAR] = ACTIONS(2225),
    [anon_sym_CARET] = ACTIONS(2223),
    [anon_sym_AMP] = ACTIONS(2223),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2227),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2229),
    [anon_sym_DOT_DOT] = ACTIONS(2231),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1287] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6893),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2968),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7023),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6167),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4416),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7390),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9221),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1287),
    [sym_preproc_endregion] = STATE(1287),
    [sym_preproc_line] = STATE(1287),
    [sym_preproc_pragma] = STATE(1287),
    [sym_preproc_nullable] = STATE(1287),
    [sym_preproc_error] = STATE(1287),
    [sym_preproc_define] = STATE(1287),
    [sym_preproc_undef] = STATE(1287),
    [aux_sym_class_declaration_repeat1] = STATE(3808),
    [aux_sym_lambda_expression_repeat1] = STATE(4129),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_ref] = ACTIONS(2217),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(2223),
    [anon_sym_TILDE] = ACTIONS(2223),
    [anon_sym_PLUS_PLUS] = ACTIONS(2223),
    [anon_sym_DASH_DASH] = ACTIONS(2223),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2221),
    [anon_sym_DASH] = ACTIONS(2221),
    [anon_sym_STAR] = ACTIONS(2225),
    [anon_sym_CARET] = ACTIONS(2223),
    [anon_sym_AMP] = ACTIONS(2223),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2227),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2229),
    [anon_sym_DOT_DOT] = ACTIONS(2231),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1288] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6893),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2968),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7023),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6168),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4416),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7390),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9221),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1288),
    [sym_preproc_endregion] = STATE(1288),
    [sym_preproc_line] = STATE(1288),
    [sym_preproc_pragma] = STATE(1288),
    [sym_preproc_nullable] = STATE(1288),
    [sym_preproc_error] = STATE(1288),
    [sym_preproc_define] = STATE(1288),
    [sym_preproc_undef] = STATE(1288),
    [aux_sym_class_declaration_repeat1] = STATE(3808),
    [aux_sym_lambda_expression_repeat1] = STATE(4129),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_ref] = ACTIONS(2217),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(2223),
    [anon_sym_TILDE] = ACTIONS(2223),
    [anon_sym_PLUS_PLUS] = ACTIONS(2223),
    [anon_sym_DASH_DASH] = ACTIONS(2223),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2221),
    [anon_sym_DASH] = ACTIONS(2221),
    [anon_sym_STAR] = ACTIONS(2225),
    [anon_sym_CARET] = ACTIONS(2223),
    [anon_sym_AMP] = ACTIONS(2223),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2227),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2229),
    [anon_sym_DOT_DOT] = ACTIONS(2231),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1289] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6893),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2968),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7023),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6169),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4416),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7390),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9221),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1289),
    [sym_preproc_endregion] = STATE(1289),
    [sym_preproc_line] = STATE(1289),
    [sym_preproc_pragma] = STATE(1289),
    [sym_preproc_nullable] = STATE(1289),
    [sym_preproc_error] = STATE(1289),
    [sym_preproc_define] = STATE(1289),
    [sym_preproc_undef] = STATE(1289),
    [aux_sym_class_declaration_repeat1] = STATE(3808),
    [aux_sym_lambda_expression_repeat1] = STATE(4129),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_ref] = ACTIONS(2217),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(2223),
    [anon_sym_TILDE] = ACTIONS(2223),
    [anon_sym_PLUS_PLUS] = ACTIONS(2223),
    [anon_sym_DASH_DASH] = ACTIONS(2223),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2221),
    [anon_sym_DASH] = ACTIONS(2221),
    [anon_sym_STAR] = ACTIONS(2225),
    [anon_sym_CARET] = ACTIONS(2223),
    [anon_sym_AMP] = ACTIONS(2223),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2227),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2229),
    [anon_sym_DOT_DOT] = ACTIONS(2231),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1290] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6320),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1290),
    [sym_preproc_endregion] = STATE(1290),
    [sym_preproc_line] = STATE(1290),
    [sym_preproc_pragma] = STATE(1290),
    [sym_preproc_nullable] = STATE(1290),
    [sym_preproc_error] = STATE(1290),
    [sym_preproc_define] = STATE(1290),
    [sym_preproc_undef] = STATE(1290),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1291] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6893),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2968),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7023),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6170),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4416),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7390),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9221),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1291),
    [sym_preproc_endregion] = STATE(1291),
    [sym_preproc_line] = STATE(1291),
    [sym_preproc_pragma] = STATE(1291),
    [sym_preproc_nullable] = STATE(1291),
    [sym_preproc_error] = STATE(1291),
    [sym_preproc_define] = STATE(1291),
    [sym_preproc_undef] = STATE(1291),
    [aux_sym_class_declaration_repeat1] = STATE(3808),
    [aux_sym_lambda_expression_repeat1] = STATE(4129),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_ref] = ACTIONS(2217),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(2223),
    [anon_sym_TILDE] = ACTIONS(2223),
    [anon_sym_PLUS_PLUS] = ACTIONS(2223),
    [anon_sym_DASH_DASH] = ACTIONS(2223),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2221),
    [anon_sym_DASH] = ACTIONS(2221),
    [anon_sym_STAR] = ACTIONS(2225),
    [anon_sym_CARET] = ACTIONS(2223),
    [anon_sym_AMP] = ACTIONS(2223),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2227),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2229),
    [anon_sym_DOT_DOT] = ACTIONS(2231),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1292] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6893),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2968),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7023),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6171),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4416),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7390),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9221),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1292),
    [sym_preproc_endregion] = STATE(1292),
    [sym_preproc_line] = STATE(1292),
    [sym_preproc_pragma] = STATE(1292),
    [sym_preproc_nullable] = STATE(1292),
    [sym_preproc_error] = STATE(1292),
    [sym_preproc_define] = STATE(1292),
    [sym_preproc_undef] = STATE(1292),
    [aux_sym_class_declaration_repeat1] = STATE(3808),
    [aux_sym_lambda_expression_repeat1] = STATE(4129),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_ref] = ACTIONS(2217),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(2223),
    [anon_sym_TILDE] = ACTIONS(2223),
    [anon_sym_PLUS_PLUS] = ACTIONS(2223),
    [anon_sym_DASH_DASH] = ACTIONS(2223),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2221),
    [anon_sym_DASH] = ACTIONS(2221),
    [anon_sym_STAR] = ACTIONS(2225),
    [anon_sym_CARET] = ACTIONS(2223),
    [anon_sym_AMP] = ACTIONS(2223),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2227),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2229),
    [anon_sym_DOT_DOT] = ACTIONS(2231),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1293] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6893),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2968),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7023),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6172),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4416),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7390),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9221),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1293),
    [sym_preproc_endregion] = STATE(1293),
    [sym_preproc_line] = STATE(1293),
    [sym_preproc_pragma] = STATE(1293),
    [sym_preproc_nullable] = STATE(1293),
    [sym_preproc_error] = STATE(1293),
    [sym_preproc_define] = STATE(1293),
    [sym_preproc_undef] = STATE(1293),
    [aux_sym_class_declaration_repeat1] = STATE(3808),
    [aux_sym_lambda_expression_repeat1] = STATE(4129),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_ref] = ACTIONS(2217),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(2223),
    [anon_sym_TILDE] = ACTIONS(2223),
    [anon_sym_PLUS_PLUS] = ACTIONS(2223),
    [anon_sym_DASH_DASH] = ACTIONS(2223),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2221),
    [anon_sym_DASH] = ACTIONS(2221),
    [anon_sym_STAR] = ACTIONS(2225),
    [anon_sym_CARET] = ACTIONS(2223),
    [anon_sym_AMP] = ACTIONS(2223),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2227),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2229),
    [anon_sym_DOT_DOT] = ACTIONS(2231),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1294] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6893),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2968),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7023),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6173),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4416),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7390),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9221),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1294),
    [sym_preproc_endregion] = STATE(1294),
    [sym_preproc_line] = STATE(1294),
    [sym_preproc_pragma] = STATE(1294),
    [sym_preproc_nullable] = STATE(1294),
    [sym_preproc_error] = STATE(1294),
    [sym_preproc_define] = STATE(1294),
    [sym_preproc_undef] = STATE(1294),
    [aux_sym_class_declaration_repeat1] = STATE(3808),
    [aux_sym_lambda_expression_repeat1] = STATE(4129),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_ref] = ACTIONS(2217),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(2223),
    [anon_sym_TILDE] = ACTIONS(2223),
    [anon_sym_PLUS_PLUS] = ACTIONS(2223),
    [anon_sym_DASH_DASH] = ACTIONS(2223),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2221),
    [anon_sym_DASH] = ACTIONS(2221),
    [anon_sym_STAR] = ACTIONS(2225),
    [anon_sym_CARET] = ACTIONS(2223),
    [anon_sym_AMP] = ACTIONS(2223),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2227),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2229),
    [anon_sym_DOT_DOT] = ACTIONS(2231),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1295] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6893),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2968),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7023),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6174),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4416),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7390),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9221),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1295),
    [sym_preproc_endregion] = STATE(1295),
    [sym_preproc_line] = STATE(1295),
    [sym_preproc_pragma] = STATE(1295),
    [sym_preproc_nullable] = STATE(1295),
    [sym_preproc_error] = STATE(1295),
    [sym_preproc_define] = STATE(1295),
    [sym_preproc_undef] = STATE(1295),
    [aux_sym_class_declaration_repeat1] = STATE(3808),
    [aux_sym_lambda_expression_repeat1] = STATE(4129),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_ref] = ACTIONS(2217),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(2223),
    [anon_sym_TILDE] = ACTIONS(2223),
    [anon_sym_PLUS_PLUS] = ACTIONS(2223),
    [anon_sym_DASH_DASH] = ACTIONS(2223),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2221),
    [anon_sym_DASH] = ACTIONS(2221),
    [anon_sym_STAR] = ACTIONS(2225),
    [anon_sym_CARET] = ACTIONS(2223),
    [anon_sym_AMP] = ACTIONS(2223),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2227),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2229),
    [anon_sym_DOT_DOT] = ACTIONS(2231),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1296] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6893),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2968),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7023),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6176),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4416),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7390),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9221),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1296),
    [sym_preproc_endregion] = STATE(1296),
    [sym_preproc_line] = STATE(1296),
    [sym_preproc_pragma] = STATE(1296),
    [sym_preproc_nullable] = STATE(1296),
    [sym_preproc_error] = STATE(1296),
    [sym_preproc_define] = STATE(1296),
    [sym_preproc_undef] = STATE(1296),
    [aux_sym_class_declaration_repeat1] = STATE(3808),
    [aux_sym_lambda_expression_repeat1] = STATE(4129),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_ref] = ACTIONS(2217),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(2223),
    [anon_sym_TILDE] = ACTIONS(2223),
    [anon_sym_PLUS_PLUS] = ACTIONS(2223),
    [anon_sym_DASH_DASH] = ACTIONS(2223),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2221),
    [anon_sym_DASH] = ACTIONS(2221),
    [anon_sym_STAR] = ACTIONS(2225),
    [anon_sym_CARET] = ACTIONS(2223),
    [anon_sym_AMP] = ACTIONS(2223),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2227),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2229),
    [anon_sym_DOT_DOT] = ACTIONS(2231),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1297] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6893),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2968),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7023),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6177),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4416),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7390),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9221),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1297),
    [sym_preproc_endregion] = STATE(1297),
    [sym_preproc_line] = STATE(1297),
    [sym_preproc_pragma] = STATE(1297),
    [sym_preproc_nullable] = STATE(1297),
    [sym_preproc_error] = STATE(1297),
    [sym_preproc_define] = STATE(1297),
    [sym_preproc_undef] = STATE(1297),
    [aux_sym_class_declaration_repeat1] = STATE(3808),
    [aux_sym_lambda_expression_repeat1] = STATE(4129),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_ref] = ACTIONS(2217),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(2223),
    [anon_sym_TILDE] = ACTIONS(2223),
    [anon_sym_PLUS_PLUS] = ACTIONS(2223),
    [anon_sym_DASH_DASH] = ACTIONS(2223),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2221),
    [anon_sym_DASH] = ACTIONS(2221),
    [anon_sym_STAR] = ACTIONS(2225),
    [anon_sym_CARET] = ACTIONS(2223),
    [anon_sym_AMP] = ACTIONS(2223),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2227),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2229),
    [anon_sym_DOT_DOT] = ACTIONS(2231),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1298] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6893),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2968),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7023),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6179),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4416),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7390),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9221),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1298),
    [sym_preproc_endregion] = STATE(1298),
    [sym_preproc_line] = STATE(1298),
    [sym_preproc_pragma] = STATE(1298),
    [sym_preproc_nullable] = STATE(1298),
    [sym_preproc_error] = STATE(1298),
    [sym_preproc_define] = STATE(1298),
    [sym_preproc_undef] = STATE(1298),
    [aux_sym_class_declaration_repeat1] = STATE(3808),
    [aux_sym_lambda_expression_repeat1] = STATE(4129),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_ref] = ACTIONS(2217),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(2223),
    [anon_sym_TILDE] = ACTIONS(2223),
    [anon_sym_PLUS_PLUS] = ACTIONS(2223),
    [anon_sym_DASH_DASH] = ACTIONS(2223),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2221),
    [anon_sym_DASH] = ACTIONS(2221),
    [anon_sym_STAR] = ACTIONS(2225),
    [anon_sym_CARET] = ACTIONS(2223),
    [anon_sym_AMP] = ACTIONS(2223),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2227),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2229),
    [anon_sym_DOT_DOT] = ACTIONS(2231),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1299] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6054),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1299),
    [sym_preproc_endregion] = STATE(1299),
    [sym_preproc_line] = STATE(1299),
    [sym_preproc_pragma] = STATE(1299),
    [sym_preproc_nullable] = STATE(1299),
    [sym_preproc_error] = STATE(1299),
    [sym_preproc_define] = STATE(1299),
    [sym_preproc_undef] = STATE(1299),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1300] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6901),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2939),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7050),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4309),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4507),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7378),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9063),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1300),
    [sym_preproc_endregion] = STATE(1300),
    [sym_preproc_line] = STATE(1300),
    [sym_preproc_pragma] = STATE(1300),
    [sym_preproc_nullable] = STATE(1300),
    [sym_preproc_error] = STATE(1300),
    [sym_preproc_define] = STATE(1300),
    [sym_preproc_undef] = STATE(1300),
    [aux_sym_class_declaration_repeat1] = STATE(3854),
    [aux_sym_lambda_expression_repeat1] = STATE(4229),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2193),
    [anon_sym_ref] = ACTIONS(2195),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2197),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2201),
    [anon_sym_TILDE] = ACTIONS(2201),
    [anon_sym_PLUS_PLUS] = ACTIONS(2201),
    [anon_sym_DASH_DASH] = ACTIONS(2201),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2199),
    [anon_sym_DASH] = ACTIONS(2199),
    [anon_sym_STAR] = ACTIONS(2203),
    [anon_sym_CARET] = ACTIONS(2201),
    [anon_sym_AMP] = ACTIONS(2201),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2205),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2207),
    [anon_sym_DOT_DOT] = ACTIONS(2209),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1301] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6901),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2939),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7050),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6296),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4507),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7378),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9063),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1301),
    [sym_preproc_endregion] = STATE(1301),
    [sym_preproc_line] = STATE(1301),
    [sym_preproc_pragma] = STATE(1301),
    [sym_preproc_nullable] = STATE(1301),
    [sym_preproc_error] = STATE(1301),
    [sym_preproc_define] = STATE(1301),
    [sym_preproc_undef] = STATE(1301),
    [aux_sym_class_declaration_repeat1] = STATE(3854),
    [aux_sym_lambda_expression_repeat1] = STATE(4229),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2193),
    [anon_sym_ref] = ACTIONS(2195),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2197),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2201),
    [anon_sym_TILDE] = ACTIONS(2201),
    [anon_sym_PLUS_PLUS] = ACTIONS(2201),
    [anon_sym_DASH_DASH] = ACTIONS(2201),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2199),
    [anon_sym_DASH] = ACTIONS(2199),
    [anon_sym_STAR] = ACTIONS(2203),
    [anon_sym_CARET] = ACTIONS(2201),
    [anon_sym_AMP] = ACTIONS(2201),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2205),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2207),
    [anon_sym_DOT_DOT] = ACTIONS(2209),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1302] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6901),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2939),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7050),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6295),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4507),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7378),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9063),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1302),
    [sym_preproc_endregion] = STATE(1302),
    [sym_preproc_line] = STATE(1302),
    [sym_preproc_pragma] = STATE(1302),
    [sym_preproc_nullable] = STATE(1302),
    [sym_preproc_error] = STATE(1302),
    [sym_preproc_define] = STATE(1302),
    [sym_preproc_undef] = STATE(1302),
    [aux_sym_class_declaration_repeat1] = STATE(3854),
    [aux_sym_lambda_expression_repeat1] = STATE(4229),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2193),
    [anon_sym_ref] = ACTIONS(2195),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2197),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2201),
    [anon_sym_TILDE] = ACTIONS(2201),
    [anon_sym_PLUS_PLUS] = ACTIONS(2201),
    [anon_sym_DASH_DASH] = ACTIONS(2201),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2199),
    [anon_sym_DASH] = ACTIONS(2199),
    [anon_sym_STAR] = ACTIONS(2203),
    [anon_sym_CARET] = ACTIONS(2201),
    [anon_sym_AMP] = ACTIONS(2201),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2205),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2207),
    [anon_sym_DOT_DOT] = ACTIONS(2209),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1303] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6893),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2968),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7023),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6089),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4416),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7390),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9221),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1303),
    [sym_preproc_endregion] = STATE(1303),
    [sym_preproc_line] = STATE(1303),
    [sym_preproc_pragma] = STATE(1303),
    [sym_preproc_nullable] = STATE(1303),
    [sym_preproc_error] = STATE(1303),
    [sym_preproc_define] = STATE(1303),
    [sym_preproc_undef] = STATE(1303),
    [aux_sym_class_declaration_repeat1] = STATE(3808),
    [aux_sym_lambda_expression_repeat1] = STATE(4129),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_ref] = ACTIONS(2217),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(2223),
    [anon_sym_TILDE] = ACTIONS(2223),
    [anon_sym_PLUS_PLUS] = ACTIONS(2223),
    [anon_sym_DASH_DASH] = ACTIONS(2223),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2221),
    [anon_sym_DASH] = ACTIONS(2221),
    [anon_sym_STAR] = ACTIONS(2225),
    [anon_sym_CARET] = ACTIONS(2223),
    [anon_sym_AMP] = ACTIONS(2223),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2227),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2229),
    [anon_sym_DOT_DOT] = ACTIONS(2231),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1304] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6918),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7126),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(3556),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(3736),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7377),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9441),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1304),
    [sym_preproc_endregion] = STATE(1304),
    [sym_preproc_line] = STATE(1304),
    [sym_preproc_pragma] = STATE(1304),
    [sym_preproc_nullable] = STATE(1304),
    [sym_preproc_error] = STATE(1304),
    [sym_preproc_define] = STATE(1304),
    [sym_preproc_undef] = STATE(1304),
    [aux_sym_class_declaration_repeat1] = STATE(3848),
    [aux_sym_lambda_expression_repeat1] = STATE(4242),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1213),
    [anon_sym_ref] = ACTIONS(1215),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1221),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1227),
    [anon_sym_TILDE] = ACTIONS(1227),
    [anon_sym_PLUS_PLUS] = ACTIONS(1227),
    [anon_sym_DASH_DASH] = ACTIONS(1227),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1225),
    [anon_sym_DASH] = ACTIONS(1225),
    [anon_sym_STAR] = ACTIONS(1231),
    [anon_sym_CARET] = ACTIONS(1227),
    [anon_sym_AMP] = ACTIONS(1227),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1239),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1241),
    [anon_sym_DOT_DOT] = ACTIONS(1243),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1305] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6874),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2968),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6941),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5670),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4214),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7412),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9154),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1305),
    [sym_preproc_endregion] = STATE(1305),
    [sym_preproc_line] = STATE(1305),
    [sym_preproc_pragma] = STATE(1305),
    [sym_preproc_nullable] = STATE(1305),
    [sym_preproc_error] = STATE(1305),
    [sym_preproc_define] = STATE(1305),
    [sym_preproc_undef] = STATE(1305),
    [aux_sym_class_declaration_repeat1] = STATE(3798),
    [aux_sym_lambda_expression_repeat1] = STATE(4162),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1777),
    [anon_sym_ref] = ACTIONS(1779),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1781),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1785),
    [anon_sym_TILDE] = ACTIONS(1785),
    [anon_sym_PLUS_PLUS] = ACTIONS(1785),
    [anon_sym_DASH_DASH] = ACTIONS(1785),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_STAR] = ACTIONS(1787),
    [anon_sym_CARET] = ACTIONS(1785),
    [anon_sym_AMP] = ACTIONS(1785),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1789),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1791),
    [anon_sym_DOT_DOT] = ACTIONS(1793),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1306] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6918),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7126),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4745),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(3736),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7377),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9441),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1306),
    [sym_preproc_endregion] = STATE(1306),
    [sym_preproc_line] = STATE(1306),
    [sym_preproc_pragma] = STATE(1306),
    [sym_preproc_nullable] = STATE(1306),
    [sym_preproc_error] = STATE(1306),
    [sym_preproc_define] = STATE(1306),
    [sym_preproc_undef] = STATE(1306),
    [aux_sym_class_declaration_repeat1] = STATE(3848),
    [aux_sym_lambda_expression_repeat1] = STATE(4242),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1213),
    [anon_sym_ref] = ACTIONS(1215),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1221),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1227),
    [anon_sym_TILDE] = ACTIONS(1227),
    [anon_sym_PLUS_PLUS] = ACTIONS(1227),
    [anon_sym_DASH_DASH] = ACTIONS(1227),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1225),
    [anon_sym_DASH] = ACTIONS(1225),
    [anon_sym_STAR] = ACTIONS(1231),
    [anon_sym_CARET] = ACTIONS(1227),
    [anon_sym_AMP] = ACTIONS(1227),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1239),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1241),
    [anon_sym_DOT_DOT] = ACTIONS(1243),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1307] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6901),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2939),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7050),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6292),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4507),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7378),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9063),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1307),
    [sym_preproc_endregion] = STATE(1307),
    [sym_preproc_line] = STATE(1307),
    [sym_preproc_pragma] = STATE(1307),
    [sym_preproc_nullable] = STATE(1307),
    [sym_preproc_error] = STATE(1307),
    [sym_preproc_define] = STATE(1307),
    [sym_preproc_undef] = STATE(1307),
    [aux_sym_class_declaration_repeat1] = STATE(3854),
    [aux_sym_lambda_expression_repeat1] = STATE(4229),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2193),
    [anon_sym_ref] = ACTIONS(2195),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2197),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2201),
    [anon_sym_TILDE] = ACTIONS(2201),
    [anon_sym_PLUS_PLUS] = ACTIONS(2201),
    [anon_sym_DASH_DASH] = ACTIONS(2201),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2199),
    [anon_sym_DASH] = ACTIONS(2199),
    [anon_sym_STAR] = ACTIONS(2203),
    [anon_sym_CARET] = ACTIONS(2201),
    [anon_sym_AMP] = ACTIONS(2201),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2205),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2207),
    [anon_sym_DOT_DOT] = ACTIONS(2209),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1308] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6893),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2968),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7023),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6189),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4416),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7390),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9221),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1308),
    [sym_preproc_endregion] = STATE(1308),
    [sym_preproc_line] = STATE(1308),
    [sym_preproc_pragma] = STATE(1308),
    [sym_preproc_nullable] = STATE(1308),
    [sym_preproc_error] = STATE(1308),
    [sym_preproc_define] = STATE(1308),
    [sym_preproc_undef] = STATE(1308),
    [aux_sym_class_declaration_repeat1] = STATE(3808),
    [aux_sym_lambda_expression_repeat1] = STATE(4129),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_ref] = ACTIONS(2217),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(2223),
    [anon_sym_TILDE] = ACTIONS(2223),
    [anon_sym_PLUS_PLUS] = ACTIONS(2223),
    [anon_sym_DASH_DASH] = ACTIONS(2223),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2221),
    [anon_sym_DASH] = ACTIONS(2221),
    [anon_sym_STAR] = ACTIONS(2225),
    [anon_sym_CARET] = ACTIONS(2223),
    [anon_sym_AMP] = ACTIONS(2223),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2227),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2229),
    [anon_sym_DOT_DOT] = ACTIONS(2231),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1309] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6898),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2940),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6925),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6315),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4498),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7403),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(8973),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1309),
    [sym_preproc_endregion] = STATE(1309),
    [sym_preproc_line] = STATE(1309),
    [sym_preproc_pragma] = STATE(1309),
    [sym_preproc_nullable] = STATE(1309),
    [sym_preproc_error] = STATE(1309),
    [sym_preproc_define] = STATE(1309),
    [sym_preproc_undef] = STATE(1309),
    [aux_sym_class_declaration_repeat1] = STATE(3830),
    [aux_sym_lambda_expression_repeat1] = STATE(4194),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2153),
    [anon_sym_ref] = ACTIONS(2155),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2157),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2161),
    [anon_sym_TILDE] = ACTIONS(2161),
    [anon_sym_PLUS_PLUS] = ACTIONS(2161),
    [anon_sym_DASH_DASH] = ACTIONS(2161),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2159),
    [anon_sym_DASH] = ACTIONS(2159),
    [anon_sym_STAR] = ACTIONS(2163),
    [anon_sym_CARET] = ACTIONS(2161),
    [anon_sym_AMP] = ACTIONS(2161),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2165),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2167),
    [anon_sym_DOT_DOT] = ACTIONS(2169),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1310] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6901),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2939),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7050),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6288),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4507),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7378),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9063),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1310),
    [sym_preproc_endregion] = STATE(1310),
    [sym_preproc_line] = STATE(1310),
    [sym_preproc_pragma] = STATE(1310),
    [sym_preproc_nullable] = STATE(1310),
    [sym_preproc_error] = STATE(1310),
    [sym_preproc_define] = STATE(1310),
    [sym_preproc_undef] = STATE(1310),
    [aux_sym_class_declaration_repeat1] = STATE(3854),
    [aux_sym_lambda_expression_repeat1] = STATE(4229),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2193),
    [anon_sym_ref] = ACTIONS(2195),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2197),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2201),
    [anon_sym_TILDE] = ACTIONS(2201),
    [anon_sym_PLUS_PLUS] = ACTIONS(2201),
    [anon_sym_DASH_DASH] = ACTIONS(2201),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2199),
    [anon_sym_DASH] = ACTIONS(2199),
    [anon_sym_STAR] = ACTIONS(2203),
    [anon_sym_CARET] = ACTIONS(2201),
    [anon_sym_AMP] = ACTIONS(2201),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2205),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2207),
    [anon_sym_DOT_DOT] = ACTIONS(2209),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1311] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6893),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2968),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7023),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(3556),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4416),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7390),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9221),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1311),
    [sym_preproc_endregion] = STATE(1311),
    [sym_preproc_line] = STATE(1311),
    [sym_preproc_pragma] = STATE(1311),
    [sym_preproc_nullable] = STATE(1311),
    [sym_preproc_error] = STATE(1311),
    [sym_preproc_define] = STATE(1311),
    [sym_preproc_undef] = STATE(1311),
    [aux_sym_class_declaration_repeat1] = STATE(3808),
    [aux_sym_lambda_expression_repeat1] = STATE(4129),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_ref] = ACTIONS(2217),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(2223),
    [anon_sym_TILDE] = ACTIONS(2223),
    [anon_sym_PLUS_PLUS] = ACTIONS(2223),
    [anon_sym_DASH_DASH] = ACTIONS(2223),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2221),
    [anon_sym_DASH] = ACTIONS(2221),
    [anon_sym_STAR] = ACTIONS(2225),
    [anon_sym_CARET] = ACTIONS(2223),
    [anon_sym_AMP] = ACTIONS(2223),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2227),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2229),
    [anon_sym_DOT_DOT] = ACTIONS(2231),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1312] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6893),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2968),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7023),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6191),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4416),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7390),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9221),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1312),
    [sym_preproc_endregion] = STATE(1312),
    [sym_preproc_line] = STATE(1312),
    [sym_preproc_pragma] = STATE(1312),
    [sym_preproc_nullable] = STATE(1312),
    [sym_preproc_error] = STATE(1312),
    [sym_preproc_define] = STATE(1312),
    [sym_preproc_undef] = STATE(1312),
    [aux_sym_class_declaration_repeat1] = STATE(3808),
    [aux_sym_lambda_expression_repeat1] = STATE(4129),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_ref] = ACTIONS(2217),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(2223),
    [anon_sym_TILDE] = ACTIONS(2223),
    [anon_sym_PLUS_PLUS] = ACTIONS(2223),
    [anon_sym_DASH_DASH] = ACTIONS(2223),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2221),
    [anon_sym_DASH] = ACTIONS(2221),
    [anon_sym_STAR] = ACTIONS(2225),
    [anon_sym_CARET] = ACTIONS(2223),
    [anon_sym_AMP] = ACTIONS(2223),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2227),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2229),
    [anon_sym_DOT_DOT] = ACTIONS(2231),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1313] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6901),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2939),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7050),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6283),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4507),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7378),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9063),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1313),
    [sym_preproc_endregion] = STATE(1313),
    [sym_preproc_line] = STATE(1313),
    [sym_preproc_pragma] = STATE(1313),
    [sym_preproc_nullable] = STATE(1313),
    [sym_preproc_error] = STATE(1313),
    [sym_preproc_define] = STATE(1313),
    [sym_preproc_undef] = STATE(1313),
    [aux_sym_class_declaration_repeat1] = STATE(3854),
    [aux_sym_lambda_expression_repeat1] = STATE(4229),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2193),
    [anon_sym_ref] = ACTIONS(2195),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2197),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2201),
    [anon_sym_TILDE] = ACTIONS(2201),
    [anon_sym_PLUS_PLUS] = ACTIONS(2201),
    [anon_sym_DASH_DASH] = ACTIONS(2201),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2199),
    [anon_sym_DASH] = ACTIONS(2199),
    [anon_sym_STAR] = ACTIONS(2203),
    [anon_sym_CARET] = ACTIONS(2201),
    [anon_sym_AMP] = ACTIONS(2201),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2205),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2207),
    [anon_sym_DOT_DOT] = ACTIONS(2209),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1314] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6880),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7055),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(3922),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4312),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7380),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9286),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1314),
    [sym_preproc_endregion] = STATE(1314),
    [sym_preproc_line] = STATE(1314),
    [sym_preproc_pragma] = STATE(1314),
    [sym_preproc_nullable] = STATE(1314),
    [sym_preproc_error] = STATE(1314),
    [sym_preproc_define] = STATE(1314),
    [sym_preproc_undef] = STATE(1314),
    [aux_sym_class_declaration_repeat1] = STATE(3799),
    [aux_sym_lambda_expression_repeat1] = STATE(4101),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1545),
    [anon_sym_ref] = ACTIONS(1547),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1551),
    [anon_sym_TILDE] = ACTIONS(1551),
    [anon_sym_PLUS_PLUS] = ACTIONS(1551),
    [anon_sym_DASH_DASH] = ACTIONS(1551),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1549),
    [anon_sym_DASH] = ACTIONS(1549),
    [anon_sym_STAR] = ACTIONS(1553),
    [anon_sym_CARET] = ACTIONS(1551),
    [anon_sym_AMP] = ACTIONS(1551),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1555),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1557),
    [anon_sym_DOT_DOT] = ACTIONS(1559),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1315] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6901),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2939),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7050),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6410),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4507),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7378),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9063),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1315),
    [sym_preproc_endregion] = STATE(1315),
    [sym_preproc_line] = STATE(1315),
    [sym_preproc_pragma] = STATE(1315),
    [sym_preproc_nullable] = STATE(1315),
    [sym_preproc_error] = STATE(1315),
    [sym_preproc_define] = STATE(1315),
    [sym_preproc_undef] = STATE(1315),
    [aux_sym_class_declaration_repeat1] = STATE(3854),
    [aux_sym_lambda_expression_repeat1] = STATE(4229),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2193),
    [anon_sym_ref] = ACTIONS(2195),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2197),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2201),
    [anon_sym_TILDE] = ACTIONS(2201),
    [anon_sym_PLUS_PLUS] = ACTIONS(2201),
    [anon_sym_DASH_DASH] = ACTIONS(2201),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2199),
    [anon_sym_DASH] = ACTIONS(2199),
    [anon_sym_STAR] = ACTIONS(2203),
    [anon_sym_CARET] = ACTIONS(2201),
    [anon_sym_AMP] = ACTIONS(2201),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2205),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2207),
    [anon_sym_DOT_DOT] = ACTIONS(2209),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1316] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6880),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7055),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5925),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4312),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7380),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9286),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1316),
    [sym_preproc_endregion] = STATE(1316),
    [sym_preproc_line] = STATE(1316),
    [sym_preproc_pragma] = STATE(1316),
    [sym_preproc_nullable] = STATE(1316),
    [sym_preproc_error] = STATE(1316),
    [sym_preproc_define] = STATE(1316),
    [sym_preproc_undef] = STATE(1316),
    [aux_sym_class_declaration_repeat1] = STATE(3799),
    [aux_sym_lambda_expression_repeat1] = STATE(4101),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1545),
    [anon_sym_ref] = ACTIONS(1547),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1551),
    [anon_sym_TILDE] = ACTIONS(1551),
    [anon_sym_PLUS_PLUS] = ACTIONS(1551),
    [anon_sym_DASH_DASH] = ACTIONS(1551),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1549),
    [anon_sym_DASH] = ACTIONS(1549),
    [anon_sym_STAR] = ACTIONS(1553),
    [anon_sym_CARET] = ACTIONS(1551),
    [anon_sym_AMP] = ACTIONS(1551),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1555),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1557),
    [anon_sym_DOT_DOT] = ACTIONS(1559),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1317] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6880),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7055),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5926),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4312),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7380),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9286),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1317),
    [sym_preproc_endregion] = STATE(1317),
    [sym_preproc_line] = STATE(1317),
    [sym_preproc_pragma] = STATE(1317),
    [sym_preproc_nullable] = STATE(1317),
    [sym_preproc_error] = STATE(1317),
    [sym_preproc_define] = STATE(1317),
    [sym_preproc_undef] = STATE(1317),
    [aux_sym_class_declaration_repeat1] = STATE(3799),
    [aux_sym_lambda_expression_repeat1] = STATE(4101),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1545),
    [anon_sym_ref] = ACTIONS(1547),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1551),
    [anon_sym_TILDE] = ACTIONS(1551),
    [anon_sym_PLUS_PLUS] = ACTIONS(1551),
    [anon_sym_DASH_DASH] = ACTIONS(1551),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1549),
    [anon_sym_DASH] = ACTIONS(1549),
    [anon_sym_STAR] = ACTIONS(1553),
    [anon_sym_CARET] = ACTIONS(1551),
    [anon_sym_AMP] = ACTIONS(1551),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1555),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1557),
    [anon_sym_DOT_DOT] = ACTIONS(1559),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1318] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6880),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7055),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5927),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4312),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7380),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9286),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1318),
    [sym_preproc_endregion] = STATE(1318),
    [sym_preproc_line] = STATE(1318),
    [sym_preproc_pragma] = STATE(1318),
    [sym_preproc_nullable] = STATE(1318),
    [sym_preproc_error] = STATE(1318),
    [sym_preproc_define] = STATE(1318),
    [sym_preproc_undef] = STATE(1318),
    [aux_sym_class_declaration_repeat1] = STATE(3799),
    [aux_sym_lambda_expression_repeat1] = STATE(4101),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1545),
    [anon_sym_ref] = ACTIONS(1547),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1551),
    [anon_sym_TILDE] = ACTIONS(1551),
    [anon_sym_PLUS_PLUS] = ACTIONS(1551),
    [anon_sym_DASH_DASH] = ACTIONS(1551),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1549),
    [anon_sym_DASH] = ACTIONS(1549),
    [anon_sym_STAR] = ACTIONS(1553),
    [anon_sym_CARET] = ACTIONS(1551),
    [anon_sym_AMP] = ACTIONS(1551),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1555),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1557),
    [anon_sym_DOT_DOT] = ACTIONS(1559),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1319] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6880),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7055),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5928),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4312),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7380),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9286),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1319),
    [sym_preproc_endregion] = STATE(1319),
    [sym_preproc_line] = STATE(1319),
    [sym_preproc_pragma] = STATE(1319),
    [sym_preproc_nullable] = STATE(1319),
    [sym_preproc_error] = STATE(1319),
    [sym_preproc_define] = STATE(1319),
    [sym_preproc_undef] = STATE(1319),
    [aux_sym_class_declaration_repeat1] = STATE(3799),
    [aux_sym_lambda_expression_repeat1] = STATE(4101),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1545),
    [anon_sym_ref] = ACTIONS(1547),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1551),
    [anon_sym_TILDE] = ACTIONS(1551),
    [anon_sym_PLUS_PLUS] = ACTIONS(1551),
    [anon_sym_DASH_DASH] = ACTIONS(1551),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1549),
    [anon_sym_DASH] = ACTIONS(1549),
    [anon_sym_STAR] = ACTIONS(1553),
    [anon_sym_CARET] = ACTIONS(1551),
    [anon_sym_AMP] = ACTIONS(1551),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1555),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1557),
    [anon_sym_DOT_DOT] = ACTIONS(1559),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1320] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6898),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2940),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6925),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6406),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4498),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7403),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(8973),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1320),
    [sym_preproc_endregion] = STATE(1320),
    [sym_preproc_line] = STATE(1320),
    [sym_preproc_pragma] = STATE(1320),
    [sym_preproc_nullable] = STATE(1320),
    [sym_preproc_error] = STATE(1320),
    [sym_preproc_define] = STATE(1320),
    [sym_preproc_undef] = STATE(1320),
    [aux_sym_class_declaration_repeat1] = STATE(3830),
    [aux_sym_lambda_expression_repeat1] = STATE(4194),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2153),
    [anon_sym_ref] = ACTIONS(2155),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2157),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2161),
    [anon_sym_TILDE] = ACTIONS(2161),
    [anon_sym_PLUS_PLUS] = ACTIONS(2161),
    [anon_sym_DASH_DASH] = ACTIONS(2161),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2159),
    [anon_sym_DASH] = ACTIONS(2159),
    [anon_sym_STAR] = ACTIONS(2163),
    [anon_sym_CARET] = ACTIONS(2161),
    [anon_sym_AMP] = ACTIONS(2161),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2165),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2167),
    [anon_sym_DOT_DOT] = ACTIONS(2169),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1321] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6880),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7055),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5929),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4312),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7380),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9286),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1321),
    [sym_preproc_endregion] = STATE(1321),
    [sym_preproc_line] = STATE(1321),
    [sym_preproc_pragma] = STATE(1321),
    [sym_preproc_nullable] = STATE(1321),
    [sym_preproc_error] = STATE(1321),
    [sym_preproc_define] = STATE(1321),
    [sym_preproc_undef] = STATE(1321),
    [aux_sym_class_declaration_repeat1] = STATE(3799),
    [aux_sym_lambda_expression_repeat1] = STATE(4101),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1545),
    [anon_sym_ref] = ACTIONS(1547),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1551),
    [anon_sym_TILDE] = ACTIONS(1551),
    [anon_sym_PLUS_PLUS] = ACTIONS(1551),
    [anon_sym_DASH_DASH] = ACTIONS(1551),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1549),
    [anon_sym_DASH] = ACTIONS(1549),
    [anon_sym_STAR] = ACTIONS(1553),
    [anon_sym_CARET] = ACTIONS(1551),
    [anon_sym_AMP] = ACTIONS(1551),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1555),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1557),
    [anon_sym_DOT_DOT] = ACTIONS(1559),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1322] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6880),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7055),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5930),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4312),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7380),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9286),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1322),
    [sym_preproc_endregion] = STATE(1322),
    [sym_preproc_line] = STATE(1322),
    [sym_preproc_pragma] = STATE(1322),
    [sym_preproc_nullable] = STATE(1322),
    [sym_preproc_error] = STATE(1322),
    [sym_preproc_define] = STATE(1322),
    [sym_preproc_undef] = STATE(1322),
    [aux_sym_class_declaration_repeat1] = STATE(3799),
    [aux_sym_lambda_expression_repeat1] = STATE(4101),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1545),
    [anon_sym_ref] = ACTIONS(1547),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1551),
    [anon_sym_TILDE] = ACTIONS(1551),
    [anon_sym_PLUS_PLUS] = ACTIONS(1551),
    [anon_sym_DASH_DASH] = ACTIONS(1551),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1549),
    [anon_sym_DASH] = ACTIONS(1549),
    [anon_sym_STAR] = ACTIONS(1553),
    [anon_sym_CARET] = ACTIONS(1551),
    [anon_sym_AMP] = ACTIONS(1551),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1555),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1557),
    [anon_sym_DOT_DOT] = ACTIONS(1559),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1323] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6880),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7055),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5941),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4312),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7380),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9286),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1323),
    [sym_preproc_endregion] = STATE(1323),
    [sym_preproc_line] = STATE(1323),
    [sym_preproc_pragma] = STATE(1323),
    [sym_preproc_nullable] = STATE(1323),
    [sym_preproc_error] = STATE(1323),
    [sym_preproc_define] = STATE(1323),
    [sym_preproc_undef] = STATE(1323),
    [aux_sym_class_declaration_repeat1] = STATE(3799),
    [aux_sym_lambda_expression_repeat1] = STATE(4101),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1545),
    [anon_sym_ref] = ACTIONS(1547),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1551),
    [anon_sym_TILDE] = ACTIONS(1551),
    [anon_sym_PLUS_PLUS] = ACTIONS(1551),
    [anon_sym_DASH_DASH] = ACTIONS(1551),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1549),
    [anon_sym_DASH] = ACTIONS(1549),
    [anon_sym_STAR] = ACTIONS(1553),
    [anon_sym_CARET] = ACTIONS(1551),
    [anon_sym_AMP] = ACTIONS(1551),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1555),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1557),
    [anon_sym_DOT_DOT] = ACTIONS(1559),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1324] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6880),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7055),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5951),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4312),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7380),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9286),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1324),
    [sym_preproc_endregion] = STATE(1324),
    [sym_preproc_line] = STATE(1324),
    [sym_preproc_pragma] = STATE(1324),
    [sym_preproc_nullable] = STATE(1324),
    [sym_preproc_error] = STATE(1324),
    [sym_preproc_define] = STATE(1324),
    [sym_preproc_undef] = STATE(1324),
    [aux_sym_class_declaration_repeat1] = STATE(3799),
    [aux_sym_lambda_expression_repeat1] = STATE(4101),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1545),
    [anon_sym_ref] = ACTIONS(1547),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1551),
    [anon_sym_TILDE] = ACTIONS(1551),
    [anon_sym_PLUS_PLUS] = ACTIONS(1551),
    [anon_sym_DASH_DASH] = ACTIONS(1551),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1549),
    [anon_sym_DASH] = ACTIONS(1549),
    [anon_sym_STAR] = ACTIONS(1553),
    [anon_sym_CARET] = ACTIONS(1551),
    [anon_sym_AMP] = ACTIONS(1551),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1555),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1557),
    [anon_sym_DOT_DOT] = ACTIONS(1559),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1325] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6880),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7055),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5857),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4312),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7380),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9286),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1325),
    [sym_preproc_endregion] = STATE(1325),
    [sym_preproc_line] = STATE(1325),
    [sym_preproc_pragma] = STATE(1325),
    [sym_preproc_nullable] = STATE(1325),
    [sym_preproc_error] = STATE(1325),
    [sym_preproc_define] = STATE(1325),
    [sym_preproc_undef] = STATE(1325),
    [aux_sym_class_declaration_repeat1] = STATE(3799),
    [aux_sym_lambda_expression_repeat1] = STATE(4101),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1545),
    [anon_sym_ref] = ACTIONS(1547),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1551),
    [anon_sym_TILDE] = ACTIONS(1551),
    [anon_sym_PLUS_PLUS] = ACTIONS(1551),
    [anon_sym_DASH_DASH] = ACTIONS(1551),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1549),
    [anon_sym_DASH] = ACTIONS(1549),
    [anon_sym_STAR] = ACTIONS(1553),
    [anon_sym_CARET] = ACTIONS(1551),
    [anon_sym_AMP] = ACTIONS(1551),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1555),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1557),
    [anon_sym_DOT_DOT] = ACTIONS(1559),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1326] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6880),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7055),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5953),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4312),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7380),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9286),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1326),
    [sym_preproc_endregion] = STATE(1326),
    [sym_preproc_line] = STATE(1326),
    [sym_preproc_pragma] = STATE(1326),
    [sym_preproc_nullable] = STATE(1326),
    [sym_preproc_error] = STATE(1326),
    [sym_preproc_define] = STATE(1326),
    [sym_preproc_undef] = STATE(1326),
    [aux_sym_class_declaration_repeat1] = STATE(3799),
    [aux_sym_lambda_expression_repeat1] = STATE(4101),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1545),
    [anon_sym_ref] = ACTIONS(1547),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1551),
    [anon_sym_TILDE] = ACTIONS(1551),
    [anon_sym_PLUS_PLUS] = ACTIONS(1551),
    [anon_sym_DASH_DASH] = ACTIONS(1551),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1549),
    [anon_sym_DASH] = ACTIONS(1549),
    [anon_sym_STAR] = ACTIONS(1553),
    [anon_sym_CARET] = ACTIONS(1551),
    [anon_sym_AMP] = ACTIONS(1551),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1555),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1557),
    [anon_sym_DOT_DOT] = ACTIONS(1559),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1327] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6880),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7055),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5954),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4312),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7380),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9286),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1327),
    [sym_preproc_endregion] = STATE(1327),
    [sym_preproc_line] = STATE(1327),
    [sym_preproc_pragma] = STATE(1327),
    [sym_preproc_nullable] = STATE(1327),
    [sym_preproc_error] = STATE(1327),
    [sym_preproc_define] = STATE(1327),
    [sym_preproc_undef] = STATE(1327),
    [aux_sym_class_declaration_repeat1] = STATE(3799),
    [aux_sym_lambda_expression_repeat1] = STATE(4101),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1545),
    [anon_sym_ref] = ACTIONS(1547),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1551),
    [anon_sym_TILDE] = ACTIONS(1551),
    [anon_sym_PLUS_PLUS] = ACTIONS(1551),
    [anon_sym_DASH_DASH] = ACTIONS(1551),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1549),
    [anon_sym_DASH] = ACTIONS(1549),
    [anon_sym_STAR] = ACTIONS(1553),
    [anon_sym_CARET] = ACTIONS(1551),
    [anon_sym_AMP] = ACTIONS(1551),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1555),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1557),
    [anon_sym_DOT_DOT] = ACTIONS(1559),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1328] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6911),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6992),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5102),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(3829),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7391),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9246),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1328),
    [sym_preproc_endregion] = STATE(1328),
    [sym_preproc_line] = STATE(1328),
    [sym_preproc_pragma] = STATE(1328),
    [sym_preproc_nullable] = STATE(1328),
    [sym_preproc_error] = STATE(1328),
    [sym_preproc_define] = STATE(1328),
    [sym_preproc_undef] = STATE(1328),
    [aux_sym_class_declaration_repeat1] = STATE(3800),
    [aux_sym_lambda_expression_repeat1] = STATE(4089),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1323),
    [anon_sym_ref] = ACTIONS(1325),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1145),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1329),
    [anon_sym_TILDE] = ACTIONS(1329),
    [anon_sym_PLUS_PLUS] = ACTIONS(1329),
    [anon_sym_DASH_DASH] = ACTIONS(1329),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1327),
    [anon_sym_DASH] = ACTIONS(1327),
    [anon_sym_STAR] = ACTIONS(1331),
    [anon_sym_CARET] = ACTIONS(1329),
    [anon_sym_AMP] = ACTIONS(1329),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1333),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1335),
    [anon_sym_DOT_DOT] = ACTIONS(1337),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1329] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6898),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2940),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6925),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6642),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4498),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7403),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(8973),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1329),
    [sym_preproc_endregion] = STATE(1329),
    [sym_preproc_line] = STATE(1329),
    [sym_preproc_pragma] = STATE(1329),
    [sym_preproc_nullable] = STATE(1329),
    [sym_preproc_error] = STATE(1329),
    [sym_preproc_define] = STATE(1329),
    [sym_preproc_undef] = STATE(1329),
    [aux_sym_class_declaration_repeat1] = STATE(3830),
    [aux_sym_lambda_expression_repeat1] = STATE(4194),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2153),
    [anon_sym_ref] = ACTIONS(2155),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2157),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2161),
    [anon_sym_TILDE] = ACTIONS(2161),
    [anon_sym_PLUS_PLUS] = ACTIONS(2161),
    [anon_sym_DASH_DASH] = ACTIONS(2161),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2159),
    [anon_sym_DASH] = ACTIONS(2159),
    [anon_sym_STAR] = ACTIONS(2163),
    [anon_sym_CARET] = ACTIONS(2161),
    [anon_sym_AMP] = ACTIONS(2161),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2165),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2167),
    [anon_sym_DOT_DOT] = ACTIONS(2169),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1330] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6901),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2939),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7085),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5832),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4322),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7392),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9185),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1330),
    [sym_preproc_endregion] = STATE(1330),
    [sym_preproc_line] = STATE(1330),
    [sym_preproc_pragma] = STATE(1330),
    [sym_preproc_nullable] = STATE(1330),
    [sym_preproc_error] = STATE(1330),
    [sym_preproc_define] = STATE(1330),
    [sym_preproc_undef] = STATE(1330),
    [aux_sym_class_declaration_repeat1] = STATE(3819),
    [aux_sym_lambda_expression_repeat1] = STATE(4161),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_ref] = ACTIONS(1761),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1763),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1767),
    [anon_sym_TILDE] = ACTIONS(1767),
    [anon_sym_PLUS_PLUS] = ACTIONS(1767),
    [anon_sym_DASH_DASH] = ACTIONS(1767),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1765),
    [anon_sym_STAR] = ACTIONS(1769),
    [anon_sym_CARET] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(1767),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1771),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1773),
    [anon_sym_DOT_DOT] = ACTIONS(1775),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1331] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6901),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2939),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7050),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6367),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4507),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7378),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9063),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1331),
    [sym_preproc_endregion] = STATE(1331),
    [sym_preproc_line] = STATE(1331),
    [sym_preproc_pragma] = STATE(1331),
    [sym_preproc_nullable] = STATE(1331),
    [sym_preproc_error] = STATE(1331),
    [sym_preproc_define] = STATE(1331),
    [sym_preproc_undef] = STATE(1331),
    [aux_sym_class_declaration_repeat1] = STATE(3854),
    [aux_sym_lambda_expression_repeat1] = STATE(4229),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2193),
    [anon_sym_ref] = ACTIONS(2195),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2197),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2201),
    [anon_sym_TILDE] = ACTIONS(2201),
    [anon_sym_PLUS_PLUS] = ACTIONS(2201),
    [anon_sym_DASH_DASH] = ACTIONS(2201),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2199),
    [anon_sym_DASH] = ACTIONS(2199),
    [anon_sym_STAR] = ACTIONS(2203),
    [anon_sym_CARET] = ACTIONS(2201),
    [anon_sym_AMP] = ACTIONS(2201),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2205),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2207),
    [anon_sym_DOT_DOT] = ACTIONS(2209),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1332] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6911),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6992),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5107),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(3829),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7391),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9246),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1332),
    [sym_preproc_endregion] = STATE(1332),
    [sym_preproc_line] = STATE(1332),
    [sym_preproc_pragma] = STATE(1332),
    [sym_preproc_nullable] = STATE(1332),
    [sym_preproc_error] = STATE(1332),
    [sym_preproc_define] = STATE(1332),
    [sym_preproc_undef] = STATE(1332),
    [aux_sym_class_declaration_repeat1] = STATE(3800),
    [aux_sym_lambda_expression_repeat1] = STATE(4089),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1323),
    [anon_sym_ref] = ACTIONS(1325),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1145),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1329),
    [anon_sym_TILDE] = ACTIONS(1329),
    [anon_sym_PLUS_PLUS] = ACTIONS(1329),
    [anon_sym_DASH_DASH] = ACTIONS(1329),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1327),
    [anon_sym_DASH] = ACTIONS(1327),
    [anon_sym_STAR] = ACTIONS(1331),
    [anon_sym_CARET] = ACTIONS(1329),
    [anon_sym_AMP] = ACTIONS(1329),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1333),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1335),
    [anon_sym_DOT_DOT] = ACTIONS(1337),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1333] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6901),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2939),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7085),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5759),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4322),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7392),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9185),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1333),
    [sym_preproc_endregion] = STATE(1333),
    [sym_preproc_line] = STATE(1333),
    [sym_preproc_pragma] = STATE(1333),
    [sym_preproc_nullable] = STATE(1333),
    [sym_preproc_error] = STATE(1333),
    [sym_preproc_define] = STATE(1333),
    [sym_preproc_undef] = STATE(1333),
    [aux_sym_class_declaration_repeat1] = STATE(3819),
    [aux_sym_lambda_expression_repeat1] = STATE(4161),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_ref] = ACTIONS(1761),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1763),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1767),
    [anon_sym_TILDE] = ACTIONS(1767),
    [anon_sym_PLUS_PLUS] = ACTIONS(1767),
    [anon_sym_DASH_DASH] = ACTIONS(1767),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1765),
    [anon_sym_STAR] = ACTIONS(1769),
    [anon_sym_CARET] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(1767),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1771),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1773),
    [anon_sym_DOT_DOT] = ACTIONS(1775),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1334] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6901),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2939),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7085),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5758),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4322),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7392),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9185),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1334),
    [sym_preproc_endregion] = STATE(1334),
    [sym_preproc_line] = STATE(1334),
    [sym_preproc_pragma] = STATE(1334),
    [sym_preproc_nullable] = STATE(1334),
    [sym_preproc_error] = STATE(1334),
    [sym_preproc_define] = STATE(1334),
    [sym_preproc_undef] = STATE(1334),
    [aux_sym_class_declaration_repeat1] = STATE(3819),
    [aux_sym_lambda_expression_repeat1] = STATE(4161),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_ref] = ACTIONS(1761),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1763),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1767),
    [anon_sym_TILDE] = ACTIONS(1767),
    [anon_sym_PLUS_PLUS] = ACTIONS(1767),
    [anon_sym_DASH_DASH] = ACTIONS(1767),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1765),
    [anon_sym_STAR] = ACTIONS(1769),
    [anon_sym_CARET] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(1767),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1771),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1773),
    [anon_sym_DOT_DOT] = ACTIONS(1775),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1335] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6913),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7016),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4465),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(3582),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7407),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9275),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1335),
    [sym_preproc_endregion] = STATE(1335),
    [sym_preproc_line] = STATE(1335),
    [sym_preproc_pragma] = STATE(1335),
    [sym_preproc_nullable] = STATE(1335),
    [sym_preproc_error] = STATE(1335),
    [sym_preproc_define] = STATE(1335),
    [sym_preproc_undef] = STATE(1335),
    [aux_sym_class_declaration_repeat1] = STATE(3789),
    [aux_sym_lambda_expression_repeat1] = STATE(4086),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1137),
    [anon_sym_ref] = ACTIONS(1139),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1145),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1153),
    [anon_sym_TILDE] = ACTIONS(1153),
    [anon_sym_PLUS_PLUS] = ACTIONS(1153),
    [anon_sym_DASH_DASH] = ACTIONS(1153),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1151),
    [anon_sym_DASH] = ACTIONS(1151),
    [anon_sym_STAR] = ACTIONS(1157),
    [anon_sym_CARET] = ACTIONS(1153),
    [anon_sym_AMP] = ACTIONS(1153),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1165),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1167),
    [anon_sym_DOT_DOT] = ACTIONS(1169),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1336] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6901),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2939),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7085),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5840),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4322),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7392),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9185),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1336),
    [sym_preproc_endregion] = STATE(1336),
    [sym_preproc_line] = STATE(1336),
    [sym_preproc_pragma] = STATE(1336),
    [sym_preproc_nullable] = STATE(1336),
    [sym_preproc_error] = STATE(1336),
    [sym_preproc_define] = STATE(1336),
    [sym_preproc_undef] = STATE(1336),
    [aux_sym_class_declaration_repeat1] = STATE(3819),
    [aux_sym_lambda_expression_repeat1] = STATE(4161),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_ref] = ACTIONS(1761),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1763),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1767),
    [anon_sym_TILDE] = ACTIONS(1767),
    [anon_sym_PLUS_PLUS] = ACTIONS(1767),
    [anon_sym_DASH_DASH] = ACTIONS(1767),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1765),
    [anon_sym_STAR] = ACTIONS(1769),
    [anon_sym_CARET] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(1767),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1771),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1773),
    [anon_sym_DOT_DOT] = ACTIONS(1775),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1337] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6901),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2939),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7085),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5757),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4322),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7392),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9185),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1337),
    [sym_preproc_endregion] = STATE(1337),
    [sym_preproc_line] = STATE(1337),
    [sym_preproc_pragma] = STATE(1337),
    [sym_preproc_nullable] = STATE(1337),
    [sym_preproc_error] = STATE(1337),
    [sym_preproc_define] = STATE(1337),
    [sym_preproc_undef] = STATE(1337),
    [aux_sym_class_declaration_repeat1] = STATE(3819),
    [aux_sym_lambda_expression_repeat1] = STATE(4161),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_ref] = ACTIONS(1761),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1763),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1767),
    [anon_sym_TILDE] = ACTIONS(1767),
    [anon_sym_PLUS_PLUS] = ACTIONS(1767),
    [anon_sym_DASH_DASH] = ACTIONS(1767),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1765),
    [anon_sym_STAR] = ACTIONS(1769),
    [anon_sym_CARET] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(1767),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1771),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1773),
    [anon_sym_DOT_DOT] = ACTIONS(1775),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1338] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6898),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2940),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6925),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6526),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4498),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7403),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(8973),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1338),
    [sym_preproc_endregion] = STATE(1338),
    [sym_preproc_line] = STATE(1338),
    [sym_preproc_pragma] = STATE(1338),
    [sym_preproc_nullable] = STATE(1338),
    [sym_preproc_error] = STATE(1338),
    [sym_preproc_define] = STATE(1338),
    [sym_preproc_undef] = STATE(1338),
    [aux_sym_class_declaration_repeat1] = STATE(3830),
    [aux_sym_lambda_expression_repeat1] = STATE(4194),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2153),
    [anon_sym_ref] = ACTIONS(2155),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2157),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2161),
    [anon_sym_TILDE] = ACTIONS(2161),
    [anon_sym_PLUS_PLUS] = ACTIONS(2161),
    [anon_sym_DASH_DASH] = ACTIONS(2161),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2159),
    [anon_sym_DASH] = ACTIONS(2159),
    [anon_sym_STAR] = ACTIONS(2163),
    [anon_sym_CARET] = ACTIONS(2161),
    [anon_sym_AMP] = ACTIONS(2161),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2165),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2167),
    [anon_sym_DOT_DOT] = ACTIONS(2169),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1339] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6901),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2939),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7085),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5756),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4322),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7392),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9185),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1339),
    [sym_preproc_endregion] = STATE(1339),
    [sym_preproc_line] = STATE(1339),
    [sym_preproc_pragma] = STATE(1339),
    [sym_preproc_nullable] = STATE(1339),
    [sym_preproc_error] = STATE(1339),
    [sym_preproc_define] = STATE(1339),
    [sym_preproc_undef] = STATE(1339),
    [aux_sym_class_declaration_repeat1] = STATE(3819),
    [aux_sym_lambda_expression_repeat1] = STATE(4161),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_ref] = ACTIONS(1761),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1763),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1767),
    [anon_sym_TILDE] = ACTIONS(1767),
    [anon_sym_PLUS_PLUS] = ACTIONS(1767),
    [anon_sym_DASH_DASH] = ACTIONS(1767),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1765),
    [anon_sym_STAR] = ACTIONS(1769),
    [anon_sym_CARET] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(1767),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1771),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1773),
    [anon_sym_DOT_DOT] = ACTIONS(1775),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1340] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5907),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1340),
    [sym_preproc_endregion] = STATE(1340),
    [sym_preproc_line] = STATE(1340),
    [sym_preproc_pragma] = STATE(1340),
    [sym_preproc_nullable] = STATE(1340),
    [sym_preproc_error] = STATE(1340),
    [sym_preproc_define] = STATE(1340),
    [sym_preproc_undef] = STATE(1340),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1341] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6901),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2939),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7085),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5755),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4322),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7392),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9185),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1341),
    [sym_preproc_endregion] = STATE(1341),
    [sym_preproc_line] = STATE(1341),
    [sym_preproc_pragma] = STATE(1341),
    [sym_preproc_nullable] = STATE(1341),
    [sym_preproc_error] = STATE(1341),
    [sym_preproc_define] = STATE(1341),
    [sym_preproc_undef] = STATE(1341),
    [aux_sym_class_declaration_repeat1] = STATE(3819),
    [aux_sym_lambda_expression_repeat1] = STATE(4161),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_ref] = ACTIONS(1761),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1763),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1767),
    [anon_sym_TILDE] = ACTIONS(1767),
    [anon_sym_PLUS_PLUS] = ACTIONS(1767),
    [anon_sym_DASH_DASH] = ACTIONS(1767),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1765),
    [anon_sym_STAR] = ACTIONS(1769),
    [anon_sym_CARET] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(1767),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1771),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1773),
    [anon_sym_DOT_DOT] = ACTIONS(1775),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1342] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6901),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2939),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7085),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5770),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4322),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7392),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9185),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1342),
    [sym_preproc_endregion] = STATE(1342),
    [sym_preproc_line] = STATE(1342),
    [sym_preproc_pragma] = STATE(1342),
    [sym_preproc_nullable] = STATE(1342),
    [sym_preproc_error] = STATE(1342),
    [sym_preproc_define] = STATE(1342),
    [sym_preproc_undef] = STATE(1342),
    [aux_sym_class_declaration_repeat1] = STATE(3819),
    [aux_sym_lambda_expression_repeat1] = STATE(4161),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_ref] = ACTIONS(1761),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1763),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1767),
    [anon_sym_TILDE] = ACTIONS(1767),
    [anon_sym_PLUS_PLUS] = ACTIONS(1767),
    [anon_sym_DASH_DASH] = ACTIONS(1767),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1765),
    [anon_sym_STAR] = ACTIONS(1769),
    [anon_sym_CARET] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(1767),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1771),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1773),
    [anon_sym_DOT_DOT] = ACTIONS(1775),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1343] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6901),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2939),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7085),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5771),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4322),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7392),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9185),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1343),
    [sym_preproc_endregion] = STATE(1343),
    [sym_preproc_line] = STATE(1343),
    [sym_preproc_pragma] = STATE(1343),
    [sym_preproc_nullable] = STATE(1343),
    [sym_preproc_error] = STATE(1343),
    [sym_preproc_define] = STATE(1343),
    [sym_preproc_undef] = STATE(1343),
    [aux_sym_class_declaration_repeat1] = STATE(3819),
    [aux_sym_lambda_expression_repeat1] = STATE(4161),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_ref] = ACTIONS(1761),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1763),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1767),
    [anon_sym_TILDE] = ACTIONS(1767),
    [anon_sym_PLUS_PLUS] = ACTIONS(1767),
    [anon_sym_DASH_DASH] = ACTIONS(1767),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1765),
    [anon_sym_STAR] = ACTIONS(1769),
    [anon_sym_CARET] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(1767),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1771),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1773),
    [anon_sym_DOT_DOT] = ACTIONS(1775),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1344] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6354),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1344),
    [sym_preproc_endregion] = STATE(1344),
    [sym_preproc_line] = STATE(1344),
    [sym_preproc_pragma] = STATE(1344),
    [sym_preproc_nullable] = STATE(1344),
    [sym_preproc_error] = STATE(1344),
    [sym_preproc_define] = STATE(1344),
    [sym_preproc_undef] = STATE(1344),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1345] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6898),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2940),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6936),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5917),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4318),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7401),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9262),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1345),
    [sym_preproc_endregion] = STATE(1345),
    [sym_preproc_line] = STATE(1345),
    [sym_preproc_pragma] = STATE(1345),
    [sym_preproc_nullable] = STATE(1345),
    [sym_preproc_error] = STATE(1345),
    [sym_preproc_define] = STATE(1345),
    [sym_preproc_undef] = STATE(1345),
    [aux_sym_class_declaration_repeat1] = STATE(3815),
    [aux_sym_lambda_expression_repeat1] = STATE(4072),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1885),
    [anon_sym_ref] = ACTIONS(1887),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1889),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1893),
    [anon_sym_TILDE] = ACTIONS(1893),
    [anon_sym_PLUS_PLUS] = ACTIONS(1893),
    [anon_sym_DASH_DASH] = ACTIONS(1893),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1891),
    [anon_sym_DASH] = ACTIONS(1891),
    [anon_sym_STAR] = ACTIONS(1895),
    [anon_sym_CARET] = ACTIONS(1893),
    [anon_sym_AMP] = ACTIONS(1893),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1897),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1899),
    [anon_sym_DOT_DOT] = ACTIONS(1901),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1346] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6901),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2939),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7085),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5806),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4322),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7392),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9185),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1346),
    [sym_preproc_endregion] = STATE(1346),
    [sym_preproc_line] = STATE(1346),
    [sym_preproc_pragma] = STATE(1346),
    [sym_preproc_nullable] = STATE(1346),
    [sym_preproc_error] = STATE(1346),
    [sym_preproc_define] = STATE(1346),
    [sym_preproc_undef] = STATE(1346),
    [aux_sym_class_declaration_repeat1] = STATE(3819),
    [aux_sym_lambda_expression_repeat1] = STATE(4161),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_ref] = ACTIONS(1761),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1763),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1767),
    [anon_sym_TILDE] = ACTIONS(1767),
    [anon_sym_PLUS_PLUS] = ACTIONS(1767),
    [anon_sym_DASH_DASH] = ACTIONS(1767),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1765),
    [anon_sym_STAR] = ACTIONS(1769),
    [anon_sym_CARET] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(1767),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1771),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1773),
    [anon_sym_DOT_DOT] = ACTIONS(1775),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1347] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6901),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2939),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7085),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5807),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4322),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7392),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9185),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1347),
    [sym_preproc_endregion] = STATE(1347),
    [sym_preproc_line] = STATE(1347),
    [sym_preproc_pragma] = STATE(1347),
    [sym_preproc_nullable] = STATE(1347),
    [sym_preproc_error] = STATE(1347),
    [sym_preproc_define] = STATE(1347),
    [sym_preproc_undef] = STATE(1347),
    [aux_sym_class_declaration_repeat1] = STATE(3819),
    [aux_sym_lambda_expression_repeat1] = STATE(4161),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_ref] = ACTIONS(1761),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1763),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1767),
    [anon_sym_TILDE] = ACTIONS(1767),
    [anon_sym_PLUS_PLUS] = ACTIONS(1767),
    [anon_sym_DASH_DASH] = ACTIONS(1767),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1765),
    [anon_sym_STAR] = ACTIONS(1769),
    [anon_sym_CARET] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(1767),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1771),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1773),
    [anon_sym_DOT_DOT] = ACTIONS(1775),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1348] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6181),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1348),
    [sym_preproc_endregion] = STATE(1348),
    [sym_preproc_line] = STATE(1348),
    [sym_preproc_pragma] = STATE(1348),
    [sym_preproc_nullable] = STATE(1348),
    [sym_preproc_error] = STATE(1348),
    [sym_preproc_define] = STATE(1348),
    [sym_preproc_undef] = STATE(1348),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1349] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6901),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2939),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7085),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5810),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4322),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7392),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9185),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1349),
    [sym_preproc_endregion] = STATE(1349),
    [sym_preproc_line] = STATE(1349),
    [sym_preproc_pragma] = STATE(1349),
    [sym_preproc_nullable] = STATE(1349),
    [sym_preproc_error] = STATE(1349),
    [sym_preproc_define] = STATE(1349),
    [sym_preproc_undef] = STATE(1349),
    [aux_sym_class_declaration_repeat1] = STATE(3819),
    [aux_sym_lambda_expression_repeat1] = STATE(4161),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_ref] = ACTIONS(1761),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1763),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1767),
    [anon_sym_TILDE] = ACTIONS(1767),
    [anon_sym_PLUS_PLUS] = ACTIONS(1767),
    [anon_sym_DASH_DASH] = ACTIONS(1767),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1765),
    [anon_sym_STAR] = ACTIONS(1769),
    [anon_sym_CARET] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(1767),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1771),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1773),
    [anon_sym_DOT_DOT] = ACTIONS(1775),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1350] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6898),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2940),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6925),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4309),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4498),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7403),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(8973),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1350),
    [sym_preproc_endregion] = STATE(1350),
    [sym_preproc_line] = STATE(1350),
    [sym_preproc_pragma] = STATE(1350),
    [sym_preproc_nullable] = STATE(1350),
    [sym_preproc_error] = STATE(1350),
    [sym_preproc_define] = STATE(1350),
    [sym_preproc_undef] = STATE(1350),
    [aux_sym_class_declaration_repeat1] = STATE(3830),
    [aux_sym_lambda_expression_repeat1] = STATE(4194),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2153),
    [anon_sym_ref] = ACTIONS(2155),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2157),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2161),
    [anon_sym_TILDE] = ACTIONS(2161),
    [anon_sym_PLUS_PLUS] = ACTIONS(2161),
    [anon_sym_DASH_DASH] = ACTIONS(2161),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2159),
    [anon_sym_DASH] = ACTIONS(2159),
    [anon_sym_STAR] = ACTIONS(2163),
    [anon_sym_CARET] = ACTIONS(2161),
    [anon_sym_AMP] = ACTIONS(2161),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2165),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2167),
    [anon_sym_DOT_DOT] = ACTIONS(2169),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1351] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3921),
    [sym__name] = STATE(6919),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2868),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(7068),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6032),
    [sym_non_lvalue_expression] = STATE(5735),
    [sym_lvalue_expression] = STATE(4323),
    [sym__expression_statement_expression] = STATE(5733),
    [sym_assignment_expression] = STATE(5734),
    [sym_binary_expression] = STATE(5733),
    [sym_postfix_unary_expression] = STATE(5734),
    [sym_prefix_unary_expression] = STATE(5734),
    [sym__pointer_indirection_expression] = STATE(3911),
    [sym_query_expression] = STATE(5733),
    [sym_from_clause] = STATE(7393),
    [sym_conditional_expression] = STATE(5733),
    [sym_conditional_access_expression] = STATE(5733),
    [sym_as_expression] = STATE(5733),
    [sym_is_expression] = STATE(5733),
    [sym_is_pattern_expression] = STATE(5733),
    [sym_cast_expression] = STATE(5733),
    [sym_checked_expression] = STATE(5733),
    [sym_invocation_expression] = STATE(5734),
    [sym_switch_expression] = STATE(5733),
    [sym_await_expression] = STATE(5734),
    [sym_throw_expression] = STATE(5733),
    [sym_element_access_expression] = STATE(3911),
    [sym_interpolated_string_expression] = STATE(5733),
    [sym_member_access_expression] = STATE(3911),
    [sym_object_creation_expression] = STATE(5734),
    [sym_parenthesized_expression] = STATE(5734),
    [sym__parenthesized_lvalue_expression] = STATE(3911),
    [sym_lambda_expression] = STATE(5733),
    [sym__lambda_parameters] = STATE(9932),
    [sym_array_creation_expression] = STATE(5733),
    [sym_anonymous_method_expression] = STATE(5733),
    [sym_anonymous_object_creation_expression] = STATE(5733),
    [sym_implicit_array_creation_expression] = STATE(5733),
    [sym_implicit_object_creation_expression] = STATE(5733),
    [sym_implicit_stackalloc_expression] = STATE(5733),
    [sym_initializer_expression] = STATE(5733),
    [sym_default_expression] = STATE(5733),
    [sym_with_expression] = STATE(5733),
    [sym_sizeof_expression] = STATE(5733),
    [sym_typeof_expression] = STATE(5733),
    [sym_makeref_expression] = STATE(5733),
    [sym_ref_expression] = STATE(5733),
    [sym_reftype_expression] = STATE(5733),
    [sym_refvalue_expression] = STATE(5733),
    [sym_stackalloc_expression] = STATE(5733),
    [sym_range_expression] = STATE(5733),
    [sym_tuple_expression] = STATE(3911),
    [sym_literal] = STATE(5733),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2798),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(5733),
    [sym_preproc_region] = STATE(1351),
    [sym_preproc_endregion] = STATE(1351),
    [sym_preproc_line] = STATE(1351),
    [sym_preproc_pragma] = STATE(1351),
    [sym_preproc_nullable] = STATE(1351),
    [sym_preproc_error] = STATE(1351),
    [sym_preproc_define] = STATE(1351),
    [sym_preproc_undef] = STATE(1351),
    [aux_sym_class_declaration_repeat1] = STATE(3831),
    [aux_sym_lambda_expression_repeat1] = STATE(4227),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_LPAREN] = ACTIONS(1577),
    [anon_sym_ref] = ACTIONS(1579),
    [anon_sym_LBRACE] = ACTIONS(1377),
    [anon_sym_delegate] = ACTIONS(1379),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1381),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1583),
    [anon_sym_TILDE] = ACTIONS(1583),
    [anon_sym_PLUS_PLUS] = ACTIONS(1583),
    [anon_sym_DASH_DASH] = ACTIONS(1583),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1581),
    [anon_sym_DASH] = ACTIONS(1581),
    [anon_sym_STAR] = ACTIONS(1391),
    [anon_sym_CARET] = ACTIONS(1583),
    [anon_sym_AMP] = ACTIONS(1583),
    [anon_sym_this] = ACTIONS(1393),
    [anon_sym_scoped] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1397),
    [sym_predefined_type] = ACTIONS(1399),
    [anon_sym_unchecked] = ACTIONS(1383),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1585),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1587),
    [anon_sym_DOT_DOT] = ACTIONS(1589),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_stackalloc] = ACTIONS(1413),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(1419),
    [anon_sym___reftype] = ACTIONS(1421),
    [anon_sym___refvalue] = ACTIONS(1423),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
  },
  [1352] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6901),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2939),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7085),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(3922),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4322),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7392),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9185),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1352),
    [sym_preproc_endregion] = STATE(1352),
    [sym_preproc_line] = STATE(1352),
    [sym_preproc_pragma] = STATE(1352),
    [sym_preproc_nullable] = STATE(1352),
    [sym_preproc_error] = STATE(1352),
    [sym_preproc_define] = STATE(1352),
    [sym_preproc_undef] = STATE(1352),
    [aux_sym_class_declaration_repeat1] = STATE(3819),
    [aux_sym_lambda_expression_repeat1] = STATE(4161),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_ref] = ACTIONS(1761),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1763),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1767),
    [anon_sym_TILDE] = ACTIONS(1767),
    [anon_sym_PLUS_PLUS] = ACTIONS(1767),
    [anon_sym_DASH_DASH] = ACTIONS(1767),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1765),
    [anon_sym_STAR] = ACTIONS(1769),
    [anon_sym_CARET] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(1767),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1771),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1773),
    [anon_sym_DOT_DOT] = ACTIONS(1775),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1353] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6913),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7016),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4463),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(3582),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7407),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9275),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1353),
    [sym_preproc_endregion] = STATE(1353),
    [sym_preproc_line] = STATE(1353),
    [sym_preproc_pragma] = STATE(1353),
    [sym_preproc_nullable] = STATE(1353),
    [sym_preproc_error] = STATE(1353),
    [sym_preproc_define] = STATE(1353),
    [sym_preproc_undef] = STATE(1353),
    [aux_sym_class_declaration_repeat1] = STATE(3789),
    [aux_sym_lambda_expression_repeat1] = STATE(4086),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1137),
    [anon_sym_ref] = ACTIONS(1139),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1145),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1153),
    [anon_sym_TILDE] = ACTIONS(1153),
    [anon_sym_PLUS_PLUS] = ACTIONS(1153),
    [anon_sym_DASH_DASH] = ACTIONS(1153),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1151),
    [anon_sym_DASH] = ACTIONS(1151),
    [anon_sym_STAR] = ACTIONS(1157),
    [anon_sym_CARET] = ACTIONS(1153),
    [anon_sym_AMP] = ACTIONS(1153),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1165),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1167),
    [anon_sym_DOT_DOT] = ACTIONS(1169),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1354] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6898),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2940),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6925),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6422),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4498),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7403),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(8973),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1354),
    [sym_preproc_endregion] = STATE(1354),
    [sym_preproc_line] = STATE(1354),
    [sym_preproc_pragma] = STATE(1354),
    [sym_preproc_nullable] = STATE(1354),
    [sym_preproc_error] = STATE(1354),
    [sym_preproc_define] = STATE(1354),
    [sym_preproc_undef] = STATE(1354),
    [aux_sym_class_declaration_repeat1] = STATE(3830),
    [aux_sym_lambda_expression_repeat1] = STATE(4194),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2153),
    [anon_sym_ref] = ACTIONS(2155),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2157),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2161),
    [anon_sym_TILDE] = ACTIONS(2161),
    [anon_sym_PLUS_PLUS] = ACTIONS(2161),
    [anon_sym_DASH_DASH] = ACTIONS(2161),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2159),
    [anon_sym_DASH] = ACTIONS(2159),
    [anon_sym_STAR] = ACTIONS(2163),
    [anon_sym_CARET] = ACTIONS(2161),
    [anon_sym_AMP] = ACTIONS(2161),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2165),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2167),
    [anon_sym_DOT_DOT] = ACTIONS(2169),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1355] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6913),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7000),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5476),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4181),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7384),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9143),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1355),
    [sym_preproc_endregion] = STATE(1355),
    [sym_preproc_line] = STATE(1355),
    [sym_preproc_pragma] = STATE(1355),
    [sym_preproc_nullable] = STATE(1355),
    [sym_preproc_error] = STATE(1355),
    [sym_preproc_define] = STATE(1355),
    [sym_preproc_undef] = STATE(1355),
    [aux_sym_class_declaration_repeat1] = STATE(3814),
    [aux_sym_lambda_expression_repeat1] = STATE(4171),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1561),
    [anon_sym_ref] = ACTIONS(1563),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1145),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(1567),
    [anon_sym_PLUS_PLUS] = ACTIONS(1567),
    [anon_sym_DASH_DASH] = ACTIONS(1567),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1565),
    [anon_sym_DASH] = ACTIONS(1565),
    [anon_sym_STAR] = ACTIONS(1569),
    [anon_sym_CARET] = ACTIONS(1567),
    [anon_sym_AMP] = ACTIONS(1567),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1571),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1573),
    [anon_sym_DOT_DOT] = ACTIONS(1575),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1356] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3921),
    [sym__name] = STATE(6919),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2868),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(7068),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5124),
    [sym_non_lvalue_expression] = STATE(5735),
    [sym_lvalue_expression] = STATE(4323),
    [sym__expression_statement_expression] = STATE(5733),
    [sym_assignment_expression] = STATE(5734),
    [sym_binary_expression] = STATE(5733),
    [sym_postfix_unary_expression] = STATE(5734),
    [sym_prefix_unary_expression] = STATE(5734),
    [sym__pointer_indirection_expression] = STATE(3911),
    [sym_query_expression] = STATE(5733),
    [sym_from_clause] = STATE(7393),
    [sym_conditional_expression] = STATE(5733),
    [sym_conditional_access_expression] = STATE(5733),
    [sym_as_expression] = STATE(5733),
    [sym_is_expression] = STATE(5733),
    [sym_is_pattern_expression] = STATE(5733),
    [sym_cast_expression] = STATE(5733),
    [sym_checked_expression] = STATE(5733),
    [sym_invocation_expression] = STATE(5734),
    [sym_switch_expression] = STATE(5733),
    [sym_await_expression] = STATE(5734),
    [sym_throw_expression] = STATE(5733),
    [sym_element_access_expression] = STATE(3911),
    [sym_interpolated_string_expression] = STATE(5733),
    [sym_member_access_expression] = STATE(3911),
    [sym_object_creation_expression] = STATE(5734),
    [sym_parenthesized_expression] = STATE(5734),
    [sym__parenthesized_lvalue_expression] = STATE(3911),
    [sym_lambda_expression] = STATE(5733),
    [sym__lambda_parameters] = STATE(9932),
    [sym_array_creation_expression] = STATE(5733),
    [sym_anonymous_method_expression] = STATE(5733),
    [sym_anonymous_object_creation_expression] = STATE(5733),
    [sym_implicit_array_creation_expression] = STATE(5733),
    [sym_implicit_object_creation_expression] = STATE(5733),
    [sym_implicit_stackalloc_expression] = STATE(5733),
    [sym_initializer_expression] = STATE(5733),
    [sym_default_expression] = STATE(5733),
    [sym_with_expression] = STATE(5733),
    [sym_sizeof_expression] = STATE(5733),
    [sym_typeof_expression] = STATE(5733),
    [sym_makeref_expression] = STATE(5733),
    [sym_ref_expression] = STATE(5733),
    [sym_reftype_expression] = STATE(5733),
    [sym_refvalue_expression] = STATE(5733),
    [sym_stackalloc_expression] = STATE(5733),
    [sym_range_expression] = STATE(5733),
    [sym_tuple_expression] = STATE(3911),
    [sym_literal] = STATE(5733),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2798),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(5733),
    [sym_preproc_region] = STATE(1356),
    [sym_preproc_endregion] = STATE(1356),
    [sym_preproc_line] = STATE(1356),
    [sym_preproc_pragma] = STATE(1356),
    [sym_preproc_nullable] = STATE(1356),
    [sym_preproc_error] = STATE(1356),
    [sym_preproc_define] = STATE(1356),
    [sym_preproc_undef] = STATE(1356),
    [aux_sym_class_declaration_repeat1] = STATE(3831),
    [aux_sym_lambda_expression_repeat1] = STATE(4227),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_LPAREN] = ACTIONS(1577),
    [anon_sym_ref] = ACTIONS(1579),
    [anon_sym_LBRACE] = ACTIONS(1377),
    [anon_sym_delegate] = ACTIONS(1379),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1381),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1583),
    [anon_sym_TILDE] = ACTIONS(1583),
    [anon_sym_PLUS_PLUS] = ACTIONS(1583),
    [anon_sym_DASH_DASH] = ACTIONS(1583),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1581),
    [anon_sym_DASH] = ACTIONS(1581),
    [anon_sym_STAR] = ACTIONS(1391),
    [anon_sym_CARET] = ACTIONS(1583),
    [anon_sym_AMP] = ACTIONS(1583),
    [anon_sym_this] = ACTIONS(1393),
    [anon_sym_scoped] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1397),
    [sym_predefined_type] = ACTIONS(1399),
    [anon_sym_unchecked] = ACTIONS(1383),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1585),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1587),
    [anon_sym_DOT_DOT] = ACTIONS(1589),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_stackalloc] = ACTIONS(1413),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(1419),
    [anon_sym___reftype] = ACTIONS(1421),
    [anon_sym___refvalue] = ACTIONS(1423),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
  },
  [1357] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6898),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2940),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6925),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6483),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4498),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7403),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(8973),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1357),
    [sym_preproc_endregion] = STATE(1357),
    [sym_preproc_line] = STATE(1357),
    [sym_preproc_pragma] = STATE(1357),
    [sym_preproc_nullable] = STATE(1357),
    [sym_preproc_error] = STATE(1357),
    [sym_preproc_define] = STATE(1357),
    [sym_preproc_undef] = STATE(1357),
    [aux_sym_class_declaration_repeat1] = STATE(3830),
    [aux_sym_lambda_expression_repeat1] = STATE(4194),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2153),
    [anon_sym_ref] = ACTIONS(2155),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2157),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2161),
    [anon_sym_TILDE] = ACTIONS(2161),
    [anon_sym_PLUS_PLUS] = ACTIONS(2161),
    [anon_sym_DASH_DASH] = ACTIONS(2161),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2159),
    [anon_sym_DASH] = ACTIONS(2159),
    [anon_sym_STAR] = ACTIONS(2163),
    [anon_sym_CARET] = ACTIONS(2161),
    [anon_sym_AMP] = ACTIONS(2161),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2165),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2167),
    [anon_sym_DOT_DOT] = ACTIONS(2169),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1358] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6918),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7126),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4763),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(3736),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7377),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9441),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1358),
    [sym_preproc_endregion] = STATE(1358),
    [sym_preproc_line] = STATE(1358),
    [sym_preproc_pragma] = STATE(1358),
    [sym_preproc_nullable] = STATE(1358),
    [sym_preproc_error] = STATE(1358),
    [sym_preproc_define] = STATE(1358),
    [sym_preproc_undef] = STATE(1358),
    [aux_sym_class_declaration_repeat1] = STATE(3848),
    [aux_sym_lambda_expression_repeat1] = STATE(4242),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1213),
    [anon_sym_ref] = ACTIONS(1215),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1221),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1227),
    [anon_sym_TILDE] = ACTIONS(1227),
    [anon_sym_PLUS_PLUS] = ACTIONS(1227),
    [anon_sym_DASH_DASH] = ACTIONS(1227),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1225),
    [anon_sym_DASH] = ACTIONS(1225),
    [anon_sym_STAR] = ACTIONS(1231),
    [anon_sym_CARET] = ACTIONS(1227),
    [anon_sym_AMP] = ACTIONS(1227),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1239),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1241),
    [anon_sym_DOT_DOT] = ACTIONS(1243),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1359] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6898),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2940),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6925),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6482),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4498),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7403),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(8973),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1359),
    [sym_preproc_endregion] = STATE(1359),
    [sym_preproc_line] = STATE(1359),
    [sym_preproc_pragma] = STATE(1359),
    [sym_preproc_nullable] = STATE(1359),
    [sym_preproc_error] = STATE(1359),
    [sym_preproc_define] = STATE(1359),
    [sym_preproc_undef] = STATE(1359),
    [aux_sym_class_declaration_repeat1] = STATE(3830),
    [aux_sym_lambda_expression_repeat1] = STATE(4194),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2153),
    [anon_sym_ref] = ACTIONS(2155),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2157),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2161),
    [anon_sym_TILDE] = ACTIONS(2161),
    [anon_sym_PLUS_PLUS] = ACTIONS(2161),
    [anon_sym_DASH_DASH] = ACTIONS(2161),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2159),
    [anon_sym_DASH] = ACTIONS(2159),
    [anon_sym_STAR] = ACTIONS(2163),
    [anon_sym_CARET] = ACTIONS(2161),
    [anon_sym_AMP] = ACTIONS(2161),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2165),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2167),
    [anon_sym_DOT_DOT] = ACTIONS(2169),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1360] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6898),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2940),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6925),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6481),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4498),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7403),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(8973),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1360),
    [sym_preproc_endregion] = STATE(1360),
    [sym_preproc_line] = STATE(1360),
    [sym_preproc_pragma] = STATE(1360),
    [sym_preproc_nullable] = STATE(1360),
    [sym_preproc_error] = STATE(1360),
    [sym_preproc_define] = STATE(1360),
    [sym_preproc_undef] = STATE(1360),
    [aux_sym_class_declaration_repeat1] = STATE(3830),
    [aux_sym_lambda_expression_repeat1] = STATE(4194),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2153),
    [anon_sym_ref] = ACTIONS(2155),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2157),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2161),
    [anon_sym_TILDE] = ACTIONS(2161),
    [anon_sym_PLUS_PLUS] = ACTIONS(2161),
    [anon_sym_DASH_DASH] = ACTIONS(2161),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2159),
    [anon_sym_DASH] = ACTIONS(2159),
    [anon_sym_STAR] = ACTIONS(2163),
    [anon_sym_CARET] = ACTIONS(2161),
    [anon_sym_AMP] = ACTIONS(2161),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2165),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2167),
    [anon_sym_DOT_DOT] = ACTIONS(2169),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1361] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6901),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2939),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7085),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5827),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4322),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7392),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9185),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1361),
    [sym_preproc_endregion] = STATE(1361),
    [sym_preproc_line] = STATE(1361),
    [sym_preproc_pragma] = STATE(1361),
    [sym_preproc_nullable] = STATE(1361),
    [sym_preproc_error] = STATE(1361),
    [sym_preproc_define] = STATE(1361),
    [sym_preproc_undef] = STATE(1361),
    [aux_sym_class_declaration_repeat1] = STATE(3819),
    [aux_sym_lambda_expression_repeat1] = STATE(4161),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_ref] = ACTIONS(1761),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1763),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1767),
    [anon_sym_TILDE] = ACTIONS(1767),
    [anon_sym_PLUS_PLUS] = ACTIONS(1767),
    [anon_sym_DASH_DASH] = ACTIONS(1767),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1765),
    [anon_sym_STAR] = ACTIONS(1769),
    [anon_sym_CARET] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(1767),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1771),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1773),
    [anon_sym_DOT_DOT] = ACTIONS(1775),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1362] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6898),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2940),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6925),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6478),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4498),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7403),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(8973),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1362),
    [sym_preproc_endregion] = STATE(1362),
    [sym_preproc_line] = STATE(1362),
    [sym_preproc_pragma] = STATE(1362),
    [sym_preproc_nullable] = STATE(1362),
    [sym_preproc_error] = STATE(1362),
    [sym_preproc_define] = STATE(1362),
    [sym_preproc_undef] = STATE(1362),
    [aux_sym_class_declaration_repeat1] = STATE(3830),
    [aux_sym_lambda_expression_repeat1] = STATE(4194),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2153),
    [anon_sym_ref] = ACTIONS(2155),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2157),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2161),
    [anon_sym_TILDE] = ACTIONS(2161),
    [anon_sym_PLUS_PLUS] = ACTIONS(2161),
    [anon_sym_DASH_DASH] = ACTIONS(2161),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2159),
    [anon_sym_DASH] = ACTIONS(2159),
    [anon_sym_STAR] = ACTIONS(2163),
    [anon_sym_CARET] = ACTIONS(2161),
    [anon_sym_AMP] = ACTIONS(2161),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2165),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2167),
    [anon_sym_DOT_DOT] = ACTIONS(2169),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1363] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6898),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2940),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6925),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6477),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4498),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7403),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(8973),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1363),
    [sym_preproc_endregion] = STATE(1363),
    [sym_preproc_line] = STATE(1363),
    [sym_preproc_pragma] = STATE(1363),
    [sym_preproc_nullable] = STATE(1363),
    [sym_preproc_error] = STATE(1363),
    [sym_preproc_define] = STATE(1363),
    [sym_preproc_undef] = STATE(1363),
    [aux_sym_class_declaration_repeat1] = STATE(3830),
    [aux_sym_lambda_expression_repeat1] = STATE(4194),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2153),
    [anon_sym_ref] = ACTIONS(2155),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2157),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2161),
    [anon_sym_TILDE] = ACTIONS(2161),
    [anon_sym_PLUS_PLUS] = ACTIONS(2161),
    [anon_sym_DASH_DASH] = ACTIONS(2161),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2159),
    [anon_sym_DASH] = ACTIONS(2159),
    [anon_sym_STAR] = ACTIONS(2163),
    [anon_sym_CARET] = ACTIONS(2161),
    [anon_sym_AMP] = ACTIONS(2161),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2165),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2167),
    [anon_sym_DOT_DOT] = ACTIONS(2169),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1364] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6898),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2940),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6925),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6476),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4498),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7403),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(8973),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1364),
    [sym_preproc_endregion] = STATE(1364),
    [sym_preproc_line] = STATE(1364),
    [sym_preproc_pragma] = STATE(1364),
    [sym_preproc_nullable] = STATE(1364),
    [sym_preproc_error] = STATE(1364),
    [sym_preproc_define] = STATE(1364),
    [sym_preproc_undef] = STATE(1364),
    [aux_sym_class_declaration_repeat1] = STATE(3830),
    [aux_sym_lambda_expression_repeat1] = STATE(4194),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2153),
    [anon_sym_ref] = ACTIONS(2155),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2157),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2161),
    [anon_sym_TILDE] = ACTIONS(2161),
    [anon_sym_PLUS_PLUS] = ACTIONS(2161),
    [anon_sym_DASH_DASH] = ACTIONS(2161),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2159),
    [anon_sym_DASH] = ACTIONS(2159),
    [anon_sym_STAR] = ACTIONS(2163),
    [anon_sym_CARET] = ACTIONS(2161),
    [anon_sym_AMP] = ACTIONS(2161),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2165),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2167),
    [anon_sym_DOT_DOT] = ACTIONS(2169),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1365] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6898),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2940),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6925),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6475),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4498),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7403),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(8973),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1365),
    [sym_preproc_endregion] = STATE(1365),
    [sym_preproc_line] = STATE(1365),
    [sym_preproc_pragma] = STATE(1365),
    [sym_preproc_nullable] = STATE(1365),
    [sym_preproc_error] = STATE(1365),
    [sym_preproc_define] = STATE(1365),
    [sym_preproc_undef] = STATE(1365),
    [aux_sym_class_declaration_repeat1] = STATE(3830),
    [aux_sym_lambda_expression_repeat1] = STATE(4194),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2153),
    [anon_sym_ref] = ACTIONS(2155),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2157),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2161),
    [anon_sym_TILDE] = ACTIONS(2161),
    [anon_sym_PLUS_PLUS] = ACTIONS(2161),
    [anon_sym_DASH_DASH] = ACTIONS(2161),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2159),
    [anon_sym_DASH] = ACTIONS(2159),
    [anon_sym_STAR] = ACTIONS(2163),
    [anon_sym_CARET] = ACTIONS(2161),
    [anon_sym_AMP] = ACTIONS(2161),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2165),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2167),
    [anon_sym_DOT_DOT] = ACTIONS(2169),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1366] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6898),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2940),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6925),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6474),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4498),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7403),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(8973),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1366),
    [sym_preproc_endregion] = STATE(1366),
    [sym_preproc_line] = STATE(1366),
    [sym_preproc_pragma] = STATE(1366),
    [sym_preproc_nullable] = STATE(1366),
    [sym_preproc_error] = STATE(1366),
    [sym_preproc_define] = STATE(1366),
    [sym_preproc_undef] = STATE(1366),
    [aux_sym_class_declaration_repeat1] = STATE(3830),
    [aux_sym_lambda_expression_repeat1] = STATE(4194),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2153),
    [anon_sym_ref] = ACTIONS(2155),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2157),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2161),
    [anon_sym_TILDE] = ACTIONS(2161),
    [anon_sym_PLUS_PLUS] = ACTIONS(2161),
    [anon_sym_DASH_DASH] = ACTIONS(2161),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2159),
    [anon_sym_DASH] = ACTIONS(2159),
    [anon_sym_STAR] = ACTIONS(2163),
    [anon_sym_CARET] = ACTIONS(2161),
    [anon_sym_AMP] = ACTIONS(2161),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2165),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2167),
    [anon_sym_DOT_DOT] = ACTIONS(2169),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1367] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6253),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1367),
    [sym_preproc_endregion] = STATE(1367),
    [sym_preproc_line] = STATE(1367),
    [sym_preproc_pragma] = STATE(1367),
    [sym_preproc_nullable] = STATE(1367),
    [sym_preproc_error] = STATE(1367),
    [sym_preproc_define] = STATE(1367),
    [sym_preproc_undef] = STATE(1367),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1368] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6918),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7126),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4776),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(3736),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7377),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9441),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1368),
    [sym_preproc_endregion] = STATE(1368),
    [sym_preproc_line] = STATE(1368),
    [sym_preproc_pragma] = STATE(1368),
    [sym_preproc_nullable] = STATE(1368),
    [sym_preproc_error] = STATE(1368),
    [sym_preproc_define] = STATE(1368),
    [sym_preproc_undef] = STATE(1368),
    [aux_sym_class_declaration_repeat1] = STATE(3848),
    [aux_sym_lambda_expression_repeat1] = STATE(4242),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1213),
    [anon_sym_ref] = ACTIONS(1215),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1221),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1227),
    [anon_sym_TILDE] = ACTIONS(1227),
    [anon_sym_PLUS_PLUS] = ACTIONS(1227),
    [anon_sym_DASH_DASH] = ACTIONS(1227),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1225),
    [anon_sym_DASH] = ACTIONS(1225),
    [anon_sym_STAR] = ACTIONS(1231),
    [anon_sym_CARET] = ACTIONS(1227),
    [anon_sym_AMP] = ACTIONS(1227),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1239),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1241),
    [anon_sym_DOT_DOT] = ACTIONS(1243),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1369] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6898),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2940),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6925),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6473),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4498),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7403),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(8973),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1369),
    [sym_preproc_endregion] = STATE(1369),
    [sym_preproc_line] = STATE(1369),
    [sym_preproc_pragma] = STATE(1369),
    [sym_preproc_nullable] = STATE(1369),
    [sym_preproc_error] = STATE(1369),
    [sym_preproc_define] = STATE(1369),
    [sym_preproc_undef] = STATE(1369),
    [aux_sym_class_declaration_repeat1] = STATE(3830),
    [aux_sym_lambda_expression_repeat1] = STATE(4194),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2153),
    [anon_sym_ref] = ACTIONS(2155),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2157),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2161),
    [anon_sym_TILDE] = ACTIONS(2161),
    [anon_sym_PLUS_PLUS] = ACTIONS(2161),
    [anon_sym_DASH_DASH] = ACTIONS(2161),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2159),
    [anon_sym_DASH] = ACTIONS(2159),
    [anon_sym_STAR] = ACTIONS(2163),
    [anon_sym_CARET] = ACTIONS(2161),
    [anon_sym_AMP] = ACTIONS(2161),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2165),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2167),
    [anon_sym_DOT_DOT] = ACTIONS(2169),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1370] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6898),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2940),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6925),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6436),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4498),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7403),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(8973),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1370),
    [sym_preproc_endregion] = STATE(1370),
    [sym_preproc_line] = STATE(1370),
    [sym_preproc_pragma] = STATE(1370),
    [sym_preproc_nullable] = STATE(1370),
    [sym_preproc_error] = STATE(1370),
    [sym_preproc_define] = STATE(1370),
    [sym_preproc_undef] = STATE(1370),
    [aux_sym_class_declaration_repeat1] = STATE(3830),
    [aux_sym_lambda_expression_repeat1] = STATE(4194),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2153),
    [anon_sym_ref] = ACTIONS(2155),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2157),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2161),
    [anon_sym_TILDE] = ACTIONS(2161),
    [anon_sym_PLUS_PLUS] = ACTIONS(2161),
    [anon_sym_DASH_DASH] = ACTIONS(2161),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2159),
    [anon_sym_DASH] = ACTIONS(2159),
    [anon_sym_STAR] = ACTIONS(2163),
    [anon_sym_CARET] = ACTIONS(2161),
    [anon_sym_AMP] = ACTIONS(2161),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2165),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2167),
    [anon_sym_DOT_DOT] = ACTIONS(2169),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1371] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6918),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7126),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4777),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(3736),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7377),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9441),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1371),
    [sym_preproc_endregion] = STATE(1371),
    [sym_preproc_line] = STATE(1371),
    [sym_preproc_pragma] = STATE(1371),
    [sym_preproc_nullable] = STATE(1371),
    [sym_preproc_error] = STATE(1371),
    [sym_preproc_define] = STATE(1371),
    [sym_preproc_undef] = STATE(1371),
    [aux_sym_class_declaration_repeat1] = STATE(3848),
    [aux_sym_lambda_expression_repeat1] = STATE(4242),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1213),
    [anon_sym_ref] = ACTIONS(1215),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1221),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1227),
    [anon_sym_TILDE] = ACTIONS(1227),
    [anon_sym_PLUS_PLUS] = ACTIONS(1227),
    [anon_sym_DASH_DASH] = ACTIONS(1227),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1225),
    [anon_sym_DASH] = ACTIONS(1225),
    [anon_sym_STAR] = ACTIONS(1231),
    [anon_sym_CARET] = ACTIONS(1227),
    [anon_sym_AMP] = ACTIONS(1227),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1239),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1241),
    [anon_sym_DOT_DOT] = ACTIONS(1243),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1372] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6898),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2940),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6925),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6472),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4498),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7403),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(8973),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1372),
    [sym_preproc_endregion] = STATE(1372),
    [sym_preproc_line] = STATE(1372),
    [sym_preproc_pragma] = STATE(1372),
    [sym_preproc_nullable] = STATE(1372),
    [sym_preproc_error] = STATE(1372),
    [sym_preproc_define] = STATE(1372),
    [sym_preproc_undef] = STATE(1372),
    [aux_sym_class_declaration_repeat1] = STATE(3830),
    [aux_sym_lambda_expression_repeat1] = STATE(4194),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2153),
    [anon_sym_ref] = ACTIONS(2155),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2157),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2161),
    [anon_sym_TILDE] = ACTIONS(2161),
    [anon_sym_PLUS_PLUS] = ACTIONS(2161),
    [anon_sym_DASH_DASH] = ACTIONS(2161),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2159),
    [anon_sym_DASH] = ACTIONS(2159),
    [anon_sym_STAR] = ACTIONS(2163),
    [anon_sym_CARET] = ACTIONS(2161),
    [anon_sym_AMP] = ACTIONS(2161),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2165),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2167),
    [anon_sym_DOT_DOT] = ACTIONS(2169),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1373] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6901),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2939),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7085),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(3901),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4322),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7392),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9185),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1373),
    [sym_preproc_endregion] = STATE(1373),
    [sym_preproc_line] = STATE(1373),
    [sym_preproc_pragma] = STATE(1373),
    [sym_preproc_nullable] = STATE(1373),
    [sym_preproc_error] = STATE(1373),
    [sym_preproc_define] = STATE(1373),
    [sym_preproc_undef] = STATE(1373),
    [aux_sym_class_declaration_repeat1] = STATE(3819),
    [aux_sym_lambda_expression_repeat1] = STATE(4161),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_ref] = ACTIONS(1761),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1763),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1767),
    [anon_sym_TILDE] = ACTIONS(1767),
    [anon_sym_PLUS_PLUS] = ACTIONS(1767),
    [anon_sym_DASH_DASH] = ACTIONS(1767),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1765),
    [anon_sym_STAR] = ACTIONS(1769),
    [anon_sym_CARET] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(1767),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1771),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1773),
    [anon_sym_DOT_DOT] = ACTIONS(1775),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1374] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6898),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2940),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6925),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6469),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4498),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7403),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(8973),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1374),
    [sym_preproc_endregion] = STATE(1374),
    [sym_preproc_line] = STATE(1374),
    [sym_preproc_pragma] = STATE(1374),
    [sym_preproc_nullable] = STATE(1374),
    [sym_preproc_error] = STATE(1374),
    [sym_preproc_define] = STATE(1374),
    [sym_preproc_undef] = STATE(1374),
    [aux_sym_class_declaration_repeat1] = STATE(3830),
    [aux_sym_lambda_expression_repeat1] = STATE(4194),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2153),
    [anon_sym_ref] = ACTIONS(2155),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2157),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2161),
    [anon_sym_TILDE] = ACTIONS(2161),
    [anon_sym_PLUS_PLUS] = ACTIONS(2161),
    [anon_sym_DASH_DASH] = ACTIONS(2161),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2159),
    [anon_sym_DASH] = ACTIONS(2159),
    [anon_sym_STAR] = ACTIONS(2163),
    [anon_sym_CARET] = ACTIONS(2161),
    [anon_sym_AMP] = ACTIONS(2161),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2165),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2167),
    [anon_sym_DOT_DOT] = ACTIONS(2169),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1375] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6381),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1375),
    [sym_preproc_endregion] = STATE(1375),
    [sym_preproc_line] = STATE(1375),
    [sym_preproc_pragma] = STATE(1375),
    [sym_preproc_nullable] = STATE(1375),
    [sym_preproc_error] = STATE(1375),
    [sym_preproc_define] = STATE(1375),
    [sym_preproc_undef] = STATE(1375),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1376] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6918),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7126),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4780),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(3736),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7377),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9441),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1376),
    [sym_preproc_endregion] = STATE(1376),
    [sym_preproc_line] = STATE(1376),
    [sym_preproc_pragma] = STATE(1376),
    [sym_preproc_nullable] = STATE(1376),
    [sym_preproc_error] = STATE(1376),
    [sym_preproc_define] = STATE(1376),
    [sym_preproc_undef] = STATE(1376),
    [aux_sym_class_declaration_repeat1] = STATE(3848),
    [aux_sym_lambda_expression_repeat1] = STATE(4242),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1213),
    [anon_sym_ref] = ACTIONS(1215),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1221),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1227),
    [anon_sym_TILDE] = ACTIONS(1227),
    [anon_sym_PLUS_PLUS] = ACTIONS(1227),
    [anon_sym_DASH_DASH] = ACTIONS(1227),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1225),
    [anon_sym_DASH] = ACTIONS(1225),
    [anon_sym_STAR] = ACTIONS(1231),
    [anon_sym_CARET] = ACTIONS(1227),
    [anon_sym_AMP] = ACTIONS(1227),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1239),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1241),
    [anon_sym_DOT_DOT] = ACTIONS(1243),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1377] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6901),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2939),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7085),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5831),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4322),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7392),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9185),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1377),
    [sym_preproc_endregion] = STATE(1377),
    [sym_preproc_line] = STATE(1377),
    [sym_preproc_pragma] = STATE(1377),
    [sym_preproc_nullable] = STATE(1377),
    [sym_preproc_error] = STATE(1377),
    [sym_preproc_define] = STATE(1377),
    [sym_preproc_undef] = STATE(1377),
    [aux_sym_class_declaration_repeat1] = STATE(3819),
    [aux_sym_lambda_expression_repeat1] = STATE(4161),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_ref] = ACTIONS(1761),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1763),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1767),
    [anon_sym_TILDE] = ACTIONS(1767),
    [anon_sym_PLUS_PLUS] = ACTIONS(1767),
    [anon_sym_DASH_DASH] = ACTIONS(1767),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1765),
    [anon_sym_STAR] = ACTIONS(1769),
    [anon_sym_CARET] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(1767),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1771),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1773),
    [anon_sym_DOT_DOT] = ACTIONS(1775),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1378] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6918),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7126),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4786),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(3736),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7377),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9441),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1378),
    [sym_preproc_endregion] = STATE(1378),
    [sym_preproc_line] = STATE(1378),
    [sym_preproc_pragma] = STATE(1378),
    [sym_preproc_nullable] = STATE(1378),
    [sym_preproc_error] = STATE(1378),
    [sym_preproc_define] = STATE(1378),
    [sym_preproc_undef] = STATE(1378),
    [aux_sym_class_declaration_repeat1] = STATE(3848),
    [aux_sym_lambda_expression_repeat1] = STATE(4242),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1213),
    [anon_sym_ref] = ACTIONS(1215),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1221),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1227),
    [anon_sym_TILDE] = ACTIONS(1227),
    [anon_sym_PLUS_PLUS] = ACTIONS(1227),
    [anon_sym_DASH_DASH] = ACTIONS(1227),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1225),
    [anon_sym_DASH] = ACTIONS(1225),
    [anon_sym_STAR] = ACTIONS(1231),
    [anon_sym_CARET] = ACTIONS(1227),
    [anon_sym_AMP] = ACTIONS(1227),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1239),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1241),
    [anon_sym_DOT_DOT] = ACTIONS(1243),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1379] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6898),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2940),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6925),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6379),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4498),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7403),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(8973),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1379),
    [sym_preproc_endregion] = STATE(1379),
    [sym_preproc_line] = STATE(1379),
    [sym_preproc_pragma] = STATE(1379),
    [sym_preproc_nullable] = STATE(1379),
    [sym_preproc_error] = STATE(1379),
    [sym_preproc_define] = STATE(1379),
    [sym_preproc_undef] = STATE(1379),
    [aux_sym_class_declaration_repeat1] = STATE(3830),
    [aux_sym_lambda_expression_repeat1] = STATE(4194),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2153),
    [anon_sym_ref] = ACTIONS(2155),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2157),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2161),
    [anon_sym_TILDE] = ACTIONS(2161),
    [anon_sym_PLUS_PLUS] = ACTIONS(2161),
    [anon_sym_DASH_DASH] = ACTIONS(2161),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2159),
    [anon_sym_DASH] = ACTIONS(2159),
    [anon_sym_STAR] = ACTIONS(2163),
    [anon_sym_CARET] = ACTIONS(2161),
    [anon_sym_AMP] = ACTIONS(2161),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2165),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2167),
    [anon_sym_DOT_DOT] = ACTIONS(2169),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1380] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6918),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7126),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4787),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(3736),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7377),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9441),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1380),
    [sym_preproc_endregion] = STATE(1380),
    [sym_preproc_line] = STATE(1380),
    [sym_preproc_pragma] = STATE(1380),
    [sym_preproc_nullable] = STATE(1380),
    [sym_preproc_error] = STATE(1380),
    [sym_preproc_define] = STATE(1380),
    [sym_preproc_undef] = STATE(1380),
    [aux_sym_class_declaration_repeat1] = STATE(3848),
    [aux_sym_lambda_expression_repeat1] = STATE(4242),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1213),
    [anon_sym_ref] = ACTIONS(1215),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1221),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1227),
    [anon_sym_TILDE] = ACTIONS(1227),
    [anon_sym_PLUS_PLUS] = ACTIONS(1227),
    [anon_sym_DASH_DASH] = ACTIONS(1227),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1225),
    [anon_sym_DASH] = ACTIONS(1225),
    [anon_sym_STAR] = ACTIONS(1231),
    [anon_sym_CARET] = ACTIONS(1227),
    [anon_sym_AMP] = ACTIONS(1227),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1239),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1241),
    [anon_sym_DOT_DOT] = ACTIONS(1243),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1381] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6918),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7126),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4790),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(3736),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7377),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9441),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1381),
    [sym_preproc_endregion] = STATE(1381),
    [sym_preproc_line] = STATE(1381),
    [sym_preproc_pragma] = STATE(1381),
    [sym_preproc_nullable] = STATE(1381),
    [sym_preproc_error] = STATE(1381),
    [sym_preproc_define] = STATE(1381),
    [sym_preproc_undef] = STATE(1381),
    [aux_sym_class_declaration_repeat1] = STATE(3848),
    [aux_sym_lambda_expression_repeat1] = STATE(4242),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1213),
    [anon_sym_ref] = ACTIONS(1215),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1221),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1227),
    [anon_sym_TILDE] = ACTIONS(1227),
    [anon_sym_PLUS_PLUS] = ACTIONS(1227),
    [anon_sym_DASH_DASH] = ACTIONS(1227),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1225),
    [anon_sym_DASH] = ACTIONS(1225),
    [anon_sym_STAR] = ACTIONS(1231),
    [anon_sym_CARET] = ACTIONS(1227),
    [anon_sym_AMP] = ACTIONS(1227),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1239),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1241),
    [anon_sym_DOT_DOT] = ACTIONS(1243),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1382] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6180),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1382),
    [sym_preproc_endregion] = STATE(1382),
    [sym_preproc_line] = STATE(1382),
    [sym_preproc_pragma] = STATE(1382),
    [sym_preproc_nullable] = STATE(1382),
    [sym_preproc_error] = STATE(1382),
    [sym_preproc_define] = STATE(1382),
    [sym_preproc_undef] = STATE(1382),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1383] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6918),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7126),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4791),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(3736),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7377),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9441),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1383),
    [sym_preproc_endregion] = STATE(1383),
    [sym_preproc_line] = STATE(1383),
    [sym_preproc_pragma] = STATE(1383),
    [sym_preproc_nullable] = STATE(1383),
    [sym_preproc_error] = STATE(1383),
    [sym_preproc_define] = STATE(1383),
    [sym_preproc_undef] = STATE(1383),
    [aux_sym_class_declaration_repeat1] = STATE(3848),
    [aux_sym_lambda_expression_repeat1] = STATE(4242),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1213),
    [anon_sym_ref] = ACTIONS(1215),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1221),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1227),
    [anon_sym_TILDE] = ACTIONS(1227),
    [anon_sym_PLUS_PLUS] = ACTIONS(1227),
    [anon_sym_DASH_DASH] = ACTIONS(1227),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1225),
    [anon_sym_DASH] = ACTIONS(1225),
    [anon_sym_STAR] = ACTIONS(1231),
    [anon_sym_CARET] = ACTIONS(1227),
    [anon_sym_AMP] = ACTIONS(1227),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1239),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1241),
    [anon_sym_DOT_DOT] = ACTIONS(1243),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1384] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6898),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2940),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6925),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4325),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4498),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7403),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(8973),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1384),
    [sym_preproc_endregion] = STATE(1384),
    [sym_preproc_line] = STATE(1384),
    [sym_preproc_pragma] = STATE(1384),
    [sym_preproc_nullable] = STATE(1384),
    [sym_preproc_error] = STATE(1384),
    [sym_preproc_define] = STATE(1384),
    [sym_preproc_undef] = STATE(1384),
    [aux_sym_class_declaration_repeat1] = STATE(3830),
    [aux_sym_lambda_expression_repeat1] = STATE(4194),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2153),
    [anon_sym_ref] = ACTIONS(2155),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2157),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2161),
    [anon_sym_TILDE] = ACTIONS(2161),
    [anon_sym_PLUS_PLUS] = ACTIONS(2161),
    [anon_sym_DASH_DASH] = ACTIONS(2161),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2159),
    [anon_sym_DASH] = ACTIONS(2159),
    [anon_sym_STAR] = ACTIONS(2163),
    [anon_sym_CARET] = ACTIONS(2161),
    [anon_sym_AMP] = ACTIONS(2161),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2165),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2167),
    [anon_sym_DOT_DOT] = ACTIONS(2169),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1385] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6898),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2940),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6925),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6403),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4498),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7403),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(8973),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1385),
    [sym_preproc_endregion] = STATE(1385),
    [sym_preproc_line] = STATE(1385),
    [sym_preproc_pragma] = STATE(1385),
    [sym_preproc_nullable] = STATE(1385),
    [sym_preproc_error] = STATE(1385),
    [sym_preproc_define] = STATE(1385),
    [sym_preproc_undef] = STATE(1385),
    [aux_sym_class_declaration_repeat1] = STATE(3830),
    [aux_sym_lambda_expression_repeat1] = STATE(4194),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2153),
    [anon_sym_ref] = ACTIONS(2155),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2157),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2161),
    [anon_sym_TILDE] = ACTIONS(2161),
    [anon_sym_PLUS_PLUS] = ACTIONS(2161),
    [anon_sym_DASH_DASH] = ACTIONS(2161),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2159),
    [anon_sym_DASH] = ACTIONS(2159),
    [anon_sym_STAR] = ACTIONS(2163),
    [anon_sym_CARET] = ACTIONS(2161),
    [anon_sym_AMP] = ACTIONS(2161),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2165),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2167),
    [anon_sym_DOT_DOT] = ACTIONS(2169),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1386] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6901),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2939),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7085),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5842),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4322),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7392),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9185),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1386),
    [sym_preproc_endregion] = STATE(1386),
    [sym_preproc_line] = STATE(1386),
    [sym_preproc_pragma] = STATE(1386),
    [sym_preproc_nullable] = STATE(1386),
    [sym_preproc_error] = STATE(1386),
    [sym_preproc_define] = STATE(1386),
    [sym_preproc_undef] = STATE(1386),
    [aux_sym_class_declaration_repeat1] = STATE(3819),
    [aux_sym_lambda_expression_repeat1] = STATE(4161),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_ref] = ACTIONS(1761),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1763),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1767),
    [anon_sym_TILDE] = ACTIONS(1767),
    [anon_sym_PLUS_PLUS] = ACTIONS(1767),
    [anon_sym_DASH_DASH] = ACTIONS(1767),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1765),
    [anon_sym_STAR] = ACTIONS(1769),
    [anon_sym_CARET] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(1767),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1771),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1773),
    [anon_sym_DOT_DOT] = ACTIONS(1775),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1387] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6918),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7126),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4804),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(3736),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7377),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9441),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1387),
    [sym_preproc_endregion] = STATE(1387),
    [sym_preproc_line] = STATE(1387),
    [sym_preproc_pragma] = STATE(1387),
    [sym_preproc_nullable] = STATE(1387),
    [sym_preproc_error] = STATE(1387),
    [sym_preproc_define] = STATE(1387),
    [sym_preproc_undef] = STATE(1387),
    [aux_sym_class_declaration_repeat1] = STATE(3848),
    [aux_sym_lambda_expression_repeat1] = STATE(4242),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1213),
    [anon_sym_ref] = ACTIONS(1215),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1221),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1227),
    [anon_sym_TILDE] = ACTIONS(1227),
    [anon_sym_PLUS_PLUS] = ACTIONS(1227),
    [anon_sym_DASH_DASH] = ACTIONS(1227),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1225),
    [anon_sym_DASH] = ACTIONS(1225),
    [anon_sym_STAR] = ACTIONS(1231),
    [anon_sym_CARET] = ACTIONS(1227),
    [anon_sym_AMP] = ACTIONS(1227),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1239),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1241),
    [anon_sym_DOT_DOT] = ACTIONS(1243),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1388] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6918),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7126),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4718),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(3736),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7377),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9441),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1388),
    [sym_preproc_endregion] = STATE(1388),
    [sym_preproc_line] = STATE(1388),
    [sym_preproc_pragma] = STATE(1388),
    [sym_preproc_nullable] = STATE(1388),
    [sym_preproc_error] = STATE(1388),
    [sym_preproc_define] = STATE(1388),
    [sym_preproc_undef] = STATE(1388),
    [aux_sym_class_declaration_repeat1] = STATE(3848),
    [aux_sym_lambda_expression_repeat1] = STATE(4242),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1213),
    [anon_sym_ref] = ACTIONS(1215),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1221),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1227),
    [anon_sym_TILDE] = ACTIONS(1227),
    [anon_sym_PLUS_PLUS] = ACTIONS(1227),
    [anon_sym_DASH_DASH] = ACTIONS(1227),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1225),
    [anon_sym_DASH] = ACTIONS(1225),
    [anon_sym_STAR] = ACTIONS(1231),
    [anon_sym_CARET] = ACTIONS(1227),
    [anon_sym_AMP] = ACTIONS(1227),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1239),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1241),
    [anon_sym_DOT_DOT] = ACTIONS(1243),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1389] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6918),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7126),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4811),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(3736),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7377),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9441),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1389),
    [sym_preproc_endregion] = STATE(1389),
    [sym_preproc_line] = STATE(1389),
    [sym_preproc_pragma] = STATE(1389),
    [sym_preproc_nullable] = STATE(1389),
    [sym_preproc_error] = STATE(1389),
    [sym_preproc_define] = STATE(1389),
    [sym_preproc_undef] = STATE(1389),
    [aux_sym_class_declaration_repeat1] = STATE(3848),
    [aux_sym_lambda_expression_repeat1] = STATE(4242),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1213),
    [anon_sym_ref] = ACTIONS(1215),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1221),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1227),
    [anon_sym_TILDE] = ACTIONS(1227),
    [anon_sym_PLUS_PLUS] = ACTIONS(1227),
    [anon_sym_DASH_DASH] = ACTIONS(1227),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1225),
    [anon_sym_DASH] = ACTIONS(1225),
    [anon_sym_STAR] = ACTIONS(1231),
    [anon_sym_CARET] = ACTIONS(1227),
    [anon_sym_AMP] = ACTIONS(1227),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1239),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1241),
    [anon_sym_DOT_DOT] = ACTIONS(1243),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1390] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3921),
    [sym__name] = STATE(6919),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2868),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(7068),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6165),
    [sym_non_lvalue_expression] = STATE(5735),
    [sym_lvalue_expression] = STATE(4323),
    [sym__expression_statement_expression] = STATE(5733),
    [sym_assignment_expression] = STATE(5734),
    [sym_binary_expression] = STATE(5733),
    [sym_postfix_unary_expression] = STATE(5734),
    [sym_prefix_unary_expression] = STATE(5734),
    [sym__pointer_indirection_expression] = STATE(3911),
    [sym_query_expression] = STATE(5733),
    [sym_from_clause] = STATE(7393),
    [sym_conditional_expression] = STATE(5733),
    [sym_conditional_access_expression] = STATE(5733),
    [sym_as_expression] = STATE(5733),
    [sym_is_expression] = STATE(5733),
    [sym_is_pattern_expression] = STATE(5733),
    [sym_cast_expression] = STATE(5733),
    [sym_checked_expression] = STATE(5733),
    [sym_invocation_expression] = STATE(5734),
    [sym_switch_expression] = STATE(5733),
    [sym_await_expression] = STATE(5734),
    [sym_throw_expression] = STATE(5733),
    [sym_element_access_expression] = STATE(3911),
    [sym_interpolated_string_expression] = STATE(5733),
    [sym_member_access_expression] = STATE(3911),
    [sym_object_creation_expression] = STATE(5734),
    [sym_parenthesized_expression] = STATE(5734),
    [sym__parenthesized_lvalue_expression] = STATE(3911),
    [sym_lambda_expression] = STATE(5733),
    [sym__lambda_parameters] = STATE(9932),
    [sym_array_creation_expression] = STATE(5733),
    [sym_anonymous_method_expression] = STATE(5733),
    [sym_anonymous_object_creation_expression] = STATE(5733),
    [sym_implicit_array_creation_expression] = STATE(5733),
    [sym_implicit_object_creation_expression] = STATE(5733),
    [sym_implicit_stackalloc_expression] = STATE(5733),
    [sym_initializer_expression] = STATE(5733),
    [sym_default_expression] = STATE(5733),
    [sym_with_expression] = STATE(5733),
    [sym_sizeof_expression] = STATE(5733),
    [sym_typeof_expression] = STATE(5733),
    [sym_makeref_expression] = STATE(5733),
    [sym_ref_expression] = STATE(5733),
    [sym_reftype_expression] = STATE(5733),
    [sym_refvalue_expression] = STATE(5733),
    [sym_stackalloc_expression] = STATE(5733),
    [sym_range_expression] = STATE(5733),
    [sym_tuple_expression] = STATE(3911),
    [sym_literal] = STATE(5733),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2798),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(5733),
    [sym_preproc_region] = STATE(1390),
    [sym_preproc_endregion] = STATE(1390),
    [sym_preproc_line] = STATE(1390),
    [sym_preproc_pragma] = STATE(1390),
    [sym_preproc_nullable] = STATE(1390),
    [sym_preproc_error] = STATE(1390),
    [sym_preproc_define] = STATE(1390),
    [sym_preproc_undef] = STATE(1390),
    [aux_sym_class_declaration_repeat1] = STATE(3831),
    [aux_sym_lambda_expression_repeat1] = STATE(4227),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_LPAREN] = ACTIONS(1577),
    [anon_sym_ref] = ACTIONS(1579),
    [anon_sym_LBRACE] = ACTIONS(1377),
    [anon_sym_delegate] = ACTIONS(1379),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1381),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1583),
    [anon_sym_TILDE] = ACTIONS(1583),
    [anon_sym_PLUS_PLUS] = ACTIONS(1583),
    [anon_sym_DASH_DASH] = ACTIONS(1583),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1581),
    [anon_sym_DASH] = ACTIONS(1581),
    [anon_sym_STAR] = ACTIONS(1391),
    [anon_sym_CARET] = ACTIONS(1583),
    [anon_sym_AMP] = ACTIONS(1583),
    [anon_sym_this] = ACTIONS(1393),
    [anon_sym_scoped] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1397),
    [sym_predefined_type] = ACTIONS(1399),
    [anon_sym_unchecked] = ACTIONS(1383),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1585),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1587),
    [anon_sym_DOT_DOT] = ACTIONS(1589),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_stackalloc] = ACTIONS(1413),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(1419),
    [anon_sym___reftype] = ACTIONS(1421),
    [anon_sym___refvalue] = ACTIONS(1423),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
  },
  [1391] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6918),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7094),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6691),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(2988),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1391),
    [sym_preproc_endregion] = STATE(1391),
    [sym_preproc_line] = STATE(1391),
    [sym_preproc_pragma] = STATE(1391),
    [sym_preproc_nullable] = STATE(1391),
    [sym_preproc_error] = STATE(1391),
    [sym_preproc_define] = STATE(1391),
    [sym_preproc_undef] = STATE(1391),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2911),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1669),
    [anon_sym_TILDE] = ACTIONS(1669),
    [anon_sym_PLUS_PLUS] = ACTIONS(1669),
    [anon_sym_DASH_DASH] = ACTIONS(1669),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1667),
    [anon_sym_DASH] = ACTIONS(1667),
    [anon_sym_STAR] = ACTIONS(1231),
    [anon_sym_CARET] = ACTIONS(1669),
    [anon_sym_AMP] = ACTIONS(1669),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1392] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3559),
    [sym__name] = STATE(6878),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2911),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6938),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4345),
    [sym_non_lvalue_expression] = STATE(4553),
    [sym_lvalue_expression] = STATE(3750),
    [sym__expression_statement_expression] = STATE(4559),
    [sym_assignment_expression] = STATE(4558),
    [sym_binary_expression] = STATE(4559),
    [sym_postfix_unary_expression] = STATE(4558),
    [sym_prefix_unary_expression] = STATE(4558),
    [sym__pointer_indirection_expression] = STATE(3560),
    [sym_query_expression] = STATE(4559),
    [sym_from_clause] = STATE(7406),
    [sym_conditional_expression] = STATE(4559),
    [sym_conditional_access_expression] = STATE(4559),
    [sym_as_expression] = STATE(4559),
    [sym_is_expression] = STATE(4559),
    [sym_is_pattern_expression] = STATE(4559),
    [sym_cast_expression] = STATE(4559),
    [sym_checked_expression] = STATE(4559),
    [sym_invocation_expression] = STATE(4558),
    [sym_switch_expression] = STATE(4559),
    [sym_await_expression] = STATE(4558),
    [sym_throw_expression] = STATE(4559),
    [sym_element_access_expression] = STATE(3560),
    [sym_interpolated_string_expression] = STATE(4559),
    [sym_member_access_expression] = STATE(3560),
    [sym_object_creation_expression] = STATE(4558),
    [sym_parenthesized_expression] = STATE(4558),
    [sym__parenthesized_lvalue_expression] = STATE(3560),
    [sym_lambda_expression] = STATE(4559),
    [sym__lambda_parameters] = STATE(9691),
    [sym_array_creation_expression] = STATE(4559),
    [sym_anonymous_method_expression] = STATE(4559),
    [sym_anonymous_object_creation_expression] = STATE(4559),
    [sym_implicit_array_creation_expression] = STATE(4559),
    [sym_implicit_object_creation_expression] = STATE(4559),
    [sym_implicit_stackalloc_expression] = STATE(4559),
    [sym_initializer_expression] = STATE(4559),
    [sym_default_expression] = STATE(4559),
    [sym_with_expression] = STATE(4559),
    [sym_sizeof_expression] = STATE(4559),
    [sym_typeof_expression] = STATE(4559),
    [sym_makeref_expression] = STATE(4559),
    [sym_ref_expression] = STATE(4559),
    [sym_reftype_expression] = STATE(4559),
    [sym_refvalue_expression] = STATE(4559),
    [sym_stackalloc_expression] = STATE(4559),
    [sym_range_expression] = STATE(4559),
    [sym_tuple_expression] = STATE(3560),
    [sym_literal] = STATE(4559),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4559),
    [sym_preproc_region] = STATE(1392),
    [sym_preproc_endregion] = STATE(1392),
    [sym_preproc_line] = STATE(1392),
    [sym_preproc_pragma] = STATE(1392),
    [sym_preproc_nullable] = STATE(1392),
    [sym_preproc_error] = STATE(1392),
    [sym_preproc_define] = STATE(1392),
    [sym_preproc_undef] = STATE(1392),
    [aux_sym_class_declaration_repeat1] = STATE(3836),
    [aux_sym_lambda_expression_repeat1] = STATE(4216),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(2003),
    [anon_sym_ref] = ACTIONS(2005),
    [anon_sym_LBRACE] = ACTIONS(1611),
    [anon_sym_delegate] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1615),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(2009),
    [anon_sym_TILDE] = ACTIONS(2009),
    [anon_sym_PLUS_PLUS] = ACTIONS(2009),
    [anon_sym_DASH_DASH] = ACTIONS(2009),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(2007),
    [anon_sym_DASH] = ACTIONS(2007),
    [anon_sym_STAR] = ACTIONS(1625),
    [anon_sym_CARET] = ACTIONS(2009),
    [anon_sym_AMP] = ACTIONS(2009),
    [anon_sym_this] = ACTIONS(1627),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1629),
    [anon_sym_unchecked] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(2011),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2013),
    [anon_sym_DOT_DOT] = ACTIONS(2015),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_stackalloc] = ACTIONS(1641),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(1647),
    [anon_sym___reftype] = ACTIONS(1649),
    [anon_sym___refvalue] = ACTIONS(1651),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1659),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [1393] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6913),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7000),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5530),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4181),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7384),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9143),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1393),
    [sym_preproc_endregion] = STATE(1393),
    [sym_preproc_line] = STATE(1393),
    [sym_preproc_pragma] = STATE(1393),
    [sym_preproc_nullable] = STATE(1393),
    [sym_preproc_error] = STATE(1393),
    [sym_preproc_define] = STATE(1393),
    [sym_preproc_undef] = STATE(1393),
    [aux_sym_class_declaration_repeat1] = STATE(3814),
    [aux_sym_lambda_expression_repeat1] = STATE(4171),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1561),
    [anon_sym_ref] = ACTIONS(1563),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1145),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(1567),
    [anon_sym_PLUS_PLUS] = ACTIONS(1567),
    [anon_sym_DASH_DASH] = ACTIONS(1567),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1565),
    [anon_sym_DASH] = ACTIONS(1565),
    [anon_sym_STAR] = ACTIONS(1569),
    [anon_sym_CARET] = ACTIONS(1567),
    [anon_sym_AMP] = ACTIONS(1567),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1571),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1573),
    [anon_sym_DOT_DOT] = ACTIONS(1575),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1394] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6913),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7000),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(3822),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4181),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7384),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9143),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1394),
    [sym_preproc_endregion] = STATE(1394),
    [sym_preproc_line] = STATE(1394),
    [sym_preproc_pragma] = STATE(1394),
    [sym_preproc_nullable] = STATE(1394),
    [sym_preproc_error] = STATE(1394),
    [sym_preproc_define] = STATE(1394),
    [sym_preproc_undef] = STATE(1394),
    [aux_sym_class_declaration_repeat1] = STATE(3814),
    [aux_sym_lambda_expression_repeat1] = STATE(4171),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1561),
    [anon_sym_ref] = ACTIONS(1563),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1145),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(1567),
    [anon_sym_PLUS_PLUS] = ACTIONS(1567),
    [anon_sym_DASH_DASH] = ACTIONS(1567),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1565),
    [anon_sym_DASH] = ACTIONS(1565),
    [anon_sym_STAR] = ACTIONS(1569),
    [anon_sym_CARET] = ACTIONS(1567),
    [anon_sym_AMP] = ACTIONS(1567),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1571),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1573),
    [anon_sym_DOT_DOT] = ACTIONS(1575),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1395] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6913),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7000),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5711),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4181),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7384),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9143),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1395),
    [sym_preproc_endregion] = STATE(1395),
    [sym_preproc_line] = STATE(1395),
    [sym_preproc_pragma] = STATE(1395),
    [sym_preproc_nullable] = STATE(1395),
    [sym_preproc_error] = STATE(1395),
    [sym_preproc_define] = STATE(1395),
    [sym_preproc_undef] = STATE(1395),
    [aux_sym_class_declaration_repeat1] = STATE(3814),
    [aux_sym_lambda_expression_repeat1] = STATE(4171),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1561),
    [anon_sym_ref] = ACTIONS(1563),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1145),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(1567),
    [anon_sym_PLUS_PLUS] = ACTIONS(1567),
    [anon_sym_DASH_DASH] = ACTIONS(1567),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1565),
    [anon_sym_DASH] = ACTIONS(1565),
    [anon_sym_STAR] = ACTIONS(1569),
    [anon_sym_CARET] = ACTIONS(1567),
    [anon_sym_AMP] = ACTIONS(1567),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1571),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1573),
    [anon_sym_DOT_DOT] = ACTIONS(1575),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1396] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3921),
    [sym__name] = STATE(6919),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2868),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(7068),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6017),
    [sym_non_lvalue_expression] = STATE(5735),
    [sym_lvalue_expression] = STATE(4323),
    [sym__expression_statement_expression] = STATE(5733),
    [sym_assignment_expression] = STATE(5734),
    [sym_binary_expression] = STATE(5733),
    [sym_postfix_unary_expression] = STATE(5734),
    [sym_prefix_unary_expression] = STATE(5734),
    [sym__pointer_indirection_expression] = STATE(3911),
    [sym_query_expression] = STATE(5733),
    [sym_from_clause] = STATE(7393),
    [sym_conditional_expression] = STATE(5733),
    [sym_conditional_access_expression] = STATE(5733),
    [sym_as_expression] = STATE(5733),
    [sym_is_expression] = STATE(5733),
    [sym_is_pattern_expression] = STATE(5733),
    [sym_cast_expression] = STATE(5733),
    [sym_checked_expression] = STATE(5733),
    [sym_invocation_expression] = STATE(5734),
    [sym_switch_expression] = STATE(5733),
    [sym_await_expression] = STATE(5734),
    [sym_throw_expression] = STATE(5733),
    [sym_element_access_expression] = STATE(3911),
    [sym_interpolated_string_expression] = STATE(5733),
    [sym_member_access_expression] = STATE(3911),
    [sym_object_creation_expression] = STATE(5734),
    [sym_parenthesized_expression] = STATE(5734),
    [sym__parenthesized_lvalue_expression] = STATE(3911),
    [sym_lambda_expression] = STATE(5733),
    [sym__lambda_parameters] = STATE(9932),
    [sym_array_creation_expression] = STATE(5733),
    [sym_anonymous_method_expression] = STATE(5733),
    [sym_anonymous_object_creation_expression] = STATE(5733),
    [sym_implicit_array_creation_expression] = STATE(5733),
    [sym_implicit_object_creation_expression] = STATE(5733),
    [sym_implicit_stackalloc_expression] = STATE(5733),
    [sym_initializer_expression] = STATE(5733),
    [sym_default_expression] = STATE(5733),
    [sym_with_expression] = STATE(5733),
    [sym_sizeof_expression] = STATE(5733),
    [sym_typeof_expression] = STATE(5733),
    [sym_makeref_expression] = STATE(5733),
    [sym_ref_expression] = STATE(5733),
    [sym_reftype_expression] = STATE(5733),
    [sym_refvalue_expression] = STATE(5733),
    [sym_stackalloc_expression] = STATE(5733),
    [sym_range_expression] = STATE(5733),
    [sym_tuple_expression] = STATE(3911),
    [sym_literal] = STATE(5733),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2798),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(5733),
    [sym_preproc_region] = STATE(1396),
    [sym_preproc_endregion] = STATE(1396),
    [sym_preproc_line] = STATE(1396),
    [sym_preproc_pragma] = STATE(1396),
    [sym_preproc_nullable] = STATE(1396),
    [sym_preproc_error] = STATE(1396),
    [sym_preproc_define] = STATE(1396),
    [sym_preproc_undef] = STATE(1396),
    [aux_sym_class_declaration_repeat1] = STATE(3831),
    [aux_sym_lambda_expression_repeat1] = STATE(4227),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_LPAREN] = ACTIONS(1577),
    [anon_sym_ref] = ACTIONS(1579),
    [anon_sym_LBRACE] = ACTIONS(1377),
    [anon_sym_delegate] = ACTIONS(1379),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1381),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1583),
    [anon_sym_TILDE] = ACTIONS(1583),
    [anon_sym_PLUS_PLUS] = ACTIONS(1583),
    [anon_sym_DASH_DASH] = ACTIONS(1583),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1581),
    [anon_sym_DASH] = ACTIONS(1581),
    [anon_sym_STAR] = ACTIONS(1391),
    [anon_sym_CARET] = ACTIONS(1583),
    [anon_sym_AMP] = ACTIONS(1583),
    [anon_sym_this] = ACTIONS(1393),
    [anon_sym_scoped] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1397),
    [sym_predefined_type] = ACTIONS(1399),
    [anon_sym_unchecked] = ACTIONS(1383),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1585),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1587),
    [anon_sym_DOT_DOT] = ACTIONS(1589),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_stackalloc] = ACTIONS(1413),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(1419),
    [anon_sym___reftype] = ACTIONS(1421),
    [anon_sym___refvalue] = ACTIONS(1423),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
  },
  [1397] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6913),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7000),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5710),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4181),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7384),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9143),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1397),
    [sym_preproc_endregion] = STATE(1397),
    [sym_preproc_line] = STATE(1397),
    [sym_preproc_pragma] = STATE(1397),
    [sym_preproc_nullable] = STATE(1397),
    [sym_preproc_error] = STATE(1397),
    [sym_preproc_define] = STATE(1397),
    [sym_preproc_undef] = STATE(1397),
    [aux_sym_class_declaration_repeat1] = STATE(3814),
    [aux_sym_lambda_expression_repeat1] = STATE(4171),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1561),
    [anon_sym_ref] = ACTIONS(1563),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1145),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(1567),
    [anon_sym_PLUS_PLUS] = ACTIONS(1567),
    [anon_sym_DASH_DASH] = ACTIONS(1567),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1565),
    [anon_sym_DASH] = ACTIONS(1565),
    [anon_sym_STAR] = ACTIONS(1569),
    [anon_sym_CARET] = ACTIONS(1567),
    [anon_sym_AMP] = ACTIONS(1567),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1571),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1573),
    [anon_sym_DOT_DOT] = ACTIONS(1575),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1398] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6913),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7000),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5698),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4181),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7384),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9143),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1398),
    [sym_preproc_endregion] = STATE(1398),
    [sym_preproc_line] = STATE(1398),
    [sym_preproc_pragma] = STATE(1398),
    [sym_preproc_nullable] = STATE(1398),
    [sym_preproc_error] = STATE(1398),
    [sym_preproc_define] = STATE(1398),
    [sym_preproc_undef] = STATE(1398),
    [aux_sym_class_declaration_repeat1] = STATE(3814),
    [aux_sym_lambda_expression_repeat1] = STATE(4171),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1561),
    [anon_sym_ref] = ACTIONS(1563),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1145),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(1567),
    [anon_sym_PLUS_PLUS] = ACTIONS(1567),
    [anon_sym_DASH_DASH] = ACTIONS(1567),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1565),
    [anon_sym_DASH] = ACTIONS(1565),
    [anon_sym_STAR] = ACTIONS(1569),
    [anon_sym_CARET] = ACTIONS(1567),
    [anon_sym_AMP] = ACTIONS(1567),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1571),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1573),
    [anon_sym_DOT_DOT] = ACTIONS(1575),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1399] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6913),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7000),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5529),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4181),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7384),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9143),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1399),
    [sym_preproc_endregion] = STATE(1399),
    [sym_preproc_line] = STATE(1399),
    [sym_preproc_pragma] = STATE(1399),
    [sym_preproc_nullable] = STATE(1399),
    [sym_preproc_error] = STATE(1399),
    [sym_preproc_define] = STATE(1399),
    [sym_preproc_undef] = STATE(1399),
    [aux_sym_class_declaration_repeat1] = STATE(3814),
    [aux_sym_lambda_expression_repeat1] = STATE(4171),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1561),
    [anon_sym_ref] = ACTIONS(1563),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1145),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(1567),
    [anon_sym_PLUS_PLUS] = ACTIONS(1567),
    [anon_sym_DASH_DASH] = ACTIONS(1567),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1565),
    [anon_sym_DASH] = ACTIONS(1565),
    [anon_sym_STAR] = ACTIONS(1569),
    [anon_sym_CARET] = ACTIONS(1567),
    [anon_sym_AMP] = ACTIONS(1567),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1571),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1573),
    [anon_sym_DOT_DOT] = ACTIONS(1575),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1400] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6913),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7000),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5528),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4181),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7384),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9143),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1400),
    [sym_preproc_endregion] = STATE(1400),
    [sym_preproc_line] = STATE(1400),
    [sym_preproc_pragma] = STATE(1400),
    [sym_preproc_nullable] = STATE(1400),
    [sym_preproc_error] = STATE(1400),
    [sym_preproc_define] = STATE(1400),
    [sym_preproc_undef] = STATE(1400),
    [aux_sym_class_declaration_repeat1] = STATE(3814),
    [aux_sym_lambda_expression_repeat1] = STATE(4171),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1561),
    [anon_sym_ref] = ACTIONS(1563),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1145),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(1567),
    [anon_sym_PLUS_PLUS] = ACTIONS(1567),
    [anon_sym_DASH_DASH] = ACTIONS(1567),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1565),
    [anon_sym_DASH] = ACTIONS(1565),
    [anon_sym_STAR] = ACTIONS(1569),
    [anon_sym_CARET] = ACTIONS(1567),
    [anon_sym_AMP] = ACTIONS(1567),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1571),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1573),
    [anon_sym_DOT_DOT] = ACTIONS(1575),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1401] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6913),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7000),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5527),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4181),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7384),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9143),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1401),
    [sym_preproc_endregion] = STATE(1401),
    [sym_preproc_line] = STATE(1401),
    [sym_preproc_pragma] = STATE(1401),
    [sym_preproc_nullable] = STATE(1401),
    [sym_preproc_error] = STATE(1401),
    [sym_preproc_define] = STATE(1401),
    [sym_preproc_undef] = STATE(1401),
    [aux_sym_class_declaration_repeat1] = STATE(3814),
    [aux_sym_lambda_expression_repeat1] = STATE(4171),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1561),
    [anon_sym_ref] = ACTIONS(1563),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1145),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(1567),
    [anon_sym_PLUS_PLUS] = ACTIONS(1567),
    [anon_sym_DASH_DASH] = ACTIONS(1567),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1565),
    [anon_sym_DASH] = ACTIONS(1565),
    [anon_sym_STAR] = ACTIONS(1569),
    [anon_sym_CARET] = ACTIONS(1567),
    [anon_sym_AMP] = ACTIONS(1567),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1571),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1573),
    [anon_sym_DOT_DOT] = ACTIONS(1575),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1402] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6913),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7000),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5708),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4181),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7384),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9143),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1402),
    [sym_preproc_endregion] = STATE(1402),
    [sym_preproc_line] = STATE(1402),
    [sym_preproc_pragma] = STATE(1402),
    [sym_preproc_nullable] = STATE(1402),
    [sym_preproc_error] = STATE(1402),
    [sym_preproc_define] = STATE(1402),
    [sym_preproc_undef] = STATE(1402),
    [aux_sym_class_declaration_repeat1] = STATE(3814),
    [aux_sym_lambda_expression_repeat1] = STATE(4171),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1561),
    [anon_sym_ref] = ACTIONS(1563),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1145),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(1567),
    [anon_sym_PLUS_PLUS] = ACTIONS(1567),
    [anon_sym_DASH_DASH] = ACTIONS(1567),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1565),
    [anon_sym_DASH] = ACTIONS(1565),
    [anon_sym_STAR] = ACTIONS(1569),
    [anon_sym_CARET] = ACTIONS(1567),
    [anon_sym_AMP] = ACTIONS(1567),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1571),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1573),
    [anon_sym_DOT_DOT] = ACTIONS(1575),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1403] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6913),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7000),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5526),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4181),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7384),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9143),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1403),
    [sym_preproc_endregion] = STATE(1403),
    [sym_preproc_line] = STATE(1403),
    [sym_preproc_pragma] = STATE(1403),
    [sym_preproc_nullable] = STATE(1403),
    [sym_preproc_error] = STATE(1403),
    [sym_preproc_define] = STATE(1403),
    [sym_preproc_undef] = STATE(1403),
    [aux_sym_class_declaration_repeat1] = STATE(3814),
    [aux_sym_lambda_expression_repeat1] = STATE(4171),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1561),
    [anon_sym_ref] = ACTIONS(1563),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1145),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(1567),
    [anon_sym_PLUS_PLUS] = ACTIONS(1567),
    [anon_sym_DASH_DASH] = ACTIONS(1567),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1565),
    [anon_sym_DASH] = ACTIONS(1565),
    [anon_sym_STAR] = ACTIONS(1569),
    [anon_sym_CARET] = ACTIONS(1567),
    [anon_sym_AMP] = ACTIONS(1567),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1571),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1573),
    [anon_sym_DOT_DOT] = ACTIONS(1575),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1404] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6913),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7000),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5524),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4181),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7384),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9143),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1404),
    [sym_preproc_endregion] = STATE(1404),
    [sym_preproc_line] = STATE(1404),
    [sym_preproc_pragma] = STATE(1404),
    [sym_preproc_nullable] = STATE(1404),
    [sym_preproc_error] = STATE(1404),
    [sym_preproc_define] = STATE(1404),
    [sym_preproc_undef] = STATE(1404),
    [aux_sym_class_declaration_repeat1] = STATE(3814),
    [aux_sym_lambda_expression_repeat1] = STATE(4171),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1561),
    [anon_sym_ref] = ACTIONS(1563),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1145),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(1567),
    [anon_sym_PLUS_PLUS] = ACTIONS(1567),
    [anon_sym_DASH_DASH] = ACTIONS(1567),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1565),
    [anon_sym_DASH] = ACTIONS(1565),
    [anon_sym_STAR] = ACTIONS(1569),
    [anon_sym_CARET] = ACTIONS(1567),
    [anon_sym_AMP] = ACTIONS(1567),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1571),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1573),
    [anon_sym_DOT_DOT] = ACTIONS(1575),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1405] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6913),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7000),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5523),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4181),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7384),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9143),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1405),
    [sym_preproc_endregion] = STATE(1405),
    [sym_preproc_line] = STATE(1405),
    [sym_preproc_pragma] = STATE(1405),
    [sym_preproc_nullable] = STATE(1405),
    [sym_preproc_error] = STATE(1405),
    [sym_preproc_define] = STATE(1405),
    [sym_preproc_undef] = STATE(1405),
    [aux_sym_class_declaration_repeat1] = STATE(3814),
    [aux_sym_lambda_expression_repeat1] = STATE(4171),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1561),
    [anon_sym_ref] = ACTIONS(1563),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1145),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(1567),
    [anon_sym_PLUS_PLUS] = ACTIONS(1567),
    [anon_sym_DASH_DASH] = ACTIONS(1567),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1565),
    [anon_sym_DASH] = ACTIONS(1565),
    [anon_sym_STAR] = ACTIONS(1569),
    [anon_sym_CARET] = ACTIONS(1567),
    [anon_sym_AMP] = ACTIONS(1567),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1571),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1573),
    [anon_sym_DOT_DOT] = ACTIONS(1575),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1406] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6913),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7000),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5522),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4181),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7384),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9143),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1406),
    [sym_preproc_endregion] = STATE(1406),
    [sym_preproc_line] = STATE(1406),
    [sym_preproc_pragma] = STATE(1406),
    [sym_preproc_nullable] = STATE(1406),
    [sym_preproc_error] = STATE(1406),
    [sym_preproc_define] = STATE(1406),
    [sym_preproc_undef] = STATE(1406),
    [aux_sym_class_declaration_repeat1] = STATE(3814),
    [aux_sym_lambda_expression_repeat1] = STATE(4171),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1561),
    [anon_sym_ref] = ACTIONS(1563),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1145),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(1567),
    [anon_sym_PLUS_PLUS] = ACTIONS(1567),
    [anon_sym_DASH_DASH] = ACTIONS(1567),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1565),
    [anon_sym_DASH] = ACTIONS(1565),
    [anon_sym_STAR] = ACTIONS(1569),
    [anon_sym_CARET] = ACTIONS(1567),
    [anon_sym_AMP] = ACTIONS(1567),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1571),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1573),
    [anon_sym_DOT_DOT] = ACTIONS(1575),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1407] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6913),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7000),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5521),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4181),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7384),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9143),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1407),
    [sym_preproc_endregion] = STATE(1407),
    [sym_preproc_line] = STATE(1407),
    [sym_preproc_pragma] = STATE(1407),
    [sym_preproc_nullable] = STATE(1407),
    [sym_preproc_error] = STATE(1407),
    [sym_preproc_define] = STATE(1407),
    [sym_preproc_undef] = STATE(1407),
    [aux_sym_class_declaration_repeat1] = STATE(3814),
    [aux_sym_lambda_expression_repeat1] = STATE(4171),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1561),
    [anon_sym_ref] = ACTIONS(1563),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1145),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(1567),
    [anon_sym_PLUS_PLUS] = ACTIONS(1567),
    [anon_sym_DASH_DASH] = ACTIONS(1567),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1565),
    [anon_sym_DASH] = ACTIONS(1565),
    [anon_sym_STAR] = ACTIONS(1569),
    [anon_sym_CARET] = ACTIONS(1567),
    [anon_sym_AMP] = ACTIONS(1567),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1571),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1573),
    [anon_sym_DOT_DOT] = ACTIONS(1575),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1408] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6913),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7000),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(3826),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4181),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7384),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9143),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1408),
    [sym_preproc_endregion] = STATE(1408),
    [sym_preproc_line] = STATE(1408),
    [sym_preproc_pragma] = STATE(1408),
    [sym_preproc_nullable] = STATE(1408),
    [sym_preproc_error] = STATE(1408),
    [sym_preproc_define] = STATE(1408),
    [sym_preproc_undef] = STATE(1408),
    [aux_sym_class_declaration_repeat1] = STATE(3814),
    [aux_sym_lambda_expression_repeat1] = STATE(4171),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1561),
    [anon_sym_ref] = ACTIONS(1563),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1145),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(1567),
    [anon_sym_PLUS_PLUS] = ACTIONS(1567),
    [anon_sym_DASH_DASH] = ACTIONS(1567),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1565),
    [anon_sym_DASH] = ACTIONS(1565),
    [anon_sym_STAR] = ACTIONS(1569),
    [anon_sym_CARET] = ACTIONS(1567),
    [anon_sym_AMP] = ACTIONS(1567),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1571),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1573),
    [anon_sym_DOT_DOT] = ACTIONS(1575),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1409] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6913),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7000),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5517),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4181),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7384),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9143),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1409),
    [sym_preproc_endregion] = STATE(1409),
    [sym_preproc_line] = STATE(1409),
    [sym_preproc_pragma] = STATE(1409),
    [sym_preproc_nullable] = STATE(1409),
    [sym_preproc_error] = STATE(1409),
    [sym_preproc_define] = STATE(1409),
    [sym_preproc_undef] = STATE(1409),
    [aux_sym_class_declaration_repeat1] = STATE(3814),
    [aux_sym_lambda_expression_repeat1] = STATE(4171),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1561),
    [anon_sym_ref] = ACTIONS(1563),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1145),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(1567),
    [anon_sym_PLUS_PLUS] = ACTIONS(1567),
    [anon_sym_DASH_DASH] = ACTIONS(1567),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1565),
    [anon_sym_DASH] = ACTIONS(1565),
    [anon_sym_STAR] = ACTIONS(1569),
    [anon_sym_CARET] = ACTIONS(1567),
    [anon_sym_AMP] = ACTIONS(1567),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1571),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1573),
    [anon_sym_DOT_DOT] = ACTIONS(1575),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1410] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6879),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2935),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7096),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5495),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4288),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7379),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9175),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1410),
    [sym_preproc_endregion] = STATE(1410),
    [sym_preproc_line] = STATE(1410),
    [sym_preproc_pragma] = STATE(1410),
    [sym_preproc_nullable] = STATE(1410),
    [sym_preproc_error] = STATE(1410),
    [sym_preproc_define] = STATE(1410),
    [sym_preproc_undef] = STATE(1410),
    [aux_sym_class_declaration_repeat1] = STATE(3816),
    [aux_sym_lambda_expression_repeat1] = STATE(4119),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1867),
    [anon_sym_ref] = ACTIONS(1869),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1871),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1875),
    [anon_sym_TILDE] = ACTIONS(1875),
    [anon_sym_PLUS_PLUS] = ACTIONS(1875),
    [anon_sym_DASH_DASH] = ACTIONS(1875),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1873),
    [anon_sym_DASH] = ACTIONS(1873),
    [anon_sym_STAR] = ACTIONS(1877),
    [anon_sym_CARET] = ACTIONS(1875),
    [anon_sym_AMP] = ACTIONS(1875),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1879),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1881),
    [anon_sym_DOT_DOT] = ACTIONS(1883),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1411] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6967),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(3902),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(3858),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7382),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9625),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1411),
    [sym_preproc_endregion] = STATE(1411),
    [sym_preproc_line] = STATE(1411),
    [sym_preproc_pragma] = STATE(1411),
    [sym_preproc_nullable] = STATE(1411),
    [sym_preproc_error] = STATE(1411),
    [sym_preproc_define] = STATE(1411),
    [sym_preproc_undef] = STATE(1411),
    [aux_sym_class_declaration_repeat1] = STATE(3851),
    [aux_sym_lambda_expression_repeat1] = STATE(4234),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_ref] = ACTIONS(1293),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1059),
    [anon_sym_TILDE] = ACTIONS(1059),
    [anon_sym_PLUS_PLUS] = ACTIONS(1059),
    [anon_sym_DASH_DASH] = ACTIONS(1059),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1061),
    [anon_sym_DASH] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(1303),
    [anon_sym_CARET] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1307),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1309),
    [anon_sym_DOT_DOT] = ACTIONS(1311),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1412] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6898),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2940),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6925),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6634),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4498),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7403),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(8973),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1412),
    [sym_preproc_endregion] = STATE(1412),
    [sym_preproc_line] = STATE(1412),
    [sym_preproc_pragma] = STATE(1412),
    [sym_preproc_nullable] = STATE(1412),
    [sym_preproc_error] = STATE(1412),
    [sym_preproc_define] = STATE(1412),
    [sym_preproc_undef] = STATE(1412),
    [aux_sym_class_declaration_repeat1] = STATE(3830),
    [aux_sym_lambda_expression_repeat1] = STATE(4194),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2153),
    [anon_sym_ref] = ACTIONS(2155),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2157),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2161),
    [anon_sym_TILDE] = ACTIONS(2161),
    [anon_sym_PLUS_PLUS] = ACTIONS(2161),
    [anon_sym_DASH_DASH] = ACTIONS(2161),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2159),
    [anon_sym_DASH] = ACTIONS(2159),
    [anon_sym_STAR] = ACTIONS(2163),
    [anon_sym_CARET] = ACTIONS(2161),
    [anon_sym_AMP] = ACTIONS(2161),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2165),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2167),
    [anon_sym_DOT_DOT] = ACTIONS(2169),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1413] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6898),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2940),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6925),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6370),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4498),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7403),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(8973),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1413),
    [sym_preproc_endregion] = STATE(1413),
    [sym_preproc_line] = STATE(1413),
    [sym_preproc_pragma] = STATE(1413),
    [sym_preproc_nullable] = STATE(1413),
    [sym_preproc_error] = STATE(1413),
    [sym_preproc_define] = STATE(1413),
    [sym_preproc_undef] = STATE(1413),
    [aux_sym_class_declaration_repeat1] = STATE(3830),
    [aux_sym_lambda_expression_repeat1] = STATE(4194),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2153),
    [anon_sym_ref] = ACTIONS(2155),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2157),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2161),
    [anon_sym_TILDE] = ACTIONS(2161),
    [anon_sym_PLUS_PLUS] = ACTIONS(2161),
    [anon_sym_DASH_DASH] = ACTIONS(2161),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2159),
    [anon_sym_DASH] = ACTIONS(2159),
    [anon_sym_STAR] = ACTIONS(2163),
    [anon_sym_CARET] = ACTIONS(2161),
    [anon_sym_AMP] = ACTIONS(2161),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2165),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2167),
    [anon_sym_DOT_DOT] = ACTIONS(2169),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1414] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6286),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1414),
    [sym_preproc_endregion] = STATE(1414),
    [sym_preproc_line] = STATE(1414),
    [sym_preproc_pragma] = STATE(1414),
    [sym_preproc_nullable] = STATE(1414),
    [sym_preproc_error] = STATE(1414),
    [sym_preproc_define] = STATE(1414),
    [sym_preproc_undef] = STATE(1414),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1415] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7094),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6687),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(3455),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1415),
    [sym_preproc_endregion] = STATE(1415),
    [sym_preproc_line] = STATE(1415),
    [sym_preproc_pragma] = STATE(1415),
    [sym_preproc_nullable] = STATE(1415),
    [sym_preproc_error] = STATE(1415),
    [sym_preproc_define] = STATE(1415),
    [sym_preproc_undef] = STATE(1415),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(2909),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1669),
    [anon_sym_TILDE] = ACTIONS(1669),
    [anon_sym_PLUS_PLUS] = ACTIONS(1669),
    [anon_sym_DASH_DASH] = ACTIONS(1669),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1667),
    [anon_sym_DASH] = ACTIONS(1667),
    [anon_sym_STAR] = ACTIONS(1303),
    [anon_sym_CARET] = ACTIONS(1669),
    [anon_sym_AMP] = ACTIONS(1669),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1416] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6881),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2964),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6972),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6561),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4495),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7398),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9102),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1416),
    [sym_preproc_endregion] = STATE(1416),
    [sym_preproc_line] = STATE(1416),
    [sym_preproc_pragma] = STATE(1416),
    [sym_preproc_nullable] = STATE(1416),
    [sym_preproc_error] = STATE(1416),
    [sym_preproc_define] = STATE(1416),
    [sym_preproc_undef] = STATE(1416),
    [aux_sym_class_declaration_repeat1] = STATE(3857),
    [aux_sym_lambda_expression_repeat1] = STATE(4241),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2097),
    [anon_sym_ref] = ACTIONS(2099),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2101),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2105),
    [anon_sym_TILDE] = ACTIONS(2105),
    [anon_sym_PLUS_PLUS] = ACTIONS(2105),
    [anon_sym_DASH_DASH] = ACTIONS(2105),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2103),
    [anon_sym_DASH] = ACTIONS(2103),
    [anon_sym_STAR] = ACTIONS(2107),
    [anon_sym_CARET] = ACTIONS(2105),
    [anon_sym_AMP] = ACTIONS(2105),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2111),
    [anon_sym_DOT_DOT] = ACTIONS(2113),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1417] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6881),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2964),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6972),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4325),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4495),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7398),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9102),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1417),
    [sym_preproc_endregion] = STATE(1417),
    [sym_preproc_line] = STATE(1417),
    [sym_preproc_pragma] = STATE(1417),
    [sym_preproc_nullable] = STATE(1417),
    [sym_preproc_error] = STATE(1417),
    [sym_preproc_define] = STATE(1417),
    [sym_preproc_undef] = STATE(1417),
    [aux_sym_class_declaration_repeat1] = STATE(3857),
    [aux_sym_lambda_expression_repeat1] = STATE(4241),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2097),
    [anon_sym_ref] = ACTIONS(2099),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2101),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2105),
    [anon_sym_TILDE] = ACTIONS(2105),
    [anon_sym_PLUS_PLUS] = ACTIONS(2105),
    [anon_sym_DASH_DASH] = ACTIONS(2105),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2103),
    [anon_sym_DASH] = ACTIONS(2103),
    [anon_sym_STAR] = ACTIONS(2107),
    [anon_sym_CARET] = ACTIONS(2105),
    [anon_sym_AMP] = ACTIONS(2105),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2111),
    [anon_sym_DOT_DOT] = ACTIONS(2113),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1418] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6881),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2964),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6972),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6521),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4495),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7398),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9102),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1418),
    [sym_preproc_endregion] = STATE(1418),
    [sym_preproc_line] = STATE(1418),
    [sym_preproc_pragma] = STATE(1418),
    [sym_preproc_nullable] = STATE(1418),
    [sym_preproc_error] = STATE(1418),
    [sym_preproc_define] = STATE(1418),
    [sym_preproc_undef] = STATE(1418),
    [aux_sym_class_declaration_repeat1] = STATE(3857),
    [aux_sym_lambda_expression_repeat1] = STATE(4241),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2097),
    [anon_sym_ref] = ACTIONS(2099),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2101),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2105),
    [anon_sym_TILDE] = ACTIONS(2105),
    [anon_sym_PLUS_PLUS] = ACTIONS(2105),
    [anon_sym_DASH_DASH] = ACTIONS(2105),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2103),
    [anon_sym_DASH] = ACTIONS(2103),
    [anon_sym_STAR] = ACTIONS(2107),
    [anon_sym_CARET] = ACTIONS(2105),
    [anon_sym_AMP] = ACTIONS(2105),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2111),
    [anon_sym_DOT_DOT] = ACTIONS(2113),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1419] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6888),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2882),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7048),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(3826),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4019),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7409),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9210),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1419),
    [sym_preproc_endregion] = STATE(1419),
    [sym_preproc_line] = STATE(1419),
    [sym_preproc_pragma] = STATE(1419),
    [sym_preproc_nullable] = STATE(1419),
    [sym_preproc_error] = STATE(1419),
    [sym_preproc_define] = STATE(1419),
    [sym_preproc_undef] = STATE(1419),
    [aux_sym_class_declaration_repeat1] = STATE(3812),
    [aux_sym_lambda_expression_repeat1] = STATE(4146),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1709),
    [anon_sym_ref] = ACTIONS(1711),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1713),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1717),
    [anon_sym_TILDE] = ACTIONS(1717),
    [anon_sym_PLUS_PLUS] = ACTIONS(1717),
    [anon_sym_DASH_DASH] = ACTIONS(1717),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1715),
    [anon_sym_DASH] = ACTIONS(1715),
    [anon_sym_STAR] = ACTIONS(1719),
    [anon_sym_CARET] = ACTIONS(1717),
    [anon_sym_AMP] = ACTIONS(1717),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1721),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1723),
    [anon_sym_DOT_DOT] = ACTIONS(1725),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1420] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6881),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2964),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7109),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5868),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4326),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7394),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9186),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1420),
    [sym_preproc_endregion] = STATE(1420),
    [sym_preproc_line] = STATE(1420),
    [sym_preproc_pragma] = STATE(1420),
    [sym_preproc_nullable] = STATE(1420),
    [sym_preproc_error] = STATE(1420),
    [sym_preproc_define] = STATE(1420),
    [sym_preproc_undef] = STATE(1420),
    [aux_sym_class_declaration_repeat1] = STATE(3828),
    [aux_sym_lambda_expression_repeat1] = STATE(4180),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1813),
    [anon_sym_ref] = ACTIONS(1815),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1817),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1821),
    [anon_sym_TILDE] = ACTIONS(1821),
    [anon_sym_PLUS_PLUS] = ACTIONS(1821),
    [anon_sym_DASH_DASH] = ACTIONS(1821),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1819),
    [anon_sym_DASH] = ACTIONS(1819),
    [anon_sym_STAR] = ACTIONS(1823),
    [anon_sym_CARET] = ACTIONS(1821),
    [anon_sym_AMP] = ACTIONS(1821),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1825),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1827),
    [anon_sym_DOT_DOT] = ACTIONS(1829),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1421] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6881),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2964),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6972),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6524),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4495),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7398),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9102),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1421),
    [sym_preproc_endregion] = STATE(1421),
    [sym_preproc_line] = STATE(1421),
    [sym_preproc_pragma] = STATE(1421),
    [sym_preproc_nullable] = STATE(1421),
    [sym_preproc_error] = STATE(1421),
    [sym_preproc_define] = STATE(1421),
    [sym_preproc_undef] = STATE(1421),
    [aux_sym_class_declaration_repeat1] = STATE(3857),
    [aux_sym_lambda_expression_repeat1] = STATE(4241),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2097),
    [anon_sym_ref] = ACTIONS(2099),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2101),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2105),
    [anon_sym_TILDE] = ACTIONS(2105),
    [anon_sym_PLUS_PLUS] = ACTIONS(2105),
    [anon_sym_DASH_DASH] = ACTIONS(2105),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2103),
    [anon_sym_DASH] = ACTIONS(2103),
    [anon_sym_STAR] = ACTIONS(2107),
    [anon_sym_CARET] = ACTIONS(2105),
    [anon_sym_AMP] = ACTIONS(2105),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2111),
    [anon_sym_DOT_DOT] = ACTIONS(2113),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1422] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6879),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2935),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7096),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5480),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4288),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7379),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9175),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1422),
    [sym_preproc_endregion] = STATE(1422),
    [sym_preproc_line] = STATE(1422),
    [sym_preproc_pragma] = STATE(1422),
    [sym_preproc_nullable] = STATE(1422),
    [sym_preproc_error] = STATE(1422),
    [sym_preproc_define] = STATE(1422),
    [sym_preproc_undef] = STATE(1422),
    [aux_sym_class_declaration_repeat1] = STATE(3816),
    [aux_sym_lambda_expression_repeat1] = STATE(4119),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1867),
    [anon_sym_ref] = ACTIONS(1869),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1871),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1875),
    [anon_sym_TILDE] = ACTIONS(1875),
    [anon_sym_PLUS_PLUS] = ACTIONS(1875),
    [anon_sym_DASH_DASH] = ACTIONS(1875),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1873),
    [anon_sym_DASH] = ACTIONS(1873),
    [anon_sym_STAR] = ACTIONS(1877),
    [anon_sym_CARET] = ACTIONS(1875),
    [anon_sym_AMP] = ACTIONS(1875),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1879),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1881),
    [anon_sym_DOT_DOT] = ACTIONS(1883),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1423] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6894),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2955),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7025),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(3557),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(3735),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7397),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9590),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1423),
    [sym_preproc_endregion] = STATE(1423),
    [sym_preproc_line] = STATE(1423),
    [sym_preproc_pragma] = STATE(1423),
    [sym_preproc_nullable] = STATE(1423),
    [sym_preproc_error] = STATE(1423),
    [sym_preproc_define] = STATE(1423),
    [sym_preproc_undef] = STATE(1423),
    [aux_sym_class_declaration_repeat1] = STATE(3844),
    [aux_sym_lambda_expression_repeat1] = STATE(4245),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1849),
    [anon_sym_ref] = ACTIONS(1851),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1853),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1857),
    [anon_sym_TILDE] = ACTIONS(1857),
    [anon_sym_PLUS_PLUS] = ACTIONS(1857),
    [anon_sym_DASH_DASH] = ACTIONS(1857),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1855),
    [anon_sym_DASH] = ACTIONS(1855),
    [anon_sym_STAR] = ACTIONS(1859),
    [anon_sym_CARET] = ACTIONS(1857),
    [anon_sym_AMP] = ACTIONS(1857),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1861),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1863),
    [anon_sym_DOT_DOT] = ACTIONS(1865),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1424] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6894),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2955),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7025),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(3565),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(3735),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7397),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9590),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1424),
    [sym_preproc_endregion] = STATE(1424),
    [sym_preproc_line] = STATE(1424),
    [sym_preproc_pragma] = STATE(1424),
    [sym_preproc_nullable] = STATE(1424),
    [sym_preproc_error] = STATE(1424),
    [sym_preproc_define] = STATE(1424),
    [sym_preproc_undef] = STATE(1424),
    [aux_sym_class_declaration_repeat1] = STATE(3844),
    [aux_sym_lambda_expression_repeat1] = STATE(4245),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1849),
    [anon_sym_ref] = ACTIONS(1851),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1853),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1857),
    [anon_sym_TILDE] = ACTIONS(1857),
    [anon_sym_PLUS_PLUS] = ACTIONS(1857),
    [anon_sym_DASH_DASH] = ACTIONS(1857),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1855),
    [anon_sym_DASH] = ACTIONS(1855),
    [anon_sym_STAR] = ACTIONS(1859),
    [anon_sym_CARET] = ACTIONS(1857),
    [anon_sym_AMP] = ACTIONS(1857),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1861),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1863),
    [anon_sym_DOT_DOT] = ACTIONS(1865),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1425] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6888),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2882),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7048),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5378),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4019),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7409),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9210),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1425),
    [sym_preproc_endregion] = STATE(1425),
    [sym_preproc_line] = STATE(1425),
    [sym_preproc_pragma] = STATE(1425),
    [sym_preproc_nullable] = STATE(1425),
    [sym_preproc_error] = STATE(1425),
    [sym_preproc_define] = STATE(1425),
    [sym_preproc_undef] = STATE(1425),
    [aux_sym_class_declaration_repeat1] = STATE(3812),
    [aux_sym_lambda_expression_repeat1] = STATE(4146),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1709),
    [anon_sym_ref] = ACTIONS(1711),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1713),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1717),
    [anon_sym_TILDE] = ACTIONS(1717),
    [anon_sym_PLUS_PLUS] = ACTIONS(1717),
    [anon_sym_DASH_DASH] = ACTIONS(1717),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1715),
    [anon_sym_DASH] = ACTIONS(1715),
    [anon_sym_STAR] = ACTIONS(1719),
    [anon_sym_CARET] = ACTIONS(1717),
    [anon_sym_AMP] = ACTIONS(1717),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1721),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1723),
    [anon_sym_DOT_DOT] = ACTIONS(1725),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1426] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6888),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2882),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7048),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5377),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4019),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7409),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9210),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1426),
    [sym_preproc_endregion] = STATE(1426),
    [sym_preproc_line] = STATE(1426),
    [sym_preproc_pragma] = STATE(1426),
    [sym_preproc_nullable] = STATE(1426),
    [sym_preproc_error] = STATE(1426),
    [sym_preproc_define] = STATE(1426),
    [sym_preproc_undef] = STATE(1426),
    [aux_sym_class_declaration_repeat1] = STATE(3812),
    [aux_sym_lambda_expression_repeat1] = STATE(4146),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1709),
    [anon_sym_ref] = ACTIONS(1711),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1713),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1717),
    [anon_sym_TILDE] = ACTIONS(1717),
    [anon_sym_PLUS_PLUS] = ACTIONS(1717),
    [anon_sym_DASH_DASH] = ACTIONS(1717),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1715),
    [anon_sym_DASH] = ACTIONS(1715),
    [anon_sym_STAR] = ACTIONS(1719),
    [anon_sym_CARET] = ACTIONS(1717),
    [anon_sym_AMP] = ACTIONS(1717),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1721),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1723),
    [anon_sym_DOT_DOT] = ACTIONS(1725),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1427] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6250),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1427),
    [sym_preproc_endregion] = STATE(1427),
    [sym_preproc_line] = STATE(1427),
    [sym_preproc_pragma] = STATE(1427),
    [sym_preproc_nullable] = STATE(1427),
    [sym_preproc_error] = STATE(1427),
    [sym_preproc_define] = STATE(1427),
    [sym_preproc_undef] = STATE(1427),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1428] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6888),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2882),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7048),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5374),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4019),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7409),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9210),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1428),
    [sym_preproc_endregion] = STATE(1428),
    [sym_preproc_line] = STATE(1428),
    [sym_preproc_pragma] = STATE(1428),
    [sym_preproc_nullable] = STATE(1428),
    [sym_preproc_error] = STATE(1428),
    [sym_preproc_define] = STATE(1428),
    [sym_preproc_undef] = STATE(1428),
    [aux_sym_class_declaration_repeat1] = STATE(3812),
    [aux_sym_lambda_expression_repeat1] = STATE(4146),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1709),
    [anon_sym_ref] = ACTIONS(1711),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1713),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1717),
    [anon_sym_TILDE] = ACTIONS(1717),
    [anon_sym_PLUS_PLUS] = ACTIONS(1717),
    [anon_sym_DASH_DASH] = ACTIONS(1717),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1715),
    [anon_sym_DASH] = ACTIONS(1715),
    [anon_sym_STAR] = ACTIONS(1719),
    [anon_sym_CARET] = ACTIONS(1717),
    [anon_sym_AMP] = ACTIONS(1717),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1721),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1723),
    [anon_sym_DOT_DOT] = ACTIONS(1725),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1429] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6881),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2964),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6972),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6525),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4495),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7398),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9102),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1429),
    [sym_preproc_endregion] = STATE(1429),
    [sym_preproc_line] = STATE(1429),
    [sym_preproc_pragma] = STATE(1429),
    [sym_preproc_nullable] = STATE(1429),
    [sym_preproc_error] = STATE(1429),
    [sym_preproc_define] = STATE(1429),
    [sym_preproc_undef] = STATE(1429),
    [aux_sym_class_declaration_repeat1] = STATE(3857),
    [aux_sym_lambda_expression_repeat1] = STATE(4241),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2097),
    [anon_sym_ref] = ACTIONS(2099),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2101),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2105),
    [anon_sym_TILDE] = ACTIONS(2105),
    [anon_sym_PLUS_PLUS] = ACTIONS(2105),
    [anon_sym_DASH_DASH] = ACTIONS(2105),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2103),
    [anon_sym_DASH] = ACTIONS(2103),
    [anon_sym_STAR] = ACTIONS(2107),
    [anon_sym_CARET] = ACTIONS(2105),
    [anon_sym_AMP] = ACTIONS(2105),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2111),
    [anon_sym_DOT_DOT] = ACTIONS(2113),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1430] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6881),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2964),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6972),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6527),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4495),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7398),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9102),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1430),
    [sym_preproc_endregion] = STATE(1430),
    [sym_preproc_line] = STATE(1430),
    [sym_preproc_pragma] = STATE(1430),
    [sym_preproc_nullable] = STATE(1430),
    [sym_preproc_error] = STATE(1430),
    [sym_preproc_define] = STATE(1430),
    [sym_preproc_undef] = STATE(1430),
    [aux_sym_class_declaration_repeat1] = STATE(3857),
    [aux_sym_lambda_expression_repeat1] = STATE(4241),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2097),
    [anon_sym_ref] = ACTIONS(2099),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2101),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2105),
    [anon_sym_TILDE] = ACTIONS(2105),
    [anon_sym_PLUS_PLUS] = ACTIONS(2105),
    [anon_sym_DASH_DASH] = ACTIONS(2105),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2103),
    [anon_sym_DASH] = ACTIONS(2103),
    [anon_sym_STAR] = ACTIONS(2107),
    [anon_sym_CARET] = ACTIONS(2105),
    [anon_sym_AMP] = ACTIONS(2105),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2111),
    [anon_sym_DOT_DOT] = ACTIONS(2113),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1431] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6888),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2882),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7048),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5370),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4019),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7409),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9210),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1431),
    [sym_preproc_endregion] = STATE(1431),
    [sym_preproc_line] = STATE(1431),
    [sym_preproc_pragma] = STATE(1431),
    [sym_preproc_nullable] = STATE(1431),
    [sym_preproc_error] = STATE(1431),
    [sym_preproc_define] = STATE(1431),
    [sym_preproc_undef] = STATE(1431),
    [aux_sym_class_declaration_repeat1] = STATE(3812),
    [aux_sym_lambda_expression_repeat1] = STATE(4146),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1709),
    [anon_sym_ref] = ACTIONS(1711),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1713),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1717),
    [anon_sym_TILDE] = ACTIONS(1717),
    [anon_sym_PLUS_PLUS] = ACTIONS(1717),
    [anon_sym_DASH_DASH] = ACTIONS(1717),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1715),
    [anon_sym_DASH] = ACTIONS(1715),
    [anon_sym_STAR] = ACTIONS(1719),
    [anon_sym_CARET] = ACTIONS(1717),
    [anon_sym_AMP] = ACTIONS(1717),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1721),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1723),
    [anon_sym_DOT_DOT] = ACTIONS(1725),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1432] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6888),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2882),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7048),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5232),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4019),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7409),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9210),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1432),
    [sym_preproc_endregion] = STATE(1432),
    [sym_preproc_line] = STATE(1432),
    [sym_preproc_pragma] = STATE(1432),
    [sym_preproc_nullable] = STATE(1432),
    [sym_preproc_error] = STATE(1432),
    [sym_preproc_define] = STATE(1432),
    [sym_preproc_undef] = STATE(1432),
    [aux_sym_class_declaration_repeat1] = STATE(3812),
    [aux_sym_lambda_expression_repeat1] = STATE(4146),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1709),
    [anon_sym_ref] = ACTIONS(1711),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1713),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1717),
    [anon_sym_TILDE] = ACTIONS(1717),
    [anon_sym_PLUS_PLUS] = ACTIONS(1717),
    [anon_sym_DASH_DASH] = ACTIONS(1717),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1715),
    [anon_sym_DASH] = ACTIONS(1715),
    [anon_sym_STAR] = ACTIONS(1719),
    [anon_sym_CARET] = ACTIONS(1717),
    [anon_sym_AMP] = ACTIONS(1717),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1721),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1723),
    [anon_sym_DOT_DOT] = ACTIONS(1725),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1433] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6918),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7126),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4869),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(3736),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7377),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9441),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1433),
    [sym_preproc_endregion] = STATE(1433),
    [sym_preproc_line] = STATE(1433),
    [sym_preproc_pragma] = STATE(1433),
    [sym_preproc_nullable] = STATE(1433),
    [sym_preproc_error] = STATE(1433),
    [sym_preproc_define] = STATE(1433),
    [sym_preproc_undef] = STATE(1433),
    [aux_sym_class_declaration_repeat1] = STATE(3848),
    [aux_sym_lambda_expression_repeat1] = STATE(4242),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1213),
    [anon_sym_ref] = ACTIONS(1215),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1221),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1227),
    [anon_sym_TILDE] = ACTIONS(1227),
    [anon_sym_PLUS_PLUS] = ACTIONS(1227),
    [anon_sym_DASH_DASH] = ACTIONS(1227),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1225),
    [anon_sym_DASH] = ACTIONS(1225),
    [anon_sym_STAR] = ACTIONS(1231),
    [anon_sym_CARET] = ACTIONS(1227),
    [anon_sym_AMP] = ACTIONS(1227),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1239),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1241),
    [anon_sym_DOT_DOT] = ACTIONS(1243),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1434] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6888),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2882),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7048),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5367),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4019),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7409),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9210),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1434),
    [sym_preproc_endregion] = STATE(1434),
    [sym_preproc_line] = STATE(1434),
    [sym_preproc_pragma] = STATE(1434),
    [sym_preproc_nullable] = STATE(1434),
    [sym_preproc_error] = STATE(1434),
    [sym_preproc_define] = STATE(1434),
    [sym_preproc_undef] = STATE(1434),
    [aux_sym_class_declaration_repeat1] = STATE(3812),
    [aux_sym_lambda_expression_repeat1] = STATE(4146),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1709),
    [anon_sym_ref] = ACTIONS(1711),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1713),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1717),
    [anon_sym_TILDE] = ACTIONS(1717),
    [anon_sym_PLUS_PLUS] = ACTIONS(1717),
    [anon_sym_DASH_DASH] = ACTIONS(1717),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1715),
    [anon_sym_DASH] = ACTIONS(1715),
    [anon_sym_STAR] = ACTIONS(1719),
    [anon_sym_CARET] = ACTIONS(1717),
    [anon_sym_AMP] = ACTIONS(1717),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1721),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1723),
    [anon_sym_DOT_DOT] = ACTIONS(1725),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1435] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6881),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2964),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6972),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6530),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4495),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7398),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9102),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1435),
    [sym_preproc_endregion] = STATE(1435),
    [sym_preproc_line] = STATE(1435),
    [sym_preproc_pragma] = STATE(1435),
    [sym_preproc_nullable] = STATE(1435),
    [sym_preproc_error] = STATE(1435),
    [sym_preproc_define] = STATE(1435),
    [sym_preproc_undef] = STATE(1435),
    [aux_sym_class_declaration_repeat1] = STATE(3857),
    [aux_sym_lambda_expression_repeat1] = STATE(4241),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2097),
    [anon_sym_ref] = ACTIONS(2099),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2101),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2105),
    [anon_sym_TILDE] = ACTIONS(2105),
    [anon_sym_PLUS_PLUS] = ACTIONS(2105),
    [anon_sym_DASH_DASH] = ACTIONS(2105),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2103),
    [anon_sym_DASH] = ACTIONS(2103),
    [anon_sym_STAR] = ACTIONS(2107),
    [anon_sym_CARET] = ACTIONS(2105),
    [anon_sym_AMP] = ACTIONS(2105),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2111),
    [anon_sym_DOT_DOT] = ACTIONS(2113),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1436] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6888),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2882),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7048),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5366),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4019),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7409),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9210),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1436),
    [sym_preproc_endregion] = STATE(1436),
    [sym_preproc_line] = STATE(1436),
    [sym_preproc_pragma] = STATE(1436),
    [sym_preproc_nullable] = STATE(1436),
    [sym_preproc_error] = STATE(1436),
    [sym_preproc_define] = STATE(1436),
    [sym_preproc_undef] = STATE(1436),
    [aux_sym_class_declaration_repeat1] = STATE(3812),
    [aux_sym_lambda_expression_repeat1] = STATE(4146),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1709),
    [anon_sym_ref] = ACTIONS(1711),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1713),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1717),
    [anon_sym_TILDE] = ACTIONS(1717),
    [anon_sym_PLUS_PLUS] = ACTIONS(1717),
    [anon_sym_DASH_DASH] = ACTIONS(1717),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1715),
    [anon_sym_DASH] = ACTIONS(1715),
    [anon_sym_STAR] = ACTIONS(1719),
    [anon_sym_CARET] = ACTIONS(1717),
    [anon_sym_AMP] = ACTIONS(1717),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1721),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1723),
    [anon_sym_DOT_DOT] = ACTIONS(1725),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1437] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6888),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2882),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7048),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5357),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4019),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7409),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9210),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1437),
    [sym_preproc_endregion] = STATE(1437),
    [sym_preproc_line] = STATE(1437),
    [sym_preproc_pragma] = STATE(1437),
    [sym_preproc_nullable] = STATE(1437),
    [sym_preproc_error] = STATE(1437),
    [sym_preproc_define] = STATE(1437),
    [sym_preproc_undef] = STATE(1437),
    [aux_sym_class_declaration_repeat1] = STATE(3812),
    [aux_sym_lambda_expression_repeat1] = STATE(4146),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1709),
    [anon_sym_ref] = ACTIONS(1711),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1713),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1717),
    [anon_sym_TILDE] = ACTIONS(1717),
    [anon_sym_PLUS_PLUS] = ACTIONS(1717),
    [anon_sym_DASH_DASH] = ACTIONS(1717),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1715),
    [anon_sym_DASH] = ACTIONS(1715),
    [anon_sym_STAR] = ACTIONS(1719),
    [anon_sym_CARET] = ACTIONS(1717),
    [anon_sym_AMP] = ACTIONS(1717),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1721),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1723),
    [anon_sym_DOT_DOT] = ACTIONS(1725),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1438] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6894),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2955),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7025),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4795),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(3735),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7397),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9590),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1438),
    [sym_preproc_endregion] = STATE(1438),
    [sym_preproc_line] = STATE(1438),
    [sym_preproc_pragma] = STATE(1438),
    [sym_preproc_nullable] = STATE(1438),
    [sym_preproc_error] = STATE(1438),
    [sym_preproc_define] = STATE(1438),
    [sym_preproc_undef] = STATE(1438),
    [aux_sym_class_declaration_repeat1] = STATE(3844),
    [aux_sym_lambda_expression_repeat1] = STATE(4245),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1849),
    [anon_sym_ref] = ACTIONS(1851),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1853),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1857),
    [anon_sym_TILDE] = ACTIONS(1857),
    [anon_sym_PLUS_PLUS] = ACTIONS(1857),
    [anon_sym_DASH_DASH] = ACTIONS(1857),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1855),
    [anon_sym_DASH] = ACTIONS(1855),
    [anon_sym_STAR] = ACTIONS(1859),
    [anon_sym_CARET] = ACTIONS(1857),
    [anon_sym_AMP] = ACTIONS(1857),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1861),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1863),
    [anon_sym_DOT_DOT] = ACTIONS(1865),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1439] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6888),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2882),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7048),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5241),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4019),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7409),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9210),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1439),
    [sym_preproc_endregion] = STATE(1439),
    [sym_preproc_line] = STATE(1439),
    [sym_preproc_pragma] = STATE(1439),
    [sym_preproc_nullable] = STATE(1439),
    [sym_preproc_error] = STATE(1439),
    [sym_preproc_define] = STATE(1439),
    [sym_preproc_undef] = STATE(1439),
    [aux_sym_class_declaration_repeat1] = STATE(3812),
    [aux_sym_lambda_expression_repeat1] = STATE(4146),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1709),
    [anon_sym_ref] = ACTIONS(1711),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1713),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1717),
    [anon_sym_TILDE] = ACTIONS(1717),
    [anon_sym_PLUS_PLUS] = ACTIONS(1717),
    [anon_sym_DASH_DASH] = ACTIONS(1717),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1715),
    [anon_sym_DASH] = ACTIONS(1715),
    [anon_sym_STAR] = ACTIONS(1719),
    [anon_sym_CARET] = ACTIONS(1717),
    [anon_sym_AMP] = ACTIONS(1717),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1721),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1723),
    [anon_sym_DOT_DOT] = ACTIONS(1725),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1440] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6888),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2882),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7048),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5231),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4019),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7409),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9210),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1440),
    [sym_preproc_endregion] = STATE(1440),
    [sym_preproc_line] = STATE(1440),
    [sym_preproc_pragma] = STATE(1440),
    [sym_preproc_nullable] = STATE(1440),
    [sym_preproc_error] = STATE(1440),
    [sym_preproc_define] = STATE(1440),
    [sym_preproc_undef] = STATE(1440),
    [aux_sym_class_declaration_repeat1] = STATE(3812),
    [aux_sym_lambda_expression_repeat1] = STATE(4146),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1709),
    [anon_sym_ref] = ACTIONS(1711),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1713),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1717),
    [anon_sym_TILDE] = ACTIONS(1717),
    [anon_sym_PLUS_PLUS] = ACTIONS(1717),
    [anon_sym_DASH_DASH] = ACTIONS(1717),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1715),
    [anon_sym_DASH] = ACTIONS(1715),
    [anon_sym_STAR] = ACTIONS(1719),
    [anon_sym_CARET] = ACTIONS(1717),
    [anon_sym_AMP] = ACTIONS(1717),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1721),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1723),
    [anon_sym_DOT_DOT] = ACTIONS(1725),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1441] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6918),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7126),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(3565),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(3736),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7377),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9441),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1441),
    [sym_preproc_endregion] = STATE(1441),
    [sym_preproc_line] = STATE(1441),
    [sym_preproc_pragma] = STATE(1441),
    [sym_preproc_nullable] = STATE(1441),
    [sym_preproc_error] = STATE(1441),
    [sym_preproc_define] = STATE(1441),
    [sym_preproc_undef] = STATE(1441),
    [aux_sym_class_declaration_repeat1] = STATE(3848),
    [aux_sym_lambda_expression_repeat1] = STATE(4242),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1213),
    [anon_sym_ref] = ACTIONS(1215),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1221),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1227),
    [anon_sym_TILDE] = ACTIONS(1227),
    [anon_sym_PLUS_PLUS] = ACTIONS(1227),
    [anon_sym_DASH_DASH] = ACTIONS(1227),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1225),
    [anon_sym_DASH] = ACTIONS(1225),
    [anon_sym_STAR] = ACTIONS(1231),
    [anon_sym_CARET] = ACTIONS(1227),
    [anon_sym_AMP] = ACTIONS(1227),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1239),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1241),
    [anon_sym_DOT_DOT] = ACTIONS(1243),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1442] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6881),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2964),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6972),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6539),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4495),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7398),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9102),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1442),
    [sym_preproc_endregion] = STATE(1442),
    [sym_preproc_line] = STATE(1442),
    [sym_preproc_pragma] = STATE(1442),
    [sym_preproc_nullable] = STATE(1442),
    [sym_preproc_error] = STATE(1442),
    [sym_preproc_define] = STATE(1442),
    [sym_preproc_undef] = STATE(1442),
    [aux_sym_class_declaration_repeat1] = STATE(3857),
    [aux_sym_lambda_expression_repeat1] = STATE(4241),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2097),
    [anon_sym_ref] = ACTIONS(2099),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2101),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2105),
    [anon_sym_TILDE] = ACTIONS(2105),
    [anon_sym_PLUS_PLUS] = ACTIONS(2105),
    [anon_sym_DASH_DASH] = ACTIONS(2105),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2103),
    [anon_sym_DASH] = ACTIONS(2103),
    [anon_sym_STAR] = ACTIONS(2107),
    [anon_sym_CARET] = ACTIONS(2105),
    [anon_sym_AMP] = ACTIONS(2105),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2111),
    [anon_sym_DOT_DOT] = ACTIONS(2113),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1443] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6888),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2882),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7048),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5230),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4019),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7409),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9210),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1443),
    [sym_preproc_endregion] = STATE(1443),
    [sym_preproc_line] = STATE(1443),
    [sym_preproc_pragma] = STATE(1443),
    [sym_preproc_nullable] = STATE(1443),
    [sym_preproc_error] = STATE(1443),
    [sym_preproc_define] = STATE(1443),
    [sym_preproc_undef] = STATE(1443),
    [aux_sym_class_declaration_repeat1] = STATE(3812),
    [aux_sym_lambda_expression_repeat1] = STATE(4146),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1709),
    [anon_sym_ref] = ACTIONS(1711),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1713),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1717),
    [anon_sym_TILDE] = ACTIONS(1717),
    [anon_sym_PLUS_PLUS] = ACTIONS(1717),
    [anon_sym_DASH_DASH] = ACTIONS(1717),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1715),
    [anon_sym_DASH] = ACTIONS(1715),
    [anon_sym_STAR] = ACTIONS(1719),
    [anon_sym_CARET] = ACTIONS(1717),
    [anon_sym_AMP] = ACTIONS(1717),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1721),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1723),
    [anon_sym_DOT_DOT] = ACTIONS(1725),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1444] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6879),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2935),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7096),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(3822),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4288),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7379),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9175),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1444),
    [sym_preproc_endregion] = STATE(1444),
    [sym_preproc_line] = STATE(1444),
    [sym_preproc_pragma] = STATE(1444),
    [sym_preproc_nullable] = STATE(1444),
    [sym_preproc_error] = STATE(1444),
    [sym_preproc_define] = STATE(1444),
    [sym_preproc_undef] = STATE(1444),
    [aux_sym_class_declaration_repeat1] = STATE(3816),
    [aux_sym_lambda_expression_repeat1] = STATE(4119),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1867),
    [anon_sym_ref] = ACTIONS(1869),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1871),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1875),
    [anon_sym_TILDE] = ACTIONS(1875),
    [anon_sym_PLUS_PLUS] = ACTIONS(1875),
    [anon_sym_DASH_DASH] = ACTIONS(1875),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1873),
    [anon_sym_DASH] = ACTIONS(1873),
    [anon_sym_STAR] = ACTIONS(1877),
    [anon_sym_CARET] = ACTIONS(1875),
    [anon_sym_AMP] = ACTIONS(1875),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1879),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1881),
    [anon_sym_DOT_DOT] = ACTIONS(1883),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1445] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6879),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2935),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7096),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5477),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4288),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7379),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9175),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1445),
    [sym_preproc_endregion] = STATE(1445),
    [sym_preproc_line] = STATE(1445),
    [sym_preproc_pragma] = STATE(1445),
    [sym_preproc_nullable] = STATE(1445),
    [sym_preproc_error] = STATE(1445),
    [sym_preproc_define] = STATE(1445),
    [sym_preproc_undef] = STATE(1445),
    [aux_sym_class_declaration_repeat1] = STATE(3816),
    [aux_sym_lambda_expression_repeat1] = STATE(4119),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1867),
    [anon_sym_ref] = ACTIONS(1869),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1871),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1875),
    [anon_sym_TILDE] = ACTIONS(1875),
    [anon_sym_PLUS_PLUS] = ACTIONS(1875),
    [anon_sym_DASH_DASH] = ACTIONS(1875),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1873),
    [anon_sym_DASH] = ACTIONS(1873),
    [anon_sym_STAR] = ACTIONS(1877),
    [anon_sym_CARET] = ACTIONS(1875),
    [anon_sym_AMP] = ACTIONS(1875),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1879),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1881),
    [anon_sym_DOT_DOT] = ACTIONS(1883),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1446] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6894),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2955),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7025),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4796),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(3735),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7397),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9590),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1446),
    [sym_preproc_endregion] = STATE(1446),
    [sym_preproc_line] = STATE(1446),
    [sym_preproc_pragma] = STATE(1446),
    [sym_preproc_nullable] = STATE(1446),
    [sym_preproc_error] = STATE(1446),
    [sym_preproc_define] = STATE(1446),
    [sym_preproc_undef] = STATE(1446),
    [aux_sym_class_declaration_repeat1] = STATE(3844),
    [aux_sym_lambda_expression_repeat1] = STATE(4245),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1849),
    [anon_sym_ref] = ACTIONS(1851),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1853),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1857),
    [anon_sym_TILDE] = ACTIONS(1857),
    [anon_sym_PLUS_PLUS] = ACTIONS(1857),
    [anon_sym_DASH_DASH] = ACTIONS(1857),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1855),
    [anon_sym_DASH] = ACTIONS(1855),
    [anon_sym_STAR] = ACTIONS(1859),
    [anon_sym_CARET] = ACTIONS(1857),
    [anon_sym_AMP] = ACTIONS(1857),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1861),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1863),
    [anon_sym_DOT_DOT] = ACTIONS(1865),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1447] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6910),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2957),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7089),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5078),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(3796),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7395),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9374),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1447),
    [sym_preproc_endregion] = STATE(1447),
    [sym_preproc_line] = STATE(1447),
    [sym_preproc_pragma] = STATE(1447),
    [sym_preproc_nullable] = STATE(1447),
    [sym_preproc_error] = STATE(1447),
    [sym_preproc_define] = STATE(1447),
    [sym_preproc_undef] = STATE(1447),
    [aux_sym_class_declaration_repeat1] = STATE(3839),
    [aux_sym_lambda_expression_repeat1] = STATE(4209),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2139),
    [anon_sym_ref] = ACTIONS(2141),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1799),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2145),
    [anon_sym_TILDE] = ACTIONS(2145),
    [anon_sym_PLUS_PLUS] = ACTIONS(2145),
    [anon_sym_DASH_DASH] = ACTIONS(2145),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2143),
    [anon_sym_DASH] = ACTIONS(2143),
    [anon_sym_STAR] = ACTIONS(1805),
    [anon_sym_CARET] = ACTIONS(2145),
    [anon_sym_AMP] = ACTIONS(2145),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2147),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2149),
    [anon_sym_DOT_DOT] = ACTIONS(2151),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1448] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6881),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2964),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6972),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6598),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4495),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7398),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9102),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1448),
    [sym_preproc_endregion] = STATE(1448),
    [sym_preproc_line] = STATE(1448),
    [sym_preproc_pragma] = STATE(1448),
    [sym_preproc_nullable] = STATE(1448),
    [sym_preproc_error] = STATE(1448),
    [sym_preproc_define] = STATE(1448),
    [sym_preproc_undef] = STATE(1448),
    [aux_sym_class_declaration_repeat1] = STATE(3857),
    [aux_sym_lambda_expression_repeat1] = STATE(4241),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2097),
    [anon_sym_ref] = ACTIONS(2099),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2101),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2105),
    [anon_sym_TILDE] = ACTIONS(2105),
    [anon_sym_PLUS_PLUS] = ACTIONS(2105),
    [anon_sym_DASH_DASH] = ACTIONS(2105),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2103),
    [anon_sym_DASH] = ACTIONS(2103),
    [anon_sym_STAR] = ACTIONS(2107),
    [anon_sym_CARET] = ACTIONS(2105),
    [anon_sym_AMP] = ACTIONS(2105),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2111),
    [anon_sym_DOT_DOT] = ACTIONS(2113),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1449] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6881),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2964),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6972),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6554),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4495),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7398),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9102),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1449),
    [sym_preproc_endregion] = STATE(1449),
    [sym_preproc_line] = STATE(1449),
    [sym_preproc_pragma] = STATE(1449),
    [sym_preproc_nullable] = STATE(1449),
    [sym_preproc_error] = STATE(1449),
    [sym_preproc_define] = STATE(1449),
    [sym_preproc_undef] = STATE(1449),
    [aux_sym_class_declaration_repeat1] = STATE(3857),
    [aux_sym_lambda_expression_repeat1] = STATE(4241),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2097),
    [anon_sym_ref] = ACTIONS(2099),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2101),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2105),
    [anon_sym_TILDE] = ACTIONS(2105),
    [anon_sym_PLUS_PLUS] = ACTIONS(2105),
    [anon_sym_DASH_DASH] = ACTIONS(2105),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2103),
    [anon_sym_DASH] = ACTIONS(2103),
    [anon_sym_STAR] = ACTIONS(2107),
    [anon_sym_CARET] = ACTIONS(2105),
    [anon_sym_AMP] = ACTIONS(2105),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2111),
    [anon_sym_DOT_DOT] = ACTIONS(2113),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1450] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6901),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2939),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7050),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6591),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4507),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7378),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9063),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1450),
    [sym_preproc_endregion] = STATE(1450),
    [sym_preproc_line] = STATE(1450),
    [sym_preproc_pragma] = STATE(1450),
    [sym_preproc_nullable] = STATE(1450),
    [sym_preproc_error] = STATE(1450),
    [sym_preproc_define] = STATE(1450),
    [sym_preproc_undef] = STATE(1450),
    [aux_sym_class_declaration_repeat1] = STATE(3854),
    [aux_sym_lambda_expression_repeat1] = STATE(4229),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2193),
    [anon_sym_ref] = ACTIONS(2195),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2197),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2201),
    [anon_sym_TILDE] = ACTIONS(2201),
    [anon_sym_PLUS_PLUS] = ACTIONS(2201),
    [anon_sym_DASH_DASH] = ACTIONS(2201),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2199),
    [anon_sym_DASH] = ACTIONS(2199),
    [anon_sym_STAR] = ACTIONS(2203),
    [anon_sym_CARET] = ACTIONS(2201),
    [anon_sym_AMP] = ACTIONS(2201),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2205),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2207),
    [anon_sym_DOT_DOT] = ACTIONS(2209),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1451] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6909),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2874),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7062),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5479),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4291),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7411),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9300),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1451),
    [sym_preproc_endregion] = STATE(1451),
    [sym_preproc_line] = STATE(1451),
    [sym_preproc_pragma] = STATE(1451),
    [sym_preproc_nullable] = STATE(1451),
    [sym_preproc_error] = STATE(1451),
    [sym_preproc_define] = STATE(1451),
    [sym_preproc_undef] = STATE(1451),
    [aux_sym_class_declaration_repeat1] = STATE(3804),
    [aux_sym_lambda_expression_repeat1] = STATE(4114),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1501),
    [anon_sym_ref] = ACTIONS(1503),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1505),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1509),
    [anon_sym_PLUS_PLUS] = ACTIONS(1509),
    [anon_sym_DASH_DASH] = ACTIONS(1509),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1507),
    [anon_sym_DASH] = ACTIONS(1507),
    [anon_sym_STAR] = ACTIONS(1511),
    [anon_sym_CARET] = ACTIONS(1509),
    [anon_sym_AMP] = ACTIONS(1509),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1513),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1515),
    [anon_sym_DOT_DOT] = ACTIONS(1517),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1452] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6881),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2964),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6972),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6556),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4495),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7398),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9102),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1452),
    [sym_preproc_endregion] = STATE(1452),
    [sym_preproc_line] = STATE(1452),
    [sym_preproc_pragma] = STATE(1452),
    [sym_preproc_nullable] = STATE(1452),
    [sym_preproc_error] = STATE(1452),
    [sym_preproc_define] = STATE(1452),
    [sym_preproc_undef] = STATE(1452),
    [aux_sym_class_declaration_repeat1] = STATE(3857),
    [aux_sym_lambda_expression_repeat1] = STATE(4241),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2097),
    [anon_sym_ref] = ACTIONS(2099),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2101),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2105),
    [anon_sym_TILDE] = ACTIONS(2105),
    [anon_sym_PLUS_PLUS] = ACTIONS(2105),
    [anon_sym_DASH_DASH] = ACTIONS(2105),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2103),
    [anon_sym_DASH] = ACTIONS(2103),
    [anon_sym_STAR] = ACTIONS(2107),
    [anon_sym_CARET] = ACTIONS(2105),
    [anon_sym_AMP] = ACTIONS(2105),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2111),
    [anon_sym_DOT_DOT] = ACTIONS(2113),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1453] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6881),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2964),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6972),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6588),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4495),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7398),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9102),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1453),
    [sym_preproc_endregion] = STATE(1453),
    [sym_preproc_line] = STATE(1453),
    [sym_preproc_pragma] = STATE(1453),
    [sym_preproc_nullable] = STATE(1453),
    [sym_preproc_error] = STATE(1453),
    [sym_preproc_define] = STATE(1453),
    [sym_preproc_undef] = STATE(1453),
    [aux_sym_class_declaration_repeat1] = STATE(3857),
    [aux_sym_lambda_expression_repeat1] = STATE(4241),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2097),
    [anon_sym_ref] = ACTIONS(2099),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2101),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2105),
    [anon_sym_TILDE] = ACTIONS(2105),
    [anon_sym_PLUS_PLUS] = ACTIONS(2105),
    [anon_sym_DASH_DASH] = ACTIONS(2105),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2103),
    [anon_sym_DASH] = ACTIONS(2103),
    [anon_sym_STAR] = ACTIONS(2107),
    [anon_sym_CARET] = ACTIONS(2105),
    [anon_sym_AMP] = ACTIONS(2105),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2111),
    [anon_sym_DOT_DOT] = ACTIONS(2113),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1454] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6894),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2955),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7046),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4999),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(3786),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7408),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9363),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1454),
    [sym_preproc_endregion] = STATE(1454),
    [sym_preproc_line] = STATE(1454),
    [sym_preproc_pragma] = STATE(1454),
    [sym_preproc_nullable] = STATE(1454),
    [sym_preproc_error] = STATE(1454),
    [sym_preproc_define] = STATE(1454),
    [sym_preproc_undef] = STATE(1454),
    [aux_sym_class_declaration_repeat1] = STATE(3811),
    [aux_sym_lambda_expression_repeat1] = STATE(4149),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2069),
    [anon_sym_ref] = ACTIONS(2071),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1853),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(2075),
    [anon_sym_TILDE] = ACTIONS(2075),
    [anon_sym_PLUS_PLUS] = ACTIONS(2075),
    [anon_sym_DASH_DASH] = ACTIONS(2075),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2073),
    [anon_sym_DASH] = ACTIONS(2073),
    [anon_sym_STAR] = ACTIONS(1859),
    [anon_sym_CARET] = ACTIONS(2075),
    [anon_sym_AMP] = ACTIONS(2075),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2077),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2079),
    [anon_sym_DOT_DOT] = ACTIONS(2081),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1455] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6881),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2964),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6972),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6593),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4495),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7398),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9102),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1455),
    [sym_preproc_endregion] = STATE(1455),
    [sym_preproc_line] = STATE(1455),
    [sym_preproc_pragma] = STATE(1455),
    [sym_preproc_nullable] = STATE(1455),
    [sym_preproc_error] = STATE(1455),
    [sym_preproc_define] = STATE(1455),
    [sym_preproc_undef] = STATE(1455),
    [aux_sym_class_declaration_repeat1] = STATE(3857),
    [aux_sym_lambda_expression_repeat1] = STATE(4241),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2097),
    [anon_sym_ref] = ACTIONS(2099),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2101),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2105),
    [anon_sym_TILDE] = ACTIONS(2105),
    [anon_sym_PLUS_PLUS] = ACTIONS(2105),
    [anon_sym_DASH_DASH] = ACTIONS(2105),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2103),
    [anon_sym_DASH] = ACTIONS(2103),
    [anon_sym_STAR] = ACTIONS(2107),
    [anon_sym_CARET] = ACTIONS(2105),
    [anon_sym_AMP] = ACTIONS(2105),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2111),
    [anon_sym_DOT_DOT] = ACTIONS(2113),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1456] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6909),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2874),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7062),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5470),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4291),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7411),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9300),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1456),
    [sym_preproc_endregion] = STATE(1456),
    [sym_preproc_line] = STATE(1456),
    [sym_preproc_pragma] = STATE(1456),
    [sym_preproc_nullable] = STATE(1456),
    [sym_preproc_error] = STATE(1456),
    [sym_preproc_define] = STATE(1456),
    [sym_preproc_undef] = STATE(1456),
    [aux_sym_class_declaration_repeat1] = STATE(3804),
    [aux_sym_lambda_expression_repeat1] = STATE(4114),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1501),
    [anon_sym_ref] = ACTIONS(1503),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1505),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1509),
    [anon_sym_PLUS_PLUS] = ACTIONS(1509),
    [anon_sym_DASH_DASH] = ACTIONS(1509),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1507),
    [anon_sym_DASH] = ACTIONS(1507),
    [anon_sym_STAR] = ACTIONS(1511),
    [anon_sym_CARET] = ACTIONS(1509),
    [anon_sym_AMP] = ACTIONS(1509),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1513),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1515),
    [anon_sym_DOT_DOT] = ACTIONS(1517),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1457] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6881),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2964),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6972),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6596),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4495),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7398),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9102),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1457),
    [sym_preproc_endregion] = STATE(1457),
    [sym_preproc_line] = STATE(1457),
    [sym_preproc_pragma] = STATE(1457),
    [sym_preproc_nullable] = STATE(1457),
    [sym_preproc_error] = STATE(1457),
    [sym_preproc_define] = STATE(1457),
    [sym_preproc_undef] = STATE(1457),
    [aux_sym_class_declaration_repeat1] = STATE(3857),
    [aux_sym_lambda_expression_repeat1] = STATE(4241),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2097),
    [anon_sym_ref] = ACTIONS(2099),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2101),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2105),
    [anon_sym_TILDE] = ACTIONS(2105),
    [anon_sym_PLUS_PLUS] = ACTIONS(2105),
    [anon_sym_DASH_DASH] = ACTIONS(2105),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2103),
    [anon_sym_DASH] = ACTIONS(2103),
    [anon_sym_STAR] = ACTIONS(2107),
    [anon_sym_CARET] = ACTIONS(2105),
    [anon_sym_AMP] = ACTIONS(2105),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2111),
    [anon_sym_DOT_DOT] = ACTIONS(2113),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1458] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6894),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2955),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7025),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4807),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(3735),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7397),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9590),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1458),
    [sym_preproc_endregion] = STATE(1458),
    [sym_preproc_line] = STATE(1458),
    [sym_preproc_pragma] = STATE(1458),
    [sym_preproc_nullable] = STATE(1458),
    [sym_preproc_error] = STATE(1458),
    [sym_preproc_define] = STATE(1458),
    [sym_preproc_undef] = STATE(1458),
    [aux_sym_class_declaration_repeat1] = STATE(3844),
    [aux_sym_lambda_expression_repeat1] = STATE(4245),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1849),
    [anon_sym_ref] = ACTIONS(1851),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1853),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1857),
    [anon_sym_TILDE] = ACTIONS(1857),
    [anon_sym_PLUS_PLUS] = ACTIONS(1857),
    [anon_sym_DASH_DASH] = ACTIONS(1857),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1855),
    [anon_sym_DASH] = ACTIONS(1855),
    [anon_sym_STAR] = ACTIONS(1859),
    [anon_sym_CARET] = ACTIONS(1857),
    [anon_sym_AMP] = ACTIONS(1857),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1861),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1863),
    [anon_sym_DOT_DOT] = ACTIONS(1865),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1459] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3921),
    [sym__name] = STATE(6919),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2868),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(6950),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5305),
    [sym_non_lvalue_expression] = STATE(5735),
    [sym_lvalue_expression] = STATE(4054),
    [sym__expression_statement_expression] = STATE(5733),
    [sym_assignment_expression] = STATE(5734),
    [sym_binary_expression] = STATE(5733),
    [sym_postfix_unary_expression] = STATE(5734),
    [sym_prefix_unary_expression] = STATE(5734),
    [sym__pointer_indirection_expression] = STATE(3911),
    [sym_query_expression] = STATE(5733),
    [sym_from_clause] = STATE(7400),
    [sym_conditional_expression] = STATE(5733),
    [sym_conditional_access_expression] = STATE(5733),
    [sym_as_expression] = STATE(5733),
    [sym_is_expression] = STATE(5733),
    [sym_is_pattern_expression] = STATE(5733),
    [sym_cast_expression] = STATE(5733),
    [sym_checked_expression] = STATE(5733),
    [sym_invocation_expression] = STATE(5734),
    [sym_switch_expression] = STATE(5733),
    [sym_await_expression] = STATE(5734),
    [sym_throw_expression] = STATE(5733),
    [sym_element_access_expression] = STATE(3911),
    [sym_interpolated_string_expression] = STATE(5733),
    [sym_member_access_expression] = STATE(3911),
    [sym_object_creation_expression] = STATE(5734),
    [sym_parenthesized_expression] = STATE(5734),
    [sym__parenthesized_lvalue_expression] = STATE(3911),
    [sym_lambda_expression] = STATE(5733),
    [sym__lambda_parameters] = STATE(9693),
    [sym_array_creation_expression] = STATE(5733),
    [sym_anonymous_method_expression] = STATE(5733),
    [sym_anonymous_object_creation_expression] = STATE(5733),
    [sym_implicit_array_creation_expression] = STATE(5733),
    [sym_implicit_object_creation_expression] = STATE(5733),
    [sym_implicit_stackalloc_expression] = STATE(5733),
    [sym_initializer_expression] = STATE(5733),
    [sym_default_expression] = STATE(5733),
    [sym_with_expression] = STATE(5733),
    [sym_sizeof_expression] = STATE(5733),
    [sym_typeof_expression] = STATE(5733),
    [sym_makeref_expression] = STATE(5733),
    [sym_ref_expression] = STATE(5733),
    [sym_reftype_expression] = STATE(5733),
    [sym_refvalue_expression] = STATE(5733),
    [sym_stackalloc_expression] = STATE(5733),
    [sym_range_expression] = STATE(5733),
    [sym_tuple_expression] = STATE(3911),
    [sym_literal] = STATE(5733),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2798),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(5733),
    [sym_preproc_region] = STATE(1459),
    [sym_preproc_endregion] = STATE(1459),
    [sym_preproc_line] = STATE(1459),
    [sym_preproc_pragma] = STATE(1459),
    [sym_preproc_nullable] = STATE(1459),
    [sym_preproc_error] = STATE(1459),
    [sym_preproc_define] = STATE(1459),
    [sym_preproc_undef] = STATE(1459),
    [aux_sym_class_declaration_repeat1] = STATE(3791),
    [aux_sym_lambda_expression_repeat1] = STATE(4075),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_LPAREN] = ACTIONS(1373),
    [anon_sym_ref] = ACTIONS(1375),
    [anon_sym_LBRACE] = ACTIONS(1377),
    [anon_sym_delegate] = ACTIONS(1379),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1381),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1387),
    [anon_sym_TILDE] = ACTIONS(1387),
    [anon_sym_PLUS_PLUS] = ACTIONS(1387),
    [anon_sym_DASH_DASH] = ACTIONS(1387),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1385),
    [anon_sym_DASH] = ACTIONS(1385),
    [anon_sym_STAR] = ACTIONS(1391),
    [anon_sym_CARET] = ACTIONS(1387),
    [anon_sym_AMP] = ACTIONS(1387),
    [anon_sym_this] = ACTIONS(1393),
    [anon_sym_scoped] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1397),
    [sym_predefined_type] = ACTIONS(1399),
    [anon_sym_unchecked] = ACTIONS(1383),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1403),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1405),
    [anon_sym_DOT_DOT] = ACTIONS(1407),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_stackalloc] = ACTIONS(1413),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(1419),
    [anon_sym___reftype] = ACTIONS(1421),
    [anon_sym___refvalue] = ACTIONS(1423),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
  },
  [1460] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6909),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2874),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7062),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(3901),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4291),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7411),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9300),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1460),
    [sym_preproc_endregion] = STATE(1460),
    [sym_preproc_line] = STATE(1460),
    [sym_preproc_pragma] = STATE(1460),
    [sym_preproc_nullable] = STATE(1460),
    [sym_preproc_error] = STATE(1460),
    [sym_preproc_define] = STATE(1460),
    [sym_preproc_undef] = STATE(1460),
    [aux_sym_class_declaration_repeat1] = STATE(3804),
    [aux_sym_lambda_expression_repeat1] = STATE(4114),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1501),
    [anon_sym_ref] = ACTIONS(1503),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1505),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1509),
    [anon_sym_PLUS_PLUS] = ACTIONS(1509),
    [anon_sym_DASH_DASH] = ACTIONS(1509),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1507),
    [anon_sym_DASH] = ACTIONS(1507),
    [anon_sym_STAR] = ACTIONS(1511),
    [anon_sym_CARET] = ACTIONS(1509),
    [anon_sym_AMP] = ACTIONS(1509),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1513),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1515),
    [anon_sym_DOT_DOT] = ACTIONS(1517),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1461] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6909),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2874),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7062),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5468),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4291),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7411),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9300),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1461),
    [sym_preproc_endregion] = STATE(1461),
    [sym_preproc_line] = STATE(1461),
    [sym_preproc_pragma] = STATE(1461),
    [sym_preproc_nullable] = STATE(1461),
    [sym_preproc_error] = STATE(1461),
    [sym_preproc_define] = STATE(1461),
    [sym_preproc_undef] = STATE(1461),
    [aux_sym_class_declaration_repeat1] = STATE(3804),
    [aux_sym_lambda_expression_repeat1] = STATE(4114),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1501),
    [anon_sym_ref] = ACTIONS(1503),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1505),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1509),
    [anon_sym_PLUS_PLUS] = ACTIONS(1509),
    [anon_sym_DASH_DASH] = ACTIONS(1509),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1507),
    [anon_sym_DASH] = ACTIONS(1507),
    [anon_sym_STAR] = ACTIONS(1511),
    [anon_sym_CARET] = ACTIONS(1509),
    [anon_sym_AMP] = ACTIONS(1509),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1513),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1515),
    [anon_sym_DOT_DOT] = ACTIONS(1517),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1462] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6881),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2964),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6972),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6595),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4495),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7398),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9102),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1462),
    [sym_preproc_endregion] = STATE(1462),
    [sym_preproc_line] = STATE(1462),
    [sym_preproc_pragma] = STATE(1462),
    [sym_preproc_nullable] = STATE(1462),
    [sym_preproc_error] = STATE(1462),
    [sym_preproc_define] = STATE(1462),
    [sym_preproc_undef] = STATE(1462),
    [aux_sym_class_declaration_repeat1] = STATE(3857),
    [aux_sym_lambda_expression_repeat1] = STATE(4241),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2097),
    [anon_sym_ref] = ACTIONS(2099),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2101),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2105),
    [anon_sym_TILDE] = ACTIONS(2105),
    [anon_sym_PLUS_PLUS] = ACTIONS(2105),
    [anon_sym_DASH_DASH] = ACTIONS(2105),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2103),
    [anon_sym_DASH] = ACTIONS(2103),
    [anon_sym_STAR] = ACTIONS(2107),
    [anon_sym_CARET] = ACTIONS(2105),
    [anon_sym_AMP] = ACTIONS(2105),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2111),
    [anon_sym_DOT_DOT] = ACTIONS(2113),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1463] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6905),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2944),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7006),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(3565),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4413),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7404),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9233),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1463),
    [sym_preproc_endregion] = STATE(1463),
    [sym_preproc_line] = STATE(1463),
    [sym_preproc_pragma] = STATE(1463),
    [sym_preproc_nullable] = STATE(1463),
    [sym_preproc_error] = STATE(1463),
    [sym_preproc_define] = STATE(1463),
    [sym_preproc_undef] = STATE(1463),
    [aux_sym_class_declaration_repeat1] = STATE(3803),
    [aux_sym_lambda_expression_repeat1] = STATE(4105),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2175),
    [anon_sym_ref] = ACTIONS(2177),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2179),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(2183),
    [anon_sym_TILDE] = ACTIONS(2183),
    [anon_sym_PLUS_PLUS] = ACTIONS(2183),
    [anon_sym_DASH_DASH] = ACTIONS(2183),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2181),
    [anon_sym_DASH] = ACTIONS(2181),
    [anon_sym_STAR] = ACTIONS(2185),
    [anon_sym_CARET] = ACTIONS(2183),
    [anon_sym_AMP] = ACTIONS(2183),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2187),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2189),
    [anon_sym_DOT_DOT] = ACTIONS(2191),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1464] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6905),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2944),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7006),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6251),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4413),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7404),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9233),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1464),
    [sym_preproc_endregion] = STATE(1464),
    [sym_preproc_line] = STATE(1464),
    [sym_preproc_pragma] = STATE(1464),
    [sym_preproc_nullable] = STATE(1464),
    [sym_preproc_error] = STATE(1464),
    [sym_preproc_define] = STATE(1464),
    [sym_preproc_undef] = STATE(1464),
    [aux_sym_class_declaration_repeat1] = STATE(3803),
    [aux_sym_lambda_expression_repeat1] = STATE(4105),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2175),
    [anon_sym_ref] = ACTIONS(2177),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2179),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(2183),
    [anon_sym_TILDE] = ACTIONS(2183),
    [anon_sym_PLUS_PLUS] = ACTIONS(2183),
    [anon_sym_DASH_DASH] = ACTIONS(2183),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2181),
    [anon_sym_DASH] = ACTIONS(2181),
    [anon_sym_STAR] = ACTIONS(2185),
    [anon_sym_CARET] = ACTIONS(2183),
    [anon_sym_AMP] = ACTIONS(2183),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2187),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2189),
    [anon_sym_DOT_DOT] = ACTIONS(2191),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1465] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6894),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2955),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7025),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4812),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(3735),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7397),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9590),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1465),
    [sym_preproc_endregion] = STATE(1465),
    [sym_preproc_line] = STATE(1465),
    [sym_preproc_pragma] = STATE(1465),
    [sym_preproc_nullable] = STATE(1465),
    [sym_preproc_error] = STATE(1465),
    [sym_preproc_define] = STATE(1465),
    [sym_preproc_undef] = STATE(1465),
    [aux_sym_class_declaration_repeat1] = STATE(3844),
    [aux_sym_lambda_expression_repeat1] = STATE(4245),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1849),
    [anon_sym_ref] = ACTIONS(1851),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1853),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1857),
    [anon_sym_TILDE] = ACTIONS(1857),
    [anon_sym_PLUS_PLUS] = ACTIONS(1857),
    [anon_sym_DASH_DASH] = ACTIONS(1857),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1855),
    [anon_sym_DASH] = ACTIONS(1855),
    [anon_sym_STAR] = ACTIONS(1859),
    [anon_sym_CARET] = ACTIONS(1857),
    [anon_sym_AMP] = ACTIONS(1857),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1861),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1863),
    [anon_sym_DOT_DOT] = ACTIONS(1865),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1466] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6894),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2955),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7025),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4840),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(3735),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7397),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9590),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1466),
    [sym_preproc_endregion] = STATE(1466),
    [sym_preproc_line] = STATE(1466),
    [sym_preproc_pragma] = STATE(1466),
    [sym_preproc_nullable] = STATE(1466),
    [sym_preproc_error] = STATE(1466),
    [sym_preproc_define] = STATE(1466),
    [sym_preproc_undef] = STATE(1466),
    [aux_sym_class_declaration_repeat1] = STATE(3844),
    [aux_sym_lambda_expression_repeat1] = STATE(4245),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1849),
    [anon_sym_ref] = ACTIONS(1851),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1853),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1857),
    [anon_sym_TILDE] = ACTIONS(1857),
    [anon_sym_PLUS_PLUS] = ACTIONS(1857),
    [anon_sym_DASH_DASH] = ACTIONS(1857),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1855),
    [anon_sym_DASH] = ACTIONS(1855),
    [anon_sym_STAR] = ACTIONS(1859),
    [anon_sym_CARET] = ACTIONS(1857),
    [anon_sym_AMP] = ACTIONS(1857),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1861),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1863),
    [anon_sym_DOT_DOT] = ACTIONS(1865),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1467] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6905),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2944),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7006),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6252),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4413),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7404),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9233),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1467),
    [sym_preproc_endregion] = STATE(1467),
    [sym_preproc_line] = STATE(1467),
    [sym_preproc_pragma] = STATE(1467),
    [sym_preproc_nullable] = STATE(1467),
    [sym_preproc_error] = STATE(1467),
    [sym_preproc_define] = STATE(1467),
    [sym_preproc_undef] = STATE(1467),
    [aux_sym_class_declaration_repeat1] = STATE(3803),
    [aux_sym_lambda_expression_repeat1] = STATE(4105),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2175),
    [anon_sym_ref] = ACTIONS(2177),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2179),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(2183),
    [anon_sym_TILDE] = ACTIONS(2183),
    [anon_sym_PLUS_PLUS] = ACTIONS(2183),
    [anon_sym_DASH_DASH] = ACTIONS(2183),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2181),
    [anon_sym_DASH] = ACTIONS(2181),
    [anon_sym_STAR] = ACTIONS(2185),
    [anon_sym_CARET] = ACTIONS(2183),
    [anon_sym_AMP] = ACTIONS(2183),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2187),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2189),
    [anon_sym_DOT_DOT] = ACTIONS(2191),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1468] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6905),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2944),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7006),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6254),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4413),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7404),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9233),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1468),
    [sym_preproc_endregion] = STATE(1468),
    [sym_preproc_line] = STATE(1468),
    [sym_preproc_pragma] = STATE(1468),
    [sym_preproc_nullable] = STATE(1468),
    [sym_preproc_error] = STATE(1468),
    [sym_preproc_define] = STATE(1468),
    [sym_preproc_undef] = STATE(1468),
    [aux_sym_class_declaration_repeat1] = STATE(3803),
    [aux_sym_lambda_expression_repeat1] = STATE(4105),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2175),
    [anon_sym_ref] = ACTIONS(2177),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2179),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(2183),
    [anon_sym_TILDE] = ACTIONS(2183),
    [anon_sym_PLUS_PLUS] = ACTIONS(2183),
    [anon_sym_DASH_DASH] = ACTIONS(2183),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2181),
    [anon_sym_DASH] = ACTIONS(2181),
    [anon_sym_STAR] = ACTIONS(2185),
    [anon_sym_CARET] = ACTIONS(2183),
    [anon_sym_AMP] = ACTIONS(2183),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2187),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2189),
    [anon_sym_DOT_DOT] = ACTIONS(2191),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1469] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3921),
    [sym__name] = STATE(6919),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2868),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(7068),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5995),
    [sym_non_lvalue_expression] = STATE(5735),
    [sym_lvalue_expression] = STATE(4323),
    [sym__expression_statement_expression] = STATE(5733),
    [sym_assignment_expression] = STATE(5734),
    [sym_binary_expression] = STATE(5733),
    [sym_postfix_unary_expression] = STATE(5734),
    [sym_prefix_unary_expression] = STATE(5734),
    [sym__pointer_indirection_expression] = STATE(3911),
    [sym_query_expression] = STATE(5733),
    [sym_from_clause] = STATE(7393),
    [sym_conditional_expression] = STATE(5733),
    [sym_conditional_access_expression] = STATE(5733),
    [sym_as_expression] = STATE(5733),
    [sym_is_expression] = STATE(5733),
    [sym_is_pattern_expression] = STATE(5733),
    [sym_cast_expression] = STATE(5733),
    [sym_checked_expression] = STATE(5733),
    [sym_invocation_expression] = STATE(5734),
    [sym_switch_expression] = STATE(5733),
    [sym_await_expression] = STATE(5734),
    [sym_throw_expression] = STATE(5733),
    [sym_element_access_expression] = STATE(3911),
    [sym_interpolated_string_expression] = STATE(5733),
    [sym_member_access_expression] = STATE(3911),
    [sym_object_creation_expression] = STATE(5734),
    [sym_parenthesized_expression] = STATE(5734),
    [sym__parenthesized_lvalue_expression] = STATE(3911),
    [sym_lambda_expression] = STATE(5733),
    [sym__lambda_parameters] = STATE(9932),
    [sym_array_creation_expression] = STATE(5733),
    [sym_anonymous_method_expression] = STATE(5733),
    [sym_anonymous_object_creation_expression] = STATE(5733),
    [sym_implicit_array_creation_expression] = STATE(5733),
    [sym_implicit_object_creation_expression] = STATE(5733),
    [sym_implicit_stackalloc_expression] = STATE(5733),
    [sym_initializer_expression] = STATE(5733),
    [sym_default_expression] = STATE(5733),
    [sym_with_expression] = STATE(5733),
    [sym_sizeof_expression] = STATE(5733),
    [sym_typeof_expression] = STATE(5733),
    [sym_makeref_expression] = STATE(5733),
    [sym_ref_expression] = STATE(5733),
    [sym_reftype_expression] = STATE(5733),
    [sym_refvalue_expression] = STATE(5733),
    [sym_stackalloc_expression] = STATE(5733),
    [sym_range_expression] = STATE(5733),
    [sym_tuple_expression] = STATE(3911),
    [sym_literal] = STATE(5733),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2798),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(5733),
    [sym_preproc_region] = STATE(1469),
    [sym_preproc_endregion] = STATE(1469),
    [sym_preproc_line] = STATE(1469),
    [sym_preproc_pragma] = STATE(1469),
    [sym_preproc_nullable] = STATE(1469),
    [sym_preproc_error] = STATE(1469),
    [sym_preproc_define] = STATE(1469),
    [sym_preproc_undef] = STATE(1469),
    [aux_sym_class_declaration_repeat1] = STATE(3831),
    [aux_sym_lambda_expression_repeat1] = STATE(4227),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_LPAREN] = ACTIONS(1577),
    [anon_sym_ref] = ACTIONS(1579),
    [anon_sym_LBRACE] = ACTIONS(1377),
    [anon_sym_delegate] = ACTIONS(1379),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1381),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1583),
    [anon_sym_TILDE] = ACTIONS(1583),
    [anon_sym_PLUS_PLUS] = ACTIONS(1583),
    [anon_sym_DASH_DASH] = ACTIONS(1583),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1581),
    [anon_sym_DASH] = ACTIONS(1581),
    [anon_sym_STAR] = ACTIONS(1391),
    [anon_sym_CARET] = ACTIONS(1583),
    [anon_sym_AMP] = ACTIONS(1583),
    [anon_sym_this] = ACTIONS(1393),
    [anon_sym_scoped] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1397),
    [sym_predefined_type] = ACTIONS(1399),
    [anon_sym_unchecked] = ACTIONS(1383),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1585),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1587),
    [anon_sym_DOT_DOT] = ACTIONS(1589),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_stackalloc] = ACTIONS(1413),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(1419),
    [anon_sym___reftype] = ACTIONS(1421),
    [anon_sym___refvalue] = ACTIONS(1423),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
  },
  [1470] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6894),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2955),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7025),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4813),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(3735),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7397),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9590),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1470),
    [sym_preproc_endregion] = STATE(1470),
    [sym_preproc_line] = STATE(1470),
    [sym_preproc_pragma] = STATE(1470),
    [sym_preproc_nullable] = STATE(1470),
    [sym_preproc_error] = STATE(1470),
    [sym_preproc_define] = STATE(1470),
    [sym_preproc_undef] = STATE(1470),
    [aux_sym_class_declaration_repeat1] = STATE(3844),
    [aux_sym_lambda_expression_repeat1] = STATE(4245),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1849),
    [anon_sym_ref] = ACTIONS(1851),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1853),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1857),
    [anon_sym_TILDE] = ACTIONS(1857),
    [anon_sym_PLUS_PLUS] = ACTIONS(1857),
    [anon_sym_DASH_DASH] = ACTIONS(1857),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1855),
    [anon_sym_DASH] = ACTIONS(1855),
    [anon_sym_STAR] = ACTIONS(1859),
    [anon_sym_CARET] = ACTIONS(1857),
    [anon_sym_AMP] = ACTIONS(1857),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1861),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1863),
    [anon_sym_DOT_DOT] = ACTIONS(1865),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1471] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6905),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2944),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7006),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6255),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4413),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7404),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9233),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1471),
    [sym_preproc_endregion] = STATE(1471),
    [sym_preproc_line] = STATE(1471),
    [sym_preproc_pragma] = STATE(1471),
    [sym_preproc_nullable] = STATE(1471),
    [sym_preproc_error] = STATE(1471),
    [sym_preproc_define] = STATE(1471),
    [sym_preproc_undef] = STATE(1471),
    [aux_sym_class_declaration_repeat1] = STATE(3803),
    [aux_sym_lambda_expression_repeat1] = STATE(4105),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2175),
    [anon_sym_ref] = ACTIONS(2177),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2179),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(2183),
    [anon_sym_TILDE] = ACTIONS(2183),
    [anon_sym_PLUS_PLUS] = ACTIONS(2183),
    [anon_sym_DASH_DASH] = ACTIONS(2183),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2181),
    [anon_sym_DASH] = ACTIONS(2181),
    [anon_sym_STAR] = ACTIONS(2185),
    [anon_sym_CARET] = ACTIONS(2183),
    [anon_sym_AMP] = ACTIONS(2183),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2187),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2189),
    [anon_sym_DOT_DOT] = ACTIONS(2191),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1472] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6905),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2944),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7006),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6256),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4413),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7404),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9233),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1472),
    [sym_preproc_endregion] = STATE(1472),
    [sym_preproc_line] = STATE(1472),
    [sym_preproc_pragma] = STATE(1472),
    [sym_preproc_nullable] = STATE(1472),
    [sym_preproc_error] = STATE(1472),
    [sym_preproc_define] = STATE(1472),
    [sym_preproc_undef] = STATE(1472),
    [aux_sym_class_declaration_repeat1] = STATE(3803),
    [aux_sym_lambda_expression_repeat1] = STATE(4105),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2175),
    [anon_sym_ref] = ACTIONS(2177),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2179),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(2183),
    [anon_sym_TILDE] = ACTIONS(2183),
    [anon_sym_PLUS_PLUS] = ACTIONS(2183),
    [anon_sym_DASH_DASH] = ACTIONS(2183),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2181),
    [anon_sym_DASH] = ACTIONS(2181),
    [anon_sym_STAR] = ACTIONS(2185),
    [anon_sym_CARET] = ACTIONS(2183),
    [anon_sym_AMP] = ACTIONS(2183),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2187),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2189),
    [anon_sym_DOT_DOT] = ACTIONS(2191),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1473] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6894),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2955),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7025),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4814),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(3735),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7397),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9590),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1473),
    [sym_preproc_endregion] = STATE(1473),
    [sym_preproc_line] = STATE(1473),
    [sym_preproc_pragma] = STATE(1473),
    [sym_preproc_nullable] = STATE(1473),
    [sym_preproc_error] = STATE(1473),
    [sym_preproc_define] = STATE(1473),
    [sym_preproc_undef] = STATE(1473),
    [aux_sym_class_declaration_repeat1] = STATE(3844),
    [aux_sym_lambda_expression_repeat1] = STATE(4245),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1849),
    [anon_sym_ref] = ACTIONS(1851),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1853),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1857),
    [anon_sym_TILDE] = ACTIONS(1857),
    [anon_sym_PLUS_PLUS] = ACTIONS(1857),
    [anon_sym_DASH_DASH] = ACTIONS(1857),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1855),
    [anon_sym_DASH] = ACTIONS(1855),
    [anon_sym_STAR] = ACTIONS(1859),
    [anon_sym_CARET] = ACTIONS(1857),
    [anon_sym_AMP] = ACTIONS(1857),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1861),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1863),
    [anon_sym_DOT_DOT] = ACTIONS(1865),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1474] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6905),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2944),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7006),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6257),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4413),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7404),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9233),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1474),
    [sym_preproc_endregion] = STATE(1474),
    [sym_preproc_line] = STATE(1474),
    [sym_preproc_pragma] = STATE(1474),
    [sym_preproc_nullable] = STATE(1474),
    [sym_preproc_error] = STATE(1474),
    [sym_preproc_define] = STATE(1474),
    [sym_preproc_undef] = STATE(1474),
    [aux_sym_class_declaration_repeat1] = STATE(3803),
    [aux_sym_lambda_expression_repeat1] = STATE(4105),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2175),
    [anon_sym_ref] = ACTIONS(2177),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2179),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(2183),
    [anon_sym_TILDE] = ACTIONS(2183),
    [anon_sym_PLUS_PLUS] = ACTIONS(2183),
    [anon_sym_DASH_DASH] = ACTIONS(2183),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2181),
    [anon_sym_DASH] = ACTIONS(2181),
    [anon_sym_STAR] = ACTIONS(2185),
    [anon_sym_CARET] = ACTIONS(2183),
    [anon_sym_AMP] = ACTIONS(2183),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2187),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2189),
    [anon_sym_DOT_DOT] = ACTIONS(2191),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1475] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6894),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2955),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7025),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4830),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(3735),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7397),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9590),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1475),
    [sym_preproc_endregion] = STATE(1475),
    [sym_preproc_line] = STATE(1475),
    [sym_preproc_pragma] = STATE(1475),
    [sym_preproc_nullable] = STATE(1475),
    [sym_preproc_error] = STATE(1475),
    [sym_preproc_define] = STATE(1475),
    [sym_preproc_undef] = STATE(1475),
    [aux_sym_class_declaration_repeat1] = STATE(3844),
    [aux_sym_lambda_expression_repeat1] = STATE(4245),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1849),
    [anon_sym_ref] = ACTIONS(1851),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1853),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1857),
    [anon_sym_TILDE] = ACTIONS(1857),
    [anon_sym_PLUS_PLUS] = ACTIONS(1857),
    [anon_sym_DASH_DASH] = ACTIONS(1857),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1855),
    [anon_sym_DASH] = ACTIONS(1855),
    [anon_sym_STAR] = ACTIONS(1859),
    [anon_sym_CARET] = ACTIONS(1857),
    [anon_sym_AMP] = ACTIONS(1857),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1861),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1863),
    [anon_sym_DOT_DOT] = ACTIONS(1865),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1476] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6905),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2944),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7006),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6258),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4413),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7404),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9233),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1476),
    [sym_preproc_endregion] = STATE(1476),
    [sym_preproc_line] = STATE(1476),
    [sym_preproc_pragma] = STATE(1476),
    [sym_preproc_nullable] = STATE(1476),
    [sym_preproc_error] = STATE(1476),
    [sym_preproc_define] = STATE(1476),
    [sym_preproc_undef] = STATE(1476),
    [aux_sym_class_declaration_repeat1] = STATE(3803),
    [aux_sym_lambda_expression_repeat1] = STATE(4105),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2175),
    [anon_sym_ref] = ACTIONS(2177),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2179),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(2183),
    [anon_sym_TILDE] = ACTIONS(2183),
    [anon_sym_PLUS_PLUS] = ACTIONS(2183),
    [anon_sym_DASH_DASH] = ACTIONS(2183),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2181),
    [anon_sym_DASH] = ACTIONS(2181),
    [anon_sym_STAR] = ACTIONS(2185),
    [anon_sym_CARET] = ACTIONS(2183),
    [anon_sym_AMP] = ACTIONS(2183),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2187),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2189),
    [anon_sym_DOT_DOT] = ACTIONS(2191),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1477] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6905),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2944),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7006),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6259),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4413),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7404),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9233),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1477),
    [sym_preproc_endregion] = STATE(1477),
    [sym_preproc_line] = STATE(1477),
    [sym_preproc_pragma] = STATE(1477),
    [sym_preproc_nullable] = STATE(1477),
    [sym_preproc_error] = STATE(1477),
    [sym_preproc_define] = STATE(1477),
    [sym_preproc_undef] = STATE(1477),
    [aux_sym_class_declaration_repeat1] = STATE(3803),
    [aux_sym_lambda_expression_repeat1] = STATE(4105),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2175),
    [anon_sym_ref] = ACTIONS(2177),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2179),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(2183),
    [anon_sym_TILDE] = ACTIONS(2183),
    [anon_sym_PLUS_PLUS] = ACTIONS(2183),
    [anon_sym_DASH_DASH] = ACTIONS(2183),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2181),
    [anon_sym_DASH] = ACTIONS(2181),
    [anon_sym_STAR] = ACTIONS(2185),
    [anon_sym_CARET] = ACTIONS(2183),
    [anon_sym_AMP] = ACTIONS(2183),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2187),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2189),
    [anon_sym_DOT_DOT] = ACTIONS(2191),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1478] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6905),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2944),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7006),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6260),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4413),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7404),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9233),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1478),
    [sym_preproc_endregion] = STATE(1478),
    [sym_preproc_line] = STATE(1478),
    [sym_preproc_pragma] = STATE(1478),
    [sym_preproc_nullable] = STATE(1478),
    [sym_preproc_error] = STATE(1478),
    [sym_preproc_define] = STATE(1478),
    [sym_preproc_undef] = STATE(1478),
    [aux_sym_class_declaration_repeat1] = STATE(3803),
    [aux_sym_lambda_expression_repeat1] = STATE(4105),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2175),
    [anon_sym_ref] = ACTIONS(2177),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2179),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(2183),
    [anon_sym_TILDE] = ACTIONS(2183),
    [anon_sym_PLUS_PLUS] = ACTIONS(2183),
    [anon_sym_DASH_DASH] = ACTIONS(2183),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2181),
    [anon_sym_DASH] = ACTIONS(2181),
    [anon_sym_STAR] = ACTIONS(2185),
    [anon_sym_CARET] = ACTIONS(2183),
    [anon_sym_AMP] = ACTIONS(2183),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2187),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2189),
    [anon_sym_DOT_DOT] = ACTIONS(2191),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1479] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6905),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2944),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7006),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6261),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4413),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7404),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9233),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1479),
    [sym_preproc_endregion] = STATE(1479),
    [sym_preproc_line] = STATE(1479),
    [sym_preproc_pragma] = STATE(1479),
    [sym_preproc_nullable] = STATE(1479),
    [sym_preproc_error] = STATE(1479),
    [sym_preproc_define] = STATE(1479),
    [sym_preproc_undef] = STATE(1479),
    [aux_sym_class_declaration_repeat1] = STATE(3803),
    [aux_sym_lambda_expression_repeat1] = STATE(4105),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2175),
    [anon_sym_ref] = ACTIONS(2177),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2179),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(2183),
    [anon_sym_TILDE] = ACTIONS(2183),
    [anon_sym_PLUS_PLUS] = ACTIONS(2183),
    [anon_sym_DASH_DASH] = ACTIONS(2183),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2181),
    [anon_sym_DASH] = ACTIONS(2181),
    [anon_sym_STAR] = ACTIONS(2185),
    [anon_sym_CARET] = ACTIONS(2183),
    [anon_sym_AMP] = ACTIONS(2183),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2187),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2189),
    [anon_sym_DOT_DOT] = ACTIONS(2191),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1480] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6905),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2944),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7006),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6262),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4413),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7404),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9233),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1480),
    [sym_preproc_endregion] = STATE(1480),
    [sym_preproc_line] = STATE(1480),
    [sym_preproc_pragma] = STATE(1480),
    [sym_preproc_nullable] = STATE(1480),
    [sym_preproc_error] = STATE(1480),
    [sym_preproc_define] = STATE(1480),
    [sym_preproc_undef] = STATE(1480),
    [aux_sym_class_declaration_repeat1] = STATE(3803),
    [aux_sym_lambda_expression_repeat1] = STATE(4105),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2175),
    [anon_sym_ref] = ACTIONS(2177),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2179),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(2183),
    [anon_sym_TILDE] = ACTIONS(2183),
    [anon_sym_PLUS_PLUS] = ACTIONS(2183),
    [anon_sym_DASH_DASH] = ACTIONS(2183),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2181),
    [anon_sym_DASH] = ACTIONS(2181),
    [anon_sym_STAR] = ACTIONS(2185),
    [anon_sym_CARET] = ACTIONS(2183),
    [anon_sym_AMP] = ACTIONS(2183),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2187),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2189),
    [anon_sym_DOT_DOT] = ACTIONS(2191),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1481] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6894),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2955),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7025),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4860),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(3735),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7397),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9590),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1481),
    [sym_preproc_endregion] = STATE(1481),
    [sym_preproc_line] = STATE(1481),
    [sym_preproc_pragma] = STATE(1481),
    [sym_preproc_nullable] = STATE(1481),
    [sym_preproc_error] = STATE(1481),
    [sym_preproc_define] = STATE(1481),
    [sym_preproc_undef] = STATE(1481),
    [aux_sym_class_declaration_repeat1] = STATE(3844),
    [aux_sym_lambda_expression_repeat1] = STATE(4245),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1849),
    [anon_sym_ref] = ACTIONS(1851),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1853),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1857),
    [anon_sym_TILDE] = ACTIONS(1857),
    [anon_sym_PLUS_PLUS] = ACTIONS(1857),
    [anon_sym_DASH_DASH] = ACTIONS(1857),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1855),
    [anon_sym_DASH] = ACTIONS(1855),
    [anon_sym_STAR] = ACTIONS(1859),
    [anon_sym_CARET] = ACTIONS(1857),
    [anon_sym_AMP] = ACTIONS(1857),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1861),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1863),
    [anon_sym_DOT_DOT] = ACTIONS(1865),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1482] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6894),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2955),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7025),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4866),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(3735),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7397),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9590),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1482),
    [sym_preproc_endregion] = STATE(1482),
    [sym_preproc_line] = STATE(1482),
    [sym_preproc_pragma] = STATE(1482),
    [sym_preproc_nullable] = STATE(1482),
    [sym_preproc_error] = STATE(1482),
    [sym_preproc_define] = STATE(1482),
    [sym_preproc_undef] = STATE(1482),
    [aux_sym_class_declaration_repeat1] = STATE(3844),
    [aux_sym_lambda_expression_repeat1] = STATE(4245),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1849),
    [anon_sym_ref] = ACTIONS(1851),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1853),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1857),
    [anon_sym_TILDE] = ACTIONS(1857),
    [anon_sym_PLUS_PLUS] = ACTIONS(1857),
    [anon_sym_DASH_DASH] = ACTIONS(1857),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1855),
    [anon_sym_DASH] = ACTIONS(1855),
    [anon_sym_STAR] = ACTIONS(1859),
    [anon_sym_CARET] = ACTIONS(1857),
    [anon_sym_AMP] = ACTIONS(1857),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1861),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1863),
    [anon_sym_DOT_DOT] = ACTIONS(1865),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1483] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6905),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2944),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7006),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6149),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4413),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7404),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9233),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1483),
    [sym_preproc_endregion] = STATE(1483),
    [sym_preproc_line] = STATE(1483),
    [sym_preproc_pragma] = STATE(1483),
    [sym_preproc_nullable] = STATE(1483),
    [sym_preproc_error] = STATE(1483),
    [sym_preproc_define] = STATE(1483),
    [sym_preproc_undef] = STATE(1483),
    [aux_sym_class_declaration_repeat1] = STATE(3803),
    [aux_sym_lambda_expression_repeat1] = STATE(4105),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2175),
    [anon_sym_ref] = ACTIONS(2177),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2179),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(2183),
    [anon_sym_TILDE] = ACTIONS(2183),
    [anon_sym_PLUS_PLUS] = ACTIONS(2183),
    [anon_sym_DASH_DASH] = ACTIONS(2183),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2181),
    [anon_sym_DASH] = ACTIONS(2181),
    [anon_sym_STAR] = ACTIONS(2185),
    [anon_sym_CARET] = ACTIONS(2183),
    [anon_sym_AMP] = ACTIONS(2183),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2187),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2189),
    [anon_sym_DOT_DOT] = ACTIONS(2191),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1484] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6894),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2955),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7025),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4770),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(3735),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7397),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9590),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1484),
    [sym_preproc_endregion] = STATE(1484),
    [sym_preproc_line] = STATE(1484),
    [sym_preproc_pragma] = STATE(1484),
    [sym_preproc_nullable] = STATE(1484),
    [sym_preproc_error] = STATE(1484),
    [sym_preproc_define] = STATE(1484),
    [sym_preproc_undef] = STATE(1484),
    [aux_sym_class_declaration_repeat1] = STATE(3844),
    [aux_sym_lambda_expression_repeat1] = STATE(4245),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1849),
    [anon_sym_ref] = ACTIONS(1851),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1853),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1857),
    [anon_sym_TILDE] = ACTIONS(1857),
    [anon_sym_PLUS_PLUS] = ACTIONS(1857),
    [anon_sym_DASH_DASH] = ACTIONS(1857),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1855),
    [anon_sym_DASH] = ACTIONS(1855),
    [anon_sym_STAR] = ACTIONS(1859),
    [anon_sym_CARET] = ACTIONS(1857),
    [anon_sym_AMP] = ACTIONS(1857),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1861),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1863),
    [anon_sym_DOT_DOT] = ACTIONS(1865),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1485] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6894),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2955),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7025),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4850),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(3735),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7397),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9590),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1485),
    [sym_preproc_endregion] = STATE(1485),
    [sym_preproc_line] = STATE(1485),
    [sym_preproc_pragma] = STATE(1485),
    [sym_preproc_nullable] = STATE(1485),
    [sym_preproc_error] = STATE(1485),
    [sym_preproc_define] = STATE(1485),
    [sym_preproc_undef] = STATE(1485),
    [aux_sym_class_declaration_repeat1] = STATE(3844),
    [aux_sym_lambda_expression_repeat1] = STATE(4245),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1849),
    [anon_sym_ref] = ACTIONS(1851),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1853),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1857),
    [anon_sym_TILDE] = ACTIONS(1857),
    [anon_sym_PLUS_PLUS] = ACTIONS(1857),
    [anon_sym_DASH_DASH] = ACTIONS(1857),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1855),
    [anon_sym_DASH] = ACTIONS(1855),
    [anon_sym_STAR] = ACTIONS(1859),
    [anon_sym_CARET] = ACTIONS(1857),
    [anon_sym_AMP] = ACTIONS(1857),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1861),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1863),
    [anon_sym_DOT_DOT] = ACTIONS(1865),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1486] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6894),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2955),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7025),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4717),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(3735),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7397),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9590),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1486),
    [sym_preproc_endregion] = STATE(1486),
    [sym_preproc_line] = STATE(1486),
    [sym_preproc_pragma] = STATE(1486),
    [sym_preproc_nullable] = STATE(1486),
    [sym_preproc_error] = STATE(1486),
    [sym_preproc_define] = STATE(1486),
    [sym_preproc_undef] = STATE(1486),
    [aux_sym_class_declaration_repeat1] = STATE(3844),
    [aux_sym_lambda_expression_repeat1] = STATE(4245),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1849),
    [anon_sym_ref] = ACTIONS(1851),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1853),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1857),
    [anon_sym_TILDE] = ACTIONS(1857),
    [anon_sym_PLUS_PLUS] = ACTIONS(1857),
    [anon_sym_DASH_DASH] = ACTIONS(1857),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1855),
    [anon_sym_DASH] = ACTIONS(1855),
    [anon_sym_STAR] = ACTIONS(1859),
    [anon_sym_CARET] = ACTIONS(1857),
    [anon_sym_AMP] = ACTIONS(1857),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1861),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1863),
    [anon_sym_DOT_DOT] = ACTIONS(1865),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1487] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6905),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2944),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7006),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6268),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4413),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7404),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9233),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1487),
    [sym_preproc_endregion] = STATE(1487),
    [sym_preproc_line] = STATE(1487),
    [sym_preproc_pragma] = STATE(1487),
    [sym_preproc_nullable] = STATE(1487),
    [sym_preproc_error] = STATE(1487),
    [sym_preproc_define] = STATE(1487),
    [sym_preproc_undef] = STATE(1487),
    [aux_sym_class_declaration_repeat1] = STATE(3803),
    [aux_sym_lambda_expression_repeat1] = STATE(4105),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2175),
    [anon_sym_ref] = ACTIONS(2177),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2179),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(2183),
    [anon_sym_TILDE] = ACTIONS(2183),
    [anon_sym_PLUS_PLUS] = ACTIONS(2183),
    [anon_sym_DASH_DASH] = ACTIONS(2183),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2181),
    [anon_sym_DASH] = ACTIONS(2181),
    [anon_sym_STAR] = ACTIONS(2185),
    [anon_sym_CARET] = ACTIONS(2183),
    [anon_sym_AMP] = ACTIONS(2183),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2187),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2189),
    [anon_sym_DOT_DOT] = ACTIONS(2191),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1488] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6881),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2964),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6972),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4309),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4495),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7398),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9102),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1488),
    [sym_preproc_endregion] = STATE(1488),
    [sym_preproc_line] = STATE(1488),
    [sym_preproc_pragma] = STATE(1488),
    [sym_preproc_nullable] = STATE(1488),
    [sym_preproc_error] = STATE(1488),
    [sym_preproc_define] = STATE(1488),
    [sym_preproc_undef] = STATE(1488),
    [aux_sym_class_declaration_repeat1] = STATE(3857),
    [aux_sym_lambda_expression_repeat1] = STATE(4241),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2097),
    [anon_sym_ref] = ACTIONS(2099),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2101),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2105),
    [anon_sym_TILDE] = ACTIONS(2105),
    [anon_sym_PLUS_PLUS] = ACTIONS(2105),
    [anon_sym_DASH_DASH] = ACTIONS(2105),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2103),
    [anon_sym_DASH] = ACTIONS(2103),
    [anon_sym_STAR] = ACTIONS(2107),
    [anon_sym_CARET] = ACTIONS(2105),
    [anon_sym_AMP] = ACTIONS(2105),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2111),
    [anon_sym_DOT_DOT] = ACTIONS(2113),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1489] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5503),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1489),
    [sym_preproc_endregion] = STATE(1489),
    [sym_preproc_line] = STATE(1489),
    [sym_preproc_pragma] = STATE(1489),
    [sym_preproc_nullable] = STATE(1489),
    [sym_preproc_error] = STATE(1489),
    [sym_preproc_define] = STATE(1489),
    [sym_preproc_undef] = STATE(1489),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1490] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6896),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2944),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6952),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5615),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4248),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7396),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9160),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1490),
    [sym_preproc_endregion] = STATE(1490),
    [sym_preproc_line] = STATE(1490),
    [sym_preproc_pragma] = STATE(1490),
    [sym_preproc_nullable] = STATE(1490),
    [sym_preproc_error] = STATE(1490),
    [sym_preproc_define] = STATE(1490),
    [sym_preproc_undef] = STATE(1490),
    [aux_sym_class_declaration_repeat1] = STATE(3795),
    [aux_sym_lambda_expression_repeat1] = STATE(4144),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1831),
    [anon_sym_ref] = ACTIONS(1833),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1835),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1839),
    [anon_sym_TILDE] = ACTIONS(1839),
    [anon_sym_PLUS_PLUS] = ACTIONS(1839),
    [anon_sym_DASH_DASH] = ACTIONS(1839),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1837),
    [anon_sym_DASH] = ACTIONS(1837),
    [anon_sym_STAR] = ACTIONS(1841),
    [anon_sym_CARET] = ACTIONS(1839),
    [anon_sym_AMP] = ACTIONS(1839),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1843),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1845),
    [anon_sym_DOT_DOT] = ACTIONS(1847),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1491] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6881),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2964),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7109),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5767),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4326),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7394),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9186),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1491),
    [sym_preproc_endregion] = STATE(1491),
    [sym_preproc_line] = STATE(1491),
    [sym_preproc_pragma] = STATE(1491),
    [sym_preproc_nullable] = STATE(1491),
    [sym_preproc_error] = STATE(1491),
    [sym_preproc_define] = STATE(1491),
    [sym_preproc_undef] = STATE(1491),
    [aux_sym_class_declaration_repeat1] = STATE(3828),
    [aux_sym_lambda_expression_repeat1] = STATE(4180),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1813),
    [anon_sym_ref] = ACTIONS(1815),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1817),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1821),
    [anon_sym_TILDE] = ACTIONS(1821),
    [anon_sym_PLUS_PLUS] = ACTIONS(1821),
    [anon_sym_DASH_DASH] = ACTIONS(1821),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1819),
    [anon_sym_DASH] = ACTIONS(1819),
    [anon_sym_STAR] = ACTIONS(1823),
    [anon_sym_CARET] = ACTIONS(1821),
    [anon_sym_AMP] = ACTIONS(1821),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1825),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1827),
    [anon_sym_DOT_DOT] = ACTIONS(1829),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1492] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6881),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2964),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6972),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6622),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4495),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7398),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9102),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1492),
    [sym_preproc_endregion] = STATE(1492),
    [sym_preproc_line] = STATE(1492),
    [sym_preproc_pragma] = STATE(1492),
    [sym_preproc_nullable] = STATE(1492),
    [sym_preproc_error] = STATE(1492),
    [sym_preproc_define] = STATE(1492),
    [sym_preproc_undef] = STATE(1492),
    [aux_sym_class_declaration_repeat1] = STATE(3857),
    [aux_sym_lambda_expression_repeat1] = STATE(4241),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2097),
    [anon_sym_ref] = ACTIONS(2099),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2101),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2105),
    [anon_sym_TILDE] = ACTIONS(2105),
    [anon_sym_PLUS_PLUS] = ACTIONS(2105),
    [anon_sym_DASH_DASH] = ACTIONS(2105),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2103),
    [anon_sym_DASH] = ACTIONS(2103),
    [anon_sym_STAR] = ACTIONS(2107),
    [anon_sym_CARET] = ACTIONS(2105),
    [anon_sym_AMP] = ACTIONS(2105),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2111),
    [anon_sym_DOT_DOT] = ACTIONS(2113),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1493] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6905),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2944),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7006),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6272),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4413),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7404),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9233),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1493),
    [sym_preproc_endregion] = STATE(1493),
    [sym_preproc_line] = STATE(1493),
    [sym_preproc_pragma] = STATE(1493),
    [sym_preproc_nullable] = STATE(1493),
    [sym_preproc_error] = STATE(1493),
    [sym_preproc_define] = STATE(1493),
    [sym_preproc_undef] = STATE(1493),
    [aux_sym_class_declaration_repeat1] = STATE(3803),
    [aux_sym_lambda_expression_repeat1] = STATE(4105),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2175),
    [anon_sym_ref] = ACTIONS(2177),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2179),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(2183),
    [anon_sym_TILDE] = ACTIONS(2183),
    [anon_sym_PLUS_PLUS] = ACTIONS(2183),
    [anon_sym_DASH_DASH] = ACTIONS(2183),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2181),
    [anon_sym_DASH] = ACTIONS(2181),
    [anon_sym_STAR] = ACTIONS(2185),
    [anon_sym_CARET] = ACTIONS(2183),
    [anon_sym_AMP] = ACTIONS(2183),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2187),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2189),
    [anon_sym_DOT_DOT] = ACTIONS(2191),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1494] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6905),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2944),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7006),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6199),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4413),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7404),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9233),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1494),
    [sym_preproc_endregion] = STATE(1494),
    [sym_preproc_line] = STATE(1494),
    [sym_preproc_pragma] = STATE(1494),
    [sym_preproc_nullable] = STATE(1494),
    [sym_preproc_error] = STATE(1494),
    [sym_preproc_define] = STATE(1494),
    [sym_preproc_undef] = STATE(1494),
    [aux_sym_class_declaration_repeat1] = STATE(3803),
    [aux_sym_lambda_expression_repeat1] = STATE(4105),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2175),
    [anon_sym_ref] = ACTIONS(2177),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2179),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(2183),
    [anon_sym_TILDE] = ACTIONS(2183),
    [anon_sym_PLUS_PLUS] = ACTIONS(2183),
    [anon_sym_DASH_DASH] = ACTIONS(2183),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2181),
    [anon_sym_DASH] = ACTIONS(2181),
    [anon_sym_STAR] = ACTIONS(2185),
    [anon_sym_CARET] = ACTIONS(2183),
    [anon_sym_AMP] = ACTIONS(2183),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2187),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2189),
    [anon_sym_DOT_DOT] = ACTIONS(2191),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1495] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4325),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1495),
    [sym_preproc_endregion] = STATE(1495),
    [sym_preproc_line] = STATE(1495),
    [sym_preproc_pragma] = STATE(1495),
    [sym_preproc_nullable] = STATE(1495),
    [sym_preproc_error] = STATE(1495),
    [sym_preproc_define] = STATE(1495),
    [sym_preproc_undef] = STATE(1495),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1496] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6905),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2944),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7006),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(3556),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4413),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7404),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9233),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1496),
    [sym_preproc_endregion] = STATE(1496),
    [sym_preproc_line] = STATE(1496),
    [sym_preproc_pragma] = STATE(1496),
    [sym_preproc_nullable] = STATE(1496),
    [sym_preproc_error] = STATE(1496),
    [sym_preproc_define] = STATE(1496),
    [sym_preproc_undef] = STATE(1496),
    [aux_sym_class_declaration_repeat1] = STATE(3803),
    [aux_sym_lambda_expression_repeat1] = STATE(4105),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2175),
    [anon_sym_ref] = ACTIONS(2177),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2179),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(2183),
    [anon_sym_TILDE] = ACTIONS(2183),
    [anon_sym_PLUS_PLUS] = ACTIONS(2183),
    [anon_sym_DASH_DASH] = ACTIONS(2183),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2181),
    [anon_sym_DASH] = ACTIONS(2181),
    [anon_sym_STAR] = ACTIONS(2185),
    [anon_sym_CARET] = ACTIONS(2183),
    [anon_sym_AMP] = ACTIONS(2183),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2187),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2189),
    [anon_sym_DOT_DOT] = ACTIONS(2191),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1497] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6905),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2944),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7006),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6274),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4413),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7404),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9233),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1497),
    [sym_preproc_endregion] = STATE(1497),
    [sym_preproc_line] = STATE(1497),
    [sym_preproc_pragma] = STATE(1497),
    [sym_preproc_nullable] = STATE(1497),
    [sym_preproc_error] = STATE(1497),
    [sym_preproc_define] = STATE(1497),
    [sym_preproc_undef] = STATE(1497),
    [aux_sym_class_declaration_repeat1] = STATE(3803),
    [aux_sym_lambda_expression_repeat1] = STATE(4105),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2175),
    [anon_sym_ref] = ACTIONS(2177),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2179),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(2183),
    [anon_sym_TILDE] = ACTIONS(2183),
    [anon_sym_PLUS_PLUS] = ACTIONS(2183),
    [anon_sym_DASH_DASH] = ACTIONS(2183),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2181),
    [anon_sym_DASH] = ACTIONS(2181),
    [anon_sym_STAR] = ACTIONS(2185),
    [anon_sym_CARET] = ACTIONS(2183),
    [anon_sym_AMP] = ACTIONS(2183),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2187),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2189),
    [anon_sym_DOT_DOT] = ACTIONS(2191),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1498] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7064),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5208),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(3866),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7382),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9762),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1498),
    [sym_preproc_endregion] = STATE(1498),
    [sym_preproc_line] = STATE(1498),
    [sym_preproc_pragma] = STATE(1498),
    [sym_preproc_nullable] = STATE(1498),
    [sym_preproc_error] = STATE(1498),
    [sym_preproc_define] = STATE(1498),
    [sym_preproc_undef] = STATE(1498),
    [aux_sym_class_declaration_repeat1] = STATE(3842),
    [aux_sym_lambda_expression_repeat1] = STATE(4280),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1351),
    [anon_sym_ref] = ACTIONS(1353),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1357),
    [anon_sym_TILDE] = ACTIONS(1357),
    [anon_sym_PLUS_PLUS] = ACTIONS(1357),
    [anon_sym_DASH_DASH] = ACTIONS(1357),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1355),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(1357),
    [anon_sym_AMP] = ACTIONS(1357),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1361),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1363),
    [anon_sym_DOT_DOT] = ACTIONS(1365),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1499] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6909),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2874),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7062),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(3922),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4291),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7411),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9300),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1499),
    [sym_preproc_endregion] = STATE(1499),
    [sym_preproc_line] = STATE(1499),
    [sym_preproc_pragma] = STATE(1499),
    [sym_preproc_nullable] = STATE(1499),
    [sym_preproc_error] = STATE(1499),
    [sym_preproc_define] = STATE(1499),
    [sym_preproc_undef] = STATE(1499),
    [aux_sym_class_declaration_repeat1] = STATE(3804),
    [aux_sym_lambda_expression_repeat1] = STATE(4114),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1501),
    [anon_sym_ref] = ACTIONS(1503),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1505),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1509),
    [anon_sym_PLUS_PLUS] = ACTIONS(1509),
    [anon_sym_DASH_DASH] = ACTIONS(1509),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1507),
    [anon_sym_DASH] = ACTIONS(1507),
    [anon_sym_STAR] = ACTIONS(1511),
    [anon_sym_CARET] = ACTIONS(1509),
    [anon_sym_AMP] = ACTIONS(1509),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1513),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1515),
    [anon_sym_DOT_DOT] = ACTIONS(1517),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1500] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6908),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2874),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7082),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(3902),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4189),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7388),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9466),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1500),
    [sym_preproc_endregion] = STATE(1500),
    [sym_preproc_line] = STATE(1500),
    [sym_preproc_pragma] = STATE(1500),
    [sym_preproc_nullable] = STATE(1500),
    [sym_preproc_error] = STATE(1500),
    [sym_preproc_define] = STATE(1500),
    [sym_preproc_undef] = STATE(1500),
    [aux_sym_class_declaration_repeat1] = STATE(3825),
    [aux_sym_lambda_expression_repeat1] = STATE(4178),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1743),
    [anon_sym_ref] = ACTIONS(1745),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1505),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1749),
    [anon_sym_TILDE] = ACTIONS(1749),
    [anon_sym_PLUS_PLUS] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1749),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1747),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_CARET] = ACTIONS(1749),
    [anon_sym_AMP] = ACTIONS(1749),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1753),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1755),
    [anon_sym_DOT_DOT] = ACTIONS(1757),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1501] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6909),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2874),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7062),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5461),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4291),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7411),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9300),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1501),
    [sym_preproc_endregion] = STATE(1501),
    [sym_preproc_line] = STATE(1501),
    [sym_preproc_pragma] = STATE(1501),
    [sym_preproc_nullable] = STATE(1501),
    [sym_preproc_error] = STATE(1501),
    [sym_preproc_define] = STATE(1501),
    [sym_preproc_undef] = STATE(1501),
    [aux_sym_class_declaration_repeat1] = STATE(3804),
    [aux_sym_lambda_expression_repeat1] = STATE(4114),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1501),
    [anon_sym_ref] = ACTIONS(1503),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1505),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1509),
    [anon_sym_PLUS_PLUS] = ACTIONS(1509),
    [anon_sym_DASH_DASH] = ACTIONS(1509),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1507),
    [anon_sym_DASH] = ACTIONS(1507),
    [anon_sym_STAR] = ACTIONS(1511),
    [anon_sym_CARET] = ACTIONS(1509),
    [anon_sym_AMP] = ACTIONS(1509),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1513),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1515),
    [anon_sym_DOT_DOT] = ACTIONS(1517),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1502] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7064),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(3901),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(3866),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7382),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9762),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1502),
    [sym_preproc_endregion] = STATE(1502),
    [sym_preproc_line] = STATE(1502),
    [sym_preproc_pragma] = STATE(1502),
    [sym_preproc_nullable] = STATE(1502),
    [sym_preproc_error] = STATE(1502),
    [sym_preproc_define] = STATE(1502),
    [sym_preproc_undef] = STATE(1502),
    [aux_sym_class_declaration_repeat1] = STATE(3842),
    [aux_sym_lambda_expression_repeat1] = STATE(4280),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1351),
    [anon_sym_ref] = ACTIONS(1353),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1357),
    [anon_sym_TILDE] = ACTIONS(1357),
    [anon_sym_PLUS_PLUS] = ACTIONS(1357),
    [anon_sym_DASH_DASH] = ACTIONS(1357),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1355),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(1357),
    [anon_sym_AMP] = ACTIONS(1357),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1361),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1363),
    [anon_sym_DOT_DOT] = ACTIONS(1365),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1503] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6909),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2874),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7062),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5459),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4291),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7411),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9300),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1503),
    [sym_preproc_endregion] = STATE(1503),
    [sym_preproc_line] = STATE(1503),
    [sym_preproc_pragma] = STATE(1503),
    [sym_preproc_nullable] = STATE(1503),
    [sym_preproc_error] = STATE(1503),
    [sym_preproc_define] = STATE(1503),
    [sym_preproc_undef] = STATE(1503),
    [aux_sym_class_declaration_repeat1] = STATE(3804),
    [aux_sym_lambda_expression_repeat1] = STATE(4114),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1501),
    [anon_sym_ref] = ACTIONS(1503),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1505),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1509),
    [anon_sym_PLUS_PLUS] = ACTIONS(1509),
    [anon_sym_DASH_DASH] = ACTIONS(1509),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1507),
    [anon_sym_DASH] = ACTIONS(1507),
    [anon_sym_STAR] = ACTIONS(1511),
    [anon_sym_CARET] = ACTIONS(1509),
    [anon_sym_AMP] = ACTIONS(1509),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1513),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1515),
    [anon_sym_DOT_DOT] = ACTIONS(1517),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1504] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6909),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2874),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7062),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5458),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4291),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7411),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9300),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1504),
    [sym_preproc_endregion] = STATE(1504),
    [sym_preproc_line] = STATE(1504),
    [sym_preproc_pragma] = STATE(1504),
    [sym_preproc_nullable] = STATE(1504),
    [sym_preproc_error] = STATE(1504),
    [sym_preproc_define] = STATE(1504),
    [sym_preproc_undef] = STATE(1504),
    [aux_sym_class_declaration_repeat1] = STATE(3804),
    [aux_sym_lambda_expression_repeat1] = STATE(4114),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1501),
    [anon_sym_ref] = ACTIONS(1503),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1505),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1509),
    [anon_sym_PLUS_PLUS] = ACTIONS(1509),
    [anon_sym_DASH_DASH] = ACTIONS(1509),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1507),
    [anon_sym_DASH] = ACTIONS(1507),
    [anon_sym_STAR] = ACTIONS(1511),
    [anon_sym_CARET] = ACTIONS(1509),
    [anon_sym_AMP] = ACTIONS(1509),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1513),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1515),
    [anon_sym_DOT_DOT] = ACTIONS(1517),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1505] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6909),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2874),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7062),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5453),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4291),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7411),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9300),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1505),
    [sym_preproc_endregion] = STATE(1505),
    [sym_preproc_line] = STATE(1505),
    [sym_preproc_pragma] = STATE(1505),
    [sym_preproc_nullable] = STATE(1505),
    [sym_preproc_error] = STATE(1505),
    [sym_preproc_define] = STATE(1505),
    [sym_preproc_undef] = STATE(1505),
    [aux_sym_class_declaration_repeat1] = STATE(3804),
    [aux_sym_lambda_expression_repeat1] = STATE(4114),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1501),
    [anon_sym_ref] = ACTIONS(1503),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1505),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1509),
    [anon_sym_PLUS_PLUS] = ACTIONS(1509),
    [anon_sym_DASH_DASH] = ACTIONS(1509),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1507),
    [anon_sym_DASH] = ACTIONS(1507),
    [anon_sym_STAR] = ACTIONS(1511),
    [anon_sym_CARET] = ACTIONS(1509),
    [anon_sym_AMP] = ACTIONS(1509),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1513),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1515),
    [anon_sym_DOT_DOT] = ACTIONS(1517),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1506] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6909),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2874),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7062),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5436),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4291),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7411),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9300),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1506),
    [sym_preproc_endregion] = STATE(1506),
    [sym_preproc_line] = STATE(1506),
    [sym_preproc_pragma] = STATE(1506),
    [sym_preproc_nullable] = STATE(1506),
    [sym_preproc_error] = STATE(1506),
    [sym_preproc_define] = STATE(1506),
    [sym_preproc_undef] = STATE(1506),
    [aux_sym_class_declaration_repeat1] = STATE(3804),
    [aux_sym_lambda_expression_repeat1] = STATE(4114),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1501),
    [anon_sym_ref] = ACTIONS(1503),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1505),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1509),
    [anon_sym_PLUS_PLUS] = ACTIONS(1509),
    [anon_sym_DASH_DASH] = ACTIONS(1509),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1507),
    [anon_sym_DASH] = ACTIONS(1507),
    [anon_sym_STAR] = ACTIONS(1511),
    [anon_sym_CARET] = ACTIONS(1509),
    [anon_sym_AMP] = ACTIONS(1509),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1513),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1515),
    [anon_sym_DOT_DOT] = ACTIONS(1517),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1507] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6909),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2874),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7062),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5435),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4291),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7411),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9300),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1507),
    [sym_preproc_endregion] = STATE(1507),
    [sym_preproc_line] = STATE(1507),
    [sym_preproc_pragma] = STATE(1507),
    [sym_preproc_nullable] = STATE(1507),
    [sym_preproc_error] = STATE(1507),
    [sym_preproc_define] = STATE(1507),
    [sym_preproc_undef] = STATE(1507),
    [aux_sym_class_declaration_repeat1] = STATE(3804),
    [aux_sym_lambda_expression_repeat1] = STATE(4114),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1501),
    [anon_sym_ref] = ACTIONS(1503),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1505),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1509),
    [anon_sym_PLUS_PLUS] = ACTIONS(1509),
    [anon_sym_DASH_DASH] = ACTIONS(1509),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1507),
    [anon_sym_DASH] = ACTIONS(1507),
    [anon_sym_STAR] = ACTIONS(1511),
    [anon_sym_CARET] = ACTIONS(1509),
    [anon_sym_AMP] = ACTIONS(1509),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1513),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1515),
    [anon_sym_DOT_DOT] = ACTIONS(1517),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1508] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6909),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2874),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7062),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5434),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4291),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7411),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9300),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1508),
    [sym_preproc_endregion] = STATE(1508),
    [sym_preproc_line] = STATE(1508),
    [sym_preproc_pragma] = STATE(1508),
    [sym_preproc_nullable] = STATE(1508),
    [sym_preproc_error] = STATE(1508),
    [sym_preproc_define] = STATE(1508),
    [sym_preproc_undef] = STATE(1508),
    [aux_sym_class_declaration_repeat1] = STATE(3804),
    [aux_sym_lambda_expression_repeat1] = STATE(4114),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1501),
    [anon_sym_ref] = ACTIONS(1503),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1505),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1509),
    [anon_sym_PLUS_PLUS] = ACTIONS(1509),
    [anon_sym_DASH_DASH] = ACTIONS(1509),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1507),
    [anon_sym_DASH] = ACTIONS(1507),
    [anon_sym_STAR] = ACTIONS(1511),
    [anon_sym_CARET] = ACTIONS(1509),
    [anon_sym_AMP] = ACTIONS(1509),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1513),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1515),
    [anon_sym_DOT_DOT] = ACTIONS(1517),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1509] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6909),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2874),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7062),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5433),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4291),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7411),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9300),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1509),
    [sym_preproc_endregion] = STATE(1509),
    [sym_preproc_line] = STATE(1509),
    [sym_preproc_pragma] = STATE(1509),
    [sym_preproc_nullable] = STATE(1509),
    [sym_preproc_error] = STATE(1509),
    [sym_preproc_define] = STATE(1509),
    [sym_preproc_undef] = STATE(1509),
    [aux_sym_class_declaration_repeat1] = STATE(3804),
    [aux_sym_lambda_expression_repeat1] = STATE(4114),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1501),
    [anon_sym_ref] = ACTIONS(1503),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1505),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1509),
    [anon_sym_PLUS_PLUS] = ACTIONS(1509),
    [anon_sym_DASH_DASH] = ACTIONS(1509),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1507),
    [anon_sym_DASH] = ACTIONS(1507),
    [anon_sym_STAR] = ACTIONS(1511),
    [anon_sym_CARET] = ACTIONS(1509),
    [anon_sym_AMP] = ACTIONS(1509),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1513),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1515),
    [anon_sym_DOT_DOT] = ACTIONS(1517),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1510] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6909),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2874),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7062),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5663),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4291),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7411),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9300),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1510),
    [sym_preproc_endregion] = STATE(1510),
    [sym_preproc_line] = STATE(1510),
    [sym_preproc_pragma] = STATE(1510),
    [sym_preproc_nullable] = STATE(1510),
    [sym_preproc_error] = STATE(1510),
    [sym_preproc_define] = STATE(1510),
    [sym_preproc_undef] = STATE(1510),
    [aux_sym_class_declaration_repeat1] = STATE(3804),
    [aux_sym_lambda_expression_repeat1] = STATE(4114),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1501),
    [anon_sym_ref] = ACTIONS(1503),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1505),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1509),
    [anon_sym_PLUS_PLUS] = ACTIONS(1509),
    [anon_sym_DASH_DASH] = ACTIONS(1509),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1507),
    [anon_sym_DASH] = ACTIONS(1507),
    [anon_sym_STAR] = ACTIONS(1511),
    [anon_sym_CARET] = ACTIONS(1509),
    [anon_sym_AMP] = ACTIONS(1509),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1513),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1515),
    [anon_sym_DOT_DOT] = ACTIONS(1517),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1511] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6909),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2874),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7062),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5432),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4291),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7411),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9300),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1511),
    [sym_preproc_endregion] = STATE(1511),
    [sym_preproc_line] = STATE(1511),
    [sym_preproc_pragma] = STATE(1511),
    [sym_preproc_nullable] = STATE(1511),
    [sym_preproc_error] = STATE(1511),
    [sym_preproc_define] = STATE(1511),
    [sym_preproc_undef] = STATE(1511),
    [aux_sym_class_declaration_repeat1] = STATE(3804),
    [aux_sym_lambda_expression_repeat1] = STATE(4114),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1501),
    [anon_sym_ref] = ACTIONS(1503),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1505),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1509),
    [anon_sym_PLUS_PLUS] = ACTIONS(1509),
    [anon_sym_DASH_DASH] = ACTIONS(1509),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1507),
    [anon_sym_DASH] = ACTIONS(1507),
    [anon_sym_STAR] = ACTIONS(1511),
    [anon_sym_CARET] = ACTIONS(1509),
    [anon_sym_AMP] = ACTIONS(1509),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1513),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1515),
    [anon_sym_DOT_DOT] = ACTIONS(1517),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1512] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6894),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2955),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7025),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(3556),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(3735),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7397),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9590),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1512),
    [sym_preproc_endregion] = STATE(1512),
    [sym_preproc_line] = STATE(1512),
    [sym_preproc_pragma] = STATE(1512),
    [sym_preproc_nullable] = STATE(1512),
    [sym_preproc_error] = STATE(1512),
    [sym_preproc_define] = STATE(1512),
    [sym_preproc_undef] = STATE(1512),
    [aux_sym_class_declaration_repeat1] = STATE(3844),
    [aux_sym_lambda_expression_repeat1] = STATE(4245),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1849),
    [anon_sym_ref] = ACTIONS(1851),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1853),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1857),
    [anon_sym_TILDE] = ACTIONS(1857),
    [anon_sym_PLUS_PLUS] = ACTIONS(1857),
    [anon_sym_DASH_DASH] = ACTIONS(1857),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1855),
    [anon_sym_DASH] = ACTIONS(1855),
    [anon_sym_STAR] = ACTIONS(1859),
    [anon_sym_CARET] = ACTIONS(1857),
    [anon_sym_AMP] = ACTIONS(1857),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1861),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1863),
    [anon_sym_DOT_DOT] = ACTIONS(1865),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1513] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6909),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2874),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7062),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5431),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4291),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7411),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9300),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1513),
    [sym_preproc_endregion] = STATE(1513),
    [sym_preproc_line] = STATE(1513),
    [sym_preproc_pragma] = STATE(1513),
    [sym_preproc_nullable] = STATE(1513),
    [sym_preproc_error] = STATE(1513),
    [sym_preproc_define] = STATE(1513),
    [sym_preproc_undef] = STATE(1513),
    [aux_sym_class_declaration_repeat1] = STATE(3804),
    [aux_sym_lambda_expression_repeat1] = STATE(4114),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1501),
    [anon_sym_ref] = ACTIONS(1503),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1505),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1509),
    [anon_sym_PLUS_PLUS] = ACTIONS(1509),
    [anon_sym_DASH_DASH] = ACTIONS(1509),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1507),
    [anon_sym_DASH] = ACTIONS(1507),
    [anon_sym_STAR] = ACTIONS(1511),
    [anon_sym_CARET] = ACTIONS(1509),
    [anon_sym_AMP] = ACTIONS(1509),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1513),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1515),
    [anon_sym_DOT_DOT] = ACTIONS(1517),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1514] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6881),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2964),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7109),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5869),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4326),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7394),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9186),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1514),
    [sym_preproc_endregion] = STATE(1514),
    [sym_preproc_line] = STATE(1514),
    [sym_preproc_pragma] = STATE(1514),
    [sym_preproc_nullable] = STATE(1514),
    [sym_preproc_error] = STATE(1514),
    [sym_preproc_define] = STATE(1514),
    [sym_preproc_undef] = STATE(1514),
    [aux_sym_class_declaration_repeat1] = STATE(3828),
    [aux_sym_lambda_expression_repeat1] = STATE(4180),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1813),
    [anon_sym_ref] = ACTIONS(1815),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1817),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1821),
    [anon_sym_TILDE] = ACTIONS(1821),
    [anon_sym_PLUS_PLUS] = ACTIONS(1821),
    [anon_sym_DASH_DASH] = ACTIONS(1821),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1819),
    [anon_sym_DASH] = ACTIONS(1819),
    [anon_sym_STAR] = ACTIONS(1823),
    [anon_sym_CARET] = ACTIONS(1821),
    [anon_sym_AMP] = ACTIONS(1821),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1825),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1827),
    [anon_sym_DOT_DOT] = ACTIONS(1829),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1515] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3921),
    [sym__name] = STATE(6919),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2868),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(7068),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5966),
    [sym_non_lvalue_expression] = STATE(5735),
    [sym_lvalue_expression] = STATE(4323),
    [sym__expression_statement_expression] = STATE(5733),
    [sym_assignment_expression] = STATE(5734),
    [sym_binary_expression] = STATE(5733),
    [sym_postfix_unary_expression] = STATE(5734),
    [sym_prefix_unary_expression] = STATE(5734),
    [sym__pointer_indirection_expression] = STATE(3911),
    [sym_query_expression] = STATE(5733),
    [sym_from_clause] = STATE(7393),
    [sym_conditional_expression] = STATE(5733),
    [sym_conditional_access_expression] = STATE(5733),
    [sym_as_expression] = STATE(5733),
    [sym_is_expression] = STATE(5733),
    [sym_is_pattern_expression] = STATE(5733),
    [sym_cast_expression] = STATE(5733),
    [sym_checked_expression] = STATE(5733),
    [sym_invocation_expression] = STATE(5734),
    [sym_switch_expression] = STATE(5733),
    [sym_await_expression] = STATE(5734),
    [sym_throw_expression] = STATE(5733),
    [sym_element_access_expression] = STATE(3911),
    [sym_interpolated_string_expression] = STATE(5733),
    [sym_member_access_expression] = STATE(3911),
    [sym_object_creation_expression] = STATE(5734),
    [sym_parenthesized_expression] = STATE(5734),
    [sym__parenthesized_lvalue_expression] = STATE(3911),
    [sym_lambda_expression] = STATE(5733),
    [sym__lambda_parameters] = STATE(9932),
    [sym_array_creation_expression] = STATE(5733),
    [sym_anonymous_method_expression] = STATE(5733),
    [sym_anonymous_object_creation_expression] = STATE(5733),
    [sym_implicit_array_creation_expression] = STATE(5733),
    [sym_implicit_object_creation_expression] = STATE(5733),
    [sym_implicit_stackalloc_expression] = STATE(5733),
    [sym_initializer_expression] = STATE(5733),
    [sym_default_expression] = STATE(5733),
    [sym_with_expression] = STATE(5733),
    [sym_sizeof_expression] = STATE(5733),
    [sym_typeof_expression] = STATE(5733),
    [sym_makeref_expression] = STATE(5733),
    [sym_ref_expression] = STATE(5733),
    [sym_reftype_expression] = STATE(5733),
    [sym_refvalue_expression] = STATE(5733),
    [sym_stackalloc_expression] = STATE(5733),
    [sym_range_expression] = STATE(5733),
    [sym_tuple_expression] = STATE(3911),
    [sym_literal] = STATE(5733),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2798),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(5733),
    [sym_preproc_region] = STATE(1515),
    [sym_preproc_endregion] = STATE(1515),
    [sym_preproc_line] = STATE(1515),
    [sym_preproc_pragma] = STATE(1515),
    [sym_preproc_nullable] = STATE(1515),
    [sym_preproc_error] = STATE(1515),
    [sym_preproc_define] = STATE(1515),
    [sym_preproc_undef] = STATE(1515),
    [aux_sym_class_declaration_repeat1] = STATE(3831),
    [aux_sym_lambda_expression_repeat1] = STATE(4227),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_LPAREN] = ACTIONS(1577),
    [anon_sym_ref] = ACTIONS(1579),
    [anon_sym_LBRACE] = ACTIONS(1377),
    [anon_sym_delegate] = ACTIONS(1379),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1381),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1583),
    [anon_sym_TILDE] = ACTIONS(1583),
    [anon_sym_PLUS_PLUS] = ACTIONS(1583),
    [anon_sym_DASH_DASH] = ACTIONS(1583),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1581),
    [anon_sym_DASH] = ACTIONS(1581),
    [anon_sym_STAR] = ACTIONS(1391),
    [anon_sym_CARET] = ACTIONS(1583),
    [anon_sym_AMP] = ACTIONS(1583),
    [anon_sym_this] = ACTIONS(1393),
    [anon_sym_scoped] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1397),
    [sym_predefined_type] = ACTIONS(1399),
    [anon_sym_unchecked] = ACTIONS(1383),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1585),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1587),
    [anon_sym_DOT_DOT] = ACTIONS(1589),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_stackalloc] = ACTIONS(1413),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(1419),
    [anon_sym___reftype] = ACTIONS(1421),
    [anon_sym___refvalue] = ACTIONS(1423),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
  },
  [1516] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6881),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2964),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7109),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5818),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4326),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7394),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9186),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1516),
    [sym_preproc_endregion] = STATE(1516),
    [sym_preproc_line] = STATE(1516),
    [sym_preproc_pragma] = STATE(1516),
    [sym_preproc_nullable] = STATE(1516),
    [sym_preproc_error] = STATE(1516),
    [sym_preproc_define] = STATE(1516),
    [sym_preproc_undef] = STATE(1516),
    [aux_sym_class_declaration_repeat1] = STATE(3828),
    [aux_sym_lambda_expression_repeat1] = STATE(4180),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1813),
    [anon_sym_ref] = ACTIONS(1815),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1817),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1821),
    [anon_sym_TILDE] = ACTIONS(1821),
    [anon_sym_PLUS_PLUS] = ACTIONS(1821),
    [anon_sym_DASH_DASH] = ACTIONS(1821),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1819),
    [anon_sym_DASH] = ACTIONS(1819),
    [anon_sym_STAR] = ACTIONS(1823),
    [anon_sym_CARET] = ACTIONS(1821),
    [anon_sym_AMP] = ACTIONS(1821),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1825),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1827),
    [anon_sym_DOT_DOT] = ACTIONS(1829),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1517] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6881),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2964),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7109),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5870),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4326),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7394),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9186),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1517),
    [sym_preproc_endregion] = STATE(1517),
    [sym_preproc_line] = STATE(1517),
    [sym_preproc_pragma] = STATE(1517),
    [sym_preproc_nullable] = STATE(1517),
    [sym_preproc_error] = STATE(1517),
    [sym_preproc_define] = STATE(1517),
    [sym_preproc_undef] = STATE(1517),
    [aux_sym_class_declaration_repeat1] = STATE(3828),
    [aux_sym_lambda_expression_repeat1] = STATE(4180),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1813),
    [anon_sym_ref] = ACTIONS(1815),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1817),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1821),
    [anon_sym_TILDE] = ACTIONS(1821),
    [anon_sym_PLUS_PLUS] = ACTIONS(1821),
    [anon_sym_DASH_DASH] = ACTIONS(1821),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1819),
    [anon_sym_DASH] = ACTIONS(1819),
    [anon_sym_STAR] = ACTIONS(1823),
    [anon_sym_CARET] = ACTIONS(1821),
    [anon_sym_AMP] = ACTIONS(1821),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1825),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1827),
    [anon_sym_DOT_DOT] = ACTIONS(1829),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1518] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3921),
    [sym__name] = STATE(6919),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2868),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(7068),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5965),
    [sym_non_lvalue_expression] = STATE(5735),
    [sym_lvalue_expression] = STATE(4323),
    [sym__expression_statement_expression] = STATE(5733),
    [sym_assignment_expression] = STATE(5734),
    [sym_binary_expression] = STATE(5733),
    [sym_postfix_unary_expression] = STATE(5734),
    [sym_prefix_unary_expression] = STATE(5734),
    [sym__pointer_indirection_expression] = STATE(3911),
    [sym_query_expression] = STATE(5733),
    [sym_from_clause] = STATE(7393),
    [sym_conditional_expression] = STATE(5733),
    [sym_conditional_access_expression] = STATE(5733),
    [sym_as_expression] = STATE(5733),
    [sym_is_expression] = STATE(5733),
    [sym_is_pattern_expression] = STATE(5733),
    [sym_cast_expression] = STATE(5733),
    [sym_checked_expression] = STATE(5733),
    [sym_invocation_expression] = STATE(5734),
    [sym_switch_expression] = STATE(5733),
    [sym_await_expression] = STATE(5734),
    [sym_throw_expression] = STATE(5733),
    [sym_element_access_expression] = STATE(3911),
    [sym_interpolated_string_expression] = STATE(5733),
    [sym_member_access_expression] = STATE(3911),
    [sym_object_creation_expression] = STATE(5734),
    [sym_parenthesized_expression] = STATE(5734),
    [sym__parenthesized_lvalue_expression] = STATE(3911),
    [sym_lambda_expression] = STATE(5733),
    [sym__lambda_parameters] = STATE(9932),
    [sym_array_creation_expression] = STATE(5733),
    [sym_anonymous_method_expression] = STATE(5733),
    [sym_anonymous_object_creation_expression] = STATE(5733),
    [sym_implicit_array_creation_expression] = STATE(5733),
    [sym_implicit_object_creation_expression] = STATE(5733),
    [sym_implicit_stackalloc_expression] = STATE(5733),
    [sym_initializer_expression] = STATE(5733),
    [sym_default_expression] = STATE(5733),
    [sym_with_expression] = STATE(5733),
    [sym_sizeof_expression] = STATE(5733),
    [sym_typeof_expression] = STATE(5733),
    [sym_makeref_expression] = STATE(5733),
    [sym_ref_expression] = STATE(5733),
    [sym_reftype_expression] = STATE(5733),
    [sym_refvalue_expression] = STATE(5733),
    [sym_stackalloc_expression] = STATE(5733),
    [sym_range_expression] = STATE(5733),
    [sym_tuple_expression] = STATE(3911),
    [sym_literal] = STATE(5733),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2798),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(5733),
    [sym_preproc_region] = STATE(1518),
    [sym_preproc_endregion] = STATE(1518),
    [sym_preproc_line] = STATE(1518),
    [sym_preproc_pragma] = STATE(1518),
    [sym_preproc_nullable] = STATE(1518),
    [sym_preproc_error] = STATE(1518),
    [sym_preproc_define] = STATE(1518),
    [sym_preproc_undef] = STATE(1518),
    [aux_sym_class_declaration_repeat1] = STATE(3831),
    [aux_sym_lambda_expression_repeat1] = STATE(4227),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_LPAREN] = ACTIONS(1577),
    [anon_sym_ref] = ACTIONS(1579),
    [anon_sym_LBRACE] = ACTIONS(1377),
    [anon_sym_delegate] = ACTIONS(1379),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1381),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1583),
    [anon_sym_TILDE] = ACTIONS(1583),
    [anon_sym_PLUS_PLUS] = ACTIONS(1583),
    [anon_sym_DASH_DASH] = ACTIONS(1583),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1581),
    [anon_sym_DASH] = ACTIONS(1581),
    [anon_sym_STAR] = ACTIONS(1391),
    [anon_sym_CARET] = ACTIONS(1583),
    [anon_sym_AMP] = ACTIONS(1583),
    [anon_sym_this] = ACTIONS(1393),
    [anon_sym_scoped] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1397),
    [sym_predefined_type] = ACTIONS(1399),
    [anon_sym_unchecked] = ACTIONS(1383),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1585),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1587),
    [anon_sym_DOT_DOT] = ACTIONS(1589),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_stackalloc] = ACTIONS(1413),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(1419),
    [anon_sym___reftype] = ACTIONS(1421),
    [anon_sym___refvalue] = ACTIONS(1423),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
  },
  [1519] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3921),
    [sym__name] = STATE(6919),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2868),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(7068),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5964),
    [sym_non_lvalue_expression] = STATE(5735),
    [sym_lvalue_expression] = STATE(4323),
    [sym__expression_statement_expression] = STATE(5733),
    [sym_assignment_expression] = STATE(5734),
    [sym_binary_expression] = STATE(5733),
    [sym_postfix_unary_expression] = STATE(5734),
    [sym_prefix_unary_expression] = STATE(5734),
    [sym__pointer_indirection_expression] = STATE(3911),
    [sym_query_expression] = STATE(5733),
    [sym_from_clause] = STATE(7393),
    [sym_conditional_expression] = STATE(5733),
    [sym_conditional_access_expression] = STATE(5733),
    [sym_as_expression] = STATE(5733),
    [sym_is_expression] = STATE(5733),
    [sym_is_pattern_expression] = STATE(5733),
    [sym_cast_expression] = STATE(5733),
    [sym_checked_expression] = STATE(5733),
    [sym_invocation_expression] = STATE(5734),
    [sym_switch_expression] = STATE(5733),
    [sym_await_expression] = STATE(5734),
    [sym_throw_expression] = STATE(5733),
    [sym_element_access_expression] = STATE(3911),
    [sym_interpolated_string_expression] = STATE(5733),
    [sym_member_access_expression] = STATE(3911),
    [sym_object_creation_expression] = STATE(5734),
    [sym_parenthesized_expression] = STATE(5734),
    [sym__parenthesized_lvalue_expression] = STATE(3911),
    [sym_lambda_expression] = STATE(5733),
    [sym__lambda_parameters] = STATE(9932),
    [sym_array_creation_expression] = STATE(5733),
    [sym_anonymous_method_expression] = STATE(5733),
    [sym_anonymous_object_creation_expression] = STATE(5733),
    [sym_implicit_array_creation_expression] = STATE(5733),
    [sym_implicit_object_creation_expression] = STATE(5733),
    [sym_implicit_stackalloc_expression] = STATE(5733),
    [sym_initializer_expression] = STATE(5733),
    [sym_default_expression] = STATE(5733),
    [sym_with_expression] = STATE(5733),
    [sym_sizeof_expression] = STATE(5733),
    [sym_typeof_expression] = STATE(5733),
    [sym_makeref_expression] = STATE(5733),
    [sym_ref_expression] = STATE(5733),
    [sym_reftype_expression] = STATE(5733),
    [sym_refvalue_expression] = STATE(5733),
    [sym_stackalloc_expression] = STATE(5733),
    [sym_range_expression] = STATE(5733),
    [sym_tuple_expression] = STATE(3911),
    [sym_literal] = STATE(5733),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2798),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(5733),
    [sym_preproc_region] = STATE(1519),
    [sym_preproc_endregion] = STATE(1519),
    [sym_preproc_line] = STATE(1519),
    [sym_preproc_pragma] = STATE(1519),
    [sym_preproc_nullable] = STATE(1519),
    [sym_preproc_error] = STATE(1519),
    [sym_preproc_define] = STATE(1519),
    [sym_preproc_undef] = STATE(1519),
    [aux_sym_class_declaration_repeat1] = STATE(3831),
    [aux_sym_lambda_expression_repeat1] = STATE(4227),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_LPAREN] = ACTIONS(1577),
    [anon_sym_ref] = ACTIONS(1579),
    [anon_sym_LBRACE] = ACTIONS(1377),
    [anon_sym_delegate] = ACTIONS(1379),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1381),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1583),
    [anon_sym_TILDE] = ACTIONS(1583),
    [anon_sym_PLUS_PLUS] = ACTIONS(1583),
    [anon_sym_DASH_DASH] = ACTIONS(1583),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1581),
    [anon_sym_DASH] = ACTIONS(1581),
    [anon_sym_STAR] = ACTIONS(1391),
    [anon_sym_CARET] = ACTIONS(1583),
    [anon_sym_AMP] = ACTIONS(1583),
    [anon_sym_this] = ACTIONS(1393),
    [anon_sym_scoped] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1397),
    [sym_predefined_type] = ACTIONS(1399),
    [anon_sym_unchecked] = ACTIONS(1383),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1585),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1587),
    [anon_sym_DOT_DOT] = ACTIONS(1589),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_stackalloc] = ACTIONS(1413),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(1419),
    [anon_sym___reftype] = ACTIONS(1421),
    [anon_sym___refvalue] = ACTIONS(1423),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
  },
  [1520] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6881),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2964),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7109),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5871),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4326),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7394),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9186),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1520),
    [sym_preproc_endregion] = STATE(1520),
    [sym_preproc_line] = STATE(1520),
    [sym_preproc_pragma] = STATE(1520),
    [sym_preproc_nullable] = STATE(1520),
    [sym_preproc_error] = STATE(1520),
    [sym_preproc_define] = STATE(1520),
    [sym_preproc_undef] = STATE(1520),
    [aux_sym_class_declaration_repeat1] = STATE(3828),
    [aux_sym_lambda_expression_repeat1] = STATE(4180),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1813),
    [anon_sym_ref] = ACTIONS(1815),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1817),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1821),
    [anon_sym_TILDE] = ACTIONS(1821),
    [anon_sym_PLUS_PLUS] = ACTIONS(1821),
    [anon_sym_DASH_DASH] = ACTIONS(1821),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1819),
    [anon_sym_DASH] = ACTIONS(1819),
    [anon_sym_STAR] = ACTIONS(1823),
    [anon_sym_CARET] = ACTIONS(1821),
    [anon_sym_AMP] = ACTIONS(1821),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1825),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1827),
    [anon_sym_DOT_DOT] = ACTIONS(1829),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1521] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6881),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2964),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7109),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5873),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4326),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7394),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9186),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1521),
    [sym_preproc_endregion] = STATE(1521),
    [sym_preproc_line] = STATE(1521),
    [sym_preproc_pragma] = STATE(1521),
    [sym_preproc_nullable] = STATE(1521),
    [sym_preproc_error] = STATE(1521),
    [sym_preproc_define] = STATE(1521),
    [sym_preproc_undef] = STATE(1521),
    [aux_sym_class_declaration_repeat1] = STATE(3828),
    [aux_sym_lambda_expression_repeat1] = STATE(4180),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1813),
    [anon_sym_ref] = ACTIONS(1815),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1817),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1821),
    [anon_sym_TILDE] = ACTIONS(1821),
    [anon_sym_PLUS_PLUS] = ACTIONS(1821),
    [anon_sym_DASH_DASH] = ACTIONS(1821),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1819),
    [anon_sym_DASH] = ACTIONS(1819),
    [anon_sym_STAR] = ACTIONS(1823),
    [anon_sym_CARET] = ACTIONS(1821),
    [anon_sym_AMP] = ACTIONS(1821),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1825),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1827),
    [anon_sym_DOT_DOT] = ACTIONS(1829),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1522] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6881),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2964),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7109),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5876),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4326),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7394),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9186),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1522),
    [sym_preproc_endregion] = STATE(1522),
    [sym_preproc_line] = STATE(1522),
    [sym_preproc_pragma] = STATE(1522),
    [sym_preproc_nullable] = STATE(1522),
    [sym_preproc_error] = STATE(1522),
    [sym_preproc_define] = STATE(1522),
    [sym_preproc_undef] = STATE(1522),
    [aux_sym_class_declaration_repeat1] = STATE(3828),
    [aux_sym_lambda_expression_repeat1] = STATE(4180),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1813),
    [anon_sym_ref] = ACTIONS(1815),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1817),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1821),
    [anon_sym_TILDE] = ACTIONS(1821),
    [anon_sym_PLUS_PLUS] = ACTIONS(1821),
    [anon_sym_DASH_DASH] = ACTIONS(1821),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1819),
    [anon_sym_DASH] = ACTIONS(1819),
    [anon_sym_STAR] = ACTIONS(1823),
    [anon_sym_CARET] = ACTIONS(1821),
    [anon_sym_AMP] = ACTIONS(1821),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1825),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1827),
    [anon_sym_DOT_DOT] = ACTIONS(1829),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1523] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6881),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2964),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7109),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5877),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4326),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7394),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9186),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1523),
    [sym_preproc_endregion] = STATE(1523),
    [sym_preproc_line] = STATE(1523),
    [sym_preproc_pragma] = STATE(1523),
    [sym_preproc_nullable] = STATE(1523),
    [sym_preproc_error] = STATE(1523),
    [sym_preproc_define] = STATE(1523),
    [sym_preproc_undef] = STATE(1523),
    [aux_sym_class_declaration_repeat1] = STATE(3828),
    [aux_sym_lambda_expression_repeat1] = STATE(4180),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1813),
    [anon_sym_ref] = ACTIONS(1815),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1817),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1821),
    [anon_sym_TILDE] = ACTIONS(1821),
    [anon_sym_PLUS_PLUS] = ACTIONS(1821),
    [anon_sym_DASH_DASH] = ACTIONS(1821),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1819),
    [anon_sym_DASH] = ACTIONS(1819),
    [anon_sym_STAR] = ACTIONS(1823),
    [anon_sym_CARET] = ACTIONS(1821),
    [anon_sym_AMP] = ACTIONS(1821),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1825),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1827),
    [anon_sym_DOT_DOT] = ACTIONS(1829),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1524] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6881),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2964),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7109),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5878),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4326),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7394),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9186),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1524),
    [sym_preproc_endregion] = STATE(1524),
    [sym_preproc_line] = STATE(1524),
    [sym_preproc_pragma] = STATE(1524),
    [sym_preproc_nullable] = STATE(1524),
    [sym_preproc_error] = STATE(1524),
    [sym_preproc_define] = STATE(1524),
    [sym_preproc_undef] = STATE(1524),
    [aux_sym_class_declaration_repeat1] = STATE(3828),
    [aux_sym_lambda_expression_repeat1] = STATE(4180),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1813),
    [anon_sym_ref] = ACTIONS(1815),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1817),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1821),
    [anon_sym_TILDE] = ACTIONS(1821),
    [anon_sym_PLUS_PLUS] = ACTIONS(1821),
    [anon_sym_DASH_DASH] = ACTIONS(1821),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1819),
    [anon_sym_DASH] = ACTIONS(1819),
    [anon_sym_STAR] = ACTIONS(1823),
    [anon_sym_CARET] = ACTIONS(1821),
    [anon_sym_AMP] = ACTIONS(1821),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1825),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1827),
    [anon_sym_DOT_DOT] = ACTIONS(1829),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1525] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6881),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2964),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7109),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5879),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4326),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7394),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9186),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1525),
    [sym_preproc_endregion] = STATE(1525),
    [sym_preproc_line] = STATE(1525),
    [sym_preproc_pragma] = STATE(1525),
    [sym_preproc_nullable] = STATE(1525),
    [sym_preproc_error] = STATE(1525),
    [sym_preproc_define] = STATE(1525),
    [sym_preproc_undef] = STATE(1525),
    [aux_sym_class_declaration_repeat1] = STATE(3828),
    [aux_sym_lambda_expression_repeat1] = STATE(4180),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1813),
    [anon_sym_ref] = ACTIONS(1815),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1817),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1821),
    [anon_sym_TILDE] = ACTIONS(1821),
    [anon_sym_PLUS_PLUS] = ACTIONS(1821),
    [anon_sym_DASH_DASH] = ACTIONS(1821),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1819),
    [anon_sym_DASH] = ACTIONS(1819),
    [anon_sym_STAR] = ACTIONS(1823),
    [anon_sym_CARET] = ACTIONS(1821),
    [anon_sym_AMP] = ACTIONS(1821),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1825),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1827),
    [anon_sym_DOT_DOT] = ACTIONS(1829),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1526] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6887),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2935),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6959),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6109),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4399),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7410),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9332),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1526),
    [sym_preproc_endregion] = STATE(1526),
    [sym_preproc_line] = STATE(1526),
    [sym_preproc_pragma] = STATE(1526),
    [sym_preproc_nullable] = STATE(1526),
    [sym_preproc_error] = STATE(1526),
    [sym_preproc_define] = STATE(1526),
    [sym_preproc_undef] = STATE(1526),
    [aux_sym_class_declaration_repeat1] = STATE(3807),
    [aux_sym_lambda_expression_repeat1] = STATE(4128),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2115),
    [anon_sym_ref] = ACTIONS(2117),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2119),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(2123),
    [anon_sym_TILDE] = ACTIONS(2123),
    [anon_sym_PLUS_PLUS] = ACTIONS(2123),
    [anon_sym_DASH_DASH] = ACTIONS(2123),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2121),
    [anon_sym_DASH] = ACTIONS(2121),
    [anon_sym_STAR] = ACTIONS(2125),
    [anon_sym_CARET] = ACTIONS(2123),
    [anon_sym_AMP] = ACTIONS(2123),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2127),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2129),
    [anon_sym_DOT_DOT] = ACTIONS(2131),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1527] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7094),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5826),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1527),
    [sym_preproc_endregion] = STATE(1527),
    [sym_preproc_line] = STATE(1527),
    [sym_preproc_pragma] = STATE(1527),
    [sym_preproc_nullable] = STATE(1527),
    [sym_preproc_error] = STATE(1527),
    [sym_preproc_define] = STATE(1527),
    [sym_preproc_undef] = STATE(1527),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1669),
    [anon_sym_TILDE] = ACTIONS(1669),
    [anon_sym_PLUS_PLUS] = ACTIONS(1669),
    [anon_sym_DASH_DASH] = ACTIONS(1669),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1667),
    [anon_sym_DASH] = ACTIONS(1667),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1669),
    [anon_sym_AMP] = ACTIONS(1669),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1528] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6881),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2964),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7109),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5880),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4326),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7394),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9186),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1528),
    [sym_preproc_endregion] = STATE(1528),
    [sym_preproc_line] = STATE(1528),
    [sym_preproc_pragma] = STATE(1528),
    [sym_preproc_nullable] = STATE(1528),
    [sym_preproc_error] = STATE(1528),
    [sym_preproc_define] = STATE(1528),
    [sym_preproc_undef] = STATE(1528),
    [aux_sym_class_declaration_repeat1] = STATE(3828),
    [aux_sym_lambda_expression_repeat1] = STATE(4180),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1813),
    [anon_sym_ref] = ACTIONS(1815),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1817),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1821),
    [anon_sym_TILDE] = ACTIONS(1821),
    [anon_sym_PLUS_PLUS] = ACTIONS(1821),
    [anon_sym_DASH_DASH] = ACTIONS(1821),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1819),
    [anon_sym_DASH] = ACTIONS(1819),
    [anon_sym_STAR] = ACTIONS(1823),
    [anon_sym_CARET] = ACTIONS(1821),
    [anon_sym_AMP] = ACTIONS(1821),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1825),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1827),
    [anon_sym_DOT_DOT] = ACTIONS(1829),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1529] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6980),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6352),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4482),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9438),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1529),
    [sym_preproc_endregion] = STATE(1529),
    [sym_preproc_line] = STATE(1529),
    [sym_preproc_pragma] = STATE(1529),
    [sym_preproc_nullable] = STATE(1529),
    [sym_preproc_error] = STATE(1529),
    [sym_preproc_define] = STATE(1529),
    [sym_preproc_undef] = STATE(1529),
    [aux_sym_class_declaration_repeat1] = STATE(3801),
    [aux_sym_lambda_expression_repeat1] = STATE(4134),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1993),
    [anon_sym_ref] = ACTIONS(1995),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1999),
    [anon_sym_TILDE] = ACTIONS(1999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1999),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_AMP] = ACTIONS(1999),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1281),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1283),
    [anon_sym_DOT_DOT] = ACTIONS(1285),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1530] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6881),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2964),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7109),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(3922),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4326),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7394),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9186),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1530),
    [sym_preproc_endregion] = STATE(1530),
    [sym_preproc_line] = STATE(1530),
    [sym_preproc_pragma] = STATE(1530),
    [sym_preproc_nullable] = STATE(1530),
    [sym_preproc_error] = STATE(1530),
    [sym_preproc_define] = STATE(1530),
    [sym_preproc_undef] = STATE(1530),
    [aux_sym_class_declaration_repeat1] = STATE(3828),
    [aux_sym_lambda_expression_repeat1] = STATE(4180),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1813),
    [anon_sym_ref] = ACTIONS(1815),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1817),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1821),
    [anon_sym_TILDE] = ACTIONS(1821),
    [anon_sym_PLUS_PLUS] = ACTIONS(1821),
    [anon_sym_DASH_DASH] = ACTIONS(1821),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1819),
    [anon_sym_DASH] = ACTIONS(1819),
    [anon_sym_STAR] = ACTIONS(1823),
    [anon_sym_CARET] = ACTIONS(1821),
    [anon_sym_AMP] = ACTIONS(1821),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1825),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1827),
    [anon_sym_DOT_DOT] = ACTIONS(1829),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1531] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3921),
    [sym__name] = STATE(6919),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2868),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(7068),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5963),
    [sym_non_lvalue_expression] = STATE(5735),
    [sym_lvalue_expression] = STATE(4323),
    [sym__expression_statement_expression] = STATE(5733),
    [sym_assignment_expression] = STATE(5734),
    [sym_binary_expression] = STATE(5733),
    [sym_postfix_unary_expression] = STATE(5734),
    [sym_prefix_unary_expression] = STATE(5734),
    [sym__pointer_indirection_expression] = STATE(3911),
    [sym_query_expression] = STATE(5733),
    [sym_from_clause] = STATE(7393),
    [sym_conditional_expression] = STATE(5733),
    [sym_conditional_access_expression] = STATE(5733),
    [sym_as_expression] = STATE(5733),
    [sym_is_expression] = STATE(5733),
    [sym_is_pattern_expression] = STATE(5733),
    [sym_cast_expression] = STATE(5733),
    [sym_checked_expression] = STATE(5733),
    [sym_invocation_expression] = STATE(5734),
    [sym_switch_expression] = STATE(5733),
    [sym_await_expression] = STATE(5734),
    [sym_throw_expression] = STATE(5733),
    [sym_element_access_expression] = STATE(3911),
    [sym_interpolated_string_expression] = STATE(5733),
    [sym_member_access_expression] = STATE(3911),
    [sym_object_creation_expression] = STATE(5734),
    [sym_parenthesized_expression] = STATE(5734),
    [sym__parenthesized_lvalue_expression] = STATE(3911),
    [sym_lambda_expression] = STATE(5733),
    [sym__lambda_parameters] = STATE(9932),
    [sym_array_creation_expression] = STATE(5733),
    [sym_anonymous_method_expression] = STATE(5733),
    [sym_anonymous_object_creation_expression] = STATE(5733),
    [sym_implicit_array_creation_expression] = STATE(5733),
    [sym_implicit_object_creation_expression] = STATE(5733),
    [sym_implicit_stackalloc_expression] = STATE(5733),
    [sym_initializer_expression] = STATE(5733),
    [sym_default_expression] = STATE(5733),
    [sym_with_expression] = STATE(5733),
    [sym_sizeof_expression] = STATE(5733),
    [sym_typeof_expression] = STATE(5733),
    [sym_makeref_expression] = STATE(5733),
    [sym_ref_expression] = STATE(5733),
    [sym_reftype_expression] = STATE(5733),
    [sym_refvalue_expression] = STATE(5733),
    [sym_stackalloc_expression] = STATE(5733),
    [sym_range_expression] = STATE(5733),
    [sym_tuple_expression] = STATE(3911),
    [sym_literal] = STATE(5733),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2798),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(5733),
    [sym_preproc_region] = STATE(1531),
    [sym_preproc_endregion] = STATE(1531),
    [sym_preproc_line] = STATE(1531),
    [sym_preproc_pragma] = STATE(1531),
    [sym_preproc_nullable] = STATE(1531),
    [sym_preproc_error] = STATE(1531),
    [sym_preproc_define] = STATE(1531),
    [sym_preproc_undef] = STATE(1531),
    [aux_sym_class_declaration_repeat1] = STATE(3831),
    [aux_sym_lambda_expression_repeat1] = STATE(4227),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_LPAREN] = ACTIONS(1577),
    [anon_sym_ref] = ACTIONS(1579),
    [anon_sym_LBRACE] = ACTIONS(1377),
    [anon_sym_delegate] = ACTIONS(1379),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1381),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1583),
    [anon_sym_TILDE] = ACTIONS(1583),
    [anon_sym_PLUS_PLUS] = ACTIONS(1583),
    [anon_sym_DASH_DASH] = ACTIONS(1583),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1581),
    [anon_sym_DASH] = ACTIONS(1581),
    [anon_sym_STAR] = ACTIONS(1391),
    [anon_sym_CARET] = ACTIONS(1583),
    [anon_sym_AMP] = ACTIONS(1583),
    [anon_sym_this] = ACTIONS(1393),
    [anon_sym_scoped] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1397),
    [sym_predefined_type] = ACTIONS(1399),
    [anon_sym_unchecked] = ACTIONS(1383),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1585),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1587),
    [anon_sym_DOT_DOT] = ACTIONS(1589),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_stackalloc] = ACTIONS(1413),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(1419),
    [anon_sym___reftype] = ACTIONS(1421),
    [anon_sym___refvalue] = ACTIONS(1423),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
  },
  [1532] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6881),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2964),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7109),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5893),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4326),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7394),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9186),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1532),
    [sym_preproc_endregion] = STATE(1532),
    [sym_preproc_line] = STATE(1532),
    [sym_preproc_pragma] = STATE(1532),
    [sym_preproc_nullable] = STATE(1532),
    [sym_preproc_error] = STATE(1532),
    [sym_preproc_define] = STATE(1532),
    [sym_preproc_undef] = STATE(1532),
    [aux_sym_class_declaration_repeat1] = STATE(3828),
    [aux_sym_lambda_expression_repeat1] = STATE(4180),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1813),
    [anon_sym_ref] = ACTIONS(1815),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1817),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1821),
    [anon_sym_TILDE] = ACTIONS(1821),
    [anon_sym_PLUS_PLUS] = ACTIONS(1821),
    [anon_sym_DASH_DASH] = ACTIONS(1821),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1819),
    [anon_sym_DASH] = ACTIONS(1819),
    [anon_sym_STAR] = ACTIONS(1823),
    [anon_sym_CARET] = ACTIONS(1821),
    [anon_sym_AMP] = ACTIONS(1821),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1825),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1827),
    [anon_sym_DOT_DOT] = ACTIONS(1829),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1533] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7076),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6133),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4314),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9775),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1533),
    [sym_preproc_endregion] = STATE(1533),
    [sym_preproc_line] = STATE(1533),
    [sym_preproc_pragma] = STATE(1533),
    [sym_preproc_nullable] = STATE(1533),
    [sym_preproc_error] = STATE(1533),
    [sym_preproc_define] = STATE(1533),
    [sym_preproc_undef] = STATE(1533),
    [aux_sym_class_declaration_repeat1] = STATE(3835),
    [aux_sym_lambda_expression_repeat1] = STATE(4236),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1535),
    [anon_sym_ref] = ACTIONS(1537),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1465),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(885),
    [anon_sym_TILDE] = ACTIONS(885),
    [anon_sym_PLUS_PLUS] = ACTIONS(885),
    [anon_sym_DASH_DASH] = ACTIONS(885),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(887),
    [anon_sym_DASH] = ACTIONS(887),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(885),
    [anon_sym_AMP] = ACTIONS(885),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1539),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1541),
    [anon_sym_DOT_DOT] = ACTIONS(1543),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1534] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3921),
    [sym__name] = STATE(6919),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2868),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(7068),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5950),
    [sym_non_lvalue_expression] = STATE(5735),
    [sym_lvalue_expression] = STATE(4323),
    [sym__expression_statement_expression] = STATE(5733),
    [sym_assignment_expression] = STATE(5734),
    [sym_binary_expression] = STATE(5733),
    [sym_postfix_unary_expression] = STATE(5734),
    [sym_prefix_unary_expression] = STATE(5734),
    [sym__pointer_indirection_expression] = STATE(3911),
    [sym_query_expression] = STATE(5733),
    [sym_from_clause] = STATE(7393),
    [sym_conditional_expression] = STATE(5733),
    [sym_conditional_access_expression] = STATE(5733),
    [sym_as_expression] = STATE(5733),
    [sym_is_expression] = STATE(5733),
    [sym_is_pattern_expression] = STATE(5733),
    [sym_cast_expression] = STATE(5733),
    [sym_checked_expression] = STATE(5733),
    [sym_invocation_expression] = STATE(5734),
    [sym_switch_expression] = STATE(5733),
    [sym_await_expression] = STATE(5734),
    [sym_throw_expression] = STATE(5733),
    [sym_element_access_expression] = STATE(3911),
    [sym_interpolated_string_expression] = STATE(5733),
    [sym_member_access_expression] = STATE(3911),
    [sym_object_creation_expression] = STATE(5734),
    [sym_parenthesized_expression] = STATE(5734),
    [sym__parenthesized_lvalue_expression] = STATE(3911),
    [sym_lambda_expression] = STATE(5733),
    [sym__lambda_parameters] = STATE(9932),
    [sym_array_creation_expression] = STATE(5733),
    [sym_anonymous_method_expression] = STATE(5733),
    [sym_anonymous_object_creation_expression] = STATE(5733),
    [sym_implicit_array_creation_expression] = STATE(5733),
    [sym_implicit_object_creation_expression] = STATE(5733),
    [sym_implicit_stackalloc_expression] = STATE(5733),
    [sym_initializer_expression] = STATE(5733),
    [sym_default_expression] = STATE(5733),
    [sym_with_expression] = STATE(5733),
    [sym_sizeof_expression] = STATE(5733),
    [sym_typeof_expression] = STATE(5733),
    [sym_makeref_expression] = STATE(5733),
    [sym_ref_expression] = STATE(5733),
    [sym_reftype_expression] = STATE(5733),
    [sym_refvalue_expression] = STATE(5733),
    [sym_stackalloc_expression] = STATE(5733),
    [sym_range_expression] = STATE(5733),
    [sym_tuple_expression] = STATE(3911),
    [sym_literal] = STATE(5733),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2798),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(5733),
    [sym_preproc_region] = STATE(1534),
    [sym_preproc_endregion] = STATE(1534),
    [sym_preproc_line] = STATE(1534),
    [sym_preproc_pragma] = STATE(1534),
    [sym_preproc_nullable] = STATE(1534),
    [sym_preproc_error] = STATE(1534),
    [sym_preproc_define] = STATE(1534),
    [sym_preproc_undef] = STATE(1534),
    [aux_sym_class_declaration_repeat1] = STATE(3831),
    [aux_sym_lambda_expression_repeat1] = STATE(4227),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_LPAREN] = ACTIONS(1577),
    [anon_sym_ref] = ACTIONS(1579),
    [anon_sym_LBRACE] = ACTIONS(1377),
    [anon_sym_delegate] = ACTIONS(1379),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1381),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1583),
    [anon_sym_TILDE] = ACTIONS(1583),
    [anon_sym_PLUS_PLUS] = ACTIONS(1583),
    [anon_sym_DASH_DASH] = ACTIONS(1583),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1581),
    [anon_sym_DASH] = ACTIONS(1581),
    [anon_sym_STAR] = ACTIONS(1391),
    [anon_sym_CARET] = ACTIONS(1583),
    [anon_sym_AMP] = ACTIONS(1583),
    [anon_sym_this] = ACTIONS(1393),
    [anon_sym_scoped] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1397),
    [sym_predefined_type] = ACTIONS(1399),
    [anon_sym_unchecked] = ACTIONS(1383),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1585),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1587),
    [anon_sym_DOT_DOT] = ACTIONS(1589),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_stackalloc] = ACTIONS(1413),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(1419),
    [anon_sym___reftype] = ACTIONS(1421),
    [anon_sym___refvalue] = ACTIONS(1423),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
  },
  [1535] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6881),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2964),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7109),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(3901),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4326),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7394),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9186),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1535),
    [sym_preproc_endregion] = STATE(1535),
    [sym_preproc_line] = STATE(1535),
    [sym_preproc_pragma] = STATE(1535),
    [sym_preproc_nullable] = STATE(1535),
    [sym_preproc_error] = STATE(1535),
    [sym_preproc_define] = STATE(1535),
    [sym_preproc_undef] = STATE(1535),
    [aux_sym_class_declaration_repeat1] = STATE(3828),
    [aux_sym_lambda_expression_repeat1] = STATE(4180),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1813),
    [anon_sym_ref] = ACTIONS(1815),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1817),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1821),
    [anon_sym_TILDE] = ACTIONS(1821),
    [anon_sym_PLUS_PLUS] = ACTIONS(1821),
    [anon_sym_DASH_DASH] = ACTIONS(1821),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1819),
    [anon_sym_DASH] = ACTIONS(1819),
    [anon_sym_STAR] = ACTIONS(1823),
    [anon_sym_CARET] = ACTIONS(1821),
    [anon_sym_AMP] = ACTIONS(1821),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1825),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1827),
    [anon_sym_DOT_DOT] = ACTIONS(1829),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1536] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3921),
    [sym__name] = STATE(6919),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2868),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(7068),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5960),
    [sym_non_lvalue_expression] = STATE(5735),
    [sym_lvalue_expression] = STATE(4323),
    [sym__expression_statement_expression] = STATE(5733),
    [sym_assignment_expression] = STATE(5734),
    [sym_binary_expression] = STATE(5733),
    [sym_postfix_unary_expression] = STATE(5734),
    [sym_prefix_unary_expression] = STATE(5734),
    [sym__pointer_indirection_expression] = STATE(3911),
    [sym_query_expression] = STATE(5733),
    [sym_from_clause] = STATE(7393),
    [sym_conditional_expression] = STATE(5733),
    [sym_conditional_access_expression] = STATE(5733),
    [sym_as_expression] = STATE(5733),
    [sym_is_expression] = STATE(5733),
    [sym_is_pattern_expression] = STATE(5733),
    [sym_cast_expression] = STATE(5733),
    [sym_checked_expression] = STATE(5733),
    [sym_invocation_expression] = STATE(5734),
    [sym_switch_expression] = STATE(5733),
    [sym_await_expression] = STATE(5734),
    [sym_throw_expression] = STATE(5733),
    [sym_element_access_expression] = STATE(3911),
    [sym_interpolated_string_expression] = STATE(5733),
    [sym_member_access_expression] = STATE(3911),
    [sym_object_creation_expression] = STATE(5734),
    [sym_parenthesized_expression] = STATE(5734),
    [sym__parenthesized_lvalue_expression] = STATE(3911),
    [sym_lambda_expression] = STATE(5733),
    [sym__lambda_parameters] = STATE(9932),
    [sym_array_creation_expression] = STATE(5733),
    [sym_anonymous_method_expression] = STATE(5733),
    [sym_anonymous_object_creation_expression] = STATE(5733),
    [sym_implicit_array_creation_expression] = STATE(5733),
    [sym_implicit_object_creation_expression] = STATE(5733),
    [sym_implicit_stackalloc_expression] = STATE(5733),
    [sym_initializer_expression] = STATE(5733),
    [sym_default_expression] = STATE(5733),
    [sym_with_expression] = STATE(5733),
    [sym_sizeof_expression] = STATE(5733),
    [sym_typeof_expression] = STATE(5733),
    [sym_makeref_expression] = STATE(5733),
    [sym_ref_expression] = STATE(5733),
    [sym_reftype_expression] = STATE(5733),
    [sym_refvalue_expression] = STATE(5733),
    [sym_stackalloc_expression] = STATE(5733),
    [sym_range_expression] = STATE(5733),
    [sym_tuple_expression] = STATE(3911),
    [sym_literal] = STATE(5733),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2798),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(5733),
    [sym_preproc_region] = STATE(1536),
    [sym_preproc_endregion] = STATE(1536),
    [sym_preproc_line] = STATE(1536),
    [sym_preproc_pragma] = STATE(1536),
    [sym_preproc_nullable] = STATE(1536),
    [sym_preproc_error] = STATE(1536),
    [sym_preproc_define] = STATE(1536),
    [sym_preproc_undef] = STATE(1536),
    [aux_sym_class_declaration_repeat1] = STATE(3831),
    [aux_sym_lambda_expression_repeat1] = STATE(4227),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_LPAREN] = ACTIONS(1577),
    [anon_sym_ref] = ACTIONS(1579),
    [anon_sym_LBRACE] = ACTIONS(1377),
    [anon_sym_delegate] = ACTIONS(1379),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1381),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1583),
    [anon_sym_TILDE] = ACTIONS(1583),
    [anon_sym_PLUS_PLUS] = ACTIONS(1583),
    [anon_sym_DASH_DASH] = ACTIONS(1583),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1581),
    [anon_sym_DASH] = ACTIONS(1581),
    [anon_sym_STAR] = ACTIONS(1391),
    [anon_sym_CARET] = ACTIONS(1583),
    [anon_sym_AMP] = ACTIONS(1583),
    [anon_sym_this] = ACTIONS(1393),
    [anon_sym_scoped] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1397),
    [sym_predefined_type] = ACTIONS(1399),
    [anon_sym_unchecked] = ACTIONS(1383),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1585),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1587),
    [anon_sym_DOT_DOT] = ACTIONS(1589),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_stackalloc] = ACTIONS(1413),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(1419),
    [anon_sym___reftype] = ACTIONS(1421),
    [anon_sym___refvalue] = ACTIONS(1423),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
  },
  [1537] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3921),
    [sym__name] = STATE(6919),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2868),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(7068),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5959),
    [sym_non_lvalue_expression] = STATE(5735),
    [sym_lvalue_expression] = STATE(4323),
    [sym__expression_statement_expression] = STATE(5733),
    [sym_assignment_expression] = STATE(5734),
    [sym_binary_expression] = STATE(5733),
    [sym_postfix_unary_expression] = STATE(5734),
    [sym_prefix_unary_expression] = STATE(5734),
    [sym__pointer_indirection_expression] = STATE(3911),
    [sym_query_expression] = STATE(5733),
    [sym_from_clause] = STATE(7393),
    [sym_conditional_expression] = STATE(5733),
    [sym_conditional_access_expression] = STATE(5733),
    [sym_as_expression] = STATE(5733),
    [sym_is_expression] = STATE(5733),
    [sym_is_pattern_expression] = STATE(5733),
    [sym_cast_expression] = STATE(5733),
    [sym_checked_expression] = STATE(5733),
    [sym_invocation_expression] = STATE(5734),
    [sym_switch_expression] = STATE(5733),
    [sym_await_expression] = STATE(5734),
    [sym_throw_expression] = STATE(5733),
    [sym_element_access_expression] = STATE(3911),
    [sym_interpolated_string_expression] = STATE(5733),
    [sym_member_access_expression] = STATE(3911),
    [sym_object_creation_expression] = STATE(5734),
    [sym_parenthesized_expression] = STATE(5734),
    [sym__parenthesized_lvalue_expression] = STATE(3911),
    [sym_lambda_expression] = STATE(5733),
    [sym__lambda_parameters] = STATE(9932),
    [sym_array_creation_expression] = STATE(5733),
    [sym_anonymous_method_expression] = STATE(5733),
    [sym_anonymous_object_creation_expression] = STATE(5733),
    [sym_implicit_array_creation_expression] = STATE(5733),
    [sym_implicit_object_creation_expression] = STATE(5733),
    [sym_implicit_stackalloc_expression] = STATE(5733),
    [sym_initializer_expression] = STATE(5733),
    [sym_default_expression] = STATE(5733),
    [sym_with_expression] = STATE(5733),
    [sym_sizeof_expression] = STATE(5733),
    [sym_typeof_expression] = STATE(5733),
    [sym_makeref_expression] = STATE(5733),
    [sym_ref_expression] = STATE(5733),
    [sym_reftype_expression] = STATE(5733),
    [sym_refvalue_expression] = STATE(5733),
    [sym_stackalloc_expression] = STATE(5733),
    [sym_range_expression] = STATE(5733),
    [sym_tuple_expression] = STATE(3911),
    [sym_literal] = STATE(5733),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2798),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(5733),
    [sym_preproc_region] = STATE(1537),
    [sym_preproc_endregion] = STATE(1537),
    [sym_preproc_line] = STATE(1537),
    [sym_preproc_pragma] = STATE(1537),
    [sym_preproc_nullable] = STATE(1537),
    [sym_preproc_error] = STATE(1537),
    [sym_preproc_define] = STATE(1537),
    [sym_preproc_undef] = STATE(1537),
    [aux_sym_class_declaration_repeat1] = STATE(3831),
    [aux_sym_lambda_expression_repeat1] = STATE(4227),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_LPAREN] = ACTIONS(1577),
    [anon_sym_ref] = ACTIONS(1579),
    [anon_sym_LBRACE] = ACTIONS(1377),
    [anon_sym_delegate] = ACTIONS(1379),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1381),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1583),
    [anon_sym_TILDE] = ACTIONS(1583),
    [anon_sym_PLUS_PLUS] = ACTIONS(1583),
    [anon_sym_DASH_DASH] = ACTIONS(1583),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1581),
    [anon_sym_DASH] = ACTIONS(1581),
    [anon_sym_STAR] = ACTIONS(1391),
    [anon_sym_CARET] = ACTIONS(1583),
    [anon_sym_AMP] = ACTIONS(1583),
    [anon_sym_this] = ACTIONS(1393),
    [anon_sym_scoped] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1397),
    [sym_predefined_type] = ACTIONS(1399),
    [anon_sym_unchecked] = ACTIONS(1383),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1585),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1587),
    [anon_sym_DOT_DOT] = ACTIONS(1589),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_stackalloc] = ACTIONS(1413),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(1419),
    [anon_sym___reftype] = ACTIONS(1421),
    [anon_sym___refvalue] = ACTIONS(1423),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
  },
  [1538] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6880),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7055),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5858),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4312),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7380),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9286),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1538),
    [sym_preproc_endregion] = STATE(1538),
    [sym_preproc_line] = STATE(1538),
    [sym_preproc_pragma] = STATE(1538),
    [sym_preproc_nullable] = STATE(1538),
    [sym_preproc_error] = STATE(1538),
    [sym_preproc_define] = STATE(1538),
    [sym_preproc_undef] = STATE(1538),
    [aux_sym_class_declaration_repeat1] = STATE(3799),
    [aux_sym_lambda_expression_repeat1] = STATE(4101),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1545),
    [anon_sym_ref] = ACTIONS(1547),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1551),
    [anon_sym_TILDE] = ACTIONS(1551),
    [anon_sym_PLUS_PLUS] = ACTIONS(1551),
    [anon_sym_DASH_DASH] = ACTIONS(1551),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1549),
    [anon_sym_DASH] = ACTIONS(1549),
    [anon_sym_STAR] = ACTIONS(1553),
    [anon_sym_CARET] = ACTIONS(1551),
    [anon_sym_AMP] = ACTIONS(1551),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1555),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1557),
    [anon_sym_DOT_DOT] = ACTIONS(1559),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1539] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3921),
    [sym__name] = STATE(6919),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2868),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(7068),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5958),
    [sym_non_lvalue_expression] = STATE(5735),
    [sym_lvalue_expression] = STATE(4323),
    [sym__expression_statement_expression] = STATE(5733),
    [sym_assignment_expression] = STATE(5734),
    [sym_binary_expression] = STATE(5733),
    [sym_postfix_unary_expression] = STATE(5734),
    [sym_prefix_unary_expression] = STATE(5734),
    [sym__pointer_indirection_expression] = STATE(3911),
    [sym_query_expression] = STATE(5733),
    [sym_from_clause] = STATE(7393),
    [sym_conditional_expression] = STATE(5733),
    [sym_conditional_access_expression] = STATE(5733),
    [sym_as_expression] = STATE(5733),
    [sym_is_expression] = STATE(5733),
    [sym_is_pattern_expression] = STATE(5733),
    [sym_cast_expression] = STATE(5733),
    [sym_checked_expression] = STATE(5733),
    [sym_invocation_expression] = STATE(5734),
    [sym_switch_expression] = STATE(5733),
    [sym_await_expression] = STATE(5734),
    [sym_throw_expression] = STATE(5733),
    [sym_element_access_expression] = STATE(3911),
    [sym_interpolated_string_expression] = STATE(5733),
    [sym_member_access_expression] = STATE(3911),
    [sym_object_creation_expression] = STATE(5734),
    [sym_parenthesized_expression] = STATE(5734),
    [sym__parenthesized_lvalue_expression] = STATE(3911),
    [sym_lambda_expression] = STATE(5733),
    [sym__lambda_parameters] = STATE(9932),
    [sym_array_creation_expression] = STATE(5733),
    [sym_anonymous_method_expression] = STATE(5733),
    [sym_anonymous_object_creation_expression] = STATE(5733),
    [sym_implicit_array_creation_expression] = STATE(5733),
    [sym_implicit_object_creation_expression] = STATE(5733),
    [sym_implicit_stackalloc_expression] = STATE(5733),
    [sym_initializer_expression] = STATE(5733),
    [sym_default_expression] = STATE(5733),
    [sym_with_expression] = STATE(5733),
    [sym_sizeof_expression] = STATE(5733),
    [sym_typeof_expression] = STATE(5733),
    [sym_makeref_expression] = STATE(5733),
    [sym_ref_expression] = STATE(5733),
    [sym_reftype_expression] = STATE(5733),
    [sym_refvalue_expression] = STATE(5733),
    [sym_stackalloc_expression] = STATE(5733),
    [sym_range_expression] = STATE(5733),
    [sym_tuple_expression] = STATE(3911),
    [sym_literal] = STATE(5733),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2798),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(5733),
    [sym_preproc_region] = STATE(1539),
    [sym_preproc_endregion] = STATE(1539),
    [sym_preproc_line] = STATE(1539),
    [sym_preproc_pragma] = STATE(1539),
    [sym_preproc_nullable] = STATE(1539),
    [sym_preproc_error] = STATE(1539),
    [sym_preproc_define] = STATE(1539),
    [sym_preproc_undef] = STATE(1539),
    [aux_sym_class_declaration_repeat1] = STATE(3831),
    [aux_sym_lambda_expression_repeat1] = STATE(4227),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_LPAREN] = ACTIONS(1577),
    [anon_sym_ref] = ACTIONS(1579),
    [anon_sym_LBRACE] = ACTIONS(1377),
    [anon_sym_delegate] = ACTIONS(1379),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1381),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1583),
    [anon_sym_TILDE] = ACTIONS(1583),
    [anon_sym_PLUS_PLUS] = ACTIONS(1583),
    [anon_sym_DASH_DASH] = ACTIONS(1583),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1581),
    [anon_sym_DASH] = ACTIONS(1581),
    [anon_sym_STAR] = ACTIONS(1391),
    [anon_sym_CARET] = ACTIONS(1583),
    [anon_sym_AMP] = ACTIONS(1583),
    [anon_sym_this] = ACTIONS(1393),
    [anon_sym_scoped] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1397),
    [sym_predefined_type] = ACTIONS(1399),
    [anon_sym_unchecked] = ACTIONS(1383),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1585),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1587),
    [anon_sym_DOT_DOT] = ACTIONS(1589),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_stackalloc] = ACTIONS(1413),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(1419),
    [anon_sym___reftype] = ACTIONS(1421),
    [anon_sym___refvalue] = ACTIONS(1423),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
  },
  [1540] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6961),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6452),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9849),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1540),
    [sym_preproc_endregion] = STATE(1540),
    [sym_preproc_line] = STATE(1540),
    [sym_preproc_pragma] = STATE(1540),
    [sym_preproc_nullable] = STATE(1540),
    [sym_preproc_error] = STATE(1540),
    [sym_preproc_define] = STATE(1540),
    [sym_preproc_undef] = STATE(1540),
    [aux_sym_class_declaration_repeat1] = STATE(3841),
    [aux_sym_lambda_expression_repeat1] = STATE(4283),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1459),
    [anon_sym_ref] = ACTIONS(1461),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1465),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1467),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1469),
    [anon_sym_DOT_DOT] = ACTIONS(1471),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1541] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6894),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2955),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7025),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4882),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(3735),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7397),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9590),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1541),
    [sym_preproc_endregion] = STATE(1541),
    [sym_preproc_line] = STATE(1541),
    [sym_preproc_pragma] = STATE(1541),
    [sym_preproc_nullable] = STATE(1541),
    [sym_preproc_error] = STATE(1541),
    [sym_preproc_define] = STATE(1541),
    [sym_preproc_undef] = STATE(1541),
    [aux_sym_class_declaration_repeat1] = STATE(3844),
    [aux_sym_lambda_expression_repeat1] = STATE(4245),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1849),
    [anon_sym_ref] = ACTIONS(1851),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1853),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1857),
    [anon_sym_TILDE] = ACTIONS(1857),
    [anon_sym_PLUS_PLUS] = ACTIONS(1857),
    [anon_sym_DASH_DASH] = ACTIONS(1857),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1855),
    [anon_sym_DASH] = ACTIONS(1855),
    [anon_sym_STAR] = ACTIONS(1859),
    [anon_sym_CARET] = ACTIONS(1857),
    [anon_sym_AMP] = ACTIONS(1857),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1861),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1863),
    [anon_sym_DOT_DOT] = ACTIONS(1865),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1542] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6881),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2964),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7109),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5897),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4326),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7394),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9186),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1542),
    [sym_preproc_endregion] = STATE(1542),
    [sym_preproc_line] = STATE(1542),
    [sym_preproc_pragma] = STATE(1542),
    [sym_preproc_nullable] = STATE(1542),
    [sym_preproc_error] = STATE(1542),
    [sym_preproc_define] = STATE(1542),
    [sym_preproc_undef] = STATE(1542),
    [aux_sym_class_declaration_repeat1] = STATE(3828),
    [aux_sym_lambda_expression_repeat1] = STATE(4180),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1813),
    [anon_sym_ref] = ACTIONS(1815),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1817),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1821),
    [anon_sym_TILDE] = ACTIONS(1821),
    [anon_sym_PLUS_PLUS] = ACTIONS(1821),
    [anon_sym_DASH_DASH] = ACTIONS(1821),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1819),
    [anon_sym_DASH] = ACTIONS(1819),
    [anon_sym_STAR] = ACTIONS(1823),
    [anon_sym_CARET] = ACTIONS(1821),
    [anon_sym_AMP] = ACTIONS(1821),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1825),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1827),
    [anon_sym_DOT_DOT] = ACTIONS(1829),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1543] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6881),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2964),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7109),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5919),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4326),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7394),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9186),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1543),
    [sym_preproc_endregion] = STATE(1543),
    [sym_preproc_line] = STATE(1543),
    [sym_preproc_pragma] = STATE(1543),
    [sym_preproc_nullable] = STATE(1543),
    [sym_preproc_error] = STATE(1543),
    [sym_preproc_define] = STATE(1543),
    [sym_preproc_undef] = STATE(1543),
    [aux_sym_class_declaration_repeat1] = STATE(3828),
    [aux_sym_lambda_expression_repeat1] = STATE(4180),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1813),
    [anon_sym_ref] = ACTIONS(1815),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1817),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1821),
    [anon_sym_TILDE] = ACTIONS(1821),
    [anon_sym_PLUS_PLUS] = ACTIONS(1821),
    [anon_sym_DASH_DASH] = ACTIONS(1821),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1819),
    [anon_sym_DASH] = ACTIONS(1819),
    [anon_sym_STAR] = ACTIONS(1823),
    [anon_sym_CARET] = ACTIONS(1821),
    [anon_sym_AMP] = ACTIONS(1821),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1825),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1827),
    [anon_sym_DOT_DOT] = ACTIONS(1829),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1544] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6980),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4309),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4482),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9438),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1544),
    [sym_preproc_endregion] = STATE(1544),
    [sym_preproc_line] = STATE(1544),
    [sym_preproc_pragma] = STATE(1544),
    [sym_preproc_nullable] = STATE(1544),
    [sym_preproc_error] = STATE(1544),
    [sym_preproc_define] = STATE(1544),
    [sym_preproc_undef] = STATE(1544),
    [aux_sym_class_declaration_repeat1] = STATE(3801),
    [aux_sym_lambda_expression_repeat1] = STATE(4134),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1993),
    [anon_sym_ref] = ACTIONS(1995),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1999),
    [anon_sym_TILDE] = ACTIONS(1999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1999),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_AMP] = ACTIONS(1999),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1281),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1283),
    [anon_sym_DOT_DOT] = ACTIONS(1285),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1545] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3921),
    [sym__name] = STATE(6919),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2868),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(7068),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5957),
    [sym_non_lvalue_expression] = STATE(5735),
    [sym_lvalue_expression] = STATE(4323),
    [sym__expression_statement_expression] = STATE(5733),
    [sym_assignment_expression] = STATE(5734),
    [sym_binary_expression] = STATE(5733),
    [sym_postfix_unary_expression] = STATE(5734),
    [sym_prefix_unary_expression] = STATE(5734),
    [sym__pointer_indirection_expression] = STATE(3911),
    [sym_query_expression] = STATE(5733),
    [sym_from_clause] = STATE(7393),
    [sym_conditional_expression] = STATE(5733),
    [sym_conditional_access_expression] = STATE(5733),
    [sym_as_expression] = STATE(5733),
    [sym_is_expression] = STATE(5733),
    [sym_is_pattern_expression] = STATE(5733),
    [sym_cast_expression] = STATE(5733),
    [sym_checked_expression] = STATE(5733),
    [sym_invocation_expression] = STATE(5734),
    [sym_switch_expression] = STATE(5733),
    [sym_await_expression] = STATE(5734),
    [sym_throw_expression] = STATE(5733),
    [sym_element_access_expression] = STATE(3911),
    [sym_interpolated_string_expression] = STATE(5733),
    [sym_member_access_expression] = STATE(3911),
    [sym_object_creation_expression] = STATE(5734),
    [sym_parenthesized_expression] = STATE(5734),
    [sym__parenthesized_lvalue_expression] = STATE(3911),
    [sym_lambda_expression] = STATE(5733),
    [sym__lambda_parameters] = STATE(9932),
    [sym_array_creation_expression] = STATE(5733),
    [sym_anonymous_method_expression] = STATE(5733),
    [sym_anonymous_object_creation_expression] = STATE(5733),
    [sym_implicit_array_creation_expression] = STATE(5733),
    [sym_implicit_object_creation_expression] = STATE(5733),
    [sym_implicit_stackalloc_expression] = STATE(5733),
    [sym_initializer_expression] = STATE(5733),
    [sym_default_expression] = STATE(5733),
    [sym_with_expression] = STATE(5733),
    [sym_sizeof_expression] = STATE(5733),
    [sym_typeof_expression] = STATE(5733),
    [sym_makeref_expression] = STATE(5733),
    [sym_ref_expression] = STATE(5733),
    [sym_reftype_expression] = STATE(5733),
    [sym_refvalue_expression] = STATE(5733),
    [sym_stackalloc_expression] = STATE(5733),
    [sym_range_expression] = STATE(5733),
    [sym_tuple_expression] = STATE(3911),
    [sym_literal] = STATE(5733),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2798),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(5733),
    [sym_preproc_region] = STATE(1545),
    [sym_preproc_endregion] = STATE(1545),
    [sym_preproc_line] = STATE(1545),
    [sym_preproc_pragma] = STATE(1545),
    [sym_preproc_nullable] = STATE(1545),
    [sym_preproc_error] = STATE(1545),
    [sym_preproc_define] = STATE(1545),
    [sym_preproc_undef] = STATE(1545),
    [aux_sym_class_declaration_repeat1] = STATE(3831),
    [aux_sym_lambda_expression_repeat1] = STATE(4227),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_LPAREN] = ACTIONS(1577),
    [anon_sym_ref] = ACTIONS(1579),
    [anon_sym_LBRACE] = ACTIONS(1377),
    [anon_sym_delegate] = ACTIONS(1379),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1381),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1583),
    [anon_sym_TILDE] = ACTIONS(1583),
    [anon_sym_PLUS_PLUS] = ACTIONS(1583),
    [anon_sym_DASH_DASH] = ACTIONS(1583),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1581),
    [anon_sym_DASH] = ACTIONS(1581),
    [anon_sym_STAR] = ACTIONS(1391),
    [anon_sym_CARET] = ACTIONS(1583),
    [anon_sym_AMP] = ACTIONS(1583),
    [anon_sym_this] = ACTIONS(1393),
    [anon_sym_scoped] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1397),
    [sym_predefined_type] = ACTIONS(1399),
    [anon_sym_unchecked] = ACTIONS(1383),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1585),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1587),
    [anon_sym_DOT_DOT] = ACTIONS(1589),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_stackalloc] = ACTIONS(1413),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(1419),
    [anon_sym___reftype] = ACTIONS(1421),
    [anon_sym___refvalue] = ACTIONS(1423),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
  },
  [1546] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7076),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6130),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4314),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9775),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1546),
    [sym_preproc_endregion] = STATE(1546),
    [sym_preproc_line] = STATE(1546),
    [sym_preproc_pragma] = STATE(1546),
    [sym_preproc_nullable] = STATE(1546),
    [sym_preproc_error] = STATE(1546),
    [sym_preproc_define] = STATE(1546),
    [sym_preproc_undef] = STATE(1546),
    [aux_sym_class_declaration_repeat1] = STATE(3835),
    [aux_sym_lambda_expression_repeat1] = STATE(4236),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1535),
    [anon_sym_ref] = ACTIONS(1537),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1465),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(885),
    [anon_sym_TILDE] = ACTIONS(885),
    [anon_sym_PLUS_PLUS] = ACTIONS(885),
    [anon_sym_DASH_DASH] = ACTIONS(885),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(887),
    [anon_sym_DASH] = ACTIONS(887),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(885),
    [anon_sym_AMP] = ACTIONS(885),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1539),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1541),
    [anon_sym_DOT_DOT] = ACTIONS(1543),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1547] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6887),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2935),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6959),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6126),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4399),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7410),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9332),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1547),
    [sym_preproc_endregion] = STATE(1547),
    [sym_preproc_line] = STATE(1547),
    [sym_preproc_pragma] = STATE(1547),
    [sym_preproc_nullable] = STATE(1547),
    [sym_preproc_error] = STATE(1547),
    [sym_preproc_define] = STATE(1547),
    [sym_preproc_undef] = STATE(1547),
    [aux_sym_class_declaration_repeat1] = STATE(3807),
    [aux_sym_lambda_expression_repeat1] = STATE(4128),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2115),
    [anon_sym_ref] = ACTIONS(2117),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2119),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(2123),
    [anon_sym_TILDE] = ACTIONS(2123),
    [anon_sym_PLUS_PLUS] = ACTIONS(2123),
    [anon_sym_DASH_DASH] = ACTIONS(2123),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2121),
    [anon_sym_DASH] = ACTIONS(2121),
    [anon_sym_STAR] = ACTIONS(2125),
    [anon_sym_CARET] = ACTIONS(2123),
    [anon_sym_AMP] = ACTIONS(2123),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2127),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2129),
    [anon_sym_DOT_DOT] = ACTIONS(2131),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1548] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3921),
    [sym__name] = STATE(6919),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2868),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(7068),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5956),
    [sym_non_lvalue_expression] = STATE(5735),
    [sym_lvalue_expression] = STATE(4323),
    [sym__expression_statement_expression] = STATE(5733),
    [sym_assignment_expression] = STATE(5734),
    [sym_binary_expression] = STATE(5733),
    [sym_postfix_unary_expression] = STATE(5734),
    [sym_prefix_unary_expression] = STATE(5734),
    [sym__pointer_indirection_expression] = STATE(3911),
    [sym_query_expression] = STATE(5733),
    [sym_from_clause] = STATE(7393),
    [sym_conditional_expression] = STATE(5733),
    [sym_conditional_access_expression] = STATE(5733),
    [sym_as_expression] = STATE(5733),
    [sym_is_expression] = STATE(5733),
    [sym_is_pattern_expression] = STATE(5733),
    [sym_cast_expression] = STATE(5733),
    [sym_checked_expression] = STATE(5733),
    [sym_invocation_expression] = STATE(5734),
    [sym_switch_expression] = STATE(5733),
    [sym_await_expression] = STATE(5734),
    [sym_throw_expression] = STATE(5733),
    [sym_element_access_expression] = STATE(3911),
    [sym_interpolated_string_expression] = STATE(5733),
    [sym_member_access_expression] = STATE(3911),
    [sym_object_creation_expression] = STATE(5734),
    [sym_parenthesized_expression] = STATE(5734),
    [sym__parenthesized_lvalue_expression] = STATE(3911),
    [sym_lambda_expression] = STATE(5733),
    [sym__lambda_parameters] = STATE(9932),
    [sym_array_creation_expression] = STATE(5733),
    [sym_anonymous_method_expression] = STATE(5733),
    [sym_anonymous_object_creation_expression] = STATE(5733),
    [sym_implicit_array_creation_expression] = STATE(5733),
    [sym_implicit_object_creation_expression] = STATE(5733),
    [sym_implicit_stackalloc_expression] = STATE(5733),
    [sym_initializer_expression] = STATE(5733),
    [sym_default_expression] = STATE(5733),
    [sym_with_expression] = STATE(5733),
    [sym_sizeof_expression] = STATE(5733),
    [sym_typeof_expression] = STATE(5733),
    [sym_makeref_expression] = STATE(5733),
    [sym_ref_expression] = STATE(5733),
    [sym_reftype_expression] = STATE(5733),
    [sym_refvalue_expression] = STATE(5733),
    [sym_stackalloc_expression] = STATE(5733),
    [sym_range_expression] = STATE(5733),
    [sym_tuple_expression] = STATE(3911),
    [sym_literal] = STATE(5733),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2798),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(5733),
    [sym_preproc_region] = STATE(1548),
    [sym_preproc_endregion] = STATE(1548),
    [sym_preproc_line] = STATE(1548),
    [sym_preproc_pragma] = STATE(1548),
    [sym_preproc_nullable] = STATE(1548),
    [sym_preproc_error] = STATE(1548),
    [sym_preproc_define] = STATE(1548),
    [sym_preproc_undef] = STATE(1548),
    [aux_sym_class_declaration_repeat1] = STATE(3831),
    [aux_sym_lambda_expression_repeat1] = STATE(4227),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_LPAREN] = ACTIONS(1577),
    [anon_sym_ref] = ACTIONS(1579),
    [anon_sym_LBRACE] = ACTIONS(1377),
    [anon_sym_delegate] = ACTIONS(1379),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1381),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1583),
    [anon_sym_TILDE] = ACTIONS(1583),
    [anon_sym_PLUS_PLUS] = ACTIONS(1583),
    [anon_sym_DASH_DASH] = ACTIONS(1583),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1581),
    [anon_sym_DASH] = ACTIONS(1581),
    [anon_sym_STAR] = ACTIONS(1391),
    [anon_sym_CARET] = ACTIONS(1583),
    [anon_sym_AMP] = ACTIONS(1583),
    [anon_sym_this] = ACTIONS(1393),
    [anon_sym_scoped] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1397),
    [sym_predefined_type] = ACTIONS(1399),
    [anon_sym_unchecked] = ACTIONS(1383),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1585),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1587),
    [anon_sym_DOT_DOT] = ACTIONS(1589),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_stackalloc] = ACTIONS(1413),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(1419),
    [anon_sym___reftype] = ACTIONS(1421),
    [anon_sym___refvalue] = ACTIONS(1423),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
  },
  [1549] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6980),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6548),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4482),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9438),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1549),
    [sym_preproc_endregion] = STATE(1549),
    [sym_preproc_line] = STATE(1549),
    [sym_preproc_pragma] = STATE(1549),
    [sym_preproc_nullable] = STATE(1549),
    [sym_preproc_error] = STATE(1549),
    [sym_preproc_define] = STATE(1549),
    [sym_preproc_undef] = STATE(1549),
    [aux_sym_class_declaration_repeat1] = STATE(3801),
    [aux_sym_lambda_expression_repeat1] = STATE(4134),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1993),
    [anon_sym_ref] = ACTIONS(1995),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1999),
    [anon_sym_TILDE] = ACTIONS(1999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1999),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_AMP] = ACTIONS(1999),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1281),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1283),
    [anon_sym_DOT_DOT] = ACTIONS(1285),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1550] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7027),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5990),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4329),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7402),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9167),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1550),
    [sym_preproc_endregion] = STATE(1550),
    [sym_preproc_line] = STATE(1550),
    [sym_preproc_pragma] = STATE(1550),
    [sym_preproc_nullable] = STATE(1550),
    [sym_preproc_error] = STATE(1550),
    [sym_preproc_define] = STATE(1550),
    [sym_preproc_undef] = STATE(1550),
    [aux_sym_class_declaration_repeat1] = STATE(3794),
    [aux_sym_lambda_expression_repeat1] = STATE(4293),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1693),
    [anon_sym_ref] = ACTIONS(1695),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1699),
    [anon_sym_TILDE] = ACTIONS(1699),
    [anon_sym_PLUS_PLUS] = ACTIONS(1699),
    [anon_sym_DASH_DASH] = ACTIONS(1699),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1697),
    [anon_sym_DASH] = ACTIONS(1697),
    [anon_sym_STAR] = ACTIONS(1701),
    [anon_sym_CARET] = ACTIONS(1699),
    [anon_sym_AMP] = ACTIONS(1699),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1703),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1705),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1551] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6980),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6573),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4482),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9438),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1551),
    [sym_preproc_endregion] = STATE(1551),
    [sym_preproc_line] = STATE(1551),
    [sym_preproc_pragma] = STATE(1551),
    [sym_preproc_nullable] = STATE(1551),
    [sym_preproc_error] = STATE(1551),
    [sym_preproc_define] = STATE(1551),
    [sym_preproc_undef] = STATE(1551),
    [aux_sym_class_declaration_repeat1] = STATE(3801),
    [aux_sym_lambda_expression_repeat1] = STATE(4134),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1993),
    [anon_sym_ref] = ACTIONS(1995),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1999),
    [anon_sym_TILDE] = ACTIONS(1999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1999),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_AMP] = ACTIONS(1999),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1281),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1283),
    [anon_sym_DOT_DOT] = ACTIONS(1285),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1552] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6980),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6575),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4482),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9438),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1552),
    [sym_preproc_endregion] = STATE(1552),
    [sym_preproc_line] = STATE(1552),
    [sym_preproc_pragma] = STATE(1552),
    [sym_preproc_nullable] = STATE(1552),
    [sym_preproc_error] = STATE(1552),
    [sym_preproc_define] = STATE(1552),
    [sym_preproc_undef] = STATE(1552),
    [aux_sym_class_declaration_repeat1] = STATE(3801),
    [aux_sym_lambda_expression_repeat1] = STATE(4134),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1993),
    [anon_sym_ref] = ACTIONS(1995),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1999),
    [anon_sym_TILDE] = ACTIONS(1999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1999),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_AMP] = ACTIONS(1999),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1281),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1283),
    [anon_sym_DOT_DOT] = ACTIONS(1285),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1553] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6980),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6576),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4482),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9438),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1553),
    [sym_preproc_endregion] = STATE(1553),
    [sym_preproc_line] = STATE(1553),
    [sym_preproc_pragma] = STATE(1553),
    [sym_preproc_nullable] = STATE(1553),
    [sym_preproc_error] = STATE(1553),
    [sym_preproc_define] = STATE(1553),
    [sym_preproc_undef] = STATE(1553),
    [aux_sym_class_declaration_repeat1] = STATE(3801),
    [aux_sym_lambda_expression_repeat1] = STATE(4134),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1993),
    [anon_sym_ref] = ACTIONS(1995),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1999),
    [anon_sym_TILDE] = ACTIONS(1999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1999),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_AMP] = ACTIONS(1999),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1281),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1283),
    [anon_sym_DOT_DOT] = ACTIONS(1285),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1554] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6904),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7094),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6691),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(2988),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1554),
    [sym_preproc_endregion] = STATE(1554),
    [sym_preproc_line] = STATE(1554),
    [sym_preproc_pragma] = STATE(1554),
    [sym_preproc_nullable] = STATE(1554),
    [sym_preproc_error] = STATE(1554),
    [sym_preproc_define] = STATE(1554),
    [sym_preproc_undef] = STATE(1554),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2911),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1669),
    [anon_sym_TILDE] = ACTIONS(1669),
    [anon_sym_PLUS_PLUS] = ACTIONS(1669),
    [anon_sym_DASH_DASH] = ACTIONS(1669),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1667),
    [anon_sym_DASH] = ACTIONS(1667),
    [anon_sym_STAR] = ACTIONS(1493),
    [anon_sym_CARET] = ACTIONS(1669),
    [anon_sym_AMP] = ACTIONS(1669),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1555] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6980),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6584),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4482),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9438),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1555),
    [sym_preproc_endregion] = STATE(1555),
    [sym_preproc_line] = STATE(1555),
    [sym_preproc_pragma] = STATE(1555),
    [sym_preproc_nullable] = STATE(1555),
    [sym_preproc_error] = STATE(1555),
    [sym_preproc_define] = STATE(1555),
    [sym_preproc_undef] = STATE(1555),
    [aux_sym_class_declaration_repeat1] = STATE(3801),
    [aux_sym_lambda_expression_repeat1] = STATE(4134),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1993),
    [anon_sym_ref] = ACTIONS(1995),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1999),
    [anon_sym_TILDE] = ACTIONS(1999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1999),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_AMP] = ACTIONS(1999),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1281),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1283),
    [anon_sym_DOT_DOT] = ACTIONS(1285),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1556] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6961),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6396),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9849),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1556),
    [sym_preproc_endregion] = STATE(1556),
    [sym_preproc_line] = STATE(1556),
    [sym_preproc_pragma] = STATE(1556),
    [sym_preproc_nullable] = STATE(1556),
    [sym_preproc_error] = STATE(1556),
    [sym_preproc_define] = STATE(1556),
    [sym_preproc_undef] = STATE(1556),
    [aux_sym_class_declaration_repeat1] = STATE(3841),
    [aux_sym_lambda_expression_repeat1] = STATE(4283),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1459),
    [anon_sym_ref] = ACTIONS(1461),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1465),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1467),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1469),
    [anon_sym_DOT_DOT] = ACTIONS(1471),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1557] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6980),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6585),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4482),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9438),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1557),
    [sym_preproc_endregion] = STATE(1557),
    [sym_preproc_line] = STATE(1557),
    [sym_preproc_pragma] = STATE(1557),
    [sym_preproc_nullable] = STATE(1557),
    [sym_preproc_error] = STATE(1557),
    [sym_preproc_define] = STATE(1557),
    [sym_preproc_undef] = STATE(1557),
    [aux_sym_class_declaration_repeat1] = STATE(3801),
    [aux_sym_lambda_expression_repeat1] = STATE(4134),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1993),
    [anon_sym_ref] = ACTIONS(1995),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1999),
    [anon_sym_TILDE] = ACTIONS(1999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1999),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_AMP] = ACTIONS(1999),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1281),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1283),
    [anon_sym_DOT_DOT] = ACTIONS(1285),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1558] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6980),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6586),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4482),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9438),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1558),
    [sym_preproc_endregion] = STATE(1558),
    [sym_preproc_line] = STATE(1558),
    [sym_preproc_pragma] = STATE(1558),
    [sym_preproc_nullable] = STATE(1558),
    [sym_preproc_error] = STATE(1558),
    [sym_preproc_define] = STATE(1558),
    [sym_preproc_undef] = STATE(1558),
    [aux_sym_class_declaration_repeat1] = STATE(3801),
    [aux_sym_lambda_expression_repeat1] = STATE(4134),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1993),
    [anon_sym_ref] = ACTIONS(1995),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1999),
    [anon_sym_TILDE] = ACTIONS(1999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1999),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_AMP] = ACTIONS(1999),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1281),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1283),
    [anon_sym_DOT_DOT] = ACTIONS(1285),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1559] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6980),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6587),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4482),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9438),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1559),
    [sym_preproc_endregion] = STATE(1559),
    [sym_preproc_line] = STATE(1559),
    [sym_preproc_pragma] = STATE(1559),
    [sym_preproc_nullable] = STATE(1559),
    [sym_preproc_error] = STATE(1559),
    [sym_preproc_define] = STATE(1559),
    [sym_preproc_undef] = STATE(1559),
    [aux_sym_class_declaration_repeat1] = STATE(3801),
    [aux_sym_lambda_expression_repeat1] = STATE(4134),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1993),
    [anon_sym_ref] = ACTIONS(1995),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1999),
    [anon_sym_TILDE] = ACTIONS(1999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1999),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_AMP] = ACTIONS(1999),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1281),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1283),
    [anon_sym_DOT_DOT] = ACTIONS(1285),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1560] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6980),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6590),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4482),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9438),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1560),
    [sym_preproc_endregion] = STATE(1560),
    [sym_preproc_line] = STATE(1560),
    [sym_preproc_pragma] = STATE(1560),
    [sym_preproc_nullable] = STATE(1560),
    [sym_preproc_error] = STATE(1560),
    [sym_preproc_define] = STATE(1560),
    [sym_preproc_undef] = STATE(1560),
    [aux_sym_class_declaration_repeat1] = STATE(3801),
    [aux_sym_lambda_expression_repeat1] = STATE(4134),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1993),
    [anon_sym_ref] = ACTIONS(1995),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1999),
    [anon_sym_TILDE] = ACTIONS(1999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1999),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_AMP] = ACTIONS(1999),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1281),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1283),
    [anon_sym_DOT_DOT] = ACTIONS(1285),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1561] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6980),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6597),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4482),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9438),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1561),
    [sym_preproc_endregion] = STATE(1561),
    [sym_preproc_line] = STATE(1561),
    [sym_preproc_pragma] = STATE(1561),
    [sym_preproc_nullable] = STATE(1561),
    [sym_preproc_error] = STATE(1561),
    [sym_preproc_define] = STATE(1561),
    [sym_preproc_undef] = STATE(1561),
    [aux_sym_class_declaration_repeat1] = STATE(3801),
    [aux_sym_lambda_expression_repeat1] = STATE(4134),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1993),
    [anon_sym_ref] = ACTIONS(1995),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1999),
    [anon_sym_TILDE] = ACTIONS(1999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1999),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_AMP] = ACTIONS(1999),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1281),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1283),
    [anon_sym_DOT_DOT] = ACTIONS(1285),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1562] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6980),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6600),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4482),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9438),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1562),
    [sym_preproc_endregion] = STATE(1562),
    [sym_preproc_line] = STATE(1562),
    [sym_preproc_pragma] = STATE(1562),
    [sym_preproc_nullable] = STATE(1562),
    [sym_preproc_error] = STATE(1562),
    [sym_preproc_define] = STATE(1562),
    [sym_preproc_undef] = STATE(1562),
    [aux_sym_class_declaration_repeat1] = STATE(3801),
    [aux_sym_lambda_expression_repeat1] = STATE(4134),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1993),
    [anon_sym_ref] = ACTIONS(1995),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1999),
    [anon_sym_TILDE] = ACTIONS(1999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1999),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_AMP] = ACTIONS(1999),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1281),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1283),
    [anon_sym_DOT_DOT] = ACTIONS(1285),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1563] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6987),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6453),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4462),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7405),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9130),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1563),
    [sym_preproc_endregion] = STATE(1563),
    [sym_preproc_line] = STATE(1563),
    [sym_preproc_pragma] = STATE(1563),
    [sym_preproc_nullable] = STATE(1563),
    [sym_preproc_error] = STATE(1563),
    [sym_preproc_define] = STATE(1563),
    [sym_preproc_undef] = STATE(1563),
    [aux_sym_class_declaration_repeat1] = STATE(3855),
    [aux_sym_lambda_expression_repeat1] = STATE(4244),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2031),
    [anon_sym_ref] = ACTIONS(2033),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2037),
    [anon_sym_TILDE] = ACTIONS(2037),
    [anon_sym_PLUS_PLUS] = ACTIONS(2037),
    [anon_sym_DASH_DASH] = ACTIONS(2037),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2035),
    [anon_sym_DASH] = ACTIONS(2035),
    [anon_sym_STAR] = ACTIONS(2039),
    [anon_sym_CARET] = ACTIONS(2037),
    [anon_sym_AMP] = ACTIONS(2037),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2041),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2043),
    [anon_sym_DOT_DOT] = ACTIONS(2045),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1564] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6980),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6602),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4482),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9438),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1564),
    [sym_preproc_endregion] = STATE(1564),
    [sym_preproc_line] = STATE(1564),
    [sym_preproc_pragma] = STATE(1564),
    [sym_preproc_nullable] = STATE(1564),
    [sym_preproc_error] = STATE(1564),
    [sym_preproc_define] = STATE(1564),
    [sym_preproc_undef] = STATE(1564),
    [aux_sym_class_declaration_repeat1] = STATE(3801),
    [aux_sym_lambda_expression_repeat1] = STATE(4134),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1993),
    [anon_sym_ref] = ACTIONS(1995),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1999),
    [anon_sym_TILDE] = ACTIONS(1999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1999),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_AMP] = ACTIONS(1999),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1281),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1283),
    [anon_sym_DOT_DOT] = ACTIONS(1285),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1565] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6987),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4325),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4462),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7405),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9130),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1565),
    [sym_preproc_endregion] = STATE(1565),
    [sym_preproc_line] = STATE(1565),
    [sym_preproc_pragma] = STATE(1565),
    [sym_preproc_nullable] = STATE(1565),
    [sym_preproc_error] = STATE(1565),
    [sym_preproc_define] = STATE(1565),
    [sym_preproc_undef] = STATE(1565),
    [aux_sym_class_declaration_repeat1] = STATE(3855),
    [aux_sym_lambda_expression_repeat1] = STATE(4244),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2031),
    [anon_sym_ref] = ACTIONS(2033),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2037),
    [anon_sym_TILDE] = ACTIONS(2037),
    [anon_sym_PLUS_PLUS] = ACTIONS(2037),
    [anon_sym_DASH_DASH] = ACTIONS(2037),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2035),
    [anon_sym_DASH] = ACTIONS(2035),
    [anon_sym_STAR] = ACTIONS(2039),
    [anon_sym_CARET] = ACTIONS(2037),
    [anon_sym_AMP] = ACTIONS(2037),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2041),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2043),
    [anon_sym_DOT_DOT] = ACTIONS(2045),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1566] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3921),
    [sym__name] = STATE(6919),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2868),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(7068),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5955),
    [sym_non_lvalue_expression] = STATE(5735),
    [sym_lvalue_expression] = STATE(4323),
    [sym__expression_statement_expression] = STATE(5733),
    [sym_assignment_expression] = STATE(5734),
    [sym_binary_expression] = STATE(5733),
    [sym_postfix_unary_expression] = STATE(5734),
    [sym_prefix_unary_expression] = STATE(5734),
    [sym__pointer_indirection_expression] = STATE(3911),
    [sym_query_expression] = STATE(5733),
    [sym_from_clause] = STATE(7393),
    [sym_conditional_expression] = STATE(5733),
    [sym_conditional_access_expression] = STATE(5733),
    [sym_as_expression] = STATE(5733),
    [sym_is_expression] = STATE(5733),
    [sym_is_pattern_expression] = STATE(5733),
    [sym_cast_expression] = STATE(5733),
    [sym_checked_expression] = STATE(5733),
    [sym_invocation_expression] = STATE(5734),
    [sym_switch_expression] = STATE(5733),
    [sym_await_expression] = STATE(5734),
    [sym_throw_expression] = STATE(5733),
    [sym_element_access_expression] = STATE(3911),
    [sym_interpolated_string_expression] = STATE(5733),
    [sym_member_access_expression] = STATE(3911),
    [sym_object_creation_expression] = STATE(5734),
    [sym_parenthesized_expression] = STATE(5734),
    [sym__parenthesized_lvalue_expression] = STATE(3911),
    [sym_lambda_expression] = STATE(5733),
    [sym__lambda_parameters] = STATE(9932),
    [sym_array_creation_expression] = STATE(5733),
    [sym_anonymous_method_expression] = STATE(5733),
    [sym_anonymous_object_creation_expression] = STATE(5733),
    [sym_implicit_array_creation_expression] = STATE(5733),
    [sym_implicit_object_creation_expression] = STATE(5733),
    [sym_implicit_stackalloc_expression] = STATE(5733),
    [sym_initializer_expression] = STATE(5733),
    [sym_default_expression] = STATE(5733),
    [sym_with_expression] = STATE(5733),
    [sym_sizeof_expression] = STATE(5733),
    [sym_typeof_expression] = STATE(5733),
    [sym_makeref_expression] = STATE(5733),
    [sym_ref_expression] = STATE(5733),
    [sym_reftype_expression] = STATE(5733),
    [sym_refvalue_expression] = STATE(5733),
    [sym_stackalloc_expression] = STATE(5733),
    [sym_range_expression] = STATE(5733),
    [sym_tuple_expression] = STATE(3911),
    [sym_literal] = STATE(5733),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2798),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(5733),
    [sym_preproc_region] = STATE(1566),
    [sym_preproc_endregion] = STATE(1566),
    [sym_preproc_line] = STATE(1566),
    [sym_preproc_pragma] = STATE(1566),
    [sym_preproc_nullable] = STATE(1566),
    [sym_preproc_error] = STATE(1566),
    [sym_preproc_define] = STATE(1566),
    [sym_preproc_undef] = STATE(1566),
    [aux_sym_class_declaration_repeat1] = STATE(3831),
    [aux_sym_lambda_expression_repeat1] = STATE(4227),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_LPAREN] = ACTIONS(1577),
    [anon_sym_ref] = ACTIONS(1579),
    [anon_sym_LBRACE] = ACTIONS(1377),
    [anon_sym_delegate] = ACTIONS(1379),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1381),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1583),
    [anon_sym_TILDE] = ACTIONS(1583),
    [anon_sym_PLUS_PLUS] = ACTIONS(1583),
    [anon_sym_DASH_DASH] = ACTIONS(1583),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1581),
    [anon_sym_DASH] = ACTIONS(1581),
    [anon_sym_STAR] = ACTIONS(1391),
    [anon_sym_CARET] = ACTIONS(1583),
    [anon_sym_AMP] = ACTIONS(1583),
    [anon_sym_this] = ACTIONS(1393),
    [anon_sym_scoped] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1397),
    [sym_predefined_type] = ACTIONS(1399),
    [anon_sym_unchecked] = ACTIONS(1383),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1585),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1587),
    [anon_sym_DOT_DOT] = ACTIONS(1589),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_stackalloc] = ACTIONS(1413),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(1419),
    [anon_sym___reftype] = ACTIONS(1421),
    [anon_sym___refvalue] = ACTIONS(1423),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
  },
  [1567] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7064),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5187),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(3866),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7382),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9762),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1567),
    [sym_preproc_endregion] = STATE(1567),
    [sym_preproc_line] = STATE(1567),
    [sym_preproc_pragma] = STATE(1567),
    [sym_preproc_nullable] = STATE(1567),
    [sym_preproc_error] = STATE(1567),
    [sym_preproc_define] = STATE(1567),
    [sym_preproc_undef] = STATE(1567),
    [aux_sym_class_declaration_repeat1] = STATE(3842),
    [aux_sym_lambda_expression_repeat1] = STATE(4280),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1351),
    [anon_sym_ref] = ACTIONS(1353),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1357),
    [anon_sym_TILDE] = ACTIONS(1357),
    [anon_sym_PLUS_PLUS] = ACTIONS(1357),
    [anon_sym_DASH_DASH] = ACTIONS(1357),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1355),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(1357),
    [anon_sym_AMP] = ACTIONS(1357),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1361),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1363),
    [anon_sym_DOT_DOT] = ACTIONS(1365),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1568] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6987),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6582),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4462),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7405),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9130),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1568),
    [sym_preproc_endregion] = STATE(1568),
    [sym_preproc_line] = STATE(1568),
    [sym_preproc_pragma] = STATE(1568),
    [sym_preproc_nullable] = STATE(1568),
    [sym_preproc_error] = STATE(1568),
    [sym_preproc_define] = STATE(1568),
    [sym_preproc_undef] = STATE(1568),
    [aux_sym_class_declaration_repeat1] = STATE(3855),
    [aux_sym_lambda_expression_repeat1] = STATE(4244),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2031),
    [anon_sym_ref] = ACTIONS(2033),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2037),
    [anon_sym_TILDE] = ACTIONS(2037),
    [anon_sym_PLUS_PLUS] = ACTIONS(2037),
    [anon_sym_DASH_DASH] = ACTIONS(2037),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2035),
    [anon_sym_DASH] = ACTIONS(2035),
    [anon_sym_STAR] = ACTIONS(2039),
    [anon_sym_CARET] = ACTIONS(2037),
    [anon_sym_AMP] = ACTIONS(2037),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2041),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2043),
    [anon_sym_DOT_DOT] = ACTIONS(2045),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1569] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6894),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2955),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7025),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4749),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(3735),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7397),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9590),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1569),
    [sym_preproc_endregion] = STATE(1569),
    [sym_preproc_line] = STATE(1569),
    [sym_preproc_pragma] = STATE(1569),
    [sym_preproc_nullable] = STATE(1569),
    [sym_preproc_error] = STATE(1569),
    [sym_preproc_define] = STATE(1569),
    [sym_preproc_undef] = STATE(1569),
    [aux_sym_class_declaration_repeat1] = STATE(3844),
    [aux_sym_lambda_expression_repeat1] = STATE(4245),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1849),
    [anon_sym_ref] = ACTIONS(1851),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1853),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1857),
    [anon_sym_TILDE] = ACTIONS(1857),
    [anon_sym_PLUS_PLUS] = ACTIONS(1857),
    [anon_sym_DASH_DASH] = ACTIONS(1857),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1855),
    [anon_sym_DASH] = ACTIONS(1855),
    [anon_sym_STAR] = ACTIONS(1859),
    [anon_sym_CARET] = ACTIONS(1857),
    [anon_sym_AMP] = ACTIONS(1857),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1861),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1863),
    [anon_sym_DOT_DOT] = ACTIONS(1865),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1570] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6987),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6579),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4462),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7405),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9130),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1570),
    [sym_preproc_endregion] = STATE(1570),
    [sym_preproc_line] = STATE(1570),
    [sym_preproc_pragma] = STATE(1570),
    [sym_preproc_nullable] = STATE(1570),
    [sym_preproc_error] = STATE(1570),
    [sym_preproc_define] = STATE(1570),
    [sym_preproc_undef] = STATE(1570),
    [aux_sym_class_declaration_repeat1] = STATE(3855),
    [aux_sym_lambda_expression_repeat1] = STATE(4244),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2031),
    [anon_sym_ref] = ACTIONS(2033),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2037),
    [anon_sym_TILDE] = ACTIONS(2037),
    [anon_sym_PLUS_PLUS] = ACTIONS(2037),
    [anon_sym_DASH_DASH] = ACTIONS(2037),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2035),
    [anon_sym_DASH] = ACTIONS(2035),
    [anon_sym_STAR] = ACTIONS(2039),
    [anon_sym_CARET] = ACTIONS(2037),
    [anon_sym_AMP] = ACTIONS(2037),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2041),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2043),
    [anon_sym_DOT_DOT] = ACTIONS(2045),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1571] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6987),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6577),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4462),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7405),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9130),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1571),
    [sym_preproc_endregion] = STATE(1571),
    [sym_preproc_line] = STATE(1571),
    [sym_preproc_pragma] = STATE(1571),
    [sym_preproc_nullable] = STATE(1571),
    [sym_preproc_error] = STATE(1571),
    [sym_preproc_define] = STATE(1571),
    [sym_preproc_undef] = STATE(1571),
    [aux_sym_class_declaration_repeat1] = STATE(3855),
    [aux_sym_lambda_expression_repeat1] = STATE(4244),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2031),
    [anon_sym_ref] = ACTIONS(2033),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2037),
    [anon_sym_TILDE] = ACTIONS(2037),
    [anon_sym_PLUS_PLUS] = ACTIONS(2037),
    [anon_sym_DASH_DASH] = ACTIONS(2037),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2035),
    [anon_sym_DASH] = ACTIONS(2035),
    [anon_sym_STAR] = ACTIONS(2039),
    [anon_sym_CARET] = ACTIONS(2037),
    [anon_sym_AMP] = ACTIONS(2037),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2041),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2043),
    [anon_sym_DOT_DOT] = ACTIONS(2045),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1572] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6980),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4325),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4482),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9438),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1572),
    [sym_preproc_endregion] = STATE(1572),
    [sym_preproc_line] = STATE(1572),
    [sym_preproc_pragma] = STATE(1572),
    [sym_preproc_nullable] = STATE(1572),
    [sym_preproc_error] = STATE(1572),
    [sym_preproc_define] = STATE(1572),
    [sym_preproc_undef] = STATE(1572),
    [aux_sym_class_declaration_repeat1] = STATE(3801),
    [aux_sym_lambda_expression_repeat1] = STATE(4134),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1993),
    [anon_sym_ref] = ACTIONS(1995),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1999),
    [anon_sym_TILDE] = ACTIONS(1999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1999),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_AMP] = ACTIONS(1999),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1281),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1283),
    [anon_sym_DOT_DOT] = ACTIONS(1285),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1573] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6980),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6335),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4482),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9438),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1573),
    [sym_preproc_endregion] = STATE(1573),
    [sym_preproc_line] = STATE(1573),
    [sym_preproc_pragma] = STATE(1573),
    [sym_preproc_nullable] = STATE(1573),
    [sym_preproc_error] = STATE(1573),
    [sym_preproc_define] = STATE(1573),
    [sym_preproc_undef] = STATE(1573),
    [aux_sym_class_declaration_repeat1] = STATE(3801),
    [aux_sym_lambda_expression_repeat1] = STATE(4134),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1993),
    [anon_sym_ref] = ACTIONS(1995),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1999),
    [anon_sym_TILDE] = ACTIONS(1999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1999),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_AMP] = ACTIONS(1999),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1281),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1283),
    [anon_sym_DOT_DOT] = ACTIONS(1285),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1574] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3921),
    [sym__name] = STATE(6919),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2868),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(7068),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5123),
    [sym_non_lvalue_expression] = STATE(5735),
    [sym_lvalue_expression] = STATE(4323),
    [sym__expression_statement_expression] = STATE(5733),
    [sym_assignment_expression] = STATE(5734),
    [sym_binary_expression] = STATE(5733),
    [sym_postfix_unary_expression] = STATE(5734),
    [sym_prefix_unary_expression] = STATE(5734),
    [sym__pointer_indirection_expression] = STATE(3911),
    [sym_query_expression] = STATE(5733),
    [sym_from_clause] = STATE(7393),
    [sym_conditional_expression] = STATE(5733),
    [sym_conditional_access_expression] = STATE(5733),
    [sym_as_expression] = STATE(5733),
    [sym_is_expression] = STATE(5733),
    [sym_is_pattern_expression] = STATE(5733),
    [sym_cast_expression] = STATE(5733),
    [sym_checked_expression] = STATE(5733),
    [sym_invocation_expression] = STATE(5734),
    [sym_switch_expression] = STATE(5733),
    [sym_await_expression] = STATE(5734),
    [sym_throw_expression] = STATE(5733),
    [sym_element_access_expression] = STATE(3911),
    [sym_interpolated_string_expression] = STATE(5733),
    [sym_member_access_expression] = STATE(3911),
    [sym_object_creation_expression] = STATE(5734),
    [sym_parenthesized_expression] = STATE(5734),
    [sym__parenthesized_lvalue_expression] = STATE(3911),
    [sym_lambda_expression] = STATE(5733),
    [sym__lambda_parameters] = STATE(9932),
    [sym_array_creation_expression] = STATE(5733),
    [sym_anonymous_method_expression] = STATE(5733),
    [sym_anonymous_object_creation_expression] = STATE(5733),
    [sym_implicit_array_creation_expression] = STATE(5733),
    [sym_implicit_object_creation_expression] = STATE(5733),
    [sym_implicit_stackalloc_expression] = STATE(5733),
    [sym_initializer_expression] = STATE(5733),
    [sym_default_expression] = STATE(5733),
    [sym_with_expression] = STATE(5733),
    [sym_sizeof_expression] = STATE(5733),
    [sym_typeof_expression] = STATE(5733),
    [sym_makeref_expression] = STATE(5733),
    [sym_ref_expression] = STATE(5733),
    [sym_reftype_expression] = STATE(5733),
    [sym_refvalue_expression] = STATE(5733),
    [sym_stackalloc_expression] = STATE(5733),
    [sym_range_expression] = STATE(5733),
    [sym_tuple_expression] = STATE(3911),
    [sym_literal] = STATE(5733),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2798),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(5733),
    [sym_preproc_region] = STATE(1574),
    [sym_preproc_endregion] = STATE(1574),
    [sym_preproc_line] = STATE(1574),
    [sym_preproc_pragma] = STATE(1574),
    [sym_preproc_nullable] = STATE(1574),
    [sym_preproc_error] = STATE(1574),
    [sym_preproc_define] = STATE(1574),
    [sym_preproc_undef] = STATE(1574),
    [aux_sym_class_declaration_repeat1] = STATE(3831),
    [aux_sym_lambda_expression_repeat1] = STATE(4227),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_LPAREN] = ACTIONS(1577),
    [anon_sym_ref] = ACTIONS(1579),
    [anon_sym_LBRACE] = ACTIONS(1377),
    [anon_sym_delegate] = ACTIONS(1379),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1381),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1583),
    [anon_sym_TILDE] = ACTIONS(1583),
    [anon_sym_PLUS_PLUS] = ACTIONS(1583),
    [anon_sym_DASH_DASH] = ACTIONS(1583),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1581),
    [anon_sym_DASH] = ACTIONS(1581),
    [anon_sym_STAR] = ACTIONS(1391),
    [anon_sym_CARET] = ACTIONS(1583),
    [anon_sym_AMP] = ACTIONS(1583),
    [anon_sym_this] = ACTIONS(1393),
    [anon_sym_scoped] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1397),
    [sym_predefined_type] = ACTIONS(1399),
    [anon_sym_unchecked] = ACTIONS(1383),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1585),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1587),
    [anon_sym_DOT_DOT] = ACTIONS(1589),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_stackalloc] = ACTIONS(1413),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(1419),
    [anon_sym___reftype] = ACTIONS(1421),
    [anon_sym___refvalue] = ACTIONS(1423),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
  },
  [1575] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6987),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6572),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4462),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7405),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9130),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1575),
    [sym_preproc_endregion] = STATE(1575),
    [sym_preproc_line] = STATE(1575),
    [sym_preproc_pragma] = STATE(1575),
    [sym_preproc_nullable] = STATE(1575),
    [sym_preproc_error] = STATE(1575),
    [sym_preproc_define] = STATE(1575),
    [sym_preproc_undef] = STATE(1575),
    [aux_sym_class_declaration_repeat1] = STATE(3855),
    [aux_sym_lambda_expression_repeat1] = STATE(4244),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2031),
    [anon_sym_ref] = ACTIONS(2033),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2037),
    [anon_sym_TILDE] = ACTIONS(2037),
    [anon_sym_PLUS_PLUS] = ACTIONS(2037),
    [anon_sym_DASH_DASH] = ACTIONS(2037),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2035),
    [anon_sym_DASH] = ACTIONS(2035),
    [anon_sym_STAR] = ACTIONS(2039),
    [anon_sym_CARET] = ACTIONS(2037),
    [anon_sym_AMP] = ACTIONS(2037),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2041),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2043),
    [anon_sym_DOT_DOT] = ACTIONS(2045),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1576] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6987),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6570),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4462),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7405),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9130),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1576),
    [sym_preproc_endregion] = STATE(1576),
    [sym_preproc_line] = STATE(1576),
    [sym_preproc_pragma] = STATE(1576),
    [sym_preproc_nullable] = STATE(1576),
    [sym_preproc_error] = STATE(1576),
    [sym_preproc_define] = STATE(1576),
    [sym_preproc_undef] = STATE(1576),
    [aux_sym_class_declaration_repeat1] = STATE(3855),
    [aux_sym_lambda_expression_repeat1] = STATE(4244),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2031),
    [anon_sym_ref] = ACTIONS(2033),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2037),
    [anon_sym_TILDE] = ACTIONS(2037),
    [anon_sym_PLUS_PLUS] = ACTIONS(2037),
    [anon_sym_DASH_DASH] = ACTIONS(2037),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2035),
    [anon_sym_DASH] = ACTIONS(2035),
    [anon_sym_STAR] = ACTIONS(2039),
    [anon_sym_CARET] = ACTIONS(2037),
    [anon_sym_AMP] = ACTIONS(2037),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2041),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2043),
    [anon_sym_DOT_DOT] = ACTIONS(2045),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1577] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6987),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6569),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4462),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7405),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9130),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1577),
    [sym_preproc_endregion] = STATE(1577),
    [sym_preproc_line] = STATE(1577),
    [sym_preproc_pragma] = STATE(1577),
    [sym_preproc_nullable] = STATE(1577),
    [sym_preproc_error] = STATE(1577),
    [sym_preproc_define] = STATE(1577),
    [sym_preproc_undef] = STATE(1577),
    [aux_sym_class_declaration_repeat1] = STATE(3855),
    [aux_sym_lambda_expression_repeat1] = STATE(4244),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2031),
    [anon_sym_ref] = ACTIONS(2033),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2037),
    [anon_sym_TILDE] = ACTIONS(2037),
    [anon_sym_PLUS_PLUS] = ACTIONS(2037),
    [anon_sym_DASH_DASH] = ACTIONS(2037),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2035),
    [anon_sym_DASH] = ACTIONS(2035),
    [anon_sym_STAR] = ACTIONS(2039),
    [anon_sym_CARET] = ACTIONS(2037),
    [anon_sym_AMP] = ACTIONS(2037),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2041),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2043),
    [anon_sym_DOT_DOT] = ACTIONS(2045),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1578] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6987),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6568),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4462),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7405),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9130),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1578),
    [sym_preproc_endregion] = STATE(1578),
    [sym_preproc_line] = STATE(1578),
    [sym_preproc_pragma] = STATE(1578),
    [sym_preproc_nullable] = STATE(1578),
    [sym_preproc_error] = STATE(1578),
    [sym_preproc_define] = STATE(1578),
    [sym_preproc_undef] = STATE(1578),
    [aux_sym_class_declaration_repeat1] = STATE(3855),
    [aux_sym_lambda_expression_repeat1] = STATE(4244),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2031),
    [anon_sym_ref] = ACTIONS(2033),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2037),
    [anon_sym_TILDE] = ACTIONS(2037),
    [anon_sym_PLUS_PLUS] = ACTIONS(2037),
    [anon_sym_DASH_DASH] = ACTIONS(2037),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2035),
    [anon_sym_DASH] = ACTIONS(2035),
    [anon_sym_STAR] = ACTIONS(2039),
    [anon_sym_CARET] = ACTIONS(2037),
    [anon_sym_AMP] = ACTIONS(2037),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2041),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2043),
    [anon_sym_DOT_DOT] = ACTIONS(2045),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1579] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6898),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2940),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7094),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(3014),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1579),
    [sym_preproc_endregion] = STATE(1579),
    [sym_preproc_line] = STATE(1579),
    [sym_preproc_pragma] = STATE(1579),
    [sym_preproc_nullable] = STATE(1579),
    [sym_preproc_error] = STATE(1579),
    [sym_preproc_define] = STATE(1579),
    [sym_preproc_undef] = STATE(1579),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1669),
    [anon_sym_TILDE] = ACTIONS(1669),
    [anon_sym_PLUS_PLUS] = ACTIONS(1669),
    [anon_sym_DASH_DASH] = ACTIONS(1669),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1667),
    [anon_sym_DASH] = ACTIONS(1667),
    [anon_sym_STAR] = ACTIONS(2163),
    [anon_sym_CARET] = ACTIONS(1669),
    [anon_sym_AMP] = ACTIONS(1669),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1580] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6910),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2957),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7089),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4943),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(3796),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7395),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9374),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1580),
    [sym_preproc_endregion] = STATE(1580),
    [sym_preproc_line] = STATE(1580),
    [sym_preproc_pragma] = STATE(1580),
    [sym_preproc_nullable] = STATE(1580),
    [sym_preproc_error] = STATE(1580),
    [sym_preproc_define] = STATE(1580),
    [sym_preproc_undef] = STATE(1580),
    [aux_sym_class_declaration_repeat1] = STATE(3839),
    [aux_sym_lambda_expression_repeat1] = STATE(4209),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2139),
    [anon_sym_ref] = ACTIONS(2141),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1799),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2145),
    [anon_sym_TILDE] = ACTIONS(2145),
    [anon_sym_PLUS_PLUS] = ACTIONS(2145),
    [anon_sym_DASH_DASH] = ACTIONS(2145),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2143),
    [anon_sym_DASH] = ACTIONS(2143),
    [anon_sym_STAR] = ACTIONS(1805),
    [anon_sym_CARET] = ACTIONS(2145),
    [anon_sym_AMP] = ACTIONS(2145),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2147),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2149),
    [anon_sym_DOT_DOT] = ACTIONS(2151),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1581] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6987),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6567),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4462),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7405),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9130),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1581),
    [sym_preproc_endregion] = STATE(1581),
    [sym_preproc_line] = STATE(1581),
    [sym_preproc_pragma] = STATE(1581),
    [sym_preproc_nullable] = STATE(1581),
    [sym_preproc_error] = STATE(1581),
    [sym_preproc_define] = STATE(1581),
    [sym_preproc_undef] = STATE(1581),
    [aux_sym_class_declaration_repeat1] = STATE(3855),
    [aux_sym_lambda_expression_repeat1] = STATE(4244),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2031),
    [anon_sym_ref] = ACTIONS(2033),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2037),
    [anon_sym_TILDE] = ACTIONS(2037),
    [anon_sym_PLUS_PLUS] = ACTIONS(2037),
    [anon_sym_DASH_DASH] = ACTIONS(2037),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2035),
    [anon_sym_DASH] = ACTIONS(2035),
    [anon_sym_STAR] = ACTIONS(2039),
    [anon_sym_CARET] = ACTIONS(2037),
    [anon_sym_AMP] = ACTIONS(2037),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2041),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2043),
    [anon_sym_DOT_DOT] = ACTIONS(2045),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1582] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6987),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6564),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4462),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7405),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9130),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1582),
    [sym_preproc_endregion] = STATE(1582),
    [sym_preproc_line] = STATE(1582),
    [sym_preproc_pragma] = STATE(1582),
    [sym_preproc_nullable] = STATE(1582),
    [sym_preproc_error] = STATE(1582),
    [sym_preproc_define] = STATE(1582),
    [sym_preproc_undef] = STATE(1582),
    [aux_sym_class_declaration_repeat1] = STATE(3855),
    [aux_sym_lambda_expression_repeat1] = STATE(4244),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2031),
    [anon_sym_ref] = ACTIONS(2033),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2037),
    [anon_sym_TILDE] = ACTIONS(2037),
    [anon_sym_PLUS_PLUS] = ACTIONS(2037),
    [anon_sym_DASH_DASH] = ACTIONS(2037),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2035),
    [anon_sym_DASH] = ACTIONS(2035),
    [anon_sym_STAR] = ACTIONS(2039),
    [anon_sym_CARET] = ACTIONS(2037),
    [anon_sym_AMP] = ACTIONS(2037),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2041),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2043),
    [anon_sym_DOT_DOT] = ACTIONS(2045),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1583] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6987),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6563),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4462),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7405),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9130),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1583),
    [sym_preproc_endregion] = STATE(1583),
    [sym_preproc_line] = STATE(1583),
    [sym_preproc_pragma] = STATE(1583),
    [sym_preproc_nullable] = STATE(1583),
    [sym_preproc_error] = STATE(1583),
    [sym_preproc_define] = STATE(1583),
    [sym_preproc_undef] = STATE(1583),
    [aux_sym_class_declaration_repeat1] = STATE(3855),
    [aux_sym_lambda_expression_repeat1] = STATE(4244),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2031),
    [anon_sym_ref] = ACTIONS(2033),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2037),
    [anon_sym_TILDE] = ACTIONS(2037),
    [anon_sym_PLUS_PLUS] = ACTIONS(2037),
    [anon_sym_DASH_DASH] = ACTIONS(2037),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2035),
    [anon_sym_DASH] = ACTIONS(2035),
    [anon_sym_STAR] = ACTIONS(2039),
    [anon_sym_CARET] = ACTIONS(2037),
    [anon_sym_AMP] = ACTIONS(2037),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2041),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2043),
    [anon_sym_DOT_DOT] = ACTIONS(2045),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1584] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6987),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6562),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4462),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7405),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9130),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1584),
    [sym_preproc_endregion] = STATE(1584),
    [sym_preproc_line] = STATE(1584),
    [sym_preproc_pragma] = STATE(1584),
    [sym_preproc_nullable] = STATE(1584),
    [sym_preproc_error] = STATE(1584),
    [sym_preproc_define] = STATE(1584),
    [sym_preproc_undef] = STATE(1584),
    [aux_sym_class_declaration_repeat1] = STATE(3855),
    [aux_sym_lambda_expression_repeat1] = STATE(4244),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2031),
    [anon_sym_ref] = ACTIONS(2033),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2037),
    [anon_sym_TILDE] = ACTIONS(2037),
    [anon_sym_PLUS_PLUS] = ACTIONS(2037),
    [anon_sym_DASH_DASH] = ACTIONS(2037),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2035),
    [anon_sym_DASH] = ACTIONS(2035),
    [anon_sym_STAR] = ACTIONS(2039),
    [anon_sym_CARET] = ACTIONS(2037),
    [anon_sym_AMP] = ACTIONS(2037),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2041),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2043),
    [anon_sym_DOT_DOT] = ACTIONS(2045),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1585] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6910),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2957),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7089),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5091),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(3796),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7395),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9374),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1585),
    [sym_preproc_endregion] = STATE(1585),
    [sym_preproc_line] = STATE(1585),
    [sym_preproc_pragma] = STATE(1585),
    [sym_preproc_nullable] = STATE(1585),
    [sym_preproc_error] = STATE(1585),
    [sym_preproc_define] = STATE(1585),
    [sym_preproc_undef] = STATE(1585),
    [aux_sym_class_declaration_repeat1] = STATE(3839),
    [aux_sym_lambda_expression_repeat1] = STATE(4209),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2139),
    [anon_sym_ref] = ACTIONS(2141),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1799),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2145),
    [anon_sym_TILDE] = ACTIONS(2145),
    [anon_sym_PLUS_PLUS] = ACTIONS(2145),
    [anon_sym_DASH_DASH] = ACTIONS(2145),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2143),
    [anon_sym_DASH] = ACTIONS(2143),
    [anon_sym_STAR] = ACTIONS(1805),
    [anon_sym_CARET] = ACTIONS(2145),
    [anon_sym_AMP] = ACTIONS(2145),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2147),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2149),
    [anon_sym_DOT_DOT] = ACTIONS(2151),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1586] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6987),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6489),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4462),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7405),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9130),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1586),
    [sym_preproc_endregion] = STATE(1586),
    [sym_preproc_line] = STATE(1586),
    [sym_preproc_pragma] = STATE(1586),
    [sym_preproc_nullable] = STATE(1586),
    [sym_preproc_error] = STATE(1586),
    [sym_preproc_define] = STATE(1586),
    [sym_preproc_undef] = STATE(1586),
    [aux_sym_class_declaration_repeat1] = STATE(3855),
    [aux_sym_lambda_expression_repeat1] = STATE(4244),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2031),
    [anon_sym_ref] = ACTIONS(2033),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2037),
    [anon_sym_TILDE] = ACTIONS(2037),
    [anon_sym_PLUS_PLUS] = ACTIONS(2037),
    [anon_sym_DASH_DASH] = ACTIONS(2037),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2035),
    [anon_sym_DASH] = ACTIONS(2035),
    [anon_sym_STAR] = ACTIONS(2039),
    [anon_sym_CARET] = ACTIONS(2037),
    [anon_sym_AMP] = ACTIONS(2037),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2041),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2043),
    [anon_sym_DOT_DOT] = ACTIONS(2045),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1587] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6894),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2955),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7025),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4778),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(3735),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7397),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9590),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1587),
    [sym_preproc_endregion] = STATE(1587),
    [sym_preproc_line] = STATE(1587),
    [sym_preproc_pragma] = STATE(1587),
    [sym_preproc_nullable] = STATE(1587),
    [sym_preproc_error] = STATE(1587),
    [sym_preproc_define] = STATE(1587),
    [sym_preproc_undef] = STATE(1587),
    [aux_sym_class_declaration_repeat1] = STATE(3844),
    [aux_sym_lambda_expression_repeat1] = STATE(4245),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1849),
    [anon_sym_ref] = ACTIONS(1851),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1853),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1857),
    [anon_sym_TILDE] = ACTIONS(1857),
    [anon_sym_PLUS_PLUS] = ACTIONS(1857),
    [anon_sym_DASH_DASH] = ACTIONS(1857),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1855),
    [anon_sym_DASH] = ACTIONS(1855),
    [anon_sym_STAR] = ACTIONS(1859),
    [anon_sym_CARET] = ACTIONS(1857),
    [anon_sym_AMP] = ACTIONS(1857),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1861),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1863),
    [anon_sym_DOT_DOT] = ACTIONS(1865),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1588] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6418),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1588),
    [sym_preproc_endregion] = STATE(1588),
    [sym_preproc_line] = STATE(1588),
    [sym_preproc_pragma] = STATE(1588),
    [sym_preproc_nullable] = STATE(1588),
    [sym_preproc_error] = STATE(1588),
    [sym_preproc_define] = STATE(1588),
    [sym_preproc_undef] = STATE(1588),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1589] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6888),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2882),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7048),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5290),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4019),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7409),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9210),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1589),
    [sym_preproc_endregion] = STATE(1589),
    [sym_preproc_line] = STATE(1589),
    [sym_preproc_pragma] = STATE(1589),
    [sym_preproc_nullable] = STATE(1589),
    [sym_preproc_error] = STATE(1589),
    [sym_preproc_define] = STATE(1589),
    [sym_preproc_undef] = STATE(1589),
    [aux_sym_class_declaration_repeat1] = STATE(3812),
    [aux_sym_lambda_expression_repeat1] = STATE(4146),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1709),
    [anon_sym_ref] = ACTIONS(1711),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1713),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1717),
    [anon_sym_TILDE] = ACTIONS(1717),
    [anon_sym_PLUS_PLUS] = ACTIONS(1717),
    [anon_sym_DASH_DASH] = ACTIONS(1717),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1715),
    [anon_sym_DASH] = ACTIONS(1715),
    [anon_sym_STAR] = ACTIONS(1719),
    [anon_sym_CARET] = ACTIONS(1717),
    [anon_sym_AMP] = ACTIONS(1717),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1721),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1723),
    [anon_sym_DOT_DOT] = ACTIONS(1725),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1590] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6893),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2968),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7023),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6223),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4416),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7390),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9221),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1590),
    [sym_preproc_endregion] = STATE(1590),
    [sym_preproc_line] = STATE(1590),
    [sym_preproc_pragma] = STATE(1590),
    [sym_preproc_nullable] = STATE(1590),
    [sym_preproc_error] = STATE(1590),
    [sym_preproc_define] = STATE(1590),
    [sym_preproc_undef] = STATE(1590),
    [aux_sym_class_declaration_repeat1] = STATE(3808),
    [aux_sym_lambda_expression_repeat1] = STATE(4129),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_ref] = ACTIONS(2217),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(2223),
    [anon_sym_TILDE] = ACTIONS(2223),
    [anon_sym_PLUS_PLUS] = ACTIONS(2223),
    [anon_sym_DASH_DASH] = ACTIONS(2223),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2221),
    [anon_sym_DASH] = ACTIONS(2221),
    [anon_sym_STAR] = ACTIONS(2225),
    [anon_sym_CARET] = ACTIONS(2223),
    [anon_sym_AMP] = ACTIONS(2223),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2227),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2229),
    [anon_sym_DOT_DOT] = ACTIONS(2231),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1591] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6987),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4309),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4462),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7405),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9130),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1591),
    [sym_preproc_endregion] = STATE(1591),
    [sym_preproc_line] = STATE(1591),
    [sym_preproc_pragma] = STATE(1591),
    [sym_preproc_nullable] = STATE(1591),
    [sym_preproc_error] = STATE(1591),
    [sym_preproc_define] = STATE(1591),
    [sym_preproc_undef] = STATE(1591),
    [aux_sym_class_declaration_repeat1] = STATE(3855),
    [aux_sym_lambda_expression_repeat1] = STATE(4244),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2031),
    [anon_sym_ref] = ACTIONS(2033),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2037),
    [anon_sym_TILDE] = ACTIONS(2037),
    [anon_sym_PLUS_PLUS] = ACTIONS(2037),
    [anon_sym_DASH_DASH] = ACTIONS(2037),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2035),
    [anon_sym_DASH] = ACTIONS(2035),
    [anon_sym_STAR] = ACTIONS(2039),
    [anon_sym_CARET] = ACTIONS(2037),
    [anon_sym_AMP] = ACTIONS(2037),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2041),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2043),
    [anon_sym_DOT_DOT] = ACTIONS(2045),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1592] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3921),
    [sym__name] = STATE(6889),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2854),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(7061),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5120),
    [sym_non_lvalue_expression] = STATE(5735),
    [sym_lvalue_expression] = STATE(3899),
    [sym__expression_statement_expression] = STATE(5733),
    [sym_assignment_expression] = STATE(5734),
    [sym_binary_expression] = STATE(5733),
    [sym_postfix_unary_expression] = STATE(5734),
    [sym_prefix_unary_expression] = STATE(5734),
    [sym__pointer_indirection_expression] = STATE(3911),
    [sym_query_expression] = STATE(5733),
    [sym_from_clause] = STATE(7400),
    [sym_conditional_expression] = STATE(5733),
    [sym_conditional_access_expression] = STATE(5733),
    [sym_as_expression] = STATE(5733),
    [sym_is_expression] = STATE(5733),
    [sym_is_pattern_expression] = STATE(5733),
    [sym_cast_expression] = STATE(5733),
    [sym_checked_expression] = STATE(5733),
    [sym_invocation_expression] = STATE(5734),
    [sym_switch_expression] = STATE(5733),
    [sym_await_expression] = STATE(5734),
    [sym_throw_expression] = STATE(5733),
    [sym_element_access_expression] = STATE(3911),
    [sym_interpolated_string_expression] = STATE(5733),
    [sym_member_access_expression] = STATE(3911),
    [sym_object_creation_expression] = STATE(5734),
    [sym_parenthesized_expression] = STATE(5734),
    [sym__parenthesized_lvalue_expression] = STATE(3911),
    [sym_lambda_expression] = STATE(5733),
    [sym__lambda_parameters] = STATE(9790),
    [sym_array_creation_expression] = STATE(5733),
    [sym_anonymous_method_expression] = STATE(5733),
    [sym_anonymous_object_creation_expression] = STATE(5733),
    [sym_implicit_array_creation_expression] = STATE(5733),
    [sym_implicit_object_creation_expression] = STATE(5733),
    [sym_implicit_stackalloc_expression] = STATE(5733),
    [sym_initializer_expression] = STATE(5733),
    [sym_default_expression] = STATE(5733),
    [sym_with_expression] = STATE(5733),
    [sym_sizeof_expression] = STATE(5733),
    [sym_typeof_expression] = STATE(5733),
    [sym_makeref_expression] = STATE(5733),
    [sym_ref_expression] = STATE(5733),
    [sym_reftype_expression] = STATE(5733),
    [sym_refvalue_expression] = STATE(5733),
    [sym_stackalloc_expression] = STATE(5733),
    [sym_range_expression] = STATE(5733),
    [sym_tuple_expression] = STATE(3911),
    [sym_literal] = STATE(5733),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2798),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(5733),
    [sym_preproc_region] = STATE(1592),
    [sym_preproc_endregion] = STATE(1592),
    [sym_preproc_line] = STATE(1592),
    [sym_preproc_pragma] = STATE(1592),
    [sym_preproc_nullable] = STATE(1592),
    [sym_preproc_error] = STATE(1592),
    [sym_preproc_define] = STATE(1592),
    [sym_preproc_undef] = STATE(1592),
    [aux_sym_class_declaration_repeat1] = STATE(3833),
    [aux_sym_lambda_expression_repeat1] = STATE(4182),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_LPAREN] = ACTIONS(1439),
    [anon_sym_ref] = ACTIONS(1441),
    [anon_sym_LBRACE] = ACTIONS(1377),
    [anon_sym_delegate] = ACTIONS(1379),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1443),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1447),
    [anon_sym_TILDE] = ACTIONS(1447),
    [anon_sym_PLUS_PLUS] = ACTIONS(1447),
    [anon_sym_DASH_DASH] = ACTIONS(1447),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1445),
    [anon_sym_DASH] = ACTIONS(1445),
    [anon_sym_STAR] = ACTIONS(1449),
    [anon_sym_CARET] = ACTIONS(1447),
    [anon_sym_AMP] = ACTIONS(1447),
    [anon_sym_this] = ACTIONS(1393),
    [anon_sym_scoped] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1397),
    [sym_predefined_type] = ACTIONS(1399),
    [anon_sym_unchecked] = ACTIONS(1383),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1451),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1453),
    [anon_sym_DOT_DOT] = ACTIONS(1455),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_stackalloc] = ACTIONS(1413),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(1419),
    [anon_sym___reftype] = ACTIONS(1421),
    [anon_sym___refvalue] = ACTIONS(1423),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
  },
  [1593] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7027),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5781),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4329),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7402),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9167),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1593),
    [sym_preproc_endregion] = STATE(1593),
    [sym_preproc_line] = STATE(1593),
    [sym_preproc_pragma] = STATE(1593),
    [sym_preproc_nullable] = STATE(1593),
    [sym_preproc_error] = STATE(1593),
    [sym_preproc_define] = STATE(1593),
    [sym_preproc_undef] = STATE(1593),
    [aux_sym_class_declaration_repeat1] = STATE(3794),
    [aux_sym_lambda_expression_repeat1] = STATE(4293),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1693),
    [anon_sym_ref] = ACTIONS(1695),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1699),
    [anon_sym_TILDE] = ACTIONS(1699),
    [anon_sym_PLUS_PLUS] = ACTIONS(1699),
    [anon_sym_DASH_DASH] = ACTIONS(1699),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1697),
    [anon_sym_DASH] = ACTIONS(1697),
    [anon_sym_STAR] = ACTIONS(1701),
    [anon_sym_CARET] = ACTIONS(1699),
    [anon_sym_AMP] = ACTIONS(1699),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1703),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1705),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1594] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6894),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2955),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7025),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4797),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(3735),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7397),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9590),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1594),
    [sym_preproc_endregion] = STATE(1594),
    [sym_preproc_line] = STATE(1594),
    [sym_preproc_pragma] = STATE(1594),
    [sym_preproc_nullable] = STATE(1594),
    [sym_preproc_error] = STATE(1594),
    [sym_preproc_define] = STATE(1594),
    [sym_preproc_undef] = STATE(1594),
    [aux_sym_class_declaration_repeat1] = STATE(3844),
    [aux_sym_lambda_expression_repeat1] = STATE(4245),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1849),
    [anon_sym_ref] = ACTIONS(1851),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1853),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1857),
    [anon_sym_TILDE] = ACTIONS(1857),
    [anon_sym_PLUS_PLUS] = ACTIONS(1857),
    [anon_sym_DASH_DASH] = ACTIONS(1857),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1855),
    [anon_sym_DASH] = ACTIONS(1855),
    [anon_sym_STAR] = ACTIONS(1859),
    [anon_sym_CARET] = ACTIONS(1857),
    [anon_sym_AMP] = ACTIONS(1857),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1861),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1863),
    [anon_sym_DOT_DOT] = ACTIONS(1865),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1595] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6879),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2935),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7096),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(3826),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4288),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7379),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9175),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1595),
    [sym_preproc_endregion] = STATE(1595),
    [sym_preproc_line] = STATE(1595),
    [sym_preproc_pragma] = STATE(1595),
    [sym_preproc_nullable] = STATE(1595),
    [sym_preproc_error] = STATE(1595),
    [sym_preproc_define] = STATE(1595),
    [sym_preproc_undef] = STATE(1595),
    [aux_sym_class_declaration_repeat1] = STATE(3816),
    [aux_sym_lambda_expression_repeat1] = STATE(4119),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1867),
    [anon_sym_ref] = ACTIONS(1869),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1871),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1875),
    [anon_sym_TILDE] = ACTIONS(1875),
    [anon_sym_PLUS_PLUS] = ACTIONS(1875),
    [anon_sym_DASH_DASH] = ACTIONS(1875),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1873),
    [anon_sym_DASH] = ACTIONS(1873),
    [anon_sym_STAR] = ACTIONS(1877),
    [anon_sym_CARET] = ACTIONS(1875),
    [anon_sym_AMP] = ACTIONS(1875),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1879),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1881),
    [anon_sym_DOT_DOT] = ACTIONS(1883),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1596] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7064),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5181),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(3866),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7382),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9762),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1596),
    [sym_preproc_endregion] = STATE(1596),
    [sym_preproc_line] = STATE(1596),
    [sym_preproc_pragma] = STATE(1596),
    [sym_preproc_nullable] = STATE(1596),
    [sym_preproc_error] = STATE(1596),
    [sym_preproc_define] = STATE(1596),
    [sym_preproc_undef] = STATE(1596),
    [aux_sym_class_declaration_repeat1] = STATE(3842),
    [aux_sym_lambda_expression_repeat1] = STATE(4280),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1351),
    [anon_sym_ref] = ACTIONS(1353),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1357),
    [anon_sym_TILDE] = ACTIONS(1357),
    [anon_sym_PLUS_PLUS] = ACTIONS(1357),
    [anon_sym_DASH_DASH] = ACTIONS(1357),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1355),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(1357),
    [anon_sym_AMP] = ACTIONS(1357),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1361),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1363),
    [anon_sym_DOT_DOT] = ACTIONS(1365),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1597] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3921),
    [sym__name] = STATE(6889),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2854),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(7061),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5179),
    [sym_non_lvalue_expression] = STATE(5735),
    [sym_lvalue_expression] = STATE(3899),
    [sym__expression_statement_expression] = STATE(5733),
    [sym_assignment_expression] = STATE(5734),
    [sym_binary_expression] = STATE(5733),
    [sym_postfix_unary_expression] = STATE(5734),
    [sym_prefix_unary_expression] = STATE(5734),
    [sym__pointer_indirection_expression] = STATE(3911),
    [sym_query_expression] = STATE(5733),
    [sym_from_clause] = STATE(7400),
    [sym_conditional_expression] = STATE(5733),
    [sym_conditional_access_expression] = STATE(5733),
    [sym_as_expression] = STATE(5733),
    [sym_is_expression] = STATE(5733),
    [sym_is_pattern_expression] = STATE(5733),
    [sym_cast_expression] = STATE(5733),
    [sym_checked_expression] = STATE(5733),
    [sym_invocation_expression] = STATE(5734),
    [sym_switch_expression] = STATE(5733),
    [sym_await_expression] = STATE(5734),
    [sym_throw_expression] = STATE(5733),
    [sym_element_access_expression] = STATE(3911),
    [sym_interpolated_string_expression] = STATE(5733),
    [sym_member_access_expression] = STATE(3911),
    [sym_object_creation_expression] = STATE(5734),
    [sym_parenthesized_expression] = STATE(5734),
    [sym__parenthesized_lvalue_expression] = STATE(3911),
    [sym_lambda_expression] = STATE(5733),
    [sym__lambda_parameters] = STATE(9790),
    [sym_array_creation_expression] = STATE(5733),
    [sym_anonymous_method_expression] = STATE(5733),
    [sym_anonymous_object_creation_expression] = STATE(5733),
    [sym_implicit_array_creation_expression] = STATE(5733),
    [sym_implicit_object_creation_expression] = STATE(5733),
    [sym_implicit_stackalloc_expression] = STATE(5733),
    [sym_initializer_expression] = STATE(5733),
    [sym_default_expression] = STATE(5733),
    [sym_with_expression] = STATE(5733),
    [sym_sizeof_expression] = STATE(5733),
    [sym_typeof_expression] = STATE(5733),
    [sym_makeref_expression] = STATE(5733),
    [sym_ref_expression] = STATE(5733),
    [sym_reftype_expression] = STATE(5733),
    [sym_refvalue_expression] = STATE(5733),
    [sym_stackalloc_expression] = STATE(5733),
    [sym_range_expression] = STATE(5733),
    [sym_tuple_expression] = STATE(3911),
    [sym_literal] = STATE(5733),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2798),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(5733),
    [sym_preproc_region] = STATE(1597),
    [sym_preproc_endregion] = STATE(1597),
    [sym_preproc_line] = STATE(1597),
    [sym_preproc_pragma] = STATE(1597),
    [sym_preproc_nullable] = STATE(1597),
    [sym_preproc_error] = STATE(1597),
    [sym_preproc_define] = STATE(1597),
    [sym_preproc_undef] = STATE(1597),
    [aux_sym_class_declaration_repeat1] = STATE(3833),
    [aux_sym_lambda_expression_repeat1] = STATE(4182),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_LPAREN] = ACTIONS(1439),
    [anon_sym_ref] = ACTIONS(1441),
    [anon_sym_LBRACE] = ACTIONS(1377),
    [anon_sym_delegate] = ACTIONS(1379),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1443),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1447),
    [anon_sym_TILDE] = ACTIONS(1447),
    [anon_sym_PLUS_PLUS] = ACTIONS(1447),
    [anon_sym_DASH_DASH] = ACTIONS(1447),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1445),
    [anon_sym_DASH] = ACTIONS(1445),
    [anon_sym_STAR] = ACTIONS(1449),
    [anon_sym_CARET] = ACTIONS(1447),
    [anon_sym_AMP] = ACTIONS(1447),
    [anon_sym_this] = ACTIONS(1393),
    [anon_sym_scoped] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1397),
    [sym_predefined_type] = ACTIONS(1399),
    [anon_sym_unchecked] = ACTIONS(1383),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1451),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1453),
    [anon_sym_DOT_DOT] = ACTIONS(1455),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_stackalloc] = ACTIONS(1413),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(1419),
    [anon_sym___reftype] = ACTIONS(1421),
    [anon_sym___refvalue] = ACTIONS(1423),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
  },
  [1598] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6888),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2882),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7048),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5286),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4019),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7409),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9210),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1598),
    [sym_preproc_endregion] = STATE(1598),
    [sym_preproc_line] = STATE(1598),
    [sym_preproc_pragma] = STATE(1598),
    [sym_preproc_nullable] = STATE(1598),
    [sym_preproc_error] = STATE(1598),
    [sym_preproc_define] = STATE(1598),
    [sym_preproc_undef] = STATE(1598),
    [aux_sym_class_declaration_repeat1] = STATE(3812),
    [aux_sym_lambda_expression_repeat1] = STATE(4146),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1709),
    [anon_sym_ref] = ACTIONS(1711),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1713),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1717),
    [anon_sym_TILDE] = ACTIONS(1717),
    [anon_sym_PLUS_PLUS] = ACTIONS(1717),
    [anon_sym_DASH_DASH] = ACTIONS(1717),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1715),
    [anon_sym_DASH] = ACTIONS(1715),
    [anon_sym_STAR] = ACTIONS(1719),
    [anon_sym_CARET] = ACTIONS(1717),
    [anon_sym_AMP] = ACTIONS(1717),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1721),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1723),
    [anon_sym_DOT_DOT] = ACTIONS(1725),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1599] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6879),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2935),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7096),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5635),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4288),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7379),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9175),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1599),
    [sym_preproc_endregion] = STATE(1599),
    [sym_preproc_line] = STATE(1599),
    [sym_preproc_pragma] = STATE(1599),
    [sym_preproc_nullable] = STATE(1599),
    [sym_preproc_error] = STATE(1599),
    [sym_preproc_define] = STATE(1599),
    [sym_preproc_undef] = STATE(1599),
    [aux_sym_class_declaration_repeat1] = STATE(3816),
    [aux_sym_lambda_expression_repeat1] = STATE(4119),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1867),
    [anon_sym_ref] = ACTIONS(1869),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1871),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1875),
    [anon_sym_TILDE] = ACTIONS(1875),
    [anon_sym_PLUS_PLUS] = ACTIONS(1875),
    [anon_sym_DASH_DASH] = ACTIONS(1875),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1873),
    [anon_sym_DASH] = ACTIONS(1873),
    [anon_sym_STAR] = ACTIONS(1877),
    [anon_sym_CARET] = ACTIONS(1875),
    [anon_sym_AMP] = ACTIONS(1875),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1879),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1881),
    [anon_sym_DOT_DOT] = ACTIONS(1883),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1600] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6879),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2935),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7096),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5634),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4288),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7379),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9175),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1600),
    [sym_preproc_endregion] = STATE(1600),
    [sym_preproc_line] = STATE(1600),
    [sym_preproc_pragma] = STATE(1600),
    [sym_preproc_nullable] = STATE(1600),
    [sym_preproc_error] = STATE(1600),
    [sym_preproc_define] = STATE(1600),
    [sym_preproc_undef] = STATE(1600),
    [aux_sym_class_declaration_repeat1] = STATE(3816),
    [aux_sym_lambda_expression_repeat1] = STATE(4119),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1867),
    [anon_sym_ref] = ACTIONS(1869),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1871),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1875),
    [anon_sym_TILDE] = ACTIONS(1875),
    [anon_sym_PLUS_PLUS] = ACTIONS(1875),
    [anon_sym_DASH_DASH] = ACTIONS(1875),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1873),
    [anon_sym_DASH] = ACTIONS(1873),
    [anon_sym_STAR] = ACTIONS(1877),
    [anon_sym_CARET] = ACTIONS(1875),
    [anon_sym_AMP] = ACTIONS(1875),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1879),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1881),
    [anon_sym_DOT_DOT] = ACTIONS(1883),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1601] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6879),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2935),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7096),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5633),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4288),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7379),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9175),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1601),
    [sym_preproc_endregion] = STATE(1601),
    [sym_preproc_line] = STATE(1601),
    [sym_preproc_pragma] = STATE(1601),
    [sym_preproc_nullable] = STATE(1601),
    [sym_preproc_error] = STATE(1601),
    [sym_preproc_define] = STATE(1601),
    [sym_preproc_undef] = STATE(1601),
    [aux_sym_class_declaration_repeat1] = STATE(3816),
    [aux_sym_lambda_expression_repeat1] = STATE(4119),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1867),
    [anon_sym_ref] = ACTIONS(1869),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1871),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1875),
    [anon_sym_TILDE] = ACTIONS(1875),
    [anon_sym_PLUS_PLUS] = ACTIONS(1875),
    [anon_sym_DASH_DASH] = ACTIONS(1875),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1873),
    [anon_sym_DASH] = ACTIONS(1873),
    [anon_sym_STAR] = ACTIONS(1877),
    [anon_sym_CARET] = ACTIONS(1875),
    [anon_sym_AMP] = ACTIONS(1875),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1879),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1881),
    [anon_sym_DOT_DOT] = ACTIONS(1883),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1602] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3921),
    [sym__name] = STATE(6889),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2854),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(7061),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5174),
    [sym_non_lvalue_expression] = STATE(5735),
    [sym_lvalue_expression] = STATE(3899),
    [sym__expression_statement_expression] = STATE(5733),
    [sym_assignment_expression] = STATE(5734),
    [sym_binary_expression] = STATE(5733),
    [sym_postfix_unary_expression] = STATE(5734),
    [sym_prefix_unary_expression] = STATE(5734),
    [sym__pointer_indirection_expression] = STATE(3911),
    [sym_query_expression] = STATE(5733),
    [sym_from_clause] = STATE(7400),
    [sym_conditional_expression] = STATE(5733),
    [sym_conditional_access_expression] = STATE(5733),
    [sym_as_expression] = STATE(5733),
    [sym_is_expression] = STATE(5733),
    [sym_is_pattern_expression] = STATE(5733),
    [sym_cast_expression] = STATE(5733),
    [sym_checked_expression] = STATE(5733),
    [sym_invocation_expression] = STATE(5734),
    [sym_switch_expression] = STATE(5733),
    [sym_await_expression] = STATE(5734),
    [sym_throw_expression] = STATE(5733),
    [sym_element_access_expression] = STATE(3911),
    [sym_interpolated_string_expression] = STATE(5733),
    [sym_member_access_expression] = STATE(3911),
    [sym_object_creation_expression] = STATE(5734),
    [sym_parenthesized_expression] = STATE(5734),
    [sym__parenthesized_lvalue_expression] = STATE(3911),
    [sym_lambda_expression] = STATE(5733),
    [sym__lambda_parameters] = STATE(9790),
    [sym_array_creation_expression] = STATE(5733),
    [sym_anonymous_method_expression] = STATE(5733),
    [sym_anonymous_object_creation_expression] = STATE(5733),
    [sym_implicit_array_creation_expression] = STATE(5733),
    [sym_implicit_object_creation_expression] = STATE(5733),
    [sym_implicit_stackalloc_expression] = STATE(5733),
    [sym_initializer_expression] = STATE(5733),
    [sym_default_expression] = STATE(5733),
    [sym_with_expression] = STATE(5733),
    [sym_sizeof_expression] = STATE(5733),
    [sym_typeof_expression] = STATE(5733),
    [sym_makeref_expression] = STATE(5733),
    [sym_ref_expression] = STATE(5733),
    [sym_reftype_expression] = STATE(5733),
    [sym_refvalue_expression] = STATE(5733),
    [sym_stackalloc_expression] = STATE(5733),
    [sym_range_expression] = STATE(5733),
    [sym_tuple_expression] = STATE(3911),
    [sym_literal] = STATE(5733),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2798),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(5733),
    [sym_preproc_region] = STATE(1602),
    [sym_preproc_endregion] = STATE(1602),
    [sym_preproc_line] = STATE(1602),
    [sym_preproc_pragma] = STATE(1602),
    [sym_preproc_nullable] = STATE(1602),
    [sym_preproc_error] = STATE(1602),
    [sym_preproc_define] = STATE(1602),
    [sym_preproc_undef] = STATE(1602),
    [aux_sym_class_declaration_repeat1] = STATE(3833),
    [aux_sym_lambda_expression_repeat1] = STATE(4182),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_LPAREN] = ACTIONS(1439),
    [anon_sym_ref] = ACTIONS(1441),
    [anon_sym_LBRACE] = ACTIONS(1377),
    [anon_sym_delegate] = ACTIONS(1379),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1443),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1447),
    [anon_sym_TILDE] = ACTIONS(1447),
    [anon_sym_PLUS_PLUS] = ACTIONS(1447),
    [anon_sym_DASH_DASH] = ACTIONS(1447),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1445),
    [anon_sym_DASH] = ACTIONS(1445),
    [anon_sym_STAR] = ACTIONS(1449),
    [anon_sym_CARET] = ACTIONS(1447),
    [anon_sym_AMP] = ACTIONS(1447),
    [anon_sym_this] = ACTIONS(1393),
    [anon_sym_scoped] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1397),
    [sym_predefined_type] = ACTIONS(1399),
    [anon_sym_unchecked] = ACTIONS(1383),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1451),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1453),
    [anon_sym_DOT_DOT] = ACTIONS(1455),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_stackalloc] = ACTIONS(1413),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(1419),
    [anon_sym___reftype] = ACTIONS(1421),
    [anon_sym___refvalue] = ACTIONS(1423),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
  },
  [1603] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6879),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2935),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7096),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5631),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4288),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7379),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9175),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1603),
    [sym_preproc_endregion] = STATE(1603),
    [sym_preproc_line] = STATE(1603),
    [sym_preproc_pragma] = STATE(1603),
    [sym_preproc_nullable] = STATE(1603),
    [sym_preproc_error] = STATE(1603),
    [sym_preproc_define] = STATE(1603),
    [sym_preproc_undef] = STATE(1603),
    [aux_sym_class_declaration_repeat1] = STATE(3816),
    [aux_sym_lambda_expression_repeat1] = STATE(4119),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1867),
    [anon_sym_ref] = ACTIONS(1869),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1871),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1875),
    [anon_sym_TILDE] = ACTIONS(1875),
    [anon_sym_PLUS_PLUS] = ACTIONS(1875),
    [anon_sym_DASH_DASH] = ACTIONS(1875),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1873),
    [anon_sym_DASH] = ACTIONS(1873),
    [anon_sym_STAR] = ACTIONS(1877),
    [anon_sym_CARET] = ACTIONS(1875),
    [anon_sym_AMP] = ACTIONS(1875),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1879),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1881),
    [anon_sym_DOT_DOT] = ACTIONS(1883),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1604] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6879),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2935),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7096),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5414),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4288),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7379),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9175),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1604),
    [sym_preproc_endregion] = STATE(1604),
    [sym_preproc_line] = STATE(1604),
    [sym_preproc_pragma] = STATE(1604),
    [sym_preproc_nullable] = STATE(1604),
    [sym_preproc_error] = STATE(1604),
    [sym_preproc_define] = STATE(1604),
    [sym_preproc_undef] = STATE(1604),
    [aux_sym_class_declaration_repeat1] = STATE(3816),
    [aux_sym_lambda_expression_repeat1] = STATE(4119),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1867),
    [anon_sym_ref] = ACTIONS(1869),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1871),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1875),
    [anon_sym_TILDE] = ACTIONS(1875),
    [anon_sym_PLUS_PLUS] = ACTIONS(1875),
    [anon_sym_DASH_DASH] = ACTIONS(1875),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1873),
    [anon_sym_DASH] = ACTIONS(1873),
    [anon_sym_STAR] = ACTIONS(1877),
    [anon_sym_CARET] = ACTIONS(1875),
    [anon_sym_AMP] = ACTIONS(1875),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1879),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1881),
    [anon_sym_DOT_DOT] = ACTIONS(1883),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1605] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6879),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2935),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7096),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5629),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4288),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7379),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9175),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1605),
    [sym_preproc_endregion] = STATE(1605),
    [sym_preproc_line] = STATE(1605),
    [sym_preproc_pragma] = STATE(1605),
    [sym_preproc_nullable] = STATE(1605),
    [sym_preproc_error] = STATE(1605),
    [sym_preproc_define] = STATE(1605),
    [sym_preproc_undef] = STATE(1605),
    [aux_sym_class_declaration_repeat1] = STATE(3816),
    [aux_sym_lambda_expression_repeat1] = STATE(4119),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1867),
    [anon_sym_ref] = ACTIONS(1869),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1871),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1875),
    [anon_sym_TILDE] = ACTIONS(1875),
    [anon_sym_PLUS_PLUS] = ACTIONS(1875),
    [anon_sym_DASH_DASH] = ACTIONS(1875),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1873),
    [anon_sym_DASH] = ACTIONS(1873),
    [anon_sym_STAR] = ACTIONS(1877),
    [anon_sym_CARET] = ACTIONS(1875),
    [anon_sym_AMP] = ACTIONS(1875),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1879),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1881),
    [anon_sym_DOT_DOT] = ACTIONS(1883),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1606] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6879),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2935),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7096),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5628),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4288),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7379),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9175),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1606),
    [sym_preproc_endregion] = STATE(1606),
    [sym_preproc_line] = STATE(1606),
    [sym_preproc_pragma] = STATE(1606),
    [sym_preproc_nullable] = STATE(1606),
    [sym_preproc_error] = STATE(1606),
    [sym_preproc_define] = STATE(1606),
    [sym_preproc_undef] = STATE(1606),
    [aux_sym_class_declaration_repeat1] = STATE(3816),
    [aux_sym_lambda_expression_repeat1] = STATE(4119),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1867),
    [anon_sym_ref] = ACTIONS(1869),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1871),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1875),
    [anon_sym_TILDE] = ACTIONS(1875),
    [anon_sym_PLUS_PLUS] = ACTIONS(1875),
    [anon_sym_DASH_DASH] = ACTIONS(1875),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1873),
    [anon_sym_DASH] = ACTIONS(1873),
    [anon_sym_STAR] = ACTIONS(1877),
    [anon_sym_CARET] = ACTIONS(1875),
    [anon_sym_AMP] = ACTIONS(1875),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1879),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1881),
    [anon_sym_DOT_DOT] = ACTIONS(1883),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1607] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3921),
    [sym__name] = STATE(6919),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2868),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(6950),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5120),
    [sym_non_lvalue_expression] = STATE(5735),
    [sym_lvalue_expression] = STATE(4054),
    [sym__expression_statement_expression] = STATE(5733),
    [sym_assignment_expression] = STATE(5734),
    [sym_binary_expression] = STATE(5733),
    [sym_postfix_unary_expression] = STATE(5734),
    [sym_prefix_unary_expression] = STATE(5734),
    [sym__pointer_indirection_expression] = STATE(3911),
    [sym_query_expression] = STATE(5733),
    [sym_from_clause] = STATE(7400),
    [sym_conditional_expression] = STATE(5733),
    [sym_conditional_access_expression] = STATE(5733),
    [sym_as_expression] = STATE(5733),
    [sym_is_expression] = STATE(5733),
    [sym_is_pattern_expression] = STATE(5733),
    [sym_cast_expression] = STATE(5733),
    [sym_checked_expression] = STATE(5733),
    [sym_invocation_expression] = STATE(5734),
    [sym_switch_expression] = STATE(5733),
    [sym_await_expression] = STATE(5734),
    [sym_throw_expression] = STATE(5733),
    [sym_element_access_expression] = STATE(3911),
    [sym_interpolated_string_expression] = STATE(5733),
    [sym_member_access_expression] = STATE(3911),
    [sym_object_creation_expression] = STATE(5734),
    [sym_parenthesized_expression] = STATE(5734),
    [sym__parenthesized_lvalue_expression] = STATE(3911),
    [sym_lambda_expression] = STATE(5733),
    [sym__lambda_parameters] = STATE(9693),
    [sym_array_creation_expression] = STATE(5733),
    [sym_anonymous_method_expression] = STATE(5733),
    [sym_anonymous_object_creation_expression] = STATE(5733),
    [sym_implicit_array_creation_expression] = STATE(5733),
    [sym_implicit_object_creation_expression] = STATE(5733),
    [sym_implicit_stackalloc_expression] = STATE(5733),
    [sym_initializer_expression] = STATE(5733),
    [sym_default_expression] = STATE(5733),
    [sym_with_expression] = STATE(5733),
    [sym_sizeof_expression] = STATE(5733),
    [sym_typeof_expression] = STATE(5733),
    [sym_makeref_expression] = STATE(5733),
    [sym_ref_expression] = STATE(5733),
    [sym_reftype_expression] = STATE(5733),
    [sym_refvalue_expression] = STATE(5733),
    [sym_stackalloc_expression] = STATE(5733),
    [sym_range_expression] = STATE(5733),
    [sym_tuple_expression] = STATE(3911),
    [sym_literal] = STATE(5733),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2798),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(5733),
    [sym_preproc_region] = STATE(1607),
    [sym_preproc_endregion] = STATE(1607),
    [sym_preproc_line] = STATE(1607),
    [sym_preproc_pragma] = STATE(1607),
    [sym_preproc_nullable] = STATE(1607),
    [sym_preproc_error] = STATE(1607),
    [sym_preproc_define] = STATE(1607),
    [sym_preproc_undef] = STATE(1607),
    [aux_sym_class_declaration_repeat1] = STATE(3791),
    [aux_sym_lambda_expression_repeat1] = STATE(4075),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_LPAREN] = ACTIONS(1373),
    [anon_sym_ref] = ACTIONS(1375),
    [anon_sym_LBRACE] = ACTIONS(1377),
    [anon_sym_delegate] = ACTIONS(1379),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1381),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1387),
    [anon_sym_TILDE] = ACTIONS(1387),
    [anon_sym_PLUS_PLUS] = ACTIONS(1387),
    [anon_sym_DASH_DASH] = ACTIONS(1387),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1385),
    [anon_sym_DASH] = ACTIONS(1385),
    [anon_sym_STAR] = ACTIONS(1391),
    [anon_sym_CARET] = ACTIONS(1387),
    [anon_sym_AMP] = ACTIONS(1387),
    [anon_sym_this] = ACTIONS(1393),
    [anon_sym_scoped] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1397),
    [sym_predefined_type] = ACTIONS(1399),
    [anon_sym_unchecked] = ACTIONS(1383),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1403),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1405),
    [anon_sym_DOT_DOT] = ACTIONS(1407),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_stackalloc] = ACTIONS(1413),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(1419),
    [anon_sym___reftype] = ACTIONS(1421),
    [anon_sym___refvalue] = ACTIONS(1423),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
  },
  [1608] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6879),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2935),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7096),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5627),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4288),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7379),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9175),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1608),
    [sym_preproc_endregion] = STATE(1608),
    [sym_preproc_line] = STATE(1608),
    [sym_preproc_pragma] = STATE(1608),
    [sym_preproc_nullable] = STATE(1608),
    [sym_preproc_error] = STATE(1608),
    [sym_preproc_define] = STATE(1608),
    [sym_preproc_undef] = STATE(1608),
    [aux_sym_class_declaration_repeat1] = STATE(3816),
    [aux_sym_lambda_expression_repeat1] = STATE(4119),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1867),
    [anon_sym_ref] = ACTIONS(1869),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1871),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1875),
    [anon_sym_TILDE] = ACTIONS(1875),
    [anon_sym_PLUS_PLUS] = ACTIONS(1875),
    [anon_sym_DASH_DASH] = ACTIONS(1875),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1873),
    [anon_sym_DASH] = ACTIONS(1873),
    [anon_sym_STAR] = ACTIONS(1877),
    [anon_sym_CARET] = ACTIONS(1875),
    [anon_sym_AMP] = ACTIONS(1875),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1879),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1881),
    [anon_sym_DOT_DOT] = ACTIONS(1883),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1609] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6879),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2935),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7096),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5473),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4288),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7379),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9175),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1609),
    [sym_preproc_endregion] = STATE(1609),
    [sym_preproc_line] = STATE(1609),
    [sym_preproc_pragma] = STATE(1609),
    [sym_preproc_nullable] = STATE(1609),
    [sym_preproc_error] = STATE(1609),
    [sym_preproc_define] = STATE(1609),
    [sym_preproc_undef] = STATE(1609),
    [aux_sym_class_declaration_repeat1] = STATE(3816),
    [aux_sym_lambda_expression_repeat1] = STATE(4119),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1867),
    [anon_sym_ref] = ACTIONS(1869),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1871),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1875),
    [anon_sym_TILDE] = ACTIONS(1875),
    [anon_sym_PLUS_PLUS] = ACTIONS(1875),
    [anon_sym_DASH_DASH] = ACTIONS(1875),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1873),
    [anon_sym_DASH] = ACTIONS(1873),
    [anon_sym_STAR] = ACTIONS(1877),
    [anon_sym_CARET] = ACTIONS(1875),
    [anon_sym_AMP] = ACTIONS(1875),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1879),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1881),
    [anon_sym_DOT_DOT] = ACTIONS(1883),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1610] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6879),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2935),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7096),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5415),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4288),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7379),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9175),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1610),
    [sym_preproc_endregion] = STATE(1610),
    [sym_preproc_line] = STATE(1610),
    [sym_preproc_pragma] = STATE(1610),
    [sym_preproc_nullable] = STATE(1610),
    [sym_preproc_error] = STATE(1610),
    [sym_preproc_define] = STATE(1610),
    [sym_preproc_undef] = STATE(1610),
    [aux_sym_class_declaration_repeat1] = STATE(3816),
    [aux_sym_lambda_expression_repeat1] = STATE(4119),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1867),
    [anon_sym_ref] = ACTIONS(1869),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1871),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1875),
    [anon_sym_TILDE] = ACTIONS(1875),
    [anon_sym_PLUS_PLUS] = ACTIONS(1875),
    [anon_sym_DASH_DASH] = ACTIONS(1875),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1873),
    [anon_sym_DASH] = ACTIONS(1873),
    [anon_sym_STAR] = ACTIONS(1877),
    [anon_sym_CARET] = ACTIONS(1875),
    [anon_sym_AMP] = ACTIONS(1875),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1879),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1881),
    [anon_sym_DOT_DOT] = ACTIONS(1883),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1611] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7080),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6445),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4477),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9873),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1611),
    [sym_preproc_endregion] = STATE(1611),
    [sym_preproc_line] = STATE(1611),
    [sym_preproc_pragma] = STATE(1611),
    [sym_preproc_nullable] = STATE(1611),
    [sym_preproc_error] = STATE(1611),
    [sym_preproc_define] = STATE(1611),
    [sym_preproc_undef] = STATE(1611),
    [aux_sym_class_declaration_repeat1] = STATE(3845),
    [aux_sym_lambda_expression_repeat1] = STATE(4299),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1979),
    [anon_sym_ref] = ACTIONS(1981),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1985),
    [anon_sym_TILDE] = ACTIONS(1985),
    [anon_sym_PLUS_PLUS] = ACTIONS(1985),
    [anon_sym_DASH_DASH] = ACTIONS(1985),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1983),
    [anon_sym_DASH] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1985),
    [anon_sym_AMP] = ACTIONS(1985),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1987),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1989),
    [anon_sym_DOT_DOT] = ACTIONS(1991),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1612] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6332),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1612),
    [sym_preproc_endregion] = STATE(1612),
    [sym_preproc_line] = STATE(1612),
    [sym_preproc_pragma] = STATE(1612),
    [sym_preproc_nullable] = STATE(1612),
    [sym_preproc_error] = STATE(1612),
    [sym_preproc_define] = STATE(1612),
    [sym_preproc_undef] = STATE(1612),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1613] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7080),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4309),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4477),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9873),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1613),
    [sym_preproc_endregion] = STATE(1613),
    [sym_preproc_line] = STATE(1613),
    [sym_preproc_pragma] = STATE(1613),
    [sym_preproc_nullable] = STATE(1613),
    [sym_preproc_error] = STATE(1613),
    [sym_preproc_define] = STATE(1613),
    [sym_preproc_undef] = STATE(1613),
    [aux_sym_class_declaration_repeat1] = STATE(3845),
    [aux_sym_lambda_expression_repeat1] = STATE(4299),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1979),
    [anon_sym_ref] = ACTIONS(1981),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1985),
    [anon_sym_TILDE] = ACTIONS(1985),
    [anon_sym_PLUS_PLUS] = ACTIONS(1985),
    [anon_sym_DASH_DASH] = ACTIONS(1985),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1983),
    [anon_sym_DASH] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1985),
    [anon_sym_AMP] = ACTIONS(1985),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1987),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1989),
    [anon_sym_DOT_DOT] = ACTIONS(1991),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1614] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6913),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7016),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4483),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(3582),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7407),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9275),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1614),
    [sym_preproc_endregion] = STATE(1614),
    [sym_preproc_line] = STATE(1614),
    [sym_preproc_pragma] = STATE(1614),
    [sym_preproc_nullable] = STATE(1614),
    [sym_preproc_error] = STATE(1614),
    [sym_preproc_define] = STATE(1614),
    [sym_preproc_undef] = STATE(1614),
    [aux_sym_class_declaration_repeat1] = STATE(3789),
    [aux_sym_lambda_expression_repeat1] = STATE(4086),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1137),
    [anon_sym_ref] = ACTIONS(1139),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1145),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1153),
    [anon_sym_TILDE] = ACTIONS(1153),
    [anon_sym_PLUS_PLUS] = ACTIONS(1153),
    [anon_sym_DASH_DASH] = ACTIONS(1153),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1151),
    [anon_sym_DASH] = ACTIONS(1151),
    [anon_sym_STAR] = ACTIONS(1157),
    [anon_sym_CARET] = ACTIONS(1153),
    [anon_sym_AMP] = ACTIONS(1153),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1165),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1167),
    [anon_sym_DOT_DOT] = ACTIONS(1169),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1615] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6879),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2935),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7096),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5416),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4288),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7379),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9175),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1615),
    [sym_preproc_endregion] = STATE(1615),
    [sym_preproc_line] = STATE(1615),
    [sym_preproc_pragma] = STATE(1615),
    [sym_preproc_nullable] = STATE(1615),
    [sym_preproc_error] = STATE(1615),
    [sym_preproc_define] = STATE(1615),
    [sym_preproc_undef] = STATE(1615),
    [aux_sym_class_declaration_repeat1] = STATE(3816),
    [aux_sym_lambda_expression_repeat1] = STATE(4119),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1867),
    [anon_sym_ref] = ACTIONS(1869),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1871),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1875),
    [anon_sym_TILDE] = ACTIONS(1875),
    [anon_sym_PLUS_PLUS] = ACTIONS(1875),
    [anon_sym_DASH_DASH] = ACTIONS(1875),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1873),
    [anon_sym_DASH] = ACTIONS(1873),
    [anon_sym_STAR] = ACTIONS(1877),
    [anon_sym_CARET] = ACTIONS(1875),
    [anon_sym_AMP] = ACTIONS(1875),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1879),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1881),
    [anon_sym_DOT_DOT] = ACTIONS(1883),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1616] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6888),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2882),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7048),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(3822),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4019),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7409),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9210),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1616),
    [sym_preproc_endregion] = STATE(1616),
    [sym_preproc_line] = STATE(1616),
    [sym_preproc_pragma] = STATE(1616),
    [sym_preproc_nullable] = STATE(1616),
    [sym_preproc_error] = STATE(1616),
    [sym_preproc_define] = STATE(1616),
    [sym_preproc_undef] = STATE(1616),
    [aux_sym_class_declaration_repeat1] = STATE(3812),
    [aux_sym_lambda_expression_repeat1] = STATE(4146),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1709),
    [anon_sym_ref] = ACTIONS(1711),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1713),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1717),
    [anon_sym_TILDE] = ACTIONS(1717),
    [anon_sym_PLUS_PLUS] = ACTIONS(1717),
    [anon_sym_DASH_DASH] = ACTIONS(1717),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1715),
    [anon_sym_DASH] = ACTIONS(1715),
    [anon_sym_STAR] = ACTIONS(1719),
    [anon_sym_CARET] = ACTIONS(1717),
    [anon_sym_AMP] = ACTIONS(1717),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1721),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1723),
    [anon_sym_DOT_DOT] = ACTIONS(1725),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1617] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6888),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2882),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7048),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5279),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4019),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7409),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9210),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1617),
    [sym_preproc_endregion] = STATE(1617),
    [sym_preproc_line] = STATE(1617),
    [sym_preproc_pragma] = STATE(1617),
    [sym_preproc_nullable] = STATE(1617),
    [sym_preproc_error] = STATE(1617),
    [sym_preproc_define] = STATE(1617),
    [sym_preproc_undef] = STATE(1617),
    [aux_sym_class_declaration_repeat1] = STATE(3812),
    [aux_sym_lambda_expression_repeat1] = STATE(4146),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1709),
    [anon_sym_ref] = ACTIONS(1711),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1713),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1717),
    [anon_sym_TILDE] = ACTIONS(1717),
    [anon_sym_PLUS_PLUS] = ACTIONS(1717),
    [anon_sym_DASH_DASH] = ACTIONS(1717),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1715),
    [anon_sym_DASH] = ACTIONS(1715),
    [anon_sym_STAR] = ACTIONS(1719),
    [anon_sym_CARET] = ACTIONS(1717),
    [anon_sym_AMP] = ACTIONS(1717),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1721),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1723),
    [anon_sym_DOT_DOT] = ACTIONS(1725),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1618] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6913),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7016),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(3822),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(3582),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7407),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9275),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1618),
    [sym_preproc_endregion] = STATE(1618),
    [sym_preproc_line] = STATE(1618),
    [sym_preproc_pragma] = STATE(1618),
    [sym_preproc_nullable] = STATE(1618),
    [sym_preproc_error] = STATE(1618),
    [sym_preproc_define] = STATE(1618),
    [sym_preproc_undef] = STATE(1618),
    [aux_sym_class_declaration_repeat1] = STATE(3789),
    [aux_sym_lambda_expression_repeat1] = STATE(4086),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1137),
    [anon_sym_ref] = ACTIONS(1139),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1145),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1153),
    [anon_sym_TILDE] = ACTIONS(1153),
    [anon_sym_PLUS_PLUS] = ACTIONS(1153),
    [anon_sym_DASH_DASH] = ACTIONS(1153),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1151),
    [anon_sym_DASH] = ACTIONS(1151),
    [anon_sym_STAR] = ACTIONS(1157),
    [anon_sym_CARET] = ACTIONS(1153),
    [anon_sym_AMP] = ACTIONS(1153),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1165),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1167),
    [anon_sym_DOT_DOT] = ACTIONS(1169),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1619] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6913),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7016),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4484),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(3582),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7407),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9275),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1619),
    [sym_preproc_endregion] = STATE(1619),
    [sym_preproc_line] = STATE(1619),
    [sym_preproc_pragma] = STATE(1619),
    [sym_preproc_nullable] = STATE(1619),
    [sym_preproc_error] = STATE(1619),
    [sym_preproc_define] = STATE(1619),
    [sym_preproc_undef] = STATE(1619),
    [aux_sym_class_declaration_repeat1] = STATE(3789),
    [aux_sym_lambda_expression_repeat1] = STATE(4086),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1137),
    [anon_sym_ref] = ACTIONS(1139),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1145),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1153),
    [anon_sym_TILDE] = ACTIONS(1153),
    [anon_sym_PLUS_PLUS] = ACTIONS(1153),
    [anon_sym_DASH_DASH] = ACTIONS(1153),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1151),
    [anon_sym_DASH] = ACTIONS(1151),
    [anon_sym_STAR] = ACTIONS(1157),
    [anon_sym_CARET] = ACTIONS(1153),
    [anon_sym_AMP] = ACTIONS(1153),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1165),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1167),
    [anon_sym_DOT_DOT] = ACTIONS(1169),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1620] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6913),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7016),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4485),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(3582),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7407),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9275),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1620),
    [sym_preproc_endregion] = STATE(1620),
    [sym_preproc_line] = STATE(1620),
    [sym_preproc_pragma] = STATE(1620),
    [sym_preproc_nullable] = STATE(1620),
    [sym_preproc_error] = STATE(1620),
    [sym_preproc_define] = STATE(1620),
    [sym_preproc_undef] = STATE(1620),
    [aux_sym_class_declaration_repeat1] = STATE(3789),
    [aux_sym_lambda_expression_repeat1] = STATE(4086),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1137),
    [anon_sym_ref] = ACTIONS(1139),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1145),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1153),
    [anon_sym_TILDE] = ACTIONS(1153),
    [anon_sym_PLUS_PLUS] = ACTIONS(1153),
    [anon_sym_DASH_DASH] = ACTIONS(1153),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1151),
    [anon_sym_DASH] = ACTIONS(1151),
    [anon_sym_STAR] = ACTIONS(1157),
    [anon_sym_CARET] = ACTIONS(1153),
    [anon_sym_AMP] = ACTIONS(1153),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1165),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1167),
    [anon_sym_DOT_DOT] = ACTIONS(1169),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1621] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6987),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6553),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4462),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7405),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9130),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1621),
    [sym_preproc_endregion] = STATE(1621),
    [sym_preproc_line] = STATE(1621),
    [sym_preproc_pragma] = STATE(1621),
    [sym_preproc_nullable] = STATE(1621),
    [sym_preproc_error] = STATE(1621),
    [sym_preproc_define] = STATE(1621),
    [sym_preproc_undef] = STATE(1621),
    [aux_sym_class_declaration_repeat1] = STATE(3855),
    [aux_sym_lambda_expression_repeat1] = STATE(4244),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2031),
    [anon_sym_ref] = ACTIONS(2033),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2037),
    [anon_sym_TILDE] = ACTIONS(2037),
    [anon_sym_PLUS_PLUS] = ACTIONS(2037),
    [anon_sym_DASH_DASH] = ACTIONS(2037),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2035),
    [anon_sym_DASH] = ACTIONS(2035),
    [anon_sym_STAR] = ACTIONS(2039),
    [anon_sym_CARET] = ACTIONS(2037),
    [anon_sym_AMP] = ACTIONS(2037),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2041),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2043),
    [anon_sym_DOT_DOT] = ACTIONS(2045),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1622] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6893),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2968),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7023),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6234),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4416),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7390),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9221),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1622),
    [sym_preproc_endregion] = STATE(1622),
    [sym_preproc_line] = STATE(1622),
    [sym_preproc_pragma] = STATE(1622),
    [sym_preproc_nullable] = STATE(1622),
    [sym_preproc_error] = STATE(1622),
    [sym_preproc_define] = STATE(1622),
    [sym_preproc_undef] = STATE(1622),
    [aux_sym_class_declaration_repeat1] = STATE(3808),
    [aux_sym_lambda_expression_repeat1] = STATE(4129),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_ref] = ACTIONS(2217),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(2223),
    [anon_sym_TILDE] = ACTIONS(2223),
    [anon_sym_PLUS_PLUS] = ACTIONS(2223),
    [anon_sym_DASH_DASH] = ACTIONS(2223),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2221),
    [anon_sym_DASH] = ACTIONS(2221),
    [anon_sym_STAR] = ACTIONS(2225),
    [anon_sym_CARET] = ACTIONS(2223),
    [anon_sym_AMP] = ACTIONS(2223),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2227),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2229),
    [anon_sym_DOT_DOT] = ACTIONS(2231),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1623] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6913),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7016),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4486),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(3582),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7407),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9275),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1623),
    [sym_preproc_endregion] = STATE(1623),
    [sym_preproc_line] = STATE(1623),
    [sym_preproc_pragma] = STATE(1623),
    [sym_preproc_nullable] = STATE(1623),
    [sym_preproc_error] = STATE(1623),
    [sym_preproc_define] = STATE(1623),
    [sym_preproc_undef] = STATE(1623),
    [aux_sym_class_declaration_repeat1] = STATE(3789),
    [aux_sym_lambda_expression_repeat1] = STATE(4086),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1137),
    [anon_sym_ref] = ACTIONS(1139),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1145),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1153),
    [anon_sym_TILDE] = ACTIONS(1153),
    [anon_sym_PLUS_PLUS] = ACTIONS(1153),
    [anon_sym_DASH_DASH] = ACTIONS(1153),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1151),
    [anon_sym_DASH] = ACTIONS(1151),
    [anon_sym_STAR] = ACTIONS(1157),
    [anon_sym_CARET] = ACTIONS(1153),
    [anon_sym_AMP] = ACTIONS(1153),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1165),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1167),
    [anon_sym_DOT_DOT] = ACTIONS(1169),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1624] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6913),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7016),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4487),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(3582),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7407),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9275),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1624),
    [sym_preproc_endregion] = STATE(1624),
    [sym_preproc_line] = STATE(1624),
    [sym_preproc_pragma] = STATE(1624),
    [sym_preproc_nullable] = STATE(1624),
    [sym_preproc_error] = STATE(1624),
    [sym_preproc_define] = STATE(1624),
    [sym_preproc_undef] = STATE(1624),
    [aux_sym_class_declaration_repeat1] = STATE(3789),
    [aux_sym_lambda_expression_repeat1] = STATE(4086),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1137),
    [anon_sym_ref] = ACTIONS(1139),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1145),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1153),
    [anon_sym_TILDE] = ACTIONS(1153),
    [anon_sym_PLUS_PLUS] = ACTIONS(1153),
    [anon_sym_DASH_DASH] = ACTIONS(1153),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1151),
    [anon_sym_DASH] = ACTIONS(1151),
    [anon_sym_STAR] = ACTIONS(1157),
    [anon_sym_CARET] = ACTIONS(1153),
    [anon_sym_AMP] = ACTIONS(1153),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1165),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1167),
    [anon_sym_DOT_DOT] = ACTIONS(1169),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1625] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6913),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7016),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4488),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(3582),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7407),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9275),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1625),
    [sym_preproc_endregion] = STATE(1625),
    [sym_preproc_line] = STATE(1625),
    [sym_preproc_pragma] = STATE(1625),
    [sym_preproc_nullable] = STATE(1625),
    [sym_preproc_error] = STATE(1625),
    [sym_preproc_define] = STATE(1625),
    [sym_preproc_undef] = STATE(1625),
    [aux_sym_class_declaration_repeat1] = STATE(3789),
    [aux_sym_lambda_expression_repeat1] = STATE(4086),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1137),
    [anon_sym_ref] = ACTIONS(1139),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1145),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1153),
    [anon_sym_TILDE] = ACTIONS(1153),
    [anon_sym_PLUS_PLUS] = ACTIONS(1153),
    [anon_sym_DASH_DASH] = ACTIONS(1153),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1151),
    [anon_sym_DASH] = ACTIONS(1151),
    [anon_sym_STAR] = ACTIONS(1157),
    [anon_sym_CARET] = ACTIONS(1153),
    [anon_sym_AMP] = ACTIONS(1153),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1165),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1167),
    [anon_sym_DOT_DOT] = ACTIONS(1169),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1626] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6913),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7016),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4490),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(3582),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7407),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9275),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1626),
    [sym_preproc_endregion] = STATE(1626),
    [sym_preproc_line] = STATE(1626),
    [sym_preproc_pragma] = STATE(1626),
    [sym_preproc_nullable] = STATE(1626),
    [sym_preproc_error] = STATE(1626),
    [sym_preproc_define] = STATE(1626),
    [sym_preproc_undef] = STATE(1626),
    [aux_sym_class_declaration_repeat1] = STATE(3789),
    [aux_sym_lambda_expression_repeat1] = STATE(4086),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1137),
    [anon_sym_ref] = ACTIONS(1139),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1145),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1153),
    [anon_sym_TILDE] = ACTIONS(1153),
    [anon_sym_PLUS_PLUS] = ACTIONS(1153),
    [anon_sym_DASH_DASH] = ACTIONS(1153),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1151),
    [anon_sym_DASH] = ACTIONS(1151),
    [anon_sym_STAR] = ACTIONS(1157),
    [anon_sym_CARET] = ACTIONS(1153),
    [anon_sym_AMP] = ACTIONS(1153),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1165),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1167),
    [anon_sym_DOT_DOT] = ACTIONS(1169),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1627] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7027),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5942),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4329),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7402),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9167),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1627),
    [sym_preproc_endregion] = STATE(1627),
    [sym_preproc_line] = STATE(1627),
    [sym_preproc_pragma] = STATE(1627),
    [sym_preproc_nullable] = STATE(1627),
    [sym_preproc_error] = STATE(1627),
    [sym_preproc_define] = STATE(1627),
    [sym_preproc_undef] = STATE(1627),
    [aux_sym_class_declaration_repeat1] = STATE(3794),
    [aux_sym_lambda_expression_repeat1] = STATE(4293),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1693),
    [anon_sym_ref] = ACTIONS(1695),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1699),
    [anon_sym_TILDE] = ACTIONS(1699),
    [anon_sym_PLUS_PLUS] = ACTIONS(1699),
    [anon_sym_DASH_DASH] = ACTIONS(1699),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1697),
    [anon_sym_DASH] = ACTIONS(1697),
    [anon_sym_STAR] = ACTIONS(1701),
    [anon_sym_CARET] = ACTIONS(1699),
    [anon_sym_AMP] = ACTIONS(1699),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1703),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1705),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1628] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7027),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5943),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4329),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7402),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9167),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1628),
    [sym_preproc_endregion] = STATE(1628),
    [sym_preproc_line] = STATE(1628),
    [sym_preproc_pragma] = STATE(1628),
    [sym_preproc_nullable] = STATE(1628),
    [sym_preproc_error] = STATE(1628),
    [sym_preproc_define] = STATE(1628),
    [sym_preproc_undef] = STATE(1628),
    [aux_sym_class_declaration_repeat1] = STATE(3794),
    [aux_sym_lambda_expression_repeat1] = STATE(4293),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1693),
    [anon_sym_ref] = ACTIONS(1695),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1699),
    [anon_sym_TILDE] = ACTIONS(1699),
    [anon_sym_PLUS_PLUS] = ACTIONS(1699),
    [anon_sym_DASH_DASH] = ACTIONS(1699),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1697),
    [anon_sym_DASH] = ACTIONS(1697),
    [anon_sym_STAR] = ACTIONS(1701),
    [anon_sym_CARET] = ACTIONS(1699),
    [anon_sym_AMP] = ACTIONS(1699),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1703),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1705),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1629] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3559),
    [sym__name] = STATE(6878),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2911),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6938),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4753),
    [sym_non_lvalue_expression] = STATE(4553),
    [sym_lvalue_expression] = STATE(3750),
    [sym__expression_statement_expression] = STATE(4559),
    [sym_assignment_expression] = STATE(4558),
    [sym_binary_expression] = STATE(4559),
    [sym_postfix_unary_expression] = STATE(4558),
    [sym_prefix_unary_expression] = STATE(4558),
    [sym__pointer_indirection_expression] = STATE(3560),
    [sym_query_expression] = STATE(4559),
    [sym_from_clause] = STATE(7406),
    [sym_conditional_expression] = STATE(4559),
    [sym_conditional_access_expression] = STATE(4559),
    [sym_as_expression] = STATE(4559),
    [sym_is_expression] = STATE(4559),
    [sym_is_pattern_expression] = STATE(4559),
    [sym_cast_expression] = STATE(4559),
    [sym_checked_expression] = STATE(4559),
    [sym_invocation_expression] = STATE(4558),
    [sym_switch_expression] = STATE(4559),
    [sym_await_expression] = STATE(4558),
    [sym_throw_expression] = STATE(4559),
    [sym_element_access_expression] = STATE(3560),
    [sym_interpolated_string_expression] = STATE(4559),
    [sym_member_access_expression] = STATE(3560),
    [sym_object_creation_expression] = STATE(4558),
    [sym_parenthesized_expression] = STATE(4558),
    [sym__parenthesized_lvalue_expression] = STATE(3560),
    [sym_lambda_expression] = STATE(4559),
    [sym__lambda_parameters] = STATE(9691),
    [sym_array_creation_expression] = STATE(4559),
    [sym_anonymous_method_expression] = STATE(4559),
    [sym_anonymous_object_creation_expression] = STATE(4559),
    [sym_implicit_array_creation_expression] = STATE(4559),
    [sym_implicit_object_creation_expression] = STATE(4559),
    [sym_implicit_stackalloc_expression] = STATE(4559),
    [sym_initializer_expression] = STATE(4559),
    [sym_default_expression] = STATE(4559),
    [sym_with_expression] = STATE(4559),
    [sym_sizeof_expression] = STATE(4559),
    [sym_typeof_expression] = STATE(4559),
    [sym_makeref_expression] = STATE(4559),
    [sym_ref_expression] = STATE(4559),
    [sym_reftype_expression] = STATE(4559),
    [sym_refvalue_expression] = STATE(4559),
    [sym_stackalloc_expression] = STATE(4559),
    [sym_range_expression] = STATE(4559),
    [sym_tuple_expression] = STATE(3560),
    [sym_literal] = STATE(4559),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4559),
    [sym_preproc_region] = STATE(1629),
    [sym_preproc_endregion] = STATE(1629),
    [sym_preproc_line] = STATE(1629),
    [sym_preproc_pragma] = STATE(1629),
    [sym_preproc_nullable] = STATE(1629),
    [sym_preproc_error] = STATE(1629),
    [sym_preproc_define] = STATE(1629),
    [sym_preproc_undef] = STATE(1629),
    [aux_sym_class_declaration_repeat1] = STATE(3836),
    [aux_sym_lambda_expression_repeat1] = STATE(4216),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(2003),
    [anon_sym_ref] = ACTIONS(2005),
    [anon_sym_LBRACE] = ACTIONS(1611),
    [anon_sym_delegate] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1615),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(2009),
    [anon_sym_TILDE] = ACTIONS(2009),
    [anon_sym_PLUS_PLUS] = ACTIONS(2009),
    [anon_sym_DASH_DASH] = ACTIONS(2009),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(2007),
    [anon_sym_DASH] = ACTIONS(2007),
    [anon_sym_STAR] = ACTIONS(1625),
    [anon_sym_CARET] = ACTIONS(2009),
    [anon_sym_AMP] = ACTIONS(2009),
    [anon_sym_this] = ACTIONS(1627),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1629),
    [anon_sym_unchecked] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(2011),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2013),
    [anon_sym_DOT_DOT] = ACTIONS(2015),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_stackalloc] = ACTIONS(1641),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(1647),
    [anon_sym___reftype] = ACTIONS(1649),
    [anon_sym___refvalue] = ACTIONS(1651),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1659),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [1630] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6913),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7016),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4491),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(3582),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7407),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9275),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1630),
    [sym_preproc_endregion] = STATE(1630),
    [sym_preproc_line] = STATE(1630),
    [sym_preproc_pragma] = STATE(1630),
    [sym_preproc_nullable] = STATE(1630),
    [sym_preproc_error] = STATE(1630),
    [sym_preproc_define] = STATE(1630),
    [sym_preproc_undef] = STATE(1630),
    [aux_sym_class_declaration_repeat1] = STATE(3789),
    [aux_sym_lambda_expression_repeat1] = STATE(4086),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1137),
    [anon_sym_ref] = ACTIONS(1139),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1145),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1153),
    [anon_sym_TILDE] = ACTIONS(1153),
    [anon_sym_PLUS_PLUS] = ACTIONS(1153),
    [anon_sym_DASH_DASH] = ACTIONS(1153),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1151),
    [anon_sym_DASH] = ACTIONS(1151),
    [anon_sym_STAR] = ACTIONS(1157),
    [anon_sym_CARET] = ACTIONS(1153),
    [anon_sym_AMP] = ACTIONS(1153),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1165),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1167),
    [anon_sym_DOT_DOT] = ACTIONS(1169),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1631] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6880),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7104),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5118),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(3863),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7380),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9420),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1631),
    [sym_preproc_endregion] = STATE(1631),
    [sym_preproc_line] = STATE(1631),
    [sym_preproc_pragma] = STATE(1631),
    [sym_preproc_nullable] = STATE(1631),
    [sym_preproc_error] = STATE(1631),
    [sym_preproc_define] = STATE(1631),
    [sym_preproc_undef] = STATE(1631),
    [aux_sym_class_declaration_repeat1] = STATE(3820),
    [aux_sym_lambda_expression_repeat1] = STATE(4165),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1339),
    [anon_sym_ref] = ACTIONS(1341),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1097),
    [anon_sym_TILDE] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1099),
    [anon_sym_DASH] = ACTIONS(1099),
    [anon_sym_STAR] = ACTIONS(1343),
    [anon_sym_CARET] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1097),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1345),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1347),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1632] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7027),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5772),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4329),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7402),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9167),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1632),
    [sym_preproc_endregion] = STATE(1632),
    [sym_preproc_line] = STATE(1632),
    [sym_preproc_pragma] = STATE(1632),
    [sym_preproc_nullable] = STATE(1632),
    [sym_preproc_error] = STATE(1632),
    [sym_preproc_define] = STATE(1632),
    [sym_preproc_undef] = STATE(1632),
    [aux_sym_class_declaration_repeat1] = STATE(3794),
    [aux_sym_lambda_expression_repeat1] = STATE(4293),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1693),
    [anon_sym_ref] = ACTIONS(1695),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1699),
    [anon_sym_TILDE] = ACTIONS(1699),
    [anon_sym_PLUS_PLUS] = ACTIONS(1699),
    [anon_sym_DASH_DASH] = ACTIONS(1699),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1697),
    [anon_sym_DASH] = ACTIONS(1697),
    [anon_sym_STAR] = ACTIONS(1701),
    [anon_sym_CARET] = ACTIONS(1699),
    [anon_sym_AMP] = ACTIONS(1699),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1703),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1705),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1633] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6913),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7016),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4492),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(3582),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7407),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9275),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1633),
    [sym_preproc_endregion] = STATE(1633),
    [sym_preproc_line] = STATE(1633),
    [sym_preproc_pragma] = STATE(1633),
    [sym_preproc_nullable] = STATE(1633),
    [sym_preproc_error] = STATE(1633),
    [sym_preproc_define] = STATE(1633),
    [sym_preproc_undef] = STATE(1633),
    [aux_sym_class_declaration_repeat1] = STATE(3789),
    [aux_sym_lambda_expression_repeat1] = STATE(4086),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1137),
    [anon_sym_ref] = ACTIONS(1139),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1145),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1153),
    [anon_sym_TILDE] = ACTIONS(1153),
    [anon_sym_PLUS_PLUS] = ACTIONS(1153),
    [anon_sym_DASH_DASH] = ACTIONS(1153),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1151),
    [anon_sym_DASH] = ACTIONS(1151),
    [anon_sym_STAR] = ACTIONS(1157),
    [anon_sym_CARET] = ACTIONS(1153),
    [anon_sym_AMP] = ACTIONS(1153),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1165),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1167),
    [anon_sym_DOT_DOT] = ACTIONS(1169),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1634] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7027),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5946),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4329),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7402),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9167),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1634),
    [sym_preproc_endregion] = STATE(1634),
    [sym_preproc_line] = STATE(1634),
    [sym_preproc_pragma] = STATE(1634),
    [sym_preproc_nullable] = STATE(1634),
    [sym_preproc_error] = STATE(1634),
    [sym_preproc_define] = STATE(1634),
    [sym_preproc_undef] = STATE(1634),
    [aux_sym_class_declaration_repeat1] = STATE(3794),
    [aux_sym_lambda_expression_repeat1] = STATE(4293),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1693),
    [anon_sym_ref] = ACTIONS(1695),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1699),
    [anon_sym_TILDE] = ACTIONS(1699),
    [anon_sym_PLUS_PLUS] = ACTIONS(1699),
    [anon_sym_DASH_DASH] = ACTIONS(1699),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1697),
    [anon_sym_DASH] = ACTIONS(1697),
    [anon_sym_STAR] = ACTIONS(1701),
    [anon_sym_CARET] = ACTIONS(1699),
    [anon_sym_AMP] = ACTIONS(1699),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1703),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1705),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1635] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7076),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6105),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4314),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9775),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1635),
    [sym_preproc_endregion] = STATE(1635),
    [sym_preproc_line] = STATE(1635),
    [sym_preproc_pragma] = STATE(1635),
    [sym_preproc_nullable] = STATE(1635),
    [sym_preproc_error] = STATE(1635),
    [sym_preproc_define] = STATE(1635),
    [sym_preproc_undef] = STATE(1635),
    [aux_sym_class_declaration_repeat1] = STATE(3835),
    [aux_sym_lambda_expression_repeat1] = STATE(4236),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1535),
    [anon_sym_ref] = ACTIONS(1537),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1465),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(885),
    [anon_sym_TILDE] = ACTIONS(885),
    [anon_sym_PLUS_PLUS] = ACTIONS(885),
    [anon_sym_DASH_DASH] = ACTIONS(885),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(887),
    [anon_sym_DASH] = ACTIONS(887),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(885),
    [anon_sym_AMP] = ACTIONS(885),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1539),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1541),
    [anon_sym_DOT_DOT] = ACTIONS(1543),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1636] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7027),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5947),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4329),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7402),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9167),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1636),
    [sym_preproc_endregion] = STATE(1636),
    [sym_preproc_line] = STATE(1636),
    [sym_preproc_pragma] = STATE(1636),
    [sym_preproc_nullable] = STATE(1636),
    [sym_preproc_error] = STATE(1636),
    [sym_preproc_define] = STATE(1636),
    [sym_preproc_undef] = STATE(1636),
    [aux_sym_class_declaration_repeat1] = STATE(3794),
    [aux_sym_lambda_expression_repeat1] = STATE(4293),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1693),
    [anon_sym_ref] = ACTIONS(1695),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1699),
    [anon_sym_TILDE] = ACTIONS(1699),
    [anon_sym_PLUS_PLUS] = ACTIONS(1699),
    [anon_sym_DASH_DASH] = ACTIONS(1699),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1697),
    [anon_sym_DASH] = ACTIONS(1697),
    [anon_sym_STAR] = ACTIONS(1701),
    [anon_sym_CARET] = ACTIONS(1699),
    [anon_sym_AMP] = ACTIONS(1699),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1703),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1705),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1637] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6399),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1637),
    [sym_preproc_endregion] = STATE(1637),
    [sym_preproc_line] = STATE(1637),
    [sym_preproc_pragma] = STATE(1637),
    [sym_preproc_nullable] = STATE(1637),
    [sym_preproc_error] = STATE(1637),
    [sym_preproc_define] = STATE(1637),
    [sym_preproc_undef] = STATE(1637),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1638] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7027),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5952),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4329),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7402),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9167),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1638),
    [sym_preproc_endregion] = STATE(1638),
    [sym_preproc_line] = STATE(1638),
    [sym_preproc_pragma] = STATE(1638),
    [sym_preproc_nullable] = STATE(1638),
    [sym_preproc_error] = STATE(1638),
    [sym_preproc_define] = STATE(1638),
    [sym_preproc_undef] = STATE(1638),
    [aux_sym_class_declaration_repeat1] = STATE(3794),
    [aux_sym_lambda_expression_repeat1] = STATE(4293),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1693),
    [anon_sym_ref] = ACTIONS(1695),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1699),
    [anon_sym_TILDE] = ACTIONS(1699),
    [anon_sym_PLUS_PLUS] = ACTIONS(1699),
    [anon_sym_DASH_DASH] = ACTIONS(1699),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1697),
    [anon_sym_DASH] = ACTIONS(1697),
    [anon_sym_STAR] = ACTIONS(1701),
    [anon_sym_CARET] = ACTIONS(1699),
    [anon_sym_AMP] = ACTIONS(1699),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1703),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1705),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1639] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7027),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5972),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4329),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7402),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9167),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1639),
    [sym_preproc_endregion] = STATE(1639),
    [sym_preproc_line] = STATE(1639),
    [sym_preproc_pragma] = STATE(1639),
    [sym_preproc_nullable] = STATE(1639),
    [sym_preproc_error] = STATE(1639),
    [sym_preproc_define] = STATE(1639),
    [sym_preproc_undef] = STATE(1639),
    [aux_sym_class_declaration_repeat1] = STATE(3794),
    [aux_sym_lambda_expression_repeat1] = STATE(4293),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1693),
    [anon_sym_ref] = ACTIONS(1695),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1699),
    [anon_sym_TILDE] = ACTIONS(1699),
    [anon_sym_PLUS_PLUS] = ACTIONS(1699),
    [anon_sym_DASH_DASH] = ACTIONS(1699),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1697),
    [anon_sym_DASH] = ACTIONS(1697),
    [anon_sym_STAR] = ACTIONS(1701),
    [anon_sym_CARET] = ACTIONS(1699),
    [anon_sym_AMP] = ACTIONS(1699),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1703),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1705),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1640] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6880),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7104),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5110),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(3863),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7380),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9420),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1640),
    [sym_preproc_endregion] = STATE(1640),
    [sym_preproc_line] = STATE(1640),
    [sym_preproc_pragma] = STATE(1640),
    [sym_preproc_nullable] = STATE(1640),
    [sym_preproc_error] = STATE(1640),
    [sym_preproc_define] = STATE(1640),
    [sym_preproc_undef] = STATE(1640),
    [aux_sym_class_declaration_repeat1] = STATE(3820),
    [aux_sym_lambda_expression_repeat1] = STATE(4165),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1339),
    [anon_sym_ref] = ACTIONS(1341),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1097),
    [anon_sym_TILDE] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1099),
    [anon_sym_DASH] = ACTIONS(1099),
    [anon_sym_STAR] = ACTIONS(1343),
    [anon_sym_CARET] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1097),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1345),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1347),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1641] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6913),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7016),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4494),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(3582),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7407),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9275),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1641),
    [sym_preproc_endregion] = STATE(1641),
    [sym_preproc_line] = STATE(1641),
    [sym_preproc_pragma] = STATE(1641),
    [sym_preproc_nullable] = STATE(1641),
    [sym_preproc_error] = STATE(1641),
    [sym_preproc_define] = STATE(1641),
    [sym_preproc_undef] = STATE(1641),
    [aux_sym_class_declaration_repeat1] = STATE(3789),
    [aux_sym_lambda_expression_repeat1] = STATE(4086),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1137),
    [anon_sym_ref] = ACTIONS(1139),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1145),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1153),
    [anon_sym_TILDE] = ACTIONS(1153),
    [anon_sym_PLUS_PLUS] = ACTIONS(1153),
    [anon_sym_DASH_DASH] = ACTIONS(1153),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1151),
    [anon_sym_DASH] = ACTIONS(1151),
    [anon_sym_STAR] = ACTIONS(1157),
    [anon_sym_CARET] = ACTIONS(1153),
    [anon_sym_AMP] = ACTIONS(1153),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1165),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1167),
    [anon_sym_DOT_DOT] = ACTIONS(1169),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1642] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7027),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5975),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4329),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7402),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9167),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1642),
    [sym_preproc_endregion] = STATE(1642),
    [sym_preproc_line] = STATE(1642),
    [sym_preproc_pragma] = STATE(1642),
    [sym_preproc_nullable] = STATE(1642),
    [sym_preproc_error] = STATE(1642),
    [sym_preproc_define] = STATE(1642),
    [sym_preproc_undef] = STATE(1642),
    [aux_sym_class_declaration_repeat1] = STATE(3794),
    [aux_sym_lambda_expression_repeat1] = STATE(4293),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1693),
    [anon_sym_ref] = ACTIONS(1695),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1699),
    [anon_sym_TILDE] = ACTIONS(1699),
    [anon_sym_PLUS_PLUS] = ACTIONS(1699),
    [anon_sym_DASH_DASH] = ACTIONS(1699),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1697),
    [anon_sym_DASH] = ACTIONS(1697),
    [anon_sym_STAR] = ACTIONS(1701),
    [anon_sym_CARET] = ACTIONS(1699),
    [anon_sym_AMP] = ACTIONS(1699),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1703),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1705),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1643] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7027),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5976),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4329),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7402),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9167),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1643),
    [sym_preproc_endregion] = STATE(1643),
    [sym_preproc_line] = STATE(1643),
    [sym_preproc_pragma] = STATE(1643),
    [sym_preproc_nullable] = STATE(1643),
    [sym_preproc_error] = STATE(1643),
    [sym_preproc_define] = STATE(1643),
    [sym_preproc_undef] = STATE(1643),
    [aux_sym_class_declaration_repeat1] = STATE(3794),
    [aux_sym_lambda_expression_repeat1] = STATE(4293),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1693),
    [anon_sym_ref] = ACTIONS(1695),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1699),
    [anon_sym_TILDE] = ACTIONS(1699),
    [anon_sym_PLUS_PLUS] = ACTIONS(1699),
    [anon_sym_DASH_DASH] = ACTIONS(1699),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1697),
    [anon_sym_DASH] = ACTIONS(1697),
    [anon_sym_STAR] = ACTIONS(1701),
    [anon_sym_CARET] = ACTIONS(1699),
    [anon_sym_AMP] = ACTIONS(1699),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1703),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1705),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1644] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6913),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7016),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4496),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(3582),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7407),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9275),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1644),
    [sym_preproc_endregion] = STATE(1644),
    [sym_preproc_line] = STATE(1644),
    [sym_preproc_pragma] = STATE(1644),
    [sym_preproc_nullable] = STATE(1644),
    [sym_preproc_error] = STATE(1644),
    [sym_preproc_define] = STATE(1644),
    [sym_preproc_undef] = STATE(1644),
    [aux_sym_class_declaration_repeat1] = STATE(3789),
    [aux_sym_lambda_expression_repeat1] = STATE(4086),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1137),
    [anon_sym_ref] = ACTIONS(1139),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1145),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1153),
    [anon_sym_TILDE] = ACTIONS(1153),
    [anon_sym_PLUS_PLUS] = ACTIONS(1153),
    [anon_sym_DASH_DASH] = ACTIONS(1153),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1151),
    [anon_sym_DASH] = ACTIONS(1151),
    [anon_sym_STAR] = ACTIONS(1157),
    [anon_sym_CARET] = ACTIONS(1153),
    [anon_sym_AMP] = ACTIONS(1153),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1165),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1167),
    [anon_sym_DOT_DOT] = ACTIONS(1169),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1645] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6913),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7016),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4497),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(3582),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7407),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9275),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1645),
    [sym_preproc_endregion] = STATE(1645),
    [sym_preproc_line] = STATE(1645),
    [sym_preproc_pragma] = STATE(1645),
    [sym_preproc_nullable] = STATE(1645),
    [sym_preproc_error] = STATE(1645),
    [sym_preproc_define] = STATE(1645),
    [sym_preproc_undef] = STATE(1645),
    [aux_sym_class_declaration_repeat1] = STATE(3789),
    [aux_sym_lambda_expression_repeat1] = STATE(4086),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1137),
    [anon_sym_ref] = ACTIONS(1139),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1145),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1153),
    [anon_sym_TILDE] = ACTIONS(1153),
    [anon_sym_PLUS_PLUS] = ACTIONS(1153),
    [anon_sym_DASH_DASH] = ACTIONS(1153),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1151),
    [anon_sym_DASH] = ACTIONS(1151),
    [anon_sym_STAR] = ACTIONS(1157),
    [anon_sym_CARET] = ACTIONS(1153),
    [anon_sym_AMP] = ACTIONS(1153),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1165),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1167),
    [anon_sym_DOT_DOT] = ACTIONS(1169),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1646] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7027),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5977),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4329),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7402),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9167),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1646),
    [sym_preproc_endregion] = STATE(1646),
    [sym_preproc_line] = STATE(1646),
    [sym_preproc_pragma] = STATE(1646),
    [sym_preproc_nullable] = STATE(1646),
    [sym_preproc_error] = STATE(1646),
    [sym_preproc_define] = STATE(1646),
    [sym_preproc_undef] = STATE(1646),
    [aux_sym_class_declaration_repeat1] = STATE(3794),
    [aux_sym_lambda_expression_repeat1] = STATE(4293),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1693),
    [anon_sym_ref] = ACTIONS(1695),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1699),
    [anon_sym_TILDE] = ACTIONS(1699),
    [anon_sym_PLUS_PLUS] = ACTIONS(1699),
    [anon_sym_DASH_DASH] = ACTIONS(1699),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1697),
    [anon_sym_DASH] = ACTIONS(1697),
    [anon_sym_STAR] = ACTIONS(1701),
    [anon_sym_CARET] = ACTIONS(1699),
    [anon_sym_AMP] = ACTIONS(1699),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1703),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1705),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1647] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6880),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7104),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(3901),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(3863),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7380),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9420),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1647),
    [sym_preproc_endregion] = STATE(1647),
    [sym_preproc_line] = STATE(1647),
    [sym_preproc_pragma] = STATE(1647),
    [sym_preproc_nullable] = STATE(1647),
    [sym_preproc_error] = STATE(1647),
    [sym_preproc_define] = STATE(1647),
    [sym_preproc_undef] = STATE(1647),
    [aux_sym_class_declaration_repeat1] = STATE(3820),
    [aux_sym_lambda_expression_repeat1] = STATE(4165),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1339),
    [anon_sym_ref] = ACTIONS(1341),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1097),
    [anon_sym_TILDE] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1099),
    [anon_sym_DASH] = ACTIONS(1099),
    [anon_sym_STAR] = ACTIONS(1343),
    [anon_sym_CARET] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1097),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1345),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1347),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1648] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6880),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7104),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5141),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(3863),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7380),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9420),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1648),
    [sym_preproc_endregion] = STATE(1648),
    [sym_preproc_line] = STATE(1648),
    [sym_preproc_pragma] = STATE(1648),
    [sym_preproc_nullable] = STATE(1648),
    [sym_preproc_error] = STATE(1648),
    [sym_preproc_define] = STATE(1648),
    [sym_preproc_undef] = STATE(1648),
    [aux_sym_class_declaration_repeat1] = STATE(3820),
    [aux_sym_lambda_expression_repeat1] = STATE(4165),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1339),
    [anon_sym_ref] = ACTIONS(1341),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1097),
    [anon_sym_TILDE] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1099),
    [anon_sym_DASH] = ACTIONS(1099),
    [anon_sym_STAR] = ACTIONS(1343),
    [anon_sym_CARET] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1097),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1345),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1347),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1649] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7027),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5978),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4329),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7402),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9167),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1649),
    [sym_preproc_endregion] = STATE(1649),
    [sym_preproc_line] = STATE(1649),
    [sym_preproc_pragma] = STATE(1649),
    [sym_preproc_nullable] = STATE(1649),
    [sym_preproc_error] = STATE(1649),
    [sym_preproc_define] = STATE(1649),
    [sym_preproc_undef] = STATE(1649),
    [aux_sym_class_declaration_repeat1] = STATE(3794),
    [aux_sym_lambda_expression_repeat1] = STATE(4293),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1693),
    [anon_sym_ref] = ACTIONS(1695),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1699),
    [anon_sym_TILDE] = ACTIONS(1699),
    [anon_sym_PLUS_PLUS] = ACTIONS(1699),
    [anon_sym_DASH_DASH] = ACTIONS(1699),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1697),
    [anon_sym_DASH] = ACTIONS(1697),
    [anon_sym_STAR] = ACTIONS(1701),
    [anon_sym_CARET] = ACTIONS(1699),
    [anon_sym_AMP] = ACTIONS(1699),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1703),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1705),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1650] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7027),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(3922),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4329),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7402),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9167),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1650),
    [sym_preproc_endregion] = STATE(1650),
    [sym_preproc_line] = STATE(1650),
    [sym_preproc_pragma] = STATE(1650),
    [sym_preproc_nullable] = STATE(1650),
    [sym_preproc_error] = STATE(1650),
    [sym_preproc_define] = STATE(1650),
    [sym_preproc_undef] = STATE(1650),
    [aux_sym_class_declaration_repeat1] = STATE(3794),
    [aux_sym_lambda_expression_repeat1] = STATE(4293),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1693),
    [anon_sym_ref] = ACTIONS(1695),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1699),
    [anon_sym_TILDE] = ACTIONS(1699),
    [anon_sym_PLUS_PLUS] = ACTIONS(1699),
    [anon_sym_DASH_DASH] = ACTIONS(1699),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1697),
    [anon_sym_DASH] = ACTIONS(1697),
    [anon_sym_STAR] = ACTIONS(1701),
    [anon_sym_CARET] = ACTIONS(1699),
    [anon_sym_AMP] = ACTIONS(1699),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1703),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1705),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1651] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7027),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5983),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4329),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7402),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9167),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1651),
    [sym_preproc_endregion] = STATE(1651),
    [sym_preproc_line] = STATE(1651),
    [sym_preproc_pragma] = STATE(1651),
    [sym_preproc_nullable] = STATE(1651),
    [sym_preproc_error] = STATE(1651),
    [sym_preproc_define] = STATE(1651),
    [sym_preproc_undef] = STATE(1651),
    [aux_sym_class_declaration_repeat1] = STATE(3794),
    [aux_sym_lambda_expression_repeat1] = STATE(4293),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1693),
    [anon_sym_ref] = ACTIONS(1695),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1699),
    [anon_sym_TILDE] = ACTIONS(1699),
    [anon_sym_PLUS_PLUS] = ACTIONS(1699),
    [anon_sym_DASH_DASH] = ACTIONS(1699),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1697),
    [anon_sym_DASH] = ACTIONS(1697),
    [anon_sym_STAR] = ACTIONS(1701),
    [anon_sym_CARET] = ACTIONS(1699),
    [anon_sym_AMP] = ACTIONS(1699),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1703),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1705),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1652] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6887),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2935),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6959),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(3565),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4399),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7410),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9332),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1652),
    [sym_preproc_endregion] = STATE(1652),
    [sym_preproc_line] = STATE(1652),
    [sym_preproc_pragma] = STATE(1652),
    [sym_preproc_nullable] = STATE(1652),
    [sym_preproc_error] = STATE(1652),
    [sym_preproc_define] = STATE(1652),
    [sym_preproc_undef] = STATE(1652),
    [aux_sym_class_declaration_repeat1] = STATE(3807),
    [aux_sym_lambda_expression_repeat1] = STATE(4128),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2115),
    [anon_sym_ref] = ACTIONS(2117),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2119),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(2123),
    [anon_sym_TILDE] = ACTIONS(2123),
    [anon_sym_PLUS_PLUS] = ACTIONS(2123),
    [anon_sym_DASH_DASH] = ACTIONS(2123),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2121),
    [anon_sym_DASH] = ACTIONS(2121),
    [anon_sym_STAR] = ACTIONS(2125),
    [anon_sym_CARET] = ACTIONS(2123),
    [anon_sym_AMP] = ACTIONS(2123),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2127),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2129),
    [anon_sym_DOT_DOT] = ACTIONS(2131),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1653] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6913),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7016),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4499),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(3582),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7407),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9275),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1653),
    [sym_preproc_endregion] = STATE(1653),
    [sym_preproc_line] = STATE(1653),
    [sym_preproc_pragma] = STATE(1653),
    [sym_preproc_nullable] = STATE(1653),
    [sym_preproc_error] = STATE(1653),
    [sym_preproc_define] = STATE(1653),
    [sym_preproc_undef] = STATE(1653),
    [aux_sym_class_declaration_repeat1] = STATE(3789),
    [aux_sym_lambda_expression_repeat1] = STATE(4086),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1137),
    [anon_sym_ref] = ACTIONS(1139),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1145),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1153),
    [anon_sym_TILDE] = ACTIONS(1153),
    [anon_sym_PLUS_PLUS] = ACTIONS(1153),
    [anon_sym_DASH_DASH] = ACTIONS(1153),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1151),
    [anon_sym_DASH] = ACTIONS(1151),
    [anon_sym_STAR] = ACTIONS(1157),
    [anon_sym_CARET] = ACTIONS(1153),
    [anon_sym_AMP] = ACTIONS(1153),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1165),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1167),
    [anon_sym_DOT_DOT] = ACTIONS(1169),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1654] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6887),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2935),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6959),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6249),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4399),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7410),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9332),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1654),
    [sym_preproc_endregion] = STATE(1654),
    [sym_preproc_line] = STATE(1654),
    [sym_preproc_pragma] = STATE(1654),
    [sym_preproc_nullable] = STATE(1654),
    [sym_preproc_error] = STATE(1654),
    [sym_preproc_define] = STATE(1654),
    [sym_preproc_undef] = STATE(1654),
    [aux_sym_class_declaration_repeat1] = STATE(3807),
    [aux_sym_lambda_expression_repeat1] = STATE(4128),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2115),
    [anon_sym_ref] = ACTIONS(2117),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2119),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(2123),
    [anon_sym_TILDE] = ACTIONS(2123),
    [anon_sym_PLUS_PLUS] = ACTIONS(2123),
    [anon_sym_DASH_DASH] = ACTIONS(2123),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2121),
    [anon_sym_DASH] = ACTIONS(2121),
    [anon_sym_STAR] = ACTIONS(2125),
    [anon_sym_CARET] = ACTIONS(2123),
    [anon_sym_AMP] = ACTIONS(2123),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2127),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2129),
    [anon_sym_DOT_DOT] = ACTIONS(2131),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1655] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7027),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(3901),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4329),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7402),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9167),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1655),
    [sym_preproc_endregion] = STATE(1655),
    [sym_preproc_line] = STATE(1655),
    [sym_preproc_pragma] = STATE(1655),
    [sym_preproc_nullable] = STATE(1655),
    [sym_preproc_error] = STATE(1655),
    [sym_preproc_define] = STATE(1655),
    [sym_preproc_undef] = STATE(1655),
    [aux_sym_class_declaration_repeat1] = STATE(3794),
    [aux_sym_lambda_expression_repeat1] = STATE(4293),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1693),
    [anon_sym_ref] = ACTIONS(1695),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1699),
    [anon_sym_TILDE] = ACTIONS(1699),
    [anon_sym_PLUS_PLUS] = ACTIONS(1699),
    [anon_sym_DASH_DASH] = ACTIONS(1699),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1697),
    [anon_sym_DASH] = ACTIONS(1697),
    [anon_sym_STAR] = ACTIONS(1701),
    [anon_sym_CARET] = ACTIONS(1699),
    [anon_sym_AMP] = ACTIONS(1699),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1703),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1705),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1656] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6898),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2940),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6925),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6369),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4498),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7403),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(8973),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1656),
    [sym_preproc_endregion] = STATE(1656),
    [sym_preproc_line] = STATE(1656),
    [sym_preproc_pragma] = STATE(1656),
    [sym_preproc_nullable] = STATE(1656),
    [sym_preproc_error] = STATE(1656),
    [sym_preproc_define] = STATE(1656),
    [sym_preproc_undef] = STATE(1656),
    [aux_sym_class_declaration_repeat1] = STATE(3830),
    [aux_sym_lambda_expression_repeat1] = STATE(4194),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2153),
    [anon_sym_ref] = ACTIONS(2155),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2157),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2161),
    [anon_sym_TILDE] = ACTIONS(2161),
    [anon_sym_PLUS_PLUS] = ACTIONS(2161),
    [anon_sym_DASH_DASH] = ACTIONS(2161),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2159),
    [anon_sym_DASH] = ACTIONS(2159),
    [anon_sym_STAR] = ACTIONS(2163),
    [anon_sym_CARET] = ACTIONS(2161),
    [anon_sym_AMP] = ACTIONS(2161),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2165),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2167),
    [anon_sym_DOT_DOT] = ACTIONS(2169),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1657] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6887),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2935),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6959),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6248),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4399),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7410),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9332),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1657),
    [sym_preproc_endregion] = STATE(1657),
    [sym_preproc_line] = STATE(1657),
    [sym_preproc_pragma] = STATE(1657),
    [sym_preproc_nullable] = STATE(1657),
    [sym_preproc_error] = STATE(1657),
    [sym_preproc_define] = STATE(1657),
    [sym_preproc_undef] = STATE(1657),
    [aux_sym_class_declaration_repeat1] = STATE(3807),
    [aux_sym_lambda_expression_repeat1] = STATE(4128),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2115),
    [anon_sym_ref] = ACTIONS(2117),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2119),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(2123),
    [anon_sym_TILDE] = ACTIONS(2123),
    [anon_sym_PLUS_PLUS] = ACTIONS(2123),
    [anon_sym_DASH_DASH] = ACTIONS(2123),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2121),
    [anon_sym_DASH] = ACTIONS(2121),
    [anon_sym_STAR] = ACTIONS(2125),
    [anon_sym_CARET] = ACTIONS(2123),
    [anon_sym_AMP] = ACTIONS(2123),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2127),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2129),
    [anon_sym_DOT_DOT] = ACTIONS(2131),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1658] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6887),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2935),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6959),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6247),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4399),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7410),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9332),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1658),
    [sym_preproc_endregion] = STATE(1658),
    [sym_preproc_line] = STATE(1658),
    [sym_preproc_pragma] = STATE(1658),
    [sym_preproc_nullable] = STATE(1658),
    [sym_preproc_error] = STATE(1658),
    [sym_preproc_define] = STATE(1658),
    [sym_preproc_undef] = STATE(1658),
    [aux_sym_class_declaration_repeat1] = STATE(3807),
    [aux_sym_lambda_expression_repeat1] = STATE(4128),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2115),
    [anon_sym_ref] = ACTIONS(2117),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2119),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(2123),
    [anon_sym_TILDE] = ACTIONS(2123),
    [anon_sym_PLUS_PLUS] = ACTIONS(2123),
    [anon_sym_DASH_DASH] = ACTIONS(2123),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2121),
    [anon_sym_DASH] = ACTIONS(2121),
    [anon_sym_STAR] = ACTIONS(2125),
    [anon_sym_CARET] = ACTIONS(2123),
    [anon_sym_AMP] = ACTIONS(2123),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2127),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2129),
    [anon_sym_DOT_DOT] = ACTIONS(2131),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1659] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6887),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2935),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6959),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6246),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4399),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7410),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9332),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1659),
    [sym_preproc_endregion] = STATE(1659),
    [sym_preproc_line] = STATE(1659),
    [sym_preproc_pragma] = STATE(1659),
    [sym_preproc_nullable] = STATE(1659),
    [sym_preproc_error] = STATE(1659),
    [sym_preproc_define] = STATE(1659),
    [sym_preproc_undef] = STATE(1659),
    [aux_sym_class_declaration_repeat1] = STATE(3807),
    [aux_sym_lambda_expression_repeat1] = STATE(4128),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2115),
    [anon_sym_ref] = ACTIONS(2117),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2119),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(2123),
    [anon_sym_TILDE] = ACTIONS(2123),
    [anon_sym_PLUS_PLUS] = ACTIONS(2123),
    [anon_sym_DASH_DASH] = ACTIONS(2123),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2121),
    [anon_sym_DASH] = ACTIONS(2121),
    [anon_sym_STAR] = ACTIONS(2125),
    [anon_sym_CARET] = ACTIONS(2123),
    [anon_sym_AMP] = ACTIONS(2123),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2127),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2129),
    [anon_sym_DOT_DOT] = ACTIONS(2131),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1660] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6887),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2935),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6959),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6245),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4399),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7410),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9332),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1660),
    [sym_preproc_endregion] = STATE(1660),
    [sym_preproc_line] = STATE(1660),
    [sym_preproc_pragma] = STATE(1660),
    [sym_preproc_nullable] = STATE(1660),
    [sym_preproc_error] = STATE(1660),
    [sym_preproc_define] = STATE(1660),
    [sym_preproc_undef] = STATE(1660),
    [aux_sym_class_declaration_repeat1] = STATE(3807),
    [aux_sym_lambda_expression_repeat1] = STATE(4128),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2115),
    [anon_sym_ref] = ACTIONS(2117),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2119),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(2123),
    [anon_sym_TILDE] = ACTIONS(2123),
    [anon_sym_PLUS_PLUS] = ACTIONS(2123),
    [anon_sym_DASH_DASH] = ACTIONS(2123),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2121),
    [anon_sym_DASH] = ACTIONS(2121),
    [anon_sym_STAR] = ACTIONS(2125),
    [anon_sym_CARET] = ACTIONS(2123),
    [anon_sym_AMP] = ACTIONS(2123),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2127),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2129),
    [anon_sym_DOT_DOT] = ACTIONS(2131),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1661] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6913),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7016),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(3826),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(3582),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7407),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9275),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1661),
    [sym_preproc_endregion] = STATE(1661),
    [sym_preproc_line] = STATE(1661),
    [sym_preproc_pragma] = STATE(1661),
    [sym_preproc_nullable] = STATE(1661),
    [sym_preproc_error] = STATE(1661),
    [sym_preproc_define] = STATE(1661),
    [sym_preproc_undef] = STATE(1661),
    [aux_sym_class_declaration_repeat1] = STATE(3789),
    [aux_sym_lambda_expression_repeat1] = STATE(4086),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1137),
    [anon_sym_ref] = ACTIONS(1139),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1145),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1153),
    [anon_sym_TILDE] = ACTIONS(1153),
    [anon_sym_PLUS_PLUS] = ACTIONS(1153),
    [anon_sym_DASH_DASH] = ACTIONS(1153),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1151),
    [anon_sym_DASH] = ACTIONS(1151),
    [anon_sym_STAR] = ACTIONS(1157),
    [anon_sym_CARET] = ACTIONS(1153),
    [anon_sym_AMP] = ACTIONS(1153),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1165),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1167),
    [anon_sym_DOT_DOT] = ACTIONS(1169),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1662] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6887),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2935),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6959),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6243),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4399),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7410),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9332),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1662),
    [sym_preproc_endregion] = STATE(1662),
    [sym_preproc_line] = STATE(1662),
    [sym_preproc_pragma] = STATE(1662),
    [sym_preproc_nullable] = STATE(1662),
    [sym_preproc_error] = STATE(1662),
    [sym_preproc_define] = STATE(1662),
    [sym_preproc_undef] = STATE(1662),
    [aux_sym_class_declaration_repeat1] = STATE(3807),
    [aux_sym_lambda_expression_repeat1] = STATE(4128),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2115),
    [anon_sym_ref] = ACTIONS(2117),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2119),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(2123),
    [anon_sym_TILDE] = ACTIONS(2123),
    [anon_sym_PLUS_PLUS] = ACTIONS(2123),
    [anon_sym_DASH_DASH] = ACTIONS(2123),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2121),
    [anon_sym_DASH] = ACTIONS(2121),
    [anon_sym_STAR] = ACTIONS(2125),
    [anon_sym_CARET] = ACTIONS(2123),
    [anon_sym_AMP] = ACTIONS(2123),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2127),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2129),
    [anon_sym_DOT_DOT] = ACTIONS(2131),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1663] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6887),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2935),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6959),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6242),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4399),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7410),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9332),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1663),
    [sym_preproc_endregion] = STATE(1663),
    [sym_preproc_line] = STATE(1663),
    [sym_preproc_pragma] = STATE(1663),
    [sym_preproc_nullable] = STATE(1663),
    [sym_preproc_error] = STATE(1663),
    [sym_preproc_define] = STATE(1663),
    [sym_preproc_undef] = STATE(1663),
    [aux_sym_class_declaration_repeat1] = STATE(3807),
    [aux_sym_lambda_expression_repeat1] = STATE(4128),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2115),
    [anon_sym_ref] = ACTIONS(2117),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2119),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(2123),
    [anon_sym_TILDE] = ACTIONS(2123),
    [anon_sym_PLUS_PLUS] = ACTIONS(2123),
    [anon_sym_DASH_DASH] = ACTIONS(2123),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2121),
    [anon_sym_DASH] = ACTIONS(2121),
    [anon_sym_STAR] = ACTIONS(2125),
    [anon_sym_CARET] = ACTIONS(2123),
    [anon_sym_AMP] = ACTIONS(2123),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2127),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2129),
    [anon_sym_DOT_DOT] = ACTIONS(2131),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1664] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6887),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2935),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6959),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6241),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4399),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7410),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9332),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1664),
    [sym_preproc_endregion] = STATE(1664),
    [sym_preproc_line] = STATE(1664),
    [sym_preproc_pragma] = STATE(1664),
    [sym_preproc_nullable] = STATE(1664),
    [sym_preproc_error] = STATE(1664),
    [sym_preproc_define] = STATE(1664),
    [sym_preproc_undef] = STATE(1664),
    [aux_sym_class_declaration_repeat1] = STATE(3807),
    [aux_sym_lambda_expression_repeat1] = STATE(4128),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2115),
    [anon_sym_ref] = ACTIONS(2117),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2119),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(2123),
    [anon_sym_TILDE] = ACTIONS(2123),
    [anon_sym_PLUS_PLUS] = ACTIONS(2123),
    [anon_sym_DASH_DASH] = ACTIONS(2123),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2121),
    [anon_sym_DASH] = ACTIONS(2121),
    [anon_sym_STAR] = ACTIONS(2125),
    [anon_sym_CARET] = ACTIONS(2123),
    [anon_sym_AMP] = ACTIONS(2123),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2127),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2129),
    [anon_sym_DOT_DOT] = ACTIONS(2131),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1665] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6887),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2935),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6959),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6276),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4399),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7410),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9332),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1665),
    [sym_preproc_endregion] = STATE(1665),
    [sym_preproc_line] = STATE(1665),
    [sym_preproc_pragma] = STATE(1665),
    [sym_preproc_nullable] = STATE(1665),
    [sym_preproc_error] = STATE(1665),
    [sym_preproc_define] = STATE(1665),
    [sym_preproc_undef] = STATE(1665),
    [aux_sym_class_declaration_repeat1] = STATE(3807),
    [aux_sym_lambda_expression_repeat1] = STATE(4128),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2115),
    [anon_sym_ref] = ACTIONS(2117),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2119),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(2123),
    [anon_sym_TILDE] = ACTIONS(2123),
    [anon_sym_PLUS_PLUS] = ACTIONS(2123),
    [anon_sym_DASH_DASH] = ACTIONS(2123),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2121),
    [anon_sym_DASH] = ACTIONS(2121),
    [anon_sym_STAR] = ACTIONS(2125),
    [anon_sym_CARET] = ACTIONS(2123),
    [anon_sym_AMP] = ACTIONS(2123),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2127),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2129),
    [anon_sym_DOT_DOT] = ACTIONS(2131),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1666] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7080),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6398),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4477),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9873),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1666),
    [sym_preproc_endregion] = STATE(1666),
    [sym_preproc_line] = STATE(1666),
    [sym_preproc_pragma] = STATE(1666),
    [sym_preproc_nullable] = STATE(1666),
    [sym_preproc_error] = STATE(1666),
    [sym_preproc_define] = STATE(1666),
    [sym_preproc_undef] = STATE(1666),
    [aux_sym_class_declaration_repeat1] = STATE(3845),
    [aux_sym_lambda_expression_repeat1] = STATE(4299),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1979),
    [anon_sym_ref] = ACTIONS(1981),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1985),
    [anon_sym_TILDE] = ACTIONS(1985),
    [anon_sym_PLUS_PLUS] = ACTIONS(1985),
    [anon_sym_DASH_DASH] = ACTIONS(1985),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1983),
    [anon_sym_DASH] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1985),
    [anon_sym_AMP] = ACTIONS(1985),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1987),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1989),
    [anon_sym_DOT_DOT] = ACTIONS(1991),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1667] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6887),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2935),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6959),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6238),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4399),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7410),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9332),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1667),
    [sym_preproc_endregion] = STATE(1667),
    [sym_preproc_line] = STATE(1667),
    [sym_preproc_pragma] = STATE(1667),
    [sym_preproc_nullable] = STATE(1667),
    [sym_preproc_error] = STATE(1667),
    [sym_preproc_define] = STATE(1667),
    [sym_preproc_undef] = STATE(1667),
    [aux_sym_class_declaration_repeat1] = STATE(3807),
    [aux_sym_lambda_expression_repeat1] = STATE(4128),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2115),
    [anon_sym_ref] = ACTIONS(2117),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2119),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(2123),
    [anon_sym_TILDE] = ACTIONS(2123),
    [anon_sym_PLUS_PLUS] = ACTIONS(2123),
    [anon_sym_DASH_DASH] = ACTIONS(2123),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2121),
    [anon_sym_DASH] = ACTIONS(2121),
    [anon_sym_STAR] = ACTIONS(2125),
    [anon_sym_CARET] = ACTIONS(2123),
    [anon_sym_AMP] = ACTIONS(2123),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2127),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2129),
    [anon_sym_DOT_DOT] = ACTIONS(2131),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1668] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7080),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6401),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4477),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9873),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1668),
    [sym_preproc_endregion] = STATE(1668),
    [sym_preproc_line] = STATE(1668),
    [sym_preproc_pragma] = STATE(1668),
    [sym_preproc_nullable] = STATE(1668),
    [sym_preproc_error] = STATE(1668),
    [sym_preproc_define] = STATE(1668),
    [sym_preproc_undef] = STATE(1668),
    [aux_sym_class_declaration_repeat1] = STATE(3845),
    [aux_sym_lambda_expression_repeat1] = STATE(4299),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1979),
    [anon_sym_ref] = ACTIONS(1981),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1985),
    [anon_sym_TILDE] = ACTIONS(1985),
    [anon_sym_PLUS_PLUS] = ACTIONS(1985),
    [anon_sym_DASH_DASH] = ACTIONS(1985),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1983),
    [anon_sym_DASH] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1985),
    [anon_sym_AMP] = ACTIONS(1985),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1987),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1989),
    [anon_sym_DOT_DOT] = ACTIONS(1991),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1669] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6887),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2935),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6959),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6237),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4399),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7410),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9332),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1669),
    [sym_preproc_endregion] = STATE(1669),
    [sym_preproc_line] = STATE(1669),
    [sym_preproc_pragma] = STATE(1669),
    [sym_preproc_nullable] = STATE(1669),
    [sym_preproc_error] = STATE(1669),
    [sym_preproc_define] = STATE(1669),
    [sym_preproc_undef] = STATE(1669),
    [aux_sym_class_declaration_repeat1] = STATE(3807),
    [aux_sym_lambda_expression_repeat1] = STATE(4128),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2115),
    [anon_sym_ref] = ACTIONS(2117),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2119),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(2123),
    [anon_sym_TILDE] = ACTIONS(2123),
    [anon_sym_PLUS_PLUS] = ACTIONS(2123),
    [anon_sym_DASH_DASH] = ACTIONS(2123),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2121),
    [anon_sym_DASH] = ACTIONS(2121),
    [anon_sym_STAR] = ACTIONS(2125),
    [anon_sym_CARET] = ACTIONS(2123),
    [anon_sym_AMP] = ACTIONS(2123),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2127),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2129),
    [anon_sym_DOT_DOT] = ACTIONS(2131),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1670] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7080),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6402),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4477),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9873),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1670),
    [sym_preproc_endregion] = STATE(1670),
    [sym_preproc_line] = STATE(1670),
    [sym_preproc_pragma] = STATE(1670),
    [sym_preproc_nullable] = STATE(1670),
    [sym_preproc_error] = STATE(1670),
    [sym_preproc_define] = STATE(1670),
    [sym_preproc_undef] = STATE(1670),
    [aux_sym_class_declaration_repeat1] = STATE(3845),
    [aux_sym_lambda_expression_repeat1] = STATE(4299),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1979),
    [anon_sym_ref] = ACTIONS(1981),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1985),
    [anon_sym_TILDE] = ACTIONS(1985),
    [anon_sym_PLUS_PLUS] = ACTIONS(1985),
    [anon_sym_DASH_DASH] = ACTIONS(1985),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1983),
    [anon_sym_DASH] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1985),
    [anon_sym_AMP] = ACTIONS(1985),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1987),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1989),
    [anon_sym_DOT_DOT] = ACTIONS(1991),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1671] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6913),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7016),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4513),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(3582),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7407),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9275),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1671),
    [sym_preproc_endregion] = STATE(1671),
    [sym_preproc_line] = STATE(1671),
    [sym_preproc_pragma] = STATE(1671),
    [sym_preproc_nullable] = STATE(1671),
    [sym_preproc_error] = STATE(1671),
    [sym_preproc_define] = STATE(1671),
    [sym_preproc_undef] = STATE(1671),
    [aux_sym_class_declaration_repeat1] = STATE(3789),
    [aux_sym_lambda_expression_repeat1] = STATE(4086),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1137),
    [anon_sym_ref] = ACTIONS(1139),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1145),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1153),
    [anon_sym_TILDE] = ACTIONS(1153),
    [anon_sym_PLUS_PLUS] = ACTIONS(1153),
    [anon_sym_DASH_DASH] = ACTIONS(1153),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1151),
    [anon_sym_DASH] = ACTIONS(1151),
    [anon_sym_STAR] = ACTIONS(1157),
    [anon_sym_CARET] = ACTIONS(1153),
    [anon_sym_AMP] = ACTIONS(1153),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1165),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1167),
    [anon_sym_DOT_DOT] = ACTIONS(1169),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1672] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7027),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5967),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4329),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7402),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9167),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1672),
    [sym_preproc_endregion] = STATE(1672),
    [sym_preproc_line] = STATE(1672),
    [sym_preproc_pragma] = STATE(1672),
    [sym_preproc_nullable] = STATE(1672),
    [sym_preproc_error] = STATE(1672),
    [sym_preproc_define] = STATE(1672),
    [sym_preproc_undef] = STATE(1672),
    [aux_sym_class_declaration_repeat1] = STATE(3794),
    [aux_sym_lambda_expression_repeat1] = STATE(4293),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1693),
    [anon_sym_ref] = ACTIONS(1695),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1699),
    [anon_sym_TILDE] = ACTIONS(1699),
    [anon_sym_PLUS_PLUS] = ACTIONS(1699),
    [anon_sym_DASH_DASH] = ACTIONS(1699),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1697),
    [anon_sym_DASH] = ACTIONS(1697),
    [anon_sym_STAR] = ACTIONS(1701),
    [anon_sym_CARET] = ACTIONS(1699),
    [anon_sym_AMP] = ACTIONS(1699),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1703),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1705),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1673] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7080),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6416),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4477),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9873),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1673),
    [sym_preproc_endregion] = STATE(1673),
    [sym_preproc_line] = STATE(1673),
    [sym_preproc_pragma] = STATE(1673),
    [sym_preproc_nullable] = STATE(1673),
    [sym_preproc_error] = STATE(1673),
    [sym_preproc_define] = STATE(1673),
    [sym_preproc_undef] = STATE(1673),
    [aux_sym_class_declaration_repeat1] = STATE(3845),
    [aux_sym_lambda_expression_repeat1] = STATE(4299),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1979),
    [anon_sym_ref] = ACTIONS(1981),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1985),
    [anon_sym_TILDE] = ACTIONS(1985),
    [anon_sym_PLUS_PLUS] = ACTIONS(1985),
    [anon_sym_DASH_DASH] = ACTIONS(1985),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1983),
    [anon_sym_DASH] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1985),
    [anon_sym_AMP] = ACTIONS(1985),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1987),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1989),
    [anon_sym_DOT_DOT] = ACTIONS(1991),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1674] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7080),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6441),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4477),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9873),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1674),
    [sym_preproc_endregion] = STATE(1674),
    [sym_preproc_line] = STATE(1674),
    [sym_preproc_pragma] = STATE(1674),
    [sym_preproc_nullable] = STATE(1674),
    [sym_preproc_error] = STATE(1674),
    [sym_preproc_define] = STATE(1674),
    [sym_preproc_undef] = STATE(1674),
    [aux_sym_class_declaration_repeat1] = STATE(3845),
    [aux_sym_lambda_expression_repeat1] = STATE(4299),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1979),
    [anon_sym_ref] = ACTIONS(1981),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1985),
    [anon_sym_TILDE] = ACTIONS(1985),
    [anon_sym_PLUS_PLUS] = ACTIONS(1985),
    [anon_sym_DASH_DASH] = ACTIONS(1985),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1983),
    [anon_sym_DASH] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1985),
    [anon_sym_AMP] = ACTIONS(1985),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1987),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1989),
    [anon_sym_DOT_DOT] = ACTIONS(1991),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1675] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7080),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6425),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4477),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9873),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1675),
    [sym_preproc_endregion] = STATE(1675),
    [sym_preproc_line] = STATE(1675),
    [sym_preproc_pragma] = STATE(1675),
    [sym_preproc_nullable] = STATE(1675),
    [sym_preproc_error] = STATE(1675),
    [sym_preproc_define] = STATE(1675),
    [sym_preproc_undef] = STATE(1675),
    [aux_sym_class_declaration_repeat1] = STATE(3845),
    [aux_sym_lambda_expression_repeat1] = STATE(4299),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1979),
    [anon_sym_ref] = ACTIONS(1981),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1985),
    [anon_sym_TILDE] = ACTIONS(1985),
    [anon_sym_PLUS_PLUS] = ACTIONS(1985),
    [anon_sym_DASH_DASH] = ACTIONS(1985),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1983),
    [anon_sym_DASH] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1985),
    [anon_sym_AMP] = ACTIONS(1985),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1987),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1989),
    [anon_sym_DOT_DOT] = ACTIONS(1991),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1676] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6908),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2874),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7094),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6687),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(3455),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1676),
    [sym_preproc_endregion] = STATE(1676),
    [sym_preproc_line] = STATE(1676),
    [sym_preproc_pragma] = STATE(1676),
    [sym_preproc_nullable] = STATE(1676),
    [sym_preproc_error] = STATE(1676),
    [sym_preproc_define] = STATE(1676),
    [sym_preproc_undef] = STATE(1676),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(2909),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1669),
    [anon_sym_TILDE] = ACTIONS(1669),
    [anon_sym_PLUS_PLUS] = ACTIONS(1669),
    [anon_sym_DASH_DASH] = ACTIONS(1669),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1667),
    [anon_sym_DASH] = ACTIONS(1667),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_CARET] = ACTIONS(1669),
    [anon_sym_AMP] = ACTIONS(1669),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1677] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7080),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6428),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4477),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9873),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1677),
    [sym_preproc_endregion] = STATE(1677),
    [sym_preproc_line] = STATE(1677),
    [sym_preproc_pragma] = STATE(1677),
    [sym_preproc_nullable] = STATE(1677),
    [sym_preproc_error] = STATE(1677),
    [sym_preproc_define] = STATE(1677),
    [sym_preproc_undef] = STATE(1677),
    [aux_sym_class_declaration_repeat1] = STATE(3845),
    [aux_sym_lambda_expression_repeat1] = STATE(4299),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1979),
    [anon_sym_ref] = ACTIONS(1981),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1985),
    [anon_sym_TILDE] = ACTIONS(1985),
    [anon_sym_PLUS_PLUS] = ACTIONS(1985),
    [anon_sym_DASH_DASH] = ACTIONS(1985),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1983),
    [anon_sym_DASH] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1985),
    [anon_sym_AMP] = ACTIONS(1985),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1987),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1989),
    [anon_sym_DOT_DOT] = ACTIONS(1991),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1678] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6887),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2935),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6959),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6220),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4399),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7410),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9332),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1678),
    [sym_preproc_endregion] = STATE(1678),
    [sym_preproc_line] = STATE(1678),
    [sym_preproc_pragma] = STATE(1678),
    [sym_preproc_nullable] = STATE(1678),
    [sym_preproc_error] = STATE(1678),
    [sym_preproc_define] = STATE(1678),
    [sym_preproc_undef] = STATE(1678),
    [aux_sym_class_declaration_repeat1] = STATE(3807),
    [aux_sym_lambda_expression_repeat1] = STATE(4128),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2115),
    [anon_sym_ref] = ACTIONS(2117),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2119),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(2123),
    [anon_sym_TILDE] = ACTIONS(2123),
    [anon_sym_PLUS_PLUS] = ACTIONS(2123),
    [anon_sym_DASH_DASH] = ACTIONS(2123),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2121),
    [anon_sym_DASH] = ACTIONS(2121),
    [anon_sym_STAR] = ACTIONS(2125),
    [anon_sym_CARET] = ACTIONS(2123),
    [anon_sym_AMP] = ACTIONS(2123),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2127),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2129),
    [anon_sym_DOT_DOT] = ACTIONS(2131),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1679] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6880),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7104),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(3902),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(3863),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7380),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9420),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1679),
    [sym_preproc_endregion] = STATE(1679),
    [sym_preproc_line] = STATE(1679),
    [sym_preproc_pragma] = STATE(1679),
    [sym_preproc_nullable] = STATE(1679),
    [sym_preproc_error] = STATE(1679),
    [sym_preproc_define] = STATE(1679),
    [sym_preproc_undef] = STATE(1679),
    [aux_sym_class_declaration_repeat1] = STATE(3820),
    [aux_sym_lambda_expression_repeat1] = STATE(4165),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1339),
    [anon_sym_ref] = ACTIONS(1341),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1097),
    [anon_sym_TILDE] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1099),
    [anon_sym_DASH] = ACTIONS(1099),
    [anon_sym_STAR] = ACTIONS(1343),
    [anon_sym_CARET] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1097),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1345),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1347),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1680] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7080),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6432),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4477),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9873),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1680),
    [sym_preproc_endregion] = STATE(1680),
    [sym_preproc_line] = STATE(1680),
    [sym_preproc_pragma] = STATE(1680),
    [sym_preproc_nullable] = STATE(1680),
    [sym_preproc_error] = STATE(1680),
    [sym_preproc_define] = STATE(1680),
    [sym_preproc_undef] = STATE(1680),
    [aux_sym_class_declaration_repeat1] = STATE(3845),
    [aux_sym_lambda_expression_repeat1] = STATE(4299),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1979),
    [anon_sym_ref] = ACTIONS(1981),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1985),
    [anon_sym_TILDE] = ACTIONS(1985),
    [anon_sym_PLUS_PLUS] = ACTIONS(1985),
    [anon_sym_DASH_DASH] = ACTIONS(1985),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1983),
    [anon_sym_DASH] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1985),
    [anon_sym_AMP] = ACTIONS(1985),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1987),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1989),
    [anon_sym_DOT_DOT] = ACTIONS(1991),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1681] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6914),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2882),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6963),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5316),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4002),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7386),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9254),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1681),
    [sym_preproc_endregion] = STATE(1681),
    [sym_preproc_line] = STATE(1681),
    [sym_preproc_pragma] = STATE(1681),
    [sym_preproc_nullable] = STATE(1681),
    [sym_preproc_error] = STATE(1681),
    [sym_preproc_define] = STATE(1681),
    [sym_preproc_undef] = STATE(1681),
    [aux_sym_class_declaration_repeat1] = STATE(3797),
    [aux_sym_lambda_expression_repeat1] = STATE(4081),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1727),
    [anon_sym_ref] = ACTIONS(1729),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1713),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1733),
    [anon_sym_TILDE] = ACTIONS(1733),
    [anon_sym_PLUS_PLUS] = ACTIONS(1733),
    [anon_sym_DASH_DASH] = ACTIONS(1733),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1731),
    [anon_sym_DASH] = ACTIONS(1731),
    [anon_sym_STAR] = ACTIONS(1735),
    [anon_sym_CARET] = ACTIONS(1733),
    [anon_sym_AMP] = ACTIONS(1733),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1737),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1739),
    [anon_sym_DOT_DOT] = ACTIONS(1741),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1682] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6879),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2935),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7096),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(3849),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4288),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7379),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9175),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1682),
    [sym_preproc_endregion] = STATE(1682),
    [sym_preproc_line] = STATE(1682),
    [sym_preproc_pragma] = STATE(1682),
    [sym_preproc_nullable] = STATE(1682),
    [sym_preproc_error] = STATE(1682),
    [sym_preproc_define] = STATE(1682),
    [sym_preproc_undef] = STATE(1682),
    [aux_sym_class_declaration_repeat1] = STATE(3816),
    [aux_sym_lambda_expression_repeat1] = STATE(4119),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1867),
    [anon_sym_ref] = ACTIONS(1869),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1871),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1875),
    [anon_sym_TILDE] = ACTIONS(1875),
    [anon_sym_PLUS_PLUS] = ACTIONS(1875),
    [anon_sym_DASH_DASH] = ACTIONS(1875),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1873),
    [anon_sym_DASH] = ACTIONS(1873),
    [anon_sym_STAR] = ACTIONS(1877),
    [anon_sym_CARET] = ACTIONS(1875),
    [anon_sym_AMP] = ACTIONS(1875),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1879),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1881),
    [anon_sym_DOT_DOT] = ACTIONS(1883),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1683] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7080),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6446),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4477),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9873),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1683),
    [sym_preproc_endregion] = STATE(1683),
    [sym_preproc_line] = STATE(1683),
    [sym_preproc_pragma] = STATE(1683),
    [sym_preproc_nullable] = STATE(1683),
    [sym_preproc_error] = STATE(1683),
    [sym_preproc_define] = STATE(1683),
    [sym_preproc_undef] = STATE(1683),
    [aux_sym_class_declaration_repeat1] = STATE(3845),
    [aux_sym_lambda_expression_repeat1] = STATE(4299),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1979),
    [anon_sym_ref] = ACTIONS(1981),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1985),
    [anon_sym_TILDE] = ACTIONS(1985),
    [anon_sym_PLUS_PLUS] = ACTIONS(1985),
    [anon_sym_DASH_DASH] = ACTIONS(1985),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1983),
    [anon_sym_DASH] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1985),
    [anon_sym_AMP] = ACTIONS(1985),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1987),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1989),
    [anon_sym_DOT_DOT] = ACTIONS(1991),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1684] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6888),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2882),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7048),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5238),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4019),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7409),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9210),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1684),
    [sym_preproc_endregion] = STATE(1684),
    [sym_preproc_line] = STATE(1684),
    [sym_preproc_pragma] = STATE(1684),
    [sym_preproc_nullable] = STATE(1684),
    [sym_preproc_error] = STATE(1684),
    [sym_preproc_define] = STATE(1684),
    [sym_preproc_undef] = STATE(1684),
    [aux_sym_class_declaration_repeat1] = STATE(3812),
    [aux_sym_lambda_expression_repeat1] = STATE(4146),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1709),
    [anon_sym_ref] = ACTIONS(1711),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1713),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1717),
    [anon_sym_TILDE] = ACTIONS(1717),
    [anon_sym_PLUS_PLUS] = ACTIONS(1717),
    [anon_sym_DASH_DASH] = ACTIONS(1717),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1715),
    [anon_sym_DASH] = ACTIONS(1715),
    [anon_sym_STAR] = ACTIONS(1719),
    [anon_sym_CARET] = ACTIONS(1717),
    [anon_sym_AMP] = ACTIONS(1717),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1721),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1723),
    [anon_sym_DOT_DOT] = ACTIONS(1725),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1685] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6887),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2935),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6959),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6208),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4399),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7410),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9332),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1685),
    [sym_preproc_endregion] = STATE(1685),
    [sym_preproc_line] = STATE(1685),
    [sym_preproc_pragma] = STATE(1685),
    [sym_preproc_nullable] = STATE(1685),
    [sym_preproc_error] = STATE(1685),
    [sym_preproc_define] = STATE(1685),
    [sym_preproc_undef] = STATE(1685),
    [aux_sym_class_declaration_repeat1] = STATE(3807),
    [aux_sym_lambda_expression_repeat1] = STATE(4128),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2115),
    [anon_sym_ref] = ACTIONS(2117),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2119),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(2123),
    [anon_sym_TILDE] = ACTIONS(2123),
    [anon_sym_PLUS_PLUS] = ACTIONS(2123),
    [anon_sym_DASH_DASH] = ACTIONS(2123),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2121),
    [anon_sym_DASH] = ACTIONS(2121),
    [anon_sym_STAR] = ACTIONS(2125),
    [anon_sym_CARET] = ACTIONS(2123),
    [anon_sym_AMP] = ACTIONS(2123),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2127),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2129),
    [anon_sym_DOT_DOT] = ACTIONS(2131),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1686] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6888),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2882),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7048),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5239),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4019),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7409),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9210),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1686),
    [sym_preproc_endregion] = STATE(1686),
    [sym_preproc_line] = STATE(1686),
    [sym_preproc_pragma] = STATE(1686),
    [sym_preproc_nullable] = STATE(1686),
    [sym_preproc_error] = STATE(1686),
    [sym_preproc_define] = STATE(1686),
    [sym_preproc_undef] = STATE(1686),
    [aux_sym_class_declaration_repeat1] = STATE(3812),
    [aux_sym_lambda_expression_repeat1] = STATE(4146),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1709),
    [anon_sym_ref] = ACTIONS(1711),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1713),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1717),
    [anon_sym_TILDE] = ACTIONS(1717),
    [anon_sym_PLUS_PLUS] = ACTIONS(1717),
    [anon_sym_DASH_DASH] = ACTIONS(1717),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1715),
    [anon_sym_DASH] = ACTIONS(1715),
    [anon_sym_STAR] = ACTIONS(1719),
    [anon_sym_CARET] = ACTIONS(1717),
    [anon_sym_AMP] = ACTIONS(1717),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1721),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1723),
    [anon_sym_DOT_DOT] = ACTIONS(1725),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1687] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6909),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2874),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7062),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(3902),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4291),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7411),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9300),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1687),
    [sym_preproc_endregion] = STATE(1687),
    [sym_preproc_line] = STATE(1687),
    [sym_preproc_pragma] = STATE(1687),
    [sym_preproc_nullable] = STATE(1687),
    [sym_preproc_error] = STATE(1687),
    [sym_preproc_define] = STATE(1687),
    [sym_preproc_undef] = STATE(1687),
    [aux_sym_class_declaration_repeat1] = STATE(3804),
    [aux_sym_lambda_expression_repeat1] = STATE(4114),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1501),
    [anon_sym_ref] = ACTIONS(1503),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1505),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1509),
    [anon_sym_PLUS_PLUS] = ACTIONS(1509),
    [anon_sym_DASH_DASH] = ACTIONS(1509),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1507),
    [anon_sym_DASH] = ACTIONS(1507),
    [anon_sym_STAR] = ACTIONS(1511),
    [anon_sym_CARET] = ACTIONS(1509),
    [anon_sym_AMP] = ACTIONS(1509),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1513),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1515),
    [anon_sym_DOT_DOT] = ACTIONS(1517),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1688] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6887),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2935),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6959),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(3556),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4399),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7410),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9332),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1688),
    [sym_preproc_endregion] = STATE(1688),
    [sym_preproc_line] = STATE(1688),
    [sym_preproc_pragma] = STATE(1688),
    [sym_preproc_nullable] = STATE(1688),
    [sym_preproc_error] = STATE(1688),
    [sym_preproc_define] = STATE(1688),
    [sym_preproc_undef] = STATE(1688),
    [aux_sym_class_declaration_repeat1] = STATE(3807),
    [aux_sym_lambda_expression_repeat1] = STATE(4128),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2115),
    [anon_sym_ref] = ACTIONS(2117),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2119),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(2123),
    [anon_sym_TILDE] = ACTIONS(2123),
    [anon_sym_PLUS_PLUS] = ACTIONS(2123),
    [anon_sym_DASH_DASH] = ACTIONS(2123),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2121),
    [anon_sym_DASH] = ACTIONS(2121),
    [anon_sym_STAR] = ACTIONS(2125),
    [anon_sym_CARET] = ACTIONS(2123),
    [anon_sym_AMP] = ACTIONS(2123),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2127),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2129),
    [anon_sym_DOT_DOT] = ACTIONS(2131),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1689] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7080),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6449),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4477),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9873),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1689),
    [sym_preproc_endregion] = STATE(1689),
    [sym_preproc_line] = STATE(1689),
    [sym_preproc_pragma] = STATE(1689),
    [sym_preproc_nullable] = STATE(1689),
    [sym_preproc_error] = STATE(1689),
    [sym_preproc_define] = STATE(1689),
    [sym_preproc_undef] = STATE(1689),
    [aux_sym_class_declaration_repeat1] = STATE(3845),
    [aux_sym_lambda_expression_repeat1] = STATE(4299),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1979),
    [anon_sym_ref] = ACTIONS(1981),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1985),
    [anon_sym_TILDE] = ACTIONS(1985),
    [anon_sym_PLUS_PLUS] = ACTIONS(1985),
    [anon_sym_DASH_DASH] = ACTIONS(1985),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1983),
    [anon_sym_DASH] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1985),
    [anon_sym_AMP] = ACTIONS(1985),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1987),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1989),
    [anon_sym_DOT_DOT] = ACTIONS(1991),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1690] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7080),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6451),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4477),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9873),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1690),
    [sym_preproc_endregion] = STATE(1690),
    [sym_preproc_line] = STATE(1690),
    [sym_preproc_pragma] = STATE(1690),
    [sym_preproc_nullable] = STATE(1690),
    [sym_preproc_error] = STATE(1690),
    [sym_preproc_define] = STATE(1690),
    [sym_preproc_undef] = STATE(1690),
    [aux_sym_class_declaration_repeat1] = STATE(3845),
    [aux_sym_lambda_expression_repeat1] = STATE(4299),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1979),
    [anon_sym_ref] = ACTIONS(1981),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1985),
    [anon_sym_TILDE] = ACTIONS(1985),
    [anon_sym_PLUS_PLUS] = ACTIONS(1985),
    [anon_sym_DASH_DASH] = ACTIONS(1985),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1983),
    [anon_sym_DASH] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1985),
    [anon_sym_AMP] = ACTIONS(1985),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1987),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1989),
    [anon_sym_DOT_DOT] = ACTIONS(1991),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1691] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6887),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2935),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6959),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6196),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4399),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7410),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9332),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1691),
    [sym_preproc_endregion] = STATE(1691),
    [sym_preproc_line] = STATE(1691),
    [sym_preproc_pragma] = STATE(1691),
    [sym_preproc_nullable] = STATE(1691),
    [sym_preproc_error] = STATE(1691),
    [sym_preproc_define] = STATE(1691),
    [sym_preproc_undef] = STATE(1691),
    [aux_sym_class_declaration_repeat1] = STATE(3807),
    [aux_sym_lambda_expression_repeat1] = STATE(4128),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2115),
    [anon_sym_ref] = ACTIONS(2117),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2119),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(2123),
    [anon_sym_TILDE] = ACTIONS(2123),
    [anon_sym_PLUS_PLUS] = ACTIONS(2123),
    [anon_sym_DASH_DASH] = ACTIONS(2123),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2121),
    [anon_sym_DASH] = ACTIONS(2121),
    [anon_sym_STAR] = ACTIONS(2125),
    [anon_sym_CARET] = ACTIONS(2123),
    [anon_sym_AMP] = ACTIONS(2123),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2127),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2129),
    [anon_sym_DOT_DOT] = ACTIONS(2131),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1692] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6880),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7094),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6687),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(3455),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1692),
    [sym_preproc_endregion] = STATE(1692),
    [sym_preproc_line] = STATE(1692),
    [sym_preproc_pragma] = STATE(1692),
    [sym_preproc_nullable] = STATE(1692),
    [sym_preproc_error] = STATE(1692),
    [sym_preproc_define] = STATE(1692),
    [sym_preproc_undef] = STATE(1692),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(2909),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1669),
    [anon_sym_TILDE] = ACTIONS(1669),
    [anon_sym_PLUS_PLUS] = ACTIONS(1669),
    [anon_sym_DASH_DASH] = ACTIONS(1669),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1667),
    [anon_sym_DASH] = ACTIONS(1667),
    [anon_sym_STAR] = ACTIONS(1343),
    [anon_sym_CARET] = ACTIONS(1669),
    [anon_sym_AMP] = ACTIONS(1669),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1693] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6620),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1693),
    [sym_preproc_endregion] = STATE(1693),
    [sym_preproc_line] = STATE(1693),
    [sym_preproc_pragma] = STATE(1693),
    [sym_preproc_nullable] = STATE(1693),
    [sym_preproc_error] = STATE(1693),
    [sym_preproc_define] = STATE(1693),
    [sym_preproc_undef] = STATE(1693),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1694] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3559),
    [sym__name] = STATE(6878),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2911),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6960),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4481),
    [sym_non_lvalue_expression] = STATE(4553),
    [sym_lvalue_expression] = STATE(3607),
    [sym__expression_statement_expression] = STATE(4559),
    [sym_assignment_expression] = STATE(4558),
    [sym_binary_expression] = STATE(4559),
    [sym_postfix_unary_expression] = STATE(4558),
    [sym_prefix_unary_expression] = STATE(4558),
    [sym__pointer_indirection_expression] = STATE(3560),
    [sym_query_expression] = STATE(4559),
    [sym_from_clause] = STATE(7385),
    [sym_conditional_expression] = STATE(4559),
    [sym_conditional_access_expression] = STATE(4559),
    [sym_as_expression] = STATE(4559),
    [sym_is_expression] = STATE(4559),
    [sym_is_pattern_expression] = STATE(4559),
    [sym_cast_expression] = STATE(4559),
    [sym_checked_expression] = STATE(4559),
    [sym_invocation_expression] = STATE(4558),
    [sym_switch_expression] = STATE(4559),
    [sym_await_expression] = STATE(4558),
    [sym_throw_expression] = STATE(4559),
    [sym_element_access_expression] = STATE(3560),
    [sym_interpolated_string_expression] = STATE(4559),
    [sym_member_access_expression] = STATE(3560),
    [sym_object_creation_expression] = STATE(4558),
    [sym_parenthesized_expression] = STATE(4558),
    [sym__parenthesized_lvalue_expression] = STATE(3560),
    [sym_lambda_expression] = STATE(4559),
    [sym__lambda_parameters] = STATE(9554),
    [sym_array_creation_expression] = STATE(4559),
    [sym_anonymous_method_expression] = STATE(4559),
    [sym_anonymous_object_creation_expression] = STATE(4559),
    [sym_implicit_array_creation_expression] = STATE(4559),
    [sym_implicit_object_creation_expression] = STATE(4559),
    [sym_implicit_stackalloc_expression] = STATE(4559),
    [sym_initializer_expression] = STATE(4559),
    [sym_default_expression] = STATE(4559),
    [sym_with_expression] = STATE(4559),
    [sym_sizeof_expression] = STATE(4559),
    [sym_typeof_expression] = STATE(4559),
    [sym_makeref_expression] = STATE(4559),
    [sym_ref_expression] = STATE(4559),
    [sym_reftype_expression] = STATE(4559),
    [sym_refvalue_expression] = STATE(4559),
    [sym_stackalloc_expression] = STATE(4559),
    [sym_range_expression] = STATE(4559),
    [sym_tuple_expression] = STATE(3560),
    [sym_literal] = STATE(4559),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4559),
    [sym_preproc_region] = STATE(1694),
    [sym_preproc_endregion] = STATE(1694),
    [sym_preproc_line] = STATE(1694),
    [sym_preproc_pragma] = STATE(1694),
    [sym_preproc_nullable] = STATE(1694),
    [sym_preproc_error] = STATE(1694),
    [sym_preproc_define] = STATE(1694),
    [sym_preproc_undef] = STATE(1694),
    [aux_sym_class_declaration_repeat1] = STATE(3792),
    [aux_sym_lambda_expression_repeat1] = STATE(4202),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(1607),
    [anon_sym_ref] = ACTIONS(1609),
    [anon_sym_LBRACE] = ACTIONS(1611),
    [anon_sym_delegate] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1615),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(1621),
    [anon_sym_TILDE] = ACTIONS(1621),
    [anon_sym_PLUS_PLUS] = ACTIONS(1621),
    [anon_sym_DASH_DASH] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(1619),
    [anon_sym_DASH] = ACTIONS(1619),
    [anon_sym_STAR] = ACTIONS(1625),
    [anon_sym_CARET] = ACTIONS(1621),
    [anon_sym_AMP] = ACTIONS(1621),
    [anon_sym_this] = ACTIONS(1627),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1629),
    [anon_sym_unchecked] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [anon_sym_DOT_DOT] = ACTIONS(1637),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_stackalloc] = ACTIONS(1641),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(1647),
    [anon_sym___reftype] = ACTIONS(1649),
    [anon_sym___refvalue] = ACTIONS(1651),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1659),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [1695] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6918),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7066),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6193),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4423),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7383),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9203),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1695),
    [sym_preproc_endregion] = STATE(1695),
    [sym_preproc_line] = STATE(1695),
    [sym_preproc_pragma] = STATE(1695),
    [sym_preproc_nullable] = STATE(1695),
    [sym_preproc_error] = STATE(1695),
    [sym_preproc_define] = STATE(1695),
    [sym_preproc_undef] = STATE(1695),
    [aux_sym_class_declaration_repeat1] = STATE(3817),
    [aux_sym_lambda_expression_repeat1] = STATE(4152),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1905),
    [anon_sym_ref] = ACTIONS(1907),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1221),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1911),
    [anon_sym_TILDE] = ACTIONS(1911),
    [anon_sym_PLUS_PLUS] = ACTIONS(1911),
    [anon_sym_DASH_DASH] = ACTIONS(1911),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1909),
    [anon_sym_DASH] = ACTIONS(1909),
    [anon_sym_STAR] = ACTIONS(1913),
    [anon_sym_CARET] = ACTIONS(1911),
    [anon_sym_AMP] = ACTIONS(1911),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1915),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1917),
    [anon_sym_DOT_DOT] = ACTIONS(1919),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1696] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6880),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7104),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(3922),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(3863),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7380),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9420),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1696),
    [sym_preproc_endregion] = STATE(1696),
    [sym_preproc_line] = STATE(1696),
    [sym_preproc_pragma] = STATE(1696),
    [sym_preproc_nullable] = STATE(1696),
    [sym_preproc_error] = STATE(1696),
    [sym_preproc_define] = STATE(1696),
    [sym_preproc_undef] = STATE(1696),
    [aux_sym_class_declaration_repeat1] = STATE(3820),
    [aux_sym_lambda_expression_repeat1] = STATE(4165),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1339),
    [anon_sym_ref] = ACTIONS(1341),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1097),
    [anon_sym_TILDE] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1099),
    [anon_sym_DASH] = ACTIONS(1099),
    [anon_sym_STAR] = ACTIONS(1343),
    [anon_sym_CARET] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1097),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1345),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1347),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1697] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6628),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1697),
    [sym_preproc_endregion] = STATE(1697),
    [sym_preproc_line] = STATE(1697),
    [sym_preproc_pragma] = STATE(1697),
    [sym_preproc_nullable] = STATE(1697),
    [sym_preproc_error] = STATE(1697),
    [sym_preproc_define] = STATE(1697),
    [sym_preproc_undef] = STATE(1697),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1698] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6918),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7066),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6192),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4423),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7383),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9203),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1698),
    [sym_preproc_endregion] = STATE(1698),
    [sym_preproc_line] = STATE(1698),
    [sym_preproc_pragma] = STATE(1698),
    [sym_preproc_nullable] = STATE(1698),
    [sym_preproc_error] = STATE(1698),
    [sym_preproc_define] = STATE(1698),
    [sym_preproc_undef] = STATE(1698),
    [aux_sym_class_declaration_repeat1] = STATE(3817),
    [aux_sym_lambda_expression_repeat1] = STATE(4152),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1905),
    [anon_sym_ref] = ACTIONS(1907),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1221),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1911),
    [anon_sym_TILDE] = ACTIONS(1911),
    [anon_sym_PLUS_PLUS] = ACTIONS(1911),
    [anon_sym_DASH_DASH] = ACTIONS(1911),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1909),
    [anon_sym_DASH] = ACTIONS(1909),
    [anon_sym_STAR] = ACTIONS(1913),
    [anon_sym_CARET] = ACTIONS(1911),
    [anon_sym_AMP] = ACTIONS(1911),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1915),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1917),
    [anon_sym_DOT_DOT] = ACTIONS(1919),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1699] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6648),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1699),
    [sym_preproc_endregion] = STATE(1699),
    [sym_preproc_line] = STATE(1699),
    [sym_preproc_pragma] = STATE(1699),
    [sym_preproc_nullable] = STATE(1699),
    [sym_preproc_error] = STATE(1699),
    [sym_preproc_define] = STATE(1699),
    [sym_preproc_undef] = STATE(1699),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1700] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6880),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7104),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5169),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(3863),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7380),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9420),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1700),
    [sym_preproc_endregion] = STATE(1700),
    [sym_preproc_line] = STATE(1700),
    [sym_preproc_pragma] = STATE(1700),
    [sym_preproc_nullable] = STATE(1700),
    [sym_preproc_error] = STATE(1700),
    [sym_preproc_define] = STATE(1700),
    [sym_preproc_undef] = STATE(1700),
    [aux_sym_class_declaration_repeat1] = STATE(3820),
    [aux_sym_lambda_expression_repeat1] = STATE(4165),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1339),
    [anon_sym_ref] = ACTIONS(1341),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1097),
    [anon_sym_TILDE] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1099),
    [anon_sym_DASH] = ACTIONS(1099),
    [anon_sym_STAR] = ACTIONS(1343),
    [anon_sym_CARET] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1097),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1345),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1347),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1701] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6880),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7104),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5165),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(3863),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7380),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9420),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1701),
    [sym_preproc_endregion] = STATE(1701),
    [sym_preproc_line] = STATE(1701),
    [sym_preproc_pragma] = STATE(1701),
    [sym_preproc_nullable] = STATE(1701),
    [sym_preproc_error] = STATE(1701),
    [sym_preproc_define] = STATE(1701),
    [sym_preproc_undef] = STATE(1701),
    [aux_sym_class_declaration_repeat1] = STATE(3820),
    [aux_sym_lambda_expression_repeat1] = STATE(4165),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1339),
    [anon_sym_ref] = ACTIONS(1341),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1097),
    [anon_sym_TILDE] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1099),
    [anon_sym_DASH] = ACTIONS(1099),
    [anon_sym_STAR] = ACTIONS(1343),
    [anon_sym_CARET] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1097),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1345),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1347),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1702] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6880),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7104),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5134),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(3863),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7380),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9420),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1702),
    [sym_preproc_endregion] = STATE(1702),
    [sym_preproc_line] = STATE(1702),
    [sym_preproc_pragma] = STATE(1702),
    [sym_preproc_nullable] = STATE(1702),
    [sym_preproc_error] = STATE(1702),
    [sym_preproc_define] = STATE(1702),
    [sym_preproc_undef] = STATE(1702),
    [aux_sym_class_declaration_repeat1] = STATE(3820),
    [aux_sym_lambda_expression_repeat1] = STATE(4165),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1339),
    [anon_sym_ref] = ACTIONS(1341),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1097),
    [anon_sym_TILDE] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1099),
    [anon_sym_DASH] = ACTIONS(1099),
    [anon_sym_STAR] = ACTIONS(1343),
    [anon_sym_CARET] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1097),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1345),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1347),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1703] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6880),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7104),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5156),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(3863),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7380),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9420),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1703),
    [sym_preproc_endregion] = STATE(1703),
    [sym_preproc_line] = STATE(1703),
    [sym_preproc_pragma] = STATE(1703),
    [sym_preproc_nullable] = STATE(1703),
    [sym_preproc_error] = STATE(1703),
    [sym_preproc_define] = STATE(1703),
    [sym_preproc_undef] = STATE(1703),
    [aux_sym_class_declaration_repeat1] = STATE(3820),
    [aux_sym_lambda_expression_repeat1] = STATE(4165),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1339),
    [anon_sym_ref] = ACTIONS(1341),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1097),
    [anon_sym_TILDE] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1099),
    [anon_sym_DASH] = ACTIONS(1099),
    [anon_sym_STAR] = ACTIONS(1343),
    [anon_sym_CARET] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1097),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1345),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1347),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1704] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6880),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7104),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5155),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(3863),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7380),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9420),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1704),
    [sym_preproc_endregion] = STATE(1704),
    [sym_preproc_line] = STATE(1704),
    [sym_preproc_pragma] = STATE(1704),
    [sym_preproc_nullable] = STATE(1704),
    [sym_preproc_error] = STATE(1704),
    [sym_preproc_define] = STATE(1704),
    [sym_preproc_undef] = STATE(1704),
    [aux_sym_class_declaration_repeat1] = STATE(3820),
    [aux_sym_lambda_expression_repeat1] = STATE(4165),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1339),
    [anon_sym_ref] = ACTIONS(1341),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1097),
    [anon_sym_TILDE] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1099),
    [anon_sym_DASH] = ACTIONS(1099),
    [anon_sym_STAR] = ACTIONS(1343),
    [anon_sym_CARET] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1097),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1345),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1347),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1705] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6910),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2957),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7089),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4942),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(3796),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7395),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9374),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1705),
    [sym_preproc_endregion] = STATE(1705),
    [sym_preproc_line] = STATE(1705),
    [sym_preproc_pragma] = STATE(1705),
    [sym_preproc_nullable] = STATE(1705),
    [sym_preproc_error] = STATE(1705),
    [sym_preproc_define] = STATE(1705),
    [sym_preproc_undef] = STATE(1705),
    [aux_sym_class_declaration_repeat1] = STATE(3839),
    [aux_sym_lambda_expression_repeat1] = STATE(4209),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2139),
    [anon_sym_ref] = ACTIONS(2141),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1799),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2145),
    [anon_sym_TILDE] = ACTIONS(2145),
    [anon_sym_PLUS_PLUS] = ACTIONS(2145),
    [anon_sym_DASH_DASH] = ACTIONS(2145),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2143),
    [anon_sym_DASH] = ACTIONS(2143),
    [anon_sym_STAR] = ACTIONS(1805),
    [anon_sym_CARET] = ACTIONS(2145),
    [anon_sym_AMP] = ACTIONS(2145),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2147),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2149),
    [anon_sym_DOT_DOT] = ACTIONS(2151),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1706] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6961),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6646),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9849),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1706),
    [sym_preproc_endregion] = STATE(1706),
    [sym_preproc_line] = STATE(1706),
    [sym_preproc_pragma] = STATE(1706),
    [sym_preproc_nullable] = STATE(1706),
    [sym_preproc_error] = STATE(1706),
    [sym_preproc_define] = STATE(1706),
    [sym_preproc_undef] = STATE(1706),
    [aux_sym_class_declaration_repeat1] = STATE(3841),
    [aux_sym_lambda_expression_repeat1] = STATE(4283),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1459),
    [anon_sym_ref] = ACTIONS(1461),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1465),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1467),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1469),
    [anon_sym_DOT_DOT] = ACTIONS(1471),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1707] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6880),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7104),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5154),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(3863),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7380),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9420),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1707),
    [sym_preproc_endregion] = STATE(1707),
    [sym_preproc_line] = STATE(1707),
    [sym_preproc_pragma] = STATE(1707),
    [sym_preproc_nullable] = STATE(1707),
    [sym_preproc_error] = STATE(1707),
    [sym_preproc_define] = STATE(1707),
    [sym_preproc_undef] = STATE(1707),
    [aux_sym_class_declaration_repeat1] = STATE(3820),
    [aux_sym_lambda_expression_repeat1] = STATE(4165),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1339),
    [anon_sym_ref] = ACTIONS(1341),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1097),
    [anon_sym_TILDE] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1099),
    [anon_sym_DASH] = ACTIONS(1099),
    [anon_sym_STAR] = ACTIONS(1343),
    [anon_sym_CARET] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1097),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1345),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1347),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1708] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3559),
    [sym__name] = STATE(6878),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2911),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6938),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4800),
    [sym_non_lvalue_expression] = STATE(4553),
    [sym_lvalue_expression] = STATE(3750),
    [sym__expression_statement_expression] = STATE(4559),
    [sym_assignment_expression] = STATE(4558),
    [sym_binary_expression] = STATE(4559),
    [sym_postfix_unary_expression] = STATE(4558),
    [sym_prefix_unary_expression] = STATE(4558),
    [sym__pointer_indirection_expression] = STATE(3560),
    [sym_query_expression] = STATE(4559),
    [sym_from_clause] = STATE(7406),
    [sym_conditional_expression] = STATE(4559),
    [sym_conditional_access_expression] = STATE(4559),
    [sym_as_expression] = STATE(4559),
    [sym_is_expression] = STATE(4559),
    [sym_is_pattern_expression] = STATE(4559),
    [sym_cast_expression] = STATE(4559),
    [sym_checked_expression] = STATE(4559),
    [sym_invocation_expression] = STATE(4558),
    [sym_switch_expression] = STATE(4559),
    [sym_await_expression] = STATE(4558),
    [sym_throw_expression] = STATE(4559),
    [sym_element_access_expression] = STATE(3560),
    [sym_interpolated_string_expression] = STATE(4559),
    [sym_member_access_expression] = STATE(3560),
    [sym_object_creation_expression] = STATE(4558),
    [sym_parenthesized_expression] = STATE(4558),
    [sym__parenthesized_lvalue_expression] = STATE(3560),
    [sym_lambda_expression] = STATE(4559),
    [sym__lambda_parameters] = STATE(9691),
    [sym_array_creation_expression] = STATE(4559),
    [sym_anonymous_method_expression] = STATE(4559),
    [sym_anonymous_object_creation_expression] = STATE(4559),
    [sym_implicit_array_creation_expression] = STATE(4559),
    [sym_implicit_object_creation_expression] = STATE(4559),
    [sym_implicit_stackalloc_expression] = STATE(4559),
    [sym_initializer_expression] = STATE(4559),
    [sym_default_expression] = STATE(4559),
    [sym_with_expression] = STATE(4559),
    [sym_sizeof_expression] = STATE(4559),
    [sym_typeof_expression] = STATE(4559),
    [sym_makeref_expression] = STATE(4559),
    [sym_ref_expression] = STATE(4559),
    [sym_reftype_expression] = STATE(4559),
    [sym_refvalue_expression] = STATE(4559),
    [sym_stackalloc_expression] = STATE(4559),
    [sym_range_expression] = STATE(4559),
    [sym_tuple_expression] = STATE(3560),
    [sym_literal] = STATE(4559),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4559),
    [sym_preproc_region] = STATE(1708),
    [sym_preproc_endregion] = STATE(1708),
    [sym_preproc_line] = STATE(1708),
    [sym_preproc_pragma] = STATE(1708),
    [sym_preproc_nullable] = STATE(1708),
    [sym_preproc_error] = STATE(1708),
    [sym_preproc_define] = STATE(1708),
    [sym_preproc_undef] = STATE(1708),
    [aux_sym_class_declaration_repeat1] = STATE(3836),
    [aux_sym_lambda_expression_repeat1] = STATE(4216),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(2003),
    [anon_sym_ref] = ACTIONS(2005),
    [anon_sym_LBRACE] = ACTIONS(1611),
    [anon_sym_delegate] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1615),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(2009),
    [anon_sym_TILDE] = ACTIONS(2009),
    [anon_sym_PLUS_PLUS] = ACTIONS(2009),
    [anon_sym_DASH_DASH] = ACTIONS(2009),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(2007),
    [anon_sym_DASH] = ACTIONS(2007),
    [anon_sym_STAR] = ACTIONS(1625),
    [anon_sym_CARET] = ACTIONS(2009),
    [anon_sym_AMP] = ACTIONS(2009),
    [anon_sym_this] = ACTIONS(1627),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1629),
    [anon_sym_unchecked] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(2011),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2013),
    [anon_sym_DOT_DOT] = ACTIONS(2015),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_stackalloc] = ACTIONS(1641),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(1647),
    [anon_sym___reftype] = ACTIONS(1649),
    [anon_sym___refvalue] = ACTIONS(1651),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1659),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [1709] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6880),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7104),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5153),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(3863),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7380),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9420),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1709),
    [sym_preproc_endregion] = STATE(1709),
    [sym_preproc_line] = STATE(1709),
    [sym_preproc_pragma] = STATE(1709),
    [sym_preproc_nullable] = STATE(1709),
    [sym_preproc_error] = STATE(1709),
    [sym_preproc_define] = STATE(1709),
    [sym_preproc_undef] = STATE(1709),
    [aux_sym_class_declaration_repeat1] = STATE(3820),
    [aux_sym_lambda_expression_repeat1] = STATE(4165),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1339),
    [anon_sym_ref] = ACTIONS(1341),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1097),
    [anon_sym_TILDE] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1099),
    [anon_sym_DASH] = ACTIONS(1099),
    [anon_sym_STAR] = ACTIONS(1343),
    [anon_sym_CARET] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1097),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1345),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1347),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1710] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6880),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7104),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5108),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(3863),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7380),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9420),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1710),
    [sym_preproc_endregion] = STATE(1710),
    [sym_preproc_line] = STATE(1710),
    [sym_preproc_pragma] = STATE(1710),
    [sym_preproc_nullable] = STATE(1710),
    [sym_preproc_error] = STATE(1710),
    [sym_preproc_define] = STATE(1710),
    [sym_preproc_undef] = STATE(1710),
    [aux_sym_class_declaration_repeat1] = STATE(3820),
    [aux_sym_lambda_expression_repeat1] = STATE(4165),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1339),
    [anon_sym_ref] = ACTIONS(1341),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1097),
    [anon_sym_TILDE] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1099),
    [anon_sym_DASH] = ACTIONS(1099),
    [anon_sym_STAR] = ACTIONS(1343),
    [anon_sym_CARET] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1097),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1345),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1347),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1711] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6880),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7104),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5183),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(3863),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7380),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9420),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1711),
    [sym_preproc_endregion] = STATE(1711),
    [sym_preproc_line] = STATE(1711),
    [sym_preproc_pragma] = STATE(1711),
    [sym_preproc_nullable] = STATE(1711),
    [sym_preproc_error] = STATE(1711),
    [sym_preproc_define] = STATE(1711),
    [sym_preproc_undef] = STATE(1711),
    [aux_sym_class_declaration_repeat1] = STATE(3820),
    [aux_sym_lambda_expression_repeat1] = STATE(4165),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1339),
    [anon_sym_ref] = ACTIONS(1341),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1097),
    [anon_sym_TILDE] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1099),
    [anon_sym_DASH] = ACTIONS(1099),
    [anon_sym_STAR] = ACTIONS(1343),
    [anon_sym_CARET] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1097),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1345),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1347),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1712] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6880),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7104),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5151),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(3863),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7380),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9420),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1712),
    [sym_preproc_endregion] = STATE(1712),
    [sym_preproc_line] = STATE(1712),
    [sym_preproc_pragma] = STATE(1712),
    [sym_preproc_nullable] = STATE(1712),
    [sym_preproc_error] = STATE(1712),
    [sym_preproc_define] = STATE(1712),
    [sym_preproc_undef] = STATE(1712),
    [aux_sym_class_declaration_repeat1] = STATE(3820),
    [aux_sym_lambda_expression_repeat1] = STATE(4165),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1339),
    [anon_sym_ref] = ACTIONS(1341),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1097),
    [anon_sym_TILDE] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1099),
    [anon_sym_DASH] = ACTIONS(1099),
    [anon_sym_STAR] = ACTIONS(1343),
    [anon_sym_CARET] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1097),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1345),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1347),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1713] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6880),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7104),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5150),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(3863),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7380),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9420),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1713),
    [sym_preproc_endregion] = STATE(1713),
    [sym_preproc_line] = STATE(1713),
    [sym_preproc_pragma] = STATE(1713),
    [sym_preproc_nullable] = STATE(1713),
    [sym_preproc_error] = STATE(1713),
    [sym_preproc_define] = STATE(1713),
    [sym_preproc_undef] = STATE(1713),
    [aux_sym_class_declaration_repeat1] = STATE(3820),
    [aux_sym_lambda_expression_repeat1] = STATE(4165),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1339),
    [anon_sym_ref] = ACTIONS(1341),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1097),
    [anon_sym_TILDE] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1099),
    [anon_sym_DASH] = ACTIONS(1099),
    [anon_sym_STAR] = ACTIONS(1343),
    [anon_sym_CARET] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1097),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1345),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1347),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1714] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6880),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7055),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(3902),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4312),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7380),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9286),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1714),
    [sym_preproc_endregion] = STATE(1714),
    [sym_preproc_line] = STATE(1714),
    [sym_preproc_pragma] = STATE(1714),
    [sym_preproc_nullable] = STATE(1714),
    [sym_preproc_error] = STATE(1714),
    [sym_preproc_define] = STATE(1714),
    [sym_preproc_undef] = STATE(1714),
    [aux_sym_class_declaration_repeat1] = STATE(3799),
    [aux_sym_lambda_expression_repeat1] = STATE(4101),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1545),
    [anon_sym_ref] = ACTIONS(1547),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1551),
    [anon_sym_TILDE] = ACTIONS(1551),
    [anon_sym_PLUS_PLUS] = ACTIONS(1551),
    [anon_sym_DASH_DASH] = ACTIONS(1551),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1549),
    [anon_sym_DASH] = ACTIONS(1549),
    [anon_sym_STAR] = ACTIONS(1553),
    [anon_sym_CARET] = ACTIONS(1551),
    [anon_sym_AMP] = ACTIONS(1551),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1555),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1557),
    [anon_sym_DOT_DOT] = ACTIONS(1559),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1715] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6912),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6632),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4477),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9873),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1715),
    [sym_preproc_endregion] = STATE(1715),
    [sym_preproc_line] = STATE(1715),
    [sym_preproc_pragma] = STATE(1715),
    [sym_preproc_nullable] = STATE(1715),
    [sym_preproc_error] = STATE(1715),
    [sym_preproc_define] = STATE(1715),
    [sym_preproc_undef] = STATE(1715),
    [aux_sym_class_declaration_repeat1] = STATE(3845),
    [aux_sym_lambda_expression_repeat1] = STATE(4299),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1979),
    [anon_sym_ref] = ACTIONS(1981),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1985),
    [anon_sym_TILDE] = ACTIONS(1985),
    [anon_sym_PLUS_PLUS] = ACTIONS(1985),
    [anon_sym_DASH_DASH] = ACTIONS(1985),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1983),
    [anon_sym_DASH] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1985),
    [anon_sym_AMP] = ACTIONS(1985),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1987),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1989),
    [anon_sym_DOT_DOT] = ACTIONS(1991),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1716] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6910),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2957),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7089),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5066),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(3796),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7395),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9374),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1716),
    [sym_preproc_endregion] = STATE(1716),
    [sym_preproc_line] = STATE(1716),
    [sym_preproc_pragma] = STATE(1716),
    [sym_preproc_nullable] = STATE(1716),
    [sym_preproc_error] = STATE(1716),
    [sym_preproc_define] = STATE(1716),
    [sym_preproc_undef] = STATE(1716),
    [aux_sym_class_declaration_repeat1] = STATE(3839),
    [aux_sym_lambda_expression_repeat1] = STATE(4209),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2139),
    [anon_sym_ref] = ACTIONS(2141),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1799),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2145),
    [anon_sym_TILDE] = ACTIONS(2145),
    [anon_sym_PLUS_PLUS] = ACTIONS(2145),
    [anon_sym_DASH_DASH] = ACTIONS(2145),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2143),
    [anon_sym_DASH] = ACTIONS(2143),
    [anon_sym_STAR] = ACTIONS(1805),
    [anon_sym_CARET] = ACTIONS(2145),
    [anon_sym_AMP] = ACTIONS(2145),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2147),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2149),
    [anon_sym_DOT_DOT] = ACTIONS(2151),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1717] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6894),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2955),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7094),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6691),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(2988),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1717),
    [sym_preproc_endregion] = STATE(1717),
    [sym_preproc_line] = STATE(1717),
    [sym_preproc_pragma] = STATE(1717),
    [sym_preproc_nullable] = STATE(1717),
    [sym_preproc_error] = STATE(1717),
    [sym_preproc_define] = STATE(1717),
    [sym_preproc_undef] = STATE(1717),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2911),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1669),
    [anon_sym_TILDE] = ACTIONS(1669),
    [anon_sym_PLUS_PLUS] = ACTIONS(1669),
    [anon_sym_DASH_DASH] = ACTIONS(1669),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1667),
    [anon_sym_DASH] = ACTIONS(1667),
    [anon_sym_STAR] = ACTIONS(1859),
    [anon_sym_CARET] = ACTIONS(1669),
    [anon_sym_AMP] = ACTIONS(1669),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1718] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6879),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2935),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7096),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5614),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4288),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7379),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9175),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1718),
    [sym_preproc_endregion] = STATE(1718),
    [sym_preproc_line] = STATE(1718),
    [sym_preproc_pragma] = STATE(1718),
    [sym_preproc_nullable] = STATE(1718),
    [sym_preproc_error] = STATE(1718),
    [sym_preproc_define] = STATE(1718),
    [sym_preproc_undef] = STATE(1718),
    [aux_sym_class_declaration_repeat1] = STATE(3816),
    [aux_sym_lambda_expression_repeat1] = STATE(4119),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1867),
    [anon_sym_ref] = ACTIONS(1869),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1871),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1875),
    [anon_sym_TILDE] = ACTIONS(1875),
    [anon_sym_PLUS_PLUS] = ACTIONS(1875),
    [anon_sym_DASH_DASH] = ACTIONS(1875),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1873),
    [anon_sym_DASH] = ACTIONS(1873),
    [anon_sym_STAR] = ACTIONS(1877),
    [anon_sym_CARET] = ACTIONS(1875),
    [anon_sym_AMP] = ACTIONS(1875),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1879),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1881),
    [anon_sym_DOT_DOT] = ACTIONS(1883),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1719] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6879),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2935),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7096),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5616),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4288),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7379),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9175),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1719),
    [sym_preproc_endregion] = STATE(1719),
    [sym_preproc_line] = STATE(1719),
    [sym_preproc_pragma] = STATE(1719),
    [sym_preproc_nullable] = STATE(1719),
    [sym_preproc_error] = STATE(1719),
    [sym_preproc_define] = STATE(1719),
    [sym_preproc_undef] = STATE(1719),
    [aux_sym_class_declaration_repeat1] = STATE(3816),
    [aux_sym_lambda_expression_repeat1] = STATE(4119),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1867),
    [anon_sym_ref] = ACTIONS(1869),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1871),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1875),
    [anon_sym_TILDE] = ACTIONS(1875),
    [anon_sym_PLUS_PLUS] = ACTIONS(1875),
    [anon_sym_DASH_DASH] = ACTIONS(1875),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1873),
    [anon_sym_DASH] = ACTIONS(1873),
    [anon_sym_STAR] = ACTIONS(1877),
    [anon_sym_CARET] = ACTIONS(1875),
    [anon_sym_AMP] = ACTIONS(1875),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1879),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1881),
    [anon_sym_DOT_DOT] = ACTIONS(1883),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1720] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6904),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7009),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(3557),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4008),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7381),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9536),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1720),
    [sym_preproc_endregion] = STATE(1720),
    [sym_preproc_line] = STATE(1720),
    [sym_preproc_pragma] = STATE(1720),
    [sym_preproc_nullable] = STATE(1720),
    [sym_preproc_error] = STATE(1720),
    [sym_preproc_define] = STATE(1720),
    [sym_preproc_undef] = STATE(1720),
    [aux_sym_class_declaration_repeat1] = STATE(3832),
    [aux_sym_lambda_expression_repeat1] = STATE(4090),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1485),
    [anon_sym_ref] = ACTIONS(1487),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1221),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1491),
    [anon_sym_TILDE] = ACTIONS(1491),
    [anon_sym_PLUS_PLUS] = ACTIONS(1491),
    [anon_sym_DASH_DASH] = ACTIONS(1491),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1489),
    [anon_sym_DASH] = ACTIONS(1489),
    [anon_sym_STAR] = ACTIONS(1493),
    [anon_sym_CARET] = ACTIONS(1491),
    [anon_sym_AMP] = ACTIONS(1491),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1495),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1497),
    [anon_sym_DOT_DOT] = ACTIONS(1499),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1721] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6901),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2939),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7094),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(3014),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1721),
    [sym_preproc_endregion] = STATE(1721),
    [sym_preproc_line] = STATE(1721),
    [sym_preproc_pragma] = STATE(1721),
    [sym_preproc_nullable] = STATE(1721),
    [sym_preproc_error] = STATE(1721),
    [sym_preproc_define] = STATE(1721),
    [sym_preproc_undef] = STATE(1721),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1669),
    [anon_sym_TILDE] = ACTIONS(1669),
    [anon_sym_PLUS_PLUS] = ACTIONS(1669),
    [anon_sym_DASH_DASH] = ACTIONS(1669),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1667),
    [anon_sym_DASH] = ACTIONS(1667),
    [anon_sym_STAR] = ACTIONS(2203),
    [anon_sym_CARET] = ACTIONS(1669),
    [anon_sym_AMP] = ACTIONS(1669),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1722] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6910),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2957),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7089),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5068),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(3796),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7395),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9374),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1722),
    [sym_preproc_endregion] = STATE(1722),
    [sym_preproc_line] = STATE(1722),
    [sym_preproc_pragma] = STATE(1722),
    [sym_preproc_nullable] = STATE(1722),
    [sym_preproc_error] = STATE(1722),
    [sym_preproc_define] = STATE(1722),
    [sym_preproc_undef] = STATE(1722),
    [aux_sym_class_declaration_repeat1] = STATE(3839),
    [aux_sym_lambda_expression_repeat1] = STATE(4209),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2139),
    [anon_sym_ref] = ACTIONS(2141),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1799),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2145),
    [anon_sym_TILDE] = ACTIONS(2145),
    [anon_sym_PLUS_PLUS] = ACTIONS(2145),
    [anon_sym_DASH_DASH] = ACTIONS(2145),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2143),
    [anon_sym_DASH] = ACTIONS(2143),
    [anon_sym_STAR] = ACTIONS(1805),
    [anon_sym_CARET] = ACTIONS(2145),
    [anon_sym_AMP] = ACTIONS(2145),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2147),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2149),
    [anon_sym_DOT_DOT] = ACTIONS(2151),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1723] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6896),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2944),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6952),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5664),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4248),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7396),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9160),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1723),
    [sym_preproc_endregion] = STATE(1723),
    [sym_preproc_line] = STATE(1723),
    [sym_preproc_pragma] = STATE(1723),
    [sym_preproc_nullable] = STATE(1723),
    [sym_preproc_error] = STATE(1723),
    [sym_preproc_define] = STATE(1723),
    [sym_preproc_undef] = STATE(1723),
    [aux_sym_class_declaration_repeat1] = STATE(3795),
    [aux_sym_lambda_expression_repeat1] = STATE(4144),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1831),
    [anon_sym_ref] = ACTIONS(1833),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1835),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1839),
    [anon_sym_TILDE] = ACTIONS(1839),
    [anon_sym_PLUS_PLUS] = ACTIONS(1839),
    [anon_sym_DASH_DASH] = ACTIONS(1839),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1837),
    [anon_sym_DASH] = ACTIONS(1837),
    [anon_sym_STAR] = ACTIONS(1841),
    [anon_sym_CARET] = ACTIONS(1839),
    [anon_sym_AMP] = ACTIONS(1839),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1843),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1845),
    [anon_sym_DOT_DOT] = ACTIONS(1847),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1724] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6896),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2944),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6952),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5677),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4248),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7396),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9160),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1724),
    [sym_preproc_endregion] = STATE(1724),
    [sym_preproc_line] = STATE(1724),
    [sym_preproc_pragma] = STATE(1724),
    [sym_preproc_nullable] = STATE(1724),
    [sym_preproc_error] = STATE(1724),
    [sym_preproc_define] = STATE(1724),
    [sym_preproc_undef] = STATE(1724),
    [aux_sym_class_declaration_repeat1] = STATE(3795),
    [aux_sym_lambda_expression_repeat1] = STATE(4144),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1831),
    [anon_sym_ref] = ACTIONS(1833),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1835),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1839),
    [anon_sym_TILDE] = ACTIONS(1839),
    [anon_sym_PLUS_PLUS] = ACTIONS(1839),
    [anon_sym_DASH_DASH] = ACTIONS(1839),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1837),
    [anon_sym_DASH] = ACTIONS(1837),
    [anon_sym_STAR] = ACTIONS(1841),
    [anon_sym_CARET] = ACTIONS(1839),
    [anon_sym_AMP] = ACTIONS(1839),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1843),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1845),
    [anon_sym_DOT_DOT] = ACTIONS(1847),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1725] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6880),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7072),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4308),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4210),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9027),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1725),
    [sym_preproc_endregion] = STATE(1725),
    [sym_preproc_line] = STATE(1725),
    [sym_preproc_pragma] = STATE(1725),
    [sym_preproc_nullable] = STATE(1725),
    [sym_preproc_error] = STATE(1725),
    [sym_preproc_define] = STATE(1725),
    [sym_preproc_undef] = STATE(1725),
    [aux_sym_class_declaration_repeat1] = STATE(3852),
    [aux_sym_lambda_expression_repeat1] = STATE(4220),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1473),
    [anon_sym_ref] = ACTIONS(1475),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(1479),
    [anon_sym_PLUS_PLUS] = ACTIONS(1479),
    [anon_sym_DASH_DASH] = ACTIONS(1479),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1477),
    [anon_sym_DASH] = ACTIONS(1477),
    [anon_sym_STAR] = ACTIONS(1101),
    [anon_sym_CARET] = ACTIONS(1479),
    [anon_sym_AMP] = ACTIONS(1479),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1111),
    [anon_sym_DOT_DOT] = ACTIONS(1115),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1726] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6881),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2964),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7094),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(3014),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1726),
    [sym_preproc_endregion] = STATE(1726),
    [sym_preproc_line] = STATE(1726),
    [sym_preproc_pragma] = STATE(1726),
    [sym_preproc_nullable] = STATE(1726),
    [sym_preproc_error] = STATE(1726),
    [sym_preproc_define] = STATE(1726),
    [sym_preproc_undef] = STATE(1726),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1669),
    [anon_sym_TILDE] = ACTIONS(1669),
    [anon_sym_PLUS_PLUS] = ACTIONS(1669),
    [anon_sym_DASH_DASH] = ACTIONS(1669),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1667),
    [anon_sym_DASH] = ACTIONS(1667),
    [anon_sym_STAR] = ACTIONS(2107),
    [anon_sym_CARET] = ACTIONS(1669),
    [anon_sym_AMP] = ACTIONS(1669),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1727] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6910),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2957),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7089),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5069),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(3796),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7395),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9374),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1727),
    [sym_preproc_endregion] = STATE(1727),
    [sym_preproc_line] = STATE(1727),
    [sym_preproc_pragma] = STATE(1727),
    [sym_preproc_nullable] = STATE(1727),
    [sym_preproc_error] = STATE(1727),
    [sym_preproc_define] = STATE(1727),
    [sym_preproc_undef] = STATE(1727),
    [aux_sym_class_declaration_repeat1] = STATE(3839),
    [aux_sym_lambda_expression_repeat1] = STATE(4209),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2139),
    [anon_sym_ref] = ACTIONS(2141),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1799),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2145),
    [anon_sym_TILDE] = ACTIONS(2145),
    [anon_sym_PLUS_PLUS] = ACTIONS(2145),
    [anon_sym_DASH_DASH] = ACTIONS(2145),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2143),
    [anon_sym_DASH] = ACTIONS(2143),
    [anon_sym_STAR] = ACTIONS(1805),
    [anon_sym_CARET] = ACTIONS(2145),
    [anon_sym_AMP] = ACTIONS(2145),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2147),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2149),
    [anon_sym_DOT_DOT] = ACTIONS(2151),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1728] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6874),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2968),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6941),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5692),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4214),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7412),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9154),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1728),
    [sym_preproc_endregion] = STATE(1728),
    [sym_preproc_line] = STATE(1728),
    [sym_preproc_pragma] = STATE(1728),
    [sym_preproc_nullable] = STATE(1728),
    [sym_preproc_error] = STATE(1728),
    [sym_preproc_define] = STATE(1728),
    [sym_preproc_undef] = STATE(1728),
    [aux_sym_class_declaration_repeat1] = STATE(3798),
    [aux_sym_lambda_expression_repeat1] = STATE(4162),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1777),
    [anon_sym_ref] = ACTIONS(1779),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1781),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1785),
    [anon_sym_TILDE] = ACTIONS(1785),
    [anon_sym_PLUS_PLUS] = ACTIONS(1785),
    [anon_sym_DASH_DASH] = ACTIONS(1785),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_STAR] = ACTIONS(1787),
    [anon_sym_CARET] = ACTIONS(1785),
    [anon_sym_AMP] = ACTIONS(1785),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1789),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1791),
    [anon_sym_DOT_DOT] = ACTIONS(1793),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1729] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3559),
    [sym__name] = STATE(6877),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2908),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6958),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4666),
    [sym_non_lvalue_expression] = STATE(4553),
    [sym_lvalue_expression] = STATE(3691),
    [sym__expression_statement_expression] = STATE(4559),
    [sym_assignment_expression] = STATE(4558),
    [sym_binary_expression] = STATE(4559),
    [sym_postfix_unary_expression] = STATE(4558),
    [sym_prefix_unary_expression] = STATE(4558),
    [sym__pointer_indirection_expression] = STATE(3560),
    [sym_query_expression] = STATE(4559),
    [sym_from_clause] = STATE(7406),
    [sym_conditional_expression] = STATE(4559),
    [sym_conditional_access_expression] = STATE(4559),
    [sym_as_expression] = STATE(4559),
    [sym_is_expression] = STATE(4559),
    [sym_is_pattern_expression] = STATE(4559),
    [sym_cast_expression] = STATE(4559),
    [sym_checked_expression] = STATE(4559),
    [sym_invocation_expression] = STATE(4558),
    [sym_switch_expression] = STATE(4559),
    [sym_await_expression] = STATE(4558),
    [sym_throw_expression] = STATE(4559),
    [sym_element_access_expression] = STATE(3560),
    [sym_interpolated_string_expression] = STATE(4559),
    [sym_member_access_expression] = STATE(3560),
    [sym_object_creation_expression] = STATE(4558),
    [sym_parenthesized_expression] = STATE(4558),
    [sym__parenthesized_lvalue_expression] = STATE(3560),
    [sym_lambda_expression] = STATE(4559),
    [sym__lambda_parameters] = STATE(9348),
    [sym_array_creation_expression] = STATE(4559),
    [sym_anonymous_method_expression] = STATE(4559),
    [sym_anonymous_object_creation_expression] = STATE(4559),
    [sym_implicit_array_creation_expression] = STATE(4559),
    [sym_implicit_object_creation_expression] = STATE(4559),
    [sym_implicit_stackalloc_expression] = STATE(4559),
    [sym_initializer_expression] = STATE(4559),
    [sym_default_expression] = STATE(4559),
    [sym_with_expression] = STATE(4559),
    [sym_sizeof_expression] = STATE(4559),
    [sym_typeof_expression] = STATE(4559),
    [sym_makeref_expression] = STATE(4559),
    [sym_ref_expression] = STATE(4559),
    [sym_reftype_expression] = STATE(4559),
    [sym_refvalue_expression] = STATE(4559),
    [sym_stackalloc_expression] = STATE(4559),
    [sym_range_expression] = STATE(4559),
    [sym_tuple_expression] = STATE(3560),
    [sym_literal] = STATE(4559),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4559),
    [sym_preproc_region] = STATE(1729),
    [sym_preproc_endregion] = STATE(1729),
    [sym_preproc_line] = STATE(1729),
    [sym_preproc_pragma] = STATE(1729),
    [sym_preproc_nullable] = STATE(1729),
    [sym_preproc_error] = STATE(1729),
    [sym_preproc_define] = STATE(1729),
    [sym_preproc_undef] = STATE(1729),
    [aux_sym_class_declaration_repeat1] = STATE(3810),
    [aux_sym_lambda_expression_repeat1] = STATE(4141),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(2047),
    [anon_sym_ref] = ACTIONS(2049),
    [anon_sym_LBRACE] = ACTIONS(1611),
    [anon_sym_delegate] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1679),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(2053),
    [anon_sym_TILDE] = ACTIONS(2053),
    [anon_sym_PLUS_PLUS] = ACTIONS(2053),
    [anon_sym_DASH_DASH] = ACTIONS(2053),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(2051),
    [anon_sym_DASH] = ACTIONS(2051),
    [anon_sym_STAR] = ACTIONS(1685),
    [anon_sym_CARET] = ACTIONS(2053),
    [anon_sym_AMP] = ACTIONS(2053),
    [anon_sym_this] = ACTIONS(1627),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1629),
    [anon_sym_unchecked] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(2055),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2057),
    [anon_sym_DOT_DOT] = ACTIONS(2059),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_stackalloc] = ACTIONS(1641),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(1647),
    [anon_sym___reftype] = ACTIONS(1649),
    [anon_sym___refvalue] = ACTIONS(1651),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1659),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [1730] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6874),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2968),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6941),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5694),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4214),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7412),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9154),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1730),
    [sym_preproc_endregion] = STATE(1730),
    [sym_preproc_line] = STATE(1730),
    [sym_preproc_pragma] = STATE(1730),
    [sym_preproc_nullable] = STATE(1730),
    [sym_preproc_error] = STATE(1730),
    [sym_preproc_define] = STATE(1730),
    [sym_preproc_undef] = STATE(1730),
    [aux_sym_class_declaration_repeat1] = STATE(3798),
    [aux_sym_lambda_expression_repeat1] = STATE(4162),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1777),
    [anon_sym_ref] = ACTIONS(1779),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1781),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1785),
    [anon_sym_TILDE] = ACTIONS(1785),
    [anon_sym_PLUS_PLUS] = ACTIONS(1785),
    [anon_sym_DASH_DASH] = ACTIONS(1785),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_STAR] = ACTIONS(1787),
    [anon_sym_CARET] = ACTIONS(1785),
    [anon_sym_AMP] = ACTIONS(1785),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1789),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1791),
    [anon_sym_DOT_DOT] = ACTIONS(1793),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1731] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6894),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2955),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7046),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(3557),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(3786),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7408),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9363),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1731),
    [sym_preproc_endregion] = STATE(1731),
    [sym_preproc_line] = STATE(1731),
    [sym_preproc_pragma] = STATE(1731),
    [sym_preproc_nullable] = STATE(1731),
    [sym_preproc_error] = STATE(1731),
    [sym_preproc_define] = STATE(1731),
    [sym_preproc_undef] = STATE(1731),
    [aux_sym_class_declaration_repeat1] = STATE(3811),
    [aux_sym_lambda_expression_repeat1] = STATE(4149),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2069),
    [anon_sym_ref] = ACTIONS(2071),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1853),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(2075),
    [anon_sym_TILDE] = ACTIONS(2075),
    [anon_sym_PLUS_PLUS] = ACTIONS(2075),
    [anon_sym_DASH_DASH] = ACTIONS(2075),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2073),
    [anon_sym_DASH] = ACTIONS(2073),
    [anon_sym_STAR] = ACTIONS(1859),
    [anon_sym_CARET] = ACTIONS(2075),
    [anon_sym_AMP] = ACTIONS(2075),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2077),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2079),
    [anon_sym_DOT_DOT] = ACTIONS(2081),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1732] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6961),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6538),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9849),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1732),
    [sym_preproc_endregion] = STATE(1732),
    [sym_preproc_line] = STATE(1732),
    [sym_preproc_pragma] = STATE(1732),
    [sym_preproc_nullable] = STATE(1732),
    [sym_preproc_error] = STATE(1732),
    [sym_preproc_define] = STATE(1732),
    [sym_preproc_undef] = STATE(1732),
    [aux_sym_class_declaration_repeat1] = STATE(3841),
    [aux_sym_lambda_expression_repeat1] = STATE(4283),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1459),
    [anon_sym_ref] = ACTIONS(1461),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1465),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1467),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1469),
    [anon_sym_DOT_DOT] = ACTIONS(1471),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1733] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7076),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5875),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4314),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9775),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1733),
    [sym_preproc_endregion] = STATE(1733),
    [sym_preproc_line] = STATE(1733),
    [sym_preproc_pragma] = STATE(1733),
    [sym_preproc_nullable] = STATE(1733),
    [sym_preproc_error] = STATE(1733),
    [sym_preproc_define] = STATE(1733),
    [sym_preproc_undef] = STATE(1733),
    [aux_sym_class_declaration_repeat1] = STATE(3835),
    [aux_sym_lambda_expression_repeat1] = STATE(4236),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1535),
    [anon_sym_ref] = ACTIONS(1537),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1465),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(885),
    [anon_sym_TILDE] = ACTIONS(885),
    [anon_sym_PLUS_PLUS] = ACTIONS(885),
    [anon_sym_DASH_DASH] = ACTIONS(885),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(887),
    [anon_sym_DASH] = ACTIONS(887),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(885),
    [anon_sym_AMP] = ACTIONS(885),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1539),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1541),
    [anon_sym_DOT_DOT] = ACTIONS(1543),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1734] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3559),
    [sym__name] = STATE(6877),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2908),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7094),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6692),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(3562),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3560),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3560),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3560),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3560),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3560),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1734),
    [sym_preproc_endregion] = STATE(1734),
    [sym_preproc_line] = STATE(1734),
    [sym_preproc_pragma] = STATE(1734),
    [sym_preproc_nullable] = STATE(1734),
    [sym_preproc_error] = STATE(1734),
    [sym_preproc_define] = STATE(1734),
    [sym_preproc_undef] = STATE(1734),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(2913),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1669),
    [anon_sym_TILDE] = ACTIONS(1669),
    [anon_sym_PLUS_PLUS] = ACTIONS(1669),
    [anon_sym_DASH_DASH] = ACTIONS(1669),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1667),
    [anon_sym_DASH] = ACTIONS(1667),
    [anon_sym_STAR] = ACTIONS(1685),
    [anon_sym_CARET] = ACTIONS(1669),
    [anon_sym_AMP] = ACTIONS(1669),
    [anon_sym_this] = ACTIONS(1627),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1629),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1735] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6913),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7000),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5553),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4181),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7384),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9143),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1735),
    [sym_preproc_endregion] = STATE(1735),
    [sym_preproc_line] = STATE(1735),
    [sym_preproc_pragma] = STATE(1735),
    [sym_preproc_nullable] = STATE(1735),
    [sym_preproc_error] = STATE(1735),
    [sym_preproc_define] = STATE(1735),
    [sym_preproc_undef] = STATE(1735),
    [aux_sym_class_declaration_repeat1] = STATE(3814),
    [aux_sym_lambda_expression_repeat1] = STATE(4171),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1561),
    [anon_sym_ref] = ACTIONS(1563),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1145),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(1567),
    [anon_sym_PLUS_PLUS] = ACTIONS(1567),
    [anon_sym_DASH_DASH] = ACTIONS(1567),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1565),
    [anon_sym_DASH] = ACTIONS(1565),
    [anon_sym_STAR] = ACTIONS(1569),
    [anon_sym_CARET] = ACTIONS(1567),
    [anon_sym_AMP] = ACTIONS(1567),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1571),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1573),
    [anon_sym_DOT_DOT] = ACTIONS(1575),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1736] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6910),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2957),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7089),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5097),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(3796),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7395),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9374),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1736),
    [sym_preproc_endregion] = STATE(1736),
    [sym_preproc_line] = STATE(1736),
    [sym_preproc_pragma] = STATE(1736),
    [sym_preproc_nullable] = STATE(1736),
    [sym_preproc_error] = STATE(1736),
    [sym_preproc_define] = STATE(1736),
    [sym_preproc_undef] = STATE(1736),
    [aux_sym_class_declaration_repeat1] = STATE(3839),
    [aux_sym_lambda_expression_repeat1] = STATE(4209),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2139),
    [anon_sym_ref] = ACTIONS(2141),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1799),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2145),
    [anon_sym_TILDE] = ACTIONS(2145),
    [anon_sym_PLUS_PLUS] = ACTIONS(2145),
    [anon_sym_DASH_DASH] = ACTIONS(2145),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2143),
    [anon_sym_DASH] = ACTIONS(2143),
    [anon_sym_STAR] = ACTIONS(1805),
    [anon_sym_CARET] = ACTIONS(2145),
    [anon_sym_AMP] = ACTIONS(2145),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2147),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2149),
    [anon_sym_DOT_DOT] = ACTIONS(2151),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1737] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6913),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7000),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5542),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4181),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7384),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9143),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1737),
    [sym_preproc_endregion] = STATE(1737),
    [sym_preproc_line] = STATE(1737),
    [sym_preproc_pragma] = STATE(1737),
    [sym_preproc_nullable] = STATE(1737),
    [sym_preproc_error] = STATE(1737),
    [sym_preproc_define] = STATE(1737),
    [sym_preproc_undef] = STATE(1737),
    [aux_sym_class_declaration_repeat1] = STATE(3814),
    [aux_sym_lambda_expression_repeat1] = STATE(4171),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1561),
    [anon_sym_ref] = ACTIONS(1563),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1145),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(1567),
    [anon_sym_PLUS_PLUS] = ACTIONS(1567),
    [anon_sym_DASH_DASH] = ACTIONS(1567),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1565),
    [anon_sym_DASH] = ACTIONS(1565),
    [anon_sym_STAR] = ACTIONS(1569),
    [anon_sym_CARET] = ACTIONS(1567),
    [anon_sym_AMP] = ACTIONS(1567),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1571),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1573),
    [anon_sym_DOT_DOT] = ACTIONS(1575),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1738] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6901),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2939),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7050),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4308),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4507),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7378),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9063),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1738),
    [sym_preproc_endregion] = STATE(1738),
    [sym_preproc_line] = STATE(1738),
    [sym_preproc_pragma] = STATE(1738),
    [sym_preproc_nullable] = STATE(1738),
    [sym_preproc_error] = STATE(1738),
    [sym_preproc_define] = STATE(1738),
    [sym_preproc_undef] = STATE(1738),
    [aux_sym_class_declaration_repeat1] = STATE(3854),
    [aux_sym_lambda_expression_repeat1] = STATE(4229),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2193),
    [anon_sym_ref] = ACTIONS(2195),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2197),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2201),
    [anon_sym_TILDE] = ACTIONS(2201),
    [anon_sym_PLUS_PLUS] = ACTIONS(2201),
    [anon_sym_DASH_DASH] = ACTIONS(2201),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2199),
    [anon_sym_DASH] = ACTIONS(2199),
    [anon_sym_STAR] = ACTIONS(2203),
    [anon_sym_CARET] = ACTIONS(2201),
    [anon_sym_AMP] = ACTIONS(2201),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2205),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2207),
    [anon_sym_DOT_DOT] = ACTIONS(2209),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1739] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6910),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2957),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7089),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5098),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(3796),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7395),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9374),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1739),
    [sym_preproc_endregion] = STATE(1739),
    [sym_preproc_line] = STATE(1739),
    [sym_preproc_pragma] = STATE(1739),
    [sym_preproc_nullable] = STATE(1739),
    [sym_preproc_error] = STATE(1739),
    [sym_preproc_define] = STATE(1739),
    [sym_preproc_undef] = STATE(1739),
    [aux_sym_class_declaration_repeat1] = STATE(3839),
    [aux_sym_lambda_expression_repeat1] = STATE(4209),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2139),
    [anon_sym_ref] = ACTIONS(2141),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1799),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2145),
    [anon_sym_TILDE] = ACTIONS(2145),
    [anon_sym_PLUS_PLUS] = ACTIONS(2145),
    [anon_sym_DASH_DASH] = ACTIONS(2145),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2143),
    [anon_sym_DASH] = ACTIONS(2143),
    [anon_sym_STAR] = ACTIONS(1805),
    [anon_sym_CARET] = ACTIONS(2145),
    [anon_sym_AMP] = ACTIONS(2145),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2147),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2149),
    [anon_sym_DOT_DOT] = ACTIONS(2151),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1740] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6887),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2935),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7094),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6691),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(2988),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1740),
    [sym_preproc_endregion] = STATE(1740),
    [sym_preproc_line] = STATE(1740),
    [sym_preproc_pragma] = STATE(1740),
    [sym_preproc_nullable] = STATE(1740),
    [sym_preproc_error] = STATE(1740),
    [sym_preproc_define] = STATE(1740),
    [sym_preproc_undef] = STATE(1740),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2911),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1669),
    [anon_sym_TILDE] = ACTIONS(1669),
    [anon_sym_PLUS_PLUS] = ACTIONS(1669),
    [anon_sym_DASH_DASH] = ACTIONS(1669),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1667),
    [anon_sym_DASH] = ACTIONS(1667),
    [anon_sym_STAR] = ACTIONS(2125),
    [anon_sym_CARET] = ACTIONS(1669),
    [anon_sym_AMP] = ACTIONS(1669),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1741] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6881),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2964),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6972),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4308),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4495),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7398),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9102),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1741),
    [sym_preproc_endregion] = STATE(1741),
    [sym_preproc_line] = STATE(1741),
    [sym_preproc_pragma] = STATE(1741),
    [sym_preproc_nullable] = STATE(1741),
    [sym_preproc_error] = STATE(1741),
    [sym_preproc_define] = STATE(1741),
    [sym_preproc_undef] = STATE(1741),
    [aux_sym_class_declaration_repeat1] = STATE(3857),
    [aux_sym_lambda_expression_repeat1] = STATE(4241),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2097),
    [anon_sym_ref] = ACTIONS(2099),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2101),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2105),
    [anon_sym_TILDE] = ACTIONS(2105),
    [anon_sym_PLUS_PLUS] = ACTIONS(2105),
    [anon_sym_DASH_DASH] = ACTIONS(2105),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2103),
    [anon_sym_DASH] = ACTIONS(2103),
    [anon_sym_STAR] = ACTIONS(2107),
    [anon_sym_CARET] = ACTIONS(2105),
    [anon_sym_AMP] = ACTIONS(2105),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2109),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2111),
    [anon_sym_DOT_DOT] = ACTIONS(2113),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1742] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6910),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2957),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7089),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5086),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(3796),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7395),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9374),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1742),
    [sym_preproc_endregion] = STATE(1742),
    [sym_preproc_line] = STATE(1742),
    [sym_preproc_pragma] = STATE(1742),
    [sym_preproc_nullable] = STATE(1742),
    [sym_preproc_error] = STATE(1742),
    [sym_preproc_define] = STATE(1742),
    [sym_preproc_undef] = STATE(1742),
    [aux_sym_class_declaration_repeat1] = STATE(3839),
    [aux_sym_lambda_expression_repeat1] = STATE(4209),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2139),
    [anon_sym_ref] = ACTIONS(2141),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1799),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2145),
    [anon_sym_TILDE] = ACTIONS(2145),
    [anon_sym_PLUS_PLUS] = ACTIONS(2145),
    [anon_sym_DASH_DASH] = ACTIONS(2145),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2143),
    [anon_sym_DASH] = ACTIONS(2143),
    [anon_sym_STAR] = ACTIONS(1805),
    [anon_sym_CARET] = ACTIONS(2145),
    [anon_sym_AMP] = ACTIONS(2145),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2147),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2149),
    [anon_sym_DOT_DOT] = ACTIONS(2151),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1743] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6909),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2874),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7062),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5612),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4291),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7411),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9300),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1743),
    [sym_preproc_endregion] = STATE(1743),
    [sym_preproc_line] = STATE(1743),
    [sym_preproc_pragma] = STATE(1743),
    [sym_preproc_nullable] = STATE(1743),
    [sym_preproc_error] = STATE(1743),
    [sym_preproc_define] = STATE(1743),
    [sym_preproc_undef] = STATE(1743),
    [aux_sym_class_declaration_repeat1] = STATE(3804),
    [aux_sym_lambda_expression_repeat1] = STATE(4114),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1501),
    [anon_sym_ref] = ACTIONS(1503),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1505),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1509),
    [anon_sym_PLUS_PLUS] = ACTIONS(1509),
    [anon_sym_DASH_DASH] = ACTIONS(1509),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1507),
    [anon_sym_DASH] = ACTIONS(1507),
    [anon_sym_STAR] = ACTIONS(1511),
    [anon_sym_CARET] = ACTIONS(1509),
    [anon_sym_AMP] = ACTIONS(1509),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1513),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1515),
    [anon_sym_DOT_DOT] = ACTIONS(1517),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1744] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6909),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2874),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7094),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6687),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(3455),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1744),
    [sym_preproc_endregion] = STATE(1744),
    [sym_preproc_line] = STATE(1744),
    [sym_preproc_pragma] = STATE(1744),
    [sym_preproc_nullable] = STATE(1744),
    [sym_preproc_error] = STATE(1744),
    [sym_preproc_define] = STATE(1744),
    [sym_preproc_undef] = STATE(1744),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(2909),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1669),
    [anon_sym_TILDE] = ACTIONS(1669),
    [anon_sym_PLUS_PLUS] = ACTIONS(1669),
    [anon_sym_DASH_DASH] = ACTIONS(1669),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1667),
    [anon_sym_DASH] = ACTIONS(1667),
    [anon_sym_STAR] = ACTIONS(1511),
    [anon_sym_CARET] = ACTIONS(1669),
    [anon_sym_AMP] = ACTIONS(1669),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1745] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3559),
    [sym__name] = STATE(6877),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2908),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6958),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4345),
    [sym_non_lvalue_expression] = STATE(4553),
    [sym_lvalue_expression] = STATE(3691),
    [sym__expression_statement_expression] = STATE(4559),
    [sym_assignment_expression] = STATE(4558),
    [sym_binary_expression] = STATE(4559),
    [sym_postfix_unary_expression] = STATE(4558),
    [sym_prefix_unary_expression] = STATE(4558),
    [sym__pointer_indirection_expression] = STATE(3560),
    [sym_query_expression] = STATE(4559),
    [sym_from_clause] = STATE(7406),
    [sym_conditional_expression] = STATE(4559),
    [sym_conditional_access_expression] = STATE(4559),
    [sym_as_expression] = STATE(4559),
    [sym_is_expression] = STATE(4559),
    [sym_is_pattern_expression] = STATE(4559),
    [sym_cast_expression] = STATE(4559),
    [sym_checked_expression] = STATE(4559),
    [sym_invocation_expression] = STATE(4558),
    [sym_switch_expression] = STATE(4559),
    [sym_await_expression] = STATE(4558),
    [sym_throw_expression] = STATE(4559),
    [sym_element_access_expression] = STATE(3560),
    [sym_interpolated_string_expression] = STATE(4559),
    [sym_member_access_expression] = STATE(3560),
    [sym_object_creation_expression] = STATE(4558),
    [sym_parenthesized_expression] = STATE(4558),
    [sym__parenthesized_lvalue_expression] = STATE(3560),
    [sym_lambda_expression] = STATE(4559),
    [sym__lambda_parameters] = STATE(9348),
    [sym_array_creation_expression] = STATE(4559),
    [sym_anonymous_method_expression] = STATE(4559),
    [sym_anonymous_object_creation_expression] = STATE(4559),
    [sym_implicit_array_creation_expression] = STATE(4559),
    [sym_implicit_object_creation_expression] = STATE(4559),
    [sym_implicit_stackalloc_expression] = STATE(4559),
    [sym_initializer_expression] = STATE(4559),
    [sym_default_expression] = STATE(4559),
    [sym_with_expression] = STATE(4559),
    [sym_sizeof_expression] = STATE(4559),
    [sym_typeof_expression] = STATE(4559),
    [sym_makeref_expression] = STATE(4559),
    [sym_ref_expression] = STATE(4559),
    [sym_reftype_expression] = STATE(4559),
    [sym_refvalue_expression] = STATE(4559),
    [sym_stackalloc_expression] = STATE(4559),
    [sym_range_expression] = STATE(4559),
    [sym_tuple_expression] = STATE(3560),
    [sym_literal] = STATE(4559),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4559),
    [sym_preproc_region] = STATE(1745),
    [sym_preproc_endregion] = STATE(1745),
    [sym_preproc_line] = STATE(1745),
    [sym_preproc_pragma] = STATE(1745),
    [sym_preproc_nullable] = STATE(1745),
    [sym_preproc_error] = STATE(1745),
    [sym_preproc_define] = STATE(1745),
    [sym_preproc_undef] = STATE(1745),
    [aux_sym_class_declaration_repeat1] = STATE(3810),
    [aux_sym_lambda_expression_repeat1] = STATE(4141),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(2047),
    [anon_sym_ref] = ACTIONS(2049),
    [anon_sym_LBRACE] = ACTIONS(1611),
    [anon_sym_delegate] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1679),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(2053),
    [anon_sym_TILDE] = ACTIONS(2053),
    [anon_sym_PLUS_PLUS] = ACTIONS(2053),
    [anon_sym_DASH_DASH] = ACTIONS(2053),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(2051),
    [anon_sym_DASH] = ACTIONS(2051),
    [anon_sym_STAR] = ACTIONS(1685),
    [anon_sym_CARET] = ACTIONS(2053),
    [anon_sym_AMP] = ACTIONS(2053),
    [anon_sym_this] = ACTIONS(1627),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1629),
    [anon_sym_unchecked] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(2055),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2057),
    [anon_sym_DOT_DOT] = ACTIONS(2059),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_stackalloc] = ACTIONS(1641),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(1647),
    [anon_sym___reftype] = ACTIONS(1649),
    [anon_sym___refvalue] = ACTIONS(1651),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1659),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [1746] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6880),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7094),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6687),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(3455),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1746),
    [sym_preproc_endregion] = STATE(1746),
    [sym_preproc_line] = STATE(1746),
    [sym_preproc_pragma] = STATE(1746),
    [sym_preproc_nullable] = STATE(1746),
    [sym_preproc_error] = STATE(1746),
    [sym_preproc_define] = STATE(1746),
    [sym_preproc_undef] = STATE(1746),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(2909),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1669),
    [anon_sym_TILDE] = ACTIONS(1669),
    [anon_sym_PLUS_PLUS] = ACTIONS(1669),
    [anon_sym_DASH_DASH] = ACTIONS(1669),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1667),
    [anon_sym_DASH] = ACTIONS(1667),
    [anon_sym_STAR] = ACTIONS(1553),
    [anon_sym_CARET] = ACTIONS(1669),
    [anon_sym_AMP] = ACTIONS(1669),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1747] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6898),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2940),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6936),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(3902),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4318),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7401),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9262),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1747),
    [sym_preproc_endregion] = STATE(1747),
    [sym_preproc_line] = STATE(1747),
    [sym_preproc_pragma] = STATE(1747),
    [sym_preproc_nullable] = STATE(1747),
    [sym_preproc_error] = STATE(1747),
    [sym_preproc_define] = STATE(1747),
    [sym_preproc_undef] = STATE(1747),
    [aux_sym_class_declaration_repeat1] = STATE(3815),
    [aux_sym_lambda_expression_repeat1] = STATE(4072),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1885),
    [anon_sym_ref] = ACTIONS(1887),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1889),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1893),
    [anon_sym_TILDE] = ACTIONS(1893),
    [anon_sym_PLUS_PLUS] = ACTIONS(1893),
    [anon_sym_DASH_DASH] = ACTIONS(1893),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1891),
    [anon_sym_DASH] = ACTIONS(1891),
    [anon_sym_STAR] = ACTIONS(1895),
    [anon_sym_CARET] = ACTIONS(1893),
    [anon_sym_AMP] = ACTIONS(1893),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1897),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1899),
    [anon_sym_DOT_DOT] = ACTIONS(1901),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1748] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7094),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(3014),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1748),
    [sym_preproc_endregion] = STATE(1748),
    [sym_preproc_line] = STATE(1748),
    [sym_preproc_pragma] = STATE(1748),
    [sym_preproc_nullable] = STATE(1748),
    [sym_preproc_error] = STATE(1748),
    [sym_preproc_define] = STATE(1748),
    [sym_preproc_undef] = STATE(1748),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1669),
    [anon_sym_TILDE] = ACTIONS(1669),
    [anon_sym_PLUS_PLUS] = ACTIONS(1669),
    [anon_sym_DASH_DASH] = ACTIONS(1669),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1667),
    [anon_sym_DASH] = ACTIONS(1667),
    [anon_sym_STAR] = ACTIONS(2039),
    [anon_sym_CARET] = ACTIONS(1669),
    [anon_sym_AMP] = ACTIONS(1669),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1749] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6910),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2957),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7089),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5065),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(3796),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7395),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9374),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1749),
    [sym_preproc_endregion] = STATE(1749),
    [sym_preproc_line] = STATE(1749),
    [sym_preproc_pragma] = STATE(1749),
    [sym_preproc_nullable] = STATE(1749),
    [sym_preproc_error] = STATE(1749),
    [sym_preproc_define] = STATE(1749),
    [sym_preproc_undef] = STATE(1749),
    [aux_sym_class_declaration_repeat1] = STATE(3839),
    [aux_sym_lambda_expression_repeat1] = STATE(4209),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2139),
    [anon_sym_ref] = ACTIONS(2141),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1799),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2145),
    [anon_sym_TILDE] = ACTIONS(2145),
    [anon_sym_PLUS_PLUS] = ACTIONS(2145),
    [anon_sym_DASH_DASH] = ACTIONS(2145),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2143),
    [anon_sym_DASH] = ACTIONS(2143),
    [anon_sym_STAR] = ACTIONS(1805),
    [anon_sym_CARET] = ACTIONS(2145),
    [anon_sym_AMP] = ACTIONS(2145),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2147),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2149),
    [anon_sym_DOT_DOT] = ACTIONS(2151),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1750] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6910),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2957),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7089),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5075),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(3796),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7395),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9374),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1750),
    [sym_preproc_endregion] = STATE(1750),
    [sym_preproc_line] = STATE(1750),
    [sym_preproc_pragma] = STATE(1750),
    [sym_preproc_nullable] = STATE(1750),
    [sym_preproc_error] = STATE(1750),
    [sym_preproc_define] = STATE(1750),
    [sym_preproc_undef] = STATE(1750),
    [aux_sym_class_declaration_repeat1] = STATE(3839),
    [aux_sym_lambda_expression_repeat1] = STATE(4209),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2139),
    [anon_sym_ref] = ACTIONS(2141),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1799),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2145),
    [anon_sym_TILDE] = ACTIONS(2145),
    [anon_sym_PLUS_PLUS] = ACTIONS(2145),
    [anon_sym_DASH_DASH] = ACTIONS(2145),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2143),
    [anon_sym_DASH] = ACTIONS(2143),
    [anon_sym_STAR] = ACTIONS(1805),
    [anon_sym_CARET] = ACTIONS(2145),
    [anon_sym_AMP] = ACTIONS(2145),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2147),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2149),
    [anon_sym_DOT_DOT] = ACTIONS(2151),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1751] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7076),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4309),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4314),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9775),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1751),
    [sym_preproc_endregion] = STATE(1751),
    [sym_preproc_line] = STATE(1751),
    [sym_preproc_pragma] = STATE(1751),
    [sym_preproc_nullable] = STATE(1751),
    [sym_preproc_error] = STATE(1751),
    [sym_preproc_define] = STATE(1751),
    [sym_preproc_undef] = STATE(1751),
    [aux_sym_class_declaration_repeat1] = STATE(3835),
    [aux_sym_lambda_expression_repeat1] = STATE(4236),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1535),
    [anon_sym_ref] = ACTIONS(1537),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1465),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(885),
    [anon_sym_TILDE] = ACTIONS(885),
    [anon_sym_PLUS_PLUS] = ACTIONS(885),
    [anon_sym_DASH_DASH] = ACTIONS(885),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(887),
    [anon_sym_DASH] = ACTIONS(887),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(885),
    [anon_sym_AMP] = ACTIONS(885),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1539),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1541),
    [anon_sym_DOT_DOT] = ACTIONS(1543),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1752] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6910),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2957),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7089),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5079),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(3796),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7395),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9374),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1752),
    [sym_preproc_endregion] = STATE(1752),
    [sym_preproc_line] = STATE(1752),
    [sym_preproc_pragma] = STATE(1752),
    [sym_preproc_nullable] = STATE(1752),
    [sym_preproc_error] = STATE(1752),
    [sym_preproc_define] = STATE(1752),
    [sym_preproc_undef] = STATE(1752),
    [aux_sym_class_declaration_repeat1] = STATE(3839),
    [aux_sym_lambda_expression_repeat1] = STATE(4209),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2139),
    [anon_sym_ref] = ACTIONS(2141),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1799),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2145),
    [anon_sym_TILDE] = ACTIONS(2145),
    [anon_sym_PLUS_PLUS] = ACTIONS(2145),
    [anon_sym_DASH_DASH] = ACTIONS(2145),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2143),
    [anon_sym_DASH] = ACTIONS(2143),
    [anon_sym_STAR] = ACTIONS(1805),
    [anon_sym_CARET] = ACTIONS(2145),
    [anon_sym_AMP] = ACTIONS(2145),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2147),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2149),
    [anon_sym_DOT_DOT] = ACTIONS(2151),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1753] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3559),
    [sym__name] = STATE(6877),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2908),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6958),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4640),
    [sym_non_lvalue_expression] = STATE(4553),
    [sym_lvalue_expression] = STATE(3691),
    [sym__expression_statement_expression] = STATE(4559),
    [sym_assignment_expression] = STATE(4558),
    [sym_binary_expression] = STATE(4559),
    [sym_postfix_unary_expression] = STATE(4558),
    [sym_prefix_unary_expression] = STATE(4558),
    [sym__pointer_indirection_expression] = STATE(3560),
    [sym_query_expression] = STATE(4559),
    [sym_from_clause] = STATE(7406),
    [sym_conditional_expression] = STATE(4559),
    [sym_conditional_access_expression] = STATE(4559),
    [sym_as_expression] = STATE(4559),
    [sym_is_expression] = STATE(4559),
    [sym_is_pattern_expression] = STATE(4559),
    [sym_cast_expression] = STATE(4559),
    [sym_checked_expression] = STATE(4559),
    [sym_invocation_expression] = STATE(4558),
    [sym_switch_expression] = STATE(4559),
    [sym_await_expression] = STATE(4558),
    [sym_throw_expression] = STATE(4559),
    [sym_element_access_expression] = STATE(3560),
    [sym_interpolated_string_expression] = STATE(4559),
    [sym_member_access_expression] = STATE(3560),
    [sym_object_creation_expression] = STATE(4558),
    [sym_parenthesized_expression] = STATE(4558),
    [sym__parenthesized_lvalue_expression] = STATE(3560),
    [sym_lambda_expression] = STATE(4559),
    [sym__lambda_parameters] = STATE(9348),
    [sym_array_creation_expression] = STATE(4559),
    [sym_anonymous_method_expression] = STATE(4559),
    [sym_anonymous_object_creation_expression] = STATE(4559),
    [sym_implicit_array_creation_expression] = STATE(4559),
    [sym_implicit_object_creation_expression] = STATE(4559),
    [sym_implicit_stackalloc_expression] = STATE(4559),
    [sym_initializer_expression] = STATE(4559),
    [sym_default_expression] = STATE(4559),
    [sym_with_expression] = STATE(4559),
    [sym_sizeof_expression] = STATE(4559),
    [sym_typeof_expression] = STATE(4559),
    [sym_makeref_expression] = STATE(4559),
    [sym_ref_expression] = STATE(4559),
    [sym_reftype_expression] = STATE(4559),
    [sym_refvalue_expression] = STATE(4559),
    [sym_stackalloc_expression] = STATE(4559),
    [sym_range_expression] = STATE(4559),
    [sym_tuple_expression] = STATE(3560),
    [sym_literal] = STATE(4559),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4559),
    [sym_preproc_region] = STATE(1753),
    [sym_preproc_endregion] = STATE(1753),
    [sym_preproc_line] = STATE(1753),
    [sym_preproc_pragma] = STATE(1753),
    [sym_preproc_nullable] = STATE(1753),
    [sym_preproc_error] = STATE(1753),
    [sym_preproc_define] = STATE(1753),
    [sym_preproc_undef] = STATE(1753),
    [aux_sym_class_declaration_repeat1] = STATE(3810),
    [aux_sym_lambda_expression_repeat1] = STATE(4141),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(2047),
    [anon_sym_ref] = ACTIONS(2049),
    [anon_sym_LBRACE] = ACTIONS(1611),
    [anon_sym_delegate] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1679),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(2053),
    [anon_sym_TILDE] = ACTIONS(2053),
    [anon_sym_PLUS_PLUS] = ACTIONS(2053),
    [anon_sym_DASH_DASH] = ACTIONS(2053),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(2051),
    [anon_sym_DASH] = ACTIONS(2051),
    [anon_sym_STAR] = ACTIONS(1685),
    [anon_sym_CARET] = ACTIONS(2053),
    [anon_sym_AMP] = ACTIONS(2053),
    [anon_sym_this] = ACTIONS(1627),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1629),
    [anon_sym_unchecked] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(2055),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2057),
    [anon_sym_DOT_DOT] = ACTIONS(2059),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_stackalloc] = ACTIONS(1641),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(1647),
    [anon_sym___reftype] = ACTIONS(1649),
    [anon_sym___refvalue] = ACTIONS(1651),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1659),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [1754] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7076),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5979),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4314),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9775),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1754),
    [sym_preproc_endregion] = STATE(1754),
    [sym_preproc_line] = STATE(1754),
    [sym_preproc_pragma] = STATE(1754),
    [sym_preproc_nullable] = STATE(1754),
    [sym_preproc_error] = STATE(1754),
    [sym_preproc_define] = STATE(1754),
    [sym_preproc_undef] = STATE(1754),
    [aux_sym_class_declaration_repeat1] = STATE(3835),
    [aux_sym_lambda_expression_repeat1] = STATE(4236),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1535),
    [anon_sym_ref] = ACTIONS(1537),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1465),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(885),
    [anon_sym_TILDE] = ACTIONS(885),
    [anon_sym_PLUS_PLUS] = ACTIONS(885),
    [anon_sym_DASH_DASH] = ACTIONS(885),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(887),
    [anon_sym_DASH] = ACTIONS(887),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(885),
    [anon_sym_AMP] = ACTIONS(885),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1539),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1541),
    [anon_sym_DOT_DOT] = ACTIONS(1543),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1755] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6910),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2957),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7089),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5087),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(3796),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7395),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9374),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1755),
    [sym_preproc_endregion] = STATE(1755),
    [sym_preproc_line] = STATE(1755),
    [sym_preproc_pragma] = STATE(1755),
    [sym_preproc_nullable] = STATE(1755),
    [sym_preproc_error] = STATE(1755),
    [sym_preproc_define] = STATE(1755),
    [sym_preproc_undef] = STATE(1755),
    [aux_sym_class_declaration_repeat1] = STATE(3839),
    [aux_sym_lambda_expression_repeat1] = STATE(4209),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2139),
    [anon_sym_ref] = ACTIONS(2141),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1799),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2145),
    [anon_sym_TILDE] = ACTIONS(2145),
    [anon_sym_PLUS_PLUS] = ACTIONS(2145),
    [anon_sym_DASH_DASH] = ACTIONS(2145),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2143),
    [anon_sym_DASH] = ACTIONS(2143),
    [anon_sym_STAR] = ACTIONS(1805),
    [anon_sym_CARET] = ACTIONS(2145),
    [anon_sym_AMP] = ACTIONS(2145),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2147),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2149),
    [anon_sym_DOT_DOT] = ACTIONS(2151),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1756] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7076),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5800),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4314),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9775),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1756),
    [sym_preproc_endregion] = STATE(1756),
    [sym_preproc_line] = STATE(1756),
    [sym_preproc_pragma] = STATE(1756),
    [sym_preproc_nullable] = STATE(1756),
    [sym_preproc_error] = STATE(1756),
    [sym_preproc_define] = STATE(1756),
    [sym_preproc_undef] = STATE(1756),
    [aux_sym_class_declaration_repeat1] = STATE(3835),
    [aux_sym_lambda_expression_repeat1] = STATE(4236),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1535),
    [anon_sym_ref] = ACTIONS(1537),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1465),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(885),
    [anon_sym_TILDE] = ACTIONS(885),
    [anon_sym_PLUS_PLUS] = ACTIONS(885),
    [anon_sym_DASH_DASH] = ACTIONS(885),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(887),
    [anon_sym_DASH] = ACTIONS(887),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(885),
    [anon_sym_AMP] = ACTIONS(885),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1539),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1541),
    [anon_sym_DOT_DOT] = ACTIONS(1543),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1757] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7076),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5799),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4314),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9775),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1757),
    [sym_preproc_endregion] = STATE(1757),
    [sym_preproc_line] = STATE(1757),
    [sym_preproc_pragma] = STATE(1757),
    [sym_preproc_nullable] = STATE(1757),
    [sym_preproc_error] = STATE(1757),
    [sym_preproc_define] = STATE(1757),
    [sym_preproc_undef] = STATE(1757),
    [aux_sym_class_declaration_repeat1] = STATE(3835),
    [aux_sym_lambda_expression_repeat1] = STATE(4236),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1535),
    [anon_sym_ref] = ACTIONS(1537),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1465),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(885),
    [anon_sym_TILDE] = ACTIONS(885),
    [anon_sym_PLUS_PLUS] = ACTIONS(885),
    [anon_sym_DASH_DASH] = ACTIONS(885),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(887),
    [anon_sym_DASH] = ACTIONS(887),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(885),
    [anon_sym_AMP] = ACTIONS(885),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1539),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1541),
    [anon_sym_DOT_DOT] = ACTIONS(1543),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1758] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6910),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2957),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7089),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5094),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(3796),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7395),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9374),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1758),
    [sym_preproc_endregion] = STATE(1758),
    [sym_preproc_line] = STATE(1758),
    [sym_preproc_pragma] = STATE(1758),
    [sym_preproc_nullable] = STATE(1758),
    [sym_preproc_error] = STATE(1758),
    [sym_preproc_define] = STATE(1758),
    [sym_preproc_undef] = STATE(1758),
    [aux_sym_class_declaration_repeat1] = STATE(3839),
    [aux_sym_lambda_expression_repeat1] = STATE(4209),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2139),
    [anon_sym_ref] = ACTIONS(2141),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1799),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2145),
    [anon_sym_TILDE] = ACTIONS(2145),
    [anon_sym_PLUS_PLUS] = ACTIONS(2145),
    [anon_sym_DASH_DASH] = ACTIONS(2145),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2143),
    [anon_sym_DASH] = ACTIONS(2143),
    [anon_sym_STAR] = ACTIONS(1805),
    [anon_sym_CARET] = ACTIONS(2145),
    [anon_sym_AMP] = ACTIONS(2145),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2147),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2149),
    [anon_sym_DOT_DOT] = ACTIONS(2151),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1759] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7076),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5798),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4314),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9775),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1759),
    [sym_preproc_endregion] = STATE(1759),
    [sym_preproc_line] = STATE(1759),
    [sym_preproc_pragma] = STATE(1759),
    [sym_preproc_nullable] = STATE(1759),
    [sym_preproc_error] = STATE(1759),
    [sym_preproc_define] = STATE(1759),
    [sym_preproc_undef] = STATE(1759),
    [aux_sym_class_declaration_repeat1] = STATE(3835),
    [aux_sym_lambda_expression_repeat1] = STATE(4236),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1535),
    [anon_sym_ref] = ACTIONS(1537),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1465),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(885),
    [anon_sym_TILDE] = ACTIONS(885),
    [anon_sym_PLUS_PLUS] = ACTIONS(885),
    [anon_sym_DASH_DASH] = ACTIONS(885),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(887),
    [anon_sym_DASH] = ACTIONS(887),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(885),
    [anon_sym_AMP] = ACTIONS(885),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1539),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1541),
    [anon_sym_DOT_DOT] = ACTIONS(1543),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1760] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6887),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2935),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6959),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(3557),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4399),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7410),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9332),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1760),
    [sym_preproc_endregion] = STATE(1760),
    [sym_preproc_line] = STATE(1760),
    [sym_preproc_pragma] = STATE(1760),
    [sym_preproc_nullable] = STATE(1760),
    [sym_preproc_error] = STATE(1760),
    [sym_preproc_define] = STATE(1760),
    [sym_preproc_undef] = STATE(1760),
    [aux_sym_class_declaration_repeat1] = STATE(3807),
    [aux_sym_lambda_expression_repeat1] = STATE(4128),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2115),
    [anon_sym_ref] = ACTIONS(2117),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2119),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(2123),
    [anon_sym_TILDE] = ACTIONS(2123),
    [anon_sym_PLUS_PLUS] = ACTIONS(2123),
    [anon_sym_DASH_DASH] = ACTIONS(2123),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2121),
    [anon_sym_DASH] = ACTIONS(2121),
    [anon_sym_STAR] = ACTIONS(2125),
    [anon_sym_CARET] = ACTIONS(2123),
    [anon_sym_AMP] = ACTIONS(2123),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2127),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2129),
    [anon_sym_DOT_DOT] = ACTIONS(2131),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1761] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7076),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5795),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4314),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9775),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1761),
    [sym_preproc_endregion] = STATE(1761),
    [sym_preproc_line] = STATE(1761),
    [sym_preproc_pragma] = STATE(1761),
    [sym_preproc_nullable] = STATE(1761),
    [sym_preproc_error] = STATE(1761),
    [sym_preproc_define] = STATE(1761),
    [sym_preproc_undef] = STATE(1761),
    [aux_sym_class_declaration_repeat1] = STATE(3835),
    [aux_sym_lambda_expression_repeat1] = STATE(4236),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1535),
    [anon_sym_ref] = ACTIONS(1537),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1465),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(885),
    [anon_sym_TILDE] = ACTIONS(885),
    [anon_sym_PLUS_PLUS] = ACTIONS(885),
    [anon_sym_DASH_DASH] = ACTIONS(885),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(887),
    [anon_sym_DASH] = ACTIONS(887),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(885),
    [anon_sym_AMP] = ACTIONS(885),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1539),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1541),
    [anon_sym_DOT_DOT] = ACTIONS(1543),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1762] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6961),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6531),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9849),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1762),
    [sym_preproc_endregion] = STATE(1762),
    [sym_preproc_line] = STATE(1762),
    [sym_preproc_pragma] = STATE(1762),
    [sym_preproc_nullable] = STATE(1762),
    [sym_preproc_error] = STATE(1762),
    [sym_preproc_define] = STATE(1762),
    [sym_preproc_undef] = STATE(1762),
    [aux_sym_class_declaration_repeat1] = STATE(3841),
    [aux_sym_lambda_expression_repeat1] = STATE(4283),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1459),
    [anon_sym_ref] = ACTIONS(1461),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1465),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1467),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1469),
    [anon_sym_DOT_DOT] = ACTIONS(1471),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1763] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7076),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5794),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4314),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9775),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1763),
    [sym_preproc_endregion] = STATE(1763),
    [sym_preproc_line] = STATE(1763),
    [sym_preproc_pragma] = STATE(1763),
    [sym_preproc_nullable] = STATE(1763),
    [sym_preproc_error] = STATE(1763),
    [sym_preproc_define] = STATE(1763),
    [sym_preproc_undef] = STATE(1763),
    [aux_sym_class_declaration_repeat1] = STATE(3835),
    [aux_sym_lambda_expression_repeat1] = STATE(4236),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1535),
    [anon_sym_ref] = ACTIONS(1537),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1465),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(885),
    [anon_sym_TILDE] = ACTIONS(885),
    [anon_sym_PLUS_PLUS] = ACTIONS(885),
    [anon_sym_DASH_DASH] = ACTIONS(885),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(887),
    [anon_sym_DASH] = ACTIONS(887),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(885),
    [anon_sym_AMP] = ACTIONS(885),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1539),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1541),
    [anon_sym_DOT_DOT] = ACTIONS(1543),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1764] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7076),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5793),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4314),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9775),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1764),
    [sym_preproc_endregion] = STATE(1764),
    [sym_preproc_line] = STATE(1764),
    [sym_preproc_pragma] = STATE(1764),
    [sym_preproc_nullable] = STATE(1764),
    [sym_preproc_error] = STATE(1764),
    [sym_preproc_define] = STATE(1764),
    [sym_preproc_undef] = STATE(1764),
    [aux_sym_class_declaration_repeat1] = STATE(3835),
    [aux_sym_lambda_expression_repeat1] = STATE(4236),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1535),
    [anon_sym_ref] = ACTIONS(1537),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1465),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(885),
    [anon_sym_TILDE] = ACTIONS(885),
    [anon_sym_PLUS_PLUS] = ACTIONS(885),
    [anon_sym_DASH_DASH] = ACTIONS(885),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(887),
    [anon_sym_DASH] = ACTIONS(887),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(885),
    [anon_sym_AMP] = ACTIONS(885),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1539),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1541),
    [anon_sym_DOT_DOT] = ACTIONS(1543),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1765] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7076),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5792),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4314),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9775),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1765),
    [sym_preproc_endregion] = STATE(1765),
    [sym_preproc_line] = STATE(1765),
    [sym_preproc_pragma] = STATE(1765),
    [sym_preproc_nullable] = STATE(1765),
    [sym_preproc_error] = STATE(1765),
    [sym_preproc_define] = STATE(1765),
    [sym_preproc_undef] = STATE(1765),
    [aux_sym_class_declaration_repeat1] = STATE(3835),
    [aux_sym_lambda_expression_repeat1] = STATE(4236),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1535),
    [anon_sym_ref] = ACTIONS(1537),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1465),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(885),
    [anon_sym_TILDE] = ACTIONS(885),
    [anon_sym_PLUS_PLUS] = ACTIONS(885),
    [anon_sym_DASH_DASH] = ACTIONS(885),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(887),
    [anon_sym_DASH] = ACTIONS(887),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(885),
    [anon_sym_AMP] = ACTIONS(885),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1539),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1541),
    [anon_sym_DOT_DOT] = ACTIONS(1543),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1766] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7076),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5791),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4314),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9775),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1766),
    [sym_preproc_endregion] = STATE(1766),
    [sym_preproc_line] = STATE(1766),
    [sym_preproc_pragma] = STATE(1766),
    [sym_preproc_nullable] = STATE(1766),
    [sym_preproc_error] = STATE(1766),
    [sym_preproc_define] = STATE(1766),
    [sym_preproc_undef] = STATE(1766),
    [aux_sym_class_declaration_repeat1] = STATE(3835),
    [aux_sym_lambda_expression_repeat1] = STATE(4236),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1535),
    [anon_sym_ref] = ACTIONS(1537),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1465),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(885),
    [anon_sym_TILDE] = ACTIONS(885),
    [anon_sym_PLUS_PLUS] = ACTIONS(885),
    [anon_sym_DASH_DASH] = ACTIONS(885),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(887),
    [anon_sym_DASH] = ACTIONS(887),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(885),
    [anon_sym_AMP] = ACTIONS(885),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1539),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1541),
    [anon_sym_DOT_DOT] = ACTIONS(1543),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1767] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7076),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5790),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4314),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9775),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1767),
    [sym_preproc_endregion] = STATE(1767),
    [sym_preproc_line] = STATE(1767),
    [sym_preproc_pragma] = STATE(1767),
    [sym_preproc_nullable] = STATE(1767),
    [sym_preproc_error] = STATE(1767),
    [sym_preproc_define] = STATE(1767),
    [sym_preproc_undef] = STATE(1767),
    [aux_sym_class_declaration_repeat1] = STATE(3835),
    [aux_sym_lambda_expression_repeat1] = STATE(4236),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1535),
    [anon_sym_ref] = ACTIONS(1537),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1465),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(885),
    [anon_sym_TILDE] = ACTIONS(885),
    [anon_sym_PLUS_PLUS] = ACTIONS(885),
    [anon_sym_DASH_DASH] = ACTIONS(885),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(887),
    [anon_sym_DASH] = ACTIONS(887),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(885),
    [anon_sym_AMP] = ACTIONS(885),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1539),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1541),
    [anon_sym_DOT_DOT] = ACTIONS(1543),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1768] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7076),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5789),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4314),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9775),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1768),
    [sym_preproc_endregion] = STATE(1768),
    [sym_preproc_line] = STATE(1768),
    [sym_preproc_pragma] = STATE(1768),
    [sym_preproc_nullable] = STATE(1768),
    [sym_preproc_error] = STATE(1768),
    [sym_preproc_define] = STATE(1768),
    [sym_preproc_undef] = STATE(1768),
    [aux_sym_class_declaration_repeat1] = STATE(3835),
    [aux_sym_lambda_expression_repeat1] = STATE(4236),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1535),
    [anon_sym_ref] = ACTIONS(1537),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1465),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(885),
    [anon_sym_TILDE] = ACTIONS(885),
    [anon_sym_PLUS_PLUS] = ACTIONS(885),
    [anon_sym_DASH_DASH] = ACTIONS(885),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(887),
    [anon_sym_DASH] = ACTIONS(887),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(885),
    [anon_sym_AMP] = ACTIONS(885),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1539),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1541),
    [anon_sym_DOT_DOT] = ACTIONS(1543),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1769] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6913),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7094),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6709),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(3191),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1769),
    [sym_preproc_endregion] = STATE(1769),
    [sym_preproc_line] = STATE(1769),
    [sym_preproc_pragma] = STATE(1769),
    [sym_preproc_nullable] = STATE(1769),
    [sym_preproc_error] = STATE(1769),
    [sym_preproc_define] = STATE(1769),
    [sym_preproc_undef] = STATE(1769),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(2915),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1669),
    [anon_sym_TILDE] = ACTIONS(1669),
    [anon_sym_PLUS_PLUS] = ACTIONS(1669),
    [anon_sym_DASH_DASH] = ACTIONS(1669),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1667),
    [anon_sym_DASH] = ACTIONS(1667),
    [anon_sym_STAR] = ACTIONS(1157),
    [anon_sym_CARET] = ACTIONS(1669),
    [anon_sym_AMP] = ACTIONS(1669),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1770] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7076),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5786),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4314),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9775),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1770),
    [sym_preproc_endregion] = STATE(1770),
    [sym_preproc_line] = STATE(1770),
    [sym_preproc_pragma] = STATE(1770),
    [sym_preproc_nullable] = STATE(1770),
    [sym_preproc_error] = STATE(1770),
    [sym_preproc_define] = STATE(1770),
    [sym_preproc_undef] = STATE(1770),
    [aux_sym_class_declaration_repeat1] = STATE(3835),
    [aux_sym_lambda_expression_repeat1] = STATE(4236),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1535),
    [anon_sym_ref] = ACTIONS(1537),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1465),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(885),
    [anon_sym_TILDE] = ACTIONS(885),
    [anon_sym_PLUS_PLUS] = ACTIONS(885),
    [anon_sym_DASH_DASH] = ACTIONS(885),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(887),
    [anon_sym_DASH] = ACTIONS(887),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(885),
    [anon_sym_AMP] = ACTIONS(885),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1539),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1541),
    [anon_sym_DOT_DOT] = ACTIONS(1543),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1771] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6913),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7016),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(3849),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(3582),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7407),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9275),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1771),
    [sym_preproc_endregion] = STATE(1771),
    [sym_preproc_line] = STATE(1771),
    [sym_preproc_pragma] = STATE(1771),
    [sym_preproc_nullable] = STATE(1771),
    [sym_preproc_error] = STATE(1771),
    [sym_preproc_define] = STATE(1771),
    [sym_preproc_undef] = STATE(1771),
    [aux_sym_class_declaration_repeat1] = STATE(3789),
    [aux_sym_lambda_expression_repeat1] = STATE(4086),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1137),
    [anon_sym_ref] = ACTIONS(1139),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1145),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1153),
    [anon_sym_TILDE] = ACTIONS(1153),
    [anon_sym_PLUS_PLUS] = ACTIONS(1153),
    [anon_sym_DASH_DASH] = ACTIONS(1153),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1151),
    [anon_sym_DASH] = ACTIONS(1151),
    [anon_sym_STAR] = ACTIONS(1157),
    [anon_sym_CARET] = ACTIONS(1153),
    [anon_sym_AMP] = ACTIONS(1153),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1165),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1167),
    [anon_sym_DOT_DOT] = ACTIONS(1169),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1772] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6898),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2940),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7094),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6687),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(3455),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1772),
    [sym_preproc_endregion] = STATE(1772),
    [sym_preproc_line] = STATE(1772),
    [sym_preproc_pragma] = STATE(1772),
    [sym_preproc_nullable] = STATE(1772),
    [sym_preproc_error] = STATE(1772),
    [sym_preproc_define] = STATE(1772),
    [sym_preproc_undef] = STATE(1772),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(2909),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1669),
    [anon_sym_TILDE] = ACTIONS(1669),
    [anon_sym_PLUS_PLUS] = ACTIONS(1669),
    [anon_sym_DASH_DASH] = ACTIONS(1669),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1667),
    [anon_sym_DASH] = ACTIONS(1667),
    [anon_sym_STAR] = ACTIONS(1895),
    [anon_sym_CARET] = ACTIONS(1669),
    [anon_sym_AMP] = ACTIONS(1669),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1773] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6987),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4308),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4462),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7405),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9130),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1773),
    [sym_preproc_endregion] = STATE(1773),
    [sym_preproc_line] = STATE(1773),
    [sym_preproc_pragma] = STATE(1773),
    [sym_preproc_nullable] = STATE(1773),
    [sym_preproc_error] = STATE(1773),
    [sym_preproc_define] = STATE(1773),
    [sym_preproc_undef] = STATE(1773),
    [aux_sym_class_declaration_repeat1] = STATE(3855),
    [aux_sym_lambda_expression_repeat1] = STATE(4244),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2031),
    [anon_sym_ref] = ACTIONS(2033),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2037),
    [anon_sym_TILDE] = ACTIONS(2037),
    [anon_sym_PLUS_PLUS] = ACTIONS(2037),
    [anon_sym_DASH_DASH] = ACTIONS(2037),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2035),
    [anon_sym_DASH] = ACTIONS(2035),
    [anon_sym_STAR] = ACTIONS(2039),
    [anon_sym_CARET] = ACTIONS(2037),
    [anon_sym_AMP] = ACTIONS(2037),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2041),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2043),
    [anon_sym_DOT_DOT] = ACTIONS(2045),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1774] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6914),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2882),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7094),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6709),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(3191),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1774),
    [sym_preproc_endregion] = STATE(1774),
    [sym_preproc_line] = STATE(1774),
    [sym_preproc_pragma] = STATE(1774),
    [sym_preproc_nullable] = STATE(1774),
    [sym_preproc_error] = STATE(1774),
    [sym_preproc_define] = STATE(1774),
    [sym_preproc_undef] = STATE(1774),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(2915),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1669),
    [anon_sym_TILDE] = ACTIONS(1669),
    [anon_sym_PLUS_PLUS] = ACTIONS(1669),
    [anon_sym_DASH_DASH] = ACTIONS(1669),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1667),
    [anon_sym_DASH] = ACTIONS(1667),
    [anon_sym_STAR] = ACTIONS(1735),
    [anon_sym_CARET] = ACTIONS(1669),
    [anon_sym_AMP] = ACTIONS(1669),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1775] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6911),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6992),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(3849),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(3829),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7391),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9246),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1775),
    [sym_preproc_endregion] = STATE(1775),
    [sym_preproc_line] = STATE(1775),
    [sym_preproc_pragma] = STATE(1775),
    [sym_preproc_nullable] = STATE(1775),
    [sym_preproc_error] = STATE(1775),
    [sym_preproc_define] = STATE(1775),
    [sym_preproc_undef] = STATE(1775),
    [aux_sym_class_declaration_repeat1] = STATE(3800),
    [aux_sym_lambda_expression_repeat1] = STATE(4089),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1323),
    [anon_sym_ref] = ACTIONS(1325),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1145),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1329),
    [anon_sym_TILDE] = ACTIONS(1329),
    [anon_sym_PLUS_PLUS] = ACTIONS(1329),
    [anon_sym_DASH_DASH] = ACTIONS(1329),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1327),
    [anon_sym_DASH] = ACTIONS(1327),
    [anon_sym_STAR] = ACTIONS(1331),
    [anon_sym_CARET] = ACTIONS(1329),
    [anon_sym_AMP] = ACTIONS(1329),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1333),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1335),
    [anon_sym_DOT_DOT] = ACTIONS(1337),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1776] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6911),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7094),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6709),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(3191),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1776),
    [sym_preproc_endregion] = STATE(1776),
    [sym_preproc_line] = STATE(1776),
    [sym_preproc_pragma] = STATE(1776),
    [sym_preproc_nullable] = STATE(1776),
    [sym_preproc_error] = STATE(1776),
    [sym_preproc_define] = STATE(1776),
    [sym_preproc_undef] = STATE(1776),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(2915),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1669),
    [anon_sym_TILDE] = ACTIONS(1669),
    [anon_sym_PLUS_PLUS] = ACTIONS(1669),
    [anon_sym_DASH_DASH] = ACTIONS(1669),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1667),
    [anon_sym_DASH] = ACTIONS(1667),
    [anon_sym_STAR] = ACTIONS(1331),
    [anon_sym_CARET] = ACTIONS(1669),
    [anon_sym_AMP] = ACTIONS(1669),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1777] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6914),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2882),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6963),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(3849),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4002),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7386),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9254),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1777),
    [sym_preproc_endregion] = STATE(1777),
    [sym_preproc_line] = STATE(1777),
    [sym_preproc_pragma] = STATE(1777),
    [sym_preproc_nullable] = STATE(1777),
    [sym_preproc_error] = STATE(1777),
    [sym_preproc_define] = STATE(1777),
    [sym_preproc_undef] = STATE(1777),
    [aux_sym_class_declaration_repeat1] = STATE(3797),
    [aux_sym_lambda_expression_repeat1] = STATE(4081),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1727),
    [anon_sym_ref] = ACTIONS(1729),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1713),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1733),
    [anon_sym_TILDE] = ACTIONS(1733),
    [anon_sym_PLUS_PLUS] = ACTIONS(1733),
    [anon_sym_DASH_DASH] = ACTIONS(1733),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1731),
    [anon_sym_DASH] = ACTIONS(1731),
    [anon_sym_STAR] = ACTIONS(1735),
    [anon_sym_CARET] = ACTIONS(1733),
    [anon_sym_AMP] = ACTIONS(1733),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1737),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1739),
    [anon_sym_DOT_DOT] = ACTIONS(1741),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1778] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6616),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1778),
    [sym_preproc_endregion] = STATE(1778),
    [sym_preproc_line] = STATE(1778),
    [sym_preproc_pragma] = STATE(1778),
    [sym_preproc_nullable] = STATE(1778),
    [sym_preproc_error] = STATE(1778),
    [sym_preproc_define] = STATE(1778),
    [sym_preproc_undef] = STATE(1778),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1779] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6905),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2944),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7094),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6691),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(2988),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1779),
    [sym_preproc_endregion] = STATE(1779),
    [sym_preproc_line] = STATE(1779),
    [sym_preproc_pragma] = STATE(1779),
    [sym_preproc_nullable] = STATE(1779),
    [sym_preproc_error] = STATE(1779),
    [sym_preproc_define] = STATE(1779),
    [sym_preproc_undef] = STATE(1779),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2911),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1669),
    [anon_sym_TILDE] = ACTIONS(1669),
    [anon_sym_PLUS_PLUS] = ACTIONS(1669),
    [anon_sym_DASH_DASH] = ACTIONS(1669),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1667),
    [anon_sym_DASH] = ACTIONS(1667),
    [anon_sym_STAR] = ACTIONS(2185),
    [anon_sym_CARET] = ACTIONS(1669),
    [anon_sym_AMP] = ACTIONS(1669),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1780] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6901),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2939),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7085),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(3902),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4322),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7392),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9185),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1780),
    [sym_preproc_endregion] = STATE(1780),
    [sym_preproc_line] = STATE(1780),
    [sym_preproc_pragma] = STATE(1780),
    [sym_preproc_nullable] = STATE(1780),
    [sym_preproc_error] = STATE(1780),
    [sym_preproc_define] = STATE(1780),
    [sym_preproc_undef] = STATE(1780),
    [aux_sym_class_declaration_repeat1] = STATE(3819),
    [aux_sym_lambda_expression_repeat1] = STATE(4161),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_ref] = ACTIONS(1761),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1763),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1767),
    [anon_sym_TILDE] = ACTIONS(1767),
    [anon_sym_PLUS_PLUS] = ACTIONS(1767),
    [anon_sym_DASH_DASH] = ACTIONS(1767),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1765),
    [anon_sym_STAR] = ACTIONS(1769),
    [anon_sym_CARET] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(1767),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1771),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1773),
    [anon_sym_DOT_DOT] = ACTIONS(1775),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1781] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7076),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4325),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4314),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9775),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1781),
    [sym_preproc_endregion] = STATE(1781),
    [sym_preproc_line] = STATE(1781),
    [sym_preproc_pragma] = STATE(1781),
    [sym_preproc_nullable] = STATE(1781),
    [sym_preproc_error] = STATE(1781),
    [sym_preproc_define] = STATE(1781),
    [sym_preproc_undef] = STATE(1781),
    [aux_sym_class_declaration_repeat1] = STATE(3835),
    [aux_sym_lambda_expression_repeat1] = STATE(4236),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1535),
    [anon_sym_ref] = ACTIONS(1537),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1465),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(885),
    [anon_sym_TILDE] = ACTIONS(885),
    [anon_sym_PLUS_PLUS] = ACTIONS(885),
    [anon_sym_DASH_DASH] = ACTIONS(885),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(887),
    [anon_sym_DASH] = ACTIONS(887),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(885),
    [anon_sym_AMP] = ACTIONS(885),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1539),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1541),
    [anon_sym_DOT_DOT] = ACTIONS(1543),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1782] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7076),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5982),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4314),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9775),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1782),
    [sym_preproc_endregion] = STATE(1782),
    [sym_preproc_line] = STATE(1782),
    [sym_preproc_pragma] = STATE(1782),
    [sym_preproc_nullable] = STATE(1782),
    [sym_preproc_error] = STATE(1782),
    [sym_preproc_define] = STATE(1782),
    [sym_preproc_undef] = STATE(1782),
    [aux_sym_class_declaration_repeat1] = STATE(3835),
    [aux_sym_lambda_expression_repeat1] = STATE(4236),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1535),
    [anon_sym_ref] = ACTIONS(1537),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1465),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(885),
    [anon_sym_TILDE] = ACTIONS(885),
    [anon_sym_PLUS_PLUS] = ACTIONS(885),
    [anon_sym_DASH_DASH] = ACTIONS(885),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(887),
    [anon_sym_DASH] = ACTIONS(887),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(885),
    [anon_sym_AMP] = ACTIONS(885),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1539),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1541),
    [anon_sym_DOT_DOT] = ACTIONS(1543),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1783] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6893),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2968),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7094),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6691),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(2988),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1783),
    [sym_preproc_endregion] = STATE(1783),
    [sym_preproc_line] = STATE(1783),
    [sym_preproc_pragma] = STATE(1783),
    [sym_preproc_nullable] = STATE(1783),
    [sym_preproc_error] = STATE(1783),
    [sym_preproc_define] = STATE(1783),
    [sym_preproc_undef] = STATE(1783),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2911),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1669),
    [anon_sym_TILDE] = ACTIONS(1669),
    [anon_sym_PLUS_PLUS] = ACTIONS(1669),
    [anon_sym_DASH_DASH] = ACTIONS(1669),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1667),
    [anon_sym_DASH] = ACTIONS(1667),
    [anon_sym_STAR] = ACTIONS(2225),
    [anon_sym_CARET] = ACTIONS(1669),
    [anon_sym_AMP] = ACTIONS(1669),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1784] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6905),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2944),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7006),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(3557),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4413),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7404),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9233),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1784),
    [sym_preproc_endregion] = STATE(1784),
    [sym_preproc_line] = STATE(1784),
    [sym_preproc_pragma] = STATE(1784),
    [sym_preproc_nullable] = STATE(1784),
    [sym_preproc_error] = STATE(1784),
    [sym_preproc_define] = STATE(1784),
    [sym_preproc_undef] = STATE(1784),
    [aux_sym_class_declaration_repeat1] = STATE(3803),
    [aux_sym_lambda_expression_repeat1] = STATE(4105),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2175),
    [anon_sym_ref] = ACTIONS(2177),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2179),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(2183),
    [anon_sym_TILDE] = ACTIONS(2183),
    [anon_sym_PLUS_PLUS] = ACTIONS(2183),
    [anon_sym_DASH_DASH] = ACTIONS(2183),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2181),
    [anon_sym_DASH] = ACTIONS(2181),
    [anon_sym_STAR] = ACTIONS(2185),
    [anon_sym_CARET] = ACTIONS(2183),
    [anon_sym_AMP] = ACTIONS(2183),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2187),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2189),
    [anon_sym_DOT_DOT] = ACTIONS(2191),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1785] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3559),
    [sym__name] = STATE(6878),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2911),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6938),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4346),
    [sym_non_lvalue_expression] = STATE(4553),
    [sym_lvalue_expression] = STATE(3750),
    [sym__expression_statement_expression] = STATE(4559),
    [sym_assignment_expression] = STATE(4558),
    [sym_binary_expression] = STATE(4559),
    [sym_postfix_unary_expression] = STATE(4558),
    [sym_prefix_unary_expression] = STATE(4558),
    [sym__pointer_indirection_expression] = STATE(3560),
    [sym_query_expression] = STATE(4559),
    [sym_from_clause] = STATE(7406),
    [sym_conditional_expression] = STATE(4559),
    [sym_conditional_access_expression] = STATE(4559),
    [sym_as_expression] = STATE(4559),
    [sym_is_expression] = STATE(4559),
    [sym_is_pattern_expression] = STATE(4559),
    [sym_cast_expression] = STATE(4559),
    [sym_checked_expression] = STATE(4559),
    [sym_invocation_expression] = STATE(4558),
    [sym_switch_expression] = STATE(4559),
    [sym_await_expression] = STATE(4558),
    [sym_throw_expression] = STATE(4559),
    [sym_element_access_expression] = STATE(3560),
    [sym_interpolated_string_expression] = STATE(4559),
    [sym_member_access_expression] = STATE(3560),
    [sym_object_creation_expression] = STATE(4558),
    [sym_parenthesized_expression] = STATE(4558),
    [sym__parenthesized_lvalue_expression] = STATE(3560),
    [sym_lambda_expression] = STATE(4559),
    [sym__lambda_parameters] = STATE(9691),
    [sym_array_creation_expression] = STATE(4559),
    [sym_anonymous_method_expression] = STATE(4559),
    [sym_anonymous_object_creation_expression] = STATE(4559),
    [sym_implicit_array_creation_expression] = STATE(4559),
    [sym_implicit_object_creation_expression] = STATE(4559),
    [sym_implicit_stackalloc_expression] = STATE(4559),
    [sym_initializer_expression] = STATE(4559),
    [sym_default_expression] = STATE(4559),
    [sym_with_expression] = STATE(4559),
    [sym_sizeof_expression] = STATE(4559),
    [sym_typeof_expression] = STATE(4559),
    [sym_makeref_expression] = STATE(4559),
    [sym_ref_expression] = STATE(4559),
    [sym_reftype_expression] = STATE(4559),
    [sym_refvalue_expression] = STATE(4559),
    [sym_stackalloc_expression] = STATE(4559),
    [sym_range_expression] = STATE(4559),
    [sym_tuple_expression] = STATE(3560),
    [sym_literal] = STATE(4559),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4559),
    [sym_preproc_region] = STATE(1785),
    [sym_preproc_endregion] = STATE(1785),
    [sym_preproc_line] = STATE(1785),
    [sym_preproc_pragma] = STATE(1785),
    [sym_preproc_nullable] = STATE(1785),
    [sym_preproc_error] = STATE(1785),
    [sym_preproc_define] = STATE(1785),
    [sym_preproc_undef] = STATE(1785),
    [aux_sym_class_declaration_repeat1] = STATE(3836),
    [aux_sym_lambda_expression_repeat1] = STATE(4216),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(2003),
    [anon_sym_ref] = ACTIONS(2005),
    [anon_sym_LBRACE] = ACTIONS(1611),
    [anon_sym_delegate] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1615),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(2009),
    [anon_sym_TILDE] = ACTIONS(2009),
    [anon_sym_PLUS_PLUS] = ACTIONS(2009),
    [anon_sym_DASH_DASH] = ACTIONS(2009),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(2007),
    [anon_sym_DASH] = ACTIONS(2007),
    [anon_sym_STAR] = ACTIONS(1625),
    [anon_sym_CARET] = ACTIONS(2009),
    [anon_sym_AMP] = ACTIONS(2009),
    [anon_sym_this] = ACTIONS(1627),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1629),
    [anon_sym_unchecked] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(2011),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2013),
    [anon_sym_DOT_DOT] = ACTIONS(2015),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_stackalloc] = ACTIONS(1641),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(1647),
    [anon_sym___reftype] = ACTIONS(1649),
    [anon_sym___refvalue] = ACTIONS(1651),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1659),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [1786] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3559),
    [sym__name] = STATE(6878),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2911),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6938),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4806),
    [sym_non_lvalue_expression] = STATE(4553),
    [sym_lvalue_expression] = STATE(3750),
    [sym__expression_statement_expression] = STATE(4559),
    [sym_assignment_expression] = STATE(4558),
    [sym_binary_expression] = STATE(4559),
    [sym_postfix_unary_expression] = STATE(4558),
    [sym_prefix_unary_expression] = STATE(4558),
    [sym__pointer_indirection_expression] = STATE(3560),
    [sym_query_expression] = STATE(4559),
    [sym_from_clause] = STATE(7406),
    [sym_conditional_expression] = STATE(4559),
    [sym_conditional_access_expression] = STATE(4559),
    [sym_as_expression] = STATE(4559),
    [sym_is_expression] = STATE(4559),
    [sym_is_pattern_expression] = STATE(4559),
    [sym_cast_expression] = STATE(4559),
    [sym_checked_expression] = STATE(4559),
    [sym_invocation_expression] = STATE(4558),
    [sym_switch_expression] = STATE(4559),
    [sym_await_expression] = STATE(4558),
    [sym_throw_expression] = STATE(4559),
    [sym_element_access_expression] = STATE(3560),
    [sym_interpolated_string_expression] = STATE(4559),
    [sym_member_access_expression] = STATE(3560),
    [sym_object_creation_expression] = STATE(4558),
    [sym_parenthesized_expression] = STATE(4558),
    [sym__parenthesized_lvalue_expression] = STATE(3560),
    [sym_lambda_expression] = STATE(4559),
    [sym__lambda_parameters] = STATE(9691),
    [sym_array_creation_expression] = STATE(4559),
    [sym_anonymous_method_expression] = STATE(4559),
    [sym_anonymous_object_creation_expression] = STATE(4559),
    [sym_implicit_array_creation_expression] = STATE(4559),
    [sym_implicit_object_creation_expression] = STATE(4559),
    [sym_implicit_stackalloc_expression] = STATE(4559),
    [sym_initializer_expression] = STATE(4559),
    [sym_default_expression] = STATE(4559),
    [sym_with_expression] = STATE(4559),
    [sym_sizeof_expression] = STATE(4559),
    [sym_typeof_expression] = STATE(4559),
    [sym_makeref_expression] = STATE(4559),
    [sym_ref_expression] = STATE(4559),
    [sym_reftype_expression] = STATE(4559),
    [sym_refvalue_expression] = STATE(4559),
    [sym_stackalloc_expression] = STATE(4559),
    [sym_range_expression] = STATE(4559),
    [sym_tuple_expression] = STATE(3560),
    [sym_literal] = STATE(4559),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4559),
    [sym_preproc_region] = STATE(1786),
    [sym_preproc_endregion] = STATE(1786),
    [sym_preproc_line] = STATE(1786),
    [sym_preproc_pragma] = STATE(1786),
    [sym_preproc_nullable] = STATE(1786),
    [sym_preproc_error] = STATE(1786),
    [sym_preproc_define] = STATE(1786),
    [sym_preproc_undef] = STATE(1786),
    [aux_sym_class_declaration_repeat1] = STATE(3836),
    [aux_sym_lambda_expression_repeat1] = STATE(4216),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(2003),
    [anon_sym_ref] = ACTIONS(2005),
    [anon_sym_LBRACE] = ACTIONS(1611),
    [anon_sym_delegate] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1615),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(2009),
    [anon_sym_TILDE] = ACTIONS(2009),
    [anon_sym_PLUS_PLUS] = ACTIONS(2009),
    [anon_sym_DASH_DASH] = ACTIONS(2009),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(2007),
    [anon_sym_DASH] = ACTIONS(2007),
    [anon_sym_STAR] = ACTIONS(1625),
    [anon_sym_CARET] = ACTIONS(2009),
    [anon_sym_AMP] = ACTIONS(2009),
    [anon_sym_this] = ACTIONS(1627),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1629),
    [anon_sym_unchecked] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(2011),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2013),
    [anon_sym_DOT_DOT] = ACTIONS(2015),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_stackalloc] = ACTIONS(1641),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(1647),
    [anon_sym___reftype] = ACTIONS(1649),
    [anon_sym___refvalue] = ACTIONS(1651),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1659),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [1787] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6546),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1787),
    [sym_preproc_endregion] = STATE(1787),
    [sym_preproc_line] = STATE(1787),
    [sym_preproc_pragma] = STATE(1787),
    [sym_preproc_nullable] = STATE(1787),
    [sym_preproc_error] = STATE(1787),
    [sym_preproc_define] = STATE(1787),
    [sym_preproc_undef] = STATE(1787),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1788] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6888),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2882),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7094),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6709),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(3191),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1788),
    [sym_preproc_endregion] = STATE(1788),
    [sym_preproc_line] = STATE(1788),
    [sym_preproc_pragma] = STATE(1788),
    [sym_preproc_nullable] = STATE(1788),
    [sym_preproc_error] = STATE(1788),
    [sym_preproc_define] = STATE(1788),
    [sym_preproc_undef] = STATE(1788),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(2915),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1669),
    [anon_sym_TILDE] = ACTIONS(1669),
    [anon_sym_PLUS_PLUS] = ACTIONS(1669),
    [anon_sym_DASH_DASH] = ACTIONS(1669),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1667),
    [anon_sym_DASH] = ACTIONS(1667),
    [anon_sym_STAR] = ACTIONS(1719),
    [anon_sym_CARET] = ACTIONS(1669),
    [anon_sym_AMP] = ACTIONS(1669),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1789] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6544),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1789),
    [sym_preproc_endregion] = STATE(1789),
    [sym_preproc_line] = STATE(1789),
    [sym_preproc_pragma] = STATE(1789),
    [sym_preproc_nullable] = STATE(1789),
    [sym_preproc_error] = STATE(1789),
    [sym_preproc_define] = STATE(1789),
    [sym_preproc_undef] = STATE(1789),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1790] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6881),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2964),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7109),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(3902),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4326),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7394),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9186),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1790),
    [sym_preproc_endregion] = STATE(1790),
    [sym_preproc_line] = STATE(1790),
    [sym_preproc_pragma] = STATE(1790),
    [sym_preproc_nullable] = STATE(1790),
    [sym_preproc_error] = STATE(1790),
    [sym_preproc_define] = STATE(1790),
    [sym_preproc_undef] = STATE(1790),
    [aux_sym_class_declaration_repeat1] = STATE(3828),
    [aux_sym_lambda_expression_repeat1] = STATE(4180),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1813),
    [anon_sym_ref] = ACTIONS(1815),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1817),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1821),
    [anon_sym_TILDE] = ACTIONS(1821),
    [anon_sym_PLUS_PLUS] = ACTIONS(1821),
    [anon_sym_DASH_DASH] = ACTIONS(1821),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1819),
    [anon_sym_DASH] = ACTIONS(1819),
    [anon_sym_STAR] = ACTIONS(1823),
    [anon_sym_CARET] = ACTIONS(1821),
    [anon_sym_AMP] = ACTIONS(1821),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1825),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1827),
    [anon_sym_DOT_DOT] = ACTIONS(1829),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1791] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6918),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7094),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6691),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(2988),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1791),
    [sym_preproc_endregion] = STATE(1791),
    [sym_preproc_line] = STATE(1791),
    [sym_preproc_pragma] = STATE(1791),
    [sym_preproc_nullable] = STATE(1791),
    [sym_preproc_error] = STATE(1791),
    [sym_preproc_define] = STATE(1791),
    [sym_preproc_undef] = STATE(1791),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2911),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1669),
    [anon_sym_TILDE] = ACTIONS(1669),
    [anon_sym_PLUS_PLUS] = ACTIONS(1669),
    [anon_sym_DASH_DASH] = ACTIONS(1669),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1667),
    [anon_sym_DASH] = ACTIONS(1667),
    [anon_sym_STAR] = ACTIONS(1913),
    [anon_sym_CARET] = ACTIONS(1669),
    [anon_sym_AMP] = ACTIONS(1669),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1792] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3559),
    [sym__name] = STATE(6878),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2911),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7094),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6692),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(3562),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3560),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3560),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3560),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3560),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3560),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1792),
    [sym_preproc_endregion] = STATE(1792),
    [sym_preproc_line] = STATE(1792),
    [sym_preproc_pragma] = STATE(1792),
    [sym_preproc_nullable] = STATE(1792),
    [sym_preproc_error] = STATE(1792),
    [sym_preproc_define] = STATE(1792),
    [sym_preproc_undef] = STATE(1792),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(2913),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1669),
    [anon_sym_TILDE] = ACTIONS(1669),
    [anon_sym_PLUS_PLUS] = ACTIONS(1669),
    [anon_sym_DASH_DASH] = ACTIONS(1669),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1667),
    [anon_sym_DASH] = ACTIONS(1667),
    [anon_sym_STAR] = ACTIONS(1625),
    [anon_sym_CARET] = ACTIONS(1669),
    [anon_sym_AMP] = ACTIONS(1669),
    [anon_sym_this] = ACTIONS(1627),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1629),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1793] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7064),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(3902),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(3866),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7382),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9762),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1793),
    [sym_preproc_endregion] = STATE(1793),
    [sym_preproc_line] = STATE(1793),
    [sym_preproc_pragma] = STATE(1793),
    [sym_preproc_nullable] = STATE(1793),
    [sym_preproc_error] = STATE(1793),
    [sym_preproc_define] = STATE(1793),
    [sym_preproc_undef] = STATE(1793),
    [aux_sym_class_declaration_repeat1] = STATE(3842),
    [aux_sym_lambda_expression_repeat1] = STATE(4280),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1351),
    [anon_sym_ref] = ACTIONS(1353),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1357),
    [anon_sym_TILDE] = ACTIONS(1357),
    [anon_sym_PLUS_PLUS] = ACTIONS(1357),
    [anon_sym_DASH_DASH] = ACTIONS(1357),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1355),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(1357),
    [anon_sym_AMP] = ACTIONS(1357),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1361),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1363),
    [anon_sym_DOT_DOT] = ACTIONS(1365),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1794] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6893),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2968),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7023),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(3557),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4416),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7390),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9221),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1794),
    [sym_preproc_endregion] = STATE(1794),
    [sym_preproc_line] = STATE(1794),
    [sym_preproc_pragma] = STATE(1794),
    [sym_preproc_nullable] = STATE(1794),
    [sym_preproc_error] = STATE(1794),
    [sym_preproc_define] = STATE(1794),
    [sym_preproc_undef] = STATE(1794),
    [aux_sym_class_declaration_repeat1] = STATE(3808),
    [aux_sym_lambda_expression_repeat1] = STATE(4129),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_ref] = ACTIONS(2217),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2219),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(2223),
    [anon_sym_TILDE] = ACTIONS(2223),
    [anon_sym_PLUS_PLUS] = ACTIONS(2223),
    [anon_sym_DASH_DASH] = ACTIONS(2223),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2221),
    [anon_sym_DASH] = ACTIONS(2221),
    [anon_sym_STAR] = ACTIONS(2225),
    [anon_sym_CARET] = ACTIONS(2223),
    [anon_sym_AMP] = ACTIONS(2223),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2227),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2229),
    [anon_sym_DOT_DOT] = ACTIONS(2231),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1795] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7094),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6043),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1795),
    [sym_preproc_endregion] = STATE(1795),
    [sym_preproc_line] = STATE(1795),
    [sym_preproc_pragma] = STATE(1795),
    [sym_preproc_nullable] = STATE(1795),
    [sym_preproc_error] = STATE(1795),
    [sym_preproc_define] = STATE(1795),
    [sym_preproc_undef] = STATE(1795),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1669),
    [anon_sym_TILDE] = ACTIONS(1669),
    [anon_sym_PLUS_PLUS] = ACTIONS(1669),
    [anon_sym_DASH_DASH] = ACTIONS(1669),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1667),
    [anon_sym_DASH] = ACTIONS(1667),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1669),
    [anon_sym_AMP] = ACTIONS(1669),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1796] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7094),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6046),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1796),
    [sym_preproc_endregion] = STATE(1796),
    [sym_preproc_line] = STATE(1796),
    [sym_preproc_pragma] = STATE(1796),
    [sym_preproc_nullable] = STATE(1796),
    [sym_preproc_error] = STATE(1796),
    [sym_preproc_define] = STATE(1796),
    [sym_preproc_undef] = STATE(1796),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1669),
    [anon_sym_TILDE] = ACTIONS(1669),
    [anon_sym_PLUS_PLUS] = ACTIONS(1669),
    [anon_sym_DASH_DASH] = ACTIONS(1669),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1667),
    [anon_sym_DASH] = ACTIONS(1667),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1669),
    [anon_sym_AMP] = ACTIONS(1669),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1797] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5763),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1797),
    [sym_preproc_endregion] = STATE(1797),
    [sym_preproc_line] = STATE(1797),
    [sym_preproc_pragma] = STATE(1797),
    [sym_preproc_nullable] = STATE(1797),
    [sym_preproc_error] = STATE(1797),
    [sym_preproc_define] = STATE(1797),
    [sym_preproc_undef] = STATE(1797),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1798] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6901),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2939),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7094),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6687),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(3455),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1798),
    [sym_preproc_endregion] = STATE(1798),
    [sym_preproc_line] = STATE(1798),
    [sym_preproc_pragma] = STATE(1798),
    [sym_preproc_nullable] = STATE(1798),
    [sym_preproc_error] = STATE(1798),
    [sym_preproc_define] = STATE(1798),
    [sym_preproc_undef] = STATE(1798),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(2909),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1669),
    [anon_sym_TILDE] = ACTIONS(1669),
    [anon_sym_PLUS_PLUS] = ACTIONS(1669),
    [anon_sym_DASH_DASH] = ACTIONS(1669),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1667),
    [anon_sym_DASH] = ACTIONS(1667),
    [anon_sym_STAR] = ACTIONS(1769),
    [anon_sym_CARET] = ACTIONS(1669),
    [anon_sym_AMP] = ACTIONS(1669),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1799] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7094),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6047),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1799),
    [sym_preproc_endregion] = STATE(1799),
    [sym_preproc_line] = STATE(1799),
    [sym_preproc_pragma] = STATE(1799),
    [sym_preproc_nullable] = STATE(1799),
    [sym_preproc_error] = STATE(1799),
    [sym_preproc_define] = STATE(1799),
    [sym_preproc_undef] = STATE(1799),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1669),
    [anon_sym_TILDE] = ACTIONS(1669),
    [anon_sym_PLUS_PLUS] = ACTIONS(1669),
    [anon_sym_DASH_DASH] = ACTIONS(1669),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1667),
    [anon_sym_DASH] = ACTIONS(1667),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1669),
    [anon_sym_AMP] = ACTIONS(1669),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1800] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7094),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6048),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1800),
    [sym_preproc_endregion] = STATE(1800),
    [sym_preproc_line] = STATE(1800),
    [sym_preproc_pragma] = STATE(1800),
    [sym_preproc_nullable] = STATE(1800),
    [sym_preproc_error] = STATE(1800),
    [sym_preproc_define] = STATE(1800),
    [sym_preproc_undef] = STATE(1800),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1669),
    [anon_sym_TILDE] = ACTIONS(1669),
    [anon_sym_PLUS_PLUS] = ACTIONS(1669),
    [anon_sym_DASH_DASH] = ACTIONS(1669),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1667),
    [anon_sym_DASH] = ACTIONS(1667),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1669),
    [anon_sym_AMP] = ACTIONS(1669),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1801] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7094),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6056),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1801),
    [sym_preproc_endregion] = STATE(1801),
    [sym_preproc_line] = STATE(1801),
    [sym_preproc_pragma] = STATE(1801),
    [sym_preproc_nullable] = STATE(1801),
    [sym_preproc_error] = STATE(1801),
    [sym_preproc_define] = STATE(1801),
    [sym_preproc_undef] = STATE(1801),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1669),
    [anon_sym_TILDE] = ACTIONS(1669),
    [anon_sym_PLUS_PLUS] = ACTIONS(1669),
    [anon_sym_DASH_DASH] = ACTIONS(1669),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1667),
    [anon_sym_DASH] = ACTIONS(1667),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1669),
    [anon_sym_AMP] = ACTIONS(1669),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1802] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7094),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6057),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1802),
    [sym_preproc_endregion] = STATE(1802),
    [sym_preproc_line] = STATE(1802),
    [sym_preproc_pragma] = STATE(1802),
    [sym_preproc_nullable] = STATE(1802),
    [sym_preproc_error] = STATE(1802),
    [sym_preproc_define] = STATE(1802),
    [sym_preproc_undef] = STATE(1802),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1669),
    [anon_sym_TILDE] = ACTIONS(1669),
    [anon_sym_PLUS_PLUS] = ACTIONS(1669),
    [anon_sym_DASH_DASH] = ACTIONS(1669),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1667),
    [anon_sym_DASH] = ACTIONS(1667),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1669),
    [anon_sym_AMP] = ACTIONS(1669),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1803] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3921),
    [sym__name] = STATE(6919),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2868),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(7068),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5331),
    [sym_non_lvalue_expression] = STATE(5735),
    [sym_lvalue_expression] = STATE(4323),
    [sym__expression_statement_expression] = STATE(5733),
    [sym_assignment_expression] = STATE(5734),
    [sym_binary_expression] = STATE(5733),
    [sym_postfix_unary_expression] = STATE(5734),
    [sym_prefix_unary_expression] = STATE(5734),
    [sym__pointer_indirection_expression] = STATE(3911),
    [sym_query_expression] = STATE(5733),
    [sym_from_clause] = STATE(7393),
    [sym_conditional_expression] = STATE(5733),
    [sym_conditional_access_expression] = STATE(5733),
    [sym_as_expression] = STATE(5733),
    [sym_is_expression] = STATE(5733),
    [sym_is_pattern_expression] = STATE(5733),
    [sym_cast_expression] = STATE(5733),
    [sym_checked_expression] = STATE(5733),
    [sym_invocation_expression] = STATE(5734),
    [sym_switch_expression] = STATE(5733),
    [sym_await_expression] = STATE(5734),
    [sym_throw_expression] = STATE(5733),
    [sym_element_access_expression] = STATE(3911),
    [sym_interpolated_string_expression] = STATE(5733),
    [sym_member_access_expression] = STATE(3911),
    [sym_object_creation_expression] = STATE(5734),
    [sym_parenthesized_expression] = STATE(5734),
    [sym__parenthesized_lvalue_expression] = STATE(3911),
    [sym_lambda_expression] = STATE(5733),
    [sym__lambda_parameters] = STATE(9932),
    [sym_array_creation_expression] = STATE(5733),
    [sym_anonymous_method_expression] = STATE(5733),
    [sym_anonymous_object_creation_expression] = STATE(5733),
    [sym_implicit_array_creation_expression] = STATE(5733),
    [sym_implicit_object_creation_expression] = STATE(5733),
    [sym_implicit_stackalloc_expression] = STATE(5733),
    [sym_initializer_expression] = STATE(5733),
    [sym_default_expression] = STATE(5733),
    [sym_with_expression] = STATE(5733),
    [sym_sizeof_expression] = STATE(5733),
    [sym_typeof_expression] = STATE(5733),
    [sym_makeref_expression] = STATE(5733),
    [sym_ref_expression] = STATE(5733),
    [sym_reftype_expression] = STATE(5733),
    [sym_refvalue_expression] = STATE(5733),
    [sym_stackalloc_expression] = STATE(5733),
    [sym_range_expression] = STATE(5733),
    [sym_tuple_expression] = STATE(3911),
    [sym_literal] = STATE(5733),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2798),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(5733),
    [sym_preproc_region] = STATE(1803),
    [sym_preproc_endregion] = STATE(1803),
    [sym_preproc_line] = STATE(1803),
    [sym_preproc_pragma] = STATE(1803),
    [sym_preproc_nullable] = STATE(1803),
    [sym_preproc_error] = STATE(1803),
    [sym_preproc_define] = STATE(1803),
    [sym_preproc_undef] = STATE(1803),
    [aux_sym_class_declaration_repeat1] = STATE(3831),
    [aux_sym_lambda_expression_repeat1] = STATE(4227),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_LPAREN] = ACTIONS(1577),
    [anon_sym_ref] = ACTIONS(1579),
    [anon_sym_LBRACE] = ACTIONS(1377),
    [anon_sym_delegate] = ACTIONS(1379),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1381),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1583),
    [anon_sym_TILDE] = ACTIONS(1583),
    [anon_sym_PLUS_PLUS] = ACTIONS(1583),
    [anon_sym_DASH_DASH] = ACTIONS(1583),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1581),
    [anon_sym_DASH] = ACTIONS(1581),
    [anon_sym_STAR] = ACTIONS(1391),
    [anon_sym_CARET] = ACTIONS(1583),
    [anon_sym_AMP] = ACTIONS(1583),
    [anon_sym_this] = ACTIONS(1393),
    [anon_sym_scoped] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1397),
    [sym_predefined_type] = ACTIONS(1399),
    [anon_sym_unchecked] = ACTIONS(1383),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1585),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1587),
    [anon_sym_DOT_DOT] = ACTIONS(1589),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_stackalloc] = ACTIONS(1413),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(1419),
    [anon_sym___reftype] = ACTIONS(1421),
    [anon_sym___refvalue] = ACTIONS(1423),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
  },
  [1804] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7094),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6069),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1804),
    [sym_preproc_endregion] = STATE(1804),
    [sym_preproc_line] = STATE(1804),
    [sym_preproc_pragma] = STATE(1804),
    [sym_preproc_nullable] = STATE(1804),
    [sym_preproc_error] = STATE(1804),
    [sym_preproc_define] = STATE(1804),
    [sym_preproc_undef] = STATE(1804),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1669),
    [anon_sym_TILDE] = ACTIONS(1669),
    [anon_sym_PLUS_PLUS] = ACTIONS(1669),
    [anon_sym_DASH_DASH] = ACTIONS(1669),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1667),
    [anon_sym_DASH] = ACTIONS(1667),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1669),
    [anon_sym_AMP] = ACTIONS(1669),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1805] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6881),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2964),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7094),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6687),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(3455),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1805),
    [sym_preproc_endregion] = STATE(1805),
    [sym_preproc_line] = STATE(1805),
    [sym_preproc_pragma] = STATE(1805),
    [sym_preproc_nullable] = STATE(1805),
    [sym_preproc_error] = STATE(1805),
    [sym_preproc_define] = STATE(1805),
    [sym_preproc_undef] = STATE(1805),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(2909),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1669),
    [anon_sym_TILDE] = ACTIONS(1669),
    [anon_sym_PLUS_PLUS] = ACTIONS(1669),
    [anon_sym_DASH_DASH] = ACTIONS(1669),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1667),
    [anon_sym_DASH] = ACTIONS(1667),
    [anon_sym_STAR] = ACTIONS(1823),
    [anon_sym_CARET] = ACTIONS(1669),
    [anon_sym_AMP] = ACTIONS(1669),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1806] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7094),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6058),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1806),
    [sym_preproc_endregion] = STATE(1806),
    [sym_preproc_line] = STATE(1806),
    [sym_preproc_pragma] = STATE(1806),
    [sym_preproc_nullable] = STATE(1806),
    [sym_preproc_error] = STATE(1806),
    [sym_preproc_define] = STATE(1806),
    [sym_preproc_undef] = STATE(1806),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1669),
    [anon_sym_TILDE] = ACTIONS(1669),
    [anon_sym_PLUS_PLUS] = ACTIONS(1669),
    [anon_sym_DASH_DASH] = ACTIONS(1669),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1667),
    [anon_sym_DASH] = ACTIONS(1667),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1669),
    [anon_sym_AMP] = ACTIONS(1669),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1807] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6888),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2882),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7048),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(3849),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4019),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7409),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9210),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1807),
    [sym_preproc_endregion] = STATE(1807),
    [sym_preproc_line] = STATE(1807),
    [sym_preproc_pragma] = STATE(1807),
    [sym_preproc_nullable] = STATE(1807),
    [sym_preproc_error] = STATE(1807),
    [sym_preproc_define] = STATE(1807),
    [sym_preproc_undef] = STATE(1807),
    [aux_sym_class_declaration_repeat1] = STATE(3812),
    [aux_sym_lambda_expression_repeat1] = STATE(4146),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1709),
    [anon_sym_ref] = ACTIONS(1711),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1713),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1717),
    [anon_sym_TILDE] = ACTIONS(1717),
    [anon_sym_PLUS_PLUS] = ACTIONS(1717),
    [anon_sym_DASH_DASH] = ACTIONS(1717),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1715),
    [anon_sym_DASH] = ACTIONS(1715),
    [anon_sym_STAR] = ACTIONS(1719),
    [anon_sym_CARET] = ACTIONS(1717),
    [anon_sym_AMP] = ACTIONS(1717),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1721),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1723),
    [anon_sym_DOT_DOT] = ACTIONS(1725),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1808] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6879),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2935),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7094),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6709),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(3191),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1808),
    [sym_preproc_endregion] = STATE(1808),
    [sym_preproc_line] = STATE(1808),
    [sym_preproc_pragma] = STATE(1808),
    [sym_preproc_nullable] = STATE(1808),
    [sym_preproc_error] = STATE(1808),
    [sym_preproc_define] = STATE(1808),
    [sym_preproc_undef] = STATE(1808),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(2915),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1669),
    [anon_sym_TILDE] = ACTIONS(1669),
    [anon_sym_PLUS_PLUS] = ACTIONS(1669),
    [anon_sym_DASH_DASH] = ACTIONS(1669),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1667),
    [anon_sym_DASH] = ACTIONS(1667),
    [anon_sym_STAR] = ACTIONS(1877),
    [anon_sym_CARET] = ACTIONS(1669),
    [anon_sym_AMP] = ACTIONS(1669),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1809] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7094),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6062),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1809),
    [sym_preproc_endregion] = STATE(1809),
    [sym_preproc_line] = STATE(1809),
    [sym_preproc_pragma] = STATE(1809),
    [sym_preproc_nullable] = STATE(1809),
    [sym_preproc_error] = STATE(1809),
    [sym_preproc_define] = STATE(1809),
    [sym_preproc_undef] = STATE(1809),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1669),
    [anon_sym_TILDE] = ACTIONS(1669),
    [anon_sym_PLUS_PLUS] = ACTIONS(1669),
    [anon_sym_DASH_DASH] = ACTIONS(1669),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1667),
    [anon_sym_DASH] = ACTIONS(1667),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1669),
    [anon_sym_AMP] = ACTIONS(1669),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1810] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7027),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(3902),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4329),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7402),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9167),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1810),
    [sym_preproc_endregion] = STATE(1810),
    [sym_preproc_line] = STATE(1810),
    [sym_preproc_pragma] = STATE(1810),
    [sym_preproc_nullable] = STATE(1810),
    [sym_preproc_error] = STATE(1810),
    [sym_preproc_define] = STATE(1810),
    [sym_preproc_undef] = STATE(1810),
    [aux_sym_class_declaration_repeat1] = STATE(3794),
    [aux_sym_lambda_expression_repeat1] = STATE(4293),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1693),
    [anon_sym_ref] = ACTIONS(1695),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1699),
    [anon_sym_TILDE] = ACTIONS(1699),
    [anon_sym_PLUS_PLUS] = ACTIONS(1699),
    [anon_sym_DASH_DASH] = ACTIONS(1699),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1697),
    [anon_sym_DASH] = ACTIONS(1697),
    [anon_sym_STAR] = ACTIONS(1701),
    [anon_sym_CARET] = ACTIONS(1699),
    [anon_sym_AMP] = ACTIONS(1699),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1703),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1705),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1811] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7094),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6687),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(3455),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1811),
    [sym_preproc_endregion] = STATE(1811),
    [sym_preproc_line] = STATE(1811),
    [sym_preproc_pragma] = STATE(1811),
    [sym_preproc_nullable] = STATE(1811),
    [sym_preproc_error] = STATE(1811),
    [sym_preproc_define] = STATE(1811),
    [sym_preproc_undef] = STATE(1811),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(2909),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1669),
    [anon_sym_TILDE] = ACTIONS(1669),
    [anon_sym_PLUS_PLUS] = ACTIONS(1669),
    [anon_sym_DASH_DASH] = ACTIONS(1669),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1667),
    [anon_sym_DASH] = ACTIONS(1667),
    [anon_sym_STAR] = ACTIONS(1701),
    [anon_sym_CARET] = ACTIONS(1669),
    [anon_sym_AMP] = ACTIONS(1669),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1812] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5762),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1812),
    [sym_preproc_endregion] = STATE(1812),
    [sym_preproc_line] = STATE(1812),
    [sym_preproc_pragma] = STATE(1812),
    [sym_preproc_nullable] = STATE(1812),
    [sym_preproc_error] = STATE(1812),
    [sym_preproc_define] = STATE(1812),
    [sym_preproc_undef] = STATE(1812),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1813] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6918),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7066),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(3557),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4423),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7383),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9203),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1813),
    [sym_preproc_endregion] = STATE(1813),
    [sym_preproc_line] = STATE(1813),
    [sym_preproc_pragma] = STATE(1813),
    [sym_preproc_nullable] = STATE(1813),
    [sym_preproc_error] = STATE(1813),
    [sym_preproc_define] = STATE(1813),
    [sym_preproc_undef] = STATE(1813),
    [aux_sym_class_declaration_repeat1] = STATE(3817),
    [aux_sym_lambda_expression_repeat1] = STATE(4152),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1905),
    [anon_sym_ref] = ACTIONS(1907),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1221),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1911),
    [anon_sym_TILDE] = ACTIONS(1911),
    [anon_sym_PLUS_PLUS] = ACTIONS(1911),
    [anon_sym_DASH_DASH] = ACTIONS(1911),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1909),
    [anon_sym_DASH] = ACTIONS(1909),
    [anon_sym_STAR] = ACTIONS(1913),
    [anon_sym_CARET] = ACTIONS(1911),
    [anon_sym_AMP] = ACTIONS(1911),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1915),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1917),
    [anon_sym_DOT_DOT] = ACTIONS(1919),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1814] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7094),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6063),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1814),
    [sym_preproc_endregion] = STATE(1814),
    [sym_preproc_line] = STATE(1814),
    [sym_preproc_pragma] = STATE(1814),
    [sym_preproc_nullable] = STATE(1814),
    [sym_preproc_error] = STATE(1814),
    [sym_preproc_define] = STATE(1814),
    [sym_preproc_undef] = STATE(1814),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1669),
    [anon_sym_TILDE] = ACTIONS(1669),
    [anon_sym_PLUS_PLUS] = ACTIONS(1669),
    [anon_sym_DASH_DASH] = ACTIONS(1669),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1667),
    [anon_sym_DASH] = ACTIONS(1667),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1669),
    [anon_sym_AMP] = ACTIONS(1669),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1815] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6896),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2944),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7094),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6709),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(3191),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1815),
    [sym_preproc_endregion] = STATE(1815),
    [sym_preproc_line] = STATE(1815),
    [sym_preproc_pragma] = STATE(1815),
    [sym_preproc_nullable] = STATE(1815),
    [sym_preproc_error] = STATE(1815),
    [sym_preproc_define] = STATE(1815),
    [sym_preproc_undef] = STATE(1815),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(2915),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1669),
    [anon_sym_TILDE] = ACTIONS(1669),
    [anon_sym_PLUS_PLUS] = ACTIONS(1669),
    [anon_sym_DASH_DASH] = ACTIONS(1669),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1667),
    [anon_sym_DASH] = ACTIONS(1667),
    [anon_sym_STAR] = ACTIONS(1841),
    [anon_sym_CARET] = ACTIONS(1669),
    [anon_sym_AMP] = ACTIONS(1669),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1816] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7094),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6065),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1816),
    [sym_preproc_endregion] = STATE(1816),
    [sym_preproc_line] = STATE(1816),
    [sym_preproc_pragma] = STATE(1816),
    [sym_preproc_nullable] = STATE(1816),
    [sym_preproc_error] = STATE(1816),
    [sym_preproc_define] = STATE(1816),
    [sym_preproc_undef] = STATE(1816),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1669),
    [anon_sym_TILDE] = ACTIONS(1669),
    [anon_sym_PLUS_PLUS] = ACTIONS(1669),
    [anon_sym_DASH_DASH] = ACTIONS(1669),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1667),
    [anon_sym_DASH] = ACTIONS(1667),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1669),
    [anon_sym_AMP] = ACTIONS(1669),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1817] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6961),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5420),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9849),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1817),
    [sym_preproc_endregion] = STATE(1817),
    [sym_preproc_line] = STATE(1817),
    [sym_preproc_pragma] = STATE(1817),
    [sym_preproc_nullable] = STATE(1817),
    [sym_preproc_error] = STATE(1817),
    [sym_preproc_define] = STATE(1817),
    [sym_preproc_undef] = STATE(1817),
    [aux_sym_class_declaration_repeat1] = STATE(3841),
    [aux_sym_lambda_expression_repeat1] = STATE(4283),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1459),
    [anon_sym_ref] = ACTIONS(1461),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1465),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1467),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1469),
    [anon_sym_DOT_DOT] = ACTIONS(1471),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1818] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6896),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2944),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6952),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(3849),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4248),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7396),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9160),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1818),
    [sym_preproc_endregion] = STATE(1818),
    [sym_preproc_line] = STATE(1818),
    [sym_preproc_pragma] = STATE(1818),
    [sym_preproc_nullable] = STATE(1818),
    [sym_preproc_error] = STATE(1818),
    [sym_preproc_define] = STATE(1818),
    [sym_preproc_undef] = STATE(1818),
    [aux_sym_class_declaration_repeat1] = STATE(3795),
    [aux_sym_lambda_expression_repeat1] = STATE(4144),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1831),
    [anon_sym_ref] = ACTIONS(1833),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1835),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1839),
    [anon_sym_TILDE] = ACTIONS(1839),
    [anon_sym_PLUS_PLUS] = ACTIONS(1839),
    [anon_sym_DASH_DASH] = ACTIONS(1839),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1837),
    [anon_sym_DASH] = ACTIONS(1837),
    [anon_sym_STAR] = ACTIONS(1841),
    [anon_sym_CARET] = ACTIONS(1839),
    [anon_sym_AMP] = ACTIONS(1839),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1843),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1845),
    [anon_sym_DOT_DOT] = ACTIONS(1847),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1819] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6874),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2968),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7094),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6709),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(3191),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1819),
    [sym_preproc_endregion] = STATE(1819),
    [sym_preproc_line] = STATE(1819),
    [sym_preproc_pragma] = STATE(1819),
    [sym_preproc_nullable] = STATE(1819),
    [sym_preproc_error] = STATE(1819),
    [sym_preproc_define] = STATE(1819),
    [sym_preproc_undef] = STATE(1819),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(2915),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1669),
    [anon_sym_TILDE] = ACTIONS(1669),
    [anon_sym_PLUS_PLUS] = ACTIONS(1669),
    [anon_sym_DASH_DASH] = ACTIONS(1669),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1667),
    [anon_sym_DASH] = ACTIONS(1667),
    [anon_sym_STAR] = ACTIONS(1787),
    [anon_sym_CARET] = ACTIONS(1669),
    [anon_sym_AMP] = ACTIONS(1669),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1820] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6549),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1820),
    [sym_preproc_endregion] = STATE(1820),
    [sym_preproc_line] = STATE(1820),
    [sym_preproc_pragma] = STATE(1820),
    [sym_preproc_nullable] = STATE(1820),
    [sym_preproc_error] = STATE(1820),
    [sym_preproc_define] = STATE(1820),
    [sym_preproc_undef] = STATE(1820),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1821] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6874),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2968),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6941),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(3849),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4214),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7412),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9154),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1821),
    [sym_preproc_endregion] = STATE(1821),
    [sym_preproc_line] = STATE(1821),
    [sym_preproc_pragma] = STATE(1821),
    [sym_preproc_nullable] = STATE(1821),
    [sym_preproc_error] = STATE(1821),
    [sym_preproc_define] = STATE(1821),
    [sym_preproc_undef] = STATE(1821),
    [aux_sym_class_declaration_repeat1] = STATE(3798),
    [aux_sym_lambda_expression_repeat1] = STATE(4162),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1777),
    [anon_sym_ref] = ACTIONS(1779),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1781),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1785),
    [anon_sym_TILDE] = ACTIONS(1785),
    [anon_sym_PLUS_PLUS] = ACTIONS(1785),
    [anon_sym_DASH_DASH] = ACTIONS(1785),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_STAR] = ACTIONS(1787),
    [anon_sym_CARET] = ACTIONS(1785),
    [anon_sym_AMP] = ACTIONS(1785),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1789),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1791),
    [anon_sym_DOT_DOT] = ACTIONS(1793),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1822] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6910),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2957),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7089),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5089),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(3796),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7395),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9374),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1822),
    [sym_preproc_endregion] = STATE(1822),
    [sym_preproc_line] = STATE(1822),
    [sym_preproc_pragma] = STATE(1822),
    [sym_preproc_nullable] = STATE(1822),
    [sym_preproc_error] = STATE(1822),
    [sym_preproc_define] = STATE(1822),
    [sym_preproc_undef] = STATE(1822),
    [aux_sym_class_declaration_repeat1] = STATE(3839),
    [aux_sym_lambda_expression_repeat1] = STATE(4209),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2139),
    [anon_sym_ref] = ACTIONS(2141),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1799),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2145),
    [anon_sym_TILDE] = ACTIONS(2145),
    [anon_sym_PLUS_PLUS] = ACTIONS(2145),
    [anon_sym_DASH_DASH] = ACTIONS(2145),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2143),
    [anon_sym_DASH] = ACTIONS(2143),
    [anon_sym_STAR] = ACTIONS(1805),
    [anon_sym_CARET] = ACTIONS(2145),
    [anon_sym_AMP] = ACTIONS(2145),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2147),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2149),
    [anon_sym_DOT_DOT] = ACTIONS(2151),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1823] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6911),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6992),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5041),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(3829),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7391),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9246),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1823),
    [sym_preproc_endregion] = STATE(1823),
    [sym_preproc_line] = STATE(1823),
    [sym_preproc_pragma] = STATE(1823),
    [sym_preproc_nullable] = STATE(1823),
    [sym_preproc_error] = STATE(1823),
    [sym_preproc_define] = STATE(1823),
    [sym_preproc_undef] = STATE(1823),
    [aux_sym_class_declaration_repeat1] = STATE(3800),
    [aux_sym_lambda_expression_repeat1] = STATE(4089),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1323),
    [anon_sym_ref] = ACTIONS(1325),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1145),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1329),
    [anon_sym_TILDE] = ACTIONS(1329),
    [anon_sym_PLUS_PLUS] = ACTIONS(1329),
    [anon_sym_DASH_DASH] = ACTIONS(1329),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1327),
    [anon_sym_DASH] = ACTIONS(1327),
    [anon_sym_STAR] = ACTIONS(1331),
    [anon_sym_CARET] = ACTIONS(1329),
    [anon_sym_AMP] = ACTIONS(1329),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1333),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1335),
    [anon_sym_DOT_DOT] = ACTIONS(1337),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1824] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6913),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7094),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6709),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(3191),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1824),
    [sym_preproc_endregion] = STATE(1824),
    [sym_preproc_line] = STATE(1824),
    [sym_preproc_pragma] = STATE(1824),
    [sym_preproc_nullable] = STATE(1824),
    [sym_preproc_error] = STATE(1824),
    [sym_preproc_define] = STATE(1824),
    [sym_preproc_undef] = STATE(1824),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(2915),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1669),
    [anon_sym_TILDE] = ACTIONS(1669),
    [anon_sym_PLUS_PLUS] = ACTIONS(1669),
    [anon_sym_DASH_DASH] = ACTIONS(1669),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1667),
    [anon_sym_DASH] = ACTIONS(1667),
    [anon_sym_STAR] = ACTIONS(1569),
    [anon_sym_CARET] = ACTIONS(1669),
    [anon_sym_AMP] = ACTIONS(1669),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1825] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6465),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1825),
    [sym_preproc_endregion] = STATE(1825),
    [sym_preproc_line] = STATE(1825),
    [sym_preproc_pragma] = STATE(1825),
    [sym_preproc_nullable] = STATE(1825),
    [sym_preproc_error] = STATE(1825),
    [sym_preproc_define] = STATE(1825),
    [sym_preproc_undef] = STATE(1825),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1826] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4308),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1826),
    [sym_preproc_endregion] = STATE(1826),
    [sym_preproc_line] = STATE(1826),
    [sym_preproc_pragma] = STATE(1826),
    [sym_preproc_nullable] = STATE(1826),
    [sym_preproc_error] = STATE(1826),
    [sym_preproc_define] = STATE(1826),
    [sym_preproc_undef] = STATE(1826),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1827] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7094),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(3014),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1827),
    [sym_preproc_endregion] = STATE(1827),
    [sym_preproc_line] = STATE(1827),
    [sym_preproc_pragma] = STATE(1827),
    [sym_preproc_nullable] = STATE(1827),
    [sym_preproc_error] = STATE(1827),
    [sym_preproc_define] = STATE(1827),
    [sym_preproc_undef] = STATE(1827),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1669),
    [anon_sym_TILDE] = ACTIONS(1669),
    [anon_sym_PLUS_PLUS] = ACTIONS(1669),
    [anon_sym_DASH_DASH] = ACTIONS(1669),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1667),
    [anon_sym_DASH] = ACTIONS(1667),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1669),
    [anon_sym_AMP] = ACTIONS(1669),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1828] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6464),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1828),
    [sym_preproc_endregion] = STATE(1828),
    [sym_preproc_line] = STATE(1828),
    [sym_preproc_pragma] = STATE(1828),
    [sym_preproc_nullable] = STATE(1828),
    [sym_preproc_error] = STATE(1828),
    [sym_preproc_define] = STATE(1828),
    [sym_preproc_undef] = STATE(1828),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1829] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6898),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2940),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6925),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6409),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4498),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7403),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(8973),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1829),
    [sym_preproc_endregion] = STATE(1829),
    [sym_preproc_line] = STATE(1829),
    [sym_preproc_pragma] = STATE(1829),
    [sym_preproc_nullable] = STATE(1829),
    [sym_preproc_error] = STATE(1829),
    [sym_preproc_define] = STATE(1829),
    [sym_preproc_undef] = STATE(1829),
    [aux_sym_class_declaration_repeat1] = STATE(3830),
    [aux_sym_lambda_expression_repeat1] = STATE(4194),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2153),
    [anon_sym_ref] = ACTIONS(2155),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2157),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2161),
    [anon_sym_TILDE] = ACTIONS(2161),
    [anon_sym_PLUS_PLUS] = ACTIONS(2161),
    [anon_sym_DASH_DASH] = ACTIONS(2161),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2159),
    [anon_sym_DASH] = ACTIONS(2159),
    [anon_sym_STAR] = ACTIONS(2163),
    [anon_sym_CARET] = ACTIONS(2161),
    [anon_sym_AMP] = ACTIONS(2161),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2165),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2167),
    [anon_sym_DOT_DOT] = ACTIONS(2169),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1830] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6913),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7000),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(3849),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4181),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7384),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9143),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1830),
    [sym_preproc_endregion] = STATE(1830),
    [sym_preproc_line] = STATE(1830),
    [sym_preproc_pragma] = STATE(1830),
    [sym_preproc_nullable] = STATE(1830),
    [sym_preproc_error] = STATE(1830),
    [sym_preproc_define] = STATE(1830),
    [sym_preproc_undef] = STATE(1830),
    [aux_sym_class_declaration_repeat1] = STATE(3814),
    [aux_sym_lambda_expression_repeat1] = STATE(4171),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1561),
    [anon_sym_ref] = ACTIONS(1563),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1145),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(1567),
    [anon_sym_PLUS_PLUS] = ACTIONS(1567),
    [anon_sym_DASH_DASH] = ACTIONS(1567),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1565),
    [anon_sym_DASH] = ACTIONS(1565),
    [anon_sym_STAR] = ACTIONS(1569),
    [anon_sym_CARET] = ACTIONS(1567),
    [anon_sym_AMP] = ACTIONS(1567),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1571),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1573),
    [anon_sym_DOT_DOT] = ACTIONS(1575),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1831] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6918),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7126),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4767),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(3736),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7377),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9441),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1831),
    [sym_preproc_endregion] = STATE(1831),
    [sym_preproc_line] = STATE(1831),
    [sym_preproc_pragma] = STATE(1831),
    [sym_preproc_nullable] = STATE(1831),
    [sym_preproc_error] = STATE(1831),
    [sym_preproc_define] = STATE(1831),
    [sym_preproc_undef] = STATE(1831),
    [aux_sym_class_declaration_repeat1] = STATE(3848),
    [aux_sym_lambda_expression_repeat1] = STATE(4242),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1213),
    [anon_sym_ref] = ACTIONS(1215),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1221),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1227),
    [anon_sym_TILDE] = ACTIONS(1227),
    [anon_sym_PLUS_PLUS] = ACTIONS(1227),
    [anon_sym_DASH_DASH] = ACTIONS(1227),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1225),
    [anon_sym_DASH] = ACTIONS(1225),
    [anon_sym_STAR] = ACTIONS(1231),
    [anon_sym_CARET] = ACTIONS(1227),
    [anon_sym_AMP] = ACTIONS(1227),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1239),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1241),
    [anon_sym_DOT_DOT] = ACTIONS(1243),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1832] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6462),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1832),
    [sym_preproc_endregion] = STATE(1832),
    [sym_preproc_line] = STATE(1832),
    [sym_preproc_pragma] = STATE(1832),
    [sym_preproc_nullable] = STATE(1832),
    [sym_preproc_error] = STATE(1832),
    [sym_preproc_define] = STATE(1832),
    [sym_preproc_undef] = STATE(1832),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1833] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6914),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2882),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6963),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(3826),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4002),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7386),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9254),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1833),
    [sym_preproc_endregion] = STATE(1833),
    [sym_preproc_line] = STATE(1833),
    [sym_preproc_pragma] = STATE(1833),
    [sym_preproc_nullable] = STATE(1833),
    [sym_preproc_error] = STATE(1833),
    [sym_preproc_define] = STATE(1833),
    [sym_preproc_undef] = STATE(1833),
    [aux_sym_class_declaration_repeat1] = STATE(3797),
    [aux_sym_lambda_expression_repeat1] = STATE(4081),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1727),
    [anon_sym_ref] = ACTIONS(1729),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1713),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1733),
    [anon_sym_TILDE] = ACTIONS(1733),
    [anon_sym_PLUS_PLUS] = ACTIONS(1733),
    [anon_sym_DASH_DASH] = ACTIONS(1733),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1731),
    [anon_sym_DASH] = ACTIONS(1731),
    [anon_sym_STAR] = ACTIONS(1735),
    [anon_sym_CARET] = ACTIONS(1733),
    [anon_sym_AMP] = ACTIONS(1733),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1737),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1739),
    [anon_sym_DOT_DOT] = ACTIONS(1741),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1834] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6605),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1834),
    [sym_preproc_endregion] = STATE(1834),
    [sym_preproc_line] = STATE(1834),
    [sym_preproc_pragma] = STATE(1834),
    [sym_preproc_nullable] = STATE(1834),
    [sym_preproc_error] = STATE(1834),
    [sym_preproc_define] = STATE(1834),
    [sym_preproc_undef] = STATE(1834),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1835] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6911),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6992),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5029),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(3829),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7391),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9246),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1835),
    [sym_preproc_endregion] = STATE(1835),
    [sym_preproc_line] = STATE(1835),
    [sym_preproc_pragma] = STATE(1835),
    [sym_preproc_nullable] = STATE(1835),
    [sym_preproc_error] = STATE(1835),
    [sym_preproc_define] = STATE(1835),
    [sym_preproc_undef] = STATE(1835),
    [aux_sym_class_declaration_repeat1] = STATE(3800),
    [aux_sym_lambda_expression_repeat1] = STATE(4089),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1323),
    [anon_sym_ref] = ACTIONS(1325),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1145),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1329),
    [anon_sym_TILDE] = ACTIONS(1329),
    [anon_sym_PLUS_PLUS] = ACTIONS(1329),
    [anon_sym_DASH_DASH] = ACTIONS(1329),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1327),
    [anon_sym_DASH] = ACTIONS(1327),
    [anon_sym_STAR] = ACTIONS(1331),
    [anon_sym_CARET] = ACTIONS(1329),
    [anon_sym_AMP] = ACTIONS(1329),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1333),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1335),
    [anon_sym_DOT_DOT] = ACTIONS(1337),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1836] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6914),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2882),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6963),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5339),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4002),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7386),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9254),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1836),
    [sym_preproc_endregion] = STATE(1836),
    [sym_preproc_line] = STATE(1836),
    [sym_preproc_pragma] = STATE(1836),
    [sym_preproc_nullable] = STATE(1836),
    [sym_preproc_error] = STATE(1836),
    [sym_preproc_define] = STATE(1836),
    [sym_preproc_undef] = STATE(1836),
    [aux_sym_class_declaration_repeat1] = STATE(3797),
    [aux_sym_lambda_expression_repeat1] = STATE(4081),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1727),
    [anon_sym_ref] = ACTIONS(1729),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1713),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1733),
    [anon_sym_TILDE] = ACTIONS(1733),
    [anon_sym_PLUS_PLUS] = ACTIONS(1733),
    [anon_sym_DASH_DASH] = ACTIONS(1733),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1731),
    [anon_sym_DASH] = ACTIONS(1731),
    [anon_sym_STAR] = ACTIONS(1735),
    [anon_sym_CARET] = ACTIONS(1733),
    [anon_sym_AMP] = ACTIONS(1733),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1737),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1739),
    [anon_sym_DOT_DOT] = ACTIONS(1741),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1837] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6606),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1837),
    [sym_preproc_endregion] = STATE(1837),
    [sym_preproc_line] = STATE(1837),
    [sym_preproc_pragma] = STATE(1837),
    [sym_preproc_nullable] = STATE(1837),
    [sym_preproc_error] = STATE(1837),
    [sym_preproc_define] = STATE(1837),
    [sym_preproc_undef] = STATE(1837),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1838] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6914),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2882),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6963),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5337),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4002),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7386),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9254),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1838),
    [sym_preproc_endregion] = STATE(1838),
    [sym_preproc_line] = STATE(1838),
    [sym_preproc_pragma] = STATE(1838),
    [sym_preproc_nullable] = STATE(1838),
    [sym_preproc_error] = STATE(1838),
    [sym_preproc_define] = STATE(1838),
    [sym_preproc_undef] = STATE(1838),
    [aux_sym_class_declaration_repeat1] = STATE(3797),
    [aux_sym_lambda_expression_repeat1] = STATE(4081),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1727),
    [anon_sym_ref] = ACTIONS(1729),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1713),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1733),
    [anon_sym_TILDE] = ACTIONS(1733),
    [anon_sym_PLUS_PLUS] = ACTIONS(1733),
    [anon_sym_DASH_DASH] = ACTIONS(1733),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1731),
    [anon_sym_DASH] = ACTIONS(1731),
    [anon_sym_STAR] = ACTIONS(1735),
    [anon_sym_CARET] = ACTIONS(1733),
    [anon_sym_AMP] = ACTIONS(1733),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1737),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1739),
    [anon_sym_DOT_DOT] = ACTIONS(1741),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1839] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6614),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1839),
    [sym_preproc_endregion] = STATE(1839),
    [sym_preproc_line] = STATE(1839),
    [sym_preproc_pragma] = STATE(1839),
    [sym_preproc_nullable] = STATE(1839),
    [sym_preproc_error] = STATE(1839),
    [sym_preproc_define] = STATE(1839),
    [sym_preproc_undef] = STATE(1839),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1840] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6914),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2882),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6963),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5336),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4002),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7386),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9254),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1840),
    [sym_preproc_endregion] = STATE(1840),
    [sym_preproc_line] = STATE(1840),
    [sym_preproc_pragma] = STATE(1840),
    [sym_preproc_nullable] = STATE(1840),
    [sym_preproc_error] = STATE(1840),
    [sym_preproc_define] = STATE(1840),
    [sym_preproc_undef] = STATE(1840),
    [aux_sym_class_declaration_repeat1] = STATE(3797),
    [aux_sym_lambda_expression_repeat1] = STATE(4081),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1727),
    [anon_sym_ref] = ACTIONS(1729),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1713),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1733),
    [anon_sym_TILDE] = ACTIONS(1733),
    [anon_sym_PLUS_PLUS] = ACTIONS(1733),
    [anon_sym_DASH_DASH] = ACTIONS(1733),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1731),
    [anon_sym_DASH] = ACTIONS(1731),
    [anon_sym_STAR] = ACTIONS(1735),
    [anon_sym_CARET] = ACTIONS(1733),
    [anon_sym_AMP] = ACTIONS(1733),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1737),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1739),
    [anon_sym_DOT_DOT] = ACTIONS(1741),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1841] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6594),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1841),
    [sym_preproc_endregion] = STATE(1841),
    [sym_preproc_line] = STATE(1841),
    [sym_preproc_pragma] = STATE(1841),
    [sym_preproc_nullable] = STATE(1841),
    [sym_preproc_error] = STATE(1841),
    [sym_preproc_define] = STATE(1841),
    [sym_preproc_undef] = STATE(1841),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1842] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6625),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1842),
    [sym_preproc_endregion] = STATE(1842),
    [sym_preproc_line] = STATE(1842),
    [sym_preproc_pragma] = STATE(1842),
    [sym_preproc_nullable] = STATE(1842),
    [sym_preproc_error] = STATE(1842),
    [sym_preproc_define] = STATE(1842),
    [sym_preproc_undef] = STATE(1842),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1843] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7094),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4308),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1843),
    [sym_preproc_endregion] = STATE(1843),
    [sym_preproc_line] = STATE(1843),
    [sym_preproc_pragma] = STATE(1843),
    [sym_preproc_nullable] = STATE(1843),
    [sym_preproc_error] = STATE(1843),
    [sym_preproc_define] = STATE(1843),
    [sym_preproc_undef] = STATE(1843),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1669),
    [anon_sym_TILDE] = ACTIONS(1669),
    [anon_sym_PLUS_PLUS] = ACTIONS(1669),
    [anon_sym_DASH_DASH] = ACTIONS(1669),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1667),
    [anon_sym_DASH] = ACTIONS(1667),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1669),
    [anon_sym_AMP] = ACTIONS(1669),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1844] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6626),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1844),
    [sym_preproc_endregion] = STATE(1844),
    [sym_preproc_line] = STATE(1844),
    [sym_preproc_pragma] = STATE(1844),
    [sym_preproc_nullable] = STATE(1844),
    [sym_preproc_error] = STATE(1844),
    [sym_preproc_define] = STATE(1844),
    [sym_preproc_undef] = STATE(1844),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1845] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6961),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5402),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9849),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1845),
    [sym_preproc_endregion] = STATE(1845),
    [sym_preproc_line] = STATE(1845),
    [sym_preproc_pragma] = STATE(1845),
    [sym_preproc_nullable] = STATE(1845),
    [sym_preproc_error] = STATE(1845),
    [sym_preproc_define] = STATE(1845),
    [sym_preproc_undef] = STATE(1845),
    [aux_sym_class_declaration_repeat1] = STATE(3841),
    [aux_sym_lambda_expression_repeat1] = STATE(4283),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1459),
    [anon_sym_ref] = ACTIONS(1461),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1465),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1467),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1469),
    [anon_sym_DOT_DOT] = ACTIONS(1471),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1846] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6961),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4325),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9849),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1846),
    [sym_preproc_endregion] = STATE(1846),
    [sym_preproc_line] = STATE(1846),
    [sym_preproc_pragma] = STATE(1846),
    [sym_preproc_nullable] = STATE(1846),
    [sym_preproc_error] = STATE(1846),
    [sym_preproc_define] = STATE(1846),
    [sym_preproc_undef] = STATE(1846),
    [aux_sym_class_declaration_repeat1] = STATE(3841),
    [aux_sym_lambda_expression_repeat1] = STATE(4283),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1459),
    [anon_sym_ref] = ACTIONS(1461),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1465),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1467),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1469),
    [anon_sym_DOT_DOT] = ACTIONS(1471),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1847] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6914),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2882),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6963),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5334),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4002),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7386),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9254),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1847),
    [sym_preproc_endregion] = STATE(1847),
    [sym_preproc_line] = STATE(1847),
    [sym_preproc_pragma] = STATE(1847),
    [sym_preproc_nullable] = STATE(1847),
    [sym_preproc_error] = STATE(1847),
    [sym_preproc_define] = STATE(1847),
    [sym_preproc_undef] = STATE(1847),
    [aux_sym_class_declaration_repeat1] = STATE(3797),
    [aux_sym_lambda_expression_repeat1] = STATE(4081),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1727),
    [anon_sym_ref] = ACTIONS(1729),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1713),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1733),
    [anon_sym_TILDE] = ACTIONS(1733),
    [anon_sym_PLUS_PLUS] = ACTIONS(1733),
    [anon_sym_DASH_DASH] = ACTIONS(1733),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1731),
    [anon_sym_DASH] = ACTIONS(1731),
    [anon_sym_STAR] = ACTIONS(1735),
    [anon_sym_CARET] = ACTIONS(1733),
    [anon_sym_AMP] = ACTIONS(1733),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1737),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1739),
    [anon_sym_DOT_DOT] = ACTIONS(1741),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1848] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6914),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2882),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6963),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5283),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4002),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7386),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9254),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1848),
    [sym_preproc_endregion] = STATE(1848),
    [sym_preproc_line] = STATE(1848),
    [sym_preproc_pragma] = STATE(1848),
    [sym_preproc_nullable] = STATE(1848),
    [sym_preproc_error] = STATE(1848),
    [sym_preproc_define] = STATE(1848),
    [sym_preproc_undef] = STATE(1848),
    [aux_sym_class_declaration_repeat1] = STATE(3797),
    [aux_sym_lambda_expression_repeat1] = STATE(4081),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1727),
    [anon_sym_ref] = ACTIONS(1729),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1713),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1733),
    [anon_sym_TILDE] = ACTIONS(1733),
    [anon_sym_PLUS_PLUS] = ACTIONS(1733),
    [anon_sym_DASH_DASH] = ACTIONS(1733),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1731),
    [anon_sym_DASH] = ACTIONS(1731),
    [anon_sym_STAR] = ACTIONS(1735),
    [anon_sym_CARET] = ACTIONS(1733),
    [anon_sym_AMP] = ACTIONS(1733),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1737),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1739),
    [anon_sym_DOT_DOT] = ACTIONS(1741),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1849] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6914),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2882),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6963),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5330),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4002),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7386),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9254),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1849),
    [sym_preproc_endregion] = STATE(1849),
    [sym_preproc_line] = STATE(1849),
    [sym_preproc_pragma] = STATE(1849),
    [sym_preproc_nullable] = STATE(1849),
    [sym_preproc_error] = STATE(1849),
    [sym_preproc_define] = STATE(1849),
    [sym_preproc_undef] = STATE(1849),
    [aux_sym_class_declaration_repeat1] = STATE(3797),
    [aux_sym_lambda_expression_repeat1] = STATE(4081),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1727),
    [anon_sym_ref] = ACTIONS(1729),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1713),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1733),
    [anon_sym_TILDE] = ACTIONS(1733),
    [anon_sym_PLUS_PLUS] = ACTIONS(1733),
    [anon_sym_DASH_DASH] = ACTIONS(1733),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1731),
    [anon_sym_DASH] = ACTIONS(1731),
    [anon_sym_STAR] = ACTIONS(1735),
    [anon_sym_CARET] = ACTIONS(1733),
    [anon_sym_AMP] = ACTIONS(1733),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1737),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1739),
    [anon_sym_DOT_DOT] = ACTIONS(1741),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1850] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6914),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2882),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6963),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5329),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4002),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7386),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9254),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1850),
    [sym_preproc_endregion] = STATE(1850),
    [sym_preproc_line] = STATE(1850),
    [sym_preproc_pragma] = STATE(1850),
    [sym_preproc_nullable] = STATE(1850),
    [sym_preproc_error] = STATE(1850),
    [sym_preproc_define] = STATE(1850),
    [sym_preproc_undef] = STATE(1850),
    [aux_sym_class_declaration_repeat1] = STATE(3797),
    [aux_sym_lambda_expression_repeat1] = STATE(4081),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1727),
    [anon_sym_ref] = ACTIONS(1729),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1713),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1733),
    [anon_sym_TILDE] = ACTIONS(1733),
    [anon_sym_PLUS_PLUS] = ACTIONS(1733),
    [anon_sym_DASH_DASH] = ACTIONS(1733),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1731),
    [anon_sym_DASH] = ACTIONS(1731),
    [anon_sym_STAR] = ACTIONS(1735),
    [anon_sym_CARET] = ACTIONS(1733),
    [anon_sym_AMP] = ACTIONS(1733),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1737),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1739),
    [anon_sym_DOT_DOT] = ACTIONS(1741),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1851] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6610),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1851),
    [sym_preproc_endregion] = STATE(1851),
    [sym_preproc_line] = STATE(1851),
    [sym_preproc_pragma] = STATE(1851),
    [sym_preproc_nullable] = STATE(1851),
    [sym_preproc_error] = STATE(1851),
    [sym_preproc_define] = STATE(1851),
    [sym_preproc_undef] = STATE(1851),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1852] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6914),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2882),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6963),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5328),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4002),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7386),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9254),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1852),
    [sym_preproc_endregion] = STATE(1852),
    [sym_preproc_line] = STATE(1852),
    [sym_preproc_pragma] = STATE(1852),
    [sym_preproc_nullable] = STATE(1852),
    [sym_preproc_error] = STATE(1852),
    [sym_preproc_define] = STATE(1852),
    [sym_preproc_undef] = STATE(1852),
    [aux_sym_class_declaration_repeat1] = STATE(3797),
    [aux_sym_lambda_expression_repeat1] = STATE(4081),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1727),
    [anon_sym_ref] = ACTIONS(1729),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1713),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1733),
    [anon_sym_TILDE] = ACTIONS(1733),
    [anon_sym_PLUS_PLUS] = ACTIONS(1733),
    [anon_sym_DASH_DASH] = ACTIONS(1733),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1731),
    [anon_sym_DASH] = ACTIONS(1731),
    [anon_sym_STAR] = ACTIONS(1735),
    [anon_sym_CARET] = ACTIONS(1733),
    [anon_sym_AMP] = ACTIONS(1733),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1737),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1739),
    [anon_sym_DOT_DOT] = ACTIONS(1741),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1853] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6914),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2882),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6963),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5282),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4002),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7386),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9254),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1853),
    [sym_preproc_endregion] = STATE(1853),
    [sym_preproc_line] = STATE(1853),
    [sym_preproc_pragma] = STATE(1853),
    [sym_preproc_nullable] = STATE(1853),
    [sym_preproc_error] = STATE(1853),
    [sym_preproc_define] = STATE(1853),
    [sym_preproc_undef] = STATE(1853),
    [aux_sym_class_declaration_repeat1] = STATE(3797),
    [aux_sym_lambda_expression_repeat1] = STATE(4081),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1727),
    [anon_sym_ref] = ACTIONS(1729),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1713),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1733),
    [anon_sym_TILDE] = ACTIONS(1733),
    [anon_sym_PLUS_PLUS] = ACTIONS(1733),
    [anon_sym_DASH_DASH] = ACTIONS(1733),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1731),
    [anon_sym_DASH] = ACTIONS(1731),
    [anon_sym_STAR] = ACTIONS(1735),
    [anon_sym_CARET] = ACTIONS(1733),
    [anon_sym_AMP] = ACTIONS(1733),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1737),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1739),
    [anon_sym_DOT_DOT] = ACTIONS(1741),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1854] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6914),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2882),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6963),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5281),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4002),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7386),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9254),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1854),
    [sym_preproc_endregion] = STATE(1854),
    [sym_preproc_line] = STATE(1854),
    [sym_preproc_pragma] = STATE(1854),
    [sym_preproc_nullable] = STATE(1854),
    [sym_preproc_error] = STATE(1854),
    [sym_preproc_define] = STATE(1854),
    [sym_preproc_undef] = STATE(1854),
    [aux_sym_class_declaration_repeat1] = STATE(3797),
    [aux_sym_lambda_expression_repeat1] = STATE(4081),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1727),
    [anon_sym_ref] = ACTIONS(1729),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1713),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1733),
    [anon_sym_TILDE] = ACTIONS(1733),
    [anon_sym_PLUS_PLUS] = ACTIONS(1733),
    [anon_sym_DASH_DASH] = ACTIONS(1733),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1731),
    [anon_sym_DASH] = ACTIONS(1731),
    [anon_sym_STAR] = ACTIONS(1735),
    [anon_sym_CARET] = ACTIONS(1733),
    [anon_sym_AMP] = ACTIONS(1733),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1737),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1739),
    [anon_sym_DOT_DOT] = ACTIONS(1741),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1855] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6378),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1855),
    [sym_preproc_endregion] = STATE(1855),
    [sym_preproc_line] = STATE(1855),
    [sym_preproc_pragma] = STATE(1855),
    [sym_preproc_nullable] = STATE(1855),
    [sym_preproc_error] = STATE(1855),
    [sym_preproc_define] = STATE(1855),
    [sym_preproc_undef] = STATE(1855),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1856] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6914),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2882),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6963),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5280),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4002),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7386),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9254),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1856),
    [sym_preproc_endregion] = STATE(1856),
    [sym_preproc_line] = STATE(1856),
    [sym_preproc_pragma] = STATE(1856),
    [sym_preproc_nullable] = STATE(1856),
    [sym_preproc_error] = STATE(1856),
    [sym_preproc_define] = STATE(1856),
    [sym_preproc_undef] = STATE(1856),
    [aux_sym_class_declaration_repeat1] = STATE(3797),
    [aux_sym_lambda_expression_repeat1] = STATE(4081),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1727),
    [anon_sym_ref] = ACTIONS(1729),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1713),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1733),
    [anon_sym_TILDE] = ACTIONS(1733),
    [anon_sym_PLUS_PLUS] = ACTIONS(1733),
    [anon_sym_DASH_DASH] = ACTIONS(1733),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1731),
    [anon_sym_DASH] = ACTIONS(1731),
    [anon_sym_STAR] = ACTIONS(1735),
    [anon_sym_CARET] = ACTIONS(1733),
    [anon_sym_AMP] = ACTIONS(1733),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1737),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1739),
    [anon_sym_DOT_DOT] = ACTIONS(1741),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1857] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6911),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6992),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(3822),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(3829),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7391),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9246),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1857),
    [sym_preproc_endregion] = STATE(1857),
    [sym_preproc_line] = STATE(1857),
    [sym_preproc_pragma] = STATE(1857),
    [sym_preproc_nullable] = STATE(1857),
    [sym_preproc_error] = STATE(1857),
    [sym_preproc_define] = STATE(1857),
    [sym_preproc_undef] = STATE(1857),
    [aux_sym_class_declaration_repeat1] = STATE(3800),
    [aux_sym_lambda_expression_repeat1] = STATE(4089),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1323),
    [anon_sym_ref] = ACTIONS(1325),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1145),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1329),
    [anon_sym_TILDE] = ACTIONS(1329),
    [anon_sym_PLUS_PLUS] = ACTIONS(1329),
    [anon_sym_DASH_DASH] = ACTIONS(1329),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1327),
    [anon_sym_DASH] = ACTIONS(1327),
    [anon_sym_STAR] = ACTIONS(1331),
    [anon_sym_CARET] = ACTIONS(1329),
    [anon_sym_AMP] = ACTIONS(1329),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1333),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1335),
    [anon_sym_DOT_DOT] = ACTIONS(1337),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1858] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6911),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6992),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5027),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(3829),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7391),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9246),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1858),
    [sym_preproc_endregion] = STATE(1858),
    [sym_preproc_line] = STATE(1858),
    [sym_preproc_pragma] = STATE(1858),
    [sym_preproc_nullable] = STATE(1858),
    [sym_preproc_error] = STATE(1858),
    [sym_preproc_define] = STATE(1858),
    [sym_preproc_undef] = STATE(1858),
    [aux_sym_class_declaration_repeat1] = STATE(3800),
    [aux_sym_lambda_expression_repeat1] = STATE(4089),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1323),
    [anon_sym_ref] = ACTIONS(1325),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1145),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1329),
    [anon_sym_TILDE] = ACTIONS(1329),
    [anon_sym_PLUS_PLUS] = ACTIONS(1329),
    [anon_sym_DASH_DASH] = ACTIONS(1329),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1327),
    [anon_sym_DASH] = ACTIONS(1327),
    [anon_sym_STAR] = ACTIONS(1331),
    [anon_sym_CARET] = ACTIONS(1329),
    [anon_sym_AMP] = ACTIONS(1329),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1333),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1335),
    [anon_sym_DOT_DOT] = ACTIONS(1337),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1859] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7094),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(3014),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1859),
    [sym_preproc_endregion] = STATE(1859),
    [sym_preproc_line] = STATE(1859),
    [sym_preproc_pragma] = STATE(1859),
    [sym_preproc_nullable] = STATE(1859),
    [sym_preproc_error] = STATE(1859),
    [sym_preproc_define] = STATE(1859),
    [sym_preproc_undef] = STATE(1859),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1669),
    [anon_sym_TILDE] = ACTIONS(1669),
    [anon_sym_PLUS_PLUS] = ACTIONS(1669),
    [anon_sym_DASH_DASH] = ACTIONS(1669),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1667),
    [anon_sym_DASH] = ACTIONS(1667),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1669),
    [anon_sym_AMP] = ACTIONS(1669),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1860] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6501),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1860),
    [sym_preproc_endregion] = STATE(1860),
    [sym_preproc_line] = STATE(1860),
    [sym_preproc_pragma] = STATE(1860),
    [sym_preproc_nullable] = STATE(1860),
    [sym_preproc_error] = STATE(1860),
    [sym_preproc_define] = STATE(1860),
    [sym_preproc_undef] = STATE(1860),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1861] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6368),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1861),
    [sym_preproc_endregion] = STATE(1861),
    [sym_preproc_line] = STATE(1861),
    [sym_preproc_pragma] = STATE(1861),
    [sym_preproc_nullable] = STATE(1861),
    [sym_preproc_error] = STATE(1861),
    [sym_preproc_define] = STATE(1861),
    [sym_preproc_undef] = STATE(1861),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1862] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6961),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6345),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9849),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1862),
    [sym_preproc_endregion] = STATE(1862),
    [sym_preproc_line] = STATE(1862),
    [sym_preproc_pragma] = STATE(1862),
    [sym_preproc_nullable] = STATE(1862),
    [sym_preproc_error] = STATE(1862),
    [sym_preproc_define] = STATE(1862),
    [sym_preproc_undef] = STATE(1862),
    [aux_sym_class_declaration_repeat1] = STATE(3841),
    [aux_sym_lambda_expression_repeat1] = STATE(4283),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1459),
    [anon_sym_ref] = ACTIONS(1461),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1465),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1467),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1469),
    [anon_sym_DOT_DOT] = ACTIONS(1471),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1863] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6908),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2874),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7082),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5598),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4189),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7388),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9466),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1863),
    [sym_preproc_endregion] = STATE(1863),
    [sym_preproc_line] = STATE(1863),
    [sym_preproc_pragma] = STATE(1863),
    [sym_preproc_nullable] = STATE(1863),
    [sym_preproc_error] = STATE(1863),
    [sym_preproc_define] = STATE(1863),
    [sym_preproc_undef] = STATE(1863),
    [aux_sym_class_declaration_repeat1] = STATE(3825),
    [aux_sym_lambda_expression_repeat1] = STATE(4178),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1743),
    [anon_sym_ref] = ACTIONS(1745),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1505),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1749),
    [anon_sym_TILDE] = ACTIONS(1749),
    [anon_sym_PLUS_PLUS] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1749),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1747),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_CARET] = ACTIONS(1749),
    [anon_sym_AMP] = ACTIONS(1749),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1753),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1755),
    [anon_sym_DOT_DOT] = ACTIONS(1757),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1864] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6343),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1864),
    [sym_preproc_endregion] = STATE(1864),
    [sym_preproc_line] = STATE(1864),
    [sym_preproc_pragma] = STATE(1864),
    [sym_preproc_nullable] = STATE(1864),
    [sym_preproc_error] = STATE(1864),
    [sym_preproc_define] = STATE(1864),
    [sym_preproc_undef] = STATE(1864),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1865] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6330),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1865),
    [sym_preproc_endregion] = STATE(1865),
    [sym_preproc_line] = STATE(1865),
    [sym_preproc_pragma] = STATE(1865),
    [sym_preproc_nullable] = STATE(1865),
    [sym_preproc_error] = STATE(1865),
    [sym_preproc_define] = STATE(1865),
    [sym_preproc_undef] = STATE(1865),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1866] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6326),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1866),
    [sym_preproc_endregion] = STATE(1866),
    [sym_preproc_line] = STATE(1866),
    [sym_preproc_pragma] = STATE(1866),
    [sym_preproc_nullable] = STATE(1866),
    [sym_preproc_error] = STATE(1866),
    [sym_preproc_define] = STATE(1866),
    [sym_preproc_undef] = STATE(1866),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1867] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6908),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2874),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7082),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5590),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4189),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7388),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9466),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1867),
    [sym_preproc_endregion] = STATE(1867),
    [sym_preproc_line] = STATE(1867),
    [sym_preproc_pragma] = STATE(1867),
    [sym_preproc_nullable] = STATE(1867),
    [sym_preproc_error] = STATE(1867),
    [sym_preproc_define] = STATE(1867),
    [sym_preproc_undef] = STATE(1867),
    [aux_sym_class_declaration_repeat1] = STATE(3825),
    [aux_sym_lambda_expression_repeat1] = STATE(4178),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1743),
    [anon_sym_ref] = ACTIONS(1745),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1505),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1749),
    [anon_sym_TILDE] = ACTIONS(1749),
    [anon_sym_PLUS_PLUS] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1749),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1747),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_CARET] = ACTIONS(1749),
    [anon_sym_AMP] = ACTIONS(1749),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1753),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1755),
    [anon_sym_DOT_DOT] = ACTIONS(1757),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1868] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5749),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1868),
    [sym_preproc_endregion] = STATE(1868),
    [sym_preproc_line] = STATE(1868),
    [sym_preproc_pragma] = STATE(1868),
    [sym_preproc_nullable] = STATE(1868),
    [sym_preproc_error] = STATE(1868),
    [sym_preproc_define] = STATE(1868),
    [sym_preproc_undef] = STATE(1868),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1869] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5567),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1869),
    [sym_preproc_endregion] = STATE(1869),
    [sym_preproc_line] = STATE(1869),
    [sym_preproc_pragma] = STATE(1869),
    [sym_preproc_nullable] = STATE(1869),
    [sym_preproc_error] = STATE(1869),
    [sym_preproc_define] = STATE(1869),
    [sym_preproc_undef] = STATE(1869),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1870] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6908),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2874),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7082),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(3901),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4189),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7388),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9466),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1870),
    [sym_preproc_endregion] = STATE(1870),
    [sym_preproc_line] = STATE(1870),
    [sym_preproc_pragma] = STATE(1870),
    [sym_preproc_nullable] = STATE(1870),
    [sym_preproc_error] = STATE(1870),
    [sym_preproc_define] = STATE(1870),
    [sym_preproc_undef] = STATE(1870),
    [aux_sym_class_declaration_repeat1] = STATE(3825),
    [aux_sym_lambda_expression_repeat1] = STATE(4178),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1743),
    [anon_sym_ref] = ACTIONS(1745),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1505),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1749),
    [anon_sym_TILDE] = ACTIONS(1749),
    [anon_sym_PLUS_PLUS] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1749),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1747),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_CARET] = ACTIONS(1749),
    [anon_sym_AMP] = ACTIONS(1749),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1753),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1755),
    [anon_sym_DOT_DOT] = ACTIONS(1757),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1871] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6908),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2874),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7082),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5580),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4189),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7388),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9466),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1871),
    [sym_preproc_endregion] = STATE(1871),
    [sym_preproc_line] = STATE(1871),
    [sym_preproc_pragma] = STATE(1871),
    [sym_preproc_nullable] = STATE(1871),
    [sym_preproc_error] = STATE(1871),
    [sym_preproc_define] = STATE(1871),
    [sym_preproc_undef] = STATE(1871),
    [aux_sym_class_declaration_repeat1] = STATE(3825),
    [aux_sym_lambda_expression_repeat1] = STATE(4178),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1743),
    [anon_sym_ref] = ACTIONS(1745),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1505),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1749),
    [anon_sym_TILDE] = ACTIONS(1749),
    [anon_sym_PLUS_PLUS] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1749),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1747),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_CARET] = ACTIONS(1749),
    [anon_sym_AMP] = ACTIONS(1749),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1753),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1755),
    [anon_sym_DOT_DOT] = ACTIONS(1757),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1872] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5753),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1872),
    [sym_preproc_endregion] = STATE(1872),
    [sym_preproc_line] = STATE(1872),
    [sym_preproc_pragma] = STATE(1872),
    [sym_preproc_nullable] = STATE(1872),
    [sym_preproc_error] = STATE(1872),
    [sym_preproc_define] = STATE(1872),
    [sym_preproc_undef] = STATE(1872),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1873] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6894),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2955),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7046),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(3565),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(3786),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7408),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9363),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1873),
    [sym_preproc_endregion] = STATE(1873),
    [sym_preproc_line] = STATE(1873),
    [sym_preproc_pragma] = STATE(1873),
    [sym_preproc_nullable] = STATE(1873),
    [sym_preproc_error] = STATE(1873),
    [sym_preproc_define] = STATE(1873),
    [sym_preproc_undef] = STATE(1873),
    [aux_sym_class_declaration_repeat1] = STATE(3811),
    [aux_sym_lambda_expression_repeat1] = STATE(4149),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2069),
    [anon_sym_ref] = ACTIONS(2071),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1853),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(2075),
    [anon_sym_TILDE] = ACTIONS(2075),
    [anon_sym_PLUS_PLUS] = ACTIONS(2075),
    [anon_sym_DASH_DASH] = ACTIONS(2075),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2073),
    [anon_sym_DASH] = ACTIONS(2073),
    [anon_sym_STAR] = ACTIONS(1859),
    [anon_sym_CARET] = ACTIONS(2075),
    [anon_sym_AMP] = ACTIONS(2075),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2077),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2079),
    [anon_sym_DOT_DOT] = ACTIONS(2081),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1874] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6281),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1874),
    [sym_preproc_endregion] = STATE(1874),
    [sym_preproc_line] = STATE(1874),
    [sym_preproc_pragma] = STATE(1874),
    [sym_preproc_nullable] = STATE(1874),
    [sym_preproc_error] = STATE(1874),
    [sym_preproc_define] = STATE(1874),
    [sym_preproc_undef] = STATE(1874),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1875] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6894),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2955),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7046),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5004),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(3786),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7408),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9363),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1875),
    [sym_preproc_endregion] = STATE(1875),
    [sym_preproc_line] = STATE(1875),
    [sym_preproc_pragma] = STATE(1875),
    [sym_preproc_nullable] = STATE(1875),
    [sym_preproc_error] = STATE(1875),
    [sym_preproc_define] = STATE(1875),
    [sym_preproc_undef] = STATE(1875),
    [aux_sym_class_declaration_repeat1] = STATE(3811),
    [aux_sym_lambda_expression_repeat1] = STATE(4149),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2069),
    [anon_sym_ref] = ACTIONS(2071),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1853),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(2075),
    [anon_sym_TILDE] = ACTIONS(2075),
    [anon_sym_PLUS_PLUS] = ACTIONS(2075),
    [anon_sym_DASH_DASH] = ACTIONS(2075),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2073),
    [anon_sym_DASH] = ACTIONS(2073),
    [anon_sym_STAR] = ACTIONS(1859),
    [anon_sym_CARET] = ACTIONS(2075),
    [anon_sym_AMP] = ACTIONS(2075),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2077),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2079),
    [anon_sym_DOT_DOT] = ACTIONS(2081),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1876] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6894),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2955),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7046),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5000),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(3786),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7408),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9363),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1876),
    [sym_preproc_endregion] = STATE(1876),
    [sym_preproc_line] = STATE(1876),
    [sym_preproc_pragma] = STATE(1876),
    [sym_preproc_nullable] = STATE(1876),
    [sym_preproc_error] = STATE(1876),
    [sym_preproc_define] = STATE(1876),
    [sym_preproc_undef] = STATE(1876),
    [aux_sym_class_declaration_repeat1] = STATE(3811),
    [aux_sym_lambda_expression_repeat1] = STATE(4149),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2069),
    [anon_sym_ref] = ACTIONS(2071),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1853),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(2075),
    [anon_sym_TILDE] = ACTIONS(2075),
    [anon_sym_PLUS_PLUS] = ACTIONS(2075),
    [anon_sym_DASH_DASH] = ACTIONS(2075),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2073),
    [anon_sym_DASH] = ACTIONS(2073),
    [anon_sym_STAR] = ACTIONS(1859),
    [anon_sym_CARET] = ACTIONS(2075),
    [anon_sym_AMP] = ACTIONS(2075),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2077),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2079),
    [anon_sym_DOT_DOT] = ACTIONS(2081),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1877] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6894),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2955),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7046),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4990),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(3786),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7408),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9363),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1877),
    [sym_preproc_endregion] = STATE(1877),
    [sym_preproc_line] = STATE(1877),
    [sym_preproc_pragma] = STATE(1877),
    [sym_preproc_nullable] = STATE(1877),
    [sym_preproc_error] = STATE(1877),
    [sym_preproc_define] = STATE(1877),
    [sym_preproc_undef] = STATE(1877),
    [aux_sym_class_declaration_repeat1] = STATE(3811),
    [aux_sym_lambda_expression_repeat1] = STATE(4149),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2069),
    [anon_sym_ref] = ACTIONS(2071),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1853),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(2075),
    [anon_sym_TILDE] = ACTIONS(2075),
    [anon_sym_PLUS_PLUS] = ACTIONS(2075),
    [anon_sym_DASH_DASH] = ACTIONS(2075),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2073),
    [anon_sym_DASH] = ACTIONS(2073),
    [anon_sym_STAR] = ACTIONS(1859),
    [anon_sym_CARET] = ACTIONS(2075),
    [anon_sym_AMP] = ACTIONS(2075),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2077),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2079),
    [anon_sym_DOT_DOT] = ACTIONS(2081),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1878] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6894),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2955),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7046),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4962),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(3786),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7408),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9363),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1878),
    [sym_preproc_endregion] = STATE(1878),
    [sym_preproc_line] = STATE(1878),
    [sym_preproc_pragma] = STATE(1878),
    [sym_preproc_nullable] = STATE(1878),
    [sym_preproc_error] = STATE(1878),
    [sym_preproc_define] = STATE(1878),
    [sym_preproc_undef] = STATE(1878),
    [aux_sym_class_declaration_repeat1] = STATE(3811),
    [aux_sym_lambda_expression_repeat1] = STATE(4149),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2069),
    [anon_sym_ref] = ACTIONS(2071),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1853),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(2075),
    [anon_sym_TILDE] = ACTIONS(2075),
    [anon_sym_PLUS_PLUS] = ACTIONS(2075),
    [anon_sym_DASH_DASH] = ACTIONS(2075),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2073),
    [anon_sym_DASH] = ACTIONS(2073),
    [anon_sym_STAR] = ACTIONS(1859),
    [anon_sym_CARET] = ACTIONS(2075),
    [anon_sym_AMP] = ACTIONS(2075),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2077),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2079),
    [anon_sym_DOT_DOT] = ACTIONS(2081),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1879] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6894),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2955),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7046),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4963),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(3786),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7408),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9363),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1879),
    [sym_preproc_endregion] = STATE(1879),
    [sym_preproc_line] = STATE(1879),
    [sym_preproc_pragma] = STATE(1879),
    [sym_preproc_nullable] = STATE(1879),
    [sym_preproc_error] = STATE(1879),
    [sym_preproc_define] = STATE(1879),
    [sym_preproc_undef] = STATE(1879),
    [aux_sym_class_declaration_repeat1] = STATE(3811),
    [aux_sym_lambda_expression_repeat1] = STATE(4149),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2069),
    [anon_sym_ref] = ACTIONS(2071),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1853),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(2075),
    [anon_sym_TILDE] = ACTIONS(2075),
    [anon_sym_PLUS_PLUS] = ACTIONS(2075),
    [anon_sym_DASH_DASH] = ACTIONS(2075),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2073),
    [anon_sym_DASH] = ACTIONS(2073),
    [anon_sym_STAR] = ACTIONS(1859),
    [anon_sym_CARET] = ACTIONS(2075),
    [anon_sym_AMP] = ACTIONS(2075),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2077),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2079),
    [anon_sym_DOT_DOT] = ACTIONS(2081),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1880] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6894),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2955),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7046),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5003),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(3786),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7408),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9363),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1880),
    [sym_preproc_endregion] = STATE(1880),
    [sym_preproc_line] = STATE(1880),
    [sym_preproc_pragma] = STATE(1880),
    [sym_preproc_nullable] = STATE(1880),
    [sym_preproc_error] = STATE(1880),
    [sym_preproc_define] = STATE(1880),
    [sym_preproc_undef] = STATE(1880),
    [aux_sym_class_declaration_repeat1] = STATE(3811),
    [aux_sym_lambda_expression_repeat1] = STATE(4149),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2069),
    [anon_sym_ref] = ACTIONS(2071),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1853),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(2075),
    [anon_sym_TILDE] = ACTIONS(2075),
    [anon_sym_PLUS_PLUS] = ACTIONS(2075),
    [anon_sym_DASH_DASH] = ACTIONS(2075),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2073),
    [anon_sym_DASH] = ACTIONS(2073),
    [anon_sym_STAR] = ACTIONS(1859),
    [anon_sym_CARET] = ACTIONS(2075),
    [anon_sym_AMP] = ACTIONS(2075),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2077),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2079),
    [anon_sym_DOT_DOT] = ACTIONS(2081),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1881] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6961),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6408),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9849),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1881),
    [sym_preproc_endregion] = STATE(1881),
    [sym_preproc_line] = STATE(1881),
    [sym_preproc_pragma] = STATE(1881),
    [sym_preproc_nullable] = STATE(1881),
    [sym_preproc_error] = STATE(1881),
    [sym_preproc_define] = STATE(1881),
    [sym_preproc_undef] = STATE(1881),
    [aux_sym_class_declaration_repeat1] = STATE(3841),
    [aux_sym_lambda_expression_repeat1] = STATE(4283),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1459),
    [anon_sym_ref] = ACTIONS(1461),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1465),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1467),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1469),
    [anon_sym_DOT_DOT] = ACTIONS(1471),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1882] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6894),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2955),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7046),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5009),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(3786),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7408),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9363),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1882),
    [sym_preproc_endregion] = STATE(1882),
    [sym_preproc_line] = STATE(1882),
    [sym_preproc_pragma] = STATE(1882),
    [sym_preproc_nullable] = STATE(1882),
    [sym_preproc_error] = STATE(1882),
    [sym_preproc_define] = STATE(1882),
    [sym_preproc_undef] = STATE(1882),
    [aux_sym_class_declaration_repeat1] = STATE(3811),
    [aux_sym_lambda_expression_repeat1] = STATE(4149),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2069),
    [anon_sym_ref] = ACTIONS(2071),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1853),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(2075),
    [anon_sym_TILDE] = ACTIONS(2075),
    [anon_sym_PLUS_PLUS] = ACTIONS(2075),
    [anon_sym_DASH_DASH] = ACTIONS(2075),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2073),
    [anon_sym_DASH] = ACTIONS(2073),
    [anon_sym_STAR] = ACTIONS(1859),
    [anon_sym_CARET] = ACTIONS(2075),
    [anon_sym_AMP] = ACTIONS(2075),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2077),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2079),
    [anon_sym_DOT_DOT] = ACTIONS(2081),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1883] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6894),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2955),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7046),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5011),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(3786),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7408),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9363),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1883),
    [sym_preproc_endregion] = STATE(1883),
    [sym_preproc_line] = STATE(1883),
    [sym_preproc_pragma] = STATE(1883),
    [sym_preproc_nullable] = STATE(1883),
    [sym_preproc_error] = STATE(1883),
    [sym_preproc_define] = STATE(1883),
    [sym_preproc_undef] = STATE(1883),
    [aux_sym_class_declaration_repeat1] = STATE(3811),
    [aux_sym_lambda_expression_repeat1] = STATE(4149),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2069),
    [anon_sym_ref] = ACTIONS(2071),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1853),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(2075),
    [anon_sym_TILDE] = ACTIONS(2075),
    [anon_sym_PLUS_PLUS] = ACTIONS(2075),
    [anon_sym_DASH_DASH] = ACTIONS(2075),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2073),
    [anon_sym_DASH] = ACTIONS(2073),
    [anon_sym_STAR] = ACTIONS(1859),
    [anon_sym_CARET] = ACTIONS(2075),
    [anon_sym_AMP] = ACTIONS(2075),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2077),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2079),
    [anon_sym_DOT_DOT] = ACTIONS(2081),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1884] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6894),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2955),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7046),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5014),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(3786),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7408),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9363),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1884),
    [sym_preproc_endregion] = STATE(1884),
    [sym_preproc_line] = STATE(1884),
    [sym_preproc_pragma] = STATE(1884),
    [sym_preproc_nullable] = STATE(1884),
    [sym_preproc_error] = STATE(1884),
    [sym_preproc_define] = STATE(1884),
    [sym_preproc_undef] = STATE(1884),
    [aux_sym_class_declaration_repeat1] = STATE(3811),
    [aux_sym_lambda_expression_repeat1] = STATE(4149),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2069),
    [anon_sym_ref] = ACTIONS(2071),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1853),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(2075),
    [anon_sym_TILDE] = ACTIONS(2075),
    [anon_sym_PLUS_PLUS] = ACTIONS(2075),
    [anon_sym_DASH_DASH] = ACTIONS(2075),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2073),
    [anon_sym_DASH] = ACTIONS(2073),
    [anon_sym_STAR] = ACTIONS(1859),
    [anon_sym_CARET] = ACTIONS(2075),
    [anon_sym_AMP] = ACTIONS(2075),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2077),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2079),
    [anon_sym_DOT_DOT] = ACTIONS(2081),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1885] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6894),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2955),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7046),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5007),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(3786),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7408),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9363),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1885),
    [sym_preproc_endregion] = STATE(1885),
    [sym_preproc_line] = STATE(1885),
    [sym_preproc_pragma] = STATE(1885),
    [sym_preproc_nullable] = STATE(1885),
    [sym_preproc_error] = STATE(1885),
    [sym_preproc_define] = STATE(1885),
    [sym_preproc_undef] = STATE(1885),
    [aux_sym_class_declaration_repeat1] = STATE(3811),
    [aux_sym_lambda_expression_repeat1] = STATE(4149),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2069),
    [anon_sym_ref] = ACTIONS(2071),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1853),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(2075),
    [anon_sym_TILDE] = ACTIONS(2075),
    [anon_sym_PLUS_PLUS] = ACTIONS(2075),
    [anon_sym_DASH_DASH] = ACTIONS(2075),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2073),
    [anon_sym_DASH] = ACTIONS(2073),
    [anon_sym_STAR] = ACTIONS(1859),
    [anon_sym_CARET] = ACTIONS(2075),
    [anon_sym_AMP] = ACTIONS(2075),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2077),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2079),
    [anon_sym_DOT_DOT] = ACTIONS(2081),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1886] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6894),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2955),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7046),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5002),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(3786),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7408),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9363),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1886),
    [sym_preproc_endregion] = STATE(1886),
    [sym_preproc_line] = STATE(1886),
    [sym_preproc_pragma] = STATE(1886),
    [sym_preproc_nullable] = STATE(1886),
    [sym_preproc_error] = STATE(1886),
    [sym_preproc_define] = STATE(1886),
    [sym_preproc_undef] = STATE(1886),
    [aux_sym_class_declaration_repeat1] = STATE(3811),
    [aux_sym_lambda_expression_repeat1] = STATE(4149),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2069),
    [anon_sym_ref] = ACTIONS(2071),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1853),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(2075),
    [anon_sym_TILDE] = ACTIONS(2075),
    [anon_sym_PLUS_PLUS] = ACTIONS(2075),
    [anon_sym_DASH_DASH] = ACTIONS(2075),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2073),
    [anon_sym_DASH] = ACTIONS(2073),
    [anon_sym_STAR] = ACTIONS(1859),
    [anon_sym_CARET] = ACTIONS(2075),
    [anon_sym_AMP] = ACTIONS(2075),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2077),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2079),
    [anon_sym_DOT_DOT] = ACTIONS(2081),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1887] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6287),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1887),
    [sym_preproc_endregion] = STATE(1887),
    [sym_preproc_line] = STATE(1887),
    [sym_preproc_pragma] = STATE(1887),
    [sym_preproc_nullable] = STATE(1887),
    [sym_preproc_error] = STATE(1887),
    [sym_preproc_define] = STATE(1887),
    [sym_preproc_undef] = STATE(1887),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1888] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6305),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1888),
    [sym_preproc_endregion] = STATE(1888),
    [sym_preproc_line] = STATE(1888),
    [sym_preproc_pragma] = STATE(1888),
    [sym_preproc_nullable] = STATE(1888),
    [sym_preproc_error] = STATE(1888),
    [sym_preproc_define] = STATE(1888),
    [sym_preproc_undef] = STATE(1888),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1889] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6961),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6308),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9849),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1889),
    [sym_preproc_endregion] = STATE(1889),
    [sym_preproc_line] = STATE(1889),
    [sym_preproc_pragma] = STATE(1889),
    [sym_preproc_nullable] = STATE(1889),
    [sym_preproc_error] = STATE(1889),
    [sym_preproc_define] = STATE(1889),
    [sym_preproc_undef] = STATE(1889),
    [aux_sym_class_declaration_repeat1] = STATE(3841),
    [aux_sym_lambda_expression_repeat1] = STATE(4283),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1459),
    [anon_sym_ref] = ACTIONS(1461),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1465),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1467),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1469),
    [anon_sym_DOT_DOT] = ACTIONS(1471),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1890] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6894),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2955),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7046),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4966),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(3786),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7408),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9363),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1890),
    [sym_preproc_endregion] = STATE(1890),
    [sym_preproc_line] = STATE(1890),
    [sym_preproc_pragma] = STATE(1890),
    [sym_preproc_nullable] = STATE(1890),
    [sym_preproc_error] = STATE(1890),
    [sym_preproc_define] = STATE(1890),
    [sym_preproc_undef] = STATE(1890),
    [aux_sym_class_declaration_repeat1] = STATE(3811),
    [aux_sym_lambda_expression_repeat1] = STATE(4149),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2069),
    [anon_sym_ref] = ACTIONS(2071),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1853),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(2075),
    [anon_sym_TILDE] = ACTIONS(2075),
    [anon_sym_PLUS_PLUS] = ACTIONS(2075),
    [anon_sym_DASH_DASH] = ACTIONS(2075),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2073),
    [anon_sym_DASH] = ACTIONS(2073),
    [anon_sym_STAR] = ACTIONS(1859),
    [anon_sym_CARET] = ACTIONS(2075),
    [anon_sym_AMP] = ACTIONS(2075),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2077),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2079),
    [anon_sym_DOT_DOT] = ACTIONS(2081),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1891] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5752),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1891),
    [sym_preproc_endregion] = STATE(1891),
    [sym_preproc_line] = STATE(1891),
    [sym_preproc_pragma] = STATE(1891),
    [sym_preproc_nullable] = STATE(1891),
    [sym_preproc_error] = STATE(1891),
    [sym_preproc_define] = STATE(1891),
    [sym_preproc_undef] = STATE(1891),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1892] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6879),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2935),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7096),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5562),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4288),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7379),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9175),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(1892),
    [sym_preproc_endregion] = STATE(1892),
    [sym_preproc_line] = STATE(1892),
    [sym_preproc_pragma] = STATE(1892),
    [sym_preproc_nullable] = STATE(1892),
    [sym_preproc_error] = STATE(1892),
    [sym_preproc_define] = STATE(1892),
    [sym_preproc_undef] = STATE(1892),
    [aux_sym_class_declaration_repeat1] = STATE(3816),
    [aux_sym_lambda_expression_repeat1] = STATE(4119),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1867),
    [anon_sym_ref] = ACTIONS(1869),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1871),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1875),
    [anon_sym_TILDE] = ACTIONS(1875),
    [anon_sym_PLUS_PLUS] = ACTIONS(1875),
    [anon_sym_DASH_DASH] = ACTIONS(1875),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1873),
    [anon_sym_DASH] = ACTIONS(1873),
    [anon_sym_STAR] = ACTIONS(1877),
    [anon_sym_CARET] = ACTIONS(1875),
    [anon_sym_AMP] = ACTIONS(1875),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1879),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1881),
    [anon_sym_DOT_DOT] = ACTIONS(1883),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [1893] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5751),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1893),
    [sym_preproc_endregion] = STATE(1893),
    [sym_preproc_line] = STATE(1893),
    [sym_preproc_pragma] = STATE(1893),
    [sym_preproc_nullable] = STATE(1893),
    [sym_preproc_error] = STATE(1893),
    [sym_preproc_define] = STATE(1893),
    [sym_preproc_undef] = STATE(1893),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1894] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6341),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1894),
    [sym_preproc_endregion] = STATE(1894),
    [sym_preproc_line] = STATE(1894),
    [sym_preproc_pragma] = STATE(1894),
    [sym_preproc_nullable] = STATE(1894),
    [sym_preproc_error] = STATE(1894),
    [sym_preproc_define] = STATE(1894),
    [sym_preproc_undef] = STATE(1894),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1895] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6894),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2955),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7046),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4977),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(3786),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7408),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9363),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1895),
    [sym_preproc_endregion] = STATE(1895),
    [sym_preproc_line] = STATE(1895),
    [sym_preproc_pragma] = STATE(1895),
    [sym_preproc_nullable] = STATE(1895),
    [sym_preproc_error] = STATE(1895),
    [sym_preproc_define] = STATE(1895),
    [sym_preproc_undef] = STATE(1895),
    [aux_sym_class_declaration_repeat1] = STATE(3811),
    [aux_sym_lambda_expression_repeat1] = STATE(4149),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2069),
    [anon_sym_ref] = ACTIONS(2071),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1853),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(2075),
    [anon_sym_TILDE] = ACTIONS(2075),
    [anon_sym_PLUS_PLUS] = ACTIONS(2075),
    [anon_sym_DASH_DASH] = ACTIONS(2075),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2073),
    [anon_sym_DASH] = ACTIONS(2073),
    [anon_sym_STAR] = ACTIONS(1859),
    [anon_sym_CARET] = ACTIONS(2075),
    [anon_sym_AMP] = ACTIONS(2075),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2077),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2079),
    [anon_sym_DOT_DOT] = ACTIONS(2081),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1896] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6359),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1896),
    [sym_preproc_endregion] = STATE(1896),
    [sym_preproc_line] = STATE(1896),
    [sym_preproc_pragma] = STATE(1896),
    [sym_preproc_nullable] = STATE(1896),
    [sym_preproc_error] = STATE(1896),
    [sym_preproc_define] = STATE(1896),
    [sym_preproc_undef] = STATE(1896),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1897] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5750),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1897),
    [sym_preproc_endregion] = STATE(1897),
    [sym_preproc_line] = STATE(1897),
    [sym_preproc_pragma] = STATE(1897),
    [sym_preproc_nullable] = STATE(1897),
    [sym_preproc_error] = STATE(1897),
    [sym_preproc_define] = STATE(1897),
    [sym_preproc_undef] = STATE(1897),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1898] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6894),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2955),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7046),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(3556),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(3786),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7408),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9363),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1898),
    [sym_preproc_endregion] = STATE(1898),
    [sym_preproc_line] = STATE(1898),
    [sym_preproc_pragma] = STATE(1898),
    [sym_preproc_nullable] = STATE(1898),
    [sym_preproc_error] = STATE(1898),
    [sym_preproc_define] = STATE(1898),
    [sym_preproc_undef] = STATE(1898),
    [aux_sym_class_declaration_repeat1] = STATE(3811),
    [aux_sym_lambda_expression_repeat1] = STATE(4149),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2069),
    [anon_sym_ref] = ACTIONS(2071),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1853),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(2075),
    [anon_sym_TILDE] = ACTIONS(2075),
    [anon_sym_PLUS_PLUS] = ACTIONS(2075),
    [anon_sym_DASH_DASH] = ACTIONS(2075),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2073),
    [anon_sym_DASH] = ACTIONS(2073),
    [anon_sym_STAR] = ACTIONS(1859),
    [anon_sym_CARET] = ACTIONS(2075),
    [anon_sym_AMP] = ACTIONS(2075),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2077),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2079),
    [anon_sym_DOT_DOT] = ACTIONS(2081),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1899] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6894),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2955),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7046),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4967),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(3786),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7408),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9363),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1899),
    [sym_preproc_endregion] = STATE(1899),
    [sym_preproc_line] = STATE(1899),
    [sym_preproc_pragma] = STATE(1899),
    [sym_preproc_nullable] = STATE(1899),
    [sym_preproc_error] = STATE(1899),
    [sym_preproc_define] = STATE(1899),
    [sym_preproc_undef] = STATE(1899),
    [aux_sym_class_declaration_repeat1] = STATE(3811),
    [aux_sym_lambda_expression_repeat1] = STATE(4149),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2069),
    [anon_sym_ref] = ACTIONS(2071),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1853),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(2075),
    [anon_sym_TILDE] = ACTIONS(2075),
    [anon_sym_PLUS_PLUS] = ACTIONS(2075),
    [anon_sym_DASH_DASH] = ACTIONS(2075),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2073),
    [anon_sym_DASH] = ACTIONS(2073),
    [anon_sym_STAR] = ACTIONS(1859),
    [anon_sym_CARET] = ACTIONS(2075),
    [anon_sym_AMP] = ACTIONS(2075),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2077),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2079),
    [anon_sym_DOT_DOT] = ACTIONS(2081),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1900] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5748),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1900),
    [sym_preproc_endregion] = STATE(1900),
    [sym_preproc_line] = STATE(1900),
    [sym_preproc_pragma] = STATE(1900),
    [sym_preproc_nullable] = STATE(1900),
    [sym_preproc_error] = STATE(1900),
    [sym_preproc_define] = STATE(1900),
    [sym_preproc_undef] = STATE(1900),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1901] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6372),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1901),
    [sym_preproc_endregion] = STATE(1901),
    [sym_preproc_line] = STATE(1901),
    [sym_preproc_pragma] = STATE(1901),
    [sym_preproc_nullable] = STATE(1901),
    [sym_preproc_error] = STATE(1901),
    [sym_preproc_define] = STATE(1901),
    [sym_preproc_undef] = STATE(1901),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1902] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5746),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1902),
    [sym_preproc_endregion] = STATE(1902),
    [sym_preproc_line] = STATE(1902),
    [sym_preproc_pragma] = STATE(1902),
    [sym_preproc_nullable] = STATE(1902),
    [sym_preproc_error] = STATE(1902),
    [sym_preproc_define] = STATE(1902),
    [sym_preproc_undef] = STATE(1902),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1903] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6898),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2940),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6925),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6518),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4498),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7403),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(8973),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1903),
    [sym_preproc_endregion] = STATE(1903),
    [sym_preproc_line] = STATE(1903),
    [sym_preproc_pragma] = STATE(1903),
    [sym_preproc_nullable] = STATE(1903),
    [sym_preproc_error] = STATE(1903),
    [sym_preproc_define] = STATE(1903),
    [sym_preproc_undef] = STATE(1903),
    [aux_sym_class_declaration_repeat1] = STATE(3830),
    [aux_sym_lambda_expression_repeat1] = STATE(4194),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2153),
    [anon_sym_ref] = ACTIONS(2155),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2157),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2161),
    [anon_sym_TILDE] = ACTIONS(2161),
    [anon_sym_PLUS_PLUS] = ACTIONS(2161),
    [anon_sym_DASH_DASH] = ACTIONS(2161),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2159),
    [anon_sym_DASH] = ACTIONS(2159),
    [anon_sym_STAR] = ACTIONS(2163),
    [anon_sym_CARET] = ACTIONS(2161),
    [anon_sym_AMP] = ACTIONS(2161),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(2165),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2167),
    [anon_sym_DOT_DOT] = ACTIONS(2169),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1904] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6961),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6611),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9849),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1904),
    [sym_preproc_endregion] = STATE(1904),
    [sym_preproc_line] = STATE(1904),
    [sym_preproc_pragma] = STATE(1904),
    [sym_preproc_nullable] = STATE(1904),
    [sym_preproc_error] = STATE(1904),
    [sym_preproc_define] = STATE(1904),
    [sym_preproc_undef] = STATE(1904),
    [aux_sym_class_declaration_repeat1] = STATE(3841),
    [aux_sym_lambda_expression_repeat1] = STATE(4283),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1459),
    [anon_sym_ref] = ACTIONS(1461),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1465),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1467),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1469),
    [anon_sym_DOT_DOT] = ACTIONS(1471),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1905] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6348),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1905),
    [sym_preproc_endregion] = STATE(1905),
    [sym_preproc_line] = STATE(1905),
    [sym_preproc_pragma] = STATE(1905),
    [sym_preproc_nullable] = STATE(1905),
    [sym_preproc_error] = STATE(1905),
    [sym_preproc_define] = STATE(1905),
    [sym_preproc_undef] = STATE(1905),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1906] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6908),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2874),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7082),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(3922),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4189),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7388),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9466),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1906),
    [sym_preproc_endregion] = STATE(1906),
    [sym_preproc_line] = STATE(1906),
    [sym_preproc_pragma] = STATE(1906),
    [sym_preproc_nullable] = STATE(1906),
    [sym_preproc_error] = STATE(1906),
    [sym_preproc_define] = STATE(1906),
    [sym_preproc_undef] = STATE(1906),
    [aux_sym_class_declaration_repeat1] = STATE(3825),
    [aux_sym_lambda_expression_repeat1] = STATE(4178),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1743),
    [anon_sym_ref] = ACTIONS(1745),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1505),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1749),
    [anon_sym_TILDE] = ACTIONS(1749),
    [anon_sym_PLUS_PLUS] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1749),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1747),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_CARET] = ACTIONS(1749),
    [anon_sym_AMP] = ACTIONS(1749),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1753),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1755),
    [anon_sym_DOT_DOT] = ACTIONS(1757),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1907] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3921),
    [sym__name] = STATE(6919),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2868),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(7068),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5348),
    [sym_non_lvalue_expression] = STATE(5735),
    [sym_lvalue_expression] = STATE(4323),
    [sym__expression_statement_expression] = STATE(5733),
    [sym_assignment_expression] = STATE(5734),
    [sym_binary_expression] = STATE(5733),
    [sym_postfix_unary_expression] = STATE(5734),
    [sym_prefix_unary_expression] = STATE(5734),
    [sym__pointer_indirection_expression] = STATE(3911),
    [sym_query_expression] = STATE(5733),
    [sym_from_clause] = STATE(7393),
    [sym_conditional_expression] = STATE(5733),
    [sym_conditional_access_expression] = STATE(5733),
    [sym_as_expression] = STATE(5733),
    [sym_is_expression] = STATE(5733),
    [sym_is_pattern_expression] = STATE(5733),
    [sym_cast_expression] = STATE(5733),
    [sym_checked_expression] = STATE(5733),
    [sym_invocation_expression] = STATE(5734),
    [sym_switch_expression] = STATE(5733),
    [sym_await_expression] = STATE(5734),
    [sym_throw_expression] = STATE(5733),
    [sym_element_access_expression] = STATE(3911),
    [sym_interpolated_string_expression] = STATE(5733),
    [sym_member_access_expression] = STATE(3911),
    [sym_object_creation_expression] = STATE(5734),
    [sym_parenthesized_expression] = STATE(5734),
    [sym__parenthesized_lvalue_expression] = STATE(3911),
    [sym_lambda_expression] = STATE(5733),
    [sym__lambda_parameters] = STATE(9932),
    [sym_array_creation_expression] = STATE(5733),
    [sym_anonymous_method_expression] = STATE(5733),
    [sym_anonymous_object_creation_expression] = STATE(5733),
    [sym_implicit_array_creation_expression] = STATE(5733),
    [sym_implicit_object_creation_expression] = STATE(5733),
    [sym_implicit_stackalloc_expression] = STATE(5733),
    [sym_initializer_expression] = STATE(5733),
    [sym_default_expression] = STATE(5733),
    [sym_with_expression] = STATE(5733),
    [sym_sizeof_expression] = STATE(5733),
    [sym_typeof_expression] = STATE(5733),
    [sym_makeref_expression] = STATE(5733),
    [sym_ref_expression] = STATE(5733),
    [sym_reftype_expression] = STATE(5733),
    [sym_refvalue_expression] = STATE(5733),
    [sym_stackalloc_expression] = STATE(5733),
    [sym_range_expression] = STATE(5733),
    [sym_tuple_expression] = STATE(3911),
    [sym_literal] = STATE(5733),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2798),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(5733),
    [sym_preproc_region] = STATE(1907),
    [sym_preproc_endregion] = STATE(1907),
    [sym_preproc_line] = STATE(1907),
    [sym_preproc_pragma] = STATE(1907),
    [sym_preproc_nullable] = STATE(1907),
    [sym_preproc_error] = STATE(1907),
    [sym_preproc_define] = STATE(1907),
    [sym_preproc_undef] = STATE(1907),
    [aux_sym_class_declaration_repeat1] = STATE(3831),
    [aux_sym_lambda_expression_repeat1] = STATE(4227),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_LPAREN] = ACTIONS(1577),
    [anon_sym_ref] = ACTIONS(1579),
    [anon_sym_LBRACE] = ACTIONS(1377),
    [anon_sym_delegate] = ACTIONS(1379),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1381),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1583),
    [anon_sym_TILDE] = ACTIONS(1583),
    [anon_sym_PLUS_PLUS] = ACTIONS(1583),
    [anon_sym_DASH_DASH] = ACTIONS(1583),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1581),
    [anon_sym_DASH] = ACTIONS(1581),
    [anon_sym_STAR] = ACTIONS(1391),
    [anon_sym_CARET] = ACTIONS(1583),
    [anon_sym_AMP] = ACTIONS(1583),
    [anon_sym_this] = ACTIONS(1393),
    [anon_sym_scoped] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1397),
    [sym_predefined_type] = ACTIONS(1399),
    [anon_sym_unchecked] = ACTIONS(1383),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1585),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1587),
    [anon_sym_DOT_DOT] = ACTIONS(1589),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_stackalloc] = ACTIONS(1413),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(1419),
    [anon_sym___reftype] = ACTIONS(1421),
    [anon_sym___refvalue] = ACTIONS(1423),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
  },
  [1908] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6908),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2874),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7082),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5491),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4189),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7388),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9466),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1908),
    [sym_preproc_endregion] = STATE(1908),
    [sym_preproc_line] = STATE(1908),
    [sym_preproc_pragma] = STATE(1908),
    [sym_preproc_nullable] = STATE(1908),
    [sym_preproc_error] = STATE(1908),
    [sym_preproc_define] = STATE(1908),
    [sym_preproc_undef] = STATE(1908),
    [aux_sym_class_declaration_repeat1] = STATE(3825),
    [aux_sym_lambda_expression_repeat1] = STATE(4178),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1743),
    [anon_sym_ref] = ACTIONS(1745),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1505),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1749),
    [anon_sym_TILDE] = ACTIONS(1749),
    [anon_sym_PLUS_PLUS] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1749),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1747),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_CARET] = ACTIONS(1749),
    [anon_sym_AMP] = ACTIONS(1749),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1753),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1755),
    [anon_sym_DOT_DOT] = ACTIONS(1757),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1909] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5738),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1909),
    [sym_preproc_endregion] = STATE(1909),
    [sym_preproc_line] = STATE(1909),
    [sym_preproc_pragma] = STATE(1909),
    [sym_preproc_nullable] = STATE(1909),
    [sym_preproc_error] = STATE(1909),
    [sym_preproc_define] = STATE(1909),
    [sym_preproc_undef] = STATE(1909),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1910] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6908),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2874),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7082),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5490),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4189),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7388),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9466),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1910),
    [sym_preproc_endregion] = STATE(1910),
    [sym_preproc_line] = STATE(1910),
    [sym_preproc_pragma] = STATE(1910),
    [sym_preproc_nullable] = STATE(1910),
    [sym_preproc_error] = STATE(1910),
    [sym_preproc_define] = STATE(1910),
    [sym_preproc_undef] = STATE(1910),
    [aux_sym_class_declaration_repeat1] = STATE(3825),
    [aux_sym_lambda_expression_repeat1] = STATE(4178),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1743),
    [anon_sym_ref] = ACTIONS(1745),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1505),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1749),
    [anon_sym_TILDE] = ACTIONS(1749),
    [anon_sym_PLUS_PLUS] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1749),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1747),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_CARET] = ACTIONS(1749),
    [anon_sym_AMP] = ACTIONS(1749),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1753),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1755),
    [anon_sym_DOT_DOT] = ACTIONS(1757),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1911] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6908),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2874),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7082),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5489),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4189),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7388),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9466),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1911),
    [sym_preproc_endregion] = STATE(1911),
    [sym_preproc_line] = STATE(1911),
    [sym_preproc_pragma] = STATE(1911),
    [sym_preproc_nullable] = STATE(1911),
    [sym_preproc_error] = STATE(1911),
    [sym_preproc_define] = STATE(1911),
    [sym_preproc_undef] = STATE(1911),
    [aux_sym_class_declaration_repeat1] = STATE(3825),
    [aux_sym_lambda_expression_repeat1] = STATE(4178),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1743),
    [anon_sym_ref] = ACTIONS(1745),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1505),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1749),
    [anon_sym_TILDE] = ACTIONS(1749),
    [anon_sym_PLUS_PLUS] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1749),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1747),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_CARET] = ACTIONS(1749),
    [anon_sym_AMP] = ACTIONS(1749),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1753),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1755),
    [anon_sym_DOT_DOT] = ACTIONS(1757),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1912] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5737),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1912),
    [sym_preproc_endregion] = STATE(1912),
    [sym_preproc_line] = STATE(1912),
    [sym_preproc_pragma] = STATE(1912),
    [sym_preproc_nullable] = STATE(1912),
    [sym_preproc_error] = STATE(1912),
    [sym_preproc_define] = STATE(1912),
    [sym_preproc_undef] = STATE(1912),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1913] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5736),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1913),
    [sym_preproc_endregion] = STATE(1913),
    [sym_preproc_line] = STATE(1913),
    [sym_preproc_pragma] = STATE(1913),
    [sym_preproc_nullable] = STATE(1913),
    [sym_preproc_error] = STATE(1913),
    [sym_preproc_define] = STATE(1913),
    [sym_preproc_undef] = STATE(1913),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1914] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5397),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1914),
    [sym_preproc_endregion] = STATE(1914),
    [sym_preproc_line] = STATE(1914),
    [sym_preproc_pragma] = STATE(1914),
    [sym_preproc_nullable] = STATE(1914),
    [sym_preproc_error] = STATE(1914),
    [sym_preproc_define] = STATE(1914),
    [sym_preproc_undef] = STATE(1914),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1915] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6904),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7009),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5346),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4008),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7381),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9536),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1915),
    [sym_preproc_endregion] = STATE(1915),
    [sym_preproc_line] = STATE(1915),
    [sym_preproc_pragma] = STATE(1915),
    [sym_preproc_nullable] = STATE(1915),
    [sym_preproc_error] = STATE(1915),
    [sym_preproc_define] = STATE(1915),
    [sym_preproc_undef] = STATE(1915),
    [aux_sym_class_declaration_repeat1] = STATE(3832),
    [aux_sym_lambda_expression_repeat1] = STATE(4090),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1485),
    [anon_sym_ref] = ACTIONS(1487),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1221),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1491),
    [anon_sym_TILDE] = ACTIONS(1491),
    [anon_sym_PLUS_PLUS] = ACTIONS(1491),
    [anon_sym_DASH_DASH] = ACTIONS(1491),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1489),
    [anon_sym_DASH] = ACTIONS(1489),
    [anon_sym_STAR] = ACTIONS(1493),
    [anon_sym_CARET] = ACTIONS(1491),
    [anon_sym_AMP] = ACTIONS(1491),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1495),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1497),
    [anon_sym_DOT_DOT] = ACTIONS(1499),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1916] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6980),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4308),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4482),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9438),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1916),
    [sym_preproc_endregion] = STATE(1916),
    [sym_preproc_line] = STATE(1916),
    [sym_preproc_pragma] = STATE(1916),
    [sym_preproc_nullable] = STATE(1916),
    [sym_preproc_error] = STATE(1916),
    [sym_preproc_define] = STATE(1916),
    [sym_preproc_undef] = STATE(1916),
    [aux_sym_class_declaration_repeat1] = STATE(3801),
    [aux_sym_lambda_expression_repeat1] = STATE(4134),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1993),
    [anon_sym_ref] = ACTIONS(1995),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1999),
    [anon_sym_TILDE] = ACTIONS(1999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1999),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_AMP] = ACTIONS(1999),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1281),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1283),
    [anon_sym_DOT_DOT] = ACTIONS(1285),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1917] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7108),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5889),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4313),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7382),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9733),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1917),
    [sym_preproc_endregion] = STATE(1917),
    [sym_preproc_line] = STATE(1917),
    [sym_preproc_pragma] = STATE(1917),
    [sym_preproc_nullable] = STATE(1917),
    [sym_preproc_error] = STATE(1917),
    [sym_preproc_define] = STATE(1917),
    [sym_preproc_undef] = STATE(1917),
    [aux_sym_class_declaration_repeat1] = STATE(3802),
    [aux_sym_lambda_expression_repeat1] = STATE(4108),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1519),
    [anon_sym_ref] = ACTIONS(1521),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1523),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1529),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1531),
    [anon_sym_DOT_DOT] = ACTIONS(1533),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1918] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4309),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1918),
    [sym_preproc_endregion] = STATE(1918),
    [sym_preproc_line] = STATE(1918),
    [sym_preproc_pragma] = STATE(1918),
    [sym_preproc_nullable] = STATE(1918),
    [sym_preproc_error] = STATE(1918),
    [sym_preproc_define] = STATE(1918),
    [sym_preproc_undef] = STATE(1918),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1919] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6479),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1919),
    [sym_preproc_endregion] = STATE(1919),
    [sym_preproc_line] = STATE(1919),
    [sym_preproc_pragma] = STATE(1919),
    [sym_preproc_nullable] = STATE(1919),
    [sym_preproc_error] = STATE(1919),
    [sym_preproc_define] = STATE(1919),
    [sym_preproc_undef] = STATE(1919),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1920] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6285),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1920),
    [sym_preproc_endregion] = STATE(1920),
    [sym_preproc_line] = STATE(1920),
    [sym_preproc_pragma] = STATE(1920),
    [sym_preproc_nullable] = STATE(1920),
    [sym_preproc_error] = STATE(1920),
    [sym_preproc_define] = STATE(1920),
    [sym_preproc_undef] = STATE(1920),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1921] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6350),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1921),
    [sym_preproc_endregion] = STATE(1921),
    [sym_preproc_line] = STATE(1921),
    [sym_preproc_pragma] = STATE(1921),
    [sym_preproc_nullable] = STATE(1921),
    [sym_preproc_error] = STATE(1921),
    [sym_preproc_define] = STATE(1921),
    [sym_preproc_undef] = STATE(1921),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1922] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6908),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2874),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7082),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5488),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4189),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7388),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9466),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1922),
    [sym_preproc_endregion] = STATE(1922),
    [sym_preproc_line] = STATE(1922),
    [sym_preproc_pragma] = STATE(1922),
    [sym_preproc_nullable] = STATE(1922),
    [sym_preproc_error] = STATE(1922),
    [sym_preproc_define] = STATE(1922),
    [sym_preproc_undef] = STATE(1922),
    [aux_sym_class_declaration_repeat1] = STATE(3825),
    [aux_sym_lambda_expression_repeat1] = STATE(4178),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1743),
    [anon_sym_ref] = ACTIONS(1745),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1505),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1749),
    [anon_sym_TILDE] = ACTIONS(1749),
    [anon_sym_PLUS_PLUS] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1749),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1747),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_CARET] = ACTIONS(1749),
    [anon_sym_AMP] = ACTIONS(1749),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1753),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1755),
    [anon_sym_DOT_DOT] = ACTIONS(1757),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1923] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6098),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1923),
    [sym_preproc_endregion] = STATE(1923),
    [sym_preproc_line] = STATE(1923),
    [sym_preproc_pragma] = STATE(1923),
    [sym_preproc_nullable] = STATE(1923),
    [sym_preproc_error] = STATE(1923),
    [sym_preproc_define] = STATE(1923),
    [sym_preproc_undef] = STATE(1923),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1924] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6647),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1924),
    [sym_preproc_endregion] = STATE(1924),
    [sym_preproc_line] = STATE(1924),
    [sym_preproc_pragma] = STATE(1924),
    [sym_preproc_nullable] = STATE(1924),
    [sym_preproc_error] = STATE(1924),
    [sym_preproc_define] = STATE(1924),
    [sym_preproc_undef] = STATE(1924),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1925] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6095),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1925),
    [sym_preproc_endregion] = STATE(1925),
    [sym_preproc_line] = STATE(1925),
    [sym_preproc_pragma] = STATE(1925),
    [sym_preproc_nullable] = STATE(1925),
    [sym_preproc_error] = STATE(1925),
    [sym_preproc_define] = STATE(1925),
    [sym_preproc_undef] = STATE(1925),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1926] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6908),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2874),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7082),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5487),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4189),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7388),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9466),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1926),
    [sym_preproc_endregion] = STATE(1926),
    [sym_preproc_line] = STATE(1926),
    [sym_preproc_pragma] = STATE(1926),
    [sym_preproc_nullable] = STATE(1926),
    [sym_preproc_error] = STATE(1926),
    [sym_preproc_define] = STATE(1926),
    [sym_preproc_undef] = STATE(1926),
    [aux_sym_class_declaration_repeat1] = STATE(3825),
    [aux_sym_lambda_expression_repeat1] = STATE(4178),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1743),
    [anon_sym_ref] = ACTIONS(1745),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1505),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1749),
    [anon_sym_TILDE] = ACTIONS(1749),
    [anon_sym_PLUS_PLUS] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1749),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1747),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_CARET] = ACTIONS(1749),
    [anon_sym_AMP] = ACTIONS(1749),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1753),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1755),
    [anon_sym_DOT_DOT] = ACTIONS(1757),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1927] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6645),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1927),
    [sym_preproc_endregion] = STATE(1927),
    [sym_preproc_line] = STATE(1927),
    [sym_preproc_pragma] = STATE(1927),
    [sym_preproc_nullable] = STATE(1927),
    [sym_preproc_error] = STATE(1927),
    [sym_preproc_define] = STATE(1927),
    [sym_preproc_undef] = STATE(1927),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1928] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6337),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1928),
    [sym_preproc_endregion] = STATE(1928),
    [sym_preproc_line] = STATE(1928),
    [sym_preproc_pragma] = STATE(1928),
    [sym_preproc_nullable] = STATE(1928),
    [sym_preproc_error] = STATE(1928),
    [sym_preproc_define] = STATE(1928),
    [sym_preproc_undef] = STATE(1928),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1929] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6908),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2874),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7082),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5486),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4189),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7388),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9466),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1929),
    [sym_preproc_endregion] = STATE(1929),
    [sym_preproc_line] = STATE(1929),
    [sym_preproc_pragma] = STATE(1929),
    [sym_preproc_nullable] = STATE(1929),
    [sym_preproc_error] = STATE(1929),
    [sym_preproc_define] = STATE(1929),
    [sym_preproc_undef] = STATE(1929),
    [aux_sym_class_declaration_repeat1] = STATE(3825),
    [aux_sym_lambda_expression_repeat1] = STATE(4178),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1743),
    [anon_sym_ref] = ACTIONS(1745),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1505),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1749),
    [anon_sym_TILDE] = ACTIONS(1749),
    [anon_sym_PLUS_PLUS] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1749),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1747),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_CARET] = ACTIONS(1749),
    [anon_sym_AMP] = ACTIONS(1749),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1753),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1755),
    [anon_sym_DOT_DOT] = ACTIONS(1757),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1930] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6908),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2874),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7082),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5485),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4189),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7388),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9466),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1930),
    [sym_preproc_endregion] = STATE(1930),
    [sym_preproc_line] = STATE(1930),
    [sym_preproc_pragma] = STATE(1930),
    [sym_preproc_nullable] = STATE(1930),
    [sym_preproc_error] = STATE(1930),
    [sym_preproc_define] = STATE(1930),
    [sym_preproc_undef] = STATE(1930),
    [aux_sym_class_declaration_repeat1] = STATE(3825),
    [aux_sym_lambda_expression_repeat1] = STATE(4178),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1743),
    [anon_sym_ref] = ACTIONS(1745),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1505),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1749),
    [anon_sym_TILDE] = ACTIONS(1749),
    [anon_sym_PLUS_PLUS] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1749),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1747),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_CARET] = ACTIONS(1749),
    [anon_sym_AMP] = ACTIONS(1749),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1753),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1755),
    [anon_sym_DOT_DOT] = ACTIONS(1757),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1931] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6967),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5072),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(3858),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7382),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9625),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1931),
    [sym_preproc_endregion] = STATE(1931),
    [sym_preproc_line] = STATE(1931),
    [sym_preproc_pragma] = STATE(1931),
    [sym_preproc_nullable] = STATE(1931),
    [sym_preproc_error] = STATE(1931),
    [sym_preproc_define] = STATE(1931),
    [sym_preproc_undef] = STATE(1931),
    [aux_sym_class_declaration_repeat1] = STATE(3851),
    [aux_sym_lambda_expression_repeat1] = STATE(4234),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_ref] = ACTIONS(1293),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1059),
    [anon_sym_TILDE] = ACTIONS(1059),
    [anon_sym_PLUS_PLUS] = ACTIONS(1059),
    [anon_sym_DASH_DASH] = ACTIONS(1059),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1061),
    [anon_sym_DASH] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(1303),
    [anon_sym_CARET] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1307),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1309),
    [anon_sym_DOT_DOT] = ACTIONS(1311),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1932] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6908),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2874),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7082),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5484),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4189),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7388),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9466),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1932),
    [sym_preproc_endregion] = STATE(1932),
    [sym_preproc_line] = STATE(1932),
    [sym_preproc_pragma] = STATE(1932),
    [sym_preproc_nullable] = STATE(1932),
    [sym_preproc_error] = STATE(1932),
    [sym_preproc_define] = STATE(1932),
    [sym_preproc_undef] = STATE(1932),
    [aux_sym_class_declaration_repeat1] = STATE(3825),
    [aux_sym_lambda_expression_repeat1] = STATE(4178),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1743),
    [anon_sym_ref] = ACTIONS(1745),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1505),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1749),
    [anon_sym_TILDE] = ACTIONS(1749),
    [anon_sym_PLUS_PLUS] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1749),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1747),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_CARET] = ACTIONS(1749),
    [anon_sym_AMP] = ACTIONS(1749),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1753),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1755),
    [anon_sym_DOT_DOT] = ACTIONS(1757),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1933] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6650),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1933),
    [sym_preproc_endregion] = STATE(1933),
    [sym_preproc_line] = STATE(1933),
    [sym_preproc_pragma] = STATE(1933),
    [sym_preproc_nullable] = STATE(1933),
    [sym_preproc_error] = STATE(1933),
    [sym_preproc_define] = STATE(1933),
    [sym_preproc_undef] = STATE(1933),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1934] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6908),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2874),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7082),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5560),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4189),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7388),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9466),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1934),
    [sym_preproc_endregion] = STATE(1934),
    [sym_preproc_line] = STATE(1934),
    [sym_preproc_pragma] = STATE(1934),
    [sym_preproc_nullable] = STATE(1934),
    [sym_preproc_error] = STATE(1934),
    [sym_preproc_define] = STATE(1934),
    [sym_preproc_undef] = STATE(1934),
    [aux_sym_class_declaration_repeat1] = STATE(3825),
    [aux_sym_lambda_expression_repeat1] = STATE(4178),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1743),
    [anon_sym_ref] = ACTIONS(1745),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1505),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1749),
    [anon_sym_TILDE] = ACTIONS(1749),
    [anon_sym_PLUS_PLUS] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1749),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1747),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_CARET] = ACTIONS(1749),
    [anon_sym_AMP] = ACTIONS(1749),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1753),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1755),
    [anon_sym_DOT_DOT] = ACTIONS(1757),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1935] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6908),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2874),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7082),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5483),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4189),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7388),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9466),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1935),
    [sym_preproc_endregion] = STATE(1935),
    [sym_preproc_line] = STATE(1935),
    [sym_preproc_pragma] = STATE(1935),
    [sym_preproc_nullable] = STATE(1935),
    [sym_preproc_error] = STATE(1935),
    [sym_preproc_define] = STATE(1935),
    [sym_preproc_undef] = STATE(1935),
    [aux_sym_class_declaration_repeat1] = STATE(3825),
    [aux_sym_lambda_expression_repeat1] = STATE(4178),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1743),
    [anon_sym_ref] = ACTIONS(1745),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1505),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1749),
    [anon_sym_TILDE] = ACTIONS(1749),
    [anon_sym_PLUS_PLUS] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1749),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1747),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_CARET] = ACTIONS(1749),
    [anon_sym_AMP] = ACTIONS(1749),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1753),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1755),
    [anon_sym_DOT_DOT] = ACTIONS(1757),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1936] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6652),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1936),
    [sym_preproc_endregion] = STATE(1936),
    [sym_preproc_line] = STATE(1936),
    [sym_preproc_pragma] = STATE(1936),
    [sym_preproc_nullable] = STATE(1936),
    [sym_preproc_error] = STATE(1936),
    [sym_preproc_define] = STATE(1936),
    [sym_preproc_undef] = STATE(1936),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1937] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6637),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1937),
    [sym_preproc_endregion] = STATE(1937),
    [sym_preproc_line] = STATE(1937),
    [sym_preproc_pragma] = STATE(1937),
    [sym_preproc_nullable] = STATE(1937),
    [sym_preproc_error] = STATE(1937),
    [sym_preproc_define] = STATE(1937),
    [sym_preproc_undef] = STATE(1937),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1938] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6961),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6621),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9849),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1938),
    [sym_preproc_endregion] = STATE(1938),
    [sym_preproc_line] = STATE(1938),
    [sym_preproc_pragma] = STATE(1938),
    [sym_preproc_nullable] = STATE(1938),
    [sym_preproc_error] = STATE(1938),
    [sym_preproc_define] = STATE(1938),
    [sym_preproc_undef] = STATE(1938),
    [aux_sym_class_declaration_repeat1] = STATE(3841),
    [aux_sym_lambda_expression_repeat1] = STATE(4283),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1459),
    [anon_sym_ref] = ACTIONS(1461),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1465),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1467),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1469),
    [anon_sym_DOT_DOT] = ACTIONS(1471),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1939] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6618),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1939),
    [sym_preproc_endregion] = STATE(1939),
    [sym_preproc_line] = STATE(1939),
    [sym_preproc_pragma] = STATE(1939),
    [sym_preproc_nullable] = STATE(1939),
    [sym_preproc_error] = STATE(1939),
    [sym_preproc_define] = STATE(1939),
    [sym_preproc_undef] = STATE(1939),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1940] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6908),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2874),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7082),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5482),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4189),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7388),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9466),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1940),
    [sym_preproc_endregion] = STATE(1940),
    [sym_preproc_line] = STATE(1940),
    [sym_preproc_pragma] = STATE(1940),
    [sym_preproc_nullable] = STATE(1940),
    [sym_preproc_error] = STATE(1940),
    [sym_preproc_define] = STATE(1940),
    [sym_preproc_undef] = STATE(1940),
    [aux_sym_class_declaration_repeat1] = STATE(3825),
    [aux_sym_lambda_expression_repeat1] = STATE(4178),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1743),
    [anon_sym_ref] = ACTIONS(1745),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1505),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1749),
    [anon_sym_TILDE] = ACTIONS(1749),
    [anon_sym_PLUS_PLUS] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1749),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1747),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_CARET] = ACTIONS(1749),
    [anon_sym_AMP] = ACTIONS(1749),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1753),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1755),
    [anon_sym_DOT_DOT] = ACTIONS(1757),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1941] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6030),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1941),
    [sym_preproc_endregion] = STATE(1941),
    [sym_preproc_line] = STATE(1941),
    [sym_preproc_pragma] = STATE(1941),
    [sym_preproc_nullable] = STATE(1941),
    [sym_preproc_error] = STATE(1941),
    [sym_preproc_define] = STATE(1941),
    [sym_preproc_undef] = STATE(1941),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1942] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6115),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1942),
    [sym_preproc_endregion] = STATE(1942),
    [sym_preproc_line] = STATE(1942),
    [sym_preproc_pragma] = STATE(1942),
    [sym_preproc_nullable] = STATE(1942),
    [sym_preproc_error] = STATE(1942),
    [sym_preproc_define] = STATE(1942),
    [sym_preproc_undef] = STATE(1942),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1943] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6118),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1943),
    [sym_preproc_endregion] = STATE(1943),
    [sym_preproc_line] = STATE(1943),
    [sym_preproc_pragma] = STATE(1943),
    [sym_preproc_nullable] = STATE(1943),
    [sym_preproc_error] = STATE(1943),
    [sym_preproc_define] = STATE(1943),
    [sym_preproc_undef] = STATE(1943),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1944] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6540),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1944),
    [sym_preproc_endregion] = STATE(1944),
    [sym_preproc_line] = STATE(1944),
    [sym_preproc_pragma] = STATE(1944),
    [sym_preproc_nullable] = STATE(1944),
    [sym_preproc_error] = STATE(1944),
    [sym_preproc_define] = STATE(1944),
    [sym_preproc_undef] = STATE(1944),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1945] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5676),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1945),
    [sym_preproc_endregion] = STATE(1945),
    [sym_preproc_line] = STATE(1945),
    [sym_preproc_pragma] = STATE(1945),
    [sym_preproc_nullable] = STATE(1945),
    [sym_preproc_error] = STATE(1945),
    [sym_preproc_define] = STATE(1945),
    [sym_preproc_undef] = STATE(1945),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1946] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6604),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1946),
    [sym_preproc_endregion] = STATE(1946),
    [sym_preproc_line] = STATE(1946),
    [sym_preproc_pragma] = STATE(1946),
    [sym_preproc_nullable] = STATE(1946),
    [sym_preproc_error] = STATE(1946),
    [sym_preproc_define] = STATE(1946),
    [sym_preproc_undef] = STATE(1946),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1947] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6910),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2957),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6984),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4914),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(3777),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7387),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9385),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1947),
    [sym_preproc_endregion] = STATE(1947),
    [sym_preproc_line] = STATE(1947),
    [sym_preproc_pragma] = STATE(1947),
    [sym_preproc_nullable] = STATE(1947),
    [sym_preproc_error] = STATE(1947),
    [sym_preproc_define] = STATE(1947),
    [sym_preproc_undef] = STATE(1947),
    [aux_sym_class_declaration_repeat1] = STATE(3793),
    [aux_sym_lambda_expression_repeat1] = STATE(4083),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1795),
    [anon_sym_ref] = ACTIONS(1797),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1799),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1803),
    [anon_sym_TILDE] = ACTIONS(1803),
    [anon_sym_PLUS_PLUS] = ACTIONS(1803),
    [anon_sym_DASH_DASH] = ACTIONS(1803),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1801),
    [anon_sym_DASH] = ACTIONS(1801),
    [anon_sym_STAR] = ACTIONS(1805),
    [anon_sym_CARET] = ACTIONS(1803),
    [anon_sym_AMP] = ACTIONS(1803),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1807),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1809),
    [anon_sym_DOT_DOT] = ACTIONS(1811),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1948] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6910),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2957),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6984),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4946),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(3777),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7387),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9385),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1948),
    [sym_preproc_endregion] = STATE(1948),
    [sym_preproc_line] = STATE(1948),
    [sym_preproc_pragma] = STATE(1948),
    [sym_preproc_nullable] = STATE(1948),
    [sym_preproc_error] = STATE(1948),
    [sym_preproc_define] = STATE(1948),
    [sym_preproc_undef] = STATE(1948),
    [aux_sym_class_declaration_repeat1] = STATE(3793),
    [aux_sym_lambda_expression_repeat1] = STATE(4083),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1795),
    [anon_sym_ref] = ACTIONS(1797),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1799),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1803),
    [anon_sym_TILDE] = ACTIONS(1803),
    [anon_sym_PLUS_PLUS] = ACTIONS(1803),
    [anon_sym_DASH_DASH] = ACTIONS(1803),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1801),
    [anon_sym_DASH] = ACTIONS(1801),
    [anon_sym_STAR] = ACTIONS(1805),
    [anon_sym_CARET] = ACTIONS(1803),
    [anon_sym_AMP] = ACTIONS(1803),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1807),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1809),
    [anon_sym_DOT_DOT] = ACTIONS(1811),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1949] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7108),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6081),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4313),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7382),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9733),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1949),
    [sym_preproc_endregion] = STATE(1949),
    [sym_preproc_line] = STATE(1949),
    [sym_preproc_pragma] = STATE(1949),
    [sym_preproc_nullable] = STATE(1949),
    [sym_preproc_error] = STATE(1949),
    [sym_preproc_define] = STATE(1949),
    [sym_preproc_undef] = STATE(1949),
    [aux_sym_class_declaration_repeat1] = STATE(3802),
    [aux_sym_lambda_expression_repeat1] = STATE(4108),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1519),
    [anon_sym_ref] = ACTIONS(1521),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1523),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1529),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1531),
    [anon_sym_DOT_DOT] = ACTIONS(1533),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1950] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7108),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6083),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4313),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7382),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9733),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1950),
    [sym_preproc_endregion] = STATE(1950),
    [sym_preproc_line] = STATE(1950),
    [sym_preproc_pragma] = STATE(1950),
    [sym_preproc_nullable] = STATE(1950),
    [sym_preproc_error] = STATE(1950),
    [sym_preproc_define] = STATE(1950),
    [sym_preproc_undef] = STATE(1950),
    [aux_sym_class_declaration_repeat1] = STATE(3802),
    [aux_sym_lambda_expression_repeat1] = STATE(4108),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1519),
    [anon_sym_ref] = ACTIONS(1521),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1523),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1529),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1531),
    [anon_sym_DOT_DOT] = ACTIONS(1533),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1951] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7108),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5872),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4313),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7382),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9733),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1951),
    [sym_preproc_endregion] = STATE(1951),
    [sym_preproc_line] = STATE(1951),
    [sym_preproc_pragma] = STATE(1951),
    [sym_preproc_nullable] = STATE(1951),
    [sym_preproc_error] = STATE(1951),
    [sym_preproc_define] = STATE(1951),
    [sym_preproc_undef] = STATE(1951),
    [aux_sym_class_declaration_repeat1] = STATE(3802),
    [aux_sym_lambda_expression_repeat1] = STATE(4108),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1519),
    [anon_sym_ref] = ACTIONS(1521),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1523),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1529),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1531),
    [anon_sym_DOT_DOT] = ACTIONS(1533),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1952] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7108),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6085),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4313),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7382),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9733),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1952),
    [sym_preproc_endregion] = STATE(1952),
    [sym_preproc_line] = STATE(1952),
    [sym_preproc_pragma] = STATE(1952),
    [sym_preproc_nullable] = STATE(1952),
    [sym_preproc_error] = STATE(1952),
    [sym_preproc_define] = STATE(1952),
    [sym_preproc_undef] = STATE(1952),
    [aux_sym_class_declaration_repeat1] = STATE(3802),
    [aux_sym_lambda_expression_repeat1] = STATE(4108),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1519),
    [anon_sym_ref] = ACTIONS(1521),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1523),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1529),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1531),
    [anon_sym_DOT_DOT] = ACTIONS(1533),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1953] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7108),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6088),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4313),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7382),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9733),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1953),
    [sym_preproc_endregion] = STATE(1953),
    [sym_preproc_line] = STATE(1953),
    [sym_preproc_pragma] = STATE(1953),
    [sym_preproc_nullable] = STATE(1953),
    [sym_preproc_error] = STATE(1953),
    [sym_preproc_define] = STATE(1953),
    [sym_preproc_undef] = STATE(1953),
    [aux_sym_class_declaration_repeat1] = STATE(3802),
    [aux_sym_lambda_expression_repeat1] = STATE(4108),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1519),
    [anon_sym_ref] = ACTIONS(1521),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1523),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1529),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1531),
    [anon_sym_DOT_DOT] = ACTIONS(1533),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1954] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7108),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5985),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4313),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7382),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9733),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1954),
    [sym_preproc_endregion] = STATE(1954),
    [sym_preproc_line] = STATE(1954),
    [sym_preproc_pragma] = STATE(1954),
    [sym_preproc_nullable] = STATE(1954),
    [sym_preproc_error] = STATE(1954),
    [sym_preproc_define] = STATE(1954),
    [sym_preproc_undef] = STATE(1954),
    [aux_sym_class_declaration_repeat1] = STATE(3802),
    [aux_sym_lambda_expression_repeat1] = STATE(4108),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1519),
    [anon_sym_ref] = ACTIONS(1521),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1523),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1529),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1531),
    [anon_sym_DOT_DOT] = ACTIONS(1533),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1955] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7108),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6070),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4313),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7382),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9733),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1955),
    [sym_preproc_endregion] = STATE(1955),
    [sym_preproc_line] = STATE(1955),
    [sym_preproc_pragma] = STATE(1955),
    [sym_preproc_nullable] = STATE(1955),
    [sym_preproc_error] = STATE(1955),
    [sym_preproc_define] = STATE(1955),
    [sym_preproc_undef] = STATE(1955),
    [aux_sym_class_declaration_repeat1] = STATE(3802),
    [aux_sym_lambda_expression_repeat1] = STATE(4108),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1519),
    [anon_sym_ref] = ACTIONS(1521),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1523),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1529),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1531),
    [anon_sym_DOT_DOT] = ACTIONS(1533),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1956] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7108),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6074),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4313),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7382),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9733),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1956),
    [sym_preproc_endregion] = STATE(1956),
    [sym_preproc_line] = STATE(1956),
    [sym_preproc_pragma] = STATE(1956),
    [sym_preproc_nullable] = STATE(1956),
    [sym_preproc_error] = STATE(1956),
    [sym_preproc_define] = STATE(1956),
    [sym_preproc_undef] = STATE(1956),
    [aux_sym_class_declaration_repeat1] = STATE(3802),
    [aux_sym_lambda_expression_repeat1] = STATE(4108),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1519),
    [anon_sym_ref] = ACTIONS(1521),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1523),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1529),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1531),
    [anon_sym_DOT_DOT] = ACTIONS(1533),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1957] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7108),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6078),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4313),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7382),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9733),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1957),
    [sym_preproc_endregion] = STATE(1957),
    [sym_preproc_line] = STATE(1957),
    [sym_preproc_pragma] = STATE(1957),
    [sym_preproc_nullable] = STATE(1957),
    [sym_preproc_error] = STATE(1957),
    [sym_preproc_define] = STATE(1957),
    [sym_preproc_undef] = STATE(1957),
    [aux_sym_class_declaration_repeat1] = STATE(3802),
    [aux_sym_lambda_expression_repeat1] = STATE(4108),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1519),
    [anon_sym_ref] = ACTIONS(1521),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1523),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1529),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1531),
    [anon_sym_DOT_DOT] = ACTIONS(1533),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1958] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6894),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2955),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7046),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5013),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(3786),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7408),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9363),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1958),
    [sym_preproc_endregion] = STATE(1958),
    [sym_preproc_line] = STATE(1958),
    [sym_preproc_pragma] = STATE(1958),
    [sym_preproc_nullable] = STATE(1958),
    [sym_preproc_error] = STATE(1958),
    [sym_preproc_define] = STATE(1958),
    [sym_preproc_undef] = STATE(1958),
    [aux_sym_class_declaration_repeat1] = STATE(3811),
    [aux_sym_lambda_expression_repeat1] = STATE(4149),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2069),
    [anon_sym_ref] = ACTIONS(2071),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1853),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(2075),
    [anon_sym_TILDE] = ACTIONS(2075),
    [anon_sym_PLUS_PLUS] = ACTIONS(2075),
    [anon_sym_DASH_DASH] = ACTIONS(2075),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2073),
    [anon_sym_DASH] = ACTIONS(2073),
    [anon_sym_STAR] = ACTIONS(1859),
    [anon_sym_CARET] = ACTIONS(2075),
    [anon_sym_AMP] = ACTIONS(2075),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2077),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2079),
    [anon_sym_DOT_DOT] = ACTIONS(2081),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1959] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7108),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6084),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4313),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7382),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9733),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1959),
    [sym_preproc_endregion] = STATE(1959),
    [sym_preproc_line] = STATE(1959),
    [sym_preproc_pragma] = STATE(1959),
    [sym_preproc_nullable] = STATE(1959),
    [sym_preproc_error] = STATE(1959),
    [sym_preproc_define] = STATE(1959),
    [sym_preproc_undef] = STATE(1959),
    [aux_sym_class_declaration_repeat1] = STATE(3802),
    [aux_sym_lambda_expression_repeat1] = STATE(4108),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1519),
    [anon_sym_ref] = ACTIONS(1521),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1523),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1529),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1531),
    [anon_sym_DOT_DOT] = ACTIONS(1533),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1960] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7108),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6075),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4313),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7382),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9733),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1960),
    [sym_preproc_endregion] = STATE(1960),
    [sym_preproc_line] = STATE(1960),
    [sym_preproc_pragma] = STATE(1960),
    [sym_preproc_nullable] = STATE(1960),
    [sym_preproc_error] = STATE(1960),
    [sym_preproc_define] = STATE(1960),
    [sym_preproc_undef] = STATE(1960),
    [aux_sym_class_declaration_repeat1] = STATE(3802),
    [aux_sym_lambda_expression_repeat1] = STATE(4108),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1519),
    [anon_sym_ref] = ACTIONS(1521),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1523),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1529),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1531),
    [anon_sym_DOT_DOT] = ACTIONS(1533),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1961] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6961),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5388),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9849),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1961),
    [sym_preproc_endregion] = STATE(1961),
    [sym_preproc_line] = STATE(1961),
    [sym_preproc_pragma] = STATE(1961),
    [sym_preproc_nullable] = STATE(1961),
    [sym_preproc_error] = STATE(1961),
    [sym_preproc_define] = STATE(1961),
    [sym_preproc_undef] = STATE(1961),
    [aux_sym_class_declaration_repeat1] = STATE(3841),
    [aux_sym_lambda_expression_repeat1] = STATE(4283),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1459),
    [anon_sym_ref] = ACTIONS(1461),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1465),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1467),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1469),
    [anon_sym_DOT_DOT] = ACTIONS(1471),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1962] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6615),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1962),
    [sym_preproc_endregion] = STATE(1962),
    [sym_preproc_line] = STATE(1962),
    [sym_preproc_pragma] = STATE(1962),
    [sym_preproc_nullable] = STATE(1962),
    [sym_preproc_error] = STATE(1962),
    [sym_preproc_define] = STATE(1962),
    [sym_preproc_undef] = STATE(1962),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1963] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6904),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7009),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5335),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4008),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7381),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9536),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1963),
    [sym_preproc_endregion] = STATE(1963),
    [sym_preproc_line] = STATE(1963),
    [sym_preproc_pragma] = STATE(1963),
    [sym_preproc_nullable] = STATE(1963),
    [sym_preproc_error] = STATE(1963),
    [sym_preproc_define] = STATE(1963),
    [sym_preproc_undef] = STATE(1963),
    [aux_sym_class_declaration_repeat1] = STATE(3832),
    [aux_sym_lambda_expression_repeat1] = STATE(4090),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1485),
    [anon_sym_ref] = ACTIONS(1487),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1221),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1491),
    [anon_sym_TILDE] = ACTIONS(1491),
    [anon_sym_PLUS_PLUS] = ACTIONS(1491),
    [anon_sym_DASH_DASH] = ACTIONS(1491),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1489),
    [anon_sym_DASH] = ACTIONS(1489),
    [anon_sym_STAR] = ACTIONS(1493),
    [anon_sym_CARET] = ACTIONS(1491),
    [anon_sym_AMP] = ACTIONS(1491),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1495),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1497),
    [anon_sym_DOT_DOT] = ACTIONS(1499),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1964] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6910),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2957),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6984),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4935),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(3777),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7387),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9385),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1964),
    [sym_preproc_endregion] = STATE(1964),
    [sym_preproc_line] = STATE(1964),
    [sym_preproc_pragma] = STATE(1964),
    [sym_preproc_nullable] = STATE(1964),
    [sym_preproc_error] = STATE(1964),
    [sym_preproc_define] = STATE(1964),
    [sym_preproc_undef] = STATE(1964),
    [aux_sym_class_declaration_repeat1] = STATE(3793),
    [aux_sym_lambda_expression_repeat1] = STATE(4083),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1795),
    [anon_sym_ref] = ACTIONS(1797),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1799),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1803),
    [anon_sym_TILDE] = ACTIONS(1803),
    [anon_sym_PLUS_PLUS] = ACTIONS(1803),
    [anon_sym_DASH_DASH] = ACTIONS(1803),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1801),
    [anon_sym_DASH] = ACTIONS(1801),
    [anon_sym_STAR] = ACTIONS(1805),
    [anon_sym_CARET] = ACTIONS(1803),
    [anon_sym_AMP] = ACTIONS(1803),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1807),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1809),
    [anon_sym_DOT_DOT] = ACTIONS(1811),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1965] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7108),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(3922),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4313),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7382),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9733),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1965),
    [sym_preproc_endregion] = STATE(1965),
    [sym_preproc_line] = STATE(1965),
    [sym_preproc_pragma] = STATE(1965),
    [sym_preproc_nullable] = STATE(1965),
    [sym_preproc_error] = STATE(1965),
    [sym_preproc_define] = STATE(1965),
    [sym_preproc_undef] = STATE(1965),
    [aux_sym_class_declaration_repeat1] = STATE(3802),
    [aux_sym_lambda_expression_repeat1] = STATE(4108),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1519),
    [anon_sym_ref] = ACTIONS(1521),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1523),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1529),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1531),
    [anon_sym_DOT_DOT] = ACTIONS(1533),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1966] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6910),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2957),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6984),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4917),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(3777),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7387),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9385),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1966),
    [sym_preproc_endregion] = STATE(1966),
    [sym_preproc_line] = STATE(1966),
    [sym_preproc_pragma] = STATE(1966),
    [sym_preproc_nullable] = STATE(1966),
    [sym_preproc_error] = STATE(1966),
    [sym_preproc_define] = STATE(1966),
    [sym_preproc_undef] = STATE(1966),
    [aux_sym_class_declaration_repeat1] = STATE(3793),
    [aux_sym_lambda_expression_repeat1] = STATE(4083),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1795),
    [anon_sym_ref] = ACTIONS(1797),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1799),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1803),
    [anon_sym_TILDE] = ACTIONS(1803),
    [anon_sym_PLUS_PLUS] = ACTIONS(1803),
    [anon_sym_DASH_DASH] = ACTIONS(1803),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1801),
    [anon_sym_DASH] = ACTIONS(1801),
    [anon_sym_STAR] = ACTIONS(1805),
    [anon_sym_CARET] = ACTIONS(1803),
    [anon_sym_AMP] = ACTIONS(1803),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1807),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1809),
    [anon_sym_DOT_DOT] = ACTIONS(1811),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1967] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7094),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5924),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1967),
    [sym_preproc_endregion] = STATE(1967),
    [sym_preproc_line] = STATE(1967),
    [sym_preproc_pragma] = STATE(1967),
    [sym_preproc_nullable] = STATE(1967),
    [sym_preproc_error] = STATE(1967),
    [sym_preproc_define] = STATE(1967),
    [sym_preproc_undef] = STATE(1967),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1669),
    [anon_sym_TILDE] = ACTIONS(1669),
    [anon_sym_PLUS_PLUS] = ACTIONS(1669),
    [anon_sym_DASH_DASH] = ACTIONS(1669),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1667),
    [anon_sym_DASH] = ACTIONS(1667),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1669),
    [anon_sym_AMP] = ACTIONS(1669),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1968] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7080),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4308),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4477),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9873),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1968),
    [sym_preproc_endregion] = STATE(1968),
    [sym_preproc_line] = STATE(1968),
    [sym_preproc_pragma] = STATE(1968),
    [sym_preproc_nullable] = STATE(1968),
    [sym_preproc_error] = STATE(1968),
    [sym_preproc_define] = STATE(1968),
    [sym_preproc_undef] = STATE(1968),
    [aux_sym_class_declaration_repeat1] = STATE(3845),
    [aux_sym_lambda_expression_repeat1] = STATE(4299),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1979),
    [anon_sym_ref] = ACTIONS(1981),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1985),
    [anon_sym_TILDE] = ACTIONS(1985),
    [anon_sym_PLUS_PLUS] = ACTIONS(1985),
    [anon_sym_DASH_DASH] = ACTIONS(1985),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1983),
    [anon_sym_DASH] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1985),
    [anon_sym_AMP] = ACTIONS(1985),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1987),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1989),
    [anon_sym_DOT_DOT] = ACTIONS(1991),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1969] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3559),
    [sym__name] = STATE(6877),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2908),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7129),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4345),
    [sym_non_lvalue_expression] = STATE(4553),
    [sym_lvalue_expression] = STATE(3561),
    [sym__expression_statement_expression] = STATE(4559),
    [sym_assignment_expression] = STATE(4558),
    [sym_binary_expression] = STATE(4559),
    [sym_postfix_unary_expression] = STATE(4558),
    [sym_prefix_unary_expression] = STATE(4558),
    [sym__pointer_indirection_expression] = STATE(3560),
    [sym_query_expression] = STATE(4559),
    [sym_from_clause] = STATE(7385),
    [sym_conditional_expression] = STATE(4559),
    [sym_conditional_access_expression] = STATE(4559),
    [sym_as_expression] = STATE(4559),
    [sym_is_expression] = STATE(4559),
    [sym_is_pattern_expression] = STATE(4559),
    [sym_cast_expression] = STATE(4559),
    [sym_checked_expression] = STATE(4559),
    [sym_invocation_expression] = STATE(4558),
    [sym_switch_expression] = STATE(4559),
    [sym_await_expression] = STATE(4558),
    [sym_throw_expression] = STATE(4559),
    [sym_element_access_expression] = STATE(3560),
    [sym_interpolated_string_expression] = STATE(4559),
    [sym_member_access_expression] = STATE(3560),
    [sym_object_creation_expression] = STATE(4558),
    [sym_parenthesized_expression] = STATE(4558),
    [sym__parenthesized_lvalue_expression] = STATE(3560),
    [sym_lambda_expression] = STATE(4559),
    [sym__lambda_parameters] = STATE(9776),
    [sym_array_creation_expression] = STATE(4559),
    [sym_anonymous_method_expression] = STATE(4559),
    [sym_anonymous_object_creation_expression] = STATE(4559),
    [sym_implicit_array_creation_expression] = STATE(4559),
    [sym_implicit_object_creation_expression] = STATE(4559),
    [sym_implicit_stackalloc_expression] = STATE(4559),
    [sym_initializer_expression] = STATE(4559),
    [sym_default_expression] = STATE(4559),
    [sym_with_expression] = STATE(4559),
    [sym_sizeof_expression] = STATE(4559),
    [sym_typeof_expression] = STATE(4559),
    [sym_makeref_expression] = STATE(4559),
    [sym_ref_expression] = STATE(4559),
    [sym_reftype_expression] = STATE(4559),
    [sym_refvalue_expression] = STATE(4559),
    [sym_stackalloc_expression] = STATE(4559),
    [sym_range_expression] = STATE(4559),
    [sym_tuple_expression] = STATE(3560),
    [sym_literal] = STATE(4559),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4559),
    [sym_preproc_region] = STATE(1969),
    [sym_preproc_endregion] = STATE(1969),
    [sym_preproc_line] = STATE(1969),
    [sym_preproc_pragma] = STATE(1969),
    [sym_preproc_nullable] = STATE(1969),
    [sym_preproc_error] = STATE(1969),
    [sym_preproc_define] = STATE(1969),
    [sym_preproc_undef] = STATE(1969),
    [aux_sym_class_declaration_repeat1] = STATE(3843),
    [aux_sym_lambda_expression_repeat1] = STATE(4277),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(1675),
    [anon_sym_ref] = ACTIONS(1677),
    [anon_sym_LBRACE] = ACTIONS(1611),
    [anon_sym_delegate] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1679),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(1683),
    [anon_sym_TILDE] = ACTIONS(1683),
    [anon_sym_PLUS_PLUS] = ACTIONS(1683),
    [anon_sym_DASH_DASH] = ACTIONS(1683),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_DASH] = ACTIONS(1681),
    [anon_sym_STAR] = ACTIONS(1685),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1683),
    [anon_sym_this] = ACTIONS(1627),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1629),
    [anon_sym_unchecked] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(1687),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1689),
    [anon_sym_DOT_DOT] = ACTIONS(1691),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_stackalloc] = ACTIONS(1641),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(1647),
    [anon_sym___reftype] = ACTIONS(1649),
    [anon_sym___refvalue] = ACTIONS(1651),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1659),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [1970] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6560),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6980),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6346),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4482),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7389),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9438),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1970),
    [sym_preproc_endregion] = STATE(1970),
    [sym_preproc_line] = STATE(1970),
    [sym_preproc_pragma] = STATE(1970),
    [sym_preproc_nullable] = STATE(1970),
    [sym_preproc_error] = STATE(1970),
    [sym_preproc_define] = STATE(1970),
    [sym_preproc_undef] = STATE(1970),
    [aux_sym_class_declaration_repeat1] = STATE(3801),
    [aux_sym_lambda_expression_repeat1] = STATE(4134),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1993),
    [anon_sym_ref] = ACTIONS(1995),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1999),
    [anon_sym_TILDE] = ACTIONS(1999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1999),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_AMP] = ACTIONS(1999),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1281),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1283),
    [anon_sym_DOT_DOT] = ACTIONS(1285),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1971] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6961),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6414),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9849),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1971),
    [sym_preproc_endregion] = STATE(1971),
    [sym_preproc_line] = STATE(1971),
    [sym_preproc_pragma] = STATE(1971),
    [sym_preproc_nullable] = STATE(1971),
    [sym_preproc_error] = STATE(1971),
    [sym_preproc_define] = STATE(1971),
    [sym_preproc_undef] = STATE(1971),
    [aux_sym_class_declaration_repeat1] = STATE(3841),
    [aux_sym_lambda_expression_repeat1] = STATE(4283),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1459),
    [anon_sym_ref] = ACTIONS(1461),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1465),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1467),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1469),
    [anon_sym_DOT_DOT] = ACTIONS(1471),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1972] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6908),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2874),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7082),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5532),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4189),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7388),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9466),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1972),
    [sym_preproc_endregion] = STATE(1972),
    [sym_preproc_line] = STATE(1972),
    [sym_preproc_pragma] = STATE(1972),
    [sym_preproc_nullable] = STATE(1972),
    [sym_preproc_error] = STATE(1972),
    [sym_preproc_define] = STATE(1972),
    [sym_preproc_undef] = STATE(1972),
    [aux_sym_class_declaration_repeat1] = STATE(3825),
    [aux_sym_lambda_expression_repeat1] = STATE(4178),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1743),
    [anon_sym_ref] = ACTIONS(1745),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1505),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1749),
    [anon_sym_TILDE] = ACTIONS(1749),
    [anon_sym_PLUS_PLUS] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1749),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1747),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_CARET] = ACTIONS(1749),
    [anon_sym_AMP] = ACTIONS(1749),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1753),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1755),
    [anon_sym_DOT_DOT] = ACTIONS(1757),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1973] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3559),
    [sym__name] = STATE(6878),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2911),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6960),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4434),
    [sym_non_lvalue_expression] = STATE(4553),
    [sym_lvalue_expression] = STATE(3607),
    [sym__expression_statement_expression] = STATE(4559),
    [sym_assignment_expression] = STATE(4558),
    [sym_binary_expression] = STATE(4559),
    [sym_postfix_unary_expression] = STATE(4558),
    [sym_prefix_unary_expression] = STATE(4558),
    [sym__pointer_indirection_expression] = STATE(3560),
    [sym_query_expression] = STATE(4559),
    [sym_from_clause] = STATE(7385),
    [sym_conditional_expression] = STATE(4559),
    [sym_conditional_access_expression] = STATE(4559),
    [sym_as_expression] = STATE(4559),
    [sym_is_expression] = STATE(4559),
    [sym_is_pattern_expression] = STATE(4559),
    [sym_cast_expression] = STATE(4559),
    [sym_checked_expression] = STATE(4559),
    [sym_invocation_expression] = STATE(4558),
    [sym_switch_expression] = STATE(4559),
    [sym_await_expression] = STATE(4558),
    [sym_throw_expression] = STATE(4559),
    [sym_element_access_expression] = STATE(3560),
    [sym_interpolated_string_expression] = STATE(4559),
    [sym_member_access_expression] = STATE(3560),
    [sym_object_creation_expression] = STATE(4558),
    [sym_parenthesized_expression] = STATE(4558),
    [sym__parenthesized_lvalue_expression] = STATE(3560),
    [sym_lambda_expression] = STATE(4559),
    [sym__lambda_parameters] = STATE(9554),
    [sym_array_creation_expression] = STATE(4559),
    [sym_anonymous_method_expression] = STATE(4559),
    [sym_anonymous_object_creation_expression] = STATE(4559),
    [sym_implicit_array_creation_expression] = STATE(4559),
    [sym_implicit_object_creation_expression] = STATE(4559),
    [sym_implicit_stackalloc_expression] = STATE(4559),
    [sym_initializer_expression] = STATE(4559),
    [sym_default_expression] = STATE(4559),
    [sym_with_expression] = STATE(4559),
    [sym_sizeof_expression] = STATE(4559),
    [sym_typeof_expression] = STATE(4559),
    [sym_makeref_expression] = STATE(4559),
    [sym_ref_expression] = STATE(4559),
    [sym_reftype_expression] = STATE(4559),
    [sym_refvalue_expression] = STATE(4559),
    [sym_stackalloc_expression] = STATE(4559),
    [sym_range_expression] = STATE(4559),
    [sym_tuple_expression] = STATE(3560),
    [sym_literal] = STATE(4559),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4559),
    [sym_preproc_region] = STATE(1973),
    [sym_preproc_endregion] = STATE(1973),
    [sym_preproc_line] = STATE(1973),
    [sym_preproc_pragma] = STATE(1973),
    [sym_preproc_nullable] = STATE(1973),
    [sym_preproc_error] = STATE(1973),
    [sym_preproc_define] = STATE(1973),
    [sym_preproc_undef] = STATE(1973),
    [aux_sym_class_declaration_repeat1] = STATE(3792),
    [aux_sym_lambda_expression_repeat1] = STATE(4202),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(1607),
    [anon_sym_ref] = ACTIONS(1609),
    [anon_sym_LBRACE] = ACTIONS(1611),
    [anon_sym_delegate] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1615),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(1621),
    [anon_sym_TILDE] = ACTIONS(1621),
    [anon_sym_PLUS_PLUS] = ACTIONS(1621),
    [anon_sym_DASH_DASH] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(1619),
    [anon_sym_DASH] = ACTIONS(1619),
    [anon_sym_STAR] = ACTIONS(1625),
    [anon_sym_CARET] = ACTIONS(1621),
    [anon_sym_AMP] = ACTIONS(1621),
    [anon_sym_this] = ACTIONS(1627),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1629),
    [anon_sym_unchecked] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [anon_sym_DOT_DOT] = ACTIONS(1637),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_stackalloc] = ACTIONS(1641),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(1647),
    [anon_sym___reftype] = ACTIONS(1649),
    [anon_sym___refvalue] = ACTIONS(1651),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1659),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [1974] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3559),
    [sym__name] = STATE(6878),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2911),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6960),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4346),
    [sym_non_lvalue_expression] = STATE(4553),
    [sym_lvalue_expression] = STATE(3607),
    [sym__expression_statement_expression] = STATE(4559),
    [sym_assignment_expression] = STATE(4558),
    [sym_binary_expression] = STATE(4559),
    [sym_postfix_unary_expression] = STATE(4558),
    [sym_prefix_unary_expression] = STATE(4558),
    [sym__pointer_indirection_expression] = STATE(3560),
    [sym_query_expression] = STATE(4559),
    [sym_from_clause] = STATE(7385),
    [sym_conditional_expression] = STATE(4559),
    [sym_conditional_access_expression] = STATE(4559),
    [sym_as_expression] = STATE(4559),
    [sym_is_expression] = STATE(4559),
    [sym_is_pattern_expression] = STATE(4559),
    [sym_cast_expression] = STATE(4559),
    [sym_checked_expression] = STATE(4559),
    [sym_invocation_expression] = STATE(4558),
    [sym_switch_expression] = STATE(4559),
    [sym_await_expression] = STATE(4558),
    [sym_throw_expression] = STATE(4559),
    [sym_element_access_expression] = STATE(3560),
    [sym_interpolated_string_expression] = STATE(4559),
    [sym_member_access_expression] = STATE(3560),
    [sym_object_creation_expression] = STATE(4558),
    [sym_parenthesized_expression] = STATE(4558),
    [sym__parenthesized_lvalue_expression] = STATE(3560),
    [sym_lambda_expression] = STATE(4559),
    [sym__lambda_parameters] = STATE(9554),
    [sym_array_creation_expression] = STATE(4559),
    [sym_anonymous_method_expression] = STATE(4559),
    [sym_anonymous_object_creation_expression] = STATE(4559),
    [sym_implicit_array_creation_expression] = STATE(4559),
    [sym_implicit_object_creation_expression] = STATE(4559),
    [sym_implicit_stackalloc_expression] = STATE(4559),
    [sym_initializer_expression] = STATE(4559),
    [sym_default_expression] = STATE(4559),
    [sym_with_expression] = STATE(4559),
    [sym_sizeof_expression] = STATE(4559),
    [sym_typeof_expression] = STATE(4559),
    [sym_makeref_expression] = STATE(4559),
    [sym_ref_expression] = STATE(4559),
    [sym_reftype_expression] = STATE(4559),
    [sym_refvalue_expression] = STATE(4559),
    [sym_stackalloc_expression] = STATE(4559),
    [sym_range_expression] = STATE(4559),
    [sym_tuple_expression] = STATE(3560),
    [sym_literal] = STATE(4559),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4559),
    [sym_preproc_region] = STATE(1974),
    [sym_preproc_endregion] = STATE(1974),
    [sym_preproc_line] = STATE(1974),
    [sym_preproc_pragma] = STATE(1974),
    [sym_preproc_nullable] = STATE(1974),
    [sym_preproc_error] = STATE(1974),
    [sym_preproc_define] = STATE(1974),
    [sym_preproc_undef] = STATE(1974),
    [aux_sym_class_declaration_repeat1] = STATE(3792),
    [aux_sym_lambda_expression_repeat1] = STATE(4202),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(1607),
    [anon_sym_ref] = ACTIONS(1609),
    [anon_sym_LBRACE] = ACTIONS(1611),
    [anon_sym_delegate] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1615),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(1621),
    [anon_sym_TILDE] = ACTIONS(1621),
    [anon_sym_PLUS_PLUS] = ACTIONS(1621),
    [anon_sym_DASH_DASH] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(1619),
    [anon_sym_DASH] = ACTIONS(1619),
    [anon_sym_STAR] = ACTIONS(1625),
    [anon_sym_CARET] = ACTIONS(1621),
    [anon_sym_AMP] = ACTIONS(1621),
    [anon_sym_this] = ACTIONS(1627),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1629),
    [anon_sym_unchecked] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [anon_sym_DOT_DOT] = ACTIONS(1637),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_stackalloc] = ACTIONS(1641),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(1647),
    [anon_sym___reftype] = ACTIONS(1649),
    [anon_sym___refvalue] = ACTIONS(1651),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1659),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [1975] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3559),
    [sym__name] = STATE(6878),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2911),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6960),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4345),
    [sym_non_lvalue_expression] = STATE(4553),
    [sym_lvalue_expression] = STATE(3607),
    [sym__expression_statement_expression] = STATE(4559),
    [sym_assignment_expression] = STATE(4558),
    [sym_binary_expression] = STATE(4559),
    [sym_postfix_unary_expression] = STATE(4558),
    [sym_prefix_unary_expression] = STATE(4558),
    [sym__pointer_indirection_expression] = STATE(3560),
    [sym_query_expression] = STATE(4559),
    [sym_from_clause] = STATE(7385),
    [sym_conditional_expression] = STATE(4559),
    [sym_conditional_access_expression] = STATE(4559),
    [sym_as_expression] = STATE(4559),
    [sym_is_expression] = STATE(4559),
    [sym_is_pattern_expression] = STATE(4559),
    [sym_cast_expression] = STATE(4559),
    [sym_checked_expression] = STATE(4559),
    [sym_invocation_expression] = STATE(4558),
    [sym_switch_expression] = STATE(4559),
    [sym_await_expression] = STATE(4558),
    [sym_throw_expression] = STATE(4559),
    [sym_element_access_expression] = STATE(3560),
    [sym_interpolated_string_expression] = STATE(4559),
    [sym_member_access_expression] = STATE(3560),
    [sym_object_creation_expression] = STATE(4558),
    [sym_parenthesized_expression] = STATE(4558),
    [sym__parenthesized_lvalue_expression] = STATE(3560),
    [sym_lambda_expression] = STATE(4559),
    [sym__lambda_parameters] = STATE(9554),
    [sym_array_creation_expression] = STATE(4559),
    [sym_anonymous_method_expression] = STATE(4559),
    [sym_anonymous_object_creation_expression] = STATE(4559),
    [sym_implicit_array_creation_expression] = STATE(4559),
    [sym_implicit_object_creation_expression] = STATE(4559),
    [sym_implicit_stackalloc_expression] = STATE(4559),
    [sym_initializer_expression] = STATE(4559),
    [sym_default_expression] = STATE(4559),
    [sym_with_expression] = STATE(4559),
    [sym_sizeof_expression] = STATE(4559),
    [sym_typeof_expression] = STATE(4559),
    [sym_makeref_expression] = STATE(4559),
    [sym_ref_expression] = STATE(4559),
    [sym_reftype_expression] = STATE(4559),
    [sym_refvalue_expression] = STATE(4559),
    [sym_stackalloc_expression] = STATE(4559),
    [sym_range_expression] = STATE(4559),
    [sym_tuple_expression] = STATE(3560),
    [sym_literal] = STATE(4559),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4559),
    [sym_preproc_region] = STATE(1975),
    [sym_preproc_endregion] = STATE(1975),
    [sym_preproc_line] = STATE(1975),
    [sym_preproc_pragma] = STATE(1975),
    [sym_preproc_nullable] = STATE(1975),
    [sym_preproc_error] = STATE(1975),
    [sym_preproc_define] = STATE(1975),
    [sym_preproc_undef] = STATE(1975),
    [aux_sym_class_declaration_repeat1] = STATE(3792),
    [aux_sym_lambda_expression_repeat1] = STATE(4202),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(1607),
    [anon_sym_ref] = ACTIONS(1609),
    [anon_sym_LBRACE] = ACTIONS(1611),
    [anon_sym_delegate] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1615),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(1621),
    [anon_sym_TILDE] = ACTIONS(1621),
    [anon_sym_PLUS_PLUS] = ACTIONS(1621),
    [anon_sym_DASH_DASH] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(1619),
    [anon_sym_DASH] = ACTIONS(1619),
    [anon_sym_STAR] = ACTIONS(1625),
    [anon_sym_CARET] = ACTIONS(1621),
    [anon_sym_AMP] = ACTIONS(1621),
    [anon_sym_this] = ACTIONS(1627),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1629),
    [anon_sym_unchecked] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [anon_sym_DOT_DOT] = ACTIONS(1637),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_stackalloc] = ACTIONS(1641),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(1647),
    [anon_sym___reftype] = ACTIONS(1649),
    [anon_sym___refvalue] = ACTIONS(1651),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1659),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [1976] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7094),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4309),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1976),
    [sym_preproc_endregion] = STATE(1976),
    [sym_preproc_line] = STATE(1976),
    [sym_preproc_pragma] = STATE(1976),
    [sym_preproc_nullable] = STATE(1976),
    [sym_preproc_error] = STATE(1976),
    [sym_preproc_define] = STATE(1976),
    [sym_preproc_undef] = STATE(1976),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1669),
    [anon_sym_TILDE] = ACTIONS(1669),
    [anon_sym_PLUS_PLUS] = ACTIONS(1669),
    [anon_sym_DASH_DASH] = ACTIONS(1669),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1667),
    [anon_sym_DASH] = ACTIONS(1667),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1669),
    [anon_sym_AMP] = ACTIONS(1669),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1977] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6910),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2957),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6984),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4941),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(3777),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7387),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9385),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1977),
    [sym_preproc_endregion] = STATE(1977),
    [sym_preproc_line] = STATE(1977),
    [sym_preproc_pragma] = STATE(1977),
    [sym_preproc_nullable] = STATE(1977),
    [sym_preproc_error] = STATE(1977),
    [sym_preproc_define] = STATE(1977),
    [sym_preproc_undef] = STATE(1977),
    [aux_sym_class_declaration_repeat1] = STATE(3793),
    [aux_sym_lambda_expression_repeat1] = STATE(4083),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1795),
    [anon_sym_ref] = ACTIONS(1797),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1799),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1803),
    [anon_sym_TILDE] = ACTIONS(1803),
    [anon_sym_PLUS_PLUS] = ACTIONS(1803),
    [anon_sym_DASH_DASH] = ACTIONS(1803),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1801),
    [anon_sym_DASH] = ACTIONS(1801),
    [anon_sym_STAR] = ACTIONS(1805),
    [anon_sym_CARET] = ACTIONS(1803),
    [anon_sym_AMP] = ACTIONS(1803),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1807),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1809),
    [anon_sym_DOT_DOT] = ACTIONS(1811),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1978] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6910),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2957),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6984),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4940),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(3777),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7387),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9385),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1978),
    [sym_preproc_endregion] = STATE(1978),
    [sym_preproc_line] = STATE(1978),
    [sym_preproc_pragma] = STATE(1978),
    [sym_preproc_nullable] = STATE(1978),
    [sym_preproc_error] = STATE(1978),
    [sym_preproc_define] = STATE(1978),
    [sym_preproc_undef] = STATE(1978),
    [aux_sym_class_declaration_repeat1] = STATE(3793),
    [aux_sym_lambda_expression_repeat1] = STATE(4083),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1795),
    [anon_sym_ref] = ACTIONS(1797),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1799),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1803),
    [anon_sym_TILDE] = ACTIONS(1803),
    [anon_sym_PLUS_PLUS] = ACTIONS(1803),
    [anon_sym_DASH_DASH] = ACTIONS(1803),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1801),
    [anon_sym_DASH] = ACTIONS(1801),
    [anon_sym_STAR] = ACTIONS(1805),
    [anon_sym_CARET] = ACTIONS(1803),
    [anon_sym_AMP] = ACTIONS(1803),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1807),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1809),
    [anon_sym_DOT_DOT] = ACTIONS(1811),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1979] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6910),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2957),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6984),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4936),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(3777),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7387),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9385),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1979),
    [sym_preproc_endregion] = STATE(1979),
    [sym_preproc_line] = STATE(1979),
    [sym_preproc_pragma] = STATE(1979),
    [sym_preproc_nullable] = STATE(1979),
    [sym_preproc_error] = STATE(1979),
    [sym_preproc_define] = STATE(1979),
    [sym_preproc_undef] = STATE(1979),
    [aux_sym_class_declaration_repeat1] = STATE(3793),
    [aux_sym_lambda_expression_repeat1] = STATE(4083),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1795),
    [anon_sym_ref] = ACTIONS(1797),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1799),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1803),
    [anon_sym_TILDE] = ACTIONS(1803),
    [anon_sym_PLUS_PLUS] = ACTIONS(1803),
    [anon_sym_DASH_DASH] = ACTIONS(1803),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1801),
    [anon_sym_DASH] = ACTIONS(1801),
    [anon_sym_STAR] = ACTIONS(1805),
    [anon_sym_CARET] = ACTIONS(1803),
    [anon_sym_AMP] = ACTIONS(1803),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1807),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1809),
    [anon_sym_DOT_DOT] = ACTIONS(1811),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1980] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6961),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4309),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9849),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1980),
    [sym_preproc_endregion] = STATE(1980),
    [sym_preproc_line] = STATE(1980),
    [sym_preproc_pragma] = STATE(1980),
    [sym_preproc_nullable] = STATE(1980),
    [sym_preproc_error] = STATE(1980),
    [sym_preproc_define] = STATE(1980),
    [sym_preproc_undef] = STATE(1980),
    [aux_sym_class_declaration_repeat1] = STATE(3841),
    [aux_sym_lambda_expression_repeat1] = STATE(4283),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1459),
    [anon_sym_ref] = ACTIONS(1461),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1465),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1467),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1469),
    [anon_sym_DOT_DOT] = ACTIONS(1471),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1981] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6910),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2957),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6984),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4943),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(3777),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7387),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9385),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1981),
    [sym_preproc_endregion] = STATE(1981),
    [sym_preproc_line] = STATE(1981),
    [sym_preproc_pragma] = STATE(1981),
    [sym_preproc_nullable] = STATE(1981),
    [sym_preproc_error] = STATE(1981),
    [sym_preproc_define] = STATE(1981),
    [sym_preproc_undef] = STATE(1981),
    [aux_sym_class_declaration_repeat1] = STATE(3793),
    [aux_sym_lambda_expression_repeat1] = STATE(4083),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1795),
    [anon_sym_ref] = ACTIONS(1797),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1799),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1803),
    [anon_sym_TILDE] = ACTIONS(1803),
    [anon_sym_PLUS_PLUS] = ACTIONS(1803),
    [anon_sym_DASH_DASH] = ACTIONS(1803),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1801),
    [anon_sym_DASH] = ACTIONS(1801),
    [anon_sym_STAR] = ACTIONS(1805),
    [anon_sym_CARET] = ACTIONS(1803),
    [anon_sym_AMP] = ACTIONS(1803),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1807),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1809),
    [anon_sym_DOT_DOT] = ACTIONS(1811),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1982] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3559),
    [sym__name] = STATE(6877),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2908),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7129),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4420),
    [sym_non_lvalue_expression] = STATE(4553),
    [sym_lvalue_expression] = STATE(3561),
    [sym__expression_statement_expression] = STATE(4559),
    [sym_assignment_expression] = STATE(4558),
    [sym_binary_expression] = STATE(4559),
    [sym_postfix_unary_expression] = STATE(4558),
    [sym_prefix_unary_expression] = STATE(4558),
    [sym__pointer_indirection_expression] = STATE(3560),
    [sym_query_expression] = STATE(4559),
    [sym_from_clause] = STATE(7385),
    [sym_conditional_expression] = STATE(4559),
    [sym_conditional_access_expression] = STATE(4559),
    [sym_as_expression] = STATE(4559),
    [sym_is_expression] = STATE(4559),
    [sym_is_pattern_expression] = STATE(4559),
    [sym_cast_expression] = STATE(4559),
    [sym_checked_expression] = STATE(4559),
    [sym_invocation_expression] = STATE(4558),
    [sym_switch_expression] = STATE(4559),
    [sym_await_expression] = STATE(4558),
    [sym_throw_expression] = STATE(4559),
    [sym_element_access_expression] = STATE(3560),
    [sym_interpolated_string_expression] = STATE(4559),
    [sym_member_access_expression] = STATE(3560),
    [sym_object_creation_expression] = STATE(4558),
    [sym_parenthesized_expression] = STATE(4558),
    [sym__parenthesized_lvalue_expression] = STATE(3560),
    [sym_lambda_expression] = STATE(4559),
    [sym__lambda_parameters] = STATE(9776),
    [sym_array_creation_expression] = STATE(4559),
    [sym_anonymous_method_expression] = STATE(4559),
    [sym_anonymous_object_creation_expression] = STATE(4559),
    [sym_implicit_array_creation_expression] = STATE(4559),
    [sym_implicit_object_creation_expression] = STATE(4559),
    [sym_implicit_stackalloc_expression] = STATE(4559),
    [sym_initializer_expression] = STATE(4559),
    [sym_default_expression] = STATE(4559),
    [sym_with_expression] = STATE(4559),
    [sym_sizeof_expression] = STATE(4559),
    [sym_typeof_expression] = STATE(4559),
    [sym_makeref_expression] = STATE(4559),
    [sym_ref_expression] = STATE(4559),
    [sym_reftype_expression] = STATE(4559),
    [sym_refvalue_expression] = STATE(4559),
    [sym_stackalloc_expression] = STATE(4559),
    [sym_range_expression] = STATE(4559),
    [sym_tuple_expression] = STATE(3560),
    [sym_literal] = STATE(4559),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4559),
    [sym_preproc_region] = STATE(1982),
    [sym_preproc_endregion] = STATE(1982),
    [sym_preproc_line] = STATE(1982),
    [sym_preproc_pragma] = STATE(1982),
    [sym_preproc_nullable] = STATE(1982),
    [sym_preproc_error] = STATE(1982),
    [sym_preproc_define] = STATE(1982),
    [sym_preproc_undef] = STATE(1982),
    [aux_sym_class_declaration_repeat1] = STATE(3843),
    [aux_sym_lambda_expression_repeat1] = STATE(4277),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(1675),
    [anon_sym_ref] = ACTIONS(1677),
    [anon_sym_LBRACE] = ACTIONS(1611),
    [anon_sym_delegate] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1679),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(1683),
    [anon_sym_TILDE] = ACTIONS(1683),
    [anon_sym_PLUS_PLUS] = ACTIONS(1683),
    [anon_sym_DASH_DASH] = ACTIONS(1683),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_DASH] = ACTIONS(1681),
    [anon_sym_STAR] = ACTIONS(1685),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1683),
    [anon_sym_this] = ACTIONS(1627),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1629),
    [anon_sym_unchecked] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(1687),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1689),
    [anon_sym_DOT_DOT] = ACTIONS(1691),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_stackalloc] = ACTIONS(1641),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(1647),
    [anon_sym___reftype] = ACTIONS(1649),
    [anon_sym___refvalue] = ACTIONS(1651),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1659),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [1983] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3921),
    [sym__name] = STATE(6889),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2854),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(6991),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5533),
    [sym_non_lvalue_expression] = STATE(5735),
    [sym_lvalue_expression] = STATE(4295),
    [sym__expression_statement_expression] = STATE(5733),
    [sym_assignment_expression] = STATE(5734),
    [sym_binary_expression] = STATE(5733),
    [sym_postfix_unary_expression] = STATE(5734),
    [sym_prefix_unary_expression] = STATE(5734),
    [sym__pointer_indirection_expression] = STATE(3911),
    [sym_query_expression] = STATE(5733),
    [sym_from_clause] = STATE(7393),
    [sym_conditional_expression] = STATE(5733),
    [sym_conditional_access_expression] = STATE(5733),
    [sym_as_expression] = STATE(5733),
    [sym_is_expression] = STATE(5733),
    [sym_is_pattern_expression] = STATE(5733),
    [sym_cast_expression] = STATE(5733),
    [sym_checked_expression] = STATE(5733),
    [sym_invocation_expression] = STATE(5734),
    [sym_switch_expression] = STATE(5733),
    [sym_await_expression] = STATE(5734),
    [sym_throw_expression] = STATE(5733),
    [sym_element_access_expression] = STATE(3911),
    [sym_interpolated_string_expression] = STATE(5733),
    [sym_member_access_expression] = STATE(3911),
    [sym_object_creation_expression] = STATE(5734),
    [sym_parenthesized_expression] = STATE(5734),
    [sym__parenthesized_lvalue_expression] = STATE(3911),
    [sym_lambda_expression] = STATE(5733),
    [sym__lambda_parameters] = STATE(9313),
    [sym_array_creation_expression] = STATE(5733),
    [sym_anonymous_method_expression] = STATE(5733),
    [sym_anonymous_object_creation_expression] = STATE(5733),
    [sym_implicit_array_creation_expression] = STATE(5733),
    [sym_implicit_object_creation_expression] = STATE(5733),
    [sym_implicit_stackalloc_expression] = STATE(5733),
    [sym_initializer_expression] = STATE(5733),
    [sym_default_expression] = STATE(5733),
    [sym_with_expression] = STATE(5733),
    [sym_sizeof_expression] = STATE(5733),
    [sym_typeof_expression] = STATE(5733),
    [sym_makeref_expression] = STATE(5733),
    [sym_ref_expression] = STATE(5733),
    [sym_reftype_expression] = STATE(5733),
    [sym_refvalue_expression] = STATE(5733),
    [sym_stackalloc_expression] = STATE(5733),
    [sym_range_expression] = STATE(5733),
    [sym_tuple_expression] = STATE(3911),
    [sym_literal] = STATE(5733),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2798),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(5733),
    [sym_preproc_region] = STATE(1983),
    [sym_preproc_endregion] = STATE(1983),
    [sym_preproc_line] = STATE(1983),
    [sym_preproc_pragma] = STATE(1983),
    [sym_preproc_nullable] = STATE(1983),
    [sym_preproc_error] = STATE(1983),
    [sym_preproc_define] = STATE(1983),
    [sym_preproc_undef] = STATE(1983),
    [aux_sym_class_declaration_repeat1] = STATE(3805),
    [aux_sym_lambda_expression_repeat1] = STATE(4122),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_LPAREN] = ACTIONS(1591),
    [anon_sym_ref] = ACTIONS(1593),
    [anon_sym_LBRACE] = ACTIONS(1377),
    [anon_sym_delegate] = ACTIONS(1379),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1443),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1597),
    [anon_sym_TILDE] = ACTIONS(1597),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1595),
    [anon_sym_DASH] = ACTIONS(1595),
    [anon_sym_STAR] = ACTIONS(1449),
    [anon_sym_CARET] = ACTIONS(1597),
    [anon_sym_AMP] = ACTIONS(1597),
    [anon_sym_this] = ACTIONS(1393),
    [anon_sym_scoped] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1397),
    [sym_predefined_type] = ACTIONS(1399),
    [anon_sym_unchecked] = ACTIONS(1383),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1599),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1601),
    [anon_sym_DOT_DOT] = ACTIONS(1603),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_stackalloc] = ACTIONS(1413),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(1419),
    [anon_sym___reftype] = ACTIONS(1421),
    [anon_sym___refvalue] = ACTIONS(1423),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
  },
  [1984] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6910),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2957),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6984),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4918),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(3777),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7387),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9385),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1984),
    [sym_preproc_endregion] = STATE(1984),
    [sym_preproc_line] = STATE(1984),
    [sym_preproc_pragma] = STATE(1984),
    [sym_preproc_nullable] = STATE(1984),
    [sym_preproc_error] = STATE(1984),
    [sym_preproc_define] = STATE(1984),
    [sym_preproc_undef] = STATE(1984),
    [aux_sym_class_declaration_repeat1] = STATE(3793),
    [aux_sym_lambda_expression_repeat1] = STATE(4083),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1795),
    [anon_sym_ref] = ACTIONS(1797),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1799),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1803),
    [anon_sym_TILDE] = ACTIONS(1803),
    [anon_sym_PLUS_PLUS] = ACTIONS(1803),
    [anon_sym_DASH_DASH] = ACTIONS(1803),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1801),
    [anon_sym_DASH] = ACTIONS(1801),
    [anon_sym_STAR] = ACTIONS(1805),
    [anon_sym_CARET] = ACTIONS(1803),
    [anon_sym_AMP] = ACTIONS(1803),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1807),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1809),
    [anon_sym_DOT_DOT] = ACTIONS(1811),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1985] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7075),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6077),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4120),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9121),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1985),
    [sym_preproc_endregion] = STATE(1985),
    [sym_preproc_line] = STATE(1985),
    [sym_preproc_pragma] = STATE(1985),
    [sym_preproc_nullable] = STATE(1985),
    [sym_preproc_error] = STATE(1985),
    [sym_preproc_define] = STATE(1985),
    [sym_preproc_undef] = STATE(1985),
    [aux_sym_class_declaration_repeat1] = STATE(3806),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_ref] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1986] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7094),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5936),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1986),
    [sym_preproc_endregion] = STATE(1986),
    [sym_preproc_line] = STATE(1986),
    [sym_preproc_pragma] = STATE(1986),
    [sym_preproc_nullable] = STATE(1986),
    [sym_preproc_error] = STATE(1986),
    [sym_preproc_define] = STATE(1986),
    [sym_preproc_undef] = STATE(1986),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1669),
    [anon_sym_TILDE] = ACTIONS(1669),
    [anon_sym_PLUS_PLUS] = ACTIONS(1669),
    [anon_sym_DASH_DASH] = ACTIONS(1669),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1667),
    [anon_sym_DASH] = ACTIONS(1667),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1669),
    [anon_sym_AMP] = ACTIONS(1669),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1987] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3559),
    [sym__name] = STATE(6877),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2908),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7129),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4424),
    [sym_non_lvalue_expression] = STATE(4553),
    [sym_lvalue_expression] = STATE(3561),
    [sym__expression_statement_expression] = STATE(4559),
    [sym_assignment_expression] = STATE(4558),
    [sym_binary_expression] = STATE(4559),
    [sym_postfix_unary_expression] = STATE(4558),
    [sym_prefix_unary_expression] = STATE(4558),
    [sym__pointer_indirection_expression] = STATE(3560),
    [sym_query_expression] = STATE(4559),
    [sym_from_clause] = STATE(7385),
    [sym_conditional_expression] = STATE(4559),
    [sym_conditional_access_expression] = STATE(4559),
    [sym_as_expression] = STATE(4559),
    [sym_is_expression] = STATE(4559),
    [sym_is_pattern_expression] = STATE(4559),
    [sym_cast_expression] = STATE(4559),
    [sym_checked_expression] = STATE(4559),
    [sym_invocation_expression] = STATE(4558),
    [sym_switch_expression] = STATE(4559),
    [sym_await_expression] = STATE(4558),
    [sym_throw_expression] = STATE(4559),
    [sym_element_access_expression] = STATE(3560),
    [sym_interpolated_string_expression] = STATE(4559),
    [sym_member_access_expression] = STATE(3560),
    [sym_object_creation_expression] = STATE(4558),
    [sym_parenthesized_expression] = STATE(4558),
    [sym__parenthesized_lvalue_expression] = STATE(3560),
    [sym_lambda_expression] = STATE(4559),
    [sym__lambda_parameters] = STATE(9776),
    [sym_array_creation_expression] = STATE(4559),
    [sym_anonymous_method_expression] = STATE(4559),
    [sym_anonymous_object_creation_expression] = STATE(4559),
    [sym_implicit_array_creation_expression] = STATE(4559),
    [sym_implicit_object_creation_expression] = STATE(4559),
    [sym_implicit_stackalloc_expression] = STATE(4559),
    [sym_initializer_expression] = STATE(4559),
    [sym_default_expression] = STATE(4559),
    [sym_with_expression] = STATE(4559),
    [sym_sizeof_expression] = STATE(4559),
    [sym_typeof_expression] = STATE(4559),
    [sym_makeref_expression] = STATE(4559),
    [sym_ref_expression] = STATE(4559),
    [sym_reftype_expression] = STATE(4559),
    [sym_refvalue_expression] = STATE(4559),
    [sym_stackalloc_expression] = STATE(4559),
    [sym_range_expression] = STATE(4559),
    [sym_tuple_expression] = STATE(3560),
    [sym_literal] = STATE(4559),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4559),
    [sym_preproc_region] = STATE(1987),
    [sym_preproc_endregion] = STATE(1987),
    [sym_preproc_line] = STATE(1987),
    [sym_preproc_pragma] = STATE(1987),
    [sym_preproc_nullable] = STATE(1987),
    [sym_preproc_error] = STATE(1987),
    [sym_preproc_define] = STATE(1987),
    [sym_preproc_undef] = STATE(1987),
    [aux_sym_class_declaration_repeat1] = STATE(3843),
    [aux_sym_lambda_expression_repeat1] = STATE(4277),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(1675),
    [anon_sym_ref] = ACTIONS(1677),
    [anon_sym_LBRACE] = ACTIONS(1611),
    [anon_sym_delegate] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1679),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(1683),
    [anon_sym_TILDE] = ACTIONS(1683),
    [anon_sym_PLUS_PLUS] = ACTIONS(1683),
    [anon_sym_DASH_DASH] = ACTIONS(1683),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_DASH] = ACTIONS(1681),
    [anon_sym_STAR] = ACTIONS(1685),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1683),
    [anon_sym_this] = ACTIONS(1627),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1629),
    [anon_sym_unchecked] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(1687),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1689),
    [anon_sym_DOT_DOT] = ACTIONS(1691),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_stackalloc] = ACTIONS(1641),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(1647),
    [anon_sym___reftype] = ACTIONS(1649),
    [anon_sym___refvalue] = ACTIONS(1651),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1659),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [1988] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7108),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(3902),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4313),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7382),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9733),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(1988),
    [sym_preproc_endregion] = STATE(1988),
    [sym_preproc_line] = STATE(1988),
    [sym_preproc_pragma] = STATE(1988),
    [sym_preproc_nullable] = STATE(1988),
    [sym_preproc_error] = STATE(1988),
    [sym_preproc_define] = STATE(1988),
    [sym_preproc_undef] = STATE(1988),
    [aux_sym_class_declaration_repeat1] = STATE(3802),
    [aux_sym_lambda_expression_repeat1] = STATE(4108),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1519),
    [anon_sym_ref] = ACTIONS(1521),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1523),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1529),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1531),
    [anon_sym_DOT_DOT] = ACTIONS(1533),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1989] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7080),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6450),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4477),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9873),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1989),
    [sym_preproc_endregion] = STATE(1989),
    [sym_preproc_line] = STATE(1989),
    [sym_preproc_pragma] = STATE(1989),
    [sym_preproc_nullable] = STATE(1989),
    [sym_preproc_error] = STATE(1989),
    [sym_preproc_define] = STATE(1989),
    [sym_preproc_undef] = STATE(1989),
    [aux_sym_class_declaration_repeat1] = STATE(3845),
    [aux_sym_lambda_expression_repeat1] = STATE(4299),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1979),
    [anon_sym_ref] = ACTIONS(1981),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1985),
    [anon_sym_TILDE] = ACTIONS(1985),
    [anon_sym_PLUS_PLUS] = ACTIONS(1985),
    [anon_sym_DASH_DASH] = ACTIONS(1985),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1983),
    [anon_sym_DASH] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1985),
    [anon_sym_AMP] = ACTIONS(1985),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1987),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1989),
    [anon_sym_DOT_DOT] = ACTIONS(1991),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1990] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6910),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2957),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6984),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4919),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(3777),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7387),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9385),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1990),
    [sym_preproc_endregion] = STATE(1990),
    [sym_preproc_line] = STATE(1990),
    [sym_preproc_pragma] = STATE(1990),
    [sym_preproc_nullable] = STATE(1990),
    [sym_preproc_error] = STATE(1990),
    [sym_preproc_define] = STATE(1990),
    [sym_preproc_undef] = STATE(1990),
    [aux_sym_class_declaration_repeat1] = STATE(3793),
    [aux_sym_lambda_expression_repeat1] = STATE(4083),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1795),
    [anon_sym_ref] = ACTIONS(1797),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1799),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1803),
    [anon_sym_TILDE] = ACTIONS(1803),
    [anon_sym_PLUS_PLUS] = ACTIONS(1803),
    [anon_sym_DASH_DASH] = ACTIONS(1803),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1801),
    [anon_sym_DASH] = ACTIONS(1801),
    [anon_sym_STAR] = ACTIONS(1805),
    [anon_sym_CARET] = ACTIONS(1803),
    [anon_sym_AMP] = ACTIONS(1803),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1807),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1809),
    [anon_sym_DOT_DOT] = ACTIONS(1811),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1991] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7080),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4325),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4477),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9873),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1991),
    [sym_preproc_endregion] = STATE(1991),
    [sym_preproc_line] = STATE(1991),
    [sym_preproc_pragma] = STATE(1991),
    [sym_preproc_nullable] = STATE(1991),
    [sym_preproc_error] = STATE(1991),
    [sym_preproc_define] = STATE(1991),
    [sym_preproc_undef] = STATE(1991),
    [aux_sym_class_declaration_repeat1] = STATE(3845),
    [aux_sym_lambda_expression_repeat1] = STATE(4299),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1979),
    [anon_sym_ref] = ACTIONS(1981),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1985),
    [anon_sym_TILDE] = ACTIONS(1985),
    [anon_sym_PLUS_PLUS] = ACTIONS(1985),
    [anon_sym_DASH_DASH] = ACTIONS(1985),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1983),
    [anon_sym_DASH] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1985),
    [anon_sym_AMP] = ACTIONS(1985),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1987),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1989),
    [anon_sym_DOT_DOT] = ACTIONS(1991),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1992] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7080),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6492),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4477),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9873),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1992),
    [sym_preproc_endregion] = STATE(1992),
    [sym_preproc_line] = STATE(1992),
    [sym_preproc_pragma] = STATE(1992),
    [sym_preproc_nullable] = STATE(1992),
    [sym_preproc_error] = STATE(1992),
    [sym_preproc_define] = STATE(1992),
    [sym_preproc_undef] = STATE(1992),
    [aux_sym_class_declaration_repeat1] = STATE(3845),
    [aux_sym_lambda_expression_repeat1] = STATE(4299),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1979),
    [anon_sym_ref] = ACTIONS(1981),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1985),
    [anon_sym_TILDE] = ACTIONS(1985),
    [anon_sym_PLUS_PLUS] = ACTIONS(1985),
    [anon_sym_DASH_DASH] = ACTIONS(1985),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1983),
    [anon_sym_DASH] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1985),
    [anon_sym_AMP] = ACTIONS(1985),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1987),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1989),
    [anon_sym_DOT_DOT] = ACTIONS(1991),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1993] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6894),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2955),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7046),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4960),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(3786),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7408),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9363),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(1993),
    [sym_preproc_endregion] = STATE(1993),
    [sym_preproc_line] = STATE(1993),
    [sym_preproc_pragma] = STATE(1993),
    [sym_preproc_nullable] = STATE(1993),
    [sym_preproc_error] = STATE(1993),
    [sym_preproc_define] = STATE(1993),
    [sym_preproc_undef] = STATE(1993),
    [aux_sym_class_declaration_repeat1] = STATE(3811),
    [aux_sym_lambda_expression_repeat1] = STATE(4149),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(2069),
    [anon_sym_ref] = ACTIONS(2071),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1853),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(2075),
    [anon_sym_TILDE] = ACTIONS(2075),
    [anon_sym_PLUS_PLUS] = ACTIONS(2075),
    [anon_sym_DASH_DASH] = ACTIONS(2075),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2073),
    [anon_sym_DASH] = ACTIONS(2073),
    [anon_sym_STAR] = ACTIONS(1859),
    [anon_sym_CARET] = ACTIONS(2075),
    [anon_sym_AMP] = ACTIONS(2075),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2077),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2079),
    [anon_sym_DOT_DOT] = ACTIONS(2081),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [1994] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7094),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5811),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1994),
    [sym_preproc_endregion] = STATE(1994),
    [sym_preproc_line] = STATE(1994),
    [sym_preproc_pragma] = STATE(1994),
    [sym_preproc_nullable] = STATE(1994),
    [sym_preproc_error] = STATE(1994),
    [sym_preproc_define] = STATE(1994),
    [sym_preproc_undef] = STATE(1994),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1669),
    [anon_sym_TILDE] = ACTIONS(1669),
    [anon_sym_PLUS_PLUS] = ACTIONS(1669),
    [anon_sym_DASH_DASH] = ACTIONS(1669),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1667),
    [anon_sym_DASH] = ACTIONS(1667),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1669),
    [anon_sym_AMP] = ACTIONS(1669),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1995] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3921),
    [sym__name] = STATE(6889),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2854),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(6991),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5120),
    [sym_non_lvalue_expression] = STATE(5735),
    [sym_lvalue_expression] = STATE(4295),
    [sym__expression_statement_expression] = STATE(5733),
    [sym_assignment_expression] = STATE(5734),
    [sym_binary_expression] = STATE(5733),
    [sym_postfix_unary_expression] = STATE(5734),
    [sym_prefix_unary_expression] = STATE(5734),
    [sym__pointer_indirection_expression] = STATE(3911),
    [sym_query_expression] = STATE(5733),
    [sym_from_clause] = STATE(7393),
    [sym_conditional_expression] = STATE(5733),
    [sym_conditional_access_expression] = STATE(5733),
    [sym_as_expression] = STATE(5733),
    [sym_is_expression] = STATE(5733),
    [sym_is_pattern_expression] = STATE(5733),
    [sym_cast_expression] = STATE(5733),
    [sym_checked_expression] = STATE(5733),
    [sym_invocation_expression] = STATE(5734),
    [sym_switch_expression] = STATE(5733),
    [sym_await_expression] = STATE(5734),
    [sym_throw_expression] = STATE(5733),
    [sym_element_access_expression] = STATE(3911),
    [sym_interpolated_string_expression] = STATE(5733),
    [sym_member_access_expression] = STATE(3911),
    [sym_object_creation_expression] = STATE(5734),
    [sym_parenthesized_expression] = STATE(5734),
    [sym__parenthesized_lvalue_expression] = STATE(3911),
    [sym_lambda_expression] = STATE(5733),
    [sym__lambda_parameters] = STATE(9313),
    [sym_array_creation_expression] = STATE(5733),
    [sym_anonymous_method_expression] = STATE(5733),
    [sym_anonymous_object_creation_expression] = STATE(5733),
    [sym_implicit_array_creation_expression] = STATE(5733),
    [sym_implicit_object_creation_expression] = STATE(5733),
    [sym_implicit_stackalloc_expression] = STATE(5733),
    [sym_initializer_expression] = STATE(5733),
    [sym_default_expression] = STATE(5733),
    [sym_with_expression] = STATE(5733),
    [sym_sizeof_expression] = STATE(5733),
    [sym_typeof_expression] = STATE(5733),
    [sym_makeref_expression] = STATE(5733),
    [sym_ref_expression] = STATE(5733),
    [sym_reftype_expression] = STATE(5733),
    [sym_refvalue_expression] = STATE(5733),
    [sym_stackalloc_expression] = STATE(5733),
    [sym_range_expression] = STATE(5733),
    [sym_tuple_expression] = STATE(3911),
    [sym_literal] = STATE(5733),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2798),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(5733),
    [sym_preproc_region] = STATE(1995),
    [sym_preproc_endregion] = STATE(1995),
    [sym_preproc_line] = STATE(1995),
    [sym_preproc_pragma] = STATE(1995),
    [sym_preproc_nullable] = STATE(1995),
    [sym_preproc_error] = STATE(1995),
    [sym_preproc_define] = STATE(1995),
    [sym_preproc_undef] = STATE(1995),
    [aux_sym_class_declaration_repeat1] = STATE(3805),
    [aux_sym_lambda_expression_repeat1] = STATE(4122),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_LPAREN] = ACTIONS(1591),
    [anon_sym_ref] = ACTIONS(1593),
    [anon_sym_LBRACE] = ACTIONS(1377),
    [anon_sym_delegate] = ACTIONS(1379),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1443),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1597),
    [anon_sym_TILDE] = ACTIONS(1597),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1595),
    [anon_sym_DASH] = ACTIONS(1595),
    [anon_sym_STAR] = ACTIONS(1449),
    [anon_sym_CARET] = ACTIONS(1597),
    [anon_sym_AMP] = ACTIONS(1597),
    [anon_sym_this] = ACTIONS(1393),
    [anon_sym_scoped] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1397),
    [sym_predefined_type] = ACTIONS(1399),
    [anon_sym_unchecked] = ACTIONS(1383),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1599),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1601),
    [anon_sym_DOT_DOT] = ACTIONS(1603),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_stackalloc] = ACTIONS(1413),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(1419),
    [anon_sym___reftype] = ACTIONS(1421),
    [anon_sym___refvalue] = ACTIONS(1423),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
  },
  [1996] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6961),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5443),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9849),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1996),
    [sym_preproc_endregion] = STATE(1996),
    [sym_preproc_line] = STATE(1996),
    [sym_preproc_pragma] = STATE(1996),
    [sym_preproc_nullable] = STATE(1996),
    [sym_preproc_error] = STATE(1996),
    [sym_preproc_define] = STATE(1996),
    [sym_preproc_undef] = STATE(1996),
    [aux_sym_class_declaration_repeat1] = STATE(3841),
    [aux_sym_lambda_expression_repeat1] = STATE(4283),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1459),
    [anon_sym_ref] = ACTIONS(1461),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1465),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1467),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1469),
    [anon_sym_DOT_DOT] = ACTIONS(1471),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1997] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6961),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5444),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9849),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1997),
    [sym_preproc_endregion] = STATE(1997),
    [sym_preproc_line] = STATE(1997),
    [sym_preproc_pragma] = STATE(1997),
    [sym_preproc_nullable] = STATE(1997),
    [sym_preproc_error] = STATE(1997),
    [sym_preproc_define] = STATE(1997),
    [sym_preproc_undef] = STATE(1997),
    [aux_sym_class_declaration_repeat1] = STATE(3841),
    [aux_sym_lambda_expression_repeat1] = STATE(4283),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1459),
    [anon_sym_ref] = ACTIONS(1461),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1465),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1467),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1469),
    [anon_sym_DOT_DOT] = ACTIONS(1471),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1998] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6961),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5446),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9849),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1998),
    [sym_preproc_endregion] = STATE(1998),
    [sym_preproc_line] = STATE(1998),
    [sym_preproc_pragma] = STATE(1998),
    [sym_preproc_nullable] = STATE(1998),
    [sym_preproc_error] = STATE(1998),
    [sym_preproc_define] = STATE(1998),
    [sym_preproc_undef] = STATE(1998),
    [aux_sym_class_declaration_repeat1] = STATE(3841),
    [aux_sym_lambda_expression_repeat1] = STATE(4283),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1459),
    [anon_sym_ref] = ACTIONS(1461),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1465),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1467),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1469),
    [anon_sym_DOT_DOT] = ACTIONS(1471),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [1999] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3921),
    [sym__name] = STATE(6889),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2854),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(7094),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6676),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(3886),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3911),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3911),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3911),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3911),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3911),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2798),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(1999),
    [sym_preproc_endregion] = STATE(1999),
    [sym_preproc_line] = STATE(1999),
    [sym_preproc_pragma] = STATE(1999),
    [sym_preproc_nullable] = STATE(1999),
    [sym_preproc_error] = STATE(1999),
    [sym_preproc_define] = STATE(1999),
    [sym_preproc_undef] = STATE(1999),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_LPAREN] = ACTIONS(2917),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1669),
    [anon_sym_TILDE] = ACTIONS(1669),
    [anon_sym_PLUS_PLUS] = ACTIONS(1669),
    [anon_sym_DASH_DASH] = ACTIONS(1669),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1667),
    [anon_sym_DASH] = ACTIONS(1667),
    [anon_sym_STAR] = ACTIONS(1449),
    [anon_sym_CARET] = ACTIONS(1669),
    [anon_sym_AMP] = ACTIONS(1669),
    [anon_sym_this] = ACTIONS(1393),
    [anon_sym_scoped] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1397),
    [sym_predefined_type] = ACTIONS(1399),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1673),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [2000] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6961),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5448),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9849),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(2000),
    [sym_preproc_endregion] = STATE(2000),
    [sym_preproc_line] = STATE(2000),
    [sym_preproc_pragma] = STATE(2000),
    [sym_preproc_nullable] = STATE(2000),
    [sym_preproc_error] = STATE(2000),
    [sym_preproc_define] = STATE(2000),
    [sym_preproc_undef] = STATE(2000),
    [aux_sym_class_declaration_repeat1] = STATE(3841),
    [aux_sym_lambda_expression_repeat1] = STATE(4283),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1459),
    [anon_sym_ref] = ACTIONS(1461),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1465),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1467),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1469),
    [anon_sym_DOT_DOT] = ACTIONS(1471),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [2001] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6961),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5429),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9849),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(2001),
    [sym_preproc_endregion] = STATE(2001),
    [sym_preproc_line] = STATE(2001),
    [sym_preproc_pragma] = STATE(2001),
    [sym_preproc_nullable] = STATE(2001),
    [sym_preproc_error] = STATE(2001),
    [sym_preproc_define] = STATE(2001),
    [sym_preproc_undef] = STATE(2001),
    [aux_sym_class_declaration_repeat1] = STATE(3841),
    [aux_sym_lambda_expression_repeat1] = STATE(4283),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1459),
    [anon_sym_ref] = ACTIONS(1461),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1465),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1467),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1469),
    [anon_sym_DOT_DOT] = ACTIONS(1471),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [2002] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6961),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5451),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9849),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(2002),
    [sym_preproc_endregion] = STATE(2002),
    [sym_preproc_line] = STATE(2002),
    [sym_preproc_pragma] = STATE(2002),
    [sym_preproc_nullable] = STATE(2002),
    [sym_preproc_error] = STATE(2002),
    [sym_preproc_define] = STATE(2002),
    [sym_preproc_undef] = STATE(2002),
    [aux_sym_class_declaration_repeat1] = STATE(3841),
    [aux_sym_lambda_expression_repeat1] = STATE(4283),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1459),
    [anon_sym_ref] = ACTIONS(1461),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1465),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1467),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1469),
    [anon_sym_DOT_DOT] = ACTIONS(1471),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [2003] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6961),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5452),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9849),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(2003),
    [sym_preproc_endregion] = STATE(2003),
    [sym_preproc_line] = STATE(2003),
    [sym_preproc_pragma] = STATE(2003),
    [sym_preproc_nullable] = STATE(2003),
    [sym_preproc_error] = STATE(2003),
    [sym_preproc_define] = STATE(2003),
    [sym_preproc_undef] = STATE(2003),
    [aux_sym_class_declaration_repeat1] = STATE(3841),
    [aux_sym_lambda_expression_repeat1] = STATE(4283),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1459),
    [anon_sym_ref] = ACTIONS(1461),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1465),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1467),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1469),
    [anon_sym_DOT_DOT] = ACTIONS(1471),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [2004] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6961),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5454),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9849),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(2004),
    [sym_preproc_endregion] = STATE(2004),
    [sym_preproc_line] = STATE(2004),
    [sym_preproc_pragma] = STATE(2004),
    [sym_preproc_nullable] = STATE(2004),
    [sym_preproc_error] = STATE(2004),
    [sym_preproc_define] = STATE(2004),
    [sym_preproc_undef] = STATE(2004),
    [aux_sym_class_declaration_repeat1] = STATE(3841),
    [aux_sym_lambda_expression_repeat1] = STATE(4283),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1459),
    [anon_sym_ref] = ACTIONS(1461),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1465),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1467),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1469),
    [anon_sym_DOT_DOT] = ACTIONS(1471),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [2005] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6961),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5455),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9849),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(2005),
    [sym_preproc_endregion] = STATE(2005),
    [sym_preproc_line] = STATE(2005),
    [sym_preproc_pragma] = STATE(2005),
    [sym_preproc_nullable] = STATE(2005),
    [sym_preproc_error] = STATE(2005),
    [sym_preproc_define] = STATE(2005),
    [sym_preproc_undef] = STATE(2005),
    [aux_sym_class_declaration_repeat1] = STATE(3841),
    [aux_sym_lambda_expression_repeat1] = STATE(4283),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1459),
    [anon_sym_ref] = ACTIONS(1461),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1465),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1467),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1469),
    [anon_sym_DOT_DOT] = ACTIONS(1471),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [2006] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6961),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5456),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9849),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(2006),
    [sym_preproc_endregion] = STATE(2006),
    [sym_preproc_line] = STATE(2006),
    [sym_preproc_pragma] = STATE(2006),
    [sym_preproc_nullable] = STATE(2006),
    [sym_preproc_error] = STATE(2006),
    [sym_preproc_define] = STATE(2006),
    [sym_preproc_undef] = STATE(2006),
    [aux_sym_class_declaration_repeat1] = STATE(3841),
    [aux_sym_lambda_expression_repeat1] = STATE(4283),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1459),
    [anon_sym_ref] = ACTIONS(1461),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1465),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1467),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1469),
    [anon_sym_DOT_DOT] = ACTIONS(1471),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [2007] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6910),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2957),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6984),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4920),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(3777),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7387),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9385),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(2007),
    [sym_preproc_endregion] = STATE(2007),
    [sym_preproc_line] = STATE(2007),
    [sym_preproc_pragma] = STATE(2007),
    [sym_preproc_nullable] = STATE(2007),
    [sym_preproc_error] = STATE(2007),
    [sym_preproc_define] = STATE(2007),
    [sym_preproc_undef] = STATE(2007),
    [aux_sym_class_declaration_repeat1] = STATE(3793),
    [aux_sym_lambda_expression_repeat1] = STATE(4083),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1795),
    [anon_sym_ref] = ACTIONS(1797),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1799),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1803),
    [anon_sym_TILDE] = ACTIONS(1803),
    [anon_sym_PLUS_PLUS] = ACTIONS(1803),
    [anon_sym_DASH_DASH] = ACTIONS(1803),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1801),
    [anon_sym_DASH] = ACTIONS(1801),
    [anon_sym_STAR] = ACTIONS(1805),
    [anon_sym_CARET] = ACTIONS(1803),
    [anon_sym_AMP] = ACTIONS(1803),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1807),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1809),
    [anon_sym_DOT_DOT] = ACTIONS(1811),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [2008] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6961),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5457),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4131),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9849),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(2008),
    [sym_preproc_endregion] = STATE(2008),
    [sym_preproc_line] = STATE(2008),
    [sym_preproc_pragma] = STATE(2008),
    [sym_preproc_nullable] = STATE(2008),
    [sym_preproc_error] = STATE(2008),
    [sym_preproc_define] = STATE(2008),
    [sym_preproc_undef] = STATE(2008),
    [aux_sym_class_declaration_repeat1] = STATE(3841),
    [aux_sym_lambda_expression_repeat1] = STATE(4283),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1459),
    [anon_sym_ref] = ACTIONS(1461),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1465),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1467),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1469),
    [anon_sym_DOT_DOT] = ACTIONS(1471),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [2009] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3921),
    [sym__name] = STATE(6889),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2854),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(7061),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5123),
    [sym_non_lvalue_expression] = STATE(5735),
    [sym_lvalue_expression] = STATE(3899),
    [sym__expression_statement_expression] = STATE(5733),
    [sym_assignment_expression] = STATE(5734),
    [sym_binary_expression] = STATE(5733),
    [sym_postfix_unary_expression] = STATE(5734),
    [sym_prefix_unary_expression] = STATE(5734),
    [sym__pointer_indirection_expression] = STATE(3911),
    [sym_query_expression] = STATE(5733),
    [sym_from_clause] = STATE(7400),
    [sym_conditional_expression] = STATE(5733),
    [sym_conditional_access_expression] = STATE(5733),
    [sym_as_expression] = STATE(5733),
    [sym_is_expression] = STATE(5733),
    [sym_is_pattern_expression] = STATE(5733),
    [sym_cast_expression] = STATE(5733),
    [sym_checked_expression] = STATE(5733),
    [sym_invocation_expression] = STATE(5734),
    [sym_switch_expression] = STATE(5733),
    [sym_await_expression] = STATE(5734),
    [sym_throw_expression] = STATE(5733),
    [sym_element_access_expression] = STATE(3911),
    [sym_interpolated_string_expression] = STATE(5733),
    [sym_member_access_expression] = STATE(3911),
    [sym_object_creation_expression] = STATE(5734),
    [sym_parenthesized_expression] = STATE(5734),
    [sym__parenthesized_lvalue_expression] = STATE(3911),
    [sym_lambda_expression] = STATE(5733),
    [sym__lambda_parameters] = STATE(9790),
    [sym_array_creation_expression] = STATE(5733),
    [sym_anonymous_method_expression] = STATE(5733),
    [sym_anonymous_object_creation_expression] = STATE(5733),
    [sym_implicit_array_creation_expression] = STATE(5733),
    [sym_implicit_object_creation_expression] = STATE(5733),
    [sym_implicit_stackalloc_expression] = STATE(5733),
    [sym_initializer_expression] = STATE(5733),
    [sym_default_expression] = STATE(5733),
    [sym_with_expression] = STATE(5733),
    [sym_sizeof_expression] = STATE(5733),
    [sym_typeof_expression] = STATE(5733),
    [sym_makeref_expression] = STATE(5733),
    [sym_ref_expression] = STATE(5733),
    [sym_reftype_expression] = STATE(5733),
    [sym_refvalue_expression] = STATE(5733),
    [sym_stackalloc_expression] = STATE(5733),
    [sym_range_expression] = STATE(5733),
    [sym_tuple_expression] = STATE(3911),
    [sym_literal] = STATE(5733),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2798),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(5733),
    [sym_preproc_region] = STATE(2009),
    [sym_preproc_endregion] = STATE(2009),
    [sym_preproc_line] = STATE(2009),
    [sym_preproc_pragma] = STATE(2009),
    [sym_preproc_nullable] = STATE(2009),
    [sym_preproc_error] = STATE(2009),
    [sym_preproc_define] = STATE(2009),
    [sym_preproc_undef] = STATE(2009),
    [aux_sym_class_declaration_repeat1] = STATE(3833),
    [aux_sym_lambda_expression_repeat1] = STATE(4182),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_LPAREN] = ACTIONS(1439),
    [anon_sym_ref] = ACTIONS(1441),
    [anon_sym_LBRACE] = ACTIONS(1377),
    [anon_sym_delegate] = ACTIONS(1379),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1443),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1447),
    [anon_sym_TILDE] = ACTIONS(1447),
    [anon_sym_PLUS_PLUS] = ACTIONS(1447),
    [anon_sym_DASH_DASH] = ACTIONS(1447),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1445),
    [anon_sym_DASH] = ACTIONS(1445),
    [anon_sym_STAR] = ACTIONS(1449),
    [anon_sym_CARET] = ACTIONS(1447),
    [anon_sym_AMP] = ACTIONS(1447),
    [anon_sym_this] = ACTIONS(1393),
    [anon_sym_scoped] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1397),
    [sym_predefined_type] = ACTIONS(1399),
    [anon_sym_unchecked] = ACTIONS(1383),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1451),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1453),
    [anon_sym_DOT_DOT] = ACTIONS(1455),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_stackalloc] = ACTIONS(1413),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(1419),
    [anon_sym___reftype] = ACTIONS(1421),
    [anon_sym___refvalue] = ACTIONS(1423),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
  },
  [2010] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3921),
    [sym__name] = STATE(6889),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2854),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(7061),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5195),
    [sym_non_lvalue_expression] = STATE(5735),
    [sym_lvalue_expression] = STATE(3899),
    [sym__expression_statement_expression] = STATE(5733),
    [sym_assignment_expression] = STATE(5734),
    [sym_binary_expression] = STATE(5733),
    [sym_postfix_unary_expression] = STATE(5734),
    [sym_prefix_unary_expression] = STATE(5734),
    [sym__pointer_indirection_expression] = STATE(3911),
    [sym_query_expression] = STATE(5733),
    [sym_from_clause] = STATE(7400),
    [sym_conditional_expression] = STATE(5733),
    [sym_conditional_access_expression] = STATE(5733),
    [sym_as_expression] = STATE(5733),
    [sym_is_expression] = STATE(5733),
    [sym_is_pattern_expression] = STATE(5733),
    [sym_cast_expression] = STATE(5733),
    [sym_checked_expression] = STATE(5733),
    [sym_invocation_expression] = STATE(5734),
    [sym_switch_expression] = STATE(5733),
    [sym_await_expression] = STATE(5734),
    [sym_throw_expression] = STATE(5733),
    [sym_element_access_expression] = STATE(3911),
    [sym_interpolated_string_expression] = STATE(5733),
    [sym_member_access_expression] = STATE(3911),
    [sym_object_creation_expression] = STATE(5734),
    [sym_parenthesized_expression] = STATE(5734),
    [sym__parenthesized_lvalue_expression] = STATE(3911),
    [sym_lambda_expression] = STATE(5733),
    [sym__lambda_parameters] = STATE(9790),
    [sym_array_creation_expression] = STATE(5733),
    [sym_anonymous_method_expression] = STATE(5733),
    [sym_anonymous_object_creation_expression] = STATE(5733),
    [sym_implicit_array_creation_expression] = STATE(5733),
    [sym_implicit_object_creation_expression] = STATE(5733),
    [sym_implicit_stackalloc_expression] = STATE(5733),
    [sym_initializer_expression] = STATE(5733),
    [sym_default_expression] = STATE(5733),
    [sym_with_expression] = STATE(5733),
    [sym_sizeof_expression] = STATE(5733),
    [sym_typeof_expression] = STATE(5733),
    [sym_makeref_expression] = STATE(5733),
    [sym_ref_expression] = STATE(5733),
    [sym_reftype_expression] = STATE(5733),
    [sym_refvalue_expression] = STATE(5733),
    [sym_stackalloc_expression] = STATE(5733),
    [sym_range_expression] = STATE(5733),
    [sym_tuple_expression] = STATE(3911),
    [sym_literal] = STATE(5733),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2798),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(5733),
    [sym_preproc_region] = STATE(2010),
    [sym_preproc_endregion] = STATE(2010),
    [sym_preproc_line] = STATE(2010),
    [sym_preproc_pragma] = STATE(2010),
    [sym_preproc_nullable] = STATE(2010),
    [sym_preproc_error] = STATE(2010),
    [sym_preproc_define] = STATE(2010),
    [sym_preproc_undef] = STATE(2010),
    [aux_sym_class_declaration_repeat1] = STATE(3833),
    [aux_sym_lambda_expression_repeat1] = STATE(4182),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_LPAREN] = ACTIONS(1439),
    [anon_sym_ref] = ACTIONS(1441),
    [anon_sym_LBRACE] = ACTIONS(1377),
    [anon_sym_delegate] = ACTIONS(1379),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1443),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1447),
    [anon_sym_TILDE] = ACTIONS(1447),
    [anon_sym_PLUS_PLUS] = ACTIONS(1447),
    [anon_sym_DASH_DASH] = ACTIONS(1447),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1445),
    [anon_sym_DASH] = ACTIONS(1445),
    [anon_sym_STAR] = ACTIONS(1449),
    [anon_sym_CARET] = ACTIONS(1447),
    [anon_sym_AMP] = ACTIONS(1447),
    [anon_sym_this] = ACTIONS(1393),
    [anon_sym_scoped] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1397),
    [sym_predefined_type] = ACTIONS(1399),
    [anon_sym_unchecked] = ACTIONS(1383),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1451),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1453),
    [anon_sym_DOT_DOT] = ACTIONS(1455),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_stackalloc] = ACTIONS(1413),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(1419),
    [anon_sym___reftype] = ACTIONS(1421),
    [anon_sym___refvalue] = ACTIONS(1423),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
  },
  [2011] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6910),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2957),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6984),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4931),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(3777),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7387),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9385),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(2011),
    [sym_preproc_endregion] = STATE(2011),
    [sym_preproc_line] = STATE(2011),
    [sym_preproc_pragma] = STATE(2011),
    [sym_preproc_nullable] = STATE(2011),
    [sym_preproc_error] = STATE(2011),
    [sym_preproc_define] = STATE(2011),
    [sym_preproc_undef] = STATE(2011),
    [aux_sym_class_declaration_repeat1] = STATE(3793),
    [aux_sym_lambda_expression_repeat1] = STATE(4083),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1795),
    [anon_sym_ref] = ACTIONS(1797),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1799),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1803),
    [anon_sym_TILDE] = ACTIONS(1803),
    [anon_sym_PLUS_PLUS] = ACTIONS(1803),
    [anon_sym_DASH_DASH] = ACTIONS(1803),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1801),
    [anon_sym_DASH] = ACTIONS(1801),
    [anon_sym_STAR] = ACTIONS(1805),
    [anon_sym_CARET] = ACTIONS(1803),
    [anon_sym_AMP] = ACTIONS(1803),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1807),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1809),
    [anon_sym_DOT_DOT] = ACTIONS(1811),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [2012] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6967),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5064),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(3858),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7382),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9625),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(2012),
    [sym_preproc_endregion] = STATE(2012),
    [sym_preproc_line] = STATE(2012),
    [sym_preproc_pragma] = STATE(2012),
    [sym_preproc_nullable] = STATE(2012),
    [sym_preproc_error] = STATE(2012),
    [sym_preproc_define] = STATE(2012),
    [sym_preproc_undef] = STATE(2012),
    [aux_sym_class_declaration_repeat1] = STATE(3851),
    [aux_sym_lambda_expression_repeat1] = STATE(4234),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_ref] = ACTIONS(1293),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1059),
    [anon_sym_TILDE] = ACTIONS(1059),
    [anon_sym_PLUS_PLUS] = ACTIONS(1059),
    [anon_sym_DASH_DASH] = ACTIONS(1059),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1061),
    [anon_sym_DASH] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(1303),
    [anon_sym_CARET] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1307),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1309),
    [anon_sym_DOT_DOT] = ACTIONS(1311),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [2013] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6967),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5063),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(3858),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7382),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9625),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(2013),
    [sym_preproc_endregion] = STATE(2013),
    [sym_preproc_line] = STATE(2013),
    [sym_preproc_pragma] = STATE(2013),
    [sym_preproc_nullable] = STATE(2013),
    [sym_preproc_error] = STATE(2013),
    [sym_preproc_define] = STATE(2013),
    [sym_preproc_undef] = STATE(2013),
    [aux_sym_class_declaration_repeat1] = STATE(3851),
    [aux_sym_lambda_expression_repeat1] = STATE(4234),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_ref] = ACTIONS(1293),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1059),
    [anon_sym_TILDE] = ACTIONS(1059),
    [anon_sym_PLUS_PLUS] = ACTIONS(1059),
    [anon_sym_DASH_DASH] = ACTIONS(1059),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1061),
    [anon_sym_DASH] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(1303),
    [anon_sym_CARET] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1307),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1309),
    [anon_sym_DOT_DOT] = ACTIONS(1311),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [2014] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6967),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5093),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(3858),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7382),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9625),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(2014),
    [sym_preproc_endregion] = STATE(2014),
    [sym_preproc_line] = STATE(2014),
    [sym_preproc_pragma] = STATE(2014),
    [sym_preproc_nullable] = STATE(2014),
    [sym_preproc_error] = STATE(2014),
    [sym_preproc_define] = STATE(2014),
    [sym_preproc_undef] = STATE(2014),
    [aux_sym_class_declaration_repeat1] = STATE(3851),
    [aux_sym_lambda_expression_repeat1] = STATE(4234),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_ref] = ACTIONS(1293),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1059),
    [anon_sym_TILDE] = ACTIONS(1059),
    [anon_sym_PLUS_PLUS] = ACTIONS(1059),
    [anon_sym_DASH_DASH] = ACTIONS(1059),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1061),
    [anon_sym_DASH] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(1303),
    [anon_sym_CARET] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1307),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1309),
    [anon_sym_DOT_DOT] = ACTIONS(1311),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [2015] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6910),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2957),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7089),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5073),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(3796),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7395),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9374),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(2015),
    [sym_preproc_endregion] = STATE(2015),
    [sym_preproc_line] = STATE(2015),
    [sym_preproc_pragma] = STATE(2015),
    [sym_preproc_nullable] = STATE(2015),
    [sym_preproc_error] = STATE(2015),
    [sym_preproc_define] = STATE(2015),
    [sym_preproc_undef] = STATE(2015),
    [aux_sym_class_declaration_repeat1] = STATE(3839),
    [aux_sym_lambda_expression_repeat1] = STATE(4209),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2139),
    [anon_sym_ref] = ACTIONS(2141),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1799),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2145),
    [anon_sym_TILDE] = ACTIONS(2145),
    [anon_sym_PLUS_PLUS] = ACTIONS(2145),
    [anon_sym_DASH_DASH] = ACTIONS(2145),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2143),
    [anon_sym_DASH] = ACTIONS(2143),
    [anon_sym_STAR] = ACTIONS(1805),
    [anon_sym_CARET] = ACTIONS(2145),
    [anon_sym_AMP] = ACTIONS(2145),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2147),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2149),
    [anon_sym_DOT_DOT] = ACTIONS(2151),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [2016] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6967),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5062),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(3858),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7382),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9625),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(2016),
    [sym_preproc_endregion] = STATE(2016),
    [sym_preproc_line] = STATE(2016),
    [sym_preproc_pragma] = STATE(2016),
    [sym_preproc_nullable] = STATE(2016),
    [sym_preproc_error] = STATE(2016),
    [sym_preproc_define] = STATE(2016),
    [sym_preproc_undef] = STATE(2016),
    [aux_sym_class_declaration_repeat1] = STATE(3851),
    [aux_sym_lambda_expression_repeat1] = STATE(4234),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_ref] = ACTIONS(1293),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1059),
    [anon_sym_TILDE] = ACTIONS(1059),
    [anon_sym_PLUS_PLUS] = ACTIONS(1059),
    [anon_sym_DASH_DASH] = ACTIONS(1059),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1061),
    [anon_sym_DASH] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(1303),
    [anon_sym_CARET] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1307),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1309),
    [anon_sym_DOT_DOT] = ACTIONS(1311),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [2017] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7064),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5158),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(3866),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7382),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9762),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(2017),
    [sym_preproc_endregion] = STATE(2017),
    [sym_preproc_line] = STATE(2017),
    [sym_preproc_pragma] = STATE(2017),
    [sym_preproc_nullable] = STATE(2017),
    [sym_preproc_error] = STATE(2017),
    [sym_preproc_define] = STATE(2017),
    [sym_preproc_undef] = STATE(2017),
    [aux_sym_class_declaration_repeat1] = STATE(3842),
    [aux_sym_lambda_expression_repeat1] = STATE(4280),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1351),
    [anon_sym_ref] = ACTIONS(1353),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1357),
    [anon_sym_TILDE] = ACTIONS(1357),
    [anon_sym_PLUS_PLUS] = ACTIONS(1357),
    [anon_sym_DASH_DASH] = ACTIONS(1357),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1355),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(1357),
    [anon_sym_AMP] = ACTIONS(1357),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1361),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1363),
    [anon_sym_DOT_DOT] = ACTIONS(1365),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [2018] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6910),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2957),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6984),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4922),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(3777),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7387),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9385),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(2018),
    [sym_preproc_endregion] = STATE(2018),
    [sym_preproc_line] = STATE(2018),
    [sym_preproc_pragma] = STATE(2018),
    [sym_preproc_nullable] = STATE(2018),
    [sym_preproc_error] = STATE(2018),
    [sym_preproc_define] = STATE(2018),
    [sym_preproc_undef] = STATE(2018),
    [aux_sym_class_declaration_repeat1] = STATE(3793),
    [aux_sym_lambda_expression_repeat1] = STATE(4083),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1795),
    [anon_sym_ref] = ACTIONS(1797),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1799),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1803),
    [anon_sym_TILDE] = ACTIONS(1803),
    [anon_sym_PLUS_PLUS] = ACTIONS(1803),
    [anon_sym_DASH_DASH] = ACTIONS(1803),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1801),
    [anon_sym_DASH] = ACTIONS(1801),
    [anon_sym_STAR] = ACTIONS(1805),
    [anon_sym_CARET] = ACTIONS(1803),
    [anon_sym_AMP] = ACTIONS(1803),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1807),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1809),
    [anon_sym_DOT_DOT] = ACTIONS(1811),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [2019] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6910),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2957),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6984),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4923),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(3777),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7387),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9385),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(2019),
    [sym_preproc_endregion] = STATE(2019),
    [sym_preproc_line] = STATE(2019),
    [sym_preproc_pragma] = STATE(2019),
    [sym_preproc_nullable] = STATE(2019),
    [sym_preproc_error] = STATE(2019),
    [sym_preproc_define] = STATE(2019),
    [sym_preproc_undef] = STATE(2019),
    [aux_sym_class_declaration_repeat1] = STATE(3793),
    [aux_sym_lambda_expression_repeat1] = STATE(4083),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1795),
    [anon_sym_ref] = ACTIONS(1797),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1799),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1803),
    [anon_sym_TILDE] = ACTIONS(1803),
    [anon_sym_PLUS_PLUS] = ACTIONS(1803),
    [anon_sym_DASH_DASH] = ACTIONS(1803),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1801),
    [anon_sym_DASH] = ACTIONS(1801),
    [anon_sym_STAR] = ACTIONS(1805),
    [anon_sym_CARET] = ACTIONS(1803),
    [anon_sym_AMP] = ACTIONS(1803),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1807),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1809),
    [anon_sym_DOT_DOT] = ACTIONS(1811),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [2020] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6910),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2957),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6984),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4924),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(3777),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7387),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9385),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(2020),
    [sym_preproc_endregion] = STATE(2020),
    [sym_preproc_line] = STATE(2020),
    [sym_preproc_pragma] = STATE(2020),
    [sym_preproc_nullable] = STATE(2020),
    [sym_preproc_error] = STATE(2020),
    [sym_preproc_define] = STATE(2020),
    [sym_preproc_undef] = STATE(2020),
    [aux_sym_class_declaration_repeat1] = STATE(3793),
    [aux_sym_lambda_expression_repeat1] = STATE(4083),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1795),
    [anon_sym_ref] = ACTIONS(1797),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1799),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1803),
    [anon_sym_TILDE] = ACTIONS(1803),
    [anon_sym_PLUS_PLUS] = ACTIONS(1803),
    [anon_sym_DASH_DASH] = ACTIONS(1803),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1801),
    [anon_sym_DASH] = ACTIONS(1801),
    [anon_sym_STAR] = ACTIONS(1805),
    [anon_sym_CARET] = ACTIONS(1803),
    [anon_sym_AMP] = ACTIONS(1803),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1807),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1809),
    [anon_sym_DOT_DOT] = ACTIONS(1811),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [2021] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6910),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2957),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6984),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4925),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(3777),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7387),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9385),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(2021),
    [sym_preproc_endregion] = STATE(2021),
    [sym_preproc_line] = STATE(2021),
    [sym_preproc_pragma] = STATE(2021),
    [sym_preproc_nullable] = STATE(2021),
    [sym_preproc_error] = STATE(2021),
    [sym_preproc_define] = STATE(2021),
    [sym_preproc_undef] = STATE(2021),
    [aux_sym_class_declaration_repeat1] = STATE(3793),
    [aux_sym_lambda_expression_repeat1] = STATE(4083),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1795),
    [anon_sym_ref] = ACTIONS(1797),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1799),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1803),
    [anon_sym_TILDE] = ACTIONS(1803),
    [anon_sym_PLUS_PLUS] = ACTIONS(1803),
    [anon_sym_DASH_DASH] = ACTIONS(1803),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1801),
    [anon_sym_DASH] = ACTIONS(1801),
    [anon_sym_STAR] = ACTIONS(1805),
    [anon_sym_CARET] = ACTIONS(1803),
    [anon_sym_AMP] = ACTIONS(1803),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1807),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1809),
    [anon_sym_DOT_DOT] = ACTIONS(1811),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [2022] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7094),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4325),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(2022),
    [sym_preproc_endregion] = STATE(2022),
    [sym_preproc_line] = STATE(2022),
    [sym_preproc_pragma] = STATE(2022),
    [sym_preproc_nullable] = STATE(2022),
    [sym_preproc_error] = STATE(2022),
    [sym_preproc_define] = STATE(2022),
    [sym_preproc_undef] = STATE(2022),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1669),
    [anon_sym_TILDE] = ACTIONS(1669),
    [anon_sym_PLUS_PLUS] = ACTIONS(1669),
    [anon_sym_DASH_DASH] = ACTIONS(1669),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1667),
    [anon_sym_DASH] = ACTIONS(1667),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1669),
    [anon_sym_AMP] = ACTIONS(1669),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [2023] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7094),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5782),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4317),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(2023),
    [sym_preproc_endregion] = STATE(2023),
    [sym_preproc_line] = STATE(2023),
    [sym_preproc_pragma] = STATE(2023),
    [sym_preproc_nullable] = STATE(2023),
    [sym_preproc_error] = STATE(2023),
    [sym_preproc_define] = STATE(2023),
    [sym_preproc_undef] = STATE(2023),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1669),
    [anon_sym_TILDE] = ACTIONS(1669),
    [anon_sym_PLUS_PLUS] = ACTIONS(1669),
    [anon_sym_DASH_DASH] = ACTIONS(1669),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1667),
    [anon_sym_DASH] = ACTIONS(1667),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1669),
    [anon_sym_AMP] = ACTIONS(1669),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [2024] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3559),
    [sym__name] = STATE(6878),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2911),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6960),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4438),
    [sym_non_lvalue_expression] = STATE(4553),
    [sym_lvalue_expression] = STATE(3607),
    [sym__expression_statement_expression] = STATE(4559),
    [sym_assignment_expression] = STATE(4558),
    [sym_binary_expression] = STATE(4559),
    [sym_postfix_unary_expression] = STATE(4558),
    [sym_prefix_unary_expression] = STATE(4558),
    [sym__pointer_indirection_expression] = STATE(3560),
    [sym_query_expression] = STATE(4559),
    [sym_from_clause] = STATE(7385),
    [sym_conditional_expression] = STATE(4559),
    [sym_conditional_access_expression] = STATE(4559),
    [sym_as_expression] = STATE(4559),
    [sym_is_expression] = STATE(4559),
    [sym_is_pattern_expression] = STATE(4559),
    [sym_cast_expression] = STATE(4559),
    [sym_checked_expression] = STATE(4559),
    [sym_invocation_expression] = STATE(4558),
    [sym_switch_expression] = STATE(4559),
    [sym_await_expression] = STATE(4558),
    [sym_throw_expression] = STATE(4559),
    [sym_element_access_expression] = STATE(3560),
    [sym_interpolated_string_expression] = STATE(4559),
    [sym_member_access_expression] = STATE(3560),
    [sym_object_creation_expression] = STATE(4558),
    [sym_parenthesized_expression] = STATE(4558),
    [sym__parenthesized_lvalue_expression] = STATE(3560),
    [sym_lambda_expression] = STATE(4559),
    [sym__lambda_parameters] = STATE(9554),
    [sym_array_creation_expression] = STATE(4559),
    [sym_anonymous_method_expression] = STATE(4559),
    [sym_anonymous_object_creation_expression] = STATE(4559),
    [sym_implicit_array_creation_expression] = STATE(4559),
    [sym_implicit_object_creation_expression] = STATE(4559),
    [sym_implicit_stackalloc_expression] = STATE(4559),
    [sym_initializer_expression] = STATE(4559),
    [sym_default_expression] = STATE(4559),
    [sym_with_expression] = STATE(4559),
    [sym_sizeof_expression] = STATE(4559),
    [sym_typeof_expression] = STATE(4559),
    [sym_makeref_expression] = STATE(4559),
    [sym_ref_expression] = STATE(4559),
    [sym_reftype_expression] = STATE(4559),
    [sym_refvalue_expression] = STATE(4559),
    [sym_stackalloc_expression] = STATE(4559),
    [sym_range_expression] = STATE(4559),
    [sym_tuple_expression] = STATE(3560),
    [sym_literal] = STATE(4559),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4559),
    [sym_preproc_region] = STATE(2024),
    [sym_preproc_endregion] = STATE(2024),
    [sym_preproc_line] = STATE(2024),
    [sym_preproc_pragma] = STATE(2024),
    [sym_preproc_nullable] = STATE(2024),
    [sym_preproc_error] = STATE(2024),
    [sym_preproc_define] = STATE(2024),
    [sym_preproc_undef] = STATE(2024),
    [aux_sym_class_declaration_repeat1] = STATE(3792),
    [aux_sym_lambda_expression_repeat1] = STATE(4202),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(1607),
    [anon_sym_ref] = ACTIONS(1609),
    [anon_sym_LBRACE] = ACTIONS(1611),
    [anon_sym_delegate] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1615),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(1621),
    [anon_sym_TILDE] = ACTIONS(1621),
    [anon_sym_PLUS_PLUS] = ACTIONS(1621),
    [anon_sym_DASH_DASH] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(1619),
    [anon_sym_DASH] = ACTIONS(1619),
    [anon_sym_STAR] = ACTIONS(1625),
    [anon_sym_CARET] = ACTIONS(1621),
    [anon_sym_AMP] = ACTIONS(1621),
    [anon_sym_this] = ACTIONS(1627),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1629),
    [anon_sym_unchecked] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [anon_sym_DOT_DOT] = ACTIONS(1637),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_stackalloc] = ACTIONS(1641),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(1647),
    [anon_sym___reftype] = ACTIONS(1649),
    [anon_sym___refvalue] = ACTIONS(1651),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1659),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [2025] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6910),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2957),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6984),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4942),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(3777),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7387),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9385),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(2025),
    [sym_preproc_endregion] = STATE(2025),
    [sym_preproc_line] = STATE(2025),
    [sym_preproc_pragma] = STATE(2025),
    [sym_preproc_nullable] = STATE(2025),
    [sym_preproc_error] = STATE(2025),
    [sym_preproc_define] = STATE(2025),
    [sym_preproc_undef] = STATE(2025),
    [aux_sym_class_declaration_repeat1] = STATE(3793),
    [aux_sym_lambda_expression_repeat1] = STATE(4083),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1795),
    [anon_sym_ref] = ACTIONS(1797),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1799),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1803),
    [anon_sym_TILDE] = ACTIONS(1803),
    [anon_sym_PLUS_PLUS] = ACTIONS(1803),
    [anon_sym_DASH_DASH] = ACTIONS(1803),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1801),
    [anon_sym_DASH] = ACTIONS(1801),
    [anon_sym_STAR] = ACTIONS(1805),
    [anon_sym_CARET] = ACTIONS(1803),
    [anon_sym_AMP] = ACTIONS(1803),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1807),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1809),
    [anon_sym_DOT_DOT] = ACTIONS(1811),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [2026] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6967),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5060),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(3858),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7382),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9625),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(2026),
    [sym_preproc_endregion] = STATE(2026),
    [sym_preproc_line] = STATE(2026),
    [sym_preproc_pragma] = STATE(2026),
    [sym_preproc_nullable] = STATE(2026),
    [sym_preproc_error] = STATE(2026),
    [sym_preproc_define] = STATE(2026),
    [sym_preproc_undef] = STATE(2026),
    [aux_sym_class_declaration_repeat1] = STATE(3851),
    [aux_sym_lambda_expression_repeat1] = STATE(4234),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_ref] = ACTIONS(1293),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1059),
    [anon_sym_TILDE] = ACTIONS(1059),
    [anon_sym_PLUS_PLUS] = ACTIONS(1059),
    [anon_sym_DASH_DASH] = ACTIONS(1059),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1061),
    [anon_sym_DASH] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(1303),
    [anon_sym_CARET] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1307),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1309),
    [anon_sym_DOT_DOT] = ACTIONS(1311),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [2027] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6967),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5059),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(3858),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7382),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9625),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(2027),
    [sym_preproc_endregion] = STATE(2027),
    [sym_preproc_line] = STATE(2027),
    [sym_preproc_pragma] = STATE(2027),
    [sym_preproc_nullable] = STATE(2027),
    [sym_preproc_error] = STATE(2027),
    [sym_preproc_define] = STATE(2027),
    [sym_preproc_undef] = STATE(2027),
    [aux_sym_class_declaration_repeat1] = STATE(3851),
    [aux_sym_lambda_expression_repeat1] = STATE(4234),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_ref] = ACTIONS(1293),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1059),
    [anon_sym_TILDE] = ACTIONS(1059),
    [anon_sym_PLUS_PLUS] = ACTIONS(1059),
    [anon_sym_DASH_DASH] = ACTIONS(1059),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1061),
    [anon_sym_DASH] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(1303),
    [anon_sym_CARET] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1307),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1309),
    [anon_sym_DOT_DOT] = ACTIONS(1311),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [2028] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3559),
    [sym__name] = STATE(6878),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2911),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6960),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4441),
    [sym_non_lvalue_expression] = STATE(4553),
    [sym_lvalue_expression] = STATE(3607),
    [sym__expression_statement_expression] = STATE(4559),
    [sym_assignment_expression] = STATE(4558),
    [sym_binary_expression] = STATE(4559),
    [sym_postfix_unary_expression] = STATE(4558),
    [sym_prefix_unary_expression] = STATE(4558),
    [sym__pointer_indirection_expression] = STATE(3560),
    [sym_query_expression] = STATE(4559),
    [sym_from_clause] = STATE(7385),
    [sym_conditional_expression] = STATE(4559),
    [sym_conditional_access_expression] = STATE(4559),
    [sym_as_expression] = STATE(4559),
    [sym_is_expression] = STATE(4559),
    [sym_is_pattern_expression] = STATE(4559),
    [sym_cast_expression] = STATE(4559),
    [sym_checked_expression] = STATE(4559),
    [sym_invocation_expression] = STATE(4558),
    [sym_switch_expression] = STATE(4559),
    [sym_await_expression] = STATE(4558),
    [sym_throw_expression] = STATE(4559),
    [sym_element_access_expression] = STATE(3560),
    [sym_interpolated_string_expression] = STATE(4559),
    [sym_member_access_expression] = STATE(3560),
    [sym_object_creation_expression] = STATE(4558),
    [sym_parenthesized_expression] = STATE(4558),
    [sym__parenthesized_lvalue_expression] = STATE(3560),
    [sym_lambda_expression] = STATE(4559),
    [sym__lambda_parameters] = STATE(9554),
    [sym_array_creation_expression] = STATE(4559),
    [sym_anonymous_method_expression] = STATE(4559),
    [sym_anonymous_object_creation_expression] = STATE(4559),
    [sym_implicit_array_creation_expression] = STATE(4559),
    [sym_implicit_object_creation_expression] = STATE(4559),
    [sym_implicit_stackalloc_expression] = STATE(4559),
    [sym_initializer_expression] = STATE(4559),
    [sym_default_expression] = STATE(4559),
    [sym_with_expression] = STATE(4559),
    [sym_sizeof_expression] = STATE(4559),
    [sym_typeof_expression] = STATE(4559),
    [sym_makeref_expression] = STATE(4559),
    [sym_ref_expression] = STATE(4559),
    [sym_reftype_expression] = STATE(4559),
    [sym_refvalue_expression] = STATE(4559),
    [sym_stackalloc_expression] = STATE(4559),
    [sym_range_expression] = STATE(4559),
    [sym_tuple_expression] = STATE(3560),
    [sym_literal] = STATE(4559),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4559),
    [sym_preproc_region] = STATE(2028),
    [sym_preproc_endregion] = STATE(2028),
    [sym_preproc_line] = STATE(2028),
    [sym_preproc_pragma] = STATE(2028),
    [sym_preproc_nullable] = STATE(2028),
    [sym_preproc_error] = STATE(2028),
    [sym_preproc_define] = STATE(2028),
    [sym_preproc_undef] = STATE(2028),
    [aux_sym_class_declaration_repeat1] = STATE(3792),
    [aux_sym_lambda_expression_repeat1] = STATE(4202),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(1607),
    [anon_sym_ref] = ACTIONS(1609),
    [anon_sym_LBRACE] = ACTIONS(1611),
    [anon_sym_delegate] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1615),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(1621),
    [anon_sym_TILDE] = ACTIONS(1621),
    [anon_sym_PLUS_PLUS] = ACTIONS(1621),
    [anon_sym_DASH_DASH] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(1619),
    [anon_sym_DASH] = ACTIONS(1619),
    [anon_sym_STAR] = ACTIONS(1625),
    [anon_sym_CARET] = ACTIONS(1621),
    [anon_sym_AMP] = ACTIONS(1621),
    [anon_sym_this] = ACTIONS(1627),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1629),
    [anon_sym_unchecked] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [anon_sym_DOT_DOT] = ACTIONS(1637),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_stackalloc] = ACTIONS(1641),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(1647),
    [anon_sym___reftype] = ACTIONS(1649),
    [anon_sym___refvalue] = ACTIONS(1651),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1659),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [2029] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6967),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5057),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(3858),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7382),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9625),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(2029),
    [sym_preproc_endregion] = STATE(2029),
    [sym_preproc_line] = STATE(2029),
    [sym_preproc_pragma] = STATE(2029),
    [sym_preproc_nullable] = STATE(2029),
    [sym_preproc_error] = STATE(2029),
    [sym_preproc_define] = STATE(2029),
    [sym_preproc_undef] = STATE(2029),
    [aux_sym_class_declaration_repeat1] = STATE(3851),
    [aux_sym_lambda_expression_repeat1] = STATE(4234),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_ref] = ACTIONS(1293),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1059),
    [anon_sym_TILDE] = ACTIONS(1059),
    [anon_sym_PLUS_PLUS] = ACTIONS(1059),
    [anon_sym_DASH_DASH] = ACTIONS(1059),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1061),
    [anon_sym_DASH] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(1303),
    [anon_sym_CARET] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1307),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1309),
    [anon_sym_DOT_DOT] = ACTIONS(1311),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [2030] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3559),
    [sym__name] = STATE(6878),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2911),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6960),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4471),
    [sym_non_lvalue_expression] = STATE(4553),
    [sym_lvalue_expression] = STATE(3607),
    [sym__expression_statement_expression] = STATE(4559),
    [sym_assignment_expression] = STATE(4558),
    [sym_binary_expression] = STATE(4559),
    [sym_postfix_unary_expression] = STATE(4558),
    [sym_prefix_unary_expression] = STATE(4558),
    [sym__pointer_indirection_expression] = STATE(3560),
    [sym_query_expression] = STATE(4559),
    [sym_from_clause] = STATE(7385),
    [sym_conditional_expression] = STATE(4559),
    [sym_conditional_access_expression] = STATE(4559),
    [sym_as_expression] = STATE(4559),
    [sym_is_expression] = STATE(4559),
    [sym_is_pattern_expression] = STATE(4559),
    [sym_cast_expression] = STATE(4559),
    [sym_checked_expression] = STATE(4559),
    [sym_invocation_expression] = STATE(4558),
    [sym_switch_expression] = STATE(4559),
    [sym_await_expression] = STATE(4558),
    [sym_throw_expression] = STATE(4559),
    [sym_element_access_expression] = STATE(3560),
    [sym_interpolated_string_expression] = STATE(4559),
    [sym_member_access_expression] = STATE(3560),
    [sym_object_creation_expression] = STATE(4558),
    [sym_parenthesized_expression] = STATE(4558),
    [sym__parenthesized_lvalue_expression] = STATE(3560),
    [sym_lambda_expression] = STATE(4559),
    [sym__lambda_parameters] = STATE(9554),
    [sym_array_creation_expression] = STATE(4559),
    [sym_anonymous_method_expression] = STATE(4559),
    [sym_anonymous_object_creation_expression] = STATE(4559),
    [sym_implicit_array_creation_expression] = STATE(4559),
    [sym_implicit_object_creation_expression] = STATE(4559),
    [sym_implicit_stackalloc_expression] = STATE(4559),
    [sym_initializer_expression] = STATE(4559),
    [sym_default_expression] = STATE(4559),
    [sym_with_expression] = STATE(4559),
    [sym_sizeof_expression] = STATE(4559),
    [sym_typeof_expression] = STATE(4559),
    [sym_makeref_expression] = STATE(4559),
    [sym_ref_expression] = STATE(4559),
    [sym_reftype_expression] = STATE(4559),
    [sym_refvalue_expression] = STATE(4559),
    [sym_stackalloc_expression] = STATE(4559),
    [sym_range_expression] = STATE(4559),
    [sym_tuple_expression] = STATE(3560),
    [sym_literal] = STATE(4559),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4559),
    [sym_preproc_region] = STATE(2030),
    [sym_preproc_endregion] = STATE(2030),
    [sym_preproc_line] = STATE(2030),
    [sym_preproc_pragma] = STATE(2030),
    [sym_preproc_nullable] = STATE(2030),
    [sym_preproc_error] = STATE(2030),
    [sym_preproc_define] = STATE(2030),
    [sym_preproc_undef] = STATE(2030),
    [aux_sym_class_declaration_repeat1] = STATE(3792),
    [aux_sym_lambda_expression_repeat1] = STATE(4202),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(1607),
    [anon_sym_ref] = ACTIONS(1609),
    [anon_sym_LBRACE] = ACTIONS(1611),
    [anon_sym_delegate] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1615),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(1621),
    [anon_sym_TILDE] = ACTIONS(1621),
    [anon_sym_PLUS_PLUS] = ACTIONS(1621),
    [anon_sym_DASH_DASH] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(1619),
    [anon_sym_DASH] = ACTIONS(1619),
    [anon_sym_STAR] = ACTIONS(1625),
    [anon_sym_CARET] = ACTIONS(1621),
    [anon_sym_AMP] = ACTIONS(1621),
    [anon_sym_this] = ACTIONS(1627),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1629),
    [anon_sym_unchecked] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [anon_sym_DOT_DOT] = ACTIONS(1637),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_stackalloc] = ACTIONS(1641),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(1647),
    [anon_sym___reftype] = ACTIONS(1649),
    [anon_sym___refvalue] = ACTIONS(1651),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1659),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [2031] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6910),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2957),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7094),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6699),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(3014),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(2031),
    [sym_preproc_endregion] = STATE(2031),
    [sym_preproc_line] = STATE(2031),
    [sym_preproc_pragma] = STATE(2031),
    [sym_preproc_nullable] = STATE(2031),
    [sym_preproc_error] = STATE(2031),
    [sym_preproc_define] = STATE(2031),
    [sym_preproc_undef] = STATE(2031),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2919),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1669),
    [anon_sym_TILDE] = ACTIONS(1669),
    [anon_sym_PLUS_PLUS] = ACTIONS(1669),
    [anon_sym_DASH_DASH] = ACTIONS(1669),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1667),
    [anon_sym_DASH] = ACTIONS(1667),
    [anon_sym_STAR] = ACTIONS(1805),
    [anon_sym_CARET] = ACTIONS(1669),
    [anon_sym_AMP] = ACTIONS(1669),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1673),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [2032] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7076),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4308),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4314),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9775),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(2032),
    [sym_preproc_endregion] = STATE(2032),
    [sym_preproc_line] = STATE(2032),
    [sym_preproc_pragma] = STATE(2032),
    [sym_preproc_nullable] = STATE(2032),
    [sym_preproc_error] = STATE(2032),
    [sym_preproc_define] = STATE(2032),
    [sym_preproc_undef] = STATE(2032),
    [aux_sym_class_declaration_repeat1] = STATE(3835),
    [aux_sym_lambda_expression_repeat1] = STATE(4236),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1535),
    [anon_sym_ref] = ACTIONS(1537),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1465),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(885),
    [anon_sym_TILDE] = ACTIONS(885),
    [anon_sym_PLUS_PLUS] = ACTIONS(885),
    [anon_sym_DASH_DASH] = ACTIONS(885),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(887),
    [anon_sym_DASH] = ACTIONS(887),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(885),
    [anon_sym_AMP] = ACTIONS(885),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1539),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1541),
    [anon_sym_DOT_DOT] = ACTIONS(1543),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [2033] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3559),
    [sym__name] = STATE(6878),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2911),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6960),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4470),
    [sym_non_lvalue_expression] = STATE(4553),
    [sym_lvalue_expression] = STATE(3607),
    [sym__expression_statement_expression] = STATE(4559),
    [sym_assignment_expression] = STATE(4558),
    [sym_binary_expression] = STATE(4559),
    [sym_postfix_unary_expression] = STATE(4558),
    [sym_prefix_unary_expression] = STATE(4558),
    [sym__pointer_indirection_expression] = STATE(3560),
    [sym_query_expression] = STATE(4559),
    [sym_from_clause] = STATE(7385),
    [sym_conditional_expression] = STATE(4559),
    [sym_conditional_access_expression] = STATE(4559),
    [sym_as_expression] = STATE(4559),
    [sym_is_expression] = STATE(4559),
    [sym_is_pattern_expression] = STATE(4559),
    [sym_cast_expression] = STATE(4559),
    [sym_checked_expression] = STATE(4559),
    [sym_invocation_expression] = STATE(4558),
    [sym_switch_expression] = STATE(4559),
    [sym_await_expression] = STATE(4558),
    [sym_throw_expression] = STATE(4559),
    [sym_element_access_expression] = STATE(3560),
    [sym_interpolated_string_expression] = STATE(4559),
    [sym_member_access_expression] = STATE(3560),
    [sym_object_creation_expression] = STATE(4558),
    [sym_parenthesized_expression] = STATE(4558),
    [sym__parenthesized_lvalue_expression] = STATE(3560),
    [sym_lambda_expression] = STATE(4559),
    [sym__lambda_parameters] = STATE(9554),
    [sym_array_creation_expression] = STATE(4559),
    [sym_anonymous_method_expression] = STATE(4559),
    [sym_anonymous_object_creation_expression] = STATE(4559),
    [sym_implicit_array_creation_expression] = STATE(4559),
    [sym_implicit_object_creation_expression] = STATE(4559),
    [sym_implicit_stackalloc_expression] = STATE(4559),
    [sym_initializer_expression] = STATE(4559),
    [sym_default_expression] = STATE(4559),
    [sym_with_expression] = STATE(4559),
    [sym_sizeof_expression] = STATE(4559),
    [sym_typeof_expression] = STATE(4559),
    [sym_makeref_expression] = STATE(4559),
    [sym_ref_expression] = STATE(4559),
    [sym_reftype_expression] = STATE(4559),
    [sym_refvalue_expression] = STATE(4559),
    [sym_stackalloc_expression] = STATE(4559),
    [sym_range_expression] = STATE(4559),
    [sym_tuple_expression] = STATE(3560),
    [sym_literal] = STATE(4559),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4559),
    [sym_preproc_region] = STATE(2033),
    [sym_preproc_endregion] = STATE(2033),
    [sym_preproc_line] = STATE(2033),
    [sym_preproc_pragma] = STATE(2033),
    [sym_preproc_nullable] = STATE(2033),
    [sym_preproc_error] = STATE(2033),
    [sym_preproc_define] = STATE(2033),
    [sym_preproc_undef] = STATE(2033),
    [aux_sym_class_declaration_repeat1] = STATE(3792),
    [aux_sym_lambda_expression_repeat1] = STATE(4202),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(1607),
    [anon_sym_ref] = ACTIONS(1609),
    [anon_sym_LBRACE] = ACTIONS(1611),
    [anon_sym_delegate] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1615),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(1621),
    [anon_sym_TILDE] = ACTIONS(1621),
    [anon_sym_PLUS_PLUS] = ACTIONS(1621),
    [anon_sym_DASH_DASH] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(1619),
    [anon_sym_DASH] = ACTIONS(1619),
    [anon_sym_STAR] = ACTIONS(1625),
    [anon_sym_CARET] = ACTIONS(1621),
    [anon_sym_AMP] = ACTIONS(1621),
    [anon_sym_this] = ACTIONS(1627),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1629),
    [anon_sym_unchecked] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [anon_sym_DOT_DOT] = ACTIONS(1637),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_stackalloc] = ACTIONS(1641),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(1647),
    [anon_sym___reftype] = ACTIONS(1649),
    [anon_sym___refvalue] = ACTIONS(1651),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1659),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [2034] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6967),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5053),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(3858),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7382),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9625),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(2034),
    [sym_preproc_endregion] = STATE(2034),
    [sym_preproc_line] = STATE(2034),
    [sym_preproc_pragma] = STATE(2034),
    [sym_preproc_nullable] = STATE(2034),
    [sym_preproc_error] = STATE(2034),
    [sym_preproc_define] = STATE(2034),
    [sym_preproc_undef] = STATE(2034),
    [aux_sym_class_declaration_repeat1] = STATE(3851),
    [aux_sym_lambda_expression_repeat1] = STATE(4234),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_ref] = ACTIONS(1293),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1059),
    [anon_sym_TILDE] = ACTIONS(1059),
    [anon_sym_PLUS_PLUS] = ACTIONS(1059),
    [anon_sym_DASH_DASH] = ACTIONS(1059),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1061),
    [anon_sym_DASH] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(1303),
    [anon_sym_CARET] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1307),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1309),
    [anon_sym_DOT_DOT] = ACTIONS(1311),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [2035] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3921),
    [sym__name] = STATE(6919),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2868),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(7068),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5120),
    [sym_non_lvalue_expression] = STATE(5735),
    [sym_lvalue_expression] = STATE(4323),
    [sym__expression_statement_expression] = STATE(5733),
    [sym_assignment_expression] = STATE(5734),
    [sym_binary_expression] = STATE(5733),
    [sym_postfix_unary_expression] = STATE(5734),
    [sym_prefix_unary_expression] = STATE(5734),
    [sym__pointer_indirection_expression] = STATE(3911),
    [sym_query_expression] = STATE(5733),
    [sym_from_clause] = STATE(7393),
    [sym_conditional_expression] = STATE(5733),
    [sym_conditional_access_expression] = STATE(5733),
    [sym_as_expression] = STATE(5733),
    [sym_is_expression] = STATE(5733),
    [sym_is_pattern_expression] = STATE(5733),
    [sym_cast_expression] = STATE(5733),
    [sym_checked_expression] = STATE(5733),
    [sym_invocation_expression] = STATE(5734),
    [sym_switch_expression] = STATE(5733),
    [sym_await_expression] = STATE(5734),
    [sym_throw_expression] = STATE(5733),
    [sym_element_access_expression] = STATE(3911),
    [sym_interpolated_string_expression] = STATE(5733),
    [sym_member_access_expression] = STATE(3911),
    [sym_object_creation_expression] = STATE(5734),
    [sym_parenthesized_expression] = STATE(5734),
    [sym__parenthesized_lvalue_expression] = STATE(3911),
    [sym_lambda_expression] = STATE(5733),
    [sym__lambda_parameters] = STATE(9932),
    [sym_array_creation_expression] = STATE(5733),
    [sym_anonymous_method_expression] = STATE(5733),
    [sym_anonymous_object_creation_expression] = STATE(5733),
    [sym_implicit_array_creation_expression] = STATE(5733),
    [sym_implicit_object_creation_expression] = STATE(5733),
    [sym_implicit_stackalloc_expression] = STATE(5733),
    [sym_initializer_expression] = STATE(5733),
    [sym_default_expression] = STATE(5733),
    [sym_with_expression] = STATE(5733),
    [sym_sizeof_expression] = STATE(5733),
    [sym_typeof_expression] = STATE(5733),
    [sym_makeref_expression] = STATE(5733),
    [sym_ref_expression] = STATE(5733),
    [sym_reftype_expression] = STATE(5733),
    [sym_refvalue_expression] = STATE(5733),
    [sym_stackalloc_expression] = STATE(5733),
    [sym_range_expression] = STATE(5733),
    [sym_tuple_expression] = STATE(3911),
    [sym_literal] = STATE(5733),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2798),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(5733),
    [sym_preproc_region] = STATE(2035),
    [sym_preproc_endregion] = STATE(2035),
    [sym_preproc_line] = STATE(2035),
    [sym_preproc_pragma] = STATE(2035),
    [sym_preproc_nullable] = STATE(2035),
    [sym_preproc_error] = STATE(2035),
    [sym_preproc_define] = STATE(2035),
    [sym_preproc_undef] = STATE(2035),
    [aux_sym_class_declaration_repeat1] = STATE(3831),
    [aux_sym_lambda_expression_repeat1] = STATE(4227),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_LPAREN] = ACTIONS(1577),
    [anon_sym_ref] = ACTIONS(1579),
    [anon_sym_LBRACE] = ACTIONS(1377),
    [anon_sym_delegate] = ACTIONS(1379),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1381),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1583),
    [anon_sym_TILDE] = ACTIONS(1583),
    [anon_sym_PLUS_PLUS] = ACTIONS(1583),
    [anon_sym_DASH_DASH] = ACTIONS(1583),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1581),
    [anon_sym_DASH] = ACTIONS(1581),
    [anon_sym_STAR] = ACTIONS(1391),
    [anon_sym_CARET] = ACTIONS(1583),
    [anon_sym_AMP] = ACTIONS(1583),
    [anon_sym_this] = ACTIONS(1393),
    [anon_sym_scoped] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1397),
    [sym_predefined_type] = ACTIONS(1399),
    [anon_sym_unchecked] = ACTIONS(1383),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1585),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1587),
    [anon_sym_DOT_DOT] = ACTIONS(1589),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_stackalloc] = ACTIONS(1413),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(1419),
    [anon_sym___reftype] = ACTIONS(1421),
    [anon_sym___refvalue] = ACTIONS(1423),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
  },
  [2036] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3559),
    [sym__name] = STATE(6878),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2911),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6960),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4469),
    [sym_non_lvalue_expression] = STATE(4553),
    [sym_lvalue_expression] = STATE(3607),
    [sym__expression_statement_expression] = STATE(4559),
    [sym_assignment_expression] = STATE(4558),
    [sym_binary_expression] = STATE(4559),
    [sym_postfix_unary_expression] = STATE(4558),
    [sym_prefix_unary_expression] = STATE(4558),
    [sym__pointer_indirection_expression] = STATE(3560),
    [sym_query_expression] = STATE(4559),
    [sym_from_clause] = STATE(7385),
    [sym_conditional_expression] = STATE(4559),
    [sym_conditional_access_expression] = STATE(4559),
    [sym_as_expression] = STATE(4559),
    [sym_is_expression] = STATE(4559),
    [sym_is_pattern_expression] = STATE(4559),
    [sym_cast_expression] = STATE(4559),
    [sym_checked_expression] = STATE(4559),
    [sym_invocation_expression] = STATE(4558),
    [sym_switch_expression] = STATE(4559),
    [sym_await_expression] = STATE(4558),
    [sym_throw_expression] = STATE(4559),
    [sym_element_access_expression] = STATE(3560),
    [sym_interpolated_string_expression] = STATE(4559),
    [sym_member_access_expression] = STATE(3560),
    [sym_object_creation_expression] = STATE(4558),
    [sym_parenthesized_expression] = STATE(4558),
    [sym__parenthesized_lvalue_expression] = STATE(3560),
    [sym_lambda_expression] = STATE(4559),
    [sym__lambda_parameters] = STATE(9554),
    [sym_array_creation_expression] = STATE(4559),
    [sym_anonymous_method_expression] = STATE(4559),
    [sym_anonymous_object_creation_expression] = STATE(4559),
    [sym_implicit_array_creation_expression] = STATE(4559),
    [sym_implicit_object_creation_expression] = STATE(4559),
    [sym_implicit_stackalloc_expression] = STATE(4559),
    [sym_initializer_expression] = STATE(4559),
    [sym_default_expression] = STATE(4559),
    [sym_with_expression] = STATE(4559),
    [sym_sizeof_expression] = STATE(4559),
    [sym_typeof_expression] = STATE(4559),
    [sym_makeref_expression] = STATE(4559),
    [sym_ref_expression] = STATE(4559),
    [sym_reftype_expression] = STATE(4559),
    [sym_refvalue_expression] = STATE(4559),
    [sym_stackalloc_expression] = STATE(4559),
    [sym_range_expression] = STATE(4559),
    [sym_tuple_expression] = STATE(3560),
    [sym_literal] = STATE(4559),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4559),
    [sym_preproc_region] = STATE(2036),
    [sym_preproc_endregion] = STATE(2036),
    [sym_preproc_line] = STATE(2036),
    [sym_preproc_pragma] = STATE(2036),
    [sym_preproc_nullable] = STATE(2036),
    [sym_preproc_error] = STATE(2036),
    [sym_preproc_define] = STATE(2036),
    [sym_preproc_undef] = STATE(2036),
    [aux_sym_class_declaration_repeat1] = STATE(3792),
    [aux_sym_lambda_expression_repeat1] = STATE(4202),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(1607),
    [anon_sym_ref] = ACTIONS(1609),
    [anon_sym_LBRACE] = ACTIONS(1611),
    [anon_sym_delegate] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1615),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(1621),
    [anon_sym_TILDE] = ACTIONS(1621),
    [anon_sym_PLUS_PLUS] = ACTIONS(1621),
    [anon_sym_DASH_DASH] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(1619),
    [anon_sym_DASH] = ACTIONS(1619),
    [anon_sym_STAR] = ACTIONS(1625),
    [anon_sym_CARET] = ACTIONS(1621),
    [anon_sym_AMP] = ACTIONS(1621),
    [anon_sym_this] = ACTIONS(1627),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1629),
    [anon_sym_unchecked] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [anon_sym_DOT_DOT] = ACTIONS(1637),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_stackalloc] = ACTIONS(1641),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(1647),
    [anon_sym___reftype] = ACTIONS(1649),
    [anon_sym___refvalue] = ACTIONS(1651),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1659),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [2037] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3921),
    [sym__name] = STATE(6919),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2868),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(7094),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6676),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(3886),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3911),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3911),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3911),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3911),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9654),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3911),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2798),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(2037),
    [sym_preproc_endregion] = STATE(2037),
    [sym_preproc_line] = STATE(2037),
    [sym_preproc_pragma] = STATE(2037),
    [sym_preproc_nullable] = STATE(2037),
    [sym_preproc_error] = STATE(2037),
    [sym_preproc_define] = STATE(2037),
    [sym_preproc_undef] = STATE(2037),
    [aux_sym_class_declaration_repeat1] = STATE(3846),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_LPAREN] = ACTIONS(2917),
    [anon_sym_ref] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1669),
    [anon_sym_TILDE] = ACTIONS(1669),
    [anon_sym_PLUS_PLUS] = ACTIONS(1669),
    [anon_sym_DASH_DASH] = ACTIONS(1669),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1667),
    [anon_sym_DASH] = ACTIONS(1667),
    [anon_sym_STAR] = ACTIONS(1391),
    [anon_sym_CARET] = ACTIONS(1669),
    [anon_sym_AMP] = ACTIONS(1669),
    [anon_sym_this] = ACTIONS(1393),
    [anon_sym_scoped] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1397),
    [sym_predefined_type] = ACTIONS(1399),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1673),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [2038] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6967),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5050),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(3858),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7382),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9625),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(2038),
    [sym_preproc_endregion] = STATE(2038),
    [sym_preproc_line] = STATE(2038),
    [sym_preproc_pragma] = STATE(2038),
    [sym_preproc_nullable] = STATE(2038),
    [sym_preproc_error] = STATE(2038),
    [sym_preproc_define] = STATE(2038),
    [sym_preproc_undef] = STATE(2038),
    [aux_sym_class_declaration_repeat1] = STATE(3851),
    [aux_sym_lambda_expression_repeat1] = STATE(4234),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_ref] = ACTIONS(1293),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1059),
    [anon_sym_TILDE] = ACTIONS(1059),
    [anon_sym_PLUS_PLUS] = ACTIONS(1059),
    [anon_sym_DASH_DASH] = ACTIONS(1059),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1061),
    [anon_sym_DASH] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(1303),
    [anon_sym_CARET] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1307),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1309),
    [anon_sym_DOT_DOT] = ACTIONS(1311),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [2039] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6967),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5047),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(3858),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7382),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9625),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(2039),
    [sym_preproc_endregion] = STATE(2039),
    [sym_preproc_line] = STATE(2039),
    [sym_preproc_pragma] = STATE(2039),
    [sym_preproc_nullable] = STATE(2039),
    [sym_preproc_error] = STATE(2039),
    [sym_preproc_define] = STATE(2039),
    [sym_preproc_undef] = STATE(2039),
    [aux_sym_class_declaration_repeat1] = STATE(3851),
    [aux_sym_lambda_expression_repeat1] = STATE(4234),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_ref] = ACTIONS(1293),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1059),
    [anon_sym_TILDE] = ACTIONS(1059),
    [anon_sym_PLUS_PLUS] = ACTIONS(1059),
    [anon_sym_DASH_DASH] = ACTIONS(1059),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1061),
    [anon_sym_DASH] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(1303),
    [anon_sym_CARET] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1307),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1309),
    [anon_sym_DOT_DOT] = ACTIONS(1311),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [2040] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6967),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5044),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(3858),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7382),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9625),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(2040),
    [sym_preproc_endregion] = STATE(2040),
    [sym_preproc_line] = STATE(2040),
    [sym_preproc_pragma] = STATE(2040),
    [sym_preproc_nullable] = STATE(2040),
    [sym_preproc_error] = STATE(2040),
    [sym_preproc_define] = STATE(2040),
    [sym_preproc_undef] = STATE(2040),
    [aux_sym_class_declaration_repeat1] = STATE(3851),
    [aux_sym_lambda_expression_repeat1] = STATE(4234),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_ref] = ACTIONS(1293),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1059),
    [anon_sym_TILDE] = ACTIONS(1059),
    [anon_sym_PLUS_PLUS] = ACTIONS(1059),
    [anon_sym_DASH_DASH] = ACTIONS(1059),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1061),
    [anon_sym_DASH] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(1303),
    [anon_sym_CARET] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1307),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1309),
    [anon_sym_DOT_DOT] = ACTIONS(1311),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [2041] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3921),
    [sym__name] = STATE(6889),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2854),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(7061),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5114),
    [sym_non_lvalue_expression] = STATE(5735),
    [sym_lvalue_expression] = STATE(3899),
    [sym__expression_statement_expression] = STATE(5733),
    [sym_assignment_expression] = STATE(5734),
    [sym_binary_expression] = STATE(5733),
    [sym_postfix_unary_expression] = STATE(5734),
    [sym_prefix_unary_expression] = STATE(5734),
    [sym__pointer_indirection_expression] = STATE(3911),
    [sym_query_expression] = STATE(5733),
    [sym_from_clause] = STATE(7400),
    [sym_conditional_expression] = STATE(5733),
    [sym_conditional_access_expression] = STATE(5733),
    [sym_as_expression] = STATE(5733),
    [sym_is_expression] = STATE(5733),
    [sym_is_pattern_expression] = STATE(5733),
    [sym_cast_expression] = STATE(5733),
    [sym_checked_expression] = STATE(5733),
    [sym_invocation_expression] = STATE(5734),
    [sym_switch_expression] = STATE(5733),
    [sym_await_expression] = STATE(5734),
    [sym_throw_expression] = STATE(5733),
    [sym_element_access_expression] = STATE(3911),
    [sym_interpolated_string_expression] = STATE(5733),
    [sym_member_access_expression] = STATE(3911),
    [sym_object_creation_expression] = STATE(5734),
    [sym_parenthesized_expression] = STATE(5734),
    [sym__parenthesized_lvalue_expression] = STATE(3911),
    [sym_lambda_expression] = STATE(5733),
    [sym__lambda_parameters] = STATE(9790),
    [sym_array_creation_expression] = STATE(5733),
    [sym_anonymous_method_expression] = STATE(5733),
    [sym_anonymous_object_creation_expression] = STATE(5733),
    [sym_implicit_array_creation_expression] = STATE(5733),
    [sym_implicit_object_creation_expression] = STATE(5733),
    [sym_implicit_stackalloc_expression] = STATE(5733),
    [sym_initializer_expression] = STATE(5733),
    [sym_default_expression] = STATE(5733),
    [sym_with_expression] = STATE(5733),
    [sym_sizeof_expression] = STATE(5733),
    [sym_typeof_expression] = STATE(5733),
    [sym_makeref_expression] = STATE(5733),
    [sym_ref_expression] = STATE(5733),
    [sym_reftype_expression] = STATE(5733),
    [sym_refvalue_expression] = STATE(5733),
    [sym_stackalloc_expression] = STATE(5733),
    [sym_range_expression] = STATE(5733),
    [sym_tuple_expression] = STATE(3911),
    [sym_literal] = STATE(5733),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2798),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(5733),
    [sym_preproc_region] = STATE(2041),
    [sym_preproc_endregion] = STATE(2041),
    [sym_preproc_line] = STATE(2041),
    [sym_preproc_pragma] = STATE(2041),
    [sym_preproc_nullable] = STATE(2041),
    [sym_preproc_error] = STATE(2041),
    [sym_preproc_define] = STATE(2041),
    [sym_preproc_undef] = STATE(2041),
    [aux_sym_class_declaration_repeat1] = STATE(3833),
    [aux_sym_lambda_expression_repeat1] = STATE(4182),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_LPAREN] = ACTIONS(1439),
    [anon_sym_ref] = ACTIONS(1441),
    [anon_sym_LBRACE] = ACTIONS(1377),
    [anon_sym_delegate] = ACTIONS(1379),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1443),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1447),
    [anon_sym_TILDE] = ACTIONS(1447),
    [anon_sym_PLUS_PLUS] = ACTIONS(1447),
    [anon_sym_DASH_DASH] = ACTIONS(1447),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1445),
    [anon_sym_DASH] = ACTIONS(1445),
    [anon_sym_STAR] = ACTIONS(1449),
    [anon_sym_CARET] = ACTIONS(1447),
    [anon_sym_AMP] = ACTIONS(1447),
    [anon_sym_this] = ACTIONS(1393),
    [anon_sym_scoped] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1397),
    [sym_predefined_type] = ACTIONS(1399),
    [anon_sym_unchecked] = ACTIONS(1383),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1451),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1453),
    [anon_sym_DOT_DOT] = ACTIONS(1455),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_stackalloc] = ACTIONS(1413),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(1419),
    [anon_sym___reftype] = ACTIONS(1421),
    [anon_sym___refvalue] = ACTIONS(1423),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
  },
  [2042] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6967),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(3922),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(3858),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7382),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9625),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(2042),
    [sym_preproc_endregion] = STATE(2042),
    [sym_preproc_line] = STATE(2042),
    [sym_preproc_pragma] = STATE(2042),
    [sym_preproc_nullable] = STATE(2042),
    [sym_preproc_error] = STATE(2042),
    [sym_preproc_define] = STATE(2042),
    [sym_preproc_undef] = STATE(2042),
    [aux_sym_class_declaration_repeat1] = STATE(3851),
    [aux_sym_lambda_expression_repeat1] = STATE(4234),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_ref] = ACTIONS(1293),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1059),
    [anon_sym_TILDE] = ACTIONS(1059),
    [anon_sym_PLUS_PLUS] = ACTIONS(1059),
    [anon_sym_DASH_DASH] = ACTIONS(1059),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1061),
    [anon_sym_DASH] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(1303),
    [anon_sym_CARET] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1307),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1309),
    [anon_sym_DOT_DOT] = ACTIONS(1311),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [2043] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3559),
    [sym__name] = STATE(6878),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2911),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6960),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4457),
    [sym_non_lvalue_expression] = STATE(4553),
    [sym_lvalue_expression] = STATE(3607),
    [sym__expression_statement_expression] = STATE(4559),
    [sym_assignment_expression] = STATE(4558),
    [sym_binary_expression] = STATE(4559),
    [sym_postfix_unary_expression] = STATE(4558),
    [sym_prefix_unary_expression] = STATE(4558),
    [sym__pointer_indirection_expression] = STATE(3560),
    [sym_query_expression] = STATE(4559),
    [sym_from_clause] = STATE(7385),
    [sym_conditional_expression] = STATE(4559),
    [sym_conditional_access_expression] = STATE(4559),
    [sym_as_expression] = STATE(4559),
    [sym_is_expression] = STATE(4559),
    [sym_is_pattern_expression] = STATE(4559),
    [sym_cast_expression] = STATE(4559),
    [sym_checked_expression] = STATE(4559),
    [sym_invocation_expression] = STATE(4558),
    [sym_switch_expression] = STATE(4559),
    [sym_await_expression] = STATE(4558),
    [sym_throw_expression] = STATE(4559),
    [sym_element_access_expression] = STATE(3560),
    [sym_interpolated_string_expression] = STATE(4559),
    [sym_member_access_expression] = STATE(3560),
    [sym_object_creation_expression] = STATE(4558),
    [sym_parenthesized_expression] = STATE(4558),
    [sym__parenthesized_lvalue_expression] = STATE(3560),
    [sym_lambda_expression] = STATE(4559),
    [sym__lambda_parameters] = STATE(9554),
    [sym_array_creation_expression] = STATE(4559),
    [sym_anonymous_method_expression] = STATE(4559),
    [sym_anonymous_object_creation_expression] = STATE(4559),
    [sym_implicit_array_creation_expression] = STATE(4559),
    [sym_implicit_object_creation_expression] = STATE(4559),
    [sym_implicit_stackalloc_expression] = STATE(4559),
    [sym_initializer_expression] = STATE(4559),
    [sym_default_expression] = STATE(4559),
    [sym_with_expression] = STATE(4559),
    [sym_sizeof_expression] = STATE(4559),
    [sym_typeof_expression] = STATE(4559),
    [sym_makeref_expression] = STATE(4559),
    [sym_ref_expression] = STATE(4559),
    [sym_reftype_expression] = STATE(4559),
    [sym_refvalue_expression] = STATE(4559),
    [sym_stackalloc_expression] = STATE(4559),
    [sym_range_expression] = STATE(4559),
    [sym_tuple_expression] = STATE(3560),
    [sym_literal] = STATE(4559),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4559),
    [sym_preproc_region] = STATE(2043),
    [sym_preproc_endregion] = STATE(2043),
    [sym_preproc_line] = STATE(2043),
    [sym_preproc_pragma] = STATE(2043),
    [sym_preproc_nullable] = STATE(2043),
    [sym_preproc_error] = STATE(2043),
    [sym_preproc_define] = STATE(2043),
    [sym_preproc_undef] = STATE(2043),
    [aux_sym_class_declaration_repeat1] = STATE(3792),
    [aux_sym_lambda_expression_repeat1] = STATE(4202),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(1607),
    [anon_sym_ref] = ACTIONS(1609),
    [anon_sym_LBRACE] = ACTIONS(1611),
    [anon_sym_delegate] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1615),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(1621),
    [anon_sym_TILDE] = ACTIONS(1621),
    [anon_sym_PLUS_PLUS] = ACTIONS(1621),
    [anon_sym_DASH_DASH] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(1619),
    [anon_sym_DASH] = ACTIONS(1619),
    [anon_sym_STAR] = ACTIONS(1625),
    [anon_sym_CARET] = ACTIONS(1621),
    [anon_sym_AMP] = ACTIONS(1621),
    [anon_sym_this] = ACTIONS(1627),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1629),
    [anon_sym_unchecked] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [anon_sym_DOT_DOT] = ACTIONS(1637),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_stackalloc] = ACTIONS(1641),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(1647),
    [anon_sym___reftype] = ACTIONS(1649),
    [anon_sym___refvalue] = ACTIONS(1651),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1659),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [2044] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3921),
    [sym__name] = STATE(6889),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2854),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(7061),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5119),
    [sym_non_lvalue_expression] = STATE(5735),
    [sym_lvalue_expression] = STATE(3899),
    [sym__expression_statement_expression] = STATE(5733),
    [sym_assignment_expression] = STATE(5734),
    [sym_binary_expression] = STATE(5733),
    [sym_postfix_unary_expression] = STATE(5734),
    [sym_prefix_unary_expression] = STATE(5734),
    [sym__pointer_indirection_expression] = STATE(3911),
    [sym_query_expression] = STATE(5733),
    [sym_from_clause] = STATE(7400),
    [sym_conditional_expression] = STATE(5733),
    [sym_conditional_access_expression] = STATE(5733),
    [sym_as_expression] = STATE(5733),
    [sym_is_expression] = STATE(5733),
    [sym_is_pattern_expression] = STATE(5733),
    [sym_cast_expression] = STATE(5733),
    [sym_checked_expression] = STATE(5733),
    [sym_invocation_expression] = STATE(5734),
    [sym_switch_expression] = STATE(5733),
    [sym_await_expression] = STATE(5734),
    [sym_throw_expression] = STATE(5733),
    [sym_element_access_expression] = STATE(3911),
    [sym_interpolated_string_expression] = STATE(5733),
    [sym_member_access_expression] = STATE(3911),
    [sym_object_creation_expression] = STATE(5734),
    [sym_parenthesized_expression] = STATE(5734),
    [sym__parenthesized_lvalue_expression] = STATE(3911),
    [sym_lambda_expression] = STATE(5733),
    [sym__lambda_parameters] = STATE(9790),
    [sym_array_creation_expression] = STATE(5733),
    [sym_anonymous_method_expression] = STATE(5733),
    [sym_anonymous_object_creation_expression] = STATE(5733),
    [sym_implicit_array_creation_expression] = STATE(5733),
    [sym_implicit_object_creation_expression] = STATE(5733),
    [sym_implicit_stackalloc_expression] = STATE(5733),
    [sym_initializer_expression] = STATE(5733),
    [sym_default_expression] = STATE(5733),
    [sym_with_expression] = STATE(5733),
    [sym_sizeof_expression] = STATE(5733),
    [sym_typeof_expression] = STATE(5733),
    [sym_makeref_expression] = STATE(5733),
    [sym_ref_expression] = STATE(5733),
    [sym_reftype_expression] = STATE(5733),
    [sym_refvalue_expression] = STATE(5733),
    [sym_stackalloc_expression] = STATE(5733),
    [sym_range_expression] = STATE(5733),
    [sym_tuple_expression] = STATE(3911),
    [sym_literal] = STATE(5733),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2798),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(5733),
    [sym_preproc_region] = STATE(2044),
    [sym_preproc_endregion] = STATE(2044),
    [sym_preproc_line] = STATE(2044),
    [sym_preproc_pragma] = STATE(2044),
    [sym_preproc_nullable] = STATE(2044),
    [sym_preproc_error] = STATE(2044),
    [sym_preproc_define] = STATE(2044),
    [sym_preproc_undef] = STATE(2044),
    [aux_sym_class_declaration_repeat1] = STATE(3833),
    [aux_sym_lambda_expression_repeat1] = STATE(4182),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_LPAREN] = ACTIONS(1439),
    [anon_sym_ref] = ACTIONS(1441),
    [anon_sym_LBRACE] = ACTIONS(1377),
    [anon_sym_delegate] = ACTIONS(1379),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1443),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1447),
    [anon_sym_TILDE] = ACTIONS(1447),
    [anon_sym_PLUS_PLUS] = ACTIONS(1447),
    [anon_sym_DASH_DASH] = ACTIONS(1447),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1445),
    [anon_sym_DASH] = ACTIONS(1445),
    [anon_sym_STAR] = ACTIONS(1449),
    [anon_sym_CARET] = ACTIONS(1447),
    [anon_sym_AMP] = ACTIONS(1447),
    [anon_sym_this] = ACTIONS(1393),
    [anon_sym_scoped] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1397),
    [sym_predefined_type] = ACTIONS(1399),
    [anon_sym_unchecked] = ACTIONS(1383),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1451),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1453),
    [anon_sym_DOT_DOT] = ACTIONS(1455),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_stackalloc] = ACTIONS(1413),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(1419),
    [anon_sym___reftype] = ACTIONS(1421),
    [anon_sym___refvalue] = ACTIONS(1423),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
  },
  [2045] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7076),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6154),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4314),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9775),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(2045),
    [sym_preproc_endregion] = STATE(2045),
    [sym_preproc_line] = STATE(2045),
    [sym_preproc_pragma] = STATE(2045),
    [sym_preproc_nullable] = STATE(2045),
    [sym_preproc_error] = STATE(2045),
    [sym_preproc_define] = STATE(2045),
    [sym_preproc_undef] = STATE(2045),
    [aux_sym_class_declaration_repeat1] = STATE(3835),
    [aux_sym_lambda_expression_repeat1] = STATE(4236),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1535),
    [anon_sym_ref] = ACTIONS(1537),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1465),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(885),
    [anon_sym_TILDE] = ACTIONS(885),
    [anon_sym_PLUS_PLUS] = ACTIONS(885),
    [anon_sym_DASH_DASH] = ACTIONS(885),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(887),
    [anon_sym_DASH] = ACTIONS(887),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(885),
    [anon_sym_AMP] = ACTIONS(885),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1539),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1541),
    [anon_sym_DOT_DOT] = ACTIONS(1543),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [2046] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3559),
    [sym__name] = STATE(6878),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2911),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6960),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4456),
    [sym_non_lvalue_expression] = STATE(4553),
    [sym_lvalue_expression] = STATE(3607),
    [sym__expression_statement_expression] = STATE(4559),
    [sym_assignment_expression] = STATE(4558),
    [sym_binary_expression] = STATE(4559),
    [sym_postfix_unary_expression] = STATE(4558),
    [sym_prefix_unary_expression] = STATE(4558),
    [sym__pointer_indirection_expression] = STATE(3560),
    [sym_query_expression] = STATE(4559),
    [sym_from_clause] = STATE(7385),
    [sym_conditional_expression] = STATE(4559),
    [sym_conditional_access_expression] = STATE(4559),
    [sym_as_expression] = STATE(4559),
    [sym_is_expression] = STATE(4559),
    [sym_is_pattern_expression] = STATE(4559),
    [sym_cast_expression] = STATE(4559),
    [sym_checked_expression] = STATE(4559),
    [sym_invocation_expression] = STATE(4558),
    [sym_switch_expression] = STATE(4559),
    [sym_await_expression] = STATE(4558),
    [sym_throw_expression] = STATE(4559),
    [sym_element_access_expression] = STATE(3560),
    [sym_interpolated_string_expression] = STATE(4559),
    [sym_member_access_expression] = STATE(3560),
    [sym_object_creation_expression] = STATE(4558),
    [sym_parenthesized_expression] = STATE(4558),
    [sym__parenthesized_lvalue_expression] = STATE(3560),
    [sym_lambda_expression] = STATE(4559),
    [sym__lambda_parameters] = STATE(9554),
    [sym_array_creation_expression] = STATE(4559),
    [sym_anonymous_method_expression] = STATE(4559),
    [sym_anonymous_object_creation_expression] = STATE(4559),
    [sym_implicit_array_creation_expression] = STATE(4559),
    [sym_implicit_object_creation_expression] = STATE(4559),
    [sym_implicit_stackalloc_expression] = STATE(4559),
    [sym_initializer_expression] = STATE(4559),
    [sym_default_expression] = STATE(4559),
    [sym_with_expression] = STATE(4559),
    [sym_sizeof_expression] = STATE(4559),
    [sym_typeof_expression] = STATE(4559),
    [sym_makeref_expression] = STATE(4559),
    [sym_ref_expression] = STATE(4559),
    [sym_reftype_expression] = STATE(4559),
    [sym_refvalue_expression] = STATE(4559),
    [sym_stackalloc_expression] = STATE(4559),
    [sym_range_expression] = STATE(4559),
    [sym_tuple_expression] = STATE(3560),
    [sym_literal] = STATE(4559),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4559),
    [sym_preproc_region] = STATE(2046),
    [sym_preproc_endregion] = STATE(2046),
    [sym_preproc_line] = STATE(2046),
    [sym_preproc_pragma] = STATE(2046),
    [sym_preproc_nullable] = STATE(2046),
    [sym_preproc_error] = STATE(2046),
    [sym_preproc_define] = STATE(2046),
    [sym_preproc_undef] = STATE(2046),
    [aux_sym_class_declaration_repeat1] = STATE(3792),
    [aux_sym_lambda_expression_repeat1] = STATE(4202),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(1607),
    [anon_sym_ref] = ACTIONS(1609),
    [anon_sym_LBRACE] = ACTIONS(1611),
    [anon_sym_delegate] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1615),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(1621),
    [anon_sym_TILDE] = ACTIONS(1621),
    [anon_sym_PLUS_PLUS] = ACTIONS(1621),
    [anon_sym_DASH_DASH] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(1619),
    [anon_sym_DASH] = ACTIONS(1619),
    [anon_sym_STAR] = ACTIONS(1625),
    [anon_sym_CARET] = ACTIONS(1621),
    [anon_sym_AMP] = ACTIONS(1621),
    [anon_sym_this] = ACTIONS(1627),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1629),
    [anon_sym_unchecked] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [anon_sym_DOT_DOT] = ACTIONS(1637),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_stackalloc] = ACTIONS(1641),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(1647),
    [anon_sym___reftype] = ACTIONS(1649),
    [anon_sym___refvalue] = ACTIONS(1651),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1659),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [2047] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3559),
    [sym__name] = STATE(6878),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2911),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6960),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4455),
    [sym_non_lvalue_expression] = STATE(4553),
    [sym_lvalue_expression] = STATE(3607),
    [sym__expression_statement_expression] = STATE(4559),
    [sym_assignment_expression] = STATE(4558),
    [sym_binary_expression] = STATE(4559),
    [sym_postfix_unary_expression] = STATE(4558),
    [sym_prefix_unary_expression] = STATE(4558),
    [sym__pointer_indirection_expression] = STATE(3560),
    [sym_query_expression] = STATE(4559),
    [sym_from_clause] = STATE(7385),
    [sym_conditional_expression] = STATE(4559),
    [sym_conditional_access_expression] = STATE(4559),
    [sym_as_expression] = STATE(4559),
    [sym_is_expression] = STATE(4559),
    [sym_is_pattern_expression] = STATE(4559),
    [sym_cast_expression] = STATE(4559),
    [sym_checked_expression] = STATE(4559),
    [sym_invocation_expression] = STATE(4558),
    [sym_switch_expression] = STATE(4559),
    [sym_await_expression] = STATE(4558),
    [sym_throw_expression] = STATE(4559),
    [sym_element_access_expression] = STATE(3560),
    [sym_interpolated_string_expression] = STATE(4559),
    [sym_member_access_expression] = STATE(3560),
    [sym_object_creation_expression] = STATE(4558),
    [sym_parenthesized_expression] = STATE(4558),
    [sym__parenthesized_lvalue_expression] = STATE(3560),
    [sym_lambda_expression] = STATE(4559),
    [sym__lambda_parameters] = STATE(9554),
    [sym_array_creation_expression] = STATE(4559),
    [sym_anonymous_method_expression] = STATE(4559),
    [sym_anonymous_object_creation_expression] = STATE(4559),
    [sym_implicit_array_creation_expression] = STATE(4559),
    [sym_implicit_object_creation_expression] = STATE(4559),
    [sym_implicit_stackalloc_expression] = STATE(4559),
    [sym_initializer_expression] = STATE(4559),
    [sym_default_expression] = STATE(4559),
    [sym_with_expression] = STATE(4559),
    [sym_sizeof_expression] = STATE(4559),
    [sym_typeof_expression] = STATE(4559),
    [sym_makeref_expression] = STATE(4559),
    [sym_ref_expression] = STATE(4559),
    [sym_reftype_expression] = STATE(4559),
    [sym_refvalue_expression] = STATE(4559),
    [sym_stackalloc_expression] = STATE(4559),
    [sym_range_expression] = STATE(4559),
    [sym_tuple_expression] = STATE(3560),
    [sym_literal] = STATE(4559),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4559),
    [sym_preproc_region] = STATE(2047),
    [sym_preproc_endregion] = STATE(2047),
    [sym_preproc_line] = STATE(2047),
    [sym_preproc_pragma] = STATE(2047),
    [sym_preproc_nullable] = STATE(2047),
    [sym_preproc_error] = STATE(2047),
    [sym_preproc_define] = STATE(2047),
    [sym_preproc_undef] = STATE(2047),
    [aux_sym_class_declaration_repeat1] = STATE(3792),
    [aux_sym_lambda_expression_repeat1] = STATE(4202),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(1607),
    [anon_sym_ref] = ACTIONS(1609),
    [anon_sym_LBRACE] = ACTIONS(1611),
    [anon_sym_delegate] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1615),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(1621),
    [anon_sym_TILDE] = ACTIONS(1621),
    [anon_sym_PLUS_PLUS] = ACTIONS(1621),
    [anon_sym_DASH_DASH] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(1619),
    [anon_sym_DASH] = ACTIONS(1619),
    [anon_sym_STAR] = ACTIONS(1625),
    [anon_sym_CARET] = ACTIONS(1621),
    [anon_sym_AMP] = ACTIONS(1621),
    [anon_sym_this] = ACTIONS(1627),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1629),
    [anon_sym_unchecked] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [anon_sym_DOT_DOT] = ACTIONS(1637),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_stackalloc] = ACTIONS(1641),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(1647),
    [anon_sym___reftype] = ACTIONS(1649),
    [anon_sym___refvalue] = ACTIONS(1651),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1659),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [2048] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3559),
    [sym__name] = STATE(6877),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2908),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6958),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4676),
    [sym_non_lvalue_expression] = STATE(4553),
    [sym_lvalue_expression] = STATE(3691),
    [sym__expression_statement_expression] = STATE(4559),
    [sym_assignment_expression] = STATE(4558),
    [sym_binary_expression] = STATE(4559),
    [sym_postfix_unary_expression] = STATE(4558),
    [sym_prefix_unary_expression] = STATE(4558),
    [sym__pointer_indirection_expression] = STATE(3560),
    [sym_query_expression] = STATE(4559),
    [sym_from_clause] = STATE(7406),
    [sym_conditional_expression] = STATE(4559),
    [sym_conditional_access_expression] = STATE(4559),
    [sym_as_expression] = STATE(4559),
    [sym_is_expression] = STATE(4559),
    [sym_is_pattern_expression] = STATE(4559),
    [sym_cast_expression] = STATE(4559),
    [sym_checked_expression] = STATE(4559),
    [sym_invocation_expression] = STATE(4558),
    [sym_switch_expression] = STATE(4559),
    [sym_await_expression] = STATE(4558),
    [sym_throw_expression] = STATE(4559),
    [sym_element_access_expression] = STATE(3560),
    [sym_interpolated_string_expression] = STATE(4559),
    [sym_member_access_expression] = STATE(3560),
    [sym_object_creation_expression] = STATE(4558),
    [sym_parenthesized_expression] = STATE(4558),
    [sym__parenthesized_lvalue_expression] = STATE(3560),
    [sym_lambda_expression] = STATE(4559),
    [sym__lambda_parameters] = STATE(9348),
    [sym_array_creation_expression] = STATE(4559),
    [sym_anonymous_method_expression] = STATE(4559),
    [sym_anonymous_object_creation_expression] = STATE(4559),
    [sym_implicit_array_creation_expression] = STATE(4559),
    [sym_implicit_object_creation_expression] = STATE(4559),
    [sym_implicit_stackalloc_expression] = STATE(4559),
    [sym_initializer_expression] = STATE(4559),
    [sym_default_expression] = STATE(4559),
    [sym_with_expression] = STATE(4559),
    [sym_sizeof_expression] = STATE(4559),
    [sym_typeof_expression] = STATE(4559),
    [sym_makeref_expression] = STATE(4559),
    [sym_ref_expression] = STATE(4559),
    [sym_reftype_expression] = STATE(4559),
    [sym_refvalue_expression] = STATE(4559),
    [sym_stackalloc_expression] = STATE(4559),
    [sym_range_expression] = STATE(4559),
    [sym_tuple_expression] = STATE(3560),
    [sym_literal] = STATE(4559),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4559),
    [sym_preproc_region] = STATE(2048),
    [sym_preproc_endregion] = STATE(2048),
    [sym_preproc_line] = STATE(2048),
    [sym_preproc_pragma] = STATE(2048),
    [sym_preproc_nullable] = STATE(2048),
    [sym_preproc_error] = STATE(2048),
    [sym_preproc_define] = STATE(2048),
    [sym_preproc_undef] = STATE(2048),
    [aux_sym_class_declaration_repeat1] = STATE(3810),
    [aux_sym_lambda_expression_repeat1] = STATE(4141),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(2047),
    [anon_sym_ref] = ACTIONS(2049),
    [anon_sym_LBRACE] = ACTIONS(1611),
    [anon_sym_delegate] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1679),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(2053),
    [anon_sym_TILDE] = ACTIONS(2053),
    [anon_sym_PLUS_PLUS] = ACTIONS(2053),
    [anon_sym_DASH_DASH] = ACTIONS(2053),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(2051),
    [anon_sym_DASH] = ACTIONS(2051),
    [anon_sym_STAR] = ACTIONS(1685),
    [anon_sym_CARET] = ACTIONS(2053),
    [anon_sym_AMP] = ACTIONS(2053),
    [anon_sym_this] = ACTIONS(1627),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1629),
    [anon_sym_unchecked] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(2055),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2057),
    [anon_sym_DOT_DOT] = ACTIONS(2059),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_stackalloc] = ACTIONS(1641),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(1647),
    [anon_sym___reftype] = ACTIONS(1649),
    [anon_sym___refvalue] = ACTIONS(1651),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1659),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [2049] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3559),
    [sym__name] = STATE(6878),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2911),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6960),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4468),
    [sym_non_lvalue_expression] = STATE(4553),
    [sym_lvalue_expression] = STATE(3607),
    [sym__expression_statement_expression] = STATE(4559),
    [sym_assignment_expression] = STATE(4558),
    [sym_binary_expression] = STATE(4559),
    [sym_postfix_unary_expression] = STATE(4558),
    [sym_prefix_unary_expression] = STATE(4558),
    [sym__pointer_indirection_expression] = STATE(3560),
    [sym_query_expression] = STATE(4559),
    [sym_from_clause] = STATE(7385),
    [sym_conditional_expression] = STATE(4559),
    [sym_conditional_access_expression] = STATE(4559),
    [sym_as_expression] = STATE(4559),
    [sym_is_expression] = STATE(4559),
    [sym_is_pattern_expression] = STATE(4559),
    [sym_cast_expression] = STATE(4559),
    [sym_checked_expression] = STATE(4559),
    [sym_invocation_expression] = STATE(4558),
    [sym_switch_expression] = STATE(4559),
    [sym_await_expression] = STATE(4558),
    [sym_throw_expression] = STATE(4559),
    [sym_element_access_expression] = STATE(3560),
    [sym_interpolated_string_expression] = STATE(4559),
    [sym_member_access_expression] = STATE(3560),
    [sym_object_creation_expression] = STATE(4558),
    [sym_parenthesized_expression] = STATE(4558),
    [sym__parenthesized_lvalue_expression] = STATE(3560),
    [sym_lambda_expression] = STATE(4559),
    [sym__lambda_parameters] = STATE(9554),
    [sym_array_creation_expression] = STATE(4559),
    [sym_anonymous_method_expression] = STATE(4559),
    [sym_anonymous_object_creation_expression] = STATE(4559),
    [sym_implicit_array_creation_expression] = STATE(4559),
    [sym_implicit_object_creation_expression] = STATE(4559),
    [sym_implicit_stackalloc_expression] = STATE(4559),
    [sym_initializer_expression] = STATE(4559),
    [sym_default_expression] = STATE(4559),
    [sym_with_expression] = STATE(4559),
    [sym_sizeof_expression] = STATE(4559),
    [sym_typeof_expression] = STATE(4559),
    [sym_makeref_expression] = STATE(4559),
    [sym_ref_expression] = STATE(4559),
    [sym_reftype_expression] = STATE(4559),
    [sym_refvalue_expression] = STATE(4559),
    [sym_stackalloc_expression] = STATE(4559),
    [sym_range_expression] = STATE(4559),
    [sym_tuple_expression] = STATE(3560),
    [sym_literal] = STATE(4559),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4559),
    [sym_preproc_region] = STATE(2049),
    [sym_preproc_endregion] = STATE(2049),
    [sym_preproc_line] = STATE(2049),
    [sym_preproc_pragma] = STATE(2049),
    [sym_preproc_nullable] = STATE(2049),
    [sym_preproc_error] = STATE(2049),
    [sym_preproc_define] = STATE(2049),
    [sym_preproc_undef] = STATE(2049),
    [aux_sym_class_declaration_repeat1] = STATE(3792),
    [aux_sym_lambda_expression_repeat1] = STATE(4202),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(1607),
    [anon_sym_ref] = ACTIONS(1609),
    [anon_sym_LBRACE] = ACTIONS(1611),
    [anon_sym_delegate] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1615),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(1621),
    [anon_sym_TILDE] = ACTIONS(1621),
    [anon_sym_PLUS_PLUS] = ACTIONS(1621),
    [anon_sym_DASH_DASH] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(1619),
    [anon_sym_DASH] = ACTIONS(1619),
    [anon_sym_STAR] = ACTIONS(1625),
    [anon_sym_CARET] = ACTIONS(1621),
    [anon_sym_AMP] = ACTIONS(1621),
    [anon_sym_this] = ACTIONS(1627),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1629),
    [anon_sym_unchecked] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [anon_sym_DOT_DOT] = ACTIONS(1637),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_stackalloc] = ACTIONS(1641),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(1647),
    [anon_sym___reftype] = ACTIONS(1649),
    [anon_sym___refvalue] = ACTIONS(1651),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1659),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [2050] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3559),
    [sym__name] = STATE(6877),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2908),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6958),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4346),
    [sym_non_lvalue_expression] = STATE(4553),
    [sym_lvalue_expression] = STATE(3691),
    [sym__expression_statement_expression] = STATE(4559),
    [sym_assignment_expression] = STATE(4558),
    [sym_binary_expression] = STATE(4559),
    [sym_postfix_unary_expression] = STATE(4558),
    [sym_prefix_unary_expression] = STATE(4558),
    [sym__pointer_indirection_expression] = STATE(3560),
    [sym_query_expression] = STATE(4559),
    [sym_from_clause] = STATE(7406),
    [sym_conditional_expression] = STATE(4559),
    [sym_conditional_access_expression] = STATE(4559),
    [sym_as_expression] = STATE(4559),
    [sym_is_expression] = STATE(4559),
    [sym_is_pattern_expression] = STATE(4559),
    [sym_cast_expression] = STATE(4559),
    [sym_checked_expression] = STATE(4559),
    [sym_invocation_expression] = STATE(4558),
    [sym_switch_expression] = STATE(4559),
    [sym_await_expression] = STATE(4558),
    [sym_throw_expression] = STATE(4559),
    [sym_element_access_expression] = STATE(3560),
    [sym_interpolated_string_expression] = STATE(4559),
    [sym_member_access_expression] = STATE(3560),
    [sym_object_creation_expression] = STATE(4558),
    [sym_parenthesized_expression] = STATE(4558),
    [sym__parenthesized_lvalue_expression] = STATE(3560),
    [sym_lambda_expression] = STATE(4559),
    [sym__lambda_parameters] = STATE(9348),
    [sym_array_creation_expression] = STATE(4559),
    [sym_anonymous_method_expression] = STATE(4559),
    [sym_anonymous_object_creation_expression] = STATE(4559),
    [sym_implicit_array_creation_expression] = STATE(4559),
    [sym_implicit_object_creation_expression] = STATE(4559),
    [sym_implicit_stackalloc_expression] = STATE(4559),
    [sym_initializer_expression] = STATE(4559),
    [sym_default_expression] = STATE(4559),
    [sym_with_expression] = STATE(4559),
    [sym_sizeof_expression] = STATE(4559),
    [sym_typeof_expression] = STATE(4559),
    [sym_makeref_expression] = STATE(4559),
    [sym_ref_expression] = STATE(4559),
    [sym_reftype_expression] = STATE(4559),
    [sym_refvalue_expression] = STATE(4559),
    [sym_stackalloc_expression] = STATE(4559),
    [sym_range_expression] = STATE(4559),
    [sym_tuple_expression] = STATE(3560),
    [sym_literal] = STATE(4559),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4559),
    [sym_preproc_region] = STATE(2050),
    [sym_preproc_endregion] = STATE(2050),
    [sym_preproc_line] = STATE(2050),
    [sym_preproc_pragma] = STATE(2050),
    [sym_preproc_nullable] = STATE(2050),
    [sym_preproc_error] = STATE(2050),
    [sym_preproc_define] = STATE(2050),
    [sym_preproc_undef] = STATE(2050),
    [aux_sym_class_declaration_repeat1] = STATE(3810),
    [aux_sym_lambda_expression_repeat1] = STATE(4141),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(2047),
    [anon_sym_ref] = ACTIONS(2049),
    [anon_sym_LBRACE] = ACTIONS(1611),
    [anon_sym_delegate] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1679),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(2053),
    [anon_sym_TILDE] = ACTIONS(2053),
    [anon_sym_PLUS_PLUS] = ACTIONS(2053),
    [anon_sym_DASH_DASH] = ACTIONS(2053),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(2051),
    [anon_sym_DASH] = ACTIONS(2051),
    [anon_sym_STAR] = ACTIONS(1685),
    [anon_sym_CARET] = ACTIONS(2053),
    [anon_sym_AMP] = ACTIONS(2053),
    [anon_sym_this] = ACTIONS(1627),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1629),
    [anon_sym_unchecked] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(2055),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2057),
    [anon_sym_DOT_DOT] = ACTIONS(2059),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_stackalloc] = ACTIONS(1641),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(1647),
    [anon_sym___reftype] = ACTIONS(1649),
    [anon_sym___refvalue] = ACTIONS(1651),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1659),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [2051] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7076),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6159),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4314),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9775),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(2051),
    [sym_preproc_endregion] = STATE(2051),
    [sym_preproc_line] = STATE(2051),
    [sym_preproc_pragma] = STATE(2051),
    [sym_preproc_nullable] = STATE(2051),
    [sym_preproc_error] = STATE(2051),
    [sym_preproc_define] = STATE(2051),
    [sym_preproc_undef] = STATE(2051),
    [aux_sym_class_declaration_repeat1] = STATE(3835),
    [aux_sym_lambda_expression_repeat1] = STATE(4236),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1535),
    [anon_sym_ref] = ACTIONS(1537),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1465),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(885),
    [anon_sym_TILDE] = ACTIONS(885),
    [anon_sym_PLUS_PLUS] = ACTIONS(885),
    [anon_sym_DASH_DASH] = ACTIONS(885),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(887),
    [anon_sym_DASH] = ACTIONS(887),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(885),
    [anon_sym_AMP] = ACTIONS(885),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1539),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1541),
    [anon_sym_DOT_DOT] = ACTIONS(1543),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [2052] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3921),
    [sym__name] = STATE(6889),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2854),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(7061),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5113),
    [sym_non_lvalue_expression] = STATE(5735),
    [sym_lvalue_expression] = STATE(3899),
    [sym__expression_statement_expression] = STATE(5733),
    [sym_assignment_expression] = STATE(5734),
    [sym_binary_expression] = STATE(5733),
    [sym_postfix_unary_expression] = STATE(5734),
    [sym_prefix_unary_expression] = STATE(5734),
    [sym__pointer_indirection_expression] = STATE(3911),
    [sym_query_expression] = STATE(5733),
    [sym_from_clause] = STATE(7400),
    [sym_conditional_expression] = STATE(5733),
    [sym_conditional_access_expression] = STATE(5733),
    [sym_as_expression] = STATE(5733),
    [sym_is_expression] = STATE(5733),
    [sym_is_pattern_expression] = STATE(5733),
    [sym_cast_expression] = STATE(5733),
    [sym_checked_expression] = STATE(5733),
    [sym_invocation_expression] = STATE(5734),
    [sym_switch_expression] = STATE(5733),
    [sym_await_expression] = STATE(5734),
    [sym_throw_expression] = STATE(5733),
    [sym_element_access_expression] = STATE(3911),
    [sym_interpolated_string_expression] = STATE(5733),
    [sym_member_access_expression] = STATE(3911),
    [sym_object_creation_expression] = STATE(5734),
    [sym_parenthesized_expression] = STATE(5734),
    [sym__parenthesized_lvalue_expression] = STATE(3911),
    [sym_lambda_expression] = STATE(5733),
    [sym__lambda_parameters] = STATE(9790),
    [sym_array_creation_expression] = STATE(5733),
    [sym_anonymous_method_expression] = STATE(5733),
    [sym_anonymous_object_creation_expression] = STATE(5733),
    [sym_implicit_array_creation_expression] = STATE(5733),
    [sym_implicit_object_creation_expression] = STATE(5733),
    [sym_implicit_stackalloc_expression] = STATE(5733),
    [sym_initializer_expression] = STATE(5733),
    [sym_default_expression] = STATE(5733),
    [sym_with_expression] = STATE(5733),
    [sym_sizeof_expression] = STATE(5733),
    [sym_typeof_expression] = STATE(5733),
    [sym_makeref_expression] = STATE(5733),
    [sym_ref_expression] = STATE(5733),
    [sym_reftype_expression] = STATE(5733),
    [sym_refvalue_expression] = STATE(5733),
    [sym_stackalloc_expression] = STATE(5733),
    [sym_range_expression] = STATE(5733),
    [sym_tuple_expression] = STATE(3911),
    [sym_literal] = STATE(5733),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2798),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(5733),
    [sym_preproc_region] = STATE(2052),
    [sym_preproc_endregion] = STATE(2052),
    [sym_preproc_line] = STATE(2052),
    [sym_preproc_pragma] = STATE(2052),
    [sym_preproc_nullable] = STATE(2052),
    [sym_preproc_error] = STATE(2052),
    [sym_preproc_define] = STATE(2052),
    [sym_preproc_undef] = STATE(2052),
    [aux_sym_class_declaration_repeat1] = STATE(3833),
    [aux_sym_lambda_expression_repeat1] = STATE(4182),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_LPAREN] = ACTIONS(1439),
    [anon_sym_ref] = ACTIONS(1441),
    [anon_sym_LBRACE] = ACTIONS(1377),
    [anon_sym_delegate] = ACTIONS(1379),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1443),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1447),
    [anon_sym_TILDE] = ACTIONS(1447),
    [anon_sym_PLUS_PLUS] = ACTIONS(1447),
    [anon_sym_DASH_DASH] = ACTIONS(1447),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1445),
    [anon_sym_DASH] = ACTIONS(1445),
    [anon_sym_STAR] = ACTIONS(1449),
    [anon_sym_CARET] = ACTIONS(1447),
    [anon_sym_AMP] = ACTIONS(1447),
    [anon_sym_this] = ACTIONS(1393),
    [anon_sym_scoped] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1397),
    [sym_predefined_type] = ACTIONS(1399),
    [anon_sym_unchecked] = ACTIONS(1383),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1451),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1453),
    [anon_sym_DOT_DOT] = ACTIONS(1455),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_stackalloc] = ACTIONS(1413),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(1419),
    [anon_sym___reftype] = ACTIONS(1421),
    [anon_sym___refvalue] = ACTIONS(1423),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
  },
  [2053] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3559),
    [sym__name] = STATE(6878),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2911),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6960),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4454),
    [sym_non_lvalue_expression] = STATE(4553),
    [sym_lvalue_expression] = STATE(3607),
    [sym__expression_statement_expression] = STATE(4559),
    [sym_assignment_expression] = STATE(4558),
    [sym_binary_expression] = STATE(4559),
    [sym_postfix_unary_expression] = STATE(4558),
    [sym_prefix_unary_expression] = STATE(4558),
    [sym__pointer_indirection_expression] = STATE(3560),
    [sym_query_expression] = STATE(4559),
    [sym_from_clause] = STATE(7385),
    [sym_conditional_expression] = STATE(4559),
    [sym_conditional_access_expression] = STATE(4559),
    [sym_as_expression] = STATE(4559),
    [sym_is_expression] = STATE(4559),
    [sym_is_pattern_expression] = STATE(4559),
    [sym_cast_expression] = STATE(4559),
    [sym_checked_expression] = STATE(4559),
    [sym_invocation_expression] = STATE(4558),
    [sym_switch_expression] = STATE(4559),
    [sym_await_expression] = STATE(4558),
    [sym_throw_expression] = STATE(4559),
    [sym_element_access_expression] = STATE(3560),
    [sym_interpolated_string_expression] = STATE(4559),
    [sym_member_access_expression] = STATE(3560),
    [sym_object_creation_expression] = STATE(4558),
    [sym_parenthesized_expression] = STATE(4558),
    [sym__parenthesized_lvalue_expression] = STATE(3560),
    [sym_lambda_expression] = STATE(4559),
    [sym__lambda_parameters] = STATE(9554),
    [sym_array_creation_expression] = STATE(4559),
    [sym_anonymous_method_expression] = STATE(4559),
    [sym_anonymous_object_creation_expression] = STATE(4559),
    [sym_implicit_array_creation_expression] = STATE(4559),
    [sym_implicit_object_creation_expression] = STATE(4559),
    [sym_implicit_stackalloc_expression] = STATE(4559),
    [sym_initializer_expression] = STATE(4559),
    [sym_default_expression] = STATE(4559),
    [sym_with_expression] = STATE(4559),
    [sym_sizeof_expression] = STATE(4559),
    [sym_typeof_expression] = STATE(4559),
    [sym_makeref_expression] = STATE(4559),
    [sym_ref_expression] = STATE(4559),
    [sym_reftype_expression] = STATE(4559),
    [sym_refvalue_expression] = STATE(4559),
    [sym_stackalloc_expression] = STATE(4559),
    [sym_range_expression] = STATE(4559),
    [sym_tuple_expression] = STATE(3560),
    [sym_literal] = STATE(4559),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4559),
    [sym_preproc_region] = STATE(2053),
    [sym_preproc_endregion] = STATE(2053),
    [sym_preproc_line] = STATE(2053),
    [sym_preproc_pragma] = STATE(2053),
    [sym_preproc_nullable] = STATE(2053),
    [sym_preproc_error] = STATE(2053),
    [sym_preproc_define] = STATE(2053),
    [sym_preproc_undef] = STATE(2053),
    [aux_sym_class_declaration_repeat1] = STATE(3792),
    [aux_sym_lambda_expression_repeat1] = STATE(4202),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(1607),
    [anon_sym_ref] = ACTIONS(1609),
    [anon_sym_LBRACE] = ACTIONS(1611),
    [anon_sym_delegate] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1615),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(1621),
    [anon_sym_TILDE] = ACTIONS(1621),
    [anon_sym_PLUS_PLUS] = ACTIONS(1621),
    [anon_sym_DASH_DASH] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(1619),
    [anon_sym_DASH] = ACTIONS(1619),
    [anon_sym_STAR] = ACTIONS(1625),
    [anon_sym_CARET] = ACTIONS(1621),
    [anon_sym_AMP] = ACTIONS(1621),
    [anon_sym_this] = ACTIONS(1627),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1629),
    [anon_sym_unchecked] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [anon_sym_DOT_DOT] = ACTIONS(1637),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_stackalloc] = ACTIONS(1641),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(1647),
    [anon_sym___reftype] = ACTIONS(1649),
    [anon_sym___refvalue] = ACTIONS(1651),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1659),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [2054] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3921),
    [sym__name] = STATE(6889),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2854),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(7061),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5170),
    [sym_non_lvalue_expression] = STATE(5735),
    [sym_lvalue_expression] = STATE(3899),
    [sym__expression_statement_expression] = STATE(5733),
    [sym_assignment_expression] = STATE(5734),
    [sym_binary_expression] = STATE(5733),
    [sym_postfix_unary_expression] = STATE(5734),
    [sym_prefix_unary_expression] = STATE(5734),
    [sym__pointer_indirection_expression] = STATE(3911),
    [sym_query_expression] = STATE(5733),
    [sym_from_clause] = STATE(7400),
    [sym_conditional_expression] = STATE(5733),
    [sym_conditional_access_expression] = STATE(5733),
    [sym_as_expression] = STATE(5733),
    [sym_is_expression] = STATE(5733),
    [sym_is_pattern_expression] = STATE(5733),
    [sym_cast_expression] = STATE(5733),
    [sym_checked_expression] = STATE(5733),
    [sym_invocation_expression] = STATE(5734),
    [sym_switch_expression] = STATE(5733),
    [sym_await_expression] = STATE(5734),
    [sym_throw_expression] = STATE(5733),
    [sym_element_access_expression] = STATE(3911),
    [sym_interpolated_string_expression] = STATE(5733),
    [sym_member_access_expression] = STATE(3911),
    [sym_object_creation_expression] = STATE(5734),
    [sym_parenthesized_expression] = STATE(5734),
    [sym__parenthesized_lvalue_expression] = STATE(3911),
    [sym_lambda_expression] = STATE(5733),
    [sym__lambda_parameters] = STATE(9790),
    [sym_array_creation_expression] = STATE(5733),
    [sym_anonymous_method_expression] = STATE(5733),
    [sym_anonymous_object_creation_expression] = STATE(5733),
    [sym_implicit_array_creation_expression] = STATE(5733),
    [sym_implicit_object_creation_expression] = STATE(5733),
    [sym_implicit_stackalloc_expression] = STATE(5733),
    [sym_initializer_expression] = STATE(5733),
    [sym_default_expression] = STATE(5733),
    [sym_with_expression] = STATE(5733),
    [sym_sizeof_expression] = STATE(5733),
    [sym_typeof_expression] = STATE(5733),
    [sym_makeref_expression] = STATE(5733),
    [sym_ref_expression] = STATE(5733),
    [sym_reftype_expression] = STATE(5733),
    [sym_refvalue_expression] = STATE(5733),
    [sym_stackalloc_expression] = STATE(5733),
    [sym_range_expression] = STATE(5733),
    [sym_tuple_expression] = STATE(3911),
    [sym_literal] = STATE(5733),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2798),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(5733),
    [sym_preproc_region] = STATE(2054),
    [sym_preproc_endregion] = STATE(2054),
    [sym_preproc_line] = STATE(2054),
    [sym_preproc_pragma] = STATE(2054),
    [sym_preproc_nullable] = STATE(2054),
    [sym_preproc_error] = STATE(2054),
    [sym_preproc_define] = STATE(2054),
    [sym_preproc_undef] = STATE(2054),
    [aux_sym_class_declaration_repeat1] = STATE(3833),
    [aux_sym_lambda_expression_repeat1] = STATE(4182),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_LPAREN] = ACTIONS(1439),
    [anon_sym_ref] = ACTIONS(1441),
    [anon_sym_LBRACE] = ACTIONS(1377),
    [anon_sym_delegate] = ACTIONS(1379),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1443),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1447),
    [anon_sym_TILDE] = ACTIONS(1447),
    [anon_sym_PLUS_PLUS] = ACTIONS(1447),
    [anon_sym_DASH_DASH] = ACTIONS(1447),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1445),
    [anon_sym_DASH] = ACTIONS(1445),
    [anon_sym_STAR] = ACTIONS(1449),
    [anon_sym_CARET] = ACTIONS(1447),
    [anon_sym_AMP] = ACTIONS(1447),
    [anon_sym_this] = ACTIONS(1393),
    [anon_sym_scoped] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1397),
    [sym_predefined_type] = ACTIONS(1399),
    [anon_sym_unchecked] = ACTIONS(1383),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1451),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1453),
    [anon_sym_DOT_DOT] = ACTIONS(1455),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_stackalloc] = ACTIONS(1413),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(1419),
    [anon_sym___reftype] = ACTIONS(1421),
    [anon_sym___refvalue] = ACTIONS(1423),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
  },
  [2055] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3921),
    [sym__name] = STATE(6889),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2854),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(7061),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5127),
    [sym_non_lvalue_expression] = STATE(5735),
    [sym_lvalue_expression] = STATE(3899),
    [sym__expression_statement_expression] = STATE(5733),
    [sym_assignment_expression] = STATE(5734),
    [sym_binary_expression] = STATE(5733),
    [sym_postfix_unary_expression] = STATE(5734),
    [sym_prefix_unary_expression] = STATE(5734),
    [sym__pointer_indirection_expression] = STATE(3911),
    [sym_query_expression] = STATE(5733),
    [sym_from_clause] = STATE(7400),
    [sym_conditional_expression] = STATE(5733),
    [sym_conditional_access_expression] = STATE(5733),
    [sym_as_expression] = STATE(5733),
    [sym_is_expression] = STATE(5733),
    [sym_is_pattern_expression] = STATE(5733),
    [sym_cast_expression] = STATE(5733),
    [sym_checked_expression] = STATE(5733),
    [sym_invocation_expression] = STATE(5734),
    [sym_switch_expression] = STATE(5733),
    [sym_await_expression] = STATE(5734),
    [sym_throw_expression] = STATE(5733),
    [sym_element_access_expression] = STATE(3911),
    [sym_interpolated_string_expression] = STATE(5733),
    [sym_member_access_expression] = STATE(3911),
    [sym_object_creation_expression] = STATE(5734),
    [sym_parenthesized_expression] = STATE(5734),
    [sym__parenthesized_lvalue_expression] = STATE(3911),
    [sym_lambda_expression] = STATE(5733),
    [sym__lambda_parameters] = STATE(9790),
    [sym_array_creation_expression] = STATE(5733),
    [sym_anonymous_method_expression] = STATE(5733),
    [sym_anonymous_object_creation_expression] = STATE(5733),
    [sym_implicit_array_creation_expression] = STATE(5733),
    [sym_implicit_object_creation_expression] = STATE(5733),
    [sym_implicit_stackalloc_expression] = STATE(5733),
    [sym_initializer_expression] = STATE(5733),
    [sym_default_expression] = STATE(5733),
    [sym_with_expression] = STATE(5733),
    [sym_sizeof_expression] = STATE(5733),
    [sym_typeof_expression] = STATE(5733),
    [sym_makeref_expression] = STATE(5733),
    [sym_ref_expression] = STATE(5733),
    [sym_reftype_expression] = STATE(5733),
    [sym_refvalue_expression] = STATE(5733),
    [sym_stackalloc_expression] = STATE(5733),
    [sym_range_expression] = STATE(5733),
    [sym_tuple_expression] = STATE(3911),
    [sym_literal] = STATE(5733),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2798),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(5733),
    [sym_preproc_region] = STATE(2055),
    [sym_preproc_endregion] = STATE(2055),
    [sym_preproc_line] = STATE(2055),
    [sym_preproc_pragma] = STATE(2055),
    [sym_preproc_nullable] = STATE(2055),
    [sym_preproc_error] = STATE(2055),
    [sym_preproc_define] = STATE(2055),
    [sym_preproc_undef] = STATE(2055),
    [aux_sym_class_declaration_repeat1] = STATE(3833),
    [aux_sym_lambda_expression_repeat1] = STATE(4182),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_LPAREN] = ACTIONS(1439),
    [anon_sym_ref] = ACTIONS(1441),
    [anon_sym_LBRACE] = ACTIONS(1377),
    [anon_sym_delegate] = ACTIONS(1379),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1443),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1447),
    [anon_sym_TILDE] = ACTIONS(1447),
    [anon_sym_PLUS_PLUS] = ACTIONS(1447),
    [anon_sym_DASH_DASH] = ACTIONS(1447),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1445),
    [anon_sym_DASH] = ACTIONS(1445),
    [anon_sym_STAR] = ACTIONS(1449),
    [anon_sym_CARET] = ACTIONS(1447),
    [anon_sym_AMP] = ACTIONS(1447),
    [anon_sym_this] = ACTIONS(1393),
    [anon_sym_scoped] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1397),
    [sym_predefined_type] = ACTIONS(1399),
    [anon_sym_unchecked] = ACTIONS(1383),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1451),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1453),
    [anon_sym_DOT_DOT] = ACTIONS(1455),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_stackalloc] = ACTIONS(1413),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(1419),
    [anon_sym___reftype] = ACTIONS(1421),
    [anon_sym___refvalue] = ACTIONS(1423),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
  },
  [2056] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3559),
    [sym__name] = STATE(6878),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2911),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6960),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4453),
    [sym_non_lvalue_expression] = STATE(4553),
    [sym_lvalue_expression] = STATE(3607),
    [sym__expression_statement_expression] = STATE(4559),
    [sym_assignment_expression] = STATE(4558),
    [sym_binary_expression] = STATE(4559),
    [sym_postfix_unary_expression] = STATE(4558),
    [sym_prefix_unary_expression] = STATE(4558),
    [sym__pointer_indirection_expression] = STATE(3560),
    [sym_query_expression] = STATE(4559),
    [sym_from_clause] = STATE(7385),
    [sym_conditional_expression] = STATE(4559),
    [sym_conditional_access_expression] = STATE(4559),
    [sym_as_expression] = STATE(4559),
    [sym_is_expression] = STATE(4559),
    [sym_is_pattern_expression] = STATE(4559),
    [sym_cast_expression] = STATE(4559),
    [sym_checked_expression] = STATE(4559),
    [sym_invocation_expression] = STATE(4558),
    [sym_switch_expression] = STATE(4559),
    [sym_await_expression] = STATE(4558),
    [sym_throw_expression] = STATE(4559),
    [sym_element_access_expression] = STATE(3560),
    [sym_interpolated_string_expression] = STATE(4559),
    [sym_member_access_expression] = STATE(3560),
    [sym_object_creation_expression] = STATE(4558),
    [sym_parenthesized_expression] = STATE(4558),
    [sym__parenthesized_lvalue_expression] = STATE(3560),
    [sym_lambda_expression] = STATE(4559),
    [sym__lambda_parameters] = STATE(9554),
    [sym_array_creation_expression] = STATE(4559),
    [sym_anonymous_method_expression] = STATE(4559),
    [sym_anonymous_object_creation_expression] = STATE(4559),
    [sym_implicit_array_creation_expression] = STATE(4559),
    [sym_implicit_object_creation_expression] = STATE(4559),
    [sym_implicit_stackalloc_expression] = STATE(4559),
    [sym_initializer_expression] = STATE(4559),
    [sym_default_expression] = STATE(4559),
    [sym_with_expression] = STATE(4559),
    [sym_sizeof_expression] = STATE(4559),
    [sym_typeof_expression] = STATE(4559),
    [sym_makeref_expression] = STATE(4559),
    [sym_ref_expression] = STATE(4559),
    [sym_reftype_expression] = STATE(4559),
    [sym_refvalue_expression] = STATE(4559),
    [sym_stackalloc_expression] = STATE(4559),
    [sym_range_expression] = STATE(4559),
    [sym_tuple_expression] = STATE(3560),
    [sym_literal] = STATE(4559),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4559),
    [sym_preproc_region] = STATE(2056),
    [sym_preproc_endregion] = STATE(2056),
    [sym_preproc_line] = STATE(2056),
    [sym_preproc_pragma] = STATE(2056),
    [sym_preproc_nullable] = STATE(2056),
    [sym_preproc_error] = STATE(2056),
    [sym_preproc_define] = STATE(2056),
    [sym_preproc_undef] = STATE(2056),
    [aux_sym_class_declaration_repeat1] = STATE(3792),
    [aux_sym_lambda_expression_repeat1] = STATE(4202),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(1607),
    [anon_sym_ref] = ACTIONS(1609),
    [anon_sym_LBRACE] = ACTIONS(1611),
    [anon_sym_delegate] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1615),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(1621),
    [anon_sym_TILDE] = ACTIONS(1621),
    [anon_sym_PLUS_PLUS] = ACTIONS(1621),
    [anon_sym_DASH_DASH] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(1619),
    [anon_sym_DASH] = ACTIONS(1619),
    [anon_sym_STAR] = ACTIONS(1625),
    [anon_sym_CARET] = ACTIONS(1621),
    [anon_sym_AMP] = ACTIONS(1621),
    [anon_sym_this] = ACTIONS(1627),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1629),
    [anon_sym_unchecked] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [anon_sym_DOT_DOT] = ACTIONS(1637),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_stackalloc] = ACTIONS(1641),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(1647),
    [anon_sym___reftype] = ACTIONS(1649),
    [anon_sym___refvalue] = ACTIONS(1651),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1659),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [2057] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3559),
    [sym__name] = STATE(6878),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2911),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6960),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4452),
    [sym_non_lvalue_expression] = STATE(4553),
    [sym_lvalue_expression] = STATE(3607),
    [sym__expression_statement_expression] = STATE(4559),
    [sym_assignment_expression] = STATE(4558),
    [sym_binary_expression] = STATE(4559),
    [sym_postfix_unary_expression] = STATE(4558),
    [sym_prefix_unary_expression] = STATE(4558),
    [sym__pointer_indirection_expression] = STATE(3560),
    [sym_query_expression] = STATE(4559),
    [sym_from_clause] = STATE(7385),
    [sym_conditional_expression] = STATE(4559),
    [sym_conditional_access_expression] = STATE(4559),
    [sym_as_expression] = STATE(4559),
    [sym_is_expression] = STATE(4559),
    [sym_is_pattern_expression] = STATE(4559),
    [sym_cast_expression] = STATE(4559),
    [sym_checked_expression] = STATE(4559),
    [sym_invocation_expression] = STATE(4558),
    [sym_switch_expression] = STATE(4559),
    [sym_await_expression] = STATE(4558),
    [sym_throw_expression] = STATE(4559),
    [sym_element_access_expression] = STATE(3560),
    [sym_interpolated_string_expression] = STATE(4559),
    [sym_member_access_expression] = STATE(3560),
    [sym_object_creation_expression] = STATE(4558),
    [sym_parenthesized_expression] = STATE(4558),
    [sym__parenthesized_lvalue_expression] = STATE(3560),
    [sym_lambda_expression] = STATE(4559),
    [sym__lambda_parameters] = STATE(9554),
    [sym_array_creation_expression] = STATE(4559),
    [sym_anonymous_method_expression] = STATE(4559),
    [sym_anonymous_object_creation_expression] = STATE(4559),
    [sym_implicit_array_creation_expression] = STATE(4559),
    [sym_implicit_object_creation_expression] = STATE(4559),
    [sym_implicit_stackalloc_expression] = STATE(4559),
    [sym_initializer_expression] = STATE(4559),
    [sym_default_expression] = STATE(4559),
    [sym_with_expression] = STATE(4559),
    [sym_sizeof_expression] = STATE(4559),
    [sym_typeof_expression] = STATE(4559),
    [sym_makeref_expression] = STATE(4559),
    [sym_ref_expression] = STATE(4559),
    [sym_reftype_expression] = STATE(4559),
    [sym_refvalue_expression] = STATE(4559),
    [sym_stackalloc_expression] = STATE(4559),
    [sym_range_expression] = STATE(4559),
    [sym_tuple_expression] = STATE(3560),
    [sym_literal] = STATE(4559),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4559),
    [sym_preproc_region] = STATE(2057),
    [sym_preproc_endregion] = STATE(2057),
    [sym_preproc_line] = STATE(2057),
    [sym_preproc_pragma] = STATE(2057),
    [sym_preproc_nullable] = STATE(2057),
    [sym_preproc_error] = STATE(2057),
    [sym_preproc_define] = STATE(2057),
    [sym_preproc_undef] = STATE(2057),
    [aux_sym_class_declaration_repeat1] = STATE(3792),
    [aux_sym_lambda_expression_repeat1] = STATE(4202),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(1607),
    [anon_sym_ref] = ACTIONS(1609),
    [anon_sym_LBRACE] = ACTIONS(1611),
    [anon_sym_delegate] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1615),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(1621),
    [anon_sym_TILDE] = ACTIONS(1621),
    [anon_sym_PLUS_PLUS] = ACTIONS(1621),
    [anon_sym_DASH_DASH] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(1619),
    [anon_sym_DASH] = ACTIONS(1619),
    [anon_sym_STAR] = ACTIONS(1625),
    [anon_sym_CARET] = ACTIONS(1621),
    [anon_sym_AMP] = ACTIONS(1621),
    [anon_sym_this] = ACTIONS(1627),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1629),
    [anon_sym_unchecked] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [anon_sym_DOT_DOT] = ACTIONS(1637),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_stackalloc] = ACTIONS(1641),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(1647),
    [anon_sym___reftype] = ACTIONS(1649),
    [anon_sym___refvalue] = ACTIONS(1651),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1659),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [2058] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3559),
    [sym__name] = STATE(6878),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2911),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6960),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4451),
    [sym_non_lvalue_expression] = STATE(4553),
    [sym_lvalue_expression] = STATE(3607),
    [sym__expression_statement_expression] = STATE(4559),
    [sym_assignment_expression] = STATE(4558),
    [sym_binary_expression] = STATE(4559),
    [sym_postfix_unary_expression] = STATE(4558),
    [sym_prefix_unary_expression] = STATE(4558),
    [sym__pointer_indirection_expression] = STATE(3560),
    [sym_query_expression] = STATE(4559),
    [sym_from_clause] = STATE(7385),
    [sym_conditional_expression] = STATE(4559),
    [sym_conditional_access_expression] = STATE(4559),
    [sym_as_expression] = STATE(4559),
    [sym_is_expression] = STATE(4559),
    [sym_is_pattern_expression] = STATE(4559),
    [sym_cast_expression] = STATE(4559),
    [sym_checked_expression] = STATE(4559),
    [sym_invocation_expression] = STATE(4558),
    [sym_switch_expression] = STATE(4559),
    [sym_await_expression] = STATE(4558),
    [sym_throw_expression] = STATE(4559),
    [sym_element_access_expression] = STATE(3560),
    [sym_interpolated_string_expression] = STATE(4559),
    [sym_member_access_expression] = STATE(3560),
    [sym_object_creation_expression] = STATE(4558),
    [sym_parenthesized_expression] = STATE(4558),
    [sym__parenthesized_lvalue_expression] = STATE(3560),
    [sym_lambda_expression] = STATE(4559),
    [sym__lambda_parameters] = STATE(9554),
    [sym_array_creation_expression] = STATE(4559),
    [sym_anonymous_method_expression] = STATE(4559),
    [sym_anonymous_object_creation_expression] = STATE(4559),
    [sym_implicit_array_creation_expression] = STATE(4559),
    [sym_implicit_object_creation_expression] = STATE(4559),
    [sym_implicit_stackalloc_expression] = STATE(4559),
    [sym_initializer_expression] = STATE(4559),
    [sym_default_expression] = STATE(4559),
    [sym_with_expression] = STATE(4559),
    [sym_sizeof_expression] = STATE(4559),
    [sym_typeof_expression] = STATE(4559),
    [sym_makeref_expression] = STATE(4559),
    [sym_ref_expression] = STATE(4559),
    [sym_reftype_expression] = STATE(4559),
    [sym_refvalue_expression] = STATE(4559),
    [sym_stackalloc_expression] = STATE(4559),
    [sym_range_expression] = STATE(4559),
    [sym_tuple_expression] = STATE(3560),
    [sym_literal] = STATE(4559),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4559),
    [sym_preproc_region] = STATE(2058),
    [sym_preproc_endregion] = STATE(2058),
    [sym_preproc_line] = STATE(2058),
    [sym_preproc_pragma] = STATE(2058),
    [sym_preproc_nullable] = STATE(2058),
    [sym_preproc_error] = STATE(2058),
    [sym_preproc_define] = STATE(2058),
    [sym_preproc_undef] = STATE(2058),
    [aux_sym_class_declaration_repeat1] = STATE(3792),
    [aux_sym_lambda_expression_repeat1] = STATE(4202),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(1607),
    [anon_sym_ref] = ACTIONS(1609),
    [anon_sym_LBRACE] = ACTIONS(1611),
    [anon_sym_delegate] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1615),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(1621),
    [anon_sym_TILDE] = ACTIONS(1621),
    [anon_sym_PLUS_PLUS] = ACTIONS(1621),
    [anon_sym_DASH_DASH] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(1619),
    [anon_sym_DASH] = ACTIONS(1619),
    [anon_sym_STAR] = ACTIONS(1625),
    [anon_sym_CARET] = ACTIONS(1621),
    [anon_sym_AMP] = ACTIONS(1621),
    [anon_sym_this] = ACTIONS(1627),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1629),
    [anon_sym_unchecked] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [anon_sym_DOT_DOT] = ACTIONS(1637),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_stackalloc] = ACTIONS(1641),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(1647),
    [anon_sym___reftype] = ACTIONS(1649),
    [anon_sym___refvalue] = ACTIONS(1651),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1659),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [2059] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3921),
    [sym__name] = STATE(6889),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2854),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(7061),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5135),
    [sym_non_lvalue_expression] = STATE(5735),
    [sym_lvalue_expression] = STATE(3899),
    [sym__expression_statement_expression] = STATE(5733),
    [sym_assignment_expression] = STATE(5734),
    [sym_binary_expression] = STATE(5733),
    [sym_postfix_unary_expression] = STATE(5734),
    [sym_prefix_unary_expression] = STATE(5734),
    [sym__pointer_indirection_expression] = STATE(3911),
    [sym_query_expression] = STATE(5733),
    [sym_from_clause] = STATE(7400),
    [sym_conditional_expression] = STATE(5733),
    [sym_conditional_access_expression] = STATE(5733),
    [sym_as_expression] = STATE(5733),
    [sym_is_expression] = STATE(5733),
    [sym_is_pattern_expression] = STATE(5733),
    [sym_cast_expression] = STATE(5733),
    [sym_checked_expression] = STATE(5733),
    [sym_invocation_expression] = STATE(5734),
    [sym_switch_expression] = STATE(5733),
    [sym_await_expression] = STATE(5734),
    [sym_throw_expression] = STATE(5733),
    [sym_element_access_expression] = STATE(3911),
    [sym_interpolated_string_expression] = STATE(5733),
    [sym_member_access_expression] = STATE(3911),
    [sym_object_creation_expression] = STATE(5734),
    [sym_parenthesized_expression] = STATE(5734),
    [sym__parenthesized_lvalue_expression] = STATE(3911),
    [sym_lambda_expression] = STATE(5733),
    [sym__lambda_parameters] = STATE(9790),
    [sym_array_creation_expression] = STATE(5733),
    [sym_anonymous_method_expression] = STATE(5733),
    [sym_anonymous_object_creation_expression] = STATE(5733),
    [sym_implicit_array_creation_expression] = STATE(5733),
    [sym_implicit_object_creation_expression] = STATE(5733),
    [sym_implicit_stackalloc_expression] = STATE(5733),
    [sym_initializer_expression] = STATE(5733),
    [sym_default_expression] = STATE(5733),
    [sym_with_expression] = STATE(5733),
    [sym_sizeof_expression] = STATE(5733),
    [sym_typeof_expression] = STATE(5733),
    [sym_makeref_expression] = STATE(5733),
    [sym_ref_expression] = STATE(5733),
    [sym_reftype_expression] = STATE(5733),
    [sym_refvalue_expression] = STATE(5733),
    [sym_stackalloc_expression] = STATE(5733),
    [sym_range_expression] = STATE(5733),
    [sym_tuple_expression] = STATE(3911),
    [sym_literal] = STATE(5733),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2798),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(5733),
    [sym_preproc_region] = STATE(2059),
    [sym_preproc_endregion] = STATE(2059),
    [sym_preproc_line] = STATE(2059),
    [sym_preproc_pragma] = STATE(2059),
    [sym_preproc_nullable] = STATE(2059),
    [sym_preproc_error] = STATE(2059),
    [sym_preproc_define] = STATE(2059),
    [sym_preproc_undef] = STATE(2059),
    [aux_sym_class_declaration_repeat1] = STATE(3833),
    [aux_sym_lambda_expression_repeat1] = STATE(4182),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_LPAREN] = ACTIONS(1439),
    [anon_sym_ref] = ACTIONS(1441),
    [anon_sym_LBRACE] = ACTIONS(1377),
    [anon_sym_delegate] = ACTIONS(1379),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1443),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1447),
    [anon_sym_TILDE] = ACTIONS(1447),
    [anon_sym_PLUS_PLUS] = ACTIONS(1447),
    [anon_sym_DASH_DASH] = ACTIONS(1447),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1445),
    [anon_sym_DASH] = ACTIONS(1445),
    [anon_sym_STAR] = ACTIONS(1449),
    [anon_sym_CARET] = ACTIONS(1447),
    [anon_sym_AMP] = ACTIONS(1447),
    [anon_sym_this] = ACTIONS(1393),
    [anon_sym_scoped] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1397),
    [sym_predefined_type] = ACTIONS(1399),
    [anon_sym_unchecked] = ACTIONS(1383),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1451),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1453),
    [anon_sym_DOT_DOT] = ACTIONS(1455),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_stackalloc] = ACTIONS(1413),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(1419),
    [anon_sym___reftype] = ACTIONS(1421),
    [anon_sym___refvalue] = ACTIONS(1423),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
  },
  [2060] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6218),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6875),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6592),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(4477),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7399),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9873),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(2060),
    [sym_preproc_endregion] = STATE(2060),
    [sym_preproc_line] = STATE(2060),
    [sym_preproc_pragma] = STATE(2060),
    [sym_preproc_nullable] = STATE(2060),
    [sym_preproc_error] = STATE(2060),
    [sym_preproc_define] = STATE(2060),
    [sym_preproc_undef] = STATE(2060),
    [aux_sym_class_declaration_repeat1] = STATE(3845),
    [aux_sym_lambda_expression_repeat1] = STATE(4299),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1979),
    [anon_sym_ref] = ACTIONS(1981),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1985),
    [anon_sym_TILDE] = ACTIONS(1985),
    [anon_sym_PLUS_PLUS] = ACTIONS(1985),
    [anon_sym_DASH_DASH] = ACTIONS(1985),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1983),
    [anon_sym_DASH] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1985),
    [anon_sym_AMP] = ACTIONS(1985),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1987),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1989),
    [anon_sym_DOT_DOT] = ACTIONS(1991),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [2061] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3559),
    [sym__name] = STATE(6878),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2911),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6960),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4421),
    [sym_non_lvalue_expression] = STATE(4553),
    [sym_lvalue_expression] = STATE(3607),
    [sym__expression_statement_expression] = STATE(4559),
    [sym_assignment_expression] = STATE(4558),
    [sym_binary_expression] = STATE(4559),
    [sym_postfix_unary_expression] = STATE(4558),
    [sym_prefix_unary_expression] = STATE(4558),
    [sym__pointer_indirection_expression] = STATE(3560),
    [sym_query_expression] = STATE(4559),
    [sym_from_clause] = STATE(7385),
    [sym_conditional_expression] = STATE(4559),
    [sym_conditional_access_expression] = STATE(4559),
    [sym_as_expression] = STATE(4559),
    [sym_is_expression] = STATE(4559),
    [sym_is_pattern_expression] = STATE(4559),
    [sym_cast_expression] = STATE(4559),
    [sym_checked_expression] = STATE(4559),
    [sym_invocation_expression] = STATE(4558),
    [sym_switch_expression] = STATE(4559),
    [sym_await_expression] = STATE(4558),
    [sym_throw_expression] = STATE(4559),
    [sym_element_access_expression] = STATE(3560),
    [sym_interpolated_string_expression] = STATE(4559),
    [sym_member_access_expression] = STATE(3560),
    [sym_object_creation_expression] = STATE(4558),
    [sym_parenthesized_expression] = STATE(4558),
    [sym__parenthesized_lvalue_expression] = STATE(3560),
    [sym_lambda_expression] = STATE(4559),
    [sym__lambda_parameters] = STATE(9554),
    [sym_array_creation_expression] = STATE(4559),
    [sym_anonymous_method_expression] = STATE(4559),
    [sym_anonymous_object_creation_expression] = STATE(4559),
    [sym_implicit_array_creation_expression] = STATE(4559),
    [sym_implicit_object_creation_expression] = STATE(4559),
    [sym_implicit_stackalloc_expression] = STATE(4559),
    [sym_initializer_expression] = STATE(4559),
    [sym_default_expression] = STATE(4559),
    [sym_with_expression] = STATE(4559),
    [sym_sizeof_expression] = STATE(4559),
    [sym_typeof_expression] = STATE(4559),
    [sym_makeref_expression] = STATE(4559),
    [sym_ref_expression] = STATE(4559),
    [sym_reftype_expression] = STATE(4559),
    [sym_refvalue_expression] = STATE(4559),
    [sym_stackalloc_expression] = STATE(4559),
    [sym_range_expression] = STATE(4559),
    [sym_tuple_expression] = STATE(3560),
    [sym_literal] = STATE(4559),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4559),
    [sym_preproc_region] = STATE(2061),
    [sym_preproc_endregion] = STATE(2061),
    [sym_preproc_line] = STATE(2061),
    [sym_preproc_pragma] = STATE(2061),
    [sym_preproc_nullable] = STATE(2061),
    [sym_preproc_error] = STATE(2061),
    [sym_preproc_define] = STATE(2061),
    [sym_preproc_undef] = STATE(2061),
    [aux_sym_class_declaration_repeat1] = STATE(3792),
    [aux_sym_lambda_expression_repeat1] = STATE(4202),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(1607),
    [anon_sym_ref] = ACTIONS(1609),
    [anon_sym_LBRACE] = ACTIONS(1611),
    [anon_sym_delegate] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1615),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(1621),
    [anon_sym_TILDE] = ACTIONS(1621),
    [anon_sym_PLUS_PLUS] = ACTIONS(1621),
    [anon_sym_DASH_DASH] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(1619),
    [anon_sym_DASH] = ACTIONS(1619),
    [anon_sym_STAR] = ACTIONS(1625),
    [anon_sym_CARET] = ACTIONS(1621),
    [anon_sym_AMP] = ACTIONS(1621),
    [anon_sym_this] = ACTIONS(1627),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1629),
    [anon_sym_unchecked] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [anon_sym_DOT_DOT] = ACTIONS(1637),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_stackalloc] = ACTIONS(1641),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(1647),
    [anon_sym___reftype] = ACTIONS(1649),
    [anon_sym___refvalue] = ACTIONS(1651),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1659),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [2062] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3921),
    [sym__name] = STATE(6889),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2854),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(7061),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5140),
    [sym_non_lvalue_expression] = STATE(5735),
    [sym_lvalue_expression] = STATE(3899),
    [sym__expression_statement_expression] = STATE(5733),
    [sym_assignment_expression] = STATE(5734),
    [sym_binary_expression] = STATE(5733),
    [sym_postfix_unary_expression] = STATE(5734),
    [sym_prefix_unary_expression] = STATE(5734),
    [sym__pointer_indirection_expression] = STATE(3911),
    [sym_query_expression] = STATE(5733),
    [sym_from_clause] = STATE(7400),
    [sym_conditional_expression] = STATE(5733),
    [sym_conditional_access_expression] = STATE(5733),
    [sym_as_expression] = STATE(5733),
    [sym_is_expression] = STATE(5733),
    [sym_is_pattern_expression] = STATE(5733),
    [sym_cast_expression] = STATE(5733),
    [sym_checked_expression] = STATE(5733),
    [sym_invocation_expression] = STATE(5734),
    [sym_switch_expression] = STATE(5733),
    [sym_await_expression] = STATE(5734),
    [sym_throw_expression] = STATE(5733),
    [sym_element_access_expression] = STATE(3911),
    [sym_interpolated_string_expression] = STATE(5733),
    [sym_member_access_expression] = STATE(3911),
    [sym_object_creation_expression] = STATE(5734),
    [sym_parenthesized_expression] = STATE(5734),
    [sym__parenthesized_lvalue_expression] = STATE(3911),
    [sym_lambda_expression] = STATE(5733),
    [sym__lambda_parameters] = STATE(9790),
    [sym_array_creation_expression] = STATE(5733),
    [sym_anonymous_method_expression] = STATE(5733),
    [sym_anonymous_object_creation_expression] = STATE(5733),
    [sym_implicit_array_creation_expression] = STATE(5733),
    [sym_implicit_object_creation_expression] = STATE(5733),
    [sym_implicit_stackalloc_expression] = STATE(5733),
    [sym_initializer_expression] = STATE(5733),
    [sym_default_expression] = STATE(5733),
    [sym_with_expression] = STATE(5733),
    [sym_sizeof_expression] = STATE(5733),
    [sym_typeof_expression] = STATE(5733),
    [sym_makeref_expression] = STATE(5733),
    [sym_ref_expression] = STATE(5733),
    [sym_reftype_expression] = STATE(5733),
    [sym_refvalue_expression] = STATE(5733),
    [sym_stackalloc_expression] = STATE(5733),
    [sym_range_expression] = STATE(5733),
    [sym_tuple_expression] = STATE(3911),
    [sym_literal] = STATE(5733),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2798),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(5733),
    [sym_preproc_region] = STATE(2062),
    [sym_preproc_endregion] = STATE(2062),
    [sym_preproc_line] = STATE(2062),
    [sym_preproc_pragma] = STATE(2062),
    [sym_preproc_nullable] = STATE(2062),
    [sym_preproc_error] = STATE(2062),
    [sym_preproc_define] = STATE(2062),
    [sym_preproc_undef] = STATE(2062),
    [aux_sym_class_declaration_repeat1] = STATE(3833),
    [aux_sym_lambda_expression_repeat1] = STATE(4182),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_LPAREN] = ACTIONS(1439),
    [anon_sym_ref] = ACTIONS(1441),
    [anon_sym_LBRACE] = ACTIONS(1377),
    [anon_sym_delegate] = ACTIONS(1379),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1443),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1447),
    [anon_sym_TILDE] = ACTIONS(1447),
    [anon_sym_PLUS_PLUS] = ACTIONS(1447),
    [anon_sym_DASH_DASH] = ACTIONS(1447),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1445),
    [anon_sym_DASH] = ACTIONS(1445),
    [anon_sym_STAR] = ACTIONS(1449),
    [anon_sym_CARET] = ACTIONS(1447),
    [anon_sym_AMP] = ACTIONS(1447),
    [anon_sym_this] = ACTIONS(1393),
    [anon_sym_scoped] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1397),
    [sym_predefined_type] = ACTIONS(1399),
    [anon_sym_unchecked] = ACTIONS(1383),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1451),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1453),
    [anon_sym_DOT_DOT] = ACTIONS(1455),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_stackalloc] = ACTIONS(1413),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(1419),
    [anon_sym___reftype] = ACTIONS(1421),
    [anon_sym___refvalue] = ACTIONS(1423),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
  },
  [2063] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3921),
    [sym__name] = STATE(6919),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2868),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(6950),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5297),
    [sym_non_lvalue_expression] = STATE(5735),
    [sym_lvalue_expression] = STATE(4054),
    [sym__expression_statement_expression] = STATE(5733),
    [sym_assignment_expression] = STATE(5734),
    [sym_binary_expression] = STATE(5733),
    [sym_postfix_unary_expression] = STATE(5734),
    [sym_prefix_unary_expression] = STATE(5734),
    [sym__pointer_indirection_expression] = STATE(3911),
    [sym_query_expression] = STATE(5733),
    [sym_from_clause] = STATE(7400),
    [sym_conditional_expression] = STATE(5733),
    [sym_conditional_access_expression] = STATE(5733),
    [sym_as_expression] = STATE(5733),
    [sym_is_expression] = STATE(5733),
    [sym_is_pattern_expression] = STATE(5733),
    [sym_cast_expression] = STATE(5733),
    [sym_checked_expression] = STATE(5733),
    [sym_invocation_expression] = STATE(5734),
    [sym_switch_expression] = STATE(5733),
    [sym_await_expression] = STATE(5734),
    [sym_throw_expression] = STATE(5733),
    [sym_element_access_expression] = STATE(3911),
    [sym_interpolated_string_expression] = STATE(5733),
    [sym_member_access_expression] = STATE(3911),
    [sym_object_creation_expression] = STATE(5734),
    [sym_parenthesized_expression] = STATE(5734),
    [sym__parenthesized_lvalue_expression] = STATE(3911),
    [sym_lambda_expression] = STATE(5733),
    [sym__lambda_parameters] = STATE(9693),
    [sym_array_creation_expression] = STATE(5733),
    [sym_anonymous_method_expression] = STATE(5733),
    [sym_anonymous_object_creation_expression] = STATE(5733),
    [sym_implicit_array_creation_expression] = STATE(5733),
    [sym_implicit_object_creation_expression] = STATE(5733),
    [sym_implicit_stackalloc_expression] = STATE(5733),
    [sym_initializer_expression] = STATE(5733),
    [sym_default_expression] = STATE(5733),
    [sym_with_expression] = STATE(5733),
    [sym_sizeof_expression] = STATE(5733),
    [sym_typeof_expression] = STATE(5733),
    [sym_makeref_expression] = STATE(5733),
    [sym_ref_expression] = STATE(5733),
    [sym_reftype_expression] = STATE(5733),
    [sym_refvalue_expression] = STATE(5733),
    [sym_stackalloc_expression] = STATE(5733),
    [sym_range_expression] = STATE(5733),
    [sym_tuple_expression] = STATE(3911),
    [sym_literal] = STATE(5733),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2798),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(5733),
    [sym_preproc_region] = STATE(2063),
    [sym_preproc_endregion] = STATE(2063),
    [sym_preproc_line] = STATE(2063),
    [sym_preproc_pragma] = STATE(2063),
    [sym_preproc_nullable] = STATE(2063),
    [sym_preproc_error] = STATE(2063),
    [sym_preproc_define] = STATE(2063),
    [sym_preproc_undef] = STATE(2063),
    [aux_sym_class_declaration_repeat1] = STATE(3791),
    [aux_sym_lambda_expression_repeat1] = STATE(4075),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_LPAREN] = ACTIONS(1373),
    [anon_sym_ref] = ACTIONS(1375),
    [anon_sym_LBRACE] = ACTIONS(1377),
    [anon_sym_delegate] = ACTIONS(1379),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1381),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1387),
    [anon_sym_TILDE] = ACTIONS(1387),
    [anon_sym_PLUS_PLUS] = ACTIONS(1387),
    [anon_sym_DASH_DASH] = ACTIONS(1387),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1385),
    [anon_sym_DASH] = ACTIONS(1385),
    [anon_sym_STAR] = ACTIONS(1391),
    [anon_sym_CARET] = ACTIONS(1387),
    [anon_sym_AMP] = ACTIONS(1387),
    [anon_sym_this] = ACTIONS(1393),
    [anon_sym_scoped] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1397),
    [sym_predefined_type] = ACTIONS(1399),
    [anon_sym_unchecked] = ACTIONS(1383),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1403),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1405),
    [anon_sym_DOT_DOT] = ACTIONS(1407),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_stackalloc] = ACTIONS(1413),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(1419),
    [anon_sym___reftype] = ACTIONS(1421),
    [anon_sym___refvalue] = ACTIONS(1423),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
  },
  [2064] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3921),
    [sym__name] = STATE(6919),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2868),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(6950),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5124),
    [sym_non_lvalue_expression] = STATE(5735),
    [sym_lvalue_expression] = STATE(4054),
    [sym__expression_statement_expression] = STATE(5733),
    [sym_assignment_expression] = STATE(5734),
    [sym_binary_expression] = STATE(5733),
    [sym_postfix_unary_expression] = STATE(5734),
    [sym_prefix_unary_expression] = STATE(5734),
    [sym__pointer_indirection_expression] = STATE(3911),
    [sym_query_expression] = STATE(5733),
    [sym_from_clause] = STATE(7400),
    [sym_conditional_expression] = STATE(5733),
    [sym_conditional_access_expression] = STATE(5733),
    [sym_as_expression] = STATE(5733),
    [sym_is_expression] = STATE(5733),
    [sym_is_pattern_expression] = STATE(5733),
    [sym_cast_expression] = STATE(5733),
    [sym_checked_expression] = STATE(5733),
    [sym_invocation_expression] = STATE(5734),
    [sym_switch_expression] = STATE(5733),
    [sym_await_expression] = STATE(5734),
    [sym_throw_expression] = STATE(5733),
    [sym_element_access_expression] = STATE(3911),
    [sym_interpolated_string_expression] = STATE(5733),
    [sym_member_access_expression] = STATE(3911),
    [sym_object_creation_expression] = STATE(5734),
    [sym_parenthesized_expression] = STATE(5734),
    [sym__parenthesized_lvalue_expression] = STATE(3911),
    [sym_lambda_expression] = STATE(5733),
    [sym__lambda_parameters] = STATE(9693),
    [sym_array_creation_expression] = STATE(5733),
    [sym_anonymous_method_expression] = STATE(5733),
    [sym_anonymous_object_creation_expression] = STATE(5733),
    [sym_implicit_array_creation_expression] = STATE(5733),
    [sym_implicit_object_creation_expression] = STATE(5733),
    [sym_implicit_stackalloc_expression] = STATE(5733),
    [sym_initializer_expression] = STATE(5733),
    [sym_default_expression] = STATE(5733),
    [sym_with_expression] = STATE(5733),
    [sym_sizeof_expression] = STATE(5733),
    [sym_typeof_expression] = STATE(5733),
    [sym_makeref_expression] = STATE(5733),
    [sym_ref_expression] = STATE(5733),
    [sym_reftype_expression] = STATE(5733),
    [sym_refvalue_expression] = STATE(5733),
    [sym_stackalloc_expression] = STATE(5733),
    [sym_range_expression] = STATE(5733),
    [sym_tuple_expression] = STATE(3911),
    [sym_literal] = STATE(5733),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2798),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(5733),
    [sym_preproc_region] = STATE(2064),
    [sym_preproc_endregion] = STATE(2064),
    [sym_preproc_line] = STATE(2064),
    [sym_preproc_pragma] = STATE(2064),
    [sym_preproc_nullable] = STATE(2064),
    [sym_preproc_error] = STATE(2064),
    [sym_preproc_define] = STATE(2064),
    [sym_preproc_undef] = STATE(2064),
    [aux_sym_class_declaration_repeat1] = STATE(3791),
    [aux_sym_lambda_expression_repeat1] = STATE(4075),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_LPAREN] = ACTIONS(1373),
    [anon_sym_ref] = ACTIONS(1375),
    [anon_sym_LBRACE] = ACTIONS(1377),
    [anon_sym_delegate] = ACTIONS(1379),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1381),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1387),
    [anon_sym_TILDE] = ACTIONS(1387),
    [anon_sym_PLUS_PLUS] = ACTIONS(1387),
    [anon_sym_DASH_DASH] = ACTIONS(1387),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1385),
    [anon_sym_DASH] = ACTIONS(1385),
    [anon_sym_STAR] = ACTIONS(1391),
    [anon_sym_CARET] = ACTIONS(1387),
    [anon_sym_AMP] = ACTIONS(1387),
    [anon_sym_this] = ACTIONS(1393),
    [anon_sym_scoped] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1397),
    [sym_predefined_type] = ACTIONS(1399),
    [anon_sym_unchecked] = ACTIONS(1383),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1403),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1405),
    [anon_sym_DOT_DOT] = ACTIONS(1407),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_stackalloc] = ACTIONS(1413),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(1419),
    [anon_sym___reftype] = ACTIONS(1421),
    [anon_sym___refvalue] = ACTIONS(1423),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
  },
  [2065] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3559),
    [sym__name] = STATE(6877),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2908),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6958),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4671),
    [sym_non_lvalue_expression] = STATE(4553),
    [sym_lvalue_expression] = STATE(3691),
    [sym__expression_statement_expression] = STATE(4559),
    [sym_assignment_expression] = STATE(4558),
    [sym_binary_expression] = STATE(4559),
    [sym_postfix_unary_expression] = STATE(4558),
    [sym_prefix_unary_expression] = STATE(4558),
    [sym__pointer_indirection_expression] = STATE(3560),
    [sym_query_expression] = STATE(4559),
    [sym_from_clause] = STATE(7406),
    [sym_conditional_expression] = STATE(4559),
    [sym_conditional_access_expression] = STATE(4559),
    [sym_as_expression] = STATE(4559),
    [sym_is_expression] = STATE(4559),
    [sym_is_pattern_expression] = STATE(4559),
    [sym_cast_expression] = STATE(4559),
    [sym_checked_expression] = STATE(4559),
    [sym_invocation_expression] = STATE(4558),
    [sym_switch_expression] = STATE(4559),
    [sym_await_expression] = STATE(4558),
    [sym_throw_expression] = STATE(4559),
    [sym_element_access_expression] = STATE(3560),
    [sym_interpolated_string_expression] = STATE(4559),
    [sym_member_access_expression] = STATE(3560),
    [sym_object_creation_expression] = STATE(4558),
    [sym_parenthesized_expression] = STATE(4558),
    [sym__parenthesized_lvalue_expression] = STATE(3560),
    [sym_lambda_expression] = STATE(4559),
    [sym__lambda_parameters] = STATE(9348),
    [sym_array_creation_expression] = STATE(4559),
    [sym_anonymous_method_expression] = STATE(4559),
    [sym_anonymous_object_creation_expression] = STATE(4559),
    [sym_implicit_array_creation_expression] = STATE(4559),
    [sym_implicit_object_creation_expression] = STATE(4559),
    [sym_implicit_stackalloc_expression] = STATE(4559),
    [sym_initializer_expression] = STATE(4559),
    [sym_default_expression] = STATE(4559),
    [sym_with_expression] = STATE(4559),
    [sym_sizeof_expression] = STATE(4559),
    [sym_typeof_expression] = STATE(4559),
    [sym_makeref_expression] = STATE(4559),
    [sym_ref_expression] = STATE(4559),
    [sym_reftype_expression] = STATE(4559),
    [sym_refvalue_expression] = STATE(4559),
    [sym_stackalloc_expression] = STATE(4559),
    [sym_range_expression] = STATE(4559),
    [sym_tuple_expression] = STATE(3560),
    [sym_literal] = STATE(4559),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4559),
    [sym_preproc_region] = STATE(2065),
    [sym_preproc_endregion] = STATE(2065),
    [sym_preproc_line] = STATE(2065),
    [sym_preproc_pragma] = STATE(2065),
    [sym_preproc_nullable] = STATE(2065),
    [sym_preproc_error] = STATE(2065),
    [sym_preproc_define] = STATE(2065),
    [sym_preproc_undef] = STATE(2065),
    [aux_sym_class_declaration_repeat1] = STATE(3810),
    [aux_sym_lambda_expression_repeat1] = STATE(4141),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(2047),
    [anon_sym_ref] = ACTIONS(2049),
    [anon_sym_LBRACE] = ACTIONS(1611),
    [anon_sym_delegate] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1679),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(2053),
    [anon_sym_TILDE] = ACTIONS(2053),
    [anon_sym_PLUS_PLUS] = ACTIONS(2053),
    [anon_sym_DASH_DASH] = ACTIONS(2053),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(2051),
    [anon_sym_DASH] = ACTIONS(2051),
    [anon_sym_STAR] = ACTIONS(1685),
    [anon_sym_CARET] = ACTIONS(2053),
    [anon_sym_AMP] = ACTIONS(2053),
    [anon_sym_this] = ACTIONS(1627),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1629),
    [anon_sym_unchecked] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(2055),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2057),
    [anon_sym_DOT_DOT] = ACTIONS(2059),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_stackalloc] = ACTIONS(1641),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(1647),
    [anon_sym___reftype] = ACTIONS(1649),
    [anon_sym___refvalue] = ACTIONS(1651),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1659),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [2066] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3921),
    [sym__name] = STATE(6919),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2868),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(6950),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5242),
    [sym_non_lvalue_expression] = STATE(5735),
    [sym_lvalue_expression] = STATE(4054),
    [sym__expression_statement_expression] = STATE(5733),
    [sym_assignment_expression] = STATE(5734),
    [sym_binary_expression] = STATE(5733),
    [sym_postfix_unary_expression] = STATE(5734),
    [sym_prefix_unary_expression] = STATE(5734),
    [sym__pointer_indirection_expression] = STATE(3911),
    [sym_query_expression] = STATE(5733),
    [sym_from_clause] = STATE(7400),
    [sym_conditional_expression] = STATE(5733),
    [sym_conditional_access_expression] = STATE(5733),
    [sym_as_expression] = STATE(5733),
    [sym_is_expression] = STATE(5733),
    [sym_is_pattern_expression] = STATE(5733),
    [sym_cast_expression] = STATE(5733),
    [sym_checked_expression] = STATE(5733),
    [sym_invocation_expression] = STATE(5734),
    [sym_switch_expression] = STATE(5733),
    [sym_await_expression] = STATE(5734),
    [sym_throw_expression] = STATE(5733),
    [sym_element_access_expression] = STATE(3911),
    [sym_interpolated_string_expression] = STATE(5733),
    [sym_member_access_expression] = STATE(3911),
    [sym_object_creation_expression] = STATE(5734),
    [sym_parenthesized_expression] = STATE(5734),
    [sym__parenthesized_lvalue_expression] = STATE(3911),
    [sym_lambda_expression] = STATE(5733),
    [sym__lambda_parameters] = STATE(9693),
    [sym_array_creation_expression] = STATE(5733),
    [sym_anonymous_method_expression] = STATE(5733),
    [sym_anonymous_object_creation_expression] = STATE(5733),
    [sym_implicit_array_creation_expression] = STATE(5733),
    [sym_implicit_object_creation_expression] = STATE(5733),
    [sym_implicit_stackalloc_expression] = STATE(5733),
    [sym_initializer_expression] = STATE(5733),
    [sym_default_expression] = STATE(5733),
    [sym_with_expression] = STATE(5733),
    [sym_sizeof_expression] = STATE(5733),
    [sym_typeof_expression] = STATE(5733),
    [sym_makeref_expression] = STATE(5733),
    [sym_ref_expression] = STATE(5733),
    [sym_reftype_expression] = STATE(5733),
    [sym_refvalue_expression] = STATE(5733),
    [sym_stackalloc_expression] = STATE(5733),
    [sym_range_expression] = STATE(5733),
    [sym_tuple_expression] = STATE(3911),
    [sym_literal] = STATE(5733),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2798),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(5733),
    [sym_preproc_region] = STATE(2066),
    [sym_preproc_endregion] = STATE(2066),
    [sym_preproc_line] = STATE(2066),
    [sym_preproc_pragma] = STATE(2066),
    [sym_preproc_nullable] = STATE(2066),
    [sym_preproc_error] = STATE(2066),
    [sym_preproc_define] = STATE(2066),
    [sym_preproc_undef] = STATE(2066),
    [aux_sym_class_declaration_repeat1] = STATE(3791),
    [aux_sym_lambda_expression_repeat1] = STATE(4075),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_LPAREN] = ACTIONS(1373),
    [anon_sym_ref] = ACTIONS(1375),
    [anon_sym_LBRACE] = ACTIONS(1377),
    [anon_sym_delegate] = ACTIONS(1379),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1381),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1387),
    [anon_sym_TILDE] = ACTIONS(1387),
    [anon_sym_PLUS_PLUS] = ACTIONS(1387),
    [anon_sym_DASH_DASH] = ACTIONS(1387),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1385),
    [anon_sym_DASH] = ACTIONS(1385),
    [anon_sym_STAR] = ACTIONS(1391),
    [anon_sym_CARET] = ACTIONS(1387),
    [anon_sym_AMP] = ACTIONS(1387),
    [anon_sym_this] = ACTIONS(1393),
    [anon_sym_scoped] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1397),
    [sym_predefined_type] = ACTIONS(1399),
    [anon_sym_unchecked] = ACTIONS(1383),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1403),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1405),
    [anon_sym_DOT_DOT] = ACTIONS(1407),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_stackalloc] = ACTIONS(1413),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(1419),
    [anon_sym___reftype] = ACTIONS(1421),
    [anon_sym___refvalue] = ACTIONS(1423),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
  },
  [2067] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6910),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2957),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7089),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5076),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(3796),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7395),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9374),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(2067),
    [sym_preproc_endregion] = STATE(2067),
    [sym_preproc_line] = STATE(2067),
    [sym_preproc_pragma] = STATE(2067),
    [sym_preproc_nullable] = STATE(2067),
    [sym_preproc_error] = STATE(2067),
    [sym_preproc_define] = STATE(2067),
    [sym_preproc_undef] = STATE(2067),
    [aux_sym_class_declaration_repeat1] = STATE(3839),
    [aux_sym_lambda_expression_repeat1] = STATE(4209),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2139),
    [anon_sym_ref] = ACTIONS(2141),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1799),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2145),
    [anon_sym_TILDE] = ACTIONS(2145),
    [anon_sym_PLUS_PLUS] = ACTIONS(2145),
    [anon_sym_DASH_DASH] = ACTIONS(2145),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2143),
    [anon_sym_DASH] = ACTIONS(2143),
    [anon_sym_STAR] = ACTIONS(1805),
    [anon_sym_CARET] = ACTIONS(2145),
    [anon_sym_AMP] = ACTIONS(2145),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2147),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2149),
    [anon_sym_DOT_DOT] = ACTIONS(2151),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [2068] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6910),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2957),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7089),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4946),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(3796),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7395),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9374),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(2068),
    [sym_preproc_endregion] = STATE(2068),
    [sym_preproc_line] = STATE(2068),
    [sym_preproc_pragma] = STATE(2068),
    [sym_preproc_nullable] = STATE(2068),
    [sym_preproc_error] = STATE(2068),
    [sym_preproc_define] = STATE(2068),
    [sym_preproc_undef] = STATE(2068),
    [aux_sym_class_declaration_repeat1] = STATE(3839),
    [aux_sym_lambda_expression_repeat1] = STATE(4209),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2139),
    [anon_sym_ref] = ACTIONS(2141),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1799),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2145),
    [anon_sym_TILDE] = ACTIONS(2145),
    [anon_sym_PLUS_PLUS] = ACTIONS(2145),
    [anon_sym_DASH_DASH] = ACTIONS(2145),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2143),
    [anon_sym_DASH] = ACTIONS(2143),
    [anon_sym_STAR] = ACTIONS(1805),
    [anon_sym_CARET] = ACTIONS(2145),
    [anon_sym_AMP] = ACTIONS(2145),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2147),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2149),
    [anon_sym_DOT_DOT] = ACTIONS(2151),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [2069] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3921),
    [sym__name] = STATE(6919),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2868),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(6950),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5248),
    [sym_non_lvalue_expression] = STATE(5735),
    [sym_lvalue_expression] = STATE(4054),
    [sym__expression_statement_expression] = STATE(5733),
    [sym_assignment_expression] = STATE(5734),
    [sym_binary_expression] = STATE(5733),
    [sym_postfix_unary_expression] = STATE(5734),
    [sym_prefix_unary_expression] = STATE(5734),
    [sym__pointer_indirection_expression] = STATE(3911),
    [sym_query_expression] = STATE(5733),
    [sym_from_clause] = STATE(7400),
    [sym_conditional_expression] = STATE(5733),
    [sym_conditional_access_expression] = STATE(5733),
    [sym_as_expression] = STATE(5733),
    [sym_is_expression] = STATE(5733),
    [sym_is_pattern_expression] = STATE(5733),
    [sym_cast_expression] = STATE(5733),
    [sym_checked_expression] = STATE(5733),
    [sym_invocation_expression] = STATE(5734),
    [sym_switch_expression] = STATE(5733),
    [sym_await_expression] = STATE(5734),
    [sym_throw_expression] = STATE(5733),
    [sym_element_access_expression] = STATE(3911),
    [sym_interpolated_string_expression] = STATE(5733),
    [sym_member_access_expression] = STATE(3911),
    [sym_object_creation_expression] = STATE(5734),
    [sym_parenthesized_expression] = STATE(5734),
    [sym__parenthesized_lvalue_expression] = STATE(3911),
    [sym_lambda_expression] = STATE(5733),
    [sym__lambda_parameters] = STATE(9693),
    [sym_array_creation_expression] = STATE(5733),
    [sym_anonymous_method_expression] = STATE(5733),
    [sym_anonymous_object_creation_expression] = STATE(5733),
    [sym_implicit_array_creation_expression] = STATE(5733),
    [sym_implicit_object_creation_expression] = STATE(5733),
    [sym_implicit_stackalloc_expression] = STATE(5733),
    [sym_initializer_expression] = STATE(5733),
    [sym_default_expression] = STATE(5733),
    [sym_with_expression] = STATE(5733),
    [sym_sizeof_expression] = STATE(5733),
    [sym_typeof_expression] = STATE(5733),
    [sym_makeref_expression] = STATE(5733),
    [sym_ref_expression] = STATE(5733),
    [sym_reftype_expression] = STATE(5733),
    [sym_refvalue_expression] = STATE(5733),
    [sym_stackalloc_expression] = STATE(5733),
    [sym_range_expression] = STATE(5733),
    [sym_tuple_expression] = STATE(3911),
    [sym_literal] = STATE(5733),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2798),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(5733),
    [sym_preproc_region] = STATE(2069),
    [sym_preproc_endregion] = STATE(2069),
    [sym_preproc_line] = STATE(2069),
    [sym_preproc_pragma] = STATE(2069),
    [sym_preproc_nullable] = STATE(2069),
    [sym_preproc_error] = STATE(2069),
    [sym_preproc_define] = STATE(2069),
    [sym_preproc_undef] = STATE(2069),
    [aux_sym_class_declaration_repeat1] = STATE(3791),
    [aux_sym_lambda_expression_repeat1] = STATE(4075),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_LPAREN] = ACTIONS(1373),
    [anon_sym_ref] = ACTIONS(1375),
    [anon_sym_LBRACE] = ACTIONS(1377),
    [anon_sym_delegate] = ACTIONS(1379),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1381),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1387),
    [anon_sym_TILDE] = ACTIONS(1387),
    [anon_sym_PLUS_PLUS] = ACTIONS(1387),
    [anon_sym_DASH_DASH] = ACTIONS(1387),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1385),
    [anon_sym_DASH] = ACTIONS(1385),
    [anon_sym_STAR] = ACTIONS(1391),
    [anon_sym_CARET] = ACTIONS(1387),
    [anon_sym_AMP] = ACTIONS(1387),
    [anon_sym_this] = ACTIONS(1393),
    [anon_sym_scoped] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1397),
    [sym_predefined_type] = ACTIONS(1399),
    [anon_sym_unchecked] = ACTIONS(1383),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1403),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1405),
    [anon_sym_DOT_DOT] = ACTIONS(1407),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_stackalloc] = ACTIONS(1413),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(1419),
    [anon_sym___reftype] = ACTIONS(1421),
    [anon_sym___refvalue] = ACTIONS(1423),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
  },
  [2070] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7108),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6022),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4313),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7382),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9733),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(2070),
    [sym_preproc_endregion] = STATE(2070),
    [sym_preproc_line] = STATE(2070),
    [sym_preproc_pragma] = STATE(2070),
    [sym_preproc_nullable] = STATE(2070),
    [sym_preproc_error] = STATE(2070),
    [sym_preproc_define] = STATE(2070),
    [sym_preproc_undef] = STATE(2070),
    [aux_sym_class_declaration_repeat1] = STATE(3802),
    [aux_sym_lambda_expression_repeat1] = STATE(4108),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1519),
    [anon_sym_ref] = ACTIONS(1521),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1523),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1529),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1531),
    [anon_sym_DOT_DOT] = ACTIONS(1533),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [2071] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3921),
    [sym__name] = STATE(6889),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2854),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(7061),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5171),
    [sym_non_lvalue_expression] = STATE(5735),
    [sym_lvalue_expression] = STATE(3899),
    [sym__expression_statement_expression] = STATE(5733),
    [sym_assignment_expression] = STATE(5734),
    [sym_binary_expression] = STATE(5733),
    [sym_postfix_unary_expression] = STATE(5734),
    [sym_prefix_unary_expression] = STATE(5734),
    [sym__pointer_indirection_expression] = STATE(3911),
    [sym_query_expression] = STATE(5733),
    [sym_from_clause] = STATE(7400),
    [sym_conditional_expression] = STATE(5733),
    [sym_conditional_access_expression] = STATE(5733),
    [sym_as_expression] = STATE(5733),
    [sym_is_expression] = STATE(5733),
    [sym_is_pattern_expression] = STATE(5733),
    [sym_cast_expression] = STATE(5733),
    [sym_checked_expression] = STATE(5733),
    [sym_invocation_expression] = STATE(5734),
    [sym_switch_expression] = STATE(5733),
    [sym_await_expression] = STATE(5734),
    [sym_throw_expression] = STATE(5733),
    [sym_element_access_expression] = STATE(3911),
    [sym_interpolated_string_expression] = STATE(5733),
    [sym_member_access_expression] = STATE(3911),
    [sym_object_creation_expression] = STATE(5734),
    [sym_parenthesized_expression] = STATE(5734),
    [sym__parenthesized_lvalue_expression] = STATE(3911),
    [sym_lambda_expression] = STATE(5733),
    [sym__lambda_parameters] = STATE(9790),
    [sym_array_creation_expression] = STATE(5733),
    [sym_anonymous_method_expression] = STATE(5733),
    [sym_anonymous_object_creation_expression] = STATE(5733),
    [sym_implicit_array_creation_expression] = STATE(5733),
    [sym_implicit_object_creation_expression] = STATE(5733),
    [sym_implicit_stackalloc_expression] = STATE(5733),
    [sym_initializer_expression] = STATE(5733),
    [sym_default_expression] = STATE(5733),
    [sym_with_expression] = STATE(5733),
    [sym_sizeof_expression] = STATE(5733),
    [sym_typeof_expression] = STATE(5733),
    [sym_makeref_expression] = STATE(5733),
    [sym_ref_expression] = STATE(5733),
    [sym_reftype_expression] = STATE(5733),
    [sym_refvalue_expression] = STATE(5733),
    [sym_stackalloc_expression] = STATE(5733),
    [sym_range_expression] = STATE(5733),
    [sym_tuple_expression] = STATE(3911),
    [sym_literal] = STATE(5733),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2798),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(5733),
    [sym_preproc_region] = STATE(2071),
    [sym_preproc_endregion] = STATE(2071),
    [sym_preproc_line] = STATE(2071),
    [sym_preproc_pragma] = STATE(2071),
    [sym_preproc_nullable] = STATE(2071),
    [sym_preproc_error] = STATE(2071),
    [sym_preproc_define] = STATE(2071),
    [sym_preproc_undef] = STATE(2071),
    [aux_sym_class_declaration_repeat1] = STATE(3833),
    [aux_sym_lambda_expression_repeat1] = STATE(4182),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_LPAREN] = ACTIONS(1439),
    [anon_sym_ref] = ACTIONS(1441),
    [anon_sym_LBRACE] = ACTIONS(1377),
    [anon_sym_delegate] = ACTIONS(1379),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1443),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1447),
    [anon_sym_TILDE] = ACTIONS(1447),
    [anon_sym_PLUS_PLUS] = ACTIONS(1447),
    [anon_sym_DASH_DASH] = ACTIONS(1447),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1445),
    [anon_sym_DASH] = ACTIONS(1445),
    [anon_sym_STAR] = ACTIONS(1449),
    [anon_sym_CARET] = ACTIONS(1447),
    [anon_sym_AMP] = ACTIONS(1447),
    [anon_sym_this] = ACTIONS(1393),
    [anon_sym_scoped] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1397),
    [sym_predefined_type] = ACTIONS(1399),
    [anon_sym_unchecked] = ACTIONS(1383),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1451),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1453),
    [anon_sym_DOT_DOT] = ACTIONS(1455),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_stackalloc] = ACTIONS(1413),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(1419),
    [anon_sym___reftype] = ACTIONS(1421),
    [anon_sym___refvalue] = ACTIONS(1423),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
  },
  [2072] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6910),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2957),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7089),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5033),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(3796),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7395),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9374),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(2072),
    [sym_preproc_endregion] = STATE(2072),
    [sym_preproc_line] = STATE(2072),
    [sym_preproc_pragma] = STATE(2072),
    [sym_preproc_nullable] = STATE(2072),
    [sym_preproc_error] = STATE(2072),
    [sym_preproc_define] = STATE(2072),
    [sym_preproc_undef] = STATE(2072),
    [aux_sym_class_declaration_repeat1] = STATE(3839),
    [aux_sym_lambda_expression_repeat1] = STATE(4209),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2139),
    [anon_sym_ref] = ACTIONS(2141),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1799),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2145),
    [anon_sym_TILDE] = ACTIONS(2145),
    [anon_sym_PLUS_PLUS] = ACTIONS(2145),
    [anon_sym_DASH_DASH] = ACTIONS(2145),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2143),
    [anon_sym_DASH] = ACTIONS(2143),
    [anon_sym_STAR] = ACTIONS(1805),
    [anon_sym_CARET] = ACTIONS(2145),
    [anon_sym_AMP] = ACTIONS(2145),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2147),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2149),
    [anon_sym_DOT_DOT] = ACTIONS(2151),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [2073] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3921),
    [sym__name] = STATE(6889),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2854),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(7061),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5172),
    [sym_non_lvalue_expression] = STATE(5735),
    [sym_lvalue_expression] = STATE(3899),
    [sym__expression_statement_expression] = STATE(5733),
    [sym_assignment_expression] = STATE(5734),
    [sym_binary_expression] = STATE(5733),
    [sym_postfix_unary_expression] = STATE(5734),
    [sym_prefix_unary_expression] = STATE(5734),
    [sym__pointer_indirection_expression] = STATE(3911),
    [sym_query_expression] = STATE(5733),
    [sym_from_clause] = STATE(7400),
    [sym_conditional_expression] = STATE(5733),
    [sym_conditional_access_expression] = STATE(5733),
    [sym_as_expression] = STATE(5733),
    [sym_is_expression] = STATE(5733),
    [sym_is_pattern_expression] = STATE(5733),
    [sym_cast_expression] = STATE(5733),
    [sym_checked_expression] = STATE(5733),
    [sym_invocation_expression] = STATE(5734),
    [sym_switch_expression] = STATE(5733),
    [sym_await_expression] = STATE(5734),
    [sym_throw_expression] = STATE(5733),
    [sym_element_access_expression] = STATE(3911),
    [sym_interpolated_string_expression] = STATE(5733),
    [sym_member_access_expression] = STATE(3911),
    [sym_object_creation_expression] = STATE(5734),
    [sym_parenthesized_expression] = STATE(5734),
    [sym__parenthesized_lvalue_expression] = STATE(3911),
    [sym_lambda_expression] = STATE(5733),
    [sym__lambda_parameters] = STATE(9790),
    [sym_array_creation_expression] = STATE(5733),
    [sym_anonymous_method_expression] = STATE(5733),
    [sym_anonymous_object_creation_expression] = STATE(5733),
    [sym_implicit_array_creation_expression] = STATE(5733),
    [sym_implicit_object_creation_expression] = STATE(5733),
    [sym_implicit_stackalloc_expression] = STATE(5733),
    [sym_initializer_expression] = STATE(5733),
    [sym_default_expression] = STATE(5733),
    [sym_with_expression] = STATE(5733),
    [sym_sizeof_expression] = STATE(5733),
    [sym_typeof_expression] = STATE(5733),
    [sym_makeref_expression] = STATE(5733),
    [sym_ref_expression] = STATE(5733),
    [sym_reftype_expression] = STATE(5733),
    [sym_refvalue_expression] = STATE(5733),
    [sym_stackalloc_expression] = STATE(5733),
    [sym_range_expression] = STATE(5733),
    [sym_tuple_expression] = STATE(3911),
    [sym_literal] = STATE(5733),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2798),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(5733),
    [sym_preproc_region] = STATE(2073),
    [sym_preproc_endregion] = STATE(2073),
    [sym_preproc_line] = STATE(2073),
    [sym_preproc_pragma] = STATE(2073),
    [sym_preproc_nullable] = STATE(2073),
    [sym_preproc_error] = STATE(2073),
    [sym_preproc_define] = STATE(2073),
    [sym_preproc_undef] = STATE(2073),
    [aux_sym_class_declaration_repeat1] = STATE(3833),
    [aux_sym_lambda_expression_repeat1] = STATE(4182),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_LPAREN] = ACTIONS(1439),
    [anon_sym_ref] = ACTIONS(1441),
    [anon_sym_LBRACE] = ACTIONS(1377),
    [anon_sym_delegate] = ACTIONS(1379),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1443),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1447),
    [anon_sym_TILDE] = ACTIONS(1447),
    [anon_sym_PLUS_PLUS] = ACTIONS(1447),
    [anon_sym_DASH_DASH] = ACTIONS(1447),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1445),
    [anon_sym_DASH] = ACTIONS(1445),
    [anon_sym_STAR] = ACTIONS(1449),
    [anon_sym_CARET] = ACTIONS(1447),
    [anon_sym_AMP] = ACTIONS(1447),
    [anon_sym_this] = ACTIONS(1393),
    [anon_sym_scoped] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1397),
    [sym_predefined_type] = ACTIONS(1399),
    [anon_sym_unchecked] = ACTIONS(1383),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1451),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1453),
    [anon_sym_DOT_DOT] = ACTIONS(1455),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_stackalloc] = ACTIONS(1413),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(1419),
    [anon_sym___reftype] = ACTIONS(1421),
    [anon_sym___refvalue] = ACTIONS(1423),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
  },
  [2074] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6914),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2882),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6963),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5349),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4002),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7386),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9254),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(2074),
    [sym_preproc_endregion] = STATE(2074),
    [sym_preproc_line] = STATE(2074),
    [sym_preproc_pragma] = STATE(2074),
    [sym_preproc_nullable] = STATE(2074),
    [sym_preproc_error] = STATE(2074),
    [sym_preproc_define] = STATE(2074),
    [sym_preproc_undef] = STATE(2074),
    [aux_sym_class_declaration_repeat1] = STATE(3797),
    [aux_sym_lambda_expression_repeat1] = STATE(4081),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1727),
    [anon_sym_ref] = ACTIONS(1729),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1713),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1733),
    [anon_sym_TILDE] = ACTIONS(1733),
    [anon_sym_PLUS_PLUS] = ACTIONS(1733),
    [anon_sym_DASH_DASH] = ACTIONS(1733),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1731),
    [anon_sym_DASH] = ACTIONS(1731),
    [anon_sym_STAR] = ACTIONS(1735),
    [anon_sym_CARET] = ACTIONS(1733),
    [anon_sym_AMP] = ACTIONS(1733),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1737),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1739),
    [anon_sym_DOT_DOT] = ACTIONS(1741),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [2075] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7108),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(3901),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4313),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7382),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9733),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(2075),
    [sym_preproc_endregion] = STATE(2075),
    [sym_preproc_line] = STATE(2075),
    [sym_preproc_pragma] = STATE(2075),
    [sym_preproc_nullable] = STATE(2075),
    [sym_preproc_error] = STATE(2075),
    [sym_preproc_define] = STATE(2075),
    [sym_preproc_undef] = STATE(2075),
    [aux_sym_class_declaration_repeat1] = STATE(3802),
    [aux_sym_lambda_expression_repeat1] = STATE(4108),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1519),
    [anon_sym_ref] = ACTIONS(1521),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1523),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1529),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1531),
    [anon_sym_DOT_DOT] = ACTIONS(1533),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [2076] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3921),
    [sym__name] = STATE(6889),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2854),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(7061),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5173),
    [sym_non_lvalue_expression] = STATE(5735),
    [sym_lvalue_expression] = STATE(3899),
    [sym__expression_statement_expression] = STATE(5733),
    [sym_assignment_expression] = STATE(5734),
    [sym_binary_expression] = STATE(5733),
    [sym_postfix_unary_expression] = STATE(5734),
    [sym_prefix_unary_expression] = STATE(5734),
    [sym__pointer_indirection_expression] = STATE(3911),
    [sym_query_expression] = STATE(5733),
    [sym_from_clause] = STATE(7400),
    [sym_conditional_expression] = STATE(5733),
    [sym_conditional_access_expression] = STATE(5733),
    [sym_as_expression] = STATE(5733),
    [sym_is_expression] = STATE(5733),
    [sym_is_pattern_expression] = STATE(5733),
    [sym_cast_expression] = STATE(5733),
    [sym_checked_expression] = STATE(5733),
    [sym_invocation_expression] = STATE(5734),
    [sym_switch_expression] = STATE(5733),
    [sym_await_expression] = STATE(5734),
    [sym_throw_expression] = STATE(5733),
    [sym_element_access_expression] = STATE(3911),
    [sym_interpolated_string_expression] = STATE(5733),
    [sym_member_access_expression] = STATE(3911),
    [sym_object_creation_expression] = STATE(5734),
    [sym_parenthesized_expression] = STATE(5734),
    [sym__parenthesized_lvalue_expression] = STATE(3911),
    [sym_lambda_expression] = STATE(5733),
    [sym__lambda_parameters] = STATE(9790),
    [sym_array_creation_expression] = STATE(5733),
    [sym_anonymous_method_expression] = STATE(5733),
    [sym_anonymous_object_creation_expression] = STATE(5733),
    [sym_implicit_array_creation_expression] = STATE(5733),
    [sym_implicit_object_creation_expression] = STATE(5733),
    [sym_implicit_stackalloc_expression] = STATE(5733),
    [sym_initializer_expression] = STATE(5733),
    [sym_default_expression] = STATE(5733),
    [sym_with_expression] = STATE(5733),
    [sym_sizeof_expression] = STATE(5733),
    [sym_typeof_expression] = STATE(5733),
    [sym_makeref_expression] = STATE(5733),
    [sym_ref_expression] = STATE(5733),
    [sym_reftype_expression] = STATE(5733),
    [sym_refvalue_expression] = STATE(5733),
    [sym_stackalloc_expression] = STATE(5733),
    [sym_range_expression] = STATE(5733),
    [sym_tuple_expression] = STATE(3911),
    [sym_literal] = STATE(5733),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2798),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(5733),
    [sym_preproc_region] = STATE(2076),
    [sym_preproc_endregion] = STATE(2076),
    [sym_preproc_line] = STATE(2076),
    [sym_preproc_pragma] = STATE(2076),
    [sym_preproc_nullable] = STATE(2076),
    [sym_preproc_error] = STATE(2076),
    [sym_preproc_define] = STATE(2076),
    [sym_preproc_undef] = STATE(2076),
    [aux_sym_class_declaration_repeat1] = STATE(3833),
    [aux_sym_lambda_expression_repeat1] = STATE(4182),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_LPAREN] = ACTIONS(1439),
    [anon_sym_ref] = ACTIONS(1441),
    [anon_sym_LBRACE] = ACTIONS(1377),
    [anon_sym_delegate] = ACTIONS(1379),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1443),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1447),
    [anon_sym_TILDE] = ACTIONS(1447),
    [anon_sym_PLUS_PLUS] = ACTIONS(1447),
    [anon_sym_DASH_DASH] = ACTIONS(1447),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1445),
    [anon_sym_DASH] = ACTIONS(1445),
    [anon_sym_STAR] = ACTIONS(1449),
    [anon_sym_CARET] = ACTIONS(1447),
    [anon_sym_AMP] = ACTIONS(1447),
    [anon_sym_this] = ACTIONS(1393),
    [anon_sym_scoped] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1397),
    [sym_predefined_type] = ACTIONS(1399),
    [anon_sym_unchecked] = ACTIONS(1383),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1451),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1453),
    [anon_sym_DOT_DOT] = ACTIONS(1455),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_stackalloc] = ACTIONS(1413),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(1419),
    [anon_sym___reftype] = ACTIONS(1421),
    [anon_sym___refvalue] = ACTIONS(1423),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
  },
  [2077] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3559),
    [sym__name] = STATE(6877),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2908),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7129),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4369),
    [sym_non_lvalue_expression] = STATE(4553),
    [sym_lvalue_expression] = STATE(3561),
    [sym__expression_statement_expression] = STATE(4559),
    [sym_assignment_expression] = STATE(4558),
    [sym_binary_expression] = STATE(4559),
    [sym_postfix_unary_expression] = STATE(4558),
    [sym_prefix_unary_expression] = STATE(4558),
    [sym__pointer_indirection_expression] = STATE(3560),
    [sym_query_expression] = STATE(4559),
    [sym_from_clause] = STATE(7385),
    [sym_conditional_expression] = STATE(4559),
    [sym_conditional_access_expression] = STATE(4559),
    [sym_as_expression] = STATE(4559),
    [sym_is_expression] = STATE(4559),
    [sym_is_pattern_expression] = STATE(4559),
    [sym_cast_expression] = STATE(4559),
    [sym_checked_expression] = STATE(4559),
    [sym_invocation_expression] = STATE(4558),
    [sym_switch_expression] = STATE(4559),
    [sym_await_expression] = STATE(4558),
    [sym_throw_expression] = STATE(4559),
    [sym_element_access_expression] = STATE(3560),
    [sym_interpolated_string_expression] = STATE(4559),
    [sym_member_access_expression] = STATE(3560),
    [sym_object_creation_expression] = STATE(4558),
    [sym_parenthesized_expression] = STATE(4558),
    [sym__parenthesized_lvalue_expression] = STATE(3560),
    [sym_lambda_expression] = STATE(4559),
    [sym__lambda_parameters] = STATE(9776),
    [sym_array_creation_expression] = STATE(4559),
    [sym_anonymous_method_expression] = STATE(4559),
    [sym_anonymous_object_creation_expression] = STATE(4559),
    [sym_implicit_array_creation_expression] = STATE(4559),
    [sym_implicit_object_creation_expression] = STATE(4559),
    [sym_implicit_stackalloc_expression] = STATE(4559),
    [sym_initializer_expression] = STATE(4559),
    [sym_default_expression] = STATE(4559),
    [sym_with_expression] = STATE(4559),
    [sym_sizeof_expression] = STATE(4559),
    [sym_typeof_expression] = STATE(4559),
    [sym_makeref_expression] = STATE(4559),
    [sym_ref_expression] = STATE(4559),
    [sym_reftype_expression] = STATE(4559),
    [sym_refvalue_expression] = STATE(4559),
    [sym_stackalloc_expression] = STATE(4559),
    [sym_range_expression] = STATE(4559),
    [sym_tuple_expression] = STATE(3560),
    [sym_literal] = STATE(4559),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4559),
    [sym_preproc_region] = STATE(2077),
    [sym_preproc_endregion] = STATE(2077),
    [sym_preproc_line] = STATE(2077),
    [sym_preproc_pragma] = STATE(2077),
    [sym_preproc_nullable] = STATE(2077),
    [sym_preproc_error] = STATE(2077),
    [sym_preproc_define] = STATE(2077),
    [sym_preproc_undef] = STATE(2077),
    [aux_sym_class_declaration_repeat1] = STATE(3843),
    [aux_sym_lambda_expression_repeat1] = STATE(4277),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(1675),
    [anon_sym_ref] = ACTIONS(1677),
    [anon_sym_LBRACE] = ACTIONS(1611),
    [anon_sym_delegate] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1679),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(1683),
    [anon_sym_TILDE] = ACTIONS(1683),
    [anon_sym_PLUS_PLUS] = ACTIONS(1683),
    [anon_sym_DASH_DASH] = ACTIONS(1683),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_DASH] = ACTIONS(1681),
    [anon_sym_STAR] = ACTIONS(1685),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1683),
    [anon_sym_this] = ACTIONS(1627),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1629),
    [anon_sym_unchecked] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(1687),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1689),
    [anon_sym_DOT_DOT] = ACTIONS(1691),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_stackalloc] = ACTIONS(1641),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(1647),
    [anon_sym___reftype] = ACTIONS(1649),
    [anon_sym___refvalue] = ACTIONS(1651),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1659),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [2078] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3921),
    [sym__name] = STATE(6889),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2854),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(7061),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5157),
    [sym_non_lvalue_expression] = STATE(5735),
    [sym_lvalue_expression] = STATE(3899),
    [sym__expression_statement_expression] = STATE(5733),
    [sym_assignment_expression] = STATE(5734),
    [sym_binary_expression] = STATE(5733),
    [sym_postfix_unary_expression] = STATE(5734),
    [sym_prefix_unary_expression] = STATE(5734),
    [sym__pointer_indirection_expression] = STATE(3911),
    [sym_query_expression] = STATE(5733),
    [sym_from_clause] = STATE(7400),
    [sym_conditional_expression] = STATE(5733),
    [sym_conditional_access_expression] = STATE(5733),
    [sym_as_expression] = STATE(5733),
    [sym_is_expression] = STATE(5733),
    [sym_is_pattern_expression] = STATE(5733),
    [sym_cast_expression] = STATE(5733),
    [sym_checked_expression] = STATE(5733),
    [sym_invocation_expression] = STATE(5734),
    [sym_switch_expression] = STATE(5733),
    [sym_await_expression] = STATE(5734),
    [sym_throw_expression] = STATE(5733),
    [sym_element_access_expression] = STATE(3911),
    [sym_interpolated_string_expression] = STATE(5733),
    [sym_member_access_expression] = STATE(3911),
    [sym_object_creation_expression] = STATE(5734),
    [sym_parenthesized_expression] = STATE(5734),
    [sym__parenthesized_lvalue_expression] = STATE(3911),
    [sym_lambda_expression] = STATE(5733),
    [sym__lambda_parameters] = STATE(9790),
    [sym_array_creation_expression] = STATE(5733),
    [sym_anonymous_method_expression] = STATE(5733),
    [sym_anonymous_object_creation_expression] = STATE(5733),
    [sym_implicit_array_creation_expression] = STATE(5733),
    [sym_implicit_object_creation_expression] = STATE(5733),
    [sym_implicit_stackalloc_expression] = STATE(5733),
    [sym_initializer_expression] = STATE(5733),
    [sym_default_expression] = STATE(5733),
    [sym_with_expression] = STATE(5733),
    [sym_sizeof_expression] = STATE(5733),
    [sym_typeof_expression] = STATE(5733),
    [sym_makeref_expression] = STATE(5733),
    [sym_ref_expression] = STATE(5733),
    [sym_reftype_expression] = STATE(5733),
    [sym_refvalue_expression] = STATE(5733),
    [sym_stackalloc_expression] = STATE(5733),
    [sym_range_expression] = STATE(5733),
    [sym_tuple_expression] = STATE(3911),
    [sym_literal] = STATE(5733),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2798),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(5733),
    [sym_preproc_region] = STATE(2078),
    [sym_preproc_endregion] = STATE(2078),
    [sym_preproc_line] = STATE(2078),
    [sym_preproc_pragma] = STATE(2078),
    [sym_preproc_nullable] = STATE(2078),
    [sym_preproc_error] = STATE(2078),
    [sym_preproc_define] = STATE(2078),
    [sym_preproc_undef] = STATE(2078),
    [aux_sym_class_declaration_repeat1] = STATE(3833),
    [aux_sym_lambda_expression_repeat1] = STATE(4182),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_LPAREN] = ACTIONS(1439),
    [anon_sym_ref] = ACTIONS(1441),
    [anon_sym_LBRACE] = ACTIONS(1377),
    [anon_sym_delegate] = ACTIONS(1379),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1443),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1447),
    [anon_sym_TILDE] = ACTIONS(1447),
    [anon_sym_PLUS_PLUS] = ACTIONS(1447),
    [anon_sym_DASH_DASH] = ACTIONS(1447),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1445),
    [anon_sym_DASH] = ACTIONS(1445),
    [anon_sym_STAR] = ACTIONS(1449),
    [anon_sym_CARET] = ACTIONS(1447),
    [anon_sym_AMP] = ACTIONS(1447),
    [anon_sym_this] = ACTIONS(1393),
    [anon_sym_scoped] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1397),
    [sym_predefined_type] = ACTIONS(1399),
    [anon_sym_unchecked] = ACTIONS(1383),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1451),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1453),
    [anon_sym_DOT_DOT] = ACTIONS(1455),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_stackalloc] = ACTIONS(1413),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(1419),
    [anon_sym___reftype] = ACTIONS(1421),
    [anon_sym___refvalue] = ACTIONS(1423),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
  },
  [2079] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3921),
    [sym__name] = STATE(6919),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2868),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(6950),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5219),
    [sym_non_lvalue_expression] = STATE(5735),
    [sym_lvalue_expression] = STATE(4054),
    [sym__expression_statement_expression] = STATE(5733),
    [sym_assignment_expression] = STATE(5734),
    [sym_binary_expression] = STATE(5733),
    [sym_postfix_unary_expression] = STATE(5734),
    [sym_prefix_unary_expression] = STATE(5734),
    [sym__pointer_indirection_expression] = STATE(3911),
    [sym_query_expression] = STATE(5733),
    [sym_from_clause] = STATE(7400),
    [sym_conditional_expression] = STATE(5733),
    [sym_conditional_access_expression] = STATE(5733),
    [sym_as_expression] = STATE(5733),
    [sym_is_expression] = STATE(5733),
    [sym_is_pattern_expression] = STATE(5733),
    [sym_cast_expression] = STATE(5733),
    [sym_checked_expression] = STATE(5733),
    [sym_invocation_expression] = STATE(5734),
    [sym_switch_expression] = STATE(5733),
    [sym_await_expression] = STATE(5734),
    [sym_throw_expression] = STATE(5733),
    [sym_element_access_expression] = STATE(3911),
    [sym_interpolated_string_expression] = STATE(5733),
    [sym_member_access_expression] = STATE(3911),
    [sym_object_creation_expression] = STATE(5734),
    [sym_parenthesized_expression] = STATE(5734),
    [sym__parenthesized_lvalue_expression] = STATE(3911),
    [sym_lambda_expression] = STATE(5733),
    [sym__lambda_parameters] = STATE(9693),
    [sym_array_creation_expression] = STATE(5733),
    [sym_anonymous_method_expression] = STATE(5733),
    [sym_anonymous_object_creation_expression] = STATE(5733),
    [sym_implicit_array_creation_expression] = STATE(5733),
    [sym_implicit_object_creation_expression] = STATE(5733),
    [sym_implicit_stackalloc_expression] = STATE(5733),
    [sym_initializer_expression] = STATE(5733),
    [sym_default_expression] = STATE(5733),
    [sym_with_expression] = STATE(5733),
    [sym_sizeof_expression] = STATE(5733),
    [sym_typeof_expression] = STATE(5733),
    [sym_makeref_expression] = STATE(5733),
    [sym_ref_expression] = STATE(5733),
    [sym_reftype_expression] = STATE(5733),
    [sym_refvalue_expression] = STATE(5733),
    [sym_stackalloc_expression] = STATE(5733),
    [sym_range_expression] = STATE(5733),
    [sym_tuple_expression] = STATE(3911),
    [sym_literal] = STATE(5733),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2798),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(5733),
    [sym_preproc_region] = STATE(2079),
    [sym_preproc_endregion] = STATE(2079),
    [sym_preproc_line] = STATE(2079),
    [sym_preproc_pragma] = STATE(2079),
    [sym_preproc_nullable] = STATE(2079),
    [sym_preproc_error] = STATE(2079),
    [sym_preproc_define] = STATE(2079),
    [sym_preproc_undef] = STATE(2079),
    [aux_sym_class_declaration_repeat1] = STATE(3791),
    [aux_sym_lambda_expression_repeat1] = STATE(4075),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_LPAREN] = ACTIONS(1373),
    [anon_sym_ref] = ACTIONS(1375),
    [anon_sym_LBRACE] = ACTIONS(1377),
    [anon_sym_delegate] = ACTIONS(1379),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1381),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1387),
    [anon_sym_TILDE] = ACTIONS(1387),
    [anon_sym_PLUS_PLUS] = ACTIONS(1387),
    [anon_sym_DASH_DASH] = ACTIONS(1387),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1385),
    [anon_sym_DASH] = ACTIONS(1385),
    [anon_sym_STAR] = ACTIONS(1391),
    [anon_sym_CARET] = ACTIONS(1387),
    [anon_sym_AMP] = ACTIONS(1387),
    [anon_sym_this] = ACTIONS(1393),
    [anon_sym_scoped] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1397),
    [sym_predefined_type] = ACTIONS(1399),
    [anon_sym_unchecked] = ACTIONS(1383),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1403),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1405),
    [anon_sym_DOT_DOT] = ACTIONS(1407),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_stackalloc] = ACTIONS(1413),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(1419),
    [anon_sym___reftype] = ACTIONS(1421),
    [anon_sym___refvalue] = ACTIONS(1423),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
  },
  [2080] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3921),
    [sym__name] = STATE(6919),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2868),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(6950),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5218),
    [sym_non_lvalue_expression] = STATE(5735),
    [sym_lvalue_expression] = STATE(4054),
    [sym__expression_statement_expression] = STATE(5733),
    [sym_assignment_expression] = STATE(5734),
    [sym_binary_expression] = STATE(5733),
    [sym_postfix_unary_expression] = STATE(5734),
    [sym_prefix_unary_expression] = STATE(5734),
    [sym__pointer_indirection_expression] = STATE(3911),
    [sym_query_expression] = STATE(5733),
    [sym_from_clause] = STATE(7400),
    [sym_conditional_expression] = STATE(5733),
    [sym_conditional_access_expression] = STATE(5733),
    [sym_as_expression] = STATE(5733),
    [sym_is_expression] = STATE(5733),
    [sym_is_pattern_expression] = STATE(5733),
    [sym_cast_expression] = STATE(5733),
    [sym_checked_expression] = STATE(5733),
    [sym_invocation_expression] = STATE(5734),
    [sym_switch_expression] = STATE(5733),
    [sym_await_expression] = STATE(5734),
    [sym_throw_expression] = STATE(5733),
    [sym_element_access_expression] = STATE(3911),
    [sym_interpolated_string_expression] = STATE(5733),
    [sym_member_access_expression] = STATE(3911),
    [sym_object_creation_expression] = STATE(5734),
    [sym_parenthesized_expression] = STATE(5734),
    [sym__parenthesized_lvalue_expression] = STATE(3911),
    [sym_lambda_expression] = STATE(5733),
    [sym__lambda_parameters] = STATE(9693),
    [sym_array_creation_expression] = STATE(5733),
    [sym_anonymous_method_expression] = STATE(5733),
    [sym_anonymous_object_creation_expression] = STATE(5733),
    [sym_implicit_array_creation_expression] = STATE(5733),
    [sym_implicit_object_creation_expression] = STATE(5733),
    [sym_implicit_stackalloc_expression] = STATE(5733),
    [sym_initializer_expression] = STATE(5733),
    [sym_default_expression] = STATE(5733),
    [sym_with_expression] = STATE(5733),
    [sym_sizeof_expression] = STATE(5733),
    [sym_typeof_expression] = STATE(5733),
    [sym_makeref_expression] = STATE(5733),
    [sym_ref_expression] = STATE(5733),
    [sym_reftype_expression] = STATE(5733),
    [sym_refvalue_expression] = STATE(5733),
    [sym_stackalloc_expression] = STATE(5733),
    [sym_range_expression] = STATE(5733),
    [sym_tuple_expression] = STATE(3911),
    [sym_literal] = STATE(5733),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2798),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(5733),
    [sym_preproc_region] = STATE(2080),
    [sym_preproc_endregion] = STATE(2080),
    [sym_preproc_line] = STATE(2080),
    [sym_preproc_pragma] = STATE(2080),
    [sym_preproc_nullable] = STATE(2080),
    [sym_preproc_error] = STATE(2080),
    [sym_preproc_define] = STATE(2080),
    [sym_preproc_undef] = STATE(2080),
    [aux_sym_class_declaration_repeat1] = STATE(3791),
    [aux_sym_lambda_expression_repeat1] = STATE(4075),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_LPAREN] = ACTIONS(1373),
    [anon_sym_ref] = ACTIONS(1375),
    [anon_sym_LBRACE] = ACTIONS(1377),
    [anon_sym_delegate] = ACTIONS(1379),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1381),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1387),
    [anon_sym_TILDE] = ACTIONS(1387),
    [anon_sym_PLUS_PLUS] = ACTIONS(1387),
    [anon_sym_DASH_DASH] = ACTIONS(1387),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1385),
    [anon_sym_DASH] = ACTIONS(1385),
    [anon_sym_STAR] = ACTIONS(1391),
    [anon_sym_CARET] = ACTIONS(1387),
    [anon_sym_AMP] = ACTIONS(1387),
    [anon_sym_this] = ACTIONS(1393),
    [anon_sym_scoped] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1397),
    [sym_predefined_type] = ACTIONS(1399),
    [anon_sym_unchecked] = ACTIONS(1383),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1403),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1405),
    [anon_sym_DOT_DOT] = ACTIONS(1407),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_stackalloc] = ACTIONS(1413),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(1419),
    [anon_sym___reftype] = ACTIONS(1421),
    [anon_sym___refvalue] = ACTIONS(1423),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
  },
  [2081] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6911),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6992),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(3826),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(3829),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7391),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9246),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(2081),
    [sym_preproc_endregion] = STATE(2081),
    [sym_preproc_line] = STATE(2081),
    [sym_preproc_pragma] = STATE(2081),
    [sym_preproc_nullable] = STATE(2081),
    [sym_preproc_error] = STATE(2081),
    [sym_preproc_define] = STATE(2081),
    [sym_preproc_undef] = STATE(2081),
    [aux_sym_class_declaration_repeat1] = STATE(3800),
    [aux_sym_lambda_expression_repeat1] = STATE(4089),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1323),
    [anon_sym_ref] = ACTIONS(1325),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1145),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1329),
    [anon_sym_TILDE] = ACTIONS(1329),
    [anon_sym_PLUS_PLUS] = ACTIONS(1329),
    [anon_sym_DASH_DASH] = ACTIONS(1329),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1327),
    [anon_sym_DASH] = ACTIONS(1327),
    [anon_sym_STAR] = ACTIONS(1331),
    [anon_sym_CARET] = ACTIONS(1329),
    [anon_sym_AMP] = ACTIONS(1329),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1333),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1335),
    [anon_sym_DOT_DOT] = ACTIONS(1337),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [2082] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3921),
    [sym__name] = STATE(6919),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2868),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(6950),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5217),
    [sym_non_lvalue_expression] = STATE(5735),
    [sym_lvalue_expression] = STATE(4054),
    [sym__expression_statement_expression] = STATE(5733),
    [sym_assignment_expression] = STATE(5734),
    [sym_binary_expression] = STATE(5733),
    [sym_postfix_unary_expression] = STATE(5734),
    [sym_prefix_unary_expression] = STATE(5734),
    [sym__pointer_indirection_expression] = STATE(3911),
    [sym_query_expression] = STATE(5733),
    [sym_from_clause] = STATE(7400),
    [sym_conditional_expression] = STATE(5733),
    [sym_conditional_access_expression] = STATE(5733),
    [sym_as_expression] = STATE(5733),
    [sym_is_expression] = STATE(5733),
    [sym_is_pattern_expression] = STATE(5733),
    [sym_cast_expression] = STATE(5733),
    [sym_checked_expression] = STATE(5733),
    [sym_invocation_expression] = STATE(5734),
    [sym_switch_expression] = STATE(5733),
    [sym_await_expression] = STATE(5734),
    [sym_throw_expression] = STATE(5733),
    [sym_element_access_expression] = STATE(3911),
    [sym_interpolated_string_expression] = STATE(5733),
    [sym_member_access_expression] = STATE(3911),
    [sym_object_creation_expression] = STATE(5734),
    [sym_parenthesized_expression] = STATE(5734),
    [sym__parenthesized_lvalue_expression] = STATE(3911),
    [sym_lambda_expression] = STATE(5733),
    [sym__lambda_parameters] = STATE(9693),
    [sym_array_creation_expression] = STATE(5733),
    [sym_anonymous_method_expression] = STATE(5733),
    [sym_anonymous_object_creation_expression] = STATE(5733),
    [sym_implicit_array_creation_expression] = STATE(5733),
    [sym_implicit_object_creation_expression] = STATE(5733),
    [sym_implicit_stackalloc_expression] = STATE(5733),
    [sym_initializer_expression] = STATE(5733),
    [sym_default_expression] = STATE(5733),
    [sym_with_expression] = STATE(5733),
    [sym_sizeof_expression] = STATE(5733),
    [sym_typeof_expression] = STATE(5733),
    [sym_makeref_expression] = STATE(5733),
    [sym_ref_expression] = STATE(5733),
    [sym_reftype_expression] = STATE(5733),
    [sym_refvalue_expression] = STATE(5733),
    [sym_stackalloc_expression] = STATE(5733),
    [sym_range_expression] = STATE(5733),
    [sym_tuple_expression] = STATE(3911),
    [sym_literal] = STATE(5733),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2798),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(5733),
    [sym_preproc_region] = STATE(2082),
    [sym_preproc_endregion] = STATE(2082),
    [sym_preproc_line] = STATE(2082),
    [sym_preproc_pragma] = STATE(2082),
    [sym_preproc_nullable] = STATE(2082),
    [sym_preproc_error] = STATE(2082),
    [sym_preproc_define] = STATE(2082),
    [sym_preproc_undef] = STATE(2082),
    [aux_sym_class_declaration_repeat1] = STATE(3791),
    [aux_sym_lambda_expression_repeat1] = STATE(4075),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_LPAREN] = ACTIONS(1373),
    [anon_sym_ref] = ACTIONS(1375),
    [anon_sym_LBRACE] = ACTIONS(1377),
    [anon_sym_delegate] = ACTIONS(1379),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1381),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1387),
    [anon_sym_TILDE] = ACTIONS(1387),
    [anon_sym_PLUS_PLUS] = ACTIONS(1387),
    [anon_sym_DASH_DASH] = ACTIONS(1387),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1385),
    [anon_sym_DASH] = ACTIONS(1385),
    [anon_sym_STAR] = ACTIONS(1391),
    [anon_sym_CARET] = ACTIONS(1387),
    [anon_sym_AMP] = ACTIONS(1387),
    [anon_sym_this] = ACTIONS(1393),
    [anon_sym_scoped] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1397),
    [sym_predefined_type] = ACTIONS(1399),
    [anon_sym_unchecked] = ACTIONS(1383),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1403),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1405),
    [anon_sym_DOT_DOT] = ACTIONS(1407),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_stackalloc] = ACTIONS(1413),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(1419),
    [anon_sym___reftype] = ACTIONS(1421),
    [anon_sym___refvalue] = ACTIONS(1423),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
  },
  [2083] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6914),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2882),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6963),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5340),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4002),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7386),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9254),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(2083),
    [sym_preproc_endregion] = STATE(2083),
    [sym_preproc_line] = STATE(2083),
    [sym_preproc_pragma] = STATE(2083),
    [sym_preproc_nullable] = STATE(2083),
    [sym_preproc_error] = STATE(2083),
    [sym_preproc_define] = STATE(2083),
    [sym_preproc_undef] = STATE(2083),
    [aux_sym_class_declaration_repeat1] = STATE(3797),
    [aux_sym_lambda_expression_repeat1] = STATE(4081),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1727),
    [anon_sym_ref] = ACTIONS(1729),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1713),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1733),
    [anon_sym_TILDE] = ACTIONS(1733),
    [anon_sym_PLUS_PLUS] = ACTIONS(1733),
    [anon_sym_DASH_DASH] = ACTIONS(1733),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1731),
    [anon_sym_DASH] = ACTIONS(1731),
    [anon_sym_STAR] = ACTIONS(1735),
    [anon_sym_CARET] = ACTIONS(1733),
    [anon_sym_AMP] = ACTIONS(1733),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1737),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1739),
    [anon_sym_DOT_DOT] = ACTIONS(1741),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [2084] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3559),
    [sym__name] = STATE(6877),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2908),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6958),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4659),
    [sym_non_lvalue_expression] = STATE(4553),
    [sym_lvalue_expression] = STATE(3691),
    [sym__expression_statement_expression] = STATE(4559),
    [sym_assignment_expression] = STATE(4558),
    [sym_binary_expression] = STATE(4559),
    [sym_postfix_unary_expression] = STATE(4558),
    [sym_prefix_unary_expression] = STATE(4558),
    [sym__pointer_indirection_expression] = STATE(3560),
    [sym_query_expression] = STATE(4559),
    [sym_from_clause] = STATE(7406),
    [sym_conditional_expression] = STATE(4559),
    [sym_conditional_access_expression] = STATE(4559),
    [sym_as_expression] = STATE(4559),
    [sym_is_expression] = STATE(4559),
    [sym_is_pattern_expression] = STATE(4559),
    [sym_cast_expression] = STATE(4559),
    [sym_checked_expression] = STATE(4559),
    [sym_invocation_expression] = STATE(4558),
    [sym_switch_expression] = STATE(4559),
    [sym_await_expression] = STATE(4558),
    [sym_throw_expression] = STATE(4559),
    [sym_element_access_expression] = STATE(3560),
    [sym_interpolated_string_expression] = STATE(4559),
    [sym_member_access_expression] = STATE(3560),
    [sym_object_creation_expression] = STATE(4558),
    [sym_parenthesized_expression] = STATE(4558),
    [sym__parenthesized_lvalue_expression] = STATE(3560),
    [sym_lambda_expression] = STATE(4559),
    [sym__lambda_parameters] = STATE(9348),
    [sym_array_creation_expression] = STATE(4559),
    [sym_anonymous_method_expression] = STATE(4559),
    [sym_anonymous_object_creation_expression] = STATE(4559),
    [sym_implicit_array_creation_expression] = STATE(4559),
    [sym_implicit_object_creation_expression] = STATE(4559),
    [sym_implicit_stackalloc_expression] = STATE(4559),
    [sym_initializer_expression] = STATE(4559),
    [sym_default_expression] = STATE(4559),
    [sym_with_expression] = STATE(4559),
    [sym_sizeof_expression] = STATE(4559),
    [sym_typeof_expression] = STATE(4559),
    [sym_makeref_expression] = STATE(4559),
    [sym_ref_expression] = STATE(4559),
    [sym_reftype_expression] = STATE(4559),
    [sym_refvalue_expression] = STATE(4559),
    [sym_stackalloc_expression] = STATE(4559),
    [sym_range_expression] = STATE(4559),
    [sym_tuple_expression] = STATE(3560),
    [sym_literal] = STATE(4559),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4559),
    [sym_preproc_region] = STATE(2084),
    [sym_preproc_endregion] = STATE(2084),
    [sym_preproc_line] = STATE(2084),
    [sym_preproc_pragma] = STATE(2084),
    [sym_preproc_nullable] = STATE(2084),
    [sym_preproc_error] = STATE(2084),
    [sym_preproc_define] = STATE(2084),
    [sym_preproc_undef] = STATE(2084),
    [aux_sym_class_declaration_repeat1] = STATE(3810),
    [aux_sym_lambda_expression_repeat1] = STATE(4141),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(2047),
    [anon_sym_ref] = ACTIONS(2049),
    [anon_sym_LBRACE] = ACTIONS(1611),
    [anon_sym_delegate] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1679),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(2053),
    [anon_sym_TILDE] = ACTIONS(2053),
    [anon_sym_PLUS_PLUS] = ACTIONS(2053),
    [anon_sym_DASH_DASH] = ACTIONS(2053),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(2051),
    [anon_sym_DASH] = ACTIONS(2051),
    [anon_sym_STAR] = ACTIONS(1685),
    [anon_sym_CARET] = ACTIONS(2053),
    [anon_sym_AMP] = ACTIONS(2053),
    [anon_sym_this] = ACTIONS(1627),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1629),
    [anon_sym_unchecked] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(2055),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2057),
    [anon_sym_DOT_DOT] = ACTIONS(2059),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_stackalloc] = ACTIONS(1641),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(1647),
    [anon_sym___reftype] = ACTIONS(1649),
    [anon_sym___refvalue] = ACTIONS(1651),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1659),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [2085] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6911),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6992),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5026),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(3829),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7391),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9246),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(2085),
    [sym_preproc_endregion] = STATE(2085),
    [sym_preproc_line] = STATE(2085),
    [sym_preproc_pragma] = STATE(2085),
    [sym_preproc_nullable] = STATE(2085),
    [sym_preproc_error] = STATE(2085),
    [sym_preproc_define] = STATE(2085),
    [sym_preproc_undef] = STATE(2085),
    [aux_sym_class_declaration_repeat1] = STATE(3800),
    [aux_sym_lambda_expression_repeat1] = STATE(4089),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1323),
    [anon_sym_ref] = ACTIONS(1325),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1145),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1329),
    [anon_sym_TILDE] = ACTIONS(1329),
    [anon_sym_PLUS_PLUS] = ACTIONS(1329),
    [anon_sym_DASH_DASH] = ACTIONS(1329),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1327),
    [anon_sym_DASH] = ACTIONS(1327),
    [anon_sym_STAR] = ACTIONS(1331),
    [anon_sym_CARET] = ACTIONS(1329),
    [anon_sym_AMP] = ACTIONS(1329),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1333),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1335),
    [anon_sym_DOT_DOT] = ACTIONS(1337),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [2086] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6911),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6992),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5025),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(3829),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7391),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9246),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(2086),
    [sym_preproc_endregion] = STATE(2086),
    [sym_preproc_line] = STATE(2086),
    [sym_preproc_pragma] = STATE(2086),
    [sym_preproc_nullable] = STATE(2086),
    [sym_preproc_error] = STATE(2086),
    [sym_preproc_define] = STATE(2086),
    [sym_preproc_undef] = STATE(2086),
    [aux_sym_class_declaration_repeat1] = STATE(3800),
    [aux_sym_lambda_expression_repeat1] = STATE(4089),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1323),
    [anon_sym_ref] = ACTIONS(1325),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1145),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1329),
    [anon_sym_TILDE] = ACTIONS(1329),
    [anon_sym_PLUS_PLUS] = ACTIONS(1329),
    [anon_sym_DASH_DASH] = ACTIONS(1329),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1327),
    [anon_sym_DASH] = ACTIONS(1327),
    [anon_sym_STAR] = ACTIONS(1331),
    [anon_sym_CARET] = ACTIONS(1329),
    [anon_sym_AMP] = ACTIONS(1329),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1333),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1335),
    [anon_sym_DOT_DOT] = ACTIONS(1337),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [2087] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6911),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6992),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5024),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(3829),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7391),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9246),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(2087),
    [sym_preproc_endregion] = STATE(2087),
    [sym_preproc_line] = STATE(2087),
    [sym_preproc_pragma] = STATE(2087),
    [sym_preproc_nullable] = STATE(2087),
    [sym_preproc_error] = STATE(2087),
    [sym_preproc_define] = STATE(2087),
    [sym_preproc_undef] = STATE(2087),
    [aux_sym_class_declaration_repeat1] = STATE(3800),
    [aux_sym_lambda_expression_repeat1] = STATE(4089),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1323),
    [anon_sym_ref] = ACTIONS(1325),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1145),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1329),
    [anon_sym_TILDE] = ACTIONS(1329),
    [anon_sym_PLUS_PLUS] = ACTIONS(1329),
    [anon_sym_DASH_DASH] = ACTIONS(1329),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1327),
    [anon_sym_DASH] = ACTIONS(1327),
    [anon_sym_STAR] = ACTIONS(1331),
    [anon_sym_CARET] = ACTIONS(1329),
    [anon_sym_AMP] = ACTIONS(1329),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1333),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1335),
    [anon_sym_DOT_DOT] = ACTIONS(1337),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [2088] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3921),
    [sym__name] = STATE(6889),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2854),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(7061),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5164),
    [sym_non_lvalue_expression] = STATE(5735),
    [sym_lvalue_expression] = STATE(3899),
    [sym__expression_statement_expression] = STATE(5733),
    [sym_assignment_expression] = STATE(5734),
    [sym_binary_expression] = STATE(5733),
    [sym_postfix_unary_expression] = STATE(5734),
    [sym_prefix_unary_expression] = STATE(5734),
    [sym__pointer_indirection_expression] = STATE(3911),
    [sym_query_expression] = STATE(5733),
    [sym_from_clause] = STATE(7400),
    [sym_conditional_expression] = STATE(5733),
    [sym_conditional_access_expression] = STATE(5733),
    [sym_as_expression] = STATE(5733),
    [sym_is_expression] = STATE(5733),
    [sym_is_pattern_expression] = STATE(5733),
    [sym_cast_expression] = STATE(5733),
    [sym_checked_expression] = STATE(5733),
    [sym_invocation_expression] = STATE(5734),
    [sym_switch_expression] = STATE(5733),
    [sym_await_expression] = STATE(5734),
    [sym_throw_expression] = STATE(5733),
    [sym_element_access_expression] = STATE(3911),
    [sym_interpolated_string_expression] = STATE(5733),
    [sym_member_access_expression] = STATE(3911),
    [sym_object_creation_expression] = STATE(5734),
    [sym_parenthesized_expression] = STATE(5734),
    [sym__parenthesized_lvalue_expression] = STATE(3911),
    [sym_lambda_expression] = STATE(5733),
    [sym__lambda_parameters] = STATE(9790),
    [sym_array_creation_expression] = STATE(5733),
    [sym_anonymous_method_expression] = STATE(5733),
    [sym_anonymous_object_creation_expression] = STATE(5733),
    [sym_implicit_array_creation_expression] = STATE(5733),
    [sym_implicit_object_creation_expression] = STATE(5733),
    [sym_implicit_stackalloc_expression] = STATE(5733),
    [sym_initializer_expression] = STATE(5733),
    [sym_default_expression] = STATE(5733),
    [sym_with_expression] = STATE(5733),
    [sym_sizeof_expression] = STATE(5733),
    [sym_typeof_expression] = STATE(5733),
    [sym_makeref_expression] = STATE(5733),
    [sym_ref_expression] = STATE(5733),
    [sym_reftype_expression] = STATE(5733),
    [sym_refvalue_expression] = STATE(5733),
    [sym_stackalloc_expression] = STATE(5733),
    [sym_range_expression] = STATE(5733),
    [sym_tuple_expression] = STATE(3911),
    [sym_literal] = STATE(5733),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2798),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(5733),
    [sym_preproc_region] = STATE(2088),
    [sym_preproc_endregion] = STATE(2088),
    [sym_preproc_line] = STATE(2088),
    [sym_preproc_pragma] = STATE(2088),
    [sym_preproc_nullable] = STATE(2088),
    [sym_preproc_error] = STATE(2088),
    [sym_preproc_define] = STATE(2088),
    [sym_preproc_undef] = STATE(2088),
    [aux_sym_class_declaration_repeat1] = STATE(3833),
    [aux_sym_lambda_expression_repeat1] = STATE(4182),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_LPAREN] = ACTIONS(1439),
    [anon_sym_ref] = ACTIONS(1441),
    [anon_sym_LBRACE] = ACTIONS(1377),
    [anon_sym_delegate] = ACTIONS(1379),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1443),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1447),
    [anon_sym_TILDE] = ACTIONS(1447),
    [anon_sym_PLUS_PLUS] = ACTIONS(1447),
    [anon_sym_DASH_DASH] = ACTIONS(1447),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1445),
    [anon_sym_DASH] = ACTIONS(1445),
    [anon_sym_STAR] = ACTIONS(1449),
    [anon_sym_CARET] = ACTIONS(1447),
    [anon_sym_AMP] = ACTIONS(1447),
    [anon_sym_this] = ACTIONS(1393),
    [anon_sym_scoped] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1397),
    [sym_predefined_type] = ACTIONS(1399),
    [anon_sym_unchecked] = ACTIONS(1383),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1451),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1453),
    [anon_sym_DOT_DOT] = ACTIONS(1455),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_stackalloc] = ACTIONS(1413),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(1419),
    [anon_sym___reftype] = ACTIONS(1421),
    [anon_sym___refvalue] = ACTIONS(1423),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
  },
  [2089] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6911),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6992),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5022),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(3829),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7391),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9246),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(2089),
    [sym_preproc_endregion] = STATE(2089),
    [sym_preproc_line] = STATE(2089),
    [sym_preproc_pragma] = STATE(2089),
    [sym_preproc_nullable] = STATE(2089),
    [sym_preproc_error] = STATE(2089),
    [sym_preproc_define] = STATE(2089),
    [sym_preproc_undef] = STATE(2089),
    [aux_sym_class_declaration_repeat1] = STATE(3800),
    [aux_sym_lambda_expression_repeat1] = STATE(4089),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1323),
    [anon_sym_ref] = ACTIONS(1325),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1145),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1329),
    [anon_sym_TILDE] = ACTIONS(1329),
    [anon_sym_PLUS_PLUS] = ACTIONS(1329),
    [anon_sym_DASH_DASH] = ACTIONS(1329),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1327),
    [anon_sym_DASH] = ACTIONS(1327),
    [anon_sym_STAR] = ACTIONS(1331),
    [anon_sym_CARET] = ACTIONS(1329),
    [anon_sym_AMP] = ACTIONS(1329),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1333),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1335),
    [anon_sym_DOT_DOT] = ACTIONS(1337),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [2090] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6911),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6992),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5021),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(3829),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7391),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9246),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(2090),
    [sym_preproc_endregion] = STATE(2090),
    [sym_preproc_line] = STATE(2090),
    [sym_preproc_pragma] = STATE(2090),
    [sym_preproc_nullable] = STATE(2090),
    [sym_preproc_error] = STATE(2090),
    [sym_preproc_define] = STATE(2090),
    [sym_preproc_undef] = STATE(2090),
    [aux_sym_class_declaration_repeat1] = STATE(3800),
    [aux_sym_lambda_expression_repeat1] = STATE(4089),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1323),
    [anon_sym_ref] = ACTIONS(1325),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1145),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1329),
    [anon_sym_TILDE] = ACTIONS(1329),
    [anon_sym_PLUS_PLUS] = ACTIONS(1329),
    [anon_sym_DASH_DASH] = ACTIONS(1329),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1327),
    [anon_sym_DASH] = ACTIONS(1327),
    [anon_sym_STAR] = ACTIONS(1331),
    [anon_sym_CARET] = ACTIONS(1329),
    [anon_sym_AMP] = ACTIONS(1329),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1333),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1335),
    [anon_sym_DOT_DOT] = ACTIONS(1337),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [2091] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6911),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6992),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5020),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(3829),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7391),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9246),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(2091),
    [sym_preproc_endregion] = STATE(2091),
    [sym_preproc_line] = STATE(2091),
    [sym_preproc_pragma] = STATE(2091),
    [sym_preproc_nullable] = STATE(2091),
    [sym_preproc_error] = STATE(2091),
    [sym_preproc_define] = STATE(2091),
    [sym_preproc_undef] = STATE(2091),
    [aux_sym_class_declaration_repeat1] = STATE(3800),
    [aux_sym_lambda_expression_repeat1] = STATE(4089),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1323),
    [anon_sym_ref] = ACTIONS(1325),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1145),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1329),
    [anon_sym_TILDE] = ACTIONS(1329),
    [anon_sym_PLUS_PLUS] = ACTIONS(1329),
    [anon_sym_DASH_DASH] = ACTIONS(1329),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1327),
    [anon_sym_DASH] = ACTIONS(1327),
    [anon_sym_STAR] = ACTIONS(1331),
    [anon_sym_CARET] = ACTIONS(1329),
    [anon_sym_AMP] = ACTIONS(1329),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1333),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1335),
    [anon_sym_DOT_DOT] = ACTIONS(1337),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [2092] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3921),
    [sym__name] = STATE(6889),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2854),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(7061),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5124),
    [sym_non_lvalue_expression] = STATE(5735),
    [sym_lvalue_expression] = STATE(3899),
    [sym__expression_statement_expression] = STATE(5733),
    [sym_assignment_expression] = STATE(5734),
    [sym_binary_expression] = STATE(5733),
    [sym_postfix_unary_expression] = STATE(5734),
    [sym_prefix_unary_expression] = STATE(5734),
    [sym__pointer_indirection_expression] = STATE(3911),
    [sym_query_expression] = STATE(5733),
    [sym_from_clause] = STATE(7400),
    [sym_conditional_expression] = STATE(5733),
    [sym_conditional_access_expression] = STATE(5733),
    [sym_as_expression] = STATE(5733),
    [sym_is_expression] = STATE(5733),
    [sym_is_pattern_expression] = STATE(5733),
    [sym_cast_expression] = STATE(5733),
    [sym_checked_expression] = STATE(5733),
    [sym_invocation_expression] = STATE(5734),
    [sym_switch_expression] = STATE(5733),
    [sym_await_expression] = STATE(5734),
    [sym_throw_expression] = STATE(5733),
    [sym_element_access_expression] = STATE(3911),
    [sym_interpolated_string_expression] = STATE(5733),
    [sym_member_access_expression] = STATE(3911),
    [sym_object_creation_expression] = STATE(5734),
    [sym_parenthesized_expression] = STATE(5734),
    [sym__parenthesized_lvalue_expression] = STATE(3911),
    [sym_lambda_expression] = STATE(5733),
    [sym__lambda_parameters] = STATE(9790),
    [sym_array_creation_expression] = STATE(5733),
    [sym_anonymous_method_expression] = STATE(5733),
    [sym_anonymous_object_creation_expression] = STATE(5733),
    [sym_implicit_array_creation_expression] = STATE(5733),
    [sym_implicit_object_creation_expression] = STATE(5733),
    [sym_implicit_stackalloc_expression] = STATE(5733),
    [sym_initializer_expression] = STATE(5733),
    [sym_default_expression] = STATE(5733),
    [sym_with_expression] = STATE(5733),
    [sym_sizeof_expression] = STATE(5733),
    [sym_typeof_expression] = STATE(5733),
    [sym_makeref_expression] = STATE(5733),
    [sym_ref_expression] = STATE(5733),
    [sym_reftype_expression] = STATE(5733),
    [sym_refvalue_expression] = STATE(5733),
    [sym_stackalloc_expression] = STATE(5733),
    [sym_range_expression] = STATE(5733),
    [sym_tuple_expression] = STATE(3911),
    [sym_literal] = STATE(5733),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2798),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(5733),
    [sym_preproc_region] = STATE(2092),
    [sym_preproc_endregion] = STATE(2092),
    [sym_preproc_line] = STATE(2092),
    [sym_preproc_pragma] = STATE(2092),
    [sym_preproc_nullable] = STATE(2092),
    [sym_preproc_error] = STATE(2092),
    [sym_preproc_define] = STATE(2092),
    [sym_preproc_undef] = STATE(2092),
    [aux_sym_class_declaration_repeat1] = STATE(3833),
    [aux_sym_lambda_expression_repeat1] = STATE(4182),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_LPAREN] = ACTIONS(1439),
    [anon_sym_ref] = ACTIONS(1441),
    [anon_sym_LBRACE] = ACTIONS(1377),
    [anon_sym_delegate] = ACTIONS(1379),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1443),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1447),
    [anon_sym_TILDE] = ACTIONS(1447),
    [anon_sym_PLUS_PLUS] = ACTIONS(1447),
    [anon_sym_DASH_DASH] = ACTIONS(1447),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1445),
    [anon_sym_DASH] = ACTIONS(1445),
    [anon_sym_STAR] = ACTIONS(1449),
    [anon_sym_CARET] = ACTIONS(1447),
    [anon_sym_AMP] = ACTIONS(1447),
    [anon_sym_this] = ACTIONS(1393),
    [anon_sym_scoped] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1397),
    [sym_predefined_type] = ACTIONS(1399),
    [anon_sym_unchecked] = ACTIONS(1383),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1451),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1453),
    [anon_sym_DOT_DOT] = ACTIONS(1455),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_stackalloc] = ACTIONS(1413),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(1419),
    [anon_sym___reftype] = ACTIONS(1421),
    [anon_sym___refvalue] = ACTIONS(1423),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
  },
  [2093] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6904),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7009),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5326),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4008),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7381),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9536),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(2093),
    [sym_preproc_endregion] = STATE(2093),
    [sym_preproc_line] = STATE(2093),
    [sym_preproc_pragma] = STATE(2093),
    [sym_preproc_nullable] = STATE(2093),
    [sym_preproc_error] = STATE(2093),
    [sym_preproc_define] = STATE(2093),
    [sym_preproc_undef] = STATE(2093),
    [aux_sym_class_declaration_repeat1] = STATE(3832),
    [aux_sym_lambda_expression_repeat1] = STATE(4090),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1485),
    [anon_sym_ref] = ACTIONS(1487),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1221),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1491),
    [anon_sym_TILDE] = ACTIONS(1491),
    [anon_sym_PLUS_PLUS] = ACTIONS(1491),
    [anon_sym_DASH_DASH] = ACTIONS(1491),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1489),
    [anon_sym_DASH] = ACTIONS(1489),
    [anon_sym_STAR] = ACTIONS(1493),
    [anon_sym_CARET] = ACTIONS(1491),
    [anon_sym_AMP] = ACTIONS(1491),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1495),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1497),
    [anon_sym_DOT_DOT] = ACTIONS(1499),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [2094] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6904),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7009),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(3556),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4008),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7381),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9536),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(2094),
    [sym_preproc_endregion] = STATE(2094),
    [sym_preproc_line] = STATE(2094),
    [sym_preproc_pragma] = STATE(2094),
    [sym_preproc_nullable] = STATE(2094),
    [sym_preproc_error] = STATE(2094),
    [sym_preproc_define] = STATE(2094),
    [sym_preproc_undef] = STATE(2094),
    [aux_sym_class_declaration_repeat1] = STATE(3832),
    [aux_sym_lambda_expression_repeat1] = STATE(4090),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1485),
    [anon_sym_ref] = ACTIONS(1487),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1221),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1491),
    [anon_sym_TILDE] = ACTIONS(1491),
    [anon_sym_PLUS_PLUS] = ACTIONS(1491),
    [anon_sym_DASH_DASH] = ACTIONS(1491),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1489),
    [anon_sym_DASH] = ACTIONS(1489),
    [anon_sym_STAR] = ACTIONS(1493),
    [anon_sym_CARET] = ACTIONS(1491),
    [anon_sym_AMP] = ACTIONS(1491),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1495),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1497),
    [anon_sym_DOT_DOT] = ACTIONS(1499),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [2095] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3559),
    [sym__name] = STATE(6877),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2908),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6958),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4637),
    [sym_non_lvalue_expression] = STATE(4553),
    [sym_lvalue_expression] = STATE(3691),
    [sym__expression_statement_expression] = STATE(4559),
    [sym_assignment_expression] = STATE(4558),
    [sym_binary_expression] = STATE(4559),
    [sym_postfix_unary_expression] = STATE(4558),
    [sym_prefix_unary_expression] = STATE(4558),
    [sym__pointer_indirection_expression] = STATE(3560),
    [sym_query_expression] = STATE(4559),
    [sym_from_clause] = STATE(7406),
    [sym_conditional_expression] = STATE(4559),
    [sym_conditional_access_expression] = STATE(4559),
    [sym_as_expression] = STATE(4559),
    [sym_is_expression] = STATE(4559),
    [sym_is_pattern_expression] = STATE(4559),
    [sym_cast_expression] = STATE(4559),
    [sym_checked_expression] = STATE(4559),
    [sym_invocation_expression] = STATE(4558),
    [sym_switch_expression] = STATE(4559),
    [sym_await_expression] = STATE(4558),
    [sym_throw_expression] = STATE(4559),
    [sym_element_access_expression] = STATE(3560),
    [sym_interpolated_string_expression] = STATE(4559),
    [sym_member_access_expression] = STATE(3560),
    [sym_object_creation_expression] = STATE(4558),
    [sym_parenthesized_expression] = STATE(4558),
    [sym__parenthesized_lvalue_expression] = STATE(3560),
    [sym_lambda_expression] = STATE(4559),
    [sym__lambda_parameters] = STATE(9348),
    [sym_array_creation_expression] = STATE(4559),
    [sym_anonymous_method_expression] = STATE(4559),
    [sym_anonymous_object_creation_expression] = STATE(4559),
    [sym_implicit_array_creation_expression] = STATE(4559),
    [sym_implicit_object_creation_expression] = STATE(4559),
    [sym_implicit_stackalloc_expression] = STATE(4559),
    [sym_initializer_expression] = STATE(4559),
    [sym_default_expression] = STATE(4559),
    [sym_with_expression] = STATE(4559),
    [sym_sizeof_expression] = STATE(4559),
    [sym_typeof_expression] = STATE(4559),
    [sym_makeref_expression] = STATE(4559),
    [sym_ref_expression] = STATE(4559),
    [sym_reftype_expression] = STATE(4559),
    [sym_refvalue_expression] = STATE(4559),
    [sym_stackalloc_expression] = STATE(4559),
    [sym_range_expression] = STATE(4559),
    [sym_tuple_expression] = STATE(3560),
    [sym_literal] = STATE(4559),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4559),
    [sym_preproc_region] = STATE(2095),
    [sym_preproc_endregion] = STATE(2095),
    [sym_preproc_line] = STATE(2095),
    [sym_preproc_pragma] = STATE(2095),
    [sym_preproc_nullable] = STATE(2095),
    [sym_preproc_error] = STATE(2095),
    [sym_preproc_define] = STATE(2095),
    [sym_preproc_undef] = STATE(2095),
    [aux_sym_class_declaration_repeat1] = STATE(3810),
    [aux_sym_lambda_expression_repeat1] = STATE(4141),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(2047),
    [anon_sym_ref] = ACTIONS(2049),
    [anon_sym_LBRACE] = ACTIONS(1611),
    [anon_sym_delegate] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1679),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(2053),
    [anon_sym_TILDE] = ACTIONS(2053),
    [anon_sym_PLUS_PLUS] = ACTIONS(2053),
    [anon_sym_DASH_DASH] = ACTIONS(2053),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(2051),
    [anon_sym_DASH] = ACTIONS(2051),
    [anon_sym_STAR] = ACTIONS(1685),
    [anon_sym_CARET] = ACTIONS(2053),
    [anon_sym_AMP] = ACTIONS(2053),
    [anon_sym_this] = ACTIONS(1627),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1629),
    [anon_sym_unchecked] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(2055),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2057),
    [anon_sym_DOT_DOT] = ACTIONS(2059),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_stackalloc] = ACTIONS(1641),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(1647),
    [anon_sym___reftype] = ACTIONS(1649),
    [anon_sym___refvalue] = ACTIONS(1651),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1659),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [2096] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6911),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6992),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5019),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(3829),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7391),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9246),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(2096),
    [sym_preproc_endregion] = STATE(2096),
    [sym_preproc_line] = STATE(2096),
    [sym_preproc_pragma] = STATE(2096),
    [sym_preproc_nullable] = STATE(2096),
    [sym_preproc_error] = STATE(2096),
    [sym_preproc_define] = STATE(2096),
    [sym_preproc_undef] = STATE(2096),
    [aux_sym_class_declaration_repeat1] = STATE(3800),
    [aux_sym_lambda_expression_repeat1] = STATE(4089),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1323),
    [anon_sym_ref] = ACTIONS(1325),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1145),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1329),
    [anon_sym_TILDE] = ACTIONS(1329),
    [anon_sym_PLUS_PLUS] = ACTIONS(1329),
    [anon_sym_DASH_DASH] = ACTIONS(1329),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1327),
    [anon_sym_DASH] = ACTIONS(1327),
    [anon_sym_STAR] = ACTIONS(1331),
    [anon_sym_CARET] = ACTIONS(1329),
    [anon_sym_AMP] = ACTIONS(1329),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1333),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1335),
    [anon_sym_DOT_DOT] = ACTIONS(1337),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [2097] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3559),
    [sym__name] = STATE(6877),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2908),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6958),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4636),
    [sym_non_lvalue_expression] = STATE(4553),
    [sym_lvalue_expression] = STATE(3691),
    [sym__expression_statement_expression] = STATE(4559),
    [sym_assignment_expression] = STATE(4558),
    [sym_binary_expression] = STATE(4559),
    [sym_postfix_unary_expression] = STATE(4558),
    [sym_prefix_unary_expression] = STATE(4558),
    [sym__pointer_indirection_expression] = STATE(3560),
    [sym_query_expression] = STATE(4559),
    [sym_from_clause] = STATE(7406),
    [sym_conditional_expression] = STATE(4559),
    [sym_conditional_access_expression] = STATE(4559),
    [sym_as_expression] = STATE(4559),
    [sym_is_expression] = STATE(4559),
    [sym_is_pattern_expression] = STATE(4559),
    [sym_cast_expression] = STATE(4559),
    [sym_checked_expression] = STATE(4559),
    [sym_invocation_expression] = STATE(4558),
    [sym_switch_expression] = STATE(4559),
    [sym_await_expression] = STATE(4558),
    [sym_throw_expression] = STATE(4559),
    [sym_element_access_expression] = STATE(3560),
    [sym_interpolated_string_expression] = STATE(4559),
    [sym_member_access_expression] = STATE(3560),
    [sym_object_creation_expression] = STATE(4558),
    [sym_parenthesized_expression] = STATE(4558),
    [sym__parenthesized_lvalue_expression] = STATE(3560),
    [sym_lambda_expression] = STATE(4559),
    [sym__lambda_parameters] = STATE(9348),
    [sym_array_creation_expression] = STATE(4559),
    [sym_anonymous_method_expression] = STATE(4559),
    [sym_anonymous_object_creation_expression] = STATE(4559),
    [sym_implicit_array_creation_expression] = STATE(4559),
    [sym_implicit_object_creation_expression] = STATE(4559),
    [sym_implicit_stackalloc_expression] = STATE(4559),
    [sym_initializer_expression] = STATE(4559),
    [sym_default_expression] = STATE(4559),
    [sym_with_expression] = STATE(4559),
    [sym_sizeof_expression] = STATE(4559),
    [sym_typeof_expression] = STATE(4559),
    [sym_makeref_expression] = STATE(4559),
    [sym_ref_expression] = STATE(4559),
    [sym_reftype_expression] = STATE(4559),
    [sym_refvalue_expression] = STATE(4559),
    [sym_stackalloc_expression] = STATE(4559),
    [sym_range_expression] = STATE(4559),
    [sym_tuple_expression] = STATE(3560),
    [sym_literal] = STATE(4559),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4559),
    [sym_preproc_region] = STATE(2097),
    [sym_preproc_endregion] = STATE(2097),
    [sym_preproc_line] = STATE(2097),
    [sym_preproc_pragma] = STATE(2097),
    [sym_preproc_nullable] = STATE(2097),
    [sym_preproc_error] = STATE(2097),
    [sym_preproc_define] = STATE(2097),
    [sym_preproc_undef] = STATE(2097),
    [aux_sym_class_declaration_repeat1] = STATE(3810),
    [aux_sym_lambda_expression_repeat1] = STATE(4141),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(2047),
    [anon_sym_ref] = ACTIONS(2049),
    [anon_sym_LBRACE] = ACTIONS(1611),
    [anon_sym_delegate] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1679),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(2053),
    [anon_sym_TILDE] = ACTIONS(2053),
    [anon_sym_PLUS_PLUS] = ACTIONS(2053),
    [anon_sym_DASH_DASH] = ACTIONS(2053),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(2051),
    [anon_sym_DASH] = ACTIONS(2051),
    [anon_sym_STAR] = ACTIONS(1685),
    [anon_sym_CARET] = ACTIONS(2053),
    [anon_sym_AMP] = ACTIONS(2053),
    [anon_sym_this] = ACTIONS(1627),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1629),
    [anon_sym_unchecked] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(2055),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2057),
    [anon_sym_DOT_DOT] = ACTIONS(2059),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_stackalloc] = ACTIONS(1641),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(1647),
    [anon_sym___reftype] = ACTIONS(1649),
    [anon_sym___refvalue] = ACTIONS(1651),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1659),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [2098] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6911),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6992),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5018),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(3829),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7391),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9246),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(2098),
    [sym_preproc_endregion] = STATE(2098),
    [sym_preproc_line] = STATE(2098),
    [sym_preproc_pragma] = STATE(2098),
    [sym_preproc_nullable] = STATE(2098),
    [sym_preproc_error] = STATE(2098),
    [sym_preproc_define] = STATE(2098),
    [sym_preproc_undef] = STATE(2098),
    [aux_sym_class_declaration_repeat1] = STATE(3800),
    [aux_sym_lambda_expression_repeat1] = STATE(4089),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1323),
    [anon_sym_ref] = ACTIONS(1325),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1145),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1329),
    [anon_sym_TILDE] = ACTIONS(1329),
    [anon_sym_PLUS_PLUS] = ACTIONS(1329),
    [anon_sym_DASH_DASH] = ACTIONS(1329),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1327),
    [anon_sym_DASH] = ACTIONS(1327),
    [anon_sym_STAR] = ACTIONS(1331),
    [anon_sym_CARET] = ACTIONS(1329),
    [anon_sym_AMP] = ACTIONS(1329),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1333),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1335),
    [anon_sym_DOT_DOT] = ACTIONS(1337),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [2099] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6911),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6992),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5017),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(3829),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7391),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9246),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(2099),
    [sym_preproc_endregion] = STATE(2099),
    [sym_preproc_line] = STATE(2099),
    [sym_preproc_pragma] = STATE(2099),
    [sym_preproc_nullable] = STATE(2099),
    [sym_preproc_error] = STATE(2099),
    [sym_preproc_define] = STATE(2099),
    [sym_preproc_undef] = STATE(2099),
    [aux_sym_class_declaration_repeat1] = STATE(3800),
    [aux_sym_lambda_expression_repeat1] = STATE(4089),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1323),
    [anon_sym_ref] = ACTIONS(1325),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1145),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1329),
    [anon_sym_TILDE] = ACTIONS(1329),
    [anon_sym_PLUS_PLUS] = ACTIONS(1329),
    [anon_sym_DASH_DASH] = ACTIONS(1329),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1327),
    [anon_sym_DASH] = ACTIONS(1327),
    [anon_sym_STAR] = ACTIONS(1331),
    [anon_sym_CARET] = ACTIONS(1329),
    [anon_sym_AMP] = ACTIONS(1329),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1333),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1335),
    [anon_sym_DOT_DOT] = ACTIONS(1337),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [2100] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6911),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6992),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5016),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(3829),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7391),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9246),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(2100),
    [sym_preproc_endregion] = STATE(2100),
    [sym_preproc_line] = STATE(2100),
    [sym_preproc_pragma] = STATE(2100),
    [sym_preproc_nullable] = STATE(2100),
    [sym_preproc_error] = STATE(2100),
    [sym_preproc_define] = STATE(2100),
    [sym_preproc_undef] = STATE(2100),
    [aux_sym_class_declaration_repeat1] = STATE(3800),
    [aux_sym_lambda_expression_repeat1] = STATE(4089),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1323),
    [anon_sym_ref] = ACTIONS(1325),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1145),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1329),
    [anon_sym_TILDE] = ACTIONS(1329),
    [anon_sym_PLUS_PLUS] = ACTIONS(1329),
    [anon_sym_DASH_DASH] = ACTIONS(1329),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1327),
    [anon_sym_DASH] = ACTIONS(1327),
    [anon_sym_STAR] = ACTIONS(1331),
    [anon_sym_CARET] = ACTIONS(1329),
    [anon_sym_AMP] = ACTIONS(1329),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1333),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1335),
    [anon_sym_DOT_DOT] = ACTIONS(1337),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [2101] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6911),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6992),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5028),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(3829),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7391),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9246),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(2101),
    [sym_preproc_endregion] = STATE(2101),
    [sym_preproc_line] = STATE(2101),
    [sym_preproc_pragma] = STATE(2101),
    [sym_preproc_nullable] = STATE(2101),
    [sym_preproc_error] = STATE(2101),
    [sym_preproc_define] = STATE(2101),
    [sym_preproc_undef] = STATE(2101),
    [aux_sym_class_declaration_repeat1] = STATE(3800),
    [aux_sym_lambda_expression_repeat1] = STATE(4089),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1323),
    [anon_sym_ref] = ACTIONS(1325),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1145),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1329),
    [anon_sym_TILDE] = ACTIONS(1329),
    [anon_sym_PLUS_PLUS] = ACTIONS(1329),
    [anon_sym_DASH_DASH] = ACTIONS(1329),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1327),
    [anon_sym_DASH] = ACTIONS(1327),
    [anon_sym_STAR] = ACTIONS(1331),
    [anon_sym_CARET] = ACTIONS(1329),
    [anon_sym_AMP] = ACTIONS(1329),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1333),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1335),
    [anon_sym_DOT_DOT] = ACTIONS(1337),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [2102] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3921),
    [sym__name] = STATE(6919),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2868),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(6950),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5306),
    [sym_non_lvalue_expression] = STATE(5735),
    [sym_lvalue_expression] = STATE(4054),
    [sym__expression_statement_expression] = STATE(5733),
    [sym_assignment_expression] = STATE(5734),
    [sym_binary_expression] = STATE(5733),
    [sym_postfix_unary_expression] = STATE(5734),
    [sym_prefix_unary_expression] = STATE(5734),
    [sym__pointer_indirection_expression] = STATE(3911),
    [sym_query_expression] = STATE(5733),
    [sym_from_clause] = STATE(7400),
    [sym_conditional_expression] = STATE(5733),
    [sym_conditional_access_expression] = STATE(5733),
    [sym_as_expression] = STATE(5733),
    [sym_is_expression] = STATE(5733),
    [sym_is_pattern_expression] = STATE(5733),
    [sym_cast_expression] = STATE(5733),
    [sym_checked_expression] = STATE(5733),
    [sym_invocation_expression] = STATE(5734),
    [sym_switch_expression] = STATE(5733),
    [sym_await_expression] = STATE(5734),
    [sym_throw_expression] = STATE(5733),
    [sym_element_access_expression] = STATE(3911),
    [sym_interpolated_string_expression] = STATE(5733),
    [sym_member_access_expression] = STATE(3911),
    [sym_object_creation_expression] = STATE(5734),
    [sym_parenthesized_expression] = STATE(5734),
    [sym__parenthesized_lvalue_expression] = STATE(3911),
    [sym_lambda_expression] = STATE(5733),
    [sym__lambda_parameters] = STATE(9693),
    [sym_array_creation_expression] = STATE(5733),
    [sym_anonymous_method_expression] = STATE(5733),
    [sym_anonymous_object_creation_expression] = STATE(5733),
    [sym_implicit_array_creation_expression] = STATE(5733),
    [sym_implicit_object_creation_expression] = STATE(5733),
    [sym_implicit_stackalloc_expression] = STATE(5733),
    [sym_initializer_expression] = STATE(5733),
    [sym_default_expression] = STATE(5733),
    [sym_with_expression] = STATE(5733),
    [sym_sizeof_expression] = STATE(5733),
    [sym_typeof_expression] = STATE(5733),
    [sym_makeref_expression] = STATE(5733),
    [sym_ref_expression] = STATE(5733),
    [sym_reftype_expression] = STATE(5733),
    [sym_refvalue_expression] = STATE(5733),
    [sym_stackalloc_expression] = STATE(5733),
    [sym_range_expression] = STATE(5733),
    [sym_tuple_expression] = STATE(3911),
    [sym_literal] = STATE(5733),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2798),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(5733),
    [sym_preproc_region] = STATE(2102),
    [sym_preproc_endregion] = STATE(2102),
    [sym_preproc_line] = STATE(2102),
    [sym_preproc_pragma] = STATE(2102),
    [sym_preproc_nullable] = STATE(2102),
    [sym_preproc_error] = STATE(2102),
    [sym_preproc_define] = STATE(2102),
    [sym_preproc_undef] = STATE(2102),
    [aux_sym_class_declaration_repeat1] = STATE(3791),
    [aux_sym_lambda_expression_repeat1] = STATE(4075),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_LPAREN] = ACTIONS(1373),
    [anon_sym_ref] = ACTIONS(1375),
    [anon_sym_LBRACE] = ACTIONS(1377),
    [anon_sym_delegate] = ACTIONS(1379),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1381),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1387),
    [anon_sym_TILDE] = ACTIONS(1387),
    [anon_sym_PLUS_PLUS] = ACTIONS(1387),
    [anon_sym_DASH_DASH] = ACTIONS(1387),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1385),
    [anon_sym_DASH] = ACTIONS(1385),
    [anon_sym_STAR] = ACTIONS(1391),
    [anon_sym_CARET] = ACTIONS(1387),
    [anon_sym_AMP] = ACTIONS(1387),
    [anon_sym_this] = ACTIONS(1393),
    [anon_sym_scoped] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1397),
    [sym_predefined_type] = ACTIONS(1399),
    [anon_sym_unchecked] = ACTIONS(1383),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1403),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1405),
    [anon_sym_DOT_DOT] = ACTIONS(1407),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_stackalloc] = ACTIONS(1413),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(1419),
    [anon_sym___reftype] = ACTIONS(1421),
    [anon_sym___refvalue] = ACTIONS(1423),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
  },
  [2103] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3559),
    [sym__name] = STATE(6877),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2908),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6958),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4635),
    [sym_non_lvalue_expression] = STATE(4553),
    [sym_lvalue_expression] = STATE(3691),
    [sym__expression_statement_expression] = STATE(4559),
    [sym_assignment_expression] = STATE(4558),
    [sym_binary_expression] = STATE(4559),
    [sym_postfix_unary_expression] = STATE(4558),
    [sym_prefix_unary_expression] = STATE(4558),
    [sym__pointer_indirection_expression] = STATE(3560),
    [sym_query_expression] = STATE(4559),
    [sym_from_clause] = STATE(7406),
    [sym_conditional_expression] = STATE(4559),
    [sym_conditional_access_expression] = STATE(4559),
    [sym_as_expression] = STATE(4559),
    [sym_is_expression] = STATE(4559),
    [sym_is_pattern_expression] = STATE(4559),
    [sym_cast_expression] = STATE(4559),
    [sym_checked_expression] = STATE(4559),
    [sym_invocation_expression] = STATE(4558),
    [sym_switch_expression] = STATE(4559),
    [sym_await_expression] = STATE(4558),
    [sym_throw_expression] = STATE(4559),
    [sym_element_access_expression] = STATE(3560),
    [sym_interpolated_string_expression] = STATE(4559),
    [sym_member_access_expression] = STATE(3560),
    [sym_object_creation_expression] = STATE(4558),
    [sym_parenthesized_expression] = STATE(4558),
    [sym__parenthesized_lvalue_expression] = STATE(3560),
    [sym_lambda_expression] = STATE(4559),
    [sym__lambda_parameters] = STATE(9348),
    [sym_array_creation_expression] = STATE(4559),
    [sym_anonymous_method_expression] = STATE(4559),
    [sym_anonymous_object_creation_expression] = STATE(4559),
    [sym_implicit_array_creation_expression] = STATE(4559),
    [sym_implicit_object_creation_expression] = STATE(4559),
    [sym_implicit_stackalloc_expression] = STATE(4559),
    [sym_initializer_expression] = STATE(4559),
    [sym_default_expression] = STATE(4559),
    [sym_with_expression] = STATE(4559),
    [sym_sizeof_expression] = STATE(4559),
    [sym_typeof_expression] = STATE(4559),
    [sym_makeref_expression] = STATE(4559),
    [sym_ref_expression] = STATE(4559),
    [sym_reftype_expression] = STATE(4559),
    [sym_refvalue_expression] = STATE(4559),
    [sym_stackalloc_expression] = STATE(4559),
    [sym_range_expression] = STATE(4559),
    [sym_tuple_expression] = STATE(3560),
    [sym_literal] = STATE(4559),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4559),
    [sym_preproc_region] = STATE(2103),
    [sym_preproc_endregion] = STATE(2103),
    [sym_preproc_line] = STATE(2103),
    [sym_preproc_pragma] = STATE(2103),
    [sym_preproc_nullable] = STATE(2103),
    [sym_preproc_error] = STATE(2103),
    [sym_preproc_define] = STATE(2103),
    [sym_preproc_undef] = STATE(2103),
    [aux_sym_class_declaration_repeat1] = STATE(3810),
    [aux_sym_lambda_expression_repeat1] = STATE(4141),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(2047),
    [anon_sym_ref] = ACTIONS(2049),
    [anon_sym_LBRACE] = ACTIONS(1611),
    [anon_sym_delegate] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1679),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(2053),
    [anon_sym_TILDE] = ACTIONS(2053),
    [anon_sym_PLUS_PLUS] = ACTIONS(2053),
    [anon_sym_DASH_DASH] = ACTIONS(2053),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(2051),
    [anon_sym_DASH] = ACTIONS(2051),
    [anon_sym_STAR] = ACTIONS(1685),
    [anon_sym_CARET] = ACTIONS(2053),
    [anon_sym_AMP] = ACTIONS(2053),
    [anon_sym_this] = ACTIONS(1627),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1629),
    [anon_sym_unchecked] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(2055),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2057),
    [anon_sym_DOT_DOT] = ACTIONS(2059),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_stackalloc] = ACTIONS(1641),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(1647),
    [anon_sym___reftype] = ACTIONS(1649),
    [anon_sym___refvalue] = ACTIONS(1651),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1659),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [2104] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6914),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2882),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6963),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(3822),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4002),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7386),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9254),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(2104),
    [sym_preproc_endregion] = STATE(2104),
    [sym_preproc_line] = STATE(2104),
    [sym_preproc_pragma] = STATE(2104),
    [sym_preproc_nullable] = STATE(2104),
    [sym_preproc_error] = STATE(2104),
    [sym_preproc_define] = STATE(2104),
    [sym_preproc_undef] = STATE(2104),
    [aux_sym_class_declaration_repeat1] = STATE(3797),
    [aux_sym_lambda_expression_repeat1] = STATE(4081),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1727),
    [anon_sym_ref] = ACTIONS(1729),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1713),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1733),
    [anon_sym_TILDE] = ACTIONS(1733),
    [anon_sym_PLUS_PLUS] = ACTIONS(1733),
    [anon_sym_DASH_DASH] = ACTIONS(1733),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1731),
    [anon_sym_DASH] = ACTIONS(1731),
    [anon_sym_STAR] = ACTIONS(1735),
    [anon_sym_CARET] = ACTIONS(1733),
    [anon_sym_AMP] = ACTIONS(1733),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1737),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1739),
    [anon_sym_DOT_DOT] = ACTIONS(1741),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [2105] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6914),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2882),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6963),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5325),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(4002),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7386),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9254),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2821),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(2105),
    [sym_preproc_endregion] = STATE(2105),
    [sym_preproc_line] = STATE(2105),
    [sym_preproc_pragma] = STATE(2105),
    [sym_preproc_nullable] = STATE(2105),
    [sym_preproc_error] = STATE(2105),
    [sym_preproc_define] = STATE(2105),
    [sym_preproc_undef] = STATE(2105),
    [aux_sym_class_declaration_repeat1] = STATE(3797),
    [aux_sym_lambda_expression_repeat1] = STATE(4081),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1727),
    [anon_sym_ref] = ACTIONS(1729),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1713),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1733),
    [anon_sym_TILDE] = ACTIONS(1733),
    [anon_sym_PLUS_PLUS] = ACTIONS(1733),
    [anon_sym_DASH_DASH] = ACTIONS(1733),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1731),
    [anon_sym_DASH] = ACTIONS(1731),
    [anon_sym_STAR] = ACTIONS(1735),
    [anon_sym_CARET] = ACTIONS(1733),
    [anon_sym_AMP] = ACTIONS(1733),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1737),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1739),
    [anon_sym_DOT_DOT] = ACTIONS(1741),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [2106] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3921),
    [sym__name] = STATE(6919),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2868),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(6950),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5307),
    [sym_non_lvalue_expression] = STATE(5735),
    [sym_lvalue_expression] = STATE(4054),
    [sym__expression_statement_expression] = STATE(5733),
    [sym_assignment_expression] = STATE(5734),
    [sym_binary_expression] = STATE(5733),
    [sym_postfix_unary_expression] = STATE(5734),
    [sym_prefix_unary_expression] = STATE(5734),
    [sym__pointer_indirection_expression] = STATE(3911),
    [sym_query_expression] = STATE(5733),
    [sym_from_clause] = STATE(7400),
    [sym_conditional_expression] = STATE(5733),
    [sym_conditional_access_expression] = STATE(5733),
    [sym_as_expression] = STATE(5733),
    [sym_is_expression] = STATE(5733),
    [sym_is_pattern_expression] = STATE(5733),
    [sym_cast_expression] = STATE(5733),
    [sym_checked_expression] = STATE(5733),
    [sym_invocation_expression] = STATE(5734),
    [sym_switch_expression] = STATE(5733),
    [sym_await_expression] = STATE(5734),
    [sym_throw_expression] = STATE(5733),
    [sym_element_access_expression] = STATE(3911),
    [sym_interpolated_string_expression] = STATE(5733),
    [sym_member_access_expression] = STATE(3911),
    [sym_object_creation_expression] = STATE(5734),
    [sym_parenthesized_expression] = STATE(5734),
    [sym__parenthesized_lvalue_expression] = STATE(3911),
    [sym_lambda_expression] = STATE(5733),
    [sym__lambda_parameters] = STATE(9693),
    [sym_array_creation_expression] = STATE(5733),
    [sym_anonymous_method_expression] = STATE(5733),
    [sym_anonymous_object_creation_expression] = STATE(5733),
    [sym_implicit_array_creation_expression] = STATE(5733),
    [sym_implicit_object_creation_expression] = STATE(5733),
    [sym_implicit_stackalloc_expression] = STATE(5733),
    [sym_initializer_expression] = STATE(5733),
    [sym_default_expression] = STATE(5733),
    [sym_with_expression] = STATE(5733),
    [sym_sizeof_expression] = STATE(5733),
    [sym_typeof_expression] = STATE(5733),
    [sym_makeref_expression] = STATE(5733),
    [sym_ref_expression] = STATE(5733),
    [sym_reftype_expression] = STATE(5733),
    [sym_refvalue_expression] = STATE(5733),
    [sym_stackalloc_expression] = STATE(5733),
    [sym_range_expression] = STATE(5733),
    [sym_tuple_expression] = STATE(3911),
    [sym_literal] = STATE(5733),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2798),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(5733),
    [sym_preproc_region] = STATE(2106),
    [sym_preproc_endregion] = STATE(2106),
    [sym_preproc_line] = STATE(2106),
    [sym_preproc_pragma] = STATE(2106),
    [sym_preproc_nullable] = STATE(2106),
    [sym_preproc_error] = STATE(2106),
    [sym_preproc_define] = STATE(2106),
    [sym_preproc_undef] = STATE(2106),
    [aux_sym_class_declaration_repeat1] = STATE(3791),
    [aux_sym_lambda_expression_repeat1] = STATE(4075),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_LPAREN] = ACTIONS(1373),
    [anon_sym_ref] = ACTIONS(1375),
    [anon_sym_LBRACE] = ACTIONS(1377),
    [anon_sym_delegate] = ACTIONS(1379),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1381),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1387),
    [anon_sym_TILDE] = ACTIONS(1387),
    [anon_sym_PLUS_PLUS] = ACTIONS(1387),
    [anon_sym_DASH_DASH] = ACTIONS(1387),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1385),
    [anon_sym_DASH] = ACTIONS(1385),
    [anon_sym_STAR] = ACTIONS(1391),
    [anon_sym_CARET] = ACTIONS(1387),
    [anon_sym_AMP] = ACTIONS(1387),
    [anon_sym_this] = ACTIONS(1393),
    [anon_sym_scoped] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1397),
    [sym_predefined_type] = ACTIONS(1399),
    [anon_sym_unchecked] = ACTIONS(1383),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1403),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1405),
    [anon_sym_DOT_DOT] = ACTIONS(1407),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_stackalloc] = ACTIONS(1413),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(1419),
    [anon_sym___reftype] = ACTIONS(1421),
    [anon_sym___refvalue] = ACTIONS(1423),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
  },
  [2107] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7064),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5191),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(3866),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7382),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9762),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(2107),
    [sym_preproc_endregion] = STATE(2107),
    [sym_preproc_line] = STATE(2107),
    [sym_preproc_pragma] = STATE(2107),
    [sym_preproc_nullable] = STATE(2107),
    [sym_preproc_error] = STATE(2107),
    [sym_preproc_define] = STATE(2107),
    [sym_preproc_undef] = STATE(2107),
    [aux_sym_class_declaration_repeat1] = STATE(3842),
    [aux_sym_lambda_expression_repeat1] = STATE(4280),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1351),
    [anon_sym_ref] = ACTIONS(1353),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1357),
    [anon_sym_TILDE] = ACTIONS(1357),
    [anon_sym_PLUS_PLUS] = ACTIONS(1357),
    [anon_sym_DASH_DASH] = ACTIONS(1357),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1355),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(1357),
    [anon_sym_AMP] = ACTIONS(1357),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1361),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1363),
    [anon_sym_DOT_DOT] = ACTIONS(1365),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [2108] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3921),
    [sym__name] = STATE(6919),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2868),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(6950),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5309),
    [sym_non_lvalue_expression] = STATE(5735),
    [sym_lvalue_expression] = STATE(4054),
    [sym__expression_statement_expression] = STATE(5733),
    [sym_assignment_expression] = STATE(5734),
    [sym_binary_expression] = STATE(5733),
    [sym_postfix_unary_expression] = STATE(5734),
    [sym_prefix_unary_expression] = STATE(5734),
    [sym__pointer_indirection_expression] = STATE(3911),
    [sym_query_expression] = STATE(5733),
    [sym_from_clause] = STATE(7400),
    [sym_conditional_expression] = STATE(5733),
    [sym_conditional_access_expression] = STATE(5733),
    [sym_as_expression] = STATE(5733),
    [sym_is_expression] = STATE(5733),
    [sym_is_pattern_expression] = STATE(5733),
    [sym_cast_expression] = STATE(5733),
    [sym_checked_expression] = STATE(5733),
    [sym_invocation_expression] = STATE(5734),
    [sym_switch_expression] = STATE(5733),
    [sym_await_expression] = STATE(5734),
    [sym_throw_expression] = STATE(5733),
    [sym_element_access_expression] = STATE(3911),
    [sym_interpolated_string_expression] = STATE(5733),
    [sym_member_access_expression] = STATE(3911),
    [sym_object_creation_expression] = STATE(5734),
    [sym_parenthesized_expression] = STATE(5734),
    [sym__parenthesized_lvalue_expression] = STATE(3911),
    [sym_lambda_expression] = STATE(5733),
    [sym__lambda_parameters] = STATE(9693),
    [sym_array_creation_expression] = STATE(5733),
    [sym_anonymous_method_expression] = STATE(5733),
    [sym_anonymous_object_creation_expression] = STATE(5733),
    [sym_implicit_array_creation_expression] = STATE(5733),
    [sym_implicit_object_creation_expression] = STATE(5733),
    [sym_implicit_stackalloc_expression] = STATE(5733),
    [sym_initializer_expression] = STATE(5733),
    [sym_default_expression] = STATE(5733),
    [sym_with_expression] = STATE(5733),
    [sym_sizeof_expression] = STATE(5733),
    [sym_typeof_expression] = STATE(5733),
    [sym_makeref_expression] = STATE(5733),
    [sym_ref_expression] = STATE(5733),
    [sym_reftype_expression] = STATE(5733),
    [sym_refvalue_expression] = STATE(5733),
    [sym_stackalloc_expression] = STATE(5733),
    [sym_range_expression] = STATE(5733),
    [sym_tuple_expression] = STATE(3911),
    [sym_literal] = STATE(5733),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2798),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(5733),
    [sym_preproc_region] = STATE(2108),
    [sym_preproc_endregion] = STATE(2108),
    [sym_preproc_line] = STATE(2108),
    [sym_preproc_pragma] = STATE(2108),
    [sym_preproc_nullable] = STATE(2108),
    [sym_preproc_error] = STATE(2108),
    [sym_preproc_define] = STATE(2108),
    [sym_preproc_undef] = STATE(2108),
    [aux_sym_class_declaration_repeat1] = STATE(3791),
    [aux_sym_lambda_expression_repeat1] = STATE(4075),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_LPAREN] = ACTIONS(1373),
    [anon_sym_ref] = ACTIONS(1375),
    [anon_sym_LBRACE] = ACTIONS(1377),
    [anon_sym_delegate] = ACTIONS(1379),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1381),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1387),
    [anon_sym_TILDE] = ACTIONS(1387),
    [anon_sym_PLUS_PLUS] = ACTIONS(1387),
    [anon_sym_DASH_DASH] = ACTIONS(1387),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1385),
    [anon_sym_DASH] = ACTIONS(1385),
    [anon_sym_STAR] = ACTIONS(1391),
    [anon_sym_CARET] = ACTIONS(1387),
    [anon_sym_AMP] = ACTIONS(1387),
    [anon_sym_this] = ACTIONS(1393),
    [anon_sym_scoped] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1397),
    [sym_predefined_type] = ACTIONS(1399),
    [anon_sym_unchecked] = ACTIONS(1383),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1403),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1405),
    [anon_sym_DOT_DOT] = ACTIONS(1407),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_stackalloc] = ACTIONS(1413),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(1419),
    [anon_sym___reftype] = ACTIONS(1421),
    [anon_sym___refvalue] = ACTIONS(1423),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
  },
  [2109] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7064),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5193),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(3866),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7382),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9762),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(2109),
    [sym_preproc_endregion] = STATE(2109),
    [sym_preproc_line] = STATE(2109),
    [sym_preproc_pragma] = STATE(2109),
    [sym_preproc_nullable] = STATE(2109),
    [sym_preproc_error] = STATE(2109),
    [sym_preproc_define] = STATE(2109),
    [sym_preproc_undef] = STATE(2109),
    [aux_sym_class_declaration_repeat1] = STATE(3842),
    [aux_sym_lambda_expression_repeat1] = STATE(4280),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1351),
    [anon_sym_ref] = ACTIONS(1353),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1357),
    [anon_sym_TILDE] = ACTIONS(1357),
    [anon_sym_PLUS_PLUS] = ACTIONS(1357),
    [anon_sym_DASH_DASH] = ACTIONS(1357),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1355),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(1357),
    [anon_sym_AMP] = ACTIONS(1357),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1361),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1363),
    [anon_sym_DOT_DOT] = ACTIONS(1365),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [2110] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7064),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5196),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(3866),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7382),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9762),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(2110),
    [sym_preproc_endregion] = STATE(2110),
    [sym_preproc_line] = STATE(2110),
    [sym_preproc_pragma] = STATE(2110),
    [sym_preproc_nullable] = STATE(2110),
    [sym_preproc_error] = STATE(2110),
    [sym_preproc_define] = STATE(2110),
    [sym_preproc_undef] = STATE(2110),
    [aux_sym_class_declaration_repeat1] = STATE(3842),
    [aux_sym_lambda_expression_repeat1] = STATE(4280),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1351),
    [anon_sym_ref] = ACTIONS(1353),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1357),
    [anon_sym_TILDE] = ACTIONS(1357),
    [anon_sym_PLUS_PLUS] = ACTIONS(1357),
    [anon_sym_DASH_DASH] = ACTIONS(1357),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1355),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(1357),
    [anon_sym_AMP] = ACTIONS(1357),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1361),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1363),
    [anon_sym_DOT_DOT] = ACTIONS(1365),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [2111] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7064),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5197),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(3866),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7382),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9762),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(2111),
    [sym_preproc_endregion] = STATE(2111),
    [sym_preproc_line] = STATE(2111),
    [sym_preproc_pragma] = STATE(2111),
    [sym_preproc_nullable] = STATE(2111),
    [sym_preproc_error] = STATE(2111),
    [sym_preproc_define] = STATE(2111),
    [sym_preproc_undef] = STATE(2111),
    [aux_sym_class_declaration_repeat1] = STATE(3842),
    [aux_sym_lambda_expression_repeat1] = STATE(4280),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1351),
    [anon_sym_ref] = ACTIONS(1353),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1357),
    [anon_sym_TILDE] = ACTIONS(1357),
    [anon_sym_PLUS_PLUS] = ACTIONS(1357),
    [anon_sym_DASH_DASH] = ACTIONS(1357),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1355),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(1357),
    [anon_sym_AMP] = ACTIONS(1357),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1361),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1363),
    [anon_sym_DOT_DOT] = ACTIONS(1365),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [2112] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7064),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5198),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(3866),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7382),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9762),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(2112),
    [sym_preproc_endregion] = STATE(2112),
    [sym_preproc_line] = STATE(2112),
    [sym_preproc_pragma] = STATE(2112),
    [sym_preproc_nullable] = STATE(2112),
    [sym_preproc_error] = STATE(2112),
    [sym_preproc_define] = STATE(2112),
    [sym_preproc_undef] = STATE(2112),
    [aux_sym_class_declaration_repeat1] = STATE(3842),
    [aux_sym_lambda_expression_repeat1] = STATE(4280),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1351),
    [anon_sym_ref] = ACTIONS(1353),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1357),
    [anon_sym_TILDE] = ACTIONS(1357),
    [anon_sym_PLUS_PLUS] = ACTIONS(1357),
    [anon_sym_DASH_DASH] = ACTIONS(1357),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1355),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(1357),
    [anon_sym_AMP] = ACTIONS(1357),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1361),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1363),
    [anon_sym_DOT_DOT] = ACTIONS(1365),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [2113] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7064),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5199),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(3866),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7382),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9762),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(2113),
    [sym_preproc_endregion] = STATE(2113),
    [sym_preproc_line] = STATE(2113),
    [sym_preproc_pragma] = STATE(2113),
    [sym_preproc_nullable] = STATE(2113),
    [sym_preproc_error] = STATE(2113),
    [sym_preproc_define] = STATE(2113),
    [sym_preproc_undef] = STATE(2113),
    [aux_sym_class_declaration_repeat1] = STATE(3842),
    [aux_sym_lambda_expression_repeat1] = STATE(4280),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1351),
    [anon_sym_ref] = ACTIONS(1353),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1357),
    [anon_sym_TILDE] = ACTIONS(1357),
    [anon_sym_PLUS_PLUS] = ACTIONS(1357),
    [anon_sym_DASH_DASH] = ACTIONS(1357),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1355),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(1357),
    [anon_sym_AMP] = ACTIONS(1357),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1361),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1363),
    [anon_sym_DOT_DOT] = ACTIONS(1365),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [2114] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7064),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5200),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(3866),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7382),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9762),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(2114),
    [sym_preproc_endregion] = STATE(2114),
    [sym_preproc_line] = STATE(2114),
    [sym_preproc_pragma] = STATE(2114),
    [sym_preproc_nullable] = STATE(2114),
    [sym_preproc_error] = STATE(2114),
    [sym_preproc_define] = STATE(2114),
    [sym_preproc_undef] = STATE(2114),
    [aux_sym_class_declaration_repeat1] = STATE(3842),
    [aux_sym_lambda_expression_repeat1] = STATE(4280),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1351),
    [anon_sym_ref] = ACTIONS(1353),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1357),
    [anon_sym_TILDE] = ACTIONS(1357),
    [anon_sym_PLUS_PLUS] = ACTIONS(1357),
    [anon_sym_DASH_DASH] = ACTIONS(1357),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1355),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(1357),
    [anon_sym_AMP] = ACTIONS(1357),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1361),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1363),
    [anon_sym_DOT_DOT] = ACTIONS(1365),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [2115] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7064),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5202),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(3866),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7382),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9762),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(2115),
    [sym_preproc_endregion] = STATE(2115),
    [sym_preproc_line] = STATE(2115),
    [sym_preproc_pragma] = STATE(2115),
    [sym_preproc_nullable] = STATE(2115),
    [sym_preproc_error] = STATE(2115),
    [sym_preproc_define] = STATE(2115),
    [sym_preproc_undef] = STATE(2115),
    [aux_sym_class_declaration_repeat1] = STATE(3842),
    [aux_sym_lambda_expression_repeat1] = STATE(4280),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1351),
    [anon_sym_ref] = ACTIONS(1353),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1357),
    [anon_sym_TILDE] = ACTIONS(1357),
    [anon_sym_PLUS_PLUS] = ACTIONS(1357),
    [anon_sym_DASH_DASH] = ACTIONS(1357),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1355),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(1357),
    [anon_sym_AMP] = ACTIONS(1357),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1361),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1363),
    [anon_sym_DOT_DOT] = ACTIONS(1365),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [2116] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3559),
    [sym__name] = STATE(6877),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2908),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7129),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4358),
    [sym_non_lvalue_expression] = STATE(4553),
    [sym_lvalue_expression] = STATE(3561),
    [sym__expression_statement_expression] = STATE(4559),
    [sym_assignment_expression] = STATE(4558),
    [sym_binary_expression] = STATE(4559),
    [sym_postfix_unary_expression] = STATE(4558),
    [sym_prefix_unary_expression] = STATE(4558),
    [sym__pointer_indirection_expression] = STATE(3560),
    [sym_query_expression] = STATE(4559),
    [sym_from_clause] = STATE(7385),
    [sym_conditional_expression] = STATE(4559),
    [sym_conditional_access_expression] = STATE(4559),
    [sym_as_expression] = STATE(4559),
    [sym_is_expression] = STATE(4559),
    [sym_is_pattern_expression] = STATE(4559),
    [sym_cast_expression] = STATE(4559),
    [sym_checked_expression] = STATE(4559),
    [sym_invocation_expression] = STATE(4558),
    [sym_switch_expression] = STATE(4559),
    [sym_await_expression] = STATE(4558),
    [sym_throw_expression] = STATE(4559),
    [sym_element_access_expression] = STATE(3560),
    [sym_interpolated_string_expression] = STATE(4559),
    [sym_member_access_expression] = STATE(3560),
    [sym_object_creation_expression] = STATE(4558),
    [sym_parenthesized_expression] = STATE(4558),
    [sym__parenthesized_lvalue_expression] = STATE(3560),
    [sym_lambda_expression] = STATE(4559),
    [sym__lambda_parameters] = STATE(9776),
    [sym_array_creation_expression] = STATE(4559),
    [sym_anonymous_method_expression] = STATE(4559),
    [sym_anonymous_object_creation_expression] = STATE(4559),
    [sym_implicit_array_creation_expression] = STATE(4559),
    [sym_implicit_object_creation_expression] = STATE(4559),
    [sym_implicit_stackalloc_expression] = STATE(4559),
    [sym_initializer_expression] = STATE(4559),
    [sym_default_expression] = STATE(4559),
    [sym_with_expression] = STATE(4559),
    [sym_sizeof_expression] = STATE(4559),
    [sym_typeof_expression] = STATE(4559),
    [sym_makeref_expression] = STATE(4559),
    [sym_ref_expression] = STATE(4559),
    [sym_reftype_expression] = STATE(4559),
    [sym_refvalue_expression] = STATE(4559),
    [sym_stackalloc_expression] = STATE(4559),
    [sym_range_expression] = STATE(4559),
    [sym_tuple_expression] = STATE(3560),
    [sym_literal] = STATE(4559),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4559),
    [sym_preproc_region] = STATE(2116),
    [sym_preproc_endregion] = STATE(2116),
    [sym_preproc_line] = STATE(2116),
    [sym_preproc_pragma] = STATE(2116),
    [sym_preproc_nullable] = STATE(2116),
    [sym_preproc_error] = STATE(2116),
    [sym_preproc_define] = STATE(2116),
    [sym_preproc_undef] = STATE(2116),
    [aux_sym_class_declaration_repeat1] = STATE(3843),
    [aux_sym_lambda_expression_repeat1] = STATE(4277),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(1675),
    [anon_sym_ref] = ACTIONS(1677),
    [anon_sym_LBRACE] = ACTIONS(1611),
    [anon_sym_delegate] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1679),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(1683),
    [anon_sym_TILDE] = ACTIONS(1683),
    [anon_sym_PLUS_PLUS] = ACTIONS(1683),
    [anon_sym_DASH_DASH] = ACTIONS(1683),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_DASH] = ACTIONS(1681),
    [anon_sym_STAR] = ACTIONS(1685),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1683),
    [anon_sym_this] = ACTIONS(1627),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1629),
    [anon_sym_unchecked] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(1687),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1689),
    [anon_sym_DOT_DOT] = ACTIONS(1691),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_stackalloc] = ACTIONS(1641),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(1647),
    [anon_sym___reftype] = ACTIONS(1649),
    [anon_sym___refvalue] = ACTIONS(1651),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1659),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [2117] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7064),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5203),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(3866),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7382),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9762),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(2117),
    [sym_preproc_endregion] = STATE(2117),
    [sym_preproc_line] = STATE(2117),
    [sym_preproc_pragma] = STATE(2117),
    [sym_preproc_nullable] = STATE(2117),
    [sym_preproc_error] = STATE(2117),
    [sym_preproc_define] = STATE(2117),
    [sym_preproc_undef] = STATE(2117),
    [aux_sym_class_declaration_repeat1] = STATE(3842),
    [aux_sym_lambda_expression_repeat1] = STATE(4280),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1351),
    [anon_sym_ref] = ACTIONS(1353),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1357),
    [anon_sym_TILDE] = ACTIONS(1357),
    [anon_sym_PLUS_PLUS] = ACTIONS(1357),
    [anon_sym_DASH_DASH] = ACTIONS(1357),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1355),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(1357),
    [anon_sym_AMP] = ACTIONS(1357),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1361),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1363),
    [anon_sym_DOT_DOT] = ACTIONS(1365),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [2118] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7064),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5204),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(3866),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7382),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9762),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(2118),
    [sym_preproc_endregion] = STATE(2118),
    [sym_preproc_line] = STATE(2118),
    [sym_preproc_pragma] = STATE(2118),
    [sym_preproc_nullable] = STATE(2118),
    [sym_preproc_error] = STATE(2118),
    [sym_preproc_define] = STATE(2118),
    [sym_preproc_undef] = STATE(2118),
    [aux_sym_class_declaration_repeat1] = STATE(3842),
    [aux_sym_lambda_expression_repeat1] = STATE(4280),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1351),
    [anon_sym_ref] = ACTIONS(1353),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1357),
    [anon_sym_TILDE] = ACTIONS(1357),
    [anon_sym_PLUS_PLUS] = ACTIONS(1357),
    [anon_sym_DASH_DASH] = ACTIONS(1357),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1355),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(1357),
    [anon_sym_AMP] = ACTIONS(1357),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1361),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1363),
    [anon_sym_DOT_DOT] = ACTIONS(1365),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [2119] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7064),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5206),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(3866),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7382),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9762),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(2119),
    [sym_preproc_endregion] = STATE(2119),
    [sym_preproc_line] = STATE(2119),
    [sym_preproc_pragma] = STATE(2119),
    [sym_preproc_nullable] = STATE(2119),
    [sym_preproc_error] = STATE(2119),
    [sym_preproc_define] = STATE(2119),
    [sym_preproc_undef] = STATE(2119),
    [aux_sym_class_declaration_repeat1] = STATE(3842),
    [aux_sym_lambda_expression_repeat1] = STATE(4280),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1351),
    [anon_sym_ref] = ACTIONS(1353),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1357),
    [anon_sym_TILDE] = ACTIONS(1357),
    [anon_sym_PLUS_PLUS] = ACTIONS(1357),
    [anon_sym_DASH_DASH] = ACTIONS(1357),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1355),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(1357),
    [anon_sym_AMP] = ACTIONS(1357),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1361),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1363),
    [anon_sym_DOT_DOT] = ACTIONS(1365),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [2120] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3921),
    [sym__name] = STATE(6889),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2854),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(7061),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5167),
    [sym_non_lvalue_expression] = STATE(5735),
    [sym_lvalue_expression] = STATE(3899),
    [sym__expression_statement_expression] = STATE(5733),
    [sym_assignment_expression] = STATE(5734),
    [sym_binary_expression] = STATE(5733),
    [sym_postfix_unary_expression] = STATE(5734),
    [sym_prefix_unary_expression] = STATE(5734),
    [sym__pointer_indirection_expression] = STATE(3911),
    [sym_query_expression] = STATE(5733),
    [sym_from_clause] = STATE(7400),
    [sym_conditional_expression] = STATE(5733),
    [sym_conditional_access_expression] = STATE(5733),
    [sym_as_expression] = STATE(5733),
    [sym_is_expression] = STATE(5733),
    [sym_is_pattern_expression] = STATE(5733),
    [sym_cast_expression] = STATE(5733),
    [sym_checked_expression] = STATE(5733),
    [sym_invocation_expression] = STATE(5734),
    [sym_switch_expression] = STATE(5733),
    [sym_await_expression] = STATE(5734),
    [sym_throw_expression] = STATE(5733),
    [sym_element_access_expression] = STATE(3911),
    [sym_interpolated_string_expression] = STATE(5733),
    [sym_member_access_expression] = STATE(3911),
    [sym_object_creation_expression] = STATE(5734),
    [sym_parenthesized_expression] = STATE(5734),
    [sym__parenthesized_lvalue_expression] = STATE(3911),
    [sym_lambda_expression] = STATE(5733),
    [sym__lambda_parameters] = STATE(9790),
    [sym_array_creation_expression] = STATE(5733),
    [sym_anonymous_method_expression] = STATE(5733),
    [sym_anonymous_object_creation_expression] = STATE(5733),
    [sym_implicit_array_creation_expression] = STATE(5733),
    [sym_implicit_object_creation_expression] = STATE(5733),
    [sym_implicit_stackalloc_expression] = STATE(5733),
    [sym_initializer_expression] = STATE(5733),
    [sym_default_expression] = STATE(5733),
    [sym_with_expression] = STATE(5733),
    [sym_sizeof_expression] = STATE(5733),
    [sym_typeof_expression] = STATE(5733),
    [sym_makeref_expression] = STATE(5733),
    [sym_ref_expression] = STATE(5733),
    [sym_reftype_expression] = STATE(5733),
    [sym_refvalue_expression] = STATE(5733),
    [sym_stackalloc_expression] = STATE(5733),
    [sym_range_expression] = STATE(5733),
    [sym_tuple_expression] = STATE(3911),
    [sym_literal] = STATE(5733),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2798),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(5733),
    [sym_preproc_region] = STATE(2120),
    [sym_preproc_endregion] = STATE(2120),
    [sym_preproc_line] = STATE(2120),
    [sym_preproc_pragma] = STATE(2120),
    [sym_preproc_nullable] = STATE(2120),
    [sym_preproc_error] = STATE(2120),
    [sym_preproc_define] = STATE(2120),
    [sym_preproc_undef] = STATE(2120),
    [aux_sym_class_declaration_repeat1] = STATE(3833),
    [aux_sym_lambda_expression_repeat1] = STATE(4182),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_LPAREN] = ACTIONS(1439),
    [anon_sym_ref] = ACTIONS(1441),
    [anon_sym_LBRACE] = ACTIONS(1377),
    [anon_sym_delegate] = ACTIONS(1379),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1443),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1447),
    [anon_sym_TILDE] = ACTIONS(1447),
    [anon_sym_PLUS_PLUS] = ACTIONS(1447),
    [anon_sym_DASH_DASH] = ACTIONS(1447),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1445),
    [anon_sym_DASH] = ACTIONS(1445),
    [anon_sym_STAR] = ACTIONS(1449),
    [anon_sym_CARET] = ACTIONS(1447),
    [anon_sym_AMP] = ACTIONS(1447),
    [anon_sym_this] = ACTIONS(1393),
    [anon_sym_scoped] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1397),
    [sym_predefined_type] = ACTIONS(1399),
    [anon_sym_unchecked] = ACTIONS(1383),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1451),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1453),
    [anon_sym_DOT_DOT] = ACTIONS(1455),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_stackalloc] = ACTIONS(1413),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(1419),
    [anon_sym___reftype] = ACTIONS(1421),
    [anon_sym___refvalue] = ACTIONS(1423),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
  },
  [2121] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3559),
    [sym__name] = STATE(6877),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2908),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6958),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4549),
    [sym_non_lvalue_expression] = STATE(4553),
    [sym_lvalue_expression] = STATE(3691),
    [sym__expression_statement_expression] = STATE(4559),
    [sym_assignment_expression] = STATE(4558),
    [sym_binary_expression] = STATE(4559),
    [sym_postfix_unary_expression] = STATE(4558),
    [sym_prefix_unary_expression] = STATE(4558),
    [sym__pointer_indirection_expression] = STATE(3560),
    [sym_query_expression] = STATE(4559),
    [sym_from_clause] = STATE(7406),
    [sym_conditional_expression] = STATE(4559),
    [sym_conditional_access_expression] = STATE(4559),
    [sym_as_expression] = STATE(4559),
    [sym_is_expression] = STATE(4559),
    [sym_is_pattern_expression] = STATE(4559),
    [sym_cast_expression] = STATE(4559),
    [sym_checked_expression] = STATE(4559),
    [sym_invocation_expression] = STATE(4558),
    [sym_switch_expression] = STATE(4559),
    [sym_await_expression] = STATE(4558),
    [sym_throw_expression] = STATE(4559),
    [sym_element_access_expression] = STATE(3560),
    [sym_interpolated_string_expression] = STATE(4559),
    [sym_member_access_expression] = STATE(3560),
    [sym_object_creation_expression] = STATE(4558),
    [sym_parenthesized_expression] = STATE(4558),
    [sym__parenthesized_lvalue_expression] = STATE(3560),
    [sym_lambda_expression] = STATE(4559),
    [sym__lambda_parameters] = STATE(9348),
    [sym_array_creation_expression] = STATE(4559),
    [sym_anonymous_method_expression] = STATE(4559),
    [sym_anonymous_object_creation_expression] = STATE(4559),
    [sym_implicit_array_creation_expression] = STATE(4559),
    [sym_implicit_object_creation_expression] = STATE(4559),
    [sym_implicit_stackalloc_expression] = STATE(4559),
    [sym_initializer_expression] = STATE(4559),
    [sym_default_expression] = STATE(4559),
    [sym_with_expression] = STATE(4559),
    [sym_sizeof_expression] = STATE(4559),
    [sym_typeof_expression] = STATE(4559),
    [sym_makeref_expression] = STATE(4559),
    [sym_ref_expression] = STATE(4559),
    [sym_reftype_expression] = STATE(4559),
    [sym_refvalue_expression] = STATE(4559),
    [sym_stackalloc_expression] = STATE(4559),
    [sym_range_expression] = STATE(4559),
    [sym_tuple_expression] = STATE(3560),
    [sym_literal] = STATE(4559),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4559),
    [sym_preproc_region] = STATE(2121),
    [sym_preproc_endregion] = STATE(2121),
    [sym_preproc_line] = STATE(2121),
    [sym_preproc_pragma] = STATE(2121),
    [sym_preproc_nullable] = STATE(2121),
    [sym_preproc_error] = STATE(2121),
    [sym_preproc_define] = STATE(2121),
    [sym_preproc_undef] = STATE(2121),
    [aux_sym_class_declaration_repeat1] = STATE(3810),
    [aux_sym_lambda_expression_repeat1] = STATE(4141),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(2047),
    [anon_sym_ref] = ACTIONS(2049),
    [anon_sym_LBRACE] = ACTIONS(1611),
    [anon_sym_delegate] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1679),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(2053),
    [anon_sym_TILDE] = ACTIONS(2053),
    [anon_sym_PLUS_PLUS] = ACTIONS(2053),
    [anon_sym_DASH_DASH] = ACTIONS(2053),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(2051),
    [anon_sym_DASH] = ACTIONS(2051),
    [anon_sym_STAR] = ACTIONS(1685),
    [anon_sym_CARET] = ACTIONS(2053),
    [anon_sym_AMP] = ACTIONS(2053),
    [anon_sym_this] = ACTIONS(1627),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1629),
    [anon_sym_unchecked] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(2055),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2057),
    [anon_sym_DOT_DOT] = ACTIONS(2059),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_stackalloc] = ACTIONS(1641),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(1647),
    [anon_sym___reftype] = ACTIONS(1649),
    [anon_sym___refvalue] = ACTIONS(1651),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1659),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [2122] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3559),
    [sym__name] = STATE(6877),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2908),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6958),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4550),
    [sym_non_lvalue_expression] = STATE(4553),
    [sym_lvalue_expression] = STATE(3691),
    [sym__expression_statement_expression] = STATE(4559),
    [sym_assignment_expression] = STATE(4558),
    [sym_binary_expression] = STATE(4559),
    [sym_postfix_unary_expression] = STATE(4558),
    [sym_prefix_unary_expression] = STATE(4558),
    [sym__pointer_indirection_expression] = STATE(3560),
    [sym_query_expression] = STATE(4559),
    [sym_from_clause] = STATE(7406),
    [sym_conditional_expression] = STATE(4559),
    [sym_conditional_access_expression] = STATE(4559),
    [sym_as_expression] = STATE(4559),
    [sym_is_expression] = STATE(4559),
    [sym_is_pattern_expression] = STATE(4559),
    [sym_cast_expression] = STATE(4559),
    [sym_checked_expression] = STATE(4559),
    [sym_invocation_expression] = STATE(4558),
    [sym_switch_expression] = STATE(4559),
    [sym_await_expression] = STATE(4558),
    [sym_throw_expression] = STATE(4559),
    [sym_element_access_expression] = STATE(3560),
    [sym_interpolated_string_expression] = STATE(4559),
    [sym_member_access_expression] = STATE(3560),
    [sym_object_creation_expression] = STATE(4558),
    [sym_parenthesized_expression] = STATE(4558),
    [sym__parenthesized_lvalue_expression] = STATE(3560),
    [sym_lambda_expression] = STATE(4559),
    [sym__lambda_parameters] = STATE(9348),
    [sym_array_creation_expression] = STATE(4559),
    [sym_anonymous_method_expression] = STATE(4559),
    [sym_anonymous_object_creation_expression] = STATE(4559),
    [sym_implicit_array_creation_expression] = STATE(4559),
    [sym_implicit_object_creation_expression] = STATE(4559),
    [sym_implicit_stackalloc_expression] = STATE(4559),
    [sym_initializer_expression] = STATE(4559),
    [sym_default_expression] = STATE(4559),
    [sym_with_expression] = STATE(4559),
    [sym_sizeof_expression] = STATE(4559),
    [sym_typeof_expression] = STATE(4559),
    [sym_makeref_expression] = STATE(4559),
    [sym_ref_expression] = STATE(4559),
    [sym_reftype_expression] = STATE(4559),
    [sym_refvalue_expression] = STATE(4559),
    [sym_stackalloc_expression] = STATE(4559),
    [sym_range_expression] = STATE(4559),
    [sym_tuple_expression] = STATE(3560),
    [sym_literal] = STATE(4559),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4559),
    [sym_preproc_region] = STATE(2122),
    [sym_preproc_endregion] = STATE(2122),
    [sym_preproc_line] = STATE(2122),
    [sym_preproc_pragma] = STATE(2122),
    [sym_preproc_nullable] = STATE(2122),
    [sym_preproc_error] = STATE(2122),
    [sym_preproc_define] = STATE(2122),
    [sym_preproc_undef] = STATE(2122),
    [aux_sym_class_declaration_repeat1] = STATE(3810),
    [aux_sym_lambda_expression_repeat1] = STATE(4141),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(2047),
    [anon_sym_ref] = ACTIONS(2049),
    [anon_sym_LBRACE] = ACTIONS(1611),
    [anon_sym_delegate] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1679),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(2053),
    [anon_sym_TILDE] = ACTIONS(2053),
    [anon_sym_PLUS_PLUS] = ACTIONS(2053),
    [anon_sym_DASH_DASH] = ACTIONS(2053),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(2051),
    [anon_sym_DASH] = ACTIONS(2051),
    [anon_sym_STAR] = ACTIONS(1685),
    [anon_sym_CARET] = ACTIONS(2053),
    [anon_sym_AMP] = ACTIONS(2053),
    [anon_sym_this] = ACTIONS(1627),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1629),
    [anon_sym_unchecked] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(2055),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2057),
    [anon_sym_DOT_DOT] = ACTIONS(2059),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_stackalloc] = ACTIONS(1641),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(1647),
    [anon_sym___reftype] = ACTIONS(1649),
    [anon_sym___refvalue] = ACTIONS(1651),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1659),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [2123] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6910),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2957),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7089),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5058),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(3796),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7395),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9374),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(2123),
    [sym_preproc_endregion] = STATE(2123),
    [sym_preproc_line] = STATE(2123),
    [sym_preproc_pragma] = STATE(2123),
    [sym_preproc_nullable] = STATE(2123),
    [sym_preproc_error] = STATE(2123),
    [sym_preproc_define] = STATE(2123),
    [sym_preproc_undef] = STATE(2123),
    [aux_sym_class_declaration_repeat1] = STATE(3839),
    [aux_sym_lambda_expression_repeat1] = STATE(4209),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(2139),
    [anon_sym_ref] = ACTIONS(2141),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1799),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(2145),
    [anon_sym_TILDE] = ACTIONS(2145),
    [anon_sym_PLUS_PLUS] = ACTIONS(2145),
    [anon_sym_DASH_DASH] = ACTIONS(2145),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(2143),
    [anon_sym_DASH] = ACTIONS(2143),
    [anon_sym_STAR] = ACTIONS(1805),
    [anon_sym_CARET] = ACTIONS(2145),
    [anon_sym_AMP] = ACTIONS(2145),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(2147),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2149),
    [anon_sym_DOT_DOT] = ACTIONS(2151),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [2124] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3559),
    [sym__name] = STATE(6877),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2908),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6958),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4551),
    [sym_non_lvalue_expression] = STATE(4553),
    [sym_lvalue_expression] = STATE(3691),
    [sym__expression_statement_expression] = STATE(4559),
    [sym_assignment_expression] = STATE(4558),
    [sym_binary_expression] = STATE(4559),
    [sym_postfix_unary_expression] = STATE(4558),
    [sym_prefix_unary_expression] = STATE(4558),
    [sym__pointer_indirection_expression] = STATE(3560),
    [sym_query_expression] = STATE(4559),
    [sym_from_clause] = STATE(7406),
    [sym_conditional_expression] = STATE(4559),
    [sym_conditional_access_expression] = STATE(4559),
    [sym_as_expression] = STATE(4559),
    [sym_is_expression] = STATE(4559),
    [sym_is_pattern_expression] = STATE(4559),
    [sym_cast_expression] = STATE(4559),
    [sym_checked_expression] = STATE(4559),
    [sym_invocation_expression] = STATE(4558),
    [sym_switch_expression] = STATE(4559),
    [sym_await_expression] = STATE(4558),
    [sym_throw_expression] = STATE(4559),
    [sym_element_access_expression] = STATE(3560),
    [sym_interpolated_string_expression] = STATE(4559),
    [sym_member_access_expression] = STATE(3560),
    [sym_object_creation_expression] = STATE(4558),
    [sym_parenthesized_expression] = STATE(4558),
    [sym__parenthesized_lvalue_expression] = STATE(3560),
    [sym_lambda_expression] = STATE(4559),
    [sym__lambda_parameters] = STATE(9348),
    [sym_array_creation_expression] = STATE(4559),
    [sym_anonymous_method_expression] = STATE(4559),
    [sym_anonymous_object_creation_expression] = STATE(4559),
    [sym_implicit_array_creation_expression] = STATE(4559),
    [sym_implicit_object_creation_expression] = STATE(4559),
    [sym_implicit_stackalloc_expression] = STATE(4559),
    [sym_initializer_expression] = STATE(4559),
    [sym_default_expression] = STATE(4559),
    [sym_with_expression] = STATE(4559),
    [sym_sizeof_expression] = STATE(4559),
    [sym_typeof_expression] = STATE(4559),
    [sym_makeref_expression] = STATE(4559),
    [sym_ref_expression] = STATE(4559),
    [sym_reftype_expression] = STATE(4559),
    [sym_refvalue_expression] = STATE(4559),
    [sym_stackalloc_expression] = STATE(4559),
    [sym_range_expression] = STATE(4559),
    [sym_tuple_expression] = STATE(3560),
    [sym_literal] = STATE(4559),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4559),
    [sym_preproc_region] = STATE(2124),
    [sym_preproc_endregion] = STATE(2124),
    [sym_preproc_line] = STATE(2124),
    [sym_preproc_pragma] = STATE(2124),
    [sym_preproc_nullable] = STATE(2124),
    [sym_preproc_error] = STATE(2124),
    [sym_preproc_define] = STATE(2124),
    [sym_preproc_undef] = STATE(2124),
    [aux_sym_class_declaration_repeat1] = STATE(3810),
    [aux_sym_lambda_expression_repeat1] = STATE(4141),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(2047),
    [anon_sym_ref] = ACTIONS(2049),
    [anon_sym_LBRACE] = ACTIONS(1611),
    [anon_sym_delegate] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1679),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(2053),
    [anon_sym_TILDE] = ACTIONS(2053),
    [anon_sym_PLUS_PLUS] = ACTIONS(2053),
    [anon_sym_DASH_DASH] = ACTIONS(2053),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(2051),
    [anon_sym_DASH] = ACTIONS(2051),
    [anon_sym_STAR] = ACTIONS(1685),
    [anon_sym_CARET] = ACTIONS(2053),
    [anon_sym_AMP] = ACTIONS(2053),
    [anon_sym_this] = ACTIONS(1627),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1629),
    [anon_sym_unchecked] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(2055),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2057),
    [anon_sym_DOT_DOT] = ACTIONS(2059),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_stackalloc] = ACTIONS(1641),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(1647),
    [anon_sym___reftype] = ACTIONS(1649),
    [anon_sym___refvalue] = ACTIONS(1651),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1659),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [2125] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3921),
    [sym__name] = STATE(6889),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2854),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(6991),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5651),
    [sym_non_lvalue_expression] = STATE(5735),
    [sym_lvalue_expression] = STATE(4295),
    [sym__expression_statement_expression] = STATE(5733),
    [sym_assignment_expression] = STATE(5734),
    [sym_binary_expression] = STATE(5733),
    [sym_postfix_unary_expression] = STATE(5734),
    [sym_prefix_unary_expression] = STATE(5734),
    [sym__pointer_indirection_expression] = STATE(3911),
    [sym_query_expression] = STATE(5733),
    [sym_from_clause] = STATE(7393),
    [sym_conditional_expression] = STATE(5733),
    [sym_conditional_access_expression] = STATE(5733),
    [sym_as_expression] = STATE(5733),
    [sym_is_expression] = STATE(5733),
    [sym_is_pattern_expression] = STATE(5733),
    [sym_cast_expression] = STATE(5733),
    [sym_checked_expression] = STATE(5733),
    [sym_invocation_expression] = STATE(5734),
    [sym_switch_expression] = STATE(5733),
    [sym_await_expression] = STATE(5734),
    [sym_throw_expression] = STATE(5733),
    [sym_element_access_expression] = STATE(3911),
    [sym_interpolated_string_expression] = STATE(5733),
    [sym_member_access_expression] = STATE(3911),
    [sym_object_creation_expression] = STATE(5734),
    [sym_parenthesized_expression] = STATE(5734),
    [sym__parenthesized_lvalue_expression] = STATE(3911),
    [sym_lambda_expression] = STATE(5733),
    [sym__lambda_parameters] = STATE(9313),
    [sym_array_creation_expression] = STATE(5733),
    [sym_anonymous_method_expression] = STATE(5733),
    [sym_anonymous_object_creation_expression] = STATE(5733),
    [sym_implicit_array_creation_expression] = STATE(5733),
    [sym_implicit_object_creation_expression] = STATE(5733),
    [sym_implicit_stackalloc_expression] = STATE(5733),
    [sym_initializer_expression] = STATE(5733),
    [sym_default_expression] = STATE(5733),
    [sym_with_expression] = STATE(5733),
    [sym_sizeof_expression] = STATE(5733),
    [sym_typeof_expression] = STATE(5733),
    [sym_makeref_expression] = STATE(5733),
    [sym_ref_expression] = STATE(5733),
    [sym_reftype_expression] = STATE(5733),
    [sym_refvalue_expression] = STATE(5733),
    [sym_stackalloc_expression] = STATE(5733),
    [sym_range_expression] = STATE(5733),
    [sym_tuple_expression] = STATE(3911),
    [sym_literal] = STATE(5733),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2798),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(5733),
    [sym_preproc_region] = STATE(2125),
    [sym_preproc_endregion] = STATE(2125),
    [sym_preproc_line] = STATE(2125),
    [sym_preproc_pragma] = STATE(2125),
    [sym_preproc_nullable] = STATE(2125),
    [sym_preproc_error] = STATE(2125),
    [sym_preproc_define] = STATE(2125),
    [sym_preproc_undef] = STATE(2125),
    [aux_sym_class_declaration_repeat1] = STATE(3805),
    [aux_sym_lambda_expression_repeat1] = STATE(4122),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_LPAREN] = ACTIONS(1591),
    [anon_sym_ref] = ACTIONS(1593),
    [anon_sym_LBRACE] = ACTIONS(1377),
    [anon_sym_delegate] = ACTIONS(1379),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1443),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1597),
    [anon_sym_TILDE] = ACTIONS(1597),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1595),
    [anon_sym_DASH] = ACTIONS(1595),
    [anon_sym_STAR] = ACTIONS(1449),
    [anon_sym_CARET] = ACTIONS(1597),
    [anon_sym_AMP] = ACTIONS(1597),
    [anon_sym_this] = ACTIONS(1393),
    [anon_sym_scoped] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1397),
    [sym_predefined_type] = ACTIONS(1399),
    [anon_sym_unchecked] = ACTIONS(1383),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1599),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1601),
    [anon_sym_DOT_DOT] = ACTIONS(1603),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_stackalloc] = ACTIONS(1413),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(1419),
    [anon_sym___reftype] = ACTIONS(1421),
    [anon_sym___refvalue] = ACTIONS(1423),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
  },
  [2126] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3559),
    [sym__name] = STATE(6877),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2908),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7129),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4421),
    [sym_non_lvalue_expression] = STATE(4553),
    [sym_lvalue_expression] = STATE(3561),
    [sym__expression_statement_expression] = STATE(4559),
    [sym_assignment_expression] = STATE(4558),
    [sym_binary_expression] = STATE(4559),
    [sym_postfix_unary_expression] = STATE(4558),
    [sym_prefix_unary_expression] = STATE(4558),
    [sym__pointer_indirection_expression] = STATE(3560),
    [sym_query_expression] = STATE(4559),
    [sym_from_clause] = STATE(7385),
    [sym_conditional_expression] = STATE(4559),
    [sym_conditional_access_expression] = STATE(4559),
    [sym_as_expression] = STATE(4559),
    [sym_is_expression] = STATE(4559),
    [sym_is_pattern_expression] = STATE(4559),
    [sym_cast_expression] = STATE(4559),
    [sym_checked_expression] = STATE(4559),
    [sym_invocation_expression] = STATE(4558),
    [sym_switch_expression] = STATE(4559),
    [sym_await_expression] = STATE(4558),
    [sym_throw_expression] = STATE(4559),
    [sym_element_access_expression] = STATE(3560),
    [sym_interpolated_string_expression] = STATE(4559),
    [sym_member_access_expression] = STATE(3560),
    [sym_object_creation_expression] = STATE(4558),
    [sym_parenthesized_expression] = STATE(4558),
    [sym__parenthesized_lvalue_expression] = STATE(3560),
    [sym_lambda_expression] = STATE(4559),
    [sym__lambda_parameters] = STATE(9776),
    [sym_array_creation_expression] = STATE(4559),
    [sym_anonymous_method_expression] = STATE(4559),
    [sym_anonymous_object_creation_expression] = STATE(4559),
    [sym_implicit_array_creation_expression] = STATE(4559),
    [sym_implicit_object_creation_expression] = STATE(4559),
    [sym_implicit_stackalloc_expression] = STATE(4559),
    [sym_initializer_expression] = STATE(4559),
    [sym_default_expression] = STATE(4559),
    [sym_with_expression] = STATE(4559),
    [sym_sizeof_expression] = STATE(4559),
    [sym_typeof_expression] = STATE(4559),
    [sym_makeref_expression] = STATE(4559),
    [sym_ref_expression] = STATE(4559),
    [sym_reftype_expression] = STATE(4559),
    [sym_refvalue_expression] = STATE(4559),
    [sym_stackalloc_expression] = STATE(4559),
    [sym_range_expression] = STATE(4559),
    [sym_tuple_expression] = STATE(3560),
    [sym_literal] = STATE(4559),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4559),
    [sym_preproc_region] = STATE(2126),
    [sym_preproc_endregion] = STATE(2126),
    [sym_preproc_line] = STATE(2126),
    [sym_preproc_pragma] = STATE(2126),
    [sym_preproc_nullable] = STATE(2126),
    [sym_preproc_error] = STATE(2126),
    [sym_preproc_define] = STATE(2126),
    [sym_preproc_undef] = STATE(2126),
    [aux_sym_class_declaration_repeat1] = STATE(3843),
    [aux_sym_lambda_expression_repeat1] = STATE(4277),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(1675),
    [anon_sym_ref] = ACTIONS(1677),
    [anon_sym_LBRACE] = ACTIONS(1611),
    [anon_sym_delegate] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1679),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(1683),
    [anon_sym_TILDE] = ACTIONS(1683),
    [anon_sym_PLUS_PLUS] = ACTIONS(1683),
    [anon_sym_DASH_DASH] = ACTIONS(1683),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_DASH] = ACTIONS(1681),
    [anon_sym_STAR] = ACTIONS(1685),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1683),
    [anon_sym_this] = ACTIONS(1627),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1629),
    [anon_sym_unchecked] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(1687),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1689),
    [anon_sym_DOT_DOT] = ACTIONS(1691),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_stackalloc] = ACTIONS(1641),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(1647),
    [anon_sym___reftype] = ACTIONS(1649),
    [anon_sym___refvalue] = ACTIONS(1651),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1659),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [2127] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3921),
    [sym__name] = STATE(6919),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2868),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(6950),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5216),
    [sym_non_lvalue_expression] = STATE(5735),
    [sym_lvalue_expression] = STATE(4054),
    [sym__expression_statement_expression] = STATE(5733),
    [sym_assignment_expression] = STATE(5734),
    [sym_binary_expression] = STATE(5733),
    [sym_postfix_unary_expression] = STATE(5734),
    [sym_prefix_unary_expression] = STATE(5734),
    [sym__pointer_indirection_expression] = STATE(3911),
    [sym_query_expression] = STATE(5733),
    [sym_from_clause] = STATE(7400),
    [sym_conditional_expression] = STATE(5733),
    [sym_conditional_access_expression] = STATE(5733),
    [sym_as_expression] = STATE(5733),
    [sym_is_expression] = STATE(5733),
    [sym_is_pattern_expression] = STATE(5733),
    [sym_cast_expression] = STATE(5733),
    [sym_checked_expression] = STATE(5733),
    [sym_invocation_expression] = STATE(5734),
    [sym_switch_expression] = STATE(5733),
    [sym_await_expression] = STATE(5734),
    [sym_throw_expression] = STATE(5733),
    [sym_element_access_expression] = STATE(3911),
    [sym_interpolated_string_expression] = STATE(5733),
    [sym_member_access_expression] = STATE(3911),
    [sym_object_creation_expression] = STATE(5734),
    [sym_parenthesized_expression] = STATE(5734),
    [sym__parenthesized_lvalue_expression] = STATE(3911),
    [sym_lambda_expression] = STATE(5733),
    [sym__lambda_parameters] = STATE(9693),
    [sym_array_creation_expression] = STATE(5733),
    [sym_anonymous_method_expression] = STATE(5733),
    [sym_anonymous_object_creation_expression] = STATE(5733),
    [sym_implicit_array_creation_expression] = STATE(5733),
    [sym_implicit_object_creation_expression] = STATE(5733),
    [sym_implicit_stackalloc_expression] = STATE(5733),
    [sym_initializer_expression] = STATE(5733),
    [sym_default_expression] = STATE(5733),
    [sym_with_expression] = STATE(5733),
    [sym_sizeof_expression] = STATE(5733),
    [sym_typeof_expression] = STATE(5733),
    [sym_makeref_expression] = STATE(5733),
    [sym_ref_expression] = STATE(5733),
    [sym_reftype_expression] = STATE(5733),
    [sym_refvalue_expression] = STATE(5733),
    [sym_stackalloc_expression] = STATE(5733),
    [sym_range_expression] = STATE(5733),
    [sym_tuple_expression] = STATE(3911),
    [sym_literal] = STATE(5733),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2798),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(5733),
    [sym_preproc_region] = STATE(2127),
    [sym_preproc_endregion] = STATE(2127),
    [sym_preproc_line] = STATE(2127),
    [sym_preproc_pragma] = STATE(2127),
    [sym_preproc_nullable] = STATE(2127),
    [sym_preproc_error] = STATE(2127),
    [sym_preproc_define] = STATE(2127),
    [sym_preproc_undef] = STATE(2127),
    [aux_sym_class_declaration_repeat1] = STATE(3791),
    [aux_sym_lambda_expression_repeat1] = STATE(4075),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_LPAREN] = ACTIONS(1373),
    [anon_sym_ref] = ACTIONS(1375),
    [anon_sym_LBRACE] = ACTIONS(1377),
    [anon_sym_delegate] = ACTIONS(1379),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1381),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1387),
    [anon_sym_TILDE] = ACTIONS(1387),
    [anon_sym_PLUS_PLUS] = ACTIONS(1387),
    [anon_sym_DASH_DASH] = ACTIONS(1387),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1385),
    [anon_sym_DASH] = ACTIONS(1385),
    [anon_sym_STAR] = ACTIONS(1391),
    [anon_sym_CARET] = ACTIONS(1387),
    [anon_sym_AMP] = ACTIONS(1387),
    [anon_sym_this] = ACTIONS(1393),
    [anon_sym_scoped] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1397),
    [sym_predefined_type] = ACTIONS(1399),
    [anon_sym_unchecked] = ACTIONS(1383),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1403),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1405),
    [anon_sym_DOT_DOT] = ACTIONS(1407),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_stackalloc] = ACTIONS(1413),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(1419),
    [anon_sym___reftype] = ACTIONS(1421),
    [anon_sym___refvalue] = ACTIONS(1423),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
  },
  [2128] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6967),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5042),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(3858),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7382),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9625),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(2128),
    [sym_preproc_endregion] = STATE(2128),
    [sym_preproc_line] = STATE(2128),
    [sym_preproc_pragma] = STATE(2128),
    [sym_preproc_nullable] = STATE(2128),
    [sym_preproc_error] = STATE(2128),
    [sym_preproc_define] = STATE(2128),
    [sym_preproc_undef] = STATE(2128),
    [aux_sym_class_declaration_repeat1] = STATE(3851),
    [aux_sym_lambda_expression_repeat1] = STATE(4234),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_ref] = ACTIONS(1293),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1059),
    [anon_sym_TILDE] = ACTIONS(1059),
    [anon_sym_PLUS_PLUS] = ACTIONS(1059),
    [anon_sym_DASH_DASH] = ACTIONS(1059),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1061),
    [anon_sym_DASH] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(1303),
    [anon_sym_CARET] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1307),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1309),
    [anon_sym_DOT_DOT] = ACTIONS(1311),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [2129] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3921),
    [sym__name] = STATE(6919),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2868),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(6950),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5311),
    [sym_non_lvalue_expression] = STATE(5735),
    [sym_lvalue_expression] = STATE(4054),
    [sym__expression_statement_expression] = STATE(5733),
    [sym_assignment_expression] = STATE(5734),
    [sym_binary_expression] = STATE(5733),
    [sym_postfix_unary_expression] = STATE(5734),
    [sym_prefix_unary_expression] = STATE(5734),
    [sym__pointer_indirection_expression] = STATE(3911),
    [sym_query_expression] = STATE(5733),
    [sym_from_clause] = STATE(7400),
    [sym_conditional_expression] = STATE(5733),
    [sym_conditional_access_expression] = STATE(5733),
    [sym_as_expression] = STATE(5733),
    [sym_is_expression] = STATE(5733),
    [sym_is_pattern_expression] = STATE(5733),
    [sym_cast_expression] = STATE(5733),
    [sym_checked_expression] = STATE(5733),
    [sym_invocation_expression] = STATE(5734),
    [sym_switch_expression] = STATE(5733),
    [sym_await_expression] = STATE(5734),
    [sym_throw_expression] = STATE(5733),
    [sym_element_access_expression] = STATE(3911),
    [sym_interpolated_string_expression] = STATE(5733),
    [sym_member_access_expression] = STATE(3911),
    [sym_object_creation_expression] = STATE(5734),
    [sym_parenthesized_expression] = STATE(5734),
    [sym__parenthesized_lvalue_expression] = STATE(3911),
    [sym_lambda_expression] = STATE(5733),
    [sym__lambda_parameters] = STATE(9693),
    [sym_array_creation_expression] = STATE(5733),
    [sym_anonymous_method_expression] = STATE(5733),
    [sym_anonymous_object_creation_expression] = STATE(5733),
    [sym_implicit_array_creation_expression] = STATE(5733),
    [sym_implicit_object_creation_expression] = STATE(5733),
    [sym_implicit_stackalloc_expression] = STATE(5733),
    [sym_initializer_expression] = STATE(5733),
    [sym_default_expression] = STATE(5733),
    [sym_with_expression] = STATE(5733),
    [sym_sizeof_expression] = STATE(5733),
    [sym_typeof_expression] = STATE(5733),
    [sym_makeref_expression] = STATE(5733),
    [sym_ref_expression] = STATE(5733),
    [sym_reftype_expression] = STATE(5733),
    [sym_refvalue_expression] = STATE(5733),
    [sym_stackalloc_expression] = STATE(5733),
    [sym_range_expression] = STATE(5733),
    [sym_tuple_expression] = STATE(3911),
    [sym_literal] = STATE(5733),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2798),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(5733),
    [sym_preproc_region] = STATE(2129),
    [sym_preproc_endregion] = STATE(2129),
    [sym_preproc_line] = STATE(2129),
    [sym_preproc_pragma] = STATE(2129),
    [sym_preproc_nullable] = STATE(2129),
    [sym_preproc_error] = STATE(2129),
    [sym_preproc_define] = STATE(2129),
    [sym_preproc_undef] = STATE(2129),
    [aux_sym_class_declaration_repeat1] = STATE(3791),
    [aux_sym_lambda_expression_repeat1] = STATE(4075),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_LPAREN] = ACTIONS(1373),
    [anon_sym_ref] = ACTIONS(1375),
    [anon_sym_LBRACE] = ACTIONS(1377),
    [anon_sym_delegate] = ACTIONS(1379),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1381),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1387),
    [anon_sym_TILDE] = ACTIONS(1387),
    [anon_sym_PLUS_PLUS] = ACTIONS(1387),
    [anon_sym_DASH_DASH] = ACTIONS(1387),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1385),
    [anon_sym_DASH] = ACTIONS(1385),
    [anon_sym_STAR] = ACTIONS(1391),
    [anon_sym_CARET] = ACTIONS(1387),
    [anon_sym_AMP] = ACTIONS(1387),
    [anon_sym_this] = ACTIONS(1393),
    [anon_sym_scoped] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1397),
    [sym_predefined_type] = ACTIONS(1399),
    [anon_sym_unchecked] = ACTIONS(1383),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1403),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1405),
    [anon_sym_DOT_DOT] = ACTIONS(1407),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_stackalloc] = ACTIONS(1413),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(1419),
    [anon_sym___reftype] = ACTIONS(1421),
    [anon_sym___refvalue] = ACTIONS(1423),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
  },
  [2130] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3559),
    [sym__name] = STATE(6877),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2908),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6958),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4634),
    [sym_non_lvalue_expression] = STATE(4553),
    [sym_lvalue_expression] = STATE(3691),
    [sym__expression_statement_expression] = STATE(4559),
    [sym_assignment_expression] = STATE(4558),
    [sym_binary_expression] = STATE(4559),
    [sym_postfix_unary_expression] = STATE(4558),
    [sym_prefix_unary_expression] = STATE(4558),
    [sym__pointer_indirection_expression] = STATE(3560),
    [sym_query_expression] = STATE(4559),
    [sym_from_clause] = STATE(7406),
    [sym_conditional_expression] = STATE(4559),
    [sym_conditional_access_expression] = STATE(4559),
    [sym_as_expression] = STATE(4559),
    [sym_is_expression] = STATE(4559),
    [sym_is_pattern_expression] = STATE(4559),
    [sym_cast_expression] = STATE(4559),
    [sym_checked_expression] = STATE(4559),
    [sym_invocation_expression] = STATE(4558),
    [sym_switch_expression] = STATE(4559),
    [sym_await_expression] = STATE(4558),
    [sym_throw_expression] = STATE(4559),
    [sym_element_access_expression] = STATE(3560),
    [sym_interpolated_string_expression] = STATE(4559),
    [sym_member_access_expression] = STATE(3560),
    [sym_object_creation_expression] = STATE(4558),
    [sym_parenthesized_expression] = STATE(4558),
    [sym__parenthesized_lvalue_expression] = STATE(3560),
    [sym_lambda_expression] = STATE(4559),
    [sym__lambda_parameters] = STATE(9348),
    [sym_array_creation_expression] = STATE(4559),
    [sym_anonymous_method_expression] = STATE(4559),
    [sym_anonymous_object_creation_expression] = STATE(4559),
    [sym_implicit_array_creation_expression] = STATE(4559),
    [sym_implicit_object_creation_expression] = STATE(4559),
    [sym_implicit_stackalloc_expression] = STATE(4559),
    [sym_initializer_expression] = STATE(4559),
    [sym_default_expression] = STATE(4559),
    [sym_with_expression] = STATE(4559),
    [sym_sizeof_expression] = STATE(4559),
    [sym_typeof_expression] = STATE(4559),
    [sym_makeref_expression] = STATE(4559),
    [sym_ref_expression] = STATE(4559),
    [sym_reftype_expression] = STATE(4559),
    [sym_refvalue_expression] = STATE(4559),
    [sym_stackalloc_expression] = STATE(4559),
    [sym_range_expression] = STATE(4559),
    [sym_tuple_expression] = STATE(3560),
    [sym_literal] = STATE(4559),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4559),
    [sym_preproc_region] = STATE(2130),
    [sym_preproc_endregion] = STATE(2130),
    [sym_preproc_line] = STATE(2130),
    [sym_preproc_pragma] = STATE(2130),
    [sym_preproc_nullable] = STATE(2130),
    [sym_preproc_error] = STATE(2130),
    [sym_preproc_define] = STATE(2130),
    [sym_preproc_undef] = STATE(2130),
    [aux_sym_class_declaration_repeat1] = STATE(3810),
    [aux_sym_lambda_expression_repeat1] = STATE(4141),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(2047),
    [anon_sym_ref] = ACTIONS(2049),
    [anon_sym_LBRACE] = ACTIONS(1611),
    [anon_sym_delegate] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1679),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(2053),
    [anon_sym_TILDE] = ACTIONS(2053),
    [anon_sym_PLUS_PLUS] = ACTIONS(2053),
    [anon_sym_DASH_DASH] = ACTIONS(2053),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(2051),
    [anon_sym_DASH] = ACTIONS(2051),
    [anon_sym_STAR] = ACTIONS(1685),
    [anon_sym_CARET] = ACTIONS(2053),
    [anon_sym_AMP] = ACTIONS(2053),
    [anon_sym_this] = ACTIONS(1627),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1629),
    [anon_sym_unchecked] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(2055),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2057),
    [anon_sym_DOT_DOT] = ACTIONS(2059),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_stackalloc] = ACTIONS(1641),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(1647),
    [anon_sym___reftype] = ACTIONS(1649),
    [anon_sym___refvalue] = ACTIONS(1651),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1659),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [2131] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3559),
    [sym__name] = STATE(6877),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2908),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6958),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4552),
    [sym_non_lvalue_expression] = STATE(4553),
    [sym_lvalue_expression] = STATE(3691),
    [sym__expression_statement_expression] = STATE(4559),
    [sym_assignment_expression] = STATE(4558),
    [sym_binary_expression] = STATE(4559),
    [sym_postfix_unary_expression] = STATE(4558),
    [sym_prefix_unary_expression] = STATE(4558),
    [sym__pointer_indirection_expression] = STATE(3560),
    [sym_query_expression] = STATE(4559),
    [sym_from_clause] = STATE(7406),
    [sym_conditional_expression] = STATE(4559),
    [sym_conditional_access_expression] = STATE(4559),
    [sym_as_expression] = STATE(4559),
    [sym_is_expression] = STATE(4559),
    [sym_is_pattern_expression] = STATE(4559),
    [sym_cast_expression] = STATE(4559),
    [sym_checked_expression] = STATE(4559),
    [sym_invocation_expression] = STATE(4558),
    [sym_switch_expression] = STATE(4559),
    [sym_await_expression] = STATE(4558),
    [sym_throw_expression] = STATE(4559),
    [sym_element_access_expression] = STATE(3560),
    [sym_interpolated_string_expression] = STATE(4559),
    [sym_member_access_expression] = STATE(3560),
    [sym_object_creation_expression] = STATE(4558),
    [sym_parenthesized_expression] = STATE(4558),
    [sym__parenthesized_lvalue_expression] = STATE(3560),
    [sym_lambda_expression] = STATE(4559),
    [sym__lambda_parameters] = STATE(9348),
    [sym_array_creation_expression] = STATE(4559),
    [sym_anonymous_method_expression] = STATE(4559),
    [sym_anonymous_object_creation_expression] = STATE(4559),
    [sym_implicit_array_creation_expression] = STATE(4559),
    [sym_implicit_object_creation_expression] = STATE(4559),
    [sym_implicit_stackalloc_expression] = STATE(4559),
    [sym_initializer_expression] = STATE(4559),
    [sym_default_expression] = STATE(4559),
    [sym_with_expression] = STATE(4559),
    [sym_sizeof_expression] = STATE(4559),
    [sym_typeof_expression] = STATE(4559),
    [sym_makeref_expression] = STATE(4559),
    [sym_ref_expression] = STATE(4559),
    [sym_reftype_expression] = STATE(4559),
    [sym_refvalue_expression] = STATE(4559),
    [sym_stackalloc_expression] = STATE(4559),
    [sym_range_expression] = STATE(4559),
    [sym_tuple_expression] = STATE(3560),
    [sym_literal] = STATE(4559),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4559),
    [sym_preproc_region] = STATE(2131),
    [sym_preproc_endregion] = STATE(2131),
    [sym_preproc_line] = STATE(2131),
    [sym_preproc_pragma] = STATE(2131),
    [sym_preproc_nullable] = STATE(2131),
    [sym_preproc_error] = STATE(2131),
    [sym_preproc_define] = STATE(2131),
    [sym_preproc_undef] = STATE(2131),
    [aux_sym_class_declaration_repeat1] = STATE(3810),
    [aux_sym_lambda_expression_repeat1] = STATE(4141),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(2047),
    [anon_sym_ref] = ACTIONS(2049),
    [anon_sym_LBRACE] = ACTIONS(1611),
    [anon_sym_delegate] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1679),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(2053),
    [anon_sym_TILDE] = ACTIONS(2053),
    [anon_sym_PLUS_PLUS] = ACTIONS(2053),
    [anon_sym_DASH_DASH] = ACTIONS(2053),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(2051),
    [anon_sym_DASH] = ACTIONS(2051),
    [anon_sym_STAR] = ACTIONS(1685),
    [anon_sym_CARET] = ACTIONS(2053),
    [anon_sym_AMP] = ACTIONS(2053),
    [anon_sym_this] = ACTIONS(1627),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1629),
    [anon_sym_unchecked] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(2055),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2057),
    [anon_sym_DOT_DOT] = ACTIONS(2059),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_stackalloc] = ACTIONS(1641),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(1647),
    [anon_sym___reftype] = ACTIONS(1649),
    [anon_sym___refvalue] = ACTIONS(1651),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1659),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [2132] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3921),
    [sym__name] = STATE(6919),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2868),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(6950),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5322),
    [sym_non_lvalue_expression] = STATE(5735),
    [sym_lvalue_expression] = STATE(4054),
    [sym__expression_statement_expression] = STATE(5733),
    [sym_assignment_expression] = STATE(5734),
    [sym_binary_expression] = STATE(5733),
    [sym_postfix_unary_expression] = STATE(5734),
    [sym_prefix_unary_expression] = STATE(5734),
    [sym__pointer_indirection_expression] = STATE(3911),
    [sym_query_expression] = STATE(5733),
    [sym_from_clause] = STATE(7400),
    [sym_conditional_expression] = STATE(5733),
    [sym_conditional_access_expression] = STATE(5733),
    [sym_as_expression] = STATE(5733),
    [sym_is_expression] = STATE(5733),
    [sym_is_pattern_expression] = STATE(5733),
    [sym_cast_expression] = STATE(5733),
    [sym_checked_expression] = STATE(5733),
    [sym_invocation_expression] = STATE(5734),
    [sym_switch_expression] = STATE(5733),
    [sym_await_expression] = STATE(5734),
    [sym_throw_expression] = STATE(5733),
    [sym_element_access_expression] = STATE(3911),
    [sym_interpolated_string_expression] = STATE(5733),
    [sym_member_access_expression] = STATE(3911),
    [sym_object_creation_expression] = STATE(5734),
    [sym_parenthesized_expression] = STATE(5734),
    [sym__parenthesized_lvalue_expression] = STATE(3911),
    [sym_lambda_expression] = STATE(5733),
    [sym__lambda_parameters] = STATE(9693),
    [sym_array_creation_expression] = STATE(5733),
    [sym_anonymous_method_expression] = STATE(5733),
    [sym_anonymous_object_creation_expression] = STATE(5733),
    [sym_implicit_array_creation_expression] = STATE(5733),
    [sym_implicit_object_creation_expression] = STATE(5733),
    [sym_implicit_stackalloc_expression] = STATE(5733),
    [sym_initializer_expression] = STATE(5733),
    [sym_default_expression] = STATE(5733),
    [sym_with_expression] = STATE(5733),
    [sym_sizeof_expression] = STATE(5733),
    [sym_typeof_expression] = STATE(5733),
    [sym_makeref_expression] = STATE(5733),
    [sym_ref_expression] = STATE(5733),
    [sym_reftype_expression] = STATE(5733),
    [sym_refvalue_expression] = STATE(5733),
    [sym_stackalloc_expression] = STATE(5733),
    [sym_range_expression] = STATE(5733),
    [sym_tuple_expression] = STATE(3911),
    [sym_literal] = STATE(5733),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2798),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(5733),
    [sym_preproc_region] = STATE(2132),
    [sym_preproc_endregion] = STATE(2132),
    [sym_preproc_line] = STATE(2132),
    [sym_preproc_pragma] = STATE(2132),
    [sym_preproc_nullable] = STATE(2132),
    [sym_preproc_error] = STATE(2132),
    [sym_preproc_define] = STATE(2132),
    [sym_preproc_undef] = STATE(2132),
    [aux_sym_class_declaration_repeat1] = STATE(3791),
    [aux_sym_lambda_expression_repeat1] = STATE(4075),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_LPAREN] = ACTIONS(1373),
    [anon_sym_ref] = ACTIONS(1375),
    [anon_sym_LBRACE] = ACTIONS(1377),
    [anon_sym_delegate] = ACTIONS(1379),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1381),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1387),
    [anon_sym_TILDE] = ACTIONS(1387),
    [anon_sym_PLUS_PLUS] = ACTIONS(1387),
    [anon_sym_DASH_DASH] = ACTIONS(1387),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1385),
    [anon_sym_DASH] = ACTIONS(1385),
    [anon_sym_STAR] = ACTIONS(1391),
    [anon_sym_CARET] = ACTIONS(1387),
    [anon_sym_AMP] = ACTIONS(1387),
    [anon_sym_this] = ACTIONS(1393),
    [anon_sym_scoped] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1397),
    [sym_predefined_type] = ACTIONS(1399),
    [anon_sym_unchecked] = ACTIONS(1383),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1403),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1405),
    [anon_sym_DOT_DOT] = ACTIONS(1407),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_stackalloc] = ACTIONS(1413),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(1419),
    [anon_sym___reftype] = ACTIONS(1421),
    [anon_sym___refvalue] = ACTIONS(1423),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
  },
  [2133] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3921),
    [sym__name] = STATE(6919),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2868),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(6950),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5323),
    [sym_non_lvalue_expression] = STATE(5735),
    [sym_lvalue_expression] = STATE(4054),
    [sym__expression_statement_expression] = STATE(5733),
    [sym_assignment_expression] = STATE(5734),
    [sym_binary_expression] = STATE(5733),
    [sym_postfix_unary_expression] = STATE(5734),
    [sym_prefix_unary_expression] = STATE(5734),
    [sym__pointer_indirection_expression] = STATE(3911),
    [sym_query_expression] = STATE(5733),
    [sym_from_clause] = STATE(7400),
    [sym_conditional_expression] = STATE(5733),
    [sym_conditional_access_expression] = STATE(5733),
    [sym_as_expression] = STATE(5733),
    [sym_is_expression] = STATE(5733),
    [sym_is_pattern_expression] = STATE(5733),
    [sym_cast_expression] = STATE(5733),
    [sym_checked_expression] = STATE(5733),
    [sym_invocation_expression] = STATE(5734),
    [sym_switch_expression] = STATE(5733),
    [sym_await_expression] = STATE(5734),
    [sym_throw_expression] = STATE(5733),
    [sym_element_access_expression] = STATE(3911),
    [sym_interpolated_string_expression] = STATE(5733),
    [sym_member_access_expression] = STATE(3911),
    [sym_object_creation_expression] = STATE(5734),
    [sym_parenthesized_expression] = STATE(5734),
    [sym__parenthesized_lvalue_expression] = STATE(3911),
    [sym_lambda_expression] = STATE(5733),
    [sym__lambda_parameters] = STATE(9693),
    [sym_array_creation_expression] = STATE(5733),
    [sym_anonymous_method_expression] = STATE(5733),
    [sym_anonymous_object_creation_expression] = STATE(5733),
    [sym_implicit_array_creation_expression] = STATE(5733),
    [sym_implicit_object_creation_expression] = STATE(5733),
    [sym_implicit_stackalloc_expression] = STATE(5733),
    [sym_initializer_expression] = STATE(5733),
    [sym_default_expression] = STATE(5733),
    [sym_with_expression] = STATE(5733),
    [sym_sizeof_expression] = STATE(5733),
    [sym_typeof_expression] = STATE(5733),
    [sym_makeref_expression] = STATE(5733),
    [sym_ref_expression] = STATE(5733),
    [sym_reftype_expression] = STATE(5733),
    [sym_refvalue_expression] = STATE(5733),
    [sym_stackalloc_expression] = STATE(5733),
    [sym_range_expression] = STATE(5733),
    [sym_tuple_expression] = STATE(3911),
    [sym_literal] = STATE(5733),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2798),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(5733),
    [sym_preproc_region] = STATE(2133),
    [sym_preproc_endregion] = STATE(2133),
    [sym_preproc_line] = STATE(2133),
    [sym_preproc_pragma] = STATE(2133),
    [sym_preproc_nullable] = STATE(2133),
    [sym_preproc_error] = STATE(2133),
    [sym_preproc_define] = STATE(2133),
    [sym_preproc_undef] = STATE(2133),
    [aux_sym_class_declaration_repeat1] = STATE(3791),
    [aux_sym_lambda_expression_repeat1] = STATE(4075),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_LPAREN] = ACTIONS(1373),
    [anon_sym_ref] = ACTIONS(1375),
    [anon_sym_LBRACE] = ACTIONS(1377),
    [anon_sym_delegate] = ACTIONS(1379),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1381),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1387),
    [anon_sym_TILDE] = ACTIONS(1387),
    [anon_sym_PLUS_PLUS] = ACTIONS(1387),
    [anon_sym_DASH_DASH] = ACTIONS(1387),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1385),
    [anon_sym_DASH] = ACTIONS(1385),
    [anon_sym_STAR] = ACTIONS(1391),
    [anon_sym_CARET] = ACTIONS(1387),
    [anon_sym_AMP] = ACTIONS(1387),
    [anon_sym_this] = ACTIONS(1393),
    [anon_sym_scoped] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1397),
    [sym_predefined_type] = ACTIONS(1399),
    [anon_sym_unchecked] = ACTIONS(1383),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1403),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1405),
    [anon_sym_DOT_DOT] = ACTIONS(1407),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_stackalloc] = ACTIONS(1413),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(1419),
    [anon_sym___reftype] = ACTIONS(1421),
    [anon_sym___refvalue] = ACTIONS(1423),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
  },
  [2134] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3921),
    [sym__name] = STATE(6889),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2854),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(6991),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5123),
    [sym_non_lvalue_expression] = STATE(5735),
    [sym_lvalue_expression] = STATE(4295),
    [sym__expression_statement_expression] = STATE(5733),
    [sym_assignment_expression] = STATE(5734),
    [sym_binary_expression] = STATE(5733),
    [sym_postfix_unary_expression] = STATE(5734),
    [sym_prefix_unary_expression] = STATE(5734),
    [sym__pointer_indirection_expression] = STATE(3911),
    [sym_query_expression] = STATE(5733),
    [sym_from_clause] = STATE(7393),
    [sym_conditional_expression] = STATE(5733),
    [sym_conditional_access_expression] = STATE(5733),
    [sym_as_expression] = STATE(5733),
    [sym_is_expression] = STATE(5733),
    [sym_is_pattern_expression] = STATE(5733),
    [sym_cast_expression] = STATE(5733),
    [sym_checked_expression] = STATE(5733),
    [sym_invocation_expression] = STATE(5734),
    [sym_switch_expression] = STATE(5733),
    [sym_await_expression] = STATE(5734),
    [sym_throw_expression] = STATE(5733),
    [sym_element_access_expression] = STATE(3911),
    [sym_interpolated_string_expression] = STATE(5733),
    [sym_member_access_expression] = STATE(3911),
    [sym_object_creation_expression] = STATE(5734),
    [sym_parenthesized_expression] = STATE(5734),
    [sym__parenthesized_lvalue_expression] = STATE(3911),
    [sym_lambda_expression] = STATE(5733),
    [sym__lambda_parameters] = STATE(9313),
    [sym_array_creation_expression] = STATE(5733),
    [sym_anonymous_method_expression] = STATE(5733),
    [sym_anonymous_object_creation_expression] = STATE(5733),
    [sym_implicit_array_creation_expression] = STATE(5733),
    [sym_implicit_object_creation_expression] = STATE(5733),
    [sym_implicit_stackalloc_expression] = STATE(5733),
    [sym_initializer_expression] = STATE(5733),
    [sym_default_expression] = STATE(5733),
    [sym_with_expression] = STATE(5733),
    [sym_sizeof_expression] = STATE(5733),
    [sym_typeof_expression] = STATE(5733),
    [sym_makeref_expression] = STATE(5733),
    [sym_ref_expression] = STATE(5733),
    [sym_reftype_expression] = STATE(5733),
    [sym_refvalue_expression] = STATE(5733),
    [sym_stackalloc_expression] = STATE(5733),
    [sym_range_expression] = STATE(5733),
    [sym_tuple_expression] = STATE(3911),
    [sym_literal] = STATE(5733),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2798),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(5733),
    [sym_preproc_region] = STATE(2134),
    [sym_preproc_endregion] = STATE(2134),
    [sym_preproc_line] = STATE(2134),
    [sym_preproc_pragma] = STATE(2134),
    [sym_preproc_nullable] = STATE(2134),
    [sym_preproc_error] = STATE(2134),
    [sym_preproc_define] = STATE(2134),
    [sym_preproc_undef] = STATE(2134),
    [aux_sym_class_declaration_repeat1] = STATE(3805),
    [aux_sym_lambda_expression_repeat1] = STATE(4122),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_LPAREN] = ACTIONS(1591),
    [anon_sym_ref] = ACTIONS(1593),
    [anon_sym_LBRACE] = ACTIONS(1377),
    [anon_sym_delegate] = ACTIONS(1379),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1443),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1597),
    [anon_sym_TILDE] = ACTIONS(1597),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1595),
    [anon_sym_DASH] = ACTIONS(1595),
    [anon_sym_STAR] = ACTIONS(1449),
    [anon_sym_CARET] = ACTIONS(1597),
    [anon_sym_AMP] = ACTIONS(1597),
    [anon_sym_this] = ACTIONS(1393),
    [anon_sym_scoped] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1397),
    [sym_predefined_type] = ACTIONS(1399),
    [anon_sym_unchecked] = ACTIONS(1383),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1599),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1601),
    [anon_sym_DOT_DOT] = ACTIONS(1603),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_stackalloc] = ACTIONS(1413),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(1419),
    [anon_sym___reftype] = ACTIONS(1421),
    [anon_sym___refvalue] = ACTIONS(1423),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
  },
  [2135] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3559),
    [sym__name] = STATE(6877),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2908),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7129),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4373),
    [sym_non_lvalue_expression] = STATE(4553),
    [sym_lvalue_expression] = STATE(3561),
    [sym__expression_statement_expression] = STATE(4559),
    [sym_assignment_expression] = STATE(4558),
    [sym_binary_expression] = STATE(4559),
    [sym_postfix_unary_expression] = STATE(4558),
    [sym_prefix_unary_expression] = STATE(4558),
    [sym__pointer_indirection_expression] = STATE(3560),
    [sym_query_expression] = STATE(4559),
    [sym_from_clause] = STATE(7385),
    [sym_conditional_expression] = STATE(4559),
    [sym_conditional_access_expression] = STATE(4559),
    [sym_as_expression] = STATE(4559),
    [sym_is_expression] = STATE(4559),
    [sym_is_pattern_expression] = STATE(4559),
    [sym_cast_expression] = STATE(4559),
    [sym_checked_expression] = STATE(4559),
    [sym_invocation_expression] = STATE(4558),
    [sym_switch_expression] = STATE(4559),
    [sym_await_expression] = STATE(4558),
    [sym_throw_expression] = STATE(4559),
    [sym_element_access_expression] = STATE(3560),
    [sym_interpolated_string_expression] = STATE(4559),
    [sym_member_access_expression] = STATE(3560),
    [sym_object_creation_expression] = STATE(4558),
    [sym_parenthesized_expression] = STATE(4558),
    [sym__parenthesized_lvalue_expression] = STATE(3560),
    [sym_lambda_expression] = STATE(4559),
    [sym__lambda_parameters] = STATE(9776),
    [sym_array_creation_expression] = STATE(4559),
    [sym_anonymous_method_expression] = STATE(4559),
    [sym_anonymous_object_creation_expression] = STATE(4559),
    [sym_implicit_array_creation_expression] = STATE(4559),
    [sym_implicit_object_creation_expression] = STATE(4559),
    [sym_implicit_stackalloc_expression] = STATE(4559),
    [sym_initializer_expression] = STATE(4559),
    [sym_default_expression] = STATE(4559),
    [sym_with_expression] = STATE(4559),
    [sym_sizeof_expression] = STATE(4559),
    [sym_typeof_expression] = STATE(4559),
    [sym_makeref_expression] = STATE(4559),
    [sym_ref_expression] = STATE(4559),
    [sym_reftype_expression] = STATE(4559),
    [sym_refvalue_expression] = STATE(4559),
    [sym_stackalloc_expression] = STATE(4559),
    [sym_range_expression] = STATE(4559),
    [sym_tuple_expression] = STATE(3560),
    [sym_literal] = STATE(4559),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4559),
    [sym_preproc_region] = STATE(2135),
    [sym_preproc_endregion] = STATE(2135),
    [sym_preproc_line] = STATE(2135),
    [sym_preproc_pragma] = STATE(2135),
    [sym_preproc_nullable] = STATE(2135),
    [sym_preproc_error] = STATE(2135),
    [sym_preproc_define] = STATE(2135),
    [sym_preproc_undef] = STATE(2135),
    [aux_sym_class_declaration_repeat1] = STATE(3843),
    [aux_sym_lambda_expression_repeat1] = STATE(4277),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(1675),
    [anon_sym_ref] = ACTIONS(1677),
    [anon_sym_LBRACE] = ACTIONS(1611),
    [anon_sym_delegate] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1679),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(1683),
    [anon_sym_TILDE] = ACTIONS(1683),
    [anon_sym_PLUS_PLUS] = ACTIONS(1683),
    [anon_sym_DASH_DASH] = ACTIONS(1683),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_DASH] = ACTIONS(1681),
    [anon_sym_STAR] = ACTIONS(1685),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1683),
    [anon_sym_this] = ACTIONS(1627),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1629),
    [anon_sym_unchecked] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(1687),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1689),
    [anon_sym_DOT_DOT] = ACTIONS(1691),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_stackalloc] = ACTIONS(1641),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(1647),
    [anon_sym___reftype] = ACTIONS(1649),
    [anon_sym___refvalue] = ACTIONS(1651),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1659),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [2136] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6967),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5054),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(3858),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7382),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9625),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(2136),
    [sym_preproc_endregion] = STATE(2136),
    [sym_preproc_line] = STATE(2136),
    [sym_preproc_pragma] = STATE(2136),
    [sym_preproc_nullable] = STATE(2136),
    [sym_preproc_error] = STATE(2136),
    [sym_preproc_define] = STATE(2136),
    [sym_preproc_undef] = STATE(2136),
    [aux_sym_class_declaration_repeat1] = STATE(3851),
    [aux_sym_lambda_expression_repeat1] = STATE(4234),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_ref] = ACTIONS(1293),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1059),
    [anon_sym_TILDE] = ACTIONS(1059),
    [anon_sym_PLUS_PLUS] = ACTIONS(1059),
    [anon_sym_DASH_DASH] = ACTIONS(1059),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1061),
    [anon_sym_DASH] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(1303),
    [anon_sym_CARET] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1307),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1309),
    [anon_sym_DOT_DOT] = ACTIONS(1311),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [2137] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3921),
    [sym__name] = STATE(6889),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2854),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(6991),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5589),
    [sym_non_lvalue_expression] = STATE(5735),
    [sym_lvalue_expression] = STATE(4295),
    [sym__expression_statement_expression] = STATE(5733),
    [sym_assignment_expression] = STATE(5734),
    [sym_binary_expression] = STATE(5733),
    [sym_postfix_unary_expression] = STATE(5734),
    [sym_prefix_unary_expression] = STATE(5734),
    [sym__pointer_indirection_expression] = STATE(3911),
    [sym_query_expression] = STATE(5733),
    [sym_from_clause] = STATE(7393),
    [sym_conditional_expression] = STATE(5733),
    [sym_conditional_access_expression] = STATE(5733),
    [sym_as_expression] = STATE(5733),
    [sym_is_expression] = STATE(5733),
    [sym_is_pattern_expression] = STATE(5733),
    [sym_cast_expression] = STATE(5733),
    [sym_checked_expression] = STATE(5733),
    [sym_invocation_expression] = STATE(5734),
    [sym_switch_expression] = STATE(5733),
    [sym_await_expression] = STATE(5734),
    [sym_throw_expression] = STATE(5733),
    [sym_element_access_expression] = STATE(3911),
    [sym_interpolated_string_expression] = STATE(5733),
    [sym_member_access_expression] = STATE(3911),
    [sym_object_creation_expression] = STATE(5734),
    [sym_parenthesized_expression] = STATE(5734),
    [sym__parenthesized_lvalue_expression] = STATE(3911),
    [sym_lambda_expression] = STATE(5733),
    [sym__lambda_parameters] = STATE(9313),
    [sym_array_creation_expression] = STATE(5733),
    [sym_anonymous_method_expression] = STATE(5733),
    [sym_anonymous_object_creation_expression] = STATE(5733),
    [sym_implicit_array_creation_expression] = STATE(5733),
    [sym_implicit_object_creation_expression] = STATE(5733),
    [sym_implicit_stackalloc_expression] = STATE(5733),
    [sym_initializer_expression] = STATE(5733),
    [sym_default_expression] = STATE(5733),
    [sym_with_expression] = STATE(5733),
    [sym_sizeof_expression] = STATE(5733),
    [sym_typeof_expression] = STATE(5733),
    [sym_makeref_expression] = STATE(5733),
    [sym_ref_expression] = STATE(5733),
    [sym_reftype_expression] = STATE(5733),
    [sym_refvalue_expression] = STATE(5733),
    [sym_stackalloc_expression] = STATE(5733),
    [sym_range_expression] = STATE(5733),
    [sym_tuple_expression] = STATE(3911),
    [sym_literal] = STATE(5733),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2798),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(5733),
    [sym_preproc_region] = STATE(2137),
    [sym_preproc_endregion] = STATE(2137),
    [sym_preproc_line] = STATE(2137),
    [sym_preproc_pragma] = STATE(2137),
    [sym_preproc_nullable] = STATE(2137),
    [sym_preproc_error] = STATE(2137),
    [sym_preproc_define] = STATE(2137),
    [sym_preproc_undef] = STATE(2137),
    [aux_sym_class_declaration_repeat1] = STATE(3805),
    [aux_sym_lambda_expression_repeat1] = STATE(4122),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_LPAREN] = ACTIONS(1591),
    [anon_sym_ref] = ACTIONS(1593),
    [anon_sym_LBRACE] = ACTIONS(1377),
    [anon_sym_delegate] = ACTIONS(1379),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1443),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1597),
    [anon_sym_TILDE] = ACTIONS(1597),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1595),
    [anon_sym_DASH] = ACTIONS(1595),
    [anon_sym_STAR] = ACTIONS(1449),
    [anon_sym_CARET] = ACTIONS(1597),
    [anon_sym_AMP] = ACTIONS(1597),
    [anon_sym_this] = ACTIONS(1393),
    [anon_sym_scoped] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1397),
    [sym_predefined_type] = ACTIONS(1399),
    [anon_sym_unchecked] = ACTIONS(1383),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1599),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1601),
    [anon_sym_DOT_DOT] = ACTIONS(1603),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_stackalloc] = ACTIONS(1413),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(1419),
    [anon_sym___reftype] = ACTIONS(1421),
    [anon_sym___refvalue] = ACTIONS(1423),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
  },
  [2138] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3559),
    [sym__name] = STATE(6877),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2908),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6958),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4554),
    [sym_non_lvalue_expression] = STATE(4553),
    [sym_lvalue_expression] = STATE(3691),
    [sym__expression_statement_expression] = STATE(4559),
    [sym_assignment_expression] = STATE(4558),
    [sym_binary_expression] = STATE(4559),
    [sym_postfix_unary_expression] = STATE(4558),
    [sym_prefix_unary_expression] = STATE(4558),
    [sym__pointer_indirection_expression] = STATE(3560),
    [sym_query_expression] = STATE(4559),
    [sym_from_clause] = STATE(7406),
    [sym_conditional_expression] = STATE(4559),
    [sym_conditional_access_expression] = STATE(4559),
    [sym_as_expression] = STATE(4559),
    [sym_is_expression] = STATE(4559),
    [sym_is_pattern_expression] = STATE(4559),
    [sym_cast_expression] = STATE(4559),
    [sym_checked_expression] = STATE(4559),
    [sym_invocation_expression] = STATE(4558),
    [sym_switch_expression] = STATE(4559),
    [sym_await_expression] = STATE(4558),
    [sym_throw_expression] = STATE(4559),
    [sym_element_access_expression] = STATE(3560),
    [sym_interpolated_string_expression] = STATE(4559),
    [sym_member_access_expression] = STATE(3560),
    [sym_object_creation_expression] = STATE(4558),
    [sym_parenthesized_expression] = STATE(4558),
    [sym__parenthesized_lvalue_expression] = STATE(3560),
    [sym_lambda_expression] = STATE(4559),
    [sym__lambda_parameters] = STATE(9348),
    [sym_array_creation_expression] = STATE(4559),
    [sym_anonymous_method_expression] = STATE(4559),
    [sym_anonymous_object_creation_expression] = STATE(4559),
    [sym_implicit_array_creation_expression] = STATE(4559),
    [sym_implicit_object_creation_expression] = STATE(4559),
    [sym_implicit_stackalloc_expression] = STATE(4559),
    [sym_initializer_expression] = STATE(4559),
    [sym_default_expression] = STATE(4559),
    [sym_with_expression] = STATE(4559),
    [sym_sizeof_expression] = STATE(4559),
    [sym_typeof_expression] = STATE(4559),
    [sym_makeref_expression] = STATE(4559),
    [sym_ref_expression] = STATE(4559),
    [sym_reftype_expression] = STATE(4559),
    [sym_refvalue_expression] = STATE(4559),
    [sym_stackalloc_expression] = STATE(4559),
    [sym_range_expression] = STATE(4559),
    [sym_tuple_expression] = STATE(3560),
    [sym_literal] = STATE(4559),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4559),
    [sym_preproc_region] = STATE(2138),
    [sym_preproc_endregion] = STATE(2138),
    [sym_preproc_line] = STATE(2138),
    [sym_preproc_pragma] = STATE(2138),
    [sym_preproc_nullable] = STATE(2138),
    [sym_preproc_error] = STATE(2138),
    [sym_preproc_define] = STATE(2138),
    [sym_preproc_undef] = STATE(2138),
    [aux_sym_class_declaration_repeat1] = STATE(3810),
    [aux_sym_lambda_expression_repeat1] = STATE(4141),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(2047),
    [anon_sym_ref] = ACTIONS(2049),
    [anon_sym_LBRACE] = ACTIONS(1611),
    [anon_sym_delegate] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1679),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(2053),
    [anon_sym_TILDE] = ACTIONS(2053),
    [anon_sym_PLUS_PLUS] = ACTIONS(2053),
    [anon_sym_DASH_DASH] = ACTIONS(2053),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(2051),
    [anon_sym_DASH] = ACTIONS(2051),
    [anon_sym_STAR] = ACTIONS(1685),
    [anon_sym_CARET] = ACTIONS(2053),
    [anon_sym_AMP] = ACTIONS(2053),
    [anon_sym_this] = ACTIONS(1627),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1629),
    [anon_sym_unchecked] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(2055),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2057),
    [anon_sym_DOT_DOT] = ACTIONS(2059),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_stackalloc] = ACTIONS(1641),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(1647),
    [anon_sym___reftype] = ACTIONS(1649),
    [anon_sym___refvalue] = ACTIONS(1651),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1659),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [2139] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3921),
    [sym__name] = STATE(6889),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2854),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(6991),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5588),
    [sym_non_lvalue_expression] = STATE(5735),
    [sym_lvalue_expression] = STATE(4295),
    [sym__expression_statement_expression] = STATE(5733),
    [sym_assignment_expression] = STATE(5734),
    [sym_binary_expression] = STATE(5733),
    [sym_postfix_unary_expression] = STATE(5734),
    [sym_prefix_unary_expression] = STATE(5734),
    [sym__pointer_indirection_expression] = STATE(3911),
    [sym_query_expression] = STATE(5733),
    [sym_from_clause] = STATE(7393),
    [sym_conditional_expression] = STATE(5733),
    [sym_conditional_access_expression] = STATE(5733),
    [sym_as_expression] = STATE(5733),
    [sym_is_expression] = STATE(5733),
    [sym_is_pattern_expression] = STATE(5733),
    [sym_cast_expression] = STATE(5733),
    [sym_checked_expression] = STATE(5733),
    [sym_invocation_expression] = STATE(5734),
    [sym_switch_expression] = STATE(5733),
    [sym_await_expression] = STATE(5734),
    [sym_throw_expression] = STATE(5733),
    [sym_element_access_expression] = STATE(3911),
    [sym_interpolated_string_expression] = STATE(5733),
    [sym_member_access_expression] = STATE(3911),
    [sym_object_creation_expression] = STATE(5734),
    [sym_parenthesized_expression] = STATE(5734),
    [sym__parenthesized_lvalue_expression] = STATE(3911),
    [sym_lambda_expression] = STATE(5733),
    [sym__lambda_parameters] = STATE(9313),
    [sym_array_creation_expression] = STATE(5733),
    [sym_anonymous_method_expression] = STATE(5733),
    [sym_anonymous_object_creation_expression] = STATE(5733),
    [sym_implicit_array_creation_expression] = STATE(5733),
    [sym_implicit_object_creation_expression] = STATE(5733),
    [sym_implicit_stackalloc_expression] = STATE(5733),
    [sym_initializer_expression] = STATE(5733),
    [sym_default_expression] = STATE(5733),
    [sym_with_expression] = STATE(5733),
    [sym_sizeof_expression] = STATE(5733),
    [sym_typeof_expression] = STATE(5733),
    [sym_makeref_expression] = STATE(5733),
    [sym_ref_expression] = STATE(5733),
    [sym_reftype_expression] = STATE(5733),
    [sym_refvalue_expression] = STATE(5733),
    [sym_stackalloc_expression] = STATE(5733),
    [sym_range_expression] = STATE(5733),
    [sym_tuple_expression] = STATE(3911),
    [sym_literal] = STATE(5733),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2798),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(5733),
    [sym_preproc_region] = STATE(2139),
    [sym_preproc_endregion] = STATE(2139),
    [sym_preproc_line] = STATE(2139),
    [sym_preproc_pragma] = STATE(2139),
    [sym_preproc_nullable] = STATE(2139),
    [sym_preproc_error] = STATE(2139),
    [sym_preproc_define] = STATE(2139),
    [sym_preproc_undef] = STATE(2139),
    [aux_sym_class_declaration_repeat1] = STATE(3805),
    [aux_sym_lambda_expression_repeat1] = STATE(4122),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_LPAREN] = ACTIONS(1591),
    [anon_sym_ref] = ACTIONS(1593),
    [anon_sym_LBRACE] = ACTIONS(1377),
    [anon_sym_delegate] = ACTIONS(1379),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1443),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1597),
    [anon_sym_TILDE] = ACTIONS(1597),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1595),
    [anon_sym_DASH] = ACTIONS(1595),
    [anon_sym_STAR] = ACTIONS(1449),
    [anon_sym_CARET] = ACTIONS(1597),
    [anon_sym_AMP] = ACTIONS(1597),
    [anon_sym_this] = ACTIONS(1393),
    [anon_sym_scoped] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1397),
    [sym_predefined_type] = ACTIONS(1399),
    [anon_sym_unchecked] = ACTIONS(1383),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1599),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1601),
    [anon_sym_DOT_DOT] = ACTIONS(1603),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_stackalloc] = ACTIONS(1413),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(1419),
    [anon_sym___reftype] = ACTIONS(1421),
    [anon_sym___refvalue] = ACTIONS(1423),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
  },
  [2140] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3921),
    [sym__name] = STATE(6889),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2854),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(6991),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5587),
    [sym_non_lvalue_expression] = STATE(5735),
    [sym_lvalue_expression] = STATE(4295),
    [sym__expression_statement_expression] = STATE(5733),
    [sym_assignment_expression] = STATE(5734),
    [sym_binary_expression] = STATE(5733),
    [sym_postfix_unary_expression] = STATE(5734),
    [sym_prefix_unary_expression] = STATE(5734),
    [sym__pointer_indirection_expression] = STATE(3911),
    [sym_query_expression] = STATE(5733),
    [sym_from_clause] = STATE(7393),
    [sym_conditional_expression] = STATE(5733),
    [sym_conditional_access_expression] = STATE(5733),
    [sym_as_expression] = STATE(5733),
    [sym_is_expression] = STATE(5733),
    [sym_is_pattern_expression] = STATE(5733),
    [sym_cast_expression] = STATE(5733),
    [sym_checked_expression] = STATE(5733),
    [sym_invocation_expression] = STATE(5734),
    [sym_switch_expression] = STATE(5733),
    [sym_await_expression] = STATE(5734),
    [sym_throw_expression] = STATE(5733),
    [sym_element_access_expression] = STATE(3911),
    [sym_interpolated_string_expression] = STATE(5733),
    [sym_member_access_expression] = STATE(3911),
    [sym_object_creation_expression] = STATE(5734),
    [sym_parenthesized_expression] = STATE(5734),
    [sym__parenthesized_lvalue_expression] = STATE(3911),
    [sym_lambda_expression] = STATE(5733),
    [sym__lambda_parameters] = STATE(9313),
    [sym_array_creation_expression] = STATE(5733),
    [sym_anonymous_method_expression] = STATE(5733),
    [sym_anonymous_object_creation_expression] = STATE(5733),
    [sym_implicit_array_creation_expression] = STATE(5733),
    [sym_implicit_object_creation_expression] = STATE(5733),
    [sym_implicit_stackalloc_expression] = STATE(5733),
    [sym_initializer_expression] = STATE(5733),
    [sym_default_expression] = STATE(5733),
    [sym_with_expression] = STATE(5733),
    [sym_sizeof_expression] = STATE(5733),
    [sym_typeof_expression] = STATE(5733),
    [sym_makeref_expression] = STATE(5733),
    [sym_ref_expression] = STATE(5733),
    [sym_reftype_expression] = STATE(5733),
    [sym_refvalue_expression] = STATE(5733),
    [sym_stackalloc_expression] = STATE(5733),
    [sym_range_expression] = STATE(5733),
    [sym_tuple_expression] = STATE(3911),
    [sym_literal] = STATE(5733),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2798),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(5733),
    [sym_preproc_region] = STATE(2140),
    [sym_preproc_endregion] = STATE(2140),
    [sym_preproc_line] = STATE(2140),
    [sym_preproc_pragma] = STATE(2140),
    [sym_preproc_nullable] = STATE(2140),
    [sym_preproc_error] = STATE(2140),
    [sym_preproc_define] = STATE(2140),
    [sym_preproc_undef] = STATE(2140),
    [aux_sym_class_declaration_repeat1] = STATE(3805),
    [aux_sym_lambda_expression_repeat1] = STATE(4122),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_LPAREN] = ACTIONS(1591),
    [anon_sym_ref] = ACTIONS(1593),
    [anon_sym_LBRACE] = ACTIONS(1377),
    [anon_sym_delegate] = ACTIONS(1379),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1443),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1597),
    [anon_sym_TILDE] = ACTIONS(1597),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1595),
    [anon_sym_DASH] = ACTIONS(1595),
    [anon_sym_STAR] = ACTIONS(1449),
    [anon_sym_CARET] = ACTIONS(1597),
    [anon_sym_AMP] = ACTIONS(1597),
    [anon_sym_this] = ACTIONS(1393),
    [anon_sym_scoped] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1397),
    [sym_predefined_type] = ACTIONS(1399),
    [anon_sym_unchecked] = ACTIONS(1383),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1599),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1601),
    [anon_sym_DOT_DOT] = ACTIONS(1603),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_stackalloc] = ACTIONS(1413),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(1419),
    [anon_sym___reftype] = ACTIONS(1421),
    [anon_sym___refvalue] = ACTIONS(1423),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
  },
  [2141] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3921),
    [sym__name] = STATE(6919),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2868),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(6950),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5324),
    [sym_non_lvalue_expression] = STATE(5735),
    [sym_lvalue_expression] = STATE(4054),
    [sym__expression_statement_expression] = STATE(5733),
    [sym_assignment_expression] = STATE(5734),
    [sym_binary_expression] = STATE(5733),
    [sym_postfix_unary_expression] = STATE(5734),
    [sym_prefix_unary_expression] = STATE(5734),
    [sym__pointer_indirection_expression] = STATE(3911),
    [sym_query_expression] = STATE(5733),
    [sym_from_clause] = STATE(7400),
    [sym_conditional_expression] = STATE(5733),
    [sym_conditional_access_expression] = STATE(5733),
    [sym_as_expression] = STATE(5733),
    [sym_is_expression] = STATE(5733),
    [sym_is_pattern_expression] = STATE(5733),
    [sym_cast_expression] = STATE(5733),
    [sym_checked_expression] = STATE(5733),
    [sym_invocation_expression] = STATE(5734),
    [sym_switch_expression] = STATE(5733),
    [sym_await_expression] = STATE(5734),
    [sym_throw_expression] = STATE(5733),
    [sym_element_access_expression] = STATE(3911),
    [sym_interpolated_string_expression] = STATE(5733),
    [sym_member_access_expression] = STATE(3911),
    [sym_object_creation_expression] = STATE(5734),
    [sym_parenthesized_expression] = STATE(5734),
    [sym__parenthesized_lvalue_expression] = STATE(3911),
    [sym_lambda_expression] = STATE(5733),
    [sym__lambda_parameters] = STATE(9693),
    [sym_array_creation_expression] = STATE(5733),
    [sym_anonymous_method_expression] = STATE(5733),
    [sym_anonymous_object_creation_expression] = STATE(5733),
    [sym_implicit_array_creation_expression] = STATE(5733),
    [sym_implicit_object_creation_expression] = STATE(5733),
    [sym_implicit_stackalloc_expression] = STATE(5733),
    [sym_initializer_expression] = STATE(5733),
    [sym_default_expression] = STATE(5733),
    [sym_with_expression] = STATE(5733),
    [sym_sizeof_expression] = STATE(5733),
    [sym_typeof_expression] = STATE(5733),
    [sym_makeref_expression] = STATE(5733),
    [sym_ref_expression] = STATE(5733),
    [sym_reftype_expression] = STATE(5733),
    [sym_refvalue_expression] = STATE(5733),
    [sym_stackalloc_expression] = STATE(5733),
    [sym_range_expression] = STATE(5733),
    [sym_tuple_expression] = STATE(3911),
    [sym_literal] = STATE(5733),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2798),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(5733),
    [sym_preproc_region] = STATE(2141),
    [sym_preproc_endregion] = STATE(2141),
    [sym_preproc_line] = STATE(2141),
    [sym_preproc_pragma] = STATE(2141),
    [sym_preproc_nullable] = STATE(2141),
    [sym_preproc_error] = STATE(2141),
    [sym_preproc_define] = STATE(2141),
    [sym_preproc_undef] = STATE(2141),
    [aux_sym_class_declaration_repeat1] = STATE(3791),
    [aux_sym_lambda_expression_repeat1] = STATE(4075),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_LPAREN] = ACTIONS(1373),
    [anon_sym_ref] = ACTIONS(1375),
    [anon_sym_LBRACE] = ACTIONS(1377),
    [anon_sym_delegate] = ACTIONS(1379),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1381),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1387),
    [anon_sym_TILDE] = ACTIONS(1387),
    [anon_sym_PLUS_PLUS] = ACTIONS(1387),
    [anon_sym_DASH_DASH] = ACTIONS(1387),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1385),
    [anon_sym_DASH] = ACTIONS(1385),
    [anon_sym_STAR] = ACTIONS(1391),
    [anon_sym_CARET] = ACTIONS(1387),
    [anon_sym_AMP] = ACTIONS(1387),
    [anon_sym_this] = ACTIONS(1393),
    [anon_sym_scoped] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1397),
    [sym_predefined_type] = ACTIONS(1399),
    [anon_sym_unchecked] = ACTIONS(1383),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1403),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1405),
    [anon_sym_DOT_DOT] = ACTIONS(1407),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_stackalloc] = ACTIONS(1413),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(1419),
    [anon_sym___reftype] = ACTIONS(1421),
    [anon_sym___refvalue] = ACTIONS(1423),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
  },
  [2142] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3921),
    [sym__name] = STATE(6889),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2854),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(6991),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5585),
    [sym_non_lvalue_expression] = STATE(5735),
    [sym_lvalue_expression] = STATE(4295),
    [sym__expression_statement_expression] = STATE(5733),
    [sym_assignment_expression] = STATE(5734),
    [sym_binary_expression] = STATE(5733),
    [sym_postfix_unary_expression] = STATE(5734),
    [sym_prefix_unary_expression] = STATE(5734),
    [sym__pointer_indirection_expression] = STATE(3911),
    [sym_query_expression] = STATE(5733),
    [sym_from_clause] = STATE(7393),
    [sym_conditional_expression] = STATE(5733),
    [sym_conditional_access_expression] = STATE(5733),
    [sym_as_expression] = STATE(5733),
    [sym_is_expression] = STATE(5733),
    [sym_is_pattern_expression] = STATE(5733),
    [sym_cast_expression] = STATE(5733),
    [sym_checked_expression] = STATE(5733),
    [sym_invocation_expression] = STATE(5734),
    [sym_switch_expression] = STATE(5733),
    [sym_await_expression] = STATE(5734),
    [sym_throw_expression] = STATE(5733),
    [sym_element_access_expression] = STATE(3911),
    [sym_interpolated_string_expression] = STATE(5733),
    [sym_member_access_expression] = STATE(3911),
    [sym_object_creation_expression] = STATE(5734),
    [sym_parenthesized_expression] = STATE(5734),
    [sym__parenthesized_lvalue_expression] = STATE(3911),
    [sym_lambda_expression] = STATE(5733),
    [sym__lambda_parameters] = STATE(9313),
    [sym_array_creation_expression] = STATE(5733),
    [sym_anonymous_method_expression] = STATE(5733),
    [sym_anonymous_object_creation_expression] = STATE(5733),
    [sym_implicit_array_creation_expression] = STATE(5733),
    [sym_implicit_object_creation_expression] = STATE(5733),
    [sym_implicit_stackalloc_expression] = STATE(5733),
    [sym_initializer_expression] = STATE(5733),
    [sym_default_expression] = STATE(5733),
    [sym_with_expression] = STATE(5733),
    [sym_sizeof_expression] = STATE(5733),
    [sym_typeof_expression] = STATE(5733),
    [sym_makeref_expression] = STATE(5733),
    [sym_ref_expression] = STATE(5733),
    [sym_reftype_expression] = STATE(5733),
    [sym_refvalue_expression] = STATE(5733),
    [sym_stackalloc_expression] = STATE(5733),
    [sym_range_expression] = STATE(5733),
    [sym_tuple_expression] = STATE(3911),
    [sym_literal] = STATE(5733),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2798),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(5733),
    [sym_preproc_region] = STATE(2142),
    [sym_preproc_endregion] = STATE(2142),
    [sym_preproc_line] = STATE(2142),
    [sym_preproc_pragma] = STATE(2142),
    [sym_preproc_nullable] = STATE(2142),
    [sym_preproc_error] = STATE(2142),
    [sym_preproc_define] = STATE(2142),
    [sym_preproc_undef] = STATE(2142),
    [aux_sym_class_declaration_repeat1] = STATE(3805),
    [aux_sym_lambda_expression_repeat1] = STATE(4122),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_LPAREN] = ACTIONS(1591),
    [anon_sym_ref] = ACTIONS(1593),
    [anon_sym_LBRACE] = ACTIONS(1377),
    [anon_sym_delegate] = ACTIONS(1379),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1443),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1597),
    [anon_sym_TILDE] = ACTIONS(1597),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1595),
    [anon_sym_DASH] = ACTIONS(1595),
    [anon_sym_STAR] = ACTIONS(1449),
    [anon_sym_CARET] = ACTIONS(1597),
    [anon_sym_AMP] = ACTIONS(1597),
    [anon_sym_this] = ACTIONS(1393),
    [anon_sym_scoped] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1397),
    [sym_predefined_type] = ACTIONS(1399),
    [anon_sym_unchecked] = ACTIONS(1383),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1599),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1601),
    [anon_sym_DOT_DOT] = ACTIONS(1603),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_stackalloc] = ACTIONS(1413),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(1419),
    [anon_sym___reftype] = ACTIONS(1421),
    [anon_sym___refvalue] = ACTIONS(1423),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
  },
  [2143] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3921),
    [sym__name] = STATE(6889),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2854),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(6991),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5534),
    [sym_non_lvalue_expression] = STATE(5735),
    [sym_lvalue_expression] = STATE(4295),
    [sym__expression_statement_expression] = STATE(5733),
    [sym_assignment_expression] = STATE(5734),
    [sym_binary_expression] = STATE(5733),
    [sym_postfix_unary_expression] = STATE(5734),
    [sym_prefix_unary_expression] = STATE(5734),
    [sym__pointer_indirection_expression] = STATE(3911),
    [sym_query_expression] = STATE(5733),
    [sym_from_clause] = STATE(7393),
    [sym_conditional_expression] = STATE(5733),
    [sym_conditional_access_expression] = STATE(5733),
    [sym_as_expression] = STATE(5733),
    [sym_is_expression] = STATE(5733),
    [sym_is_pattern_expression] = STATE(5733),
    [sym_cast_expression] = STATE(5733),
    [sym_checked_expression] = STATE(5733),
    [sym_invocation_expression] = STATE(5734),
    [sym_switch_expression] = STATE(5733),
    [sym_await_expression] = STATE(5734),
    [sym_throw_expression] = STATE(5733),
    [sym_element_access_expression] = STATE(3911),
    [sym_interpolated_string_expression] = STATE(5733),
    [sym_member_access_expression] = STATE(3911),
    [sym_object_creation_expression] = STATE(5734),
    [sym_parenthesized_expression] = STATE(5734),
    [sym__parenthesized_lvalue_expression] = STATE(3911),
    [sym_lambda_expression] = STATE(5733),
    [sym__lambda_parameters] = STATE(9313),
    [sym_array_creation_expression] = STATE(5733),
    [sym_anonymous_method_expression] = STATE(5733),
    [sym_anonymous_object_creation_expression] = STATE(5733),
    [sym_implicit_array_creation_expression] = STATE(5733),
    [sym_implicit_object_creation_expression] = STATE(5733),
    [sym_implicit_stackalloc_expression] = STATE(5733),
    [sym_initializer_expression] = STATE(5733),
    [sym_default_expression] = STATE(5733),
    [sym_with_expression] = STATE(5733),
    [sym_sizeof_expression] = STATE(5733),
    [sym_typeof_expression] = STATE(5733),
    [sym_makeref_expression] = STATE(5733),
    [sym_ref_expression] = STATE(5733),
    [sym_reftype_expression] = STATE(5733),
    [sym_refvalue_expression] = STATE(5733),
    [sym_stackalloc_expression] = STATE(5733),
    [sym_range_expression] = STATE(5733),
    [sym_tuple_expression] = STATE(3911),
    [sym_literal] = STATE(5733),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2798),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(5733),
    [sym_preproc_region] = STATE(2143),
    [sym_preproc_endregion] = STATE(2143),
    [sym_preproc_line] = STATE(2143),
    [sym_preproc_pragma] = STATE(2143),
    [sym_preproc_nullable] = STATE(2143),
    [sym_preproc_error] = STATE(2143),
    [sym_preproc_define] = STATE(2143),
    [sym_preproc_undef] = STATE(2143),
    [aux_sym_class_declaration_repeat1] = STATE(3805),
    [aux_sym_lambda_expression_repeat1] = STATE(4122),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_LPAREN] = ACTIONS(1591),
    [anon_sym_ref] = ACTIONS(1593),
    [anon_sym_LBRACE] = ACTIONS(1377),
    [anon_sym_delegate] = ACTIONS(1379),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1443),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1597),
    [anon_sym_TILDE] = ACTIONS(1597),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1595),
    [anon_sym_DASH] = ACTIONS(1595),
    [anon_sym_STAR] = ACTIONS(1449),
    [anon_sym_CARET] = ACTIONS(1597),
    [anon_sym_AMP] = ACTIONS(1597),
    [anon_sym_this] = ACTIONS(1393),
    [anon_sym_scoped] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1397),
    [sym_predefined_type] = ACTIONS(1399),
    [anon_sym_unchecked] = ACTIONS(1383),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1599),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1601),
    [anon_sym_DOT_DOT] = ACTIONS(1603),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_stackalloc] = ACTIONS(1413),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(1419),
    [anon_sym___reftype] = ACTIONS(1421),
    [anon_sym___refvalue] = ACTIONS(1423),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
  },
  [2144] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3921),
    [sym__name] = STATE(6889),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2854),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(6991),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5584),
    [sym_non_lvalue_expression] = STATE(5735),
    [sym_lvalue_expression] = STATE(4295),
    [sym__expression_statement_expression] = STATE(5733),
    [sym_assignment_expression] = STATE(5734),
    [sym_binary_expression] = STATE(5733),
    [sym_postfix_unary_expression] = STATE(5734),
    [sym_prefix_unary_expression] = STATE(5734),
    [sym__pointer_indirection_expression] = STATE(3911),
    [sym_query_expression] = STATE(5733),
    [sym_from_clause] = STATE(7393),
    [sym_conditional_expression] = STATE(5733),
    [sym_conditional_access_expression] = STATE(5733),
    [sym_as_expression] = STATE(5733),
    [sym_is_expression] = STATE(5733),
    [sym_is_pattern_expression] = STATE(5733),
    [sym_cast_expression] = STATE(5733),
    [sym_checked_expression] = STATE(5733),
    [sym_invocation_expression] = STATE(5734),
    [sym_switch_expression] = STATE(5733),
    [sym_await_expression] = STATE(5734),
    [sym_throw_expression] = STATE(5733),
    [sym_element_access_expression] = STATE(3911),
    [sym_interpolated_string_expression] = STATE(5733),
    [sym_member_access_expression] = STATE(3911),
    [sym_object_creation_expression] = STATE(5734),
    [sym_parenthesized_expression] = STATE(5734),
    [sym__parenthesized_lvalue_expression] = STATE(3911),
    [sym_lambda_expression] = STATE(5733),
    [sym__lambda_parameters] = STATE(9313),
    [sym_array_creation_expression] = STATE(5733),
    [sym_anonymous_method_expression] = STATE(5733),
    [sym_anonymous_object_creation_expression] = STATE(5733),
    [sym_implicit_array_creation_expression] = STATE(5733),
    [sym_implicit_object_creation_expression] = STATE(5733),
    [sym_implicit_stackalloc_expression] = STATE(5733),
    [sym_initializer_expression] = STATE(5733),
    [sym_default_expression] = STATE(5733),
    [sym_with_expression] = STATE(5733),
    [sym_sizeof_expression] = STATE(5733),
    [sym_typeof_expression] = STATE(5733),
    [sym_makeref_expression] = STATE(5733),
    [sym_ref_expression] = STATE(5733),
    [sym_reftype_expression] = STATE(5733),
    [sym_refvalue_expression] = STATE(5733),
    [sym_stackalloc_expression] = STATE(5733),
    [sym_range_expression] = STATE(5733),
    [sym_tuple_expression] = STATE(3911),
    [sym_literal] = STATE(5733),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2798),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(5733),
    [sym_preproc_region] = STATE(2144),
    [sym_preproc_endregion] = STATE(2144),
    [sym_preproc_line] = STATE(2144),
    [sym_preproc_pragma] = STATE(2144),
    [sym_preproc_nullable] = STATE(2144),
    [sym_preproc_error] = STATE(2144),
    [sym_preproc_define] = STATE(2144),
    [sym_preproc_undef] = STATE(2144),
    [aux_sym_class_declaration_repeat1] = STATE(3805),
    [aux_sym_lambda_expression_repeat1] = STATE(4122),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_LPAREN] = ACTIONS(1591),
    [anon_sym_ref] = ACTIONS(1593),
    [anon_sym_LBRACE] = ACTIONS(1377),
    [anon_sym_delegate] = ACTIONS(1379),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1443),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1597),
    [anon_sym_TILDE] = ACTIONS(1597),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1595),
    [anon_sym_DASH] = ACTIONS(1595),
    [anon_sym_STAR] = ACTIONS(1449),
    [anon_sym_CARET] = ACTIONS(1597),
    [anon_sym_AMP] = ACTIONS(1597),
    [anon_sym_this] = ACTIONS(1393),
    [anon_sym_scoped] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1397),
    [sym_predefined_type] = ACTIONS(1399),
    [anon_sym_unchecked] = ACTIONS(1383),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1599),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1601),
    [anon_sym_DOT_DOT] = ACTIONS(1603),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_stackalloc] = ACTIONS(1413),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(1419),
    [anon_sym___reftype] = ACTIONS(1421),
    [anon_sym___refvalue] = ACTIONS(1423),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
  },
  [2145] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3921),
    [sym__name] = STATE(6889),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2854),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(6991),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5583),
    [sym_non_lvalue_expression] = STATE(5735),
    [sym_lvalue_expression] = STATE(4295),
    [sym__expression_statement_expression] = STATE(5733),
    [sym_assignment_expression] = STATE(5734),
    [sym_binary_expression] = STATE(5733),
    [sym_postfix_unary_expression] = STATE(5734),
    [sym_prefix_unary_expression] = STATE(5734),
    [sym__pointer_indirection_expression] = STATE(3911),
    [sym_query_expression] = STATE(5733),
    [sym_from_clause] = STATE(7393),
    [sym_conditional_expression] = STATE(5733),
    [sym_conditional_access_expression] = STATE(5733),
    [sym_as_expression] = STATE(5733),
    [sym_is_expression] = STATE(5733),
    [sym_is_pattern_expression] = STATE(5733),
    [sym_cast_expression] = STATE(5733),
    [sym_checked_expression] = STATE(5733),
    [sym_invocation_expression] = STATE(5734),
    [sym_switch_expression] = STATE(5733),
    [sym_await_expression] = STATE(5734),
    [sym_throw_expression] = STATE(5733),
    [sym_element_access_expression] = STATE(3911),
    [sym_interpolated_string_expression] = STATE(5733),
    [sym_member_access_expression] = STATE(3911),
    [sym_object_creation_expression] = STATE(5734),
    [sym_parenthesized_expression] = STATE(5734),
    [sym__parenthesized_lvalue_expression] = STATE(3911),
    [sym_lambda_expression] = STATE(5733),
    [sym__lambda_parameters] = STATE(9313),
    [sym_array_creation_expression] = STATE(5733),
    [sym_anonymous_method_expression] = STATE(5733),
    [sym_anonymous_object_creation_expression] = STATE(5733),
    [sym_implicit_array_creation_expression] = STATE(5733),
    [sym_implicit_object_creation_expression] = STATE(5733),
    [sym_implicit_stackalloc_expression] = STATE(5733),
    [sym_initializer_expression] = STATE(5733),
    [sym_default_expression] = STATE(5733),
    [sym_with_expression] = STATE(5733),
    [sym_sizeof_expression] = STATE(5733),
    [sym_typeof_expression] = STATE(5733),
    [sym_makeref_expression] = STATE(5733),
    [sym_ref_expression] = STATE(5733),
    [sym_reftype_expression] = STATE(5733),
    [sym_refvalue_expression] = STATE(5733),
    [sym_stackalloc_expression] = STATE(5733),
    [sym_range_expression] = STATE(5733),
    [sym_tuple_expression] = STATE(3911),
    [sym_literal] = STATE(5733),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2798),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(5733),
    [sym_preproc_region] = STATE(2145),
    [sym_preproc_endregion] = STATE(2145),
    [sym_preproc_line] = STATE(2145),
    [sym_preproc_pragma] = STATE(2145),
    [sym_preproc_nullable] = STATE(2145),
    [sym_preproc_error] = STATE(2145),
    [sym_preproc_define] = STATE(2145),
    [sym_preproc_undef] = STATE(2145),
    [aux_sym_class_declaration_repeat1] = STATE(3805),
    [aux_sym_lambda_expression_repeat1] = STATE(4122),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_LPAREN] = ACTIONS(1591),
    [anon_sym_ref] = ACTIONS(1593),
    [anon_sym_LBRACE] = ACTIONS(1377),
    [anon_sym_delegate] = ACTIONS(1379),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1443),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1597),
    [anon_sym_TILDE] = ACTIONS(1597),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1595),
    [anon_sym_DASH] = ACTIONS(1595),
    [anon_sym_STAR] = ACTIONS(1449),
    [anon_sym_CARET] = ACTIONS(1597),
    [anon_sym_AMP] = ACTIONS(1597),
    [anon_sym_this] = ACTIONS(1393),
    [anon_sym_scoped] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1397),
    [sym_predefined_type] = ACTIONS(1399),
    [anon_sym_unchecked] = ACTIONS(1383),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1599),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1601),
    [anon_sym_DOT_DOT] = ACTIONS(1603),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_stackalloc] = ACTIONS(1413),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(1419),
    [anon_sym___reftype] = ACTIONS(1421),
    [anon_sym___refvalue] = ACTIONS(1423),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
  },
  [2146] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3921),
    [sym__name] = STATE(6889),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2854),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(6991),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5582),
    [sym_non_lvalue_expression] = STATE(5735),
    [sym_lvalue_expression] = STATE(4295),
    [sym__expression_statement_expression] = STATE(5733),
    [sym_assignment_expression] = STATE(5734),
    [sym_binary_expression] = STATE(5733),
    [sym_postfix_unary_expression] = STATE(5734),
    [sym_prefix_unary_expression] = STATE(5734),
    [sym__pointer_indirection_expression] = STATE(3911),
    [sym_query_expression] = STATE(5733),
    [sym_from_clause] = STATE(7393),
    [sym_conditional_expression] = STATE(5733),
    [sym_conditional_access_expression] = STATE(5733),
    [sym_as_expression] = STATE(5733),
    [sym_is_expression] = STATE(5733),
    [sym_is_pattern_expression] = STATE(5733),
    [sym_cast_expression] = STATE(5733),
    [sym_checked_expression] = STATE(5733),
    [sym_invocation_expression] = STATE(5734),
    [sym_switch_expression] = STATE(5733),
    [sym_await_expression] = STATE(5734),
    [sym_throw_expression] = STATE(5733),
    [sym_element_access_expression] = STATE(3911),
    [sym_interpolated_string_expression] = STATE(5733),
    [sym_member_access_expression] = STATE(3911),
    [sym_object_creation_expression] = STATE(5734),
    [sym_parenthesized_expression] = STATE(5734),
    [sym__parenthesized_lvalue_expression] = STATE(3911),
    [sym_lambda_expression] = STATE(5733),
    [sym__lambda_parameters] = STATE(9313),
    [sym_array_creation_expression] = STATE(5733),
    [sym_anonymous_method_expression] = STATE(5733),
    [sym_anonymous_object_creation_expression] = STATE(5733),
    [sym_implicit_array_creation_expression] = STATE(5733),
    [sym_implicit_object_creation_expression] = STATE(5733),
    [sym_implicit_stackalloc_expression] = STATE(5733),
    [sym_initializer_expression] = STATE(5733),
    [sym_default_expression] = STATE(5733),
    [sym_with_expression] = STATE(5733),
    [sym_sizeof_expression] = STATE(5733),
    [sym_typeof_expression] = STATE(5733),
    [sym_makeref_expression] = STATE(5733),
    [sym_ref_expression] = STATE(5733),
    [sym_reftype_expression] = STATE(5733),
    [sym_refvalue_expression] = STATE(5733),
    [sym_stackalloc_expression] = STATE(5733),
    [sym_range_expression] = STATE(5733),
    [sym_tuple_expression] = STATE(3911),
    [sym_literal] = STATE(5733),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2798),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(5733),
    [sym_preproc_region] = STATE(2146),
    [sym_preproc_endregion] = STATE(2146),
    [sym_preproc_line] = STATE(2146),
    [sym_preproc_pragma] = STATE(2146),
    [sym_preproc_nullable] = STATE(2146),
    [sym_preproc_error] = STATE(2146),
    [sym_preproc_define] = STATE(2146),
    [sym_preproc_undef] = STATE(2146),
    [aux_sym_class_declaration_repeat1] = STATE(3805),
    [aux_sym_lambda_expression_repeat1] = STATE(4122),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_LPAREN] = ACTIONS(1591),
    [anon_sym_ref] = ACTIONS(1593),
    [anon_sym_LBRACE] = ACTIONS(1377),
    [anon_sym_delegate] = ACTIONS(1379),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1443),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1597),
    [anon_sym_TILDE] = ACTIONS(1597),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1595),
    [anon_sym_DASH] = ACTIONS(1595),
    [anon_sym_STAR] = ACTIONS(1449),
    [anon_sym_CARET] = ACTIONS(1597),
    [anon_sym_AMP] = ACTIONS(1597),
    [anon_sym_this] = ACTIONS(1393),
    [anon_sym_scoped] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1397),
    [sym_predefined_type] = ACTIONS(1399),
    [anon_sym_unchecked] = ACTIONS(1383),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1599),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1601),
    [anon_sym_DOT_DOT] = ACTIONS(1603),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_stackalloc] = ACTIONS(1413),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(1419),
    [anon_sym___reftype] = ACTIONS(1421),
    [anon_sym___refvalue] = ACTIONS(1423),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
  },
  [2147] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7064),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(3922),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(3866),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7382),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9762),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(2147),
    [sym_preproc_endregion] = STATE(2147),
    [sym_preproc_line] = STATE(2147),
    [sym_preproc_pragma] = STATE(2147),
    [sym_preproc_nullable] = STATE(2147),
    [sym_preproc_error] = STATE(2147),
    [sym_preproc_define] = STATE(2147),
    [sym_preproc_undef] = STATE(2147),
    [aux_sym_class_declaration_repeat1] = STATE(3842),
    [aux_sym_lambda_expression_repeat1] = STATE(4280),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1351),
    [anon_sym_ref] = ACTIONS(1353),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1357),
    [anon_sym_TILDE] = ACTIONS(1357),
    [anon_sym_PLUS_PLUS] = ACTIONS(1357),
    [anon_sym_DASH_DASH] = ACTIONS(1357),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1355),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(1357),
    [anon_sym_AMP] = ACTIONS(1357),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1361),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1363),
    [anon_sym_DOT_DOT] = ACTIONS(1365),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [2148] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3921),
    [sym__name] = STATE(6889),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2854),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(6991),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5535),
    [sym_non_lvalue_expression] = STATE(5735),
    [sym_lvalue_expression] = STATE(4295),
    [sym__expression_statement_expression] = STATE(5733),
    [sym_assignment_expression] = STATE(5734),
    [sym_binary_expression] = STATE(5733),
    [sym_postfix_unary_expression] = STATE(5734),
    [sym_prefix_unary_expression] = STATE(5734),
    [sym__pointer_indirection_expression] = STATE(3911),
    [sym_query_expression] = STATE(5733),
    [sym_from_clause] = STATE(7393),
    [sym_conditional_expression] = STATE(5733),
    [sym_conditional_access_expression] = STATE(5733),
    [sym_as_expression] = STATE(5733),
    [sym_is_expression] = STATE(5733),
    [sym_is_pattern_expression] = STATE(5733),
    [sym_cast_expression] = STATE(5733),
    [sym_checked_expression] = STATE(5733),
    [sym_invocation_expression] = STATE(5734),
    [sym_switch_expression] = STATE(5733),
    [sym_await_expression] = STATE(5734),
    [sym_throw_expression] = STATE(5733),
    [sym_element_access_expression] = STATE(3911),
    [sym_interpolated_string_expression] = STATE(5733),
    [sym_member_access_expression] = STATE(3911),
    [sym_object_creation_expression] = STATE(5734),
    [sym_parenthesized_expression] = STATE(5734),
    [sym__parenthesized_lvalue_expression] = STATE(3911),
    [sym_lambda_expression] = STATE(5733),
    [sym__lambda_parameters] = STATE(9313),
    [sym_array_creation_expression] = STATE(5733),
    [sym_anonymous_method_expression] = STATE(5733),
    [sym_anonymous_object_creation_expression] = STATE(5733),
    [sym_implicit_array_creation_expression] = STATE(5733),
    [sym_implicit_object_creation_expression] = STATE(5733),
    [sym_implicit_stackalloc_expression] = STATE(5733),
    [sym_initializer_expression] = STATE(5733),
    [sym_default_expression] = STATE(5733),
    [sym_with_expression] = STATE(5733),
    [sym_sizeof_expression] = STATE(5733),
    [sym_typeof_expression] = STATE(5733),
    [sym_makeref_expression] = STATE(5733),
    [sym_ref_expression] = STATE(5733),
    [sym_reftype_expression] = STATE(5733),
    [sym_refvalue_expression] = STATE(5733),
    [sym_stackalloc_expression] = STATE(5733),
    [sym_range_expression] = STATE(5733),
    [sym_tuple_expression] = STATE(3911),
    [sym_literal] = STATE(5733),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2798),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(5733),
    [sym_preproc_region] = STATE(2148),
    [sym_preproc_endregion] = STATE(2148),
    [sym_preproc_line] = STATE(2148),
    [sym_preproc_pragma] = STATE(2148),
    [sym_preproc_nullable] = STATE(2148),
    [sym_preproc_error] = STATE(2148),
    [sym_preproc_define] = STATE(2148),
    [sym_preproc_undef] = STATE(2148),
    [aux_sym_class_declaration_repeat1] = STATE(3805),
    [aux_sym_lambda_expression_repeat1] = STATE(4122),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_LPAREN] = ACTIONS(1591),
    [anon_sym_ref] = ACTIONS(1593),
    [anon_sym_LBRACE] = ACTIONS(1377),
    [anon_sym_delegate] = ACTIONS(1379),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1443),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1597),
    [anon_sym_TILDE] = ACTIONS(1597),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1595),
    [anon_sym_DASH] = ACTIONS(1595),
    [anon_sym_STAR] = ACTIONS(1449),
    [anon_sym_CARET] = ACTIONS(1597),
    [anon_sym_AMP] = ACTIONS(1597),
    [anon_sym_this] = ACTIONS(1393),
    [anon_sym_scoped] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1397),
    [sym_predefined_type] = ACTIONS(1399),
    [anon_sym_unchecked] = ACTIONS(1383),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1599),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1601),
    [anon_sym_DOT_DOT] = ACTIONS(1603),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_stackalloc] = ACTIONS(1413),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(1419),
    [anon_sym___reftype] = ACTIONS(1421),
    [anon_sym___refvalue] = ACTIONS(1423),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
  },
  [2149] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3921),
    [sym__name] = STATE(6889),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2854),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(6991),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5536),
    [sym_non_lvalue_expression] = STATE(5735),
    [sym_lvalue_expression] = STATE(4295),
    [sym__expression_statement_expression] = STATE(5733),
    [sym_assignment_expression] = STATE(5734),
    [sym_binary_expression] = STATE(5733),
    [sym_postfix_unary_expression] = STATE(5734),
    [sym_prefix_unary_expression] = STATE(5734),
    [sym__pointer_indirection_expression] = STATE(3911),
    [sym_query_expression] = STATE(5733),
    [sym_from_clause] = STATE(7393),
    [sym_conditional_expression] = STATE(5733),
    [sym_conditional_access_expression] = STATE(5733),
    [sym_as_expression] = STATE(5733),
    [sym_is_expression] = STATE(5733),
    [sym_is_pattern_expression] = STATE(5733),
    [sym_cast_expression] = STATE(5733),
    [sym_checked_expression] = STATE(5733),
    [sym_invocation_expression] = STATE(5734),
    [sym_switch_expression] = STATE(5733),
    [sym_await_expression] = STATE(5734),
    [sym_throw_expression] = STATE(5733),
    [sym_element_access_expression] = STATE(3911),
    [sym_interpolated_string_expression] = STATE(5733),
    [sym_member_access_expression] = STATE(3911),
    [sym_object_creation_expression] = STATE(5734),
    [sym_parenthesized_expression] = STATE(5734),
    [sym__parenthesized_lvalue_expression] = STATE(3911),
    [sym_lambda_expression] = STATE(5733),
    [sym__lambda_parameters] = STATE(9313),
    [sym_array_creation_expression] = STATE(5733),
    [sym_anonymous_method_expression] = STATE(5733),
    [sym_anonymous_object_creation_expression] = STATE(5733),
    [sym_implicit_array_creation_expression] = STATE(5733),
    [sym_implicit_object_creation_expression] = STATE(5733),
    [sym_implicit_stackalloc_expression] = STATE(5733),
    [sym_initializer_expression] = STATE(5733),
    [sym_default_expression] = STATE(5733),
    [sym_with_expression] = STATE(5733),
    [sym_sizeof_expression] = STATE(5733),
    [sym_typeof_expression] = STATE(5733),
    [sym_makeref_expression] = STATE(5733),
    [sym_ref_expression] = STATE(5733),
    [sym_reftype_expression] = STATE(5733),
    [sym_refvalue_expression] = STATE(5733),
    [sym_stackalloc_expression] = STATE(5733),
    [sym_range_expression] = STATE(5733),
    [sym_tuple_expression] = STATE(3911),
    [sym_literal] = STATE(5733),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2798),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(5733),
    [sym_preproc_region] = STATE(2149),
    [sym_preproc_endregion] = STATE(2149),
    [sym_preproc_line] = STATE(2149),
    [sym_preproc_pragma] = STATE(2149),
    [sym_preproc_nullable] = STATE(2149),
    [sym_preproc_error] = STATE(2149),
    [sym_preproc_define] = STATE(2149),
    [sym_preproc_undef] = STATE(2149),
    [aux_sym_class_declaration_repeat1] = STATE(3805),
    [aux_sym_lambda_expression_repeat1] = STATE(4122),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_LPAREN] = ACTIONS(1591),
    [anon_sym_ref] = ACTIONS(1593),
    [anon_sym_LBRACE] = ACTIONS(1377),
    [anon_sym_delegate] = ACTIONS(1379),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1443),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1597),
    [anon_sym_TILDE] = ACTIONS(1597),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1595),
    [anon_sym_DASH] = ACTIONS(1595),
    [anon_sym_STAR] = ACTIONS(1449),
    [anon_sym_CARET] = ACTIONS(1597),
    [anon_sym_AMP] = ACTIONS(1597),
    [anon_sym_this] = ACTIONS(1393),
    [anon_sym_scoped] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1397),
    [sym_predefined_type] = ACTIONS(1399),
    [anon_sym_unchecked] = ACTIONS(1383),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1599),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1601),
    [anon_sym_DOT_DOT] = ACTIONS(1603),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_stackalloc] = ACTIONS(1413),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(1419),
    [anon_sym___reftype] = ACTIONS(1421),
    [anon_sym___refvalue] = ACTIONS(1423),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
  },
  [2150] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3559),
    [sym__name] = STATE(6877),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2908),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6958),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4555),
    [sym_non_lvalue_expression] = STATE(4553),
    [sym_lvalue_expression] = STATE(3691),
    [sym__expression_statement_expression] = STATE(4559),
    [sym_assignment_expression] = STATE(4558),
    [sym_binary_expression] = STATE(4559),
    [sym_postfix_unary_expression] = STATE(4558),
    [sym_prefix_unary_expression] = STATE(4558),
    [sym__pointer_indirection_expression] = STATE(3560),
    [sym_query_expression] = STATE(4559),
    [sym_from_clause] = STATE(7406),
    [sym_conditional_expression] = STATE(4559),
    [sym_conditional_access_expression] = STATE(4559),
    [sym_as_expression] = STATE(4559),
    [sym_is_expression] = STATE(4559),
    [sym_is_pattern_expression] = STATE(4559),
    [sym_cast_expression] = STATE(4559),
    [sym_checked_expression] = STATE(4559),
    [sym_invocation_expression] = STATE(4558),
    [sym_switch_expression] = STATE(4559),
    [sym_await_expression] = STATE(4558),
    [sym_throw_expression] = STATE(4559),
    [sym_element_access_expression] = STATE(3560),
    [sym_interpolated_string_expression] = STATE(4559),
    [sym_member_access_expression] = STATE(3560),
    [sym_object_creation_expression] = STATE(4558),
    [sym_parenthesized_expression] = STATE(4558),
    [sym__parenthesized_lvalue_expression] = STATE(3560),
    [sym_lambda_expression] = STATE(4559),
    [sym__lambda_parameters] = STATE(9348),
    [sym_array_creation_expression] = STATE(4559),
    [sym_anonymous_method_expression] = STATE(4559),
    [sym_anonymous_object_creation_expression] = STATE(4559),
    [sym_implicit_array_creation_expression] = STATE(4559),
    [sym_implicit_object_creation_expression] = STATE(4559),
    [sym_implicit_stackalloc_expression] = STATE(4559),
    [sym_initializer_expression] = STATE(4559),
    [sym_default_expression] = STATE(4559),
    [sym_with_expression] = STATE(4559),
    [sym_sizeof_expression] = STATE(4559),
    [sym_typeof_expression] = STATE(4559),
    [sym_makeref_expression] = STATE(4559),
    [sym_ref_expression] = STATE(4559),
    [sym_reftype_expression] = STATE(4559),
    [sym_refvalue_expression] = STATE(4559),
    [sym_stackalloc_expression] = STATE(4559),
    [sym_range_expression] = STATE(4559),
    [sym_tuple_expression] = STATE(3560),
    [sym_literal] = STATE(4559),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4559),
    [sym_preproc_region] = STATE(2150),
    [sym_preproc_endregion] = STATE(2150),
    [sym_preproc_line] = STATE(2150),
    [sym_preproc_pragma] = STATE(2150),
    [sym_preproc_nullable] = STATE(2150),
    [sym_preproc_error] = STATE(2150),
    [sym_preproc_define] = STATE(2150),
    [sym_preproc_undef] = STATE(2150),
    [aux_sym_class_declaration_repeat1] = STATE(3810),
    [aux_sym_lambda_expression_repeat1] = STATE(4141),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(2047),
    [anon_sym_ref] = ACTIONS(2049),
    [anon_sym_LBRACE] = ACTIONS(1611),
    [anon_sym_delegate] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1679),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(2053),
    [anon_sym_TILDE] = ACTIONS(2053),
    [anon_sym_PLUS_PLUS] = ACTIONS(2053),
    [anon_sym_DASH_DASH] = ACTIONS(2053),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(2051),
    [anon_sym_DASH] = ACTIONS(2051),
    [anon_sym_STAR] = ACTIONS(1685),
    [anon_sym_CARET] = ACTIONS(2053),
    [anon_sym_AMP] = ACTIONS(2053),
    [anon_sym_this] = ACTIONS(1627),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1629),
    [anon_sym_unchecked] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(2055),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2057),
    [anon_sym_DOT_DOT] = ACTIONS(2059),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_stackalloc] = ACTIONS(1641),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(1647),
    [anon_sym___reftype] = ACTIONS(1649),
    [anon_sym___refvalue] = ACTIONS(1651),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1659),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [2151] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3559),
    [sym__name] = STATE(6877),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2908),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6958),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4557),
    [sym_non_lvalue_expression] = STATE(4553),
    [sym_lvalue_expression] = STATE(3691),
    [sym__expression_statement_expression] = STATE(4559),
    [sym_assignment_expression] = STATE(4558),
    [sym_binary_expression] = STATE(4559),
    [sym_postfix_unary_expression] = STATE(4558),
    [sym_prefix_unary_expression] = STATE(4558),
    [sym__pointer_indirection_expression] = STATE(3560),
    [sym_query_expression] = STATE(4559),
    [sym_from_clause] = STATE(7406),
    [sym_conditional_expression] = STATE(4559),
    [sym_conditional_access_expression] = STATE(4559),
    [sym_as_expression] = STATE(4559),
    [sym_is_expression] = STATE(4559),
    [sym_is_pattern_expression] = STATE(4559),
    [sym_cast_expression] = STATE(4559),
    [sym_checked_expression] = STATE(4559),
    [sym_invocation_expression] = STATE(4558),
    [sym_switch_expression] = STATE(4559),
    [sym_await_expression] = STATE(4558),
    [sym_throw_expression] = STATE(4559),
    [sym_element_access_expression] = STATE(3560),
    [sym_interpolated_string_expression] = STATE(4559),
    [sym_member_access_expression] = STATE(3560),
    [sym_object_creation_expression] = STATE(4558),
    [sym_parenthesized_expression] = STATE(4558),
    [sym__parenthesized_lvalue_expression] = STATE(3560),
    [sym_lambda_expression] = STATE(4559),
    [sym__lambda_parameters] = STATE(9348),
    [sym_array_creation_expression] = STATE(4559),
    [sym_anonymous_method_expression] = STATE(4559),
    [sym_anonymous_object_creation_expression] = STATE(4559),
    [sym_implicit_array_creation_expression] = STATE(4559),
    [sym_implicit_object_creation_expression] = STATE(4559),
    [sym_implicit_stackalloc_expression] = STATE(4559),
    [sym_initializer_expression] = STATE(4559),
    [sym_default_expression] = STATE(4559),
    [sym_with_expression] = STATE(4559),
    [sym_sizeof_expression] = STATE(4559),
    [sym_typeof_expression] = STATE(4559),
    [sym_makeref_expression] = STATE(4559),
    [sym_ref_expression] = STATE(4559),
    [sym_reftype_expression] = STATE(4559),
    [sym_refvalue_expression] = STATE(4559),
    [sym_stackalloc_expression] = STATE(4559),
    [sym_range_expression] = STATE(4559),
    [sym_tuple_expression] = STATE(3560),
    [sym_literal] = STATE(4559),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4559),
    [sym_preproc_region] = STATE(2151),
    [sym_preproc_endregion] = STATE(2151),
    [sym_preproc_line] = STATE(2151),
    [sym_preproc_pragma] = STATE(2151),
    [sym_preproc_nullable] = STATE(2151),
    [sym_preproc_error] = STATE(2151),
    [sym_preproc_define] = STATE(2151),
    [sym_preproc_undef] = STATE(2151),
    [aux_sym_class_declaration_repeat1] = STATE(3810),
    [aux_sym_lambda_expression_repeat1] = STATE(4141),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(2047),
    [anon_sym_ref] = ACTIONS(2049),
    [anon_sym_LBRACE] = ACTIONS(1611),
    [anon_sym_delegate] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1679),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(2053),
    [anon_sym_TILDE] = ACTIONS(2053),
    [anon_sym_PLUS_PLUS] = ACTIONS(2053),
    [anon_sym_DASH_DASH] = ACTIONS(2053),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(2051),
    [anon_sym_DASH] = ACTIONS(2051),
    [anon_sym_STAR] = ACTIONS(1685),
    [anon_sym_CARET] = ACTIONS(2053),
    [anon_sym_AMP] = ACTIONS(2053),
    [anon_sym_this] = ACTIONS(1627),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1629),
    [anon_sym_unchecked] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(2055),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2057),
    [anon_sym_DOT_DOT] = ACTIONS(2059),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_stackalloc] = ACTIONS(1641),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(1647),
    [anon_sym___reftype] = ACTIONS(1649),
    [anon_sym___refvalue] = ACTIONS(1651),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1659),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [2152] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3921),
    [sym__name] = STATE(6889),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2854),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(6991),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5537),
    [sym_non_lvalue_expression] = STATE(5735),
    [sym_lvalue_expression] = STATE(4295),
    [sym__expression_statement_expression] = STATE(5733),
    [sym_assignment_expression] = STATE(5734),
    [sym_binary_expression] = STATE(5733),
    [sym_postfix_unary_expression] = STATE(5734),
    [sym_prefix_unary_expression] = STATE(5734),
    [sym__pointer_indirection_expression] = STATE(3911),
    [sym_query_expression] = STATE(5733),
    [sym_from_clause] = STATE(7393),
    [sym_conditional_expression] = STATE(5733),
    [sym_conditional_access_expression] = STATE(5733),
    [sym_as_expression] = STATE(5733),
    [sym_is_expression] = STATE(5733),
    [sym_is_pattern_expression] = STATE(5733),
    [sym_cast_expression] = STATE(5733),
    [sym_checked_expression] = STATE(5733),
    [sym_invocation_expression] = STATE(5734),
    [sym_switch_expression] = STATE(5733),
    [sym_await_expression] = STATE(5734),
    [sym_throw_expression] = STATE(5733),
    [sym_element_access_expression] = STATE(3911),
    [sym_interpolated_string_expression] = STATE(5733),
    [sym_member_access_expression] = STATE(3911),
    [sym_object_creation_expression] = STATE(5734),
    [sym_parenthesized_expression] = STATE(5734),
    [sym__parenthesized_lvalue_expression] = STATE(3911),
    [sym_lambda_expression] = STATE(5733),
    [sym__lambda_parameters] = STATE(9313),
    [sym_array_creation_expression] = STATE(5733),
    [sym_anonymous_method_expression] = STATE(5733),
    [sym_anonymous_object_creation_expression] = STATE(5733),
    [sym_implicit_array_creation_expression] = STATE(5733),
    [sym_implicit_object_creation_expression] = STATE(5733),
    [sym_implicit_stackalloc_expression] = STATE(5733),
    [sym_initializer_expression] = STATE(5733),
    [sym_default_expression] = STATE(5733),
    [sym_with_expression] = STATE(5733),
    [sym_sizeof_expression] = STATE(5733),
    [sym_typeof_expression] = STATE(5733),
    [sym_makeref_expression] = STATE(5733),
    [sym_ref_expression] = STATE(5733),
    [sym_reftype_expression] = STATE(5733),
    [sym_refvalue_expression] = STATE(5733),
    [sym_stackalloc_expression] = STATE(5733),
    [sym_range_expression] = STATE(5733),
    [sym_tuple_expression] = STATE(3911),
    [sym_literal] = STATE(5733),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2798),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(5733),
    [sym_preproc_region] = STATE(2152),
    [sym_preproc_endregion] = STATE(2152),
    [sym_preproc_line] = STATE(2152),
    [sym_preproc_pragma] = STATE(2152),
    [sym_preproc_nullable] = STATE(2152),
    [sym_preproc_error] = STATE(2152),
    [sym_preproc_define] = STATE(2152),
    [sym_preproc_undef] = STATE(2152),
    [aux_sym_class_declaration_repeat1] = STATE(3805),
    [aux_sym_lambda_expression_repeat1] = STATE(4122),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_LPAREN] = ACTIONS(1591),
    [anon_sym_ref] = ACTIONS(1593),
    [anon_sym_LBRACE] = ACTIONS(1377),
    [anon_sym_delegate] = ACTIONS(1379),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1443),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1597),
    [anon_sym_TILDE] = ACTIONS(1597),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1595),
    [anon_sym_DASH] = ACTIONS(1595),
    [anon_sym_STAR] = ACTIONS(1449),
    [anon_sym_CARET] = ACTIONS(1597),
    [anon_sym_AMP] = ACTIONS(1597),
    [anon_sym_this] = ACTIONS(1393),
    [anon_sym_scoped] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1397),
    [sym_predefined_type] = ACTIONS(1399),
    [anon_sym_unchecked] = ACTIONS(1383),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1599),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1601),
    [anon_sym_DOT_DOT] = ACTIONS(1603),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_stackalloc] = ACTIONS(1413),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(1419),
    [anon_sym___reftype] = ACTIONS(1421),
    [anon_sym___refvalue] = ACTIONS(1423),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
  },
  [2153] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7108),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6019),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4313),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7382),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9733),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(2153),
    [sym_preproc_endregion] = STATE(2153),
    [sym_preproc_line] = STATE(2153),
    [sym_preproc_pragma] = STATE(2153),
    [sym_preproc_nullable] = STATE(2153),
    [sym_preproc_error] = STATE(2153),
    [sym_preproc_define] = STATE(2153),
    [sym_preproc_undef] = STATE(2153),
    [aux_sym_class_declaration_repeat1] = STATE(3802),
    [aux_sym_lambda_expression_repeat1] = STATE(4108),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1519),
    [anon_sym_ref] = ACTIONS(1521),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1523),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1529),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1531),
    [anon_sym_DOT_DOT] = ACTIONS(1533),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [2154] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3559),
    [sym__name] = STATE(6877),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2908),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7129),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4384),
    [sym_non_lvalue_expression] = STATE(4553),
    [sym_lvalue_expression] = STATE(3561),
    [sym__expression_statement_expression] = STATE(4559),
    [sym_assignment_expression] = STATE(4558),
    [sym_binary_expression] = STATE(4559),
    [sym_postfix_unary_expression] = STATE(4558),
    [sym_prefix_unary_expression] = STATE(4558),
    [sym__pointer_indirection_expression] = STATE(3560),
    [sym_query_expression] = STATE(4559),
    [sym_from_clause] = STATE(7385),
    [sym_conditional_expression] = STATE(4559),
    [sym_conditional_access_expression] = STATE(4559),
    [sym_as_expression] = STATE(4559),
    [sym_is_expression] = STATE(4559),
    [sym_is_pattern_expression] = STATE(4559),
    [sym_cast_expression] = STATE(4559),
    [sym_checked_expression] = STATE(4559),
    [sym_invocation_expression] = STATE(4558),
    [sym_switch_expression] = STATE(4559),
    [sym_await_expression] = STATE(4558),
    [sym_throw_expression] = STATE(4559),
    [sym_element_access_expression] = STATE(3560),
    [sym_interpolated_string_expression] = STATE(4559),
    [sym_member_access_expression] = STATE(3560),
    [sym_object_creation_expression] = STATE(4558),
    [sym_parenthesized_expression] = STATE(4558),
    [sym__parenthesized_lvalue_expression] = STATE(3560),
    [sym_lambda_expression] = STATE(4559),
    [sym__lambda_parameters] = STATE(9776),
    [sym_array_creation_expression] = STATE(4559),
    [sym_anonymous_method_expression] = STATE(4559),
    [sym_anonymous_object_creation_expression] = STATE(4559),
    [sym_implicit_array_creation_expression] = STATE(4559),
    [sym_implicit_object_creation_expression] = STATE(4559),
    [sym_implicit_stackalloc_expression] = STATE(4559),
    [sym_initializer_expression] = STATE(4559),
    [sym_default_expression] = STATE(4559),
    [sym_with_expression] = STATE(4559),
    [sym_sizeof_expression] = STATE(4559),
    [sym_typeof_expression] = STATE(4559),
    [sym_makeref_expression] = STATE(4559),
    [sym_ref_expression] = STATE(4559),
    [sym_reftype_expression] = STATE(4559),
    [sym_refvalue_expression] = STATE(4559),
    [sym_stackalloc_expression] = STATE(4559),
    [sym_range_expression] = STATE(4559),
    [sym_tuple_expression] = STATE(3560),
    [sym_literal] = STATE(4559),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4559),
    [sym_preproc_region] = STATE(2154),
    [sym_preproc_endregion] = STATE(2154),
    [sym_preproc_line] = STATE(2154),
    [sym_preproc_pragma] = STATE(2154),
    [sym_preproc_nullable] = STATE(2154),
    [sym_preproc_error] = STATE(2154),
    [sym_preproc_define] = STATE(2154),
    [sym_preproc_undef] = STATE(2154),
    [aux_sym_class_declaration_repeat1] = STATE(3843),
    [aux_sym_lambda_expression_repeat1] = STATE(4277),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(1675),
    [anon_sym_ref] = ACTIONS(1677),
    [anon_sym_LBRACE] = ACTIONS(1611),
    [anon_sym_delegate] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1679),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(1683),
    [anon_sym_TILDE] = ACTIONS(1683),
    [anon_sym_PLUS_PLUS] = ACTIONS(1683),
    [anon_sym_DASH_DASH] = ACTIONS(1683),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_DASH] = ACTIONS(1681),
    [anon_sym_STAR] = ACTIONS(1685),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1683),
    [anon_sym_this] = ACTIONS(1627),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1629),
    [anon_sym_unchecked] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(1687),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1689),
    [anon_sym_DOT_DOT] = ACTIONS(1691),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_stackalloc] = ACTIONS(1641),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(1647),
    [anon_sym___reftype] = ACTIONS(1649),
    [anon_sym___refvalue] = ACTIONS(1651),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1659),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [2155] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6967),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(3901),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(3858),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7382),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9625),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(2155),
    [sym_preproc_endregion] = STATE(2155),
    [sym_preproc_line] = STATE(2155),
    [sym_preproc_pragma] = STATE(2155),
    [sym_preproc_nullable] = STATE(2155),
    [sym_preproc_error] = STATE(2155),
    [sym_preproc_define] = STATE(2155),
    [sym_preproc_undef] = STATE(2155),
    [aux_sym_class_declaration_repeat1] = STATE(3851),
    [aux_sym_lambda_expression_repeat1] = STATE(4234),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_ref] = ACTIONS(1293),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1059),
    [anon_sym_TILDE] = ACTIONS(1059),
    [anon_sym_PLUS_PLUS] = ACTIONS(1059),
    [anon_sym_DASH_DASH] = ACTIONS(1059),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1061),
    [anon_sym_DASH] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(1303),
    [anon_sym_CARET] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1307),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1309),
    [anon_sym_DOT_DOT] = ACTIONS(1311),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [2156] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2802),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6967),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5070),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(3858),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7382),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9625),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(2156),
    [sym_preproc_endregion] = STATE(2156),
    [sym_preproc_line] = STATE(2156),
    [sym_preproc_pragma] = STATE(2156),
    [sym_preproc_nullable] = STATE(2156),
    [sym_preproc_error] = STATE(2156),
    [sym_preproc_define] = STATE(2156),
    [sym_preproc_undef] = STATE(2156),
    [aux_sym_class_declaration_repeat1] = STATE(3851),
    [aux_sym_lambda_expression_repeat1] = STATE(4234),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_ref] = ACTIONS(1293),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1059),
    [anon_sym_TILDE] = ACTIONS(1059),
    [anon_sym_PLUS_PLUS] = ACTIONS(1059),
    [anon_sym_DASH_DASH] = ACTIONS(1059),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1061),
    [anon_sym_DASH] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(1303),
    [anon_sym_CARET] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1307),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1309),
    [anon_sym_DOT_DOT] = ACTIONS(1311),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [2157] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3921),
    [sym__name] = STATE(6919),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2868),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(6950),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5123),
    [sym_non_lvalue_expression] = STATE(5735),
    [sym_lvalue_expression] = STATE(4054),
    [sym__expression_statement_expression] = STATE(5733),
    [sym_assignment_expression] = STATE(5734),
    [sym_binary_expression] = STATE(5733),
    [sym_postfix_unary_expression] = STATE(5734),
    [sym_prefix_unary_expression] = STATE(5734),
    [sym__pointer_indirection_expression] = STATE(3911),
    [sym_query_expression] = STATE(5733),
    [sym_from_clause] = STATE(7400),
    [sym_conditional_expression] = STATE(5733),
    [sym_conditional_access_expression] = STATE(5733),
    [sym_as_expression] = STATE(5733),
    [sym_is_expression] = STATE(5733),
    [sym_is_pattern_expression] = STATE(5733),
    [sym_cast_expression] = STATE(5733),
    [sym_checked_expression] = STATE(5733),
    [sym_invocation_expression] = STATE(5734),
    [sym_switch_expression] = STATE(5733),
    [sym_await_expression] = STATE(5734),
    [sym_throw_expression] = STATE(5733),
    [sym_element_access_expression] = STATE(3911),
    [sym_interpolated_string_expression] = STATE(5733),
    [sym_member_access_expression] = STATE(3911),
    [sym_object_creation_expression] = STATE(5734),
    [sym_parenthesized_expression] = STATE(5734),
    [sym__parenthesized_lvalue_expression] = STATE(3911),
    [sym_lambda_expression] = STATE(5733),
    [sym__lambda_parameters] = STATE(9693),
    [sym_array_creation_expression] = STATE(5733),
    [sym_anonymous_method_expression] = STATE(5733),
    [sym_anonymous_object_creation_expression] = STATE(5733),
    [sym_implicit_array_creation_expression] = STATE(5733),
    [sym_implicit_object_creation_expression] = STATE(5733),
    [sym_implicit_stackalloc_expression] = STATE(5733),
    [sym_initializer_expression] = STATE(5733),
    [sym_default_expression] = STATE(5733),
    [sym_with_expression] = STATE(5733),
    [sym_sizeof_expression] = STATE(5733),
    [sym_typeof_expression] = STATE(5733),
    [sym_makeref_expression] = STATE(5733),
    [sym_ref_expression] = STATE(5733),
    [sym_reftype_expression] = STATE(5733),
    [sym_refvalue_expression] = STATE(5733),
    [sym_stackalloc_expression] = STATE(5733),
    [sym_range_expression] = STATE(5733),
    [sym_tuple_expression] = STATE(3911),
    [sym_literal] = STATE(5733),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2798),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(5733),
    [sym_preproc_region] = STATE(2157),
    [sym_preproc_endregion] = STATE(2157),
    [sym_preproc_line] = STATE(2157),
    [sym_preproc_pragma] = STATE(2157),
    [sym_preproc_nullable] = STATE(2157),
    [sym_preproc_error] = STATE(2157),
    [sym_preproc_define] = STATE(2157),
    [sym_preproc_undef] = STATE(2157),
    [aux_sym_class_declaration_repeat1] = STATE(3791),
    [aux_sym_lambda_expression_repeat1] = STATE(4075),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_LPAREN] = ACTIONS(1373),
    [anon_sym_ref] = ACTIONS(1375),
    [anon_sym_LBRACE] = ACTIONS(1377),
    [anon_sym_delegate] = ACTIONS(1379),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1381),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1387),
    [anon_sym_TILDE] = ACTIONS(1387),
    [anon_sym_PLUS_PLUS] = ACTIONS(1387),
    [anon_sym_DASH_DASH] = ACTIONS(1387),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1385),
    [anon_sym_DASH] = ACTIONS(1385),
    [anon_sym_STAR] = ACTIONS(1391),
    [anon_sym_CARET] = ACTIONS(1387),
    [anon_sym_AMP] = ACTIONS(1387),
    [anon_sym_this] = ACTIONS(1393),
    [anon_sym_scoped] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1397),
    [sym_predefined_type] = ACTIONS(1399),
    [anon_sym_unchecked] = ACTIONS(1383),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1403),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1405),
    [anon_sym_DOT_DOT] = ACTIONS(1407),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_stackalloc] = ACTIONS(1413),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(1419),
    [anon_sym___reftype] = ACTIONS(1421),
    [anon_sym___refvalue] = ACTIONS(1423),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
  },
  [2158] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6904),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7009),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5227),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4008),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7381),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9536),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(2158),
    [sym_preproc_endregion] = STATE(2158),
    [sym_preproc_line] = STATE(2158),
    [sym_preproc_pragma] = STATE(2158),
    [sym_preproc_nullable] = STATE(2158),
    [sym_preproc_error] = STATE(2158),
    [sym_preproc_define] = STATE(2158),
    [sym_preproc_undef] = STATE(2158),
    [aux_sym_class_declaration_repeat1] = STATE(3832),
    [aux_sym_lambda_expression_repeat1] = STATE(4090),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1485),
    [anon_sym_ref] = ACTIONS(1487),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1221),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1491),
    [anon_sym_TILDE] = ACTIONS(1491),
    [anon_sym_PLUS_PLUS] = ACTIONS(1491),
    [anon_sym_DASH_DASH] = ACTIONS(1491),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1489),
    [anon_sym_DASH] = ACTIONS(1489),
    [anon_sym_STAR] = ACTIONS(1493),
    [anon_sym_CARET] = ACTIONS(1491),
    [anon_sym_AMP] = ACTIONS(1491),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1495),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1497),
    [anon_sym_DOT_DOT] = ACTIONS(1499),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [2159] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3428),
    [sym__name] = STATE(6897),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2761),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7108),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(6009),
    [sym_non_lvalue_expression] = STATE(4251),
    [sym_lvalue_expression] = STATE(4313),
    [sym__expression_statement_expression] = STATE(4247),
    [sym_assignment_expression] = STATE(4249),
    [sym_binary_expression] = STATE(4247),
    [sym_postfix_unary_expression] = STATE(4249),
    [sym_prefix_unary_expression] = STATE(4249),
    [sym__pointer_indirection_expression] = STATE(3420),
    [sym_query_expression] = STATE(4247),
    [sym_from_clause] = STATE(7382),
    [sym_conditional_expression] = STATE(4247),
    [sym_conditional_access_expression] = STATE(4247),
    [sym_as_expression] = STATE(4247),
    [sym_is_expression] = STATE(4247),
    [sym_is_pattern_expression] = STATE(4247),
    [sym_cast_expression] = STATE(4247),
    [sym_checked_expression] = STATE(4247),
    [sym_invocation_expression] = STATE(4249),
    [sym_switch_expression] = STATE(4247),
    [sym_await_expression] = STATE(4249),
    [sym_throw_expression] = STATE(4247),
    [sym_element_access_expression] = STATE(3420),
    [sym_interpolated_string_expression] = STATE(4247),
    [sym_member_access_expression] = STATE(3420),
    [sym_object_creation_expression] = STATE(4249),
    [sym_parenthesized_expression] = STATE(4249),
    [sym__parenthesized_lvalue_expression] = STATE(3420),
    [sym_lambda_expression] = STATE(4247),
    [sym__lambda_parameters] = STATE(9733),
    [sym_array_creation_expression] = STATE(4247),
    [sym_anonymous_method_expression] = STATE(4247),
    [sym_anonymous_object_creation_expression] = STATE(4247),
    [sym_implicit_array_creation_expression] = STATE(4247),
    [sym_implicit_object_creation_expression] = STATE(4247),
    [sym_implicit_stackalloc_expression] = STATE(4247),
    [sym_initializer_expression] = STATE(4247),
    [sym_default_expression] = STATE(4247),
    [sym_with_expression] = STATE(4247),
    [sym_sizeof_expression] = STATE(4247),
    [sym_typeof_expression] = STATE(4247),
    [sym_makeref_expression] = STATE(4247),
    [sym_ref_expression] = STATE(4247),
    [sym_reftype_expression] = STATE(4247),
    [sym_refvalue_expression] = STATE(4247),
    [sym_stackalloc_expression] = STATE(4247),
    [sym_range_expression] = STATE(4247),
    [sym_tuple_expression] = STATE(3420),
    [sym_literal] = STATE(4247),
    [sym_character_literal] = STATE(4217),
    [sym_string_literal] = STATE(4217),
    [sym_boolean_literal] = STATE(4217),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4247),
    [sym_preproc_region] = STATE(2159),
    [sym_preproc_endregion] = STATE(2159),
    [sym_preproc_line] = STATE(2159),
    [sym_preproc_pragma] = STATE(2159),
    [sym_preproc_nullable] = STATE(2159),
    [sym_preproc_error] = STATE(2159),
    [sym_preproc_define] = STATE(2159),
    [sym_preproc_undef] = STATE(2159),
    [aux_sym_class_declaration_repeat1] = STATE(3802),
    [aux_sym_lambda_expression_repeat1] = STATE(4108),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1519),
    [anon_sym_ref] = ACTIONS(1521),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_delegate] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1523),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(1305),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(87),
    [anon_sym_unchecked] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(105),
    [anon_sym_throw] = ACTIONS(1529),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1531),
    [anon_sym_DOT_DOT] = ACTIONS(1533),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(123),
    [anon_sym_stackalloc] = ACTIONS(1313),
    [anon_sym_sizeof] = ACTIONS(127),
    [anon_sym_typeof] = ACTIONS(129),
    [anon_sym___makeref] = ACTIONS(1315),
    [anon_sym___reftype] = ACTIONS(1317),
    [anon_sym___refvalue] = ACTIONS(1319),
    [sym_null_literal] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [sym_integer_literal] = ACTIONS(137),
    [sym_real_literal] = ACTIONS(141),
    [sym_verbatim_string_literal] = ACTIONS(141),
    [sym_raw_string_literal] = ACTIONS(141),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(147),
    [sym_interpolation_verbatim_start] = ACTIONS(149),
    [sym_interpolation_raw_start] = ACTIONS(151),
  },
  [2160] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3559),
    [sym__name] = STATE(6877),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2908),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7129),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4382),
    [sym_non_lvalue_expression] = STATE(4553),
    [sym_lvalue_expression] = STATE(3561),
    [sym__expression_statement_expression] = STATE(4559),
    [sym_assignment_expression] = STATE(4558),
    [sym_binary_expression] = STATE(4559),
    [sym_postfix_unary_expression] = STATE(4558),
    [sym_prefix_unary_expression] = STATE(4558),
    [sym__pointer_indirection_expression] = STATE(3560),
    [sym_query_expression] = STATE(4559),
    [sym_from_clause] = STATE(7385),
    [sym_conditional_expression] = STATE(4559),
    [sym_conditional_access_expression] = STATE(4559),
    [sym_as_expression] = STATE(4559),
    [sym_is_expression] = STATE(4559),
    [sym_is_pattern_expression] = STATE(4559),
    [sym_cast_expression] = STATE(4559),
    [sym_checked_expression] = STATE(4559),
    [sym_invocation_expression] = STATE(4558),
    [sym_switch_expression] = STATE(4559),
    [sym_await_expression] = STATE(4558),
    [sym_throw_expression] = STATE(4559),
    [sym_element_access_expression] = STATE(3560),
    [sym_interpolated_string_expression] = STATE(4559),
    [sym_member_access_expression] = STATE(3560),
    [sym_object_creation_expression] = STATE(4558),
    [sym_parenthesized_expression] = STATE(4558),
    [sym__parenthesized_lvalue_expression] = STATE(3560),
    [sym_lambda_expression] = STATE(4559),
    [sym__lambda_parameters] = STATE(9776),
    [sym_array_creation_expression] = STATE(4559),
    [sym_anonymous_method_expression] = STATE(4559),
    [sym_anonymous_object_creation_expression] = STATE(4559),
    [sym_implicit_array_creation_expression] = STATE(4559),
    [sym_implicit_object_creation_expression] = STATE(4559),
    [sym_implicit_stackalloc_expression] = STATE(4559),
    [sym_initializer_expression] = STATE(4559),
    [sym_default_expression] = STATE(4559),
    [sym_with_expression] = STATE(4559),
    [sym_sizeof_expression] = STATE(4559),
    [sym_typeof_expression] = STATE(4559),
    [sym_makeref_expression] = STATE(4559),
    [sym_ref_expression] = STATE(4559),
    [sym_reftype_expression] = STATE(4559),
    [sym_refvalue_expression] = STATE(4559),
    [sym_stackalloc_expression] = STATE(4559),
    [sym_range_expression] = STATE(4559),
    [sym_tuple_expression] = STATE(3560),
    [sym_literal] = STATE(4559),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4559),
    [sym_preproc_region] = STATE(2160),
    [sym_preproc_endregion] = STATE(2160),
    [sym_preproc_line] = STATE(2160),
    [sym_preproc_pragma] = STATE(2160),
    [sym_preproc_nullable] = STATE(2160),
    [sym_preproc_error] = STATE(2160),
    [sym_preproc_define] = STATE(2160),
    [sym_preproc_undef] = STATE(2160),
    [aux_sym_class_declaration_repeat1] = STATE(3843),
    [aux_sym_lambda_expression_repeat1] = STATE(4277),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(1675),
    [anon_sym_ref] = ACTIONS(1677),
    [anon_sym_LBRACE] = ACTIONS(1611),
    [anon_sym_delegate] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1679),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(1683),
    [anon_sym_TILDE] = ACTIONS(1683),
    [anon_sym_PLUS_PLUS] = ACTIONS(1683),
    [anon_sym_DASH_DASH] = ACTIONS(1683),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_DASH] = ACTIONS(1681),
    [anon_sym_STAR] = ACTIONS(1685),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1683),
    [anon_sym_this] = ACTIONS(1627),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1629),
    [anon_sym_unchecked] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(1687),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1689),
    [anon_sym_DOT_DOT] = ACTIONS(1691),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_stackalloc] = ACTIONS(1641),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(1647),
    [anon_sym___reftype] = ACTIONS(1649),
    [anon_sym___refvalue] = ACTIONS(1651),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1659),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [2161] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3921),
    [sym__name] = STATE(6889),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2854),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(6991),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5544),
    [sym_non_lvalue_expression] = STATE(5735),
    [sym_lvalue_expression] = STATE(4295),
    [sym__expression_statement_expression] = STATE(5733),
    [sym_assignment_expression] = STATE(5734),
    [sym_binary_expression] = STATE(5733),
    [sym_postfix_unary_expression] = STATE(5734),
    [sym_prefix_unary_expression] = STATE(5734),
    [sym__pointer_indirection_expression] = STATE(3911),
    [sym_query_expression] = STATE(5733),
    [sym_from_clause] = STATE(7393),
    [sym_conditional_expression] = STATE(5733),
    [sym_conditional_access_expression] = STATE(5733),
    [sym_as_expression] = STATE(5733),
    [sym_is_expression] = STATE(5733),
    [sym_is_pattern_expression] = STATE(5733),
    [sym_cast_expression] = STATE(5733),
    [sym_checked_expression] = STATE(5733),
    [sym_invocation_expression] = STATE(5734),
    [sym_switch_expression] = STATE(5733),
    [sym_await_expression] = STATE(5734),
    [sym_throw_expression] = STATE(5733),
    [sym_element_access_expression] = STATE(3911),
    [sym_interpolated_string_expression] = STATE(5733),
    [sym_member_access_expression] = STATE(3911),
    [sym_object_creation_expression] = STATE(5734),
    [sym_parenthesized_expression] = STATE(5734),
    [sym__parenthesized_lvalue_expression] = STATE(3911),
    [sym_lambda_expression] = STATE(5733),
    [sym__lambda_parameters] = STATE(9313),
    [sym_array_creation_expression] = STATE(5733),
    [sym_anonymous_method_expression] = STATE(5733),
    [sym_anonymous_object_creation_expression] = STATE(5733),
    [sym_implicit_array_creation_expression] = STATE(5733),
    [sym_implicit_object_creation_expression] = STATE(5733),
    [sym_implicit_stackalloc_expression] = STATE(5733),
    [sym_initializer_expression] = STATE(5733),
    [sym_default_expression] = STATE(5733),
    [sym_with_expression] = STATE(5733),
    [sym_sizeof_expression] = STATE(5733),
    [sym_typeof_expression] = STATE(5733),
    [sym_makeref_expression] = STATE(5733),
    [sym_ref_expression] = STATE(5733),
    [sym_reftype_expression] = STATE(5733),
    [sym_refvalue_expression] = STATE(5733),
    [sym_stackalloc_expression] = STATE(5733),
    [sym_range_expression] = STATE(5733),
    [sym_tuple_expression] = STATE(3911),
    [sym_literal] = STATE(5733),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2798),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(5733),
    [sym_preproc_region] = STATE(2161),
    [sym_preproc_endregion] = STATE(2161),
    [sym_preproc_line] = STATE(2161),
    [sym_preproc_pragma] = STATE(2161),
    [sym_preproc_nullable] = STATE(2161),
    [sym_preproc_error] = STATE(2161),
    [sym_preproc_define] = STATE(2161),
    [sym_preproc_undef] = STATE(2161),
    [aux_sym_class_declaration_repeat1] = STATE(3805),
    [aux_sym_lambda_expression_repeat1] = STATE(4122),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_LPAREN] = ACTIONS(1591),
    [anon_sym_ref] = ACTIONS(1593),
    [anon_sym_LBRACE] = ACTIONS(1377),
    [anon_sym_delegate] = ACTIONS(1379),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1443),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1597),
    [anon_sym_TILDE] = ACTIONS(1597),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1595),
    [anon_sym_DASH] = ACTIONS(1595),
    [anon_sym_STAR] = ACTIONS(1449),
    [anon_sym_CARET] = ACTIONS(1597),
    [anon_sym_AMP] = ACTIONS(1597),
    [anon_sym_this] = ACTIONS(1393),
    [anon_sym_scoped] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1397),
    [sym_predefined_type] = ACTIONS(1399),
    [anon_sym_unchecked] = ACTIONS(1383),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1599),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1601),
    [anon_sym_DOT_DOT] = ACTIONS(1603),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_stackalloc] = ACTIONS(1413),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(1419),
    [anon_sym___reftype] = ACTIONS(1421),
    [anon_sym___refvalue] = ACTIONS(1423),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
  },
  [2162] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3559),
    [sym__name] = STATE(6877),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2908),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6958),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4421),
    [sym_non_lvalue_expression] = STATE(4553),
    [sym_lvalue_expression] = STATE(3691),
    [sym__expression_statement_expression] = STATE(4559),
    [sym_assignment_expression] = STATE(4558),
    [sym_binary_expression] = STATE(4559),
    [sym_postfix_unary_expression] = STATE(4558),
    [sym_prefix_unary_expression] = STATE(4558),
    [sym__pointer_indirection_expression] = STATE(3560),
    [sym_query_expression] = STATE(4559),
    [sym_from_clause] = STATE(7406),
    [sym_conditional_expression] = STATE(4559),
    [sym_conditional_access_expression] = STATE(4559),
    [sym_as_expression] = STATE(4559),
    [sym_is_expression] = STATE(4559),
    [sym_is_pattern_expression] = STATE(4559),
    [sym_cast_expression] = STATE(4559),
    [sym_checked_expression] = STATE(4559),
    [sym_invocation_expression] = STATE(4558),
    [sym_switch_expression] = STATE(4559),
    [sym_await_expression] = STATE(4558),
    [sym_throw_expression] = STATE(4559),
    [sym_element_access_expression] = STATE(3560),
    [sym_interpolated_string_expression] = STATE(4559),
    [sym_member_access_expression] = STATE(3560),
    [sym_object_creation_expression] = STATE(4558),
    [sym_parenthesized_expression] = STATE(4558),
    [sym__parenthesized_lvalue_expression] = STATE(3560),
    [sym_lambda_expression] = STATE(4559),
    [sym__lambda_parameters] = STATE(9348),
    [sym_array_creation_expression] = STATE(4559),
    [sym_anonymous_method_expression] = STATE(4559),
    [sym_anonymous_object_creation_expression] = STATE(4559),
    [sym_implicit_array_creation_expression] = STATE(4559),
    [sym_implicit_object_creation_expression] = STATE(4559),
    [sym_implicit_stackalloc_expression] = STATE(4559),
    [sym_initializer_expression] = STATE(4559),
    [sym_default_expression] = STATE(4559),
    [sym_with_expression] = STATE(4559),
    [sym_sizeof_expression] = STATE(4559),
    [sym_typeof_expression] = STATE(4559),
    [sym_makeref_expression] = STATE(4559),
    [sym_ref_expression] = STATE(4559),
    [sym_reftype_expression] = STATE(4559),
    [sym_refvalue_expression] = STATE(4559),
    [sym_stackalloc_expression] = STATE(4559),
    [sym_range_expression] = STATE(4559),
    [sym_tuple_expression] = STATE(3560),
    [sym_literal] = STATE(4559),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4559),
    [sym_preproc_region] = STATE(2162),
    [sym_preproc_endregion] = STATE(2162),
    [sym_preproc_line] = STATE(2162),
    [sym_preproc_pragma] = STATE(2162),
    [sym_preproc_nullable] = STATE(2162),
    [sym_preproc_error] = STATE(2162),
    [sym_preproc_define] = STATE(2162),
    [sym_preproc_undef] = STATE(2162),
    [aux_sym_class_declaration_repeat1] = STATE(3810),
    [aux_sym_lambda_expression_repeat1] = STATE(4141),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(2047),
    [anon_sym_ref] = ACTIONS(2049),
    [anon_sym_LBRACE] = ACTIONS(1611),
    [anon_sym_delegate] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1679),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(2053),
    [anon_sym_TILDE] = ACTIONS(2053),
    [anon_sym_PLUS_PLUS] = ACTIONS(2053),
    [anon_sym_DASH_DASH] = ACTIONS(2053),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(2051),
    [anon_sym_DASH] = ACTIONS(2051),
    [anon_sym_STAR] = ACTIONS(1685),
    [anon_sym_CARET] = ACTIONS(2053),
    [anon_sym_AMP] = ACTIONS(2053),
    [anon_sym_this] = ACTIONS(1627),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1629),
    [anon_sym_unchecked] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(2055),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2057),
    [anon_sym_DOT_DOT] = ACTIONS(2059),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_stackalloc] = ACTIONS(1641),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(1647),
    [anon_sym___reftype] = ACTIONS(1649),
    [anon_sym___refvalue] = ACTIONS(1651),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1659),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [2163] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3559),
    [sym__name] = STATE(6877),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2908),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7129),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4385),
    [sym_non_lvalue_expression] = STATE(4553),
    [sym_lvalue_expression] = STATE(3561),
    [sym__expression_statement_expression] = STATE(4559),
    [sym_assignment_expression] = STATE(4558),
    [sym_binary_expression] = STATE(4559),
    [sym_postfix_unary_expression] = STATE(4558),
    [sym_prefix_unary_expression] = STATE(4558),
    [sym__pointer_indirection_expression] = STATE(3560),
    [sym_query_expression] = STATE(4559),
    [sym_from_clause] = STATE(7385),
    [sym_conditional_expression] = STATE(4559),
    [sym_conditional_access_expression] = STATE(4559),
    [sym_as_expression] = STATE(4559),
    [sym_is_expression] = STATE(4559),
    [sym_is_pattern_expression] = STATE(4559),
    [sym_cast_expression] = STATE(4559),
    [sym_checked_expression] = STATE(4559),
    [sym_invocation_expression] = STATE(4558),
    [sym_switch_expression] = STATE(4559),
    [sym_await_expression] = STATE(4558),
    [sym_throw_expression] = STATE(4559),
    [sym_element_access_expression] = STATE(3560),
    [sym_interpolated_string_expression] = STATE(4559),
    [sym_member_access_expression] = STATE(3560),
    [sym_object_creation_expression] = STATE(4558),
    [sym_parenthesized_expression] = STATE(4558),
    [sym__parenthesized_lvalue_expression] = STATE(3560),
    [sym_lambda_expression] = STATE(4559),
    [sym__lambda_parameters] = STATE(9776),
    [sym_array_creation_expression] = STATE(4559),
    [sym_anonymous_method_expression] = STATE(4559),
    [sym_anonymous_object_creation_expression] = STATE(4559),
    [sym_implicit_array_creation_expression] = STATE(4559),
    [sym_implicit_object_creation_expression] = STATE(4559),
    [sym_implicit_stackalloc_expression] = STATE(4559),
    [sym_initializer_expression] = STATE(4559),
    [sym_default_expression] = STATE(4559),
    [sym_with_expression] = STATE(4559),
    [sym_sizeof_expression] = STATE(4559),
    [sym_typeof_expression] = STATE(4559),
    [sym_makeref_expression] = STATE(4559),
    [sym_ref_expression] = STATE(4559),
    [sym_reftype_expression] = STATE(4559),
    [sym_refvalue_expression] = STATE(4559),
    [sym_stackalloc_expression] = STATE(4559),
    [sym_range_expression] = STATE(4559),
    [sym_tuple_expression] = STATE(3560),
    [sym_literal] = STATE(4559),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4559),
    [sym_preproc_region] = STATE(2163),
    [sym_preproc_endregion] = STATE(2163),
    [sym_preproc_line] = STATE(2163),
    [sym_preproc_pragma] = STATE(2163),
    [sym_preproc_nullable] = STATE(2163),
    [sym_preproc_error] = STATE(2163),
    [sym_preproc_define] = STATE(2163),
    [sym_preproc_undef] = STATE(2163),
    [aux_sym_class_declaration_repeat1] = STATE(3843),
    [aux_sym_lambda_expression_repeat1] = STATE(4277),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(1675),
    [anon_sym_ref] = ACTIONS(1677),
    [anon_sym_LBRACE] = ACTIONS(1611),
    [anon_sym_delegate] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1679),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(1683),
    [anon_sym_TILDE] = ACTIONS(1683),
    [anon_sym_PLUS_PLUS] = ACTIONS(1683),
    [anon_sym_DASH_DASH] = ACTIONS(1683),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_DASH] = ACTIONS(1681),
    [anon_sym_STAR] = ACTIONS(1685),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1683),
    [anon_sym_this] = ACTIONS(1627),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1629),
    [anon_sym_unchecked] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(1687),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1689),
    [anon_sym_DOT_DOT] = ACTIONS(1691),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_stackalloc] = ACTIONS(1641),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(1647),
    [anon_sym___reftype] = ACTIONS(1649),
    [anon_sym___refvalue] = ACTIONS(1651),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1659),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [2164] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3189),
    [sym__name] = STATE(6911),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6992),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5106),
    [sym_non_lvalue_expression] = STATE(3996),
    [sym_lvalue_expression] = STATE(3829),
    [sym__expression_statement_expression] = STATE(3991),
    [sym_assignment_expression] = STATE(3992),
    [sym_binary_expression] = STATE(3991),
    [sym_postfix_unary_expression] = STATE(3992),
    [sym_prefix_unary_expression] = STATE(3992),
    [sym__pointer_indirection_expression] = STATE(3183),
    [sym_query_expression] = STATE(3991),
    [sym_from_clause] = STATE(7391),
    [sym_conditional_expression] = STATE(3991),
    [sym_conditional_access_expression] = STATE(3991),
    [sym_as_expression] = STATE(3991),
    [sym_is_expression] = STATE(3991),
    [sym_is_pattern_expression] = STATE(3991),
    [sym_cast_expression] = STATE(3991),
    [sym_checked_expression] = STATE(3991),
    [sym_invocation_expression] = STATE(3992),
    [sym_switch_expression] = STATE(3991),
    [sym_await_expression] = STATE(3992),
    [sym_throw_expression] = STATE(3991),
    [sym_element_access_expression] = STATE(3183),
    [sym_interpolated_string_expression] = STATE(3991),
    [sym_member_access_expression] = STATE(3183),
    [sym_object_creation_expression] = STATE(3992),
    [sym_parenthesized_expression] = STATE(3992),
    [sym__parenthesized_lvalue_expression] = STATE(3183),
    [sym_lambda_expression] = STATE(3991),
    [sym__lambda_parameters] = STATE(9246),
    [sym_array_creation_expression] = STATE(3991),
    [sym_anonymous_method_expression] = STATE(3991),
    [sym_anonymous_object_creation_expression] = STATE(3991),
    [sym_implicit_array_creation_expression] = STATE(3991),
    [sym_implicit_object_creation_expression] = STATE(3991),
    [sym_implicit_stackalloc_expression] = STATE(3991),
    [sym_initializer_expression] = STATE(3991),
    [sym_default_expression] = STATE(3991),
    [sym_with_expression] = STATE(3991),
    [sym_sizeof_expression] = STATE(3991),
    [sym_typeof_expression] = STATE(3991),
    [sym_makeref_expression] = STATE(3991),
    [sym_ref_expression] = STATE(3991),
    [sym_reftype_expression] = STATE(3991),
    [sym_refvalue_expression] = STATE(3991),
    [sym_stackalloc_expression] = STATE(3991),
    [sym_range_expression] = STATE(3991),
    [sym_tuple_expression] = STATE(3183),
    [sym_literal] = STATE(3991),
    [sym_character_literal] = STATE(3982),
    [sym_string_literal] = STATE(3982),
    [sym_boolean_literal] = STATE(3982),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3991),
    [sym_preproc_region] = STATE(2164),
    [sym_preproc_endregion] = STATE(2164),
    [sym_preproc_line] = STATE(2164),
    [sym_preproc_pragma] = STATE(2164),
    [sym_preproc_nullable] = STATE(2164),
    [sym_preproc_error] = STATE(2164),
    [sym_preproc_define] = STATE(2164),
    [sym_preproc_undef] = STATE(2164),
    [aux_sym_class_declaration_repeat1] = STATE(3800),
    [aux_sym_lambda_expression_repeat1] = STATE(4089),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1323),
    [anon_sym_ref] = ACTIONS(1325),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_delegate] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1145),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1329),
    [anon_sym_TILDE] = ACTIONS(1329),
    [anon_sym_PLUS_PLUS] = ACTIONS(1329),
    [anon_sym_DASH_DASH] = ACTIONS(1329),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1327),
    [anon_sym_DASH] = ACTIONS(1327),
    [anon_sym_STAR] = ACTIONS(1331),
    [anon_sym_CARET] = ACTIONS(1329),
    [anon_sym_AMP] = ACTIONS(1329),
    [anon_sym_this] = ACTIONS(1159),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1161),
    [anon_sym_unchecked] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1333),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1335),
    [anon_sym_DOT_DOT] = ACTIONS(1337),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_stackalloc] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1175),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym___makeref] = ACTIONS(1179),
    [anon_sym___reftype] = ACTIONS(1181),
    [anon_sym___refvalue] = ACTIONS(1183),
    [sym_null_literal] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1185),
    [sym_real_literal] = ACTIONS(1189),
    [sym_verbatim_string_literal] = ACTIONS(1189),
    [sym_raw_string_literal] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1193),
    [sym_interpolation_verbatim_start] = ACTIONS(1195),
    [sym_interpolation_raw_start] = ACTIONS(1197),
  },
  [2165] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3559),
    [sym__name] = STATE(6877),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2908),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7129),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4354),
    [sym_non_lvalue_expression] = STATE(4553),
    [sym_lvalue_expression] = STATE(3561),
    [sym__expression_statement_expression] = STATE(4559),
    [sym_assignment_expression] = STATE(4558),
    [sym_binary_expression] = STATE(4559),
    [sym_postfix_unary_expression] = STATE(4558),
    [sym_prefix_unary_expression] = STATE(4558),
    [sym__pointer_indirection_expression] = STATE(3560),
    [sym_query_expression] = STATE(4559),
    [sym_from_clause] = STATE(7385),
    [sym_conditional_expression] = STATE(4559),
    [sym_conditional_access_expression] = STATE(4559),
    [sym_as_expression] = STATE(4559),
    [sym_is_expression] = STATE(4559),
    [sym_is_pattern_expression] = STATE(4559),
    [sym_cast_expression] = STATE(4559),
    [sym_checked_expression] = STATE(4559),
    [sym_invocation_expression] = STATE(4558),
    [sym_switch_expression] = STATE(4559),
    [sym_await_expression] = STATE(4558),
    [sym_throw_expression] = STATE(4559),
    [sym_element_access_expression] = STATE(3560),
    [sym_interpolated_string_expression] = STATE(4559),
    [sym_member_access_expression] = STATE(3560),
    [sym_object_creation_expression] = STATE(4558),
    [sym_parenthesized_expression] = STATE(4558),
    [sym__parenthesized_lvalue_expression] = STATE(3560),
    [sym_lambda_expression] = STATE(4559),
    [sym__lambda_parameters] = STATE(9776),
    [sym_array_creation_expression] = STATE(4559),
    [sym_anonymous_method_expression] = STATE(4559),
    [sym_anonymous_object_creation_expression] = STATE(4559),
    [sym_implicit_array_creation_expression] = STATE(4559),
    [sym_implicit_object_creation_expression] = STATE(4559),
    [sym_implicit_stackalloc_expression] = STATE(4559),
    [sym_initializer_expression] = STATE(4559),
    [sym_default_expression] = STATE(4559),
    [sym_with_expression] = STATE(4559),
    [sym_sizeof_expression] = STATE(4559),
    [sym_typeof_expression] = STATE(4559),
    [sym_makeref_expression] = STATE(4559),
    [sym_ref_expression] = STATE(4559),
    [sym_reftype_expression] = STATE(4559),
    [sym_refvalue_expression] = STATE(4559),
    [sym_stackalloc_expression] = STATE(4559),
    [sym_range_expression] = STATE(4559),
    [sym_tuple_expression] = STATE(3560),
    [sym_literal] = STATE(4559),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4559),
    [sym_preproc_region] = STATE(2165),
    [sym_preproc_endregion] = STATE(2165),
    [sym_preproc_line] = STATE(2165),
    [sym_preproc_pragma] = STATE(2165),
    [sym_preproc_nullable] = STATE(2165),
    [sym_preproc_error] = STATE(2165),
    [sym_preproc_define] = STATE(2165),
    [sym_preproc_undef] = STATE(2165),
    [aux_sym_class_declaration_repeat1] = STATE(3843),
    [aux_sym_lambda_expression_repeat1] = STATE(4277),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(1675),
    [anon_sym_ref] = ACTIONS(1677),
    [anon_sym_LBRACE] = ACTIONS(1611),
    [anon_sym_delegate] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1679),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(1683),
    [anon_sym_TILDE] = ACTIONS(1683),
    [anon_sym_PLUS_PLUS] = ACTIONS(1683),
    [anon_sym_DASH_DASH] = ACTIONS(1683),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_DASH] = ACTIONS(1681),
    [anon_sym_STAR] = ACTIONS(1685),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1683),
    [anon_sym_this] = ACTIONS(1627),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1629),
    [anon_sym_unchecked] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(1687),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1689),
    [anon_sym_DOT_DOT] = ACTIONS(1691),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_stackalloc] = ACTIONS(1641),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(1647),
    [anon_sym___reftype] = ACTIONS(1649),
    [anon_sym___refvalue] = ACTIONS(1651),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1659),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [2166] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6904),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7009),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5220),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4008),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7381),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9536),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(2166),
    [sym_preproc_endregion] = STATE(2166),
    [sym_preproc_line] = STATE(2166),
    [sym_preproc_pragma] = STATE(2166),
    [sym_preproc_nullable] = STATE(2166),
    [sym_preproc_error] = STATE(2166),
    [sym_preproc_define] = STATE(2166),
    [sym_preproc_undef] = STATE(2166),
    [aux_sym_class_declaration_repeat1] = STATE(3832),
    [aux_sym_lambda_expression_repeat1] = STATE(4090),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1485),
    [anon_sym_ref] = ACTIONS(1487),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1221),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1491),
    [anon_sym_TILDE] = ACTIONS(1491),
    [anon_sym_PLUS_PLUS] = ACTIONS(1491),
    [anon_sym_DASH_DASH] = ACTIONS(1491),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1489),
    [anon_sym_DASH] = ACTIONS(1489),
    [anon_sym_STAR] = ACTIONS(1493),
    [anon_sym_CARET] = ACTIONS(1491),
    [anon_sym_AMP] = ACTIONS(1491),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1495),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1497),
    [anon_sym_DOT_DOT] = ACTIONS(1499),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [2167] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3559),
    [sym__name] = STATE(6877),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2908),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7129),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4386),
    [sym_non_lvalue_expression] = STATE(4553),
    [sym_lvalue_expression] = STATE(3561),
    [sym__expression_statement_expression] = STATE(4559),
    [sym_assignment_expression] = STATE(4558),
    [sym_binary_expression] = STATE(4559),
    [sym_postfix_unary_expression] = STATE(4558),
    [sym_prefix_unary_expression] = STATE(4558),
    [sym__pointer_indirection_expression] = STATE(3560),
    [sym_query_expression] = STATE(4559),
    [sym_from_clause] = STATE(7385),
    [sym_conditional_expression] = STATE(4559),
    [sym_conditional_access_expression] = STATE(4559),
    [sym_as_expression] = STATE(4559),
    [sym_is_expression] = STATE(4559),
    [sym_is_pattern_expression] = STATE(4559),
    [sym_cast_expression] = STATE(4559),
    [sym_checked_expression] = STATE(4559),
    [sym_invocation_expression] = STATE(4558),
    [sym_switch_expression] = STATE(4559),
    [sym_await_expression] = STATE(4558),
    [sym_throw_expression] = STATE(4559),
    [sym_element_access_expression] = STATE(3560),
    [sym_interpolated_string_expression] = STATE(4559),
    [sym_member_access_expression] = STATE(3560),
    [sym_object_creation_expression] = STATE(4558),
    [sym_parenthesized_expression] = STATE(4558),
    [sym__parenthesized_lvalue_expression] = STATE(3560),
    [sym_lambda_expression] = STATE(4559),
    [sym__lambda_parameters] = STATE(9776),
    [sym_array_creation_expression] = STATE(4559),
    [sym_anonymous_method_expression] = STATE(4559),
    [sym_anonymous_object_creation_expression] = STATE(4559),
    [sym_implicit_array_creation_expression] = STATE(4559),
    [sym_implicit_object_creation_expression] = STATE(4559),
    [sym_implicit_stackalloc_expression] = STATE(4559),
    [sym_initializer_expression] = STATE(4559),
    [sym_default_expression] = STATE(4559),
    [sym_with_expression] = STATE(4559),
    [sym_sizeof_expression] = STATE(4559),
    [sym_typeof_expression] = STATE(4559),
    [sym_makeref_expression] = STATE(4559),
    [sym_ref_expression] = STATE(4559),
    [sym_reftype_expression] = STATE(4559),
    [sym_refvalue_expression] = STATE(4559),
    [sym_stackalloc_expression] = STATE(4559),
    [sym_range_expression] = STATE(4559),
    [sym_tuple_expression] = STATE(3560),
    [sym_literal] = STATE(4559),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4559),
    [sym_preproc_region] = STATE(2167),
    [sym_preproc_endregion] = STATE(2167),
    [sym_preproc_line] = STATE(2167),
    [sym_preproc_pragma] = STATE(2167),
    [sym_preproc_nullable] = STATE(2167),
    [sym_preproc_error] = STATE(2167),
    [sym_preproc_define] = STATE(2167),
    [sym_preproc_undef] = STATE(2167),
    [aux_sym_class_declaration_repeat1] = STATE(3843),
    [aux_sym_lambda_expression_repeat1] = STATE(4277),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(1675),
    [anon_sym_ref] = ACTIONS(1677),
    [anon_sym_LBRACE] = ACTIONS(1611),
    [anon_sym_delegate] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1679),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(1683),
    [anon_sym_TILDE] = ACTIONS(1683),
    [anon_sym_PLUS_PLUS] = ACTIONS(1683),
    [anon_sym_DASH_DASH] = ACTIONS(1683),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_DASH] = ACTIONS(1681),
    [anon_sym_STAR] = ACTIONS(1685),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1683),
    [anon_sym_this] = ACTIONS(1627),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1629),
    [anon_sym_unchecked] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(1687),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1689),
    [anon_sym_DOT_DOT] = ACTIONS(1691),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_stackalloc] = ACTIONS(1641),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(1647),
    [anon_sym___reftype] = ACTIONS(1649),
    [anon_sym___refvalue] = ACTIONS(1651),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1659),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [2168] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3559),
    [sym__name] = STATE(6877),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2908),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7129),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4387),
    [sym_non_lvalue_expression] = STATE(4553),
    [sym_lvalue_expression] = STATE(3561),
    [sym__expression_statement_expression] = STATE(4559),
    [sym_assignment_expression] = STATE(4558),
    [sym_binary_expression] = STATE(4559),
    [sym_postfix_unary_expression] = STATE(4558),
    [sym_prefix_unary_expression] = STATE(4558),
    [sym__pointer_indirection_expression] = STATE(3560),
    [sym_query_expression] = STATE(4559),
    [sym_from_clause] = STATE(7385),
    [sym_conditional_expression] = STATE(4559),
    [sym_conditional_access_expression] = STATE(4559),
    [sym_as_expression] = STATE(4559),
    [sym_is_expression] = STATE(4559),
    [sym_is_pattern_expression] = STATE(4559),
    [sym_cast_expression] = STATE(4559),
    [sym_checked_expression] = STATE(4559),
    [sym_invocation_expression] = STATE(4558),
    [sym_switch_expression] = STATE(4559),
    [sym_await_expression] = STATE(4558),
    [sym_throw_expression] = STATE(4559),
    [sym_element_access_expression] = STATE(3560),
    [sym_interpolated_string_expression] = STATE(4559),
    [sym_member_access_expression] = STATE(3560),
    [sym_object_creation_expression] = STATE(4558),
    [sym_parenthesized_expression] = STATE(4558),
    [sym__parenthesized_lvalue_expression] = STATE(3560),
    [sym_lambda_expression] = STATE(4559),
    [sym__lambda_parameters] = STATE(9776),
    [sym_array_creation_expression] = STATE(4559),
    [sym_anonymous_method_expression] = STATE(4559),
    [sym_anonymous_object_creation_expression] = STATE(4559),
    [sym_implicit_array_creation_expression] = STATE(4559),
    [sym_implicit_object_creation_expression] = STATE(4559),
    [sym_implicit_stackalloc_expression] = STATE(4559),
    [sym_initializer_expression] = STATE(4559),
    [sym_default_expression] = STATE(4559),
    [sym_with_expression] = STATE(4559),
    [sym_sizeof_expression] = STATE(4559),
    [sym_typeof_expression] = STATE(4559),
    [sym_makeref_expression] = STATE(4559),
    [sym_ref_expression] = STATE(4559),
    [sym_reftype_expression] = STATE(4559),
    [sym_refvalue_expression] = STATE(4559),
    [sym_stackalloc_expression] = STATE(4559),
    [sym_range_expression] = STATE(4559),
    [sym_tuple_expression] = STATE(3560),
    [sym_literal] = STATE(4559),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4559),
    [sym_preproc_region] = STATE(2168),
    [sym_preproc_endregion] = STATE(2168),
    [sym_preproc_line] = STATE(2168),
    [sym_preproc_pragma] = STATE(2168),
    [sym_preproc_nullable] = STATE(2168),
    [sym_preproc_error] = STATE(2168),
    [sym_preproc_define] = STATE(2168),
    [sym_preproc_undef] = STATE(2168),
    [aux_sym_class_declaration_repeat1] = STATE(3843),
    [aux_sym_lambda_expression_repeat1] = STATE(4277),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(1675),
    [anon_sym_ref] = ACTIONS(1677),
    [anon_sym_LBRACE] = ACTIONS(1611),
    [anon_sym_delegate] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1679),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(1683),
    [anon_sym_TILDE] = ACTIONS(1683),
    [anon_sym_PLUS_PLUS] = ACTIONS(1683),
    [anon_sym_DASH_DASH] = ACTIONS(1683),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_DASH] = ACTIONS(1681),
    [anon_sym_STAR] = ACTIONS(1685),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1683),
    [anon_sym_this] = ACTIONS(1627),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1629),
    [anon_sym_unchecked] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(1687),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1689),
    [anon_sym_DOT_DOT] = ACTIONS(1691),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_stackalloc] = ACTIONS(1641),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(1647),
    [anon_sym___reftype] = ACTIONS(1649),
    [anon_sym___refvalue] = ACTIONS(1651),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1659),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [2169] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3040),
    [sym__name] = STATE(6910),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2957),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(6984),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4953),
    [sym_non_lvalue_expression] = STATE(3765),
    [sym_lvalue_expression] = STATE(3777),
    [sym__expression_statement_expression] = STATE(3774),
    [sym_assignment_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3774),
    [sym_postfix_unary_expression] = STATE(3733),
    [sym_prefix_unary_expression] = STATE(3733),
    [sym__pointer_indirection_expression] = STATE(3042),
    [sym_query_expression] = STATE(3774),
    [sym_from_clause] = STATE(7387),
    [sym_conditional_expression] = STATE(3774),
    [sym_conditional_access_expression] = STATE(3774),
    [sym_as_expression] = STATE(3774),
    [sym_is_expression] = STATE(3774),
    [sym_is_pattern_expression] = STATE(3774),
    [sym_cast_expression] = STATE(3774),
    [sym_checked_expression] = STATE(3774),
    [sym_invocation_expression] = STATE(3733),
    [sym_switch_expression] = STATE(3774),
    [sym_await_expression] = STATE(3733),
    [sym_throw_expression] = STATE(3774),
    [sym_element_access_expression] = STATE(3042),
    [sym_interpolated_string_expression] = STATE(3774),
    [sym_member_access_expression] = STATE(3042),
    [sym_object_creation_expression] = STATE(3733),
    [sym_parenthesized_expression] = STATE(3733),
    [sym__parenthesized_lvalue_expression] = STATE(3042),
    [sym_lambda_expression] = STATE(3774),
    [sym__lambda_parameters] = STATE(9385),
    [sym_array_creation_expression] = STATE(3774),
    [sym_anonymous_method_expression] = STATE(3774),
    [sym_anonymous_object_creation_expression] = STATE(3774),
    [sym_implicit_array_creation_expression] = STATE(3774),
    [sym_implicit_object_creation_expression] = STATE(3774),
    [sym_implicit_stackalloc_expression] = STATE(3774),
    [sym_initializer_expression] = STATE(3774),
    [sym_default_expression] = STATE(3774),
    [sym_with_expression] = STATE(3774),
    [sym_sizeof_expression] = STATE(3774),
    [sym_typeof_expression] = STATE(3774),
    [sym_makeref_expression] = STATE(3774),
    [sym_ref_expression] = STATE(3774),
    [sym_reftype_expression] = STATE(3774),
    [sym_refvalue_expression] = STATE(3774),
    [sym_stackalloc_expression] = STATE(3774),
    [sym_range_expression] = STATE(3774),
    [sym_tuple_expression] = STATE(3042),
    [sym_literal] = STATE(3774),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3774),
    [sym_preproc_region] = STATE(2169),
    [sym_preproc_endregion] = STATE(2169),
    [sym_preproc_line] = STATE(2169),
    [sym_preproc_pragma] = STATE(2169),
    [sym_preproc_nullable] = STATE(2169),
    [sym_preproc_error] = STATE(2169),
    [sym_preproc_define] = STATE(2169),
    [sym_preproc_undef] = STATE(2169),
    [aux_sym_class_declaration_repeat1] = STATE(3793),
    [aux_sym_lambda_expression_repeat1] = STATE(4083),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1795),
    [anon_sym_ref] = ACTIONS(1797),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_delegate] = ACTIONS(663),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1799),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1803),
    [anon_sym_TILDE] = ACTIONS(1803),
    [anon_sym_PLUS_PLUS] = ACTIONS(1803),
    [anon_sym_DASH_DASH] = ACTIONS(1803),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1801),
    [anon_sym_DASH] = ACTIONS(1801),
    [anon_sym_STAR] = ACTIONS(1805),
    [anon_sym_CARET] = ACTIONS(1803),
    [anon_sym_AMP] = ACTIONS(1803),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1807),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1809),
    [anon_sym_DOT_DOT] = ACTIONS(1811),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(125),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(131),
    [anon_sym___reftype] = ACTIONS(133),
    [anon_sym___refvalue] = ACTIONS(135),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [2170] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3559),
    [sym__name] = STATE(6877),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2908),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7129),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4388),
    [sym_non_lvalue_expression] = STATE(4553),
    [sym_lvalue_expression] = STATE(3561),
    [sym__expression_statement_expression] = STATE(4559),
    [sym_assignment_expression] = STATE(4558),
    [sym_binary_expression] = STATE(4559),
    [sym_postfix_unary_expression] = STATE(4558),
    [sym_prefix_unary_expression] = STATE(4558),
    [sym__pointer_indirection_expression] = STATE(3560),
    [sym_query_expression] = STATE(4559),
    [sym_from_clause] = STATE(7385),
    [sym_conditional_expression] = STATE(4559),
    [sym_conditional_access_expression] = STATE(4559),
    [sym_as_expression] = STATE(4559),
    [sym_is_expression] = STATE(4559),
    [sym_is_pattern_expression] = STATE(4559),
    [sym_cast_expression] = STATE(4559),
    [sym_checked_expression] = STATE(4559),
    [sym_invocation_expression] = STATE(4558),
    [sym_switch_expression] = STATE(4559),
    [sym_await_expression] = STATE(4558),
    [sym_throw_expression] = STATE(4559),
    [sym_element_access_expression] = STATE(3560),
    [sym_interpolated_string_expression] = STATE(4559),
    [sym_member_access_expression] = STATE(3560),
    [sym_object_creation_expression] = STATE(4558),
    [sym_parenthesized_expression] = STATE(4558),
    [sym__parenthesized_lvalue_expression] = STATE(3560),
    [sym_lambda_expression] = STATE(4559),
    [sym__lambda_parameters] = STATE(9776),
    [sym_array_creation_expression] = STATE(4559),
    [sym_anonymous_method_expression] = STATE(4559),
    [sym_anonymous_object_creation_expression] = STATE(4559),
    [sym_implicit_array_creation_expression] = STATE(4559),
    [sym_implicit_object_creation_expression] = STATE(4559),
    [sym_implicit_stackalloc_expression] = STATE(4559),
    [sym_initializer_expression] = STATE(4559),
    [sym_default_expression] = STATE(4559),
    [sym_with_expression] = STATE(4559),
    [sym_sizeof_expression] = STATE(4559),
    [sym_typeof_expression] = STATE(4559),
    [sym_makeref_expression] = STATE(4559),
    [sym_ref_expression] = STATE(4559),
    [sym_reftype_expression] = STATE(4559),
    [sym_refvalue_expression] = STATE(4559),
    [sym_stackalloc_expression] = STATE(4559),
    [sym_range_expression] = STATE(4559),
    [sym_tuple_expression] = STATE(3560),
    [sym_literal] = STATE(4559),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4559),
    [sym_preproc_region] = STATE(2170),
    [sym_preproc_endregion] = STATE(2170),
    [sym_preproc_line] = STATE(2170),
    [sym_preproc_pragma] = STATE(2170),
    [sym_preproc_nullable] = STATE(2170),
    [sym_preproc_error] = STATE(2170),
    [sym_preproc_define] = STATE(2170),
    [sym_preproc_undef] = STATE(2170),
    [aux_sym_class_declaration_repeat1] = STATE(3843),
    [aux_sym_lambda_expression_repeat1] = STATE(4277),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(1675),
    [anon_sym_ref] = ACTIONS(1677),
    [anon_sym_LBRACE] = ACTIONS(1611),
    [anon_sym_delegate] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1679),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(1683),
    [anon_sym_TILDE] = ACTIONS(1683),
    [anon_sym_PLUS_PLUS] = ACTIONS(1683),
    [anon_sym_DASH_DASH] = ACTIONS(1683),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_DASH] = ACTIONS(1681),
    [anon_sym_STAR] = ACTIONS(1685),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1683),
    [anon_sym_this] = ACTIONS(1627),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1629),
    [anon_sym_unchecked] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(1687),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1689),
    [anon_sym_DOT_DOT] = ACTIONS(1691),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_stackalloc] = ACTIONS(1641),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(1647),
    [anon_sym___reftype] = ACTIONS(1649),
    [anon_sym___refvalue] = ACTIONS(1651),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1659),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [2171] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3559),
    [sym__name] = STATE(6877),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2908),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7129),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4356),
    [sym_non_lvalue_expression] = STATE(4553),
    [sym_lvalue_expression] = STATE(3561),
    [sym__expression_statement_expression] = STATE(4559),
    [sym_assignment_expression] = STATE(4558),
    [sym_binary_expression] = STATE(4559),
    [sym_postfix_unary_expression] = STATE(4558),
    [sym_prefix_unary_expression] = STATE(4558),
    [sym__pointer_indirection_expression] = STATE(3560),
    [sym_query_expression] = STATE(4559),
    [sym_from_clause] = STATE(7385),
    [sym_conditional_expression] = STATE(4559),
    [sym_conditional_access_expression] = STATE(4559),
    [sym_as_expression] = STATE(4559),
    [sym_is_expression] = STATE(4559),
    [sym_is_pattern_expression] = STATE(4559),
    [sym_cast_expression] = STATE(4559),
    [sym_checked_expression] = STATE(4559),
    [sym_invocation_expression] = STATE(4558),
    [sym_switch_expression] = STATE(4559),
    [sym_await_expression] = STATE(4558),
    [sym_throw_expression] = STATE(4559),
    [sym_element_access_expression] = STATE(3560),
    [sym_interpolated_string_expression] = STATE(4559),
    [sym_member_access_expression] = STATE(3560),
    [sym_object_creation_expression] = STATE(4558),
    [sym_parenthesized_expression] = STATE(4558),
    [sym__parenthesized_lvalue_expression] = STATE(3560),
    [sym_lambda_expression] = STATE(4559),
    [sym__lambda_parameters] = STATE(9776),
    [sym_array_creation_expression] = STATE(4559),
    [sym_anonymous_method_expression] = STATE(4559),
    [sym_anonymous_object_creation_expression] = STATE(4559),
    [sym_implicit_array_creation_expression] = STATE(4559),
    [sym_implicit_object_creation_expression] = STATE(4559),
    [sym_implicit_stackalloc_expression] = STATE(4559),
    [sym_initializer_expression] = STATE(4559),
    [sym_default_expression] = STATE(4559),
    [sym_with_expression] = STATE(4559),
    [sym_sizeof_expression] = STATE(4559),
    [sym_typeof_expression] = STATE(4559),
    [sym_makeref_expression] = STATE(4559),
    [sym_ref_expression] = STATE(4559),
    [sym_reftype_expression] = STATE(4559),
    [sym_refvalue_expression] = STATE(4559),
    [sym_stackalloc_expression] = STATE(4559),
    [sym_range_expression] = STATE(4559),
    [sym_tuple_expression] = STATE(3560),
    [sym_literal] = STATE(4559),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4559),
    [sym_preproc_region] = STATE(2171),
    [sym_preproc_endregion] = STATE(2171),
    [sym_preproc_line] = STATE(2171),
    [sym_preproc_pragma] = STATE(2171),
    [sym_preproc_nullable] = STATE(2171),
    [sym_preproc_error] = STATE(2171),
    [sym_preproc_define] = STATE(2171),
    [sym_preproc_undef] = STATE(2171),
    [aux_sym_class_declaration_repeat1] = STATE(3843),
    [aux_sym_lambda_expression_repeat1] = STATE(4277),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(1675),
    [anon_sym_ref] = ACTIONS(1677),
    [anon_sym_LBRACE] = ACTIONS(1611),
    [anon_sym_delegate] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1679),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(1683),
    [anon_sym_TILDE] = ACTIONS(1683),
    [anon_sym_PLUS_PLUS] = ACTIONS(1683),
    [anon_sym_DASH_DASH] = ACTIONS(1683),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_DASH] = ACTIONS(1681),
    [anon_sym_STAR] = ACTIONS(1685),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1683),
    [anon_sym_this] = ACTIONS(1627),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1629),
    [anon_sym_unchecked] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(1687),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1689),
    [anon_sym_DOT_DOT] = ACTIONS(1691),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_stackalloc] = ACTIONS(1641),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(1647),
    [anon_sym___reftype] = ACTIONS(1649),
    [anon_sym___refvalue] = ACTIONS(1651),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1659),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [2172] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3921),
    [sym__name] = STATE(6889),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2854),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(7061),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5166),
    [sym_non_lvalue_expression] = STATE(5735),
    [sym_lvalue_expression] = STATE(3899),
    [sym__expression_statement_expression] = STATE(5733),
    [sym_assignment_expression] = STATE(5734),
    [sym_binary_expression] = STATE(5733),
    [sym_postfix_unary_expression] = STATE(5734),
    [sym_prefix_unary_expression] = STATE(5734),
    [sym__pointer_indirection_expression] = STATE(3911),
    [sym_query_expression] = STATE(5733),
    [sym_from_clause] = STATE(7400),
    [sym_conditional_expression] = STATE(5733),
    [sym_conditional_access_expression] = STATE(5733),
    [sym_as_expression] = STATE(5733),
    [sym_is_expression] = STATE(5733),
    [sym_is_pattern_expression] = STATE(5733),
    [sym_cast_expression] = STATE(5733),
    [sym_checked_expression] = STATE(5733),
    [sym_invocation_expression] = STATE(5734),
    [sym_switch_expression] = STATE(5733),
    [sym_await_expression] = STATE(5734),
    [sym_throw_expression] = STATE(5733),
    [sym_element_access_expression] = STATE(3911),
    [sym_interpolated_string_expression] = STATE(5733),
    [sym_member_access_expression] = STATE(3911),
    [sym_object_creation_expression] = STATE(5734),
    [sym_parenthesized_expression] = STATE(5734),
    [sym__parenthesized_lvalue_expression] = STATE(3911),
    [sym_lambda_expression] = STATE(5733),
    [sym__lambda_parameters] = STATE(9790),
    [sym_array_creation_expression] = STATE(5733),
    [sym_anonymous_method_expression] = STATE(5733),
    [sym_anonymous_object_creation_expression] = STATE(5733),
    [sym_implicit_array_creation_expression] = STATE(5733),
    [sym_implicit_object_creation_expression] = STATE(5733),
    [sym_implicit_stackalloc_expression] = STATE(5733),
    [sym_initializer_expression] = STATE(5733),
    [sym_default_expression] = STATE(5733),
    [sym_with_expression] = STATE(5733),
    [sym_sizeof_expression] = STATE(5733),
    [sym_typeof_expression] = STATE(5733),
    [sym_makeref_expression] = STATE(5733),
    [sym_ref_expression] = STATE(5733),
    [sym_reftype_expression] = STATE(5733),
    [sym_refvalue_expression] = STATE(5733),
    [sym_stackalloc_expression] = STATE(5733),
    [sym_range_expression] = STATE(5733),
    [sym_tuple_expression] = STATE(3911),
    [sym_literal] = STATE(5733),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2798),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(5733),
    [sym_preproc_region] = STATE(2172),
    [sym_preproc_endregion] = STATE(2172),
    [sym_preproc_line] = STATE(2172),
    [sym_preproc_pragma] = STATE(2172),
    [sym_preproc_nullable] = STATE(2172),
    [sym_preproc_error] = STATE(2172),
    [sym_preproc_define] = STATE(2172),
    [sym_preproc_undef] = STATE(2172),
    [aux_sym_class_declaration_repeat1] = STATE(3833),
    [aux_sym_lambda_expression_repeat1] = STATE(4182),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_LPAREN] = ACTIONS(1439),
    [anon_sym_ref] = ACTIONS(1441),
    [anon_sym_LBRACE] = ACTIONS(1377),
    [anon_sym_delegate] = ACTIONS(1379),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1443),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1447),
    [anon_sym_TILDE] = ACTIONS(1447),
    [anon_sym_PLUS_PLUS] = ACTIONS(1447),
    [anon_sym_DASH_DASH] = ACTIONS(1447),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1445),
    [anon_sym_DASH] = ACTIONS(1445),
    [anon_sym_STAR] = ACTIONS(1449),
    [anon_sym_CARET] = ACTIONS(1447),
    [anon_sym_AMP] = ACTIONS(1447),
    [anon_sym_this] = ACTIONS(1393),
    [anon_sym_scoped] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1397),
    [sym_predefined_type] = ACTIONS(1399),
    [anon_sym_unchecked] = ACTIONS(1383),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1451),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1453),
    [anon_sym_DOT_DOT] = ACTIONS(1455),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_stackalloc] = ACTIONS(1413),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(1419),
    [anon_sym___reftype] = ACTIONS(1421),
    [anon_sym___refvalue] = ACTIONS(1423),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
  },
  [2173] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3559),
    [sym__name] = STATE(6877),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2908),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7129),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4357),
    [sym_non_lvalue_expression] = STATE(4553),
    [sym_lvalue_expression] = STATE(3561),
    [sym__expression_statement_expression] = STATE(4559),
    [sym_assignment_expression] = STATE(4558),
    [sym_binary_expression] = STATE(4559),
    [sym_postfix_unary_expression] = STATE(4558),
    [sym_prefix_unary_expression] = STATE(4558),
    [sym__pointer_indirection_expression] = STATE(3560),
    [sym_query_expression] = STATE(4559),
    [sym_from_clause] = STATE(7385),
    [sym_conditional_expression] = STATE(4559),
    [sym_conditional_access_expression] = STATE(4559),
    [sym_as_expression] = STATE(4559),
    [sym_is_expression] = STATE(4559),
    [sym_is_pattern_expression] = STATE(4559),
    [sym_cast_expression] = STATE(4559),
    [sym_checked_expression] = STATE(4559),
    [sym_invocation_expression] = STATE(4558),
    [sym_switch_expression] = STATE(4559),
    [sym_await_expression] = STATE(4558),
    [sym_throw_expression] = STATE(4559),
    [sym_element_access_expression] = STATE(3560),
    [sym_interpolated_string_expression] = STATE(4559),
    [sym_member_access_expression] = STATE(3560),
    [sym_object_creation_expression] = STATE(4558),
    [sym_parenthesized_expression] = STATE(4558),
    [sym__parenthesized_lvalue_expression] = STATE(3560),
    [sym_lambda_expression] = STATE(4559),
    [sym__lambda_parameters] = STATE(9776),
    [sym_array_creation_expression] = STATE(4559),
    [sym_anonymous_method_expression] = STATE(4559),
    [sym_anonymous_object_creation_expression] = STATE(4559),
    [sym_implicit_array_creation_expression] = STATE(4559),
    [sym_implicit_object_creation_expression] = STATE(4559),
    [sym_implicit_stackalloc_expression] = STATE(4559),
    [sym_initializer_expression] = STATE(4559),
    [sym_default_expression] = STATE(4559),
    [sym_with_expression] = STATE(4559),
    [sym_sizeof_expression] = STATE(4559),
    [sym_typeof_expression] = STATE(4559),
    [sym_makeref_expression] = STATE(4559),
    [sym_ref_expression] = STATE(4559),
    [sym_reftype_expression] = STATE(4559),
    [sym_refvalue_expression] = STATE(4559),
    [sym_stackalloc_expression] = STATE(4559),
    [sym_range_expression] = STATE(4559),
    [sym_tuple_expression] = STATE(3560),
    [sym_literal] = STATE(4559),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4559),
    [sym_preproc_region] = STATE(2173),
    [sym_preproc_endregion] = STATE(2173),
    [sym_preproc_line] = STATE(2173),
    [sym_preproc_pragma] = STATE(2173),
    [sym_preproc_nullable] = STATE(2173),
    [sym_preproc_error] = STATE(2173),
    [sym_preproc_define] = STATE(2173),
    [sym_preproc_undef] = STATE(2173),
    [aux_sym_class_declaration_repeat1] = STATE(3843),
    [aux_sym_lambda_expression_repeat1] = STATE(4277),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(1675),
    [anon_sym_ref] = ACTIONS(1677),
    [anon_sym_LBRACE] = ACTIONS(1611),
    [anon_sym_delegate] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1679),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(1683),
    [anon_sym_TILDE] = ACTIONS(1683),
    [anon_sym_PLUS_PLUS] = ACTIONS(1683),
    [anon_sym_DASH_DASH] = ACTIONS(1683),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_DASH] = ACTIONS(1681),
    [anon_sym_STAR] = ACTIONS(1685),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1683),
    [anon_sym_this] = ACTIONS(1627),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1629),
    [anon_sym_unchecked] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(1687),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1689),
    [anon_sym_DOT_DOT] = ACTIONS(1691),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_stackalloc] = ACTIONS(1641),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(1647),
    [anon_sym___reftype] = ACTIONS(1649),
    [anon_sym___refvalue] = ACTIONS(1651),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1659),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [2174] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6904),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7009),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(3565),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4008),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7381),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9536),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(2174),
    [sym_preproc_endregion] = STATE(2174),
    [sym_preproc_line] = STATE(2174),
    [sym_preproc_pragma] = STATE(2174),
    [sym_preproc_nullable] = STATE(2174),
    [sym_preproc_error] = STATE(2174),
    [sym_preproc_define] = STATE(2174),
    [sym_preproc_undef] = STATE(2174),
    [aux_sym_class_declaration_repeat1] = STATE(3832),
    [aux_sym_lambda_expression_repeat1] = STATE(4090),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1485),
    [anon_sym_ref] = ACTIONS(1487),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1221),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1491),
    [anon_sym_TILDE] = ACTIONS(1491),
    [anon_sym_PLUS_PLUS] = ACTIONS(1491),
    [anon_sym_DASH_DASH] = ACTIONS(1491),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1489),
    [anon_sym_DASH] = ACTIONS(1489),
    [anon_sym_STAR] = ACTIONS(1493),
    [anon_sym_CARET] = ACTIONS(1491),
    [anon_sym_AMP] = ACTIONS(1491),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1495),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1497),
    [anon_sym_DOT_DOT] = ACTIONS(1499),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [2175] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3559),
    [sym__name] = STATE(6877),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2908),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7129),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4404),
    [sym_non_lvalue_expression] = STATE(4553),
    [sym_lvalue_expression] = STATE(3561),
    [sym__expression_statement_expression] = STATE(4559),
    [sym_assignment_expression] = STATE(4558),
    [sym_binary_expression] = STATE(4559),
    [sym_postfix_unary_expression] = STATE(4558),
    [sym_prefix_unary_expression] = STATE(4558),
    [sym__pointer_indirection_expression] = STATE(3560),
    [sym_query_expression] = STATE(4559),
    [sym_from_clause] = STATE(7385),
    [sym_conditional_expression] = STATE(4559),
    [sym_conditional_access_expression] = STATE(4559),
    [sym_as_expression] = STATE(4559),
    [sym_is_expression] = STATE(4559),
    [sym_is_pattern_expression] = STATE(4559),
    [sym_cast_expression] = STATE(4559),
    [sym_checked_expression] = STATE(4559),
    [sym_invocation_expression] = STATE(4558),
    [sym_switch_expression] = STATE(4559),
    [sym_await_expression] = STATE(4558),
    [sym_throw_expression] = STATE(4559),
    [sym_element_access_expression] = STATE(3560),
    [sym_interpolated_string_expression] = STATE(4559),
    [sym_member_access_expression] = STATE(3560),
    [sym_object_creation_expression] = STATE(4558),
    [sym_parenthesized_expression] = STATE(4558),
    [sym__parenthesized_lvalue_expression] = STATE(3560),
    [sym_lambda_expression] = STATE(4559),
    [sym__lambda_parameters] = STATE(9776),
    [sym_array_creation_expression] = STATE(4559),
    [sym_anonymous_method_expression] = STATE(4559),
    [sym_anonymous_object_creation_expression] = STATE(4559),
    [sym_implicit_array_creation_expression] = STATE(4559),
    [sym_implicit_object_creation_expression] = STATE(4559),
    [sym_implicit_stackalloc_expression] = STATE(4559),
    [sym_initializer_expression] = STATE(4559),
    [sym_default_expression] = STATE(4559),
    [sym_with_expression] = STATE(4559),
    [sym_sizeof_expression] = STATE(4559),
    [sym_typeof_expression] = STATE(4559),
    [sym_makeref_expression] = STATE(4559),
    [sym_ref_expression] = STATE(4559),
    [sym_reftype_expression] = STATE(4559),
    [sym_refvalue_expression] = STATE(4559),
    [sym_stackalloc_expression] = STATE(4559),
    [sym_range_expression] = STATE(4559),
    [sym_tuple_expression] = STATE(3560),
    [sym_literal] = STATE(4559),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4559),
    [sym_preproc_region] = STATE(2175),
    [sym_preproc_endregion] = STATE(2175),
    [sym_preproc_line] = STATE(2175),
    [sym_preproc_pragma] = STATE(2175),
    [sym_preproc_nullable] = STATE(2175),
    [sym_preproc_error] = STATE(2175),
    [sym_preproc_define] = STATE(2175),
    [sym_preproc_undef] = STATE(2175),
    [aux_sym_class_declaration_repeat1] = STATE(3843),
    [aux_sym_lambda_expression_repeat1] = STATE(4277),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(1675),
    [anon_sym_ref] = ACTIONS(1677),
    [anon_sym_LBRACE] = ACTIONS(1611),
    [anon_sym_delegate] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1679),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(1683),
    [anon_sym_TILDE] = ACTIONS(1683),
    [anon_sym_PLUS_PLUS] = ACTIONS(1683),
    [anon_sym_DASH_DASH] = ACTIONS(1683),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_DASH] = ACTIONS(1681),
    [anon_sym_STAR] = ACTIONS(1685),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1683),
    [anon_sym_this] = ACTIONS(1627),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1629),
    [anon_sym_unchecked] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(1687),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1689),
    [anon_sym_DOT_DOT] = ACTIONS(1691),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_stackalloc] = ACTIONS(1641),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(1647),
    [anon_sym___reftype] = ACTIONS(1649),
    [anon_sym___refvalue] = ACTIONS(1651),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1659),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [2176] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3921),
    [sym__name] = STATE(6889),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2854),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(6991),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5557),
    [sym_non_lvalue_expression] = STATE(5735),
    [sym_lvalue_expression] = STATE(4295),
    [sym__expression_statement_expression] = STATE(5733),
    [sym_assignment_expression] = STATE(5734),
    [sym_binary_expression] = STATE(5733),
    [sym_postfix_unary_expression] = STATE(5734),
    [sym_prefix_unary_expression] = STATE(5734),
    [sym__pointer_indirection_expression] = STATE(3911),
    [sym_query_expression] = STATE(5733),
    [sym_from_clause] = STATE(7393),
    [sym_conditional_expression] = STATE(5733),
    [sym_conditional_access_expression] = STATE(5733),
    [sym_as_expression] = STATE(5733),
    [sym_is_expression] = STATE(5733),
    [sym_is_pattern_expression] = STATE(5733),
    [sym_cast_expression] = STATE(5733),
    [sym_checked_expression] = STATE(5733),
    [sym_invocation_expression] = STATE(5734),
    [sym_switch_expression] = STATE(5733),
    [sym_await_expression] = STATE(5734),
    [sym_throw_expression] = STATE(5733),
    [sym_element_access_expression] = STATE(3911),
    [sym_interpolated_string_expression] = STATE(5733),
    [sym_member_access_expression] = STATE(3911),
    [sym_object_creation_expression] = STATE(5734),
    [sym_parenthesized_expression] = STATE(5734),
    [sym__parenthesized_lvalue_expression] = STATE(3911),
    [sym_lambda_expression] = STATE(5733),
    [sym__lambda_parameters] = STATE(9313),
    [sym_array_creation_expression] = STATE(5733),
    [sym_anonymous_method_expression] = STATE(5733),
    [sym_anonymous_object_creation_expression] = STATE(5733),
    [sym_implicit_array_creation_expression] = STATE(5733),
    [sym_implicit_object_creation_expression] = STATE(5733),
    [sym_implicit_stackalloc_expression] = STATE(5733),
    [sym_initializer_expression] = STATE(5733),
    [sym_default_expression] = STATE(5733),
    [sym_with_expression] = STATE(5733),
    [sym_sizeof_expression] = STATE(5733),
    [sym_typeof_expression] = STATE(5733),
    [sym_makeref_expression] = STATE(5733),
    [sym_ref_expression] = STATE(5733),
    [sym_reftype_expression] = STATE(5733),
    [sym_refvalue_expression] = STATE(5733),
    [sym_stackalloc_expression] = STATE(5733),
    [sym_range_expression] = STATE(5733),
    [sym_tuple_expression] = STATE(3911),
    [sym_literal] = STATE(5733),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2798),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(5733),
    [sym_preproc_region] = STATE(2176),
    [sym_preproc_endregion] = STATE(2176),
    [sym_preproc_line] = STATE(2176),
    [sym_preproc_pragma] = STATE(2176),
    [sym_preproc_nullable] = STATE(2176),
    [sym_preproc_error] = STATE(2176),
    [sym_preproc_define] = STATE(2176),
    [sym_preproc_undef] = STATE(2176),
    [aux_sym_class_declaration_repeat1] = STATE(3805),
    [aux_sym_lambda_expression_repeat1] = STATE(4122),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_LPAREN] = ACTIONS(1591),
    [anon_sym_ref] = ACTIONS(1593),
    [anon_sym_LBRACE] = ACTIONS(1377),
    [anon_sym_delegate] = ACTIONS(1379),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1443),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1597),
    [anon_sym_TILDE] = ACTIONS(1597),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1595),
    [anon_sym_DASH] = ACTIONS(1595),
    [anon_sym_STAR] = ACTIONS(1449),
    [anon_sym_CARET] = ACTIONS(1597),
    [anon_sym_AMP] = ACTIONS(1597),
    [anon_sym_this] = ACTIONS(1393),
    [anon_sym_scoped] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1397),
    [sym_predefined_type] = ACTIONS(1399),
    [anon_sym_unchecked] = ACTIONS(1383),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1599),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1601),
    [anon_sym_DOT_DOT] = ACTIONS(1603),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_stackalloc] = ACTIONS(1413),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(1419),
    [anon_sym___reftype] = ACTIONS(1421),
    [anon_sym___refvalue] = ACTIONS(1423),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
  },
  [2177] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3559),
    [sym__name] = STATE(6877),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2908),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7129),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4346),
    [sym_non_lvalue_expression] = STATE(4553),
    [sym_lvalue_expression] = STATE(3561),
    [sym__expression_statement_expression] = STATE(4559),
    [sym_assignment_expression] = STATE(4558),
    [sym_binary_expression] = STATE(4559),
    [sym_postfix_unary_expression] = STATE(4558),
    [sym_prefix_unary_expression] = STATE(4558),
    [sym__pointer_indirection_expression] = STATE(3560),
    [sym_query_expression] = STATE(4559),
    [sym_from_clause] = STATE(7385),
    [sym_conditional_expression] = STATE(4559),
    [sym_conditional_access_expression] = STATE(4559),
    [sym_as_expression] = STATE(4559),
    [sym_is_expression] = STATE(4559),
    [sym_is_pattern_expression] = STATE(4559),
    [sym_cast_expression] = STATE(4559),
    [sym_checked_expression] = STATE(4559),
    [sym_invocation_expression] = STATE(4558),
    [sym_switch_expression] = STATE(4559),
    [sym_await_expression] = STATE(4558),
    [sym_throw_expression] = STATE(4559),
    [sym_element_access_expression] = STATE(3560),
    [sym_interpolated_string_expression] = STATE(4559),
    [sym_member_access_expression] = STATE(3560),
    [sym_object_creation_expression] = STATE(4558),
    [sym_parenthesized_expression] = STATE(4558),
    [sym__parenthesized_lvalue_expression] = STATE(3560),
    [sym_lambda_expression] = STATE(4559),
    [sym__lambda_parameters] = STATE(9776),
    [sym_array_creation_expression] = STATE(4559),
    [sym_anonymous_method_expression] = STATE(4559),
    [sym_anonymous_object_creation_expression] = STATE(4559),
    [sym_implicit_array_creation_expression] = STATE(4559),
    [sym_implicit_object_creation_expression] = STATE(4559),
    [sym_implicit_stackalloc_expression] = STATE(4559),
    [sym_initializer_expression] = STATE(4559),
    [sym_default_expression] = STATE(4559),
    [sym_with_expression] = STATE(4559),
    [sym_sizeof_expression] = STATE(4559),
    [sym_typeof_expression] = STATE(4559),
    [sym_makeref_expression] = STATE(4559),
    [sym_ref_expression] = STATE(4559),
    [sym_reftype_expression] = STATE(4559),
    [sym_refvalue_expression] = STATE(4559),
    [sym_stackalloc_expression] = STATE(4559),
    [sym_range_expression] = STATE(4559),
    [sym_tuple_expression] = STATE(3560),
    [sym_literal] = STATE(4559),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4559),
    [sym_preproc_region] = STATE(2177),
    [sym_preproc_endregion] = STATE(2177),
    [sym_preproc_line] = STATE(2177),
    [sym_preproc_pragma] = STATE(2177),
    [sym_preproc_nullable] = STATE(2177),
    [sym_preproc_error] = STATE(2177),
    [sym_preproc_define] = STATE(2177),
    [sym_preproc_undef] = STATE(2177),
    [aux_sym_class_declaration_repeat1] = STATE(3843),
    [aux_sym_lambda_expression_repeat1] = STATE(4277),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(1675),
    [anon_sym_ref] = ACTIONS(1677),
    [anon_sym_LBRACE] = ACTIONS(1611),
    [anon_sym_delegate] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1679),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(1683),
    [anon_sym_TILDE] = ACTIONS(1683),
    [anon_sym_PLUS_PLUS] = ACTIONS(1683),
    [anon_sym_DASH_DASH] = ACTIONS(1683),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_DASH] = ACTIONS(1681),
    [anon_sym_STAR] = ACTIONS(1685),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1683),
    [anon_sym_this] = ACTIONS(1627),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1629),
    [anon_sym_unchecked] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(1687),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1689),
    [anon_sym_DOT_DOT] = ACTIONS(1691),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_stackalloc] = ACTIONS(1641),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(1647),
    [anon_sym___reftype] = ACTIONS(1649),
    [anon_sym___refvalue] = ACTIONS(1651),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1659),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [2178] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6904),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7009),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5275),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4008),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7381),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9536),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(2178),
    [sym_preproc_endregion] = STATE(2178),
    [sym_preproc_line] = STATE(2178),
    [sym_preproc_pragma] = STATE(2178),
    [sym_preproc_nullable] = STATE(2178),
    [sym_preproc_error] = STATE(2178),
    [sym_preproc_define] = STATE(2178),
    [sym_preproc_undef] = STATE(2178),
    [aux_sym_class_declaration_repeat1] = STATE(3832),
    [aux_sym_lambda_expression_repeat1] = STATE(4090),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1485),
    [anon_sym_ref] = ACTIONS(1487),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1221),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1491),
    [anon_sym_TILDE] = ACTIONS(1491),
    [anon_sym_PLUS_PLUS] = ACTIONS(1491),
    [anon_sym_DASH_DASH] = ACTIONS(1491),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1489),
    [anon_sym_DASH] = ACTIONS(1489),
    [anon_sym_STAR] = ACTIONS(1493),
    [anon_sym_CARET] = ACTIONS(1491),
    [anon_sym_AMP] = ACTIONS(1491),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1495),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1497),
    [anon_sym_DOT_DOT] = ACTIONS(1499),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [2179] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6904),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7009),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5274),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4008),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7381),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9536),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(2179),
    [sym_preproc_endregion] = STATE(2179),
    [sym_preproc_line] = STATE(2179),
    [sym_preproc_pragma] = STATE(2179),
    [sym_preproc_nullable] = STATE(2179),
    [sym_preproc_error] = STATE(2179),
    [sym_preproc_define] = STATE(2179),
    [sym_preproc_undef] = STATE(2179),
    [aux_sym_class_declaration_repeat1] = STATE(3832),
    [aux_sym_lambda_expression_repeat1] = STATE(4090),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1485),
    [anon_sym_ref] = ACTIONS(1487),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1221),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1491),
    [anon_sym_TILDE] = ACTIONS(1491),
    [anon_sym_PLUS_PLUS] = ACTIONS(1491),
    [anon_sym_DASH_DASH] = ACTIONS(1491),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1489),
    [anon_sym_DASH] = ACTIONS(1489),
    [anon_sym_STAR] = ACTIONS(1493),
    [anon_sym_CARET] = ACTIONS(1491),
    [anon_sym_AMP] = ACTIONS(1491),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1495),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1497),
    [anon_sym_DOT_DOT] = ACTIONS(1499),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [2180] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3921),
    [sym__name] = STATE(6889),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2854),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2813),
    [sym_type] = STATE(6991),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5124),
    [sym_non_lvalue_expression] = STATE(5735),
    [sym_lvalue_expression] = STATE(4295),
    [sym__expression_statement_expression] = STATE(5733),
    [sym_assignment_expression] = STATE(5734),
    [sym_binary_expression] = STATE(5733),
    [sym_postfix_unary_expression] = STATE(5734),
    [sym_prefix_unary_expression] = STATE(5734),
    [sym__pointer_indirection_expression] = STATE(3911),
    [sym_query_expression] = STATE(5733),
    [sym_from_clause] = STATE(7393),
    [sym_conditional_expression] = STATE(5733),
    [sym_conditional_access_expression] = STATE(5733),
    [sym_as_expression] = STATE(5733),
    [sym_is_expression] = STATE(5733),
    [sym_is_pattern_expression] = STATE(5733),
    [sym_cast_expression] = STATE(5733),
    [sym_checked_expression] = STATE(5733),
    [sym_invocation_expression] = STATE(5734),
    [sym_switch_expression] = STATE(5733),
    [sym_await_expression] = STATE(5734),
    [sym_throw_expression] = STATE(5733),
    [sym_element_access_expression] = STATE(3911),
    [sym_interpolated_string_expression] = STATE(5733),
    [sym_member_access_expression] = STATE(3911),
    [sym_object_creation_expression] = STATE(5734),
    [sym_parenthesized_expression] = STATE(5734),
    [sym__parenthesized_lvalue_expression] = STATE(3911),
    [sym_lambda_expression] = STATE(5733),
    [sym__lambda_parameters] = STATE(9313),
    [sym_array_creation_expression] = STATE(5733),
    [sym_anonymous_method_expression] = STATE(5733),
    [sym_anonymous_object_creation_expression] = STATE(5733),
    [sym_implicit_array_creation_expression] = STATE(5733),
    [sym_implicit_object_creation_expression] = STATE(5733),
    [sym_implicit_stackalloc_expression] = STATE(5733),
    [sym_initializer_expression] = STATE(5733),
    [sym_default_expression] = STATE(5733),
    [sym_with_expression] = STATE(5733),
    [sym_sizeof_expression] = STATE(5733),
    [sym_typeof_expression] = STATE(5733),
    [sym_makeref_expression] = STATE(5733),
    [sym_ref_expression] = STATE(5733),
    [sym_reftype_expression] = STATE(5733),
    [sym_refvalue_expression] = STATE(5733),
    [sym_stackalloc_expression] = STATE(5733),
    [sym_range_expression] = STATE(5733),
    [sym_tuple_expression] = STATE(3911),
    [sym_literal] = STATE(5733),
    [sym_character_literal] = STATE(5740),
    [sym_string_literal] = STATE(5740),
    [sym_boolean_literal] = STATE(5740),
    [sym_identifier] = STATE(2798),
    [sym__reserved_identifier] = STATE(2792),
    [sym_preproc_if_in_expression] = STATE(5733),
    [sym_preproc_region] = STATE(2180),
    [sym_preproc_endregion] = STATE(2180),
    [sym_preproc_line] = STATE(2180),
    [sym_preproc_pragma] = STATE(2180),
    [sym_preproc_nullable] = STATE(2180),
    [sym_preproc_error] = STATE(2180),
    [sym_preproc_define] = STATE(2180),
    [sym_preproc_undef] = STATE(2180),
    [aux_sym_class_declaration_repeat1] = STATE(3805),
    [aux_sym_lambda_expression_repeat1] = STATE(4122),
    [sym__identifier_token] = ACTIONS(1367),
    [anon_sym_alias] = ACTIONS(1369),
    [anon_sym_global] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_LPAREN] = ACTIONS(1591),
    [anon_sym_ref] = ACTIONS(1593),
    [anon_sym_LBRACE] = ACTIONS(1377),
    [anon_sym_delegate] = ACTIONS(1379),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1443),
    [anon_sym_where] = ACTIONS(1369),
    [anon_sym_notnull] = ACTIONS(1369),
    [anon_sym_unmanaged] = ACTIONS(1369),
    [anon_sym_checked] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1597),
    [anon_sym_TILDE] = ACTIONS(1597),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1595),
    [anon_sym_DASH] = ACTIONS(1595),
    [anon_sym_STAR] = ACTIONS(1449),
    [anon_sym_CARET] = ACTIONS(1597),
    [anon_sym_AMP] = ACTIONS(1597),
    [anon_sym_this] = ACTIONS(1393),
    [anon_sym_scoped] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1397),
    [sym_predefined_type] = ACTIONS(1399),
    [anon_sym_unchecked] = ACTIONS(1383),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1599),
    [anon_sym_when] = ACTIONS(1369),
    [anon_sym_await] = ACTIONS(1601),
    [anon_sym_DOT_DOT] = ACTIONS(1603),
    [anon_sym_from] = ACTIONS(1409),
    [anon_sym_into] = ACTIONS(1369),
    [anon_sym_join] = ACTIONS(1369),
    [anon_sym_on] = ACTIONS(1369),
    [anon_sym_equals] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_orderby] = ACTIONS(1369),
    [anon_sym_ascending] = ACTIONS(1369),
    [anon_sym_descending] = ACTIONS(1369),
    [anon_sym_group] = ACTIONS(1369),
    [anon_sym_by] = ACTIONS(1369),
    [anon_sym_select] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [anon_sym_stackalloc] = ACTIONS(1413),
    [anon_sym_sizeof] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym___makeref] = ACTIONS(1419),
    [anon_sym___reftype] = ACTIONS(1421),
    [anon_sym___refvalue] = ACTIONS(1423),
    [sym_null_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [sym_integer_literal] = ACTIONS(1425),
    [sym_real_literal] = ACTIONS(1429),
    [sym_verbatim_string_literal] = ACTIONS(1429),
    [sym_raw_string_literal] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1433),
    [sym_interpolation_verbatim_start] = ACTIONS(1435),
    [sym_interpolation_raw_start] = ACTIONS(1437),
  },
  [2181] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3559),
    [sym__name] = STATE(6877),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2908),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7129),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4402),
    [sym_non_lvalue_expression] = STATE(4553),
    [sym_lvalue_expression] = STATE(3561),
    [sym__expression_statement_expression] = STATE(4559),
    [sym_assignment_expression] = STATE(4558),
    [sym_binary_expression] = STATE(4559),
    [sym_postfix_unary_expression] = STATE(4558),
    [sym_prefix_unary_expression] = STATE(4558),
    [sym__pointer_indirection_expression] = STATE(3560),
    [sym_query_expression] = STATE(4559),
    [sym_from_clause] = STATE(7385),
    [sym_conditional_expression] = STATE(4559),
    [sym_conditional_access_expression] = STATE(4559),
    [sym_as_expression] = STATE(4559),
    [sym_is_expression] = STATE(4559),
    [sym_is_pattern_expression] = STATE(4559),
    [sym_cast_expression] = STATE(4559),
    [sym_checked_expression] = STATE(4559),
    [sym_invocation_expression] = STATE(4558),
    [sym_switch_expression] = STATE(4559),
    [sym_await_expression] = STATE(4558),
    [sym_throw_expression] = STATE(4559),
    [sym_element_access_expression] = STATE(3560),
    [sym_interpolated_string_expression] = STATE(4559),
    [sym_member_access_expression] = STATE(3560),
    [sym_object_creation_expression] = STATE(4558),
    [sym_parenthesized_expression] = STATE(4558),
    [sym__parenthesized_lvalue_expression] = STATE(3560),
    [sym_lambda_expression] = STATE(4559),
    [sym__lambda_parameters] = STATE(9776),
    [sym_array_creation_expression] = STATE(4559),
    [sym_anonymous_method_expression] = STATE(4559),
    [sym_anonymous_object_creation_expression] = STATE(4559),
    [sym_implicit_array_creation_expression] = STATE(4559),
    [sym_implicit_object_creation_expression] = STATE(4559),
    [sym_implicit_stackalloc_expression] = STATE(4559),
    [sym_initializer_expression] = STATE(4559),
    [sym_default_expression] = STATE(4559),
    [sym_with_expression] = STATE(4559),
    [sym_sizeof_expression] = STATE(4559),
    [sym_typeof_expression] = STATE(4559),
    [sym_makeref_expression] = STATE(4559),
    [sym_ref_expression] = STATE(4559),
    [sym_reftype_expression] = STATE(4559),
    [sym_refvalue_expression] = STATE(4559),
    [sym_stackalloc_expression] = STATE(4559),
    [sym_range_expression] = STATE(4559),
    [sym_tuple_expression] = STATE(3560),
    [sym_literal] = STATE(4559),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4559),
    [sym_preproc_region] = STATE(2181),
    [sym_preproc_endregion] = STATE(2181),
    [sym_preproc_line] = STATE(2181),
    [sym_preproc_pragma] = STATE(2181),
    [sym_preproc_nullable] = STATE(2181),
    [sym_preproc_error] = STATE(2181),
    [sym_preproc_define] = STATE(2181),
    [sym_preproc_undef] = STATE(2181),
    [aux_sym_class_declaration_repeat1] = STATE(3843),
    [aux_sym_lambda_expression_repeat1] = STATE(4277),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(1675),
    [anon_sym_ref] = ACTIONS(1677),
    [anon_sym_LBRACE] = ACTIONS(1611),
    [anon_sym_delegate] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1679),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(1683),
    [anon_sym_TILDE] = ACTIONS(1683),
    [anon_sym_PLUS_PLUS] = ACTIONS(1683),
    [anon_sym_DASH_DASH] = ACTIONS(1683),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_DASH] = ACTIONS(1681),
    [anon_sym_STAR] = ACTIONS(1685),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1683),
    [anon_sym_this] = ACTIONS(1627),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1629),
    [anon_sym_unchecked] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(1687),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1689),
    [anon_sym_DOT_DOT] = ACTIONS(1691),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_stackalloc] = ACTIONS(1641),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(1647),
    [anon_sym___reftype] = ACTIONS(1649),
    [anon_sym___refvalue] = ACTIONS(1651),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1659),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [2182] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6904),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7009),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5270),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4008),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7381),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9536),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(2182),
    [sym_preproc_endregion] = STATE(2182),
    [sym_preproc_line] = STATE(2182),
    [sym_preproc_pragma] = STATE(2182),
    [sym_preproc_nullable] = STATE(2182),
    [sym_preproc_error] = STATE(2182),
    [sym_preproc_define] = STATE(2182),
    [sym_preproc_undef] = STATE(2182),
    [aux_sym_class_declaration_repeat1] = STATE(3832),
    [aux_sym_lambda_expression_repeat1] = STATE(4090),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1485),
    [anon_sym_ref] = ACTIONS(1487),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1221),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1491),
    [anon_sym_TILDE] = ACTIONS(1491),
    [anon_sym_PLUS_PLUS] = ACTIONS(1491),
    [anon_sym_DASH_DASH] = ACTIONS(1491),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1489),
    [anon_sym_DASH] = ACTIONS(1489),
    [anon_sym_STAR] = ACTIONS(1493),
    [anon_sym_CARET] = ACTIONS(1491),
    [anon_sym_AMP] = ACTIONS(1491),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1495),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1497),
    [anon_sym_DOT_DOT] = ACTIONS(1499),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [2183] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3559),
    [sym__name] = STATE(6877),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2908),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7129),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(4394),
    [sym_non_lvalue_expression] = STATE(4553),
    [sym_lvalue_expression] = STATE(3561),
    [sym__expression_statement_expression] = STATE(4559),
    [sym_assignment_expression] = STATE(4558),
    [sym_binary_expression] = STATE(4559),
    [sym_postfix_unary_expression] = STATE(4558),
    [sym_prefix_unary_expression] = STATE(4558),
    [sym__pointer_indirection_expression] = STATE(3560),
    [sym_query_expression] = STATE(4559),
    [sym_from_clause] = STATE(7385),
    [sym_conditional_expression] = STATE(4559),
    [sym_conditional_access_expression] = STATE(4559),
    [sym_as_expression] = STATE(4559),
    [sym_is_expression] = STATE(4559),
    [sym_is_pattern_expression] = STATE(4559),
    [sym_cast_expression] = STATE(4559),
    [sym_checked_expression] = STATE(4559),
    [sym_invocation_expression] = STATE(4558),
    [sym_switch_expression] = STATE(4559),
    [sym_await_expression] = STATE(4558),
    [sym_throw_expression] = STATE(4559),
    [sym_element_access_expression] = STATE(3560),
    [sym_interpolated_string_expression] = STATE(4559),
    [sym_member_access_expression] = STATE(3560),
    [sym_object_creation_expression] = STATE(4558),
    [sym_parenthesized_expression] = STATE(4558),
    [sym__parenthesized_lvalue_expression] = STATE(3560),
    [sym_lambda_expression] = STATE(4559),
    [sym__lambda_parameters] = STATE(9776),
    [sym_array_creation_expression] = STATE(4559),
    [sym_anonymous_method_expression] = STATE(4559),
    [sym_anonymous_object_creation_expression] = STATE(4559),
    [sym_implicit_array_creation_expression] = STATE(4559),
    [sym_implicit_object_creation_expression] = STATE(4559),
    [sym_implicit_stackalloc_expression] = STATE(4559),
    [sym_initializer_expression] = STATE(4559),
    [sym_default_expression] = STATE(4559),
    [sym_with_expression] = STATE(4559),
    [sym_sizeof_expression] = STATE(4559),
    [sym_typeof_expression] = STATE(4559),
    [sym_makeref_expression] = STATE(4559),
    [sym_ref_expression] = STATE(4559),
    [sym_reftype_expression] = STATE(4559),
    [sym_refvalue_expression] = STATE(4559),
    [sym_stackalloc_expression] = STATE(4559),
    [sym_range_expression] = STATE(4559),
    [sym_tuple_expression] = STATE(3560),
    [sym_literal] = STATE(4559),
    [sym_character_literal] = STATE(4543),
    [sym_string_literal] = STATE(4543),
    [sym_boolean_literal] = STATE(4543),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(4559),
    [sym_preproc_region] = STATE(2183),
    [sym_preproc_endregion] = STATE(2183),
    [sym_preproc_line] = STATE(2183),
    [sym_preproc_pragma] = STATE(2183),
    [sym_preproc_nullable] = STATE(2183),
    [sym_preproc_error] = STATE(2183),
    [sym_preproc_define] = STATE(2183),
    [sym_preproc_undef] = STATE(2183),
    [aux_sym_class_declaration_repeat1] = STATE(3843),
    [aux_sym_lambda_expression_repeat1] = STATE(4277),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(1675),
    [anon_sym_ref] = ACTIONS(1677),
    [anon_sym_LBRACE] = ACTIONS(1611),
    [anon_sym_delegate] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1679),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(1683),
    [anon_sym_TILDE] = ACTIONS(1683),
    [anon_sym_PLUS_PLUS] = ACTIONS(1683),
    [anon_sym_DASH_DASH] = ACTIONS(1683),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_DASH] = ACTIONS(1681),
    [anon_sym_STAR] = ACTIONS(1685),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1683),
    [anon_sym_this] = ACTIONS(1627),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1629),
    [anon_sym_unchecked] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(1687),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1689),
    [anon_sym_DOT_DOT] = ACTIONS(1691),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_stackalloc] = ACTIONS(1641),
    [anon_sym_sizeof] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym___makeref] = ACTIONS(1647),
    [anon_sym___reftype] = ACTIONS(1649),
    [anon_sym___refvalue] = ACTIONS(1651),
    [sym_null_literal] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [sym_real_literal] = ACTIONS(1657),
    [sym_verbatim_string_literal] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [aux_sym_preproc_if_token1] = ACTIONS(1659),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1661),
    [sym_interpolation_verbatim_start] = ACTIONS(1663),
    [sym_interpolation_raw_start] = ACTIONS(1665),
  },
  [2184] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6904),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7009),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5269),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4008),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7381),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9536),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(2184),
    [sym_preproc_endregion] = STATE(2184),
    [sym_preproc_line] = STATE(2184),
    [sym_preproc_pragma] = STATE(2184),
    [sym_preproc_nullable] = STATE(2184),
    [sym_preproc_error] = STATE(2184),
    [sym_preproc_define] = STATE(2184),
    [sym_preproc_undef] = STATE(2184),
    [aux_sym_class_declaration_repeat1] = STATE(3832),
    [aux_sym_lambda_expression_repeat1] = STATE(4090),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1485),
    [anon_sym_ref] = ACTIONS(1487),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1221),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1491),
    [anon_sym_TILDE] = ACTIONS(1491),
    [anon_sym_PLUS_PLUS] = ACTIONS(1491),
    [anon_sym_DASH_DASH] = ACTIONS(1491),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1489),
    [anon_sym_DASH] = ACTIONS(1489),
    [anon_sym_STAR] = ACTIONS(1493),
    [anon_sym_CARET] = ACTIONS(1491),
    [anon_sym_AMP] = ACTIONS(1491),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1495),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1497),
    [anon_sym_DOT_DOT] = ACTIONS(1499),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [2185] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6904),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7009),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5268),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4008),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7381),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9536),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(2185),
    [sym_preproc_endregion] = STATE(2185),
    [sym_preproc_line] = STATE(2185),
    [sym_preproc_pragma] = STATE(2185),
    [sym_preproc_nullable] = STATE(2185),
    [sym_preproc_error] = STATE(2185),
    [sym_preproc_define] = STATE(2185),
    [sym_preproc_undef] = STATE(2185),
    [aux_sym_class_declaration_repeat1] = STATE(3832),
    [aux_sym_lambda_expression_repeat1] = STATE(4090),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1485),
    [anon_sym_ref] = ACTIONS(1487),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1221),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1491),
    [anon_sym_TILDE] = ACTIONS(1491),
    [anon_sym_PLUS_PLUS] = ACTIONS(1491),
    [anon_sym_DASH_DASH] = ACTIONS(1491),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1489),
    [anon_sym_DASH] = ACTIONS(1489),
    [anon_sym_STAR] = ACTIONS(1493),
    [anon_sym_CARET] = ACTIONS(1491),
    [anon_sym_AMP] = ACTIONS(1491),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1495),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1497),
    [anon_sym_DOT_DOT] = ACTIONS(1499),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [2186] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6904),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7009),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5267),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4008),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7381),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9536),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(2186),
    [sym_preproc_endregion] = STATE(2186),
    [sym_preproc_line] = STATE(2186),
    [sym_preproc_pragma] = STATE(2186),
    [sym_preproc_nullable] = STATE(2186),
    [sym_preproc_error] = STATE(2186),
    [sym_preproc_define] = STATE(2186),
    [sym_preproc_undef] = STATE(2186),
    [aux_sym_class_declaration_repeat1] = STATE(3832),
    [aux_sym_lambda_expression_repeat1] = STATE(4090),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1485),
    [anon_sym_ref] = ACTIONS(1487),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1221),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1491),
    [anon_sym_TILDE] = ACTIONS(1491),
    [anon_sym_PLUS_PLUS] = ACTIONS(1491),
    [anon_sym_DASH_DASH] = ACTIONS(1491),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1489),
    [anon_sym_DASH] = ACTIONS(1489),
    [anon_sym_STAR] = ACTIONS(1493),
    [anon_sym_CARET] = ACTIONS(1491),
    [anon_sym_AMP] = ACTIONS(1491),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1495),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1497),
    [anon_sym_DOT_DOT] = ACTIONS(1499),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [2187] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6904),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7009),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5264),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4008),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7381),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9536),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(2187),
    [sym_preproc_endregion] = STATE(2187),
    [sym_preproc_line] = STATE(2187),
    [sym_preproc_pragma] = STATE(2187),
    [sym_preproc_nullable] = STATE(2187),
    [sym_preproc_error] = STATE(2187),
    [sym_preproc_define] = STATE(2187),
    [sym_preproc_undef] = STATE(2187),
    [aux_sym_class_declaration_repeat1] = STATE(3832),
    [aux_sym_lambda_expression_repeat1] = STATE(4090),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1485),
    [anon_sym_ref] = ACTIONS(1487),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1221),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1491),
    [anon_sym_TILDE] = ACTIONS(1491),
    [anon_sym_PLUS_PLUS] = ACTIONS(1491),
    [anon_sym_DASH_DASH] = ACTIONS(1491),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1489),
    [anon_sym_DASH] = ACTIONS(1489),
    [anon_sym_STAR] = ACTIONS(1493),
    [anon_sym_CARET] = ACTIONS(1491),
    [anon_sym_AMP] = ACTIONS(1491),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1495),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1497),
    [anon_sym_DOT_DOT] = ACTIONS(1499),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [2188] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6904),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7009),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5263),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4008),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7381),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9536),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(2188),
    [sym_preproc_endregion] = STATE(2188),
    [sym_preproc_line] = STATE(2188),
    [sym_preproc_pragma] = STATE(2188),
    [sym_preproc_nullable] = STATE(2188),
    [sym_preproc_error] = STATE(2188),
    [sym_preproc_define] = STATE(2188),
    [sym_preproc_undef] = STATE(2188),
    [aux_sym_class_declaration_repeat1] = STATE(3832),
    [aux_sym_lambda_expression_repeat1] = STATE(4090),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1485),
    [anon_sym_ref] = ACTIONS(1487),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1221),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1491),
    [anon_sym_TILDE] = ACTIONS(1491),
    [anon_sym_PLUS_PLUS] = ACTIONS(1491),
    [anon_sym_DASH_DASH] = ACTIONS(1491),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1489),
    [anon_sym_DASH] = ACTIONS(1489),
    [anon_sym_STAR] = ACTIONS(1493),
    [anon_sym_CARET] = ACTIONS(1491),
    [anon_sym_AMP] = ACTIONS(1491),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1495),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1497),
    [anon_sym_DOT_DOT] = ACTIONS(1499),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [2189] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6904),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7009),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5260),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4008),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7381),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9536),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(2189),
    [sym_preproc_endregion] = STATE(2189),
    [sym_preproc_line] = STATE(2189),
    [sym_preproc_pragma] = STATE(2189),
    [sym_preproc_nullable] = STATE(2189),
    [sym_preproc_error] = STATE(2189),
    [sym_preproc_define] = STATE(2189),
    [sym_preproc_undef] = STATE(2189),
    [aux_sym_class_declaration_repeat1] = STATE(3832),
    [aux_sym_lambda_expression_repeat1] = STATE(4090),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1485),
    [anon_sym_ref] = ACTIONS(1487),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1221),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1491),
    [anon_sym_TILDE] = ACTIONS(1491),
    [anon_sym_PLUS_PLUS] = ACTIONS(1491),
    [anon_sym_DASH_DASH] = ACTIONS(1491),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1489),
    [anon_sym_DASH] = ACTIONS(1489),
    [anon_sym_STAR] = ACTIONS(1493),
    [anon_sym_CARET] = ACTIONS(1491),
    [anon_sym_AMP] = ACTIONS(1491),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1495),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1497),
    [anon_sym_DOT_DOT] = ACTIONS(1499),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [2190] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6904),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7009),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5259),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4008),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7381),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9536),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(2190),
    [sym_preproc_endregion] = STATE(2190),
    [sym_preproc_line] = STATE(2190),
    [sym_preproc_pragma] = STATE(2190),
    [sym_preproc_nullable] = STATE(2190),
    [sym_preproc_error] = STATE(2190),
    [sym_preproc_define] = STATE(2190),
    [sym_preproc_undef] = STATE(2190),
    [aux_sym_class_declaration_repeat1] = STATE(3832),
    [aux_sym_lambda_expression_repeat1] = STATE(4090),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1485),
    [anon_sym_ref] = ACTIONS(1487),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1221),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1491),
    [anon_sym_TILDE] = ACTIONS(1491),
    [anon_sym_PLUS_PLUS] = ACTIONS(1491),
    [anon_sym_DASH_DASH] = ACTIONS(1491),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1489),
    [anon_sym_DASH] = ACTIONS(1489),
    [anon_sym_STAR] = ACTIONS(1493),
    [anon_sym_CARET] = ACTIONS(1491),
    [anon_sym_AMP] = ACTIONS(1491),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1495),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1497),
    [anon_sym_DOT_DOT] = ACTIONS(1499),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [2191] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym_bracketed_argument_list] = STATE(3003),
    [sym__name] = STATE(6904),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(2755),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_type] = STATE(7009),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_expression] = STATE(5256),
    [sym_non_lvalue_expression] = STATE(3682),
    [sym_lvalue_expression] = STATE(4008),
    [sym__expression_statement_expression] = STATE(3673),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3673),
    [sym_postfix_unary_expression] = STATE(3675),
    [sym_prefix_unary_expression] = STATE(3675),
    [sym__pointer_indirection_expression] = STATE(3006),
    [sym_query_expression] = STATE(3673),
    [sym_from_clause] = STATE(7381),
    [sym_conditional_expression] = STATE(3673),
    [sym_conditional_access_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_is_expression] = STATE(3673),
    [sym_is_pattern_expression] = STATE(3673),
    [sym_cast_expression] = STATE(3673),
    [sym_checked_expression] = STATE(3673),
    [sym_invocation_expression] = STATE(3675),
    [sym_switch_expression] = STATE(3673),
    [sym_await_expression] = STATE(3675),
    [sym_throw_expression] = STATE(3673),
    [sym_element_access_expression] = STATE(3006),
    [sym_interpolated_string_expression] = STATE(3673),
    [sym_member_access_expression] = STATE(3006),
    [sym_object_creation_expression] = STATE(3675),
    [sym_parenthesized_expression] = STATE(3675),
    [sym__parenthesized_lvalue_expression] = STATE(3006),
    [sym_lambda_expression] = STATE(3673),
    [sym__lambda_parameters] = STATE(9536),
    [sym_array_creation_expression] = STATE(3673),
    [sym_anonymous_method_expression] = STATE(3673),
    [sym_anonymous_object_creation_expression] = STATE(3673),
    [sym_implicit_array_creation_expression] = STATE(3673),
    [sym_implicit_object_creation_expression] = STATE(3673),
    [sym_implicit_stackalloc_expression] = STATE(3673),
    [sym_initializer_expression] = STATE(3673),
    [sym_default_expression] = STATE(3673),
    [sym_with_expression] = STATE(3673),
    [sym_sizeof_expression] = STATE(3673),
    [sym_typeof_expression] = STATE(3673),
    [sym_makeref_expression] = STATE(3673),
    [sym_ref_expression] = STATE(3673),
    [sym_reftype_expression] = STATE(3673),
    [sym_refvalue_expression] = STATE(3673),
    [sym_stackalloc_expression] = STATE(3673),
    [sym_range_expression] = STATE(3673),
    [sym_tuple_expression] = STATE(3006),
    [sym_literal] = STATE(3673),
    [sym_character_literal] = STATE(3693),
    [sym_string_literal] = STATE(3693),
    [sym_boolean_literal] = STATE(3693),
    [sym_identifier] = STATE(2740),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_if_in_expression] = STATE(3673),
    [sym_preproc_region] = STATE(2191),
    [sym_preproc_endregion] = STATE(2191),
    [sym_preproc_line] = STATE(2191),
    [sym_preproc_pragma] = STATE(2191),
    [sym_preproc_nullable] = STATE(2191),
    [sym_preproc_error] = STATE(2191),
    [sym_preproc_define] = STATE(2191),
    [sym_preproc_undef] = STATE(2191),
    [aux_sym_class_declaration_repeat1] = STATE(3832),
    [aux_sym_lambda_expression_repeat1] = STATE(4090),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1485),
    [anon_sym_ref] = ACTIONS(1487),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_delegate] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1221),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1491),
    [anon_sym_TILDE] = ACTIONS(1491),
    [anon_sym_PLUS_PLUS] = ACTIONS(1491),
    [anon_sym_DASH_DASH] = ACTIONS(1491),
    [anon_sym_true] = ACTIONS(1229),
    [anon_sym_false] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1489),
    [anon_sym_DASH] = ACTIONS(1489),
    [anon_sym_STAR] = ACTIONS(1493),
    [anon_sym_CARET] = ACTIONS(1491),
    [anon_sym_AMP] = ACTIONS(1491),
    [anon_sym_this] = ACTIONS(1233),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_var] = ACTIONS(85),
    [sym_predefined_type] = ACTIONS(1235),
    [anon_sym_unchecked] = ACTIONS(1223),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1495),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1497),
    [anon_sym_DOT_DOT] = ACTIONS(1499),
    [anon_sym_from] = ACTIONS(121),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_stackalloc] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym___makeref] = ACTIONS(1253),
    [anon_sym___reftype] = ACTIONS(1255),
    [anon_sym___refvalue] = ACTIONS(1257),
    [sym_null_literal] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_integer_literal] = ACTIONS(1259),
    [sym_real_literal] = ACTIONS(1263),
    [sym_verbatim_string_literal] = ACTIONS(1263),
    [sym_raw_string_literal] = ACTIONS(1263),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1267),
    [sym_interpolation_verbatim_start] = ACTIONS(1269),
    [sym_interpolation_raw_start] = ACTIONS(1271),
  },
  [2192] = {
    [sym_preproc_region] = STATE(2192),
    [sym_preproc_endregion] = STATE(2192),
    [sym_preproc_line] = STATE(2192),
    [sym_preproc_pragma] = STATE(2192),
    [sym_preproc_nullable] = STATE(2192),
    [sym_preproc_error] = STATE(2192),
    [sym_preproc_define] = STATE(2192),
    [sym_preproc_undef] = STATE(2192),
    [sym__identifier_token] = ACTIONS(2921),
    [anon_sym_extern] = ACTIONS(2921),
    [anon_sym_alias] = ACTIONS(2921),
    [anon_sym_SEMI] = ACTIONS(2923),
    [anon_sym_global] = ACTIONS(2921),
    [anon_sym_using] = ACTIONS(2921),
    [anon_sym_unsafe] = ACTIONS(2921),
    [anon_sym_static] = ACTIONS(2921),
    [anon_sym_LBRACK] = ACTIONS(2923),
    [anon_sym_LPAREN] = ACTIONS(2923),
    [anon_sym_return] = ACTIONS(2921),
    [anon_sym_namespace] = ACTIONS(2921),
    [anon_sym_class] = ACTIONS(2921),
    [anon_sym_ref] = ACTIONS(2921),
    [anon_sym_struct] = ACTIONS(2921),
    [anon_sym_enum] = ACTIONS(2921),
    [anon_sym_LBRACE] = ACTIONS(2923),
    [anon_sym_interface] = ACTIONS(2921),
    [anon_sym_delegate] = ACTIONS(2921),
    [anon_sym_record] = ACTIONS(2921),
    [anon_sym_abstract] = ACTIONS(2921),
    [anon_sym_async] = ACTIONS(2921),
    [anon_sym_const] = ACTIONS(2921),
    [anon_sym_file] = ACTIONS(2921),
    [anon_sym_fixed] = ACTIONS(2921),
    [anon_sym_internal] = ACTIONS(2921),
    [anon_sym_new] = ACTIONS(2921),
    [anon_sym_override] = ACTIONS(2921),
    [anon_sym_partial] = ACTIONS(2921),
    [anon_sym_private] = ACTIONS(2921),
    [anon_sym_protected] = ACTIONS(2921),
    [anon_sym_public] = ACTIONS(2921),
    [anon_sym_readonly] = ACTIONS(2921),
    [anon_sym_required] = ACTIONS(2921),
    [anon_sym_sealed] = ACTIONS(2921),
    [anon_sym_virtual] = ACTIONS(2921),
    [anon_sym_volatile] = ACTIONS(2921),
    [anon_sym_LT] = ACTIONS(2925),
    [anon_sym_GT] = ACTIONS(2925),
    [anon_sym_where] = ACTIONS(2921),
    [anon_sym_QMARK] = ACTIONS(2925),
    [anon_sym_notnull] = ACTIONS(2921),
    [anon_sym_unmanaged] = ACTIONS(2921),
    [anon_sym_checked] = ACTIONS(2921),
    [anon_sym_BANG] = ACTIONS(2921),
    [anon_sym_TILDE] = ACTIONS(2923),
    [anon_sym_PLUS_PLUS] = ACTIONS(2923),
    [anon_sym_DASH_DASH] = ACTIONS(2923),
    [anon_sym_true] = ACTIONS(2921),
    [anon_sym_false] = ACTIONS(2921),
    [anon_sym_PLUS] = ACTIONS(2921),
    [anon_sym_DASH] = ACTIONS(2921),
    [anon_sym_STAR] = ACTIONS(2923),
    [anon_sym_SLASH] = ACTIONS(2925),
    [anon_sym_PERCENT] = ACTIONS(2927),
    [anon_sym_CARET] = ACTIONS(2923),
    [anon_sym_PIPE] = ACTIONS(2925),
    [anon_sym_AMP] = ACTIONS(2921),
    [anon_sym_LT_LT] = ACTIONS(2927),
    [anon_sym_GT_GT] = ACTIONS(2925),
    [anon_sym_GT_GT_GT] = ACTIONS(2927),
    [anon_sym_EQ_EQ] = ACTIONS(2927),
    [anon_sym_BANG_EQ] = ACTIONS(2927),
    [anon_sym_GT_EQ] = ACTIONS(2927),
    [anon_sym_LT_EQ] = ACTIONS(2927),
    [anon_sym_this] = ACTIONS(2921),
    [anon_sym_DOT] = ACTIONS(2925),
    [anon_sym_scoped] = ACTIONS(2921),
    [anon_sym_var] = ACTIONS(2921),
    [sym_predefined_type] = ACTIONS(2921),
    [anon_sym_break] = ACTIONS(2921),
    [anon_sym_unchecked] = ACTIONS(2921),
    [anon_sym_continue] = ACTIONS(2921),
    [anon_sym_do] = ACTIONS(2921),
    [anon_sym_while] = ACTIONS(2921),
    [anon_sym_for] = ACTIONS(2921),
    [anon_sym_lock] = ACTIONS(2921),
    [anon_sym_yield] = ACTIONS(2921),
    [anon_sym_switch] = ACTIONS(2921),
    [anon_sym_default] = ACTIONS(2921),
    [anon_sym_throw] = ACTIONS(2921),
    [anon_sym_try] = ACTIONS(2921),
    [anon_sym_when] = ACTIONS(2921),
    [anon_sym_await] = ACTIONS(2921),
    [anon_sym_foreach] = ACTIONS(2921),
    [anon_sym_goto] = ACTIONS(2921),
    [anon_sym_if] = ACTIONS(2921),
    [anon_sym_else] = ACTIONS(2921),
    [anon_sym_DOT_DOT] = ACTIONS(2923),
    [anon_sym_AMP_AMP] = ACTIONS(2927),
    [anon_sym_PIPE_PIPE] = ACTIONS(2927),
    [anon_sym_QMARK_QMARK] = ACTIONS(2927),
    [anon_sym_from] = ACTIONS(2921),
    [anon_sym_into] = ACTIONS(2921),
    [anon_sym_join] = ACTIONS(2921),
    [anon_sym_on] = ACTIONS(2921),
    [anon_sym_equals] = ACTIONS(2921),
    [anon_sym_let] = ACTIONS(2921),
    [anon_sym_orderby] = ACTIONS(2921),
    [anon_sym_ascending] = ACTIONS(2921),
    [anon_sym_descending] = ACTIONS(2921),
    [anon_sym_group] = ACTIONS(2921),
    [anon_sym_by] = ACTIONS(2921),
    [anon_sym_select] = ACTIONS(2921),
    [anon_sym_as] = ACTIONS(2925),
    [anon_sym_is] = ACTIONS(2925),
    [anon_sym_DQUOTE] = ACTIONS(2921),
    [anon_sym_DASH_GT] = ACTIONS(2927),
    [anon_sym_stackalloc] = ACTIONS(2921),
    [anon_sym_with] = ACTIONS(2925),
    [anon_sym_sizeof] = ACTIONS(2921),
    [anon_sym_typeof] = ACTIONS(2921),
    [anon_sym___makeref] = ACTIONS(2921),
    [anon_sym___reftype] = ACTIONS(2921),
    [anon_sym___refvalue] = ACTIONS(2921),
    [sym_null_literal] = ACTIONS(2921),
    [anon_sym_SQUOTE] = ACTIONS(2923),
    [sym_integer_literal] = ACTIONS(2921),
    [sym_real_literal] = ACTIONS(2923),
    [sym_verbatim_string_literal] = ACTIONS(2923),
    [sym_raw_string_literal] = ACTIONS(2923),
    [aux_sym_preproc_if_token1] = ACTIONS(2923),
    [aux_sym_preproc_if_token3] = ACTIONS(2923),
    [aux_sym_preproc_else_token1] = ACTIONS(2923),
    [aux_sym_preproc_elif_token1] = ACTIONS(2923),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(2923),
    [sym_interpolation_verbatim_start] = ACTIONS(2923),
    [sym_interpolation_raw_start] = ACTIONS(2923),
  },
  [2193] = {
    [sym_preproc_region] = STATE(2193),
    [sym_preproc_endregion] = STATE(2193),
    [sym_preproc_line] = STATE(2193),
    [sym_preproc_pragma] = STATE(2193),
    [sym_preproc_nullable] = STATE(2193),
    [sym_preproc_error] = STATE(2193),
    [sym_preproc_define] = STATE(2193),
    [sym_preproc_undef] = STATE(2193),
    [sym__identifier_token] = ACTIONS(2929),
    [anon_sym_extern] = ACTIONS(2929),
    [anon_sym_alias] = ACTIONS(2929),
    [anon_sym_SEMI] = ACTIONS(2931),
    [anon_sym_global] = ACTIONS(2929),
    [anon_sym_using] = ACTIONS(2929),
    [anon_sym_unsafe] = ACTIONS(2929),
    [anon_sym_static] = ACTIONS(2929),
    [anon_sym_LBRACK] = ACTIONS(2931),
    [anon_sym_LPAREN] = ACTIONS(2931),
    [anon_sym_return] = ACTIONS(2929),
    [anon_sym_namespace] = ACTIONS(2929),
    [anon_sym_class] = ACTIONS(2929),
    [anon_sym_ref] = ACTIONS(2929),
    [anon_sym_struct] = ACTIONS(2929),
    [anon_sym_enum] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [anon_sym_interface] = ACTIONS(2929),
    [anon_sym_delegate] = ACTIONS(2929),
    [anon_sym_record] = ACTIONS(2929),
    [anon_sym_abstract] = ACTIONS(2929),
    [anon_sym_async] = ACTIONS(2929),
    [anon_sym_const] = ACTIONS(2929),
    [anon_sym_file] = ACTIONS(2929),
    [anon_sym_fixed] = ACTIONS(2929),
    [anon_sym_internal] = ACTIONS(2929),
    [anon_sym_new] = ACTIONS(2929),
    [anon_sym_override] = ACTIONS(2929),
    [anon_sym_partial] = ACTIONS(2929),
    [anon_sym_private] = ACTIONS(2929),
    [anon_sym_protected] = ACTIONS(2929),
    [anon_sym_public] = ACTIONS(2929),
    [anon_sym_readonly] = ACTIONS(2929),
    [anon_sym_required] = ACTIONS(2929),
    [anon_sym_sealed] = ACTIONS(2929),
    [anon_sym_virtual] = ACTIONS(2929),
    [anon_sym_volatile] = ACTIONS(2929),
    [anon_sym_LT] = ACTIONS(2933),
    [anon_sym_GT] = ACTIONS(2933),
    [anon_sym_where] = ACTIONS(2929),
    [anon_sym_QMARK] = ACTIONS(2933),
    [anon_sym_notnull] = ACTIONS(2929),
    [anon_sym_unmanaged] = ACTIONS(2929),
    [anon_sym_checked] = ACTIONS(2929),
    [anon_sym_BANG] = ACTIONS(2929),
    [anon_sym_TILDE] = ACTIONS(2931),
    [anon_sym_PLUS_PLUS] = ACTIONS(2931),
    [anon_sym_DASH_DASH] = ACTIONS(2931),
    [anon_sym_true] = ACTIONS(2929),
    [anon_sym_false] = ACTIONS(2929),
    [anon_sym_PLUS] = ACTIONS(2929),
    [anon_sym_DASH] = ACTIONS(2929),
    [anon_sym_STAR] = ACTIONS(2931),
    [anon_sym_SLASH] = ACTIONS(2933),
    [anon_sym_PERCENT] = ACTIONS(2935),
    [anon_sym_CARET] = ACTIONS(2931),
    [anon_sym_PIPE] = ACTIONS(2933),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_LT_LT] = ACTIONS(2935),
    [anon_sym_GT_GT] = ACTIONS(2933),
    [anon_sym_GT_GT_GT] = ACTIONS(2935),
    [anon_sym_EQ_EQ] = ACTIONS(2935),
    [anon_sym_BANG_EQ] = ACTIONS(2935),
    [anon_sym_GT_EQ] = ACTIONS(2935),
    [anon_sym_LT_EQ] = ACTIONS(2935),
    [anon_sym_this] = ACTIONS(2929),
    [anon_sym_DOT] = ACTIONS(2933),
    [anon_sym_scoped] = ACTIONS(2929),
    [anon_sym_var] = ACTIONS(2929),
    [sym_predefined_type] = ACTIONS(2929),
    [anon_sym_break] = ACTIONS(2929),
    [anon_sym_unchecked] = ACTIONS(2929),
    [anon_sym_continue] = ACTIONS(2929),
    [anon_sym_do] = ACTIONS(2929),
    [anon_sym_while] = ACTIONS(2929),
    [anon_sym_for] = ACTIONS(2929),
    [anon_sym_lock] = ACTIONS(2929),
    [anon_sym_yield] = ACTIONS(2929),
    [anon_sym_switch] = ACTIONS(2929),
    [anon_sym_default] = ACTIONS(2929),
    [anon_sym_throw] = ACTIONS(2929),
    [anon_sym_try] = ACTIONS(2929),
    [anon_sym_when] = ACTIONS(2929),
    [anon_sym_await] = ACTIONS(2929),
    [anon_sym_foreach] = ACTIONS(2929),
    [anon_sym_goto] = ACTIONS(2929),
    [anon_sym_if] = ACTIONS(2929),
    [anon_sym_else] = ACTIONS(2929),
    [anon_sym_DOT_DOT] = ACTIONS(2931),
    [anon_sym_AMP_AMP] = ACTIONS(2935),
    [anon_sym_PIPE_PIPE] = ACTIONS(2935),
    [anon_sym_QMARK_QMARK] = ACTIONS(2935),
    [anon_sym_from] = ACTIONS(2929),
    [anon_sym_into] = ACTIONS(2929),
    [anon_sym_join] = ACTIONS(2929),
    [anon_sym_on] = ACTIONS(2929),
    [anon_sym_equals] = ACTIONS(2929),
    [anon_sym_let] = ACTIONS(2929),
    [anon_sym_orderby] = ACTIONS(2929),
    [anon_sym_ascending] = ACTIONS(2929),
    [anon_sym_descending] = ACTIONS(2929),
    [anon_sym_group] = ACTIONS(2929),
    [anon_sym_by] = ACTIONS(2929),
    [anon_sym_select] = ACTIONS(2929),
    [anon_sym_as] = ACTIONS(2933),
    [anon_sym_is] = ACTIONS(2933),
    [anon_sym_DQUOTE] = ACTIONS(2929),
    [anon_sym_DASH_GT] = ACTIONS(2935),
    [anon_sym_stackalloc] = ACTIONS(2929),
    [anon_sym_with] = ACTIONS(2933),
    [anon_sym_sizeof] = ACTIONS(2929),
    [anon_sym_typeof] = ACTIONS(2929),
    [anon_sym___makeref] = ACTIONS(2929),
    [anon_sym___reftype] = ACTIONS(2929),
    [anon_sym___refvalue] = ACTIONS(2929),
    [sym_null_literal] = ACTIONS(2929),
    [anon_sym_SQUOTE] = ACTIONS(2931),
    [sym_integer_literal] = ACTIONS(2929),
    [sym_real_literal] = ACTIONS(2931),
    [sym_verbatim_string_literal] = ACTIONS(2931),
    [sym_raw_string_literal] = ACTIONS(2931),
    [aux_sym_preproc_if_token1] = ACTIONS(2931),
    [aux_sym_preproc_if_token3] = ACTIONS(2931),
    [aux_sym_preproc_else_token1] = ACTIONS(2931),
    [aux_sym_preproc_elif_token1] = ACTIONS(2931),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(2931),
    [sym_interpolation_verbatim_start] = ACTIONS(2931),
    [sym_interpolation_raw_start] = ACTIONS(2931),
  },
  [2194] = {
    [sym_preproc_region] = STATE(2194),
    [sym_preproc_endregion] = STATE(2194),
    [sym_preproc_line] = STATE(2194),
    [sym_preproc_pragma] = STATE(2194),
    [sym_preproc_nullable] = STATE(2194),
    [sym_preproc_error] = STATE(2194),
    [sym_preproc_define] = STATE(2194),
    [sym_preproc_undef] = STATE(2194),
    [ts_builtin_sym_end] = ACTIONS(2931),
    [sym__identifier_token] = ACTIONS(2929),
    [anon_sym_extern] = ACTIONS(2929),
    [anon_sym_alias] = ACTIONS(2929),
    [anon_sym_SEMI] = ACTIONS(2931),
    [anon_sym_global] = ACTIONS(2929),
    [anon_sym_using] = ACTIONS(2929),
    [anon_sym_unsafe] = ACTIONS(2929),
    [anon_sym_static] = ACTIONS(2929),
    [anon_sym_LBRACK] = ACTIONS(2931),
    [anon_sym_LPAREN] = ACTIONS(2931),
    [anon_sym_return] = ACTIONS(2929),
    [anon_sym_namespace] = ACTIONS(2929),
    [anon_sym_class] = ACTIONS(2929),
    [anon_sym_ref] = ACTIONS(2929),
    [anon_sym_struct] = ACTIONS(2929),
    [anon_sym_enum] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [anon_sym_interface] = ACTIONS(2929),
    [anon_sym_delegate] = ACTIONS(2929),
    [anon_sym_record] = ACTIONS(2929),
    [anon_sym_abstract] = ACTIONS(2929),
    [anon_sym_async] = ACTIONS(2929),
    [anon_sym_const] = ACTIONS(2929),
    [anon_sym_file] = ACTIONS(2929),
    [anon_sym_fixed] = ACTIONS(2929),
    [anon_sym_internal] = ACTIONS(2929),
    [anon_sym_new] = ACTIONS(2929),
    [anon_sym_override] = ACTIONS(2929),
    [anon_sym_partial] = ACTIONS(2929),
    [anon_sym_private] = ACTIONS(2929),
    [anon_sym_protected] = ACTIONS(2929),
    [anon_sym_public] = ACTIONS(2929),
    [anon_sym_readonly] = ACTIONS(2929),
    [anon_sym_required] = ACTIONS(2929),
    [anon_sym_sealed] = ACTIONS(2929),
    [anon_sym_virtual] = ACTIONS(2929),
    [anon_sym_volatile] = ACTIONS(2929),
    [anon_sym_LT] = ACTIONS(2933),
    [anon_sym_GT] = ACTIONS(2933),
    [anon_sym_where] = ACTIONS(2929),
    [anon_sym_QMARK] = ACTIONS(2933),
    [anon_sym_notnull] = ACTIONS(2929),
    [anon_sym_unmanaged] = ACTIONS(2929),
    [anon_sym_checked] = ACTIONS(2929),
    [anon_sym_BANG] = ACTIONS(2929),
    [anon_sym_TILDE] = ACTIONS(2931),
    [anon_sym_PLUS_PLUS] = ACTIONS(2931),
    [anon_sym_DASH_DASH] = ACTIONS(2931),
    [anon_sym_true] = ACTIONS(2929),
    [anon_sym_false] = ACTIONS(2929),
    [anon_sym_PLUS] = ACTIONS(2929),
    [anon_sym_DASH] = ACTIONS(2929),
    [anon_sym_STAR] = ACTIONS(2931),
    [anon_sym_SLASH] = ACTIONS(2933),
    [anon_sym_PERCENT] = ACTIONS(2935),
    [anon_sym_CARET] = ACTIONS(2931),
    [anon_sym_PIPE] = ACTIONS(2933),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_LT_LT] = ACTIONS(2935),
    [anon_sym_GT_GT] = ACTIONS(2933),
    [anon_sym_GT_GT_GT] = ACTIONS(2935),
    [anon_sym_EQ_EQ] = ACTIONS(2935),
    [anon_sym_BANG_EQ] = ACTIONS(2935),
    [anon_sym_GT_EQ] = ACTIONS(2935),
    [anon_sym_LT_EQ] = ACTIONS(2935),
    [anon_sym_this] = ACTIONS(2929),
    [anon_sym_DOT] = ACTIONS(2933),
    [anon_sym_scoped] = ACTIONS(2929),
    [anon_sym_var] = ACTIONS(2929),
    [sym_predefined_type] = ACTIONS(2929),
    [anon_sym_break] = ACTIONS(2929),
    [anon_sym_unchecked] = ACTIONS(2929),
    [anon_sym_continue] = ACTIONS(2929),
    [anon_sym_do] = ACTIONS(2929),
    [anon_sym_while] = ACTIONS(2929),
    [anon_sym_for] = ACTIONS(2929),
    [anon_sym_lock] = ACTIONS(2929),
    [anon_sym_yield] = ACTIONS(2929),
    [anon_sym_switch] = ACTIONS(2929),
    [anon_sym_default] = ACTIONS(2929),
    [anon_sym_throw] = ACTIONS(2929),
    [anon_sym_try] = ACTIONS(2929),
    [anon_sym_when] = ACTIONS(2929),
    [anon_sym_await] = ACTIONS(2929),
    [anon_sym_foreach] = ACTIONS(2929),
    [anon_sym_goto] = ACTIONS(2929),
    [anon_sym_if] = ACTIONS(2929),
    [anon_sym_else] = ACTIONS(2929),
    [anon_sym_DOT_DOT] = ACTIONS(2931),
    [anon_sym_AMP_AMP] = ACTIONS(2935),
    [anon_sym_PIPE_PIPE] = ACTIONS(2935),
    [anon_sym_QMARK_QMARK] = ACTIONS(2935),
    [anon_sym_from] = ACTIONS(2929),
    [anon_sym_into] = ACTIONS(2929),
    [anon_sym_join] = ACTIONS(2929),
    [anon_sym_on] = ACTIONS(2929),
    [anon_sym_equals] = ACTIONS(2929),
    [anon_sym_let] = ACTIONS(2929),
    [anon_sym_orderby] = ACTIONS(2929),
    [anon_sym_ascending] = ACTIONS(2929),
    [anon_sym_descending] = ACTIONS(2929),
    [anon_sym_group] = ACTIONS(2929),
    [anon_sym_by] = ACTIONS(2929),
    [anon_sym_select] = ACTIONS(2929),
    [anon_sym_as] = ACTIONS(2933),
    [anon_sym_is] = ACTIONS(2933),
    [anon_sym_DQUOTE] = ACTIONS(2929),
    [anon_sym_DASH_GT] = ACTIONS(2935),
    [anon_sym_stackalloc] = ACTIONS(2929),
    [anon_sym_with] = ACTIONS(2933),
    [anon_sym_sizeof] = ACTIONS(2929),
    [anon_sym_typeof] = ACTIONS(2929),
    [anon_sym___makeref] = ACTIONS(2929),
    [anon_sym___reftype] = ACTIONS(2929),
    [anon_sym___refvalue] = ACTIONS(2929),
    [sym_null_literal] = ACTIONS(2929),
    [anon_sym_SQUOTE] = ACTIONS(2931),
    [sym_integer_literal] = ACTIONS(2929),
    [sym_real_literal] = ACTIONS(2931),
    [sym_verbatim_string_literal] = ACTIONS(2931),
    [sym_raw_string_literal] = ACTIONS(2931),
    [aux_sym_preproc_if_token1] = ACTIONS(2931),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(2931),
    [sym_interpolation_verbatim_start] = ACTIONS(2931),
    [sym_interpolation_raw_start] = ACTIONS(2931),
  },
  [2195] = {
    [sym_preproc_region] = STATE(2195),
    [sym_preproc_endregion] = STATE(2195),
    [sym_preproc_line] = STATE(2195),
    [sym_preproc_pragma] = STATE(2195),
    [sym_preproc_nullable] = STATE(2195),
    [sym_preproc_error] = STATE(2195),
    [sym_preproc_define] = STATE(2195),
    [sym_preproc_undef] = STATE(2195),
    [ts_builtin_sym_end] = ACTIONS(2923),
    [sym__identifier_token] = ACTIONS(2921),
    [anon_sym_extern] = ACTIONS(2921),
    [anon_sym_alias] = ACTIONS(2921),
    [anon_sym_SEMI] = ACTIONS(2923),
    [anon_sym_global] = ACTIONS(2921),
    [anon_sym_using] = ACTIONS(2921),
    [anon_sym_unsafe] = ACTIONS(2921),
    [anon_sym_static] = ACTIONS(2921),
    [anon_sym_LBRACK] = ACTIONS(2923),
    [anon_sym_LPAREN] = ACTIONS(2923),
    [anon_sym_return] = ACTIONS(2921),
    [anon_sym_namespace] = ACTIONS(2921),
    [anon_sym_class] = ACTIONS(2921),
    [anon_sym_ref] = ACTIONS(2921),
    [anon_sym_struct] = ACTIONS(2921),
    [anon_sym_enum] = ACTIONS(2921),
    [anon_sym_LBRACE] = ACTIONS(2923),
    [anon_sym_interface] = ACTIONS(2921),
    [anon_sym_delegate] = ACTIONS(2921),
    [anon_sym_record] = ACTIONS(2921),
    [anon_sym_abstract] = ACTIONS(2921),
    [anon_sym_async] = ACTIONS(2921),
    [anon_sym_const] = ACTIONS(2921),
    [anon_sym_file] = ACTIONS(2921),
    [anon_sym_fixed] = ACTIONS(2921),
    [anon_sym_internal] = ACTIONS(2921),
    [anon_sym_new] = ACTIONS(2921),
    [anon_sym_override] = ACTIONS(2921),
    [anon_sym_partial] = ACTIONS(2921),
    [anon_sym_private] = ACTIONS(2921),
    [anon_sym_protected] = ACTIONS(2921),
    [anon_sym_public] = ACTIONS(2921),
    [anon_sym_readonly] = ACTIONS(2921),
    [anon_sym_required] = ACTIONS(2921),
    [anon_sym_sealed] = ACTIONS(2921),
    [anon_sym_virtual] = ACTIONS(2921),
    [anon_sym_volatile] = ACTIONS(2921),
    [anon_sym_LT] = ACTIONS(2925),
    [anon_sym_GT] = ACTIONS(2925),
    [anon_sym_where] = ACTIONS(2921),
    [anon_sym_QMARK] = ACTIONS(2925),
    [anon_sym_notnull] = ACTIONS(2921),
    [anon_sym_unmanaged] = ACTIONS(2921),
    [anon_sym_checked] = ACTIONS(2921),
    [anon_sym_BANG] = ACTIONS(2921),
    [anon_sym_TILDE] = ACTIONS(2923),
    [anon_sym_PLUS_PLUS] = ACTIONS(2923),
    [anon_sym_DASH_DASH] = ACTIONS(2923),
    [anon_sym_true] = ACTIONS(2921),
    [anon_sym_false] = ACTIONS(2921),
    [anon_sym_PLUS] = ACTIONS(2921),
    [anon_sym_DASH] = ACTIONS(2921),
    [anon_sym_STAR] = ACTIONS(2923),
    [anon_sym_SLASH] = ACTIONS(2925),
    [anon_sym_PERCENT] = ACTIONS(2927),
    [anon_sym_CARET] = ACTIONS(2923),
    [anon_sym_PIPE] = ACTIONS(2925),
    [anon_sym_AMP] = ACTIONS(2921),
    [anon_sym_LT_LT] = ACTIONS(2927),
    [anon_sym_GT_GT] = ACTIONS(2925),
    [anon_sym_GT_GT_GT] = ACTIONS(2927),
    [anon_sym_EQ_EQ] = ACTIONS(2927),
    [anon_sym_BANG_EQ] = ACTIONS(2927),
    [anon_sym_GT_EQ] = ACTIONS(2927),
    [anon_sym_LT_EQ] = ACTIONS(2927),
    [anon_sym_this] = ACTIONS(2921),
    [anon_sym_DOT] = ACTIONS(2925),
    [anon_sym_scoped] = ACTIONS(2921),
    [anon_sym_var] = ACTIONS(2921),
    [sym_predefined_type] = ACTIONS(2921),
    [anon_sym_break] = ACTIONS(2921),
    [anon_sym_unchecked] = ACTIONS(2921),
    [anon_sym_continue] = ACTIONS(2921),
    [anon_sym_do] = ACTIONS(2921),
    [anon_sym_while] = ACTIONS(2921),
    [anon_sym_for] = ACTIONS(2921),
    [anon_sym_lock] = ACTIONS(2921),
    [anon_sym_yield] = ACTIONS(2921),
    [anon_sym_switch] = ACTIONS(2921),
    [anon_sym_default] = ACTIONS(2921),
    [anon_sym_throw] = ACTIONS(2921),
    [anon_sym_try] = ACTIONS(2921),
    [anon_sym_when] = ACTIONS(2921),
    [anon_sym_await] = ACTIONS(2921),
    [anon_sym_foreach] = ACTIONS(2921),
    [anon_sym_goto] = ACTIONS(2921),
    [anon_sym_if] = ACTIONS(2921),
    [anon_sym_else] = ACTIONS(2921),
    [anon_sym_DOT_DOT] = ACTIONS(2923),
    [anon_sym_AMP_AMP] = ACTIONS(2927),
    [anon_sym_PIPE_PIPE] = ACTIONS(2927),
    [anon_sym_QMARK_QMARK] = ACTIONS(2927),
    [anon_sym_from] = ACTIONS(2921),
    [anon_sym_into] = ACTIONS(2921),
    [anon_sym_join] = ACTIONS(2921),
    [anon_sym_on] = ACTIONS(2921),
    [anon_sym_equals] = ACTIONS(2921),
    [anon_sym_let] = ACTIONS(2921),
    [anon_sym_orderby] = ACTIONS(2921),
    [anon_sym_ascending] = ACTIONS(2921),
    [anon_sym_descending] = ACTIONS(2921),
    [anon_sym_group] = ACTIONS(2921),
    [anon_sym_by] = ACTIONS(2921),
    [anon_sym_select] = ACTIONS(2921),
    [anon_sym_as] = ACTIONS(2925),
    [anon_sym_is] = ACTIONS(2925),
    [anon_sym_DQUOTE] = ACTIONS(2921),
    [anon_sym_DASH_GT] = ACTIONS(2927),
    [anon_sym_stackalloc] = ACTIONS(2921),
    [anon_sym_with] = ACTIONS(2925),
    [anon_sym_sizeof] = ACTIONS(2921),
    [anon_sym_typeof] = ACTIONS(2921),
    [anon_sym___makeref] = ACTIONS(2921),
    [anon_sym___reftype] = ACTIONS(2921),
    [anon_sym___refvalue] = ACTIONS(2921),
    [sym_null_literal] = ACTIONS(2921),
    [anon_sym_SQUOTE] = ACTIONS(2923),
    [sym_integer_literal] = ACTIONS(2921),
    [sym_real_literal] = ACTIONS(2923),
    [sym_verbatim_string_literal] = ACTIONS(2923),
    [sym_raw_string_literal] = ACTIONS(2923),
    [aux_sym_preproc_if_token1] = ACTIONS(2923),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(2923),
    [sym_interpolation_verbatim_start] = ACTIONS(2923),
    [sym_interpolation_raw_start] = ACTIONS(2923),
  },
  [2196] = {
    [sym_preproc_region] = STATE(2196),
    [sym_preproc_endregion] = STATE(2196),
    [sym_preproc_line] = STATE(2196),
    [sym_preproc_pragma] = STATE(2196),
    [sym_preproc_nullable] = STATE(2196),
    [sym_preproc_error] = STATE(2196),
    [sym_preproc_define] = STATE(2196),
    [sym_preproc_undef] = STATE(2196),
    [sym__identifier_token] = ACTIONS(2929),
    [anon_sym_extern] = ACTIONS(2929),
    [anon_sym_alias] = ACTIONS(2929),
    [anon_sym_SEMI] = ACTIONS(2931),
    [anon_sym_global] = ACTIONS(2929),
    [anon_sym_using] = ACTIONS(2929),
    [anon_sym_unsafe] = ACTIONS(2929),
    [anon_sym_static] = ACTIONS(2929),
    [anon_sym_LBRACK] = ACTIONS(2931),
    [anon_sym_COMMA] = ACTIONS(2935),
    [anon_sym_LPAREN] = ACTIONS(2931),
    [anon_sym_return] = ACTIONS(2929),
    [anon_sym_ref] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [anon_sym_RBRACE] = ACTIONS(2931),
    [anon_sym_delegate] = ACTIONS(2929),
    [anon_sym_abstract] = ACTIONS(2929),
    [anon_sym_async] = ACTIONS(2929),
    [anon_sym_const] = ACTIONS(2929),
    [anon_sym_file] = ACTIONS(2929),
    [anon_sym_fixed] = ACTIONS(2929),
    [anon_sym_internal] = ACTIONS(2929),
    [anon_sym_new] = ACTIONS(2929),
    [anon_sym_override] = ACTIONS(2929),
    [anon_sym_partial] = ACTIONS(2929),
    [anon_sym_private] = ACTIONS(2929),
    [anon_sym_protected] = ACTIONS(2929),
    [anon_sym_public] = ACTIONS(2929),
    [anon_sym_readonly] = ACTIONS(2929),
    [anon_sym_required] = ACTIONS(2929),
    [anon_sym_sealed] = ACTIONS(2929),
    [anon_sym_virtual] = ACTIONS(2929),
    [anon_sym_volatile] = ACTIONS(2929),
    [anon_sym_LT] = ACTIONS(2933),
    [anon_sym_GT] = ACTIONS(2933),
    [anon_sym_where] = ACTIONS(2929),
    [anon_sym_QMARK] = ACTIONS(2933),
    [anon_sym_notnull] = ACTIONS(2929),
    [anon_sym_unmanaged] = ACTIONS(2929),
    [anon_sym_checked] = ACTIONS(2929),
    [anon_sym_BANG] = ACTIONS(2929),
    [anon_sym_TILDE] = ACTIONS(2931),
    [anon_sym_PLUS_PLUS] = ACTIONS(2931),
    [anon_sym_DASH_DASH] = ACTIONS(2931),
    [anon_sym_true] = ACTIONS(2929),
    [anon_sym_false] = ACTIONS(2929),
    [anon_sym_PLUS] = ACTIONS(2929),
    [anon_sym_DASH] = ACTIONS(2929),
    [anon_sym_STAR] = ACTIONS(2931),
    [anon_sym_SLASH] = ACTIONS(2933),
    [anon_sym_PERCENT] = ACTIONS(2935),
    [anon_sym_CARET] = ACTIONS(2931),
    [anon_sym_PIPE] = ACTIONS(2933),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_LT_LT] = ACTIONS(2935),
    [anon_sym_GT_GT] = ACTIONS(2933),
    [anon_sym_GT_GT_GT] = ACTIONS(2935),
    [anon_sym_EQ_EQ] = ACTIONS(2935),
    [anon_sym_BANG_EQ] = ACTIONS(2935),
    [anon_sym_GT_EQ] = ACTIONS(2935),
    [anon_sym_LT_EQ] = ACTIONS(2935),
    [anon_sym_this] = ACTIONS(2929),
    [anon_sym_DOT] = ACTIONS(2933),
    [anon_sym_scoped] = ACTIONS(2929),
    [anon_sym_var] = ACTIONS(2929),
    [sym_predefined_type] = ACTIONS(2929),
    [anon_sym_break] = ACTIONS(2929),
    [anon_sym_unchecked] = ACTIONS(2929),
    [anon_sym_continue] = ACTIONS(2929),
    [anon_sym_do] = ACTIONS(2929),
    [anon_sym_while] = ACTIONS(2929),
    [anon_sym_for] = ACTIONS(2929),
    [anon_sym_lock] = ACTIONS(2929),
    [anon_sym_yield] = ACTIONS(2929),
    [anon_sym_switch] = ACTIONS(2929),
    [anon_sym_case] = ACTIONS(2929),
    [anon_sym_default] = ACTIONS(2929),
    [anon_sym_throw] = ACTIONS(2929),
    [anon_sym_try] = ACTIONS(2929),
    [anon_sym_when] = ACTIONS(2929),
    [anon_sym_await] = ACTIONS(2929),
    [anon_sym_foreach] = ACTIONS(2929),
    [anon_sym_goto] = ACTIONS(2929),
    [anon_sym_if] = ACTIONS(2929),
    [anon_sym_else] = ACTIONS(2929),
    [anon_sym_DOT_DOT] = ACTIONS(2931),
    [anon_sym_AMP_AMP] = ACTIONS(2935),
    [anon_sym_PIPE_PIPE] = ACTIONS(2935),
    [anon_sym_QMARK_QMARK] = ACTIONS(2935),
    [anon_sym_from] = ACTIONS(2929),
    [anon_sym_into] = ACTIONS(2929),
    [anon_sym_join] = ACTIONS(2929),
    [anon_sym_on] = ACTIONS(2929),
    [anon_sym_equals] = ACTIONS(2929),
    [anon_sym_let] = ACTIONS(2929),
    [anon_sym_orderby] = ACTIONS(2929),
    [anon_sym_ascending] = ACTIONS(2929),
    [anon_sym_descending] = ACTIONS(2929),
    [anon_sym_group] = ACTIONS(2929),
    [anon_sym_by] = ACTIONS(2929),
    [anon_sym_select] = ACTIONS(2929),
    [anon_sym_as] = ACTIONS(2933),
    [anon_sym_is] = ACTIONS(2933),
    [anon_sym_DQUOTE] = ACTIONS(2929),
    [anon_sym_DASH_GT] = ACTIONS(2935),
    [anon_sym_stackalloc] = ACTIONS(2929),
    [anon_sym_with] = ACTIONS(2933),
    [anon_sym_sizeof] = ACTIONS(2929),
    [anon_sym_typeof] = ACTIONS(2929),
    [anon_sym___makeref] = ACTIONS(2929),
    [anon_sym___reftype] = ACTIONS(2929),
    [anon_sym___refvalue] = ACTIONS(2929),
    [sym_null_literal] = ACTIONS(2929),
    [anon_sym_SQUOTE] = ACTIONS(2931),
    [sym_integer_literal] = ACTIONS(2929),
    [sym_real_literal] = ACTIONS(2931),
    [sym_verbatim_string_literal] = ACTIONS(2931),
    [sym_raw_string_literal] = ACTIONS(2931),
    [aux_sym_preproc_if_token1] = ACTIONS(2931),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(2931),
    [sym_interpolation_verbatim_start] = ACTIONS(2931),
    [sym_interpolation_raw_start] = ACTIONS(2931),
  },
  [2197] = {
    [sym_preproc_region] = STATE(2197),
    [sym_preproc_endregion] = STATE(2197),
    [sym_preproc_line] = STATE(2197),
    [sym_preproc_pragma] = STATE(2197),
    [sym_preproc_nullable] = STATE(2197),
    [sym_preproc_error] = STATE(2197),
    [sym_preproc_define] = STATE(2197),
    [sym_preproc_undef] = STATE(2197),
    [sym__identifier_token] = ACTIONS(2921),
    [anon_sym_extern] = ACTIONS(2921),
    [anon_sym_alias] = ACTIONS(2921),
    [anon_sym_SEMI] = ACTIONS(2923),
    [anon_sym_global] = ACTIONS(2921),
    [anon_sym_using] = ACTIONS(2921),
    [anon_sym_unsafe] = ACTIONS(2921),
    [anon_sym_static] = ACTIONS(2921),
    [anon_sym_LBRACK] = ACTIONS(2923),
    [anon_sym_COMMA] = ACTIONS(2927),
    [anon_sym_LPAREN] = ACTIONS(2923),
    [anon_sym_return] = ACTIONS(2921),
    [anon_sym_ref] = ACTIONS(2921),
    [anon_sym_LBRACE] = ACTIONS(2923),
    [anon_sym_RBRACE] = ACTIONS(2923),
    [anon_sym_delegate] = ACTIONS(2921),
    [anon_sym_abstract] = ACTIONS(2921),
    [anon_sym_async] = ACTIONS(2921),
    [anon_sym_const] = ACTIONS(2921),
    [anon_sym_file] = ACTIONS(2921),
    [anon_sym_fixed] = ACTIONS(2921),
    [anon_sym_internal] = ACTIONS(2921),
    [anon_sym_new] = ACTIONS(2921),
    [anon_sym_override] = ACTIONS(2921),
    [anon_sym_partial] = ACTIONS(2921),
    [anon_sym_private] = ACTIONS(2921),
    [anon_sym_protected] = ACTIONS(2921),
    [anon_sym_public] = ACTIONS(2921),
    [anon_sym_readonly] = ACTIONS(2921),
    [anon_sym_required] = ACTIONS(2921),
    [anon_sym_sealed] = ACTIONS(2921),
    [anon_sym_virtual] = ACTIONS(2921),
    [anon_sym_volatile] = ACTIONS(2921),
    [anon_sym_LT] = ACTIONS(2925),
    [anon_sym_GT] = ACTIONS(2925),
    [anon_sym_where] = ACTIONS(2921),
    [anon_sym_QMARK] = ACTIONS(2925),
    [anon_sym_notnull] = ACTIONS(2921),
    [anon_sym_unmanaged] = ACTIONS(2921),
    [anon_sym_checked] = ACTIONS(2921),
    [anon_sym_BANG] = ACTIONS(2921),
    [anon_sym_TILDE] = ACTIONS(2923),
    [anon_sym_PLUS_PLUS] = ACTIONS(2923),
    [anon_sym_DASH_DASH] = ACTIONS(2923),
    [anon_sym_true] = ACTIONS(2921),
    [anon_sym_false] = ACTIONS(2921),
    [anon_sym_PLUS] = ACTIONS(2921),
    [anon_sym_DASH] = ACTIONS(2921),
    [anon_sym_STAR] = ACTIONS(2923),
    [anon_sym_SLASH] = ACTIONS(2925),
    [anon_sym_PERCENT] = ACTIONS(2927),
    [anon_sym_CARET] = ACTIONS(2923),
    [anon_sym_PIPE] = ACTIONS(2925),
    [anon_sym_AMP] = ACTIONS(2921),
    [anon_sym_LT_LT] = ACTIONS(2927),
    [anon_sym_GT_GT] = ACTIONS(2925),
    [anon_sym_GT_GT_GT] = ACTIONS(2927),
    [anon_sym_EQ_EQ] = ACTIONS(2927),
    [anon_sym_BANG_EQ] = ACTIONS(2927),
    [anon_sym_GT_EQ] = ACTIONS(2927),
    [anon_sym_LT_EQ] = ACTIONS(2927),
    [anon_sym_this] = ACTIONS(2921),
    [anon_sym_DOT] = ACTIONS(2925),
    [anon_sym_scoped] = ACTIONS(2921),
    [anon_sym_var] = ACTIONS(2921),
    [sym_predefined_type] = ACTIONS(2921),
    [anon_sym_break] = ACTIONS(2921),
    [anon_sym_unchecked] = ACTIONS(2921),
    [anon_sym_continue] = ACTIONS(2921),
    [anon_sym_do] = ACTIONS(2921),
    [anon_sym_while] = ACTIONS(2921),
    [anon_sym_for] = ACTIONS(2921),
    [anon_sym_lock] = ACTIONS(2921),
    [anon_sym_yield] = ACTIONS(2921),
    [anon_sym_switch] = ACTIONS(2921),
    [anon_sym_case] = ACTIONS(2921),
    [anon_sym_default] = ACTIONS(2921),
    [anon_sym_throw] = ACTIONS(2921),
    [anon_sym_try] = ACTIONS(2921),
    [anon_sym_when] = ACTIONS(2921),
    [anon_sym_await] = ACTIONS(2921),
    [anon_sym_foreach] = ACTIONS(2921),
    [anon_sym_goto] = ACTIONS(2921),
    [anon_sym_if] = ACTIONS(2921),
    [anon_sym_else] = ACTIONS(2921),
    [anon_sym_DOT_DOT] = ACTIONS(2923),
    [anon_sym_AMP_AMP] = ACTIONS(2927),
    [anon_sym_PIPE_PIPE] = ACTIONS(2927),
    [anon_sym_QMARK_QMARK] = ACTIONS(2927),
    [anon_sym_from] = ACTIONS(2921),
    [anon_sym_into] = ACTIONS(2921),
    [anon_sym_join] = ACTIONS(2921),
    [anon_sym_on] = ACTIONS(2921),
    [anon_sym_equals] = ACTIONS(2921),
    [anon_sym_let] = ACTIONS(2921),
    [anon_sym_orderby] = ACTIONS(2921),
    [anon_sym_ascending] = ACTIONS(2921),
    [anon_sym_descending] = ACTIONS(2921),
    [anon_sym_group] = ACTIONS(2921),
    [anon_sym_by] = ACTIONS(2921),
    [anon_sym_select] = ACTIONS(2921),
    [anon_sym_as] = ACTIONS(2925),
    [anon_sym_is] = ACTIONS(2925),
    [anon_sym_DQUOTE] = ACTIONS(2921),
    [anon_sym_DASH_GT] = ACTIONS(2927),
    [anon_sym_stackalloc] = ACTIONS(2921),
    [anon_sym_with] = ACTIONS(2925),
    [anon_sym_sizeof] = ACTIONS(2921),
    [anon_sym_typeof] = ACTIONS(2921),
    [anon_sym___makeref] = ACTIONS(2921),
    [anon_sym___reftype] = ACTIONS(2921),
    [anon_sym___refvalue] = ACTIONS(2921),
    [sym_null_literal] = ACTIONS(2921),
    [anon_sym_SQUOTE] = ACTIONS(2923),
    [sym_integer_literal] = ACTIONS(2921),
    [sym_real_literal] = ACTIONS(2923),
    [sym_verbatim_string_literal] = ACTIONS(2923),
    [sym_raw_string_literal] = ACTIONS(2923),
    [aux_sym_preproc_if_token1] = ACTIONS(2923),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(2923),
    [sym_interpolation_verbatim_start] = ACTIONS(2923),
    [sym_interpolation_raw_start] = ACTIONS(2923),
  },
  [2198] = {
    [sym_catch_clause] = STATE(2208),
    [sym_finally_clause] = STATE(2238),
    [sym_preproc_region] = STATE(2198),
    [sym_preproc_endregion] = STATE(2198),
    [sym_preproc_line] = STATE(2198),
    [sym_preproc_pragma] = STATE(2198),
    [sym_preproc_nullable] = STATE(2198),
    [sym_preproc_error] = STATE(2198),
    [sym_preproc_define] = STATE(2198),
    [sym_preproc_undef] = STATE(2198),
    [aux_sym_try_statement_repeat1] = STATE(2200),
    [sym__identifier_token] = ACTIONS(2937),
    [anon_sym_extern] = ACTIONS(2937),
    [anon_sym_alias] = ACTIONS(2937),
    [anon_sym_SEMI] = ACTIONS(2939),
    [anon_sym_global] = ACTIONS(2937),
    [anon_sym_using] = ACTIONS(2937),
    [anon_sym_unsafe] = ACTIONS(2937),
    [anon_sym_static] = ACTIONS(2937),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_LPAREN] = ACTIONS(2939),
    [anon_sym_return] = ACTIONS(2937),
    [anon_sym_namespace] = ACTIONS(2937),
    [anon_sym_class] = ACTIONS(2937),
    [anon_sym_ref] = ACTIONS(2937),
    [anon_sym_struct] = ACTIONS(2937),
    [anon_sym_enum] = ACTIONS(2937),
    [anon_sym_LBRACE] = ACTIONS(2939),
    [anon_sym_interface] = ACTIONS(2937),
    [anon_sym_delegate] = ACTIONS(2937),
    [anon_sym_record] = ACTIONS(2937),
    [anon_sym_abstract] = ACTIONS(2937),
    [anon_sym_async] = ACTIONS(2937),
    [anon_sym_const] = ACTIONS(2937),
    [anon_sym_file] = ACTIONS(2937),
    [anon_sym_fixed] = ACTIONS(2937),
    [anon_sym_internal] = ACTIONS(2937),
    [anon_sym_new] = ACTIONS(2937),
    [anon_sym_override] = ACTIONS(2937),
    [anon_sym_partial] = ACTIONS(2937),
    [anon_sym_private] = ACTIONS(2937),
    [anon_sym_protected] = ACTIONS(2937),
    [anon_sym_public] = ACTIONS(2937),
    [anon_sym_readonly] = ACTIONS(2937),
    [anon_sym_required] = ACTIONS(2937),
    [anon_sym_sealed] = ACTIONS(2937),
    [anon_sym_virtual] = ACTIONS(2937),
    [anon_sym_volatile] = ACTIONS(2937),
    [anon_sym_where] = ACTIONS(2937),
    [anon_sym_notnull] = ACTIONS(2937),
    [anon_sym_unmanaged] = ACTIONS(2937),
    [anon_sym_checked] = ACTIONS(2937),
    [anon_sym_BANG] = ACTIONS(2939),
    [anon_sym_TILDE] = ACTIONS(2939),
    [anon_sym_PLUS_PLUS] = ACTIONS(2939),
    [anon_sym_DASH_DASH] = ACTIONS(2939),
    [anon_sym_true] = ACTIONS(2937),
    [anon_sym_false] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(2937),
    [anon_sym_DASH] = ACTIONS(2937),
    [anon_sym_STAR] = ACTIONS(2939),
    [anon_sym_CARET] = ACTIONS(2939),
    [anon_sym_AMP] = ACTIONS(2939),
    [anon_sym_this] = ACTIONS(2937),
    [anon_sym_scoped] = ACTIONS(2937),
    [anon_sym_var] = ACTIONS(2937),
    [sym_predefined_type] = ACTIONS(2937),
    [anon_sym_break] = ACTIONS(2937),
    [anon_sym_unchecked] = ACTIONS(2937),
    [anon_sym_continue] = ACTIONS(2937),
    [anon_sym_do] = ACTIONS(2937),
    [anon_sym_while] = ACTIONS(2937),
    [anon_sym_for] = ACTIONS(2937),
    [anon_sym_lock] = ACTIONS(2937),
    [anon_sym_yield] = ACTIONS(2937),
    [anon_sym_switch] = ACTIONS(2937),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_throw] = ACTIONS(2937),
    [anon_sym_try] = ACTIONS(2937),
    [anon_sym_catch] = ACTIONS(2941),
    [anon_sym_when] = ACTIONS(2937),
    [anon_sym_finally] = ACTIONS(2943),
    [anon_sym_await] = ACTIONS(2937),
    [anon_sym_foreach] = ACTIONS(2937),
    [anon_sym_goto] = ACTIONS(2937),
    [anon_sym_if] = ACTIONS(2937),
    [anon_sym_else] = ACTIONS(2937),
    [anon_sym_DOT_DOT] = ACTIONS(2939),
    [anon_sym_from] = ACTIONS(2937),
    [anon_sym_into] = ACTIONS(2937),
    [anon_sym_join] = ACTIONS(2937),
    [anon_sym_on] = ACTIONS(2937),
    [anon_sym_equals] = ACTIONS(2937),
    [anon_sym_let] = ACTIONS(2937),
    [anon_sym_orderby] = ACTIONS(2937),
    [anon_sym_ascending] = ACTIONS(2937),
    [anon_sym_descending] = ACTIONS(2937),
    [anon_sym_group] = ACTIONS(2937),
    [anon_sym_by] = ACTIONS(2937),
    [anon_sym_select] = ACTIONS(2937),
    [anon_sym_DQUOTE] = ACTIONS(2937),
    [anon_sym_stackalloc] = ACTIONS(2937),
    [anon_sym_sizeof] = ACTIONS(2937),
    [anon_sym_typeof] = ACTIONS(2937),
    [anon_sym___makeref] = ACTIONS(2937),
    [anon_sym___reftype] = ACTIONS(2937),
    [anon_sym___refvalue] = ACTIONS(2937),
    [sym_null_literal] = ACTIONS(2937),
    [anon_sym_SQUOTE] = ACTIONS(2939),
    [sym_integer_literal] = ACTIONS(2937),
    [sym_real_literal] = ACTIONS(2939),
    [sym_verbatim_string_literal] = ACTIONS(2939),
    [sym_raw_string_literal] = ACTIONS(2939),
    [aux_sym_preproc_if_token1] = ACTIONS(2939),
    [aux_sym_preproc_if_token3] = ACTIONS(2939),
    [aux_sym_preproc_else_token1] = ACTIONS(2939),
    [aux_sym_preproc_elif_token1] = ACTIONS(2939),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(2939),
    [sym_interpolation_verbatim_start] = ACTIONS(2939),
    [sym_interpolation_raw_start] = ACTIONS(2939),
  },
  [2199] = {
    [sym_catch_clause] = STATE(2208),
    [sym_finally_clause] = STATE(2276),
    [sym_preproc_region] = STATE(2199),
    [sym_preproc_endregion] = STATE(2199),
    [sym_preproc_line] = STATE(2199),
    [sym_preproc_pragma] = STATE(2199),
    [sym_preproc_nullable] = STATE(2199),
    [sym_preproc_error] = STATE(2199),
    [sym_preproc_define] = STATE(2199),
    [sym_preproc_undef] = STATE(2199),
    [aux_sym_try_statement_repeat1] = STATE(2198),
    [sym__identifier_token] = ACTIONS(2945),
    [anon_sym_extern] = ACTIONS(2945),
    [anon_sym_alias] = ACTIONS(2945),
    [anon_sym_SEMI] = ACTIONS(2947),
    [anon_sym_global] = ACTIONS(2945),
    [anon_sym_using] = ACTIONS(2945),
    [anon_sym_unsafe] = ACTIONS(2945),
    [anon_sym_static] = ACTIONS(2945),
    [anon_sym_LBRACK] = ACTIONS(2947),
    [anon_sym_LPAREN] = ACTIONS(2947),
    [anon_sym_return] = ACTIONS(2945),
    [anon_sym_namespace] = ACTIONS(2945),
    [anon_sym_class] = ACTIONS(2945),
    [anon_sym_ref] = ACTIONS(2945),
    [anon_sym_struct] = ACTIONS(2945),
    [anon_sym_enum] = ACTIONS(2945),
    [anon_sym_LBRACE] = ACTIONS(2947),
    [anon_sym_interface] = ACTIONS(2945),
    [anon_sym_delegate] = ACTIONS(2945),
    [anon_sym_record] = ACTIONS(2945),
    [anon_sym_abstract] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(2945),
    [anon_sym_const] = ACTIONS(2945),
    [anon_sym_file] = ACTIONS(2945),
    [anon_sym_fixed] = ACTIONS(2945),
    [anon_sym_internal] = ACTIONS(2945),
    [anon_sym_new] = ACTIONS(2945),
    [anon_sym_override] = ACTIONS(2945),
    [anon_sym_partial] = ACTIONS(2945),
    [anon_sym_private] = ACTIONS(2945),
    [anon_sym_protected] = ACTIONS(2945),
    [anon_sym_public] = ACTIONS(2945),
    [anon_sym_readonly] = ACTIONS(2945),
    [anon_sym_required] = ACTIONS(2945),
    [anon_sym_sealed] = ACTIONS(2945),
    [anon_sym_virtual] = ACTIONS(2945),
    [anon_sym_volatile] = ACTIONS(2945),
    [anon_sym_where] = ACTIONS(2945),
    [anon_sym_notnull] = ACTIONS(2945),
    [anon_sym_unmanaged] = ACTIONS(2945),
    [anon_sym_checked] = ACTIONS(2945),
    [anon_sym_BANG] = ACTIONS(2947),
    [anon_sym_TILDE] = ACTIONS(2947),
    [anon_sym_PLUS_PLUS] = ACTIONS(2947),
    [anon_sym_DASH_DASH] = ACTIONS(2947),
    [anon_sym_true] = ACTIONS(2945),
    [anon_sym_false] = ACTIONS(2945),
    [anon_sym_PLUS] = ACTIONS(2945),
    [anon_sym_DASH] = ACTIONS(2945),
    [anon_sym_STAR] = ACTIONS(2947),
    [anon_sym_CARET] = ACTIONS(2947),
    [anon_sym_AMP] = ACTIONS(2947),
    [anon_sym_this] = ACTIONS(2945),
    [anon_sym_scoped] = ACTIONS(2945),
    [anon_sym_var] = ACTIONS(2945),
    [sym_predefined_type] = ACTIONS(2945),
    [anon_sym_break] = ACTIONS(2945),
    [anon_sym_unchecked] = ACTIONS(2945),
    [anon_sym_continue] = ACTIONS(2945),
    [anon_sym_do] = ACTIONS(2945),
    [anon_sym_while] = ACTIONS(2945),
    [anon_sym_for] = ACTIONS(2945),
    [anon_sym_lock] = ACTIONS(2945),
    [anon_sym_yield] = ACTIONS(2945),
    [anon_sym_switch] = ACTIONS(2945),
    [anon_sym_default] = ACTIONS(2945),
    [anon_sym_throw] = ACTIONS(2945),
    [anon_sym_try] = ACTIONS(2945),
    [anon_sym_catch] = ACTIONS(2941),
    [anon_sym_when] = ACTIONS(2945),
    [anon_sym_finally] = ACTIONS(2943),
    [anon_sym_await] = ACTIONS(2945),
    [anon_sym_foreach] = ACTIONS(2945),
    [anon_sym_goto] = ACTIONS(2945),
    [anon_sym_if] = ACTIONS(2945),
    [anon_sym_else] = ACTIONS(2945),
    [anon_sym_DOT_DOT] = ACTIONS(2947),
    [anon_sym_from] = ACTIONS(2945),
    [anon_sym_into] = ACTIONS(2945),
    [anon_sym_join] = ACTIONS(2945),
    [anon_sym_on] = ACTIONS(2945),
    [anon_sym_equals] = ACTIONS(2945),
    [anon_sym_let] = ACTIONS(2945),
    [anon_sym_orderby] = ACTIONS(2945),
    [anon_sym_ascending] = ACTIONS(2945),
    [anon_sym_descending] = ACTIONS(2945),
    [anon_sym_group] = ACTIONS(2945),
    [anon_sym_by] = ACTIONS(2945),
    [anon_sym_select] = ACTIONS(2945),
    [anon_sym_DQUOTE] = ACTIONS(2945),
    [anon_sym_stackalloc] = ACTIONS(2945),
    [anon_sym_sizeof] = ACTIONS(2945),
    [anon_sym_typeof] = ACTIONS(2945),
    [anon_sym___makeref] = ACTIONS(2945),
    [anon_sym___reftype] = ACTIONS(2945),
    [anon_sym___refvalue] = ACTIONS(2945),
    [sym_null_literal] = ACTIONS(2945),
    [anon_sym_SQUOTE] = ACTIONS(2947),
    [sym_integer_literal] = ACTIONS(2945),
    [sym_real_literal] = ACTIONS(2947),
    [sym_verbatim_string_literal] = ACTIONS(2947),
    [sym_raw_string_literal] = ACTIONS(2947),
    [aux_sym_preproc_if_token1] = ACTIONS(2947),
    [aux_sym_preproc_if_token3] = ACTIONS(2947),
    [aux_sym_preproc_else_token1] = ACTIONS(2947),
    [aux_sym_preproc_elif_token1] = ACTIONS(2947),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(2947),
    [sym_interpolation_verbatim_start] = ACTIONS(2947),
    [sym_interpolation_raw_start] = ACTIONS(2947),
  },
  [2200] = {
    [sym_catch_clause] = STATE(2208),
    [sym_preproc_region] = STATE(2200),
    [sym_preproc_endregion] = STATE(2200),
    [sym_preproc_line] = STATE(2200),
    [sym_preproc_pragma] = STATE(2200),
    [sym_preproc_nullable] = STATE(2200),
    [sym_preproc_error] = STATE(2200),
    [sym_preproc_define] = STATE(2200),
    [sym_preproc_undef] = STATE(2200),
    [aux_sym_try_statement_repeat1] = STATE(2200),
    [sym__identifier_token] = ACTIONS(2949),
    [anon_sym_extern] = ACTIONS(2949),
    [anon_sym_alias] = ACTIONS(2949),
    [anon_sym_SEMI] = ACTIONS(2951),
    [anon_sym_global] = ACTIONS(2949),
    [anon_sym_using] = ACTIONS(2949),
    [anon_sym_unsafe] = ACTIONS(2949),
    [anon_sym_static] = ACTIONS(2949),
    [anon_sym_LBRACK] = ACTIONS(2951),
    [anon_sym_LPAREN] = ACTIONS(2951),
    [anon_sym_return] = ACTIONS(2949),
    [anon_sym_namespace] = ACTIONS(2949),
    [anon_sym_class] = ACTIONS(2949),
    [anon_sym_ref] = ACTIONS(2949),
    [anon_sym_struct] = ACTIONS(2949),
    [anon_sym_enum] = ACTIONS(2949),
    [anon_sym_LBRACE] = ACTIONS(2951),
    [anon_sym_interface] = ACTIONS(2949),
    [anon_sym_delegate] = ACTIONS(2949),
    [anon_sym_record] = ACTIONS(2949),
    [anon_sym_abstract] = ACTIONS(2949),
    [anon_sym_async] = ACTIONS(2949),
    [anon_sym_const] = ACTIONS(2949),
    [anon_sym_file] = ACTIONS(2949),
    [anon_sym_fixed] = ACTIONS(2949),
    [anon_sym_internal] = ACTIONS(2949),
    [anon_sym_new] = ACTIONS(2949),
    [anon_sym_override] = ACTIONS(2949),
    [anon_sym_partial] = ACTIONS(2949),
    [anon_sym_private] = ACTIONS(2949),
    [anon_sym_protected] = ACTIONS(2949),
    [anon_sym_public] = ACTIONS(2949),
    [anon_sym_readonly] = ACTIONS(2949),
    [anon_sym_required] = ACTIONS(2949),
    [anon_sym_sealed] = ACTIONS(2949),
    [anon_sym_virtual] = ACTIONS(2949),
    [anon_sym_volatile] = ACTIONS(2949),
    [anon_sym_where] = ACTIONS(2949),
    [anon_sym_notnull] = ACTIONS(2949),
    [anon_sym_unmanaged] = ACTIONS(2949),
    [anon_sym_checked] = ACTIONS(2949),
    [anon_sym_BANG] = ACTIONS(2951),
    [anon_sym_TILDE] = ACTIONS(2951),
    [anon_sym_PLUS_PLUS] = ACTIONS(2951),
    [anon_sym_DASH_DASH] = ACTIONS(2951),
    [anon_sym_true] = ACTIONS(2949),
    [anon_sym_false] = ACTIONS(2949),
    [anon_sym_PLUS] = ACTIONS(2949),
    [anon_sym_DASH] = ACTIONS(2949),
    [anon_sym_STAR] = ACTIONS(2951),
    [anon_sym_CARET] = ACTIONS(2951),
    [anon_sym_AMP] = ACTIONS(2951),
    [anon_sym_this] = ACTIONS(2949),
    [anon_sym_scoped] = ACTIONS(2949),
    [anon_sym_var] = ACTIONS(2949),
    [sym_predefined_type] = ACTIONS(2949),
    [anon_sym_break] = ACTIONS(2949),
    [anon_sym_unchecked] = ACTIONS(2949),
    [anon_sym_continue] = ACTIONS(2949),
    [anon_sym_do] = ACTIONS(2949),
    [anon_sym_while] = ACTIONS(2949),
    [anon_sym_for] = ACTIONS(2949),
    [anon_sym_lock] = ACTIONS(2949),
    [anon_sym_yield] = ACTIONS(2949),
    [anon_sym_switch] = ACTIONS(2949),
    [anon_sym_default] = ACTIONS(2949),
    [anon_sym_throw] = ACTIONS(2949),
    [anon_sym_try] = ACTIONS(2949),
    [anon_sym_catch] = ACTIONS(2953),
    [anon_sym_when] = ACTIONS(2949),
    [anon_sym_finally] = ACTIONS(2949),
    [anon_sym_await] = ACTIONS(2949),
    [anon_sym_foreach] = ACTIONS(2949),
    [anon_sym_goto] = ACTIONS(2949),
    [anon_sym_if] = ACTIONS(2949),
    [anon_sym_else] = ACTIONS(2949),
    [anon_sym_DOT_DOT] = ACTIONS(2951),
    [anon_sym_from] = ACTIONS(2949),
    [anon_sym_into] = ACTIONS(2949),
    [anon_sym_join] = ACTIONS(2949),
    [anon_sym_on] = ACTIONS(2949),
    [anon_sym_equals] = ACTIONS(2949),
    [anon_sym_let] = ACTIONS(2949),
    [anon_sym_orderby] = ACTIONS(2949),
    [anon_sym_ascending] = ACTIONS(2949),
    [anon_sym_descending] = ACTIONS(2949),
    [anon_sym_group] = ACTIONS(2949),
    [anon_sym_by] = ACTIONS(2949),
    [anon_sym_select] = ACTIONS(2949),
    [anon_sym_DQUOTE] = ACTIONS(2949),
    [anon_sym_stackalloc] = ACTIONS(2949),
    [anon_sym_sizeof] = ACTIONS(2949),
    [anon_sym_typeof] = ACTIONS(2949),
    [anon_sym___makeref] = ACTIONS(2949),
    [anon_sym___reftype] = ACTIONS(2949),
    [anon_sym___refvalue] = ACTIONS(2949),
    [sym_null_literal] = ACTIONS(2949),
    [anon_sym_SQUOTE] = ACTIONS(2951),
    [sym_integer_literal] = ACTIONS(2949),
    [sym_real_literal] = ACTIONS(2951),
    [sym_verbatim_string_literal] = ACTIONS(2951),
    [sym_raw_string_literal] = ACTIONS(2951),
    [aux_sym_preproc_if_token1] = ACTIONS(2951),
    [aux_sym_preproc_if_token3] = ACTIONS(2951),
    [aux_sym_preproc_else_token1] = ACTIONS(2951),
    [aux_sym_preproc_elif_token1] = ACTIONS(2951),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(2951),
    [sym_interpolation_verbatim_start] = ACTIONS(2951),
    [sym_interpolation_raw_start] = ACTIONS(2951),
  },
  [2201] = {
    [sym_catch_clause] = STATE(2224),
    [sym_finally_clause] = STATE(2497),
    [sym_preproc_region] = STATE(2201),
    [sym_preproc_endregion] = STATE(2201),
    [sym_preproc_line] = STATE(2201),
    [sym_preproc_pragma] = STATE(2201),
    [sym_preproc_nullable] = STATE(2201),
    [sym_preproc_error] = STATE(2201),
    [sym_preproc_define] = STATE(2201),
    [sym_preproc_undef] = STATE(2201),
    [aux_sym_try_statement_repeat1] = STATE(2203),
    [ts_builtin_sym_end] = ACTIONS(2939),
    [sym__identifier_token] = ACTIONS(2937),
    [anon_sym_extern] = ACTIONS(2937),
    [anon_sym_alias] = ACTIONS(2937),
    [anon_sym_SEMI] = ACTIONS(2939),
    [anon_sym_global] = ACTIONS(2937),
    [anon_sym_using] = ACTIONS(2937),
    [anon_sym_unsafe] = ACTIONS(2937),
    [anon_sym_static] = ACTIONS(2937),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_LPAREN] = ACTIONS(2939),
    [anon_sym_return] = ACTIONS(2937),
    [anon_sym_namespace] = ACTIONS(2937),
    [anon_sym_class] = ACTIONS(2937),
    [anon_sym_ref] = ACTIONS(2937),
    [anon_sym_struct] = ACTIONS(2937),
    [anon_sym_enum] = ACTIONS(2937),
    [anon_sym_LBRACE] = ACTIONS(2939),
    [anon_sym_interface] = ACTIONS(2937),
    [anon_sym_delegate] = ACTIONS(2937),
    [anon_sym_record] = ACTIONS(2937),
    [anon_sym_abstract] = ACTIONS(2937),
    [anon_sym_async] = ACTIONS(2937),
    [anon_sym_const] = ACTIONS(2937),
    [anon_sym_file] = ACTIONS(2937),
    [anon_sym_fixed] = ACTIONS(2937),
    [anon_sym_internal] = ACTIONS(2937),
    [anon_sym_new] = ACTIONS(2937),
    [anon_sym_override] = ACTIONS(2937),
    [anon_sym_partial] = ACTIONS(2937),
    [anon_sym_private] = ACTIONS(2937),
    [anon_sym_protected] = ACTIONS(2937),
    [anon_sym_public] = ACTIONS(2937),
    [anon_sym_readonly] = ACTIONS(2937),
    [anon_sym_required] = ACTIONS(2937),
    [anon_sym_sealed] = ACTIONS(2937),
    [anon_sym_virtual] = ACTIONS(2937),
    [anon_sym_volatile] = ACTIONS(2937),
    [anon_sym_where] = ACTIONS(2937),
    [anon_sym_notnull] = ACTIONS(2937),
    [anon_sym_unmanaged] = ACTIONS(2937),
    [anon_sym_checked] = ACTIONS(2937),
    [anon_sym_BANG] = ACTIONS(2939),
    [anon_sym_TILDE] = ACTIONS(2939),
    [anon_sym_PLUS_PLUS] = ACTIONS(2939),
    [anon_sym_DASH_DASH] = ACTIONS(2939),
    [anon_sym_true] = ACTIONS(2937),
    [anon_sym_false] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(2937),
    [anon_sym_DASH] = ACTIONS(2937),
    [anon_sym_STAR] = ACTIONS(2939),
    [anon_sym_CARET] = ACTIONS(2939),
    [anon_sym_AMP] = ACTIONS(2939),
    [anon_sym_this] = ACTIONS(2937),
    [anon_sym_scoped] = ACTIONS(2937),
    [anon_sym_var] = ACTIONS(2937),
    [sym_predefined_type] = ACTIONS(2937),
    [anon_sym_break] = ACTIONS(2937),
    [anon_sym_unchecked] = ACTIONS(2937),
    [anon_sym_continue] = ACTIONS(2937),
    [anon_sym_do] = ACTIONS(2937),
    [anon_sym_while] = ACTIONS(2937),
    [anon_sym_for] = ACTIONS(2937),
    [anon_sym_lock] = ACTIONS(2937),
    [anon_sym_yield] = ACTIONS(2937),
    [anon_sym_switch] = ACTIONS(2937),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_throw] = ACTIONS(2937),
    [anon_sym_try] = ACTIONS(2937),
    [anon_sym_catch] = ACTIONS(2956),
    [anon_sym_when] = ACTIONS(2937),
    [anon_sym_finally] = ACTIONS(2958),
    [anon_sym_await] = ACTIONS(2937),
    [anon_sym_foreach] = ACTIONS(2937),
    [anon_sym_goto] = ACTIONS(2937),
    [anon_sym_if] = ACTIONS(2937),
    [anon_sym_else] = ACTIONS(2937),
    [anon_sym_DOT_DOT] = ACTIONS(2939),
    [anon_sym_from] = ACTIONS(2937),
    [anon_sym_into] = ACTIONS(2937),
    [anon_sym_join] = ACTIONS(2937),
    [anon_sym_on] = ACTIONS(2937),
    [anon_sym_equals] = ACTIONS(2937),
    [anon_sym_let] = ACTIONS(2937),
    [anon_sym_orderby] = ACTIONS(2937),
    [anon_sym_ascending] = ACTIONS(2937),
    [anon_sym_descending] = ACTIONS(2937),
    [anon_sym_group] = ACTIONS(2937),
    [anon_sym_by] = ACTIONS(2937),
    [anon_sym_select] = ACTIONS(2937),
    [anon_sym_DQUOTE] = ACTIONS(2937),
    [anon_sym_stackalloc] = ACTIONS(2937),
    [anon_sym_sizeof] = ACTIONS(2937),
    [anon_sym_typeof] = ACTIONS(2937),
    [anon_sym___makeref] = ACTIONS(2937),
    [anon_sym___reftype] = ACTIONS(2937),
    [anon_sym___refvalue] = ACTIONS(2937),
    [sym_null_literal] = ACTIONS(2937),
    [anon_sym_SQUOTE] = ACTIONS(2939),
    [sym_integer_literal] = ACTIONS(2937),
    [sym_real_literal] = ACTIONS(2939),
    [sym_verbatim_string_literal] = ACTIONS(2939),
    [sym_raw_string_literal] = ACTIONS(2939),
    [aux_sym_preproc_if_token1] = ACTIONS(2939),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(2939),
    [sym_interpolation_verbatim_start] = ACTIONS(2939),
    [sym_interpolation_raw_start] = ACTIONS(2939),
  },
  [2202] = {
    [sym_catch_clause] = STATE(2224),
    [sym_finally_clause] = STATE(2468),
    [sym_preproc_region] = STATE(2202),
    [sym_preproc_endregion] = STATE(2202),
    [sym_preproc_line] = STATE(2202),
    [sym_preproc_pragma] = STATE(2202),
    [sym_preproc_nullable] = STATE(2202),
    [sym_preproc_error] = STATE(2202),
    [sym_preproc_define] = STATE(2202),
    [sym_preproc_undef] = STATE(2202),
    [aux_sym_try_statement_repeat1] = STATE(2201),
    [ts_builtin_sym_end] = ACTIONS(2947),
    [sym__identifier_token] = ACTIONS(2945),
    [anon_sym_extern] = ACTIONS(2945),
    [anon_sym_alias] = ACTIONS(2945),
    [anon_sym_SEMI] = ACTIONS(2947),
    [anon_sym_global] = ACTIONS(2945),
    [anon_sym_using] = ACTIONS(2945),
    [anon_sym_unsafe] = ACTIONS(2945),
    [anon_sym_static] = ACTIONS(2945),
    [anon_sym_LBRACK] = ACTIONS(2947),
    [anon_sym_LPAREN] = ACTIONS(2947),
    [anon_sym_return] = ACTIONS(2945),
    [anon_sym_namespace] = ACTIONS(2945),
    [anon_sym_class] = ACTIONS(2945),
    [anon_sym_ref] = ACTIONS(2945),
    [anon_sym_struct] = ACTIONS(2945),
    [anon_sym_enum] = ACTIONS(2945),
    [anon_sym_LBRACE] = ACTIONS(2947),
    [anon_sym_interface] = ACTIONS(2945),
    [anon_sym_delegate] = ACTIONS(2945),
    [anon_sym_record] = ACTIONS(2945),
    [anon_sym_abstract] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(2945),
    [anon_sym_const] = ACTIONS(2945),
    [anon_sym_file] = ACTIONS(2945),
    [anon_sym_fixed] = ACTIONS(2945),
    [anon_sym_internal] = ACTIONS(2945),
    [anon_sym_new] = ACTIONS(2945),
    [anon_sym_override] = ACTIONS(2945),
    [anon_sym_partial] = ACTIONS(2945),
    [anon_sym_private] = ACTIONS(2945),
    [anon_sym_protected] = ACTIONS(2945),
    [anon_sym_public] = ACTIONS(2945),
    [anon_sym_readonly] = ACTIONS(2945),
    [anon_sym_required] = ACTIONS(2945),
    [anon_sym_sealed] = ACTIONS(2945),
    [anon_sym_virtual] = ACTIONS(2945),
    [anon_sym_volatile] = ACTIONS(2945),
    [anon_sym_where] = ACTIONS(2945),
    [anon_sym_notnull] = ACTIONS(2945),
    [anon_sym_unmanaged] = ACTIONS(2945),
    [anon_sym_checked] = ACTIONS(2945),
    [anon_sym_BANG] = ACTIONS(2947),
    [anon_sym_TILDE] = ACTIONS(2947),
    [anon_sym_PLUS_PLUS] = ACTIONS(2947),
    [anon_sym_DASH_DASH] = ACTIONS(2947),
    [anon_sym_true] = ACTIONS(2945),
    [anon_sym_false] = ACTIONS(2945),
    [anon_sym_PLUS] = ACTIONS(2945),
    [anon_sym_DASH] = ACTIONS(2945),
    [anon_sym_STAR] = ACTIONS(2947),
    [anon_sym_CARET] = ACTIONS(2947),
    [anon_sym_AMP] = ACTIONS(2947),
    [anon_sym_this] = ACTIONS(2945),
    [anon_sym_scoped] = ACTIONS(2945),
    [anon_sym_var] = ACTIONS(2945),
    [sym_predefined_type] = ACTIONS(2945),
    [anon_sym_break] = ACTIONS(2945),
    [anon_sym_unchecked] = ACTIONS(2945),
    [anon_sym_continue] = ACTIONS(2945),
    [anon_sym_do] = ACTIONS(2945),
    [anon_sym_while] = ACTIONS(2945),
    [anon_sym_for] = ACTIONS(2945),
    [anon_sym_lock] = ACTIONS(2945),
    [anon_sym_yield] = ACTIONS(2945),
    [anon_sym_switch] = ACTIONS(2945),
    [anon_sym_default] = ACTIONS(2945),
    [anon_sym_throw] = ACTIONS(2945),
    [anon_sym_try] = ACTIONS(2945),
    [anon_sym_catch] = ACTIONS(2956),
    [anon_sym_when] = ACTIONS(2945),
    [anon_sym_finally] = ACTIONS(2958),
    [anon_sym_await] = ACTIONS(2945),
    [anon_sym_foreach] = ACTIONS(2945),
    [anon_sym_goto] = ACTIONS(2945),
    [anon_sym_if] = ACTIONS(2945),
    [anon_sym_else] = ACTIONS(2945),
    [anon_sym_DOT_DOT] = ACTIONS(2947),
    [anon_sym_from] = ACTIONS(2945),
    [anon_sym_into] = ACTIONS(2945),
    [anon_sym_join] = ACTIONS(2945),
    [anon_sym_on] = ACTIONS(2945),
    [anon_sym_equals] = ACTIONS(2945),
    [anon_sym_let] = ACTIONS(2945),
    [anon_sym_orderby] = ACTIONS(2945),
    [anon_sym_ascending] = ACTIONS(2945),
    [anon_sym_descending] = ACTIONS(2945),
    [anon_sym_group] = ACTIONS(2945),
    [anon_sym_by] = ACTIONS(2945),
    [anon_sym_select] = ACTIONS(2945),
    [anon_sym_DQUOTE] = ACTIONS(2945),
    [anon_sym_stackalloc] = ACTIONS(2945),
    [anon_sym_sizeof] = ACTIONS(2945),
    [anon_sym_typeof] = ACTIONS(2945),
    [anon_sym___makeref] = ACTIONS(2945),
    [anon_sym___reftype] = ACTIONS(2945),
    [anon_sym___refvalue] = ACTIONS(2945),
    [sym_null_literal] = ACTIONS(2945),
    [anon_sym_SQUOTE] = ACTIONS(2947),
    [sym_integer_literal] = ACTIONS(2945),
    [sym_real_literal] = ACTIONS(2947),
    [sym_verbatim_string_literal] = ACTIONS(2947),
    [sym_raw_string_literal] = ACTIONS(2947),
    [aux_sym_preproc_if_token1] = ACTIONS(2947),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(2947),
    [sym_interpolation_verbatim_start] = ACTIONS(2947),
    [sym_interpolation_raw_start] = ACTIONS(2947),
  },
  [2203] = {
    [sym_catch_clause] = STATE(2224),
    [sym_preproc_region] = STATE(2203),
    [sym_preproc_endregion] = STATE(2203),
    [sym_preproc_line] = STATE(2203),
    [sym_preproc_pragma] = STATE(2203),
    [sym_preproc_nullable] = STATE(2203),
    [sym_preproc_error] = STATE(2203),
    [sym_preproc_define] = STATE(2203),
    [sym_preproc_undef] = STATE(2203),
    [aux_sym_try_statement_repeat1] = STATE(2203),
    [ts_builtin_sym_end] = ACTIONS(2951),
    [sym__identifier_token] = ACTIONS(2949),
    [anon_sym_extern] = ACTIONS(2949),
    [anon_sym_alias] = ACTIONS(2949),
    [anon_sym_SEMI] = ACTIONS(2951),
    [anon_sym_global] = ACTIONS(2949),
    [anon_sym_using] = ACTIONS(2949),
    [anon_sym_unsafe] = ACTIONS(2949),
    [anon_sym_static] = ACTIONS(2949),
    [anon_sym_LBRACK] = ACTIONS(2951),
    [anon_sym_LPAREN] = ACTIONS(2951),
    [anon_sym_return] = ACTIONS(2949),
    [anon_sym_namespace] = ACTIONS(2949),
    [anon_sym_class] = ACTIONS(2949),
    [anon_sym_ref] = ACTIONS(2949),
    [anon_sym_struct] = ACTIONS(2949),
    [anon_sym_enum] = ACTIONS(2949),
    [anon_sym_LBRACE] = ACTIONS(2951),
    [anon_sym_interface] = ACTIONS(2949),
    [anon_sym_delegate] = ACTIONS(2949),
    [anon_sym_record] = ACTIONS(2949),
    [anon_sym_abstract] = ACTIONS(2949),
    [anon_sym_async] = ACTIONS(2949),
    [anon_sym_const] = ACTIONS(2949),
    [anon_sym_file] = ACTIONS(2949),
    [anon_sym_fixed] = ACTIONS(2949),
    [anon_sym_internal] = ACTIONS(2949),
    [anon_sym_new] = ACTIONS(2949),
    [anon_sym_override] = ACTIONS(2949),
    [anon_sym_partial] = ACTIONS(2949),
    [anon_sym_private] = ACTIONS(2949),
    [anon_sym_protected] = ACTIONS(2949),
    [anon_sym_public] = ACTIONS(2949),
    [anon_sym_readonly] = ACTIONS(2949),
    [anon_sym_required] = ACTIONS(2949),
    [anon_sym_sealed] = ACTIONS(2949),
    [anon_sym_virtual] = ACTIONS(2949),
    [anon_sym_volatile] = ACTIONS(2949),
    [anon_sym_where] = ACTIONS(2949),
    [anon_sym_notnull] = ACTIONS(2949),
    [anon_sym_unmanaged] = ACTIONS(2949),
    [anon_sym_checked] = ACTIONS(2949),
    [anon_sym_BANG] = ACTIONS(2951),
    [anon_sym_TILDE] = ACTIONS(2951),
    [anon_sym_PLUS_PLUS] = ACTIONS(2951),
    [anon_sym_DASH_DASH] = ACTIONS(2951),
    [anon_sym_true] = ACTIONS(2949),
    [anon_sym_false] = ACTIONS(2949),
    [anon_sym_PLUS] = ACTIONS(2949),
    [anon_sym_DASH] = ACTIONS(2949),
    [anon_sym_STAR] = ACTIONS(2951),
    [anon_sym_CARET] = ACTIONS(2951),
    [anon_sym_AMP] = ACTIONS(2951),
    [anon_sym_this] = ACTIONS(2949),
    [anon_sym_scoped] = ACTIONS(2949),
    [anon_sym_var] = ACTIONS(2949),
    [sym_predefined_type] = ACTIONS(2949),
    [anon_sym_break] = ACTIONS(2949),
    [anon_sym_unchecked] = ACTIONS(2949),
    [anon_sym_continue] = ACTIONS(2949),
    [anon_sym_do] = ACTIONS(2949),
    [anon_sym_while] = ACTIONS(2949),
    [anon_sym_for] = ACTIONS(2949),
    [anon_sym_lock] = ACTIONS(2949),
    [anon_sym_yield] = ACTIONS(2949),
    [anon_sym_switch] = ACTIONS(2949),
    [anon_sym_default] = ACTIONS(2949),
    [anon_sym_throw] = ACTIONS(2949),
    [anon_sym_try] = ACTIONS(2949),
    [anon_sym_catch] = ACTIONS(2960),
    [anon_sym_when] = ACTIONS(2949),
    [anon_sym_finally] = ACTIONS(2949),
    [anon_sym_await] = ACTIONS(2949),
    [anon_sym_foreach] = ACTIONS(2949),
    [anon_sym_goto] = ACTIONS(2949),
    [anon_sym_if] = ACTIONS(2949),
    [anon_sym_else] = ACTIONS(2949),
    [anon_sym_DOT_DOT] = ACTIONS(2951),
    [anon_sym_from] = ACTIONS(2949),
    [anon_sym_into] = ACTIONS(2949),
    [anon_sym_join] = ACTIONS(2949),
    [anon_sym_on] = ACTIONS(2949),
    [anon_sym_equals] = ACTIONS(2949),
    [anon_sym_let] = ACTIONS(2949),
    [anon_sym_orderby] = ACTIONS(2949),
    [anon_sym_ascending] = ACTIONS(2949),
    [anon_sym_descending] = ACTIONS(2949),
    [anon_sym_group] = ACTIONS(2949),
    [anon_sym_by] = ACTIONS(2949),
    [anon_sym_select] = ACTIONS(2949),
    [anon_sym_DQUOTE] = ACTIONS(2949),
    [anon_sym_stackalloc] = ACTIONS(2949),
    [anon_sym_sizeof] = ACTIONS(2949),
    [anon_sym_typeof] = ACTIONS(2949),
    [anon_sym___makeref] = ACTIONS(2949),
    [anon_sym___reftype] = ACTIONS(2949),
    [anon_sym___refvalue] = ACTIONS(2949),
    [sym_null_literal] = ACTIONS(2949),
    [anon_sym_SQUOTE] = ACTIONS(2951),
    [sym_integer_literal] = ACTIONS(2949),
    [sym_real_literal] = ACTIONS(2951),
    [sym_verbatim_string_literal] = ACTIONS(2951),
    [sym_raw_string_literal] = ACTIONS(2951),
    [aux_sym_preproc_if_token1] = ACTIONS(2951),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(2951),
    [sym_interpolation_verbatim_start] = ACTIONS(2951),
    [sym_interpolation_raw_start] = ACTIONS(2951),
  },
  [2204] = {
    [sym_preproc_region] = STATE(2204),
    [sym_preproc_endregion] = STATE(2204),
    [sym_preproc_line] = STATE(2204),
    [sym_preproc_pragma] = STATE(2204),
    [sym_preproc_nullable] = STATE(2204),
    [sym_preproc_error] = STATE(2204),
    [sym_preproc_define] = STATE(2204),
    [sym_preproc_undef] = STATE(2204),
    [sym__identifier_token] = ACTIONS(2963),
    [anon_sym_extern] = ACTIONS(2963),
    [anon_sym_alias] = ACTIONS(2963),
    [anon_sym_SEMI] = ACTIONS(2965),
    [anon_sym_global] = ACTIONS(2963),
    [anon_sym_using] = ACTIONS(2963),
    [anon_sym_unsafe] = ACTIONS(2963),
    [anon_sym_static] = ACTIONS(2963),
    [anon_sym_LBRACK] = ACTIONS(2965),
    [anon_sym_LPAREN] = ACTIONS(2965),
    [anon_sym_return] = ACTIONS(2963),
    [anon_sym_namespace] = ACTIONS(2963),
    [anon_sym_class] = ACTIONS(2963),
    [anon_sym_ref] = ACTIONS(2963),
    [anon_sym_struct] = ACTIONS(2963),
    [anon_sym_enum] = ACTIONS(2963),
    [anon_sym_LBRACE] = ACTIONS(2965),
    [anon_sym_interface] = ACTIONS(2963),
    [anon_sym_delegate] = ACTIONS(2963),
    [anon_sym_record] = ACTIONS(2963),
    [anon_sym_abstract] = ACTIONS(2963),
    [anon_sym_async] = ACTIONS(2963),
    [anon_sym_const] = ACTIONS(2963),
    [anon_sym_file] = ACTIONS(2963),
    [anon_sym_fixed] = ACTIONS(2963),
    [anon_sym_internal] = ACTIONS(2963),
    [anon_sym_new] = ACTIONS(2963),
    [anon_sym_override] = ACTIONS(2963),
    [anon_sym_partial] = ACTIONS(2963),
    [anon_sym_private] = ACTIONS(2963),
    [anon_sym_protected] = ACTIONS(2963),
    [anon_sym_public] = ACTIONS(2963),
    [anon_sym_readonly] = ACTIONS(2963),
    [anon_sym_required] = ACTIONS(2963),
    [anon_sym_sealed] = ACTIONS(2963),
    [anon_sym_virtual] = ACTIONS(2963),
    [anon_sym_volatile] = ACTIONS(2963),
    [anon_sym_where] = ACTIONS(2963),
    [anon_sym_notnull] = ACTIONS(2963),
    [anon_sym_unmanaged] = ACTIONS(2963),
    [anon_sym_checked] = ACTIONS(2963),
    [anon_sym_BANG] = ACTIONS(2965),
    [anon_sym_TILDE] = ACTIONS(2965),
    [anon_sym_PLUS_PLUS] = ACTIONS(2965),
    [anon_sym_DASH_DASH] = ACTIONS(2965),
    [anon_sym_true] = ACTIONS(2963),
    [anon_sym_false] = ACTIONS(2963),
    [anon_sym_PLUS] = ACTIONS(2963),
    [anon_sym_DASH] = ACTIONS(2963),
    [anon_sym_STAR] = ACTIONS(2965),
    [anon_sym_CARET] = ACTIONS(2965),
    [anon_sym_AMP] = ACTIONS(2965),
    [anon_sym_this] = ACTIONS(2963),
    [anon_sym_scoped] = ACTIONS(2963),
    [anon_sym_var] = ACTIONS(2963),
    [sym_predefined_type] = ACTIONS(2963),
    [anon_sym_break] = ACTIONS(2963),
    [anon_sym_unchecked] = ACTIONS(2963),
    [anon_sym_continue] = ACTIONS(2963),
    [anon_sym_do] = ACTIONS(2963),
    [anon_sym_while] = ACTIONS(2963),
    [anon_sym_for] = ACTIONS(2963),
    [anon_sym_lock] = ACTIONS(2963),
    [anon_sym_yield] = ACTIONS(2963),
    [anon_sym_switch] = ACTIONS(2963),
    [anon_sym_default] = ACTIONS(2963),
    [anon_sym_throw] = ACTIONS(2963),
    [anon_sym_try] = ACTIONS(2963),
    [anon_sym_catch] = ACTIONS(2963),
    [anon_sym_when] = ACTIONS(2963),
    [anon_sym_finally] = ACTIONS(2963),
    [anon_sym_await] = ACTIONS(2963),
    [anon_sym_foreach] = ACTIONS(2963),
    [anon_sym_goto] = ACTIONS(2963),
    [anon_sym_if] = ACTIONS(2963),
    [anon_sym_else] = ACTIONS(2963),
    [anon_sym_DOT_DOT] = ACTIONS(2965),
    [anon_sym_from] = ACTIONS(2963),
    [anon_sym_into] = ACTIONS(2963),
    [anon_sym_join] = ACTIONS(2963),
    [anon_sym_on] = ACTIONS(2963),
    [anon_sym_equals] = ACTIONS(2963),
    [anon_sym_let] = ACTIONS(2963),
    [anon_sym_orderby] = ACTIONS(2963),
    [anon_sym_ascending] = ACTIONS(2963),
    [anon_sym_descending] = ACTIONS(2963),
    [anon_sym_group] = ACTIONS(2963),
    [anon_sym_by] = ACTIONS(2963),
    [anon_sym_select] = ACTIONS(2963),
    [anon_sym_DQUOTE] = ACTIONS(2963),
    [anon_sym_stackalloc] = ACTIONS(2963),
    [anon_sym_sizeof] = ACTIONS(2963),
    [anon_sym_typeof] = ACTIONS(2963),
    [anon_sym___makeref] = ACTIONS(2963),
    [anon_sym___reftype] = ACTIONS(2963),
    [anon_sym___refvalue] = ACTIONS(2963),
    [sym_null_literal] = ACTIONS(2963),
    [anon_sym_SQUOTE] = ACTIONS(2965),
    [sym_integer_literal] = ACTIONS(2963),
    [sym_real_literal] = ACTIONS(2965),
    [sym_verbatim_string_literal] = ACTIONS(2965),
    [sym_raw_string_literal] = ACTIONS(2965),
    [aux_sym_preproc_if_token1] = ACTIONS(2965),
    [aux_sym_preproc_if_token3] = ACTIONS(2965),
    [aux_sym_preproc_else_token1] = ACTIONS(2965),
    [aux_sym_preproc_elif_token1] = ACTIONS(2965),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(2965),
    [sym_interpolation_verbatim_start] = ACTIONS(2965),
    [sym_interpolation_raw_start] = ACTIONS(2965),
  },
  [2205] = {
    [sym_preproc_region] = STATE(2205),
    [sym_preproc_endregion] = STATE(2205),
    [sym_preproc_line] = STATE(2205),
    [sym_preproc_pragma] = STATE(2205),
    [sym_preproc_nullable] = STATE(2205),
    [sym_preproc_error] = STATE(2205),
    [sym_preproc_define] = STATE(2205),
    [sym_preproc_undef] = STATE(2205),
    [sym__identifier_token] = ACTIONS(2921),
    [anon_sym_extern] = ACTIONS(2921),
    [anon_sym_alias] = ACTIONS(2921),
    [anon_sym_SEMI] = ACTIONS(2923),
    [anon_sym_global] = ACTIONS(2921),
    [anon_sym_using] = ACTIONS(2921),
    [anon_sym_unsafe] = ACTIONS(2921),
    [anon_sym_static] = ACTIONS(2921),
    [anon_sym_LBRACK] = ACTIONS(2923),
    [anon_sym_LPAREN] = ACTIONS(2923),
    [anon_sym_return] = ACTIONS(2921),
    [anon_sym_namespace] = ACTIONS(2921),
    [anon_sym_class] = ACTIONS(2921),
    [anon_sym_ref] = ACTIONS(2921),
    [anon_sym_struct] = ACTIONS(2921),
    [anon_sym_enum] = ACTIONS(2921),
    [anon_sym_LBRACE] = ACTIONS(2923),
    [anon_sym_interface] = ACTIONS(2921),
    [anon_sym_delegate] = ACTIONS(2921),
    [anon_sym_record] = ACTIONS(2921),
    [anon_sym_abstract] = ACTIONS(2921),
    [anon_sym_async] = ACTIONS(2921),
    [anon_sym_const] = ACTIONS(2921),
    [anon_sym_file] = ACTIONS(2921),
    [anon_sym_fixed] = ACTIONS(2921),
    [anon_sym_internal] = ACTIONS(2921),
    [anon_sym_new] = ACTIONS(2921),
    [anon_sym_override] = ACTIONS(2921),
    [anon_sym_partial] = ACTIONS(2921),
    [anon_sym_private] = ACTIONS(2921),
    [anon_sym_protected] = ACTIONS(2921),
    [anon_sym_public] = ACTIONS(2921),
    [anon_sym_readonly] = ACTIONS(2921),
    [anon_sym_required] = ACTIONS(2921),
    [anon_sym_sealed] = ACTIONS(2921),
    [anon_sym_virtual] = ACTIONS(2921),
    [anon_sym_volatile] = ACTIONS(2921),
    [anon_sym_where] = ACTIONS(2921),
    [anon_sym_notnull] = ACTIONS(2921),
    [anon_sym_unmanaged] = ACTIONS(2921),
    [anon_sym_checked] = ACTIONS(2921),
    [anon_sym_BANG] = ACTIONS(2923),
    [anon_sym_TILDE] = ACTIONS(2923),
    [anon_sym_PLUS_PLUS] = ACTIONS(2923),
    [anon_sym_DASH_DASH] = ACTIONS(2923),
    [anon_sym_true] = ACTIONS(2921),
    [anon_sym_false] = ACTIONS(2921),
    [anon_sym_PLUS] = ACTIONS(2921),
    [anon_sym_DASH] = ACTIONS(2921),
    [anon_sym_STAR] = ACTIONS(2923),
    [anon_sym_CARET] = ACTIONS(2923),
    [anon_sym_AMP] = ACTIONS(2923),
    [anon_sym_this] = ACTIONS(2921),
    [anon_sym_scoped] = ACTIONS(2921),
    [anon_sym_var] = ACTIONS(2921),
    [sym_predefined_type] = ACTIONS(2921),
    [anon_sym_break] = ACTIONS(2921),
    [anon_sym_unchecked] = ACTIONS(2921),
    [anon_sym_continue] = ACTIONS(2921),
    [anon_sym_do] = ACTIONS(2921),
    [anon_sym_while] = ACTIONS(2921),
    [anon_sym_for] = ACTIONS(2921),
    [anon_sym_lock] = ACTIONS(2921),
    [anon_sym_yield] = ACTIONS(2921),
    [anon_sym_switch] = ACTIONS(2921),
    [anon_sym_default] = ACTIONS(2921),
    [anon_sym_throw] = ACTIONS(2921),
    [anon_sym_try] = ACTIONS(2921),
    [anon_sym_catch] = ACTIONS(2921),
    [anon_sym_when] = ACTIONS(2921),
    [anon_sym_finally] = ACTIONS(2921),
    [anon_sym_await] = ACTIONS(2921),
    [anon_sym_foreach] = ACTIONS(2921),
    [anon_sym_goto] = ACTIONS(2921),
    [anon_sym_if] = ACTIONS(2921),
    [anon_sym_else] = ACTIONS(2921),
    [anon_sym_DOT_DOT] = ACTIONS(2923),
    [anon_sym_from] = ACTIONS(2921),
    [anon_sym_into] = ACTIONS(2921),
    [anon_sym_join] = ACTIONS(2921),
    [anon_sym_on] = ACTIONS(2921),
    [anon_sym_equals] = ACTIONS(2921),
    [anon_sym_let] = ACTIONS(2921),
    [anon_sym_orderby] = ACTIONS(2921),
    [anon_sym_ascending] = ACTIONS(2921),
    [anon_sym_descending] = ACTIONS(2921),
    [anon_sym_group] = ACTIONS(2921),
    [anon_sym_by] = ACTIONS(2921),
    [anon_sym_select] = ACTIONS(2921),
    [anon_sym_DQUOTE] = ACTIONS(2921),
    [anon_sym_stackalloc] = ACTIONS(2921),
    [anon_sym_sizeof] = ACTIONS(2921),
    [anon_sym_typeof] = ACTIONS(2921),
    [anon_sym___makeref] = ACTIONS(2921),
    [anon_sym___reftype] = ACTIONS(2921),
    [anon_sym___refvalue] = ACTIONS(2921),
    [sym_null_literal] = ACTIONS(2921),
    [anon_sym_SQUOTE] = ACTIONS(2923),
    [sym_integer_literal] = ACTIONS(2921),
    [sym_real_literal] = ACTIONS(2923),
    [sym_verbatim_string_literal] = ACTIONS(2923),
    [sym_raw_string_literal] = ACTIONS(2923),
    [aux_sym_preproc_if_token1] = ACTIONS(2923),
    [aux_sym_preproc_if_token3] = ACTIONS(2923),
    [aux_sym_preproc_else_token1] = ACTIONS(2923),
    [aux_sym_preproc_elif_token1] = ACTIONS(2923),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(2923),
    [sym_interpolation_verbatim_start] = ACTIONS(2923),
    [sym_interpolation_raw_start] = ACTIONS(2923),
  },
  [2206] = {
    [sym_preproc_region] = STATE(2206),
    [sym_preproc_endregion] = STATE(2206),
    [sym_preproc_line] = STATE(2206),
    [sym_preproc_pragma] = STATE(2206),
    [sym_preproc_nullable] = STATE(2206),
    [sym_preproc_error] = STATE(2206),
    [sym_preproc_define] = STATE(2206),
    [sym_preproc_undef] = STATE(2206),
    [sym__identifier_token] = ACTIONS(2967),
    [anon_sym_extern] = ACTIONS(2967),
    [anon_sym_alias] = ACTIONS(2967),
    [anon_sym_SEMI] = ACTIONS(2969),
    [anon_sym_global] = ACTIONS(2967),
    [anon_sym_using] = ACTIONS(2967),
    [anon_sym_unsafe] = ACTIONS(2967),
    [anon_sym_static] = ACTIONS(2967),
    [anon_sym_LBRACK] = ACTIONS(2969),
    [anon_sym_LPAREN] = ACTIONS(2969),
    [anon_sym_return] = ACTIONS(2967),
    [anon_sym_namespace] = ACTIONS(2967),
    [anon_sym_class] = ACTIONS(2967),
    [anon_sym_ref] = ACTIONS(2967),
    [anon_sym_struct] = ACTIONS(2967),
    [anon_sym_enum] = ACTIONS(2967),
    [anon_sym_LBRACE] = ACTIONS(2969),
    [anon_sym_interface] = ACTIONS(2967),
    [anon_sym_delegate] = ACTIONS(2967),
    [anon_sym_record] = ACTIONS(2967),
    [anon_sym_abstract] = ACTIONS(2967),
    [anon_sym_async] = ACTIONS(2967),
    [anon_sym_const] = ACTIONS(2967),
    [anon_sym_file] = ACTIONS(2967),
    [anon_sym_fixed] = ACTIONS(2967),
    [anon_sym_internal] = ACTIONS(2967),
    [anon_sym_new] = ACTIONS(2967),
    [anon_sym_override] = ACTIONS(2967),
    [anon_sym_partial] = ACTIONS(2967),
    [anon_sym_private] = ACTIONS(2967),
    [anon_sym_protected] = ACTIONS(2967),
    [anon_sym_public] = ACTIONS(2967),
    [anon_sym_readonly] = ACTIONS(2967),
    [anon_sym_required] = ACTIONS(2967),
    [anon_sym_sealed] = ACTIONS(2967),
    [anon_sym_virtual] = ACTIONS(2967),
    [anon_sym_volatile] = ACTIONS(2967),
    [anon_sym_where] = ACTIONS(2967),
    [anon_sym_notnull] = ACTIONS(2967),
    [anon_sym_unmanaged] = ACTIONS(2967),
    [anon_sym_checked] = ACTIONS(2967),
    [anon_sym_BANG] = ACTIONS(2969),
    [anon_sym_TILDE] = ACTIONS(2969),
    [anon_sym_PLUS_PLUS] = ACTIONS(2969),
    [anon_sym_DASH_DASH] = ACTIONS(2969),
    [anon_sym_true] = ACTIONS(2967),
    [anon_sym_false] = ACTIONS(2967),
    [anon_sym_PLUS] = ACTIONS(2967),
    [anon_sym_DASH] = ACTIONS(2967),
    [anon_sym_STAR] = ACTIONS(2969),
    [anon_sym_CARET] = ACTIONS(2969),
    [anon_sym_AMP] = ACTIONS(2969),
    [anon_sym_this] = ACTIONS(2967),
    [anon_sym_scoped] = ACTIONS(2967),
    [anon_sym_var] = ACTIONS(2967),
    [sym_predefined_type] = ACTIONS(2967),
    [anon_sym_break] = ACTIONS(2967),
    [anon_sym_unchecked] = ACTIONS(2967),
    [anon_sym_continue] = ACTIONS(2967),
    [anon_sym_do] = ACTIONS(2967),
    [anon_sym_while] = ACTIONS(2967),
    [anon_sym_for] = ACTIONS(2967),
    [anon_sym_lock] = ACTIONS(2967),
    [anon_sym_yield] = ACTIONS(2967),
    [anon_sym_switch] = ACTIONS(2967),
    [anon_sym_default] = ACTIONS(2967),
    [anon_sym_throw] = ACTIONS(2967),
    [anon_sym_try] = ACTIONS(2967),
    [anon_sym_catch] = ACTIONS(2967),
    [anon_sym_when] = ACTIONS(2967),
    [anon_sym_finally] = ACTIONS(2967),
    [anon_sym_await] = ACTIONS(2967),
    [anon_sym_foreach] = ACTIONS(2967),
    [anon_sym_goto] = ACTIONS(2967),
    [anon_sym_if] = ACTIONS(2967),
    [anon_sym_else] = ACTIONS(2967),
    [anon_sym_DOT_DOT] = ACTIONS(2969),
    [anon_sym_from] = ACTIONS(2967),
    [anon_sym_into] = ACTIONS(2967),
    [anon_sym_join] = ACTIONS(2967),
    [anon_sym_on] = ACTIONS(2967),
    [anon_sym_equals] = ACTIONS(2967),
    [anon_sym_let] = ACTIONS(2967),
    [anon_sym_orderby] = ACTIONS(2967),
    [anon_sym_ascending] = ACTIONS(2967),
    [anon_sym_descending] = ACTIONS(2967),
    [anon_sym_group] = ACTIONS(2967),
    [anon_sym_by] = ACTIONS(2967),
    [anon_sym_select] = ACTIONS(2967),
    [anon_sym_DQUOTE] = ACTIONS(2967),
    [anon_sym_stackalloc] = ACTIONS(2967),
    [anon_sym_sizeof] = ACTIONS(2967),
    [anon_sym_typeof] = ACTIONS(2967),
    [anon_sym___makeref] = ACTIONS(2967),
    [anon_sym___reftype] = ACTIONS(2967),
    [anon_sym___refvalue] = ACTIONS(2967),
    [sym_null_literal] = ACTIONS(2967),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [sym_integer_literal] = ACTIONS(2967),
    [sym_real_literal] = ACTIONS(2969),
    [sym_verbatim_string_literal] = ACTIONS(2969),
    [sym_raw_string_literal] = ACTIONS(2969),
    [aux_sym_preproc_if_token1] = ACTIONS(2969),
    [aux_sym_preproc_if_token3] = ACTIONS(2969),
    [aux_sym_preproc_else_token1] = ACTIONS(2969),
    [aux_sym_preproc_elif_token1] = ACTIONS(2969),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(2969),
    [sym_interpolation_verbatim_start] = ACTIONS(2969),
    [sym_interpolation_raw_start] = ACTIONS(2969),
  },
  [2207] = {
    [sym_preproc_region] = STATE(2207),
    [sym_preproc_endregion] = STATE(2207),
    [sym_preproc_line] = STATE(2207),
    [sym_preproc_pragma] = STATE(2207),
    [sym_preproc_nullable] = STATE(2207),
    [sym_preproc_error] = STATE(2207),
    [sym_preproc_define] = STATE(2207),
    [sym_preproc_undef] = STATE(2207),
    [sym__identifier_token] = ACTIONS(2971),
    [anon_sym_extern] = ACTIONS(2971),
    [anon_sym_alias] = ACTIONS(2971),
    [anon_sym_SEMI] = ACTIONS(2973),
    [anon_sym_global] = ACTIONS(2971),
    [anon_sym_using] = ACTIONS(2971),
    [anon_sym_unsafe] = ACTIONS(2971),
    [anon_sym_static] = ACTIONS(2971),
    [anon_sym_LBRACK] = ACTIONS(2973),
    [anon_sym_LPAREN] = ACTIONS(2973),
    [anon_sym_return] = ACTIONS(2971),
    [anon_sym_namespace] = ACTIONS(2971),
    [anon_sym_class] = ACTIONS(2971),
    [anon_sym_ref] = ACTIONS(2971),
    [anon_sym_struct] = ACTIONS(2971),
    [anon_sym_enum] = ACTIONS(2971),
    [anon_sym_LBRACE] = ACTIONS(2973),
    [anon_sym_interface] = ACTIONS(2971),
    [anon_sym_delegate] = ACTIONS(2971),
    [anon_sym_record] = ACTIONS(2971),
    [anon_sym_abstract] = ACTIONS(2971),
    [anon_sym_async] = ACTIONS(2971),
    [anon_sym_const] = ACTIONS(2971),
    [anon_sym_file] = ACTIONS(2971),
    [anon_sym_fixed] = ACTIONS(2971),
    [anon_sym_internal] = ACTIONS(2971),
    [anon_sym_new] = ACTIONS(2971),
    [anon_sym_override] = ACTIONS(2971),
    [anon_sym_partial] = ACTIONS(2971),
    [anon_sym_private] = ACTIONS(2971),
    [anon_sym_protected] = ACTIONS(2971),
    [anon_sym_public] = ACTIONS(2971),
    [anon_sym_readonly] = ACTIONS(2971),
    [anon_sym_required] = ACTIONS(2971),
    [anon_sym_sealed] = ACTIONS(2971),
    [anon_sym_virtual] = ACTIONS(2971),
    [anon_sym_volatile] = ACTIONS(2971),
    [anon_sym_where] = ACTIONS(2971),
    [anon_sym_notnull] = ACTIONS(2971),
    [anon_sym_unmanaged] = ACTIONS(2971),
    [anon_sym_checked] = ACTIONS(2971),
    [anon_sym_BANG] = ACTIONS(2973),
    [anon_sym_TILDE] = ACTIONS(2973),
    [anon_sym_PLUS_PLUS] = ACTIONS(2973),
    [anon_sym_DASH_DASH] = ACTIONS(2973),
    [anon_sym_true] = ACTIONS(2971),
    [anon_sym_false] = ACTIONS(2971),
    [anon_sym_PLUS] = ACTIONS(2971),
    [anon_sym_DASH] = ACTIONS(2971),
    [anon_sym_STAR] = ACTIONS(2973),
    [anon_sym_CARET] = ACTIONS(2973),
    [anon_sym_AMP] = ACTIONS(2973),
    [anon_sym_this] = ACTIONS(2971),
    [anon_sym_scoped] = ACTIONS(2971),
    [anon_sym_var] = ACTIONS(2971),
    [sym_predefined_type] = ACTIONS(2971),
    [anon_sym_break] = ACTIONS(2971),
    [anon_sym_unchecked] = ACTIONS(2971),
    [anon_sym_continue] = ACTIONS(2971),
    [anon_sym_do] = ACTIONS(2971),
    [anon_sym_while] = ACTIONS(2971),
    [anon_sym_for] = ACTIONS(2971),
    [anon_sym_lock] = ACTIONS(2971),
    [anon_sym_yield] = ACTIONS(2971),
    [anon_sym_switch] = ACTIONS(2971),
    [anon_sym_default] = ACTIONS(2971),
    [anon_sym_throw] = ACTIONS(2971),
    [anon_sym_try] = ACTIONS(2971),
    [anon_sym_catch] = ACTIONS(2971),
    [anon_sym_when] = ACTIONS(2971),
    [anon_sym_finally] = ACTIONS(2971),
    [anon_sym_await] = ACTIONS(2971),
    [anon_sym_foreach] = ACTIONS(2971),
    [anon_sym_goto] = ACTIONS(2971),
    [anon_sym_if] = ACTIONS(2971),
    [anon_sym_else] = ACTIONS(2971),
    [anon_sym_DOT_DOT] = ACTIONS(2973),
    [anon_sym_from] = ACTIONS(2971),
    [anon_sym_into] = ACTIONS(2971),
    [anon_sym_join] = ACTIONS(2971),
    [anon_sym_on] = ACTIONS(2971),
    [anon_sym_equals] = ACTIONS(2971),
    [anon_sym_let] = ACTIONS(2971),
    [anon_sym_orderby] = ACTIONS(2971),
    [anon_sym_ascending] = ACTIONS(2971),
    [anon_sym_descending] = ACTIONS(2971),
    [anon_sym_group] = ACTIONS(2971),
    [anon_sym_by] = ACTIONS(2971),
    [anon_sym_select] = ACTIONS(2971),
    [anon_sym_DQUOTE] = ACTIONS(2971),
    [anon_sym_stackalloc] = ACTIONS(2971),
    [anon_sym_sizeof] = ACTIONS(2971),
    [anon_sym_typeof] = ACTIONS(2971),
    [anon_sym___makeref] = ACTIONS(2971),
    [anon_sym___reftype] = ACTIONS(2971),
    [anon_sym___refvalue] = ACTIONS(2971),
    [sym_null_literal] = ACTIONS(2971),
    [anon_sym_SQUOTE] = ACTIONS(2973),
    [sym_integer_literal] = ACTIONS(2971),
    [sym_real_literal] = ACTIONS(2973),
    [sym_verbatim_string_literal] = ACTIONS(2973),
    [sym_raw_string_literal] = ACTIONS(2973),
    [aux_sym_preproc_if_token1] = ACTIONS(2973),
    [aux_sym_preproc_if_token3] = ACTIONS(2973),
    [aux_sym_preproc_else_token1] = ACTIONS(2973),
    [aux_sym_preproc_elif_token1] = ACTIONS(2973),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(2973),
    [sym_interpolation_verbatim_start] = ACTIONS(2973),
    [sym_interpolation_raw_start] = ACTIONS(2973),
  },
  [2208] = {
    [sym_preproc_region] = STATE(2208),
    [sym_preproc_endregion] = STATE(2208),
    [sym_preproc_line] = STATE(2208),
    [sym_preproc_pragma] = STATE(2208),
    [sym_preproc_nullable] = STATE(2208),
    [sym_preproc_error] = STATE(2208),
    [sym_preproc_define] = STATE(2208),
    [sym_preproc_undef] = STATE(2208),
    [sym__identifier_token] = ACTIONS(2975),
    [anon_sym_extern] = ACTIONS(2975),
    [anon_sym_alias] = ACTIONS(2975),
    [anon_sym_SEMI] = ACTIONS(2977),
    [anon_sym_global] = ACTIONS(2975),
    [anon_sym_using] = ACTIONS(2975),
    [anon_sym_unsafe] = ACTIONS(2975),
    [anon_sym_static] = ACTIONS(2975),
    [anon_sym_LBRACK] = ACTIONS(2977),
    [anon_sym_LPAREN] = ACTIONS(2977),
    [anon_sym_return] = ACTIONS(2975),
    [anon_sym_namespace] = ACTIONS(2975),
    [anon_sym_class] = ACTIONS(2975),
    [anon_sym_ref] = ACTIONS(2975),
    [anon_sym_struct] = ACTIONS(2975),
    [anon_sym_enum] = ACTIONS(2975),
    [anon_sym_LBRACE] = ACTIONS(2977),
    [anon_sym_interface] = ACTIONS(2975),
    [anon_sym_delegate] = ACTIONS(2975),
    [anon_sym_record] = ACTIONS(2975),
    [anon_sym_abstract] = ACTIONS(2975),
    [anon_sym_async] = ACTIONS(2975),
    [anon_sym_const] = ACTIONS(2975),
    [anon_sym_file] = ACTIONS(2975),
    [anon_sym_fixed] = ACTIONS(2975),
    [anon_sym_internal] = ACTIONS(2975),
    [anon_sym_new] = ACTIONS(2975),
    [anon_sym_override] = ACTIONS(2975),
    [anon_sym_partial] = ACTIONS(2975),
    [anon_sym_private] = ACTIONS(2975),
    [anon_sym_protected] = ACTIONS(2975),
    [anon_sym_public] = ACTIONS(2975),
    [anon_sym_readonly] = ACTIONS(2975),
    [anon_sym_required] = ACTIONS(2975),
    [anon_sym_sealed] = ACTIONS(2975),
    [anon_sym_virtual] = ACTIONS(2975),
    [anon_sym_volatile] = ACTIONS(2975),
    [anon_sym_where] = ACTIONS(2975),
    [anon_sym_notnull] = ACTIONS(2975),
    [anon_sym_unmanaged] = ACTIONS(2975),
    [anon_sym_checked] = ACTIONS(2975),
    [anon_sym_BANG] = ACTIONS(2977),
    [anon_sym_TILDE] = ACTIONS(2977),
    [anon_sym_PLUS_PLUS] = ACTIONS(2977),
    [anon_sym_DASH_DASH] = ACTIONS(2977),
    [anon_sym_true] = ACTIONS(2975),
    [anon_sym_false] = ACTIONS(2975),
    [anon_sym_PLUS] = ACTIONS(2975),
    [anon_sym_DASH] = ACTIONS(2975),
    [anon_sym_STAR] = ACTIONS(2977),
    [anon_sym_CARET] = ACTIONS(2977),
    [anon_sym_AMP] = ACTIONS(2977),
    [anon_sym_this] = ACTIONS(2975),
    [anon_sym_scoped] = ACTIONS(2975),
    [anon_sym_var] = ACTIONS(2975),
    [sym_predefined_type] = ACTIONS(2975),
    [anon_sym_break] = ACTIONS(2975),
    [anon_sym_unchecked] = ACTIONS(2975),
    [anon_sym_continue] = ACTIONS(2975),
    [anon_sym_do] = ACTIONS(2975),
    [anon_sym_while] = ACTIONS(2975),
    [anon_sym_for] = ACTIONS(2975),
    [anon_sym_lock] = ACTIONS(2975),
    [anon_sym_yield] = ACTIONS(2975),
    [anon_sym_switch] = ACTIONS(2975),
    [anon_sym_default] = ACTIONS(2975),
    [anon_sym_throw] = ACTIONS(2975),
    [anon_sym_try] = ACTIONS(2975),
    [anon_sym_catch] = ACTIONS(2975),
    [anon_sym_when] = ACTIONS(2975),
    [anon_sym_finally] = ACTIONS(2975),
    [anon_sym_await] = ACTIONS(2975),
    [anon_sym_foreach] = ACTIONS(2975),
    [anon_sym_goto] = ACTIONS(2975),
    [anon_sym_if] = ACTIONS(2975),
    [anon_sym_else] = ACTIONS(2975),
    [anon_sym_DOT_DOT] = ACTIONS(2977),
    [anon_sym_from] = ACTIONS(2975),
    [anon_sym_into] = ACTIONS(2975),
    [anon_sym_join] = ACTIONS(2975),
    [anon_sym_on] = ACTIONS(2975),
    [anon_sym_equals] = ACTIONS(2975),
    [anon_sym_let] = ACTIONS(2975),
    [anon_sym_orderby] = ACTIONS(2975),
    [anon_sym_ascending] = ACTIONS(2975),
    [anon_sym_descending] = ACTIONS(2975),
    [anon_sym_group] = ACTIONS(2975),
    [anon_sym_by] = ACTIONS(2975),
    [anon_sym_select] = ACTIONS(2975),
    [anon_sym_DQUOTE] = ACTIONS(2975),
    [anon_sym_stackalloc] = ACTIONS(2975),
    [anon_sym_sizeof] = ACTIONS(2975),
    [anon_sym_typeof] = ACTIONS(2975),
    [anon_sym___makeref] = ACTIONS(2975),
    [anon_sym___reftype] = ACTIONS(2975),
    [anon_sym___refvalue] = ACTIONS(2975),
    [sym_null_literal] = ACTIONS(2975),
    [anon_sym_SQUOTE] = ACTIONS(2977),
    [sym_integer_literal] = ACTIONS(2975),
    [sym_real_literal] = ACTIONS(2977),
    [sym_verbatim_string_literal] = ACTIONS(2977),
    [sym_raw_string_literal] = ACTIONS(2977),
    [aux_sym_preproc_if_token1] = ACTIONS(2977),
    [aux_sym_preproc_if_token3] = ACTIONS(2977),
    [aux_sym_preproc_else_token1] = ACTIONS(2977),
    [aux_sym_preproc_elif_token1] = ACTIONS(2977),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(2977),
    [sym_interpolation_verbatim_start] = ACTIONS(2977),
    [sym_interpolation_raw_start] = ACTIONS(2977),
  },
  [2209] = {
    [sym_preproc_region] = STATE(2209),
    [sym_preproc_endregion] = STATE(2209),
    [sym_preproc_line] = STATE(2209),
    [sym_preproc_pragma] = STATE(2209),
    [sym_preproc_nullable] = STATE(2209),
    [sym_preproc_error] = STATE(2209),
    [sym_preproc_define] = STATE(2209),
    [sym_preproc_undef] = STATE(2209),
    [sym__identifier_token] = ACTIONS(2979),
    [anon_sym_extern] = ACTIONS(2979),
    [anon_sym_alias] = ACTIONS(2979),
    [anon_sym_SEMI] = ACTIONS(2981),
    [anon_sym_global] = ACTIONS(2979),
    [anon_sym_using] = ACTIONS(2979),
    [anon_sym_unsafe] = ACTIONS(2979),
    [anon_sym_static] = ACTIONS(2979),
    [anon_sym_LBRACK] = ACTIONS(2981),
    [anon_sym_LPAREN] = ACTIONS(2981),
    [anon_sym_return] = ACTIONS(2979),
    [anon_sym_namespace] = ACTIONS(2979),
    [anon_sym_class] = ACTIONS(2979),
    [anon_sym_ref] = ACTIONS(2979),
    [anon_sym_struct] = ACTIONS(2979),
    [anon_sym_enum] = ACTIONS(2979),
    [anon_sym_LBRACE] = ACTIONS(2981),
    [anon_sym_interface] = ACTIONS(2979),
    [anon_sym_delegate] = ACTIONS(2979),
    [anon_sym_record] = ACTIONS(2979),
    [anon_sym_abstract] = ACTIONS(2979),
    [anon_sym_async] = ACTIONS(2979),
    [anon_sym_const] = ACTIONS(2979),
    [anon_sym_file] = ACTIONS(2979),
    [anon_sym_fixed] = ACTIONS(2979),
    [anon_sym_internal] = ACTIONS(2979),
    [anon_sym_new] = ACTIONS(2979),
    [anon_sym_override] = ACTIONS(2979),
    [anon_sym_partial] = ACTIONS(2979),
    [anon_sym_private] = ACTIONS(2979),
    [anon_sym_protected] = ACTIONS(2979),
    [anon_sym_public] = ACTIONS(2979),
    [anon_sym_readonly] = ACTIONS(2979),
    [anon_sym_required] = ACTIONS(2979),
    [anon_sym_sealed] = ACTIONS(2979),
    [anon_sym_virtual] = ACTIONS(2979),
    [anon_sym_volatile] = ACTIONS(2979),
    [anon_sym_where] = ACTIONS(2979),
    [anon_sym_notnull] = ACTIONS(2979),
    [anon_sym_unmanaged] = ACTIONS(2979),
    [anon_sym_checked] = ACTIONS(2979),
    [anon_sym_BANG] = ACTIONS(2981),
    [anon_sym_TILDE] = ACTIONS(2981),
    [anon_sym_PLUS_PLUS] = ACTIONS(2981),
    [anon_sym_DASH_DASH] = ACTIONS(2981),
    [anon_sym_true] = ACTIONS(2979),
    [anon_sym_false] = ACTIONS(2979),
    [anon_sym_PLUS] = ACTIONS(2979),
    [anon_sym_DASH] = ACTIONS(2979),
    [anon_sym_STAR] = ACTIONS(2981),
    [anon_sym_CARET] = ACTIONS(2981),
    [anon_sym_AMP] = ACTIONS(2981),
    [anon_sym_this] = ACTIONS(2979),
    [anon_sym_scoped] = ACTIONS(2979),
    [anon_sym_var] = ACTIONS(2979),
    [sym_predefined_type] = ACTIONS(2979),
    [anon_sym_break] = ACTIONS(2979),
    [anon_sym_unchecked] = ACTIONS(2979),
    [anon_sym_continue] = ACTIONS(2979),
    [anon_sym_do] = ACTIONS(2979),
    [anon_sym_while] = ACTIONS(2979),
    [anon_sym_for] = ACTIONS(2979),
    [anon_sym_lock] = ACTIONS(2979),
    [anon_sym_yield] = ACTIONS(2979),
    [anon_sym_switch] = ACTIONS(2979),
    [anon_sym_default] = ACTIONS(2979),
    [anon_sym_throw] = ACTIONS(2979),
    [anon_sym_try] = ACTIONS(2979),
    [anon_sym_catch] = ACTIONS(2979),
    [anon_sym_when] = ACTIONS(2979),
    [anon_sym_finally] = ACTIONS(2979),
    [anon_sym_await] = ACTIONS(2979),
    [anon_sym_foreach] = ACTIONS(2979),
    [anon_sym_goto] = ACTIONS(2979),
    [anon_sym_if] = ACTIONS(2979),
    [anon_sym_else] = ACTIONS(2979),
    [anon_sym_DOT_DOT] = ACTIONS(2981),
    [anon_sym_from] = ACTIONS(2979),
    [anon_sym_into] = ACTIONS(2979),
    [anon_sym_join] = ACTIONS(2979),
    [anon_sym_on] = ACTIONS(2979),
    [anon_sym_equals] = ACTIONS(2979),
    [anon_sym_let] = ACTIONS(2979),
    [anon_sym_orderby] = ACTIONS(2979),
    [anon_sym_ascending] = ACTIONS(2979),
    [anon_sym_descending] = ACTIONS(2979),
    [anon_sym_group] = ACTIONS(2979),
    [anon_sym_by] = ACTIONS(2979),
    [anon_sym_select] = ACTIONS(2979),
    [anon_sym_DQUOTE] = ACTIONS(2979),
    [anon_sym_stackalloc] = ACTIONS(2979),
    [anon_sym_sizeof] = ACTIONS(2979),
    [anon_sym_typeof] = ACTIONS(2979),
    [anon_sym___makeref] = ACTIONS(2979),
    [anon_sym___reftype] = ACTIONS(2979),
    [anon_sym___refvalue] = ACTIONS(2979),
    [sym_null_literal] = ACTIONS(2979),
    [anon_sym_SQUOTE] = ACTIONS(2981),
    [sym_integer_literal] = ACTIONS(2979),
    [sym_real_literal] = ACTIONS(2981),
    [sym_verbatim_string_literal] = ACTIONS(2981),
    [sym_raw_string_literal] = ACTIONS(2981),
    [aux_sym_preproc_if_token1] = ACTIONS(2981),
    [aux_sym_preproc_if_token3] = ACTIONS(2981),
    [aux_sym_preproc_else_token1] = ACTIONS(2981),
    [aux_sym_preproc_elif_token1] = ACTIONS(2981),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(2981),
    [sym_interpolation_verbatim_start] = ACTIONS(2981),
    [sym_interpolation_raw_start] = ACTIONS(2981),
  },
  [2210] = {
    [sym_using_directive] = STATE(3272),
    [sym_attribute_list] = STATE(3753),
    [sym_namespace_declaration] = STATE(3272),
    [sym_class_declaration] = STATE(3272),
    [sym_struct_declaration] = STATE(3272),
    [sym_enum_declaration] = STATE(3272),
    [sym_interface_declaration] = STATE(3272),
    [sym_delegate_declaration] = STATE(3272),
    [sym_record_declaration] = STATE(3272),
    [sym_modifier] = STATE(3780),
    [sym_operator_declaration] = STATE(3272),
    [sym_conversion_operator_declaration] = STATE(3272),
    [sym_declaration] = STATE(3284),
    [sym_field_declaration] = STATE(3272),
    [sym_constructor_declaration] = STATE(3272),
    [sym_destructor_declaration] = STATE(3272),
    [sym_method_declaration] = STATE(3272),
    [sym_event_declaration] = STATE(3272),
    [sym_event_field_declaration] = STATE(3272),
    [sym_indexer_declaration] = STATE(3272),
    [sym_property_declaration] = STATE(3272),
    [sym_variable_declaration] = STATE(9222),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(6306),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_identifier] = STATE(6719),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_if] = STATE(3272),
    [sym_preproc_else] = STATE(9638),
    [sym_preproc_elif] = STATE(9638),
    [sym_preproc_region] = STATE(2210),
    [sym_preproc_endregion] = STATE(2210),
    [sym_preproc_line] = STATE(2210),
    [sym_preproc_pragma] = STATE(2210),
    [sym_preproc_nullable] = STATE(2210),
    [sym_preproc_error] = STATE(2210),
    [sym_preproc_define] = STATE(2210),
    [sym_preproc_undef] = STATE(2210),
    [aux_sym_class_declaration_repeat1] = STATE(2782),
    [aux_sym_class_declaration_repeat2] = STATE(2834),
    [aux_sym_declaration_list_repeat1] = STATE(2233),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_extern] = ACTIONS(2985),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2989),
    [anon_sym_using] = ACTIONS(2991),
    [anon_sym_unsafe] = ACTIONS(63),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_LBRACK] = ACTIONS(2993),
    [anon_sym_LPAREN] = ACTIONS(2995),
    [anon_sym_event] = ACTIONS(2997),
    [anon_sym_namespace] = ACTIONS(2999),
    [anon_sym_class] = ACTIONS(3001),
    [anon_sym_ref] = ACTIONS(3003),
    [anon_sym_struct] = ACTIONS(3005),
    [anon_sym_enum] = ACTIONS(3007),
    [anon_sym_interface] = ACTIONS(3009),
    [anon_sym_delegate] = ACTIONS(3011),
    [anon_sym_record] = ACTIONS(3013),
    [anon_sym_abstract] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_file] = ACTIONS(3015),
    [anon_sym_fixed] = ACTIONS(63),
    [anon_sym_internal] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(63),
    [anon_sym_override] = ACTIONS(63),
    [anon_sym_partial] = ACTIONS(63),
    [anon_sym_private] = ACTIONS(63),
    [anon_sym_protected] = ACTIONS(63),
    [anon_sym_public] = ACTIONS(63),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_required] = ACTIONS(63),
    [anon_sym_sealed] = ACTIONS(63),
    [anon_sym_virtual] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_TILDE] = ACTIONS(3017),
    [anon_sym_implicit] = ACTIONS(3019),
    [anon_sym_explicit] = ACTIONS(3019),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_if_token1] = ACTIONS(3027),
    [aux_sym_preproc_if_token3] = ACTIONS(3029),
    [aux_sym_preproc_else_token1] = ACTIONS(3031),
    [aux_sym_preproc_elif_token1] = ACTIONS(3033),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2211] = {
    [sym_using_directive] = STATE(3272),
    [sym_attribute_list] = STATE(3753),
    [sym_namespace_declaration] = STATE(3272),
    [sym_class_declaration] = STATE(3272),
    [sym_struct_declaration] = STATE(3272),
    [sym_enum_declaration] = STATE(3272),
    [sym_interface_declaration] = STATE(3272),
    [sym_delegate_declaration] = STATE(3272),
    [sym_record_declaration] = STATE(3272),
    [sym_modifier] = STATE(3780),
    [sym_operator_declaration] = STATE(3272),
    [sym_conversion_operator_declaration] = STATE(3272),
    [sym_declaration] = STATE(3284),
    [sym_field_declaration] = STATE(3272),
    [sym_constructor_declaration] = STATE(3272),
    [sym_destructor_declaration] = STATE(3272),
    [sym_method_declaration] = STATE(3272),
    [sym_event_declaration] = STATE(3272),
    [sym_event_field_declaration] = STATE(3272),
    [sym_indexer_declaration] = STATE(3272),
    [sym_property_declaration] = STATE(3272),
    [sym_variable_declaration] = STATE(9222),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(6306),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_identifier] = STATE(6719),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_if] = STATE(3272),
    [sym_preproc_else] = STATE(9885),
    [sym_preproc_elif] = STATE(9885),
    [sym_preproc_region] = STATE(2211),
    [sym_preproc_endregion] = STATE(2211),
    [sym_preproc_line] = STATE(2211),
    [sym_preproc_pragma] = STATE(2211),
    [sym_preproc_nullable] = STATE(2211),
    [sym_preproc_error] = STATE(2211),
    [sym_preproc_define] = STATE(2211),
    [sym_preproc_undef] = STATE(2211),
    [aux_sym_class_declaration_repeat1] = STATE(2782),
    [aux_sym_class_declaration_repeat2] = STATE(2834),
    [aux_sym_declaration_list_repeat1] = STATE(2213),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_extern] = ACTIONS(2985),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2989),
    [anon_sym_using] = ACTIONS(2991),
    [anon_sym_unsafe] = ACTIONS(63),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_LBRACK] = ACTIONS(2993),
    [anon_sym_LPAREN] = ACTIONS(2995),
    [anon_sym_event] = ACTIONS(2997),
    [anon_sym_namespace] = ACTIONS(2999),
    [anon_sym_class] = ACTIONS(3001),
    [anon_sym_ref] = ACTIONS(3003),
    [anon_sym_struct] = ACTIONS(3005),
    [anon_sym_enum] = ACTIONS(3007),
    [anon_sym_interface] = ACTIONS(3009),
    [anon_sym_delegate] = ACTIONS(3011),
    [anon_sym_record] = ACTIONS(3013),
    [anon_sym_abstract] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_file] = ACTIONS(3015),
    [anon_sym_fixed] = ACTIONS(63),
    [anon_sym_internal] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(63),
    [anon_sym_override] = ACTIONS(63),
    [anon_sym_partial] = ACTIONS(63),
    [anon_sym_private] = ACTIONS(63),
    [anon_sym_protected] = ACTIONS(63),
    [anon_sym_public] = ACTIONS(63),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_required] = ACTIONS(63),
    [anon_sym_sealed] = ACTIONS(63),
    [anon_sym_virtual] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_TILDE] = ACTIONS(3017),
    [anon_sym_implicit] = ACTIONS(3019),
    [anon_sym_explicit] = ACTIONS(3019),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_if_token1] = ACTIONS(3027),
    [aux_sym_preproc_if_token3] = ACTIONS(3035),
    [aux_sym_preproc_else_token1] = ACTIONS(3031),
    [aux_sym_preproc_elif_token1] = ACTIONS(3033),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2212] = {
    [sym_using_directive] = STATE(3272),
    [sym_attribute_list] = STATE(3753),
    [sym_namespace_declaration] = STATE(3272),
    [sym_class_declaration] = STATE(3272),
    [sym_struct_declaration] = STATE(3272),
    [sym_enum_declaration] = STATE(3272),
    [sym_interface_declaration] = STATE(3272),
    [sym_delegate_declaration] = STATE(3272),
    [sym_record_declaration] = STATE(3272),
    [sym_modifier] = STATE(3780),
    [sym_operator_declaration] = STATE(3272),
    [sym_conversion_operator_declaration] = STATE(3272),
    [sym_declaration] = STATE(3284),
    [sym_field_declaration] = STATE(3272),
    [sym_constructor_declaration] = STATE(3272),
    [sym_destructor_declaration] = STATE(3272),
    [sym_method_declaration] = STATE(3272),
    [sym_event_declaration] = STATE(3272),
    [sym_event_field_declaration] = STATE(3272),
    [sym_indexer_declaration] = STATE(3272),
    [sym_property_declaration] = STATE(3272),
    [sym_variable_declaration] = STATE(9222),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(6306),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_identifier] = STATE(6719),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_if] = STATE(3272),
    [sym_preproc_else] = STATE(9202),
    [sym_preproc_elif] = STATE(9202),
    [sym_preproc_region] = STATE(2212),
    [sym_preproc_endregion] = STATE(2212),
    [sym_preproc_line] = STATE(2212),
    [sym_preproc_pragma] = STATE(2212),
    [sym_preproc_nullable] = STATE(2212),
    [sym_preproc_error] = STATE(2212),
    [sym_preproc_define] = STATE(2212),
    [sym_preproc_undef] = STATE(2212),
    [aux_sym_class_declaration_repeat1] = STATE(2782),
    [aux_sym_class_declaration_repeat2] = STATE(2834),
    [aux_sym_declaration_list_repeat1] = STATE(2210),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_extern] = ACTIONS(2985),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2989),
    [anon_sym_using] = ACTIONS(2991),
    [anon_sym_unsafe] = ACTIONS(63),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_LBRACK] = ACTIONS(2993),
    [anon_sym_LPAREN] = ACTIONS(2995),
    [anon_sym_event] = ACTIONS(2997),
    [anon_sym_namespace] = ACTIONS(2999),
    [anon_sym_class] = ACTIONS(3001),
    [anon_sym_ref] = ACTIONS(3003),
    [anon_sym_struct] = ACTIONS(3005),
    [anon_sym_enum] = ACTIONS(3007),
    [anon_sym_interface] = ACTIONS(3009),
    [anon_sym_delegate] = ACTIONS(3011),
    [anon_sym_record] = ACTIONS(3013),
    [anon_sym_abstract] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_file] = ACTIONS(3015),
    [anon_sym_fixed] = ACTIONS(63),
    [anon_sym_internal] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(63),
    [anon_sym_override] = ACTIONS(63),
    [anon_sym_partial] = ACTIONS(63),
    [anon_sym_private] = ACTIONS(63),
    [anon_sym_protected] = ACTIONS(63),
    [anon_sym_public] = ACTIONS(63),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_required] = ACTIONS(63),
    [anon_sym_sealed] = ACTIONS(63),
    [anon_sym_virtual] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_TILDE] = ACTIONS(3017),
    [anon_sym_implicit] = ACTIONS(3019),
    [anon_sym_explicit] = ACTIONS(3019),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_if_token1] = ACTIONS(3027),
    [aux_sym_preproc_if_token3] = ACTIONS(3037),
    [aux_sym_preproc_else_token1] = ACTIONS(3031),
    [aux_sym_preproc_elif_token1] = ACTIONS(3033),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2213] = {
    [sym_using_directive] = STATE(3272),
    [sym_attribute_list] = STATE(3753),
    [sym_namespace_declaration] = STATE(3272),
    [sym_class_declaration] = STATE(3272),
    [sym_struct_declaration] = STATE(3272),
    [sym_enum_declaration] = STATE(3272),
    [sym_interface_declaration] = STATE(3272),
    [sym_delegate_declaration] = STATE(3272),
    [sym_record_declaration] = STATE(3272),
    [sym_modifier] = STATE(3780),
    [sym_operator_declaration] = STATE(3272),
    [sym_conversion_operator_declaration] = STATE(3272),
    [sym_declaration] = STATE(3284),
    [sym_field_declaration] = STATE(3272),
    [sym_constructor_declaration] = STATE(3272),
    [sym_destructor_declaration] = STATE(3272),
    [sym_method_declaration] = STATE(3272),
    [sym_event_declaration] = STATE(3272),
    [sym_event_field_declaration] = STATE(3272),
    [sym_indexer_declaration] = STATE(3272),
    [sym_property_declaration] = STATE(3272),
    [sym_variable_declaration] = STATE(9222),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(6306),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_identifier] = STATE(6719),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_if] = STATE(3272),
    [sym_preproc_else] = STATE(9657),
    [sym_preproc_elif] = STATE(9657),
    [sym_preproc_region] = STATE(2213),
    [sym_preproc_endregion] = STATE(2213),
    [sym_preproc_line] = STATE(2213),
    [sym_preproc_pragma] = STATE(2213),
    [sym_preproc_nullable] = STATE(2213),
    [sym_preproc_error] = STATE(2213),
    [sym_preproc_define] = STATE(2213),
    [sym_preproc_undef] = STATE(2213),
    [aux_sym_class_declaration_repeat1] = STATE(2782),
    [aux_sym_class_declaration_repeat2] = STATE(2834),
    [aux_sym_declaration_list_repeat1] = STATE(2233),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_extern] = ACTIONS(2985),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2989),
    [anon_sym_using] = ACTIONS(2991),
    [anon_sym_unsafe] = ACTIONS(63),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_LBRACK] = ACTIONS(2993),
    [anon_sym_LPAREN] = ACTIONS(2995),
    [anon_sym_event] = ACTIONS(2997),
    [anon_sym_namespace] = ACTIONS(2999),
    [anon_sym_class] = ACTIONS(3001),
    [anon_sym_ref] = ACTIONS(3003),
    [anon_sym_struct] = ACTIONS(3005),
    [anon_sym_enum] = ACTIONS(3007),
    [anon_sym_interface] = ACTIONS(3009),
    [anon_sym_delegate] = ACTIONS(3011),
    [anon_sym_record] = ACTIONS(3013),
    [anon_sym_abstract] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_file] = ACTIONS(3015),
    [anon_sym_fixed] = ACTIONS(63),
    [anon_sym_internal] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(63),
    [anon_sym_override] = ACTIONS(63),
    [anon_sym_partial] = ACTIONS(63),
    [anon_sym_private] = ACTIONS(63),
    [anon_sym_protected] = ACTIONS(63),
    [anon_sym_public] = ACTIONS(63),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_required] = ACTIONS(63),
    [anon_sym_sealed] = ACTIONS(63),
    [anon_sym_virtual] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_TILDE] = ACTIONS(3017),
    [anon_sym_implicit] = ACTIONS(3019),
    [anon_sym_explicit] = ACTIONS(3019),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_if_token1] = ACTIONS(3027),
    [aux_sym_preproc_if_token3] = ACTIONS(3039),
    [aux_sym_preproc_else_token1] = ACTIONS(3031),
    [aux_sym_preproc_elif_token1] = ACTIONS(3033),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2214] = {
    [sym_preproc_region] = STATE(2214),
    [sym_preproc_endregion] = STATE(2214),
    [sym_preproc_line] = STATE(2214),
    [sym_preproc_pragma] = STATE(2214),
    [sym_preproc_nullable] = STATE(2214),
    [sym_preproc_error] = STATE(2214),
    [sym_preproc_define] = STATE(2214),
    [sym_preproc_undef] = STATE(2214),
    [sym__identifier_token] = ACTIONS(3041),
    [anon_sym_extern] = ACTIONS(3041),
    [anon_sym_alias] = ACTIONS(3041),
    [anon_sym_SEMI] = ACTIONS(3043),
    [anon_sym_global] = ACTIONS(3041),
    [anon_sym_using] = ACTIONS(3041),
    [anon_sym_unsafe] = ACTIONS(3041),
    [anon_sym_static] = ACTIONS(3041),
    [anon_sym_LBRACK] = ACTIONS(3043),
    [anon_sym_LPAREN] = ACTIONS(3043),
    [anon_sym_return] = ACTIONS(3041),
    [anon_sym_namespace] = ACTIONS(3041),
    [anon_sym_class] = ACTIONS(3041),
    [anon_sym_ref] = ACTIONS(3041),
    [anon_sym_struct] = ACTIONS(3041),
    [anon_sym_enum] = ACTIONS(3041),
    [anon_sym_LBRACE] = ACTIONS(3043),
    [anon_sym_interface] = ACTIONS(3041),
    [anon_sym_delegate] = ACTIONS(3041),
    [anon_sym_record] = ACTIONS(3041),
    [anon_sym_abstract] = ACTIONS(3041),
    [anon_sym_async] = ACTIONS(3041),
    [anon_sym_const] = ACTIONS(3041),
    [anon_sym_file] = ACTIONS(3041),
    [anon_sym_fixed] = ACTIONS(3041),
    [anon_sym_internal] = ACTIONS(3041),
    [anon_sym_new] = ACTIONS(3041),
    [anon_sym_override] = ACTIONS(3041),
    [anon_sym_partial] = ACTIONS(3041),
    [anon_sym_private] = ACTIONS(3041),
    [anon_sym_protected] = ACTIONS(3041),
    [anon_sym_public] = ACTIONS(3041),
    [anon_sym_readonly] = ACTIONS(3041),
    [anon_sym_required] = ACTIONS(3041),
    [anon_sym_sealed] = ACTIONS(3041),
    [anon_sym_virtual] = ACTIONS(3041),
    [anon_sym_volatile] = ACTIONS(3041),
    [anon_sym_where] = ACTIONS(3041),
    [anon_sym_notnull] = ACTIONS(3041),
    [anon_sym_unmanaged] = ACTIONS(3041),
    [anon_sym_checked] = ACTIONS(3041),
    [anon_sym_BANG] = ACTIONS(3043),
    [anon_sym_TILDE] = ACTIONS(3043),
    [anon_sym_PLUS_PLUS] = ACTIONS(3043),
    [anon_sym_DASH_DASH] = ACTIONS(3043),
    [anon_sym_true] = ACTIONS(3041),
    [anon_sym_false] = ACTIONS(3041),
    [anon_sym_PLUS] = ACTIONS(3041),
    [anon_sym_DASH] = ACTIONS(3041),
    [anon_sym_STAR] = ACTIONS(3043),
    [anon_sym_CARET] = ACTIONS(3043),
    [anon_sym_AMP] = ACTIONS(3043),
    [anon_sym_this] = ACTIONS(3041),
    [anon_sym_scoped] = ACTIONS(3041),
    [anon_sym_var] = ACTIONS(3041),
    [sym_predefined_type] = ACTIONS(3041),
    [anon_sym_break] = ACTIONS(3041),
    [anon_sym_unchecked] = ACTIONS(3041),
    [anon_sym_continue] = ACTIONS(3041),
    [anon_sym_do] = ACTIONS(3041),
    [anon_sym_while] = ACTIONS(3041),
    [anon_sym_for] = ACTIONS(3041),
    [anon_sym_lock] = ACTIONS(3041),
    [anon_sym_yield] = ACTIONS(3041),
    [anon_sym_switch] = ACTIONS(3041),
    [anon_sym_default] = ACTIONS(3041),
    [anon_sym_throw] = ACTIONS(3041),
    [anon_sym_try] = ACTIONS(3041),
    [anon_sym_when] = ACTIONS(3041),
    [anon_sym_await] = ACTIONS(3041),
    [anon_sym_foreach] = ACTIONS(3041),
    [anon_sym_goto] = ACTIONS(3041),
    [anon_sym_if] = ACTIONS(3041),
    [anon_sym_else] = ACTIONS(3041),
    [anon_sym_DOT_DOT] = ACTIONS(3043),
    [anon_sym_from] = ACTIONS(3041),
    [anon_sym_into] = ACTIONS(3041),
    [anon_sym_join] = ACTIONS(3041),
    [anon_sym_on] = ACTIONS(3041),
    [anon_sym_equals] = ACTIONS(3041),
    [anon_sym_let] = ACTIONS(3041),
    [anon_sym_orderby] = ACTIONS(3041),
    [anon_sym_ascending] = ACTIONS(3041),
    [anon_sym_descending] = ACTIONS(3041),
    [anon_sym_group] = ACTIONS(3041),
    [anon_sym_by] = ACTIONS(3041),
    [anon_sym_select] = ACTIONS(3041),
    [anon_sym_DQUOTE] = ACTIONS(3041),
    [anon_sym_stackalloc] = ACTIONS(3041),
    [anon_sym_sizeof] = ACTIONS(3041),
    [anon_sym_typeof] = ACTIONS(3041),
    [anon_sym___makeref] = ACTIONS(3041),
    [anon_sym___reftype] = ACTIONS(3041),
    [anon_sym___refvalue] = ACTIONS(3041),
    [sym_null_literal] = ACTIONS(3041),
    [anon_sym_SQUOTE] = ACTIONS(3043),
    [sym_integer_literal] = ACTIONS(3041),
    [sym_real_literal] = ACTIONS(3043),
    [sym_verbatim_string_literal] = ACTIONS(3043),
    [sym_raw_string_literal] = ACTIONS(3043),
    [aux_sym_preproc_if_token1] = ACTIONS(3043),
    [aux_sym_preproc_if_token3] = ACTIONS(3043),
    [aux_sym_preproc_else_token1] = ACTIONS(3043),
    [aux_sym_preproc_elif_token1] = ACTIONS(3043),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3043),
    [sym_interpolation_verbatim_start] = ACTIONS(3043),
    [sym_interpolation_raw_start] = ACTIONS(3043),
  },
  [2215] = {
    [sym_preproc_region] = STATE(2215),
    [sym_preproc_endregion] = STATE(2215),
    [sym_preproc_line] = STATE(2215),
    [sym_preproc_pragma] = STATE(2215),
    [sym_preproc_nullable] = STATE(2215),
    [sym_preproc_error] = STATE(2215),
    [sym_preproc_define] = STATE(2215),
    [sym_preproc_undef] = STATE(2215),
    [sym__identifier_token] = ACTIONS(3045),
    [anon_sym_extern] = ACTIONS(3045),
    [anon_sym_alias] = ACTIONS(3045),
    [anon_sym_SEMI] = ACTIONS(3047),
    [anon_sym_global] = ACTIONS(3045),
    [anon_sym_using] = ACTIONS(3045),
    [anon_sym_unsafe] = ACTIONS(3045),
    [anon_sym_static] = ACTIONS(3045),
    [anon_sym_LBRACK] = ACTIONS(3047),
    [anon_sym_LPAREN] = ACTIONS(3047),
    [anon_sym_return] = ACTIONS(3045),
    [anon_sym_namespace] = ACTIONS(3045),
    [anon_sym_class] = ACTIONS(3045),
    [anon_sym_ref] = ACTIONS(3045),
    [anon_sym_struct] = ACTIONS(3045),
    [anon_sym_enum] = ACTIONS(3045),
    [anon_sym_LBRACE] = ACTIONS(3047),
    [anon_sym_interface] = ACTIONS(3045),
    [anon_sym_delegate] = ACTIONS(3045),
    [anon_sym_record] = ACTIONS(3045),
    [anon_sym_abstract] = ACTIONS(3045),
    [anon_sym_async] = ACTIONS(3045),
    [anon_sym_const] = ACTIONS(3045),
    [anon_sym_file] = ACTIONS(3045),
    [anon_sym_fixed] = ACTIONS(3045),
    [anon_sym_internal] = ACTIONS(3045),
    [anon_sym_new] = ACTIONS(3045),
    [anon_sym_override] = ACTIONS(3045),
    [anon_sym_partial] = ACTIONS(3045),
    [anon_sym_private] = ACTIONS(3045),
    [anon_sym_protected] = ACTIONS(3045),
    [anon_sym_public] = ACTIONS(3045),
    [anon_sym_readonly] = ACTIONS(3045),
    [anon_sym_required] = ACTIONS(3045),
    [anon_sym_sealed] = ACTIONS(3045),
    [anon_sym_virtual] = ACTIONS(3045),
    [anon_sym_volatile] = ACTIONS(3045),
    [anon_sym_where] = ACTIONS(3045),
    [anon_sym_notnull] = ACTIONS(3045),
    [anon_sym_unmanaged] = ACTIONS(3045),
    [anon_sym_checked] = ACTIONS(3045),
    [anon_sym_BANG] = ACTIONS(3047),
    [anon_sym_TILDE] = ACTIONS(3047),
    [anon_sym_PLUS_PLUS] = ACTIONS(3047),
    [anon_sym_DASH_DASH] = ACTIONS(3047),
    [anon_sym_true] = ACTIONS(3045),
    [anon_sym_false] = ACTIONS(3045),
    [anon_sym_PLUS] = ACTIONS(3045),
    [anon_sym_DASH] = ACTIONS(3045),
    [anon_sym_STAR] = ACTIONS(3047),
    [anon_sym_CARET] = ACTIONS(3047),
    [anon_sym_AMP] = ACTIONS(3047),
    [anon_sym_this] = ACTIONS(3045),
    [anon_sym_scoped] = ACTIONS(3045),
    [anon_sym_var] = ACTIONS(3045),
    [sym_predefined_type] = ACTIONS(3045),
    [anon_sym_break] = ACTIONS(3045),
    [anon_sym_unchecked] = ACTIONS(3045),
    [anon_sym_continue] = ACTIONS(3045),
    [anon_sym_do] = ACTIONS(3045),
    [anon_sym_while] = ACTIONS(3045),
    [anon_sym_for] = ACTIONS(3045),
    [anon_sym_lock] = ACTIONS(3045),
    [anon_sym_yield] = ACTIONS(3045),
    [anon_sym_switch] = ACTIONS(3045),
    [anon_sym_default] = ACTIONS(3045),
    [anon_sym_throw] = ACTIONS(3045),
    [anon_sym_try] = ACTIONS(3045),
    [anon_sym_when] = ACTIONS(3045),
    [anon_sym_await] = ACTIONS(3045),
    [anon_sym_foreach] = ACTIONS(3045),
    [anon_sym_goto] = ACTIONS(3045),
    [anon_sym_if] = ACTIONS(3045),
    [anon_sym_else] = ACTIONS(3045),
    [anon_sym_DOT_DOT] = ACTIONS(3047),
    [anon_sym_from] = ACTIONS(3045),
    [anon_sym_into] = ACTIONS(3045),
    [anon_sym_join] = ACTIONS(3045),
    [anon_sym_on] = ACTIONS(3045),
    [anon_sym_equals] = ACTIONS(3045),
    [anon_sym_let] = ACTIONS(3045),
    [anon_sym_orderby] = ACTIONS(3045),
    [anon_sym_ascending] = ACTIONS(3045),
    [anon_sym_descending] = ACTIONS(3045),
    [anon_sym_group] = ACTIONS(3045),
    [anon_sym_by] = ACTIONS(3045),
    [anon_sym_select] = ACTIONS(3045),
    [anon_sym_DQUOTE] = ACTIONS(3045),
    [anon_sym_stackalloc] = ACTIONS(3045),
    [anon_sym_sizeof] = ACTIONS(3045),
    [anon_sym_typeof] = ACTIONS(3045),
    [anon_sym___makeref] = ACTIONS(3045),
    [anon_sym___reftype] = ACTIONS(3045),
    [anon_sym___refvalue] = ACTIONS(3045),
    [sym_null_literal] = ACTIONS(3045),
    [anon_sym_SQUOTE] = ACTIONS(3047),
    [sym_integer_literal] = ACTIONS(3045),
    [sym_real_literal] = ACTIONS(3047),
    [sym_verbatim_string_literal] = ACTIONS(3047),
    [sym_raw_string_literal] = ACTIONS(3047),
    [aux_sym_preproc_if_token1] = ACTIONS(3047),
    [aux_sym_preproc_if_token3] = ACTIONS(3047),
    [aux_sym_preproc_else_token1] = ACTIONS(3047),
    [aux_sym_preproc_elif_token1] = ACTIONS(3047),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3047),
    [sym_interpolation_verbatim_start] = ACTIONS(3047),
    [sym_interpolation_raw_start] = ACTIONS(3047),
  },
  [2216] = {
    [sym_preproc_region] = STATE(2216),
    [sym_preproc_endregion] = STATE(2216),
    [sym_preproc_line] = STATE(2216),
    [sym_preproc_pragma] = STATE(2216),
    [sym_preproc_nullable] = STATE(2216),
    [sym_preproc_error] = STATE(2216),
    [sym_preproc_define] = STATE(2216),
    [sym_preproc_undef] = STATE(2216),
    [sym__identifier_token] = ACTIONS(3049),
    [anon_sym_extern] = ACTIONS(3049),
    [anon_sym_alias] = ACTIONS(3049),
    [anon_sym_SEMI] = ACTIONS(3051),
    [anon_sym_global] = ACTIONS(3049),
    [anon_sym_using] = ACTIONS(3049),
    [anon_sym_unsafe] = ACTIONS(3049),
    [anon_sym_static] = ACTIONS(3049),
    [anon_sym_LBRACK] = ACTIONS(3051),
    [anon_sym_LPAREN] = ACTIONS(3051),
    [anon_sym_return] = ACTIONS(3049),
    [anon_sym_namespace] = ACTIONS(3049),
    [anon_sym_class] = ACTIONS(3049),
    [anon_sym_ref] = ACTIONS(3049),
    [anon_sym_struct] = ACTIONS(3049),
    [anon_sym_enum] = ACTIONS(3049),
    [anon_sym_LBRACE] = ACTIONS(3051),
    [anon_sym_interface] = ACTIONS(3049),
    [anon_sym_delegate] = ACTIONS(3049),
    [anon_sym_record] = ACTIONS(3049),
    [anon_sym_abstract] = ACTIONS(3049),
    [anon_sym_async] = ACTIONS(3049),
    [anon_sym_const] = ACTIONS(3049),
    [anon_sym_file] = ACTIONS(3049),
    [anon_sym_fixed] = ACTIONS(3049),
    [anon_sym_internal] = ACTIONS(3049),
    [anon_sym_new] = ACTIONS(3049),
    [anon_sym_override] = ACTIONS(3049),
    [anon_sym_partial] = ACTIONS(3049),
    [anon_sym_private] = ACTIONS(3049),
    [anon_sym_protected] = ACTIONS(3049),
    [anon_sym_public] = ACTIONS(3049),
    [anon_sym_readonly] = ACTIONS(3049),
    [anon_sym_required] = ACTIONS(3049),
    [anon_sym_sealed] = ACTIONS(3049),
    [anon_sym_virtual] = ACTIONS(3049),
    [anon_sym_volatile] = ACTIONS(3049),
    [anon_sym_where] = ACTIONS(3049),
    [anon_sym_notnull] = ACTIONS(3049),
    [anon_sym_unmanaged] = ACTIONS(3049),
    [anon_sym_checked] = ACTIONS(3049),
    [anon_sym_BANG] = ACTIONS(3051),
    [anon_sym_TILDE] = ACTIONS(3051),
    [anon_sym_PLUS_PLUS] = ACTIONS(3051),
    [anon_sym_DASH_DASH] = ACTIONS(3051),
    [anon_sym_true] = ACTIONS(3049),
    [anon_sym_false] = ACTIONS(3049),
    [anon_sym_PLUS] = ACTIONS(3049),
    [anon_sym_DASH] = ACTIONS(3049),
    [anon_sym_STAR] = ACTIONS(3051),
    [anon_sym_CARET] = ACTIONS(3051),
    [anon_sym_AMP] = ACTIONS(3051),
    [anon_sym_this] = ACTIONS(3049),
    [anon_sym_scoped] = ACTIONS(3049),
    [anon_sym_var] = ACTIONS(3049),
    [sym_predefined_type] = ACTIONS(3049),
    [anon_sym_break] = ACTIONS(3049),
    [anon_sym_unchecked] = ACTIONS(3049),
    [anon_sym_continue] = ACTIONS(3049),
    [anon_sym_do] = ACTIONS(3049),
    [anon_sym_while] = ACTIONS(3049),
    [anon_sym_for] = ACTIONS(3049),
    [anon_sym_lock] = ACTIONS(3049),
    [anon_sym_yield] = ACTIONS(3049),
    [anon_sym_switch] = ACTIONS(3049),
    [anon_sym_default] = ACTIONS(3049),
    [anon_sym_throw] = ACTIONS(3049),
    [anon_sym_try] = ACTIONS(3049),
    [anon_sym_when] = ACTIONS(3049),
    [anon_sym_await] = ACTIONS(3049),
    [anon_sym_foreach] = ACTIONS(3049),
    [anon_sym_goto] = ACTIONS(3049),
    [anon_sym_if] = ACTIONS(3049),
    [anon_sym_else] = ACTIONS(3049),
    [anon_sym_DOT_DOT] = ACTIONS(3051),
    [anon_sym_from] = ACTIONS(3049),
    [anon_sym_into] = ACTIONS(3049),
    [anon_sym_join] = ACTIONS(3049),
    [anon_sym_on] = ACTIONS(3049),
    [anon_sym_equals] = ACTIONS(3049),
    [anon_sym_let] = ACTIONS(3049),
    [anon_sym_orderby] = ACTIONS(3049),
    [anon_sym_ascending] = ACTIONS(3049),
    [anon_sym_descending] = ACTIONS(3049),
    [anon_sym_group] = ACTIONS(3049),
    [anon_sym_by] = ACTIONS(3049),
    [anon_sym_select] = ACTIONS(3049),
    [anon_sym_DQUOTE] = ACTIONS(3049),
    [anon_sym_stackalloc] = ACTIONS(3049),
    [anon_sym_sizeof] = ACTIONS(3049),
    [anon_sym_typeof] = ACTIONS(3049),
    [anon_sym___makeref] = ACTIONS(3049),
    [anon_sym___reftype] = ACTIONS(3049),
    [anon_sym___refvalue] = ACTIONS(3049),
    [sym_null_literal] = ACTIONS(3049),
    [anon_sym_SQUOTE] = ACTIONS(3051),
    [sym_integer_literal] = ACTIONS(3049),
    [sym_real_literal] = ACTIONS(3051),
    [sym_verbatim_string_literal] = ACTIONS(3051),
    [sym_raw_string_literal] = ACTIONS(3051),
    [aux_sym_preproc_if_token1] = ACTIONS(3051),
    [aux_sym_preproc_if_token3] = ACTIONS(3051),
    [aux_sym_preproc_else_token1] = ACTIONS(3051),
    [aux_sym_preproc_elif_token1] = ACTIONS(3051),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3051),
    [sym_interpolation_verbatim_start] = ACTIONS(3051),
    [sym_interpolation_raw_start] = ACTIONS(3051),
  },
  [2217] = {
    [sym_preproc_region] = STATE(2217),
    [sym_preproc_endregion] = STATE(2217),
    [sym_preproc_line] = STATE(2217),
    [sym_preproc_pragma] = STATE(2217),
    [sym_preproc_nullable] = STATE(2217),
    [sym_preproc_error] = STATE(2217),
    [sym_preproc_define] = STATE(2217),
    [sym_preproc_undef] = STATE(2217),
    [sym__identifier_token] = ACTIONS(3053),
    [anon_sym_extern] = ACTIONS(3053),
    [anon_sym_alias] = ACTIONS(3053),
    [anon_sym_SEMI] = ACTIONS(3055),
    [anon_sym_global] = ACTIONS(3053),
    [anon_sym_using] = ACTIONS(3053),
    [anon_sym_unsafe] = ACTIONS(3053),
    [anon_sym_static] = ACTIONS(3053),
    [anon_sym_LBRACK] = ACTIONS(3055),
    [anon_sym_LPAREN] = ACTIONS(3055),
    [anon_sym_return] = ACTIONS(3053),
    [anon_sym_namespace] = ACTIONS(3053),
    [anon_sym_class] = ACTIONS(3053),
    [anon_sym_ref] = ACTIONS(3053),
    [anon_sym_struct] = ACTIONS(3053),
    [anon_sym_enum] = ACTIONS(3053),
    [anon_sym_LBRACE] = ACTIONS(3055),
    [anon_sym_interface] = ACTIONS(3053),
    [anon_sym_delegate] = ACTIONS(3053),
    [anon_sym_record] = ACTIONS(3053),
    [anon_sym_abstract] = ACTIONS(3053),
    [anon_sym_async] = ACTIONS(3053),
    [anon_sym_const] = ACTIONS(3053),
    [anon_sym_file] = ACTIONS(3053),
    [anon_sym_fixed] = ACTIONS(3053),
    [anon_sym_internal] = ACTIONS(3053),
    [anon_sym_new] = ACTIONS(3053),
    [anon_sym_override] = ACTIONS(3053),
    [anon_sym_partial] = ACTIONS(3053),
    [anon_sym_private] = ACTIONS(3053),
    [anon_sym_protected] = ACTIONS(3053),
    [anon_sym_public] = ACTIONS(3053),
    [anon_sym_readonly] = ACTIONS(3053),
    [anon_sym_required] = ACTIONS(3053),
    [anon_sym_sealed] = ACTIONS(3053),
    [anon_sym_virtual] = ACTIONS(3053),
    [anon_sym_volatile] = ACTIONS(3053),
    [anon_sym_where] = ACTIONS(3053),
    [anon_sym_notnull] = ACTIONS(3053),
    [anon_sym_unmanaged] = ACTIONS(3053),
    [anon_sym_checked] = ACTIONS(3053),
    [anon_sym_BANG] = ACTIONS(3055),
    [anon_sym_TILDE] = ACTIONS(3055),
    [anon_sym_PLUS_PLUS] = ACTIONS(3055),
    [anon_sym_DASH_DASH] = ACTIONS(3055),
    [anon_sym_true] = ACTIONS(3053),
    [anon_sym_false] = ACTIONS(3053),
    [anon_sym_PLUS] = ACTIONS(3053),
    [anon_sym_DASH] = ACTIONS(3053),
    [anon_sym_STAR] = ACTIONS(3055),
    [anon_sym_CARET] = ACTIONS(3055),
    [anon_sym_AMP] = ACTIONS(3055),
    [anon_sym_this] = ACTIONS(3053),
    [anon_sym_scoped] = ACTIONS(3053),
    [anon_sym_var] = ACTIONS(3053),
    [sym_predefined_type] = ACTIONS(3053),
    [anon_sym_break] = ACTIONS(3053),
    [anon_sym_unchecked] = ACTIONS(3053),
    [anon_sym_continue] = ACTIONS(3053),
    [anon_sym_do] = ACTIONS(3053),
    [anon_sym_while] = ACTIONS(3053),
    [anon_sym_for] = ACTIONS(3053),
    [anon_sym_lock] = ACTIONS(3053),
    [anon_sym_yield] = ACTIONS(3053),
    [anon_sym_switch] = ACTIONS(3053),
    [anon_sym_default] = ACTIONS(3053),
    [anon_sym_throw] = ACTIONS(3053),
    [anon_sym_try] = ACTIONS(3053),
    [anon_sym_when] = ACTIONS(3053),
    [anon_sym_await] = ACTIONS(3053),
    [anon_sym_foreach] = ACTIONS(3053),
    [anon_sym_goto] = ACTIONS(3053),
    [anon_sym_if] = ACTIONS(3053),
    [anon_sym_else] = ACTIONS(3053),
    [anon_sym_DOT_DOT] = ACTIONS(3055),
    [anon_sym_from] = ACTIONS(3053),
    [anon_sym_into] = ACTIONS(3053),
    [anon_sym_join] = ACTIONS(3053),
    [anon_sym_on] = ACTIONS(3053),
    [anon_sym_equals] = ACTIONS(3053),
    [anon_sym_let] = ACTIONS(3053),
    [anon_sym_orderby] = ACTIONS(3053),
    [anon_sym_ascending] = ACTIONS(3053),
    [anon_sym_descending] = ACTIONS(3053),
    [anon_sym_group] = ACTIONS(3053),
    [anon_sym_by] = ACTIONS(3053),
    [anon_sym_select] = ACTIONS(3053),
    [anon_sym_DQUOTE] = ACTIONS(3053),
    [anon_sym_stackalloc] = ACTIONS(3053),
    [anon_sym_sizeof] = ACTIONS(3053),
    [anon_sym_typeof] = ACTIONS(3053),
    [anon_sym___makeref] = ACTIONS(3053),
    [anon_sym___reftype] = ACTIONS(3053),
    [anon_sym___refvalue] = ACTIONS(3053),
    [sym_null_literal] = ACTIONS(3053),
    [anon_sym_SQUOTE] = ACTIONS(3055),
    [sym_integer_literal] = ACTIONS(3053),
    [sym_real_literal] = ACTIONS(3055),
    [sym_verbatim_string_literal] = ACTIONS(3055),
    [sym_raw_string_literal] = ACTIONS(3055),
    [aux_sym_preproc_if_token1] = ACTIONS(3055),
    [aux_sym_preproc_if_token3] = ACTIONS(3055),
    [aux_sym_preproc_else_token1] = ACTIONS(3055),
    [aux_sym_preproc_elif_token1] = ACTIONS(3055),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3055),
    [sym_interpolation_verbatim_start] = ACTIONS(3055),
    [sym_interpolation_raw_start] = ACTIONS(3055),
  },
  [2218] = {
    [sym_preproc_region] = STATE(2218),
    [sym_preproc_endregion] = STATE(2218),
    [sym_preproc_line] = STATE(2218),
    [sym_preproc_pragma] = STATE(2218),
    [sym_preproc_nullable] = STATE(2218),
    [sym_preproc_error] = STATE(2218),
    [sym_preproc_define] = STATE(2218),
    [sym_preproc_undef] = STATE(2218),
    [sym__identifier_token] = ACTIONS(3057),
    [anon_sym_extern] = ACTIONS(3057),
    [anon_sym_alias] = ACTIONS(3057),
    [anon_sym_SEMI] = ACTIONS(3059),
    [anon_sym_global] = ACTIONS(3057),
    [anon_sym_using] = ACTIONS(3057),
    [anon_sym_unsafe] = ACTIONS(3057),
    [anon_sym_static] = ACTIONS(3057),
    [anon_sym_LBRACK] = ACTIONS(3059),
    [anon_sym_LPAREN] = ACTIONS(3059),
    [anon_sym_return] = ACTIONS(3057),
    [anon_sym_namespace] = ACTIONS(3057),
    [anon_sym_class] = ACTIONS(3057),
    [anon_sym_ref] = ACTIONS(3057),
    [anon_sym_struct] = ACTIONS(3057),
    [anon_sym_enum] = ACTIONS(3057),
    [anon_sym_LBRACE] = ACTIONS(3059),
    [anon_sym_interface] = ACTIONS(3057),
    [anon_sym_delegate] = ACTIONS(3057),
    [anon_sym_record] = ACTIONS(3057),
    [anon_sym_abstract] = ACTIONS(3057),
    [anon_sym_async] = ACTIONS(3057),
    [anon_sym_const] = ACTIONS(3057),
    [anon_sym_file] = ACTIONS(3057),
    [anon_sym_fixed] = ACTIONS(3057),
    [anon_sym_internal] = ACTIONS(3057),
    [anon_sym_new] = ACTIONS(3057),
    [anon_sym_override] = ACTIONS(3057),
    [anon_sym_partial] = ACTIONS(3057),
    [anon_sym_private] = ACTIONS(3057),
    [anon_sym_protected] = ACTIONS(3057),
    [anon_sym_public] = ACTIONS(3057),
    [anon_sym_readonly] = ACTIONS(3057),
    [anon_sym_required] = ACTIONS(3057),
    [anon_sym_sealed] = ACTIONS(3057),
    [anon_sym_virtual] = ACTIONS(3057),
    [anon_sym_volatile] = ACTIONS(3057),
    [anon_sym_where] = ACTIONS(3057),
    [anon_sym_notnull] = ACTIONS(3057),
    [anon_sym_unmanaged] = ACTIONS(3057),
    [anon_sym_checked] = ACTIONS(3057),
    [anon_sym_BANG] = ACTIONS(3059),
    [anon_sym_TILDE] = ACTIONS(3059),
    [anon_sym_PLUS_PLUS] = ACTIONS(3059),
    [anon_sym_DASH_DASH] = ACTIONS(3059),
    [anon_sym_true] = ACTIONS(3057),
    [anon_sym_false] = ACTIONS(3057),
    [anon_sym_PLUS] = ACTIONS(3057),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_STAR] = ACTIONS(3059),
    [anon_sym_CARET] = ACTIONS(3059),
    [anon_sym_AMP] = ACTIONS(3059),
    [anon_sym_this] = ACTIONS(3057),
    [anon_sym_scoped] = ACTIONS(3057),
    [anon_sym_var] = ACTIONS(3057),
    [sym_predefined_type] = ACTIONS(3057),
    [anon_sym_break] = ACTIONS(3057),
    [anon_sym_unchecked] = ACTIONS(3057),
    [anon_sym_continue] = ACTIONS(3057),
    [anon_sym_do] = ACTIONS(3057),
    [anon_sym_while] = ACTIONS(3057),
    [anon_sym_for] = ACTIONS(3057),
    [anon_sym_lock] = ACTIONS(3057),
    [anon_sym_yield] = ACTIONS(3057),
    [anon_sym_switch] = ACTIONS(3057),
    [anon_sym_default] = ACTIONS(3057),
    [anon_sym_throw] = ACTIONS(3057),
    [anon_sym_try] = ACTIONS(3057),
    [anon_sym_when] = ACTIONS(3057),
    [anon_sym_await] = ACTIONS(3057),
    [anon_sym_foreach] = ACTIONS(3057),
    [anon_sym_goto] = ACTIONS(3057),
    [anon_sym_if] = ACTIONS(3057),
    [anon_sym_else] = ACTIONS(3057),
    [anon_sym_DOT_DOT] = ACTIONS(3059),
    [anon_sym_from] = ACTIONS(3057),
    [anon_sym_into] = ACTIONS(3057),
    [anon_sym_join] = ACTIONS(3057),
    [anon_sym_on] = ACTIONS(3057),
    [anon_sym_equals] = ACTIONS(3057),
    [anon_sym_let] = ACTIONS(3057),
    [anon_sym_orderby] = ACTIONS(3057),
    [anon_sym_ascending] = ACTIONS(3057),
    [anon_sym_descending] = ACTIONS(3057),
    [anon_sym_group] = ACTIONS(3057),
    [anon_sym_by] = ACTIONS(3057),
    [anon_sym_select] = ACTIONS(3057),
    [anon_sym_DQUOTE] = ACTIONS(3057),
    [anon_sym_stackalloc] = ACTIONS(3057),
    [anon_sym_sizeof] = ACTIONS(3057),
    [anon_sym_typeof] = ACTIONS(3057),
    [anon_sym___makeref] = ACTIONS(3057),
    [anon_sym___reftype] = ACTIONS(3057),
    [anon_sym___refvalue] = ACTIONS(3057),
    [sym_null_literal] = ACTIONS(3057),
    [anon_sym_SQUOTE] = ACTIONS(3059),
    [sym_integer_literal] = ACTIONS(3057),
    [sym_real_literal] = ACTIONS(3059),
    [sym_verbatim_string_literal] = ACTIONS(3059),
    [sym_raw_string_literal] = ACTIONS(3059),
    [aux_sym_preproc_if_token1] = ACTIONS(3059),
    [aux_sym_preproc_if_token3] = ACTIONS(3059),
    [aux_sym_preproc_else_token1] = ACTIONS(3059),
    [aux_sym_preproc_elif_token1] = ACTIONS(3059),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3059),
    [sym_interpolation_verbatim_start] = ACTIONS(3059),
    [sym_interpolation_raw_start] = ACTIONS(3059),
  },
  [2219] = {
    [sym_preproc_region] = STATE(2219),
    [sym_preproc_endregion] = STATE(2219),
    [sym_preproc_line] = STATE(2219),
    [sym_preproc_pragma] = STATE(2219),
    [sym_preproc_nullable] = STATE(2219),
    [sym_preproc_error] = STATE(2219),
    [sym_preproc_define] = STATE(2219),
    [sym_preproc_undef] = STATE(2219),
    [sym__identifier_token] = ACTIONS(3061),
    [anon_sym_extern] = ACTIONS(3061),
    [anon_sym_alias] = ACTIONS(3061),
    [anon_sym_SEMI] = ACTIONS(3063),
    [anon_sym_global] = ACTIONS(3061),
    [anon_sym_using] = ACTIONS(3061),
    [anon_sym_unsafe] = ACTIONS(3061),
    [anon_sym_static] = ACTIONS(3061),
    [anon_sym_LBRACK] = ACTIONS(3063),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_return] = ACTIONS(3061),
    [anon_sym_namespace] = ACTIONS(3061),
    [anon_sym_class] = ACTIONS(3061),
    [anon_sym_ref] = ACTIONS(3061),
    [anon_sym_struct] = ACTIONS(3061),
    [anon_sym_enum] = ACTIONS(3061),
    [anon_sym_LBRACE] = ACTIONS(3063),
    [anon_sym_interface] = ACTIONS(3061),
    [anon_sym_delegate] = ACTIONS(3061),
    [anon_sym_record] = ACTIONS(3061),
    [anon_sym_abstract] = ACTIONS(3061),
    [anon_sym_async] = ACTIONS(3061),
    [anon_sym_const] = ACTIONS(3061),
    [anon_sym_file] = ACTIONS(3061),
    [anon_sym_fixed] = ACTIONS(3061),
    [anon_sym_internal] = ACTIONS(3061),
    [anon_sym_new] = ACTIONS(3061),
    [anon_sym_override] = ACTIONS(3061),
    [anon_sym_partial] = ACTIONS(3061),
    [anon_sym_private] = ACTIONS(3061),
    [anon_sym_protected] = ACTIONS(3061),
    [anon_sym_public] = ACTIONS(3061),
    [anon_sym_readonly] = ACTIONS(3061),
    [anon_sym_required] = ACTIONS(3061),
    [anon_sym_sealed] = ACTIONS(3061),
    [anon_sym_virtual] = ACTIONS(3061),
    [anon_sym_volatile] = ACTIONS(3061),
    [anon_sym_where] = ACTIONS(3061),
    [anon_sym_notnull] = ACTIONS(3061),
    [anon_sym_unmanaged] = ACTIONS(3061),
    [anon_sym_checked] = ACTIONS(3061),
    [anon_sym_BANG] = ACTIONS(3063),
    [anon_sym_TILDE] = ACTIONS(3063),
    [anon_sym_PLUS_PLUS] = ACTIONS(3063),
    [anon_sym_DASH_DASH] = ACTIONS(3063),
    [anon_sym_true] = ACTIONS(3061),
    [anon_sym_false] = ACTIONS(3061),
    [anon_sym_PLUS] = ACTIONS(3061),
    [anon_sym_DASH] = ACTIONS(3061),
    [anon_sym_STAR] = ACTIONS(3063),
    [anon_sym_CARET] = ACTIONS(3063),
    [anon_sym_AMP] = ACTIONS(3063),
    [anon_sym_this] = ACTIONS(3061),
    [anon_sym_scoped] = ACTIONS(3061),
    [anon_sym_var] = ACTIONS(3061),
    [sym_predefined_type] = ACTIONS(3061),
    [anon_sym_break] = ACTIONS(3061),
    [anon_sym_unchecked] = ACTIONS(3061),
    [anon_sym_continue] = ACTIONS(3061),
    [anon_sym_do] = ACTIONS(3061),
    [anon_sym_while] = ACTIONS(3061),
    [anon_sym_for] = ACTIONS(3061),
    [anon_sym_lock] = ACTIONS(3061),
    [anon_sym_yield] = ACTIONS(3061),
    [anon_sym_switch] = ACTIONS(3061),
    [anon_sym_default] = ACTIONS(3061),
    [anon_sym_throw] = ACTIONS(3061),
    [anon_sym_try] = ACTIONS(3061),
    [anon_sym_when] = ACTIONS(3061),
    [anon_sym_await] = ACTIONS(3061),
    [anon_sym_foreach] = ACTIONS(3061),
    [anon_sym_goto] = ACTIONS(3061),
    [anon_sym_if] = ACTIONS(3061),
    [anon_sym_else] = ACTIONS(3061),
    [anon_sym_DOT_DOT] = ACTIONS(3063),
    [anon_sym_from] = ACTIONS(3061),
    [anon_sym_into] = ACTIONS(3061),
    [anon_sym_join] = ACTIONS(3061),
    [anon_sym_on] = ACTIONS(3061),
    [anon_sym_equals] = ACTIONS(3061),
    [anon_sym_let] = ACTIONS(3061),
    [anon_sym_orderby] = ACTIONS(3061),
    [anon_sym_ascending] = ACTIONS(3061),
    [anon_sym_descending] = ACTIONS(3061),
    [anon_sym_group] = ACTIONS(3061),
    [anon_sym_by] = ACTIONS(3061),
    [anon_sym_select] = ACTIONS(3061),
    [anon_sym_DQUOTE] = ACTIONS(3061),
    [anon_sym_stackalloc] = ACTIONS(3061),
    [anon_sym_sizeof] = ACTIONS(3061),
    [anon_sym_typeof] = ACTIONS(3061),
    [anon_sym___makeref] = ACTIONS(3061),
    [anon_sym___reftype] = ACTIONS(3061),
    [anon_sym___refvalue] = ACTIONS(3061),
    [sym_null_literal] = ACTIONS(3061),
    [anon_sym_SQUOTE] = ACTIONS(3063),
    [sym_integer_literal] = ACTIONS(3061),
    [sym_real_literal] = ACTIONS(3063),
    [sym_verbatim_string_literal] = ACTIONS(3063),
    [sym_raw_string_literal] = ACTIONS(3063),
    [aux_sym_preproc_if_token1] = ACTIONS(3063),
    [aux_sym_preproc_if_token3] = ACTIONS(3063),
    [aux_sym_preproc_else_token1] = ACTIONS(3063),
    [aux_sym_preproc_elif_token1] = ACTIONS(3063),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3063),
    [sym_interpolation_verbatim_start] = ACTIONS(3063),
    [sym_interpolation_raw_start] = ACTIONS(3063),
  },
  [2220] = {
    [sym_preproc_region] = STATE(2220),
    [sym_preproc_endregion] = STATE(2220),
    [sym_preproc_line] = STATE(2220),
    [sym_preproc_pragma] = STATE(2220),
    [sym_preproc_nullable] = STATE(2220),
    [sym_preproc_error] = STATE(2220),
    [sym_preproc_define] = STATE(2220),
    [sym_preproc_undef] = STATE(2220),
    [sym__identifier_token] = ACTIONS(3065),
    [anon_sym_extern] = ACTIONS(3065),
    [anon_sym_alias] = ACTIONS(3065),
    [anon_sym_SEMI] = ACTIONS(3067),
    [anon_sym_global] = ACTIONS(3065),
    [anon_sym_using] = ACTIONS(3065),
    [anon_sym_unsafe] = ACTIONS(3065),
    [anon_sym_static] = ACTIONS(3065),
    [anon_sym_LBRACK] = ACTIONS(3067),
    [anon_sym_LPAREN] = ACTIONS(3067),
    [anon_sym_return] = ACTIONS(3065),
    [anon_sym_namespace] = ACTIONS(3065),
    [anon_sym_class] = ACTIONS(3065),
    [anon_sym_ref] = ACTIONS(3065),
    [anon_sym_struct] = ACTIONS(3065),
    [anon_sym_enum] = ACTIONS(3065),
    [anon_sym_LBRACE] = ACTIONS(3067),
    [anon_sym_interface] = ACTIONS(3065),
    [anon_sym_delegate] = ACTIONS(3065),
    [anon_sym_record] = ACTIONS(3065),
    [anon_sym_abstract] = ACTIONS(3065),
    [anon_sym_async] = ACTIONS(3065),
    [anon_sym_const] = ACTIONS(3065),
    [anon_sym_file] = ACTIONS(3065),
    [anon_sym_fixed] = ACTIONS(3065),
    [anon_sym_internal] = ACTIONS(3065),
    [anon_sym_new] = ACTIONS(3065),
    [anon_sym_override] = ACTIONS(3065),
    [anon_sym_partial] = ACTIONS(3065),
    [anon_sym_private] = ACTIONS(3065),
    [anon_sym_protected] = ACTIONS(3065),
    [anon_sym_public] = ACTIONS(3065),
    [anon_sym_readonly] = ACTIONS(3065),
    [anon_sym_required] = ACTIONS(3065),
    [anon_sym_sealed] = ACTIONS(3065),
    [anon_sym_virtual] = ACTIONS(3065),
    [anon_sym_volatile] = ACTIONS(3065),
    [anon_sym_where] = ACTIONS(3065),
    [anon_sym_notnull] = ACTIONS(3065),
    [anon_sym_unmanaged] = ACTIONS(3065),
    [anon_sym_checked] = ACTIONS(3065),
    [anon_sym_BANG] = ACTIONS(3067),
    [anon_sym_TILDE] = ACTIONS(3067),
    [anon_sym_PLUS_PLUS] = ACTIONS(3067),
    [anon_sym_DASH_DASH] = ACTIONS(3067),
    [anon_sym_true] = ACTIONS(3065),
    [anon_sym_false] = ACTIONS(3065),
    [anon_sym_PLUS] = ACTIONS(3065),
    [anon_sym_DASH] = ACTIONS(3065),
    [anon_sym_STAR] = ACTIONS(3067),
    [anon_sym_CARET] = ACTIONS(3067),
    [anon_sym_AMP] = ACTIONS(3067),
    [anon_sym_this] = ACTIONS(3065),
    [anon_sym_scoped] = ACTIONS(3065),
    [anon_sym_var] = ACTIONS(3065),
    [sym_predefined_type] = ACTIONS(3065),
    [anon_sym_break] = ACTIONS(3065),
    [anon_sym_unchecked] = ACTIONS(3065),
    [anon_sym_continue] = ACTIONS(3065),
    [anon_sym_do] = ACTIONS(3065),
    [anon_sym_while] = ACTIONS(3065),
    [anon_sym_for] = ACTIONS(3065),
    [anon_sym_lock] = ACTIONS(3065),
    [anon_sym_yield] = ACTIONS(3065),
    [anon_sym_switch] = ACTIONS(3065),
    [anon_sym_default] = ACTIONS(3065),
    [anon_sym_throw] = ACTIONS(3065),
    [anon_sym_try] = ACTIONS(3065),
    [anon_sym_when] = ACTIONS(3065),
    [anon_sym_await] = ACTIONS(3065),
    [anon_sym_foreach] = ACTIONS(3065),
    [anon_sym_goto] = ACTIONS(3065),
    [anon_sym_if] = ACTIONS(3065),
    [anon_sym_else] = ACTIONS(3065),
    [anon_sym_DOT_DOT] = ACTIONS(3067),
    [anon_sym_from] = ACTIONS(3065),
    [anon_sym_into] = ACTIONS(3065),
    [anon_sym_join] = ACTIONS(3065),
    [anon_sym_on] = ACTIONS(3065),
    [anon_sym_equals] = ACTIONS(3065),
    [anon_sym_let] = ACTIONS(3065),
    [anon_sym_orderby] = ACTIONS(3065),
    [anon_sym_ascending] = ACTIONS(3065),
    [anon_sym_descending] = ACTIONS(3065),
    [anon_sym_group] = ACTIONS(3065),
    [anon_sym_by] = ACTIONS(3065),
    [anon_sym_select] = ACTIONS(3065),
    [anon_sym_DQUOTE] = ACTIONS(3065),
    [anon_sym_stackalloc] = ACTIONS(3065),
    [anon_sym_sizeof] = ACTIONS(3065),
    [anon_sym_typeof] = ACTIONS(3065),
    [anon_sym___makeref] = ACTIONS(3065),
    [anon_sym___reftype] = ACTIONS(3065),
    [anon_sym___refvalue] = ACTIONS(3065),
    [sym_null_literal] = ACTIONS(3065),
    [anon_sym_SQUOTE] = ACTIONS(3067),
    [sym_integer_literal] = ACTIONS(3065),
    [sym_real_literal] = ACTIONS(3067),
    [sym_verbatim_string_literal] = ACTIONS(3067),
    [sym_raw_string_literal] = ACTIONS(3067),
    [aux_sym_preproc_if_token1] = ACTIONS(3067),
    [aux_sym_preproc_if_token3] = ACTIONS(3067),
    [aux_sym_preproc_else_token1] = ACTIONS(3067),
    [aux_sym_preproc_elif_token1] = ACTIONS(3067),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3067),
    [sym_interpolation_verbatim_start] = ACTIONS(3067),
    [sym_interpolation_raw_start] = ACTIONS(3067),
  },
  [2221] = {
    [sym_preproc_region] = STATE(2221),
    [sym_preproc_endregion] = STATE(2221),
    [sym_preproc_line] = STATE(2221),
    [sym_preproc_pragma] = STATE(2221),
    [sym_preproc_nullable] = STATE(2221),
    [sym_preproc_error] = STATE(2221),
    [sym_preproc_define] = STATE(2221),
    [sym_preproc_undef] = STATE(2221),
    [sym__identifier_token] = ACTIONS(3069),
    [anon_sym_extern] = ACTIONS(3069),
    [anon_sym_alias] = ACTIONS(3069),
    [anon_sym_SEMI] = ACTIONS(3071),
    [anon_sym_global] = ACTIONS(3069),
    [anon_sym_using] = ACTIONS(3069),
    [anon_sym_unsafe] = ACTIONS(3069),
    [anon_sym_static] = ACTIONS(3069),
    [anon_sym_LBRACK] = ACTIONS(3071),
    [anon_sym_LPAREN] = ACTIONS(3071),
    [anon_sym_return] = ACTIONS(3069),
    [anon_sym_namespace] = ACTIONS(3069),
    [anon_sym_class] = ACTIONS(3069),
    [anon_sym_ref] = ACTIONS(3069),
    [anon_sym_struct] = ACTIONS(3069),
    [anon_sym_enum] = ACTIONS(3069),
    [anon_sym_LBRACE] = ACTIONS(3071),
    [anon_sym_interface] = ACTIONS(3069),
    [anon_sym_delegate] = ACTIONS(3069),
    [anon_sym_record] = ACTIONS(3069),
    [anon_sym_abstract] = ACTIONS(3069),
    [anon_sym_async] = ACTIONS(3069),
    [anon_sym_const] = ACTIONS(3069),
    [anon_sym_file] = ACTIONS(3069),
    [anon_sym_fixed] = ACTIONS(3069),
    [anon_sym_internal] = ACTIONS(3069),
    [anon_sym_new] = ACTIONS(3069),
    [anon_sym_override] = ACTIONS(3069),
    [anon_sym_partial] = ACTIONS(3069),
    [anon_sym_private] = ACTIONS(3069),
    [anon_sym_protected] = ACTIONS(3069),
    [anon_sym_public] = ACTIONS(3069),
    [anon_sym_readonly] = ACTIONS(3069),
    [anon_sym_required] = ACTIONS(3069),
    [anon_sym_sealed] = ACTIONS(3069),
    [anon_sym_virtual] = ACTIONS(3069),
    [anon_sym_volatile] = ACTIONS(3069),
    [anon_sym_where] = ACTIONS(3069),
    [anon_sym_notnull] = ACTIONS(3069),
    [anon_sym_unmanaged] = ACTIONS(3069),
    [anon_sym_checked] = ACTIONS(3069),
    [anon_sym_BANG] = ACTIONS(3071),
    [anon_sym_TILDE] = ACTIONS(3071),
    [anon_sym_PLUS_PLUS] = ACTIONS(3071),
    [anon_sym_DASH_DASH] = ACTIONS(3071),
    [anon_sym_true] = ACTIONS(3069),
    [anon_sym_false] = ACTIONS(3069),
    [anon_sym_PLUS] = ACTIONS(3069),
    [anon_sym_DASH] = ACTIONS(3069),
    [anon_sym_STAR] = ACTIONS(3071),
    [anon_sym_CARET] = ACTIONS(3071),
    [anon_sym_AMP] = ACTIONS(3071),
    [anon_sym_this] = ACTIONS(3069),
    [anon_sym_scoped] = ACTIONS(3069),
    [anon_sym_var] = ACTIONS(3069),
    [sym_predefined_type] = ACTIONS(3069),
    [anon_sym_break] = ACTIONS(3069),
    [anon_sym_unchecked] = ACTIONS(3069),
    [anon_sym_continue] = ACTIONS(3069),
    [anon_sym_do] = ACTIONS(3069),
    [anon_sym_while] = ACTIONS(3069),
    [anon_sym_for] = ACTIONS(3069),
    [anon_sym_lock] = ACTIONS(3069),
    [anon_sym_yield] = ACTIONS(3069),
    [anon_sym_switch] = ACTIONS(3069),
    [anon_sym_default] = ACTIONS(3069),
    [anon_sym_throw] = ACTIONS(3069),
    [anon_sym_try] = ACTIONS(3069),
    [anon_sym_when] = ACTIONS(3069),
    [anon_sym_await] = ACTIONS(3069),
    [anon_sym_foreach] = ACTIONS(3069),
    [anon_sym_goto] = ACTIONS(3069),
    [anon_sym_if] = ACTIONS(3069),
    [anon_sym_else] = ACTIONS(3069),
    [anon_sym_DOT_DOT] = ACTIONS(3071),
    [anon_sym_from] = ACTIONS(3069),
    [anon_sym_into] = ACTIONS(3069),
    [anon_sym_join] = ACTIONS(3069),
    [anon_sym_on] = ACTIONS(3069),
    [anon_sym_equals] = ACTIONS(3069),
    [anon_sym_let] = ACTIONS(3069),
    [anon_sym_orderby] = ACTIONS(3069),
    [anon_sym_ascending] = ACTIONS(3069),
    [anon_sym_descending] = ACTIONS(3069),
    [anon_sym_group] = ACTIONS(3069),
    [anon_sym_by] = ACTIONS(3069),
    [anon_sym_select] = ACTIONS(3069),
    [anon_sym_DQUOTE] = ACTIONS(3069),
    [anon_sym_stackalloc] = ACTIONS(3069),
    [anon_sym_sizeof] = ACTIONS(3069),
    [anon_sym_typeof] = ACTIONS(3069),
    [anon_sym___makeref] = ACTIONS(3069),
    [anon_sym___reftype] = ACTIONS(3069),
    [anon_sym___refvalue] = ACTIONS(3069),
    [sym_null_literal] = ACTIONS(3069),
    [anon_sym_SQUOTE] = ACTIONS(3071),
    [sym_integer_literal] = ACTIONS(3069),
    [sym_real_literal] = ACTIONS(3071),
    [sym_verbatim_string_literal] = ACTIONS(3071),
    [sym_raw_string_literal] = ACTIONS(3071),
    [aux_sym_preproc_if_token1] = ACTIONS(3071),
    [aux_sym_preproc_if_token3] = ACTIONS(3071),
    [aux_sym_preproc_else_token1] = ACTIONS(3071),
    [aux_sym_preproc_elif_token1] = ACTIONS(3071),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3071),
    [sym_interpolation_verbatim_start] = ACTIONS(3071),
    [sym_interpolation_raw_start] = ACTIONS(3071),
  },
  [2222] = {
    [sym_preproc_region] = STATE(2222),
    [sym_preproc_endregion] = STATE(2222),
    [sym_preproc_line] = STATE(2222),
    [sym_preproc_pragma] = STATE(2222),
    [sym_preproc_nullable] = STATE(2222),
    [sym_preproc_error] = STATE(2222),
    [sym_preproc_define] = STATE(2222),
    [sym_preproc_undef] = STATE(2222),
    [sym__identifier_token] = ACTIONS(3073),
    [anon_sym_extern] = ACTIONS(3073),
    [anon_sym_alias] = ACTIONS(3073),
    [anon_sym_SEMI] = ACTIONS(3075),
    [anon_sym_global] = ACTIONS(3073),
    [anon_sym_using] = ACTIONS(3073),
    [anon_sym_unsafe] = ACTIONS(3073),
    [anon_sym_static] = ACTIONS(3073),
    [anon_sym_LBRACK] = ACTIONS(3075),
    [anon_sym_LPAREN] = ACTIONS(3075),
    [anon_sym_return] = ACTIONS(3073),
    [anon_sym_namespace] = ACTIONS(3073),
    [anon_sym_class] = ACTIONS(3073),
    [anon_sym_ref] = ACTIONS(3073),
    [anon_sym_struct] = ACTIONS(3073),
    [anon_sym_enum] = ACTIONS(3073),
    [anon_sym_LBRACE] = ACTIONS(3075),
    [anon_sym_interface] = ACTIONS(3073),
    [anon_sym_delegate] = ACTIONS(3073),
    [anon_sym_record] = ACTIONS(3073),
    [anon_sym_abstract] = ACTIONS(3073),
    [anon_sym_async] = ACTIONS(3073),
    [anon_sym_const] = ACTIONS(3073),
    [anon_sym_file] = ACTIONS(3073),
    [anon_sym_fixed] = ACTIONS(3073),
    [anon_sym_internal] = ACTIONS(3073),
    [anon_sym_new] = ACTIONS(3073),
    [anon_sym_override] = ACTIONS(3073),
    [anon_sym_partial] = ACTIONS(3073),
    [anon_sym_private] = ACTIONS(3073),
    [anon_sym_protected] = ACTIONS(3073),
    [anon_sym_public] = ACTIONS(3073),
    [anon_sym_readonly] = ACTIONS(3073),
    [anon_sym_required] = ACTIONS(3073),
    [anon_sym_sealed] = ACTIONS(3073),
    [anon_sym_virtual] = ACTIONS(3073),
    [anon_sym_volatile] = ACTIONS(3073),
    [anon_sym_where] = ACTIONS(3073),
    [anon_sym_notnull] = ACTIONS(3073),
    [anon_sym_unmanaged] = ACTIONS(3073),
    [anon_sym_checked] = ACTIONS(3073),
    [anon_sym_BANG] = ACTIONS(3075),
    [anon_sym_TILDE] = ACTIONS(3075),
    [anon_sym_PLUS_PLUS] = ACTIONS(3075),
    [anon_sym_DASH_DASH] = ACTIONS(3075),
    [anon_sym_true] = ACTIONS(3073),
    [anon_sym_false] = ACTIONS(3073),
    [anon_sym_PLUS] = ACTIONS(3073),
    [anon_sym_DASH] = ACTIONS(3073),
    [anon_sym_STAR] = ACTIONS(3075),
    [anon_sym_CARET] = ACTIONS(3075),
    [anon_sym_AMP] = ACTIONS(3075),
    [anon_sym_this] = ACTIONS(3073),
    [anon_sym_scoped] = ACTIONS(3073),
    [anon_sym_var] = ACTIONS(3073),
    [sym_predefined_type] = ACTIONS(3073),
    [anon_sym_break] = ACTIONS(3073),
    [anon_sym_unchecked] = ACTIONS(3073),
    [anon_sym_continue] = ACTIONS(3073),
    [anon_sym_do] = ACTIONS(3073),
    [anon_sym_while] = ACTIONS(3073),
    [anon_sym_for] = ACTIONS(3073),
    [anon_sym_lock] = ACTIONS(3073),
    [anon_sym_yield] = ACTIONS(3073),
    [anon_sym_switch] = ACTIONS(3073),
    [anon_sym_default] = ACTIONS(3073),
    [anon_sym_throw] = ACTIONS(3073),
    [anon_sym_try] = ACTIONS(3073),
    [anon_sym_when] = ACTIONS(3073),
    [anon_sym_await] = ACTIONS(3073),
    [anon_sym_foreach] = ACTIONS(3073),
    [anon_sym_goto] = ACTIONS(3073),
    [anon_sym_if] = ACTIONS(3073),
    [anon_sym_else] = ACTIONS(3073),
    [anon_sym_DOT_DOT] = ACTIONS(3075),
    [anon_sym_from] = ACTIONS(3073),
    [anon_sym_into] = ACTIONS(3073),
    [anon_sym_join] = ACTIONS(3073),
    [anon_sym_on] = ACTIONS(3073),
    [anon_sym_equals] = ACTIONS(3073),
    [anon_sym_let] = ACTIONS(3073),
    [anon_sym_orderby] = ACTIONS(3073),
    [anon_sym_ascending] = ACTIONS(3073),
    [anon_sym_descending] = ACTIONS(3073),
    [anon_sym_group] = ACTIONS(3073),
    [anon_sym_by] = ACTIONS(3073),
    [anon_sym_select] = ACTIONS(3073),
    [anon_sym_DQUOTE] = ACTIONS(3073),
    [anon_sym_stackalloc] = ACTIONS(3073),
    [anon_sym_sizeof] = ACTIONS(3073),
    [anon_sym_typeof] = ACTIONS(3073),
    [anon_sym___makeref] = ACTIONS(3073),
    [anon_sym___reftype] = ACTIONS(3073),
    [anon_sym___refvalue] = ACTIONS(3073),
    [sym_null_literal] = ACTIONS(3073),
    [anon_sym_SQUOTE] = ACTIONS(3075),
    [sym_integer_literal] = ACTIONS(3073),
    [sym_real_literal] = ACTIONS(3075),
    [sym_verbatim_string_literal] = ACTIONS(3075),
    [sym_raw_string_literal] = ACTIONS(3075),
    [aux_sym_preproc_if_token1] = ACTIONS(3075),
    [aux_sym_preproc_if_token3] = ACTIONS(3075),
    [aux_sym_preproc_else_token1] = ACTIONS(3075),
    [aux_sym_preproc_elif_token1] = ACTIONS(3075),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3075),
    [sym_interpolation_verbatim_start] = ACTIONS(3075),
    [sym_interpolation_raw_start] = ACTIONS(3075),
  },
  [2223] = {
    [sym_preproc_region] = STATE(2223),
    [sym_preproc_endregion] = STATE(2223),
    [sym_preproc_line] = STATE(2223),
    [sym_preproc_pragma] = STATE(2223),
    [sym_preproc_nullable] = STATE(2223),
    [sym_preproc_error] = STATE(2223),
    [sym_preproc_define] = STATE(2223),
    [sym_preproc_undef] = STATE(2223),
    [sym__identifier_token] = ACTIONS(3077),
    [anon_sym_extern] = ACTIONS(3077),
    [anon_sym_alias] = ACTIONS(3077),
    [anon_sym_SEMI] = ACTIONS(3079),
    [anon_sym_global] = ACTIONS(3077),
    [anon_sym_using] = ACTIONS(3077),
    [anon_sym_unsafe] = ACTIONS(3077),
    [anon_sym_static] = ACTIONS(3077),
    [anon_sym_LBRACK] = ACTIONS(3079),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_return] = ACTIONS(3077),
    [anon_sym_namespace] = ACTIONS(3077),
    [anon_sym_class] = ACTIONS(3077),
    [anon_sym_ref] = ACTIONS(3077),
    [anon_sym_struct] = ACTIONS(3077),
    [anon_sym_enum] = ACTIONS(3077),
    [anon_sym_LBRACE] = ACTIONS(3079),
    [anon_sym_interface] = ACTIONS(3077),
    [anon_sym_delegate] = ACTIONS(3077),
    [anon_sym_record] = ACTIONS(3077),
    [anon_sym_abstract] = ACTIONS(3077),
    [anon_sym_async] = ACTIONS(3077),
    [anon_sym_const] = ACTIONS(3077),
    [anon_sym_file] = ACTIONS(3077),
    [anon_sym_fixed] = ACTIONS(3077),
    [anon_sym_internal] = ACTIONS(3077),
    [anon_sym_new] = ACTIONS(3077),
    [anon_sym_override] = ACTIONS(3077),
    [anon_sym_partial] = ACTIONS(3077),
    [anon_sym_private] = ACTIONS(3077),
    [anon_sym_protected] = ACTIONS(3077),
    [anon_sym_public] = ACTIONS(3077),
    [anon_sym_readonly] = ACTIONS(3077),
    [anon_sym_required] = ACTIONS(3077),
    [anon_sym_sealed] = ACTIONS(3077),
    [anon_sym_virtual] = ACTIONS(3077),
    [anon_sym_volatile] = ACTIONS(3077),
    [anon_sym_where] = ACTIONS(3077),
    [anon_sym_notnull] = ACTIONS(3077),
    [anon_sym_unmanaged] = ACTIONS(3077),
    [anon_sym_checked] = ACTIONS(3077),
    [anon_sym_BANG] = ACTIONS(3079),
    [anon_sym_TILDE] = ACTIONS(3079),
    [anon_sym_PLUS_PLUS] = ACTIONS(3079),
    [anon_sym_DASH_DASH] = ACTIONS(3079),
    [anon_sym_true] = ACTIONS(3077),
    [anon_sym_false] = ACTIONS(3077),
    [anon_sym_PLUS] = ACTIONS(3077),
    [anon_sym_DASH] = ACTIONS(3077),
    [anon_sym_STAR] = ACTIONS(3079),
    [anon_sym_CARET] = ACTIONS(3079),
    [anon_sym_AMP] = ACTIONS(3079),
    [anon_sym_this] = ACTIONS(3077),
    [anon_sym_scoped] = ACTIONS(3077),
    [anon_sym_var] = ACTIONS(3077),
    [sym_predefined_type] = ACTIONS(3077),
    [anon_sym_break] = ACTIONS(3077),
    [anon_sym_unchecked] = ACTIONS(3077),
    [anon_sym_continue] = ACTIONS(3077),
    [anon_sym_do] = ACTIONS(3077),
    [anon_sym_while] = ACTIONS(3077),
    [anon_sym_for] = ACTIONS(3077),
    [anon_sym_lock] = ACTIONS(3077),
    [anon_sym_yield] = ACTIONS(3077),
    [anon_sym_switch] = ACTIONS(3077),
    [anon_sym_default] = ACTIONS(3077),
    [anon_sym_throw] = ACTIONS(3077),
    [anon_sym_try] = ACTIONS(3077),
    [anon_sym_when] = ACTIONS(3077),
    [anon_sym_await] = ACTIONS(3077),
    [anon_sym_foreach] = ACTIONS(3077),
    [anon_sym_goto] = ACTIONS(3077),
    [anon_sym_if] = ACTIONS(3077),
    [anon_sym_else] = ACTIONS(3077),
    [anon_sym_DOT_DOT] = ACTIONS(3079),
    [anon_sym_from] = ACTIONS(3077),
    [anon_sym_into] = ACTIONS(3077),
    [anon_sym_join] = ACTIONS(3077),
    [anon_sym_on] = ACTIONS(3077),
    [anon_sym_equals] = ACTIONS(3077),
    [anon_sym_let] = ACTIONS(3077),
    [anon_sym_orderby] = ACTIONS(3077),
    [anon_sym_ascending] = ACTIONS(3077),
    [anon_sym_descending] = ACTIONS(3077),
    [anon_sym_group] = ACTIONS(3077),
    [anon_sym_by] = ACTIONS(3077),
    [anon_sym_select] = ACTIONS(3077),
    [anon_sym_DQUOTE] = ACTIONS(3077),
    [anon_sym_stackalloc] = ACTIONS(3077),
    [anon_sym_sizeof] = ACTIONS(3077),
    [anon_sym_typeof] = ACTIONS(3077),
    [anon_sym___makeref] = ACTIONS(3077),
    [anon_sym___reftype] = ACTIONS(3077),
    [anon_sym___refvalue] = ACTIONS(3077),
    [sym_null_literal] = ACTIONS(3077),
    [anon_sym_SQUOTE] = ACTIONS(3079),
    [sym_integer_literal] = ACTIONS(3077),
    [sym_real_literal] = ACTIONS(3079),
    [sym_verbatim_string_literal] = ACTIONS(3079),
    [sym_raw_string_literal] = ACTIONS(3079),
    [aux_sym_preproc_if_token1] = ACTIONS(3079),
    [aux_sym_preproc_if_token3] = ACTIONS(3079),
    [aux_sym_preproc_else_token1] = ACTIONS(3079),
    [aux_sym_preproc_elif_token1] = ACTIONS(3079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3079),
    [sym_interpolation_verbatim_start] = ACTIONS(3079),
    [sym_interpolation_raw_start] = ACTIONS(3079),
  },
  [2224] = {
    [sym_preproc_region] = STATE(2224),
    [sym_preproc_endregion] = STATE(2224),
    [sym_preproc_line] = STATE(2224),
    [sym_preproc_pragma] = STATE(2224),
    [sym_preproc_nullable] = STATE(2224),
    [sym_preproc_error] = STATE(2224),
    [sym_preproc_define] = STATE(2224),
    [sym_preproc_undef] = STATE(2224),
    [ts_builtin_sym_end] = ACTIONS(2977),
    [sym__identifier_token] = ACTIONS(2975),
    [anon_sym_extern] = ACTIONS(2975),
    [anon_sym_alias] = ACTIONS(2975),
    [anon_sym_SEMI] = ACTIONS(2977),
    [anon_sym_global] = ACTIONS(2975),
    [anon_sym_using] = ACTIONS(2975),
    [anon_sym_unsafe] = ACTIONS(2975),
    [anon_sym_static] = ACTIONS(2975),
    [anon_sym_LBRACK] = ACTIONS(2977),
    [anon_sym_LPAREN] = ACTIONS(2977),
    [anon_sym_return] = ACTIONS(2975),
    [anon_sym_namespace] = ACTIONS(2975),
    [anon_sym_class] = ACTIONS(2975),
    [anon_sym_ref] = ACTIONS(2975),
    [anon_sym_struct] = ACTIONS(2975),
    [anon_sym_enum] = ACTIONS(2975),
    [anon_sym_LBRACE] = ACTIONS(2977),
    [anon_sym_interface] = ACTIONS(2975),
    [anon_sym_delegate] = ACTIONS(2975),
    [anon_sym_record] = ACTIONS(2975),
    [anon_sym_abstract] = ACTIONS(2975),
    [anon_sym_async] = ACTIONS(2975),
    [anon_sym_const] = ACTIONS(2975),
    [anon_sym_file] = ACTIONS(2975),
    [anon_sym_fixed] = ACTIONS(2975),
    [anon_sym_internal] = ACTIONS(2975),
    [anon_sym_new] = ACTIONS(2975),
    [anon_sym_override] = ACTIONS(2975),
    [anon_sym_partial] = ACTIONS(2975),
    [anon_sym_private] = ACTIONS(2975),
    [anon_sym_protected] = ACTIONS(2975),
    [anon_sym_public] = ACTIONS(2975),
    [anon_sym_readonly] = ACTIONS(2975),
    [anon_sym_required] = ACTIONS(2975),
    [anon_sym_sealed] = ACTIONS(2975),
    [anon_sym_virtual] = ACTIONS(2975),
    [anon_sym_volatile] = ACTIONS(2975),
    [anon_sym_where] = ACTIONS(2975),
    [anon_sym_notnull] = ACTIONS(2975),
    [anon_sym_unmanaged] = ACTIONS(2975),
    [anon_sym_checked] = ACTIONS(2975),
    [anon_sym_BANG] = ACTIONS(2977),
    [anon_sym_TILDE] = ACTIONS(2977),
    [anon_sym_PLUS_PLUS] = ACTIONS(2977),
    [anon_sym_DASH_DASH] = ACTIONS(2977),
    [anon_sym_true] = ACTIONS(2975),
    [anon_sym_false] = ACTIONS(2975),
    [anon_sym_PLUS] = ACTIONS(2975),
    [anon_sym_DASH] = ACTIONS(2975),
    [anon_sym_STAR] = ACTIONS(2977),
    [anon_sym_CARET] = ACTIONS(2977),
    [anon_sym_AMP] = ACTIONS(2977),
    [anon_sym_this] = ACTIONS(2975),
    [anon_sym_scoped] = ACTIONS(2975),
    [anon_sym_var] = ACTIONS(2975),
    [sym_predefined_type] = ACTIONS(2975),
    [anon_sym_break] = ACTIONS(2975),
    [anon_sym_unchecked] = ACTIONS(2975),
    [anon_sym_continue] = ACTIONS(2975),
    [anon_sym_do] = ACTIONS(2975),
    [anon_sym_while] = ACTIONS(2975),
    [anon_sym_for] = ACTIONS(2975),
    [anon_sym_lock] = ACTIONS(2975),
    [anon_sym_yield] = ACTIONS(2975),
    [anon_sym_switch] = ACTIONS(2975),
    [anon_sym_default] = ACTIONS(2975),
    [anon_sym_throw] = ACTIONS(2975),
    [anon_sym_try] = ACTIONS(2975),
    [anon_sym_catch] = ACTIONS(2975),
    [anon_sym_when] = ACTIONS(2975),
    [anon_sym_finally] = ACTIONS(2975),
    [anon_sym_await] = ACTIONS(2975),
    [anon_sym_foreach] = ACTIONS(2975),
    [anon_sym_goto] = ACTIONS(2975),
    [anon_sym_if] = ACTIONS(2975),
    [anon_sym_else] = ACTIONS(2975),
    [anon_sym_DOT_DOT] = ACTIONS(2977),
    [anon_sym_from] = ACTIONS(2975),
    [anon_sym_into] = ACTIONS(2975),
    [anon_sym_join] = ACTIONS(2975),
    [anon_sym_on] = ACTIONS(2975),
    [anon_sym_equals] = ACTIONS(2975),
    [anon_sym_let] = ACTIONS(2975),
    [anon_sym_orderby] = ACTIONS(2975),
    [anon_sym_ascending] = ACTIONS(2975),
    [anon_sym_descending] = ACTIONS(2975),
    [anon_sym_group] = ACTIONS(2975),
    [anon_sym_by] = ACTIONS(2975),
    [anon_sym_select] = ACTIONS(2975),
    [anon_sym_DQUOTE] = ACTIONS(2975),
    [anon_sym_stackalloc] = ACTIONS(2975),
    [anon_sym_sizeof] = ACTIONS(2975),
    [anon_sym_typeof] = ACTIONS(2975),
    [anon_sym___makeref] = ACTIONS(2975),
    [anon_sym___reftype] = ACTIONS(2975),
    [anon_sym___refvalue] = ACTIONS(2975),
    [sym_null_literal] = ACTIONS(2975),
    [anon_sym_SQUOTE] = ACTIONS(2977),
    [sym_integer_literal] = ACTIONS(2975),
    [sym_real_literal] = ACTIONS(2977),
    [sym_verbatim_string_literal] = ACTIONS(2977),
    [sym_raw_string_literal] = ACTIONS(2977),
    [aux_sym_preproc_if_token1] = ACTIONS(2977),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(2977),
    [sym_interpolation_verbatim_start] = ACTIONS(2977),
    [sym_interpolation_raw_start] = ACTIONS(2977),
  },
  [2225] = {
    [sym_preproc_region] = STATE(2225),
    [sym_preproc_endregion] = STATE(2225),
    [sym_preproc_line] = STATE(2225),
    [sym_preproc_pragma] = STATE(2225),
    [sym_preproc_nullable] = STATE(2225),
    [sym_preproc_error] = STATE(2225),
    [sym_preproc_define] = STATE(2225),
    [sym_preproc_undef] = STATE(2225),
    [sym__identifier_token] = ACTIONS(3081),
    [anon_sym_extern] = ACTIONS(3081),
    [anon_sym_alias] = ACTIONS(3081),
    [anon_sym_SEMI] = ACTIONS(3083),
    [anon_sym_global] = ACTIONS(3081),
    [anon_sym_using] = ACTIONS(3081),
    [anon_sym_unsafe] = ACTIONS(3081),
    [anon_sym_static] = ACTIONS(3081),
    [anon_sym_LBRACK] = ACTIONS(3083),
    [anon_sym_LPAREN] = ACTIONS(3083),
    [anon_sym_return] = ACTIONS(3081),
    [anon_sym_namespace] = ACTIONS(3081),
    [anon_sym_class] = ACTIONS(3081),
    [anon_sym_ref] = ACTIONS(3081),
    [anon_sym_struct] = ACTIONS(3081),
    [anon_sym_enum] = ACTIONS(3081),
    [anon_sym_LBRACE] = ACTIONS(3083),
    [anon_sym_interface] = ACTIONS(3081),
    [anon_sym_delegate] = ACTIONS(3081),
    [anon_sym_record] = ACTIONS(3081),
    [anon_sym_abstract] = ACTIONS(3081),
    [anon_sym_async] = ACTIONS(3081),
    [anon_sym_const] = ACTIONS(3081),
    [anon_sym_file] = ACTIONS(3081),
    [anon_sym_fixed] = ACTIONS(3081),
    [anon_sym_internal] = ACTIONS(3081),
    [anon_sym_new] = ACTIONS(3081),
    [anon_sym_override] = ACTIONS(3081),
    [anon_sym_partial] = ACTIONS(3081),
    [anon_sym_private] = ACTIONS(3081),
    [anon_sym_protected] = ACTIONS(3081),
    [anon_sym_public] = ACTIONS(3081),
    [anon_sym_readonly] = ACTIONS(3081),
    [anon_sym_required] = ACTIONS(3081),
    [anon_sym_sealed] = ACTIONS(3081),
    [anon_sym_virtual] = ACTIONS(3081),
    [anon_sym_volatile] = ACTIONS(3081),
    [anon_sym_where] = ACTIONS(3081),
    [anon_sym_notnull] = ACTIONS(3081),
    [anon_sym_unmanaged] = ACTIONS(3081),
    [anon_sym_checked] = ACTIONS(3081),
    [anon_sym_BANG] = ACTIONS(3083),
    [anon_sym_TILDE] = ACTIONS(3083),
    [anon_sym_PLUS_PLUS] = ACTIONS(3083),
    [anon_sym_DASH_DASH] = ACTIONS(3083),
    [anon_sym_true] = ACTIONS(3081),
    [anon_sym_false] = ACTIONS(3081),
    [anon_sym_PLUS] = ACTIONS(3081),
    [anon_sym_DASH] = ACTIONS(3081),
    [anon_sym_STAR] = ACTIONS(3083),
    [anon_sym_CARET] = ACTIONS(3083),
    [anon_sym_AMP] = ACTIONS(3083),
    [anon_sym_this] = ACTIONS(3081),
    [anon_sym_scoped] = ACTIONS(3081),
    [anon_sym_var] = ACTIONS(3081),
    [sym_predefined_type] = ACTIONS(3081),
    [anon_sym_break] = ACTIONS(3081),
    [anon_sym_unchecked] = ACTIONS(3081),
    [anon_sym_continue] = ACTIONS(3081),
    [anon_sym_do] = ACTIONS(3081),
    [anon_sym_while] = ACTIONS(3081),
    [anon_sym_for] = ACTIONS(3081),
    [anon_sym_lock] = ACTIONS(3081),
    [anon_sym_yield] = ACTIONS(3081),
    [anon_sym_switch] = ACTIONS(3081),
    [anon_sym_default] = ACTIONS(3081),
    [anon_sym_throw] = ACTIONS(3081),
    [anon_sym_try] = ACTIONS(3081),
    [anon_sym_when] = ACTIONS(3081),
    [anon_sym_await] = ACTIONS(3081),
    [anon_sym_foreach] = ACTIONS(3081),
    [anon_sym_goto] = ACTIONS(3081),
    [anon_sym_if] = ACTIONS(3081),
    [anon_sym_else] = ACTIONS(3081),
    [anon_sym_DOT_DOT] = ACTIONS(3083),
    [anon_sym_from] = ACTIONS(3081),
    [anon_sym_into] = ACTIONS(3081),
    [anon_sym_join] = ACTIONS(3081),
    [anon_sym_on] = ACTIONS(3081),
    [anon_sym_equals] = ACTIONS(3081),
    [anon_sym_let] = ACTIONS(3081),
    [anon_sym_orderby] = ACTIONS(3081),
    [anon_sym_ascending] = ACTIONS(3081),
    [anon_sym_descending] = ACTIONS(3081),
    [anon_sym_group] = ACTIONS(3081),
    [anon_sym_by] = ACTIONS(3081),
    [anon_sym_select] = ACTIONS(3081),
    [anon_sym_DQUOTE] = ACTIONS(3081),
    [anon_sym_stackalloc] = ACTIONS(3081),
    [anon_sym_sizeof] = ACTIONS(3081),
    [anon_sym_typeof] = ACTIONS(3081),
    [anon_sym___makeref] = ACTIONS(3081),
    [anon_sym___reftype] = ACTIONS(3081),
    [anon_sym___refvalue] = ACTIONS(3081),
    [sym_null_literal] = ACTIONS(3081),
    [anon_sym_SQUOTE] = ACTIONS(3083),
    [sym_integer_literal] = ACTIONS(3081),
    [sym_real_literal] = ACTIONS(3083),
    [sym_verbatim_string_literal] = ACTIONS(3083),
    [sym_raw_string_literal] = ACTIONS(3083),
    [aux_sym_preproc_if_token1] = ACTIONS(3083),
    [aux_sym_preproc_if_token3] = ACTIONS(3083),
    [aux_sym_preproc_else_token1] = ACTIONS(3083),
    [aux_sym_preproc_elif_token1] = ACTIONS(3083),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3083),
    [sym_interpolation_verbatim_start] = ACTIONS(3083),
    [sym_interpolation_raw_start] = ACTIONS(3083),
  },
  [2226] = {
    [sym_preproc_region] = STATE(2226),
    [sym_preproc_endregion] = STATE(2226),
    [sym_preproc_line] = STATE(2226),
    [sym_preproc_pragma] = STATE(2226),
    [sym_preproc_nullable] = STATE(2226),
    [sym_preproc_error] = STATE(2226),
    [sym_preproc_define] = STATE(2226),
    [sym_preproc_undef] = STATE(2226),
    [sym__identifier_token] = ACTIONS(3085),
    [anon_sym_extern] = ACTIONS(3085),
    [anon_sym_alias] = ACTIONS(3085),
    [anon_sym_SEMI] = ACTIONS(3087),
    [anon_sym_global] = ACTIONS(3085),
    [anon_sym_using] = ACTIONS(3085),
    [anon_sym_unsafe] = ACTIONS(3085),
    [anon_sym_static] = ACTIONS(3085),
    [anon_sym_LBRACK] = ACTIONS(3087),
    [anon_sym_LPAREN] = ACTIONS(3087),
    [anon_sym_return] = ACTIONS(3085),
    [anon_sym_namespace] = ACTIONS(3085),
    [anon_sym_class] = ACTIONS(3085),
    [anon_sym_ref] = ACTIONS(3085),
    [anon_sym_struct] = ACTIONS(3085),
    [anon_sym_enum] = ACTIONS(3085),
    [anon_sym_LBRACE] = ACTIONS(3087),
    [anon_sym_interface] = ACTIONS(3085),
    [anon_sym_delegate] = ACTIONS(3085),
    [anon_sym_record] = ACTIONS(3085),
    [anon_sym_abstract] = ACTIONS(3085),
    [anon_sym_async] = ACTIONS(3085),
    [anon_sym_const] = ACTIONS(3085),
    [anon_sym_file] = ACTIONS(3085),
    [anon_sym_fixed] = ACTIONS(3085),
    [anon_sym_internal] = ACTIONS(3085),
    [anon_sym_new] = ACTIONS(3085),
    [anon_sym_override] = ACTIONS(3085),
    [anon_sym_partial] = ACTIONS(3085),
    [anon_sym_private] = ACTIONS(3085),
    [anon_sym_protected] = ACTIONS(3085),
    [anon_sym_public] = ACTIONS(3085),
    [anon_sym_readonly] = ACTIONS(3085),
    [anon_sym_required] = ACTIONS(3085),
    [anon_sym_sealed] = ACTIONS(3085),
    [anon_sym_virtual] = ACTIONS(3085),
    [anon_sym_volatile] = ACTIONS(3085),
    [anon_sym_where] = ACTIONS(3085),
    [anon_sym_notnull] = ACTIONS(3085),
    [anon_sym_unmanaged] = ACTIONS(3085),
    [anon_sym_checked] = ACTIONS(3085),
    [anon_sym_BANG] = ACTIONS(3087),
    [anon_sym_TILDE] = ACTIONS(3087),
    [anon_sym_PLUS_PLUS] = ACTIONS(3087),
    [anon_sym_DASH_DASH] = ACTIONS(3087),
    [anon_sym_true] = ACTIONS(3085),
    [anon_sym_false] = ACTIONS(3085),
    [anon_sym_PLUS] = ACTIONS(3085),
    [anon_sym_DASH] = ACTIONS(3085),
    [anon_sym_STAR] = ACTIONS(3087),
    [anon_sym_CARET] = ACTIONS(3087),
    [anon_sym_AMP] = ACTIONS(3087),
    [anon_sym_this] = ACTIONS(3085),
    [anon_sym_scoped] = ACTIONS(3085),
    [anon_sym_var] = ACTIONS(3085),
    [sym_predefined_type] = ACTIONS(3085),
    [anon_sym_break] = ACTIONS(3085),
    [anon_sym_unchecked] = ACTIONS(3085),
    [anon_sym_continue] = ACTIONS(3085),
    [anon_sym_do] = ACTIONS(3085),
    [anon_sym_while] = ACTIONS(3085),
    [anon_sym_for] = ACTIONS(3085),
    [anon_sym_lock] = ACTIONS(3085),
    [anon_sym_yield] = ACTIONS(3085),
    [anon_sym_switch] = ACTIONS(3085),
    [anon_sym_default] = ACTIONS(3085),
    [anon_sym_throw] = ACTIONS(3085),
    [anon_sym_try] = ACTIONS(3085),
    [anon_sym_when] = ACTIONS(3085),
    [anon_sym_await] = ACTIONS(3085),
    [anon_sym_foreach] = ACTIONS(3085),
    [anon_sym_goto] = ACTIONS(3085),
    [anon_sym_if] = ACTIONS(3085),
    [anon_sym_else] = ACTIONS(3085),
    [anon_sym_DOT_DOT] = ACTIONS(3087),
    [anon_sym_from] = ACTIONS(3085),
    [anon_sym_into] = ACTIONS(3085),
    [anon_sym_join] = ACTIONS(3085),
    [anon_sym_on] = ACTIONS(3085),
    [anon_sym_equals] = ACTIONS(3085),
    [anon_sym_let] = ACTIONS(3085),
    [anon_sym_orderby] = ACTIONS(3085),
    [anon_sym_ascending] = ACTIONS(3085),
    [anon_sym_descending] = ACTIONS(3085),
    [anon_sym_group] = ACTIONS(3085),
    [anon_sym_by] = ACTIONS(3085),
    [anon_sym_select] = ACTIONS(3085),
    [anon_sym_DQUOTE] = ACTIONS(3085),
    [anon_sym_stackalloc] = ACTIONS(3085),
    [anon_sym_sizeof] = ACTIONS(3085),
    [anon_sym_typeof] = ACTIONS(3085),
    [anon_sym___makeref] = ACTIONS(3085),
    [anon_sym___reftype] = ACTIONS(3085),
    [anon_sym___refvalue] = ACTIONS(3085),
    [sym_null_literal] = ACTIONS(3085),
    [anon_sym_SQUOTE] = ACTIONS(3087),
    [sym_integer_literal] = ACTIONS(3085),
    [sym_real_literal] = ACTIONS(3087),
    [sym_verbatim_string_literal] = ACTIONS(3087),
    [sym_raw_string_literal] = ACTIONS(3087),
    [aux_sym_preproc_if_token1] = ACTIONS(3087),
    [aux_sym_preproc_if_token3] = ACTIONS(3087),
    [aux_sym_preproc_else_token1] = ACTIONS(3087),
    [aux_sym_preproc_elif_token1] = ACTIONS(3087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3087),
    [sym_interpolation_verbatim_start] = ACTIONS(3087),
    [sym_interpolation_raw_start] = ACTIONS(3087),
  },
  [2227] = {
    [sym_preproc_region] = STATE(2227),
    [sym_preproc_endregion] = STATE(2227),
    [sym_preproc_line] = STATE(2227),
    [sym_preproc_pragma] = STATE(2227),
    [sym_preproc_nullable] = STATE(2227),
    [sym_preproc_error] = STATE(2227),
    [sym_preproc_define] = STATE(2227),
    [sym_preproc_undef] = STATE(2227),
    [sym__identifier_token] = ACTIONS(3089),
    [anon_sym_extern] = ACTIONS(3089),
    [anon_sym_alias] = ACTIONS(3089),
    [anon_sym_SEMI] = ACTIONS(3091),
    [anon_sym_global] = ACTIONS(3089),
    [anon_sym_using] = ACTIONS(3089),
    [anon_sym_unsafe] = ACTIONS(3089),
    [anon_sym_static] = ACTIONS(3089),
    [anon_sym_LBRACK] = ACTIONS(3091),
    [anon_sym_LPAREN] = ACTIONS(3091),
    [anon_sym_return] = ACTIONS(3089),
    [anon_sym_namespace] = ACTIONS(3089),
    [anon_sym_class] = ACTIONS(3089),
    [anon_sym_ref] = ACTIONS(3089),
    [anon_sym_struct] = ACTIONS(3089),
    [anon_sym_enum] = ACTIONS(3089),
    [anon_sym_LBRACE] = ACTIONS(3091),
    [anon_sym_interface] = ACTIONS(3089),
    [anon_sym_delegate] = ACTIONS(3089),
    [anon_sym_record] = ACTIONS(3089),
    [anon_sym_abstract] = ACTIONS(3089),
    [anon_sym_async] = ACTIONS(3089),
    [anon_sym_const] = ACTIONS(3089),
    [anon_sym_file] = ACTIONS(3089),
    [anon_sym_fixed] = ACTIONS(3089),
    [anon_sym_internal] = ACTIONS(3089),
    [anon_sym_new] = ACTIONS(3089),
    [anon_sym_override] = ACTIONS(3089),
    [anon_sym_partial] = ACTIONS(3089),
    [anon_sym_private] = ACTIONS(3089),
    [anon_sym_protected] = ACTIONS(3089),
    [anon_sym_public] = ACTIONS(3089),
    [anon_sym_readonly] = ACTIONS(3089),
    [anon_sym_required] = ACTIONS(3089),
    [anon_sym_sealed] = ACTIONS(3089),
    [anon_sym_virtual] = ACTIONS(3089),
    [anon_sym_volatile] = ACTIONS(3089),
    [anon_sym_where] = ACTIONS(3089),
    [anon_sym_notnull] = ACTIONS(3089),
    [anon_sym_unmanaged] = ACTIONS(3089),
    [anon_sym_checked] = ACTIONS(3089),
    [anon_sym_BANG] = ACTIONS(3091),
    [anon_sym_TILDE] = ACTIONS(3091),
    [anon_sym_PLUS_PLUS] = ACTIONS(3091),
    [anon_sym_DASH_DASH] = ACTIONS(3091),
    [anon_sym_true] = ACTIONS(3089),
    [anon_sym_false] = ACTIONS(3089),
    [anon_sym_PLUS] = ACTIONS(3089),
    [anon_sym_DASH] = ACTIONS(3089),
    [anon_sym_STAR] = ACTIONS(3091),
    [anon_sym_CARET] = ACTIONS(3091),
    [anon_sym_AMP] = ACTIONS(3091),
    [anon_sym_this] = ACTIONS(3089),
    [anon_sym_scoped] = ACTIONS(3089),
    [anon_sym_var] = ACTIONS(3089),
    [sym_predefined_type] = ACTIONS(3089),
    [anon_sym_break] = ACTIONS(3089),
    [anon_sym_unchecked] = ACTIONS(3089),
    [anon_sym_continue] = ACTIONS(3089),
    [anon_sym_do] = ACTIONS(3089),
    [anon_sym_while] = ACTIONS(3089),
    [anon_sym_for] = ACTIONS(3089),
    [anon_sym_lock] = ACTIONS(3089),
    [anon_sym_yield] = ACTIONS(3089),
    [anon_sym_switch] = ACTIONS(3089),
    [anon_sym_default] = ACTIONS(3089),
    [anon_sym_throw] = ACTIONS(3089),
    [anon_sym_try] = ACTIONS(3089),
    [anon_sym_when] = ACTIONS(3089),
    [anon_sym_await] = ACTIONS(3089),
    [anon_sym_foreach] = ACTIONS(3089),
    [anon_sym_goto] = ACTIONS(3089),
    [anon_sym_if] = ACTIONS(3089),
    [anon_sym_else] = ACTIONS(3089),
    [anon_sym_DOT_DOT] = ACTIONS(3091),
    [anon_sym_from] = ACTIONS(3089),
    [anon_sym_into] = ACTIONS(3089),
    [anon_sym_join] = ACTIONS(3089),
    [anon_sym_on] = ACTIONS(3089),
    [anon_sym_equals] = ACTIONS(3089),
    [anon_sym_let] = ACTIONS(3089),
    [anon_sym_orderby] = ACTIONS(3089),
    [anon_sym_ascending] = ACTIONS(3089),
    [anon_sym_descending] = ACTIONS(3089),
    [anon_sym_group] = ACTIONS(3089),
    [anon_sym_by] = ACTIONS(3089),
    [anon_sym_select] = ACTIONS(3089),
    [anon_sym_DQUOTE] = ACTIONS(3089),
    [anon_sym_stackalloc] = ACTIONS(3089),
    [anon_sym_sizeof] = ACTIONS(3089),
    [anon_sym_typeof] = ACTIONS(3089),
    [anon_sym___makeref] = ACTIONS(3089),
    [anon_sym___reftype] = ACTIONS(3089),
    [anon_sym___refvalue] = ACTIONS(3089),
    [sym_null_literal] = ACTIONS(3089),
    [anon_sym_SQUOTE] = ACTIONS(3091),
    [sym_integer_literal] = ACTIONS(3089),
    [sym_real_literal] = ACTIONS(3091),
    [sym_verbatim_string_literal] = ACTIONS(3091),
    [sym_raw_string_literal] = ACTIONS(3091),
    [aux_sym_preproc_if_token1] = ACTIONS(3091),
    [aux_sym_preproc_if_token3] = ACTIONS(3091),
    [aux_sym_preproc_else_token1] = ACTIONS(3091),
    [aux_sym_preproc_elif_token1] = ACTIONS(3091),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3091),
    [sym_interpolation_verbatim_start] = ACTIONS(3091),
    [sym_interpolation_raw_start] = ACTIONS(3091),
  },
  [2228] = {
    [sym_preproc_region] = STATE(2228),
    [sym_preproc_endregion] = STATE(2228),
    [sym_preproc_line] = STATE(2228),
    [sym_preproc_pragma] = STATE(2228),
    [sym_preproc_nullable] = STATE(2228),
    [sym_preproc_error] = STATE(2228),
    [sym_preproc_define] = STATE(2228),
    [sym_preproc_undef] = STATE(2228),
    [sym__identifier_token] = ACTIONS(3093),
    [anon_sym_extern] = ACTIONS(3093),
    [anon_sym_alias] = ACTIONS(3093),
    [anon_sym_SEMI] = ACTIONS(3095),
    [anon_sym_global] = ACTIONS(3093),
    [anon_sym_using] = ACTIONS(3093),
    [anon_sym_unsafe] = ACTIONS(3093),
    [anon_sym_static] = ACTIONS(3093),
    [anon_sym_LBRACK] = ACTIONS(3095),
    [anon_sym_LPAREN] = ACTIONS(3095),
    [anon_sym_return] = ACTIONS(3093),
    [anon_sym_namespace] = ACTIONS(3093),
    [anon_sym_class] = ACTIONS(3093),
    [anon_sym_ref] = ACTIONS(3093),
    [anon_sym_struct] = ACTIONS(3093),
    [anon_sym_enum] = ACTIONS(3093),
    [anon_sym_LBRACE] = ACTIONS(3095),
    [anon_sym_interface] = ACTIONS(3093),
    [anon_sym_delegate] = ACTIONS(3093),
    [anon_sym_record] = ACTIONS(3093),
    [anon_sym_abstract] = ACTIONS(3093),
    [anon_sym_async] = ACTIONS(3093),
    [anon_sym_const] = ACTIONS(3093),
    [anon_sym_file] = ACTIONS(3093),
    [anon_sym_fixed] = ACTIONS(3093),
    [anon_sym_internal] = ACTIONS(3093),
    [anon_sym_new] = ACTIONS(3093),
    [anon_sym_override] = ACTIONS(3093),
    [anon_sym_partial] = ACTIONS(3093),
    [anon_sym_private] = ACTIONS(3093),
    [anon_sym_protected] = ACTIONS(3093),
    [anon_sym_public] = ACTIONS(3093),
    [anon_sym_readonly] = ACTIONS(3093),
    [anon_sym_required] = ACTIONS(3093),
    [anon_sym_sealed] = ACTIONS(3093),
    [anon_sym_virtual] = ACTIONS(3093),
    [anon_sym_volatile] = ACTIONS(3093),
    [anon_sym_where] = ACTIONS(3093),
    [anon_sym_notnull] = ACTIONS(3093),
    [anon_sym_unmanaged] = ACTIONS(3093),
    [anon_sym_checked] = ACTIONS(3093),
    [anon_sym_BANG] = ACTIONS(3095),
    [anon_sym_TILDE] = ACTIONS(3095),
    [anon_sym_PLUS_PLUS] = ACTIONS(3095),
    [anon_sym_DASH_DASH] = ACTIONS(3095),
    [anon_sym_true] = ACTIONS(3093),
    [anon_sym_false] = ACTIONS(3093),
    [anon_sym_PLUS] = ACTIONS(3093),
    [anon_sym_DASH] = ACTIONS(3093),
    [anon_sym_STAR] = ACTIONS(3095),
    [anon_sym_CARET] = ACTIONS(3095),
    [anon_sym_AMP] = ACTIONS(3095),
    [anon_sym_this] = ACTIONS(3093),
    [anon_sym_scoped] = ACTIONS(3093),
    [anon_sym_var] = ACTIONS(3093),
    [sym_predefined_type] = ACTIONS(3093),
    [anon_sym_break] = ACTIONS(3093),
    [anon_sym_unchecked] = ACTIONS(3093),
    [anon_sym_continue] = ACTIONS(3093),
    [anon_sym_do] = ACTIONS(3093),
    [anon_sym_while] = ACTIONS(3093),
    [anon_sym_for] = ACTIONS(3093),
    [anon_sym_lock] = ACTIONS(3093),
    [anon_sym_yield] = ACTIONS(3093),
    [anon_sym_switch] = ACTIONS(3093),
    [anon_sym_default] = ACTIONS(3093),
    [anon_sym_throw] = ACTIONS(3093),
    [anon_sym_try] = ACTIONS(3093),
    [anon_sym_when] = ACTIONS(3093),
    [anon_sym_await] = ACTIONS(3093),
    [anon_sym_foreach] = ACTIONS(3093),
    [anon_sym_goto] = ACTIONS(3093),
    [anon_sym_if] = ACTIONS(3093),
    [anon_sym_else] = ACTIONS(3093),
    [anon_sym_DOT_DOT] = ACTIONS(3095),
    [anon_sym_from] = ACTIONS(3093),
    [anon_sym_into] = ACTIONS(3093),
    [anon_sym_join] = ACTIONS(3093),
    [anon_sym_on] = ACTIONS(3093),
    [anon_sym_equals] = ACTIONS(3093),
    [anon_sym_let] = ACTIONS(3093),
    [anon_sym_orderby] = ACTIONS(3093),
    [anon_sym_ascending] = ACTIONS(3093),
    [anon_sym_descending] = ACTIONS(3093),
    [anon_sym_group] = ACTIONS(3093),
    [anon_sym_by] = ACTIONS(3093),
    [anon_sym_select] = ACTIONS(3093),
    [anon_sym_DQUOTE] = ACTIONS(3093),
    [anon_sym_stackalloc] = ACTIONS(3093),
    [anon_sym_sizeof] = ACTIONS(3093),
    [anon_sym_typeof] = ACTIONS(3093),
    [anon_sym___makeref] = ACTIONS(3093),
    [anon_sym___reftype] = ACTIONS(3093),
    [anon_sym___refvalue] = ACTIONS(3093),
    [sym_null_literal] = ACTIONS(3093),
    [anon_sym_SQUOTE] = ACTIONS(3095),
    [sym_integer_literal] = ACTIONS(3093),
    [sym_real_literal] = ACTIONS(3095),
    [sym_verbatim_string_literal] = ACTIONS(3095),
    [sym_raw_string_literal] = ACTIONS(3095),
    [aux_sym_preproc_if_token1] = ACTIONS(3095),
    [aux_sym_preproc_if_token3] = ACTIONS(3095),
    [aux_sym_preproc_else_token1] = ACTIONS(3095),
    [aux_sym_preproc_elif_token1] = ACTIONS(3095),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3095),
    [sym_interpolation_verbatim_start] = ACTIONS(3095),
    [sym_interpolation_raw_start] = ACTIONS(3095),
  },
  [2229] = {
    [sym_preproc_region] = STATE(2229),
    [sym_preproc_endregion] = STATE(2229),
    [sym_preproc_line] = STATE(2229),
    [sym_preproc_pragma] = STATE(2229),
    [sym_preproc_nullable] = STATE(2229),
    [sym_preproc_error] = STATE(2229),
    [sym_preproc_define] = STATE(2229),
    [sym_preproc_undef] = STATE(2229),
    [sym__identifier_token] = ACTIONS(3097),
    [anon_sym_extern] = ACTIONS(3097),
    [anon_sym_alias] = ACTIONS(3097),
    [anon_sym_SEMI] = ACTIONS(3099),
    [anon_sym_global] = ACTIONS(3097),
    [anon_sym_using] = ACTIONS(3097),
    [anon_sym_unsafe] = ACTIONS(3097),
    [anon_sym_static] = ACTIONS(3097),
    [anon_sym_LBRACK] = ACTIONS(3099),
    [anon_sym_LPAREN] = ACTIONS(3099),
    [anon_sym_return] = ACTIONS(3097),
    [anon_sym_namespace] = ACTIONS(3097),
    [anon_sym_class] = ACTIONS(3097),
    [anon_sym_ref] = ACTIONS(3097),
    [anon_sym_struct] = ACTIONS(3097),
    [anon_sym_enum] = ACTIONS(3097),
    [anon_sym_LBRACE] = ACTIONS(3099),
    [anon_sym_interface] = ACTIONS(3097),
    [anon_sym_delegate] = ACTIONS(3097),
    [anon_sym_record] = ACTIONS(3097),
    [anon_sym_abstract] = ACTIONS(3097),
    [anon_sym_async] = ACTIONS(3097),
    [anon_sym_const] = ACTIONS(3097),
    [anon_sym_file] = ACTIONS(3097),
    [anon_sym_fixed] = ACTIONS(3097),
    [anon_sym_internal] = ACTIONS(3097),
    [anon_sym_new] = ACTIONS(3097),
    [anon_sym_override] = ACTIONS(3097),
    [anon_sym_partial] = ACTIONS(3097),
    [anon_sym_private] = ACTIONS(3097),
    [anon_sym_protected] = ACTIONS(3097),
    [anon_sym_public] = ACTIONS(3097),
    [anon_sym_readonly] = ACTIONS(3097),
    [anon_sym_required] = ACTIONS(3097),
    [anon_sym_sealed] = ACTIONS(3097),
    [anon_sym_virtual] = ACTIONS(3097),
    [anon_sym_volatile] = ACTIONS(3097),
    [anon_sym_where] = ACTIONS(3097),
    [anon_sym_notnull] = ACTIONS(3097),
    [anon_sym_unmanaged] = ACTIONS(3097),
    [anon_sym_checked] = ACTIONS(3097),
    [anon_sym_BANG] = ACTIONS(3099),
    [anon_sym_TILDE] = ACTIONS(3099),
    [anon_sym_PLUS_PLUS] = ACTIONS(3099),
    [anon_sym_DASH_DASH] = ACTIONS(3099),
    [anon_sym_true] = ACTIONS(3097),
    [anon_sym_false] = ACTIONS(3097),
    [anon_sym_PLUS] = ACTIONS(3097),
    [anon_sym_DASH] = ACTIONS(3097),
    [anon_sym_STAR] = ACTIONS(3099),
    [anon_sym_CARET] = ACTIONS(3099),
    [anon_sym_AMP] = ACTIONS(3099),
    [anon_sym_this] = ACTIONS(3097),
    [anon_sym_scoped] = ACTIONS(3097),
    [anon_sym_var] = ACTIONS(3097),
    [sym_predefined_type] = ACTIONS(3097),
    [anon_sym_break] = ACTIONS(3097),
    [anon_sym_unchecked] = ACTIONS(3097),
    [anon_sym_continue] = ACTIONS(3097),
    [anon_sym_do] = ACTIONS(3097),
    [anon_sym_while] = ACTIONS(3097),
    [anon_sym_for] = ACTIONS(3097),
    [anon_sym_lock] = ACTIONS(3097),
    [anon_sym_yield] = ACTIONS(3097),
    [anon_sym_switch] = ACTIONS(3097),
    [anon_sym_default] = ACTIONS(3097),
    [anon_sym_throw] = ACTIONS(3097),
    [anon_sym_try] = ACTIONS(3097),
    [anon_sym_when] = ACTIONS(3097),
    [anon_sym_await] = ACTIONS(3097),
    [anon_sym_foreach] = ACTIONS(3097),
    [anon_sym_goto] = ACTIONS(3097),
    [anon_sym_if] = ACTIONS(3097),
    [anon_sym_else] = ACTIONS(3097),
    [anon_sym_DOT_DOT] = ACTIONS(3099),
    [anon_sym_from] = ACTIONS(3097),
    [anon_sym_into] = ACTIONS(3097),
    [anon_sym_join] = ACTIONS(3097),
    [anon_sym_on] = ACTIONS(3097),
    [anon_sym_equals] = ACTIONS(3097),
    [anon_sym_let] = ACTIONS(3097),
    [anon_sym_orderby] = ACTIONS(3097),
    [anon_sym_ascending] = ACTIONS(3097),
    [anon_sym_descending] = ACTIONS(3097),
    [anon_sym_group] = ACTIONS(3097),
    [anon_sym_by] = ACTIONS(3097),
    [anon_sym_select] = ACTIONS(3097),
    [anon_sym_DQUOTE] = ACTIONS(3097),
    [anon_sym_stackalloc] = ACTIONS(3097),
    [anon_sym_sizeof] = ACTIONS(3097),
    [anon_sym_typeof] = ACTIONS(3097),
    [anon_sym___makeref] = ACTIONS(3097),
    [anon_sym___reftype] = ACTIONS(3097),
    [anon_sym___refvalue] = ACTIONS(3097),
    [sym_null_literal] = ACTIONS(3097),
    [anon_sym_SQUOTE] = ACTIONS(3099),
    [sym_integer_literal] = ACTIONS(3097),
    [sym_real_literal] = ACTIONS(3099),
    [sym_verbatim_string_literal] = ACTIONS(3099),
    [sym_raw_string_literal] = ACTIONS(3099),
    [aux_sym_preproc_if_token1] = ACTIONS(3099),
    [aux_sym_preproc_if_token3] = ACTIONS(3099),
    [aux_sym_preproc_else_token1] = ACTIONS(3099),
    [aux_sym_preproc_elif_token1] = ACTIONS(3099),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3099),
    [sym_interpolation_verbatim_start] = ACTIONS(3099),
    [sym_interpolation_raw_start] = ACTIONS(3099),
  },
  [2230] = {
    [sym_preproc_region] = STATE(2230),
    [sym_preproc_endregion] = STATE(2230),
    [sym_preproc_line] = STATE(2230),
    [sym_preproc_pragma] = STATE(2230),
    [sym_preproc_nullable] = STATE(2230),
    [sym_preproc_error] = STATE(2230),
    [sym_preproc_define] = STATE(2230),
    [sym_preproc_undef] = STATE(2230),
    [sym__identifier_token] = ACTIONS(3101),
    [anon_sym_extern] = ACTIONS(3101),
    [anon_sym_alias] = ACTIONS(3101),
    [anon_sym_SEMI] = ACTIONS(3103),
    [anon_sym_global] = ACTIONS(3101),
    [anon_sym_using] = ACTIONS(3101),
    [anon_sym_unsafe] = ACTIONS(3101),
    [anon_sym_static] = ACTIONS(3101),
    [anon_sym_LBRACK] = ACTIONS(3103),
    [anon_sym_LPAREN] = ACTIONS(3103),
    [anon_sym_return] = ACTIONS(3101),
    [anon_sym_namespace] = ACTIONS(3101),
    [anon_sym_class] = ACTIONS(3101),
    [anon_sym_ref] = ACTIONS(3101),
    [anon_sym_struct] = ACTIONS(3101),
    [anon_sym_enum] = ACTIONS(3101),
    [anon_sym_LBRACE] = ACTIONS(3103),
    [anon_sym_interface] = ACTIONS(3101),
    [anon_sym_delegate] = ACTIONS(3101),
    [anon_sym_record] = ACTIONS(3101),
    [anon_sym_abstract] = ACTIONS(3101),
    [anon_sym_async] = ACTIONS(3101),
    [anon_sym_const] = ACTIONS(3101),
    [anon_sym_file] = ACTIONS(3101),
    [anon_sym_fixed] = ACTIONS(3101),
    [anon_sym_internal] = ACTIONS(3101),
    [anon_sym_new] = ACTIONS(3101),
    [anon_sym_override] = ACTIONS(3101),
    [anon_sym_partial] = ACTIONS(3101),
    [anon_sym_private] = ACTIONS(3101),
    [anon_sym_protected] = ACTIONS(3101),
    [anon_sym_public] = ACTIONS(3101),
    [anon_sym_readonly] = ACTIONS(3101),
    [anon_sym_required] = ACTIONS(3101),
    [anon_sym_sealed] = ACTIONS(3101),
    [anon_sym_virtual] = ACTIONS(3101),
    [anon_sym_volatile] = ACTIONS(3101),
    [anon_sym_where] = ACTIONS(3101),
    [anon_sym_notnull] = ACTIONS(3101),
    [anon_sym_unmanaged] = ACTIONS(3101),
    [anon_sym_checked] = ACTIONS(3101),
    [anon_sym_BANG] = ACTIONS(3103),
    [anon_sym_TILDE] = ACTIONS(3103),
    [anon_sym_PLUS_PLUS] = ACTIONS(3103),
    [anon_sym_DASH_DASH] = ACTIONS(3103),
    [anon_sym_true] = ACTIONS(3101),
    [anon_sym_false] = ACTIONS(3101),
    [anon_sym_PLUS] = ACTIONS(3101),
    [anon_sym_DASH] = ACTIONS(3101),
    [anon_sym_STAR] = ACTIONS(3103),
    [anon_sym_CARET] = ACTIONS(3103),
    [anon_sym_AMP] = ACTIONS(3103),
    [anon_sym_this] = ACTIONS(3101),
    [anon_sym_scoped] = ACTIONS(3101),
    [anon_sym_var] = ACTIONS(3101),
    [sym_predefined_type] = ACTIONS(3101),
    [anon_sym_break] = ACTIONS(3101),
    [anon_sym_unchecked] = ACTIONS(3101),
    [anon_sym_continue] = ACTIONS(3101),
    [anon_sym_do] = ACTIONS(3101),
    [anon_sym_while] = ACTIONS(3101),
    [anon_sym_for] = ACTIONS(3101),
    [anon_sym_lock] = ACTIONS(3101),
    [anon_sym_yield] = ACTIONS(3101),
    [anon_sym_switch] = ACTIONS(3101),
    [anon_sym_default] = ACTIONS(3101),
    [anon_sym_throw] = ACTIONS(3101),
    [anon_sym_try] = ACTIONS(3101),
    [anon_sym_when] = ACTIONS(3101),
    [anon_sym_await] = ACTIONS(3101),
    [anon_sym_foreach] = ACTIONS(3101),
    [anon_sym_goto] = ACTIONS(3101),
    [anon_sym_if] = ACTIONS(3101),
    [anon_sym_else] = ACTIONS(3101),
    [anon_sym_DOT_DOT] = ACTIONS(3103),
    [anon_sym_from] = ACTIONS(3101),
    [anon_sym_into] = ACTIONS(3101),
    [anon_sym_join] = ACTIONS(3101),
    [anon_sym_on] = ACTIONS(3101),
    [anon_sym_equals] = ACTIONS(3101),
    [anon_sym_let] = ACTIONS(3101),
    [anon_sym_orderby] = ACTIONS(3101),
    [anon_sym_ascending] = ACTIONS(3101),
    [anon_sym_descending] = ACTIONS(3101),
    [anon_sym_group] = ACTIONS(3101),
    [anon_sym_by] = ACTIONS(3101),
    [anon_sym_select] = ACTIONS(3101),
    [anon_sym_DQUOTE] = ACTIONS(3101),
    [anon_sym_stackalloc] = ACTIONS(3101),
    [anon_sym_sizeof] = ACTIONS(3101),
    [anon_sym_typeof] = ACTIONS(3101),
    [anon_sym___makeref] = ACTIONS(3101),
    [anon_sym___reftype] = ACTIONS(3101),
    [anon_sym___refvalue] = ACTIONS(3101),
    [sym_null_literal] = ACTIONS(3101),
    [anon_sym_SQUOTE] = ACTIONS(3103),
    [sym_integer_literal] = ACTIONS(3101),
    [sym_real_literal] = ACTIONS(3103),
    [sym_verbatim_string_literal] = ACTIONS(3103),
    [sym_raw_string_literal] = ACTIONS(3103),
    [aux_sym_preproc_if_token1] = ACTIONS(3103),
    [aux_sym_preproc_if_token3] = ACTIONS(3103),
    [aux_sym_preproc_else_token1] = ACTIONS(3103),
    [aux_sym_preproc_elif_token1] = ACTIONS(3103),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3103),
    [sym_interpolation_verbatim_start] = ACTIONS(3103),
    [sym_interpolation_raw_start] = ACTIONS(3103),
  },
  [2231] = {
    [sym_preproc_region] = STATE(2231),
    [sym_preproc_endregion] = STATE(2231),
    [sym_preproc_line] = STATE(2231),
    [sym_preproc_pragma] = STATE(2231),
    [sym_preproc_nullable] = STATE(2231),
    [sym_preproc_error] = STATE(2231),
    [sym_preproc_define] = STATE(2231),
    [sym_preproc_undef] = STATE(2231),
    [sym__identifier_token] = ACTIONS(3105),
    [anon_sym_extern] = ACTIONS(3105),
    [anon_sym_alias] = ACTIONS(3105),
    [anon_sym_SEMI] = ACTIONS(3107),
    [anon_sym_global] = ACTIONS(3105),
    [anon_sym_using] = ACTIONS(3105),
    [anon_sym_unsafe] = ACTIONS(3105),
    [anon_sym_static] = ACTIONS(3105),
    [anon_sym_LBRACK] = ACTIONS(3107),
    [anon_sym_LPAREN] = ACTIONS(3107),
    [anon_sym_return] = ACTIONS(3105),
    [anon_sym_namespace] = ACTIONS(3105),
    [anon_sym_class] = ACTIONS(3105),
    [anon_sym_ref] = ACTIONS(3105),
    [anon_sym_struct] = ACTIONS(3105),
    [anon_sym_enum] = ACTIONS(3105),
    [anon_sym_LBRACE] = ACTIONS(3107),
    [anon_sym_interface] = ACTIONS(3105),
    [anon_sym_delegate] = ACTIONS(3105),
    [anon_sym_record] = ACTIONS(3105),
    [anon_sym_abstract] = ACTIONS(3105),
    [anon_sym_async] = ACTIONS(3105),
    [anon_sym_const] = ACTIONS(3105),
    [anon_sym_file] = ACTIONS(3105),
    [anon_sym_fixed] = ACTIONS(3105),
    [anon_sym_internal] = ACTIONS(3105),
    [anon_sym_new] = ACTIONS(3105),
    [anon_sym_override] = ACTIONS(3105),
    [anon_sym_partial] = ACTIONS(3105),
    [anon_sym_private] = ACTIONS(3105),
    [anon_sym_protected] = ACTIONS(3105),
    [anon_sym_public] = ACTIONS(3105),
    [anon_sym_readonly] = ACTIONS(3105),
    [anon_sym_required] = ACTIONS(3105),
    [anon_sym_sealed] = ACTIONS(3105),
    [anon_sym_virtual] = ACTIONS(3105),
    [anon_sym_volatile] = ACTIONS(3105),
    [anon_sym_where] = ACTIONS(3105),
    [anon_sym_notnull] = ACTIONS(3105),
    [anon_sym_unmanaged] = ACTIONS(3105),
    [anon_sym_checked] = ACTIONS(3105),
    [anon_sym_BANG] = ACTIONS(3107),
    [anon_sym_TILDE] = ACTIONS(3107),
    [anon_sym_PLUS_PLUS] = ACTIONS(3107),
    [anon_sym_DASH_DASH] = ACTIONS(3107),
    [anon_sym_true] = ACTIONS(3105),
    [anon_sym_false] = ACTIONS(3105),
    [anon_sym_PLUS] = ACTIONS(3105),
    [anon_sym_DASH] = ACTIONS(3105),
    [anon_sym_STAR] = ACTIONS(3107),
    [anon_sym_CARET] = ACTIONS(3107),
    [anon_sym_AMP] = ACTIONS(3107),
    [anon_sym_this] = ACTIONS(3105),
    [anon_sym_scoped] = ACTIONS(3105),
    [anon_sym_var] = ACTIONS(3105),
    [sym_predefined_type] = ACTIONS(3105),
    [anon_sym_break] = ACTIONS(3105),
    [anon_sym_unchecked] = ACTIONS(3105),
    [anon_sym_continue] = ACTIONS(3105),
    [anon_sym_do] = ACTIONS(3105),
    [anon_sym_while] = ACTIONS(3105),
    [anon_sym_for] = ACTIONS(3105),
    [anon_sym_lock] = ACTIONS(3105),
    [anon_sym_yield] = ACTIONS(3105),
    [anon_sym_switch] = ACTIONS(3105),
    [anon_sym_default] = ACTIONS(3105),
    [anon_sym_throw] = ACTIONS(3105),
    [anon_sym_try] = ACTIONS(3105),
    [anon_sym_when] = ACTIONS(3105),
    [anon_sym_await] = ACTIONS(3105),
    [anon_sym_foreach] = ACTIONS(3105),
    [anon_sym_goto] = ACTIONS(3105),
    [anon_sym_if] = ACTIONS(3105),
    [anon_sym_else] = ACTIONS(3105),
    [anon_sym_DOT_DOT] = ACTIONS(3107),
    [anon_sym_from] = ACTIONS(3105),
    [anon_sym_into] = ACTIONS(3105),
    [anon_sym_join] = ACTIONS(3105),
    [anon_sym_on] = ACTIONS(3105),
    [anon_sym_equals] = ACTIONS(3105),
    [anon_sym_let] = ACTIONS(3105),
    [anon_sym_orderby] = ACTIONS(3105),
    [anon_sym_ascending] = ACTIONS(3105),
    [anon_sym_descending] = ACTIONS(3105),
    [anon_sym_group] = ACTIONS(3105),
    [anon_sym_by] = ACTIONS(3105),
    [anon_sym_select] = ACTIONS(3105),
    [anon_sym_DQUOTE] = ACTIONS(3105),
    [anon_sym_stackalloc] = ACTIONS(3105),
    [anon_sym_sizeof] = ACTIONS(3105),
    [anon_sym_typeof] = ACTIONS(3105),
    [anon_sym___makeref] = ACTIONS(3105),
    [anon_sym___reftype] = ACTIONS(3105),
    [anon_sym___refvalue] = ACTIONS(3105),
    [sym_null_literal] = ACTIONS(3105),
    [anon_sym_SQUOTE] = ACTIONS(3107),
    [sym_integer_literal] = ACTIONS(3105),
    [sym_real_literal] = ACTIONS(3107),
    [sym_verbatim_string_literal] = ACTIONS(3107),
    [sym_raw_string_literal] = ACTIONS(3107),
    [aux_sym_preproc_if_token1] = ACTIONS(3107),
    [aux_sym_preproc_if_token3] = ACTIONS(3107),
    [aux_sym_preproc_else_token1] = ACTIONS(3107),
    [aux_sym_preproc_elif_token1] = ACTIONS(3107),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3107),
    [sym_interpolation_verbatim_start] = ACTIONS(3107),
    [sym_interpolation_raw_start] = ACTIONS(3107),
  },
  [2232] = {
    [sym_preproc_region] = STATE(2232),
    [sym_preproc_endregion] = STATE(2232),
    [sym_preproc_line] = STATE(2232),
    [sym_preproc_pragma] = STATE(2232),
    [sym_preproc_nullable] = STATE(2232),
    [sym_preproc_error] = STATE(2232),
    [sym_preproc_define] = STATE(2232),
    [sym_preproc_undef] = STATE(2232),
    [sym__identifier_token] = ACTIONS(3109),
    [anon_sym_extern] = ACTIONS(3109),
    [anon_sym_alias] = ACTIONS(3109),
    [anon_sym_SEMI] = ACTIONS(3111),
    [anon_sym_global] = ACTIONS(3109),
    [anon_sym_using] = ACTIONS(3109),
    [anon_sym_unsafe] = ACTIONS(3109),
    [anon_sym_static] = ACTIONS(3109),
    [anon_sym_LBRACK] = ACTIONS(3111),
    [anon_sym_LPAREN] = ACTIONS(3111),
    [anon_sym_return] = ACTIONS(3109),
    [anon_sym_namespace] = ACTIONS(3109),
    [anon_sym_class] = ACTIONS(3109),
    [anon_sym_ref] = ACTIONS(3109),
    [anon_sym_struct] = ACTIONS(3109),
    [anon_sym_enum] = ACTIONS(3109),
    [anon_sym_LBRACE] = ACTIONS(3111),
    [anon_sym_interface] = ACTIONS(3109),
    [anon_sym_delegate] = ACTIONS(3109),
    [anon_sym_record] = ACTIONS(3109),
    [anon_sym_abstract] = ACTIONS(3109),
    [anon_sym_async] = ACTIONS(3109),
    [anon_sym_const] = ACTIONS(3109),
    [anon_sym_file] = ACTIONS(3109),
    [anon_sym_fixed] = ACTIONS(3109),
    [anon_sym_internal] = ACTIONS(3109),
    [anon_sym_new] = ACTIONS(3109),
    [anon_sym_override] = ACTIONS(3109),
    [anon_sym_partial] = ACTIONS(3109),
    [anon_sym_private] = ACTIONS(3109),
    [anon_sym_protected] = ACTIONS(3109),
    [anon_sym_public] = ACTIONS(3109),
    [anon_sym_readonly] = ACTIONS(3109),
    [anon_sym_required] = ACTIONS(3109),
    [anon_sym_sealed] = ACTIONS(3109),
    [anon_sym_virtual] = ACTIONS(3109),
    [anon_sym_volatile] = ACTIONS(3109),
    [anon_sym_where] = ACTIONS(3109),
    [anon_sym_notnull] = ACTIONS(3109),
    [anon_sym_unmanaged] = ACTIONS(3109),
    [anon_sym_checked] = ACTIONS(3109),
    [anon_sym_BANG] = ACTIONS(3111),
    [anon_sym_TILDE] = ACTIONS(3111),
    [anon_sym_PLUS_PLUS] = ACTIONS(3111),
    [anon_sym_DASH_DASH] = ACTIONS(3111),
    [anon_sym_true] = ACTIONS(3109),
    [anon_sym_false] = ACTIONS(3109),
    [anon_sym_PLUS] = ACTIONS(3109),
    [anon_sym_DASH] = ACTIONS(3109),
    [anon_sym_STAR] = ACTIONS(3111),
    [anon_sym_CARET] = ACTIONS(3111),
    [anon_sym_AMP] = ACTIONS(3111),
    [anon_sym_this] = ACTIONS(3109),
    [anon_sym_scoped] = ACTIONS(3109),
    [anon_sym_var] = ACTIONS(3109),
    [sym_predefined_type] = ACTIONS(3109),
    [anon_sym_break] = ACTIONS(3109),
    [anon_sym_unchecked] = ACTIONS(3109),
    [anon_sym_continue] = ACTIONS(3109),
    [anon_sym_do] = ACTIONS(3109),
    [anon_sym_while] = ACTIONS(3109),
    [anon_sym_for] = ACTIONS(3109),
    [anon_sym_lock] = ACTIONS(3109),
    [anon_sym_yield] = ACTIONS(3109),
    [anon_sym_switch] = ACTIONS(3109),
    [anon_sym_default] = ACTIONS(3109),
    [anon_sym_throw] = ACTIONS(3109),
    [anon_sym_try] = ACTIONS(3109),
    [anon_sym_when] = ACTIONS(3109),
    [anon_sym_await] = ACTIONS(3109),
    [anon_sym_foreach] = ACTIONS(3109),
    [anon_sym_goto] = ACTIONS(3109),
    [anon_sym_if] = ACTIONS(3109),
    [anon_sym_else] = ACTIONS(3109),
    [anon_sym_DOT_DOT] = ACTIONS(3111),
    [anon_sym_from] = ACTIONS(3109),
    [anon_sym_into] = ACTIONS(3109),
    [anon_sym_join] = ACTIONS(3109),
    [anon_sym_on] = ACTIONS(3109),
    [anon_sym_equals] = ACTIONS(3109),
    [anon_sym_let] = ACTIONS(3109),
    [anon_sym_orderby] = ACTIONS(3109),
    [anon_sym_ascending] = ACTIONS(3109),
    [anon_sym_descending] = ACTIONS(3109),
    [anon_sym_group] = ACTIONS(3109),
    [anon_sym_by] = ACTIONS(3109),
    [anon_sym_select] = ACTIONS(3109),
    [anon_sym_DQUOTE] = ACTIONS(3109),
    [anon_sym_stackalloc] = ACTIONS(3109),
    [anon_sym_sizeof] = ACTIONS(3109),
    [anon_sym_typeof] = ACTIONS(3109),
    [anon_sym___makeref] = ACTIONS(3109),
    [anon_sym___reftype] = ACTIONS(3109),
    [anon_sym___refvalue] = ACTIONS(3109),
    [sym_null_literal] = ACTIONS(3109),
    [anon_sym_SQUOTE] = ACTIONS(3111),
    [sym_integer_literal] = ACTIONS(3109),
    [sym_real_literal] = ACTIONS(3111),
    [sym_verbatim_string_literal] = ACTIONS(3111),
    [sym_raw_string_literal] = ACTIONS(3111),
    [aux_sym_preproc_if_token1] = ACTIONS(3111),
    [aux_sym_preproc_if_token3] = ACTIONS(3111),
    [aux_sym_preproc_else_token1] = ACTIONS(3111),
    [aux_sym_preproc_elif_token1] = ACTIONS(3111),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3111),
    [sym_interpolation_verbatim_start] = ACTIONS(3111),
    [sym_interpolation_raw_start] = ACTIONS(3111),
  },
  [2233] = {
    [sym_using_directive] = STATE(3272),
    [sym_attribute_list] = STATE(3753),
    [sym_namespace_declaration] = STATE(3272),
    [sym_class_declaration] = STATE(3272),
    [sym_struct_declaration] = STATE(3272),
    [sym_enum_declaration] = STATE(3272),
    [sym_interface_declaration] = STATE(3272),
    [sym_delegate_declaration] = STATE(3272),
    [sym_record_declaration] = STATE(3272),
    [sym_modifier] = STATE(3780),
    [sym_operator_declaration] = STATE(3272),
    [sym_conversion_operator_declaration] = STATE(3272),
    [sym_declaration] = STATE(3284),
    [sym_field_declaration] = STATE(3272),
    [sym_constructor_declaration] = STATE(3272),
    [sym_destructor_declaration] = STATE(3272),
    [sym_method_declaration] = STATE(3272),
    [sym_event_declaration] = STATE(3272),
    [sym_event_field_declaration] = STATE(3272),
    [sym_indexer_declaration] = STATE(3272),
    [sym_property_declaration] = STATE(3272),
    [sym_variable_declaration] = STATE(9222),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(6306),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_identifier] = STATE(6719),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_if] = STATE(3272),
    [sym_preproc_region] = STATE(2233),
    [sym_preproc_endregion] = STATE(2233),
    [sym_preproc_line] = STATE(2233),
    [sym_preproc_pragma] = STATE(2233),
    [sym_preproc_nullable] = STATE(2233),
    [sym_preproc_error] = STATE(2233),
    [sym_preproc_define] = STATE(2233),
    [sym_preproc_undef] = STATE(2233),
    [aux_sym_class_declaration_repeat1] = STATE(2782),
    [aux_sym_class_declaration_repeat2] = STATE(2834),
    [aux_sym_declaration_list_repeat1] = STATE(2233),
    [sym__identifier_token] = ACTIONS(3113),
    [anon_sym_extern] = ACTIONS(3116),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3122),
    [anon_sym_using] = ACTIONS(3125),
    [anon_sym_unsafe] = ACTIONS(3128),
    [anon_sym_static] = ACTIONS(3128),
    [anon_sym_LBRACK] = ACTIONS(3131),
    [anon_sym_LPAREN] = ACTIONS(3134),
    [anon_sym_event] = ACTIONS(3137),
    [anon_sym_namespace] = ACTIONS(3140),
    [anon_sym_class] = ACTIONS(3143),
    [anon_sym_ref] = ACTIONS(3146),
    [anon_sym_struct] = ACTIONS(3149),
    [anon_sym_enum] = ACTIONS(3152),
    [anon_sym_RBRACE] = ACTIONS(3155),
    [anon_sym_interface] = ACTIONS(3157),
    [anon_sym_delegate] = ACTIONS(3160),
    [anon_sym_record] = ACTIONS(3163),
    [anon_sym_abstract] = ACTIONS(3128),
    [anon_sym_async] = ACTIONS(3128),
    [anon_sym_const] = ACTIONS(3128),
    [anon_sym_file] = ACTIONS(3166),
    [anon_sym_fixed] = ACTIONS(3128),
    [anon_sym_internal] = ACTIONS(3128),
    [anon_sym_new] = ACTIONS(3128),
    [anon_sym_override] = ACTIONS(3128),
    [anon_sym_partial] = ACTIONS(3128),
    [anon_sym_private] = ACTIONS(3128),
    [anon_sym_protected] = ACTIONS(3128),
    [anon_sym_public] = ACTIONS(3128),
    [anon_sym_readonly] = ACTIONS(3128),
    [anon_sym_required] = ACTIONS(3128),
    [anon_sym_sealed] = ACTIONS(3128),
    [anon_sym_virtual] = ACTIONS(3128),
    [anon_sym_volatile] = ACTIONS(3128),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_TILDE] = ACTIONS(3169),
    [anon_sym_implicit] = ACTIONS(3172),
    [anon_sym_explicit] = ACTIONS(3172),
    [anon_sym_scoped] = ACTIONS(3175),
    [anon_sym_var] = ACTIONS(3178),
    [sym_predefined_type] = ACTIONS(3181),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_if_token1] = ACTIONS(3184),
    [aux_sym_preproc_if_token3] = ACTIONS(3155),
    [aux_sym_preproc_else_token1] = ACTIONS(3155),
    [aux_sym_preproc_elif_token1] = ACTIONS(3155),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2234] = {
    [sym_preproc_region] = STATE(2234),
    [sym_preproc_endregion] = STATE(2234),
    [sym_preproc_line] = STATE(2234),
    [sym_preproc_pragma] = STATE(2234),
    [sym_preproc_nullable] = STATE(2234),
    [sym_preproc_error] = STATE(2234),
    [sym_preproc_define] = STATE(2234),
    [sym_preproc_undef] = STATE(2234),
    [sym__identifier_token] = ACTIONS(3187),
    [anon_sym_extern] = ACTIONS(3187),
    [anon_sym_alias] = ACTIONS(3187),
    [anon_sym_SEMI] = ACTIONS(3189),
    [anon_sym_global] = ACTIONS(3187),
    [anon_sym_using] = ACTIONS(3187),
    [anon_sym_unsafe] = ACTIONS(3187),
    [anon_sym_static] = ACTIONS(3187),
    [anon_sym_LBRACK] = ACTIONS(3189),
    [anon_sym_LPAREN] = ACTIONS(3189),
    [anon_sym_return] = ACTIONS(3187),
    [anon_sym_namespace] = ACTIONS(3187),
    [anon_sym_class] = ACTIONS(3187),
    [anon_sym_ref] = ACTIONS(3187),
    [anon_sym_struct] = ACTIONS(3187),
    [anon_sym_enum] = ACTIONS(3187),
    [anon_sym_LBRACE] = ACTIONS(3189),
    [anon_sym_interface] = ACTIONS(3187),
    [anon_sym_delegate] = ACTIONS(3187),
    [anon_sym_record] = ACTIONS(3187),
    [anon_sym_abstract] = ACTIONS(3187),
    [anon_sym_async] = ACTIONS(3187),
    [anon_sym_const] = ACTIONS(3187),
    [anon_sym_file] = ACTIONS(3187),
    [anon_sym_fixed] = ACTIONS(3187),
    [anon_sym_internal] = ACTIONS(3187),
    [anon_sym_new] = ACTIONS(3187),
    [anon_sym_override] = ACTIONS(3187),
    [anon_sym_partial] = ACTIONS(3187),
    [anon_sym_private] = ACTIONS(3187),
    [anon_sym_protected] = ACTIONS(3187),
    [anon_sym_public] = ACTIONS(3187),
    [anon_sym_readonly] = ACTIONS(3187),
    [anon_sym_required] = ACTIONS(3187),
    [anon_sym_sealed] = ACTIONS(3187),
    [anon_sym_virtual] = ACTIONS(3187),
    [anon_sym_volatile] = ACTIONS(3187),
    [anon_sym_where] = ACTIONS(3187),
    [anon_sym_notnull] = ACTIONS(3187),
    [anon_sym_unmanaged] = ACTIONS(3187),
    [anon_sym_checked] = ACTIONS(3187),
    [anon_sym_BANG] = ACTIONS(3189),
    [anon_sym_TILDE] = ACTIONS(3189),
    [anon_sym_PLUS_PLUS] = ACTIONS(3189),
    [anon_sym_DASH_DASH] = ACTIONS(3189),
    [anon_sym_true] = ACTIONS(3187),
    [anon_sym_false] = ACTIONS(3187),
    [anon_sym_PLUS] = ACTIONS(3187),
    [anon_sym_DASH] = ACTIONS(3187),
    [anon_sym_STAR] = ACTIONS(3189),
    [anon_sym_CARET] = ACTIONS(3189),
    [anon_sym_AMP] = ACTIONS(3189),
    [anon_sym_this] = ACTIONS(3187),
    [anon_sym_scoped] = ACTIONS(3187),
    [anon_sym_var] = ACTIONS(3187),
    [sym_predefined_type] = ACTIONS(3187),
    [anon_sym_break] = ACTIONS(3187),
    [anon_sym_unchecked] = ACTIONS(3187),
    [anon_sym_continue] = ACTIONS(3187),
    [anon_sym_do] = ACTIONS(3187),
    [anon_sym_while] = ACTIONS(3187),
    [anon_sym_for] = ACTIONS(3187),
    [anon_sym_lock] = ACTIONS(3187),
    [anon_sym_yield] = ACTIONS(3187),
    [anon_sym_switch] = ACTIONS(3187),
    [anon_sym_default] = ACTIONS(3187),
    [anon_sym_throw] = ACTIONS(3187),
    [anon_sym_try] = ACTIONS(3187),
    [anon_sym_when] = ACTIONS(3187),
    [anon_sym_await] = ACTIONS(3187),
    [anon_sym_foreach] = ACTIONS(3187),
    [anon_sym_goto] = ACTIONS(3187),
    [anon_sym_if] = ACTIONS(3187),
    [anon_sym_else] = ACTIONS(3187),
    [anon_sym_DOT_DOT] = ACTIONS(3189),
    [anon_sym_from] = ACTIONS(3187),
    [anon_sym_into] = ACTIONS(3187),
    [anon_sym_join] = ACTIONS(3187),
    [anon_sym_on] = ACTIONS(3187),
    [anon_sym_equals] = ACTIONS(3187),
    [anon_sym_let] = ACTIONS(3187),
    [anon_sym_orderby] = ACTIONS(3187),
    [anon_sym_ascending] = ACTIONS(3187),
    [anon_sym_descending] = ACTIONS(3187),
    [anon_sym_group] = ACTIONS(3187),
    [anon_sym_by] = ACTIONS(3187),
    [anon_sym_select] = ACTIONS(3187),
    [anon_sym_DQUOTE] = ACTIONS(3187),
    [anon_sym_stackalloc] = ACTIONS(3187),
    [anon_sym_sizeof] = ACTIONS(3187),
    [anon_sym_typeof] = ACTIONS(3187),
    [anon_sym___makeref] = ACTIONS(3187),
    [anon_sym___reftype] = ACTIONS(3187),
    [anon_sym___refvalue] = ACTIONS(3187),
    [sym_null_literal] = ACTIONS(3187),
    [anon_sym_SQUOTE] = ACTIONS(3189),
    [sym_integer_literal] = ACTIONS(3187),
    [sym_real_literal] = ACTIONS(3189),
    [sym_verbatim_string_literal] = ACTIONS(3189),
    [sym_raw_string_literal] = ACTIONS(3189),
    [aux_sym_preproc_if_token1] = ACTIONS(3189),
    [aux_sym_preproc_if_token3] = ACTIONS(3189),
    [aux_sym_preproc_else_token1] = ACTIONS(3189),
    [aux_sym_preproc_elif_token1] = ACTIONS(3189),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3189),
    [sym_interpolation_verbatim_start] = ACTIONS(3189),
    [sym_interpolation_raw_start] = ACTIONS(3189),
  },
  [2235] = {
    [sym_preproc_region] = STATE(2235),
    [sym_preproc_endregion] = STATE(2235),
    [sym_preproc_line] = STATE(2235),
    [sym_preproc_pragma] = STATE(2235),
    [sym_preproc_nullable] = STATE(2235),
    [sym_preproc_error] = STATE(2235),
    [sym_preproc_define] = STATE(2235),
    [sym_preproc_undef] = STATE(2235),
    [sym__identifier_token] = ACTIONS(3191),
    [anon_sym_extern] = ACTIONS(3191),
    [anon_sym_alias] = ACTIONS(3191),
    [anon_sym_SEMI] = ACTIONS(3193),
    [anon_sym_global] = ACTIONS(3191),
    [anon_sym_using] = ACTIONS(3191),
    [anon_sym_unsafe] = ACTIONS(3191),
    [anon_sym_static] = ACTIONS(3191),
    [anon_sym_LBRACK] = ACTIONS(3193),
    [anon_sym_LPAREN] = ACTIONS(3193),
    [anon_sym_return] = ACTIONS(3191),
    [anon_sym_namespace] = ACTIONS(3191),
    [anon_sym_class] = ACTIONS(3191),
    [anon_sym_ref] = ACTIONS(3191),
    [anon_sym_struct] = ACTIONS(3191),
    [anon_sym_enum] = ACTIONS(3191),
    [anon_sym_LBRACE] = ACTIONS(3193),
    [anon_sym_interface] = ACTIONS(3191),
    [anon_sym_delegate] = ACTIONS(3191),
    [anon_sym_record] = ACTIONS(3191),
    [anon_sym_abstract] = ACTIONS(3191),
    [anon_sym_async] = ACTIONS(3191),
    [anon_sym_const] = ACTIONS(3191),
    [anon_sym_file] = ACTIONS(3191),
    [anon_sym_fixed] = ACTIONS(3191),
    [anon_sym_internal] = ACTIONS(3191),
    [anon_sym_new] = ACTIONS(3191),
    [anon_sym_override] = ACTIONS(3191),
    [anon_sym_partial] = ACTIONS(3191),
    [anon_sym_private] = ACTIONS(3191),
    [anon_sym_protected] = ACTIONS(3191),
    [anon_sym_public] = ACTIONS(3191),
    [anon_sym_readonly] = ACTIONS(3191),
    [anon_sym_required] = ACTIONS(3191),
    [anon_sym_sealed] = ACTIONS(3191),
    [anon_sym_virtual] = ACTIONS(3191),
    [anon_sym_volatile] = ACTIONS(3191),
    [anon_sym_where] = ACTIONS(3191),
    [anon_sym_notnull] = ACTIONS(3191),
    [anon_sym_unmanaged] = ACTIONS(3191),
    [anon_sym_checked] = ACTIONS(3191),
    [anon_sym_BANG] = ACTIONS(3193),
    [anon_sym_TILDE] = ACTIONS(3193),
    [anon_sym_PLUS_PLUS] = ACTIONS(3193),
    [anon_sym_DASH_DASH] = ACTIONS(3193),
    [anon_sym_true] = ACTIONS(3191),
    [anon_sym_false] = ACTIONS(3191),
    [anon_sym_PLUS] = ACTIONS(3191),
    [anon_sym_DASH] = ACTIONS(3191),
    [anon_sym_STAR] = ACTIONS(3193),
    [anon_sym_CARET] = ACTIONS(3193),
    [anon_sym_AMP] = ACTIONS(3193),
    [anon_sym_this] = ACTIONS(3191),
    [anon_sym_scoped] = ACTIONS(3191),
    [anon_sym_var] = ACTIONS(3191),
    [sym_predefined_type] = ACTIONS(3191),
    [anon_sym_break] = ACTIONS(3191),
    [anon_sym_unchecked] = ACTIONS(3191),
    [anon_sym_continue] = ACTIONS(3191),
    [anon_sym_do] = ACTIONS(3191),
    [anon_sym_while] = ACTIONS(3191),
    [anon_sym_for] = ACTIONS(3191),
    [anon_sym_lock] = ACTIONS(3191),
    [anon_sym_yield] = ACTIONS(3191),
    [anon_sym_switch] = ACTIONS(3191),
    [anon_sym_default] = ACTIONS(3191),
    [anon_sym_throw] = ACTIONS(3191),
    [anon_sym_try] = ACTIONS(3191),
    [anon_sym_when] = ACTIONS(3191),
    [anon_sym_await] = ACTIONS(3191),
    [anon_sym_foreach] = ACTIONS(3191),
    [anon_sym_goto] = ACTIONS(3191),
    [anon_sym_if] = ACTIONS(3191),
    [anon_sym_else] = ACTIONS(3191),
    [anon_sym_DOT_DOT] = ACTIONS(3193),
    [anon_sym_from] = ACTIONS(3191),
    [anon_sym_into] = ACTIONS(3191),
    [anon_sym_join] = ACTIONS(3191),
    [anon_sym_on] = ACTIONS(3191),
    [anon_sym_equals] = ACTIONS(3191),
    [anon_sym_let] = ACTIONS(3191),
    [anon_sym_orderby] = ACTIONS(3191),
    [anon_sym_ascending] = ACTIONS(3191),
    [anon_sym_descending] = ACTIONS(3191),
    [anon_sym_group] = ACTIONS(3191),
    [anon_sym_by] = ACTIONS(3191),
    [anon_sym_select] = ACTIONS(3191),
    [anon_sym_DQUOTE] = ACTIONS(3191),
    [anon_sym_stackalloc] = ACTIONS(3191),
    [anon_sym_sizeof] = ACTIONS(3191),
    [anon_sym_typeof] = ACTIONS(3191),
    [anon_sym___makeref] = ACTIONS(3191),
    [anon_sym___reftype] = ACTIONS(3191),
    [anon_sym___refvalue] = ACTIONS(3191),
    [sym_null_literal] = ACTIONS(3191),
    [anon_sym_SQUOTE] = ACTIONS(3193),
    [sym_integer_literal] = ACTIONS(3191),
    [sym_real_literal] = ACTIONS(3193),
    [sym_verbatim_string_literal] = ACTIONS(3193),
    [sym_raw_string_literal] = ACTIONS(3193),
    [aux_sym_preproc_if_token1] = ACTIONS(3193),
    [aux_sym_preproc_if_token3] = ACTIONS(3193),
    [aux_sym_preproc_else_token1] = ACTIONS(3193),
    [aux_sym_preproc_elif_token1] = ACTIONS(3193),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3193),
    [sym_interpolation_verbatim_start] = ACTIONS(3193),
    [sym_interpolation_raw_start] = ACTIONS(3193),
  },
  [2236] = {
    [sym_preproc_region] = STATE(2236),
    [sym_preproc_endregion] = STATE(2236),
    [sym_preproc_line] = STATE(2236),
    [sym_preproc_pragma] = STATE(2236),
    [sym_preproc_nullable] = STATE(2236),
    [sym_preproc_error] = STATE(2236),
    [sym_preproc_define] = STATE(2236),
    [sym_preproc_undef] = STATE(2236),
    [sym__identifier_token] = ACTIONS(3195),
    [anon_sym_extern] = ACTIONS(3195),
    [anon_sym_alias] = ACTIONS(3195),
    [anon_sym_SEMI] = ACTIONS(3197),
    [anon_sym_global] = ACTIONS(3195),
    [anon_sym_using] = ACTIONS(3195),
    [anon_sym_unsafe] = ACTIONS(3195),
    [anon_sym_static] = ACTIONS(3195),
    [anon_sym_LBRACK] = ACTIONS(3197),
    [anon_sym_LPAREN] = ACTIONS(3197),
    [anon_sym_return] = ACTIONS(3195),
    [anon_sym_namespace] = ACTIONS(3195),
    [anon_sym_class] = ACTIONS(3195),
    [anon_sym_ref] = ACTIONS(3195),
    [anon_sym_struct] = ACTIONS(3195),
    [anon_sym_enum] = ACTIONS(3195),
    [anon_sym_LBRACE] = ACTIONS(3197),
    [anon_sym_interface] = ACTIONS(3195),
    [anon_sym_delegate] = ACTIONS(3195),
    [anon_sym_record] = ACTIONS(3195),
    [anon_sym_abstract] = ACTIONS(3195),
    [anon_sym_async] = ACTIONS(3195),
    [anon_sym_const] = ACTIONS(3195),
    [anon_sym_file] = ACTIONS(3195),
    [anon_sym_fixed] = ACTIONS(3195),
    [anon_sym_internal] = ACTIONS(3195),
    [anon_sym_new] = ACTIONS(3195),
    [anon_sym_override] = ACTIONS(3195),
    [anon_sym_partial] = ACTIONS(3195),
    [anon_sym_private] = ACTIONS(3195),
    [anon_sym_protected] = ACTIONS(3195),
    [anon_sym_public] = ACTIONS(3195),
    [anon_sym_readonly] = ACTIONS(3195),
    [anon_sym_required] = ACTIONS(3195),
    [anon_sym_sealed] = ACTIONS(3195),
    [anon_sym_virtual] = ACTIONS(3195),
    [anon_sym_volatile] = ACTIONS(3195),
    [anon_sym_where] = ACTIONS(3195),
    [anon_sym_notnull] = ACTIONS(3195),
    [anon_sym_unmanaged] = ACTIONS(3195),
    [anon_sym_checked] = ACTIONS(3195),
    [anon_sym_BANG] = ACTIONS(3197),
    [anon_sym_TILDE] = ACTIONS(3197),
    [anon_sym_PLUS_PLUS] = ACTIONS(3197),
    [anon_sym_DASH_DASH] = ACTIONS(3197),
    [anon_sym_true] = ACTIONS(3195),
    [anon_sym_false] = ACTIONS(3195),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_STAR] = ACTIONS(3197),
    [anon_sym_CARET] = ACTIONS(3197),
    [anon_sym_AMP] = ACTIONS(3197),
    [anon_sym_this] = ACTIONS(3195),
    [anon_sym_scoped] = ACTIONS(3195),
    [anon_sym_var] = ACTIONS(3195),
    [sym_predefined_type] = ACTIONS(3195),
    [anon_sym_break] = ACTIONS(3195),
    [anon_sym_unchecked] = ACTIONS(3195),
    [anon_sym_continue] = ACTIONS(3195),
    [anon_sym_do] = ACTIONS(3195),
    [anon_sym_while] = ACTIONS(3195),
    [anon_sym_for] = ACTIONS(3195),
    [anon_sym_lock] = ACTIONS(3195),
    [anon_sym_yield] = ACTIONS(3195),
    [anon_sym_switch] = ACTIONS(3195),
    [anon_sym_default] = ACTIONS(3195),
    [anon_sym_throw] = ACTIONS(3195),
    [anon_sym_try] = ACTIONS(3195),
    [anon_sym_when] = ACTIONS(3195),
    [anon_sym_await] = ACTIONS(3195),
    [anon_sym_foreach] = ACTIONS(3195),
    [anon_sym_goto] = ACTIONS(3195),
    [anon_sym_if] = ACTIONS(3195),
    [anon_sym_else] = ACTIONS(3195),
    [anon_sym_DOT_DOT] = ACTIONS(3197),
    [anon_sym_from] = ACTIONS(3195),
    [anon_sym_into] = ACTIONS(3195),
    [anon_sym_join] = ACTIONS(3195),
    [anon_sym_on] = ACTIONS(3195),
    [anon_sym_equals] = ACTIONS(3195),
    [anon_sym_let] = ACTIONS(3195),
    [anon_sym_orderby] = ACTIONS(3195),
    [anon_sym_ascending] = ACTIONS(3195),
    [anon_sym_descending] = ACTIONS(3195),
    [anon_sym_group] = ACTIONS(3195),
    [anon_sym_by] = ACTIONS(3195),
    [anon_sym_select] = ACTIONS(3195),
    [anon_sym_DQUOTE] = ACTIONS(3195),
    [anon_sym_stackalloc] = ACTIONS(3195),
    [anon_sym_sizeof] = ACTIONS(3195),
    [anon_sym_typeof] = ACTIONS(3195),
    [anon_sym___makeref] = ACTIONS(3195),
    [anon_sym___reftype] = ACTIONS(3195),
    [anon_sym___refvalue] = ACTIONS(3195),
    [sym_null_literal] = ACTIONS(3195),
    [anon_sym_SQUOTE] = ACTIONS(3197),
    [sym_integer_literal] = ACTIONS(3195),
    [sym_real_literal] = ACTIONS(3197),
    [sym_verbatim_string_literal] = ACTIONS(3197),
    [sym_raw_string_literal] = ACTIONS(3197),
    [aux_sym_preproc_if_token1] = ACTIONS(3197),
    [aux_sym_preproc_if_token3] = ACTIONS(3197),
    [aux_sym_preproc_else_token1] = ACTIONS(3197),
    [aux_sym_preproc_elif_token1] = ACTIONS(3197),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3197),
    [sym_interpolation_verbatim_start] = ACTIONS(3197),
    [sym_interpolation_raw_start] = ACTIONS(3197),
  },
  [2237] = {
    [sym_preproc_region] = STATE(2237),
    [sym_preproc_endregion] = STATE(2237),
    [sym_preproc_line] = STATE(2237),
    [sym_preproc_pragma] = STATE(2237),
    [sym_preproc_nullable] = STATE(2237),
    [sym_preproc_error] = STATE(2237),
    [sym_preproc_define] = STATE(2237),
    [sym_preproc_undef] = STATE(2237),
    [ts_builtin_sym_end] = ACTIONS(2969),
    [sym__identifier_token] = ACTIONS(2967),
    [anon_sym_extern] = ACTIONS(2967),
    [anon_sym_alias] = ACTIONS(2967),
    [anon_sym_SEMI] = ACTIONS(2969),
    [anon_sym_global] = ACTIONS(2967),
    [anon_sym_using] = ACTIONS(2967),
    [anon_sym_unsafe] = ACTIONS(2967),
    [anon_sym_static] = ACTIONS(2967),
    [anon_sym_LBRACK] = ACTIONS(2969),
    [anon_sym_LPAREN] = ACTIONS(2969),
    [anon_sym_return] = ACTIONS(2967),
    [anon_sym_namespace] = ACTIONS(2967),
    [anon_sym_class] = ACTIONS(2967),
    [anon_sym_ref] = ACTIONS(2967),
    [anon_sym_struct] = ACTIONS(2967),
    [anon_sym_enum] = ACTIONS(2967),
    [anon_sym_LBRACE] = ACTIONS(2969),
    [anon_sym_interface] = ACTIONS(2967),
    [anon_sym_delegate] = ACTIONS(2967),
    [anon_sym_record] = ACTIONS(2967),
    [anon_sym_abstract] = ACTIONS(2967),
    [anon_sym_async] = ACTIONS(2967),
    [anon_sym_const] = ACTIONS(2967),
    [anon_sym_file] = ACTIONS(2967),
    [anon_sym_fixed] = ACTIONS(2967),
    [anon_sym_internal] = ACTIONS(2967),
    [anon_sym_new] = ACTIONS(2967),
    [anon_sym_override] = ACTIONS(2967),
    [anon_sym_partial] = ACTIONS(2967),
    [anon_sym_private] = ACTIONS(2967),
    [anon_sym_protected] = ACTIONS(2967),
    [anon_sym_public] = ACTIONS(2967),
    [anon_sym_readonly] = ACTIONS(2967),
    [anon_sym_required] = ACTIONS(2967),
    [anon_sym_sealed] = ACTIONS(2967),
    [anon_sym_virtual] = ACTIONS(2967),
    [anon_sym_volatile] = ACTIONS(2967),
    [anon_sym_where] = ACTIONS(2967),
    [anon_sym_notnull] = ACTIONS(2967),
    [anon_sym_unmanaged] = ACTIONS(2967),
    [anon_sym_checked] = ACTIONS(2967),
    [anon_sym_BANG] = ACTIONS(2969),
    [anon_sym_TILDE] = ACTIONS(2969),
    [anon_sym_PLUS_PLUS] = ACTIONS(2969),
    [anon_sym_DASH_DASH] = ACTIONS(2969),
    [anon_sym_true] = ACTIONS(2967),
    [anon_sym_false] = ACTIONS(2967),
    [anon_sym_PLUS] = ACTIONS(2967),
    [anon_sym_DASH] = ACTIONS(2967),
    [anon_sym_STAR] = ACTIONS(2969),
    [anon_sym_CARET] = ACTIONS(2969),
    [anon_sym_AMP] = ACTIONS(2969),
    [anon_sym_this] = ACTIONS(2967),
    [anon_sym_scoped] = ACTIONS(2967),
    [anon_sym_var] = ACTIONS(2967),
    [sym_predefined_type] = ACTIONS(2967),
    [anon_sym_break] = ACTIONS(2967),
    [anon_sym_unchecked] = ACTIONS(2967),
    [anon_sym_continue] = ACTIONS(2967),
    [anon_sym_do] = ACTIONS(2967),
    [anon_sym_while] = ACTIONS(2967),
    [anon_sym_for] = ACTIONS(2967),
    [anon_sym_lock] = ACTIONS(2967),
    [anon_sym_yield] = ACTIONS(2967),
    [anon_sym_switch] = ACTIONS(2967),
    [anon_sym_default] = ACTIONS(2967),
    [anon_sym_throw] = ACTIONS(2967),
    [anon_sym_try] = ACTIONS(2967),
    [anon_sym_catch] = ACTIONS(2967),
    [anon_sym_when] = ACTIONS(2967),
    [anon_sym_finally] = ACTIONS(2967),
    [anon_sym_await] = ACTIONS(2967),
    [anon_sym_foreach] = ACTIONS(2967),
    [anon_sym_goto] = ACTIONS(2967),
    [anon_sym_if] = ACTIONS(2967),
    [anon_sym_else] = ACTIONS(2967),
    [anon_sym_DOT_DOT] = ACTIONS(2969),
    [anon_sym_from] = ACTIONS(2967),
    [anon_sym_into] = ACTIONS(2967),
    [anon_sym_join] = ACTIONS(2967),
    [anon_sym_on] = ACTIONS(2967),
    [anon_sym_equals] = ACTIONS(2967),
    [anon_sym_let] = ACTIONS(2967),
    [anon_sym_orderby] = ACTIONS(2967),
    [anon_sym_ascending] = ACTIONS(2967),
    [anon_sym_descending] = ACTIONS(2967),
    [anon_sym_group] = ACTIONS(2967),
    [anon_sym_by] = ACTIONS(2967),
    [anon_sym_select] = ACTIONS(2967),
    [anon_sym_DQUOTE] = ACTIONS(2967),
    [anon_sym_stackalloc] = ACTIONS(2967),
    [anon_sym_sizeof] = ACTIONS(2967),
    [anon_sym_typeof] = ACTIONS(2967),
    [anon_sym___makeref] = ACTIONS(2967),
    [anon_sym___reftype] = ACTIONS(2967),
    [anon_sym___refvalue] = ACTIONS(2967),
    [sym_null_literal] = ACTIONS(2967),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [sym_integer_literal] = ACTIONS(2967),
    [sym_real_literal] = ACTIONS(2969),
    [sym_verbatim_string_literal] = ACTIONS(2969),
    [sym_raw_string_literal] = ACTIONS(2969),
    [aux_sym_preproc_if_token1] = ACTIONS(2969),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(2969),
    [sym_interpolation_verbatim_start] = ACTIONS(2969),
    [sym_interpolation_raw_start] = ACTIONS(2969),
  },
  [2238] = {
    [sym_preproc_region] = STATE(2238),
    [sym_preproc_endregion] = STATE(2238),
    [sym_preproc_line] = STATE(2238),
    [sym_preproc_pragma] = STATE(2238),
    [sym_preproc_nullable] = STATE(2238),
    [sym_preproc_error] = STATE(2238),
    [sym_preproc_define] = STATE(2238),
    [sym_preproc_undef] = STATE(2238),
    [sym__identifier_token] = ACTIONS(3199),
    [anon_sym_extern] = ACTIONS(3199),
    [anon_sym_alias] = ACTIONS(3199),
    [anon_sym_SEMI] = ACTIONS(3201),
    [anon_sym_global] = ACTIONS(3199),
    [anon_sym_using] = ACTIONS(3199),
    [anon_sym_unsafe] = ACTIONS(3199),
    [anon_sym_static] = ACTIONS(3199),
    [anon_sym_LBRACK] = ACTIONS(3201),
    [anon_sym_LPAREN] = ACTIONS(3201),
    [anon_sym_return] = ACTIONS(3199),
    [anon_sym_namespace] = ACTIONS(3199),
    [anon_sym_class] = ACTIONS(3199),
    [anon_sym_ref] = ACTIONS(3199),
    [anon_sym_struct] = ACTIONS(3199),
    [anon_sym_enum] = ACTIONS(3199),
    [anon_sym_LBRACE] = ACTIONS(3201),
    [anon_sym_interface] = ACTIONS(3199),
    [anon_sym_delegate] = ACTIONS(3199),
    [anon_sym_record] = ACTIONS(3199),
    [anon_sym_abstract] = ACTIONS(3199),
    [anon_sym_async] = ACTIONS(3199),
    [anon_sym_const] = ACTIONS(3199),
    [anon_sym_file] = ACTIONS(3199),
    [anon_sym_fixed] = ACTIONS(3199),
    [anon_sym_internal] = ACTIONS(3199),
    [anon_sym_new] = ACTIONS(3199),
    [anon_sym_override] = ACTIONS(3199),
    [anon_sym_partial] = ACTIONS(3199),
    [anon_sym_private] = ACTIONS(3199),
    [anon_sym_protected] = ACTIONS(3199),
    [anon_sym_public] = ACTIONS(3199),
    [anon_sym_readonly] = ACTIONS(3199),
    [anon_sym_required] = ACTIONS(3199),
    [anon_sym_sealed] = ACTIONS(3199),
    [anon_sym_virtual] = ACTIONS(3199),
    [anon_sym_volatile] = ACTIONS(3199),
    [anon_sym_where] = ACTIONS(3199),
    [anon_sym_notnull] = ACTIONS(3199),
    [anon_sym_unmanaged] = ACTIONS(3199),
    [anon_sym_checked] = ACTIONS(3199),
    [anon_sym_BANG] = ACTIONS(3201),
    [anon_sym_TILDE] = ACTIONS(3201),
    [anon_sym_PLUS_PLUS] = ACTIONS(3201),
    [anon_sym_DASH_DASH] = ACTIONS(3201),
    [anon_sym_true] = ACTIONS(3199),
    [anon_sym_false] = ACTIONS(3199),
    [anon_sym_PLUS] = ACTIONS(3199),
    [anon_sym_DASH] = ACTIONS(3199),
    [anon_sym_STAR] = ACTIONS(3201),
    [anon_sym_CARET] = ACTIONS(3201),
    [anon_sym_AMP] = ACTIONS(3201),
    [anon_sym_this] = ACTIONS(3199),
    [anon_sym_scoped] = ACTIONS(3199),
    [anon_sym_var] = ACTIONS(3199),
    [sym_predefined_type] = ACTIONS(3199),
    [anon_sym_break] = ACTIONS(3199),
    [anon_sym_unchecked] = ACTIONS(3199),
    [anon_sym_continue] = ACTIONS(3199),
    [anon_sym_do] = ACTIONS(3199),
    [anon_sym_while] = ACTIONS(3199),
    [anon_sym_for] = ACTIONS(3199),
    [anon_sym_lock] = ACTIONS(3199),
    [anon_sym_yield] = ACTIONS(3199),
    [anon_sym_switch] = ACTIONS(3199),
    [anon_sym_default] = ACTIONS(3199),
    [anon_sym_throw] = ACTIONS(3199),
    [anon_sym_try] = ACTIONS(3199),
    [anon_sym_when] = ACTIONS(3199),
    [anon_sym_await] = ACTIONS(3199),
    [anon_sym_foreach] = ACTIONS(3199),
    [anon_sym_goto] = ACTIONS(3199),
    [anon_sym_if] = ACTIONS(3199),
    [anon_sym_else] = ACTIONS(3199),
    [anon_sym_DOT_DOT] = ACTIONS(3201),
    [anon_sym_from] = ACTIONS(3199),
    [anon_sym_into] = ACTIONS(3199),
    [anon_sym_join] = ACTIONS(3199),
    [anon_sym_on] = ACTIONS(3199),
    [anon_sym_equals] = ACTIONS(3199),
    [anon_sym_let] = ACTIONS(3199),
    [anon_sym_orderby] = ACTIONS(3199),
    [anon_sym_ascending] = ACTIONS(3199),
    [anon_sym_descending] = ACTIONS(3199),
    [anon_sym_group] = ACTIONS(3199),
    [anon_sym_by] = ACTIONS(3199),
    [anon_sym_select] = ACTIONS(3199),
    [anon_sym_DQUOTE] = ACTIONS(3199),
    [anon_sym_stackalloc] = ACTIONS(3199),
    [anon_sym_sizeof] = ACTIONS(3199),
    [anon_sym_typeof] = ACTIONS(3199),
    [anon_sym___makeref] = ACTIONS(3199),
    [anon_sym___reftype] = ACTIONS(3199),
    [anon_sym___refvalue] = ACTIONS(3199),
    [sym_null_literal] = ACTIONS(3199),
    [anon_sym_SQUOTE] = ACTIONS(3201),
    [sym_integer_literal] = ACTIONS(3199),
    [sym_real_literal] = ACTIONS(3201),
    [sym_verbatim_string_literal] = ACTIONS(3201),
    [sym_raw_string_literal] = ACTIONS(3201),
    [aux_sym_preproc_if_token1] = ACTIONS(3201),
    [aux_sym_preproc_if_token3] = ACTIONS(3201),
    [aux_sym_preproc_else_token1] = ACTIONS(3201),
    [aux_sym_preproc_elif_token1] = ACTIONS(3201),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3201),
    [sym_interpolation_verbatim_start] = ACTIONS(3201),
    [sym_interpolation_raw_start] = ACTIONS(3201),
  },
  [2239] = {
    [sym_preproc_region] = STATE(2239),
    [sym_preproc_endregion] = STATE(2239),
    [sym_preproc_line] = STATE(2239),
    [sym_preproc_pragma] = STATE(2239),
    [sym_preproc_nullable] = STATE(2239),
    [sym_preproc_error] = STATE(2239),
    [sym_preproc_define] = STATE(2239),
    [sym_preproc_undef] = STATE(2239),
    [sym__identifier_token] = ACTIONS(3203),
    [anon_sym_extern] = ACTIONS(3203),
    [anon_sym_alias] = ACTIONS(3203),
    [anon_sym_SEMI] = ACTIONS(3205),
    [anon_sym_global] = ACTIONS(3203),
    [anon_sym_using] = ACTIONS(3203),
    [anon_sym_unsafe] = ACTIONS(3203),
    [anon_sym_static] = ACTIONS(3203),
    [anon_sym_LBRACK] = ACTIONS(3205),
    [anon_sym_LPAREN] = ACTIONS(3205),
    [anon_sym_return] = ACTIONS(3203),
    [anon_sym_namespace] = ACTIONS(3203),
    [anon_sym_class] = ACTIONS(3203),
    [anon_sym_ref] = ACTIONS(3203),
    [anon_sym_struct] = ACTIONS(3203),
    [anon_sym_enum] = ACTIONS(3203),
    [anon_sym_LBRACE] = ACTIONS(3205),
    [anon_sym_interface] = ACTIONS(3203),
    [anon_sym_delegate] = ACTIONS(3203),
    [anon_sym_record] = ACTIONS(3203),
    [anon_sym_abstract] = ACTIONS(3203),
    [anon_sym_async] = ACTIONS(3203),
    [anon_sym_const] = ACTIONS(3203),
    [anon_sym_file] = ACTIONS(3203),
    [anon_sym_fixed] = ACTIONS(3203),
    [anon_sym_internal] = ACTIONS(3203),
    [anon_sym_new] = ACTIONS(3203),
    [anon_sym_override] = ACTIONS(3203),
    [anon_sym_partial] = ACTIONS(3203),
    [anon_sym_private] = ACTIONS(3203),
    [anon_sym_protected] = ACTIONS(3203),
    [anon_sym_public] = ACTIONS(3203),
    [anon_sym_readonly] = ACTIONS(3203),
    [anon_sym_required] = ACTIONS(3203),
    [anon_sym_sealed] = ACTIONS(3203),
    [anon_sym_virtual] = ACTIONS(3203),
    [anon_sym_volatile] = ACTIONS(3203),
    [anon_sym_where] = ACTIONS(3203),
    [anon_sym_notnull] = ACTIONS(3203),
    [anon_sym_unmanaged] = ACTIONS(3203),
    [anon_sym_checked] = ACTIONS(3203),
    [anon_sym_BANG] = ACTIONS(3205),
    [anon_sym_TILDE] = ACTIONS(3205),
    [anon_sym_PLUS_PLUS] = ACTIONS(3205),
    [anon_sym_DASH_DASH] = ACTIONS(3205),
    [anon_sym_true] = ACTIONS(3203),
    [anon_sym_false] = ACTIONS(3203),
    [anon_sym_PLUS] = ACTIONS(3203),
    [anon_sym_DASH] = ACTIONS(3203),
    [anon_sym_STAR] = ACTIONS(3205),
    [anon_sym_CARET] = ACTIONS(3205),
    [anon_sym_AMP] = ACTIONS(3205),
    [anon_sym_this] = ACTIONS(3203),
    [anon_sym_scoped] = ACTIONS(3203),
    [anon_sym_var] = ACTIONS(3203),
    [sym_predefined_type] = ACTIONS(3203),
    [anon_sym_break] = ACTIONS(3203),
    [anon_sym_unchecked] = ACTIONS(3203),
    [anon_sym_continue] = ACTIONS(3203),
    [anon_sym_do] = ACTIONS(3203),
    [anon_sym_while] = ACTIONS(3203),
    [anon_sym_for] = ACTIONS(3203),
    [anon_sym_lock] = ACTIONS(3203),
    [anon_sym_yield] = ACTIONS(3203),
    [anon_sym_switch] = ACTIONS(3203),
    [anon_sym_default] = ACTIONS(3203),
    [anon_sym_throw] = ACTIONS(3203),
    [anon_sym_try] = ACTIONS(3203),
    [anon_sym_when] = ACTIONS(3203),
    [anon_sym_await] = ACTIONS(3203),
    [anon_sym_foreach] = ACTIONS(3203),
    [anon_sym_goto] = ACTIONS(3203),
    [anon_sym_if] = ACTIONS(3203),
    [anon_sym_else] = ACTIONS(3203),
    [anon_sym_DOT_DOT] = ACTIONS(3205),
    [anon_sym_from] = ACTIONS(3203),
    [anon_sym_into] = ACTIONS(3203),
    [anon_sym_join] = ACTIONS(3203),
    [anon_sym_on] = ACTIONS(3203),
    [anon_sym_equals] = ACTIONS(3203),
    [anon_sym_let] = ACTIONS(3203),
    [anon_sym_orderby] = ACTIONS(3203),
    [anon_sym_ascending] = ACTIONS(3203),
    [anon_sym_descending] = ACTIONS(3203),
    [anon_sym_group] = ACTIONS(3203),
    [anon_sym_by] = ACTIONS(3203),
    [anon_sym_select] = ACTIONS(3203),
    [anon_sym_DQUOTE] = ACTIONS(3203),
    [anon_sym_stackalloc] = ACTIONS(3203),
    [anon_sym_sizeof] = ACTIONS(3203),
    [anon_sym_typeof] = ACTIONS(3203),
    [anon_sym___makeref] = ACTIONS(3203),
    [anon_sym___reftype] = ACTIONS(3203),
    [anon_sym___refvalue] = ACTIONS(3203),
    [sym_null_literal] = ACTIONS(3203),
    [anon_sym_SQUOTE] = ACTIONS(3205),
    [sym_integer_literal] = ACTIONS(3203),
    [sym_real_literal] = ACTIONS(3205),
    [sym_verbatim_string_literal] = ACTIONS(3205),
    [sym_raw_string_literal] = ACTIONS(3205),
    [aux_sym_preproc_if_token1] = ACTIONS(3205),
    [aux_sym_preproc_if_token3] = ACTIONS(3205),
    [aux_sym_preproc_else_token1] = ACTIONS(3205),
    [aux_sym_preproc_elif_token1] = ACTIONS(3205),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3205),
    [sym_interpolation_verbatim_start] = ACTIONS(3205),
    [sym_interpolation_raw_start] = ACTIONS(3205),
  },
  [2240] = {
    [sym_preproc_region] = STATE(2240),
    [sym_preproc_endregion] = STATE(2240),
    [sym_preproc_line] = STATE(2240),
    [sym_preproc_pragma] = STATE(2240),
    [sym_preproc_nullable] = STATE(2240),
    [sym_preproc_error] = STATE(2240),
    [sym_preproc_define] = STATE(2240),
    [sym_preproc_undef] = STATE(2240),
    [sym__identifier_token] = ACTIONS(3207),
    [anon_sym_extern] = ACTIONS(3207),
    [anon_sym_alias] = ACTIONS(3207),
    [anon_sym_SEMI] = ACTIONS(3209),
    [anon_sym_global] = ACTIONS(3207),
    [anon_sym_using] = ACTIONS(3207),
    [anon_sym_unsafe] = ACTIONS(3207),
    [anon_sym_static] = ACTIONS(3207),
    [anon_sym_LBRACK] = ACTIONS(3209),
    [anon_sym_LPAREN] = ACTIONS(3209),
    [anon_sym_return] = ACTIONS(3207),
    [anon_sym_namespace] = ACTIONS(3207),
    [anon_sym_class] = ACTIONS(3207),
    [anon_sym_ref] = ACTIONS(3207),
    [anon_sym_struct] = ACTIONS(3207),
    [anon_sym_enum] = ACTIONS(3207),
    [anon_sym_LBRACE] = ACTIONS(3209),
    [anon_sym_interface] = ACTIONS(3207),
    [anon_sym_delegate] = ACTIONS(3207),
    [anon_sym_record] = ACTIONS(3207),
    [anon_sym_abstract] = ACTIONS(3207),
    [anon_sym_async] = ACTIONS(3207),
    [anon_sym_const] = ACTIONS(3207),
    [anon_sym_file] = ACTIONS(3207),
    [anon_sym_fixed] = ACTIONS(3207),
    [anon_sym_internal] = ACTIONS(3207),
    [anon_sym_new] = ACTIONS(3207),
    [anon_sym_override] = ACTIONS(3207),
    [anon_sym_partial] = ACTIONS(3207),
    [anon_sym_private] = ACTIONS(3207),
    [anon_sym_protected] = ACTIONS(3207),
    [anon_sym_public] = ACTIONS(3207),
    [anon_sym_readonly] = ACTIONS(3207),
    [anon_sym_required] = ACTIONS(3207),
    [anon_sym_sealed] = ACTIONS(3207),
    [anon_sym_virtual] = ACTIONS(3207),
    [anon_sym_volatile] = ACTIONS(3207),
    [anon_sym_where] = ACTIONS(3207),
    [anon_sym_notnull] = ACTIONS(3207),
    [anon_sym_unmanaged] = ACTIONS(3207),
    [anon_sym_checked] = ACTIONS(3207),
    [anon_sym_BANG] = ACTIONS(3209),
    [anon_sym_TILDE] = ACTIONS(3209),
    [anon_sym_PLUS_PLUS] = ACTIONS(3209),
    [anon_sym_DASH_DASH] = ACTIONS(3209),
    [anon_sym_true] = ACTIONS(3207),
    [anon_sym_false] = ACTIONS(3207),
    [anon_sym_PLUS] = ACTIONS(3207),
    [anon_sym_DASH] = ACTIONS(3207),
    [anon_sym_STAR] = ACTIONS(3209),
    [anon_sym_CARET] = ACTIONS(3209),
    [anon_sym_AMP] = ACTIONS(3209),
    [anon_sym_this] = ACTIONS(3207),
    [anon_sym_scoped] = ACTIONS(3207),
    [anon_sym_var] = ACTIONS(3207),
    [sym_predefined_type] = ACTIONS(3207),
    [anon_sym_break] = ACTIONS(3207),
    [anon_sym_unchecked] = ACTIONS(3207),
    [anon_sym_continue] = ACTIONS(3207),
    [anon_sym_do] = ACTIONS(3207),
    [anon_sym_while] = ACTIONS(3207),
    [anon_sym_for] = ACTIONS(3207),
    [anon_sym_lock] = ACTIONS(3207),
    [anon_sym_yield] = ACTIONS(3207),
    [anon_sym_switch] = ACTIONS(3207),
    [anon_sym_default] = ACTIONS(3207),
    [anon_sym_throw] = ACTIONS(3207),
    [anon_sym_try] = ACTIONS(3207),
    [anon_sym_when] = ACTIONS(3207),
    [anon_sym_await] = ACTIONS(3207),
    [anon_sym_foreach] = ACTIONS(3207),
    [anon_sym_goto] = ACTIONS(3207),
    [anon_sym_if] = ACTIONS(3207),
    [anon_sym_else] = ACTIONS(3207),
    [anon_sym_DOT_DOT] = ACTIONS(3209),
    [anon_sym_from] = ACTIONS(3207),
    [anon_sym_into] = ACTIONS(3207),
    [anon_sym_join] = ACTIONS(3207),
    [anon_sym_on] = ACTIONS(3207),
    [anon_sym_equals] = ACTIONS(3207),
    [anon_sym_let] = ACTIONS(3207),
    [anon_sym_orderby] = ACTIONS(3207),
    [anon_sym_ascending] = ACTIONS(3207),
    [anon_sym_descending] = ACTIONS(3207),
    [anon_sym_group] = ACTIONS(3207),
    [anon_sym_by] = ACTIONS(3207),
    [anon_sym_select] = ACTIONS(3207),
    [anon_sym_DQUOTE] = ACTIONS(3207),
    [anon_sym_stackalloc] = ACTIONS(3207),
    [anon_sym_sizeof] = ACTIONS(3207),
    [anon_sym_typeof] = ACTIONS(3207),
    [anon_sym___makeref] = ACTIONS(3207),
    [anon_sym___reftype] = ACTIONS(3207),
    [anon_sym___refvalue] = ACTIONS(3207),
    [sym_null_literal] = ACTIONS(3207),
    [anon_sym_SQUOTE] = ACTIONS(3209),
    [sym_integer_literal] = ACTIONS(3207),
    [sym_real_literal] = ACTIONS(3209),
    [sym_verbatim_string_literal] = ACTIONS(3209),
    [sym_raw_string_literal] = ACTIONS(3209),
    [aux_sym_preproc_if_token1] = ACTIONS(3209),
    [aux_sym_preproc_if_token3] = ACTIONS(3209),
    [aux_sym_preproc_else_token1] = ACTIONS(3209),
    [aux_sym_preproc_elif_token1] = ACTIONS(3209),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3209),
    [sym_interpolation_verbatim_start] = ACTIONS(3209),
    [sym_interpolation_raw_start] = ACTIONS(3209),
  },
  [2241] = {
    [sym_preproc_region] = STATE(2241),
    [sym_preproc_endregion] = STATE(2241),
    [sym_preproc_line] = STATE(2241),
    [sym_preproc_pragma] = STATE(2241),
    [sym_preproc_nullable] = STATE(2241),
    [sym_preproc_error] = STATE(2241),
    [sym_preproc_define] = STATE(2241),
    [sym_preproc_undef] = STATE(2241),
    [sym__identifier_token] = ACTIONS(3211),
    [anon_sym_extern] = ACTIONS(3211),
    [anon_sym_alias] = ACTIONS(3211),
    [anon_sym_SEMI] = ACTIONS(3213),
    [anon_sym_global] = ACTIONS(3211),
    [anon_sym_using] = ACTIONS(3211),
    [anon_sym_unsafe] = ACTIONS(3211),
    [anon_sym_static] = ACTIONS(3211),
    [anon_sym_LBRACK] = ACTIONS(3213),
    [anon_sym_LPAREN] = ACTIONS(3213),
    [anon_sym_return] = ACTIONS(3211),
    [anon_sym_namespace] = ACTIONS(3211),
    [anon_sym_class] = ACTIONS(3211),
    [anon_sym_ref] = ACTIONS(3211),
    [anon_sym_struct] = ACTIONS(3211),
    [anon_sym_enum] = ACTIONS(3211),
    [anon_sym_LBRACE] = ACTIONS(3213),
    [anon_sym_interface] = ACTIONS(3211),
    [anon_sym_delegate] = ACTIONS(3211),
    [anon_sym_record] = ACTIONS(3211),
    [anon_sym_abstract] = ACTIONS(3211),
    [anon_sym_async] = ACTIONS(3211),
    [anon_sym_const] = ACTIONS(3211),
    [anon_sym_file] = ACTIONS(3211),
    [anon_sym_fixed] = ACTIONS(3211),
    [anon_sym_internal] = ACTIONS(3211),
    [anon_sym_new] = ACTIONS(3211),
    [anon_sym_override] = ACTIONS(3211),
    [anon_sym_partial] = ACTIONS(3211),
    [anon_sym_private] = ACTIONS(3211),
    [anon_sym_protected] = ACTIONS(3211),
    [anon_sym_public] = ACTIONS(3211),
    [anon_sym_readonly] = ACTIONS(3211),
    [anon_sym_required] = ACTIONS(3211),
    [anon_sym_sealed] = ACTIONS(3211),
    [anon_sym_virtual] = ACTIONS(3211),
    [anon_sym_volatile] = ACTIONS(3211),
    [anon_sym_where] = ACTIONS(3211),
    [anon_sym_notnull] = ACTIONS(3211),
    [anon_sym_unmanaged] = ACTIONS(3211),
    [anon_sym_checked] = ACTIONS(3211),
    [anon_sym_BANG] = ACTIONS(3213),
    [anon_sym_TILDE] = ACTIONS(3213),
    [anon_sym_PLUS_PLUS] = ACTIONS(3213),
    [anon_sym_DASH_DASH] = ACTIONS(3213),
    [anon_sym_true] = ACTIONS(3211),
    [anon_sym_false] = ACTIONS(3211),
    [anon_sym_PLUS] = ACTIONS(3211),
    [anon_sym_DASH] = ACTIONS(3211),
    [anon_sym_STAR] = ACTIONS(3213),
    [anon_sym_CARET] = ACTIONS(3213),
    [anon_sym_AMP] = ACTIONS(3213),
    [anon_sym_this] = ACTIONS(3211),
    [anon_sym_scoped] = ACTIONS(3211),
    [anon_sym_var] = ACTIONS(3211),
    [sym_predefined_type] = ACTIONS(3211),
    [anon_sym_break] = ACTIONS(3211),
    [anon_sym_unchecked] = ACTIONS(3211),
    [anon_sym_continue] = ACTIONS(3211),
    [anon_sym_do] = ACTIONS(3211),
    [anon_sym_while] = ACTIONS(3211),
    [anon_sym_for] = ACTIONS(3211),
    [anon_sym_lock] = ACTIONS(3211),
    [anon_sym_yield] = ACTIONS(3211),
    [anon_sym_switch] = ACTIONS(3211),
    [anon_sym_default] = ACTIONS(3211),
    [anon_sym_throw] = ACTIONS(3211),
    [anon_sym_try] = ACTIONS(3211),
    [anon_sym_when] = ACTIONS(3211),
    [anon_sym_await] = ACTIONS(3211),
    [anon_sym_foreach] = ACTIONS(3211),
    [anon_sym_goto] = ACTIONS(3211),
    [anon_sym_if] = ACTIONS(3211),
    [anon_sym_else] = ACTIONS(3211),
    [anon_sym_DOT_DOT] = ACTIONS(3213),
    [anon_sym_from] = ACTIONS(3211),
    [anon_sym_into] = ACTIONS(3211),
    [anon_sym_join] = ACTIONS(3211),
    [anon_sym_on] = ACTIONS(3211),
    [anon_sym_equals] = ACTIONS(3211),
    [anon_sym_let] = ACTIONS(3211),
    [anon_sym_orderby] = ACTIONS(3211),
    [anon_sym_ascending] = ACTIONS(3211),
    [anon_sym_descending] = ACTIONS(3211),
    [anon_sym_group] = ACTIONS(3211),
    [anon_sym_by] = ACTIONS(3211),
    [anon_sym_select] = ACTIONS(3211),
    [anon_sym_DQUOTE] = ACTIONS(3211),
    [anon_sym_stackalloc] = ACTIONS(3211),
    [anon_sym_sizeof] = ACTIONS(3211),
    [anon_sym_typeof] = ACTIONS(3211),
    [anon_sym___makeref] = ACTIONS(3211),
    [anon_sym___reftype] = ACTIONS(3211),
    [anon_sym___refvalue] = ACTIONS(3211),
    [sym_null_literal] = ACTIONS(3211),
    [anon_sym_SQUOTE] = ACTIONS(3213),
    [sym_integer_literal] = ACTIONS(3211),
    [sym_real_literal] = ACTIONS(3213),
    [sym_verbatim_string_literal] = ACTIONS(3213),
    [sym_raw_string_literal] = ACTIONS(3213),
    [aux_sym_preproc_if_token1] = ACTIONS(3213),
    [aux_sym_preproc_if_token3] = ACTIONS(3213),
    [aux_sym_preproc_else_token1] = ACTIONS(3213),
    [aux_sym_preproc_elif_token1] = ACTIONS(3213),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3213),
    [sym_interpolation_verbatim_start] = ACTIONS(3213),
    [sym_interpolation_raw_start] = ACTIONS(3213),
  },
  [2242] = {
    [sym_preproc_region] = STATE(2242),
    [sym_preproc_endregion] = STATE(2242),
    [sym_preproc_line] = STATE(2242),
    [sym_preproc_pragma] = STATE(2242),
    [sym_preproc_nullable] = STATE(2242),
    [sym_preproc_error] = STATE(2242),
    [sym_preproc_define] = STATE(2242),
    [sym_preproc_undef] = STATE(2242),
    [sym__identifier_token] = ACTIONS(3215),
    [anon_sym_extern] = ACTIONS(3215),
    [anon_sym_alias] = ACTIONS(3215),
    [anon_sym_SEMI] = ACTIONS(3217),
    [anon_sym_global] = ACTIONS(3215),
    [anon_sym_using] = ACTIONS(3215),
    [anon_sym_unsafe] = ACTIONS(3215),
    [anon_sym_static] = ACTIONS(3215),
    [anon_sym_LBRACK] = ACTIONS(3217),
    [anon_sym_LPAREN] = ACTIONS(3217),
    [anon_sym_return] = ACTIONS(3215),
    [anon_sym_namespace] = ACTIONS(3215),
    [anon_sym_class] = ACTIONS(3215),
    [anon_sym_ref] = ACTIONS(3215),
    [anon_sym_struct] = ACTIONS(3215),
    [anon_sym_enum] = ACTIONS(3215),
    [anon_sym_LBRACE] = ACTIONS(3217),
    [anon_sym_interface] = ACTIONS(3215),
    [anon_sym_delegate] = ACTIONS(3215),
    [anon_sym_record] = ACTIONS(3215),
    [anon_sym_abstract] = ACTIONS(3215),
    [anon_sym_async] = ACTIONS(3215),
    [anon_sym_const] = ACTIONS(3215),
    [anon_sym_file] = ACTIONS(3215),
    [anon_sym_fixed] = ACTIONS(3215),
    [anon_sym_internal] = ACTIONS(3215),
    [anon_sym_new] = ACTIONS(3215),
    [anon_sym_override] = ACTIONS(3215),
    [anon_sym_partial] = ACTIONS(3215),
    [anon_sym_private] = ACTIONS(3215),
    [anon_sym_protected] = ACTIONS(3215),
    [anon_sym_public] = ACTIONS(3215),
    [anon_sym_readonly] = ACTIONS(3215),
    [anon_sym_required] = ACTIONS(3215),
    [anon_sym_sealed] = ACTIONS(3215),
    [anon_sym_virtual] = ACTIONS(3215),
    [anon_sym_volatile] = ACTIONS(3215),
    [anon_sym_where] = ACTIONS(3215),
    [anon_sym_notnull] = ACTIONS(3215),
    [anon_sym_unmanaged] = ACTIONS(3215),
    [anon_sym_checked] = ACTIONS(3215),
    [anon_sym_BANG] = ACTIONS(3217),
    [anon_sym_TILDE] = ACTIONS(3217),
    [anon_sym_PLUS_PLUS] = ACTIONS(3217),
    [anon_sym_DASH_DASH] = ACTIONS(3217),
    [anon_sym_true] = ACTIONS(3215),
    [anon_sym_false] = ACTIONS(3215),
    [anon_sym_PLUS] = ACTIONS(3215),
    [anon_sym_DASH] = ACTIONS(3215),
    [anon_sym_STAR] = ACTIONS(3217),
    [anon_sym_CARET] = ACTIONS(3217),
    [anon_sym_AMP] = ACTIONS(3217),
    [anon_sym_this] = ACTIONS(3215),
    [anon_sym_scoped] = ACTIONS(3215),
    [anon_sym_var] = ACTIONS(3215),
    [sym_predefined_type] = ACTIONS(3215),
    [anon_sym_break] = ACTIONS(3215),
    [anon_sym_unchecked] = ACTIONS(3215),
    [anon_sym_continue] = ACTIONS(3215),
    [anon_sym_do] = ACTIONS(3215),
    [anon_sym_while] = ACTIONS(3215),
    [anon_sym_for] = ACTIONS(3215),
    [anon_sym_lock] = ACTIONS(3215),
    [anon_sym_yield] = ACTIONS(3215),
    [anon_sym_switch] = ACTIONS(3215),
    [anon_sym_default] = ACTIONS(3215),
    [anon_sym_throw] = ACTIONS(3215),
    [anon_sym_try] = ACTIONS(3215),
    [anon_sym_when] = ACTIONS(3215),
    [anon_sym_await] = ACTIONS(3215),
    [anon_sym_foreach] = ACTIONS(3215),
    [anon_sym_goto] = ACTIONS(3215),
    [anon_sym_if] = ACTIONS(3215),
    [anon_sym_else] = ACTIONS(3215),
    [anon_sym_DOT_DOT] = ACTIONS(3217),
    [anon_sym_from] = ACTIONS(3215),
    [anon_sym_into] = ACTIONS(3215),
    [anon_sym_join] = ACTIONS(3215),
    [anon_sym_on] = ACTIONS(3215),
    [anon_sym_equals] = ACTIONS(3215),
    [anon_sym_let] = ACTIONS(3215),
    [anon_sym_orderby] = ACTIONS(3215),
    [anon_sym_ascending] = ACTIONS(3215),
    [anon_sym_descending] = ACTIONS(3215),
    [anon_sym_group] = ACTIONS(3215),
    [anon_sym_by] = ACTIONS(3215),
    [anon_sym_select] = ACTIONS(3215),
    [anon_sym_DQUOTE] = ACTIONS(3215),
    [anon_sym_stackalloc] = ACTIONS(3215),
    [anon_sym_sizeof] = ACTIONS(3215),
    [anon_sym_typeof] = ACTIONS(3215),
    [anon_sym___makeref] = ACTIONS(3215),
    [anon_sym___reftype] = ACTIONS(3215),
    [anon_sym___refvalue] = ACTIONS(3215),
    [sym_null_literal] = ACTIONS(3215),
    [anon_sym_SQUOTE] = ACTIONS(3217),
    [sym_integer_literal] = ACTIONS(3215),
    [sym_real_literal] = ACTIONS(3217),
    [sym_verbatim_string_literal] = ACTIONS(3217),
    [sym_raw_string_literal] = ACTIONS(3217),
    [aux_sym_preproc_if_token1] = ACTIONS(3217),
    [aux_sym_preproc_if_token3] = ACTIONS(3217),
    [aux_sym_preproc_else_token1] = ACTIONS(3217),
    [aux_sym_preproc_elif_token1] = ACTIONS(3217),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3217),
    [sym_interpolation_verbatim_start] = ACTIONS(3217),
    [sym_interpolation_raw_start] = ACTIONS(3217),
  },
  [2243] = {
    [sym_preproc_region] = STATE(2243),
    [sym_preproc_endregion] = STATE(2243),
    [sym_preproc_line] = STATE(2243),
    [sym_preproc_pragma] = STATE(2243),
    [sym_preproc_nullable] = STATE(2243),
    [sym_preproc_error] = STATE(2243),
    [sym_preproc_define] = STATE(2243),
    [sym_preproc_undef] = STATE(2243),
    [sym__identifier_token] = ACTIONS(3219),
    [anon_sym_extern] = ACTIONS(3219),
    [anon_sym_alias] = ACTIONS(3219),
    [anon_sym_SEMI] = ACTIONS(3221),
    [anon_sym_global] = ACTIONS(3219),
    [anon_sym_using] = ACTIONS(3219),
    [anon_sym_unsafe] = ACTIONS(3219),
    [anon_sym_static] = ACTIONS(3219),
    [anon_sym_LBRACK] = ACTIONS(3221),
    [anon_sym_LPAREN] = ACTIONS(3221),
    [anon_sym_return] = ACTIONS(3219),
    [anon_sym_namespace] = ACTIONS(3219),
    [anon_sym_class] = ACTIONS(3219),
    [anon_sym_ref] = ACTIONS(3219),
    [anon_sym_struct] = ACTIONS(3219),
    [anon_sym_enum] = ACTIONS(3219),
    [anon_sym_LBRACE] = ACTIONS(3221),
    [anon_sym_interface] = ACTIONS(3219),
    [anon_sym_delegate] = ACTIONS(3219),
    [anon_sym_record] = ACTIONS(3219),
    [anon_sym_abstract] = ACTIONS(3219),
    [anon_sym_async] = ACTIONS(3219),
    [anon_sym_const] = ACTIONS(3219),
    [anon_sym_file] = ACTIONS(3219),
    [anon_sym_fixed] = ACTIONS(3219),
    [anon_sym_internal] = ACTIONS(3219),
    [anon_sym_new] = ACTIONS(3219),
    [anon_sym_override] = ACTIONS(3219),
    [anon_sym_partial] = ACTIONS(3219),
    [anon_sym_private] = ACTIONS(3219),
    [anon_sym_protected] = ACTIONS(3219),
    [anon_sym_public] = ACTIONS(3219),
    [anon_sym_readonly] = ACTIONS(3219),
    [anon_sym_required] = ACTIONS(3219),
    [anon_sym_sealed] = ACTIONS(3219),
    [anon_sym_virtual] = ACTIONS(3219),
    [anon_sym_volatile] = ACTIONS(3219),
    [anon_sym_where] = ACTIONS(3219),
    [anon_sym_notnull] = ACTIONS(3219),
    [anon_sym_unmanaged] = ACTIONS(3219),
    [anon_sym_checked] = ACTIONS(3219),
    [anon_sym_BANG] = ACTIONS(3221),
    [anon_sym_TILDE] = ACTIONS(3221),
    [anon_sym_PLUS_PLUS] = ACTIONS(3221),
    [anon_sym_DASH_DASH] = ACTIONS(3221),
    [anon_sym_true] = ACTIONS(3219),
    [anon_sym_false] = ACTIONS(3219),
    [anon_sym_PLUS] = ACTIONS(3219),
    [anon_sym_DASH] = ACTIONS(3219),
    [anon_sym_STAR] = ACTIONS(3221),
    [anon_sym_CARET] = ACTIONS(3221),
    [anon_sym_AMP] = ACTIONS(3221),
    [anon_sym_this] = ACTIONS(3219),
    [anon_sym_scoped] = ACTIONS(3219),
    [anon_sym_var] = ACTIONS(3219),
    [sym_predefined_type] = ACTIONS(3219),
    [anon_sym_break] = ACTIONS(3219),
    [anon_sym_unchecked] = ACTIONS(3219),
    [anon_sym_continue] = ACTIONS(3219),
    [anon_sym_do] = ACTIONS(3219),
    [anon_sym_while] = ACTIONS(3219),
    [anon_sym_for] = ACTIONS(3219),
    [anon_sym_lock] = ACTIONS(3219),
    [anon_sym_yield] = ACTIONS(3219),
    [anon_sym_switch] = ACTIONS(3219),
    [anon_sym_default] = ACTIONS(3219),
    [anon_sym_throw] = ACTIONS(3219),
    [anon_sym_try] = ACTIONS(3219),
    [anon_sym_when] = ACTIONS(3219),
    [anon_sym_await] = ACTIONS(3219),
    [anon_sym_foreach] = ACTIONS(3219),
    [anon_sym_goto] = ACTIONS(3219),
    [anon_sym_if] = ACTIONS(3219),
    [anon_sym_else] = ACTIONS(3219),
    [anon_sym_DOT_DOT] = ACTIONS(3221),
    [anon_sym_from] = ACTIONS(3219),
    [anon_sym_into] = ACTIONS(3219),
    [anon_sym_join] = ACTIONS(3219),
    [anon_sym_on] = ACTIONS(3219),
    [anon_sym_equals] = ACTIONS(3219),
    [anon_sym_let] = ACTIONS(3219),
    [anon_sym_orderby] = ACTIONS(3219),
    [anon_sym_ascending] = ACTIONS(3219),
    [anon_sym_descending] = ACTIONS(3219),
    [anon_sym_group] = ACTIONS(3219),
    [anon_sym_by] = ACTIONS(3219),
    [anon_sym_select] = ACTIONS(3219),
    [anon_sym_DQUOTE] = ACTIONS(3219),
    [anon_sym_stackalloc] = ACTIONS(3219),
    [anon_sym_sizeof] = ACTIONS(3219),
    [anon_sym_typeof] = ACTIONS(3219),
    [anon_sym___makeref] = ACTIONS(3219),
    [anon_sym___reftype] = ACTIONS(3219),
    [anon_sym___refvalue] = ACTIONS(3219),
    [sym_null_literal] = ACTIONS(3219),
    [anon_sym_SQUOTE] = ACTIONS(3221),
    [sym_integer_literal] = ACTIONS(3219),
    [sym_real_literal] = ACTIONS(3221),
    [sym_verbatim_string_literal] = ACTIONS(3221),
    [sym_raw_string_literal] = ACTIONS(3221),
    [aux_sym_preproc_if_token1] = ACTIONS(3221),
    [aux_sym_preproc_if_token3] = ACTIONS(3221),
    [aux_sym_preproc_else_token1] = ACTIONS(3221),
    [aux_sym_preproc_elif_token1] = ACTIONS(3221),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3221),
    [sym_interpolation_verbatim_start] = ACTIONS(3221),
    [sym_interpolation_raw_start] = ACTIONS(3221),
  },
  [2244] = {
    [sym_preproc_region] = STATE(2244),
    [sym_preproc_endregion] = STATE(2244),
    [sym_preproc_line] = STATE(2244),
    [sym_preproc_pragma] = STATE(2244),
    [sym_preproc_nullable] = STATE(2244),
    [sym_preproc_error] = STATE(2244),
    [sym_preproc_define] = STATE(2244),
    [sym_preproc_undef] = STATE(2244),
    [sym__identifier_token] = ACTIONS(3223),
    [anon_sym_extern] = ACTIONS(3223),
    [anon_sym_alias] = ACTIONS(3223),
    [anon_sym_SEMI] = ACTIONS(3225),
    [anon_sym_global] = ACTIONS(3223),
    [anon_sym_using] = ACTIONS(3223),
    [anon_sym_unsafe] = ACTIONS(3223),
    [anon_sym_static] = ACTIONS(3223),
    [anon_sym_LBRACK] = ACTIONS(3225),
    [anon_sym_LPAREN] = ACTIONS(3225),
    [anon_sym_return] = ACTIONS(3223),
    [anon_sym_namespace] = ACTIONS(3223),
    [anon_sym_class] = ACTIONS(3223),
    [anon_sym_ref] = ACTIONS(3223),
    [anon_sym_struct] = ACTIONS(3223),
    [anon_sym_enum] = ACTIONS(3223),
    [anon_sym_LBRACE] = ACTIONS(3225),
    [anon_sym_interface] = ACTIONS(3223),
    [anon_sym_delegate] = ACTIONS(3223),
    [anon_sym_record] = ACTIONS(3223),
    [anon_sym_abstract] = ACTIONS(3223),
    [anon_sym_async] = ACTIONS(3223),
    [anon_sym_const] = ACTIONS(3223),
    [anon_sym_file] = ACTIONS(3223),
    [anon_sym_fixed] = ACTIONS(3223),
    [anon_sym_internal] = ACTIONS(3223),
    [anon_sym_new] = ACTIONS(3223),
    [anon_sym_override] = ACTIONS(3223),
    [anon_sym_partial] = ACTIONS(3223),
    [anon_sym_private] = ACTIONS(3223),
    [anon_sym_protected] = ACTIONS(3223),
    [anon_sym_public] = ACTIONS(3223),
    [anon_sym_readonly] = ACTIONS(3223),
    [anon_sym_required] = ACTIONS(3223),
    [anon_sym_sealed] = ACTIONS(3223),
    [anon_sym_virtual] = ACTIONS(3223),
    [anon_sym_volatile] = ACTIONS(3223),
    [anon_sym_where] = ACTIONS(3223),
    [anon_sym_notnull] = ACTIONS(3223),
    [anon_sym_unmanaged] = ACTIONS(3223),
    [anon_sym_checked] = ACTIONS(3223),
    [anon_sym_BANG] = ACTIONS(3225),
    [anon_sym_TILDE] = ACTIONS(3225),
    [anon_sym_PLUS_PLUS] = ACTIONS(3225),
    [anon_sym_DASH_DASH] = ACTIONS(3225),
    [anon_sym_true] = ACTIONS(3223),
    [anon_sym_false] = ACTIONS(3223),
    [anon_sym_PLUS] = ACTIONS(3223),
    [anon_sym_DASH] = ACTIONS(3223),
    [anon_sym_STAR] = ACTIONS(3225),
    [anon_sym_CARET] = ACTIONS(3225),
    [anon_sym_AMP] = ACTIONS(3225),
    [anon_sym_this] = ACTIONS(3223),
    [anon_sym_scoped] = ACTIONS(3223),
    [anon_sym_var] = ACTIONS(3223),
    [sym_predefined_type] = ACTIONS(3223),
    [anon_sym_break] = ACTIONS(3223),
    [anon_sym_unchecked] = ACTIONS(3223),
    [anon_sym_continue] = ACTIONS(3223),
    [anon_sym_do] = ACTIONS(3223),
    [anon_sym_while] = ACTIONS(3223),
    [anon_sym_for] = ACTIONS(3223),
    [anon_sym_lock] = ACTIONS(3223),
    [anon_sym_yield] = ACTIONS(3223),
    [anon_sym_switch] = ACTIONS(3223),
    [anon_sym_default] = ACTIONS(3223),
    [anon_sym_throw] = ACTIONS(3223),
    [anon_sym_try] = ACTIONS(3223),
    [anon_sym_when] = ACTIONS(3223),
    [anon_sym_await] = ACTIONS(3223),
    [anon_sym_foreach] = ACTIONS(3223),
    [anon_sym_goto] = ACTIONS(3223),
    [anon_sym_if] = ACTIONS(3223),
    [anon_sym_else] = ACTIONS(3223),
    [anon_sym_DOT_DOT] = ACTIONS(3225),
    [anon_sym_from] = ACTIONS(3223),
    [anon_sym_into] = ACTIONS(3223),
    [anon_sym_join] = ACTIONS(3223),
    [anon_sym_on] = ACTIONS(3223),
    [anon_sym_equals] = ACTIONS(3223),
    [anon_sym_let] = ACTIONS(3223),
    [anon_sym_orderby] = ACTIONS(3223),
    [anon_sym_ascending] = ACTIONS(3223),
    [anon_sym_descending] = ACTIONS(3223),
    [anon_sym_group] = ACTIONS(3223),
    [anon_sym_by] = ACTIONS(3223),
    [anon_sym_select] = ACTIONS(3223),
    [anon_sym_DQUOTE] = ACTIONS(3223),
    [anon_sym_stackalloc] = ACTIONS(3223),
    [anon_sym_sizeof] = ACTIONS(3223),
    [anon_sym_typeof] = ACTIONS(3223),
    [anon_sym___makeref] = ACTIONS(3223),
    [anon_sym___reftype] = ACTIONS(3223),
    [anon_sym___refvalue] = ACTIONS(3223),
    [sym_null_literal] = ACTIONS(3223),
    [anon_sym_SQUOTE] = ACTIONS(3225),
    [sym_integer_literal] = ACTIONS(3223),
    [sym_real_literal] = ACTIONS(3225),
    [sym_verbatim_string_literal] = ACTIONS(3225),
    [sym_raw_string_literal] = ACTIONS(3225),
    [aux_sym_preproc_if_token1] = ACTIONS(3225),
    [aux_sym_preproc_if_token3] = ACTIONS(3225),
    [aux_sym_preproc_else_token1] = ACTIONS(3225),
    [aux_sym_preproc_elif_token1] = ACTIONS(3225),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3225),
    [sym_interpolation_verbatim_start] = ACTIONS(3225),
    [sym_interpolation_raw_start] = ACTIONS(3225),
  },
  [2245] = {
    [sym_preproc_region] = STATE(2245),
    [sym_preproc_endregion] = STATE(2245),
    [sym_preproc_line] = STATE(2245),
    [sym_preproc_pragma] = STATE(2245),
    [sym_preproc_nullable] = STATE(2245),
    [sym_preproc_error] = STATE(2245),
    [sym_preproc_define] = STATE(2245),
    [sym_preproc_undef] = STATE(2245),
    [sym__identifier_token] = ACTIONS(3227),
    [anon_sym_extern] = ACTIONS(3227),
    [anon_sym_alias] = ACTIONS(3227),
    [anon_sym_SEMI] = ACTIONS(3229),
    [anon_sym_global] = ACTIONS(3227),
    [anon_sym_using] = ACTIONS(3227),
    [anon_sym_unsafe] = ACTIONS(3227),
    [anon_sym_static] = ACTIONS(3227),
    [anon_sym_LBRACK] = ACTIONS(3229),
    [anon_sym_LPAREN] = ACTIONS(3229),
    [anon_sym_return] = ACTIONS(3227),
    [anon_sym_namespace] = ACTIONS(3227),
    [anon_sym_class] = ACTIONS(3227),
    [anon_sym_ref] = ACTIONS(3227),
    [anon_sym_struct] = ACTIONS(3227),
    [anon_sym_enum] = ACTIONS(3227),
    [anon_sym_LBRACE] = ACTIONS(3229),
    [anon_sym_interface] = ACTIONS(3227),
    [anon_sym_delegate] = ACTIONS(3227),
    [anon_sym_record] = ACTIONS(3227),
    [anon_sym_abstract] = ACTIONS(3227),
    [anon_sym_async] = ACTIONS(3227),
    [anon_sym_const] = ACTIONS(3227),
    [anon_sym_file] = ACTIONS(3227),
    [anon_sym_fixed] = ACTIONS(3227),
    [anon_sym_internal] = ACTIONS(3227),
    [anon_sym_new] = ACTIONS(3227),
    [anon_sym_override] = ACTIONS(3227),
    [anon_sym_partial] = ACTIONS(3227),
    [anon_sym_private] = ACTIONS(3227),
    [anon_sym_protected] = ACTIONS(3227),
    [anon_sym_public] = ACTIONS(3227),
    [anon_sym_readonly] = ACTIONS(3227),
    [anon_sym_required] = ACTIONS(3227),
    [anon_sym_sealed] = ACTIONS(3227),
    [anon_sym_virtual] = ACTIONS(3227),
    [anon_sym_volatile] = ACTIONS(3227),
    [anon_sym_where] = ACTIONS(3227),
    [anon_sym_notnull] = ACTIONS(3227),
    [anon_sym_unmanaged] = ACTIONS(3227),
    [anon_sym_checked] = ACTIONS(3227),
    [anon_sym_BANG] = ACTIONS(3229),
    [anon_sym_TILDE] = ACTIONS(3229),
    [anon_sym_PLUS_PLUS] = ACTIONS(3229),
    [anon_sym_DASH_DASH] = ACTIONS(3229),
    [anon_sym_true] = ACTIONS(3227),
    [anon_sym_false] = ACTIONS(3227),
    [anon_sym_PLUS] = ACTIONS(3227),
    [anon_sym_DASH] = ACTIONS(3227),
    [anon_sym_STAR] = ACTIONS(3229),
    [anon_sym_CARET] = ACTIONS(3229),
    [anon_sym_AMP] = ACTIONS(3229),
    [anon_sym_this] = ACTIONS(3227),
    [anon_sym_scoped] = ACTIONS(3227),
    [anon_sym_var] = ACTIONS(3227),
    [sym_predefined_type] = ACTIONS(3227),
    [anon_sym_break] = ACTIONS(3227),
    [anon_sym_unchecked] = ACTIONS(3227),
    [anon_sym_continue] = ACTIONS(3227),
    [anon_sym_do] = ACTIONS(3227),
    [anon_sym_while] = ACTIONS(3227),
    [anon_sym_for] = ACTIONS(3227),
    [anon_sym_lock] = ACTIONS(3227),
    [anon_sym_yield] = ACTIONS(3227),
    [anon_sym_switch] = ACTIONS(3227),
    [anon_sym_default] = ACTIONS(3227),
    [anon_sym_throw] = ACTIONS(3227),
    [anon_sym_try] = ACTIONS(3227),
    [anon_sym_when] = ACTIONS(3227),
    [anon_sym_await] = ACTIONS(3227),
    [anon_sym_foreach] = ACTIONS(3227),
    [anon_sym_goto] = ACTIONS(3227),
    [anon_sym_if] = ACTIONS(3227),
    [anon_sym_else] = ACTIONS(3227),
    [anon_sym_DOT_DOT] = ACTIONS(3229),
    [anon_sym_from] = ACTIONS(3227),
    [anon_sym_into] = ACTIONS(3227),
    [anon_sym_join] = ACTIONS(3227),
    [anon_sym_on] = ACTIONS(3227),
    [anon_sym_equals] = ACTIONS(3227),
    [anon_sym_let] = ACTIONS(3227),
    [anon_sym_orderby] = ACTIONS(3227),
    [anon_sym_ascending] = ACTIONS(3227),
    [anon_sym_descending] = ACTIONS(3227),
    [anon_sym_group] = ACTIONS(3227),
    [anon_sym_by] = ACTIONS(3227),
    [anon_sym_select] = ACTIONS(3227),
    [anon_sym_DQUOTE] = ACTIONS(3227),
    [anon_sym_stackalloc] = ACTIONS(3227),
    [anon_sym_sizeof] = ACTIONS(3227),
    [anon_sym_typeof] = ACTIONS(3227),
    [anon_sym___makeref] = ACTIONS(3227),
    [anon_sym___reftype] = ACTIONS(3227),
    [anon_sym___refvalue] = ACTIONS(3227),
    [sym_null_literal] = ACTIONS(3227),
    [anon_sym_SQUOTE] = ACTIONS(3229),
    [sym_integer_literal] = ACTIONS(3227),
    [sym_real_literal] = ACTIONS(3229),
    [sym_verbatim_string_literal] = ACTIONS(3229),
    [sym_raw_string_literal] = ACTIONS(3229),
    [aux_sym_preproc_if_token1] = ACTIONS(3229),
    [aux_sym_preproc_if_token3] = ACTIONS(3229),
    [aux_sym_preproc_else_token1] = ACTIONS(3229),
    [aux_sym_preproc_elif_token1] = ACTIONS(3229),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3229),
    [sym_interpolation_verbatim_start] = ACTIONS(3229),
    [sym_interpolation_raw_start] = ACTIONS(3229),
  },
  [2246] = {
    [sym_preproc_region] = STATE(2246),
    [sym_preproc_endregion] = STATE(2246),
    [sym_preproc_line] = STATE(2246),
    [sym_preproc_pragma] = STATE(2246),
    [sym_preproc_nullable] = STATE(2246),
    [sym_preproc_error] = STATE(2246),
    [sym_preproc_define] = STATE(2246),
    [sym_preproc_undef] = STATE(2246),
    [sym__identifier_token] = ACTIONS(3231),
    [anon_sym_extern] = ACTIONS(3231),
    [anon_sym_alias] = ACTIONS(3231),
    [anon_sym_SEMI] = ACTIONS(3233),
    [anon_sym_global] = ACTIONS(3231),
    [anon_sym_using] = ACTIONS(3231),
    [anon_sym_unsafe] = ACTIONS(3231),
    [anon_sym_static] = ACTIONS(3231),
    [anon_sym_LBRACK] = ACTIONS(3233),
    [anon_sym_LPAREN] = ACTIONS(3233),
    [anon_sym_return] = ACTIONS(3231),
    [anon_sym_namespace] = ACTIONS(3231),
    [anon_sym_class] = ACTIONS(3231),
    [anon_sym_ref] = ACTIONS(3231),
    [anon_sym_struct] = ACTIONS(3231),
    [anon_sym_enum] = ACTIONS(3231),
    [anon_sym_LBRACE] = ACTIONS(3233),
    [anon_sym_interface] = ACTIONS(3231),
    [anon_sym_delegate] = ACTIONS(3231),
    [anon_sym_record] = ACTIONS(3231),
    [anon_sym_abstract] = ACTIONS(3231),
    [anon_sym_async] = ACTIONS(3231),
    [anon_sym_const] = ACTIONS(3231),
    [anon_sym_file] = ACTIONS(3231),
    [anon_sym_fixed] = ACTIONS(3231),
    [anon_sym_internal] = ACTIONS(3231),
    [anon_sym_new] = ACTIONS(3231),
    [anon_sym_override] = ACTIONS(3231),
    [anon_sym_partial] = ACTIONS(3231),
    [anon_sym_private] = ACTIONS(3231),
    [anon_sym_protected] = ACTIONS(3231),
    [anon_sym_public] = ACTIONS(3231),
    [anon_sym_readonly] = ACTIONS(3231),
    [anon_sym_required] = ACTIONS(3231),
    [anon_sym_sealed] = ACTIONS(3231),
    [anon_sym_virtual] = ACTIONS(3231),
    [anon_sym_volatile] = ACTIONS(3231),
    [anon_sym_where] = ACTIONS(3231),
    [anon_sym_notnull] = ACTIONS(3231),
    [anon_sym_unmanaged] = ACTIONS(3231),
    [anon_sym_checked] = ACTIONS(3231),
    [anon_sym_BANG] = ACTIONS(3233),
    [anon_sym_TILDE] = ACTIONS(3233),
    [anon_sym_PLUS_PLUS] = ACTIONS(3233),
    [anon_sym_DASH_DASH] = ACTIONS(3233),
    [anon_sym_true] = ACTIONS(3231),
    [anon_sym_false] = ACTIONS(3231),
    [anon_sym_PLUS] = ACTIONS(3231),
    [anon_sym_DASH] = ACTIONS(3231),
    [anon_sym_STAR] = ACTIONS(3233),
    [anon_sym_CARET] = ACTIONS(3233),
    [anon_sym_AMP] = ACTIONS(3233),
    [anon_sym_this] = ACTIONS(3231),
    [anon_sym_scoped] = ACTIONS(3231),
    [anon_sym_var] = ACTIONS(3231),
    [sym_predefined_type] = ACTIONS(3231),
    [anon_sym_break] = ACTIONS(3231),
    [anon_sym_unchecked] = ACTIONS(3231),
    [anon_sym_continue] = ACTIONS(3231),
    [anon_sym_do] = ACTIONS(3231),
    [anon_sym_while] = ACTIONS(3231),
    [anon_sym_for] = ACTIONS(3231),
    [anon_sym_lock] = ACTIONS(3231),
    [anon_sym_yield] = ACTIONS(3231),
    [anon_sym_switch] = ACTIONS(3231),
    [anon_sym_default] = ACTIONS(3231),
    [anon_sym_throw] = ACTIONS(3231),
    [anon_sym_try] = ACTIONS(3231),
    [anon_sym_when] = ACTIONS(3231),
    [anon_sym_await] = ACTIONS(3231),
    [anon_sym_foreach] = ACTIONS(3231),
    [anon_sym_goto] = ACTIONS(3231),
    [anon_sym_if] = ACTIONS(3231),
    [anon_sym_else] = ACTIONS(3231),
    [anon_sym_DOT_DOT] = ACTIONS(3233),
    [anon_sym_from] = ACTIONS(3231),
    [anon_sym_into] = ACTIONS(3231),
    [anon_sym_join] = ACTIONS(3231),
    [anon_sym_on] = ACTIONS(3231),
    [anon_sym_equals] = ACTIONS(3231),
    [anon_sym_let] = ACTIONS(3231),
    [anon_sym_orderby] = ACTIONS(3231),
    [anon_sym_ascending] = ACTIONS(3231),
    [anon_sym_descending] = ACTIONS(3231),
    [anon_sym_group] = ACTIONS(3231),
    [anon_sym_by] = ACTIONS(3231),
    [anon_sym_select] = ACTIONS(3231),
    [anon_sym_DQUOTE] = ACTIONS(3231),
    [anon_sym_stackalloc] = ACTIONS(3231),
    [anon_sym_sizeof] = ACTIONS(3231),
    [anon_sym_typeof] = ACTIONS(3231),
    [anon_sym___makeref] = ACTIONS(3231),
    [anon_sym___reftype] = ACTIONS(3231),
    [anon_sym___refvalue] = ACTIONS(3231),
    [sym_null_literal] = ACTIONS(3231),
    [anon_sym_SQUOTE] = ACTIONS(3233),
    [sym_integer_literal] = ACTIONS(3231),
    [sym_real_literal] = ACTIONS(3233),
    [sym_verbatim_string_literal] = ACTIONS(3233),
    [sym_raw_string_literal] = ACTIONS(3233),
    [aux_sym_preproc_if_token1] = ACTIONS(3233),
    [aux_sym_preproc_if_token3] = ACTIONS(3233),
    [aux_sym_preproc_else_token1] = ACTIONS(3233),
    [aux_sym_preproc_elif_token1] = ACTIONS(3233),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3233),
    [sym_interpolation_verbatim_start] = ACTIONS(3233),
    [sym_interpolation_raw_start] = ACTIONS(3233),
  },
  [2247] = {
    [sym_preproc_region] = STATE(2247),
    [sym_preproc_endregion] = STATE(2247),
    [sym_preproc_line] = STATE(2247),
    [sym_preproc_pragma] = STATE(2247),
    [sym_preproc_nullable] = STATE(2247),
    [sym_preproc_error] = STATE(2247),
    [sym_preproc_define] = STATE(2247),
    [sym_preproc_undef] = STATE(2247),
    [sym__identifier_token] = ACTIONS(3235),
    [anon_sym_extern] = ACTIONS(3235),
    [anon_sym_alias] = ACTIONS(3235),
    [anon_sym_SEMI] = ACTIONS(3237),
    [anon_sym_global] = ACTIONS(3235),
    [anon_sym_using] = ACTIONS(3235),
    [anon_sym_unsafe] = ACTIONS(3235),
    [anon_sym_static] = ACTIONS(3235),
    [anon_sym_LBRACK] = ACTIONS(3237),
    [anon_sym_LPAREN] = ACTIONS(3237),
    [anon_sym_return] = ACTIONS(3235),
    [anon_sym_namespace] = ACTIONS(3235),
    [anon_sym_class] = ACTIONS(3235),
    [anon_sym_ref] = ACTIONS(3235),
    [anon_sym_struct] = ACTIONS(3235),
    [anon_sym_enum] = ACTIONS(3235),
    [anon_sym_LBRACE] = ACTIONS(3237),
    [anon_sym_interface] = ACTIONS(3235),
    [anon_sym_delegate] = ACTIONS(3235),
    [anon_sym_record] = ACTIONS(3235),
    [anon_sym_abstract] = ACTIONS(3235),
    [anon_sym_async] = ACTIONS(3235),
    [anon_sym_const] = ACTIONS(3235),
    [anon_sym_file] = ACTIONS(3235),
    [anon_sym_fixed] = ACTIONS(3235),
    [anon_sym_internal] = ACTIONS(3235),
    [anon_sym_new] = ACTIONS(3235),
    [anon_sym_override] = ACTIONS(3235),
    [anon_sym_partial] = ACTIONS(3235),
    [anon_sym_private] = ACTIONS(3235),
    [anon_sym_protected] = ACTIONS(3235),
    [anon_sym_public] = ACTIONS(3235),
    [anon_sym_readonly] = ACTIONS(3235),
    [anon_sym_required] = ACTIONS(3235),
    [anon_sym_sealed] = ACTIONS(3235),
    [anon_sym_virtual] = ACTIONS(3235),
    [anon_sym_volatile] = ACTIONS(3235),
    [anon_sym_where] = ACTIONS(3235),
    [anon_sym_notnull] = ACTIONS(3235),
    [anon_sym_unmanaged] = ACTIONS(3235),
    [anon_sym_checked] = ACTIONS(3235),
    [anon_sym_BANG] = ACTIONS(3237),
    [anon_sym_TILDE] = ACTIONS(3237),
    [anon_sym_PLUS_PLUS] = ACTIONS(3237),
    [anon_sym_DASH_DASH] = ACTIONS(3237),
    [anon_sym_true] = ACTIONS(3235),
    [anon_sym_false] = ACTIONS(3235),
    [anon_sym_PLUS] = ACTIONS(3235),
    [anon_sym_DASH] = ACTIONS(3235),
    [anon_sym_STAR] = ACTIONS(3237),
    [anon_sym_CARET] = ACTIONS(3237),
    [anon_sym_AMP] = ACTIONS(3237),
    [anon_sym_this] = ACTIONS(3235),
    [anon_sym_scoped] = ACTIONS(3235),
    [anon_sym_var] = ACTIONS(3235),
    [sym_predefined_type] = ACTIONS(3235),
    [anon_sym_break] = ACTIONS(3235),
    [anon_sym_unchecked] = ACTIONS(3235),
    [anon_sym_continue] = ACTIONS(3235),
    [anon_sym_do] = ACTIONS(3235),
    [anon_sym_while] = ACTIONS(3235),
    [anon_sym_for] = ACTIONS(3235),
    [anon_sym_lock] = ACTIONS(3235),
    [anon_sym_yield] = ACTIONS(3235),
    [anon_sym_switch] = ACTIONS(3235),
    [anon_sym_default] = ACTIONS(3235),
    [anon_sym_throw] = ACTIONS(3235),
    [anon_sym_try] = ACTIONS(3235),
    [anon_sym_when] = ACTIONS(3235),
    [anon_sym_await] = ACTIONS(3235),
    [anon_sym_foreach] = ACTIONS(3235),
    [anon_sym_goto] = ACTIONS(3235),
    [anon_sym_if] = ACTIONS(3235),
    [anon_sym_else] = ACTIONS(3235),
    [anon_sym_DOT_DOT] = ACTIONS(3237),
    [anon_sym_from] = ACTIONS(3235),
    [anon_sym_into] = ACTIONS(3235),
    [anon_sym_join] = ACTIONS(3235),
    [anon_sym_on] = ACTIONS(3235),
    [anon_sym_equals] = ACTIONS(3235),
    [anon_sym_let] = ACTIONS(3235),
    [anon_sym_orderby] = ACTIONS(3235),
    [anon_sym_ascending] = ACTIONS(3235),
    [anon_sym_descending] = ACTIONS(3235),
    [anon_sym_group] = ACTIONS(3235),
    [anon_sym_by] = ACTIONS(3235),
    [anon_sym_select] = ACTIONS(3235),
    [anon_sym_DQUOTE] = ACTIONS(3235),
    [anon_sym_stackalloc] = ACTIONS(3235),
    [anon_sym_sizeof] = ACTIONS(3235),
    [anon_sym_typeof] = ACTIONS(3235),
    [anon_sym___makeref] = ACTIONS(3235),
    [anon_sym___reftype] = ACTIONS(3235),
    [anon_sym___refvalue] = ACTIONS(3235),
    [sym_null_literal] = ACTIONS(3235),
    [anon_sym_SQUOTE] = ACTIONS(3237),
    [sym_integer_literal] = ACTIONS(3235),
    [sym_real_literal] = ACTIONS(3237),
    [sym_verbatim_string_literal] = ACTIONS(3237),
    [sym_raw_string_literal] = ACTIONS(3237),
    [aux_sym_preproc_if_token1] = ACTIONS(3237),
    [aux_sym_preproc_if_token3] = ACTIONS(3237),
    [aux_sym_preproc_else_token1] = ACTIONS(3237),
    [aux_sym_preproc_elif_token1] = ACTIONS(3237),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3237),
    [sym_interpolation_verbatim_start] = ACTIONS(3237),
    [sym_interpolation_raw_start] = ACTIONS(3237),
  },
  [2248] = {
    [sym_preproc_region] = STATE(2248),
    [sym_preproc_endregion] = STATE(2248),
    [sym_preproc_line] = STATE(2248),
    [sym_preproc_pragma] = STATE(2248),
    [sym_preproc_nullable] = STATE(2248),
    [sym_preproc_error] = STATE(2248),
    [sym_preproc_define] = STATE(2248),
    [sym_preproc_undef] = STATE(2248),
    [sym__identifier_token] = ACTIONS(3239),
    [anon_sym_extern] = ACTIONS(3239),
    [anon_sym_alias] = ACTIONS(3239),
    [anon_sym_SEMI] = ACTIONS(3241),
    [anon_sym_global] = ACTIONS(3239),
    [anon_sym_using] = ACTIONS(3239),
    [anon_sym_unsafe] = ACTIONS(3239),
    [anon_sym_static] = ACTIONS(3239),
    [anon_sym_LBRACK] = ACTIONS(3241),
    [anon_sym_LPAREN] = ACTIONS(3241),
    [anon_sym_return] = ACTIONS(3239),
    [anon_sym_namespace] = ACTIONS(3239),
    [anon_sym_class] = ACTIONS(3239),
    [anon_sym_ref] = ACTIONS(3239),
    [anon_sym_struct] = ACTIONS(3239),
    [anon_sym_enum] = ACTIONS(3239),
    [anon_sym_LBRACE] = ACTIONS(3241),
    [anon_sym_interface] = ACTIONS(3239),
    [anon_sym_delegate] = ACTIONS(3239),
    [anon_sym_record] = ACTIONS(3239),
    [anon_sym_abstract] = ACTIONS(3239),
    [anon_sym_async] = ACTIONS(3239),
    [anon_sym_const] = ACTIONS(3239),
    [anon_sym_file] = ACTIONS(3239),
    [anon_sym_fixed] = ACTIONS(3239),
    [anon_sym_internal] = ACTIONS(3239),
    [anon_sym_new] = ACTIONS(3239),
    [anon_sym_override] = ACTIONS(3239),
    [anon_sym_partial] = ACTIONS(3239),
    [anon_sym_private] = ACTIONS(3239),
    [anon_sym_protected] = ACTIONS(3239),
    [anon_sym_public] = ACTIONS(3239),
    [anon_sym_readonly] = ACTIONS(3239),
    [anon_sym_required] = ACTIONS(3239),
    [anon_sym_sealed] = ACTIONS(3239),
    [anon_sym_virtual] = ACTIONS(3239),
    [anon_sym_volatile] = ACTIONS(3239),
    [anon_sym_where] = ACTIONS(3239),
    [anon_sym_notnull] = ACTIONS(3239),
    [anon_sym_unmanaged] = ACTIONS(3239),
    [anon_sym_checked] = ACTIONS(3239),
    [anon_sym_BANG] = ACTIONS(3241),
    [anon_sym_TILDE] = ACTIONS(3241),
    [anon_sym_PLUS_PLUS] = ACTIONS(3241),
    [anon_sym_DASH_DASH] = ACTIONS(3241),
    [anon_sym_true] = ACTIONS(3239),
    [anon_sym_false] = ACTIONS(3239),
    [anon_sym_PLUS] = ACTIONS(3239),
    [anon_sym_DASH] = ACTIONS(3239),
    [anon_sym_STAR] = ACTIONS(3241),
    [anon_sym_CARET] = ACTIONS(3241),
    [anon_sym_AMP] = ACTIONS(3241),
    [anon_sym_this] = ACTIONS(3239),
    [anon_sym_scoped] = ACTIONS(3239),
    [anon_sym_var] = ACTIONS(3239),
    [sym_predefined_type] = ACTIONS(3239),
    [anon_sym_break] = ACTIONS(3239),
    [anon_sym_unchecked] = ACTIONS(3239),
    [anon_sym_continue] = ACTIONS(3239),
    [anon_sym_do] = ACTIONS(3239),
    [anon_sym_while] = ACTIONS(3239),
    [anon_sym_for] = ACTIONS(3239),
    [anon_sym_lock] = ACTIONS(3239),
    [anon_sym_yield] = ACTIONS(3239),
    [anon_sym_switch] = ACTIONS(3239),
    [anon_sym_default] = ACTIONS(3239),
    [anon_sym_throw] = ACTIONS(3239),
    [anon_sym_try] = ACTIONS(3239),
    [anon_sym_when] = ACTIONS(3239),
    [anon_sym_await] = ACTIONS(3239),
    [anon_sym_foreach] = ACTIONS(3239),
    [anon_sym_goto] = ACTIONS(3239),
    [anon_sym_if] = ACTIONS(3239),
    [anon_sym_else] = ACTIONS(3239),
    [anon_sym_DOT_DOT] = ACTIONS(3241),
    [anon_sym_from] = ACTIONS(3239),
    [anon_sym_into] = ACTIONS(3239),
    [anon_sym_join] = ACTIONS(3239),
    [anon_sym_on] = ACTIONS(3239),
    [anon_sym_equals] = ACTIONS(3239),
    [anon_sym_let] = ACTIONS(3239),
    [anon_sym_orderby] = ACTIONS(3239),
    [anon_sym_ascending] = ACTIONS(3239),
    [anon_sym_descending] = ACTIONS(3239),
    [anon_sym_group] = ACTIONS(3239),
    [anon_sym_by] = ACTIONS(3239),
    [anon_sym_select] = ACTIONS(3239),
    [anon_sym_DQUOTE] = ACTIONS(3239),
    [anon_sym_stackalloc] = ACTIONS(3239),
    [anon_sym_sizeof] = ACTIONS(3239),
    [anon_sym_typeof] = ACTIONS(3239),
    [anon_sym___makeref] = ACTIONS(3239),
    [anon_sym___reftype] = ACTIONS(3239),
    [anon_sym___refvalue] = ACTIONS(3239),
    [sym_null_literal] = ACTIONS(3239),
    [anon_sym_SQUOTE] = ACTIONS(3241),
    [sym_integer_literal] = ACTIONS(3239),
    [sym_real_literal] = ACTIONS(3241),
    [sym_verbatim_string_literal] = ACTIONS(3241),
    [sym_raw_string_literal] = ACTIONS(3241),
    [aux_sym_preproc_if_token1] = ACTIONS(3241),
    [aux_sym_preproc_if_token3] = ACTIONS(3241),
    [aux_sym_preproc_else_token1] = ACTIONS(3241),
    [aux_sym_preproc_elif_token1] = ACTIONS(3241),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3241),
    [sym_interpolation_verbatim_start] = ACTIONS(3241),
    [sym_interpolation_raw_start] = ACTIONS(3241),
  },
  [2249] = {
    [sym_preproc_region] = STATE(2249),
    [sym_preproc_endregion] = STATE(2249),
    [sym_preproc_line] = STATE(2249),
    [sym_preproc_pragma] = STATE(2249),
    [sym_preproc_nullable] = STATE(2249),
    [sym_preproc_error] = STATE(2249),
    [sym_preproc_define] = STATE(2249),
    [sym_preproc_undef] = STATE(2249),
    [sym__identifier_token] = ACTIONS(3243),
    [anon_sym_extern] = ACTIONS(3243),
    [anon_sym_alias] = ACTIONS(3243),
    [anon_sym_SEMI] = ACTIONS(3245),
    [anon_sym_global] = ACTIONS(3243),
    [anon_sym_using] = ACTIONS(3243),
    [anon_sym_unsafe] = ACTIONS(3243),
    [anon_sym_static] = ACTIONS(3243),
    [anon_sym_LBRACK] = ACTIONS(3245),
    [anon_sym_LPAREN] = ACTIONS(3245),
    [anon_sym_return] = ACTIONS(3243),
    [anon_sym_namespace] = ACTIONS(3243),
    [anon_sym_class] = ACTIONS(3243),
    [anon_sym_ref] = ACTIONS(3243),
    [anon_sym_struct] = ACTIONS(3243),
    [anon_sym_enum] = ACTIONS(3243),
    [anon_sym_LBRACE] = ACTIONS(3245),
    [anon_sym_interface] = ACTIONS(3243),
    [anon_sym_delegate] = ACTIONS(3243),
    [anon_sym_record] = ACTIONS(3243),
    [anon_sym_abstract] = ACTIONS(3243),
    [anon_sym_async] = ACTIONS(3243),
    [anon_sym_const] = ACTIONS(3243),
    [anon_sym_file] = ACTIONS(3243),
    [anon_sym_fixed] = ACTIONS(3243),
    [anon_sym_internal] = ACTIONS(3243),
    [anon_sym_new] = ACTIONS(3243),
    [anon_sym_override] = ACTIONS(3243),
    [anon_sym_partial] = ACTIONS(3243),
    [anon_sym_private] = ACTIONS(3243),
    [anon_sym_protected] = ACTIONS(3243),
    [anon_sym_public] = ACTIONS(3243),
    [anon_sym_readonly] = ACTIONS(3243),
    [anon_sym_required] = ACTIONS(3243),
    [anon_sym_sealed] = ACTIONS(3243),
    [anon_sym_virtual] = ACTIONS(3243),
    [anon_sym_volatile] = ACTIONS(3243),
    [anon_sym_where] = ACTIONS(3243),
    [anon_sym_notnull] = ACTIONS(3243),
    [anon_sym_unmanaged] = ACTIONS(3243),
    [anon_sym_checked] = ACTIONS(3243),
    [anon_sym_BANG] = ACTIONS(3245),
    [anon_sym_TILDE] = ACTIONS(3245),
    [anon_sym_PLUS_PLUS] = ACTIONS(3245),
    [anon_sym_DASH_DASH] = ACTIONS(3245),
    [anon_sym_true] = ACTIONS(3243),
    [anon_sym_false] = ACTIONS(3243),
    [anon_sym_PLUS] = ACTIONS(3243),
    [anon_sym_DASH] = ACTIONS(3243),
    [anon_sym_STAR] = ACTIONS(3245),
    [anon_sym_CARET] = ACTIONS(3245),
    [anon_sym_AMP] = ACTIONS(3245),
    [anon_sym_this] = ACTIONS(3243),
    [anon_sym_scoped] = ACTIONS(3243),
    [anon_sym_var] = ACTIONS(3243),
    [sym_predefined_type] = ACTIONS(3243),
    [anon_sym_break] = ACTIONS(3243),
    [anon_sym_unchecked] = ACTIONS(3243),
    [anon_sym_continue] = ACTIONS(3243),
    [anon_sym_do] = ACTIONS(3243),
    [anon_sym_while] = ACTIONS(3243),
    [anon_sym_for] = ACTIONS(3243),
    [anon_sym_lock] = ACTIONS(3243),
    [anon_sym_yield] = ACTIONS(3243),
    [anon_sym_switch] = ACTIONS(3243),
    [anon_sym_default] = ACTIONS(3243),
    [anon_sym_throw] = ACTIONS(3243),
    [anon_sym_try] = ACTIONS(3243),
    [anon_sym_when] = ACTIONS(3243),
    [anon_sym_await] = ACTIONS(3243),
    [anon_sym_foreach] = ACTIONS(3243),
    [anon_sym_goto] = ACTIONS(3243),
    [anon_sym_if] = ACTIONS(3243),
    [anon_sym_else] = ACTIONS(3243),
    [anon_sym_DOT_DOT] = ACTIONS(3245),
    [anon_sym_from] = ACTIONS(3243),
    [anon_sym_into] = ACTIONS(3243),
    [anon_sym_join] = ACTIONS(3243),
    [anon_sym_on] = ACTIONS(3243),
    [anon_sym_equals] = ACTIONS(3243),
    [anon_sym_let] = ACTIONS(3243),
    [anon_sym_orderby] = ACTIONS(3243),
    [anon_sym_ascending] = ACTIONS(3243),
    [anon_sym_descending] = ACTIONS(3243),
    [anon_sym_group] = ACTIONS(3243),
    [anon_sym_by] = ACTIONS(3243),
    [anon_sym_select] = ACTIONS(3243),
    [anon_sym_DQUOTE] = ACTIONS(3243),
    [anon_sym_stackalloc] = ACTIONS(3243),
    [anon_sym_sizeof] = ACTIONS(3243),
    [anon_sym_typeof] = ACTIONS(3243),
    [anon_sym___makeref] = ACTIONS(3243),
    [anon_sym___reftype] = ACTIONS(3243),
    [anon_sym___refvalue] = ACTIONS(3243),
    [sym_null_literal] = ACTIONS(3243),
    [anon_sym_SQUOTE] = ACTIONS(3245),
    [sym_integer_literal] = ACTIONS(3243),
    [sym_real_literal] = ACTIONS(3245),
    [sym_verbatim_string_literal] = ACTIONS(3245),
    [sym_raw_string_literal] = ACTIONS(3245),
    [aux_sym_preproc_if_token1] = ACTIONS(3245),
    [aux_sym_preproc_if_token3] = ACTIONS(3245),
    [aux_sym_preproc_else_token1] = ACTIONS(3245),
    [aux_sym_preproc_elif_token1] = ACTIONS(3245),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3245),
    [sym_interpolation_verbatim_start] = ACTIONS(3245),
    [sym_interpolation_raw_start] = ACTIONS(3245),
  },
  [2250] = {
    [sym_preproc_region] = STATE(2250),
    [sym_preproc_endregion] = STATE(2250),
    [sym_preproc_line] = STATE(2250),
    [sym_preproc_pragma] = STATE(2250),
    [sym_preproc_nullable] = STATE(2250),
    [sym_preproc_error] = STATE(2250),
    [sym_preproc_define] = STATE(2250),
    [sym_preproc_undef] = STATE(2250),
    [sym__identifier_token] = ACTIONS(3247),
    [anon_sym_extern] = ACTIONS(3247),
    [anon_sym_alias] = ACTIONS(3247),
    [anon_sym_SEMI] = ACTIONS(3249),
    [anon_sym_global] = ACTIONS(3247),
    [anon_sym_using] = ACTIONS(3247),
    [anon_sym_unsafe] = ACTIONS(3247),
    [anon_sym_static] = ACTIONS(3247),
    [anon_sym_LBRACK] = ACTIONS(3249),
    [anon_sym_LPAREN] = ACTIONS(3249),
    [anon_sym_return] = ACTIONS(3247),
    [anon_sym_namespace] = ACTIONS(3247),
    [anon_sym_class] = ACTIONS(3247),
    [anon_sym_ref] = ACTIONS(3247),
    [anon_sym_struct] = ACTIONS(3247),
    [anon_sym_enum] = ACTIONS(3247),
    [anon_sym_LBRACE] = ACTIONS(3249),
    [anon_sym_interface] = ACTIONS(3247),
    [anon_sym_delegate] = ACTIONS(3247),
    [anon_sym_record] = ACTIONS(3247),
    [anon_sym_abstract] = ACTIONS(3247),
    [anon_sym_async] = ACTIONS(3247),
    [anon_sym_const] = ACTIONS(3247),
    [anon_sym_file] = ACTIONS(3247),
    [anon_sym_fixed] = ACTIONS(3247),
    [anon_sym_internal] = ACTIONS(3247),
    [anon_sym_new] = ACTIONS(3247),
    [anon_sym_override] = ACTIONS(3247),
    [anon_sym_partial] = ACTIONS(3247),
    [anon_sym_private] = ACTIONS(3247),
    [anon_sym_protected] = ACTIONS(3247),
    [anon_sym_public] = ACTIONS(3247),
    [anon_sym_readonly] = ACTIONS(3247),
    [anon_sym_required] = ACTIONS(3247),
    [anon_sym_sealed] = ACTIONS(3247),
    [anon_sym_virtual] = ACTIONS(3247),
    [anon_sym_volatile] = ACTIONS(3247),
    [anon_sym_where] = ACTIONS(3247),
    [anon_sym_notnull] = ACTIONS(3247),
    [anon_sym_unmanaged] = ACTIONS(3247),
    [anon_sym_checked] = ACTIONS(3247),
    [anon_sym_BANG] = ACTIONS(3249),
    [anon_sym_TILDE] = ACTIONS(3249),
    [anon_sym_PLUS_PLUS] = ACTIONS(3249),
    [anon_sym_DASH_DASH] = ACTIONS(3249),
    [anon_sym_true] = ACTIONS(3247),
    [anon_sym_false] = ACTIONS(3247),
    [anon_sym_PLUS] = ACTIONS(3247),
    [anon_sym_DASH] = ACTIONS(3247),
    [anon_sym_STAR] = ACTIONS(3249),
    [anon_sym_CARET] = ACTIONS(3249),
    [anon_sym_AMP] = ACTIONS(3249),
    [anon_sym_this] = ACTIONS(3247),
    [anon_sym_scoped] = ACTIONS(3247),
    [anon_sym_var] = ACTIONS(3247),
    [sym_predefined_type] = ACTIONS(3247),
    [anon_sym_break] = ACTIONS(3247),
    [anon_sym_unchecked] = ACTIONS(3247),
    [anon_sym_continue] = ACTIONS(3247),
    [anon_sym_do] = ACTIONS(3247),
    [anon_sym_while] = ACTIONS(3247),
    [anon_sym_for] = ACTIONS(3247),
    [anon_sym_lock] = ACTIONS(3247),
    [anon_sym_yield] = ACTIONS(3247),
    [anon_sym_switch] = ACTIONS(3247),
    [anon_sym_default] = ACTIONS(3247),
    [anon_sym_throw] = ACTIONS(3247),
    [anon_sym_try] = ACTIONS(3247),
    [anon_sym_when] = ACTIONS(3247),
    [anon_sym_await] = ACTIONS(3247),
    [anon_sym_foreach] = ACTIONS(3247),
    [anon_sym_goto] = ACTIONS(3247),
    [anon_sym_if] = ACTIONS(3247),
    [anon_sym_else] = ACTIONS(3247),
    [anon_sym_DOT_DOT] = ACTIONS(3249),
    [anon_sym_from] = ACTIONS(3247),
    [anon_sym_into] = ACTIONS(3247),
    [anon_sym_join] = ACTIONS(3247),
    [anon_sym_on] = ACTIONS(3247),
    [anon_sym_equals] = ACTIONS(3247),
    [anon_sym_let] = ACTIONS(3247),
    [anon_sym_orderby] = ACTIONS(3247),
    [anon_sym_ascending] = ACTIONS(3247),
    [anon_sym_descending] = ACTIONS(3247),
    [anon_sym_group] = ACTIONS(3247),
    [anon_sym_by] = ACTIONS(3247),
    [anon_sym_select] = ACTIONS(3247),
    [anon_sym_DQUOTE] = ACTIONS(3247),
    [anon_sym_stackalloc] = ACTIONS(3247),
    [anon_sym_sizeof] = ACTIONS(3247),
    [anon_sym_typeof] = ACTIONS(3247),
    [anon_sym___makeref] = ACTIONS(3247),
    [anon_sym___reftype] = ACTIONS(3247),
    [anon_sym___refvalue] = ACTIONS(3247),
    [sym_null_literal] = ACTIONS(3247),
    [anon_sym_SQUOTE] = ACTIONS(3249),
    [sym_integer_literal] = ACTIONS(3247),
    [sym_real_literal] = ACTIONS(3249),
    [sym_verbatim_string_literal] = ACTIONS(3249),
    [sym_raw_string_literal] = ACTIONS(3249),
    [aux_sym_preproc_if_token1] = ACTIONS(3249),
    [aux_sym_preproc_if_token3] = ACTIONS(3249),
    [aux_sym_preproc_else_token1] = ACTIONS(3249),
    [aux_sym_preproc_elif_token1] = ACTIONS(3249),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3249),
    [sym_interpolation_verbatim_start] = ACTIONS(3249),
    [sym_interpolation_raw_start] = ACTIONS(3249),
  },
  [2251] = {
    [sym_preproc_region] = STATE(2251),
    [sym_preproc_endregion] = STATE(2251),
    [sym_preproc_line] = STATE(2251),
    [sym_preproc_pragma] = STATE(2251),
    [sym_preproc_nullable] = STATE(2251),
    [sym_preproc_error] = STATE(2251),
    [sym_preproc_define] = STATE(2251),
    [sym_preproc_undef] = STATE(2251),
    [sym__identifier_token] = ACTIONS(3251),
    [anon_sym_extern] = ACTIONS(3251),
    [anon_sym_alias] = ACTIONS(3251),
    [anon_sym_SEMI] = ACTIONS(3253),
    [anon_sym_global] = ACTIONS(3251),
    [anon_sym_using] = ACTIONS(3251),
    [anon_sym_unsafe] = ACTIONS(3251),
    [anon_sym_static] = ACTIONS(3251),
    [anon_sym_LBRACK] = ACTIONS(3253),
    [anon_sym_LPAREN] = ACTIONS(3253),
    [anon_sym_return] = ACTIONS(3251),
    [anon_sym_namespace] = ACTIONS(3251),
    [anon_sym_class] = ACTIONS(3251),
    [anon_sym_ref] = ACTIONS(3251),
    [anon_sym_struct] = ACTIONS(3251),
    [anon_sym_enum] = ACTIONS(3251),
    [anon_sym_LBRACE] = ACTIONS(3253),
    [anon_sym_interface] = ACTIONS(3251),
    [anon_sym_delegate] = ACTIONS(3251),
    [anon_sym_record] = ACTIONS(3251),
    [anon_sym_abstract] = ACTIONS(3251),
    [anon_sym_async] = ACTIONS(3251),
    [anon_sym_const] = ACTIONS(3251),
    [anon_sym_file] = ACTIONS(3251),
    [anon_sym_fixed] = ACTIONS(3251),
    [anon_sym_internal] = ACTIONS(3251),
    [anon_sym_new] = ACTIONS(3251),
    [anon_sym_override] = ACTIONS(3251),
    [anon_sym_partial] = ACTIONS(3251),
    [anon_sym_private] = ACTIONS(3251),
    [anon_sym_protected] = ACTIONS(3251),
    [anon_sym_public] = ACTIONS(3251),
    [anon_sym_readonly] = ACTIONS(3251),
    [anon_sym_required] = ACTIONS(3251),
    [anon_sym_sealed] = ACTIONS(3251),
    [anon_sym_virtual] = ACTIONS(3251),
    [anon_sym_volatile] = ACTIONS(3251),
    [anon_sym_where] = ACTIONS(3251),
    [anon_sym_notnull] = ACTIONS(3251),
    [anon_sym_unmanaged] = ACTIONS(3251),
    [anon_sym_checked] = ACTIONS(3251),
    [anon_sym_BANG] = ACTIONS(3253),
    [anon_sym_TILDE] = ACTIONS(3253),
    [anon_sym_PLUS_PLUS] = ACTIONS(3253),
    [anon_sym_DASH_DASH] = ACTIONS(3253),
    [anon_sym_true] = ACTIONS(3251),
    [anon_sym_false] = ACTIONS(3251),
    [anon_sym_PLUS] = ACTIONS(3251),
    [anon_sym_DASH] = ACTIONS(3251),
    [anon_sym_STAR] = ACTIONS(3253),
    [anon_sym_CARET] = ACTIONS(3253),
    [anon_sym_AMP] = ACTIONS(3253),
    [anon_sym_this] = ACTIONS(3251),
    [anon_sym_scoped] = ACTIONS(3251),
    [anon_sym_var] = ACTIONS(3251),
    [sym_predefined_type] = ACTIONS(3251),
    [anon_sym_break] = ACTIONS(3251),
    [anon_sym_unchecked] = ACTIONS(3251),
    [anon_sym_continue] = ACTIONS(3251),
    [anon_sym_do] = ACTIONS(3251),
    [anon_sym_while] = ACTIONS(3251),
    [anon_sym_for] = ACTIONS(3251),
    [anon_sym_lock] = ACTIONS(3251),
    [anon_sym_yield] = ACTIONS(3251),
    [anon_sym_switch] = ACTIONS(3251),
    [anon_sym_default] = ACTIONS(3251),
    [anon_sym_throw] = ACTIONS(3251),
    [anon_sym_try] = ACTIONS(3251),
    [anon_sym_when] = ACTIONS(3251),
    [anon_sym_await] = ACTIONS(3251),
    [anon_sym_foreach] = ACTIONS(3251),
    [anon_sym_goto] = ACTIONS(3251),
    [anon_sym_if] = ACTIONS(3251),
    [anon_sym_else] = ACTIONS(3251),
    [anon_sym_DOT_DOT] = ACTIONS(3253),
    [anon_sym_from] = ACTIONS(3251),
    [anon_sym_into] = ACTIONS(3251),
    [anon_sym_join] = ACTIONS(3251),
    [anon_sym_on] = ACTIONS(3251),
    [anon_sym_equals] = ACTIONS(3251),
    [anon_sym_let] = ACTIONS(3251),
    [anon_sym_orderby] = ACTIONS(3251),
    [anon_sym_ascending] = ACTIONS(3251),
    [anon_sym_descending] = ACTIONS(3251),
    [anon_sym_group] = ACTIONS(3251),
    [anon_sym_by] = ACTIONS(3251),
    [anon_sym_select] = ACTIONS(3251),
    [anon_sym_DQUOTE] = ACTIONS(3251),
    [anon_sym_stackalloc] = ACTIONS(3251),
    [anon_sym_sizeof] = ACTIONS(3251),
    [anon_sym_typeof] = ACTIONS(3251),
    [anon_sym___makeref] = ACTIONS(3251),
    [anon_sym___reftype] = ACTIONS(3251),
    [anon_sym___refvalue] = ACTIONS(3251),
    [sym_null_literal] = ACTIONS(3251),
    [anon_sym_SQUOTE] = ACTIONS(3253),
    [sym_integer_literal] = ACTIONS(3251),
    [sym_real_literal] = ACTIONS(3253),
    [sym_verbatim_string_literal] = ACTIONS(3253),
    [sym_raw_string_literal] = ACTIONS(3253),
    [aux_sym_preproc_if_token1] = ACTIONS(3253),
    [aux_sym_preproc_if_token3] = ACTIONS(3253),
    [aux_sym_preproc_else_token1] = ACTIONS(3253),
    [aux_sym_preproc_elif_token1] = ACTIONS(3253),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3253),
    [sym_interpolation_verbatim_start] = ACTIONS(3253),
    [sym_interpolation_raw_start] = ACTIONS(3253),
  },
  [2252] = {
    [sym_preproc_region] = STATE(2252),
    [sym_preproc_endregion] = STATE(2252),
    [sym_preproc_line] = STATE(2252),
    [sym_preproc_pragma] = STATE(2252),
    [sym_preproc_nullable] = STATE(2252),
    [sym_preproc_error] = STATE(2252),
    [sym_preproc_define] = STATE(2252),
    [sym_preproc_undef] = STATE(2252),
    [sym__identifier_token] = ACTIONS(3255),
    [anon_sym_extern] = ACTIONS(3255),
    [anon_sym_alias] = ACTIONS(3255),
    [anon_sym_SEMI] = ACTIONS(3257),
    [anon_sym_global] = ACTIONS(3255),
    [anon_sym_using] = ACTIONS(3255),
    [anon_sym_unsafe] = ACTIONS(3255),
    [anon_sym_static] = ACTIONS(3255),
    [anon_sym_LBRACK] = ACTIONS(3257),
    [anon_sym_LPAREN] = ACTIONS(3257),
    [anon_sym_return] = ACTIONS(3255),
    [anon_sym_namespace] = ACTIONS(3255),
    [anon_sym_class] = ACTIONS(3255),
    [anon_sym_ref] = ACTIONS(3255),
    [anon_sym_struct] = ACTIONS(3255),
    [anon_sym_enum] = ACTIONS(3255),
    [anon_sym_LBRACE] = ACTIONS(3257),
    [anon_sym_interface] = ACTIONS(3255),
    [anon_sym_delegate] = ACTIONS(3255),
    [anon_sym_record] = ACTIONS(3255),
    [anon_sym_abstract] = ACTIONS(3255),
    [anon_sym_async] = ACTIONS(3255),
    [anon_sym_const] = ACTIONS(3255),
    [anon_sym_file] = ACTIONS(3255),
    [anon_sym_fixed] = ACTIONS(3255),
    [anon_sym_internal] = ACTIONS(3255),
    [anon_sym_new] = ACTIONS(3255),
    [anon_sym_override] = ACTIONS(3255),
    [anon_sym_partial] = ACTIONS(3255),
    [anon_sym_private] = ACTIONS(3255),
    [anon_sym_protected] = ACTIONS(3255),
    [anon_sym_public] = ACTIONS(3255),
    [anon_sym_readonly] = ACTIONS(3255),
    [anon_sym_required] = ACTIONS(3255),
    [anon_sym_sealed] = ACTIONS(3255),
    [anon_sym_virtual] = ACTIONS(3255),
    [anon_sym_volatile] = ACTIONS(3255),
    [anon_sym_where] = ACTIONS(3255),
    [anon_sym_notnull] = ACTIONS(3255),
    [anon_sym_unmanaged] = ACTIONS(3255),
    [anon_sym_checked] = ACTIONS(3255),
    [anon_sym_BANG] = ACTIONS(3257),
    [anon_sym_TILDE] = ACTIONS(3257),
    [anon_sym_PLUS_PLUS] = ACTIONS(3257),
    [anon_sym_DASH_DASH] = ACTIONS(3257),
    [anon_sym_true] = ACTIONS(3255),
    [anon_sym_false] = ACTIONS(3255),
    [anon_sym_PLUS] = ACTIONS(3255),
    [anon_sym_DASH] = ACTIONS(3255),
    [anon_sym_STAR] = ACTIONS(3257),
    [anon_sym_CARET] = ACTIONS(3257),
    [anon_sym_AMP] = ACTIONS(3257),
    [anon_sym_this] = ACTIONS(3255),
    [anon_sym_scoped] = ACTIONS(3255),
    [anon_sym_var] = ACTIONS(3255),
    [sym_predefined_type] = ACTIONS(3255),
    [anon_sym_break] = ACTIONS(3255),
    [anon_sym_unchecked] = ACTIONS(3255),
    [anon_sym_continue] = ACTIONS(3255),
    [anon_sym_do] = ACTIONS(3255),
    [anon_sym_while] = ACTIONS(3255),
    [anon_sym_for] = ACTIONS(3255),
    [anon_sym_lock] = ACTIONS(3255),
    [anon_sym_yield] = ACTIONS(3255),
    [anon_sym_switch] = ACTIONS(3255),
    [anon_sym_default] = ACTIONS(3255),
    [anon_sym_throw] = ACTIONS(3255),
    [anon_sym_try] = ACTIONS(3255),
    [anon_sym_when] = ACTIONS(3255),
    [anon_sym_await] = ACTIONS(3255),
    [anon_sym_foreach] = ACTIONS(3255),
    [anon_sym_goto] = ACTIONS(3255),
    [anon_sym_if] = ACTIONS(3255),
    [anon_sym_else] = ACTIONS(3255),
    [anon_sym_DOT_DOT] = ACTIONS(3257),
    [anon_sym_from] = ACTIONS(3255),
    [anon_sym_into] = ACTIONS(3255),
    [anon_sym_join] = ACTIONS(3255),
    [anon_sym_on] = ACTIONS(3255),
    [anon_sym_equals] = ACTIONS(3255),
    [anon_sym_let] = ACTIONS(3255),
    [anon_sym_orderby] = ACTIONS(3255),
    [anon_sym_ascending] = ACTIONS(3255),
    [anon_sym_descending] = ACTIONS(3255),
    [anon_sym_group] = ACTIONS(3255),
    [anon_sym_by] = ACTIONS(3255),
    [anon_sym_select] = ACTIONS(3255),
    [anon_sym_DQUOTE] = ACTIONS(3255),
    [anon_sym_stackalloc] = ACTIONS(3255),
    [anon_sym_sizeof] = ACTIONS(3255),
    [anon_sym_typeof] = ACTIONS(3255),
    [anon_sym___makeref] = ACTIONS(3255),
    [anon_sym___reftype] = ACTIONS(3255),
    [anon_sym___refvalue] = ACTIONS(3255),
    [sym_null_literal] = ACTIONS(3255),
    [anon_sym_SQUOTE] = ACTIONS(3257),
    [sym_integer_literal] = ACTIONS(3255),
    [sym_real_literal] = ACTIONS(3257),
    [sym_verbatim_string_literal] = ACTIONS(3257),
    [sym_raw_string_literal] = ACTIONS(3257),
    [aux_sym_preproc_if_token1] = ACTIONS(3257),
    [aux_sym_preproc_if_token3] = ACTIONS(3257),
    [aux_sym_preproc_else_token1] = ACTIONS(3257),
    [aux_sym_preproc_elif_token1] = ACTIONS(3257),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3257),
    [sym_interpolation_verbatim_start] = ACTIONS(3257),
    [sym_interpolation_raw_start] = ACTIONS(3257),
  },
  [2253] = {
    [sym_preproc_region] = STATE(2253),
    [sym_preproc_endregion] = STATE(2253),
    [sym_preproc_line] = STATE(2253),
    [sym_preproc_pragma] = STATE(2253),
    [sym_preproc_nullable] = STATE(2253),
    [sym_preproc_error] = STATE(2253),
    [sym_preproc_define] = STATE(2253),
    [sym_preproc_undef] = STATE(2253),
    [sym__identifier_token] = ACTIONS(3259),
    [anon_sym_extern] = ACTIONS(3259),
    [anon_sym_alias] = ACTIONS(3259),
    [anon_sym_SEMI] = ACTIONS(3261),
    [anon_sym_global] = ACTIONS(3259),
    [anon_sym_using] = ACTIONS(3259),
    [anon_sym_unsafe] = ACTIONS(3259),
    [anon_sym_static] = ACTIONS(3259),
    [anon_sym_LBRACK] = ACTIONS(3261),
    [anon_sym_LPAREN] = ACTIONS(3261),
    [anon_sym_return] = ACTIONS(3259),
    [anon_sym_namespace] = ACTIONS(3259),
    [anon_sym_class] = ACTIONS(3259),
    [anon_sym_ref] = ACTIONS(3259),
    [anon_sym_struct] = ACTIONS(3259),
    [anon_sym_enum] = ACTIONS(3259),
    [anon_sym_LBRACE] = ACTIONS(3261),
    [anon_sym_interface] = ACTIONS(3259),
    [anon_sym_delegate] = ACTIONS(3259),
    [anon_sym_record] = ACTIONS(3259),
    [anon_sym_abstract] = ACTIONS(3259),
    [anon_sym_async] = ACTIONS(3259),
    [anon_sym_const] = ACTIONS(3259),
    [anon_sym_file] = ACTIONS(3259),
    [anon_sym_fixed] = ACTIONS(3259),
    [anon_sym_internal] = ACTIONS(3259),
    [anon_sym_new] = ACTIONS(3259),
    [anon_sym_override] = ACTIONS(3259),
    [anon_sym_partial] = ACTIONS(3259),
    [anon_sym_private] = ACTIONS(3259),
    [anon_sym_protected] = ACTIONS(3259),
    [anon_sym_public] = ACTIONS(3259),
    [anon_sym_readonly] = ACTIONS(3259),
    [anon_sym_required] = ACTIONS(3259),
    [anon_sym_sealed] = ACTIONS(3259),
    [anon_sym_virtual] = ACTIONS(3259),
    [anon_sym_volatile] = ACTIONS(3259),
    [anon_sym_where] = ACTIONS(3259),
    [anon_sym_notnull] = ACTIONS(3259),
    [anon_sym_unmanaged] = ACTIONS(3259),
    [anon_sym_checked] = ACTIONS(3259),
    [anon_sym_BANG] = ACTIONS(3261),
    [anon_sym_TILDE] = ACTIONS(3261),
    [anon_sym_PLUS_PLUS] = ACTIONS(3261),
    [anon_sym_DASH_DASH] = ACTIONS(3261),
    [anon_sym_true] = ACTIONS(3259),
    [anon_sym_false] = ACTIONS(3259),
    [anon_sym_PLUS] = ACTIONS(3259),
    [anon_sym_DASH] = ACTIONS(3259),
    [anon_sym_STAR] = ACTIONS(3261),
    [anon_sym_CARET] = ACTIONS(3261),
    [anon_sym_AMP] = ACTIONS(3261),
    [anon_sym_this] = ACTIONS(3259),
    [anon_sym_scoped] = ACTIONS(3259),
    [anon_sym_var] = ACTIONS(3259),
    [sym_predefined_type] = ACTIONS(3259),
    [anon_sym_break] = ACTIONS(3259),
    [anon_sym_unchecked] = ACTIONS(3259),
    [anon_sym_continue] = ACTIONS(3259),
    [anon_sym_do] = ACTIONS(3259),
    [anon_sym_while] = ACTIONS(3259),
    [anon_sym_for] = ACTIONS(3259),
    [anon_sym_lock] = ACTIONS(3259),
    [anon_sym_yield] = ACTIONS(3259),
    [anon_sym_switch] = ACTIONS(3259),
    [anon_sym_default] = ACTIONS(3259),
    [anon_sym_throw] = ACTIONS(3259),
    [anon_sym_try] = ACTIONS(3259),
    [anon_sym_when] = ACTIONS(3259),
    [anon_sym_await] = ACTIONS(3259),
    [anon_sym_foreach] = ACTIONS(3259),
    [anon_sym_goto] = ACTIONS(3259),
    [anon_sym_if] = ACTIONS(3259),
    [anon_sym_else] = ACTIONS(3259),
    [anon_sym_DOT_DOT] = ACTIONS(3261),
    [anon_sym_from] = ACTIONS(3259),
    [anon_sym_into] = ACTIONS(3259),
    [anon_sym_join] = ACTIONS(3259),
    [anon_sym_on] = ACTIONS(3259),
    [anon_sym_equals] = ACTIONS(3259),
    [anon_sym_let] = ACTIONS(3259),
    [anon_sym_orderby] = ACTIONS(3259),
    [anon_sym_ascending] = ACTIONS(3259),
    [anon_sym_descending] = ACTIONS(3259),
    [anon_sym_group] = ACTIONS(3259),
    [anon_sym_by] = ACTIONS(3259),
    [anon_sym_select] = ACTIONS(3259),
    [anon_sym_DQUOTE] = ACTIONS(3259),
    [anon_sym_stackalloc] = ACTIONS(3259),
    [anon_sym_sizeof] = ACTIONS(3259),
    [anon_sym_typeof] = ACTIONS(3259),
    [anon_sym___makeref] = ACTIONS(3259),
    [anon_sym___reftype] = ACTIONS(3259),
    [anon_sym___refvalue] = ACTIONS(3259),
    [sym_null_literal] = ACTIONS(3259),
    [anon_sym_SQUOTE] = ACTIONS(3261),
    [sym_integer_literal] = ACTIONS(3259),
    [sym_real_literal] = ACTIONS(3261),
    [sym_verbatim_string_literal] = ACTIONS(3261),
    [sym_raw_string_literal] = ACTIONS(3261),
    [aux_sym_preproc_if_token1] = ACTIONS(3261),
    [aux_sym_preproc_if_token3] = ACTIONS(3261),
    [aux_sym_preproc_else_token1] = ACTIONS(3261),
    [aux_sym_preproc_elif_token1] = ACTIONS(3261),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3261),
    [sym_interpolation_verbatim_start] = ACTIONS(3261),
    [sym_interpolation_raw_start] = ACTIONS(3261),
  },
  [2254] = {
    [sym_preproc_region] = STATE(2254),
    [sym_preproc_endregion] = STATE(2254),
    [sym_preproc_line] = STATE(2254),
    [sym_preproc_pragma] = STATE(2254),
    [sym_preproc_nullable] = STATE(2254),
    [sym_preproc_error] = STATE(2254),
    [sym_preproc_define] = STATE(2254),
    [sym_preproc_undef] = STATE(2254),
    [sym__identifier_token] = ACTIONS(3263),
    [anon_sym_extern] = ACTIONS(3263),
    [anon_sym_alias] = ACTIONS(3263),
    [anon_sym_SEMI] = ACTIONS(3265),
    [anon_sym_global] = ACTIONS(3263),
    [anon_sym_using] = ACTIONS(3263),
    [anon_sym_unsafe] = ACTIONS(3263),
    [anon_sym_static] = ACTIONS(3263),
    [anon_sym_LBRACK] = ACTIONS(3265),
    [anon_sym_LPAREN] = ACTIONS(3265),
    [anon_sym_return] = ACTIONS(3263),
    [anon_sym_namespace] = ACTIONS(3263),
    [anon_sym_class] = ACTIONS(3263),
    [anon_sym_ref] = ACTIONS(3263),
    [anon_sym_struct] = ACTIONS(3263),
    [anon_sym_enum] = ACTIONS(3263),
    [anon_sym_LBRACE] = ACTIONS(3265),
    [anon_sym_interface] = ACTIONS(3263),
    [anon_sym_delegate] = ACTIONS(3263),
    [anon_sym_record] = ACTIONS(3263),
    [anon_sym_abstract] = ACTIONS(3263),
    [anon_sym_async] = ACTIONS(3263),
    [anon_sym_const] = ACTIONS(3263),
    [anon_sym_file] = ACTIONS(3263),
    [anon_sym_fixed] = ACTIONS(3263),
    [anon_sym_internal] = ACTIONS(3263),
    [anon_sym_new] = ACTIONS(3263),
    [anon_sym_override] = ACTIONS(3263),
    [anon_sym_partial] = ACTIONS(3263),
    [anon_sym_private] = ACTIONS(3263),
    [anon_sym_protected] = ACTIONS(3263),
    [anon_sym_public] = ACTIONS(3263),
    [anon_sym_readonly] = ACTIONS(3263),
    [anon_sym_required] = ACTIONS(3263),
    [anon_sym_sealed] = ACTIONS(3263),
    [anon_sym_virtual] = ACTIONS(3263),
    [anon_sym_volatile] = ACTIONS(3263),
    [anon_sym_where] = ACTIONS(3263),
    [anon_sym_notnull] = ACTIONS(3263),
    [anon_sym_unmanaged] = ACTIONS(3263),
    [anon_sym_checked] = ACTIONS(3263),
    [anon_sym_BANG] = ACTIONS(3265),
    [anon_sym_TILDE] = ACTIONS(3265),
    [anon_sym_PLUS_PLUS] = ACTIONS(3265),
    [anon_sym_DASH_DASH] = ACTIONS(3265),
    [anon_sym_true] = ACTIONS(3263),
    [anon_sym_false] = ACTIONS(3263),
    [anon_sym_PLUS] = ACTIONS(3263),
    [anon_sym_DASH] = ACTIONS(3263),
    [anon_sym_STAR] = ACTIONS(3265),
    [anon_sym_CARET] = ACTIONS(3265),
    [anon_sym_AMP] = ACTIONS(3265),
    [anon_sym_this] = ACTIONS(3263),
    [anon_sym_scoped] = ACTIONS(3263),
    [anon_sym_var] = ACTIONS(3263),
    [sym_predefined_type] = ACTIONS(3263),
    [anon_sym_break] = ACTIONS(3263),
    [anon_sym_unchecked] = ACTIONS(3263),
    [anon_sym_continue] = ACTIONS(3263),
    [anon_sym_do] = ACTIONS(3263),
    [anon_sym_while] = ACTIONS(3263),
    [anon_sym_for] = ACTIONS(3263),
    [anon_sym_lock] = ACTIONS(3263),
    [anon_sym_yield] = ACTIONS(3263),
    [anon_sym_switch] = ACTIONS(3263),
    [anon_sym_default] = ACTIONS(3263),
    [anon_sym_throw] = ACTIONS(3263),
    [anon_sym_try] = ACTIONS(3263),
    [anon_sym_when] = ACTIONS(3263),
    [anon_sym_await] = ACTIONS(3263),
    [anon_sym_foreach] = ACTIONS(3263),
    [anon_sym_goto] = ACTIONS(3263),
    [anon_sym_if] = ACTIONS(3263),
    [anon_sym_else] = ACTIONS(3263),
    [anon_sym_DOT_DOT] = ACTIONS(3265),
    [anon_sym_from] = ACTIONS(3263),
    [anon_sym_into] = ACTIONS(3263),
    [anon_sym_join] = ACTIONS(3263),
    [anon_sym_on] = ACTIONS(3263),
    [anon_sym_equals] = ACTIONS(3263),
    [anon_sym_let] = ACTIONS(3263),
    [anon_sym_orderby] = ACTIONS(3263),
    [anon_sym_ascending] = ACTIONS(3263),
    [anon_sym_descending] = ACTIONS(3263),
    [anon_sym_group] = ACTIONS(3263),
    [anon_sym_by] = ACTIONS(3263),
    [anon_sym_select] = ACTIONS(3263),
    [anon_sym_DQUOTE] = ACTIONS(3263),
    [anon_sym_stackalloc] = ACTIONS(3263),
    [anon_sym_sizeof] = ACTIONS(3263),
    [anon_sym_typeof] = ACTIONS(3263),
    [anon_sym___makeref] = ACTIONS(3263),
    [anon_sym___reftype] = ACTIONS(3263),
    [anon_sym___refvalue] = ACTIONS(3263),
    [sym_null_literal] = ACTIONS(3263),
    [anon_sym_SQUOTE] = ACTIONS(3265),
    [sym_integer_literal] = ACTIONS(3263),
    [sym_real_literal] = ACTIONS(3265),
    [sym_verbatim_string_literal] = ACTIONS(3265),
    [sym_raw_string_literal] = ACTIONS(3265),
    [aux_sym_preproc_if_token1] = ACTIONS(3265),
    [aux_sym_preproc_if_token3] = ACTIONS(3265),
    [aux_sym_preproc_else_token1] = ACTIONS(3265),
    [aux_sym_preproc_elif_token1] = ACTIONS(3265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3265),
    [sym_interpolation_verbatim_start] = ACTIONS(3265),
    [sym_interpolation_raw_start] = ACTIONS(3265),
  },
  [2255] = {
    [sym_preproc_region] = STATE(2255),
    [sym_preproc_endregion] = STATE(2255),
    [sym_preproc_line] = STATE(2255),
    [sym_preproc_pragma] = STATE(2255),
    [sym_preproc_nullable] = STATE(2255),
    [sym_preproc_error] = STATE(2255),
    [sym_preproc_define] = STATE(2255),
    [sym_preproc_undef] = STATE(2255),
    [sym__identifier_token] = ACTIONS(3267),
    [anon_sym_extern] = ACTIONS(3267),
    [anon_sym_alias] = ACTIONS(3267),
    [anon_sym_SEMI] = ACTIONS(3269),
    [anon_sym_global] = ACTIONS(3267),
    [anon_sym_using] = ACTIONS(3267),
    [anon_sym_unsafe] = ACTIONS(3267),
    [anon_sym_static] = ACTIONS(3267),
    [anon_sym_LBRACK] = ACTIONS(3269),
    [anon_sym_LPAREN] = ACTIONS(3269),
    [anon_sym_return] = ACTIONS(3267),
    [anon_sym_namespace] = ACTIONS(3267),
    [anon_sym_class] = ACTIONS(3267),
    [anon_sym_ref] = ACTIONS(3267),
    [anon_sym_struct] = ACTIONS(3267),
    [anon_sym_enum] = ACTIONS(3267),
    [anon_sym_LBRACE] = ACTIONS(3269),
    [anon_sym_interface] = ACTIONS(3267),
    [anon_sym_delegate] = ACTIONS(3267),
    [anon_sym_record] = ACTIONS(3267),
    [anon_sym_abstract] = ACTIONS(3267),
    [anon_sym_async] = ACTIONS(3267),
    [anon_sym_const] = ACTIONS(3267),
    [anon_sym_file] = ACTIONS(3267),
    [anon_sym_fixed] = ACTIONS(3267),
    [anon_sym_internal] = ACTIONS(3267),
    [anon_sym_new] = ACTIONS(3267),
    [anon_sym_override] = ACTIONS(3267),
    [anon_sym_partial] = ACTIONS(3267),
    [anon_sym_private] = ACTIONS(3267),
    [anon_sym_protected] = ACTIONS(3267),
    [anon_sym_public] = ACTIONS(3267),
    [anon_sym_readonly] = ACTIONS(3267),
    [anon_sym_required] = ACTIONS(3267),
    [anon_sym_sealed] = ACTIONS(3267),
    [anon_sym_virtual] = ACTIONS(3267),
    [anon_sym_volatile] = ACTIONS(3267),
    [anon_sym_where] = ACTIONS(3267),
    [anon_sym_notnull] = ACTIONS(3267),
    [anon_sym_unmanaged] = ACTIONS(3267),
    [anon_sym_checked] = ACTIONS(3267),
    [anon_sym_BANG] = ACTIONS(3269),
    [anon_sym_TILDE] = ACTIONS(3269),
    [anon_sym_PLUS_PLUS] = ACTIONS(3269),
    [anon_sym_DASH_DASH] = ACTIONS(3269),
    [anon_sym_true] = ACTIONS(3267),
    [anon_sym_false] = ACTIONS(3267),
    [anon_sym_PLUS] = ACTIONS(3267),
    [anon_sym_DASH] = ACTIONS(3267),
    [anon_sym_STAR] = ACTIONS(3269),
    [anon_sym_CARET] = ACTIONS(3269),
    [anon_sym_AMP] = ACTIONS(3269),
    [anon_sym_this] = ACTIONS(3267),
    [anon_sym_scoped] = ACTIONS(3267),
    [anon_sym_var] = ACTIONS(3267),
    [sym_predefined_type] = ACTIONS(3267),
    [anon_sym_break] = ACTIONS(3267),
    [anon_sym_unchecked] = ACTIONS(3267),
    [anon_sym_continue] = ACTIONS(3267),
    [anon_sym_do] = ACTIONS(3267),
    [anon_sym_while] = ACTIONS(3267),
    [anon_sym_for] = ACTIONS(3267),
    [anon_sym_lock] = ACTIONS(3267),
    [anon_sym_yield] = ACTIONS(3267),
    [anon_sym_switch] = ACTIONS(3267),
    [anon_sym_default] = ACTIONS(3267),
    [anon_sym_throw] = ACTIONS(3267),
    [anon_sym_try] = ACTIONS(3267),
    [anon_sym_when] = ACTIONS(3267),
    [anon_sym_await] = ACTIONS(3267),
    [anon_sym_foreach] = ACTIONS(3267),
    [anon_sym_goto] = ACTIONS(3267),
    [anon_sym_if] = ACTIONS(3267),
    [anon_sym_else] = ACTIONS(3267),
    [anon_sym_DOT_DOT] = ACTIONS(3269),
    [anon_sym_from] = ACTIONS(3267),
    [anon_sym_into] = ACTIONS(3267),
    [anon_sym_join] = ACTIONS(3267),
    [anon_sym_on] = ACTIONS(3267),
    [anon_sym_equals] = ACTIONS(3267),
    [anon_sym_let] = ACTIONS(3267),
    [anon_sym_orderby] = ACTIONS(3267),
    [anon_sym_ascending] = ACTIONS(3267),
    [anon_sym_descending] = ACTIONS(3267),
    [anon_sym_group] = ACTIONS(3267),
    [anon_sym_by] = ACTIONS(3267),
    [anon_sym_select] = ACTIONS(3267),
    [anon_sym_DQUOTE] = ACTIONS(3267),
    [anon_sym_stackalloc] = ACTIONS(3267),
    [anon_sym_sizeof] = ACTIONS(3267),
    [anon_sym_typeof] = ACTIONS(3267),
    [anon_sym___makeref] = ACTIONS(3267),
    [anon_sym___reftype] = ACTIONS(3267),
    [anon_sym___refvalue] = ACTIONS(3267),
    [sym_null_literal] = ACTIONS(3267),
    [anon_sym_SQUOTE] = ACTIONS(3269),
    [sym_integer_literal] = ACTIONS(3267),
    [sym_real_literal] = ACTIONS(3269),
    [sym_verbatim_string_literal] = ACTIONS(3269),
    [sym_raw_string_literal] = ACTIONS(3269),
    [aux_sym_preproc_if_token1] = ACTIONS(3269),
    [aux_sym_preproc_if_token3] = ACTIONS(3269),
    [aux_sym_preproc_else_token1] = ACTIONS(3269),
    [aux_sym_preproc_elif_token1] = ACTIONS(3269),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3269),
    [sym_interpolation_verbatim_start] = ACTIONS(3269),
    [sym_interpolation_raw_start] = ACTIONS(3269),
  },
  [2256] = {
    [sym_preproc_region] = STATE(2256),
    [sym_preproc_endregion] = STATE(2256),
    [sym_preproc_line] = STATE(2256),
    [sym_preproc_pragma] = STATE(2256),
    [sym_preproc_nullable] = STATE(2256),
    [sym_preproc_error] = STATE(2256),
    [sym_preproc_define] = STATE(2256),
    [sym_preproc_undef] = STATE(2256),
    [sym__identifier_token] = ACTIONS(3271),
    [anon_sym_extern] = ACTIONS(3271),
    [anon_sym_alias] = ACTIONS(3271),
    [anon_sym_SEMI] = ACTIONS(3273),
    [anon_sym_global] = ACTIONS(3271),
    [anon_sym_using] = ACTIONS(3271),
    [anon_sym_unsafe] = ACTIONS(3271),
    [anon_sym_static] = ACTIONS(3271),
    [anon_sym_LBRACK] = ACTIONS(3273),
    [anon_sym_LPAREN] = ACTIONS(3273),
    [anon_sym_return] = ACTIONS(3271),
    [anon_sym_namespace] = ACTIONS(3271),
    [anon_sym_class] = ACTIONS(3271),
    [anon_sym_ref] = ACTIONS(3271),
    [anon_sym_struct] = ACTIONS(3271),
    [anon_sym_enum] = ACTIONS(3271),
    [anon_sym_LBRACE] = ACTIONS(3273),
    [anon_sym_interface] = ACTIONS(3271),
    [anon_sym_delegate] = ACTIONS(3271),
    [anon_sym_record] = ACTIONS(3271),
    [anon_sym_abstract] = ACTIONS(3271),
    [anon_sym_async] = ACTIONS(3271),
    [anon_sym_const] = ACTIONS(3271),
    [anon_sym_file] = ACTIONS(3271),
    [anon_sym_fixed] = ACTIONS(3271),
    [anon_sym_internal] = ACTIONS(3271),
    [anon_sym_new] = ACTIONS(3271),
    [anon_sym_override] = ACTIONS(3271),
    [anon_sym_partial] = ACTIONS(3271),
    [anon_sym_private] = ACTIONS(3271),
    [anon_sym_protected] = ACTIONS(3271),
    [anon_sym_public] = ACTIONS(3271),
    [anon_sym_readonly] = ACTIONS(3271),
    [anon_sym_required] = ACTIONS(3271),
    [anon_sym_sealed] = ACTIONS(3271),
    [anon_sym_virtual] = ACTIONS(3271),
    [anon_sym_volatile] = ACTIONS(3271),
    [anon_sym_where] = ACTIONS(3271),
    [anon_sym_notnull] = ACTIONS(3271),
    [anon_sym_unmanaged] = ACTIONS(3271),
    [anon_sym_checked] = ACTIONS(3271),
    [anon_sym_BANG] = ACTIONS(3273),
    [anon_sym_TILDE] = ACTIONS(3273),
    [anon_sym_PLUS_PLUS] = ACTIONS(3273),
    [anon_sym_DASH_DASH] = ACTIONS(3273),
    [anon_sym_true] = ACTIONS(3271),
    [anon_sym_false] = ACTIONS(3271),
    [anon_sym_PLUS] = ACTIONS(3271),
    [anon_sym_DASH] = ACTIONS(3271),
    [anon_sym_STAR] = ACTIONS(3273),
    [anon_sym_CARET] = ACTIONS(3273),
    [anon_sym_AMP] = ACTIONS(3273),
    [anon_sym_this] = ACTIONS(3271),
    [anon_sym_scoped] = ACTIONS(3271),
    [anon_sym_var] = ACTIONS(3271),
    [sym_predefined_type] = ACTIONS(3271),
    [anon_sym_break] = ACTIONS(3271),
    [anon_sym_unchecked] = ACTIONS(3271),
    [anon_sym_continue] = ACTIONS(3271),
    [anon_sym_do] = ACTIONS(3271),
    [anon_sym_while] = ACTIONS(3271),
    [anon_sym_for] = ACTIONS(3271),
    [anon_sym_lock] = ACTIONS(3271),
    [anon_sym_yield] = ACTIONS(3271),
    [anon_sym_switch] = ACTIONS(3271),
    [anon_sym_default] = ACTIONS(3271),
    [anon_sym_throw] = ACTIONS(3271),
    [anon_sym_try] = ACTIONS(3271),
    [anon_sym_when] = ACTIONS(3271),
    [anon_sym_await] = ACTIONS(3271),
    [anon_sym_foreach] = ACTIONS(3271),
    [anon_sym_goto] = ACTIONS(3271),
    [anon_sym_if] = ACTIONS(3271),
    [anon_sym_else] = ACTIONS(3271),
    [anon_sym_DOT_DOT] = ACTIONS(3273),
    [anon_sym_from] = ACTIONS(3271),
    [anon_sym_into] = ACTIONS(3271),
    [anon_sym_join] = ACTIONS(3271),
    [anon_sym_on] = ACTIONS(3271),
    [anon_sym_equals] = ACTIONS(3271),
    [anon_sym_let] = ACTIONS(3271),
    [anon_sym_orderby] = ACTIONS(3271),
    [anon_sym_ascending] = ACTIONS(3271),
    [anon_sym_descending] = ACTIONS(3271),
    [anon_sym_group] = ACTIONS(3271),
    [anon_sym_by] = ACTIONS(3271),
    [anon_sym_select] = ACTIONS(3271),
    [anon_sym_DQUOTE] = ACTIONS(3271),
    [anon_sym_stackalloc] = ACTIONS(3271),
    [anon_sym_sizeof] = ACTIONS(3271),
    [anon_sym_typeof] = ACTIONS(3271),
    [anon_sym___makeref] = ACTIONS(3271),
    [anon_sym___reftype] = ACTIONS(3271),
    [anon_sym___refvalue] = ACTIONS(3271),
    [sym_null_literal] = ACTIONS(3271),
    [anon_sym_SQUOTE] = ACTIONS(3273),
    [sym_integer_literal] = ACTIONS(3271),
    [sym_real_literal] = ACTIONS(3273),
    [sym_verbatim_string_literal] = ACTIONS(3273),
    [sym_raw_string_literal] = ACTIONS(3273),
    [aux_sym_preproc_if_token1] = ACTIONS(3273),
    [aux_sym_preproc_if_token3] = ACTIONS(3273),
    [aux_sym_preproc_else_token1] = ACTIONS(3273),
    [aux_sym_preproc_elif_token1] = ACTIONS(3273),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3273),
    [sym_interpolation_verbatim_start] = ACTIONS(3273),
    [sym_interpolation_raw_start] = ACTIONS(3273),
  },
  [2257] = {
    [sym_preproc_region] = STATE(2257),
    [sym_preproc_endregion] = STATE(2257),
    [sym_preproc_line] = STATE(2257),
    [sym_preproc_pragma] = STATE(2257),
    [sym_preproc_nullable] = STATE(2257),
    [sym_preproc_error] = STATE(2257),
    [sym_preproc_define] = STATE(2257),
    [sym_preproc_undef] = STATE(2257),
    [sym__identifier_token] = ACTIONS(3275),
    [anon_sym_extern] = ACTIONS(3275),
    [anon_sym_alias] = ACTIONS(3275),
    [anon_sym_SEMI] = ACTIONS(3277),
    [anon_sym_global] = ACTIONS(3275),
    [anon_sym_using] = ACTIONS(3275),
    [anon_sym_unsafe] = ACTIONS(3275),
    [anon_sym_static] = ACTIONS(3275),
    [anon_sym_LBRACK] = ACTIONS(3277),
    [anon_sym_LPAREN] = ACTIONS(3277),
    [anon_sym_return] = ACTIONS(3275),
    [anon_sym_namespace] = ACTIONS(3275),
    [anon_sym_class] = ACTIONS(3275),
    [anon_sym_ref] = ACTIONS(3275),
    [anon_sym_struct] = ACTIONS(3275),
    [anon_sym_enum] = ACTIONS(3275),
    [anon_sym_LBRACE] = ACTIONS(3277),
    [anon_sym_interface] = ACTIONS(3275),
    [anon_sym_delegate] = ACTIONS(3275),
    [anon_sym_record] = ACTIONS(3275),
    [anon_sym_abstract] = ACTIONS(3275),
    [anon_sym_async] = ACTIONS(3275),
    [anon_sym_const] = ACTIONS(3275),
    [anon_sym_file] = ACTIONS(3275),
    [anon_sym_fixed] = ACTIONS(3275),
    [anon_sym_internal] = ACTIONS(3275),
    [anon_sym_new] = ACTIONS(3275),
    [anon_sym_override] = ACTIONS(3275),
    [anon_sym_partial] = ACTIONS(3275),
    [anon_sym_private] = ACTIONS(3275),
    [anon_sym_protected] = ACTIONS(3275),
    [anon_sym_public] = ACTIONS(3275),
    [anon_sym_readonly] = ACTIONS(3275),
    [anon_sym_required] = ACTIONS(3275),
    [anon_sym_sealed] = ACTIONS(3275),
    [anon_sym_virtual] = ACTIONS(3275),
    [anon_sym_volatile] = ACTIONS(3275),
    [anon_sym_where] = ACTIONS(3275),
    [anon_sym_notnull] = ACTIONS(3275),
    [anon_sym_unmanaged] = ACTIONS(3275),
    [anon_sym_checked] = ACTIONS(3275),
    [anon_sym_BANG] = ACTIONS(3277),
    [anon_sym_TILDE] = ACTIONS(3277),
    [anon_sym_PLUS_PLUS] = ACTIONS(3277),
    [anon_sym_DASH_DASH] = ACTIONS(3277),
    [anon_sym_true] = ACTIONS(3275),
    [anon_sym_false] = ACTIONS(3275),
    [anon_sym_PLUS] = ACTIONS(3275),
    [anon_sym_DASH] = ACTIONS(3275),
    [anon_sym_STAR] = ACTIONS(3277),
    [anon_sym_CARET] = ACTIONS(3277),
    [anon_sym_AMP] = ACTIONS(3277),
    [anon_sym_this] = ACTIONS(3275),
    [anon_sym_scoped] = ACTIONS(3275),
    [anon_sym_var] = ACTIONS(3275),
    [sym_predefined_type] = ACTIONS(3275),
    [anon_sym_break] = ACTIONS(3275),
    [anon_sym_unchecked] = ACTIONS(3275),
    [anon_sym_continue] = ACTIONS(3275),
    [anon_sym_do] = ACTIONS(3275),
    [anon_sym_while] = ACTIONS(3275),
    [anon_sym_for] = ACTIONS(3275),
    [anon_sym_lock] = ACTIONS(3275),
    [anon_sym_yield] = ACTIONS(3275),
    [anon_sym_switch] = ACTIONS(3275),
    [anon_sym_default] = ACTIONS(3275),
    [anon_sym_throw] = ACTIONS(3275),
    [anon_sym_try] = ACTIONS(3275),
    [anon_sym_when] = ACTIONS(3275),
    [anon_sym_await] = ACTIONS(3275),
    [anon_sym_foreach] = ACTIONS(3275),
    [anon_sym_goto] = ACTIONS(3275),
    [anon_sym_if] = ACTIONS(3275),
    [anon_sym_else] = ACTIONS(3275),
    [anon_sym_DOT_DOT] = ACTIONS(3277),
    [anon_sym_from] = ACTIONS(3275),
    [anon_sym_into] = ACTIONS(3275),
    [anon_sym_join] = ACTIONS(3275),
    [anon_sym_on] = ACTIONS(3275),
    [anon_sym_equals] = ACTIONS(3275),
    [anon_sym_let] = ACTIONS(3275),
    [anon_sym_orderby] = ACTIONS(3275),
    [anon_sym_ascending] = ACTIONS(3275),
    [anon_sym_descending] = ACTIONS(3275),
    [anon_sym_group] = ACTIONS(3275),
    [anon_sym_by] = ACTIONS(3275),
    [anon_sym_select] = ACTIONS(3275),
    [anon_sym_DQUOTE] = ACTIONS(3275),
    [anon_sym_stackalloc] = ACTIONS(3275),
    [anon_sym_sizeof] = ACTIONS(3275),
    [anon_sym_typeof] = ACTIONS(3275),
    [anon_sym___makeref] = ACTIONS(3275),
    [anon_sym___reftype] = ACTIONS(3275),
    [anon_sym___refvalue] = ACTIONS(3275),
    [sym_null_literal] = ACTIONS(3275),
    [anon_sym_SQUOTE] = ACTIONS(3277),
    [sym_integer_literal] = ACTIONS(3275),
    [sym_real_literal] = ACTIONS(3277),
    [sym_verbatim_string_literal] = ACTIONS(3277),
    [sym_raw_string_literal] = ACTIONS(3277),
    [aux_sym_preproc_if_token1] = ACTIONS(3277),
    [aux_sym_preproc_if_token3] = ACTIONS(3277),
    [aux_sym_preproc_else_token1] = ACTIONS(3277),
    [aux_sym_preproc_elif_token1] = ACTIONS(3277),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3277),
    [sym_interpolation_verbatim_start] = ACTIONS(3277),
    [sym_interpolation_raw_start] = ACTIONS(3277),
  },
  [2258] = {
    [sym_preproc_region] = STATE(2258),
    [sym_preproc_endregion] = STATE(2258),
    [sym_preproc_line] = STATE(2258),
    [sym_preproc_pragma] = STATE(2258),
    [sym_preproc_nullable] = STATE(2258),
    [sym_preproc_error] = STATE(2258),
    [sym_preproc_define] = STATE(2258),
    [sym_preproc_undef] = STATE(2258),
    [sym__identifier_token] = ACTIONS(3279),
    [anon_sym_extern] = ACTIONS(3279),
    [anon_sym_alias] = ACTIONS(3279),
    [anon_sym_SEMI] = ACTIONS(3281),
    [anon_sym_global] = ACTIONS(3279),
    [anon_sym_using] = ACTIONS(3279),
    [anon_sym_unsafe] = ACTIONS(3279),
    [anon_sym_static] = ACTIONS(3279),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_LPAREN] = ACTIONS(3281),
    [anon_sym_return] = ACTIONS(3279),
    [anon_sym_namespace] = ACTIONS(3279),
    [anon_sym_class] = ACTIONS(3279),
    [anon_sym_ref] = ACTIONS(3279),
    [anon_sym_struct] = ACTIONS(3279),
    [anon_sym_enum] = ACTIONS(3279),
    [anon_sym_LBRACE] = ACTIONS(3281),
    [anon_sym_interface] = ACTIONS(3279),
    [anon_sym_delegate] = ACTIONS(3279),
    [anon_sym_record] = ACTIONS(3279),
    [anon_sym_abstract] = ACTIONS(3279),
    [anon_sym_async] = ACTIONS(3279),
    [anon_sym_const] = ACTIONS(3279),
    [anon_sym_file] = ACTIONS(3279),
    [anon_sym_fixed] = ACTIONS(3279),
    [anon_sym_internal] = ACTIONS(3279),
    [anon_sym_new] = ACTIONS(3279),
    [anon_sym_override] = ACTIONS(3279),
    [anon_sym_partial] = ACTIONS(3279),
    [anon_sym_private] = ACTIONS(3279),
    [anon_sym_protected] = ACTIONS(3279),
    [anon_sym_public] = ACTIONS(3279),
    [anon_sym_readonly] = ACTIONS(3279),
    [anon_sym_required] = ACTIONS(3279),
    [anon_sym_sealed] = ACTIONS(3279),
    [anon_sym_virtual] = ACTIONS(3279),
    [anon_sym_volatile] = ACTIONS(3279),
    [anon_sym_where] = ACTIONS(3279),
    [anon_sym_notnull] = ACTIONS(3279),
    [anon_sym_unmanaged] = ACTIONS(3279),
    [anon_sym_checked] = ACTIONS(3279),
    [anon_sym_BANG] = ACTIONS(3281),
    [anon_sym_TILDE] = ACTIONS(3281),
    [anon_sym_PLUS_PLUS] = ACTIONS(3281),
    [anon_sym_DASH_DASH] = ACTIONS(3281),
    [anon_sym_true] = ACTIONS(3279),
    [anon_sym_false] = ACTIONS(3279),
    [anon_sym_PLUS] = ACTIONS(3279),
    [anon_sym_DASH] = ACTIONS(3279),
    [anon_sym_STAR] = ACTIONS(3281),
    [anon_sym_CARET] = ACTIONS(3281),
    [anon_sym_AMP] = ACTIONS(3281),
    [anon_sym_this] = ACTIONS(3279),
    [anon_sym_scoped] = ACTIONS(3279),
    [anon_sym_var] = ACTIONS(3279),
    [sym_predefined_type] = ACTIONS(3279),
    [anon_sym_break] = ACTIONS(3279),
    [anon_sym_unchecked] = ACTIONS(3279),
    [anon_sym_continue] = ACTIONS(3279),
    [anon_sym_do] = ACTIONS(3279),
    [anon_sym_while] = ACTIONS(3279),
    [anon_sym_for] = ACTIONS(3279),
    [anon_sym_lock] = ACTIONS(3279),
    [anon_sym_yield] = ACTIONS(3279),
    [anon_sym_switch] = ACTIONS(3279),
    [anon_sym_default] = ACTIONS(3279),
    [anon_sym_throw] = ACTIONS(3279),
    [anon_sym_try] = ACTIONS(3279),
    [anon_sym_when] = ACTIONS(3279),
    [anon_sym_await] = ACTIONS(3279),
    [anon_sym_foreach] = ACTIONS(3279),
    [anon_sym_goto] = ACTIONS(3279),
    [anon_sym_if] = ACTIONS(3279),
    [anon_sym_else] = ACTIONS(3279),
    [anon_sym_DOT_DOT] = ACTIONS(3281),
    [anon_sym_from] = ACTIONS(3279),
    [anon_sym_into] = ACTIONS(3279),
    [anon_sym_join] = ACTIONS(3279),
    [anon_sym_on] = ACTIONS(3279),
    [anon_sym_equals] = ACTIONS(3279),
    [anon_sym_let] = ACTIONS(3279),
    [anon_sym_orderby] = ACTIONS(3279),
    [anon_sym_ascending] = ACTIONS(3279),
    [anon_sym_descending] = ACTIONS(3279),
    [anon_sym_group] = ACTIONS(3279),
    [anon_sym_by] = ACTIONS(3279),
    [anon_sym_select] = ACTIONS(3279),
    [anon_sym_DQUOTE] = ACTIONS(3279),
    [anon_sym_stackalloc] = ACTIONS(3279),
    [anon_sym_sizeof] = ACTIONS(3279),
    [anon_sym_typeof] = ACTIONS(3279),
    [anon_sym___makeref] = ACTIONS(3279),
    [anon_sym___reftype] = ACTIONS(3279),
    [anon_sym___refvalue] = ACTIONS(3279),
    [sym_null_literal] = ACTIONS(3279),
    [anon_sym_SQUOTE] = ACTIONS(3281),
    [sym_integer_literal] = ACTIONS(3279),
    [sym_real_literal] = ACTIONS(3281),
    [sym_verbatim_string_literal] = ACTIONS(3281),
    [sym_raw_string_literal] = ACTIONS(3281),
    [aux_sym_preproc_if_token1] = ACTIONS(3281),
    [aux_sym_preproc_if_token3] = ACTIONS(3281),
    [aux_sym_preproc_else_token1] = ACTIONS(3281),
    [aux_sym_preproc_elif_token1] = ACTIONS(3281),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3281),
    [sym_interpolation_verbatim_start] = ACTIONS(3281),
    [sym_interpolation_raw_start] = ACTIONS(3281),
  },
  [2259] = {
    [sym_preproc_region] = STATE(2259),
    [sym_preproc_endregion] = STATE(2259),
    [sym_preproc_line] = STATE(2259),
    [sym_preproc_pragma] = STATE(2259),
    [sym_preproc_nullable] = STATE(2259),
    [sym_preproc_error] = STATE(2259),
    [sym_preproc_define] = STATE(2259),
    [sym_preproc_undef] = STATE(2259),
    [sym__identifier_token] = ACTIONS(3283),
    [anon_sym_extern] = ACTIONS(3283),
    [anon_sym_alias] = ACTIONS(3283),
    [anon_sym_SEMI] = ACTIONS(3285),
    [anon_sym_global] = ACTIONS(3283),
    [anon_sym_using] = ACTIONS(3283),
    [anon_sym_unsafe] = ACTIONS(3283),
    [anon_sym_static] = ACTIONS(3283),
    [anon_sym_LBRACK] = ACTIONS(3285),
    [anon_sym_LPAREN] = ACTIONS(3285),
    [anon_sym_return] = ACTIONS(3283),
    [anon_sym_namespace] = ACTIONS(3283),
    [anon_sym_class] = ACTIONS(3283),
    [anon_sym_ref] = ACTIONS(3283),
    [anon_sym_struct] = ACTIONS(3283),
    [anon_sym_enum] = ACTIONS(3283),
    [anon_sym_LBRACE] = ACTIONS(3285),
    [anon_sym_interface] = ACTIONS(3283),
    [anon_sym_delegate] = ACTIONS(3283),
    [anon_sym_record] = ACTIONS(3283),
    [anon_sym_abstract] = ACTIONS(3283),
    [anon_sym_async] = ACTIONS(3283),
    [anon_sym_const] = ACTIONS(3283),
    [anon_sym_file] = ACTIONS(3283),
    [anon_sym_fixed] = ACTIONS(3283),
    [anon_sym_internal] = ACTIONS(3283),
    [anon_sym_new] = ACTIONS(3283),
    [anon_sym_override] = ACTIONS(3283),
    [anon_sym_partial] = ACTIONS(3283),
    [anon_sym_private] = ACTIONS(3283),
    [anon_sym_protected] = ACTIONS(3283),
    [anon_sym_public] = ACTIONS(3283),
    [anon_sym_readonly] = ACTIONS(3283),
    [anon_sym_required] = ACTIONS(3283),
    [anon_sym_sealed] = ACTIONS(3283),
    [anon_sym_virtual] = ACTIONS(3283),
    [anon_sym_volatile] = ACTIONS(3283),
    [anon_sym_where] = ACTIONS(3283),
    [anon_sym_notnull] = ACTIONS(3283),
    [anon_sym_unmanaged] = ACTIONS(3283),
    [anon_sym_checked] = ACTIONS(3283),
    [anon_sym_BANG] = ACTIONS(3285),
    [anon_sym_TILDE] = ACTIONS(3285),
    [anon_sym_PLUS_PLUS] = ACTIONS(3285),
    [anon_sym_DASH_DASH] = ACTIONS(3285),
    [anon_sym_true] = ACTIONS(3283),
    [anon_sym_false] = ACTIONS(3283),
    [anon_sym_PLUS] = ACTIONS(3283),
    [anon_sym_DASH] = ACTIONS(3283),
    [anon_sym_STAR] = ACTIONS(3285),
    [anon_sym_CARET] = ACTIONS(3285),
    [anon_sym_AMP] = ACTIONS(3285),
    [anon_sym_this] = ACTIONS(3283),
    [anon_sym_scoped] = ACTIONS(3283),
    [anon_sym_var] = ACTIONS(3283),
    [sym_predefined_type] = ACTIONS(3283),
    [anon_sym_break] = ACTIONS(3283),
    [anon_sym_unchecked] = ACTIONS(3283),
    [anon_sym_continue] = ACTIONS(3283),
    [anon_sym_do] = ACTIONS(3283),
    [anon_sym_while] = ACTIONS(3283),
    [anon_sym_for] = ACTIONS(3283),
    [anon_sym_lock] = ACTIONS(3283),
    [anon_sym_yield] = ACTIONS(3283),
    [anon_sym_switch] = ACTIONS(3283),
    [anon_sym_default] = ACTIONS(3283),
    [anon_sym_throw] = ACTIONS(3283),
    [anon_sym_try] = ACTIONS(3283),
    [anon_sym_when] = ACTIONS(3283),
    [anon_sym_await] = ACTIONS(3283),
    [anon_sym_foreach] = ACTIONS(3283),
    [anon_sym_goto] = ACTIONS(3283),
    [anon_sym_if] = ACTIONS(3283),
    [anon_sym_else] = ACTIONS(3283),
    [anon_sym_DOT_DOT] = ACTIONS(3285),
    [anon_sym_from] = ACTIONS(3283),
    [anon_sym_into] = ACTIONS(3283),
    [anon_sym_join] = ACTIONS(3283),
    [anon_sym_on] = ACTIONS(3283),
    [anon_sym_equals] = ACTIONS(3283),
    [anon_sym_let] = ACTIONS(3283),
    [anon_sym_orderby] = ACTIONS(3283),
    [anon_sym_ascending] = ACTIONS(3283),
    [anon_sym_descending] = ACTIONS(3283),
    [anon_sym_group] = ACTIONS(3283),
    [anon_sym_by] = ACTIONS(3283),
    [anon_sym_select] = ACTIONS(3283),
    [anon_sym_DQUOTE] = ACTIONS(3283),
    [anon_sym_stackalloc] = ACTIONS(3283),
    [anon_sym_sizeof] = ACTIONS(3283),
    [anon_sym_typeof] = ACTIONS(3283),
    [anon_sym___makeref] = ACTIONS(3283),
    [anon_sym___reftype] = ACTIONS(3283),
    [anon_sym___refvalue] = ACTIONS(3283),
    [sym_null_literal] = ACTIONS(3283),
    [anon_sym_SQUOTE] = ACTIONS(3285),
    [sym_integer_literal] = ACTIONS(3283),
    [sym_real_literal] = ACTIONS(3285),
    [sym_verbatim_string_literal] = ACTIONS(3285),
    [sym_raw_string_literal] = ACTIONS(3285),
    [aux_sym_preproc_if_token1] = ACTIONS(3285),
    [aux_sym_preproc_if_token3] = ACTIONS(3285),
    [aux_sym_preproc_else_token1] = ACTIONS(3285),
    [aux_sym_preproc_elif_token1] = ACTIONS(3285),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3285),
    [sym_interpolation_verbatim_start] = ACTIONS(3285),
    [sym_interpolation_raw_start] = ACTIONS(3285),
  },
  [2260] = {
    [sym_preproc_region] = STATE(2260),
    [sym_preproc_endregion] = STATE(2260),
    [sym_preproc_line] = STATE(2260),
    [sym_preproc_pragma] = STATE(2260),
    [sym_preproc_nullable] = STATE(2260),
    [sym_preproc_error] = STATE(2260),
    [sym_preproc_define] = STATE(2260),
    [sym_preproc_undef] = STATE(2260),
    [sym__identifier_token] = ACTIONS(3287),
    [anon_sym_extern] = ACTIONS(3287),
    [anon_sym_alias] = ACTIONS(3287),
    [anon_sym_SEMI] = ACTIONS(3289),
    [anon_sym_global] = ACTIONS(3287),
    [anon_sym_using] = ACTIONS(3287),
    [anon_sym_unsafe] = ACTIONS(3287),
    [anon_sym_static] = ACTIONS(3287),
    [anon_sym_LBRACK] = ACTIONS(3289),
    [anon_sym_LPAREN] = ACTIONS(3289),
    [anon_sym_return] = ACTIONS(3287),
    [anon_sym_namespace] = ACTIONS(3287),
    [anon_sym_class] = ACTIONS(3287),
    [anon_sym_ref] = ACTIONS(3287),
    [anon_sym_struct] = ACTIONS(3287),
    [anon_sym_enum] = ACTIONS(3287),
    [anon_sym_LBRACE] = ACTIONS(3289),
    [anon_sym_interface] = ACTIONS(3287),
    [anon_sym_delegate] = ACTIONS(3287),
    [anon_sym_record] = ACTIONS(3287),
    [anon_sym_abstract] = ACTIONS(3287),
    [anon_sym_async] = ACTIONS(3287),
    [anon_sym_const] = ACTIONS(3287),
    [anon_sym_file] = ACTIONS(3287),
    [anon_sym_fixed] = ACTIONS(3287),
    [anon_sym_internal] = ACTIONS(3287),
    [anon_sym_new] = ACTIONS(3287),
    [anon_sym_override] = ACTIONS(3287),
    [anon_sym_partial] = ACTIONS(3287),
    [anon_sym_private] = ACTIONS(3287),
    [anon_sym_protected] = ACTIONS(3287),
    [anon_sym_public] = ACTIONS(3287),
    [anon_sym_readonly] = ACTIONS(3287),
    [anon_sym_required] = ACTIONS(3287),
    [anon_sym_sealed] = ACTIONS(3287),
    [anon_sym_virtual] = ACTIONS(3287),
    [anon_sym_volatile] = ACTIONS(3287),
    [anon_sym_where] = ACTIONS(3287),
    [anon_sym_notnull] = ACTIONS(3287),
    [anon_sym_unmanaged] = ACTIONS(3287),
    [anon_sym_checked] = ACTIONS(3287),
    [anon_sym_BANG] = ACTIONS(3289),
    [anon_sym_TILDE] = ACTIONS(3289),
    [anon_sym_PLUS_PLUS] = ACTIONS(3289),
    [anon_sym_DASH_DASH] = ACTIONS(3289),
    [anon_sym_true] = ACTIONS(3287),
    [anon_sym_false] = ACTIONS(3287),
    [anon_sym_PLUS] = ACTIONS(3287),
    [anon_sym_DASH] = ACTIONS(3287),
    [anon_sym_STAR] = ACTIONS(3289),
    [anon_sym_CARET] = ACTIONS(3289),
    [anon_sym_AMP] = ACTIONS(3289),
    [anon_sym_this] = ACTIONS(3287),
    [anon_sym_scoped] = ACTIONS(3287),
    [anon_sym_var] = ACTIONS(3287),
    [sym_predefined_type] = ACTIONS(3287),
    [anon_sym_break] = ACTIONS(3287),
    [anon_sym_unchecked] = ACTIONS(3287),
    [anon_sym_continue] = ACTIONS(3287),
    [anon_sym_do] = ACTIONS(3287),
    [anon_sym_while] = ACTIONS(3287),
    [anon_sym_for] = ACTIONS(3287),
    [anon_sym_lock] = ACTIONS(3287),
    [anon_sym_yield] = ACTIONS(3287),
    [anon_sym_switch] = ACTIONS(3287),
    [anon_sym_default] = ACTIONS(3287),
    [anon_sym_throw] = ACTIONS(3287),
    [anon_sym_try] = ACTIONS(3287),
    [anon_sym_when] = ACTIONS(3287),
    [anon_sym_await] = ACTIONS(3287),
    [anon_sym_foreach] = ACTIONS(3287),
    [anon_sym_goto] = ACTIONS(3287),
    [anon_sym_if] = ACTIONS(3287),
    [anon_sym_else] = ACTIONS(3287),
    [anon_sym_DOT_DOT] = ACTIONS(3289),
    [anon_sym_from] = ACTIONS(3287),
    [anon_sym_into] = ACTIONS(3287),
    [anon_sym_join] = ACTIONS(3287),
    [anon_sym_on] = ACTIONS(3287),
    [anon_sym_equals] = ACTIONS(3287),
    [anon_sym_let] = ACTIONS(3287),
    [anon_sym_orderby] = ACTIONS(3287),
    [anon_sym_ascending] = ACTIONS(3287),
    [anon_sym_descending] = ACTIONS(3287),
    [anon_sym_group] = ACTIONS(3287),
    [anon_sym_by] = ACTIONS(3287),
    [anon_sym_select] = ACTIONS(3287),
    [anon_sym_DQUOTE] = ACTIONS(3287),
    [anon_sym_stackalloc] = ACTIONS(3287),
    [anon_sym_sizeof] = ACTIONS(3287),
    [anon_sym_typeof] = ACTIONS(3287),
    [anon_sym___makeref] = ACTIONS(3287),
    [anon_sym___reftype] = ACTIONS(3287),
    [anon_sym___refvalue] = ACTIONS(3287),
    [sym_null_literal] = ACTIONS(3287),
    [anon_sym_SQUOTE] = ACTIONS(3289),
    [sym_integer_literal] = ACTIONS(3287),
    [sym_real_literal] = ACTIONS(3289),
    [sym_verbatim_string_literal] = ACTIONS(3289),
    [sym_raw_string_literal] = ACTIONS(3289),
    [aux_sym_preproc_if_token1] = ACTIONS(3289),
    [aux_sym_preproc_if_token3] = ACTIONS(3289),
    [aux_sym_preproc_else_token1] = ACTIONS(3289),
    [aux_sym_preproc_elif_token1] = ACTIONS(3289),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3289),
    [sym_interpolation_verbatim_start] = ACTIONS(3289),
    [sym_interpolation_raw_start] = ACTIONS(3289),
  },
  [2261] = {
    [sym_preproc_region] = STATE(2261),
    [sym_preproc_endregion] = STATE(2261),
    [sym_preproc_line] = STATE(2261),
    [sym_preproc_pragma] = STATE(2261),
    [sym_preproc_nullable] = STATE(2261),
    [sym_preproc_error] = STATE(2261),
    [sym_preproc_define] = STATE(2261),
    [sym_preproc_undef] = STATE(2261),
    [sym__identifier_token] = ACTIONS(3291),
    [anon_sym_extern] = ACTIONS(3291),
    [anon_sym_alias] = ACTIONS(3291),
    [anon_sym_SEMI] = ACTIONS(3293),
    [anon_sym_global] = ACTIONS(3291),
    [anon_sym_using] = ACTIONS(3291),
    [anon_sym_unsafe] = ACTIONS(3291),
    [anon_sym_static] = ACTIONS(3291),
    [anon_sym_LBRACK] = ACTIONS(3293),
    [anon_sym_LPAREN] = ACTIONS(3293),
    [anon_sym_return] = ACTIONS(3291),
    [anon_sym_namespace] = ACTIONS(3291),
    [anon_sym_class] = ACTIONS(3291),
    [anon_sym_ref] = ACTIONS(3291),
    [anon_sym_struct] = ACTIONS(3291),
    [anon_sym_enum] = ACTIONS(3291),
    [anon_sym_LBRACE] = ACTIONS(3293),
    [anon_sym_interface] = ACTIONS(3291),
    [anon_sym_delegate] = ACTIONS(3291),
    [anon_sym_record] = ACTIONS(3291),
    [anon_sym_abstract] = ACTIONS(3291),
    [anon_sym_async] = ACTIONS(3291),
    [anon_sym_const] = ACTIONS(3291),
    [anon_sym_file] = ACTIONS(3291),
    [anon_sym_fixed] = ACTIONS(3291),
    [anon_sym_internal] = ACTIONS(3291),
    [anon_sym_new] = ACTIONS(3291),
    [anon_sym_override] = ACTIONS(3291),
    [anon_sym_partial] = ACTIONS(3291),
    [anon_sym_private] = ACTIONS(3291),
    [anon_sym_protected] = ACTIONS(3291),
    [anon_sym_public] = ACTIONS(3291),
    [anon_sym_readonly] = ACTIONS(3291),
    [anon_sym_required] = ACTIONS(3291),
    [anon_sym_sealed] = ACTIONS(3291),
    [anon_sym_virtual] = ACTIONS(3291),
    [anon_sym_volatile] = ACTIONS(3291),
    [anon_sym_where] = ACTIONS(3291),
    [anon_sym_notnull] = ACTIONS(3291),
    [anon_sym_unmanaged] = ACTIONS(3291),
    [anon_sym_checked] = ACTIONS(3291),
    [anon_sym_BANG] = ACTIONS(3293),
    [anon_sym_TILDE] = ACTIONS(3293),
    [anon_sym_PLUS_PLUS] = ACTIONS(3293),
    [anon_sym_DASH_DASH] = ACTIONS(3293),
    [anon_sym_true] = ACTIONS(3291),
    [anon_sym_false] = ACTIONS(3291),
    [anon_sym_PLUS] = ACTIONS(3291),
    [anon_sym_DASH] = ACTIONS(3291),
    [anon_sym_STAR] = ACTIONS(3293),
    [anon_sym_CARET] = ACTIONS(3293),
    [anon_sym_AMP] = ACTIONS(3293),
    [anon_sym_this] = ACTIONS(3291),
    [anon_sym_scoped] = ACTIONS(3291),
    [anon_sym_var] = ACTIONS(3291),
    [sym_predefined_type] = ACTIONS(3291),
    [anon_sym_break] = ACTIONS(3291),
    [anon_sym_unchecked] = ACTIONS(3291),
    [anon_sym_continue] = ACTIONS(3291),
    [anon_sym_do] = ACTIONS(3291),
    [anon_sym_while] = ACTIONS(3291),
    [anon_sym_for] = ACTIONS(3291),
    [anon_sym_lock] = ACTIONS(3291),
    [anon_sym_yield] = ACTIONS(3291),
    [anon_sym_switch] = ACTIONS(3291),
    [anon_sym_default] = ACTIONS(3291),
    [anon_sym_throw] = ACTIONS(3291),
    [anon_sym_try] = ACTIONS(3291),
    [anon_sym_when] = ACTIONS(3291),
    [anon_sym_await] = ACTIONS(3291),
    [anon_sym_foreach] = ACTIONS(3291),
    [anon_sym_goto] = ACTIONS(3291),
    [anon_sym_if] = ACTIONS(3291),
    [anon_sym_else] = ACTIONS(3291),
    [anon_sym_DOT_DOT] = ACTIONS(3293),
    [anon_sym_from] = ACTIONS(3291),
    [anon_sym_into] = ACTIONS(3291),
    [anon_sym_join] = ACTIONS(3291),
    [anon_sym_on] = ACTIONS(3291),
    [anon_sym_equals] = ACTIONS(3291),
    [anon_sym_let] = ACTIONS(3291),
    [anon_sym_orderby] = ACTIONS(3291),
    [anon_sym_ascending] = ACTIONS(3291),
    [anon_sym_descending] = ACTIONS(3291),
    [anon_sym_group] = ACTIONS(3291),
    [anon_sym_by] = ACTIONS(3291),
    [anon_sym_select] = ACTIONS(3291),
    [anon_sym_DQUOTE] = ACTIONS(3291),
    [anon_sym_stackalloc] = ACTIONS(3291),
    [anon_sym_sizeof] = ACTIONS(3291),
    [anon_sym_typeof] = ACTIONS(3291),
    [anon_sym___makeref] = ACTIONS(3291),
    [anon_sym___reftype] = ACTIONS(3291),
    [anon_sym___refvalue] = ACTIONS(3291),
    [sym_null_literal] = ACTIONS(3291),
    [anon_sym_SQUOTE] = ACTIONS(3293),
    [sym_integer_literal] = ACTIONS(3291),
    [sym_real_literal] = ACTIONS(3293),
    [sym_verbatim_string_literal] = ACTIONS(3293),
    [sym_raw_string_literal] = ACTIONS(3293),
    [aux_sym_preproc_if_token1] = ACTIONS(3293),
    [aux_sym_preproc_if_token3] = ACTIONS(3293),
    [aux_sym_preproc_else_token1] = ACTIONS(3293),
    [aux_sym_preproc_elif_token1] = ACTIONS(3293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3293),
    [sym_interpolation_verbatim_start] = ACTIONS(3293),
    [sym_interpolation_raw_start] = ACTIONS(3293),
  },
  [2262] = {
    [sym_preproc_region] = STATE(2262),
    [sym_preproc_endregion] = STATE(2262),
    [sym_preproc_line] = STATE(2262),
    [sym_preproc_pragma] = STATE(2262),
    [sym_preproc_nullable] = STATE(2262),
    [sym_preproc_error] = STATE(2262),
    [sym_preproc_define] = STATE(2262),
    [sym_preproc_undef] = STATE(2262),
    [sym__identifier_token] = ACTIONS(3295),
    [anon_sym_extern] = ACTIONS(3295),
    [anon_sym_alias] = ACTIONS(3295),
    [anon_sym_SEMI] = ACTIONS(3297),
    [anon_sym_global] = ACTIONS(3295),
    [anon_sym_using] = ACTIONS(3295),
    [anon_sym_unsafe] = ACTIONS(3295),
    [anon_sym_static] = ACTIONS(3295),
    [anon_sym_LBRACK] = ACTIONS(3297),
    [anon_sym_LPAREN] = ACTIONS(3297),
    [anon_sym_return] = ACTIONS(3295),
    [anon_sym_namespace] = ACTIONS(3295),
    [anon_sym_class] = ACTIONS(3295),
    [anon_sym_ref] = ACTIONS(3295),
    [anon_sym_struct] = ACTIONS(3295),
    [anon_sym_enum] = ACTIONS(3295),
    [anon_sym_LBRACE] = ACTIONS(3297),
    [anon_sym_interface] = ACTIONS(3295),
    [anon_sym_delegate] = ACTIONS(3295),
    [anon_sym_record] = ACTIONS(3295),
    [anon_sym_abstract] = ACTIONS(3295),
    [anon_sym_async] = ACTIONS(3295),
    [anon_sym_const] = ACTIONS(3295),
    [anon_sym_file] = ACTIONS(3295),
    [anon_sym_fixed] = ACTIONS(3295),
    [anon_sym_internal] = ACTIONS(3295),
    [anon_sym_new] = ACTIONS(3295),
    [anon_sym_override] = ACTIONS(3295),
    [anon_sym_partial] = ACTIONS(3295),
    [anon_sym_private] = ACTIONS(3295),
    [anon_sym_protected] = ACTIONS(3295),
    [anon_sym_public] = ACTIONS(3295),
    [anon_sym_readonly] = ACTIONS(3295),
    [anon_sym_required] = ACTIONS(3295),
    [anon_sym_sealed] = ACTIONS(3295),
    [anon_sym_virtual] = ACTIONS(3295),
    [anon_sym_volatile] = ACTIONS(3295),
    [anon_sym_where] = ACTIONS(3295),
    [anon_sym_notnull] = ACTIONS(3295),
    [anon_sym_unmanaged] = ACTIONS(3295),
    [anon_sym_checked] = ACTIONS(3295),
    [anon_sym_BANG] = ACTIONS(3297),
    [anon_sym_TILDE] = ACTIONS(3297),
    [anon_sym_PLUS_PLUS] = ACTIONS(3297),
    [anon_sym_DASH_DASH] = ACTIONS(3297),
    [anon_sym_true] = ACTIONS(3295),
    [anon_sym_false] = ACTIONS(3295),
    [anon_sym_PLUS] = ACTIONS(3295),
    [anon_sym_DASH] = ACTIONS(3295),
    [anon_sym_STAR] = ACTIONS(3297),
    [anon_sym_CARET] = ACTIONS(3297),
    [anon_sym_AMP] = ACTIONS(3297),
    [anon_sym_this] = ACTIONS(3295),
    [anon_sym_scoped] = ACTIONS(3295),
    [anon_sym_var] = ACTIONS(3295),
    [sym_predefined_type] = ACTIONS(3295),
    [anon_sym_break] = ACTIONS(3295),
    [anon_sym_unchecked] = ACTIONS(3295),
    [anon_sym_continue] = ACTIONS(3295),
    [anon_sym_do] = ACTIONS(3295),
    [anon_sym_while] = ACTIONS(3295),
    [anon_sym_for] = ACTIONS(3295),
    [anon_sym_lock] = ACTIONS(3295),
    [anon_sym_yield] = ACTIONS(3295),
    [anon_sym_switch] = ACTIONS(3295),
    [anon_sym_default] = ACTIONS(3295),
    [anon_sym_throw] = ACTIONS(3295),
    [anon_sym_try] = ACTIONS(3295),
    [anon_sym_when] = ACTIONS(3295),
    [anon_sym_await] = ACTIONS(3295),
    [anon_sym_foreach] = ACTIONS(3295),
    [anon_sym_goto] = ACTIONS(3295),
    [anon_sym_if] = ACTIONS(3295),
    [anon_sym_else] = ACTIONS(3295),
    [anon_sym_DOT_DOT] = ACTIONS(3297),
    [anon_sym_from] = ACTIONS(3295),
    [anon_sym_into] = ACTIONS(3295),
    [anon_sym_join] = ACTIONS(3295),
    [anon_sym_on] = ACTIONS(3295),
    [anon_sym_equals] = ACTIONS(3295),
    [anon_sym_let] = ACTIONS(3295),
    [anon_sym_orderby] = ACTIONS(3295),
    [anon_sym_ascending] = ACTIONS(3295),
    [anon_sym_descending] = ACTIONS(3295),
    [anon_sym_group] = ACTIONS(3295),
    [anon_sym_by] = ACTIONS(3295),
    [anon_sym_select] = ACTIONS(3295),
    [anon_sym_DQUOTE] = ACTIONS(3295),
    [anon_sym_stackalloc] = ACTIONS(3295),
    [anon_sym_sizeof] = ACTIONS(3295),
    [anon_sym_typeof] = ACTIONS(3295),
    [anon_sym___makeref] = ACTIONS(3295),
    [anon_sym___reftype] = ACTIONS(3295),
    [anon_sym___refvalue] = ACTIONS(3295),
    [sym_null_literal] = ACTIONS(3295),
    [anon_sym_SQUOTE] = ACTIONS(3297),
    [sym_integer_literal] = ACTIONS(3295),
    [sym_real_literal] = ACTIONS(3297),
    [sym_verbatim_string_literal] = ACTIONS(3297),
    [sym_raw_string_literal] = ACTIONS(3297),
    [aux_sym_preproc_if_token1] = ACTIONS(3297),
    [aux_sym_preproc_if_token3] = ACTIONS(3297),
    [aux_sym_preproc_else_token1] = ACTIONS(3297),
    [aux_sym_preproc_elif_token1] = ACTIONS(3297),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3297),
    [sym_interpolation_verbatim_start] = ACTIONS(3297),
    [sym_interpolation_raw_start] = ACTIONS(3297),
  },
  [2263] = {
    [sym_preproc_region] = STATE(2263),
    [sym_preproc_endregion] = STATE(2263),
    [sym_preproc_line] = STATE(2263),
    [sym_preproc_pragma] = STATE(2263),
    [sym_preproc_nullable] = STATE(2263),
    [sym_preproc_error] = STATE(2263),
    [sym_preproc_define] = STATE(2263),
    [sym_preproc_undef] = STATE(2263),
    [sym__identifier_token] = ACTIONS(3299),
    [anon_sym_extern] = ACTIONS(3299),
    [anon_sym_alias] = ACTIONS(3299),
    [anon_sym_SEMI] = ACTIONS(3301),
    [anon_sym_global] = ACTIONS(3299),
    [anon_sym_using] = ACTIONS(3299),
    [anon_sym_unsafe] = ACTIONS(3299),
    [anon_sym_static] = ACTIONS(3299),
    [anon_sym_LBRACK] = ACTIONS(3301),
    [anon_sym_LPAREN] = ACTIONS(3301),
    [anon_sym_return] = ACTIONS(3299),
    [anon_sym_namespace] = ACTIONS(3299),
    [anon_sym_class] = ACTIONS(3299),
    [anon_sym_ref] = ACTIONS(3299),
    [anon_sym_struct] = ACTIONS(3299),
    [anon_sym_enum] = ACTIONS(3299),
    [anon_sym_LBRACE] = ACTIONS(3301),
    [anon_sym_interface] = ACTIONS(3299),
    [anon_sym_delegate] = ACTIONS(3299),
    [anon_sym_record] = ACTIONS(3299),
    [anon_sym_abstract] = ACTIONS(3299),
    [anon_sym_async] = ACTIONS(3299),
    [anon_sym_const] = ACTIONS(3299),
    [anon_sym_file] = ACTIONS(3299),
    [anon_sym_fixed] = ACTIONS(3299),
    [anon_sym_internal] = ACTIONS(3299),
    [anon_sym_new] = ACTIONS(3299),
    [anon_sym_override] = ACTIONS(3299),
    [anon_sym_partial] = ACTIONS(3299),
    [anon_sym_private] = ACTIONS(3299),
    [anon_sym_protected] = ACTIONS(3299),
    [anon_sym_public] = ACTIONS(3299),
    [anon_sym_readonly] = ACTIONS(3299),
    [anon_sym_required] = ACTIONS(3299),
    [anon_sym_sealed] = ACTIONS(3299),
    [anon_sym_virtual] = ACTIONS(3299),
    [anon_sym_volatile] = ACTIONS(3299),
    [anon_sym_where] = ACTIONS(3299),
    [anon_sym_notnull] = ACTIONS(3299),
    [anon_sym_unmanaged] = ACTIONS(3299),
    [anon_sym_checked] = ACTIONS(3299),
    [anon_sym_BANG] = ACTIONS(3301),
    [anon_sym_TILDE] = ACTIONS(3301),
    [anon_sym_PLUS_PLUS] = ACTIONS(3301),
    [anon_sym_DASH_DASH] = ACTIONS(3301),
    [anon_sym_true] = ACTIONS(3299),
    [anon_sym_false] = ACTIONS(3299),
    [anon_sym_PLUS] = ACTIONS(3299),
    [anon_sym_DASH] = ACTIONS(3299),
    [anon_sym_STAR] = ACTIONS(3301),
    [anon_sym_CARET] = ACTIONS(3301),
    [anon_sym_AMP] = ACTIONS(3301),
    [anon_sym_this] = ACTIONS(3299),
    [anon_sym_scoped] = ACTIONS(3299),
    [anon_sym_var] = ACTIONS(3299),
    [sym_predefined_type] = ACTIONS(3299),
    [anon_sym_break] = ACTIONS(3299),
    [anon_sym_unchecked] = ACTIONS(3299),
    [anon_sym_continue] = ACTIONS(3299),
    [anon_sym_do] = ACTIONS(3299),
    [anon_sym_while] = ACTIONS(3299),
    [anon_sym_for] = ACTIONS(3299),
    [anon_sym_lock] = ACTIONS(3299),
    [anon_sym_yield] = ACTIONS(3299),
    [anon_sym_switch] = ACTIONS(3299),
    [anon_sym_default] = ACTIONS(3299),
    [anon_sym_throw] = ACTIONS(3299),
    [anon_sym_try] = ACTIONS(3299),
    [anon_sym_when] = ACTIONS(3299),
    [anon_sym_await] = ACTIONS(3299),
    [anon_sym_foreach] = ACTIONS(3299),
    [anon_sym_goto] = ACTIONS(3299),
    [anon_sym_if] = ACTIONS(3299),
    [anon_sym_else] = ACTIONS(3299),
    [anon_sym_DOT_DOT] = ACTIONS(3301),
    [anon_sym_from] = ACTIONS(3299),
    [anon_sym_into] = ACTIONS(3299),
    [anon_sym_join] = ACTIONS(3299),
    [anon_sym_on] = ACTIONS(3299),
    [anon_sym_equals] = ACTIONS(3299),
    [anon_sym_let] = ACTIONS(3299),
    [anon_sym_orderby] = ACTIONS(3299),
    [anon_sym_ascending] = ACTIONS(3299),
    [anon_sym_descending] = ACTIONS(3299),
    [anon_sym_group] = ACTIONS(3299),
    [anon_sym_by] = ACTIONS(3299),
    [anon_sym_select] = ACTIONS(3299),
    [anon_sym_DQUOTE] = ACTIONS(3299),
    [anon_sym_stackalloc] = ACTIONS(3299),
    [anon_sym_sizeof] = ACTIONS(3299),
    [anon_sym_typeof] = ACTIONS(3299),
    [anon_sym___makeref] = ACTIONS(3299),
    [anon_sym___reftype] = ACTIONS(3299),
    [anon_sym___refvalue] = ACTIONS(3299),
    [sym_null_literal] = ACTIONS(3299),
    [anon_sym_SQUOTE] = ACTIONS(3301),
    [sym_integer_literal] = ACTIONS(3299),
    [sym_real_literal] = ACTIONS(3301),
    [sym_verbatim_string_literal] = ACTIONS(3301),
    [sym_raw_string_literal] = ACTIONS(3301),
    [aux_sym_preproc_if_token1] = ACTIONS(3301),
    [aux_sym_preproc_if_token3] = ACTIONS(3301),
    [aux_sym_preproc_else_token1] = ACTIONS(3301),
    [aux_sym_preproc_elif_token1] = ACTIONS(3301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3301),
    [sym_interpolation_verbatim_start] = ACTIONS(3301),
    [sym_interpolation_raw_start] = ACTIONS(3301),
  },
  [2264] = {
    [sym_preproc_region] = STATE(2264),
    [sym_preproc_endregion] = STATE(2264),
    [sym_preproc_line] = STATE(2264),
    [sym_preproc_pragma] = STATE(2264),
    [sym_preproc_nullable] = STATE(2264),
    [sym_preproc_error] = STATE(2264),
    [sym_preproc_define] = STATE(2264),
    [sym_preproc_undef] = STATE(2264),
    [sym__identifier_token] = ACTIONS(3303),
    [anon_sym_extern] = ACTIONS(3303),
    [anon_sym_alias] = ACTIONS(3303),
    [anon_sym_SEMI] = ACTIONS(3305),
    [anon_sym_global] = ACTIONS(3303),
    [anon_sym_using] = ACTIONS(3303),
    [anon_sym_unsafe] = ACTIONS(3303),
    [anon_sym_static] = ACTIONS(3303),
    [anon_sym_LBRACK] = ACTIONS(3305),
    [anon_sym_LPAREN] = ACTIONS(3305),
    [anon_sym_return] = ACTIONS(3303),
    [anon_sym_namespace] = ACTIONS(3303),
    [anon_sym_class] = ACTIONS(3303),
    [anon_sym_ref] = ACTIONS(3303),
    [anon_sym_struct] = ACTIONS(3303),
    [anon_sym_enum] = ACTIONS(3303),
    [anon_sym_LBRACE] = ACTIONS(3305),
    [anon_sym_interface] = ACTIONS(3303),
    [anon_sym_delegate] = ACTIONS(3303),
    [anon_sym_record] = ACTIONS(3303),
    [anon_sym_abstract] = ACTIONS(3303),
    [anon_sym_async] = ACTIONS(3303),
    [anon_sym_const] = ACTIONS(3303),
    [anon_sym_file] = ACTIONS(3303),
    [anon_sym_fixed] = ACTIONS(3303),
    [anon_sym_internal] = ACTIONS(3303),
    [anon_sym_new] = ACTIONS(3303),
    [anon_sym_override] = ACTIONS(3303),
    [anon_sym_partial] = ACTIONS(3303),
    [anon_sym_private] = ACTIONS(3303),
    [anon_sym_protected] = ACTIONS(3303),
    [anon_sym_public] = ACTIONS(3303),
    [anon_sym_readonly] = ACTIONS(3303),
    [anon_sym_required] = ACTIONS(3303),
    [anon_sym_sealed] = ACTIONS(3303),
    [anon_sym_virtual] = ACTIONS(3303),
    [anon_sym_volatile] = ACTIONS(3303),
    [anon_sym_where] = ACTIONS(3303),
    [anon_sym_notnull] = ACTIONS(3303),
    [anon_sym_unmanaged] = ACTIONS(3303),
    [anon_sym_checked] = ACTIONS(3303),
    [anon_sym_BANG] = ACTIONS(3305),
    [anon_sym_TILDE] = ACTIONS(3305),
    [anon_sym_PLUS_PLUS] = ACTIONS(3305),
    [anon_sym_DASH_DASH] = ACTIONS(3305),
    [anon_sym_true] = ACTIONS(3303),
    [anon_sym_false] = ACTIONS(3303),
    [anon_sym_PLUS] = ACTIONS(3303),
    [anon_sym_DASH] = ACTIONS(3303),
    [anon_sym_STAR] = ACTIONS(3305),
    [anon_sym_CARET] = ACTIONS(3305),
    [anon_sym_AMP] = ACTIONS(3305),
    [anon_sym_this] = ACTIONS(3303),
    [anon_sym_scoped] = ACTIONS(3303),
    [anon_sym_var] = ACTIONS(3303),
    [sym_predefined_type] = ACTIONS(3303),
    [anon_sym_break] = ACTIONS(3303),
    [anon_sym_unchecked] = ACTIONS(3303),
    [anon_sym_continue] = ACTIONS(3303),
    [anon_sym_do] = ACTIONS(3303),
    [anon_sym_while] = ACTIONS(3303),
    [anon_sym_for] = ACTIONS(3303),
    [anon_sym_lock] = ACTIONS(3303),
    [anon_sym_yield] = ACTIONS(3303),
    [anon_sym_switch] = ACTIONS(3303),
    [anon_sym_default] = ACTIONS(3303),
    [anon_sym_throw] = ACTIONS(3303),
    [anon_sym_try] = ACTIONS(3303),
    [anon_sym_when] = ACTIONS(3303),
    [anon_sym_await] = ACTIONS(3303),
    [anon_sym_foreach] = ACTIONS(3303),
    [anon_sym_goto] = ACTIONS(3303),
    [anon_sym_if] = ACTIONS(3303),
    [anon_sym_else] = ACTIONS(3303),
    [anon_sym_DOT_DOT] = ACTIONS(3305),
    [anon_sym_from] = ACTIONS(3303),
    [anon_sym_into] = ACTIONS(3303),
    [anon_sym_join] = ACTIONS(3303),
    [anon_sym_on] = ACTIONS(3303),
    [anon_sym_equals] = ACTIONS(3303),
    [anon_sym_let] = ACTIONS(3303),
    [anon_sym_orderby] = ACTIONS(3303),
    [anon_sym_ascending] = ACTIONS(3303),
    [anon_sym_descending] = ACTIONS(3303),
    [anon_sym_group] = ACTIONS(3303),
    [anon_sym_by] = ACTIONS(3303),
    [anon_sym_select] = ACTIONS(3303),
    [anon_sym_DQUOTE] = ACTIONS(3303),
    [anon_sym_stackalloc] = ACTIONS(3303),
    [anon_sym_sizeof] = ACTIONS(3303),
    [anon_sym_typeof] = ACTIONS(3303),
    [anon_sym___makeref] = ACTIONS(3303),
    [anon_sym___reftype] = ACTIONS(3303),
    [anon_sym___refvalue] = ACTIONS(3303),
    [sym_null_literal] = ACTIONS(3303),
    [anon_sym_SQUOTE] = ACTIONS(3305),
    [sym_integer_literal] = ACTIONS(3303),
    [sym_real_literal] = ACTIONS(3305),
    [sym_verbatim_string_literal] = ACTIONS(3305),
    [sym_raw_string_literal] = ACTIONS(3305),
    [aux_sym_preproc_if_token1] = ACTIONS(3305),
    [aux_sym_preproc_if_token3] = ACTIONS(3305),
    [aux_sym_preproc_else_token1] = ACTIONS(3305),
    [aux_sym_preproc_elif_token1] = ACTIONS(3305),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3305),
    [sym_interpolation_verbatim_start] = ACTIONS(3305),
    [sym_interpolation_raw_start] = ACTIONS(3305),
  },
  [2265] = {
    [sym_preproc_region] = STATE(2265),
    [sym_preproc_endregion] = STATE(2265),
    [sym_preproc_line] = STATE(2265),
    [sym_preproc_pragma] = STATE(2265),
    [sym_preproc_nullable] = STATE(2265),
    [sym_preproc_error] = STATE(2265),
    [sym_preproc_define] = STATE(2265),
    [sym_preproc_undef] = STATE(2265),
    [sym__identifier_token] = ACTIONS(3307),
    [anon_sym_extern] = ACTIONS(3307),
    [anon_sym_alias] = ACTIONS(3307),
    [anon_sym_SEMI] = ACTIONS(3309),
    [anon_sym_global] = ACTIONS(3307),
    [anon_sym_using] = ACTIONS(3307),
    [anon_sym_unsafe] = ACTIONS(3307),
    [anon_sym_static] = ACTIONS(3307),
    [anon_sym_LBRACK] = ACTIONS(3309),
    [anon_sym_LPAREN] = ACTIONS(3309),
    [anon_sym_return] = ACTIONS(3307),
    [anon_sym_namespace] = ACTIONS(3307),
    [anon_sym_class] = ACTIONS(3307),
    [anon_sym_ref] = ACTIONS(3307),
    [anon_sym_struct] = ACTIONS(3307),
    [anon_sym_enum] = ACTIONS(3307),
    [anon_sym_LBRACE] = ACTIONS(3309),
    [anon_sym_interface] = ACTIONS(3307),
    [anon_sym_delegate] = ACTIONS(3307),
    [anon_sym_record] = ACTIONS(3307),
    [anon_sym_abstract] = ACTIONS(3307),
    [anon_sym_async] = ACTIONS(3307),
    [anon_sym_const] = ACTIONS(3307),
    [anon_sym_file] = ACTIONS(3307),
    [anon_sym_fixed] = ACTIONS(3307),
    [anon_sym_internal] = ACTIONS(3307),
    [anon_sym_new] = ACTIONS(3307),
    [anon_sym_override] = ACTIONS(3307),
    [anon_sym_partial] = ACTIONS(3307),
    [anon_sym_private] = ACTIONS(3307),
    [anon_sym_protected] = ACTIONS(3307),
    [anon_sym_public] = ACTIONS(3307),
    [anon_sym_readonly] = ACTIONS(3307),
    [anon_sym_required] = ACTIONS(3307),
    [anon_sym_sealed] = ACTIONS(3307),
    [anon_sym_virtual] = ACTIONS(3307),
    [anon_sym_volatile] = ACTIONS(3307),
    [anon_sym_where] = ACTIONS(3307),
    [anon_sym_notnull] = ACTIONS(3307),
    [anon_sym_unmanaged] = ACTIONS(3307),
    [anon_sym_checked] = ACTIONS(3307),
    [anon_sym_BANG] = ACTIONS(3309),
    [anon_sym_TILDE] = ACTIONS(3309),
    [anon_sym_PLUS_PLUS] = ACTIONS(3309),
    [anon_sym_DASH_DASH] = ACTIONS(3309),
    [anon_sym_true] = ACTIONS(3307),
    [anon_sym_false] = ACTIONS(3307),
    [anon_sym_PLUS] = ACTIONS(3307),
    [anon_sym_DASH] = ACTIONS(3307),
    [anon_sym_STAR] = ACTIONS(3309),
    [anon_sym_CARET] = ACTIONS(3309),
    [anon_sym_AMP] = ACTIONS(3309),
    [anon_sym_this] = ACTIONS(3307),
    [anon_sym_scoped] = ACTIONS(3307),
    [anon_sym_var] = ACTIONS(3307),
    [sym_predefined_type] = ACTIONS(3307),
    [anon_sym_break] = ACTIONS(3307),
    [anon_sym_unchecked] = ACTIONS(3307),
    [anon_sym_continue] = ACTIONS(3307),
    [anon_sym_do] = ACTIONS(3307),
    [anon_sym_while] = ACTIONS(3307),
    [anon_sym_for] = ACTIONS(3307),
    [anon_sym_lock] = ACTIONS(3307),
    [anon_sym_yield] = ACTIONS(3307),
    [anon_sym_switch] = ACTIONS(3307),
    [anon_sym_default] = ACTIONS(3307),
    [anon_sym_throw] = ACTIONS(3307),
    [anon_sym_try] = ACTIONS(3307),
    [anon_sym_when] = ACTIONS(3307),
    [anon_sym_await] = ACTIONS(3307),
    [anon_sym_foreach] = ACTIONS(3307),
    [anon_sym_goto] = ACTIONS(3307),
    [anon_sym_if] = ACTIONS(3307),
    [anon_sym_else] = ACTIONS(3307),
    [anon_sym_DOT_DOT] = ACTIONS(3309),
    [anon_sym_from] = ACTIONS(3307),
    [anon_sym_into] = ACTIONS(3307),
    [anon_sym_join] = ACTIONS(3307),
    [anon_sym_on] = ACTIONS(3307),
    [anon_sym_equals] = ACTIONS(3307),
    [anon_sym_let] = ACTIONS(3307),
    [anon_sym_orderby] = ACTIONS(3307),
    [anon_sym_ascending] = ACTIONS(3307),
    [anon_sym_descending] = ACTIONS(3307),
    [anon_sym_group] = ACTIONS(3307),
    [anon_sym_by] = ACTIONS(3307),
    [anon_sym_select] = ACTIONS(3307),
    [anon_sym_DQUOTE] = ACTIONS(3307),
    [anon_sym_stackalloc] = ACTIONS(3307),
    [anon_sym_sizeof] = ACTIONS(3307),
    [anon_sym_typeof] = ACTIONS(3307),
    [anon_sym___makeref] = ACTIONS(3307),
    [anon_sym___reftype] = ACTIONS(3307),
    [anon_sym___refvalue] = ACTIONS(3307),
    [sym_null_literal] = ACTIONS(3307),
    [anon_sym_SQUOTE] = ACTIONS(3309),
    [sym_integer_literal] = ACTIONS(3307),
    [sym_real_literal] = ACTIONS(3309),
    [sym_verbatim_string_literal] = ACTIONS(3309),
    [sym_raw_string_literal] = ACTIONS(3309),
    [aux_sym_preproc_if_token1] = ACTIONS(3309),
    [aux_sym_preproc_if_token3] = ACTIONS(3309),
    [aux_sym_preproc_else_token1] = ACTIONS(3309),
    [aux_sym_preproc_elif_token1] = ACTIONS(3309),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3309),
    [sym_interpolation_verbatim_start] = ACTIONS(3309),
    [sym_interpolation_raw_start] = ACTIONS(3309),
  },
  [2266] = {
    [sym_preproc_region] = STATE(2266),
    [sym_preproc_endregion] = STATE(2266),
    [sym_preproc_line] = STATE(2266),
    [sym_preproc_pragma] = STATE(2266),
    [sym_preproc_nullable] = STATE(2266),
    [sym_preproc_error] = STATE(2266),
    [sym_preproc_define] = STATE(2266),
    [sym_preproc_undef] = STATE(2266),
    [sym__identifier_token] = ACTIONS(3311),
    [anon_sym_extern] = ACTIONS(3311),
    [anon_sym_alias] = ACTIONS(3311),
    [anon_sym_SEMI] = ACTIONS(3313),
    [anon_sym_global] = ACTIONS(3311),
    [anon_sym_using] = ACTIONS(3311),
    [anon_sym_unsafe] = ACTIONS(3311),
    [anon_sym_static] = ACTIONS(3311),
    [anon_sym_LBRACK] = ACTIONS(3313),
    [anon_sym_LPAREN] = ACTIONS(3313),
    [anon_sym_return] = ACTIONS(3311),
    [anon_sym_namespace] = ACTIONS(3311),
    [anon_sym_class] = ACTIONS(3311),
    [anon_sym_ref] = ACTIONS(3311),
    [anon_sym_struct] = ACTIONS(3311),
    [anon_sym_enum] = ACTIONS(3311),
    [anon_sym_LBRACE] = ACTIONS(3313),
    [anon_sym_interface] = ACTIONS(3311),
    [anon_sym_delegate] = ACTIONS(3311),
    [anon_sym_record] = ACTIONS(3311),
    [anon_sym_abstract] = ACTIONS(3311),
    [anon_sym_async] = ACTIONS(3311),
    [anon_sym_const] = ACTIONS(3311),
    [anon_sym_file] = ACTIONS(3311),
    [anon_sym_fixed] = ACTIONS(3311),
    [anon_sym_internal] = ACTIONS(3311),
    [anon_sym_new] = ACTIONS(3311),
    [anon_sym_override] = ACTIONS(3311),
    [anon_sym_partial] = ACTIONS(3311),
    [anon_sym_private] = ACTIONS(3311),
    [anon_sym_protected] = ACTIONS(3311),
    [anon_sym_public] = ACTIONS(3311),
    [anon_sym_readonly] = ACTIONS(3311),
    [anon_sym_required] = ACTIONS(3311),
    [anon_sym_sealed] = ACTIONS(3311),
    [anon_sym_virtual] = ACTIONS(3311),
    [anon_sym_volatile] = ACTIONS(3311),
    [anon_sym_where] = ACTIONS(3311),
    [anon_sym_notnull] = ACTIONS(3311),
    [anon_sym_unmanaged] = ACTIONS(3311),
    [anon_sym_checked] = ACTIONS(3311),
    [anon_sym_BANG] = ACTIONS(3313),
    [anon_sym_TILDE] = ACTIONS(3313),
    [anon_sym_PLUS_PLUS] = ACTIONS(3313),
    [anon_sym_DASH_DASH] = ACTIONS(3313),
    [anon_sym_true] = ACTIONS(3311),
    [anon_sym_false] = ACTIONS(3311),
    [anon_sym_PLUS] = ACTIONS(3311),
    [anon_sym_DASH] = ACTIONS(3311),
    [anon_sym_STAR] = ACTIONS(3313),
    [anon_sym_CARET] = ACTIONS(3313),
    [anon_sym_AMP] = ACTIONS(3313),
    [anon_sym_this] = ACTIONS(3311),
    [anon_sym_scoped] = ACTIONS(3311),
    [anon_sym_var] = ACTIONS(3311),
    [sym_predefined_type] = ACTIONS(3311),
    [anon_sym_break] = ACTIONS(3311),
    [anon_sym_unchecked] = ACTIONS(3311),
    [anon_sym_continue] = ACTIONS(3311),
    [anon_sym_do] = ACTIONS(3311),
    [anon_sym_while] = ACTIONS(3311),
    [anon_sym_for] = ACTIONS(3311),
    [anon_sym_lock] = ACTIONS(3311),
    [anon_sym_yield] = ACTIONS(3311),
    [anon_sym_switch] = ACTIONS(3311),
    [anon_sym_default] = ACTIONS(3311),
    [anon_sym_throw] = ACTIONS(3311),
    [anon_sym_try] = ACTIONS(3311),
    [anon_sym_when] = ACTIONS(3311),
    [anon_sym_await] = ACTIONS(3311),
    [anon_sym_foreach] = ACTIONS(3311),
    [anon_sym_goto] = ACTIONS(3311),
    [anon_sym_if] = ACTIONS(3311),
    [anon_sym_else] = ACTIONS(3311),
    [anon_sym_DOT_DOT] = ACTIONS(3313),
    [anon_sym_from] = ACTIONS(3311),
    [anon_sym_into] = ACTIONS(3311),
    [anon_sym_join] = ACTIONS(3311),
    [anon_sym_on] = ACTIONS(3311),
    [anon_sym_equals] = ACTIONS(3311),
    [anon_sym_let] = ACTIONS(3311),
    [anon_sym_orderby] = ACTIONS(3311),
    [anon_sym_ascending] = ACTIONS(3311),
    [anon_sym_descending] = ACTIONS(3311),
    [anon_sym_group] = ACTIONS(3311),
    [anon_sym_by] = ACTIONS(3311),
    [anon_sym_select] = ACTIONS(3311),
    [anon_sym_DQUOTE] = ACTIONS(3311),
    [anon_sym_stackalloc] = ACTIONS(3311),
    [anon_sym_sizeof] = ACTIONS(3311),
    [anon_sym_typeof] = ACTIONS(3311),
    [anon_sym___makeref] = ACTIONS(3311),
    [anon_sym___reftype] = ACTIONS(3311),
    [anon_sym___refvalue] = ACTIONS(3311),
    [sym_null_literal] = ACTIONS(3311),
    [anon_sym_SQUOTE] = ACTIONS(3313),
    [sym_integer_literal] = ACTIONS(3311),
    [sym_real_literal] = ACTIONS(3313),
    [sym_verbatim_string_literal] = ACTIONS(3313),
    [sym_raw_string_literal] = ACTIONS(3313),
    [aux_sym_preproc_if_token1] = ACTIONS(3313),
    [aux_sym_preproc_if_token3] = ACTIONS(3313),
    [aux_sym_preproc_else_token1] = ACTIONS(3313),
    [aux_sym_preproc_elif_token1] = ACTIONS(3313),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3313),
    [sym_interpolation_verbatim_start] = ACTIONS(3313),
    [sym_interpolation_raw_start] = ACTIONS(3313),
  },
  [2267] = {
    [sym_preproc_region] = STATE(2267),
    [sym_preproc_endregion] = STATE(2267),
    [sym_preproc_line] = STATE(2267),
    [sym_preproc_pragma] = STATE(2267),
    [sym_preproc_nullable] = STATE(2267),
    [sym_preproc_error] = STATE(2267),
    [sym_preproc_define] = STATE(2267),
    [sym_preproc_undef] = STATE(2267),
    [sym__identifier_token] = ACTIONS(3315),
    [anon_sym_extern] = ACTIONS(3315),
    [anon_sym_alias] = ACTIONS(3315),
    [anon_sym_SEMI] = ACTIONS(3317),
    [anon_sym_global] = ACTIONS(3315),
    [anon_sym_using] = ACTIONS(3315),
    [anon_sym_unsafe] = ACTIONS(3315),
    [anon_sym_static] = ACTIONS(3315),
    [anon_sym_LBRACK] = ACTIONS(3317),
    [anon_sym_LPAREN] = ACTIONS(3317),
    [anon_sym_return] = ACTIONS(3315),
    [anon_sym_namespace] = ACTIONS(3315),
    [anon_sym_class] = ACTIONS(3315),
    [anon_sym_ref] = ACTIONS(3315),
    [anon_sym_struct] = ACTIONS(3315),
    [anon_sym_enum] = ACTIONS(3315),
    [anon_sym_LBRACE] = ACTIONS(3317),
    [anon_sym_interface] = ACTIONS(3315),
    [anon_sym_delegate] = ACTIONS(3315),
    [anon_sym_record] = ACTIONS(3315),
    [anon_sym_abstract] = ACTIONS(3315),
    [anon_sym_async] = ACTIONS(3315),
    [anon_sym_const] = ACTIONS(3315),
    [anon_sym_file] = ACTIONS(3315),
    [anon_sym_fixed] = ACTIONS(3315),
    [anon_sym_internal] = ACTIONS(3315),
    [anon_sym_new] = ACTIONS(3315),
    [anon_sym_override] = ACTIONS(3315),
    [anon_sym_partial] = ACTIONS(3315),
    [anon_sym_private] = ACTIONS(3315),
    [anon_sym_protected] = ACTIONS(3315),
    [anon_sym_public] = ACTIONS(3315),
    [anon_sym_readonly] = ACTIONS(3315),
    [anon_sym_required] = ACTIONS(3315),
    [anon_sym_sealed] = ACTIONS(3315),
    [anon_sym_virtual] = ACTIONS(3315),
    [anon_sym_volatile] = ACTIONS(3315),
    [anon_sym_where] = ACTIONS(3315),
    [anon_sym_notnull] = ACTIONS(3315),
    [anon_sym_unmanaged] = ACTIONS(3315),
    [anon_sym_checked] = ACTIONS(3315),
    [anon_sym_BANG] = ACTIONS(3317),
    [anon_sym_TILDE] = ACTIONS(3317),
    [anon_sym_PLUS_PLUS] = ACTIONS(3317),
    [anon_sym_DASH_DASH] = ACTIONS(3317),
    [anon_sym_true] = ACTIONS(3315),
    [anon_sym_false] = ACTIONS(3315),
    [anon_sym_PLUS] = ACTIONS(3315),
    [anon_sym_DASH] = ACTIONS(3315),
    [anon_sym_STAR] = ACTIONS(3317),
    [anon_sym_CARET] = ACTIONS(3317),
    [anon_sym_AMP] = ACTIONS(3317),
    [anon_sym_this] = ACTIONS(3315),
    [anon_sym_scoped] = ACTIONS(3315),
    [anon_sym_var] = ACTIONS(3315),
    [sym_predefined_type] = ACTIONS(3315),
    [anon_sym_break] = ACTIONS(3315),
    [anon_sym_unchecked] = ACTIONS(3315),
    [anon_sym_continue] = ACTIONS(3315),
    [anon_sym_do] = ACTIONS(3315),
    [anon_sym_while] = ACTIONS(3315),
    [anon_sym_for] = ACTIONS(3315),
    [anon_sym_lock] = ACTIONS(3315),
    [anon_sym_yield] = ACTIONS(3315),
    [anon_sym_switch] = ACTIONS(3315),
    [anon_sym_default] = ACTIONS(3315),
    [anon_sym_throw] = ACTIONS(3315),
    [anon_sym_try] = ACTIONS(3315),
    [anon_sym_when] = ACTIONS(3315),
    [anon_sym_await] = ACTIONS(3315),
    [anon_sym_foreach] = ACTIONS(3315),
    [anon_sym_goto] = ACTIONS(3315),
    [anon_sym_if] = ACTIONS(3315),
    [anon_sym_else] = ACTIONS(3315),
    [anon_sym_DOT_DOT] = ACTIONS(3317),
    [anon_sym_from] = ACTIONS(3315),
    [anon_sym_into] = ACTIONS(3315),
    [anon_sym_join] = ACTIONS(3315),
    [anon_sym_on] = ACTIONS(3315),
    [anon_sym_equals] = ACTIONS(3315),
    [anon_sym_let] = ACTIONS(3315),
    [anon_sym_orderby] = ACTIONS(3315),
    [anon_sym_ascending] = ACTIONS(3315),
    [anon_sym_descending] = ACTIONS(3315),
    [anon_sym_group] = ACTIONS(3315),
    [anon_sym_by] = ACTIONS(3315),
    [anon_sym_select] = ACTIONS(3315),
    [anon_sym_DQUOTE] = ACTIONS(3315),
    [anon_sym_stackalloc] = ACTIONS(3315),
    [anon_sym_sizeof] = ACTIONS(3315),
    [anon_sym_typeof] = ACTIONS(3315),
    [anon_sym___makeref] = ACTIONS(3315),
    [anon_sym___reftype] = ACTIONS(3315),
    [anon_sym___refvalue] = ACTIONS(3315),
    [sym_null_literal] = ACTIONS(3315),
    [anon_sym_SQUOTE] = ACTIONS(3317),
    [sym_integer_literal] = ACTIONS(3315),
    [sym_real_literal] = ACTIONS(3317),
    [sym_verbatim_string_literal] = ACTIONS(3317),
    [sym_raw_string_literal] = ACTIONS(3317),
    [aux_sym_preproc_if_token1] = ACTIONS(3317),
    [aux_sym_preproc_if_token3] = ACTIONS(3317),
    [aux_sym_preproc_else_token1] = ACTIONS(3317),
    [aux_sym_preproc_elif_token1] = ACTIONS(3317),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3317),
    [sym_interpolation_verbatim_start] = ACTIONS(3317),
    [sym_interpolation_raw_start] = ACTIONS(3317),
  },
  [2268] = {
    [sym_preproc_region] = STATE(2268),
    [sym_preproc_endregion] = STATE(2268),
    [sym_preproc_line] = STATE(2268),
    [sym_preproc_pragma] = STATE(2268),
    [sym_preproc_nullable] = STATE(2268),
    [sym_preproc_error] = STATE(2268),
    [sym_preproc_define] = STATE(2268),
    [sym_preproc_undef] = STATE(2268),
    [sym__identifier_token] = ACTIONS(3319),
    [anon_sym_extern] = ACTIONS(3319),
    [anon_sym_alias] = ACTIONS(3319),
    [anon_sym_SEMI] = ACTIONS(3321),
    [anon_sym_global] = ACTIONS(3319),
    [anon_sym_using] = ACTIONS(3319),
    [anon_sym_unsafe] = ACTIONS(3319),
    [anon_sym_static] = ACTIONS(3319),
    [anon_sym_LBRACK] = ACTIONS(3321),
    [anon_sym_LPAREN] = ACTIONS(3321),
    [anon_sym_return] = ACTIONS(3319),
    [anon_sym_namespace] = ACTIONS(3319),
    [anon_sym_class] = ACTIONS(3319),
    [anon_sym_ref] = ACTIONS(3319),
    [anon_sym_struct] = ACTIONS(3319),
    [anon_sym_enum] = ACTIONS(3319),
    [anon_sym_LBRACE] = ACTIONS(3321),
    [anon_sym_interface] = ACTIONS(3319),
    [anon_sym_delegate] = ACTIONS(3319),
    [anon_sym_record] = ACTIONS(3319),
    [anon_sym_abstract] = ACTIONS(3319),
    [anon_sym_async] = ACTIONS(3319),
    [anon_sym_const] = ACTIONS(3319),
    [anon_sym_file] = ACTIONS(3319),
    [anon_sym_fixed] = ACTIONS(3319),
    [anon_sym_internal] = ACTIONS(3319),
    [anon_sym_new] = ACTIONS(3319),
    [anon_sym_override] = ACTIONS(3319),
    [anon_sym_partial] = ACTIONS(3319),
    [anon_sym_private] = ACTIONS(3319),
    [anon_sym_protected] = ACTIONS(3319),
    [anon_sym_public] = ACTIONS(3319),
    [anon_sym_readonly] = ACTIONS(3319),
    [anon_sym_required] = ACTIONS(3319),
    [anon_sym_sealed] = ACTIONS(3319),
    [anon_sym_virtual] = ACTIONS(3319),
    [anon_sym_volatile] = ACTIONS(3319),
    [anon_sym_where] = ACTIONS(3319),
    [anon_sym_notnull] = ACTIONS(3319),
    [anon_sym_unmanaged] = ACTIONS(3319),
    [anon_sym_checked] = ACTIONS(3319),
    [anon_sym_BANG] = ACTIONS(3321),
    [anon_sym_TILDE] = ACTIONS(3321),
    [anon_sym_PLUS_PLUS] = ACTIONS(3321),
    [anon_sym_DASH_DASH] = ACTIONS(3321),
    [anon_sym_true] = ACTIONS(3319),
    [anon_sym_false] = ACTIONS(3319),
    [anon_sym_PLUS] = ACTIONS(3319),
    [anon_sym_DASH] = ACTIONS(3319),
    [anon_sym_STAR] = ACTIONS(3321),
    [anon_sym_CARET] = ACTIONS(3321),
    [anon_sym_AMP] = ACTIONS(3321),
    [anon_sym_this] = ACTIONS(3319),
    [anon_sym_scoped] = ACTIONS(3319),
    [anon_sym_var] = ACTIONS(3319),
    [sym_predefined_type] = ACTIONS(3319),
    [anon_sym_break] = ACTIONS(3319),
    [anon_sym_unchecked] = ACTIONS(3319),
    [anon_sym_continue] = ACTIONS(3319),
    [anon_sym_do] = ACTIONS(3319),
    [anon_sym_while] = ACTIONS(3319),
    [anon_sym_for] = ACTIONS(3319),
    [anon_sym_lock] = ACTIONS(3319),
    [anon_sym_yield] = ACTIONS(3319),
    [anon_sym_switch] = ACTIONS(3319),
    [anon_sym_default] = ACTIONS(3319),
    [anon_sym_throw] = ACTIONS(3319),
    [anon_sym_try] = ACTIONS(3319),
    [anon_sym_when] = ACTIONS(3319),
    [anon_sym_await] = ACTIONS(3319),
    [anon_sym_foreach] = ACTIONS(3319),
    [anon_sym_goto] = ACTIONS(3319),
    [anon_sym_if] = ACTIONS(3319),
    [anon_sym_else] = ACTIONS(3319),
    [anon_sym_DOT_DOT] = ACTIONS(3321),
    [anon_sym_from] = ACTIONS(3319),
    [anon_sym_into] = ACTIONS(3319),
    [anon_sym_join] = ACTIONS(3319),
    [anon_sym_on] = ACTIONS(3319),
    [anon_sym_equals] = ACTIONS(3319),
    [anon_sym_let] = ACTIONS(3319),
    [anon_sym_orderby] = ACTIONS(3319),
    [anon_sym_ascending] = ACTIONS(3319),
    [anon_sym_descending] = ACTIONS(3319),
    [anon_sym_group] = ACTIONS(3319),
    [anon_sym_by] = ACTIONS(3319),
    [anon_sym_select] = ACTIONS(3319),
    [anon_sym_DQUOTE] = ACTIONS(3319),
    [anon_sym_stackalloc] = ACTIONS(3319),
    [anon_sym_sizeof] = ACTIONS(3319),
    [anon_sym_typeof] = ACTIONS(3319),
    [anon_sym___makeref] = ACTIONS(3319),
    [anon_sym___reftype] = ACTIONS(3319),
    [anon_sym___refvalue] = ACTIONS(3319),
    [sym_null_literal] = ACTIONS(3319),
    [anon_sym_SQUOTE] = ACTIONS(3321),
    [sym_integer_literal] = ACTIONS(3319),
    [sym_real_literal] = ACTIONS(3321),
    [sym_verbatim_string_literal] = ACTIONS(3321),
    [sym_raw_string_literal] = ACTIONS(3321),
    [aux_sym_preproc_if_token1] = ACTIONS(3321),
    [aux_sym_preproc_if_token3] = ACTIONS(3321),
    [aux_sym_preproc_else_token1] = ACTIONS(3321),
    [aux_sym_preproc_elif_token1] = ACTIONS(3321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3321),
    [sym_interpolation_verbatim_start] = ACTIONS(3321),
    [sym_interpolation_raw_start] = ACTIONS(3321),
  },
  [2269] = {
    [sym_preproc_region] = STATE(2269),
    [sym_preproc_endregion] = STATE(2269),
    [sym_preproc_line] = STATE(2269),
    [sym_preproc_pragma] = STATE(2269),
    [sym_preproc_nullable] = STATE(2269),
    [sym_preproc_error] = STATE(2269),
    [sym_preproc_define] = STATE(2269),
    [sym_preproc_undef] = STATE(2269),
    [sym__identifier_token] = ACTIONS(3323),
    [anon_sym_extern] = ACTIONS(3323),
    [anon_sym_alias] = ACTIONS(3323),
    [anon_sym_SEMI] = ACTIONS(3325),
    [anon_sym_global] = ACTIONS(3323),
    [anon_sym_using] = ACTIONS(3323),
    [anon_sym_unsafe] = ACTIONS(3323),
    [anon_sym_static] = ACTIONS(3323),
    [anon_sym_LBRACK] = ACTIONS(3325),
    [anon_sym_LPAREN] = ACTIONS(3325),
    [anon_sym_return] = ACTIONS(3323),
    [anon_sym_namespace] = ACTIONS(3323),
    [anon_sym_class] = ACTIONS(3323),
    [anon_sym_ref] = ACTIONS(3323),
    [anon_sym_struct] = ACTIONS(3323),
    [anon_sym_enum] = ACTIONS(3323),
    [anon_sym_LBRACE] = ACTIONS(3325),
    [anon_sym_interface] = ACTIONS(3323),
    [anon_sym_delegate] = ACTIONS(3323),
    [anon_sym_record] = ACTIONS(3323),
    [anon_sym_abstract] = ACTIONS(3323),
    [anon_sym_async] = ACTIONS(3323),
    [anon_sym_const] = ACTIONS(3323),
    [anon_sym_file] = ACTIONS(3323),
    [anon_sym_fixed] = ACTIONS(3323),
    [anon_sym_internal] = ACTIONS(3323),
    [anon_sym_new] = ACTIONS(3323),
    [anon_sym_override] = ACTIONS(3323),
    [anon_sym_partial] = ACTIONS(3323),
    [anon_sym_private] = ACTIONS(3323),
    [anon_sym_protected] = ACTIONS(3323),
    [anon_sym_public] = ACTIONS(3323),
    [anon_sym_readonly] = ACTIONS(3323),
    [anon_sym_required] = ACTIONS(3323),
    [anon_sym_sealed] = ACTIONS(3323),
    [anon_sym_virtual] = ACTIONS(3323),
    [anon_sym_volatile] = ACTIONS(3323),
    [anon_sym_where] = ACTIONS(3323),
    [anon_sym_notnull] = ACTIONS(3323),
    [anon_sym_unmanaged] = ACTIONS(3323),
    [anon_sym_checked] = ACTIONS(3323),
    [anon_sym_BANG] = ACTIONS(3325),
    [anon_sym_TILDE] = ACTIONS(3325),
    [anon_sym_PLUS_PLUS] = ACTIONS(3325),
    [anon_sym_DASH_DASH] = ACTIONS(3325),
    [anon_sym_true] = ACTIONS(3323),
    [anon_sym_false] = ACTIONS(3323),
    [anon_sym_PLUS] = ACTIONS(3323),
    [anon_sym_DASH] = ACTIONS(3323),
    [anon_sym_STAR] = ACTIONS(3325),
    [anon_sym_CARET] = ACTIONS(3325),
    [anon_sym_AMP] = ACTIONS(3325),
    [anon_sym_this] = ACTIONS(3323),
    [anon_sym_scoped] = ACTIONS(3323),
    [anon_sym_var] = ACTIONS(3323),
    [sym_predefined_type] = ACTIONS(3323),
    [anon_sym_break] = ACTIONS(3323),
    [anon_sym_unchecked] = ACTIONS(3323),
    [anon_sym_continue] = ACTIONS(3323),
    [anon_sym_do] = ACTIONS(3323),
    [anon_sym_while] = ACTIONS(3323),
    [anon_sym_for] = ACTIONS(3323),
    [anon_sym_lock] = ACTIONS(3323),
    [anon_sym_yield] = ACTIONS(3323),
    [anon_sym_switch] = ACTIONS(3323),
    [anon_sym_default] = ACTIONS(3323),
    [anon_sym_throw] = ACTIONS(3323),
    [anon_sym_try] = ACTIONS(3323),
    [anon_sym_when] = ACTIONS(3323),
    [anon_sym_await] = ACTIONS(3323),
    [anon_sym_foreach] = ACTIONS(3323),
    [anon_sym_goto] = ACTIONS(3323),
    [anon_sym_if] = ACTIONS(3323),
    [anon_sym_else] = ACTIONS(3323),
    [anon_sym_DOT_DOT] = ACTIONS(3325),
    [anon_sym_from] = ACTIONS(3323),
    [anon_sym_into] = ACTIONS(3323),
    [anon_sym_join] = ACTIONS(3323),
    [anon_sym_on] = ACTIONS(3323),
    [anon_sym_equals] = ACTIONS(3323),
    [anon_sym_let] = ACTIONS(3323),
    [anon_sym_orderby] = ACTIONS(3323),
    [anon_sym_ascending] = ACTIONS(3323),
    [anon_sym_descending] = ACTIONS(3323),
    [anon_sym_group] = ACTIONS(3323),
    [anon_sym_by] = ACTIONS(3323),
    [anon_sym_select] = ACTIONS(3323),
    [anon_sym_DQUOTE] = ACTIONS(3323),
    [anon_sym_stackalloc] = ACTIONS(3323),
    [anon_sym_sizeof] = ACTIONS(3323),
    [anon_sym_typeof] = ACTIONS(3323),
    [anon_sym___makeref] = ACTIONS(3323),
    [anon_sym___reftype] = ACTIONS(3323),
    [anon_sym___refvalue] = ACTIONS(3323),
    [sym_null_literal] = ACTIONS(3323),
    [anon_sym_SQUOTE] = ACTIONS(3325),
    [sym_integer_literal] = ACTIONS(3323),
    [sym_real_literal] = ACTIONS(3325),
    [sym_verbatim_string_literal] = ACTIONS(3325),
    [sym_raw_string_literal] = ACTIONS(3325),
    [aux_sym_preproc_if_token1] = ACTIONS(3325),
    [aux_sym_preproc_if_token3] = ACTIONS(3325),
    [aux_sym_preproc_else_token1] = ACTIONS(3325),
    [aux_sym_preproc_elif_token1] = ACTIONS(3325),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3325),
    [sym_interpolation_verbatim_start] = ACTIONS(3325),
    [sym_interpolation_raw_start] = ACTIONS(3325),
  },
  [2270] = {
    [sym_preproc_region] = STATE(2270),
    [sym_preproc_endregion] = STATE(2270),
    [sym_preproc_line] = STATE(2270),
    [sym_preproc_pragma] = STATE(2270),
    [sym_preproc_nullable] = STATE(2270),
    [sym_preproc_error] = STATE(2270),
    [sym_preproc_define] = STATE(2270),
    [sym_preproc_undef] = STATE(2270),
    [sym__identifier_token] = ACTIONS(3327),
    [anon_sym_extern] = ACTIONS(3327),
    [anon_sym_alias] = ACTIONS(3327),
    [anon_sym_SEMI] = ACTIONS(3329),
    [anon_sym_global] = ACTIONS(3327),
    [anon_sym_using] = ACTIONS(3327),
    [anon_sym_unsafe] = ACTIONS(3327),
    [anon_sym_static] = ACTIONS(3327),
    [anon_sym_LBRACK] = ACTIONS(3329),
    [anon_sym_LPAREN] = ACTIONS(3329),
    [anon_sym_return] = ACTIONS(3327),
    [anon_sym_namespace] = ACTIONS(3327),
    [anon_sym_class] = ACTIONS(3327),
    [anon_sym_ref] = ACTIONS(3327),
    [anon_sym_struct] = ACTIONS(3327),
    [anon_sym_enum] = ACTIONS(3327),
    [anon_sym_LBRACE] = ACTIONS(3329),
    [anon_sym_interface] = ACTIONS(3327),
    [anon_sym_delegate] = ACTIONS(3327),
    [anon_sym_record] = ACTIONS(3327),
    [anon_sym_abstract] = ACTIONS(3327),
    [anon_sym_async] = ACTIONS(3327),
    [anon_sym_const] = ACTIONS(3327),
    [anon_sym_file] = ACTIONS(3327),
    [anon_sym_fixed] = ACTIONS(3327),
    [anon_sym_internal] = ACTIONS(3327),
    [anon_sym_new] = ACTIONS(3327),
    [anon_sym_override] = ACTIONS(3327),
    [anon_sym_partial] = ACTIONS(3327),
    [anon_sym_private] = ACTIONS(3327),
    [anon_sym_protected] = ACTIONS(3327),
    [anon_sym_public] = ACTIONS(3327),
    [anon_sym_readonly] = ACTIONS(3327),
    [anon_sym_required] = ACTIONS(3327),
    [anon_sym_sealed] = ACTIONS(3327),
    [anon_sym_virtual] = ACTIONS(3327),
    [anon_sym_volatile] = ACTIONS(3327),
    [anon_sym_where] = ACTIONS(3327),
    [anon_sym_notnull] = ACTIONS(3327),
    [anon_sym_unmanaged] = ACTIONS(3327),
    [anon_sym_checked] = ACTIONS(3327),
    [anon_sym_BANG] = ACTIONS(3329),
    [anon_sym_TILDE] = ACTIONS(3329),
    [anon_sym_PLUS_PLUS] = ACTIONS(3329),
    [anon_sym_DASH_DASH] = ACTIONS(3329),
    [anon_sym_true] = ACTIONS(3327),
    [anon_sym_false] = ACTIONS(3327),
    [anon_sym_PLUS] = ACTIONS(3327),
    [anon_sym_DASH] = ACTIONS(3327),
    [anon_sym_STAR] = ACTIONS(3329),
    [anon_sym_CARET] = ACTIONS(3329),
    [anon_sym_AMP] = ACTIONS(3329),
    [anon_sym_this] = ACTIONS(3327),
    [anon_sym_scoped] = ACTIONS(3327),
    [anon_sym_var] = ACTIONS(3327),
    [sym_predefined_type] = ACTIONS(3327),
    [anon_sym_break] = ACTIONS(3327),
    [anon_sym_unchecked] = ACTIONS(3327),
    [anon_sym_continue] = ACTIONS(3327),
    [anon_sym_do] = ACTIONS(3327),
    [anon_sym_while] = ACTIONS(3327),
    [anon_sym_for] = ACTIONS(3327),
    [anon_sym_lock] = ACTIONS(3327),
    [anon_sym_yield] = ACTIONS(3327),
    [anon_sym_switch] = ACTIONS(3327),
    [anon_sym_default] = ACTIONS(3327),
    [anon_sym_throw] = ACTIONS(3327),
    [anon_sym_try] = ACTIONS(3327),
    [anon_sym_when] = ACTIONS(3327),
    [anon_sym_await] = ACTIONS(3327),
    [anon_sym_foreach] = ACTIONS(3327),
    [anon_sym_goto] = ACTIONS(3327),
    [anon_sym_if] = ACTIONS(3327),
    [anon_sym_else] = ACTIONS(3327),
    [anon_sym_DOT_DOT] = ACTIONS(3329),
    [anon_sym_from] = ACTIONS(3327),
    [anon_sym_into] = ACTIONS(3327),
    [anon_sym_join] = ACTIONS(3327),
    [anon_sym_on] = ACTIONS(3327),
    [anon_sym_equals] = ACTIONS(3327),
    [anon_sym_let] = ACTIONS(3327),
    [anon_sym_orderby] = ACTIONS(3327),
    [anon_sym_ascending] = ACTIONS(3327),
    [anon_sym_descending] = ACTIONS(3327),
    [anon_sym_group] = ACTIONS(3327),
    [anon_sym_by] = ACTIONS(3327),
    [anon_sym_select] = ACTIONS(3327),
    [anon_sym_DQUOTE] = ACTIONS(3327),
    [anon_sym_stackalloc] = ACTIONS(3327),
    [anon_sym_sizeof] = ACTIONS(3327),
    [anon_sym_typeof] = ACTIONS(3327),
    [anon_sym___makeref] = ACTIONS(3327),
    [anon_sym___reftype] = ACTIONS(3327),
    [anon_sym___refvalue] = ACTIONS(3327),
    [sym_null_literal] = ACTIONS(3327),
    [anon_sym_SQUOTE] = ACTIONS(3329),
    [sym_integer_literal] = ACTIONS(3327),
    [sym_real_literal] = ACTIONS(3329),
    [sym_verbatim_string_literal] = ACTIONS(3329),
    [sym_raw_string_literal] = ACTIONS(3329),
    [aux_sym_preproc_if_token1] = ACTIONS(3329),
    [aux_sym_preproc_if_token3] = ACTIONS(3329),
    [aux_sym_preproc_else_token1] = ACTIONS(3329),
    [aux_sym_preproc_elif_token1] = ACTIONS(3329),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3329),
    [sym_interpolation_verbatim_start] = ACTIONS(3329),
    [sym_interpolation_raw_start] = ACTIONS(3329),
  },
  [2271] = {
    [sym_preproc_region] = STATE(2271),
    [sym_preproc_endregion] = STATE(2271),
    [sym_preproc_line] = STATE(2271),
    [sym_preproc_pragma] = STATE(2271),
    [sym_preproc_nullable] = STATE(2271),
    [sym_preproc_error] = STATE(2271),
    [sym_preproc_define] = STATE(2271),
    [sym_preproc_undef] = STATE(2271),
    [sym__identifier_token] = ACTIONS(3331),
    [anon_sym_extern] = ACTIONS(3331),
    [anon_sym_alias] = ACTIONS(3331),
    [anon_sym_SEMI] = ACTIONS(3333),
    [anon_sym_global] = ACTIONS(3331),
    [anon_sym_using] = ACTIONS(3331),
    [anon_sym_unsafe] = ACTIONS(3331),
    [anon_sym_static] = ACTIONS(3331),
    [anon_sym_LBRACK] = ACTIONS(3333),
    [anon_sym_LPAREN] = ACTIONS(3333),
    [anon_sym_return] = ACTIONS(3331),
    [anon_sym_namespace] = ACTIONS(3331),
    [anon_sym_class] = ACTIONS(3331),
    [anon_sym_ref] = ACTIONS(3331),
    [anon_sym_struct] = ACTIONS(3331),
    [anon_sym_enum] = ACTIONS(3331),
    [anon_sym_LBRACE] = ACTIONS(3333),
    [anon_sym_interface] = ACTIONS(3331),
    [anon_sym_delegate] = ACTIONS(3331),
    [anon_sym_record] = ACTIONS(3331),
    [anon_sym_abstract] = ACTIONS(3331),
    [anon_sym_async] = ACTIONS(3331),
    [anon_sym_const] = ACTIONS(3331),
    [anon_sym_file] = ACTIONS(3331),
    [anon_sym_fixed] = ACTIONS(3331),
    [anon_sym_internal] = ACTIONS(3331),
    [anon_sym_new] = ACTIONS(3331),
    [anon_sym_override] = ACTIONS(3331),
    [anon_sym_partial] = ACTIONS(3331),
    [anon_sym_private] = ACTIONS(3331),
    [anon_sym_protected] = ACTIONS(3331),
    [anon_sym_public] = ACTIONS(3331),
    [anon_sym_readonly] = ACTIONS(3331),
    [anon_sym_required] = ACTIONS(3331),
    [anon_sym_sealed] = ACTIONS(3331),
    [anon_sym_virtual] = ACTIONS(3331),
    [anon_sym_volatile] = ACTIONS(3331),
    [anon_sym_where] = ACTIONS(3331),
    [anon_sym_notnull] = ACTIONS(3331),
    [anon_sym_unmanaged] = ACTIONS(3331),
    [anon_sym_checked] = ACTIONS(3331),
    [anon_sym_BANG] = ACTIONS(3333),
    [anon_sym_TILDE] = ACTIONS(3333),
    [anon_sym_PLUS_PLUS] = ACTIONS(3333),
    [anon_sym_DASH_DASH] = ACTIONS(3333),
    [anon_sym_true] = ACTIONS(3331),
    [anon_sym_false] = ACTIONS(3331),
    [anon_sym_PLUS] = ACTIONS(3331),
    [anon_sym_DASH] = ACTIONS(3331),
    [anon_sym_STAR] = ACTIONS(3333),
    [anon_sym_CARET] = ACTIONS(3333),
    [anon_sym_AMP] = ACTIONS(3333),
    [anon_sym_this] = ACTIONS(3331),
    [anon_sym_scoped] = ACTIONS(3331),
    [anon_sym_var] = ACTIONS(3331),
    [sym_predefined_type] = ACTIONS(3331),
    [anon_sym_break] = ACTIONS(3331),
    [anon_sym_unchecked] = ACTIONS(3331),
    [anon_sym_continue] = ACTIONS(3331),
    [anon_sym_do] = ACTIONS(3331),
    [anon_sym_while] = ACTIONS(3331),
    [anon_sym_for] = ACTIONS(3331),
    [anon_sym_lock] = ACTIONS(3331),
    [anon_sym_yield] = ACTIONS(3331),
    [anon_sym_switch] = ACTIONS(3331),
    [anon_sym_default] = ACTIONS(3331),
    [anon_sym_throw] = ACTIONS(3331),
    [anon_sym_try] = ACTIONS(3331),
    [anon_sym_when] = ACTIONS(3331),
    [anon_sym_await] = ACTIONS(3331),
    [anon_sym_foreach] = ACTIONS(3331),
    [anon_sym_goto] = ACTIONS(3331),
    [anon_sym_if] = ACTIONS(3331),
    [anon_sym_else] = ACTIONS(3331),
    [anon_sym_DOT_DOT] = ACTIONS(3333),
    [anon_sym_from] = ACTIONS(3331),
    [anon_sym_into] = ACTIONS(3331),
    [anon_sym_join] = ACTIONS(3331),
    [anon_sym_on] = ACTIONS(3331),
    [anon_sym_equals] = ACTIONS(3331),
    [anon_sym_let] = ACTIONS(3331),
    [anon_sym_orderby] = ACTIONS(3331),
    [anon_sym_ascending] = ACTIONS(3331),
    [anon_sym_descending] = ACTIONS(3331),
    [anon_sym_group] = ACTIONS(3331),
    [anon_sym_by] = ACTIONS(3331),
    [anon_sym_select] = ACTIONS(3331),
    [anon_sym_DQUOTE] = ACTIONS(3331),
    [anon_sym_stackalloc] = ACTIONS(3331),
    [anon_sym_sizeof] = ACTIONS(3331),
    [anon_sym_typeof] = ACTIONS(3331),
    [anon_sym___makeref] = ACTIONS(3331),
    [anon_sym___reftype] = ACTIONS(3331),
    [anon_sym___refvalue] = ACTIONS(3331),
    [sym_null_literal] = ACTIONS(3331),
    [anon_sym_SQUOTE] = ACTIONS(3333),
    [sym_integer_literal] = ACTIONS(3331),
    [sym_real_literal] = ACTIONS(3333),
    [sym_verbatim_string_literal] = ACTIONS(3333),
    [sym_raw_string_literal] = ACTIONS(3333),
    [aux_sym_preproc_if_token1] = ACTIONS(3333),
    [aux_sym_preproc_if_token3] = ACTIONS(3333),
    [aux_sym_preproc_else_token1] = ACTIONS(3333),
    [aux_sym_preproc_elif_token1] = ACTIONS(3333),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3333),
    [sym_interpolation_verbatim_start] = ACTIONS(3333),
    [sym_interpolation_raw_start] = ACTIONS(3333),
  },
  [2272] = {
    [sym_preproc_region] = STATE(2272),
    [sym_preproc_endregion] = STATE(2272),
    [sym_preproc_line] = STATE(2272),
    [sym_preproc_pragma] = STATE(2272),
    [sym_preproc_nullable] = STATE(2272),
    [sym_preproc_error] = STATE(2272),
    [sym_preproc_define] = STATE(2272),
    [sym_preproc_undef] = STATE(2272),
    [sym__identifier_token] = ACTIONS(3335),
    [anon_sym_extern] = ACTIONS(3335),
    [anon_sym_alias] = ACTIONS(3335),
    [anon_sym_SEMI] = ACTIONS(3337),
    [anon_sym_global] = ACTIONS(3335),
    [anon_sym_using] = ACTIONS(3335),
    [anon_sym_unsafe] = ACTIONS(3335),
    [anon_sym_static] = ACTIONS(3335),
    [anon_sym_LBRACK] = ACTIONS(3337),
    [anon_sym_LPAREN] = ACTIONS(3337),
    [anon_sym_return] = ACTIONS(3335),
    [anon_sym_namespace] = ACTIONS(3335),
    [anon_sym_class] = ACTIONS(3335),
    [anon_sym_ref] = ACTIONS(3335),
    [anon_sym_struct] = ACTIONS(3335),
    [anon_sym_enum] = ACTIONS(3335),
    [anon_sym_LBRACE] = ACTIONS(3337),
    [anon_sym_interface] = ACTIONS(3335),
    [anon_sym_delegate] = ACTIONS(3335),
    [anon_sym_record] = ACTIONS(3335),
    [anon_sym_abstract] = ACTIONS(3335),
    [anon_sym_async] = ACTIONS(3335),
    [anon_sym_const] = ACTIONS(3335),
    [anon_sym_file] = ACTIONS(3335),
    [anon_sym_fixed] = ACTIONS(3335),
    [anon_sym_internal] = ACTIONS(3335),
    [anon_sym_new] = ACTIONS(3335),
    [anon_sym_override] = ACTIONS(3335),
    [anon_sym_partial] = ACTIONS(3335),
    [anon_sym_private] = ACTIONS(3335),
    [anon_sym_protected] = ACTIONS(3335),
    [anon_sym_public] = ACTIONS(3335),
    [anon_sym_readonly] = ACTIONS(3335),
    [anon_sym_required] = ACTIONS(3335),
    [anon_sym_sealed] = ACTIONS(3335),
    [anon_sym_virtual] = ACTIONS(3335),
    [anon_sym_volatile] = ACTIONS(3335),
    [anon_sym_where] = ACTIONS(3335),
    [anon_sym_notnull] = ACTIONS(3335),
    [anon_sym_unmanaged] = ACTIONS(3335),
    [anon_sym_checked] = ACTIONS(3335),
    [anon_sym_BANG] = ACTIONS(3337),
    [anon_sym_TILDE] = ACTIONS(3337),
    [anon_sym_PLUS_PLUS] = ACTIONS(3337),
    [anon_sym_DASH_DASH] = ACTIONS(3337),
    [anon_sym_true] = ACTIONS(3335),
    [anon_sym_false] = ACTIONS(3335),
    [anon_sym_PLUS] = ACTIONS(3335),
    [anon_sym_DASH] = ACTIONS(3335),
    [anon_sym_STAR] = ACTIONS(3337),
    [anon_sym_CARET] = ACTIONS(3337),
    [anon_sym_AMP] = ACTIONS(3337),
    [anon_sym_this] = ACTIONS(3335),
    [anon_sym_scoped] = ACTIONS(3335),
    [anon_sym_var] = ACTIONS(3335),
    [sym_predefined_type] = ACTIONS(3335),
    [anon_sym_break] = ACTIONS(3335),
    [anon_sym_unchecked] = ACTIONS(3335),
    [anon_sym_continue] = ACTIONS(3335),
    [anon_sym_do] = ACTIONS(3335),
    [anon_sym_while] = ACTIONS(3335),
    [anon_sym_for] = ACTIONS(3335),
    [anon_sym_lock] = ACTIONS(3335),
    [anon_sym_yield] = ACTIONS(3335),
    [anon_sym_switch] = ACTIONS(3335),
    [anon_sym_default] = ACTIONS(3335),
    [anon_sym_throw] = ACTIONS(3335),
    [anon_sym_try] = ACTIONS(3335),
    [anon_sym_when] = ACTIONS(3335),
    [anon_sym_await] = ACTIONS(3335),
    [anon_sym_foreach] = ACTIONS(3335),
    [anon_sym_goto] = ACTIONS(3335),
    [anon_sym_if] = ACTIONS(3335),
    [anon_sym_else] = ACTIONS(3335),
    [anon_sym_DOT_DOT] = ACTIONS(3337),
    [anon_sym_from] = ACTIONS(3335),
    [anon_sym_into] = ACTIONS(3335),
    [anon_sym_join] = ACTIONS(3335),
    [anon_sym_on] = ACTIONS(3335),
    [anon_sym_equals] = ACTIONS(3335),
    [anon_sym_let] = ACTIONS(3335),
    [anon_sym_orderby] = ACTIONS(3335),
    [anon_sym_ascending] = ACTIONS(3335),
    [anon_sym_descending] = ACTIONS(3335),
    [anon_sym_group] = ACTIONS(3335),
    [anon_sym_by] = ACTIONS(3335),
    [anon_sym_select] = ACTIONS(3335),
    [anon_sym_DQUOTE] = ACTIONS(3335),
    [anon_sym_stackalloc] = ACTIONS(3335),
    [anon_sym_sizeof] = ACTIONS(3335),
    [anon_sym_typeof] = ACTIONS(3335),
    [anon_sym___makeref] = ACTIONS(3335),
    [anon_sym___reftype] = ACTIONS(3335),
    [anon_sym___refvalue] = ACTIONS(3335),
    [sym_null_literal] = ACTIONS(3335),
    [anon_sym_SQUOTE] = ACTIONS(3337),
    [sym_integer_literal] = ACTIONS(3335),
    [sym_real_literal] = ACTIONS(3337),
    [sym_verbatim_string_literal] = ACTIONS(3337),
    [sym_raw_string_literal] = ACTIONS(3337),
    [aux_sym_preproc_if_token1] = ACTIONS(3337),
    [aux_sym_preproc_if_token3] = ACTIONS(3337),
    [aux_sym_preproc_else_token1] = ACTIONS(3337),
    [aux_sym_preproc_elif_token1] = ACTIONS(3337),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3337),
    [sym_interpolation_verbatim_start] = ACTIONS(3337),
    [sym_interpolation_raw_start] = ACTIONS(3337),
  },
  [2273] = {
    [sym_preproc_region] = STATE(2273),
    [sym_preproc_endregion] = STATE(2273),
    [sym_preproc_line] = STATE(2273),
    [sym_preproc_pragma] = STATE(2273),
    [sym_preproc_nullable] = STATE(2273),
    [sym_preproc_error] = STATE(2273),
    [sym_preproc_define] = STATE(2273),
    [sym_preproc_undef] = STATE(2273),
    [sym__identifier_token] = ACTIONS(3339),
    [anon_sym_extern] = ACTIONS(3339),
    [anon_sym_alias] = ACTIONS(3339),
    [anon_sym_SEMI] = ACTIONS(3341),
    [anon_sym_global] = ACTIONS(3339),
    [anon_sym_using] = ACTIONS(3339),
    [anon_sym_unsafe] = ACTIONS(3339),
    [anon_sym_static] = ACTIONS(3339),
    [anon_sym_LBRACK] = ACTIONS(3341),
    [anon_sym_LPAREN] = ACTIONS(3341),
    [anon_sym_return] = ACTIONS(3339),
    [anon_sym_namespace] = ACTIONS(3339),
    [anon_sym_class] = ACTIONS(3339),
    [anon_sym_ref] = ACTIONS(3339),
    [anon_sym_struct] = ACTIONS(3339),
    [anon_sym_enum] = ACTIONS(3339),
    [anon_sym_LBRACE] = ACTIONS(3341),
    [anon_sym_interface] = ACTIONS(3339),
    [anon_sym_delegate] = ACTIONS(3339),
    [anon_sym_record] = ACTIONS(3339),
    [anon_sym_abstract] = ACTIONS(3339),
    [anon_sym_async] = ACTIONS(3339),
    [anon_sym_const] = ACTIONS(3339),
    [anon_sym_file] = ACTIONS(3339),
    [anon_sym_fixed] = ACTIONS(3339),
    [anon_sym_internal] = ACTIONS(3339),
    [anon_sym_new] = ACTIONS(3339),
    [anon_sym_override] = ACTIONS(3339),
    [anon_sym_partial] = ACTIONS(3339),
    [anon_sym_private] = ACTIONS(3339),
    [anon_sym_protected] = ACTIONS(3339),
    [anon_sym_public] = ACTIONS(3339),
    [anon_sym_readonly] = ACTIONS(3339),
    [anon_sym_required] = ACTIONS(3339),
    [anon_sym_sealed] = ACTIONS(3339),
    [anon_sym_virtual] = ACTIONS(3339),
    [anon_sym_volatile] = ACTIONS(3339),
    [anon_sym_where] = ACTIONS(3339),
    [anon_sym_notnull] = ACTIONS(3339),
    [anon_sym_unmanaged] = ACTIONS(3339),
    [anon_sym_checked] = ACTIONS(3339),
    [anon_sym_BANG] = ACTIONS(3341),
    [anon_sym_TILDE] = ACTIONS(3341),
    [anon_sym_PLUS_PLUS] = ACTIONS(3341),
    [anon_sym_DASH_DASH] = ACTIONS(3341),
    [anon_sym_true] = ACTIONS(3339),
    [anon_sym_false] = ACTIONS(3339),
    [anon_sym_PLUS] = ACTIONS(3339),
    [anon_sym_DASH] = ACTIONS(3339),
    [anon_sym_STAR] = ACTIONS(3341),
    [anon_sym_CARET] = ACTIONS(3341),
    [anon_sym_AMP] = ACTIONS(3341),
    [anon_sym_this] = ACTIONS(3339),
    [anon_sym_scoped] = ACTIONS(3339),
    [anon_sym_var] = ACTIONS(3339),
    [sym_predefined_type] = ACTIONS(3339),
    [anon_sym_break] = ACTIONS(3339),
    [anon_sym_unchecked] = ACTIONS(3339),
    [anon_sym_continue] = ACTIONS(3339),
    [anon_sym_do] = ACTIONS(3339),
    [anon_sym_while] = ACTIONS(3339),
    [anon_sym_for] = ACTIONS(3339),
    [anon_sym_lock] = ACTIONS(3339),
    [anon_sym_yield] = ACTIONS(3339),
    [anon_sym_switch] = ACTIONS(3339),
    [anon_sym_default] = ACTIONS(3339),
    [anon_sym_throw] = ACTIONS(3339),
    [anon_sym_try] = ACTIONS(3339),
    [anon_sym_when] = ACTIONS(3339),
    [anon_sym_await] = ACTIONS(3339),
    [anon_sym_foreach] = ACTIONS(3339),
    [anon_sym_goto] = ACTIONS(3339),
    [anon_sym_if] = ACTIONS(3339),
    [anon_sym_else] = ACTIONS(3339),
    [anon_sym_DOT_DOT] = ACTIONS(3341),
    [anon_sym_from] = ACTIONS(3339),
    [anon_sym_into] = ACTIONS(3339),
    [anon_sym_join] = ACTIONS(3339),
    [anon_sym_on] = ACTIONS(3339),
    [anon_sym_equals] = ACTIONS(3339),
    [anon_sym_let] = ACTIONS(3339),
    [anon_sym_orderby] = ACTIONS(3339),
    [anon_sym_ascending] = ACTIONS(3339),
    [anon_sym_descending] = ACTIONS(3339),
    [anon_sym_group] = ACTIONS(3339),
    [anon_sym_by] = ACTIONS(3339),
    [anon_sym_select] = ACTIONS(3339),
    [anon_sym_DQUOTE] = ACTIONS(3339),
    [anon_sym_stackalloc] = ACTIONS(3339),
    [anon_sym_sizeof] = ACTIONS(3339),
    [anon_sym_typeof] = ACTIONS(3339),
    [anon_sym___makeref] = ACTIONS(3339),
    [anon_sym___reftype] = ACTIONS(3339),
    [anon_sym___refvalue] = ACTIONS(3339),
    [sym_null_literal] = ACTIONS(3339),
    [anon_sym_SQUOTE] = ACTIONS(3341),
    [sym_integer_literal] = ACTIONS(3339),
    [sym_real_literal] = ACTIONS(3341),
    [sym_verbatim_string_literal] = ACTIONS(3341),
    [sym_raw_string_literal] = ACTIONS(3341),
    [aux_sym_preproc_if_token1] = ACTIONS(3341),
    [aux_sym_preproc_if_token3] = ACTIONS(3341),
    [aux_sym_preproc_else_token1] = ACTIONS(3341),
    [aux_sym_preproc_elif_token1] = ACTIONS(3341),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3341),
    [sym_interpolation_verbatim_start] = ACTIONS(3341),
    [sym_interpolation_raw_start] = ACTIONS(3341),
  },
  [2274] = {
    [sym_preproc_region] = STATE(2274),
    [sym_preproc_endregion] = STATE(2274),
    [sym_preproc_line] = STATE(2274),
    [sym_preproc_pragma] = STATE(2274),
    [sym_preproc_nullable] = STATE(2274),
    [sym_preproc_error] = STATE(2274),
    [sym_preproc_define] = STATE(2274),
    [sym_preproc_undef] = STATE(2274),
    [ts_builtin_sym_end] = ACTIONS(2923),
    [sym__identifier_token] = ACTIONS(2921),
    [anon_sym_extern] = ACTIONS(2921),
    [anon_sym_alias] = ACTIONS(2921),
    [anon_sym_SEMI] = ACTIONS(2923),
    [anon_sym_global] = ACTIONS(2921),
    [anon_sym_using] = ACTIONS(2921),
    [anon_sym_unsafe] = ACTIONS(2921),
    [anon_sym_static] = ACTIONS(2921),
    [anon_sym_LBRACK] = ACTIONS(2923),
    [anon_sym_LPAREN] = ACTIONS(2923),
    [anon_sym_return] = ACTIONS(2921),
    [anon_sym_namespace] = ACTIONS(2921),
    [anon_sym_class] = ACTIONS(2921),
    [anon_sym_ref] = ACTIONS(2921),
    [anon_sym_struct] = ACTIONS(2921),
    [anon_sym_enum] = ACTIONS(2921),
    [anon_sym_LBRACE] = ACTIONS(2923),
    [anon_sym_interface] = ACTIONS(2921),
    [anon_sym_delegate] = ACTIONS(2921),
    [anon_sym_record] = ACTIONS(2921),
    [anon_sym_abstract] = ACTIONS(2921),
    [anon_sym_async] = ACTIONS(2921),
    [anon_sym_const] = ACTIONS(2921),
    [anon_sym_file] = ACTIONS(2921),
    [anon_sym_fixed] = ACTIONS(2921),
    [anon_sym_internal] = ACTIONS(2921),
    [anon_sym_new] = ACTIONS(2921),
    [anon_sym_override] = ACTIONS(2921),
    [anon_sym_partial] = ACTIONS(2921),
    [anon_sym_private] = ACTIONS(2921),
    [anon_sym_protected] = ACTIONS(2921),
    [anon_sym_public] = ACTIONS(2921),
    [anon_sym_readonly] = ACTIONS(2921),
    [anon_sym_required] = ACTIONS(2921),
    [anon_sym_sealed] = ACTIONS(2921),
    [anon_sym_virtual] = ACTIONS(2921),
    [anon_sym_volatile] = ACTIONS(2921),
    [anon_sym_where] = ACTIONS(2921),
    [anon_sym_notnull] = ACTIONS(2921),
    [anon_sym_unmanaged] = ACTIONS(2921),
    [anon_sym_checked] = ACTIONS(2921),
    [anon_sym_BANG] = ACTIONS(2923),
    [anon_sym_TILDE] = ACTIONS(2923),
    [anon_sym_PLUS_PLUS] = ACTIONS(2923),
    [anon_sym_DASH_DASH] = ACTIONS(2923),
    [anon_sym_true] = ACTIONS(2921),
    [anon_sym_false] = ACTIONS(2921),
    [anon_sym_PLUS] = ACTIONS(2921),
    [anon_sym_DASH] = ACTIONS(2921),
    [anon_sym_STAR] = ACTIONS(2923),
    [anon_sym_CARET] = ACTIONS(2923),
    [anon_sym_AMP] = ACTIONS(2923),
    [anon_sym_this] = ACTIONS(2921),
    [anon_sym_scoped] = ACTIONS(2921),
    [anon_sym_var] = ACTIONS(2921),
    [sym_predefined_type] = ACTIONS(2921),
    [anon_sym_break] = ACTIONS(2921),
    [anon_sym_unchecked] = ACTIONS(2921),
    [anon_sym_continue] = ACTIONS(2921),
    [anon_sym_do] = ACTIONS(2921),
    [anon_sym_while] = ACTIONS(2921),
    [anon_sym_for] = ACTIONS(2921),
    [anon_sym_lock] = ACTIONS(2921),
    [anon_sym_yield] = ACTIONS(2921),
    [anon_sym_switch] = ACTIONS(2921),
    [anon_sym_default] = ACTIONS(2921),
    [anon_sym_throw] = ACTIONS(2921),
    [anon_sym_try] = ACTIONS(2921),
    [anon_sym_catch] = ACTIONS(2921),
    [anon_sym_when] = ACTIONS(2921),
    [anon_sym_finally] = ACTIONS(2921),
    [anon_sym_await] = ACTIONS(2921),
    [anon_sym_foreach] = ACTIONS(2921),
    [anon_sym_goto] = ACTIONS(2921),
    [anon_sym_if] = ACTIONS(2921),
    [anon_sym_else] = ACTIONS(2921),
    [anon_sym_DOT_DOT] = ACTIONS(2923),
    [anon_sym_from] = ACTIONS(2921),
    [anon_sym_into] = ACTIONS(2921),
    [anon_sym_join] = ACTIONS(2921),
    [anon_sym_on] = ACTIONS(2921),
    [anon_sym_equals] = ACTIONS(2921),
    [anon_sym_let] = ACTIONS(2921),
    [anon_sym_orderby] = ACTIONS(2921),
    [anon_sym_ascending] = ACTIONS(2921),
    [anon_sym_descending] = ACTIONS(2921),
    [anon_sym_group] = ACTIONS(2921),
    [anon_sym_by] = ACTIONS(2921),
    [anon_sym_select] = ACTIONS(2921),
    [anon_sym_DQUOTE] = ACTIONS(2921),
    [anon_sym_stackalloc] = ACTIONS(2921),
    [anon_sym_sizeof] = ACTIONS(2921),
    [anon_sym_typeof] = ACTIONS(2921),
    [anon_sym___makeref] = ACTIONS(2921),
    [anon_sym___reftype] = ACTIONS(2921),
    [anon_sym___refvalue] = ACTIONS(2921),
    [sym_null_literal] = ACTIONS(2921),
    [anon_sym_SQUOTE] = ACTIONS(2923),
    [sym_integer_literal] = ACTIONS(2921),
    [sym_real_literal] = ACTIONS(2923),
    [sym_verbatim_string_literal] = ACTIONS(2923),
    [sym_raw_string_literal] = ACTIONS(2923),
    [aux_sym_preproc_if_token1] = ACTIONS(2923),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(2923),
    [sym_interpolation_verbatim_start] = ACTIONS(2923),
    [sym_interpolation_raw_start] = ACTIONS(2923),
  },
  [2275] = {
    [sym_preproc_region] = STATE(2275),
    [sym_preproc_endregion] = STATE(2275),
    [sym_preproc_line] = STATE(2275),
    [sym_preproc_pragma] = STATE(2275),
    [sym_preproc_nullable] = STATE(2275),
    [sym_preproc_error] = STATE(2275),
    [sym_preproc_define] = STATE(2275),
    [sym_preproc_undef] = STATE(2275),
    [sym__identifier_token] = ACTIONS(3343),
    [anon_sym_extern] = ACTIONS(3343),
    [anon_sym_alias] = ACTIONS(3343),
    [anon_sym_SEMI] = ACTIONS(3345),
    [anon_sym_global] = ACTIONS(3343),
    [anon_sym_using] = ACTIONS(3343),
    [anon_sym_unsafe] = ACTIONS(3343),
    [anon_sym_static] = ACTIONS(3343),
    [anon_sym_LBRACK] = ACTIONS(3345),
    [anon_sym_LPAREN] = ACTIONS(3345),
    [anon_sym_return] = ACTIONS(3343),
    [anon_sym_namespace] = ACTIONS(3343),
    [anon_sym_class] = ACTIONS(3343),
    [anon_sym_ref] = ACTIONS(3343),
    [anon_sym_struct] = ACTIONS(3343),
    [anon_sym_enum] = ACTIONS(3343),
    [anon_sym_LBRACE] = ACTIONS(3345),
    [anon_sym_interface] = ACTIONS(3343),
    [anon_sym_delegate] = ACTIONS(3343),
    [anon_sym_record] = ACTIONS(3343),
    [anon_sym_abstract] = ACTIONS(3343),
    [anon_sym_async] = ACTIONS(3343),
    [anon_sym_const] = ACTIONS(3343),
    [anon_sym_file] = ACTIONS(3343),
    [anon_sym_fixed] = ACTIONS(3343),
    [anon_sym_internal] = ACTIONS(3343),
    [anon_sym_new] = ACTIONS(3343),
    [anon_sym_override] = ACTIONS(3343),
    [anon_sym_partial] = ACTIONS(3343),
    [anon_sym_private] = ACTIONS(3343),
    [anon_sym_protected] = ACTIONS(3343),
    [anon_sym_public] = ACTIONS(3343),
    [anon_sym_readonly] = ACTIONS(3343),
    [anon_sym_required] = ACTIONS(3343),
    [anon_sym_sealed] = ACTIONS(3343),
    [anon_sym_virtual] = ACTIONS(3343),
    [anon_sym_volatile] = ACTIONS(3343),
    [anon_sym_where] = ACTIONS(3343),
    [anon_sym_notnull] = ACTIONS(3343),
    [anon_sym_unmanaged] = ACTIONS(3343),
    [anon_sym_checked] = ACTIONS(3343),
    [anon_sym_BANG] = ACTIONS(3345),
    [anon_sym_TILDE] = ACTIONS(3345),
    [anon_sym_PLUS_PLUS] = ACTIONS(3345),
    [anon_sym_DASH_DASH] = ACTIONS(3345),
    [anon_sym_true] = ACTIONS(3343),
    [anon_sym_false] = ACTIONS(3343),
    [anon_sym_PLUS] = ACTIONS(3343),
    [anon_sym_DASH] = ACTIONS(3343),
    [anon_sym_STAR] = ACTIONS(3345),
    [anon_sym_CARET] = ACTIONS(3345),
    [anon_sym_AMP] = ACTIONS(3345),
    [anon_sym_this] = ACTIONS(3343),
    [anon_sym_scoped] = ACTIONS(3343),
    [anon_sym_var] = ACTIONS(3343),
    [sym_predefined_type] = ACTIONS(3343),
    [anon_sym_break] = ACTIONS(3343),
    [anon_sym_unchecked] = ACTIONS(3343),
    [anon_sym_continue] = ACTIONS(3343),
    [anon_sym_do] = ACTIONS(3343),
    [anon_sym_while] = ACTIONS(3343),
    [anon_sym_for] = ACTIONS(3343),
    [anon_sym_lock] = ACTIONS(3343),
    [anon_sym_yield] = ACTIONS(3343),
    [anon_sym_switch] = ACTIONS(3343),
    [anon_sym_default] = ACTIONS(3343),
    [anon_sym_throw] = ACTIONS(3343),
    [anon_sym_try] = ACTIONS(3343),
    [anon_sym_when] = ACTIONS(3343),
    [anon_sym_await] = ACTIONS(3343),
    [anon_sym_foreach] = ACTIONS(3343),
    [anon_sym_goto] = ACTIONS(3343),
    [anon_sym_if] = ACTIONS(3343),
    [anon_sym_else] = ACTIONS(3343),
    [anon_sym_DOT_DOT] = ACTIONS(3345),
    [anon_sym_from] = ACTIONS(3343),
    [anon_sym_into] = ACTIONS(3343),
    [anon_sym_join] = ACTIONS(3343),
    [anon_sym_on] = ACTIONS(3343),
    [anon_sym_equals] = ACTIONS(3343),
    [anon_sym_let] = ACTIONS(3343),
    [anon_sym_orderby] = ACTIONS(3343),
    [anon_sym_ascending] = ACTIONS(3343),
    [anon_sym_descending] = ACTIONS(3343),
    [anon_sym_group] = ACTIONS(3343),
    [anon_sym_by] = ACTIONS(3343),
    [anon_sym_select] = ACTIONS(3343),
    [anon_sym_DQUOTE] = ACTIONS(3343),
    [anon_sym_stackalloc] = ACTIONS(3343),
    [anon_sym_sizeof] = ACTIONS(3343),
    [anon_sym_typeof] = ACTIONS(3343),
    [anon_sym___makeref] = ACTIONS(3343),
    [anon_sym___reftype] = ACTIONS(3343),
    [anon_sym___refvalue] = ACTIONS(3343),
    [sym_null_literal] = ACTIONS(3343),
    [anon_sym_SQUOTE] = ACTIONS(3345),
    [sym_integer_literal] = ACTIONS(3343),
    [sym_real_literal] = ACTIONS(3345),
    [sym_verbatim_string_literal] = ACTIONS(3345),
    [sym_raw_string_literal] = ACTIONS(3345),
    [aux_sym_preproc_if_token1] = ACTIONS(3345),
    [aux_sym_preproc_if_token3] = ACTIONS(3345),
    [aux_sym_preproc_else_token1] = ACTIONS(3345),
    [aux_sym_preproc_elif_token1] = ACTIONS(3345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3345),
    [sym_interpolation_verbatim_start] = ACTIONS(3345),
    [sym_interpolation_raw_start] = ACTIONS(3345),
  },
  [2276] = {
    [sym_preproc_region] = STATE(2276),
    [sym_preproc_endregion] = STATE(2276),
    [sym_preproc_line] = STATE(2276),
    [sym_preproc_pragma] = STATE(2276),
    [sym_preproc_nullable] = STATE(2276),
    [sym_preproc_error] = STATE(2276),
    [sym_preproc_define] = STATE(2276),
    [sym_preproc_undef] = STATE(2276),
    [sym__identifier_token] = ACTIONS(2937),
    [anon_sym_extern] = ACTIONS(2937),
    [anon_sym_alias] = ACTIONS(2937),
    [anon_sym_SEMI] = ACTIONS(2939),
    [anon_sym_global] = ACTIONS(2937),
    [anon_sym_using] = ACTIONS(2937),
    [anon_sym_unsafe] = ACTIONS(2937),
    [anon_sym_static] = ACTIONS(2937),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_LPAREN] = ACTIONS(2939),
    [anon_sym_return] = ACTIONS(2937),
    [anon_sym_namespace] = ACTIONS(2937),
    [anon_sym_class] = ACTIONS(2937),
    [anon_sym_ref] = ACTIONS(2937),
    [anon_sym_struct] = ACTIONS(2937),
    [anon_sym_enum] = ACTIONS(2937),
    [anon_sym_LBRACE] = ACTIONS(2939),
    [anon_sym_interface] = ACTIONS(2937),
    [anon_sym_delegate] = ACTIONS(2937),
    [anon_sym_record] = ACTIONS(2937),
    [anon_sym_abstract] = ACTIONS(2937),
    [anon_sym_async] = ACTIONS(2937),
    [anon_sym_const] = ACTIONS(2937),
    [anon_sym_file] = ACTIONS(2937),
    [anon_sym_fixed] = ACTIONS(2937),
    [anon_sym_internal] = ACTIONS(2937),
    [anon_sym_new] = ACTIONS(2937),
    [anon_sym_override] = ACTIONS(2937),
    [anon_sym_partial] = ACTIONS(2937),
    [anon_sym_private] = ACTIONS(2937),
    [anon_sym_protected] = ACTIONS(2937),
    [anon_sym_public] = ACTIONS(2937),
    [anon_sym_readonly] = ACTIONS(2937),
    [anon_sym_required] = ACTIONS(2937),
    [anon_sym_sealed] = ACTIONS(2937),
    [anon_sym_virtual] = ACTIONS(2937),
    [anon_sym_volatile] = ACTIONS(2937),
    [anon_sym_where] = ACTIONS(2937),
    [anon_sym_notnull] = ACTIONS(2937),
    [anon_sym_unmanaged] = ACTIONS(2937),
    [anon_sym_checked] = ACTIONS(2937),
    [anon_sym_BANG] = ACTIONS(2939),
    [anon_sym_TILDE] = ACTIONS(2939),
    [anon_sym_PLUS_PLUS] = ACTIONS(2939),
    [anon_sym_DASH_DASH] = ACTIONS(2939),
    [anon_sym_true] = ACTIONS(2937),
    [anon_sym_false] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(2937),
    [anon_sym_DASH] = ACTIONS(2937),
    [anon_sym_STAR] = ACTIONS(2939),
    [anon_sym_CARET] = ACTIONS(2939),
    [anon_sym_AMP] = ACTIONS(2939),
    [anon_sym_this] = ACTIONS(2937),
    [anon_sym_scoped] = ACTIONS(2937),
    [anon_sym_var] = ACTIONS(2937),
    [sym_predefined_type] = ACTIONS(2937),
    [anon_sym_break] = ACTIONS(2937),
    [anon_sym_unchecked] = ACTIONS(2937),
    [anon_sym_continue] = ACTIONS(2937),
    [anon_sym_do] = ACTIONS(2937),
    [anon_sym_while] = ACTIONS(2937),
    [anon_sym_for] = ACTIONS(2937),
    [anon_sym_lock] = ACTIONS(2937),
    [anon_sym_yield] = ACTIONS(2937),
    [anon_sym_switch] = ACTIONS(2937),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_throw] = ACTIONS(2937),
    [anon_sym_try] = ACTIONS(2937),
    [anon_sym_when] = ACTIONS(2937),
    [anon_sym_await] = ACTIONS(2937),
    [anon_sym_foreach] = ACTIONS(2937),
    [anon_sym_goto] = ACTIONS(2937),
    [anon_sym_if] = ACTIONS(2937),
    [anon_sym_else] = ACTIONS(2937),
    [anon_sym_DOT_DOT] = ACTIONS(2939),
    [anon_sym_from] = ACTIONS(2937),
    [anon_sym_into] = ACTIONS(2937),
    [anon_sym_join] = ACTIONS(2937),
    [anon_sym_on] = ACTIONS(2937),
    [anon_sym_equals] = ACTIONS(2937),
    [anon_sym_let] = ACTIONS(2937),
    [anon_sym_orderby] = ACTIONS(2937),
    [anon_sym_ascending] = ACTIONS(2937),
    [anon_sym_descending] = ACTIONS(2937),
    [anon_sym_group] = ACTIONS(2937),
    [anon_sym_by] = ACTIONS(2937),
    [anon_sym_select] = ACTIONS(2937),
    [anon_sym_DQUOTE] = ACTIONS(2937),
    [anon_sym_stackalloc] = ACTIONS(2937),
    [anon_sym_sizeof] = ACTIONS(2937),
    [anon_sym_typeof] = ACTIONS(2937),
    [anon_sym___makeref] = ACTIONS(2937),
    [anon_sym___reftype] = ACTIONS(2937),
    [anon_sym___refvalue] = ACTIONS(2937),
    [sym_null_literal] = ACTIONS(2937),
    [anon_sym_SQUOTE] = ACTIONS(2939),
    [sym_integer_literal] = ACTIONS(2937),
    [sym_real_literal] = ACTIONS(2939),
    [sym_verbatim_string_literal] = ACTIONS(2939),
    [sym_raw_string_literal] = ACTIONS(2939),
    [aux_sym_preproc_if_token1] = ACTIONS(2939),
    [aux_sym_preproc_if_token3] = ACTIONS(2939),
    [aux_sym_preproc_else_token1] = ACTIONS(2939),
    [aux_sym_preproc_elif_token1] = ACTIONS(2939),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(2939),
    [sym_interpolation_verbatim_start] = ACTIONS(2939),
    [sym_interpolation_raw_start] = ACTIONS(2939),
  },
  [2277] = {
    [sym_preproc_region] = STATE(2277),
    [sym_preproc_endregion] = STATE(2277),
    [sym_preproc_line] = STATE(2277),
    [sym_preproc_pragma] = STATE(2277),
    [sym_preproc_nullable] = STATE(2277),
    [sym_preproc_error] = STATE(2277),
    [sym_preproc_define] = STATE(2277),
    [sym_preproc_undef] = STATE(2277),
    [sym__identifier_token] = ACTIONS(3347),
    [anon_sym_extern] = ACTIONS(3347),
    [anon_sym_alias] = ACTIONS(3347),
    [anon_sym_SEMI] = ACTIONS(3349),
    [anon_sym_global] = ACTIONS(3347),
    [anon_sym_using] = ACTIONS(3347),
    [anon_sym_unsafe] = ACTIONS(3347),
    [anon_sym_static] = ACTIONS(3347),
    [anon_sym_LBRACK] = ACTIONS(3349),
    [anon_sym_LPAREN] = ACTIONS(3349),
    [anon_sym_return] = ACTIONS(3347),
    [anon_sym_namespace] = ACTIONS(3347),
    [anon_sym_class] = ACTIONS(3347),
    [anon_sym_ref] = ACTIONS(3347),
    [anon_sym_struct] = ACTIONS(3347),
    [anon_sym_enum] = ACTIONS(3347),
    [anon_sym_LBRACE] = ACTIONS(3349),
    [anon_sym_interface] = ACTIONS(3347),
    [anon_sym_delegate] = ACTIONS(3347),
    [anon_sym_record] = ACTIONS(3347),
    [anon_sym_abstract] = ACTIONS(3347),
    [anon_sym_async] = ACTIONS(3347),
    [anon_sym_const] = ACTIONS(3347),
    [anon_sym_file] = ACTIONS(3347),
    [anon_sym_fixed] = ACTIONS(3347),
    [anon_sym_internal] = ACTIONS(3347),
    [anon_sym_new] = ACTIONS(3347),
    [anon_sym_override] = ACTIONS(3347),
    [anon_sym_partial] = ACTIONS(3347),
    [anon_sym_private] = ACTIONS(3347),
    [anon_sym_protected] = ACTIONS(3347),
    [anon_sym_public] = ACTIONS(3347),
    [anon_sym_readonly] = ACTIONS(3347),
    [anon_sym_required] = ACTIONS(3347),
    [anon_sym_sealed] = ACTIONS(3347),
    [anon_sym_virtual] = ACTIONS(3347),
    [anon_sym_volatile] = ACTIONS(3347),
    [anon_sym_where] = ACTIONS(3347),
    [anon_sym_notnull] = ACTIONS(3347),
    [anon_sym_unmanaged] = ACTIONS(3347),
    [anon_sym_checked] = ACTIONS(3347),
    [anon_sym_BANG] = ACTIONS(3349),
    [anon_sym_TILDE] = ACTIONS(3349),
    [anon_sym_PLUS_PLUS] = ACTIONS(3349),
    [anon_sym_DASH_DASH] = ACTIONS(3349),
    [anon_sym_true] = ACTIONS(3347),
    [anon_sym_false] = ACTIONS(3347),
    [anon_sym_PLUS] = ACTIONS(3347),
    [anon_sym_DASH] = ACTIONS(3347),
    [anon_sym_STAR] = ACTIONS(3349),
    [anon_sym_CARET] = ACTIONS(3349),
    [anon_sym_AMP] = ACTIONS(3349),
    [anon_sym_this] = ACTIONS(3347),
    [anon_sym_scoped] = ACTIONS(3347),
    [anon_sym_var] = ACTIONS(3347),
    [sym_predefined_type] = ACTIONS(3347),
    [anon_sym_break] = ACTIONS(3347),
    [anon_sym_unchecked] = ACTIONS(3347),
    [anon_sym_continue] = ACTIONS(3347),
    [anon_sym_do] = ACTIONS(3347),
    [anon_sym_while] = ACTIONS(3347),
    [anon_sym_for] = ACTIONS(3347),
    [anon_sym_lock] = ACTIONS(3347),
    [anon_sym_yield] = ACTIONS(3347),
    [anon_sym_switch] = ACTIONS(3347),
    [anon_sym_default] = ACTIONS(3347),
    [anon_sym_throw] = ACTIONS(3347),
    [anon_sym_try] = ACTIONS(3347),
    [anon_sym_when] = ACTIONS(3347),
    [anon_sym_await] = ACTIONS(3347),
    [anon_sym_foreach] = ACTIONS(3347),
    [anon_sym_goto] = ACTIONS(3347),
    [anon_sym_if] = ACTIONS(3347),
    [anon_sym_else] = ACTIONS(3347),
    [anon_sym_DOT_DOT] = ACTIONS(3349),
    [anon_sym_from] = ACTIONS(3347),
    [anon_sym_into] = ACTIONS(3347),
    [anon_sym_join] = ACTIONS(3347),
    [anon_sym_on] = ACTIONS(3347),
    [anon_sym_equals] = ACTIONS(3347),
    [anon_sym_let] = ACTIONS(3347),
    [anon_sym_orderby] = ACTIONS(3347),
    [anon_sym_ascending] = ACTIONS(3347),
    [anon_sym_descending] = ACTIONS(3347),
    [anon_sym_group] = ACTIONS(3347),
    [anon_sym_by] = ACTIONS(3347),
    [anon_sym_select] = ACTIONS(3347),
    [anon_sym_DQUOTE] = ACTIONS(3347),
    [anon_sym_stackalloc] = ACTIONS(3347),
    [anon_sym_sizeof] = ACTIONS(3347),
    [anon_sym_typeof] = ACTIONS(3347),
    [anon_sym___makeref] = ACTIONS(3347),
    [anon_sym___reftype] = ACTIONS(3347),
    [anon_sym___refvalue] = ACTIONS(3347),
    [sym_null_literal] = ACTIONS(3347),
    [anon_sym_SQUOTE] = ACTIONS(3349),
    [sym_integer_literal] = ACTIONS(3347),
    [sym_real_literal] = ACTIONS(3349),
    [sym_verbatim_string_literal] = ACTIONS(3349),
    [sym_raw_string_literal] = ACTIONS(3349),
    [aux_sym_preproc_if_token1] = ACTIONS(3349),
    [aux_sym_preproc_if_token3] = ACTIONS(3349),
    [aux_sym_preproc_else_token1] = ACTIONS(3349),
    [aux_sym_preproc_elif_token1] = ACTIONS(3349),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3349),
    [sym_interpolation_verbatim_start] = ACTIONS(3349),
    [sym_interpolation_raw_start] = ACTIONS(3349),
  },
  [2278] = {
    [sym_preproc_region] = STATE(2278),
    [sym_preproc_endregion] = STATE(2278),
    [sym_preproc_line] = STATE(2278),
    [sym_preproc_pragma] = STATE(2278),
    [sym_preproc_nullable] = STATE(2278),
    [sym_preproc_error] = STATE(2278),
    [sym_preproc_define] = STATE(2278),
    [sym_preproc_undef] = STATE(2278),
    [ts_builtin_sym_end] = ACTIONS(2981),
    [sym__identifier_token] = ACTIONS(2979),
    [anon_sym_extern] = ACTIONS(2979),
    [anon_sym_alias] = ACTIONS(2979),
    [anon_sym_SEMI] = ACTIONS(2981),
    [anon_sym_global] = ACTIONS(2979),
    [anon_sym_using] = ACTIONS(2979),
    [anon_sym_unsafe] = ACTIONS(2979),
    [anon_sym_static] = ACTIONS(2979),
    [anon_sym_LBRACK] = ACTIONS(2981),
    [anon_sym_LPAREN] = ACTIONS(2981),
    [anon_sym_return] = ACTIONS(2979),
    [anon_sym_namespace] = ACTIONS(2979),
    [anon_sym_class] = ACTIONS(2979),
    [anon_sym_ref] = ACTIONS(2979),
    [anon_sym_struct] = ACTIONS(2979),
    [anon_sym_enum] = ACTIONS(2979),
    [anon_sym_LBRACE] = ACTIONS(2981),
    [anon_sym_interface] = ACTIONS(2979),
    [anon_sym_delegate] = ACTIONS(2979),
    [anon_sym_record] = ACTIONS(2979),
    [anon_sym_abstract] = ACTIONS(2979),
    [anon_sym_async] = ACTIONS(2979),
    [anon_sym_const] = ACTIONS(2979),
    [anon_sym_file] = ACTIONS(2979),
    [anon_sym_fixed] = ACTIONS(2979),
    [anon_sym_internal] = ACTIONS(2979),
    [anon_sym_new] = ACTIONS(2979),
    [anon_sym_override] = ACTIONS(2979),
    [anon_sym_partial] = ACTIONS(2979),
    [anon_sym_private] = ACTIONS(2979),
    [anon_sym_protected] = ACTIONS(2979),
    [anon_sym_public] = ACTIONS(2979),
    [anon_sym_readonly] = ACTIONS(2979),
    [anon_sym_required] = ACTIONS(2979),
    [anon_sym_sealed] = ACTIONS(2979),
    [anon_sym_virtual] = ACTIONS(2979),
    [anon_sym_volatile] = ACTIONS(2979),
    [anon_sym_where] = ACTIONS(2979),
    [anon_sym_notnull] = ACTIONS(2979),
    [anon_sym_unmanaged] = ACTIONS(2979),
    [anon_sym_checked] = ACTIONS(2979),
    [anon_sym_BANG] = ACTIONS(2981),
    [anon_sym_TILDE] = ACTIONS(2981),
    [anon_sym_PLUS_PLUS] = ACTIONS(2981),
    [anon_sym_DASH_DASH] = ACTIONS(2981),
    [anon_sym_true] = ACTIONS(2979),
    [anon_sym_false] = ACTIONS(2979),
    [anon_sym_PLUS] = ACTIONS(2979),
    [anon_sym_DASH] = ACTIONS(2979),
    [anon_sym_STAR] = ACTIONS(2981),
    [anon_sym_CARET] = ACTIONS(2981),
    [anon_sym_AMP] = ACTIONS(2981),
    [anon_sym_this] = ACTIONS(2979),
    [anon_sym_scoped] = ACTIONS(2979),
    [anon_sym_var] = ACTIONS(2979),
    [sym_predefined_type] = ACTIONS(2979),
    [anon_sym_break] = ACTIONS(2979),
    [anon_sym_unchecked] = ACTIONS(2979),
    [anon_sym_continue] = ACTIONS(2979),
    [anon_sym_do] = ACTIONS(2979),
    [anon_sym_while] = ACTIONS(2979),
    [anon_sym_for] = ACTIONS(2979),
    [anon_sym_lock] = ACTIONS(2979),
    [anon_sym_yield] = ACTIONS(2979),
    [anon_sym_switch] = ACTIONS(2979),
    [anon_sym_default] = ACTIONS(2979),
    [anon_sym_throw] = ACTIONS(2979),
    [anon_sym_try] = ACTIONS(2979),
    [anon_sym_catch] = ACTIONS(2979),
    [anon_sym_when] = ACTIONS(2979),
    [anon_sym_finally] = ACTIONS(2979),
    [anon_sym_await] = ACTIONS(2979),
    [anon_sym_foreach] = ACTIONS(2979),
    [anon_sym_goto] = ACTIONS(2979),
    [anon_sym_if] = ACTIONS(2979),
    [anon_sym_else] = ACTIONS(2979),
    [anon_sym_DOT_DOT] = ACTIONS(2981),
    [anon_sym_from] = ACTIONS(2979),
    [anon_sym_into] = ACTIONS(2979),
    [anon_sym_join] = ACTIONS(2979),
    [anon_sym_on] = ACTIONS(2979),
    [anon_sym_equals] = ACTIONS(2979),
    [anon_sym_let] = ACTIONS(2979),
    [anon_sym_orderby] = ACTIONS(2979),
    [anon_sym_ascending] = ACTIONS(2979),
    [anon_sym_descending] = ACTIONS(2979),
    [anon_sym_group] = ACTIONS(2979),
    [anon_sym_by] = ACTIONS(2979),
    [anon_sym_select] = ACTIONS(2979),
    [anon_sym_DQUOTE] = ACTIONS(2979),
    [anon_sym_stackalloc] = ACTIONS(2979),
    [anon_sym_sizeof] = ACTIONS(2979),
    [anon_sym_typeof] = ACTIONS(2979),
    [anon_sym___makeref] = ACTIONS(2979),
    [anon_sym___reftype] = ACTIONS(2979),
    [anon_sym___refvalue] = ACTIONS(2979),
    [sym_null_literal] = ACTIONS(2979),
    [anon_sym_SQUOTE] = ACTIONS(2981),
    [sym_integer_literal] = ACTIONS(2979),
    [sym_real_literal] = ACTIONS(2981),
    [sym_verbatim_string_literal] = ACTIONS(2981),
    [sym_raw_string_literal] = ACTIONS(2981),
    [aux_sym_preproc_if_token1] = ACTIONS(2981),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(2981),
    [sym_interpolation_verbatim_start] = ACTIONS(2981),
    [sym_interpolation_raw_start] = ACTIONS(2981),
  },
  [2279] = {
    [sym_preproc_region] = STATE(2279),
    [sym_preproc_endregion] = STATE(2279),
    [sym_preproc_line] = STATE(2279),
    [sym_preproc_pragma] = STATE(2279),
    [sym_preproc_nullable] = STATE(2279),
    [sym_preproc_error] = STATE(2279),
    [sym_preproc_define] = STATE(2279),
    [sym_preproc_undef] = STATE(2279),
    [ts_builtin_sym_end] = ACTIONS(2973),
    [sym__identifier_token] = ACTIONS(2971),
    [anon_sym_extern] = ACTIONS(2971),
    [anon_sym_alias] = ACTIONS(2971),
    [anon_sym_SEMI] = ACTIONS(2973),
    [anon_sym_global] = ACTIONS(2971),
    [anon_sym_using] = ACTIONS(2971),
    [anon_sym_unsafe] = ACTIONS(2971),
    [anon_sym_static] = ACTIONS(2971),
    [anon_sym_LBRACK] = ACTIONS(2973),
    [anon_sym_LPAREN] = ACTIONS(2973),
    [anon_sym_return] = ACTIONS(2971),
    [anon_sym_namespace] = ACTIONS(2971),
    [anon_sym_class] = ACTIONS(2971),
    [anon_sym_ref] = ACTIONS(2971),
    [anon_sym_struct] = ACTIONS(2971),
    [anon_sym_enum] = ACTIONS(2971),
    [anon_sym_LBRACE] = ACTIONS(2973),
    [anon_sym_interface] = ACTIONS(2971),
    [anon_sym_delegate] = ACTIONS(2971),
    [anon_sym_record] = ACTIONS(2971),
    [anon_sym_abstract] = ACTIONS(2971),
    [anon_sym_async] = ACTIONS(2971),
    [anon_sym_const] = ACTIONS(2971),
    [anon_sym_file] = ACTIONS(2971),
    [anon_sym_fixed] = ACTIONS(2971),
    [anon_sym_internal] = ACTIONS(2971),
    [anon_sym_new] = ACTIONS(2971),
    [anon_sym_override] = ACTIONS(2971),
    [anon_sym_partial] = ACTIONS(2971),
    [anon_sym_private] = ACTIONS(2971),
    [anon_sym_protected] = ACTIONS(2971),
    [anon_sym_public] = ACTIONS(2971),
    [anon_sym_readonly] = ACTIONS(2971),
    [anon_sym_required] = ACTIONS(2971),
    [anon_sym_sealed] = ACTIONS(2971),
    [anon_sym_virtual] = ACTIONS(2971),
    [anon_sym_volatile] = ACTIONS(2971),
    [anon_sym_where] = ACTIONS(2971),
    [anon_sym_notnull] = ACTIONS(2971),
    [anon_sym_unmanaged] = ACTIONS(2971),
    [anon_sym_checked] = ACTIONS(2971),
    [anon_sym_BANG] = ACTIONS(2973),
    [anon_sym_TILDE] = ACTIONS(2973),
    [anon_sym_PLUS_PLUS] = ACTIONS(2973),
    [anon_sym_DASH_DASH] = ACTIONS(2973),
    [anon_sym_true] = ACTIONS(2971),
    [anon_sym_false] = ACTIONS(2971),
    [anon_sym_PLUS] = ACTIONS(2971),
    [anon_sym_DASH] = ACTIONS(2971),
    [anon_sym_STAR] = ACTIONS(2973),
    [anon_sym_CARET] = ACTIONS(2973),
    [anon_sym_AMP] = ACTIONS(2973),
    [anon_sym_this] = ACTIONS(2971),
    [anon_sym_scoped] = ACTIONS(2971),
    [anon_sym_var] = ACTIONS(2971),
    [sym_predefined_type] = ACTIONS(2971),
    [anon_sym_break] = ACTIONS(2971),
    [anon_sym_unchecked] = ACTIONS(2971),
    [anon_sym_continue] = ACTIONS(2971),
    [anon_sym_do] = ACTIONS(2971),
    [anon_sym_while] = ACTIONS(2971),
    [anon_sym_for] = ACTIONS(2971),
    [anon_sym_lock] = ACTIONS(2971),
    [anon_sym_yield] = ACTIONS(2971),
    [anon_sym_switch] = ACTIONS(2971),
    [anon_sym_default] = ACTIONS(2971),
    [anon_sym_throw] = ACTIONS(2971),
    [anon_sym_try] = ACTIONS(2971),
    [anon_sym_catch] = ACTIONS(2971),
    [anon_sym_when] = ACTIONS(2971),
    [anon_sym_finally] = ACTIONS(2971),
    [anon_sym_await] = ACTIONS(2971),
    [anon_sym_foreach] = ACTIONS(2971),
    [anon_sym_goto] = ACTIONS(2971),
    [anon_sym_if] = ACTIONS(2971),
    [anon_sym_else] = ACTIONS(2971),
    [anon_sym_DOT_DOT] = ACTIONS(2973),
    [anon_sym_from] = ACTIONS(2971),
    [anon_sym_into] = ACTIONS(2971),
    [anon_sym_join] = ACTIONS(2971),
    [anon_sym_on] = ACTIONS(2971),
    [anon_sym_equals] = ACTIONS(2971),
    [anon_sym_let] = ACTIONS(2971),
    [anon_sym_orderby] = ACTIONS(2971),
    [anon_sym_ascending] = ACTIONS(2971),
    [anon_sym_descending] = ACTIONS(2971),
    [anon_sym_group] = ACTIONS(2971),
    [anon_sym_by] = ACTIONS(2971),
    [anon_sym_select] = ACTIONS(2971),
    [anon_sym_DQUOTE] = ACTIONS(2971),
    [anon_sym_stackalloc] = ACTIONS(2971),
    [anon_sym_sizeof] = ACTIONS(2971),
    [anon_sym_typeof] = ACTIONS(2971),
    [anon_sym___makeref] = ACTIONS(2971),
    [anon_sym___reftype] = ACTIONS(2971),
    [anon_sym___refvalue] = ACTIONS(2971),
    [sym_null_literal] = ACTIONS(2971),
    [anon_sym_SQUOTE] = ACTIONS(2973),
    [sym_integer_literal] = ACTIONS(2971),
    [sym_real_literal] = ACTIONS(2973),
    [sym_verbatim_string_literal] = ACTIONS(2973),
    [sym_raw_string_literal] = ACTIONS(2973),
    [aux_sym_preproc_if_token1] = ACTIONS(2973),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(2973),
    [sym_interpolation_verbatim_start] = ACTIONS(2973),
    [sym_interpolation_raw_start] = ACTIONS(2973),
  },
  [2280] = {
    [sym_preproc_region] = STATE(2280),
    [sym_preproc_endregion] = STATE(2280),
    [sym_preproc_line] = STATE(2280),
    [sym_preproc_pragma] = STATE(2280),
    [sym_preproc_nullable] = STATE(2280),
    [sym_preproc_error] = STATE(2280),
    [sym_preproc_define] = STATE(2280),
    [sym_preproc_undef] = STATE(2280),
    [sym__identifier_token] = ACTIONS(3351),
    [anon_sym_extern] = ACTIONS(3351),
    [anon_sym_alias] = ACTIONS(3351),
    [anon_sym_SEMI] = ACTIONS(3353),
    [anon_sym_global] = ACTIONS(3351),
    [anon_sym_using] = ACTIONS(3351),
    [anon_sym_unsafe] = ACTIONS(3351),
    [anon_sym_static] = ACTIONS(3351),
    [anon_sym_LBRACK] = ACTIONS(3353),
    [anon_sym_LPAREN] = ACTIONS(3353),
    [anon_sym_return] = ACTIONS(3351),
    [anon_sym_namespace] = ACTIONS(3351),
    [anon_sym_class] = ACTIONS(3351),
    [anon_sym_ref] = ACTIONS(3351),
    [anon_sym_struct] = ACTIONS(3351),
    [anon_sym_enum] = ACTIONS(3351),
    [anon_sym_LBRACE] = ACTIONS(3353),
    [anon_sym_interface] = ACTIONS(3351),
    [anon_sym_delegate] = ACTIONS(3351),
    [anon_sym_record] = ACTIONS(3351),
    [anon_sym_abstract] = ACTIONS(3351),
    [anon_sym_async] = ACTIONS(3351),
    [anon_sym_const] = ACTIONS(3351),
    [anon_sym_file] = ACTIONS(3351),
    [anon_sym_fixed] = ACTIONS(3351),
    [anon_sym_internal] = ACTIONS(3351),
    [anon_sym_new] = ACTIONS(3351),
    [anon_sym_override] = ACTIONS(3351),
    [anon_sym_partial] = ACTIONS(3351),
    [anon_sym_private] = ACTIONS(3351),
    [anon_sym_protected] = ACTIONS(3351),
    [anon_sym_public] = ACTIONS(3351),
    [anon_sym_readonly] = ACTIONS(3351),
    [anon_sym_required] = ACTIONS(3351),
    [anon_sym_sealed] = ACTIONS(3351),
    [anon_sym_virtual] = ACTIONS(3351),
    [anon_sym_volatile] = ACTIONS(3351),
    [anon_sym_where] = ACTIONS(3351),
    [anon_sym_notnull] = ACTIONS(3351),
    [anon_sym_unmanaged] = ACTIONS(3351),
    [anon_sym_checked] = ACTIONS(3351),
    [anon_sym_BANG] = ACTIONS(3353),
    [anon_sym_TILDE] = ACTIONS(3353),
    [anon_sym_PLUS_PLUS] = ACTIONS(3353),
    [anon_sym_DASH_DASH] = ACTIONS(3353),
    [anon_sym_true] = ACTIONS(3351),
    [anon_sym_false] = ACTIONS(3351),
    [anon_sym_PLUS] = ACTIONS(3351),
    [anon_sym_DASH] = ACTIONS(3351),
    [anon_sym_STAR] = ACTIONS(3353),
    [anon_sym_CARET] = ACTIONS(3353),
    [anon_sym_AMP] = ACTIONS(3353),
    [anon_sym_this] = ACTIONS(3351),
    [anon_sym_scoped] = ACTIONS(3351),
    [anon_sym_var] = ACTIONS(3351),
    [sym_predefined_type] = ACTIONS(3351),
    [anon_sym_break] = ACTIONS(3351),
    [anon_sym_unchecked] = ACTIONS(3351),
    [anon_sym_continue] = ACTIONS(3351),
    [anon_sym_do] = ACTIONS(3351),
    [anon_sym_while] = ACTIONS(3351),
    [anon_sym_for] = ACTIONS(3351),
    [anon_sym_lock] = ACTIONS(3351),
    [anon_sym_yield] = ACTIONS(3351),
    [anon_sym_switch] = ACTIONS(3351),
    [anon_sym_default] = ACTIONS(3351),
    [anon_sym_throw] = ACTIONS(3351),
    [anon_sym_try] = ACTIONS(3351),
    [anon_sym_when] = ACTIONS(3351),
    [anon_sym_await] = ACTIONS(3351),
    [anon_sym_foreach] = ACTIONS(3351),
    [anon_sym_goto] = ACTIONS(3351),
    [anon_sym_if] = ACTIONS(3351),
    [anon_sym_else] = ACTIONS(3351),
    [anon_sym_DOT_DOT] = ACTIONS(3353),
    [anon_sym_from] = ACTIONS(3351),
    [anon_sym_into] = ACTIONS(3351),
    [anon_sym_join] = ACTIONS(3351),
    [anon_sym_on] = ACTIONS(3351),
    [anon_sym_equals] = ACTIONS(3351),
    [anon_sym_let] = ACTIONS(3351),
    [anon_sym_orderby] = ACTIONS(3351),
    [anon_sym_ascending] = ACTIONS(3351),
    [anon_sym_descending] = ACTIONS(3351),
    [anon_sym_group] = ACTIONS(3351),
    [anon_sym_by] = ACTIONS(3351),
    [anon_sym_select] = ACTIONS(3351),
    [anon_sym_DQUOTE] = ACTIONS(3351),
    [anon_sym_stackalloc] = ACTIONS(3351),
    [anon_sym_sizeof] = ACTIONS(3351),
    [anon_sym_typeof] = ACTIONS(3351),
    [anon_sym___makeref] = ACTIONS(3351),
    [anon_sym___reftype] = ACTIONS(3351),
    [anon_sym___refvalue] = ACTIONS(3351),
    [sym_null_literal] = ACTIONS(3351),
    [anon_sym_SQUOTE] = ACTIONS(3353),
    [sym_integer_literal] = ACTIONS(3351),
    [sym_real_literal] = ACTIONS(3353),
    [sym_verbatim_string_literal] = ACTIONS(3353),
    [sym_raw_string_literal] = ACTIONS(3353),
    [aux_sym_preproc_if_token1] = ACTIONS(3353),
    [aux_sym_preproc_if_token3] = ACTIONS(3353),
    [aux_sym_preproc_else_token1] = ACTIONS(3353),
    [aux_sym_preproc_elif_token1] = ACTIONS(3353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3353),
    [sym_interpolation_verbatim_start] = ACTIONS(3353),
    [sym_interpolation_raw_start] = ACTIONS(3353),
  },
  [2281] = {
    [sym_preproc_region] = STATE(2281),
    [sym_preproc_endregion] = STATE(2281),
    [sym_preproc_line] = STATE(2281),
    [sym_preproc_pragma] = STATE(2281),
    [sym_preproc_nullable] = STATE(2281),
    [sym_preproc_error] = STATE(2281),
    [sym_preproc_define] = STATE(2281),
    [sym_preproc_undef] = STATE(2281),
    [sym__identifier_token] = ACTIONS(3355),
    [anon_sym_extern] = ACTIONS(3355),
    [anon_sym_alias] = ACTIONS(3355),
    [anon_sym_SEMI] = ACTIONS(3357),
    [anon_sym_global] = ACTIONS(3355),
    [anon_sym_using] = ACTIONS(3355),
    [anon_sym_unsafe] = ACTIONS(3355),
    [anon_sym_static] = ACTIONS(3355),
    [anon_sym_LBRACK] = ACTIONS(3357),
    [anon_sym_LPAREN] = ACTIONS(3357),
    [anon_sym_return] = ACTIONS(3355),
    [anon_sym_namespace] = ACTIONS(3355),
    [anon_sym_class] = ACTIONS(3355),
    [anon_sym_ref] = ACTIONS(3355),
    [anon_sym_struct] = ACTIONS(3355),
    [anon_sym_enum] = ACTIONS(3355),
    [anon_sym_LBRACE] = ACTIONS(3357),
    [anon_sym_interface] = ACTIONS(3355),
    [anon_sym_delegate] = ACTIONS(3355),
    [anon_sym_record] = ACTIONS(3355),
    [anon_sym_abstract] = ACTIONS(3355),
    [anon_sym_async] = ACTIONS(3355),
    [anon_sym_const] = ACTIONS(3355),
    [anon_sym_file] = ACTIONS(3355),
    [anon_sym_fixed] = ACTIONS(3355),
    [anon_sym_internal] = ACTIONS(3355),
    [anon_sym_new] = ACTIONS(3355),
    [anon_sym_override] = ACTIONS(3355),
    [anon_sym_partial] = ACTIONS(3355),
    [anon_sym_private] = ACTIONS(3355),
    [anon_sym_protected] = ACTIONS(3355),
    [anon_sym_public] = ACTIONS(3355),
    [anon_sym_readonly] = ACTIONS(3355),
    [anon_sym_required] = ACTIONS(3355),
    [anon_sym_sealed] = ACTIONS(3355),
    [anon_sym_virtual] = ACTIONS(3355),
    [anon_sym_volatile] = ACTIONS(3355),
    [anon_sym_where] = ACTIONS(3355),
    [anon_sym_notnull] = ACTIONS(3355),
    [anon_sym_unmanaged] = ACTIONS(3355),
    [anon_sym_checked] = ACTIONS(3355),
    [anon_sym_BANG] = ACTIONS(3357),
    [anon_sym_TILDE] = ACTIONS(3357),
    [anon_sym_PLUS_PLUS] = ACTIONS(3357),
    [anon_sym_DASH_DASH] = ACTIONS(3357),
    [anon_sym_true] = ACTIONS(3355),
    [anon_sym_false] = ACTIONS(3355),
    [anon_sym_PLUS] = ACTIONS(3355),
    [anon_sym_DASH] = ACTIONS(3355),
    [anon_sym_STAR] = ACTIONS(3357),
    [anon_sym_CARET] = ACTIONS(3357),
    [anon_sym_AMP] = ACTIONS(3357),
    [anon_sym_this] = ACTIONS(3355),
    [anon_sym_scoped] = ACTIONS(3355),
    [anon_sym_var] = ACTIONS(3355),
    [sym_predefined_type] = ACTIONS(3355),
    [anon_sym_break] = ACTIONS(3355),
    [anon_sym_unchecked] = ACTIONS(3355),
    [anon_sym_continue] = ACTIONS(3355),
    [anon_sym_do] = ACTIONS(3355),
    [anon_sym_while] = ACTIONS(3355),
    [anon_sym_for] = ACTIONS(3355),
    [anon_sym_lock] = ACTIONS(3355),
    [anon_sym_yield] = ACTIONS(3355),
    [anon_sym_switch] = ACTIONS(3355),
    [anon_sym_default] = ACTIONS(3355),
    [anon_sym_throw] = ACTIONS(3355),
    [anon_sym_try] = ACTIONS(3355),
    [anon_sym_when] = ACTIONS(3355),
    [anon_sym_await] = ACTIONS(3355),
    [anon_sym_foreach] = ACTIONS(3355),
    [anon_sym_goto] = ACTIONS(3355),
    [anon_sym_if] = ACTIONS(3355),
    [anon_sym_else] = ACTIONS(3355),
    [anon_sym_DOT_DOT] = ACTIONS(3357),
    [anon_sym_from] = ACTIONS(3355),
    [anon_sym_into] = ACTIONS(3355),
    [anon_sym_join] = ACTIONS(3355),
    [anon_sym_on] = ACTIONS(3355),
    [anon_sym_equals] = ACTIONS(3355),
    [anon_sym_let] = ACTIONS(3355),
    [anon_sym_orderby] = ACTIONS(3355),
    [anon_sym_ascending] = ACTIONS(3355),
    [anon_sym_descending] = ACTIONS(3355),
    [anon_sym_group] = ACTIONS(3355),
    [anon_sym_by] = ACTIONS(3355),
    [anon_sym_select] = ACTIONS(3355),
    [anon_sym_DQUOTE] = ACTIONS(3355),
    [anon_sym_stackalloc] = ACTIONS(3355),
    [anon_sym_sizeof] = ACTIONS(3355),
    [anon_sym_typeof] = ACTIONS(3355),
    [anon_sym___makeref] = ACTIONS(3355),
    [anon_sym___reftype] = ACTIONS(3355),
    [anon_sym___refvalue] = ACTIONS(3355),
    [sym_null_literal] = ACTIONS(3355),
    [anon_sym_SQUOTE] = ACTIONS(3357),
    [sym_integer_literal] = ACTIONS(3355),
    [sym_real_literal] = ACTIONS(3357),
    [sym_verbatim_string_literal] = ACTIONS(3357),
    [sym_raw_string_literal] = ACTIONS(3357),
    [aux_sym_preproc_if_token1] = ACTIONS(3357),
    [aux_sym_preproc_if_token3] = ACTIONS(3357),
    [aux_sym_preproc_else_token1] = ACTIONS(3357),
    [aux_sym_preproc_elif_token1] = ACTIONS(3357),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3357),
    [sym_interpolation_verbatim_start] = ACTIONS(3357),
    [sym_interpolation_raw_start] = ACTIONS(3357),
  },
  [2282] = {
    [sym_preproc_region] = STATE(2282),
    [sym_preproc_endregion] = STATE(2282),
    [sym_preproc_line] = STATE(2282),
    [sym_preproc_pragma] = STATE(2282),
    [sym_preproc_nullable] = STATE(2282),
    [sym_preproc_error] = STATE(2282),
    [sym_preproc_define] = STATE(2282),
    [sym_preproc_undef] = STATE(2282),
    [sym__identifier_token] = ACTIONS(3359),
    [anon_sym_extern] = ACTIONS(3359),
    [anon_sym_alias] = ACTIONS(3359),
    [anon_sym_SEMI] = ACTIONS(3361),
    [anon_sym_global] = ACTIONS(3359),
    [anon_sym_using] = ACTIONS(3359),
    [anon_sym_unsafe] = ACTIONS(3359),
    [anon_sym_static] = ACTIONS(3359),
    [anon_sym_LBRACK] = ACTIONS(3361),
    [anon_sym_LPAREN] = ACTIONS(3361),
    [anon_sym_return] = ACTIONS(3359),
    [anon_sym_namespace] = ACTIONS(3359),
    [anon_sym_class] = ACTIONS(3359),
    [anon_sym_ref] = ACTIONS(3359),
    [anon_sym_struct] = ACTIONS(3359),
    [anon_sym_enum] = ACTIONS(3359),
    [anon_sym_LBRACE] = ACTIONS(3361),
    [anon_sym_interface] = ACTIONS(3359),
    [anon_sym_delegate] = ACTIONS(3359),
    [anon_sym_record] = ACTIONS(3359),
    [anon_sym_abstract] = ACTIONS(3359),
    [anon_sym_async] = ACTIONS(3359),
    [anon_sym_const] = ACTIONS(3359),
    [anon_sym_file] = ACTIONS(3359),
    [anon_sym_fixed] = ACTIONS(3359),
    [anon_sym_internal] = ACTIONS(3359),
    [anon_sym_new] = ACTIONS(3359),
    [anon_sym_override] = ACTIONS(3359),
    [anon_sym_partial] = ACTIONS(3359),
    [anon_sym_private] = ACTIONS(3359),
    [anon_sym_protected] = ACTIONS(3359),
    [anon_sym_public] = ACTIONS(3359),
    [anon_sym_readonly] = ACTIONS(3359),
    [anon_sym_required] = ACTIONS(3359),
    [anon_sym_sealed] = ACTIONS(3359),
    [anon_sym_virtual] = ACTIONS(3359),
    [anon_sym_volatile] = ACTIONS(3359),
    [anon_sym_where] = ACTIONS(3359),
    [anon_sym_notnull] = ACTIONS(3359),
    [anon_sym_unmanaged] = ACTIONS(3359),
    [anon_sym_checked] = ACTIONS(3359),
    [anon_sym_BANG] = ACTIONS(3361),
    [anon_sym_TILDE] = ACTIONS(3361),
    [anon_sym_PLUS_PLUS] = ACTIONS(3361),
    [anon_sym_DASH_DASH] = ACTIONS(3361),
    [anon_sym_true] = ACTIONS(3359),
    [anon_sym_false] = ACTIONS(3359),
    [anon_sym_PLUS] = ACTIONS(3359),
    [anon_sym_DASH] = ACTIONS(3359),
    [anon_sym_STAR] = ACTIONS(3361),
    [anon_sym_CARET] = ACTIONS(3361),
    [anon_sym_AMP] = ACTIONS(3361),
    [anon_sym_this] = ACTIONS(3359),
    [anon_sym_scoped] = ACTIONS(3359),
    [anon_sym_var] = ACTIONS(3359),
    [sym_predefined_type] = ACTIONS(3359),
    [anon_sym_break] = ACTIONS(3359),
    [anon_sym_unchecked] = ACTIONS(3359),
    [anon_sym_continue] = ACTIONS(3359),
    [anon_sym_do] = ACTIONS(3359),
    [anon_sym_while] = ACTIONS(3359),
    [anon_sym_for] = ACTIONS(3359),
    [anon_sym_lock] = ACTIONS(3359),
    [anon_sym_yield] = ACTIONS(3359),
    [anon_sym_switch] = ACTIONS(3359),
    [anon_sym_default] = ACTIONS(3359),
    [anon_sym_throw] = ACTIONS(3359),
    [anon_sym_try] = ACTIONS(3359),
    [anon_sym_when] = ACTIONS(3359),
    [anon_sym_await] = ACTIONS(3359),
    [anon_sym_foreach] = ACTIONS(3359),
    [anon_sym_goto] = ACTIONS(3359),
    [anon_sym_if] = ACTIONS(3359),
    [anon_sym_else] = ACTIONS(3359),
    [anon_sym_DOT_DOT] = ACTIONS(3361),
    [anon_sym_from] = ACTIONS(3359),
    [anon_sym_into] = ACTIONS(3359),
    [anon_sym_join] = ACTIONS(3359),
    [anon_sym_on] = ACTIONS(3359),
    [anon_sym_equals] = ACTIONS(3359),
    [anon_sym_let] = ACTIONS(3359),
    [anon_sym_orderby] = ACTIONS(3359),
    [anon_sym_ascending] = ACTIONS(3359),
    [anon_sym_descending] = ACTIONS(3359),
    [anon_sym_group] = ACTIONS(3359),
    [anon_sym_by] = ACTIONS(3359),
    [anon_sym_select] = ACTIONS(3359),
    [anon_sym_DQUOTE] = ACTIONS(3359),
    [anon_sym_stackalloc] = ACTIONS(3359),
    [anon_sym_sizeof] = ACTIONS(3359),
    [anon_sym_typeof] = ACTIONS(3359),
    [anon_sym___makeref] = ACTIONS(3359),
    [anon_sym___reftype] = ACTIONS(3359),
    [anon_sym___refvalue] = ACTIONS(3359),
    [sym_null_literal] = ACTIONS(3359),
    [anon_sym_SQUOTE] = ACTIONS(3361),
    [sym_integer_literal] = ACTIONS(3359),
    [sym_real_literal] = ACTIONS(3361),
    [sym_verbatim_string_literal] = ACTIONS(3361),
    [sym_raw_string_literal] = ACTIONS(3361),
    [aux_sym_preproc_if_token1] = ACTIONS(3361),
    [aux_sym_preproc_if_token3] = ACTIONS(3361),
    [aux_sym_preproc_else_token1] = ACTIONS(3361),
    [aux_sym_preproc_elif_token1] = ACTIONS(3361),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3361),
    [sym_interpolation_verbatim_start] = ACTIONS(3361),
    [sym_interpolation_raw_start] = ACTIONS(3361),
  },
  [2283] = {
    [sym_preproc_region] = STATE(2283),
    [sym_preproc_endregion] = STATE(2283),
    [sym_preproc_line] = STATE(2283),
    [sym_preproc_pragma] = STATE(2283),
    [sym_preproc_nullable] = STATE(2283),
    [sym_preproc_error] = STATE(2283),
    [sym_preproc_define] = STATE(2283),
    [sym_preproc_undef] = STATE(2283),
    [sym__identifier_token] = ACTIONS(3363),
    [anon_sym_extern] = ACTIONS(3363),
    [anon_sym_alias] = ACTIONS(3363),
    [anon_sym_SEMI] = ACTIONS(3365),
    [anon_sym_global] = ACTIONS(3363),
    [anon_sym_using] = ACTIONS(3363),
    [anon_sym_unsafe] = ACTIONS(3363),
    [anon_sym_static] = ACTIONS(3363),
    [anon_sym_LBRACK] = ACTIONS(3365),
    [anon_sym_LPAREN] = ACTIONS(3365),
    [anon_sym_return] = ACTIONS(3363),
    [anon_sym_namespace] = ACTIONS(3363),
    [anon_sym_class] = ACTIONS(3363),
    [anon_sym_ref] = ACTIONS(3363),
    [anon_sym_struct] = ACTIONS(3363),
    [anon_sym_enum] = ACTIONS(3363),
    [anon_sym_LBRACE] = ACTIONS(3365),
    [anon_sym_interface] = ACTIONS(3363),
    [anon_sym_delegate] = ACTIONS(3363),
    [anon_sym_record] = ACTIONS(3363),
    [anon_sym_abstract] = ACTIONS(3363),
    [anon_sym_async] = ACTIONS(3363),
    [anon_sym_const] = ACTIONS(3363),
    [anon_sym_file] = ACTIONS(3363),
    [anon_sym_fixed] = ACTIONS(3363),
    [anon_sym_internal] = ACTIONS(3363),
    [anon_sym_new] = ACTIONS(3363),
    [anon_sym_override] = ACTIONS(3363),
    [anon_sym_partial] = ACTIONS(3363),
    [anon_sym_private] = ACTIONS(3363),
    [anon_sym_protected] = ACTIONS(3363),
    [anon_sym_public] = ACTIONS(3363),
    [anon_sym_readonly] = ACTIONS(3363),
    [anon_sym_required] = ACTIONS(3363),
    [anon_sym_sealed] = ACTIONS(3363),
    [anon_sym_virtual] = ACTIONS(3363),
    [anon_sym_volatile] = ACTIONS(3363),
    [anon_sym_where] = ACTIONS(3363),
    [anon_sym_notnull] = ACTIONS(3363),
    [anon_sym_unmanaged] = ACTIONS(3363),
    [anon_sym_checked] = ACTIONS(3363),
    [anon_sym_BANG] = ACTIONS(3365),
    [anon_sym_TILDE] = ACTIONS(3365),
    [anon_sym_PLUS_PLUS] = ACTIONS(3365),
    [anon_sym_DASH_DASH] = ACTIONS(3365),
    [anon_sym_true] = ACTIONS(3363),
    [anon_sym_false] = ACTIONS(3363),
    [anon_sym_PLUS] = ACTIONS(3363),
    [anon_sym_DASH] = ACTIONS(3363),
    [anon_sym_STAR] = ACTIONS(3365),
    [anon_sym_CARET] = ACTIONS(3365),
    [anon_sym_AMP] = ACTIONS(3365),
    [anon_sym_this] = ACTIONS(3363),
    [anon_sym_scoped] = ACTIONS(3363),
    [anon_sym_var] = ACTIONS(3363),
    [sym_predefined_type] = ACTIONS(3363),
    [anon_sym_break] = ACTIONS(3363),
    [anon_sym_unchecked] = ACTIONS(3363),
    [anon_sym_continue] = ACTIONS(3363),
    [anon_sym_do] = ACTIONS(3363),
    [anon_sym_while] = ACTIONS(3363),
    [anon_sym_for] = ACTIONS(3363),
    [anon_sym_lock] = ACTIONS(3363),
    [anon_sym_yield] = ACTIONS(3363),
    [anon_sym_switch] = ACTIONS(3363),
    [anon_sym_default] = ACTIONS(3363),
    [anon_sym_throw] = ACTIONS(3363),
    [anon_sym_try] = ACTIONS(3363),
    [anon_sym_when] = ACTIONS(3363),
    [anon_sym_await] = ACTIONS(3363),
    [anon_sym_foreach] = ACTIONS(3363),
    [anon_sym_goto] = ACTIONS(3363),
    [anon_sym_if] = ACTIONS(3363),
    [anon_sym_else] = ACTIONS(3363),
    [anon_sym_DOT_DOT] = ACTIONS(3365),
    [anon_sym_from] = ACTIONS(3363),
    [anon_sym_into] = ACTIONS(3363),
    [anon_sym_join] = ACTIONS(3363),
    [anon_sym_on] = ACTIONS(3363),
    [anon_sym_equals] = ACTIONS(3363),
    [anon_sym_let] = ACTIONS(3363),
    [anon_sym_orderby] = ACTIONS(3363),
    [anon_sym_ascending] = ACTIONS(3363),
    [anon_sym_descending] = ACTIONS(3363),
    [anon_sym_group] = ACTIONS(3363),
    [anon_sym_by] = ACTIONS(3363),
    [anon_sym_select] = ACTIONS(3363),
    [anon_sym_DQUOTE] = ACTIONS(3363),
    [anon_sym_stackalloc] = ACTIONS(3363),
    [anon_sym_sizeof] = ACTIONS(3363),
    [anon_sym_typeof] = ACTIONS(3363),
    [anon_sym___makeref] = ACTIONS(3363),
    [anon_sym___reftype] = ACTIONS(3363),
    [anon_sym___refvalue] = ACTIONS(3363),
    [sym_null_literal] = ACTIONS(3363),
    [anon_sym_SQUOTE] = ACTIONS(3365),
    [sym_integer_literal] = ACTIONS(3363),
    [sym_real_literal] = ACTIONS(3365),
    [sym_verbatim_string_literal] = ACTIONS(3365),
    [sym_raw_string_literal] = ACTIONS(3365),
    [aux_sym_preproc_if_token1] = ACTIONS(3365),
    [aux_sym_preproc_if_token3] = ACTIONS(3365),
    [aux_sym_preproc_else_token1] = ACTIONS(3365),
    [aux_sym_preproc_elif_token1] = ACTIONS(3365),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3365),
    [sym_interpolation_verbatim_start] = ACTIONS(3365),
    [sym_interpolation_raw_start] = ACTIONS(3365),
  },
  [2284] = {
    [sym_preproc_region] = STATE(2284),
    [sym_preproc_endregion] = STATE(2284),
    [sym_preproc_line] = STATE(2284),
    [sym_preproc_pragma] = STATE(2284),
    [sym_preproc_nullable] = STATE(2284),
    [sym_preproc_error] = STATE(2284),
    [sym_preproc_define] = STATE(2284),
    [sym_preproc_undef] = STATE(2284),
    [sym__identifier_token] = ACTIONS(3367),
    [anon_sym_extern] = ACTIONS(3367),
    [anon_sym_alias] = ACTIONS(3367),
    [anon_sym_SEMI] = ACTIONS(3369),
    [anon_sym_global] = ACTIONS(3367),
    [anon_sym_using] = ACTIONS(3367),
    [anon_sym_unsafe] = ACTIONS(3367),
    [anon_sym_static] = ACTIONS(3367),
    [anon_sym_LBRACK] = ACTIONS(3369),
    [anon_sym_LPAREN] = ACTIONS(3369),
    [anon_sym_return] = ACTIONS(3367),
    [anon_sym_namespace] = ACTIONS(3367),
    [anon_sym_class] = ACTIONS(3367),
    [anon_sym_ref] = ACTIONS(3367),
    [anon_sym_struct] = ACTIONS(3367),
    [anon_sym_enum] = ACTIONS(3367),
    [anon_sym_LBRACE] = ACTIONS(3369),
    [anon_sym_interface] = ACTIONS(3367),
    [anon_sym_delegate] = ACTIONS(3367),
    [anon_sym_record] = ACTIONS(3367),
    [anon_sym_abstract] = ACTIONS(3367),
    [anon_sym_async] = ACTIONS(3367),
    [anon_sym_const] = ACTIONS(3367),
    [anon_sym_file] = ACTIONS(3367),
    [anon_sym_fixed] = ACTIONS(3367),
    [anon_sym_internal] = ACTIONS(3367),
    [anon_sym_new] = ACTIONS(3367),
    [anon_sym_override] = ACTIONS(3367),
    [anon_sym_partial] = ACTIONS(3367),
    [anon_sym_private] = ACTIONS(3367),
    [anon_sym_protected] = ACTIONS(3367),
    [anon_sym_public] = ACTIONS(3367),
    [anon_sym_readonly] = ACTIONS(3367),
    [anon_sym_required] = ACTIONS(3367),
    [anon_sym_sealed] = ACTIONS(3367),
    [anon_sym_virtual] = ACTIONS(3367),
    [anon_sym_volatile] = ACTIONS(3367),
    [anon_sym_where] = ACTIONS(3367),
    [anon_sym_notnull] = ACTIONS(3367),
    [anon_sym_unmanaged] = ACTIONS(3367),
    [anon_sym_checked] = ACTIONS(3367),
    [anon_sym_BANG] = ACTIONS(3369),
    [anon_sym_TILDE] = ACTIONS(3369),
    [anon_sym_PLUS_PLUS] = ACTIONS(3369),
    [anon_sym_DASH_DASH] = ACTIONS(3369),
    [anon_sym_true] = ACTIONS(3367),
    [anon_sym_false] = ACTIONS(3367),
    [anon_sym_PLUS] = ACTIONS(3367),
    [anon_sym_DASH] = ACTIONS(3367),
    [anon_sym_STAR] = ACTIONS(3369),
    [anon_sym_CARET] = ACTIONS(3369),
    [anon_sym_AMP] = ACTIONS(3369),
    [anon_sym_this] = ACTIONS(3367),
    [anon_sym_scoped] = ACTIONS(3367),
    [anon_sym_var] = ACTIONS(3367),
    [sym_predefined_type] = ACTIONS(3367),
    [anon_sym_break] = ACTIONS(3367),
    [anon_sym_unchecked] = ACTIONS(3367),
    [anon_sym_continue] = ACTIONS(3367),
    [anon_sym_do] = ACTIONS(3367),
    [anon_sym_while] = ACTIONS(3367),
    [anon_sym_for] = ACTIONS(3367),
    [anon_sym_lock] = ACTIONS(3367),
    [anon_sym_yield] = ACTIONS(3367),
    [anon_sym_switch] = ACTIONS(3367),
    [anon_sym_default] = ACTIONS(3367),
    [anon_sym_throw] = ACTIONS(3367),
    [anon_sym_try] = ACTIONS(3367),
    [anon_sym_when] = ACTIONS(3367),
    [anon_sym_await] = ACTIONS(3367),
    [anon_sym_foreach] = ACTIONS(3367),
    [anon_sym_goto] = ACTIONS(3367),
    [anon_sym_if] = ACTIONS(3367),
    [anon_sym_else] = ACTIONS(3367),
    [anon_sym_DOT_DOT] = ACTIONS(3369),
    [anon_sym_from] = ACTIONS(3367),
    [anon_sym_into] = ACTIONS(3367),
    [anon_sym_join] = ACTIONS(3367),
    [anon_sym_on] = ACTIONS(3367),
    [anon_sym_equals] = ACTIONS(3367),
    [anon_sym_let] = ACTIONS(3367),
    [anon_sym_orderby] = ACTIONS(3367),
    [anon_sym_ascending] = ACTIONS(3367),
    [anon_sym_descending] = ACTIONS(3367),
    [anon_sym_group] = ACTIONS(3367),
    [anon_sym_by] = ACTIONS(3367),
    [anon_sym_select] = ACTIONS(3367),
    [anon_sym_DQUOTE] = ACTIONS(3367),
    [anon_sym_stackalloc] = ACTIONS(3367),
    [anon_sym_sizeof] = ACTIONS(3367),
    [anon_sym_typeof] = ACTIONS(3367),
    [anon_sym___makeref] = ACTIONS(3367),
    [anon_sym___reftype] = ACTIONS(3367),
    [anon_sym___refvalue] = ACTIONS(3367),
    [sym_null_literal] = ACTIONS(3367),
    [anon_sym_SQUOTE] = ACTIONS(3369),
    [sym_integer_literal] = ACTIONS(3367),
    [sym_real_literal] = ACTIONS(3369),
    [sym_verbatim_string_literal] = ACTIONS(3369),
    [sym_raw_string_literal] = ACTIONS(3369),
    [aux_sym_preproc_if_token1] = ACTIONS(3369),
    [aux_sym_preproc_if_token3] = ACTIONS(3369),
    [aux_sym_preproc_else_token1] = ACTIONS(3369),
    [aux_sym_preproc_elif_token1] = ACTIONS(3369),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3369),
    [sym_interpolation_verbatim_start] = ACTIONS(3369),
    [sym_interpolation_raw_start] = ACTIONS(3369),
  },
  [2285] = {
    [sym_preproc_region] = STATE(2285),
    [sym_preproc_endregion] = STATE(2285),
    [sym_preproc_line] = STATE(2285),
    [sym_preproc_pragma] = STATE(2285),
    [sym_preproc_nullable] = STATE(2285),
    [sym_preproc_error] = STATE(2285),
    [sym_preproc_define] = STATE(2285),
    [sym_preproc_undef] = STATE(2285),
    [sym__identifier_token] = ACTIONS(3371),
    [anon_sym_extern] = ACTIONS(3371),
    [anon_sym_alias] = ACTIONS(3371),
    [anon_sym_SEMI] = ACTIONS(3373),
    [anon_sym_global] = ACTIONS(3371),
    [anon_sym_using] = ACTIONS(3371),
    [anon_sym_unsafe] = ACTIONS(3371),
    [anon_sym_static] = ACTIONS(3371),
    [anon_sym_LBRACK] = ACTIONS(3373),
    [anon_sym_LPAREN] = ACTIONS(3373),
    [anon_sym_return] = ACTIONS(3371),
    [anon_sym_namespace] = ACTIONS(3371),
    [anon_sym_class] = ACTIONS(3371),
    [anon_sym_ref] = ACTIONS(3371),
    [anon_sym_struct] = ACTIONS(3371),
    [anon_sym_enum] = ACTIONS(3371),
    [anon_sym_LBRACE] = ACTIONS(3373),
    [anon_sym_interface] = ACTIONS(3371),
    [anon_sym_delegate] = ACTIONS(3371),
    [anon_sym_record] = ACTIONS(3371),
    [anon_sym_abstract] = ACTIONS(3371),
    [anon_sym_async] = ACTIONS(3371),
    [anon_sym_const] = ACTIONS(3371),
    [anon_sym_file] = ACTIONS(3371),
    [anon_sym_fixed] = ACTIONS(3371),
    [anon_sym_internal] = ACTIONS(3371),
    [anon_sym_new] = ACTIONS(3371),
    [anon_sym_override] = ACTIONS(3371),
    [anon_sym_partial] = ACTIONS(3371),
    [anon_sym_private] = ACTIONS(3371),
    [anon_sym_protected] = ACTIONS(3371),
    [anon_sym_public] = ACTIONS(3371),
    [anon_sym_readonly] = ACTIONS(3371),
    [anon_sym_required] = ACTIONS(3371),
    [anon_sym_sealed] = ACTIONS(3371),
    [anon_sym_virtual] = ACTIONS(3371),
    [anon_sym_volatile] = ACTIONS(3371),
    [anon_sym_where] = ACTIONS(3371),
    [anon_sym_notnull] = ACTIONS(3371),
    [anon_sym_unmanaged] = ACTIONS(3371),
    [anon_sym_checked] = ACTIONS(3371),
    [anon_sym_BANG] = ACTIONS(3373),
    [anon_sym_TILDE] = ACTIONS(3373),
    [anon_sym_PLUS_PLUS] = ACTIONS(3373),
    [anon_sym_DASH_DASH] = ACTIONS(3373),
    [anon_sym_true] = ACTIONS(3371),
    [anon_sym_false] = ACTIONS(3371),
    [anon_sym_PLUS] = ACTIONS(3371),
    [anon_sym_DASH] = ACTIONS(3371),
    [anon_sym_STAR] = ACTIONS(3373),
    [anon_sym_CARET] = ACTIONS(3373),
    [anon_sym_AMP] = ACTIONS(3373),
    [anon_sym_this] = ACTIONS(3371),
    [anon_sym_scoped] = ACTIONS(3371),
    [anon_sym_var] = ACTIONS(3371),
    [sym_predefined_type] = ACTIONS(3371),
    [anon_sym_break] = ACTIONS(3371),
    [anon_sym_unchecked] = ACTIONS(3371),
    [anon_sym_continue] = ACTIONS(3371),
    [anon_sym_do] = ACTIONS(3371),
    [anon_sym_while] = ACTIONS(3371),
    [anon_sym_for] = ACTIONS(3371),
    [anon_sym_lock] = ACTIONS(3371),
    [anon_sym_yield] = ACTIONS(3371),
    [anon_sym_switch] = ACTIONS(3371),
    [anon_sym_default] = ACTIONS(3371),
    [anon_sym_throw] = ACTIONS(3371),
    [anon_sym_try] = ACTIONS(3371),
    [anon_sym_when] = ACTIONS(3371),
    [anon_sym_await] = ACTIONS(3371),
    [anon_sym_foreach] = ACTIONS(3371),
    [anon_sym_goto] = ACTIONS(3371),
    [anon_sym_if] = ACTIONS(3371),
    [anon_sym_else] = ACTIONS(3371),
    [anon_sym_DOT_DOT] = ACTIONS(3373),
    [anon_sym_from] = ACTIONS(3371),
    [anon_sym_into] = ACTIONS(3371),
    [anon_sym_join] = ACTIONS(3371),
    [anon_sym_on] = ACTIONS(3371),
    [anon_sym_equals] = ACTIONS(3371),
    [anon_sym_let] = ACTIONS(3371),
    [anon_sym_orderby] = ACTIONS(3371),
    [anon_sym_ascending] = ACTIONS(3371),
    [anon_sym_descending] = ACTIONS(3371),
    [anon_sym_group] = ACTIONS(3371),
    [anon_sym_by] = ACTIONS(3371),
    [anon_sym_select] = ACTIONS(3371),
    [anon_sym_DQUOTE] = ACTIONS(3371),
    [anon_sym_stackalloc] = ACTIONS(3371),
    [anon_sym_sizeof] = ACTIONS(3371),
    [anon_sym_typeof] = ACTIONS(3371),
    [anon_sym___makeref] = ACTIONS(3371),
    [anon_sym___reftype] = ACTIONS(3371),
    [anon_sym___refvalue] = ACTIONS(3371),
    [sym_null_literal] = ACTIONS(3371),
    [anon_sym_SQUOTE] = ACTIONS(3373),
    [sym_integer_literal] = ACTIONS(3371),
    [sym_real_literal] = ACTIONS(3373),
    [sym_verbatim_string_literal] = ACTIONS(3373),
    [sym_raw_string_literal] = ACTIONS(3373),
    [aux_sym_preproc_if_token1] = ACTIONS(3373),
    [aux_sym_preproc_if_token3] = ACTIONS(3373),
    [aux_sym_preproc_else_token1] = ACTIONS(3373),
    [aux_sym_preproc_elif_token1] = ACTIONS(3373),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3373),
    [sym_interpolation_verbatim_start] = ACTIONS(3373),
    [sym_interpolation_raw_start] = ACTIONS(3373),
  },
  [2286] = {
    [sym_preproc_region] = STATE(2286),
    [sym_preproc_endregion] = STATE(2286),
    [sym_preproc_line] = STATE(2286),
    [sym_preproc_pragma] = STATE(2286),
    [sym_preproc_nullable] = STATE(2286),
    [sym_preproc_error] = STATE(2286),
    [sym_preproc_define] = STATE(2286),
    [sym_preproc_undef] = STATE(2286),
    [sym__identifier_token] = ACTIONS(3375),
    [anon_sym_extern] = ACTIONS(3375),
    [anon_sym_alias] = ACTIONS(3375),
    [anon_sym_SEMI] = ACTIONS(3377),
    [anon_sym_global] = ACTIONS(3375),
    [anon_sym_using] = ACTIONS(3375),
    [anon_sym_unsafe] = ACTIONS(3375),
    [anon_sym_static] = ACTIONS(3375),
    [anon_sym_LBRACK] = ACTIONS(3377),
    [anon_sym_LPAREN] = ACTIONS(3377),
    [anon_sym_return] = ACTIONS(3375),
    [anon_sym_namespace] = ACTIONS(3375),
    [anon_sym_class] = ACTIONS(3375),
    [anon_sym_ref] = ACTIONS(3375),
    [anon_sym_struct] = ACTIONS(3375),
    [anon_sym_enum] = ACTIONS(3375),
    [anon_sym_LBRACE] = ACTIONS(3377),
    [anon_sym_interface] = ACTIONS(3375),
    [anon_sym_delegate] = ACTIONS(3375),
    [anon_sym_record] = ACTIONS(3375),
    [anon_sym_abstract] = ACTIONS(3375),
    [anon_sym_async] = ACTIONS(3375),
    [anon_sym_const] = ACTIONS(3375),
    [anon_sym_file] = ACTIONS(3375),
    [anon_sym_fixed] = ACTIONS(3375),
    [anon_sym_internal] = ACTIONS(3375),
    [anon_sym_new] = ACTIONS(3375),
    [anon_sym_override] = ACTIONS(3375),
    [anon_sym_partial] = ACTIONS(3375),
    [anon_sym_private] = ACTIONS(3375),
    [anon_sym_protected] = ACTIONS(3375),
    [anon_sym_public] = ACTIONS(3375),
    [anon_sym_readonly] = ACTIONS(3375),
    [anon_sym_required] = ACTIONS(3375),
    [anon_sym_sealed] = ACTIONS(3375),
    [anon_sym_virtual] = ACTIONS(3375),
    [anon_sym_volatile] = ACTIONS(3375),
    [anon_sym_where] = ACTIONS(3375),
    [anon_sym_notnull] = ACTIONS(3375),
    [anon_sym_unmanaged] = ACTIONS(3375),
    [anon_sym_checked] = ACTIONS(3375),
    [anon_sym_BANG] = ACTIONS(3377),
    [anon_sym_TILDE] = ACTIONS(3377),
    [anon_sym_PLUS_PLUS] = ACTIONS(3377),
    [anon_sym_DASH_DASH] = ACTIONS(3377),
    [anon_sym_true] = ACTIONS(3375),
    [anon_sym_false] = ACTIONS(3375),
    [anon_sym_PLUS] = ACTIONS(3375),
    [anon_sym_DASH] = ACTIONS(3375),
    [anon_sym_STAR] = ACTIONS(3377),
    [anon_sym_CARET] = ACTIONS(3377),
    [anon_sym_AMP] = ACTIONS(3377),
    [anon_sym_this] = ACTIONS(3375),
    [anon_sym_scoped] = ACTIONS(3375),
    [anon_sym_var] = ACTIONS(3375),
    [sym_predefined_type] = ACTIONS(3375),
    [anon_sym_break] = ACTIONS(3375),
    [anon_sym_unchecked] = ACTIONS(3375),
    [anon_sym_continue] = ACTIONS(3375),
    [anon_sym_do] = ACTIONS(3375),
    [anon_sym_while] = ACTIONS(3375),
    [anon_sym_for] = ACTIONS(3375),
    [anon_sym_lock] = ACTIONS(3375),
    [anon_sym_yield] = ACTIONS(3375),
    [anon_sym_switch] = ACTIONS(3375),
    [anon_sym_default] = ACTIONS(3375),
    [anon_sym_throw] = ACTIONS(3375),
    [anon_sym_try] = ACTIONS(3375),
    [anon_sym_when] = ACTIONS(3375),
    [anon_sym_await] = ACTIONS(3375),
    [anon_sym_foreach] = ACTIONS(3375),
    [anon_sym_goto] = ACTIONS(3375),
    [anon_sym_if] = ACTIONS(3375),
    [anon_sym_else] = ACTIONS(3375),
    [anon_sym_DOT_DOT] = ACTIONS(3377),
    [anon_sym_from] = ACTIONS(3375),
    [anon_sym_into] = ACTIONS(3375),
    [anon_sym_join] = ACTIONS(3375),
    [anon_sym_on] = ACTIONS(3375),
    [anon_sym_equals] = ACTIONS(3375),
    [anon_sym_let] = ACTIONS(3375),
    [anon_sym_orderby] = ACTIONS(3375),
    [anon_sym_ascending] = ACTIONS(3375),
    [anon_sym_descending] = ACTIONS(3375),
    [anon_sym_group] = ACTIONS(3375),
    [anon_sym_by] = ACTIONS(3375),
    [anon_sym_select] = ACTIONS(3375),
    [anon_sym_DQUOTE] = ACTIONS(3375),
    [anon_sym_stackalloc] = ACTIONS(3375),
    [anon_sym_sizeof] = ACTIONS(3375),
    [anon_sym_typeof] = ACTIONS(3375),
    [anon_sym___makeref] = ACTIONS(3375),
    [anon_sym___reftype] = ACTIONS(3375),
    [anon_sym___refvalue] = ACTIONS(3375),
    [sym_null_literal] = ACTIONS(3375),
    [anon_sym_SQUOTE] = ACTIONS(3377),
    [sym_integer_literal] = ACTIONS(3375),
    [sym_real_literal] = ACTIONS(3377),
    [sym_verbatim_string_literal] = ACTIONS(3377),
    [sym_raw_string_literal] = ACTIONS(3377),
    [aux_sym_preproc_if_token1] = ACTIONS(3377),
    [aux_sym_preproc_if_token3] = ACTIONS(3377),
    [aux_sym_preproc_else_token1] = ACTIONS(3377),
    [aux_sym_preproc_elif_token1] = ACTIONS(3377),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3377),
    [sym_interpolation_verbatim_start] = ACTIONS(3377),
    [sym_interpolation_raw_start] = ACTIONS(3377),
  },
  [2287] = {
    [sym_preproc_region] = STATE(2287),
    [sym_preproc_endregion] = STATE(2287),
    [sym_preproc_line] = STATE(2287),
    [sym_preproc_pragma] = STATE(2287),
    [sym_preproc_nullable] = STATE(2287),
    [sym_preproc_error] = STATE(2287),
    [sym_preproc_define] = STATE(2287),
    [sym_preproc_undef] = STATE(2287),
    [sym__identifier_token] = ACTIONS(3379),
    [anon_sym_extern] = ACTIONS(3379),
    [anon_sym_alias] = ACTIONS(3379),
    [anon_sym_SEMI] = ACTIONS(3381),
    [anon_sym_global] = ACTIONS(3379),
    [anon_sym_using] = ACTIONS(3379),
    [anon_sym_unsafe] = ACTIONS(3379),
    [anon_sym_static] = ACTIONS(3379),
    [anon_sym_LBRACK] = ACTIONS(3381),
    [anon_sym_LPAREN] = ACTIONS(3381),
    [anon_sym_return] = ACTIONS(3379),
    [anon_sym_namespace] = ACTIONS(3379),
    [anon_sym_class] = ACTIONS(3379),
    [anon_sym_ref] = ACTIONS(3379),
    [anon_sym_struct] = ACTIONS(3379),
    [anon_sym_enum] = ACTIONS(3379),
    [anon_sym_LBRACE] = ACTIONS(3381),
    [anon_sym_interface] = ACTIONS(3379),
    [anon_sym_delegate] = ACTIONS(3379),
    [anon_sym_record] = ACTIONS(3379),
    [anon_sym_abstract] = ACTIONS(3379),
    [anon_sym_async] = ACTIONS(3379),
    [anon_sym_const] = ACTIONS(3379),
    [anon_sym_file] = ACTIONS(3379),
    [anon_sym_fixed] = ACTIONS(3379),
    [anon_sym_internal] = ACTIONS(3379),
    [anon_sym_new] = ACTIONS(3379),
    [anon_sym_override] = ACTIONS(3379),
    [anon_sym_partial] = ACTIONS(3379),
    [anon_sym_private] = ACTIONS(3379),
    [anon_sym_protected] = ACTIONS(3379),
    [anon_sym_public] = ACTIONS(3379),
    [anon_sym_readonly] = ACTIONS(3379),
    [anon_sym_required] = ACTIONS(3379),
    [anon_sym_sealed] = ACTIONS(3379),
    [anon_sym_virtual] = ACTIONS(3379),
    [anon_sym_volatile] = ACTIONS(3379),
    [anon_sym_where] = ACTIONS(3379),
    [anon_sym_notnull] = ACTIONS(3379),
    [anon_sym_unmanaged] = ACTIONS(3379),
    [anon_sym_checked] = ACTIONS(3379),
    [anon_sym_BANG] = ACTIONS(3381),
    [anon_sym_TILDE] = ACTIONS(3381),
    [anon_sym_PLUS_PLUS] = ACTIONS(3381),
    [anon_sym_DASH_DASH] = ACTIONS(3381),
    [anon_sym_true] = ACTIONS(3379),
    [anon_sym_false] = ACTIONS(3379),
    [anon_sym_PLUS] = ACTIONS(3379),
    [anon_sym_DASH] = ACTIONS(3379),
    [anon_sym_STAR] = ACTIONS(3381),
    [anon_sym_CARET] = ACTIONS(3381),
    [anon_sym_AMP] = ACTIONS(3381),
    [anon_sym_this] = ACTIONS(3379),
    [anon_sym_scoped] = ACTIONS(3379),
    [anon_sym_var] = ACTIONS(3379),
    [sym_predefined_type] = ACTIONS(3379),
    [anon_sym_break] = ACTIONS(3379),
    [anon_sym_unchecked] = ACTIONS(3379),
    [anon_sym_continue] = ACTIONS(3379),
    [anon_sym_do] = ACTIONS(3379),
    [anon_sym_while] = ACTIONS(3379),
    [anon_sym_for] = ACTIONS(3379),
    [anon_sym_lock] = ACTIONS(3379),
    [anon_sym_yield] = ACTIONS(3379),
    [anon_sym_switch] = ACTIONS(3379),
    [anon_sym_default] = ACTIONS(3379),
    [anon_sym_throw] = ACTIONS(3379),
    [anon_sym_try] = ACTIONS(3379),
    [anon_sym_when] = ACTIONS(3379),
    [anon_sym_await] = ACTIONS(3379),
    [anon_sym_foreach] = ACTIONS(3379),
    [anon_sym_goto] = ACTIONS(3379),
    [anon_sym_if] = ACTIONS(3379),
    [anon_sym_else] = ACTIONS(3379),
    [anon_sym_DOT_DOT] = ACTIONS(3381),
    [anon_sym_from] = ACTIONS(3379),
    [anon_sym_into] = ACTIONS(3379),
    [anon_sym_join] = ACTIONS(3379),
    [anon_sym_on] = ACTIONS(3379),
    [anon_sym_equals] = ACTIONS(3379),
    [anon_sym_let] = ACTIONS(3379),
    [anon_sym_orderby] = ACTIONS(3379),
    [anon_sym_ascending] = ACTIONS(3379),
    [anon_sym_descending] = ACTIONS(3379),
    [anon_sym_group] = ACTIONS(3379),
    [anon_sym_by] = ACTIONS(3379),
    [anon_sym_select] = ACTIONS(3379),
    [anon_sym_DQUOTE] = ACTIONS(3379),
    [anon_sym_stackalloc] = ACTIONS(3379),
    [anon_sym_sizeof] = ACTIONS(3379),
    [anon_sym_typeof] = ACTIONS(3379),
    [anon_sym___makeref] = ACTIONS(3379),
    [anon_sym___reftype] = ACTIONS(3379),
    [anon_sym___refvalue] = ACTIONS(3379),
    [sym_null_literal] = ACTIONS(3379),
    [anon_sym_SQUOTE] = ACTIONS(3381),
    [sym_integer_literal] = ACTIONS(3379),
    [sym_real_literal] = ACTIONS(3381),
    [sym_verbatim_string_literal] = ACTIONS(3381),
    [sym_raw_string_literal] = ACTIONS(3381),
    [aux_sym_preproc_if_token1] = ACTIONS(3381),
    [aux_sym_preproc_if_token3] = ACTIONS(3381),
    [aux_sym_preproc_else_token1] = ACTIONS(3381),
    [aux_sym_preproc_elif_token1] = ACTIONS(3381),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3381),
    [sym_interpolation_verbatim_start] = ACTIONS(3381),
    [sym_interpolation_raw_start] = ACTIONS(3381),
  },
  [2288] = {
    [sym_preproc_region] = STATE(2288),
    [sym_preproc_endregion] = STATE(2288),
    [sym_preproc_line] = STATE(2288),
    [sym_preproc_pragma] = STATE(2288),
    [sym_preproc_nullable] = STATE(2288),
    [sym_preproc_error] = STATE(2288),
    [sym_preproc_define] = STATE(2288),
    [sym_preproc_undef] = STATE(2288),
    [sym__identifier_token] = ACTIONS(3383),
    [anon_sym_extern] = ACTIONS(3383),
    [anon_sym_alias] = ACTIONS(3383),
    [anon_sym_SEMI] = ACTIONS(3385),
    [anon_sym_global] = ACTIONS(3383),
    [anon_sym_using] = ACTIONS(3383),
    [anon_sym_unsafe] = ACTIONS(3383),
    [anon_sym_static] = ACTIONS(3383),
    [anon_sym_LBRACK] = ACTIONS(3385),
    [anon_sym_LPAREN] = ACTIONS(3385),
    [anon_sym_return] = ACTIONS(3383),
    [anon_sym_namespace] = ACTIONS(3383),
    [anon_sym_class] = ACTIONS(3383),
    [anon_sym_ref] = ACTIONS(3383),
    [anon_sym_struct] = ACTIONS(3383),
    [anon_sym_enum] = ACTIONS(3383),
    [anon_sym_LBRACE] = ACTIONS(3385),
    [anon_sym_interface] = ACTIONS(3383),
    [anon_sym_delegate] = ACTIONS(3383),
    [anon_sym_record] = ACTIONS(3383),
    [anon_sym_abstract] = ACTIONS(3383),
    [anon_sym_async] = ACTIONS(3383),
    [anon_sym_const] = ACTIONS(3383),
    [anon_sym_file] = ACTIONS(3383),
    [anon_sym_fixed] = ACTIONS(3383),
    [anon_sym_internal] = ACTIONS(3383),
    [anon_sym_new] = ACTIONS(3383),
    [anon_sym_override] = ACTIONS(3383),
    [anon_sym_partial] = ACTIONS(3383),
    [anon_sym_private] = ACTIONS(3383),
    [anon_sym_protected] = ACTIONS(3383),
    [anon_sym_public] = ACTIONS(3383),
    [anon_sym_readonly] = ACTIONS(3383),
    [anon_sym_required] = ACTIONS(3383),
    [anon_sym_sealed] = ACTIONS(3383),
    [anon_sym_virtual] = ACTIONS(3383),
    [anon_sym_volatile] = ACTIONS(3383),
    [anon_sym_where] = ACTIONS(3383),
    [anon_sym_notnull] = ACTIONS(3383),
    [anon_sym_unmanaged] = ACTIONS(3383),
    [anon_sym_checked] = ACTIONS(3383),
    [anon_sym_BANG] = ACTIONS(3385),
    [anon_sym_TILDE] = ACTIONS(3385),
    [anon_sym_PLUS_PLUS] = ACTIONS(3385),
    [anon_sym_DASH_DASH] = ACTIONS(3385),
    [anon_sym_true] = ACTIONS(3383),
    [anon_sym_false] = ACTIONS(3383),
    [anon_sym_PLUS] = ACTIONS(3383),
    [anon_sym_DASH] = ACTIONS(3383),
    [anon_sym_STAR] = ACTIONS(3385),
    [anon_sym_CARET] = ACTIONS(3385),
    [anon_sym_AMP] = ACTIONS(3385),
    [anon_sym_this] = ACTIONS(3383),
    [anon_sym_scoped] = ACTIONS(3383),
    [anon_sym_var] = ACTIONS(3383),
    [sym_predefined_type] = ACTIONS(3383),
    [anon_sym_break] = ACTIONS(3383),
    [anon_sym_unchecked] = ACTIONS(3383),
    [anon_sym_continue] = ACTIONS(3383),
    [anon_sym_do] = ACTIONS(3383),
    [anon_sym_while] = ACTIONS(3383),
    [anon_sym_for] = ACTIONS(3383),
    [anon_sym_lock] = ACTIONS(3383),
    [anon_sym_yield] = ACTIONS(3383),
    [anon_sym_switch] = ACTIONS(3383),
    [anon_sym_default] = ACTIONS(3383),
    [anon_sym_throw] = ACTIONS(3383),
    [anon_sym_try] = ACTIONS(3383),
    [anon_sym_when] = ACTIONS(3383),
    [anon_sym_await] = ACTIONS(3383),
    [anon_sym_foreach] = ACTIONS(3383),
    [anon_sym_goto] = ACTIONS(3383),
    [anon_sym_if] = ACTIONS(3383),
    [anon_sym_else] = ACTIONS(3383),
    [anon_sym_DOT_DOT] = ACTIONS(3385),
    [anon_sym_from] = ACTIONS(3383),
    [anon_sym_into] = ACTIONS(3383),
    [anon_sym_join] = ACTIONS(3383),
    [anon_sym_on] = ACTIONS(3383),
    [anon_sym_equals] = ACTIONS(3383),
    [anon_sym_let] = ACTIONS(3383),
    [anon_sym_orderby] = ACTIONS(3383),
    [anon_sym_ascending] = ACTIONS(3383),
    [anon_sym_descending] = ACTIONS(3383),
    [anon_sym_group] = ACTIONS(3383),
    [anon_sym_by] = ACTIONS(3383),
    [anon_sym_select] = ACTIONS(3383),
    [anon_sym_DQUOTE] = ACTIONS(3383),
    [anon_sym_stackalloc] = ACTIONS(3383),
    [anon_sym_sizeof] = ACTIONS(3383),
    [anon_sym_typeof] = ACTIONS(3383),
    [anon_sym___makeref] = ACTIONS(3383),
    [anon_sym___reftype] = ACTIONS(3383),
    [anon_sym___refvalue] = ACTIONS(3383),
    [sym_null_literal] = ACTIONS(3383),
    [anon_sym_SQUOTE] = ACTIONS(3385),
    [sym_integer_literal] = ACTIONS(3383),
    [sym_real_literal] = ACTIONS(3385),
    [sym_verbatim_string_literal] = ACTIONS(3385),
    [sym_raw_string_literal] = ACTIONS(3385),
    [aux_sym_preproc_if_token1] = ACTIONS(3385),
    [aux_sym_preproc_if_token3] = ACTIONS(3385),
    [aux_sym_preproc_else_token1] = ACTIONS(3385),
    [aux_sym_preproc_elif_token1] = ACTIONS(3385),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3385),
    [sym_interpolation_verbatim_start] = ACTIONS(3385),
    [sym_interpolation_raw_start] = ACTIONS(3385),
  },
  [2289] = {
    [sym_preproc_region] = STATE(2289),
    [sym_preproc_endregion] = STATE(2289),
    [sym_preproc_line] = STATE(2289),
    [sym_preproc_pragma] = STATE(2289),
    [sym_preproc_nullable] = STATE(2289),
    [sym_preproc_error] = STATE(2289),
    [sym_preproc_define] = STATE(2289),
    [sym_preproc_undef] = STATE(2289),
    [sym__identifier_token] = ACTIONS(3387),
    [anon_sym_extern] = ACTIONS(3387),
    [anon_sym_alias] = ACTIONS(3387),
    [anon_sym_SEMI] = ACTIONS(3389),
    [anon_sym_global] = ACTIONS(3387),
    [anon_sym_using] = ACTIONS(3387),
    [anon_sym_unsafe] = ACTIONS(3387),
    [anon_sym_static] = ACTIONS(3387),
    [anon_sym_LBRACK] = ACTIONS(3389),
    [anon_sym_LPAREN] = ACTIONS(3389),
    [anon_sym_return] = ACTIONS(3387),
    [anon_sym_namespace] = ACTIONS(3387),
    [anon_sym_class] = ACTIONS(3387),
    [anon_sym_ref] = ACTIONS(3387),
    [anon_sym_struct] = ACTIONS(3387),
    [anon_sym_enum] = ACTIONS(3387),
    [anon_sym_LBRACE] = ACTIONS(3389),
    [anon_sym_interface] = ACTIONS(3387),
    [anon_sym_delegate] = ACTIONS(3387),
    [anon_sym_record] = ACTIONS(3387),
    [anon_sym_abstract] = ACTIONS(3387),
    [anon_sym_async] = ACTIONS(3387),
    [anon_sym_const] = ACTIONS(3387),
    [anon_sym_file] = ACTIONS(3387),
    [anon_sym_fixed] = ACTIONS(3387),
    [anon_sym_internal] = ACTIONS(3387),
    [anon_sym_new] = ACTIONS(3387),
    [anon_sym_override] = ACTIONS(3387),
    [anon_sym_partial] = ACTIONS(3387),
    [anon_sym_private] = ACTIONS(3387),
    [anon_sym_protected] = ACTIONS(3387),
    [anon_sym_public] = ACTIONS(3387),
    [anon_sym_readonly] = ACTIONS(3387),
    [anon_sym_required] = ACTIONS(3387),
    [anon_sym_sealed] = ACTIONS(3387),
    [anon_sym_virtual] = ACTIONS(3387),
    [anon_sym_volatile] = ACTIONS(3387),
    [anon_sym_where] = ACTIONS(3387),
    [anon_sym_notnull] = ACTIONS(3387),
    [anon_sym_unmanaged] = ACTIONS(3387),
    [anon_sym_checked] = ACTIONS(3387),
    [anon_sym_BANG] = ACTIONS(3389),
    [anon_sym_TILDE] = ACTIONS(3389),
    [anon_sym_PLUS_PLUS] = ACTIONS(3389),
    [anon_sym_DASH_DASH] = ACTIONS(3389),
    [anon_sym_true] = ACTIONS(3387),
    [anon_sym_false] = ACTIONS(3387),
    [anon_sym_PLUS] = ACTIONS(3387),
    [anon_sym_DASH] = ACTIONS(3387),
    [anon_sym_STAR] = ACTIONS(3389),
    [anon_sym_CARET] = ACTIONS(3389),
    [anon_sym_AMP] = ACTIONS(3389),
    [anon_sym_this] = ACTIONS(3387),
    [anon_sym_scoped] = ACTIONS(3387),
    [anon_sym_var] = ACTIONS(3387),
    [sym_predefined_type] = ACTIONS(3387),
    [anon_sym_break] = ACTIONS(3387),
    [anon_sym_unchecked] = ACTIONS(3387),
    [anon_sym_continue] = ACTIONS(3387),
    [anon_sym_do] = ACTIONS(3387),
    [anon_sym_while] = ACTIONS(3387),
    [anon_sym_for] = ACTIONS(3387),
    [anon_sym_lock] = ACTIONS(3387),
    [anon_sym_yield] = ACTIONS(3387),
    [anon_sym_switch] = ACTIONS(3387),
    [anon_sym_default] = ACTIONS(3387),
    [anon_sym_throw] = ACTIONS(3387),
    [anon_sym_try] = ACTIONS(3387),
    [anon_sym_when] = ACTIONS(3387),
    [anon_sym_await] = ACTIONS(3387),
    [anon_sym_foreach] = ACTIONS(3387),
    [anon_sym_goto] = ACTIONS(3387),
    [anon_sym_if] = ACTIONS(3387),
    [anon_sym_else] = ACTIONS(3387),
    [anon_sym_DOT_DOT] = ACTIONS(3389),
    [anon_sym_from] = ACTIONS(3387),
    [anon_sym_into] = ACTIONS(3387),
    [anon_sym_join] = ACTIONS(3387),
    [anon_sym_on] = ACTIONS(3387),
    [anon_sym_equals] = ACTIONS(3387),
    [anon_sym_let] = ACTIONS(3387),
    [anon_sym_orderby] = ACTIONS(3387),
    [anon_sym_ascending] = ACTIONS(3387),
    [anon_sym_descending] = ACTIONS(3387),
    [anon_sym_group] = ACTIONS(3387),
    [anon_sym_by] = ACTIONS(3387),
    [anon_sym_select] = ACTIONS(3387),
    [anon_sym_DQUOTE] = ACTIONS(3387),
    [anon_sym_stackalloc] = ACTIONS(3387),
    [anon_sym_sizeof] = ACTIONS(3387),
    [anon_sym_typeof] = ACTIONS(3387),
    [anon_sym___makeref] = ACTIONS(3387),
    [anon_sym___reftype] = ACTIONS(3387),
    [anon_sym___refvalue] = ACTIONS(3387),
    [sym_null_literal] = ACTIONS(3387),
    [anon_sym_SQUOTE] = ACTIONS(3389),
    [sym_integer_literal] = ACTIONS(3387),
    [sym_real_literal] = ACTIONS(3389),
    [sym_verbatim_string_literal] = ACTIONS(3389),
    [sym_raw_string_literal] = ACTIONS(3389),
    [aux_sym_preproc_if_token1] = ACTIONS(3389),
    [aux_sym_preproc_if_token3] = ACTIONS(3389),
    [aux_sym_preproc_else_token1] = ACTIONS(3389),
    [aux_sym_preproc_elif_token1] = ACTIONS(3389),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3389),
    [sym_interpolation_verbatim_start] = ACTIONS(3389),
    [sym_interpolation_raw_start] = ACTIONS(3389),
  },
  [2290] = {
    [sym_preproc_region] = STATE(2290),
    [sym_preproc_endregion] = STATE(2290),
    [sym_preproc_line] = STATE(2290),
    [sym_preproc_pragma] = STATE(2290),
    [sym_preproc_nullable] = STATE(2290),
    [sym_preproc_error] = STATE(2290),
    [sym_preproc_define] = STATE(2290),
    [sym_preproc_undef] = STATE(2290),
    [sym__identifier_token] = ACTIONS(3391),
    [anon_sym_extern] = ACTIONS(3391),
    [anon_sym_alias] = ACTIONS(3391),
    [anon_sym_SEMI] = ACTIONS(3393),
    [anon_sym_global] = ACTIONS(3391),
    [anon_sym_using] = ACTIONS(3391),
    [anon_sym_unsafe] = ACTIONS(3391),
    [anon_sym_static] = ACTIONS(3391),
    [anon_sym_LBRACK] = ACTIONS(3393),
    [anon_sym_LPAREN] = ACTIONS(3393),
    [anon_sym_return] = ACTIONS(3391),
    [anon_sym_namespace] = ACTIONS(3391),
    [anon_sym_class] = ACTIONS(3391),
    [anon_sym_ref] = ACTIONS(3391),
    [anon_sym_struct] = ACTIONS(3391),
    [anon_sym_enum] = ACTIONS(3391),
    [anon_sym_LBRACE] = ACTIONS(3393),
    [anon_sym_interface] = ACTIONS(3391),
    [anon_sym_delegate] = ACTIONS(3391),
    [anon_sym_record] = ACTIONS(3391),
    [anon_sym_abstract] = ACTIONS(3391),
    [anon_sym_async] = ACTIONS(3391),
    [anon_sym_const] = ACTIONS(3391),
    [anon_sym_file] = ACTIONS(3391),
    [anon_sym_fixed] = ACTIONS(3391),
    [anon_sym_internal] = ACTIONS(3391),
    [anon_sym_new] = ACTIONS(3391),
    [anon_sym_override] = ACTIONS(3391),
    [anon_sym_partial] = ACTIONS(3391),
    [anon_sym_private] = ACTIONS(3391),
    [anon_sym_protected] = ACTIONS(3391),
    [anon_sym_public] = ACTIONS(3391),
    [anon_sym_readonly] = ACTIONS(3391),
    [anon_sym_required] = ACTIONS(3391),
    [anon_sym_sealed] = ACTIONS(3391),
    [anon_sym_virtual] = ACTIONS(3391),
    [anon_sym_volatile] = ACTIONS(3391),
    [anon_sym_where] = ACTIONS(3391),
    [anon_sym_notnull] = ACTIONS(3391),
    [anon_sym_unmanaged] = ACTIONS(3391),
    [anon_sym_checked] = ACTIONS(3391),
    [anon_sym_BANG] = ACTIONS(3393),
    [anon_sym_TILDE] = ACTIONS(3393),
    [anon_sym_PLUS_PLUS] = ACTIONS(3393),
    [anon_sym_DASH_DASH] = ACTIONS(3393),
    [anon_sym_true] = ACTIONS(3391),
    [anon_sym_false] = ACTIONS(3391),
    [anon_sym_PLUS] = ACTIONS(3391),
    [anon_sym_DASH] = ACTIONS(3391),
    [anon_sym_STAR] = ACTIONS(3393),
    [anon_sym_CARET] = ACTIONS(3393),
    [anon_sym_AMP] = ACTIONS(3393),
    [anon_sym_this] = ACTIONS(3391),
    [anon_sym_scoped] = ACTIONS(3391),
    [anon_sym_var] = ACTIONS(3391),
    [sym_predefined_type] = ACTIONS(3391),
    [anon_sym_break] = ACTIONS(3391),
    [anon_sym_unchecked] = ACTIONS(3391),
    [anon_sym_continue] = ACTIONS(3391),
    [anon_sym_do] = ACTIONS(3391),
    [anon_sym_while] = ACTIONS(3391),
    [anon_sym_for] = ACTIONS(3391),
    [anon_sym_lock] = ACTIONS(3391),
    [anon_sym_yield] = ACTIONS(3391),
    [anon_sym_switch] = ACTIONS(3391),
    [anon_sym_default] = ACTIONS(3391),
    [anon_sym_throw] = ACTIONS(3391),
    [anon_sym_try] = ACTIONS(3391),
    [anon_sym_when] = ACTIONS(3391),
    [anon_sym_await] = ACTIONS(3391),
    [anon_sym_foreach] = ACTIONS(3391),
    [anon_sym_goto] = ACTIONS(3391),
    [anon_sym_if] = ACTIONS(3391),
    [anon_sym_else] = ACTIONS(3395),
    [anon_sym_DOT_DOT] = ACTIONS(3393),
    [anon_sym_from] = ACTIONS(3391),
    [anon_sym_into] = ACTIONS(3391),
    [anon_sym_join] = ACTIONS(3391),
    [anon_sym_on] = ACTIONS(3391),
    [anon_sym_equals] = ACTIONS(3391),
    [anon_sym_let] = ACTIONS(3391),
    [anon_sym_orderby] = ACTIONS(3391),
    [anon_sym_ascending] = ACTIONS(3391),
    [anon_sym_descending] = ACTIONS(3391),
    [anon_sym_group] = ACTIONS(3391),
    [anon_sym_by] = ACTIONS(3391),
    [anon_sym_select] = ACTIONS(3391),
    [anon_sym_DQUOTE] = ACTIONS(3391),
    [anon_sym_stackalloc] = ACTIONS(3391),
    [anon_sym_sizeof] = ACTIONS(3391),
    [anon_sym_typeof] = ACTIONS(3391),
    [anon_sym___makeref] = ACTIONS(3391),
    [anon_sym___reftype] = ACTIONS(3391),
    [anon_sym___refvalue] = ACTIONS(3391),
    [sym_null_literal] = ACTIONS(3391),
    [anon_sym_SQUOTE] = ACTIONS(3393),
    [sym_integer_literal] = ACTIONS(3391),
    [sym_real_literal] = ACTIONS(3393),
    [sym_verbatim_string_literal] = ACTIONS(3393),
    [sym_raw_string_literal] = ACTIONS(3393),
    [aux_sym_preproc_if_token1] = ACTIONS(3393),
    [aux_sym_preproc_if_token3] = ACTIONS(3393),
    [aux_sym_preproc_else_token1] = ACTIONS(3393),
    [aux_sym_preproc_elif_token1] = ACTIONS(3393),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3393),
    [sym_interpolation_verbatim_start] = ACTIONS(3393),
    [sym_interpolation_raw_start] = ACTIONS(3393),
  },
  [2291] = {
    [sym_preproc_region] = STATE(2291),
    [sym_preproc_endregion] = STATE(2291),
    [sym_preproc_line] = STATE(2291),
    [sym_preproc_pragma] = STATE(2291),
    [sym_preproc_nullable] = STATE(2291),
    [sym_preproc_error] = STATE(2291),
    [sym_preproc_define] = STATE(2291),
    [sym_preproc_undef] = STATE(2291),
    [sym__identifier_token] = ACTIONS(3397),
    [anon_sym_extern] = ACTIONS(3397),
    [anon_sym_alias] = ACTIONS(3397),
    [anon_sym_SEMI] = ACTIONS(3399),
    [anon_sym_global] = ACTIONS(3397),
    [anon_sym_using] = ACTIONS(3397),
    [anon_sym_unsafe] = ACTIONS(3397),
    [anon_sym_static] = ACTIONS(3397),
    [anon_sym_LBRACK] = ACTIONS(3399),
    [anon_sym_LPAREN] = ACTIONS(3399),
    [anon_sym_return] = ACTIONS(3397),
    [anon_sym_namespace] = ACTIONS(3397),
    [anon_sym_class] = ACTIONS(3397),
    [anon_sym_ref] = ACTIONS(3397),
    [anon_sym_struct] = ACTIONS(3397),
    [anon_sym_enum] = ACTIONS(3397),
    [anon_sym_LBRACE] = ACTIONS(3399),
    [anon_sym_interface] = ACTIONS(3397),
    [anon_sym_delegate] = ACTIONS(3397),
    [anon_sym_record] = ACTIONS(3397),
    [anon_sym_abstract] = ACTIONS(3397),
    [anon_sym_async] = ACTIONS(3397),
    [anon_sym_const] = ACTIONS(3397),
    [anon_sym_file] = ACTIONS(3397),
    [anon_sym_fixed] = ACTIONS(3397),
    [anon_sym_internal] = ACTIONS(3397),
    [anon_sym_new] = ACTIONS(3397),
    [anon_sym_override] = ACTIONS(3397),
    [anon_sym_partial] = ACTIONS(3397),
    [anon_sym_private] = ACTIONS(3397),
    [anon_sym_protected] = ACTIONS(3397),
    [anon_sym_public] = ACTIONS(3397),
    [anon_sym_readonly] = ACTIONS(3397),
    [anon_sym_required] = ACTIONS(3397),
    [anon_sym_sealed] = ACTIONS(3397),
    [anon_sym_virtual] = ACTIONS(3397),
    [anon_sym_volatile] = ACTIONS(3397),
    [anon_sym_where] = ACTIONS(3397),
    [anon_sym_notnull] = ACTIONS(3397),
    [anon_sym_unmanaged] = ACTIONS(3397),
    [anon_sym_checked] = ACTIONS(3397),
    [anon_sym_BANG] = ACTIONS(3399),
    [anon_sym_TILDE] = ACTIONS(3399),
    [anon_sym_PLUS_PLUS] = ACTIONS(3399),
    [anon_sym_DASH_DASH] = ACTIONS(3399),
    [anon_sym_true] = ACTIONS(3397),
    [anon_sym_false] = ACTIONS(3397),
    [anon_sym_PLUS] = ACTIONS(3397),
    [anon_sym_DASH] = ACTIONS(3397),
    [anon_sym_STAR] = ACTIONS(3399),
    [anon_sym_CARET] = ACTIONS(3399),
    [anon_sym_AMP] = ACTIONS(3399),
    [anon_sym_this] = ACTIONS(3397),
    [anon_sym_scoped] = ACTIONS(3397),
    [anon_sym_var] = ACTIONS(3397),
    [sym_predefined_type] = ACTIONS(3397),
    [anon_sym_break] = ACTIONS(3397),
    [anon_sym_unchecked] = ACTIONS(3397),
    [anon_sym_continue] = ACTIONS(3397),
    [anon_sym_do] = ACTIONS(3397),
    [anon_sym_while] = ACTIONS(3397),
    [anon_sym_for] = ACTIONS(3397),
    [anon_sym_lock] = ACTIONS(3397),
    [anon_sym_yield] = ACTIONS(3397),
    [anon_sym_switch] = ACTIONS(3397),
    [anon_sym_default] = ACTIONS(3397),
    [anon_sym_throw] = ACTIONS(3397),
    [anon_sym_try] = ACTIONS(3397),
    [anon_sym_when] = ACTIONS(3397),
    [anon_sym_await] = ACTIONS(3397),
    [anon_sym_foreach] = ACTIONS(3397),
    [anon_sym_goto] = ACTIONS(3397),
    [anon_sym_if] = ACTIONS(3397),
    [anon_sym_else] = ACTIONS(3397),
    [anon_sym_DOT_DOT] = ACTIONS(3399),
    [anon_sym_from] = ACTIONS(3397),
    [anon_sym_into] = ACTIONS(3397),
    [anon_sym_join] = ACTIONS(3397),
    [anon_sym_on] = ACTIONS(3397),
    [anon_sym_equals] = ACTIONS(3397),
    [anon_sym_let] = ACTIONS(3397),
    [anon_sym_orderby] = ACTIONS(3397),
    [anon_sym_ascending] = ACTIONS(3397),
    [anon_sym_descending] = ACTIONS(3397),
    [anon_sym_group] = ACTIONS(3397),
    [anon_sym_by] = ACTIONS(3397),
    [anon_sym_select] = ACTIONS(3397),
    [anon_sym_DQUOTE] = ACTIONS(3397),
    [anon_sym_stackalloc] = ACTIONS(3397),
    [anon_sym_sizeof] = ACTIONS(3397),
    [anon_sym_typeof] = ACTIONS(3397),
    [anon_sym___makeref] = ACTIONS(3397),
    [anon_sym___reftype] = ACTIONS(3397),
    [anon_sym___refvalue] = ACTIONS(3397),
    [sym_null_literal] = ACTIONS(3397),
    [anon_sym_SQUOTE] = ACTIONS(3399),
    [sym_integer_literal] = ACTIONS(3397),
    [sym_real_literal] = ACTIONS(3399),
    [sym_verbatim_string_literal] = ACTIONS(3399),
    [sym_raw_string_literal] = ACTIONS(3399),
    [aux_sym_preproc_if_token1] = ACTIONS(3399),
    [aux_sym_preproc_if_token3] = ACTIONS(3399),
    [aux_sym_preproc_else_token1] = ACTIONS(3399),
    [aux_sym_preproc_elif_token1] = ACTIONS(3399),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3399),
    [sym_interpolation_verbatim_start] = ACTIONS(3399),
    [sym_interpolation_raw_start] = ACTIONS(3399),
  },
  [2292] = {
    [sym_preproc_region] = STATE(2292),
    [sym_preproc_endregion] = STATE(2292),
    [sym_preproc_line] = STATE(2292),
    [sym_preproc_pragma] = STATE(2292),
    [sym_preproc_nullable] = STATE(2292),
    [sym_preproc_error] = STATE(2292),
    [sym_preproc_define] = STATE(2292),
    [sym_preproc_undef] = STATE(2292),
    [sym__identifier_token] = ACTIONS(3401),
    [anon_sym_extern] = ACTIONS(3401),
    [anon_sym_alias] = ACTIONS(3401),
    [anon_sym_SEMI] = ACTIONS(3403),
    [anon_sym_global] = ACTIONS(3401),
    [anon_sym_using] = ACTIONS(3401),
    [anon_sym_unsafe] = ACTIONS(3401),
    [anon_sym_static] = ACTIONS(3401),
    [anon_sym_LBRACK] = ACTIONS(3403),
    [anon_sym_LPAREN] = ACTIONS(3403),
    [anon_sym_return] = ACTIONS(3401),
    [anon_sym_namespace] = ACTIONS(3401),
    [anon_sym_class] = ACTIONS(3401),
    [anon_sym_ref] = ACTIONS(3401),
    [anon_sym_struct] = ACTIONS(3401),
    [anon_sym_enum] = ACTIONS(3401),
    [anon_sym_LBRACE] = ACTIONS(3403),
    [anon_sym_interface] = ACTIONS(3401),
    [anon_sym_delegate] = ACTIONS(3401),
    [anon_sym_record] = ACTIONS(3401),
    [anon_sym_abstract] = ACTIONS(3401),
    [anon_sym_async] = ACTIONS(3401),
    [anon_sym_const] = ACTIONS(3401),
    [anon_sym_file] = ACTIONS(3401),
    [anon_sym_fixed] = ACTIONS(3401),
    [anon_sym_internal] = ACTIONS(3401),
    [anon_sym_new] = ACTIONS(3401),
    [anon_sym_override] = ACTIONS(3401),
    [anon_sym_partial] = ACTIONS(3401),
    [anon_sym_private] = ACTIONS(3401),
    [anon_sym_protected] = ACTIONS(3401),
    [anon_sym_public] = ACTIONS(3401),
    [anon_sym_readonly] = ACTIONS(3401),
    [anon_sym_required] = ACTIONS(3401),
    [anon_sym_sealed] = ACTIONS(3401),
    [anon_sym_virtual] = ACTIONS(3401),
    [anon_sym_volatile] = ACTIONS(3401),
    [anon_sym_where] = ACTIONS(3401),
    [anon_sym_notnull] = ACTIONS(3401),
    [anon_sym_unmanaged] = ACTIONS(3401),
    [anon_sym_checked] = ACTIONS(3401),
    [anon_sym_BANG] = ACTIONS(3403),
    [anon_sym_TILDE] = ACTIONS(3403),
    [anon_sym_PLUS_PLUS] = ACTIONS(3403),
    [anon_sym_DASH_DASH] = ACTIONS(3403),
    [anon_sym_true] = ACTIONS(3401),
    [anon_sym_false] = ACTIONS(3401),
    [anon_sym_PLUS] = ACTIONS(3401),
    [anon_sym_DASH] = ACTIONS(3401),
    [anon_sym_STAR] = ACTIONS(3403),
    [anon_sym_CARET] = ACTIONS(3403),
    [anon_sym_AMP] = ACTIONS(3403),
    [anon_sym_this] = ACTIONS(3401),
    [anon_sym_scoped] = ACTIONS(3401),
    [anon_sym_var] = ACTIONS(3401),
    [sym_predefined_type] = ACTIONS(3401),
    [anon_sym_break] = ACTIONS(3401),
    [anon_sym_unchecked] = ACTIONS(3401),
    [anon_sym_continue] = ACTIONS(3401),
    [anon_sym_do] = ACTIONS(3401),
    [anon_sym_while] = ACTIONS(3401),
    [anon_sym_for] = ACTIONS(3401),
    [anon_sym_lock] = ACTIONS(3401),
    [anon_sym_yield] = ACTIONS(3401),
    [anon_sym_switch] = ACTIONS(3401),
    [anon_sym_default] = ACTIONS(3401),
    [anon_sym_throw] = ACTIONS(3401),
    [anon_sym_try] = ACTIONS(3401),
    [anon_sym_when] = ACTIONS(3401),
    [anon_sym_await] = ACTIONS(3401),
    [anon_sym_foreach] = ACTIONS(3401),
    [anon_sym_goto] = ACTIONS(3401),
    [anon_sym_if] = ACTIONS(3401),
    [anon_sym_else] = ACTIONS(3401),
    [anon_sym_DOT_DOT] = ACTIONS(3403),
    [anon_sym_from] = ACTIONS(3401),
    [anon_sym_into] = ACTIONS(3401),
    [anon_sym_join] = ACTIONS(3401),
    [anon_sym_on] = ACTIONS(3401),
    [anon_sym_equals] = ACTIONS(3401),
    [anon_sym_let] = ACTIONS(3401),
    [anon_sym_orderby] = ACTIONS(3401),
    [anon_sym_ascending] = ACTIONS(3401),
    [anon_sym_descending] = ACTIONS(3401),
    [anon_sym_group] = ACTIONS(3401),
    [anon_sym_by] = ACTIONS(3401),
    [anon_sym_select] = ACTIONS(3401),
    [anon_sym_DQUOTE] = ACTIONS(3401),
    [anon_sym_stackalloc] = ACTIONS(3401),
    [anon_sym_sizeof] = ACTIONS(3401),
    [anon_sym_typeof] = ACTIONS(3401),
    [anon_sym___makeref] = ACTIONS(3401),
    [anon_sym___reftype] = ACTIONS(3401),
    [anon_sym___refvalue] = ACTIONS(3401),
    [sym_null_literal] = ACTIONS(3401),
    [anon_sym_SQUOTE] = ACTIONS(3403),
    [sym_integer_literal] = ACTIONS(3401),
    [sym_real_literal] = ACTIONS(3403),
    [sym_verbatim_string_literal] = ACTIONS(3403),
    [sym_raw_string_literal] = ACTIONS(3403),
    [aux_sym_preproc_if_token1] = ACTIONS(3403),
    [aux_sym_preproc_if_token3] = ACTIONS(3403),
    [aux_sym_preproc_else_token1] = ACTIONS(3403),
    [aux_sym_preproc_elif_token1] = ACTIONS(3403),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3403),
    [sym_interpolation_verbatim_start] = ACTIONS(3403),
    [sym_interpolation_raw_start] = ACTIONS(3403),
  },
  [2293] = {
    [sym_preproc_region] = STATE(2293),
    [sym_preproc_endregion] = STATE(2293),
    [sym_preproc_line] = STATE(2293),
    [sym_preproc_pragma] = STATE(2293),
    [sym_preproc_nullable] = STATE(2293),
    [sym_preproc_error] = STATE(2293),
    [sym_preproc_define] = STATE(2293),
    [sym_preproc_undef] = STATE(2293),
    [sym__identifier_token] = ACTIONS(3405),
    [anon_sym_extern] = ACTIONS(3405),
    [anon_sym_alias] = ACTIONS(3405),
    [anon_sym_SEMI] = ACTIONS(3407),
    [anon_sym_global] = ACTIONS(3405),
    [anon_sym_using] = ACTIONS(3405),
    [anon_sym_unsafe] = ACTIONS(3405),
    [anon_sym_static] = ACTIONS(3405),
    [anon_sym_LBRACK] = ACTIONS(3407),
    [anon_sym_LPAREN] = ACTIONS(3407),
    [anon_sym_return] = ACTIONS(3405),
    [anon_sym_namespace] = ACTIONS(3405),
    [anon_sym_class] = ACTIONS(3405),
    [anon_sym_ref] = ACTIONS(3405),
    [anon_sym_struct] = ACTIONS(3405),
    [anon_sym_enum] = ACTIONS(3405),
    [anon_sym_LBRACE] = ACTIONS(3407),
    [anon_sym_interface] = ACTIONS(3405),
    [anon_sym_delegate] = ACTIONS(3405),
    [anon_sym_record] = ACTIONS(3405),
    [anon_sym_abstract] = ACTIONS(3405),
    [anon_sym_async] = ACTIONS(3405),
    [anon_sym_const] = ACTIONS(3405),
    [anon_sym_file] = ACTIONS(3405),
    [anon_sym_fixed] = ACTIONS(3405),
    [anon_sym_internal] = ACTIONS(3405),
    [anon_sym_new] = ACTIONS(3405),
    [anon_sym_override] = ACTIONS(3405),
    [anon_sym_partial] = ACTIONS(3405),
    [anon_sym_private] = ACTIONS(3405),
    [anon_sym_protected] = ACTIONS(3405),
    [anon_sym_public] = ACTIONS(3405),
    [anon_sym_readonly] = ACTIONS(3405),
    [anon_sym_required] = ACTIONS(3405),
    [anon_sym_sealed] = ACTIONS(3405),
    [anon_sym_virtual] = ACTIONS(3405),
    [anon_sym_volatile] = ACTIONS(3405),
    [anon_sym_where] = ACTIONS(3405),
    [anon_sym_notnull] = ACTIONS(3405),
    [anon_sym_unmanaged] = ACTIONS(3405),
    [anon_sym_checked] = ACTIONS(3405),
    [anon_sym_BANG] = ACTIONS(3407),
    [anon_sym_TILDE] = ACTIONS(3407),
    [anon_sym_PLUS_PLUS] = ACTIONS(3407),
    [anon_sym_DASH_DASH] = ACTIONS(3407),
    [anon_sym_true] = ACTIONS(3405),
    [anon_sym_false] = ACTIONS(3405),
    [anon_sym_PLUS] = ACTIONS(3405),
    [anon_sym_DASH] = ACTIONS(3405),
    [anon_sym_STAR] = ACTIONS(3407),
    [anon_sym_CARET] = ACTIONS(3407),
    [anon_sym_AMP] = ACTIONS(3407),
    [anon_sym_this] = ACTIONS(3405),
    [anon_sym_scoped] = ACTIONS(3405),
    [anon_sym_var] = ACTIONS(3405),
    [sym_predefined_type] = ACTIONS(3405),
    [anon_sym_break] = ACTIONS(3405),
    [anon_sym_unchecked] = ACTIONS(3405),
    [anon_sym_continue] = ACTIONS(3405),
    [anon_sym_do] = ACTIONS(3405),
    [anon_sym_while] = ACTIONS(3405),
    [anon_sym_for] = ACTIONS(3405),
    [anon_sym_lock] = ACTIONS(3405),
    [anon_sym_yield] = ACTIONS(3405),
    [anon_sym_switch] = ACTIONS(3405),
    [anon_sym_default] = ACTIONS(3405),
    [anon_sym_throw] = ACTIONS(3405),
    [anon_sym_try] = ACTIONS(3405),
    [anon_sym_when] = ACTIONS(3405),
    [anon_sym_await] = ACTIONS(3405),
    [anon_sym_foreach] = ACTIONS(3405),
    [anon_sym_goto] = ACTIONS(3405),
    [anon_sym_if] = ACTIONS(3405),
    [anon_sym_else] = ACTIONS(3405),
    [anon_sym_DOT_DOT] = ACTIONS(3407),
    [anon_sym_from] = ACTIONS(3405),
    [anon_sym_into] = ACTIONS(3405),
    [anon_sym_join] = ACTIONS(3405),
    [anon_sym_on] = ACTIONS(3405),
    [anon_sym_equals] = ACTIONS(3405),
    [anon_sym_let] = ACTIONS(3405),
    [anon_sym_orderby] = ACTIONS(3405),
    [anon_sym_ascending] = ACTIONS(3405),
    [anon_sym_descending] = ACTIONS(3405),
    [anon_sym_group] = ACTIONS(3405),
    [anon_sym_by] = ACTIONS(3405),
    [anon_sym_select] = ACTIONS(3405),
    [anon_sym_DQUOTE] = ACTIONS(3405),
    [anon_sym_stackalloc] = ACTIONS(3405),
    [anon_sym_sizeof] = ACTIONS(3405),
    [anon_sym_typeof] = ACTIONS(3405),
    [anon_sym___makeref] = ACTIONS(3405),
    [anon_sym___reftype] = ACTIONS(3405),
    [anon_sym___refvalue] = ACTIONS(3405),
    [sym_null_literal] = ACTIONS(3405),
    [anon_sym_SQUOTE] = ACTIONS(3407),
    [sym_integer_literal] = ACTIONS(3405),
    [sym_real_literal] = ACTIONS(3407),
    [sym_verbatim_string_literal] = ACTIONS(3407),
    [sym_raw_string_literal] = ACTIONS(3407),
    [aux_sym_preproc_if_token1] = ACTIONS(3407),
    [aux_sym_preproc_if_token3] = ACTIONS(3407),
    [aux_sym_preproc_else_token1] = ACTIONS(3407),
    [aux_sym_preproc_elif_token1] = ACTIONS(3407),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3407),
    [sym_interpolation_verbatim_start] = ACTIONS(3407),
    [sym_interpolation_raw_start] = ACTIONS(3407),
  },
  [2294] = {
    [sym_preproc_region] = STATE(2294),
    [sym_preproc_endregion] = STATE(2294),
    [sym_preproc_line] = STATE(2294),
    [sym_preproc_pragma] = STATE(2294),
    [sym_preproc_nullable] = STATE(2294),
    [sym_preproc_error] = STATE(2294),
    [sym_preproc_define] = STATE(2294),
    [sym_preproc_undef] = STATE(2294),
    [sym__identifier_token] = ACTIONS(3409),
    [anon_sym_extern] = ACTIONS(3409),
    [anon_sym_alias] = ACTIONS(3409),
    [anon_sym_SEMI] = ACTIONS(3411),
    [anon_sym_global] = ACTIONS(3409),
    [anon_sym_using] = ACTIONS(3409),
    [anon_sym_unsafe] = ACTIONS(3409),
    [anon_sym_static] = ACTIONS(3409),
    [anon_sym_LBRACK] = ACTIONS(3411),
    [anon_sym_LPAREN] = ACTIONS(3411),
    [anon_sym_return] = ACTIONS(3409),
    [anon_sym_namespace] = ACTIONS(3409),
    [anon_sym_class] = ACTIONS(3409),
    [anon_sym_ref] = ACTIONS(3409),
    [anon_sym_struct] = ACTIONS(3409),
    [anon_sym_enum] = ACTIONS(3409),
    [anon_sym_LBRACE] = ACTIONS(3411),
    [anon_sym_interface] = ACTIONS(3409),
    [anon_sym_delegate] = ACTIONS(3409),
    [anon_sym_record] = ACTIONS(3409),
    [anon_sym_abstract] = ACTIONS(3409),
    [anon_sym_async] = ACTIONS(3409),
    [anon_sym_const] = ACTIONS(3409),
    [anon_sym_file] = ACTIONS(3409),
    [anon_sym_fixed] = ACTIONS(3409),
    [anon_sym_internal] = ACTIONS(3409),
    [anon_sym_new] = ACTIONS(3409),
    [anon_sym_override] = ACTIONS(3409),
    [anon_sym_partial] = ACTIONS(3409),
    [anon_sym_private] = ACTIONS(3409),
    [anon_sym_protected] = ACTIONS(3409),
    [anon_sym_public] = ACTIONS(3409),
    [anon_sym_readonly] = ACTIONS(3409),
    [anon_sym_required] = ACTIONS(3409),
    [anon_sym_sealed] = ACTIONS(3409),
    [anon_sym_virtual] = ACTIONS(3409),
    [anon_sym_volatile] = ACTIONS(3409),
    [anon_sym_where] = ACTIONS(3409),
    [anon_sym_notnull] = ACTIONS(3409),
    [anon_sym_unmanaged] = ACTIONS(3409),
    [anon_sym_checked] = ACTIONS(3409),
    [anon_sym_BANG] = ACTIONS(3411),
    [anon_sym_TILDE] = ACTIONS(3411),
    [anon_sym_PLUS_PLUS] = ACTIONS(3411),
    [anon_sym_DASH_DASH] = ACTIONS(3411),
    [anon_sym_true] = ACTIONS(3409),
    [anon_sym_false] = ACTIONS(3409),
    [anon_sym_PLUS] = ACTIONS(3409),
    [anon_sym_DASH] = ACTIONS(3409),
    [anon_sym_STAR] = ACTIONS(3411),
    [anon_sym_CARET] = ACTIONS(3411),
    [anon_sym_AMP] = ACTIONS(3411),
    [anon_sym_this] = ACTIONS(3409),
    [anon_sym_scoped] = ACTIONS(3409),
    [anon_sym_var] = ACTIONS(3409),
    [sym_predefined_type] = ACTIONS(3409),
    [anon_sym_break] = ACTIONS(3409),
    [anon_sym_unchecked] = ACTIONS(3409),
    [anon_sym_continue] = ACTIONS(3409),
    [anon_sym_do] = ACTIONS(3409),
    [anon_sym_while] = ACTIONS(3409),
    [anon_sym_for] = ACTIONS(3409),
    [anon_sym_lock] = ACTIONS(3409),
    [anon_sym_yield] = ACTIONS(3409),
    [anon_sym_switch] = ACTIONS(3409),
    [anon_sym_default] = ACTIONS(3409),
    [anon_sym_throw] = ACTIONS(3409),
    [anon_sym_try] = ACTIONS(3409),
    [anon_sym_when] = ACTIONS(3409),
    [anon_sym_await] = ACTIONS(3409),
    [anon_sym_foreach] = ACTIONS(3409),
    [anon_sym_goto] = ACTIONS(3409),
    [anon_sym_if] = ACTIONS(3409),
    [anon_sym_else] = ACTIONS(3409),
    [anon_sym_DOT_DOT] = ACTIONS(3411),
    [anon_sym_from] = ACTIONS(3409),
    [anon_sym_into] = ACTIONS(3409),
    [anon_sym_join] = ACTIONS(3409),
    [anon_sym_on] = ACTIONS(3409),
    [anon_sym_equals] = ACTIONS(3409),
    [anon_sym_let] = ACTIONS(3409),
    [anon_sym_orderby] = ACTIONS(3409),
    [anon_sym_ascending] = ACTIONS(3409),
    [anon_sym_descending] = ACTIONS(3409),
    [anon_sym_group] = ACTIONS(3409),
    [anon_sym_by] = ACTIONS(3409),
    [anon_sym_select] = ACTIONS(3409),
    [anon_sym_DQUOTE] = ACTIONS(3409),
    [anon_sym_stackalloc] = ACTIONS(3409),
    [anon_sym_sizeof] = ACTIONS(3409),
    [anon_sym_typeof] = ACTIONS(3409),
    [anon_sym___makeref] = ACTIONS(3409),
    [anon_sym___reftype] = ACTIONS(3409),
    [anon_sym___refvalue] = ACTIONS(3409),
    [sym_null_literal] = ACTIONS(3409),
    [anon_sym_SQUOTE] = ACTIONS(3411),
    [sym_integer_literal] = ACTIONS(3409),
    [sym_real_literal] = ACTIONS(3411),
    [sym_verbatim_string_literal] = ACTIONS(3411),
    [sym_raw_string_literal] = ACTIONS(3411),
    [aux_sym_preproc_if_token1] = ACTIONS(3411),
    [aux_sym_preproc_if_token3] = ACTIONS(3411),
    [aux_sym_preproc_else_token1] = ACTIONS(3411),
    [aux_sym_preproc_elif_token1] = ACTIONS(3411),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3411),
    [sym_interpolation_verbatim_start] = ACTIONS(3411),
    [sym_interpolation_raw_start] = ACTIONS(3411),
  },
  [2295] = {
    [sym_preproc_region] = STATE(2295),
    [sym_preproc_endregion] = STATE(2295),
    [sym_preproc_line] = STATE(2295),
    [sym_preproc_pragma] = STATE(2295),
    [sym_preproc_nullable] = STATE(2295),
    [sym_preproc_error] = STATE(2295),
    [sym_preproc_define] = STATE(2295),
    [sym_preproc_undef] = STATE(2295),
    [sym__identifier_token] = ACTIONS(3413),
    [anon_sym_extern] = ACTIONS(3413),
    [anon_sym_alias] = ACTIONS(3413),
    [anon_sym_SEMI] = ACTIONS(3415),
    [anon_sym_global] = ACTIONS(3413),
    [anon_sym_using] = ACTIONS(3413),
    [anon_sym_unsafe] = ACTIONS(3413),
    [anon_sym_static] = ACTIONS(3413),
    [anon_sym_LBRACK] = ACTIONS(3415),
    [anon_sym_LPAREN] = ACTIONS(3415),
    [anon_sym_return] = ACTIONS(3413),
    [anon_sym_namespace] = ACTIONS(3413),
    [anon_sym_class] = ACTIONS(3413),
    [anon_sym_ref] = ACTIONS(3413),
    [anon_sym_struct] = ACTIONS(3413),
    [anon_sym_enum] = ACTIONS(3413),
    [anon_sym_LBRACE] = ACTIONS(3415),
    [anon_sym_interface] = ACTIONS(3413),
    [anon_sym_delegate] = ACTIONS(3413),
    [anon_sym_record] = ACTIONS(3413),
    [anon_sym_abstract] = ACTIONS(3413),
    [anon_sym_async] = ACTIONS(3413),
    [anon_sym_const] = ACTIONS(3413),
    [anon_sym_file] = ACTIONS(3413),
    [anon_sym_fixed] = ACTIONS(3413),
    [anon_sym_internal] = ACTIONS(3413),
    [anon_sym_new] = ACTIONS(3413),
    [anon_sym_override] = ACTIONS(3413),
    [anon_sym_partial] = ACTIONS(3413),
    [anon_sym_private] = ACTIONS(3413),
    [anon_sym_protected] = ACTIONS(3413),
    [anon_sym_public] = ACTIONS(3413),
    [anon_sym_readonly] = ACTIONS(3413),
    [anon_sym_required] = ACTIONS(3413),
    [anon_sym_sealed] = ACTIONS(3413),
    [anon_sym_virtual] = ACTIONS(3413),
    [anon_sym_volatile] = ACTIONS(3413),
    [anon_sym_where] = ACTIONS(3413),
    [anon_sym_notnull] = ACTIONS(3413),
    [anon_sym_unmanaged] = ACTIONS(3413),
    [anon_sym_checked] = ACTIONS(3413),
    [anon_sym_BANG] = ACTIONS(3415),
    [anon_sym_TILDE] = ACTIONS(3415),
    [anon_sym_PLUS_PLUS] = ACTIONS(3415),
    [anon_sym_DASH_DASH] = ACTIONS(3415),
    [anon_sym_true] = ACTIONS(3413),
    [anon_sym_false] = ACTIONS(3413),
    [anon_sym_PLUS] = ACTIONS(3413),
    [anon_sym_DASH] = ACTIONS(3413),
    [anon_sym_STAR] = ACTIONS(3415),
    [anon_sym_CARET] = ACTIONS(3415),
    [anon_sym_AMP] = ACTIONS(3415),
    [anon_sym_this] = ACTIONS(3413),
    [anon_sym_scoped] = ACTIONS(3413),
    [anon_sym_var] = ACTIONS(3413),
    [sym_predefined_type] = ACTIONS(3413),
    [anon_sym_break] = ACTIONS(3413),
    [anon_sym_unchecked] = ACTIONS(3413),
    [anon_sym_continue] = ACTIONS(3413),
    [anon_sym_do] = ACTIONS(3413),
    [anon_sym_while] = ACTIONS(3413),
    [anon_sym_for] = ACTIONS(3413),
    [anon_sym_lock] = ACTIONS(3413),
    [anon_sym_yield] = ACTIONS(3413),
    [anon_sym_switch] = ACTIONS(3413),
    [anon_sym_default] = ACTIONS(3413),
    [anon_sym_throw] = ACTIONS(3413),
    [anon_sym_try] = ACTIONS(3413),
    [anon_sym_when] = ACTIONS(3413),
    [anon_sym_await] = ACTIONS(3413),
    [anon_sym_foreach] = ACTIONS(3413),
    [anon_sym_goto] = ACTIONS(3413),
    [anon_sym_if] = ACTIONS(3413),
    [anon_sym_else] = ACTIONS(3413),
    [anon_sym_DOT_DOT] = ACTIONS(3415),
    [anon_sym_from] = ACTIONS(3413),
    [anon_sym_into] = ACTIONS(3413),
    [anon_sym_join] = ACTIONS(3413),
    [anon_sym_on] = ACTIONS(3413),
    [anon_sym_equals] = ACTIONS(3413),
    [anon_sym_let] = ACTIONS(3413),
    [anon_sym_orderby] = ACTIONS(3413),
    [anon_sym_ascending] = ACTIONS(3413),
    [anon_sym_descending] = ACTIONS(3413),
    [anon_sym_group] = ACTIONS(3413),
    [anon_sym_by] = ACTIONS(3413),
    [anon_sym_select] = ACTIONS(3413),
    [anon_sym_DQUOTE] = ACTIONS(3413),
    [anon_sym_stackalloc] = ACTIONS(3413),
    [anon_sym_sizeof] = ACTIONS(3413),
    [anon_sym_typeof] = ACTIONS(3413),
    [anon_sym___makeref] = ACTIONS(3413),
    [anon_sym___reftype] = ACTIONS(3413),
    [anon_sym___refvalue] = ACTIONS(3413),
    [sym_null_literal] = ACTIONS(3413),
    [anon_sym_SQUOTE] = ACTIONS(3415),
    [sym_integer_literal] = ACTIONS(3413),
    [sym_real_literal] = ACTIONS(3415),
    [sym_verbatim_string_literal] = ACTIONS(3415),
    [sym_raw_string_literal] = ACTIONS(3415),
    [aux_sym_preproc_if_token1] = ACTIONS(3415),
    [aux_sym_preproc_if_token3] = ACTIONS(3415),
    [aux_sym_preproc_else_token1] = ACTIONS(3415),
    [aux_sym_preproc_elif_token1] = ACTIONS(3415),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3415),
    [sym_interpolation_verbatim_start] = ACTIONS(3415),
    [sym_interpolation_raw_start] = ACTIONS(3415),
  },
  [2296] = {
    [sym_preproc_region] = STATE(2296),
    [sym_preproc_endregion] = STATE(2296),
    [sym_preproc_line] = STATE(2296),
    [sym_preproc_pragma] = STATE(2296),
    [sym_preproc_nullable] = STATE(2296),
    [sym_preproc_error] = STATE(2296),
    [sym_preproc_define] = STATE(2296),
    [sym_preproc_undef] = STATE(2296),
    [ts_builtin_sym_end] = ACTIONS(2965),
    [sym__identifier_token] = ACTIONS(2963),
    [anon_sym_extern] = ACTIONS(2963),
    [anon_sym_alias] = ACTIONS(2963),
    [anon_sym_SEMI] = ACTIONS(2965),
    [anon_sym_global] = ACTIONS(2963),
    [anon_sym_using] = ACTIONS(2963),
    [anon_sym_unsafe] = ACTIONS(2963),
    [anon_sym_static] = ACTIONS(2963),
    [anon_sym_LBRACK] = ACTIONS(2965),
    [anon_sym_LPAREN] = ACTIONS(2965),
    [anon_sym_return] = ACTIONS(2963),
    [anon_sym_namespace] = ACTIONS(2963),
    [anon_sym_class] = ACTIONS(2963),
    [anon_sym_ref] = ACTIONS(2963),
    [anon_sym_struct] = ACTIONS(2963),
    [anon_sym_enum] = ACTIONS(2963),
    [anon_sym_LBRACE] = ACTIONS(2965),
    [anon_sym_interface] = ACTIONS(2963),
    [anon_sym_delegate] = ACTIONS(2963),
    [anon_sym_record] = ACTIONS(2963),
    [anon_sym_abstract] = ACTIONS(2963),
    [anon_sym_async] = ACTIONS(2963),
    [anon_sym_const] = ACTIONS(2963),
    [anon_sym_file] = ACTIONS(2963),
    [anon_sym_fixed] = ACTIONS(2963),
    [anon_sym_internal] = ACTIONS(2963),
    [anon_sym_new] = ACTIONS(2963),
    [anon_sym_override] = ACTIONS(2963),
    [anon_sym_partial] = ACTIONS(2963),
    [anon_sym_private] = ACTIONS(2963),
    [anon_sym_protected] = ACTIONS(2963),
    [anon_sym_public] = ACTIONS(2963),
    [anon_sym_readonly] = ACTIONS(2963),
    [anon_sym_required] = ACTIONS(2963),
    [anon_sym_sealed] = ACTIONS(2963),
    [anon_sym_virtual] = ACTIONS(2963),
    [anon_sym_volatile] = ACTIONS(2963),
    [anon_sym_where] = ACTIONS(2963),
    [anon_sym_notnull] = ACTIONS(2963),
    [anon_sym_unmanaged] = ACTIONS(2963),
    [anon_sym_checked] = ACTIONS(2963),
    [anon_sym_BANG] = ACTIONS(2965),
    [anon_sym_TILDE] = ACTIONS(2965),
    [anon_sym_PLUS_PLUS] = ACTIONS(2965),
    [anon_sym_DASH_DASH] = ACTIONS(2965),
    [anon_sym_true] = ACTIONS(2963),
    [anon_sym_false] = ACTIONS(2963),
    [anon_sym_PLUS] = ACTIONS(2963),
    [anon_sym_DASH] = ACTIONS(2963),
    [anon_sym_STAR] = ACTIONS(2965),
    [anon_sym_CARET] = ACTIONS(2965),
    [anon_sym_AMP] = ACTIONS(2965),
    [anon_sym_this] = ACTIONS(2963),
    [anon_sym_scoped] = ACTIONS(2963),
    [anon_sym_var] = ACTIONS(2963),
    [sym_predefined_type] = ACTIONS(2963),
    [anon_sym_break] = ACTIONS(2963),
    [anon_sym_unchecked] = ACTIONS(2963),
    [anon_sym_continue] = ACTIONS(2963),
    [anon_sym_do] = ACTIONS(2963),
    [anon_sym_while] = ACTIONS(2963),
    [anon_sym_for] = ACTIONS(2963),
    [anon_sym_lock] = ACTIONS(2963),
    [anon_sym_yield] = ACTIONS(2963),
    [anon_sym_switch] = ACTIONS(2963),
    [anon_sym_default] = ACTIONS(2963),
    [anon_sym_throw] = ACTIONS(2963),
    [anon_sym_try] = ACTIONS(2963),
    [anon_sym_catch] = ACTIONS(2963),
    [anon_sym_when] = ACTIONS(2963),
    [anon_sym_finally] = ACTIONS(2963),
    [anon_sym_await] = ACTIONS(2963),
    [anon_sym_foreach] = ACTIONS(2963),
    [anon_sym_goto] = ACTIONS(2963),
    [anon_sym_if] = ACTIONS(2963),
    [anon_sym_else] = ACTIONS(2963),
    [anon_sym_DOT_DOT] = ACTIONS(2965),
    [anon_sym_from] = ACTIONS(2963),
    [anon_sym_into] = ACTIONS(2963),
    [anon_sym_join] = ACTIONS(2963),
    [anon_sym_on] = ACTIONS(2963),
    [anon_sym_equals] = ACTIONS(2963),
    [anon_sym_let] = ACTIONS(2963),
    [anon_sym_orderby] = ACTIONS(2963),
    [anon_sym_ascending] = ACTIONS(2963),
    [anon_sym_descending] = ACTIONS(2963),
    [anon_sym_group] = ACTIONS(2963),
    [anon_sym_by] = ACTIONS(2963),
    [anon_sym_select] = ACTIONS(2963),
    [anon_sym_DQUOTE] = ACTIONS(2963),
    [anon_sym_stackalloc] = ACTIONS(2963),
    [anon_sym_sizeof] = ACTIONS(2963),
    [anon_sym_typeof] = ACTIONS(2963),
    [anon_sym___makeref] = ACTIONS(2963),
    [anon_sym___reftype] = ACTIONS(2963),
    [anon_sym___refvalue] = ACTIONS(2963),
    [sym_null_literal] = ACTIONS(2963),
    [anon_sym_SQUOTE] = ACTIONS(2965),
    [sym_integer_literal] = ACTIONS(2963),
    [sym_real_literal] = ACTIONS(2965),
    [sym_verbatim_string_literal] = ACTIONS(2965),
    [sym_raw_string_literal] = ACTIONS(2965),
    [aux_sym_preproc_if_token1] = ACTIONS(2965),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(2965),
    [sym_interpolation_verbatim_start] = ACTIONS(2965),
    [sym_interpolation_raw_start] = ACTIONS(2965),
  },
  [2297] = {
    [sym_preproc_region] = STATE(2297),
    [sym_preproc_endregion] = STATE(2297),
    [sym_preproc_line] = STATE(2297),
    [sym_preproc_pragma] = STATE(2297),
    [sym_preproc_nullable] = STATE(2297),
    [sym_preproc_error] = STATE(2297),
    [sym_preproc_define] = STATE(2297),
    [sym_preproc_undef] = STATE(2297),
    [sym__identifier_token] = ACTIONS(3417),
    [anon_sym_extern] = ACTIONS(3417),
    [anon_sym_alias] = ACTIONS(3417),
    [anon_sym_SEMI] = ACTIONS(3419),
    [anon_sym_global] = ACTIONS(3417),
    [anon_sym_using] = ACTIONS(3417),
    [anon_sym_unsafe] = ACTIONS(3417),
    [anon_sym_static] = ACTIONS(3417),
    [anon_sym_LBRACK] = ACTIONS(3419),
    [anon_sym_LPAREN] = ACTIONS(3419),
    [anon_sym_return] = ACTIONS(3417),
    [anon_sym_namespace] = ACTIONS(3417),
    [anon_sym_class] = ACTIONS(3417),
    [anon_sym_ref] = ACTIONS(3417),
    [anon_sym_struct] = ACTIONS(3417),
    [anon_sym_enum] = ACTIONS(3417),
    [anon_sym_LBRACE] = ACTIONS(3419),
    [anon_sym_interface] = ACTIONS(3417),
    [anon_sym_delegate] = ACTIONS(3417),
    [anon_sym_record] = ACTIONS(3417),
    [anon_sym_abstract] = ACTIONS(3417),
    [anon_sym_async] = ACTIONS(3417),
    [anon_sym_const] = ACTIONS(3417),
    [anon_sym_file] = ACTIONS(3417),
    [anon_sym_fixed] = ACTIONS(3417),
    [anon_sym_internal] = ACTIONS(3417),
    [anon_sym_new] = ACTIONS(3417),
    [anon_sym_override] = ACTIONS(3417),
    [anon_sym_partial] = ACTIONS(3417),
    [anon_sym_private] = ACTIONS(3417),
    [anon_sym_protected] = ACTIONS(3417),
    [anon_sym_public] = ACTIONS(3417),
    [anon_sym_readonly] = ACTIONS(3417),
    [anon_sym_required] = ACTIONS(3417),
    [anon_sym_sealed] = ACTIONS(3417),
    [anon_sym_virtual] = ACTIONS(3417),
    [anon_sym_volatile] = ACTIONS(3417),
    [anon_sym_where] = ACTIONS(3417),
    [anon_sym_notnull] = ACTIONS(3417),
    [anon_sym_unmanaged] = ACTIONS(3417),
    [anon_sym_checked] = ACTIONS(3417),
    [anon_sym_BANG] = ACTIONS(3419),
    [anon_sym_TILDE] = ACTIONS(3419),
    [anon_sym_PLUS_PLUS] = ACTIONS(3419),
    [anon_sym_DASH_DASH] = ACTIONS(3419),
    [anon_sym_true] = ACTIONS(3417),
    [anon_sym_false] = ACTIONS(3417),
    [anon_sym_PLUS] = ACTIONS(3417),
    [anon_sym_DASH] = ACTIONS(3417),
    [anon_sym_STAR] = ACTIONS(3419),
    [anon_sym_CARET] = ACTIONS(3419),
    [anon_sym_AMP] = ACTIONS(3419),
    [anon_sym_this] = ACTIONS(3417),
    [anon_sym_scoped] = ACTIONS(3417),
    [anon_sym_var] = ACTIONS(3417),
    [sym_predefined_type] = ACTIONS(3417),
    [anon_sym_break] = ACTIONS(3417),
    [anon_sym_unchecked] = ACTIONS(3417),
    [anon_sym_continue] = ACTIONS(3417),
    [anon_sym_do] = ACTIONS(3417),
    [anon_sym_while] = ACTIONS(3417),
    [anon_sym_for] = ACTIONS(3417),
    [anon_sym_lock] = ACTIONS(3417),
    [anon_sym_yield] = ACTIONS(3417),
    [anon_sym_switch] = ACTIONS(3417),
    [anon_sym_default] = ACTIONS(3417),
    [anon_sym_throw] = ACTIONS(3417),
    [anon_sym_try] = ACTIONS(3417),
    [anon_sym_when] = ACTIONS(3417),
    [anon_sym_await] = ACTIONS(3417),
    [anon_sym_foreach] = ACTIONS(3417),
    [anon_sym_goto] = ACTIONS(3417),
    [anon_sym_if] = ACTIONS(3417),
    [anon_sym_DOT_DOT] = ACTIONS(3419),
    [anon_sym_from] = ACTIONS(3417),
    [anon_sym_into] = ACTIONS(3417),
    [anon_sym_join] = ACTIONS(3417),
    [anon_sym_on] = ACTIONS(3417),
    [anon_sym_equals] = ACTIONS(3417),
    [anon_sym_let] = ACTIONS(3417),
    [anon_sym_orderby] = ACTIONS(3417),
    [anon_sym_ascending] = ACTIONS(3417),
    [anon_sym_descending] = ACTIONS(3417),
    [anon_sym_group] = ACTIONS(3417),
    [anon_sym_by] = ACTIONS(3417),
    [anon_sym_select] = ACTIONS(3417),
    [anon_sym_DQUOTE] = ACTIONS(3417),
    [anon_sym_stackalloc] = ACTIONS(3417),
    [anon_sym_sizeof] = ACTIONS(3417),
    [anon_sym_typeof] = ACTIONS(3417),
    [anon_sym___makeref] = ACTIONS(3417),
    [anon_sym___reftype] = ACTIONS(3417),
    [anon_sym___refvalue] = ACTIONS(3417),
    [sym_null_literal] = ACTIONS(3417),
    [anon_sym_SQUOTE] = ACTIONS(3419),
    [sym_integer_literal] = ACTIONS(3417),
    [sym_real_literal] = ACTIONS(3419),
    [sym_verbatim_string_literal] = ACTIONS(3419),
    [sym_raw_string_literal] = ACTIONS(3419),
    [aux_sym_preproc_if_token1] = ACTIONS(3419),
    [aux_sym_preproc_if_token3] = ACTIONS(3419),
    [aux_sym_preproc_else_token1] = ACTIONS(3419),
    [aux_sym_preproc_elif_token1] = ACTIONS(3419),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3419),
    [sym_interpolation_verbatim_start] = ACTIONS(3419),
    [sym_interpolation_raw_start] = ACTIONS(3419),
  },
  [2298] = {
    [sym_preproc_region] = STATE(2298),
    [sym_preproc_endregion] = STATE(2298),
    [sym_preproc_line] = STATE(2298),
    [sym_preproc_pragma] = STATE(2298),
    [sym_preproc_nullable] = STATE(2298),
    [sym_preproc_error] = STATE(2298),
    [sym_preproc_define] = STATE(2298),
    [sym_preproc_undef] = STATE(2298),
    [sym__identifier_token] = ACTIONS(3421),
    [anon_sym_extern] = ACTIONS(3421),
    [anon_sym_alias] = ACTIONS(3421),
    [anon_sym_SEMI] = ACTIONS(3423),
    [anon_sym_global] = ACTIONS(3421),
    [anon_sym_using] = ACTIONS(3421),
    [anon_sym_unsafe] = ACTIONS(3421),
    [anon_sym_static] = ACTIONS(3421),
    [anon_sym_LBRACK] = ACTIONS(3423),
    [anon_sym_LPAREN] = ACTIONS(3423),
    [anon_sym_return] = ACTIONS(3421),
    [anon_sym_namespace] = ACTIONS(3421),
    [anon_sym_class] = ACTIONS(3421),
    [anon_sym_ref] = ACTIONS(3421),
    [anon_sym_struct] = ACTIONS(3421),
    [anon_sym_enum] = ACTIONS(3421),
    [anon_sym_LBRACE] = ACTIONS(3423),
    [anon_sym_interface] = ACTIONS(3421),
    [anon_sym_delegate] = ACTIONS(3421),
    [anon_sym_record] = ACTIONS(3421),
    [anon_sym_abstract] = ACTIONS(3421),
    [anon_sym_async] = ACTIONS(3421),
    [anon_sym_const] = ACTIONS(3421),
    [anon_sym_file] = ACTIONS(3421),
    [anon_sym_fixed] = ACTIONS(3421),
    [anon_sym_internal] = ACTIONS(3421),
    [anon_sym_new] = ACTIONS(3421),
    [anon_sym_override] = ACTIONS(3421),
    [anon_sym_partial] = ACTIONS(3421),
    [anon_sym_private] = ACTIONS(3421),
    [anon_sym_protected] = ACTIONS(3421),
    [anon_sym_public] = ACTIONS(3421),
    [anon_sym_readonly] = ACTIONS(3421),
    [anon_sym_required] = ACTIONS(3421),
    [anon_sym_sealed] = ACTIONS(3421),
    [anon_sym_virtual] = ACTIONS(3421),
    [anon_sym_volatile] = ACTIONS(3421),
    [anon_sym_where] = ACTIONS(3421),
    [anon_sym_notnull] = ACTIONS(3421),
    [anon_sym_unmanaged] = ACTIONS(3421),
    [anon_sym_checked] = ACTIONS(3421),
    [anon_sym_BANG] = ACTIONS(3423),
    [anon_sym_TILDE] = ACTIONS(3423),
    [anon_sym_PLUS_PLUS] = ACTIONS(3423),
    [anon_sym_DASH_DASH] = ACTIONS(3423),
    [anon_sym_true] = ACTIONS(3421),
    [anon_sym_false] = ACTIONS(3421),
    [anon_sym_PLUS] = ACTIONS(3421),
    [anon_sym_DASH] = ACTIONS(3421),
    [anon_sym_STAR] = ACTIONS(3423),
    [anon_sym_CARET] = ACTIONS(3423),
    [anon_sym_AMP] = ACTIONS(3423),
    [anon_sym_this] = ACTIONS(3421),
    [anon_sym_scoped] = ACTIONS(3421),
    [anon_sym_var] = ACTIONS(3421),
    [sym_predefined_type] = ACTIONS(3421),
    [anon_sym_break] = ACTIONS(3421),
    [anon_sym_unchecked] = ACTIONS(3421),
    [anon_sym_continue] = ACTIONS(3421),
    [anon_sym_do] = ACTIONS(3421),
    [anon_sym_while] = ACTIONS(3421),
    [anon_sym_for] = ACTIONS(3421),
    [anon_sym_lock] = ACTIONS(3421),
    [anon_sym_yield] = ACTIONS(3421),
    [anon_sym_switch] = ACTIONS(3421),
    [anon_sym_default] = ACTIONS(3421),
    [anon_sym_throw] = ACTIONS(3421),
    [anon_sym_try] = ACTIONS(3421),
    [anon_sym_when] = ACTIONS(3421),
    [anon_sym_await] = ACTIONS(3421),
    [anon_sym_foreach] = ACTIONS(3421),
    [anon_sym_goto] = ACTIONS(3421),
    [anon_sym_if] = ACTIONS(3421),
    [anon_sym_DOT_DOT] = ACTIONS(3423),
    [anon_sym_from] = ACTIONS(3421),
    [anon_sym_into] = ACTIONS(3421),
    [anon_sym_join] = ACTIONS(3421),
    [anon_sym_on] = ACTIONS(3421),
    [anon_sym_equals] = ACTIONS(3421),
    [anon_sym_let] = ACTIONS(3421),
    [anon_sym_orderby] = ACTIONS(3421),
    [anon_sym_ascending] = ACTIONS(3421),
    [anon_sym_descending] = ACTIONS(3421),
    [anon_sym_group] = ACTIONS(3421),
    [anon_sym_by] = ACTIONS(3421),
    [anon_sym_select] = ACTIONS(3421),
    [anon_sym_DQUOTE] = ACTIONS(3421),
    [anon_sym_stackalloc] = ACTIONS(3421),
    [anon_sym_sizeof] = ACTIONS(3421),
    [anon_sym_typeof] = ACTIONS(3421),
    [anon_sym___makeref] = ACTIONS(3421),
    [anon_sym___reftype] = ACTIONS(3421),
    [anon_sym___refvalue] = ACTIONS(3421),
    [sym_null_literal] = ACTIONS(3421),
    [anon_sym_SQUOTE] = ACTIONS(3423),
    [sym_integer_literal] = ACTIONS(3421),
    [sym_real_literal] = ACTIONS(3423),
    [sym_verbatim_string_literal] = ACTIONS(3423),
    [sym_raw_string_literal] = ACTIONS(3423),
    [aux_sym_preproc_if_token1] = ACTIONS(3423),
    [aux_sym_preproc_if_token3] = ACTIONS(3423),
    [aux_sym_preproc_else_token1] = ACTIONS(3423),
    [aux_sym_preproc_elif_token1] = ACTIONS(3423),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3423),
    [sym_interpolation_verbatim_start] = ACTIONS(3423),
    [sym_interpolation_raw_start] = ACTIONS(3423),
  },
  [2299] = {
    [sym_preproc_region] = STATE(2299),
    [sym_preproc_endregion] = STATE(2299),
    [sym_preproc_line] = STATE(2299),
    [sym_preproc_pragma] = STATE(2299),
    [sym_preproc_nullable] = STATE(2299),
    [sym_preproc_error] = STATE(2299),
    [sym_preproc_define] = STATE(2299),
    [sym_preproc_undef] = STATE(2299),
    [sym__identifier_token] = ACTIONS(3425),
    [anon_sym_extern] = ACTIONS(3425),
    [anon_sym_alias] = ACTIONS(3425),
    [anon_sym_SEMI] = ACTIONS(3427),
    [anon_sym_global] = ACTIONS(3425),
    [anon_sym_using] = ACTIONS(3425),
    [anon_sym_unsafe] = ACTIONS(3425),
    [anon_sym_static] = ACTIONS(3425),
    [anon_sym_LBRACK] = ACTIONS(3427),
    [anon_sym_LPAREN] = ACTIONS(3427),
    [anon_sym_return] = ACTIONS(3425),
    [anon_sym_namespace] = ACTIONS(3425),
    [anon_sym_class] = ACTIONS(3425),
    [anon_sym_ref] = ACTIONS(3425),
    [anon_sym_struct] = ACTIONS(3425),
    [anon_sym_enum] = ACTIONS(3425),
    [anon_sym_LBRACE] = ACTIONS(3427),
    [anon_sym_interface] = ACTIONS(3425),
    [anon_sym_delegate] = ACTIONS(3425),
    [anon_sym_record] = ACTIONS(3425),
    [anon_sym_abstract] = ACTIONS(3425),
    [anon_sym_async] = ACTIONS(3425),
    [anon_sym_const] = ACTIONS(3425),
    [anon_sym_file] = ACTIONS(3425),
    [anon_sym_fixed] = ACTIONS(3425),
    [anon_sym_internal] = ACTIONS(3425),
    [anon_sym_new] = ACTIONS(3425),
    [anon_sym_override] = ACTIONS(3425),
    [anon_sym_partial] = ACTIONS(3425),
    [anon_sym_private] = ACTIONS(3425),
    [anon_sym_protected] = ACTIONS(3425),
    [anon_sym_public] = ACTIONS(3425),
    [anon_sym_readonly] = ACTIONS(3425),
    [anon_sym_required] = ACTIONS(3425),
    [anon_sym_sealed] = ACTIONS(3425),
    [anon_sym_virtual] = ACTIONS(3425),
    [anon_sym_volatile] = ACTIONS(3425),
    [anon_sym_where] = ACTIONS(3425),
    [anon_sym_notnull] = ACTIONS(3425),
    [anon_sym_unmanaged] = ACTIONS(3425),
    [anon_sym_checked] = ACTIONS(3425),
    [anon_sym_BANG] = ACTIONS(3427),
    [anon_sym_TILDE] = ACTIONS(3427),
    [anon_sym_PLUS_PLUS] = ACTIONS(3427),
    [anon_sym_DASH_DASH] = ACTIONS(3427),
    [anon_sym_true] = ACTIONS(3425),
    [anon_sym_false] = ACTIONS(3425),
    [anon_sym_PLUS] = ACTIONS(3425),
    [anon_sym_DASH] = ACTIONS(3425),
    [anon_sym_STAR] = ACTIONS(3427),
    [anon_sym_CARET] = ACTIONS(3427),
    [anon_sym_AMP] = ACTIONS(3427),
    [anon_sym_this] = ACTIONS(3425),
    [anon_sym_scoped] = ACTIONS(3425),
    [anon_sym_var] = ACTIONS(3425),
    [sym_predefined_type] = ACTIONS(3425),
    [anon_sym_break] = ACTIONS(3425),
    [anon_sym_unchecked] = ACTIONS(3425),
    [anon_sym_continue] = ACTIONS(3425),
    [anon_sym_do] = ACTIONS(3425),
    [anon_sym_while] = ACTIONS(3425),
    [anon_sym_for] = ACTIONS(3425),
    [anon_sym_lock] = ACTIONS(3425),
    [anon_sym_yield] = ACTIONS(3425),
    [anon_sym_switch] = ACTIONS(3425),
    [anon_sym_default] = ACTIONS(3425),
    [anon_sym_throw] = ACTIONS(3425),
    [anon_sym_try] = ACTIONS(3425),
    [anon_sym_when] = ACTIONS(3425),
    [anon_sym_await] = ACTIONS(3425),
    [anon_sym_foreach] = ACTIONS(3425),
    [anon_sym_goto] = ACTIONS(3425),
    [anon_sym_if] = ACTIONS(3425),
    [anon_sym_DOT_DOT] = ACTIONS(3427),
    [anon_sym_from] = ACTIONS(3425),
    [anon_sym_into] = ACTIONS(3425),
    [anon_sym_join] = ACTIONS(3425),
    [anon_sym_on] = ACTIONS(3425),
    [anon_sym_equals] = ACTIONS(3425),
    [anon_sym_let] = ACTIONS(3425),
    [anon_sym_orderby] = ACTIONS(3425),
    [anon_sym_ascending] = ACTIONS(3425),
    [anon_sym_descending] = ACTIONS(3425),
    [anon_sym_group] = ACTIONS(3425),
    [anon_sym_by] = ACTIONS(3425),
    [anon_sym_select] = ACTIONS(3425),
    [anon_sym_DQUOTE] = ACTIONS(3425),
    [anon_sym_stackalloc] = ACTIONS(3425),
    [anon_sym_sizeof] = ACTIONS(3425),
    [anon_sym_typeof] = ACTIONS(3425),
    [anon_sym___makeref] = ACTIONS(3425),
    [anon_sym___reftype] = ACTIONS(3425),
    [anon_sym___refvalue] = ACTIONS(3425),
    [sym_null_literal] = ACTIONS(3425),
    [anon_sym_SQUOTE] = ACTIONS(3427),
    [sym_integer_literal] = ACTIONS(3425),
    [sym_real_literal] = ACTIONS(3427),
    [sym_verbatim_string_literal] = ACTIONS(3427),
    [sym_raw_string_literal] = ACTIONS(3427),
    [aux_sym_preproc_if_token1] = ACTIONS(3427),
    [aux_sym_preproc_if_token3] = ACTIONS(3427),
    [aux_sym_preproc_else_token1] = ACTIONS(3427),
    [aux_sym_preproc_elif_token1] = ACTIONS(3427),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3427),
    [sym_interpolation_verbatim_start] = ACTIONS(3427),
    [sym_interpolation_raw_start] = ACTIONS(3427),
  },
  [2300] = {
    [sym_preproc_region] = STATE(2300),
    [sym_preproc_endregion] = STATE(2300),
    [sym_preproc_line] = STATE(2300),
    [sym_preproc_pragma] = STATE(2300),
    [sym_preproc_nullable] = STATE(2300),
    [sym_preproc_error] = STATE(2300),
    [sym_preproc_define] = STATE(2300),
    [sym_preproc_undef] = STATE(2300),
    [sym__identifier_token] = ACTIONS(3429),
    [anon_sym_extern] = ACTIONS(3429),
    [anon_sym_alias] = ACTIONS(3429),
    [anon_sym_SEMI] = ACTIONS(3431),
    [anon_sym_global] = ACTIONS(3429),
    [anon_sym_using] = ACTIONS(3429),
    [anon_sym_unsafe] = ACTIONS(3429),
    [anon_sym_static] = ACTIONS(3429),
    [anon_sym_LBRACK] = ACTIONS(3431),
    [anon_sym_LPAREN] = ACTIONS(3431),
    [anon_sym_return] = ACTIONS(3429),
    [anon_sym_namespace] = ACTIONS(3429),
    [anon_sym_class] = ACTIONS(3429),
    [anon_sym_ref] = ACTIONS(3429),
    [anon_sym_struct] = ACTIONS(3429),
    [anon_sym_enum] = ACTIONS(3429),
    [anon_sym_LBRACE] = ACTIONS(3431),
    [anon_sym_interface] = ACTIONS(3429),
    [anon_sym_delegate] = ACTIONS(3429),
    [anon_sym_record] = ACTIONS(3429),
    [anon_sym_abstract] = ACTIONS(3429),
    [anon_sym_async] = ACTIONS(3429),
    [anon_sym_const] = ACTIONS(3429),
    [anon_sym_file] = ACTIONS(3429),
    [anon_sym_fixed] = ACTIONS(3429),
    [anon_sym_internal] = ACTIONS(3429),
    [anon_sym_new] = ACTIONS(3429),
    [anon_sym_override] = ACTIONS(3429),
    [anon_sym_partial] = ACTIONS(3429),
    [anon_sym_private] = ACTIONS(3429),
    [anon_sym_protected] = ACTIONS(3429),
    [anon_sym_public] = ACTIONS(3429),
    [anon_sym_readonly] = ACTIONS(3429),
    [anon_sym_required] = ACTIONS(3429),
    [anon_sym_sealed] = ACTIONS(3429),
    [anon_sym_virtual] = ACTIONS(3429),
    [anon_sym_volatile] = ACTIONS(3429),
    [anon_sym_where] = ACTIONS(3429),
    [anon_sym_notnull] = ACTIONS(3429),
    [anon_sym_unmanaged] = ACTIONS(3429),
    [anon_sym_checked] = ACTIONS(3429),
    [anon_sym_BANG] = ACTIONS(3431),
    [anon_sym_TILDE] = ACTIONS(3431),
    [anon_sym_PLUS_PLUS] = ACTIONS(3431),
    [anon_sym_DASH_DASH] = ACTIONS(3431),
    [anon_sym_true] = ACTIONS(3429),
    [anon_sym_false] = ACTIONS(3429),
    [anon_sym_PLUS] = ACTIONS(3429),
    [anon_sym_DASH] = ACTIONS(3429),
    [anon_sym_STAR] = ACTIONS(3431),
    [anon_sym_CARET] = ACTIONS(3431),
    [anon_sym_AMP] = ACTIONS(3431),
    [anon_sym_this] = ACTIONS(3429),
    [anon_sym_scoped] = ACTIONS(3429),
    [anon_sym_var] = ACTIONS(3429),
    [sym_predefined_type] = ACTIONS(3429),
    [anon_sym_break] = ACTIONS(3429),
    [anon_sym_unchecked] = ACTIONS(3429),
    [anon_sym_continue] = ACTIONS(3429),
    [anon_sym_do] = ACTIONS(3429),
    [anon_sym_while] = ACTIONS(3429),
    [anon_sym_for] = ACTIONS(3429),
    [anon_sym_lock] = ACTIONS(3429),
    [anon_sym_yield] = ACTIONS(3429),
    [anon_sym_switch] = ACTIONS(3429),
    [anon_sym_default] = ACTIONS(3429),
    [anon_sym_throw] = ACTIONS(3429),
    [anon_sym_try] = ACTIONS(3429),
    [anon_sym_when] = ACTIONS(3429),
    [anon_sym_await] = ACTIONS(3429),
    [anon_sym_foreach] = ACTIONS(3429),
    [anon_sym_goto] = ACTIONS(3429),
    [anon_sym_if] = ACTIONS(3429),
    [anon_sym_DOT_DOT] = ACTIONS(3431),
    [anon_sym_from] = ACTIONS(3429),
    [anon_sym_into] = ACTIONS(3429),
    [anon_sym_join] = ACTIONS(3429),
    [anon_sym_on] = ACTIONS(3429),
    [anon_sym_equals] = ACTIONS(3429),
    [anon_sym_let] = ACTIONS(3429),
    [anon_sym_orderby] = ACTIONS(3429),
    [anon_sym_ascending] = ACTIONS(3429),
    [anon_sym_descending] = ACTIONS(3429),
    [anon_sym_group] = ACTIONS(3429),
    [anon_sym_by] = ACTIONS(3429),
    [anon_sym_select] = ACTIONS(3429),
    [anon_sym_DQUOTE] = ACTIONS(3429),
    [anon_sym_stackalloc] = ACTIONS(3429),
    [anon_sym_sizeof] = ACTIONS(3429),
    [anon_sym_typeof] = ACTIONS(3429),
    [anon_sym___makeref] = ACTIONS(3429),
    [anon_sym___reftype] = ACTIONS(3429),
    [anon_sym___refvalue] = ACTIONS(3429),
    [sym_null_literal] = ACTIONS(3429),
    [anon_sym_SQUOTE] = ACTIONS(3431),
    [sym_integer_literal] = ACTIONS(3429),
    [sym_real_literal] = ACTIONS(3431),
    [sym_verbatim_string_literal] = ACTIONS(3431),
    [sym_raw_string_literal] = ACTIONS(3431),
    [aux_sym_preproc_if_token1] = ACTIONS(3431),
    [aux_sym_preproc_if_token3] = ACTIONS(3431),
    [aux_sym_preproc_else_token1] = ACTIONS(3431),
    [aux_sym_preproc_elif_token1] = ACTIONS(3431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3431),
    [sym_interpolation_verbatim_start] = ACTIONS(3431),
    [sym_interpolation_raw_start] = ACTIONS(3431),
  },
  [2301] = {
    [sym_preproc_region] = STATE(2301),
    [sym_preproc_endregion] = STATE(2301),
    [sym_preproc_line] = STATE(2301),
    [sym_preproc_pragma] = STATE(2301),
    [sym_preproc_nullable] = STATE(2301),
    [sym_preproc_error] = STATE(2301),
    [sym_preproc_define] = STATE(2301),
    [sym_preproc_undef] = STATE(2301),
    [sym__identifier_token] = ACTIONS(3433),
    [anon_sym_extern] = ACTIONS(3433),
    [anon_sym_alias] = ACTIONS(3433),
    [anon_sym_SEMI] = ACTIONS(3435),
    [anon_sym_global] = ACTIONS(3433),
    [anon_sym_using] = ACTIONS(3433),
    [anon_sym_unsafe] = ACTIONS(3433),
    [anon_sym_static] = ACTIONS(3433),
    [anon_sym_LBRACK] = ACTIONS(3435),
    [anon_sym_LPAREN] = ACTIONS(3435),
    [anon_sym_return] = ACTIONS(3433),
    [anon_sym_namespace] = ACTIONS(3433),
    [anon_sym_class] = ACTIONS(3433),
    [anon_sym_ref] = ACTIONS(3433),
    [anon_sym_struct] = ACTIONS(3433),
    [anon_sym_enum] = ACTIONS(3433),
    [anon_sym_LBRACE] = ACTIONS(3435),
    [anon_sym_interface] = ACTIONS(3433),
    [anon_sym_delegate] = ACTIONS(3433),
    [anon_sym_record] = ACTIONS(3433),
    [anon_sym_abstract] = ACTIONS(3433),
    [anon_sym_async] = ACTIONS(3433),
    [anon_sym_const] = ACTIONS(3433),
    [anon_sym_file] = ACTIONS(3433),
    [anon_sym_fixed] = ACTIONS(3433),
    [anon_sym_internal] = ACTIONS(3433),
    [anon_sym_new] = ACTIONS(3433),
    [anon_sym_override] = ACTIONS(3433),
    [anon_sym_partial] = ACTIONS(3433),
    [anon_sym_private] = ACTIONS(3433),
    [anon_sym_protected] = ACTIONS(3433),
    [anon_sym_public] = ACTIONS(3433),
    [anon_sym_readonly] = ACTIONS(3433),
    [anon_sym_required] = ACTIONS(3433),
    [anon_sym_sealed] = ACTIONS(3433),
    [anon_sym_virtual] = ACTIONS(3433),
    [anon_sym_volatile] = ACTIONS(3433),
    [anon_sym_where] = ACTIONS(3433),
    [anon_sym_notnull] = ACTIONS(3433),
    [anon_sym_unmanaged] = ACTIONS(3433),
    [anon_sym_checked] = ACTIONS(3433),
    [anon_sym_BANG] = ACTIONS(3435),
    [anon_sym_TILDE] = ACTIONS(3435),
    [anon_sym_PLUS_PLUS] = ACTIONS(3435),
    [anon_sym_DASH_DASH] = ACTIONS(3435),
    [anon_sym_true] = ACTIONS(3433),
    [anon_sym_false] = ACTIONS(3433),
    [anon_sym_PLUS] = ACTIONS(3433),
    [anon_sym_DASH] = ACTIONS(3433),
    [anon_sym_STAR] = ACTIONS(3435),
    [anon_sym_CARET] = ACTIONS(3435),
    [anon_sym_AMP] = ACTIONS(3435),
    [anon_sym_this] = ACTIONS(3433),
    [anon_sym_scoped] = ACTIONS(3433),
    [anon_sym_var] = ACTIONS(3433),
    [sym_predefined_type] = ACTIONS(3433),
    [anon_sym_break] = ACTIONS(3433),
    [anon_sym_unchecked] = ACTIONS(3433),
    [anon_sym_continue] = ACTIONS(3433),
    [anon_sym_do] = ACTIONS(3433),
    [anon_sym_while] = ACTIONS(3433),
    [anon_sym_for] = ACTIONS(3433),
    [anon_sym_lock] = ACTIONS(3433),
    [anon_sym_yield] = ACTIONS(3433),
    [anon_sym_switch] = ACTIONS(3433),
    [anon_sym_default] = ACTIONS(3433),
    [anon_sym_throw] = ACTIONS(3433),
    [anon_sym_try] = ACTIONS(3433),
    [anon_sym_when] = ACTIONS(3433),
    [anon_sym_await] = ACTIONS(3433),
    [anon_sym_foreach] = ACTIONS(3433),
    [anon_sym_goto] = ACTIONS(3433),
    [anon_sym_if] = ACTIONS(3433),
    [anon_sym_DOT_DOT] = ACTIONS(3435),
    [anon_sym_from] = ACTIONS(3433),
    [anon_sym_into] = ACTIONS(3433),
    [anon_sym_join] = ACTIONS(3433),
    [anon_sym_on] = ACTIONS(3433),
    [anon_sym_equals] = ACTIONS(3433),
    [anon_sym_let] = ACTIONS(3433),
    [anon_sym_orderby] = ACTIONS(3433),
    [anon_sym_ascending] = ACTIONS(3433),
    [anon_sym_descending] = ACTIONS(3433),
    [anon_sym_group] = ACTIONS(3433),
    [anon_sym_by] = ACTIONS(3433),
    [anon_sym_select] = ACTIONS(3433),
    [anon_sym_DQUOTE] = ACTIONS(3433),
    [anon_sym_stackalloc] = ACTIONS(3433),
    [anon_sym_sizeof] = ACTIONS(3433),
    [anon_sym_typeof] = ACTIONS(3433),
    [anon_sym___makeref] = ACTIONS(3433),
    [anon_sym___reftype] = ACTIONS(3433),
    [anon_sym___refvalue] = ACTIONS(3433),
    [sym_null_literal] = ACTIONS(3433),
    [anon_sym_SQUOTE] = ACTIONS(3435),
    [sym_integer_literal] = ACTIONS(3433),
    [sym_real_literal] = ACTIONS(3435),
    [sym_verbatim_string_literal] = ACTIONS(3435),
    [sym_raw_string_literal] = ACTIONS(3435),
    [aux_sym_preproc_if_token1] = ACTIONS(3435),
    [aux_sym_preproc_if_token3] = ACTIONS(3435),
    [aux_sym_preproc_else_token1] = ACTIONS(3435),
    [aux_sym_preproc_elif_token1] = ACTIONS(3435),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3435),
    [sym_interpolation_verbatim_start] = ACTIONS(3435),
    [sym_interpolation_raw_start] = ACTIONS(3435),
  },
  [2302] = {
    [sym_preproc_region] = STATE(2302),
    [sym_preproc_endregion] = STATE(2302),
    [sym_preproc_line] = STATE(2302),
    [sym_preproc_pragma] = STATE(2302),
    [sym_preproc_nullable] = STATE(2302),
    [sym_preproc_error] = STATE(2302),
    [sym_preproc_define] = STATE(2302),
    [sym_preproc_undef] = STATE(2302),
    [sym__identifier_token] = ACTIONS(3437),
    [anon_sym_extern] = ACTIONS(3437),
    [anon_sym_alias] = ACTIONS(3437),
    [anon_sym_SEMI] = ACTIONS(3439),
    [anon_sym_global] = ACTIONS(3437),
    [anon_sym_using] = ACTIONS(3437),
    [anon_sym_unsafe] = ACTIONS(3437),
    [anon_sym_static] = ACTIONS(3437),
    [anon_sym_LBRACK] = ACTIONS(3439),
    [anon_sym_LPAREN] = ACTIONS(3439),
    [anon_sym_return] = ACTIONS(3437),
    [anon_sym_namespace] = ACTIONS(3437),
    [anon_sym_class] = ACTIONS(3437),
    [anon_sym_ref] = ACTIONS(3437),
    [anon_sym_struct] = ACTIONS(3437),
    [anon_sym_enum] = ACTIONS(3437),
    [anon_sym_LBRACE] = ACTIONS(3439),
    [anon_sym_interface] = ACTIONS(3437),
    [anon_sym_delegate] = ACTIONS(3437),
    [anon_sym_record] = ACTIONS(3437),
    [anon_sym_abstract] = ACTIONS(3437),
    [anon_sym_async] = ACTIONS(3437),
    [anon_sym_const] = ACTIONS(3437),
    [anon_sym_file] = ACTIONS(3437),
    [anon_sym_fixed] = ACTIONS(3437),
    [anon_sym_internal] = ACTIONS(3437),
    [anon_sym_new] = ACTIONS(3437),
    [anon_sym_override] = ACTIONS(3437),
    [anon_sym_partial] = ACTIONS(3437),
    [anon_sym_private] = ACTIONS(3437),
    [anon_sym_protected] = ACTIONS(3437),
    [anon_sym_public] = ACTIONS(3437),
    [anon_sym_readonly] = ACTIONS(3437),
    [anon_sym_required] = ACTIONS(3437),
    [anon_sym_sealed] = ACTIONS(3437),
    [anon_sym_virtual] = ACTIONS(3437),
    [anon_sym_volatile] = ACTIONS(3437),
    [anon_sym_where] = ACTIONS(3437),
    [anon_sym_notnull] = ACTIONS(3437),
    [anon_sym_unmanaged] = ACTIONS(3437),
    [anon_sym_checked] = ACTIONS(3437),
    [anon_sym_BANG] = ACTIONS(3439),
    [anon_sym_TILDE] = ACTIONS(3439),
    [anon_sym_PLUS_PLUS] = ACTIONS(3439),
    [anon_sym_DASH_DASH] = ACTIONS(3439),
    [anon_sym_true] = ACTIONS(3437),
    [anon_sym_false] = ACTIONS(3437),
    [anon_sym_PLUS] = ACTIONS(3437),
    [anon_sym_DASH] = ACTIONS(3437),
    [anon_sym_STAR] = ACTIONS(3439),
    [anon_sym_CARET] = ACTIONS(3439),
    [anon_sym_AMP] = ACTIONS(3439),
    [anon_sym_this] = ACTIONS(3437),
    [anon_sym_scoped] = ACTIONS(3437),
    [anon_sym_var] = ACTIONS(3437),
    [sym_predefined_type] = ACTIONS(3437),
    [anon_sym_break] = ACTIONS(3437),
    [anon_sym_unchecked] = ACTIONS(3437),
    [anon_sym_continue] = ACTIONS(3437),
    [anon_sym_do] = ACTIONS(3437),
    [anon_sym_while] = ACTIONS(3437),
    [anon_sym_for] = ACTIONS(3437),
    [anon_sym_lock] = ACTIONS(3437),
    [anon_sym_yield] = ACTIONS(3437),
    [anon_sym_switch] = ACTIONS(3437),
    [anon_sym_default] = ACTIONS(3437),
    [anon_sym_throw] = ACTIONS(3437),
    [anon_sym_try] = ACTIONS(3437),
    [anon_sym_when] = ACTIONS(3437),
    [anon_sym_await] = ACTIONS(3437),
    [anon_sym_foreach] = ACTIONS(3437),
    [anon_sym_goto] = ACTIONS(3437),
    [anon_sym_if] = ACTIONS(3437),
    [anon_sym_DOT_DOT] = ACTIONS(3439),
    [anon_sym_from] = ACTIONS(3437),
    [anon_sym_into] = ACTIONS(3437),
    [anon_sym_join] = ACTIONS(3437),
    [anon_sym_on] = ACTIONS(3437),
    [anon_sym_equals] = ACTIONS(3437),
    [anon_sym_let] = ACTIONS(3437),
    [anon_sym_orderby] = ACTIONS(3437),
    [anon_sym_ascending] = ACTIONS(3437),
    [anon_sym_descending] = ACTIONS(3437),
    [anon_sym_group] = ACTIONS(3437),
    [anon_sym_by] = ACTIONS(3437),
    [anon_sym_select] = ACTIONS(3437),
    [anon_sym_DQUOTE] = ACTIONS(3437),
    [anon_sym_stackalloc] = ACTIONS(3437),
    [anon_sym_sizeof] = ACTIONS(3437),
    [anon_sym_typeof] = ACTIONS(3437),
    [anon_sym___makeref] = ACTIONS(3437),
    [anon_sym___reftype] = ACTIONS(3437),
    [anon_sym___refvalue] = ACTIONS(3437),
    [sym_null_literal] = ACTIONS(3437),
    [anon_sym_SQUOTE] = ACTIONS(3439),
    [sym_integer_literal] = ACTIONS(3437),
    [sym_real_literal] = ACTIONS(3439),
    [sym_verbatim_string_literal] = ACTIONS(3439),
    [sym_raw_string_literal] = ACTIONS(3439),
    [aux_sym_preproc_if_token1] = ACTIONS(3439),
    [aux_sym_preproc_if_token3] = ACTIONS(3439),
    [aux_sym_preproc_else_token1] = ACTIONS(3439),
    [aux_sym_preproc_elif_token1] = ACTIONS(3439),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3439),
    [sym_interpolation_verbatim_start] = ACTIONS(3439),
    [sym_interpolation_raw_start] = ACTIONS(3439),
  },
  [2303] = {
    [sym_preproc_region] = STATE(2303),
    [sym_preproc_endregion] = STATE(2303),
    [sym_preproc_line] = STATE(2303),
    [sym_preproc_pragma] = STATE(2303),
    [sym_preproc_nullable] = STATE(2303),
    [sym_preproc_error] = STATE(2303),
    [sym_preproc_define] = STATE(2303),
    [sym_preproc_undef] = STATE(2303),
    [sym__identifier_token] = ACTIONS(3441),
    [anon_sym_extern] = ACTIONS(3441),
    [anon_sym_alias] = ACTIONS(3441),
    [anon_sym_SEMI] = ACTIONS(3443),
    [anon_sym_global] = ACTIONS(3441),
    [anon_sym_using] = ACTIONS(3441),
    [anon_sym_unsafe] = ACTIONS(3441),
    [anon_sym_static] = ACTIONS(3441),
    [anon_sym_LBRACK] = ACTIONS(3443),
    [anon_sym_LPAREN] = ACTIONS(3443),
    [anon_sym_return] = ACTIONS(3441),
    [anon_sym_namespace] = ACTIONS(3441),
    [anon_sym_class] = ACTIONS(3441),
    [anon_sym_ref] = ACTIONS(3441),
    [anon_sym_struct] = ACTIONS(3441),
    [anon_sym_enum] = ACTIONS(3441),
    [anon_sym_LBRACE] = ACTIONS(3443),
    [anon_sym_interface] = ACTIONS(3441),
    [anon_sym_delegate] = ACTIONS(3441),
    [anon_sym_record] = ACTIONS(3441),
    [anon_sym_abstract] = ACTIONS(3441),
    [anon_sym_async] = ACTIONS(3441),
    [anon_sym_const] = ACTIONS(3441),
    [anon_sym_file] = ACTIONS(3441),
    [anon_sym_fixed] = ACTIONS(3441),
    [anon_sym_internal] = ACTIONS(3441),
    [anon_sym_new] = ACTIONS(3441),
    [anon_sym_override] = ACTIONS(3441),
    [anon_sym_partial] = ACTIONS(3441),
    [anon_sym_private] = ACTIONS(3441),
    [anon_sym_protected] = ACTIONS(3441),
    [anon_sym_public] = ACTIONS(3441),
    [anon_sym_readonly] = ACTIONS(3441),
    [anon_sym_required] = ACTIONS(3441),
    [anon_sym_sealed] = ACTIONS(3441),
    [anon_sym_virtual] = ACTIONS(3441),
    [anon_sym_volatile] = ACTIONS(3441),
    [anon_sym_where] = ACTIONS(3441),
    [anon_sym_notnull] = ACTIONS(3441),
    [anon_sym_unmanaged] = ACTIONS(3441),
    [anon_sym_checked] = ACTIONS(3441),
    [anon_sym_BANG] = ACTIONS(3443),
    [anon_sym_TILDE] = ACTIONS(3443),
    [anon_sym_PLUS_PLUS] = ACTIONS(3443),
    [anon_sym_DASH_DASH] = ACTIONS(3443),
    [anon_sym_true] = ACTIONS(3441),
    [anon_sym_false] = ACTIONS(3441),
    [anon_sym_PLUS] = ACTIONS(3441),
    [anon_sym_DASH] = ACTIONS(3441),
    [anon_sym_STAR] = ACTIONS(3443),
    [anon_sym_CARET] = ACTIONS(3443),
    [anon_sym_AMP] = ACTIONS(3443),
    [anon_sym_this] = ACTIONS(3441),
    [anon_sym_scoped] = ACTIONS(3441),
    [anon_sym_var] = ACTIONS(3441),
    [sym_predefined_type] = ACTIONS(3441),
    [anon_sym_break] = ACTIONS(3441),
    [anon_sym_unchecked] = ACTIONS(3441),
    [anon_sym_continue] = ACTIONS(3441),
    [anon_sym_do] = ACTIONS(3441),
    [anon_sym_while] = ACTIONS(3441),
    [anon_sym_for] = ACTIONS(3441),
    [anon_sym_lock] = ACTIONS(3441),
    [anon_sym_yield] = ACTIONS(3441),
    [anon_sym_switch] = ACTIONS(3441),
    [anon_sym_default] = ACTIONS(3441),
    [anon_sym_throw] = ACTIONS(3441),
    [anon_sym_try] = ACTIONS(3441),
    [anon_sym_when] = ACTIONS(3441),
    [anon_sym_await] = ACTIONS(3441),
    [anon_sym_foreach] = ACTIONS(3441),
    [anon_sym_goto] = ACTIONS(3441),
    [anon_sym_if] = ACTIONS(3441),
    [anon_sym_DOT_DOT] = ACTIONS(3443),
    [anon_sym_from] = ACTIONS(3441),
    [anon_sym_into] = ACTIONS(3441),
    [anon_sym_join] = ACTIONS(3441),
    [anon_sym_on] = ACTIONS(3441),
    [anon_sym_equals] = ACTIONS(3441),
    [anon_sym_let] = ACTIONS(3441),
    [anon_sym_orderby] = ACTIONS(3441),
    [anon_sym_ascending] = ACTIONS(3441),
    [anon_sym_descending] = ACTIONS(3441),
    [anon_sym_group] = ACTIONS(3441),
    [anon_sym_by] = ACTIONS(3441),
    [anon_sym_select] = ACTIONS(3441),
    [anon_sym_DQUOTE] = ACTIONS(3441),
    [anon_sym_stackalloc] = ACTIONS(3441),
    [anon_sym_sizeof] = ACTIONS(3441),
    [anon_sym_typeof] = ACTIONS(3441),
    [anon_sym___makeref] = ACTIONS(3441),
    [anon_sym___reftype] = ACTIONS(3441),
    [anon_sym___refvalue] = ACTIONS(3441),
    [sym_null_literal] = ACTIONS(3441),
    [anon_sym_SQUOTE] = ACTIONS(3443),
    [sym_integer_literal] = ACTIONS(3441),
    [sym_real_literal] = ACTIONS(3443),
    [sym_verbatim_string_literal] = ACTIONS(3443),
    [sym_raw_string_literal] = ACTIONS(3443),
    [aux_sym_preproc_if_token1] = ACTIONS(3443),
    [aux_sym_preproc_if_token3] = ACTIONS(3443),
    [aux_sym_preproc_else_token1] = ACTIONS(3443),
    [aux_sym_preproc_elif_token1] = ACTIONS(3443),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3443),
    [sym_interpolation_verbatim_start] = ACTIONS(3443),
    [sym_interpolation_raw_start] = ACTIONS(3443),
  },
  [2304] = {
    [sym_preproc_region] = STATE(2304),
    [sym_preproc_endregion] = STATE(2304),
    [sym_preproc_line] = STATE(2304),
    [sym_preproc_pragma] = STATE(2304),
    [sym_preproc_nullable] = STATE(2304),
    [sym_preproc_error] = STATE(2304),
    [sym_preproc_define] = STATE(2304),
    [sym_preproc_undef] = STATE(2304),
    [sym__identifier_token] = ACTIONS(3445),
    [anon_sym_extern] = ACTIONS(3445),
    [anon_sym_alias] = ACTIONS(3445),
    [anon_sym_SEMI] = ACTIONS(3447),
    [anon_sym_global] = ACTIONS(3445),
    [anon_sym_using] = ACTIONS(3445),
    [anon_sym_unsafe] = ACTIONS(3445),
    [anon_sym_static] = ACTIONS(3445),
    [anon_sym_LBRACK] = ACTIONS(3447),
    [anon_sym_LPAREN] = ACTIONS(3447),
    [anon_sym_return] = ACTIONS(3445),
    [anon_sym_namespace] = ACTIONS(3445),
    [anon_sym_class] = ACTIONS(3445),
    [anon_sym_ref] = ACTIONS(3445),
    [anon_sym_struct] = ACTIONS(3445),
    [anon_sym_enum] = ACTIONS(3445),
    [anon_sym_LBRACE] = ACTIONS(3447),
    [anon_sym_interface] = ACTIONS(3445),
    [anon_sym_delegate] = ACTIONS(3445),
    [anon_sym_record] = ACTIONS(3445),
    [anon_sym_abstract] = ACTIONS(3445),
    [anon_sym_async] = ACTIONS(3445),
    [anon_sym_const] = ACTIONS(3445),
    [anon_sym_file] = ACTIONS(3445),
    [anon_sym_fixed] = ACTIONS(3445),
    [anon_sym_internal] = ACTIONS(3445),
    [anon_sym_new] = ACTIONS(3445),
    [anon_sym_override] = ACTIONS(3445),
    [anon_sym_partial] = ACTIONS(3445),
    [anon_sym_private] = ACTIONS(3445),
    [anon_sym_protected] = ACTIONS(3445),
    [anon_sym_public] = ACTIONS(3445),
    [anon_sym_readonly] = ACTIONS(3445),
    [anon_sym_required] = ACTIONS(3445),
    [anon_sym_sealed] = ACTIONS(3445),
    [anon_sym_virtual] = ACTIONS(3445),
    [anon_sym_volatile] = ACTIONS(3445),
    [anon_sym_where] = ACTIONS(3445),
    [anon_sym_notnull] = ACTIONS(3445),
    [anon_sym_unmanaged] = ACTIONS(3445),
    [anon_sym_checked] = ACTIONS(3445),
    [anon_sym_BANG] = ACTIONS(3447),
    [anon_sym_TILDE] = ACTIONS(3447),
    [anon_sym_PLUS_PLUS] = ACTIONS(3447),
    [anon_sym_DASH_DASH] = ACTIONS(3447),
    [anon_sym_true] = ACTIONS(3445),
    [anon_sym_false] = ACTIONS(3445),
    [anon_sym_PLUS] = ACTIONS(3445),
    [anon_sym_DASH] = ACTIONS(3445),
    [anon_sym_STAR] = ACTIONS(3447),
    [anon_sym_CARET] = ACTIONS(3447),
    [anon_sym_AMP] = ACTIONS(3447),
    [anon_sym_this] = ACTIONS(3445),
    [anon_sym_scoped] = ACTIONS(3445),
    [anon_sym_var] = ACTIONS(3445),
    [sym_predefined_type] = ACTIONS(3445),
    [anon_sym_break] = ACTIONS(3445),
    [anon_sym_unchecked] = ACTIONS(3445),
    [anon_sym_continue] = ACTIONS(3445),
    [anon_sym_do] = ACTIONS(3445),
    [anon_sym_while] = ACTIONS(3445),
    [anon_sym_for] = ACTIONS(3445),
    [anon_sym_lock] = ACTIONS(3445),
    [anon_sym_yield] = ACTIONS(3445),
    [anon_sym_switch] = ACTIONS(3445),
    [anon_sym_default] = ACTIONS(3445),
    [anon_sym_throw] = ACTIONS(3445),
    [anon_sym_try] = ACTIONS(3445),
    [anon_sym_when] = ACTIONS(3445),
    [anon_sym_await] = ACTIONS(3445),
    [anon_sym_foreach] = ACTIONS(3445),
    [anon_sym_goto] = ACTIONS(3445),
    [anon_sym_if] = ACTIONS(3445),
    [anon_sym_DOT_DOT] = ACTIONS(3447),
    [anon_sym_from] = ACTIONS(3445),
    [anon_sym_into] = ACTIONS(3445),
    [anon_sym_join] = ACTIONS(3445),
    [anon_sym_on] = ACTIONS(3445),
    [anon_sym_equals] = ACTIONS(3445),
    [anon_sym_let] = ACTIONS(3445),
    [anon_sym_orderby] = ACTIONS(3445),
    [anon_sym_ascending] = ACTIONS(3445),
    [anon_sym_descending] = ACTIONS(3445),
    [anon_sym_group] = ACTIONS(3445),
    [anon_sym_by] = ACTIONS(3445),
    [anon_sym_select] = ACTIONS(3445),
    [anon_sym_DQUOTE] = ACTIONS(3445),
    [anon_sym_stackalloc] = ACTIONS(3445),
    [anon_sym_sizeof] = ACTIONS(3445),
    [anon_sym_typeof] = ACTIONS(3445),
    [anon_sym___makeref] = ACTIONS(3445),
    [anon_sym___reftype] = ACTIONS(3445),
    [anon_sym___refvalue] = ACTIONS(3445),
    [sym_null_literal] = ACTIONS(3445),
    [anon_sym_SQUOTE] = ACTIONS(3447),
    [sym_integer_literal] = ACTIONS(3445),
    [sym_real_literal] = ACTIONS(3447),
    [sym_verbatim_string_literal] = ACTIONS(3447),
    [sym_raw_string_literal] = ACTIONS(3447),
    [aux_sym_preproc_if_token1] = ACTIONS(3447),
    [aux_sym_preproc_if_token3] = ACTIONS(3447),
    [aux_sym_preproc_else_token1] = ACTIONS(3447),
    [aux_sym_preproc_elif_token1] = ACTIONS(3447),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3447),
    [sym_interpolation_verbatim_start] = ACTIONS(3447),
    [sym_interpolation_raw_start] = ACTIONS(3447),
  },
  [2305] = {
    [sym_preproc_region] = STATE(2305),
    [sym_preproc_endregion] = STATE(2305),
    [sym_preproc_line] = STATE(2305),
    [sym_preproc_pragma] = STATE(2305),
    [sym_preproc_nullable] = STATE(2305),
    [sym_preproc_error] = STATE(2305),
    [sym_preproc_define] = STATE(2305),
    [sym_preproc_undef] = STATE(2305),
    [sym__identifier_token] = ACTIONS(3449),
    [anon_sym_extern] = ACTIONS(3449),
    [anon_sym_alias] = ACTIONS(3449),
    [anon_sym_SEMI] = ACTIONS(3451),
    [anon_sym_global] = ACTIONS(3449),
    [anon_sym_using] = ACTIONS(3449),
    [anon_sym_unsafe] = ACTIONS(3449),
    [anon_sym_static] = ACTIONS(3449),
    [anon_sym_LBRACK] = ACTIONS(3451),
    [anon_sym_LPAREN] = ACTIONS(3451),
    [anon_sym_return] = ACTIONS(3449),
    [anon_sym_namespace] = ACTIONS(3449),
    [anon_sym_class] = ACTIONS(3449),
    [anon_sym_ref] = ACTIONS(3449),
    [anon_sym_struct] = ACTIONS(3449),
    [anon_sym_enum] = ACTIONS(3449),
    [anon_sym_LBRACE] = ACTIONS(3451),
    [anon_sym_interface] = ACTIONS(3449),
    [anon_sym_delegate] = ACTIONS(3449),
    [anon_sym_record] = ACTIONS(3449),
    [anon_sym_abstract] = ACTIONS(3449),
    [anon_sym_async] = ACTIONS(3449),
    [anon_sym_const] = ACTIONS(3449),
    [anon_sym_file] = ACTIONS(3449),
    [anon_sym_fixed] = ACTIONS(3449),
    [anon_sym_internal] = ACTIONS(3449),
    [anon_sym_new] = ACTIONS(3449),
    [anon_sym_override] = ACTIONS(3449),
    [anon_sym_partial] = ACTIONS(3449),
    [anon_sym_private] = ACTIONS(3449),
    [anon_sym_protected] = ACTIONS(3449),
    [anon_sym_public] = ACTIONS(3449),
    [anon_sym_readonly] = ACTIONS(3449),
    [anon_sym_required] = ACTIONS(3449),
    [anon_sym_sealed] = ACTIONS(3449),
    [anon_sym_virtual] = ACTIONS(3449),
    [anon_sym_volatile] = ACTIONS(3449),
    [anon_sym_where] = ACTIONS(3449),
    [anon_sym_notnull] = ACTIONS(3449),
    [anon_sym_unmanaged] = ACTIONS(3449),
    [anon_sym_checked] = ACTIONS(3449),
    [anon_sym_BANG] = ACTIONS(3451),
    [anon_sym_TILDE] = ACTIONS(3451),
    [anon_sym_PLUS_PLUS] = ACTIONS(3451),
    [anon_sym_DASH_DASH] = ACTIONS(3451),
    [anon_sym_true] = ACTIONS(3449),
    [anon_sym_false] = ACTIONS(3449),
    [anon_sym_PLUS] = ACTIONS(3449),
    [anon_sym_DASH] = ACTIONS(3449),
    [anon_sym_STAR] = ACTIONS(3451),
    [anon_sym_CARET] = ACTIONS(3451),
    [anon_sym_AMP] = ACTIONS(3451),
    [anon_sym_this] = ACTIONS(3449),
    [anon_sym_scoped] = ACTIONS(3449),
    [anon_sym_var] = ACTIONS(3449),
    [sym_predefined_type] = ACTIONS(3449),
    [anon_sym_break] = ACTIONS(3449),
    [anon_sym_unchecked] = ACTIONS(3449),
    [anon_sym_continue] = ACTIONS(3449),
    [anon_sym_do] = ACTIONS(3449),
    [anon_sym_while] = ACTIONS(3449),
    [anon_sym_for] = ACTIONS(3449),
    [anon_sym_lock] = ACTIONS(3449),
    [anon_sym_yield] = ACTIONS(3449),
    [anon_sym_switch] = ACTIONS(3449),
    [anon_sym_default] = ACTIONS(3449),
    [anon_sym_throw] = ACTIONS(3449),
    [anon_sym_try] = ACTIONS(3449),
    [anon_sym_when] = ACTIONS(3449),
    [anon_sym_await] = ACTIONS(3449),
    [anon_sym_foreach] = ACTIONS(3449),
    [anon_sym_goto] = ACTIONS(3449),
    [anon_sym_if] = ACTIONS(3449),
    [anon_sym_DOT_DOT] = ACTIONS(3451),
    [anon_sym_from] = ACTIONS(3449),
    [anon_sym_into] = ACTIONS(3449),
    [anon_sym_join] = ACTIONS(3449),
    [anon_sym_on] = ACTIONS(3449),
    [anon_sym_equals] = ACTIONS(3449),
    [anon_sym_let] = ACTIONS(3449),
    [anon_sym_orderby] = ACTIONS(3449),
    [anon_sym_ascending] = ACTIONS(3449),
    [anon_sym_descending] = ACTIONS(3449),
    [anon_sym_group] = ACTIONS(3449),
    [anon_sym_by] = ACTIONS(3449),
    [anon_sym_select] = ACTIONS(3449),
    [anon_sym_DQUOTE] = ACTIONS(3449),
    [anon_sym_stackalloc] = ACTIONS(3449),
    [anon_sym_sizeof] = ACTIONS(3449),
    [anon_sym_typeof] = ACTIONS(3449),
    [anon_sym___makeref] = ACTIONS(3449),
    [anon_sym___reftype] = ACTIONS(3449),
    [anon_sym___refvalue] = ACTIONS(3449),
    [sym_null_literal] = ACTIONS(3449),
    [anon_sym_SQUOTE] = ACTIONS(3451),
    [sym_integer_literal] = ACTIONS(3449),
    [sym_real_literal] = ACTIONS(3451),
    [sym_verbatim_string_literal] = ACTIONS(3451),
    [sym_raw_string_literal] = ACTIONS(3451),
    [aux_sym_preproc_if_token1] = ACTIONS(3451),
    [aux_sym_preproc_if_token3] = ACTIONS(3451),
    [aux_sym_preproc_else_token1] = ACTIONS(3451),
    [aux_sym_preproc_elif_token1] = ACTIONS(3451),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3451),
    [sym_interpolation_verbatim_start] = ACTIONS(3451),
    [sym_interpolation_raw_start] = ACTIONS(3451),
  },
  [2306] = {
    [sym_preproc_region] = STATE(2306),
    [sym_preproc_endregion] = STATE(2306),
    [sym_preproc_line] = STATE(2306),
    [sym_preproc_pragma] = STATE(2306),
    [sym_preproc_nullable] = STATE(2306),
    [sym_preproc_error] = STATE(2306),
    [sym_preproc_define] = STATE(2306),
    [sym_preproc_undef] = STATE(2306),
    [sym__identifier_token] = ACTIONS(3453),
    [anon_sym_extern] = ACTIONS(3453),
    [anon_sym_alias] = ACTIONS(3453),
    [anon_sym_SEMI] = ACTIONS(3455),
    [anon_sym_global] = ACTIONS(3453),
    [anon_sym_using] = ACTIONS(3453),
    [anon_sym_unsafe] = ACTIONS(3453),
    [anon_sym_static] = ACTIONS(3453),
    [anon_sym_LBRACK] = ACTIONS(3455),
    [anon_sym_LPAREN] = ACTIONS(3455),
    [anon_sym_return] = ACTIONS(3453),
    [anon_sym_namespace] = ACTIONS(3453),
    [anon_sym_class] = ACTIONS(3453),
    [anon_sym_ref] = ACTIONS(3453),
    [anon_sym_struct] = ACTIONS(3453),
    [anon_sym_enum] = ACTIONS(3453),
    [anon_sym_LBRACE] = ACTIONS(3455),
    [anon_sym_interface] = ACTIONS(3453),
    [anon_sym_delegate] = ACTIONS(3453),
    [anon_sym_record] = ACTIONS(3453),
    [anon_sym_abstract] = ACTIONS(3453),
    [anon_sym_async] = ACTIONS(3453),
    [anon_sym_const] = ACTIONS(3453),
    [anon_sym_file] = ACTIONS(3453),
    [anon_sym_fixed] = ACTIONS(3453),
    [anon_sym_internal] = ACTIONS(3453),
    [anon_sym_new] = ACTIONS(3453),
    [anon_sym_override] = ACTIONS(3453),
    [anon_sym_partial] = ACTIONS(3453),
    [anon_sym_private] = ACTIONS(3453),
    [anon_sym_protected] = ACTIONS(3453),
    [anon_sym_public] = ACTIONS(3453),
    [anon_sym_readonly] = ACTIONS(3453),
    [anon_sym_required] = ACTIONS(3453),
    [anon_sym_sealed] = ACTIONS(3453),
    [anon_sym_virtual] = ACTIONS(3453),
    [anon_sym_volatile] = ACTIONS(3453),
    [anon_sym_where] = ACTIONS(3453),
    [anon_sym_notnull] = ACTIONS(3453),
    [anon_sym_unmanaged] = ACTIONS(3453),
    [anon_sym_checked] = ACTIONS(3453),
    [anon_sym_BANG] = ACTIONS(3455),
    [anon_sym_TILDE] = ACTIONS(3455),
    [anon_sym_PLUS_PLUS] = ACTIONS(3455),
    [anon_sym_DASH_DASH] = ACTIONS(3455),
    [anon_sym_true] = ACTIONS(3453),
    [anon_sym_false] = ACTIONS(3453),
    [anon_sym_PLUS] = ACTIONS(3453),
    [anon_sym_DASH] = ACTIONS(3453),
    [anon_sym_STAR] = ACTIONS(3455),
    [anon_sym_CARET] = ACTIONS(3455),
    [anon_sym_AMP] = ACTIONS(3455),
    [anon_sym_this] = ACTIONS(3453),
    [anon_sym_scoped] = ACTIONS(3453),
    [anon_sym_var] = ACTIONS(3453),
    [sym_predefined_type] = ACTIONS(3453),
    [anon_sym_break] = ACTIONS(3453),
    [anon_sym_unchecked] = ACTIONS(3453),
    [anon_sym_continue] = ACTIONS(3453),
    [anon_sym_do] = ACTIONS(3453),
    [anon_sym_while] = ACTIONS(3453),
    [anon_sym_for] = ACTIONS(3453),
    [anon_sym_lock] = ACTIONS(3453),
    [anon_sym_yield] = ACTIONS(3453),
    [anon_sym_switch] = ACTIONS(3453),
    [anon_sym_default] = ACTIONS(3453),
    [anon_sym_throw] = ACTIONS(3453),
    [anon_sym_try] = ACTIONS(3453),
    [anon_sym_when] = ACTIONS(3453),
    [anon_sym_await] = ACTIONS(3453),
    [anon_sym_foreach] = ACTIONS(3453),
    [anon_sym_goto] = ACTIONS(3453),
    [anon_sym_if] = ACTIONS(3453),
    [anon_sym_DOT_DOT] = ACTIONS(3455),
    [anon_sym_from] = ACTIONS(3453),
    [anon_sym_into] = ACTIONS(3453),
    [anon_sym_join] = ACTIONS(3453),
    [anon_sym_on] = ACTIONS(3453),
    [anon_sym_equals] = ACTIONS(3453),
    [anon_sym_let] = ACTIONS(3453),
    [anon_sym_orderby] = ACTIONS(3453),
    [anon_sym_ascending] = ACTIONS(3453),
    [anon_sym_descending] = ACTIONS(3453),
    [anon_sym_group] = ACTIONS(3453),
    [anon_sym_by] = ACTIONS(3453),
    [anon_sym_select] = ACTIONS(3453),
    [anon_sym_DQUOTE] = ACTIONS(3453),
    [anon_sym_stackalloc] = ACTIONS(3453),
    [anon_sym_sizeof] = ACTIONS(3453),
    [anon_sym_typeof] = ACTIONS(3453),
    [anon_sym___makeref] = ACTIONS(3453),
    [anon_sym___reftype] = ACTIONS(3453),
    [anon_sym___refvalue] = ACTIONS(3453),
    [sym_null_literal] = ACTIONS(3453),
    [anon_sym_SQUOTE] = ACTIONS(3455),
    [sym_integer_literal] = ACTIONS(3453),
    [sym_real_literal] = ACTIONS(3455),
    [sym_verbatim_string_literal] = ACTIONS(3455),
    [sym_raw_string_literal] = ACTIONS(3455),
    [aux_sym_preproc_if_token1] = ACTIONS(3455),
    [aux_sym_preproc_if_token3] = ACTIONS(3455),
    [aux_sym_preproc_else_token1] = ACTIONS(3455),
    [aux_sym_preproc_elif_token1] = ACTIONS(3455),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3455),
    [sym_interpolation_verbatim_start] = ACTIONS(3455),
    [sym_interpolation_raw_start] = ACTIONS(3455),
  },
  [2307] = {
    [sym_preproc_region] = STATE(2307),
    [sym_preproc_endregion] = STATE(2307),
    [sym_preproc_line] = STATE(2307),
    [sym_preproc_pragma] = STATE(2307),
    [sym_preproc_nullable] = STATE(2307),
    [sym_preproc_error] = STATE(2307),
    [sym_preproc_define] = STATE(2307),
    [sym_preproc_undef] = STATE(2307),
    [sym__identifier_token] = ACTIONS(3457),
    [anon_sym_extern] = ACTIONS(3457),
    [anon_sym_alias] = ACTIONS(3457),
    [anon_sym_SEMI] = ACTIONS(3459),
    [anon_sym_global] = ACTIONS(3457),
    [anon_sym_using] = ACTIONS(3457),
    [anon_sym_unsafe] = ACTIONS(3457),
    [anon_sym_static] = ACTIONS(3457),
    [anon_sym_LBRACK] = ACTIONS(3459),
    [anon_sym_LPAREN] = ACTIONS(3459),
    [anon_sym_return] = ACTIONS(3457),
    [anon_sym_namespace] = ACTIONS(3457),
    [anon_sym_class] = ACTIONS(3457),
    [anon_sym_ref] = ACTIONS(3457),
    [anon_sym_struct] = ACTIONS(3457),
    [anon_sym_enum] = ACTIONS(3457),
    [anon_sym_LBRACE] = ACTIONS(3459),
    [anon_sym_interface] = ACTIONS(3457),
    [anon_sym_delegate] = ACTIONS(3457),
    [anon_sym_record] = ACTIONS(3457),
    [anon_sym_abstract] = ACTIONS(3457),
    [anon_sym_async] = ACTIONS(3457),
    [anon_sym_const] = ACTIONS(3457),
    [anon_sym_file] = ACTIONS(3457),
    [anon_sym_fixed] = ACTIONS(3457),
    [anon_sym_internal] = ACTIONS(3457),
    [anon_sym_new] = ACTIONS(3457),
    [anon_sym_override] = ACTIONS(3457),
    [anon_sym_partial] = ACTIONS(3457),
    [anon_sym_private] = ACTIONS(3457),
    [anon_sym_protected] = ACTIONS(3457),
    [anon_sym_public] = ACTIONS(3457),
    [anon_sym_readonly] = ACTIONS(3457),
    [anon_sym_required] = ACTIONS(3457),
    [anon_sym_sealed] = ACTIONS(3457),
    [anon_sym_virtual] = ACTIONS(3457),
    [anon_sym_volatile] = ACTIONS(3457),
    [anon_sym_where] = ACTIONS(3457),
    [anon_sym_notnull] = ACTIONS(3457),
    [anon_sym_unmanaged] = ACTIONS(3457),
    [anon_sym_checked] = ACTIONS(3457),
    [anon_sym_BANG] = ACTIONS(3459),
    [anon_sym_TILDE] = ACTIONS(3459),
    [anon_sym_PLUS_PLUS] = ACTIONS(3459),
    [anon_sym_DASH_DASH] = ACTIONS(3459),
    [anon_sym_true] = ACTIONS(3457),
    [anon_sym_false] = ACTIONS(3457),
    [anon_sym_PLUS] = ACTIONS(3457),
    [anon_sym_DASH] = ACTIONS(3457),
    [anon_sym_STAR] = ACTIONS(3459),
    [anon_sym_CARET] = ACTIONS(3459),
    [anon_sym_AMP] = ACTIONS(3459),
    [anon_sym_this] = ACTIONS(3457),
    [anon_sym_scoped] = ACTIONS(3457),
    [anon_sym_var] = ACTIONS(3457),
    [sym_predefined_type] = ACTIONS(3457),
    [anon_sym_break] = ACTIONS(3457),
    [anon_sym_unchecked] = ACTIONS(3457),
    [anon_sym_continue] = ACTIONS(3457),
    [anon_sym_do] = ACTIONS(3457),
    [anon_sym_while] = ACTIONS(3457),
    [anon_sym_for] = ACTIONS(3457),
    [anon_sym_lock] = ACTIONS(3457),
    [anon_sym_yield] = ACTIONS(3457),
    [anon_sym_switch] = ACTIONS(3457),
    [anon_sym_default] = ACTIONS(3457),
    [anon_sym_throw] = ACTIONS(3457),
    [anon_sym_try] = ACTIONS(3457),
    [anon_sym_when] = ACTIONS(3457),
    [anon_sym_await] = ACTIONS(3457),
    [anon_sym_foreach] = ACTIONS(3457),
    [anon_sym_goto] = ACTIONS(3457),
    [anon_sym_if] = ACTIONS(3457),
    [anon_sym_DOT_DOT] = ACTIONS(3459),
    [anon_sym_from] = ACTIONS(3457),
    [anon_sym_into] = ACTIONS(3457),
    [anon_sym_join] = ACTIONS(3457),
    [anon_sym_on] = ACTIONS(3457),
    [anon_sym_equals] = ACTIONS(3457),
    [anon_sym_let] = ACTIONS(3457),
    [anon_sym_orderby] = ACTIONS(3457),
    [anon_sym_ascending] = ACTIONS(3457),
    [anon_sym_descending] = ACTIONS(3457),
    [anon_sym_group] = ACTIONS(3457),
    [anon_sym_by] = ACTIONS(3457),
    [anon_sym_select] = ACTIONS(3457),
    [anon_sym_DQUOTE] = ACTIONS(3457),
    [anon_sym_stackalloc] = ACTIONS(3457),
    [anon_sym_sizeof] = ACTIONS(3457),
    [anon_sym_typeof] = ACTIONS(3457),
    [anon_sym___makeref] = ACTIONS(3457),
    [anon_sym___reftype] = ACTIONS(3457),
    [anon_sym___refvalue] = ACTIONS(3457),
    [sym_null_literal] = ACTIONS(3457),
    [anon_sym_SQUOTE] = ACTIONS(3459),
    [sym_integer_literal] = ACTIONS(3457),
    [sym_real_literal] = ACTIONS(3459),
    [sym_verbatim_string_literal] = ACTIONS(3459),
    [sym_raw_string_literal] = ACTIONS(3459),
    [aux_sym_preproc_if_token1] = ACTIONS(3459),
    [aux_sym_preproc_if_token3] = ACTIONS(3459),
    [aux_sym_preproc_else_token1] = ACTIONS(3459),
    [aux_sym_preproc_elif_token1] = ACTIONS(3459),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3459),
    [sym_interpolation_verbatim_start] = ACTIONS(3459),
    [sym_interpolation_raw_start] = ACTIONS(3459),
  },
  [2308] = {
    [sym_preproc_region] = STATE(2308),
    [sym_preproc_endregion] = STATE(2308),
    [sym_preproc_line] = STATE(2308),
    [sym_preproc_pragma] = STATE(2308),
    [sym_preproc_nullable] = STATE(2308),
    [sym_preproc_error] = STATE(2308),
    [sym_preproc_define] = STATE(2308),
    [sym_preproc_undef] = STATE(2308),
    [sym__identifier_token] = ACTIONS(3461),
    [anon_sym_extern] = ACTIONS(3461),
    [anon_sym_alias] = ACTIONS(3461),
    [anon_sym_SEMI] = ACTIONS(3463),
    [anon_sym_global] = ACTIONS(3461),
    [anon_sym_using] = ACTIONS(3461),
    [anon_sym_unsafe] = ACTIONS(3461),
    [anon_sym_static] = ACTIONS(3461),
    [anon_sym_LBRACK] = ACTIONS(3463),
    [anon_sym_LPAREN] = ACTIONS(3463),
    [anon_sym_return] = ACTIONS(3461),
    [anon_sym_namespace] = ACTIONS(3461),
    [anon_sym_class] = ACTIONS(3461),
    [anon_sym_ref] = ACTIONS(3461),
    [anon_sym_struct] = ACTIONS(3461),
    [anon_sym_enum] = ACTIONS(3461),
    [anon_sym_LBRACE] = ACTIONS(3463),
    [anon_sym_interface] = ACTIONS(3461),
    [anon_sym_delegate] = ACTIONS(3461),
    [anon_sym_record] = ACTIONS(3461),
    [anon_sym_abstract] = ACTIONS(3461),
    [anon_sym_async] = ACTIONS(3461),
    [anon_sym_const] = ACTIONS(3461),
    [anon_sym_file] = ACTIONS(3461),
    [anon_sym_fixed] = ACTIONS(3461),
    [anon_sym_internal] = ACTIONS(3461),
    [anon_sym_new] = ACTIONS(3461),
    [anon_sym_override] = ACTIONS(3461),
    [anon_sym_partial] = ACTIONS(3461),
    [anon_sym_private] = ACTIONS(3461),
    [anon_sym_protected] = ACTIONS(3461),
    [anon_sym_public] = ACTIONS(3461),
    [anon_sym_readonly] = ACTIONS(3461),
    [anon_sym_required] = ACTIONS(3461),
    [anon_sym_sealed] = ACTIONS(3461),
    [anon_sym_virtual] = ACTIONS(3461),
    [anon_sym_volatile] = ACTIONS(3461),
    [anon_sym_where] = ACTIONS(3461),
    [anon_sym_notnull] = ACTIONS(3461),
    [anon_sym_unmanaged] = ACTIONS(3461),
    [anon_sym_checked] = ACTIONS(3461),
    [anon_sym_BANG] = ACTIONS(3463),
    [anon_sym_TILDE] = ACTIONS(3463),
    [anon_sym_PLUS_PLUS] = ACTIONS(3463),
    [anon_sym_DASH_DASH] = ACTIONS(3463),
    [anon_sym_true] = ACTIONS(3461),
    [anon_sym_false] = ACTIONS(3461),
    [anon_sym_PLUS] = ACTIONS(3461),
    [anon_sym_DASH] = ACTIONS(3461),
    [anon_sym_STAR] = ACTIONS(3463),
    [anon_sym_CARET] = ACTIONS(3463),
    [anon_sym_AMP] = ACTIONS(3463),
    [anon_sym_this] = ACTIONS(3461),
    [anon_sym_scoped] = ACTIONS(3461),
    [anon_sym_var] = ACTIONS(3461),
    [sym_predefined_type] = ACTIONS(3461),
    [anon_sym_break] = ACTIONS(3461),
    [anon_sym_unchecked] = ACTIONS(3461),
    [anon_sym_continue] = ACTIONS(3461),
    [anon_sym_do] = ACTIONS(3461),
    [anon_sym_while] = ACTIONS(3461),
    [anon_sym_for] = ACTIONS(3461),
    [anon_sym_lock] = ACTIONS(3461),
    [anon_sym_yield] = ACTIONS(3461),
    [anon_sym_switch] = ACTIONS(3461),
    [anon_sym_default] = ACTIONS(3461),
    [anon_sym_throw] = ACTIONS(3461),
    [anon_sym_try] = ACTIONS(3461),
    [anon_sym_when] = ACTIONS(3461),
    [anon_sym_await] = ACTIONS(3461),
    [anon_sym_foreach] = ACTIONS(3461),
    [anon_sym_goto] = ACTIONS(3461),
    [anon_sym_if] = ACTIONS(3461),
    [anon_sym_DOT_DOT] = ACTIONS(3463),
    [anon_sym_from] = ACTIONS(3461),
    [anon_sym_into] = ACTIONS(3461),
    [anon_sym_join] = ACTIONS(3461),
    [anon_sym_on] = ACTIONS(3461),
    [anon_sym_equals] = ACTIONS(3461),
    [anon_sym_let] = ACTIONS(3461),
    [anon_sym_orderby] = ACTIONS(3461),
    [anon_sym_ascending] = ACTIONS(3461),
    [anon_sym_descending] = ACTIONS(3461),
    [anon_sym_group] = ACTIONS(3461),
    [anon_sym_by] = ACTIONS(3461),
    [anon_sym_select] = ACTIONS(3461),
    [anon_sym_DQUOTE] = ACTIONS(3461),
    [anon_sym_stackalloc] = ACTIONS(3461),
    [anon_sym_sizeof] = ACTIONS(3461),
    [anon_sym_typeof] = ACTIONS(3461),
    [anon_sym___makeref] = ACTIONS(3461),
    [anon_sym___reftype] = ACTIONS(3461),
    [anon_sym___refvalue] = ACTIONS(3461),
    [sym_null_literal] = ACTIONS(3461),
    [anon_sym_SQUOTE] = ACTIONS(3463),
    [sym_integer_literal] = ACTIONS(3461),
    [sym_real_literal] = ACTIONS(3463),
    [sym_verbatim_string_literal] = ACTIONS(3463),
    [sym_raw_string_literal] = ACTIONS(3463),
    [aux_sym_preproc_if_token1] = ACTIONS(3463),
    [aux_sym_preproc_if_token3] = ACTIONS(3463),
    [aux_sym_preproc_else_token1] = ACTIONS(3463),
    [aux_sym_preproc_elif_token1] = ACTIONS(3463),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3463),
    [sym_interpolation_verbatim_start] = ACTIONS(3463),
    [sym_interpolation_raw_start] = ACTIONS(3463),
  },
  [2309] = {
    [sym_preproc_region] = STATE(2309),
    [sym_preproc_endregion] = STATE(2309),
    [sym_preproc_line] = STATE(2309),
    [sym_preproc_pragma] = STATE(2309),
    [sym_preproc_nullable] = STATE(2309),
    [sym_preproc_error] = STATE(2309),
    [sym_preproc_define] = STATE(2309),
    [sym_preproc_undef] = STATE(2309),
    [sym__identifier_token] = ACTIONS(3465),
    [anon_sym_extern] = ACTIONS(3465),
    [anon_sym_alias] = ACTIONS(3465),
    [anon_sym_SEMI] = ACTIONS(3467),
    [anon_sym_global] = ACTIONS(3465),
    [anon_sym_using] = ACTIONS(3465),
    [anon_sym_unsafe] = ACTIONS(3465),
    [anon_sym_static] = ACTIONS(3465),
    [anon_sym_LBRACK] = ACTIONS(3467),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_return] = ACTIONS(3465),
    [anon_sym_namespace] = ACTIONS(3465),
    [anon_sym_class] = ACTIONS(3465),
    [anon_sym_ref] = ACTIONS(3465),
    [anon_sym_struct] = ACTIONS(3465),
    [anon_sym_enum] = ACTIONS(3465),
    [anon_sym_LBRACE] = ACTIONS(3467),
    [anon_sym_interface] = ACTIONS(3465),
    [anon_sym_delegate] = ACTIONS(3465),
    [anon_sym_record] = ACTIONS(3465),
    [anon_sym_abstract] = ACTIONS(3465),
    [anon_sym_async] = ACTIONS(3465),
    [anon_sym_const] = ACTIONS(3465),
    [anon_sym_file] = ACTIONS(3465),
    [anon_sym_fixed] = ACTIONS(3465),
    [anon_sym_internal] = ACTIONS(3465),
    [anon_sym_new] = ACTIONS(3465),
    [anon_sym_override] = ACTIONS(3465),
    [anon_sym_partial] = ACTIONS(3465),
    [anon_sym_private] = ACTIONS(3465),
    [anon_sym_protected] = ACTIONS(3465),
    [anon_sym_public] = ACTIONS(3465),
    [anon_sym_readonly] = ACTIONS(3465),
    [anon_sym_required] = ACTIONS(3465),
    [anon_sym_sealed] = ACTIONS(3465),
    [anon_sym_virtual] = ACTIONS(3465),
    [anon_sym_volatile] = ACTIONS(3465),
    [anon_sym_where] = ACTIONS(3465),
    [anon_sym_notnull] = ACTIONS(3465),
    [anon_sym_unmanaged] = ACTIONS(3465),
    [anon_sym_checked] = ACTIONS(3465),
    [anon_sym_BANG] = ACTIONS(3467),
    [anon_sym_TILDE] = ACTIONS(3467),
    [anon_sym_PLUS_PLUS] = ACTIONS(3467),
    [anon_sym_DASH_DASH] = ACTIONS(3467),
    [anon_sym_true] = ACTIONS(3465),
    [anon_sym_false] = ACTIONS(3465),
    [anon_sym_PLUS] = ACTIONS(3465),
    [anon_sym_DASH] = ACTIONS(3465),
    [anon_sym_STAR] = ACTIONS(3467),
    [anon_sym_CARET] = ACTIONS(3467),
    [anon_sym_AMP] = ACTIONS(3467),
    [anon_sym_this] = ACTIONS(3465),
    [anon_sym_scoped] = ACTIONS(3465),
    [anon_sym_var] = ACTIONS(3465),
    [sym_predefined_type] = ACTIONS(3465),
    [anon_sym_break] = ACTIONS(3465),
    [anon_sym_unchecked] = ACTIONS(3465),
    [anon_sym_continue] = ACTIONS(3465),
    [anon_sym_do] = ACTIONS(3465),
    [anon_sym_while] = ACTIONS(3465),
    [anon_sym_for] = ACTIONS(3465),
    [anon_sym_lock] = ACTIONS(3465),
    [anon_sym_yield] = ACTIONS(3465),
    [anon_sym_switch] = ACTIONS(3465),
    [anon_sym_default] = ACTIONS(3465),
    [anon_sym_throw] = ACTIONS(3465),
    [anon_sym_try] = ACTIONS(3465),
    [anon_sym_when] = ACTIONS(3465),
    [anon_sym_await] = ACTIONS(3465),
    [anon_sym_foreach] = ACTIONS(3465),
    [anon_sym_goto] = ACTIONS(3465),
    [anon_sym_if] = ACTIONS(3465),
    [anon_sym_DOT_DOT] = ACTIONS(3467),
    [anon_sym_from] = ACTIONS(3465),
    [anon_sym_into] = ACTIONS(3465),
    [anon_sym_join] = ACTIONS(3465),
    [anon_sym_on] = ACTIONS(3465),
    [anon_sym_equals] = ACTIONS(3465),
    [anon_sym_let] = ACTIONS(3465),
    [anon_sym_orderby] = ACTIONS(3465),
    [anon_sym_ascending] = ACTIONS(3465),
    [anon_sym_descending] = ACTIONS(3465),
    [anon_sym_group] = ACTIONS(3465),
    [anon_sym_by] = ACTIONS(3465),
    [anon_sym_select] = ACTIONS(3465),
    [anon_sym_DQUOTE] = ACTIONS(3465),
    [anon_sym_stackalloc] = ACTIONS(3465),
    [anon_sym_sizeof] = ACTIONS(3465),
    [anon_sym_typeof] = ACTIONS(3465),
    [anon_sym___makeref] = ACTIONS(3465),
    [anon_sym___reftype] = ACTIONS(3465),
    [anon_sym___refvalue] = ACTIONS(3465),
    [sym_null_literal] = ACTIONS(3465),
    [anon_sym_SQUOTE] = ACTIONS(3467),
    [sym_integer_literal] = ACTIONS(3465),
    [sym_real_literal] = ACTIONS(3467),
    [sym_verbatim_string_literal] = ACTIONS(3467),
    [sym_raw_string_literal] = ACTIONS(3467),
    [aux_sym_preproc_if_token1] = ACTIONS(3467),
    [aux_sym_preproc_if_token3] = ACTIONS(3467),
    [aux_sym_preproc_else_token1] = ACTIONS(3467),
    [aux_sym_preproc_elif_token1] = ACTIONS(3467),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3467),
    [sym_interpolation_verbatim_start] = ACTIONS(3467),
    [sym_interpolation_raw_start] = ACTIONS(3467),
  },
  [2310] = {
    [sym_preproc_region] = STATE(2310),
    [sym_preproc_endregion] = STATE(2310),
    [sym_preproc_line] = STATE(2310),
    [sym_preproc_pragma] = STATE(2310),
    [sym_preproc_nullable] = STATE(2310),
    [sym_preproc_error] = STATE(2310),
    [sym_preproc_define] = STATE(2310),
    [sym_preproc_undef] = STATE(2310),
    [sym__identifier_token] = ACTIONS(3469),
    [anon_sym_extern] = ACTIONS(3469),
    [anon_sym_alias] = ACTIONS(3469),
    [anon_sym_SEMI] = ACTIONS(3471),
    [anon_sym_global] = ACTIONS(3469),
    [anon_sym_using] = ACTIONS(3469),
    [anon_sym_unsafe] = ACTIONS(3469),
    [anon_sym_static] = ACTIONS(3469),
    [anon_sym_LBRACK] = ACTIONS(3471),
    [anon_sym_LPAREN] = ACTIONS(3471),
    [anon_sym_return] = ACTIONS(3469),
    [anon_sym_namespace] = ACTIONS(3469),
    [anon_sym_class] = ACTIONS(3469),
    [anon_sym_ref] = ACTIONS(3469),
    [anon_sym_struct] = ACTIONS(3469),
    [anon_sym_enum] = ACTIONS(3469),
    [anon_sym_LBRACE] = ACTIONS(3471),
    [anon_sym_interface] = ACTIONS(3469),
    [anon_sym_delegate] = ACTIONS(3469),
    [anon_sym_record] = ACTIONS(3469),
    [anon_sym_abstract] = ACTIONS(3469),
    [anon_sym_async] = ACTIONS(3469),
    [anon_sym_const] = ACTIONS(3469),
    [anon_sym_file] = ACTIONS(3469),
    [anon_sym_fixed] = ACTIONS(3469),
    [anon_sym_internal] = ACTIONS(3469),
    [anon_sym_new] = ACTIONS(3469),
    [anon_sym_override] = ACTIONS(3469),
    [anon_sym_partial] = ACTIONS(3469),
    [anon_sym_private] = ACTIONS(3469),
    [anon_sym_protected] = ACTIONS(3469),
    [anon_sym_public] = ACTIONS(3469),
    [anon_sym_readonly] = ACTIONS(3469),
    [anon_sym_required] = ACTIONS(3469),
    [anon_sym_sealed] = ACTIONS(3469),
    [anon_sym_virtual] = ACTIONS(3469),
    [anon_sym_volatile] = ACTIONS(3469),
    [anon_sym_where] = ACTIONS(3469),
    [anon_sym_notnull] = ACTIONS(3469),
    [anon_sym_unmanaged] = ACTIONS(3469),
    [anon_sym_checked] = ACTIONS(3469),
    [anon_sym_BANG] = ACTIONS(3471),
    [anon_sym_TILDE] = ACTIONS(3471),
    [anon_sym_PLUS_PLUS] = ACTIONS(3471),
    [anon_sym_DASH_DASH] = ACTIONS(3471),
    [anon_sym_true] = ACTIONS(3469),
    [anon_sym_false] = ACTIONS(3469),
    [anon_sym_PLUS] = ACTIONS(3469),
    [anon_sym_DASH] = ACTIONS(3469),
    [anon_sym_STAR] = ACTIONS(3471),
    [anon_sym_CARET] = ACTIONS(3471),
    [anon_sym_AMP] = ACTIONS(3471),
    [anon_sym_this] = ACTIONS(3469),
    [anon_sym_scoped] = ACTIONS(3469),
    [anon_sym_var] = ACTIONS(3469),
    [sym_predefined_type] = ACTIONS(3469),
    [anon_sym_break] = ACTIONS(3469),
    [anon_sym_unchecked] = ACTIONS(3469),
    [anon_sym_continue] = ACTIONS(3469),
    [anon_sym_do] = ACTIONS(3469),
    [anon_sym_while] = ACTIONS(3469),
    [anon_sym_for] = ACTIONS(3469),
    [anon_sym_lock] = ACTIONS(3469),
    [anon_sym_yield] = ACTIONS(3469),
    [anon_sym_switch] = ACTIONS(3469),
    [anon_sym_default] = ACTIONS(3469),
    [anon_sym_throw] = ACTIONS(3469),
    [anon_sym_try] = ACTIONS(3469),
    [anon_sym_when] = ACTIONS(3469),
    [anon_sym_await] = ACTIONS(3469),
    [anon_sym_foreach] = ACTIONS(3469),
    [anon_sym_goto] = ACTIONS(3469),
    [anon_sym_if] = ACTIONS(3469),
    [anon_sym_DOT_DOT] = ACTIONS(3471),
    [anon_sym_from] = ACTIONS(3469),
    [anon_sym_into] = ACTIONS(3469),
    [anon_sym_join] = ACTIONS(3469),
    [anon_sym_on] = ACTIONS(3469),
    [anon_sym_equals] = ACTIONS(3469),
    [anon_sym_let] = ACTIONS(3469),
    [anon_sym_orderby] = ACTIONS(3469),
    [anon_sym_ascending] = ACTIONS(3469),
    [anon_sym_descending] = ACTIONS(3469),
    [anon_sym_group] = ACTIONS(3469),
    [anon_sym_by] = ACTIONS(3469),
    [anon_sym_select] = ACTIONS(3469),
    [anon_sym_DQUOTE] = ACTIONS(3469),
    [anon_sym_stackalloc] = ACTIONS(3469),
    [anon_sym_sizeof] = ACTIONS(3469),
    [anon_sym_typeof] = ACTIONS(3469),
    [anon_sym___makeref] = ACTIONS(3469),
    [anon_sym___reftype] = ACTIONS(3469),
    [anon_sym___refvalue] = ACTIONS(3469),
    [sym_null_literal] = ACTIONS(3469),
    [anon_sym_SQUOTE] = ACTIONS(3471),
    [sym_integer_literal] = ACTIONS(3469),
    [sym_real_literal] = ACTIONS(3471),
    [sym_verbatim_string_literal] = ACTIONS(3471),
    [sym_raw_string_literal] = ACTIONS(3471),
    [aux_sym_preproc_if_token1] = ACTIONS(3471),
    [aux_sym_preproc_if_token3] = ACTIONS(3471),
    [aux_sym_preproc_else_token1] = ACTIONS(3471),
    [aux_sym_preproc_elif_token1] = ACTIONS(3471),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3471),
    [sym_interpolation_verbatim_start] = ACTIONS(3471),
    [sym_interpolation_raw_start] = ACTIONS(3471),
  },
  [2311] = {
    [sym_preproc_region] = STATE(2311),
    [sym_preproc_endregion] = STATE(2311),
    [sym_preproc_line] = STATE(2311),
    [sym_preproc_pragma] = STATE(2311),
    [sym_preproc_nullable] = STATE(2311),
    [sym_preproc_error] = STATE(2311),
    [sym_preproc_define] = STATE(2311),
    [sym_preproc_undef] = STATE(2311),
    [sym__identifier_token] = ACTIONS(3473),
    [anon_sym_extern] = ACTIONS(3473),
    [anon_sym_alias] = ACTIONS(3473),
    [anon_sym_SEMI] = ACTIONS(3475),
    [anon_sym_global] = ACTIONS(3473),
    [anon_sym_using] = ACTIONS(3473),
    [anon_sym_unsafe] = ACTIONS(3473),
    [anon_sym_static] = ACTIONS(3473),
    [anon_sym_LBRACK] = ACTIONS(3475),
    [anon_sym_LPAREN] = ACTIONS(3475),
    [anon_sym_return] = ACTIONS(3473),
    [anon_sym_namespace] = ACTIONS(3473),
    [anon_sym_class] = ACTIONS(3473),
    [anon_sym_ref] = ACTIONS(3473),
    [anon_sym_struct] = ACTIONS(3473),
    [anon_sym_enum] = ACTIONS(3473),
    [anon_sym_LBRACE] = ACTIONS(3475),
    [anon_sym_interface] = ACTIONS(3473),
    [anon_sym_delegate] = ACTIONS(3473),
    [anon_sym_record] = ACTIONS(3473),
    [anon_sym_abstract] = ACTIONS(3473),
    [anon_sym_async] = ACTIONS(3473),
    [anon_sym_const] = ACTIONS(3473),
    [anon_sym_file] = ACTIONS(3473),
    [anon_sym_fixed] = ACTIONS(3473),
    [anon_sym_internal] = ACTIONS(3473),
    [anon_sym_new] = ACTIONS(3473),
    [anon_sym_override] = ACTIONS(3473),
    [anon_sym_partial] = ACTIONS(3473),
    [anon_sym_private] = ACTIONS(3473),
    [anon_sym_protected] = ACTIONS(3473),
    [anon_sym_public] = ACTIONS(3473),
    [anon_sym_readonly] = ACTIONS(3473),
    [anon_sym_required] = ACTIONS(3473),
    [anon_sym_sealed] = ACTIONS(3473),
    [anon_sym_virtual] = ACTIONS(3473),
    [anon_sym_volatile] = ACTIONS(3473),
    [anon_sym_where] = ACTIONS(3473),
    [anon_sym_notnull] = ACTIONS(3473),
    [anon_sym_unmanaged] = ACTIONS(3473),
    [anon_sym_checked] = ACTIONS(3473),
    [anon_sym_BANG] = ACTIONS(3475),
    [anon_sym_TILDE] = ACTIONS(3475),
    [anon_sym_PLUS_PLUS] = ACTIONS(3475),
    [anon_sym_DASH_DASH] = ACTIONS(3475),
    [anon_sym_true] = ACTIONS(3473),
    [anon_sym_false] = ACTIONS(3473),
    [anon_sym_PLUS] = ACTIONS(3473),
    [anon_sym_DASH] = ACTIONS(3473),
    [anon_sym_STAR] = ACTIONS(3475),
    [anon_sym_CARET] = ACTIONS(3475),
    [anon_sym_AMP] = ACTIONS(3475),
    [anon_sym_this] = ACTIONS(3473),
    [anon_sym_scoped] = ACTIONS(3473),
    [anon_sym_var] = ACTIONS(3473),
    [sym_predefined_type] = ACTIONS(3473),
    [anon_sym_break] = ACTIONS(3473),
    [anon_sym_unchecked] = ACTIONS(3473),
    [anon_sym_continue] = ACTIONS(3473),
    [anon_sym_do] = ACTIONS(3473),
    [anon_sym_while] = ACTIONS(3473),
    [anon_sym_for] = ACTIONS(3473),
    [anon_sym_lock] = ACTIONS(3473),
    [anon_sym_yield] = ACTIONS(3473),
    [anon_sym_switch] = ACTIONS(3473),
    [anon_sym_default] = ACTIONS(3473),
    [anon_sym_throw] = ACTIONS(3473),
    [anon_sym_try] = ACTIONS(3473),
    [anon_sym_when] = ACTIONS(3473),
    [anon_sym_await] = ACTIONS(3473),
    [anon_sym_foreach] = ACTIONS(3473),
    [anon_sym_goto] = ACTIONS(3473),
    [anon_sym_if] = ACTIONS(3473),
    [anon_sym_DOT_DOT] = ACTIONS(3475),
    [anon_sym_from] = ACTIONS(3473),
    [anon_sym_into] = ACTIONS(3473),
    [anon_sym_join] = ACTIONS(3473),
    [anon_sym_on] = ACTIONS(3473),
    [anon_sym_equals] = ACTIONS(3473),
    [anon_sym_let] = ACTIONS(3473),
    [anon_sym_orderby] = ACTIONS(3473),
    [anon_sym_ascending] = ACTIONS(3473),
    [anon_sym_descending] = ACTIONS(3473),
    [anon_sym_group] = ACTIONS(3473),
    [anon_sym_by] = ACTIONS(3473),
    [anon_sym_select] = ACTIONS(3473),
    [anon_sym_DQUOTE] = ACTIONS(3473),
    [anon_sym_stackalloc] = ACTIONS(3473),
    [anon_sym_sizeof] = ACTIONS(3473),
    [anon_sym_typeof] = ACTIONS(3473),
    [anon_sym___makeref] = ACTIONS(3473),
    [anon_sym___reftype] = ACTIONS(3473),
    [anon_sym___refvalue] = ACTIONS(3473),
    [sym_null_literal] = ACTIONS(3473),
    [anon_sym_SQUOTE] = ACTIONS(3475),
    [sym_integer_literal] = ACTIONS(3473),
    [sym_real_literal] = ACTIONS(3475),
    [sym_verbatim_string_literal] = ACTIONS(3475),
    [sym_raw_string_literal] = ACTIONS(3475),
    [aux_sym_preproc_if_token1] = ACTIONS(3475),
    [aux_sym_preproc_if_token3] = ACTIONS(3475),
    [aux_sym_preproc_else_token1] = ACTIONS(3475),
    [aux_sym_preproc_elif_token1] = ACTIONS(3475),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3475),
    [sym_interpolation_verbatim_start] = ACTIONS(3475),
    [sym_interpolation_raw_start] = ACTIONS(3475),
  },
  [2312] = {
    [sym_preproc_region] = STATE(2312),
    [sym_preproc_endregion] = STATE(2312),
    [sym_preproc_line] = STATE(2312),
    [sym_preproc_pragma] = STATE(2312),
    [sym_preproc_nullable] = STATE(2312),
    [sym_preproc_error] = STATE(2312),
    [sym_preproc_define] = STATE(2312),
    [sym_preproc_undef] = STATE(2312),
    [sym__identifier_token] = ACTIONS(3477),
    [anon_sym_extern] = ACTIONS(3477),
    [anon_sym_alias] = ACTIONS(3477),
    [anon_sym_SEMI] = ACTIONS(3479),
    [anon_sym_global] = ACTIONS(3477),
    [anon_sym_using] = ACTIONS(3477),
    [anon_sym_unsafe] = ACTIONS(3477),
    [anon_sym_static] = ACTIONS(3477),
    [anon_sym_LBRACK] = ACTIONS(3479),
    [anon_sym_LPAREN] = ACTIONS(3479),
    [anon_sym_return] = ACTIONS(3477),
    [anon_sym_namespace] = ACTIONS(3477),
    [anon_sym_class] = ACTIONS(3477),
    [anon_sym_ref] = ACTIONS(3477),
    [anon_sym_struct] = ACTIONS(3477),
    [anon_sym_enum] = ACTIONS(3477),
    [anon_sym_LBRACE] = ACTIONS(3479),
    [anon_sym_interface] = ACTIONS(3477),
    [anon_sym_delegate] = ACTIONS(3477),
    [anon_sym_record] = ACTIONS(3477),
    [anon_sym_abstract] = ACTIONS(3477),
    [anon_sym_async] = ACTIONS(3477),
    [anon_sym_const] = ACTIONS(3477),
    [anon_sym_file] = ACTIONS(3477),
    [anon_sym_fixed] = ACTIONS(3477),
    [anon_sym_internal] = ACTIONS(3477),
    [anon_sym_new] = ACTIONS(3477),
    [anon_sym_override] = ACTIONS(3477),
    [anon_sym_partial] = ACTIONS(3477),
    [anon_sym_private] = ACTIONS(3477),
    [anon_sym_protected] = ACTIONS(3477),
    [anon_sym_public] = ACTIONS(3477),
    [anon_sym_readonly] = ACTIONS(3477),
    [anon_sym_required] = ACTIONS(3477),
    [anon_sym_sealed] = ACTIONS(3477),
    [anon_sym_virtual] = ACTIONS(3477),
    [anon_sym_volatile] = ACTIONS(3477),
    [anon_sym_where] = ACTIONS(3477),
    [anon_sym_notnull] = ACTIONS(3477),
    [anon_sym_unmanaged] = ACTIONS(3477),
    [anon_sym_checked] = ACTIONS(3477),
    [anon_sym_BANG] = ACTIONS(3479),
    [anon_sym_TILDE] = ACTIONS(3479),
    [anon_sym_PLUS_PLUS] = ACTIONS(3479),
    [anon_sym_DASH_DASH] = ACTIONS(3479),
    [anon_sym_true] = ACTIONS(3477),
    [anon_sym_false] = ACTIONS(3477),
    [anon_sym_PLUS] = ACTIONS(3477),
    [anon_sym_DASH] = ACTIONS(3477),
    [anon_sym_STAR] = ACTIONS(3479),
    [anon_sym_CARET] = ACTIONS(3479),
    [anon_sym_AMP] = ACTIONS(3479),
    [anon_sym_this] = ACTIONS(3477),
    [anon_sym_scoped] = ACTIONS(3477),
    [anon_sym_var] = ACTIONS(3477),
    [sym_predefined_type] = ACTIONS(3477),
    [anon_sym_break] = ACTIONS(3477),
    [anon_sym_unchecked] = ACTIONS(3477),
    [anon_sym_continue] = ACTIONS(3477),
    [anon_sym_do] = ACTIONS(3477),
    [anon_sym_while] = ACTIONS(3477),
    [anon_sym_for] = ACTIONS(3477),
    [anon_sym_lock] = ACTIONS(3477),
    [anon_sym_yield] = ACTIONS(3477),
    [anon_sym_switch] = ACTIONS(3477),
    [anon_sym_default] = ACTIONS(3477),
    [anon_sym_throw] = ACTIONS(3477),
    [anon_sym_try] = ACTIONS(3477),
    [anon_sym_when] = ACTIONS(3477),
    [anon_sym_await] = ACTIONS(3477),
    [anon_sym_foreach] = ACTIONS(3477),
    [anon_sym_goto] = ACTIONS(3477),
    [anon_sym_if] = ACTIONS(3477),
    [anon_sym_DOT_DOT] = ACTIONS(3479),
    [anon_sym_from] = ACTIONS(3477),
    [anon_sym_into] = ACTIONS(3477),
    [anon_sym_join] = ACTIONS(3477),
    [anon_sym_on] = ACTIONS(3477),
    [anon_sym_equals] = ACTIONS(3477),
    [anon_sym_let] = ACTIONS(3477),
    [anon_sym_orderby] = ACTIONS(3477),
    [anon_sym_ascending] = ACTIONS(3477),
    [anon_sym_descending] = ACTIONS(3477),
    [anon_sym_group] = ACTIONS(3477),
    [anon_sym_by] = ACTIONS(3477),
    [anon_sym_select] = ACTIONS(3477),
    [anon_sym_DQUOTE] = ACTIONS(3477),
    [anon_sym_stackalloc] = ACTIONS(3477),
    [anon_sym_sizeof] = ACTIONS(3477),
    [anon_sym_typeof] = ACTIONS(3477),
    [anon_sym___makeref] = ACTIONS(3477),
    [anon_sym___reftype] = ACTIONS(3477),
    [anon_sym___refvalue] = ACTIONS(3477),
    [sym_null_literal] = ACTIONS(3477),
    [anon_sym_SQUOTE] = ACTIONS(3479),
    [sym_integer_literal] = ACTIONS(3477),
    [sym_real_literal] = ACTIONS(3479),
    [sym_verbatim_string_literal] = ACTIONS(3479),
    [sym_raw_string_literal] = ACTIONS(3479),
    [aux_sym_preproc_if_token1] = ACTIONS(3479),
    [aux_sym_preproc_if_token3] = ACTIONS(3479),
    [aux_sym_preproc_else_token1] = ACTIONS(3479),
    [aux_sym_preproc_elif_token1] = ACTIONS(3479),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3479),
    [sym_interpolation_verbatim_start] = ACTIONS(3479),
    [sym_interpolation_raw_start] = ACTIONS(3479),
  },
  [2313] = {
    [sym_preproc_region] = STATE(2313),
    [sym_preproc_endregion] = STATE(2313),
    [sym_preproc_line] = STATE(2313),
    [sym_preproc_pragma] = STATE(2313),
    [sym_preproc_nullable] = STATE(2313),
    [sym_preproc_error] = STATE(2313),
    [sym_preproc_define] = STATE(2313),
    [sym_preproc_undef] = STATE(2313),
    [sym__identifier_token] = ACTIONS(3481),
    [anon_sym_extern] = ACTIONS(3481),
    [anon_sym_alias] = ACTIONS(3481),
    [anon_sym_SEMI] = ACTIONS(3483),
    [anon_sym_global] = ACTIONS(3481),
    [anon_sym_using] = ACTIONS(3481),
    [anon_sym_unsafe] = ACTIONS(3481),
    [anon_sym_static] = ACTIONS(3481),
    [anon_sym_LBRACK] = ACTIONS(3483),
    [anon_sym_LPAREN] = ACTIONS(3483),
    [anon_sym_return] = ACTIONS(3481),
    [anon_sym_namespace] = ACTIONS(3481),
    [anon_sym_class] = ACTIONS(3481),
    [anon_sym_ref] = ACTIONS(3481),
    [anon_sym_struct] = ACTIONS(3481),
    [anon_sym_enum] = ACTIONS(3481),
    [anon_sym_LBRACE] = ACTIONS(3483),
    [anon_sym_interface] = ACTIONS(3481),
    [anon_sym_delegate] = ACTIONS(3481),
    [anon_sym_record] = ACTIONS(3481),
    [anon_sym_abstract] = ACTIONS(3481),
    [anon_sym_async] = ACTIONS(3481),
    [anon_sym_const] = ACTIONS(3481),
    [anon_sym_file] = ACTIONS(3481),
    [anon_sym_fixed] = ACTIONS(3481),
    [anon_sym_internal] = ACTIONS(3481),
    [anon_sym_new] = ACTIONS(3481),
    [anon_sym_override] = ACTIONS(3481),
    [anon_sym_partial] = ACTIONS(3481),
    [anon_sym_private] = ACTIONS(3481),
    [anon_sym_protected] = ACTIONS(3481),
    [anon_sym_public] = ACTIONS(3481),
    [anon_sym_readonly] = ACTIONS(3481),
    [anon_sym_required] = ACTIONS(3481),
    [anon_sym_sealed] = ACTIONS(3481),
    [anon_sym_virtual] = ACTIONS(3481),
    [anon_sym_volatile] = ACTIONS(3481),
    [anon_sym_where] = ACTIONS(3481),
    [anon_sym_notnull] = ACTIONS(3481),
    [anon_sym_unmanaged] = ACTIONS(3481),
    [anon_sym_checked] = ACTIONS(3481),
    [anon_sym_BANG] = ACTIONS(3483),
    [anon_sym_TILDE] = ACTIONS(3483),
    [anon_sym_PLUS_PLUS] = ACTIONS(3483),
    [anon_sym_DASH_DASH] = ACTIONS(3483),
    [anon_sym_true] = ACTIONS(3481),
    [anon_sym_false] = ACTIONS(3481),
    [anon_sym_PLUS] = ACTIONS(3481),
    [anon_sym_DASH] = ACTIONS(3481),
    [anon_sym_STAR] = ACTIONS(3483),
    [anon_sym_CARET] = ACTIONS(3483),
    [anon_sym_AMP] = ACTIONS(3483),
    [anon_sym_this] = ACTIONS(3481),
    [anon_sym_scoped] = ACTIONS(3481),
    [anon_sym_var] = ACTIONS(3481),
    [sym_predefined_type] = ACTIONS(3481),
    [anon_sym_break] = ACTIONS(3481),
    [anon_sym_unchecked] = ACTIONS(3481),
    [anon_sym_continue] = ACTIONS(3481),
    [anon_sym_do] = ACTIONS(3481),
    [anon_sym_while] = ACTIONS(3481),
    [anon_sym_for] = ACTIONS(3481),
    [anon_sym_lock] = ACTIONS(3481),
    [anon_sym_yield] = ACTIONS(3481),
    [anon_sym_switch] = ACTIONS(3481),
    [anon_sym_default] = ACTIONS(3481),
    [anon_sym_throw] = ACTIONS(3481),
    [anon_sym_try] = ACTIONS(3481),
    [anon_sym_when] = ACTIONS(3481),
    [anon_sym_await] = ACTIONS(3481),
    [anon_sym_foreach] = ACTIONS(3481),
    [anon_sym_goto] = ACTIONS(3481),
    [anon_sym_if] = ACTIONS(3481),
    [anon_sym_DOT_DOT] = ACTIONS(3483),
    [anon_sym_from] = ACTIONS(3481),
    [anon_sym_into] = ACTIONS(3481),
    [anon_sym_join] = ACTIONS(3481),
    [anon_sym_on] = ACTIONS(3481),
    [anon_sym_equals] = ACTIONS(3481),
    [anon_sym_let] = ACTIONS(3481),
    [anon_sym_orderby] = ACTIONS(3481),
    [anon_sym_ascending] = ACTIONS(3481),
    [anon_sym_descending] = ACTIONS(3481),
    [anon_sym_group] = ACTIONS(3481),
    [anon_sym_by] = ACTIONS(3481),
    [anon_sym_select] = ACTIONS(3481),
    [anon_sym_DQUOTE] = ACTIONS(3481),
    [anon_sym_stackalloc] = ACTIONS(3481),
    [anon_sym_sizeof] = ACTIONS(3481),
    [anon_sym_typeof] = ACTIONS(3481),
    [anon_sym___makeref] = ACTIONS(3481),
    [anon_sym___reftype] = ACTIONS(3481),
    [anon_sym___refvalue] = ACTIONS(3481),
    [sym_null_literal] = ACTIONS(3481),
    [anon_sym_SQUOTE] = ACTIONS(3483),
    [sym_integer_literal] = ACTIONS(3481),
    [sym_real_literal] = ACTIONS(3483),
    [sym_verbatim_string_literal] = ACTIONS(3483),
    [sym_raw_string_literal] = ACTIONS(3483),
    [aux_sym_preproc_if_token1] = ACTIONS(3483),
    [aux_sym_preproc_if_token3] = ACTIONS(3483),
    [aux_sym_preproc_else_token1] = ACTIONS(3483),
    [aux_sym_preproc_elif_token1] = ACTIONS(3483),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3483),
    [sym_interpolation_verbatim_start] = ACTIONS(3483),
    [sym_interpolation_raw_start] = ACTIONS(3483),
  },
  [2314] = {
    [sym_preproc_region] = STATE(2314),
    [sym_preproc_endregion] = STATE(2314),
    [sym_preproc_line] = STATE(2314),
    [sym_preproc_pragma] = STATE(2314),
    [sym_preproc_nullable] = STATE(2314),
    [sym_preproc_error] = STATE(2314),
    [sym_preproc_define] = STATE(2314),
    [sym_preproc_undef] = STATE(2314),
    [sym__identifier_token] = ACTIONS(3485),
    [anon_sym_extern] = ACTIONS(3485),
    [anon_sym_alias] = ACTIONS(3485),
    [anon_sym_SEMI] = ACTIONS(3487),
    [anon_sym_global] = ACTIONS(3485),
    [anon_sym_using] = ACTIONS(3485),
    [anon_sym_unsafe] = ACTIONS(3485),
    [anon_sym_static] = ACTIONS(3485),
    [anon_sym_LBRACK] = ACTIONS(3487),
    [anon_sym_LPAREN] = ACTIONS(3487),
    [anon_sym_return] = ACTIONS(3485),
    [anon_sym_namespace] = ACTIONS(3485),
    [anon_sym_class] = ACTIONS(3485),
    [anon_sym_ref] = ACTIONS(3485),
    [anon_sym_struct] = ACTIONS(3485),
    [anon_sym_enum] = ACTIONS(3485),
    [anon_sym_LBRACE] = ACTIONS(3487),
    [anon_sym_interface] = ACTIONS(3485),
    [anon_sym_delegate] = ACTIONS(3485),
    [anon_sym_record] = ACTIONS(3485),
    [anon_sym_abstract] = ACTIONS(3485),
    [anon_sym_async] = ACTIONS(3485),
    [anon_sym_const] = ACTIONS(3485),
    [anon_sym_file] = ACTIONS(3485),
    [anon_sym_fixed] = ACTIONS(3485),
    [anon_sym_internal] = ACTIONS(3485),
    [anon_sym_new] = ACTIONS(3485),
    [anon_sym_override] = ACTIONS(3485),
    [anon_sym_partial] = ACTIONS(3485),
    [anon_sym_private] = ACTIONS(3485),
    [anon_sym_protected] = ACTIONS(3485),
    [anon_sym_public] = ACTIONS(3485),
    [anon_sym_readonly] = ACTIONS(3485),
    [anon_sym_required] = ACTIONS(3485),
    [anon_sym_sealed] = ACTIONS(3485),
    [anon_sym_virtual] = ACTIONS(3485),
    [anon_sym_volatile] = ACTIONS(3485),
    [anon_sym_where] = ACTIONS(3485),
    [anon_sym_notnull] = ACTIONS(3485),
    [anon_sym_unmanaged] = ACTIONS(3485),
    [anon_sym_checked] = ACTIONS(3485),
    [anon_sym_BANG] = ACTIONS(3487),
    [anon_sym_TILDE] = ACTIONS(3487),
    [anon_sym_PLUS_PLUS] = ACTIONS(3487),
    [anon_sym_DASH_DASH] = ACTIONS(3487),
    [anon_sym_true] = ACTIONS(3485),
    [anon_sym_false] = ACTIONS(3485),
    [anon_sym_PLUS] = ACTIONS(3485),
    [anon_sym_DASH] = ACTIONS(3485),
    [anon_sym_STAR] = ACTIONS(3487),
    [anon_sym_CARET] = ACTIONS(3487),
    [anon_sym_AMP] = ACTIONS(3487),
    [anon_sym_this] = ACTIONS(3485),
    [anon_sym_scoped] = ACTIONS(3485),
    [anon_sym_var] = ACTIONS(3485),
    [sym_predefined_type] = ACTIONS(3485),
    [anon_sym_break] = ACTIONS(3485),
    [anon_sym_unchecked] = ACTIONS(3485),
    [anon_sym_continue] = ACTIONS(3485),
    [anon_sym_do] = ACTIONS(3485),
    [anon_sym_while] = ACTIONS(3485),
    [anon_sym_for] = ACTIONS(3485),
    [anon_sym_lock] = ACTIONS(3485),
    [anon_sym_yield] = ACTIONS(3485),
    [anon_sym_switch] = ACTIONS(3485),
    [anon_sym_default] = ACTIONS(3485),
    [anon_sym_throw] = ACTIONS(3485),
    [anon_sym_try] = ACTIONS(3485),
    [anon_sym_when] = ACTIONS(3485),
    [anon_sym_await] = ACTIONS(3485),
    [anon_sym_foreach] = ACTIONS(3485),
    [anon_sym_goto] = ACTIONS(3485),
    [anon_sym_if] = ACTIONS(3485),
    [anon_sym_DOT_DOT] = ACTIONS(3487),
    [anon_sym_from] = ACTIONS(3485),
    [anon_sym_into] = ACTIONS(3485),
    [anon_sym_join] = ACTIONS(3485),
    [anon_sym_on] = ACTIONS(3485),
    [anon_sym_equals] = ACTIONS(3485),
    [anon_sym_let] = ACTIONS(3485),
    [anon_sym_orderby] = ACTIONS(3485),
    [anon_sym_ascending] = ACTIONS(3485),
    [anon_sym_descending] = ACTIONS(3485),
    [anon_sym_group] = ACTIONS(3485),
    [anon_sym_by] = ACTIONS(3485),
    [anon_sym_select] = ACTIONS(3485),
    [anon_sym_DQUOTE] = ACTIONS(3485),
    [anon_sym_stackalloc] = ACTIONS(3485),
    [anon_sym_sizeof] = ACTIONS(3485),
    [anon_sym_typeof] = ACTIONS(3485),
    [anon_sym___makeref] = ACTIONS(3485),
    [anon_sym___reftype] = ACTIONS(3485),
    [anon_sym___refvalue] = ACTIONS(3485),
    [sym_null_literal] = ACTIONS(3485),
    [anon_sym_SQUOTE] = ACTIONS(3487),
    [sym_integer_literal] = ACTIONS(3485),
    [sym_real_literal] = ACTIONS(3487),
    [sym_verbatim_string_literal] = ACTIONS(3487),
    [sym_raw_string_literal] = ACTIONS(3487),
    [aux_sym_preproc_if_token1] = ACTIONS(3487),
    [aux_sym_preproc_if_token3] = ACTIONS(3487),
    [aux_sym_preproc_else_token1] = ACTIONS(3487),
    [aux_sym_preproc_elif_token1] = ACTIONS(3487),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3487),
    [sym_interpolation_verbatim_start] = ACTIONS(3487),
    [sym_interpolation_raw_start] = ACTIONS(3487),
  },
  [2315] = {
    [sym_preproc_region] = STATE(2315),
    [sym_preproc_endregion] = STATE(2315),
    [sym_preproc_line] = STATE(2315),
    [sym_preproc_pragma] = STATE(2315),
    [sym_preproc_nullable] = STATE(2315),
    [sym_preproc_error] = STATE(2315),
    [sym_preproc_define] = STATE(2315),
    [sym_preproc_undef] = STATE(2315),
    [sym__identifier_token] = ACTIONS(3489),
    [anon_sym_extern] = ACTIONS(3489),
    [anon_sym_alias] = ACTIONS(3489),
    [anon_sym_SEMI] = ACTIONS(3491),
    [anon_sym_global] = ACTIONS(3489),
    [anon_sym_using] = ACTIONS(3489),
    [anon_sym_unsafe] = ACTIONS(3489),
    [anon_sym_static] = ACTIONS(3489),
    [anon_sym_LBRACK] = ACTIONS(3491),
    [anon_sym_LPAREN] = ACTIONS(3491),
    [anon_sym_return] = ACTIONS(3489),
    [anon_sym_namespace] = ACTIONS(3489),
    [anon_sym_class] = ACTIONS(3489),
    [anon_sym_ref] = ACTIONS(3489),
    [anon_sym_struct] = ACTIONS(3489),
    [anon_sym_enum] = ACTIONS(3489),
    [anon_sym_LBRACE] = ACTIONS(3491),
    [anon_sym_interface] = ACTIONS(3489),
    [anon_sym_delegate] = ACTIONS(3489),
    [anon_sym_record] = ACTIONS(3489),
    [anon_sym_abstract] = ACTIONS(3489),
    [anon_sym_async] = ACTIONS(3489),
    [anon_sym_const] = ACTIONS(3489),
    [anon_sym_file] = ACTIONS(3489),
    [anon_sym_fixed] = ACTIONS(3489),
    [anon_sym_internal] = ACTIONS(3489),
    [anon_sym_new] = ACTIONS(3489),
    [anon_sym_override] = ACTIONS(3489),
    [anon_sym_partial] = ACTIONS(3489),
    [anon_sym_private] = ACTIONS(3489),
    [anon_sym_protected] = ACTIONS(3489),
    [anon_sym_public] = ACTIONS(3489),
    [anon_sym_readonly] = ACTIONS(3489),
    [anon_sym_required] = ACTIONS(3489),
    [anon_sym_sealed] = ACTIONS(3489),
    [anon_sym_virtual] = ACTIONS(3489),
    [anon_sym_volatile] = ACTIONS(3489),
    [anon_sym_where] = ACTIONS(3489),
    [anon_sym_notnull] = ACTIONS(3489),
    [anon_sym_unmanaged] = ACTIONS(3489),
    [anon_sym_checked] = ACTIONS(3489),
    [anon_sym_BANG] = ACTIONS(3491),
    [anon_sym_TILDE] = ACTIONS(3491),
    [anon_sym_PLUS_PLUS] = ACTIONS(3491),
    [anon_sym_DASH_DASH] = ACTIONS(3491),
    [anon_sym_true] = ACTIONS(3489),
    [anon_sym_false] = ACTIONS(3489),
    [anon_sym_PLUS] = ACTIONS(3489),
    [anon_sym_DASH] = ACTIONS(3489),
    [anon_sym_STAR] = ACTIONS(3491),
    [anon_sym_CARET] = ACTIONS(3491),
    [anon_sym_AMP] = ACTIONS(3491),
    [anon_sym_this] = ACTIONS(3489),
    [anon_sym_scoped] = ACTIONS(3489),
    [anon_sym_var] = ACTIONS(3489),
    [sym_predefined_type] = ACTIONS(3489),
    [anon_sym_break] = ACTIONS(3489),
    [anon_sym_unchecked] = ACTIONS(3489),
    [anon_sym_continue] = ACTIONS(3489),
    [anon_sym_do] = ACTIONS(3489),
    [anon_sym_while] = ACTIONS(3489),
    [anon_sym_for] = ACTIONS(3489),
    [anon_sym_lock] = ACTIONS(3489),
    [anon_sym_yield] = ACTIONS(3489),
    [anon_sym_switch] = ACTIONS(3489),
    [anon_sym_default] = ACTIONS(3489),
    [anon_sym_throw] = ACTIONS(3489),
    [anon_sym_try] = ACTIONS(3489),
    [anon_sym_when] = ACTIONS(3489),
    [anon_sym_await] = ACTIONS(3489),
    [anon_sym_foreach] = ACTIONS(3489),
    [anon_sym_goto] = ACTIONS(3489),
    [anon_sym_if] = ACTIONS(3489),
    [anon_sym_DOT_DOT] = ACTIONS(3491),
    [anon_sym_from] = ACTIONS(3489),
    [anon_sym_into] = ACTIONS(3489),
    [anon_sym_join] = ACTIONS(3489),
    [anon_sym_on] = ACTIONS(3489),
    [anon_sym_equals] = ACTIONS(3489),
    [anon_sym_let] = ACTIONS(3489),
    [anon_sym_orderby] = ACTIONS(3489),
    [anon_sym_ascending] = ACTIONS(3489),
    [anon_sym_descending] = ACTIONS(3489),
    [anon_sym_group] = ACTIONS(3489),
    [anon_sym_by] = ACTIONS(3489),
    [anon_sym_select] = ACTIONS(3489),
    [anon_sym_DQUOTE] = ACTIONS(3489),
    [anon_sym_stackalloc] = ACTIONS(3489),
    [anon_sym_sizeof] = ACTIONS(3489),
    [anon_sym_typeof] = ACTIONS(3489),
    [anon_sym___makeref] = ACTIONS(3489),
    [anon_sym___reftype] = ACTIONS(3489),
    [anon_sym___refvalue] = ACTIONS(3489),
    [sym_null_literal] = ACTIONS(3489),
    [anon_sym_SQUOTE] = ACTIONS(3491),
    [sym_integer_literal] = ACTIONS(3489),
    [sym_real_literal] = ACTIONS(3491),
    [sym_verbatim_string_literal] = ACTIONS(3491),
    [sym_raw_string_literal] = ACTIONS(3491),
    [aux_sym_preproc_if_token1] = ACTIONS(3491),
    [aux_sym_preproc_if_token3] = ACTIONS(3491),
    [aux_sym_preproc_else_token1] = ACTIONS(3491),
    [aux_sym_preproc_elif_token1] = ACTIONS(3491),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3491),
    [sym_interpolation_verbatim_start] = ACTIONS(3491),
    [sym_interpolation_raw_start] = ACTIONS(3491),
  },
  [2316] = {
    [sym_preproc_region] = STATE(2316),
    [sym_preproc_endregion] = STATE(2316),
    [sym_preproc_line] = STATE(2316),
    [sym_preproc_pragma] = STATE(2316),
    [sym_preproc_nullable] = STATE(2316),
    [sym_preproc_error] = STATE(2316),
    [sym_preproc_define] = STATE(2316),
    [sym_preproc_undef] = STATE(2316),
    [sym__identifier_token] = ACTIONS(3493),
    [anon_sym_extern] = ACTIONS(3493),
    [anon_sym_alias] = ACTIONS(3493),
    [anon_sym_SEMI] = ACTIONS(3495),
    [anon_sym_global] = ACTIONS(3493),
    [anon_sym_using] = ACTIONS(3493),
    [anon_sym_unsafe] = ACTIONS(3493),
    [anon_sym_static] = ACTIONS(3493),
    [anon_sym_LBRACK] = ACTIONS(3495),
    [anon_sym_LPAREN] = ACTIONS(3495),
    [anon_sym_return] = ACTIONS(3493),
    [anon_sym_namespace] = ACTIONS(3493),
    [anon_sym_class] = ACTIONS(3493),
    [anon_sym_ref] = ACTIONS(3493),
    [anon_sym_struct] = ACTIONS(3493),
    [anon_sym_enum] = ACTIONS(3493),
    [anon_sym_LBRACE] = ACTIONS(3495),
    [anon_sym_interface] = ACTIONS(3493),
    [anon_sym_delegate] = ACTIONS(3493),
    [anon_sym_record] = ACTIONS(3493),
    [anon_sym_abstract] = ACTIONS(3493),
    [anon_sym_async] = ACTIONS(3493),
    [anon_sym_const] = ACTIONS(3493),
    [anon_sym_file] = ACTIONS(3493),
    [anon_sym_fixed] = ACTIONS(3493),
    [anon_sym_internal] = ACTIONS(3493),
    [anon_sym_new] = ACTIONS(3493),
    [anon_sym_override] = ACTIONS(3493),
    [anon_sym_partial] = ACTIONS(3493),
    [anon_sym_private] = ACTIONS(3493),
    [anon_sym_protected] = ACTIONS(3493),
    [anon_sym_public] = ACTIONS(3493),
    [anon_sym_readonly] = ACTIONS(3493),
    [anon_sym_required] = ACTIONS(3493),
    [anon_sym_sealed] = ACTIONS(3493),
    [anon_sym_virtual] = ACTIONS(3493),
    [anon_sym_volatile] = ACTIONS(3493),
    [anon_sym_where] = ACTIONS(3493),
    [anon_sym_notnull] = ACTIONS(3493),
    [anon_sym_unmanaged] = ACTIONS(3493),
    [anon_sym_checked] = ACTIONS(3493),
    [anon_sym_BANG] = ACTIONS(3495),
    [anon_sym_TILDE] = ACTIONS(3495),
    [anon_sym_PLUS_PLUS] = ACTIONS(3495),
    [anon_sym_DASH_DASH] = ACTIONS(3495),
    [anon_sym_true] = ACTIONS(3493),
    [anon_sym_false] = ACTIONS(3493),
    [anon_sym_PLUS] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(3493),
    [anon_sym_STAR] = ACTIONS(3495),
    [anon_sym_CARET] = ACTIONS(3495),
    [anon_sym_AMP] = ACTIONS(3495),
    [anon_sym_this] = ACTIONS(3493),
    [anon_sym_scoped] = ACTIONS(3493),
    [anon_sym_var] = ACTIONS(3493),
    [sym_predefined_type] = ACTIONS(3493),
    [anon_sym_break] = ACTIONS(3493),
    [anon_sym_unchecked] = ACTIONS(3493),
    [anon_sym_continue] = ACTIONS(3493),
    [anon_sym_do] = ACTIONS(3493),
    [anon_sym_while] = ACTIONS(3493),
    [anon_sym_for] = ACTIONS(3493),
    [anon_sym_lock] = ACTIONS(3493),
    [anon_sym_yield] = ACTIONS(3493),
    [anon_sym_switch] = ACTIONS(3493),
    [anon_sym_default] = ACTIONS(3493),
    [anon_sym_throw] = ACTIONS(3493),
    [anon_sym_try] = ACTIONS(3493),
    [anon_sym_when] = ACTIONS(3493),
    [anon_sym_await] = ACTIONS(3493),
    [anon_sym_foreach] = ACTIONS(3493),
    [anon_sym_goto] = ACTIONS(3493),
    [anon_sym_if] = ACTIONS(3493),
    [anon_sym_DOT_DOT] = ACTIONS(3495),
    [anon_sym_from] = ACTIONS(3493),
    [anon_sym_into] = ACTIONS(3493),
    [anon_sym_join] = ACTIONS(3493),
    [anon_sym_on] = ACTIONS(3493),
    [anon_sym_equals] = ACTIONS(3493),
    [anon_sym_let] = ACTIONS(3493),
    [anon_sym_orderby] = ACTIONS(3493),
    [anon_sym_ascending] = ACTIONS(3493),
    [anon_sym_descending] = ACTIONS(3493),
    [anon_sym_group] = ACTIONS(3493),
    [anon_sym_by] = ACTIONS(3493),
    [anon_sym_select] = ACTIONS(3493),
    [anon_sym_DQUOTE] = ACTIONS(3493),
    [anon_sym_stackalloc] = ACTIONS(3493),
    [anon_sym_sizeof] = ACTIONS(3493),
    [anon_sym_typeof] = ACTIONS(3493),
    [anon_sym___makeref] = ACTIONS(3493),
    [anon_sym___reftype] = ACTIONS(3493),
    [anon_sym___refvalue] = ACTIONS(3493),
    [sym_null_literal] = ACTIONS(3493),
    [anon_sym_SQUOTE] = ACTIONS(3495),
    [sym_integer_literal] = ACTIONS(3493),
    [sym_real_literal] = ACTIONS(3495),
    [sym_verbatim_string_literal] = ACTIONS(3495),
    [sym_raw_string_literal] = ACTIONS(3495),
    [aux_sym_preproc_if_token1] = ACTIONS(3495),
    [aux_sym_preproc_if_token3] = ACTIONS(3495),
    [aux_sym_preproc_else_token1] = ACTIONS(3495),
    [aux_sym_preproc_elif_token1] = ACTIONS(3495),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3495),
    [sym_interpolation_verbatim_start] = ACTIONS(3495),
    [sym_interpolation_raw_start] = ACTIONS(3495),
  },
  [2317] = {
    [sym_preproc_region] = STATE(2317),
    [sym_preproc_endregion] = STATE(2317),
    [sym_preproc_line] = STATE(2317),
    [sym_preproc_pragma] = STATE(2317),
    [sym_preproc_nullable] = STATE(2317),
    [sym_preproc_error] = STATE(2317),
    [sym_preproc_define] = STATE(2317),
    [sym_preproc_undef] = STATE(2317),
    [sym__identifier_token] = ACTIONS(3497),
    [anon_sym_extern] = ACTIONS(3497),
    [anon_sym_alias] = ACTIONS(3497),
    [anon_sym_SEMI] = ACTIONS(3499),
    [anon_sym_global] = ACTIONS(3497),
    [anon_sym_using] = ACTIONS(3497),
    [anon_sym_unsafe] = ACTIONS(3497),
    [anon_sym_static] = ACTIONS(3497),
    [anon_sym_LBRACK] = ACTIONS(3499),
    [anon_sym_LPAREN] = ACTIONS(3499),
    [anon_sym_return] = ACTIONS(3497),
    [anon_sym_namespace] = ACTIONS(3497),
    [anon_sym_class] = ACTIONS(3497),
    [anon_sym_ref] = ACTIONS(3497),
    [anon_sym_struct] = ACTIONS(3497),
    [anon_sym_enum] = ACTIONS(3497),
    [anon_sym_LBRACE] = ACTIONS(3499),
    [anon_sym_interface] = ACTIONS(3497),
    [anon_sym_delegate] = ACTIONS(3497),
    [anon_sym_record] = ACTIONS(3497),
    [anon_sym_abstract] = ACTIONS(3497),
    [anon_sym_async] = ACTIONS(3497),
    [anon_sym_const] = ACTIONS(3497),
    [anon_sym_file] = ACTIONS(3497),
    [anon_sym_fixed] = ACTIONS(3497),
    [anon_sym_internal] = ACTIONS(3497),
    [anon_sym_new] = ACTIONS(3497),
    [anon_sym_override] = ACTIONS(3497),
    [anon_sym_partial] = ACTIONS(3497),
    [anon_sym_private] = ACTIONS(3497),
    [anon_sym_protected] = ACTIONS(3497),
    [anon_sym_public] = ACTIONS(3497),
    [anon_sym_readonly] = ACTIONS(3497),
    [anon_sym_required] = ACTIONS(3497),
    [anon_sym_sealed] = ACTIONS(3497),
    [anon_sym_virtual] = ACTIONS(3497),
    [anon_sym_volatile] = ACTIONS(3497),
    [anon_sym_where] = ACTIONS(3497),
    [anon_sym_notnull] = ACTIONS(3497),
    [anon_sym_unmanaged] = ACTIONS(3497),
    [anon_sym_checked] = ACTIONS(3497),
    [anon_sym_BANG] = ACTIONS(3499),
    [anon_sym_TILDE] = ACTIONS(3499),
    [anon_sym_PLUS_PLUS] = ACTIONS(3499),
    [anon_sym_DASH_DASH] = ACTIONS(3499),
    [anon_sym_true] = ACTIONS(3497),
    [anon_sym_false] = ACTIONS(3497),
    [anon_sym_PLUS] = ACTIONS(3497),
    [anon_sym_DASH] = ACTIONS(3497),
    [anon_sym_STAR] = ACTIONS(3499),
    [anon_sym_CARET] = ACTIONS(3499),
    [anon_sym_AMP] = ACTIONS(3499),
    [anon_sym_this] = ACTIONS(3497),
    [anon_sym_scoped] = ACTIONS(3497),
    [anon_sym_var] = ACTIONS(3497),
    [sym_predefined_type] = ACTIONS(3497),
    [anon_sym_break] = ACTIONS(3497),
    [anon_sym_unchecked] = ACTIONS(3497),
    [anon_sym_continue] = ACTIONS(3497),
    [anon_sym_do] = ACTIONS(3497),
    [anon_sym_while] = ACTIONS(3497),
    [anon_sym_for] = ACTIONS(3497),
    [anon_sym_lock] = ACTIONS(3497),
    [anon_sym_yield] = ACTIONS(3497),
    [anon_sym_switch] = ACTIONS(3497),
    [anon_sym_default] = ACTIONS(3497),
    [anon_sym_throw] = ACTIONS(3497),
    [anon_sym_try] = ACTIONS(3497),
    [anon_sym_when] = ACTIONS(3497),
    [anon_sym_await] = ACTIONS(3497),
    [anon_sym_foreach] = ACTIONS(3497),
    [anon_sym_goto] = ACTIONS(3497),
    [anon_sym_if] = ACTIONS(3497),
    [anon_sym_DOT_DOT] = ACTIONS(3499),
    [anon_sym_from] = ACTIONS(3497),
    [anon_sym_into] = ACTIONS(3497),
    [anon_sym_join] = ACTIONS(3497),
    [anon_sym_on] = ACTIONS(3497),
    [anon_sym_equals] = ACTIONS(3497),
    [anon_sym_let] = ACTIONS(3497),
    [anon_sym_orderby] = ACTIONS(3497),
    [anon_sym_ascending] = ACTIONS(3497),
    [anon_sym_descending] = ACTIONS(3497),
    [anon_sym_group] = ACTIONS(3497),
    [anon_sym_by] = ACTIONS(3497),
    [anon_sym_select] = ACTIONS(3497),
    [anon_sym_DQUOTE] = ACTIONS(3497),
    [anon_sym_stackalloc] = ACTIONS(3497),
    [anon_sym_sizeof] = ACTIONS(3497),
    [anon_sym_typeof] = ACTIONS(3497),
    [anon_sym___makeref] = ACTIONS(3497),
    [anon_sym___reftype] = ACTIONS(3497),
    [anon_sym___refvalue] = ACTIONS(3497),
    [sym_null_literal] = ACTIONS(3497),
    [anon_sym_SQUOTE] = ACTIONS(3499),
    [sym_integer_literal] = ACTIONS(3497),
    [sym_real_literal] = ACTIONS(3499),
    [sym_verbatim_string_literal] = ACTIONS(3499),
    [sym_raw_string_literal] = ACTIONS(3499),
    [aux_sym_preproc_if_token1] = ACTIONS(3499),
    [aux_sym_preproc_if_token3] = ACTIONS(3499),
    [aux_sym_preproc_else_token1] = ACTIONS(3499),
    [aux_sym_preproc_elif_token1] = ACTIONS(3499),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3499),
    [sym_interpolation_verbatim_start] = ACTIONS(3499),
    [sym_interpolation_raw_start] = ACTIONS(3499),
  },
  [2318] = {
    [sym_preproc_region] = STATE(2318),
    [sym_preproc_endregion] = STATE(2318),
    [sym_preproc_line] = STATE(2318),
    [sym_preproc_pragma] = STATE(2318),
    [sym_preproc_nullable] = STATE(2318),
    [sym_preproc_error] = STATE(2318),
    [sym_preproc_define] = STATE(2318),
    [sym_preproc_undef] = STATE(2318),
    [sym__identifier_token] = ACTIONS(3501),
    [anon_sym_extern] = ACTIONS(3501),
    [anon_sym_alias] = ACTIONS(3501),
    [anon_sym_SEMI] = ACTIONS(3503),
    [anon_sym_global] = ACTIONS(3501),
    [anon_sym_using] = ACTIONS(3501),
    [anon_sym_unsafe] = ACTIONS(3501),
    [anon_sym_static] = ACTIONS(3501),
    [anon_sym_LBRACK] = ACTIONS(3503),
    [anon_sym_LPAREN] = ACTIONS(3503),
    [anon_sym_return] = ACTIONS(3501),
    [anon_sym_namespace] = ACTIONS(3501),
    [anon_sym_class] = ACTIONS(3501),
    [anon_sym_ref] = ACTIONS(3501),
    [anon_sym_struct] = ACTIONS(3501),
    [anon_sym_enum] = ACTIONS(3501),
    [anon_sym_LBRACE] = ACTIONS(3503),
    [anon_sym_interface] = ACTIONS(3501),
    [anon_sym_delegate] = ACTIONS(3501),
    [anon_sym_record] = ACTIONS(3501),
    [anon_sym_abstract] = ACTIONS(3501),
    [anon_sym_async] = ACTIONS(3501),
    [anon_sym_const] = ACTIONS(3501),
    [anon_sym_file] = ACTIONS(3501),
    [anon_sym_fixed] = ACTIONS(3501),
    [anon_sym_internal] = ACTIONS(3501),
    [anon_sym_new] = ACTIONS(3501),
    [anon_sym_override] = ACTIONS(3501),
    [anon_sym_partial] = ACTIONS(3501),
    [anon_sym_private] = ACTIONS(3501),
    [anon_sym_protected] = ACTIONS(3501),
    [anon_sym_public] = ACTIONS(3501),
    [anon_sym_readonly] = ACTIONS(3501),
    [anon_sym_required] = ACTIONS(3501),
    [anon_sym_sealed] = ACTIONS(3501),
    [anon_sym_virtual] = ACTIONS(3501),
    [anon_sym_volatile] = ACTIONS(3501),
    [anon_sym_where] = ACTIONS(3501),
    [anon_sym_notnull] = ACTIONS(3501),
    [anon_sym_unmanaged] = ACTIONS(3501),
    [anon_sym_checked] = ACTIONS(3501),
    [anon_sym_BANG] = ACTIONS(3503),
    [anon_sym_TILDE] = ACTIONS(3503),
    [anon_sym_PLUS_PLUS] = ACTIONS(3503),
    [anon_sym_DASH_DASH] = ACTIONS(3503),
    [anon_sym_true] = ACTIONS(3501),
    [anon_sym_false] = ACTIONS(3501),
    [anon_sym_PLUS] = ACTIONS(3501),
    [anon_sym_DASH] = ACTIONS(3501),
    [anon_sym_STAR] = ACTIONS(3503),
    [anon_sym_CARET] = ACTIONS(3503),
    [anon_sym_AMP] = ACTIONS(3503),
    [anon_sym_this] = ACTIONS(3501),
    [anon_sym_scoped] = ACTIONS(3501),
    [anon_sym_var] = ACTIONS(3501),
    [sym_predefined_type] = ACTIONS(3501),
    [anon_sym_break] = ACTIONS(3501),
    [anon_sym_unchecked] = ACTIONS(3501),
    [anon_sym_continue] = ACTIONS(3501),
    [anon_sym_do] = ACTIONS(3501),
    [anon_sym_while] = ACTIONS(3501),
    [anon_sym_for] = ACTIONS(3501),
    [anon_sym_lock] = ACTIONS(3501),
    [anon_sym_yield] = ACTIONS(3501),
    [anon_sym_switch] = ACTIONS(3501),
    [anon_sym_default] = ACTIONS(3501),
    [anon_sym_throw] = ACTIONS(3501),
    [anon_sym_try] = ACTIONS(3501),
    [anon_sym_when] = ACTIONS(3501),
    [anon_sym_await] = ACTIONS(3501),
    [anon_sym_foreach] = ACTIONS(3501),
    [anon_sym_goto] = ACTIONS(3501),
    [anon_sym_if] = ACTIONS(3501),
    [anon_sym_DOT_DOT] = ACTIONS(3503),
    [anon_sym_from] = ACTIONS(3501),
    [anon_sym_into] = ACTIONS(3501),
    [anon_sym_join] = ACTIONS(3501),
    [anon_sym_on] = ACTIONS(3501),
    [anon_sym_equals] = ACTIONS(3501),
    [anon_sym_let] = ACTIONS(3501),
    [anon_sym_orderby] = ACTIONS(3501),
    [anon_sym_ascending] = ACTIONS(3501),
    [anon_sym_descending] = ACTIONS(3501),
    [anon_sym_group] = ACTIONS(3501),
    [anon_sym_by] = ACTIONS(3501),
    [anon_sym_select] = ACTIONS(3501),
    [anon_sym_DQUOTE] = ACTIONS(3501),
    [anon_sym_stackalloc] = ACTIONS(3501),
    [anon_sym_sizeof] = ACTIONS(3501),
    [anon_sym_typeof] = ACTIONS(3501),
    [anon_sym___makeref] = ACTIONS(3501),
    [anon_sym___reftype] = ACTIONS(3501),
    [anon_sym___refvalue] = ACTIONS(3501),
    [sym_null_literal] = ACTIONS(3501),
    [anon_sym_SQUOTE] = ACTIONS(3503),
    [sym_integer_literal] = ACTIONS(3501),
    [sym_real_literal] = ACTIONS(3503),
    [sym_verbatim_string_literal] = ACTIONS(3503),
    [sym_raw_string_literal] = ACTIONS(3503),
    [aux_sym_preproc_if_token1] = ACTIONS(3503),
    [aux_sym_preproc_if_token3] = ACTIONS(3503),
    [aux_sym_preproc_else_token1] = ACTIONS(3503),
    [aux_sym_preproc_elif_token1] = ACTIONS(3503),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3503),
    [sym_interpolation_verbatim_start] = ACTIONS(3503),
    [sym_interpolation_raw_start] = ACTIONS(3503),
  },
  [2319] = {
    [sym_preproc_region] = STATE(2319),
    [sym_preproc_endregion] = STATE(2319),
    [sym_preproc_line] = STATE(2319),
    [sym_preproc_pragma] = STATE(2319),
    [sym_preproc_nullable] = STATE(2319),
    [sym_preproc_error] = STATE(2319),
    [sym_preproc_define] = STATE(2319),
    [sym_preproc_undef] = STATE(2319),
    [sym__identifier_token] = ACTIONS(3505),
    [anon_sym_extern] = ACTIONS(3505),
    [anon_sym_alias] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(3507),
    [anon_sym_global] = ACTIONS(3505),
    [anon_sym_using] = ACTIONS(3505),
    [anon_sym_unsafe] = ACTIONS(3505),
    [anon_sym_static] = ACTIONS(3505),
    [anon_sym_LBRACK] = ACTIONS(3507),
    [anon_sym_LPAREN] = ACTIONS(3507),
    [anon_sym_return] = ACTIONS(3505),
    [anon_sym_namespace] = ACTIONS(3505),
    [anon_sym_class] = ACTIONS(3505),
    [anon_sym_ref] = ACTIONS(3505),
    [anon_sym_struct] = ACTIONS(3505),
    [anon_sym_enum] = ACTIONS(3505),
    [anon_sym_LBRACE] = ACTIONS(3507),
    [anon_sym_interface] = ACTIONS(3505),
    [anon_sym_delegate] = ACTIONS(3505),
    [anon_sym_record] = ACTIONS(3505),
    [anon_sym_abstract] = ACTIONS(3505),
    [anon_sym_async] = ACTIONS(3505),
    [anon_sym_const] = ACTIONS(3505),
    [anon_sym_file] = ACTIONS(3505),
    [anon_sym_fixed] = ACTIONS(3505),
    [anon_sym_internal] = ACTIONS(3505),
    [anon_sym_new] = ACTIONS(3505),
    [anon_sym_override] = ACTIONS(3505),
    [anon_sym_partial] = ACTIONS(3505),
    [anon_sym_private] = ACTIONS(3505),
    [anon_sym_protected] = ACTIONS(3505),
    [anon_sym_public] = ACTIONS(3505),
    [anon_sym_readonly] = ACTIONS(3505),
    [anon_sym_required] = ACTIONS(3505),
    [anon_sym_sealed] = ACTIONS(3505),
    [anon_sym_virtual] = ACTIONS(3505),
    [anon_sym_volatile] = ACTIONS(3505),
    [anon_sym_where] = ACTIONS(3505),
    [anon_sym_notnull] = ACTIONS(3505),
    [anon_sym_unmanaged] = ACTIONS(3505),
    [anon_sym_checked] = ACTIONS(3505),
    [anon_sym_BANG] = ACTIONS(3507),
    [anon_sym_TILDE] = ACTIONS(3507),
    [anon_sym_PLUS_PLUS] = ACTIONS(3507),
    [anon_sym_DASH_DASH] = ACTIONS(3507),
    [anon_sym_true] = ACTIONS(3505),
    [anon_sym_false] = ACTIONS(3505),
    [anon_sym_PLUS] = ACTIONS(3505),
    [anon_sym_DASH] = ACTIONS(3505),
    [anon_sym_STAR] = ACTIONS(3507),
    [anon_sym_CARET] = ACTIONS(3507),
    [anon_sym_AMP] = ACTIONS(3507),
    [anon_sym_this] = ACTIONS(3505),
    [anon_sym_scoped] = ACTIONS(3505),
    [anon_sym_var] = ACTIONS(3505),
    [sym_predefined_type] = ACTIONS(3505),
    [anon_sym_break] = ACTIONS(3505),
    [anon_sym_unchecked] = ACTIONS(3505),
    [anon_sym_continue] = ACTIONS(3505),
    [anon_sym_do] = ACTIONS(3505),
    [anon_sym_while] = ACTIONS(3505),
    [anon_sym_for] = ACTIONS(3505),
    [anon_sym_lock] = ACTIONS(3505),
    [anon_sym_yield] = ACTIONS(3505),
    [anon_sym_switch] = ACTIONS(3505),
    [anon_sym_default] = ACTIONS(3505),
    [anon_sym_throw] = ACTIONS(3505),
    [anon_sym_try] = ACTIONS(3505),
    [anon_sym_when] = ACTIONS(3505),
    [anon_sym_await] = ACTIONS(3505),
    [anon_sym_foreach] = ACTIONS(3505),
    [anon_sym_goto] = ACTIONS(3505),
    [anon_sym_if] = ACTIONS(3505),
    [anon_sym_DOT_DOT] = ACTIONS(3507),
    [anon_sym_from] = ACTIONS(3505),
    [anon_sym_into] = ACTIONS(3505),
    [anon_sym_join] = ACTIONS(3505),
    [anon_sym_on] = ACTIONS(3505),
    [anon_sym_equals] = ACTIONS(3505),
    [anon_sym_let] = ACTIONS(3505),
    [anon_sym_orderby] = ACTIONS(3505),
    [anon_sym_ascending] = ACTIONS(3505),
    [anon_sym_descending] = ACTIONS(3505),
    [anon_sym_group] = ACTIONS(3505),
    [anon_sym_by] = ACTIONS(3505),
    [anon_sym_select] = ACTIONS(3505),
    [anon_sym_DQUOTE] = ACTIONS(3505),
    [anon_sym_stackalloc] = ACTIONS(3505),
    [anon_sym_sizeof] = ACTIONS(3505),
    [anon_sym_typeof] = ACTIONS(3505),
    [anon_sym___makeref] = ACTIONS(3505),
    [anon_sym___reftype] = ACTIONS(3505),
    [anon_sym___refvalue] = ACTIONS(3505),
    [sym_null_literal] = ACTIONS(3505),
    [anon_sym_SQUOTE] = ACTIONS(3507),
    [sym_integer_literal] = ACTIONS(3505),
    [sym_real_literal] = ACTIONS(3507),
    [sym_verbatim_string_literal] = ACTIONS(3507),
    [sym_raw_string_literal] = ACTIONS(3507),
    [aux_sym_preproc_if_token1] = ACTIONS(3507),
    [aux_sym_preproc_if_token3] = ACTIONS(3507),
    [aux_sym_preproc_else_token1] = ACTIONS(3507),
    [aux_sym_preproc_elif_token1] = ACTIONS(3507),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3507),
    [sym_interpolation_verbatim_start] = ACTIONS(3507),
    [sym_interpolation_raw_start] = ACTIONS(3507),
  },
  [2320] = {
    [sym_preproc_region] = STATE(2320),
    [sym_preproc_endregion] = STATE(2320),
    [sym_preproc_line] = STATE(2320),
    [sym_preproc_pragma] = STATE(2320),
    [sym_preproc_nullable] = STATE(2320),
    [sym_preproc_error] = STATE(2320),
    [sym_preproc_define] = STATE(2320),
    [sym_preproc_undef] = STATE(2320),
    [sym__identifier_token] = ACTIONS(3509),
    [anon_sym_extern] = ACTIONS(3509),
    [anon_sym_alias] = ACTIONS(3509),
    [anon_sym_SEMI] = ACTIONS(3511),
    [anon_sym_global] = ACTIONS(3509),
    [anon_sym_using] = ACTIONS(3509),
    [anon_sym_unsafe] = ACTIONS(3509),
    [anon_sym_static] = ACTIONS(3509),
    [anon_sym_LBRACK] = ACTIONS(3511),
    [anon_sym_LPAREN] = ACTIONS(3511),
    [anon_sym_return] = ACTIONS(3509),
    [anon_sym_namespace] = ACTIONS(3509),
    [anon_sym_class] = ACTIONS(3509),
    [anon_sym_ref] = ACTIONS(3509),
    [anon_sym_struct] = ACTIONS(3509),
    [anon_sym_enum] = ACTIONS(3509),
    [anon_sym_LBRACE] = ACTIONS(3511),
    [anon_sym_interface] = ACTIONS(3509),
    [anon_sym_delegate] = ACTIONS(3509),
    [anon_sym_record] = ACTIONS(3509),
    [anon_sym_abstract] = ACTIONS(3509),
    [anon_sym_async] = ACTIONS(3509),
    [anon_sym_const] = ACTIONS(3509),
    [anon_sym_file] = ACTIONS(3509),
    [anon_sym_fixed] = ACTIONS(3509),
    [anon_sym_internal] = ACTIONS(3509),
    [anon_sym_new] = ACTIONS(3509),
    [anon_sym_override] = ACTIONS(3509),
    [anon_sym_partial] = ACTIONS(3509),
    [anon_sym_private] = ACTIONS(3509),
    [anon_sym_protected] = ACTIONS(3509),
    [anon_sym_public] = ACTIONS(3509),
    [anon_sym_readonly] = ACTIONS(3509),
    [anon_sym_required] = ACTIONS(3509),
    [anon_sym_sealed] = ACTIONS(3509),
    [anon_sym_virtual] = ACTIONS(3509),
    [anon_sym_volatile] = ACTIONS(3509),
    [anon_sym_where] = ACTIONS(3509),
    [anon_sym_notnull] = ACTIONS(3509),
    [anon_sym_unmanaged] = ACTIONS(3509),
    [anon_sym_checked] = ACTIONS(3509),
    [anon_sym_BANG] = ACTIONS(3511),
    [anon_sym_TILDE] = ACTIONS(3511),
    [anon_sym_PLUS_PLUS] = ACTIONS(3511),
    [anon_sym_DASH_DASH] = ACTIONS(3511),
    [anon_sym_true] = ACTIONS(3509),
    [anon_sym_false] = ACTIONS(3509),
    [anon_sym_PLUS] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3509),
    [anon_sym_STAR] = ACTIONS(3511),
    [anon_sym_CARET] = ACTIONS(3511),
    [anon_sym_AMP] = ACTIONS(3511),
    [anon_sym_this] = ACTIONS(3509),
    [anon_sym_scoped] = ACTIONS(3509),
    [anon_sym_var] = ACTIONS(3509),
    [sym_predefined_type] = ACTIONS(3509),
    [anon_sym_break] = ACTIONS(3509),
    [anon_sym_unchecked] = ACTIONS(3509),
    [anon_sym_continue] = ACTIONS(3509),
    [anon_sym_do] = ACTIONS(3509),
    [anon_sym_while] = ACTIONS(3509),
    [anon_sym_for] = ACTIONS(3509),
    [anon_sym_lock] = ACTIONS(3509),
    [anon_sym_yield] = ACTIONS(3509),
    [anon_sym_switch] = ACTIONS(3509),
    [anon_sym_default] = ACTIONS(3509),
    [anon_sym_throw] = ACTIONS(3509),
    [anon_sym_try] = ACTIONS(3509),
    [anon_sym_when] = ACTIONS(3509),
    [anon_sym_await] = ACTIONS(3509),
    [anon_sym_foreach] = ACTIONS(3509),
    [anon_sym_goto] = ACTIONS(3509),
    [anon_sym_if] = ACTIONS(3509),
    [anon_sym_DOT_DOT] = ACTIONS(3511),
    [anon_sym_from] = ACTIONS(3509),
    [anon_sym_into] = ACTIONS(3509),
    [anon_sym_join] = ACTIONS(3509),
    [anon_sym_on] = ACTIONS(3509),
    [anon_sym_equals] = ACTIONS(3509),
    [anon_sym_let] = ACTIONS(3509),
    [anon_sym_orderby] = ACTIONS(3509),
    [anon_sym_ascending] = ACTIONS(3509),
    [anon_sym_descending] = ACTIONS(3509),
    [anon_sym_group] = ACTIONS(3509),
    [anon_sym_by] = ACTIONS(3509),
    [anon_sym_select] = ACTIONS(3509),
    [anon_sym_DQUOTE] = ACTIONS(3509),
    [anon_sym_stackalloc] = ACTIONS(3509),
    [anon_sym_sizeof] = ACTIONS(3509),
    [anon_sym_typeof] = ACTIONS(3509),
    [anon_sym___makeref] = ACTIONS(3509),
    [anon_sym___reftype] = ACTIONS(3509),
    [anon_sym___refvalue] = ACTIONS(3509),
    [sym_null_literal] = ACTIONS(3509),
    [anon_sym_SQUOTE] = ACTIONS(3511),
    [sym_integer_literal] = ACTIONS(3509),
    [sym_real_literal] = ACTIONS(3511),
    [sym_verbatim_string_literal] = ACTIONS(3511),
    [sym_raw_string_literal] = ACTIONS(3511),
    [aux_sym_preproc_if_token1] = ACTIONS(3511),
    [aux_sym_preproc_if_token3] = ACTIONS(3511),
    [aux_sym_preproc_else_token1] = ACTIONS(3511),
    [aux_sym_preproc_elif_token1] = ACTIONS(3511),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3511),
    [sym_interpolation_verbatim_start] = ACTIONS(3511),
    [sym_interpolation_raw_start] = ACTIONS(3511),
  },
  [2321] = {
    [sym_preproc_region] = STATE(2321),
    [sym_preproc_endregion] = STATE(2321),
    [sym_preproc_line] = STATE(2321),
    [sym_preproc_pragma] = STATE(2321),
    [sym_preproc_nullable] = STATE(2321),
    [sym_preproc_error] = STATE(2321),
    [sym_preproc_define] = STATE(2321),
    [sym_preproc_undef] = STATE(2321),
    [sym__identifier_token] = ACTIONS(3513),
    [anon_sym_extern] = ACTIONS(3513),
    [anon_sym_alias] = ACTIONS(3513),
    [anon_sym_SEMI] = ACTIONS(3515),
    [anon_sym_global] = ACTIONS(3513),
    [anon_sym_using] = ACTIONS(3513),
    [anon_sym_unsafe] = ACTIONS(3513),
    [anon_sym_static] = ACTIONS(3513),
    [anon_sym_LBRACK] = ACTIONS(3515),
    [anon_sym_LPAREN] = ACTIONS(3515),
    [anon_sym_return] = ACTIONS(3513),
    [anon_sym_namespace] = ACTIONS(3513),
    [anon_sym_class] = ACTIONS(3513),
    [anon_sym_ref] = ACTIONS(3513),
    [anon_sym_struct] = ACTIONS(3513),
    [anon_sym_enum] = ACTIONS(3513),
    [anon_sym_LBRACE] = ACTIONS(3515),
    [anon_sym_interface] = ACTIONS(3513),
    [anon_sym_delegate] = ACTIONS(3513),
    [anon_sym_record] = ACTIONS(3513),
    [anon_sym_abstract] = ACTIONS(3513),
    [anon_sym_async] = ACTIONS(3513),
    [anon_sym_const] = ACTIONS(3513),
    [anon_sym_file] = ACTIONS(3513),
    [anon_sym_fixed] = ACTIONS(3513),
    [anon_sym_internal] = ACTIONS(3513),
    [anon_sym_new] = ACTIONS(3513),
    [anon_sym_override] = ACTIONS(3513),
    [anon_sym_partial] = ACTIONS(3513),
    [anon_sym_private] = ACTIONS(3513),
    [anon_sym_protected] = ACTIONS(3513),
    [anon_sym_public] = ACTIONS(3513),
    [anon_sym_readonly] = ACTIONS(3513),
    [anon_sym_required] = ACTIONS(3513),
    [anon_sym_sealed] = ACTIONS(3513),
    [anon_sym_virtual] = ACTIONS(3513),
    [anon_sym_volatile] = ACTIONS(3513),
    [anon_sym_where] = ACTIONS(3513),
    [anon_sym_notnull] = ACTIONS(3513),
    [anon_sym_unmanaged] = ACTIONS(3513),
    [anon_sym_checked] = ACTIONS(3513),
    [anon_sym_BANG] = ACTIONS(3515),
    [anon_sym_TILDE] = ACTIONS(3515),
    [anon_sym_PLUS_PLUS] = ACTIONS(3515),
    [anon_sym_DASH_DASH] = ACTIONS(3515),
    [anon_sym_true] = ACTIONS(3513),
    [anon_sym_false] = ACTIONS(3513),
    [anon_sym_PLUS] = ACTIONS(3513),
    [anon_sym_DASH] = ACTIONS(3513),
    [anon_sym_STAR] = ACTIONS(3515),
    [anon_sym_CARET] = ACTIONS(3515),
    [anon_sym_AMP] = ACTIONS(3515),
    [anon_sym_this] = ACTIONS(3513),
    [anon_sym_scoped] = ACTIONS(3513),
    [anon_sym_var] = ACTIONS(3513),
    [sym_predefined_type] = ACTIONS(3513),
    [anon_sym_break] = ACTIONS(3513),
    [anon_sym_unchecked] = ACTIONS(3513),
    [anon_sym_continue] = ACTIONS(3513),
    [anon_sym_do] = ACTIONS(3513),
    [anon_sym_while] = ACTIONS(3513),
    [anon_sym_for] = ACTIONS(3513),
    [anon_sym_lock] = ACTIONS(3513),
    [anon_sym_yield] = ACTIONS(3513),
    [anon_sym_switch] = ACTIONS(3513),
    [anon_sym_default] = ACTIONS(3513),
    [anon_sym_throw] = ACTIONS(3513),
    [anon_sym_try] = ACTIONS(3513),
    [anon_sym_when] = ACTIONS(3513),
    [anon_sym_await] = ACTIONS(3513),
    [anon_sym_foreach] = ACTIONS(3513),
    [anon_sym_goto] = ACTIONS(3513),
    [anon_sym_if] = ACTIONS(3513),
    [anon_sym_DOT_DOT] = ACTIONS(3515),
    [anon_sym_from] = ACTIONS(3513),
    [anon_sym_into] = ACTIONS(3513),
    [anon_sym_join] = ACTIONS(3513),
    [anon_sym_on] = ACTIONS(3513),
    [anon_sym_equals] = ACTIONS(3513),
    [anon_sym_let] = ACTIONS(3513),
    [anon_sym_orderby] = ACTIONS(3513),
    [anon_sym_ascending] = ACTIONS(3513),
    [anon_sym_descending] = ACTIONS(3513),
    [anon_sym_group] = ACTIONS(3513),
    [anon_sym_by] = ACTIONS(3513),
    [anon_sym_select] = ACTIONS(3513),
    [anon_sym_DQUOTE] = ACTIONS(3513),
    [anon_sym_stackalloc] = ACTIONS(3513),
    [anon_sym_sizeof] = ACTIONS(3513),
    [anon_sym_typeof] = ACTIONS(3513),
    [anon_sym___makeref] = ACTIONS(3513),
    [anon_sym___reftype] = ACTIONS(3513),
    [anon_sym___refvalue] = ACTIONS(3513),
    [sym_null_literal] = ACTIONS(3513),
    [anon_sym_SQUOTE] = ACTIONS(3515),
    [sym_integer_literal] = ACTIONS(3513),
    [sym_real_literal] = ACTIONS(3515),
    [sym_verbatim_string_literal] = ACTIONS(3515),
    [sym_raw_string_literal] = ACTIONS(3515),
    [aux_sym_preproc_if_token1] = ACTIONS(3515),
    [aux_sym_preproc_if_token3] = ACTIONS(3515),
    [aux_sym_preproc_else_token1] = ACTIONS(3515),
    [aux_sym_preproc_elif_token1] = ACTIONS(3515),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3515),
    [sym_interpolation_verbatim_start] = ACTIONS(3515),
    [sym_interpolation_raw_start] = ACTIONS(3515),
  },
  [2322] = {
    [sym_preproc_region] = STATE(2322),
    [sym_preproc_endregion] = STATE(2322),
    [sym_preproc_line] = STATE(2322),
    [sym_preproc_pragma] = STATE(2322),
    [sym_preproc_nullable] = STATE(2322),
    [sym_preproc_error] = STATE(2322),
    [sym_preproc_define] = STATE(2322),
    [sym_preproc_undef] = STATE(2322),
    [sym__identifier_token] = ACTIONS(3517),
    [anon_sym_extern] = ACTIONS(3517),
    [anon_sym_alias] = ACTIONS(3517),
    [anon_sym_SEMI] = ACTIONS(3519),
    [anon_sym_global] = ACTIONS(3517),
    [anon_sym_using] = ACTIONS(3517),
    [anon_sym_unsafe] = ACTIONS(3517),
    [anon_sym_static] = ACTIONS(3517),
    [anon_sym_LBRACK] = ACTIONS(3519),
    [anon_sym_LPAREN] = ACTIONS(3519),
    [anon_sym_return] = ACTIONS(3517),
    [anon_sym_namespace] = ACTIONS(3517),
    [anon_sym_class] = ACTIONS(3517),
    [anon_sym_ref] = ACTIONS(3517),
    [anon_sym_struct] = ACTIONS(3517),
    [anon_sym_enum] = ACTIONS(3517),
    [anon_sym_LBRACE] = ACTIONS(3519),
    [anon_sym_interface] = ACTIONS(3517),
    [anon_sym_delegate] = ACTIONS(3517),
    [anon_sym_record] = ACTIONS(3517),
    [anon_sym_abstract] = ACTIONS(3517),
    [anon_sym_async] = ACTIONS(3517),
    [anon_sym_const] = ACTIONS(3517),
    [anon_sym_file] = ACTIONS(3517),
    [anon_sym_fixed] = ACTIONS(3517),
    [anon_sym_internal] = ACTIONS(3517),
    [anon_sym_new] = ACTIONS(3517),
    [anon_sym_override] = ACTIONS(3517),
    [anon_sym_partial] = ACTIONS(3517),
    [anon_sym_private] = ACTIONS(3517),
    [anon_sym_protected] = ACTIONS(3517),
    [anon_sym_public] = ACTIONS(3517),
    [anon_sym_readonly] = ACTIONS(3517),
    [anon_sym_required] = ACTIONS(3517),
    [anon_sym_sealed] = ACTIONS(3517),
    [anon_sym_virtual] = ACTIONS(3517),
    [anon_sym_volatile] = ACTIONS(3517),
    [anon_sym_where] = ACTIONS(3517),
    [anon_sym_notnull] = ACTIONS(3517),
    [anon_sym_unmanaged] = ACTIONS(3517),
    [anon_sym_checked] = ACTIONS(3517),
    [anon_sym_BANG] = ACTIONS(3519),
    [anon_sym_TILDE] = ACTIONS(3519),
    [anon_sym_PLUS_PLUS] = ACTIONS(3519),
    [anon_sym_DASH_DASH] = ACTIONS(3519),
    [anon_sym_true] = ACTIONS(3517),
    [anon_sym_false] = ACTIONS(3517),
    [anon_sym_PLUS] = ACTIONS(3517),
    [anon_sym_DASH] = ACTIONS(3517),
    [anon_sym_STAR] = ACTIONS(3519),
    [anon_sym_CARET] = ACTIONS(3519),
    [anon_sym_AMP] = ACTIONS(3519),
    [anon_sym_this] = ACTIONS(3517),
    [anon_sym_scoped] = ACTIONS(3517),
    [anon_sym_var] = ACTIONS(3517),
    [sym_predefined_type] = ACTIONS(3517),
    [anon_sym_break] = ACTIONS(3517),
    [anon_sym_unchecked] = ACTIONS(3517),
    [anon_sym_continue] = ACTIONS(3517),
    [anon_sym_do] = ACTIONS(3517),
    [anon_sym_while] = ACTIONS(3517),
    [anon_sym_for] = ACTIONS(3517),
    [anon_sym_lock] = ACTIONS(3517),
    [anon_sym_yield] = ACTIONS(3517),
    [anon_sym_switch] = ACTIONS(3517),
    [anon_sym_default] = ACTIONS(3517),
    [anon_sym_throw] = ACTIONS(3517),
    [anon_sym_try] = ACTIONS(3517),
    [anon_sym_when] = ACTIONS(3517),
    [anon_sym_await] = ACTIONS(3517),
    [anon_sym_foreach] = ACTIONS(3517),
    [anon_sym_goto] = ACTIONS(3517),
    [anon_sym_if] = ACTIONS(3517),
    [anon_sym_DOT_DOT] = ACTIONS(3519),
    [anon_sym_from] = ACTIONS(3517),
    [anon_sym_into] = ACTIONS(3517),
    [anon_sym_join] = ACTIONS(3517),
    [anon_sym_on] = ACTIONS(3517),
    [anon_sym_equals] = ACTIONS(3517),
    [anon_sym_let] = ACTIONS(3517),
    [anon_sym_orderby] = ACTIONS(3517),
    [anon_sym_ascending] = ACTIONS(3517),
    [anon_sym_descending] = ACTIONS(3517),
    [anon_sym_group] = ACTIONS(3517),
    [anon_sym_by] = ACTIONS(3517),
    [anon_sym_select] = ACTIONS(3517),
    [anon_sym_DQUOTE] = ACTIONS(3517),
    [anon_sym_stackalloc] = ACTIONS(3517),
    [anon_sym_sizeof] = ACTIONS(3517),
    [anon_sym_typeof] = ACTIONS(3517),
    [anon_sym___makeref] = ACTIONS(3517),
    [anon_sym___reftype] = ACTIONS(3517),
    [anon_sym___refvalue] = ACTIONS(3517),
    [sym_null_literal] = ACTIONS(3517),
    [anon_sym_SQUOTE] = ACTIONS(3519),
    [sym_integer_literal] = ACTIONS(3517),
    [sym_real_literal] = ACTIONS(3519),
    [sym_verbatim_string_literal] = ACTIONS(3519),
    [sym_raw_string_literal] = ACTIONS(3519),
    [aux_sym_preproc_if_token1] = ACTIONS(3519),
    [aux_sym_preproc_if_token3] = ACTIONS(3519),
    [aux_sym_preproc_else_token1] = ACTIONS(3519),
    [aux_sym_preproc_elif_token1] = ACTIONS(3519),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3519),
    [sym_interpolation_verbatim_start] = ACTIONS(3519),
    [sym_interpolation_raw_start] = ACTIONS(3519),
  },
  [2323] = {
    [sym_preproc_region] = STATE(2323),
    [sym_preproc_endregion] = STATE(2323),
    [sym_preproc_line] = STATE(2323),
    [sym_preproc_pragma] = STATE(2323),
    [sym_preproc_nullable] = STATE(2323),
    [sym_preproc_error] = STATE(2323),
    [sym_preproc_define] = STATE(2323),
    [sym_preproc_undef] = STATE(2323),
    [sym__identifier_token] = ACTIONS(3521),
    [anon_sym_extern] = ACTIONS(3521),
    [anon_sym_alias] = ACTIONS(3521),
    [anon_sym_SEMI] = ACTIONS(3523),
    [anon_sym_global] = ACTIONS(3521),
    [anon_sym_using] = ACTIONS(3521),
    [anon_sym_unsafe] = ACTIONS(3521),
    [anon_sym_static] = ACTIONS(3521),
    [anon_sym_LBRACK] = ACTIONS(3523),
    [anon_sym_LPAREN] = ACTIONS(3523),
    [anon_sym_return] = ACTIONS(3521),
    [anon_sym_namespace] = ACTIONS(3521),
    [anon_sym_class] = ACTIONS(3521),
    [anon_sym_ref] = ACTIONS(3521),
    [anon_sym_struct] = ACTIONS(3521),
    [anon_sym_enum] = ACTIONS(3521),
    [anon_sym_LBRACE] = ACTIONS(3523),
    [anon_sym_interface] = ACTIONS(3521),
    [anon_sym_delegate] = ACTIONS(3521),
    [anon_sym_record] = ACTIONS(3521),
    [anon_sym_abstract] = ACTIONS(3521),
    [anon_sym_async] = ACTIONS(3521),
    [anon_sym_const] = ACTIONS(3521),
    [anon_sym_file] = ACTIONS(3521),
    [anon_sym_fixed] = ACTIONS(3521),
    [anon_sym_internal] = ACTIONS(3521),
    [anon_sym_new] = ACTIONS(3521),
    [anon_sym_override] = ACTIONS(3521),
    [anon_sym_partial] = ACTIONS(3521),
    [anon_sym_private] = ACTIONS(3521),
    [anon_sym_protected] = ACTIONS(3521),
    [anon_sym_public] = ACTIONS(3521),
    [anon_sym_readonly] = ACTIONS(3521),
    [anon_sym_required] = ACTIONS(3521),
    [anon_sym_sealed] = ACTIONS(3521),
    [anon_sym_virtual] = ACTIONS(3521),
    [anon_sym_volatile] = ACTIONS(3521),
    [anon_sym_where] = ACTIONS(3521),
    [anon_sym_notnull] = ACTIONS(3521),
    [anon_sym_unmanaged] = ACTIONS(3521),
    [anon_sym_checked] = ACTIONS(3521),
    [anon_sym_BANG] = ACTIONS(3523),
    [anon_sym_TILDE] = ACTIONS(3523),
    [anon_sym_PLUS_PLUS] = ACTIONS(3523),
    [anon_sym_DASH_DASH] = ACTIONS(3523),
    [anon_sym_true] = ACTIONS(3521),
    [anon_sym_false] = ACTIONS(3521),
    [anon_sym_PLUS] = ACTIONS(3521),
    [anon_sym_DASH] = ACTIONS(3521),
    [anon_sym_STAR] = ACTIONS(3523),
    [anon_sym_CARET] = ACTIONS(3523),
    [anon_sym_AMP] = ACTIONS(3523),
    [anon_sym_this] = ACTIONS(3521),
    [anon_sym_scoped] = ACTIONS(3521),
    [anon_sym_var] = ACTIONS(3521),
    [sym_predefined_type] = ACTIONS(3521),
    [anon_sym_break] = ACTIONS(3521),
    [anon_sym_unchecked] = ACTIONS(3521),
    [anon_sym_continue] = ACTIONS(3521),
    [anon_sym_do] = ACTIONS(3521),
    [anon_sym_while] = ACTIONS(3521),
    [anon_sym_for] = ACTIONS(3521),
    [anon_sym_lock] = ACTIONS(3521),
    [anon_sym_yield] = ACTIONS(3521),
    [anon_sym_switch] = ACTIONS(3521),
    [anon_sym_default] = ACTIONS(3521),
    [anon_sym_throw] = ACTIONS(3521),
    [anon_sym_try] = ACTIONS(3521),
    [anon_sym_when] = ACTIONS(3521),
    [anon_sym_await] = ACTIONS(3521),
    [anon_sym_foreach] = ACTIONS(3521),
    [anon_sym_goto] = ACTIONS(3521),
    [anon_sym_if] = ACTIONS(3521),
    [anon_sym_DOT_DOT] = ACTIONS(3523),
    [anon_sym_from] = ACTIONS(3521),
    [anon_sym_into] = ACTIONS(3521),
    [anon_sym_join] = ACTIONS(3521),
    [anon_sym_on] = ACTIONS(3521),
    [anon_sym_equals] = ACTIONS(3521),
    [anon_sym_let] = ACTIONS(3521),
    [anon_sym_orderby] = ACTIONS(3521),
    [anon_sym_ascending] = ACTIONS(3521),
    [anon_sym_descending] = ACTIONS(3521),
    [anon_sym_group] = ACTIONS(3521),
    [anon_sym_by] = ACTIONS(3521),
    [anon_sym_select] = ACTIONS(3521),
    [anon_sym_DQUOTE] = ACTIONS(3521),
    [anon_sym_stackalloc] = ACTIONS(3521),
    [anon_sym_sizeof] = ACTIONS(3521),
    [anon_sym_typeof] = ACTIONS(3521),
    [anon_sym___makeref] = ACTIONS(3521),
    [anon_sym___reftype] = ACTIONS(3521),
    [anon_sym___refvalue] = ACTIONS(3521),
    [sym_null_literal] = ACTIONS(3521),
    [anon_sym_SQUOTE] = ACTIONS(3523),
    [sym_integer_literal] = ACTIONS(3521),
    [sym_real_literal] = ACTIONS(3523),
    [sym_verbatim_string_literal] = ACTIONS(3523),
    [sym_raw_string_literal] = ACTIONS(3523),
    [aux_sym_preproc_if_token1] = ACTIONS(3523),
    [aux_sym_preproc_if_token3] = ACTIONS(3523),
    [aux_sym_preproc_else_token1] = ACTIONS(3523),
    [aux_sym_preproc_elif_token1] = ACTIONS(3523),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3523),
    [sym_interpolation_verbatim_start] = ACTIONS(3523),
    [sym_interpolation_raw_start] = ACTIONS(3523),
  },
  [2324] = {
    [sym_preproc_region] = STATE(2324),
    [sym_preproc_endregion] = STATE(2324),
    [sym_preproc_line] = STATE(2324),
    [sym_preproc_pragma] = STATE(2324),
    [sym_preproc_nullable] = STATE(2324),
    [sym_preproc_error] = STATE(2324),
    [sym_preproc_define] = STATE(2324),
    [sym_preproc_undef] = STATE(2324),
    [sym__identifier_token] = ACTIONS(3525),
    [anon_sym_extern] = ACTIONS(3525),
    [anon_sym_alias] = ACTIONS(3525),
    [anon_sym_SEMI] = ACTIONS(3527),
    [anon_sym_global] = ACTIONS(3525),
    [anon_sym_using] = ACTIONS(3525),
    [anon_sym_unsafe] = ACTIONS(3525),
    [anon_sym_static] = ACTIONS(3525),
    [anon_sym_LBRACK] = ACTIONS(3527),
    [anon_sym_LPAREN] = ACTIONS(3527),
    [anon_sym_return] = ACTIONS(3525),
    [anon_sym_namespace] = ACTIONS(3525),
    [anon_sym_class] = ACTIONS(3525),
    [anon_sym_ref] = ACTIONS(3525),
    [anon_sym_struct] = ACTIONS(3525),
    [anon_sym_enum] = ACTIONS(3525),
    [anon_sym_LBRACE] = ACTIONS(3527),
    [anon_sym_interface] = ACTIONS(3525),
    [anon_sym_delegate] = ACTIONS(3525),
    [anon_sym_record] = ACTIONS(3525),
    [anon_sym_abstract] = ACTIONS(3525),
    [anon_sym_async] = ACTIONS(3525),
    [anon_sym_const] = ACTIONS(3525),
    [anon_sym_file] = ACTIONS(3525),
    [anon_sym_fixed] = ACTIONS(3525),
    [anon_sym_internal] = ACTIONS(3525),
    [anon_sym_new] = ACTIONS(3525),
    [anon_sym_override] = ACTIONS(3525),
    [anon_sym_partial] = ACTIONS(3525),
    [anon_sym_private] = ACTIONS(3525),
    [anon_sym_protected] = ACTIONS(3525),
    [anon_sym_public] = ACTIONS(3525),
    [anon_sym_readonly] = ACTIONS(3525),
    [anon_sym_required] = ACTIONS(3525),
    [anon_sym_sealed] = ACTIONS(3525),
    [anon_sym_virtual] = ACTIONS(3525),
    [anon_sym_volatile] = ACTIONS(3525),
    [anon_sym_where] = ACTIONS(3525),
    [anon_sym_notnull] = ACTIONS(3525),
    [anon_sym_unmanaged] = ACTIONS(3525),
    [anon_sym_checked] = ACTIONS(3525),
    [anon_sym_BANG] = ACTIONS(3527),
    [anon_sym_TILDE] = ACTIONS(3527),
    [anon_sym_PLUS_PLUS] = ACTIONS(3527),
    [anon_sym_DASH_DASH] = ACTIONS(3527),
    [anon_sym_true] = ACTIONS(3525),
    [anon_sym_false] = ACTIONS(3525),
    [anon_sym_PLUS] = ACTIONS(3525),
    [anon_sym_DASH] = ACTIONS(3525),
    [anon_sym_STAR] = ACTIONS(3527),
    [anon_sym_CARET] = ACTIONS(3527),
    [anon_sym_AMP] = ACTIONS(3527),
    [anon_sym_this] = ACTIONS(3525),
    [anon_sym_scoped] = ACTIONS(3525),
    [anon_sym_var] = ACTIONS(3525),
    [sym_predefined_type] = ACTIONS(3525),
    [anon_sym_break] = ACTIONS(3525),
    [anon_sym_unchecked] = ACTIONS(3525),
    [anon_sym_continue] = ACTIONS(3525),
    [anon_sym_do] = ACTIONS(3525),
    [anon_sym_while] = ACTIONS(3525),
    [anon_sym_for] = ACTIONS(3525),
    [anon_sym_lock] = ACTIONS(3525),
    [anon_sym_yield] = ACTIONS(3525),
    [anon_sym_switch] = ACTIONS(3525),
    [anon_sym_default] = ACTIONS(3525),
    [anon_sym_throw] = ACTIONS(3525),
    [anon_sym_try] = ACTIONS(3525),
    [anon_sym_when] = ACTIONS(3525),
    [anon_sym_await] = ACTIONS(3525),
    [anon_sym_foreach] = ACTIONS(3525),
    [anon_sym_goto] = ACTIONS(3525),
    [anon_sym_if] = ACTIONS(3525),
    [anon_sym_DOT_DOT] = ACTIONS(3527),
    [anon_sym_from] = ACTIONS(3525),
    [anon_sym_into] = ACTIONS(3525),
    [anon_sym_join] = ACTIONS(3525),
    [anon_sym_on] = ACTIONS(3525),
    [anon_sym_equals] = ACTIONS(3525),
    [anon_sym_let] = ACTIONS(3525),
    [anon_sym_orderby] = ACTIONS(3525),
    [anon_sym_ascending] = ACTIONS(3525),
    [anon_sym_descending] = ACTIONS(3525),
    [anon_sym_group] = ACTIONS(3525),
    [anon_sym_by] = ACTIONS(3525),
    [anon_sym_select] = ACTIONS(3525),
    [anon_sym_DQUOTE] = ACTIONS(3525),
    [anon_sym_stackalloc] = ACTIONS(3525),
    [anon_sym_sizeof] = ACTIONS(3525),
    [anon_sym_typeof] = ACTIONS(3525),
    [anon_sym___makeref] = ACTIONS(3525),
    [anon_sym___reftype] = ACTIONS(3525),
    [anon_sym___refvalue] = ACTIONS(3525),
    [sym_null_literal] = ACTIONS(3525),
    [anon_sym_SQUOTE] = ACTIONS(3527),
    [sym_integer_literal] = ACTIONS(3525),
    [sym_real_literal] = ACTIONS(3527),
    [sym_verbatim_string_literal] = ACTIONS(3527),
    [sym_raw_string_literal] = ACTIONS(3527),
    [aux_sym_preproc_if_token1] = ACTIONS(3527),
    [aux_sym_preproc_if_token3] = ACTIONS(3527),
    [aux_sym_preproc_else_token1] = ACTIONS(3527),
    [aux_sym_preproc_elif_token1] = ACTIONS(3527),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3527),
    [sym_interpolation_verbatim_start] = ACTIONS(3527),
    [sym_interpolation_raw_start] = ACTIONS(3527),
  },
  [2325] = {
    [sym_preproc_region] = STATE(2325),
    [sym_preproc_endregion] = STATE(2325),
    [sym_preproc_line] = STATE(2325),
    [sym_preproc_pragma] = STATE(2325),
    [sym_preproc_nullable] = STATE(2325),
    [sym_preproc_error] = STATE(2325),
    [sym_preproc_define] = STATE(2325),
    [sym_preproc_undef] = STATE(2325),
    [sym__identifier_token] = ACTIONS(3529),
    [anon_sym_extern] = ACTIONS(3529),
    [anon_sym_alias] = ACTIONS(3529),
    [anon_sym_SEMI] = ACTIONS(3531),
    [anon_sym_global] = ACTIONS(3529),
    [anon_sym_using] = ACTIONS(3529),
    [anon_sym_unsafe] = ACTIONS(3529),
    [anon_sym_static] = ACTIONS(3529),
    [anon_sym_LBRACK] = ACTIONS(3531),
    [anon_sym_LPAREN] = ACTIONS(3531),
    [anon_sym_return] = ACTIONS(3529),
    [anon_sym_namespace] = ACTIONS(3529),
    [anon_sym_class] = ACTIONS(3529),
    [anon_sym_ref] = ACTIONS(3529),
    [anon_sym_struct] = ACTIONS(3529),
    [anon_sym_enum] = ACTIONS(3529),
    [anon_sym_LBRACE] = ACTIONS(3531),
    [anon_sym_interface] = ACTIONS(3529),
    [anon_sym_delegate] = ACTIONS(3529),
    [anon_sym_record] = ACTIONS(3529),
    [anon_sym_abstract] = ACTIONS(3529),
    [anon_sym_async] = ACTIONS(3529),
    [anon_sym_const] = ACTIONS(3529),
    [anon_sym_file] = ACTIONS(3529),
    [anon_sym_fixed] = ACTIONS(3529),
    [anon_sym_internal] = ACTIONS(3529),
    [anon_sym_new] = ACTIONS(3529),
    [anon_sym_override] = ACTIONS(3529),
    [anon_sym_partial] = ACTIONS(3529),
    [anon_sym_private] = ACTIONS(3529),
    [anon_sym_protected] = ACTIONS(3529),
    [anon_sym_public] = ACTIONS(3529),
    [anon_sym_readonly] = ACTIONS(3529),
    [anon_sym_required] = ACTIONS(3529),
    [anon_sym_sealed] = ACTIONS(3529),
    [anon_sym_virtual] = ACTIONS(3529),
    [anon_sym_volatile] = ACTIONS(3529),
    [anon_sym_where] = ACTIONS(3529),
    [anon_sym_notnull] = ACTIONS(3529),
    [anon_sym_unmanaged] = ACTIONS(3529),
    [anon_sym_checked] = ACTIONS(3529),
    [anon_sym_BANG] = ACTIONS(3531),
    [anon_sym_TILDE] = ACTIONS(3531),
    [anon_sym_PLUS_PLUS] = ACTIONS(3531),
    [anon_sym_DASH_DASH] = ACTIONS(3531),
    [anon_sym_true] = ACTIONS(3529),
    [anon_sym_false] = ACTIONS(3529),
    [anon_sym_PLUS] = ACTIONS(3529),
    [anon_sym_DASH] = ACTIONS(3529),
    [anon_sym_STAR] = ACTIONS(3531),
    [anon_sym_CARET] = ACTIONS(3531),
    [anon_sym_AMP] = ACTIONS(3531),
    [anon_sym_this] = ACTIONS(3529),
    [anon_sym_scoped] = ACTIONS(3529),
    [anon_sym_var] = ACTIONS(3529),
    [sym_predefined_type] = ACTIONS(3529),
    [anon_sym_break] = ACTIONS(3529),
    [anon_sym_unchecked] = ACTIONS(3529),
    [anon_sym_continue] = ACTIONS(3529),
    [anon_sym_do] = ACTIONS(3529),
    [anon_sym_while] = ACTIONS(3529),
    [anon_sym_for] = ACTIONS(3529),
    [anon_sym_lock] = ACTIONS(3529),
    [anon_sym_yield] = ACTIONS(3529),
    [anon_sym_switch] = ACTIONS(3529),
    [anon_sym_default] = ACTIONS(3529),
    [anon_sym_throw] = ACTIONS(3529),
    [anon_sym_try] = ACTIONS(3529),
    [anon_sym_when] = ACTIONS(3529),
    [anon_sym_await] = ACTIONS(3529),
    [anon_sym_foreach] = ACTIONS(3529),
    [anon_sym_goto] = ACTIONS(3529),
    [anon_sym_if] = ACTIONS(3529),
    [anon_sym_DOT_DOT] = ACTIONS(3531),
    [anon_sym_from] = ACTIONS(3529),
    [anon_sym_into] = ACTIONS(3529),
    [anon_sym_join] = ACTIONS(3529),
    [anon_sym_on] = ACTIONS(3529),
    [anon_sym_equals] = ACTIONS(3529),
    [anon_sym_let] = ACTIONS(3529),
    [anon_sym_orderby] = ACTIONS(3529),
    [anon_sym_ascending] = ACTIONS(3529),
    [anon_sym_descending] = ACTIONS(3529),
    [anon_sym_group] = ACTIONS(3529),
    [anon_sym_by] = ACTIONS(3529),
    [anon_sym_select] = ACTIONS(3529),
    [anon_sym_DQUOTE] = ACTIONS(3529),
    [anon_sym_stackalloc] = ACTIONS(3529),
    [anon_sym_sizeof] = ACTIONS(3529),
    [anon_sym_typeof] = ACTIONS(3529),
    [anon_sym___makeref] = ACTIONS(3529),
    [anon_sym___reftype] = ACTIONS(3529),
    [anon_sym___refvalue] = ACTIONS(3529),
    [sym_null_literal] = ACTIONS(3529),
    [anon_sym_SQUOTE] = ACTIONS(3531),
    [sym_integer_literal] = ACTIONS(3529),
    [sym_real_literal] = ACTIONS(3531),
    [sym_verbatim_string_literal] = ACTIONS(3531),
    [sym_raw_string_literal] = ACTIONS(3531),
    [aux_sym_preproc_if_token1] = ACTIONS(3531),
    [aux_sym_preproc_if_token3] = ACTIONS(3531),
    [aux_sym_preproc_else_token1] = ACTIONS(3531),
    [aux_sym_preproc_elif_token1] = ACTIONS(3531),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3531),
    [sym_interpolation_verbatim_start] = ACTIONS(3531),
    [sym_interpolation_raw_start] = ACTIONS(3531),
  },
  [2326] = {
    [sym_preproc_region] = STATE(2326),
    [sym_preproc_endregion] = STATE(2326),
    [sym_preproc_line] = STATE(2326),
    [sym_preproc_pragma] = STATE(2326),
    [sym_preproc_nullable] = STATE(2326),
    [sym_preproc_error] = STATE(2326),
    [sym_preproc_define] = STATE(2326),
    [sym_preproc_undef] = STATE(2326),
    [sym__identifier_token] = ACTIONS(3533),
    [anon_sym_extern] = ACTIONS(3533),
    [anon_sym_alias] = ACTIONS(3533),
    [anon_sym_SEMI] = ACTIONS(3535),
    [anon_sym_global] = ACTIONS(3533),
    [anon_sym_using] = ACTIONS(3533),
    [anon_sym_unsafe] = ACTIONS(3533),
    [anon_sym_static] = ACTIONS(3533),
    [anon_sym_LBRACK] = ACTIONS(3535),
    [anon_sym_LPAREN] = ACTIONS(3535),
    [anon_sym_return] = ACTIONS(3533),
    [anon_sym_namespace] = ACTIONS(3533),
    [anon_sym_class] = ACTIONS(3533),
    [anon_sym_ref] = ACTIONS(3533),
    [anon_sym_struct] = ACTIONS(3533),
    [anon_sym_enum] = ACTIONS(3533),
    [anon_sym_LBRACE] = ACTIONS(3535),
    [anon_sym_interface] = ACTIONS(3533),
    [anon_sym_delegate] = ACTIONS(3533),
    [anon_sym_record] = ACTIONS(3533),
    [anon_sym_abstract] = ACTIONS(3533),
    [anon_sym_async] = ACTIONS(3533),
    [anon_sym_const] = ACTIONS(3533),
    [anon_sym_file] = ACTIONS(3533),
    [anon_sym_fixed] = ACTIONS(3533),
    [anon_sym_internal] = ACTIONS(3533),
    [anon_sym_new] = ACTIONS(3533),
    [anon_sym_override] = ACTIONS(3533),
    [anon_sym_partial] = ACTIONS(3533),
    [anon_sym_private] = ACTIONS(3533),
    [anon_sym_protected] = ACTIONS(3533),
    [anon_sym_public] = ACTIONS(3533),
    [anon_sym_readonly] = ACTIONS(3533),
    [anon_sym_required] = ACTIONS(3533),
    [anon_sym_sealed] = ACTIONS(3533),
    [anon_sym_virtual] = ACTIONS(3533),
    [anon_sym_volatile] = ACTIONS(3533),
    [anon_sym_where] = ACTIONS(3533),
    [anon_sym_notnull] = ACTIONS(3533),
    [anon_sym_unmanaged] = ACTIONS(3533),
    [anon_sym_checked] = ACTIONS(3533),
    [anon_sym_BANG] = ACTIONS(3535),
    [anon_sym_TILDE] = ACTIONS(3535),
    [anon_sym_PLUS_PLUS] = ACTIONS(3535),
    [anon_sym_DASH_DASH] = ACTIONS(3535),
    [anon_sym_true] = ACTIONS(3533),
    [anon_sym_false] = ACTIONS(3533),
    [anon_sym_PLUS] = ACTIONS(3533),
    [anon_sym_DASH] = ACTIONS(3533),
    [anon_sym_STAR] = ACTIONS(3535),
    [anon_sym_CARET] = ACTIONS(3535),
    [anon_sym_AMP] = ACTIONS(3535),
    [anon_sym_this] = ACTIONS(3533),
    [anon_sym_scoped] = ACTIONS(3533),
    [anon_sym_var] = ACTIONS(3533),
    [sym_predefined_type] = ACTIONS(3533),
    [anon_sym_break] = ACTIONS(3533),
    [anon_sym_unchecked] = ACTIONS(3533),
    [anon_sym_continue] = ACTIONS(3533),
    [anon_sym_do] = ACTIONS(3533),
    [anon_sym_while] = ACTIONS(3533),
    [anon_sym_for] = ACTIONS(3533),
    [anon_sym_lock] = ACTIONS(3533),
    [anon_sym_yield] = ACTIONS(3533),
    [anon_sym_switch] = ACTIONS(3533),
    [anon_sym_default] = ACTIONS(3533),
    [anon_sym_throw] = ACTIONS(3533),
    [anon_sym_try] = ACTIONS(3533),
    [anon_sym_when] = ACTIONS(3533),
    [anon_sym_await] = ACTIONS(3533),
    [anon_sym_foreach] = ACTIONS(3533),
    [anon_sym_goto] = ACTIONS(3533),
    [anon_sym_if] = ACTIONS(3533),
    [anon_sym_DOT_DOT] = ACTIONS(3535),
    [anon_sym_from] = ACTIONS(3533),
    [anon_sym_into] = ACTIONS(3533),
    [anon_sym_join] = ACTIONS(3533),
    [anon_sym_on] = ACTIONS(3533),
    [anon_sym_equals] = ACTIONS(3533),
    [anon_sym_let] = ACTIONS(3533),
    [anon_sym_orderby] = ACTIONS(3533),
    [anon_sym_ascending] = ACTIONS(3533),
    [anon_sym_descending] = ACTIONS(3533),
    [anon_sym_group] = ACTIONS(3533),
    [anon_sym_by] = ACTIONS(3533),
    [anon_sym_select] = ACTIONS(3533),
    [anon_sym_DQUOTE] = ACTIONS(3533),
    [anon_sym_stackalloc] = ACTIONS(3533),
    [anon_sym_sizeof] = ACTIONS(3533),
    [anon_sym_typeof] = ACTIONS(3533),
    [anon_sym___makeref] = ACTIONS(3533),
    [anon_sym___reftype] = ACTIONS(3533),
    [anon_sym___refvalue] = ACTIONS(3533),
    [sym_null_literal] = ACTIONS(3533),
    [anon_sym_SQUOTE] = ACTIONS(3535),
    [sym_integer_literal] = ACTIONS(3533),
    [sym_real_literal] = ACTIONS(3535),
    [sym_verbatim_string_literal] = ACTIONS(3535),
    [sym_raw_string_literal] = ACTIONS(3535),
    [aux_sym_preproc_if_token1] = ACTIONS(3535),
    [aux_sym_preproc_if_token3] = ACTIONS(3535),
    [aux_sym_preproc_else_token1] = ACTIONS(3535),
    [aux_sym_preproc_elif_token1] = ACTIONS(3535),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3535),
    [sym_interpolation_verbatim_start] = ACTIONS(3535),
    [sym_interpolation_raw_start] = ACTIONS(3535),
  },
  [2327] = {
    [sym_preproc_region] = STATE(2327),
    [sym_preproc_endregion] = STATE(2327),
    [sym_preproc_line] = STATE(2327),
    [sym_preproc_pragma] = STATE(2327),
    [sym_preproc_nullable] = STATE(2327),
    [sym_preproc_error] = STATE(2327),
    [sym_preproc_define] = STATE(2327),
    [sym_preproc_undef] = STATE(2327),
    [sym__identifier_token] = ACTIONS(3537),
    [anon_sym_extern] = ACTIONS(3537),
    [anon_sym_alias] = ACTIONS(3537),
    [anon_sym_SEMI] = ACTIONS(3539),
    [anon_sym_global] = ACTIONS(3537),
    [anon_sym_using] = ACTIONS(3537),
    [anon_sym_unsafe] = ACTIONS(3537),
    [anon_sym_static] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(3539),
    [anon_sym_LPAREN] = ACTIONS(3539),
    [anon_sym_return] = ACTIONS(3537),
    [anon_sym_namespace] = ACTIONS(3537),
    [anon_sym_class] = ACTIONS(3537),
    [anon_sym_ref] = ACTIONS(3537),
    [anon_sym_struct] = ACTIONS(3537),
    [anon_sym_enum] = ACTIONS(3537),
    [anon_sym_LBRACE] = ACTIONS(3539),
    [anon_sym_interface] = ACTIONS(3537),
    [anon_sym_delegate] = ACTIONS(3537),
    [anon_sym_record] = ACTIONS(3537),
    [anon_sym_abstract] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(3537),
    [anon_sym_const] = ACTIONS(3537),
    [anon_sym_file] = ACTIONS(3537),
    [anon_sym_fixed] = ACTIONS(3537),
    [anon_sym_internal] = ACTIONS(3537),
    [anon_sym_new] = ACTIONS(3537),
    [anon_sym_override] = ACTIONS(3537),
    [anon_sym_partial] = ACTIONS(3537),
    [anon_sym_private] = ACTIONS(3537),
    [anon_sym_protected] = ACTIONS(3537),
    [anon_sym_public] = ACTIONS(3537),
    [anon_sym_readonly] = ACTIONS(3537),
    [anon_sym_required] = ACTIONS(3537),
    [anon_sym_sealed] = ACTIONS(3537),
    [anon_sym_virtual] = ACTIONS(3537),
    [anon_sym_volatile] = ACTIONS(3537),
    [anon_sym_where] = ACTIONS(3537),
    [anon_sym_notnull] = ACTIONS(3537),
    [anon_sym_unmanaged] = ACTIONS(3537),
    [anon_sym_checked] = ACTIONS(3537),
    [anon_sym_BANG] = ACTIONS(3539),
    [anon_sym_TILDE] = ACTIONS(3539),
    [anon_sym_PLUS_PLUS] = ACTIONS(3539),
    [anon_sym_DASH_DASH] = ACTIONS(3539),
    [anon_sym_true] = ACTIONS(3537),
    [anon_sym_false] = ACTIONS(3537),
    [anon_sym_PLUS] = ACTIONS(3537),
    [anon_sym_DASH] = ACTIONS(3537),
    [anon_sym_STAR] = ACTIONS(3539),
    [anon_sym_CARET] = ACTIONS(3539),
    [anon_sym_AMP] = ACTIONS(3539),
    [anon_sym_this] = ACTIONS(3537),
    [anon_sym_scoped] = ACTIONS(3537),
    [anon_sym_var] = ACTIONS(3537),
    [sym_predefined_type] = ACTIONS(3537),
    [anon_sym_break] = ACTIONS(3537),
    [anon_sym_unchecked] = ACTIONS(3537),
    [anon_sym_continue] = ACTIONS(3537),
    [anon_sym_do] = ACTIONS(3537),
    [anon_sym_while] = ACTIONS(3537),
    [anon_sym_for] = ACTIONS(3537),
    [anon_sym_lock] = ACTIONS(3537),
    [anon_sym_yield] = ACTIONS(3537),
    [anon_sym_switch] = ACTIONS(3537),
    [anon_sym_default] = ACTIONS(3537),
    [anon_sym_throw] = ACTIONS(3537),
    [anon_sym_try] = ACTIONS(3537),
    [anon_sym_when] = ACTIONS(3537),
    [anon_sym_await] = ACTIONS(3537),
    [anon_sym_foreach] = ACTIONS(3537),
    [anon_sym_goto] = ACTIONS(3537),
    [anon_sym_if] = ACTIONS(3537),
    [anon_sym_DOT_DOT] = ACTIONS(3539),
    [anon_sym_from] = ACTIONS(3537),
    [anon_sym_into] = ACTIONS(3537),
    [anon_sym_join] = ACTIONS(3537),
    [anon_sym_on] = ACTIONS(3537),
    [anon_sym_equals] = ACTIONS(3537),
    [anon_sym_let] = ACTIONS(3537),
    [anon_sym_orderby] = ACTIONS(3537),
    [anon_sym_ascending] = ACTIONS(3537),
    [anon_sym_descending] = ACTIONS(3537),
    [anon_sym_group] = ACTIONS(3537),
    [anon_sym_by] = ACTIONS(3537),
    [anon_sym_select] = ACTIONS(3537),
    [anon_sym_DQUOTE] = ACTIONS(3537),
    [anon_sym_stackalloc] = ACTIONS(3537),
    [anon_sym_sizeof] = ACTIONS(3537),
    [anon_sym_typeof] = ACTIONS(3537),
    [anon_sym___makeref] = ACTIONS(3537),
    [anon_sym___reftype] = ACTIONS(3537),
    [anon_sym___refvalue] = ACTIONS(3537),
    [sym_null_literal] = ACTIONS(3537),
    [anon_sym_SQUOTE] = ACTIONS(3539),
    [sym_integer_literal] = ACTIONS(3537),
    [sym_real_literal] = ACTIONS(3539),
    [sym_verbatim_string_literal] = ACTIONS(3539),
    [sym_raw_string_literal] = ACTIONS(3539),
    [aux_sym_preproc_if_token1] = ACTIONS(3539),
    [aux_sym_preproc_if_token3] = ACTIONS(3539),
    [aux_sym_preproc_else_token1] = ACTIONS(3539),
    [aux_sym_preproc_elif_token1] = ACTIONS(3539),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3539),
    [sym_interpolation_verbatim_start] = ACTIONS(3539),
    [sym_interpolation_raw_start] = ACTIONS(3539),
  },
  [2328] = {
    [sym_preproc_region] = STATE(2328),
    [sym_preproc_endregion] = STATE(2328),
    [sym_preproc_line] = STATE(2328),
    [sym_preproc_pragma] = STATE(2328),
    [sym_preproc_nullable] = STATE(2328),
    [sym_preproc_error] = STATE(2328),
    [sym_preproc_define] = STATE(2328),
    [sym_preproc_undef] = STATE(2328),
    [sym__identifier_token] = ACTIONS(3541),
    [anon_sym_extern] = ACTIONS(3541),
    [anon_sym_alias] = ACTIONS(3541),
    [anon_sym_SEMI] = ACTIONS(3543),
    [anon_sym_global] = ACTIONS(3541),
    [anon_sym_using] = ACTIONS(3541),
    [anon_sym_unsafe] = ACTIONS(3541),
    [anon_sym_static] = ACTIONS(3541),
    [anon_sym_LBRACK] = ACTIONS(3543),
    [anon_sym_LPAREN] = ACTIONS(3543),
    [anon_sym_return] = ACTIONS(3541),
    [anon_sym_namespace] = ACTIONS(3541),
    [anon_sym_class] = ACTIONS(3541),
    [anon_sym_ref] = ACTIONS(3541),
    [anon_sym_struct] = ACTIONS(3541),
    [anon_sym_enum] = ACTIONS(3541),
    [anon_sym_LBRACE] = ACTIONS(3543),
    [anon_sym_interface] = ACTIONS(3541),
    [anon_sym_delegate] = ACTIONS(3541),
    [anon_sym_record] = ACTIONS(3541),
    [anon_sym_abstract] = ACTIONS(3541),
    [anon_sym_async] = ACTIONS(3541),
    [anon_sym_const] = ACTIONS(3541),
    [anon_sym_file] = ACTIONS(3541),
    [anon_sym_fixed] = ACTIONS(3541),
    [anon_sym_internal] = ACTIONS(3541),
    [anon_sym_new] = ACTIONS(3541),
    [anon_sym_override] = ACTIONS(3541),
    [anon_sym_partial] = ACTIONS(3541),
    [anon_sym_private] = ACTIONS(3541),
    [anon_sym_protected] = ACTIONS(3541),
    [anon_sym_public] = ACTIONS(3541),
    [anon_sym_readonly] = ACTIONS(3541),
    [anon_sym_required] = ACTIONS(3541),
    [anon_sym_sealed] = ACTIONS(3541),
    [anon_sym_virtual] = ACTIONS(3541),
    [anon_sym_volatile] = ACTIONS(3541),
    [anon_sym_where] = ACTIONS(3541),
    [anon_sym_notnull] = ACTIONS(3541),
    [anon_sym_unmanaged] = ACTIONS(3541),
    [anon_sym_checked] = ACTIONS(3541),
    [anon_sym_BANG] = ACTIONS(3543),
    [anon_sym_TILDE] = ACTIONS(3543),
    [anon_sym_PLUS_PLUS] = ACTIONS(3543),
    [anon_sym_DASH_DASH] = ACTIONS(3543),
    [anon_sym_true] = ACTIONS(3541),
    [anon_sym_false] = ACTIONS(3541),
    [anon_sym_PLUS] = ACTIONS(3541),
    [anon_sym_DASH] = ACTIONS(3541),
    [anon_sym_STAR] = ACTIONS(3543),
    [anon_sym_CARET] = ACTIONS(3543),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_this] = ACTIONS(3541),
    [anon_sym_scoped] = ACTIONS(3541),
    [anon_sym_var] = ACTIONS(3541),
    [sym_predefined_type] = ACTIONS(3541),
    [anon_sym_break] = ACTIONS(3541),
    [anon_sym_unchecked] = ACTIONS(3541),
    [anon_sym_continue] = ACTIONS(3541),
    [anon_sym_do] = ACTIONS(3541),
    [anon_sym_while] = ACTIONS(3541),
    [anon_sym_for] = ACTIONS(3541),
    [anon_sym_lock] = ACTIONS(3541),
    [anon_sym_yield] = ACTIONS(3541),
    [anon_sym_switch] = ACTIONS(3541),
    [anon_sym_default] = ACTIONS(3541),
    [anon_sym_throw] = ACTIONS(3541),
    [anon_sym_try] = ACTIONS(3541),
    [anon_sym_when] = ACTIONS(3541),
    [anon_sym_await] = ACTIONS(3541),
    [anon_sym_foreach] = ACTIONS(3541),
    [anon_sym_goto] = ACTIONS(3541),
    [anon_sym_if] = ACTIONS(3541),
    [anon_sym_DOT_DOT] = ACTIONS(3543),
    [anon_sym_from] = ACTIONS(3541),
    [anon_sym_into] = ACTIONS(3541),
    [anon_sym_join] = ACTIONS(3541),
    [anon_sym_on] = ACTIONS(3541),
    [anon_sym_equals] = ACTIONS(3541),
    [anon_sym_let] = ACTIONS(3541),
    [anon_sym_orderby] = ACTIONS(3541),
    [anon_sym_ascending] = ACTIONS(3541),
    [anon_sym_descending] = ACTIONS(3541),
    [anon_sym_group] = ACTIONS(3541),
    [anon_sym_by] = ACTIONS(3541),
    [anon_sym_select] = ACTIONS(3541),
    [anon_sym_DQUOTE] = ACTIONS(3541),
    [anon_sym_stackalloc] = ACTIONS(3541),
    [anon_sym_sizeof] = ACTIONS(3541),
    [anon_sym_typeof] = ACTIONS(3541),
    [anon_sym___makeref] = ACTIONS(3541),
    [anon_sym___reftype] = ACTIONS(3541),
    [anon_sym___refvalue] = ACTIONS(3541),
    [sym_null_literal] = ACTIONS(3541),
    [anon_sym_SQUOTE] = ACTIONS(3543),
    [sym_integer_literal] = ACTIONS(3541),
    [sym_real_literal] = ACTIONS(3543),
    [sym_verbatim_string_literal] = ACTIONS(3543),
    [sym_raw_string_literal] = ACTIONS(3543),
    [aux_sym_preproc_if_token1] = ACTIONS(3543),
    [aux_sym_preproc_if_token3] = ACTIONS(3543),
    [aux_sym_preproc_else_token1] = ACTIONS(3543),
    [aux_sym_preproc_elif_token1] = ACTIONS(3543),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3543),
    [sym_interpolation_verbatim_start] = ACTIONS(3543),
    [sym_interpolation_raw_start] = ACTIONS(3543),
  },
  [2329] = {
    [sym_preproc_region] = STATE(2329),
    [sym_preproc_endregion] = STATE(2329),
    [sym_preproc_line] = STATE(2329),
    [sym_preproc_pragma] = STATE(2329),
    [sym_preproc_nullable] = STATE(2329),
    [sym_preproc_error] = STATE(2329),
    [sym_preproc_define] = STATE(2329),
    [sym_preproc_undef] = STATE(2329),
    [sym__identifier_token] = ACTIONS(3545),
    [anon_sym_extern] = ACTIONS(3545),
    [anon_sym_alias] = ACTIONS(3545),
    [anon_sym_SEMI] = ACTIONS(3547),
    [anon_sym_global] = ACTIONS(3545),
    [anon_sym_using] = ACTIONS(3545),
    [anon_sym_unsafe] = ACTIONS(3545),
    [anon_sym_static] = ACTIONS(3545),
    [anon_sym_LBRACK] = ACTIONS(3547),
    [anon_sym_LPAREN] = ACTIONS(3547),
    [anon_sym_return] = ACTIONS(3545),
    [anon_sym_namespace] = ACTIONS(3545),
    [anon_sym_class] = ACTIONS(3545),
    [anon_sym_ref] = ACTIONS(3545),
    [anon_sym_struct] = ACTIONS(3545),
    [anon_sym_enum] = ACTIONS(3545),
    [anon_sym_LBRACE] = ACTIONS(3547),
    [anon_sym_interface] = ACTIONS(3545),
    [anon_sym_delegate] = ACTIONS(3545),
    [anon_sym_record] = ACTIONS(3545),
    [anon_sym_abstract] = ACTIONS(3545),
    [anon_sym_async] = ACTIONS(3545),
    [anon_sym_const] = ACTIONS(3545),
    [anon_sym_file] = ACTIONS(3545),
    [anon_sym_fixed] = ACTIONS(3545),
    [anon_sym_internal] = ACTIONS(3545),
    [anon_sym_new] = ACTIONS(3545),
    [anon_sym_override] = ACTIONS(3545),
    [anon_sym_partial] = ACTIONS(3545),
    [anon_sym_private] = ACTIONS(3545),
    [anon_sym_protected] = ACTIONS(3545),
    [anon_sym_public] = ACTIONS(3545),
    [anon_sym_readonly] = ACTIONS(3545),
    [anon_sym_required] = ACTIONS(3545),
    [anon_sym_sealed] = ACTIONS(3545),
    [anon_sym_virtual] = ACTIONS(3545),
    [anon_sym_volatile] = ACTIONS(3545),
    [anon_sym_where] = ACTIONS(3545),
    [anon_sym_notnull] = ACTIONS(3545),
    [anon_sym_unmanaged] = ACTIONS(3545),
    [anon_sym_checked] = ACTIONS(3545),
    [anon_sym_BANG] = ACTIONS(3547),
    [anon_sym_TILDE] = ACTIONS(3547),
    [anon_sym_PLUS_PLUS] = ACTIONS(3547),
    [anon_sym_DASH_DASH] = ACTIONS(3547),
    [anon_sym_true] = ACTIONS(3545),
    [anon_sym_false] = ACTIONS(3545),
    [anon_sym_PLUS] = ACTIONS(3545),
    [anon_sym_DASH] = ACTIONS(3545),
    [anon_sym_STAR] = ACTIONS(3547),
    [anon_sym_CARET] = ACTIONS(3547),
    [anon_sym_AMP] = ACTIONS(3547),
    [anon_sym_this] = ACTIONS(3545),
    [anon_sym_scoped] = ACTIONS(3545),
    [anon_sym_var] = ACTIONS(3545),
    [sym_predefined_type] = ACTIONS(3545),
    [anon_sym_break] = ACTIONS(3545),
    [anon_sym_unchecked] = ACTIONS(3545),
    [anon_sym_continue] = ACTIONS(3545),
    [anon_sym_do] = ACTIONS(3545),
    [anon_sym_while] = ACTIONS(3545),
    [anon_sym_for] = ACTIONS(3545),
    [anon_sym_lock] = ACTIONS(3545),
    [anon_sym_yield] = ACTIONS(3545),
    [anon_sym_switch] = ACTIONS(3545),
    [anon_sym_default] = ACTIONS(3545),
    [anon_sym_throw] = ACTIONS(3545),
    [anon_sym_try] = ACTIONS(3545),
    [anon_sym_when] = ACTIONS(3545),
    [anon_sym_await] = ACTIONS(3545),
    [anon_sym_foreach] = ACTIONS(3545),
    [anon_sym_goto] = ACTIONS(3545),
    [anon_sym_if] = ACTIONS(3545),
    [anon_sym_DOT_DOT] = ACTIONS(3547),
    [anon_sym_from] = ACTIONS(3545),
    [anon_sym_into] = ACTIONS(3545),
    [anon_sym_join] = ACTIONS(3545),
    [anon_sym_on] = ACTIONS(3545),
    [anon_sym_equals] = ACTIONS(3545),
    [anon_sym_let] = ACTIONS(3545),
    [anon_sym_orderby] = ACTIONS(3545),
    [anon_sym_ascending] = ACTIONS(3545),
    [anon_sym_descending] = ACTIONS(3545),
    [anon_sym_group] = ACTIONS(3545),
    [anon_sym_by] = ACTIONS(3545),
    [anon_sym_select] = ACTIONS(3545),
    [anon_sym_DQUOTE] = ACTIONS(3545),
    [anon_sym_stackalloc] = ACTIONS(3545),
    [anon_sym_sizeof] = ACTIONS(3545),
    [anon_sym_typeof] = ACTIONS(3545),
    [anon_sym___makeref] = ACTIONS(3545),
    [anon_sym___reftype] = ACTIONS(3545),
    [anon_sym___refvalue] = ACTIONS(3545),
    [sym_null_literal] = ACTIONS(3545),
    [anon_sym_SQUOTE] = ACTIONS(3547),
    [sym_integer_literal] = ACTIONS(3545),
    [sym_real_literal] = ACTIONS(3547),
    [sym_verbatim_string_literal] = ACTIONS(3547),
    [sym_raw_string_literal] = ACTIONS(3547),
    [aux_sym_preproc_if_token1] = ACTIONS(3547),
    [aux_sym_preproc_if_token3] = ACTIONS(3547),
    [aux_sym_preproc_else_token1] = ACTIONS(3547),
    [aux_sym_preproc_elif_token1] = ACTIONS(3547),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3547),
    [sym_interpolation_verbatim_start] = ACTIONS(3547),
    [sym_interpolation_raw_start] = ACTIONS(3547),
  },
  [2330] = {
    [sym_preproc_region] = STATE(2330),
    [sym_preproc_endregion] = STATE(2330),
    [sym_preproc_line] = STATE(2330),
    [sym_preproc_pragma] = STATE(2330),
    [sym_preproc_nullable] = STATE(2330),
    [sym_preproc_error] = STATE(2330),
    [sym_preproc_define] = STATE(2330),
    [sym_preproc_undef] = STATE(2330),
    [sym__identifier_token] = ACTIONS(3549),
    [anon_sym_extern] = ACTIONS(3549),
    [anon_sym_alias] = ACTIONS(3549),
    [anon_sym_SEMI] = ACTIONS(3551),
    [anon_sym_global] = ACTIONS(3549),
    [anon_sym_using] = ACTIONS(3549),
    [anon_sym_unsafe] = ACTIONS(3549),
    [anon_sym_static] = ACTIONS(3549),
    [anon_sym_LBRACK] = ACTIONS(3551),
    [anon_sym_LPAREN] = ACTIONS(3551),
    [anon_sym_return] = ACTIONS(3549),
    [anon_sym_namespace] = ACTIONS(3549),
    [anon_sym_class] = ACTIONS(3549),
    [anon_sym_ref] = ACTIONS(3549),
    [anon_sym_struct] = ACTIONS(3549),
    [anon_sym_enum] = ACTIONS(3549),
    [anon_sym_LBRACE] = ACTIONS(3551),
    [anon_sym_interface] = ACTIONS(3549),
    [anon_sym_delegate] = ACTIONS(3549),
    [anon_sym_record] = ACTIONS(3549),
    [anon_sym_abstract] = ACTIONS(3549),
    [anon_sym_async] = ACTIONS(3549),
    [anon_sym_const] = ACTIONS(3549),
    [anon_sym_file] = ACTIONS(3549),
    [anon_sym_fixed] = ACTIONS(3549),
    [anon_sym_internal] = ACTIONS(3549),
    [anon_sym_new] = ACTIONS(3549),
    [anon_sym_override] = ACTIONS(3549),
    [anon_sym_partial] = ACTIONS(3549),
    [anon_sym_private] = ACTIONS(3549),
    [anon_sym_protected] = ACTIONS(3549),
    [anon_sym_public] = ACTIONS(3549),
    [anon_sym_readonly] = ACTIONS(3549),
    [anon_sym_required] = ACTIONS(3549),
    [anon_sym_sealed] = ACTIONS(3549),
    [anon_sym_virtual] = ACTIONS(3549),
    [anon_sym_volatile] = ACTIONS(3549),
    [anon_sym_where] = ACTIONS(3549),
    [anon_sym_notnull] = ACTIONS(3549),
    [anon_sym_unmanaged] = ACTIONS(3549),
    [anon_sym_checked] = ACTIONS(3549),
    [anon_sym_BANG] = ACTIONS(3551),
    [anon_sym_TILDE] = ACTIONS(3551),
    [anon_sym_PLUS_PLUS] = ACTIONS(3551),
    [anon_sym_DASH_DASH] = ACTIONS(3551),
    [anon_sym_true] = ACTIONS(3549),
    [anon_sym_false] = ACTIONS(3549),
    [anon_sym_PLUS] = ACTIONS(3549),
    [anon_sym_DASH] = ACTIONS(3549),
    [anon_sym_STAR] = ACTIONS(3551),
    [anon_sym_CARET] = ACTIONS(3551),
    [anon_sym_AMP] = ACTIONS(3551),
    [anon_sym_this] = ACTIONS(3549),
    [anon_sym_scoped] = ACTIONS(3549),
    [anon_sym_var] = ACTIONS(3549),
    [sym_predefined_type] = ACTIONS(3549),
    [anon_sym_break] = ACTIONS(3549),
    [anon_sym_unchecked] = ACTIONS(3549),
    [anon_sym_continue] = ACTIONS(3549),
    [anon_sym_do] = ACTIONS(3549),
    [anon_sym_while] = ACTIONS(3549),
    [anon_sym_for] = ACTIONS(3549),
    [anon_sym_lock] = ACTIONS(3549),
    [anon_sym_yield] = ACTIONS(3549),
    [anon_sym_switch] = ACTIONS(3549),
    [anon_sym_default] = ACTIONS(3549),
    [anon_sym_throw] = ACTIONS(3549),
    [anon_sym_try] = ACTIONS(3549),
    [anon_sym_when] = ACTIONS(3549),
    [anon_sym_await] = ACTIONS(3549),
    [anon_sym_foreach] = ACTIONS(3549),
    [anon_sym_goto] = ACTIONS(3549),
    [anon_sym_if] = ACTIONS(3549),
    [anon_sym_DOT_DOT] = ACTIONS(3551),
    [anon_sym_from] = ACTIONS(3549),
    [anon_sym_into] = ACTIONS(3549),
    [anon_sym_join] = ACTIONS(3549),
    [anon_sym_on] = ACTIONS(3549),
    [anon_sym_equals] = ACTIONS(3549),
    [anon_sym_let] = ACTIONS(3549),
    [anon_sym_orderby] = ACTIONS(3549),
    [anon_sym_ascending] = ACTIONS(3549),
    [anon_sym_descending] = ACTIONS(3549),
    [anon_sym_group] = ACTIONS(3549),
    [anon_sym_by] = ACTIONS(3549),
    [anon_sym_select] = ACTIONS(3549),
    [anon_sym_DQUOTE] = ACTIONS(3549),
    [anon_sym_stackalloc] = ACTIONS(3549),
    [anon_sym_sizeof] = ACTIONS(3549),
    [anon_sym_typeof] = ACTIONS(3549),
    [anon_sym___makeref] = ACTIONS(3549),
    [anon_sym___reftype] = ACTIONS(3549),
    [anon_sym___refvalue] = ACTIONS(3549),
    [sym_null_literal] = ACTIONS(3549),
    [anon_sym_SQUOTE] = ACTIONS(3551),
    [sym_integer_literal] = ACTIONS(3549),
    [sym_real_literal] = ACTIONS(3551),
    [sym_verbatim_string_literal] = ACTIONS(3551),
    [sym_raw_string_literal] = ACTIONS(3551),
    [aux_sym_preproc_if_token1] = ACTIONS(3551),
    [aux_sym_preproc_if_token3] = ACTIONS(3551),
    [aux_sym_preproc_else_token1] = ACTIONS(3551),
    [aux_sym_preproc_elif_token1] = ACTIONS(3551),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3551),
    [sym_interpolation_verbatim_start] = ACTIONS(3551),
    [sym_interpolation_raw_start] = ACTIONS(3551),
  },
  [2331] = {
    [sym_preproc_region] = STATE(2331),
    [sym_preproc_endregion] = STATE(2331),
    [sym_preproc_line] = STATE(2331),
    [sym_preproc_pragma] = STATE(2331),
    [sym_preproc_nullable] = STATE(2331),
    [sym_preproc_error] = STATE(2331),
    [sym_preproc_define] = STATE(2331),
    [sym_preproc_undef] = STATE(2331),
    [sym__identifier_token] = ACTIONS(3553),
    [anon_sym_extern] = ACTIONS(3553),
    [anon_sym_alias] = ACTIONS(3553),
    [anon_sym_SEMI] = ACTIONS(3555),
    [anon_sym_global] = ACTIONS(3553),
    [anon_sym_using] = ACTIONS(3553),
    [anon_sym_unsafe] = ACTIONS(3553),
    [anon_sym_static] = ACTIONS(3553),
    [anon_sym_LBRACK] = ACTIONS(3555),
    [anon_sym_LPAREN] = ACTIONS(3555),
    [anon_sym_return] = ACTIONS(3553),
    [anon_sym_namespace] = ACTIONS(3553),
    [anon_sym_class] = ACTIONS(3553),
    [anon_sym_ref] = ACTIONS(3553),
    [anon_sym_struct] = ACTIONS(3553),
    [anon_sym_enum] = ACTIONS(3553),
    [anon_sym_LBRACE] = ACTIONS(3555),
    [anon_sym_interface] = ACTIONS(3553),
    [anon_sym_delegate] = ACTIONS(3553),
    [anon_sym_record] = ACTIONS(3553),
    [anon_sym_abstract] = ACTIONS(3553),
    [anon_sym_async] = ACTIONS(3553),
    [anon_sym_const] = ACTIONS(3553),
    [anon_sym_file] = ACTIONS(3553),
    [anon_sym_fixed] = ACTIONS(3553),
    [anon_sym_internal] = ACTIONS(3553),
    [anon_sym_new] = ACTIONS(3553),
    [anon_sym_override] = ACTIONS(3553),
    [anon_sym_partial] = ACTIONS(3553),
    [anon_sym_private] = ACTIONS(3553),
    [anon_sym_protected] = ACTIONS(3553),
    [anon_sym_public] = ACTIONS(3553),
    [anon_sym_readonly] = ACTIONS(3553),
    [anon_sym_required] = ACTIONS(3553),
    [anon_sym_sealed] = ACTIONS(3553),
    [anon_sym_virtual] = ACTIONS(3553),
    [anon_sym_volatile] = ACTIONS(3553),
    [anon_sym_where] = ACTIONS(3553),
    [anon_sym_notnull] = ACTIONS(3553),
    [anon_sym_unmanaged] = ACTIONS(3553),
    [anon_sym_checked] = ACTIONS(3553),
    [anon_sym_BANG] = ACTIONS(3555),
    [anon_sym_TILDE] = ACTIONS(3555),
    [anon_sym_PLUS_PLUS] = ACTIONS(3555),
    [anon_sym_DASH_DASH] = ACTIONS(3555),
    [anon_sym_true] = ACTIONS(3553),
    [anon_sym_false] = ACTIONS(3553),
    [anon_sym_PLUS] = ACTIONS(3553),
    [anon_sym_DASH] = ACTIONS(3553),
    [anon_sym_STAR] = ACTIONS(3555),
    [anon_sym_CARET] = ACTIONS(3555),
    [anon_sym_AMP] = ACTIONS(3555),
    [anon_sym_this] = ACTIONS(3553),
    [anon_sym_scoped] = ACTIONS(3553),
    [anon_sym_var] = ACTIONS(3553),
    [sym_predefined_type] = ACTIONS(3553),
    [anon_sym_break] = ACTIONS(3553),
    [anon_sym_unchecked] = ACTIONS(3553),
    [anon_sym_continue] = ACTIONS(3553),
    [anon_sym_do] = ACTIONS(3553),
    [anon_sym_while] = ACTIONS(3553),
    [anon_sym_for] = ACTIONS(3553),
    [anon_sym_lock] = ACTIONS(3553),
    [anon_sym_yield] = ACTIONS(3553),
    [anon_sym_switch] = ACTIONS(3553),
    [anon_sym_default] = ACTIONS(3553),
    [anon_sym_throw] = ACTIONS(3553),
    [anon_sym_try] = ACTIONS(3553),
    [anon_sym_when] = ACTIONS(3553),
    [anon_sym_await] = ACTIONS(3553),
    [anon_sym_foreach] = ACTIONS(3553),
    [anon_sym_goto] = ACTIONS(3553),
    [anon_sym_if] = ACTIONS(3553),
    [anon_sym_DOT_DOT] = ACTIONS(3555),
    [anon_sym_from] = ACTIONS(3553),
    [anon_sym_into] = ACTIONS(3553),
    [anon_sym_join] = ACTIONS(3553),
    [anon_sym_on] = ACTIONS(3553),
    [anon_sym_equals] = ACTIONS(3553),
    [anon_sym_let] = ACTIONS(3553),
    [anon_sym_orderby] = ACTIONS(3553),
    [anon_sym_ascending] = ACTIONS(3553),
    [anon_sym_descending] = ACTIONS(3553),
    [anon_sym_group] = ACTIONS(3553),
    [anon_sym_by] = ACTIONS(3553),
    [anon_sym_select] = ACTIONS(3553),
    [anon_sym_DQUOTE] = ACTIONS(3553),
    [anon_sym_stackalloc] = ACTIONS(3553),
    [anon_sym_sizeof] = ACTIONS(3553),
    [anon_sym_typeof] = ACTIONS(3553),
    [anon_sym___makeref] = ACTIONS(3553),
    [anon_sym___reftype] = ACTIONS(3553),
    [anon_sym___refvalue] = ACTIONS(3553),
    [sym_null_literal] = ACTIONS(3553),
    [anon_sym_SQUOTE] = ACTIONS(3555),
    [sym_integer_literal] = ACTIONS(3553),
    [sym_real_literal] = ACTIONS(3555),
    [sym_verbatim_string_literal] = ACTIONS(3555),
    [sym_raw_string_literal] = ACTIONS(3555),
    [aux_sym_preproc_if_token1] = ACTIONS(3555),
    [aux_sym_preproc_if_token3] = ACTIONS(3555),
    [aux_sym_preproc_else_token1] = ACTIONS(3555),
    [aux_sym_preproc_elif_token1] = ACTIONS(3555),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3555),
    [sym_interpolation_verbatim_start] = ACTIONS(3555),
    [sym_interpolation_raw_start] = ACTIONS(3555),
  },
  [2332] = {
    [sym_preproc_region] = STATE(2332),
    [sym_preproc_endregion] = STATE(2332),
    [sym_preproc_line] = STATE(2332),
    [sym_preproc_pragma] = STATE(2332),
    [sym_preproc_nullable] = STATE(2332),
    [sym_preproc_error] = STATE(2332),
    [sym_preproc_define] = STATE(2332),
    [sym_preproc_undef] = STATE(2332),
    [sym__identifier_token] = ACTIONS(3557),
    [anon_sym_extern] = ACTIONS(3557),
    [anon_sym_alias] = ACTIONS(3557),
    [anon_sym_SEMI] = ACTIONS(3559),
    [anon_sym_global] = ACTIONS(3557),
    [anon_sym_using] = ACTIONS(3557),
    [anon_sym_unsafe] = ACTIONS(3557),
    [anon_sym_static] = ACTIONS(3557),
    [anon_sym_LBRACK] = ACTIONS(3559),
    [anon_sym_LPAREN] = ACTIONS(3559),
    [anon_sym_return] = ACTIONS(3557),
    [anon_sym_namespace] = ACTIONS(3557),
    [anon_sym_class] = ACTIONS(3557),
    [anon_sym_ref] = ACTIONS(3557),
    [anon_sym_struct] = ACTIONS(3557),
    [anon_sym_enum] = ACTIONS(3557),
    [anon_sym_LBRACE] = ACTIONS(3559),
    [anon_sym_interface] = ACTIONS(3557),
    [anon_sym_delegate] = ACTIONS(3557),
    [anon_sym_record] = ACTIONS(3557),
    [anon_sym_abstract] = ACTIONS(3557),
    [anon_sym_async] = ACTIONS(3557),
    [anon_sym_const] = ACTIONS(3557),
    [anon_sym_file] = ACTIONS(3557),
    [anon_sym_fixed] = ACTIONS(3557),
    [anon_sym_internal] = ACTIONS(3557),
    [anon_sym_new] = ACTIONS(3557),
    [anon_sym_override] = ACTIONS(3557),
    [anon_sym_partial] = ACTIONS(3557),
    [anon_sym_private] = ACTIONS(3557),
    [anon_sym_protected] = ACTIONS(3557),
    [anon_sym_public] = ACTIONS(3557),
    [anon_sym_readonly] = ACTIONS(3557),
    [anon_sym_required] = ACTIONS(3557),
    [anon_sym_sealed] = ACTIONS(3557),
    [anon_sym_virtual] = ACTIONS(3557),
    [anon_sym_volatile] = ACTIONS(3557),
    [anon_sym_where] = ACTIONS(3557),
    [anon_sym_notnull] = ACTIONS(3557),
    [anon_sym_unmanaged] = ACTIONS(3557),
    [anon_sym_checked] = ACTIONS(3557),
    [anon_sym_BANG] = ACTIONS(3559),
    [anon_sym_TILDE] = ACTIONS(3559),
    [anon_sym_PLUS_PLUS] = ACTIONS(3559),
    [anon_sym_DASH_DASH] = ACTIONS(3559),
    [anon_sym_true] = ACTIONS(3557),
    [anon_sym_false] = ACTIONS(3557),
    [anon_sym_PLUS] = ACTIONS(3557),
    [anon_sym_DASH] = ACTIONS(3557),
    [anon_sym_STAR] = ACTIONS(3559),
    [anon_sym_CARET] = ACTIONS(3559),
    [anon_sym_AMP] = ACTIONS(3559),
    [anon_sym_this] = ACTIONS(3557),
    [anon_sym_scoped] = ACTIONS(3557),
    [anon_sym_var] = ACTIONS(3557),
    [sym_predefined_type] = ACTIONS(3557),
    [anon_sym_break] = ACTIONS(3557),
    [anon_sym_unchecked] = ACTIONS(3557),
    [anon_sym_continue] = ACTIONS(3557),
    [anon_sym_do] = ACTIONS(3557),
    [anon_sym_while] = ACTIONS(3557),
    [anon_sym_for] = ACTIONS(3557),
    [anon_sym_lock] = ACTIONS(3557),
    [anon_sym_yield] = ACTIONS(3557),
    [anon_sym_switch] = ACTIONS(3557),
    [anon_sym_default] = ACTIONS(3557),
    [anon_sym_throw] = ACTIONS(3557),
    [anon_sym_try] = ACTIONS(3557),
    [anon_sym_when] = ACTIONS(3557),
    [anon_sym_await] = ACTIONS(3557),
    [anon_sym_foreach] = ACTIONS(3557),
    [anon_sym_goto] = ACTIONS(3557),
    [anon_sym_if] = ACTIONS(3557),
    [anon_sym_DOT_DOT] = ACTIONS(3559),
    [anon_sym_from] = ACTIONS(3557),
    [anon_sym_into] = ACTIONS(3557),
    [anon_sym_join] = ACTIONS(3557),
    [anon_sym_on] = ACTIONS(3557),
    [anon_sym_equals] = ACTIONS(3557),
    [anon_sym_let] = ACTIONS(3557),
    [anon_sym_orderby] = ACTIONS(3557),
    [anon_sym_ascending] = ACTIONS(3557),
    [anon_sym_descending] = ACTIONS(3557),
    [anon_sym_group] = ACTIONS(3557),
    [anon_sym_by] = ACTIONS(3557),
    [anon_sym_select] = ACTIONS(3557),
    [anon_sym_DQUOTE] = ACTIONS(3557),
    [anon_sym_stackalloc] = ACTIONS(3557),
    [anon_sym_sizeof] = ACTIONS(3557),
    [anon_sym_typeof] = ACTIONS(3557),
    [anon_sym___makeref] = ACTIONS(3557),
    [anon_sym___reftype] = ACTIONS(3557),
    [anon_sym___refvalue] = ACTIONS(3557),
    [sym_null_literal] = ACTIONS(3557),
    [anon_sym_SQUOTE] = ACTIONS(3559),
    [sym_integer_literal] = ACTIONS(3557),
    [sym_real_literal] = ACTIONS(3559),
    [sym_verbatim_string_literal] = ACTIONS(3559),
    [sym_raw_string_literal] = ACTIONS(3559),
    [aux_sym_preproc_if_token1] = ACTIONS(3559),
    [aux_sym_preproc_if_token3] = ACTIONS(3559),
    [aux_sym_preproc_else_token1] = ACTIONS(3559),
    [aux_sym_preproc_elif_token1] = ACTIONS(3559),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3559),
    [sym_interpolation_verbatim_start] = ACTIONS(3559),
    [sym_interpolation_raw_start] = ACTIONS(3559),
  },
  [2333] = {
    [sym_preproc_region] = STATE(2333),
    [sym_preproc_endregion] = STATE(2333),
    [sym_preproc_line] = STATE(2333),
    [sym_preproc_pragma] = STATE(2333),
    [sym_preproc_nullable] = STATE(2333),
    [sym_preproc_error] = STATE(2333),
    [sym_preproc_define] = STATE(2333),
    [sym_preproc_undef] = STATE(2333),
    [sym__identifier_token] = ACTIONS(3561),
    [anon_sym_extern] = ACTIONS(3561),
    [anon_sym_alias] = ACTIONS(3561),
    [anon_sym_SEMI] = ACTIONS(3563),
    [anon_sym_global] = ACTIONS(3561),
    [anon_sym_using] = ACTIONS(3561),
    [anon_sym_unsafe] = ACTIONS(3561),
    [anon_sym_static] = ACTIONS(3561),
    [anon_sym_LBRACK] = ACTIONS(3563),
    [anon_sym_LPAREN] = ACTIONS(3563),
    [anon_sym_return] = ACTIONS(3561),
    [anon_sym_namespace] = ACTIONS(3561),
    [anon_sym_class] = ACTIONS(3561),
    [anon_sym_ref] = ACTIONS(3561),
    [anon_sym_struct] = ACTIONS(3561),
    [anon_sym_enum] = ACTIONS(3561),
    [anon_sym_LBRACE] = ACTIONS(3563),
    [anon_sym_interface] = ACTIONS(3561),
    [anon_sym_delegate] = ACTIONS(3561),
    [anon_sym_record] = ACTIONS(3561),
    [anon_sym_abstract] = ACTIONS(3561),
    [anon_sym_async] = ACTIONS(3561),
    [anon_sym_const] = ACTIONS(3561),
    [anon_sym_file] = ACTIONS(3561),
    [anon_sym_fixed] = ACTIONS(3561),
    [anon_sym_internal] = ACTIONS(3561),
    [anon_sym_new] = ACTIONS(3561),
    [anon_sym_override] = ACTIONS(3561),
    [anon_sym_partial] = ACTIONS(3561),
    [anon_sym_private] = ACTIONS(3561),
    [anon_sym_protected] = ACTIONS(3561),
    [anon_sym_public] = ACTIONS(3561),
    [anon_sym_readonly] = ACTIONS(3561),
    [anon_sym_required] = ACTIONS(3561),
    [anon_sym_sealed] = ACTIONS(3561),
    [anon_sym_virtual] = ACTIONS(3561),
    [anon_sym_volatile] = ACTIONS(3561),
    [anon_sym_where] = ACTIONS(3561),
    [anon_sym_notnull] = ACTIONS(3561),
    [anon_sym_unmanaged] = ACTIONS(3561),
    [anon_sym_checked] = ACTIONS(3561),
    [anon_sym_BANG] = ACTIONS(3563),
    [anon_sym_TILDE] = ACTIONS(3563),
    [anon_sym_PLUS_PLUS] = ACTIONS(3563),
    [anon_sym_DASH_DASH] = ACTIONS(3563),
    [anon_sym_true] = ACTIONS(3561),
    [anon_sym_false] = ACTIONS(3561),
    [anon_sym_PLUS] = ACTIONS(3561),
    [anon_sym_DASH] = ACTIONS(3561),
    [anon_sym_STAR] = ACTIONS(3563),
    [anon_sym_CARET] = ACTIONS(3563),
    [anon_sym_AMP] = ACTIONS(3563),
    [anon_sym_this] = ACTIONS(3561),
    [anon_sym_scoped] = ACTIONS(3561),
    [anon_sym_var] = ACTIONS(3561),
    [sym_predefined_type] = ACTIONS(3561),
    [anon_sym_break] = ACTIONS(3561),
    [anon_sym_unchecked] = ACTIONS(3561),
    [anon_sym_continue] = ACTIONS(3561),
    [anon_sym_do] = ACTIONS(3561),
    [anon_sym_while] = ACTIONS(3561),
    [anon_sym_for] = ACTIONS(3561),
    [anon_sym_lock] = ACTIONS(3561),
    [anon_sym_yield] = ACTIONS(3561),
    [anon_sym_switch] = ACTIONS(3561),
    [anon_sym_default] = ACTIONS(3561),
    [anon_sym_throw] = ACTIONS(3561),
    [anon_sym_try] = ACTIONS(3561),
    [anon_sym_when] = ACTIONS(3561),
    [anon_sym_await] = ACTIONS(3561),
    [anon_sym_foreach] = ACTIONS(3561),
    [anon_sym_goto] = ACTIONS(3561),
    [anon_sym_if] = ACTIONS(3561),
    [anon_sym_DOT_DOT] = ACTIONS(3563),
    [anon_sym_from] = ACTIONS(3561),
    [anon_sym_into] = ACTIONS(3561),
    [anon_sym_join] = ACTIONS(3561),
    [anon_sym_on] = ACTIONS(3561),
    [anon_sym_equals] = ACTIONS(3561),
    [anon_sym_let] = ACTIONS(3561),
    [anon_sym_orderby] = ACTIONS(3561),
    [anon_sym_ascending] = ACTIONS(3561),
    [anon_sym_descending] = ACTIONS(3561),
    [anon_sym_group] = ACTIONS(3561),
    [anon_sym_by] = ACTIONS(3561),
    [anon_sym_select] = ACTIONS(3561),
    [anon_sym_DQUOTE] = ACTIONS(3561),
    [anon_sym_stackalloc] = ACTIONS(3561),
    [anon_sym_sizeof] = ACTIONS(3561),
    [anon_sym_typeof] = ACTIONS(3561),
    [anon_sym___makeref] = ACTIONS(3561),
    [anon_sym___reftype] = ACTIONS(3561),
    [anon_sym___refvalue] = ACTIONS(3561),
    [sym_null_literal] = ACTIONS(3561),
    [anon_sym_SQUOTE] = ACTIONS(3563),
    [sym_integer_literal] = ACTIONS(3561),
    [sym_real_literal] = ACTIONS(3563),
    [sym_verbatim_string_literal] = ACTIONS(3563),
    [sym_raw_string_literal] = ACTIONS(3563),
    [aux_sym_preproc_if_token1] = ACTIONS(3563),
    [aux_sym_preproc_if_token3] = ACTIONS(3563),
    [aux_sym_preproc_else_token1] = ACTIONS(3563),
    [aux_sym_preproc_elif_token1] = ACTIONS(3563),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3563),
    [sym_interpolation_verbatim_start] = ACTIONS(3563),
    [sym_interpolation_raw_start] = ACTIONS(3563),
  },
  [2334] = {
    [sym_preproc_region] = STATE(2334),
    [sym_preproc_endregion] = STATE(2334),
    [sym_preproc_line] = STATE(2334),
    [sym_preproc_pragma] = STATE(2334),
    [sym_preproc_nullable] = STATE(2334),
    [sym_preproc_error] = STATE(2334),
    [sym_preproc_define] = STATE(2334),
    [sym_preproc_undef] = STATE(2334),
    [sym__identifier_token] = ACTIONS(3565),
    [anon_sym_extern] = ACTIONS(3565),
    [anon_sym_alias] = ACTIONS(3565),
    [anon_sym_SEMI] = ACTIONS(3567),
    [anon_sym_global] = ACTIONS(3565),
    [anon_sym_using] = ACTIONS(3565),
    [anon_sym_unsafe] = ACTIONS(3565),
    [anon_sym_static] = ACTIONS(3565),
    [anon_sym_LBRACK] = ACTIONS(3567),
    [anon_sym_LPAREN] = ACTIONS(3567),
    [anon_sym_return] = ACTIONS(3565),
    [anon_sym_namespace] = ACTIONS(3565),
    [anon_sym_class] = ACTIONS(3565),
    [anon_sym_ref] = ACTIONS(3565),
    [anon_sym_struct] = ACTIONS(3565),
    [anon_sym_enum] = ACTIONS(3565),
    [anon_sym_LBRACE] = ACTIONS(3567),
    [anon_sym_interface] = ACTIONS(3565),
    [anon_sym_delegate] = ACTIONS(3565),
    [anon_sym_record] = ACTIONS(3565),
    [anon_sym_abstract] = ACTIONS(3565),
    [anon_sym_async] = ACTIONS(3565),
    [anon_sym_const] = ACTIONS(3565),
    [anon_sym_file] = ACTIONS(3565),
    [anon_sym_fixed] = ACTIONS(3565),
    [anon_sym_internal] = ACTIONS(3565),
    [anon_sym_new] = ACTIONS(3565),
    [anon_sym_override] = ACTIONS(3565),
    [anon_sym_partial] = ACTIONS(3565),
    [anon_sym_private] = ACTIONS(3565),
    [anon_sym_protected] = ACTIONS(3565),
    [anon_sym_public] = ACTIONS(3565),
    [anon_sym_readonly] = ACTIONS(3565),
    [anon_sym_required] = ACTIONS(3565),
    [anon_sym_sealed] = ACTIONS(3565),
    [anon_sym_virtual] = ACTIONS(3565),
    [anon_sym_volatile] = ACTIONS(3565),
    [anon_sym_where] = ACTIONS(3565),
    [anon_sym_notnull] = ACTIONS(3565),
    [anon_sym_unmanaged] = ACTIONS(3565),
    [anon_sym_checked] = ACTIONS(3565),
    [anon_sym_BANG] = ACTIONS(3567),
    [anon_sym_TILDE] = ACTIONS(3567),
    [anon_sym_PLUS_PLUS] = ACTIONS(3567),
    [anon_sym_DASH_DASH] = ACTIONS(3567),
    [anon_sym_true] = ACTIONS(3565),
    [anon_sym_false] = ACTIONS(3565),
    [anon_sym_PLUS] = ACTIONS(3565),
    [anon_sym_DASH] = ACTIONS(3565),
    [anon_sym_STAR] = ACTIONS(3567),
    [anon_sym_CARET] = ACTIONS(3567),
    [anon_sym_AMP] = ACTIONS(3567),
    [anon_sym_this] = ACTIONS(3565),
    [anon_sym_scoped] = ACTIONS(3565),
    [anon_sym_var] = ACTIONS(3565),
    [sym_predefined_type] = ACTIONS(3565),
    [anon_sym_break] = ACTIONS(3565),
    [anon_sym_unchecked] = ACTIONS(3565),
    [anon_sym_continue] = ACTIONS(3565),
    [anon_sym_do] = ACTIONS(3565),
    [anon_sym_while] = ACTIONS(3565),
    [anon_sym_for] = ACTIONS(3565),
    [anon_sym_lock] = ACTIONS(3565),
    [anon_sym_yield] = ACTIONS(3565),
    [anon_sym_switch] = ACTIONS(3565),
    [anon_sym_default] = ACTIONS(3565),
    [anon_sym_throw] = ACTIONS(3565),
    [anon_sym_try] = ACTIONS(3565),
    [anon_sym_when] = ACTIONS(3565),
    [anon_sym_await] = ACTIONS(3565),
    [anon_sym_foreach] = ACTIONS(3565),
    [anon_sym_goto] = ACTIONS(3565),
    [anon_sym_if] = ACTIONS(3565),
    [anon_sym_DOT_DOT] = ACTIONS(3567),
    [anon_sym_from] = ACTIONS(3565),
    [anon_sym_into] = ACTIONS(3565),
    [anon_sym_join] = ACTIONS(3565),
    [anon_sym_on] = ACTIONS(3565),
    [anon_sym_equals] = ACTIONS(3565),
    [anon_sym_let] = ACTIONS(3565),
    [anon_sym_orderby] = ACTIONS(3565),
    [anon_sym_ascending] = ACTIONS(3565),
    [anon_sym_descending] = ACTIONS(3565),
    [anon_sym_group] = ACTIONS(3565),
    [anon_sym_by] = ACTIONS(3565),
    [anon_sym_select] = ACTIONS(3565),
    [anon_sym_DQUOTE] = ACTIONS(3565),
    [anon_sym_stackalloc] = ACTIONS(3565),
    [anon_sym_sizeof] = ACTIONS(3565),
    [anon_sym_typeof] = ACTIONS(3565),
    [anon_sym___makeref] = ACTIONS(3565),
    [anon_sym___reftype] = ACTIONS(3565),
    [anon_sym___refvalue] = ACTIONS(3565),
    [sym_null_literal] = ACTIONS(3565),
    [anon_sym_SQUOTE] = ACTIONS(3567),
    [sym_integer_literal] = ACTIONS(3565),
    [sym_real_literal] = ACTIONS(3567),
    [sym_verbatim_string_literal] = ACTIONS(3567),
    [sym_raw_string_literal] = ACTIONS(3567),
    [aux_sym_preproc_if_token1] = ACTIONS(3567),
    [aux_sym_preproc_if_token3] = ACTIONS(3567),
    [aux_sym_preproc_else_token1] = ACTIONS(3567),
    [aux_sym_preproc_elif_token1] = ACTIONS(3567),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3567),
    [sym_interpolation_verbatim_start] = ACTIONS(3567),
    [sym_interpolation_raw_start] = ACTIONS(3567),
  },
  [2335] = {
    [sym_preproc_region] = STATE(2335),
    [sym_preproc_endregion] = STATE(2335),
    [sym_preproc_line] = STATE(2335),
    [sym_preproc_pragma] = STATE(2335),
    [sym_preproc_nullable] = STATE(2335),
    [sym_preproc_error] = STATE(2335),
    [sym_preproc_define] = STATE(2335),
    [sym_preproc_undef] = STATE(2335),
    [sym__identifier_token] = ACTIONS(3569),
    [anon_sym_extern] = ACTIONS(3569),
    [anon_sym_alias] = ACTIONS(3569),
    [anon_sym_SEMI] = ACTIONS(3571),
    [anon_sym_global] = ACTIONS(3569),
    [anon_sym_using] = ACTIONS(3569),
    [anon_sym_unsafe] = ACTIONS(3569),
    [anon_sym_static] = ACTIONS(3569),
    [anon_sym_LBRACK] = ACTIONS(3571),
    [anon_sym_LPAREN] = ACTIONS(3571),
    [anon_sym_return] = ACTIONS(3569),
    [anon_sym_namespace] = ACTIONS(3569),
    [anon_sym_class] = ACTIONS(3569),
    [anon_sym_ref] = ACTIONS(3569),
    [anon_sym_struct] = ACTIONS(3569),
    [anon_sym_enum] = ACTIONS(3569),
    [anon_sym_LBRACE] = ACTIONS(3571),
    [anon_sym_interface] = ACTIONS(3569),
    [anon_sym_delegate] = ACTIONS(3569),
    [anon_sym_record] = ACTIONS(3569),
    [anon_sym_abstract] = ACTIONS(3569),
    [anon_sym_async] = ACTIONS(3569),
    [anon_sym_const] = ACTIONS(3569),
    [anon_sym_file] = ACTIONS(3569),
    [anon_sym_fixed] = ACTIONS(3569),
    [anon_sym_internal] = ACTIONS(3569),
    [anon_sym_new] = ACTIONS(3569),
    [anon_sym_override] = ACTIONS(3569),
    [anon_sym_partial] = ACTIONS(3569),
    [anon_sym_private] = ACTIONS(3569),
    [anon_sym_protected] = ACTIONS(3569),
    [anon_sym_public] = ACTIONS(3569),
    [anon_sym_readonly] = ACTIONS(3569),
    [anon_sym_required] = ACTIONS(3569),
    [anon_sym_sealed] = ACTIONS(3569),
    [anon_sym_virtual] = ACTIONS(3569),
    [anon_sym_volatile] = ACTIONS(3569),
    [anon_sym_where] = ACTIONS(3569),
    [anon_sym_notnull] = ACTIONS(3569),
    [anon_sym_unmanaged] = ACTIONS(3569),
    [anon_sym_checked] = ACTIONS(3569),
    [anon_sym_BANG] = ACTIONS(3571),
    [anon_sym_TILDE] = ACTIONS(3571),
    [anon_sym_PLUS_PLUS] = ACTIONS(3571),
    [anon_sym_DASH_DASH] = ACTIONS(3571),
    [anon_sym_true] = ACTIONS(3569),
    [anon_sym_false] = ACTIONS(3569),
    [anon_sym_PLUS] = ACTIONS(3569),
    [anon_sym_DASH] = ACTIONS(3569),
    [anon_sym_STAR] = ACTIONS(3571),
    [anon_sym_CARET] = ACTIONS(3571),
    [anon_sym_AMP] = ACTIONS(3571),
    [anon_sym_this] = ACTIONS(3569),
    [anon_sym_scoped] = ACTIONS(3569),
    [anon_sym_var] = ACTIONS(3569),
    [sym_predefined_type] = ACTIONS(3569),
    [anon_sym_break] = ACTIONS(3569),
    [anon_sym_unchecked] = ACTIONS(3569),
    [anon_sym_continue] = ACTIONS(3569),
    [anon_sym_do] = ACTIONS(3569),
    [anon_sym_while] = ACTIONS(3569),
    [anon_sym_for] = ACTIONS(3569),
    [anon_sym_lock] = ACTIONS(3569),
    [anon_sym_yield] = ACTIONS(3569),
    [anon_sym_switch] = ACTIONS(3569),
    [anon_sym_default] = ACTIONS(3569),
    [anon_sym_throw] = ACTIONS(3569),
    [anon_sym_try] = ACTIONS(3569),
    [anon_sym_when] = ACTIONS(3569),
    [anon_sym_await] = ACTIONS(3569),
    [anon_sym_foreach] = ACTIONS(3569),
    [anon_sym_goto] = ACTIONS(3569),
    [anon_sym_if] = ACTIONS(3569),
    [anon_sym_DOT_DOT] = ACTIONS(3571),
    [anon_sym_from] = ACTIONS(3569),
    [anon_sym_into] = ACTIONS(3569),
    [anon_sym_join] = ACTIONS(3569),
    [anon_sym_on] = ACTIONS(3569),
    [anon_sym_equals] = ACTIONS(3569),
    [anon_sym_let] = ACTIONS(3569),
    [anon_sym_orderby] = ACTIONS(3569),
    [anon_sym_ascending] = ACTIONS(3569),
    [anon_sym_descending] = ACTIONS(3569),
    [anon_sym_group] = ACTIONS(3569),
    [anon_sym_by] = ACTIONS(3569),
    [anon_sym_select] = ACTIONS(3569),
    [anon_sym_DQUOTE] = ACTIONS(3569),
    [anon_sym_stackalloc] = ACTIONS(3569),
    [anon_sym_sizeof] = ACTIONS(3569),
    [anon_sym_typeof] = ACTIONS(3569),
    [anon_sym___makeref] = ACTIONS(3569),
    [anon_sym___reftype] = ACTIONS(3569),
    [anon_sym___refvalue] = ACTIONS(3569),
    [sym_null_literal] = ACTIONS(3569),
    [anon_sym_SQUOTE] = ACTIONS(3571),
    [sym_integer_literal] = ACTIONS(3569),
    [sym_real_literal] = ACTIONS(3571),
    [sym_verbatim_string_literal] = ACTIONS(3571),
    [sym_raw_string_literal] = ACTIONS(3571),
    [aux_sym_preproc_if_token1] = ACTIONS(3571),
    [aux_sym_preproc_if_token3] = ACTIONS(3571),
    [aux_sym_preproc_else_token1] = ACTIONS(3571),
    [aux_sym_preproc_elif_token1] = ACTIONS(3571),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3571),
    [sym_interpolation_verbatim_start] = ACTIONS(3571),
    [sym_interpolation_raw_start] = ACTIONS(3571),
  },
  [2336] = {
    [sym_preproc_region] = STATE(2336),
    [sym_preproc_endregion] = STATE(2336),
    [sym_preproc_line] = STATE(2336),
    [sym_preproc_pragma] = STATE(2336),
    [sym_preproc_nullable] = STATE(2336),
    [sym_preproc_error] = STATE(2336),
    [sym_preproc_define] = STATE(2336),
    [sym_preproc_undef] = STATE(2336),
    [sym__identifier_token] = ACTIONS(3573),
    [anon_sym_extern] = ACTIONS(3573),
    [anon_sym_alias] = ACTIONS(3573),
    [anon_sym_SEMI] = ACTIONS(3575),
    [anon_sym_global] = ACTIONS(3573),
    [anon_sym_using] = ACTIONS(3573),
    [anon_sym_unsafe] = ACTIONS(3573),
    [anon_sym_static] = ACTIONS(3573),
    [anon_sym_LBRACK] = ACTIONS(3575),
    [anon_sym_LPAREN] = ACTIONS(3575),
    [anon_sym_return] = ACTIONS(3573),
    [anon_sym_namespace] = ACTIONS(3573),
    [anon_sym_class] = ACTIONS(3573),
    [anon_sym_ref] = ACTIONS(3573),
    [anon_sym_struct] = ACTIONS(3573),
    [anon_sym_enum] = ACTIONS(3573),
    [anon_sym_LBRACE] = ACTIONS(3575),
    [anon_sym_interface] = ACTIONS(3573),
    [anon_sym_delegate] = ACTIONS(3573),
    [anon_sym_record] = ACTIONS(3573),
    [anon_sym_abstract] = ACTIONS(3573),
    [anon_sym_async] = ACTIONS(3573),
    [anon_sym_const] = ACTIONS(3573),
    [anon_sym_file] = ACTIONS(3573),
    [anon_sym_fixed] = ACTIONS(3573),
    [anon_sym_internal] = ACTIONS(3573),
    [anon_sym_new] = ACTIONS(3573),
    [anon_sym_override] = ACTIONS(3573),
    [anon_sym_partial] = ACTIONS(3573),
    [anon_sym_private] = ACTIONS(3573),
    [anon_sym_protected] = ACTIONS(3573),
    [anon_sym_public] = ACTIONS(3573),
    [anon_sym_readonly] = ACTIONS(3573),
    [anon_sym_required] = ACTIONS(3573),
    [anon_sym_sealed] = ACTIONS(3573),
    [anon_sym_virtual] = ACTIONS(3573),
    [anon_sym_volatile] = ACTIONS(3573),
    [anon_sym_where] = ACTIONS(3573),
    [anon_sym_notnull] = ACTIONS(3573),
    [anon_sym_unmanaged] = ACTIONS(3573),
    [anon_sym_checked] = ACTIONS(3573),
    [anon_sym_BANG] = ACTIONS(3575),
    [anon_sym_TILDE] = ACTIONS(3575),
    [anon_sym_PLUS_PLUS] = ACTIONS(3575),
    [anon_sym_DASH_DASH] = ACTIONS(3575),
    [anon_sym_true] = ACTIONS(3573),
    [anon_sym_false] = ACTIONS(3573),
    [anon_sym_PLUS] = ACTIONS(3573),
    [anon_sym_DASH] = ACTIONS(3573),
    [anon_sym_STAR] = ACTIONS(3575),
    [anon_sym_CARET] = ACTIONS(3575),
    [anon_sym_AMP] = ACTIONS(3575),
    [anon_sym_this] = ACTIONS(3573),
    [anon_sym_scoped] = ACTIONS(3573),
    [anon_sym_var] = ACTIONS(3573),
    [sym_predefined_type] = ACTIONS(3573),
    [anon_sym_break] = ACTIONS(3573),
    [anon_sym_unchecked] = ACTIONS(3573),
    [anon_sym_continue] = ACTIONS(3573),
    [anon_sym_do] = ACTIONS(3573),
    [anon_sym_while] = ACTIONS(3573),
    [anon_sym_for] = ACTIONS(3573),
    [anon_sym_lock] = ACTIONS(3573),
    [anon_sym_yield] = ACTIONS(3573),
    [anon_sym_switch] = ACTIONS(3573),
    [anon_sym_default] = ACTIONS(3573),
    [anon_sym_throw] = ACTIONS(3573),
    [anon_sym_try] = ACTIONS(3573),
    [anon_sym_when] = ACTIONS(3573),
    [anon_sym_await] = ACTIONS(3573),
    [anon_sym_foreach] = ACTIONS(3573),
    [anon_sym_goto] = ACTIONS(3573),
    [anon_sym_if] = ACTIONS(3573),
    [anon_sym_DOT_DOT] = ACTIONS(3575),
    [anon_sym_from] = ACTIONS(3573),
    [anon_sym_into] = ACTIONS(3573),
    [anon_sym_join] = ACTIONS(3573),
    [anon_sym_on] = ACTIONS(3573),
    [anon_sym_equals] = ACTIONS(3573),
    [anon_sym_let] = ACTIONS(3573),
    [anon_sym_orderby] = ACTIONS(3573),
    [anon_sym_ascending] = ACTIONS(3573),
    [anon_sym_descending] = ACTIONS(3573),
    [anon_sym_group] = ACTIONS(3573),
    [anon_sym_by] = ACTIONS(3573),
    [anon_sym_select] = ACTIONS(3573),
    [anon_sym_DQUOTE] = ACTIONS(3573),
    [anon_sym_stackalloc] = ACTIONS(3573),
    [anon_sym_sizeof] = ACTIONS(3573),
    [anon_sym_typeof] = ACTIONS(3573),
    [anon_sym___makeref] = ACTIONS(3573),
    [anon_sym___reftype] = ACTIONS(3573),
    [anon_sym___refvalue] = ACTIONS(3573),
    [sym_null_literal] = ACTIONS(3573),
    [anon_sym_SQUOTE] = ACTIONS(3575),
    [sym_integer_literal] = ACTIONS(3573),
    [sym_real_literal] = ACTIONS(3575),
    [sym_verbatim_string_literal] = ACTIONS(3575),
    [sym_raw_string_literal] = ACTIONS(3575),
    [aux_sym_preproc_if_token1] = ACTIONS(3575),
    [aux_sym_preproc_if_token3] = ACTIONS(3575),
    [aux_sym_preproc_else_token1] = ACTIONS(3575),
    [aux_sym_preproc_elif_token1] = ACTIONS(3575),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3575),
    [sym_interpolation_verbatim_start] = ACTIONS(3575),
    [sym_interpolation_raw_start] = ACTIONS(3575),
  },
  [2337] = {
    [sym_preproc_region] = STATE(2337),
    [sym_preproc_endregion] = STATE(2337),
    [sym_preproc_line] = STATE(2337),
    [sym_preproc_pragma] = STATE(2337),
    [sym_preproc_nullable] = STATE(2337),
    [sym_preproc_error] = STATE(2337),
    [sym_preproc_define] = STATE(2337),
    [sym_preproc_undef] = STATE(2337),
    [sym__identifier_token] = ACTIONS(3577),
    [anon_sym_extern] = ACTIONS(3577),
    [anon_sym_alias] = ACTIONS(3577),
    [anon_sym_SEMI] = ACTIONS(3579),
    [anon_sym_global] = ACTIONS(3577),
    [anon_sym_using] = ACTIONS(3577),
    [anon_sym_unsafe] = ACTIONS(3577),
    [anon_sym_static] = ACTIONS(3577),
    [anon_sym_LBRACK] = ACTIONS(3579),
    [anon_sym_LPAREN] = ACTIONS(3579),
    [anon_sym_return] = ACTIONS(3577),
    [anon_sym_namespace] = ACTIONS(3577),
    [anon_sym_class] = ACTIONS(3577),
    [anon_sym_ref] = ACTIONS(3577),
    [anon_sym_struct] = ACTIONS(3577),
    [anon_sym_enum] = ACTIONS(3577),
    [anon_sym_LBRACE] = ACTIONS(3579),
    [anon_sym_interface] = ACTIONS(3577),
    [anon_sym_delegate] = ACTIONS(3577),
    [anon_sym_record] = ACTIONS(3577),
    [anon_sym_abstract] = ACTIONS(3577),
    [anon_sym_async] = ACTIONS(3577),
    [anon_sym_const] = ACTIONS(3577),
    [anon_sym_file] = ACTIONS(3577),
    [anon_sym_fixed] = ACTIONS(3577),
    [anon_sym_internal] = ACTIONS(3577),
    [anon_sym_new] = ACTIONS(3577),
    [anon_sym_override] = ACTIONS(3577),
    [anon_sym_partial] = ACTIONS(3577),
    [anon_sym_private] = ACTIONS(3577),
    [anon_sym_protected] = ACTIONS(3577),
    [anon_sym_public] = ACTIONS(3577),
    [anon_sym_readonly] = ACTIONS(3577),
    [anon_sym_required] = ACTIONS(3577),
    [anon_sym_sealed] = ACTIONS(3577),
    [anon_sym_virtual] = ACTIONS(3577),
    [anon_sym_volatile] = ACTIONS(3577),
    [anon_sym_where] = ACTIONS(3577),
    [anon_sym_notnull] = ACTIONS(3577),
    [anon_sym_unmanaged] = ACTIONS(3577),
    [anon_sym_checked] = ACTIONS(3577),
    [anon_sym_BANG] = ACTIONS(3579),
    [anon_sym_TILDE] = ACTIONS(3579),
    [anon_sym_PLUS_PLUS] = ACTIONS(3579),
    [anon_sym_DASH_DASH] = ACTIONS(3579),
    [anon_sym_true] = ACTIONS(3577),
    [anon_sym_false] = ACTIONS(3577),
    [anon_sym_PLUS] = ACTIONS(3577),
    [anon_sym_DASH] = ACTIONS(3577),
    [anon_sym_STAR] = ACTIONS(3579),
    [anon_sym_CARET] = ACTIONS(3579),
    [anon_sym_AMP] = ACTIONS(3579),
    [anon_sym_this] = ACTIONS(3577),
    [anon_sym_scoped] = ACTIONS(3577),
    [anon_sym_var] = ACTIONS(3577),
    [sym_predefined_type] = ACTIONS(3577),
    [anon_sym_break] = ACTIONS(3577),
    [anon_sym_unchecked] = ACTIONS(3577),
    [anon_sym_continue] = ACTIONS(3577),
    [anon_sym_do] = ACTIONS(3577),
    [anon_sym_while] = ACTIONS(3577),
    [anon_sym_for] = ACTIONS(3577),
    [anon_sym_lock] = ACTIONS(3577),
    [anon_sym_yield] = ACTIONS(3577),
    [anon_sym_switch] = ACTIONS(3577),
    [anon_sym_default] = ACTIONS(3577),
    [anon_sym_throw] = ACTIONS(3577),
    [anon_sym_try] = ACTIONS(3577),
    [anon_sym_when] = ACTIONS(3577),
    [anon_sym_await] = ACTIONS(3577),
    [anon_sym_foreach] = ACTIONS(3577),
    [anon_sym_goto] = ACTIONS(3577),
    [anon_sym_if] = ACTIONS(3577),
    [anon_sym_DOT_DOT] = ACTIONS(3579),
    [anon_sym_from] = ACTIONS(3577),
    [anon_sym_into] = ACTIONS(3577),
    [anon_sym_join] = ACTIONS(3577),
    [anon_sym_on] = ACTIONS(3577),
    [anon_sym_equals] = ACTIONS(3577),
    [anon_sym_let] = ACTIONS(3577),
    [anon_sym_orderby] = ACTIONS(3577),
    [anon_sym_ascending] = ACTIONS(3577),
    [anon_sym_descending] = ACTIONS(3577),
    [anon_sym_group] = ACTIONS(3577),
    [anon_sym_by] = ACTIONS(3577),
    [anon_sym_select] = ACTIONS(3577),
    [anon_sym_DQUOTE] = ACTIONS(3577),
    [anon_sym_stackalloc] = ACTIONS(3577),
    [anon_sym_sizeof] = ACTIONS(3577),
    [anon_sym_typeof] = ACTIONS(3577),
    [anon_sym___makeref] = ACTIONS(3577),
    [anon_sym___reftype] = ACTIONS(3577),
    [anon_sym___refvalue] = ACTIONS(3577),
    [sym_null_literal] = ACTIONS(3577),
    [anon_sym_SQUOTE] = ACTIONS(3579),
    [sym_integer_literal] = ACTIONS(3577),
    [sym_real_literal] = ACTIONS(3579),
    [sym_verbatim_string_literal] = ACTIONS(3579),
    [sym_raw_string_literal] = ACTIONS(3579),
    [aux_sym_preproc_if_token1] = ACTIONS(3579),
    [aux_sym_preproc_if_token3] = ACTIONS(3579),
    [aux_sym_preproc_else_token1] = ACTIONS(3579),
    [aux_sym_preproc_elif_token1] = ACTIONS(3579),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3579),
    [sym_interpolation_verbatim_start] = ACTIONS(3579),
    [sym_interpolation_raw_start] = ACTIONS(3579),
  },
  [2338] = {
    [sym_preproc_region] = STATE(2338),
    [sym_preproc_endregion] = STATE(2338),
    [sym_preproc_line] = STATE(2338),
    [sym_preproc_pragma] = STATE(2338),
    [sym_preproc_nullable] = STATE(2338),
    [sym_preproc_error] = STATE(2338),
    [sym_preproc_define] = STATE(2338),
    [sym_preproc_undef] = STATE(2338),
    [sym__identifier_token] = ACTIONS(3581),
    [anon_sym_extern] = ACTIONS(3581),
    [anon_sym_alias] = ACTIONS(3581),
    [anon_sym_SEMI] = ACTIONS(3583),
    [anon_sym_global] = ACTIONS(3581),
    [anon_sym_using] = ACTIONS(3581),
    [anon_sym_unsafe] = ACTIONS(3581),
    [anon_sym_static] = ACTIONS(3581),
    [anon_sym_LBRACK] = ACTIONS(3583),
    [anon_sym_LPAREN] = ACTIONS(3583),
    [anon_sym_return] = ACTIONS(3581),
    [anon_sym_namespace] = ACTIONS(3581),
    [anon_sym_class] = ACTIONS(3581),
    [anon_sym_ref] = ACTIONS(3581),
    [anon_sym_struct] = ACTIONS(3581),
    [anon_sym_enum] = ACTIONS(3581),
    [anon_sym_LBRACE] = ACTIONS(3583),
    [anon_sym_interface] = ACTIONS(3581),
    [anon_sym_delegate] = ACTIONS(3581),
    [anon_sym_record] = ACTIONS(3581),
    [anon_sym_abstract] = ACTIONS(3581),
    [anon_sym_async] = ACTIONS(3581),
    [anon_sym_const] = ACTIONS(3581),
    [anon_sym_file] = ACTIONS(3581),
    [anon_sym_fixed] = ACTIONS(3581),
    [anon_sym_internal] = ACTIONS(3581),
    [anon_sym_new] = ACTIONS(3581),
    [anon_sym_override] = ACTIONS(3581),
    [anon_sym_partial] = ACTIONS(3581),
    [anon_sym_private] = ACTIONS(3581),
    [anon_sym_protected] = ACTIONS(3581),
    [anon_sym_public] = ACTIONS(3581),
    [anon_sym_readonly] = ACTIONS(3581),
    [anon_sym_required] = ACTIONS(3581),
    [anon_sym_sealed] = ACTIONS(3581),
    [anon_sym_virtual] = ACTIONS(3581),
    [anon_sym_volatile] = ACTIONS(3581),
    [anon_sym_where] = ACTIONS(3581),
    [anon_sym_notnull] = ACTIONS(3581),
    [anon_sym_unmanaged] = ACTIONS(3581),
    [anon_sym_checked] = ACTIONS(3581),
    [anon_sym_BANG] = ACTIONS(3583),
    [anon_sym_TILDE] = ACTIONS(3583),
    [anon_sym_PLUS_PLUS] = ACTIONS(3583),
    [anon_sym_DASH_DASH] = ACTIONS(3583),
    [anon_sym_true] = ACTIONS(3581),
    [anon_sym_false] = ACTIONS(3581),
    [anon_sym_PLUS] = ACTIONS(3581),
    [anon_sym_DASH] = ACTIONS(3581),
    [anon_sym_STAR] = ACTIONS(3583),
    [anon_sym_CARET] = ACTIONS(3583),
    [anon_sym_AMP] = ACTIONS(3583),
    [anon_sym_this] = ACTIONS(3581),
    [anon_sym_scoped] = ACTIONS(3581),
    [anon_sym_var] = ACTIONS(3581),
    [sym_predefined_type] = ACTIONS(3581),
    [anon_sym_break] = ACTIONS(3581),
    [anon_sym_unchecked] = ACTIONS(3581),
    [anon_sym_continue] = ACTIONS(3581),
    [anon_sym_do] = ACTIONS(3581),
    [anon_sym_while] = ACTIONS(3581),
    [anon_sym_for] = ACTIONS(3581),
    [anon_sym_lock] = ACTIONS(3581),
    [anon_sym_yield] = ACTIONS(3581),
    [anon_sym_switch] = ACTIONS(3581),
    [anon_sym_default] = ACTIONS(3581),
    [anon_sym_throw] = ACTIONS(3581),
    [anon_sym_try] = ACTIONS(3581),
    [anon_sym_when] = ACTIONS(3581),
    [anon_sym_await] = ACTIONS(3581),
    [anon_sym_foreach] = ACTIONS(3581),
    [anon_sym_goto] = ACTIONS(3581),
    [anon_sym_if] = ACTIONS(3581),
    [anon_sym_DOT_DOT] = ACTIONS(3583),
    [anon_sym_from] = ACTIONS(3581),
    [anon_sym_into] = ACTIONS(3581),
    [anon_sym_join] = ACTIONS(3581),
    [anon_sym_on] = ACTIONS(3581),
    [anon_sym_equals] = ACTIONS(3581),
    [anon_sym_let] = ACTIONS(3581),
    [anon_sym_orderby] = ACTIONS(3581),
    [anon_sym_ascending] = ACTIONS(3581),
    [anon_sym_descending] = ACTIONS(3581),
    [anon_sym_group] = ACTIONS(3581),
    [anon_sym_by] = ACTIONS(3581),
    [anon_sym_select] = ACTIONS(3581),
    [anon_sym_DQUOTE] = ACTIONS(3581),
    [anon_sym_stackalloc] = ACTIONS(3581),
    [anon_sym_sizeof] = ACTIONS(3581),
    [anon_sym_typeof] = ACTIONS(3581),
    [anon_sym___makeref] = ACTIONS(3581),
    [anon_sym___reftype] = ACTIONS(3581),
    [anon_sym___refvalue] = ACTIONS(3581),
    [sym_null_literal] = ACTIONS(3581),
    [anon_sym_SQUOTE] = ACTIONS(3583),
    [sym_integer_literal] = ACTIONS(3581),
    [sym_real_literal] = ACTIONS(3583),
    [sym_verbatim_string_literal] = ACTIONS(3583),
    [sym_raw_string_literal] = ACTIONS(3583),
    [aux_sym_preproc_if_token1] = ACTIONS(3583),
    [aux_sym_preproc_if_token3] = ACTIONS(3583),
    [aux_sym_preproc_else_token1] = ACTIONS(3583),
    [aux_sym_preproc_elif_token1] = ACTIONS(3583),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3583),
    [sym_interpolation_verbatim_start] = ACTIONS(3583),
    [sym_interpolation_raw_start] = ACTIONS(3583),
  },
  [2339] = {
    [sym_preproc_region] = STATE(2339),
    [sym_preproc_endregion] = STATE(2339),
    [sym_preproc_line] = STATE(2339),
    [sym_preproc_pragma] = STATE(2339),
    [sym_preproc_nullable] = STATE(2339),
    [sym_preproc_error] = STATE(2339),
    [sym_preproc_define] = STATE(2339),
    [sym_preproc_undef] = STATE(2339),
    [sym__identifier_token] = ACTIONS(3585),
    [anon_sym_extern] = ACTIONS(3585),
    [anon_sym_alias] = ACTIONS(3585),
    [anon_sym_SEMI] = ACTIONS(3587),
    [anon_sym_global] = ACTIONS(3585),
    [anon_sym_using] = ACTIONS(3585),
    [anon_sym_unsafe] = ACTIONS(3585),
    [anon_sym_static] = ACTIONS(3585),
    [anon_sym_LBRACK] = ACTIONS(3587),
    [anon_sym_LPAREN] = ACTIONS(3587),
    [anon_sym_return] = ACTIONS(3585),
    [anon_sym_namespace] = ACTIONS(3585),
    [anon_sym_class] = ACTIONS(3585),
    [anon_sym_ref] = ACTIONS(3585),
    [anon_sym_struct] = ACTIONS(3585),
    [anon_sym_enum] = ACTIONS(3585),
    [anon_sym_LBRACE] = ACTIONS(3587),
    [anon_sym_interface] = ACTIONS(3585),
    [anon_sym_delegate] = ACTIONS(3585),
    [anon_sym_record] = ACTIONS(3585),
    [anon_sym_abstract] = ACTIONS(3585),
    [anon_sym_async] = ACTIONS(3585),
    [anon_sym_const] = ACTIONS(3585),
    [anon_sym_file] = ACTIONS(3585),
    [anon_sym_fixed] = ACTIONS(3585),
    [anon_sym_internal] = ACTIONS(3585),
    [anon_sym_new] = ACTIONS(3585),
    [anon_sym_override] = ACTIONS(3585),
    [anon_sym_partial] = ACTIONS(3585),
    [anon_sym_private] = ACTIONS(3585),
    [anon_sym_protected] = ACTIONS(3585),
    [anon_sym_public] = ACTIONS(3585),
    [anon_sym_readonly] = ACTIONS(3585),
    [anon_sym_required] = ACTIONS(3585),
    [anon_sym_sealed] = ACTIONS(3585),
    [anon_sym_virtual] = ACTIONS(3585),
    [anon_sym_volatile] = ACTIONS(3585),
    [anon_sym_where] = ACTIONS(3585),
    [anon_sym_notnull] = ACTIONS(3585),
    [anon_sym_unmanaged] = ACTIONS(3585),
    [anon_sym_checked] = ACTIONS(3585),
    [anon_sym_BANG] = ACTIONS(3587),
    [anon_sym_TILDE] = ACTIONS(3587),
    [anon_sym_PLUS_PLUS] = ACTIONS(3587),
    [anon_sym_DASH_DASH] = ACTIONS(3587),
    [anon_sym_true] = ACTIONS(3585),
    [anon_sym_false] = ACTIONS(3585),
    [anon_sym_PLUS] = ACTIONS(3585),
    [anon_sym_DASH] = ACTIONS(3585),
    [anon_sym_STAR] = ACTIONS(3587),
    [anon_sym_CARET] = ACTIONS(3587),
    [anon_sym_AMP] = ACTIONS(3587),
    [anon_sym_this] = ACTIONS(3585),
    [anon_sym_scoped] = ACTIONS(3585),
    [anon_sym_var] = ACTIONS(3585),
    [sym_predefined_type] = ACTIONS(3585),
    [anon_sym_break] = ACTIONS(3585),
    [anon_sym_unchecked] = ACTIONS(3585),
    [anon_sym_continue] = ACTIONS(3585),
    [anon_sym_do] = ACTIONS(3585),
    [anon_sym_while] = ACTIONS(3585),
    [anon_sym_for] = ACTIONS(3585),
    [anon_sym_lock] = ACTIONS(3585),
    [anon_sym_yield] = ACTIONS(3585),
    [anon_sym_switch] = ACTIONS(3585),
    [anon_sym_default] = ACTIONS(3585),
    [anon_sym_throw] = ACTIONS(3585),
    [anon_sym_try] = ACTIONS(3585),
    [anon_sym_when] = ACTIONS(3585),
    [anon_sym_await] = ACTIONS(3585),
    [anon_sym_foreach] = ACTIONS(3585),
    [anon_sym_goto] = ACTIONS(3585),
    [anon_sym_if] = ACTIONS(3585),
    [anon_sym_DOT_DOT] = ACTIONS(3587),
    [anon_sym_from] = ACTIONS(3585),
    [anon_sym_into] = ACTIONS(3585),
    [anon_sym_join] = ACTIONS(3585),
    [anon_sym_on] = ACTIONS(3585),
    [anon_sym_equals] = ACTIONS(3585),
    [anon_sym_let] = ACTIONS(3585),
    [anon_sym_orderby] = ACTIONS(3585),
    [anon_sym_ascending] = ACTIONS(3585),
    [anon_sym_descending] = ACTIONS(3585),
    [anon_sym_group] = ACTIONS(3585),
    [anon_sym_by] = ACTIONS(3585),
    [anon_sym_select] = ACTIONS(3585),
    [anon_sym_DQUOTE] = ACTIONS(3585),
    [anon_sym_stackalloc] = ACTIONS(3585),
    [anon_sym_sizeof] = ACTIONS(3585),
    [anon_sym_typeof] = ACTIONS(3585),
    [anon_sym___makeref] = ACTIONS(3585),
    [anon_sym___reftype] = ACTIONS(3585),
    [anon_sym___refvalue] = ACTIONS(3585),
    [sym_null_literal] = ACTIONS(3585),
    [anon_sym_SQUOTE] = ACTIONS(3587),
    [sym_integer_literal] = ACTIONS(3585),
    [sym_real_literal] = ACTIONS(3587),
    [sym_verbatim_string_literal] = ACTIONS(3587),
    [sym_raw_string_literal] = ACTIONS(3587),
    [aux_sym_preproc_if_token1] = ACTIONS(3587),
    [aux_sym_preproc_if_token3] = ACTIONS(3587),
    [aux_sym_preproc_else_token1] = ACTIONS(3587),
    [aux_sym_preproc_elif_token1] = ACTIONS(3587),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3587),
    [sym_interpolation_verbatim_start] = ACTIONS(3587),
    [sym_interpolation_raw_start] = ACTIONS(3587),
  },
  [2340] = {
    [sym_preproc_region] = STATE(2340),
    [sym_preproc_endregion] = STATE(2340),
    [sym_preproc_line] = STATE(2340),
    [sym_preproc_pragma] = STATE(2340),
    [sym_preproc_nullable] = STATE(2340),
    [sym_preproc_error] = STATE(2340),
    [sym_preproc_define] = STATE(2340),
    [sym_preproc_undef] = STATE(2340),
    [sym__identifier_token] = ACTIONS(3589),
    [anon_sym_extern] = ACTIONS(3589),
    [anon_sym_alias] = ACTIONS(3589),
    [anon_sym_SEMI] = ACTIONS(3591),
    [anon_sym_global] = ACTIONS(3589),
    [anon_sym_using] = ACTIONS(3589),
    [anon_sym_unsafe] = ACTIONS(3589),
    [anon_sym_static] = ACTIONS(3589),
    [anon_sym_LBRACK] = ACTIONS(3591),
    [anon_sym_LPAREN] = ACTIONS(3591),
    [anon_sym_return] = ACTIONS(3589),
    [anon_sym_namespace] = ACTIONS(3589),
    [anon_sym_class] = ACTIONS(3589),
    [anon_sym_ref] = ACTIONS(3589),
    [anon_sym_struct] = ACTIONS(3589),
    [anon_sym_enum] = ACTIONS(3589),
    [anon_sym_LBRACE] = ACTIONS(3591),
    [anon_sym_interface] = ACTIONS(3589),
    [anon_sym_delegate] = ACTIONS(3589),
    [anon_sym_record] = ACTIONS(3589),
    [anon_sym_abstract] = ACTIONS(3589),
    [anon_sym_async] = ACTIONS(3589),
    [anon_sym_const] = ACTIONS(3589),
    [anon_sym_file] = ACTIONS(3589),
    [anon_sym_fixed] = ACTIONS(3589),
    [anon_sym_internal] = ACTIONS(3589),
    [anon_sym_new] = ACTIONS(3589),
    [anon_sym_override] = ACTIONS(3589),
    [anon_sym_partial] = ACTIONS(3589),
    [anon_sym_private] = ACTIONS(3589),
    [anon_sym_protected] = ACTIONS(3589),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_readonly] = ACTIONS(3589),
    [anon_sym_required] = ACTIONS(3589),
    [anon_sym_sealed] = ACTIONS(3589),
    [anon_sym_virtual] = ACTIONS(3589),
    [anon_sym_volatile] = ACTIONS(3589),
    [anon_sym_where] = ACTIONS(3589),
    [anon_sym_notnull] = ACTIONS(3589),
    [anon_sym_unmanaged] = ACTIONS(3589),
    [anon_sym_checked] = ACTIONS(3589),
    [anon_sym_BANG] = ACTIONS(3591),
    [anon_sym_TILDE] = ACTIONS(3591),
    [anon_sym_PLUS_PLUS] = ACTIONS(3591),
    [anon_sym_DASH_DASH] = ACTIONS(3591),
    [anon_sym_true] = ACTIONS(3589),
    [anon_sym_false] = ACTIONS(3589),
    [anon_sym_PLUS] = ACTIONS(3589),
    [anon_sym_DASH] = ACTIONS(3589),
    [anon_sym_STAR] = ACTIONS(3591),
    [anon_sym_CARET] = ACTIONS(3591),
    [anon_sym_AMP] = ACTIONS(3591),
    [anon_sym_this] = ACTIONS(3589),
    [anon_sym_scoped] = ACTIONS(3589),
    [anon_sym_var] = ACTIONS(3589),
    [sym_predefined_type] = ACTIONS(3589),
    [anon_sym_break] = ACTIONS(3589),
    [anon_sym_unchecked] = ACTIONS(3589),
    [anon_sym_continue] = ACTIONS(3589),
    [anon_sym_do] = ACTIONS(3589),
    [anon_sym_while] = ACTIONS(3589),
    [anon_sym_for] = ACTIONS(3589),
    [anon_sym_lock] = ACTIONS(3589),
    [anon_sym_yield] = ACTIONS(3589),
    [anon_sym_switch] = ACTIONS(3589),
    [anon_sym_default] = ACTIONS(3589),
    [anon_sym_throw] = ACTIONS(3589),
    [anon_sym_try] = ACTIONS(3589),
    [anon_sym_when] = ACTIONS(3589),
    [anon_sym_await] = ACTIONS(3589),
    [anon_sym_foreach] = ACTIONS(3589),
    [anon_sym_goto] = ACTIONS(3589),
    [anon_sym_if] = ACTIONS(3589),
    [anon_sym_DOT_DOT] = ACTIONS(3591),
    [anon_sym_from] = ACTIONS(3589),
    [anon_sym_into] = ACTIONS(3589),
    [anon_sym_join] = ACTIONS(3589),
    [anon_sym_on] = ACTIONS(3589),
    [anon_sym_equals] = ACTIONS(3589),
    [anon_sym_let] = ACTIONS(3589),
    [anon_sym_orderby] = ACTIONS(3589),
    [anon_sym_ascending] = ACTIONS(3589),
    [anon_sym_descending] = ACTIONS(3589),
    [anon_sym_group] = ACTIONS(3589),
    [anon_sym_by] = ACTIONS(3589),
    [anon_sym_select] = ACTIONS(3589),
    [anon_sym_DQUOTE] = ACTIONS(3589),
    [anon_sym_stackalloc] = ACTIONS(3589),
    [anon_sym_sizeof] = ACTIONS(3589),
    [anon_sym_typeof] = ACTIONS(3589),
    [anon_sym___makeref] = ACTIONS(3589),
    [anon_sym___reftype] = ACTIONS(3589),
    [anon_sym___refvalue] = ACTIONS(3589),
    [sym_null_literal] = ACTIONS(3589),
    [anon_sym_SQUOTE] = ACTIONS(3591),
    [sym_integer_literal] = ACTIONS(3589),
    [sym_real_literal] = ACTIONS(3591),
    [sym_verbatim_string_literal] = ACTIONS(3591),
    [sym_raw_string_literal] = ACTIONS(3591),
    [aux_sym_preproc_if_token1] = ACTIONS(3591),
    [aux_sym_preproc_if_token3] = ACTIONS(3591),
    [aux_sym_preproc_else_token1] = ACTIONS(3591),
    [aux_sym_preproc_elif_token1] = ACTIONS(3591),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3591),
    [sym_interpolation_verbatim_start] = ACTIONS(3591),
    [sym_interpolation_raw_start] = ACTIONS(3591),
  },
  [2341] = {
    [sym_preproc_region] = STATE(2341),
    [sym_preproc_endregion] = STATE(2341),
    [sym_preproc_line] = STATE(2341),
    [sym_preproc_pragma] = STATE(2341),
    [sym_preproc_nullable] = STATE(2341),
    [sym_preproc_error] = STATE(2341),
    [sym_preproc_define] = STATE(2341),
    [sym_preproc_undef] = STATE(2341),
    [sym__identifier_token] = ACTIONS(3593),
    [anon_sym_extern] = ACTIONS(3593),
    [anon_sym_alias] = ACTIONS(3593),
    [anon_sym_SEMI] = ACTIONS(3595),
    [anon_sym_global] = ACTIONS(3593),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_unsafe] = ACTIONS(3593),
    [anon_sym_static] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(3595),
    [anon_sym_LPAREN] = ACTIONS(3595),
    [anon_sym_return] = ACTIONS(3593),
    [anon_sym_namespace] = ACTIONS(3593),
    [anon_sym_class] = ACTIONS(3593),
    [anon_sym_ref] = ACTIONS(3593),
    [anon_sym_struct] = ACTIONS(3593),
    [anon_sym_enum] = ACTIONS(3593),
    [anon_sym_LBRACE] = ACTIONS(3595),
    [anon_sym_interface] = ACTIONS(3593),
    [anon_sym_delegate] = ACTIONS(3593),
    [anon_sym_record] = ACTIONS(3593),
    [anon_sym_abstract] = ACTIONS(3593),
    [anon_sym_async] = ACTIONS(3593),
    [anon_sym_const] = ACTIONS(3593),
    [anon_sym_file] = ACTIONS(3593),
    [anon_sym_fixed] = ACTIONS(3593),
    [anon_sym_internal] = ACTIONS(3593),
    [anon_sym_new] = ACTIONS(3593),
    [anon_sym_override] = ACTIONS(3593),
    [anon_sym_partial] = ACTIONS(3593),
    [anon_sym_private] = ACTIONS(3593),
    [anon_sym_protected] = ACTIONS(3593),
    [anon_sym_public] = ACTIONS(3593),
    [anon_sym_readonly] = ACTIONS(3593),
    [anon_sym_required] = ACTIONS(3593),
    [anon_sym_sealed] = ACTIONS(3593),
    [anon_sym_virtual] = ACTIONS(3593),
    [anon_sym_volatile] = ACTIONS(3593),
    [anon_sym_where] = ACTIONS(3593),
    [anon_sym_notnull] = ACTIONS(3593),
    [anon_sym_unmanaged] = ACTIONS(3593),
    [anon_sym_checked] = ACTIONS(3593),
    [anon_sym_BANG] = ACTIONS(3595),
    [anon_sym_TILDE] = ACTIONS(3595),
    [anon_sym_PLUS_PLUS] = ACTIONS(3595),
    [anon_sym_DASH_DASH] = ACTIONS(3595),
    [anon_sym_true] = ACTIONS(3593),
    [anon_sym_false] = ACTIONS(3593),
    [anon_sym_PLUS] = ACTIONS(3593),
    [anon_sym_DASH] = ACTIONS(3593),
    [anon_sym_STAR] = ACTIONS(3595),
    [anon_sym_CARET] = ACTIONS(3595),
    [anon_sym_AMP] = ACTIONS(3595),
    [anon_sym_this] = ACTIONS(3593),
    [anon_sym_scoped] = ACTIONS(3593),
    [anon_sym_var] = ACTIONS(3593),
    [sym_predefined_type] = ACTIONS(3593),
    [anon_sym_break] = ACTIONS(3593),
    [anon_sym_unchecked] = ACTIONS(3593),
    [anon_sym_continue] = ACTIONS(3593),
    [anon_sym_do] = ACTIONS(3593),
    [anon_sym_while] = ACTIONS(3593),
    [anon_sym_for] = ACTIONS(3593),
    [anon_sym_lock] = ACTIONS(3593),
    [anon_sym_yield] = ACTIONS(3593),
    [anon_sym_switch] = ACTIONS(3593),
    [anon_sym_default] = ACTIONS(3593),
    [anon_sym_throw] = ACTIONS(3593),
    [anon_sym_try] = ACTIONS(3593),
    [anon_sym_when] = ACTIONS(3593),
    [anon_sym_await] = ACTIONS(3593),
    [anon_sym_foreach] = ACTIONS(3593),
    [anon_sym_goto] = ACTIONS(3593),
    [anon_sym_if] = ACTIONS(3593),
    [anon_sym_DOT_DOT] = ACTIONS(3595),
    [anon_sym_from] = ACTIONS(3593),
    [anon_sym_into] = ACTIONS(3593),
    [anon_sym_join] = ACTIONS(3593),
    [anon_sym_on] = ACTIONS(3593),
    [anon_sym_equals] = ACTIONS(3593),
    [anon_sym_let] = ACTIONS(3593),
    [anon_sym_orderby] = ACTIONS(3593),
    [anon_sym_ascending] = ACTIONS(3593),
    [anon_sym_descending] = ACTIONS(3593),
    [anon_sym_group] = ACTIONS(3593),
    [anon_sym_by] = ACTIONS(3593),
    [anon_sym_select] = ACTIONS(3593),
    [anon_sym_DQUOTE] = ACTIONS(3593),
    [anon_sym_stackalloc] = ACTIONS(3593),
    [anon_sym_sizeof] = ACTIONS(3593),
    [anon_sym_typeof] = ACTIONS(3593),
    [anon_sym___makeref] = ACTIONS(3593),
    [anon_sym___reftype] = ACTIONS(3593),
    [anon_sym___refvalue] = ACTIONS(3593),
    [sym_null_literal] = ACTIONS(3593),
    [anon_sym_SQUOTE] = ACTIONS(3595),
    [sym_integer_literal] = ACTIONS(3593),
    [sym_real_literal] = ACTIONS(3595),
    [sym_verbatim_string_literal] = ACTIONS(3595),
    [sym_raw_string_literal] = ACTIONS(3595),
    [aux_sym_preproc_if_token1] = ACTIONS(3595),
    [aux_sym_preproc_if_token3] = ACTIONS(3595),
    [aux_sym_preproc_else_token1] = ACTIONS(3595),
    [aux_sym_preproc_elif_token1] = ACTIONS(3595),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3595),
    [sym_interpolation_verbatim_start] = ACTIONS(3595),
    [sym_interpolation_raw_start] = ACTIONS(3595),
  },
  [2342] = {
    [sym_preproc_region] = STATE(2342),
    [sym_preproc_endregion] = STATE(2342),
    [sym_preproc_line] = STATE(2342),
    [sym_preproc_pragma] = STATE(2342),
    [sym_preproc_nullable] = STATE(2342),
    [sym_preproc_error] = STATE(2342),
    [sym_preproc_define] = STATE(2342),
    [sym_preproc_undef] = STATE(2342),
    [sym__identifier_token] = ACTIONS(3597),
    [anon_sym_extern] = ACTIONS(3597),
    [anon_sym_alias] = ACTIONS(3597),
    [anon_sym_SEMI] = ACTIONS(3599),
    [anon_sym_global] = ACTIONS(3597),
    [anon_sym_using] = ACTIONS(3597),
    [anon_sym_unsafe] = ACTIONS(3597),
    [anon_sym_static] = ACTIONS(3597),
    [anon_sym_LBRACK] = ACTIONS(3599),
    [anon_sym_LPAREN] = ACTIONS(3599),
    [anon_sym_return] = ACTIONS(3597),
    [anon_sym_namespace] = ACTIONS(3597),
    [anon_sym_class] = ACTIONS(3597),
    [anon_sym_ref] = ACTIONS(3597),
    [anon_sym_struct] = ACTIONS(3597),
    [anon_sym_enum] = ACTIONS(3597),
    [anon_sym_LBRACE] = ACTIONS(3599),
    [anon_sym_interface] = ACTIONS(3597),
    [anon_sym_delegate] = ACTIONS(3597),
    [anon_sym_record] = ACTIONS(3597),
    [anon_sym_abstract] = ACTIONS(3597),
    [anon_sym_async] = ACTIONS(3597),
    [anon_sym_const] = ACTIONS(3597),
    [anon_sym_file] = ACTIONS(3597),
    [anon_sym_fixed] = ACTIONS(3597),
    [anon_sym_internal] = ACTIONS(3597),
    [anon_sym_new] = ACTIONS(3597),
    [anon_sym_override] = ACTIONS(3597),
    [anon_sym_partial] = ACTIONS(3597),
    [anon_sym_private] = ACTIONS(3597),
    [anon_sym_protected] = ACTIONS(3597),
    [anon_sym_public] = ACTIONS(3597),
    [anon_sym_readonly] = ACTIONS(3597),
    [anon_sym_required] = ACTIONS(3597),
    [anon_sym_sealed] = ACTIONS(3597),
    [anon_sym_virtual] = ACTIONS(3597),
    [anon_sym_volatile] = ACTIONS(3597),
    [anon_sym_where] = ACTIONS(3597),
    [anon_sym_notnull] = ACTIONS(3597),
    [anon_sym_unmanaged] = ACTIONS(3597),
    [anon_sym_checked] = ACTIONS(3597),
    [anon_sym_BANG] = ACTIONS(3599),
    [anon_sym_TILDE] = ACTIONS(3599),
    [anon_sym_PLUS_PLUS] = ACTIONS(3599),
    [anon_sym_DASH_DASH] = ACTIONS(3599),
    [anon_sym_true] = ACTIONS(3597),
    [anon_sym_false] = ACTIONS(3597),
    [anon_sym_PLUS] = ACTIONS(3597),
    [anon_sym_DASH] = ACTIONS(3597),
    [anon_sym_STAR] = ACTIONS(3599),
    [anon_sym_CARET] = ACTIONS(3599),
    [anon_sym_AMP] = ACTIONS(3599),
    [anon_sym_this] = ACTIONS(3597),
    [anon_sym_scoped] = ACTIONS(3597),
    [anon_sym_var] = ACTIONS(3597),
    [sym_predefined_type] = ACTIONS(3597),
    [anon_sym_break] = ACTIONS(3597),
    [anon_sym_unchecked] = ACTIONS(3597),
    [anon_sym_continue] = ACTIONS(3597),
    [anon_sym_do] = ACTIONS(3597),
    [anon_sym_while] = ACTIONS(3597),
    [anon_sym_for] = ACTIONS(3597),
    [anon_sym_lock] = ACTIONS(3597),
    [anon_sym_yield] = ACTIONS(3597),
    [anon_sym_switch] = ACTIONS(3597),
    [anon_sym_default] = ACTIONS(3597),
    [anon_sym_throw] = ACTIONS(3597),
    [anon_sym_try] = ACTIONS(3597),
    [anon_sym_when] = ACTIONS(3597),
    [anon_sym_await] = ACTIONS(3597),
    [anon_sym_foreach] = ACTIONS(3597),
    [anon_sym_goto] = ACTIONS(3597),
    [anon_sym_if] = ACTIONS(3597),
    [anon_sym_DOT_DOT] = ACTIONS(3599),
    [anon_sym_from] = ACTIONS(3597),
    [anon_sym_into] = ACTIONS(3597),
    [anon_sym_join] = ACTIONS(3597),
    [anon_sym_on] = ACTIONS(3597),
    [anon_sym_equals] = ACTIONS(3597),
    [anon_sym_let] = ACTIONS(3597),
    [anon_sym_orderby] = ACTIONS(3597),
    [anon_sym_ascending] = ACTIONS(3597),
    [anon_sym_descending] = ACTIONS(3597),
    [anon_sym_group] = ACTIONS(3597),
    [anon_sym_by] = ACTIONS(3597),
    [anon_sym_select] = ACTIONS(3597),
    [anon_sym_DQUOTE] = ACTIONS(3597),
    [anon_sym_stackalloc] = ACTIONS(3597),
    [anon_sym_sizeof] = ACTIONS(3597),
    [anon_sym_typeof] = ACTIONS(3597),
    [anon_sym___makeref] = ACTIONS(3597),
    [anon_sym___reftype] = ACTIONS(3597),
    [anon_sym___refvalue] = ACTIONS(3597),
    [sym_null_literal] = ACTIONS(3597),
    [anon_sym_SQUOTE] = ACTIONS(3599),
    [sym_integer_literal] = ACTIONS(3597),
    [sym_real_literal] = ACTIONS(3599),
    [sym_verbatim_string_literal] = ACTIONS(3599),
    [sym_raw_string_literal] = ACTIONS(3599),
    [aux_sym_preproc_if_token1] = ACTIONS(3599),
    [aux_sym_preproc_if_token3] = ACTIONS(3599),
    [aux_sym_preproc_else_token1] = ACTIONS(3599),
    [aux_sym_preproc_elif_token1] = ACTIONS(3599),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3599),
    [sym_interpolation_verbatim_start] = ACTIONS(3599),
    [sym_interpolation_raw_start] = ACTIONS(3599),
  },
  [2343] = {
    [sym_preproc_region] = STATE(2343),
    [sym_preproc_endregion] = STATE(2343),
    [sym_preproc_line] = STATE(2343),
    [sym_preproc_pragma] = STATE(2343),
    [sym_preproc_nullable] = STATE(2343),
    [sym_preproc_error] = STATE(2343),
    [sym_preproc_define] = STATE(2343),
    [sym_preproc_undef] = STATE(2343),
    [sym__identifier_token] = ACTIONS(3601),
    [anon_sym_extern] = ACTIONS(3601),
    [anon_sym_alias] = ACTIONS(3601),
    [anon_sym_SEMI] = ACTIONS(3603),
    [anon_sym_global] = ACTIONS(3601),
    [anon_sym_using] = ACTIONS(3601),
    [anon_sym_unsafe] = ACTIONS(3601),
    [anon_sym_static] = ACTIONS(3601),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_LPAREN] = ACTIONS(3603),
    [anon_sym_return] = ACTIONS(3601),
    [anon_sym_namespace] = ACTIONS(3601),
    [anon_sym_class] = ACTIONS(3601),
    [anon_sym_ref] = ACTIONS(3601),
    [anon_sym_struct] = ACTIONS(3601),
    [anon_sym_enum] = ACTIONS(3601),
    [anon_sym_LBRACE] = ACTIONS(3603),
    [anon_sym_interface] = ACTIONS(3601),
    [anon_sym_delegate] = ACTIONS(3601),
    [anon_sym_record] = ACTIONS(3601),
    [anon_sym_abstract] = ACTIONS(3601),
    [anon_sym_async] = ACTIONS(3601),
    [anon_sym_const] = ACTIONS(3601),
    [anon_sym_file] = ACTIONS(3601),
    [anon_sym_fixed] = ACTIONS(3601),
    [anon_sym_internal] = ACTIONS(3601),
    [anon_sym_new] = ACTIONS(3601),
    [anon_sym_override] = ACTIONS(3601),
    [anon_sym_partial] = ACTIONS(3601),
    [anon_sym_private] = ACTIONS(3601),
    [anon_sym_protected] = ACTIONS(3601),
    [anon_sym_public] = ACTIONS(3601),
    [anon_sym_readonly] = ACTIONS(3601),
    [anon_sym_required] = ACTIONS(3601),
    [anon_sym_sealed] = ACTIONS(3601),
    [anon_sym_virtual] = ACTIONS(3601),
    [anon_sym_volatile] = ACTIONS(3601),
    [anon_sym_where] = ACTIONS(3601),
    [anon_sym_notnull] = ACTIONS(3601),
    [anon_sym_unmanaged] = ACTIONS(3601),
    [anon_sym_checked] = ACTIONS(3601),
    [anon_sym_BANG] = ACTIONS(3603),
    [anon_sym_TILDE] = ACTIONS(3603),
    [anon_sym_PLUS_PLUS] = ACTIONS(3603),
    [anon_sym_DASH_DASH] = ACTIONS(3603),
    [anon_sym_true] = ACTIONS(3601),
    [anon_sym_false] = ACTIONS(3601),
    [anon_sym_PLUS] = ACTIONS(3601),
    [anon_sym_DASH] = ACTIONS(3601),
    [anon_sym_STAR] = ACTIONS(3603),
    [anon_sym_CARET] = ACTIONS(3603),
    [anon_sym_AMP] = ACTIONS(3603),
    [anon_sym_this] = ACTIONS(3601),
    [anon_sym_scoped] = ACTIONS(3601),
    [anon_sym_var] = ACTIONS(3601),
    [sym_predefined_type] = ACTIONS(3601),
    [anon_sym_break] = ACTIONS(3601),
    [anon_sym_unchecked] = ACTIONS(3601),
    [anon_sym_continue] = ACTIONS(3601),
    [anon_sym_do] = ACTIONS(3601),
    [anon_sym_while] = ACTIONS(3601),
    [anon_sym_for] = ACTIONS(3601),
    [anon_sym_lock] = ACTIONS(3601),
    [anon_sym_yield] = ACTIONS(3601),
    [anon_sym_switch] = ACTIONS(3601),
    [anon_sym_default] = ACTIONS(3601),
    [anon_sym_throw] = ACTIONS(3601),
    [anon_sym_try] = ACTIONS(3601),
    [anon_sym_when] = ACTIONS(3601),
    [anon_sym_await] = ACTIONS(3601),
    [anon_sym_foreach] = ACTIONS(3601),
    [anon_sym_goto] = ACTIONS(3601),
    [anon_sym_if] = ACTIONS(3601),
    [anon_sym_DOT_DOT] = ACTIONS(3603),
    [anon_sym_from] = ACTIONS(3601),
    [anon_sym_into] = ACTIONS(3601),
    [anon_sym_join] = ACTIONS(3601),
    [anon_sym_on] = ACTIONS(3601),
    [anon_sym_equals] = ACTIONS(3601),
    [anon_sym_let] = ACTIONS(3601),
    [anon_sym_orderby] = ACTIONS(3601),
    [anon_sym_ascending] = ACTIONS(3601),
    [anon_sym_descending] = ACTIONS(3601),
    [anon_sym_group] = ACTIONS(3601),
    [anon_sym_by] = ACTIONS(3601),
    [anon_sym_select] = ACTIONS(3601),
    [anon_sym_DQUOTE] = ACTIONS(3601),
    [anon_sym_stackalloc] = ACTIONS(3601),
    [anon_sym_sizeof] = ACTIONS(3601),
    [anon_sym_typeof] = ACTIONS(3601),
    [anon_sym___makeref] = ACTIONS(3601),
    [anon_sym___reftype] = ACTIONS(3601),
    [anon_sym___refvalue] = ACTIONS(3601),
    [sym_null_literal] = ACTIONS(3601),
    [anon_sym_SQUOTE] = ACTIONS(3603),
    [sym_integer_literal] = ACTIONS(3601),
    [sym_real_literal] = ACTIONS(3603),
    [sym_verbatim_string_literal] = ACTIONS(3603),
    [sym_raw_string_literal] = ACTIONS(3603),
    [aux_sym_preproc_if_token1] = ACTIONS(3603),
    [aux_sym_preproc_if_token3] = ACTIONS(3603),
    [aux_sym_preproc_else_token1] = ACTIONS(3603),
    [aux_sym_preproc_elif_token1] = ACTIONS(3603),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3603),
    [sym_interpolation_verbatim_start] = ACTIONS(3603),
    [sym_interpolation_raw_start] = ACTIONS(3603),
  },
  [2344] = {
    [sym_preproc_region] = STATE(2344),
    [sym_preproc_endregion] = STATE(2344),
    [sym_preproc_line] = STATE(2344),
    [sym_preproc_pragma] = STATE(2344),
    [sym_preproc_nullable] = STATE(2344),
    [sym_preproc_error] = STATE(2344),
    [sym_preproc_define] = STATE(2344),
    [sym_preproc_undef] = STATE(2344),
    [sym__identifier_token] = ACTIONS(3605),
    [anon_sym_extern] = ACTIONS(3605),
    [anon_sym_alias] = ACTIONS(3605),
    [anon_sym_SEMI] = ACTIONS(3607),
    [anon_sym_global] = ACTIONS(3605),
    [anon_sym_using] = ACTIONS(3605),
    [anon_sym_unsafe] = ACTIONS(3605),
    [anon_sym_static] = ACTIONS(3605),
    [anon_sym_LBRACK] = ACTIONS(3607),
    [anon_sym_LPAREN] = ACTIONS(3607),
    [anon_sym_return] = ACTIONS(3605),
    [anon_sym_namespace] = ACTIONS(3605),
    [anon_sym_class] = ACTIONS(3605),
    [anon_sym_ref] = ACTIONS(3605),
    [anon_sym_struct] = ACTIONS(3605),
    [anon_sym_enum] = ACTIONS(3605),
    [anon_sym_LBRACE] = ACTIONS(3607),
    [anon_sym_interface] = ACTIONS(3605),
    [anon_sym_delegate] = ACTIONS(3605),
    [anon_sym_record] = ACTIONS(3605),
    [anon_sym_abstract] = ACTIONS(3605),
    [anon_sym_async] = ACTIONS(3605),
    [anon_sym_const] = ACTIONS(3605),
    [anon_sym_file] = ACTIONS(3605),
    [anon_sym_fixed] = ACTIONS(3605),
    [anon_sym_internal] = ACTIONS(3605),
    [anon_sym_new] = ACTIONS(3605),
    [anon_sym_override] = ACTIONS(3605),
    [anon_sym_partial] = ACTIONS(3605),
    [anon_sym_private] = ACTIONS(3605),
    [anon_sym_protected] = ACTIONS(3605),
    [anon_sym_public] = ACTIONS(3605),
    [anon_sym_readonly] = ACTIONS(3605),
    [anon_sym_required] = ACTIONS(3605),
    [anon_sym_sealed] = ACTIONS(3605),
    [anon_sym_virtual] = ACTIONS(3605),
    [anon_sym_volatile] = ACTIONS(3605),
    [anon_sym_where] = ACTIONS(3605),
    [anon_sym_notnull] = ACTIONS(3605),
    [anon_sym_unmanaged] = ACTIONS(3605),
    [anon_sym_checked] = ACTIONS(3605),
    [anon_sym_BANG] = ACTIONS(3607),
    [anon_sym_TILDE] = ACTIONS(3607),
    [anon_sym_PLUS_PLUS] = ACTIONS(3607),
    [anon_sym_DASH_DASH] = ACTIONS(3607),
    [anon_sym_true] = ACTIONS(3605),
    [anon_sym_false] = ACTIONS(3605),
    [anon_sym_PLUS] = ACTIONS(3605),
    [anon_sym_DASH] = ACTIONS(3605),
    [anon_sym_STAR] = ACTIONS(3607),
    [anon_sym_CARET] = ACTIONS(3607),
    [anon_sym_AMP] = ACTIONS(3607),
    [anon_sym_this] = ACTIONS(3605),
    [anon_sym_scoped] = ACTIONS(3605),
    [anon_sym_var] = ACTIONS(3605),
    [sym_predefined_type] = ACTIONS(3605),
    [anon_sym_break] = ACTIONS(3605),
    [anon_sym_unchecked] = ACTIONS(3605),
    [anon_sym_continue] = ACTIONS(3605),
    [anon_sym_do] = ACTIONS(3605),
    [anon_sym_while] = ACTIONS(3605),
    [anon_sym_for] = ACTIONS(3605),
    [anon_sym_lock] = ACTIONS(3605),
    [anon_sym_yield] = ACTIONS(3605),
    [anon_sym_switch] = ACTIONS(3605),
    [anon_sym_default] = ACTIONS(3605),
    [anon_sym_throw] = ACTIONS(3605),
    [anon_sym_try] = ACTIONS(3605),
    [anon_sym_when] = ACTIONS(3605),
    [anon_sym_await] = ACTIONS(3605),
    [anon_sym_foreach] = ACTIONS(3605),
    [anon_sym_goto] = ACTIONS(3605),
    [anon_sym_if] = ACTIONS(3605),
    [anon_sym_DOT_DOT] = ACTIONS(3607),
    [anon_sym_from] = ACTIONS(3605),
    [anon_sym_into] = ACTIONS(3605),
    [anon_sym_join] = ACTIONS(3605),
    [anon_sym_on] = ACTIONS(3605),
    [anon_sym_equals] = ACTIONS(3605),
    [anon_sym_let] = ACTIONS(3605),
    [anon_sym_orderby] = ACTIONS(3605),
    [anon_sym_ascending] = ACTIONS(3605),
    [anon_sym_descending] = ACTIONS(3605),
    [anon_sym_group] = ACTIONS(3605),
    [anon_sym_by] = ACTIONS(3605),
    [anon_sym_select] = ACTIONS(3605),
    [anon_sym_DQUOTE] = ACTIONS(3605),
    [anon_sym_stackalloc] = ACTIONS(3605),
    [anon_sym_sizeof] = ACTIONS(3605),
    [anon_sym_typeof] = ACTIONS(3605),
    [anon_sym___makeref] = ACTIONS(3605),
    [anon_sym___reftype] = ACTIONS(3605),
    [anon_sym___refvalue] = ACTIONS(3605),
    [sym_null_literal] = ACTIONS(3605),
    [anon_sym_SQUOTE] = ACTIONS(3607),
    [sym_integer_literal] = ACTIONS(3605),
    [sym_real_literal] = ACTIONS(3607),
    [sym_verbatim_string_literal] = ACTIONS(3607),
    [sym_raw_string_literal] = ACTIONS(3607),
    [aux_sym_preproc_if_token1] = ACTIONS(3607),
    [aux_sym_preproc_if_token3] = ACTIONS(3607),
    [aux_sym_preproc_else_token1] = ACTIONS(3607),
    [aux_sym_preproc_elif_token1] = ACTIONS(3607),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3607),
    [sym_interpolation_verbatim_start] = ACTIONS(3607),
    [sym_interpolation_raw_start] = ACTIONS(3607),
  },
  [2345] = {
    [sym_preproc_region] = STATE(2345),
    [sym_preproc_endregion] = STATE(2345),
    [sym_preproc_line] = STATE(2345),
    [sym_preproc_pragma] = STATE(2345),
    [sym_preproc_nullable] = STATE(2345),
    [sym_preproc_error] = STATE(2345),
    [sym_preproc_define] = STATE(2345),
    [sym_preproc_undef] = STATE(2345),
    [sym__identifier_token] = ACTIONS(3609),
    [anon_sym_extern] = ACTIONS(3609),
    [anon_sym_alias] = ACTIONS(3609),
    [anon_sym_SEMI] = ACTIONS(3611),
    [anon_sym_global] = ACTIONS(3609),
    [anon_sym_using] = ACTIONS(3609),
    [anon_sym_unsafe] = ACTIONS(3609),
    [anon_sym_static] = ACTIONS(3609),
    [anon_sym_LBRACK] = ACTIONS(3611),
    [anon_sym_LPAREN] = ACTIONS(3611),
    [anon_sym_return] = ACTIONS(3609),
    [anon_sym_namespace] = ACTIONS(3609),
    [anon_sym_class] = ACTIONS(3609),
    [anon_sym_ref] = ACTIONS(3609),
    [anon_sym_struct] = ACTIONS(3609),
    [anon_sym_enum] = ACTIONS(3609),
    [anon_sym_LBRACE] = ACTIONS(3611),
    [anon_sym_interface] = ACTIONS(3609),
    [anon_sym_delegate] = ACTIONS(3609),
    [anon_sym_record] = ACTIONS(3609),
    [anon_sym_abstract] = ACTIONS(3609),
    [anon_sym_async] = ACTIONS(3609),
    [anon_sym_const] = ACTIONS(3609),
    [anon_sym_file] = ACTIONS(3609),
    [anon_sym_fixed] = ACTIONS(3609),
    [anon_sym_internal] = ACTIONS(3609),
    [anon_sym_new] = ACTIONS(3609),
    [anon_sym_override] = ACTIONS(3609),
    [anon_sym_partial] = ACTIONS(3609),
    [anon_sym_private] = ACTIONS(3609),
    [anon_sym_protected] = ACTIONS(3609),
    [anon_sym_public] = ACTIONS(3609),
    [anon_sym_readonly] = ACTIONS(3609),
    [anon_sym_required] = ACTIONS(3609),
    [anon_sym_sealed] = ACTIONS(3609),
    [anon_sym_virtual] = ACTIONS(3609),
    [anon_sym_volatile] = ACTIONS(3609),
    [anon_sym_where] = ACTIONS(3609),
    [anon_sym_notnull] = ACTIONS(3609),
    [anon_sym_unmanaged] = ACTIONS(3609),
    [anon_sym_checked] = ACTIONS(3609),
    [anon_sym_BANG] = ACTIONS(3611),
    [anon_sym_TILDE] = ACTIONS(3611),
    [anon_sym_PLUS_PLUS] = ACTIONS(3611),
    [anon_sym_DASH_DASH] = ACTIONS(3611),
    [anon_sym_true] = ACTIONS(3609),
    [anon_sym_false] = ACTIONS(3609),
    [anon_sym_PLUS] = ACTIONS(3609),
    [anon_sym_DASH] = ACTIONS(3609),
    [anon_sym_STAR] = ACTIONS(3611),
    [anon_sym_CARET] = ACTIONS(3611),
    [anon_sym_AMP] = ACTIONS(3611),
    [anon_sym_this] = ACTIONS(3609),
    [anon_sym_scoped] = ACTIONS(3609),
    [anon_sym_var] = ACTIONS(3609),
    [sym_predefined_type] = ACTIONS(3609),
    [anon_sym_break] = ACTIONS(3609),
    [anon_sym_unchecked] = ACTIONS(3609),
    [anon_sym_continue] = ACTIONS(3609),
    [anon_sym_do] = ACTIONS(3609),
    [anon_sym_while] = ACTIONS(3609),
    [anon_sym_for] = ACTIONS(3609),
    [anon_sym_lock] = ACTIONS(3609),
    [anon_sym_yield] = ACTIONS(3609),
    [anon_sym_switch] = ACTIONS(3609),
    [anon_sym_default] = ACTIONS(3609),
    [anon_sym_throw] = ACTIONS(3609),
    [anon_sym_try] = ACTIONS(3609),
    [anon_sym_when] = ACTIONS(3609),
    [anon_sym_await] = ACTIONS(3609),
    [anon_sym_foreach] = ACTIONS(3609),
    [anon_sym_goto] = ACTIONS(3609),
    [anon_sym_if] = ACTIONS(3609),
    [anon_sym_DOT_DOT] = ACTIONS(3611),
    [anon_sym_from] = ACTIONS(3609),
    [anon_sym_into] = ACTIONS(3609),
    [anon_sym_join] = ACTIONS(3609),
    [anon_sym_on] = ACTIONS(3609),
    [anon_sym_equals] = ACTIONS(3609),
    [anon_sym_let] = ACTIONS(3609),
    [anon_sym_orderby] = ACTIONS(3609),
    [anon_sym_ascending] = ACTIONS(3609),
    [anon_sym_descending] = ACTIONS(3609),
    [anon_sym_group] = ACTIONS(3609),
    [anon_sym_by] = ACTIONS(3609),
    [anon_sym_select] = ACTIONS(3609),
    [anon_sym_DQUOTE] = ACTIONS(3609),
    [anon_sym_stackalloc] = ACTIONS(3609),
    [anon_sym_sizeof] = ACTIONS(3609),
    [anon_sym_typeof] = ACTIONS(3609),
    [anon_sym___makeref] = ACTIONS(3609),
    [anon_sym___reftype] = ACTIONS(3609),
    [anon_sym___refvalue] = ACTIONS(3609),
    [sym_null_literal] = ACTIONS(3609),
    [anon_sym_SQUOTE] = ACTIONS(3611),
    [sym_integer_literal] = ACTIONS(3609),
    [sym_real_literal] = ACTIONS(3611),
    [sym_verbatim_string_literal] = ACTIONS(3611),
    [sym_raw_string_literal] = ACTIONS(3611),
    [aux_sym_preproc_if_token1] = ACTIONS(3611),
    [aux_sym_preproc_if_token3] = ACTIONS(3611),
    [aux_sym_preproc_else_token1] = ACTIONS(3611),
    [aux_sym_preproc_elif_token1] = ACTIONS(3611),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3611),
    [sym_interpolation_verbatim_start] = ACTIONS(3611),
    [sym_interpolation_raw_start] = ACTIONS(3611),
  },
  [2346] = {
    [sym_preproc_region] = STATE(2346),
    [sym_preproc_endregion] = STATE(2346),
    [sym_preproc_line] = STATE(2346),
    [sym_preproc_pragma] = STATE(2346),
    [sym_preproc_nullable] = STATE(2346),
    [sym_preproc_error] = STATE(2346),
    [sym_preproc_define] = STATE(2346),
    [sym_preproc_undef] = STATE(2346),
    [sym__identifier_token] = ACTIONS(3065),
    [anon_sym_extern] = ACTIONS(3065),
    [anon_sym_alias] = ACTIONS(3065),
    [anon_sym_SEMI] = ACTIONS(3067),
    [anon_sym_global] = ACTIONS(3065),
    [anon_sym_using] = ACTIONS(3065),
    [anon_sym_unsafe] = ACTIONS(3065),
    [anon_sym_static] = ACTIONS(3065),
    [anon_sym_LBRACK] = ACTIONS(3067),
    [anon_sym_LPAREN] = ACTIONS(3067),
    [anon_sym_return] = ACTIONS(3065),
    [anon_sym_namespace] = ACTIONS(3065),
    [anon_sym_class] = ACTIONS(3065),
    [anon_sym_ref] = ACTIONS(3065),
    [anon_sym_struct] = ACTIONS(3065),
    [anon_sym_enum] = ACTIONS(3065),
    [anon_sym_LBRACE] = ACTIONS(3067),
    [anon_sym_interface] = ACTIONS(3065),
    [anon_sym_delegate] = ACTIONS(3065),
    [anon_sym_record] = ACTIONS(3065),
    [anon_sym_abstract] = ACTIONS(3065),
    [anon_sym_async] = ACTIONS(3065),
    [anon_sym_const] = ACTIONS(3065),
    [anon_sym_file] = ACTIONS(3065),
    [anon_sym_fixed] = ACTIONS(3065),
    [anon_sym_internal] = ACTIONS(3065),
    [anon_sym_new] = ACTIONS(3065),
    [anon_sym_override] = ACTIONS(3065),
    [anon_sym_partial] = ACTIONS(3065),
    [anon_sym_private] = ACTIONS(3065),
    [anon_sym_protected] = ACTIONS(3065),
    [anon_sym_public] = ACTIONS(3065),
    [anon_sym_readonly] = ACTIONS(3065),
    [anon_sym_required] = ACTIONS(3065),
    [anon_sym_sealed] = ACTIONS(3065),
    [anon_sym_virtual] = ACTIONS(3065),
    [anon_sym_volatile] = ACTIONS(3065),
    [anon_sym_where] = ACTIONS(3065),
    [anon_sym_notnull] = ACTIONS(3065),
    [anon_sym_unmanaged] = ACTIONS(3065),
    [anon_sym_checked] = ACTIONS(3065),
    [anon_sym_BANG] = ACTIONS(3067),
    [anon_sym_TILDE] = ACTIONS(3067),
    [anon_sym_PLUS_PLUS] = ACTIONS(3067),
    [anon_sym_DASH_DASH] = ACTIONS(3067),
    [anon_sym_true] = ACTIONS(3065),
    [anon_sym_false] = ACTIONS(3065),
    [anon_sym_PLUS] = ACTIONS(3065),
    [anon_sym_DASH] = ACTIONS(3065),
    [anon_sym_STAR] = ACTIONS(3067),
    [anon_sym_CARET] = ACTIONS(3067),
    [anon_sym_AMP] = ACTIONS(3067),
    [anon_sym_this] = ACTIONS(3065),
    [anon_sym_scoped] = ACTIONS(3065),
    [anon_sym_var] = ACTIONS(3065),
    [sym_predefined_type] = ACTIONS(3065),
    [anon_sym_break] = ACTIONS(3065),
    [anon_sym_unchecked] = ACTIONS(3065),
    [anon_sym_continue] = ACTIONS(3065),
    [anon_sym_do] = ACTIONS(3065),
    [anon_sym_while] = ACTIONS(3065),
    [anon_sym_for] = ACTIONS(3065),
    [anon_sym_lock] = ACTIONS(3065),
    [anon_sym_yield] = ACTIONS(3065),
    [anon_sym_switch] = ACTIONS(3065),
    [anon_sym_default] = ACTIONS(3065),
    [anon_sym_throw] = ACTIONS(3065),
    [anon_sym_try] = ACTIONS(3065),
    [anon_sym_when] = ACTIONS(3065),
    [anon_sym_await] = ACTIONS(3065),
    [anon_sym_foreach] = ACTIONS(3065),
    [anon_sym_goto] = ACTIONS(3065),
    [anon_sym_if] = ACTIONS(3065),
    [anon_sym_DOT_DOT] = ACTIONS(3067),
    [anon_sym_from] = ACTIONS(3065),
    [anon_sym_into] = ACTIONS(3065),
    [anon_sym_join] = ACTIONS(3065),
    [anon_sym_on] = ACTIONS(3065),
    [anon_sym_equals] = ACTIONS(3065),
    [anon_sym_let] = ACTIONS(3065),
    [anon_sym_orderby] = ACTIONS(3065),
    [anon_sym_ascending] = ACTIONS(3065),
    [anon_sym_descending] = ACTIONS(3065),
    [anon_sym_group] = ACTIONS(3065),
    [anon_sym_by] = ACTIONS(3065),
    [anon_sym_select] = ACTIONS(3065),
    [anon_sym_DQUOTE] = ACTIONS(3065),
    [anon_sym_stackalloc] = ACTIONS(3065),
    [anon_sym_sizeof] = ACTIONS(3065),
    [anon_sym_typeof] = ACTIONS(3065),
    [anon_sym___makeref] = ACTIONS(3065),
    [anon_sym___reftype] = ACTIONS(3065),
    [anon_sym___refvalue] = ACTIONS(3065),
    [sym_null_literal] = ACTIONS(3065),
    [anon_sym_SQUOTE] = ACTIONS(3067),
    [sym_integer_literal] = ACTIONS(3065),
    [sym_real_literal] = ACTIONS(3067),
    [sym_verbatim_string_literal] = ACTIONS(3067),
    [sym_raw_string_literal] = ACTIONS(3067),
    [aux_sym_preproc_if_token1] = ACTIONS(3067),
    [aux_sym_preproc_if_token3] = ACTIONS(3067),
    [aux_sym_preproc_else_token1] = ACTIONS(3067),
    [aux_sym_preproc_elif_token1] = ACTIONS(3067),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3067),
    [sym_interpolation_verbatim_start] = ACTIONS(3067),
    [sym_interpolation_raw_start] = ACTIONS(3067),
  },
  [2347] = {
    [sym_preproc_region] = STATE(2347),
    [sym_preproc_endregion] = STATE(2347),
    [sym_preproc_line] = STATE(2347),
    [sym_preproc_pragma] = STATE(2347),
    [sym_preproc_nullable] = STATE(2347),
    [sym_preproc_error] = STATE(2347),
    [sym_preproc_define] = STATE(2347),
    [sym_preproc_undef] = STATE(2347),
    [sym__identifier_token] = ACTIONS(3613),
    [anon_sym_extern] = ACTIONS(3613),
    [anon_sym_alias] = ACTIONS(3613),
    [anon_sym_SEMI] = ACTIONS(3615),
    [anon_sym_global] = ACTIONS(3613),
    [anon_sym_using] = ACTIONS(3613),
    [anon_sym_unsafe] = ACTIONS(3613),
    [anon_sym_static] = ACTIONS(3613),
    [anon_sym_LBRACK] = ACTIONS(3615),
    [anon_sym_LPAREN] = ACTIONS(3615),
    [anon_sym_return] = ACTIONS(3613),
    [anon_sym_namespace] = ACTIONS(3613),
    [anon_sym_class] = ACTIONS(3613),
    [anon_sym_ref] = ACTIONS(3613),
    [anon_sym_struct] = ACTIONS(3613),
    [anon_sym_enum] = ACTIONS(3613),
    [anon_sym_LBRACE] = ACTIONS(3615),
    [anon_sym_interface] = ACTIONS(3613),
    [anon_sym_delegate] = ACTIONS(3613),
    [anon_sym_record] = ACTIONS(3613),
    [anon_sym_abstract] = ACTIONS(3613),
    [anon_sym_async] = ACTIONS(3613),
    [anon_sym_const] = ACTIONS(3613),
    [anon_sym_file] = ACTIONS(3613),
    [anon_sym_fixed] = ACTIONS(3613),
    [anon_sym_internal] = ACTIONS(3613),
    [anon_sym_new] = ACTIONS(3613),
    [anon_sym_override] = ACTIONS(3613),
    [anon_sym_partial] = ACTIONS(3613),
    [anon_sym_private] = ACTIONS(3613),
    [anon_sym_protected] = ACTIONS(3613),
    [anon_sym_public] = ACTIONS(3613),
    [anon_sym_readonly] = ACTIONS(3613),
    [anon_sym_required] = ACTIONS(3613),
    [anon_sym_sealed] = ACTIONS(3613),
    [anon_sym_virtual] = ACTIONS(3613),
    [anon_sym_volatile] = ACTIONS(3613),
    [anon_sym_where] = ACTIONS(3613),
    [anon_sym_notnull] = ACTIONS(3613),
    [anon_sym_unmanaged] = ACTIONS(3613),
    [anon_sym_checked] = ACTIONS(3613),
    [anon_sym_BANG] = ACTIONS(3615),
    [anon_sym_TILDE] = ACTIONS(3615),
    [anon_sym_PLUS_PLUS] = ACTIONS(3615),
    [anon_sym_DASH_DASH] = ACTIONS(3615),
    [anon_sym_true] = ACTIONS(3613),
    [anon_sym_false] = ACTIONS(3613),
    [anon_sym_PLUS] = ACTIONS(3613),
    [anon_sym_DASH] = ACTIONS(3613),
    [anon_sym_STAR] = ACTIONS(3615),
    [anon_sym_CARET] = ACTIONS(3615),
    [anon_sym_AMP] = ACTIONS(3615),
    [anon_sym_this] = ACTIONS(3613),
    [anon_sym_scoped] = ACTIONS(3613),
    [anon_sym_var] = ACTIONS(3613),
    [sym_predefined_type] = ACTIONS(3613),
    [anon_sym_break] = ACTIONS(3613),
    [anon_sym_unchecked] = ACTIONS(3613),
    [anon_sym_continue] = ACTIONS(3613),
    [anon_sym_do] = ACTIONS(3613),
    [anon_sym_while] = ACTIONS(3613),
    [anon_sym_for] = ACTIONS(3613),
    [anon_sym_lock] = ACTIONS(3613),
    [anon_sym_yield] = ACTIONS(3613),
    [anon_sym_switch] = ACTIONS(3613),
    [anon_sym_default] = ACTIONS(3613),
    [anon_sym_throw] = ACTIONS(3613),
    [anon_sym_try] = ACTIONS(3613),
    [anon_sym_when] = ACTIONS(3613),
    [anon_sym_await] = ACTIONS(3613),
    [anon_sym_foreach] = ACTIONS(3613),
    [anon_sym_goto] = ACTIONS(3613),
    [anon_sym_if] = ACTIONS(3613),
    [anon_sym_DOT_DOT] = ACTIONS(3615),
    [anon_sym_from] = ACTIONS(3613),
    [anon_sym_into] = ACTIONS(3613),
    [anon_sym_join] = ACTIONS(3613),
    [anon_sym_on] = ACTIONS(3613),
    [anon_sym_equals] = ACTIONS(3613),
    [anon_sym_let] = ACTIONS(3613),
    [anon_sym_orderby] = ACTIONS(3613),
    [anon_sym_ascending] = ACTIONS(3613),
    [anon_sym_descending] = ACTIONS(3613),
    [anon_sym_group] = ACTIONS(3613),
    [anon_sym_by] = ACTIONS(3613),
    [anon_sym_select] = ACTIONS(3613),
    [anon_sym_DQUOTE] = ACTIONS(3613),
    [anon_sym_stackalloc] = ACTIONS(3613),
    [anon_sym_sizeof] = ACTIONS(3613),
    [anon_sym_typeof] = ACTIONS(3613),
    [anon_sym___makeref] = ACTIONS(3613),
    [anon_sym___reftype] = ACTIONS(3613),
    [anon_sym___refvalue] = ACTIONS(3613),
    [sym_null_literal] = ACTIONS(3613),
    [anon_sym_SQUOTE] = ACTIONS(3615),
    [sym_integer_literal] = ACTIONS(3613),
    [sym_real_literal] = ACTIONS(3615),
    [sym_verbatim_string_literal] = ACTIONS(3615),
    [sym_raw_string_literal] = ACTIONS(3615),
    [aux_sym_preproc_if_token1] = ACTIONS(3615),
    [aux_sym_preproc_if_token3] = ACTIONS(3615),
    [aux_sym_preproc_else_token1] = ACTIONS(3615),
    [aux_sym_preproc_elif_token1] = ACTIONS(3615),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3615),
    [sym_interpolation_verbatim_start] = ACTIONS(3615),
    [sym_interpolation_raw_start] = ACTIONS(3615),
  },
  [2348] = {
    [sym_preproc_region] = STATE(2348),
    [sym_preproc_endregion] = STATE(2348),
    [sym_preproc_line] = STATE(2348),
    [sym_preproc_pragma] = STATE(2348),
    [sym_preproc_nullable] = STATE(2348),
    [sym_preproc_error] = STATE(2348),
    [sym_preproc_define] = STATE(2348),
    [sym_preproc_undef] = STATE(2348),
    [sym__identifier_token] = ACTIONS(3617),
    [anon_sym_extern] = ACTIONS(3617),
    [anon_sym_alias] = ACTIONS(3617),
    [anon_sym_SEMI] = ACTIONS(3619),
    [anon_sym_global] = ACTIONS(3617),
    [anon_sym_using] = ACTIONS(3617),
    [anon_sym_unsafe] = ACTIONS(3617),
    [anon_sym_static] = ACTIONS(3617),
    [anon_sym_LBRACK] = ACTIONS(3619),
    [anon_sym_LPAREN] = ACTIONS(3619),
    [anon_sym_return] = ACTIONS(3617),
    [anon_sym_namespace] = ACTIONS(3617),
    [anon_sym_class] = ACTIONS(3617),
    [anon_sym_ref] = ACTIONS(3617),
    [anon_sym_struct] = ACTIONS(3617),
    [anon_sym_enum] = ACTIONS(3617),
    [anon_sym_LBRACE] = ACTIONS(3619),
    [anon_sym_interface] = ACTIONS(3617),
    [anon_sym_delegate] = ACTIONS(3617),
    [anon_sym_record] = ACTIONS(3617),
    [anon_sym_abstract] = ACTIONS(3617),
    [anon_sym_async] = ACTIONS(3617),
    [anon_sym_const] = ACTIONS(3617),
    [anon_sym_file] = ACTIONS(3617),
    [anon_sym_fixed] = ACTIONS(3617),
    [anon_sym_internal] = ACTIONS(3617),
    [anon_sym_new] = ACTIONS(3617),
    [anon_sym_override] = ACTIONS(3617),
    [anon_sym_partial] = ACTIONS(3617),
    [anon_sym_private] = ACTIONS(3617),
    [anon_sym_protected] = ACTIONS(3617),
    [anon_sym_public] = ACTIONS(3617),
    [anon_sym_readonly] = ACTIONS(3617),
    [anon_sym_required] = ACTIONS(3617),
    [anon_sym_sealed] = ACTIONS(3617),
    [anon_sym_virtual] = ACTIONS(3617),
    [anon_sym_volatile] = ACTIONS(3617),
    [anon_sym_where] = ACTIONS(3617),
    [anon_sym_notnull] = ACTIONS(3617),
    [anon_sym_unmanaged] = ACTIONS(3617),
    [anon_sym_checked] = ACTIONS(3617),
    [anon_sym_BANG] = ACTIONS(3619),
    [anon_sym_TILDE] = ACTIONS(3619),
    [anon_sym_PLUS_PLUS] = ACTIONS(3619),
    [anon_sym_DASH_DASH] = ACTIONS(3619),
    [anon_sym_true] = ACTIONS(3617),
    [anon_sym_false] = ACTIONS(3617),
    [anon_sym_PLUS] = ACTIONS(3617),
    [anon_sym_DASH] = ACTIONS(3617),
    [anon_sym_STAR] = ACTIONS(3619),
    [anon_sym_CARET] = ACTIONS(3619),
    [anon_sym_AMP] = ACTIONS(3619),
    [anon_sym_this] = ACTIONS(3617),
    [anon_sym_scoped] = ACTIONS(3617),
    [anon_sym_var] = ACTIONS(3617),
    [sym_predefined_type] = ACTIONS(3617),
    [anon_sym_break] = ACTIONS(3617),
    [anon_sym_unchecked] = ACTIONS(3617),
    [anon_sym_continue] = ACTIONS(3617),
    [anon_sym_do] = ACTIONS(3617),
    [anon_sym_while] = ACTIONS(3617),
    [anon_sym_for] = ACTIONS(3617),
    [anon_sym_lock] = ACTIONS(3617),
    [anon_sym_yield] = ACTIONS(3617),
    [anon_sym_switch] = ACTIONS(3617),
    [anon_sym_default] = ACTIONS(3617),
    [anon_sym_throw] = ACTIONS(3617),
    [anon_sym_try] = ACTIONS(3617),
    [anon_sym_when] = ACTIONS(3617),
    [anon_sym_await] = ACTIONS(3617),
    [anon_sym_foreach] = ACTIONS(3617),
    [anon_sym_goto] = ACTIONS(3617),
    [anon_sym_if] = ACTIONS(3617),
    [anon_sym_DOT_DOT] = ACTIONS(3619),
    [anon_sym_from] = ACTIONS(3617),
    [anon_sym_into] = ACTIONS(3617),
    [anon_sym_join] = ACTIONS(3617),
    [anon_sym_on] = ACTIONS(3617),
    [anon_sym_equals] = ACTIONS(3617),
    [anon_sym_let] = ACTIONS(3617),
    [anon_sym_orderby] = ACTIONS(3617),
    [anon_sym_ascending] = ACTIONS(3617),
    [anon_sym_descending] = ACTIONS(3617),
    [anon_sym_group] = ACTIONS(3617),
    [anon_sym_by] = ACTIONS(3617),
    [anon_sym_select] = ACTIONS(3617),
    [anon_sym_DQUOTE] = ACTIONS(3617),
    [anon_sym_stackalloc] = ACTIONS(3617),
    [anon_sym_sizeof] = ACTIONS(3617),
    [anon_sym_typeof] = ACTIONS(3617),
    [anon_sym___makeref] = ACTIONS(3617),
    [anon_sym___reftype] = ACTIONS(3617),
    [anon_sym___refvalue] = ACTIONS(3617),
    [sym_null_literal] = ACTIONS(3617),
    [anon_sym_SQUOTE] = ACTIONS(3619),
    [sym_integer_literal] = ACTIONS(3617),
    [sym_real_literal] = ACTIONS(3619),
    [sym_verbatim_string_literal] = ACTIONS(3619),
    [sym_raw_string_literal] = ACTIONS(3619),
    [aux_sym_preproc_if_token1] = ACTIONS(3619),
    [aux_sym_preproc_if_token3] = ACTIONS(3619),
    [aux_sym_preproc_else_token1] = ACTIONS(3619),
    [aux_sym_preproc_elif_token1] = ACTIONS(3619),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3619),
    [sym_interpolation_verbatim_start] = ACTIONS(3619),
    [sym_interpolation_raw_start] = ACTIONS(3619),
  },
  [2349] = {
    [sym_preproc_region] = STATE(2349),
    [sym_preproc_endregion] = STATE(2349),
    [sym_preproc_line] = STATE(2349),
    [sym_preproc_pragma] = STATE(2349),
    [sym_preproc_nullable] = STATE(2349),
    [sym_preproc_error] = STATE(2349),
    [sym_preproc_define] = STATE(2349),
    [sym_preproc_undef] = STATE(2349),
    [sym__identifier_token] = ACTIONS(3621),
    [anon_sym_extern] = ACTIONS(3621),
    [anon_sym_alias] = ACTIONS(3621),
    [anon_sym_SEMI] = ACTIONS(3623),
    [anon_sym_global] = ACTIONS(3621),
    [anon_sym_using] = ACTIONS(3621),
    [anon_sym_unsafe] = ACTIONS(3621),
    [anon_sym_static] = ACTIONS(3621),
    [anon_sym_LBRACK] = ACTIONS(3623),
    [anon_sym_LPAREN] = ACTIONS(3623),
    [anon_sym_return] = ACTIONS(3621),
    [anon_sym_namespace] = ACTIONS(3621),
    [anon_sym_class] = ACTIONS(3621),
    [anon_sym_ref] = ACTIONS(3621),
    [anon_sym_struct] = ACTIONS(3621),
    [anon_sym_enum] = ACTIONS(3621),
    [anon_sym_LBRACE] = ACTIONS(3623),
    [anon_sym_interface] = ACTIONS(3621),
    [anon_sym_delegate] = ACTIONS(3621),
    [anon_sym_record] = ACTIONS(3621),
    [anon_sym_abstract] = ACTIONS(3621),
    [anon_sym_async] = ACTIONS(3621),
    [anon_sym_const] = ACTIONS(3621),
    [anon_sym_file] = ACTIONS(3621),
    [anon_sym_fixed] = ACTIONS(3621),
    [anon_sym_internal] = ACTIONS(3621),
    [anon_sym_new] = ACTIONS(3621),
    [anon_sym_override] = ACTIONS(3621),
    [anon_sym_partial] = ACTIONS(3621),
    [anon_sym_private] = ACTIONS(3621),
    [anon_sym_protected] = ACTIONS(3621),
    [anon_sym_public] = ACTIONS(3621),
    [anon_sym_readonly] = ACTIONS(3621),
    [anon_sym_required] = ACTIONS(3621),
    [anon_sym_sealed] = ACTIONS(3621),
    [anon_sym_virtual] = ACTIONS(3621),
    [anon_sym_volatile] = ACTIONS(3621),
    [anon_sym_where] = ACTIONS(3621),
    [anon_sym_notnull] = ACTIONS(3621),
    [anon_sym_unmanaged] = ACTIONS(3621),
    [anon_sym_checked] = ACTIONS(3621),
    [anon_sym_BANG] = ACTIONS(3623),
    [anon_sym_TILDE] = ACTIONS(3623),
    [anon_sym_PLUS_PLUS] = ACTIONS(3623),
    [anon_sym_DASH_DASH] = ACTIONS(3623),
    [anon_sym_true] = ACTIONS(3621),
    [anon_sym_false] = ACTIONS(3621),
    [anon_sym_PLUS] = ACTIONS(3621),
    [anon_sym_DASH] = ACTIONS(3621),
    [anon_sym_STAR] = ACTIONS(3623),
    [anon_sym_CARET] = ACTIONS(3623),
    [anon_sym_AMP] = ACTIONS(3623),
    [anon_sym_this] = ACTIONS(3621),
    [anon_sym_scoped] = ACTIONS(3621),
    [anon_sym_var] = ACTIONS(3621),
    [sym_predefined_type] = ACTIONS(3621),
    [anon_sym_break] = ACTIONS(3621),
    [anon_sym_unchecked] = ACTIONS(3621),
    [anon_sym_continue] = ACTIONS(3621),
    [anon_sym_do] = ACTIONS(3621),
    [anon_sym_while] = ACTIONS(3621),
    [anon_sym_for] = ACTIONS(3621),
    [anon_sym_lock] = ACTIONS(3621),
    [anon_sym_yield] = ACTIONS(3621),
    [anon_sym_switch] = ACTIONS(3621),
    [anon_sym_default] = ACTIONS(3621),
    [anon_sym_throw] = ACTIONS(3621),
    [anon_sym_try] = ACTIONS(3621),
    [anon_sym_when] = ACTIONS(3621),
    [anon_sym_await] = ACTIONS(3621),
    [anon_sym_foreach] = ACTIONS(3621),
    [anon_sym_goto] = ACTIONS(3621),
    [anon_sym_if] = ACTIONS(3621),
    [anon_sym_DOT_DOT] = ACTIONS(3623),
    [anon_sym_from] = ACTIONS(3621),
    [anon_sym_into] = ACTIONS(3621),
    [anon_sym_join] = ACTIONS(3621),
    [anon_sym_on] = ACTIONS(3621),
    [anon_sym_equals] = ACTIONS(3621),
    [anon_sym_let] = ACTIONS(3621),
    [anon_sym_orderby] = ACTIONS(3621),
    [anon_sym_ascending] = ACTIONS(3621),
    [anon_sym_descending] = ACTIONS(3621),
    [anon_sym_group] = ACTIONS(3621),
    [anon_sym_by] = ACTIONS(3621),
    [anon_sym_select] = ACTIONS(3621),
    [anon_sym_DQUOTE] = ACTIONS(3621),
    [anon_sym_stackalloc] = ACTIONS(3621),
    [anon_sym_sizeof] = ACTIONS(3621),
    [anon_sym_typeof] = ACTIONS(3621),
    [anon_sym___makeref] = ACTIONS(3621),
    [anon_sym___reftype] = ACTIONS(3621),
    [anon_sym___refvalue] = ACTIONS(3621),
    [sym_null_literal] = ACTIONS(3621),
    [anon_sym_SQUOTE] = ACTIONS(3623),
    [sym_integer_literal] = ACTIONS(3621),
    [sym_real_literal] = ACTIONS(3623),
    [sym_verbatim_string_literal] = ACTIONS(3623),
    [sym_raw_string_literal] = ACTIONS(3623),
    [aux_sym_preproc_if_token1] = ACTIONS(3623),
    [aux_sym_preproc_if_token3] = ACTIONS(3623),
    [aux_sym_preproc_else_token1] = ACTIONS(3623),
    [aux_sym_preproc_elif_token1] = ACTIONS(3623),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3623),
    [sym_interpolation_verbatim_start] = ACTIONS(3623),
    [sym_interpolation_raw_start] = ACTIONS(3623),
  },
  [2350] = {
    [sym_preproc_region] = STATE(2350),
    [sym_preproc_endregion] = STATE(2350),
    [sym_preproc_line] = STATE(2350),
    [sym_preproc_pragma] = STATE(2350),
    [sym_preproc_nullable] = STATE(2350),
    [sym_preproc_error] = STATE(2350),
    [sym_preproc_define] = STATE(2350),
    [sym_preproc_undef] = STATE(2350),
    [sym__identifier_token] = ACTIONS(3625),
    [anon_sym_extern] = ACTIONS(3625),
    [anon_sym_alias] = ACTIONS(3625),
    [anon_sym_SEMI] = ACTIONS(3627),
    [anon_sym_global] = ACTIONS(3625),
    [anon_sym_using] = ACTIONS(3625),
    [anon_sym_unsafe] = ACTIONS(3625),
    [anon_sym_static] = ACTIONS(3625),
    [anon_sym_LBRACK] = ACTIONS(3627),
    [anon_sym_LPAREN] = ACTIONS(3627),
    [anon_sym_return] = ACTIONS(3625),
    [anon_sym_namespace] = ACTIONS(3625),
    [anon_sym_class] = ACTIONS(3625),
    [anon_sym_ref] = ACTIONS(3625),
    [anon_sym_struct] = ACTIONS(3625),
    [anon_sym_enum] = ACTIONS(3625),
    [anon_sym_LBRACE] = ACTIONS(3627),
    [anon_sym_interface] = ACTIONS(3625),
    [anon_sym_delegate] = ACTIONS(3625),
    [anon_sym_record] = ACTIONS(3625),
    [anon_sym_abstract] = ACTIONS(3625),
    [anon_sym_async] = ACTIONS(3625),
    [anon_sym_const] = ACTIONS(3625),
    [anon_sym_file] = ACTIONS(3625),
    [anon_sym_fixed] = ACTIONS(3625),
    [anon_sym_internal] = ACTIONS(3625),
    [anon_sym_new] = ACTIONS(3625),
    [anon_sym_override] = ACTIONS(3625),
    [anon_sym_partial] = ACTIONS(3625),
    [anon_sym_private] = ACTIONS(3625),
    [anon_sym_protected] = ACTIONS(3625),
    [anon_sym_public] = ACTIONS(3625),
    [anon_sym_readonly] = ACTIONS(3625),
    [anon_sym_required] = ACTIONS(3625),
    [anon_sym_sealed] = ACTIONS(3625),
    [anon_sym_virtual] = ACTIONS(3625),
    [anon_sym_volatile] = ACTIONS(3625),
    [anon_sym_where] = ACTIONS(3625),
    [anon_sym_notnull] = ACTIONS(3625),
    [anon_sym_unmanaged] = ACTIONS(3625),
    [anon_sym_checked] = ACTIONS(3625),
    [anon_sym_BANG] = ACTIONS(3627),
    [anon_sym_TILDE] = ACTIONS(3627),
    [anon_sym_PLUS_PLUS] = ACTIONS(3627),
    [anon_sym_DASH_DASH] = ACTIONS(3627),
    [anon_sym_true] = ACTIONS(3625),
    [anon_sym_false] = ACTIONS(3625),
    [anon_sym_PLUS] = ACTIONS(3625),
    [anon_sym_DASH] = ACTIONS(3625),
    [anon_sym_STAR] = ACTIONS(3627),
    [anon_sym_CARET] = ACTIONS(3627),
    [anon_sym_AMP] = ACTIONS(3627),
    [anon_sym_this] = ACTIONS(3625),
    [anon_sym_scoped] = ACTIONS(3625),
    [anon_sym_var] = ACTIONS(3625),
    [sym_predefined_type] = ACTIONS(3625),
    [anon_sym_break] = ACTIONS(3625),
    [anon_sym_unchecked] = ACTIONS(3625),
    [anon_sym_continue] = ACTIONS(3625),
    [anon_sym_do] = ACTIONS(3625),
    [anon_sym_while] = ACTIONS(3625),
    [anon_sym_for] = ACTIONS(3625),
    [anon_sym_lock] = ACTIONS(3625),
    [anon_sym_yield] = ACTIONS(3625),
    [anon_sym_switch] = ACTIONS(3625),
    [anon_sym_default] = ACTIONS(3625),
    [anon_sym_throw] = ACTIONS(3625),
    [anon_sym_try] = ACTIONS(3625),
    [anon_sym_when] = ACTIONS(3625),
    [anon_sym_await] = ACTIONS(3625),
    [anon_sym_foreach] = ACTIONS(3625),
    [anon_sym_goto] = ACTIONS(3625),
    [anon_sym_if] = ACTIONS(3625),
    [anon_sym_DOT_DOT] = ACTIONS(3627),
    [anon_sym_from] = ACTIONS(3625),
    [anon_sym_into] = ACTIONS(3625),
    [anon_sym_join] = ACTIONS(3625),
    [anon_sym_on] = ACTIONS(3625),
    [anon_sym_equals] = ACTIONS(3625),
    [anon_sym_let] = ACTIONS(3625),
    [anon_sym_orderby] = ACTIONS(3625),
    [anon_sym_ascending] = ACTIONS(3625),
    [anon_sym_descending] = ACTIONS(3625),
    [anon_sym_group] = ACTIONS(3625),
    [anon_sym_by] = ACTIONS(3625),
    [anon_sym_select] = ACTIONS(3625),
    [anon_sym_DQUOTE] = ACTIONS(3625),
    [anon_sym_stackalloc] = ACTIONS(3625),
    [anon_sym_sizeof] = ACTIONS(3625),
    [anon_sym_typeof] = ACTIONS(3625),
    [anon_sym___makeref] = ACTIONS(3625),
    [anon_sym___reftype] = ACTIONS(3625),
    [anon_sym___refvalue] = ACTIONS(3625),
    [sym_null_literal] = ACTIONS(3625),
    [anon_sym_SQUOTE] = ACTIONS(3627),
    [sym_integer_literal] = ACTIONS(3625),
    [sym_real_literal] = ACTIONS(3627),
    [sym_verbatim_string_literal] = ACTIONS(3627),
    [sym_raw_string_literal] = ACTIONS(3627),
    [aux_sym_preproc_if_token1] = ACTIONS(3627),
    [aux_sym_preproc_if_token3] = ACTIONS(3627),
    [aux_sym_preproc_else_token1] = ACTIONS(3627),
    [aux_sym_preproc_elif_token1] = ACTIONS(3627),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3627),
    [sym_interpolation_verbatim_start] = ACTIONS(3627),
    [sym_interpolation_raw_start] = ACTIONS(3627),
  },
  [2351] = {
    [sym_preproc_region] = STATE(2351),
    [sym_preproc_endregion] = STATE(2351),
    [sym_preproc_line] = STATE(2351),
    [sym_preproc_pragma] = STATE(2351),
    [sym_preproc_nullable] = STATE(2351),
    [sym_preproc_error] = STATE(2351),
    [sym_preproc_define] = STATE(2351),
    [sym_preproc_undef] = STATE(2351),
    [sym__identifier_token] = ACTIONS(3629),
    [anon_sym_extern] = ACTIONS(3629),
    [anon_sym_alias] = ACTIONS(3629),
    [anon_sym_SEMI] = ACTIONS(3631),
    [anon_sym_global] = ACTIONS(3629),
    [anon_sym_using] = ACTIONS(3629),
    [anon_sym_unsafe] = ACTIONS(3629),
    [anon_sym_static] = ACTIONS(3629),
    [anon_sym_LBRACK] = ACTIONS(3631),
    [anon_sym_LPAREN] = ACTIONS(3631),
    [anon_sym_return] = ACTIONS(3629),
    [anon_sym_namespace] = ACTIONS(3629),
    [anon_sym_class] = ACTIONS(3629),
    [anon_sym_ref] = ACTIONS(3629),
    [anon_sym_struct] = ACTIONS(3629),
    [anon_sym_enum] = ACTIONS(3629),
    [anon_sym_LBRACE] = ACTIONS(3631),
    [anon_sym_interface] = ACTIONS(3629),
    [anon_sym_delegate] = ACTIONS(3629),
    [anon_sym_record] = ACTIONS(3629),
    [anon_sym_abstract] = ACTIONS(3629),
    [anon_sym_async] = ACTIONS(3629),
    [anon_sym_const] = ACTIONS(3629),
    [anon_sym_file] = ACTIONS(3629),
    [anon_sym_fixed] = ACTIONS(3629),
    [anon_sym_internal] = ACTIONS(3629),
    [anon_sym_new] = ACTIONS(3629),
    [anon_sym_override] = ACTIONS(3629),
    [anon_sym_partial] = ACTIONS(3629),
    [anon_sym_private] = ACTIONS(3629),
    [anon_sym_protected] = ACTIONS(3629),
    [anon_sym_public] = ACTIONS(3629),
    [anon_sym_readonly] = ACTIONS(3629),
    [anon_sym_required] = ACTIONS(3629),
    [anon_sym_sealed] = ACTIONS(3629),
    [anon_sym_virtual] = ACTIONS(3629),
    [anon_sym_volatile] = ACTIONS(3629),
    [anon_sym_where] = ACTIONS(3629),
    [anon_sym_notnull] = ACTIONS(3629),
    [anon_sym_unmanaged] = ACTIONS(3629),
    [anon_sym_checked] = ACTIONS(3629),
    [anon_sym_BANG] = ACTIONS(3631),
    [anon_sym_TILDE] = ACTIONS(3631),
    [anon_sym_PLUS_PLUS] = ACTIONS(3631),
    [anon_sym_DASH_DASH] = ACTIONS(3631),
    [anon_sym_true] = ACTIONS(3629),
    [anon_sym_false] = ACTIONS(3629),
    [anon_sym_PLUS] = ACTIONS(3629),
    [anon_sym_DASH] = ACTIONS(3629),
    [anon_sym_STAR] = ACTIONS(3631),
    [anon_sym_CARET] = ACTIONS(3631),
    [anon_sym_AMP] = ACTIONS(3631),
    [anon_sym_this] = ACTIONS(3629),
    [anon_sym_scoped] = ACTIONS(3629),
    [anon_sym_var] = ACTIONS(3629),
    [sym_predefined_type] = ACTIONS(3629),
    [anon_sym_break] = ACTIONS(3629),
    [anon_sym_unchecked] = ACTIONS(3629),
    [anon_sym_continue] = ACTIONS(3629),
    [anon_sym_do] = ACTIONS(3629),
    [anon_sym_while] = ACTIONS(3629),
    [anon_sym_for] = ACTIONS(3629),
    [anon_sym_lock] = ACTIONS(3629),
    [anon_sym_yield] = ACTIONS(3629),
    [anon_sym_switch] = ACTIONS(3629),
    [anon_sym_default] = ACTIONS(3629),
    [anon_sym_throw] = ACTIONS(3629),
    [anon_sym_try] = ACTIONS(3629),
    [anon_sym_when] = ACTIONS(3629),
    [anon_sym_await] = ACTIONS(3629),
    [anon_sym_foreach] = ACTIONS(3629),
    [anon_sym_goto] = ACTIONS(3629),
    [anon_sym_if] = ACTIONS(3629),
    [anon_sym_DOT_DOT] = ACTIONS(3631),
    [anon_sym_from] = ACTIONS(3629),
    [anon_sym_into] = ACTIONS(3629),
    [anon_sym_join] = ACTIONS(3629),
    [anon_sym_on] = ACTIONS(3629),
    [anon_sym_equals] = ACTIONS(3629),
    [anon_sym_let] = ACTIONS(3629),
    [anon_sym_orderby] = ACTIONS(3629),
    [anon_sym_ascending] = ACTIONS(3629),
    [anon_sym_descending] = ACTIONS(3629),
    [anon_sym_group] = ACTIONS(3629),
    [anon_sym_by] = ACTIONS(3629),
    [anon_sym_select] = ACTIONS(3629),
    [anon_sym_DQUOTE] = ACTIONS(3629),
    [anon_sym_stackalloc] = ACTIONS(3629),
    [anon_sym_sizeof] = ACTIONS(3629),
    [anon_sym_typeof] = ACTIONS(3629),
    [anon_sym___makeref] = ACTIONS(3629),
    [anon_sym___reftype] = ACTIONS(3629),
    [anon_sym___refvalue] = ACTIONS(3629),
    [sym_null_literal] = ACTIONS(3629),
    [anon_sym_SQUOTE] = ACTIONS(3631),
    [sym_integer_literal] = ACTIONS(3629),
    [sym_real_literal] = ACTIONS(3631),
    [sym_verbatim_string_literal] = ACTIONS(3631),
    [sym_raw_string_literal] = ACTIONS(3631),
    [aux_sym_preproc_if_token1] = ACTIONS(3631),
    [aux_sym_preproc_if_token3] = ACTIONS(3631),
    [aux_sym_preproc_else_token1] = ACTIONS(3631),
    [aux_sym_preproc_elif_token1] = ACTIONS(3631),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3631),
    [sym_interpolation_verbatim_start] = ACTIONS(3631),
    [sym_interpolation_raw_start] = ACTIONS(3631),
  },
  [2352] = {
    [sym_preproc_region] = STATE(2352),
    [sym_preproc_endregion] = STATE(2352),
    [sym_preproc_line] = STATE(2352),
    [sym_preproc_pragma] = STATE(2352),
    [sym_preproc_nullable] = STATE(2352),
    [sym_preproc_error] = STATE(2352),
    [sym_preproc_define] = STATE(2352),
    [sym_preproc_undef] = STATE(2352),
    [sym__identifier_token] = ACTIONS(3633),
    [anon_sym_extern] = ACTIONS(3633),
    [anon_sym_alias] = ACTIONS(3633),
    [anon_sym_SEMI] = ACTIONS(3635),
    [anon_sym_global] = ACTIONS(3633),
    [anon_sym_using] = ACTIONS(3633),
    [anon_sym_unsafe] = ACTIONS(3633),
    [anon_sym_static] = ACTIONS(3633),
    [anon_sym_LBRACK] = ACTIONS(3635),
    [anon_sym_LPAREN] = ACTIONS(3635),
    [anon_sym_return] = ACTIONS(3633),
    [anon_sym_namespace] = ACTIONS(3633),
    [anon_sym_class] = ACTIONS(3633),
    [anon_sym_ref] = ACTIONS(3633),
    [anon_sym_struct] = ACTIONS(3633),
    [anon_sym_enum] = ACTIONS(3633),
    [anon_sym_LBRACE] = ACTIONS(3635),
    [anon_sym_interface] = ACTIONS(3633),
    [anon_sym_delegate] = ACTIONS(3633),
    [anon_sym_record] = ACTIONS(3633),
    [anon_sym_abstract] = ACTIONS(3633),
    [anon_sym_async] = ACTIONS(3633),
    [anon_sym_const] = ACTIONS(3633),
    [anon_sym_file] = ACTIONS(3633),
    [anon_sym_fixed] = ACTIONS(3633),
    [anon_sym_internal] = ACTIONS(3633),
    [anon_sym_new] = ACTIONS(3633),
    [anon_sym_override] = ACTIONS(3633),
    [anon_sym_partial] = ACTIONS(3633),
    [anon_sym_private] = ACTIONS(3633),
    [anon_sym_protected] = ACTIONS(3633),
    [anon_sym_public] = ACTIONS(3633),
    [anon_sym_readonly] = ACTIONS(3633),
    [anon_sym_required] = ACTIONS(3633),
    [anon_sym_sealed] = ACTIONS(3633),
    [anon_sym_virtual] = ACTIONS(3633),
    [anon_sym_volatile] = ACTIONS(3633),
    [anon_sym_where] = ACTIONS(3633),
    [anon_sym_notnull] = ACTIONS(3633),
    [anon_sym_unmanaged] = ACTIONS(3633),
    [anon_sym_checked] = ACTIONS(3633),
    [anon_sym_BANG] = ACTIONS(3635),
    [anon_sym_TILDE] = ACTIONS(3635),
    [anon_sym_PLUS_PLUS] = ACTIONS(3635),
    [anon_sym_DASH_DASH] = ACTIONS(3635),
    [anon_sym_true] = ACTIONS(3633),
    [anon_sym_false] = ACTIONS(3633),
    [anon_sym_PLUS] = ACTIONS(3633),
    [anon_sym_DASH] = ACTIONS(3633),
    [anon_sym_STAR] = ACTIONS(3635),
    [anon_sym_CARET] = ACTIONS(3635),
    [anon_sym_AMP] = ACTIONS(3635),
    [anon_sym_this] = ACTIONS(3633),
    [anon_sym_scoped] = ACTIONS(3633),
    [anon_sym_var] = ACTIONS(3633),
    [sym_predefined_type] = ACTIONS(3633),
    [anon_sym_break] = ACTIONS(3633),
    [anon_sym_unchecked] = ACTIONS(3633),
    [anon_sym_continue] = ACTIONS(3633),
    [anon_sym_do] = ACTIONS(3633),
    [anon_sym_while] = ACTIONS(3633),
    [anon_sym_for] = ACTIONS(3633),
    [anon_sym_lock] = ACTIONS(3633),
    [anon_sym_yield] = ACTIONS(3633),
    [anon_sym_switch] = ACTIONS(3633),
    [anon_sym_default] = ACTIONS(3633),
    [anon_sym_throw] = ACTIONS(3633),
    [anon_sym_try] = ACTIONS(3633),
    [anon_sym_when] = ACTIONS(3633),
    [anon_sym_await] = ACTIONS(3633),
    [anon_sym_foreach] = ACTIONS(3633),
    [anon_sym_goto] = ACTIONS(3633),
    [anon_sym_if] = ACTIONS(3633),
    [anon_sym_DOT_DOT] = ACTIONS(3635),
    [anon_sym_from] = ACTIONS(3633),
    [anon_sym_into] = ACTIONS(3633),
    [anon_sym_join] = ACTIONS(3633),
    [anon_sym_on] = ACTIONS(3633),
    [anon_sym_equals] = ACTIONS(3633),
    [anon_sym_let] = ACTIONS(3633),
    [anon_sym_orderby] = ACTIONS(3633),
    [anon_sym_ascending] = ACTIONS(3633),
    [anon_sym_descending] = ACTIONS(3633),
    [anon_sym_group] = ACTIONS(3633),
    [anon_sym_by] = ACTIONS(3633),
    [anon_sym_select] = ACTIONS(3633),
    [anon_sym_DQUOTE] = ACTIONS(3633),
    [anon_sym_stackalloc] = ACTIONS(3633),
    [anon_sym_sizeof] = ACTIONS(3633),
    [anon_sym_typeof] = ACTIONS(3633),
    [anon_sym___makeref] = ACTIONS(3633),
    [anon_sym___reftype] = ACTIONS(3633),
    [anon_sym___refvalue] = ACTIONS(3633),
    [sym_null_literal] = ACTIONS(3633),
    [anon_sym_SQUOTE] = ACTIONS(3635),
    [sym_integer_literal] = ACTIONS(3633),
    [sym_real_literal] = ACTIONS(3635),
    [sym_verbatim_string_literal] = ACTIONS(3635),
    [sym_raw_string_literal] = ACTIONS(3635),
    [aux_sym_preproc_if_token1] = ACTIONS(3635),
    [aux_sym_preproc_if_token3] = ACTIONS(3635),
    [aux_sym_preproc_else_token1] = ACTIONS(3635),
    [aux_sym_preproc_elif_token1] = ACTIONS(3635),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3635),
    [sym_interpolation_verbatim_start] = ACTIONS(3635),
    [sym_interpolation_raw_start] = ACTIONS(3635),
  },
  [2353] = {
    [sym_preproc_region] = STATE(2353),
    [sym_preproc_endregion] = STATE(2353),
    [sym_preproc_line] = STATE(2353),
    [sym_preproc_pragma] = STATE(2353),
    [sym_preproc_nullable] = STATE(2353),
    [sym_preproc_error] = STATE(2353),
    [sym_preproc_define] = STATE(2353),
    [sym_preproc_undef] = STATE(2353),
    [sym__identifier_token] = ACTIONS(3637),
    [anon_sym_extern] = ACTIONS(3637),
    [anon_sym_alias] = ACTIONS(3637),
    [anon_sym_SEMI] = ACTIONS(3639),
    [anon_sym_global] = ACTIONS(3637),
    [anon_sym_using] = ACTIONS(3637),
    [anon_sym_unsafe] = ACTIONS(3637),
    [anon_sym_static] = ACTIONS(3637),
    [anon_sym_LBRACK] = ACTIONS(3639),
    [anon_sym_LPAREN] = ACTIONS(3639),
    [anon_sym_return] = ACTIONS(3637),
    [anon_sym_namespace] = ACTIONS(3637),
    [anon_sym_class] = ACTIONS(3637),
    [anon_sym_ref] = ACTIONS(3637),
    [anon_sym_struct] = ACTIONS(3637),
    [anon_sym_enum] = ACTIONS(3637),
    [anon_sym_LBRACE] = ACTIONS(3639),
    [anon_sym_interface] = ACTIONS(3637),
    [anon_sym_delegate] = ACTIONS(3637),
    [anon_sym_record] = ACTIONS(3637),
    [anon_sym_abstract] = ACTIONS(3637),
    [anon_sym_async] = ACTIONS(3637),
    [anon_sym_const] = ACTIONS(3637),
    [anon_sym_file] = ACTIONS(3637),
    [anon_sym_fixed] = ACTIONS(3637),
    [anon_sym_internal] = ACTIONS(3637),
    [anon_sym_new] = ACTIONS(3637),
    [anon_sym_override] = ACTIONS(3637),
    [anon_sym_partial] = ACTIONS(3637),
    [anon_sym_private] = ACTIONS(3637),
    [anon_sym_protected] = ACTIONS(3637),
    [anon_sym_public] = ACTIONS(3637),
    [anon_sym_readonly] = ACTIONS(3637),
    [anon_sym_required] = ACTIONS(3637),
    [anon_sym_sealed] = ACTIONS(3637),
    [anon_sym_virtual] = ACTIONS(3637),
    [anon_sym_volatile] = ACTIONS(3637),
    [anon_sym_where] = ACTIONS(3637),
    [anon_sym_notnull] = ACTIONS(3637),
    [anon_sym_unmanaged] = ACTIONS(3637),
    [anon_sym_checked] = ACTIONS(3637),
    [anon_sym_BANG] = ACTIONS(3639),
    [anon_sym_TILDE] = ACTIONS(3639),
    [anon_sym_PLUS_PLUS] = ACTIONS(3639),
    [anon_sym_DASH_DASH] = ACTIONS(3639),
    [anon_sym_true] = ACTIONS(3637),
    [anon_sym_false] = ACTIONS(3637),
    [anon_sym_PLUS] = ACTIONS(3637),
    [anon_sym_DASH] = ACTIONS(3637),
    [anon_sym_STAR] = ACTIONS(3639),
    [anon_sym_CARET] = ACTIONS(3639),
    [anon_sym_AMP] = ACTIONS(3639),
    [anon_sym_this] = ACTIONS(3637),
    [anon_sym_scoped] = ACTIONS(3637),
    [anon_sym_var] = ACTIONS(3637),
    [sym_predefined_type] = ACTIONS(3637),
    [anon_sym_break] = ACTIONS(3637),
    [anon_sym_unchecked] = ACTIONS(3637),
    [anon_sym_continue] = ACTIONS(3637),
    [anon_sym_do] = ACTIONS(3637),
    [anon_sym_while] = ACTIONS(3637),
    [anon_sym_for] = ACTIONS(3637),
    [anon_sym_lock] = ACTIONS(3637),
    [anon_sym_yield] = ACTIONS(3637),
    [anon_sym_switch] = ACTIONS(3637),
    [anon_sym_default] = ACTIONS(3637),
    [anon_sym_throw] = ACTIONS(3637),
    [anon_sym_try] = ACTIONS(3637),
    [anon_sym_when] = ACTIONS(3637),
    [anon_sym_await] = ACTIONS(3637),
    [anon_sym_foreach] = ACTIONS(3637),
    [anon_sym_goto] = ACTIONS(3637),
    [anon_sym_if] = ACTIONS(3637),
    [anon_sym_DOT_DOT] = ACTIONS(3639),
    [anon_sym_from] = ACTIONS(3637),
    [anon_sym_into] = ACTIONS(3637),
    [anon_sym_join] = ACTIONS(3637),
    [anon_sym_on] = ACTIONS(3637),
    [anon_sym_equals] = ACTIONS(3637),
    [anon_sym_let] = ACTIONS(3637),
    [anon_sym_orderby] = ACTIONS(3637),
    [anon_sym_ascending] = ACTIONS(3637),
    [anon_sym_descending] = ACTIONS(3637),
    [anon_sym_group] = ACTIONS(3637),
    [anon_sym_by] = ACTIONS(3637),
    [anon_sym_select] = ACTIONS(3637),
    [anon_sym_DQUOTE] = ACTIONS(3637),
    [anon_sym_stackalloc] = ACTIONS(3637),
    [anon_sym_sizeof] = ACTIONS(3637),
    [anon_sym_typeof] = ACTIONS(3637),
    [anon_sym___makeref] = ACTIONS(3637),
    [anon_sym___reftype] = ACTIONS(3637),
    [anon_sym___refvalue] = ACTIONS(3637),
    [sym_null_literal] = ACTIONS(3637),
    [anon_sym_SQUOTE] = ACTIONS(3639),
    [sym_integer_literal] = ACTIONS(3637),
    [sym_real_literal] = ACTIONS(3639),
    [sym_verbatim_string_literal] = ACTIONS(3639),
    [sym_raw_string_literal] = ACTIONS(3639),
    [aux_sym_preproc_if_token1] = ACTIONS(3639),
    [aux_sym_preproc_if_token3] = ACTIONS(3639),
    [aux_sym_preproc_else_token1] = ACTIONS(3639),
    [aux_sym_preproc_elif_token1] = ACTIONS(3639),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3639),
    [sym_interpolation_verbatim_start] = ACTIONS(3639),
    [sym_interpolation_raw_start] = ACTIONS(3639),
  },
  [2354] = {
    [sym_preproc_region] = STATE(2354),
    [sym_preproc_endregion] = STATE(2354),
    [sym_preproc_line] = STATE(2354),
    [sym_preproc_pragma] = STATE(2354),
    [sym_preproc_nullable] = STATE(2354),
    [sym_preproc_error] = STATE(2354),
    [sym_preproc_define] = STATE(2354),
    [sym_preproc_undef] = STATE(2354),
    [sym__identifier_token] = ACTIONS(3641),
    [anon_sym_extern] = ACTIONS(3641),
    [anon_sym_alias] = ACTIONS(3641),
    [anon_sym_SEMI] = ACTIONS(3643),
    [anon_sym_global] = ACTIONS(3641),
    [anon_sym_using] = ACTIONS(3641),
    [anon_sym_unsafe] = ACTIONS(3641),
    [anon_sym_static] = ACTIONS(3641),
    [anon_sym_LBRACK] = ACTIONS(3643),
    [anon_sym_LPAREN] = ACTIONS(3643),
    [anon_sym_return] = ACTIONS(3641),
    [anon_sym_namespace] = ACTIONS(3641),
    [anon_sym_class] = ACTIONS(3641),
    [anon_sym_ref] = ACTIONS(3641),
    [anon_sym_struct] = ACTIONS(3641),
    [anon_sym_enum] = ACTIONS(3641),
    [anon_sym_LBRACE] = ACTIONS(3643),
    [anon_sym_interface] = ACTIONS(3641),
    [anon_sym_delegate] = ACTIONS(3641),
    [anon_sym_record] = ACTIONS(3641),
    [anon_sym_abstract] = ACTIONS(3641),
    [anon_sym_async] = ACTIONS(3641),
    [anon_sym_const] = ACTIONS(3641),
    [anon_sym_file] = ACTIONS(3641),
    [anon_sym_fixed] = ACTIONS(3641),
    [anon_sym_internal] = ACTIONS(3641),
    [anon_sym_new] = ACTIONS(3641),
    [anon_sym_override] = ACTIONS(3641),
    [anon_sym_partial] = ACTIONS(3641),
    [anon_sym_private] = ACTIONS(3641),
    [anon_sym_protected] = ACTIONS(3641),
    [anon_sym_public] = ACTIONS(3641),
    [anon_sym_readonly] = ACTIONS(3641),
    [anon_sym_required] = ACTIONS(3641),
    [anon_sym_sealed] = ACTIONS(3641),
    [anon_sym_virtual] = ACTIONS(3641),
    [anon_sym_volatile] = ACTIONS(3641),
    [anon_sym_where] = ACTIONS(3641),
    [anon_sym_notnull] = ACTIONS(3641),
    [anon_sym_unmanaged] = ACTIONS(3641),
    [anon_sym_checked] = ACTIONS(3641),
    [anon_sym_BANG] = ACTIONS(3643),
    [anon_sym_TILDE] = ACTIONS(3643),
    [anon_sym_PLUS_PLUS] = ACTIONS(3643),
    [anon_sym_DASH_DASH] = ACTIONS(3643),
    [anon_sym_true] = ACTIONS(3641),
    [anon_sym_false] = ACTIONS(3641),
    [anon_sym_PLUS] = ACTIONS(3641),
    [anon_sym_DASH] = ACTIONS(3641),
    [anon_sym_STAR] = ACTIONS(3643),
    [anon_sym_CARET] = ACTIONS(3643),
    [anon_sym_AMP] = ACTIONS(3643),
    [anon_sym_this] = ACTIONS(3641),
    [anon_sym_scoped] = ACTIONS(3641),
    [anon_sym_var] = ACTIONS(3641),
    [sym_predefined_type] = ACTIONS(3641),
    [anon_sym_break] = ACTIONS(3641),
    [anon_sym_unchecked] = ACTIONS(3641),
    [anon_sym_continue] = ACTIONS(3641),
    [anon_sym_do] = ACTIONS(3641),
    [anon_sym_while] = ACTIONS(3641),
    [anon_sym_for] = ACTIONS(3641),
    [anon_sym_lock] = ACTIONS(3641),
    [anon_sym_yield] = ACTIONS(3641),
    [anon_sym_switch] = ACTIONS(3641),
    [anon_sym_default] = ACTIONS(3641),
    [anon_sym_throw] = ACTIONS(3641),
    [anon_sym_try] = ACTIONS(3641),
    [anon_sym_when] = ACTIONS(3641),
    [anon_sym_await] = ACTIONS(3641),
    [anon_sym_foreach] = ACTIONS(3641),
    [anon_sym_goto] = ACTIONS(3641),
    [anon_sym_if] = ACTIONS(3641),
    [anon_sym_DOT_DOT] = ACTIONS(3643),
    [anon_sym_from] = ACTIONS(3641),
    [anon_sym_into] = ACTIONS(3641),
    [anon_sym_join] = ACTIONS(3641),
    [anon_sym_on] = ACTIONS(3641),
    [anon_sym_equals] = ACTIONS(3641),
    [anon_sym_let] = ACTIONS(3641),
    [anon_sym_orderby] = ACTIONS(3641),
    [anon_sym_ascending] = ACTIONS(3641),
    [anon_sym_descending] = ACTIONS(3641),
    [anon_sym_group] = ACTIONS(3641),
    [anon_sym_by] = ACTIONS(3641),
    [anon_sym_select] = ACTIONS(3641),
    [anon_sym_DQUOTE] = ACTIONS(3641),
    [anon_sym_stackalloc] = ACTIONS(3641),
    [anon_sym_sizeof] = ACTIONS(3641),
    [anon_sym_typeof] = ACTIONS(3641),
    [anon_sym___makeref] = ACTIONS(3641),
    [anon_sym___reftype] = ACTIONS(3641),
    [anon_sym___refvalue] = ACTIONS(3641),
    [sym_null_literal] = ACTIONS(3641),
    [anon_sym_SQUOTE] = ACTIONS(3643),
    [sym_integer_literal] = ACTIONS(3641),
    [sym_real_literal] = ACTIONS(3643),
    [sym_verbatim_string_literal] = ACTIONS(3643),
    [sym_raw_string_literal] = ACTIONS(3643),
    [aux_sym_preproc_if_token1] = ACTIONS(3643),
    [aux_sym_preproc_if_token3] = ACTIONS(3643),
    [aux_sym_preproc_else_token1] = ACTIONS(3643),
    [aux_sym_preproc_elif_token1] = ACTIONS(3643),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3643),
    [sym_interpolation_verbatim_start] = ACTIONS(3643),
    [sym_interpolation_raw_start] = ACTIONS(3643),
  },
  [2355] = {
    [sym_preproc_region] = STATE(2355),
    [sym_preproc_endregion] = STATE(2355),
    [sym_preproc_line] = STATE(2355),
    [sym_preproc_pragma] = STATE(2355),
    [sym_preproc_nullable] = STATE(2355),
    [sym_preproc_error] = STATE(2355),
    [sym_preproc_define] = STATE(2355),
    [sym_preproc_undef] = STATE(2355),
    [sym__identifier_token] = ACTIONS(3645),
    [anon_sym_extern] = ACTIONS(3645),
    [anon_sym_alias] = ACTIONS(3645),
    [anon_sym_SEMI] = ACTIONS(3647),
    [anon_sym_global] = ACTIONS(3645),
    [anon_sym_using] = ACTIONS(3645),
    [anon_sym_unsafe] = ACTIONS(3645),
    [anon_sym_static] = ACTIONS(3645),
    [anon_sym_LBRACK] = ACTIONS(3647),
    [anon_sym_LPAREN] = ACTIONS(3647),
    [anon_sym_return] = ACTIONS(3645),
    [anon_sym_namespace] = ACTIONS(3645),
    [anon_sym_class] = ACTIONS(3645),
    [anon_sym_ref] = ACTIONS(3645),
    [anon_sym_struct] = ACTIONS(3645),
    [anon_sym_enum] = ACTIONS(3645),
    [anon_sym_LBRACE] = ACTIONS(3647),
    [anon_sym_interface] = ACTIONS(3645),
    [anon_sym_delegate] = ACTIONS(3645),
    [anon_sym_record] = ACTIONS(3645),
    [anon_sym_abstract] = ACTIONS(3645),
    [anon_sym_async] = ACTIONS(3645),
    [anon_sym_const] = ACTIONS(3645),
    [anon_sym_file] = ACTIONS(3645),
    [anon_sym_fixed] = ACTIONS(3645),
    [anon_sym_internal] = ACTIONS(3645),
    [anon_sym_new] = ACTIONS(3645),
    [anon_sym_override] = ACTIONS(3645),
    [anon_sym_partial] = ACTIONS(3645),
    [anon_sym_private] = ACTIONS(3645),
    [anon_sym_protected] = ACTIONS(3645),
    [anon_sym_public] = ACTIONS(3645),
    [anon_sym_readonly] = ACTIONS(3645),
    [anon_sym_required] = ACTIONS(3645),
    [anon_sym_sealed] = ACTIONS(3645),
    [anon_sym_virtual] = ACTIONS(3645),
    [anon_sym_volatile] = ACTIONS(3645),
    [anon_sym_where] = ACTIONS(3645),
    [anon_sym_notnull] = ACTIONS(3645),
    [anon_sym_unmanaged] = ACTIONS(3645),
    [anon_sym_checked] = ACTIONS(3645),
    [anon_sym_BANG] = ACTIONS(3647),
    [anon_sym_TILDE] = ACTIONS(3647),
    [anon_sym_PLUS_PLUS] = ACTIONS(3647),
    [anon_sym_DASH_DASH] = ACTIONS(3647),
    [anon_sym_true] = ACTIONS(3645),
    [anon_sym_false] = ACTIONS(3645),
    [anon_sym_PLUS] = ACTIONS(3645),
    [anon_sym_DASH] = ACTIONS(3645),
    [anon_sym_STAR] = ACTIONS(3647),
    [anon_sym_CARET] = ACTIONS(3647),
    [anon_sym_AMP] = ACTIONS(3647),
    [anon_sym_this] = ACTIONS(3645),
    [anon_sym_scoped] = ACTIONS(3645),
    [anon_sym_var] = ACTIONS(3645),
    [sym_predefined_type] = ACTIONS(3645),
    [anon_sym_break] = ACTIONS(3645),
    [anon_sym_unchecked] = ACTIONS(3645),
    [anon_sym_continue] = ACTIONS(3645),
    [anon_sym_do] = ACTIONS(3645),
    [anon_sym_while] = ACTIONS(3645),
    [anon_sym_for] = ACTIONS(3645),
    [anon_sym_lock] = ACTIONS(3645),
    [anon_sym_yield] = ACTIONS(3645),
    [anon_sym_switch] = ACTIONS(3645),
    [anon_sym_default] = ACTIONS(3645),
    [anon_sym_throw] = ACTIONS(3645),
    [anon_sym_try] = ACTIONS(3645),
    [anon_sym_when] = ACTIONS(3645),
    [anon_sym_await] = ACTIONS(3645),
    [anon_sym_foreach] = ACTIONS(3645),
    [anon_sym_goto] = ACTIONS(3645),
    [anon_sym_if] = ACTIONS(3645),
    [anon_sym_DOT_DOT] = ACTIONS(3647),
    [anon_sym_from] = ACTIONS(3645),
    [anon_sym_into] = ACTIONS(3645),
    [anon_sym_join] = ACTIONS(3645),
    [anon_sym_on] = ACTIONS(3645),
    [anon_sym_equals] = ACTIONS(3645),
    [anon_sym_let] = ACTIONS(3645),
    [anon_sym_orderby] = ACTIONS(3645),
    [anon_sym_ascending] = ACTIONS(3645),
    [anon_sym_descending] = ACTIONS(3645),
    [anon_sym_group] = ACTIONS(3645),
    [anon_sym_by] = ACTIONS(3645),
    [anon_sym_select] = ACTIONS(3645),
    [anon_sym_DQUOTE] = ACTIONS(3645),
    [anon_sym_stackalloc] = ACTIONS(3645),
    [anon_sym_sizeof] = ACTIONS(3645),
    [anon_sym_typeof] = ACTIONS(3645),
    [anon_sym___makeref] = ACTIONS(3645),
    [anon_sym___reftype] = ACTIONS(3645),
    [anon_sym___refvalue] = ACTIONS(3645),
    [sym_null_literal] = ACTIONS(3645),
    [anon_sym_SQUOTE] = ACTIONS(3647),
    [sym_integer_literal] = ACTIONS(3645),
    [sym_real_literal] = ACTIONS(3647),
    [sym_verbatim_string_literal] = ACTIONS(3647),
    [sym_raw_string_literal] = ACTIONS(3647),
    [aux_sym_preproc_if_token1] = ACTIONS(3647),
    [aux_sym_preproc_if_token3] = ACTIONS(3647),
    [aux_sym_preproc_else_token1] = ACTIONS(3647),
    [aux_sym_preproc_elif_token1] = ACTIONS(3647),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3647),
    [sym_interpolation_verbatim_start] = ACTIONS(3647),
    [sym_interpolation_raw_start] = ACTIONS(3647),
  },
  [2356] = {
    [sym_preproc_region] = STATE(2356),
    [sym_preproc_endregion] = STATE(2356),
    [sym_preproc_line] = STATE(2356),
    [sym_preproc_pragma] = STATE(2356),
    [sym_preproc_nullable] = STATE(2356),
    [sym_preproc_error] = STATE(2356),
    [sym_preproc_define] = STATE(2356),
    [sym_preproc_undef] = STATE(2356),
    [sym__identifier_token] = ACTIONS(3649),
    [anon_sym_extern] = ACTIONS(3649),
    [anon_sym_alias] = ACTIONS(3649),
    [anon_sym_SEMI] = ACTIONS(3651),
    [anon_sym_global] = ACTIONS(3649),
    [anon_sym_using] = ACTIONS(3649),
    [anon_sym_unsafe] = ACTIONS(3649),
    [anon_sym_static] = ACTIONS(3649),
    [anon_sym_LBRACK] = ACTIONS(3651),
    [anon_sym_LPAREN] = ACTIONS(3651),
    [anon_sym_return] = ACTIONS(3649),
    [anon_sym_namespace] = ACTIONS(3649),
    [anon_sym_class] = ACTIONS(3649),
    [anon_sym_ref] = ACTIONS(3649),
    [anon_sym_struct] = ACTIONS(3649),
    [anon_sym_enum] = ACTIONS(3649),
    [anon_sym_LBRACE] = ACTIONS(3651),
    [anon_sym_interface] = ACTIONS(3649),
    [anon_sym_delegate] = ACTIONS(3649),
    [anon_sym_record] = ACTIONS(3649),
    [anon_sym_abstract] = ACTIONS(3649),
    [anon_sym_async] = ACTIONS(3649),
    [anon_sym_const] = ACTIONS(3649),
    [anon_sym_file] = ACTIONS(3649),
    [anon_sym_fixed] = ACTIONS(3649),
    [anon_sym_internal] = ACTIONS(3649),
    [anon_sym_new] = ACTIONS(3649),
    [anon_sym_override] = ACTIONS(3649),
    [anon_sym_partial] = ACTIONS(3649),
    [anon_sym_private] = ACTIONS(3649),
    [anon_sym_protected] = ACTIONS(3649),
    [anon_sym_public] = ACTIONS(3649),
    [anon_sym_readonly] = ACTIONS(3649),
    [anon_sym_required] = ACTIONS(3649),
    [anon_sym_sealed] = ACTIONS(3649),
    [anon_sym_virtual] = ACTIONS(3649),
    [anon_sym_volatile] = ACTIONS(3649),
    [anon_sym_where] = ACTIONS(3649),
    [anon_sym_notnull] = ACTIONS(3649),
    [anon_sym_unmanaged] = ACTIONS(3649),
    [anon_sym_checked] = ACTIONS(3649),
    [anon_sym_BANG] = ACTIONS(3651),
    [anon_sym_TILDE] = ACTIONS(3651),
    [anon_sym_PLUS_PLUS] = ACTIONS(3651),
    [anon_sym_DASH_DASH] = ACTIONS(3651),
    [anon_sym_true] = ACTIONS(3649),
    [anon_sym_false] = ACTIONS(3649),
    [anon_sym_PLUS] = ACTIONS(3649),
    [anon_sym_DASH] = ACTIONS(3649),
    [anon_sym_STAR] = ACTIONS(3651),
    [anon_sym_CARET] = ACTIONS(3651),
    [anon_sym_AMP] = ACTIONS(3651),
    [anon_sym_this] = ACTIONS(3649),
    [anon_sym_scoped] = ACTIONS(3649),
    [anon_sym_var] = ACTIONS(3649),
    [sym_predefined_type] = ACTIONS(3649),
    [anon_sym_break] = ACTIONS(3649),
    [anon_sym_unchecked] = ACTIONS(3649),
    [anon_sym_continue] = ACTIONS(3649),
    [anon_sym_do] = ACTIONS(3649),
    [anon_sym_while] = ACTIONS(3649),
    [anon_sym_for] = ACTIONS(3649),
    [anon_sym_lock] = ACTIONS(3649),
    [anon_sym_yield] = ACTIONS(3649),
    [anon_sym_switch] = ACTIONS(3649),
    [anon_sym_default] = ACTIONS(3649),
    [anon_sym_throw] = ACTIONS(3649),
    [anon_sym_try] = ACTIONS(3649),
    [anon_sym_when] = ACTIONS(3649),
    [anon_sym_await] = ACTIONS(3649),
    [anon_sym_foreach] = ACTIONS(3649),
    [anon_sym_goto] = ACTIONS(3649),
    [anon_sym_if] = ACTIONS(3649),
    [anon_sym_DOT_DOT] = ACTIONS(3651),
    [anon_sym_from] = ACTIONS(3649),
    [anon_sym_into] = ACTIONS(3649),
    [anon_sym_join] = ACTIONS(3649),
    [anon_sym_on] = ACTIONS(3649),
    [anon_sym_equals] = ACTIONS(3649),
    [anon_sym_let] = ACTIONS(3649),
    [anon_sym_orderby] = ACTIONS(3649),
    [anon_sym_ascending] = ACTIONS(3649),
    [anon_sym_descending] = ACTIONS(3649),
    [anon_sym_group] = ACTIONS(3649),
    [anon_sym_by] = ACTIONS(3649),
    [anon_sym_select] = ACTIONS(3649),
    [anon_sym_DQUOTE] = ACTIONS(3649),
    [anon_sym_stackalloc] = ACTIONS(3649),
    [anon_sym_sizeof] = ACTIONS(3649),
    [anon_sym_typeof] = ACTIONS(3649),
    [anon_sym___makeref] = ACTIONS(3649),
    [anon_sym___reftype] = ACTIONS(3649),
    [anon_sym___refvalue] = ACTIONS(3649),
    [sym_null_literal] = ACTIONS(3649),
    [anon_sym_SQUOTE] = ACTIONS(3651),
    [sym_integer_literal] = ACTIONS(3649),
    [sym_real_literal] = ACTIONS(3651),
    [sym_verbatim_string_literal] = ACTIONS(3651),
    [sym_raw_string_literal] = ACTIONS(3651),
    [aux_sym_preproc_if_token1] = ACTIONS(3651),
    [aux_sym_preproc_if_token3] = ACTIONS(3651),
    [aux_sym_preproc_else_token1] = ACTIONS(3651),
    [aux_sym_preproc_elif_token1] = ACTIONS(3651),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3651),
    [sym_interpolation_verbatim_start] = ACTIONS(3651),
    [sym_interpolation_raw_start] = ACTIONS(3651),
  },
  [2357] = {
    [sym_preproc_region] = STATE(2357),
    [sym_preproc_endregion] = STATE(2357),
    [sym_preproc_line] = STATE(2357),
    [sym_preproc_pragma] = STATE(2357),
    [sym_preproc_nullable] = STATE(2357),
    [sym_preproc_error] = STATE(2357),
    [sym_preproc_define] = STATE(2357),
    [sym_preproc_undef] = STATE(2357),
    [sym__identifier_token] = ACTIONS(3653),
    [anon_sym_extern] = ACTIONS(3653),
    [anon_sym_alias] = ACTIONS(3653),
    [anon_sym_SEMI] = ACTIONS(3655),
    [anon_sym_global] = ACTIONS(3653),
    [anon_sym_using] = ACTIONS(3653),
    [anon_sym_unsafe] = ACTIONS(3653),
    [anon_sym_static] = ACTIONS(3653),
    [anon_sym_LBRACK] = ACTIONS(3655),
    [anon_sym_LPAREN] = ACTIONS(3655),
    [anon_sym_return] = ACTIONS(3653),
    [anon_sym_namespace] = ACTIONS(3653),
    [anon_sym_class] = ACTIONS(3653),
    [anon_sym_ref] = ACTIONS(3653),
    [anon_sym_struct] = ACTIONS(3653),
    [anon_sym_enum] = ACTIONS(3653),
    [anon_sym_LBRACE] = ACTIONS(3655),
    [anon_sym_interface] = ACTIONS(3653),
    [anon_sym_delegate] = ACTIONS(3653),
    [anon_sym_record] = ACTIONS(3653),
    [anon_sym_abstract] = ACTIONS(3653),
    [anon_sym_async] = ACTIONS(3653),
    [anon_sym_const] = ACTIONS(3653),
    [anon_sym_file] = ACTIONS(3653),
    [anon_sym_fixed] = ACTIONS(3653),
    [anon_sym_internal] = ACTIONS(3653),
    [anon_sym_new] = ACTIONS(3653),
    [anon_sym_override] = ACTIONS(3653),
    [anon_sym_partial] = ACTIONS(3653),
    [anon_sym_private] = ACTIONS(3653),
    [anon_sym_protected] = ACTIONS(3653),
    [anon_sym_public] = ACTIONS(3653),
    [anon_sym_readonly] = ACTIONS(3653),
    [anon_sym_required] = ACTIONS(3653),
    [anon_sym_sealed] = ACTIONS(3653),
    [anon_sym_virtual] = ACTIONS(3653),
    [anon_sym_volatile] = ACTIONS(3653),
    [anon_sym_where] = ACTIONS(3653),
    [anon_sym_notnull] = ACTIONS(3653),
    [anon_sym_unmanaged] = ACTIONS(3653),
    [anon_sym_checked] = ACTIONS(3653),
    [anon_sym_BANG] = ACTIONS(3655),
    [anon_sym_TILDE] = ACTIONS(3655),
    [anon_sym_PLUS_PLUS] = ACTIONS(3655),
    [anon_sym_DASH_DASH] = ACTIONS(3655),
    [anon_sym_true] = ACTIONS(3653),
    [anon_sym_false] = ACTIONS(3653),
    [anon_sym_PLUS] = ACTIONS(3653),
    [anon_sym_DASH] = ACTIONS(3653),
    [anon_sym_STAR] = ACTIONS(3655),
    [anon_sym_CARET] = ACTIONS(3655),
    [anon_sym_AMP] = ACTIONS(3655),
    [anon_sym_this] = ACTIONS(3653),
    [anon_sym_scoped] = ACTIONS(3653),
    [anon_sym_var] = ACTIONS(3653),
    [sym_predefined_type] = ACTIONS(3653),
    [anon_sym_break] = ACTIONS(3653),
    [anon_sym_unchecked] = ACTIONS(3653),
    [anon_sym_continue] = ACTIONS(3653),
    [anon_sym_do] = ACTIONS(3653),
    [anon_sym_while] = ACTIONS(3653),
    [anon_sym_for] = ACTIONS(3653),
    [anon_sym_lock] = ACTIONS(3653),
    [anon_sym_yield] = ACTIONS(3653),
    [anon_sym_switch] = ACTIONS(3653),
    [anon_sym_default] = ACTIONS(3653),
    [anon_sym_throw] = ACTIONS(3653),
    [anon_sym_try] = ACTIONS(3653),
    [anon_sym_when] = ACTIONS(3653),
    [anon_sym_await] = ACTIONS(3653),
    [anon_sym_foreach] = ACTIONS(3653),
    [anon_sym_goto] = ACTIONS(3653),
    [anon_sym_if] = ACTIONS(3653),
    [anon_sym_DOT_DOT] = ACTIONS(3655),
    [anon_sym_from] = ACTIONS(3653),
    [anon_sym_into] = ACTIONS(3653),
    [anon_sym_join] = ACTIONS(3653),
    [anon_sym_on] = ACTIONS(3653),
    [anon_sym_equals] = ACTIONS(3653),
    [anon_sym_let] = ACTIONS(3653),
    [anon_sym_orderby] = ACTIONS(3653),
    [anon_sym_ascending] = ACTIONS(3653),
    [anon_sym_descending] = ACTIONS(3653),
    [anon_sym_group] = ACTIONS(3653),
    [anon_sym_by] = ACTIONS(3653),
    [anon_sym_select] = ACTIONS(3653),
    [anon_sym_DQUOTE] = ACTIONS(3653),
    [anon_sym_stackalloc] = ACTIONS(3653),
    [anon_sym_sizeof] = ACTIONS(3653),
    [anon_sym_typeof] = ACTIONS(3653),
    [anon_sym___makeref] = ACTIONS(3653),
    [anon_sym___reftype] = ACTIONS(3653),
    [anon_sym___refvalue] = ACTIONS(3653),
    [sym_null_literal] = ACTIONS(3653),
    [anon_sym_SQUOTE] = ACTIONS(3655),
    [sym_integer_literal] = ACTIONS(3653),
    [sym_real_literal] = ACTIONS(3655),
    [sym_verbatim_string_literal] = ACTIONS(3655),
    [sym_raw_string_literal] = ACTIONS(3655),
    [aux_sym_preproc_if_token1] = ACTIONS(3655),
    [aux_sym_preproc_if_token3] = ACTIONS(3655),
    [aux_sym_preproc_else_token1] = ACTIONS(3655),
    [aux_sym_preproc_elif_token1] = ACTIONS(3655),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3655),
    [sym_interpolation_verbatim_start] = ACTIONS(3655),
    [sym_interpolation_raw_start] = ACTIONS(3655),
  },
  [2358] = {
    [sym_preproc_region] = STATE(2358),
    [sym_preproc_endregion] = STATE(2358),
    [sym_preproc_line] = STATE(2358),
    [sym_preproc_pragma] = STATE(2358),
    [sym_preproc_nullable] = STATE(2358),
    [sym_preproc_error] = STATE(2358),
    [sym_preproc_define] = STATE(2358),
    [sym_preproc_undef] = STATE(2358),
    [sym__identifier_token] = ACTIONS(3657),
    [anon_sym_extern] = ACTIONS(3657),
    [anon_sym_alias] = ACTIONS(3657),
    [anon_sym_SEMI] = ACTIONS(3659),
    [anon_sym_global] = ACTIONS(3657),
    [anon_sym_using] = ACTIONS(3657),
    [anon_sym_unsafe] = ACTIONS(3657),
    [anon_sym_static] = ACTIONS(3657),
    [anon_sym_LBRACK] = ACTIONS(3659),
    [anon_sym_LPAREN] = ACTIONS(3659),
    [anon_sym_return] = ACTIONS(3657),
    [anon_sym_namespace] = ACTIONS(3657),
    [anon_sym_class] = ACTIONS(3657),
    [anon_sym_ref] = ACTIONS(3657),
    [anon_sym_struct] = ACTIONS(3657),
    [anon_sym_enum] = ACTIONS(3657),
    [anon_sym_LBRACE] = ACTIONS(3659),
    [anon_sym_interface] = ACTIONS(3657),
    [anon_sym_delegate] = ACTIONS(3657),
    [anon_sym_record] = ACTIONS(3657),
    [anon_sym_abstract] = ACTIONS(3657),
    [anon_sym_async] = ACTIONS(3657),
    [anon_sym_const] = ACTIONS(3657),
    [anon_sym_file] = ACTIONS(3657),
    [anon_sym_fixed] = ACTIONS(3657),
    [anon_sym_internal] = ACTIONS(3657),
    [anon_sym_new] = ACTIONS(3657),
    [anon_sym_override] = ACTIONS(3657),
    [anon_sym_partial] = ACTIONS(3657),
    [anon_sym_private] = ACTIONS(3657),
    [anon_sym_protected] = ACTIONS(3657),
    [anon_sym_public] = ACTIONS(3657),
    [anon_sym_readonly] = ACTIONS(3657),
    [anon_sym_required] = ACTIONS(3657),
    [anon_sym_sealed] = ACTIONS(3657),
    [anon_sym_virtual] = ACTIONS(3657),
    [anon_sym_volatile] = ACTIONS(3657),
    [anon_sym_where] = ACTIONS(3657),
    [anon_sym_notnull] = ACTIONS(3657),
    [anon_sym_unmanaged] = ACTIONS(3657),
    [anon_sym_checked] = ACTIONS(3657),
    [anon_sym_BANG] = ACTIONS(3659),
    [anon_sym_TILDE] = ACTIONS(3659),
    [anon_sym_PLUS_PLUS] = ACTIONS(3659),
    [anon_sym_DASH_DASH] = ACTIONS(3659),
    [anon_sym_true] = ACTIONS(3657),
    [anon_sym_false] = ACTIONS(3657),
    [anon_sym_PLUS] = ACTIONS(3657),
    [anon_sym_DASH] = ACTIONS(3657),
    [anon_sym_STAR] = ACTIONS(3659),
    [anon_sym_CARET] = ACTIONS(3659),
    [anon_sym_AMP] = ACTIONS(3659),
    [anon_sym_this] = ACTIONS(3657),
    [anon_sym_scoped] = ACTIONS(3657),
    [anon_sym_var] = ACTIONS(3657),
    [sym_predefined_type] = ACTIONS(3657),
    [anon_sym_break] = ACTIONS(3657),
    [anon_sym_unchecked] = ACTIONS(3657),
    [anon_sym_continue] = ACTIONS(3657),
    [anon_sym_do] = ACTIONS(3657),
    [anon_sym_while] = ACTIONS(3657),
    [anon_sym_for] = ACTIONS(3657),
    [anon_sym_lock] = ACTIONS(3657),
    [anon_sym_yield] = ACTIONS(3657),
    [anon_sym_switch] = ACTIONS(3657),
    [anon_sym_default] = ACTIONS(3657),
    [anon_sym_throw] = ACTIONS(3657),
    [anon_sym_try] = ACTIONS(3657),
    [anon_sym_when] = ACTIONS(3657),
    [anon_sym_await] = ACTIONS(3657),
    [anon_sym_foreach] = ACTIONS(3657),
    [anon_sym_goto] = ACTIONS(3657),
    [anon_sym_if] = ACTIONS(3657),
    [anon_sym_DOT_DOT] = ACTIONS(3659),
    [anon_sym_from] = ACTIONS(3657),
    [anon_sym_into] = ACTIONS(3657),
    [anon_sym_join] = ACTIONS(3657),
    [anon_sym_on] = ACTIONS(3657),
    [anon_sym_equals] = ACTIONS(3657),
    [anon_sym_let] = ACTIONS(3657),
    [anon_sym_orderby] = ACTIONS(3657),
    [anon_sym_ascending] = ACTIONS(3657),
    [anon_sym_descending] = ACTIONS(3657),
    [anon_sym_group] = ACTIONS(3657),
    [anon_sym_by] = ACTIONS(3657),
    [anon_sym_select] = ACTIONS(3657),
    [anon_sym_DQUOTE] = ACTIONS(3657),
    [anon_sym_stackalloc] = ACTIONS(3657),
    [anon_sym_sizeof] = ACTIONS(3657),
    [anon_sym_typeof] = ACTIONS(3657),
    [anon_sym___makeref] = ACTIONS(3657),
    [anon_sym___reftype] = ACTIONS(3657),
    [anon_sym___refvalue] = ACTIONS(3657),
    [sym_null_literal] = ACTIONS(3657),
    [anon_sym_SQUOTE] = ACTIONS(3659),
    [sym_integer_literal] = ACTIONS(3657),
    [sym_real_literal] = ACTIONS(3659),
    [sym_verbatim_string_literal] = ACTIONS(3659),
    [sym_raw_string_literal] = ACTIONS(3659),
    [aux_sym_preproc_if_token1] = ACTIONS(3659),
    [aux_sym_preproc_if_token3] = ACTIONS(3659),
    [aux_sym_preproc_else_token1] = ACTIONS(3659),
    [aux_sym_preproc_elif_token1] = ACTIONS(3659),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3659),
    [sym_interpolation_verbatim_start] = ACTIONS(3659),
    [sym_interpolation_raw_start] = ACTIONS(3659),
  },
  [2359] = {
    [sym_preproc_region] = STATE(2359),
    [sym_preproc_endregion] = STATE(2359),
    [sym_preproc_line] = STATE(2359),
    [sym_preproc_pragma] = STATE(2359),
    [sym_preproc_nullable] = STATE(2359),
    [sym_preproc_error] = STATE(2359),
    [sym_preproc_define] = STATE(2359),
    [sym_preproc_undef] = STATE(2359),
    [sym__identifier_token] = ACTIONS(3661),
    [anon_sym_extern] = ACTIONS(3661),
    [anon_sym_alias] = ACTIONS(3661),
    [anon_sym_SEMI] = ACTIONS(3663),
    [anon_sym_global] = ACTIONS(3661),
    [anon_sym_using] = ACTIONS(3661),
    [anon_sym_unsafe] = ACTIONS(3661),
    [anon_sym_static] = ACTIONS(3661),
    [anon_sym_LBRACK] = ACTIONS(3663),
    [anon_sym_LPAREN] = ACTIONS(3663),
    [anon_sym_return] = ACTIONS(3661),
    [anon_sym_namespace] = ACTIONS(3661),
    [anon_sym_class] = ACTIONS(3661),
    [anon_sym_ref] = ACTIONS(3661),
    [anon_sym_struct] = ACTIONS(3661),
    [anon_sym_enum] = ACTIONS(3661),
    [anon_sym_LBRACE] = ACTIONS(3663),
    [anon_sym_interface] = ACTIONS(3661),
    [anon_sym_delegate] = ACTIONS(3661),
    [anon_sym_record] = ACTIONS(3661),
    [anon_sym_abstract] = ACTIONS(3661),
    [anon_sym_async] = ACTIONS(3661),
    [anon_sym_const] = ACTIONS(3661),
    [anon_sym_file] = ACTIONS(3661),
    [anon_sym_fixed] = ACTIONS(3661),
    [anon_sym_internal] = ACTIONS(3661),
    [anon_sym_new] = ACTIONS(3661),
    [anon_sym_override] = ACTIONS(3661),
    [anon_sym_partial] = ACTIONS(3661),
    [anon_sym_private] = ACTIONS(3661),
    [anon_sym_protected] = ACTIONS(3661),
    [anon_sym_public] = ACTIONS(3661),
    [anon_sym_readonly] = ACTIONS(3661),
    [anon_sym_required] = ACTIONS(3661),
    [anon_sym_sealed] = ACTIONS(3661),
    [anon_sym_virtual] = ACTIONS(3661),
    [anon_sym_volatile] = ACTIONS(3661),
    [anon_sym_where] = ACTIONS(3661),
    [anon_sym_notnull] = ACTIONS(3661),
    [anon_sym_unmanaged] = ACTIONS(3661),
    [anon_sym_checked] = ACTIONS(3661),
    [anon_sym_BANG] = ACTIONS(3663),
    [anon_sym_TILDE] = ACTIONS(3663),
    [anon_sym_PLUS_PLUS] = ACTIONS(3663),
    [anon_sym_DASH_DASH] = ACTIONS(3663),
    [anon_sym_true] = ACTIONS(3661),
    [anon_sym_false] = ACTIONS(3661),
    [anon_sym_PLUS] = ACTIONS(3661),
    [anon_sym_DASH] = ACTIONS(3661),
    [anon_sym_STAR] = ACTIONS(3663),
    [anon_sym_CARET] = ACTIONS(3663),
    [anon_sym_AMP] = ACTIONS(3663),
    [anon_sym_this] = ACTIONS(3661),
    [anon_sym_scoped] = ACTIONS(3661),
    [anon_sym_var] = ACTIONS(3661),
    [sym_predefined_type] = ACTIONS(3661),
    [anon_sym_break] = ACTIONS(3661),
    [anon_sym_unchecked] = ACTIONS(3661),
    [anon_sym_continue] = ACTIONS(3661),
    [anon_sym_do] = ACTIONS(3661),
    [anon_sym_while] = ACTIONS(3661),
    [anon_sym_for] = ACTIONS(3661),
    [anon_sym_lock] = ACTIONS(3661),
    [anon_sym_yield] = ACTIONS(3661),
    [anon_sym_switch] = ACTIONS(3661),
    [anon_sym_default] = ACTIONS(3661),
    [anon_sym_throw] = ACTIONS(3661),
    [anon_sym_try] = ACTIONS(3661),
    [anon_sym_when] = ACTIONS(3661),
    [anon_sym_await] = ACTIONS(3661),
    [anon_sym_foreach] = ACTIONS(3661),
    [anon_sym_goto] = ACTIONS(3661),
    [anon_sym_if] = ACTIONS(3661),
    [anon_sym_DOT_DOT] = ACTIONS(3663),
    [anon_sym_from] = ACTIONS(3661),
    [anon_sym_into] = ACTIONS(3661),
    [anon_sym_join] = ACTIONS(3661),
    [anon_sym_on] = ACTIONS(3661),
    [anon_sym_equals] = ACTIONS(3661),
    [anon_sym_let] = ACTIONS(3661),
    [anon_sym_orderby] = ACTIONS(3661),
    [anon_sym_ascending] = ACTIONS(3661),
    [anon_sym_descending] = ACTIONS(3661),
    [anon_sym_group] = ACTIONS(3661),
    [anon_sym_by] = ACTIONS(3661),
    [anon_sym_select] = ACTIONS(3661),
    [anon_sym_DQUOTE] = ACTIONS(3661),
    [anon_sym_stackalloc] = ACTIONS(3661),
    [anon_sym_sizeof] = ACTIONS(3661),
    [anon_sym_typeof] = ACTIONS(3661),
    [anon_sym___makeref] = ACTIONS(3661),
    [anon_sym___reftype] = ACTIONS(3661),
    [anon_sym___refvalue] = ACTIONS(3661),
    [sym_null_literal] = ACTIONS(3661),
    [anon_sym_SQUOTE] = ACTIONS(3663),
    [sym_integer_literal] = ACTIONS(3661),
    [sym_real_literal] = ACTIONS(3663),
    [sym_verbatim_string_literal] = ACTIONS(3663),
    [sym_raw_string_literal] = ACTIONS(3663),
    [aux_sym_preproc_if_token1] = ACTIONS(3663),
    [aux_sym_preproc_if_token3] = ACTIONS(3663),
    [aux_sym_preproc_else_token1] = ACTIONS(3663),
    [aux_sym_preproc_elif_token1] = ACTIONS(3663),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3663),
    [sym_interpolation_verbatim_start] = ACTIONS(3663),
    [sym_interpolation_raw_start] = ACTIONS(3663),
  },
  [2360] = {
    [sym_preproc_region] = STATE(2360),
    [sym_preproc_endregion] = STATE(2360),
    [sym_preproc_line] = STATE(2360),
    [sym_preproc_pragma] = STATE(2360),
    [sym_preproc_nullable] = STATE(2360),
    [sym_preproc_error] = STATE(2360),
    [sym_preproc_define] = STATE(2360),
    [sym_preproc_undef] = STATE(2360),
    [sym__identifier_token] = ACTIONS(3665),
    [anon_sym_extern] = ACTIONS(3665),
    [anon_sym_alias] = ACTIONS(3665),
    [anon_sym_SEMI] = ACTIONS(3667),
    [anon_sym_global] = ACTIONS(3665),
    [anon_sym_using] = ACTIONS(3665),
    [anon_sym_unsafe] = ACTIONS(3665),
    [anon_sym_static] = ACTIONS(3665),
    [anon_sym_LBRACK] = ACTIONS(3667),
    [anon_sym_LPAREN] = ACTIONS(3667),
    [anon_sym_return] = ACTIONS(3665),
    [anon_sym_namespace] = ACTIONS(3665),
    [anon_sym_class] = ACTIONS(3665),
    [anon_sym_ref] = ACTIONS(3665),
    [anon_sym_struct] = ACTIONS(3665),
    [anon_sym_enum] = ACTIONS(3665),
    [anon_sym_LBRACE] = ACTIONS(3667),
    [anon_sym_interface] = ACTIONS(3665),
    [anon_sym_delegate] = ACTIONS(3665),
    [anon_sym_record] = ACTIONS(3665),
    [anon_sym_abstract] = ACTIONS(3665),
    [anon_sym_async] = ACTIONS(3665),
    [anon_sym_const] = ACTIONS(3665),
    [anon_sym_file] = ACTIONS(3665),
    [anon_sym_fixed] = ACTIONS(3665),
    [anon_sym_internal] = ACTIONS(3665),
    [anon_sym_new] = ACTIONS(3665),
    [anon_sym_override] = ACTIONS(3665),
    [anon_sym_partial] = ACTIONS(3665),
    [anon_sym_private] = ACTIONS(3665),
    [anon_sym_protected] = ACTIONS(3665),
    [anon_sym_public] = ACTIONS(3665),
    [anon_sym_readonly] = ACTIONS(3665),
    [anon_sym_required] = ACTIONS(3665),
    [anon_sym_sealed] = ACTIONS(3665),
    [anon_sym_virtual] = ACTIONS(3665),
    [anon_sym_volatile] = ACTIONS(3665),
    [anon_sym_where] = ACTIONS(3665),
    [anon_sym_notnull] = ACTIONS(3665),
    [anon_sym_unmanaged] = ACTIONS(3665),
    [anon_sym_checked] = ACTIONS(3665),
    [anon_sym_BANG] = ACTIONS(3667),
    [anon_sym_TILDE] = ACTIONS(3667),
    [anon_sym_PLUS_PLUS] = ACTIONS(3667),
    [anon_sym_DASH_DASH] = ACTIONS(3667),
    [anon_sym_true] = ACTIONS(3665),
    [anon_sym_false] = ACTIONS(3665),
    [anon_sym_PLUS] = ACTIONS(3665),
    [anon_sym_DASH] = ACTIONS(3665),
    [anon_sym_STAR] = ACTIONS(3667),
    [anon_sym_CARET] = ACTIONS(3667),
    [anon_sym_AMP] = ACTIONS(3667),
    [anon_sym_this] = ACTIONS(3665),
    [anon_sym_scoped] = ACTIONS(3665),
    [anon_sym_var] = ACTIONS(3665),
    [sym_predefined_type] = ACTIONS(3665),
    [anon_sym_break] = ACTIONS(3665),
    [anon_sym_unchecked] = ACTIONS(3665),
    [anon_sym_continue] = ACTIONS(3665),
    [anon_sym_do] = ACTIONS(3665),
    [anon_sym_while] = ACTIONS(3665),
    [anon_sym_for] = ACTIONS(3665),
    [anon_sym_lock] = ACTIONS(3665),
    [anon_sym_yield] = ACTIONS(3665),
    [anon_sym_switch] = ACTIONS(3665),
    [anon_sym_default] = ACTIONS(3665),
    [anon_sym_throw] = ACTIONS(3665),
    [anon_sym_try] = ACTIONS(3665),
    [anon_sym_when] = ACTIONS(3665),
    [anon_sym_await] = ACTIONS(3665),
    [anon_sym_foreach] = ACTIONS(3665),
    [anon_sym_goto] = ACTIONS(3665),
    [anon_sym_if] = ACTIONS(3665),
    [anon_sym_DOT_DOT] = ACTIONS(3667),
    [anon_sym_from] = ACTIONS(3665),
    [anon_sym_into] = ACTIONS(3665),
    [anon_sym_join] = ACTIONS(3665),
    [anon_sym_on] = ACTIONS(3665),
    [anon_sym_equals] = ACTIONS(3665),
    [anon_sym_let] = ACTIONS(3665),
    [anon_sym_orderby] = ACTIONS(3665),
    [anon_sym_ascending] = ACTIONS(3665),
    [anon_sym_descending] = ACTIONS(3665),
    [anon_sym_group] = ACTIONS(3665),
    [anon_sym_by] = ACTIONS(3665),
    [anon_sym_select] = ACTIONS(3665),
    [anon_sym_DQUOTE] = ACTIONS(3665),
    [anon_sym_stackalloc] = ACTIONS(3665),
    [anon_sym_sizeof] = ACTIONS(3665),
    [anon_sym_typeof] = ACTIONS(3665),
    [anon_sym___makeref] = ACTIONS(3665),
    [anon_sym___reftype] = ACTIONS(3665),
    [anon_sym___refvalue] = ACTIONS(3665),
    [sym_null_literal] = ACTIONS(3665),
    [anon_sym_SQUOTE] = ACTIONS(3667),
    [sym_integer_literal] = ACTIONS(3665),
    [sym_real_literal] = ACTIONS(3667),
    [sym_verbatim_string_literal] = ACTIONS(3667),
    [sym_raw_string_literal] = ACTIONS(3667),
    [aux_sym_preproc_if_token1] = ACTIONS(3667),
    [aux_sym_preproc_if_token3] = ACTIONS(3667),
    [aux_sym_preproc_else_token1] = ACTIONS(3667),
    [aux_sym_preproc_elif_token1] = ACTIONS(3667),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3667),
    [sym_interpolation_verbatim_start] = ACTIONS(3667),
    [sym_interpolation_raw_start] = ACTIONS(3667),
  },
  [2361] = {
    [sym_preproc_region] = STATE(2361),
    [sym_preproc_endregion] = STATE(2361),
    [sym_preproc_line] = STATE(2361),
    [sym_preproc_pragma] = STATE(2361),
    [sym_preproc_nullable] = STATE(2361),
    [sym_preproc_error] = STATE(2361),
    [sym_preproc_define] = STATE(2361),
    [sym_preproc_undef] = STATE(2361),
    [sym__identifier_token] = ACTIONS(3669),
    [anon_sym_extern] = ACTIONS(3669),
    [anon_sym_alias] = ACTIONS(3669),
    [anon_sym_SEMI] = ACTIONS(3671),
    [anon_sym_global] = ACTIONS(3669),
    [anon_sym_using] = ACTIONS(3669),
    [anon_sym_unsafe] = ACTIONS(3669),
    [anon_sym_static] = ACTIONS(3669),
    [anon_sym_LBRACK] = ACTIONS(3671),
    [anon_sym_LPAREN] = ACTIONS(3671),
    [anon_sym_return] = ACTIONS(3669),
    [anon_sym_namespace] = ACTIONS(3669),
    [anon_sym_class] = ACTIONS(3669),
    [anon_sym_ref] = ACTIONS(3669),
    [anon_sym_struct] = ACTIONS(3669),
    [anon_sym_enum] = ACTIONS(3669),
    [anon_sym_LBRACE] = ACTIONS(3671),
    [anon_sym_interface] = ACTIONS(3669),
    [anon_sym_delegate] = ACTIONS(3669),
    [anon_sym_record] = ACTIONS(3669),
    [anon_sym_abstract] = ACTIONS(3669),
    [anon_sym_async] = ACTIONS(3669),
    [anon_sym_const] = ACTIONS(3669),
    [anon_sym_file] = ACTIONS(3669),
    [anon_sym_fixed] = ACTIONS(3669),
    [anon_sym_internal] = ACTIONS(3669),
    [anon_sym_new] = ACTIONS(3669),
    [anon_sym_override] = ACTIONS(3669),
    [anon_sym_partial] = ACTIONS(3669),
    [anon_sym_private] = ACTIONS(3669),
    [anon_sym_protected] = ACTIONS(3669),
    [anon_sym_public] = ACTIONS(3669),
    [anon_sym_readonly] = ACTIONS(3669),
    [anon_sym_required] = ACTIONS(3669),
    [anon_sym_sealed] = ACTIONS(3669),
    [anon_sym_virtual] = ACTIONS(3669),
    [anon_sym_volatile] = ACTIONS(3669),
    [anon_sym_where] = ACTIONS(3669),
    [anon_sym_notnull] = ACTIONS(3669),
    [anon_sym_unmanaged] = ACTIONS(3669),
    [anon_sym_checked] = ACTIONS(3669),
    [anon_sym_BANG] = ACTIONS(3671),
    [anon_sym_TILDE] = ACTIONS(3671),
    [anon_sym_PLUS_PLUS] = ACTIONS(3671),
    [anon_sym_DASH_DASH] = ACTIONS(3671),
    [anon_sym_true] = ACTIONS(3669),
    [anon_sym_false] = ACTIONS(3669),
    [anon_sym_PLUS] = ACTIONS(3669),
    [anon_sym_DASH] = ACTIONS(3669),
    [anon_sym_STAR] = ACTIONS(3671),
    [anon_sym_CARET] = ACTIONS(3671),
    [anon_sym_AMP] = ACTIONS(3671),
    [anon_sym_this] = ACTIONS(3669),
    [anon_sym_scoped] = ACTIONS(3669),
    [anon_sym_var] = ACTIONS(3669),
    [sym_predefined_type] = ACTIONS(3669),
    [anon_sym_break] = ACTIONS(3669),
    [anon_sym_unchecked] = ACTIONS(3669),
    [anon_sym_continue] = ACTIONS(3669),
    [anon_sym_do] = ACTIONS(3669),
    [anon_sym_while] = ACTIONS(3669),
    [anon_sym_for] = ACTIONS(3669),
    [anon_sym_lock] = ACTIONS(3669),
    [anon_sym_yield] = ACTIONS(3669),
    [anon_sym_switch] = ACTIONS(3669),
    [anon_sym_default] = ACTIONS(3669),
    [anon_sym_throw] = ACTIONS(3669),
    [anon_sym_try] = ACTIONS(3669),
    [anon_sym_when] = ACTIONS(3669),
    [anon_sym_await] = ACTIONS(3669),
    [anon_sym_foreach] = ACTIONS(3669),
    [anon_sym_goto] = ACTIONS(3669),
    [anon_sym_if] = ACTIONS(3669),
    [anon_sym_DOT_DOT] = ACTIONS(3671),
    [anon_sym_from] = ACTIONS(3669),
    [anon_sym_into] = ACTIONS(3669),
    [anon_sym_join] = ACTIONS(3669),
    [anon_sym_on] = ACTIONS(3669),
    [anon_sym_equals] = ACTIONS(3669),
    [anon_sym_let] = ACTIONS(3669),
    [anon_sym_orderby] = ACTIONS(3669),
    [anon_sym_ascending] = ACTIONS(3669),
    [anon_sym_descending] = ACTIONS(3669),
    [anon_sym_group] = ACTIONS(3669),
    [anon_sym_by] = ACTIONS(3669),
    [anon_sym_select] = ACTIONS(3669),
    [anon_sym_DQUOTE] = ACTIONS(3669),
    [anon_sym_stackalloc] = ACTIONS(3669),
    [anon_sym_sizeof] = ACTIONS(3669),
    [anon_sym_typeof] = ACTIONS(3669),
    [anon_sym___makeref] = ACTIONS(3669),
    [anon_sym___reftype] = ACTIONS(3669),
    [anon_sym___refvalue] = ACTIONS(3669),
    [sym_null_literal] = ACTIONS(3669),
    [anon_sym_SQUOTE] = ACTIONS(3671),
    [sym_integer_literal] = ACTIONS(3669),
    [sym_real_literal] = ACTIONS(3671),
    [sym_verbatim_string_literal] = ACTIONS(3671),
    [sym_raw_string_literal] = ACTIONS(3671),
    [aux_sym_preproc_if_token1] = ACTIONS(3671),
    [aux_sym_preproc_if_token3] = ACTIONS(3671),
    [aux_sym_preproc_else_token1] = ACTIONS(3671),
    [aux_sym_preproc_elif_token1] = ACTIONS(3671),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3671),
    [sym_interpolation_verbatim_start] = ACTIONS(3671),
    [sym_interpolation_raw_start] = ACTIONS(3671),
  },
  [2362] = {
    [sym_preproc_region] = STATE(2362),
    [sym_preproc_endregion] = STATE(2362),
    [sym_preproc_line] = STATE(2362),
    [sym_preproc_pragma] = STATE(2362),
    [sym_preproc_nullable] = STATE(2362),
    [sym_preproc_error] = STATE(2362),
    [sym_preproc_define] = STATE(2362),
    [sym_preproc_undef] = STATE(2362),
    [sym__identifier_token] = ACTIONS(3673),
    [anon_sym_extern] = ACTIONS(3673),
    [anon_sym_alias] = ACTIONS(3673),
    [anon_sym_SEMI] = ACTIONS(3675),
    [anon_sym_global] = ACTIONS(3673),
    [anon_sym_using] = ACTIONS(3673),
    [anon_sym_unsafe] = ACTIONS(3673),
    [anon_sym_static] = ACTIONS(3673),
    [anon_sym_LBRACK] = ACTIONS(3675),
    [anon_sym_LPAREN] = ACTIONS(3675),
    [anon_sym_return] = ACTIONS(3673),
    [anon_sym_namespace] = ACTIONS(3673),
    [anon_sym_class] = ACTIONS(3673),
    [anon_sym_ref] = ACTIONS(3673),
    [anon_sym_struct] = ACTIONS(3673),
    [anon_sym_enum] = ACTIONS(3673),
    [anon_sym_LBRACE] = ACTIONS(3675),
    [anon_sym_interface] = ACTIONS(3673),
    [anon_sym_delegate] = ACTIONS(3673),
    [anon_sym_record] = ACTIONS(3673),
    [anon_sym_abstract] = ACTIONS(3673),
    [anon_sym_async] = ACTIONS(3673),
    [anon_sym_const] = ACTIONS(3673),
    [anon_sym_file] = ACTIONS(3673),
    [anon_sym_fixed] = ACTIONS(3673),
    [anon_sym_internal] = ACTIONS(3673),
    [anon_sym_new] = ACTIONS(3673),
    [anon_sym_override] = ACTIONS(3673),
    [anon_sym_partial] = ACTIONS(3673),
    [anon_sym_private] = ACTIONS(3673),
    [anon_sym_protected] = ACTIONS(3673),
    [anon_sym_public] = ACTIONS(3673),
    [anon_sym_readonly] = ACTIONS(3673),
    [anon_sym_required] = ACTIONS(3673),
    [anon_sym_sealed] = ACTIONS(3673),
    [anon_sym_virtual] = ACTIONS(3673),
    [anon_sym_volatile] = ACTIONS(3673),
    [anon_sym_where] = ACTIONS(3673),
    [anon_sym_notnull] = ACTIONS(3673),
    [anon_sym_unmanaged] = ACTIONS(3673),
    [anon_sym_checked] = ACTIONS(3673),
    [anon_sym_BANG] = ACTIONS(3675),
    [anon_sym_TILDE] = ACTIONS(3675),
    [anon_sym_PLUS_PLUS] = ACTIONS(3675),
    [anon_sym_DASH_DASH] = ACTIONS(3675),
    [anon_sym_true] = ACTIONS(3673),
    [anon_sym_false] = ACTIONS(3673),
    [anon_sym_PLUS] = ACTIONS(3673),
    [anon_sym_DASH] = ACTIONS(3673),
    [anon_sym_STAR] = ACTIONS(3675),
    [anon_sym_CARET] = ACTIONS(3675),
    [anon_sym_AMP] = ACTIONS(3675),
    [anon_sym_this] = ACTIONS(3673),
    [anon_sym_scoped] = ACTIONS(3673),
    [anon_sym_var] = ACTIONS(3673),
    [sym_predefined_type] = ACTIONS(3673),
    [anon_sym_break] = ACTIONS(3673),
    [anon_sym_unchecked] = ACTIONS(3673),
    [anon_sym_continue] = ACTIONS(3673),
    [anon_sym_do] = ACTIONS(3673),
    [anon_sym_while] = ACTIONS(3673),
    [anon_sym_for] = ACTIONS(3673),
    [anon_sym_lock] = ACTIONS(3673),
    [anon_sym_yield] = ACTIONS(3673),
    [anon_sym_switch] = ACTIONS(3673),
    [anon_sym_default] = ACTIONS(3673),
    [anon_sym_throw] = ACTIONS(3673),
    [anon_sym_try] = ACTIONS(3673),
    [anon_sym_when] = ACTIONS(3673),
    [anon_sym_await] = ACTIONS(3673),
    [anon_sym_foreach] = ACTIONS(3673),
    [anon_sym_goto] = ACTIONS(3673),
    [anon_sym_if] = ACTIONS(3673),
    [anon_sym_DOT_DOT] = ACTIONS(3675),
    [anon_sym_from] = ACTIONS(3673),
    [anon_sym_into] = ACTIONS(3673),
    [anon_sym_join] = ACTIONS(3673),
    [anon_sym_on] = ACTIONS(3673),
    [anon_sym_equals] = ACTIONS(3673),
    [anon_sym_let] = ACTIONS(3673),
    [anon_sym_orderby] = ACTIONS(3673),
    [anon_sym_ascending] = ACTIONS(3673),
    [anon_sym_descending] = ACTIONS(3673),
    [anon_sym_group] = ACTIONS(3673),
    [anon_sym_by] = ACTIONS(3673),
    [anon_sym_select] = ACTIONS(3673),
    [anon_sym_DQUOTE] = ACTIONS(3673),
    [anon_sym_stackalloc] = ACTIONS(3673),
    [anon_sym_sizeof] = ACTIONS(3673),
    [anon_sym_typeof] = ACTIONS(3673),
    [anon_sym___makeref] = ACTIONS(3673),
    [anon_sym___reftype] = ACTIONS(3673),
    [anon_sym___refvalue] = ACTIONS(3673),
    [sym_null_literal] = ACTIONS(3673),
    [anon_sym_SQUOTE] = ACTIONS(3675),
    [sym_integer_literal] = ACTIONS(3673),
    [sym_real_literal] = ACTIONS(3675),
    [sym_verbatim_string_literal] = ACTIONS(3675),
    [sym_raw_string_literal] = ACTIONS(3675),
    [aux_sym_preproc_if_token1] = ACTIONS(3675),
    [aux_sym_preproc_if_token3] = ACTIONS(3675),
    [aux_sym_preproc_else_token1] = ACTIONS(3675),
    [aux_sym_preproc_elif_token1] = ACTIONS(3675),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3675),
    [sym_interpolation_verbatim_start] = ACTIONS(3675),
    [sym_interpolation_raw_start] = ACTIONS(3675),
  },
  [2363] = {
    [sym_preproc_region] = STATE(2363),
    [sym_preproc_endregion] = STATE(2363),
    [sym_preproc_line] = STATE(2363),
    [sym_preproc_pragma] = STATE(2363),
    [sym_preproc_nullable] = STATE(2363),
    [sym_preproc_error] = STATE(2363),
    [sym_preproc_define] = STATE(2363),
    [sym_preproc_undef] = STATE(2363),
    [sym__identifier_token] = ACTIONS(3677),
    [anon_sym_extern] = ACTIONS(3677),
    [anon_sym_alias] = ACTIONS(3677),
    [anon_sym_SEMI] = ACTIONS(3679),
    [anon_sym_global] = ACTIONS(3677),
    [anon_sym_using] = ACTIONS(3677),
    [anon_sym_unsafe] = ACTIONS(3677),
    [anon_sym_static] = ACTIONS(3677),
    [anon_sym_LBRACK] = ACTIONS(3679),
    [anon_sym_LPAREN] = ACTIONS(3679),
    [anon_sym_return] = ACTIONS(3677),
    [anon_sym_namespace] = ACTIONS(3677),
    [anon_sym_class] = ACTIONS(3677),
    [anon_sym_ref] = ACTIONS(3677),
    [anon_sym_struct] = ACTIONS(3677),
    [anon_sym_enum] = ACTIONS(3677),
    [anon_sym_LBRACE] = ACTIONS(3679),
    [anon_sym_interface] = ACTIONS(3677),
    [anon_sym_delegate] = ACTIONS(3677),
    [anon_sym_record] = ACTIONS(3677),
    [anon_sym_abstract] = ACTIONS(3677),
    [anon_sym_async] = ACTIONS(3677),
    [anon_sym_const] = ACTIONS(3677),
    [anon_sym_file] = ACTIONS(3677),
    [anon_sym_fixed] = ACTIONS(3677),
    [anon_sym_internal] = ACTIONS(3677),
    [anon_sym_new] = ACTIONS(3677),
    [anon_sym_override] = ACTIONS(3677),
    [anon_sym_partial] = ACTIONS(3677),
    [anon_sym_private] = ACTIONS(3677),
    [anon_sym_protected] = ACTIONS(3677),
    [anon_sym_public] = ACTIONS(3677),
    [anon_sym_readonly] = ACTIONS(3677),
    [anon_sym_required] = ACTIONS(3677),
    [anon_sym_sealed] = ACTIONS(3677),
    [anon_sym_virtual] = ACTIONS(3677),
    [anon_sym_volatile] = ACTIONS(3677),
    [anon_sym_where] = ACTIONS(3677),
    [anon_sym_notnull] = ACTIONS(3677),
    [anon_sym_unmanaged] = ACTIONS(3677),
    [anon_sym_checked] = ACTIONS(3677),
    [anon_sym_BANG] = ACTIONS(3679),
    [anon_sym_TILDE] = ACTIONS(3679),
    [anon_sym_PLUS_PLUS] = ACTIONS(3679),
    [anon_sym_DASH_DASH] = ACTIONS(3679),
    [anon_sym_true] = ACTIONS(3677),
    [anon_sym_false] = ACTIONS(3677),
    [anon_sym_PLUS] = ACTIONS(3677),
    [anon_sym_DASH] = ACTIONS(3677),
    [anon_sym_STAR] = ACTIONS(3679),
    [anon_sym_CARET] = ACTIONS(3679),
    [anon_sym_AMP] = ACTIONS(3679),
    [anon_sym_this] = ACTIONS(3677),
    [anon_sym_scoped] = ACTIONS(3677),
    [anon_sym_var] = ACTIONS(3677),
    [sym_predefined_type] = ACTIONS(3677),
    [anon_sym_break] = ACTIONS(3677),
    [anon_sym_unchecked] = ACTIONS(3677),
    [anon_sym_continue] = ACTIONS(3677),
    [anon_sym_do] = ACTIONS(3677),
    [anon_sym_while] = ACTIONS(3677),
    [anon_sym_for] = ACTIONS(3677),
    [anon_sym_lock] = ACTIONS(3677),
    [anon_sym_yield] = ACTIONS(3677),
    [anon_sym_switch] = ACTIONS(3677),
    [anon_sym_default] = ACTIONS(3677),
    [anon_sym_throw] = ACTIONS(3677),
    [anon_sym_try] = ACTIONS(3677),
    [anon_sym_when] = ACTIONS(3677),
    [anon_sym_await] = ACTIONS(3677),
    [anon_sym_foreach] = ACTIONS(3677),
    [anon_sym_goto] = ACTIONS(3677),
    [anon_sym_if] = ACTIONS(3677),
    [anon_sym_DOT_DOT] = ACTIONS(3679),
    [anon_sym_from] = ACTIONS(3677),
    [anon_sym_into] = ACTIONS(3677),
    [anon_sym_join] = ACTIONS(3677),
    [anon_sym_on] = ACTIONS(3677),
    [anon_sym_equals] = ACTIONS(3677),
    [anon_sym_let] = ACTIONS(3677),
    [anon_sym_orderby] = ACTIONS(3677),
    [anon_sym_ascending] = ACTIONS(3677),
    [anon_sym_descending] = ACTIONS(3677),
    [anon_sym_group] = ACTIONS(3677),
    [anon_sym_by] = ACTIONS(3677),
    [anon_sym_select] = ACTIONS(3677),
    [anon_sym_DQUOTE] = ACTIONS(3677),
    [anon_sym_stackalloc] = ACTIONS(3677),
    [anon_sym_sizeof] = ACTIONS(3677),
    [anon_sym_typeof] = ACTIONS(3677),
    [anon_sym___makeref] = ACTIONS(3677),
    [anon_sym___reftype] = ACTIONS(3677),
    [anon_sym___refvalue] = ACTIONS(3677),
    [sym_null_literal] = ACTIONS(3677),
    [anon_sym_SQUOTE] = ACTIONS(3679),
    [sym_integer_literal] = ACTIONS(3677),
    [sym_real_literal] = ACTIONS(3679),
    [sym_verbatim_string_literal] = ACTIONS(3679),
    [sym_raw_string_literal] = ACTIONS(3679),
    [aux_sym_preproc_if_token1] = ACTIONS(3679),
    [aux_sym_preproc_if_token3] = ACTIONS(3679),
    [aux_sym_preproc_else_token1] = ACTIONS(3679),
    [aux_sym_preproc_elif_token1] = ACTIONS(3679),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3679),
    [sym_interpolation_verbatim_start] = ACTIONS(3679),
    [sym_interpolation_raw_start] = ACTIONS(3679),
  },
  [2364] = {
    [sym_preproc_region] = STATE(2364),
    [sym_preproc_endregion] = STATE(2364),
    [sym_preproc_line] = STATE(2364),
    [sym_preproc_pragma] = STATE(2364),
    [sym_preproc_nullable] = STATE(2364),
    [sym_preproc_error] = STATE(2364),
    [sym_preproc_define] = STATE(2364),
    [sym_preproc_undef] = STATE(2364),
    [sym__identifier_token] = ACTIONS(3681),
    [anon_sym_extern] = ACTIONS(3681),
    [anon_sym_alias] = ACTIONS(3681),
    [anon_sym_SEMI] = ACTIONS(3683),
    [anon_sym_global] = ACTIONS(3681),
    [anon_sym_using] = ACTIONS(3681),
    [anon_sym_unsafe] = ACTIONS(3681),
    [anon_sym_static] = ACTIONS(3681),
    [anon_sym_LBRACK] = ACTIONS(3683),
    [anon_sym_LPAREN] = ACTIONS(3683),
    [anon_sym_return] = ACTIONS(3681),
    [anon_sym_namespace] = ACTIONS(3681),
    [anon_sym_class] = ACTIONS(3681),
    [anon_sym_ref] = ACTIONS(3681),
    [anon_sym_struct] = ACTIONS(3681),
    [anon_sym_enum] = ACTIONS(3681),
    [anon_sym_LBRACE] = ACTIONS(3683),
    [anon_sym_interface] = ACTIONS(3681),
    [anon_sym_delegate] = ACTIONS(3681),
    [anon_sym_record] = ACTIONS(3681),
    [anon_sym_abstract] = ACTIONS(3681),
    [anon_sym_async] = ACTIONS(3681),
    [anon_sym_const] = ACTIONS(3681),
    [anon_sym_file] = ACTIONS(3681),
    [anon_sym_fixed] = ACTIONS(3681),
    [anon_sym_internal] = ACTIONS(3681),
    [anon_sym_new] = ACTIONS(3681),
    [anon_sym_override] = ACTIONS(3681),
    [anon_sym_partial] = ACTIONS(3681),
    [anon_sym_private] = ACTIONS(3681),
    [anon_sym_protected] = ACTIONS(3681),
    [anon_sym_public] = ACTIONS(3681),
    [anon_sym_readonly] = ACTIONS(3681),
    [anon_sym_required] = ACTIONS(3681),
    [anon_sym_sealed] = ACTIONS(3681),
    [anon_sym_virtual] = ACTIONS(3681),
    [anon_sym_volatile] = ACTIONS(3681),
    [anon_sym_where] = ACTIONS(3681),
    [anon_sym_notnull] = ACTIONS(3681),
    [anon_sym_unmanaged] = ACTIONS(3681),
    [anon_sym_checked] = ACTIONS(3681),
    [anon_sym_BANG] = ACTIONS(3683),
    [anon_sym_TILDE] = ACTIONS(3683),
    [anon_sym_PLUS_PLUS] = ACTIONS(3683),
    [anon_sym_DASH_DASH] = ACTIONS(3683),
    [anon_sym_true] = ACTIONS(3681),
    [anon_sym_false] = ACTIONS(3681),
    [anon_sym_PLUS] = ACTIONS(3681),
    [anon_sym_DASH] = ACTIONS(3681),
    [anon_sym_STAR] = ACTIONS(3683),
    [anon_sym_CARET] = ACTIONS(3683),
    [anon_sym_AMP] = ACTIONS(3683),
    [anon_sym_this] = ACTIONS(3681),
    [anon_sym_scoped] = ACTIONS(3681),
    [anon_sym_var] = ACTIONS(3681),
    [sym_predefined_type] = ACTIONS(3681),
    [anon_sym_break] = ACTIONS(3681),
    [anon_sym_unchecked] = ACTIONS(3681),
    [anon_sym_continue] = ACTIONS(3681),
    [anon_sym_do] = ACTIONS(3681),
    [anon_sym_while] = ACTIONS(3681),
    [anon_sym_for] = ACTIONS(3681),
    [anon_sym_lock] = ACTIONS(3681),
    [anon_sym_yield] = ACTIONS(3681),
    [anon_sym_switch] = ACTIONS(3681),
    [anon_sym_default] = ACTIONS(3681),
    [anon_sym_throw] = ACTIONS(3681),
    [anon_sym_try] = ACTIONS(3681),
    [anon_sym_when] = ACTIONS(3681),
    [anon_sym_await] = ACTIONS(3681),
    [anon_sym_foreach] = ACTIONS(3681),
    [anon_sym_goto] = ACTIONS(3681),
    [anon_sym_if] = ACTIONS(3681),
    [anon_sym_DOT_DOT] = ACTIONS(3683),
    [anon_sym_from] = ACTIONS(3681),
    [anon_sym_into] = ACTIONS(3681),
    [anon_sym_join] = ACTIONS(3681),
    [anon_sym_on] = ACTIONS(3681),
    [anon_sym_equals] = ACTIONS(3681),
    [anon_sym_let] = ACTIONS(3681),
    [anon_sym_orderby] = ACTIONS(3681),
    [anon_sym_ascending] = ACTIONS(3681),
    [anon_sym_descending] = ACTIONS(3681),
    [anon_sym_group] = ACTIONS(3681),
    [anon_sym_by] = ACTIONS(3681),
    [anon_sym_select] = ACTIONS(3681),
    [anon_sym_DQUOTE] = ACTIONS(3681),
    [anon_sym_stackalloc] = ACTIONS(3681),
    [anon_sym_sizeof] = ACTIONS(3681),
    [anon_sym_typeof] = ACTIONS(3681),
    [anon_sym___makeref] = ACTIONS(3681),
    [anon_sym___reftype] = ACTIONS(3681),
    [anon_sym___refvalue] = ACTIONS(3681),
    [sym_null_literal] = ACTIONS(3681),
    [anon_sym_SQUOTE] = ACTIONS(3683),
    [sym_integer_literal] = ACTIONS(3681),
    [sym_real_literal] = ACTIONS(3683),
    [sym_verbatim_string_literal] = ACTIONS(3683),
    [sym_raw_string_literal] = ACTIONS(3683),
    [aux_sym_preproc_if_token1] = ACTIONS(3683),
    [aux_sym_preproc_if_token3] = ACTIONS(3683),
    [aux_sym_preproc_else_token1] = ACTIONS(3683),
    [aux_sym_preproc_elif_token1] = ACTIONS(3683),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3683),
    [sym_interpolation_verbatim_start] = ACTIONS(3683),
    [sym_interpolation_raw_start] = ACTIONS(3683),
  },
  [2365] = {
    [sym_preproc_region] = STATE(2365),
    [sym_preproc_endregion] = STATE(2365),
    [sym_preproc_line] = STATE(2365),
    [sym_preproc_pragma] = STATE(2365),
    [sym_preproc_nullable] = STATE(2365),
    [sym_preproc_error] = STATE(2365),
    [sym_preproc_define] = STATE(2365),
    [sym_preproc_undef] = STATE(2365),
    [sym__identifier_token] = ACTIONS(3685),
    [anon_sym_extern] = ACTIONS(3685),
    [anon_sym_alias] = ACTIONS(3685),
    [anon_sym_SEMI] = ACTIONS(3687),
    [anon_sym_global] = ACTIONS(3685),
    [anon_sym_using] = ACTIONS(3685),
    [anon_sym_unsafe] = ACTIONS(3685),
    [anon_sym_static] = ACTIONS(3685),
    [anon_sym_LBRACK] = ACTIONS(3687),
    [anon_sym_LPAREN] = ACTIONS(3687),
    [anon_sym_return] = ACTIONS(3685),
    [anon_sym_namespace] = ACTIONS(3685),
    [anon_sym_class] = ACTIONS(3685),
    [anon_sym_ref] = ACTIONS(3685),
    [anon_sym_struct] = ACTIONS(3685),
    [anon_sym_enum] = ACTIONS(3685),
    [anon_sym_LBRACE] = ACTIONS(3687),
    [anon_sym_interface] = ACTIONS(3685),
    [anon_sym_delegate] = ACTIONS(3685),
    [anon_sym_record] = ACTIONS(3685),
    [anon_sym_abstract] = ACTIONS(3685),
    [anon_sym_async] = ACTIONS(3685),
    [anon_sym_const] = ACTIONS(3685),
    [anon_sym_file] = ACTIONS(3685),
    [anon_sym_fixed] = ACTIONS(3685),
    [anon_sym_internal] = ACTIONS(3685),
    [anon_sym_new] = ACTIONS(3685),
    [anon_sym_override] = ACTIONS(3685),
    [anon_sym_partial] = ACTIONS(3685),
    [anon_sym_private] = ACTIONS(3685),
    [anon_sym_protected] = ACTIONS(3685),
    [anon_sym_public] = ACTIONS(3685),
    [anon_sym_readonly] = ACTIONS(3685),
    [anon_sym_required] = ACTIONS(3685),
    [anon_sym_sealed] = ACTIONS(3685),
    [anon_sym_virtual] = ACTIONS(3685),
    [anon_sym_volatile] = ACTIONS(3685),
    [anon_sym_where] = ACTIONS(3685),
    [anon_sym_notnull] = ACTIONS(3685),
    [anon_sym_unmanaged] = ACTIONS(3685),
    [anon_sym_checked] = ACTIONS(3685),
    [anon_sym_BANG] = ACTIONS(3687),
    [anon_sym_TILDE] = ACTIONS(3687),
    [anon_sym_PLUS_PLUS] = ACTIONS(3687),
    [anon_sym_DASH_DASH] = ACTIONS(3687),
    [anon_sym_true] = ACTIONS(3685),
    [anon_sym_false] = ACTIONS(3685),
    [anon_sym_PLUS] = ACTIONS(3685),
    [anon_sym_DASH] = ACTIONS(3685),
    [anon_sym_STAR] = ACTIONS(3687),
    [anon_sym_CARET] = ACTIONS(3687),
    [anon_sym_AMP] = ACTIONS(3687),
    [anon_sym_this] = ACTIONS(3685),
    [anon_sym_scoped] = ACTIONS(3685),
    [anon_sym_var] = ACTIONS(3685),
    [sym_predefined_type] = ACTIONS(3685),
    [anon_sym_break] = ACTIONS(3685),
    [anon_sym_unchecked] = ACTIONS(3685),
    [anon_sym_continue] = ACTIONS(3685),
    [anon_sym_do] = ACTIONS(3685),
    [anon_sym_while] = ACTIONS(3685),
    [anon_sym_for] = ACTIONS(3685),
    [anon_sym_lock] = ACTIONS(3685),
    [anon_sym_yield] = ACTIONS(3685),
    [anon_sym_switch] = ACTIONS(3685),
    [anon_sym_default] = ACTIONS(3685),
    [anon_sym_throw] = ACTIONS(3685),
    [anon_sym_try] = ACTIONS(3685),
    [anon_sym_when] = ACTIONS(3685),
    [anon_sym_await] = ACTIONS(3685),
    [anon_sym_foreach] = ACTIONS(3685),
    [anon_sym_goto] = ACTIONS(3685),
    [anon_sym_if] = ACTIONS(3685),
    [anon_sym_DOT_DOT] = ACTIONS(3687),
    [anon_sym_from] = ACTIONS(3685),
    [anon_sym_into] = ACTIONS(3685),
    [anon_sym_join] = ACTIONS(3685),
    [anon_sym_on] = ACTIONS(3685),
    [anon_sym_equals] = ACTIONS(3685),
    [anon_sym_let] = ACTIONS(3685),
    [anon_sym_orderby] = ACTIONS(3685),
    [anon_sym_ascending] = ACTIONS(3685),
    [anon_sym_descending] = ACTIONS(3685),
    [anon_sym_group] = ACTIONS(3685),
    [anon_sym_by] = ACTIONS(3685),
    [anon_sym_select] = ACTIONS(3685),
    [anon_sym_DQUOTE] = ACTIONS(3685),
    [anon_sym_stackalloc] = ACTIONS(3685),
    [anon_sym_sizeof] = ACTIONS(3685),
    [anon_sym_typeof] = ACTIONS(3685),
    [anon_sym___makeref] = ACTIONS(3685),
    [anon_sym___reftype] = ACTIONS(3685),
    [anon_sym___refvalue] = ACTIONS(3685),
    [sym_null_literal] = ACTIONS(3685),
    [anon_sym_SQUOTE] = ACTIONS(3687),
    [sym_integer_literal] = ACTIONS(3685),
    [sym_real_literal] = ACTIONS(3687),
    [sym_verbatim_string_literal] = ACTIONS(3687),
    [sym_raw_string_literal] = ACTIONS(3687),
    [aux_sym_preproc_if_token1] = ACTIONS(3687),
    [aux_sym_preproc_if_token3] = ACTIONS(3687),
    [aux_sym_preproc_else_token1] = ACTIONS(3687),
    [aux_sym_preproc_elif_token1] = ACTIONS(3687),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3687),
    [sym_interpolation_verbatim_start] = ACTIONS(3687),
    [sym_interpolation_raw_start] = ACTIONS(3687),
  },
  [2366] = {
    [sym_preproc_region] = STATE(2366),
    [sym_preproc_endregion] = STATE(2366),
    [sym_preproc_line] = STATE(2366),
    [sym_preproc_pragma] = STATE(2366),
    [sym_preproc_nullable] = STATE(2366),
    [sym_preproc_error] = STATE(2366),
    [sym_preproc_define] = STATE(2366),
    [sym_preproc_undef] = STATE(2366),
    [sym__identifier_token] = ACTIONS(3689),
    [anon_sym_extern] = ACTIONS(3689),
    [anon_sym_alias] = ACTIONS(3689),
    [anon_sym_SEMI] = ACTIONS(3691),
    [anon_sym_global] = ACTIONS(3689),
    [anon_sym_using] = ACTIONS(3689),
    [anon_sym_unsafe] = ACTIONS(3689),
    [anon_sym_static] = ACTIONS(3689),
    [anon_sym_LBRACK] = ACTIONS(3691),
    [anon_sym_LPAREN] = ACTIONS(3691),
    [anon_sym_return] = ACTIONS(3689),
    [anon_sym_namespace] = ACTIONS(3689),
    [anon_sym_class] = ACTIONS(3689),
    [anon_sym_ref] = ACTIONS(3689),
    [anon_sym_struct] = ACTIONS(3689),
    [anon_sym_enum] = ACTIONS(3689),
    [anon_sym_LBRACE] = ACTIONS(3691),
    [anon_sym_interface] = ACTIONS(3689),
    [anon_sym_delegate] = ACTIONS(3689),
    [anon_sym_record] = ACTIONS(3689),
    [anon_sym_abstract] = ACTIONS(3689),
    [anon_sym_async] = ACTIONS(3689),
    [anon_sym_const] = ACTIONS(3689),
    [anon_sym_file] = ACTIONS(3689),
    [anon_sym_fixed] = ACTIONS(3689),
    [anon_sym_internal] = ACTIONS(3689),
    [anon_sym_new] = ACTIONS(3689),
    [anon_sym_override] = ACTIONS(3689),
    [anon_sym_partial] = ACTIONS(3689),
    [anon_sym_private] = ACTIONS(3689),
    [anon_sym_protected] = ACTIONS(3689),
    [anon_sym_public] = ACTIONS(3689),
    [anon_sym_readonly] = ACTIONS(3689),
    [anon_sym_required] = ACTIONS(3689),
    [anon_sym_sealed] = ACTIONS(3689),
    [anon_sym_virtual] = ACTIONS(3689),
    [anon_sym_volatile] = ACTIONS(3689),
    [anon_sym_where] = ACTIONS(3689),
    [anon_sym_notnull] = ACTIONS(3689),
    [anon_sym_unmanaged] = ACTIONS(3689),
    [anon_sym_checked] = ACTIONS(3689),
    [anon_sym_BANG] = ACTIONS(3691),
    [anon_sym_TILDE] = ACTIONS(3691),
    [anon_sym_PLUS_PLUS] = ACTIONS(3691),
    [anon_sym_DASH_DASH] = ACTIONS(3691),
    [anon_sym_true] = ACTIONS(3689),
    [anon_sym_false] = ACTIONS(3689),
    [anon_sym_PLUS] = ACTIONS(3689),
    [anon_sym_DASH] = ACTIONS(3689),
    [anon_sym_STAR] = ACTIONS(3691),
    [anon_sym_CARET] = ACTIONS(3691),
    [anon_sym_AMP] = ACTIONS(3691),
    [anon_sym_this] = ACTIONS(3689),
    [anon_sym_scoped] = ACTIONS(3689),
    [anon_sym_var] = ACTIONS(3689),
    [sym_predefined_type] = ACTIONS(3689),
    [anon_sym_break] = ACTIONS(3689),
    [anon_sym_unchecked] = ACTIONS(3689),
    [anon_sym_continue] = ACTIONS(3689),
    [anon_sym_do] = ACTIONS(3689),
    [anon_sym_while] = ACTIONS(3689),
    [anon_sym_for] = ACTIONS(3689),
    [anon_sym_lock] = ACTIONS(3689),
    [anon_sym_yield] = ACTIONS(3689),
    [anon_sym_switch] = ACTIONS(3689),
    [anon_sym_default] = ACTIONS(3689),
    [anon_sym_throw] = ACTIONS(3689),
    [anon_sym_try] = ACTIONS(3689),
    [anon_sym_when] = ACTIONS(3689),
    [anon_sym_await] = ACTIONS(3689),
    [anon_sym_foreach] = ACTIONS(3689),
    [anon_sym_goto] = ACTIONS(3689),
    [anon_sym_if] = ACTIONS(3689),
    [anon_sym_DOT_DOT] = ACTIONS(3691),
    [anon_sym_from] = ACTIONS(3689),
    [anon_sym_into] = ACTIONS(3689),
    [anon_sym_join] = ACTIONS(3689),
    [anon_sym_on] = ACTIONS(3689),
    [anon_sym_equals] = ACTIONS(3689),
    [anon_sym_let] = ACTIONS(3689),
    [anon_sym_orderby] = ACTIONS(3689),
    [anon_sym_ascending] = ACTIONS(3689),
    [anon_sym_descending] = ACTIONS(3689),
    [anon_sym_group] = ACTIONS(3689),
    [anon_sym_by] = ACTIONS(3689),
    [anon_sym_select] = ACTIONS(3689),
    [anon_sym_DQUOTE] = ACTIONS(3689),
    [anon_sym_stackalloc] = ACTIONS(3689),
    [anon_sym_sizeof] = ACTIONS(3689),
    [anon_sym_typeof] = ACTIONS(3689),
    [anon_sym___makeref] = ACTIONS(3689),
    [anon_sym___reftype] = ACTIONS(3689),
    [anon_sym___refvalue] = ACTIONS(3689),
    [sym_null_literal] = ACTIONS(3689),
    [anon_sym_SQUOTE] = ACTIONS(3691),
    [sym_integer_literal] = ACTIONS(3689),
    [sym_real_literal] = ACTIONS(3691),
    [sym_verbatim_string_literal] = ACTIONS(3691),
    [sym_raw_string_literal] = ACTIONS(3691),
    [aux_sym_preproc_if_token1] = ACTIONS(3691),
    [aux_sym_preproc_if_token3] = ACTIONS(3691),
    [aux_sym_preproc_else_token1] = ACTIONS(3691),
    [aux_sym_preproc_elif_token1] = ACTIONS(3691),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3691),
    [sym_interpolation_verbatim_start] = ACTIONS(3691),
    [sym_interpolation_raw_start] = ACTIONS(3691),
  },
  [2367] = {
    [sym_preproc_region] = STATE(2367),
    [sym_preproc_endregion] = STATE(2367),
    [sym_preproc_line] = STATE(2367),
    [sym_preproc_pragma] = STATE(2367),
    [sym_preproc_nullable] = STATE(2367),
    [sym_preproc_error] = STATE(2367),
    [sym_preproc_define] = STATE(2367),
    [sym_preproc_undef] = STATE(2367),
    [sym__identifier_token] = ACTIONS(3693),
    [anon_sym_extern] = ACTIONS(3693),
    [anon_sym_alias] = ACTIONS(3693),
    [anon_sym_SEMI] = ACTIONS(3695),
    [anon_sym_global] = ACTIONS(3693),
    [anon_sym_using] = ACTIONS(3693),
    [anon_sym_unsafe] = ACTIONS(3693),
    [anon_sym_static] = ACTIONS(3693),
    [anon_sym_LBRACK] = ACTIONS(3695),
    [anon_sym_LPAREN] = ACTIONS(3695),
    [anon_sym_return] = ACTIONS(3693),
    [anon_sym_namespace] = ACTIONS(3693),
    [anon_sym_class] = ACTIONS(3693),
    [anon_sym_ref] = ACTIONS(3693),
    [anon_sym_struct] = ACTIONS(3693),
    [anon_sym_enum] = ACTIONS(3693),
    [anon_sym_LBRACE] = ACTIONS(3695),
    [anon_sym_interface] = ACTIONS(3693),
    [anon_sym_delegate] = ACTIONS(3693),
    [anon_sym_record] = ACTIONS(3693),
    [anon_sym_abstract] = ACTIONS(3693),
    [anon_sym_async] = ACTIONS(3693),
    [anon_sym_const] = ACTIONS(3693),
    [anon_sym_file] = ACTIONS(3693),
    [anon_sym_fixed] = ACTIONS(3693),
    [anon_sym_internal] = ACTIONS(3693),
    [anon_sym_new] = ACTIONS(3693),
    [anon_sym_override] = ACTIONS(3693),
    [anon_sym_partial] = ACTIONS(3693),
    [anon_sym_private] = ACTIONS(3693),
    [anon_sym_protected] = ACTIONS(3693),
    [anon_sym_public] = ACTIONS(3693),
    [anon_sym_readonly] = ACTIONS(3693),
    [anon_sym_required] = ACTIONS(3693),
    [anon_sym_sealed] = ACTIONS(3693),
    [anon_sym_virtual] = ACTIONS(3693),
    [anon_sym_volatile] = ACTIONS(3693),
    [anon_sym_where] = ACTIONS(3693),
    [anon_sym_notnull] = ACTIONS(3693),
    [anon_sym_unmanaged] = ACTIONS(3693),
    [anon_sym_checked] = ACTIONS(3693),
    [anon_sym_BANG] = ACTIONS(3695),
    [anon_sym_TILDE] = ACTIONS(3695),
    [anon_sym_PLUS_PLUS] = ACTIONS(3695),
    [anon_sym_DASH_DASH] = ACTIONS(3695),
    [anon_sym_true] = ACTIONS(3693),
    [anon_sym_false] = ACTIONS(3693),
    [anon_sym_PLUS] = ACTIONS(3693),
    [anon_sym_DASH] = ACTIONS(3693),
    [anon_sym_STAR] = ACTIONS(3695),
    [anon_sym_CARET] = ACTIONS(3695),
    [anon_sym_AMP] = ACTIONS(3695),
    [anon_sym_this] = ACTIONS(3693),
    [anon_sym_scoped] = ACTIONS(3693),
    [anon_sym_var] = ACTIONS(3693),
    [sym_predefined_type] = ACTIONS(3693),
    [anon_sym_break] = ACTIONS(3693),
    [anon_sym_unchecked] = ACTIONS(3693),
    [anon_sym_continue] = ACTIONS(3693),
    [anon_sym_do] = ACTIONS(3693),
    [anon_sym_while] = ACTIONS(3693),
    [anon_sym_for] = ACTIONS(3693),
    [anon_sym_lock] = ACTIONS(3693),
    [anon_sym_yield] = ACTIONS(3693),
    [anon_sym_switch] = ACTIONS(3693),
    [anon_sym_default] = ACTIONS(3693),
    [anon_sym_throw] = ACTIONS(3693),
    [anon_sym_try] = ACTIONS(3693),
    [anon_sym_when] = ACTIONS(3693),
    [anon_sym_await] = ACTIONS(3693),
    [anon_sym_foreach] = ACTIONS(3693),
    [anon_sym_goto] = ACTIONS(3693),
    [anon_sym_if] = ACTIONS(3693),
    [anon_sym_DOT_DOT] = ACTIONS(3695),
    [anon_sym_from] = ACTIONS(3693),
    [anon_sym_into] = ACTIONS(3693),
    [anon_sym_join] = ACTIONS(3693),
    [anon_sym_on] = ACTIONS(3693),
    [anon_sym_equals] = ACTIONS(3693),
    [anon_sym_let] = ACTIONS(3693),
    [anon_sym_orderby] = ACTIONS(3693),
    [anon_sym_ascending] = ACTIONS(3693),
    [anon_sym_descending] = ACTIONS(3693),
    [anon_sym_group] = ACTIONS(3693),
    [anon_sym_by] = ACTIONS(3693),
    [anon_sym_select] = ACTIONS(3693),
    [anon_sym_DQUOTE] = ACTIONS(3693),
    [anon_sym_stackalloc] = ACTIONS(3693),
    [anon_sym_sizeof] = ACTIONS(3693),
    [anon_sym_typeof] = ACTIONS(3693),
    [anon_sym___makeref] = ACTIONS(3693),
    [anon_sym___reftype] = ACTIONS(3693),
    [anon_sym___refvalue] = ACTIONS(3693),
    [sym_null_literal] = ACTIONS(3693),
    [anon_sym_SQUOTE] = ACTIONS(3695),
    [sym_integer_literal] = ACTIONS(3693),
    [sym_real_literal] = ACTIONS(3695),
    [sym_verbatim_string_literal] = ACTIONS(3695),
    [sym_raw_string_literal] = ACTIONS(3695),
    [aux_sym_preproc_if_token1] = ACTIONS(3695),
    [aux_sym_preproc_if_token3] = ACTIONS(3695),
    [aux_sym_preproc_else_token1] = ACTIONS(3695),
    [aux_sym_preproc_elif_token1] = ACTIONS(3695),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3695),
    [sym_interpolation_verbatim_start] = ACTIONS(3695),
    [sym_interpolation_raw_start] = ACTIONS(3695),
  },
  [2368] = {
    [sym_preproc_region] = STATE(2368),
    [sym_preproc_endregion] = STATE(2368),
    [sym_preproc_line] = STATE(2368),
    [sym_preproc_pragma] = STATE(2368),
    [sym_preproc_nullable] = STATE(2368),
    [sym_preproc_error] = STATE(2368),
    [sym_preproc_define] = STATE(2368),
    [sym_preproc_undef] = STATE(2368),
    [sym__identifier_token] = ACTIONS(3697),
    [anon_sym_extern] = ACTIONS(3697),
    [anon_sym_alias] = ACTIONS(3697),
    [anon_sym_SEMI] = ACTIONS(3699),
    [anon_sym_global] = ACTIONS(3697),
    [anon_sym_using] = ACTIONS(3697),
    [anon_sym_unsafe] = ACTIONS(3697),
    [anon_sym_static] = ACTIONS(3697),
    [anon_sym_LBRACK] = ACTIONS(3699),
    [anon_sym_LPAREN] = ACTIONS(3699),
    [anon_sym_return] = ACTIONS(3697),
    [anon_sym_namespace] = ACTIONS(3697),
    [anon_sym_class] = ACTIONS(3697),
    [anon_sym_ref] = ACTIONS(3697),
    [anon_sym_struct] = ACTIONS(3697),
    [anon_sym_enum] = ACTIONS(3697),
    [anon_sym_LBRACE] = ACTIONS(3699),
    [anon_sym_interface] = ACTIONS(3697),
    [anon_sym_delegate] = ACTIONS(3697),
    [anon_sym_record] = ACTIONS(3697),
    [anon_sym_abstract] = ACTIONS(3697),
    [anon_sym_async] = ACTIONS(3697),
    [anon_sym_const] = ACTIONS(3697),
    [anon_sym_file] = ACTIONS(3697),
    [anon_sym_fixed] = ACTIONS(3697),
    [anon_sym_internal] = ACTIONS(3697),
    [anon_sym_new] = ACTIONS(3697),
    [anon_sym_override] = ACTIONS(3697),
    [anon_sym_partial] = ACTIONS(3697),
    [anon_sym_private] = ACTIONS(3697),
    [anon_sym_protected] = ACTIONS(3697),
    [anon_sym_public] = ACTIONS(3697),
    [anon_sym_readonly] = ACTIONS(3697),
    [anon_sym_required] = ACTIONS(3697),
    [anon_sym_sealed] = ACTIONS(3697),
    [anon_sym_virtual] = ACTIONS(3697),
    [anon_sym_volatile] = ACTIONS(3697),
    [anon_sym_where] = ACTIONS(3697),
    [anon_sym_notnull] = ACTIONS(3697),
    [anon_sym_unmanaged] = ACTIONS(3697),
    [anon_sym_checked] = ACTIONS(3697),
    [anon_sym_BANG] = ACTIONS(3699),
    [anon_sym_TILDE] = ACTIONS(3699),
    [anon_sym_PLUS_PLUS] = ACTIONS(3699),
    [anon_sym_DASH_DASH] = ACTIONS(3699),
    [anon_sym_true] = ACTIONS(3697),
    [anon_sym_false] = ACTIONS(3697),
    [anon_sym_PLUS] = ACTIONS(3697),
    [anon_sym_DASH] = ACTIONS(3697),
    [anon_sym_STAR] = ACTIONS(3699),
    [anon_sym_CARET] = ACTIONS(3699),
    [anon_sym_AMP] = ACTIONS(3699),
    [anon_sym_this] = ACTIONS(3697),
    [anon_sym_scoped] = ACTIONS(3697),
    [anon_sym_var] = ACTIONS(3697),
    [sym_predefined_type] = ACTIONS(3697),
    [anon_sym_break] = ACTIONS(3697),
    [anon_sym_unchecked] = ACTIONS(3697),
    [anon_sym_continue] = ACTIONS(3697),
    [anon_sym_do] = ACTIONS(3697),
    [anon_sym_while] = ACTIONS(3697),
    [anon_sym_for] = ACTIONS(3697),
    [anon_sym_lock] = ACTIONS(3697),
    [anon_sym_yield] = ACTIONS(3697),
    [anon_sym_switch] = ACTIONS(3697),
    [anon_sym_default] = ACTIONS(3697),
    [anon_sym_throw] = ACTIONS(3697),
    [anon_sym_try] = ACTIONS(3697),
    [anon_sym_when] = ACTIONS(3697),
    [anon_sym_await] = ACTIONS(3697),
    [anon_sym_foreach] = ACTIONS(3697),
    [anon_sym_goto] = ACTIONS(3697),
    [anon_sym_if] = ACTIONS(3697),
    [anon_sym_DOT_DOT] = ACTIONS(3699),
    [anon_sym_from] = ACTIONS(3697),
    [anon_sym_into] = ACTIONS(3697),
    [anon_sym_join] = ACTIONS(3697),
    [anon_sym_on] = ACTIONS(3697),
    [anon_sym_equals] = ACTIONS(3697),
    [anon_sym_let] = ACTIONS(3697),
    [anon_sym_orderby] = ACTIONS(3697),
    [anon_sym_ascending] = ACTIONS(3697),
    [anon_sym_descending] = ACTIONS(3697),
    [anon_sym_group] = ACTIONS(3697),
    [anon_sym_by] = ACTIONS(3697),
    [anon_sym_select] = ACTIONS(3697),
    [anon_sym_DQUOTE] = ACTIONS(3697),
    [anon_sym_stackalloc] = ACTIONS(3697),
    [anon_sym_sizeof] = ACTIONS(3697),
    [anon_sym_typeof] = ACTIONS(3697),
    [anon_sym___makeref] = ACTIONS(3697),
    [anon_sym___reftype] = ACTIONS(3697),
    [anon_sym___refvalue] = ACTIONS(3697),
    [sym_null_literal] = ACTIONS(3697),
    [anon_sym_SQUOTE] = ACTIONS(3699),
    [sym_integer_literal] = ACTIONS(3697),
    [sym_real_literal] = ACTIONS(3699),
    [sym_verbatim_string_literal] = ACTIONS(3699),
    [sym_raw_string_literal] = ACTIONS(3699),
    [aux_sym_preproc_if_token1] = ACTIONS(3699),
    [aux_sym_preproc_if_token3] = ACTIONS(3699),
    [aux_sym_preproc_else_token1] = ACTIONS(3699),
    [aux_sym_preproc_elif_token1] = ACTIONS(3699),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3699),
    [sym_interpolation_verbatim_start] = ACTIONS(3699),
    [sym_interpolation_raw_start] = ACTIONS(3699),
  },
  [2369] = {
    [sym_preproc_region] = STATE(2369),
    [sym_preproc_endregion] = STATE(2369),
    [sym_preproc_line] = STATE(2369),
    [sym_preproc_pragma] = STATE(2369),
    [sym_preproc_nullable] = STATE(2369),
    [sym_preproc_error] = STATE(2369),
    [sym_preproc_define] = STATE(2369),
    [sym_preproc_undef] = STATE(2369),
    [sym__identifier_token] = ACTIONS(3701),
    [anon_sym_extern] = ACTIONS(3701),
    [anon_sym_alias] = ACTIONS(3701),
    [anon_sym_SEMI] = ACTIONS(3703),
    [anon_sym_global] = ACTIONS(3701),
    [anon_sym_using] = ACTIONS(3701),
    [anon_sym_unsafe] = ACTIONS(3701),
    [anon_sym_static] = ACTIONS(3701),
    [anon_sym_LBRACK] = ACTIONS(3703),
    [anon_sym_LPAREN] = ACTIONS(3703),
    [anon_sym_return] = ACTIONS(3701),
    [anon_sym_namespace] = ACTIONS(3701),
    [anon_sym_class] = ACTIONS(3701),
    [anon_sym_ref] = ACTIONS(3701),
    [anon_sym_struct] = ACTIONS(3701),
    [anon_sym_enum] = ACTIONS(3701),
    [anon_sym_LBRACE] = ACTIONS(3703),
    [anon_sym_interface] = ACTIONS(3701),
    [anon_sym_delegate] = ACTIONS(3701),
    [anon_sym_record] = ACTIONS(3701),
    [anon_sym_abstract] = ACTIONS(3701),
    [anon_sym_async] = ACTIONS(3701),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_file] = ACTIONS(3701),
    [anon_sym_fixed] = ACTIONS(3701),
    [anon_sym_internal] = ACTIONS(3701),
    [anon_sym_new] = ACTIONS(3701),
    [anon_sym_override] = ACTIONS(3701),
    [anon_sym_partial] = ACTIONS(3701),
    [anon_sym_private] = ACTIONS(3701),
    [anon_sym_protected] = ACTIONS(3701),
    [anon_sym_public] = ACTIONS(3701),
    [anon_sym_readonly] = ACTIONS(3701),
    [anon_sym_required] = ACTIONS(3701),
    [anon_sym_sealed] = ACTIONS(3701),
    [anon_sym_virtual] = ACTIONS(3701),
    [anon_sym_volatile] = ACTIONS(3701),
    [anon_sym_where] = ACTIONS(3701),
    [anon_sym_notnull] = ACTIONS(3701),
    [anon_sym_unmanaged] = ACTIONS(3701),
    [anon_sym_checked] = ACTIONS(3701),
    [anon_sym_BANG] = ACTIONS(3703),
    [anon_sym_TILDE] = ACTIONS(3703),
    [anon_sym_PLUS_PLUS] = ACTIONS(3703),
    [anon_sym_DASH_DASH] = ACTIONS(3703),
    [anon_sym_true] = ACTIONS(3701),
    [anon_sym_false] = ACTIONS(3701),
    [anon_sym_PLUS] = ACTIONS(3701),
    [anon_sym_DASH] = ACTIONS(3701),
    [anon_sym_STAR] = ACTIONS(3703),
    [anon_sym_CARET] = ACTIONS(3703),
    [anon_sym_AMP] = ACTIONS(3703),
    [anon_sym_this] = ACTIONS(3701),
    [anon_sym_scoped] = ACTIONS(3701),
    [anon_sym_var] = ACTIONS(3701),
    [sym_predefined_type] = ACTIONS(3701),
    [anon_sym_break] = ACTIONS(3701),
    [anon_sym_unchecked] = ACTIONS(3701),
    [anon_sym_continue] = ACTIONS(3701),
    [anon_sym_do] = ACTIONS(3701),
    [anon_sym_while] = ACTIONS(3701),
    [anon_sym_for] = ACTIONS(3701),
    [anon_sym_lock] = ACTIONS(3701),
    [anon_sym_yield] = ACTIONS(3701),
    [anon_sym_switch] = ACTIONS(3701),
    [anon_sym_default] = ACTIONS(3701),
    [anon_sym_throw] = ACTIONS(3701),
    [anon_sym_try] = ACTIONS(3701),
    [anon_sym_when] = ACTIONS(3701),
    [anon_sym_await] = ACTIONS(3701),
    [anon_sym_foreach] = ACTIONS(3701),
    [anon_sym_goto] = ACTIONS(3701),
    [anon_sym_if] = ACTIONS(3701),
    [anon_sym_DOT_DOT] = ACTIONS(3703),
    [anon_sym_from] = ACTIONS(3701),
    [anon_sym_into] = ACTIONS(3701),
    [anon_sym_join] = ACTIONS(3701),
    [anon_sym_on] = ACTIONS(3701),
    [anon_sym_equals] = ACTIONS(3701),
    [anon_sym_let] = ACTIONS(3701),
    [anon_sym_orderby] = ACTIONS(3701),
    [anon_sym_ascending] = ACTIONS(3701),
    [anon_sym_descending] = ACTIONS(3701),
    [anon_sym_group] = ACTIONS(3701),
    [anon_sym_by] = ACTIONS(3701),
    [anon_sym_select] = ACTIONS(3701),
    [anon_sym_DQUOTE] = ACTIONS(3701),
    [anon_sym_stackalloc] = ACTIONS(3701),
    [anon_sym_sizeof] = ACTIONS(3701),
    [anon_sym_typeof] = ACTIONS(3701),
    [anon_sym___makeref] = ACTIONS(3701),
    [anon_sym___reftype] = ACTIONS(3701),
    [anon_sym___refvalue] = ACTIONS(3701),
    [sym_null_literal] = ACTIONS(3701),
    [anon_sym_SQUOTE] = ACTIONS(3703),
    [sym_integer_literal] = ACTIONS(3701),
    [sym_real_literal] = ACTIONS(3703),
    [sym_verbatim_string_literal] = ACTIONS(3703),
    [sym_raw_string_literal] = ACTIONS(3703),
    [aux_sym_preproc_if_token1] = ACTIONS(3703),
    [aux_sym_preproc_if_token3] = ACTIONS(3703),
    [aux_sym_preproc_else_token1] = ACTIONS(3703),
    [aux_sym_preproc_elif_token1] = ACTIONS(3703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3703),
    [sym_interpolation_verbatim_start] = ACTIONS(3703),
    [sym_interpolation_raw_start] = ACTIONS(3703),
  },
  [2370] = {
    [sym_preproc_region] = STATE(2370),
    [sym_preproc_endregion] = STATE(2370),
    [sym_preproc_line] = STATE(2370),
    [sym_preproc_pragma] = STATE(2370),
    [sym_preproc_nullable] = STATE(2370),
    [sym_preproc_error] = STATE(2370),
    [sym_preproc_define] = STATE(2370),
    [sym_preproc_undef] = STATE(2370),
    [sym__identifier_token] = ACTIONS(3705),
    [anon_sym_extern] = ACTIONS(3705),
    [anon_sym_alias] = ACTIONS(3705),
    [anon_sym_SEMI] = ACTIONS(3707),
    [anon_sym_global] = ACTIONS(3705),
    [anon_sym_using] = ACTIONS(3705),
    [anon_sym_unsafe] = ACTIONS(3705),
    [anon_sym_static] = ACTIONS(3705),
    [anon_sym_LBRACK] = ACTIONS(3707),
    [anon_sym_LPAREN] = ACTIONS(3707),
    [anon_sym_return] = ACTIONS(3705),
    [anon_sym_namespace] = ACTIONS(3705),
    [anon_sym_class] = ACTIONS(3705),
    [anon_sym_ref] = ACTIONS(3705),
    [anon_sym_struct] = ACTIONS(3705),
    [anon_sym_enum] = ACTIONS(3705),
    [anon_sym_LBRACE] = ACTIONS(3707),
    [anon_sym_interface] = ACTIONS(3705),
    [anon_sym_delegate] = ACTIONS(3705),
    [anon_sym_record] = ACTIONS(3705),
    [anon_sym_abstract] = ACTIONS(3705),
    [anon_sym_async] = ACTIONS(3705),
    [anon_sym_const] = ACTIONS(3705),
    [anon_sym_file] = ACTIONS(3705),
    [anon_sym_fixed] = ACTIONS(3705),
    [anon_sym_internal] = ACTIONS(3705),
    [anon_sym_new] = ACTIONS(3705),
    [anon_sym_override] = ACTIONS(3705),
    [anon_sym_partial] = ACTIONS(3705),
    [anon_sym_private] = ACTIONS(3705),
    [anon_sym_protected] = ACTIONS(3705),
    [anon_sym_public] = ACTIONS(3705),
    [anon_sym_readonly] = ACTIONS(3705),
    [anon_sym_required] = ACTIONS(3705),
    [anon_sym_sealed] = ACTIONS(3705),
    [anon_sym_virtual] = ACTIONS(3705),
    [anon_sym_volatile] = ACTIONS(3705),
    [anon_sym_where] = ACTIONS(3705),
    [anon_sym_notnull] = ACTIONS(3705),
    [anon_sym_unmanaged] = ACTIONS(3705),
    [anon_sym_checked] = ACTIONS(3705),
    [anon_sym_BANG] = ACTIONS(3707),
    [anon_sym_TILDE] = ACTIONS(3707),
    [anon_sym_PLUS_PLUS] = ACTIONS(3707),
    [anon_sym_DASH_DASH] = ACTIONS(3707),
    [anon_sym_true] = ACTIONS(3705),
    [anon_sym_false] = ACTIONS(3705),
    [anon_sym_PLUS] = ACTIONS(3705),
    [anon_sym_DASH] = ACTIONS(3705),
    [anon_sym_STAR] = ACTIONS(3707),
    [anon_sym_CARET] = ACTIONS(3707),
    [anon_sym_AMP] = ACTIONS(3707),
    [anon_sym_this] = ACTIONS(3705),
    [anon_sym_scoped] = ACTIONS(3705),
    [anon_sym_var] = ACTIONS(3705),
    [sym_predefined_type] = ACTIONS(3705),
    [anon_sym_break] = ACTIONS(3705),
    [anon_sym_unchecked] = ACTIONS(3705),
    [anon_sym_continue] = ACTIONS(3705),
    [anon_sym_do] = ACTIONS(3705),
    [anon_sym_while] = ACTIONS(3705),
    [anon_sym_for] = ACTIONS(3705),
    [anon_sym_lock] = ACTIONS(3705),
    [anon_sym_yield] = ACTIONS(3705),
    [anon_sym_switch] = ACTIONS(3705),
    [anon_sym_default] = ACTIONS(3705),
    [anon_sym_throw] = ACTIONS(3705),
    [anon_sym_try] = ACTIONS(3705),
    [anon_sym_when] = ACTIONS(3705),
    [anon_sym_await] = ACTIONS(3705),
    [anon_sym_foreach] = ACTIONS(3705),
    [anon_sym_goto] = ACTIONS(3705),
    [anon_sym_if] = ACTIONS(3705),
    [anon_sym_DOT_DOT] = ACTIONS(3707),
    [anon_sym_from] = ACTIONS(3705),
    [anon_sym_into] = ACTIONS(3705),
    [anon_sym_join] = ACTIONS(3705),
    [anon_sym_on] = ACTIONS(3705),
    [anon_sym_equals] = ACTIONS(3705),
    [anon_sym_let] = ACTIONS(3705),
    [anon_sym_orderby] = ACTIONS(3705),
    [anon_sym_ascending] = ACTIONS(3705),
    [anon_sym_descending] = ACTIONS(3705),
    [anon_sym_group] = ACTIONS(3705),
    [anon_sym_by] = ACTIONS(3705),
    [anon_sym_select] = ACTIONS(3705),
    [anon_sym_DQUOTE] = ACTIONS(3705),
    [anon_sym_stackalloc] = ACTIONS(3705),
    [anon_sym_sizeof] = ACTIONS(3705),
    [anon_sym_typeof] = ACTIONS(3705),
    [anon_sym___makeref] = ACTIONS(3705),
    [anon_sym___reftype] = ACTIONS(3705),
    [anon_sym___refvalue] = ACTIONS(3705),
    [sym_null_literal] = ACTIONS(3705),
    [anon_sym_SQUOTE] = ACTIONS(3707),
    [sym_integer_literal] = ACTIONS(3705),
    [sym_real_literal] = ACTIONS(3707),
    [sym_verbatim_string_literal] = ACTIONS(3707),
    [sym_raw_string_literal] = ACTIONS(3707),
    [aux_sym_preproc_if_token1] = ACTIONS(3707),
    [aux_sym_preproc_if_token3] = ACTIONS(3707),
    [aux_sym_preproc_else_token1] = ACTIONS(3707),
    [aux_sym_preproc_elif_token1] = ACTIONS(3707),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3707),
    [sym_interpolation_verbatim_start] = ACTIONS(3707),
    [sym_interpolation_raw_start] = ACTIONS(3707),
  },
  [2371] = {
    [sym_preproc_region] = STATE(2371),
    [sym_preproc_endregion] = STATE(2371),
    [sym_preproc_line] = STATE(2371),
    [sym_preproc_pragma] = STATE(2371),
    [sym_preproc_nullable] = STATE(2371),
    [sym_preproc_error] = STATE(2371),
    [sym_preproc_define] = STATE(2371),
    [sym_preproc_undef] = STATE(2371),
    [sym__identifier_token] = ACTIONS(3709),
    [anon_sym_extern] = ACTIONS(3709),
    [anon_sym_alias] = ACTIONS(3709),
    [anon_sym_SEMI] = ACTIONS(3711),
    [anon_sym_global] = ACTIONS(3709),
    [anon_sym_using] = ACTIONS(3709),
    [anon_sym_unsafe] = ACTIONS(3709),
    [anon_sym_static] = ACTIONS(3709),
    [anon_sym_LBRACK] = ACTIONS(3711),
    [anon_sym_LPAREN] = ACTIONS(3711),
    [anon_sym_return] = ACTIONS(3709),
    [anon_sym_namespace] = ACTIONS(3709),
    [anon_sym_class] = ACTIONS(3709),
    [anon_sym_ref] = ACTIONS(3709),
    [anon_sym_struct] = ACTIONS(3709),
    [anon_sym_enum] = ACTIONS(3709),
    [anon_sym_LBRACE] = ACTIONS(3711),
    [anon_sym_interface] = ACTIONS(3709),
    [anon_sym_delegate] = ACTIONS(3709),
    [anon_sym_record] = ACTIONS(3709),
    [anon_sym_abstract] = ACTIONS(3709),
    [anon_sym_async] = ACTIONS(3709),
    [anon_sym_const] = ACTIONS(3709),
    [anon_sym_file] = ACTIONS(3709),
    [anon_sym_fixed] = ACTIONS(3709),
    [anon_sym_internal] = ACTIONS(3709),
    [anon_sym_new] = ACTIONS(3709),
    [anon_sym_override] = ACTIONS(3709),
    [anon_sym_partial] = ACTIONS(3709),
    [anon_sym_private] = ACTIONS(3709),
    [anon_sym_protected] = ACTIONS(3709),
    [anon_sym_public] = ACTIONS(3709),
    [anon_sym_readonly] = ACTIONS(3709),
    [anon_sym_required] = ACTIONS(3709),
    [anon_sym_sealed] = ACTIONS(3709),
    [anon_sym_virtual] = ACTIONS(3709),
    [anon_sym_volatile] = ACTIONS(3709),
    [anon_sym_where] = ACTIONS(3709),
    [anon_sym_notnull] = ACTIONS(3709),
    [anon_sym_unmanaged] = ACTIONS(3709),
    [anon_sym_checked] = ACTIONS(3709),
    [anon_sym_BANG] = ACTIONS(3711),
    [anon_sym_TILDE] = ACTIONS(3711),
    [anon_sym_PLUS_PLUS] = ACTIONS(3711),
    [anon_sym_DASH_DASH] = ACTIONS(3711),
    [anon_sym_true] = ACTIONS(3709),
    [anon_sym_false] = ACTIONS(3709),
    [anon_sym_PLUS] = ACTIONS(3709),
    [anon_sym_DASH] = ACTIONS(3709),
    [anon_sym_STAR] = ACTIONS(3711),
    [anon_sym_CARET] = ACTIONS(3711),
    [anon_sym_AMP] = ACTIONS(3711),
    [anon_sym_this] = ACTIONS(3709),
    [anon_sym_scoped] = ACTIONS(3709),
    [anon_sym_var] = ACTIONS(3709),
    [sym_predefined_type] = ACTIONS(3709),
    [anon_sym_break] = ACTIONS(3709),
    [anon_sym_unchecked] = ACTIONS(3709),
    [anon_sym_continue] = ACTIONS(3709),
    [anon_sym_do] = ACTIONS(3709),
    [anon_sym_while] = ACTIONS(3709),
    [anon_sym_for] = ACTIONS(3709),
    [anon_sym_lock] = ACTIONS(3709),
    [anon_sym_yield] = ACTIONS(3709),
    [anon_sym_switch] = ACTIONS(3709),
    [anon_sym_default] = ACTIONS(3709),
    [anon_sym_throw] = ACTIONS(3709),
    [anon_sym_try] = ACTIONS(3709),
    [anon_sym_when] = ACTIONS(3709),
    [anon_sym_await] = ACTIONS(3709),
    [anon_sym_foreach] = ACTIONS(3709),
    [anon_sym_goto] = ACTIONS(3709),
    [anon_sym_if] = ACTIONS(3709),
    [anon_sym_DOT_DOT] = ACTIONS(3711),
    [anon_sym_from] = ACTIONS(3709),
    [anon_sym_into] = ACTIONS(3709),
    [anon_sym_join] = ACTIONS(3709),
    [anon_sym_on] = ACTIONS(3709),
    [anon_sym_equals] = ACTIONS(3709),
    [anon_sym_let] = ACTIONS(3709),
    [anon_sym_orderby] = ACTIONS(3709),
    [anon_sym_ascending] = ACTIONS(3709),
    [anon_sym_descending] = ACTIONS(3709),
    [anon_sym_group] = ACTIONS(3709),
    [anon_sym_by] = ACTIONS(3709),
    [anon_sym_select] = ACTIONS(3709),
    [anon_sym_DQUOTE] = ACTIONS(3709),
    [anon_sym_stackalloc] = ACTIONS(3709),
    [anon_sym_sizeof] = ACTIONS(3709),
    [anon_sym_typeof] = ACTIONS(3709),
    [anon_sym___makeref] = ACTIONS(3709),
    [anon_sym___reftype] = ACTIONS(3709),
    [anon_sym___refvalue] = ACTIONS(3709),
    [sym_null_literal] = ACTIONS(3709),
    [anon_sym_SQUOTE] = ACTIONS(3711),
    [sym_integer_literal] = ACTIONS(3709),
    [sym_real_literal] = ACTIONS(3711),
    [sym_verbatim_string_literal] = ACTIONS(3711),
    [sym_raw_string_literal] = ACTIONS(3711),
    [aux_sym_preproc_if_token1] = ACTIONS(3711),
    [aux_sym_preproc_if_token3] = ACTIONS(3711),
    [aux_sym_preproc_else_token1] = ACTIONS(3711),
    [aux_sym_preproc_elif_token1] = ACTIONS(3711),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3711),
    [sym_interpolation_verbatim_start] = ACTIONS(3711),
    [sym_interpolation_raw_start] = ACTIONS(3711),
  },
  [2372] = {
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7330),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_identifier] = STATE(6784),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(2372),
    [sym_preproc_endregion] = STATE(2372),
    [sym_preproc_line] = STATE(2372),
    [sym_preproc_pragma] = STATE(2372),
    [sym_preproc_nullable] = STATE(2372),
    [sym_preproc_error] = STATE(2372),
    [sym_preproc_define] = STATE(2372),
    [sym_preproc_undef] = STATE(2372),
    [sym__identifier_token] = ACTIONS(3713),
    [anon_sym_alias] = ACTIONS(3716),
    [anon_sym_SEMI] = ACTIONS(3719),
    [anon_sym_global] = ACTIONS(3716),
    [anon_sym_EQ] = ACTIONS(3721),
    [anon_sym_LBRACK] = ACTIONS(3719),
    [anon_sym_COLON] = ACTIONS(3721),
    [anon_sym_COMMA] = ACTIONS(3719),
    [anon_sym_RBRACK] = ACTIONS(3719),
    [anon_sym_LPAREN] = ACTIONS(3723),
    [anon_sym_RPAREN] = ACTIONS(3719),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_LBRACE] = ACTIONS(3719),
    [anon_sym_RBRACE] = ACTIONS(3719),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_file] = ACTIONS(3716),
    [anon_sym_LT] = ACTIONS(3721),
    [anon_sym_GT] = ACTIONS(3721),
    [anon_sym_in] = ACTIONS(3721),
    [anon_sym_where] = ACTIONS(3716),
    [anon_sym_QMARK] = ACTIONS(3721),
    [anon_sym_notnull] = ACTIONS(3716),
    [anon_sym_unmanaged] = ACTIONS(3716),
    [anon_sym_BANG] = ACTIONS(3721),
    [anon_sym_PLUS_PLUS] = ACTIONS(3719),
    [anon_sym_DASH_DASH] = ACTIONS(3719),
    [anon_sym_PLUS] = ACTIONS(3721),
    [anon_sym_DASH] = ACTIONS(3721),
    [anon_sym_STAR] = ACTIONS(3721),
    [anon_sym_SLASH] = ACTIONS(3721),
    [anon_sym_PERCENT] = ACTIONS(3721),
    [anon_sym_CARET] = ACTIONS(3721),
    [anon_sym_PIPE] = ACTIONS(3721),
    [anon_sym_AMP] = ACTIONS(3721),
    [anon_sym_LT_LT] = ACTIONS(3721),
    [anon_sym_GT_GT] = ACTIONS(3721),
    [anon_sym_GT_GT_GT] = ACTIONS(3721),
    [anon_sym_EQ_EQ] = ACTIONS(3719),
    [anon_sym_BANG_EQ] = ACTIONS(3719),
    [anon_sym_GT_EQ] = ACTIONS(3719),
    [anon_sym_LT_EQ] = ACTIONS(3719),
    [anon_sym_DOT] = ACTIONS(3721),
    [anon_sym_scoped] = ACTIONS(3730),
    [anon_sym_EQ_GT] = ACTIONS(3719),
    [anon_sym_COLON_COLON] = ACTIONS(3719),
    [anon_sym_var] = ACTIONS(3733),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(3716),
    [anon_sym_switch] = ACTIONS(3721),
    [anon_sym_when] = ACTIONS(3716),
    [sym_discard] = ACTIONS(3721),
    [anon_sym_DOT_DOT] = ACTIONS(3719),
    [anon_sym_and] = ACTIONS(3721),
    [anon_sym_or] = ACTIONS(3721),
    [anon_sym_PLUS_EQ] = ACTIONS(3719),
    [anon_sym_DASH_EQ] = ACTIONS(3719),
    [anon_sym_STAR_EQ] = ACTIONS(3719),
    [anon_sym_SLASH_EQ] = ACTIONS(3719),
    [anon_sym_PERCENT_EQ] = ACTIONS(3719),
    [anon_sym_AMP_EQ] = ACTIONS(3719),
    [anon_sym_CARET_EQ] = ACTIONS(3719),
    [anon_sym_PIPE_EQ] = ACTIONS(3719),
    [anon_sym_LT_LT_EQ] = ACTIONS(3719),
    [anon_sym_GT_GT_EQ] = ACTIONS(3719),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3719),
    [anon_sym_AMP_AMP] = ACTIONS(3719),
    [anon_sym_PIPE_PIPE] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK] = ACTIONS(3721),
    [anon_sym_from] = ACTIONS(3716),
    [anon_sym_into] = ACTIONS(3716),
    [anon_sym_join] = ACTIONS(3716),
    [anon_sym_on] = ACTIONS(3716),
    [anon_sym_equals] = ACTIONS(3716),
    [anon_sym_let] = ACTIONS(3716),
    [anon_sym_orderby] = ACTIONS(3716),
    [anon_sym_ascending] = ACTIONS(3716),
    [anon_sym_descending] = ACTIONS(3716),
    [anon_sym_group] = ACTIONS(3716),
    [anon_sym_by] = ACTIONS(3716),
    [anon_sym_select] = ACTIONS(3716),
    [anon_sym_as] = ACTIONS(3721),
    [anon_sym_is] = ACTIONS(3721),
    [anon_sym_DASH_GT] = ACTIONS(3719),
    [anon_sym_with] = ACTIONS(3721),
    [aux_sym_preproc_if_token3] = ACTIONS(3719),
    [aux_sym_preproc_else_token1] = ACTIONS(3719),
    [aux_sym_preproc_elif_token1] = ACTIONS(3719),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2373] = {
    [sym_preproc_region] = STATE(2373),
    [sym_preproc_endregion] = STATE(2373),
    [sym_preproc_line] = STATE(2373),
    [sym_preproc_pragma] = STATE(2373),
    [sym_preproc_nullable] = STATE(2373),
    [sym_preproc_error] = STATE(2373),
    [sym_preproc_define] = STATE(2373),
    [sym_preproc_undef] = STATE(2373),
    [sym__identifier_token] = ACTIONS(3736),
    [anon_sym_extern] = ACTIONS(3736),
    [anon_sym_alias] = ACTIONS(3736),
    [anon_sym_SEMI] = ACTIONS(3738),
    [anon_sym_global] = ACTIONS(3736),
    [anon_sym_using] = ACTIONS(3736),
    [anon_sym_unsafe] = ACTIONS(3736),
    [anon_sym_static] = ACTIONS(3736),
    [anon_sym_LBRACK] = ACTIONS(3738),
    [anon_sym_LPAREN] = ACTIONS(3738),
    [anon_sym_return] = ACTIONS(3736),
    [anon_sym_namespace] = ACTIONS(3736),
    [anon_sym_class] = ACTIONS(3736),
    [anon_sym_ref] = ACTIONS(3736),
    [anon_sym_struct] = ACTIONS(3736),
    [anon_sym_enum] = ACTIONS(3736),
    [anon_sym_LBRACE] = ACTIONS(3738),
    [anon_sym_interface] = ACTIONS(3736),
    [anon_sym_delegate] = ACTIONS(3736),
    [anon_sym_record] = ACTIONS(3736),
    [anon_sym_abstract] = ACTIONS(3736),
    [anon_sym_async] = ACTIONS(3736),
    [anon_sym_const] = ACTIONS(3736),
    [anon_sym_file] = ACTIONS(3736),
    [anon_sym_fixed] = ACTIONS(3736),
    [anon_sym_internal] = ACTIONS(3736),
    [anon_sym_new] = ACTIONS(3736),
    [anon_sym_override] = ACTIONS(3736),
    [anon_sym_partial] = ACTIONS(3736),
    [anon_sym_private] = ACTIONS(3736),
    [anon_sym_protected] = ACTIONS(3736),
    [anon_sym_public] = ACTIONS(3736),
    [anon_sym_readonly] = ACTIONS(3736),
    [anon_sym_required] = ACTIONS(3736),
    [anon_sym_sealed] = ACTIONS(3736),
    [anon_sym_virtual] = ACTIONS(3736),
    [anon_sym_volatile] = ACTIONS(3736),
    [anon_sym_where] = ACTIONS(3736),
    [anon_sym_notnull] = ACTIONS(3736),
    [anon_sym_unmanaged] = ACTIONS(3736),
    [anon_sym_checked] = ACTIONS(3736),
    [anon_sym_BANG] = ACTIONS(3738),
    [anon_sym_TILDE] = ACTIONS(3738),
    [anon_sym_PLUS_PLUS] = ACTIONS(3738),
    [anon_sym_DASH_DASH] = ACTIONS(3738),
    [anon_sym_true] = ACTIONS(3736),
    [anon_sym_false] = ACTIONS(3736),
    [anon_sym_PLUS] = ACTIONS(3736),
    [anon_sym_DASH] = ACTIONS(3736),
    [anon_sym_STAR] = ACTIONS(3738),
    [anon_sym_CARET] = ACTIONS(3738),
    [anon_sym_AMP] = ACTIONS(3738),
    [anon_sym_this] = ACTIONS(3736),
    [anon_sym_scoped] = ACTIONS(3736),
    [anon_sym_var] = ACTIONS(3736),
    [sym_predefined_type] = ACTIONS(3736),
    [anon_sym_break] = ACTIONS(3736),
    [anon_sym_unchecked] = ACTIONS(3736),
    [anon_sym_continue] = ACTIONS(3736),
    [anon_sym_do] = ACTIONS(3736),
    [anon_sym_while] = ACTIONS(3736),
    [anon_sym_for] = ACTIONS(3736),
    [anon_sym_lock] = ACTIONS(3736),
    [anon_sym_yield] = ACTIONS(3736),
    [anon_sym_switch] = ACTIONS(3736),
    [anon_sym_default] = ACTIONS(3736),
    [anon_sym_throw] = ACTIONS(3736),
    [anon_sym_try] = ACTIONS(3736),
    [anon_sym_when] = ACTIONS(3736),
    [anon_sym_await] = ACTIONS(3736),
    [anon_sym_foreach] = ACTIONS(3736),
    [anon_sym_goto] = ACTIONS(3736),
    [anon_sym_if] = ACTIONS(3736),
    [anon_sym_DOT_DOT] = ACTIONS(3738),
    [anon_sym_from] = ACTIONS(3736),
    [anon_sym_into] = ACTIONS(3736),
    [anon_sym_join] = ACTIONS(3736),
    [anon_sym_on] = ACTIONS(3736),
    [anon_sym_equals] = ACTIONS(3736),
    [anon_sym_let] = ACTIONS(3736),
    [anon_sym_orderby] = ACTIONS(3736),
    [anon_sym_ascending] = ACTIONS(3736),
    [anon_sym_descending] = ACTIONS(3736),
    [anon_sym_group] = ACTIONS(3736),
    [anon_sym_by] = ACTIONS(3736),
    [anon_sym_select] = ACTIONS(3736),
    [anon_sym_DQUOTE] = ACTIONS(3736),
    [anon_sym_stackalloc] = ACTIONS(3736),
    [anon_sym_sizeof] = ACTIONS(3736),
    [anon_sym_typeof] = ACTIONS(3736),
    [anon_sym___makeref] = ACTIONS(3736),
    [anon_sym___reftype] = ACTIONS(3736),
    [anon_sym___refvalue] = ACTIONS(3736),
    [sym_null_literal] = ACTIONS(3736),
    [anon_sym_SQUOTE] = ACTIONS(3738),
    [sym_integer_literal] = ACTIONS(3736),
    [sym_real_literal] = ACTIONS(3738),
    [sym_verbatim_string_literal] = ACTIONS(3738),
    [sym_raw_string_literal] = ACTIONS(3738),
    [aux_sym_preproc_if_token1] = ACTIONS(3738),
    [aux_sym_preproc_if_token3] = ACTIONS(3738),
    [aux_sym_preproc_else_token1] = ACTIONS(3738),
    [aux_sym_preproc_elif_token1] = ACTIONS(3738),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3738),
    [sym_interpolation_verbatim_start] = ACTIONS(3738),
    [sym_interpolation_raw_start] = ACTIONS(3738),
  },
  [2374] = {
    [sym_preproc_region] = STATE(2374),
    [sym_preproc_endregion] = STATE(2374),
    [sym_preproc_line] = STATE(2374),
    [sym_preproc_pragma] = STATE(2374),
    [sym_preproc_nullable] = STATE(2374),
    [sym_preproc_error] = STATE(2374),
    [sym_preproc_define] = STATE(2374),
    [sym_preproc_undef] = STATE(2374),
    [sym__identifier_token] = ACTIONS(3740),
    [anon_sym_extern] = ACTIONS(3740),
    [anon_sym_alias] = ACTIONS(3740),
    [anon_sym_SEMI] = ACTIONS(3742),
    [anon_sym_global] = ACTIONS(3740),
    [anon_sym_using] = ACTIONS(3740),
    [anon_sym_unsafe] = ACTIONS(3740),
    [anon_sym_static] = ACTIONS(3740),
    [anon_sym_LBRACK] = ACTIONS(3742),
    [anon_sym_LPAREN] = ACTIONS(3742),
    [anon_sym_return] = ACTIONS(3740),
    [anon_sym_namespace] = ACTIONS(3740),
    [anon_sym_class] = ACTIONS(3740),
    [anon_sym_ref] = ACTIONS(3740),
    [anon_sym_struct] = ACTIONS(3740),
    [anon_sym_enum] = ACTIONS(3740),
    [anon_sym_LBRACE] = ACTIONS(3742),
    [anon_sym_interface] = ACTIONS(3740),
    [anon_sym_delegate] = ACTIONS(3740),
    [anon_sym_record] = ACTIONS(3740),
    [anon_sym_abstract] = ACTIONS(3740),
    [anon_sym_async] = ACTIONS(3740),
    [anon_sym_const] = ACTIONS(3740),
    [anon_sym_file] = ACTIONS(3740),
    [anon_sym_fixed] = ACTIONS(3740),
    [anon_sym_internal] = ACTIONS(3740),
    [anon_sym_new] = ACTIONS(3740),
    [anon_sym_override] = ACTIONS(3740),
    [anon_sym_partial] = ACTIONS(3740),
    [anon_sym_private] = ACTIONS(3740),
    [anon_sym_protected] = ACTIONS(3740),
    [anon_sym_public] = ACTIONS(3740),
    [anon_sym_readonly] = ACTIONS(3740),
    [anon_sym_required] = ACTIONS(3740),
    [anon_sym_sealed] = ACTIONS(3740),
    [anon_sym_virtual] = ACTIONS(3740),
    [anon_sym_volatile] = ACTIONS(3740),
    [anon_sym_where] = ACTIONS(3740),
    [anon_sym_notnull] = ACTIONS(3740),
    [anon_sym_unmanaged] = ACTIONS(3740),
    [anon_sym_checked] = ACTIONS(3740),
    [anon_sym_BANG] = ACTIONS(3742),
    [anon_sym_TILDE] = ACTIONS(3742),
    [anon_sym_PLUS_PLUS] = ACTIONS(3742),
    [anon_sym_DASH_DASH] = ACTIONS(3742),
    [anon_sym_true] = ACTIONS(3740),
    [anon_sym_false] = ACTIONS(3740),
    [anon_sym_PLUS] = ACTIONS(3740),
    [anon_sym_DASH] = ACTIONS(3740),
    [anon_sym_STAR] = ACTIONS(3742),
    [anon_sym_CARET] = ACTIONS(3742),
    [anon_sym_AMP] = ACTIONS(3742),
    [anon_sym_this] = ACTIONS(3740),
    [anon_sym_scoped] = ACTIONS(3740),
    [anon_sym_var] = ACTIONS(3740),
    [sym_predefined_type] = ACTIONS(3740),
    [anon_sym_break] = ACTIONS(3740),
    [anon_sym_unchecked] = ACTIONS(3740),
    [anon_sym_continue] = ACTIONS(3740),
    [anon_sym_do] = ACTIONS(3740),
    [anon_sym_while] = ACTIONS(3740),
    [anon_sym_for] = ACTIONS(3740),
    [anon_sym_lock] = ACTIONS(3740),
    [anon_sym_yield] = ACTIONS(3740),
    [anon_sym_switch] = ACTIONS(3740),
    [anon_sym_default] = ACTIONS(3740),
    [anon_sym_throw] = ACTIONS(3740),
    [anon_sym_try] = ACTIONS(3740),
    [anon_sym_when] = ACTIONS(3740),
    [anon_sym_await] = ACTIONS(3740),
    [anon_sym_foreach] = ACTIONS(3740),
    [anon_sym_goto] = ACTIONS(3740),
    [anon_sym_if] = ACTIONS(3740),
    [anon_sym_DOT_DOT] = ACTIONS(3742),
    [anon_sym_from] = ACTIONS(3740),
    [anon_sym_into] = ACTIONS(3740),
    [anon_sym_join] = ACTIONS(3740),
    [anon_sym_on] = ACTIONS(3740),
    [anon_sym_equals] = ACTIONS(3740),
    [anon_sym_let] = ACTIONS(3740),
    [anon_sym_orderby] = ACTIONS(3740),
    [anon_sym_ascending] = ACTIONS(3740),
    [anon_sym_descending] = ACTIONS(3740),
    [anon_sym_group] = ACTIONS(3740),
    [anon_sym_by] = ACTIONS(3740),
    [anon_sym_select] = ACTIONS(3740),
    [anon_sym_DQUOTE] = ACTIONS(3740),
    [anon_sym_stackalloc] = ACTIONS(3740),
    [anon_sym_sizeof] = ACTIONS(3740),
    [anon_sym_typeof] = ACTIONS(3740),
    [anon_sym___makeref] = ACTIONS(3740),
    [anon_sym___reftype] = ACTIONS(3740),
    [anon_sym___refvalue] = ACTIONS(3740),
    [sym_null_literal] = ACTIONS(3740),
    [anon_sym_SQUOTE] = ACTIONS(3742),
    [sym_integer_literal] = ACTIONS(3740),
    [sym_real_literal] = ACTIONS(3742),
    [sym_verbatim_string_literal] = ACTIONS(3742),
    [sym_raw_string_literal] = ACTIONS(3742),
    [aux_sym_preproc_if_token1] = ACTIONS(3742),
    [aux_sym_preproc_if_token3] = ACTIONS(3742),
    [aux_sym_preproc_else_token1] = ACTIONS(3742),
    [aux_sym_preproc_elif_token1] = ACTIONS(3742),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3742),
    [sym_interpolation_verbatim_start] = ACTIONS(3742),
    [sym_interpolation_raw_start] = ACTIONS(3742),
  },
  [2375] = {
    [sym_preproc_region] = STATE(2375),
    [sym_preproc_endregion] = STATE(2375),
    [sym_preproc_line] = STATE(2375),
    [sym_preproc_pragma] = STATE(2375),
    [sym_preproc_nullable] = STATE(2375),
    [sym_preproc_error] = STATE(2375),
    [sym_preproc_define] = STATE(2375),
    [sym_preproc_undef] = STATE(2375),
    [sym__identifier_token] = ACTIONS(3744),
    [anon_sym_extern] = ACTIONS(3744),
    [anon_sym_alias] = ACTIONS(3744),
    [anon_sym_SEMI] = ACTIONS(3746),
    [anon_sym_global] = ACTIONS(3744),
    [anon_sym_using] = ACTIONS(3744),
    [anon_sym_unsafe] = ACTIONS(3744),
    [anon_sym_static] = ACTIONS(3744),
    [anon_sym_LBRACK] = ACTIONS(3746),
    [anon_sym_LPAREN] = ACTIONS(3746),
    [anon_sym_return] = ACTIONS(3744),
    [anon_sym_namespace] = ACTIONS(3744),
    [anon_sym_class] = ACTIONS(3744),
    [anon_sym_ref] = ACTIONS(3744),
    [anon_sym_struct] = ACTIONS(3744),
    [anon_sym_enum] = ACTIONS(3744),
    [anon_sym_LBRACE] = ACTIONS(3746),
    [anon_sym_interface] = ACTIONS(3744),
    [anon_sym_delegate] = ACTIONS(3744),
    [anon_sym_record] = ACTIONS(3744),
    [anon_sym_abstract] = ACTIONS(3744),
    [anon_sym_async] = ACTIONS(3744),
    [anon_sym_const] = ACTIONS(3744),
    [anon_sym_file] = ACTIONS(3744),
    [anon_sym_fixed] = ACTIONS(3744),
    [anon_sym_internal] = ACTIONS(3744),
    [anon_sym_new] = ACTIONS(3744),
    [anon_sym_override] = ACTIONS(3744),
    [anon_sym_partial] = ACTIONS(3744),
    [anon_sym_private] = ACTIONS(3744),
    [anon_sym_protected] = ACTIONS(3744),
    [anon_sym_public] = ACTIONS(3744),
    [anon_sym_readonly] = ACTIONS(3744),
    [anon_sym_required] = ACTIONS(3744),
    [anon_sym_sealed] = ACTIONS(3744),
    [anon_sym_virtual] = ACTIONS(3744),
    [anon_sym_volatile] = ACTIONS(3744),
    [anon_sym_where] = ACTIONS(3744),
    [anon_sym_notnull] = ACTIONS(3744),
    [anon_sym_unmanaged] = ACTIONS(3744),
    [anon_sym_checked] = ACTIONS(3744),
    [anon_sym_BANG] = ACTIONS(3746),
    [anon_sym_TILDE] = ACTIONS(3746),
    [anon_sym_PLUS_PLUS] = ACTIONS(3746),
    [anon_sym_DASH_DASH] = ACTIONS(3746),
    [anon_sym_true] = ACTIONS(3744),
    [anon_sym_false] = ACTIONS(3744),
    [anon_sym_PLUS] = ACTIONS(3744),
    [anon_sym_DASH] = ACTIONS(3744),
    [anon_sym_STAR] = ACTIONS(3746),
    [anon_sym_CARET] = ACTIONS(3746),
    [anon_sym_AMP] = ACTIONS(3746),
    [anon_sym_this] = ACTIONS(3744),
    [anon_sym_scoped] = ACTIONS(3744),
    [anon_sym_var] = ACTIONS(3744),
    [sym_predefined_type] = ACTIONS(3744),
    [anon_sym_break] = ACTIONS(3744),
    [anon_sym_unchecked] = ACTIONS(3744),
    [anon_sym_continue] = ACTIONS(3744),
    [anon_sym_do] = ACTIONS(3744),
    [anon_sym_while] = ACTIONS(3744),
    [anon_sym_for] = ACTIONS(3744),
    [anon_sym_lock] = ACTIONS(3744),
    [anon_sym_yield] = ACTIONS(3744),
    [anon_sym_switch] = ACTIONS(3744),
    [anon_sym_default] = ACTIONS(3744),
    [anon_sym_throw] = ACTIONS(3744),
    [anon_sym_try] = ACTIONS(3744),
    [anon_sym_when] = ACTIONS(3744),
    [anon_sym_await] = ACTIONS(3744),
    [anon_sym_foreach] = ACTIONS(3744),
    [anon_sym_goto] = ACTIONS(3744),
    [anon_sym_if] = ACTIONS(3744),
    [anon_sym_DOT_DOT] = ACTIONS(3746),
    [anon_sym_from] = ACTIONS(3744),
    [anon_sym_into] = ACTIONS(3744),
    [anon_sym_join] = ACTIONS(3744),
    [anon_sym_on] = ACTIONS(3744),
    [anon_sym_equals] = ACTIONS(3744),
    [anon_sym_let] = ACTIONS(3744),
    [anon_sym_orderby] = ACTIONS(3744),
    [anon_sym_ascending] = ACTIONS(3744),
    [anon_sym_descending] = ACTIONS(3744),
    [anon_sym_group] = ACTIONS(3744),
    [anon_sym_by] = ACTIONS(3744),
    [anon_sym_select] = ACTIONS(3744),
    [anon_sym_DQUOTE] = ACTIONS(3744),
    [anon_sym_stackalloc] = ACTIONS(3744),
    [anon_sym_sizeof] = ACTIONS(3744),
    [anon_sym_typeof] = ACTIONS(3744),
    [anon_sym___makeref] = ACTIONS(3744),
    [anon_sym___reftype] = ACTIONS(3744),
    [anon_sym___refvalue] = ACTIONS(3744),
    [sym_null_literal] = ACTIONS(3744),
    [anon_sym_SQUOTE] = ACTIONS(3746),
    [sym_integer_literal] = ACTIONS(3744),
    [sym_real_literal] = ACTIONS(3746),
    [sym_verbatim_string_literal] = ACTIONS(3746),
    [sym_raw_string_literal] = ACTIONS(3746),
    [aux_sym_preproc_if_token1] = ACTIONS(3746),
    [aux_sym_preproc_if_token3] = ACTIONS(3746),
    [aux_sym_preproc_else_token1] = ACTIONS(3746),
    [aux_sym_preproc_elif_token1] = ACTIONS(3746),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3746),
    [sym_interpolation_verbatim_start] = ACTIONS(3746),
    [sym_interpolation_raw_start] = ACTIONS(3746),
  },
  [2376] = {
    [sym_preproc_region] = STATE(2376),
    [sym_preproc_endregion] = STATE(2376),
    [sym_preproc_line] = STATE(2376),
    [sym_preproc_pragma] = STATE(2376),
    [sym_preproc_nullable] = STATE(2376),
    [sym_preproc_error] = STATE(2376),
    [sym_preproc_define] = STATE(2376),
    [sym_preproc_undef] = STATE(2376),
    [sym__identifier_token] = ACTIONS(3748),
    [anon_sym_extern] = ACTIONS(3748),
    [anon_sym_alias] = ACTIONS(3748),
    [anon_sym_SEMI] = ACTIONS(3750),
    [anon_sym_global] = ACTIONS(3748),
    [anon_sym_using] = ACTIONS(3748),
    [anon_sym_unsafe] = ACTIONS(3748),
    [anon_sym_static] = ACTIONS(3748),
    [anon_sym_LBRACK] = ACTIONS(3750),
    [anon_sym_LPAREN] = ACTIONS(3750),
    [anon_sym_return] = ACTIONS(3748),
    [anon_sym_namespace] = ACTIONS(3748),
    [anon_sym_class] = ACTIONS(3748),
    [anon_sym_ref] = ACTIONS(3748),
    [anon_sym_struct] = ACTIONS(3748),
    [anon_sym_enum] = ACTIONS(3748),
    [anon_sym_LBRACE] = ACTIONS(3750),
    [anon_sym_interface] = ACTIONS(3748),
    [anon_sym_delegate] = ACTIONS(3748),
    [anon_sym_record] = ACTIONS(3748),
    [anon_sym_abstract] = ACTIONS(3748),
    [anon_sym_async] = ACTIONS(3748),
    [anon_sym_const] = ACTIONS(3748),
    [anon_sym_file] = ACTIONS(3748),
    [anon_sym_fixed] = ACTIONS(3748),
    [anon_sym_internal] = ACTIONS(3748),
    [anon_sym_new] = ACTIONS(3748),
    [anon_sym_override] = ACTIONS(3748),
    [anon_sym_partial] = ACTIONS(3748),
    [anon_sym_private] = ACTIONS(3748),
    [anon_sym_protected] = ACTIONS(3748),
    [anon_sym_public] = ACTIONS(3748),
    [anon_sym_readonly] = ACTIONS(3748),
    [anon_sym_required] = ACTIONS(3748),
    [anon_sym_sealed] = ACTIONS(3748),
    [anon_sym_virtual] = ACTIONS(3748),
    [anon_sym_volatile] = ACTIONS(3748),
    [anon_sym_where] = ACTIONS(3748),
    [anon_sym_notnull] = ACTIONS(3748),
    [anon_sym_unmanaged] = ACTIONS(3748),
    [anon_sym_checked] = ACTIONS(3748),
    [anon_sym_BANG] = ACTIONS(3750),
    [anon_sym_TILDE] = ACTIONS(3750),
    [anon_sym_PLUS_PLUS] = ACTIONS(3750),
    [anon_sym_DASH_DASH] = ACTIONS(3750),
    [anon_sym_true] = ACTIONS(3748),
    [anon_sym_false] = ACTIONS(3748),
    [anon_sym_PLUS] = ACTIONS(3748),
    [anon_sym_DASH] = ACTIONS(3748),
    [anon_sym_STAR] = ACTIONS(3750),
    [anon_sym_CARET] = ACTIONS(3750),
    [anon_sym_AMP] = ACTIONS(3750),
    [anon_sym_this] = ACTIONS(3748),
    [anon_sym_scoped] = ACTIONS(3748),
    [anon_sym_var] = ACTIONS(3748),
    [sym_predefined_type] = ACTIONS(3748),
    [anon_sym_break] = ACTIONS(3748),
    [anon_sym_unchecked] = ACTIONS(3748),
    [anon_sym_continue] = ACTIONS(3748),
    [anon_sym_do] = ACTIONS(3748),
    [anon_sym_while] = ACTIONS(3748),
    [anon_sym_for] = ACTIONS(3748),
    [anon_sym_lock] = ACTIONS(3748),
    [anon_sym_yield] = ACTIONS(3748),
    [anon_sym_switch] = ACTIONS(3748),
    [anon_sym_default] = ACTIONS(3748),
    [anon_sym_throw] = ACTIONS(3748),
    [anon_sym_try] = ACTIONS(3748),
    [anon_sym_when] = ACTIONS(3748),
    [anon_sym_await] = ACTIONS(3748),
    [anon_sym_foreach] = ACTIONS(3748),
    [anon_sym_goto] = ACTIONS(3748),
    [anon_sym_if] = ACTIONS(3748),
    [anon_sym_DOT_DOT] = ACTIONS(3750),
    [anon_sym_from] = ACTIONS(3748),
    [anon_sym_into] = ACTIONS(3748),
    [anon_sym_join] = ACTIONS(3748),
    [anon_sym_on] = ACTIONS(3748),
    [anon_sym_equals] = ACTIONS(3748),
    [anon_sym_let] = ACTIONS(3748),
    [anon_sym_orderby] = ACTIONS(3748),
    [anon_sym_ascending] = ACTIONS(3748),
    [anon_sym_descending] = ACTIONS(3748),
    [anon_sym_group] = ACTIONS(3748),
    [anon_sym_by] = ACTIONS(3748),
    [anon_sym_select] = ACTIONS(3748),
    [anon_sym_DQUOTE] = ACTIONS(3748),
    [anon_sym_stackalloc] = ACTIONS(3748),
    [anon_sym_sizeof] = ACTIONS(3748),
    [anon_sym_typeof] = ACTIONS(3748),
    [anon_sym___makeref] = ACTIONS(3748),
    [anon_sym___reftype] = ACTIONS(3748),
    [anon_sym___refvalue] = ACTIONS(3748),
    [sym_null_literal] = ACTIONS(3748),
    [anon_sym_SQUOTE] = ACTIONS(3750),
    [sym_integer_literal] = ACTIONS(3748),
    [sym_real_literal] = ACTIONS(3750),
    [sym_verbatim_string_literal] = ACTIONS(3750),
    [sym_raw_string_literal] = ACTIONS(3750),
    [aux_sym_preproc_if_token1] = ACTIONS(3750),
    [aux_sym_preproc_if_token3] = ACTIONS(3750),
    [aux_sym_preproc_else_token1] = ACTIONS(3750),
    [aux_sym_preproc_elif_token1] = ACTIONS(3750),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3750),
    [sym_interpolation_verbatim_start] = ACTIONS(3750),
    [sym_interpolation_raw_start] = ACTIONS(3750),
  },
  [2377] = {
    [sym_preproc_region] = STATE(2377),
    [sym_preproc_endregion] = STATE(2377),
    [sym_preproc_line] = STATE(2377),
    [sym_preproc_pragma] = STATE(2377),
    [sym_preproc_nullable] = STATE(2377),
    [sym_preproc_error] = STATE(2377),
    [sym_preproc_define] = STATE(2377),
    [sym_preproc_undef] = STATE(2377),
    [sym__identifier_token] = ACTIONS(3752),
    [anon_sym_extern] = ACTIONS(3752),
    [anon_sym_alias] = ACTIONS(3752),
    [anon_sym_SEMI] = ACTIONS(3754),
    [anon_sym_global] = ACTIONS(3752),
    [anon_sym_using] = ACTIONS(3752),
    [anon_sym_unsafe] = ACTIONS(3752),
    [anon_sym_static] = ACTIONS(3752),
    [anon_sym_LBRACK] = ACTIONS(3754),
    [anon_sym_LPAREN] = ACTIONS(3754),
    [anon_sym_return] = ACTIONS(3752),
    [anon_sym_namespace] = ACTIONS(3752),
    [anon_sym_class] = ACTIONS(3752),
    [anon_sym_ref] = ACTIONS(3752),
    [anon_sym_struct] = ACTIONS(3752),
    [anon_sym_enum] = ACTIONS(3752),
    [anon_sym_LBRACE] = ACTIONS(3754),
    [anon_sym_interface] = ACTIONS(3752),
    [anon_sym_delegate] = ACTIONS(3752),
    [anon_sym_record] = ACTIONS(3752),
    [anon_sym_abstract] = ACTIONS(3752),
    [anon_sym_async] = ACTIONS(3752),
    [anon_sym_const] = ACTIONS(3752),
    [anon_sym_file] = ACTIONS(3752),
    [anon_sym_fixed] = ACTIONS(3752),
    [anon_sym_internal] = ACTIONS(3752),
    [anon_sym_new] = ACTIONS(3752),
    [anon_sym_override] = ACTIONS(3752),
    [anon_sym_partial] = ACTIONS(3752),
    [anon_sym_private] = ACTIONS(3752),
    [anon_sym_protected] = ACTIONS(3752),
    [anon_sym_public] = ACTIONS(3752),
    [anon_sym_readonly] = ACTIONS(3752),
    [anon_sym_required] = ACTIONS(3752),
    [anon_sym_sealed] = ACTIONS(3752),
    [anon_sym_virtual] = ACTIONS(3752),
    [anon_sym_volatile] = ACTIONS(3752),
    [anon_sym_where] = ACTIONS(3752),
    [anon_sym_notnull] = ACTIONS(3752),
    [anon_sym_unmanaged] = ACTIONS(3752),
    [anon_sym_checked] = ACTIONS(3752),
    [anon_sym_BANG] = ACTIONS(3754),
    [anon_sym_TILDE] = ACTIONS(3754),
    [anon_sym_PLUS_PLUS] = ACTIONS(3754),
    [anon_sym_DASH_DASH] = ACTIONS(3754),
    [anon_sym_true] = ACTIONS(3752),
    [anon_sym_false] = ACTIONS(3752),
    [anon_sym_PLUS] = ACTIONS(3752),
    [anon_sym_DASH] = ACTIONS(3752),
    [anon_sym_STAR] = ACTIONS(3754),
    [anon_sym_CARET] = ACTIONS(3754),
    [anon_sym_AMP] = ACTIONS(3754),
    [anon_sym_this] = ACTIONS(3752),
    [anon_sym_scoped] = ACTIONS(3752),
    [anon_sym_var] = ACTIONS(3752),
    [sym_predefined_type] = ACTIONS(3752),
    [anon_sym_break] = ACTIONS(3752),
    [anon_sym_unchecked] = ACTIONS(3752),
    [anon_sym_continue] = ACTIONS(3752),
    [anon_sym_do] = ACTIONS(3752),
    [anon_sym_while] = ACTIONS(3752),
    [anon_sym_for] = ACTIONS(3752),
    [anon_sym_lock] = ACTIONS(3752),
    [anon_sym_yield] = ACTIONS(3752),
    [anon_sym_switch] = ACTIONS(3752),
    [anon_sym_default] = ACTIONS(3752),
    [anon_sym_throw] = ACTIONS(3752),
    [anon_sym_try] = ACTIONS(3752),
    [anon_sym_when] = ACTIONS(3752),
    [anon_sym_await] = ACTIONS(3752),
    [anon_sym_foreach] = ACTIONS(3752),
    [anon_sym_goto] = ACTIONS(3752),
    [anon_sym_if] = ACTIONS(3752),
    [anon_sym_DOT_DOT] = ACTIONS(3754),
    [anon_sym_from] = ACTIONS(3752),
    [anon_sym_into] = ACTIONS(3752),
    [anon_sym_join] = ACTIONS(3752),
    [anon_sym_on] = ACTIONS(3752),
    [anon_sym_equals] = ACTIONS(3752),
    [anon_sym_let] = ACTIONS(3752),
    [anon_sym_orderby] = ACTIONS(3752),
    [anon_sym_ascending] = ACTIONS(3752),
    [anon_sym_descending] = ACTIONS(3752),
    [anon_sym_group] = ACTIONS(3752),
    [anon_sym_by] = ACTIONS(3752),
    [anon_sym_select] = ACTIONS(3752),
    [anon_sym_DQUOTE] = ACTIONS(3752),
    [anon_sym_stackalloc] = ACTIONS(3752),
    [anon_sym_sizeof] = ACTIONS(3752),
    [anon_sym_typeof] = ACTIONS(3752),
    [anon_sym___makeref] = ACTIONS(3752),
    [anon_sym___reftype] = ACTIONS(3752),
    [anon_sym___refvalue] = ACTIONS(3752),
    [sym_null_literal] = ACTIONS(3752),
    [anon_sym_SQUOTE] = ACTIONS(3754),
    [sym_integer_literal] = ACTIONS(3752),
    [sym_real_literal] = ACTIONS(3754),
    [sym_verbatim_string_literal] = ACTIONS(3754),
    [sym_raw_string_literal] = ACTIONS(3754),
    [aux_sym_preproc_if_token1] = ACTIONS(3754),
    [aux_sym_preproc_if_token3] = ACTIONS(3754),
    [aux_sym_preproc_else_token1] = ACTIONS(3754),
    [aux_sym_preproc_elif_token1] = ACTIONS(3754),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3754),
    [sym_interpolation_verbatim_start] = ACTIONS(3754),
    [sym_interpolation_raw_start] = ACTIONS(3754),
  },
  [2378] = {
    [sym_preproc_region] = STATE(2378),
    [sym_preproc_endregion] = STATE(2378),
    [sym_preproc_line] = STATE(2378),
    [sym_preproc_pragma] = STATE(2378),
    [sym_preproc_nullable] = STATE(2378),
    [sym_preproc_error] = STATE(2378),
    [sym_preproc_define] = STATE(2378),
    [sym_preproc_undef] = STATE(2378),
    [sym__identifier_token] = ACTIONS(3756),
    [anon_sym_extern] = ACTIONS(3756),
    [anon_sym_alias] = ACTIONS(3756),
    [anon_sym_SEMI] = ACTIONS(3758),
    [anon_sym_global] = ACTIONS(3756),
    [anon_sym_using] = ACTIONS(3756),
    [anon_sym_unsafe] = ACTIONS(3756),
    [anon_sym_static] = ACTIONS(3756),
    [anon_sym_LBRACK] = ACTIONS(3758),
    [anon_sym_LPAREN] = ACTIONS(3758),
    [anon_sym_return] = ACTIONS(3756),
    [anon_sym_namespace] = ACTIONS(3756),
    [anon_sym_class] = ACTIONS(3756),
    [anon_sym_ref] = ACTIONS(3756),
    [anon_sym_struct] = ACTIONS(3756),
    [anon_sym_enum] = ACTIONS(3756),
    [anon_sym_LBRACE] = ACTIONS(3758),
    [anon_sym_interface] = ACTIONS(3756),
    [anon_sym_delegate] = ACTIONS(3756),
    [anon_sym_record] = ACTIONS(3756),
    [anon_sym_abstract] = ACTIONS(3756),
    [anon_sym_async] = ACTIONS(3756),
    [anon_sym_const] = ACTIONS(3756),
    [anon_sym_file] = ACTIONS(3756),
    [anon_sym_fixed] = ACTIONS(3756),
    [anon_sym_internal] = ACTIONS(3756),
    [anon_sym_new] = ACTIONS(3756),
    [anon_sym_override] = ACTIONS(3756),
    [anon_sym_partial] = ACTIONS(3756),
    [anon_sym_private] = ACTIONS(3756),
    [anon_sym_protected] = ACTIONS(3756),
    [anon_sym_public] = ACTIONS(3756),
    [anon_sym_readonly] = ACTIONS(3756),
    [anon_sym_required] = ACTIONS(3756),
    [anon_sym_sealed] = ACTIONS(3756),
    [anon_sym_virtual] = ACTIONS(3756),
    [anon_sym_volatile] = ACTIONS(3756),
    [anon_sym_where] = ACTIONS(3756),
    [anon_sym_notnull] = ACTIONS(3756),
    [anon_sym_unmanaged] = ACTIONS(3756),
    [anon_sym_checked] = ACTIONS(3756),
    [anon_sym_BANG] = ACTIONS(3758),
    [anon_sym_TILDE] = ACTIONS(3758),
    [anon_sym_PLUS_PLUS] = ACTIONS(3758),
    [anon_sym_DASH_DASH] = ACTIONS(3758),
    [anon_sym_true] = ACTIONS(3756),
    [anon_sym_false] = ACTIONS(3756),
    [anon_sym_PLUS] = ACTIONS(3756),
    [anon_sym_DASH] = ACTIONS(3756),
    [anon_sym_STAR] = ACTIONS(3758),
    [anon_sym_CARET] = ACTIONS(3758),
    [anon_sym_AMP] = ACTIONS(3758),
    [anon_sym_this] = ACTIONS(3756),
    [anon_sym_scoped] = ACTIONS(3756),
    [anon_sym_var] = ACTIONS(3756),
    [sym_predefined_type] = ACTIONS(3756),
    [anon_sym_break] = ACTIONS(3756),
    [anon_sym_unchecked] = ACTIONS(3756),
    [anon_sym_continue] = ACTIONS(3756),
    [anon_sym_do] = ACTIONS(3756),
    [anon_sym_while] = ACTIONS(3756),
    [anon_sym_for] = ACTIONS(3756),
    [anon_sym_lock] = ACTIONS(3756),
    [anon_sym_yield] = ACTIONS(3756),
    [anon_sym_switch] = ACTIONS(3756),
    [anon_sym_default] = ACTIONS(3756),
    [anon_sym_throw] = ACTIONS(3756),
    [anon_sym_try] = ACTIONS(3756),
    [anon_sym_when] = ACTIONS(3756),
    [anon_sym_await] = ACTIONS(3756),
    [anon_sym_foreach] = ACTIONS(3756),
    [anon_sym_goto] = ACTIONS(3756),
    [anon_sym_if] = ACTIONS(3756),
    [anon_sym_DOT_DOT] = ACTIONS(3758),
    [anon_sym_from] = ACTIONS(3756),
    [anon_sym_into] = ACTIONS(3756),
    [anon_sym_join] = ACTIONS(3756),
    [anon_sym_on] = ACTIONS(3756),
    [anon_sym_equals] = ACTIONS(3756),
    [anon_sym_let] = ACTIONS(3756),
    [anon_sym_orderby] = ACTIONS(3756),
    [anon_sym_ascending] = ACTIONS(3756),
    [anon_sym_descending] = ACTIONS(3756),
    [anon_sym_group] = ACTIONS(3756),
    [anon_sym_by] = ACTIONS(3756),
    [anon_sym_select] = ACTIONS(3756),
    [anon_sym_DQUOTE] = ACTIONS(3756),
    [anon_sym_stackalloc] = ACTIONS(3756),
    [anon_sym_sizeof] = ACTIONS(3756),
    [anon_sym_typeof] = ACTIONS(3756),
    [anon_sym___makeref] = ACTIONS(3756),
    [anon_sym___reftype] = ACTIONS(3756),
    [anon_sym___refvalue] = ACTIONS(3756),
    [sym_null_literal] = ACTIONS(3756),
    [anon_sym_SQUOTE] = ACTIONS(3758),
    [sym_integer_literal] = ACTIONS(3756),
    [sym_real_literal] = ACTIONS(3758),
    [sym_verbatim_string_literal] = ACTIONS(3758),
    [sym_raw_string_literal] = ACTIONS(3758),
    [aux_sym_preproc_if_token1] = ACTIONS(3758),
    [aux_sym_preproc_if_token3] = ACTIONS(3758),
    [aux_sym_preproc_else_token1] = ACTIONS(3758),
    [aux_sym_preproc_elif_token1] = ACTIONS(3758),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3758),
    [sym_interpolation_verbatim_start] = ACTIONS(3758),
    [sym_interpolation_raw_start] = ACTIONS(3758),
  },
  [2379] = {
    [sym_preproc_region] = STATE(2379),
    [sym_preproc_endregion] = STATE(2379),
    [sym_preproc_line] = STATE(2379),
    [sym_preproc_pragma] = STATE(2379),
    [sym_preproc_nullable] = STATE(2379),
    [sym_preproc_error] = STATE(2379),
    [sym_preproc_define] = STATE(2379),
    [sym_preproc_undef] = STATE(2379),
    [sym__identifier_token] = ACTIONS(3760),
    [anon_sym_extern] = ACTIONS(3760),
    [anon_sym_alias] = ACTIONS(3760),
    [anon_sym_SEMI] = ACTIONS(3762),
    [anon_sym_global] = ACTIONS(3760),
    [anon_sym_using] = ACTIONS(3760),
    [anon_sym_unsafe] = ACTIONS(3760),
    [anon_sym_static] = ACTIONS(3760),
    [anon_sym_LBRACK] = ACTIONS(3762),
    [anon_sym_LPAREN] = ACTIONS(3762),
    [anon_sym_return] = ACTIONS(3760),
    [anon_sym_namespace] = ACTIONS(3760),
    [anon_sym_class] = ACTIONS(3760),
    [anon_sym_ref] = ACTIONS(3760),
    [anon_sym_struct] = ACTIONS(3760),
    [anon_sym_enum] = ACTIONS(3760),
    [anon_sym_LBRACE] = ACTIONS(3762),
    [anon_sym_interface] = ACTIONS(3760),
    [anon_sym_delegate] = ACTIONS(3760),
    [anon_sym_record] = ACTIONS(3760),
    [anon_sym_abstract] = ACTIONS(3760),
    [anon_sym_async] = ACTIONS(3760),
    [anon_sym_const] = ACTIONS(3760),
    [anon_sym_file] = ACTIONS(3760),
    [anon_sym_fixed] = ACTIONS(3760),
    [anon_sym_internal] = ACTIONS(3760),
    [anon_sym_new] = ACTIONS(3760),
    [anon_sym_override] = ACTIONS(3760),
    [anon_sym_partial] = ACTIONS(3760),
    [anon_sym_private] = ACTIONS(3760),
    [anon_sym_protected] = ACTIONS(3760),
    [anon_sym_public] = ACTIONS(3760),
    [anon_sym_readonly] = ACTIONS(3760),
    [anon_sym_required] = ACTIONS(3760),
    [anon_sym_sealed] = ACTIONS(3760),
    [anon_sym_virtual] = ACTIONS(3760),
    [anon_sym_volatile] = ACTIONS(3760),
    [anon_sym_where] = ACTIONS(3760),
    [anon_sym_notnull] = ACTIONS(3760),
    [anon_sym_unmanaged] = ACTIONS(3760),
    [anon_sym_checked] = ACTIONS(3760),
    [anon_sym_BANG] = ACTIONS(3762),
    [anon_sym_TILDE] = ACTIONS(3762),
    [anon_sym_PLUS_PLUS] = ACTIONS(3762),
    [anon_sym_DASH_DASH] = ACTIONS(3762),
    [anon_sym_true] = ACTIONS(3760),
    [anon_sym_false] = ACTIONS(3760),
    [anon_sym_PLUS] = ACTIONS(3760),
    [anon_sym_DASH] = ACTIONS(3760),
    [anon_sym_STAR] = ACTIONS(3762),
    [anon_sym_CARET] = ACTIONS(3762),
    [anon_sym_AMP] = ACTIONS(3762),
    [anon_sym_this] = ACTIONS(3760),
    [anon_sym_scoped] = ACTIONS(3760),
    [anon_sym_var] = ACTIONS(3760),
    [sym_predefined_type] = ACTIONS(3760),
    [anon_sym_break] = ACTIONS(3760),
    [anon_sym_unchecked] = ACTIONS(3760),
    [anon_sym_continue] = ACTIONS(3760),
    [anon_sym_do] = ACTIONS(3760),
    [anon_sym_while] = ACTIONS(3760),
    [anon_sym_for] = ACTIONS(3760),
    [anon_sym_lock] = ACTIONS(3760),
    [anon_sym_yield] = ACTIONS(3760),
    [anon_sym_switch] = ACTIONS(3760),
    [anon_sym_default] = ACTIONS(3760),
    [anon_sym_throw] = ACTIONS(3760),
    [anon_sym_try] = ACTIONS(3760),
    [anon_sym_when] = ACTIONS(3760),
    [anon_sym_await] = ACTIONS(3760),
    [anon_sym_foreach] = ACTIONS(3760),
    [anon_sym_goto] = ACTIONS(3760),
    [anon_sym_if] = ACTIONS(3760),
    [anon_sym_DOT_DOT] = ACTIONS(3762),
    [anon_sym_from] = ACTIONS(3760),
    [anon_sym_into] = ACTIONS(3760),
    [anon_sym_join] = ACTIONS(3760),
    [anon_sym_on] = ACTIONS(3760),
    [anon_sym_equals] = ACTIONS(3760),
    [anon_sym_let] = ACTIONS(3760),
    [anon_sym_orderby] = ACTIONS(3760),
    [anon_sym_ascending] = ACTIONS(3760),
    [anon_sym_descending] = ACTIONS(3760),
    [anon_sym_group] = ACTIONS(3760),
    [anon_sym_by] = ACTIONS(3760),
    [anon_sym_select] = ACTIONS(3760),
    [anon_sym_DQUOTE] = ACTIONS(3760),
    [anon_sym_stackalloc] = ACTIONS(3760),
    [anon_sym_sizeof] = ACTIONS(3760),
    [anon_sym_typeof] = ACTIONS(3760),
    [anon_sym___makeref] = ACTIONS(3760),
    [anon_sym___reftype] = ACTIONS(3760),
    [anon_sym___refvalue] = ACTIONS(3760),
    [sym_null_literal] = ACTIONS(3760),
    [anon_sym_SQUOTE] = ACTIONS(3762),
    [sym_integer_literal] = ACTIONS(3760),
    [sym_real_literal] = ACTIONS(3762),
    [sym_verbatim_string_literal] = ACTIONS(3762),
    [sym_raw_string_literal] = ACTIONS(3762),
    [aux_sym_preproc_if_token1] = ACTIONS(3762),
    [aux_sym_preproc_if_token3] = ACTIONS(3762),
    [aux_sym_preproc_else_token1] = ACTIONS(3762),
    [aux_sym_preproc_elif_token1] = ACTIONS(3762),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3762),
    [sym_interpolation_verbatim_start] = ACTIONS(3762),
    [sym_interpolation_raw_start] = ACTIONS(3762),
  },
  [2380] = {
    [sym_preproc_region] = STATE(2380),
    [sym_preproc_endregion] = STATE(2380),
    [sym_preproc_line] = STATE(2380),
    [sym_preproc_pragma] = STATE(2380),
    [sym_preproc_nullable] = STATE(2380),
    [sym_preproc_error] = STATE(2380),
    [sym_preproc_define] = STATE(2380),
    [sym_preproc_undef] = STATE(2380),
    [sym__identifier_token] = ACTIONS(3764),
    [anon_sym_extern] = ACTIONS(3764),
    [anon_sym_alias] = ACTIONS(3764),
    [anon_sym_SEMI] = ACTIONS(3766),
    [anon_sym_global] = ACTIONS(3764),
    [anon_sym_using] = ACTIONS(3764),
    [anon_sym_unsafe] = ACTIONS(3764),
    [anon_sym_static] = ACTIONS(3764),
    [anon_sym_LBRACK] = ACTIONS(3766),
    [anon_sym_LPAREN] = ACTIONS(3766),
    [anon_sym_return] = ACTIONS(3764),
    [anon_sym_namespace] = ACTIONS(3764),
    [anon_sym_class] = ACTIONS(3764),
    [anon_sym_ref] = ACTIONS(3764),
    [anon_sym_struct] = ACTIONS(3764),
    [anon_sym_enum] = ACTIONS(3764),
    [anon_sym_LBRACE] = ACTIONS(3766),
    [anon_sym_interface] = ACTIONS(3764),
    [anon_sym_delegate] = ACTIONS(3764),
    [anon_sym_record] = ACTIONS(3764),
    [anon_sym_abstract] = ACTIONS(3764),
    [anon_sym_async] = ACTIONS(3764),
    [anon_sym_const] = ACTIONS(3764),
    [anon_sym_file] = ACTIONS(3764),
    [anon_sym_fixed] = ACTIONS(3764),
    [anon_sym_internal] = ACTIONS(3764),
    [anon_sym_new] = ACTIONS(3764),
    [anon_sym_override] = ACTIONS(3764),
    [anon_sym_partial] = ACTIONS(3764),
    [anon_sym_private] = ACTIONS(3764),
    [anon_sym_protected] = ACTIONS(3764),
    [anon_sym_public] = ACTIONS(3764),
    [anon_sym_readonly] = ACTIONS(3764),
    [anon_sym_required] = ACTIONS(3764),
    [anon_sym_sealed] = ACTIONS(3764),
    [anon_sym_virtual] = ACTIONS(3764),
    [anon_sym_volatile] = ACTIONS(3764),
    [anon_sym_where] = ACTIONS(3764),
    [anon_sym_notnull] = ACTIONS(3764),
    [anon_sym_unmanaged] = ACTIONS(3764),
    [anon_sym_checked] = ACTIONS(3764),
    [anon_sym_BANG] = ACTIONS(3766),
    [anon_sym_TILDE] = ACTIONS(3766),
    [anon_sym_PLUS_PLUS] = ACTIONS(3766),
    [anon_sym_DASH_DASH] = ACTIONS(3766),
    [anon_sym_true] = ACTIONS(3764),
    [anon_sym_false] = ACTIONS(3764),
    [anon_sym_PLUS] = ACTIONS(3764),
    [anon_sym_DASH] = ACTIONS(3764),
    [anon_sym_STAR] = ACTIONS(3766),
    [anon_sym_CARET] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3766),
    [anon_sym_this] = ACTIONS(3764),
    [anon_sym_scoped] = ACTIONS(3764),
    [anon_sym_var] = ACTIONS(3764),
    [sym_predefined_type] = ACTIONS(3764),
    [anon_sym_break] = ACTIONS(3764),
    [anon_sym_unchecked] = ACTIONS(3764),
    [anon_sym_continue] = ACTIONS(3764),
    [anon_sym_do] = ACTIONS(3764),
    [anon_sym_while] = ACTIONS(3764),
    [anon_sym_for] = ACTIONS(3764),
    [anon_sym_lock] = ACTIONS(3764),
    [anon_sym_yield] = ACTIONS(3764),
    [anon_sym_switch] = ACTIONS(3764),
    [anon_sym_default] = ACTIONS(3764),
    [anon_sym_throw] = ACTIONS(3764),
    [anon_sym_try] = ACTIONS(3764),
    [anon_sym_when] = ACTIONS(3764),
    [anon_sym_await] = ACTIONS(3764),
    [anon_sym_foreach] = ACTIONS(3764),
    [anon_sym_goto] = ACTIONS(3764),
    [anon_sym_if] = ACTIONS(3764),
    [anon_sym_DOT_DOT] = ACTIONS(3766),
    [anon_sym_from] = ACTIONS(3764),
    [anon_sym_into] = ACTIONS(3764),
    [anon_sym_join] = ACTIONS(3764),
    [anon_sym_on] = ACTIONS(3764),
    [anon_sym_equals] = ACTIONS(3764),
    [anon_sym_let] = ACTIONS(3764),
    [anon_sym_orderby] = ACTIONS(3764),
    [anon_sym_ascending] = ACTIONS(3764),
    [anon_sym_descending] = ACTIONS(3764),
    [anon_sym_group] = ACTIONS(3764),
    [anon_sym_by] = ACTIONS(3764),
    [anon_sym_select] = ACTIONS(3764),
    [anon_sym_DQUOTE] = ACTIONS(3764),
    [anon_sym_stackalloc] = ACTIONS(3764),
    [anon_sym_sizeof] = ACTIONS(3764),
    [anon_sym_typeof] = ACTIONS(3764),
    [anon_sym___makeref] = ACTIONS(3764),
    [anon_sym___reftype] = ACTIONS(3764),
    [anon_sym___refvalue] = ACTIONS(3764),
    [sym_null_literal] = ACTIONS(3764),
    [anon_sym_SQUOTE] = ACTIONS(3766),
    [sym_integer_literal] = ACTIONS(3764),
    [sym_real_literal] = ACTIONS(3766),
    [sym_verbatim_string_literal] = ACTIONS(3766),
    [sym_raw_string_literal] = ACTIONS(3766),
    [aux_sym_preproc_if_token1] = ACTIONS(3766),
    [aux_sym_preproc_if_token3] = ACTIONS(3766),
    [aux_sym_preproc_else_token1] = ACTIONS(3766),
    [aux_sym_preproc_elif_token1] = ACTIONS(3766),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3766),
    [sym_interpolation_verbatim_start] = ACTIONS(3766),
    [sym_interpolation_raw_start] = ACTIONS(3766),
  },
  [2381] = {
    [sym_preproc_region] = STATE(2381),
    [sym_preproc_endregion] = STATE(2381),
    [sym_preproc_line] = STATE(2381),
    [sym_preproc_pragma] = STATE(2381),
    [sym_preproc_nullable] = STATE(2381),
    [sym_preproc_error] = STATE(2381),
    [sym_preproc_define] = STATE(2381),
    [sym_preproc_undef] = STATE(2381),
    [sym__identifier_token] = ACTIONS(3768),
    [anon_sym_extern] = ACTIONS(3768),
    [anon_sym_alias] = ACTIONS(3768),
    [anon_sym_SEMI] = ACTIONS(3770),
    [anon_sym_global] = ACTIONS(3768),
    [anon_sym_using] = ACTIONS(3768),
    [anon_sym_unsafe] = ACTIONS(3768),
    [anon_sym_static] = ACTIONS(3768),
    [anon_sym_LBRACK] = ACTIONS(3770),
    [anon_sym_LPAREN] = ACTIONS(3770),
    [anon_sym_return] = ACTIONS(3768),
    [anon_sym_namespace] = ACTIONS(3768),
    [anon_sym_class] = ACTIONS(3768),
    [anon_sym_ref] = ACTIONS(3768),
    [anon_sym_struct] = ACTIONS(3768),
    [anon_sym_enum] = ACTIONS(3768),
    [anon_sym_LBRACE] = ACTIONS(3770),
    [anon_sym_interface] = ACTIONS(3768),
    [anon_sym_delegate] = ACTIONS(3768),
    [anon_sym_record] = ACTIONS(3768),
    [anon_sym_abstract] = ACTIONS(3768),
    [anon_sym_async] = ACTIONS(3768),
    [anon_sym_const] = ACTIONS(3768),
    [anon_sym_file] = ACTIONS(3768),
    [anon_sym_fixed] = ACTIONS(3768),
    [anon_sym_internal] = ACTIONS(3768),
    [anon_sym_new] = ACTIONS(3768),
    [anon_sym_override] = ACTIONS(3768),
    [anon_sym_partial] = ACTIONS(3768),
    [anon_sym_private] = ACTIONS(3768),
    [anon_sym_protected] = ACTIONS(3768),
    [anon_sym_public] = ACTIONS(3768),
    [anon_sym_readonly] = ACTIONS(3768),
    [anon_sym_required] = ACTIONS(3768),
    [anon_sym_sealed] = ACTIONS(3768),
    [anon_sym_virtual] = ACTIONS(3768),
    [anon_sym_volatile] = ACTIONS(3768),
    [anon_sym_where] = ACTIONS(3768),
    [anon_sym_notnull] = ACTIONS(3768),
    [anon_sym_unmanaged] = ACTIONS(3768),
    [anon_sym_checked] = ACTIONS(3768),
    [anon_sym_BANG] = ACTIONS(3770),
    [anon_sym_TILDE] = ACTIONS(3770),
    [anon_sym_PLUS_PLUS] = ACTIONS(3770),
    [anon_sym_DASH_DASH] = ACTIONS(3770),
    [anon_sym_true] = ACTIONS(3768),
    [anon_sym_false] = ACTIONS(3768),
    [anon_sym_PLUS] = ACTIONS(3768),
    [anon_sym_DASH] = ACTIONS(3768),
    [anon_sym_STAR] = ACTIONS(3770),
    [anon_sym_CARET] = ACTIONS(3770),
    [anon_sym_AMP] = ACTIONS(3770),
    [anon_sym_this] = ACTIONS(3768),
    [anon_sym_scoped] = ACTIONS(3768),
    [anon_sym_var] = ACTIONS(3768),
    [sym_predefined_type] = ACTIONS(3768),
    [anon_sym_break] = ACTIONS(3768),
    [anon_sym_unchecked] = ACTIONS(3768),
    [anon_sym_continue] = ACTIONS(3768),
    [anon_sym_do] = ACTIONS(3768),
    [anon_sym_while] = ACTIONS(3768),
    [anon_sym_for] = ACTIONS(3768),
    [anon_sym_lock] = ACTIONS(3768),
    [anon_sym_yield] = ACTIONS(3768),
    [anon_sym_switch] = ACTIONS(3768),
    [anon_sym_default] = ACTIONS(3768),
    [anon_sym_throw] = ACTIONS(3768),
    [anon_sym_try] = ACTIONS(3768),
    [anon_sym_when] = ACTIONS(3768),
    [anon_sym_await] = ACTIONS(3768),
    [anon_sym_foreach] = ACTIONS(3768),
    [anon_sym_goto] = ACTIONS(3768),
    [anon_sym_if] = ACTIONS(3768),
    [anon_sym_DOT_DOT] = ACTIONS(3770),
    [anon_sym_from] = ACTIONS(3768),
    [anon_sym_into] = ACTIONS(3768),
    [anon_sym_join] = ACTIONS(3768),
    [anon_sym_on] = ACTIONS(3768),
    [anon_sym_equals] = ACTIONS(3768),
    [anon_sym_let] = ACTIONS(3768),
    [anon_sym_orderby] = ACTIONS(3768),
    [anon_sym_ascending] = ACTIONS(3768),
    [anon_sym_descending] = ACTIONS(3768),
    [anon_sym_group] = ACTIONS(3768),
    [anon_sym_by] = ACTIONS(3768),
    [anon_sym_select] = ACTIONS(3768),
    [anon_sym_DQUOTE] = ACTIONS(3768),
    [anon_sym_stackalloc] = ACTIONS(3768),
    [anon_sym_sizeof] = ACTIONS(3768),
    [anon_sym_typeof] = ACTIONS(3768),
    [anon_sym___makeref] = ACTIONS(3768),
    [anon_sym___reftype] = ACTIONS(3768),
    [anon_sym___refvalue] = ACTIONS(3768),
    [sym_null_literal] = ACTIONS(3768),
    [anon_sym_SQUOTE] = ACTIONS(3770),
    [sym_integer_literal] = ACTIONS(3768),
    [sym_real_literal] = ACTIONS(3770),
    [sym_verbatim_string_literal] = ACTIONS(3770),
    [sym_raw_string_literal] = ACTIONS(3770),
    [aux_sym_preproc_if_token1] = ACTIONS(3770),
    [aux_sym_preproc_if_token3] = ACTIONS(3770),
    [aux_sym_preproc_else_token1] = ACTIONS(3770),
    [aux_sym_preproc_elif_token1] = ACTIONS(3770),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3770),
    [sym_interpolation_verbatim_start] = ACTIONS(3770),
    [sym_interpolation_raw_start] = ACTIONS(3770),
  },
  [2382] = {
    [sym_preproc_region] = STATE(2382),
    [sym_preproc_endregion] = STATE(2382),
    [sym_preproc_line] = STATE(2382),
    [sym_preproc_pragma] = STATE(2382),
    [sym_preproc_nullable] = STATE(2382),
    [sym_preproc_error] = STATE(2382),
    [sym_preproc_define] = STATE(2382),
    [sym_preproc_undef] = STATE(2382),
    [sym__identifier_token] = ACTIONS(3772),
    [anon_sym_extern] = ACTIONS(3772),
    [anon_sym_alias] = ACTIONS(3772),
    [anon_sym_SEMI] = ACTIONS(3774),
    [anon_sym_global] = ACTIONS(3772),
    [anon_sym_using] = ACTIONS(3772),
    [anon_sym_unsafe] = ACTIONS(3772),
    [anon_sym_static] = ACTIONS(3772),
    [anon_sym_LBRACK] = ACTIONS(3774),
    [anon_sym_LPAREN] = ACTIONS(3774),
    [anon_sym_return] = ACTIONS(3772),
    [anon_sym_namespace] = ACTIONS(3772),
    [anon_sym_class] = ACTIONS(3772),
    [anon_sym_ref] = ACTIONS(3772),
    [anon_sym_struct] = ACTIONS(3772),
    [anon_sym_enum] = ACTIONS(3772),
    [anon_sym_LBRACE] = ACTIONS(3774),
    [anon_sym_interface] = ACTIONS(3772),
    [anon_sym_delegate] = ACTIONS(3772),
    [anon_sym_record] = ACTIONS(3772),
    [anon_sym_abstract] = ACTIONS(3772),
    [anon_sym_async] = ACTIONS(3772),
    [anon_sym_const] = ACTIONS(3772),
    [anon_sym_file] = ACTIONS(3772),
    [anon_sym_fixed] = ACTIONS(3772),
    [anon_sym_internal] = ACTIONS(3772),
    [anon_sym_new] = ACTIONS(3772),
    [anon_sym_override] = ACTIONS(3772),
    [anon_sym_partial] = ACTIONS(3772),
    [anon_sym_private] = ACTIONS(3772),
    [anon_sym_protected] = ACTIONS(3772),
    [anon_sym_public] = ACTIONS(3772),
    [anon_sym_readonly] = ACTIONS(3772),
    [anon_sym_required] = ACTIONS(3772),
    [anon_sym_sealed] = ACTIONS(3772),
    [anon_sym_virtual] = ACTIONS(3772),
    [anon_sym_volatile] = ACTIONS(3772),
    [anon_sym_where] = ACTIONS(3772),
    [anon_sym_notnull] = ACTIONS(3772),
    [anon_sym_unmanaged] = ACTIONS(3772),
    [anon_sym_checked] = ACTIONS(3772),
    [anon_sym_BANG] = ACTIONS(3774),
    [anon_sym_TILDE] = ACTIONS(3774),
    [anon_sym_PLUS_PLUS] = ACTIONS(3774),
    [anon_sym_DASH_DASH] = ACTIONS(3774),
    [anon_sym_true] = ACTIONS(3772),
    [anon_sym_false] = ACTIONS(3772),
    [anon_sym_PLUS] = ACTIONS(3772),
    [anon_sym_DASH] = ACTIONS(3772),
    [anon_sym_STAR] = ACTIONS(3774),
    [anon_sym_CARET] = ACTIONS(3774),
    [anon_sym_AMP] = ACTIONS(3774),
    [anon_sym_this] = ACTIONS(3772),
    [anon_sym_scoped] = ACTIONS(3772),
    [anon_sym_var] = ACTIONS(3772),
    [sym_predefined_type] = ACTIONS(3772),
    [anon_sym_break] = ACTIONS(3772),
    [anon_sym_unchecked] = ACTIONS(3772),
    [anon_sym_continue] = ACTIONS(3772),
    [anon_sym_do] = ACTIONS(3772),
    [anon_sym_while] = ACTIONS(3772),
    [anon_sym_for] = ACTIONS(3772),
    [anon_sym_lock] = ACTIONS(3772),
    [anon_sym_yield] = ACTIONS(3772),
    [anon_sym_switch] = ACTIONS(3772),
    [anon_sym_default] = ACTIONS(3772),
    [anon_sym_throw] = ACTIONS(3772),
    [anon_sym_try] = ACTIONS(3772),
    [anon_sym_when] = ACTIONS(3772),
    [anon_sym_await] = ACTIONS(3772),
    [anon_sym_foreach] = ACTIONS(3772),
    [anon_sym_goto] = ACTIONS(3772),
    [anon_sym_if] = ACTIONS(3772),
    [anon_sym_DOT_DOT] = ACTIONS(3774),
    [anon_sym_from] = ACTIONS(3772),
    [anon_sym_into] = ACTIONS(3772),
    [anon_sym_join] = ACTIONS(3772),
    [anon_sym_on] = ACTIONS(3772),
    [anon_sym_equals] = ACTIONS(3772),
    [anon_sym_let] = ACTIONS(3772),
    [anon_sym_orderby] = ACTIONS(3772),
    [anon_sym_ascending] = ACTIONS(3772),
    [anon_sym_descending] = ACTIONS(3772),
    [anon_sym_group] = ACTIONS(3772),
    [anon_sym_by] = ACTIONS(3772),
    [anon_sym_select] = ACTIONS(3772),
    [anon_sym_DQUOTE] = ACTIONS(3772),
    [anon_sym_stackalloc] = ACTIONS(3772),
    [anon_sym_sizeof] = ACTIONS(3772),
    [anon_sym_typeof] = ACTIONS(3772),
    [anon_sym___makeref] = ACTIONS(3772),
    [anon_sym___reftype] = ACTIONS(3772),
    [anon_sym___refvalue] = ACTIONS(3772),
    [sym_null_literal] = ACTIONS(3772),
    [anon_sym_SQUOTE] = ACTIONS(3774),
    [sym_integer_literal] = ACTIONS(3772),
    [sym_real_literal] = ACTIONS(3774),
    [sym_verbatim_string_literal] = ACTIONS(3774),
    [sym_raw_string_literal] = ACTIONS(3774),
    [aux_sym_preproc_if_token1] = ACTIONS(3774),
    [aux_sym_preproc_if_token3] = ACTIONS(3774),
    [aux_sym_preproc_else_token1] = ACTIONS(3774),
    [aux_sym_preproc_elif_token1] = ACTIONS(3774),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3774),
    [sym_interpolation_verbatim_start] = ACTIONS(3774),
    [sym_interpolation_raw_start] = ACTIONS(3774),
  },
  [2383] = {
    [sym_preproc_region] = STATE(2383),
    [sym_preproc_endregion] = STATE(2383),
    [sym_preproc_line] = STATE(2383),
    [sym_preproc_pragma] = STATE(2383),
    [sym_preproc_nullable] = STATE(2383),
    [sym_preproc_error] = STATE(2383),
    [sym_preproc_define] = STATE(2383),
    [sym_preproc_undef] = STATE(2383),
    [sym__identifier_token] = ACTIONS(3776),
    [anon_sym_extern] = ACTIONS(3776),
    [anon_sym_alias] = ACTIONS(3776),
    [anon_sym_SEMI] = ACTIONS(3778),
    [anon_sym_global] = ACTIONS(3776),
    [anon_sym_using] = ACTIONS(3776),
    [anon_sym_unsafe] = ACTIONS(3776),
    [anon_sym_static] = ACTIONS(3776),
    [anon_sym_LBRACK] = ACTIONS(3778),
    [anon_sym_LPAREN] = ACTIONS(3778),
    [anon_sym_return] = ACTIONS(3776),
    [anon_sym_namespace] = ACTIONS(3776),
    [anon_sym_class] = ACTIONS(3776),
    [anon_sym_ref] = ACTIONS(3776),
    [anon_sym_struct] = ACTIONS(3776),
    [anon_sym_enum] = ACTIONS(3776),
    [anon_sym_LBRACE] = ACTIONS(3778),
    [anon_sym_interface] = ACTIONS(3776),
    [anon_sym_delegate] = ACTIONS(3776),
    [anon_sym_record] = ACTIONS(3776),
    [anon_sym_abstract] = ACTIONS(3776),
    [anon_sym_async] = ACTIONS(3776),
    [anon_sym_const] = ACTIONS(3776),
    [anon_sym_file] = ACTIONS(3776),
    [anon_sym_fixed] = ACTIONS(3776),
    [anon_sym_internal] = ACTIONS(3776),
    [anon_sym_new] = ACTIONS(3776),
    [anon_sym_override] = ACTIONS(3776),
    [anon_sym_partial] = ACTIONS(3776),
    [anon_sym_private] = ACTIONS(3776),
    [anon_sym_protected] = ACTIONS(3776),
    [anon_sym_public] = ACTIONS(3776),
    [anon_sym_readonly] = ACTIONS(3776),
    [anon_sym_required] = ACTIONS(3776),
    [anon_sym_sealed] = ACTIONS(3776),
    [anon_sym_virtual] = ACTIONS(3776),
    [anon_sym_volatile] = ACTIONS(3776),
    [anon_sym_where] = ACTIONS(3776),
    [anon_sym_notnull] = ACTIONS(3776),
    [anon_sym_unmanaged] = ACTIONS(3776),
    [anon_sym_checked] = ACTIONS(3776),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_TILDE] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3778),
    [anon_sym_DASH_DASH] = ACTIONS(3778),
    [anon_sym_true] = ACTIONS(3776),
    [anon_sym_false] = ACTIONS(3776),
    [anon_sym_PLUS] = ACTIONS(3776),
    [anon_sym_DASH] = ACTIONS(3776),
    [anon_sym_STAR] = ACTIONS(3778),
    [anon_sym_CARET] = ACTIONS(3778),
    [anon_sym_AMP] = ACTIONS(3778),
    [anon_sym_this] = ACTIONS(3776),
    [anon_sym_scoped] = ACTIONS(3776),
    [anon_sym_var] = ACTIONS(3776),
    [sym_predefined_type] = ACTIONS(3776),
    [anon_sym_break] = ACTIONS(3776),
    [anon_sym_unchecked] = ACTIONS(3776),
    [anon_sym_continue] = ACTIONS(3776),
    [anon_sym_do] = ACTIONS(3776),
    [anon_sym_while] = ACTIONS(3776),
    [anon_sym_for] = ACTIONS(3776),
    [anon_sym_lock] = ACTIONS(3776),
    [anon_sym_yield] = ACTIONS(3776),
    [anon_sym_switch] = ACTIONS(3776),
    [anon_sym_default] = ACTIONS(3776),
    [anon_sym_throw] = ACTIONS(3776),
    [anon_sym_try] = ACTIONS(3776),
    [anon_sym_when] = ACTIONS(3776),
    [anon_sym_await] = ACTIONS(3776),
    [anon_sym_foreach] = ACTIONS(3776),
    [anon_sym_goto] = ACTIONS(3776),
    [anon_sym_if] = ACTIONS(3776),
    [anon_sym_DOT_DOT] = ACTIONS(3778),
    [anon_sym_from] = ACTIONS(3776),
    [anon_sym_into] = ACTIONS(3776),
    [anon_sym_join] = ACTIONS(3776),
    [anon_sym_on] = ACTIONS(3776),
    [anon_sym_equals] = ACTIONS(3776),
    [anon_sym_let] = ACTIONS(3776),
    [anon_sym_orderby] = ACTIONS(3776),
    [anon_sym_ascending] = ACTIONS(3776),
    [anon_sym_descending] = ACTIONS(3776),
    [anon_sym_group] = ACTIONS(3776),
    [anon_sym_by] = ACTIONS(3776),
    [anon_sym_select] = ACTIONS(3776),
    [anon_sym_DQUOTE] = ACTIONS(3776),
    [anon_sym_stackalloc] = ACTIONS(3776),
    [anon_sym_sizeof] = ACTIONS(3776),
    [anon_sym_typeof] = ACTIONS(3776),
    [anon_sym___makeref] = ACTIONS(3776),
    [anon_sym___reftype] = ACTIONS(3776),
    [anon_sym___refvalue] = ACTIONS(3776),
    [sym_null_literal] = ACTIONS(3776),
    [anon_sym_SQUOTE] = ACTIONS(3778),
    [sym_integer_literal] = ACTIONS(3776),
    [sym_real_literal] = ACTIONS(3778),
    [sym_verbatim_string_literal] = ACTIONS(3778),
    [sym_raw_string_literal] = ACTIONS(3778),
    [aux_sym_preproc_if_token1] = ACTIONS(3778),
    [aux_sym_preproc_if_token3] = ACTIONS(3778),
    [aux_sym_preproc_else_token1] = ACTIONS(3778),
    [aux_sym_preproc_elif_token1] = ACTIONS(3778),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3778),
    [sym_interpolation_verbatim_start] = ACTIONS(3778),
    [sym_interpolation_raw_start] = ACTIONS(3778),
  },
  [2384] = {
    [sym_preproc_region] = STATE(2384),
    [sym_preproc_endregion] = STATE(2384),
    [sym_preproc_line] = STATE(2384),
    [sym_preproc_pragma] = STATE(2384),
    [sym_preproc_nullable] = STATE(2384),
    [sym_preproc_error] = STATE(2384),
    [sym_preproc_define] = STATE(2384),
    [sym_preproc_undef] = STATE(2384),
    [sym__identifier_token] = ACTIONS(3780),
    [anon_sym_extern] = ACTIONS(3780),
    [anon_sym_alias] = ACTIONS(3780),
    [anon_sym_SEMI] = ACTIONS(3782),
    [anon_sym_global] = ACTIONS(3780),
    [anon_sym_using] = ACTIONS(3780),
    [anon_sym_unsafe] = ACTIONS(3780),
    [anon_sym_static] = ACTIONS(3780),
    [anon_sym_LBRACK] = ACTIONS(3782),
    [anon_sym_LPAREN] = ACTIONS(3782),
    [anon_sym_return] = ACTIONS(3780),
    [anon_sym_namespace] = ACTIONS(3780),
    [anon_sym_class] = ACTIONS(3780),
    [anon_sym_ref] = ACTIONS(3780),
    [anon_sym_struct] = ACTIONS(3780),
    [anon_sym_enum] = ACTIONS(3780),
    [anon_sym_LBRACE] = ACTIONS(3782),
    [anon_sym_interface] = ACTIONS(3780),
    [anon_sym_delegate] = ACTIONS(3780),
    [anon_sym_record] = ACTIONS(3780),
    [anon_sym_abstract] = ACTIONS(3780),
    [anon_sym_async] = ACTIONS(3780),
    [anon_sym_const] = ACTIONS(3780),
    [anon_sym_file] = ACTIONS(3780),
    [anon_sym_fixed] = ACTIONS(3780),
    [anon_sym_internal] = ACTIONS(3780),
    [anon_sym_new] = ACTIONS(3780),
    [anon_sym_override] = ACTIONS(3780),
    [anon_sym_partial] = ACTIONS(3780),
    [anon_sym_private] = ACTIONS(3780),
    [anon_sym_protected] = ACTIONS(3780),
    [anon_sym_public] = ACTIONS(3780),
    [anon_sym_readonly] = ACTIONS(3780),
    [anon_sym_required] = ACTIONS(3780),
    [anon_sym_sealed] = ACTIONS(3780),
    [anon_sym_virtual] = ACTIONS(3780),
    [anon_sym_volatile] = ACTIONS(3780),
    [anon_sym_where] = ACTIONS(3780),
    [anon_sym_notnull] = ACTIONS(3780),
    [anon_sym_unmanaged] = ACTIONS(3780),
    [anon_sym_checked] = ACTIONS(3780),
    [anon_sym_BANG] = ACTIONS(3782),
    [anon_sym_TILDE] = ACTIONS(3782),
    [anon_sym_PLUS_PLUS] = ACTIONS(3782),
    [anon_sym_DASH_DASH] = ACTIONS(3782),
    [anon_sym_true] = ACTIONS(3780),
    [anon_sym_false] = ACTIONS(3780),
    [anon_sym_PLUS] = ACTIONS(3780),
    [anon_sym_DASH] = ACTIONS(3780),
    [anon_sym_STAR] = ACTIONS(3782),
    [anon_sym_CARET] = ACTIONS(3782),
    [anon_sym_AMP] = ACTIONS(3782),
    [anon_sym_this] = ACTIONS(3780),
    [anon_sym_scoped] = ACTIONS(3780),
    [anon_sym_var] = ACTIONS(3780),
    [sym_predefined_type] = ACTIONS(3780),
    [anon_sym_break] = ACTIONS(3780),
    [anon_sym_unchecked] = ACTIONS(3780),
    [anon_sym_continue] = ACTIONS(3780),
    [anon_sym_do] = ACTIONS(3780),
    [anon_sym_while] = ACTIONS(3780),
    [anon_sym_for] = ACTIONS(3780),
    [anon_sym_lock] = ACTIONS(3780),
    [anon_sym_yield] = ACTIONS(3780),
    [anon_sym_switch] = ACTIONS(3780),
    [anon_sym_default] = ACTIONS(3780),
    [anon_sym_throw] = ACTIONS(3780),
    [anon_sym_try] = ACTIONS(3780),
    [anon_sym_when] = ACTIONS(3780),
    [anon_sym_await] = ACTIONS(3780),
    [anon_sym_foreach] = ACTIONS(3780),
    [anon_sym_goto] = ACTIONS(3780),
    [anon_sym_if] = ACTIONS(3780),
    [anon_sym_DOT_DOT] = ACTIONS(3782),
    [anon_sym_from] = ACTIONS(3780),
    [anon_sym_into] = ACTIONS(3780),
    [anon_sym_join] = ACTIONS(3780),
    [anon_sym_on] = ACTIONS(3780),
    [anon_sym_equals] = ACTIONS(3780),
    [anon_sym_let] = ACTIONS(3780),
    [anon_sym_orderby] = ACTIONS(3780),
    [anon_sym_ascending] = ACTIONS(3780),
    [anon_sym_descending] = ACTIONS(3780),
    [anon_sym_group] = ACTIONS(3780),
    [anon_sym_by] = ACTIONS(3780),
    [anon_sym_select] = ACTIONS(3780),
    [anon_sym_DQUOTE] = ACTIONS(3780),
    [anon_sym_stackalloc] = ACTIONS(3780),
    [anon_sym_sizeof] = ACTIONS(3780),
    [anon_sym_typeof] = ACTIONS(3780),
    [anon_sym___makeref] = ACTIONS(3780),
    [anon_sym___reftype] = ACTIONS(3780),
    [anon_sym___refvalue] = ACTIONS(3780),
    [sym_null_literal] = ACTIONS(3780),
    [anon_sym_SQUOTE] = ACTIONS(3782),
    [sym_integer_literal] = ACTIONS(3780),
    [sym_real_literal] = ACTIONS(3782),
    [sym_verbatim_string_literal] = ACTIONS(3782),
    [sym_raw_string_literal] = ACTIONS(3782),
    [aux_sym_preproc_if_token1] = ACTIONS(3782),
    [aux_sym_preproc_if_token3] = ACTIONS(3782),
    [aux_sym_preproc_else_token1] = ACTIONS(3782),
    [aux_sym_preproc_elif_token1] = ACTIONS(3782),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3782),
    [sym_interpolation_verbatim_start] = ACTIONS(3782),
    [sym_interpolation_raw_start] = ACTIONS(3782),
  },
  [2385] = {
    [sym_preproc_region] = STATE(2385),
    [sym_preproc_endregion] = STATE(2385),
    [sym_preproc_line] = STATE(2385),
    [sym_preproc_pragma] = STATE(2385),
    [sym_preproc_nullable] = STATE(2385),
    [sym_preproc_error] = STATE(2385),
    [sym_preproc_define] = STATE(2385),
    [sym_preproc_undef] = STATE(2385),
    [sym__identifier_token] = ACTIONS(3784),
    [anon_sym_extern] = ACTIONS(3784),
    [anon_sym_alias] = ACTIONS(3784),
    [anon_sym_SEMI] = ACTIONS(3786),
    [anon_sym_global] = ACTIONS(3784),
    [anon_sym_using] = ACTIONS(3784),
    [anon_sym_unsafe] = ACTIONS(3784),
    [anon_sym_static] = ACTIONS(3784),
    [anon_sym_LBRACK] = ACTIONS(3786),
    [anon_sym_LPAREN] = ACTIONS(3786),
    [anon_sym_return] = ACTIONS(3784),
    [anon_sym_namespace] = ACTIONS(3784),
    [anon_sym_class] = ACTIONS(3784),
    [anon_sym_ref] = ACTIONS(3784),
    [anon_sym_struct] = ACTIONS(3784),
    [anon_sym_enum] = ACTIONS(3784),
    [anon_sym_LBRACE] = ACTIONS(3786),
    [anon_sym_interface] = ACTIONS(3784),
    [anon_sym_delegate] = ACTIONS(3784),
    [anon_sym_record] = ACTIONS(3784),
    [anon_sym_abstract] = ACTIONS(3784),
    [anon_sym_async] = ACTIONS(3784),
    [anon_sym_const] = ACTIONS(3784),
    [anon_sym_file] = ACTIONS(3784),
    [anon_sym_fixed] = ACTIONS(3784),
    [anon_sym_internal] = ACTIONS(3784),
    [anon_sym_new] = ACTIONS(3784),
    [anon_sym_override] = ACTIONS(3784),
    [anon_sym_partial] = ACTIONS(3784),
    [anon_sym_private] = ACTIONS(3784),
    [anon_sym_protected] = ACTIONS(3784),
    [anon_sym_public] = ACTIONS(3784),
    [anon_sym_readonly] = ACTIONS(3784),
    [anon_sym_required] = ACTIONS(3784),
    [anon_sym_sealed] = ACTIONS(3784),
    [anon_sym_virtual] = ACTIONS(3784),
    [anon_sym_volatile] = ACTIONS(3784),
    [anon_sym_where] = ACTIONS(3784),
    [anon_sym_notnull] = ACTIONS(3784),
    [anon_sym_unmanaged] = ACTIONS(3784),
    [anon_sym_checked] = ACTIONS(3784),
    [anon_sym_BANG] = ACTIONS(3786),
    [anon_sym_TILDE] = ACTIONS(3786),
    [anon_sym_PLUS_PLUS] = ACTIONS(3786),
    [anon_sym_DASH_DASH] = ACTIONS(3786),
    [anon_sym_true] = ACTIONS(3784),
    [anon_sym_false] = ACTIONS(3784),
    [anon_sym_PLUS] = ACTIONS(3784),
    [anon_sym_DASH] = ACTIONS(3784),
    [anon_sym_STAR] = ACTIONS(3786),
    [anon_sym_CARET] = ACTIONS(3786),
    [anon_sym_AMP] = ACTIONS(3786),
    [anon_sym_this] = ACTIONS(3784),
    [anon_sym_scoped] = ACTIONS(3784),
    [anon_sym_var] = ACTIONS(3784),
    [sym_predefined_type] = ACTIONS(3784),
    [anon_sym_break] = ACTIONS(3784),
    [anon_sym_unchecked] = ACTIONS(3784),
    [anon_sym_continue] = ACTIONS(3784),
    [anon_sym_do] = ACTIONS(3784),
    [anon_sym_while] = ACTIONS(3784),
    [anon_sym_for] = ACTIONS(3784),
    [anon_sym_lock] = ACTIONS(3784),
    [anon_sym_yield] = ACTIONS(3784),
    [anon_sym_switch] = ACTIONS(3784),
    [anon_sym_default] = ACTIONS(3784),
    [anon_sym_throw] = ACTIONS(3784),
    [anon_sym_try] = ACTIONS(3784),
    [anon_sym_when] = ACTIONS(3784),
    [anon_sym_await] = ACTIONS(3784),
    [anon_sym_foreach] = ACTIONS(3784),
    [anon_sym_goto] = ACTIONS(3784),
    [anon_sym_if] = ACTIONS(3784),
    [anon_sym_DOT_DOT] = ACTIONS(3786),
    [anon_sym_from] = ACTIONS(3784),
    [anon_sym_into] = ACTIONS(3784),
    [anon_sym_join] = ACTIONS(3784),
    [anon_sym_on] = ACTIONS(3784),
    [anon_sym_equals] = ACTIONS(3784),
    [anon_sym_let] = ACTIONS(3784),
    [anon_sym_orderby] = ACTIONS(3784),
    [anon_sym_ascending] = ACTIONS(3784),
    [anon_sym_descending] = ACTIONS(3784),
    [anon_sym_group] = ACTIONS(3784),
    [anon_sym_by] = ACTIONS(3784),
    [anon_sym_select] = ACTIONS(3784),
    [anon_sym_DQUOTE] = ACTIONS(3784),
    [anon_sym_stackalloc] = ACTIONS(3784),
    [anon_sym_sizeof] = ACTIONS(3784),
    [anon_sym_typeof] = ACTIONS(3784),
    [anon_sym___makeref] = ACTIONS(3784),
    [anon_sym___reftype] = ACTIONS(3784),
    [anon_sym___refvalue] = ACTIONS(3784),
    [sym_null_literal] = ACTIONS(3784),
    [anon_sym_SQUOTE] = ACTIONS(3786),
    [sym_integer_literal] = ACTIONS(3784),
    [sym_real_literal] = ACTIONS(3786),
    [sym_verbatim_string_literal] = ACTIONS(3786),
    [sym_raw_string_literal] = ACTIONS(3786),
    [aux_sym_preproc_if_token1] = ACTIONS(3786),
    [aux_sym_preproc_if_token3] = ACTIONS(3786),
    [aux_sym_preproc_else_token1] = ACTIONS(3786),
    [aux_sym_preproc_elif_token1] = ACTIONS(3786),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3786),
    [sym_interpolation_verbatim_start] = ACTIONS(3786),
    [sym_interpolation_raw_start] = ACTIONS(3786),
  },
  [2386] = {
    [sym_preproc_region] = STATE(2386),
    [sym_preproc_endregion] = STATE(2386),
    [sym_preproc_line] = STATE(2386),
    [sym_preproc_pragma] = STATE(2386),
    [sym_preproc_nullable] = STATE(2386),
    [sym_preproc_error] = STATE(2386),
    [sym_preproc_define] = STATE(2386),
    [sym_preproc_undef] = STATE(2386),
    [sym__identifier_token] = ACTIONS(3788),
    [anon_sym_extern] = ACTIONS(3788),
    [anon_sym_alias] = ACTIONS(3788),
    [anon_sym_SEMI] = ACTIONS(3790),
    [anon_sym_global] = ACTIONS(3788),
    [anon_sym_using] = ACTIONS(3788),
    [anon_sym_unsafe] = ACTIONS(3788),
    [anon_sym_static] = ACTIONS(3788),
    [anon_sym_LBRACK] = ACTIONS(3790),
    [anon_sym_LPAREN] = ACTIONS(3790),
    [anon_sym_return] = ACTIONS(3788),
    [anon_sym_namespace] = ACTIONS(3788),
    [anon_sym_class] = ACTIONS(3788),
    [anon_sym_ref] = ACTIONS(3788),
    [anon_sym_struct] = ACTIONS(3788),
    [anon_sym_enum] = ACTIONS(3788),
    [anon_sym_LBRACE] = ACTIONS(3790),
    [anon_sym_interface] = ACTIONS(3788),
    [anon_sym_delegate] = ACTIONS(3788),
    [anon_sym_record] = ACTIONS(3788),
    [anon_sym_abstract] = ACTIONS(3788),
    [anon_sym_async] = ACTIONS(3788),
    [anon_sym_const] = ACTIONS(3788),
    [anon_sym_file] = ACTIONS(3788),
    [anon_sym_fixed] = ACTIONS(3788),
    [anon_sym_internal] = ACTIONS(3788),
    [anon_sym_new] = ACTIONS(3788),
    [anon_sym_override] = ACTIONS(3788),
    [anon_sym_partial] = ACTIONS(3788),
    [anon_sym_private] = ACTIONS(3788),
    [anon_sym_protected] = ACTIONS(3788),
    [anon_sym_public] = ACTIONS(3788),
    [anon_sym_readonly] = ACTIONS(3788),
    [anon_sym_required] = ACTIONS(3788),
    [anon_sym_sealed] = ACTIONS(3788),
    [anon_sym_virtual] = ACTIONS(3788),
    [anon_sym_volatile] = ACTIONS(3788),
    [anon_sym_where] = ACTIONS(3788),
    [anon_sym_notnull] = ACTIONS(3788),
    [anon_sym_unmanaged] = ACTIONS(3788),
    [anon_sym_checked] = ACTIONS(3788),
    [anon_sym_BANG] = ACTIONS(3790),
    [anon_sym_TILDE] = ACTIONS(3790),
    [anon_sym_PLUS_PLUS] = ACTIONS(3790),
    [anon_sym_DASH_DASH] = ACTIONS(3790),
    [anon_sym_true] = ACTIONS(3788),
    [anon_sym_false] = ACTIONS(3788),
    [anon_sym_PLUS] = ACTIONS(3788),
    [anon_sym_DASH] = ACTIONS(3788),
    [anon_sym_STAR] = ACTIONS(3790),
    [anon_sym_CARET] = ACTIONS(3790),
    [anon_sym_AMP] = ACTIONS(3790),
    [anon_sym_this] = ACTIONS(3788),
    [anon_sym_scoped] = ACTIONS(3788),
    [anon_sym_var] = ACTIONS(3788),
    [sym_predefined_type] = ACTIONS(3788),
    [anon_sym_break] = ACTIONS(3788),
    [anon_sym_unchecked] = ACTIONS(3788),
    [anon_sym_continue] = ACTIONS(3788),
    [anon_sym_do] = ACTIONS(3788),
    [anon_sym_while] = ACTIONS(3788),
    [anon_sym_for] = ACTIONS(3788),
    [anon_sym_lock] = ACTIONS(3788),
    [anon_sym_yield] = ACTIONS(3788),
    [anon_sym_switch] = ACTIONS(3788),
    [anon_sym_default] = ACTIONS(3788),
    [anon_sym_throw] = ACTIONS(3788),
    [anon_sym_try] = ACTIONS(3788),
    [anon_sym_when] = ACTIONS(3788),
    [anon_sym_await] = ACTIONS(3788),
    [anon_sym_foreach] = ACTIONS(3788),
    [anon_sym_goto] = ACTIONS(3788),
    [anon_sym_if] = ACTIONS(3788),
    [anon_sym_DOT_DOT] = ACTIONS(3790),
    [anon_sym_from] = ACTIONS(3788),
    [anon_sym_into] = ACTIONS(3788),
    [anon_sym_join] = ACTIONS(3788),
    [anon_sym_on] = ACTIONS(3788),
    [anon_sym_equals] = ACTIONS(3788),
    [anon_sym_let] = ACTIONS(3788),
    [anon_sym_orderby] = ACTIONS(3788),
    [anon_sym_ascending] = ACTIONS(3788),
    [anon_sym_descending] = ACTIONS(3788),
    [anon_sym_group] = ACTIONS(3788),
    [anon_sym_by] = ACTIONS(3788),
    [anon_sym_select] = ACTIONS(3788),
    [anon_sym_DQUOTE] = ACTIONS(3788),
    [anon_sym_stackalloc] = ACTIONS(3788),
    [anon_sym_sizeof] = ACTIONS(3788),
    [anon_sym_typeof] = ACTIONS(3788),
    [anon_sym___makeref] = ACTIONS(3788),
    [anon_sym___reftype] = ACTIONS(3788),
    [anon_sym___refvalue] = ACTIONS(3788),
    [sym_null_literal] = ACTIONS(3788),
    [anon_sym_SQUOTE] = ACTIONS(3790),
    [sym_integer_literal] = ACTIONS(3788),
    [sym_real_literal] = ACTIONS(3790),
    [sym_verbatim_string_literal] = ACTIONS(3790),
    [sym_raw_string_literal] = ACTIONS(3790),
    [aux_sym_preproc_if_token1] = ACTIONS(3790),
    [aux_sym_preproc_if_token3] = ACTIONS(3790),
    [aux_sym_preproc_else_token1] = ACTIONS(3790),
    [aux_sym_preproc_elif_token1] = ACTIONS(3790),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3790),
    [sym_interpolation_verbatim_start] = ACTIONS(3790),
    [sym_interpolation_raw_start] = ACTIONS(3790),
  },
  [2387] = {
    [sym_preproc_region] = STATE(2387),
    [sym_preproc_endregion] = STATE(2387),
    [sym_preproc_line] = STATE(2387),
    [sym_preproc_pragma] = STATE(2387),
    [sym_preproc_nullable] = STATE(2387),
    [sym_preproc_error] = STATE(2387),
    [sym_preproc_define] = STATE(2387),
    [sym_preproc_undef] = STATE(2387),
    [sym__identifier_token] = ACTIONS(3792),
    [anon_sym_extern] = ACTIONS(3792),
    [anon_sym_alias] = ACTIONS(3792),
    [anon_sym_SEMI] = ACTIONS(3794),
    [anon_sym_global] = ACTIONS(3792),
    [anon_sym_using] = ACTIONS(3792),
    [anon_sym_unsafe] = ACTIONS(3792),
    [anon_sym_static] = ACTIONS(3792),
    [anon_sym_LBRACK] = ACTIONS(3794),
    [anon_sym_LPAREN] = ACTIONS(3794),
    [anon_sym_return] = ACTIONS(3792),
    [anon_sym_namespace] = ACTIONS(3792),
    [anon_sym_class] = ACTIONS(3792),
    [anon_sym_ref] = ACTIONS(3792),
    [anon_sym_struct] = ACTIONS(3792),
    [anon_sym_enum] = ACTIONS(3792),
    [anon_sym_LBRACE] = ACTIONS(3794),
    [anon_sym_interface] = ACTIONS(3792),
    [anon_sym_delegate] = ACTIONS(3792),
    [anon_sym_record] = ACTIONS(3792),
    [anon_sym_abstract] = ACTIONS(3792),
    [anon_sym_async] = ACTIONS(3792),
    [anon_sym_const] = ACTIONS(3792),
    [anon_sym_file] = ACTIONS(3792),
    [anon_sym_fixed] = ACTIONS(3792),
    [anon_sym_internal] = ACTIONS(3792),
    [anon_sym_new] = ACTIONS(3792),
    [anon_sym_override] = ACTIONS(3792),
    [anon_sym_partial] = ACTIONS(3792),
    [anon_sym_private] = ACTIONS(3792),
    [anon_sym_protected] = ACTIONS(3792),
    [anon_sym_public] = ACTIONS(3792),
    [anon_sym_readonly] = ACTIONS(3792),
    [anon_sym_required] = ACTIONS(3792),
    [anon_sym_sealed] = ACTIONS(3792),
    [anon_sym_virtual] = ACTIONS(3792),
    [anon_sym_volatile] = ACTIONS(3792),
    [anon_sym_where] = ACTIONS(3792),
    [anon_sym_notnull] = ACTIONS(3792),
    [anon_sym_unmanaged] = ACTIONS(3792),
    [anon_sym_checked] = ACTIONS(3792),
    [anon_sym_BANG] = ACTIONS(3794),
    [anon_sym_TILDE] = ACTIONS(3794),
    [anon_sym_PLUS_PLUS] = ACTIONS(3794),
    [anon_sym_DASH_DASH] = ACTIONS(3794),
    [anon_sym_true] = ACTIONS(3792),
    [anon_sym_false] = ACTIONS(3792),
    [anon_sym_PLUS] = ACTIONS(3792),
    [anon_sym_DASH] = ACTIONS(3792),
    [anon_sym_STAR] = ACTIONS(3794),
    [anon_sym_CARET] = ACTIONS(3794),
    [anon_sym_AMP] = ACTIONS(3794),
    [anon_sym_this] = ACTIONS(3792),
    [anon_sym_scoped] = ACTIONS(3792),
    [anon_sym_var] = ACTIONS(3792),
    [sym_predefined_type] = ACTIONS(3792),
    [anon_sym_break] = ACTIONS(3792),
    [anon_sym_unchecked] = ACTIONS(3792),
    [anon_sym_continue] = ACTIONS(3792),
    [anon_sym_do] = ACTIONS(3792),
    [anon_sym_while] = ACTIONS(3792),
    [anon_sym_for] = ACTIONS(3792),
    [anon_sym_lock] = ACTIONS(3792),
    [anon_sym_yield] = ACTIONS(3792),
    [anon_sym_switch] = ACTIONS(3792),
    [anon_sym_default] = ACTIONS(3792),
    [anon_sym_throw] = ACTIONS(3792),
    [anon_sym_try] = ACTIONS(3792),
    [anon_sym_when] = ACTIONS(3792),
    [anon_sym_await] = ACTIONS(3792),
    [anon_sym_foreach] = ACTIONS(3792),
    [anon_sym_goto] = ACTIONS(3792),
    [anon_sym_if] = ACTIONS(3792),
    [anon_sym_DOT_DOT] = ACTIONS(3794),
    [anon_sym_from] = ACTIONS(3792),
    [anon_sym_into] = ACTIONS(3792),
    [anon_sym_join] = ACTIONS(3792),
    [anon_sym_on] = ACTIONS(3792),
    [anon_sym_equals] = ACTIONS(3792),
    [anon_sym_let] = ACTIONS(3792),
    [anon_sym_orderby] = ACTIONS(3792),
    [anon_sym_ascending] = ACTIONS(3792),
    [anon_sym_descending] = ACTIONS(3792),
    [anon_sym_group] = ACTIONS(3792),
    [anon_sym_by] = ACTIONS(3792),
    [anon_sym_select] = ACTIONS(3792),
    [anon_sym_DQUOTE] = ACTIONS(3792),
    [anon_sym_stackalloc] = ACTIONS(3792),
    [anon_sym_sizeof] = ACTIONS(3792),
    [anon_sym_typeof] = ACTIONS(3792),
    [anon_sym___makeref] = ACTIONS(3792),
    [anon_sym___reftype] = ACTIONS(3792),
    [anon_sym___refvalue] = ACTIONS(3792),
    [sym_null_literal] = ACTIONS(3792),
    [anon_sym_SQUOTE] = ACTIONS(3794),
    [sym_integer_literal] = ACTIONS(3792),
    [sym_real_literal] = ACTIONS(3794),
    [sym_verbatim_string_literal] = ACTIONS(3794),
    [sym_raw_string_literal] = ACTIONS(3794),
    [aux_sym_preproc_if_token1] = ACTIONS(3794),
    [aux_sym_preproc_if_token3] = ACTIONS(3794),
    [aux_sym_preproc_else_token1] = ACTIONS(3794),
    [aux_sym_preproc_elif_token1] = ACTIONS(3794),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3794),
    [sym_interpolation_verbatim_start] = ACTIONS(3794),
    [sym_interpolation_raw_start] = ACTIONS(3794),
  },
  [2388] = {
    [sym_preproc_region] = STATE(2388),
    [sym_preproc_endregion] = STATE(2388),
    [sym_preproc_line] = STATE(2388),
    [sym_preproc_pragma] = STATE(2388),
    [sym_preproc_nullable] = STATE(2388),
    [sym_preproc_error] = STATE(2388),
    [sym_preproc_define] = STATE(2388),
    [sym_preproc_undef] = STATE(2388),
    [sym__identifier_token] = ACTIONS(3796),
    [anon_sym_extern] = ACTIONS(3796),
    [anon_sym_alias] = ACTIONS(3796),
    [anon_sym_SEMI] = ACTIONS(3798),
    [anon_sym_global] = ACTIONS(3796),
    [anon_sym_using] = ACTIONS(3796),
    [anon_sym_unsafe] = ACTIONS(3796),
    [anon_sym_static] = ACTIONS(3796),
    [anon_sym_LBRACK] = ACTIONS(3798),
    [anon_sym_LPAREN] = ACTIONS(3798),
    [anon_sym_return] = ACTIONS(3796),
    [anon_sym_namespace] = ACTIONS(3796),
    [anon_sym_class] = ACTIONS(3796),
    [anon_sym_ref] = ACTIONS(3796),
    [anon_sym_struct] = ACTIONS(3796),
    [anon_sym_enum] = ACTIONS(3796),
    [anon_sym_LBRACE] = ACTIONS(3798),
    [anon_sym_interface] = ACTIONS(3796),
    [anon_sym_delegate] = ACTIONS(3796),
    [anon_sym_record] = ACTIONS(3796),
    [anon_sym_abstract] = ACTIONS(3796),
    [anon_sym_async] = ACTIONS(3796),
    [anon_sym_const] = ACTIONS(3796),
    [anon_sym_file] = ACTIONS(3796),
    [anon_sym_fixed] = ACTIONS(3796),
    [anon_sym_internal] = ACTIONS(3796),
    [anon_sym_new] = ACTIONS(3796),
    [anon_sym_override] = ACTIONS(3796),
    [anon_sym_partial] = ACTIONS(3796),
    [anon_sym_private] = ACTIONS(3796),
    [anon_sym_protected] = ACTIONS(3796),
    [anon_sym_public] = ACTIONS(3796),
    [anon_sym_readonly] = ACTIONS(3796),
    [anon_sym_required] = ACTIONS(3796),
    [anon_sym_sealed] = ACTIONS(3796),
    [anon_sym_virtual] = ACTIONS(3796),
    [anon_sym_volatile] = ACTIONS(3796),
    [anon_sym_where] = ACTIONS(3796),
    [anon_sym_notnull] = ACTIONS(3796),
    [anon_sym_unmanaged] = ACTIONS(3796),
    [anon_sym_checked] = ACTIONS(3796),
    [anon_sym_BANG] = ACTIONS(3798),
    [anon_sym_TILDE] = ACTIONS(3798),
    [anon_sym_PLUS_PLUS] = ACTIONS(3798),
    [anon_sym_DASH_DASH] = ACTIONS(3798),
    [anon_sym_true] = ACTIONS(3796),
    [anon_sym_false] = ACTIONS(3796),
    [anon_sym_PLUS] = ACTIONS(3796),
    [anon_sym_DASH] = ACTIONS(3796),
    [anon_sym_STAR] = ACTIONS(3798),
    [anon_sym_CARET] = ACTIONS(3798),
    [anon_sym_AMP] = ACTIONS(3798),
    [anon_sym_this] = ACTIONS(3796),
    [anon_sym_scoped] = ACTIONS(3796),
    [anon_sym_var] = ACTIONS(3796),
    [sym_predefined_type] = ACTIONS(3796),
    [anon_sym_break] = ACTIONS(3796),
    [anon_sym_unchecked] = ACTIONS(3796),
    [anon_sym_continue] = ACTIONS(3796),
    [anon_sym_do] = ACTIONS(3796),
    [anon_sym_while] = ACTIONS(3796),
    [anon_sym_for] = ACTIONS(3796),
    [anon_sym_lock] = ACTIONS(3796),
    [anon_sym_yield] = ACTIONS(3796),
    [anon_sym_switch] = ACTIONS(3796),
    [anon_sym_default] = ACTIONS(3796),
    [anon_sym_throw] = ACTIONS(3796),
    [anon_sym_try] = ACTIONS(3796),
    [anon_sym_when] = ACTIONS(3796),
    [anon_sym_await] = ACTIONS(3796),
    [anon_sym_foreach] = ACTIONS(3796),
    [anon_sym_goto] = ACTIONS(3796),
    [anon_sym_if] = ACTIONS(3796),
    [anon_sym_DOT_DOT] = ACTIONS(3798),
    [anon_sym_from] = ACTIONS(3796),
    [anon_sym_into] = ACTIONS(3796),
    [anon_sym_join] = ACTIONS(3796),
    [anon_sym_on] = ACTIONS(3796),
    [anon_sym_equals] = ACTIONS(3796),
    [anon_sym_let] = ACTIONS(3796),
    [anon_sym_orderby] = ACTIONS(3796),
    [anon_sym_ascending] = ACTIONS(3796),
    [anon_sym_descending] = ACTIONS(3796),
    [anon_sym_group] = ACTIONS(3796),
    [anon_sym_by] = ACTIONS(3796),
    [anon_sym_select] = ACTIONS(3796),
    [anon_sym_DQUOTE] = ACTIONS(3796),
    [anon_sym_stackalloc] = ACTIONS(3796),
    [anon_sym_sizeof] = ACTIONS(3796),
    [anon_sym_typeof] = ACTIONS(3796),
    [anon_sym___makeref] = ACTIONS(3796),
    [anon_sym___reftype] = ACTIONS(3796),
    [anon_sym___refvalue] = ACTIONS(3796),
    [sym_null_literal] = ACTIONS(3796),
    [anon_sym_SQUOTE] = ACTIONS(3798),
    [sym_integer_literal] = ACTIONS(3796),
    [sym_real_literal] = ACTIONS(3798),
    [sym_verbatim_string_literal] = ACTIONS(3798),
    [sym_raw_string_literal] = ACTIONS(3798),
    [aux_sym_preproc_if_token1] = ACTIONS(3798),
    [aux_sym_preproc_if_token3] = ACTIONS(3798),
    [aux_sym_preproc_else_token1] = ACTIONS(3798),
    [aux_sym_preproc_elif_token1] = ACTIONS(3798),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3798),
    [sym_interpolation_verbatim_start] = ACTIONS(3798),
    [sym_interpolation_raw_start] = ACTIONS(3798),
  },
  [2389] = {
    [sym_preproc_region] = STATE(2389),
    [sym_preproc_endregion] = STATE(2389),
    [sym_preproc_line] = STATE(2389),
    [sym_preproc_pragma] = STATE(2389),
    [sym_preproc_nullable] = STATE(2389),
    [sym_preproc_error] = STATE(2389),
    [sym_preproc_define] = STATE(2389),
    [sym_preproc_undef] = STATE(2389),
    [sym__identifier_token] = ACTIONS(3800),
    [anon_sym_extern] = ACTIONS(3800),
    [anon_sym_alias] = ACTIONS(3800),
    [anon_sym_SEMI] = ACTIONS(3802),
    [anon_sym_global] = ACTIONS(3800),
    [anon_sym_using] = ACTIONS(3800),
    [anon_sym_unsafe] = ACTIONS(3800),
    [anon_sym_static] = ACTIONS(3800),
    [anon_sym_LBRACK] = ACTIONS(3802),
    [anon_sym_LPAREN] = ACTIONS(3802),
    [anon_sym_return] = ACTIONS(3800),
    [anon_sym_namespace] = ACTIONS(3800),
    [anon_sym_class] = ACTIONS(3800),
    [anon_sym_ref] = ACTIONS(3800),
    [anon_sym_struct] = ACTIONS(3800),
    [anon_sym_enum] = ACTIONS(3800),
    [anon_sym_LBRACE] = ACTIONS(3802),
    [anon_sym_interface] = ACTIONS(3800),
    [anon_sym_delegate] = ACTIONS(3800),
    [anon_sym_record] = ACTIONS(3800),
    [anon_sym_abstract] = ACTIONS(3800),
    [anon_sym_async] = ACTIONS(3800),
    [anon_sym_const] = ACTIONS(3800),
    [anon_sym_file] = ACTIONS(3800),
    [anon_sym_fixed] = ACTIONS(3800),
    [anon_sym_internal] = ACTIONS(3800),
    [anon_sym_new] = ACTIONS(3800),
    [anon_sym_override] = ACTIONS(3800),
    [anon_sym_partial] = ACTIONS(3800),
    [anon_sym_private] = ACTIONS(3800),
    [anon_sym_protected] = ACTIONS(3800),
    [anon_sym_public] = ACTIONS(3800),
    [anon_sym_readonly] = ACTIONS(3800),
    [anon_sym_required] = ACTIONS(3800),
    [anon_sym_sealed] = ACTIONS(3800),
    [anon_sym_virtual] = ACTIONS(3800),
    [anon_sym_volatile] = ACTIONS(3800),
    [anon_sym_where] = ACTIONS(3800),
    [anon_sym_notnull] = ACTIONS(3800),
    [anon_sym_unmanaged] = ACTIONS(3800),
    [anon_sym_checked] = ACTIONS(3800),
    [anon_sym_BANG] = ACTIONS(3802),
    [anon_sym_TILDE] = ACTIONS(3802),
    [anon_sym_PLUS_PLUS] = ACTIONS(3802),
    [anon_sym_DASH_DASH] = ACTIONS(3802),
    [anon_sym_true] = ACTIONS(3800),
    [anon_sym_false] = ACTIONS(3800),
    [anon_sym_PLUS] = ACTIONS(3800),
    [anon_sym_DASH] = ACTIONS(3800),
    [anon_sym_STAR] = ACTIONS(3802),
    [anon_sym_CARET] = ACTIONS(3802),
    [anon_sym_AMP] = ACTIONS(3802),
    [anon_sym_this] = ACTIONS(3800),
    [anon_sym_scoped] = ACTIONS(3800),
    [anon_sym_var] = ACTIONS(3800),
    [sym_predefined_type] = ACTIONS(3800),
    [anon_sym_break] = ACTIONS(3800),
    [anon_sym_unchecked] = ACTIONS(3800),
    [anon_sym_continue] = ACTIONS(3800),
    [anon_sym_do] = ACTIONS(3800),
    [anon_sym_while] = ACTIONS(3800),
    [anon_sym_for] = ACTIONS(3800),
    [anon_sym_lock] = ACTIONS(3800),
    [anon_sym_yield] = ACTIONS(3800),
    [anon_sym_switch] = ACTIONS(3800),
    [anon_sym_default] = ACTIONS(3800),
    [anon_sym_throw] = ACTIONS(3800),
    [anon_sym_try] = ACTIONS(3800),
    [anon_sym_when] = ACTIONS(3800),
    [anon_sym_await] = ACTIONS(3800),
    [anon_sym_foreach] = ACTIONS(3800),
    [anon_sym_goto] = ACTIONS(3800),
    [anon_sym_if] = ACTIONS(3800),
    [anon_sym_DOT_DOT] = ACTIONS(3802),
    [anon_sym_from] = ACTIONS(3800),
    [anon_sym_into] = ACTIONS(3800),
    [anon_sym_join] = ACTIONS(3800),
    [anon_sym_on] = ACTIONS(3800),
    [anon_sym_equals] = ACTIONS(3800),
    [anon_sym_let] = ACTIONS(3800),
    [anon_sym_orderby] = ACTIONS(3800),
    [anon_sym_ascending] = ACTIONS(3800),
    [anon_sym_descending] = ACTIONS(3800),
    [anon_sym_group] = ACTIONS(3800),
    [anon_sym_by] = ACTIONS(3800),
    [anon_sym_select] = ACTIONS(3800),
    [anon_sym_DQUOTE] = ACTIONS(3800),
    [anon_sym_stackalloc] = ACTIONS(3800),
    [anon_sym_sizeof] = ACTIONS(3800),
    [anon_sym_typeof] = ACTIONS(3800),
    [anon_sym___makeref] = ACTIONS(3800),
    [anon_sym___reftype] = ACTIONS(3800),
    [anon_sym___refvalue] = ACTIONS(3800),
    [sym_null_literal] = ACTIONS(3800),
    [anon_sym_SQUOTE] = ACTIONS(3802),
    [sym_integer_literal] = ACTIONS(3800),
    [sym_real_literal] = ACTIONS(3802),
    [sym_verbatim_string_literal] = ACTIONS(3802),
    [sym_raw_string_literal] = ACTIONS(3802),
    [aux_sym_preproc_if_token1] = ACTIONS(3802),
    [aux_sym_preproc_if_token3] = ACTIONS(3802),
    [aux_sym_preproc_else_token1] = ACTIONS(3802),
    [aux_sym_preproc_elif_token1] = ACTIONS(3802),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3802),
    [sym_interpolation_verbatim_start] = ACTIONS(3802),
    [sym_interpolation_raw_start] = ACTIONS(3802),
  },
  [2390] = {
    [sym_preproc_region] = STATE(2390),
    [sym_preproc_endregion] = STATE(2390),
    [sym_preproc_line] = STATE(2390),
    [sym_preproc_pragma] = STATE(2390),
    [sym_preproc_nullable] = STATE(2390),
    [sym_preproc_error] = STATE(2390),
    [sym_preproc_define] = STATE(2390),
    [sym_preproc_undef] = STATE(2390),
    [sym__identifier_token] = ACTIONS(3804),
    [anon_sym_extern] = ACTIONS(3804),
    [anon_sym_alias] = ACTIONS(3804),
    [anon_sym_SEMI] = ACTIONS(3806),
    [anon_sym_global] = ACTIONS(3804),
    [anon_sym_using] = ACTIONS(3804),
    [anon_sym_unsafe] = ACTIONS(3804),
    [anon_sym_static] = ACTIONS(3804),
    [anon_sym_LBRACK] = ACTIONS(3806),
    [anon_sym_LPAREN] = ACTIONS(3806),
    [anon_sym_return] = ACTIONS(3804),
    [anon_sym_namespace] = ACTIONS(3804),
    [anon_sym_class] = ACTIONS(3804),
    [anon_sym_ref] = ACTIONS(3804),
    [anon_sym_struct] = ACTIONS(3804),
    [anon_sym_enum] = ACTIONS(3804),
    [anon_sym_LBRACE] = ACTIONS(3806),
    [anon_sym_interface] = ACTIONS(3804),
    [anon_sym_delegate] = ACTIONS(3804),
    [anon_sym_record] = ACTIONS(3804),
    [anon_sym_abstract] = ACTIONS(3804),
    [anon_sym_async] = ACTIONS(3804),
    [anon_sym_const] = ACTIONS(3804),
    [anon_sym_file] = ACTIONS(3804),
    [anon_sym_fixed] = ACTIONS(3804),
    [anon_sym_internal] = ACTIONS(3804),
    [anon_sym_new] = ACTIONS(3804),
    [anon_sym_override] = ACTIONS(3804),
    [anon_sym_partial] = ACTIONS(3804),
    [anon_sym_private] = ACTIONS(3804),
    [anon_sym_protected] = ACTIONS(3804),
    [anon_sym_public] = ACTIONS(3804),
    [anon_sym_readonly] = ACTIONS(3804),
    [anon_sym_required] = ACTIONS(3804),
    [anon_sym_sealed] = ACTIONS(3804),
    [anon_sym_virtual] = ACTIONS(3804),
    [anon_sym_volatile] = ACTIONS(3804),
    [anon_sym_where] = ACTIONS(3804),
    [anon_sym_notnull] = ACTIONS(3804),
    [anon_sym_unmanaged] = ACTIONS(3804),
    [anon_sym_checked] = ACTIONS(3804),
    [anon_sym_BANG] = ACTIONS(3806),
    [anon_sym_TILDE] = ACTIONS(3806),
    [anon_sym_PLUS_PLUS] = ACTIONS(3806),
    [anon_sym_DASH_DASH] = ACTIONS(3806),
    [anon_sym_true] = ACTIONS(3804),
    [anon_sym_false] = ACTIONS(3804),
    [anon_sym_PLUS] = ACTIONS(3804),
    [anon_sym_DASH] = ACTIONS(3804),
    [anon_sym_STAR] = ACTIONS(3806),
    [anon_sym_CARET] = ACTIONS(3806),
    [anon_sym_AMP] = ACTIONS(3806),
    [anon_sym_this] = ACTIONS(3804),
    [anon_sym_scoped] = ACTIONS(3804),
    [anon_sym_var] = ACTIONS(3804),
    [sym_predefined_type] = ACTIONS(3804),
    [anon_sym_break] = ACTIONS(3804),
    [anon_sym_unchecked] = ACTIONS(3804),
    [anon_sym_continue] = ACTIONS(3804),
    [anon_sym_do] = ACTIONS(3804),
    [anon_sym_while] = ACTIONS(3804),
    [anon_sym_for] = ACTIONS(3804),
    [anon_sym_lock] = ACTIONS(3804),
    [anon_sym_yield] = ACTIONS(3804),
    [anon_sym_switch] = ACTIONS(3804),
    [anon_sym_default] = ACTIONS(3804),
    [anon_sym_throw] = ACTIONS(3804),
    [anon_sym_try] = ACTIONS(3804),
    [anon_sym_when] = ACTIONS(3804),
    [anon_sym_await] = ACTIONS(3804),
    [anon_sym_foreach] = ACTIONS(3804),
    [anon_sym_goto] = ACTIONS(3804),
    [anon_sym_if] = ACTIONS(3804),
    [anon_sym_DOT_DOT] = ACTIONS(3806),
    [anon_sym_from] = ACTIONS(3804),
    [anon_sym_into] = ACTIONS(3804),
    [anon_sym_join] = ACTIONS(3804),
    [anon_sym_on] = ACTIONS(3804),
    [anon_sym_equals] = ACTIONS(3804),
    [anon_sym_let] = ACTIONS(3804),
    [anon_sym_orderby] = ACTIONS(3804),
    [anon_sym_ascending] = ACTIONS(3804),
    [anon_sym_descending] = ACTIONS(3804),
    [anon_sym_group] = ACTIONS(3804),
    [anon_sym_by] = ACTIONS(3804),
    [anon_sym_select] = ACTIONS(3804),
    [anon_sym_DQUOTE] = ACTIONS(3804),
    [anon_sym_stackalloc] = ACTIONS(3804),
    [anon_sym_sizeof] = ACTIONS(3804),
    [anon_sym_typeof] = ACTIONS(3804),
    [anon_sym___makeref] = ACTIONS(3804),
    [anon_sym___reftype] = ACTIONS(3804),
    [anon_sym___refvalue] = ACTIONS(3804),
    [sym_null_literal] = ACTIONS(3804),
    [anon_sym_SQUOTE] = ACTIONS(3806),
    [sym_integer_literal] = ACTIONS(3804),
    [sym_real_literal] = ACTIONS(3806),
    [sym_verbatim_string_literal] = ACTIONS(3806),
    [sym_raw_string_literal] = ACTIONS(3806),
    [aux_sym_preproc_if_token1] = ACTIONS(3806),
    [aux_sym_preproc_if_token3] = ACTIONS(3806),
    [aux_sym_preproc_else_token1] = ACTIONS(3806),
    [aux_sym_preproc_elif_token1] = ACTIONS(3806),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3806),
    [sym_interpolation_verbatim_start] = ACTIONS(3806),
    [sym_interpolation_raw_start] = ACTIONS(3806),
  },
  [2391] = {
    [sym_preproc_region] = STATE(2391),
    [sym_preproc_endregion] = STATE(2391),
    [sym_preproc_line] = STATE(2391),
    [sym_preproc_pragma] = STATE(2391),
    [sym_preproc_nullable] = STATE(2391),
    [sym_preproc_error] = STATE(2391),
    [sym_preproc_define] = STATE(2391),
    [sym_preproc_undef] = STATE(2391),
    [sym__identifier_token] = ACTIONS(3808),
    [anon_sym_extern] = ACTIONS(3808),
    [anon_sym_alias] = ACTIONS(3808),
    [anon_sym_SEMI] = ACTIONS(3810),
    [anon_sym_global] = ACTIONS(3808),
    [anon_sym_using] = ACTIONS(3808),
    [anon_sym_unsafe] = ACTIONS(3808),
    [anon_sym_static] = ACTIONS(3808),
    [anon_sym_LBRACK] = ACTIONS(3810),
    [anon_sym_LPAREN] = ACTIONS(3810),
    [anon_sym_return] = ACTIONS(3808),
    [anon_sym_namespace] = ACTIONS(3808),
    [anon_sym_class] = ACTIONS(3808),
    [anon_sym_ref] = ACTIONS(3808),
    [anon_sym_struct] = ACTIONS(3808),
    [anon_sym_enum] = ACTIONS(3808),
    [anon_sym_LBRACE] = ACTIONS(3810),
    [anon_sym_interface] = ACTIONS(3808),
    [anon_sym_delegate] = ACTIONS(3808),
    [anon_sym_record] = ACTIONS(3808),
    [anon_sym_abstract] = ACTIONS(3808),
    [anon_sym_async] = ACTIONS(3808),
    [anon_sym_const] = ACTIONS(3808),
    [anon_sym_file] = ACTIONS(3808),
    [anon_sym_fixed] = ACTIONS(3808),
    [anon_sym_internal] = ACTIONS(3808),
    [anon_sym_new] = ACTIONS(3808),
    [anon_sym_override] = ACTIONS(3808),
    [anon_sym_partial] = ACTIONS(3808),
    [anon_sym_private] = ACTIONS(3808),
    [anon_sym_protected] = ACTIONS(3808),
    [anon_sym_public] = ACTIONS(3808),
    [anon_sym_readonly] = ACTIONS(3808),
    [anon_sym_required] = ACTIONS(3808),
    [anon_sym_sealed] = ACTIONS(3808),
    [anon_sym_virtual] = ACTIONS(3808),
    [anon_sym_volatile] = ACTIONS(3808),
    [anon_sym_where] = ACTIONS(3808),
    [anon_sym_notnull] = ACTIONS(3808),
    [anon_sym_unmanaged] = ACTIONS(3808),
    [anon_sym_checked] = ACTIONS(3808),
    [anon_sym_BANG] = ACTIONS(3810),
    [anon_sym_TILDE] = ACTIONS(3810),
    [anon_sym_PLUS_PLUS] = ACTIONS(3810),
    [anon_sym_DASH_DASH] = ACTIONS(3810),
    [anon_sym_true] = ACTIONS(3808),
    [anon_sym_false] = ACTIONS(3808),
    [anon_sym_PLUS] = ACTIONS(3808),
    [anon_sym_DASH] = ACTIONS(3808),
    [anon_sym_STAR] = ACTIONS(3810),
    [anon_sym_CARET] = ACTIONS(3810),
    [anon_sym_AMP] = ACTIONS(3810),
    [anon_sym_this] = ACTIONS(3808),
    [anon_sym_scoped] = ACTIONS(3808),
    [anon_sym_var] = ACTIONS(3808),
    [sym_predefined_type] = ACTIONS(3808),
    [anon_sym_break] = ACTIONS(3808),
    [anon_sym_unchecked] = ACTIONS(3808),
    [anon_sym_continue] = ACTIONS(3808),
    [anon_sym_do] = ACTIONS(3808),
    [anon_sym_while] = ACTIONS(3808),
    [anon_sym_for] = ACTIONS(3808),
    [anon_sym_lock] = ACTIONS(3808),
    [anon_sym_yield] = ACTIONS(3808),
    [anon_sym_switch] = ACTIONS(3808),
    [anon_sym_default] = ACTIONS(3808),
    [anon_sym_throw] = ACTIONS(3808),
    [anon_sym_try] = ACTIONS(3808),
    [anon_sym_when] = ACTIONS(3808),
    [anon_sym_await] = ACTIONS(3808),
    [anon_sym_foreach] = ACTIONS(3808),
    [anon_sym_goto] = ACTIONS(3808),
    [anon_sym_if] = ACTIONS(3808),
    [anon_sym_DOT_DOT] = ACTIONS(3810),
    [anon_sym_from] = ACTIONS(3808),
    [anon_sym_into] = ACTIONS(3808),
    [anon_sym_join] = ACTIONS(3808),
    [anon_sym_on] = ACTIONS(3808),
    [anon_sym_equals] = ACTIONS(3808),
    [anon_sym_let] = ACTIONS(3808),
    [anon_sym_orderby] = ACTIONS(3808),
    [anon_sym_ascending] = ACTIONS(3808),
    [anon_sym_descending] = ACTIONS(3808),
    [anon_sym_group] = ACTIONS(3808),
    [anon_sym_by] = ACTIONS(3808),
    [anon_sym_select] = ACTIONS(3808),
    [anon_sym_DQUOTE] = ACTIONS(3808),
    [anon_sym_stackalloc] = ACTIONS(3808),
    [anon_sym_sizeof] = ACTIONS(3808),
    [anon_sym_typeof] = ACTIONS(3808),
    [anon_sym___makeref] = ACTIONS(3808),
    [anon_sym___reftype] = ACTIONS(3808),
    [anon_sym___refvalue] = ACTIONS(3808),
    [sym_null_literal] = ACTIONS(3808),
    [anon_sym_SQUOTE] = ACTIONS(3810),
    [sym_integer_literal] = ACTIONS(3808),
    [sym_real_literal] = ACTIONS(3810),
    [sym_verbatim_string_literal] = ACTIONS(3810),
    [sym_raw_string_literal] = ACTIONS(3810),
    [aux_sym_preproc_if_token1] = ACTIONS(3810),
    [aux_sym_preproc_if_token3] = ACTIONS(3810),
    [aux_sym_preproc_else_token1] = ACTIONS(3810),
    [aux_sym_preproc_elif_token1] = ACTIONS(3810),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3810),
    [sym_interpolation_verbatim_start] = ACTIONS(3810),
    [sym_interpolation_raw_start] = ACTIONS(3810),
  },
  [2392] = {
    [sym_preproc_region] = STATE(2392),
    [sym_preproc_endregion] = STATE(2392),
    [sym_preproc_line] = STATE(2392),
    [sym_preproc_pragma] = STATE(2392),
    [sym_preproc_nullable] = STATE(2392),
    [sym_preproc_error] = STATE(2392),
    [sym_preproc_define] = STATE(2392),
    [sym_preproc_undef] = STATE(2392),
    [sym__identifier_token] = ACTIONS(3812),
    [anon_sym_extern] = ACTIONS(3812),
    [anon_sym_alias] = ACTIONS(3812),
    [anon_sym_SEMI] = ACTIONS(3814),
    [anon_sym_global] = ACTIONS(3812),
    [anon_sym_using] = ACTIONS(3812),
    [anon_sym_unsafe] = ACTIONS(3812),
    [anon_sym_static] = ACTIONS(3812),
    [anon_sym_LBRACK] = ACTIONS(3814),
    [anon_sym_LPAREN] = ACTIONS(3814),
    [anon_sym_return] = ACTIONS(3812),
    [anon_sym_namespace] = ACTIONS(3812),
    [anon_sym_class] = ACTIONS(3812),
    [anon_sym_ref] = ACTIONS(3812),
    [anon_sym_struct] = ACTIONS(3812),
    [anon_sym_enum] = ACTIONS(3812),
    [anon_sym_LBRACE] = ACTIONS(3814),
    [anon_sym_interface] = ACTIONS(3812),
    [anon_sym_delegate] = ACTIONS(3812),
    [anon_sym_record] = ACTIONS(3812),
    [anon_sym_abstract] = ACTIONS(3812),
    [anon_sym_async] = ACTIONS(3812),
    [anon_sym_const] = ACTIONS(3812),
    [anon_sym_file] = ACTIONS(3812),
    [anon_sym_fixed] = ACTIONS(3812),
    [anon_sym_internal] = ACTIONS(3812),
    [anon_sym_new] = ACTIONS(3812),
    [anon_sym_override] = ACTIONS(3812),
    [anon_sym_partial] = ACTIONS(3812),
    [anon_sym_private] = ACTIONS(3812),
    [anon_sym_protected] = ACTIONS(3812),
    [anon_sym_public] = ACTIONS(3812),
    [anon_sym_readonly] = ACTIONS(3812),
    [anon_sym_required] = ACTIONS(3812),
    [anon_sym_sealed] = ACTIONS(3812),
    [anon_sym_virtual] = ACTIONS(3812),
    [anon_sym_volatile] = ACTIONS(3812),
    [anon_sym_where] = ACTIONS(3812),
    [anon_sym_notnull] = ACTIONS(3812),
    [anon_sym_unmanaged] = ACTIONS(3812),
    [anon_sym_checked] = ACTIONS(3812),
    [anon_sym_BANG] = ACTIONS(3814),
    [anon_sym_TILDE] = ACTIONS(3814),
    [anon_sym_PLUS_PLUS] = ACTIONS(3814),
    [anon_sym_DASH_DASH] = ACTIONS(3814),
    [anon_sym_true] = ACTIONS(3812),
    [anon_sym_false] = ACTIONS(3812),
    [anon_sym_PLUS] = ACTIONS(3812),
    [anon_sym_DASH] = ACTIONS(3812),
    [anon_sym_STAR] = ACTIONS(3814),
    [anon_sym_CARET] = ACTIONS(3814),
    [anon_sym_AMP] = ACTIONS(3814),
    [anon_sym_this] = ACTIONS(3812),
    [anon_sym_scoped] = ACTIONS(3812),
    [anon_sym_var] = ACTIONS(3812),
    [sym_predefined_type] = ACTIONS(3812),
    [anon_sym_break] = ACTIONS(3812),
    [anon_sym_unchecked] = ACTIONS(3812),
    [anon_sym_continue] = ACTIONS(3812),
    [anon_sym_do] = ACTIONS(3812),
    [anon_sym_while] = ACTIONS(3812),
    [anon_sym_for] = ACTIONS(3812),
    [anon_sym_lock] = ACTIONS(3812),
    [anon_sym_yield] = ACTIONS(3812),
    [anon_sym_switch] = ACTIONS(3812),
    [anon_sym_default] = ACTIONS(3812),
    [anon_sym_throw] = ACTIONS(3812),
    [anon_sym_try] = ACTIONS(3812),
    [anon_sym_when] = ACTIONS(3812),
    [anon_sym_await] = ACTIONS(3812),
    [anon_sym_foreach] = ACTIONS(3812),
    [anon_sym_goto] = ACTIONS(3812),
    [anon_sym_if] = ACTIONS(3812),
    [anon_sym_DOT_DOT] = ACTIONS(3814),
    [anon_sym_from] = ACTIONS(3812),
    [anon_sym_into] = ACTIONS(3812),
    [anon_sym_join] = ACTIONS(3812),
    [anon_sym_on] = ACTIONS(3812),
    [anon_sym_equals] = ACTIONS(3812),
    [anon_sym_let] = ACTIONS(3812),
    [anon_sym_orderby] = ACTIONS(3812),
    [anon_sym_ascending] = ACTIONS(3812),
    [anon_sym_descending] = ACTIONS(3812),
    [anon_sym_group] = ACTIONS(3812),
    [anon_sym_by] = ACTIONS(3812),
    [anon_sym_select] = ACTIONS(3812),
    [anon_sym_DQUOTE] = ACTIONS(3812),
    [anon_sym_stackalloc] = ACTIONS(3812),
    [anon_sym_sizeof] = ACTIONS(3812),
    [anon_sym_typeof] = ACTIONS(3812),
    [anon_sym___makeref] = ACTIONS(3812),
    [anon_sym___reftype] = ACTIONS(3812),
    [anon_sym___refvalue] = ACTIONS(3812),
    [sym_null_literal] = ACTIONS(3812),
    [anon_sym_SQUOTE] = ACTIONS(3814),
    [sym_integer_literal] = ACTIONS(3812),
    [sym_real_literal] = ACTIONS(3814),
    [sym_verbatim_string_literal] = ACTIONS(3814),
    [sym_raw_string_literal] = ACTIONS(3814),
    [aux_sym_preproc_if_token1] = ACTIONS(3814),
    [aux_sym_preproc_if_token3] = ACTIONS(3814),
    [aux_sym_preproc_else_token1] = ACTIONS(3814),
    [aux_sym_preproc_elif_token1] = ACTIONS(3814),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3814),
    [sym_interpolation_verbatim_start] = ACTIONS(3814),
    [sym_interpolation_raw_start] = ACTIONS(3814),
  },
  [2393] = {
    [sym_preproc_region] = STATE(2393),
    [sym_preproc_endregion] = STATE(2393),
    [sym_preproc_line] = STATE(2393),
    [sym_preproc_pragma] = STATE(2393),
    [sym_preproc_nullable] = STATE(2393),
    [sym_preproc_error] = STATE(2393),
    [sym_preproc_define] = STATE(2393),
    [sym_preproc_undef] = STATE(2393),
    [sym__identifier_token] = ACTIONS(3816),
    [anon_sym_extern] = ACTIONS(3816),
    [anon_sym_alias] = ACTIONS(3816),
    [anon_sym_SEMI] = ACTIONS(3818),
    [anon_sym_global] = ACTIONS(3816),
    [anon_sym_using] = ACTIONS(3816),
    [anon_sym_unsafe] = ACTIONS(3816),
    [anon_sym_static] = ACTIONS(3816),
    [anon_sym_LBRACK] = ACTIONS(3818),
    [anon_sym_LPAREN] = ACTIONS(3818),
    [anon_sym_return] = ACTIONS(3816),
    [anon_sym_namespace] = ACTIONS(3816),
    [anon_sym_class] = ACTIONS(3816),
    [anon_sym_ref] = ACTIONS(3816),
    [anon_sym_struct] = ACTIONS(3816),
    [anon_sym_enum] = ACTIONS(3816),
    [anon_sym_LBRACE] = ACTIONS(3818),
    [anon_sym_interface] = ACTIONS(3816),
    [anon_sym_delegate] = ACTIONS(3816),
    [anon_sym_record] = ACTIONS(3816),
    [anon_sym_abstract] = ACTIONS(3816),
    [anon_sym_async] = ACTIONS(3816),
    [anon_sym_const] = ACTIONS(3816),
    [anon_sym_file] = ACTIONS(3816),
    [anon_sym_fixed] = ACTIONS(3816),
    [anon_sym_internal] = ACTIONS(3816),
    [anon_sym_new] = ACTIONS(3816),
    [anon_sym_override] = ACTIONS(3816),
    [anon_sym_partial] = ACTIONS(3816),
    [anon_sym_private] = ACTIONS(3816),
    [anon_sym_protected] = ACTIONS(3816),
    [anon_sym_public] = ACTIONS(3816),
    [anon_sym_readonly] = ACTIONS(3816),
    [anon_sym_required] = ACTIONS(3816),
    [anon_sym_sealed] = ACTIONS(3816),
    [anon_sym_virtual] = ACTIONS(3816),
    [anon_sym_volatile] = ACTIONS(3816),
    [anon_sym_where] = ACTIONS(3816),
    [anon_sym_notnull] = ACTIONS(3816),
    [anon_sym_unmanaged] = ACTIONS(3816),
    [anon_sym_checked] = ACTIONS(3816),
    [anon_sym_BANG] = ACTIONS(3818),
    [anon_sym_TILDE] = ACTIONS(3818),
    [anon_sym_PLUS_PLUS] = ACTIONS(3818),
    [anon_sym_DASH_DASH] = ACTIONS(3818),
    [anon_sym_true] = ACTIONS(3816),
    [anon_sym_false] = ACTIONS(3816),
    [anon_sym_PLUS] = ACTIONS(3816),
    [anon_sym_DASH] = ACTIONS(3816),
    [anon_sym_STAR] = ACTIONS(3818),
    [anon_sym_CARET] = ACTIONS(3818),
    [anon_sym_AMP] = ACTIONS(3818),
    [anon_sym_this] = ACTIONS(3816),
    [anon_sym_scoped] = ACTIONS(3816),
    [anon_sym_var] = ACTIONS(3816),
    [sym_predefined_type] = ACTIONS(3816),
    [anon_sym_break] = ACTIONS(3816),
    [anon_sym_unchecked] = ACTIONS(3816),
    [anon_sym_continue] = ACTIONS(3816),
    [anon_sym_do] = ACTIONS(3816),
    [anon_sym_while] = ACTIONS(3816),
    [anon_sym_for] = ACTIONS(3816),
    [anon_sym_lock] = ACTIONS(3816),
    [anon_sym_yield] = ACTIONS(3816),
    [anon_sym_switch] = ACTIONS(3816),
    [anon_sym_default] = ACTIONS(3816),
    [anon_sym_throw] = ACTIONS(3816),
    [anon_sym_try] = ACTIONS(3816),
    [anon_sym_when] = ACTIONS(3816),
    [anon_sym_await] = ACTIONS(3816),
    [anon_sym_foreach] = ACTIONS(3816),
    [anon_sym_goto] = ACTIONS(3816),
    [anon_sym_if] = ACTIONS(3816),
    [anon_sym_DOT_DOT] = ACTIONS(3818),
    [anon_sym_from] = ACTIONS(3816),
    [anon_sym_into] = ACTIONS(3816),
    [anon_sym_join] = ACTIONS(3816),
    [anon_sym_on] = ACTIONS(3816),
    [anon_sym_equals] = ACTIONS(3816),
    [anon_sym_let] = ACTIONS(3816),
    [anon_sym_orderby] = ACTIONS(3816),
    [anon_sym_ascending] = ACTIONS(3816),
    [anon_sym_descending] = ACTIONS(3816),
    [anon_sym_group] = ACTIONS(3816),
    [anon_sym_by] = ACTIONS(3816),
    [anon_sym_select] = ACTIONS(3816),
    [anon_sym_DQUOTE] = ACTIONS(3816),
    [anon_sym_stackalloc] = ACTIONS(3816),
    [anon_sym_sizeof] = ACTIONS(3816),
    [anon_sym_typeof] = ACTIONS(3816),
    [anon_sym___makeref] = ACTIONS(3816),
    [anon_sym___reftype] = ACTIONS(3816),
    [anon_sym___refvalue] = ACTIONS(3816),
    [sym_null_literal] = ACTIONS(3816),
    [anon_sym_SQUOTE] = ACTIONS(3818),
    [sym_integer_literal] = ACTIONS(3816),
    [sym_real_literal] = ACTIONS(3818),
    [sym_verbatim_string_literal] = ACTIONS(3818),
    [sym_raw_string_literal] = ACTIONS(3818),
    [aux_sym_preproc_if_token1] = ACTIONS(3818),
    [aux_sym_preproc_if_token3] = ACTIONS(3818),
    [aux_sym_preproc_else_token1] = ACTIONS(3818),
    [aux_sym_preproc_elif_token1] = ACTIONS(3818),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3818),
    [sym_interpolation_verbatim_start] = ACTIONS(3818),
    [sym_interpolation_raw_start] = ACTIONS(3818),
  },
  [2394] = {
    [sym_preproc_region] = STATE(2394),
    [sym_preproc_endregion] = STATE(2394),
    [sym_preproc_line] = STATE(2394),
    [sym_preproc_pragma] = STATE(2394),
    [sym_preproc_nullable] = STATE(2394),
    [sym_preproc_error] = STATE(2394),
    [sym_preproc_define] = STATE(2394),
    [sym_preproc_undef] = STATE(2394),
    [sym__identifier_token] = ACTIONS(3820),
    [anon_sym_extern] = ACTIONS(3820),
    [anon_sym_alias] = ACTIONS(3820),
    [anon_sym_SEMI] = ACTIONS(3822),
    [anon_sym_global] = ACTIONS(3820),
    [anon_sym_using] = ACTIONS(3820),
    [anon_sym_unsafe] = ACTIONS(3820),
    [anon_sym_static] = ACTIONS(3820),
    [anon_sym_LBRACK] = ACTIONS(3822),
    [anon_sym_LPAREN] = ACTIONS(3822),
    [anon_sym_return] = ACTIONS(3820),
    [anon_sym_namespace] = ACTIONS(3820),
    [anon_sym_class] = ACTIONS(3820),
    [anon_sym_ref] = ACTIONS(3820),
    [anon_sym_struct] = ACTIONS(3820),
    [anon_sym_enum] = ACTIONS(3820),
    [anon_sym_LBRACE] = ACTIONS(3822),
    [anon_sym_interface] = ACTIONS(3820),
    [anon_sym_delegate] = ACTIONS(3820),
    [anon_sym_record] = ACTIONS(3820),
    [anon_sym_abstract] = ACTIONS(3820),
    [anon_sym_async] = ACTIONS(3820),
    [anon_sym_const] = ACTIONS(3820),
    [anon_sym_file] = ACTIONS(3820),
    [anon_sym_fixed] = ACTIONS(3820),
    [anon_sym_internal] = ACTIONS(3820),
    [anon_sym_new] = ACTIONS(3820),
    [anon_sym_override] = ACTIONS(3820),
    [anon_sym_partial] = ACTIONS(3820),
    [anon_sym_private] = ACTIONS(3820),
    [anon_sym_protected] = ACTIONS(3820),
    [anon_sym_public] = ACTIONS(3820),
    [anon_sym_readonly] = ACTIONS(3820),
    [anon_sym_required] = ACTIONS(3820),
    [anon_sym_sealed] = ACTIONS(3820),
    [anon_sym_virtual] = ACTIONS(3820),
    [anon_sym_volatile] = ACTIONS(3820),
    [anon_sym_where] = ACTIONS(3820),
    [anon_sym_notnull] = ACTIONS(3820),
    [anon_sym_unmanaged] = ACTIONS(3820),
    [anon_sym_checked] = ACTIONS(3820),
    [anon_sym_BANG] = ACTIONS(3822),
    [anon_sym_TILDE] = ACTIONS(3822),
    [anon_sym_PLUS_PLUS] = ACTIONS(3822),
    [anon_sym_DASH_DASH] = ACTIONS(3822),
    [anon_sym_true] = ACTIONS(3820),
    [anon_sym_false] = ACTIONS(3820),
    [anon_sym_PLUS] = ACTIONS(3820),
    [anon_sym_DASH] = ACTIONS(3820),
    [anon_sym_STAR] = ACTIONS(3822),
    [anon_sym_CARET] = ACTIONS(3822),
    [anon_sym_AMP] = ACTIONS(3822),
    [anon_sym_this] = ACTIONS(3820),
    [anon_sym_scoped] = ACTIONS(3820),
    [anon_sym_var] = ACTIONS(3820),
    [sym_predefined_type] = ACTIONS(3820),
    [anon_sym_break] = ACTIONS(3820),
    [anon_sym_unchecked] = ACTIONS(3820),
    [anon_sym_continue] = ACTIONS(3820),
    [anon_sym_do] = ACTIONS(3820),
    [anon_sym_while] = ACTIONS(3820),
    [anon_sym_for] = ACTIONS(3820),
    [anon_sym_lock] = ACTIONS(3820),
    [anon_sym_yield] = ACTIONS(3820),
    [anon_sym_switch] = ACTIONS(3820),
    [anon_sym_default] = ACTIONS(3820),
    [anon_sym_throw] = ACTIONS(3820),
    [anon_sym_try] = ACTIONS(3820),
    [anon_sym_when] = ACTIONS(3820),
    [anon_sym_await] = ACTIONS(3820),
    [anon_sym_foreach] = ACTIONS(3820),
    [anon_sym_goto] = ACTIONS(3820),
    [anon_sym_if] = ACTIONS(3820),
    [anon_sym_DOT_DOT] = ACTIONS(3822),
    [anon_sym_from] = ACTIONS(3820),
    [anon_sym_into] = ACTIONS(3820),
    [anon_sym_join] = ACTIONS(3820),
    [anon_sym_on] = ACTIONS(3820),
    [anon_sym_equals] = ACTIONS(3820),
    [anon_sym_let] = ACTIONS(3820),
    [anon_sym_orderby] = ACTIONS(3820),
    [anon_sym_ascending] = ACTIONS(3820),
    [anon_sym_descending] = ACTIONS(3820),
    [anon_sym_group] = ACTIONS(3820),
    [anon_sym_by] = ACTIONS(3820),
    [anon_sym_select] = ACTIONS(3820),
    [anon_sym_DQUOTE] = ACTIONS(3820),
    [anon_sym_stackalloc] = ACTIONS(3820),
    [anon_sym_sizeof] = ACTIONS(3820),
    [anon_sym_typeof] = ACTIONS(3820),
    [anon_sym___makeref] = ACTIONS(3820),
    [anon_sym___reftype] = ACTIONS(3820),
    [anon_sym___refvalue] = ACTIONS(3820),
    [sym_null_literal] = ACTIONS(3820),
    [anon_sym_SQUOTE] = ACTIONS(3822),
    [sym_integer_literal] = ACTIONS(3820),
    [sym_real_literal] = ACTIONS(3822),
    [sym_verbatim_string_literal] = ACTIONS(3822),
    [sym_raw_string_literal] = ACTIONS(3822),
    [aux_sym_preproc_if_token1] = ACTIONS(3822),
    [aux_sym_preproc_if_token3] = ACTIONS(3822),
    [aux_sym_preproc_else_token1] = ACTIONS(3822),
    [aux_sym_preproc_elif_token1] = ACTIONS(3822),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3822),
    [sym_interpolation_verbatim_start] = ACTIONS(3822),
    [sym_interpolation_raw_start] = ACTIONS(3822),
  },
  [2395] = {
    [sym_preproc_region] = STATE(2395),
    [sym_preproc_endregion] = STATE(2395),
    [sym_preproc_line] = STATE(2395),
    [sym_preproc_pragma] = STATE(2395),
    [sym_preproc_nullable] = STATE(2395),
    [sym_preproc_error] = STATE(2395),
    [sym_preproc_define] = STATE(2395),
    [sym_preproc_undef] = STATE(2395),
    [sym__identifier_token] = ACTIONS(3824),
    [anon_sym_extern] = ACTIONS(3824),
    [anon_sym_alias] = ACTIONS(3824),
    [anon_sym_SEMI] = ACTIONS(3826),
    [anon_sym_global] = ACTIONS(3824),
    [anon_sym_using] = ACTIONS(3824),
    [anon_sym_unsafe] = ACTIONS(3824),
    [anon_sym_static] = ACTIONS(3824),
    [anon_sym_LBRACK] = ACTIONS(3826),
    [anon_sym_LPAREN] = ACTIONS(3826),
    [anon_sym_return] = ACTIONS(3824),
    [anon_sym_namespace] = ACTIONS(3824),
    [anon_sym_class] = ACTIONS(3824),
    [anon_sym_ref] = ACTIONS(3824),
    [anon_sym_struct] = ACTIONS(3824),
    [anon_sym_enum] = ACTIONS(3824),
    [anon_sym_LBRACE] = ACTIONS(3826),
    [anon_sym_interface] = ACTIONS(3824),
    [anon_sym_delegate] = ACTIONS(3824),
    [anon_sym_record] = ACTIONS(3824),
    [anon_sym_abstract] = ACTIONS(3824),
    [anon_sym_async] = ACTIONS(3824),
    [anon_sym_const] = ACTIONS(3824),
    [anon_sym_file] = ACTIONS(3824),
    [anon_sym_fixed] = ACTIONS(3824),
    [anon_sym_internal] = ACTIONS(3824),
    [anon_sym_new] = ACTIONS(3824),
    [anon_sym_override] = ACTIONS(3824),
    [anon_sym_partial] = ACTIONS(3824),
    [anon_sym_private] = ACTIONS(3824),
    [anon_sym_protected] = ACTIONS(3824),
    [anon_sym_public] = ACTIONS(3824),
    [anon_sym_readonly] = ACTIONS(3824),
    [anon_sym_required] = ACTIONS(3824),
    [anon_sym_sealed] = ACTIONS(3824),
    [anon_sym_virtual] = ACTIONS(3824),
    [anon_sym_volatile] = ACTIONS(3824),
    [anon_sym_where] = ACTIONS(3824),
    [anon_sym_notnull] = ACTIONS(3824),
    [anon_sym_unmanaged] = ACTIONS(3824),
    [anon_sym_checked] = ACTIONS(3824),
    [anon_sym_BANG] = ACTIONS(3826),
    [anon_sym_TILDE] = ACTIONS(3826),
    [anon_sym_PLUS_PLUS] = ACTIONS(3826),
    [anon_sym_DASH_DASH] = ACTIONS(3826),
    [anon_sym_true] = ACTIONS(3824),
    [anon_sym_false] = ACTIONS(3824),
    [anon_sym_PLUS] = ACTIONS(3824),
    [anon_sym_DASH] = ACTIONS(3824),
    [anon_sym_STAR] = ACTIONS(3826),
    [anon_sym_CARET] = ACTIONS(3826),
    [anon_sym_AMP] = ACTIONS(3826),
    [anon_sym_this] = ACTIONS(3824),
    [anon_sym_scoped] = ACTIONS(3824),
    [anon_sym_var] = ACTIONS(3824),
    [sym_predefined_type] = ACTIONS(3824),
    [anon_sym_break] = ACTIONS(3824),
    [anon_sym_unchecked] = ACTIONS(3824),
    [anon_sym_continue] = ACTIONS(3824),
    [anon_sym_do] = ACTIONS(3824),
    [anon_sym_while] = ACTIONS(3824),
    [anon_sym_for] = ACTIONS(3824),
    [anon_sym_lock] = ACTIONS(3824),
    [anon_sym_yield] = ACTIONS(3824),
    [anon_sym_switch] = ACTIONS(3824),
    [anon_sym_default] = ACTIONS(3824),
    [anon_sym_throw] = ACTIONS(3824),
    [anon_sym_try] = ACTIONS(3824),
    [anon_sym_when] = ACTIONS(3824),
    [anon_sym_await] = ACTIONS(3824),
    [anon_sym_foreach] = ACTIONS(3824),
    [anon_sym_goto] = ACTIONS(3824),
    [anon_sym_if] = ACTIONS(3824),
    [anon_sym_DOT_DOT] = ACTIONS(3826),
    [anon_sym_from] = ACTIONS(3824),
    [anon_sym_into] = ACTIONS(3824),
    [anon_sym_join] = ACTIONS(3824),
    [anon_sym_on] = ACTIONS(3824),
    [anon_sym_equals] = ACTIONS(3824),
    [anon_sym_let] = ACTIONS(3824),
    [anon_sym_orderby] = ACTIONS(3824),
    [anon_sym_ascending] = ACTIONS(3824),
    [anon_sym_descending] = ACTIONS(3824),
    [anon_sym_group] = ACTIONS(3824),
    [anon_sym_by] = ACTIONS(3824),
    [anon_sym_select] = ACTIONS(3824),
    [anon_sym_DQUOTE] = ACTIONS(3824),
    [anon_sym_stackalloc] = ACTIONS(3824),
    [anon_sym_sizeof] = ACTIONS(3824),
    [anon_sym_typeof] = ACTIONS(3824),
    [anon_sym___makeref] = ACTIONS(3824),
    [anon_sym___reftype] = ACTIONS(3824),
    [anon_sym___refvalue] = ACTIONS(3824),
    [sym_null_literal] = ACTIONS(3824),
    [anon_sym_SQUOTE] = ACTIONS(3826),
    [sym_integer_literal] = ACTIONS(3824),
    [sym_real_literal] = ACTIONS(3826),
    [sym_verbatim_string_literal] = ACTIONS(3826),
    [sym_raw_string_literal] = ACTIONS(3826),
    [aux_sym_preproc_if_token1] = ACTIONS(3826),
    [aux_sym_preproc_if_token3] = ACTIONS(3826),
    [aux_sym_preproc_else_token1] = ACTIONS(3826),
    [aux_sym_preproc_elif_token1] = ACTIONS(3826),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3826),
    [sym_interpolation_verbatim_start] = ACTIONS(3826),
    [sym_interpolation_raw_start] = ACTIONS(3826),
  },
  [2396] = {
    [sym_preproc_region] = STATE(2396),
    [sym_preproc_endregion] = STATE(2396),
    [sym_preproc_line] = STATE(2396),
    [sym_preproc_pragma] = STATE(2396),
    [sym_preproc_nullable] = STATE(2396),
    [sym_preproc_error] = STATE(2396),
    [sym_preproc_define] = STATE(2396),
    [sym_preproc_undef] = STATE(2396),
    [sym__identifier_token] = ACTIONS(3828),
    [anon_sym_extern] = ACTIONS(3828),
    [anon_sym_alias] = ACTIONS(3828),
    [anon_sym_SEMI] = ACTIONS(3830),
    [anon_sym_global] = ACTIONS(3828),
    [anon_sym_using] = ACTIONS(3828),
    [anon_sym_unsafe] = ACTIONS(3828),
    [anon_sym_static] = ACTIONS(3828),
    [anon_sym_LBRACK] = ACTIONS(3830),
    [anon_sym_LPAREN] = ACTIONS(3830),
    [anon_sym_return] = ACTIONS(3828),
    [anon_sym_namespace] = ACTIONS(3828),
    [anon_sym_class] = ACTIONS(3828),
    [anon_sym_ref] = ACTIONS(3828),
    [anon_sym_struct] = ACTIONS(3828),
    [anon_sym_enum] = ACTIONS(3828),
    [anon_sym_LBRACE] = ACTIONS(3830),
    [anon_sym_interface] = ACTIONS(3828),
    [anon_sym_delegate] = ACTIONS(3828),
    [anon_sym_record] = ACTIONS(3828),
    [anon_sym_abstract] = ACTIONS(3828),
    [anon_sym_async] = ACTIONS(3828),
    [anon_sym_const] = ACTIONS(3828),
    [anon_sym_file] = ACTIONS(3828),
    [anon_sym_fixed] = ACTIONS(3828),
    [anon_sym_internal] = ACTIONS(3828),
    [anon_sym_new] = ACTIONS(3828),
    [anon_sym_override] = ACTIONS(3828),
    [anon_sym_partial] = ACTIONS(3828),
    [anon_sym_private] = ACTIONS(3828),
    [anon_sym_protected] = ACTIONS(3828),
    [anon_sym_public] = ACTIONS(3828),
    [anon_sym_readonly] = ACTIONS(3828),
    [anon_sym_required] = ACTIONS(3828),
    [anon_sym_sealed] = ACTIONS(3828),
    [anon_sym_virtual] = ACTIONS(3828),
    [anon_sym_volatile] = ACTIONS(3828),
    [anon_sym_where] = ACTIONS(3828),
    [anon_sym_notnull] = ACTIONS(3828),
    [anon_sym_unmanaged] = ACTIONS(3828),
    [anon_sym_checked] = ACTIONS(3828),
    [anon_sym_BANG] = ACTIONS(3830),
    [anon_sym_TILDE] = ACTIONS(3830),
    [anon_sym_PLUS_PLUS] = ACTIONS(3830),
    [anon_sym_DASH_DASH] = ACTIONS(3830),
    [anon_sym_true] = ACTIONS(3828),
    [anon_sym_false] = ACTIONS(3828),
    [anon_sym_PLUS] = ACTIONS(3828),
    [anon_sym_DASH] = ACTIONS(3828),
    [anon_sym_STAR] = ACTIONS(3830),
    [anon_sym_CARET] = ACTIONS(3830),
    [anon_sym_AMP] = ACTIONS(3830),
    [anon_sym_this] = ACTIONS(3828),
    [anon_sym_scoped] = ACTIONS(3828),
    [anon_sym_var] = ACTIONS(3828),
    [sym_predefined_type] = ACTIONS(3828),
    [anon_sym_break] = ACTIONS(3828),
    [anon_sym_unchecked] = ACTIONS(3828),
    [anon_sym_continue] = ACTIONS(3828),
    [anon_sym_do] = ACTIONS(3828),
    [anon_sym_while] = ACTIONS(3828),
    [anon_sym_for] = ACTIONS(3828),
    [anon_sym_lock] = ACTIONS(3828),
    [anon_sym_yield] = ACTIONS(3828),
    [anon_sym_switch] = ACTIONS(3828),
    [anon_sym_default] = ACTIONS(3828),
    [anon_sym_throw] = ACTIONS(3828),
    [anon_sym_try] = ACTIONS(3828),
    [anon_sym_when] = ACTIONS(3828),
    [anon_sym_await] = ACTIONS(3828),
    [anon_sym_foreach] = ACTIONS(3828),
    [anon_sym_goto] = ACTIONS(3828),
    [anon_sym_if] = ACTIONS(3828),
    [anon_sym_DOT_DOT] = ACTIONS(3830),
    [anon_sym_from] = ACTIONS(3828),
    [anon_sym_into] = ACTIONS(3828),
    [anon_sym_join] = ACTIONS(3828),
    [anon_sym_on] = ACTIONS(3828),
    [anon_sym_equals] = ACTIONS(3828),
    [anon_sym_let] = ACTIONS(3828),
    [anon_sym_orderby] = ACTIONS(3828),
    [anon_sym_ascending] = ACTIONS(3828),
    [anon_sym_descending] = ACTIONS(3828),
    [anon_sym_group] = ACTIONS(3828),
    [anon_sym_by] = ACTIONS(3828),
    [anon_sym_select] = ACTIONS(3828),
    [anon_sym_DQUOTE] = ACTIONS(3828),
    [anon_sym_stackalloc] = ACTIONS(3828),
    [anon_sym_sizeof] = ACTIONS(3828),
    [anon_sym_typeof] = ACTIONS(3828),
    [anon_sym___makeref] = ACTIONS(3828),
    [anon_sym___reftype] = ACTIONS(3828),
    [anon_sym___refvalue] = ACTIONS(3828),
    [sym_null_literal] = ACTIONS(3828),
    [anon_sym_SQUOTE] = ACTIONS(3830),
    [sym_integer_literal] = ACTIONS(3828),
    [sym_real_literal] = ACTIONS(3830),
    [sym_verbatim_string_literal] = ACTIONS(3830),
    [sym_raw_string_literal] = ACTIONS(3830),
    [aux_sym_preproc_if_token1] = ACTIONS(3830),
    [aux_sym_preproc_if_token3] = ACTIONS(3830),
    [aux_sym_preproc_else_token1] = ACTIONS(3830),
    [aux_sym_preproc_elif_token1] = ACTIONS(3830),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3830),
    [sym_interpolation_verbatim_start] = ACTIONS(3830),
    [sym_interpolation_raw_start] = ACTIONS(3830),
  },
  [2397] = {
    [sym_preproc_region] = STATE(2397),
    [sym_preproc_endregion] = STATE(2397),
    [sym_preproc_line] = STATE(2397),
    [sym_preproc_pragma] = STATE(2397),
    [sym_preproc_nullable] = STATE(2397),
    [sym_preproc_error] = STATE(2397),
    [sym_preproc_define] = STATE(2397),
    [sym_preproc_undef] = STATE(2397),
    [sym__identifier_token] = ACTIONS(3832),
    [anon_sym_extern] = ACTIONS(3832),
    [anon_sym_alias] = ACTIONS(3832),
    [anon_sym_SEMI] = ACTIONS(3834),
    [anon_sym_global] = ACTIONS(3832),
    [anon_sym_using] = ACTIONS(3832),
    [anon_sym_unsafe] = ACTIONS(3832),
    [anon_sym_static] = ACTIONS(3832),
    [anon_sym_LBRACK] = ACTIONS(3834),
    [anon_sym_LPAREN] = ACTIONS(3834),
    [anon_sym_return] = ACTIONS(3832),
    [anon_sym_namespace] = ACTIONS(3832),
    [anon_sym_class] = ACTIONS(3832),
    [anon_sym_ref] = ACTIONS(3832),
    [anon_sym_struct] = ACTIONS(3832),
    [anon_sym_enum] = ACTIONS(3832),
    [anon_sym_LBRACE] = ACTIONS(3834),
    [anon_sym_interface] = ACTIONS(3832),
    [anon_sym_delegate] = ACTIONS(3832),
    [anon_sym_record] = ACTIONS(3832),
    [anon_sym_abstract] = ACTIONS(3832),
    [anon_sym_async] = ACTIONS(3832),
    [anon_sym_const] = ACTIONS(3832),
    [anon_sym_file] = ACTIONS(3832),
    [anon_sym_fixed] = ACTIONS(3832),
    [anon_sym_internal] = ACTIONS(3832),
    [anon_sym_new] = ACTIONS(3832),
    [anon_sym_override] = ACTIONS(3832),
    [anon_sym_partial] = ACTIONS(3832),
    [anon_sym_private] = ACTIONS(3832),
    [anon_sym_protected] = ACTIONS(3832),
    [anon_sym_public] = ACTIONS(3832),
    [anon_sym_readonly] = ACTIONS(3832),
    [anon_sym_required] = ACTIONS(3832),
    [anon_sym_sealed] = ACTIONS(3832),
    [anon_sym_virtual] = ACTIONS(3832),
    [anon_sym_volatile] = ACTIONS(3832),
    [anon_sym_where] = ACTIONS(3832),
    [anon_sym_notnull] = ACTIONS(3832),
    [anon_sym_unmanaged] = ACTIONS(3832),
    [anon_sym_checked] = ACTIONS(3832),
    [anon_sym_BANG] = ACTIONS(3834),
    [anon_sym_TILDE] = ACTIONS(3834),
    [anon_sym_PLUS_PLUS] = ACTIONS(3834),
    [anon_sym_DASH_DASH] = ACTIONS(3834),
    [anon_sym_true] = ACTIONS(3832),
    [anon_sym_false] = ACTIONS(3832),
    [anon_sym_PLUS] = ACTIONS(3832),
    [anon_sym_DASH] = ACTIONS(3832),
    [anon_sym_STAR] = ACTIONS(3834),
    [anon_sym_CARET] = ACTIONS(3834),
    [anon_sym_AMP] = ACTIONS(3834),
    [anon_sym_this] = ACTIONS(3832),
    [anon_sym_scoped] = ACTIONS(3832),
    [anon_sym_var] = ACTIONS(3832),
    [sym_predefined_type] = ACTIONS(3832),
    [anon_sym_break] = ACTIONS(3832),
    [anon_sym_unchecked] = ACTIONS(3832),
    [anon_sym_continue] = ACTIONS(3832),
    [anon_sym_do] = ACTIONS(3832),
    [anon_sym_while] = ACTIONS(3832),
    [anon_sym_for] = ACTIONS(3832),
    [anon_sym_lock] = ACTIONS(3832),
    [anon_sym_yield] = ACTIONS(3832),
    [anon_sym_switch] = ACTIONS(3832),
    [anon_sym_default] = ACTIONS(3832),
    [anon_sym_throw] = ACTIONS(3832),
    [anon_sym_try] = ACTIONS(3832),
    [anon_sym_when] = ACTIONS(3832),
    [anon_sym_await] = ACTIONS(3832),
    [anon_sym_foreach] = ACTIONS(3832),
    [anon_sym_goto] = ACTIONS(3832),
    [anon_sym_if] = ACTIONS(3832),
    [anon_sym_DOT_DOT] = ACTIONS(3834),
    [anon_sym_from] = ACTIONS(3832),
    [anon_sym_into] = ACTIONS(3832),
    [anon_sym_join] = ACTIONS(3832),
    [anon_sym_on] = ACTIONS(3832),
    [anon_sym_equals] = ACTIONS(3832),
    [anon_sym_let] = ACTIONS(3832),
    [anon_sym_orderby] = ACTIONS(3832),
    [anon_sym_ascending] = ACTIONS(3832),
    [anon_sym_descending] = ACTIONS(3832),
    [anon_sym_group] = ACTIONS(3832),
    [anon_sym_by] = ACTIONS(3832),
    [anon_sym_select] = ACTIONS(3832),
    [anon_sym_DQUOTE] = ACTIONS(3832),
    [anon_sym_stackalloc] = ACTIONS(3832),
    [anon_sym_sizeof] = ACTIONS(3832),
    [anon_sym_typeof] = ACTIONS(3832),
    [anon_sym___makeref] = ACTIONS(3832),
    [anon_sym___reftype] = ACTIONS(3832),
    [anon_sym___refvalue] = ACTIONS(3832),
    [sym_null_literal] = ACTIONS(3832),
    [anon_sym_SQUOTE] = ACTIONS(3834),
    [sym_integer_literal] = ACTIONS(3832),
    [sym_real_literal] = ACTIONS(3834),
    [sym_verbatim_string_literal] = ACTIONS(3834),
    [sym_raw_string_literal] = ACTIONS(3834),
    [aux_sym_preproc_if_token1] = ACTIONS(3834),
    [aux_sym_preproc_if_token3] = ACTIONS(3834),
    [aux_sym_preproc_else_token1] = ACTIONS(3834),
    [aux_sym_preproc_elif_token1] = ACTIONS(3834),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3834),
    [sym_interpolation_verbatim_start] = ACTIONS(3834),
    [sym_interpolation_raw_start] = ACTIONS(3834),
  },
  [2398] = {
    [sym_preproc_region] = STATE(2398),
    [sym_preproc_endregion] = STATE(2398),
    [sym_preproc_line] = STATE(2398),
    [sym_preproc_pragma] = STATE(2398),
    [sym_preproc_nullable] = STATE(2398),
    [sym_preproc_error] = STATE(2398),
    [sym_preproc_define] = STATE(2398),
    [sym_preproc_undef] = STATE(2398),
    [sym__identifier_token] = ACTIONS(3836),
    [anon_sym_extern] = ACTIONS(3836),
    [anon_sym_alias] = ACTIONS(3836),
    [anon_sym_SEMI] = ACTIONS(3838),
    [anon_sym_global] = ACTIONS(3836),
    [anon_sym_using] = ACTIONS(3836),
    [anon_sym_unsafe] = ACTIONS(3836),
    [anon_sym_static] = ACTIONS(3836),
    [anon_sym_LBRACK] = ACTIONS(3838),
    [anon_sym_LPAREN] = ACTIONS(3838),
    [anon_sym_return] = ACTIONS(3836),
    [anon_sym_namespace] = ACTIONS(3836),
    [anon_sym_class] = ACTIONS(3836),
    [anon_sym_ref] = ACTIONS(3836),
    [anon_sym_struct] = ACTIONS(3836),
    [anon_sym_enum] = ACTIONS(3836),
    [anon_sym_LBRACE] = ACTIONS(3838),
    [anon_sym_interface] = ACTIONS(3836),
    [anon_sym_delegate] = ACTIONS(3836),
    [anon_sym_record] = ACTIONS(3836),
    [anon_sym_abstract] = ACTIONS(3836),
    [anon_sym_async] = ACTIONS(3836),
    [anon_sym_const] = ACTIONS(3836),
    [anon_sym_file] = ACTIONS(3836),
    [anon_sym_fixed] = ACTIONS(3836),
    [anon_sym_internal] = ACTIONS(3836),
    [anon_sym_new] = ACTIONS(3836),
    [anon_sym_override] = ACTIONS(3836),
    [anon_sym_partial] = ACTIONS(3836),
    [anon_sym_private] = ACTIONS(3836),
    [anon_sym_protected] = ACTIONS(3836),
    [anon_sym_public] = ACTIONS(3836),
    [anon_sym_readonly] = ACTIONS(3836),
    [anon_sym_required] = ACTIONS(3836),
    [anon_sym_sealed] = ACTIONS(3836),
    [anon_sym_virtual] = ACTIONS(3836),
    [anon_sym_volatile] = ACTIONS(3836),
    [anon_sym_where] = ACTIONS(3836),
    [anon_sym_notnull] = ACTIONS(3836),
    [anon_sym_unmanaged] = ACTIONS(3836),
    [anon_sym_checked] = ACTIONS(3836),
    [anon_sym_BANG] = ACTIONS(3838),
    [anon_sym_TILDE] = ACTIONS(3838),
    [anon_sym_PLUS_PLUS] = ACTIONS(3838),
    [anon_sym_DASH_DASH] = ACTIONS(3838),
    [anon_sym_true] = ACTIONS(3836),
    [anon_sym_false] = ACTIONS(3836),
    [anon_sym_PLUS] = ACTIONS(3836),
    [anon_sym_DASH] = ACTIONS(3836),
    [anon_sym_STAR] = ACTIONS(3838),
    [anon_sym_CARET] = ACTIONS(3838),
    [anon_sym_AMP] = ACTIONS(3838),
    [anon_sym_this] = ACTIONS(3836),
    [anon_sym_scoped] = ACTIONS(3836),
    [anon_sym_var] = ACTIONS(3836),
    [sym_predefined_type] = ACTIONS(3836),
    [anon_sym_break] = ACTIONS(3836),
    [anon_sym_unchecked] = ACTIONS(3836),
    [anon_sym_continue] = ACTIONS(3836),
    [anon_sym_do] = ACTIONS(3836),
    [anon_sym_while] = ACTIONS(3836),
    [anon_sym_for] = ACTIONS(3836),
    [anon_sym_lock] = ACTIONS(3836),
    [anon_sym_yield] = ACTIONS(3836),
    [anon_sym_switch] = ACTIONS(3836),
    [anon_sym_default] = ACTIONS(3836),
    [anon_sym_throw] = ACTIONS(3836),
    [anon_sym_try] = ACTIONS(3836),
    [anon_sym_when] = ACTIONS(3836),
    [anon_sym_await] = ACTIONS(3836),
    [anon_sym_foreach] = ACTIONS(3836),
    [anon_sym_goto] = ACTIONS(3836),
    [anon_sym_if] = ACTIONS(3836),
    [anon_sym_DOT_DOT] = ACTIONS(3838),
    [anon_sym_from] = ACTIONS(3836),
    [anon_sym_into] = ACTIONS(3836),
    [anon_sym_join] = ACTIONS(3836),
    [anon_sym_on] = ACTIONS(3836),
    [anon_sym_equals] = ACTIONS(3836),
    [anon_sym_let] = ACTIONS(3836),
    [anon_sym_orderby] = ACTIONS(3836),
    [anon_sym_ascending] = ACTIONS(3836),
    [anon_sym_descending] = ACTIONS(3836),
    [anon_sym_group] = ACTIONS(3836),
    [anon_sym_by] = ACTIONS(3836),
    [anon_sym_select] = ACTIONS(3836),
    [anon_sym_DQUOTE] = ACTIONS(3836),
    [anon_sym_stackalloc] = ACTIONS(3836),
    [anon_sym_sizeof] = ACTIONS(3836),
    [anon_sym_typeof] = ACTIONS(3836),
    [anon_sym___makeref] = ACTIONS(3836),
    [anon_sym___reftype] = ACTIONS(3836),
    [anon_sym___refvalue] = ACTIONS(3836),
    [sym_null_literal] = ACTIONS(3836),
    [anon_sym_SQUOTE] = ACTIONS(3838),
    [sym_integer_literal] = ACTIONS(3836),
    [sym_real_literal] = ACTIONS(3838),
    [sym_verbatim_string_literal] = ACTIONS(3838),
    [sym_raw_string_literal] = ACTIONS(3838),
    [aux_sym_preproc_if_token1] = ACTIONS(3838),
    [aux_sym_preproc_if_token3] = ACTIONS(3838),
    [aux_sym_preproc_else_token1] = ACTIONS(3838),
    [aux_sym_preproc_elif_token1] = ACTIONS(3838),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3838),
    [sym_interpolation_verbatim_start] = ACTIONS(3838),
    [sym_interpolation_raw_start] = ACTIONS(3838),
  },
  [2399] = {
    [sym_preproc_region] = STATE(2399),
    [sym_preproc_endregion] = STATE(2399),
    [sym_preproc_line] = STATE(2399),
    [sym_preproc_pragma] = STATE(2399),
    [sym_preproc_nullable] = STATE(2399),
    [sym_preproc_error] = STATE(2399),
    [sym_preproc_define] = STATE(2399),
    [sym_preproc_undef] = STATE(2399),
    [sym__identifier_token] = ACTIONS(3840),
    [anon_sym_extern] = ACTIONS(3840),
    [anon_sym_alias] = ACTIONS(3840),
    [anon_sym_SEMI] = ACTIONS(3842),
    [anon_sym_global] = ACTIONS(3840),
    [anon_sym_using] = ACTIONS(3840),
    [anon_sym_unsafe] = ACTIONS(3840),
    [anon_sym_static] = ACTIONS(3840),
    [anon_sym_LBRACK] = ACTIONS(3842),
    [anon_sym_LPAREN] = ACTIONS(3842),
    [anon_sym_return] = ACTIONS(3840),
    [anon_sym_namespace] = ACTIONS(3840),
    [anon_sym_class] = ACTIONS(3840),
    [anon_sym_ref] = ACTIONS(3840),
    [anon_sym_struct] = ACTIONS(3840),
    [anon_sym_enum] = ACTIONS(3840),
    [anon_sym_LBRACE] = ACTIONS(3842),
    [anon_sym_interface] = ACTIONS(3840),
    [anon_sym_delegate] = ACTIONS(3840),
    [anon_sym_record] = ACTIONS(3840),
    [anon_sym_abstract] = ACTIONS(3840),
    [anon_sym_async] = ACTIONS(3840),
    [anon_sym_const] = ACTIONS(3840),
    [anon_sym_file] = ACTIONS(3840),
    [anon_sym_fixed] = ACTIONS(3840),
    [anon_sym_internal] = ACTIONS(3840),
    [anon_sym_new] = ACTIONS(3840),
    [anon_sym_override] = ACTIONS(3840),
    [anon_sym_partial] = ACTIONS(3840),
    [anon_sym_private] = ACTIONS(3840),
    [anon_sym_protected] = ACTIONS(3840),
    [anon_sym_public] = ACTIONS(3840),
    [anon_sym_readonly] = ACTIONS(3840),
    [anon_sym_required] = ACTIONS(3840),
    [anon_sym_sealed] = ACTIONS(3840),
    [anon_sym_virtual] = ACTIONS(3840),
    [anon_sym_volatile] = ACTIONS(3840),
    [anon_sym_where] = ACTIONS(3840),
    [anon_sym_notnull] = ACTIONS(3840),
    [anon_sym_unmanaged] = ACTIONS(3840),
    [anon_sym_checked] = ACTIONS(3840),
    [anon_sym_BANG] = ACTIONS(3842),
    [anon_sym_TILDE] = ACTIONS(3842),
    [anon_sym_PLUS_PLUS] = ACTIONS(3842),
    [anon_sym_DASH_DASH] = ACTIONS(3842),
    [anon_sym_true] = ACTIONS(3840),
    [anon_sym_false] = ACTIONS(3840),
    [anon_sym_PLUS] = ACTIONS(3840),
    [anon_sym_DASH] = ACTIONS(3840),
    [anon_sym_STAR] = ACTIONS(3842),
    [anon_sym_CARET] = ACTIONS(3842),
    [anon_sym_AMP] = ACTIONS(3842),
    [anon_sym_this] = ACTIONS(3840),
    [anon_sym_scoped] = ACTIONS(3840),
    [anon_sym_var] = ACTIONS(3840),
    [sym_predefined_type] = ACTIONS(3840),
    [anon_sym_break] = ACTIONS(3840),
    [anon_sym_unchecked] = ACTIONS(3840),
    [anon_sym_continue] = ACTIONS(3840),
    [anon_sym_do] = ACTIONS(3840),
    [anon_sym_while] = ACTIONS(3840),
    [anon_sym_for] = ACTIONS(3840),
    [anon_sym_lock] = ACTIONS(3840),
    [anon_sym_yield] = ACTIONS(3840),
    [anon_sym_switch] = ACTIONS(3840),
    [anon_sym_default] = ACTIONS(3840),
    [anon_sym_throw] = ACTIONS(3840),
    [anon_sym_try] = ACTIONS(3840),
    [anon_sym_when] = ACTIONS(3840),
    [anon_sym_await] = ACTIONS(3840),
    [anon_sym_foreach] = ACTIONS(3840),
    [anon_sym_goto] = ACTIONS(3840),
    [anon_sym_if] = ACTIONS(3840),
    [anon_sym_DOT_DOT] = ACTIONS(3842),
    [anon_sym_from] = ACTIONS(3840),
    [anon_sym_into] = ACTIONS(3840),
    [anon_sym_join] = ACTIONS(3840),
    [anon_sym_on] = ACTIONS(3840),
    [anon_sym_equals] = ACTIONS(3840),
    [anon_sym_let] = ACTIONS(3840),
    [anon_sym_orderby] = ACTIONS(3840),
    [anon_sym_ascending] = ACTIONS(3840),
    [anon_sym_descending] = ACTIONS(3840),
    [anon_sym_group] = ACTIONS(3840),
    [anon_sym_by] = ACTIONS(3840),
    [anon_sym_select] = ACTIONS(3840),
    [anon_sym_DQUOTE] = ACTIONS(3840),
    [anon_sym_stackalloc] = ACTIONS(3840),
    [anon_sym_sizeof] = ACTIONS(3840),
    [anon_sym_typeof] = ACTIONS(3840),
    [anon_sym___makeref] = ACTIONS(3840),
    [anon_sym___reftype] = ACTIONS(3840),
    [anon_sym___refvalue] = ACTIONS(3840),
    [sym_null_literal] = ACTIONS(3840),
    [anon_sym_SQUOTE] = ACTIONS(3842),
    [sym_integer_literal] = ACTIONS(3840),
    [sym_real_literal] = ACTIONS(3842),
    [sym_verbatim_string_literal] = ACTIONS(3842),
    [sym_raw_string_literal] = ACTIONS(3842),
    [aux_sym_preproc_if_token1] = ACTIONS(3842),
    [aux_sym_preproc_if_token3] = ACTIONS(3842),
    [aux_sym_preproc_else_token1] = ACTIONS(3842),
    [aux_sym_preproc_elif_token1] = ACTIONS(3842),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3842),
    [sym_interpolation_verbatim_start] = ACTIONS(3842),
    [sym_interpolation_raw_start] = ACTIONS(3842),
  },
  [2400] = {
    [sym_preproc_region] = STATE(2400),
    [sym_preproc_endregion] = STATE(2400),
    [sym_preproc_line] = STATE(2400),
    [sym_preproc_pragma] = STATE(2400),
    [sym_preproc_nullable] = STATE(2400),
    [sym_preproc_error] = STATE(2400),
    [sym_preproc_define] = STATE(2400),
    [sym_preproc_undef] = STATE(2400),
    [sym__identifier_token] = ACTIONS(3844),
    [anon_sym_extern] = ACTIONS(3844),
    [anon_sym_alias] = ACTIONS(3844),
    [anon_sym_SEMI] = ACTIONS(3846),
    [anon_sym_global] = ACTIONS(3844),
    [anon_sym_using] = ACTIONS(3844),
    [anon_sym_unsafe] = ACTIONS(3844),
    [anon_sym_static] = ACTIONS(3844),
    [anon_sym_LBRACK] = ACTIONS(3846),
    [anon_sym_LPAREN] = ACTIONS(3846),
    [anon_sym_return] = ACTIONS(3844),
    [anon_sym_namespace] = ACTIONS(3844),
    [anon_sym_class] = ACTIONS(3844),
    [anon_sym_ref] = ACTIONS(3844),
    [anon_sym_struct] = ACTIONS(3844),
    [anon_sym_enum] = ACTIONS(3844),
    [anon_sym_LBRACE] = ACTIONS(3846),
    [anon_sym_interface] = ACTIONS(3844),
    [anon_sym_delegate] = ACTIONS(3844),
    [anon_sym_record] = ACTIONS(3844),
    [anon_sym_abstract] = ACTIONS(3844),
    [anon_sym_async] = ACTIONS(3844),
    [anon_sym_const] = ACTIONS(3844),
    [anon_sym_file] = ACTIONS(3844),
    [anon_sym_fixed] = ACTIONS(3844),
    [anon_sym_internal] = ACTIONS(3844),
    [anon_sym_new] = ACTIONS(3844),
    [anon_sym_override] = ACTIONS(3844),
    [anon_sym_partial] = ACTIONS(3844),
    [anon_sym_private] = ACTIONS(3844),
    [anon_sym_protected] = ACTIONS(3844),
    [anon_sym_public] = ACTIONS(3844),
    [anon_sym_readonly] = ACTIONS(3844),
    [anon_sym_required] = ACTIONS(3844),
    [anon_sym_sealed] = ACTIONS(3844),
    [anon_sym_virtual] = ACTIONS(3844),
    [anon_sym_volatile] = ACTIONS(3844),
    [anon_sym_where] = ACTIONS(3844),
    [anon_sym_notnull] = ACTIONS(3844),
    [anon_sym_unmanaged] = ACTIONS(3844),
    [anon_sym_checked] = ACTIONS(3844),
    [anon_sym_BANG] = ACTIONS(3846),
    [anon_sym_TILDE] = ACTIONS(3846),
    [anon_sym_PLUS_PLUS] = ACTIONS(3846),
    [anon_sym_DASH_DASH] = ACTIONS(3846),
    [anon_sym_true] = ACTIONS(3844),
    [anon_sym_false] = ACTIONS(3844),
    [anon_sym_PLUS] = ACTIONS(3844),
    [anon_sym_DASH] = ACTIONS(3844),
    [anon_sym_STAR] = ACTIONS(3846),
    [anon_sym_CARET] = ACTIONS(3846),
    [anon_sym_AMP] = ACTIONS(3846),
    [anon_sym_this] = ACTIONS(3844),
    [anon_sym_scoped] = ACTIONS(3844),
    [anon_sym_var] = ACTIONS(3844),
    [sym_predefined_type] = ACTIONS(3844),
    [anon_sym_break] = ACTIONS(3844),
    [anon_sym_unchecked] = ACTIONS(3844),
    [anon_sym_continue] = ACTIONS(3844),
    [anon_sym_do] = ACTIONS(3844),
    [anon_sym_while] = ACTIONS(3844),
    [anon_sym_for] = ACTIONS(3844),
    [anon_sym_lock] = ACTIONS(3844),
    [anon_sym_yield] = ACTIONS(3844),
    [anon_sym_switch] = ACTIONS(3844),
    [anon_sym_default] = ACTIONS(3844),
    [anon_sym_throw] = ACTIONS(3844),
    [anon_sym_try] = ACTIONS(3844),
    [anon_sym_when] = ACTIONS(3844),
    [anon_sym_await] = ACTIONS(3844),
    [anon_sym_foreach] = ACTIONS(3844),
    [anon_sym_goto] = ACTIONS(3844),
    [anon_sym_if] = ACTIONS(3844),
    [anon_sym_DOT_DOT] = ACTIONS(3846),
    [anon_sym_from] = ACTIONS(3844),
    [anon_sym_into] = ACTIONS(3844),
    [anon_sym_join] = ACTIONS(3844),
    [anon_sym_on] = ACTIONS(3844),
    [anon_sym_equals] = ACTIONS(3844),
    [anon_sym_let] = ACTIONS(3844),
    [anon_sym_orderby] = ACTIONS(3844),
    [anon_sym_ascending] = ACTIONS(3844),
    [anon_sym_descending] = ACTIONS(3844),
    [anon_sym_group] = ACTIONS(3844),
    [anon_sym_by] = ACTIONS(3844),
    [anon_sym_select] = ACTIONS(3844),
    [anon_sym_DQUOTE] = ACTIONS(3844),
    [anon_sym_stackalloc] = ACTIONS(3844),
    [anon_sym_sizeof] = ACTIONS(3844),
    [anon_sym_typeof] = ACTIONS(3844),
    [anon_sym___makeref] = ACTIONS(3844),
    [anon_sym___reftype] = ACTIONS(3844),
    [anon_sym___refvalue] = ACTIONS(3844),
    [sym_null_literal] = ACTIONS(3844),
    [anon_sym_SQUOTE] = ACTIONS(3846),
    [sym_integer_literal] = ACTIONS(3844),
    [sym_real_literal] = ACTIONS(3846),
    [sym_verbatim_string_literal] = ACTIONS(3846),
    [sym_raw_string_literal] = ACTIONS(3846),
    [aux_sym_preproc_if_token1] = ACTIONS(3846),
    [aux_sym_preproc_if_token3] = ACTIONS(3846),
    [aux_sym_preproc_else_token1] = ACTIONS(3846),
    [aux_sym_preproc_elif_token1] = ACTIONS(3846),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3846),
    [sym_interpolation_verbatim_start] = ACTIONS(3846),
    [sym_interpolation_raw_start] = ACTIONS(3846),
  },
  [2401] = {
    [sym_preproc_region] = STATE(2401),
    [sym_preproc_endregion] = STATE(2401),
    [sym_preproc_line] = STATE(2401),
    [sym_preproc_pragma] = STATE(2401),
    [sym_preproc_nullable] = STATE(2401),
    [sym_preproc_error] = STATE(2401),
    [sym_preproc_define] = STATE(2401),
    [sym_preproc_undef] = STATE(2401),
    [sym__identifier_token] = ACTIONS(3848),
    [anon_sym_extern] = ACTIONS(3848),
    [anon_sym_alias] = ACTIONS(3848),
    [anon_sym_SEMI] = ACTIONS(3850),
    [anon_sym_global] = ACTIONS(3848),
    [anon_sym_using] = ACTIONS(3848),
    [anon_sym_unsafe] = ACTIONS(3848),
    [anon_sym_static] = ACTIONS(3848),
    [anon_sym_LBRACK] = ACTIONS(3850),
    [anon_sym_LPAREN] = ACTIONS(3850),
    [anon_sym_return] = ACTIONS(3848),
    [anon_sym_namespace] = ACTIONS(3848),
    [anon_sym_class] = ACTIONS(3848),
    [anon_sym_ref] = ACTIONS(3848),
    [anon_sym_struct] = ACTIONS(3848),
    [anon_sym_enum] = ACTIONS(3848),
    [anon_sym_LBRACE] = ACTIONS(3850),
    [anon_sym_interface] = ACTIONS(3848),
    [anon_sym_delegate] = ACTIONS(3848),
    [anon_sym_record] = ACTIONS(3848),
    [anon_sym_abstract] = ACTIONS(3848),
    [anon_sym_async] = ACTIONS(3848),
    [anon_sym_const] = ACTIONS(3848),
    [anon_sym_file] = ACTIONS(3848),
    [anon_sym_fixed] = ACTIONS(3848),
    [anon_sym_internal] = ACTIONS(3848),
    [anon_sym_new] = ACTIONS(3848),
    [anon_sym_override] = ACTIONS(3848),
    [anon_sym_partial] = ACTIONS(3848),
    [anon_sym_private] = ACTIONS(3848),
    [anon_sym_protected] = ACTIONS(3848),
    [anon_sym_public] = ACTIONS(3848),
    [anon_sym_readonly] = ACTIONS(3848),
    [anon_sym_required] = ACTIONS(3848),
    [anon_sym_sealed] = ACTIONS(3848),
    [anon_sym_virtual] = ACTIONS(3848),
    [anon_sym_volatile] = ACTIONS(3848),
    [anon_sym_where] = ACTIONS(3848),
    [anon_sym_notnull] = ACTIONS(3848),
    [anon_sym_unmanaged] = ACTIONS(3848),
    [anon_sym_checked] = ACTIONS(3848),
    [anon_sym_BANG] = ACTIONS(3850),
    [anon_sym_TILDE] = ACTIONS(3850),
    [anon_sym_PLUS_PLUS] = ACTIONS(3850),
    [anon_sym_DASH_DASH] = ACTIONS(3850),
    [anon_sym_true] = ACTIONS(3848),
    [anon_sym_false] = ACTIONS(3848),
    [anon_sym_PLUS] = ACTIONS(3848),
    [anon_sym_DASH] = ACTIONS(3848),
    [anon_sym_STAR] = ACTIONS(3850),
    [anon_sym_CARET] = ACTIONS(3850),
    [anon_sym_AMP] = ACTIONS(3850),
    [anon_sym_this] = ACTIONS(3848),
    [anon_sym_scoped] = ACTIONS(3848),
    [anon_sym_var] = ACTIONS(3848),
    [sym_predefined_type] = ACTIONS(3848),
    [anon_sym_break] = ACTIONS(3848),
    [anon_sym_unchecked] = ACTIONS(3848),
    [anon_sym_continue] = ACTIONS(3848),
    [anon_sym_do] = ACTIONS(3848),
    [anon_sym_while] = ACTIONS(3848),
    [anon_sym_for] = ACTIONS(3848),
    [anon_sym_lock] = ACTIONS(3848),
    [anon_sym_yield] = ACTIONS(3848),
    [anon_sym_switch] = ACTIONS(3848),
    [anon_sym_default] = ACTIONS(3848),
    [anon_sym_throw] = ACTIONS(3848),
    [anon_sym_try] = ACTIONS(3848),
    [anon_sym_when] = ACTIONS(3848),
    [anon_sym_await] = ACTIONS(3848),
    [anon_sym_foreach] = ACTIONS(3848),
    [anon_sym_goto] = ACTIONS(3848),
    [anon_sym_if] = ACTIONS(3848),
    [anon_sym_DOT_DOT] = ACTIONS(3850),
    [anon_sym_from] = ACTIONS(3848),
    [anon_sym_into] = ACTIONS(3848),
    [anon_sym_join] = ACTIONS(3848),
    [anon_sym_on] = ACTIONS(3848),
    [anon_sym_equals] = ACTIONS(3848),
    [anon_sym_let] = ACTIONS(3848),
    [anon_sym_orderby] = ACTIONS(3848),
    [anon_sym_ascending] = ACTIONS(3848),
    [anon_sym_descending] = ACTIONS(3848),
    [anon_sym_group] = ACTIONS(3848),
    [anon_sym_by] = ACTIONS(3848),
    [anon_sym_select] = ACTIONS(3848),
    [anon_sym_DQUOTE] = ACTIONS(3848),
    [anon_sym_stackalloc] = ACTIONS(3848),
    [anon_sym_sizeof] = ACTIONS(3848),
    [anon_sym_typeof] = ACTIONS(3848),
    [anon_sym___makeref] = ACTIONS(3848),
    [anon_sym___reftype] = ACTIONS(3848),
    [anon_sym___refvalue] = ACTIONS(3848),
    [sym_null_literal] = ACTIONS(3848),
    [anon_sym_SQUOTE] = ACTIONS(3850),
    [sym_integer_literal] = ACTIONS(3848),
    [sym_real_literal] = ACTIONS(3850),
    [sym_verbatim_string_literal] = ACTIONS(3850),
    [sym_raw_string_literal] = ACTIONS(3850),
    [aux_sym_preproc_if_token1] = ACTIONS(3850),
    [aux_sym_preproc_if_token3] = ACTIONS(3850),
    [aux_sym_preproc_else_token1] = ACTIONS(3850),
    [aux_sym_preproc_elif_token1] = ACTIONS(3850),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3850),
    [sym_interpolation_verbatim_start] = ACTIONS(3850),
    [sym_interpolation_raw_start] = ACTIONS(3850),
  },
  [2402] = {
    [sym_preproc_region] = STATE(2402),
    [sym_preproc_endregion] = STATE(2402),
    [sym_preproc_line] = STATE(2402),
    [sym_preproc_pragma] = STATE(2402),
    [sym_preproc_nullable] = STATE(2402),
    [sym_preproc_error] = STATE(2402),
    [sym_preproc_define] = STATE(2402),
    [sym_preproc_undef] = STATE(2402),
    [sym__identifier_token] = ACTIONS(3852),
    [anon_sym_extern] = ACTIONS(3852),
    [anon_sym_alias] = ACTIONS(3852),
    [anon_sym_SEMI] = ACTIONS(3854),
    [anon_sym_global] = ACTIONS(3852),
    [anon_sym_using] = ACTIONS(3852),
    [anon_sym_unsafe] = ACTIONS(3852),
    [anon_sym_static] = ACTIONS(3852),
    [anon_sym_LBRACK] = ACTIONS(3854),
    [anon_sym_LPAREN] = ACTIONS(3854),
    [anon_sym_return] = ACTIONS(3852),
    [anon_sym_namespace] = ACTIONS(3852),
    [anon_sym_class] = ACTIONS(3852),
    [anon_sym_ref] = ACTIONS(3852),
    [anon_sym_struct] = ACTIONS(3852),
    [anon_sym_enum] = ACTIONS(3852),
    [anon_sym_LBRACE] = ACTIONS(3854),
    [anon_sym_interface] = ACTIONS(3852),
    [anon_sym_delegate] = ACTIONS(3852),
    [anon_sym_record] = ACTIONS(3852),
    [anon_sym_abstract] = ACTIONS(3852),
    [anon_sym_async] = ACTIONS(3852),
    [anon_sym_const] = ACTIONS(3852),
    [anon_sym_file] = ACTIONS(3852),
    [anon_sym_fixed] = ACTIONS(3852),
    [anon_sym_internal] = ACTIONS(3852),
    [anon_sym_new] = ACTIONS(3852),
    [anon_sym_override] = ACTIONS(3852),
    [anon_sym_partial] = ACTIONS(3852),
    [anon_sym_private] = ACTIONS(3852),
    [anon_sym_protected] = ACTIONS(3852),
    [anon_sym_public] = ACTIONS(3852),
    [anon_sym_readonly] = ACTIONS(3852),
    [anon_sym_required] = ACTIONS(3852),
    [anon_sym_sealed] = ACTIONS(3852),
    [anon_sym_virtual] = ACTIONS(3852),
    [anon_sym_volatile] = ACTIONS(3852),
    [anon_sym_where] = ACTIONS(3852),
    [anon_sym_notnull] = ACTIONS(3852),
    [anon_sym_unmanaged] = ACTIONS(3852),
    [anon_sym_checked] = ACTIONS(3852),
    [anon_sym_BANG] = ACTIONS(3854),
    [anon_sym_TILDE] = ACTIONS(3854),
    [anon_sym_PLUS_PLUS] = ACTIONS(3854),
    [anon_sym_DASH_DASH] = ACTIONS(3854),
    [anon_sym_true] = ACTIONS(3852),
    [anon_sym_false] = ACTIONS(3852),
    [anon_sym_PLUS] = ACTIONS(3852),
    [anon_sym_DASH] = ACTIONS(3852),
    [anon_sym_STAR] = ACTIONS(3854),
    [anon_sym_CARET] = ACTIONS(3854),
    [anon_sym_AMP] = ACTIONS(3854),
    [anon_sym_this] = ACTIONS(3852),
    [anon_sym_scoped] = ACTIONS(3852),
    [anon_sym_var] = ACTIONS(3852),
    [sym_predefined_type] = ACTIONS(3852),
    [anon_sym_break] = ACTIONS(3852),
    [anon_sym_unchecked] = ACTIONS(3852),
    [anon_sym_continue] = ACTIONS(3852),
    [anon_sym_do] = ACTIONS(3852),
    [anon_sym_while] = ACTIONS(3852),
    [anon_sym_for] = ACTIONS(3852),
    [anon_sym_lock] = ACTIONS(3852),
    [anon_sym_yield] = ACTIONS(3852),
    [anon_sym_switch] = ACTIONS(3852),
    [anon_sym_default] = ACTIONS(3852),
    [anon_sym_throw] = ACTIONS(3852),
    [anon_sym_try] = ACTIONS(3852),
    [anon_sym_when] = ACTIONS(3852),
    [anon_sym_await] = ACTIONS(3852),
    [anon_sym_foreach] = ACTIONS(3852),
    [anon_sym_goto] = ACTIONS(3852),
    [anon_sym_if] = ACTIONS(3852),
    [anon_sym_DOT_DOT] = ACTIONS(3854),
    [anon_sym_from] = ACTIONS(3852),
    [anon_sym_into] = ACTIONS(3852),
    [anon_sym_join] = ACTIONS(3852),
    [anon_sym_on] = ACTIONS(3852),
    [anon_sym_equals] = ACTIONS(3852),
    [anon_sym_let] = ACTIONS(3852),
    [anon_sym_orderby] = ACTIONS(3852),
    [anon_sym_ascending] = ACTIONS(3852),
    [anon_sym_descending] = ACTIONS(3852),
    [anon_sym_group] = ACTIONS(3852),
    [anon_sym_by] = ACTIONS(3852),
    [anon_sym_select] = ACTIONS(3852),
    [anon_sym_DQUOTE] = ACTIONS(3852),
    [anon_sym_stackalloc] = ACTIONS(3852),
    [anon_sym_sizeof] = ACTIONS(3852),
    [anon_sym_typeof] = ACTIONS(3852),
    [anon_sym___makeref] = ACTIONS(3852),
    [anon_sym___reftype] = ACTIONS(3852),
    [anon_sym___refvalue] = ACTIONS(3852),
    [sym_null_literal] = ACTIONS(3852),
    [anon_sym_SQUOTE] = ACTIONS(3854),
    [sym_integer_literal] = ACTIONS(3852),
    [sym_real_literal] = ACTIONS(3854),
    [sym_verbatim_string_literal] = ACTIONS(3854),
    [sym_raw_string_literal] = ACTIONS(3854),
    [aux_sym_preproc_if_token1] = ACTIONS(3854),
    [aux_sym_preproc_if_token3] = ACTIONS(3854),
    [aux_sym_preproc_else_token1] = ACTIONS(3854),
    [aux_sym_preproc_elif_token1] = ACTIONS(3854),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3854),
    [sym_interpolation_verbatim_start] = ACTIONS(3854),
    [sym_interpolation_raw_start] = ACTIONS(3854),
  },
  [2403] = {
    [sym_preproc_region] = STATE(2403),
    [sym_preproc_endregion] = STATE(2403),
    [sym_preproc_line] = STATE(2403),
    [sym_preproc_pragma] = STATE(2403),
    [sym_preproc_nullable] = STATE(2403),
    [sym_preproc_error] = STATE(2403),
    [sym_preproc_define] = STATE(2403),
    [sym_preproc_undef] = STATE(2403),
    [sym__identifier_token] = ACTIONS(3856),
    [anon_sym_extern] = ACTIONS(3856),
    [anon_sym_alias] = ACTIONS(3856),
    [anon_sym_SEMI] = ACTIONS(3858),
    [anon_sym_global] = ACTIONS(3856),
    [anon_sym_using] = ACTIONS(3856),
    [anon_sym_unsafe] = ACTIONS(3856),
    [anon_sym_static] = ACTIONS(3856),
    [anon_sym_LBRACK] = ACTIONS(3858),
    [anon_sym_LPAREN] = ACTIONS(3858),
    [anon_sym_return] = ACTIONS(3856),
    [anon_sym_namespace] = ACTIONS(3856),
    [anon_sym_class] = ACTIONS(3856),
    [anon_sym_ref] = ACTIONS(3856),
    [anon_sym_struct] = ACTIONS(3856),
    [anon_sym_enum] = ACTIONS(3856),
    [anon_sym_LBRACE] = ACTIONS(3858),
    [anon_sym_interface] = ACTIONS(3856),
    [anon_sym_delegate] = ACTIONS(3856),
    [anon_sym_record] = ACTIONS(3856),
    [anon_sym_abstract] = ACTIONS(3856),
    [anon_sym_async] = ACTIONS(3856),
    [anon_sym_const] = ACTIONS(3856),
    [anon_sym_file] = ACTIONS(3856),
    [anon_sym_fixed] = ACTIONS(3856),
    [anon_sym_internal] = ACTIONS(3856),
    [anon_sym_new] = ACTIONS(3856),
    [anon_sym_override] = ACTIONS(3856),
    [anon_sym_partial] = ACTIONS(3856),
    [anon_sym_private] = ACTIONS(3856),
    [anon_sym_protected] = ACTIONS(3856),
    [anon_sym_public] = ACTIONS(3856),
    [anon_sym_readonly] = ACTIONS(3856),
    [anon_sym_required] = ACTIONS(3856),
    [anon_sym_sealed] = ACTIONS(3856),
    [anon_sym_virtual] = ACTIONS(3856),
    [anon_sym_volatile] = ACTIONS(3856),
    [anon_sym_where] = ACTIONS(3856),
    [anon_sym_notnull] = ACTIONS(3856),
    [anon_sym_unmanaged] = ACTIONS(3856),
    [anon_sym_checked] = ACTIONS(3856),
    [anon_sym_BANG] = ACTIONS(3858),
    [anon_sym_TILDE] = ACTIONS(3858),
    [anon_sym_PLUS_PLUS] = ACTIONS(3858),
    [anon_sym_DASH_DASH] = ACTIONS(3858),
    [anon_sym_true] = ACTIONS(3856),
    [anon_sym_false] = ACTIONS(3856),
    [anon_sym_PLUS] = ACTIONS(3856),
    [anon_sym_DASH] = ACTIONS(3856),
    [anon_sym_STAR] = ACTIONS(3858),
    [anon_sym_CARET] = ACTIONS(3858),
    [anon_sym_AMP] = ACTIONS(3858),
    [anon_sym_this] = ACTIONS(3856),
    [anon_sym_scoped] = ACTIONS(3856),
    [anon_sym_var] = ACTIONS(3856),
    [sym_predefined_type] = ACTIONS(3856),
    [anon_sym_break] = ACTIONS(3856),
    [anon_sym_unchecked] = ACTIONS(3856),
    [anon_sym_continue] = ACTIONS(3856),
    [anon_sym_do] = ACTIONS(3856),
    [anon_sym_while] = ACTIONS(3856),
    [anon_sym_for] = ACTIONS(3856),
    [anon_sym_lock] = ACTIONS(3856),
    [anon_sym_yield] = ACTIONS(3856),
    [anon_sym_switch] = ACTIONS(3856),
    [anon_sym_default] = ACTIONS(3856),
    [anon_sym_throw] = ACTIONS(3856),
    [anon_sym_try] = ACTIONS(3856),
    [anon_sym_when] = ACTIONS(3856),
    [anon_sym_await] = ACTIONS(3856),
    [anon_sym_foreach] = ACTIONS(3856),
    [anon_sym_goto] = ACTIONS(3856),
    [anon_sym_if] = ACTIONS(3856),
    [anon_sym_DOT_DOT] = ACTIONS(3858),
    [anon_sym_from] = ACTIONS(3856),
    [anon_sym_into] = ACTIONS(3856),
    [anon_sym_join] = ACTIONS(3856),
    [anon_sym_on] = ACTIONS(3856),
    [anon_sym_equals] = ACTIONS(3856),
    [anon_sym_let] = ACTIONS(3856),
    [anon_sym_orderby] = ACTIONS(3856),
    [anon_sym_ascending] = ACTIONS(3856),
    [anon_sym_descending] = ACTIONS(3856),
    [anon_sym_group] = ACTIONS(3856),
    [anon_sym_by] = ACTIONS(3856),
    [anon_sym_select] = ACTIONS(3856),
    [anon_sym_DQUOTE] = ACTIONS(3856),
    [anon_sym_stackalloc] = ACTIONS(3856),
    [anon_sym_sizeof] = ACTIONS(3856),
    [anon_sym_typeof] = ACTIONS(3856),
    [anon_sym___makeref] = ACTIONS(3856),
    [anon_sym___reftype] = ACTIONS(3856),
    [anon_sym___refvalue] = ACTIONS(3856),
    [sym_null_literal] = ACTIONS(3856),
    [anon_sym_SQUOTE] = ACTIONS(3858),
    [sym_integer_literal] = ACTIONS(3856),
    [sym_real_literal] = ACTIONS(3858),
    [sym_verbatim_string_literal] = ACTIONS(3858),
    [sym_raw_string_literal] = ACTIONS(3858),
    [aux_sym_preproc_if_token1] = ACTIONS(3858),
    [aux_sym_preproc_if_token3] = ACTIONS(3858),
    [aux_sym_preproc_else_token1] = ACTIONS(3858),
    [aux_sym_preproc_elif_token1] = ACTIONS(3858),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3858),
    [sym_interpolation_verbatim_start] = ACTIONS(3858),
    [sym_interpolation_raw_start] = ACTIONS(3858),
  },
  [2404] = {
    [sym_preproc_region] = STATE(2404),
    [sym_preproc_endregion] = STATE(2404),
    [sym_preproc_line] = STATE(2404),
    [sym_preproc_pragma] = STATE(2404),
    [sym_preproc_nullable] = STATE(2404),
    [sym_preproc_error] = STATE(2404),
    [sym_preproc_define] = STATE(2404),
    [sym_preproc_undef] = STATE(2404),
    [sym__identifier_token] = ACTIONS(3860),
    [anon_sym_extern] = ACTIONS(3860),
    [anon_sym_alias] = ACTIONS(3860),
    [anon_sym_SEMI] = ACTIONS(3862),
    [anon_sym_global] = ACTIONS(3860),
    [anon_sym_using] = ACTIONS(3860),
    [anon_sym_unsafe] = ACTIONS(3860),
    [anon_sym_static] = ACTIONS(3860),
    [anon_sym_LBRACK] = ACTIONS(3862),
    [anon_sym_LPAREN] = ACTIONS(3862),
    [anon_sym_return] = ACTIONS(3860),
    [anon_sym_namespace] = ACTIONS(3860),
    [anon_sym_class] = ACTIONS(3860),
    [anon_sym_ref] = ACTIONS(3860),
    [anon_sym_struct] = ACTIONS(3860),
    [anon_sym_enum] = ACTIONS(3860),
    [anon_sym_LBRACE] = ACTIONS(3862),
    [anon_sym_interface] = ACTIONS(3860),
    [anon_sym_delegate] = ACTIONS(3860),
    [anon_sym_record] = ACTIONS(3860),
    [anon_sym_abstract] = ACTIONS(3860),
    [anon_sym_async] = ACTIONS(3860),
    [anon_sym_const] = ACTIONS(3860),
    [anon_sym_file] = ACTIONS(3860),
    [anon_sym_fixed] = ACTIONS(3860),
    [anon_sym_internal] = ACTIONS(3860),
    [anon_sym_new] = ACTIONS(3860),
    [anon_sym_override] = ACTIONS(3860),
    [anon_sym_partial] = ACTIONS(3860),
    [anon_sym_private] = ACTIONS(3860),
    [anon_sym_protected] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3860),
    [anon_sym_readonly] = ACTIONS(3860),
    [anon_sym_required] = ACTIONS(3860),
    [anon_sym_sealed] = ACTIONS(3860),
    [anon_sym_virtual] = ACTIONS(3860),
    [anon_sym_volatile] = ACTIONS(3860),
    [anon_sym_where] = ACTIONS(3860),
    [anon_sym_notnull] = ACTIONS(3860),
    [anon_sym_unmanaged] = ACTIONS(3860),
    [anon_sym_checked] = ACTIONS(3860),
    [anon_sym_BANG] = ACTIONS(3862),
    [anon_sym_TILDE] = ACTIONS(3862),
    [anon_sym_PLUS_PLUS] = ACTIONS(3862),
    [anon_sym_DASH_DASH] = ACTIONS(3862),
    [anon_sym_true] = ACTIONS(3860),
    [anon_sym_false] = ACTIONS(3860),
    [anon_sym_PLUS] = ACTIONS(3860),
    [anon_sym_DASH] = ACTIONS(3860),
    [anon_sym_STAR] = ACTIONS(3862),
    [anon_sym_CARET] = ACTIONS(3862),
    [anon_sym_AMP] = ACTIONS(3862),
    [anon_sym_this] = ACTIONS(3860),
    [anon_sym_scoped] = ACTIONS(3860),
    [anon_sym_var] = ACTIONS(3860),
    [sym_predefined_type] = ACTIONS(3860),
    [anon_sym_break] = ACTIONS(3860),
    [anon_sym_unchecked] = ACTIONS(3860),
    [anon_sym_continue] = ACTIONS(3860),
    [anon_sym_do] = ACTIONS(3860),
    [anon_sym_while] = ACTIONS(3860),
    [anon_sym_for] = ACTIONS(3860),
    [anon_sym_lock] = ACTIONS(3860),
    [anon_sym_yield] = ACTIONS(3860),
    [anon_sym_switch] = ACTIONS(3860),
    [anon_sym_default] = ACTIONS(3860),
    [anon_sym_throw] = ACTIONS(3860),
    [anon_sym_try] = ACTIONS(3860),
    [anon_sym_when] = ACTIONS(3860),
    [anon_sym_await] = ACTIONS(3860),
    [anon_sym_foreach] = ACTIONS(3860),
    [anon_sym_goto] = ACTIONS(3860),
    [anon_sym_if] = ACTIONS(3860),
    [anon_sym_DOT_DOT] = ACTIONS(3862),
    [anon_sym_from] = ACTIONS(3860),
    [anon_sym_into] = ACTIONS(3860),
    [anon_sym_join] = ACTIONS(3860),
    [anon_sym_on] = ACTIONS(3860),
    [anon_sym_equals] = ACTIONS(3860),
    [anon_sym_let] = ACTIONS(3860),
    [anon_sym_orderby] = ACTIONS(3860),
    [anon_sym_ascending] = ACTIONS(3860),
    [anon_sym_descending] = ACTIONS(3860),
    [anon_sym_group] = ACTIONS(3860),
    [anon_sym_by] = ACTIONS(3860),
    [anon_sym_select] = ACTIONS(3860),
    [anon_sym_DQUOTE] = ACTIONS(3860),
    [anon_sym_stackalloc] = ACTIONS(3860),
    [anon_sym_sizeof] = ACTIONS(3860),
    [anon_sym_typeof] = ACTIONS(3860),
    [anon_sym___makeref] = ACTIONS(3860),
    [anon_sym___reftype] = ACTIONS(3860),
    [anon_sym___refvalue] = ACTIONS(3860),
    [sym_null_literal] = ACTIONS(3860),
    [anon_sym_SQUOTE] = ACTIONS(3862),
    [sym_integer_literal] = ACTIONS(3860),
    [sym_real_literal] = ACTIONS(3862),
    [sym_verbatim_string_literal] = ACTIONS(3862),
    [sym_raw_string_literal] = ACTIONS(3862),
    [aux_sym_preproc_if_token1] = ACTIONS(3862),
    [aux_sym_preproc_if_token3] = ACTIONS(3862),
    [aux_sym_preproc_else_token1] = ACTIONS(3862),
    [aux_sym_preproc_elif_token1] = ACTIONS(3862),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3862),
    [sym_interpolation_verbatim_start] = ACTIONS(3862),
    [sym_interpolation_raw_start] = ACTIONS(3862),
  },
  [2405] = {
    [sym_preproc_region] = STATE(2405),
    [sym_preproc_endregion] = STATE(2405),
    [sym_preproc_line] = STATE(2405),
    [sym_preproc_pragma] = STATE(2405),
    [sym_preproc_nullable] = STATE(2405),
    [sym_preproc_error] = STATE(2405),
    [sym_preproc_define] = STATE(2405),
    [sym_preproc_undef] = STATE(2405),
    [sym__identifier_token] = ACTIONS(3864),
    [anon_sym_extern] = ACTIONS(3864),
    [anon_sym_alias] = ACTIONS(3864),
    [anon_sym_SEMI] = ACTIONS(3866),
    [anon_sym_global] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3864),
    [anon_sym_unsafe] = ACTIONS(3864),
    [anon_sym_static] = ACTIONS(3864),
    [anon_sym_LBRACK] = ACTIONS(3866),
    [anon_sym_LPAREN] = ACTIONS(3866),
    [anon_sym_return] = ACTIONS(3864),
    [anon_sym_namespace] = ACTIONS(3864),
    [anon_sym_class] = ACTIONS(3864),
    [anon_sym_ref] = ACTIONS(3864),
    [anon_sym_struct] = ACTIONS(3864),
    [anon_sym_enum] = ACTIONS(3864),
    [anon_sym_LBRACE] = ACTIONS(3866),
    [anon_sym_interface] = ACTIONS(3864),
    [anon_sym_delegate] = ACTIONS(3864),
    [anon_sym_record] = ACTIONS(3864),
    [anon_sym_abstract] = ACTIONS(3864),
    [anon_sym_async] = ACTIONS(3864),
    [anon_sym_const] = ACTIONS(3864),
    [anon_sym_file] = ACTIONS(3864),
    [anon_sym_fixed] = ACTIONS(3864),
    [anon_sym_internal] = ACTIONS(3864),
    [anon_sym_new] = ACTIONS(3864),
    [anon_sym_override] = ACTIONS(3864),
    [anon_sym_partial] = ACTIONS(3864),
    [anon_sym_private] = ACTIONS(3864),
    [anon_sym_protected] = ACTIONS(3864),
    [anon_sym_public] = ACTIONS(3864),
    [anon_sym_readonly] = ACTIONS(3864),
    [anon_sym_required] = ACTIONS(3864),
    [anon_sym_sealed] = ACTIONS(3864),
    [anon_sym_virtual] = ACTIONS(3864),
    [anon_sym_volatile] = ACTIONS(3864),
    [anon_sym_where] = ACTIONS(3864),
    [anon_sym_notnull] = ACTIONS(3864),
    [anon_sym_unmanaged] = ACTIONS(3864),
    [anon_sym_checked] = ACTIONS(3864),
    [anon_sym_BANG] = ACTIONS(3866),
    [anon_sym_TILDE] = ACTIONS(3866),
    [anon_sym_PLUS_PLUS] = ACTIONS(3866),
    [anon_sym_DASH_DASH] = ACTIONS(3866),
    [anon_sym_true] = ACTIONS(3864),
    [anon_sym_false] = ACTIONS(3864),
    [anon_sym_PLUS] = ACTIONS(3864),
    [anon_sym_DASH] = ACTIONS(3864),
    [anon_sym_STAR] = ACTIONS(3866),
    [anon_sym_CARET] = ACTIONS(3866),
    [anon_sym_AMP] = ACTIONS(3866),
    [anon_sym_this] = ACTIONS(3864),
    [anon_sym_scoped] = ACTIONS(3864),
    [anon_sym_var] = ACTIONS(3864),
    [sym_predefined_type] = ACTIONS(3864),
    [anon_sym_break] = ACTIONS(3864),
    [anon_sym_unchecked] = ACTIONS(3864),
    [anon_sym_continue] = ACTIONS(3864),
    [anon_sym_do] = ACTIONS(3864),
    [anon_sym_while] = ACTIONS(3864),
    [anon_sym_for] = ACTIONS(3864),
    [anon_sym_lock] = ACTIONS(3864),
    [anon_sym_yield] = ACTIONS(3864),
    [anon_sym_switch] = ACTIONS(3864),
    [anon_sym_default] = ACTIONS(3864),
    [anon_sym_throw] = ACTIONS(3864),
    [anon_sym_try] = ACTIONS(3864),
    [anon_sym_when] = ACTIONS(3864),
    [anon_sym_await] = ACTIONS(3864),
    [anon_sym_foreach] = ACTIONS(3864),
    [anon_sym_goto] = ACTIONS(3864),
    [anon_sym_if] = ACTIONS(3864),
    [anon_sym_DOT_DOT] = ACTIONS(3866),
    [anon_sym_from] = ACTIONS(3864),
    [anon_sym_into] = ACTIONS(3864),
    [anon_sym_join] = ACTIONS(3864),
    [anon_sym_on] = ACTIONS(3864),
    [anon_sym_equals] = ACTIONS(3864),
    [anon_sym_let] = ACTIONS(3864),
    [anon_sym_orderby] = ACTIONS(3864),
    [anon_sym_ascending] = ACTIONS(3864),
    [anon_sym_descending] = ACTIONS(3864),
    [anon_sym_group] = ACTIONS(3864),
    [anon_sym_by] = ACTIONS(3864),
    [anon_sym_select] = ACTIONS(3864),
    [anon_sym_DQUOTE] = ACTIONS(3864),
    [anon_sym_stackalloc] = ACTIONS(3864),
    [anon_sym_sizeof] = ACTIONS(3864),
    [anon_sym_typeof] = ACTIONS(3864),
    [anon_sym___makeref] = ACTIONS(3864),
    [anon_sym___reftype] = ACTIONS(3864),
    [anon_sym___refvalue] = ACTIONS(3864),
    [sym_null_literal] = ACTIONS(3864),
    [anon_sym_SQUOTE] = ACTIONS(3866),
    [sym_integer_literal] = ACTIONS(3864),
    [sym_real_literal] = ACTIONS(3866),
    [sym_verbatim_string_literal] = ACTIONS(3866),
    [sym_raw_string_literal] = ACTIONS(3866),
    [aux_sym_preproc_if_token1] = ACTIONS(3866),
    [aux_sym_preproc_if_token3] = ACTIONS(3866),
    [aux_sym_preproc_else_token1] = ACTIONS(3866),
    [aux_sym_preproc_elif_token1] = ACTIONS(3866),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3866),
    [sym_interpolation_verbatim_start] = ACTIONS(3866),
    [sym_interpolation_raw_start] = ACTIONS(3866),
  },
  [2406] = {
    [sym_preproc_region] = STATE(2406),
    [sym_preproc_endregion] = STATE(2406),
    [sym_preproc_line] = STATE(2406),
    [sym_preproc_pragma] = STATE(2406),
    [sym_preproc_nullable] = STATE(2406),
    [sym_preproc_error] = STATE(2406),
    [sym_preproc_define] = STATE(2406),
    [sym_preproc_undef] = STATE(2406),
    [sym__identifier_token] = ACTIONS(3868),
    [anon_sym_extern] = ACTIONS(3868),
    [anon_sym_alias] = ACTIONS(3868),
    [anon_sym_SEMI] = ACTIONS(3870),
    [anon_sym_global] = ACTIONS(3868),
    [anon_sym_using] = ACTIONS(3868),
    [anon_sym_unsafe] = ACTIONS(3868),
    [anon_sym_static] = ACTIONS(3868),
    [anon_sym_LBRACK] = ACTIONS(3870),
    [anon_sym_LPAREN] = ACTIONS(3870),
    [anon_sym_return] = ACTIONS(3868),
    [anon_sym_namespace] = ACTIONS(3868),
    [anon_sym_class] = ACTIONS(3868),
    [anon_sym_ref] = ACTIONS(3868),
    [anon_sym_struct] = ACTIONS(3868),
    [anon_sym_enum] = ACTIONS(3868),
    [anon_sym_LBRACE] = ACTIONS(3870),
    [anon_sym_interface] = ACTIONS(3868),
    [anon_sym_delegate] = ACTIONS(3868),
    [anon_sym_record] = ACTIONS(3868),
    [anon_sym_abstract] = ACTIONS(3868),
    [anon_sym_async] = ACTIONS(3868),
    [anon_sym_const] = ACTIONS(3868),
    [anon_sym_file] = ACTIONS(3868),
    [anon_sym_fixed] = ACTIONS(3868),
    [anon_sym_internal] = ACTIONS(3868),
    [anon_sym_new] = ACTIONS(3868),
    [anon_sym_override] = ACTIONS(3868),
    [anon_sym_partial] = ACTIONS(3868),
    [anon_sym_private] = ACTIONS(3868),
    [anon_sym_protected] = ACTIONS(3868),
    [anon_sym_public] = ACTIONS(3868),
    [anon_sym_readonly] = ACTIONS(3868),
    [anon_sym_required] = ACTIONS(3868),
    [anon_sym_sealed] = ACTIONS(3868),
    [anon_sym_virtual] = ACTIONS(3868),
    [anon_sym_volatile] = ACTIONS(3868),
    [anon_sym_where] = ACTIONS(3868),
    [anon_sym_notnull] = ACTIONS(3868),
    [anon_sym_unmanaged] = ACTIONS(3868),
    [anon_sym_checked] = ACTIONS(3868),
    [anon_sym_BANG] = ACTIONS(3870),
    [anon_sym_TILDE] = ACTIONS(3870),
    [anon_sym_PLUS_PLUS] = ACTIONS(3870),
    [anon_sym_DASH_DASH] = ACTIONS(3870),
    [anon_sym_true] = ACTIONS(3868),
    [anon_sym_false] = ACTIONS(3868),
    [anon_sym_PLUS] = ACTIONS(3868),
    [anon_sym_DASH] = ACTIONS(3868),
    [anon_sym_STAR] = ACTIONS(3870),
    [anon_sym_CARET] = ACTIONS(3870),
    [anon_sym_AMP] = ACTIONS(3870),
    [anon_sym_this] = ACTIONS(3868),
    [anon_sym_scoped] = ACTIONS(3868),
    [anon_sym_var] = ACTIONS(3868),
    [sym_predefined_type] = ACTIONS(3868),
    [anon_sym_break] = ACTIONS(3868),
    [anon_sym_unchecked] = ACTIONS(3868),
    [anon_sym_continue] = ACTIONS(3868),
    [anon_sym_do] = ACTIONS(3868),
    [anon_sym_while] = ACTIONS(3868),
    [anon_sym_for] = ACTIONS(3868),
    [anon_sym_lock] = ACTIONS(3868),
    [anon_sym_yield] = ACTIONS(3868),
    [anon_sym_switch] = ACTIONS(3868),
    [anon_sym_default] = ACTIONS(3868),
    [anon_sym_throw] = ACTIONS(3868),
    [anon_sym_try] = ACTIONS(3868),
    [anon_sym_when] = ACTIONS(3868),
    [anon_sym_await] = ACTIONS(3868),
    [anon_sym_foreach] = ACTIONS(3868),
    [anon_sym_goto] = ACTIONS(3868),
    [anon_sym_if] = ACTIONS(3868),
    [anon_sym_DOT_DOT] = ACTIONS(3870),
    [anon_sym_from] = ACTIONS(3868),
    [anon_sym_into] = ACTIONS(3868),
    [anon_sym_join] = ACTIONS(3868),
    [anon_sym_on] = ACTIONS(3868),
    [anon_sym_equals] = ACTIONS(3868),
    [anon_sym_let] = ACTIONS(3868),
    [anon_sym_orderby] = ACTIONS(3868),
    [anon_sym_ascending] = ACTIONS(3868),
    [anon_sym_descending] = ACTIONS(3868),
    [anon_sym_group] = ACTIONS(3868),
    [anon_sym_by] = ACTIONS(3868),
    [anon_sym_select] = ACTIONS(3868),
    [anon_sym_DQUOTE] = ACTIONS(3868),
    [anon_sym_stackalloc] = ACTIONS(3868),
    [anon_sym_sizeof] = ACTIONS(3868),
    [anon_sym_typeof] = ACTIONS(3868),
    [anon_sym___makeref] = ACTIONS(3868),
    [anon_sym___reftype] = ACTIONS(3868),
    [anon_sym___refvalue] = ACTIONS(3868),
    [sym_null_literal] = ACTIONS(3868),
    [anon_sym_SQUOTE] = ACTIONS(3870),
    [sym_integer_literal] = ACTIONS(3868),
    [sym_real_literal] = ACTIONS(3870),
    [sym_verbatim_string_literal] = ACTIONS(3870),
    [sym_raw_string_literal] = ACTIONS(3870),
    [aux_sym_preproc_if_token1] = ACTIONS(3870),
    [aux_sym_preproc_if_token3] = ACTIONS(3870),
    [aux_sym_preproc_else_token1] = ACTIONS(3870),
    [aux_sym_preproc_elif_token1] = ACTIONS(3870),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3870),
    [sym_interpolation_verbatim_start] = ACTIONS(3870),
    [sym_interpolation_raw_start] = ACTIONS(3870),
  },
  [2407] = {
    [sym_preproc_region] = STATE(2407),
    [sym_preproc_endregion] = STATE(2407),
    [sym_preproc_line] = STATE(2407),
    [sym_preproc_pragma] = STATE(2407),
    [sym_preproc_nullable] = STATE(2407),
    [sym_preproc_error] = STATE(2407),
    [sym_preproc_define] = STATE(2407),
    [sym_preproc_undef] = STATE(2407),
    [sym__identifier_token] = ACTIONS(3872),
    [anon_sym_extern] = ACTIONS(3872),
    [anon_sym_alias] = ACTIONS(3872),
    [anon_sym_SEMI] = ACTIONS(3874),
    [anon_sym_global] = ACTIONS(3872),
    [anon_sym_using] = ACTIONS(3872),
    [anon_sym_unsafe] = ACTIONS(3872),
    [anon_sym_static] = ACTIONS(3872),
    [anon_sym_LBRACK] = ACTIONS(3874),
    [anon_sym_LPAREN] = ACTIONS(3874),
    [anon_sym_return] = ACTIONS(3872),
    [anon_sym_namespace] = ACTIONS(3872),
    [anon_sym_class] = ACTIONS(3872),
    [anon_sym_ref] = ACTIONS(3872),
    [anon_sym_struct] = ACTIONS(3872),
    [anon_sym_enum] = ACTIONS(3872),
    [anon_sym_LBRACE] = ACTIONS(3874),
    [anon_sym_interface] = ACTIONS(3872),
    [anon_sym_delegate] = ACTIONS(3872),
    [anon_sym_record] = ACTIONS(3872),
    [anon_sym_abstract] = ACTIONS(3872),
    [anon_sym_async] = ACTIONS(3872),
    [anon_sym_const] = ACTIONS(3872),
    [anon_sym_file] = ACTIONS(3872),
    [anon_sym_fixed] = ACTIONS(3872),
    [anon_sym_internal] = ACTIONS(3872),
    [anon_sym_new] = ACTIONS(3872),
    [anon_sym_override] = ACTIONS(3872),
    [anon_sym_partial] = ACTIONS(3872),
    [anon_sym_private] = ACTIONS(3872),
    [anon_sym_protected] = ACTIONS(3872),
    [anon_sym_public] = ACTIONS(3872),
    [anon_sym_readonly] = ACTIONS(3872),
    [anon_sym_required] = ACTIONS(3872),
    [anon_sym_sealed] = ACTIONS(3872),
    [anon_sym_virtual] = ACTIONS(3872),
    [anon_sym_volatile] = ACTIONS(3872),
    [anon_sym_where] = ACTIONS(3872),
    [anon_sym_notnull] = ACTIONS(3872),
    [anon_sym_unmanaged] = ACTIONS(3872),
    [anon_sym_checked] = ACTIONS(3872),
    [anon_sym_BANG] = ACTIONS(3874),
    [anon_sym_TILDE] = ACTIONS(3874),
    [anon_sym_PLUS_PLUS] = ACTIONS(3874),
    [anon_sym_DASH_DASH] = ACTIONS(3874),
    [anon_sym_true] = ACTIONS(3872),
    [anon_sym_false] = ACTIONS(3872),
    [anon_sym_PLUS] = ACTIONS(3872),
    [anon_sym_DASH] = ACTIONS(3872),
    [anon_sym_STAR] = ACTIONS(3874),
    [anon_sym_CARET] = ACTIONS(3874),
    [anon_sym_AMP] = ACTIONS(3874),
    [anon_sym_this] = ACTIONS(3872),
    [anon_sym_scoped] = ACTIONS(3872),
    [anon_sym_var] = ACTIONS(3872),
    [sym_predefined_type] = ACTIONS(3872),
    [anon_sym_break] = ACTIONS(3872),
    [anon_sym_unchecked] = ACTIONS(3872),
    [anon_sym_continue] = ACTIONS(3872),
    [anon_sym_do] = ACTIONS(3872),
    [anon_sym_while] = ACTIONS(3872),
    [anon_sym_for] = ACTIONS(3872),
    [anon_sym_lock] = ACTIONS(3872),
    [anon_sym_yield] = ACTIONS(3872),
    [anon_sym_switch] = ACTIONS(3872),
    [anon_sym_default] = ACTIONS(3872),
    [anon_sym_throw] = ACTIONS(3872),
    [anon_sym_try] = ACTIONS(3872),
    [anon_sym_when] = ACTIONS(3872),
    [anon_sym_await] = ACTIONS(3872),
    [anon_sym_foreach] = ACTIONS(3872),
    [anon_sym_goto] = ACTIONS(3872),
    [anon_sym_if] = ACTIONS(3872),
    [anon_sym_DOT_DOT] = ACTIONS(3874),
    [anon_sym_from] = ACTIONS(3872),
    [anon_sym_into] = ACTIONS(3872),
    [anon_sym_join] = ACTIONS(3872),
    [anon_sym_on] = ACTIONS(3872),
    [anon_sym_equals] = ACTIONS(3872),
    [anon_sym_let] = ACTIONS(3872),
    [anon_sym_orderby] = ACTIONS(3872),
    [anon_sym_ascending] = ACTIONS(3872),
    [anon_sym_descending] = ACTIONS(3872),
    [anon_sym_group] = ACTIONS(3872),
    [anon_sym_by] = ACTIONS(3872),
    [anon_sym_select] = ACTIONS(3872),
    [anon_sym_DQUOTE] = ACTIONS(3872),
    [anon_sym_stackalloc] = ACTIONS(3872),
    [anon_sym_sizeof] = ACTIONS(3872),
    [anon_sym_typeof] = ACTIONS(3872),
    [anon_sym___makeref] = ACTIONS(3872),
    [anon_sym___reftype] = ACTIONS(3872),
    [anon_sym___refvalue] = ACTIONS(3872),
    [sym_null_literal] = ACTIONS(3872),
    [anon_sym_SQUOTE] = ACTIONS(3874),
    [sym_integer_literal] = ACTIONS(3872),
    [sym_real_literal] = ACTIONS(3874),
    [sym_verbatim_string_literal] = ACTIONS(3874),
    [sym_raw_string_literal] = ACTIONS(3874),
    [aux_sym_preproc_if_token1] = ACTIONS(3874),
    [aux_sym_preproc_if_token3] = ACTIONS(3874),
    [aux_sym_preproc_else_token1] = ACTIONS(3874),
    [aux_sym_preproc_elif_token1] = ACTIONS(3874),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3874),
    [sym_interpolation_verbatim_start] = ACTIONS(3874),
    [sym_interpolation_raw_start] = ACTIONS(3874),
  },
  [2408] = {
    [sym_preproc_region] = STATE(2408),
    [sym_preproc_endregion] = STATE(2408),
    [sym_preproc_line] = STATE(2408),
    [sym_preproc_pragma] = STATE(2408),
    [sym_preproc_nullable] = STATE(2408),
    [sym_preproc_error] = STATE(2408),
    [sym_preproc_define] = STATE(2408),
    [sym_preproc_undef] = STATE(2408),
    [sym__identifier_token] = ACTIONS(3876),
    [anon_sym_extern] = ACTIONS(3876),
    [anon_sym_alias] = ACTIONS(3876),
    [anon_sym_SEMI] = ACTIONS(3878),
    [anon_sym_global] = ACTIONS(3876),
    [anon_sym_using] = ACTIONS(3876),
    [anon_sym_unsafe] = ACTIONS(3876),
    [anon_sym_static] = ACTIONS(3876),
    [anon_sym_LBRACK] = ACTIONS(3878),
    [anon_sym_LPAREN] = ACTIONS(3878),
    [anon_sym_return] = ACTIONS(3876),
    [anon_sym_namespace] = ACTIONS(3876),
    [anon_sym_class] = ACTIONS(3876),
    [anon_sym_ref] = ACTIONS(3876),
    [anon_sym_struct] = ACTIONS(3876),
    [anon_sym_enum] = ACTIONS(3876),
    [anon_sym_LBRACE] = ACTIONS(3878),
    [anon_sym_interface] = ACTIONS(3876),
    [anon_sym_delegate] = ACTIONS(3876),
    [anon_sym_record] = ACTIONS(3876),
    [anon_sym_abstract] = ACTIONS(3876),
    [anon_sym_async] = ACTIONS(3876),
    [anon_sym_const] = ACTIONS(3876),
    [anon_sym_file] = ACTIONS(3876),
    [anon_sym_fixed] = ACTIONS(3876),
    [anon_sym_internal] = ACTIONS(3876),
    [anon_sym_new] = ACTIONS(3876),
    [anon_sym_override] = ACTIONS(3876),
    [anon_sym_partial] = ACTIONS(3876),
    [anon_sym_private] = ACTIONS(3876),
    [anon_sym_protected] = ACTIONS(3876),
    [anon_sym_public] = ACTIONS(3876),
    [anon_sym_readonly] = ACTIONS(3876),
    [anon_sym_required] = ACTIONS(3876),
    [anon_sym_sealed] = ACTIONS(3876),
    [anon_sym_virtual] = ACTIONS(3876),
    [anon_sym_volatile] = ACTIONS(3876),
    [anon_sym_where] = ACTIONS(3876),
    [anon_sym_notnull] = ACTIONS(3876),
    [anon_sym_unmanaged] = ACTIONS(3876),
    [anon_sym_checked] = ACTIONS(3876),
    [anon_sym_BANG] = ACTIONS(3878),
    [anon_sym_TILDE] = ACTIONS(3878),
    [anon_sym_PLUS_PLUS] = ACTIONS(3878),
    [anon_sym_DASH_DASH] = ACTIONS(3878),
    [anon_sym_true] = ACTIONS(3876),
    [anon_sym_false] = ACTIONS(3876),
    [anon_sym_PLUS] = ACTIONS(3876),
    [anon_sym_DASH] = ACTIONS(3876),
    [anon_sym_STAR] = ACTIONS(3878),
    [anon_sym_CARET] = ACTIONS(3878),
    [anon_sym_AMP] = ACTIONS(3878),
    [anon_sym_this] = ACTIONS(3876),
    [anon_sym_scoped] = ACTIONS(3876),
    [anon_sym_var] = ACTIONS(3876),
    [sym_predefined_type] = ACTIONS(3876),
    [anon_sym_break] = ACTIONS(3876),
    [anon_sym_unchecked] = ACTIONS(3876),
    [anon_sym_continue] = ACTIONS(3876),
    [anon_sym_do] = ACTIONS(3876),
    [anon_sym_while] = ACTIONS(3876),
    [anon_sym_for] = ACTIONS(3876),
    [anon_sym_lock] = ACTIONS(3876),
    [anon_sym_yield] = ACTIONS(3876),
    [anon_sym_switch] = ACTIONS(3876),
    [anon_sym_default] = ACTIONS(3876),
    [anon_sym_throw] = ACTIONS(3876),
    [anon_sym_try] = ACTIONS(3876),
    [anon_sym_when] = ACTIONS(3876),
    [anon_sym_await] = ACTIONS(3876),
    [anon_sym_foreach] = ACTIONS(3876),
    [anon_sym_goto] = ACTIONS(3876),
    [anon_sym_if] = ACTIONS(3876),
    [anon_sym_DOT_DOT] = ACTIONS(3878),
    [anon_sym_from] = ACTIONS(3876),
    [anon_sym_into] = ACTIONS(3876),
    [anon_sym_join] = ACTIONS(3876),
    [anon_sym_on] = ACTIONS(3876),
    [anon_sym_equals] = ACTIONS(3876),
    [anon_sym_let] = ACTIONS(3876),
    [anon_sym_orderby] = ACTIONS(3876),
    [anon_sym_ascending] = ACTIONS(3876),
    [anon_sym_descending] = ACTIONS(3876),
    [anon_sym_group] = ACTIONS(3876),
    [anon_sym_by] = ACTIONS(3876),
    [anon_sym_select] = ACTIONS(3876),
    [anon_sym_DQUOTE] = ACTIONS(3876),
    [anon_sym_stackalloc] = ACTIONS(3876),
    [anon_sym_sizeof] = ACTIONS(3876),
    [anon_sym_typeof] = ACTIONS(3876),
    [anon_sym___makeref] = ACTIONS(3876),
    [anon_sym___reftype] = ACTIONS(3876),
    [anon_sym___refvalue] = ACTIONS(3876),
    [sym_null_literal] = ACTIONS(3876),
    [anon_sym_SQUOTE] = ACTIONS(3878),
    [sym_integer_literal] = ACTIONS(3876),
    [sym_real_literal] = ACTIONS(3878),
    [sym_verbatim_string_literal] = ACTIONS(3878),
    [sym_raw_string_literal] = ACTIONS(3878),
    [aux_sym_preproc_if_token1] = ACTIONS(3878),
    [aux_sym_preproc_if_token3] = ACTIONS(3878),
    [aux_sym_preproc_else_token1] = ACTIONS(3878),
    [aux_sym_preproc_elif_token1] = ACTIONS(3878),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3878),
    [sym_interpolation_verbatim_start] = ACTIONS(3878),
    [sym_interpolation_raw_start] = ACTIONS(3878),
  },
  [2409] = {
    [sym_preproc_region] = STATE(2409),
    [sym_preproc_endregion] = STATE(2409),
    [sym_preproc_line] = STATE(2409),
    [sym_preproc_pragma] = STATE(2409),
    [sym_preproc_nullable] = STATE(2409),
    [sym_preproc_error] = STATE(2409),
    [sym_preproc_define] = STATE(2409),
    [sym_preproc_undef] = STATE(2409),
    [sym__identifier_token] = ACTIONS(3880),
    [anon_sym_extern] = ACTIONS(3880),
    [anon_sym_alias] = ACTIONS(3880),
    [anon_sym_SEMI] = ACTIONS(3882),
    [anon_sym_global] = ACTIONS(3880),
    [anon_sym_using] = ACTIONS(3880),
    [anon_sym_unsafe] = ACTIONS(3880),
    [anon_sym_static] = ACTIONS(3880),
    [anon_sym_LBRACK] = ACTIONS(3882),
    [anon_sym_LPAREN] = ACTIONS(3882),
    [anon_sym_return] = ACTIONS(3880),
    [anon_sym_namespace] = ACTIONS(3880),
    [anon_sym_class] = ACTIONS(3880),
    [anon_sym_ref] = ACTIONS(3880),
    [anon_sym_struct] = ACTIONS(3880),
    [anon_sym_enum] = ACTIONS(3880),
    [anon_sym_LBRACE] = ACTIONS(3882),
    [anon_sym_interface] = ACTIONS(3880),
    [anon_sym_delegate] = ACTIONS(3880),
    [anon_sym_record] = ACTIONS(3880),
    [anon_sym_abstract] = ACTIONS(3880),
    [anon_sym_async] = ACTIONS(3880),
    [anon_sym_const] = ACTIONS(3880),
    [anon_sym_file] = ACTIONS(3880),
    [anon_sym_fixed] = ACTIONS(3880),
    [anon_sym_internal] = ACTIONS(3880),
    [anon_sym_new] = ACTIONS(3880),
    [anon_sym_override] = ACTIONS(3880),
    [anon_sym_partial] = ACTIONS(3880),
    [anon_sym_private] = ACTIONS(3880),
    [anon_sym_protected] = ACTIONS(3880),
    [anon_sym_public] = ACTIONS(3880),
    [anon_sym_readonly] = ACTIONS(3880),
    [anon_sym_required] = ACTIONS(3880),
    [anon_sym_sealed] = ACTIONS(3880),
    [anon_sym_virtual] = ACTIONS(3880),
    [anon_sym_volatile] = ACTIONS(3880),
    [anon_sym_where] = ACTIONS(3880),
    [anon_sym_notnull] = ACTIONS(3880),
    [anon_sym_unmanaged] = ACTIONS(3880),
    [anon_sym_checked] = ACTIONS(3880),
    [anon_sym_BANG] = ACTIONS(3882),
    [anon_sym_TILDE] = ACTIONS(3882),
    [anon_sym_PLUS_PLUS] = ACTIONS(3882),
    [anon_sym_DASH_DASH] = ACTIONS(3882),
    [anon_sym_true] = ACTIONS(3880),
    [anon_sym_false] = ACTIONS(3880),
    [anon_sym_PLUS] = ACTIONS(3880),
    [anon_sym_DASH] = ACTIONS(3880),
    [anon_sym_STAR] = ACTIONS(3882),
    [anon_sym_CARET] = ACTIONS(3882),
    [anon_sym_AMP] = ACTIONS(3882),
    [anon_sym_this] = ACTIONS(3880),
    [anon_sym_scoped] = ACTIONS(3880),
    [anon_sym_var] = ACTIONS(3880),
    [sym_predefined_type] = ACTIONS(3880),
    [anon_sym_break] = ACTIONS(3880),
    [anon_sym_unchecked] = ACTIONS(3880),
    [anon_sym_continue] = ACTIONS(3880),
    [anon_sym_do] = ACTIONS(3880),
    [anon_sym_while] = ACTIONS(3880),
    [anon_sym_for] = ACTIONS(3880),
    [anon_sym_lock] = ACTIONS(3880),
    [anon_sym_yield] = ACTIONS(3880),
    [anon_sym_switch] = ACTIONS(3880),
    [anon_sym_default] = ACTIONS(3880),
    [anon_sym_throw] = ACTIONS(3880),
    [anon_sym_try] = ACTIONS(3880),
    [anon_sym_when] = ACTIONS(3880),
    [anon_sym_await] = ACTIONS(3880),
    [anon_sym_foreach] = ACTIONS(3880),
    [anon_sym_goto] = ACTIONS(3880),
    [anon_sym_if] = ACTIONS(3880),
    [anon_sym_DOT_DOT] = ACTIONS(3882),
    [anon_sym_from] = ACTIONS(3880),
    [anon_sym_into] = ACTIONS(3880),
    [anon_sym_join] = ACTIONS(3880),
    [anon_sym_on] = ACTIONS(3880),
    [anon_sym_equals] = ACTIONS(3880),
    [anon_sym_let] = ACTIONS(3880),
    [anon_sym_orderby] = ACTIONS(3880),
    [anon_sym_ascending] = ACTIONS(3880),
    [anon_sym_descending] = ACTIONS(3880),
    [anon_sym_group] = ACTIONS(3880),
    [anon_sym_by] = ACTIONS(3880),
    [anon_sym_select] = ACTIONS(3880),
    [anon_sym_DQUOTE] = ACTIONS(3880),
    [anon_sym_stackalloc] = ACTIONS(3880),
    [anon_sym_sizeof] = ACTIONS(3880),
    [anon_sym_typeof] = ACTIONS(3880),
    [anon_sym___makeref] = ACTIONS(3880),
    [anon_sym___reftype] = ACTIONS(3880),
    [anon_sym___refvalue] = ACTIONS(3880),
    [sym_null_literal] = ACTIONS(3880),
    [anon_sym_SQUOTE] = ACTIONS(3882),
    [sym_integer_literal] = ACTIONS(3880),
    [sym_real_literal] = ACTIONS(3882),
    [sym_verbatim_string_literal] = ACTIONS(3882),
    [sym_raw_string_literal] = ACTIONS(3882),
    [aux_sym_preproc_if_token1] = ACTIONS(3882),
    [aux_sym_preproc_if_token3] = ACTIONS(3882),
    [aux_sym_preproc_else_token1] = ACTIONS(3882),
    [aux_sym_preproc_elif_token1] = ACTIONS(3882),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3882),
    [sym_interpolation_verbatim_start] = ACTIONS(3882),
    [sym_interpolation_raw_start] = ACTIONS(3882),
  },
  [2410] = {
    [sym_preproc_region] = STATE(2410),
    [sym_preproc_endregion] = STATE(2410),
    [sym_preproc_line] = STATE(2410),
    [sym_preproc_pragma] = STATE(2410),
    [sym_preproc_nullable] = STATE(2410),
    [sym_preproc_error] = STATE(2410),
    [sym_preproc_define] = STATE(2410),
    [sym_preproc_undef] = STATE(2410),
    [sym__identifier_token] = ACTIONS(3884),
    [anon_sym_extern] = ACTIONS(3884),
    [anon_sym_alias] = ACTIONS(3884),
    [anon_sym_SEMI] = ACTIONS(3886),
    [anon_sym_global] = ACTIONS(3884),
    [anon_sym_using] = ACTIONS(3884),
    [anon_sym_unsafe] = ACTIONS(3884),
    [anon_sym_static] = ACTIONS(3884),
    [anon_sym_LBRACK] = ACTIONS(3886),
    [anon_sym_LPAREN] = ACTIONS(3886),
    [anon_sym_return] = ACTIONS(3884),
    [anon_sym_namespace] = ACTIONS(3884),
    [anon_sym_class] = ACTIONS(3884),
    [anon_sym_ref] = ACTIONS(3884),
    [anon_sym_struct] = ACTIONS(3884),
    [anon_sym_enum] = ACTIONS(3884),
    [anon_sym_LBRACE] = ACTIONS(3886),
    [anon_sym_interface] = ACTIONS(3884),
    [anon_sym_delegate] = ACTIONS(3884),
    [anon_sym_record] = ACTIONS(3884),
    [anon_sym_abstract] = ACTIONS(3884),
    [anon_sym_async] = ACTIONS(3884),
    [anon_sym_const] = ACTIONS(3884),
    [anon_sym_file] = ACTIONS(3884),
    [anon_sym_fixed] = ACTIONS(3884),
    [anon_sym_internal] = ACTIONS(3884),
    [anon_sym_new] = ACTIONS(3884),
    [anon_sym_override] = ACTIONS(3884),
    [anon_sym_partial] = ACTIONS(3884),
    [anon_sym_private] = ACTIONS(3884),
    [anon_sym_protected] = ACTIONS(3884),
    [anon_sym_public] = ACTIONS(3884),
    [anon_sym_readonly] = ACTIONS(3884),
    [anon_sym_required] = ACTIONS(3884),
    [anon_sym_sealed] = ACTIONS(3884),
    [anon_sym_virtual] = ACTIONS(3884),
    [anon_sym_volatile] = ACTIONS(3884),
    [anon_sym_where] = ACTIONS(3884),
    [anon_sym_notnull] = ACTIONS(3884),
    [anon_sym_unmanaged] = ACTIONS(3884),
    [anon_sym_checked] = ACTIONS(3884),
    [anon_sym_BANG] = ACTIONS(3886),
    [anon_sym_TILDE] = ACTIONS(3886),
    [anon_sym_PLUS_PLUS] = ACTIONS(3886),
    [anon_sym_DASH_DASH] = ACTIONS(3886),
    [anon_sym_true] = ACTIONS(3884),
    [anon_sym_false] = ACTIONS(3884),
    [anon_sym_PLUS] = ACTIONS(3884),
    [anon_sym_DASH] = ACTIONS(3884),
    [anon_sym_STAR] = ACTIONS(3886),
    [anon_sym_CARET] = ACTIONS(3886),
    [anon_sym_AMP] = ACTIONS(3886),
    [anon_sym_this] = ACTIONS(3884),
    [anon_sym_scoped] = ACTIONS(3884),
    [anon_sym_var] = ACTIONS(3884),
    [sym_predefined_type] = ACTIONS(3884),
    [anon_sym_break] = ACTIONS(3884),
    [anon_sym_unchecked] = ACTIONS(3884),
    [anon_sym_continue] = ACTIONS(3884),
    [anon_sym_do] = ACTIONS(3884),
    [anon_sym_while] = ACTIONS(3884),
    [anon_sym_for] = ACTIONS(3884),
    [anon_sym_lock] = ACTIONS(3884),
    [anon_sym_yield] = ACTIONS(3884),
    [anon_sym_switch] = ACTIONS(3884),
    [anon_sym_default] = ACTIONS(3884),
    [anon_sym_throw] = ACTIONS(3884),
    [anon_sym_try] = ACTIONS(3884),
    [anon_sym_when] = ACTIONS(3884),
    [anon_sym_await] = ACTIONS(3884),
    [anon_sym_foreach] = ACTIONS(3884),
    [anon_sym_goto] = ACTIONS(3884),
    [anon_sym_if] = ACTIONS(3884),
    [anon_sym_DOT_DOT] = ACTIONS(3886),
    [anon_sym_from] = ACTIONS(3884),
    [anon_sym_into] = ACTIONS(3884),
    [anon_sym_join] = ACTIONS(3884),
    [anon_sym_on] = ACTIONS(3884),
    [anon_sym_equals] = ACTIONS(3884),
    [anon_sym_let] = ACTIONS(3884),
    [anon_sym_orderby] = ACTIONS(3884),
    [anon_sym_ascending] = ACTIONS(3884),
    [anon_sym_descending] = ACTIONS(3884),
    [anon_sym_group] = ACTIONS(3884),
    [anon_sym_by] = ACTIONS(3884),
    [anon_sym_select] = ACTIONS(3884),
    [anon_sym_DQUOTE] = ACTIONS(3884),
    [anon_sym_stackalloc] = ACTIONS(3884),
    [anon_sym_sizeof] = ACTIONS(3884),
    [anon_sym_typeof] = ACTIONS(3884),
    [anon_sym___makeref] = ACTIONS(3884),
    [anon_sym___reftype] = ACTIONS(3884),
    [anon_sym___refvalue] = ACTIONS(3884),
    [sym_null_literal] = ACTIONS(3884),
    [anon_sym_SQUOTE] = ACTIONS(3886),
    [sym_integer_literal] = ACTIONS(3884),
    [sym_real_literal] = ACTIONS(3886),
    [sym_verbatim_string_literal] = ACTIONS(3886),
    [sym_raw_string_literal] = ACTIONS(3886),
    [aux_sym_preproc_if_token1] = ACTIONS(3886),
    [aux_sym_preproc_if_token3] = ACTIONS(3886),
    [aux_sym_preproc_else_token1] = ACTIONS(3886),
    [aux_sym_preproc_elif_token1] = ACTIONS(3886),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3886),
    [sym_interpolation_verbatim_start] = ACTIONS(3886),
    [sym_interpolation_raw_start] = ACTIONS(3886),
  },
  [2411] = {
    [sym_preproc_region] = STATE(2411),
    [sym_preproc_endregion] = STATE(2411),
    [sym_preproc_line] = STATE(2411),
    [sym_preproc_pragma] = STATE(2411),
    [sym_preproc_nullable] = STATE(2411),
    [sym_preproc_error] = STATE(2411),
    [sym_preproc_define] = STATE(2411),
    [sym_preproc_undef] = STATE(2411),
    [sym__identifier_token] = ACTIONS(3888),
    [anon_sym_extern] = ACTIONS(3888),
    [anon_sym_alias] = ACTIONS(3888),
    [anon_sym_SEMI] = ACTIONS(3890),
    [anon_sym_global] = ACTIONS(3888),
    [anon_sym_using] = ACTIONS(3888),
    [anon_sym_unsafe] = ACTIONS(3888),
    [anon_sym_static] = ACTIONS(3888),
    [anon_sym_LBRACK] = ACTIONS(3890),
    [anon_sym_LPAREN] = ACTIONS(3890),
    [anon_sym_return] = ACTIONS(3888),
    [anon_sym_namespace] = ACTIONS(3888),
    [anon_sym_class] = ACTIONS(3888),
    [anon_sym_ref] = ACTIONS(3888),
    [anon_sym_struct] = ACTIONS(3888),
    [anon_sym_enum] = ACTIONS(3888),
    [anon_sym_LBRACE] = ACTIONS(3890),
    [anon_sym_interface] = ACTIONS(3888),
    [anon_sym_delegate] = ACTIONS(3888),
    [anon_sym_record] = ACTIONS(3888),
    [anon_sym_abstract] = ACTIONS(3888),
    [anon_sym_async] = ACTIONS(3888),
    [anon_sym_const] = ACTIONS(3888),
    [anon_sym_file] = ACTIONS(3888),
    [anon_sym_fixed] = ACTIONS(3888),
    [anon_sym_internal] = ACTIONS(3888),
    [anon_sym_new] = ACTIONS(3888),
    [anon_sym_override] = ACTIONS(3888),
    [anon_sym_partial] = ACTIONS(3888),
    [anon_sym_private] = ACTIONS(3888),
    [anon_sym_protected] = ACTIONS(3888),
    [anon_sym_public] = ACTIONS(3888),
    [anon_sym_readonly] = ACTIONS(3888),
    [anon_sym_required] = ACTIONS(3888),
    [anon_sym_sealed] = ACTIONS(3888),
    [anon_sym_virtual] = ACTIONS(3888),
    [anon_sym_volatile] = ACTIONS(3888),
    [anon_sym_where] = ACTIONS(3888),
    [anon_sym_notnull] = ACTIONS(3888),
    [anon_sym_unmanaged] = ACTIONS(3888),
    [anon_sym_checked] = ACTIONS(3888),
    [anon_sym_BANG] = ACTIONS(3890),
    [anon_sym_TILDE] = ACTIONS(3890),
    [anon_sym_PLUS_PLUS] = ACTIONS(3890),
    [anon_sym_DASH_DASH] = ACTIONS(3890),
    [anon_sym_true] = ACTIONS(3888),
    [anon_sym_false] = ACTIONS(3888),
    [anon_sym_PLUS] = ACTIONS(3888),
    [anon_sym_DASH] = ACTIONS(3888),
    [anon_sym_STAR] = ACTIONS(3890),
    [anon_sym_CARET] = ACTIONS(3890),
    [anon_sym_AMP] = ACTIONS(3890),
    [anon_sym_this] = ACTIONS(3888),
    [anon_sym_scoped] = ACTIONS(3888),
    [anon_sym_var] = ACTIONS(3888),
    [sym_predefined_type] = ACTIONS(3888),
    [anon_sym_break] = ACTIONS(3888),
    [anon_sym_unchecked] = ACTIONS(3888),
    [anon_sym_continue] = ACTIONS(3888),
    [anon_sym_do] = ACTIONS(3888),
    [anon_sym_while] = ACTIONS(3888),
    [anon_sym_for] = ACTIONS(3888),
    [anon_sym_lock] = ACTIONS(3888),
    [anon_sym_yield] = ACTIONS(3888),
    [anon_sym_switch] = ACTIONS(3888),
    [anon_sym_default] = ACTIONS(3888),
    [anon_sym_throw] = ACTIONS(3888),
    [anon_sym_try] = ACTIONS(3888),
    [anon_sym_when] = ACTIONS(3888),
    [anon_sym_await] = ACTIONS(3888),
    [anon_sym_foreach] = ACTIONS(3888),
    [anon_sym_goto] = ACTIONS(3888),
    [anon_sym_if] = ACTIONS(3888),
    [anon_sym_DOT_DOT] = ACTIONS(3890),
    [anon_sym_from] = ACTIONS(3888),
    [anon_sym_into] = ACTIONS(3888),
    [anon_sym_join] = ACTIONS(3888),
    [anon_sym_on] = ACTIONS(3888),
    [anon_sym_equals] = ACTIONS(3888),
    [anon_sym_let] = ACTIONS(3888),
    [anon_sym_orderby] = ACTIONS(3888),
    [anon_sym_ascending] = ACTIONS(3888),
    [anon_sym_descending] = ACTIONS(3888),
    [anon_sym_group] = ACTIONS(3888),
    [anon_sym_by] = ACTIONS(3888),
    [anon_sym_select] = ACTIONS(3888),
    [anon_sym_DQUOTE] = ACTIONS(3888),
    [anon_sym_stackalloc] = ACTIONS(3888),
    [anon_sym_sizeof] = ACTIONS(3888),
    [anon_sym_typeof] = ACTIONS(3888),
    [anon_sym___makeref] = ACTIONS(3888),
    [anon_sym___reftype] = ACTIONS(3888),
    [anon_sym___refvalue] = ACTIONS(3888),
    [sym_null_literal] = ACTIONS(3888),
    [anon_sym_SQUOTE] = ACTIONS(3890),
    [sym_integer_literal] = ACTIONS(3888),
    [sym_real_literal] = ACTIONS(3890),
    [sym_verbatim_string_literal] = ACTIONS(3890),
    [sym_raw_string_literal] = ACTIONS(3890),
    [aux_sym_preproc_if_token1] = ACTIONS(3890),
    [aux_sym_preproc_if_token3] = ACTIONS(3890),
    [aux_sym_preproc_else_token1] = ACTIONS(3890),
    [aux_sym_preproc_elif_token1] = ACTIONS(3890),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3890),
    [sym_interpolation_verbatim_start] = ACTIONS(3890),
    [sym_interpolation_raw_start] = ACTIONS(3890),
  },
  [2412] = {
    [sym_preproc_region] = STATE(2412),
    [sym_preproc_endregion] = STATE(2412),
    [sym_preproc_line] = STATE(2412),
    [sym_preproc_pragma] = STATE(2412),
    [sym_preproc_nullable] = STATE(2412),
    [sym_preproc_error] = STATE(2412),
    [sym_preproc_define] = STATE(2412),
    [sym_preproc_undef] = STATE(2412),
    [sym__identifier_token] = ACTIONS(3892),
    [anon_sym_extern] = ACTIONS(3892),
    [anon_sym_alias] = ACTIONS(3892),
    [anon_sym_SEMI] = ACTIONS(3894),
    [anon_sym_global] = ACTIONS(3892),
    [anon_sym_using] = ACTIONS(3892),
    [anon_sym_unsafe] = ACTIONS(3892),
    [anon_sym_static] = ACTIONS(3892),
    [anon_sym_LBRACK] = ACTIONS(3894),
    [anon_sym_LPAREN] = ACTIONS(3894),
    [anon_sym_return] = ACTIONS(3892),
    [anon_sym_namespace] = ACTIONS(3892),
    [anon_sym_class] = ACTIONS(3892),
    [anon_sym_ref] = ACTIONS(3892),
    [anon_sym_struct] = ACTIONS(3892),
    [anon_sym_enum] = ACTIONS(3892),
    [anon_sym_LBRACE] = ACTIONS(3894),
    [anon_sym_interface] = ACTIONS(3892),
    [anon_sym_delegate] = ACTIONS(3892),
    [anon_sym_record] = ACTIONS(3892),
    [anon_sym_abstract] = ACTIONS(3892),
    [anon_sym_async] = ACTIONS(3892),
    [anon_sym_const] = ACTIONS(3892),
    [anon_sym_file] = ACTIONS(3892),
    [anon_sym_fixed] = ACTIONS(3892),
    [anon_sym_internal] = ACTIONS(3892),
    [anon_sym_new] = ACTIONS(3892),
    [anon_sym_override] = ACTIONS(3892),
    [anon_sym_partial] = ACTIONS(3892),
    [anon_sym_private] = ACTIONS(3892),
    [anon_sym_protected] = ACTIONS(3892),
    [anon_sym_public] = ACTIONS(3892),
    [anon_sym_readonly] = ACTIONS(3892),
    [anon_sym_required] = ACTIONS(3892),
    [anon_sym_sealed] = ACTIONS(3892),
    [anon_sym_virtual] = ACTIONS(3892),
    [anon_sym_volatile] = ACTIONS(3892),
    [anon_sym_where] = ACTIONS(3892),
    [anon_sym_notnull] = ACTIONS(3892),
    [anon_sym_unmanaged] = ACTIONS(3892),
    [anon_sym_checked] = ACTIONS(3892),
    [anon_sym_BANG] = ACTIONS(3894),
    [anon_sym_TILDE] = ACTIONS(3894),
    [anon_sym_PLUS_PLUS] = ACTIONS(3894),
    [anon_sym_DASH_DASH] = ACTIONS(3894),
    [anon_sym_true] = ACTIONS(3892),
    [anon_sym_false] = ACTIONS(3892),
    [anon_sym_PLUS] = ACTIONS(3892),
    [anon_sym_DASH] = ACTIONS(3892),
    [anon_sym_STAR] = ACTIONS(3894),
    [anon_sym_CARET] = ACTIONS(3894),
    [anon_sym_AMP] = ACTIONS(3894),
    [anon_sym_this] = ACTIONS(3892),
    [anon_sym_scoped] = ACTIONS(3892),
    [anon_sym_var] = ACTIONS(3892),
    [sym_predefined_type] = ACTIONS(3892),
    [anon_sym_break] = ACTIONS(3892),
    [anon_sym_unchecked] = ACTIONS(3892),
    [anon_sym_continue] = ACTIONS(3892),
    [anon_sym_do] = ACTIONS(3892),
    [anon_sym_while] = ACTIONS(3892),
    [anon_sym_for] = ACTIONS(3892),
    [anon_sym_lock] = ACTIONS(3892),
    [anon_sym_yield] = ACTIONS(3892),
    [anon_sym_switch] = ACTIONS(3892),
    [anon_sym_default] = ACTIONS(3892),
    [anon_sym_throw] = ACTIONS(3892),
    [anon_sym_try] = ACTIONS(3892),
    [anon_sym_when] = ACTIONS(3892),
    [anon_sym_await] = ACTIONS(3892),
    [anon_sym_foreach] = ACTIONS(3892),
    [anon_sym_goto] = ACTIONS(3892),
    [anon_sym_if] = ACTIONS(3892),
    [anon_sym_DOT_DOT] = ACTIONS(3894),
    [anon_sym_from] = ACTIONS(3892),
    [anon_sym_into] = ACTIONS(3892),
    [anon_sym_join] = ACTIONS(3892),
    [anon_sym_on] = ACTIONS(3892),
    [anon_sym_equals] = ACTIONS(3892),
    [anon_sym_let] = ACTIONS(3892),
    [anon_sym_orderby] = ACTIONS(3892),
    [anon_sym_ascending] = ACTIONS(3892),
    [anon_sym_descending] = ACTIONS(3892),
    [anon_sym_group] = ACTIONS(3892),
    [anon_sym_by] = ACTIONS(3892),
    [anon_sym_select] = ACTIONS(3892),
    [anon_sym_DQUOTE] = ACTIONS(3892),
    [anon_sym_stackalloc] = ACTIONS(3892),
    [anon_sym_sizeof] = ACTIONS(3892),
    [anon_sym_typeof] = ACTIONS(3892),
    [anon_sym___makeref] = ACTIONS(3892),
    [anon_sym___reftype] = ACTIONS(3892),
    [anon_sym___refvalue] = ACTIONS(3892),
    [sym_null_literal] = ACTIONS(3892),
    [anon_sym_SQUOTE] = ACTIONS(3894),
    [sym_integer_literal] = ACTIONS(3892),
    [sym_real_literal] = ACTIONS(3894),
    [sym_verbatim_string_literal] = ACTIONS(3894),
    [sym_raw_string_literal] = ACTIONS(3894),
    [aux_sym_preproc_if_token1] = ACTIONS(3894),
    [aux_sym_preproc_if_token3] = ACTIONS(3894),
    [aux_sym_preproc_else_token1] = ACTIONS(3894),
    [aux_sym_preproc_elif_token1] = ACTIONS(3894),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3894),
    [sym_interpolation_verbatim_start] = ACTIONS(3894),
    [sym_interpolation_raw_start] = ACTIONS(3894),
  },
  [2413] = {
    [sym_preproc_region] = STATE(2413),
    [sym_preproc_endregion] = STATE(2413),
    [sym_preproc_line] = STATE(2413),
    [sym_preproc_pragma] = STATE(2413),
    [sym_preproc_nullable] = STATE(2413),
    [sym_preproc_error] = STATE(2413),
    [sym_preproc_define] = STATE(2413),
    [sym_preproc_undef] = STATE(2413),
    [sym__identifier_token] = ACTIONS(3896),
    [anon_sym_extern] = ACTIONS(3896),
    [anon_sym_alias] = ACTIONS(3896),
    [anon_sym_SEMI] = ACTIONS(3898),
    [anon_sym_global] = ACTIONS(3896),
    [anon_sym_using] = ACTIONS(3896),
    [anon_sym_unsafe] = ACTIONS(3896),
    [anon_sym_static] = ACTIONS(3896),
    [anon_sym_LBRACK] = ACTIONS(3898),
    [anon_sym_LPAREN] = ACTIONS(3898),
    [anon_sym_return] = ACTIONS(3896),
    [anon_sym_namespace] = ACTIONS(3896),
    [anon_sym_class] = ACTIONS(3896),
    [anon_sym_ref] = ACTIONS(3896),
    [anon_sym_struct] = ACTIONS(3896),
    [anon_sym_enum] = ACTIONS(3896),
    [anon_sym_LBRACE] = ACTIONS(3898),
    [anon_sym_interface] = ACTIONS(3896),
    [anon_sym_delegate] = ACTIONS(3896),
    [anon_sym_record] = ACTIONS(3896),
    [anon_sym_abstract] = ACTIONS(3896),
    [anon_sym_async] = ACTIONS(3896),
    [anon_sym_const] = ACTIONS(3896),
    [anon_sym_file] = ACTIONS(3896),
    [anon_sym_fixed] = ACTIONS(3896),
    [anon_sym_internal] = ACTIONS(3896),
    [anon_sym_new] = ACTIONS(3896),
    [anon_sym_override] = ACTIONS(3896),
    [anon_sym_partial] = ACTIONS(3896),
    [anon_sym_private] = ACTIONS(3896),
    [anon_sym_protected] = ACTIONS(3896),
    [anon_sym_public] = ACTIONS(3896),
    [anon_sym_readonly] = ACTIONS(3896),
    [anon_sym_required] = ACTIONS(3896),
    [anon_sym_sealed] = ACTIONS(3896),
    [anon_sym_virtual] = ACTIONS(3896),
    [anon_sym_volatile] = ACTIONS(3896),
    [anon_sym_where] = ACTIONS(3896),
    [anon_sym_notnull] = ACTIONS(3896),
    [anon_sym_unmanaged] = ACTIONS(3896),
    [anon_sym_checked] = ACTIONS(3896),
    [anon_sym_BANG] = ACTIONS(3898),
    [anon_sym_TILDE] = ACTIONS(3898),
    [anon_sym_PLUS_PLUS] = ACTIONS(3898),
    [anon_sym_DASH_DASH] = ACTIONS(3898),
    [anon_sym_true] = ACTIONS(3896),
    [anon_sym_false] = ACTIONS(3896),
    [anon_sym_PLUS] = ACTIONS(3896),
    [anon_sym_DASH] = ACTIONS(3896),
    [anon_sym_STAR] = ACTIONS(3898),
    [anon_sym_CARET] = ACTIONS(3898),
    [anon_sym_AMP] = ACTIONS(3898),
    [anon_sym_this] = ACTIONS(3896),
    [anon_sym_scoped] = ACTIONS(3896),
    [anon_sym_var] = ACTIONS(3896),
    [sym_predefined_type] = ACTIONS(3896),
    [anon_sym_break] = ACTIONS(3896),
    [anon_sym_unchecked] = ACTIONS(3896),
    [anon_sym_continue] = ACTIONS(3896),
    [anon_sym_do] = ACTIONS(3896),
    [anon_sym_while] = ACTIONS(3896),
    [anon_sym_for] = ACTIONS(3896),
    [anon_sym_lock] = ACTIONS(3896),
    [anon_sym_yield] = ACTIONS(3896),
    [anon_sym_switch] = ACTIONS(3896),
    [anon_sym_default] = ACTIONS(3896),
    [anon_sym_throw] = ACTIONS(3896),
    [anon_sym_try] = ACTIONS(3896),
    [anon_sym_when] = ACTIONS(3896),
    [anon_sym_await] = ACTIONS(3896),
    [anon_sym_foreach] = ACTIONS(3896),
    [anon_sym_goto] = ACTIONS(3896),
    [anon_sym_if] = ACTIONS(3896),
    [anon_sym_DOT_DOT] = ACTIONS(3898),
    [anon_sym_from] = ACTIONS(3896),
    [anon_sym_into] = ACTIONS(3896),
    [anon_sym_join] = ACTIONS(3896),
    [anon_sym_on] = ACTIONS(3896),
    [anon_sym_equals] = ACTIONS(3896),
    [anon_sym_let] = ACTIONS(3896),
    [anon_sym_orderby] = ACTIONS(3896),
    [anon_sym_ascending] = ACTIONS(3896),
    [anon_sym_descending] = ACTIONS(3896),
    [anon_sym_group] = ACTIONS(3896),
    [anon_sym_by] = ACTIONS(3896),
    [anon_sym_select] = ACTIONS(3896),
    [anon_sym_DQUOTE] = ACTIONS(3896),
    [anon_sym_stackalloc] = ACTIONS(3896),
    [anon_sym_sizeof] = ACTIONS(3896),
    [anon_sym_typeof] = ACTIONS(3896),
    [anon_sym___makeref] = ACTIONS(3896),
    [anon_sym___reftype] = ACTIONS(3896),
    [anon_sym___refvalue] = ACTIONS(3896),
    [sym_null_literal] = ACTIONS(3896),
    [anon_sym_SQUOTE] = ACTIONS(3898),
    [sym_integer_literal] = ACTIONS(3896),
    [sym_real_literal] = ACTIONS(3898),
    [sym_verbatim_string_literal] = ACTIONS(3898),
    [sym_raw_string_literal] = ACTIONS(3898),
    [aux_sym_preproc_if_token1] = ACTIONS(3898),
    [aux_sym_preproc_if_token3] = ACTIONS(3898),
    [aux_sym_preproc_else_token1] = ACTIONS(3898),
    [aux_sym_preproc_elif_token1] = ACTIONS(3898),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3898),
    [sym_interpolation_verbatim_start] = ACTIONS(3898),
    [sym_interpolation_raw_start] = ACTIONS(3898),
  },
  [2414] = {
    [sym_preproc_region] = STATE(2414),
    [sym_preproc_endregion] = STATE(2414),
    [sym_preproc_line] = STATE(2414),
    [sym_preproc_pragma] = STATE(2414),
    [sym_preproc_nullable] = STATE(2414),
    [sym_preproc_error] = STATE(2414),
    [sym_preproc_define] = STATE(2414),
    [sym_preproc_undef] = STATE(2414),
    [sym__identifier_token] = ACTIONS(3900),
    [anon_sym_extern] = ACTIONS(3900),
    [anon_sym_alias] = ACTIONS(3900),
    [anon_sym_SEMI] = ACTIONS(3902),
    [anon_sym_global] = ACTIONS(3900),
    [anon_sym_using] = ACTIONS(3900),
    [anon_sym_unsafe] = ACTIONS(3900),
    [anon_sym_static] = ACTIONS(3900),
    [anon_sym_LBRACK] = ACTIONS(3902),
    [anon_sym_LPAREN] = ACTIONS(3902),
    [anon_sym_return] = ACTIONS(3900),
    [anon_sym_namespace] = ACTIONS(3900),
    [anon_sym_class] = ACTIONS(3900),
    [anon_sym_ref] = ACTIONS(3900),
    [anon_sym_struct] = ACTIONS(3900),
    [anon_sym_enum] = ACTIONS(3900),
    [anon_sym_LBRACE] = ACTIONS(3902),
    [anon_sym_interface] = ACTIONS(3900),
    [anon_sym_delegate] = ACTIONS(3900),
    [anon_sym_record] = ACTIONS(3900),
    [anon_sym_abstract] = ACTIONS(3900),
    [anon_sym_async] = ACTIONS(3900),
    [anon_sym_const] = ACTIONS(3900),
    [anon_sym_file] = ACTIONS(3900),
    [anon_sym_fixed] = ACTIONS(3900),
    [anon_sym_internal] = ACTIONS(3900),
    [anon_sym_new] = ACTIONS(3900),
    [anon_sym_override] = ACTIONS(3900),
    [anon_sym_partial] = ACTIONS(3900),
    [anon_sym_private] = ACTIONS(3900),
    [anon_sym_protected] = ACTIONS(3900),
    [anon_sym_public] = ACTIONS(3900),
    [anon_sym_readonly] = ACTIONS(3900),
    [anon_sym_required] = ACTIONS(3900),
    [anon_sym_sealed] = ACTIONS(3900),
    [anon_sym_virtual] = ACTIONS(3900),
    [anon_sym_volatile] = ACTIONS(3900),
    [anon_sym_where] = ACTIONS(3900),
    [anon_sym_notnull] = ACTIONS(3900),
    [anon_sym_unmanaged] = ACTIONS(3900),
    [anon_sym_checked] = ACTIONS(3900),
    [anon_sym_BANG] = ACTIONS(3902),
    [anon_sym_TILDE] = ACTIONS(3902),
    [anon_sym_PLUS_PLUS] = ACTIONS(3902),
    [anon_sym_DASH_DASH] = ACTIONS(3902),
    [anon_sym_true] = ACTIONS(3900),
    [anon_sym_false] = ACTIONS(3900),
    [anon_sym_PLUS] = ACTIONS(3900),
    [anon_sym_DASH] = ACTIONS(3900),
    [anon_sym_STAR] = ACTIONS(3902),
    [anon_sym_CARET] = ACTIONS(3902),
    [anon_sym_AMP] = ACTIONS(3902),
    [anon_sym_this] = ACTIONS(3900),
    [anon_sym_scoped] = ACTIONS(3900),
    [anon_sym_var] = ACTIONS(3900),
    [sym_predefined_type] = ACTIONS(3900),
    [anon_sym_break] = ACTIONS(3900),
    [anon_sym_unchecked] = ACTIONS(3900),
    [anon_sym_continue] = ACTIONS(3900),
    [anon_sym_do] = ACTIONS(3900),
    [anon_sym_while] = ACTIONS(3900),
    [anon_sym_for] = ACTIONS(3900),
    [anon_sym_lock] = ACTIONS(3900),
    [anon_sym_yield] = ACTIONS(3900),
    [anon_sym_switch] = ACTIONS(3900),
    [anon_sym_default] = ACTIONS(3900),
    [anon_sym_throw] = ACTIONS(3900),
    [anon_sym_try] = ACTIONS(3900),
    [anon_sym_when] = ACTIONS(3900),
    [anon_sym_await] = ACTIONS(3900),
    [anon_sym_foreach] = ACTIONS(3900),
    [anon_sym_goto] = ACTIONS(3900),
    [anon_sym_if] = ACTIONS(3900),
    [anon_sym_DOT_DOT] = ACTIONS(3902),
    [anon_sym_from] = ACTIONS(3900),
    [anon_sym_into] = ACTIONS(3900),
    [anon_sym_join] = ACTIONS(3900),
    [anon_sym_on] = ACTIONS(3900),
    [anon_sym_equals] = ACTIONS(3900),
    [anon_sym_let] = ACTIONS(3900),
    [anon_sym_orderby] = ACTIONS(3900),
    [anon_sym_ascending] = ACTIONS(3900),
    [anon_sym_descending] = ACTIONS(3900),
    [anon_sym_group] = ACTIONS(3900),
    [anon_sym_by] = ACTIONS(3900),
    [anon_sym_select] = ACTIONS(3900),
    [anon_sym_DQUOTE] = ACTIONS(3900),
    [anon_sym_stackalloc] = ACTIONS(3900),
    [anon_sym_sizeof] = ACTIONS(3900),
    [anon_sym_typeof] = ACTIONS(3900),
    [anon_sym___makeref] = ACTIONS(3900),
    [anon_sym___reftype] = ACTIONS(3900),
    [anon_sym___refvalue] = ACTIONS(3900),
    [sym_null_literal] = ACTIONS(3900),
    [anon_sym_SQUOTE] = ACTIONS(3902),
    [sym_integer_literal] = ACTIONS(3900),
    [sym_real_literal] = ACTIONS(3902),
    [sym_verbatim_string_literal] = ACTIONS(3902),
    [sym_raw_string_literal] = ACTIONS(3902),
    [aux_sym_preproc_if_token1] = ACTIONS(3902),
    [aux_sym_preproc_if_token3] = ACTIONS(3902),
    [aux_sym_preproc_else_token1] = ACTIONS(3902),
    [aux_sym_preproc_elif_token1] = ACTIONS(3902),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3902),
    [sym_interpolation_verbatim_start] = ACTIONS(3902),
    [sym_interpolation_raw_start] = ACTIONS(3902),
  },
  [2415] = {
    [sym_preproc_region] = STATE(2415),
    [sym_preproc_endregion] = STATE(2415),
    [sym_preproc_line] = STATE(2415),
    [sym_preproc_pragma] = STATE(2415),
    [sym_preproc_nullable] = STATE(2415),
    [sym_preproc_error] = STATE(2415),
    [sym_preproc_define] = STATE(2415),
    [sym_preproc_undef] = STATE(2415),
    [sym__identifier_token] = ACTIONS(3904),
    [anon_sym_extern] = ACTIONS(3904),
    [anon_sym_alias] = ACTIONS(3904),
    [anon_sym_SEMI] = ACTIONS(3906),
    [anon_sym_global] = ACTIONS(3904),
    [anon_sym_using] = ACTIONS(3904),
    [anon_sym_unsafe] = ACTIONS(3904),
    [anon_sym_static] = ACTIONS(3904),
    [anon_sym_LBRACK] = ACTIONS(3906),
    [anon_sym_LPAREN] = ACTIONS(3906),
    [anon_sym_return] = ACTIONS(3904),
    [anon_sym_namespace] = ACTIONS(3904),
    [anon_sym_class] = ACTIONS(3904),
    [anon_sym_ref] = ACTIONS(3904),
    [anon_sym_struct] = ACTIONS(3904),
    [anon_sym_enum] = ACTIONS(3904),
    [anon_sym_LBRACE] = ACTIONS(3906),
    [anon_sym_interface] = ACTIONS(3904),
    [anon_sym_delegate] = ACTIONS(3904),
    [anon_sym_record] = ACTIONS(3904),
    [anon_sym_abstract] = ACTIONS(3904),
    [anon_sym_async] = ACTIONS(3904),
    [anon_sym_const] = ACTIONS(3904),
    [anon_sym_file] = ACTIONS(3904),
    [anon_sym_fixed] = ACTIONS(3904),
    [anon_sym_internal] = ACTIONS(3904),
    [anon_sym_new] = ACTIONS(3904),
    [anon_sym_override] = ACTIONS(3904),
    [anon_sym_partial] = ACTIONS(3904),
    [anon_sym_private] = ACTIONS(3904),
    [anon_sym_protected] = ACTIONS(3904),
    [anon_sym_public] = ACTIONS(3904),
    [anon_sym_readonly] = ACTIONS(3904),
    [anon_sym_required] = ACTIONS(3904),
    [anon_sym_sealed] = ACTIONS(3904),
    [anon_sym_virtual] = ACTIONS(3904),
    [anon_sym_volatile] = ACTIONS(3904),
    [anon_sym_where] = ACTIONS(3904),
    [anon_sym_notnull] = ACTIONS(3904),
    [anon_sym_unmanaged] = ACTIONS(3904),
    [anon_sym_checked] = ACTIONS(3904),
    [anon_sym_BANG] = ACTIONS(3906),
    [anon_sym_TILDE] = ACTIONS(3906),
    [anon_sym_PLUS_PLUS] = ACTIONS(3906),
    [anon_sym_DASH_DASH] = ACTIONS(3906),
    [anon_sym_true] = ACTIONS(3904),
    [anon_sym_false] = ACTIONS(3904),
    [anon_sym_PLUS] = ACTIONS(3904),
    [anon_sym_DASH] = ACTIONS(3904),
    [anon_sym_STAR] = ACTIONS(3906),
    [anon_sym_CARET] = ACTIONS(3906),
    [anon_sym_AMP] = ACTIONS(3906),
    [anon_sym_this] = ACTIONS(3904),
    [anon_sym_scoped] = ACTIONS(3904),
    [anon_sym_var] = ACTIONS(3904),
    [sym_predefined_type] = ACTIONS(3904),
    [anon_sym_break] = ACTIONS(3904),
    [anon_sym_unchecked] = ACTIONS(3904),
    [anon_sym_continue] = ACTIONS(3904),
    [anon_sym_do] = ACTIONS(3904),
    [anon_sym_while] = ACTIONS(3904),
    [anon_sym_for] = ACTIONS(3904),
    [anon_sym_lock] = ACTIONS(3904),
    [anon_sym_yield] = ACTIONS(3904),
    [anon_sym_switch] = ACTIONS(3904),
    [anon_sym_default] = ACTIONS(3904),
    [anon_sym_throw] = ACTIONS(3904),
    [anon_sym_try] = ACTIONS(3904),
    [anon_sym_when] = ACTIONS(3904),
    [anon_sym_await] = ACTIONS(3904),
    [anon_sym_foreach] = ACTIONS(3904),
    [anon_sym_goto] = ACTIONS(3904),
    [anon_sym_if] = ACTIONS(3904),
    [anon_sym_DOT_DOT] = ACTIONS(3906),
    [anon_sym_from] = ACTIONS(3904),
    [anon_sym_into] = ACTIONS(3904),
    [anon_sym_join] = ACTIONS(3904),
    [anon_sym_on] = ACTIONS(3904),
    [anon_sym_equals] = ACTIONS(3904),
    [anon_sym_let] = ACTIONS(3904),
    [anon_sym_orderby] = ACTIONS(3904),
    [anon_sym_ascending] = ACTIONS(3904),
    [anon_sym_descending] = ACTIONS(3904),
    [anon_sym_group] = ACTIONS(3904),
    [anon_sym_by] = ACTIONS(3904),
    [anon_sym_select] = ACTIONS(3904),
    [anon_sym_DQUOTE] = ACTIONS(3904),
    [anon_sym_stackalloc] = ACTIONS(3904),
    [anon_sym_sizeof] = ACTIONS(3904),
    [anon_sym_typeof] = ACTIONS(3904),
    [anon_sym___makeref] = ACTIONS(3904),
    [anon_sym___reftype] = ACTIONS(3904),
    [anon_sym___refvalue] = ACTIONS(3904),
    [sym_null_literal] = ACTIONS(3904),
    [anon_sym_SQUOTE] = ACTIONS(3906),
    [sym_integer_literal] = ACTIONS(3904),
    [sym_real_literal] = ACTIONS(3906),
    [sym_verbatim_string_literal] = ACTIONS(3906),
    [sym_raw_string_literal] = ACTIONS(3906),
    [aux_sym_preproc_if_token1] = ACTIONS(3906),
    [aux_sym_preproc_if_token3] = ACTIONS(3906),
    [aux_sym_preproc_else_token1] = ACTIONS(3906),
    [aux_sym_preproc_elif_token1] = ACTIONS(3906),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3906),
    [sym_interpolation_verbatim_start] = ACTIONS(3906),
    [sym_interpolation_raw_start] = ACTIONS(3906),
  },
  [2416] = {
    [sym_preproc_region] = STATE(2416),
    [sym_preproc_endregion] = STATE(2416),
    [sym_preproc_line] = STATE(2416),
    [sym_preproc_pragma] = STATE(2416),
    [sym_preproc_nullable] = STATE(2416),
    [sym_preproc_error] = STATE(2416),
    [sym_preproc_define] = STATE(2416),
    [sym_preproc_undef] = STATE(2416),
    [sym__identifier_token] = ACTIONS(3908),
    [anon_sym_extern] = ACTIONS(3908),
    [anon_sym_alias] = ACTIONS(3908),
    [anon_sym_SEMI] = ACTIONS(3910),
    [anon_sym_global] = ACTIONS(3908),
    [anon_sym_using] = ACTIONS(3908),
    [anon_sym_unsafe] = ACTIONS(3908),
    [anon_sym_static] = ACTIONS(3908),
    [anon_sym_LBRACK] = ACTIONS(3910),
    [anon_sym_LPAREN] = ACTIONS(3910),
    [anon_sym_return] = ACTIONS(3908),
    [anon_sym_namespace] = ACTIONS(3908),
    [anon_sym_class] = ACTIONS(3908),
    [anon_sym_ref] = ACTIONS(3908),
    [anon_sym_struct] = ACTIONS(3908),
    [anon_sym_enum] = ACTIONS(3908),
    [anon_sym_LBRACE] = ACTIONS(3910),
    [anon_sym_interface] = ACTIONS(3908),
    [anon_sym_delegate] = ACTIONS(3908),
    [anon_sym_record] = ACTIONS(3908),
    [anon_sym_abstract] = ACTIONS(3908),
    [anon_sym_async] = ACTIONS(3908),
    [anon_sym_const] = ACTIONS(3908),
    [anon_sym_file] = ACTIONS(3908),
    [anon_sym_fixed] = ACTIONS(3908),
    [anon_sym_internal] = ACTIONS(3908),
    [anon_sym_new] = ACTIONS(3908),
    [anon_sym_override] = ACTIONS(3908),
    [anon_sym_partial] = ACTIONS(3908),
    [anon_sym_private] = ACTIONS(3908),
    [anon_sym_protected] = ACTIONS(3908),
    [anon_sym_public] = ACTIONS(3908),
    [anon_sym_readonly] = ACTIONS(3908),
    [anon_sym_required] = ACTIONS(3908),
    [anon_sym_sealed] = ACTIONS(3908),
    [anon_sym_virtual] = ACTIONS(3908),
    [anon_sym_volatile] = ACTIONS(3908),
    [anon_sym_where] = ACTIONS(3908),
    [anon_sym_notnull] = ACTIONS(3908),
    [anon_sym_unmanaged] = ACTIONS(3908),
    [anon_sym_checked] = ACTIONS(3908),
    [anon_sym_BANG] = ACTIONS(3910),
    [anon_sym_TILDE] = ACTIONS(3910),
    [anon_sym_PLUS_PLUS] = ACTIONS(3910),
    [anon_sym_DASH_DASH] = ACTIONS(3910),
    [anon_sym_true] = ACTIONS(3908),
    [anon_sym_false] = ACTIONS(3908),
    [anon_sym_PLUS] = ACTIONS(3908),
    [anon_sym_DASH] = ACTIONS(3908),
    [anon_sym_STAR] = ACTIONS(3910),
    [anon_sym_CARET] = ACTIONS(3910),
    [anon_sym_AMP] = ACTIONS(3910),
    [anon_sym_this] = ACTIONS(3908),
    [anon_sym_scoped] = ACTIONS(3908),
    [anon_sym_var] = ACTIONS(3908),
    [sym_predefined_type] = ACTIONS(3908),
    [anon_sym_break] = ACTIONS(3908),
    [anon_sym_unchecked] = ACTIONS(3908),
    [anon_sym_continue] = ACTIONS(3908),
    [anon_sym_do] = ACTIONS(3908),
    [anon_sym_while] = ACTIONS(3908),
    [anon_sym_for] = ACTIONS(3908),
    [anon_sym_lock] = ACTIONS(3908),
    [anon_sym_yield] = ACTIONS(3908),
    [anon_sym_switch] = ACTIONS(3908),
    [anon_sym_default] = ACTIONS(3908),
    [anon_sym_throw] = ACTIONS(3908),
    [anon_sym_try] = ACTIONS(3908),
    [anon_sym_when] = ACTIONS(3908),
    [anon_sym_await] = ACTIONS(3908),
    [anon_sym_foreach] = ACTIONS(3908),
    [anon_sym_goto] = ACTIONS(3908),
    [anon_sym_if] = ACTIONS(3908),
    [anon_sym_DOT_DOT] = ACTIONS(3910),
    [anon_sym_from] = ACTIONS(3908),
    [anon_sym_into] = ACTIONS(3908),
    [anon_sym_join] = ACTIONS(3908),
    [anon_sym_on] = ACTIONS(3908),
    [anon_sym_equals] = ACTIONS(3908),
    [anon_sym_let] = ACTIONS(3908),
    [anon_sym_orderby] = ACTIONS(3908),
    [anon_sym_ascending] = ACTIONS(3908),
    [anon_sym_descending] = ACTIONS(3908),
    [anon_sym_group] = ACTIONS(3908),
    [anon_sym_by] = ACTIONS(3908),
    [anon_sym_select] = ACTIONS(3908),
    [anon_sym_DQUOTE] = ACTIONS(3908),
    [anon_sym_stackalloc] = ACTIONS(3908),
    [anon_sym_sizeof] = ACTIONS(3908),
    [anon_sym_typeof] = ACTIONS(3908),
    [anon_sym___makeref] = ACTIONS(3908),
    [anon_sym___reftype] = ACTIONS(3908),
    [anon_sym___refvalue] = ACTIONS(3908),
    [sym_null_literal] = ACTIONS(3908),
    [anon_sym_SQUOTE] = ACTIONS(3910),
    [sym_integer_literal] = ACTIONS(3908),
    [sym_real_literal] = ACTIONS(3910),
    [sym_verbatim_string_literal] = ACTIONS(3910),
    [sym_raw_string_literal] = ACTIONS(3910),
    [aux_sym_preproc_if_token1] = ACTIONS(3910),
    [aux_sym_preproc_if_token3] = ACTIONS(3910),
    [aux_sym_preproc_else_token1] = ACTIONS(3910),
    [aux_sym_preproc_elif_token1] = ACTIONS(3910),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3910),
    [sym_interpolation_verbatim_start] = ACTIONS(3910),
    [sym_interpolation_raw_start] = ACTIONS(3910),
  },
  [2417] = {
    [sym_preproc_region] = STATE(2417),
    [sym_preproc_endregion] = STATE(2417),
    [sym_preproc_line] = STATE(2417),
    [sym_preproc_pragma] = STATE(2417),
    [sym_preproc_nullable] = STATE(2417),
    [sym_preproc_error] = STATE(2417),
    [sym_preproc_define] = STATE(2417),
    [sym_preproc_undef] = STATE(2417),
    [sym__identifier_token] = ACTIONS(3912),
    [anon_sym_extern] = ACTIONS(3912),
    [anon_sym_alias] = ACTIONS(3912),
    [anon_sym_SEMI] = ACTIONS(3914),
    [anon_sym_global] = ACTIONS(3912),
    [anon_sym_using] = ACTIONS(3912),
    [anon_sym_unsafe] = ACTIONS(3912),
    [anon_sym_static] = ACTIONS(3912),
    [anon_sym_LBRACK] = ACTIONS(3914),
    [anon_sym_LPAREN] = ACTIONS(3914),
    [anon_sym_return] = ACTIONS(3912),
    [anon_sym_namespace] = ACTIONS(3912),
    [anon_sym_class] = ACTIONS(3912),
    [anon_sym_ref] = ACTIONS(3912),
    [anon_sym_struct] = ACTIONS(3912),
    [anon_sym_enum] = ACTIONS(3912),
    [anon_sym_LBRACE] = ACTIONS(3914),
    [anon_sym_interface] = ACTIONS(3912),
    [anon_sym_delegate] = ACTIONS(3912),
    [anon_sym_record] = ACTIONS(3912),
    [anon_sym_abstract] = ACTIONS(3912),
    [anon_sym_async] = ACTIONS(3912),
    [anon_sym_const] = ACTIONS(3912),
    [anon_sym_file] = ACTIONS(3912),
    [anon_sym_fixed] = ACTIONS(3912),
    [anon_sym_internal] = ACTIONS(3912),
    [anon_sym_new] = ACTIONS(3912),
    [anon_sym_override] = ACTIONS(3912),
    [anon_sym_partial] = ACTIONS(3912),
    [anon_sym_private] = ACTIONS(3912),
    [anon_sym_protected] = ACTIONS(3912),
    [anon_sym_public] = ACTIONS(3912),
    [anon_sym_readonly] = ACTIONS(3912),
    [anon_sym_required] = ACTIONS(3912),
    [anon_sym_sealed] = ACTIONS(3912),
    [anon_sym_virtual] = ACTIONS(3912),
    [anon_sym_volatile] = ACTIONS(3912),
    [anon_sym_where] = ACTIONS(3912),
    [anon_sym_notnull] = ACTIONS(3912),
    [anon_sym_unmanaged] = ACTIONS(3912),
    [anon_sym_checked] = ACTIONS(3912),
    [anon_sym_BANG] = ACTIONS(3914),
    [anon_sym_TILDE] = ACTIONS(3914),
    [anon_sym_PLUS_PLUS] = ACTIONS(3914),
    [anon_sym_DASH_DASH] = ACTIONS(3914),
    [anon_sym_true] = ACTIONS(3912),
    [anon_sym_false] = ACTIONS(3912),
    [anon_sym_PLUS] = ACTIONS(3912),
    [anon_sym_DASH] = ACTIONS(3912),
    [anon_sym_STAR] = ACTIONS(3914),
    [anon_sym_CARET] = ACTIONS(3914),
    [anon_sym_AMP] = ACTIONS(3914),
    [anon_sym_this] = ACTIONS(3912),
    [anon_sym_scoped] = ACTIONS(3912),
    [anon_sym_var] = ACTIONS(3912),
    [sym_predefined_type] = ACTIONS(3912),
    [anon_sym_break] = ACTIONS(3912),
    [anon_sym_unchecked] = ACTIONS(3912),
    [anon_sym_continue] = ACTIONS(3912),
    [anon_sym_do] = ACTIONS(3912),
    [anon_sym_while] = ACTIONS(3912),
    [anon_sym_for] = ACTIONS(3912),
    [anon_sym_lock] = ACTIONS(3912),
    [anon_sym_yield] = ACTIONS(3912),
    [anon_sym_switch] = ACTIONS(3912),
    [anon_sym_default] = ACTIONS(3912),
    [anon_sym_throw] = ACTIONS(3912),
    [anon_sym_try] = ACTIONS(3912),
    [anon_sym_when] = ACTIONS(3912),
    [anon_sym_await] = ACTIONS(3912),
    [anon_sym_foreach] = ACTIONS(3912),
    [anon_sym_goto] = ACTIONS(3912),
    [anon_sym_if] = ACTIONS(3912),
    [anon_sym_DOT_DOT] = ACTIONS(3914),
    [anon_sym_from] = ACTIONS(3912),
    [anon_sym_into] = ACTIONS(3912),
    [anon_sym_join] = ACTIONS(3912),
    [anon_sym_on] = ACTIONS(3912),
    [anon_sym_equals] = ACTIONS(3912),
    [anon_sym_let] = ACTIONS(3912),
    [anon_sym_orderby] = ACTIONS(3912),
    [anon_sym_ascending] = ACTIONS(3912),
    [anon_sym_descending] = ACTIONS(3912),
    [anon_sym_group] = ACTIONS(3912),
    [anon_sym_by] = ACTIONS(3912),
    [anon_sym_select] = ACTIONS(3912),
    [anon_sym_DQUOTE] = ACTIONS(3912),
    [anon_sym_stackalloc] = ACTIONS(3912),
    [anon_sym_sizeof] = ACTIONS(3912),
    [anon_sym_typeof] = ACTIONS(3912),
    [anon_sym___makeref] = ACTIONS(3912),
    [anon_sym___reftype] = ACTIONS(3912),
    [anon_sym___refvalue] = ACTIONS(3912),
    [sym_null_literal] = ACTIONS(3912),
    [anon_sym_SQUOTE] = ACTIONS(3914),
    [sym_integer_literal] = ACTIONS(3912),
    [sym_real_literal] = ACTIONS(3914),
    [sym_verbatim_string_literal] = ACTIONS(3914),
    [sym_raw_string_literal] = ACTIONS(3914),
    [aux_sym_preproc_if_token1] = ACTIONS(3914),
    [aux_sym_preproc_if_token3] = ACTIONS(3914),
    [aux_sym_preproc_else_token1] = ACTIONS(3914),
    [aux_sym_preproc_elif_token1] = ACTIONS(3914),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3914),
    [sym_interpolation_verbatim_start] = ACTIONS(3914),
    [sym_interpolation_raw_start] = ACTIONS(3914),
  },
  [2418] = {
    [sym_preproc_region] = STATE(2418),
    [sym_preproc_endregion] = STATE(2418),
    [sym_preproc_line] = STATE(2418),
    [sym_preproc_pragma] = STATE(2418),
    [sym_preproc_nullable] = STATE(2418),
    [sym_preproc_error] = STATE(2418),
    [sym_preproc_define] = STATE(2418),
    [sym_preproc_undef] = STATE(2418),
    [sym__identifier_token] = ACTIONS(3916),
    [anon_sym_extern] = ACTIONS(3916),
    [anon_sym_alias] = ACTIONS(3916),
    [anon_sym_SEMI] = ACTIONS(3918),
    [anon_sym_global] = ACTIONS(3916),
    [anon_sym_using] = ACTIONS(3916),
    [anon_sym_unsafe] = ACTIONS(3916),
    [anon_sym_static] = ACTIONS(3916),
    [anon_sym_LBRACK] = ACTIONS(3918),
    [anon_sym_LPAREN] = ACTIONS(3918),
    [anon_sym_return] = ACTIONS(3916),
    [anon_sym_namespace] = ACTIONS(3916),
    [anon_sym_class] = ACTIONS(3916),
    [anon_sym_ref] = ACTIONS(3916),
    [anon_sym_struct] = ACTIONS(3916),
    [anon_sym_enum] = ACTIONS(3916),
    [anon_sym_LBRACE] = ACTIONS(3918),
    [anon_sym_interface] = ACTIONS(3916),
    [anon_sym_delegate] = ACTIONS(3916),
    [anon_sym_record] = ACTIONS(3916),
    [anon_sym_abstract] = ACTIONS(3916),
    [anon_sym_async] = ACTIONS(3916),
    [anon_sym_const] = ACTIONS(3916),
    [anon_sym_file] = ACTIONS(3916),
    [anon_sym_fixed] = ACTIONS(3916),
    [anon_sym_internal] = ACTIONS(3916),
    [anon_sym_new] = ACTIONS(3916),
    [anon_sym_override] = ACTIONS(3916),
    [anon_sym_partial] = ACTIONS(3916),
    [anon_sym_private] = ACTIONS(3916),
    [anon_sym_protected] = ACTIONS(3916),
    [anon_sym_public] = ACTIONS(3916),
    [anon_sym_readonly] = ACTIONS(3916),
    [anon_sym_required] = ACTIONS(3916),
    [anon_sym_sealed] = ACTIONS(3916),
    [anon_sym_virtual] = ACTIONS(3916),
    [anon_sym_volatile] = ACTIONS(3916),
    [anon_sym_where] = ACTIONS(3916),
    [anon_sym_notnull] = ACTIONS(3916),
    [anon_sym_unmanaged] = ACTIONS(3916),
    [anon_sym_checked] = ACTIONS(3916),
    [anon_sym_BANG] = ACTIONS(3918),
    [anon_sym_TILDE] = ACTIONS(3918),
    [anon_sym_PLUS_PLUS] = ACTIONS(3918),
    [anon_sym_DASH_DASH] = ACTIONS(3918),
    [anon_sym_true] = ACTIONS(3916),
    [anon_sym_false] = ACTIONS(3916),
    [anon_sym_PLUS] = ACTIONS(3916),
    [anon_sym_DASH] = ACTIONS(3916),
    [anon_sym_STAR] = ACTIONS(3918),
    [anon_sym_CARET] = ACTIONS(3918),
    [anon_sym_AMP] = ACTIONS(3918),
    [anon_sym_this] = ACTIONS(3916),
    [anon_sym_scoped] = ACTIONS(3916),
    [anon_sym_var] = ACTIONS(3916),
    [sym_predefined_type] = ACTIONS(3916),
    [anon_sym_break] = ACTIONS(3916),
    [anon_sym_unchecked] = ACTIONS(3916),
    [anon_sym_continue] = ACTIONS(3916),
    [anon_sym_do] = ACTIONS(3916),
    [anon_sym_while] = ACTIONS(3916),
    [anon_sym_for] = ACTIONS(3916),
    [anon_sym_lock] = ACTIONS(3916),
    [anon_sym_yield] = ACTIONS(3916),
    [anon_sym_switch] = ACTIONS(3916),
    [anon_sym_default] = ACTIONS(3916),
    [anon_sym_throw] = ACTIONS(3916),
    [anon_sym_try] = ACTIONS(3916),
    [anon_sym_when] = ACTIONS(3916),
    [anon_sym_await] = ACTIONS(3916),
    [anon_sym_foreach] = ACTIONS(3916),
    [anon_sym_goto] = ACTIONS(3916),
    [anon_sym_if] = ACTIONS(3916),
    [anon_sym_DOT_DOT] = ACTIONS(3918),
    [anon_sym_from] = ACTIONS(3916),
    [anon_sym_into] = ACTIONS(3916),
    [anon_sym_join] = ACTIONS(3916),
    [anon_sym_on] = ACTIONS(3916),
    [anon_sym_equals] = ACTIONS(3916),
    [anon_sym_let] = ACTIONS(3916),
    [anon_sym_orderby] = ACTIONS(3916),
    [anon_sym_ascending] = ACTIONS(3916),
    [anon_sym_descending] = ACTIONS(3916),
    [anon_sym_group] = ACTIONS(3916),
    [anon_sym_by] = ACTIONS(3916),
    [anon_sym_select] = ACTIONS(3916),
    [anon_sym_DQUOTE] = ACTIONS(3916),
    [anon_sym_stackalloc] = ACTIONS(3916),
    [anon_sym_sizeof] = ACTIONS(3916),
    [anon_sym_typeof] = ACTIONS(3916),
    [anon_sym___makeref] = ACTIONS(3916),
    [anon_sym___reftype] = ACTIONS(3916),
    [anon_sym___refvalue] = ACTIONS(3916),
    [sym_null_literal] = ACTIONS(3916),
    [anon_sym_SQUOTE] = ACTIONS(3918),
    [sym_integer_literal] = ACTIONS(3916),
    [sym_real_literal] = ACTIONS(3918),
    [sym_verbatim_string_literal] = ACTIONS(3918),
    [sym_raw_string_literal] = ACTIONS(3918),
    [aux_sym_preproc_if_token1] = ACTIONS(3918),
    [aux_sym_preproc_if_token3] = ACTIONS(3918),
    [aux_sym_preproc_else_token1] = ACTIONS(3918),
    [aux_sym_preproc_elif_token1] = ACTIONS(3918),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3918),
    [sym_interpolation_verbatim_start] = ACTIONS(3918),
    [sym_interpolation_raw_start] = ACTIONS(3918),
  },
  [2419] = {
    [sym_preproc_region] = STATE(2419),
    [sym_preproc_endregion] = STATE(2419),
    [sym_preproc_line] = STATE(2419),
    [sym_preproc_pragma] = STATE(2419),
    [sym_preproc_nullable] = STATE(2419),
    [sym_preproc_error] = STATE(2419),
    [sym_preproc_define] = STATE(2419),
    [sym_preproc_undef] = STATE(2419),
    [sym__identifier_token] = ACTIONS(3920),
    [anon_sym_extern] = ACTIONS(3920),
    [anon_sym_alias] = ACTIONS(3920),
    [anon_sym_SEMI] = ACTIONS(3922),
    [anon_sym_global] = ACTIONS(3920),
    [anon_sym_using] = ACTIONS(3920),
    [anon_sym_unsafe] = ACTIONS(3920),
    [anon_sym_static] = ACTIONS(3920),
    [anon_sym_LBRACK] = ACTIONS(3922),
    [anon_sym_LPAREN] = ACTIONS(3922),
    [anon_sym_return] = ACTIONS(3920),
    [anon_sym_namespace] = ACTIONS(3920),
    [anon_sym_class] = ACTIONS(3920),
    [anon_sym_ref] = ACTIONS(3920),
    [anon_sym_struct] = ACTIONS(3920),
    [anon_sym_enum] = ACTIONS(3920),
    [anon_sym_LBRACE] = ACTIONS(3922),
    [anon_sym_interface] = ACTIONS(3920),
    [anon_sym_delegate] = ACTIONS(3920),
    [anon_sym_record] = ACTIONS(3920),
    [anon_sym_abstract] = ACTIONS(3920),
    [anon_sym_async] = ACTIONS(3920),
    [anon_sym_const] = ACTIONS(3920),
    [anon_sym_file] = ACTIONS(3920),
    [anon_sym_fixed] = ACTIONS(3920),
    [anon_sym_internal] = ACTIONS(3920),
    [anon_sym_new] = ACTIONS(3920),
    [anon_sym_override] = ACTIONS(3920),
    [anon_sym_partial] = ACTIONS(3920),
    [anon_sym_private] = ACTIONS(3920),
    [anon_sym_protected] = ACTIONS(3920),
    [anon_sym_public] = ACTIONS(3920),
    [anon_sym_readonly] = ACTIONS(3920),
    [anon_sym_required] = ACTIONS(3920),
    [anon_sym_sealed] = ACTIONS(3920),
    [anon_sym_virtual] = ACTIONS(3920),
    [anon_sym_volatile] = ACTIONS(3920),
    [anon_sym_where] = ACTIONS(3920),
    [anon_sym_notnull] = ACTIONS(3920),
    [anon_sym_unmanaged] = ACTIONS(3920),
    [anon_sym_checked] = ACTIONS(3920),
    [anon_sym_BANG] = ACTIONS(3922),
    [anon_sym_TILDE] = ACTIONS(3922),
    [anon_sym_PLUS_PLUS] = ACTIONS(3922),
    [anon_sym_DASH_DASH] = ACTIONS(3922),
    [anon_sym_true] = ACTIONS(3920),
    [anon_sym_false] = ACTIONS(3920),
    [anon_sym_PLUS] = ACTIONS(3920),
    [anon_sym_DASH] = ACTIONS(3920),
    [anon_sym_STAR] = ACTIONS(3922),
    [anon_sym_CARET] = ACTIONS(3922),
    [anon_sym_AMP] = ACTIONS(3922),
    [anon_sym_this] = ACTIONS(3920),
    [anon_sym_scoped] = ACTIONS(3920),
    [anon_sym_var] = ACTIONS(3920),
    [sym_predefined_type] = ACTIONS(3920),
    [anon_sym_break] = ACTIONS(3920),
    [anon_sym_unchecked] = ACTIONS(3920),
    [anon_sym_continue] = ACTIONS(3920),
    [anon_sym_do] = ACTIONS(3920),
    [anon_sym_while] = ACTIONS(3920),
    [anon_sym_for] = ACTIONS(3920),
    [anon_sym_lock] = ACTIONS(3920),
    [anon_sym_yield] = ACTIONS(3920),
    [anon_sym_switch] = ACTIONS(3920),
    [anon_sym_default] = ACTIONS(3920),
    [anon_sym_throw] = ACTIONS(3920),
    [anon_sym_try] = ACTIONS(3920),
    [anon_sym_when] = ACTIONS(3920),
    [anon_sym_await] = ACTIONS(3920),
    [anon_sym_foreach] = ACTIONS(3920),
    [anon_sym_goto] = ACTIONS(3920),
    [anon_sym_if] = ACTIONS(3920),
    [anon_sym_DOT_DOT] = ACTIONS(3922),
    [anon_sym_from] = ACTIONS(3920),
    [anon_sym_into] = ACTIONS(3920),
    [anon_sym_join] = ACTIONS(3920),
    [anon_sym_on] = ACTIONS(3920),
    [anon_sym_equals] = ACTIONS(3920),
    [anon_sym_let] = ACTIONS(3920),
    [anon_sym_orderby] = ACTIONS(3920),
    [anon_sym_ascending] = ACTIONS(3920),
    [anon_sym_descending] = ACTIONS(3920),
    [anon_sym_group] = ACTIONS(3920),
    [anon_sym_by] = ACTIONS(3920),
    [anon_sym_select] = ACTIONS(3920),
    [anon_sym_DQUOTE] = ACTIONS(3920),
    [anon_sym_stackalloc] = ACTIONS(3920),
    [anon_sym_sizeof] = ACTIONS(3920),
    [anon_sym_typeof] = ACTIONS(3920),
    [anon_sym___makeref] = ACTIONS(3920),
    [anon_sym___reftype] = ACTIONS(3920),
    [anon_sym___refvalue] = ACTIONS(3920),
    [sym_null_literal] = ACTIONS(3920),
    [anon_sym_SQUOTE] = ACTIONS(3922),
    [sym_integer_literal] = ACTIONS(3920),
    [sym_real_literal] = ACTIONS(3922),
    [sym_verbatim_string_literal] = ACTIONS(3922),
    [sym_raw_string_literal] = ACTIONS(3922),
    [aux_sym_preproc_if_token1] = ACTIONS(3922),
    [aux_sym_preproc_if_token3] = ACTIONS(3922),
    [aux_sym_preproc_else_token1] = ACTIONS(3922),
    [aux_sym_preproc_elif_token1] = ACTIONS(3922),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3922),
    [sym_interpolation_verbatim_start] = ACTIONS(3922),
    [sym_interpolation_raw_start] = ACTIONS(3922),
  },
  [2420] = {
    [sym_preproc_region] = STATE(2420),
    [sym_preproc_endregion] = STATE(2420),
    [sym_preproc_line] = STATE(2420),
    [sym_preproc_pragma] = STATE(2420),
    [sym_preproc_nullable] = STATE(2420),
    [sym_preproc_error] = STATE(2420),
    [sym_preproc_define] = STATE(2420),
    [sym_preproc_undef] = STATE(2420),
    [sym__identifier_token] = ACTIONS(3924),
    [anon_sym_extern] = ACTIONS(3924),
    [anon_sym_alias] = ACTIONS(3924),
    [anon_sym_SEMI] = ACTIONS(3926),
    [anon_sym_global] = ACTIONS(3924),
    [anon_sym_using] = ACTIONS(3924),
    [anon_sym_unsafe] = ACTIONS(3924),
    [anon_sym_static] = ACTIONS(3924),
    [anon_sym_LBRACK] = ACTIONS(3926),
    [anon_sym_LPAREN] = ACTIONS(3926),
    [anon_sym_return] = ACTIONS(3924),
    [anon_sym_namespace] = ACTIONS(3924),
    [anon_sym_class] = ACTIONS(3924),
    [anon_sym_ref] = ACTIONS(3924),
    [anon_sym_struct] = ACTIONS(3924),
    [anon_sym_enum] = ACTIONS(3924),
    [anon_sym_LBRACE] = ACTIONS(3926),
    [anon_sym_interface] = ACTIONS(3924),
    [anon_sym_delegate] = ACTIONS(3924),
    [anon_sym_record] = ACTIONS(3924),
    [anon_sym_abstract] = ACTIONS(3924),
    [anon_sym_async] = ACTIONS(3924),
    [anon_sym_const] = ACTIONS(3924),
    [anon_sym_file] = ACTIONS(3924),
    [anon_sym_fixed] = ACTIONS(3924),
    [anon_sym_internal] = ACTIONS(3924),
    [anon_sym_new] = ACTIONS(3924),
    [anon_sym_override] = ACTIONS(3924),
    [anon_sym_partial] = ACTIONS(3924),
    [anon_sym_private] = ACTIONS(3924),
    [anon_sym_protected] = ACTIONS(3924),
    [anon_sym_public] = ACTIONS(3924),
    [anon_sym_readonly] = ACTIONS(3924),
    [anon_sym_required] = ACTIONS(3924),
    [anon_sym_sealed] = ACTIONS(3924),
    [anon_sym_virtual] = ACTIONS(3924),
    [anon_sym_volatile] = ACTIONS(3924),
    [anon_sym_where] = ACTIONS(3924),
    [anon_sym_notnull] = ACTIONS(3924),
    [anon_sym_unmanaged] = ACTIONS(3924),
    [anon_sym_checked] = ACTIONS(3924),
    [anon_sym_BANG] = ACTIONS(3926),
    [anon_sym_TILDE] = ACTIONS(3926),
    [anon_sym_PLUS_PLUS] = ACTIONS(3926),
    [anon_sym_DASH_DASH] = ACTIONS(3926),
    [anon_sym_true] = ACTIONS(3924),
    [anon_sym_false] = ACTIONS(3924),
    [anon_sym_PLUS] = ACTIONS(3924),
    [anon_sym_DASH] = ACTIONS(3924),
    [anon_sym_STAR] = ACTIONS(3926),
    [anon_sym_CARET] = ACTIONS(3926),
    [anon_sym_AMP] = ACTIONS(3926),
    [anon_sym_this] = ACTIONS(3924),
    [anon_sym_scoped] = ACTIONS(3924),
    [anon_sym_var] = ACTIONS(3924),
    [sym_predefined_type] = ACTIONS(3924),
    [anon_sym_break] = ACTIONS(3924),
    [anon_sym_unchecked] = ACTIONS(3924),
    [anon_sym_continue] = ACTIONS(3924),
    [anon_sym_do] = ACTIONS(3924),
    [anon_sym_while] = ACTIONS(3924),
    [anon_sym_for] = ACTIONS(3924),
    [anon_sym_lock] = ACTIONS(3924),
    [anon_sym_yield] = ACTIONS(3924),
    [anon_sym_switch] = ACTIONS(3924),
    [anon_sym_default] = ACTIONS(3924),
    [anon_sym_throw] = ACTIONS(3924),
    [anon_sym_try] = ACTIONS(3924),
    [anon_sym_when] = ACTIONS(3924),
    [anon_sym_await] = ACTIONS(3924),
    [anon_sym_foreach] = ACTIONS(3924),
    [anon_sym_goto] = ACTIONS(3924),
    [anon_sym_if] = ACTIONS(3924),
    [anon_sym_DOT_DOT] = ACTIONS(3926),
    [anon_sym_from] = ACTIONS(3924),
    [anon_sym_into] = ACTIONS(3924),
    [anon_sym_join] = ACTIONS(3924),
    [anon_sym_on] = ACTIONS(3924),
    [anon_sym_equals] = ACTIONS(3924),
    [anon_sym_let] = ACTIONS(3924),
    [anon_sym_orderby] = ACTIONS(3924),
    [anon_sym_ascending] = ACTIONS(3924),
    [anon_sym_descending] = ACTIONS(3924),
    [anon_sym_group] = ACTIONS(3924),
    [anon_sym_by] = ACTIONS(3924),
    [anon_sym_select] = ACTIONS(3924),
    [anon_sym_DQUOTE] = ACTIONS(3924),
    [anon_sym_stackalloc] = ACTIONS(3924),
    [anon_sym_sizeof] = ACTIONS(3924),
    [anon_sym_typeof] = ACTIONS(3924),
    [anon_sym___makeref] = ACTIONS(3924),
    [anon_sym___reftype] = ACTIONS(3924),
    [anon_sym___refvalue] = ACTIONS(3924),
    [sym_null_literal] = ACTIONS(3924),
    [anon_sym_SQUOTE] = ACTIONS(3926),
    [sym_integer_literal] = ACTIONS(3924),
    [sym_real_literal] = ACTIONS(3926),
    [sym_verbatim_string_literal] = ACTIONS(3926),
    [sym_raw_string_literal] = ACTIONS(3926),
    [aux_sym_preproc_if_token1] = ACTIONS(3926),
    [aux_sym_preproc_if_token3] = ACTIONS(3926),
    [aux_sym_preproc_else_token1] = ACTIONS(3926),
    [aux_sym_preproc_elif_token1] = ACTIONS(3926),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3926),
    [sym_interpolation_verbatim_start] = ACTIONS(3926),
    [sym_interpolation_raw_start] = ACTIONS(3926),
  },
  [2421] = {
    [sym_preproc_region] = STATE(2421),
    [sym_preproc_endregion] = STATE(2421),
    [sym_preproc_line] = STATE(2421),
    [sym_preproc_pragma] = STATE(2421),
    [sym_preproc_nullable] = STATE(2421),
    [sym_preproc_error] = STATE(2421),
    [sym_preproc_define] = STATE(2421),
    [sym_preproc_undef] = STATE(2421),
    [sym__identifier_token] = ACTIONS(3928),
    [anon_sym_extern] = ACTIONS(3928),
    [anon_sym_alias] = ACTIONS(3928),
    [anon_sym_SEMI] = ACTIONS(3930),
    [anon_sym_global] = ACTIONS(3928),
    [anon_sym_using] = ACTIONS(3928),
    [anon_sym_unsafe] = ACTIONS(3928),
    [anon_sym_static] = ACTIONS(3928),
    [anon_sym_LBRACK] = ACTIONS(3930),
    [anon_sym_LPAREN] = ACTIONS(3930),
    [anon_sym_return] = ACTIONS(3928),
    [anon_sym_namespace] = ACTIONS(3928),
    [anon_sym_class] = ACTIONS(3928),
    [anon_sym_ref] = ACTIONS(3928),
    [anon_sym_struct] = ACTIONS(3928),
    [anon_sym_enum] = ACTIONS(3928),
    [anon_sym_LBRACE] = ACTIONS(3930),
    [anon_sym_interface] = ACTIONS(3928),
    [anon_sym_delegate] = ACTIONS(3928),
    [anon_sym_record] = ACTIONS(3928),
    [anon_sym_abstract] = ACTIONS(3928),
    [anon_sym_async] = ACTIONS(3928),
    [anon_sym_const] = ACTIONS(3928),
    [anon_sym_file] = ACTIONS(3928),
    [anon_sym_fixed] = ACTIONS(3928),
    [anon_sym_internal] = ACTIONS(3928),
    [anon_sym_new] = ACTIONS(3928),
    [anon_sym_override] = ACTIONS(3928),
    [anon_sym_partial] = ACTIONS(3928),
    [anon_sym_private] = ACTIONS(3928),
    [anon_sym_protected] = ACTIONS(3928),
    [anon_sym_public] = ACTIONS(3928),
    [anon_sym_readonly] = ACTIONS(3928),
    [anon_sym_required] = ACTIONS(3928),
    [anon_sym_sealed] = ACTIONS(3928),
    [anon_sym_virtual] = ACTIONS(3928),
    [anon_sym_volatile] = ACTIONS(3928),
    [anon_sym_where] = ACTIONS(3928),
    [anon_sym_notnull] = ACTIONS(3928),
    [anon_sym_unmanaged] = ACTIONS(3928),
    [anon_sym_checked] = ACTIONS(3928),
    [anon_sym_BANG] = ACTIONS(3930),
    [anon_sym_TILDE] = ACTIONS(3930),
    [anon_sym_PLUS_PLUS] = ACTIONS(3930),
    [anon_sym_DASH_DASH] = ACTIONS(3930),
    [anon_sym_true] = ACTIONS(3928),
    [anon_sym_false] = ACTIONS(3928),
    [anon_sym_PLUS] = ACTIONS(3928),
    [anon_sym_DASH] = ACTIONS(3928),
    [anon_sym_STAR] = ACTIONS(3930),
    [anon_sym_CARET] = ACTIONS(3930),
    [anon_sym_AMP] = ACTIONS(3930),
    [anon_sym_this] = ACTIONS(3928),
    [anon_sym_scoped] = ACTIONS(3928),
    [anon_sym_var] = ACTIONS(3928),
    [sym_predefined_type] = ACTIONS(3928),
    [anon_sym_break] = ACTIONS(3928),
    [anon_sym_unchecked] = ACTIONS(3928),
    [anon_sym_continue] = ACTIONS(3928),
    [anon_sym_do] = ACTIONS(3928),
    [anon_sym_while] = ACTIONS(3928),
    [anon_sym_for] = ACTIONS(3928),
    [anon_sym_lock] = ACTIONS(3928),
    [anon_sym_yield] = ACTIONS(3928),
    [anon_sym_switch] = ACTIONS(3928),
    [anon_sym_default] = ACTIONS(3928),
    [anon_sym_throw] = ACTIONS(3928),
    [anon_sym_try] = ACTIONS(3928),
    [anon_sym_when] = ACTIONS(3928),
    [anon_sym_await] = ACTIONS(3928),
    [anon_sym_foreach] = ACTIONS(3928),
    [anon_sym_goto] = ACTIONS(3928),
    [anon_sym_if] = ACTIONS(3928),
    [anon_sym_DOT_DOT] = ACTIONS(3930),
    [anon_sym_from] = ACTIONS(3928),
    [anon_sym_into] = ACTIONS(3928),
    [anon_sym_join] = ACTIONS(3928),
    [anon_sym_on] = ACTIONS(3928),
    [anon_sym_equals] = ACTIONS(3928),
    [anon_sym_let] = ACTIONS(3928),
    [anon_sym_orderby] = ACTIONS(3928),
    [anon_sym_ascending] = ACTIONS(3928),
    [anon_sym_descending] = ACTIONS(3928),
    [anon_sym_group] = ACTIONS(3928),
    [anon_sym_by] = ACTIONS(3928),
    [anon_sym_select] = ACTIONS(3928),
    [anon_sym_DQUOTE] = ACTIONS(3928),
    [anon_sym_stackalloc] = ACTIONS(3928),
    [anon_sym_sizeof] = ACTIONS(3928),
    [anon_sym_typeof] = ACTIONS(3928),
    [anon_sym___makeref] = ACTIONS(3928),
    [anon_sym___reftype] = ACTIONS(3928),
    [anon_sym___refvalue] = ACTIONS(3928),
    [sym_null_literal] = ACTIONS(3928),
    [anon_sym_SQUOTE] = ACTIONS(3930),
    [sym_integer_literal] = ACTIONS(3928),
    [sym_real_literal] = ACTIONS(3930),
    [sym_verbatim_string_literal] = ACTIONS(3930),
    [sym_raw_string_literal] = ACTIONS(3930),
    [aux_sym_preproc_if_token1] = ACTIONS(3930),
    [aux_sym_preproc_if_token3] = ACTIONS(3930),
    [aux_sym_preproc_else_token1] = ACTIONS(3930),
    [aux_sym_preproc_elif_token1] = ACTIONS(3930),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3930),
    [sym_interpolation_verbatim_start] = ACTIONS(3930),
    [sym_interpolation_raw_start] = ACTIONS(3930),
  },
  [2422] = {
    [sym_preproc_region] = STATE(2422),
    [sym_preproc_endregion] = STATE(2422),
    [sym_preproc_line] = STATE(2422),
    [sym_preproc_pragma] = STATE(2422),
    [sym_preproc_nullable] = STATE(2422),
    [sym_preproc_error] = STATE(2422),
    [sym_preproc_define] = STATE(2422),
    [sym_preproc_undef] = STATE(2422),
    [sym__identifier_token] = ACTIONS(3932),
    [anon_sym_extern] = ACTIONS(3932),
    [anon_sym_alias] = ACTIONS(3932),
    [anon_sym_SEMI] = ACTIONS(3934),
    [anon_sym_global] = ACTIONS(3932),
    [anon_sym_using] = ACTIONS(3932),
    [anon_sym_unsafe] = ACTIONS(3932),
    [anon_sym_static] = ACTIONS(3932),
    [anon_sym_LBRACK] = ACTIONS(3934),
    [anon_sym_LPAREN] = ACTIONS(3934),
    [anon_sym_return] = ACTIONS(3932),
    [anon_sym_namespace] = ACTIONS(3932),
    [anon_sym_class] = ACTIONS(3932),
    [anon_sym_ref] = ACTIONS(3932),
    [anon_sym_struct] = ACTIONS(3932),
    [anon_sym_enum] = ACTIONS(3932),
    [anon_sym_LBRACE] = ACTIONS(3934),
    [anon_sym_interface] = ACTIONS(3932),
    [anon_sym_delegate] = ACTIONS(3932),
    [anon_sym_record] = ACTIONS(3932),
    [anon_sym_abstract] = ACTIONS(3932),
    [anon_sym_async] = ACTIONS(3932),
    [anon_sym_const] = ACTIONS(3932),
    [anon_sym_file] = ACTIONS(3932),
    [anon_sym_fixed] = ACTIONS(3932),
    [anon_sym_internal] = ACTIONS(3932),
    [anon_sym_new] = ACTIONS(3932),
    [anon_sym_override] = ACTIONS(3932),
    [anon_sym_partial] = ACTIONS(3932),
    [anon_sym_private] = ACTIONS(3932),
    [anon_sym_protected] = ACTIONS(3932),
    [anon_sym_public] = ACTIONS(3932),
    [anon_sym_readonly] = ACTIONS(3932),
    [anon_sym_required] = ACTIONS(3932),
    [anon_sym_sealed] = ACTIONS(3932),
    [anon_sym_virtual] = ACTIONS(3932),
    [anon_sym_volatile] = ACTIONS(3932),
    [anon_sym_where] = ACTIONS(3932),
    [anon_sym_notnull] = ACTIONS(3932),
    [anon_sym_unmanaged] = ACTIONS(3932),
    [anon_sym_checked] = ACTIONS(3932),
    [anon_sym_BANG] = ACTIONS(3934),
    [anon_sym_TILDE] = ACTIONS(3934),
    [anon_sym_PLUS_PLUS] = ACTIONS(3934),
    [anon_sym_DASH_DASH] = ACTIONS(3934),
    [anon_sym_true] = ACTIONS(3932),
    [anon_sym_false] = ACTIONS(3932),
    [anon_sym_PLUS] = ACTIONS(3932),
    [anon_sym_DASH] = ACTIONS(3932),
    [anon_sym_STAR] = ACTIONS(3934),
    [anon_sym_CARET] = ACTIONS(3934),
    [anon_sym_AMP] = ACTIONS(3934),
    [anon_sym_this] = ACTIONS(3932),
    [anon_sym_scoped] = ACTIONS(3932),
    [anon_sym_var] = ACTIONS(3932),
    [sym_predefined_type] = ACTIONS(3932),
    [anon_sym_break] = ACTIONS(3932),
    [anon_sym_unchecked] = ACTIONS(3932),
    [anon_sym_continue] = ACTIONS(3932),
    [anon_sym_do] = ACTIONS(3932),
    [anon_sym_while] = ACTIONS(3932),
    [anon_sym_for] = ACTIONS(3932),
    [anon_sym_lock] = ACTIONS(3932),
    [anon_sym_yield] = ACTIONS(3932),
    [anon_sym_switch] = ACTIONS(3932),
    [anon_sym_default] = ACTIONS(3932),
    [anon_sym_throw] = ACTIONS(3932),
    [anon_sym_try] = ACTIONS(3932),
    [anon_sym_when] = ACTIONS(3932),
    [anon_sym_await] = ACTIONS(3932),
    [anon_sym_foreach] = ACTIONS(3932),
    [anon_sym_goto] = ACTIONS(3932),
    [anon_sym_if] = ACTIONS(3932),
    [anon_sym_DOT_DOT] = ACTIONS(3934),
    [anon_sym_from] = ACTIONS(3932),
    [anon_sym_into] = ACTIONS(3932),
    [anon_sym_join] = ACTIONS(3932),
    [anon_sym_on] = ACTIONS(3932),
    [anon_sym_equals] = ACTIONS(3932),
    [anon_sym_let] = ACTIONS(3932),
    [anon_sym_orderby] = ACTIONS(3932),
    [anon_sym_ascending] = ACTIONS(3932),
    [anon_sym_descending] = ACTIONS(3932),
    [anon_sym_group] = ACTIONS(3932),
    [anon_sym_by] = ACTIONS(3932),
    [anon_sym_select] = ACTIONS(3932),
    [anon_sym_DQUOTE] = ACTIONS(3932),
    [anon_sym_stackalloc] = ACTIONS(3932),
    [anon_sym_sizeof] = ACTIONS(3932),
    [anon_sym_typeof] = ACTIONS(3932),
    [anon_sym___makeref] = ACTIONS(3932),
    [anon_sym___reftype] = ACTIONS(3932),
    [anon_sym___refvalue] = ACTIONS(3932),
    [sym_null_literal] = ACTIONS(3932),
    [anon_sym_SQUOTE] = ACTIONS(3934),
    [sym_integer_literal] = ACTIONS(3932),
    [sym_real_literal] = ACTIONS(3934),
    [sym_verbatim_string_literal] = ACTIONS(3934),
    [sym_raw_string_literal] = ACTIONS(3934),
    [aux_sym_preproc_if_token1] = ACTIONS(3934),
    [aux_sym_preproc_if_token3] = ACTIONS(3934),
    [aux_sym_preproc_else_token1] = ACTIONS(3934),
    [aux_sym_preproc_elif_token1] = ACTIONS(3934),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3934),
    [sym_interpolation_verbatim_start] = ACTIONS(3934),
    [sym_interpolation_raw_start] = ACTIONS(3934),
  },
  [2423] = {
    [sym_preproc_region] = STATE(2423),
    [sym_preproc_endregion] = STATE(2423),
    [sym_preproc_line] = STATE(2423),
    [sym_preproc_pragma] = STATE(2423),
    [sym_preproc_nullable] = STATE(2423),
    [sym_preproc_error] = STATE(2423),
    [sym_preproc_define] = STATE(2423),
    [sym_preproc_undef] = STATE(2423),
    [sym__identifier_token] = ACTIONS(3936),
    [anon_sym_extern] = ACTIONS(3936),
    [anon_sym_alias] = ACTIONS(3936),
    [anon_sym_SEMI] = ACTIONS(3938),
    [anon_sym_global] = ACTIONS(3936),
    [anon_sym_using] = ACTIONS(3936),
    [anon_sym_unsafe] = ACTIONS(3936),
    [anon_sym_static] = ACTIONS(3936),
    [anon_sym_LBRACK] = ACTIONS(3938),
    [anon_sym_LPAREN] = ACTIONS(3938),
    [anon_sym_return] = ACTIONS(3936),
    [anon_sym_namespace] = ACTIONS(3936),
    [anon_sym_class] = ACTIONS(3936),
    [anon_sym_ref] = ACTIONS(3936),
    [anon_sym_struct] = ACTIONS(3936),
    [anon_sym_enum] = ACTIONS(3936),
    [anon_sym_LBRACE] = ACTIONS(3938),
    [anon_sym_interface] = ACTIONS(3936),
    [anon_sym_delegate] = ACTIONS(3936),
    [anon_sym_record] = ACTIONS(3936),
    [anon_sym_abstract] = ACTIONS(3936),
    [anon_sym_async] = ACTIONS(3936),
    [anon_sym_const] = ACTIONS(3936),
    [anon_sym_file] = ACTIONS(3936),
    [anon_sym_fixed] = ACTIONS(3936),
    [anon_sym_internal] = ACTIONS(3936),
    [anon_sym_new] = ACTIONS(3936),
    [anon_sym_override] = ACTIONS(3936),
    [anon_sym_partial] = ACTIONS(3936),
    [anon_sym_private] = ACTIONS(3936),
    [anon_sym_protected] = ACTIONS(3936),
    [anon_sym_public] = ACTIONS(3936),
    [anon_sym_readonly] = ACTIONS(3936),
    [anon_sym_required] = ACTIONS(3936),
    [anon_sym_sealed] = ACTIONS(3936),
    [anon_sym_virtual] = ACTIONS(3936),
    [anon_sym_volatile] = ACTIONS(3936),
    [anon_sym_where] = ACTIONS(3936),
    [anon_sym_notnull] = ACTIONS(3936),
    [anon_sym_unmanaged] = ACTIONS(3936),
    [anon_sym_checked] = ACTIONS(3936),
    [anon_sym_BANG] = ACTIONS(3938),
    [anon_sym_TILDE] = ACTIONS(3938),
    [anon_sym_PLUS_PLUS] = ACTIONS(3938),
    [anon_sym_DASH_DASH] = ACTIONS(3938),
    [anon_sym_true] = ACTIONS(3936),
    [anon_sym_false] = ACTIONS(3936),
    [anon_sym_PLUS] = ACTIONS(3936),
    [anon_sym_DASH] = ACTIONS(3936),
    [anon_sym_STAR] = ACTIONS(3938),
    [anon_sym_CARET] = ACTIONS(3938),
    [anon_sym_AMP] = ACTIONS(3938),
    [anon_sym_this] = ACTIONS(3936),
    [anon_sym_scoped] = ACTIONS(3936),
    [anon_sym_var] = ACTIONS(3936),
    [sym_predefined_type] = ACTIONS(3936),
    [anon_sym_break] = ACTIONS(3936),
    [anon_sym_unchecked] = ACTIONS(3936),
    [anon_sym_continue] = ACTIONS(3936),
    [anon_sym_do] = ACTIONS(3936),
    [anon_sym_while] = ACTIONS(3936),
    [anon_sym_for] = ACTIONS(3936),
    [anon_sym_lock] = ACTIONS(3936),
    [anon_sym_yield] = ACTIONS(3936),
    [anon_sym_switch] = ACTIONS(3936),
    [anon_sym_default] = ACTIONS(3936),
    [anon_sym_throw] = ACTIONS(3936),
    [anon_sym_try] = ACTIONS(3936),
    [anon_sym_when] = ACTIONS(3936),
    [anon_sym_await] = ACTIONS(3936),
    [anon_sym_foreach] = ACTIONS(3936),
    [anon_sym_goto] = ACTIONS(3936),
    [anon_sym_if] = ACTIONS(3936),
    [anon_sym_DOT_DOT] = ACTIONS(3938),
    [anon_sym_from] = ACTIONS(3936),
    [anon_sym_into] = ACTIONS(3936),
    [anon_sym_join] = ACTIONS(3936),
    [anon_sym_on] = ACTIONS(3936),
    [anon_sym_equals] = ACTIONS(3936),
    [anon_sym_let] = ACTIONS(3936),
    [anon_sym_orderby] = ACTIONS(3936),
    [anon_sym_ascending] = ACTIONS(3936),
    [anon_sym_descending] = ACTIONS(3936),
    [anon_sym_group] = ACTIONS(3936),
    [anon_sym_by] = ACTIONS(3936),
    [anon_sym_select] = ACTIONS(3936),
    [anon_sym_DQUOTE] = ACTIONS(3936),
    [anon_sym_stackalloc] = ACTIONS(3936),
    [anon_sym_sizeof] = ACTIONS(3936),
    [anon_sym_typeof] = ACTIONS(3936),
    [anon_sym___makeref] = ACTIONS(3936),
    [anon_sym___reftype] = ACTIONS(3936),
    [anon_sym___refvalue] = ACTIONS(3936),
    [sym_null_literal] = ACTIONS(3936),
    [anon_sym_SQUOTE] = ACTIONS(3938),
    [sym_integer_literal] = ACTIONS(3936),
    [sym_real_literal] = ACTIONS(3938),
    [sym_verbatim_string_literal] = ACTIONS(3938),
    [sym_raw_string_literal] = ACTIONS(3938),
    [aux_sym_preproc_if_token1] = ACTIONS(3938),
    [aux_sym_preproc_if_token3] = ACTIONS(3938),
    [aux_sym_preproc_else_token1] = ACTIONS(3938),
    [aux_sym_preproc_elif_token1] = ACTIONS(3938),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3938),
    [sym_interpolation_verbatim_start] = ACTIONS(3938),
    [sym_interpolation_raw_start] = ACTIONS(3938),
  },
  [2424] = {
    [sym_preproc_region] = STATE(2424),
    [sym_preproc_endregion] = STATE(2424),
    [sym_preproc_line] = STATE(2424),
    [sym_preproc_pragma] = STATE(2424),
    [sym_preproc_nullable] = STATE(2424),
    [sym_preproc_error] = STATE(2424),
    [sym_preproc_define] = STATE(2424),
    [sym_preproc_undef] = STATE(2424),
    [sym__identifier_token] = ACTIONS(3940),
    [anon_sym_extern] = ACTIONS(3940),
    [anon_sym_alias] = ACTIONS(3940),
    [anon_sym_SEMI] = ACTIONS(3942),
    [anon_sym_global] = ACTIONS(3940),
    [anon_sym_using] = ACTIONS(3940),
    [anon_sym_unsafe] = ACTIONS(3940),
    [anon_sym_static] = ACTIONS(3940),
    [anon_sym_LBRACK] = ACTIONS(3942),
    [anon_sym_LPAREN] = ACTIONS(3942),
    [anon_sym_return] = ACTIONS(3940),
    [anon_sym_namespace] = ACTIONS(3940),
    [anon_sym_class] = ACTIONS(3940),
    [anon_sym_ref] = ACTIONS(3940),
    [anon_sym_struct] = ACTIONS(3940),
    [anon_sym_enum] = ACTIONS(3940),
    [anon_sym_LBRACE] = ACTIONS(3942),
    [anon_sym_interface] = ACTIONS(3940),
    [anon_sym_delegate] = ACTIONS(3940),
    [anon_sym_record] = ACTIONS(3940),
    [anon_sym_abstract] = ACTIONS(3940),
    [anon_sym_async] = ACTIONS(3940),
    [anon_sym_const] = ACTIONS(3940),
    [anon_sym_file] = ACTIONS(3940),
    [anon_sym_fixed] = ACTIONS(3940),
    [anon_sym_internal] = ACTIONS(3940),
    [anon_sym_new] = ACTIONS(3940),
    [anon_sym_override] = ACTIONS(3940),
    [anon_sym_partial] = ACTIONS(3940),
    [anon_sym_private] = ACTIONS(3940),
    [anon_sym_protected] = ACTIONS(3940),
    [anon_sym_public] = ACTIONS(3940),
    [anon_sym_readonly] = ACTIONS(3940),
    [anon_sym_required] = ACTIONS(3940),
    [anon_sym_sealed] = ACTIONS(3940),
    [anon_sym_virtual] = ACTIONS(3940),
    [anon_sym_volatile] = ACTIONS(3940),
    [anon_sym_where] = ACTIONS(3940),
    [anon_sym_notnull] = ACTIONS(3940),
    [anon_sym_unmanaged] = ACTIONS(3940),
    [anon_sym_checked] = ACTIONS(3940),
    [anon_sym_BANG] = ACTIONS(3942),
    [anon_sym_TILDE] = ACTIONS(3942),
    [anon_sym_PLUS_PLUS] = ACTIONS(3942),
    [anon_sym_DASH_DASH] = ACTIONS(3942),
    [anon_sym_true] = ACTIONS(3940),
    [anon_sym_false] = ACTIONS(3940),
    [anon_sym_PLUS] = ACTIONS(3940),
    [anon_sym_DASH] = ACTIONS(3940),
    [anon_sym_STAR] = ACTIONS(3942),
    [anon_sym_CARET] = ACTIONS(3942),
    [anon_sym_AMP] = ACTIONS(3942),
    [anon_sym_this] = ACTIONS(3940),
    [anon_sym_scoped] = ACTIONS(3940),
    [anon_sym_var] = ACTIONS(3940),
    [sym_predefined_type] = ACTIONS(3940),
    [anon_sym_break] = ACTIONS(3940),
    [anon_sym_unchecked] = ACTIONS(3940),
    [anon_sym_continue] = ACTIONS(3940),
    [anon_sym_do] = ACTIONS(3940),
    [anon_sym_while] = ACTIONS(3940),
    [anon_sym_for] = ACTIONS(3940),
    [anon_sym_lock] = ACTIONS(3940),
    [anon_sym_yield] = ACTIONS(3940),
    [anon_sym_switch] = ACTIONS(3940),
    [anon_sym_default] = ACTIONS(3940),
    [anon_sym_throw] = ACTIONS(3940),
    [anon_sym_try] = ACTIONS(3940),
    [anon_sym_when] = ACTIONS(3940),
    [anon_sym_await] = ACTIONS(3940),
    [anon_sym_foreach] = ACTIONS(3940),
    [anon_sym_goto] = ACTIONS(3940),
    [anon_sym_if] = ACTIONS(3940),
    [anon_sym_DOT_DOT] = ACTIONS(3942),
    [anon_sym_from] = ACTIONS(3940),
    [anon_sym_into] = ACTIONS(3940),
    [anon_sym_join] = ACTIONS(3940),
    [anon_sym_on] = ACTIONS(3940),
    [anon_sym_equals] = ACTIONS(3940),
    [anon_sym_let] = ACTIONS(3940),
    [anon_sym_orderby] = ACTIONS(3940),
    [anon_sym_ascending] = ACTIONS(3940),
    [anon_sym_descending] = ACTIONS(3940),
    [anon_sym_group] = ACTIONS(3940),
    [anon_sym_by] = ACTIONS(3940),
    [anon_sym_select] = ACTIONS(3940),
    [anon_sym_DQUOTE] = ACTIONS(3940),
    [anon_sym_stackalloc] = ACTIONS(3940),
    [anon_sym_sizeof] = ACTIONS(3940),
    [anon_sym_typeof] = ACTIONS(3940),
    [anon_sym___makeref] = ACTIONS(3940),
    [anon_sym___reftype] = ACTIONS(3940),
    [anon_sym___refvalue] = ACTIONS(3940),
    [sym_null_literal] = ACTIONS(3940),
    [anon_sym_SQUOTE] = ACTIONS(3942),
    [sym_integer_literal] = ACTIONS(3940),
    [sym_real_literal] = ACTIONS(3942),
    [sym_verbatim_string_literal] = ACTIONS(3942),
    [sym_raw_string_literal] = ACTIONS(3942),
    [aux_sym_preproc_if_token1] = ACTIONS(3942),
    [aux_sym_preproc_if_token3] = ACTIONS(3942),
    [aux_sym_preproc_else_token1] = ACTIONS(3942),
    [aux_sym_preproc_elif_token1] = ACTIONS(3942),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3942),
    [sym_interpolation_verbatim_start] = ACTIONS(3942),
    [sym_interpolation_raw_start] = ACTIONS(3942),
  },
  [2425] = {
    [sym_preproc_region] = STATE(2425),
    [sym_preproc_endregion] = STATE(2425),
    [sym_preproc_line] = STATE(2425),
    [sym_preproc_pragma] = STATE(2425),
    [sym_preproc_nullable] = STATE(2425),
    [sym_preproc_error] = STATE(2425),
    [sym_preproc_define] = STATE(2425),
    [sym_preproc_undef] = STATE(2425),
    [ts_builtin_sym_end] = ACTIONS(3345),
    [sym__identifier_token] = ACTIONS(3343),
    [anon_sym_extern] = ACTIONS(3343),
    [anon_sym_alias] = ACTIONS(3343),
    [anon_sym_SEMI] = ACTIONS(3345),
    [anon_sym_global] = ACTIONS(3343),
    [anon_sym_using] = ACTIONS(3343),
    [anon_sym_unsafe] = ACTIONS(3343),
    [anon_sym_static] = ACTIONS(3343),
    [anon_sym_LBRACK] = ACTIONS(3345),
    [anon_sym_LPAREN] = ACTIONS(3345),
    [anon_sym_return] = ACTIONS(3343),
    [anon_sym_namespace] = ACTIONS(3343),
    [anon_sym_class] = ACTIONS(3343),
    [anon_sym_ref] = ACTIONS(3343),
    [anon_sym_struct] = ACTIONS(3343),
    [anon_sym_enum] = ACTIONS(3343),
    [anon_sym_LBRACE] = ACTIONS(3345),
    [anon_sym_interface] = ACTIONS(3343),
    [anon_sym_delegate] = ACTIONS(3343),
    [anon_sym_record] = ACTIONS(3343),
    [anon_sym_abstract] = ACTIONS(3343),
    [anon_sym_async] = ACTIONS(3343),
    [anon_sym_const] = ACTIONS(3343),
    [anon_sym_file] = ACTIONS(3343),
    [anon_sym_fixed] = ACTIONS(3343),
    [anon_sym_internal] = ACTIONS(3343),
    [anon_sym_new] = ACTIONS(3343),
    [anon_sym_override] = ACTIONS(3343),
    [anon_sym_partial] = ACTIONS(3343),
    [anon_sym_private] = ACTIONS(3343),
    [anon_sym_protected] = ACTIONS(3343),
    [anon_sym_public] = ACTIONS(3343),
    [anon_sym_readonly] = ACTIONS(3343),
    [anon_sym_required] = ACTIONS(3343),
    [anon_sym_sealed] = ACTIONS(3343),
    [anon_sym_virtual] = ACTIONS(3343),
    [anon_sym_volatile] = ACTIONS(3343),
    [anon_sym_where] = ACTIONS(3343),
    [anon_sym_notnull] = ACTIONS(3343),
    [anon_sym_unmanaged] = ACTIONS(3343),
    [anon_sym_checked] = ACTIONS(3343),
    [anon_sym_BANG] = ACTIONS(3345),
    [anon_sym_TILDE] = ACTIONS(3345),
    [anon_sym_PLUS_PLUS] = ACTIONS(3345),
    [anon_sym_DASH_DASH] = ACTIONS(3345),
    [anon_sym_true] = ACTIONS(3343),
    [anon_sym_false] = ACTIONS(3343),
    [anon_sym_PLUS] = ACTIONS(3343),
    [anon_sym_DASH] = ACTIONS(3343),
    [anon_sym_STAR] = ACTIONS(3345),
    [anon_sym_CARET] = ACTIONS(3345),
    [anon_sym_AMP] = ACTIONS(3345),
    [anon_sym_this] = ACTIONS(3343),
    [anon_sym_scoped] = ACTIONS(3343),
    [anon_sym_var] = ACTIONS(3343),
    [sym_predefined_type] = ACTIONS(3343),
    [anon_sym_break] = ACTIONS(3343),
    [anon_sym_unchecked] = ACTIONS(3343),
    [anon_sym_continue] = ACTIONS(3343),
    [anon_sym_do] = ACTIONS(3343),
    [anon_sym_while] = ACTIONS(3343),
    [anon_sym_for] = ACTIONS(3343),
    [anon_sym_lock] = ACTIONS(3343),
    [anon_sym_yield] = ACTIONS(3343),
    [anon_sym_switch] = ACTIONS(3343),
    [anon_sym_default] = ACTIONS(3343),
    [anon_sym_throw] = ACTIONS(3343),
    [anon_sym_try] = ACTIONS(3343),
    [anon_sym_when] = ACTIONS(3343),
    [anon_sym_await] = ACTIONS(3343),
    [anon_sym_foreach] = ACTIONS(3343),
    [anon_sym_goto] = ACTIONS(3343),
    [anon_sym_if] = ACTIONS(3343),
    [anon_sym_else] = ACTIONS(3343),
    [anon_sym_DOT_DOT] = ACTIONS(3345),
    [anon_sym_from] = ACTIONS(3343),
    [anon_sym_into] = ACTIONS(3343),
    [anon_sym_join] = ACTIONS(3343),
    [anon_sym_on] = ACTIONS(3343),
    [anon_sym_equals] = ACTIONS(3343),
    [anon_sym_let] = ACTIONS(3343),
    [anon_sym_orderby] = ACTIONS(3343),
    [anon_sym_ascending] = ACTIONS(3343),
    [anon_sym_descending] = ACTIONS(3343),
    [anon_sym_group] = ACTIONS(3343),
    [anon_sym_by] = ACTIONS(3343),
    [anon_sym_select] = ACTIONS(3343),
    [anon_sym_DQUOTE] = ACTIONS(3343),
    [anon_sym_stackalloc] = ACTIONS(3343),
    [anon_sym_sizeof] = ACTIONS(3343),
    [anon_sym_typeof] = ACTIONS(3343),
    [anon_sym___makeref] = ACTIONS(3343),
    [anon_sym___reftype] = ACTIONS(3343),
    [anon_sym___refvalue] = ACTIONS(3343),
    [sym_null_literal] = ACTIONS(3343),
    [anon_sym_SQUOTE] = ACTIONS(3345),
    [sym_integer_literal] = ACTIONS(3343),
    [sym_real_literal] = ACTIONS(3345),
    [sym_verbatim_string_literal] = ACTIONS(3345),
    [sym_raw_string_literal] = ACTIONS(3345),
    [aux_sym_preproc_if_token1] = ACTIONS(3345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3345),
    [sym_interpolation_verbatim_start] = ACTIONS(3345),
    [sym_interpolation_raw_start] = ACTIONS(3345),
  },
  [2426] = {
    [sym_preproc_region] = STATE(2426),
    [sym_preproc_endregion] = STATE(2426),
    [sym_preproc_line] = STATE(2426),
    [sym_preproc_pragma] = STATE(2426),
    [sym_preproc_nullable] = STATE(2426),
    [sym_preproc_error] = STATE(2426),
    [sym_preproc_define] = STATE(2426),
    [sym_preproc_undef] = STATE(2426),
    [ts_builtin_sym_end] = ACTIONS(3333),
    [sym__identifier_token] = ACTIONS(3331),
    [anon_sym_extern] = ACTIONS(3331),
    [anon_sym_alias] = ACTIONS(3331),
    [anon_sym_SEMI] = ACTIONS(3333),
    [anon_sym_global] = ACTIONS(3331),
    [anon_sym_using] = ACTIONS(3331),
    [anon_sym_unsafe] = ACTIONS(3331),
    [anon_sym_static] = ACTIONS(3331),
    [anon_sym_LBRACK] = ACTIONS(3333),
    [anon_sym_LPAREN] = ACTIONS(3333),
    [anon_sym_return] = ACTIONS(3331),
    [anon_sym_namespace] = ACTIONS(3331),
    [anon_sym_class] = ACTIONS(3331),
    [anon_sym_ref] = ACTIONS(3331),
    [anon_sym_struct] = ACTIONS(3331),
    [anon_sym_enum] = ACTIONS(3331),
    [anon_sym_LBRACE] = ACTIONS(3333),
    [anon_sym_interface] = ACTIONS(3331),
    [anon_sym_delegate] = ACTIONS(3331),
    [anon_sym_record] = ACTIONS(3331),
    [anon_sym_abstract] = ACTIONS(3331),
    [anon_sym_async] = ACTIONS(3331),
    [anon_sym_const] = ACTIONS(3331),
    [anon_sym_file] = ACTIONS(3331),
    [anon_sym_fixed] = ACTIONS(3331),
    [anon_sym_internal] = ACTIONS(3331),
    [anon_sym_new] = ACTIONS(3331),
    [anon_sym_override] = ACTIONS(3331),
    [anon_sym_partial] = ACTIONS(3331),
    [anon_sym_private] = ACTIONS(3331),
    [anon_sym_protected] = ACTIONS(3331),
    [anon_sym_public] = ACTIONS(3331),
    [anon_sym_readonly] = ACTIONS(3331),
    [anon_sym_required] = ACTIONS(3331),
    [anon_sym_sealed] = ACTIONS(3331),
    [anon_sym_virtual] = ACTIONS(3331),
    [anon_sym_volatile] = ACTIONS(3331),
    [anon_sym_where] = ACTIONS(3331),
    [anon_sym_notnull] = ACTIONS(3331),
    [anon_sym_unmanaged] = ACTIONS(3331),
    [anon_sym_checked] = ACTIONS(3331),
    [anon_sym_BANG] = ACTIONS(3333),
    [anon_sym_TILDE] = ACTIONS(3333),
    [anon_sym_PLUS_PLUS] = ACTIONS(3333),
    [anon_sym_DASH_DASH] = ACTIONS(3333),
    [anon_sym_true] = ACTIONS(3331),
    [anon_sym_false] = ACTIONS(3331),
    [anon_sym_PLUS] = ACTIONS(3331),
    [anon_sym_DASH] = ACTIONS(3331),
    [anon_sym_STAR] = ACTIONS(3333),
    [anon_sym_CARET] = ACTIONS(3333),
    [anon_sym_AMP] = ACTIONS(3333),
    [anon_sym_this] = ACTIONS(3331),
    [anon_sym_scoped] = ACTIONS(3331),
    [anon_sym_var] = ACTIONS(3331),
    [sym_predefined_type] = ACTIONS(3331),
    [anon_sym_break] = ACTIONS(3331),
    [anon_sym_unchecked] = ACTIONS(3331),
    [anon_sym_continue] = ACTIONS(3331),
    [anon_sym_do] = ACTIONS(3331),
    [anon_sym_while] = ACTIONS(3331),
    [anon_sym_for] = ACTIONS(3331),
    [anon_sym_lock] = ACTIONS(3331),
    [anon_sym_yield] = ACTIONS(3331),
    [anon_sym_switch] = ACTIONS(3331),
    [anon_sym_default] = ACTIONS(3331),
    [anon_sym_throw] = ACTIONS(3331),
    [anon_sym_try] = ACTIONS(3331),
    [anon_sym_when] = ACTIONS(3331),
    [anon_sym_await] = ACTIONS(3331),
    [anon_sym_foreach] = ACTIONS(3331),
    [anon_sym_goto] = ACTIONS(3331),
    [anon_sym_if] = ACTIONS(3331),
    [anon_sym_else] = ACTIONS(3331),
    [anon_sym_DOT_DOT] = ACTIONS(3333),
    [anon_sym_from] = ACTIONS(3331),
    [anon_sym_into] = ACTIONS(3331),
    [anon_sym_join] = ACTIONS(3331),
    [anon_sym_on] = ACTIONS(3331),
    [anon_sym_equals] = ACTIONS(3331),
    [anon_sym_let] = ACTIONS(3331),
    [anon_sym_orderby] = ACTIONS(3331),
    [anon_sym_ascending] = ACTIONS(3331),
    [anon_sym_descending] = ACTIONS(3331),
    [anon_sym_group] = ACTIONS(3331),
    [anon_sym_by] = ACTIONS(3331),
    [anon_sym_select] = ACTIONS(3331),
    [anon_sym_DQUOTE] = ACTIONS(3331),
    [anon_sym_stackalloc] = ACTIONS(3331),
    [anon_sym_sizeof] = ACTIONS(3331),
    [anon_sym_typeof] = ACTIONS(3331),
    [anon_sym___makeref] = ACTIONS(3331),
    [anon_sym___reftype] = ACTIONS(3331),
    [anon_sym___refvalue] = ACTIONS(3331),
    [sym_null_literal] = ACTIONS(3331),
    [anon_sym_SQUOTE] = ACTIONS(3333),
    [sym_integer_literal] = ACTIONS(3331),
    [sym_real_literal] = ACTIONS(3333),
    [sym_verbatim_string_literal] = ACTIONS(3333),
    [sym_raw_string_literal] = ACTIONS(3333),
    [aux_sym_preproc_if_token1] = ACTIONS(3333),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3333),
    [sym_interpolation_verbatim_start] = ACTIONS(3333),
    [sym_interpolation_raw_start] = ACTIONS(3333),
  },
  [2427] = {
    [sym_preproc_region] = STATE(2427),
    [sym_preproc_endregion] = STATE(2427),
    [sym_preproc_line] = STATE(2427),
    [sym_preproc_pragma] = STATE(2427),
    [sym_preproc_nullable] = STATE(2427),
    [sym_preproc_error] = STATE(2427),
    [sym_preproc_define] = STATE(2427),
    [sym_preproc_undef] = STATE(2427),
    [ts_builtin_sym_end] = ACTIONS(3329),
    [sym__identifier_token] = ACTIONS(3327),
    [anon_sym_extern] = ACTIONS(3327),
    [anon_sym_alias] = ACTIONS(3327),
    [anon_sym_SEMI] = ACTIONS(3329),
    [anon_sym_global] = ACTIONS(3327),
    [anon_sym_using] = ACTIONS(3327),
    [anon_sym_unsafe] = ACTIONS(3327),
    [anon_sym_static] = ACTIONS(3327),
    [anon_sym_LBRACK] = ACTIONS(3329),
    [anon_sym_LPAREN] = ACTIONS(3329),
    [anon_sym_return] = ACTIONS(3327),
    [anon_sym_namespace] = ACTIONS(3327),
    [anon_sym_class] = ACTIONS(3327),
    [anon_sym_ref] = ACTIONS(3327),
    [anon_sym_struct] = ACTIONS(3327),
    [anon_sym_enum] = ACTIONS(3327),
    [anon_sym_LBRACE] = ACTIONS(3329),
    [anon_sym_interface] = ACTIONS(3327),
    [anon_sym_delegate] = ACTIONS(3327),
    [anon_sym_record] = ACTIONS(3327),
    [anon_sym_abstract] = ACTIONS(3327),
    [anon_sym_async] = ACTIONS(3327),
    [anon_sym_const] = ACTIONS(3327),
    [anon_sym_file] = ACTIONS(3327),
    [anon_sym_fixed] = ACTIONS(3327),
    [anon_sym_internal] = ACTIONS(3327),
    [anon_sym_new] = ACTIONS(3327),
    [anon_sym_override] = ACTIONS(3327),
    [anon_sym_partial] = ACTIONS(3327),
    [anon_sym_private] = ACTIONS(3327),
    [anon_sym_protected] = ACTIONS(3327),
    [anon_sym_public] = ACTIONS(3327),
    [anon_sym_readonly] = ACTIONS(3327),
    [anon_sym_required] = ACTIONS(3327),
    [anon_sym_sealed] = ACTIONS(3327),
    [anon_sym_virtual] = ACTIONS(3327),
    [anon_sym_volatile] = ACTIONS(3327),
    [anon_sym_where] = ACTIONS(3327),
    [anon_sym_notnull] = ACTIONS(3327),
    [anon_sym_unmanaged] = ACTIONS(3327),
    [anon_sym_checked] = ACTIONS(3327),
    [anon_sym_BANG] = ACTIONS(3329),
    [anon_sym_TILDE] = ACTIONS(3329),
    [anon_sym_PLUS_PLUS] = ACTIONS(3329),
    [anon_sym_DASH_DASH] = ACTIONS(3329),
    [anon_sym_true] = ACTIONS(3327),
    [anon_sym_false] = ACTIONS(3327),
    [anon_sym_PLUS] = ACTIONS(3327),
    [anon_sym_DASH] = ACTIONS(3327),
    [anon_sym_STAR] = ACTIONS(3329),
    [anon_sym_CARET] = ACTIONS(3329),
    [anon_sym_AMP] = ACTIONS(3329),
    [anon_sym_this] = ACTIONS(3327),
    [anon_sym_scoped] = ACTIONS(3327),
    [anon_sym_var] = ACTIONS(3327),
    [sym_predefined_type] = ACTIONS(3327),
    [anon_sym_break] = ACTIONS(3327),
    [anon_sym_unchecked] = ACTIONS(3327),
    [anon_sym_continue] = ACTIONS(3327),
    [anon_sym_do] = ACTIONS(3327),
    [anon_sym_while] = ACTIONS(3327),
    [anon_sym_for] = ACTIONS(3327),
    [anon_sym_lock] = ACTIONS(3327),
    [anon_sym_yield] = ACTIONS(3327),
    [anon_sym_switch] = ACTIONS(3327),
    [anon_sym_default] = ACTIONS(3327),
    [anon_sym_throw] = ACTIONS(3327),
    [anon_sym_try] = ACTIONS(3327),
    [anon_sym_when] = ACTIONS(3327),
    [anon_sym_await] = ACTIONS(3327),
    [anon_sym_foreach] = ACTIONS(3327),
    [anon_sym_goto] = ACTIONS(3327),
    [anon_sym_if] = ACTIONS(3327),
    [anon_sym_else] = ACTIONS(3327),
    [anon_sym_DOT_DOT] = ACTIONS(3329),
    [anon_sym_from] = ACTIONS(3327),
    [anon_sym_into] = ACTIONS(3327),
    [anon_sym_join] = ACTIONS(3327),
    [anon_sym_on] = ACTIONS(3327),
    [anon_sym_equals] = ACTIONS(3327),
    [anon_sym_let] = ACTIONS(3327),
    [anon_sym_orderby] = ACTIONS(3327),
    [anon_sym_ascending] = ACTIONS(3327),
    [anon_sym_descending] = ACTIONS(3327),
    [anon_sym_group] = ACTIONS(3327),
    [anon_sym_by] = ACTIONS(3327),
    [anon_sym_select] = ACTIONS(3327),
    [anon_sym_DQUOTE] = ACTIONS(3327),
    [anon_sym_stackalloc] = ACTIONS(3327),
    [anon_sym_sizeof] = ACTIONS(3327),
    [anon_sym_typeof] = ACTIONS(3327),
    [anon_sym___makeref] = ACTIONS(3327),
    [anon_sym___reftype] = ACTIONS(3327),
    [anon_sym___refvalue] = ACTIONS(3327),
    [sym_null_literal] = ACTIONS(3327),
    [anon_sym_SQUOTE] = ACTIONS(3329),
    [sym_integer_literal] = ACTIONS(3327),
    [sym_real_literal] = ACTIONS(3329),
    [sym_verbatim_string_literal] = ACTIONS(3329),
    [sym_raw_string_literal] = ACTIONS(3329),
    [aux_sym_preproc_if_token1] = ACTIONS(3329),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3329),
    [sym_interpolation_verbatim_start] = ACTIONS(3329),
    [sym_interpolation_raw_start] = ACTIONS(3329),
  },
  [2428] = {
    [sym_preproc_region] = STATE(2428),
    [sym_preproc_endregion] = STATE(2428),
    [sym_preproc_line] = STATE(2428),
    [sym_preproc_pragma] = STATE(2428),
    [sym_preproc_nullable] = STATE(2428),
    [sym_preproc_error] = STATE(2428),
    [sym_preproc_define] = STATE(2428),
    [sym_preproc_undef] = STATE(2428),
    [ts_builtin_sym_end] = ACTIONS(3325),
    [sym__identifier_token] = ACTIONS(3323),
    [anon_sym_extern] = ACTIONS(3323),
    [anon_sym_alias] = ACTIONS(3323),
    [anon_sym_SEMI] = ACTIONS(3325),
    [anon_sym_global] = ACTIONS(3323),
    [anon_sym_using] = ACTIONS(3323),
    [anon_sym_unsafe] = ACTIONS(3323),
    [anon_sym_static] = ACTIONS(3323),
    [anon_sym_LBRACK] = ACTIONS(3325),
    [anon_sym_LPAREN] = ACTIONS(3325),
    [anon_sym_return] = ACTIONS(3323),
    [anon_sym_namespace] = ACTIONS(3323),
    [anon_sym_class] = ACTIONS(3323),
    [anon_sym_ref] = ACTIONS(3323),
    [anon_sym_struct] = ACTIONS(3323),
    [anon_sym_enum] = ACTIONS(3323),
    [anon_sym_LBRACE] = ACTIONS(3325),
    [anon_sym_interface] = ACTIONS(3323),
    [anon_sym_delegate] = ACTIONS(3323),
    [anon_sym_record] = ACTIONS(3323),
    [anon_sym_abstract] = ACTIONS(3323),
    [anon_sym_async] = ACTIONS(3323),
    [anon_sym_const] = ACTIONS(3323),
    [anon_sym_file] = ACTIONS(3323),
    [anon_sym_fixed] = ACTIONS(3323),
    [anon_sym_internal] = ACTIONS(3323),
    [anon_sym_new] = ACTIONS(3323),
    [anon_sym_override] = ACTIONS(3323),
    [anon_sym_partial] = ACTIONS(3323),
    [anon_sym_private] = ACTIONS(3323),
    [anon_sym_protected] = ACTIONS(3323),
    [anon_sym_public] = ACTIONS(3323),
    [anon_sym_readonly] = ACTIONS(3323),
    [anon_sym_required] = ACTIONS(3323),
    [anon_sym_sealed] = ACTIONS(3323),
    [anon_sym_virtual] = ACTIONS(3323),
    [anon_sym_volatile] = ACTIONS(3323),
    [anon_sym_where] = ACTIONS(3323),
    [anon_sym_notnull] = ACTIONS(3323),
    [anon_sym_unmanaged] = ACTIONS(3323),
    [anon_sym_checked] = ACTIONS(3323),
    [anon_sym_BANG] = ACTIONS(3325),
    [anon_sym_TILDE] = ACTIONS(3325),
    [anon_sym_PLUS_PLUS] = ACTIONS(3325),
    [anon_sym_DASH_DASH] = ACTIONS(3325),
    [anon_sym_true] = ACTIONS(3323),
    [anon_sym_false] = ACTIONS(3323),
    [anon_sym_PLUS] = ACTIONS(3323),
    [anon_sym_DASH] = ACTIONS(3323),
    [anon_sym_STAR] = ACTIONS(3325),
    [anon_sym_CARET] = ACTIONS(3325),
    [anon_sym_AMP] = ACTIONS(3325),
    [anon_sym_this] = ACTIONS(3323),
    [anon_sym_scoped] = ACTIONS(3323),
    [anon_sym_var] = ACTIONS(3323),
    [sym_predefined_type] = ACTIONS(3323),
    [anon_sym_break] = ACTIONS(3323),
    [anon_sym_unchecked] = ACTIONS(3323),
    [anon_sym_continue] = ACTIONS(3323),
    [anon_sym_do] = ACTIONS(3323),
    [anon_sym_while] = ACTIONS(3323),
    [anon_sym_for] = ACTIONS(3323),
    [anon_sym_lock] = ACTIONS(3323),
    [anon_sym_yield] = ACTIONS(3323),
    [anon_sym_switch] = ACTIONS(3323),
    [anon_sym_default] = ACTIONS(3323),
    [anon_sym_throw] = ACTIONS(3323),
    [anon_sym_try] = ACTIONS(3323),
    [anon_sym_when] = ACTIONS(3323),
    [anon_sym_await] = ACTIONS(3323),
    [anon_sym_foreach] = ACTIONS(3323),
    [anon_sym_goto] = ACTIONS(3323),
    [anon_sym_if] = ACTIONS(3323),
    [anon_sym_else] = ACTIONS(3323),
    [anon_sym_DOT_DOT] = ACTIONS(3325),
    [anon_sym_from] = ACTIONS(3323),
    [anon_sym_into] = ACTIONS(3323),
    [anon_sym_join] = ACTIONS(3323),
    [anon_sym_on] = ACTIONS(3323),
    [anon_sym_equals] = ACTIONS(3323),
    [anon_sym_let] = ACTIONS(3323),
    [anon_sym_orderby] = ACTIONS(3323),
    [anon_sym_ascending] = ACTIONS(3323),
    [anon_sym_descending] = ACTIONS(3323),
    [anon_sym_group] = ACTIONS(3323),
    [anon_sym_by] = ACTIONS(3323),
    [anon_sym_select] = ACTIONS(3323),
    [anon_sym_DQUOTE] = ACTIONS(3323),
    [anon_sym_stackalloc] = ACTIONS(3323),
    [anon_sym_sizeof] = ACTIONS(3323),
    [anon_sym_typeof] = ACTIONS(3323),
    [anon_sym___makeref] = ACTIONS(3323),
    [anon_sym___reftype] = ACTIONS(3323),
    [anon_sym___refvalue] = ACTIONS(3323),
    [sym_null_literal] = ACTIONS(3323),
    [anon_sym_SQUOTE] = ACTIONS(3325),
    [sym_integer_literal] = ACTIONS(3323),
    [sym_real_literal] = ACTIONS(3325),
    [sym_verbatim_string_literal] = ACTIONS(3325),
    [sym_raw_string_literal] = ACTIONS(3325),
    [aux_sym_preproc_if_token1] = ACTIONS(3325),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3325),
    [sym_interpolation_verbatim_start] = ACTIONS(3325),
    [sym_interpolation_raw_start] = ACTIONS(3325),
  },
  [2429] = {
    [sym_preproc_region] = STATE(2429),
    [sym_preproc_endregion] = STATE(2429),
    [sym_preproc_line] = STATE(2429),
    [sym_preproc_pragma] = STATE(2429),
    [sym_preproc_nullable] = STATE(2429),
    [sym_preproc_error] = STATE(2429),
    [sym_preproc_define] = STATE(2429),
    [sym_preproc_undef] = STATE(2429),
    [ts_builtin_sym_end] = ACTIONS(3083),
    [sym__identifier_token] = ACTIONS(3081),
    [anon_sym_extern] = ACTIONS(3081),
    [anon_sym_alias] = ACTIONS(3081),
    [anon_sym_SEMI] = ACTIONS(3083),
    [anon_sym_global] = ACTIONS(3081),
    [anon_sym_using] = ACTIONS(3081),
    [anon_sym_unsafe] = ACTIONS(3081),
    [anon_sym_static] = ACTIONS(3081),
    [anon_sym_LBRACK] = ACTIONS(3083),
    [anon_sym_LPAREN] = ACTIONS(3083),
    [anon_sym_return] = ACTIONS(3081),
    [anon_sym_namespace] = ACTIONS(3081),
    [anon_sym_class] = ACTIONS(3081),
    [anon_sym_ref] = ACTIONS(3081),
    [anon_sym_struct] = ACTIONS(3081),
    [anon_sym_enum] = ACTIONS(3081),
    [anon_sym_LBRACE] = ACTIONS(3083),
    [anon_sym_interface] = ACTIONS(3081),
    [anon_sym_delegate] = ACTIONS(3081),
    [anon_sym_record] = ACTIONS(3081),
    [anon_sym_abstract] = ACTIONS(3081),
    [anon_sym_async] = ACTIONS(3081),
    [anon_sym_const] = ACTIONS(3081),
    [anon_sym_file] = ACTIONS(3081),
    [anon_sym_fixed] = ACTIONS(3081),
    [anon_sym_internal] = ACTIONS(3081),
    [anon_sym_new] = ACTIONS(3081),
    [anon_sym_override] = ACTIONS(3081),
    [anon_sym_partial] = ACTIONS(3081),
    [anon_sym_private] = ACTIONS(3081),
    [anon_sym_protected] = ACTIONS(3081),
    [anon_sym_public] = ACTIONS(3081),
    [anon_sym_readonly] = ACTIONS(3081),
    [anon_sym_required] = ACTIONS(3081),
    [anon_sym_sealed] = ACTIONS(3081),
    [anon_sym_virtual] = ACTIONS(3081),
    [anon_sym_volatile] = ACTIONS(3081),
    [anon_sym_where] = ACTIONS(3081),
    [anon_sym_notnull] = ACTIONS(3081),
    [anon_sym_unmanaged] = ACTIONS(3081),
    [anon_sym_checked] = ACTIONS(3081),
    [anon_sym_BANG] = ACTIONS(3083),
    [anon_sym_TILDE] = ACTIONS(3083),
    [anon_sym_PLUS_PLUS] = ACTIONS(3083),
    [anon_sym_DASH_DASH] = ACTIONS(3083),
    [anon_sym_true] = ACTIONS(3081),
    [anon_sym_false] = ACTIONS(3081),
    [anon_sym_PLUS] = ACTIONS(3081),
    [anon_sym_DASH] = ACTIONS(3081),
    [anon_sym_STAR] = ACTIONS(3083),
    [anon_sym_CARET] = ACTIONS(3083),
    [anon_sym_AMP] = ACTIONS(3083),
    [anon_sym_this] = ACTIONS(3081),
    [anon_sym_scoped] = ACTIONS(3081),
    [anon_sym_var] = ACTIONS(3081),
    [sym_predefined_type] = ACTIONS(3081),
    [anon_sym_break] = ACTIONS(3081),
    [anon_sym_unchecked] = ACTIONS(3081),
    [anon_sym_continue] = ACTIONS(3081),
    [anon_sym_do] = ACTIONS(3081),
    [anon_sym_while] = ACTIONS(3081),
    [anon_sym_for] = ACTIONS(3081),
    [anon_sym_lock] = ACTIONS(3081),
    [anon_sym_yield] = ACTIONS(3081),
    [anon_sym_switch] = ACTIONS(3081),
    [anon_sym_default] = ACTIONS(3081),
    [anon_sym_throw] = ACTIONS(3081),
    [anon_sym_try] = ACTIONS(3081),
    [anon_sym_when] = ACTIONS(3081),
    [anon_sym_await] = ACTIONS(3081),
    [anon_sym_foreach] = ACTIONS(3081),
    [anon_sym_goto] = ACTIONS(3081),
    [anon_sym_if] = ACTIONS(3081),
    [anon_sym_else] = ACTIONS(3081),
    [anon_sym_DOT_DOT] = ACTIONS(3083),
    [anon_sym_from] = ACTIONS(3081),
    [anon_sym_into] = ACTIONS(3081),
    [anon_sym_join] = ACTIONS(3081),
    [anon_sym_on] = ACTIONS(3081),
    [anon_sym_equals] = ACTIONS(3081),
    [anon_sym_let] = ACTIONS(3081),
    [anon_sym_orderby] = ACTIONS(3081),
    [anon_sym_ascending] = ACTIONS(3081),
    [anon_sym_descending] = ACTIONS(3081),
    [anon_sym_group] = ACTIONS(3081),
    [anon_sym_by] = ACTIONS(3081),
    [anon_sym_select] = ACTIONS(3081),
    [anon_sym_DQUOTE] = ACTIONS(3081),
    [anon_sym_stackalloc] = ACTIONS(3081),
    [anon_sym_sizeof] = ACTIONS(3081),
    [anon_sym_typeof] = ACTIONS(3081),
    [anon_sym___makeref] = ACTIONS(3081),
    [anon_sym___reftype] = ACTIONS(3081),
    [anon_sym___refvalue] = ACTIONS(3081),
    [sym_null_literal] = ACTIONS(3081),
    [anon_sym_SQUOTE] = ACTIONS(3083),
    [sym_integer_literal] = ACTIONS(3081),
    [sym_real_literal] = ACTIONS(3083),
    [sym_verbatim_string_literal] = ACTIONS(3083),
    [sym_raw_string_literal] = ACTIONS(3083),
    [aux_sym_preproc_if_token1] = ACTIONS(3083),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3083),
    [sym_interpolation_verbatim_start] = ACTIONS(3083),
    [sym_interpolation_raw_start] = ACTIONS(3083),
  },
  [2430] = {
    [sym_preproc_region] = STATE(2430),
    [sym_preproc_endregion] = STATE(2430),
    [sym_preproc_line] = STATE(2430),
    [sym_preproc_pragma] = STATE(2430),
    [sym_preproc_nullable] = STATE(2430),
    [sym_preproc_error] = STATE(2430),
    [sym_preproc_define] = STATE(2430),
    [sym_preproc_undef] = STATE(2430),
    [ts_builtin_sym_end] = ACTIONS(3415),
    [sym__identifier_token] = ACTIONS(3413),
    [anon_sym_extern] = ACTIONS(3413),
    [anon_sym_alias] = ACTIONS(3413),
    [anon_sym_SEMI] = ACTIONS(3415),
    [anon_sym_global] = ACTIONS(3413),
    [anon_sym_using] = ACTIONS(3413),
    [anon_sym_unsafe] = ACTIONS(3413),
    [anon_sym_static] = ACTIONS(3413),
    [anon_sym_LBRACK] = ACTIONS(3415),
    [anon_sym_LPAREN] = ACTIONS(3415),
    [anon_sym_return] = ACTIONS(3413),
    [anon_sym_namespace] = ACTIONS(3413),
    [anon_sym_class] = ACTIONS(3413),
    [anon_sym_ref] = ACTIONS(3413),
    [anon_sym_struct] = ACTIONS(3413),
    [anon_sym_enum] = ACTIONS(3413),
    [anon_sym_LBRACE] = ACTIONS(3415),
    [anon_sym_interface] = ACTIONS(3413),
    [anon_sym_delegate] = ACTIONS(3413),
    [anon_sym_record] = ACTIONS(3413),
    [anon_sym_abstract] = ACTIONS(3413),
    [anon_sym_async] = ACTIONS(3413),
    [anon_sym_const] = ACTIONS(3413),
    [anon_sym_file] = ACTIONS(3413),
    [anon_sym_fixed] = ACTIONS(3413),
    [anon_sym_internal] = ACTIONS(3413),
    [anon_sym_new] = ACTIONS(3413),
    [anon_sym_override] = ACTIONS(3413),
    [anon_sym_partial] = ACTIONS(3413),
    [anon_sym_private] = ACTIONS(3413),
    [anon_sym_protected] = ACTIONS(3413),
    [anon_sym_public] = ACTIONS(3413),
    [anon_sym_readonly] = ACTIONS(3413),
    [anon_sym_required] = ACTIONS(3413),
    [anon_sym_sealed] = ACTIONS(3413),
    [anon_sym_virtual] = ACTIONS(3413),
    [anon_sym_volatile] = ACTIONS(3413),
    [anon_sym_where] = ACTIONS(3413),
    [anon_sym_notnull] = ACTIONS(3413),
    [anon_sym_unmanaged] = ACTIONS(3413),
    [anon_sym_checked] = ACTIONS(3413),
    [anon_sym_BANG] = ACTIONS(3415),
    [anon_sym_TILDE] = ACTIONS(3415),
    [anon_sym_PLUS_PLUS] = ACTIONS(3415),
    [anon_sym_DASH_DASH] = ACTIONS(3415),
    [anon_sym_true] = ACTIONS(3413),
    [anon_sym_false] = ACTIONS(3413),
    [anon_sym_PLUS] = ACTIONS(3413),
    [anon_sym_DASH] = ACTIONS(3413),
    [anon_sym_STAR] = ACTIONS(3415),
    [anon_sym_CARET] = ACTIONS(3415),
    [anon_sym_AMP] = ACTIONS(3415),
    [anon_sym_this] = ACTIONS(3413),
    [anon_sym_scoped] = ACTIONS(3413),
    [anon_sym_var] = ACTIONS(3413),
    [sym_predefined_type] = ACTIONS(3413),
    [anon_sym_break] = ACTIONS(3413),
    [anon_sym_unchecked] = ACTIONS(3413),
    [anon_sym_continue] = ACTIONS(3413),
    [anon_sym_do] = ACTIONS(3413),
    [anon_sym_while] = ACTIONS(3413),
    [anon_sym_for] = ACTIONS(3413),
    [anon_sym_lock] = ACTIONS(3413),
    [anon_sym_yield] = ACTIONS(3413),
    [anon_sym_switch] = ACTIONS(3413),
    [anon_sym_default] = ACTIONS(3413),
    [anon_sym_throw] = ACTIONS(3413),
    [anon_sym_try] = ACTIONS(3413),
    [anon_sym_when] = ACTIONS(3413),
    [anon_sym_await] = ACTIONS(3413),
    [anon_sym_foreach] = ACTIONS(3413),
    [anon_sym_goto] = ACTIONS(3413),
    [anon_sym_if] = ACTIONS(3413),
    [anon_sym_else] = ACTIONS(3413),
    [anon_sym_DOT_DOT] = ACTIONS(3415),
    [anon_sym_from] = ACTIONS(3413),
    [anon_sym_into] = ACTIONS(3413),
    [anon_sym_join] = ACTIONS(3413),
    [anon_sym_on] = ACTIONS(3413),
    [anon_sym_equals] = ACTIONS(3413),
    [anon_sym_let] = ACTIONS(3413),
    [anon_sym_orderby] = ACTIONS(3413),
    [anon_sym_ascending] = ACTIONS(3413),
    [anon_sym_descending] = ACTIONS(3413),
    [anon_sym_group] = ACTIONS(3413),
    [anon_sym_by] = ACTIONS(3413),
    [anon_sym_select] = ACTIONS(3413),
    [anon_sym_DQUOTE] = ACTIONS(3413),
    [anon_sym_stackalloc] = ACTIONS(3413),
    [anon_sym_sizeof] = ACTIONS(3413),
    [anon_sym_typeof] = ACTIONS(3413),
    [anon_sym___makeref] = ACTIONS(3413),
    [anon_sym___reftype] = ACTIONS(3413),
    [anon_sym___refvalue] = ACTIONS(3413),
    [sym_null_literal] = ACTIONS(3413),
    [anon_sym_SQUOTE] = ACTIONS(3415),
    [sym_integer_literal] = ACTIONS(3413),
    [sym_real_literal] = ACTIONS(3415),
    [sym_verbatim_string_literal] = ACTIONS(3415),
    [sym_raw_string_literal] = ACTIONS(3415),
    [aux_sym_preproc_if_token1] = ACTIONS(3415),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3415),
    [sym_interpolation_verbatim_start] = ACTIONS(3415),
    [sym_interpolation_raw_start] = ACTIONS(3415),
  },
  [2431] = {
    [sym_preproc_region] = STATE(2431),
    [sym_preproc_endregion] = STATE(2431),
    [sym_preproc_line] = STATE(2431),
    [sym_preproc_pragma] = STATE(2431),
    [sym_preproc_nullable] = STATE(2431),
    [sym_preproc_error] = STATE(2431),
    [sym_preproc_define] = STATE(2431),
    [sym_preproc_undef] = STATE(2431),
    [ts_builtin_sym_end] = ACTIONS(3389),
    [sym__identifier_token] = ACTIONS(3387),
    [anon_sym_extern] = ACTIONS(3387),
    [anon_sym_alias] = ACTIONS(3387),
    [anon_sym_SEMI] = ACTIONS(3389),
    [anon_sym_global] = ACTIONS(3387),
    [anon_sym_using] = ACTIONS(3387),
    [anon_sym_unsafe] = ACTIONS(3387),
    [anon_sym_static] = ACTIONS(3387),
    [anon_sym_LBRACK] = ACTIONS(3389),
    [anon_sym_LPAREN] = ACTIONS(3389),
    [anon_sym_return] = ACTIONS(3387),
    [anon_sym_namespace] = ACTIONS(3387),
    [anon_sym_class] = ACTIONS(3387),
    [anon_sym_ref] = ACTIONS(3387),
    [anon_sym_struct] = ACTIONS(3387),
    [anon_sym_enum] = ACTIONS(3387),
    [anon_sym_LBRACE] = ACTIONS(3389),
    [anon_sym_interface] = ACTIONS(3387),
    [anon_sym_delegate] = ACTIONS(3387),
    [anon_sym_record] = ACTIONS(3387),
    [anon_sym_abstract] = ACTIONS(3387),
    [anon_sym_async] = ACTIONS(3387),
    [anon_sym_const] = ACTIONS(3387),
    [anon_sym_file] = ACTIONS(3387),
    [anon_sym_fixed] = ACTIONS(3387),
    [anon_sym_internal] = ACTIONS(3387),
    [anon_sym_new] = ACTIONS(3387),
    [anon_sym_override] = ACTIONS(3387),
    [anon_sym_partial] = ACTIONS(3387),
    [anon_sym_private] = ACTIONS(3387),
    [anon_sym_protected] = ACTIONS(3387),
    [anon_sym_public] = ACTIONS(3387),
    [anon_sym_readonly] = ACTIONS(3387),
    [anon_sym_required] = ACTIONS(3387),
    [anon_sym_sealed] = ACTIONS(3387),
    [anon_sym_virtual] = ACTIONS(3387),
    [anon_sym_volatile] = ACTIONS(3387),
    [anon_sym_where] = ACTIONS(3387),
    [anon_sym_notnull] = ACTIONS(3387),
    [anon_sym_unmanaged] = ACTIONS(3387),
    [anon_sym_checked] = ACTIONS(3387),
    [anon_sym_BANG] = ACTIONS(3389),
    [anon_sym_TILDE] = ACTIONS(3389),
    [anon_sym_PLUS_PLUS] = ACTIONS(3389),
    [anon_sym_DASH_DASH] = ACTIONS(3389),
    [anon_sym_true] = ACTIONS(3387),
    [anon_sym_false] = ACTIONS(3387),
    [anon_sym_PLUS] = ACTIONS(3387),
    [anon_sym_DASH] = ACTIONS(3387),
    [anon_sym_STAR] = ACTIONS(3389),
    [anon_sym_CARET] = ACTIONS(3389),
    [anon_sym_AMP] = ACTIONS(3389),
    [anon_sym_this] = ACTIONS(3387),
    [anon_sym_scoped] = ACTIONS(3387),
    [anon_sym_var] = ACTIONS(3387),
    [sym_predefined_type] = ACTIONS(3387),
    [anon_sym_break] = ACTIONS(3387),
    [anon_sym_unchecked] = ACTIONS(3387),
    [anon_sym_continue] = ACTIONS(3387),
    [anon_sym_do] = ACTIONS(3387),
    [anon_sym_while] = ACTIONS(3387),
    [anon_sym_for] = ACTIONS(3387),
    [anon_sym_lock] = ACTIONS(3387),
    [anon_sym_yield] = ACTIONS(3387),
    [anon_sym_switch] = ACTIONS(3387),
    [anon_sym_default] = ACTIONS(3387),
    [anon_sym_throw] = ACTIONS(3387),
    [anon_sym_try] = ACTIONS(3387),
    [anon_sym_when] = ACTIONS(3387),
    [anon_sym_await] = ACTIONS(3387),
    [anon_sym_foreach] = ACTIONS(3387),
    [anon_sym_goto] = ACTIONS(3387),
    [anon_sym_if] = ACTIONS(3387),
    [anon_sym_else] = ACTIONS(3387),
    [anon_sym_DOT_DOT] = ACTIONS(3389),
    [anon_sym_from] = ACTIONS(3387),
    [anon_sym_into] = ACTIONS(3387),
    [anon_sym_join] = ACTIONS(3387),
    [anon_sym_on] = ACTIONS(3387),
    [anon_sym_equals] = ACTIONS(3387),
    [anon_sym_let] = ACTIONS(3387),
    [anon_sym_orderby] = ACTIONS(3387),
    [anon_sym_ascending] = ACTIONS(3387),
    [anon_sym_descending] = ACTIONS(3387),
    [anon_sym_group] = ACTIONS(3387),
    [anon_sym_by] = ACTIONS(3387),
    [anon_sym_select] = ACTIONS(3387),
    [anon_sym_DQUOTE] = ACTIONS(3387),
    [anon_sym_stackalloc] = ACTIONS(3387),
    [anon_sym_sizeof] = ACTIONS(3387),
    [anon_sym_typeof] = ACTIONS(3387),
    [anon_sym___makeref] = ACTIONS(3387),
    [anon_sym___reftype] = ACTIONS(3387),
    [anon_sym___refvalue] = ACTIONS(3387),
    [sym_null_literal] = ACTIONS(3387),
    [anon_sym_SQUOTE] = ACTIONS(3389),
    [sym_integer_literal] = ACTIONS(3387),
    [sym_real_literal] = ACTIONS(3389),
    [sym_verbatim_string_literal] = ACTIONS(3389),
    [sym_raw_string_literal] = ACTIONS(3389),
    [aux_sym_preproc_if_token1] = ACTIONS(3389),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3389),
    [sym_interpolation_verbatim_start] = ACTIONS(3389),
    [sym_interpolation_raw_start] = ACTIONS(3389),
  },
  [2432] = {
    [sym_preproc_region] = STATE(2432),
    [sym_preproc_endregion] = STATE(2432),
    [sym_preproc_line] = STATE(2432),
    [sym_preproc_pragma] = STATE(2432),
    [sym_preproc_nullable] = STATE(2432),
    [sym_preproc_error] = STATE(2432),
    [sym_preproc_define] = STATE(2432),
    [sym_preproc_undef] = STATE(2432),
    [ts_builtin_sym_end] = ACTIONS(3393),
    [sym__identifier_token] = ACTIONS(3391),
    [anon_sym_extern] = ACTIONS(3391),
    [anon_sym_alias] = ACTIONS(3391),
    [anon_sym_SEMI] = ACTIONS(3393),
    [anon_sym_global] = ACTIONS(3391),
    [anon_sym_using] = ACTIONS(3391),
    [anon_sym_unsafe] = ACTIONS(3391),
    [anon_sym_static] = ACTIONS(3391),
    [anon_sym_LBRACK] = ACTIONS(3393),
    [anon_sym_LPAREN] = ACTIONS(3393),
    [anon_sym_return] = ACTIONS(3391),
    [anon_sym_namespace] = ACTIONS(3391),
    [anon_sym_class] = ACTIONS(3391),
    [anon_sym_ref] = ACTIONS(3391),
    [anon_sym_struct] = ACTIONS(3391),
    [anon_sym_enum] = ACTIONS(3391),
    [anon_sym_LBRACE] = ACTIONS(3393),
    [anon_sym_interface] = ACTIONS(3391),
    [anon_sym_delegate] = ACTIONS(3391),
    [anon_sym_record] = ACTIONS(3391),
    [anon_sym_abstract] = ACTIONS(3391),
    [anon_sym_async] = ACTIONS(3391),
    [anon_sym_const] = ACTIONS(3391),
    [anon_sym_file] = ACTIONS(3391),
    [anon_sym_fixed] = ACTIONS(3391),
    [anon_sym_internal] = ACTIONS(3391),
    [anon_sym_new] = ACTIONS(3391),
    [anon_sym_override] = ACTIONS(3391),
    [anon_sym_partial] = ACTIONS(3391),
    [anon_sym_private] = ACTIONS(3391),
    [anon_sym_protected] = ACTIONS(3391),
    [anon_sym_public] = ACTIONS(3391),
    [anon_sym_readonly] = ACTIONS(3391),
    [anon_sym_required] = ACTIONS(3391),
    [anon_sym_sealed] = ACTIONS(3391),
    [anon_sym_virtual] = ACTIONS(3391),
    [anon_sym_volatile] = ACTIONS(3391),
    [anon_sym_where] = ACTIONS(3391),
    [anon_sym_notnull] = ACTIONS(3391),
    [anon_sym_unmanaged] = ACTIONS(3391),
    [anon_sym_checked] = ACTIONS(3391),
    [anon_sym_BANG] = ACTIONS(3393),
    [anon_sym_TILDE] = ACTIONS(3393),
    [anon_sym_PLUS_PLUS] = ACTIONS(3393),
    [anon_sym_DASH_DASH] = ACTIONS(3393),
    [anon_sym_true] = ACTIONS(3391),
    [anon_sym_false] = ACTIONS(3391),
    [anon_sym_PLUS] = ACTIONS(3391),
    [anon_sym_DASH] = ACTIONS(3391),
    [anon_sym_STAR] = ACTIONS(3393),
    [anon_sym_CARET] = ACTIONS(3393),
    [anon_sym_AMP] = ACTIONS(3393),
    [anon_sym_this] = ACTIONS(3391),
    [anon_sym_scoped] = ACTIONS(3391),
    [anon_sym_var] = ACTIONS(3391),
    [sym_predefined_type] = ACTIONS(3391),
    [anon_sym_break] = ACTIONS(3391),
    [anon_sym_unchecked] = ACTIONS(3391),
    [anon_sym_continue] = ACTIONS(3391),
    [anon_sym_do] = ACTIONS(3391),
    [anon_sym_while] = ACTIONS(3391),
    [anon_sym_for] = ACTIONS(3391),
    [anon_sym_lock] = ACTIONS(3391),
    [anon_sym_yield] = ACTIONS(3391),
    [anon_sym_switch] = ACTIONS(3391),
    [anon_sym_default] = ACTIONS(3391),
    [anon_sym_throw] = ACTIONS(3391),
    [anon_sym_try] = ACTIONS(3391),
    [anon_sym_when] = ACTIONS(3391),
    [anon_sym_await] = ACTIONS(3391),
    [anon_sym_foreach] = ACTIONS(3391),
    [anon_sym_goto] = ACTIONS(3391),
    [anon_sym_if] = ACTIONS(3391),
    [anon_sym_else] = ACTIONS(3944),
    [anon_sym_DOT_DOT] = ACTIONS(3393),
    [anon_sym_from] = ACTIONS(3391),
    [anon_sym_into] = ACTIONS(3391),
    [anon_sym_join] = ACTIONS(3391),
    [anon_sym_on] = ACTIONS(3391),
    [anon_sym_equals] = ACTIONS(3391),
    [anon_sym_let] = ACTIONS(3391),
    [anon_sym_orderby] = ACTIONS(3391),
    [anon_sym_ascending] = ACTIONS(3391),
    [anon_sym_descending] = ACTIONS(3391),
    [anon_sym_group] = ACTIONS(3391),
    [anon_sym_by] = ACTIONS(3391),
    [anon_sym_select] = ACTIONS(3391),
    [anon_sym_DQUOTE] = ACTIONS(3391),
    [anon_sym_stackalloc] = ACTIONS(3391),
    [anon_sym_sizeof] = ACTIONS(3391),
    [anon_sym_typeof] = ACTIONS(3391),
    [anon_sym___makeref] = ACTIONS(3391),
    [anon_sym___reftype] = ACTIONS(3391),
    [anon_sym___refvalue] = ACTIONS(3391),
    [sym_null_literal] = ACTIONS(3391),
    [anon_sym_SQUOTE] = ACTIONS(3393),
    [sym_integer_literal] = ACTIONS(3391),
    [sym_real_literal] = ACTIONS(3393),
    [sym_verbatim_string_literal] = ACTIONS(3393),
    [sym_raw_string_literal] = ACTIONS(3393),
    [aux_sym_preproc_if_token1] = ACTIONS(3393),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3393),
    [sym_interpolation_verbatim_start] = ACTIONS(3393),
    [sym_interpolation_raw_start] = ACTIONS(3393),
  },
  [2433] = {
    [sym_preproc_region] = STATE(2433),
    [sym_preproc_endregion] = STATE(2433),
    [sym_preproc_line] = STATE(2433),
    [sym_preproc_pragma] = STATE(2433),
    [sym_preproc_nullable] = STATE(2433),
    [sym_preproc_error] = STATE(2433),
    [sym_preproc_define] = STATE(2433),
    [sym_preproc_undef] = STATE(2433),
    [ts_builtin_sym_end] = ACTIONS(3257),
    [sym__identifier_token] = ACTIONS(3255),
    [anon_sym_extern] = ACTIONS(3255),
    [anon_sym_alias] = ACTIONS(3255),
    [anon_sym_SEMI] = ACTIONS(3257),
    [anon_sym_global] = ACTIONS(3255),
    [anon_sym_using] = ACTIONS(3255),
    [anon_sym_unsafe] = ACTIONS(3255),
    [anon_sym_static] = ACTIONS(3255),
    [anon_sym_LBRACK] = ACTIONS(3257),
    [anon_sym_LPAREN] = ACTIONS(3257),
    [anon_sym_return] = ACTIONS(3255),
    [anon_sym_namespace] = ACTIONS(3255),
    [anon_sym_class] = ACTIONS(3255),
    [anon_sym_ref] = ACTIONS(3255),
    [anon_sym_struct] = ACTIONS(3255),
    [anon_sym_enum] = ACTIONS(3255),
    [anon_sym_LBRACE] = ACTIONS(3257),
    [anon_sym_interface] = ACTIONS(3255),
    [anon_sym_delegate] = ACTIONS(3255),
    [anon_sym_record] = ACTIONS(3255),
    [anon_sym_abstract] = ACTIONS(3255),
    [anon_sym_async] = ACTIONS(3255),
    [anon_sym_const] = ACTIONS(3255),
    [anon_sym_file] = ACTIONS(3255),
    [anon_sym_fixed] = ACTIONS(3255),
    [anon_sym_internal] = ACTIONS(3255),
    [anon_sym_new] = ACTIONS(3255),
    [anon_sym_override] = ACTIONS(3255),
    [anon_sym_partial] = ACTIONS(3255),
    [anon_sym_private] = ACTIONS(3255),
    [anon_sym_protected] = ACTIONS(3255),
    [anon_sym_public] = ACTIONS(3255),
    [anon_sym_readonly] = ACTIONS(3255),
    [anon_sym_required] = ACTIONS(3255),
    [anon_sym_sealed] = ACTIONS(3255),
    [anon_sym_virtual] = ACTIONS(3255),
    [anon_sym_volatile] = ACTIONS(3255),
    [anon_sym_where] = ACTIONS(3255),
    [anon_sym_notnull] = ACTIONS(3255),
    [anon_sym_unmanaged] = ACTIONS(3255),
    [anon_sym_checked] = ACTIONS(3255),
    [anon_sym_BANG] = ACTIONS(3257),
    [anon_sym_TILDE] = ACTIONS(3257),
    [anon_sym_PLUS_PLUS] = ACTIONS(3257),
    [anon_sym_DASH_DASH] = ACTIONS(3257),
    [anon_sym_true] = ACTIONS(3255),
    [anon_sym_false] = ACTIONS(3255),
    [anon_sym_PLUS] = ACTIONS(3255),
    [anon_sym_DASH] = ACTIONS(3255),
    [anon_sym_STAR] = ACTIONS(3257),
    [anon_sym_CARET] = ACTIONS(3257),
    [anon_sym_AMP] = ACTIONS(3257),
    [anon_sym_this] = ACTIONS(3255),
    [anon_sym_scoped] = ACTIONS(3255),
    [anon_sym_var] = ACTIONS(3255),
    [sym_predefined_type] = ACTIONS(3255),
    [anon_sym_break] = ACTIONS(3255),
    [anon_sym_unchecked] = ACTIONS(3255),
    [anon_sym_continue] = ACTIONS(3255),
    [anon_sym_do] = ACTIONS(3255),
    [anon_sym_while] = ACTIONS(3255),
    [anon_sym_for] = ACTIONS(3255),
    [anon_sym_lock] = ACTIONS(3255),
    [anon_sym_yield] = ACTIONS(3255),
    [anon_sym_switch] = ACTIONS(3255),
    [anon_sym_default] = ACTIONS(3255),
    [anon_sym_throw] = ACTIONS(3255),
    [anon_sym_try] = ACTIONS(3255),
    [anon_sym_when] = ACTIONS(3255),
    [anon_sym_await] = ACTIONS(3255),
    [anon_sym_foreach] = ACTIONS(3255),
    [anon_sym_goto] = ACTIONS(3255),
    [anon_sym_if] = ACTIONS(3255),
    [anon_sym_else] = ACTIONS(3255),
    [anon_sym_DOT_DOT] = ACTIONS(3257),
    [anon_sym_from] = ACTIONS(3255),
    [anon_sym_into] = ACTIONS(3255),
    [anon_sym_join] = ACTIONS(3255),
    [anon_sym_on] = ACTIONS(3255),
    [anon_sym_equals] = ACTIONS(3255),
    [anon_sym_let] = ACTIONS(3255),
    [anon_sym_orderby] = ACTIONS(3255),
    [anon_sym_ascending] = ACTIONS(3255),
    [anon_sym_descending] = ACTIONS(3255),
    [anon_sym_group] = ACTIONS(3255),
    [anon_sym_by] = ACTIONS(3255),
    [anon_sym_select] = ACTIONS(3255),
    [anon_sym_DQUOTE] = ACTIONS(3255),
    [anon_sym_stackalloc] = ACTIONS(3255),
    [anon_sym_sizeof] = ACTIONS(3255),
    [anon_sym_typeof] = ACTIONS(3255),
    [anon_sym___makeref] = ACTIONS(3255),
    [anon_sym___reftype] = ACTIONS(3255),
    [anon_sym___refvalue] = ACTIONS(3255),
    [sym_null_literal] = ACTIONS(3255),
    [anon_sym_SQUOTE] = ACTIONS(3257),
    [sym_integer_literal] = ACTIONS(3255),
    [sym_real_literal] = ACTIONS(3257),
    [sym_verbatim_string_literal] = ACTIONS(3257),
    [sym_raw_string_literal] = ACTIONS(3257),
    [aux_sym_preproc_if_token1] = ACTIONS(3257),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3257),
    [sym_interpolation_verbatim_start] = ACTIONS(3257),
    [sym_interpolation_raw_start] = ACTIONS(3257),
  },
  [2434] = {
    [sym_preproc_region] = STATE(2434),
    [sym_preproc_endregion] = STATE(2434),
    [sym_preproc_line] = STATE(2434),
    [sym_preproc_pragma] = STATE(2434),
    [sym_preproc_nullable] = STATE(2434),
    [sym_preproc_error] = STATE(2434),
    [sym_preproc_define] = STATE(2434),
    [sym_preproc_undef] = STATE(2434),
    [ts_builtin_sym_end] = ACTIONS(3209),
    [sym__identifier_token] = ACTIONS(3207),
    [anon_sym_extern] = ACTIONS(3207),
    [anon_sym_alias] = ACTIONS(3207),
    [anon_sym_SEMI] = ACTIONS(3209),
    [anon_sym_global] = ACTIONS(3207),
    [anon_sym_using] = ACTIONS(3207),
    [anon_sym_unsafe] = ACTIONS(3207),
    [anon_sym_static] = ACTIONS(3207),
    [anon_sym_LBRACK] = ACTIONS(3209),
    [anon_sym_LPAREN] = ACTIONS(3209),
    [anon_sym_return] = ACTIONS(3207),
    [anon_sym_namespace] = ACTIONS(3207),
    [anon_sym_class] = ACTIONS(3207),
    [anon_sym_ref] = ACTIONS(3207),
    [anon_sym_struct] = ACTIONS(3207),
    [anon_sym_enum] = ACTIONS(3207),
    [anon_sym_LBRACE] = ACTIONS(3209),
    [anon_sym_interface] = ACTIONS(3207),
    [anon_sym_delegate] = ACTIONS(3207),
    [anon_sym_record] = ACTIONS(3207),
    [anon_sym_abstract] = ACTIONS(3207),
    [anon_sym_async] = ACTIONS(3207),
    [anon_sym_const] = ACTIONS(3207),
    [anon_sym_file] = ACTIONS(3207),
    [anon_sym_fixed] = ACTIONS(3207),
    [anon_sym_internal] = ACTIONS(3207),
    [anon_sym_new] = ACTIONS(3207),
    [anon_sym_override] = ACTIONS(3207),
    [anon_sym_partial] = ACTIONS(3207),
    [anon_sym_private] = ACTIONS(3207),
    [anon_sym_protected] = ACTIONS(3207),
    [anon_sym_public] = ACTIONS(3207),
    [anon_sym_readonly] = ACTIONS(3207),
    [anon_sym_required] = ACTIONS(3207),
    [anon_sym_sealed] = ACTIONS(3207),
    [anon_sym_virtual] = ACTIONS(3207),
    [anon_sym_volatile] = ACTIONS(3207),
    [anon_sym_where] = ACTIONS(3207),
    [anon_sym_notnull] = ACTIONS(3207),
    [anon_sym_unmanaged] = ACTIONS(3207),
    [anon_sym_checked] = ACTIONS(3207),
    [anon_sym_BANG] = ACTIONS(3209),
    [anon_sym_TILDE] = ACTIONS(3209),
    [anon_sym_PLUS_PLUS] = ACTIONS(3209),
    [anon_sym_DASH_DASH] = ACTIONS(3209),
    [anon_sym_true] = ACTIONS(3207),
    [anon_sym_false] = ACTIONS(3207),
    [anon_sym_PLUS] = ACTIONS(3207),
    [anon_sym_DASH] = ACTIONS(3207),
    [anon_sym_STAR] = ACTIONS(3209),
    [anon_sym_CARET] = ACTIONS(3209),
    [anon_sym_AMP] = ACTIONS(3209),
    [anon_sym_this] = ACTIONS(3207),
    [anon_sym_scoped] = ACTIONS(3207),
    [anon_sym_var] = ACTIONS(3207),
    [sym_predefined_type] = ACTIONS(3207),
    [anon_sym_break] = ACTIONS(3207),
    [anon_sym_unchecked] = ACTIONS(3207),
    [anon_sym_continue] = ACTIONS(3207),
    [anon_sym_do] = ACTIONS(3207),
    [anon_sym_while] = ACTIONS(3207),
    [anon_sym_for] = ACTIONS(3207),
    [anon_sym_lock] = ACTIONS(3207),
    [anon_sym_yield] = ACTIONS(3207),
    [anon_sym_switch] = ACTIONS(3207),
    [anon_sym_default] = ACTIONS(3207),
    [anon_sym_throw] = ACTIONS(3207),
    [anon_sym_try] = ACTIONS(3207),
    [anon_sym_when] = ACTIONS(3207),
    [anon_sym_await] = ACTIONS(3207),
    [anon_sym_foreach] = ACTIONS(3207),
    [anon_sym_goto] = ACTIONS(3207),
    [anon_sym_if] = ACTIONS(3207),
    [anon_sym_else] = ACTIONS(3207),
    [anon_sym_DOT_DOT] = ACTIONS(3209),
    [anon_sym_from] = ACTIONS(3207),
    [anon_sym_into] = ACTIONS(3207),
    [anon_sym_join] = ACTIONS(3207),
    [anon_sym_on] = ACTIONS(3207),
    [anon_sym_equals] = ACTIONS(3207),
    [anon_sym_let] = ACTIONS(3207),
    [anon_sym_orderby] = ACTIONS(3207),
    [anon_sym_ascending] = ACTIONS(3207),
    [anon_sym_descending] = ACTIONS(3207),
    [anon_sym_group] = ACTIONS(3207),
    [anon_sym_by] = ACTIONS(3207),
    [anon_sym_select] = ACTIONS(3207),
    [anon_sym_DQUOTE] = ACTIONS(3207),
    [anon_sym_stackalloc] = ACTIONS(3207),
    [anon_sym_sizeof] = ACTIONS(3207),
    [anon_sym_typeof] = ACTIONS(3207),
    [anon_sym___makeref] = ACTIONS(3207),
    [anon_sym___reftype] = ACTIONS(3207),
    [anon_sym___refvalue] = ACTIONS(3207),
    [sym_null_literal] = ACTIONS(3207),
    [anon_sym_SQUOTE] = ACTIONS(3209),
    [sym_integer_literal] = ACTIONS(3207),
    [sym_real_literal] = ACTIONS(3209),
    [sym_verbatim_string_literal] = ACTIONS(3209),
    [sym_raw_string_literal] = ACTIONS(3209),
    [aux_sym_preproc_if_token1] = ACTIONS(3209),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3209),
    [sym_interpolation_verbatim_start] = ACTIONS(3209),
    [sym_interpolation_raw_start] = ACTIONS(3209),
  },
  [2435] = {
    [sym_preproc_region] = STATE(2435),
    [sym_preproc_endregion] = STATE(2435),
    [sym_preproc_line] = STATE(2435),
    [sym_preproc_pragma] = STATE(2435),
    [sym_preproc_nullable] = STATE(2435),
    [sym_preproc_error] = STATE(2435),
    [sym_preproc_define] = STATE(2435),
    [sym_preproc_undef] = STATE(2435),
    [ts_builtin_sym_end] = ACTIONS(3349),
    [sym__identifier_token] = ACTIONS(3347),
    [anon_sym_extern] = ACTIONS(3347),
    [anon_sym_alias] = ACTIONS(3347),
    [anon_sym_SEMI] = ACTIONS(3349),
    [anon_sym_global] = ACTIONS(3347),
    [anon_sym_using] = ACTIONS(3347),
    [anon_sym_unsafe] = ACTIONS(3347),
    [anon_sym_static] = ACTIONS(3347),
    [anon_sym_LBRACK] = ACTIONS(3349),
    [anon_sym_LPAREN] = ACTIONS(3349),
    [anon_sym_return] = ACTIONS(3347),
    [anon_sym_namespace] = ACTIONS(3347),
    [anon_sym_class] = ACTIONS(3347),
    [anon_sym_ref] = ACTIONS(3347),
    [anon_sym_struct] = ACTIONS(3347),
    [anon_sym_enum] = ACTIONS(3347),
    [anon_sym_LBRACE] = ACTIONS(3349),
    [anon_sym_interface] = ACTIONS(3347),
    [anon_sym_delegate] = ACTIONS(3347),
    [anon_sym_record] = ACTIONS(3347),
    [anon_sym_abstract] = ACTIONS(3347),
    [anon_sym_async] = ACTIONS(3347),
    [anon_sym_const] = ACTIONS(3347),
    [anon_sym_file] = ACTIONS(3347),
    [anon_sym_fixed] = ACTIONS(3347),
    [anon_sym_internal] = ACTIONS(3347),
    [anon_sym_new] = ACTIONS(3347),
    [anon_sym_override] = ACTIONS(3347),
    [anon_sym_partial] = ACTIONS(3347),
    [anon_sym_private] = ACTIONS(3347),
    [anon_sym_protected] = ACTIONS(3347),
    [anon_sym_public] = ACTIONS(3347),
    [anon_sym_readonly] = ACTIONS(3347),
    [anon_sym_required] = ACTIONS(3347),
    [anon_sym_sealed] = ACTIONS(3347),
    [anon_sym_virtual] = ACTIONS(3347),
    [anon_sym_volatile] = ACTIONS(3347),
    [anon_sym_where] = ACTIONS(3347),
    [anon_sym_notnull] = ACTIONS(3347),
    [anon_sym_unmanaged] = ACTIONS(3347),
    [anon_sym_checked] = ACTIONS(3347),
    [anon_sym_BANG] = ACTIONS(3349),
    [anon_sym_TILDE] = ACTIONS(3349),
    [anon_sym_PLUS_PLUS] = ACTIONS(3349),
    [anon_sym_DASH_DASH] = ACTIONS(3349),
    [anon_sym_true] = ACTIONS(3347),
    [anon_sym_false] = ACTIONS(3347),
    [anon_sym_PLUS] = ACTIONS(3347),
    [anon_sym_DASH] = ACTIONS(3347),
    [anon_sym_STAR] = ACTIONS(3349),
    [anon_sym_CARET] = ACTIONS(3349),
    [anon_sym_AMP] = ACTIONS(3349),
    [anon_sym_this] = ACTIONS(3347),
    [anon_sym_scoped] = ACTIONS(3347),
    [anon_sym_var] = ACTIONS(3347),
    [sym_predefined_type] = ACTIONS(3347),
    [anon_sym_break] = ACTIONS(3347),
    [anon_sym_unchecked] = ACTIONS(3347),
    [anon_sym_continue] = ACTIONS(3347),
    [anon_sym_do] = ACTIONS(3347),
    [anon_sym_while] = ACTIONS(3347),
    [anon_sym_for] = ACTIONS(3347),
    [anon_sym_lock] = ACTIONS(3347),
    [anon_sym_yield] = ACTIONS(3347),
    [anon_sym_switch] = ACTIONS(3347),
    [anon_sym_default] = ACTIONS(3347),
    [anon_sym_throw] = ACTIONS(3347),
    [anon_sym_try] = ACTIONS(3347),
    [anon_sym_when] = ACTIONS(3347),
    [anon_sym_await] = ACTIONS(3347),
    [anon_sym_foreach] = ACTIONS(3347),
    [anon_sym_goto] = ACTIONS(3347),
    [anon_sym_if] = ACTIONS(3347),
    [anon_sym_else] = ACTIONS(3347),
    [anon_sym_DOT_DOT] = ACTIONS(3349),
    [anon_sym_from] = ACTIONS(3347),
    [anon_sym_into] = ACTIONS(3347),
    [anon_sym_join] = ACTIONS(3347),
    [anon_sym_on] = ACTIONS(3347),
    [anon_sym_equals] = ACTIONS(3347),
    [anon_sym_let] = ACTIONS(3347),
    [anon_sym_orderby] = ACTIONS(3347),
    [anon_sym_ascending] = ACTIONS(3347),
    [anon_sym_descending] = ACTIONS(3347),
    [anon_sym_group] = ACTIONS(3347),
    [anon_sym_by] = ACTIONS(3347),
    [anon_sym_select] = ACTIONS(3347),
    [anon_sym_DQUOTE] = ACTIONS(3347),
    [anon_sym_stackalloc] = ACTIONS(3347),
    [anon_sym_sizeof] = ACTIONS(3347),
    [anon_sym_typeof] = ACTIONS(3347),
    [anon_sym___makeref] = ACTIONS(3347),
    [anon_sym___reftype] = ACTIONS(3347),
    [anon_sym___refvalue] = ACTIONS(3347),
    [sym_null_literal] = ACTIONS(3347),
    [anon_sym_SQUOTE] = ACTIONS(3349),
    [sym_integer_literal] = ACTIONS(3347),
    [sym_real_literal] = ACTIONS(3349),
    [sym_verbatim_string_literal] = ACTIONS(3349),
    [sym_raw_string_literal] = ACTIONS(3349),
    [aux_sym_preproc_if_token1] = ACTIONS(3349),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3349),
    [sym_interpolation_verbatim_start] = ACTIONS(3349),
    [sym_interpolation_raw_start] = ACTIONS(3349),
  },
  [2436] = {
    [sym_preproc_region] = STATE(2436),
    [sym_preproc_endregion] = STATE(2436),
    [sym_preproc_line] = STATE(2436),
    [sym_preproc_pragma] = STATE(2436),
    [sym_preproc_nullable] = STATE(2436),
    [sym_preproc_error] = STATE(2436),
    [sym_preproc_define] = STATE(2436),
    [sym_preproc_undef] = STATE(2436),
    [ts_builtin_sym_end] = ACTIONS(3305),
    [sym__identifier_token] = ACTIONS(3303),
    [anon_sym_extern] = ACTIONS(3303),
    [anon_sym_alias] = ACTIONS(3303),
    [anon_sym_SEMI] = ACTIONS(3305),
    [anon_sym_global] = ACTIONS(3303),
    [anon_sym_using] = ACTIONS(3303),
    [anon_sym_unsafe] = ACTIONS(3303),
    [anon_sym_static] = ACTIONS(3303),
    [anon_sym_LBRACK] = ACTIONS(3305),
    [anon_sym_LPAREN] = ACTIONS(3305),
    [anon_sym_return] = ACTIONS(3303),
    [anon_sym_namespace] = ACTIONS(3303),
    [anon_sym_class] = ACTIONS(3303),
    [anon_sym_ref] = ACTIONS(3303),
    [anon_sym_struct] = ACTIONS(3303),
    [anon_sym_enum] = ACTIONS(3303),
    [anon_sym_LBRACE] = ACTIONS(3305),
    [anon_sym_interface] = ACTIONS(3303),
    [anon_sym_delegate] = ACTIONS(3303),
    [anon_sym_record] = ACTIONS(3303),
    [anon_sym_abstract] = ACTIONS(3303),
    [anon_sym_async] = ACTIONS(3303),
    [anon_sym_const] = ACTIONS(3303),
    [anon_sym_file] = ACTIONS(3303),
    [anon_sym_fixed] = ACTIONS(3303),
    [anon_sym_internal] = ACTIONS(3303),
    [anon_sym_new] = ACTIONS(3303),
    [anon_sym_override] = ACTIONS(3303),
    [anon_sym_partial] = ACTIONS(3303),
    [anon_sym_private] = ACTIONS(3303),
    [anon_sym_protected] = ACTIONS(3303),
    [anon_sym_public] = ACTIONS(3303),
    [anon_sym_readonly] = ACTIONS(3303),
    [anon_sym_required] = ACTIONS(3303),
    [anon_sym_sealed] = ACTIONS(3303),
    [anon_sym_virtual] = ACTIONS(3303),
    [anon_sym_volatile] = ACTIONS(3303),
    [anon_sym_where] = ACTIONS(3303),
    [anon_sym_notnull] = ACTIONS(3303),
    [anon_sym_unmanaged] = ACTIONS(3303),
    [anon_sym_checked] = ACTIONS(3303),
    [anon_sym_BANG] = ACTIONS(3305),
    [anon_sym_TILDE] = ACTIONS(3305),
    [anon_sym_PLUS_PLUS] = ACTIONS(3305),
    [anon_sym_DASH_DASH] = ACTIONS(3305),
    [anon_sym_true] = ACTIONS(3303),
    [anon_sym_false] = ACTIONS(3303),
    [anon_sym_PLUS] = ACTIONS(3303),
    [anon_sym_DASH] = ACTIONS(3303),
    [anon_sym_STAR] = ACTIONS(3305),
    [anon_sym_CARET] = ACTIONS(3305),
    [anon_sym_AMP] = ACTIONS(3305),
    [anon_sym_this] = ACTIONS(3303),
    [anon_sym_scoped] = ACTIONS(3303),
    [anon_sym_var] = ACTIONS(3303),
    [sym_predefined_type] = ACTIONS(3303),
    [anon_sym_break] = ACTIONS(3303),
    [anon_sym_unchecked] = ACTIONS(3303),
    [anon_sym_continue] = ACTIONS(3303),
    [anon_sym_do] = ACTIONS(3303),
    [anon_sym_while] = ACTIONS(3303),
    [anon_sym_for] = ACTIONS(3303),
    [anon_sym_lock] = ACTIONS(3303),
    [anon_sym_yield] = ACTIONS(3303),
    [anon_sym_switch] = ACTIONS(3303),
    [anon_sym_default] = ACTIONS(3303),
    [anon_sym_throw] = ACTIONS(3303),
    [anon_sym_try] = ACTIONS(3303),
    [anon_sym_when] = ACTIONS(3303),
    [anon_sym_await] = ACTIONS(3303),
    [anon_sym_foreach] = ACTIONS(3303),
    [anon_sym_goto] = ACTIONS(3303),
    [anon_sym_if] = ACTIONS(3303),
    [anon_sym_else] = ACTIONS(3303),
    [anon_sym_DOT_DOT] = ACTIONS(3305),
    [anon_sym_from] = ACTIONS(3303),
    [anon_sym_into] = ACTIONS(3303),
    [anon_sym_join] = ACTIONS(3303),
    [anon_sym_on] = ACTIONS(3303),
    [anon_sym_equals] = ACTIONS(3303),
    [anon_sym_let] = ACTIONS(3303),
    [anon_sym_orderby] = ACTIONS(3303),
    [anon_sym_ascending] = ACTIONS(3303),
    [anon_sym_descending] = ACTIONS(3303),
    [anon_sym_group] = ACTIONS(3303),
    [anon_sym_by] = ACTIONS(3303),
    [anon_sym_select] = ACTIONS(3303),
    [anon_sym_DQUOTE] = ACTIONS(3303),
    [anon_sym_stackalloc] = ACTIONS(3303),
    [anon_sym_sizeof] = ACTIONS(3303),
    [anon_sym_typeof] = ACTIONS(3303),
    [anon_sym___makeref] = ACTIONS(3303),
    [anon_sym___reftype] = ACTIONS(3303),
    [anon_sym___refvalue] = ACTIONS(3303),
    [sym_null_literal] = ACTIONS(3303),
    [anon_sym_SQUOTE] = ACTIONS(3305),
    [sym_integer_literal] = ACTIONS(3303),
    [sym_real_literal] = ACTIONS(3305),
    [sym_verbatim_string_literal] = ACTIONS(3305),
    [sym_raw_string_literal] = ACTIONS(3305),
    [aux_sym_preproc_if_token1] = ACTIONS(3305),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3305),
    [sym_interpolation_verbatim_start] = ACTIONS(3305),
    [sym_interpolation_raw_start] = ACTIONS(3305),
  },
  [2437] = {
    [sym_preproc_region] = STATE(2437),
    [sym_preproc_endregion] = STATE(2437),
    [sym_preproc_line] = STATE(2437),
    [sym_preproc_pragma] = STATE(2437),
    [sym_preproc_nullable] = STATE(2437),
    [sym_preproc_error] = STATE(2437),
    [sym_preproc_define] = STATE(2437),
    [sym_preproc_undef] = STATE(2437),
    [ts_builtin_sym_end] = ACTIONS(3309),
    [sym__identifier_token] = ACTIONS(3307),
    [anon_sym_extern] = ACTIONS(3307),
    [anon_sym_alias] = ACTIONS(3307),
    [anon_sym_SEMI] = ACTIONS(3309),
    [anon_sym_global] = ACTIONS(3307),
    [anon_sym_using] = ACTIONS(3307),
    [anon_sym_unsafe] = ACTIONS(3307),
    [anon_sym_static] = ACTIONS(3307),
    [anon_sym_LBRACK] = ACTIONS(3309),
    [anon_sym_LPAREN] = ACTIONS(3309),
    [anon_sym_return] = ACTIONS(3307),
    [anon_sym_namespace] = ACTIONS(3307),
    [anon_sym_class] = ACTIONS(3307),
    [anon_sym_ref] = ACTIONS(3307),
    [anon_sym_struct] = ACTIONS(3307),
    [anon_sym_enum] = ACTIONS(3307),
    [anon_sym_LBRACE] = ACTIONS(3309),
    [anon_sym_interface] = ACTIONS(3307),
    [anon_sym_delegate] = ACTIONS(3307),
    [anon_sym_record] = ACTIONS(3307),
    [anon_sym_abstract] = ACTIONS(3307),
    [anon_sym_async] = ACTIONS(3307),
    [anon_sym_const] = ACTIONS(3307),
    [anon_sym_file] = ACTIONS(3307),
    [anon_sym_fixed] = ACTIONS(3307),
    [anon_sym_internal] = ACTIONS(3307),
    [anon_sym_new] = ACTIONS(3307),
    [anon_sym_override] = ACTIONS(3307),
    [anon_sym_partial] = ACTIONS(3307),
    [anon_sym_private] = ACTIONS(3307),
    [anon_sym_protected] = ACTIONS(3307),
    [anon_sym_public] = ACTIONS(3307),
    [anon_sym_readonly] = ACTIONS(3307),
    [anon_sym_required] = ACTIONS(3307),
    [anon_sym_sealed] = ACTIONS(3307),
    [anon_sym_virtual] = ACTIONS(3307),
    [anon_sym_volatile] = ACTIONS(3307),
    [anon_sym_where] = ACTIONS(3307),
    [anon_sym_notnull] = ACTIONS(3307),
    [anon_sym_unmanaged] = ACTIONS(3307),
    [anon_sym_checked] = ACTIONS(3307),
    [anon_sym_BANG] = ACTIONS(3309),
    [anon_sym_TILDE] = ACTIONS(3309),
    [anon_sym_PLUS_PLUS] = ACTIONS(3309),
    [anon_sym_DASH_DASH] = ACTIONS(3309),
    [anon_sym_true] = ACTIONS(3307),
    [anon_sym_false] = ACTIONS(3307),
    [anon_sym_PLUS] = ACTIONS(3307),
    [anon_sym_DASH] = ACTIONS(3307),
    [anon_sym_STAR] = ACTIONS(3309),
    [anon_sym_CARET] = ACTIONS(3309),
    [anon_sym_AMP] = ACTIONS(3309),
    [anon_sym_this] = ACTIONS(3307),
    [anon_sym_scoped] = ACTIONS(3307),
    [anon_sym_var] = ACTIONS(3307),
    [sym_predefined_type] = ACTIONS(3307),
    [anon_sym_break] = ACTIONS(3307),
    [anon_sym_unchecked] = ACTIONS(3307),
    [anon_sym_continue] = ACTIONS(3307),
    [anon_sym_do] = ACTIONS(3307),
    [anon_sym_while] = ACTIONS(3307),
    [anon_sym_for] = ACTIONS(3307),
    [anon_sym_lock] = ACTIONS(3307),
    [anon_sym_yield] = ACTIONS(3307),
    [anon_sym_switch] = ACTIONS(3307),
    [anon_sym_default] = ACTIONS(3307),
    [anon_sym_throw] = ACTIONS(3307),
    [anon_sym_try] = ACTIONS(3307),
    [anon_sym_when] = ACTIONS(3307),
    [anon_sym_await] = ACTIONS(3307),
    [anon_sym_foreach] = ACTIONS(3307),
    [anon_sym_goto] = ACTIONS(3307),
    [anon_sym_if] = ACTIONS(3307),
    [anon_sym_else] = ACTIONS(3307),
    [anon_sym_DOT_DOT] = ACTIONS(3309),
    [anon_sym_from] = ACTIONS(3307),
    [anon_sym_into] = ACTIONS(3307),
    [anon_sym_join] = ACTIONS(3307),
    [anon_sym_on] = ACTIONS(3307),
    [anon_sym_equals] = ACTIONS(3307),
    [anon_sym_let] = ACTIONS(3307),
    [anon_sym_orderby] = ACTIONS(3307),
    [anon_sym_ascending] = ACTIONS(3307),
    [anon_sym_descending] = ACTIONS(3307),
    [anon_sym_group] = ACTIONS(3307),
    [anon_sym_by] = ACTIONS(3307),
    [anon_sym_select] = ACTIONS(3307),
    [anon_sym_DQUOTE] = ACTIONS(3307),
    [anon_sym_stackalloc] = ACTIONS(3307),
    [anon_sym_sizeof] = ACTIONS(3307),
    [anon_sym_typeof] = ACTIONS(3307),
    [anon_sym___makeref] = ACTIONS(3307),
    [anon_sym___reftype] = ACTIONS(3307),
    [anon_sym___refvalue] = ACTIONS(3307),
    [sym_null_literal] = ACTIONS(3307),
    [anon_sym_SQUOTE] = ACTIONS(3309),
    [sym_integer_literal] = ACTIONS(3307),
    [sym_real_literal] = ACTIONS(3309),
    [sym_verbatim_string_literal] = ACTIONS(3309),
    [sym_raw_string_literal] = ACTIONS(3309),
    [aux_sym_preproc_if_token1] = ACTIONS(3309),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3309),
    [sym_interpolation_verbatim_start] = ACTIONS(3309),
    [sym_interpolation_raw_start] = ACTIONS(3309),
  },
  [2438] = {
    [sym_preproc_region] = STATE(2438),
    [sym_preproc_endregion] = STATE(2438),
    [sym_preproc_line] = STATE(2438),
    [sym_preproc_pragma] = STATE(2438),
    [sym_preproc_nullable] = STATE(2438),
    [sym_preproc_error] = STATE(2438),
    [sym_preproc_define] = STATE(2438),
    [sym_preproc_undef] = STATE(2438),
    [ts_builtin_sym_end] = ACTIONS(3301),
    [sym__identifier_token] = ACTIONS(3299),
    [anon_sym_extern] = ACTIONS(3299),
    [anon_sym_alias] = ACTIONS(3299),
    [anon_sym_SEMI] = ACTIONS(3301),
    [anon_sym_global] = ACTIONS(3299),
    [anon_sym_using] = ACTIONS(3299),
    [anon_sym_unsafe] = ACTIONS(3299),
    [anon_sym_static] = ACTIONS(3299),
    [anon_sym_LBRACK] = ACTIONS(3301),
    [anon_sym_LPAREN] = ACTIONS(3301),
    [anon_sym_return] = ACTIONS(3299),
    [anon_sym_namespace] = ACTIONS(3299),
    [anon_sym_class] = ACTIONS(3299),
    [anon_sym_ref] = ACTIONS(3299),
    [anon_sym_struct] = ACTIONS(3299),
    [anon_sym_enum] = ACTIONS(3299),
    [anon_sym_LBRACE] = ACTIONS(3301),
    [anon_sym_interface] = ACTIONS(3299),
    [anon_sym_delegate] = ACTIONS(3299),
    [anon_sym_record] = ACTIONS(3299),
    [anon_sym_abstract] = ACTIONS(3299),
    [anon_sym_async] = ACTIONS(3299),
    [anon_sym_const] = ACTIONS(3299),
    [anon_sym_file] = ACTIONS(3299),
    [anon_sym_fixed] = ACTIONS(3299),
    [anon_sym_internal] = ACTIONS(3299),
    [anon_sym_new] = ACTIONS(3299),
    [anon_sym_override] = ACTIONS(3299),
    [anon_sym_partial] = ACTIONS(3299),
    [anon_sym_private] = ACTIONS(3299),
    [anon_sym_protected] = ACTIONS(3299),
    [anon_sym_public] = ACTIONS(3299),
    [anon_sym_readonly] = ACTIONS(3299),
    [anon_sym_required] = ACTIONS(3299),
    [anon_sym_sealed] = ACTIONS(3299),
    [anon_sym_virtual] = ACTIONS(3299),
    [anon_sym_volatile] = ACTIONS(3299),
    [anon_sym_where] = ACTIONS(3299),
    [anon_sym_notnull] = ACTIONS(3299),
    [anon_sym_unmanaged] = ACTIONS(3299),
    [anon_sym_checked] = ACTIONS(3299),
    [anon_sym_BANG] = ACTIONS(3301),
    [anon_sym_TILDE] = ACTIONS(3301),
    [anon_sym_PLUS_PLUS] = ACTIONS(3301),
    [anon_sym_DASH_DASH] = ACTIONS(3301),
    [anon_sym_true] = ACTIONS(3299),
    [anon_sym_false] = ACTIONS(3299),
    [anon_sym_PLUS] = ACTIONS(3299),
    [anon_sym_DASH] = ACTIONS(3299),
    [anon_sym_STAR] = ACTIONS(3301),
    [anon_sym_CARET] = ACTIONS(3301),
    [anon_sym_AMP] = ACTIONS(3301),
    [anon_sym_this] = ACTIONS(3299),
    [anon_sym_scoped] = ACTIONS(3299),
    [anon_sym_var] = ACTIONS(3299),
    [sym_predefined_type] = ACTIONS(3299),
    [anon_sym_break] = ACTIONS(3299),
    [anon_sym_unchecked] = ACTIONS(3299),
    [anon_sym_continue] = ACTIONS(3299),
    [anon_sym_do] = ACTIONS(3299),
    [anon_sym_while] = ACTIONS(3299),
    [anon_sym_for] = ACTIONS(3299),
    [anon_sym_lock] = ACTIONS(3299),
    [anon_sym_yield] = ACTIONS(3299),
    [anon_sym_switch] = ACTIONS(3299),
    [anon_sym_default] = ACTIONS(3299),
    [anon_sym_throw] = ACTIONS(3299),
    [anon_sym_try] = ACTIONS(3299),
    [anon_sym_when] = ACTIONS(3299),
    [anon_sym_await] = ACTIONS(3299),
    [anon_sym_foreach] = ACTIONS(3299),
    [anon_sym_goto] = ACTIONS(3299),
    [anon_sym_if] = ACTIONS(3299),
    [anon_sym_else] = ACTIONS(3299),
    [anon_sym_DOT_DOT] = ACTIONS(3301),
    [anon_sym_from] = ACTIONS(3299),
    [anon_sym_into] = ACTIONS(3299),
    [anon_sym_join] = ACTIONS(3299),
    [anon_sym_on] = ACTIONS(3299),
    [anon_sym_equals] = ACTIONS(3299),
    [anon_sym_let] = ACTIONS(3299),
    [anon_sym_orderby] = ACTIONS(3299),
    [anon_sym_ascending] = ACTIONS(3299),
    [anon_sym_descending] = ACTIONS(3299),
    [anon_sym_group] = ACTIONS(3299),
    [anon_sym_by] = ACTIONS(3299),
    [anon_sym_select] = ACTIONS(3299),
    [anon_sym_DQUOTE] = ACTIONS(3299),
    [anon_sym_stackalloc] = ACTIONS(3299),
    [anon_sym_sizeof] = ACTIONS(3299),
    [anon_sym_typeof] = ACTIONS(3299),
    [anon_sym___makeref] = ACTIONS(3299),
    [anon_sym___reftype] = ACTIONS(3299),
    [anon_sym___refvalue] = ACTIONS(3299),
    [sym_null_literal] = ACTIONS(3299),
    [anon_sym_SQUOTE] = ACTIONS(3301),
    [sym_integer_literal] = ACTIONS(3299),
    [sym_real_literal] = ACTIONS(3301),
    [sym_verbatim_string_literal] = ACTIONS(3301),
    [sym_raw_string_literal] = ACTIONS(3301),
    [aux_sym_preproc_if_token1] = ACTIONS(3301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3301),
    [sym_interpolation_verbatim_start] = ACTIONS(3301),
    [sym_interpolation_raw_start] = ACTIONS(3301),
  },
  [2439] = {
    [sym_preproc_region] = STATE(2439),
    [sym_preproc_endregion] = STATE(2439),
    [sym_preproc_line] = STATE(2439),
    [sym_preproc_pragma] = STATE(2439),
    [sym_preproc_nullable] = STATE(2439),
    [sym_preproc_error] = STATE(2439),
    [sym_preproc_define] = STATE(2439),
    [sym_preproc_undef] = STATE(2439),
    [ts_builtin_sym_end] = ACTIONS(3107),
    [sym__identifier_token] = ACTIONS(3105),
    [anon_sym_extern] = ACTIONS(3105),
    [anon_sym_alias] = ACTIONS(3105),
    [anon_sym_SEMI] = ACTIONS(3107),
    [anon_sym_global] = ACTIONS(3105),
    [anon_sym_using] = ACTIONS(3105),
    [anon_sym_unsafe] = ACTIONS(3105),
    [anon_sym_static] = ACTIONS(3105),
    [anon_sym_LBRACK] = ACTIONS(3107),
    [anon_sym_LPAREN] = ACTIONS(3107),
    [anon_sym_return] = ACTIONS(3105),
    [anon_sym_namespace] = ACTIONS(3105),
    [anon_sym_class] = ACTIONS(3105),
    [anon_sym_ref] = ACTIONS(3105),
    [anon_sym_struct] = ACTIONS(3105),
    [anon_sym_enum] = ACTIONS(3105),
    [anon_sym_LBRACE] = ACTIONS(3107),
    [anon_sym_interface] = ACTIONS(3105),
    [anon_sym_delegate] = ACTIONS(3105),
    [anon_sym_record] = ACTIONS(3105),
    [anon_sym_abstract] = ACTIONS(3105),
    [anon_sym_async] = ACTIONS(3105),
    [anon_sym_const] = ACTIONS(3105),
    [anon_sym_file] = ACTIONS(3105),
    [anon_sym_fixed] = ACTIONS(3105),
    [anon_sym_internal] = ACTIONS(3105),
    [anon_sym_new] = ACTIONS(3105),
    [anon_sym_override] = ACTIONS(3105),
    [anon_sym_partial] = ACTIONS(3105),
    [anon_sym_private] = ACTIONS(3105),
    [anon_sym_protected] = ACTIONS(3105),
    [anon_sym_public] = ACTIONS(3105),
    [anon_sym_readonly] = ACTIONS(3105),
    [anon_sym_required] = ACTIONS(3105),
    [anon_sym_sealed] = ACTIONS(3105),
    [anon_sym_virtual] = ACTIONS(3105),
    [anon_sym_volatile] = ACTIONS(3105),
    [anon_sym_where] = ACTIONS(3105),
    [anon_sym_notnull] = ACTIONS(3105),
    [anon_sym_unmanaged] = ACTIONS(3105),
    [anon_sym_checked] = ACTIONS(3105),
    [anon_sym_BANG] = ACTIONS(3107),
    [anon_sym_TILDE] = ACTIONS(3107),
    [anon_sym_PLUS_PLUS] = ACTIONS(3107),
    [anon_sym_DASH_DASH] = ACTIONS(3107),
    [anon_sym_true] = ACTIONS(3105),
    [anon_sym_false] = ACTIONS(3105),
    [anon_sym_PLUS] = ACTIONS(3105),
    [anon_sym_DASH] = ACTIONS(3105),
    [anon_sym_STAR] = ACTIONS(3107),
    [anon_sym_CARET] = ACTIONS(3107),
    [anon_sym_AMP] = ACTIONS(3107),
    [anon_sym_this] = ACTIONS(3105),
    [anon_sym_scoped] = ACTIONS(3105),
    [anon_sym_var] = ACTIONS(3105),
    [sym_predefined_type] = ACTIONS(3105),
    [anon_sym_break] = ACTIONS(3105),
    [anon_sym_unchecked] = ACTIONS(3105),
    [anon_sym_continue] = ACTIONS(3105),
    [anon_sym_do] = ACTIONS(3105),
    [anon_sym_while] = ACTIONS(3105),
    [anon_sym_for] = ACTIONS(3105),
    [anon_sym_lock] = ACTIONS(3105),
    [anon_sym_yield] = ACTIONS(3105),
    [anon_sym_switch] = ACTIONS(3105),
    [anon_sym_default] = ACTIONS(3105),
    [anon_sym_throw] = ACTIONS(3105),
    [anon_sym_try] = ACTIONS(3105),
    [anon_sym_when] = ACTIONS(3105),
    [anon_sym_await] = ACTIONS(3105),
    [anon_sym_foreach] = ACTIONS(3105),
    [anon_sym_goto] = ACTIONS(3105),
    [anon_sym_if] = ACTIONS(3105),
    [anon_sym_else] = ACTIONS(3105),
    [anon_sym_DOT_DOT] = ACTIONS(3107),
    [anon_sym_from] = ACTIONS(3105),
    [anon_sym_into] = ACTIONS(3105),
    [anon_sym_join] = ACTIONS(3105),
    [anon_sym_on] = ACTIONS(3105),
    [anon_sym_equals] = ACTIONS(3105),
    [anon_sym_let] = ACTIONS(3105),
    [anon_sym_orderby] = ACTIONS(3105),
    [anon_sym_ascending] = ACTIONS(3105),
    [anon_sym_descending] = ACTIONS(3105),
    [anon_sym_group] = ACTIONS(3105),
    [anon_sym_by] = ACTIONS(3105),
    [anon_sym_select] = ACTIONS(3105),
    [anon_sym_DQUOTE] = ACTIONS(3105),
    [anon_sym_stackalloc] = ACTIONS(3105),
    [anon_sym_sizeof] = ACTIONS(3105),
    [anon_sym_typeof] = ACTIONS(3105),
    [anon_sym___makeref] = ACTIONS(3105),
    [anon_sym___reftype] = ACTIONS(3105),
    [anon_sym___refvalue] = ACTIONS(3105),
    [sym_null_literal] = ACTIONS(3105),
    [anon_sym_SQUOTE] = ACTIONS(3107),
    [sym_integer_literal] = ACTIONS(3105),
    [sym_real_literal] = ACTIONS(3107),
    [sym_verbatim_string_literal] = ACTIONS(3107),
    [sym_raw_string_literal] = ACTIONS(3107),
    [aux_sym_preproc_if_token1] = ACTIONS(3107),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3107),
    [sym_interpolation_verbatim_start] = ACTIONS(3107),
    [sym_interpolation_raw_start] = ACTIONS(3107),
  },
  [2440] = {
    [sym_preproc_region] = STATE(2440),
    [sym_preproc_endregion] = STATE(2440),
    [sym_preproc_line] = STATE(2440),
    [sym_preproc_pragma] = STATE(2440),
    [sym_preproc_nullable] = STATE(2440),
    [sym_preproc_error] = STATE(2440),
    [sym_preproc_define] = STATE(2440),
    [sym_preproc_undef] = STATE(2440),
    [ts_builtin_sym_end] = ACTIONS(3411),
    [sym__identifier_token] = ACTIONS(3409),
    [anon_sym_extern] = ACTIONS(3409),
    [anon_sym_alias] = ACTIONS(3409),
    [anon_sym_SEMI] = ACTIONS(3411),
    [anon_sym_global] = ACTIONS(3409),
    [anon_sym_using] = ACTIONS(3409),
    [anon_sym_unsafe] = ACTIONS(3409),
    [anon_sym_static] = ACTIONS(3409),
    [anon_sym_LBRACK] = ACTIONS(3411),
    [anon_sym_LPAREN] = ACTIONS(3411),
    [anon_sym_return] = ACTIONS(3409),
    [anon_sym_namespace] = ACTIONS(3409),
    [anon_sym_class] = ACTIONS(3409),
    [anon_sym_ref] = ACTIONS(3409),
    [anon_sym_struct] = ACTIONS(3409),
    [anon_sym_enum] = ACTIONS(3409),
    [anon_sym_LBRACE] = ACTIONS(3411),
    [anon_sym_interface] = ACTIONS(3409),
    [anon_sym_delegate] = ACTIONS(3409),
    [anon_sym_record] = ACTIONS(3409),
    [anon_sym_abstract] = ACTIONS(3409),
    [anon_sym_async] = ACTIONS(3409),
    [anon_sym_const] = ACTIONS(3409),
    [anon_sym_file] = ACTIONS(3409),
    [anon_sym_fixed] = ACTIONS(3409),
    [anon_sym_internal] = ACTIONS(3409),
    [anon_sym_new] = ACTIONS(3409),
    [anon_sym_override] = ACTIONS(3409),
    [anon_sym_partial] = ACTIONS(3409),
    [anon_sym_private] = ACTIONS(3409),
    [anon_sym_protected] = ACTIONS(3409),
    [anon_sym_public] = ACTIONS(3409),
    [anon_sym_readonly] = ACTIONS(3409),
    [anon_sym_required] = ACTIONS(3409),
    [anon_sym_sealed] = ACTIONS(3409),
    [anon_sym_virtual] = ACTIONS(3409),
    [anon_sym_volatile] = ACTIONS(3409),
    [anon_sym_where] = ACTIONS(3409),
    [anon_sym_notnull] = ACTIONS(3409),
    [anon_sym_unmanaged] = ACTIONS(3409),
    [anon_sym_checked] = ACTIONS(3409),
    [anon_sym_BANG] = ACTIONS(3411),
    [anon_sym_TILDE] = ACTIONS(3411),
    [anon_sym_PLUS_PLUS] = ACTIONS(3411),
    [anon_sym_DASH_DASH] = ACTIONS(3411),
    [anon_sym_true] = ACTIONS(3409),
    [anon_sym_false] = ACTIONS(3409),
    [anon_sym_PLUS] = ACTIONS(3409),
    [anon_sym_DASH] = ACTIONS(3409),
    [anon_sym_STAR] = ACTIONS(3411),
    [anon_sym_CARET] = ACTIONS(3411),
    [anon_sym_AMP] = ACTIONS(3411),
    [anon_sym_this] = ACTIONS(3409),
    [anon_sym_scoped] = ACTIONS(3409),
    [anon_sym_var] = ACTIONS(3409),
    [sym_predefined_type] = ACTIONS(3409),
    [anon_sym_break] = ACTIONS(3409),
    [anon_sym_unchecked] = ACTIONS(3409),
    [anon_sym_continue] = ACTIONS(3409),
    [anon_sym_do] = ACTIONS(3409),
    [anon_sym_while] = ACTIONS(3409),
    [anon_sym_for] = ACTIONS(3409),
    [anon_sym_lock] = ACTIONS(3409),
    [anon_sym_yield] = ACTIONS(3409),
    [anon_sym_switch] = ACTIONS(3409),
    [anon_sym_default] = ACTIONS(3409),
    [anon_sym_throw] = ACTIONS(3409),
    [anon_sym_try] = ACTIONS(3409),
    [anon_sym_when] = ACTIONS(3409),
    [anon_sym_await] = ACTIONS(3409),
    [anon_sym_foreach] = ACTIONS(3409),
    [anon_sym_goto] = ACTIONS(3409),
    [anon_sym_if] = ACTIONS(3409),
    [anon_sym_else] = ACTIONS(3409),
    [anon_sym_DOT_DOT] = ACTIONS(3411),
    [anon_sym_from] = ACTIONS(3409),
    [anon_sym_into] = ACTIONS(3409),
    [anon_sym_join] = ACTIONS(3409),
    [anon_sym_on] = ACTIONS(3409),
    [anon_sym_equals] = ACTIONS(3409),
    [anon_sym_let] = ACTIONS(3409),
    [anon_sym_orderby] = ACTIONS(3409),
    [anon_sym_ascending] = ACTIONS(3409),
    [anon_sym_descending] = ACTIONS(3409),
    [anon_sym_group] = ACTIONS(3409),
    [anon_sym_by] = ACTIONS(3409),
    [anon_sym_select] = ACTIONS(3409),
    [anon_sym_DQUOTE] = ACTIONS(3409),
    [anon_sym_stackalloc] = ACTIONS(3409),
    [anon_sym_sizeof] = ACTIONS(3409),
    [anon_sym_typeof] = ACTIONS(3409),
    [anon_sym___makeref] = ACTIONS(3409),
    [anon_sym___reftype] = ACTIONS(3409),
    [anon_sym___refvalue] = ACTIONS(3409),
    [sym_null_literal] = ACTIONS(3409),
    [anon_sym_SQUOTE] = ACTIONS(3411),
    [sym_integer_literal] = ACTIONS(3409),
    [sym_real_literal] = ACTIONS(3411),
    [sym_verbatim_string_literal] = ACTIONS(3411),
    [sym_raw_string_literal] = ACTIONS(3411),
    [aux_sym_preproc_if_token1] = ACTIONS(3411),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3411),
    [sym_interpolation_verbatim_start] = ACTIONS(3411),
    [sym_interpolation_raw_start] = ACTIONS(3411),
  },
  [2441] = {
    [sym_preproc_region] = STATE(2441),
    [sym_preproc_endregion] = STATE(2441),
    [sym_preproc_line] = STATE(2441),
    [sym_preproc_pragma] = STATE(2441),
    [sym_preproc_nullable] = STATE(2441),
    [sym_preproc_error] = STATE(2441),
    [sym_preproc_define] = STATE(2441),
    [sym_preproc_undef] = STATE(2441),
    [ts_builtin_sym_end] = ACTIONS(3289),
    [sym__identifier_token] = ACTIONS(3287),
    [anon_sym_extern] = ACTIONS(3287),
    [anon_sym_alias] = ACTIONS(3287),
    [anon_sym_SEMI] = ACTIONS(3289),
    [anon_sym_global] = ACTIONS(3287),
    [anon_sym_using] = ACTIONS(3287),
    [anon_sym_unsafe] = ACTIONS(3287),
    [anon_sym_static] = ACTIONS(3287),
    [anon_sym_LBRACK] = ACTIONS(3289),
    [anon_sym_LPAREN] = ACTIONS(3289),
    [anon_sym_return] = ACTIONS(3287),
    [anon_sym_namespace] = ACTIONS(3287),
    [anon_sym_class] = ACTIONS(3287),
    [anon_sym_ref] = ACTIONS(3287),
    [anon_sym_struct] = ACTIONS(3287),
    [anon_sym_enum] = ACTIONS(3287),
    [anon_sym_LBRACE] = ACTIONS(3289),
    [anon_sym_interface] = ACTIONS(3287),
    [anon_sym_delegate] = ACTIONS(3287),
    [anon_sym_record] = ACTIONS(3287),
    [anon_sym_abstract] = ACTIONS(3287),
    [anon_sym_async] = ACTIONS(3287),
    [anon_sym_const] = ACTIONS(3287),
    [anon_sym_file] = ACTIONS(3287),
    [anon_sym_fixed] = ACTIONS(3287),
    [anon_sym_internal] = ACTIONS(3287),
    [anon_sym_new] = ACTIONS(3287),
    [anon_sym_override] = ACTIONS(3287),
    [anon_sym_partial] = ACTIONS(3287),
    [anon_sym_private] = ACTIONS(3287),
    [anon_sym_protected] = ACTIONS(3287),
    [anon_sym_public] = ACTIONS(3287),
    [anon_sym_readonly] = ACTIONS(3287),
    [anon_sym_required] = ACTIONS(3287),
    [anon_sym_sealed] = ACTIONS(3287),
    [anon_sym_virtual] = ACTIONS(3287),
    [anon_sym_volatile] = ACTIONS(3287),
    [anon_sym_where] = ACTIONS(3287),
    [anon_sym_notnull] = ACTIONS(3287),
    [anon_sym_unmanaged] = ACTIONS(3287),
    [anon_sym_checked] = ACTIONS(3287),
    [anon_sym_BANG] = ACTIONS(3289),
    [anon_sym_TILDE] = ACTIONS(3289),
    [anon_sym_PLUS_PLUS] = ACTIONS(3289),
    [anon_sym_DASH_DASH] = ACTIONS(3289),
    [anon_sym_true] = ACTIONS(3287),
    [anon_sym_false] = ACTIONS(3287),
    [anon_sym_PLUS] = ACTIONS(3287),
    [anon_sym_DASH] = ACTIONS(3287),
    [anon_sym_STAR] = ACTIONS(3289),
    [anon_sym_CARET] = ACTIONS(3289),
    [anon_sym_AMP] = ACTIONS(3289),
    [anon_sym_this] = ACTIONS(3287),
    [anon_sym_scoped] = ACTIONS(3287),
    [anon_sym_var] = ACTIONS(3287),
    [sym_predefined_type] = ACTIONS(3287),
    [anon_sym_break] = ACTIONS(3287),
    [anon_sym_unchecked] = ACTIONS(3287),
    [anon_sym_continue] = ACTIONS(3287),
    [anon_sym_do] = ACTIONS(3287),
    [anon_sym_while] = ACTIONS(3287),
    [anon_sym_for] = ACTIONS(3287),
    [anon_sym_lock] = ACTIONS(3287),
    [anon_sym_yield] = ACTIONS(3287),
    [anon_sym_switch] = ACTIONS(3287),
    [anon_sym_default] = ACTIONS(3287),
    [anon_sym_throw] = ACTIONS(3287),
    [anon_sym_try] = ACTIONS(3287),
    [anon_sym_when] = ACTIONS(3287),
    [anon_sym_await] = ACTIONS(3287),
    [anon_sym_foreach] = ACTIONS(3287),
    [anon_sym_goto] = ACTIONS(3287),
    [anon_sym_if] = ACTIONS(3287),
    [anon_sym_else] = ACTIONS(3287),
    [anon_sym_DOT_DOT] = ACTIONS(3289),
    [anon_sym_from] = ACTIONS(3287),
    [anon_sym_into] = ACTIONS(3287),
    [anon_sym_join] = ACTIONS(3287),
    [anon_sym_on] = ACTIONS(3287),
    [anon_sym_equals] = ACTIONS(3287),
    [anon_sym_let] = ACTIONS(3287),
    [anon_sym_orderby] = ACTIONS(3287),
    [anon_sym_ascending] = ACTIONS(3287),
    [anon_sym_descending] = ACTIONS(3287),
    [anon_sym_group] = ACTIONS(3287),
    [anon_sym_by] = ACTIONS(3287),
    [anon_sym_select] = ACTIONS(3287),
    [anon_sym_DQUOTE] = ACTIONS(3287),
    [anon_sym_stackalloc] = ACTIONS(3287),
    [anon_sym_sizeof] = ACTIONS(3287),
    [anon_sym_typeof] = ACTIONS(3287),
    [anon_sym___makeref] = ACTIONS(3287),
    [anon_sym___reftype] = ACTIONS(3287),
    [anon_sym___refvalue] = ACTIONS(3287),
    [sym_null_literal] = ACTIONS(3287),
    [anon_sym_SQUOTE] = ACTIONS(3289),
    [sym_integer_literal] = ACTIONS(3287),
    [sym_real_literal] = ACTIONS(3289),
    [sym_verbatim_string_literal] = ACTIONS(3289),
    [sym_raw_string_literal] = ACTIONS(3289),
    [aux_sym_preproc_if_token1] = ACTIONS(3289),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3289),
    [sym_interpolation_verbatim_start] = ACTIONS(3289),
    [sym_interpolation_raw_start] = ACTIONS(3289),
  },
  [2442] = {
    [sym_preproc_region] = STATE(2442),
    [sym_preproc_endregion] = STATE(2442),
    [sym_preproc_line] = STATE(2442),
    [sym_preproc_pragma] = STATE(2442),
    [sym_preproc_nullable] = STATE(2442),
    [sym_preproc_error] = STATE(2442),
    [sym_preproc_define] = STATE(2442),
    [sym_preproc_undef] = STATE(2442),
    [ts_builtin_sym_end] = ACTIONS(3245),
    [sym__identifier_token] = ACTIONS(3243),
    [anon_sym_extern] = ACTIONS(3243),
    [anon_sym_alias] = ACTIONS(3243),
    [anon_sym_SEMI] = ACTIONS(3245),
    [anon_sym_global] = ACTIONS(3243),
    [anon_sym_using] = ACTIONS(3243),
    [anon_sym_unsafe] = ACTIONS(3243),
    [anon_sym_static] = ACTIONS(3243),
    [anon_sym_LBRACK] = ACTIONS(3245),
    [anon_sym_LPAREN] = ACTIONS(3245),
    [anon_sym_return] = ACTIONS(3243),
    [anon_sym_namespace] = ACTIONS(3243),
    [anon_sym_class] = ACTIONS(3243),
    [anon_sym_ref] = ACTIONS(3243),
    [anon_sym_struct] = ACTIONS(3243),
    [anon_sym_enum] = ACTIONS(3243),
    [anon_sym_LBRACE] = ACTIONS(3245),
    [anon_sym_interface] = ACTIONS(3243),
    [anon_sym_delegate] = ACTIONS(3243),
    [anon_sym_record] = ACTIONS(3243),
    [anon_sym_abstract] = ACTIONS(3243),
    [anon_sym_async] = ACTIONS(3243),
    [anon_sym_const] = ACTIONS(3243),
    [anon_sym_file] = ACTIONS(3243),
    [anon_sym_fixed] = ACTIONS(3243),
    [anon_sym_internal] = ACTIONS(3243),
    [anon_sym_new] = ACTIONS(3243),
    [anon_sym_override] = ACTIONS(3243),
    [anon_sym_partial] = ACTIONS(3243),
    [anon_sym_private] = ACTIONS(3243),
    [anon_sym_protected] = ACTIONS(3243),
    [anon_sym_public] = ACTIONS(3243),
    [anon_sym_readonly] = ACTIONS(3243),
    [anon_sym_required] = ACTIONS(3243),
    [anon_sym_sealed] = ACTIONS(3243),
    [anon_sym_virtual] = ACTIONS(3243),
    [anon_sym_volatile] = ACTIONS(3243),
    [anon_sym_where] = ACTIONS(3243),
    [anon_sym_notnull] = ACTIONS(3243),
    [anon_sym_unmanaged] = ACTIONS(3243),
    [anon_sym_checked] = ACTIONS(3243),
    [anon_sym_BANG] = ACTIONS(3245),
    [anon_sym_TILDE] = ACTIONS(3245),
    [anon_sym_PLUS_PLUS] = ACTIONS(3245),
    [anon_sym_DASH_DASH] = ACTIONS(3245),
    [anon_sym_true] = ACTIONS(3243),
    [anon_sym_false] = ACTIONS(3243),
    [anon_sym_PLUS] = ACTIONS(3243),
    [anon_sym_DASH] = ACTIONS(3243),
    [anon_sym_STAR] = ACTIONS(3245),
    [anon_sym_CARET] = ACTIONS(3245),
    [anon_sym_AMP] = ACTIONS(3245),
    [anon_sym_this] = ACTIONS(3243),
    [anon_sym_scoped] = ACTIONS(3243),
    [anon_sym_var] = ACTIONS(3243),
    [sym_predefined_type] = ACTIONS(3243),
    [anon_sym_break] = ACTIONS(3243),
    [anon_sym_unchecked] = ACTIONS(3243),
    [anon_sym_continue] = ACTIONS(3243),
    [anon_sym_do] = ACTIONS(3243),
    [anon_sym_while] = ACTIONS(3243),
    [anon_sym_for] = ACTIONS(3243),
    [anon_sym_lock] = ACTIONS(3243),
    [anon_sym_yield] = ACTIONS(3243),
    [anon_sym_switch] = ACTIONS(3243),
    [anon_sym_default] = ACTIONS(3243),
    [anon_sym_throw] = ACTIONS(3243),
    [anon_sym_try] = ACTIONS(3243),
    [anon_sym_when] = ACTIONS(3243),
    [anon_sym_await] = ACTIONS(3243),
    [anon_sym_foreach] = ACTIONS(3243),
    [anon_sym_goto] = ACTIONS(3243),
    [anon_sym_if] = ACTIONS(3243),
    [anon_sym_else] = ACTIONS(3243),
    [anon_sym_DOT_DOT] = ACTIONS(3245),
    [anon_sym_from] = ACTIONS(3243),
    [anon_sym_into] = ACTIONS(3243),
    [anon_sym_join] = ACTIONS(3243),
    [anon_sym_on] = ACTIONS(3243),
    [anon_sym_equals] = ACTIONS(3243),
    [anon_sym_let] = ACTIONS(3243),
    [anon_sym_orderby] = ACTIONS(3243),
    [anon_sym_ascending] = ACTIONS(3243),
    [anon_sym_descending] = ACTIONS(3243),
    [anon_sym_group] = ACTIONS(3243),
    [anon_sym_by] = ACTIONS(3243),
    [anon_sym_select] = ACTIONS(3243),
    [anon_sym_DQUOTE] = ACTIONS(3243),
    [anon_sym_stackalloc] = ACTIONS(3243),
    [anon_sym_sizeof] = ACTIONS(3243),
    [anon_sym_typeof] = ACTIONS(3243),
    [anon_sym___makeref] = ACTIONS(3243),
    [anon_sym___reftype] = ACTIONS(3243),
    [anon_sym___refvalue] = ACTIONS(3243),
    [sym_null_literal] = ACTIONS(3243),
    [anon_sym_SQUOTE] = ACTIONS(3245),
    [sym_integer_literal] = ACTIONS(3243),
    [sym_real_literal] = ACTIONS(3245),
    [sym_verbatim_string_literal] = ACTIONS(3245),
    [sym_raw_string_literal] = ACTIONS(3245),
    [aux_sym_preproc_if_token1] = ACTIONS(3245),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3245),
    [sym_interpolation_verbatim_start] = ACTIONS(3245),
    [sym_interpolation_raw_start] = ACTIONS(3245),
  },
  [2443] = {
    [sym_preproc_region] = STATE(2443),
    [sym_preproc_endregion] = STATE(2443),
    [sym_preproc_line] = STATE(2443),
    [sym_preproc_pragma] = STATE(2443),
    [sym_preproc_nullable] = STATE(2443),
    [sym_preproc_error] = STATE(2443),
    [sym_preproc_define] = STATE(2443),
    [sym_preproc_undef] = STATE(2443),
    [ts_builtin_sym_end] = ACTIONS(3217),
    [sym__identifier_token] = ACTIONS(3215),
    [anon_sym_extern] = ACTIONS(3215),
    [anon_sym_alias] = ACTIONS(3215),
    [anon_sym_SEMI] = ACTIONS(3217),
    [anon_sym_global] = ACTIONS(3215),
    [anon_sym_using] = ACTIONS(3215),
    [anon_sym_unsafe] = ACTIONS(3215),
    [anon_sym_static] = ACTIONS(3215),
    [anon_sym_LBRACK] = ACTIONS(3217),
    [anon_sym_LPAREN] = ACTIONS(3217),
    [anon_sym_return] = ACTIONS(3215),
    [anon_sym_namespace] = ACTIONS(3215),
    [anon_sym_class] = ACTIONS(3215),
    [anon_sym_ref] = ACTIONS(3215),
    [anon_sym_struct] = ACTIONS(3215),
    [anon_sym_enum] = ACTIONS(3215),
    [anon_sym_LBRACE] = ACTIONS(3217),
    [anon_sym_interface] = ACTIONS(3215),
    [anon_sym_delegate] = ACTIONS(3215),
    [anon_sym_record] = ACTIONS(3215),
    [anon_sym_abstract] = ACTIONS(3215),
    [anon_sym_async] = ACTIONS(3215),
    [anon_sym_const] = ACTIONS(3215),
    [anon_sym_file] = ACTIONS(3215),
    [anon_sym_fixed] = ACTIONS(3215),
    [anon_sym_internal] = ACTIONS(3215),
    [anon_sym_new] = ACTIONS(3215),
    [anon_sym_override] = ACTIONS(3215),
    [anon_sym_partial] = ACTIONS(3215),
    [anon_sym_private] = ACTIONS(3215),
    [anon_sym_protected] = ACTIONS(3215),
    [anon_sym_public] = ACTIONS(3215),
    [anon_sym_readonly] = ACTIONS(3215),
    [anon_sym_required] = ACTIONS(3215),
    [anon_sym_sealed] = ACTIONS(3215),
    [anon_sym_virtual] = ACTIONS(3215),
    [anon_sym_volatile] = ACTIONS(3215),
    [anon_sym_where] = ACTIONS(3215),
    [anon_sym_notnull] = ACTIONS(3215),
    [anon_sym_unmanaged] = ACTIONS(3215),
    [anon_sym_checked] = ACTIONS(3215),
    [anon_sym_BANG] = ACTIONS(3217),
    [anon_sym_TILDE] = ACTIONS(3217),
    [anon_sym_PLUS_PLUS] = ACTIONS(3217),
    [anon_sym_DASH_DASH] = ACTIONS(3217),
    [anon_sym_true] = ACTIONS(3215),
    [anon_sym_false] = ACTIONS(3215),
    [anon_sym_PLUS] = ACTIONS(3215),
    [anon_sym_DASH] = ACTIONS(3215),
    [anon_sym_STAR] = ACTIONS(3217),
    [anon_sym_CARET] = ACTIONS(3217),
    [anon_sym_AMP] = ACTIONS(3217),
    [anon_sym_this] = ACTIONS(3215),
    [anon_sym_scoped] = ACTIONS(3215),
    [anon_sym_var] = ACTIONS(3215),
    [sym_predefined_type] = ACTIONS(3215),
    [anon_sym_break] = ACTIONS(3215),
    [anon_sym_unchecked] = ACTIONS(3215),
    [anon_sym_continue] = ACTIONS(3215),
    [anon_sym_do] = ACTIONS(3215),
    [anon_sym_while] = ACTIONS(3215),
    [anon_sym_for] = ACTIONS(3215),
    [anon_sym_lock] = ACTIONS(3215),
    [anon_sym_yield] = ACTIONS(3215),
    [anon_sym_switch] = ACTIONS(3215),
    [anon_sym_default] = ACTIONS(3215),
    [anon_sym_throw] = ACTIONS(3215),
    [anon_sym_try] = ACTIONS(3215),
    [anon_sym_when] = ACTIONS(3215),
    [anon_sym_await] = ACTIONS(3215),
    [anon_sym_foreach] = ACTIONS(3215),
    [anon_sym_goto] = ACTIONS(3215),
    [anon_sym_if] = ACTIONS(3215),
    [anon_sym_else] = ACTIONS(3215),
    [anon_sym_DOT_DOT] = ACTIONS(3217),
    [anon_sym_from] = ACTIONS(3215),
    [anon_sym_into] = ACTIONS(3215),
    [anon_sym_join] = ACTIONS(3215),
    [anon_sym_on] = ACTIONS(3215),
    [anon_sym_equals] = ACTIONS(3215),
    [anon_sym_let] = ACTIONS(3215),
    [anon_sym_orderby] = ACTIONS(3215),
    [anon_sym_ascending] = ACTIONS(3215),
    [anon_sym_descending] = ACTIONS(3215),
    [anon_sym_group] = ACTIONS(3215),
    [anon_sym_by] = ACTIONS(3215),
    [anon_sym_select] = ACTIONS(3215),
    [anon_sym_DQUOTE] = ACTIONS(3215),
    [anon_sym_stackalloc] = ACTIONS(3215),
    [anon_sym_sizeof] = ACTIONS(3215),
    [anon_sym_typeof] = ACTIONS(3215),
    [anon_sym___makeref] = ACTIONS(3215),
    [anon_sym___reftype] = ACTIONS(3215),
    [anon_sym___refvalue] = ACTIONS(3215),
    [sym_null_literal] = ACTIONS(3215),
    [anon_sym_SQUOTE] = ACTIONS(3217),
    [sym_integer_literal] = ACTIONS(3215),
    [sym_real_literal] = ACTIONS(3217),
    [sym_verbatim_string_literal] = ACTIONS(3217),
    [sym_raw_string_literal] = ACTIONS(3217),
    [aux_sym_preproc_if_token1] = ACTIONS(3217),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3217),
    [sym_interpolation_verbatim_start] = ACTIONS(3217),
    [sym_interpolation_raw_start] = ACTIONS(3217),
  },
  [2444] = {
    [sym_preproc_region] = STATE(2444),
    [sym_preproc_endregion] = STATE(2444),
    [sym_preproc_line] = STATE(2444),
    [sym_preproc_pragma] = STATE(2444),
    [sym_preproc_nullable] = STATE(2444),
    [sym_preproc_error] = STATE(2444),
    [sym_preproc_define] = STATE(2444),
    [sym_preproc_undef] = STATE(2444),
    [ts_builtin_sym_end] = ACTIONS(3373),
    [sym__identifier_token] = ACTIONS(3371),
    [anon_sym_extern] = ACTIONS(3371),
    [anon_sym_alias] = ACTIONS(3371),
    [anon_sym_SEMI] = ACTIONS(3373),
    [anon_sym_global] = ACTIONS(3371),
    [anon_sym_using] = ACTIONS(3371),
    [anon_sym_unsafe] = ACTIONS(3371),
    [anon_sym_static] = ACTIONS(3371),
    [anon_sym_LBRACK] = ACTIONS(3373),
    [anon_sym_LPAREN] = ACTIONS(3373),
    [anon_sym_return] = ACTIONS(3371),
    [anon_sym_namespace] = ACTIONS(3371),
    [anon_sym_class] = ACTIONS(3371),
    [anon_sym_ref] = ACTIONS(3371),
    [anon_sym_struct] = ACTIONS(3371),
    [anon_sym_enum] = ACTIONS(3371),
    [anon_sym_LBRACE] = ACTIONS(3373),
    [anon_sym_interface] = ACTIONS(3371),
    [anon_sym_delegate] = ACTIONS(3371),
    [anon_sym_record] = ACTIONS(3371),
    [anon_sym_abstract] = ACTIONS(3371),
    [anon_sym_async] = ACTIONS(3371),
    [anon_sym_const] = ACTIONS(3371),
    [anon_sym_file] = ACTIONS(3371),
    [anon_sym_fixed] = ACTIONS(3371),
    [anon_sym_internal] = ACTIONS(3371),
    [anon_sym_new] = ACTIONS(3371),
    [anon_sym_override] = ACTIONS(3371),
    [anon_sym_partial] = ACTIONS(3371),
    [anon_sym_private] = ACTIONS(3371),
    [anon_sym_protected] = ACTIONS(3371),
    [anon_sym_public] = ACTIONS(3371),
    [anon_sym_readonly] = ACTIONS(3371),
    [anon_sym_required] = ACTIONS(3371),
    [anon_sym_sealed] = ACTIONS(3371),
    [anon_sym_virtual] = ACTIONS(3371),
    [anon_sym_volatile] = ACTIONS(3371),
    [anon_sym_where] = ACTIONS(3371),
    [anon_sym_notnull] = ACTIONS(3371),
    [anon_sym_unmanaged] = ACTIONS(3371),
    [anon_sym_checked] = ACTIONS(3371),
    [anon_sym_BANG] = ACTIONS(3373),
    [anon_sym_TILDE] = ACTIONS(3373),
    [anon_sym_PLUS_PLUS] = ACTIONS(3373),
    [anon_sym_DASH_DASH] = ACTIONS(3373),
    [anon_sym_true] = ACTIONS(3371),
    [anon_sym_false] = ACTIONS(3371),
    [anon_sym_PLUS] = ACTIONS(3371),
    [anon_sym_DASH] = ACTIONS(3371),
    [anon_sym_STAR] = ACTIONS(3373),
    [anon_sym_CARET] = ACTIONS(3373),
    [anon_sym_AMP] = ACTIONS(3373),
    [anon_sym_this] = ACTIONS(3371),
    [anon_sym_scoped] = ACTIONS(3371),
    [anon_sym_var] = ACTIONS(3371),
    [sym_predefined_type] = ACTIONS(3371),
    [anon_sym_break] = ACTIONS(3371),
    [anon_sym_unchecked] = ACTIONS(3371),
    [anon_sym_continue] = ACTIONS(3371),
    [anon_sym_do] = ACTIONS(3371),
    [anon_sym_while] = ACTIONS(3371),
    [anon_sym_for] = ACTIONS(3371),
    [anon_sym_lock] = ACTIONS(3371),
    [anon_sym_yield] = ACTIONS(3371),
    [anon_sym_switch] = ACTIONS(3371),
    [anon_sym_default] = ACTIONS(3371),
    [anon_sym_throw] = ACTIONS(3371),
    [anon_sym_try] = ACTIONS(3371),
    [anon_sym_when] = ACTIONS(3371),
    [anon_sym_await] = ACTIONS(3371),
    [anon_sym_foreach] = ACTIONS(3371),
    [anon_sym_goto] = ACTIONS(3371),
    [anon_sym_if] = ACTIONS(3371),
    [anon_sym_else] = ACTIONS(3371),
    [anon_sym_DOT_DOT] = ACTIONS(3373),
    [anon_sym_from] = ACTIONS(3371),
    [anon_sym_into] = ACTIONS(3371),
    [anon_sym_join] = ACTIONS(3371),
    [anon_sym_on] = ACTIONS(3371),
    [anon_sym_equals] = ACTIONS(3371),
    [anon_sym_let] = ACTIONS(3371),
    [anon_sym_orderby] = ACTIONS(3371),
    [anon_sym_ascending] = ACTIONS(3371),
    [anon_sym_descending] = ACTIONS(3371),
    [anon_sym_group] = ACTIONS(3371),
    [anon_sym_by] = ACTIONS(3371),
    [anon_sym_select] = ACTIONS(3371),
    [anon_sym_DQUOTE] = ACTIONS(3371),
    [anon_sym_stackalloc] = ACTIONS(3371),
    [anon_sym_sizeof] = ACTIONS(3371),
    [anon_sym_typeof] = ACTIONS(3371),
    [anon_sym___makeref] = ACTIONS(3371),
    [anon_sym___reftype] = ACTIONS(3371),
    [anon_sym___refvalue] = ACTIONS(3371),
    [sym_null_literal] = ACTIONS(3371),
    [anon_sym_SQUOTE] = ACTIONS(3373),
    [sym_integer_literal] = ACTIONS(3371),
    [sym_real_literal] = ACTIONS(3373),
    [sym_verbatim_string_literal] = ACTIONS(3373),
    [sym_raw_string_literal] = ACTIONS(3373),
    [aux_sym_preproc_if_token1] = ACTIONS(3373),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3373),
    [sym_interpolation_verbatim_start] = ACTIONS(3373),
    [sym_interpolation_raw_start] = ACTIONS(3373),
  },
  [2445] = {
    [sym_preproc_region] = STATE(2445),
    [sym_preproc_endregion] = STATE(2445),
    [sym_preproc_line] = STATE(2445),
    [sym_preproc_pragma] = STATE(2445),
    [sym_preproc_nullable] = STATE(2445),
    [sym_preproc_error] = STATE(2445),
    [sym_preproc_define] = STATE(2445),
    [sym_preproc_undef] = STATE(2445),
    [ts_builtin_sym_end] = ACTIONS(3253),
    [sym__identifier_token] = ACTIONS(3251),
    [anon_sym_extern] = ACTIONS(3251),
    [anon_sym_alias] = ACTIONS(3251),
    [anon_sym_SEMI] = ACTIONS(3253),
    [anon_sym_global] = ACTIONS(3251),
    [anon_sym_using] = ACTIONS(3251),
    [anon_sym_unsafe] = ACTIONS(3251),
    [anon_sym_static] = ACTIONS(3251),
    [anon_sym_LBRACK] = ACTIONS(3253),
    [anon_sym_LPAREN] = ACTIONS(3253),
    [anon_sym_return] = ACTIONS(3251),
    [anon_sym_namespace] = ACTIONS(3251),
    [anon_sym_class] = ACTIONS(3251),
    [anon_sym_ref] = ACTIONS(3251),
    [anon_sym_struct] = ACTIONS(3251),
    [anon_sym_enum] = ACTIONS(3251),
    [anon_sym_LBRACE] = ACTIONS(3253),
    [anon_sym_interface] = ACTIONS(3251),
    [anon_sym_delegate] = ACTIONS(3251),
    [anon_sym_record] = ACTIONS(3251),
    [anon_sym_abstract] = ACTIONS(3251),
    [anon_sym_async] = ACTIONS(3251),
    [anon_sym_const] = ACTIONS(3251),
    [anon_sym_file] = ACTIONS(3251),
    [anon_sym_fixed] = ACTIONS(3251),
    [anon_sym_internal] = ACTIONS(3251),
    [anon_sym_new] = ACTIONS(3251),
    [anon_sym_override] = ACTIONS(3251),
    [anon_sym_partial] = ACTIONS(3251),
    [anon_sym_private] = ACTIONS(3251),
    [anon_sym_protected] = ACTIONS(3251),
    [anon_sym_public] = ACTIONS(3251),
    [anon_sym_readonly] = ACTIONS(3251),
    [anon_sym_required] = ACTIONS(3251),
    [anon_sym_sealed] = ACTIONS(3251),
    [anon_sym_virtual] = ACTIONS(3251),
    [anon_sym_volatile] = ACTIONS(3251),
    [anon_sym_where] = ACTIONS(3251),
    [anon_sym_notnull] = ACTIONS(3251),
    [anon_sym_unmanaged] = ACTIONS(3251),
    [anon_sym_checked] = ACTIONS(3251),
    [anon_sym_BANG] = ACTIONS(3253),
    [anon_sym_TILDE] = ACTIONS(3253),
    [anon_sym_PLUS_PLUS] = ACTIONS(3253),
    [anon_sym_DASH_DASH] = ACTIONS(3253),
    [anon_sym_true] = ACTIONS(3251),
    [anon_sym_false] = ACTIONS(3251),
    [anon_sym_PLUS] = ACTIONS(3251),
    [anon_sym_DASH] = ACTIONS(3251),
    [anon_sym_STAR] = ACTIONS(3253),
    [anon_sym_CARET] = ACTIONS(3253),
    [anon_sym_AMP] = ACTIONS(3253),
    [anon_sym_this] = ACTIONS(3251),
    [anon_sym_scoped] = ACTIONS(3251),
    [anon_sym_var] = ACTIONS(3251),
    [sym_predefined_type] = ACTIONS(3251),
    [anon_sym_break] = ACTIONS(3251),
    [anon_sym_unchecked] = ACTIONS(3251),
    [anon_sym_continue] = ACTIONS(3251),
    [anon_sym_do] = ACTIONS(3251),
    [anon_sym_while] = ACTIONS(3251),
    [anon_sym_for] = ACTIONS(3251),
    [anon_sym_lock] = ACTIONS(3251),
    [anon_sym_yield] = ACTIONS(3251),
    [anon_sym_switch] = ACTIONS(3251),
    [anon_sym_default] = ACTIONS(3251),
    [anon_sym_throw] = ACTIONS(3251),
    [anon_sym_try] = ACTIONS(3251),
    [anon_sym_when] = ACTIONS(3251),
    [anon_sym_await] = ACTIONS(3251),
    [anon_sym_foreach] = ACTIONS(3251),
    [anon_sym_goto] = ACTIONS(3251),
    [anon_sym_if] = ACTIONS(3251),
    [anon_sym_else] = ACTIONS(3251),
    [anon_sym_DOT_DOT] = ACTIONS(3253),
    [anon_sym_from] = ACTIONS(3251),
    [anon_sym_into] = ACTIONS(3251),
    [anon_sym_join] = ACTIONS(3251),
    [anon_sym_on] = ACTIONS(3251),
    [anon_sym_equals] = ACTIONS(3251),
    [anon_sym_let] = ACTIONS(3251),
    [anon_sym_orderby] = ACTIONS(3251),
    [anon_sym_ascending] = ACTIONS(3251),
    [anon_sym_descending] = ACTIONS(3251),
    [anon_sym_group] = ACTIONS(3251),
    [anon_sym_by] = ACTIONS(3251),
    [anon_sym_select] = ACTIONS(3251),
    [anon_sym_DQUOTE] = ACTIONS(3251),
    [anon_sym_stackalloc] = ACTIONS(3251),
    [anon_sym_sizeof] = ACTIONS(3251),
    [anon_sym_typeof] = ACTIONS(3251),
    [anon_sym___makeref] = ACTIONS(3251),
    [anon_sym___reftype] = ACTIONS(3251),
    [anon_sym___refvalue] = ACTIONS(3251),
    [sym_null_literal] = ACTIONS(3251),
    [anon_sym_SQUOTE] = ACTIONS(3253),
    [sym_integer_literal] = ACTIONS(3251),
    [sym_real_literal] = ACTIONS(3253),
    [sym_verbatim_string_literal] = ACTIONS(3253),
    [sym_raw_string_literal] = ACTIONS(3253),
    [aux_sym_preproc_if_token1] = ACTIONS(3253),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3253),
    [sym_interpolation_verbatim_start] = ACTIONS(3253),
    [sym_interpolation_raw_start] = ACTIONS(3253),
  },
  [2446] = {
    [sym_preproc_region] = STATE(2446),
    [sym_preproc_endregion] = STATE(2446),
    [sym_preproc_line] = STATE(2446),
    [sym_preproc_pragma] = STATE(2446),
    [sym_preproc_nullable] = STATE(2446),
    [sym_preproc_error] = STATE(2446),
    [sym_preproc_define] = STATE(2446),
    [sym_preproc_undef] = STATE(2446),
    [ts_builtin_sym_end] = ACTIONS(3361),
    [sym__identifier_token] = ACTIONS(3359),
    [anon_sym_extern] = ACTIONS(3359),
    [anon_sym_alias] = ACTIONS(3359),
    [anon_sym_SEMI] = ACTIONS(3361),
    [anon_sym_global] = ACTIONS(3359),
    [anon_sym_using] = ACTIONS(3359),
    [anon_sym_unsafe] = ACTIONS(3359),
    [anon_sym_static] = ACTIONS(3359),
    [anon_sym_LBRACK] = ACTIONS(3361),
    [anon_sym_LPAREN] = ACTIONS(3361),
    [anon_sym_return] = ACTIONS(3359),
    [anon_sym_namespace] = ACTIONS(3359),
    [anon_sym_class] = ACTIONS(3359),
    [anon_sym_ref] = ACTIONS(3359),
    [anon_sym_struct] = ACTIONS(3359),
    [anon_sym_enum] = ACTIONS(3359),
    [anon_sym_LBRACE] = ACTIONS(3361),
    [anon_sym_interface] = ACTIONS(3359),
    [anon_sym_delegate] = ACTIONS(3359),
    [anon_sym_record] = ACTIONS(3359),
    [anon_sym_abstract] = ACTIONS(3359),
    [anon_sym_async] = ACTIONS(3359),
    [anon_sym_const] = ACTIONS(3359),
    [anon_sym_file] = ACTIONS(3359),
    [anon_sym_fixed] = ACTIONS(3359),
    [anon_sym_internal] = ACTIONS(3359),
    [anon_sym_new] = ACTIONS(3359),
    [anon_sym_override] = ACTIONS(3359),
    [anon_sym_partial] = ACTIONS(3359),
    [anon_sym_private] = ACTIONS(3359),
    [anon_sym_protected] = ACTIONS(3359),
    [anon_sym_public] = ACTIONS(3359),
    [anon_sym_readonly] = ACTIONS(3359),
    [anon_sym_required] = ACTIONS(3359),
    [anon_sym_sealed] = ACTIONS(3359),
    [anon_sym_virtual] = ACTIONS(3359),
    [anon_sym_volatile] = ACTIONS(3359),
    [anon_sym_where] = ACTIONS(3359),
    [anon_sym_notnull] = ACTIONS(3359),
    [anon_sym_unmanaged] = ACTIONS(3359),
    [anon_sym_checked] = ACTIONS(3359),
    [anon_sym_BANG] = ACTIONS(3361),
    [anon_sym_TILDE] = ACTIONS(3361),
    [anon_sym_PLUS_PLUS] = ACTIONS(3361),
    [anon_sym_DASH_DASH] = ACTIONS(3361),
    [anon_sym_true] = ACTIONS(3359),
    [anon_sym_false] = ACTIONS(3359),
    [anon_sym_PLUS] = ACTIONS(3359),
    [anon_sym_DASH] = ACTIONS(3359),
    [anon_sym_STAR] = ACTIONS(3361),
    [anon_sym_CARET] = ACTIONS(3361),
    [anon_sym_AMP] = ACTIONS(3361),
    [anon_sym_this] = ACTIONS(3359),
    [anon_sym_scoped] = ACTIONS(3359),
    [anon_sym_var] = ACTIONS(3359),
    [sym_predefined_type] = ACTIONS(3359),
    [anon_sym_break] = ACTIONS(3359),
    [anon_sym_unchecked] = ACTIONS(3359),
    [anon_sym_continue] = ACTIONS(3359),
    [anon_sym_do] = ACTIONS(3359),
    [anon_sym_while] = ACTIONS(3359),
    [anon_sym_for] = ACTIONS(3359),
    [anon_sym_lock] = ACTIONS(3359),
    [anon_sym_yield] = ACTIONS(3359),
    [anon_sym_switch] = ACTIONS(3359),
    [anon_sym_default] = ACTIONS(3359),
    [anon_sym_throw] = ACTIONS(3359),
    [anon_sym_try] = ACTIONS(3359),
    [anon_sym_when] = ACTIONS(3359),
    [anon_sym_await] = ACTIONS(3359),
    [anon_sym_foreach] = ACTIONS(3359),
    [anon_sym_goto] = ACTIONS(3359),
    [anon_sym_if] = ACTIONS(3359),
    [anon_sym_else] = ACTIONS(3359),
    [anon_sym_DOT_DOT] = ACTIONS(3361),
    [anon_sym_from] = ACTIONS(3359),
    [anon_sym_into] = ACTIONS(3359),
    [anon_sym_join] = ACTIONS(3359),
    [anon_sym_on] = ACTIONS(3359),
    [anon_sym_equals] = ACTIONS(3359),
    [anon_sym_let] = ACTIONS(3359),
    [anon_sym_orderby] = ACTIONS(3359),
    [anon_sym_ascending] = ACTIONS(3359),
    [anon_sym_descending] = ACTIONS(3359),
    [anon_sym_group] = ACTIONS(3359),
    [anon_sym_by] = ACTIONS(3359),
    [anon_sym_select] = ACTIONS(3359),
    [anon_sym_DQUOTE] = ACTIONS(3359),
    [anon_sym_stackalloc] = ACTIONS(3359),
    [anon_sym_sizeof] = ACTIONS(3359),
    [anon_sym_typeof] = ACTIONS(3359),
    [anon_sym___makeref] = ACTIONS(3359),
    [anon_sym___reftype] = ACTIONS(3359),
    [anon_sym___refvalue] = ACTIONS(3359),
    [sym_null_literal] = ACTIONS(3359),
    [anon_sym_SQUOTE] = ACTIONS(3361),
    [sym_integer_literal] = ACTIONS(3359),
    [sym_real_literal] = ACTIONS(3361),
    [sym_verbatim_string_literal] = ACTIONS(3361),
    [sym_raw_string_literal] = ACTIONS(3361),
    [aux_sym_preproc_if_token1] = ACTIONS(3361),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3361),
    [sym_interpolation_verbatim_start] = ACTIONS(3361),
    [sym_interpolation_raw_start] = ACTIONS(3361),
  },
  [2447] = {
    [sym_preproc_region] = STATE(2447),
    [sym_preproc_endregion] = STATE(2447),
    [sym_preproc_line] = STATE(2447),
    [sym_preproc_pragma] = STATE(2447),
    [sym_preproc_nullable] = STATE(2447),
    [sym_preproc_error] = STATE(2447),
    [sym_preproc_define] = STATE(2447),
    [sym_preproc_undef] = STATE(2447),
    [ts_builtin_sym_end] = ACTIONS(3357),
    [sym__identifier_token] = ACTIONS(3355),
    [anon_sym_extern] = ACTIONS(3355),
    [anon_sym_alias] = ACTIONS(3355),
    [anon_sym_SEMI] = ACTIONS(3357),
    [anon_sym_global] = ACTIONS(3355),
    [anon_sym_using] = ACTIONS(3355),
    [anon_sym_unsafe] = ACTIONS(3355),
    [anon_sym_static] = ACTIONS(3355),
    [anon_sym_LBRACK] = ACTIONS(3357),
    [anon_sym_LPAREN] = ACTIONS(3357),
    [anon_sym_return] = ACTIONS(3355),
    [anon_sym_namespace] = ACTIONS(3355),
    [anon_sym_class] = ACTIONS(3355),
    [anon_sym_ref] = ACTIONS(3355),
    [anon_sym_struct] = ACTIONS(3355),
    [anon_sym_enum] = ACTIONS(3355),
    [anon_sym_LBRACE] = ACTIONS(3357),
    [anon_sym_interface] = ACTIONS(3355),
    [anon_sym_delegate] = ACTIONS(3355),
    [anon_sym_record] = ACTIONS(3355),
    [anon_sym_abstract] = ACTIONS(3355),
    [anon_sym_async] = ACTIONS(3355),
    [anon_sym_const] = ACTIONS(3355),
    [anon_sym_file] = ACTIONS(3355),
    [anon_sym_fixed] = ACTIONS(3355),
    [anon_sym_internal] = ACTIONS(3355),
    [anon_sym_new] = ACTIONS(3355),
    [anon_sym_override] = ACTIONS(3355),
    [anon_sym_partial] = ACTIONS(3355),
    [anon_sym_private] = ACTIONS(3355),
    [anon_sym_protected] = ACTIONS(3355),
    [anon_sym_public] = ACTIONS(3355),
    [anon_sym_readonly] = ACTIONS(3355),
    [anon_sym_required] = ACTIONS(3355),
    [anon_sym_sealed] = ACTIONS(3355),
    [anon_sym_virtual] = ACTIONS(3355),
    [anon_sym_volatile] = ACTIONS(3355),
    [anon_sym_where] = ACTIONS(3355),
    [anon_sym_notnull] = ACTIONS(3355),
    [anon_sym_unmanaged] = ACTIONS(3355),
    [anon_sym_checked] = ACTIONS(3355),
    [anon_sym_BANG] = ACTIONS(3357),
    [anon_sym_TILDE] = ACTIONS(3357),
    [anon_sym_PLUS_PLUS] = ACTIONS(3357),
    [anon_sym_DASH_DASH] = ACTIONS(3357),
    [anon_sym_true] = ACTIONS(3355),
    [anon_sym_false] = ACTIONS(3355),
    [anon_sym_PLUS] = ACTIONS(3355),
    [anon_sym_DASH] = ACTIONS(3355),
    [anon_sym_STAR] = ACTIONS(3357),
    [anon_sym_CARET] = ACTIONS(3357),
    [anon_sym_AMP] = ACTIONS(3357),
    [anon_sym_this] = ACTIONS(3355),
    [anon_sym_scoped] = ACTIONS(3355),
    [anon_sym_var] = ACTIONS(3355),
    [sym_predefined_type] = ACTIONS(3355),
    [anon_sym_break] = ACTIONS(3355),
    [anon_sym_unchecked] = ACTIONS(3355),
    [anon_sym_continue] = ACTIONS(3355),
    [anon_sym_do] = ACTIONS(3355),
    [anon_sym_while] = ACTIONS(3355),
    [anon_sym_for] = ACTIONS(3355),
    [anon_sym_lock] = ACTIONS(3355),
    [anon_sym_yield] = ACTIONS(3355),
    [anon_sym_switch] = ACTIONS(3355),
    [anon_sym_default] = ACTIONS(3355),
    [anon_sym_throw] = ACTIONS(3355),
    [anon_sym_try] = ACTIONS(3355),
    [anon_sym_when] = ACTIONS(3355),
    [anon_sym_await] = ACTIONS(3355),
    [anon_sym_foreach] = ACTIONS(3355),
    [anon_sym_goto] = ACTIONS(3355),
    [anon_sym_if] = ACTIONS(3355),
    [anon_sym_else] = ACTIONS(3355),
    [anon_sym_DOT_DOT] = ACTIONS(3357),
    [anon_sym_from] = ACTIONS(3355),
    [anon_sym_into] = ACTIONS(3355),
    [anon_sym_join] = ACTIONS(3355),
    [anon_sym_on] = ACTIONS(3355),
    [anon_sym_equals] = ACTIONS(3355),
    [anon_sym_let] = ACTIONS(3355),
    [anon_sym_orderby] = ACTIONS(3355),
    [anon_sym_ascending] = ACTIONS(3355),
    [anon_sym_descending] = ACTIONS(3355),
    [anon_sym_group] = ACTIONS(3355),
    [anon_sym_by] = ACTIONS(3355),
    [anon_sym_select] = ACTIONS(3355),
    [anon_sym_DQUOTE] = ACTIONS(3355),
    [anon_sym_stackalloc] = ACTIONS(3355),
    [anon_sym_sizeof] = ACTIONS(3355),
    [anon_sym_typeof] = ACTIONS(3355),
    [anon_sym___makeref] = ACTIONS(3355),
    [anon_sym___reftype] = ACTIONS(3355),
    [anon_sym___refvalue] = ACTIONS(3355),
    [sym_null_literal] = ACTIONS(3355),
    [anon_sym_SQUOTE] = ACTIONS(3357),
    [sym_integer_literal] = ACTIONS(3355),
    [sym_real_literal] = ACTIONS(3357),
    [sym_verbatim_string_literal] = ACTIONS(3357),
    [sym_raw_string_literal] = ACTIONS(3357),
    [aux_sym_preproc_if_token1] = ACTIONS(3357),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3357),
    [sym_interpolation_verbatim_start] = ACTIONS(3357),
    [sym_interpolation_raw_start] = ACTIONS(3357),
  },
  [2448] = {
    [sym_preproc_region] = STATE(2448),
    [sym_preproc_endregion] = STATE(2448),
    [sym_preproc_line] = STATE(2448),
    [sym_preproc_pragma] = STATE(2448),
    [sym_preproc_nullable] = STATE(2448),
    [sym_preproc_error] = STATE(2448),
    [sym_preproc_define] = STATE(2448),
    [sym_preproc_undef] = STATE(2448),
    [ts_builtin_sym_end] = ACTIONS(3079),
    [sym__identifier_token] = ACTIONS(3077),
    [anon_sym_extern] = ACTIONS(3077),
    [anon_sym_alias] = ACTIONS(3077),
    [anon_sym_SEMI] = ACTIONS(3079),
    [anon_sym_global] = ACTIONS(3077),
    [anon_sym_using] = ACTIONS(3077),
    [anon_sym_unsafe] = ACTIONS(3077),
    [anon_sym_static] = ACTIONS(3077),
    [anon_sym_LBRACK] = ACTIONS(3079),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_return] = ACTIONS(3077),
    [anon_sym_namespace] = ACTIONS(3077),
    [anon_sym_class] = ACTIONS(3077),
    [anon_sym_ref] = ACTIONS(3077),
    [anon_sym_struct] = ACTIONS(3077),
    [anon_sym_enum] = ACTIONS(3077),
    [anon_sym_LBRACE] = ACTIONS(3079),
    [anon_sym_interface] = ACTIONS(3077),
    [anon_sym_delegate] = ACTIONS(3077),
    [anon_sym_record] = ACTIONS(3077),
    [anon_sym_abstract] = ACTIONS(3077),
    [anon_sym_async] = ACTIONS(3077),
    [anon_sym_const] = ACTIONS(3077),
    [anon_sym_file] = ACTIONS(3077),
    [anon_sym_fixed] = ACTIONS(3077),
    [anon_sym_internal] = ACTIONS(3077),
    [anon_sym_new] = ACTIONS(3077),
    [anon_sym_override] = ACTIONS(3077),
    [anon_sym_partial] = ACTIONS(3077),
    [anon_sym_private] = ACTIONS(3077),
    [anon_sym_protected] = ACTIONS(3077),
    [anon_sym_public] = ACTIONS(3077),
    [anon_sym_readonly] = ACTIONS(3077),
    [anon_sym_required] = ACTIONS(3077),
    [anon_sym_sealed] = ACTIONS(3077),
    [anon_sym_virtual] = ACTIONS(3077),
    [anon_sym_volatile] = ACTIONS(3077),
    [anon_sym_where] = ACTIONS(3077),
    [anon_sym_notnull] = ACTIONS(3077),
    [anon_sym_unmanaged] = ACTIONS(3077),
    [anon_sym_checked] = ACTIONS(3077),
    [anon_sym_BANG] = ACTIONS(3079),
    [anon_sym_TILDE] = ACTIONS(3079),
    [anon_sym_PLUS_PLUS] = ACTIONS(3079),
    [anon_sym_DASH_DASH] = ACTIONS(3079),
    [anon_sym_true] = ACTIONS(3077),
    [anon_sym_false] = ACTIONS(3077),
    [anon_sym_PLUS] = ACTIONS(3077),
    [anon_sym_DASH] = ACTIONS(3077),
    [anon_sym_STAR] = ACTIONS(3079),
    [anon_sym_CARET] = ACTIONS(3079),
    [anon_sym_AMP] = ACTIONS(3079),
    [anon_sym_this] = ACTIONS(3077),
    [anon_sym_scoped] = ACTIONS(3077),
    [anon_sym_var] = ACTIONS(3077),
    [sym_predefined_type] = ACTIONS(3077),
    [anon_sym_break] = ACTIONS(3077),
    [anon_sym_unchecked] = ACTIONS(3077),
    [anon_sym_continue] = ACTIONS(3077),
    [anon_sym_do] = ACTIONS(3077),
    [anon_sym_while] = ACTIONS(3077),
    [anon_sym_for] = ACTIONS(3077),
    [anon_sym_lock] = ACTIONS(3077),
    [anon_sym_yield] = ACTIONS(3077),
    [anon_sym_switch] = ACTIONS(3077),
    [anon_sym_default] = ACTIONS(3077),
    [anon_sym_throw] = ACTIONS(3077),
    [anon_sym_try] = ACTIONS(3077),
    [anon_sym_when] = ACTIONS(3077),
    [anon_sym_await] = ACTIONS(3077),
    [anon_sym_foreach] = ACTIONS(3077),
    [anon_sym_goto] = ACTIONS(3077),
    [anon_sym_if] = ACTIONS(3077),
    [anon_sym_else] = ACTIONS(3077),
    [anon_sym_DOT_DOT] = ACTIONS(3079),
    [anon_sym_from] = ACTIONS(3077),
    [anon_sym_into] = ACTIONS(3077),
    [anon_sym_join] = ACTIONS(3077),
    [anon_sym_on] = ACTIONS(3077),
    [anon_sym_equals] = ACTIONS(3077),
    [anon_sym_let] = ACTIONS(3077),
    [anon_sym_orderby] = ACTIONS(3077),
    [anon_sym_ascending] = ACTIONS(3077),
    [anon_sym_descending] = ACTIONS(3077),
    [anon_sym_group] = ACTIONS(3077),
    [anon_sym_by] = ACTIONS(3077),
    [anon_sym_select] = ACTIONS(3077),
    [anon_sym_DQUOTE] = ACTIONS(3077),
    [anon_sym_stackalloc] = ACTIONS(3077),
    [anon_sym_sizeof] = ACTIONS(3077),
    [anon_sym_typeof] = ACTIONS(3077),
    [anon_sym___makeref] = ACTIONS(3077),
    [anon_sym___reftype] = ACTIONS(3077),
    [anon_sym___refvalue] = ACTIONS(3077),
    [sym_null_literal] = ACTIONS(3077),
    [anon_sym_SQUOTE] = ACTIONS(3079),
    [sym_integer_literal] = ACTIONS(3077),
    [sym_real_literal] = ACTIONS(3079),
    [sym_verbatim_string_literal] = ACTIONS(3079),
    [sym_raw_string_literal] = ACTIONS(3079),
    [aux_sym_preproc_if_token1] = ACTIONS(3079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3079),
    [sym_interpolation_verbatim_start] = ACTIONS(3079),
    [sym_interpolation_raw_start] = ACTIONS(3079),
  },
  [2449] = {
    [sym_preproc_region] = STATE(2449),
    [sym_preproc_endregion] = STATE(2449),
    [sym_preproc_line] = STATE(2449),
    [sym_preproc_pragma] = STATE(2449),
    [sym_preproc_nullable] = STATE(2449),
    [sym_preproc_error] = STATE(2449),
    [sym_preproc_define] = STATE(2449),
    [sym_preproc_undef] = STATE(2449),
    [ts_builtin_sym_end] = ACTIONS(3075),
    [sym__identifier_token] = ACTIONS(3073),
    [anon_sym_extern] = ACTIONS(3073),
    [anon_sym_alias] = ACTIONS(3073),
    [anon_sym_SEMI] = ACTIONS(3075),
    [anon_sym_global] = ACTIONS(3073),
    [anon_sym_using] = ACTIONS(3073),
    [anon_sym_unsafe] = ACTIONS(3073),
    [anon_sym_static] = ACTIONS(3073),
    [anon_sym_LBRACK] = ACTIONS(3075),
    [anon_sym_LPAREN] = ACTIONS(3075),
    [anon_sym_return] = ACTIONS(3073),
    [anon_sym_namespace] = ACTIONS(3073),
    [anon_sym_class] = ACTIONS(3073),
    [anon_sym_ref] = ACTIONS(3073),
    [anon_sym_struct] = ACTIONS(3073),
    [anon_sym_enum] = ACTIONS(3073),
    [anon_sym_LBRACE] = ACTIONS(3075),
    [anon_sym_interface] = ACTIONS(3073),
    [anon_sym_delegate] = ACTIONS(3073),
    [anon_sym_record] = ACTIONS(3073),
    [anon_sym_abstract] = ACTIONS(3073),
    [anon_sym_async] = ACTIONS(3073),
    [anon_sym_const] = ACTIONS(3073),
    [anon_sym_file] = ACTIONS(3073),
    [anon_sym_fixed] = ACTIONS(3073),
    [anon_sym_internal] = ACTIONS(3073),
    [anon_sym_new] = ACTIONS(3073),
    [anon_sym_override] = ACTIONS(3073),
    [anon_sym_partial] = ACTIONS(3073),
    [anon_sym_private] = ACTIONS(3073),
    [anon_sym_protected] = ACTIONS(3073),
    [anon_sym_public] = ACTIONS(3073),
    [anon_sym_readonly] = ACTIONS(3073),
    [anon_sym_required] = ACTIONS(3073),
    [anon_sym_sealed] = ACTIONS(3073),
    [anon_sym_virtual] = ACTIONS(3073),
    [anon_sym_volatile] = ACTIONS(3073),
    [anon_sym_where] = ACTIONS(3073),
    [anon_sym_notnull] = ACTIONS(3073),
    [anon_sym_unmanaged] = ACTIONS(3073),
    [anon_sym_checked] = ACTIONS(3073),
    [anon_sym_BANG] = ACTIONS(3075),
    [anon_sym_TILDE] = ACTIONS(3075),
    [anon_sym_PLUS_PLUS] = ACTIONS(3075),
    [anon_sym_DASH_DASH] = ACTIONS(3075),
    [anon_sym_true] = ACTIONS(3073),
    [anon_sym_false] = ACTIONS(3073),
    [anon_sym_PLUS] = ACTIONS(3073),
    [anon_sym_DASH] = ACTIONS(3073),
    [anon_sym_STAR] = ACTIONS(3075),
    [anon_sym_CARET] = ACTIONS(3075),
    [anon_sym_AMP] = ACTIONS(3075),
    [anon_sym_this] = ACTIONS(3073),
    [anon_sym_scoped] = ACTIONS(3073),
    [anon_sym_var] = ACTIONS(3073),
    [sym_predefined_type] = ACTIONS(3073),
    [anon_sym_break] = ACTIONS(3073),
    [anon_sym_unchecked] = ACTIONS(3073),
    [anon_sym_continue] = ACTIONS(3073),
    [anon_sym_do] = ACTIONS(3073),
    [anon_sym_while] = ACTIONS(3073),
    [anon_sym_for] = ACTIONS(3073),
    [anon_sym_lock] = ACTIONS(3073),
    [anon_sym_yield] = ACTIONS(3073),
    [anon_sym_switch] = ACTIONS(3073),
    [anon_sym_default] = ACTIONS(3073),
    [anon_sym_throw] = ACTIONS(3073),
    [anon_sym_try] = ACTIONS(3073),
    [anon_sym_when] = ACTIONS(3073),
    [anon_sym_await] = ACTIONS(3073),
    [anon_sym_foreach] = ACTIONS(3073),
    [anon_sym_goto] = ACTIONS(3073),
    [anon_sym_if] = ACTIONS(3073),
    [anon_sym_else] = ACTIONS(3073),
    [anon_sym_DOT_DOT] = ACTIONS(3075),
    [anon_sym_from] = ACTIONS(3073),
    [anon_sym_into] = ACTIONS(3073),
    [anon_sym_join] = ACTIONS(3073),
    [anon_sym_on] = ACTIONS(3073),
    [anon_sym_equals] = ACTIONS(3073),
    [anon_sym_let] = ACTIONS(3073),
    [anon_sym_orderby] = ACTIONS(3073),
    [anon_sym_ascending] = ACTIONS(3073),
    [anon_sym_descending] = ACTIONS(3073),
    [anon_sym_group] = ACTIONS(3073),
    [anon_sym_by] = ACTIONS(3073),
    [anon_sym_select] = ACTIONS(3073),
    [anon_sym_DQUOTE] = ACTIONS(3073),
    [anon_sym_stackalloc] = ACTIONS(3073),
    [anon_sym_sizeof] = ACTIONS(3073),
    [anon_sym_typeof] = ACTIONS(3073),
    [anon_sym___makeref] = ACTIONS(3073),
    [anon_sym___reftype] = ACTIONS(3073),
    [anon_sym___refvalue] = ACTIONS(3073),
    [sym_null_literal] = ACTIONS(3073),
    [anon_sym_SQUOTE] = ACTIONS(3075),
    [sym_integer_literal] = ACTIONS(3073),
    [sym_real_literal] = ACTIONS(3075),
    [sym_verbatim_string_literal] = ACTIONS(3075),
    [sym_raw_string_literal] = ACTIONS(3075),
    [aux_sym_preproc_if_token1] = ACTIONS(3075),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3075),
    [sym_interpolation_verbatim_start] = ACTIONS(3075),
    [sym_interpolation_raw_start] = ACTIONS(3075),
  },
  [2450] = {
    [sym_catch_clause] = STATE(2642),
    [sym_finally_clause] = STATE(2695),
    [sym_preproc_region] = STATE(2450),
    [sym_preproc_endregion] = STATE(2450),
    [sym_preproc_line] = STATE(2450),
    [sym_preproc_pragma] = STATE(2450),
    [sym_preproc_nullable] = STATE(2450),
    [sym_preproc_error] = STATE(2450),
    [sym_preproc_define] = STATE(2450),
    [sym_preproc_undef] = STATE(2450),
    [aux_sym_try_statement_repeat1] = STATE(2479),
    [sym__identifier_token] = ACTIONS(2945),
    [anon_sym_extern] = ACTIONS(2945),
    [anon_sym_alias] = ACTIONS(2945),
    [anon_sym_SEMI] = ACTIONS(2947),
    [anon_sym_global] = ACTIONS(2945),
    [anon_sym_using] = ACTIONS(2945),
    [anon_sym_unsafe] = ACTIONS(2945),
    [anon_sym_static] = ACTIONS(2945),
    [anon_sym_LBRACK] = ACTIONS(2947),
    [anon_sym_LPAREN] = ACTIONS(2947),
    [anon_sym_return] = ACTIONS(2945),
    [anon_sym_ref] = ACTIONS(2945),
    [anon_sym_LBRACE] = ACTIONS(2947),
    [anon_sym_RBRACE] = ACTIONS(2947),
    [anon_sym_delegate] = ACTIONS(2945),
    [anon_sym_abstract] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(2945),
    [anon_sym_const] = ACTIONS(2945),
    [anon_sym_file] = ACTIONS(2945),
    [anon_sym_fixed] = ACTIONS(2945),
    [anon_sym_internal] = ACTIONS(2945),
    [anon_sym_new] = ACTIONS(2945),
    [anon_sym_override] = ACTIONS(2945),
    [anon_sym_partial] = ACTIONS(2945),
    [anon_sym_private] = ACTIONS(2945),
    [anon_sym_protected] = ACTIONS(2945),
    [anon_sym_public] = ACTIONS(2945),
    [anon_sym_readonly] = ACTIONS(2945),
    [anon_sym_required] = ACTIONS(2945),
    [anon_sym_sealed] = ACTIONS(2945),
    [anon_sym_virtual] = ACTIONS(2945),
    [anon_sym_volatile] = ACTIONS(2945),
    [anon_sym_where] = ACTIONS(2945),
    [anon_sym_notnull] = ACTIONS(2945),
    [anon_sym_unmanaged] = ACTIONS(2945),
    [anon_sym_checked] = ACTIONS(2945),
    [anon_sym_BANG] = ACTIONS(2947),
    [anon_sym_TILDE] = ACTIONS(2947),
    [anon_sym_PLUS_PLUS] = ACTIONS(2947),
    [anon_sym_DASH_DASH] = ACTIONS(2947),
    [anon_sym_true] = ACTIONS(2945),
    [anon_sym_false] = ACTIONS(2945),
    [anon_sym_PLUS] = ACTIONS(2945),
    [anon_sym_DASH] = ACTIONS(2945),
    [anon_sym_STAR] = ACTIONS(2947),
    [anon_sym_CARET] = ACTIONS(2947),
    [anon_sym_AMP] = ACTIONS(2947),
    [anon_sym_this] = ACTIONS(2945),
    [anon_sym_scoped] = ACTIONS(2945),
    [anon_sym_var] = ACTIONS(2945),
    [sym_predefined_type] = ACTIONS(2945),
    [anon_sym_break] = ACTIONS(2945),
    [anon_sym_unchecked] = ACTIONS(2945),
    [anon_sym_continue] = ACTIONS(2945),
    [anon_sym_do] = ACTIONS(2945),
    [anon_sym_while] = ACTIONS(2945),
    [anon_sym_for] = ACTIONS(2945),
    [anon_sym_lock] = ACTIONS(2945),
    [anon_sym_yield] = ACTIONS(2945),
    [anon_sym_switch] = ACTIONS(2945),
    [anon_sym_case] = ACTIONS(2945),
    [anon_sym_default] = ACTIONS(2945),
    [anon_sym_throw] = ACTIONS(2945),
    [anon_sym_try] = ACTIONS(2945),
    [anon_sym_catch] = ACTIONS(3946),
    [anon_sym_when] = ACTIONS(2945),
    [anon_sym_finally] = ACTIONS(3948),
    [anon_sym_await] = ACTIONS(2945),
    [anon_sym_foreach] = ACTIONS(2945),
    [anon_sym_goto] = ACTIONS(2945),
    [anon_sym_if] = ACTIONS(2945),
    [anon_sym_else] = ACTIONS(2945),
    [anon_sym_DOT_DOT] = ACTIONS(2947),
    [anon_sym_from] = ACTIONS(2945),
    [anon_sym_into] = ACTIONS(2945),
    [anon_sym_join] = ACTIONS(2945),
    [anon_sym_on] = ACTIONS(2945),
    [anon_sym_equals] = ACTIONS(2945),
    [anon_sym_let] = ACTIONS(2945),
    [anon_sym_orderby] = ACTIONS(2945),
    [anon_sym_ascending] = ACTIONS(2945),
    [anon_sym_descending] = ACTIONS(2945),
    [anon_sym_group] = ACTIONS(2945),
    [anon_sym_by] = ACTIONS(2945),
    [anon_sym_select] = ACTIONS(2945),
    [anon_sym_DQUOTE] = ACTIONS(2945),
    [anon_sym_stackalloc] = ACTIONS(2945),
    [anon_sym_sizeof] = ACTIONS(2945),
    [anon_sym_typeof] = ACTIONS(2945),
    [anon_sym___makeref] = ACTIONS(2945),
    [anon_sym___reftype] = ACTIONS(2945),
    [anon_sym___refvalue] = ACTIONS(2945),
    [sym_null_literal] = ACTIONS(2945),
    [anon_sym_SQUOTE] = ACTIONS(2947),
    [sym_integer_literal] = ACTIONS(2945),
    [sym_real_literal] = ACTIONS(2947),
    [sym_verbatim_string_literal] = ACTIONS(2947),
    [sym_raw_string_literal] = ACTIONS(2947),
    [aux_sym_preproc_if_token1] = ACTIONS(2947),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(2947),
    [sym_interpolation_verbatim_start] = ACTIONS(2947),
    [sym_interpolation_raw_start] = ACTIONS(2947),
  },
  [2451] = {
    [sym_preproc_region] = STATE(2451),
    [sym_preproc_endregion] = STATE(2451),
    [sym_preproc_line] = STATE(2451),
    [sym_preproc_pragma] = STATE(2451),
    [sym_preproc_nullable] = STATE(2451),
    [sym_preproc_error] = STATE(2451),
    [sym_preproc_define] = STATE(2451),
    [sym_preproc_undef] = STATE(2451),
    [ts_builtin_sym_end] = ACTIONS(3071),
    [sym__identifier_token] = ACTIONS(3069),
    [anon_sym_extern] = ACTIONS(3069),
    [anon_sym_alias] = ACTIONS(3069),
    [anon_sym_SEMI] = ACTIONS(3071),
    [anon_sym_global] = ACTIONS(3069),
    [anon_sym_using] = ACTIONS(3069),
    [anon_sym_unsafe] = ACTIONS(3069),
    [anon_sym_static] = ACTIONS(3069),
    [anon_sym_LBRACK] = ACTIONS(3071),
    [anon_sym_LPAREN] = ACTIONS(3071),
    [anon_sym_return] = ACTIONS(3069),
    [anon_sym_namespace] = ACTIONS(3069),
    [anon_sym_class] = ACTIONS(3069),
    [anon_sym_ref] = ACTIONS(3069),
    [anon_sym_struct] = ACTIONS(3069),
    [anon_sym_enum] = ACTIONS(3069),
    [anon_sym_LBRACE] = ACTIONS(3071),
    [anon_sym_interface] = ACTIONS(3069),
    [anon_sym_delegate] = ACTIONS(3069),
    [anon_sym_record] = ACTIONS(3069),
    [anon_sym_abstract] = ACTIONS(3069),
    [anon_sym_async] = ACTIONS(3069),
    [anon_sym_const] = ACTIONS(3069),
    [anon_sym_file] = ACTIONS(3069),
    [anon_sym_fixed] = ACTIONS(3069),
    [anon_sym_internal] = ACTIONS(3069),
    [anon_sym_new] = ACTIONS(3069),
    [anon_sym_override] = ACTIONS(3069),
    [anon_sym_partial] = ACTIONS(3069),
    [anon_sym_private] = ACTIONS(3069),
    [anon_sym_protected] = ACTIONS(3069),
    [anon_sym_public] = ACTIONS(3069),
    [anon_sym_readonly] = ACTIONS(3069),
    [anon_sym_required] = ACTIONS(3069),
    [anon_sym_sealed] = ACTIONS(3069),
    [anon_sym_virtual] = ACTIONS(3069),
    [anon_sym_volatile] = ACTIONS(3069),
    [anon_sym_where] = ACTIONS(3069),
    [anon_sym_notnull] = ACTIONS(3069),
    [anon_sym_unmanaged] = ACTIONS(3069),
    [anon_sym_checked] = ACTIONS(3069),
    [anon_sym_BANG] = ACTIONS(3071),
    [anon_sym_TILDE] = ACTIONS(3071),
    [anon_sym_PLUS_PLUS] = ACTIONS(3071),
    [anon_sym_DASH_DASH] = ACTIONS(3071),
    [anon_sym_true] = ACTIONS(3069),
    [anon_sym_false] = ACTIONS(3069),
    [anon_sym_PLUS] = ACTIONS(3069),
    [anon_sym_DASH] = ACTIONS(3069),
    [anon_sym_STAR] = ACTIONS(3071),
    [anon_sym_CARET] = ACTIONS(3071),
    [anon_sym_AMP] = ACTIONS(3071),
    [anon_sym_this] = ACTIONS(3069),
    [anon_sym_scoped] = ACTIONS(3069),
    [anon_sym_var] = ACTIONS(3069),
    [sym_predefined_type] = ACTIONS(3069),
    [anon_sym_break] = ACTIONS(3069),
    [anon_sym_unchecked] = ACTIONS(3069),
    [anon_sym_continue] = ACTIONS(3069),
    [anon_sym_do] = ACTIONS(3069),
    [anon_sym_while] = ACTIONS(3069),
    [anon_sym_for] = ACTIONS(3069),
    [anon_sym_lock] = ACTIONS(3069),
    [anon_sym_yield] = ACTIONS(3069),
    [anon_sym_switch] = ACTIONS(3069),
    [anon_sym_default] = ACTIONS(3069),
    [anon_sym_throw] = ACTIONS(3069),
    [anon_sym_try] = ACTIONS(3069),
    [anon_sym_when] = ACTIONS(3069),
    [anon_sym_await] = ACTIONS(3069),
    [anon_sym_foreach] = ACTIONS(3069),
    [anon_sym_goto] = ACTIONS(3069),
    [anon_sym_if] = ACTIONS(3069),
    [anon_sym_else] = ACTIONS(3069),
    [anon_sym_DOT_DOT] = ACTIONS(3071),
    [anon_sym_from] = ACTIONS(3069),
    [anon_sym_into] = ACTIONS(3069),
    [anon_sym_join] = ACTIONS(3069),
    [anon_sym_on] = ACTIONS(3069),
    [anon_sym_equals] = ACTIONS(3069),
    [anon_sym_let] = ACTIONS(3069),
    [anon_sym_orderby] = ACTIONS(3069),
    [anon_sym_ascending] = ACTIONS(3069),
    [anon_sym_descending] = ACTIONS(3069),
    [anon_sym_group] = ACTIONS(3069),
    [anon_sym_by] = ACTIONS(3069),
    [anon_sym_select] = ACTIONS(3069),
    [anon_sym_DQUOTE] = ACTIONS(3069),
    [anon_sym_stackalloc] = ACTIONS(3069),
    [anon_sym_sizeof] = ACTIONS(3069),
    [anon_sym_typeof] = ACTIONS(3069),
    [anon_sym___makeref] = ACTIONS(3069),
    [anon_sym___reftype] = ACTIONS(3069),
    [anon_sym___refvalue] = ACTIONS(3069),
    [sym_null_literal] = ACTIONS(3069),
    [anon_sym_SQUOTE] = ACTIONS(3071),
    [sym_integer_literal] = ACTIONS(3069),
    [sym_real_literal] = ACTIONS(3071),
    [sym_verbatim_string_literal] = ACTIONS(3071),
    [sym_raw_string_literal] = ACTIONS(3071),
    [aux_sym_preproc_if_token1] = ACTIONS(3071),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3071),
    [sym_interpolation_verbatim_start] = ACTIONS(3071),
    [sym_interpolation_raw_start] = ACTIONS(3071),
  },
  [2452] = {
    [sym_preproc_region] = STATE(2452),
    [sym_preproc_endregion] = STATE(2452),
    [sym_preproc_line] = STATE(2452),
    [sym_preproc_pragma] = STATE(2452),
    [sym_preproc_nullable] = STATE(2452),
    [sym_preproc_error] = STATE(2452),
    [sym_preproc_define] = STATE(2452),
    [sym_preproc_undef] = STATE(2452),
    [ts_builtin_sym_end] = ACTIONS(3063),
    [sym__identifier_token] = ACTIONS(3061),
    [anon_sym_extern] = ACTIONS(3061),
    [anon_sym_alias] = ACTIONS(3061),
    [anon_sym_SEMI] = ACTIONS(3063),
    [anon_sym_global] = ACTIONS(3061),
    [anon_sym_using] = ACTIONS(3061),
    [anon_sym_unsafe] = ACTIONS(3061),
    [anon_sym_static] = ACTIONS(3061),
    [anon_sym_LBRACK] = ACTIONS(3063),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_return] = ACTIONS(3061),
    [anon_sym_namespace] = ACTIONS(3061),
    [anon_sym_class] = ACTIONS(3061),
    [anon_sym_ref] = ACTIONS(3061),
    [anon_sym_struct] = ACTIONS(3061),
    [anon_sym_enum] = ACTIONS(3061),
    [anon_sym_LBRACE] = ACTIONS(3063),
    [anon_sym_interface] = ACTIONS(3061),
    [anon_sym_delegate] = ACTIONS(3061),
    [anon_sym_record] = ACTIONS(3061),
    [anon_sym_abstract] = ACTIONS(3061),
    [anon_sym_async] = ACTIONS(3061),
    [anon_sym_const] = ACTIONS(3061),
    [anon_sym_file] = ACTIONS(3061),
    [anon_sym_fixed] = ACTIONS(3061),
    [anon_sym_internal] = ACTIONS(3061),
    [anon_sym_new] = ACTIONS(3061),
    [anon_sym_override] = ACTIONS(3061),
    [anon_sym_partial] = ACTIONS(3061),
    [anon_sym_private] = ACTIONS(3061),
    [anon_sym_protected] = ACTIONS(3061),
    [anon_sym_public] = ACTIONS(3061),
    [anon_sym_readonly] = ACTIONS(3061),
    [anon_sym_required] = ACTIONS(3061),
    [anon_sym_sealed] = ACTIONS(3061),
    [anon_sym_virtual] = ACTIONS(3061),
    [anon_sym_volatile] = ACTIONS(3061),
    [anon_sym_where] = ACTIONS(3061),
    [anon_sym_notnull] = ACTIONS(3061),
    [anon_sym_unmanaged] = ACTIONS(3061),
    [anon_sym_checked] = ACTIONS(3061),
    [anon_sym_BANG] = ACTIONS(3063),
    [anon_sym_TILDE] = ACTIONS(3063),
    [anon_sym_PLUS_PLUS] = ACTIONS(3063),
    [anon_sym_DASH_DASH] = ACTIONS(3063),
    [anon_sym_true] = ACTIONS(3061),
    [anon_sym_false] = ACTIONS(3061),
    [anon_sym_PLUS] = ACTIONS(3061),
    [anon_sym_DASH] = ACTIONS(3061),
    [anon_sym_STAR] = ACTIONS(3063),
    [anon_sym_CARET] = ACTIONS(3063),
    [anon_sym_AMP] = ACTIONS(3063),
    [anon_sym_this] = ACTIONS(3061),
    [anon_sym_scoped] = ACTIONS(3061),
    [anon_sym_var] = ACTIONS(3061),
    [sym_predefined_type] = ACTIONS(3061),
    [anon_sym_break] = ACTIONS(3061),
    [anon_sym_unchecked] = ACTIONS(3061),
    [anon_sym_continue] = ACTIONS(3061),
    [anon_sym_do] = ACTIONS(3061),
    [anon_sym_while] = ACTIONS(3061),
    [anon_sym_for] = ACTIONS(3061),
    [anon_sym_lock] = ACTIONS(3061),
    [anon_sym_yield] = ACTIONS(3061),
    [anon_sym_switch] = ACTIONS(3061),
    [anon_sym_default] = ACTIONS(3061),
    [anon_sym_throw] = ACTIONS(3061),
    [anon_sym_try] = ACTIONS(3061),
    [anon_sym_when] = ACTIONS(3061),
    [anon_sym_await] = ACTIONS(3061),
    [anon_sym_foreach] = ACTIONS(3061),
    [anon_sym_goto] = ACTIONS(3061),
    [anon_sym_if] = ACTIONS(3061),
    [anon_sym_else] = ACTIONS(3061),
    [anon_sym_DOT_DOT] = ACTIONS(3063),
    [anon_sym_from] = ACTIONS(3061),
    [anon_sym_into] = ACTIONS(3061),
    [anon_sym_join] = ACTIONS(3061),
    [anon_sym_on] = ACTIONS(3061),
    [anon_sym_equals] = ACTIONS(3061),
    [anon_sym_let] = ACTIONS(3061),
    [anon_sym_orderby] = ACTIONS(3061),
    [anon_sym_ascending] = ACTIONS(3061),
    [anon_sym_descending] = ACTIONS(3061),
    [anon_sym_group] = ACTIONS(3061),
    [anon_sym_by] = ACTIONS(3061),
    [anon_sym_select] = ACTIONS(3061),
    [anon_sym_DQUOTE] = ACTIONS(3061),
    [anon_sym_stackalloc] = ACTIONS(3061),
    [anon_sym_sizeof] = ACTIONS(3061),
    [anon_sym_typeof] = ACTIONS(3061),
    [anon_sym___makeref] = ACTIONS(3061),
    [anon_sym___reftype] = ACTIONS(3061),
    [anon_sym___refvalue] = ACTIONS(3061),
    [sym_null_literal] = ACTIONS(3061),
    [anon_sym_SQUOTE] = ACTIONS(3063),
    [sym_integer_literal] = ACTIONS(3061),
    [sym_real_literal] = ACTIONS(3063),
    [sym_verbatim_string_literal] = ACTIONS(3063),
    [sym_raw_string_literal] = ACTIONS(3063),
    [aux_sym_preproc_if_token1] = ACTIONS(3063),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3063),
    [sym_interpolation_verbatim_start] = ACTIONS(3063),
    [sym_interpolation_raw_start] = ACTIONS(3063),
  },
  [2453] = {
    [sym_preproc_region] = STATE(2453),
    [sym_preproc_endregion] = STATE(2453),
    [sym_preproc_line] = STATE(2453),
    [sym_preproc_pragma] = STATE(2453),
    [sym_preproc_nullable] = STATE(2453),
    [sym_preproc_error] = STATE(2453),
    [sym_preproc_define] = STATE(2453),
    [sym_preproc_undef] = STATE(2453),
    [ts_builtin_sym_end] = ACTIONS(3059),
    [sym__identifier_token] = ACTIONS(3057),
    [anon_sym_extern] = ACTIONS(3057),
    [anon_sym_alias] = ACTIONS(3057),
    [anon_sym_SEMI] = ACTIONS(3059),
    [anon_sym_global] = ACTIONS(3057),
    [anon_sym_using] = ACTIONS(3057),
    [anon_sym_unsafe] = ACTIONS(3057),
    [anon_sym_static] = ACTIONS(3057),
    [anon_sym_LBRACK] = ACTIONS(3059),
    [anon_sym_LPAREN] = ACTIONS(3059),
    [anon_sym_return] = ACTIONS(3057),
    [anon_sym_namespace] = ACTIONS(3057),
    [anon_sym_class] = ACTIONS(3057),
    [anon_sym_ref] = ACTIONS(3057),
    [anon_sym_struct] = ACTIONS(3057),
    [anon_sym_enum] = ACTIONS(3057),
    [anon_sym_LBRACE] = ACTIONS(3059),
    [anon_sym_interface] = ACTIONS(3057),
    [anon_sym_delegate] = ACTIONS(3057),
    [anon_sym_record] = ACTIONS(3057),
    [anon_sym_abstract] = ACTIONS(3057),
    [anon_sym_async] = ACTIONS(3057),
    [anon_sym_const] = ACTIONS(3057),
    [anon_sym_file] = ACTIONS(3057),
    [anon_sym_fixed] = ACTIONS(3057),
    [anon_sym_internal] = ACTIONS(3057),
    [anon_sym_new] = ACTIONS(3057),
    [anon_sym_override] = ACTIONS(3057),
    [anon_sym_partial] = ACTIONS(3057),
    [anon_sym_private] = ACTIONS(3057),
    [anon_sym_protected] = ACTIONS(3057),
    [anon_sym_public] = ACTIONS(3057),
    [anon_sym_readonly] = ACTIONS(3057),
    [anon_sym_required] = ACTIONS(3057),
    [anon_sym_sealed] = ACTIONS(3057),
    [anon_sym_virtual] = ACTIONS(3057),
    [anon_sym_volatile] = ACTIONS(3057),
    [anon_sym_where] = ACTIONS(3057),
    [anon_sym_notnull] = ACTIONS(3057),
    [anon_sym_unmanaged] = ACTIONS(3057),
    [anon_sym_checked] = ACTIONS(3057),
    [anon_sym_BANG] = ACTIONS(3059),
    [anon_sym_TILDE] = ACTIONS(3059),
    [anon_sym_PLUS_PLUS] = ACTIONS(3059),
    [anon_sym_DASH_DASH] = ACTIONS(3059),
    [anon_sym_true] = ACTIONS(3057),
    [anon_sym_false] = ACTIONS(3057),
    [anon_sym_PLUS] = ACTIONS(3057),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_STAR] = ACTIONS(3059),
    [anon_sym_CARET] = ACTIONS(3059),
    [anon_sym_AMP] = ACTIONS(3059),
    [anon_sym_this] = ACTIONS(3057),
    [anon_sym_scoped] = ACTIONS(3057),
    [anon_sym_var] = ACTIONS(3057),
    [sym_predefined_type] = ACTIONS(3057),
    [anon_sym_break] = ACTIONS(3057),
    [anon_sym_unchecked] = ACTIONS(3057),
    [anon_sym_continue] = ACTIONS(3057),
    [anon_sym_do] = ACTIONS(3057),
    [anon_sym_while] = ACTIONS(3057),
    [anon_sym_for] = ACTIONS(3057),
    [anon_sym_lock] = ACTIONS(3057),
    [anon_sym_yield] = ACTIONS(3057),
    [anon_sym_switch] = ACTIONS(3057),
    [anon_sym_default] = ACTIONS(3057),
    [anon_sym_throw] = ACTIONS(3057),
    [anon_sym_try] = ACTIONS(3057),
    [anon_sym_when] = ACTIONS(3057),
    [anon_sym_await] = ACTIONS(3057),
    [anon_sym_foreach] = ACTIONS(3057),
    [anon_sym_goto] = ACTIONS(3057),
    [anon_sym_if] = ACTIONS(3057),
    [anon_sym_else] = ACTIONS(3057),
    [anon_sym_DOT_DOT] = ACTIONS(3059),
    [anon_sym_from] = ACTIONS(3057),
    [anon_sym_into] = ACTIONS(3057),
    [anon_sym_join] = ACTIONS(3057),
    [anon_sym_on] = ACTIONS(3057),
    [anon_sym_equals] = ACTIONS(3057),
    [anon_sym_let] = ACTIONS(3057),
    [anon_sym_orderby] = ACTIONS(3057),
    [anon_sym_ascending] = ACTIONS(3057),
    [anon_sym_descending] = ACTIONS(3057),
    [anon_sym_group] = ACTIONS(3057),
    [anon_sym_by] = ACTIONS(3057),
    [anon_sym_select] = ACTIONS(3057),
    [anon_sym_DQUOTE] = ACTIONS(3057),
    [anon_sym_stackalloc] = ACTIONS(3057),
    [anon_sym_sizeof] = ACTIONS(3057),
    [anon_sym_typeof] = ACTIONS(3057),
    [anon_sym___makeref] = ACTIONS(3057),
    [anon_sym___reftype] = ACTIONS(3057),
    [anon_sym___refvalue] = ACTIONS(3057),
    [sym_null_literal] = ACTIONS(3057),
    [anon_sym_SQUOTE] = ACTIONS(3059),
    [sym_integer_literal] = ACTIONS(3057),
    [sym_real_literal] = ACTIONS(3059),
    [sym_verbatim_string_literal] = ACTIONS(3059),
    [sym_raw_string_literal] = ACTIONS(3059),
    [aux_sym_preproc_if_token1] = ACTIONS(3059),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3059),
    [sym_interpolation_verbatim_start] = ACTIONS(3059),
    [sym_interpolation_raw_start] = ACTIONS(3059),
  },
  [2454] = {
    [sym_preproc_region] = STATE(2454),
    [sym_preproc_endregion] = STATE(2454),
    [sym_preproc_line] = STATE(2454),
    [sym_preproc_pragma] = STATE(2454),
    [sym_preproc_nullable] = STATE(2454),
    [sym_preproc_error] = STATE(2454),
    [sym_preproc_define] = STATE(2454),
    [sym_preproc_undef] = STATE(2454),
    [ts_builtin_sym_end] = ACTIONS(3055),
    [sym__identifier_token] = ACTIONS(3053),
    [anon_sym_extern] = ACTIONS(3053),
    [anon_sym_alias] = ACTIONS(3053),
    [anon_sym_SEMI] = ACTIONS(3055),
    [anon_sym_global] = ACTIONS(3053),
    [anon_sym_using] = ACTIONS(3053),
    [anon_sym_unsafe] = ACTIONS(3053),
    [anon_sym_static] = ACTIONS(3053),
    [anon_sym_LBRACK] = ACTIONS(3055),
    [anon_sym_LPAREN] = ACTIONS(3055),
    [anon_sym_return] = ACTIONS(3053),
    [anon_sym_namespace] = ACTIONS(3053),
    [anon_sym_class] = ACTIONS(3053),
    [anon_sym_ref] = ACTIONS(3053),
    [anon_sym_struct] = ACTIONS(3053),
    [anon_sym_enum] = ACTIONS(3053),
    [anon_sym_LBRACE] = ACTIONS(3055),
    [anon_sym_interface] = ACTIONS(3053),
    [anon_sym_delegate] = ACTIONS(3053),
    [anon_sym_record] = ACTIONS(3053),
    [anon_sym_abstract] = ACTIONS(3053),
    [anon_sym_async] = ACTIONS(3053),
    [anon_sym_const] = ACTIONS(3053),
    [anon_sym_file] = ACTIONS(3053),
    [anon_sym_fixed] = ACTIONS(3053),
    [anon_sym_internal] = ACTIONS(3053),
    [anon_sym_new] = ACTIONS(3053),
    [anon_sym_override] = ACTIONS(3053),
    [anon_sym_partial] = ACTIONS(3053),
    [anon_sym_private] = ACTIONS(3053),
    [anon_sym_protected] = ACTIONS(3053),
    [anon_sym_public] = ACTIONS(3053),
    [anon_sym_readonly] = ACTIONS(3053),
    [anon_sym_required] = ACTIONS(3053),
    [anon_sym_sealed] = ACTIONS(3053),
    [anon_sym_virtual] = ACTIONS(3053),
    [anon_sym_volatile] = ACTIONS(3053),
    [anon_sym_where] = ACTIONS(3053),
    [anon_sym_notnull] = ACTIONS(3053),
    [anon_sym_unmanaged] = ACTIONS(3053),
    [anon_sym_checked] = ACTIONS(3053),
    [anon_sym_BANG] = ACTIONS(3055),
    [anon_sym_TILDE] = ACTIONS(3055),
    [anon_sym_PLUS_PLUS] = ACTIONS(3055),
    [anon_sym_DASH_DASH] = ACTIONS(3055),
    [anon_sym_true] = ACTIONS(3053),
    [anon_sym_false] = ACTIONS(3053),
    [anon_sym_PLUS] = ACTIONS(3053),
    [anon_sym_DASH] = ACTIONS(3053),
    [anon_sym_STAR] = ACTIONS(3055),
    [anon_sym_CARET] = ACTIONS(3055),
    [anon_sym_AMP] = ACTIONS(3055),
    [anon_sym_this] = ACTIONS(3053),
    [anon_sym_scoped] = ACTIONS(3053),
    [anon_sym_var] = ACTIONS(3053),
    [sym_predefined_type] = ACTIONS(3053),
    [anon_sym_break] = ACTIONS(3053),
    [anon_sym_unchecked] = ACTIONS(3053),
    [anon_sym_continue] = ACTIONS(3053),
    [anon_sym_do] = ACTIONS(3053),
    [anon_sym_while] = ACTIONS(3053),
    [anon_sym_for] = ACTIONS(3053),
    [anon_sym_lock] = ACTIONS(3053),
    [anon_sym_yield] = ACTIONS(3053),
    [anon_sym_switch] = ACTIONS(3053),
    [anon_sym_default] = ACTIONS(3053),
    [anon_sym_throw] = ACTIONS(3053),
    [anon_sym_try] = ACTIONS(3053),
    [anon_sym_when] = ACTIONS(3053),
    [anon_sym_await] = ACTIONS(3053),
    [anon_sym_foreach] = ACTIONS(3053),
    [anon_sym_goto] = ACTIONS(3053),
    [anon_sym_if] = ACTIONS(3053),
    [anon_sym_else] = ACTIONS(3053),
    [anon_sym_DOT_DOT] = ACTIONS(3055),
    [anon_sym_from] = ACTIONS(3053),
    [anon_sym_into] = ACTIONS(3053),
    [anon_sym_join] = ACTIONS(3053),
    [anon_sym_on] = ACTIONS(3053),
    [anon_sym_equals] = ACTIONS(3053),
    [anon_sym_let] = ACTIONS(3053),
    [anon_sym_orderby] = ACTIONS(3053),
    [anon_sym_ascending] = ACTIONS(3053),
    [anon_sym_descending] = ACTIONS(3053),
    [anon_sym_group] = ACTIONS(3053),
    [anon_sym_by] = ACTIONS(3053),
    [anon_sym_select] = ACTIONS(3053),
    [anon_sym_DQUOTE] = ACTIONS(3053),
    [anon_sym_stackalloc] = ACTIONS(3053),
    [anon_sym_sizeof] = ACTIONS(3053),
    [anon_sym_typeof] = ACTIONS(3053),
    [anon_sym___makeref] = ACTIONS(3053),
    [anon_sym___reftype] = ACTIONS(3053),
    [anon_sym___refvalue] = ACTIONS(3053),
    [sym_null_literal] = ACTIONS(3053),
    [anon_sym_SQUOTE] = ACTIONS(3055),
    [sym_integer_literal] = ACTIONS(3053),
    [sym_real_literal] = ACTIONS(3055),
    [sym_verbatim_string_literal] = ACTIONS(3055),
    [sym_raw_string_literal] = ACTIONS(3055),
    [aux_sym_preproc_if_token1] = ACTIONS(3055),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3055),
    [sym_interpolation_verbatim_start] = ACTIONS(3055),
    [sym_interpolation_raw_start] = ACTIONS(3055),
  },
  [2455] = {
    [sym_preproc_region] = STATE(2455),
    [sym_preproc_endregion] = STATE(2455),
    [sym_preproc_line] = STATE(2455),
    [sym_preproc_pragma] = STATE(2455),
    [sym_preproc_nullable] = STATE(2455),
    [sym_preproc_error] = STATE(2455),
    [sym_preproc_define] = STATE(2455),
    [sym_preproc_undef] = STATE(2455),
    [ts_builtin_sym_end] = ACTIONS(3241),
    [sym__identifier_token] = ACTIONS(3239),
    [anon_sym_extern] = ACTIONS(3239),
    [anon_sym_alias] = ACTIONS(3239),
    [anon_sym_SEMI] = ACTIONS(3241),
    [anon_sym_global] = ACTIONS(3239),
    [anon_sym_using] = ACTIONS(3239),
    [anon_sym_unsafe] = ACTIONS(3239),
    [anon_sym_static] = ACTIONS(3239),
    [anon_sym_LBRACK] = ACTIONS(3241),
    [anon_sym_LPAREN] = ACTIONS(3241),
    [anon_sym_return] = ACTIONS(3239),
    [anon_sym_namespace] = ACTIONS(3239),
    [anon_sym_class] = ACTIONS(3239),
    [anon_sym_ref] = ACTIONS(3239),
    [anon_sym_struct] = ACTIONS(3239),
    [anon_sym_enum] = ACTIONS(3239),
    [anon_sym_LBRACE] = ACTIONS(3241),
    [anon_sym_interface] = ACTIONS(3239),
    [anon_sym_delegate] = ACTIONS(3239),
    [anon_sym_record] = ACTIONS(3239),
    [anon_sym_abstract] = ACTIONS(3239),
    [anon_sym_async] = ACTIONS(3239),
    [anon_sym_const] = ACTIONS(3239),
    [anon_sym_file] = ACTIONS(3239),
    [anon_sym_fixed] = ACTIONS(3239),
    [anon_sym_internal] = ACTIONS(3239),
    [anon_sym_new] = ACTIONS(3239),
    [anon_sym_override] = ACTIONS(3239),
    [anon_sym_partial] = ACTIONS(3239),
    [anon_sym_private] = ACTIONS(3239),
    [anon_sym_protected] = ACTIONS(3239),
    [anon_sym_public] = ACTIONS(3239),
    [anon_sym_readonly] = ACTIONS(3239),
    [anon_sym_required] = ACTIONS(3239),
    [anon_sym_sealed] = ACTIONS(3239),
    [anon_sym_virtual] = ACTIONS(3239),
    [anon_sym_volatile] = ACTIONS(3239),
    [anon_sym_where] = ACTIONS(3239),
    [anon_sym_notnull] = ACTIONS(3239),
    [anon_sym_unmanaged] = ACTIONS(3239),
    [anon_sym_checked] = ACTIONS(3239),
    [anon_sym_BANG] = ACTIONS(3241),
    [anon_sym_TILDE] = ACTIONS(3241),
    [anon_sym_PLUS_PLUS] = ACTIONS(3241),
    [anon_sym_DASH_DASH] = ACTIONS(3241),
    [anon_sym_true] = ACTIONS(3239),
    [anon_sym_false] = ACTIONS(3239),
    [anon_sym_PLUS] = ACTIONS(3239),
    [anon_sym_DASH] = ACTIONS(3239),
    [anon_sym_STAR] = ACTIONS(3241),
    [anon_sym_CARET] = ACTIONS(3241),
    [anon_sym_AMP] = ACTIONS(3241),
    [anon_sym_this] = ACTIONS(3239),
    [anon_sym_scoped] = ACTIONS(3239),
    [anon_sym_var] = ACTIONS(3239),
    [sym_predefined_type] = ACTIONS(3239),
    [anon_sym_break] = ACTIONS(3239),
    [anon_sym_unchecked] = ACTIONS(3239),
    [anon_sym_continue] = ACTIONS(3239),
    [anon_sym_do] = ACTIONS(3239),
    [anon_sym_while] = ACTIONS(3239),
    [anon_sym_for] = ACTIONS(3239),
    [anon_sym_lock] = ACTIONS(3239),
    [anon_sym_yield] = ACTIONS(3239),
    [anon_sym_switch] = ACTIONS(3239),
    [anon_sym_default] = ACTIONS(3239),
    [anon_sym_throw] = ACTIONS(3239),
    [anon_sym_try] = ACTIONS(3239),
    [anon_sym_when] = ACTIONS(3239),
    [anon_sym_await] = ACTIONS(3239),
    [anon_sym_foreach] = ACTIONS(3239),
    [anon_sym_goto] = ACTIONS(3239),
    [anon_sym_if] = ACTIONS(3239),
    [anon_sym_else] = ACTIONS(3239),
    [anon_sym_DOT_DOT] = ACTIONS(3241),
    [anon_sym_from] = ACTIONS(3239),
    [anon_sym_into] = ACTIONS(3239),
    [anon_sym_join] = ACTIONS(3239),
    [anon_sym_on] = ACTIONS(3239),
    [anon_sym_equals] = ACTIONS(3239),
    [anon_sym_let] = ACTIONS(3239),
    [anon_sym_orderby] = ACTIONS(3239),
    [anon_sym_ascending] = ACTIONS(3239),
    [anon_sym_descending] = ACTIONS(3239),
    [anon_sym_group] = ACTIONS(3239),
    [anon_sym_by] = ACTIONS(3239),
    [anon_sym_select] = ACTIONS(3239),
    [anon_sym_DQUOTE] = ACTIONS(3239),
    [anon_sym_stackalloc] = ACTIONS(3239),
    [anon_sym_sizeof] = ACTIONS(3239),
    [anon_sym_typeof] = ACTIONS(3239),
    [anon_sym___makeref] = ACTIONS(3239),
    [anon_sym___reftype] = ACTIONS(3239),
    [anon_sym___refvalue] = ACTIONS(3239),
    [sym_null_literal] = ACTIONS(3239),
    [anon_sym_SQUOTE] = ACTIONS(3241),
    [sym_integer_literal] = ACTIONS(3239),
    [sym_real_literal] = ACTIONS(3241),
    [sym_verbatim_string_literal] = ACTIONS(3241),
    [sym_raw_string_literal] = ACTIONS(3241),
    [aux_sym_preproc_if_token1] = ACTIONS(3241),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3241),
    [sym_interpolation_verbatim_start] = ACTIONS(3241),
    [sym_interpolation_raw_start] = ACTIONS(3241),
  },
  [2456] = {
    [sym_preproc_region] = STATE(2456),
    [sym_preproc_endregion] = STATE(2456),
    [sym_preproc_line] = STATE(2456),
    [sym_preproc_pragma] = STATE(2456),
    [sym_preproc_nullable] = STATE(2456),
    [sym_preproc_error] = STATE(2456),
    [sym_preproc_define] = STATE(2456),
    [sym_preproc_undef] = STATE(2456),
    [ts_builtin_sym_end] = ACTIONS(3337),
    [sym__identifier_token] = ACTIONS(3335),
    [anon_sym_extern] = ACTIONS(3335),
    [anon_sym_alias] = ACTIONS(3335),
    [anon_sym_SEMI] = ACTIONS(3337),
    [anon_sym_global] = ACTIONS(3335),
    [anon_sym_using] = ACTIONS(3335),
    [anon_sym_unsafe] = ACTIONS(3335),
    [anon_sym_static] = ACTIONS(3335),
    [anon_sym_LBRACK] = ACTIONS(3337),
    [anon_sym_LPAREN] = ACTIONS(3337),
    [anon_sym_return] = ACTIONS(3335),
    [anon_sym_namespace] = ACTIONS(3335),
    [anon_sym_class] = ACTIONS(3335),
    [anon_sym_ref] = ACTIONS(3335),
    [anon_sym_struct] = ACTIONS(3335),
    [anon_sym_enum] = ACTIONS(3335),
    [anon_sym_LBRACE] = ACTIONS(3337),
    [anon_sym_interface] = ACTIONS(3335),
    [anon_sym_delegate] = ACTIONS(3335),
    [anon_sym_record] = ACTIONS(3335),
    [anon_sym_abstract] = ACTIONS(3335),
    [anon_sym_async] = ACTIONS(3335),
    [anon_sym_const] = ACTIONS(3335),
    [anon_sym_file] = ACTIONS(3335),
    [anon_sym_fixed] = ACTIONS(3335),
    [anon_sym_internal] = ACTIONS(3335),
    [anon_sym_new] = ACTIONS(3335),
    [anon_sym_override] = ACTIONS(3335),
    [anon_sym_partial] = ACTIONS(3335),
    [anon_sym_private] = ACTIONS(3335),
    [anon_sym_protected] = ACTIONS(3335),
    [anon_sym_public] = ACTIONS(3335),
    [anon_sym_readonly] = ACTIONS(3335),
    [anon_sym_required] = ACTIONS(3335),
    [anon_sym_sealed] = ACTIONS(3335),
    [anon_sym_virtual] = ACTIONS(3335),
    [anon_sym_volatile] = ACTIONS(3335),
    [anon_sym_where] = ACTIONS(3335),
    [anon_sym_notnull] = ACTIONS(3335),
    [anon_sym_unmanaged] = ACTIONS(3335),
    [anon_sym_checked] = ACTIONS(3335),
    [anon_sym_BANG] = ACTIONS(3337),
    [anon_sym_TILDE] = ACTIONS(3337),
    [anon_sym_PLUS_PLUS] = ACTIONS(3337),
    [anon_sym_DASH_DASH] = ACTIONS(3337),
    [anon_sym_true] = ACTIONS(3335),
    [anon_sym_false] = ACTIONS(3335),
    [anon_sym_PLUS] = ACTIONS(3335),
    [anon_sym_DASH] = ACTIONS(3335),
    [anon_sym_STAR] = ACTIONS(3337),
    [anon_sym_CARET] = ACTIONS(3337),
    [anon_sym_AMP] = ACTIONS(3337),
    [anon_sym_this] = ACTIONS(3335),
    [anon_sym_scoped] = ACTIONS(3335),
    [anon_sym_var] = ACTIONS(3335),
    [sym_predefined_type] = ACTIONS(3335),
    [anon_sym_break] = ACTIONS(3335),
    [anon_sym_unchecked] = ACTIONS(3335),
    [anon_sym_continue] = ACTIONS(3335),
    [anon_sym_do] = ACTIONS(3335),
    [anon_sym_while] = ACTIONS(3335),
    [anon_sym_for] = ACTIONS(3335),
    [anon_sym_lock] = ACTIONS(3335),
    [anon_sym_yield] = ACTIONS(3335),
    [anon_sym_switch] = ACTIONS(3335),
    [anon_sym_default] = ACTIONS(3335),
    [anon_sym_throw] = ACTIONS(3335),
    [anon_sym_try] = ACTIONS(3335),
    [anon_sym_when] = ACTIONS(3335),
    [anon_sym_await] = ACTIONS(3335),
    [anon_sym_foreach] = ACTIONS(3335),
    [anon_sym_goto] = ACTIONS(3335),
    [anon_sym_if] = ACTIONS(3335),
    [anon_sym_else] = ACTIONS(3335),
    [anon_sym_DOT_DOT] = ACTIONS(3337),
    [anon_sym_from] = ACTIONS(3335),
    [anon_sym_into] = ACTIONS(3335),
    [anon_sym_join] = ACTIONS(3335),
    [anon_sym_on] = ACTIONS(3335),
    [anon_sym_equals] = ACTIONS(3335),
    [anon_sym_let] = ACTIONS(3335),
    [anon_sym_orderby] = ACTIONS(3335),
    [anon_sym_ascending] = ACTIONS(3335),
    [anon_sym_descending] = ACTIONS(3335),
    [anon_sym_group] = ACTIONS(3335),
    [anon_sym_by] = ACTIONS(3335),
    [anon_sym_select] = ACTIONS(3335),
    [anon_sym_DQUOTE] = ACTIONS(3335),
    [anon_sym_stackalloc] = ACTIONS(3335),
    [anon_sym_sizeof] = ACTIONS(3335),
    [anon_sym_typeof] = ACTIONS(3335),
    [anon_sym___makeref] = ACTIONS(3335),
    [anon_sym___reftype] = ACTIONS(3335),
    [anon_sym___refvalue] = ACTIONS(3335),
    [sym_null_literal] = ACTIONS(3335),
    [anon_sym_SQUOTE] = ACTIONS(3337),
    [sym_integer_literal] = ACTIONS(3335),
    [sym_real_literal] = ACTIONS(3337),
    [sym_verbatim_string_literal] = ACTIONS(3337),
    [sym_raw_string_literal] = ACTIONS(3337),
    [aux_sym_preproc_if_token1] = ACTIONS(3337),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3337),
    [sym_interpolation_verbatim_start] = ACTIONS(3337),
    [sym_interpolation_raw_start] = ACTIONS(3337),
  },
  [2457] = {
    [sym_preproc_region] = STATE(2457),
    [sym_preproc_endregion] = STATE(2457),
    [sym_preproc_line] = STATE(2457),
    [sym_preproc_pragma] = STATE(2457),
    [sym_preproc_nullable] = STATE(2457),
    [sym_preproc_error] = STATE(2457),
    [sym_preproc_define] = STATE(2457),
    [sym_preproc_undef] = STATE(2457),
    [ts_builtin_sym_end] = ACTIONS(3293),
    [sym__identifier_token] = ACTIONS(3291),
    [anon_sym_extern] = ACTIONS(3291),
    [anon_sym_alias] = ACTIONS(3291),
    [anon_sym_SEMI] = ACTIONS(3293),
    [anon_sym_global] = ACTIONS(3291),
    [anon_sym_using] = ACTIONS(3291),
    [anon_sym_unsafe] = ACTIONS(3291),
    [anon_sym_static] = ACTIONS(3291),
    [anon_sym_LBRACK] = ACTIONS(3293),
    [anon_sym_LPAREN] = ACTIONS(3293),
    [anon_sym_return] = ACTIONS(3291),
    [anon_sym_namespace] = ACTIONS(3291),
    [anon_sym_class] = ACTIONS(3291),
    [anon_sym_ref] = ACTIONS(3291),
    [anon_sym_struct] = ACTIONS(3291),
    [anon_sym_enum] = ACTIONS(3291),
    [anon_sym_LBRACE] = ACTIONS(3293),
    [anon_sym_interface] = ACTIONS(3291),
    [anon_sym_delegate] = ACTIONS(3291),
    [anon_sym_record] = ACTIONS(3291),
    [anon_sym_abstract] = ACTIONS(3291),
    [anon_sym_async] = ACTIONS(3291),
    [anon_sym_const] = ACTIONS(3291),
    [anon_sym_file] = ACTIONS(3291),
    [anon_sym_fixed] = ACTIONS(3291),
    [anon_sym_internal] = ACTIONS(3291),
    [anon_sym_new] = ACTIONS(3291),
    [anon_sym_override] = ACTIONS(3291),
    [anon_sym_partial] = ACTIONS(3291),
    [anon_sym_private] = ACTIONS(3291),
    [anon_sym_protected] = ACTIONS(3291),
    [anon_sym_public] = ACTIONS(3291),
    [anon_sym_readonly] = ACTIONS(3291),
    [anon_sym_required] = ACTIONS(3291),
    [anon_sym_sealed] = ACTIONS(3291),
    [anon_sym_virtual] = ACTIONS(3291),
    [anon_sym_volatile] = ACTIONS(3291),
    [anon_sym_where] = ACTIONS(3291),
    [anon_sym_notnull] = ACTIONS(3291),
    [anon_sym_unmanaged] = ACTIONS(3291),
    [anon_sym_checked] = ACTIONS(3291),
    [anon_sym_BANG] = ACTIONS(3293),
    [anon_sym_TILDE] = ACTIONS(3293),
    [anon_sym_PLUS_PLUS] = ACTIONS(3293),
    [anon_sym_DASH_DASH] = ACTIONS(3293),
    [anon_sym_true] = ACTIONS(3291),
    [anon_sym_false] = ACTIONS(3291),
    [anon_sym_PLUS] = ACTIONS(3291),
    [anon_sym_DASH] = ACTIONS(3291),
    [anon_sym_STAR] = ACTIONS(3293),
    [anon_sym_CARET] = ACTIONS(3293),
    [anon_sym_AMP] = ACTIONS(3293),
    [anon_sym_this] = ACTIONS(3291),
    [anon_sym_scoped] = ACTIONS(3291),
    [anon_sym_var] = ACTIONS(3291),
    [sym_predefined_type] = ACTIONS(3291),
    [anon_sym_break] = ACTIONS(3291),
    [anon_sym_unchecked] = ACTIONS(3291),
    [anon_sym_continue] = ACTIONS(3291),
    [anon_sym_do] = ACTIONS(3291),
    [anon_sym_while] = ACTIONS(3291),
    [anon_sym_for] = ACTIONS(3291),
    [anon_sym_lock] = ACTIONS(3291),
    [anon_sym_yield] = ACTIONS(3291),
    [anon_sym_switch] = ACTIONS(3291),
    [anon_sym_default] = ACTIONS(3291),
    [anon_sym_throw] = ACTIONS(3291),
    [anon_sym_try] = ACTIONS(3291),
    [anon_sym_when] = ACTIONS(3291),
    [anon_sym_await] = ACTIONS(3291),
    [anon_sym_foreach] = ACTIONS(3291),
    [anon_sym_goto] = ACTIONS(3291),
    [anon_sym_if] = ACTIONS(3291),
    [anon_sym_else] = ACTIONS(3291),
    [anon_sym_DOT_DOT] = ACTIONS(3293),
    [anon_sym_from] = ACTIONS(3291),
    [anon_sym_into] = ACTIONS(3291),
    [anon_sym_join] = ACTIONS(3291),
    [anon_sym_on] = ACTIONS(3291),
    [anon_sym_equals] = ACTIONS(3291),
    [anon_sym_let] = ACTIONS(3291),
    [anon_sym_orderby] = ACTIONS(3291),
    [anon_sym_ascending] = ACTIONS(3291),
    [anon_sym_descending] = ACTIONS(3291),
    [anon_sym_group] = ACTIONS(3291),
    [anon_sym_by] = ACTIONS(3291),
    [anon_sym_select] = ACTIONS(3291),
    [anon_sym_DQUOTE] = ACTIONS(3291),
    [anon_sym_stackalloc] = ACTIONS(3291),
    [anon_sym_sizeof] = ACTIONS(3291),
    [anon_sym_typeof] = ACTIONS(3291),
    [anon_sym___makeref] = ACTIONS(3291),
    [anon_sym___reftype] = ACTIONS(3291),
    [anon_sym___refvalue] = ACTIONS(3291),
    [sym_null_literal] = ACTIONS(3291),
    [anon_sym_SQUOTE] = ACTIONS(3293),
    [sym_integer_literal] = ACTIONS(3291),
    [sym_real_literal] = ACTIONS(3293),
    [sym_verbatim_string_literal] = ACTIONS(3293),
    [sym_raw_string_literal] = ACTIONS(3293),
    [aux_sym_preproc_if_token1] = ACTIONS(3293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3293),
    [sym_interpolation_verbatim_start] = ACTIONS(3293),
    [sym_interpolation_raw_start] = ACTIONS(3293),
  },
  [2458] = {
    [sym_preproc_region] = STATE(2458),
    [sym_preproc_endregion] = STATE(2458),
    [sym_preproc_line] = STATE(2458),
    [sym_preproc_pragma] = STATE(2458),
    [sym_preproc_nullable] = STATE(2458),
    [sym_preproc_error] = STATE(2458),
    [sym_preproc_define] = STATE(2458),
    [sym_preproc_undef] = STATE(2458),
    [ts_builtin_sym_end] = ACTIONS(3087),
    [sym__identifier_token] = ACTIONS(3085),
    [anon_sym_extern] = ACTIONS(3085),
    [anon_sym_alias] = ACTIONS(3085),
    [anon_sym_SEMI] = ACTIONS(3087),
    [anon_sym_global] = ACTIONS(3085),
    [anon_sym_using] = ACTIONS(3085),
    [anon_sym_unsafe] = ACTIONS(3085),
    [anon_sym_static] = ACTIONS(3085),
    [anon_sym_LBRACK] = ACTIONS(3087),
    [anon_sym_LPAREN] = ACTIONS(3087),
    [anon_sym_return] = ACTIONS(3085),
    [anon_sym_namespace] = ACTIONS(3085),
    [anon_sym_class] = ACTIONS(3085),
    [anon_sym_ref] = ACTIONS(3085),
    [anon_sym_struct] = ACTIONS(3085),
    [anon_sym_enum] = ACTIONS(3085),
    [anon_sym_LBRACE] = ACTIONS(3087),
    [anon_sym_interface] = ACTIONS(3085),
    [anon_sym_delegate] = ACTIONS(3085),
    [anon_sym_record] = ACTIONS(3085),
    [anon_sym_abstract] = ACTIONS(3085),
    [anon_sym_async] = ACTIONS(3085),
    [anon_sym_const] = ACTIONS(3085),
    [anon_sym_file] = ACTIONS(3085),
    [anon_sym_fixed] = ACTIONS(3085),
    [anon_sym_internal] = ACTIONS(3085),
    [anon_sym_new] = ACTIONS(3085),
    [anon_sym_override] = ACTIONS(3085),
    [anon_sym_partial] = ACTIONS(3085),
    [anon_sym_private] = ACTIONS(3085),
    [anon_sym_protected] = ACTIONS(3085),
    [anon_sym_public] = ACTIONS(3085),
    [anon_sym_readonly] = ACTIONS(3085),
    [anon_sym_required] = ACTIONS(3085),
    [anon_sym_sealed] = ACTIONS(3085),
    [anon_sym_virtual] = ACTIONS(3085),
    [anon_sym_volatile] = ACTIONS(3085),
    [anon_sym_where] = ACTIONS(3085),
    [anon_sym_notnull] = ACTIONS(3085),
    [anon_sym_unmanaged] = ACTIONS(3085),
    [anon_sym_checked] = ACTIONS(3085),
    [anon_sym_BANG] = ACTIONS(3087),
    [anon_sym_TILDE] = ACTIONS(3087),
    [anon_sym_PLUS_PLUS] = ACTIONS(3087),
    [anon_sym_DASH_DASH] = ACTIONS(3087),
    [anon_sym_true] = ACTIONS(3085),
    [anon_sym_false] = ACTIONS(3085),
    [anon_sym_PLUS] = ACTIONS(3085),
    [anon_sym_DASH] = ACTIONS(3085),
    [anon_sym_STAR] = ACTIONS(3087),
    [anon_sym_CARET] = ACTIONS(3087),
    [anon_sym_AMP] = ACTIONS(3087),
    [anon_sym_this] = ACTIONS(3085),
    [anon_sym_scoped] = ACTIONS(3085),
    [anon_sym_var] = ACTIONS(3085),
    [sym_predefined_type] = ACTIONS(3085),
    [anon_sym_break] = ACTIONS(3085),
    [anon_sym_unchecked] = ACTIONS(3085),
    [anon_sym_continue] = ACTIONS(3085),
    [anon_sym_do] = ACTIONS(3085),
    [anon_sym_while] = ACTIONS(3085),
    [anon_sym_for] = ACTIONS(3085),
    [anon_sym_lock] = ACTIONS(3085),
    [anon_sym_yield] = ACTIONS(3085),
    [anon_sym_switch] = ACTIONS(3085),
    [anon_sym_default] = ACTIONS(3085),
    [anon_sym_throw] = ACTIONS(3085),
    [anon_sym_try] = ACTIONS(3085),
    [anon_sym_when] = ACTIONS(3085),
    [anon_sym_await] = ACTIONS(3085),
    [anon_sym_foreach] = ACTIONS(3085),
    [anon_sym_goto] = ACTIONS(3085),
    [anon_sym_if] = ACTIONS(3085),
    [anon_sym_else] = ACTIONS(3085),
    [anon_sym_DOT_DOT] = ACTIONS(3087),
    [anon_sym_from] = ACTIONS(3085),
    [anon_sym_into] = ACTIONS(3085),
    [anon_sym_join] = ACTIONS(3085),
    [anon_sym_on] = ACTIONS(3085),
    [anon_sym_equals] = ACTIONS(3085),
    [anon_sym_let] = ACTIONS(3085),
    [anon_sym_orderby] = ACTIONS(3085),
    [anon_sym_ascending] = ACTIONS(3085),
    [anon_sym_descending] = ACTIONS(3085),
    [anon_sym_group] = ACTIONS(3085),
    [anon_sym_by] = ACTIONS(3085),
    [anon_sym_select] = ACTIONS(3085),
    [anon_sym_DQUOTE] = ACTIONS(3085),
    [anon_sym_stackalloc] = ACTIONS(3085),
    [anon_sym_sizeof] = ACTIONS(3085),
    [anon_sym_typeof] = ACTIONS(3085),
    [anon_sym___makeref] = ACTIONS(3085),
    [anon_sym___reftype] = ACTIONS(3085),
    [anon_sym___refvalue] = ACTIONS(3085),
    [sym_null_literal] = ACTIONS(3085),
    [anon_sym_SQUOTE] = ACTIONS(3087),
    [sym_integer_literal] = ACTIONS(3085),
    [sym_real_literal] = ACTIONS(3087),
    [sym_verbatim_string_literal] = ACTIONS(3087),
    [sym_raw_string_literal] = ACTIONS(3087),
    [aux_sym_preproc_if_token1] = ACTIONS(3087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3087),
    [sym_interpolation_verbatim_start] = ACTIONS(3087),
    [sym_interpolation_raw_start] = ACTIONS(3087),
  },
  [2459] = {
    [sym_preproc_region] = STATE(2459),
    [sym_preproc_endregion] = STATE(2459),
    [sym_preproc_line] = STATE(2459),
    [sym_preproc_pragma] = STATE(2459),
    [sym_preproc_nullable] = STATE(2459),
    [sym_preproc_error] = STATE(2459),
    [sym_preproc_define] = STATE(2459),
    [sym_preproc_undef] = STATE(2459),
    [ts_builtin_sym_end] = ACTIONS(3233),
    [sym__identifier_token] = ACTIONS(3231),
    [anon_sym_extern] = ACTIONS(3231),
    [anon_sym_alias] = ACTIONS(3231),
    [anon_sym_SEMI] = ACTIONS(3233),
    [anon_sym_global] = ACTIONS(3231),
    [anon_sym_using] = ACTIONS(3231),
    [anon_sym_unsafe] = ACTIONS(3231),
    [anon_sym_static] = ACTIONS(3231),
    [anon_sym_LBRACK] = ACTIONS(3233),
    [anon_sym_LPAREN] = ACTIONS(3233),
    [anon_sym_return] = ACTIONS(3231),
    [anon_sym_namespace] = ACTIONS(3231),
    [anon_sym_class] = ACTIONS(3231),
    [anon_sym_ref] = ACTIONS(3231),
    [anon_sym_struct] = ACTIONS(3231),
    [anon_sym_enum] = ACTIONS(3231),
    [anon_sym_LBRACE] = ACTIONS(3233),
    [anon_sym_interface] = ACTIONS(3231),
    [anon_sym_delegate] = ACTIONS(3231),
    [anon_sym_record] = ACTIONS(3231),
    [anon_sym_abstract] = ACTIONS(3231),
    [anon_sym_async] = ACTIONS(3231),
    [anon_sym_const] = ACTIONS(3231),
    [anon_sym_file] = ACTIONS(3231),
    [anon_sym_fixed] = ACTIONS(3231),
    [anon_sym_internal] = ACTIONS(3231),
    [anon_sym_new] = ACTIONS(3231),
    [anon_sym_override] = ACTIONS(3231),
    [anon_sym_partial] = ACTIONS(3231),
    [anon_sym_private] = ACTIONS(3231),
    [anon_sym_protected] = ACTIONS(3231),
    [anon_sym_public] = ACTIONS(3231),
    [anon_sym_readonly] = ACTIONS(3231),
    [anon_sym_required] = ACTIONS(3231),
    [anon_sym_sealed] = ACTIONS(3231),
    [anon_sym_virtual] = ACTIONS(3231),
    [anon_sym_volatile] = ACTIONS(3231),
    [anon_sym_where] = ACTIONS(3231),
    [anon_sym_notnull] = ACTIONS(3231),
    [anon_sym_unmanaged] = ACTIONS(3231),
    [anon_sym_checked] = ACTIONS(3231),
    [anon_sym_BANG] = ACTIONS(3233),
    [anon_sym_TILDE] = ACTIONS(3233),
    [anon_sym_PLUS_PLUS] = ACTIONS(3233),
    [anon_sym_DASH_DASH] = ACTIONS(3233),
    [anon_sym_true] = ACTIONS(3231),
    [anon_sym_false] = ACTIONS(3231),
    [anon_sym_PLUS] = ACTIONS(3231),
    [anon_sym_DASH] = ACTIONS(3231),
    [anon_sym_STAR] = ACTIONS(3233),
    [anon_sym_CARET] = ACTIONS(3233),
    [anon_sym_AMP] = ACTIONS(3233),
    [anon_sym_this] = ACTIONS(3231),
    [anon_sym_scoped] = ACTIONS(3231),
    [anon_sym_var] = ACTIONS(3231),
    [sym_predefined_type] = ACTIONS(3231),
    [anon_sym_break] = ACTIONS(3231),
    [anon_sym_unchecked] = ACTIONS(3231),
    [anon_sym_continue] = ACTIONS(3231),
    [anon_sym_do] = ACTIONS(3231),
    [anon_sym_while] = ACTIONS(3231),
    [anon_sym_for] = ACTIONS(3231),
    [anon_sym_lock] = ACTIONS(3231),
    [anon_sym_yield] = ACTIONS(3231),
    [anon_sym_switch] = ACTIONS(3231),
    [anon_sym_default] = ACTIONS(3231),
    [anon_sym_throw] = ACTIONS(3231),
    [anon_sym_try] = ACTIONS(3231),
    [anon_sym_when] = ACTIONS(3231),
    [anon_sym_await] = ACTIONS(3231),
    [anon_sym_foreach] = ACTIONS(3231),
    [anon_sym_goto] = ACTIONS(3231),
    [anon_sym_if] = ACTIONS(3231),
    [anon_sym_else] = ACTIONS(3231),
    [anon_sym_DOT_DOT] = ACTIONS(3233),
    [anon_sym_from] = ACTIONS(3231),
    [anon_sym_into] = ACTIONS(3231),
    [anon_sym_join] = ACTIONS(3231),
    [anon_sym_on] = ACTIONS(3231),
    [anon_sym_equals] = ACTIONS(3231),
    [anon_sym_let] = ACTIONS(3231),
    [anon_sym_orderby] = ACTIONS(3231),
    [anon_sym_ascending] = ACTIONS(3231),
    [anon_sym_descending] = ACTIONS(3231),
    [anon_sym_group] = ACTIONS(3231),
    [anon_sym_by] = ACTIONS(3231),
    [anon_sym_select] = ACTIONS(3231),
    [anon_sym_DQUOTE] = ACTIONS(3231),
    [anon_sym_stackalloc] = ACTIONS(3231),
    [anon_sym_sizeof] = ACTIONS(3231),
    [anon_sym_typeof] = ACTIONS(3231),
    [anon_sym___makeref] = ACTIONS(3231),
    [anon_sym___reftype] = ACTIONS(3231),
    [anon_sym___refvalue] = ACTIONS(3231),
    [sym_null_literal] = ACTIONS(3231),
    [anon_sym_SQUOTE] = ACTIONS(3233),
    [sym_integer_literal] = ACTIONS(3231),
    [sym_real_literal] = ACTIONS(3233),
    [sym_verbatim_string_literal] = ACTIONS(3233),
    [sym_raw_string_literal] = ACTIONS(3233),
    [aux_sym_preproc_if_token1] = ACTIONS(3233),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3233),
    [sym_interpolation_verbatim_start] = ACTIONS(3233),
    [sym_interpolation_raw_start] = ACTIONS(3233),
  },
  [2460] = {
    [sym_preproc_region] = STATE(2460),
    [sym_preproc_endregion] = STATE(2460),
    [sym_preproc_line] = STATE(2460),
    [sym_preproc_pragma] = STATE(2460),
    [sym_preproc_nullable] = STATE(2460),
    [sym_preproc_error] = STATE(2460),
    [sym_preproc_define] = STATE(2460),
    [sym_preproc_undef] = STATE(2460),
    [ts_builtin_sym_end] = ACTIONS(3385),
    [sym__identifier_token] = ACTIONS(3383),
    [anon_sym_extern] = ACTIONS(3383),
    [anon_sym_alias] = ACTIONS(3383),
    [anon_sym_SEMI] = ACTIONS(3385),
    [anon_sym_global] = ACTIONS(3383),
    [anon_sym_using] = ACTIONS(3383),
    [anon_sym_unsafe] = ACTIONS(3383),
    [anon_sym_static] = ACTIONS(3383),
    [anon_sym_LBRACK] = ACTIONS(3385),
    [anon_sym_LPAREN] = ACTIONS(3385),
    [anon_sym_return] = ACTIONS(3383),
    [anon_sym_namespace] = ACTIONS(3383),
    [anon_sym_class] = ACTIONS(3383),
    [anon_sym_ref] = ACTIONS(3383),
    [anon_sym_struct] = ACTIONS(3383),
    [anon_sym_enum] = ACTIONS(3383),
    [anon_sym_LBRACE] = ACTIONS(3385),
    [anon_sym_interface] = ACTIONS(3383),
    [anon_sym_delegate] = ACTIONS(3383),
    [anon_sym_record] = ACTIONS(3383),
    [anon_sym_abstract] = ACTIONS(3383),
    [anon_sym_async] = ACTIONS(3383),
    [anon_sym_const] = ACTIONS(3383),
    [anon_sym_file] = ACTIONS(3383),
    [anon_sym_fixed] = ACTIONS(3383),
    [anon_sym_internal] = ACTIONS(3383),
    [anon_sym_new] = ACTIONS(3383),
    [anon_sym_override] = ACTIONS(3383),
    [anon_sym_partial] = ACTIONS(3383),
    [anon_sym_private] = ACTIONS(3383),
    [anon_sym_protected] = ACTIONS(3383),
    [anon_sym_public] = ACTIONS(3383),
    [anon_sym_readonly] = ACTIONS(3383),
    [anon_sym_required] = ACTIONS(3383),
    [anon_sym_sealed] = ACTIONS(3383),
    [anon_sym_virtual] = ACTIONS(3383),
    [anon_sym_volatile] = ACTIONS(3383),
    [anon_sym_where] = ACTIONS(3383),
    [anon_sym_notnull] = ACTIONS(3383),
    [anon_sym_unmanaged] = ACTIONS(3383),
    [anon_sym_checked] = ACTIONS(3383),
    [anon_sym_BANG] = ACTIONS(3385),
    [anon_sym_TILDE] = ACTIONS(3385),
    [anon_sym_PLUS_PLUS] = ACTIONS(3385),
    [anon_sym_DASH_DASH] = ACTIONS(3385),
    [anon_sym_true] = ACTIONS(3383),
    [anon_sym_false] = ACTIONS(3383),
    [anon_sym_PLUS] = ACTIONS(3383),
    [anon_sym_DASH] = ACTIONS(3383),
    [anon_sym_STAR] = ACTIONS(3385),
    [anon_sym_CARET] = ACTIONS(3385),
    [anon_sym_AMP] = ACTIONS(3385),
    [anon_sym_this] = ACTIONS(3383),
    [anon_sym_scoped] = ACTIONS(3383),
    [anon_sym_var] = ACTIONS(3383),
    [sym_predefined_type] = ACTIONS(3383),
    [anon_sym_break] = ACTIONS(3383),
    [anon_sym_unchecked] = ACTIONS(3383),
    [anon_sym_continue] = ACTIONS(3383),
    [anon_sym_do] = ACTIONS(3383),
    [anon_sym_while] = ACTIONS(3383),
    [anon_sym_for] = ACTIONS(3383),
    [anon_sym_lock] = ACTIONS(3383),
    [anon_sym_yield] = ACTIONS(3383),
    [anon_sym_switch] = ACTIONS(3383),
    [anon_sym_default] = ACTIONS(3383),
    [anon_sym_throw] = ACTIONS(3383),
    [anon_sym_try] = ACTIONS(3383),
    [anon_sym_when] = ACTIONS(3383),
    [anon_sym_await] = ACTIONS(3383),
    [anon_sym_foreach] = ACTIONS(3383),
    [anon_sym_goto] = ACTIONS(3383),
    [anon_sym_if] = ACTIONS(3383),
    [anon_sym_else] = ACTIONS(3383),
    [anon_sym_DOT_DOT] = ACTIONS(3385),
    [anon_sym_from] = ACTIONS(3383),
    [anon_sym_into] = ACTIONS(3383),
    [anon_sym_join] = ACTIONS(3383),
    [anon_sym_on] = ACTIONS(3383),
    [anon_sym_equals] = ACTIONS(3383),
    [anon_sym_let] = ACTIONS(3383),
    [anon_sym_orderby] = ACTIONS(3383),
    [anon_sym_ascending] = ACTIONS(3383),
    [anon_sym_descending] = ACTIONS(3383),
    [anon_sym_group] = ACTIONS(3383),
    [anon_sym_by] = ACTIONS(3383),
    [anon_sym_select] = ACTIONS(3383),
    [anon_sym_DQUOTE] = ACTIONS(3383),
    [anon_sym_stackalloc] = ACTIONS(3383),
    [anon_sym_sizeof] = ACTIONS(3383),
    [anon_sym_typeof] = ACTIONS(3383),
    [anon_sym___makeref] = ACTIONS(3383),
    [anon_sym___reftype] = ACTIONS(3383),
    [anon_sym___refvalue] = ACTIONS(3383),
    [sym_null_literal] = ACTIONS(3383),
    [anon_sym_SQUOTE] = ACTIONS(3385),
    [sym_integer_literal] = ACTIONS(3383),
    [sym_real_literal] = ACTIONS(3385),
    [sym_verbatim_string_literal] = ACTIONS(3385),
    [sym_raw_string_literal] = ACTIONS(3385),
    [aux_sym_preproc_if_token1] = ACTIONS(3385),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3385),
    [sym_interpolation_verbatim_start] = ACTIONS(3385),
    [sym_interpolation_raw_start] = ACTIONS(3385),
  },
  [2461] = {
    [sym_preproc_region] = STATE(2461),
    [sym_preproc_endregion] = STATE(2461),
    [sym_preproc_line] = STATE(2461),
    [sym_preproc_pragma] = STATE(2461),
    [sym_preproc_nullable] = STATE(2461),
    [sym_preproc_error] = STATE(2461),
    [sym_preproc_define] = STATE(2461),
    [sym_preproc_undef] = STATE(2461),
    [ts_builtin_sym_end] = ACTIONS(3091),
    [sym__identifier_token] = ACTIONS(3089),
    [anon_sym_extern] = ACTIONS(3089),
    [anon_sym_alias] = ACTIONS(3089),
    [anon_sym_SEMI] = ACTIONS(3091),
    [anon_sym_global] = ACTIONS(3089),
    [anon_sym_using] = ACTIONS(3089),
    [anon_sym_unsafe] = ACTIONS(3089),
    [anon_sym_static] = ACTIONS(3089),
    [anon_sym_LBRACK] = ACTIONS(3091),
    [anon_sym_LPAREN] = ACTIONS(3091),
    [anon_sym_return] = ACTIONS(3089),
    [anon_sym_namespace] = ACTIONS(3089),
    [anon_sym_class] = ACTIONS(3089),
    [anon_sym_ref] = ACTIONS(3089),
    [anon_sym_struct] = ACTIONS(3089),
    [anon_sym_enum] = ACTIONS(3089),
    [anon_sym_LBRACE] = ACTIONS(3091),
    [anon_sym_interface] = ACTIONS(3089),
    [anon_sym_delegate] = ACTIONS(3089),
    [anon_sym_record] = ACTIONS(3089),
    [anon_sym_abstract] = ACTIONS(3089),
    [anon_sym_async] = ACTIONS(3089),
    [anon_sym_const] = ACTIONS(3089),
    [anon_sym_file] = ACTIONS(3089),
    [anon_sym_fixed] = ACTIONS(3089),
    [anon_sym_internal] = ACTIONS(3089),
    [anon_sym_new] = ACTIONS(3089),
    [anon_sym_override] = ACTIONS(3089),
    [anon_sym_partial] = ACTIONS(3089),
    [anon_sym_private] = ACTIONS(3089),
    [anon_sym_protected] = ACTIONS(3089),
    [anon_sym_public] = ACTIONS(3089),
    [anon_sym_readonly] = ACTIONS(3089),
    [anon_sym_required] = ACTIONS(3089),
    [anon_sym_sealed] = ACTIONS(3089),
    [anon_sym_virtual] = ACTIONS(3089),
    [anon_sym_volatile] = ACTIONS(3089),
    [anon_sym_where] = ACTIONS(3089),
    [anon_sym_notnull] = ACTIONS(3089),
    [anon_sym_unmanaged] = ACTIONS(3089),
    [anon_sym_checked] = ACTIONS(3089),
    [anon_sym_BANG] = ACTIONS(3091),
    [anon_sym_TILDE] = ACTIONS(3091),
    [anon_sym_PLUS_PLUS] = ACTIONS(3091),
    [anon_sym_DASH_DASH] = ACTIONS(3091),
    [anon_sym_true] = ACTIONS(3089),
    [anon_sym_false] = ACTIONS(3089),
    [anon_sym_PLUS] = ACTIONS(3089),
    [anon_sym_DASH] = ACTIONS(3089),
    [anon_sym_STAR] = ACTIONS(3091),
    [anon_sym_CARET] = ACTIONS(3091),
    [anon_sym_AMP] = ACTIONS(3091),
    [anon_sym_this] = ACTIONS(3089),
    [anon_sym_scoped] = ACTIONS(3089),
    [anon_sym_var] = ACTIONS(3089),
    [sym_predefined_type] = ACTIONS(3089),
    [anon_sym_break] = ACTIONS(3089),
    [anon_sym_unchecked] = ACTIONS(3089),
    [anon_sym_continue] = ACTIONS(3089),
    [anon_sym_do] = ACTIONS(3089),
    [anon_sym_while] = ACTIONS(3089),
    [anon_sym_for] = ACTIONS(3089),
    [anon_sym_lock] = ACTIONS(3089),
    [anon_sym_yield] = ACTIONS(3089),
    [anon_sym_switch] = ACTIONS(3089),
    [anon_sym_default] = ACTIONS(3089),
    [anon_sym_throw] = ACTIONS(3089),
    [anon_sym_try] = ACTIONS(3089),
    [anon_sym_when] = ACTIONS(3089),
    [anon_sym_await] = ACTIONS(3089),
    [anon_sym_foreach] = ACTIONS(3089),
    [anon_sym_goto] = ACTIONS(3089),
    [anon_sym_if] = ACTIONS(3089),
    [anon_sym_else] = ACTIONS(3089),
    [anon_sym_DOT_DOT] = ACTIONS(3091),
    [anon_sym_from] = ACTIONS(3089),
    [anon_sym_into] = ACTIONS(3089),
    [anon_sym_join] = ACTIONS(3089),
    [anon_sym_on] = ACTIONS(3089),
    [anon_sym_equals] = ACTIONS(3089),
    [anon_sym_let] = ACTIONS(3089),
    [anon_sym_orderby] = ACTIONS(3089),
    [anon_sym_ascending] = ACTIONS(3089),
    [anon_sym_descending] = ACTIONS(3089),
    [anon_sym_group] = ACTIONS(3089),
    [anon_sym_by] = ACTIONS(3089),
    [anon_sym_select] = ACTIONS(3089),
    [anon_sym_DQUOTE] = ACTIONS(3089),
    [anon_sym_stackalloc] = ACTIONS(3089),
    [anon_sym_sizeof] = ACTIONS(3089),
    [anon_sym_typeof] = ACTIONS(3089),
    [anon_sym___makeref] = ACTIONS(3089),
    [anon_sym___reftype] = ACTIONS(3089),
    [anon_sym___refvalue] = ACTIONS(3089),
    [sym_null_literal] = ACTIONS(3089),
    [anon_sym_SQUOTE] = ACTIONS(3091),
    [sym_integer_literal] = ACTIONS(3089),
    [sym_real_literal] = ACTIONS(3091),
    [sym_verbatim_string_literal] = ACTIONS(3091),
    [sym_raw_string_literal] = ACTIONS(3091),
    [aux_sym_preproc_if_token1] = ACTIONS(3091),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3091),
    [sym_interpolation_verbatim_start] = ACTIONS(3091),
    [sym_interpolation_raw_start] = ACTIONS(3091),
  },
  [2462] = {
    [sym_preproc_region] = STATE(2462),
    [sym_preproc_endregion] = STATE(2462),
    [sym_preproc_line] = STATE(2462),
    [sym_preproc_pragma] = STATE(2462),
    [sym_preproc_nullable] = STATE(2462),
    [sym_preproc_error] = STATE(2462),
    [sym_preproc_define] = STATE(2462),
    [sym_preproc_undef] = STATE(2462),
    [ts_builtin_sym_end] = ACTIONS(3277),
    [sym__identifier_token] = ACTIONS(3275),
    [anon_sym_extern] = ACTIONS(3275),
    [anon_sym_alias] = ACTIONS(3275),
    [anon_sym_SEMI] = ACTIONS(3277),
    [anon_sym_global] = ACTIONS(3275),
    [anon_sym_using] = ACTIONS(3275),
    [anon_sym_unsafe] = ACTIONS(3275),
    [anon_sym_static] = ACTIONS(3275),
    [anon_sym_LBRACK] = ACTIONS(3277),
    [anon_sym_LPAREN] = ACTIONS(3277),
    [anon_sym_return] = ACTIONS(3275),
    [anon_sym_namespace] = ACTIONS(3275),
    [anon_sym_class] = ACTIONS(3275),
    [anon_sym_ref] = ACTIONS(3275),
    [anon_sym_struct] = ACTIONS(3275),
    [anon_sym_enum] = ACTIONS(3275),
    [anon_sym_LBRACE] = ACTIONS(3277),
    [anon_sym_interface] = ACTIONS(3275),
    [anon_sym_delegate] = ACTIONS(3275),
    [anon_sym_record] = ACTIONS(3275),
    [anon_sym_abstract] = ACTIONS(3275),
    [anon_sym_async] = ACTIONS(3275),
    [anon_sym_const] = ACTIONS(3275),
    [anon_sym_file] = ACTIONS(3275),
    [anon_sym_fixed] = ACTIONS(3275),
    [anon_sym_internal] = ACTIONS(3275),
    [anon_sym_new] = ACTIONS(3275),
    [anon_sym_override] = ACTIONS(3275),
    [anon_sym_partial] = ACTIONS(3275),
    [anon_sym_private] = ACTIONS(3275),
    [anon_sym_protected] = ACTIONS(3275),
    [anon_sym_public] = ACTIONS(3275),
    [anon_sym_readonly] = ACTIONS(3275),
    [anon_sym_required] = ACTIONS(3275),
    [anon_sym_sealed] = ACTIONS(3275),
    [anon_sym_virtual] = ACTIONS(3275),
    [anon_sym_volatile] = ACTIONS(3275),
    [anon_sym_where] = ACTIONS(3275),
    [anon_sym_notnull] = ACTIONS(3275),
    [anon_sym_unmanaged] = ACTIONS(3275),
    [anon_sym_checked] = ACTIONS(3275),
    [anon_sym_BANG] = ACTIONS(3277),
    [anon_sym_TILDE] = ACTIONS(3277),
    [anon_sym_PLUS_PLUS] = ACTIONS(3277),
    [anon_sym_DASH_DASH] = ACTIONS(3277),
    [anon_sym_true] = ACTIONS(3275),
    [anon_sym_false] = ACTIONS(3275),
    [anon_sym_PLUS] = ACTIONS(3275),
    [anon_sym_DASH] = ACTIONS(3275),
    [anon_sym_STAR] = ACTIONS(3277),
    [anon_sym_CARET] = ACTIONS(3277),
    [anon_sym_AMP] = ACTIONS(3277),
    [anon_sym_this] = ACTIONS(3275),
    [anon_sym_scoped] = ACTIONS(3275),
    [anon_sym_var] = ACTIONS(3275),
    [sym_predefined_type] = ACTIONS(3275),
    [anon_sym_break] = ACTIONS(3275),
    [anon_sym_unchecked] = ACTIONS(3275),
    [anon_sym_continue] = ACTIONS(3275),
    [anon_sym_do] = ACTIONS(3275),
    [anon_sym_while] = ACTIONS(3275),
    [anon_sym_for] = ACTIONS(3275),
    [anon_sym_lock] = ACTIONS(3275),
    [anon_sym_yield] = ACTIONS(3275),
    [anon_sym_switch] = ACTIONS(3275),
    [anon_sym_default] = ACTIONS(3275),
    [anon_sym_throw] = ACTIONS(3275),
    [anon_sym_try] = ACTIONS(3275),
    [anon_sym_when] = ACTIONS(3275),
    [anon_sym_await] = ACTIONS(3275),
    [anon_sym_foreach] = ACTIONS(3275),
    [anon_sym_goto] = ACTIONS(3275),
    [anon_sym_if] = ACTIONS(3275),
    [anon_sym_else] = ACTIONS(3275),
    [anon_sym_DOT_DOT] = ACTIONS(3277),
    [anon_sym_from] = ACTIONS(3275),
    [anon_sym_into] = ACTIONS(3275),
    [anon_sym_join] = ACTIONS(3275),
    [anon_sym_on] = ACTIONS(3275),
    [anon_sym_equals] = ACTIONS(3275),
    [anon_sym_let] = ACTIONS(3275),
    [anon_sym_orderby] = ACTIONS(3275),
    [anon_sym_ascending] = ACTIONS(3275),
    [anon_sym_descending] = ACTIONS(3275),
    [anon_sym_group] = ACTIONS(3275),
    [anon_sym_by] = ACTIONS(3275),
    [anon_sym_select] = ACTIONS(3275),
    [anon_sym_DQUOTE] = ACTIONS(3275),
    [anon_sym_stackalloc] = ACTIONS(3275),
    [anon_sym_sizeof] = ACTIONS(3275),
    [anon_sym_typeof] = ACTIONS(3275),
    [anon_sym___makeref] = ACTIONS(3275),
    [anon_sym___reftype] = ACTIONS(3275),
    [anon_sym___refvalue] = ACTIONS(3275),
    [sym_null_literal] = ACTIONS(3275),
    [anon_sym_SQUOTE] = ACTIONS(3277),
    [sym_integer_literal] = ACTIONS(3275),
    [sym_real_literal] = ACTIONS(3277),
    [sym_verbatim_string_literal] = ACTIONS(3277),
    [sym_raw_string_literal] = ACTIONS(3277),
    [aux_sym_preproc_if_token1] = ACTIONS(3277),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3277),
    [sym_interpolation_verbatim_start] = ACTIONS(3277),
    [sym_interpolation_raw_start] = ACTIONS(3277),
  },
  [2463] = {
    [sym_preproc_region] = STATE(2463),
    [sym_preproc_endregion] = STATE(2463),
    [sym_preproc_line] = STATE(2463),
    [sym_preproc_pragma] = STATE(2463),
    [sym_preproc_nullable] = STATE(2463),
    [sym_preproc_error] = STATE(2463),
    [sym_preproc_define] = STATE(2463),
    [sym_preproc_undef] = STATE(2463),
    [ts_builtin_sym_end] = ACTIONS(3099),
    [sym__identifier_token] = ACTIONS(3097),
    [anon_sym_extern] = ACTIONS(3097),
    [anon_sym_alias] = ACTIONS(3097),
    [anon_sym_SEMI] = ACTIONS(3099),
    [anon_sym_global] = ACTIONS(3097),
    [anon_sym_using] = ACTIONS(3097),
    [anon_sym_unsafe] = ACTIONS(3097),
    [anon_sym_static] = ACTIONS(3097),
    [anon_sym_LBRACK] = ACTIONS(3099),
    [anon_sym_LPAREN] = ACTIONS(3099),
    [anon_sym_return] = ACTIONS(3097),
    [anon_sym_namespace] = ACTIONS(3097),
    [anon_sym_class] = ACTIONS(3097),
    [anon_sym_ref] = ACTIONS(3097),
    [anon_sym_struct] = ACTIONS(3097),
    [anon_sym_enum] = ACTIONS(3097),
    [anon_sym_LBRACE] = ACTIONS(3099),
    [anon_sym_interface] = ACTIONS(3097),
    [anon_sym_delegate] = ACTIONS(3097),
    [anon_sym_record] = ACTIONS(3097),
    [anon_sym_abstract] = ACTIONS(3097),
    [anon_sym_async] = ACTIONS(3097),
    [anon_sym_const] = ACTIONS(3097),
    [anon_sym_file] = ACTIONS(3097),
    [anon_sym_fixed] = ACTIONS(3097),
    [anon_sym_internal] = ACTIONS(3097),
    [anon_sym_new] = ACTIONS(3097),
    [anon_sym_override] = ACTIONS(3097),
    [anon_sym_partial] = ACTIONS(3097),
    [anon_sym_private] = ACTIONS(3097),
    [anon_sym_protected] = ACTIONS(3097),
    [anon_sym_public] = ACTIONS(3097),
    [anon_sym_readonly] = ACTIONS(3097),
    [anon_sym_required] = ACTIONS(3097),
    [anon_sym_sealed] = ACTIONS(3097),
    [anon_sym_virtual] = ACTIONS(3097),
    [anon_sym_volatile] = ACTIONS(3097),
    [anon_sym_where] = ACTIONS(3097),
    [anon_sym_notnull] = ACTIONS(3097),
    [anon_sym_unmanaged] = ACTIONS(3097),
    [anon_sym_checked] = ACTIONS(3097),
    [anon_sym_BANG] = ACTIONS(3099),
    [anon_sym_TILDE] = ACTIONS(3099),
    [anon_sym_PLUS_PLUS] = ACTIONS(3099),
    [anon_sym_DASH_DASH] = ACTIONS(3099),
    [anon_sym_true] = ACTIONS(3097),
    [anon_sym_false] = ACTIONS(3097),
    [anon_sym_PLUS] = ACTIONS(3097),
    [anon_sym_DASH] = ACTIONS(3097),
    [anon_sym_STAR] = ACTIONS(3099),
    [anon_sym_CARET] = ACTIONS(3099),
    [anon_sym_AMP] = ACTIONS(3099),
    [anon_sym_this] = ACTIONS(3097),
    [anon_sym_scoped] = ACTIONS(3097),
    [anon_sym_var] = ACTIONS(3097),
    [sym_predefined_type] = ACTIONS(3097),
    [anon_sym_break] = ACTIONS(3097),
    [anon_sym_unchecked] = ACTIONS(3097),
    [anon_sym_continue] = ACTIONS(3097),
    [anon_sym_do] = ACTIONS(3097),
    [anon_sym_while] = ACTIONS(3097),
    [anon_sym_for] = ACTIONS(3097),
    [anon_sym_lock] = ACTIONS(3097),
    [anon_sym_yield] = ACTIONS(3097),
    [anon_sym_switch] = ACTIONS(3097),
    [anon_sym_default] = ACTIONS(3097),
    [anon_sym_throw] = ACTIONS(3097),
    [anon_sym_try] = ACTIONS(3097),
    [anon_sym_when] = ACTIONS(3097),
    [anon_sym_await] = ACTIONS(3097),
    [anon_sym_foreach] = ACTIONS(3097),
    [anon_sym_goto] = ACTIONS(3097),
    [anon_sym_if] = ACTIONS(3097),
    [anon_sym_else] = ACTIONS(3097),
    [anon_sym_DOT_DOT] = ACTIONS(3099),
    [anon_sym_from] = ACTIONS(3097),
    [anon_sym_into] = ACTIONS(3097),
    [anon_sym_join] = ACTIONS(3097),
    [anon_sym_on] = ACTIONS(3097),
    [anon_sym_equals] = ACTIONS(3097),
    [anon_sym_let] = ACTIONS(3097),
    [anon_sym_orderby] = ACTIONS(3097),
    [anon_sym_ascending] = ACTIONS(3097),
    [anon_sym_descending] = ACTIONS(3097),
    [anon_sym_group] = ACTIONS(3097),
    [anon_sym_by] = ACTIONS(3097),
    [anon_sym_select] = ACTIONS(3097),
    [anon_sym_DQUOTE] = ACTIONS(3097),
    [anon_sym_stackalloc] = ACTIONS(3097),
    [anon_sym_sizeof] = ACTIONS(3097),
    [anon_sym_typeof] = ACTIONS(3097),
    [anon_sym___makeref] = ACTIONS(3097),
    [anon_sym___reftype] = ACTIONS(3097),
    [anon_sym___refvalue] = ACTIONS(3097),
    [sym_null_literal] = ACTIONS(3097),
    [anon_sym_SQUOTE] = ACTIONS(3099),
    [sym_integer_literal] = ACTIONS(3097),
    [sym_real_literal] = ACTIONS(3099),
    [sym_verbatim_string_literal] = ACTIONS(3099),
    [sym_raw_string_literal] = ACTIONS(3099),
    [aux_sym_preproc_if_token1] = ACTIONS(3099),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3099),
    [sym_interpolation_verbatim_start] = ACTIONS(3099),
    [sym_interpolation_raw_start] = ACTIONS(3099),
  },
  [2464] = {
    [sym_preproc_region] = STATE(2464),
    [sym_preproc_endregion] = STATE(2464),
    [sym_preproc_line] = STATE(2464),
    [sym_preproc_pragma] = STATE(2464),
    [sym_preproc_nullable] = STATE(2464),
    [sym_preproc_error] = STATE(2464),
    [sym_preproc_define] = STATE(2464),
    [sym_preproc_undef] = STATE(2464),
    [ts_builtin_sym_end] = ACTIONS(3103),
    [sym__identifier_token] = ACTIONS(3101),
    [anon_sym_extern] = ACTIONS(3101),
    [anon_sym_alias] = ACTIONS(3101),
    [anon_sym_SEMI] = ACTIONS(3103),
    [anon_sym_global] = ACTIONS(3101),
    [anon_sym_using] = ACTIONS(3101),
    [anon_sym_unsafe] = ACTIONS(3101),
    [anon_sym_static] = ACTIONS(3101),
    [anon_sym_LBRACK] = ACTIONS(3103),
    [anon_sym_LPAREN] = ACTIONS(3103),
    [anon_sym_return] = ACTIONS(3101),
    [anon_sym_namespace] = ACTIONS(3101),
    [anon_sym_class] = ACTIONS(3101),
    [anon_sym_ref] = ACTIONS(3101),
    [anon_sym_struct] = ACTIONS(3101),
    [anon_sym_enum] = ACTIONS(3101),
    [anon_sym_LBRACE] = ACTIONS(3103),
    [anon_sym_interface] = ACTIONS(3101),
    [anon_sym_delegate] = ACTIONS(3101),
    [anon_sym_record] = ACTIONS(3101),
    [anon_sym_abstract] = ACTIONS(3101),
    [anon_sym_async] = ACTIONS(3101),
    [anon_sym_const] = ACTIONS(3101),
    [anon_sym_file] = ACTIONS(3101),
    [anon_sym_fixed] = ACTIONS(3101),
    [anon_sym_internal] = ACTIONS(3101),
    [anon_sym_new] = ACTIONS(3101),
    [anon_sym_override] = ACTIONS(3101),
    [anon_sym_partial] = ACTIONS(3101),
    [anon_sym_private] = ACTIONS(3101),
    [anon_sym_protected] = ACTIONS(3101),
    [anon_sym_public] = ACTIONS(3101),
    [anon_sym_readonly] = ACTIONS(3101),
    [anon_sym_required] = ACTIONS(3101),
    [anon_sym_sealed] = ACTIONS(3101),
    [anon_sym_virtual] = ACTIONS(3101),
    [anon_sym_volatile] = ACTIONS(3101),
    [anon_sym_where] = ACTIONS(3101),
    [anon_sym_notnull] = ACTIONS(3101),
    [anon_sym_unmanaged] = ACTIONS(3101),
    [anon_sym_checked] = ACTIONS(3101),
    [anon_sym_BANG] = ACTIONS(3103),
    [anon_sym_TILDE] = ACTIONS(3103),
    [anon_sym_PLUS_PLUS] = ACTIONS(3103),
    [anon_sym_DASH_DASH] = ACTIONS(3103),
    [anon_sym_true] = ACTIONS(3101),
    [anon_sym_false] = ACTIONS(3101),
    [anon_sym_PLUS] = ACTIONS(3101),
    [anon_sym_DASH] = ACTIONS(3101),
    [anon_sym_STAR] = ACTIONS(3103),
    [anon_sym_CARET] = ACTIONS(3103),
    [anon_sym_AMP] = ACTIONS(3103),
    [anon_sym_this] = ACTIONS(3101),
    [anon_sym_scoped] = ACTIONS(3101),
    [anon_sym_var] = ACTIONS(3101),
    [sym_predefined_type] = ACTIONS(3101),
    [anon_sym_break] = ACTIONS(3101),
    [anon_sym_unchecked] = ACTIONS(3101),
    [anon_sym_continue] = ACTIONS(3101),
    [anon_sym_do] = ACTIONS(3101),
    [anon_sym_while] = ACTIONS(3101),
    [anon_sym_for] = ACTIONS(3101),
    [anon_sym_lock] = ACTIONS(3101),
    [anon_sym_yield] = ACTIONS(3101),
    [anon_sym_switch] = ACTIONS(3101),
    [anon_sym_default] = ACTIONS(3101),
    [anon_sym_throw] = ACTIONS(3101),
    [anon_sym_try] = ACTIONS(3101),
    [anon_sym_when] = ACTIONS(3101),
    [anon_sym_await] = ACTIONS(3101),
    [anon_sym_foreach] = ACTIONS(3101),
    [anon_sym_goto] = ACTIONS(3101),
    [anon_sym_if] = ACTIONS(3101),
    [anon_sym_else] = ACTIONS(3101),
    [anon_sym_DOT_DOT] = ACTIONS(3103),
    [anon_sym_from] = ACTIONS(3101),
    [anon_sym_into] = ACTIONS(3101),
    [anon_sym_join] = ACTIONS(3101),
    [anon_sym_on] = ACTIONS(3101),
    [anon_sym_equals] = ACTIONS(3101),
    [anon_sym_let] = ACTIONS(3101),
    [anon_sym_orderby] = ACTIONS(3101),
    [anon_sym_ascending] = ACTIONS(3101),
    [anon_sym_descending] = ACTIONS(3101),
    [anon_sym_group] = ACTIONS(3101),
    [anon_sym_by] = ACTIONS(3101),
    [anon_sym_select] = ACTIONS(3101),
    [anon_sym_DQUOTE] = ACTIONS(3101),
    [anon_sym_stackalloc] = ACTIONS(3101),
    [anon_sym_sizeof] = ACTIONS(3101),
    [anon_sym_typeof] = ACTIONS(3101),
    [anon_sym___makeref] = ACTIONS(3101),
    [anon_sym___reftype] = ACTIONS(3101),
    [anon_sym___refvalue] = ACTIONS(3101),
    [sym_null_literal] = ACTIONS(3101),
    [anon_sym_SQUOTE] = ACTIONS(3103),
    [sym_integer_literal] = ACTIONS(3101),
    [sym_real_literal] = ACTIONS(3103),
    [sym_verbatim_string_literal] = ACTIONS(3103),
    [sym_raw_string_literal] = ACTIONS(3103),
    [aux_sym_preproc_if_token1] = ACTIONS(3103),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3103),
    [sym_interpolation_verbatim_start] = ACTIONS(3103),
    [sym_interpolation_raw_start] = ACTIONS(3103),
  },
  [2465] = {
    [sym_preproc_region] = STATE(2465),
    [sym_preproc_endregion] = STATE(2465),
    [sym_preproc_line] = STATE(2465),
    [sym_preproc_pragma] = STATE(2465),
    [sym_preproc_nullable] = STATE(2465),
    [sym_preproc_error] = STATE(2465),
    [sym_preproc_define] = STATE(2465),
    [sym_preproc_undef] = STATE(2465),
    [ts_builtin_sym_end] = ACTIONS(3273),
    [sym__identifier_token] = ACTIONS(3271),
    [anon_sym_extern] = ACTIONS(3271),
    [anon_sym_alias] = ACTIONS(3271),
    [anon_sym_SEMI] = ACTIONS(3273),
    [anon_sym_global] = ACTIONS(3271),
    [anon_sym_using] = ACTIONS(3271),
    [anon_sym_unsafe] = ACTIONS(3271),
    [anon_sym_static] = ACTIONS(3271),
    [anon_sym_LBRACK] = ACTIONS(3273),
    [anon_sym_LPAREN] = ACTIONS(3273),
    [anon_sym_return] = ACTIONS(3271),
    [anon_sym_namespace] = ACTIONS(3271),
    [anon_sym_class] = ACTIONS(3271),
    [anon_sym_ref] = ACTIONS(3271),
    [anon_sym_struct] = ACTIONS(3271),
    [anon_sym_enum] = ACTIONS(3271),
    [anon_sym_LBRACE] = ACTIONS(3273),
    [anon_sym_interface] = ACTIONS(3271),
    [anon_sym_delegate] = ACTIONS(3271),
    [anon_sym_record] = ACTIONS(3271),
    [anon_sym_abstract] = ACTIONS(3271),
    [anon_sym_async] = ACTIONS(3271),
    [anon_sym_const] = ACTIONS(3271),
    [anon_sym_file] = ACTIONS(3271),
    [anon_sym_fixed] = ACTIONS(3271),
    [anon_sym_internal] = ACTIONS(3271),
    [anon_sym_new] = ACTIONS(3271),
    [anon_sym_override] = ACTIONS(3271),
    [anon_sym_partial] = ACTIONS(3271),
    [anon_sym_private] = ACTIONS(3271),
    [anon_sym_protected] = ACTIONS(3271),
    [anon_sym_public] = ACTIONS(3271),
    [anon_sym_readonly] = ACTIONS(3271),
    [anon_sym_required] = ACTIONS(3271),
    [anon_sym_sealed] = ACTIONS(3271),
    [anon_sym_virtual] = ACTIONS(3271),
    [anon_sym_volatile] = ACTIONS(3271),
    [anon_sym_where] = ACTIONS(3271),
    [anon_sym_notnull] = ACTIONS(3271),
    [anon_sym_unmanaged] = ACTIONS(3271),
    [anon_sym_checked] = ACTIONS(3271),
    [anon_sym_BANG] = ACTIONS(3273),
    [anon_sym_TILDE] = ACTIONS(3273),
    [anon_sym_PLUS_PLUS] = ACTIONS(3273),
    [anon_sym_DASH_DASH] = ACTIONS(3273),
    [anon_sym_true] = ACTIONS(3271),
    [anon_sym_false] = ACTIONS(3271),
    [anon_sym_PLUS] = ACTIONS(3271),
    [anon_sym_DASH] = ACTIONS(3271),
    [anon_sym_STAR] = ACTIONS(3273),
    [anon_sym_CARET] = ACTIONS(3273),
    [anon_sym_AMP] = ACTIONS(3273),
    [anon_sym_this] = ACTIONS(3271),
    [anon_sym_scoped] = ACTIONS(3271),
    [anon_sym_var] = ACTIONS(3271),
    [sym_predefined_type] = ACTIONS(3271),
    [anon_sym_break] = ACTIONS(3271),
    [anon_sym_unchecked] = ACTIONS(3271),
    [anon_sym_continue] = ACTIONS(3271),
    [anon_sym_do] = ACTIONS(3271),
    [anon_sym_while] = ACTIONS(3271),
    [anon_sym_for] = ACTIONS(3271),
    [anon_sym_lock] = ACTIONS(3271),
    [anon_sym_yield] = ACTIONS(3271),
    [anon_sym_switch] = ACTIONS(3271),
    [anon_sym_default] = ACTIONS(3271),
    [anon_sym_throw] = ACTIONS(3271),
    [anon_sym_try] = ACTIONS(3271),
    [anon_sym_when] = ACTIONS(3271),
    [anon_sym_await] = ACTIONS(3271),
    [anon_sym_foreach] = ACTIONS(3271),
    [anon_sym_goto] = ACTIONS(3271),
    [anon_sym_if] = ACTIONS(3271),
    [anon_sym_else] = ACTIONS(3271),
    [anon_sym_DOT_DOT] = ACTIONS(3273),
    [anon_sym_from] = ACTIONS(3271),
    [anon_sym_into] = ACTIONS(3271),
    [anon_sym_join] = ACTIONS(3271),
    [anon_sym_on] = ACTIONS(3271),
    [anon_sym_equals] = ACTIONS(3271),
    [anon_sym_let] = ACTIONS(3271),
    [anon_sym_orderby] = ACTIONS(3271),
    [anon_sym_ascending] = ACTIONS(3271),
    [anon_sym_descending] = ACTIONS(3271),
    [anon_sym_group] = ACTIONS(3271),
    [anon_sym_by] = ACTIONS(3271),
    [anon_sym_select] = ACTIONS(3271),
    [anon_sym_DQUOTE] = ACTIONS(3271),
    [anon_sym_stackalloc] = ACTIONS(3271),
    [anon_sym_sizeof] = ACTIONS(3271),
    [anon_sym_typeof] = ACTIONS(3271),
    [anon_sym___makeref] = ACTIONS(3271),
    [anon_sym___reftype] = ACTIONS(3271),
    [anon_sym___refvalue] = ACTIONS(3271),
    [sym_null_literal] = ACTIONS(3271),
    [anon_sym_SQUOTE] = ACTIONS(3273),
    [sym_integer_literal] = ACTIONS(3271),
    [sym_real_literal] = ACTIONS(3273),
    [sym_verbatim_string_literal] = ACTIONS(3273),
    [sym_raw_string_literal] = ACTIONS(3273),
    [aux_sym_preproc_if_token1] = ACTIONS(3273),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3273),
    [sym_interpolation_verbatim_start] = ACTIONS(3273),
    [sym_interpolation_raw_start] = ACTIONS(3273),
  },
  [2466] = {
    [sym_preproc_region] = STATE(2466),
    [sym_preproc_endregion] = STATE(2466),
    [sym_preproc_line] = STATE(2466),
    [sym_preproc_pragma] = STATE(2466),
    [sym_preproc_nullable] = STATE(2466),
    [sym_preproc_error] = STATE(2466),
    [sym_preproc_define] = STATE(2466),
    [sym_preproc_undef] = STATE(2466),
    [ts_builtin_sym_end] = ACTIONS(3249),
    [sym__identifier_token] = ACTIONS(3247),
    [anon_sym_extern] = ACTIONS(3247),
    [anon_sym_alias] = ACTIONS(3247),
    [anon_sym_SEMI] = ACTIONS(3249),
    [anon_sym_global] = ACTIONS(3247),
    [anon_sym_using] = ACTIONS(3247),
    [anon_sym_unsafe] = ACTIONS(3247),
    [anon_sym_static] = ACTIONS(3247),
    [anon_sym_LBRACK] = ACTIONS(3249),
    [anon_sym_LPAREN] = ACTIONS(3249),
    [anon_sym_return] = ACTIONS(3247),
    [anon_sym_namespace] = ACTIONS(3247),
    [anon_sym_class] = ACTIONS(3247),
    [anon_sym_ref] = ACTIONS(3247),
    [anon_sym_struct] = ACTIONS(3247),
    [anon_sym_enum] = ACTIONS(3247),
    [anon_sym_LBRACE] = ACTIONS(3249),
    [anon_sym_interface] = ACTIONS(3247),
    [anon_sym_delegate] = ACTIONS(3247),
    [anon_sym_record] = ACTIONS(3247),
    [anon_sym_abstract] = ACTIONS(3247),
    [anon_sym_async] = ACTIONS(3247),
    [anon_sym_const] = ACTIONS(3247),
    [anon_sym_file] = ACTIONS(3247),
    [anon_sym_fixed] = ACTIONS(3247),
    [anon_sym_internal] = ACTIONS(3247),
    [anon_sym_new] = ACTIONS(3247),
    [anon_sym_override] = ACTIONS(3247),
    [anon_sym_partial] = ACTIONS(3247),
    [anon_sym_private] = ACTIONS(3247),
    [anon_sym_protected] = ACTIONS(3247),
    [anon_sym_public] = ACTIONS(3247),
    [anon_sym_readonly] = ACTIONS(3247),
    [anon_sym_required] = ACTIONS(3247),
    [anon_sym_sealed] = ACTIONS(3247),
    [anon_sym_virtual] = ACTIONS(3247),
    [anon_sym_volatile] = ACTIONS(3247),
    [anon_sym_where] = ACTIONS(3247),
    [anon_sym_notnull] = ACTIONS(3247),
    [anon_sym_unmanaged] = ACTIONS(3247),
    [anon_sym_checked] = ACTIONS(3247),
    [anon_sym_BANG] = ACTIONS(3249),
    [anon_sym_TILDE] = ACTIONS(3249),
    [anon_sym_PLUS_PLUS] = ACTIONS(3249),
    [anon_sym_DASH_DASH] = ACTIONS(3249),
    [anon_sym_true] = ACTIONS(3247),
    [anon_sym_false] = ACTIONS(3247),
    [anon_sym_PLUS] = ACTIONS(3247),
    [anon_sym_DASH] = ACTIONS(3247),
    [anon_sym_STAR] = ACTIONS(3249),
    [anon_sym_CARET] = ACTIONS(3249),
    [anon_sym_AMP] = ACTIONS(3249),
    [anon_sym_this] = ACTIONS(3247),
    [anon_sym_scoped] = ACTIONS(3247),
    [anon_sym_var] = ACTIONS(3247),
    [sym_predefined_type] = ACTIONS(3247),
    [anon_sym_break] = ACTIONS(3247),
    [anon_sym_unchecked] = ACTIONS(3247),
    [anon_sym_continue] = ACTIONS(3247),
    [anon_sym_do] = ACTIONS(3247),
    [anon_sym_while] = ACTIONS(3247),
    [anon_sym_for] = ACTIONS(3247),
    [anon_sym_lock] = ACTIONS(3247),
    [anon_sym_yield] = ACTIONS(3247),
    [anon_sym_switch] = ACTIONS(3247),
    [anon_sym_default] = ACTIONS(3247),
    [anon_sym_throw] = ACTIONS(3247),
    [anon_sym_try] = ACTIONS(3247),
    [anon_sym_when] = ACTIONS(3247),
    [anon_sym_await] = ACTIONS(3247),
    [anon_sym_foreach] = ACTIONS(3247),
    [anon_sym_goto] = ACTIONS(3247),
    [anon_sym_if] = ACTIONS(3247),
    [anon_sym_else] = ACTIONS(3247),
    [anon_sym_DOT_DOT] = ACTIONS(3249),
    [anon_sym_from] = ACTIONS(3247),
    [anon_sym_into] = ACTIONS(3247),
    [anon_sym_join] = ACTIONS(3247),
    [anon_sym_on] = ACTIONS(3247),
    [anon_sym_equals] = ACTIONS(3247),
    [anon_sym_let] = ACTIONS(3247),
    [anon_sym_orderby] = ACTIONS(3247),
    [anon_sym_ascending] = ACTIONS(3247),
    [anon_sym_descending] = ACTIONS(3247),
    [anon_sym_group] = ACTIONS(3247),
    [anon_sym_by] = ACTIONS(3247),
    [anon_sym_select] = ACTIONS(3247),
    [anon_sym_DQUOTE] = ACTIONS(3247),
    [anon_sym_stackalloc] = ACTIONS(3247),
    [anon_sym_sizeof] = ACTIONS(3247),
    [anon_sym_typeof] = ACTIONS(3247),
    [anon_sym___makeref] = ACTIONS(3247),
    [anon_sym___reftype] = ACTIONS(3247),
    [anon_sym___refvalue] = ACTIONS(3247),
    [sym_null_literal] = ACTIONS(3247),
    [anon_sym_SQUOTE] = ACTIONS(3249),
    [sym_integer_literal] = ACTIONS(3247),
    [sym_real_literal] = ACTIONS(3249),
    [sym_verbatim_string_literal] = ACTIONS(3249),
    [sym_raw_string_literal] = ACTIONS(3249),
    [aux_sym_preproc_if_token1] = ACTIONS(3249),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3249),
    [sym_interpolation_verbatim_start] = ACTIONS(3249),
    [sym_interpolation_raw_start] = ACTIONS(3249),
  },
  [2467] = {
    [sym_preproc_region] = STATE(2467),
    [sym_preproc_endregion] = STATE(2467),
    [sym_preproc_line] = STATE(2467),
    [sym_preproc_pragma] = STATE(2467),
    [sym_preproc_nullable] = STATE(2467),
    [sym_preproc_error] = STATE(2467),
    [sym_preproc_define] = STATE(2467),
    [sym_preproc_undef] = STATE(2467),
    [ts_builtin_sym_end] = ACTIONS(3213),
    [sym__identifier_token] = ACTIONS(3211),
    [anon_sym_extern] = ACTIONS(3211),
    [anon_sym_alias] = ACTIONS(3211),
    [anon_sym_SEMI] = ACTIONS(3213),
    [anon_sym_global] = ACTIONS(3211),
    [anon_sym_using] = ACTIONS(3211),
    [anon_sym_unsafe] = ACTIONS(3211),
    [anon_sym_static] = ACTIONS(3211),
    [anon_sym_LBRACK] = ACTIONS(3213),
    [anon_sym_LPAREN] = ACTIONS(3213),
    [anon_sym_return] = ACTIONS(3211),
    [anon_sym_namespace] = ACTIONS(3211),
    [anon_sym_class] = ACTIONS(3211),
    [anon_sym_ref] = ACTIONS(3211),
    [anon_sym_struct] = ACTIONS(3211),
    [anon_sym_enum] = ACTIONS(3211),
    [anon_sym_LBRACE] = ACTIONS(3213),
    [anon_sym_interface] = ACTIONS(3211),
    [anon_sym_delegate] = ACTIONS(3211),
    [anon_sym_record] = ACTIONS(3211),
    [anon_sym_abstract] = ACTIONS(3211),
    [anon_sym_async] = ACTIONS(3211),
    [anon_sym_const] = ACTIONS(3211),
    [anon_sym_file] = ACTIONS(3211),
    [anon_sym_fixed] = ACTIONS(3211),
    [anon_sym_internal] = ACTIONS(3211),
    [anon_sym_new] = ACTIONS(3211),
    [anon_sym_override] = ACTIONS(3211),
    [anon_sym_partial] = ACTIONS(3211),
    [anon_sym_private] = ACTIONS(3211),
    [anon_sym_protected] = ACTIONS(3211),
    [anon_sym_public] = ACTIONS(3211),
    [anon_sym_readonly] = ACTIONS(3211),
    [anon_sym_required] = ACTIONS(3211),
    [anon_sym_sealed] = ACTIONS(3211),
    [anon_sym_virtual] = ACTIONS(3211),
    [anon_sym_volatile] = ACTIONS(3211),
    [anon_sym_where] = ACTIONS(3211),
    [anon_sym_notnull] = ACTIONS(3211),
    [anon_sym_unmanaged] = ACTIONS(3211),
    [anon_sym_checked] = ACTIONS(3211),
    [anon_sym_BANG] = ACTIONS(3213),
    [anon_sym_TILDE] = ACTIONS(3213),
    [anon_sym_PLUS_PLUS] = ACTIONS(3213),
    [anon_sym_DASH_DASH] = ACTIONS(3213),
    [anon_sym_true] = ACTIONS(3211),
    [anon_sym_false] = ACTIONS(3211),
    [anon_sym_PLUS] = ACTIONS(3211),
    [anon_sym_DASH] = ACTIONS(3211),
    [anon_sym_STAR] = ACTIONS(3213),
    [anon_sym_CARET] = ACTIONS(3213),
    [anon_sym_AMP] = ACTIONS(3213),
    [anon_sym_this] = ACTIONS(3211),
    [anon_sym_scoped] = ACTIONS(3211),
    [anon_sym_var] = ACTIONS(3211),
    [sym_predefined_type] = ACTIONS(3211),
    [anon_sym_break] = ACTIONS(3211),
    [anon_sym_unchecked] = ACTIONS(3211),
    [anon_sym_continue] = ACTIONS(3211),
    [anon_sym_do] = ACTIONS(3211),
    [anon_sym_while] = ACTIONS(3211),
    [anon_sym_for] = ACTIONS(3211),
    [anon_sym_lock] = ACTIONS(3211),
    [anon_sym_yield] = ACTIONS(3211),
    [anon_sym_switch] = ACTIONS(3211),
    [anon_sym_default] = ACTIONS(3211),
    [anon_sym_throw] = ACTIONS(3211),
    [anon_sym_try] = ACTIONS(3211),
    [anon_sym_when] = ACTIONS(3211),
    [anon_sym_await] = ACTIONS(3211),
    [anon_sym_foreach] = ACTIONS(3211),
    [anon_sym_goto] = ACTIONS(3211),
    [anon_sym_if] = ACTIONS(3211),
    [anon_sym_else] = ACTIONS(3211),
    [anon_sym_DOT_DOT] = ACTIONS(3213),
    [anon_sym_from] = ACTIONS(3211),
    [anon_sym_into] = ACTIONS(3211),
    [anon_sym_join] = ACTIONS(3211),
    [anon_sym_on] = ACTIONS(3211),
    [anon_sym_equals] = ACTIONS(3211),
    [anon_sym_let] = ACTIONS(3211),
    [anon_sym_orderby] = ACTIONS(3211),
    [anon_sym_ascending] = ACTIONS(3211),
    [anon_sym_descending] = ACTIONS(3211),
    [anon_sym_group] = ACTIONS(3211),
    [anon_sym_by] = ACTIONS(3211),
    [anon_sym_select] = ACTIONS(3211),
    [anon_sym_DQUOTE] = ACTIONS(3211),
    [anon_sym_stackalloc] = ACTIONS(3211),
    [anon_sym_sizeof] = ACTIONS(3211),
    [anon_sym_typeof] = ACTIONS(3211),
    [anon_sym___makeref] = ACTIONS(3211),
    [anon_sym___reftype] = ACTIONS(3211),
    [anon_sym___refvalue] = ACTIONS(3211),
    [sym_null_literal] = ACTIONS(3211),
    [anon_sym_SQUOTE] = ACTIONS(3213),
    [sym_integer_literal] = ACTIONS(3211),
    [sym_real_literal] = ACTIONS(3213),
    [sym_verbatim_string_literal] = ACTIONS(3213),
    [sym_raw_string_literal] = ACTIONS(3213),
    [aux_sym_preproc_if_token1] = ACTIONS(3213),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3213),
    [sym_interpolation_verbatim_start] = ACTIONS(3213),
    [sym_interpolation_raw_start] = ACTIONS(3213),
  },
  [2468] = {
    [sym_preproc_region] = STATE(2468),
    [sym_preproc_endregion] = STATE(2468),
    [sym_preproc_line] = STATE(2468),
    [sym_preproc_pragma] = STATE(2468),
    [sym_preproc_nullable] = STATE(2468),
    [sym_preproc_error] = STATE(2468),
    [sym_preproc_define] = STATE(2468),
    [sym_preproc_undef] = STATE(2468),
    [ts_builtin_sym_end] = ACTIONS(2939),
    [sym__identifier_token] = ACTIONS(2937),
    [anon_sym_extern] = ACTIONS(2937),
    [anon_sym_alias] = ACTIONS(2937),
    [anon_sym_SEMI] = ACTIONS(2939),
    [anon_sym_global] = ACTIONS(2937),
    [anon_sym_using] = ACTIONS(2937),
    [anon_sym_unsafe] = ACTIONS(2937),
    [anon_sym_static] = ACTIONS(2937),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_LPAREN] = ACTIONS(2939),
    [anon_sym_return] = ACTIONS(2937),
    [anon_sym_namespace] = ACTIONS(2937),
    [anon_sym_class] = ACTIONS(2937),
    [anon_sym_ref] = ACTIONS(2937),
    [anon_sym_struct] = ACTIONS(2937),
    [anon_sym_enum] = ACTIONS(2937),
    [anon_sym_LBRACE] = ACTIONS(2939),
    [anon_sym_interface] = ACTIONS(2937),
    [anon_sym_delegate] = ACTIONS(2937),
    [anon_sym_record] = ACTIONS(2937),
    [anon_sym_abstract] = ACTIONS(2937),
    [anon_sym_async] = ACTIONS(2937),
    [anon_sym_const] = ACTIONS(2937),
    [anon_sym_file] = ACTIONS(2937),
    [anon_sym_fixed] = ACTIONS(2937),
    [anon_sym_internal] = ACTIONS(2937),
    [anon_sym_new] = ACTIONS(2937),
    [anon_sym_override] = ACTIONS(2937),
    [anon_sym_partial] = ACTIONS(2937),
    [anon_sym_private] = ACTIONS(2937),
    [anon_sym_protected] = ACTIONS(2937),
    [anon_sym_public] = ACTIONS(2937),
    [anon_sym_readonly] = ACTIONS(2937),
    [anon_sym_required] = ACTIONS(2937),
    [anon_sym_sealed] = ACTIONS(2937),
    [anon_sym_virtual] = ACTIONS(2937),
    [anon_sym_volatile] = ACTIONS(2937),
    [anon_sym_where] = ACTIONS(2937),
    [anon_sym_notnull] = ACTIONS(2937),
    [anon_sym_unmanaged] = ACTIONS(2937),
    [anon_sym_checked] = ACTIONS(2937),
    [anon_sym_BANG] = ACTIONS(2939),
    [anon_sym_TILDE] = ACTIONS(2939),
    [anon_sym_PLUS_PLUS] = ACTIONS(2939),
    [anon_sym_DASH_DASH] = ACTIONS(2939),
    [anon_sym_true] = ACTIONS(2937),
    [anon_sym_false] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(2937),
    [anon_sym_DASH] = ACTIONS(2937),
    [anon_sym_STAR] = ACTIONS(2939),
    [anon_sym_CARET] = ACTIONS(2939),
    [anon_sym_AMP] = ACTIONS(2939),
    [anon_sym_this] = ACTIONS(2937),
    [anon_sym_scoped] = ACTIONS(2937),
    [anon_sym_var] = ACTIONS(2937),
    [sym_predefined_type] = ACTIONS(2937),
    [anon_sym_break] = ACTIONS(2937),
    [anon_sym_unchecked] = ACTIONS(2937),
    [anon_sym_continue] = ACTIONS(2937),
    [anon_sym_do] = ACTIONS(2937),
    [anon_sym_while] = ACTIONS(2937),
    [anon_sym_for] = ACTIONS(2937),
    [anon_sym_lock] = ACTIONS(2937),
    [anon_sym_yield] = ACTIONS(2937),
    [anon_sym_switch] = ACTIONS(2937),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_throw] = ACTIONS(2937),
    [anon_sym_try] = ACTIONS(2937),
    [anon_sym_when] = ACTIONS(2937),
    [anon_sym_await] = ACTIONS(2937),
    [anon_sym_foreach] = ACTIONS(2937),
    [anon_sym_goto] = ACTIONS(2937),
    [anon_sym_if] = ACTIONS(2937),
    [anon_sym_else] = ACTIONS(2937),
    [anon_sym_DOT_DOT] = ACTIONS(2939),
    [anon_sym_from] = ACTIONS(2937),
    [anon_sym_into] = ACTIONS(2937),
    [anon_sym_join] = ACTIONS(2937),
    [anon_sym_on] = ACTIONS(2937),
    [anon_sym_equals] = ACTIONS(2937),
    [anon_sym_let] = ACTIONS(2937),
    [anon_sym_orderby] = ACTIONS(2937),
    [anon_sym_ascending] = ACTIONS(2937),
    [anon_sym_descending] = ACTIONS(2937),
    [anon_sym_group] = ACTIONS(2937),
    [anon_sym_by] = ACTIONS(2937),
    [anon_sym_select] = ACTIONS(2937),
    [anon_sym_DQUOTE] = ACTIONS(2937),
    [anon_sym_stackalloc] = ACTIONS(2937),
    [anon_sym_sizeof] = ACTIONS(2937),
    [anon_sym_typeof] = ACTIONS(2937),
    [anon_sym___makeref] = ACTIONS(2937),
    [anon_sym___reftype] = ACTIONS(2937),
    [anon_sym___refvalue] = ACTIONS(2937),
    [sym_null_literal] = ACTIONS(2937),
    [anon_sym_SQUOTE] = ACTIONS(2939),
    [sym_integer_literal] = ACTIONS(2937),
    [sym_real_literal] = ACTIONS(2939),
    [sym_verbatim_string_literal] = ACTIONS(2939),
    [sym_raw_string_literal] = ACTIONS(2939),
    [aux_sym_preproc_if_token1] = ACTIONS(2939),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(2939),
    [sym_interpolation_verbatim_start] = ACTIONS(2939),
    [sym_interpolation_raw_start] = ACTIONS(2939),
  },
  [2469] = {
    [sym_preproc_region] = STATE(2469),
    [sym_preproc_endregion] = STATE(2469),
    [sym_preproc_line] = STATE(2469),
    [sym_preproc_pragma] = STATE(2469),
    [sym_preproc_nullable] = STATE(2469),
    [sym_preproc_error] = STATE(2469),
    [sym_preproc_define] = STATE(2469),
    [sym_preproc_undef] = STATE(2469),
    [ts_builtin_sym_end] = ACTIONS(3321),
    [sym__identifier_token] = ACTIONS(3319),
    [anon_sym_extern] = ACTIONS(3319),
    [anon_sym_alias] = ACTIONS(3319),
    [anon_sym_SEMI] = ACTIONS(3321),
    [anon_sym_global] = ACTIONS(3319),
    [anon_sym_using] = ACTIONS(3319),
    [anon_sym_unsafe] = ACTIONS(3319),
    [anon_sym_static] = ACTIONS(3319),
    [anon_sym_LBRACK] = ACTIONS(3321),
    [anon_sym_LPAREN] = ACTIONS(3321),
    [anon_sym_return] = ACTIONS(3319),
    [anon_sym_namespace] = ACTIONS(3319),
    [anon_sym_class] = ACTIONS(3319),
    [anon_sym_ref] = ACTIONS(3319),
    [anon_sym_struct] = ACTIONS(3319),
    [anon_sym_enum] = ACTIONS(3319),
    [anon_sym_LBRACE] = ACTIONS(3321),
    [anon_sym_interface] = ACTIONS(3319),
    [anon_sym_delegate] = ACTIONS(3319),
    [anon_sym_record] = ACTIONS(3319),
    [anon_sym_abstract] = ACTIONS(3319),
    [anon_sym_async] = ACTIONS(3319),
    [anon_sym_const] = ACTIONS(3319),
    [anon_sym_file] = ACTIONS(3319),
    [anon_sym_fixed] = ACTIONS(3319),
    [anon_sym_internal] = ACTIONS(3319),
    [anon_sym_new] = ACTIONS(3319),
    [anon_sym_override] = ACTIONS(3319),
    [anon_sym_partial] = ACTIONS(3319),
    [anon_sym_private] = ACTIONS(3319),
    [anon_sym_protected] = ACTIONS(3319),
    [anon_sym_public] = ACTIONS(3319),
    [anon_sym_readonly] = ACTIONS(3319),
    [anon_sym_required] = ACTIONS(3319),
    [anon_sym_sealed] = ACTIONS(3319),
    [anon_sym_virtual] = ACTIONS(3319),
    [anon_sym_volatile] = ACTIONS(3319),
    [anon_sym_where] = ACTIONS(3319),
    [anon_sym_notnull] = ACTIONS(3319),
    [anon_sym_unmanaged] = ACTIONS(3319),
    [anon_sym_checked] = ACTIONS(3319),
    [anon_sym_BANG] = ACTIONS(3321),
    [anon_sym_TILDE] = ACTIONS(3321),
    [anon_sym_PLUS_PLUS] = ACTIONS(3321),
    [anon_sym_DASH_DASH] = ACTIONS(3321),
    [anon_sym_true] = ACTIONS(3319),
    [anon_sym_false] = ACTIONS(3319),
    [anon_sym_PLUS] = ACTIONS(3319),
    [anon_sym_DASH] = ACTIONS(3319),
    [anon_sym_STAR] = ACTIONS(3321),
    [anon_sym_CARET] = ACTIONS(3321),
    [anon_sym_AMP] = ACTIONS(3321),
    [anon_sym_this] = ACTIONS(3319),
    [anon_sym_scoped] = ACTIONS(3319),
    [anon_sym_var] = ACTIONS(3319),
    [sym_predefined_type] = ACTIONS(3319),
    [anon_sym_break] = ACTIONS(3319),
    [anon_sym_unchecked] = ACTIONS(3319),
    [anon_sym_continue] = ACTIONS(3319),
    [anon_sym_do] = ACTIONS(3319),
    [anon_sym_while] = ACTIONS(3319),
    [anon_sym_for] = ACTIONS(3319),
    [anon_sym_lock] = ACTIONS(3319),
    [anon_sym_yield] = ACTIONS(3319),
    [anon_sym_switch] = ACTIONS(3319),
    [anon_sym_default] = ACTIONS(3319),
    [anon_sym_throw] = ACTIONS(3319),
    [anon_sym_try] = ACTIONS(3319),
    [anon_sym_when] = ACTIONS(3319),
    [anon_sym_await] = ACTIONS(3319),
    [anon_sym_foreach] = ACTIONS(3319),
    [anon_sym_goto] = ACTIONS(3319),
    [anon_sym_if] = ACTIONS(3319),
    [anon_sym_else] = ACTIONS(3319),
    [anon_sym_DOT_DOT] = ACTIONS(3321),
    [anon_sym_from] = ACTIONS(3319),
    [anon_sym_into] = ACTIONS(3319),
    [anon_sym_join] = ACTIONS(3319),
    [anon_sym_on] = ACTIONS(3319),
    [anon_sym_equals] = ACTIONS(3319),
    [anon_sym_let] = ACTIONS(3319),
    [anon_sym_orderby] = ACTIONS(3319),
    [anon_sym_ascending] = ACTIONS(3319),
    [anon_sym_descending] = ACTIONS(3319),
    [anon_sym_group] = ACTIONS(3319),
    [anon_sym_by] = ACTIONS(3319),
    [anon_sym_select] = ACTIONS(3319),
    [anon_sym_DQUOTE] = ACTIONS(3319),
    [anon_sym_stackalloc] = ACTIONS(3319),
    [anon_sym_sizeof] = ACTIONS(3319),
    [anon_sym_typeof] = ACTIONS(3319),
    [anon_sym___makeref] = ACTIONS(3319),
    [anon_sym___reftype] = ACTIONS(3319),
    [anon_sym___refvalue] = ACTIONS(3319),
    [sym_null_literal] = ACTIONS(3319),
    [anon_sym_SQUOTE] = ACTIONS(3321),
    [sym_integer_literal] = ACTIONS(3319),
    [sym_real_literal] = ACTIONS(3321),
    [sym_verbatim_string_literal] = ACTIONS(3321),
    [sym_raw_string_literal] = ACTIONS(3321),
    [aux_sym_preproc_if_token1] = ACTIONS(3321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3321),
    [sym_interpolation_verbatim_start] = ACTIONS(3321),
    [sym_interpolation_raw_start] = ACTIONS(3321),
  },
  [2470] = {
    [sym_preproc_region] = STATE(2470),
    [sym_preproc_endregion] = STATE(2470),
    [sym_preproc_line] = STATE(2470),
    [sym_preproc_pragma] = STATE(2470),
    [sym_preproc_nullable] = STATE(2470),
    [sym_preproc_error] = STATE(2470),
    [sym_preproc_define] = STATE(2470),
    [sym_preproc_undef] = STATE(2470),
    [ts_builtin_sym_end] = ACTIONS(3353),
    [sym__identifier_token] = ACTIONS(3351),
    [anon_sym_extern] = ACTIONS(3351),
    [anon_sym_alias] = ACTIONS(3351),
    [anon_sym_SEMI] = ACTIONS(3353),
    [anon_sym_global] = ACTIONS(3351),
    [anon_sym_using] = ACTIONS(3351),
    [anon_sym_unsafe] = ACTIONS(3351),
    [anon_sym_static] = ACTIONS(3351),
    [anon_sym_LBRACK] = ACTIONS(3353),
    [anon_sym_LPAREN] = ACTIONS(3353),
    [anon_sym_return] = ACTIONS(3351),
    [anon_sym_namespace] = ACTIONS(3351),
    [anon_sym_class] = ACTIONS(3351),
    [anon_sym_ref] = ACTIONS(3351),
    [anon_sym_struct] = ACTIONS(3351),
    [anon_sym_enum] = ACTIONS(3351),
    [anon_sym_LBRACE] = ACTIONS(3353),
    [anon_sym_interface] = ACTIONS(3351),
    [anon_sym_delegate] = ACTIONS(3351),
    [anon_sym_record] = ACTIONS(3351),
    [anon_sym_abstract] = ACTIONS(3351),
    [anon_sym_async] = ACTIONS(3351),
    [anon_sym_const] = ACTIONS(3351),
    [anon_sym_file] = ACTIONS(3351),
    [anon_sym_fixed] = ACTIONS(3351),
    [anon_sym_internal] = ACTIONS(3351),
    [anon_sym_new] = ACTIONS(3351),
    [anon_sym_override] = ACTIONS(3351),
    [anon_sym_partial] = ACTIONS(3351),
    [anon_sym_private] = ACTIONS(3351),
    [anon_sym_protected] = ACTIONS(3351),
    [anon_sym_public] = ACTIONS(3351),
    [anon_sym_readonly] = ACTIONS(3351),
    [anon_sym_required] = ACTIONS(3351),
    [anon_sym_sealed] = ACTIONS(3351),
    [anon_sym_virtual] = ACTIONS(3351),
    [anon_sym_volatile] = ACTIONS(3351),
    [anon_sym_where] = ACTIONS(3351),
    [anon_sym_notnull] = ACTIONS(3351),
    [anon_sym_unmanaged] = ACTIONS(3351),
    [anon_sym_checked] = ACTIONS(3351),
    [anon_sym_BANG] = ACTIONS(3353),
    [anon_sym_TILDE] = ACTIONS(3353),
    [anon_sym_PLUS_PLUS] = ACTIONS(3353),
    [anon_sym_DASH_DASH] = ACTIONS(3353),
    [anon_sym_true] = ACTIONS(3351),
    [anon_sym_false] = ACTIONS(3351),
    [anon_sym_PLUS] = ACTIONS(3351),
    [anon_sym_DASH] = ACTIONS(3351),
    [anon_sym_STAR] = ACTIONS(3353),
    [anon_sym_CARET] = ACTIONS(3353),
    [anon_sym_AMP] = ACTIONS(3353),
    [anon_sym_this] = ACTIONS(3351),
    [anon_sym_scoped] = ACTIONS(3351),
    [anon_sym_var] = ACTIONS(3351),
    [sym_predefined_type] = ACTIONS(3351),
    [anon_sym_break] = ACTIONS(3351),
    [anon_sym_unchecked] = ACTIONS(3351),
    [anon_sym_continue] = ACTIONS(3351),
    [anon_sym_do] = ACTIONS(3351),
    [anon_sym_while] = ACTIONS(3351),
    [anon_sym_for] = ACTIONS(3351),
    [anon_sym_lock] = ACTIONS(3351),
    [anon_sym_yield] = ACTIONS(3351),
    [anon_sym_switch] = ACTIONS(3351),
    [anon_sym_default] = ACTIONS(3351),
    [anon_sym_throw] = ACTIONS(3351),
    [anon_sym_try] = ACTIONS(3351),
    [anon_sym_when] = ACTIONS(3351),
    [anon_sym_await] = ACTIONS(3351),
    [anon_sym_foreach] = ACTIONS(3351),
    [anon_sym_goto] = ACTIONS(3351),
    [anon_sym_if] = ACTIONS(3351),
    [anon_sym_else] = ACTIONS(3351),
    [anon_sym_DOT_DOT] = ACTIONS(3353),
    [anon_sym_from] = ACTIONS(3351),
    [anon_sym_into] = ACTIONS(3351),
    [anon_sym_join] = ACTIONS(3351),
    [anon_sym_on] = ACTIONS(3351),
    [anon_sym_equals] = ACTIONS(3351),
    [anon_sym_let] = ACTIONS(3351),
    [anon_sym_orderby] = ACTIONS(3351),
    [anon_sym_ascending] = ACTIONS(3351),
    [anon_sym_descending] = ACTIONS(3351),
    [anon_sym_group] = ACTIONS(3351),
    [anon_sym_by] = ACTIONS(3351),
    [anon_sym_select] = ACTIONS(3351),
    [anon_sym_DQUOTE] = ACTIONS(3351),
    [anon_sym_stackalloc] = ACTIONS(3351),
    [anon_sym_sizeof] = ACTIONS(3351),
    [anon_sym_typeof] = ACTIONS(3351),
    [anon_sym___makeref] = ACTIONS(3351),
    [anon_sym___reftype] = ACTIONS(3351),
    [anon_sym___refvalue] = ACTIONS(3351),
    [sym_null_literal] = ACTIONS(3351),
    [anon_sym_SQUOTE] = ACTIONS(3353),
    [sym_integer_literal] = ACTIONS(3351),
    [sym_real_literal] = ACTIONS(3353),
    [sym_verbatim_string_literal] = ACTIONS(3353),
    [sym_raw_string_literal] = ACTIONS(3353),
    [aux_sym_preproc_if_token1] = ACTIONS(3353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3353),
    [sym_interpolation_verbatim_start] = ACTIONS(3353),
    [sym_interpolation_raw_start] = ACTIONS(3353),
  },
  [2471] = {
    [sym_preproc_region] = STATE(2471),
    [sym_preproc_endregion] = STATE(2471),
    [sym_preproc_line] = STATE(2471),
    [sym_preproc_pragma] = STATE(2471),
    [sym_preproc_nullable] = STATE(2471),
    [sym_preproc_error] = STATE(2471),
    [sym_preproc_define] = STATE(2471),
    [sym_preproc_undef] = STATE(2471),
    [ts_builtin_sym_end] = ACTIONS(3377),
    [sym__identifier_token] = ACTIONS(3375),
    [anon_sym_extern] = ACTIONS(3375),
    [anon_sym_alias] = ACTIONS(3375),
    [anon_sym_SEMI] = ACTIONS(3377),
    [anon_sym_global] = ACTIONS(3375),
    [anon_sym_using] = ACTIONS(3375),
    [anon_sym_unsafe] = ACTIONS(3375),
    [anon_sym_static] = ACTIONS(3375),
    [anon_sym_LBRACK] = ACTIONS(3377),
    [anon_sym_LPAREN] = ACTIONS(3377),
    [anon_sym_return] = ACTIONS(3375),
    [anon_sym_namespace] = ACTIONS(3375),
    [anon_sym_class] = ACTIONS(3375),
    [anon_sym_ref] = ACTIONS(3375),
    [anon_sym_struct] = ACTIONS(3375),
    [anon_sym_enum] = ACTIONS(3375),
    [anon_sym_LBRACE] = ACTIONS(3377),
    [anon_sym_interface] = ACTIONS(3375),
    [anon_sym_delegate] = ACTIONS(3375),
    [anon_sym_record] = ACTIONS(3375),
    [anon_sym_abstract] = ACTIONS(3375),
    [anon_sym_async] = ACTIONS(3375),
    [anon_sym_const] = ACTIONS(3375),
    [anon_sym_file] = ACTIONS(3375),
    [anon_sym_fixed] = ACTIONS(3375),
    [anon_sym_internal] = ACTIONS(3375),
    [anon_sym_new] = ACTIONS(3375),
    [anon_sym_override] = ACTIONS(3375),
    [anon_sym_partial] = ACTIONS(3375),
    [anon_sym_private] = ACTIONS(3375),
    [anon_sym_protected] = ACTIONS(3375),
    [anon_sym_public] = ACTIONS(3375),
    [anon_sym_readonly] = ACTIONS(3375),
    [anon_sym_required] = ACTIONS(3375),
    [anon_sym_sealed] = ACTIONS(3375),
    [anon_sym_virtual] = ACTIONS(3375),
    [anon_sym_volatile] = ACTIONS(3375),
    [anon_sym_where] = ACTIONS(3375),
    [anon_sym_notnull] = ACTIONS(3375),
    [anon_sym_unmanaged] = ACTIONS(3375),
    [anon_sym_checked] = ACTIONS(3375),
    [anon_sym_BANG] = ACTIONS(3377),
    [anon_sym_TILDE] = ACTIONS(3377),
    [anon_sym_PLUS_PLUS] = ACTIONS(3377),
    [anon_sym_DASH_DASH] = ACTIONS(3377),
    [anon_sym_true] = ACTIONS(3375),
    [anon_sym_false] = ACTIONS(3375),
    [anon_sym_PLUS] = ACTIONS(3375),
    [anon_sym_DASH] = ACTIONS(3375),
    [anon_sym_STAR] = ACTIONS(3377),
    [anon_sym_CARET] = ACTIONS(3377),
    [anon_sym_AMP] = ACTIONS(3377),
    [anon_sym_this] = ACTIONS(3375),
    [anon_sym_scoped] = ACTIONS(3375),
    [anon_sym_var] = ACTIONS(3375),
    [sym_predefined_type] = ACTIONS(3375),
    [anon_sym_break] = ACTIONS(3375),
    [anon_sym_unchecked] = ACTIONS(3375),
    [anon_sym_continue] = ACTIONS(3375),
    [anon_sym_do] = ACTIONS(3375),
    [anon_sym_while] = ACTIONS(3375),
    [anon_sym_for] = ACTIONS(3375),
    [anon_sym_lock] = ACTIONS(3375),
    [anon_sym_yield] = ACTIONS(3375),
    [anon_sym_switch] = ACTIONS(3375),
    [anon_sym_default] = ACTIONS(3375),
    [anon_sym_throw] = ACTIONS(3375),
    [anon_sym_try] = ACTIONS(3375),
    [anon_sym_when] = ACTIONS(3375),
    [anon_sym_await] = ACTIONS(3375),
    [anon_sym_foreach] = ACTIONS(3375),
    [anon_sym_goto] = ACTIONS(3375),
    [anon_sym_if] = ACTIONS(3375),
    [anon_sym_else] = ACTIONS(3375),
    [anon_sym_DOT_DOT] = ACTIONS(3377),
    [anon_sym_from] = ACTIONS(3375),
    [anon_sym_into] = ACTIONS(3375),
    [anon_sym_join] = ACTIONS(3375),
    [anon_sym_on] = ACTIONS(3375),
    [anon_sym_equals] = ACTIONS(3375),
    [anon_sym_let] = ACTIONS(3375),
    [anon_sym_orderby] = ACTIONS(3375),
    [anon_sym_ascending] = ACTIONS(3375),
    [anon_sym_descending] = ACTIONS(3375),
    [anon_sym_group] = ACTIONS(3375),
    [anon_sym_by] = ACTIONS(3375),
    [anon_sym_select] = ACTIONS(3375),
    [anon_sym_DQUOTE] = ACTIONS(3375),
    [anon_sym_stackalloc] = ACTIONS(3375),
    [anon_sym_sizeof] = ACTIONS(3375),
    [anon_sym_typeof] = ACTIONS(3375),
    [anon_sym___makeref] = ACTIONS(3375),
    [anon_sym___reftype] = ACTIONS(3375),
    [anon_sym___refvalue] = ACTIONS(3375),
    [sym_null_literal] = ACTIONS(3375),
    [anon_sym_SQUOTE] = ACTIONS(3377),
    [sym_integer_literal] = ACTIONS(3375),
    [sym_real_literal] = ACTIONS(3377),
    [sym_verbatim_string_literal] = ACTIONS(3377),
    [sym_raw_string_literal] = ACTIONS(3377),
    [aux_sym_preproc_if_token1] = ACTIONS(3377),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3377),
    [sym_interpolation_verbatim_start] = ACTIONS(3377),
    [sym_interpolation_raw_start] = ACTIONS(3377),
  },
  [2472] = {
    [sym_preproc_region] = STATE(2472),
    [sym_preproc_endregion] = STATE(2472),
    [sym_preproc_line] = STATE(2472),
    [sym_preproc_pragma] = STATE(2472),
    [sym_preproc_nullable] = STATE(2472),
    [sym_preproc_error] = STATE(2472),
    [sym_preproc_define] = STATE(2472),
    [sym_preproc_undef] = STATE(2472),
    [ts_builtin_sym_end] = ACTIONS(3043),
    [sym__identifier_token] = ACTIONS(3041),
    [anon_sym_extern] = ACTIONS(3041),
    [anon_sym_alias] = ACTIONS(3041),
    [anon_sym_SEMI] = ACTIONS(3043),
    [anon_sym_global] = ACTIONS(3041),
    [anon_sym_using] = ACTIONS(3041),
    [anon_sym_unsafe] = ACTIONS(3041),
    [anon_sym_static] = ACTIONS(3041),
    [anon_sym_LBRACK] = ACTIONS(3043),
    [anon_sym_LPAREN] = ACTIONS(3043),
    [anon_sym_return] = ACTIONS(3041),
    [anon_sym_namespace] = ACTIONS(3041),
    [anon_sym_class] = ACTIONS(3041),
    [anon_sym_ref] = ACTIONS(3041),
    [anon_sym_struct] = ACTIONS(3041),
    [anon_sym_enum] = ACTIONS(3041),
    [anon_sym_LBRACE] = ACTIONS(3043),
    [anon_sym_interface] = ACTIONS(3041),
    [anon_sym_delegate] = ACTIONS(3041),
    [anon_sym_record] = ACTIONS(3041),
    [anon_sym_abstract] = ACTIONS(3041),
    [anon_sym_async] = ACTIONS(3041),
    [anon_sym_const] = ACTIONS(3041),
    [anon_sym_file] = ACTIONS(3041),
    [anon_sym_fixed] = ACTIONS(3041),
    [anon_sym_internal] = ACTIONS(3041),
    [anon_sym_new] = ACTIONS(3041),
    [anon_sym_override] = ACTIONS(3041),
    [anon_sym_partial] = ACTIONS(3041),
    [anon_sym_private] = ACTIONS(3041),
    [anon_sym_protected] = ACTIONS(3041),
    [anon_sym_public] = ACTIONS(3041),
    [anon_sym_readonly] = ACTIONS(3041),
    [anon_sym_required] = ACTIONS(3041),
    [anon_sym_sealed] = ACTIONS(3041),
    [anon_sym_virtual] = ACTIONS(3041),
    [anon_sym_volatile] = ACTIONS(3041),
    [anon_sym_where] = ACTIONS(3041),
    [anon_sym_notnull] = ACTIONS(3041),
    [anon_sym_unmanaged] = ACTIONS(3041),
    [anon_sym_checked] = ACTIONS(3041),
    [anon_sym_BANG] = ACTIONS(3043),
    [anon_sym_TILDE] = ACTIONS(3043),
    [anon_sym_PLUS_PLUS] = ACTIONS(3043),
    [anon_sym_DASH_DASH] = ACTIONS(3043),
    [anon_sym_true] = ACTIONS(3041),
    [anon_sym_false] = ACTIONS(3041),
    [anon_sym_PLUS] = ACTIONS(3041),
    [anon_sym_DASH] = ACTIONS(3041),
    [anon_sym_STAR] = ACTIONS(3043),
    [anon_sym_CARET] = ACTIONS(3043),
    [anon_sym_AMP] = ACTIONS(3043),
    [anon_sym_this] = ACTIONS(3041),
    [anon_sym_scoped] = ACTIONS(3041),
    [anon_sym_var] = ACTIONS(3041),
    [sym_predefined_type] = ACTIONS(3041),
    [anon_sym_break] = ACTIONS(3041),
    [anon_sym_unchecked] = ACTIONS(3041),
    [anon_sym_continue] = ACTIONS(3041),
    [anon_sym_do] = ACTIONS(3041),
    [anon_sym_while] = ACTIONS(3041),
    [anon_sym_for] = ACTIONS(3041),
    [anon_sym_lock] = ACTIONS(3041),
    [anon_sym_yield] = ACTIONS(3041),
    [anon_sym_switch] = ACTIONS(3041),
    [anon_sym_default] = ACTIONS(3041),
    [anon_sym_throw] = ACTIONS(3041),
    [anon_sym_try] = ACTIONS(3041),
    [anon_sym_when] = ACTIONS(3041),
    [anon_sym_await] = ACTIONS(3041),
    [anon_sym_foreach] = ACTIONS(3041),
    [anon_sym_goto] = ACTIONS(3041),
    [anon_sym_if] = ACTIONS(3041),
    [anon_sym_else] = ACTIONS(3041),
    [anon_sym_DOT_DOT] = ACTIONS(3043),
    [anon_sym_from] = ACTIONS(3041),
    [anon_sym_into] = ACTIONS(3041),
    [anon_sym_join] = ACTIONS(3041),
    [anon_sym_on] = ACTIONS(3041),
    [anon_sym_equals] = ACTIONS(3041),
    [anon_sym_let] = ACTIONS(3041),
    [anon_sym_orderby] = ACTIONS(3041),
    [anon_sym_ascending] = ACTIONS(3041),
    [anon_sym_descending] = ACTIONS(3041),
    [anon_sym_group] = ACTIONS(3041),
    [anon_sym_by] = ACTIONS(3041),
    [anon_sym_select] = ACTIONS(3041),
    [anon_sym_DQUOTE] = ACTIONS(3041),
    [anon_sym_stackalloc] = ACTIONS(3041),
    [anon_sym_sizeof] = ACTIONS(3041),
    [anon_sym_typeof] = ACTIONS(3041),
    [anon_sym___makeref] = ACTIONS(3041),
    [anon_sym___reftype] = ACTIONS(3041),
    [anon_sym___refvalue] = ACTIONS(3041),
    [sym_null_literal] = ACTIONS(3041),
    [anon_sym_SQUOTE] = ACTIONS(3043),
    [sym_integer_literal] = ACTIONS(3041),
    [sym_real_literal] = ACTIONS(3043),
    [sym_verbatim_string_literal] = ACTIONS(3043),
    [sym_raw_string_literal] = ACTIONS(3043),
    [aux_sym_preproc_if_token1] = ACTIONS(3043),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3043),
    [sym_interpolation_verbatim_start] = ACTIONS(3043),
    [sym_interpolation_raw_start] = ACTIONS(3043),
  },
  [2473] = {
    [sym_preproc_region] = STATE(2473),
    [sym_preproc_endregion] = STATE(2473),
    [sym_preproc_line] = STATE(2473),
    [sym_preproc_pragma] = STATE(2473),
    [sym_preproc_nullable] = STATE(2473),
    [sym_preproc_error] = STATE(2473),
    [sym_preproc_define] = STATE(2473),
    [sym_preproc_undef] = STATE(2473),
    [ts_builtin_sym_end] = ACTIONS(3221),
    [sym__identifier_token] = ACTIONS(3219),
    [anon_sym_extern] = ACTIONS(3219),
    [anon_sym_alias] = ACTIONS(3219),
    [anon_sym_SEMI] = ACTIONS(3221),
    [anon_sym_global] = ACTIONS(3219),
    [anon_sym_using] = ACTIONS(3219),
    [anon_sym_unsafe] = ACTIONS(3219),
    [anon_sym_static] = ACTIONS(3219),
    [anon_sym_LBRACK] = ACTIONS(3221),
    [anon_sym_LPAREN] = ACTIONS(3221),
    [anon_sym_return] = ACTIONS(3219),
    [anon_sym_namespace] = ACTIONS(3219),
    [anon_sym_class] = ACTIONS(3219),
    [anon_sym_ref] = ACTIONS(3219),
    [anon_sym_struct] = ACTIONS(3219),
    [anon_sym_enum] = ACTIONS(3219),
    [anon_sym_LBRACE] = ACTIONS(3221),
    [anon_sym_interface] = ACTIONS(3219),
    [anon_sym_delegate] = ACTIONS(3219),
    [anon_sym_record] = ACTIONS(3219),
    [anon_sym_abstract] = ACTIONS(3219),
    [anon_sym_async] = ACTIONS(3219),
    [anon_sym_const] = ACTIONS(3219),
    [anon_sym_file] = ACTIONS(3219),
    [anon_sym_fixed] = ACTIONS(3219),
    [anon_sym_internal] = ACTIONS(3219),
    [anon_sym_new] = ACTIONS(3219),
    [anon_sym_override] = ACTIONS(3219),
    [anon_sym_partial] = ACTIONS(3219),
    [anon_sym_private] = ACTIONS(3219),
    [anon_sym_protected] = ACTIONS(3219),
    [anon_sym_public] = ACTIONS(3219),
    [anon_sym_readonly] = ACTIONS(3219),
    [anon_sym_required] = ACTIONS(3219),
    [anon_sym_sealed] = ACTIONS(3219),
    [anon_sym_virtual] = ACTIONS(3219),
    [anon_sym_volatile] = ACTIONS(3219),
    [anon_sym_where] = ACTIONS(3219),
    [anon_sym_notnull] = ACTIONS(3219),
    [anon_sym_unmanaged] = ACTIONS(3219),
    [anon_sym_checked] = ACTIONS(3219),
    [anon_sym_BANG] = ACTIONS(3221),
    [anon_sym_TILDE] = ACTIONS(3221),
    [anon_sym_PLUS_PLUS] = ACTIONS(3221),
    [anon_sym_DASH_DASH] = ACTIONS(3221),
    [anon_sym_true] = ACTIONS(3219),
    [anon_sym_false] = ACTIONS(3219),
    [anon_sym_PLUS] = ACTIONS(3219),
    [anon_sym_DASH] = ACTIONS(3219),
    [anon_sym_STAR] = ACTIONS(3221),
    [anon_sym_CARET] = ACTIONS(3221),
    [anon_sym_AMP] = ACTIONS(3221),
    [anon_sym_this] = ACTIONS(3219),
    [anon_sym_scoped] = ACTIONS(3219),
    [anon_sym_var] = ACTIONS(3219),
    [sym_predefined_type] = ACTIONS(3219),
    [anon_sym_break] = ACTIONS(3219),
    [anon_sym_unchecked] = ACTIONS(3219),
    [anon_sym_continue] = ACTIONS(3219),
    [anon_sym_do] = ACTIONS(3219),
    [anon_sym_while] = ACTIONS(3219),
    [anon_sym_for] = ACTIONS(3219),
    [anon_sym_lock] = ACTIONS(3219),
    [anon_sym_yield] = ACTIONS(3219),
    [anon_sym_switch] = ACTIONS(3219),
    [anon_sym_default] = ACTIONS(3219),
    [anon_sym_throw] = ACTIONS(3219),
    [anon_sym_try] = ACTIONS(3219),
    [anon_sym_when] = ACTIONS(3219),
    [anon_sym_await] = ACTIONS(3219),
    [anon_sym_foreach] = ACTIONS(3219),
    [anon_sym_goto] = ACTIONS(3219),
    [anon_sym_if] = ACTIONS(3219),
    [anon_sym_else] = ACTIONS(3219),
    [anon_sym_DOT_DOT] = ACTIONS(3221),
    [anon_sym_from] = ACTIONS(3219),
    [anon_sym_into] = ACTIONS(3219),
    [anon_sym_join] = ACTIONS(3219),
    [anon_sym_on] = ACTIONS(3219),
    [anon_sym_equals] = ACTIONS(3219),
    [anon_sym_let] = ACTIONS(3219),
    [anon_sym_orderby] = ACTIONS(3219),
    [anon_sym_ascending] = ACTIONS(3219),
    [anon_sym_descending] = ACTIONS(3219),
    [anon_sym_group] = ACTIONS(3219),
    [anon_sym_by] = ACTIONS(3219),
    [anon_sym_select] = ACTIONS(3219),
    [anon_sym_DQUOTE] = ACTIONS(3219),
    [anon_sym_stackalloc] = ACTIONS(3219),
    [anon_sym_sizeof] = ACTIONS(3219),
    [anon_sym_typeof] = ACTIONS(3219),
    [anon_sym___makeref] = ACTIONS(3219),
    [anon_sym___reftype] = ACTIONS(3219),
    [anon_sym___refvalue] = ACTIONS(3219),
    [sym_null_literal] = ACTIONS(3219),
    [anon_sym_SQUOTE] = ACTIONS(3221),
    [sym_integer_literal] = ACTIONS(3219),
    [sym_real_literal] = ACTIONS(3221),
    [sym_verbatim_string_literal] = ACTIONS(3221),
    [sym_raw_string_literal] = ACTIONS(3221),
    [aux_sym_preproc_if_token1] = ACTIONS(3221),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3221),
    [sym_interpolation_verbatim_start] = ACTIONS(3221),
    [sym_interpolation_raw_start] = ACTIONS(3221),
  },
  [2474] = {
    [sym_preproc_region] = STATE(2474),
    [sym_preproc_endregion] = STATE(2474),
    [sym_preproc_line] = STATE(2474),
    [sym_preproc_pragma] = STATE(2474),
    [sym_preproc_nullable] = STATE(2474),
    [sym_preproc_error] = STATE(2474),
    [sym_preproc_define] = STATE(2474),
    [sym_preproc_undef] = STATE(2474),
    [ts_builtin_sym_end] = ACTIONS(3381),
    [sym__identifier_token] = ACTIONS(3379),
    [anon_sym_extern] = ACTIONS(3379),
    [anon_sym_alias] = ACTIONS(3379),
    [anon_sym_SEMI] = ACTIONS(3381),
    [anon_sym_global] = ACTIONS(3379),
    [anon_sym_using] = ACTIONS(3379),
    [anon_sym_unsafe] = ACTIONS(3379),
    [anon_sym_static] = ACTIONS(3379),
    [anon_sym_LBRACK] = ACTIONS(3381),
    [anon_sym_LPAREN] = ACTIONS(3381),
    [anon_sym_return] = ACTIONS(3379),
    [anon_sym_namespace] = ACTIONS(3379),
    [anon_sym_class] = ACTIONS(3379),
    [anon_sym_ref] = ACTIONS(3379),
    [anon_sym_struct] = ACTIONS(3379),
    [anon_sym_enum] = ACTIONS(3379),
    [anon_sym_LBRACE] = ACTIONS(3381),
    [anon_sym_interface] = ACTIONS(3379),
    [anon_sym_delegate] = ACTIONS(3379),
    [anon_sym_record] = ACTIONS(3379),
    [anon_sym_abstract] = ACTIONS(3379),
    [anon_sym_async] = ACTIONS(3379),
    [anon_sym_const] = ACTIONS(3379),
    [anon_sym_file] = ACTIONS(3379),
    [anon_sym_fixed] = ACTIONS(3379),
    [anon_sym_internal] = ACTIONS(3379),
    [anon_sym_new] = ACTIONS(3379),
    [anon_sym_override] = ACTIONS(3379),
    [anon_sym_partial] = ACTIONS(3379),
    [anon_sym_private] = ACTIONS(3379),
    [anon_sym_protected] = ACTIONS(3379),
    [anon_sym_public] = ACTIONS(3379),
    [anon_sym_readonly] = ACTIONS(3379),
    [anon_sym_required] = ACTIONS(3379),
    [anon_sym_sealed] = ACTIONS(3379),
    [anon_sym_virtual] = ACTIONS(3379),
    [anon_sym_volatile] = ACTIONS(3379),
    [anon_sym_where] = ACTIONS(3379),
    [anon_sym_notnull] = ACTIONS(3379),
    [anon_sym_unmanaged] = ACTIONS(3379),
    [anon_sym_checked] = ACTIONS(3379),
    [anon_sym_BANG] = ACTIONS(3381),
    [anon_sym_TILDE] = ACTIONS(3381),
    [anon_sym_PLUS_PLUS] = ACTIONS(3381),
    [anon_sym_DASH_DASH] = ACTIONS(3381),
    [anon_sym_true] = ACTIONS(3379),
    [anon_sym_false] = ACTIONS(3379),
    [anon_sym_PLUS] = ACTIONS(3379),
    [anon_sym_DASH] = ACTIONS(3379),
    [anon_sym_STAR] = ACTIONS(3381),
    [anon_sym_CARET] = ACTIONS(3381),
    [anon_sym_AMP] = ACTIONS(3381),
    [anon_sym_this] = ACTIONS(3379),
    [anon_sym_scoped] = ACTIONS(3379),
    [anon_sym_var] = ACTIONS(3379),
    [sym_predefined_type] = ACTIONS(3379),
    [anon_sym_break] = ACTIONS(3379),
    [anon_sym_unchecked] = ACTIONS(3379),
    [anon_sym_continue] = ACTIONS(3379),
    [anon_sym_do] = ACTIONS(3379),
    [anon_sym_while] = ACTIONS(3379),
    [anon_sym_for] = ACTIONS(3379),
    [anon_sym_lock] = ACTIONS(3379),
    [anon_sym_yield] = ACTIONS(3379),
    [anon_sym_switch] = ACTIONS(3379),
    [anon_sym_default] = ACTIONS(3379),
    [anon_sym_throw] = ACTIONS(3379),
    [anon_sym_try] = ACTIONS(3379),
    [anon_sym_when] = ACTIONS(3379),
    [anon_sym_await] = ACTIONS(3379),
    [anon_sym_foreach] = ACTIONS(3379),
    [anon_sym_goto] = ACTIONS(3379),
    [anon_sym_if] = ACTIONS(3379),
    [anon_sym_else] = ACTIONS(3379),
    [anon_sym_DOT_DOT] = ACTIONS(3381),
    [anon_sym_from] = ACTIONS(3379),
    [anon_sym_into] = ACTIONS(3379),
    [anon_sym_join] = ACTIONS(3379),
    [anon_sym_on] = ACTIONS(3379),
    [anon_sym_equals] = ACTIONS(3379),
    [anon_sym_let] = ACTIONS(3379),
    [anon_sym_orderby] = ACTIONS(3379),
    [anon_sym_ascending] = ACTIONS(3379),
    [anon_sym_descending] = ACTIONS(3379),
    [anon_sym_group] = ACTIONS(3379),
    [anon_sym_by] = ACTIONS(3379),
    [anon_sym_select] = ACTIONS(3379),
    [anon_sym_DQUOTE] = ACTIONS(3379),
    [anon_sym_stackalloc] = ACTIONS(3379),
    [anon_sym_sizeof] = ACTIONS(3379),
    [anon_sym_typeof] = ACTIONS(3379),
    [anon_sym___makeref] = ACTIONS(3379),
    [anon_sym___reftype] = ACTIONS(3379),
    [anon_sym___refvalue] = ACTIONS(3379),
    [sym_null_literal] = ACTIONS(3379),
    [anon_sym_SQUOTE] = ACTIONS(3381),
    [sym_integer_literal] = ACTIONS(3379),
    [sym_real_literal] = ACTIONS(3381),
    [sym_verbatim_string_literal] = ACTIONS(3381),
    [sym_raw_string_literal] = ACTIONS(3381),
    [aux_sym_preproc_if_token1] = ACTIONS(3381),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3381),
    [sym_interpolation_verbatim_start] = ACTIONS(3381),
    [sym_interpolation_raw_start] = ACTIONS(3381),
  },
  [2475] = {
    [sym_preproc_region] = STATE(2475),
    [sym_preproc_endregion] = STATE(2475),
    [sym_preproc_line] = STATE(2475),
    [sym_preproc_pragma] = STATE(2475),
    [sym_preproc_nullable] = STATE(2475),
    [sym_preproc_error] = STATE(2475),
    [sym_preproc_define] = STATE(2475),
    [sym_preproc_undef] = STATE(2475),
    [ts_builtin_sym_end] = ACTIONS(3225),
    [sym__identifier_token] = ACTIONS(3223),
    [anon_sym_extern] = ACTIONS(3223),
    [anon_sym_alias] = ACTIONS(3223),
    [anon_sym_SEMI] = ACTIONS(3225),
    [anon_sym_global] = ACTIONS(3223),
    [anon_sym_using] = ACTIONS(3223),
    [anon_sym_unsafe] = ACTIONS(3223),
    [anon_sym_static] = ACTIONS(3223),
    [anon_sym_LBRACK] = ACTIONS(3225),
    [anon_sym_LPAREN] = ACTIONS(3225),
    [anon_sym_return] = ACTIONS(3223),
    [anon_sym_namespace] = ACTIONS(3223),
    [anon_sym_class] = ACTIONS(3223),
    [anon_sym_ref] = ACTIONS(3223),
    [anon_sym_struct] = ACTIONS(3223),
    [anon_sym_enum] = ACTIONS(3223),
    [anon_sym_LBRACE] = ACTIONS(3225),
    [anon_sym_interface] = ACTIONS(3223),
    [anon_sym_delegate] = ACTIONS(3223),
    [anon_sym_record] = ACTIONS(3223),
    [anon_sym_abstract] = ACTIONS(3223),
    [anon_sym_async] = ACTIONS(3223),
    [anon_sym_const] = ACTIONS(3223),
    [anon_sym_file] = ACTIONS(3223),
    [anon_sym_fixed] = ACTIONS(3223),
    [anon_sym_internal] = ACTIONS(3223),
    [anon_sym_new] = ACTIONS(3223),
    [anon_sym_override] = ACTIONS(3223),
    [anon_sym_partial] = ACTIONS(3223),
    [anon_sym_private] = ACTIONS(3223),
    [anon_sym_protected] = ACTIONS(3223),
    [anon_sym_public] = ACTIONS(3223),
    [anon_sym_readonly] = ACTIONS(3223),
    [anon_sym_required] = ACTIONS(3223),
    [anon_sym_sealed] = ACTIONS(3223),
    [anon_sym_virtual] = ACTIONS(3223),
    [anon_sym_volatile] = ACTIONS(3223),
    [anon_sym_where] = ACTIONS(3223),
    [anon_sym_notnull] = ACTIONS(3223),
    [anon_sym_unmanaged] = ACTIONS(3223),
    [anon_sym_checked] = ACTIONS(3223),
    [anon_sym_BANG] = ACTIONS(3225),
    [anon_sym_TILDE] = ACTIONS(3225),
    [anon_sym_PLUS_PLUS] = ACTIONS(3225),
    [anon_sym_DASH_DASH] = ACTIONS(3225),
    [anon_sym_true] = ACTIONS(3223),
    [anon_sym_false] = ACTIONS(3223),
    [anon_sym_PLUS] = ACTIONS(3223),
    [anon_sym_DASH] = ACTIONS(3223),
    [anon_sym_STAR] = ACTIONS(3225),
    [anon_sym_CARET] = ACTIONS(3225),
    [anon_sym_AMP] = ACTIONS(3225),
    [anon_sym_this] = ACTIONS(3223),
    [anon_sym_scoped] = ACTIONS(3223),
    [anon_sym_var] = ACTIONS(3223),
    [sym_predefined_type] = ACTIONS(3223),
    [anon_sym_break] = ACTIONS(3223),
    [anon_sym_unchecked] = ACTIONS(3223),
    [anon_sym_continue] = ACTIONS(3223),
    [anon_sym_do] = ACTIONS(3223),
    [anon_sym_while] = ACTIONS(3223),
    [anon_sym_for] = ACTIONS(3223),
    [anon_sym_lock] = ACTIONS(3223),
    [anon_sym_yield] = ACTIONS(3223),
    [anon_sym_switch] = ACTIONS(3223),
    [anon_sym_default] = ACTIONS(3223),
    [anon_sym_throw] = ACTIONS(3223),
    [anon_sym_try] = ACTIONS(3223),
    [anon_sym_when] = ACTIONS(3223),
    [anon_sym_await] = ACTIONS(3223),
    [anon_sym_foreach] = ACTIONS(3223),
    [anon_sym_goto] = ACTIONS(3223),
    [anon_sym_if] = ACTIONS(3223),
    [anon_sym_else] = ACTIONS(3223),
    [anon_sym_DOT_DOT] = ACTIONS(3225),
    [anon_sym_from] = ACTIONS(3223),
    [anon_sym_into] = ACTIONS(3223),
    [anon_sym_join] = ACTIONS(3223),
    [anon_sym_on] = ACTIONS(3223),
    [anon_sym_equals] = ACTIONS(3223),
    [anon_sym_let] = ACTIONS(3223),
    [anon_sym_orderby] = ACTIONS(3223),
    [anon_sym_ascending] = ACTIONS(3223),
    [anon_sym_descending] = ACTIONS(3223),
    [anon_sym_group] = ACTIONS(3223),
    [anon_sym_by] = ACTIONS(3223),
    [anon_sym_select] = ACTIONS(3223),
    [anon_sym_DQUOTE] = ACTIONS(3223),
    [anon_sym_stackalloc] = ACTIONS(3223),
    [anon_sym_sizeof] = ACTIONS(3223),
    [anon_sym_typeof] = ACTIONS(3223),
    [anon_sym___makeref] = ACTIONS(3223),
    [anon_sym___reftype] = ACTIONS(3223),
    [anon_sym___refvalue] = ACTIONS(3223),
    [sym_null_literal] = ACTIONS(3223),
    [anon_sym_SQUOTE] = ACTIONS(3225),
    [sym_integer_literal] = ACTIONS(3223),
    [sym_real_literal] = ACTIONS(3225),
    [sym_verbatim_string_literal] = ACTIONS(3225),
    [sym_raw_string_literal] = ACTIONS(3225),
    [aux_sym_preproc_if_token1] = ACTIONS(3225),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3225),
    [sym_interpolation_verbatim_start] = ACTIONS(3225),
    [sym_interpolation_raw_start] = ACTIONS(3225),
  },
  [2476] = {
    [sym_preproc_region] = STATE(2476),
    [sym_preproc_endregion] = STATE(2476),
    [sym_preproc_line] = STATE(2476),
    [sym_preproc_pragma] = STATE(2476),
    [sym_preproc_nullable] = STATE(2476),
    [sym_preproc_error] = STATE(2476),
    [sym_preproc_define] = STATE(2476),
    [sym_preproc_undef] = STATE(2476),
    [ts_builtin_sym_end] = ACTIONS(3047),
    [sym__identifier_token] = ACTIONS(3045),
    [anon_sym_extern] = ACTIONS(3045),
    [anon_sym_alias] = ACTIONS(3045),
    [anon_sym_SEMI] = ACTIONS(3047),
    [anon_sym_global] = ACTIONS(3045),
    [anon_sym_using] = ACTIONS(3045),
    [anon_sym_unsafe] = ACTIONS(3045),
    [anon_sym_static] = ACTIONS(3045),
    [anon_sym_LBRACK] = ACTIONS(3047),
    [anon_sym_LPAREN] = ACTIONS(3047),
    [anon_sym_return] = ACTIONS(3045),
    [anon_sym_namespace] = ACTIONS(3045),
    [anon_sym_class] = ACTIONS(3045),
    [anon_sym_ref] = ACTIONS(3045),
    [anon_sym_struct] = ACTIONS(3045),
    [anon_sym_enum] = ACTIONS(3045),
    [anon_sym_LBRACE] = ACTIONS(3047),
    [anon_sym_interface] = ACTIONS(3045),
    [anon_sym_delegate] = ACTIONS(3045),
    [anon_sym_record] = ACTIONS(3045),
    [anon_sym_abstract] = ACTIONS(3045),
    [anon_sym_async] = ACTIONS(3045),
    [anon_sym_const] = ACTIONS(3045),
    [anon_sym_file] = ACTIONS(3045),
    [anon_sym_fixed] = ACTIONS(3045),
    [anon_sym_internal] = ACTIONS(3045),
    [anon_sym_new] = ACTIONS(3045),
    [anon_sym_override] = ACTIONS(3045),
    [anon_sym_partial] = ACTIONS(3045),
    [anon_sym_private] = ACTIONS(3045),
    [anon_sym_protected] = ACTIONS(3045),
    [anon_sym_public] = ACTIONS(3045),
    [anon_sym_readonly] = ACTIONS(3045),
    [anon_sym_required] = ACTIONS(3045),
    [anon_sym_sealed] = ACTIONS(3045),
    [anon_sym_virtual] = ACTIONS(3045),
    [anon_sym_volatile] = ACTIONS(3045),
    [anon_sym_where] = ACTIONS(3045),
    [anon_sym_notnull] = ACTIONS(3045),
    [anon_sym_unmanaged] = ACTIONS(3045),
    [anon_sym_checked] = ACTIONS(3045),
    [anon_sym_BANG] = ACTIONS(3047),
    [anon_sym_TILDE] = ACTIONS(3047),
    [anon_sym_PLUS_PLUS] = ACTIONS(3047),
    [anon_sym_DASH_DASH] = ACTIONS(3047),
    [anon_sym_true] = ACTIONS(3045),
    [anon_sym_false] = ACTIONS(3045),
    [anon_sym_PLUS] = ACTIONS(3045),
    [anon_sym_DASH] = ACTIONS(3045),
    [anon_sym_STAR] = ACTIONS(3047),
    [anon_sym_CARET] = ACTIONS(3047),
    [anon_sym_AMP] = ACTIONS(3047),
    [anon_sym_this] = ACTIONS(3045),
    [anon_sym_scoped] = ACTIONS(3045),
    [anon_sym_var] = ACTIONS(3045),
    [sym_predefined_type] = ACTIONS(3045),
    [anon_sym_break] = ACTIONS(3045),
    [anon_sym_unchecked] = ACTIONS(3045),
    [anon_sym_continue] = ACTIONS(3045),
    [anon_sym_do] = ACTIONS(3045),
    [anon_sym_while] = ACTIONS(3045),
    [anon_sym_for] = ACTIONS(3045),
    [anon_sym_lock] = ACTIONS(3045),
    [anon_sym_yield] = ACTIONS(3045),
    [anon_sym_switch] = ACTIONS(3045),
    [anon_sym_default] = ACTIONS(3045),
    [anon_sym_throw] = ACTIONS(3045),
    [anon_sym_try] = ACTIONS(3045),
    [anon_sym_when] = ACTIONS(3045),
    [anon_sym_await] = ACTIONS(3045),
    [anon_sym_foreach] = ACTIONS(3045),
    [anon_sym_goto] = ACTIONS(3045),
    [anon_sym_if] = ACTIONS(3045),
    [anon_sym_else] = ACTIONS(3045),
    [anon_sym_DOT_DOT] = ACTIONS(3047),
    [anon_sym_from] = ACTIONS(3045),
    [anon_sym_into] = ACTIONS(3045),
    [anon_sym_join] = ACTIONS(3045),
    [anon_sym_on] = ACTIONS(3045),
    [anon_sym_equals] = ACTIONS(3045),
    [anon_sym_let] = ACTIONS(3045),
    [anon_sym_orderby] = ACTIONS(3045),
    [anon_sym_ascending] = ACTIONS(3045),
    [anon_sym_descending] = ACTIONS(3045),
    [anon_sym_group] = ACTIONS(3045),
    [anon_sym_by] = ACTIONS(3045),
    [anon_sym_select] = ACTIONS(3045),
    [anon_sym_DQUOTE] = ACTIONS(3045),
    [anon_sym_stackalloc] = ACTIONS(3045),
    [anon_sym_sizeof] = ACTIONS(3045),
    [anon_sym_typeof] = ACTIONS(3045),
    [anon_sym___makeref] = ACTIONS(3045),
    [anon_sym___reftype] = ACTIONS(3045),
    [anon_sym___refvalue] = ACTIONS(3045),
    [sym_null_literal] = ACTIONS(3045),
    [anon_sym_SQUOTE] = ACTIONS(3047),
    [sym_integer_literal] = ACTIONS(3045),
    [sym_real_literal] = ACTIONS(3047),
    [sym_verbatim_string_literal] = ACTIONS(3047),
    [sym_raw_string_literal] = ACTIONS(3047),
    [aux_sym_preproc_if_token1] = ACTIONS(3047),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3047),
    [sym_interpolation_verbatim_start] = ACTIONS(3047),
    [sym_interpolation_raw_start] = ACTIONS(3047),
  },
  [2477] = {
    [sym_preproc_region] = STATE(2477),
    [sym_preproc_endregion] = STATE(2477),
    [sym_preproc_line] = STATE(2477),
    [sym_preproc_pragma] = STATE(2477),
    [sym_preproc_nullable] = STATE(2477),
    [sym_preproc_error] = STATE(2477),
    [sym_preproc_define] = STATE(2477),
    [sym_preproc_undef] = STATE(2477),
    [ts_builtin_sym_end] = ACTIONS(3229),
    [sym__identifier_token] = ACTIONS(3227),
    [anon_sym_extern] = ACTIONS(3227),
    [anon_sym_alias] = ACTIONS(3227),
    [anon_sym_SEMI] = ACTIONS(3229),
    [anon_sym_global] = ACTIONS(3227),
    [anon_sym_using] = ACTIONS(3227),
    [anon_sym_unsafe] = ACTIONS(3227),
    [anon_sym_static] = ACTIONS(3227),
    [anon_sym_LBRACK] = ACTIONS(3229),
    [anon_sym_LPAREN] = ACTIONS(3229),
    [anon_sym_return] = ACTIONS(3227),
    [anon_sym_namespace] = ACTIONS(3227),
    [anon_sym_class] = ACTIONS(3227),
    [anon_sym_ref] = ACTIONS(3227),
    [anon_sym_struct] = ACTIONS(3227),
    [anon_sym_enum] = ACTIONS(3227),
    [anon_sym_LBRACE] = ACTIONS(3229),
    [anon_sym_interface] = ACTIONS(3227),
    [anon_sym_delegate] = ACTIONS(3227),
    [anon_sym_record] = ACTIONS(3227),
    [anon_sym_abstract] = ACTIONS(3227),
    [anon_sym_async] = ACTIONS(3227),
    [anon_sym_const] = ACTIONS(3227),
    [anon_sym_file] = ACTIONS(3227),
    [anon_sym_fixed] = ACTIONS(3227),
    [anon_sym_internal] = ACTIONS(3227),
    [anon_sym_new] = ACTIONS(3227),
    [anon_sym_override] = ACTIONS(3227),
    [anon_sym_partial] = ACTIONS(3227),
    [anon_sym_private] = ACTIONS(3227),
    [anon_sym_protected] = ACTIONS(3227),
    [anon_sym_public] = ACTIONS(3227),
    [anon_sym_readonly] = ACTIONS(3227),
    [anon_sym_required] = ACTIONS(3227),
    [anon_sym_sealed] = ACTIONS(3227),
    [anon_sym_virtual] = ACTIONS(3227),
    [anon_sym_volatile] = ACTIONS(3227),
    [anon_sym_where] = ACTIONS(3227),
    [anon_sym_notnull] = ACTIONS(3227),
    [anon_sym_unmanaged] = ACTIONS(3227),
    [anon_sym_checked] = ACTIONS(3227),
    [anon_sym_BANG] = ACTIONS(3229),
    [anon_sym_TILDE] = ACTIONS(3229),
    [anon_sym_PLUS_PLUS] = ACTIONS(3229),
    [anon_sym_DASH_DASH] = ACTIONS(3229),
    [anon_sym_true] = ACTIONS(3227),
    [anon_sym_false] = ACTIONS(3227),
    [anon_sym_PLUS] = ACTIONS(3227),
    [anon_sym_DASH] = ACTIONS(3227),
    [anon_sym_STAR] = ACTIONS(3229),
    [anon_sym_CARET] = ACTIONS(3229),
    [anon_sym_AMP] = ACTIONS(3229),
    [anon_sym_this] = ACTIONS(3227),
    [anon_sym_scoped] = ACTIONS(3227),
    [anon_sym_var] = ACTIONS(3227),
    [sym_predefined_type] = ACTIONS(3227),
    [anon_sym_break] = ACTIONS(3227),
    [anon_sym_unchecked] = ACTIONS(3227),
    [anon_sym_continue] = ACTIONS(3227),
    [anon_sym_do] = ACTIONS(3227),
    [anon_sym_while] = ACTIONS(3227),
    [anon_sym_for] = ACTIONS(3227),
    [anon_sym_lock] = ACTIONS(3227),
    [anon_sym_yield] = ACTIONS(3227),
    [anon_sym_switch] = ACTIONS(3227),
    [anon_sym_default] = ACTIONS(3227),
    [anon_sym_throw] = ACTIONS(3227),
    [anon_sym_try] = ACTIONS(3227),
    [anon_sym_when] = ACTIONS(3227),
    [anon_sym_await] = ACTIONS(3227),
    [anon_sym_foreach] = ACTIONS(3227),
    [anon_sym_goto] = ACTIONS(3227),
    [anon_sym_if] = ACTIONS(3227),
    [anon_sym_else] = ACTIONS(3227),
    [anon_sym_DOT_DOT] = ACTIONS(3229),
    [anon_sym_from] = ACTIONS(3227),
    [anon_sym_into] = ACTIONS(3227),
    [anon_sym_join] = ACTIONS(3227),
    [anon_sym_on] = ACTIONS(3227),
    [anon_sym_equals] = ACTIONS(3227),
    [anon_sym_let] = ACTIONS(3227),
    [anon_sym_orderby] = ACTIONS(3227),
    [anon_sym_ascending] = ACTIONS(3227),
    [anon_sym_descending] = ACTIONS(3227),
    [anon_sym_group] = ACTIONS(3227),
    [anon_sym_by] = ACTIONS(3227),
    [anon_sym_select] = ACTIONS(3227),
    [anon_sym_DQUOTE] = ACTIONS(3227),
    [anon_sym_stackalloc] = ACTIONS(3227),
    [anon_sym_sizeof] = ACTIONS(3227),
    [anon_sym_typeof] = ACTIONS(3227),
    [anon_sym___makeref] = ACTIONS(3227),
    [anon_sym___reftype] = ACTIONS(3227),
    [anon_sym___refvalue] = ACTIONS(3227),
    [sym_null_literal] = ACTIONS(3227),
    [anon_sym_SQUOTE] = ACTIONS(3229),
    [sym_integer_literal] = ACTIONS(3227),
    [sym_real_literal] = ACTIONS(3229),
    [sym_verbatim_string_literal] = ACTIONS(3229),
    [sym_raw_string_literal] = ACTIONS(3229),
    [aux_sym_preproc_if_token1] = ACTIONS(3229),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3229),
    [sym_interpolation_verbatim_start] = ACTIONS(3229),
    [sym_interpolation_raw_start] = ACTIONS(3229),
  },
  [2478] = {
    [sym_preproc_region] = STATE(2478),
    [sym_preproc_endregion] = STATE(2478),
    [sym_preproc_line] = STATE(2478),
    [sym_preproc_pragma] = STATE(2478),
    [sym_preproc_nullable] = STATE(2478),
    [sym_preproc_error] = STATE(2478),
    [sym_preproc_define] = STATE(2478),
    [sym_preproc_undef] = STATE(2478),
    [ts_builtin_sym_end] = ACTIONS(3067),
    [sym__identifier_token] = ACTIONS(3065),
    [anon_sym_extern] = ACTIONS(3065),
    [anon_sym_alias] = ACTIONS(3065),
    [anon_sym_SEMI] = ACTIONS(3067),
    [anon_sym_global] = ACTIONS(3065),
    [anon_sym_using] = ACTIONS(3065),
    [anon_sym_unsafe] = ACTIONS(3065),
    [anon_sym_static] = ACTIONS(3065),
    [anon_sym_LBRACK] = ACTIONS(3067),
    [anon_sym_LPAREN] = ACTIONS(3067),
    [anon_sym_return] = ACTIONS(3065),
    [anon_sym_namespace] = ACTIONS(3065),
    [anon_sym_class] = ACTIONS(3065),
    [anon_sym_ref] = ACTIONS(3065),
    [anon_sym_struct] = ACTIONS(3065),
    [anon_sym_enum] = ACTIONS(3065),
    [anon_sym_LBRACE] = ACTIONS(3067),
    [anon_sym_interface] = ACTIONS(3065),
    [anon_sym_delegate] = ACTIONS(3065),
    [anon_sym_record] = ACTIONS(3065),
    [anon_sym_abstract] = ACTIONS(3065),
    [anon_sym_async] = ACTIONS(3065),
    [anon_sym_const] = ACTIONS(3065),
    [anon_sym_file] = ACTIONS(3065),
    [anon_sym_fixed] = ACTIONS(3065),
    [anon_sym_internal] = ACTIONS(3065),
    [anon_sym_new] = ACTIONS(3065),
    [anon_sym_override] = ACTIONS(3065),
    [anon_sym_partial] = ACTIONS(3065),
    [anon_sym_private] = ACTIONS(3065),
    [anon_sym_protected] = ACTIONS(3065),
    [anon_sym_public] = ACTIONS(3065),
    [anon_sym_readonly] = ACTIONS(3065),
    [anon_sym_required] = ACTIONS(3065),
    [anon_sym_sealed] = ACTIONS(3065),
    [anon_sym_virtual] = ACTIONS(3065),
    [anon_sym_volatile] = ACTIONS(3065),
    [anon_sym_where] = ACTIONS(3065),
    [anon_sym_notnull] = ACTIONS(3065),
    [anon_sym_unmanaged] = ACTIONS(3065),
    [anon_sym_checked] = ACTIONS(3065),
    [anon_sym_BANG] = ACTIONS(3067),
    [anon_sym_TILDE] = ACTIONS(3067),
    [anon_sym_PLUS_PLUS] = ACTIONS(3067),
    [anon_sym_DASH_DASH] = ACTIONS(3067),
    [anon_sym_true] = ACTIONS(3065),
    [anon_sym_false] = ACTIONS(3065),
    [anon_sym_PLUS] = ACTIONS(3065),
    [anon_sym_DASH] = ACTIONS(3065),
    [anon_sym_STAR] = ACTIONS(3067),
    [anon_sym_CARET] = ACTIONS(3067),
    [anon_sym_AMP] = ACTIONS(3067),
    [anon_sym_this] = ACTIONS(3065),
    [anon_sym_scoped] = ACTIONS(3065),
    [anon_sym_var] = ACTIONS(3065),
    [sym_predefined_type] = ACTIONS(3065),
    [anon_sym_break] = ACTIONS(3065),
    [anon_sym_unchecked] = ACTIONS(3065),
    [anon_sym_continue] = ACTIONS(3065),
    [anon_sym_do] = ACTIONS(3065),
    [anon_sym_while] = ACTIONS(3065),
    [anon_sym_for] = ACTIONS(3065),
    [anon_sym_lock] = ACTIONS(3065),
    [anon_sym_yield] = ACTIONS(3065),
    [anon_sym_switch] = ACTIONS(3065),
    [anon_sym_default] = ACTIONS(3065),
    [anon_sym_throw] = ACTIONS(3065),
    [anon_sym_try] = ACTIONS(3065),
    [anon_sym_when] = ACTIONS(3065),
    [anon_sym_await] = ACTIONS(3065),
    [anon_sym_foreach] = ACTIONS(3065),
    [anon_sym_goto] = ACTIONS(3065),
    [anon_sym_if] = ACTIONS(3065),
    [anon_sym_else] = ACTIONS(3065),
    [anon_sym_DOT_DOT] = ACTIONS(3067),
    [anon_sym_from] = ACTIONS(3065),
    [anon_sym_into] = ACTIONS(3065),
    [anon_sym_join] = ACTIONS(3065),
    [anon_sym_on] = ACTIONS(3065),
    [anon_sym_equals] = ACTIONS(3065),
    [anon_sym_let] = ACTIONS(3065),
    [anon_sym_orderby] = ACTIONS(3065),
    [anon_sym_ascending] = ACTIONS(3065),
    [anon_sym_descending] = ACTIONS(3065),
    [anon_sym_group] = ACTIONS(3065),
    [anon_sym_by] = ACTIONS(3065),
    [anon_sym_select] = ACTIONS(3065),
    [anon_sym_DQUOTE] = ACTIONS(3065),
    [anon_sym_stackalloc] = ACTIONS(3065),
    [anon_sym_sizeof] = ACTIONS(3065),
    [anon_sym_typeof] = ACTIONS(3065),
    [anon_sym___makeref] = ACTIONS(3065),
    [anon_sym___reftype] = ACTIONS(3065),
    [anon_sym___refvalue] = ACTIONS(3065),
    [sym_null_literal] = ACTIONS(3065),
    [anon_sym_SQUOTE] = ACTIONS(3067),
    [sym_integer_literal] = ACTIONS(3065),
    [sym_real_literal] = ACTIONS(3067),
    [sym_verbatim_string_literal] = ACTIONS(3067),
    [sym_raw_string_literal] = ACTIONS(3067),
    [aux_sym_preproc_if_token1] = ACTIONS(3067),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3067),
    [sym_interpolation_verbatim_start] = ACTIONS(3067),
    [sym_interpolation_raw_start] = ACTIONS(3067),
  },
  [2479] = {
    [sym_catch_clause] = STATE(2642),
    [sym_finally_clause] = STATE(2655),
    [sym_preproc_region] = STATE(2479),
    [sym_preproc_endregion] = STATE(2479),
    [sym_preproc_line] = STATE(2479),
    [sym_preproc_pragma] = STATE(2479),
    [sym_preproc_nullable] = STATE(2479),
    [sym_preproc_error] = STATE(2479),
    [sym_preproc_define] = STATE(2479),
    [sym_preproc_undef] = STATE(2479),
    [aux_sym_try_statement_repeat1] = STATE(2610),
    [sym__identifier_token] = ACTIONS(2937),
    [anon_sym_extern] = ACTIONS(2937),
    [anon_sym_alias] = ACTIONS(2937),
    [anon_sym_SEMI] = ACTIONS(2939),
    [anon_sym_global] = ACTIONS(2937),
    [anon_sym_using] = ACTIONS(2937),
    [anon_sym_unsafe] = ACTIONS(2937),
    [anon_sym_static] = ACTIONS(2937),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_LPAREN] = ACTIONS(2939),
    [anon_sym_return] = ACTIONS(2937),
    [anon_sym_ref] = ACTIONS(2937),
    [anon_sym_LBRACE] = ACTIONS(2939),
    [anon_sym_RBRACE] = ACTIONS(2939),
    [anon_sym_delegate] = ACTIONS(2937),
    [anon_sym_abstract] = ACTIONS(2937),
    [anon_sym_async] = ACTIONS(2937),
    [anon_sym_const] = ACTIONS(2937),
    [anon_sym_file] = ACTIONS(2937),
    [anon_sym_fixed] = ACTIONS(2937),
    [anon_sym_internal] = ACTIONS(2937),
    [anon_sym_new] = ACTIONS(2937),
    [anon_sym_override] = ACTIONS(2937),
    [anon_sym_partial] = ACTIONS(2937),
    [anon_sym_private] = ACTIONS(2937),
    [anon_sym_protected] = ACTIONS(2937),
    [anon_sym_public] = ACTIONS(2937),
    [anon_sym_readonly] = ACTIONS(2937),
    [anon_sym_required] = ACTIONS(2937),
    [anon_sym_sealed] = ACTIONS(2937),
    [anon_sym_virtual] = ACTIONS(2937),
    [anon_sym_volatile] = ACTIONS(2937),
    [anon_sym_where] = ACTIONS(2937),
    [anon_sym_notnull] = ACTIONS(2937),
    [anon_sym_unmanaged] = ACTIONS(2937),
    [anon_sym_checked] = ACTIONS(2937),
    [anon_sym_BANG] = ACTIONS(2939),
    [anon_sym_TILDE] = ACTIONS(2939),
    [anon_sym_PLUS_PLUS] = ACTIONS(2939),
    [anon_sym_DASH_DASH] = ACTIONS(2939),
    [anon_sym_true] = ACTIONS(2937),
    [anon_sym_false] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(2937),
    [anon_sym_DASH] = ACTIONS(2937),
    [anon_sym_STAR] = ACTIONS(2939),
    [anon_sym_CARET] = ACTIONS(2939),
    [anon_sym_AMP] = ACTIONS(2939),
    [anon_sym_this] = ACTIONS(2937),
    [anon_sym_scoped] = ACTIONS(2937),
    [anon_sym_var] = ACTIONS(2937),
    [sym_predefined_type] = ACTIONS(2937),
    [anon_sym_break] = ACTIONS(2937),
    [anon_sym_unchecked] = ACTIONS(2937),
    [anon_sym_continue] = ACTIONS(2937),
    [anon_sym_do] = ACTIONS(2937),
    [anon_sym_while] = ACTIONS(2937),
    [anon_sym_for] = ACTIONS(2937),
    [anon_sym_lock] = ACTIONS(2937),
    [anon_sym_yield] = ACTIONS(2937),
    [anon_sym_switch] = ACTIONS(2937),
    [anon_sym_case] = ACTIONS(2937),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_throw] = ACTIONS(2937),
    [anon_sym_try] = ACTIONS(2937),
    [anon_sym_catch] = ACTIONS(3946),
    [anon_sym_when] = ACTIONS(2937),
    [anon_sym_finally] = ACTIONS(3948),
    [anon_sym_await] = ACTIONS(2937),
    [anon_sym_foreach] = ACTIONS(2937),
    [anon_sym_goto] = ACTIONS(2937),
    [anon_sym_if] = ACTIONS(2937),
    [anon_sym_else] = ACTIONS(2937),
    [anon_sym_DOT_DOT] = ACTIONS(2939),
    [anon_sym_from] = ACTIONS(2937),
    [anon_sym_into] = ACTIONS(2937),
    [anon_sym_join] = ACTIONS(2937),
    [anon_sym_on] = ACTIONS(2937),
    [anon_sym_equals] = ACTIONS(2937),
    [anon_sym_let] = ACTIONS(2937),
    [anon_sym_orderby] = ACTIONS(2937),
    [anon_sym_ascending] = ACTIONS(2937),
    [anon_sym_descending] = ACTIONS(2937),
    [anon_sym_group] = ACTIONS(2937),
    [anon_sym_by] = ACTIONS(2937),
    [anon_sym_select] = ACTIONS(2937),
    [anon_sym_DQUOTE] = ACTIONS(2937),
    [anon_sym_stackalloc] = ACTIONS(2937),
    [anon_sym_sizeof] = ACTIONS(2937),
    [anon_sym_typeof] = ACTIONS(2937),
    [anon_sym___makeref] = ACTIONS(2937),
    [anon_sym___reftype] = ACTIONS(2937),
    [anon_sym___refvalue] = ACTIONS(2937),
    [sym_null_literal] = ACTIONS(2937),
    [anon_sym_SQUOTE] = ACTIONS(2939),
    [sym_integer_literal] = ACTIONS(2937),
    [sym_real_literal] = ACTIONS(2939),
    [sym_verbatim_string_literal] = ACTIONS(2939),
    [sym_raw_string_literal] = ACTIONS(2939),
    [aux_sym_preproc_if_token1] = ACTIONS(2939),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(2939),
    [sym_interpolation_verbatim_start] = ACTIONS(2939),
    [sym_interpolation_raw_start] = ACTIONS(2939),
  },
  [2480] = {
    [sym_preproc_region] = STATE(2480),
    [sym_preproc_endregion] = STATE(2480),
    [sym_preproc_line] = STATE(2480),
    [sym_preproc_pragma] = STATE(2480),
    [sym_preproc_nullable] = STATE(2480),
    [sym_preproc_error] = STATE(2480),
    [sym_preproc_define] = STATE(2480),
    [sym_preproc_undef] = STATE(2480),
    [ts_builtin_sym_end] = ACTIONS(3297),
    [sym__identifier_token] = ACTIONS(3295),
    [anon_sym_extern] = ACTIONS(3295),
    [anon_sym_alias] = ACTIONS(3295),
    [anon_sym_SEMI] = ACTIONS(3297),
    [anon_sym_global] = ACTIONS(3295),
    [anon_sym_using] = ACTIONS(3295),
    [anon_sym_unsafe] = ACTIONS(3295),
    [anon_sym_static] = ACTIONS(3295),
    [anon_sym_LBRACK] = ACTIONS(3297),
    [anon_sym_LPAREN] = ACTIONS(3297),
    [anon_sym_return] = ACTIONS(3295),
    [anon_sym_namespace] = ACTIONS(3295),
    [anon_sym_class] = ACTIONS(3295),
    [anon_sym_ref] = ACTIONS(3295),
    [anon_sym_struct] = ACTIONS(3295),
    [anon_sym_enum] = ACTIONS(3295),
    [anon_sym_LBRACE] = ACTIONS(3297),
    [anon_sym_interface] = ACTIONS(3295),
    [anon_sym_delegate] = ACTIONS(3295),
    [anon_sym_record] = ACTIONS(3295),
    [anon_sym_abstract] = ACTIONS(3295),
    [anon_sym_async] = ACTIONS(3295),
    [anon_sym_const] = ACTIONS(3295),
    [anon_sym_file] = ACTIONS(3295),
    [anon_sym_fixed] = ACTIONS(3295),
    [anon_sym_internal] = ACTIONS(3295),
    [anon_sym_new] = ACTIONS(3295),
    [anon_sym_override] = ACTIONS(3295),
    [anon_sym_partial] = ACTIONS(3295),
    [anon_sym_private] = ACTIONS(3295),
    [anon_sym_protected] = ACTIONS(3295),
    [anon_sym_public] = ACTIONS(3295),
    [anon_sym_readonly] = ACTIONS(3295),
    [anon_sym_required] = ACTIONS(3295),
    [anon_sym_sealed] = ACTIONS(3295),
    [anon_sym_virtual] = ACTIONS(3295),
    [anon_sym_volatile] = ACTIONS(3295),
    [anon_sym_where] = ACTIONS(3295),
    [anon_sym_notnull] = ACTIONS(3295),
    [anon_sym_unmanaged] = ACTIONS(3295),
    [anon_sym_checked] = ACTIONS(3295),
    [anon_sym_BANG] = ACTIONS(3297),
    [anon_sym_TILDE] = ACTIONS(3297),
    [anon_sym_PLUS_PLUS] = ACTIONS(3297),
    [anon_sym_DASH_DASH] = ACTIONS(3297),
    [anon_sym_true] = ACTIONS(3295),
    [anon_sym_false] = ACTIONS(3295),
    [anon_sym_PLUS] = ACTIONS(3295),
    [anon_sym_DASH] = ACTIONS(3295),
    [anon_sym_STAR] = ACTIONS(3297),
    [anon_sym_CARET] = ACTIONS(3297),
    [anon_sym_AMP] = ACTIONS(3297),
    [anon_sym_this] = ACTIONS(3295),
    [anon_sym_scoped] = ACTIONS(3295),
    [anon_sym_var] = ACTIONS(3295),
    [sym_predefined_type] = ACTIONS(3295),
    [anon_sym_break] = ACTIONS(3295),
    [anon_sym_unchecked] = ACTIONS(3295),
    [anon_sym_continue] = ACTIONS(3295),
    [anon_sym_do] = ACTIONS(3295),
    [anon_sym_while] = ACTIONS(3295),
    [anon_sym_for] = ACTIONS(3295),
    [anon_sym_lock] = ACTIONS(3295),
    [anon_sym_yield] = ACTIONS(3295),
    [anon_sym_switch] = ACTIONS(3295),
    [anon_sym_default] = ACTIONS(3295),
    [anon_sym_throw] = ACTIONS(3295),
    [anon_sym_try] = ACTIONS(3295),
    [anon_sym_when] = ACTIONS(3295),
    [anon_sym_await] = ACTIONS(3295),
    [anon_sym_foreach] = ACTIONS(3295),
    [anon_sym_goto] = ACTIONS(3295),
    [anon_sym_if] = ACTIONS(3295),
    [anon_sym_else] = ACTIONS(3295),
    [anon_sym_DOT_DOT] = ACTIONS(3297),
    [anon_sym_from] = ACTIONS(3295),
    [anon_sym_into] = ACTIONS(3295),
    [anon_sym_join] = ACTIONS(3295),
    [anon_sym_on] = ACTIONS(3295),
    [anon_sym_equals] = ACTIONS(3295),
    [anon_sym_let] = ACTIONS(3295),
    [anon_sym_orderby] = ACTIONS(3295),
    [anon_sym_ascending] = ACTIONS(3295),
    [anon_sym_descending] = ACTIONS(3295),
    [anon_sym_group] = ACTIONS(3295),
    [anon_sym_by] = ACTIONS(3295),
    [anon_sym_select] = ACTIONS(3295),
    [anon_sym_DQUOTE] = ACTIONS(3295),
    [anon_sym_stackalloc] = ACTIONS(3295),
    [anon_sym_sizeof] = ACTIONS(3295),
    [anon_sym_typeof] = ACTIONS(3295),
    [anon_sym___makeref] = ACTIONS(3295),
    [anon_sym___reftype] = ACTIONS(3295),
    [anon_sym___refvalue] = ACTIONS(3295),
    [sym_null_literal] = ACTIONS(3295),
    [anon_sym_SQUOTE] = ACTIONS(3297),
    [sym_integer_literal] = ACTIONS(3295),
    [sym_real_literal] = ACTIONS(3297),
    [sym_verbatim_string_literal] = ACTIONS(3297),
    [sym_raw_string_literal] = ACTIONS(3297),
    [aux_sym_preproc_if_token1] = ACTIONS(3297),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3297),
    [sym_interpolation_verbatim_start] = ACTIONS(3297),
    [sym_interpolation_raw_start] = ACTIONS(3297),
  },
  [2481] = {
    [sym_preproc_region] = STATE(2481),
    [sym_preproc_endregion] = STATE(2481),
    [sym_preproc_line] = STATE(2481),
    [sym_preproc_pragma] = STATE(2481),
    [sym_preproc_nullable] = STATE(2481),
    [sym_preproc_error] = STATE(2481),
    [sym_preproc_define] = STATE(2481),
    [sym_preproc_undef] = STATE(2481),
    [ts_builtin_sym_end] = ACTIONS(3369),
    [sym__identifier_token] = ACTIONS(3367),
    [anon_sym_extern] = ACTIONS(3367),
    [anon_sym_alias] = ACTIONS(3367),
    [anon_sym_SEMI] = ACTIONS(3369),
    [anon_sym_global] = ACTIONS(3367),
    [anon_sym_using] = ACTIONS(3367),
    [anon_sym_unsafe] = ACTIONS(3367),
    [anon_sym_static] = ACTIONS(3367),
    [anon_sym_LBRACK] = ACTIONS(3369),
    [anon_sym_LPAREN] = ACTIONS(3369),
    [anon_sym_return] = ACTIONS(3367),
    [anon_sym_namespace] = ACTIONS(3367),
    [anon_sym_class] = ACTIONS(3367),
    [anon_sym_ref] = ACTIONS(3367),
    [anon_sym_struct] = ACTIONS(3367),
    [anon_sym_enum] = ACTIONS(3367),
    [anon_sym_LBRACE] = ACTIONS(3369),
    [anon_sym_interface] = ACTIONS(3367),
    [anon_sym_delegate] = ACTIONS(3367),
    [anon_sym_record] = ACTIONS(3367),
    [anon_sym_abstract] = ACTIONS(3367),
    [anon_sym_async] = ACTIONS(3367),
    [anon_sym_const] = ACTIONS(3367),
    [anon_sym_file] = ACTIONS(3367),
    [anon_sym_fixed] = ACTIONS(3367),
    [anon_sym_internal] = ACTIONS(3367),
    [anon_sym_new] = ACTIONS(3367),
    [anon_sym_override] = ACTIONS(3367),
    [anon_sym_partial] = ACTIONS(3367),
    [anon_sym_private] = ACTIONS(3367),
    [anon_sym_protected] = ACTIONS(3367),
    [anon_sym_public] = ACTIONS(3367),
    [anon_sym_readonly] = ACTIONS(3367),
    [anon_sym_required] = ACTIONS(3367),
    [anon_sym_sealed] = ACTIONS(3367),
    [anon_sym_virtual] = ACTIONS(3367),
    [anon_sym_volatile] = ACTIONS(3367),
    [anon_sym_where] = ACTIONS(3367),
    [anon_sym_notnull] = ACTIONS(3367),
    [anon_sym_unmanaged] = ACTIONS(3367),
    [anon_sym_checked] = ACTIONS(3367),
    [anon_sym_BANG] = ACTIONS(3369),
    [anon_sym_TILDE] = ACTIONS(3369),
    [anon_sym_PLUS_PLUS] = ACTIONS(3369),
    [anon_sym_DASH_DASH] = ACTIONS(3369),
    [anon_sym_true] = ACTIONS(3367),
    [anon_sym_false] = ACTIONS(3367),
    [anon_sym_PLUS] = ACTIONS(3367),
    [anon_sym_DASH] = ACTIONS(3367),
    [anon_sym_STAR] = ACTIONS(3369),
    [anon_sym_CARET] = ACTIONS(3369),
    [anon_sym_AMP] = ACTIONS(3369),
    [anon_sym_this] = ACTIONS(3367),
    [anon_sym_scoped] = ACTIONS(3367),
    [anon_sym_var] = ACTIONS(3367),
    [sym_predefined_type] = ACTIONS(3367),
    [anon_sym_break] = ACTIONS(3367),
    [anon_sym_unchecked] = ACTIONS(3367),
    [anon_sym_continue] = ACTIONS(3367),
    [anon_sym_do] = ACTIONS(3367),
    [anon_sym_while] = ACTIONS(3367),
    [anon_sym_for] = ACTIONS(3367),
    [anon_sym_lock] = ACTIONS(3367),
    [anon_sym_yield] = ACTIONS(3367),
    [anon_sym_switch] = ACTIONS(3367),
    [anon_sym_default] = ACTIONS(3367),
    [anon_sym_throw] = ACTIONS(3367),
    [anon_sym_try] = ACTIONS(3367),
    [anon_sym_when] = ACTIONS(3367),
    [anon_sym_await] = ACTIONS(3367),
    [anon_sym_foreach] = ACTIONS(3367),
    [anon_sym_goto] = ACTIONS(3367),
    [anon_sym_if] = ACTIONS(3367),
    [anon_sym_else] = ACTIONS(3367),
    [anon_sym_DOT_DOT] = ACTIONS(3369),
    [anon_sym_from] = ACTIONS(3367),
    [anon_sym_into] = ACTIONS(3367),
    [anon_sym_join] = ACTIONS(3367),
    [anon_sym_on] = ACTIONS(3367),
    [anon_sym_equals] = ACTIONS(3367),
    [anon_sym_let] = ACTIONS(3367),
    [anon_sym_orderby] = ACTIONS(3367),
    [anon_sym_ascending] = ACTIONS(3367),
    [anon_sym_descending] = ACTIONS(3367),
    [anon_sym_group] = ACTIONS(3367),
    [anon_sym_by] = ACTIONS(3367),
    [anon_sym_select] = ACTIONS(3367),
    [anon_sym_DQUOTE] = ACTIONS(3367),
    [anon_sym_stackalloc] = ACTIONS(3367),
    [anon_sym_sizeof] = ACTIONS(3367),
    [anon_sym_typeof] = ACTIONS(3367),
    [anon_sym___makeref] = ACTIONS(3367),
    [anon_sym___reftype] = ACTIONS(3367),
    [anon_sym___refvalue] = ACTIONS(3367),
    [sym_null_literal] = ACTIONS(3367),
    [anon_sym_SQUOTE] = ACTIONS(3369),
    [sym_integer_literal] = ACTIONS(3367),
    [sym_real_literal] = ACTIONS(3369),
    [sym_verbatim_string_literal] = ACTIONS(3369),
    [sym_raw_string_literal] = ACTIONS(3369),
    [aux_sym_preproc_if_token1] = ACTIONS(3369),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3369),
    [sym_interpolation_verbatim_start] = ACTIONS(3369),
    [sym_interpolation_raw_start] = ACTIONS(3369),
  },
  [2482] = {
    [sym_preproc_region] = STATE(2482),
    [sym_preproc_endregion] = STATE(2482),
    [sym_preproc_line] = STATE(2482),
    [sym_preproc_pragma] = STATE(2482),
    [sym_preproc_nullable] = STATE(2482),
    [sym_preproc_error] = STATE(2482),
    [sym_preproc_define] = STATE(2482),
    [sym_preproc_undef] = STATE(2482),
    [ts_builtin_sym_end] = ACTIONS(3313),
    [sym__identifier_token] = ACTIONS(3311),
    [anon_sym_extern] = ACTIONS(3311),
    [anon_sym_alias] = ACTIONS(3311),
    [anon_sym_SEMI] = ACTIONS(3313),
    [anon_sym_global] = ACTIONS(3311),
    [anon_sym_using] = ACTIONS(3311),
    [anon_sym_unsafe] = ACTIONS(3311),
    [anon_sym_static] = ACTIONS(3311),
    [anon_sym_LBRACK] = ACTIONS(3313),
    [anon_sym_LPAREN] = ACTIONS(3313),
    [anon_sym_return] = ACTIONS(3311),
    [anon_sym_namespace] = ACTIONS(3311),
    [anon_sym_class] = ACTIONS(3311),
    [anon_sym_ref] = ACTIONS(3311),
    [anon_sym_struct] = ACTIONS(3311),
    [anon_sym_enum] = ACTIONS(3311),
    [anon_sym_LBRACE] = ACTIONS(3313),
    [anon_sym_interface] = ACTIONS(3311),
    [anon_sym_delegate] = ACTIONS(3311),
    [anon_sym_record] = ACTIONS(3311),
    [anon_sym_abstract] = ACTIONS(3311),
    [anon_sym_async] = ACTIONS(3311),
    [anon_sym_const] = ACTIONS(3311),
    [anon_sym_file] = ACTIONS(3311),
    [anon_sym_fixed] = ACTIONS(3311),
    [anon_sym_internal] = ACTIONS(3311),
    [anon_sym_new] = ACTIONS(3311),
    [anon_sym_override] = ACTIONS(3311),
    [anon_sym_partial] = ACTIONS(3311),
    [anon_sym_private] = ACTIONS(3311),
    [anon_sym_protected] = ACTIONS(3311),
    [anon_sym_public] = ACTIONS(3311),
    [anon_sym_readonly] = ACTIONS(3311),
    [anon_sym_required] = ACTIONS(3311),
    [anon_sym_sealed] = ACTIONS(3311),
    [anon_sym_virtual] = ACTIONS(3311),
    [anon_sym_volatile] = ACTIONS(3311),
    [anon_sym_where] = ACTIONS(3311),
    [anon_sym_notnull] = ACTIONS(3311),
    [anon_sym_unmanaged] = ACTIONS(3311),
    [anon_sym_checked] = ACTIONS(3311),
    [anon_sym_BANG] = ACTIONS(3313),
    [anon_sym_TILDE] = ACTIONS(3313),
    [anon_sym_PLUS_PLUS] = ACTIONS(3313),
    [anon_sym_DASH_DASH] = ACTIONS(3313),
    [anon_sym_true] = ACTIONS(3311),
    [anon_sym_false] = ACTIONS(3311),
    [anon_sym_PLUS] = ACTIONS(3311),
    [anon_sym_DASH] = ACTIONS(3311),
    [anon_sym_STAR] = ACTIONS(3313),
    [anon_sym_CARET] = ACTIONS(3313),
    [anon_sym_AMP] = ACTIONS(3313),
    [anon_sym_this] = ACTIONS(3311),
    [anon_sym_scoped] = ACTIONS(3311),
    [anon_sym_var] = ACTIONS(3311),
    [sym_predefined_type] = ACTIONS(3311),
    [anon_sym_break] = ACTIONS(3311),
    [anon_sym_unchecked] = ACTIONS(3311),
    [anon_sym_continue] = ACTIONS(3311),
    [anon_sym_do] = ACTIONS(3311),
    [anon_sym_while] = ACTIONS(3311),
    [anon_sym_for] = ACTIONS(3311),
    [anon_sym_lock] = ACTIONS(3311),
    [anon_sym_yield] = ACTIONS(3311),
    [anon_sym_switch] = ACTIONS(3311),
    [anon_sym_default] = ACTIONS(3311),
    [anon_sym_throw] = ACTIONS(3311),
    [anon_sym_try] = ACTIONS(3311),
    [anon_sym_when] = ACTIONS(3311),
    [anon_sym_await] = ACTIONS(3311),
    [anon_sym_foreach] = ACTIONS(3311),
    [anon_sym_goto] = ACTIONS(3311),
    [anon_sym_if] = ACTIONS(3311),
    [anon_sym_else] = ACTIONS(3311),
    [anon_sym_DOT_DOT] = ACTIONS(3313),
    [anon_sym_from] = ACTIONS(3311),
    [anon_sym_into] = ACTIONS(3311),
    [anon_sym_join] = ACTIONS(3311),
    [anon_sym_on] = ACTIONS(3311),
    [anon_sym_equals] = ACTIONS(3311),
    [anon_sym_let] = ACTIONS(3311),
    [anon_sym_orderby] = ACTIONS(3311),
    [anon_sym_ascending] = ACTIONS(3311),
    [anon_sym_descending] = ACTIONS(3311),
    [anon_sym_group] = ACTIONS(3311),
    [anon_sym_by] = ACTIONS(3311),
    [anon_sym_select] = ACTIONS(3311),
    [anon_sym_DQUOTE] = ACTIONS(3311),
    [anon_sym_stackalloc] = ACTIONS(3311),
    [anon_sym_sizeof] = ACTIONS(3311),
    [anon_sym_typeof] = ACTIONS(3311),
    [anon_sym___makeref] = ACTIONS(3311),
    [anon_sym___reftype] = ACTIONS(3311),
    [anon_sym___refvalue] = ACTIONS(3311),
    [sym_null_literal] = ACTIONS(3311),
    [anon_sym_SQUOTE] = ACTIONS(3313),
    [sym_integer_literal] = ACTIONS(3311),
    [sym_real_literal] = ACTIONS(3313),
    [sym_verbatim_string_literal] = ACTIONS(3313),
    [sym_raw_string_literal] = ACTIONS(3313),
    [aux_sym_preproc_if_token1] = ACTIONS(3313),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3313),
    [sym_interpolation_verbatim_start] = ACTIONS(3313),
    [sym_interpolation_raw_start] = ACTIONS(3313),
  },
  [2483] = {
    [sym_preproc_region] = STATE(2483),
    [sym_preproc_endregion] = STATE(2483),
    [sym_preproc_line] = STATE(2483),
    [sym_preproc_pragma] = STATE(2483),
    [sym_preproc_nullable] = STATE(2483),
    [sym_preproc_error] = STATE(2483),
    [sym_preproc_define] = STATE(2483),
    [sym_preproc_undef] = STATE(2483),
    [ts_builtin_sym_end] = ACTIONS(3403),
    [sym__identifier_token] = ACTIONS(3401),
    [anon_sym_extern] = ACTIONS(3401),
    [anon_sym_alias] = ACTIONS(3401),
    [anon_sym_SEMI] = ACTIONS(3403),
    [anon_sym_global] = ACTIONS(3401),
    [anon_sym_using] = ACTIONS(3401),
    [anon_sym_unsafe] = ACTIONS(3401),
    [anon_sym_static] = ACTIONS(3401),
    [anon_sym_LBRACK] = ACTIONS(3403),
    [anon_sym_LPAREN] = ACTIONS(3403),
    [anon_sym_return] = ACTIONS(3401),
    [anon_sym_namespace] = ACTIONS(3401),
    [anon_sym_class] = ACTIONS(3401),
    [anon_sym_ref] = ACTIONS(3401),
    [anon_sym_struct] = ACTIONS(3401),
    [anon_sym_enum] = ACTIONS(3401),
    [anon_sym_LBRACE] = ACTIONS(3403),
    [anon_sym_interface] = ACTIONS(3401),
    [anon_sym_delegate] = ACTIONS(3401),
    [anon_sym_record] = ACTIONS(3401),
    [anon_sym_abstract] = ACTIONS(3401),
    [anon_sym_async] = ACTIONS(3401),
    [anon_sym_const] = ACTIONS(3401),
    [anon_sym_file] = ACTIONS(3401),
    [anon_sym_fixed] = ACTIONS(3401),
    [anon_sym_internal] = ACTIONS(3401),
    [anon_sym_new] = ACTIONS(3401),
    [anon_sym_override] = ACTIONS(3401),
    [anon_sym_partial] = ACTIONS(3401),
    [anon_sym_private] = ACTIONS(3401),
    [anon_sym_protected] = ACTIONS(3401),
    [anon_sym_public] = ACTIONS(3401),
    [anon_sym_readonly] = ACTIONS(3401),
    [anon_sym_required] = ACTIONS(3401),
    [anon_sym_sealed] = ACTIONS(3401),
    [anon_sym_virtual] = ACTIONS(3401),
    [anon_sym_volatile] = ACTIONS(3401),
    [anon_sym_where] = ACTIONS(3401),
    [anon_sym_notnull] = ACTIONS(3401),
    [anon_sym_unmanaged] = ACTIONS(3401),
    [anon_sym_checked] = ACTIONS(3401),
    [anon_sym_BANG] = ACTIONS(3403),
    [anon_sym_TILDE] = ACTIONS(3403),
    [anon_sym_PLUS_PLUS] = ACTIONS(3403),
    [anon_sym_DASH_DASH] = ACTIONS(3403),
    [anon_sym_true] = ACTIONS(3401),
    [anon_sym_false] = ACTIONS(3401),
    [anon_sym_PLUS] = ACTIONS(3401),
    [anon_sym_DASH] = ACTIONS(3401),
    [anon_sym_STAR] = ACTIONS(3403),
    [anon_sym_CARET] = ACTIONS(3403),
    [anon_sym_AMP] = ACTIONS(3403),
    [anon_sym_this] = ACTIONS(3401),
    [anon_sym_scoped] = ACTIONS(3401),
    [anon_sym_var] = ACTIONS(3401),
    [sym_predefined_type] = ACTIONS(3401),
    [anon_sym_break] = ACTIONS(3401),
    [anon_sym_unchecked] = ACTIONS(3401),
    [anon_sym_continue] = ACTIONS(3401),
    [anon_sym_do] = ACTIONS(3401),
    [anon_sym_while] = ACTIONS(3401),
    [anon_sym_for] = ACTIONS(3401),
    [anon_sym_lock] = ACTIONS(3401),
    [anon_sym_yield] = ACTIONS(3401),
    [anon_sym_switch] = ACTIONS(3401),
    [anon_sym_default] = ACTIONS(3401),
    [anon_sym_throw] = ACTIONS(3401),
    [anon_sym_try] = ACTIONS(3401),
    [anon_sym_when] = ACTIONS(3401),
    [anon_sym_await] = ACTIONS(3401),
    [anon_sym_foreach] = ACTIONS(3401),
    [anon_sym_goto] = ACTIONS(3401),
    [anon_sym_if] = ACTIONS(3401),
    [anon_sym_else] = ACTIONS(3401),
    [anon_sym_DOT_DOT] = ACTIONS(3403),
    [anon_sym_from] = ACTIONS(3401),
    [anon_sym_into] = ACTIONS(3401),
    [anon_sym_join] = ACTIONS(3401),
    [anon_sym_on] = ACTIONS(3401),
    [anon_sym_equals] = ACTIONS(3401),
    [anon_sym_let] = ACTIONS(3401),
    [anon_sym_orderby] = ACTIONS(3401),
    [anon_sym_ascending] = ACTIONS(3401),
    [anon_sym_descending] = ACTIONS(3401),
    [anon_sym_group] = ACTIONS(3401),
    [anon_sym_by] = ACTIONS(3401),
    [anon_sym_select] = ACTIONS(3401),
    [anon_sym_DQUOTE] = ACTIONS(3401),
    [anon_sym_stackalloc] = ACTIONS(3401),
    [anon_sym_sizeof] = ACTIONS(3401),
    [anon_sym_typeof] = ACTIONS(3401),
    [anon_sym___makeref] = ACTIONS(3401),
    [anon_sym___reftype] = ACTIONS(3401),
    [anon_sym___refvalue] = ACTIONS(3401),
    [sym_null_literal] = ACTIONS(3401),
    [anon_sym_SQUOTE] = ACTIONS(3403),
    [sym_integer_literal] = ACTIONS(3401),
    [sym_real_literal] = ACTIONS(3403),
    [sym_verbatim_string_literal] = ACTIONS(3403),
    [sym_raw_string_literal] = ACTIONS(3403),
    [aux_sym_preproc_if_token1] = ACTIONS(3403),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3403),
    [sym_interpolation_verbatim_start] = ACTIONS(3403),
    [sym_interpolation_raw_start] = ACTIONS(3403),
  },
  [2484] = {
    [sym_preproc_region] = STATE(2484),
    [sym_preproc_endregion] = STATE(2484),
    [sym_preproc_line] = STATE(2484),
    [sym_preproc_pragma] = STATE(2484),
    [sym_preproc_nullable] = STATE(2484),
    [sym_preproc_error] = STATE(2484),
    [sym_preproc_define] = STATE(2484),
    [sym_preproc_undef] = STATE(2484),
    [ts_builtin_sym_end] = ACTIONS(3399),
    [sym__identifier_token] = ACTIONS(3397),
    [anon_sym_extern] = ACTIONS(3397),
    [anon_sym_alias] = ACTIONS(3397),
    [anon_sym_SEMI] = ACTIONS(3399),
    [anon_sym_global] = ACTIONS(3397),
    [anon_sym_using] = ACTIONS(3397),
    [anon_sym_unsafe] = ACTIONS(3397),
    [anon_sym_static] = ACTIONS(3397),
    [anon_sym_LBRACK] = ACTIONS(3399),
    [anon_sym_LPAREN] = ACTIONS(3399),
    [anon_sym_return] = ACTIONS(3397),
    [anon_sym_namespace] = ACTIONS(3397),
    [anon_sym_class] = ACTIONS(3397),
    [anon_sym_ref] = ACTIONS(3397),
    [anon_sym_struct] = ACTIONS(3397),
    [anon_sym_enum] = ACTIONS(3397),
    [anon_sym_LBRACE] = ACTIONS(3399),
    [anon_sym_interface] = ACTIONS(3397),
    [anon_sym_delegate] = ACTIONS(3397),
    [anon_sym_record] = ACTIONS(3397),
    [anon_sym_abstract] = ACTIONS(3397),
    [anon_sym_async] = ACTIONS(3397),
    [anon_sym_const] = ACTIONS(3397),
    [anon_sym_file] = ACTIONS(3397),
    [anon_sym_fixed] = ACTIONS(3397),
    [anon_sym_internal] = ACTIONS(3397),
    [anon_sym_new] = ACTIONS(3397),
    [anon_sym_override] = ACTIONS(3397),
    [anon_sym_partial] = ACTIONS(3397),
    [anon_sym_private] = ACTIONS(3397),
    [anon_sym_protected] = ACTIONS(3397),
    [anon_sym_public] = ACTIONS(3397),
    [anon_sym_readonly] = ACTIONS(3397),
    [anon_sym_required] = ACTIONS(3397),
    [anon_sym_sealed] = ACTIONS(3397),
    [anon_sym_virtual] = ACTIONS(3397),
    [anon_sym_volatile] = ACTIONS(3397),
    [anon_sym_where] = ACTIONS(3397),
    [anon_sym_notnull] = ACTIONS(3397),
    [anon_sym_unmanaged] = ACTIONS(3397),
    [anon_sym_checked] = ACTIONS(3397),
    [anon_sym_BANG] = ACTIONS(3399),
    [anon_sym_TILDE] = ACTIONS(3399),
    [anon_sym_PLUS_PLUS] = ACTIONS(3399),
    [anon_sym_DASH_DASH] = ACTIONS(3399),
    [anon_sym_true] = ACTIONS(3397),
    [anon_sym_false] = ACTIONS(3397),
    [anon_sym_PLUS] = ACTIONS(3397),
    [anon_sym_DASH] = ACTIONS(3397),
    [anon_sym_STAR] = ACTIONS(3399),
    [anon_sym_CARET] = ACTIONS(3399),
    [anon_sym_AMP] = ACTIONS(3399),
    [anon_sym_this] = ACTIONS(3397),
    [anon_sym_scoped] = ACTIONS(3397),
    [anon_sym_var] = ACTIONS(3397),
    [sym_predefined_type] = ACTIONS(3397),
    [anon_sym_break] = ACTIONS(3397),
    [anon_sym_unchecked] = ACTIONS(3397),
    [anon_sym_continue] = ACTIONS(3397),
    [anon_sym_do] = ACTIONS(3397),
    [anon_sym_while] = ACTIONS(3397),
    [anon_sym_for] = ACTIONS(3397),
    [anon_sym_lock] = ACTIONS(3397),
    [anon_sym_yield] = ACTIONS(3397),
    [anon_sym_switch] = ACTIONS(3397),
    [anon_sym_default] = ACTIONS(3397),
    [anon_sym_throw] = ACTIONS(3397),
    [anon_sym_try] = ACTIONS(3397),
    [anon_sym_when] = ACTIONS(3397),
    [anon_sym_await] = ACTIONS(3397),
    [anon_sym_foreach] = ACTIONS(3397),
    [anon_sym_goto] = ACTIONS(3397),
    [anon_sym_if] = ACTIONS(3397),
    [anon_sym_else] = ACTIONS(3397),
    [anon_sym_DOT_DOT] = ACTIONS(3399),
    [anon_sym_from] = ACTIONS(3397),
    [anon_sym_into] = ACTIONS(3397),
    [anon_sym_join] = ACTIONS(3397),
    [anon_sym_on] = ACTIONS(3397),
    [anon_sym_equals] = ACTIONS(3397),
    [anon_sym_let] = ACTIONS(3397),
    [anon_sym_orderby] = ACTIONS(3397),
    [anon_sym_ascending] = ACTIONS(3397),
    [anon_sym_descending] = ACTIONS(3397),
    [anon_sym_group] = ACTIONS(3397),
    [anon_sym_by] = ACTIONS(3397),
    [anon_sym_select] = ACTIONS(3397),
    [anon_sym_DQUOTE] = ACTIONS(3397),
    [anon_sym_stackalloc] = ACTIONS(3397),
    [anon_sym_sizeof] = ACTIONS(3397),
    [anon_sym_typeof] = ACTIONS(3397),
    [anon_sym___makeref] = ACTIONS(3397),
    [anon_sym___reftype] = ACTIONS(3397),
    [anon_sym___refvalue] = ACTIONS(3397),
    [sym_null_literal] = ACTIONS(3397),
    [anon_sym_SQUOTE] = ACTIONS(3399),
    [sym_integer_literal] = ACTIONS(3397),
    [sym_real_literal] = ACTIONS(3399),
    [sym_verbatim_string_literal] = ACTIONS(3399),
    [sym_raw_string_literal] = ACTIONS(3399),
    [aux_sym_preproc_if_token1] = ACTIONS(3399),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3399),
    [sym_interpolation_verbatim_start] = ACTIONS(3399),
    [sym_interpolation_raw_start] = ACTIONS(3399),
  },
  [2485] = {
    [sym_preproc_region] = STATE(2485),
    [sym_preproc_endregion] = STATE(2485),
    [sym_preproc_line] = STATE(2485),
    [sym_preproc_pragma] = STATE(2485),
    [sym_preproc_nullable] = STATE(2485),
    [sym_preproc_error] = STATE(2485),
    [sym_preproc_define] = STATE(2485),
    [sym_preproc_undef] = STATE(2485),
    [ts_builtin_sym_end] = ACTIONS(3407),
    [sym__identifier_token] = ACTIONS(3405),
    [anon_sym_extern] = ACTIONS(3405),
    [anon_sym_alias] = ACTIONS(3405),
    [anon_sym_SEMI] = ACTIONS(3407),
    [anon_sym_global] = ACTIONS(3405),
    [anon_sym_using] = ACTIONS(3405),
    [anon_sym_unsafe] = ACTIONS(3405),
    [anon_sym_static] = ACTIONS(3405),
    [anon_sym_LBRACK] = ACTIONS(3407),
    [anon_sym_LPAREN] = ACTIONS(3407),
    [anon_sym_return] = ACTIONS(3405),
    [anon_sym_namespace] = ACTIONS(3405),
    [anon_sym_class] = ACTIONS(3405),
    [anon_sym_ref] = ACTIONS(3405),
    [anon_sym_struct] = ACTIONS(3405),
    [anon_sym_enum] = ACTIONS(3405),
    [anon_sym_LBRACE] = ACTIONS(3407),
    [anon_sym_interface] = ACTIONS(3405),
    [anon_sym_delegate] = ACTIONS(3405),
    [anon_sym_record] = ACTIONS(3405),
    [anon_sym_abstract] = ACTIONS(3405),
    [anon_sym_async] = ACTIONS(3405),
    [anon_sym_const] = ACTIONS(3405),
    [anon_sym_file] = ACTIONS(3405),
    [anon_sym_fixed] = ACTIONS(3405),
    [anon_sym_internal] = ACTIONS(3405),
    [anon_sym_new] = ACTIONS(3405),
    [anon_sym_override] = ACTIONS(3405),
    [anon_sym_partial] = ACTIONS(3405),
    [anon_sym_private] = ACTIONS(3405),
    [anon_sym_protected] = ACTIONS(3405),
    [anon_sym_public] = ACTIONS(3405),
    [anon_sym_readonly] = ACTIONS(3405),
    [anon_sym_required] = ACTIONS(3405),
    [anon_sym_sealed] = ACTIONS(3405),
    [anon_sym_virtual] = ACTIONS(3405),
    [anon_sym_volatile] = ACTIONS(3405),
    [anon_sym_where] = ACTIONS(3405),
    [anon_sym_notnull] = ACTIONS(3405),
    [anon_sym_unmanaged] = ACTIONS(3405),
    [anon_sym_checked] = ACTIONS(3405),
    [anon_sym_BANG] = ACTIONS(3407),
    [anon_sym_TILDE] = ACTIONS(3407),
    [anon_sym_PLUS_PLUS] = ACTIONS(3407),
    [anon_sym_DASH_DASH] = ACTIONS(3407),
    [anon_sym_true] = ACTIONS(3405),
    [anon_sym_false] = ACTIONS(3405),
    [anon_sym_PLUS] = ACTIONS(3405),
    [anon_sym_DASH] = ACTIONS(3405),
    [anon_sym_STAR] = ACTIONS(3407),
    [anon_sym_CARET] = ACTIONS(3407),
    [anon_sym_AMP] = ACTIONS(3407),
    [anon_sym_this] = ACTIONS(3405),
    [anon_sym_scoped] = ACTIONS(3405),
    [anon_sym_var] = ACTIONS(3405),
    [sym_predefined_type] = ACTIONS(3405),
    [anon_sym_break] = ACTIONS(3405),
    [anon_sym_unchecked] = ACTIONS(3405),
    [anon_sym_continue] = ACTIONS(3405),
    [anon_sym_do] = ACTIONS(3405),
    [anon_sym_while] = ACTIONS(3405),
    [anon_sym_for] = ACTIONS(3405),
    [anon_sym_lock] = ACTIONS(3405),
    [anon_sym_yield] = ACTIONS(3405),
    [anon_sym_switch] = ACTIONS(3405),
    [anon_sym_default] = ACTIONS(3405),
    [anon_sym_throw] = ACTIONS(3405),
    [anon_sym_try] = ACTIONS(3405),
    [anon_sym_when] = ACTIONS(3405),
    [anon_sym_await] = ACTIONS(3405),
    [anon_sym_foreach] = ACTIONS(3405),
    [anon_sym_goto] = ACTIONS(3405),
    [anon_sym_if] = ACTIONS(3405),
    [anon_sym_else] = ACTIONS(3405),
    [anon_sym_DOT_DOT] = ACTIONS(3407),
    [anon_sym_from] = ACTIONS(3405),
    [anon_sym_into] = ACTIONS(3405),
    [anon_sym_join] = ACTIONS(3405),
    [anon_sym_on] = ACTIONS(3405),
    [anon_sym_equals] = ACTIONS(3405),
    [anon_sym_let] = ACTIONS(3405),
    [anon_sym_orderby] = ACTIONS(3405),
    [anon_sym_ascending] = ACTIONS(3405),
    [anon_sym_descending] = ACTIONS(3405),
    [anon_sym_group] = ACTIONS(3405),
    [anon_sym_by] = ACTIONS(3405),
    [anon_sym_select] = ACTIONS(3405),
    [anon_sym_DQUOTE] = ACTIONS(3405),
    [anon_sym_stackalloc] = ACTIONS(3405),
    [anon_sym_sizeof] = ACTIONS(3405),
    [anon_sym_typeof] = ACTIONS(3405),
    [anon_sym___makeref] = ACTIONS(3405),
    [anon_sym___reftype] = ACTIONS(3405),
    [anon_sym___refvalue] = ACTIONS(3405),
    [sym_null_literal] = ACTIONS(3405),
    [anon_sym_SQUOTE] = ACTIONS(3407),
    [sym_integer_literal] = ACTIONS(3405),
    [sym_real_literal] = ACTIONS(3407),
    [sym_verbatim_string_literal] = ACTIONS(3407),
    [sym_raw_string_literal] = ACTIONS(3407),
    [aux_sym_preproc_if_token1] = ACTIONS(3407),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3407),
    [sym_interpolation_verbatim_start] = ACTIONS(3407),
    [sym_interpolation_raw_start] = ACTIONS(3407),
  },
  [2486] = {
    [sym_preproc_region] = STATE(2486),
    [sym_preproc_endregion] = STATE(2486),
    [sym_preproc_line] = STATE(2486),
    [sym_preproc_pragma] = STATE(2486),
    [sym_preproc_nullable] = STATE(2486),
    [sym_preproc_error] = STATE(2486),
    [sym_preproc_define] = STATE(2486),
    [sym_preproc_undef] = STATE(2486),
    [ts_builtin_sym_end] = ACTIONS(3261),
    [sym__identifier_token] = ACTIONS(3259),
    [anon_sym_extern] = ACTIONS(3259),
    [anon_sym_alias] = ACTIONS(3259),
    [anon_sym_SEMI] = ACTIONS(3261),
    [anon_sym_global] = ACTIONS(3259),
    [anon_sym_using] = ACTIONS(3259),
    [anon_sym_unsafe] = ACTIONS(3259),
    [anon_sym_static] = ACTIONS(3259),
    [anon_sym_LBRACK] = ACTIONS(3261),
    [anon_sym_LPAREN] = ACTIONS(3261),
    [anon_sym_return] = ACTIONS(3259),
    [anon_sym_namespace] = ACTIONS(3259),
    [anon_sym_class] = ACTIONS(3259),
    [anon_sym_ref] = ACTIONS(3259),
    [anon_sym_struct] = ACTIONS(3259),
    [anon_sym_enum] = ACTIONS(3259),
    [anon_sym_LBRACE] = ACTIONS(3261),
    [anon_sym_interface] = ACTIONS(3259),
    [anon_sym_delegate] = ACTIONS(3259),
    [anon_sym_record] = ACTIONS(3259),
    [anon_sym_abstract] = ACTIONS(3259),
    [anon_sym_async] = ACTIONS(3259),
    [anon_sym_const] = ACTIONS(3259),
    [anon_sym_file] = ACTIONS(3259),
    [anon_sym_fixed] = ACTIONS(3259),
    [anon_sym_internal] = ACTIONS(3259),
    [anon_sym_new] = ACTIONS(3259),
    [anon_sym_override] = ACTIONS(3259),
    [anon_sym_partial] = ACTIONS(3259),
    [anon_sym_private] = ACTIONS(3259),
    [anon_sym_protected] = ACTIONS(3259),
    [anon_sym_public] = ACTIONS(3259),
    [anon_sym_readonly] = ACTIONS(3259),
    [anon_sym_required] = ACTIONS(3259),
    [anon_sym_sealed] = ACTIONS(3259),
    [anon_sym_virtual] = ACTIONS(3259),
    [anon_sym_volatile] = ACTIONS(3259),
    [anon_sym_where] = ACTIONS(3259),
    [anon_sym_notnull] = ACTIONS(3259),
    [anon_sym_unmanaged] = ACTIONS(3259),
    [anon_sym_checked] = ACTIONS(3259),
    [anon_sym_BANG] = ACTIONS(3261),
    [anon_sym_TILDE] = ACTIONS(3261),
    [anon_sym_PLUS_PLUS] = ACTIONS(3261),
    [anon_sym_DASH_DASH] = ACTIONS(3261),
    [anon_sym_true] = ACTIONS(3259),
    [anon_sym_false] = ACTIONS(3259),
    [anon_sym_PLUS] = ACTIONS(3259),
    [anon_sym_DASH] = ACTIONS(3259),
    [anon_sym_STAR] = ACTIONS(3261),
    [anon_sym_CARET] = ACTIONS(3261),
    [anon_sym_AMP] = ACTIONS(3261),
    [anon_sym_this] = ACTIONS(3259),
    [anon_sym_scoped] = ACTIONS(3259),
    [anon_sym_var] = ACTIONS(3259),
    [sym_predefined_type] = ACTIONS(3259),
    [anon_sym_break] = ACTIONS(3259),
    [anon_sym_unchecked] = ACTIONS(3259),
    [anon_sym_continue] = ACTIONS(3259),
    [anon_sym_do] = ACTIONS(3259),
    [anon_sym_while] = ACTIONS(3259),
    [anon_sym_for] = ACTIONS(3259),
    [anon_sym_lock] = ACTIONS(3259),
    [anon_sym_yield] = ACTIONS(3259),
    [anon_sym_switch] = ACTIONS(3259),
    [anon_sym_default] = ACTIONS(3259),
    [anon_sym_throw] = ACTIONS(3259),
    [anon_sym_try] = ACTIONS(3259),
    [anon_sym_when] = ACTIONS(3259),
    [anon_sym_await] = ACTIONS(3259),
    [anon_sym_foreach] = ACTIONS(3259),
    [anon_sym_goto] = ACTIONS(3259),
    [anon_sym_if] = ACTIONS(3259),
    [anon_sym_else] = ACTIONS(3259),
    [anon_sym_DOT_DOT] = ACTIONS(3261),
    [anon_sym_from] = ACTIONS(3259),
    [anon_sym_into] = ACTIONS(3259),
    [anon_sym_join] = ACTIONS(3259),
    [anon_sym_on] = ACTIONS(3259),
    [anon_sym_equals] = ACTIONS(3259),
    [anon_sym_let] = ACTIONS(3259),
    [anon_sym_orderby] = ACTIONS(3259),
    [anon_sym_ascending] = ACTIONS(3259),
    [anon_sym_descending] = ACTIONS(3259),
    [anon_sym_group] = ACTIONS(3259),
    [anon_sym_by] = ACTIONS(3259),
    [anon_sym_select] = ACTIONS(3259),
    [anon_sym_DQUOTE] = ACTIONS(3259),
    [anon_sym_stackalloc] = ACTIONS(3259),
    [anon_sym_sizeof] = ACTIONS(3259),
    [anon_sym_typeof] = ACTIONS(3259),
    [anon_sym___makeref] = ACTIONS(3259),
    [anon_sym___reftype] = ACTIONS(3259),
    [anon_sym___refvalue] = ACTIONS(3259),
    [sym_null_literal] = ACTIONS(3259),
    [anon_sym_SQUOTE] = ACTIONS(3261),
    [sym_integer_literal] = ACTIONS(3259),
    [sym_real_literal] = ACTIONS(3261),
    [sym_verbatim_string_literal] = ACTIONS(3261),
    [sym_raw_string_literal] = ACTIONS(3261),
    [aux_sym_preproc_if_token1] = ACTIONS(3261),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3261),
    [sym_interpolation_verbatim_start] = ACTIONS(3261),
    [sym_interpolation_raw_start] = ACTIONS(3261),
  },
  [2487] = {
    [sym_preproc_region] = STATE(2487),
    [sym_preproc_endregion] = STATE(2487),
    [sym_preproc_line] = STATE(2487),
    [sym_preproc_pragma] = STATE(2487),
    [sym_preproc_nullable] = STATE(2487),
    [sym_preproc_error] = STATE(2487),
    [sym_preproc_define] = STATE(2487),
    [sym_preproc_undef] = STATE(2487),
    [ts_builtin_sym_end] = ACTIONS(3193),
    [sym__identifier_token] = ACTIONS(3191),
    [anon_sym_extern] = ACTIONS(3191),
    [anon_sym_alias] = ACTIONS(3191),
    [anon_sym_SEMI] = ACTIONS(3193),
    [anon_sym_global] = ACTIONS(3191),
    [anon_sym_using] = ACTIONS(3191),
    [anon_sym_unsafe] = ACTIONS(3191),
    [anon_sym_static] = ACTIONS(3191),
    [anon_sym_LBRACK] = ACTIONS(3193),
    [anon_sym_LPAREN] = ACTIONS(3193),
    [anon_sym_return] = ACTIONS(3191),
    [anon_sym_namespace] = ACTIONS(3191),
    [anon_sym_class] = ACTIONS(3191),
    [anon_sym_ref] = ACTIONS(3191),
    [anon_sym_struct] = ACTIONS(3191),
    [anon_sym_enum] = ACTIONS(3191),
    [anon_sym_LBRACE] = ACTIONS(3193),
    [anon_sym_interface] = ACTIONS(3191),
    [anon_sym_delegate] = ACTIONS(3191),
    [anon_sym_record] = ACTIONS(3191),
    [anon_sym_abstract] = ACTIONS(3191),
    [anon_sym_async] = ACTIONS(3191),
    [anon_sym_const] = ACTIONS(3191),
    [anon_sym_file] = ACTIONS(3191),
    [anon_sym_fixed] = ACTIONS(3191),
    [anon_sym_internal] = ACTIONS(3191),
    [anon_sym_new] = ACTIONS(3191),
    [anon_sym_override] = ACTIONS(3191),
    [anon_sym_partial] = ACTIONS(3191),
    [anon_sym_private] = ACTIONS(3191),
    [anon_sym_protected] = ACTIONS(3191),
    [anon_sym_public] = ACTIONS(3191),
    [anon_sym_readonly] = ACTIONS(3191),
    [anon_sym_required] = ACTIONS(3191),
    [anon_sym_sealed] = ACTIONS(3191),
    [anon_sym_virtual] = ACTIONS(3191),
    [anon_sym_volatile] = ACTIONS(3191),
    [anon_sym_where] = ACTIONS(3191),
    [anon_sym_notnull] = ACTIONS(3191),
    [anon_sym_unmanaged] = ACTIONS(3191),
    [anon_sym_checked] = ACTIONS(3191),
    [anon_sym_BANG] = ACTIONS(3193),
    [anon_sym_TILDE] = ACTIONS(3193),
    [anon_sym_PLUS_PLUS] = ACTIONS(3193),
    [anon_sym_DASH_DASH] = ACTIONS(3193),
    [anon_sym_true] = ACTIONS(3191),
    [anon_sym_false] = ACTIONS(3191),
    [anon_sym_PLUS] = ACTIONS(3191),
    [anon_sym_DASH] = ACTIONS(3191),
    [anon_sym_STAR] = ACTIONS(3193),
    [anon_sym_CARET] = ACTIONS(3193),
    [anon_sym_AMP] = ACTIONS(3193),
    [anon_sym_this] = ACTIONS(3191),
    [anon_sym_scoped] = ACTIONS(3191),
    [anon_sym_var] = ACTIONS(3191),
    [sym_predefined_type] = ACTIONS(3191),
    [anon_sym_break] = ACTIONS(3191),
    [anon_sym_unchecked] = ACTIONS(3191),
    [anon_sym_continue] = ACTIONS(3191),
    [anon_sym_do] = ACTIONS(3191),
    [anon_sym_while] = ACTIONS(3191),
    [anon_sym_for] = ACTIONS(3191),
    [anon_sym_lock] = ACTIONS(3191),
    [anon_sym_yield] = ACTIONS(3191),
    [anon_sym_switch] = ACTIONS(3191),
    [anon_sym_default] = ACTIONS(3191),
    [anon_sym_throw] = ACTIONS(3191),
    [anon_sym_try] = ACTIONS(3191),
    [anon_sym_when] = ACTIONS(3191),
    [anon_sym_await] = ACTIONS(3191),
    [anon_sym_foreach] = ACTIONS(3191),
    [anon_sym_goto] = ACTIONS(3191),
    [anon_sym_if] = ACTIONS(3191),
    [anon_sym_else] = ACTIONS(3191),
    [anon_sym_DOT_DOT] = ACTIONS(3193),
    [anon_sym_from] = ACTIONS(3191),
    [anon_sym_into] = ACTIONS(3191),
    [anon_sym_join] = ACTIONS(3191),
    [anon_sym_on] = ACTIONS(3191),
    [anon_sym_equals] = ACTIONS(3191),
    [anon_sym_let] = ACTIONS(3191),
    [anon_sym_orderby] = ACTIONS(3191),
    [anon_sym_ascending] = ACTIONS(3191),
    [anon_sym_descending] = ACTIONS(3191),
    [anon_sym_group] = ACTIONS(3191),
    [anon_sym_by] = ACTIONS(3191),
    [anon_sym_select] = ACTIONS(3191),
    [anon_sym_DQUOTE] = ACTIONS(3191),
    [anon_sym_stackalloc] = ACTIONS(3191),
    [anon_sym_sizeof] = ACTIONS(3191),
    [anon_sym_typeof] = ACTIONS(3191),
    [anon_sym___makeref] = ACTIONS(3191),
    [anon_sym___reftype] = ACTIONS(3191),
    [anon_sym___refvalue] = ACTIONS(3191),
    [sym_null_literal] = ACTIONS(3191),
    [anon_sym_SQUOTE] = ACTIONS(3193),
    [sym_integer_literal] = ACTIONS(3191),
    [sym_real_literal] = ACTIONS(3193),
    [sym_verbatim_string_literal] = ACTIONS(3193),
    [sym_raw_string_literal] = ACTIONS(3193),
    [aux_sym_preproc_if_token1] = ACTIONS(3193),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3193),
    [sym_interpolation_verbatim_start] = ACTIONS(3193),
    [sym_interpolation_raw_start] = ACTIONS(3193),
  },
  [2488] = {
    [sym_preproc_region] = STATE(2488),
    [sym_preproc_endregion] = STATE(2488),
    [sym_preproc_line] = STATE(2488),
    [sym_preproc_pragma] = STATE(2488),
    [sym_preproc_nullable] = STATE(2488),
    [sym_preproc_error] = STATE(2488),
    [sym_preproc_define] = STATE(2488),
    [sym_preproc_undef] = STATE(2488),
    [ts_builtin_sym_end] = ACTIONS(3095),
    [sym__identifier_token] = ACTIONS(3093),
    [anon_sym_extern] = ACTIONS(3093),
    [anon_sym_alias] = ACTIONS(3093),
    [anon_sym_SEMI] = ACTIONS(3095),
    [anon_sym_global] = ACTIONS(3093),
    [anon_sym_using] = ACTIONS(3093),
    [anon_sym_unsafe] = ACTIONS(3093),
    [anon_sym_static] = ACTIONS(3093),
    [anon_sym_LBRACK] = ACTIONS(3095),
    [anon_sym_LPAREN] = ACTIONS(3095),
    [anon_sym_return] = ACTIONS(3093),
    [anon_sym_namespace] = ACTIONS(3093),
    [anon_sym_class] = ACTIONS(3093),
    [anon_sym_ref] = ACTIONS(3093),
    [anon_sym_struct] = ACTIONS(3093),
    [anon_sym_enum] = ACTIONS(3093),
    [anon_sym_LBRACE] = ACTIONS(3095),
    [anon_sym_interface] = ACTIONS(3093),
    [anon_sym_delegate] = ACTIONS(3093),
    [anon_sym_record] = ACTIONS(3093),
    [anon_sym_abstract] = ACTIONS(3093),
    [anon_sym_async] = ACTIONS(3093),
    [anon_sym_const] = ACTIONS(3093),
    [anon_sym_file] = ACTIONS(3093),
    [anon_sym_fixed] = ACTIONS(3093),
    [anon_sym_internal] = ACTIONS(3093),
    [anon_sym_new] = ACTIONS(3093),
    [anon_sym_override] = ACTIONS(3093),
    [anon_sym_partial] = ACTIONS(3093),
    [anon_sym_private] = ACTIONS(3093),
    [anon_sym_protected] = ACTIONS(3093),
    [anon_sym_public] = ACTIONS(3093),
    [anon_sym_readonly] = ACTIONS(3093),
    [anon_sym_required] = ACTIONS(3093),
    [anon_sym_sealed] = ACTIONS(3093),
    [anon_sym_virtual] = ACTIONS(3093),
    [anon_sym_volatile] = ACTIONS(3093),
    [anon_sym_where] = ACTIONS(3093),
    [anon_sym_notnull] = ACTIONS(3093),
    [anon_sym_unmanaged] = ACTIONS(3093),
    [anon_sym_checked] = ACTIONS(3093),
    [anon_sym_BANG] = ACTIONS(3095),
    [anon_sym_TILDE] = ACTIONS(3095),
    [anon_sym_PLUS_PLUS] = ACTIONS(3095),
    [anon_sym_DASH_DASH] = ACTIONS(3095),
    [anon_sym_true] = ACTIONS(3093),
    [anon_sym_false] = ACTIONS(3093),
    [anon_sym_PLUS] = ACTIONS(3093),
    [anon_sym_DASH] = ACTIONS(3093),
    [anon_sym_STAR] = ACTIONS(3095),
    [anon_sym_CARET] = ACTIONS(3095),
    [anon_sym_AMP] = ACTIONS(3095),
    [anon_sym_this] = ACTIONS(3093),
    [anon_sym_scoped] = ACTIONS(3093),
    [anon_sym_var] = ACTIONS(3093),
    [sym_predefined_type] = ACTIONS(3093),
    [anon_sym_break] = ACTIONS(3093),
    [anon_sym_unchecked] = ACTIONS(3093),
    [anon_sym_continue] = ACTIONS(3093),
    [anon_sym_do] = ACTIONS(3093),
    [anon_sym_while] = ACTIONS(3093),
    [anon_sym_for] = ACTIONS(3093),
    [anon_sym_lock] = ACTIONS(3093),
    [anon_sym_yield] = ACTIONS(3093),
    [anon_sym_switch] = ACTIONS(3093),
    [anon_sym_default] = ACTIONS(3093),
    [anon_sym_throw] = ACTIONS(3093),
    [anon_sym_try] = ACTIONS(3093),
    [anon_sym_when] = ACTIONS(3093),
    [anon_sym_await] = ACTIONS(3093),
    [anon_sym_foreach] = ACTIONS(3093),
    [anon_sym_goto] = ACTIONS(3093),
    [anon_sym_if] = ACTIONS(3093),
    [anon_sym_else] = ACTIONS(3093),
    [anon_sym_DOT_DOT] = ACTIONS(3095),
    [anon_sym_from] = ACTIONS(3093),
    [anon_sym_into] = ACTIONS(3093),
    [anon_sym_join] = ACTIONS(3093),
    [anon_sym_on] = ACTIONS(3093),
    [anon_sym_equals] = ACTIONS(3093),
    [anon_sym_let] = ACTIONS(3093),
    [anon_sym_orderby] = ACTIONS(3093),
    [anon_sym_ascending] = ACTIONS(3093),
    [anon_sym_descending] = ACTIONS(3093),
    [anon_sym_group] = ACTIONS(3093),
    [anon_sym_by] = ACTIONS(3093),
    [anon_sym_select] = ACTIONS(3093),
    [anon_sym_DQUOTE] = ACTIONS(3093),
    [anon_sym_stackalloc] = ACTIONS(3093),
    [anon_sym_sizeof] = ACTIONS(3093),
    [anon_sym_typeof] = ACTIONS(3093),
    [anon_sym___makeref] = ACTIONS(3093),
    [anon_sym___reftype] = ACTIONS(3093),
    [anon_sym___refvalue] = ACTIONS(3093),
    [sym_null_literal] = ACTIONS(3093),
    [anon_sym_SQUOTE] = ACTIONS(3095),
    [sym_integer_literal] = ACTIONS(3093),
    [sym_real_literal] = ACTIONS(3095),
    [sym_verbatim_string_literal] = ACTIONS(3095),
    [sym_raw_string_literal] = ACTIONS(3095),
    [aux_sym_preproc_if_token1] = ACTIONS(3095),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3095),
    [sym_interpolation_verbatim_start] = ACTIONS(3095),
    [sym_interpolation_raw_start] = ACTIONS(3095),
  },
  [2489] = {
    [sym_preproc_region] = STATE(2489),
    [sym_preproc_endregion] = STATE(2489),
    [sym_preproc_line] = STATE(2489),
    [sym_preproc_pragma] = STATE(2489),
    [sym_preproc_nullable] = STATE(2489),
    [sym_preproc_error] = STATE(2489),
    [sym_preproc_define] = STATE(2489),
    [sym_preproc_undef] = STATE(2489),
    [ts_builtin_sym_end] = ACTIONS(3265),
    [sym__identifier_token] = ACTIONS(3263),
    [anon_sym_extern] = ACTIONS(3263),
    [anon_sym_alias] = ACTIONS(3263),
    [anon_sym_SEMI] = ACTIONS(3265),
    [anon_sym_global] = ACTIONS(3263),
    [anon_sym_using] = ACTIONS(3263),
    [anon_sym_unsafe] = ACTIONS(3263),
    [anon_sym_static] = ACTIONS(3263),
    [anon_sym_LBRACK] = ACTIONS(3265),
    [anon_sym_LPAREN] = ACTIONS(3265),
    [anon_sym_return] = ACTIONS(3263),
    [anon_sym_namespace] = ACTIONS(3263),
    [anon_sym_class] = ACTIONS(3263),
    [anon_sym_ref] = ACTIONS(3263),
    [anon_sym_struct] = ACTIONS(3263),
    [anon_sym_enum] = ACTIONS(3263),
    [anon_sym_LBRACE] = ACTIONS(3265),
    [anon_sym_interface] = ACTIONS(3263),
    [anon_sym_delegate] = ACTIONS(3263),
    [anon_sym_record] = ACTIONS(3263),
    [anon_sym_abstract] = ACTIONS(3263),
    [anon_sym_async] = ACTIONS(3263),
    [anon_sym_const] = ACTIONS(3263),
    [anon_sym_file] = ACTIONS(3263),
    [anon_sym_fixed] = ACTIONS(3263),
    [anon_sym_internal] = ACTIONS(3263),
    [anon_sym_new] = ACTIONS(3263),
    [anon_sym_override] = ACTIONS(3263),
    [anon_sym_partial] = ACTIONS(3263),
    [anon_sym_private] = ACTIONS(3263),
    [anon_sym_protected] = ACTIONS(3263),
    [anon_sym_public] = ACTIONS(3263),
    [anon_sym_readonly] = ACTIONS(3263),
    [anon_sym_required] = ACTIONS(3263),
    [anon_sym_sealed] = ACTIONS(3263),
    [anon_sym_virtual] = ACTIONS(3263),
    [anon_sym_volatile] = ACTIONS(3263),
    [anon_sym_where] = ACTIONS(3263),
    [anon_sym_notnull] = ACTIONS(3263),
    [anon_sym_unmanaged] = ACTIONS(3263),
    [anon_sym_checked] = ACTIONS(3263),
    [anon_sym_BANG] = ACTIONS(3265),
    [anon_sym_TILDE] = ACTIONS(3265),
    [anon_sym_PLUS_PLUS] = ACTIONS(3265),
    [anon_sym_DASH_DASH] = ACTIONS(3265),
    [anon_sym_true] = ACTIONS(3263),
    [anon_sym_false] = ACTIONS(3263),
    [anon_sym_PLUS] = ACTIONS(3263),
    [anon_sym_DASH] = ACTIONS(3263),
    [anon_sym_STAR] = ACTIONS(3265),
    [anon_sym_CARET] = ACTIONS(3265),
    [anon_sym_AMP] = ACTIONS(3265),
    [anon_sym_this] = ACTIONS(3263),
    [anon_sym_scoped] = ACTIONS(3263),
    [anon_sym_var] = ACTIONS(3263),
    [sym_predefined_type] = ACTIONS(3263),
    [anon_sym_break] = ACTIONS(3263),
    [anon_sym_unchecked] = ACTIONS(3263),
    [anon_sym_continue] = ACTIONS(3263),
    [anon_sym_do] = ACTIONS(3263),
    [anon_sym_while] = ACTIONS(3263),
    [anon_sym_for] = ACTIONS(3263),
    [anon_sym_lock] = ACTIONS(3263),
    [anon_sym_yield] = ACTIONS(3263),
    [anon_sym_switch] = ACTIONS(3263),
    [anon_sym_default] = ACTIONS(3263),
    [anon_sym_throw] = ACTIONS(3263),
    [anon_sym_try] = ACTIONS(3263),
    [anon_sym_when] = ACTIONS(3263),
    [anon_sym_await] = ACTIONS(3263),
    [anon_sym_foreach] = ACTIONS(3263),
    [anon_sym_goto] = ACTIONS(3263),
    [anon_sym_if] = ACTIONS(3263),
    [anon_sym_else] = ACTIONS(3263),
    [anon_sym_DOT_DOT] = ACTIONS(3265),
    [anon_sym_from] = ACTIONS(3263),
    [anon_sym_into] = ACTIONS(3263),
    [anon_sym_join] = ACTIONS(3263),
    [anon_sym_on] = ACTIONS(3263),
    [anon_sym_equals] = ACTIONS(3263),
    [anon_sym_let] = ACTIONS(3263),
    [anon_sym_orderby] = ACTIONS(3263),
    [anon_sym_ascending] = ACTIONS(3263),
    [anon_sym_descending] = ACTIONS(3263),
    [anon_sym_group] = ACTIONS(3263),
    [anon_sym_by] = ACTIONS(3263),
    [anon_sym_select] = ACTIONS(3263),
    [anon_sym_DQUOTE] = ACTIONS(3263),
    [anon_sym_stackalloc] = ACTIONS(3263),
    [anon_sym_sizeof] = ACTIONS(3263),
    [anon_sym_typeof] = ACTIONS(3263),
    [anon_sym___makeref] = ACTIONS(3263),
    [anon_sym___reftype] = ACTIONS(3263),
    [anon_sym___refvalue] = ACTIONS(3263),
    [sym_null_literal] = ACTIONS(3263),
    [anon_sym_SQUOTE] = ACTIONS(3265),
    [sym_integer_literal] = ACTIONS(3263),
    [sym_real_literal] = ACTIONS(3265),
    [sym_verbatim_string_literal] = ACTIONS(3265),
    [sym_raw_string_literal] = ACTIONS(3265),
    [aux_sym_preproc_if_token1] = ACTIONS(3265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3265),
    [sym_interpolation_verbatim_start] = ACTIONS(3265),
    [sym_interpolation_raw_start] = ACTIONS(3265),
  },
  [2490] = {
    [sym_preproc_region] = STATE(2490),
    [sym_preproc_endregion] = STATE(2490),
    [sym_preproc_line] = STATE(2490),
    [sym_preproc_pragma] = STATE(2490),
    [sym_preproc_nullable] = STATE(2490),
    [sym_preproc_error] = STATE(2490),
    [sym_preproc_define] = STATE(2490),
    [sym_preproc_undef] = STATE(2490),
    [ts_builtin_sym_end] = ACTIONS(3281),
    [sym__identifier_token] = ACTIONS(3279),
    [anon_sym_extern] = ACTIONS(3279),
    [anon_sym_alias] = ACTIONS(3279),
    [anon_sym_SEMI] = ACTIONS(3281),
    [anon_sym_global] = ACTIONS(3279),
    [anon_sym_using] = ACTIONS(3279),
    [anon_sym_unsafe] = ACTIONS(3279),
    [anon_sym_static] = ACTIONS(3279),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_LPAREN] = ACTIONS(3281),
    [anon_sym_return] = ACTIONS(3279),
    [anon_sym_namespace] = ACTIONS(3279),
    [anon_sym_class] = ACTIONS(3279),
    [anon_sym_ref] = ACTIONS(3279),
    [anon_sym_struct] = ACTIONS(3279),
    [anon_sym_enum] = ACTIONS(3279),
    [anon_sym_LBRACE] = ACTIONS(3281),
    [anon_sym_interface] = ACTIONS(3279),
    [anon_sym_delegate] = ACTIONS(3279),
    [anon_sym_record] = ACTIONS(3279),
    [anon_sym_abstract] = ACTIONS(3279),
    [anon_sym_async] = ACTIONS(3279),
    [anon_sym_const] = ACTIONS(3279),
    [anon_sym_file] = ACTIONS(3279),
    [anon_sym_fixed] = ACTIONS(3279),
    [anon_sym_internal] = ACTIONS(3279),
    [anon_sym_new] = ACTIONS(3279),
    [anon_sym_override] = ACTIONS(3279),
    [anon_sym_partial] = ACTIONS(3279),
    [anon_sym_private] = ACTIONS(3279),
    [anon_sym_protected] = ACTIONS(3279),
    [anon_sym_public] = ACTIONS(3279),
    [anon_sym_readonly] = ACTIONS(3279),
    [anon_sym_required] = ACTIONS(3279),
    [anon_sym_sealed] = ACTIONS(3279),
    [anon_sym_virtual] = ACTIONS(3279),
    [anon_sym_volatile] = ACTIONS(3279),
    [anon_sym_where] = ACTIONS(3279),
    [anon_sym_notnull] = ACTIONS(3279),
    [anon_sym_unmanaged] = ACTIONS(3279),
    [anon_sym_checked] = ACTIONS(3279),
    [anon_sym_BANG] = ACTIONS(3281),
    [anon_sym_TILDE] = ACTIONS(3281),
    [anon_sym_PLUS_PLUS] = ACTIONS(3281),
    [anon_sym_DASH_DASH] = ACTIONS(3281),
    [anon_sym_true] = ACTIONS(3279),
    [anon_sym_false] = ACTIONS(3279),
    [anon_sym_PLUS] = ACTIONS(3279),
    [anon_sym_DASH] = ACTIONS(3279),
    [anon_sym_STAR] = ACTIONS(3281),
    [anon_sym_CARET] = ACTIONS(3281),
    [anon_sym_AMP] = ACTIONS(3281),
    [anon_sym_this] = ACTIONS(3279),
    [anon_sym_scoped] = ACTIONS(3279),
    [anon_sym_var] = ACTIONS(3279),
    [sym_predefined_type] = ACTIONS(3279),
    [anon_sym_break] = ACTIONS(3279),
    [anon_sym_unchecked] = ACTIONS(3279),
    [anon_sym_continue] = ACTIONS(3279),
    [anon_sym_do] = ACTIONS(3279),
    [anon_sym_while] = ACTIONS(3279),
    [anon_sym_for] = ACTIONS(3279),
    [anon_sym_lock] = ACTIONS(3279),
    [anon_sym_yield] = ACTIONS(3279),
    [anon_sym_switch] = ACTIONS(3279),
    [anon_sym_default] = ACTIONS(3279),
    [anon_sym_throw] = ACTIONS(3279),
    [anon_sym_try] = ACTIONS(3279),
    [anon_sym_when] = ACTIONS(3279),
    [anon_sym_await] = ACTIONS(3279),
    [anon_sym_foreach] = ACTIONS(3279),
    [anon_sym_goto] = ACTIONS(3279),
    [anon_sym_if] = ACTIONS(3279),
    [anon_sym_else] = ACTIONS(3279),
    [anon_sym_DOT_DOT] = ACTIONS(3281),
    [anon_sym_from] = ACTIONS(3279),
    [anon_sym_into] = ACTIONS(3279),
    [anon_sym_join] = ACTIONS(3279),
    [anon_sym_on] = ACTIONS(3279),
    [anon_sym_equals] = ACTIONS(3279),
    [anon_sym_let] = ACTIONS(3279),
    [anon_sym_orderby] = ACTIONS(3279),
    [anon_sym_ascending] = ACTIONS(3279),
    [anon_sym_descending] = ACTIONS(3279),
    [anon_sym_group] = ACTIONS(3279),
    [anon_sym_by] = ACTIONS(3279),
    [anon_sym_select] = ACTIONS(3279),
    [anon_sym_DQUOTE] = ACTIONS(3279),
    [anon_sym_stackalloc] = ACTIONS(3279),
    [anon_sym_sizeof] = ACTIONS(3279),
    [anon_sym_typeof] = ACTIONS(3279),
    [anon_sym___makeref] = ACTIONS(3279),
    [anon_sym___reftype] = ACTIONS(3279),
    [anon_sym___refvalue] = ACTIONS(3279),
    [sym_null_literal] = ACTIONS(3279),
    [anon_sym_SQUOTE] = ACTIONS(3281),
    [sym_integer_literal] = ACTIONS(3279),
    [sym_real_literal] = ACTIONS(3281),
    [sym_verbatim_string_literal] = ACTIONS(3281),
    [sym_raw_string_literal] = ACTIONS(3281),
    [aux_sym_preproc_if_token1] = ACTIONS(3281),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3281),
    [sym_interpolation_verbatim_start] = ACTIONS(3281),
    [sym_interpolation_raw_start] = ACTIONS(3281),
  },
  [2491] = {
    [sym_preproc_region] = STATE(2491),
    [sym_preproc_endregion] = STATE(2491),
    [sym_preproc_line] = STATE(2491),
    [sym_preproc_pragma] = STATE(2491),
    [sym_preproc_nullable] = STATE(2491),
    [sym_preproc_error] = STATE(2491),
    [sym_preproc_define] = STATE(2491),
    [sym_preproc_undef] = STATE(2491),
    [ts_builtin_sym_end] = ACTIONS(3051),
    [sym__identifier_token] = ACTIONS(3049),
    [anon_sym_extern] = ACTIONS(3049),
    [anon_sym_alias] = ACTIONS(3049),
    [anon_sym_SEMI] = ACTIONS(3051),
    [anon_sym_global] = ACTIONS(3049),
    [anon_sym_using] = ACTIONS(3049),
    [anon_sym_unsafe] = ACTIONS(3049),
    [anon_sym_static] = ACTIONS(3049),
    [anon_sym_LBRACK] = ACTIONS(3051),
    [anon_sym_LPAREN] = ACTIONS(3051),
    [anon_sym_return] = ACTIONS(3049),
    [anon_sym_namespace] = ACTIONS(3049),
    [anon_sym_class] = ACTIONS(3049),
    [anon_sym_ref] = ACTIONS(3049),
    [anon_sym_struct] = ACTIONS(3049),
    [anon_sym_enum] = ACTIONS(3049),
    [anon_sym_LBRACE] = ACTIONS(3051),
    [anon_sym_interface] = ACTIONS(3049),
    [anon_sym_delegate] = ACTIONS(3049),
    [anon_sym_record] = ACTIONS(3049),
    [anon_sym_abstract] = ACTIONS(3049),
    [anon_sym_async] = ACTIONS(3049),
    [anon_sym_const] = ACTIONS(3049),
    [anon_sym_file] = ACTIONS(3049),
    [anon_sym_fixed] = ACTIONS(3049),
    [anon_sym_internal] = ACTIONS(3049),
    [anon_sym_new] = ACTIONS(3049),
    [anon_sym_override] = ACTIONS(3049),
    [anon_sym_partial] = ACTIONS(3049),
    [anon_sym_private] = ACTIONS(3049),
    [anon_sym_protected] = ACTIONS(3049),
    [anon_sym_public] = ACTIONS(3049),
    [anon_sym_readonly] = ACTIONS(3049),
    [anon_sym_required] = ACTIONS(3049),
    [anon_sym_sealed] = ACTIONS(3049),
    [anon_sym_virtual] = ACTIONS(3049),
    [anon_sym_volatile] = ACTIONS(3049),
    [anon_sym_where] = ACTIONS(3049),
    [anon_sym_notnull] = ACTIONS(3049),
    [anon_sym_unmanaged] = ACTIONS(3049),
    [anon_sym_checked] = ACTIONS(3049),
    [anon_sym_BANG] = ACTIONS(3051),
    [anon_sym_TILDE] = ACTIONS(3051),
    [anon_sym_PLUS_PLUS] = ACTIONS(3051),
    [anon_sym_DASH_DASH] = ACTIONS(3051),
    [anon_sym_true] = ACTIONS(3049),
    [anon_sym_false] = ACTIONS(3049),
    [anon_sym_PLUS] = ACTIONS(3049),
    [anon_sym_DASH] = ACTIONS(3049),
    [anon_sym_STAR] = ACTIONS(3051),
    [anon_sym_CARET] = ACTIONS(3051),
    [anon_sym_AMP] = ACTIONS(3051),
    [anon_sym_this] = ACTIONS(3049),
    [anon_sym_scoped] = ACTIONS(3049),
    [anon_sym_var] = ACTIONS(3049),
    [sym_predefined_type] = ACTIONS(3049),
    [anon_sym_break] = ACTIONS(3049),
    [anon_sym_unchecked] = ACTIONS(3049),
    [anon_sym_continue] = ACTIONS(3049),
    [anon_sym_do] = ACTIONS(3049),
    [anon_sym_while] = ACTIONS(3049),
    [anon_sym_for] = ACTIONS(3049),
    [anon_sym_lock] = ACTIONS(3049),
    [anon_sym_yield] = ACTIONS(3049),
    [anon_sym_switch] = ACTIONS(3049),
    [anon_sym_default] = ACTIONS(3049),
    [anon_sym_throw] = ACTIONS(3049),
    [anon_sym_try] = ACTIONS(3049),
    [anon_sym_when] = ACTIONS(3049),
    [anon_sym_await] = ACTIONS(3049),
    [anon_sym_foreach] = ACTIONS(3049),
    [anon_sym_goto] = ACTIONS(3049),
    [anon_sym_if] = ACTIONS(3049),
    [anon_sym_else] = ACTIONS(3049),
    [anon_sym_DOT_DOT] = ACTIONS(3051),
    [anon_sym_from] = ACTIONS(3049),
    [anon_sym_into] = ACTIONS(3049),
    [anon_sym_join] = ACTIONS(3049),
    [anon_sym_on] = ACTIONS(3049),
    [anon_sym_equals] = ACTIONS(3049),
    [anon_sym_let] = ACTIONS(3049),
    [anon_sym_orderby] = ACTIONS(3049),
    [anon_sym_ascending] = ACTIONS(3049),
    [anon_sym_descending] = ACTIONS(3049),
    [anon_sym_group] = ACTIONS(3049),
    [anon_sym_by] = ACTIONS(3049),
    [anon_sym_select] = ACTIONS(3049),
    [anon_sym_DQUOTE] = ACTIONS(3049),
    [anon_sym_stackalloc] = ACTIONS(3049),
    [anon_sym_sizeof] = ACTIONS(3049),
    [anon_sym_typeof] = ACTIONS(3049),
    [anon_sym___makeref] = ACTIONS(3049),
    [anon_sym___reftype] = ACTIONS(3049),
    [anon_sym___refvalue] = ACTIONS(3049),
    [sym_null_literal] = ACTIONS(3049),
    [anon_sym_SQUOTE] = ACTIONS(3051),
    [sym_integer_literal] = ACTIONS(3049),
    [sym_real_literal] = ACTIONS(3051),
    [sym_verbatim_string_literal] = ACTIONS(3051),
    [sym_raw_string_literal] = ACTIONS(3051),
    [aux_sym_preproc_if_token1] = ACTIONS(3051),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3051),
    [sym_interpolation_verbatim_start] = ACTIONS(3051),
    [sym_interpolation_raw_start] = ACTIONS(3051),
  },
  [2492] = {
    [sym_preproc_region] = STATE(2492),
    [sym_preproc_endregion] = STATE(2492),
    [sym_preproc_line] = STATE(2492),
    [sym_preproc_pragma] = STATE(2492),
    [sym_preproc_nullable] = STATE(2492),
    [sym_preproc_error] = STATE(2492),
    [sym_preproc_define] = STATE(2492),
    [sym_preproc_undef] = STATE(2492),
    [ts_builtin_sym_end] = ACTIONS(3269),
    [sym__identifier_token] = ACTIONS(3267),
    [anon_sym_extern] = ACTIONS(3267),
    [anon_sym_alias] = ACTIONS(3267),
    [anon_sym_SEMI] = ACTIONS(3269),
    [anon_sym_global] = ACTIONS(3267),
    [anon_sym_using] = ACTIONS(3267),
    [anon_sym_unsafe] = ACTIONS(3267),
    [anon_sym_static] = ACTIONS(3267),
    [anon_sym_LBRACK] = ACTIONS(3269),
    [anon_sym_LPAREN] = ACTIONS(3269),
    [anon_sym_return] = ACTIONS(3267),
    [anon_sym_namespace] = ACTIONS(3267),
    [anon_sym_class] = ACTIONS(3267),
    [anon_sym_ref] = ACTIONS(3267),
    [anon_sym_struct] = ACTIONS(3267),
    [anon_sym_enum] = ACTIONS(3267),
    [anon_sym_LBRACE] = ACTIONS(3269),
    [anon_sym_interface] = ACTIONS(3267),
    [anon_sym_delegate] = ACTIONS(3267),
    [anon_sym_record] = ACTIONS(3267),
    [anon_sym_abstract] = ACTIONS(3267),
    [anon_sym_async] = ACTIONS(3267),
    [anon_sym_const] = ACTIONS(3267),
    [anon_sym_file] = ACTIONS(3267),
    [anon_sym_fixed] = ACTIONS(3267),
    [anon_sym_internal] = ACTIONS(3267),
    [anon_sym_new] = ACTIONS(3267),
    [anon_sym_override] = ACTIONS(3267),
    [anon_sym_partial] = ACTIONS(3267),
    [anon_sym_private] = ACTIONS(3267),
    [anon_sym_protected] = ACTIONS(3267),
    [anon_sym_public] = ACTIONS(3267),
    [anon_sym_readonly] = ACTIONS(3267),
    [anon_sym_required] = ACTIONS(3267),
    [anon_sym_sealed] = ACTIONS(3267),
    [anon_sym_virtual] = ACTIONS(3267),
    [anon_sym_volatile] = ACTIONS(3267),
    [anon_sym_where] = ACTIONS(3267),
    [anon_sym_notnull] = ACTIONS(3267),
    [anon_sym_unmanaged] = ACTIONS(3267),
    [anon_sym_checked] = ACTIONS(3267),
    [anon_sym_BANG] = ACTIONS(3269),
    [anon_sym_TILDE] = ACTIONS(3269),
    [anon_sym_PLUS_PLUS] = ACTIONS(3269),
    [anon_sym_DASH_DASH] = ACTIONS(3269),
    [anon_sym_true] = ACTIONS(3267),
    [anon_sym_false] = ACTIONS(3267),
    [anon_sym_PLUS] = ACTIONS(3267),
    [anon_sym_DASH] = ACTIONS(3267),
    [anon_sym_STAR] = ACTIONS(3269),
    [anon_sym_CARET] = ACTIONS(3269),
    [anon_sym_AMP] = ACTIONS(3269),
    [anon_sym_this] = ACTIONS(3267),
    [anon_sym_scoped] = ACTIONS(3267),
    [anon_sym_var] = ACTIONS(3267),
    [sym_predefined_type] = ACTIONS(3267),
    [anon_sym_break] = ACTIONS(3267),
    [anon_sym_unchecked] = ACTIONS(3267),
    [anon_sym_continue] = ACTIONS(3267),
    [anon_sym_do] = ACTIONS(3267),
    [anon_sym_while] = ACTIONS(3267),
    [anon_sym_for] = ACTIONS(3267),
    [anon_sym_lock] = ACTIONS(3267),
    [anon_sym_yield] = ACTIONS(3267),
    [anon_sym_switch] = ACTIONS(3267),
    [anon_sym_default] = ACTIONS(3267),
    [anon_sym_throw] = ACTIONS(3267),
    [anon_sym_try] = ACTIONS(3267),
    [anon_sym_when] = ACTIONS(3267),
    [anon_sym_await] = ACTIONS(3267),
    [anon_sym_foreach] = ACTIONS(3267),
    [anon_sym_goto] = ACTIONS(3267),
    [anon_sym_if] = ACTIONS(3267),
    [anon_sym_else] = ACTIONS(3267),
    [anon_sym_DOT_DOT] = ACTIONS(3269),
    [anon_sym_from] = ACTIONS(3267),
    [anon_sym_into] = ACTIONS(3267),
    [anon_sym_join] = ACTIONS(3267),
    [anon_sym_on] = ACTIONS(3267),
    [anon_sym_equals] = ACTIONS(3267),
    [anon_sym_let] = ACTIONS(3267),
    [anon_sym_orderby] = ACTIONS(3267),
    [anon_sym_ascending] = ACTIONS(3267),
    [anon_sym_descending] = ACTIONS(3267),
    [anon_sym_group] = ACTIONS(3267),
    [anon_sym_by] = ACTIONS(3267),
    [anon_sym_select] = ACTIONS(3267),
    [anon_sym_DQUOTE] = ACTIONS(3267),
    [anon_sym_stackalloc] = ACTIONS(3267),
    [anon_sym_sizeof] = ACTIONS(3267),
    [anon_sym_typeof] = ACTIONS(3267),
    [anon_sym___makeref] = ACTIONS(3267),
    [anon_sym___reftype] = ACTIONS(3267),
    [anon_sym___refvalue] = ACTIONS(3267),
    [sym_null_literal] = ACTIONS(3267),
    [anon_sym_SQUOTE] = ACTIONS(3269),
    [sym_integer_literal] = ACTIONS(3267),
    [sym_real_literal] = ACTIONS(3269),
    [sym_verbatim_string_literal] = ACTIONS(3269),
    [sym_raw_string_literal] = ACTIONS(3269),
    [aux_sym_preproc_if_token1] = ACTIONS(3269),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3269),
    [sym_interpolation_verbatim_start] = ACTIONS(3269),
    [sym_interpolation_raw_start] = ACTIONS(3269),
  },
  [2493] = {
    [sym_preproc_region] = STATE(2493),
    [sym_preproc_endregion] = STATE(2493),
    [sym_preproc_line] = STATE(2493),
    [sym_preproc_pragma] = STATE(2493),
    [sym_preproc_nullable] = STATE(2493),
    [sym_preproc_error] = STATE(2493),
    [sym_preproc_define] = STATE(2493),
    [sym_preproc_undef] = STATE(2493),
    [ts_builtin_sym_end] = ACTIONS(3317),
    [sym__identifier_token] = ACTIONS(3315),
    [anon_sym_extern] = ACTIONS(3315),
    [anon_sym_alias] = ACTIONS(3315),
    [anon_sym_SEMI] = ACTIONS(3317),
    [anon_sym_global] = ACTIONS(3315),
    [anon_sym_using] = ACTIONS(3315),
    [anon_sym_unsafe] = ACTIONS(3315),
    [anon_sym_static] = ACTIONS(3315),
    [anon_sym_LBRACK] = ACTIONS(3317),
    [anon_sym_LPAREN] = ACTIONS(3317),
    [anon_sym_return] = ACTIONS(3315),
    [anon_sym_namespace] = ACTIONS(3315),
    [anon_sym_class] = ACTIONS(3315),
    [anon_sym_ref] = ACTIONS(3315),
    [anon_sym_struct] = ACTIONS(3315),
    [anon_sym_enum] = ACTIONS(3315),
    [anon_sym_LBRACE] = ACTIONS(3317),
    [anon_sym_interface] = ACTIONS(3315),
    [anon_sym_delegate] = ACTIONS(3315),
    [anon_sym_record] = ACTIONS(3315),
    [anon_sym_abstract] = ACTIONS(3315),
    [anon_sym_async] = ACTIONS(3315),
    [anon_sym_const] = ACTIONS(3315),
    [anon_sym_file] = ACTIONS(3315),
    [anon_sym_fixed] = ACTIONS(3315),
    [anon_sym_internal] = ACTIONS(3315),
    [anon_sym_new] = ACTIONS(3315),
    [anon_sym_override] = ACTIONS(3315),
    [anon_sym_partial] = ACTIONS(3315),
    [anon_sym_private] = ACTIONS(3315),
    [anon_sym_protected] = ACTIONS(3315),
    [anon_sym_public] = ACTIONS(3315),
    [anon_sym_readonly] = ACTIONS(3315),
    [anon_sym_required] = ACTIONS(3315),
    [anon_sym_sealed] = ACTIONS(3315),
    [anon_sym_virtual] = ACTIONS(3315),
    [anon_sym_volatile] = ACTIONS(3315),
    [anon_sym_where] = ACTIONS(3315),
    [anon_sym_notnull] = ACTIONS(3315),
    [anon_sym_unmanaged] = ACTIONS(3315),
    [anon_sym_checked] = ACTIONS(3315),
    [anon_sym_BANG] = ACTIONS(3317),
    [anon_sym_TILDE] = ACTIONS(3317),
    [anon_sym_PLUS_PLUS] = ACTIONS(3317),
    [anon_sym_DASH_DASH] = ACTIONS(3317),
    [anon_sym_true] = ACTIONS(3315),
    [anon_sym_false] = ACTIONS(3315),
    [anon_sym_PLUS] = ACTIONS(3315),
    [anon_sym_DASH] = ACTIONS(3315),
    [anon_sym_STAR] = ACTIONS(3317),
    [anon_sym_CARET] = ACTIONS(3317),
    [anon_sym_AMP] = ACTIONS(3317),
    [anon_sym_this] = ACTIONS(3315),
    [anon_sym_scoped] = ACTIONS(3315),
    [anon_sym_var] = ACTIONS(3315),
    [sym_predefined_type] = ACTIONS(3315),
    [anon_sym_break] = ACTIONS(3315),
    [anon_sym_unchecked] = ACTIONS(3315),
    [anon_sym_continue] = ACTIONS(3315),
    [anon_sym_do] = ACTIONS(3315),
    [anon_sym_while] = ACTIONS(3315),
    [anon_sym_for] = ACTIONS(3315),
    [anon_sym_lock] = ACTIONS(3315),
    [anon_sym_yield] = ACTIONS(3315),
    [anon_sym_switch] = ACTIONS(3315),
    [anon_sym_default] = ACTIONS(3315),
    [anon_sym_throw] = ACTIONS(3315),
    [anon_sym_try] = ACTIONS(3315),
    [anon_sym_when] = ACTIONS(3315),
    [anon_sym_await] = ACTIONS(3315),
    [anon_sym_foreach] = ACTIONS(3315),
    [anon_sym_goto] = ACTIONS(3315),
    [anon_sym_if] = ACTIONS(3315),
    [anon_sym_else] = ACTIONS(3315),
    [anon_sym_DOT_DOT] = ACTIONS(3317),
    [anon_sym_from] = ACTIONS(3315),
    [anon_sym_into] = ACTIONS(3315),
    [anon_sym_join] = ACTIONS(3315),
    [anon_sym_on] = ACTIONS(3315),
    [anon_sym_equals] = ACTIONS(3315),
    [anon_sym_let] = ACTIONS(3315),
    [anon_sym_orderby] = ACTIONS(3315),
    [anon_sym_ascending] = ACTIONS(3315),
    [anon_sym_descending] = ACTIONS(3315),
    [anon_sym_group] = ACTIONS(3315),
    [anon_sym_by] = ACTIONS(3315),
    [anon_sym_select] = ACTIONS(3315),
    [anon_sym_DQUOTE] = ACTIONS(3315),
    [anon_sym_stackalloc] = ACTIONS(3315),
    [anon_sym_sizeof] = ACTIONS(3315),
    [anon_sym_typeof] = ACTIONS(3315),
    [anon_sym___makeref] = ACTIONS(3315),
    [anon_sym___reftype] = ACTIONS(3315),
    [anon_sym___refvalue] = ACTIONS(3315),
    [sym_null_literal] = ACTIONS(3315),
    [anon_sym_SQUOTE] = ACTIONS(3317),
    [sym_integer_literal] = ACTIONS(3315),
    [sym_real_literal] = ACTIONS(3317),
    [sym_verbatim_string_literal] = ACTIONS(3317),
    [sym_raw_string_literal] = ACTIONS(3317),
    [aux_sym_preproc_if_token1] = ACTIONS(3317),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3317),
    [sym_interpolation_verbatim_start] = ACTIONS(3317),
    [sym_interpolation_raw_start] = ACTIONS(3317),
  },
  [2494] = {
    [sym_preproc_region] = STATE(2494),
    [sym_preproc_endregion] = STATE(2494),
    [sym_preproc_line] = STATE(2494),
    [sym_preproc_pragma] = STATE(2494),
    [sym_preproc_nullable] = STATE(2494),
    [sym_preproc_error] = STATE(2494),
    [sym_preproc_define] = STATE(2494),
    [sym_preproc_undef] = STATE(2494),
    [ts_builtin_sym_end] = ACTIONS(3285),
    [sym__identifier_token] = ACTIONS(3283),
    [anon_sym_extern] = ACTIONS(3283),
    [anon_sym_alias] = ACTIONS(3283),
    [anon_sym_SEMI] = ACTIONS(3285),
    [anon_sym_global] = ACTIONS(3283),
    [anon_sym_using] = ACTIONS(3283),
    [anon_sym_unsafe] = ACTIONS(3283),
    [anon_sym_static] = ACTIONS(3283),
    [anon_sym_LBRACK] = ACTIONS(3285),
    [anon_sym_LPAREN] = ACTIONS(3285),
    [anon_sym_return] = ACTIONS(3283),
    [anon_sym_namespace] = ACTIONS(3283),
    [anon_sym_class] = ACTIONS(3283),
    [anon_sym_ref] = ACTIONS(3283),
    [anon_sym_struct] = ACTIONS(3283),
    [anon_sym_enum] = ACTIONS(3283),
    [anon_sym_LBRACE] = ACTIONS(3285),
    [anon_sym_interface] = ACTIONS(3283),
    [anon_sym_delegate] = ACTIONS(3283),
    [anon_sym_record] = ACTIONS(3283),
    [anon_sym_abstract] = ACTIONS(3283),
    [anon_sym_async] = ACTIONS(3283),
    [anon_sym_const] = ACTIONS(3283),
    [anon_sym_file] = ACTIONS(3283),
    [anon_sym_fixed] = ACTIONS(3283),
    [anon_sym_internal] = ACTIONS(3283),
    [anon_sym_new] = ACTIONS(3283),
    [anon_sym_override] = ACTIONS(3283),
    [anon_sym_partial] = ACTIONS(3283),
    [anon_sym_private] = ACTIONS(3283),
    [anon_sym_protected] = ACTIONS(3283),
    [anon_sym_public] = ACTIONS(3283),
    [anon_sym_readonly] = ACTIONS(3283),
    [anon_sym_required] = ACTIONS(3283),
    [anon_sym_sealed] = ACTIONS(3283),
    [anon_sym_virtual] = ACTIONS(3283),
    [anon_sym_volatile] = ACTIONS(3283),
    [anon_sym_where] = ACTIONS(3283),
    [anon_sym_notnull] = ACTIONS(3283),
    [anon_sym_unmanaged] = ACTIONS(3283),
    [anon_sym_checked] = ACTIONS(3283),
    [anon_sym_BANG] = ACTIONS(3285),
    [anon_sym_TILDE] = ACTIONS(3285),
    [anon_sym_PLUS_PLUS] = ACTIONS(3285),
    [anon_sym_DASH_DASH] = ACTIONS(3285),
    [anon_sym_true] = ACTIONS(3283),
    [anon_sym_false] = ACTIONS(3283),
    [anon_sym_PLUS] = ACTIONS(3283),
    [anon_sym_DASH] = ACTIONS(3283),
    [anon_sym_STAR] = ACTIONS(3285),
    [anon_sym_CARET] = ACTIONS(3285),
    [anon_sym_AMP] = ACTIONS(3285),
    [anon_sym_this] = ACTIONS(3283),
    [anon_sym_scoped] = ACTIONS(3283),
    [anon_sym_var] = ACTIONS(3283),
    [sym_predefined_type] = ACTIONS(3283),
    [anon_sym_break] = ACTIONS(3283),
    [anon_sym_unchecked] = ACTIONS(3283),
    [anon_sym_continue] = ACTIONS(3283),
    [anon_sym_do] = ACTIONS(3283),
    [anon_sym_while] = ACTIONS(3283),
    [anon_sym_for] = ACTIONS(3283),
    [anon_sym_lock] = ACTIONS(3283),
    [anon_sym_yield] = ACTIONS(3283),
    [anon_sym_switch] = ACTIONS(3283),
    [anon_sym_default] = ACTIONS(3283),
    [anon_sym_throw] = ACTIONS(3283),
    [anon_sym_try] = ACTIONS(3283),
    [anon_sym_when] = ACTIONS(3283),
    [anon_sym_await] = ACTIONS(3283),
    [anon_sym_foreach] = ACTIONS(3283),
    [anon_sym_goto] = ACTIONS(3283),
    [anon_sym_if] = ACTIONS(3283),
    [anon_sym_else] = ACTIONS(3283),
    [anon_sym_DOT_DOT] = ACTIONS(3285),
    [anon_sym_from] = ACTIONS(3283),
    [anon_sym_into] = ACTIONS(3283),
    [anon_sym_join] = ACTIONS(3283),
    [anon_sym_on] = ACTIONS(3283),
    [anon_sym_equals] = ACTIONS(3283),
    [anon_sym_let] = ACTIONS(3283),
    [anon_sym_orderby] = ACTIONS(3283),
    [anon_sym_ascending] = ACTIONS(3283),
    [anon_sym_descending] = ACTIONS(3283),
    [anon_sym_group] = ACTIONS(3283),
    [anon_sym_by] = ACTIONS(3283),
    [anon_sym_select] = ACTIONS(3283),
    [anon_sym_DQUOTE] = ACTIONS(3283),
    [anon_sym_stackalloc] = ACTIONS(3283),
    [anon_sym_sizeof] = ACTIONS(3283),
    [anon_sym_typeof] = ACTIONS(3283),
    [anon_sym___makeref] = ACTIONS(3283),
    [anon_sym___reftype] = ACTIONS(3283),
    [anon_sym___refvalue] = ACTIONS(3283),
    [sym_null_literal] = ACTIONS(3283),
    [anon_sym_SQUOTE] = ACTIONS(3285),
    [sym_integer_literal] = ACTIONS(3283),
    [sym_real_literal] = ACTIONS(3285),
    [sym_verbatim_string_literal] = ACTIONS(3285),
    [sym_raw_string_literal] = ACTIONS(3285),
    [aux_sym_preproc_if_token1] = ACTIONS(3285),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3285),
    [sym_interpolation_verbatim_start] = ACTIONS(3285),
    [sym_interpolation_raw_start] = ACTIONS(3285),
  },
  [2495] = {
    [sym_preproc_region] = STATE(2495),
    [sym_preproc_endregion] = STATE(2495),
    [sym_preproc_line] = STATE(2495),
    [sym_preproc_pragma] = STATE(2495),
    [sym_preproc_nullable] = STATE(2495),
    [sym_preproc_error] = STATE(2495),
    [sym_preproc_define] = STATE(2495),
    [sym_preproc_undef] = STATE(2495),
    [ts_builtin_sym_end] = ACTIONS(3111),
    [sym__identifier_token] = ACTIONS(3109),
    [anon_sym_extern] = ACTIONS(3109),
    [anon_sym_alias] = ACTIONS(3109),
    [anon_sym_SEMI] = ACTIONS(3111),
    [anon_sym_global] = ACTIONS(3109),
    [anon_sym_using] = ACTIONS(3109),
    [anon_sym_unsafe] = ACTIONS(3109),
    [anon_sym_static] = ACTIONS(3109),
    [anon_sym_LBRACK] = ACTIONS(3111),
    [anon_sym_LPAREN] = ACTIONS(3111),
    [anon_sym_return] = ACTIONS(3109),
    [anon_sym_namespace] = ACTIONS(3109),
    [anon_sym_class] = ACTIONS(3109),
    [anon_sym_ref] = ACTIONS(3109),
    [anon_sym_struct] = ACTIONS(3109),
    [anon_sym_enum] = ACTIONS(3109),
    [anon_sym_LBRACE] = ACTIONS(3111),
    [anon_sym_interface] = ACTIONS(3109),
    [anon_sym_delegate] = ACTIONS(3109),
    [anon_sym_record] = ACTIONS(3109),
    [anon_sym_abstract] = ACTIONS(3109),
    [anon_sym_async] = ACTIONS(3109),
    [anon_sym_const] = ACTIONS(3109),
    [anon_sym_file] = ACTIONS(3109),
    [anon_sym_fixed] = ACTIONS(3109),
    [anon_sym_internal] = ACTIONS(3109),
    [anon_sym_new] = ACTIONS(3109),
    [anon_sym_override] = ACTIONS(3109),
    [anon_sym_partial] = ACTIONS(3109),
    [anon_sym_private] = ACTIONS(3109),
    [anon_sym_protected] = ACTIONS(3109),
    [anon_sym_public] = ACTIONS(3109),
    [anon_sym_readonly] = ACTIONS(3109),
    [anon_sym_required] = ACTIONS(3109),
    [anon_sym_sealed] = ACTIONS(3109),
    [anon_sym_virtual] = ACTIONS(3109),
    [anon_sym_volatile] = ACTIONS(3109),
    [anon_sym_where] = ACTIONS(3109),
    [anon_sym_notnull] = ACTIONS(3109),
    [anon_sym_unmanaged] = ACTIONS(3109),
    [anon_sym_checked] = ACTIONS(3109),
    [anon_sym_BANG] = ACTIONS(3111),
    [anon_sym_TILDE] = ACTIONS(3111),
    [anon_sym_PLUS_PLUS] = ACTIONS(3111),
    [anon_sym_DASH_DASH] = ACTIONS(3111),
    [anon_sym_true] = ACTIONS(3109),
    [anon_sym_false] = ACTIONS(3109),
    [anon_sym_PLUS] = ACTIONS(3109),
    [anon_sym_DASH] = ACTIONS(3109),
    [anon_sym_STAR] = ACTIONS(3111),
    [anon_sym_CARET] = ACTIONS(3111),
    [anon_sym_AMP] = ACTIONS(3111),
    [anon_sym_this] = ACTIONS(3109),
    [anon_sym_scoped] = ACTIONS(3109),
    [anon_sym_var] = ACTIONS(3109),
    [sym_predefined_type] = ACTIONS(3109),
    [anon_sym_break] = ACTIONS(3109),
    [anon_sym_unchecked] = ACTIONS(3109),
    [anon_sym_continue] = ACTIONS(3109),
    [anon_sym_do] = ACTIONS(3109),
    [anon_sym_while] = ACTIONS(3109),
    [anon_sym_for] = ACTIONS(3109),
    [anon_sym_lock] = ACTIONS(3109),
    [anon_sym_yield] = ACTIONS(3109),
    [anon_sym_switch] = ACTIONS(3109),
    [anon_sym_default] = ACTIONS(3109),
    [anon_sym_throw] = ACTIONS(3109),
    [anon_sym_try] = ACTIONS(3109),
    [anon_sym_when] = ACTIONS(3109),
    [anon_sym_await] = ACTIONS(3109),
    [anon_sym_foreach] = ACTIONS(3109),
    [anon_sym_goto] = ACTIONS(3109),
    [anon_sym_if] = ACTIONS(3109),
    [anon_sym_else] = ACTIONS(3109),
    [anon_sym_DOT_DOT] = ACTIONS(3111),
    [anon_sym_from] = ACTIONS(3109),
    [anon_sym_into] = ACTIONS(3109),
    [anon_sym_join] = ACTIONS(3109),
    [anon_sym_on] = ACTIONS(3109),
    [anon_sym_equals] = ACTIONS(3109),
    [anon_sym_let] = ACTIONS(3109),
    [anon_sym_orderby] = ACTIONS(3109),
    [anon_sym_ascending] = ACTIONS(3109),
    [anon_sym_descending] = ACTIONS(3109),
    [anon_sym_group] = ACTIONS(3109),
    [anon_sym_by] = ACTIONS(3109),
    [anon_sym_select] = ACTIONS(3109),
    [anon_sym_DQUOTE] = ACTIONS(3109),
    [anon_sym_stackalloc] = ACTIONS(3109),
    [anon_sym_sizeof] = ACTIONS(3109),
    [anon_sym_typeof] = ACTIONS(3109),
    [anon_sym___makeref] = ACTIONS(3109),
    [anon_sym___reftype] = ACTIONS(3109),
    [anon_sym___refvalue] = ACTIONS(3109),
    [sym_null_literal] = ACTIONS(3109),
    [anon_sym_SQUOTE] = ACTIONS(3111),
    [sym_integer_literal] = ACTIONS(3109),
    [sym_real_literal] = ACTIONS(3111),
    [sym_verbatim_string_literal] = ACTIONS(3111),
    [sym_raw_string_literal] = ACTIONS(3111),
    [aux_sym_preproc_if_token1] = ACTIONS(3111),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3111),
    [sym_interpolation_verbatim_start] = ACTIONS(3111),
    [sym_interpolation_raw_start] = ACTIONS(3111),
  },
  [2496] = {
    [sym_preproc_region] = STATE(2496),
    [sym_preproc_endregion] = STATE(2496),
    [sym_preproc_line] = STATE(2496),
    [sym_preproc_pragma] = STATE(2496),
    [sym_preproc_nullable] = STATE(2496),
    [sym_preproc_error] = STATE(2496),
    [sym_preproc_define] = STATE(2496),
    [sym_preproc_undef] = STATE(2496),
    [ts_builtin_sym_end] = ACTIONS(3189),
    [sym__identifier_token] = ACTIONS(3187),
    [anon_sym_extern] = ACTIONS(3187),
    [anon_sym_alias] = ACTIONS(3187),
    [anon_sym_SEMI] = ACTIONS(3189),
    [anon_sym_global] = ACTIONS(3187),
    [anon_sym_using] = ACTIONS(3187),
    [anon_sym_unsafe] = ACTIONS(3187),
    [anon_sym_static] = ACTIONS(3187),
    [anon_sym_LBRACK] = ACTIONS(3189),
    [anon_sym_LPAREN] = ACTIONS(3189),
    [anon_sym_return] = ACTIONS(3187),
    [anon_sym_namespace] = ACTIONS(3187),
    [anon_sym_class] = ACTIONS(3187),
    [anon_sym_ref] = ACTIONS(3187),
    [anon_sym_struct] = ACTIONS(3187),
    [anon_sym_enum] = ACTIONS(3187),
    [anon_sym_LBRACE] = ACTIONS(3189),
    [anon_sym_interface] = ACTIONS(3187),
    [anon_sym_delegate] = ACTIONS(3187),
    [anon_sym_record] = ACTIONS(3187),
    [anon_sym_abstract] = ACTIONS(3187),
    [anon_sym_async] = ACTIONS(3187),
    [anon_sym_const] = ACTIONS(3187),
    [anon_sym_file] = ACTIONS(3187),
    [anon_sym_fixed] = ACTIONS(3187),
    [anon_sym_internal] = ACTIONS(3187),
    [anon_sym_new] = ACTIONS(3187),
    [anon_sym_override] = ACTIONS(3187),
    [anon_sym_partial] = ACTIONS(3187),
    [anon_sym_private] = ACTIONS(3187),
    [anon_sym_protected] = ACTIONS(3187),
    [anon_sym_public] = ACTIONS(3187),
    [anon_sym_readonly] = ACTIONS(3187),
    [anon_sym_required] = ACTIONS(3187),
    [anon_sym_sealed] = ACTIONS(3187),
    [anon_sym_virtual] = ACTIONS(3187),
    [anon_sym_volatile] = ACTIONS(3187),
    [anon_sym_where] = ACTIONS(3187),
    [anon_sym_notnull] = ACTIONS(3187),
    [anon_sym_unmanaged] = ACTIONS(3187),
    [anon_sym_checked] = ACTIONS(3187),
    [anon_sym_BANG] = ACTIONS(3189),
    [anon_sym_TILDE] = ACTIONS(3189),
    [anon_sym_PLUS_PLUS] = ACTIONS(3189),
    [anon_sym_DASH_DASH] = ACTIONS(3189),
    [anon_sym_true] = ACTIONS(3187),
    [anon_sym_false] = ACTIONS(3187),
    [anon_sym_PLUS] = ACTIONS(3187),
    [anon_sym_DASH] = ACTIONS(3187),
    [anon_sym_STAR] = ACTIONS(3189),
    [anon_sym_CARET] = ACTIONS(3189),
    [anon_sym_AMP] = ACTIONS(3189),
    [anon_sym_this] = ACTIONS(3187),
    [anon_sym_scoped] = ACTIONS(3187),
    [anon_sym_var] = ACTIONS(3187),
    [sym_predefined_type] = ACTIONS(3187),
    [anon_sym_break] = ACTIONS(3187),
    [anon_sym_unchecked] = ACTIONS(3187),
    [anon_sym_continue] = ACTIONS(3187),
    [anon_sym_do] = ACTIONS(3187),
    [anon_sym_while] = ACTIONS(3187),
    [anon_sym_for] = ACTIONS(3187),
    [anon_sym_lock] = ACTIONS(3187),
    [anon_sym_yield] = ACTIONS(3187),
    [anon_sym_switch] = ACTIONS(3187),
    [anon_sym_default] = ACTIONS(3187),
    [anon_sym_throw] = ACTIONS(3187),
    [anon_sym_try] = ACTIONS(3187),
    [anon_sym_when] = ACTIONS(3187),
    [anon_sym_await] = ACTIONS(3187),
    [anon_sym_foreach] = ACTIONS(3187),
    [anon_sym_goto] = ACTIONS(3187),
    [anon_sym_if] = ACTIONS(3187),
    [anon_sym_else] = ACTIONS(3187),
    [anon_sym_DOT_DOT] = ACTIONS(3189),
    [anon_sym_from] = ACTIONS(3187),
    [anon_sym_into] = ACTIONS(3187),
    [anon_sym_join] = ACTIONS(3187),
    [anon_sym_on] = ACTIONS(3187),
    [anon_sym_equals] = ACTIONS(3187),
    [anon_sym_let] = ACTIONS(3187),
    [anon_sym_orderby] = ACTIONS(3187),
    [anon_sym_ascending] = ACTIONS(3187),
    [anon_sym_descending] = ACTIONS(3187),
    [anon_sym_group] = ACTIONS(3187),
    [anon_sym_by] = ACTIONS(3187),
    [anon_sym_select] = ACTIONS(3187),
    [anon_sym_DQUOTE] = ACTIONS(3187),
    [anon_sym_stackalloc] = ACTIONS(3187),
    [anon_sym_sizeof] = ACTIONS(3187),
    [anon_sym_typeof] = ACTIONS(3187),
    [anon_sym___makeref] = ACTIONS(3187),
    [anon_sym___reftype] = ACTIONS(3187),
    [anon_sym___refvalue] = ACTIONS(3187),
    [sym_null_literal] = ACTIONS(3187),
    [anon_sym_SQUOTE] = ACTIONS(3189),
    [sym_integer_literal] = ACTIONS(3187),
    [sym_real_literal] = ACTIONS(3189),
    [sym_verbatim_string_literal] = ACTIONS(3189),
    [sym_raw_string_literal] = ACTIONS(3189),
    [aux_sym_preproc_if_token1] = ACTIONS(3189),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3189),
    [sym_interpolation_verbatim_start] = ACTIONS(3189),
    [sym_interpolation_raw_start] = ACTIONS(3189),
  },
  [2497] = {
    [sym_preproc_region] = STATE(2497),
    [sym_preproc_endregion] = STATE(2497),
    [sym_preproc_line] = STATE(2497),
    [sym_preproc_pragma] = STATE(2497),
    [sym_preproc_nullable] = STATE(2497),
    [sym_preproc_error] = STATE(2497),
    [sym_preproc_define] = STATE(2497),
    [sym_preproc_undef] = STATE(2497),
    [ts_builtin_sym_end] = ACTIONS(3201),
    [sym__identifier_token] = ACTIONS(3199),
    [anon_sym_extern] = ACTIONS(3199),
    [anon_sym_alias] = ACTIONS(3199),
    [anon_sym_SEMI] = ACTIONS(3201),
    [anon_sym_global] = ACTIONS(3199),
    [anon_sym_using] = ACTIONS(3199),
    [anon_sym_unsafe] = ACTIONS(3199),
    [anon_sym_static] = ACTIONS(3199),
    [anon_sym_LBRACK] = ACTIONS(3201),
    [anon_sym_LPAREN] = ACTIONS(3201),
    [anon_sym_return] = ACTIONS(3199),
    [anon_sym_namespace] = ACTIONS(3199),
    [anon_sym_class] = ACTIONS(3199),
    [anon_sym_ref] = ACTIONS(3199),
    [anon_sym_struct] = ACTIONS(3199),
    [anon_sym_enum] = ACTIONS(3199),
    [anon_sym_LBRACE] = ACTIONS(3201),
    [anon_sym_interface] = ACTIONS(3199),
    [anon_sym_delegate] = ACTIONS(3199),
    [anon_sym_record] = ACTIONS(3199),
    [anon_sym_abstract] = ACTIONS(3199),
    [anon_sym_async] = ACTIONS(3199),
    [anon_sym_const] = ACTIONS(3199),
    [anon_sym_file] = ACTIONS(3199),
    [anon_sym_fixed] = ACTIONS(3199),
    [anon_sym_internal] = ACTIONS(3199),
    [anon_sym_new] = ACTIONS(3199),
    [anon_sym_override] = ACTIONS(3199),
    [anon_sym_partial] = ACTIONS(3199),
    [anon_sym_private] = ACTIONS(3199),
    [anon_sym_protected] = ACTIONS(3199),
    [anon_sym_public] = ACTIONS(3199),
    [anon_sym_readonly] = ACTIONS(3199),
    [anon_sym_required] = ACTIONS(3199),
    [anon_sym_sealed] = ACTIONS(3199),
    [anon_sym_virtual] = ACTIONS(3199),
    [anon_sym_volatile] = ACTIONS(3199),
    [anon_sym_where] = ACTIONS(3199),
    [anon_sym_notnull] = ACTIONS(3199),
    [anon_sym_unmanaged] = ACTIONS(3199),
    [anon_sym_checked] = ACTIONS(3199),
    [anon_sym_BANG] = ACTIONS(3201),
    [anon_sym_TILDE] = ACTIONS(3201),
    [anon_sym_PLUS_PLUS] = ACTIONS(3201),
    [anon_sym_DASH_DASH] = ACTIONS(3201),
    [anon_sym_true] = ACTIONS(3199),
    [anon_sym_false] = ACTIONS(3199),
    [anon_sym_PLUS] = ACTIONS(3199),
    [anon_sym_DASH] = ACTIONS(3199),
    [anon_sym_STAR] = ACTIONS(3201),
    [anon_sym_CARET] = ACTIONS(3201),
    [anon_sym_AMP] = ACTIONS(3201),
    [anon_sym_this] = ACTIONS(3199),
    [anon_sym_scoped] = ACTIONS(3199),
    [anon_sym_var] = ACTIONS(3199),
    [sym_predefined_type] = ACTIONS(3199),
    [anon_sym_break] = ACTIONS(3199),
    [anon_sym_unchecked] = ACTIONS(3199),
    [anon_sym_continue] = ACTIONS(3199),
    [anon_sym_do] = ACTIONS(3199),
    [anon_sym_while] = ACTIONS(3199),
    [anon_sym_for] = ACTIONS(3199),
    [anon_sym_lock] = ACTIONS(3199),
    [anon_sym_yield] = ACTIONS(3199),
    [anon_sym_switch] = ACTIONS(3199),
    [anon_sym_default] = ACTIONS(3199),
    [anon_sym_throw] = ACTIONS(3199),
    [anon_sym_try] = ACTIONS(3199),
    [anon_sym_when] = ACTIONS(3199),
    [anon_sym_await] = ACTIONS(3199),
    [anon_sym_foreach] = ACTIONS(3199),
    [anon_sym_goto] = ACTIONS(3199),
    [anon_sym_if] = ACTIONS(3199),
    [anon_sym_else] = ACTIONS(3199),
    [anon_sym_DOT_DOT] = ACTIONS(3201),
    [anon_sym_from] = ACTIONS(3199),
    [anon_sym_into] = ACTIONS(3199),
    [anon_sym_join] = ACTIONS(3199),
    [anon_sym_on] = ACTIONS(3199),
    [anon_sym_equals] = ACTIONS(3199),
    [anon_sym_let] = ACTIONS(3199),
    [anon_sym_orderby] = ACTIONS(3199),
    [anon_sym_ascending] = ACTIONS(3199),
    [anon_sym_descending] = ACTIONS(3199),
    [anon_sym_group] = ACTIONS(3199),
    [anon_sym_by] = ACTIONS(3199),
    [anon_sym_select] = ACTIONS(3199),
    [anon_sym_DQUOTE] = ACTIONS(3199),
    [anon_sym_stackalloc] = ACTIONS(3199),
    [anon_sym_sizeof] = ACTIONS(3199),
    [anon_sym_typeof] = ACTIONS(3199),
    [anon_sym___makeref] = ACTIONS(3199),
    [anon_sym___reftype] = ACTIONS(3199),
    [anon_sym___refvalue] = ACTIONS(3199),
    [sym_null_literal] = ACTIONS(3199),
    [anon_sym_SQUOTE] = ACTIONS(3201),
    [sym_integer_literal] = ACTIONS(3199),
    [sym_real_literal] = ACTIONS(3201),
    [sym_verbatim_string_literal] = ACTIONS(3201),
    [sym_raw_string_literal] = ACTIONS(3201),
    [aux_sym_preproc_if_token1] = ACTIONS(3201),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3201),
    [sym_interpolation_verbatim_start] = ACTIONS(3201),
    [sym_interpolation_raw_start] = ACTIONS(3201),
  },
  [2498] = {
    [sym_preproc_region] = STATE(2498),
    [sym_preproc_endregion] = STATE(2498),
    [sym_preproc_line] = STATE(2498),
    [sym_preproc_pragma] = STATE(2498),
    [sym_preproc_nullable] = STATE(2498),
    [sym_preproc_error] = STATE(2498),
    [sym_preproc_define] = STATE(2498),
    [sym_preproc_undef] = STATE(2498),
    [ts_builtin_sym_end] = ACTIONS(3237),
    [sym__identifier_token] = ACTIONS(3235),
    [anon_sym_extern] = ACTIONS(3235),
    [anon_sym_alias] = ACTIONS(3235),
    [anon_sym_SEMI] = ACTIONS(3237),
    [anon_sym_global] = ACTIONS(3235),
    [anon_sym_using] = ACTIONS(3235),
    [anon_sym_unsafe] = ACTIONS(3235),
    [anon_sym_static] = ACTIONS(3235),
    [anon_sym_LBRACK] = ACTIONS(3237),
    [anon_sym_LPAREN] = ACTIONS(3237),
    [anon_sym_return] = ACTIONS(3235),
    [anon_sym_namespace] = ACTIONS(3235),
    [anon_sym_class] = ACTIONS(3235),
    [anon_sym_ref] = ACTIONS(3235),
    [anon_sym_struct] = ACTIONS(3235),
    [anon_sym_enum] = ACTIONS(3235),
    [anon_sym_LBRACE] = ACTIONS(3237),
    [anon_sym_interface] = ACTIONS(3235),
    [anon_sym_delegate] = ACTIONS(3235),
    [anon_sym_record] = ACTIONS(3235),
    [anon_sym_abstract] = ACTIONS(3235),
    [anon_sym_async] = ACTIONS(3235),
    [anon_sym_const] = ACTIONS(3235),
    [anon_sym_file] = ACTIONS(3235),
    [anon_sym_fixed] = ACTIONS(3235),
    [anon_sym_internal] = ACTIONS(3235),
    [anon_sym_new] = ACTIONS(3235),
    [anon_sym_override] = ACTIONS(3235),
    [anon_sym_partial] = ACTIONS(3235),
    [anon_sym_private] = ACTIONS(3235),
    [anon_sym_protected] = ACTIONS(3235),
    [anon_sym_public] = ACTIONS(3235),
    [anon_sym_readonly] = ACTIONS(3235),
    [anon_sym_required] = ACTIONS(3235),
    [anon_sym_sealed] = ACTIONS(3235),
    [anon_sym_virtual] = ACTIONS(3235),
    [anon_sym_volatile] = ACTIONS(3235),
    [anon_sym_where] = ACTIONS(3235),
    [anon_sym_notnull] = ACTIONS(3235),
    [anon_sym_unmanaged] = ACTIONS(3235),
    [anon_sym_checked] = ACTIONS(3235),
    [anon_sym_BANG] = ACTIONS(3237),
    [anon_sym_TILDE] = ACTIONS(3237),
    [anon_sym_PLUS_PLUS] = ACTIONS(3237),
    [anon_sym_DASH_DASH] = ACTIONS(3237),
    [anon_sym_true] = ACTIONS(3235),
    [anon_sym_false] = ACTIONS(3235),
    [anon_sym_PLUS] = ACTIONS(3235),
    [anon_sym_DASH] = ACTIONS(3235),
    [anon_sym_STAR] = ACTIONS(3237),
    [anon_sym_CARET] = ACTIONS(3237),
    [anon_sym_AMP] = ACTIONS(3237),
    [anon_sym_this] = ACTIONS(3235),
    [anon_sym_scoped] = ACTIONS(3235),
    [anon_sym_var] = ACTIONS(3235),
    [sym_predefined_type] = ACTIONS(3235),
    [anon_sym_break] = ACTIONS(3235),
    [anon_sym_unchecked] = ACTIONS(3235),
    [anon_sym_continue] = ACTIONS(3235),
    [anon_sym_do] = ACTIONS(3235),
    [anon_sym_while] = ACTIONS(3235),
    [anon_sym_for] = ACTIONS(3235),
    [anon_sym_lock] = ACTIONS(3235),
    [anon_sym_yield] = ACTIONS(3235),
    [anon_sym_switch] = ACTIONS(3235),
    [anon_sym_default] = ACTIONS(3235),
    [anon_sym_throw] = ACTIONS(3235),
    [anon_sym_try] = ACTIONS(3235),
    [anon_sym_when] = ACTIONS(3235),
    [anon_sym_await] = ACTIONS(3235),
    [anon_sym_foreach] = ACTIONS(3235),
    [anon_sym_goto] = ACTIONS(3235),
    [anon_sym_if] = ACTIONS(3235),
    [anon_sym_else] = ACTIONS(3235),
    [anon_sym_DOT_DOT] = ACTIONS(3237),
    [anon_sym_from] = ACTIONS(3235),
    [anon_sym_into] = ACTIONS(3235),
    [anon_sym_join] = ACTIONS(3235),
    [anon_sym_on] = ACTIONS(3235),
    [anon_sym_equals] = ACTIONS(3235),
    [anon_sym_let] = ACTIONS(3235),
    [anon_sym_orderby] = ACTIONS(3235),
    [anon_sym_ascending] = ACTIONS(3235),
    [anon_sym_descending] = ACTIONS(3235),
    [anon_sym_group] = ACTIONS(3235),
    [anon_sym_by] = ACTIONS(3235),
    [anon_sym_select] = ACTIONS(3235),
    [anon_sym_DQUOTE] = ACTIONS(3235),
    [anon_sym_stackalloc] = ACTIONS(3235),
    [anon_sym_sizeof] = ACTIONS(3235),
    [anon_sym_typeof] = ACTIONS(3235),
    [anon_sym___makeref] = ACTIONS(3235),
    [anon_sym___reftype] = ACTIONS(3235),
    [anon_sym___refvalue] = ACTIONS(3235),
    [sym_null_literal] = ACTIONS(3235),
    [anon_sym_SQUOTE] = ACTIONS(3237),
    [sym_integer_literal] = ACTIONS(3235),
    [sym_real_literal] = ACTIONS(3237),
    [sym_verbatim_string_literal] = ACTIONS(3237),
    [sym_raw_string_literal] = ACTIONS(3237),
    [aux_sym_preproc_if_token1] = ACTIONS(3237),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3237),
    [sym_interpolation_verbatim_start] = ACTIONS(3237),
    [sym_interpolation_raw_start] = ACTIONS(3237),
  },
  [2499] = {
    [sym_preproc_region] = STATE(2499),
    [sym_preproc_endregion] = STATE(2499),
    [sym_preproc_line] = STATE(2499),
    [sym_preproc_pragma] = STATE(2499),
    [sym_preproc_nullable] = STATE(2499),
    [sym_preproc_error] = STATE(2499),
    [sym_preproc_define] = STATE(2499),
    [sym_preproc_undef] = STATE(2499),
    [ts_builtin_sym_end] = ACTIONS(3365),
    [sym__identifier_token] = ACTIONS(3363),
    [anon_sym_extern] = ACTIONS(3363),
    [anon_sym_alias] = ACTIONS(3363),
    [anon_sym_SEMI] = ACTIONS(3365),
    [anon_sym_global] = ACTIONS(3363),
    [anon_sym_using] = ACTIONS(3363),
    [anon_sym_unsafe] = ACTIONS(3363),
    [anon_sym_static] = ACTIONS(3363),
    [anon_sym_LBRACK] = ACTIONS(3365),
    [anon_sym_LPAREN] = ACTIONS(3365),
    [anon_sym_return] = ACTIONS(3363),
    [anon_sym_namespace] = ACTIONS(3363),
    [anon_sym_class] = ACTIONS(3363),
    [anon_sym_ref] = ACTIONS(3363),
    [anon_sym_struct] = ACTIONS(3363),
    [anon_sym_enum] = ACTIONS(3363),
    [anon_sym_LBRACE] = ACTIONS(3365),
    [anon_sym_interface] = ACTIONS(3363),
    [anon_sym_delegate] = ACTIONS(3363),
    [anon_sym_record] = ACTIONS(3363),
    [anon_sym_abstract] = ACTIONS(3363),
    [anon_sym_async] = ACTIONS(3363),
    [anon_sym_const] = ACTIONS(3363),
    [anon_sym_file] = ACTIONS(3363),
    [anon_sym_fixed] = ACTIONS(3363),
    [anon_sym_internal] = ACTIONS(3363),
    [anon_sym_new] = ACTIONS(3363),
    [anon_sym_override] = ACTIONS(3363),
    [anon_sym_partial] = ACTIONS(3363),
    [anon_sym_private] = ACTIONS(3363),
    [anon_sym_protected] = ACTIONS(3363),
    [anon_sym_public] = ACTIONS(3363),
    [anon_sym_readonly] = ACTIONS(3363),
    [anon_sym_required] = ACTIONS(3363),
    [anon_sym_sealed] = ACTIONS(3363),
    [anon_sym_virtual] = ACTIONS(3363),
    [anon_sym_volatile] = ACTIONS(3363),
    [anon_sym_where] = ACTIONS(3363),
    [anon_sym_notnull] = ACTIONS(3363),
    [anon_sym_unmanaged] = ACTIONS(3363),
    [anon_sym_checked] = ACTIONS(3363),
    [anon_sym_BANG] = ACTIONS(3365),
    [anon_sym_TILDE] = ACTIONS(3365),
    [anon_sym_PLUS_PLUS] = ACTIONS(3365),
    [anon_sym_DASH_DASH] = ACTIONS(3365),
    [anon_sym_true] = ACTIONS(3363),
    [anon_sym_false] = ACTIONS(3363),
    [anon_sym_PLUS] = ACTIONS(3363),
    [anon_sym_DASH] = ACTIONS(3363),
    [anon_sym_STAR] = ACTIONS(3365),
    [anon_sym_CARET] = ACTIONS(3365),
    [anon_sym_AMP] = ACTIONS(3365),
    [anon_sym_this] = ACTIONS(3363),
    [anon_sym_scoped] = ACTIONS(3363),
    [anon_sym_var] = ACTIONS(3363),
    [sym_predefined_type] = ACTIONS(3363),
    [anon_sym_break] = ACTIONS(3363),
    [anon_sym_unchecked] = ACTIONS(3363),
    [anon_sym_continue] = ACTIONS(3363),
    [anon_sym_do] = ACTIONS(3363),
    [anon_sym_while] = ACTIONS(3363),
    [anon_sym_for] = ACTIONS(3363),
    [anon_sym_lock] = ACTIONS(3363),
    [anon_sym_yield] = ACTIONS(3363),
    [anon_sym_switch] = ACTIONS(3363),
    [anon_sym_default] = ACTIONS(3363),
    [anon_sym_throw] = ACTIONS(3363),
    [anon_sym_try] = ACTIONS(3363),
    [anon_sym_when] = ACTIONS(3363),
    [anon_sym_await] = ACTIONS(3363),
    [anon_sym_foreach] = ACTIONS(3363),
    [anon_sym_goto] = ACTIONS(3363),
    [anon_sym_if] = ACTIONS(3363),
    [anon_sym_else] = ACTIONS(3363),
    [anon_sym_DOT_DOT] = ACTIONS(3365),
    [anon_sym_from] = ACTIONS(3363),
    [anon_sym_into] = ACTIONS(3363),
    [anon_sym_join] = ACTIONS(3363),
    [anon_sym_on] = ACTIONS(3363),
    [anon_sym_equals] = ACTIONS(3363),
    [anon_sym_let] = ACTIONS(3363),
    [anon_sym_orderby] = ACTIONS(3363),
    [anon_sym_ascending] = ACTIONS(3363),
    [anon_sym_descending] = ACTIONS(3363),
    [anon_sym_group] = ACTIONS(3363),
    [anon_sym_by] = ACTIONS(3363),
    [anon_sym_select] = ACTIONS(3363),
    [anon_sym_DQUOTE] = ACTIONS(3363),
    [anon_sym_stackalloc] = ACTIONS(3363),
    [anon_sym_sizeof] = ACTIONS(3363),
    [anon_sym_typeof] = ACTIONS(3363),
    [anon_sym___makeref] = ACTIONS(3363),
    [anon_sym___reftype] = ACTIONS(3363),
    [anon_sym___refvalue] = ACTIONS(3363),
    [sym_null_literal] = ACTIONS(3363),
    [anon_sym_SQUOTE] = ACTIONS(3365),
    [sym_integer_literal] = ACTIONS(3363),
    [sym_real_literal] = ACTIONS(3365),
    [sym_verbatim_string_literal] = ACTIONS(3365),
    [sym_raw_string_literal] = ACTIONS(3365),
    [aux_sym_preproc_if_token1] = ACTIONS(3365),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3365),
    [sym_interpolation_verbatim_start] = ACTIONS(3365),
    [sym_interpolation_raw_start] = ACTIONS(3365),
  },
  [2500] = {
    [sym_preproc_region] = STATE(2500),
    [sym_preproc_endregion] = STATE(2500),
    [sym_preproc_line] = STATE(2500),
    [sym_preproc_pragma] = STATE(2500),
    [sym_preproc_nullable] = STATE(2500),
    [sym_preproc_error] = STATE(2500),
    [sym_preproc_define] = STATE(2500),
    [sym_preproc_undef] = STATE(2500),
    [ts_builtin_sym_end] = ACTIONS(3197),
    [sym__identifier_token] = ACTIONS(3195),
    [anon_sym_extern] = ACTIONS(3195),
    [anon_sym_alias] = ACTIONS(3195),
    [anon_sym_SEMI] = ACTIONS(3197),
    [anon_sym_global] = ACTIONS(3195),
    [anon_sym_using] = ACTIONS(3195),
    [anon_sym_unsafe] = ACTIONS(3195),
    [anon_sym_static] = ACTIONS(3195),
    [anon_sym_LBRACK] = ACTIONS(3197),
    [anon_sym_LPAREN] = ACTIONS(3197),
    [anon_sym_return] = ACTIONS(3195),
    [anon_sym_namespace] = ACTIONS(3195),
    [anon_sym_class] = ACTIONS(3195),
    [anon_sym_ref] = ACTIONS(3195),
    [anon_sym_struct] = ACTIONS(3195),
    [anon_sym_enum] = ACTIONS(3195),
    [anon_sym_LBRACE] = ACTIONS(3197),
    [anon_sym_interface] = ACTIONS(3195),
    [anon_sym_delegate] = ACTIONS(3195),
    [anon_sym_record] = ACTIONS(3195),
    [anon_sym_abstract] = ACTIONS(3195),
    [anon_sym_async] = ACTIONS(3195),
    [anon_sym_const] = ACTIONS(3195),
    [anon_sym_file] = ACTIONS(3195),
    [anon_sym_fixed] = ACTIONS(3195),
    [anon_sym_internal] = ACTIONS(3195),
    [anon_sym_new] = ACTIONS(3195),
    [anon_sym_override] = ACTIONS(3195),
    [anon_sym_partial] = ACTIONS(3195),
    [anon_sym_private] = ACTIONS(3195),
    [anon_sym_protected] = ACTIONS(3195),
    [anon_sym_public] = ACTIONS(3195),
    [anon_sym_readonly] = ACTIONS(3195),
    [anon_sym_required] = ACTIONS(3195),
    [anon_sym_sealed] = ACTIONS(3195),
    [anon_sym_virtual] = ACTIONS(3195),
    [anon_sym_volatile] = ACTIONS(3195),
    [anon_sym_where] = ACTIONS(3195),
    [anon_sym_notnull] = ACTIONS(3195),
    [anon_sym_unmanaged] = ACTIONS(3195),
    [anon_sym_checked] = ACTIONS(3195),
    [anon_sym_BANG] = ACTIONS(3197),
    [anon_sym_TILDE] = ACTIONS(3197),
    [anon_sym_PLUS_PLUS] = ACTIONS(3197),
    [anon_sym_DASH_DASH] = ACTIONS(3197),
    [anon_sym_true] = ACTIONS(3195),
    [anon_sym_false] = ACTIONS(3195),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_STAR] = ACTIONS(3197),
    [anon_sym_CARET] = ACTIONS(3197),
    [anon_sym_AMP] = ACTIONS(3197),
    [anon_sym_this] = ACTIONS(3195),
    [anon_sym_scoped] = ACTIONS(3195),
    [anon_sym_var] = ACTIONS(3195),
    [sym_predefined_type] = ACTIONS(3195),
    [anon_sym_break] = ACTIONS(3195),
    [anon_sym_unchecked] = ACTIONS(3195),
    [anon_sym_continue] = ACTIONS(3195),
    [anon_sym_do] = ACTIONS(3195),
    [anon_sym_while] = ACTIONS(3195),
    [anon_sym_for] = ACTIONS(3195),
    [anon_sym_lock] = ACTIONS(3195),
    [anon_sym_yield] = ACTIONS(3195),
    [anon_sym_switch] = ACTIONS(3195),
    [anon_sym_default] = ACTIONS(3195),
    [anon_sym_throw] = ACTIONS(3195),
    [anon_sym_try] = ACTIONS(3195),
    [anon_sym_when] = ACTIONS(3195),
    [anon_sym_await] = ACTIONS(3195),
    [anon_sym_foreach] = ACTIONS(3195),
    [anon_sym_goto] = ACTIONS(3195),
    [anon_sym_if] = ACTIONS(3195),
    [anon_sym_else] = ACTIONS(3195),
    [anon_sym_DOT_DOT] = ACTIONS(3197),
    [anon_sym_from] = ACTIONS(3195),
    [anon_sym_into] = ACTIONS(3195),
    [anon_sym_join] = ACTIONS(3195),
    [anon_sym_on] = ACTIONS(3195),
    [anon_sym_equals] = ACTIONS(3195),
    [anon_sym_let] = ACTIONS(3195),
    [anon_sym_orderby] = ACTIONS(3195),
    [anon_sym_ascending] = ACTIONS(3195),
    [anon_sym_descending] = ACTIONS(3195),
    [anon_sym_group] = ACTIONS(3195),
    [anon_sym_by] = ACTIONS(3195),
    [anon_sym_select] = ACTIONS(3195),
    [anon_sym_DQUOTE] = ACTIONS(3195),
    [anon_sym_stackalloc] = ACTIONS(3195),
    [anon_sym_sizeof] = ACTIONS(3195),
    [anon_sym_typeof] = ACTIONS(3195),
    [anon_sym___makeref] = ACTIONS(3195),
    [anon_sym___reftype] = ACTIONS(3195),
    [anon_sym___refvalue] = ACTIONS(3195),
    [sym_null_literal] = ACTIONS(3195),
    [anon_sym_SQUOTE] = ACTIONS(3197),
    [sym_integer_literal] = ACTIONS(3195),
    [sym_real_literal] = ACTIONS(3197),
    [sym_verbatim_string_literal] = ACTIONS(3197),
    [sym_raw_string_literal] = ACTIONS(3197),
    [aux_sym_preproc_if_token1] = ACTIONS(3197),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3197),
    [sym_interpolation_verbatim_start] = ACTIONS(3197),
    [sym_interpolation_raw_start] = ACTIONS(3197),
  },
  [2501] = {
    [sym_preproc_region] = STATE(2501),
    [sym_preproc_endregion] = STATE(2501),
    [sym_preproc_line] = STATE(2501),
    [sym_preproc_pragma] = STATE(2501),
    [sym_preproc_nullable] = STATE(2501),
    [sym_preproc_error] = STATE(2501),
    [sym_preproc_define] = STATE(2501),
    [sym_preproc_undef] = STATE(2501),
    [ts_builtin_sym_end] = ACTIONS(3341),
    [sym__identifier_token] = ACTIONS(3339),
    [anon_sym_extern] = ACTIONS(3339),
    [anon_sym_alias] = ACTIONS(3339),
    [anon_sym_SEMI] = ACTIONS(3341),
    [anon_sym_global] = ACTIONS(3339),
    [anon_sym_using] = ACTIONS(3339),
    [anon_sym_unsafe] = ACTIONS(3339),
    [anon_sym_static] = ACTIONS(3339),
    [anon_sym_LBRACK] = ACTIONS(3341),
    [anon_sym_LPAREN] = ACTIONS(3341),
    [anon_sym_return] = ACTIONS(3339),
    [anon_sym_namespace] = ACTIONS(3339),
    [anon_sym_class] = ACTIONS(3339),
    [anon_sym_ref] = ACTIONS(3339),
    [anon_sym_struct] = ACTIONS(3339),
    [anon_sym_enum] = ACTIONS(3339),
    [anon_sym_LBRACE] = ACTIONS(3341),
    [anon_sym_interface] = ACTIONS(3339),
    [anon_sym_delegate] = ACTIONS(3339),
    [anon_sym_record] = ACTIONS(3339),
    [anon_sym_abstract] = ACTIONS(3339),
    [anon_sym_async] = ACTIONS(3339),
    [anon_sym_const] = ACTIONS(3339),
    [anon_sym_file] = ACTIONS(3339),
    [anon_sym_fixed] = ACTIONS(3339),
    [anon_sym_internal] = ACTIONS(3339),
    [anon_sym_new] = ACTIONS(3339),
    [anon_sym_override] = ACTIONS(3339),
    [anon_sym_partial] = ACTIONS(3339),
    [anon_sym_private] = ACTIONS(3339),
    [anon_sym_protected] = ACTIONS(3339),
    [anon_sym_public] = ACTIONS(3339),
    [anon_sym_readonly] = ACTIONS(3339),
    [anon_sym_required] = ACTIONS(3339),
    [anon_sym_sealed] = ACTIONS(3339),
    [anon_sym_virtual] = ACTIONS(3339),
    [anon_sym_volatile] = ACTIONS(3339),
    [anon_sym_where] = ACTIONS(3339),
    [anon_sym_notnull] = ACTIONS(3339),
    [anon_sym_unmanaged] = ACTIONS(3339),
    [anon_sym_checked] = ACTIONS(3339),
    [anon_sym_BANG] = ACTIONS(3341),
    [anon_sym_TILDE] = ACTIONS(3341),
    [anon_sym_PLUS_PLUS] = ACTIONS(3341),
    [anon_sym_DASH_DASH] = ACTIONS(3341),
    [anon_sym_true] = ACTIONS(3339),
    [anon_sym_false] = ACTIONS(3339),
    [anon_sym_PLUS] = ACTIONS(3339),
    [anon_sym_DASH] = ACTIONS(3339),
    [anon_sym_STAR] = ACTIONS(3341),
    [anon_sym_CARET] = ACTIONS(3341),
    [anon_sym_AMP] = ACTIONS(3341),
    [anon_sym_this] = ACTIONS(3339),
    [anon_sym_scoped] = ACTIONS(3339),
    [anon_sym_var] = ACTIONS(3339),
    [sym_predefined_type] = ACTIONS(3339),
    [anon_sym_break] = ACTIONS(3339),
    [anon_sym_unchecked] = ACTIONS(3339),
    [anon_sym_continue] = ACTIONS(3339),
    [anon_sym_do] = ACTIONS(3339),
    [anon_sym_while] = ACTIONS(3339),
    [anon_sym_for] = ACTIONS(3339),
    [anon_sym_lock] = ACTIONS(3339),
    [anon_sym_yield] = ACTIONS(3339),
    [anon_sym_switch] = ACTIONS(3339),
    [anon_sym_default] = ACTIONS(3339),
    [anon_sym_throw] = ACTIONS(3339),
    [anon_sym_try] = ACTIONS(3339),
    [anon_sym_when] = ACTIONS(3339),
    [anon_sym_await] = ACTIONS(3339),
    [anon_sym_foreach] = ACTIONS(3339),
    [anon_sym_goto] = ACTIONS(3339),
    [anon_sym_if] = ACTIONS(3339),
    [anon_sym_else] = ACTIONS(3339),
    [anon_sym_DOT_DOT] = ACTIONS(3341),
    [anon_sym_from] = ACTIONS(3339),
    [anon_sym_into] = ACTIONS(3339),
    [anon_sym_join] = ACTIONS(3339),
    [anon_sym_on] = ACTIONS(3339),
    [anon_sym_equals] = ACTIONS(3339),
    [anon_sym_let] = ACTIONS(3339),
    [anon_sym_orderby] = ACTIONS(3339),
    [anon_sym_ascending] = ACTIONS(3339),
    [anon_sym_descending] = ACTIONS(3339),
    [anon_sym_group] = ACTIONS(3339),
    [anon_sym_by] = ACTIONS(3339),
    [anon_sym_select] = ACTIONS(3339),
    [anon_sym_DQUOTE] = ACTIONS(3339),
    [anon_sym_stackalloc] = ACTIONS(3339),
    [anon_sym_sizeof] = ACTIONS(3339),
    [anon_sym_typeof] = ACTIONS(3339),
    [anon_sym___makeref] = ACTIONS(3339),
    [anon_sym___reftype] = ACTIONS(3339),
    [anon_sym___refvalue] = ACTIONS(3339),
    [sym_null_literal] = ACTIONS(3339),
    [anon_sym_SQUOTE] = ACTIONS(3341),
    [sym_integer_literal] = ACTIONS(3339),
    [sym_real_literal] = ACTIONS(3341),
    [sym_verbatim_string_literal] = ACTIONS(3341),
    [sym_raw_string_literal] = ACTIONS(3341),
    [aux_sym_preproc_if_token1] = ACTIONS(3341),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3341),
    [sym_interpolation_verbatim_start] = ACTIONS(3341),
    [sym_interpolation_raw_start] = ACTIONS(3341),
  },
  [2502] = {
    [sym_preproc_region] = STATE(2502),
    [sym_preproc_endregion] = STATE(2502),
    [sym_preproc_line] = STATE(2502),
    [sym_preproc_pragma] = STATE(2502),
    [sym_preproc_nullable] = STATE(2502),
    [sym_preproc_error] = STATE(2502),
    [sym_preproc_define] = STATE(2502),
    [sym_preproc_undef] = STATE(2502),
    [ts_builtin_sym_end] = ACTIONS(3205),
    [sym__identifier_token] = ACTIONS(3203),
    [anon_sym_extern] = ACTIONS(3203),
    [anon_sym_alias] = ACTIONS(3203),
    [anon_sym_SEMI] = ACTIONS(3205),
    [anon_sym_global] = ACTIONS(3203),
    [anon_sym_using] = ACTIONS(3203),
    [anon_sym_unsafe] = ACTIONS(3203),
    [anon_sym_static] = ACTIONS(3203),
    [anon_sym_LBRACK] = ACTIONS(3205),
    [anon_sym_LPAREN] = ACTIONS(3205),
    [anon_sym_return] = ACTIONS(3203),
    [anon_sym_namespace] = ACTIONS(3203),
    [anon_sym_class] = ACTIONS(3203),
    [anon_sym_ref] = ACTIONS(3203),
    [anon_sym_struct] = ACTIONS(3203),
    [anon_sym_enum] = ACTIONS(3203),
    [anon_sym_LBRACE] = ACTIONS(3205),
    [anon_sym_interface] = ACTIONS(3203),
    [anon_sym_delegate] = ACTIONS(3203),
    [anon_sym_record] = ACTIONS(3203),
    [anon_sym_abstract] = ACTIONS(3203),
    [anon_sym_async] = ACTIONS(3203),
    [anon_sym_const] = ACTIONS(3203),
    [anon_sym_file] = ACTIONS(3203),
    [anon_sym_fixed] = ACTIONS(3203),
    [anon_sym_internal] = ACTIONS(3203),
    [anon_sym_new] = ACTIONS(3203),
    [anon_sym_override] = ACTIONS(3203),
    [anon_sym_partial] = ACTIONS(3203),
    [anon_sym_private] = ACTIONS(3203),
    [anon_sym_protected] = ACTIONS(3203),
    [anon_sym_public] = ACTIONS(3203),
    [anon_sym_readonly] = ACTIONS(3203),
    [anon_sym_required] = ACTIONS(3203),
    [anon_sym_sealed] = ACTIONS(3203),
    [anon_sym_virtual] = ACTIONS(3203),
    [anon_sym_volatile] = ACTIONS(3203),
    [anon_sym_where] = ACTIONS(3203),
    [anon_sym_notnull] = ACTIONS(3203),
    [anon_sym_unmanaged] = ACTIONS(3203),
    [anon_sym_checked] = ACTIONS(3203),
    [anon_sym_BANG] = ACTIONS(3205),
    [anon_sym_TILDE] = ACTIONS(3205),
    [anon_sym_PLUS_PLUS] = ACTIONS(3205),
    [anon_sym_DASH_DASH] = ACTIONS(3205),
    [anon_sym_true] = ACTIONS(3203),
    [anon_sym_false] = ACTIONS(3203),
    [anon_sym_PLUS] = ACTIONS(3203),
    [anon_sym_DASH] = ACTIONS(3203),
    [anon_sym_STAR] = ACTIONS(3205),
    [anon_sym_CARET] = ACTIONS(3205),
    [anon_sym_AMP] = ACTIONS(3205),
    [anon_sym_this] = ACTIONS(3203),
    [anon_sym_scoped] = ACTIONS(3203),
    [anon_sym_var] = ACTIONS(3203),
    [sym_predefined_type] = ACTIONS(3203),
    [anon_sym_break] = ACTIONS(3203),
    [anon_sym_unchecked] = ACTIONS(3203),
    [anon_sym_continue] = ACTIONS(3203),
    [anon_sym_do] = ACTIONS(3203),
    [anon_sym_while] = ACTIONS(3203),
    [anon_sym_for] = ACTIONS(3203),
    [anon_sym_lock] = ACTIONS(3203),
    [anon_sym_yield] = ACTIONS(3203),
    [anon_sym_switch] = ACTIONS(3203),
    [anon_sym_default] = ACTIONS(3203),
    [anon_sym_throw] = ACTIONS(3203),
    [anon_sym_try] = ACTIONS(3203),
    [anon_sym_when] = ACTIONS(3203),
    [anon_sym_await] = ACTIONS(3203),
    [anon_sym_foreach] = ACTIONS(3203),
    [anon_sym_goto] = ACTIONS(3203),
    [anon_sym_if] = ACTIONS(3203),
    [anon_sym_else] = ACTIONS(3203),
    [anon_sym_DOT_DOT] = ACTIONS(3205),
    [anon_sym_from] = ACTIONS(3203),
    [anon_sym_into] = ACTIONS(3203),
    [anon_sym_join] = ACTIONS(3203),
    [anon_sym_on] = ACTIONS(3203),
    [anon_sym_equals] = ACTIONS(3203),
    [anon_sym_let] = ACTIONS(3203),
    [anon_sym_orderby] = ACTIONS(3203),
    [anon_sym_ascending] = ACTIONS(3203),
    [anon_sym_descending] = ACTIONS(3203),
    [anon_sym_group] = ACTIONS(3203),
    [anon_sym_by] = ACTIONS(3203),
    [anon_sym_select] = ACTIONS(3203),
    [anon_sym_DQUOTE] = ACTIONS(3203),
    [anon_sym_stackalloc] = ACTIONS(3203),
    [anon_sym_sizeof] = ACTIONS(3203),
    [anon_sym_typeof] = ACTIONS(3203),
    [anon_sym___makeref] = ACTIONS(3203),
    [anon_sym___reftype] = ACTIONS(3203),
    [anon_sym___refvalue] = ACTIONS(3203),
    [sym_null_literal] = ACTIONS(3203),
    [anon_sym_SQUOTE] = ACTIONS(3205),
    [sym_integer_literal] = ACTIONS(3203),
    [sym_real_literal] = ACTIONS(3205),
    [sym_verbatim_string_literal] = ACTIONS(3205),
    [sym_raw_string_literal] = ACTIONS(3205),
    [aux_sym_preproc_if_token1] = ACTIONS(3205),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3205),
    [sym_interpolation_verbatim_start] = ACTIONS(3205),
    [sym_interpolation_raw_start] = ACTIONS(3205),
  },
  [2503] = {
    [sym_preproc_region] = STATE(2503),
    [sym_preproc_endregion] = STATE(2503),
    [sym_preproc_line] = STATE(2503),
    [sym_preproc_pragma] = STATE(2503),
    [sym_preproc_nullable] = STATE(2503),
    [sym_preproc_error] = STATE(2503),
    [sym_preproc_define] = STATE(2503),
    [sym_preproc_undef] = STATE(2503),
    [ts_builtin_sym_end] = ACTIONS(3854),
    [sym__identifier_token] = ACTIONS(3852),
    [anon_sym_extern] = ACTIONS(3852),
    [anon_sym_alias] = ACTIONS(3852),
    [anon_sym_SEMI] = ACTIONS(3854),
    [anon_sym_global] = ACTIONS(3852),
    [anon_sym_using] = ACTIONS(3852),
    [anon_sym_unsafe] = ACTIONS(3852),
    [anon_sym_static] = ACTIONS(3852),
    [anon_sym_LBRACK] = ACTIONS(3854),
    [anon_sym_LPAREN] = ACTIONS(3854),
    [anon_sym_return] = ACTIONS(3852),
    [anon_sym_namespace] = ACTIONS(3852),
    [anon_sym_class] = ACTIONS(3852),
    [anon_sym_ref] = ACTIONS(3852),
    [anon_sym_struct] = ACTIONS(3852),
    [anon_sym_enum] = ACTIONS(3852),
    [anon_sym_LBRACE] = ACTIONS(3854),
    [anon_sym_interface] = ACTIONS(3852),
    [anon_sym_delegate] = ACTIONS(3852),
    [anon_sym_record] = ACTIONS(3852),
    [anon_sym_abstract] = ACTIONS(3852),
    [anon_sym_async] = ACTIONS(3852),
    [anon_sym_const] = ACTIONS(3852),
    [anon_sym_file] = ACTIONS(3852),
    [anon_sym_fixed] = ACTIONS(3852),
    [anon_sym_internal] = ACTIONS(3852),
    [anon_sym_new] = ACTIONS(3852),
    [anon_sym_override] = ACTIONS(3852),
    [anon_sym_partial] = ACTIONS(3852),
    [anon_sym_private] = ACTIONS(3852),
    [anon_sym_protected] = ACTIONS(3852),
    [anon_sym_public] = ACTIONS(3852),
    [anon_sym_readonly] = ACTIONS(3852),
    [anon_sym_required] = ACTIONS(3852),
    [anon_sym_sealed] = ACTIONS(3852),
    [anon_sym_virtual] = ACTIONS(3852),
    [anon_sym_volatile] = ACTIONS(3852),
    [anon_sym_where] = ACTIONS(3852),
    [anon_sym_notnull] = ACTIONS(3852),
    [anon_sym_unmanaged] = ACTIONS(3852),
    [anon_sym_checked] = ACTIONS(3852),
    [anon_sym_BANG] = ACTIONS(3854),
    [anon_sym_TILDE] = ACTIONS(3854),
    [anon_sym_PLUS_PLUS] = ACTIONS(3854),
    [anon_sym_DASH_DASH] = ACTIONS(3854),
    [anon_sym_true] = ACTIONS(3852),
    [anon_sym_false] = ACTIONS(3852),
    [anon_sym_PLUS] = ACTIONS(3852),
    [anon_sym_DASH] = ACTIONS(3852),
    [anon_sym_STAR] = ACTIONS(3854),
    [anon_sym_CARET] = ACTIONS(3854),
    [anon_sym_AMP] = ACTIONS(3854),
    [anon_sym_this] = ACTIONS(3852),
    [anon_sym_scoped] = ACTIONS(3852),
    [anon_sym_var] = ACTIONS(3852),
    [sym_predefined_type] = ACTIONS(3852),
    [anon_sym_break] = ACTIONS(3852),
    [anon_sym_unchecked] = ACTIONS(3852),
    [anon_sym_continue] = ACTIONS(3852),
    [anon_sym_do] = ACTIONS(3852),
    [anon_sym_while] = ACTIONS(3852),
    [anon_sym_for] = ACTIONS(3852),
    [anon_sym_lock] = ACTIONS(3852),
    [anon_sym_yield] = ACTIONS(3852),
    [anon_sym_switch] = ACTIONS(3852),
    [anon_sym_default] = ACTIONS(3852),
    [anon_sym_throw] = ACTIONS(3852),
    [anon_sym_try] = ACTIONS(3852),
    [anon_sym_when] = ACTIONS(3852),
    [anon_sym_await] = ACTIONS(3852),
    [anon_sym_foreach] = ACTIONS(3852),
    [anon_sym_goto] = ACTIONS(3852),
    [anon_sym_if] = ACTIONS(3852),
    [anon_sym_DOT_DOT] = ACTIONS(3854),
    [anon_sym_from] = ACTIONS(3852),
    [anon_sym_into] = ACTIONS(3852),
    [anon_sym_join] = ACTIONS(3852),
    [anon_sym_on] = ACTIONS(3852),
    [anon_sym_equals] = ACTIONS(3852),
    [anon_sym_let] = ACTIONS(3852),
    [anon_sym_orderby] = ACTIONS(3852),
    [anon_sym_ascending] = ACTIONS(3852),
    [anon_sym_descending] = ACTIONS(3852),
    [anon_sym_group] = ACTIONS(3852),
    [anon_sym_by] = ACTIONS(3852),
    [anon_sym_select] = ACTIONS(3852),
    [anon_sym_DQUOTE] = ACTIONS(3852),
    [anon_sym_stackalloc] = ACTIONS(3852),
    [anon_sym_sizeof] = ACTIONS(3852),
    [anon_sym_typeof] = ACTIONS(3852),
    [anon_sym___makeref] = ACTIONS(3852),
    [anon_sym___reftype] = ACTIONS(3852),
    [anon_sym___refvalue] = ACTIONS(3852),
    [sym_null_literal] = ACTIONS(3852),
    [anon_sym_SQUOTE] = ACTIONS(3854),
    [sym_integer_literal] = ACTIONS(3852),
    [sym_real_literal] = ACTIONS(3854),
    [sym_verbatim_string_literal] = ACTIONS(3854),
    [sym_raw_string_literal] = ACTIONS(3854),
    [aux_sym_preproc_if_token1] = ACTIONS(3854),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3854),
    [sym_interpolation_verbatim_start] = ACTIONS(3854),
    [sym_interpolation_raw_start] = ACTIONS(3854),
  },
  [2504] = {
    [sym_preproc_region] = STATE(2504),
    [sym_preproc_endregion] = STATE(2504),
    [sym_preproc_line] = STATE(2504),
    [sym_preproc_pragma] = STATE(2504),
    [sym_preproc_nullable] = STATE(2504),
    [sym_preproc_error] = STATE(2504),
    [sym_preproc_define] = STATE(2504),
    [sym_preproc_undef] = STATE(2504),
    [ts_builtin_sym_end] = ACTIONS(3431),
    [sym__identifier_token] = ACTIONS(3429),
    [anon_sym_extern] = ACTIONS(3429),
    [anon_sym_alias] = ACTIONS(3429),
    [anon_sym_SEMI] = ACTIONS(3431),
    [anon_sym_global] = ACTIONS(3429),
    [anon_sym_using] = ACTIONS(3429),
    [anon_sym_unsafe] = ACTIONS(3429),
    [anon_sym_static] = ACTIONS(3429),
    [anon_sym_LBRACK] = ACTIONS(3431),
    [anon_sym_LPAREN] = ACTIONS(3431),
    [anon_sym_return] = ACTIONS(3429),
    [anon_sym_namespace] = ACTIONS(3429),
    [anon_sym_class] = ACTIONS(3429),
    [anon_sym_ref] = ACTIONS(3429),
    [anon_sym_struct] = ACTIONS(3429),
    [anon_sym_enum] = ACTIONS(3429),
    [anon_sym_LBRACE] = ACTIONS(3431),
    [anon_sym_interface] = ACTIONS(3429),
    [anon_sym_delegate] = ACTIONS(3429),
    [anon_sym_record] = ACTIONS(3429),
    [anon_sym_abstract] = ACTIONS(3429),
    [anon_sym_async] = ACTIONS(3429),
    [anon_sym_const] = ACTIONS(3429),
    [anon_sym_file] = ACTIONS(3429),
    [anon_sym_fixed] = ACTIONS(3429),
    [anon_sym_internal] = ACTIONS(3429),
    [anon_sym_new] = ACTIONS(3429),
    [anon_sym_override] = ACTIONS(3429),
    [anon_sym_partial] = ACTIONS(3429),
    [anon_sym_private] = ACTIONS(3429),
    [anon_sym_protected] = ACTIONS(3429),
    [anon_sym_public] = ACTIONS(3429),
    [anon_sym_readonly] = ACTIONS(3429),
    [anon_sym_required] = ACTIONS(3429),
    [anon_sym_sealed] = ACTIONS(3429),
    [anon_sym_virtual] = ACTIONS(3429),
    [anon_sym_volatile] = ACTIONS(3429),
    [anon_sym_where] = ACTIONS(3429),
    [anon_sym_notnull] = ACTIONS(3429),
    [anon_sym_unmanaged] = ACTIONS(3429),
    [anon_sym_checked] = ACTIONS(3429),
    [anon_sym_BANG] = ACTIONS(3431),
    [anon_sym_TILDE] = ACTIONS(3431),
    [anon_sym_PLUS_PLUS] = ACTIONS(3431),
    [anon_sym_DASH_DASH] = ACTIONS(3431),
    [anon_sym_true] = ACTIONS(3429),
    [anon_sym_false] = ACTIONS(3429),
    [anon_sym_PLUS] = ACTIONS(3429),
    [anon_sym_DASH] = ACTIONS(3429),
    [anon_sym_STAR] = ACTIONS(3431),
    [anon_sym_CARET] = ACTIONS(3431),
    [anon_sym_AMP] = ACTIONS(3431),
    [anon_sym_this] = ACTIONS(3429),
    [anon_sym_scoped] = ACTIONS(3429),
    [anon_sym_var] = ACTIONS(3429),
    [sym_predefined_type] = ACTIONS(3429),
    [anon_sym_break] = ACTIONS(3429),
    [anon_sym_unchecked] = ACTIONS(3429),
    [anon_sym_continue] = ACTIONS(3429),
    [anon_sym_do] = ACTIONS(3429),
    [anon_sym_while] = ACTIONS(3429),
    [anon_sym_for] = ACTIONS(3429),
    [anon_sym_lock] = ACTIONS(3429),
    [anon_sym_yield] = ACTIONS(3429),
    [anon_sym_switch] = ACTIONS(3429),
    [anon_sym_default] = ACTIONS(3429),
    [anon_sym_throw] = ACTIONS(3429),
    [anon_sym_try] = ACTIONS(3429),
    [anon_sym_when] = ACTIONS(3429),
    [anon_sym_await] = ACTIONS(3429),
    [anon_sym_foreach] = ACTIONS(3429),
    [anon_sym_goto] = ACTIONS(3429),
    [anon_sym_if] = ACTIONS(3429),
    [anon_sym_DOT_DOT] = ACTIONS(3431),
    [anon_sym_from] = ACTIONS(3429),
    [anon_sym_into] = ACTIONS(3429),
    [anon_sym_join] = ACTIONS(3429),
    [anon_sym_on] = ACTIONS(3429),
    [anon_sym_equals] = ACTIONS(3429),
    [anon_sym_let] = ACTIONS(3429),
    [anon_sym_orderby] = ACTIONS(3429),
    [anon_sym_ascending] = ACTIONS(3429),
    [anon_sym_descending] = ACTIONS(3429),
    [anon_sym_group] = ACTIONS(3429),
    [anon_sym_by] = ACTIONS(3429),
    [anon_sym_select] = ACTIONS(3429),
    [anon_sym_DQUOTE] = ACTIONS(3429),
    [anon_sym_stackalloc] = ACTIONS(3429),
    [anon_sym_sizeof] = ACTIONS(3429),
    [anon_sym_typeof] = ACTIONS(3429),
    [anon_sym___makeref] = ACTIONS(3429),
    [anon_sym___reftype] = ACTIONS(3429),
    [anon_sym___refvalue] = ACTIONS(3429),
    [sym_null_literal] = ACTIONS(3429),
    [anon_sym_SQUOTE] = ACTIONS(3431),
    [sym_integer_literal] = ACTIONS(3429),
    [sym_real_literal] = ACTIONS(3431),
    [sym_verbatim_string_literal] = ACTIONS(3431),
    [sym_raw_string_literal] = ACTIONS(3431),
    [aux_sym_preproc_if_token1] = ACTIONS(3431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3431),
    [sym_interpolation_verbatim_start] = ACTIONS(3431),
    [sym_interpolation_raw_start] = ACTIONS(3431),
  },
  [2505] = {
    [sym_preproc_region] = STATE(2505),
    [sym_preproc_endregion] = STATE(2505),
    [sym_preproc_line] = STATE(2505),
    [sym_preproc_pragma] = STATE(2505),
    [sym_preproc_nullable] = STATE(2505),
    [sym_preproc_error] = STATE(2505),
    [sym_preproc_define] = STATE(2505),
    [sym_preproc_undef] = STATE(2505),
    [ts_builtin_sym_end] = ACTIONS(3499),
    [sym__identifier_token] = ACTIONS(3497),
    [anon_sym_extern] = ACTIONS(3497),
    [anon_sym_alias] = ACTIONS(3497),
    [anon_sym_SEMI] = ACTIONS(3499),
    [anon_sym_global] = ACTIONS(3497),
    [anon_sym_using] = ACTIONS(3497),
    [anon_sym_unsafe] = ACTIONS(3497),
    [anon_sym_static] = ACTIONS(3497),
    [anon_sym_LBRACK] = ACTIONS(3499),
    [anon_sym_LPAREN] = ACTIONS(3499),
    [anon_sym_return] = ACTIONS(3497),
    [anon_sym_namespace] = ACTIONS(3497),
    [anon_sym_class] = ACTIONS(3497),
    [anon_sym_ref] = ACTIONS(3497),
    [anon_sym_struct] = ACTIONS(3497),
    [anon_sym_enum] = ACTIONS(3497),
    [anon_sym_LBRACE] = ACTIONS(3499),
    [anon_sym_interface] = ACTIONS(3497),
    [anon_sym_delegate] = ACTIONS(3497),
    [anon_sym_record] = ACTIONS(3497),
    [anon_sym_abstract] = ACTIONS(3497),
    [anon_sym_async] = ACTIONS(3497),
    [anon_sym_const] = ACTIONS(3497),
    [anon_sym_file] = ACTIONS(3497),
    [anon_sym_fixed] = ACTIONS(3497),
    [anon_sym_internal] = ACTIONS(3497),
    [anon_sym_new] = ACTIONS(3497),
    [anon_sym_override] = ACTIONS(3497),
    [anon_sym_partial] = ACTIONS(3497),
    [anon_sym_private] = ACTIONS(3497),
    [anon_sym_protected] = ACTIONS(3497),
    [anon_sym_public] = ACTIONS(3497),
    [anon_sym_readonly] = ACTIONS(3497),
    [anon_sym_required] = ACTIONS(3497),
    [anon_sym_sealed] = ACTIONS(3497),
    [anon_sym_virtual] = ACTIONS(3497),
    [anon_sym_volatile] = ACTIONS(3497),
    [anon_sym_where] = ACTIONS(3497),
    [anon_sym_notnull] = ACTIONS(3497),
    [anon_sym_unmanaged] = ACTIONS(3497),
    [anon_sym_checked] = ACTIONS(3497),
    [anon_sym_BANG] = ACTIONS(3499),
    [anon_sym_TILDE] = ACTIONS(3499),
    [anon_sym_PLUS_PLUS] = ACTIONS(3499),
    [anon_sym_DASH_DASH] = ACTIONS(3499),
    [anon_sym_true] = ACTIONS(3497),
    [anon_sym_false] = ACTIONS(3497),
    [anon_sym_PLUS] = ACTIONS(3497),
    [anon_sym_DASH] = ACTIONS(3497),
    [anon_sym_STAR] = ACTIONS(3499),
    [anon_sym_CARET] = ACTIONS(3499),
    [anon_sym_AMP] = ACTIONS(3499),
    [anon_sym_this] = ACTIONS(3497),
    [anon_sym_scoped] = ACTIONS(3497),
    [anon_sym_var] = ACTIONS(3497),
    [sym_predefined_type] = ACTIONS(3497),
    [anon_sym_break] = ACTIONS(3497),
    [anon_sym_unchecked] = ACTIONS(3497),
    [anon_sym_continue] = ACTIONS(3497),
    [anon_sym_do] = ACTIONS(3497),
    [anon_sym_while] = ACTIONS(3497),
    [anon_sym_for] = ACTIONS(3497),
    [anon_sym_lock] = ACTIONS(3497),
    [anon_sym_yield] = ACTIONS(3497),
    [anon_sym_switch] = ACTIONS(3497),
    [anon_sym_default] = ACTIONS(3497),
    [anon_sym_throw] = ACTIONS(3497),
    [anon_sym_try] = ACTIONS(3497),
    [anon_sym_when] = ACTIONS(3497),
    [anon_sym_await] = ACTIONS(3497),
    [anon_sym_foreach] = ACTIONS(3497),
    [anon_sym_goto] = ACTIONS(3497),
    [anon_sym_if] = ACTIONS(3497),
    [anon_sym_DOT_DOT] = ACTIONS(3499),
    [anon_sym_from] = ACTIONS(3497),
    [anon_sym_into] = ACTIONS(3497),
    [anon_sym_join] = ACTIONS(3497),
    [anon_sym_on] = ACTIONS(3497),
    [anon_sym_equals] = ACTIONS(3497),
    [anon_sym_let] = ACTIONS(3497),
    [anon_sym_orderby] = ACTIONS(3497),
    [anon_sym_ascending] = ACTIONS(3497),
    [anon_sym_descending] = ACTIONS(3497),
    [anon_sym_group] = ACTIONS(3497),
    [anon_sym_by] = ACTIONS(3497),
    [anon_sym_select] = ACTIONS(3497),
    [anon_sym_DQUOTE] = ACTIONS(3497),
    [anon_sym_stackalloc] = ACTIONS(3497),
    [anon_sym_sizeof] = ACTIONS(3497),
    [anon_sym_typeof] = ACTIONS(3497),
    [anon_sym___makeref] = ACTIONS(3497),
    [anon_sym___reftype] = ACTIONS(3497),
    [anon_sym___refvalue] = ACTIONS(3497),
    [sym_null_literal] = ACTIONS(3497),
    [anon_sym_SQUOTE] = ACTIONS(3499),
    [sym_integer_literal] = ACTIONS(3497),
    [sym_real_literal] = ACTIONS(3499),
    [sym_verbatim_string_literal] = ACTIONS(3499),
    [sym_raw_string_literal] = ACTIONS(3499),
    [aux_sym_preproc_if_token1] = ACTIONS(3499),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3499),
    [sym_interpolation_verbatim_start] = ACTIONS(3499),
    [sym_interpolation_raw_start] = ACTIONS(3499),
  },
  [2506] = {
    [sym_preproc_region] = STATE(2506),
    [sym_preproc_endregion] = STATE(2506),
    [sym_preproc_line] = STATE(2506),
    [sym_preproc_pragma] = STATE(2506),
    [sym_preproc_nullable] = STATE(2506),
    [sym_preproc_error] = STATE(2506),
    [sym_preproc_define] = STATE(2506),
    [sym_preproc_undef] = STATE(2506),
    [ts_builtin_sym_end] = ACTIONS(3695),
    [sym__identifier_token] = ACTIONS(3693),
    [anon_sym_extern] = ACTIONS(3693),
    [anon_sym_alias] = ACTIONS(3693),
    [anon_sym_SEMI] = ACTIONS(3695),
    [anon_sym_global] = ACTIONS(3693),
    [anon_sym_using] = ACTIONS(3693),
    [anon_sym_unsafe] = ACTIONS(3693),
    [anon_sym_static] = ACTIONS(3693),
    [anon_sym_LBRACK] = ACTIONS(3695),
    [anon_sym_LPAREN] = ACTIONS(3695),
    [anon_sym_return] = ACTIONS(3693),
    [anon_sym_namespace] = ACTIONS(3693),
    [anon_sym_class] = ACTIONS(3693),
    [anon_sym_ref] = ACTIONS(3693),
    [anon_sym_struct] = ACTIONS(3693),
    [anon_sym_enum] = ACTIONS(3693),
    [anon_sym_LBRACE] = ACTIONS(3695),
    [anon_sym_interface] = ACTIONS(3693),
    [anon_sym_delegate] = ACTIONS(3693),
    [anon_sym_record] = ACTIONS(3693),
    [anon_sym_abstract] = ACTIONS(3693),
    [anon_sym_async] = ACTIONS(3693),
    [anon_sym_const] = ACTIONS(3693),
    [anon_sym_file] = ACTIONS(3693),
    [anon_sym_fixed] = ACTIONS(3693),
    [anon_sym_internal] = ACTIONS(3693),
    [anon_sym_new] = ACTIONS(3693),
    [anon_sym_override] = ACTIONS(3693),
    [anon_sym_partial] = ACTIONS(3693),
    [anon_sym_private] = ACTIONS(3693),
    [anon_sym_protected] = ACTIONS(3693),
    [anon_sym_public] = ACTIONS(3693),
    [anon_sym_readonly] = ACTIONS(3693),
    [anon_sym_required] = ACTIONS(3693),
    [anon_sym_sealed] = ACTIONS(3693),
    [anon_sym_virtual] = ACTIONS(3693),
    [anon_sym_volatile] = ACTIONS(3693),
    [anon_sym_where] = ACTIONS(3693),
    [anon_sym_notnull] = ACTIONS(3693),
    [anon_sym_unmanaged] = ACTIONS(3693),
    [anon_sym_checked] = ACTIONS(3693),
    [anon_sym_BANG] = ACTIONS(3695),
    [anon_sym_TILDE] = ACTIONS(3695),
    [anon_sym_PLUS_PLUS] = ACTIONS(3695),
    [anon_sym_DASH_DASH] = ACTIONS(3695),
    [anon_sym_true] = ACTIONS(3693),
    [anon_sym_false] = ACTIONS(3693),
    [anon_sym_PLUS] = ACTIONS(3693),
    [anon_sym_DASH] = ACTIONS(3693),
    [anon_sym_STAR] = ACTIONS(3695),
    [anon_sym_CARET] = ACTIONS(3695),
    [anon_sym_AMP] = ACTIONS(3695),
    [anon_sym_this] = ACTIONS(3693),
    [anon_sym_scoped] = ACTIONS(3693),
    [anon_sym_var] = ACTIONS(3693),
    [sym_predefined_type] = ACTIONS(3693),
    [anon_sym_break] = ACTIONS(3693),
    [anon_sym_unchecked] = ACTIONS(3693),
    [anon_sym_continue] = ACTIONS(3693),
    [anon_sym_do] = ACTIONS(3693),
    [anon_sym_while] = ACTIONS(3693),
    [anon_sym_for] = ACTIONS(3693),
    [anon_sym_lock] = ACTIONS(3693),
    [anon_sym_yield] = ACTIONS(3693),
    [anon_sym_switch] = ACTIONS(3693),
    [anon_sym_default] = ACTIONS(3693),
    [anon_sym_throw] = ACTIONS(3693),
    [anon_sym_try] = ACTIONS(3693),
    [anon_sym_when] = ACTIONS(3693),
    [anon_sym_await] = ACTIONS(3693),
    [anon_sym_foreach] = ACTIONS(3693),
    [anon_sym_goto] = ACTIONS(3693),
    [anon_sym_if] = ACTIONS(3693),
    [anon_sym_DOT_DOT] = ACTIONS(3695),
    [anon_sym_from] = ACTIONS(3693),
    [anon_sym_into] = ACTIONS(3693),
    [anon_sym_join] = ACTIONS(3693),
    [anon_sym_on] = ACTIONS(3693),
    [anon_sym_equals] = ACTIONS(3693),
    [anon_sym_let] = ACTIONS(3693),
    [anon_sym_orderby] = ACTIONS(3693),
    [anon_sym_ascending] = ACTIONS(3693),
    [anon_sym_descending] = ACTIONS(3693),
    [anon_sym_group] = ACTIONS(3693),
    [anon_sym_by] = ACTIONS(3693),
    [anon_sym_select] = ACTIONS(3693),
    [anon_sym_DQUOTE] = ACTIONS(3693),
    [anon_sym_stackalloc] = ACTIONS(3693),
    [anon_sym_sizeof] = ACTIONS(3693),
    [anon_sym_typeof] = ACTIONS(3693),
    [anon_sym___makeref] = ACTIONS(3693),
    [anon_sym___reftype] = ACTIONS(3693),
    [anon_sym___refvalue] = ACTIONS(3693),
    [sym_null_literal] = ACTIONS(3693),
    [anon_sym_SQUOTE] = ACTIONS(3695),
    [sym_integer_literal] = ACTIONS(3693),
    [sym_real_literal] = ACTIONS(3695),
    [sym_verbatim_string_literal] = ACTIONS(3695),
    [sym_raw_string_literal] = ACTIONS(3695),
    [aux_sym_preproc_if_token1] = ACTIONS(3695),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3695),
    [sym_interpolation_verbatim_start] = ACTIONS(3695),
    [sym_interpolation_raw_start] = ACTIONS(3695),
  },
  [2507] = {
    [sym_preproc_region] = STATE(2507),
    [sym_preproc_endregion] = STATE(2507),
    [sym_preproc_line] = STATE(2507),
    [sym_preproc_pragma] = STATE(2507),
    [sym_preproc_nullable] = STATE(2507),
    [sym_preproc_error] = STATE(2507),
    [sym_preproc_define] = STATE(2507),
    [sym_preproc_undef] = STATE(2507),
    [ts_builtin_sym_end] = ACTIONS(3711),
    [sym__identifier_token] = ACTIONS(3709),
    [anon_sym_extern] = ACTIONS(3709),
    [anon_sym_alias] = ACTIONS(3709),
    [anon_sym_SEMI] = ACTIONS(3711),
    [anon_sym_global] = ACTIONS(3709),
    [anon_sym_using] = ACTIONS(3709),
    [anon_sym_unsafe] = ACTIONS(3709),
    [anon_sym_static] = ACTIONS(3709),
    [anon_sym_LBRACK] = ACTIONS(3711),
    [anon_sym_LPAREN] = ACTIONS(3711),
    [anon_sym_return] = ACTIONS(3709),
    [anon_sym_namespace] = ACTIONS(3709),
    [anon_sym_class] = ACTIONS(3709),
    [anon_sym_ref] = ACTIONS(3709),
    [anon_sym_struct] = ACTIONS(3709),
    [anon_sym_enum] = ACTIONS(3709),
    [anon_sym_LBRACE] = ACTIONS(3711),
    [anon_sym_interface] = ACTIONS(3709),
    [anon_sym_delegate] = ACTIONS(3709),
    [anon_sym_record] = ACTIONS(3709),
    [anon_sym_abstract] = ACTIONS(3709),
    [anon_sym_async] = ACTIONS(3709),
    [anon_sym_const] = ACTIONS(3709),
    [anon_sym_file] = ACTIONS(3709),
    [anon_sym_fixed] = ACTIONS(3709),
    [anon_sym_internal] = ACTIONS(3709),
    [anon_sym_new] = ACTIONS(3709),
    [anon_sym_override] = ACTIONS(3709),
    [anon_sym_partial] = ACTIONS(3709),
    [anon_sym_private] = ACTIONS(3709),
    [anon_sym_protected] = ACTIONS(3709),
    [anon_sym_public] = ACTIONS(3709),
    [anon_sym_readonly] = ACTIONS(3709),
    [anon_sym_required] = ACTIONS(3709),
    [anon_sym_sealed] = ACTIONS(3709),
    [anon_sym_virtual] = ACTIONS(3709),
    [anon_sym_volatile] = ACTIONS(3709),
    [anon_sym_where] = ACTIONS(3709),
    [anon_sym_notnull] = ACTIONS(3709),
    [anon_sym_unmanaged] = ACTIONS(3709),
    [anon_sym_checked] = ACTIONS(3709),
    [anon_sym_BANG] = ACTIONS(3711),
    [anon_sym_TILDE] = ACTIONS(3711),
    [anon_sym_PLUS_PLUS] = ACTIONS(3711),
    [anon_sym_DASH_DASH] = ACTIONS(3711),
    [anon_sym_true] = ACTIONS(3709),
    [anon_sym_false] = ACTIONS(3709),
    [anon_sym_PLUS] = ACTIONS(3709),
    [anon_sym_DASH] = ACTIONS(3709),
    [anon_sym_STAR] = ACTIONS(3711),
    [anon_sym_CARET] = ACTIONS(3711),
    [anon_sym_AMP] = ACTIONS(3711),
    [anon_sym_this] = ACTIONS(3709),
    [anon_sym_scoped] = ACTIONS(3709),
    [anon_sym_var] = ACTIONS(3709),
    [sym_predefined_type] = ACTIONS(3709),
    [anon_sym_break] = ACTIONS(3709),
    [anon_sym_unchecked] = ACTIONS(3709),
    [anon_sym_continue] = ACTIONS(3709),
    [anon_sym_do] = ACTIONS(3709),
    [anon_sym_while] = ACTIONS(3709),
    [anon_sym_for] = ACTIONS(3709),
    [anon_sym_lock] = ACTIONS(3709),
    [anon_sym_yield] = ACTIONS(3709),
    [anon_sym_switch] = ACTIONS(3709),
    [anon_sym_default] = ACTIONS(3709),
    [anon_sym_throw] = ACTIONS(3709),
    [anon_sym_try] = ACTIONS(3709),
    [anon_sym_when] = ACTIONS(3709),
    [anon_sym_await] = ACTIONS(3709),
    [anon_sym_foreach] = ACTIONS(3709),
    [anon_sym_goto] = ACTIONS(3709),
    [anon_sym_if] = ACTIONS(3709),
    [anon_sym_DOT_DOT] = ACTIONS(3711),
    [anon_sym_from] = ACTIONS(3709),
    [anon_sym_into] = ACTIONS(3709),
    [anon_sym_join] = ACTIONS(3709),
    [anon_sym_on] = ACTIONS(3709),
    [anon_sym_equals] = ACTIONS(3709),
    [anon_sym_let] = ACTIONS(3709),
    [anon_sym_orderby] = ACTIONS(3709),
    [anon_sym_ascending] = ACTIONS(3709),
    [anon_sym_descending] = ACTIONS(3709),
    [anon_sym_group] = ACTIONS(3709),
    [anon_sym_by] = ACTIONS(3709),
    [anon_sym_select] = ACTIONS(3709),
    [anon_sym_DQUOTE] = ACTIONS(3709),
    [anon_sym_stackalloc] = ACTIONS(3709),
    [anon_sym_sizeof] = ACTIONS(3709),
    [anon_sym_typeof] = ACTIONS(3709),
    [anon_sym___makeref] = ACTIONS(3709),
    [anon_sym___reftype] = ACTIONS(3709),
    [anon_sym___refvalue] = ACTIONS(3709),
    [sym_null_literal] = ACTIONS(3709),
    [anon_sym_SQUOTE] = ACTIONS(3711),
    [sym_integer_literal] = ACTIONS(3709),
    [sym_real_literal] = ACTIONS(3711),
    [sym_verbatim_string_literal] = ACTIONS(3711),
    [sym_raw_string_literal] = ACTIONS(3711),
    [aux_sym_preproc_if_token1] = ACTIONS(3711),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3711),
    [sym_interpolation_verbatim_start] = ACTIONS(3711),
    [sym_interpolation_raw_start] = ACTIONS(3711),
  },
  [2508] = {
    [sym_preproc_region] = STATE(2508),
    [sym_preproc_endregion] = STATE(2508),
    [sym_preproc_line] = STATE(2508),
    [sym_preproc_pragma] = STATE(2508),
    [sym_preproc_nullable] = STATE(2508),
    [sym_preproc_error] = STATE(2508),
    [sym_preproc_define] = STATE(2508),
    [sym_preproc_undef] = STATE(2508),
    [ts_builtin_sym_end] = ACTIONS(3754),
    [sym__identifier_token] = ACTIONS(3752),
    [anon_sym_extern] = ACTIONS(3752),
    [anon_sym_alias] = ACTIONS(3752),
    [anon_sym_SEMI] = ACTIONS(3754),
    [anon_sym_global] = ACTIONS(3752),
    [anon_sym_using] = ACTIONS(3752),
    [anon_sym_unsafe] = ACTIONS(3752),
    [anon_sym_static] = ACTIONS(3752),
    [anon_sym_LBRACK] = ACTIONS(3754),
    [anon_sym_LPAREN] = ACTIONS(3754),
    [anon_sym_return] = ACTIONS(3752),
    [anon_sym_namespace] = ACTIONS(3752),
    [anon_sym_class] = ACTIONS(3752),
    [anon_sym_ref] = ACTIONS(3752),
    [anon_sym_struct] = ACTIONS(3752),
    [anon_sym_enum] = ACTIONS(3752),
    [anon_sym_LBRACE] = ACTIONS(3754),
    [anon_sym_interface] = ACTIONS(3752),
    [anon_sym_delegate] = ACTIONS(3752),
    [anon_sym_record] = ACTIONS(3752),
    [anon_sym_abstract] = ACTIONS(3752),
    [anon_sym_async] = ACTIONS(3752),
    [anon_sym_const] = ACTIONS(3752),
    [anon_sym_file] = ACTIONS(3752),
    [anon_sym_fixed] = ACTIONS(3752),
    [anon_sym_internal] = ACTIONS(3752),
    [anon_sym_new] = ACTIONS(3752),
    [anon_sym_override] = ACTIONS(3752),
    [anon_sym_partial] = ACTIONS(3752),
    [anon_sym_private] = ACTIONS(3752),
    [anon_sym_protected] = ACTIONS(3752),
    [anon_sym_public] = ACTIONS(3752),
    [anon_sym_readonly] = ACTIONS(3752),
    [anon_sym_required] = ACTIONS(3752),
    [anon_sym_sealed] = ACTIONS(3752),
    [anon_sym_virtual] = ACTIONS(3752),
    [anon_sym_volatile] = ACTIONS(3752),
    [anon_sym_where] = ACTIONS(3752),
    [anon_sym_notnull] = ACTIONS(3752),
    [anon_sym_unmanaged] = ACTIONS(3752),
    [anon_sym_checked] = ACTIONS(3752),
    [anon_sym_BANG] = ACTIONS(3754),
    [anon_sym_TILDE] = ACTIONS(3754),
    [anon_sym_PLUS_PLUS] = ACTIONS(3754),
    [anon_sym_DASH_DASH] = ACTIONS(3754),
    [anon_sym_true] = ACTIONS(3752),
    [anon_sym_false] = ACTIONS(3752),
    [anon_sym_PLUS] = ACTIONS(3752),
    [anon_sym_DASH] = ACTIONS(3752),
    [anon_sym_STAR] = ACTIONS(3754),
    [anon_sym_CARET] = ACTIONS(3754),
    [anon_sym_AMP] = ACTIONS(3754),
    [anon_sym_this] = ACTIONS(3752),
    [anon_sym_scoped] = ACTIONS(3752),
    [anon_sym_var] = ACTIONS(3752),
    [sym_predefined_type] = ACTIONS(3752),
    [anon_sym_break] = ACTIONS(3752),
    [anon_sym_unchecked] = ACTIONS(3752),
    [anon_sym_continue] = ACTIONS(3752),
    [anon_sym_do] = ACTIONS(3752),
    [anon_sym_while] = ACTIONS(3752),
    [anon_sym_for] = ACTIONS(3752),
    [anon_sym_lock] = ACTIONS(3752),
    [anon_sym_yield] = ACTIONS(3752),
    [anon_sym_switch] = ACTIONS(3752),
    [anon_sym_default] = ACTIONS(3752),
    [anon_sym_throw] = ACTIONS(3752),
    [anon_sym_try] = ACTIONS(3752),
    [anon_sym_when] = ACTIONS(3752),
    [anon_sym_await] = ACTIONS(3752),
    [anon_sym_foreach] = ACTIONS(3752),
    [anon_sym_goto] = ACTIONS(3752),
    [anon_sym_if] = ACTIONS(3752),
    [anon_sym_DOT_DOT] = ACTIONS(3754),
    [anon_sym_from] = ACTIONS(3752),
    [anon_sym_into] = ACTIONS(3752),
    [anon_sym_join] = ACTIONS(3752),
    [anon_sym_on] = ACTIONS(3752),
    [anon_sym_equals] = ACTIONS(3752),
    [anon_sym_let] = ACTIONS(3752),
    [anon_sym_orderby] = ACTIONS(3752),
    [anon_sym_ascending] = ACTIONS(3752),
    [anon_sym_descending] = ACTIONS(3752),
    [anon_sym_group] = ACTIONS(3752),
    [anon_sym_by] = ACTIONS(3752),
    [anon_sym_select] = ACTIONS(3752),
    [anon_sym_DQUOTE] = ACTIONS(3752),
    [anon_sym_stackalloc] = ACTIONS(3752),
    [anon_sym_sizeof] = ACTIONS(3752),
    [anon_sym_typeof] = ACTIONS(3752),
    [anon_sym___makeref] = ACTIONS(3752),
    [anon_sym___reftype] = ACTIONS(3752),
    [anon_sym___refvalue] = ACTIONS(3752),
    [sym_null_literal] = ACTIONS(3752),
    [anon_sym_SQUOTE] = ACTIONS(3754),
    [sym_integer_literal] = ACTIONS(3752),
    [sym_real_literal] = ACTIONS(3754),
    [sym_verbatim_string_literal] = ACTIONS(3754),
    [sym_raw_string_literal] = ACTIONS(3754),
    [aux_sym_preproc_if_token1] = ACTIONS(3754),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3754),
    [sym_interpolation_verbatim_start] = ACTIONS(3754),
    [sym_interpolation_raw_start] = ACTIONS(3754),
  },
  [2509] = {
    [sym_preproc_region] = STATE(2509),
    [sym_preproc_endregion] = STATE(2509),
    [sym_preproc_line] = STATE(2509),
    [sym_preproc_pragma] = STATE(2509),
    [sym_preproc_nullable] = STATE(2509),
    [sym_preproc_error] = STATE(2509),
    [sym_preproc_define] = STATE(2509),
    [sym_preproc_undef] = STATE(2509),
    [ts_builtin_sym_end] = ACTIONS(3491),
    [sym__identifier_token] = ACTIONS(3489),
    [anon_sym_extern] = ACTIONS(3489),
    [anon_sym_alias] = ACTIONS(3489),
    [anon_sym_SEMI] = ACTIONS(3491),
    [anon_sym_global] = ACTIONS(3489),
    [anon_sym_using] = ACTIONS(3489),
    [anon_sym_unsafe] = ACTIONS(3489),
    [anon_sym_static] = ACTIONS(3489),
    [anon_sym_LBRACK] = ACTIONS(3491),
    [anon_sym_LPAREN] = ACTIONS(3491),
    [anon_sym_return] = ACTIONS(3489),
    [anon_sym_namespace] = ACTIONS(3489),
    [anon_sym_class] = ACTIONS(3489),
    [anon_sym_ref] = ACTIONS(3489),
    [anon_sym_struct] = ACTIONS(3489),
    [anon_sym_enum] = ACTIONS(3489),
    [anon_sym_LBRACE] = ACTIONS(3491),
    [anon_sym_interface] = ACTIONS(3489),
    [anon_sym_delegate] = ACTIONS(3489),
    [anon_sym_record] = ACTIONS(3489),
    [anon_sym_abstract] = ACTIONS(3489),
    [anon_sym_async] = ACTIONS(3489),
    [anon_sym_const] = ACTIONS(3489),
    [anon_sym_file] = ACTIONS(3489),
    [anon_sym_fixed] = ACTIONS(3489),
    [anon_sym_internal] = ACTIONS(3489),
    [anon_sym_new] = ACTIONS(3489),
    [anon_sym_override] = ACTIONS(3489),
    [anon_sym_partial] = ACTIONS(3489),
    [anon_sym_private] = ACTIONS(3489),
    [anon_sym_protected] = ACTIONS(3489),
    [anon_sym_public] = ACTIONS(3489),
    [anon_sym_readonly] = ACTIONS(3489),
    [anon_sym_required] = ACTIONS(3489),
    [anon_sym_sealed] = ACTIONS(3489),
    [anon_sym_virtual] = ACTIONS(3489),
    [anon_sym_volatile] = ACTIONS(3489),
    [anon_sym_where] = ACTIONS(3489),
    [anon_sym_notnull] = ACTIONS(3489),
    [anon_sym_unmanaged] = ACTIONS(3489),
    [anon_sym_checked] = ACTIONS(3489),
    [anon_sym_BANG] = ACTIONS(3491),
    [anon_sym_TILDE] = ACTIONS(3491),
    [anon_sym_PLUS_PLUS] = ACTIONS(3491),
    [anon_sym_DASH_DASH] = ACTIONS(3491),
    [anon_sym_true] = ACTIONS(3489),
    [anon_sym_false] = ACTIONS(3489),
    [anon_sym_PLUS] = ACTIONS(3489),
    [anon_sym_DASH] = ACTIONS(3489),
    [anon_sym_STAR] = ACTIONS(3491),
    [anon_sym_CARET] = ACTIONS(3491),
    [anon_sym_AMP] = ACTIONS(3491),
    [anon_sym_this] = ACTIONS(3489),
    [anon_sym_scoped] = ACTIONS(3489),
    [anon_sym_var] = ACTIONS(3489),
    [sym_predefined_type] = ACTIONS(3489),
    [anon_sym_break] = ACTIONS(3489),
    [anon_sym_unchecked] = ACTIONS(3489),
    [anon_sym_continue] = ACTIONS(3489),
    [anon_sym_do] = ACTIONS(3489),
    [anon_sym_while] = ACTIONS(3489),
    [anon_sym_for] = ACTIONS(3489),
    [anon_sym_lock] = ACTIONS(3489),
    [anon_sym_yield] = ACTIONS(3489),
    [anon_sym_switch] = ACTIONS(3489),
    [anon_sym_default] = ACTIONS(3489),
    [anon_sym_throw] = ACTIONS(3489),
    [anon_sym_try] = ACTIONS(3489),
    [anon_sym_when] = ACTIONS(3489),
    [anon_sym_await] = ACTIONS(3489),
    [anon_sym_foreach] = ACTIONS(3489),
    [anon_sym_goto] = ACTIONS(3489),
    [anon_sym_if] = ACTIONS(3489),
    [anon_sym_DOT_DOT] = ACTIONS(3491),
    [anon_sym_from] = ACTIONS(3489),
    [anon_sym_into] = ACTIONS(3489),
    [anon_sym_join] = ACTIONS(3489),
    [anon_sym_on] = ACTIONS(3489),
    [anon_sym_equals] = ACTIONS(3489),
    [anon_sym_let] = ACTIONS(3489),
    [anon_sym_orderby] = ACTIONS(3489),
    [anon_sym_ascending] = ACTIONS(3489),
    [anon_sym_descending] = ACTIONS(3489),
    [anon_sym_group] = ACTIONS(3489),
    [anon_sym_by] = ACTIONS(3489),
    [anon_sym_select] = ACTIONS(3489),
    [anon_sym_DQUOTE] = ACTIONS(3489),
    [anon_sym_stackalloc] = ACTIONS(3489),
    [anon_sym_sizeof] = ACTIONS(3489),
    [anon_sym_typeof] = ACTIONS(3489),
    [anon_sym___makeref] = ACTIONS(3489),
    [anon_sym___reftype] = ACTIONS(3489),
    [anon_sym___refvalue] = ACTIONS(3489),
    [sym_null_literal] = ACTIONS(3489),
    [anon_sym_SQUOTE] = ACTIONS(3491),
    [sym_integer_literal] = ACTIONS(3489),
    [sym_real_literal] = ACTIONS(3491),
    [sym_verbatim_string_literal] = ACTIONS(3491),
    [sym_raw_string_literal] = ACTIONS(3491),
    [aux_sym_preproc_if_token1] = ACTIONS(3491),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3491),
    [sym_interpolation_verbatim_start] = ACTIONS(3491),
    [sym_interpolation_raw_start] = ACTIONS(3491),
  },
  [2510] = {
    [sym_using_directive] = STATE(3272),
    [sym_attribute_list] = STATE(3753),
    [sym_namespace_declaration] = STATE(3272),
    [sym_class_declaration] = STATE(3272),
    [sym_struct_declaration] = STATE(3272),
    [sym_enum_declaration] = STATE(3272),
    [sym_interface_declaration] = STATE(3272),
    [sym_delegate_declaration] = STATE(3272),
    [sym_record_declaration] = STATE(3272),
    [sym_modifier] = STATE(3780),
    [sym_operator_declaration] = STATE(3272),
    [sym_conversion_operator_declaration] = STATE(3272),
    [sym_declaration] = STATE(3284),
    [sym_field_declaration] = STATE(3272),
    [sym_constructor_declaration] = STATE(3272),
    [sym_destructor_declaration] = STATE(3272),
    [sym_method_declaration] = STATE(3272),
    [sym_event_declaration] = STATE(3272),
    [sym_event_field_declaration] = STATE(3272),
    [sym_indexer_declaration] = STATE(3272),
    [sym_property_declaration] = STATE(3272),
    [sym_variable_declaration] = STATE(9222),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(6306),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_identifier] = STATE(6719),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_if] = STATE(3272),
    [sym_preproc_region] = STATE(2510),
    [sym_preproc_endregion] = STATE(2510),
    [sym_preproc_line] = STATE(2510),
    [sym_preproc_pragma] = STATE(2510),
    [sym_preproc_nullable] = STATE(2510),
    [sym_preproc_error] = STATE(2510),
    [sym_preproc_define] = STATE(2510),
    [sym_preproc_undef] = STATE(2510),
    [aux_sym_class_declaration_repeat1] = STATE(2782),
    [aux_sym_class_declaration_repeat2] = STATE(2834),
    [aux_sym_declaration_list_repeat1] = STATE(2632),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_extern] = ACTIONS(2985),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2989),
    [anon_sym_using] = ACTIONS(2991),
    [anon_sym_unsafe] = ACTIONS(63),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_LBRACK] = ACTIONS(2993),
    [anon_sym_LPAREN] = ACTIONS(2995),
    [anon_sym_event] = ACTIONS(2997),
    [anon_sym_namespace] = ACTIONS(2999),
    [anon_sym_class] = ACTIONS(3001),
    [anon_sym_ref] = ACTIONS(3003),
    [anon_sym_struct] = ACTIONS(3005),
    [anon_sym_enum] = ACTIONS(3007),
    [anon_sym_RBRACE] = ACTIONS(3950),
    [anon_sym_interface] = ACTIONS(3009),
    [anon_sym_delegate] = ACTIONS(3011),
    [anon_sym_record] = ACTIONS(3013),
    [anon_sym_abstract] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_file] = ACTIONS(3015),
    [anon_sym_fixed] = ACTIONS(63),
    [anon_sym_internal] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(63),
    [anon_sym_override] = ACTIONS(63),
    [anon_sym_partial] = ACTIONS(63),
    [anon_sym_private] = ACTIONS(63),
    [anon_sym_protected] = ACTIONS(63),
    [anon_sym_public] = ACTIONS(63),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_required] = ACTIONS(63),
    [anon_sym_sealed] = ACTIONS(63),
    [anon_sym_virtual] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_TILDE] = ACTIONS(3017),
    [anon_sym_implicit] = ACTIONS(3019),
    [anon_sym_explicit] = ACTIONS(3019),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_if_token1] = ACTIONS(3027),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2511] = {
    [sym_preproc_region] = STATE(2511),
    [sym_preproc_endregion] = STATE(2511),
    [sym_preproc_line] = STATE(2511),
    [sym_preproc_pragma] = STATE(2511),
    [sym_preproc_nullable] = STATE(2511),
    [sym_preproc_error] = STATE(2511),
    [sym_preproc_define] = STATE(2511),
    [sym_preproc_undef] = STATE(2511),
    [ts_builtin_sym_end] = ACTIONS(3523),
    [sym__identifier_token] = ACTIONS(3521),
    [anon_sym_extern] = ACTIONS(3521),
    [anon_sym_alias] = ACTIONS(3521),
    [anon_sym_SEMI] = ACTIONS(3523),
    [anon_sym_global] = ACTIONS(3521),
    [anon_sym_using] = ACTIONS(3521),
    [anon_sym_unsafe] = ACTIONS(3521),
    [anon_sym_static] = ACTIONS(3521),
    [anon_sym_LBRACK] = ACTIONS(3523),
    [anon_sym_LPAREN] = ACTIONS(3523),
    [anon_sym_return] = ACTIONS(3521),
    [anon_sym_namespace] = ACTIONS(3521),
    [anon_sym_class] = ACTIONS(3521),
    [anon_sym_ref] = ACTIONS(3521),
    [anon_sym_struct] = ACTIONS(3521),
    [anon_sym_enum] = ACTIONS(3521),
    [anon_sym_LBRACE] = ACTIONS(3523),
    [anon_sym_interface] = ACTIONS(3521),
    [anon_sym_delegate] = ACTIONS(3521),
    [anon_sym_record] = ACTIONS(3521),
    [anon_sym_abstract] = ACTIONS(3521),
    [anon_sym_async] = ACTIONS(3521),
    [anon_sym_const] = ACTIONS(3521),
    [anon_sym_file] = ACTIONS(3521),
    [anon_sym_fixed] = ACTIONS(3521),
    [anon_sym_internal] = ACTIONS(3521),
    [anon_sym_new] = ACTIONS(3521),
    [anon_sym_override] = ACTIONS(3521),
    [anon_sym_partial] = ACTIONS(3521),
    [anon_sym_private] = ACTIONS(3521),
    [anon_sym_protected] = ACTIONS(3521),
    [anon_sym_public] = ACTIONS(3521),
    [anon_sym_readonly] = ACTIONS(3521),
    [anon_sym_required] = ACTIONS(3521),
    [anon_sym_sealed] = ACTIONS(3521),
    [anon_sym_virtual] = ACTIONS(3521),
    [anon_sym_volatile] = ACTIONS(3521),
    [anon_sym_where] = ACTIONS(3521),
    [anon_sym_notnull] = ACTIONS(3521),
    [anon_sym_unmanaged] = ACTIONS(3521),
    [anon_sym_checked] = ACTIONS(3521),
    [anon_sym_BANG] = ACTIONS(3523),
    [anon_sym_TILDE] = ACTIONS(3523),
    [anon_sym_PLUS_PLUS] = ACTIONS(3523),
    [anon_sym_DASH_DASH] = ACTIONS(3523),
    [anon_sym_true] = ACTIONS(3521),
    [anon_sym_false] = ACTIONS(3521),
    [anon_sym_PLUS] = ACTIONS(3521),
    [anon_sym_DASH] = ACTIONS(3521),
    [anon_sym_STAR] = ACTIONS(3523),
    [anon_sym_CARET] = ACTIONS(3523),
    [anon_sym_AMP] = ACTIONS(3523),
    [anon_sym_this] = ACTIONS(3521),
    [anon_sym_scoped] = ACTIONS(3521),
    [anon_sym_var] = ACTIONS(3521),
    [sym_predefined_type] = ACTIONS(3521),
    [anon_sym_break] = ACTIONS(3521),
    [anon_sym_unchecked] = ACTIONS(3521),
    [anon_sym_continue] = ACTIONS(3521),
    [anon_sym_do] = ACTIONS(3521),
    [anon_sym_while] = ACTIONS(3521),
    [anon_sym_for] = ACTIONS(3521),
    [anon_sym_lock] = ACTIONS(3521),
    [anon_sym_yield] = ACTIONS(3521),
    [anon_sym_switch] = ACTIONS(3521),
    [anon_sym_default] = ACTIONS(3521),
    [anon_sym_throw] = ACTIONS(3521),
    [anon_sym_try] = ACTIONS(3521),
    [anon_sym_when] = ACTIONS(3521),
    [anon_sym_await] = ACTIONS(3521),
    [anon_sym_foreach] = ACTIONS(3521),
    [anon_sym_goto] = ACTIONS(3521),
    [anon_sym_if] = ACTIONS(3521),
    [anon_sym_DOT_DOT] = ACTIONS(3523),
    [anon_sym_from] = ACTIONS(3521),
    [anon_sym_into] = ACTIONS(3521),
    [anon_sym_join] = ACTIONS(3521),
    [anon_sym_on] = ACTIONS(3521),
    [anon_sym_equals] = ACTIONS(3521),
    [anon_sym_let] = ACTIONS(3521),
    [anon_sym_orderby] = ACTIONS(3521),
    [anon_sym_ascending] = ACTIONS(3521),
    [anon_sym_descending] = ACTIONS(3521),
    [anon_sym_group] = ACTIONS(3521),
    [anon_sym_by] = ACTIONS(3521),
    [anon_sym_select] = ACTIONS(3521),
    [anon_sym_DQUOTE] = ACTIONS(3521),
    [anon_sym_stackalloc] = ACTIONS(3521),
    [anon_sym_sizeof] = ACTIONS(3521),
    [anon_sym_typeof] = ACTIONS(3521),
    [anon_sym___makeref] = ACTIONS(3521),
    [anon_sym___reftype] = ACTIONS(3521),
    [anon_sym___refvalue] = ACTIONS(3521),
    [sym_null_literal] = ACTIONS(3521),
    [anon_sym_SQUOTE] = ACTIONS(3523),
    [sym_integer_literal] = ACTIONS(3521),
    [sym_real_literal] = ACTIONS(3523),
    [sym_verbatim_string_literal] = ACTIONS(3523),
    [sym_raw_string_literal] = ACTIONS(3523),
    [aux_sym_preproc_if_token1] = ACTIONS(3523),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3523),
    [sym_interpolation_verbatim_start] = ACTIONS(3523),
    [sym_interpolation_raw_start] = ACTIONS(3523),
  },
  [2512] = {
    [sym_preproc_region] = STATE(2512),
    [sym_preproc_endregion] = STATE(2512),
    [sym_preproc_line] = STATE(2512),
    [sym_preproc_pragma] = STATE(2512),
    [sym_preproc_nullable] = STATE(2512),
    [sym_preproc_error] = STATE(2512),
    [sym_preproc_define] = STATE(2512),
    [sym_preproc_undef] = STATE(2512),
    [ts_builtin_sym_end] = ACTIONS(3487),
    [sym__identifier_token] = ACTIONS(3485),
    [anon_sym_extern] = ACTIONS(3485),
    [anon_sym_alias] = ACTIONS(3485),
    [anon_sym_SEMI] = ACTIONS(3487),
    [anon_sym_global] = ACTIONS(3485),
    [anon_sym_using] = ACTIONS(3485),
    [anon_sym_unsafe] = ACTIONS(3485),
    [anon_sym_static] = ACTIONS(3485),
    [anon_sym_LBRACK] = ACTIONS(3487),
    [anon_sym_LPAREN] = ACTIONS(3487),
    [anon_sym_return] = ACTIONS(3485),
    [anon_sym_namespace] = ACTIONS(3485),
    [anon_sym_class] = ACTIONS(3485),
    [anon_sym_ref] = ACTIONS(3485),
    [anon_sym_struct] = ACTIONS(3485),
    [anon_sym_enum] = ACTIONS(3485),
    [anon_sym_LBRACE] = ACTIONS(3487),
    [anon_sym_interface] = ACTIONS(3485),
    [anon_sym_delegate] = ACTIONS(3485),
    [anon_sym_record] = ACTIONS(3485),
    [anon_sym_abstract] = ACTIONS(3485),
    [anon_sym_async] = ACTIONS(3485),
    [anon_sym_const] = ACTIONS(3485),
    [anon_sym_file] = ACTIONS(3485),
    [anon_sym_fixed] = ACTIONS(3485),
    [anon_sym_internal] = ACTIONS(3485),
    [anon_sym_new] = ACTIONS(3485),
    [anon_sym_override] = ACTIONS(3485),
    [anon_sym_partial] = ACTIONS(3485),
    [anon_sym_private] = ACTIONS(3485),
    [anon_sym_protected] = ACTIONS(3485),
    [anon_sym_public] = ACTIONS(3485),
    [anon_sym_readonly] = ACTIONS(3485),
    [anon_sym_required] = ACTIONS(3485),
    [anon_sym_sealed] = ACTIONS(3485),
    [anon_sym_virtual] = ACTIONS(3485),
    [anon_sym_volatile] = ACTIONS(3485),
    [anon_sym_where] = ACTIONS(3485),
    [anon_sym_notnull] = ACTIONS(3485),
    [anon_sym_unmanaged] = ACTIONS(3485),
    [anon_sym_checked] = ACTIONS(3485),
    [anon_sym_BANG] = ACTIONS(3487),
    [anon_sym_TILDE] = ACTIONS(3487),
    [anon_sym_PLUS_PLUS] = ACTIONS(3487),
    [anon_sym_DASH_DASH] = ACTIONS(3487),
    [anon_sym_true] = ACTIONS(3485),
    [anon_sym_false] = ACTIONS(3485),
    [anon_sym_PLUS] = ACTIONS(3485),
    [anon_sym_DASH] = ACTIONS(3485),
    [anon_sym_STAR] = ACTIONS(3487),
    [anon_sym_CARET] = ACTIONS(3487),
    [anon_sym_AMP] = ACTIONS(3487),
    [anon_sym_this] = ACTIONS(3485),
    [anon_sym_scoped] = ACTIONS(3485),
    [anon_sym_var] = ACTIONS(3485),
    [sym_predefined_type] = ACTIONS(3485),
    [anon_sym_break] = ACTIONS(3485),
    [anon_sym_unchecked] = ACTIONS(3485),
    [anon_sym_continue] = ACTIONS(3485),
    [anon_sym_do] = ACTIONS(3485),
    [anon_sym_while] = ACTIONS(3485),
    [anon_sym_for] = ACTIONS(3485),
    [anon_sym_lock] = ACTIONS(3485),
    [anon_sym_yield] = ACTIONS(3485),
    [anon_sym_switch] = ACTIONS(3485),
    [anon_sym_default] = ACTIONS(3485),
    [anon_sym_throw] = ACTIONS(3485),
    [anon_sym_try] = ACTIONS(3485),
    [anon_sym_when] = ACTIONS(3485),
    [anon_sym_await] = ACTIONS(3485),
    [anon_sym_foreach] = ACTIONS(3485),
    [anon_sym_goto] = ACTIONS(3485),
    [anon_sym_if] = ACTIONS(3485),
    [anon_sym_DOT_DOT] = ACTIONS(3487),
    [anon_sym_from] = ACTIONS(3485),
    [anon_sym_into] = ACTIONS(3485),
    [anon_sym_join] = ACTIONS(3485),
    [anon_sym_on] = ACTIONS(3485),
    [anon_sym_equals] = ACTIONS(3485),
    [anon_sym_let] = ACTIONS(3485),
    [anon_sym_orderby] = ACTIONS(3485),
    [anon_sym_ascending] = ACTIONS(3485),
    [anon_sym_descending] = ACTIONS(3485),
    [anon_sym_group] = ACTIONS(3485),
    [anon_sym_by] = ACTIONS(3485),
    [anon_sym_select] = ACTIONS(3485),
    [anon_sym_DQUOTE] = ACTIONS(3485),
    [anon_sym_stackalloc] = ACTIONS(3485),
    [anon_sym_sizeof] = ACTIONS(3485),
    [anon_sym_typeof] = ACTIONS(3485),
    [anon_sym___makeref] = ACTIONS(3485),
    [anon_sym___reftype] = ACTIONS(3485),
    [anon_sym___refvalue] = ACTIONS(3485),
    [sym_null_literal] = ACTIONS(3485),
    [anon_sym_SQUOTE] = ACTIONS(3487),
    [sym_integer_literal] = ACTIONS(3485),
    [sym_real_literal] = ACTIONS(3487),
    [sym_verbatim_string_literal] = ACTIONS(3487),
    [sym_raw_string_literal] = ACTIONS(3487),
    [aux_sym_preproc_if_token1] = ACTIONS(3487),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3487),
    [sym_interpolation_verbatim_start] = ACTIONS(3487),
    [sym_interpolation_raw_start] = ACTIONS(3487),
  },
  [2513] = {
    [sym_preproc_region] = STATE(2513),
    [sym_preproc_endregion] = STATE(2513),
    [sym_preproc_line] = STATE(2513),
    [sym_preproc_pragma] = STATE(2513),
    [sym_preproc_nullable] = STATE(2513),
    [sym_preproc_error] = STATE(2513),
    [sym_preproc_define] = STATE(2513),
    [sym_preproc_undef] = STATE(2513),
    [ts_builtin_sym_end] = ACTIONS(3483),
    [sym__identifier_token] = ACTIONS(3481),
    [anon_sym_extern] = ACTIONS(3481),
    [anon_sym_alias] = ACTIONS(3481),
    [anon_sym_SEMI] = ACTIONS(3483),
    [anon_sym_global] = ACTIONS(3481),
    [anon_sym_using] = ACTIONS(3481),
    [anon_sym_unsafe] = ACTIONS(3481),
    [anon_sym_static] = ACTIONS(3481),
    [anon_sym_LBRACK] = ACTIONS(3483),
    [anon_sym_LPAREN] = ACTIONS(3483),
    [anon_sym_return] = ACTIONS(3481),
    [anon_sym_namespace] = ACTIONS(3481),
    [anon_sym_class] = ACTIONS(3481),
    [anon_sym_ref] = ACTIONS(3481),
    [anon_sym_struct] = ACTIONS(3481),
    [anon_sym_enum] = ACTIONS(3481),
    [anon_sym_LBRACE] = ACTIONS(3483),
    [anon_sym_interface] = ACTIONS(3481),
    [anon_sym_delegate] = ACTIONS(3481),
    [anon_sym_record] = ACTIONS(3481),
    [anon_sym_abstract] = ACTIONS(3481),
    [anon_sym_async] = ACTIONS(3481),
    [anon_sym_const] = ACTIONS(3481),
    [anon_sym_file] = ACTIONS(3481),
    [anon_sym_fixed] = ACTIONS(3481),
    [anon_sym_internal] = ACTIONS(3481),
    [anon_sym_new] = ACTIONS(3481),
    [anon_sym_override] = ACTIONS(3481),
    [anon_sym_partial] = ACTIONS(3481),
    [anon_sym_private] = ACTIONS(3481),
    [anon_sym_protected] = ACTIONS(3481),
    [anon_sym_public] = ACTIONS(3481),
    [anon_sym_readonly] = ACTIONS(3481),
    [anon_sym_required] = ACTIONS(3481),
    [anon_sym_sealed] = ACTIONS(3481),
    [anon_sym_virtual] = ACTIONS(3481),
    [anon_sym_volatile] = ACTIONS(3481),
    [anon_sym_where] = ACTIONS(3481),
    [anon_sym_notnull] = ACTIONS(3481),
    [anon_sym_unmanaged] = ACTIONS(3481),
    [anon_sym_checked] = ACTIONS(3481),
    [anon_sym_BANG] = ACTIONS(3483),
    [anon_sym_TILDE] = ACTIONS(3483),
    [anon_sym_PLUS_PLUS] = ACTIONS(3483),
    [anon_sym_DASH_DASH] = ACTIONS(3483),
    [anon_sym_true] = ACTIONS(3481),
    [anon_sym_false] = ACTIONS(3481),
    [anon_sym_PLUS] = ACTIONS(3481),
    [anon_sym_DASH] = ACTIONS(3481),
    [anon_sym_STAR] = ACTIONS(3483),
    [anon_sym_CARET] = ACTIONS(3483),
    [anon_sym_AMP] = ACTIONS(3483),
    [anon_sym_this] = ACTIONS(3481),
    [anon_sym_scoped] = ACTIONS(3481),
    [anon_sym_var] = ACTIONS(3481),
    [sym_predefined_type] = ACTIONS(3481),
    [anon_sym_break] = ACTIONS(3481),
    [anon_sym_unchecked] = ACTIONS(3481),
    [anon_sym_continue] = ACTIONS(3481),
    [anon_sym_do] = ACTIONS(3481),
    [anon_sym_while] = ACTIONS(3481),
    [anon_sym_for] = ACTIONS(3481),
    [anon_sym_lock] = ACTIONS(3481),
    [anon_sym_yield] = ACTIONS(3481),
    [anon_sym_switch] = ACTIONS(3481),
    [anon_sym_default] = ACTIONS(3481),
    [anon_sym_throw] = ACTIONS(3481),
    [anon_sym_try] = ACTIONS(3481),
    [anon_sym_when] = ACTIONS(3481),
    [anon_sym_await] = ACTIONS(3481),
    [anon_sym_foreach] = ACTIONS(3481),
    [anon_sym_goto] = ACTIONS(3481),
    [anon_sym_if] = ACTIONS(3481),
    [anon_sym_DOT_DOT] = ACTIONS(3483),
    [anon_sym_from] = ACTIONS(3481),
    [anon_sym_into] = ACTIONS(3481),
    [anon_sym_join] = ACTIONS(3481),
    [anon_sym_on] = ACTIONS(3481),
    [anon_sym_equals] = ACTIONS(3481),
    [anon_sym_let] = ACTIONS(3481),
    [anon_sym_orderby] = ACTIONS(3481),
    [anon_sym_ascending] = ACTIONS(3481),
    [anon_sym_descending] = ACTIONS(3481),
    [anon_sym_group] = ACTIONS(3481),
    [anon_sym_by] = ACTIONS(3481),
    [anon_sym_select] = ACTIONS(3481),
    [anon_sym_DQUOTE] = ACTIONS(3481),
    [anon_sym_stackalloc] = ACTIONS(3481),
    [anon_sym_sizeof] = ACTIONS(3481),
    [anon_sym_typeof] = ACTIONS(3481),
    [anon_sym___makeref] = ACTIONS(3481),
    [anon_sym___reftype] = ACTIONS(3481),
    [anon_sym___refvalue] = ACTIONS(3481),
    [sym_null_literal] = ACTIONS(3481),
    [anon_sym_SQUOTE] = ACTIONS(3483),
    [sym_integer_literal] = ACTIONS(3481),
    [sym_real_literal] = ACTIONS(3483),
    [sym_verbatim_string_literal] = ACTIONS(3483),
    [sym_raw_string_literal] = ACTIONS(3483),
    [aux_sym_preproc_if_token1] = ACTIONS(3483),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3483),
    [sym_interpolation_verbatim_start] = ACTIONS(3483),
    [sym_interpolation_raw_start] = ACTIONS(3483),
  },
  [2514] = {
    [sym_preproc_region] = STATE(2514),
    [sym_preproc_endregion] = STATE(2514),
    [sym_preproc_line] = STATE(2514),
    [sym_preproc_pragma] = STATE(2514),
    [sym_preproc_nullable] = STATE(2514),
    [sym_preproc_error] = STATE(2514),
    [sym_preproc_define] = STATE(2514),
    [sym_preproc_undef] = STATE(2514),
    [ts_builtin_sym_end] = ACTIONS(3479),
    [sym__identifier_token] = ACTIONS(3477),
    [anon_sym_extern] = ACTIONS(3477),
    [anon_sym_alias] = ACTIONS(3477),
    [anon_sym_SEMI] = ACTIONS(3479),
    [anon_sym_global] = ACTIONS(3477),
    [anon_sym_using] = ACTIONS(3477),
    [anon_sym_unsafe] = ACTIONS(3477),
    [anon_sym_static] = ACTIONS(3477),
    [anon_sym_LBRACK] = ACTIONS(3479),
    [anon_sym_LPAREN] = ACTIONS(3479),
    [anon_sym_return] = ACTIONS(3477),
    [anon_sym_namespace] = ACTIONS(3477),
    [anon_sym_class] = ACTIONS(3477),
    [anon_sym_ref] = ACTIONS(3477),
    [anon_sym_struct] = ACTIONS(3477),
    [anon_sym_enum] = ACTIONS(3477),
    [anon_sym_LBRACE] = ACTIONS(3479),
    [anon_sym_interface] = ACTIONS(3477),
    [anon_sym_delegate] = ACTIONS(3477),
    [anon_sym_record] = ACTIONS(3477),
    [anon_sym_abstract] = ACTIONS(3477),
    [anon_sym_async] = ACTIONS(3477),
    [anon_sym_const] = ACTIONS(3477),
    [anon_sym_file] = ACTIONS(3477),
    [anon_sym_fixed] = ACTIONS(3477),
    [anon_sym_internal] = ACTIONS(3477),
    [anon_sym_new] = ACTIONS(3477),
    [anon_sym_override] = ACTIONS(3477),
    [anon_sym_partial] = ACTIONS(3477),
    [anon_sym_private] = ACTIONS(3477),
    [anon_sym_protected] = ACTIONS(3477),
    [anon_sym_public] = ACTIONS(3477),
    [anon_sym_readonly] = ACTIONS(3477),
    [anon_sym_required] = ACTIONS(3477),
    [anon_sym_sealed] = ACTIONS(3477),
    [anon_sym_virtual] = ACTIONS(3477),
    [anon_sym_volatile] = ACTIONS(3477),
    [anon_sym_where] = ACTIONS(3477),
    [anon_sym_notnull] = ACTIONS(3477),
    [anon_sym_unmanaged] = ACTIONS(3477),
    [anon_sym_checked] = ACTIONS(3477),
    [anon_sym_BANG] = ACTIONS(3479),
    [anon_sym_TILDE] = ACTIONS(3479),
    [anon_sym_PLUS_PLUS] = ACTIONS(3479),
    [anon_sym_DASH_DASH] = ACTIONS(3479),
    [anon_sym_true] = ACTIONS(3477),
    [anon_sym_false] = ACTIONS(3477),
    [anon_sym_PLUS] = ACTIONS(3477),
    [anon_sym_DASH] = ACTIONS(3477),
    [anon_sym_STAR] = ACTIONS(3479),
    [anon_sym_CARET] = ACTIONS(3479),
    [anon_sym_AMP] = ACTIONS(3479),
    [anon_sym_this] = ACTIONS(3477),
    [anon_sym_scoped] = ACTIONS(3477),
    [anon_sym_var] = ACTIONS(3477),
    [sym_predefined_type] = ACTIONS(3477),
    [anon_sym_break] = ACTIONS(3477),
    [anon_sym_unchecked] = ACTIONS(3477),
    [anon_sym_continue] = ACTIONS(3477),
    [anon_sym_do] = ACTIONS(3477),
    [anon_sym_while] = ACTIONS(3477),
    [anon_sym_for] = ACTIONS(3477),
    [anon_sym_lock] = ACTIONS(3477),
    [anon_sym_yield] = ACTIONS(3477),
    [anon_sym_switch] = ACTIONS(3477),
    [anon_sym_default] = ACTIONS(3477),
    [anon_sym_throw] = ACTIONS(3477),
    [anon_sym_try] = ACTIONS(3477),
    [anon_sym_when] = ACTIONS(3477),
    [anon_sym_await] = ACTIONS(3477),
    [anon_sym_foreach] = ACTIONS(3477),
    [anon_sym_goto] = ACTIONS(3477),
    [anon_sym_if] = ACTIONS(3477),
    [anon_sym_DOT_DOT] = ACTIONS(3479),
    [anon_sym_from] = ACTIONS(3477),
    [anon_sym_into] = ACTIONS(3477),
    [anon_sym_join] = ACTIONS(3477),
    [anon_sym_on] = ACTIONS(3477),
    [anon_sym_equals] = ACTIONS(3477),
    [anon_sym_let] = ACTIONS(3477),
    [anon_sym_orderby] = ACTIONS(3477),
    [anon_sym_ascending] = ACTIONS(3477),
    [anon_sym_descending] = ACTIONS(3477),
    [anon_sym_group] = ACTIONS(3477),
    [anon_sym_by] = ACTIONS(3477),
    [anon_sym_select] = ACTIONS(3477),
    [anon_sym_DQUOTE] = ACTIONS(3477),
    [anon_sym_stackalloc] = ACTIONS(3477),
    [anon_sym_sizeof] = ACTIONS(3477),
    [anon_sym_typeof] = ACTIONS(3477),
    [anon_sym___makeref] = ACTIONS(3477),
    [anon_sym___reftype] = ACTIONS(3477),
    [anon_sym___refvalue] = ACTIONS(3477),
    [sym_null_literal] = ACTIONS(3477),
    [anon_sym_SQUOTE] = ACTIONS(3479),
    [sym_integer_literal] = ACTIONS(3477),
    [sym_real_literal] = ACTIONS(3479),
    [sym_verbatim_string_literal] = ACTIONS(3479),
    [sym_raw_string_literal] = ACTIONS(3479),
    [aux_sym_preproc_if_token1] = ACTIONS(3479),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3479),
    [sym_interpolation_verbatim_start] = ACTIONS(3479),
    [sym_interpolation_raw_start] = ACTIONS(3479),
  },
  [2515] = {
    [sym_preproc_region] = STATE(2515),
    [sym_preproc_endregion] = STATE(2515),
    [sym_preproc_line] = STATE(2515),
    [sym_preproc_pragma] = STATE(2515),
    [sym_preproc_nullable] = STATE(2515),
    [sym_preproc_error] = STATE(2515),
    [sym_preproc_define] = STATE(2515),
    [sym_preproc_undef] = STATE(2515),
    [ts_builtin_sym_end] = ACTIONS(3882),
    [sym__identifier_token] = ACTIONS(3880),
    [anon_sym_extern] = ACTIONS(3880),
    [anon_sym_alias] = ACTIONS(3880),
    [anon_sym_SEMI] = ACTIONS(3882),
    [anon_sym_global] = ACTIONS(3880),
    [anon_sym_using] = ACTIONS(3880),
    [anon_sym_unsafe] = ACTIONS(3880),
    [anon_sym_static] = ACTIONS(3880),
    [anon_sym_LBRACK] = ACTIONS(3882),
    [anon_sym_LPAREN] = ACTIONS(3882),
    [anon_sym_return] = ACTIONS(3880),
    [anon_sym_namespace] = ACTIONS(3880),
    [anon_sym_class] = ACTIONS(3880),
    [anon_sym_ref] = ACTIONS(3880),
    [anon_sym_struct] = ACTIONS(3880),
    [anon_sym_enum] = ACTIONS(3880),
    [anon_sym_LBRACE] = ACTIONS(3882),
    [anon_sym_interface] = ACTIONS(3880),
    [anon_sym_delegate] = ACTIONS(3880),
    [anon_sym_record] = ACTIONS(3880),
    [anon_sym_abstract] = ACTIONS(3880),
    [anon_sym_async] = ACTIONS(3880),
    [anon_sym_const] = ACTIONS(3880),
    [anon_sym_file] = ACTIONS(3880),
    [anon_sym_fixed] = ACTIONS(3880),
    [anon_sym_internal] = ACTIONS(3880),
    [anon_sym_new] = ACTIONS(3880),
    [anon_sym_override] = ACTIONS(3880),
    [anon_sym_partial] = ACTIONS(3880),
    [anon_sym_private] = ACTIONS(3880),
    [anon_sym_protected] = ACTIONS(3880),
    [anon_sym_public] = ACTIONS(3880),
    [anon_sym_readonly] = ACTIONS(3880),
    [anon_sym_required] = ACTIONS(3880),
    [anon_sym_sealed] = ACTIONS(3880),
    [anon_sym_virtual] = ACTIONS(3880),
    [anon_sym_volatile] = ACTIONS(3880),
    [anon_sym_where] = ACTIONS(3880),
    [anon_sym_notnull] = ACTIONS(3880),
    [anon_sym_unmanaged] = ACTIONS(3880),
    [anon_sym_checked] = ACTIONS(3880),
    [anon_sym_BANG] = ACTIONS(3882),
    [anon_sym_TILDE] = ACTIONS(3882),
    [anon_sym_PLUS_PLUS] = ACTIONS(3882),
    [anon_sym_DASH_DASH] = ACTIONS(3882),
    [anon_sym_true] = ACTIONS(3880),
    [anon_sym_false] = ACTIONS(3880),
    [anon_sym_PLUS] = ACTIONS(3880),
    [anon_sym_DASH] = ACTIONS(3880),
    [anon_sym_STAR] = ACTIONS(3882),
    [anon_sym_CARET] = ACTIONS(3882),
    [anon_sym_AMP] = ACTIONS(3882),
    [anon_sym_this] = ACTIONS(3880),
    [anon_sym_scoped] = ACTIONS(3880),
    [anon_sym_var] = ACTIONS(3880),
    [sym_predefined_type] = ACTIONS(3880),
    [anon_sym_break] = ACTIONS(3880),
    [anon_sym_unchecked] = ACTIONS(3880),
    [anon_sym_continue] = ACTIONS(3880),
    [anon_sym_do] = ACTIONS(3880),
    [anon_sym_while] = ACTIONS(3880),
    [anon_sym_for] = ACTIONS(3880),
    [anon_sym_lock] = ACTIONS(3880),
    [anon_sym_yield] = ACTIONS(3880),
    [anon_sym_switch] = ACTIONS(3880),
    [anon_sym_default] = ACTIONS(3880),
    [anon_sym_throw] = ACTIONS(3880),
    [anon_sym_try] = ACTIONS(3880),
    [anon_sym_when] = ACTIONS(3880),
    [anon_sym_await] = ACTIONS(3880),
    [anon_sym_foreach] = ACTIONS(3880),
    [anon_sym_goto] = ACTIONS(3880),
    [anon_sym_if] = ACTIONS(3880),
    [anon_sym_DOT_DOT] = ACTIONS(3882),
    [anon_sym_from] = ACTIONS(3880),
    [anon_sym_into] = ACTIONS(3880),
    [anon_sym_join] = ACTIONS(3880),
    [anon_sym_on] = ACTIONS(3880),
    [anon_sym_equals] = ACTIONS(3880),
    [anon_sym_let] = ACTIONS(3880),
    [anon_sym_orderby] = ACTIONS(3880),
    [anon_sym_ascending] = ACTIONS(3880),
    [anon_sym_descending] = ACTIONS(3880),
    [anon_sym_group] = ACTIONS(3880),
    [anon_sym_by] = ACTIONS(3880),
    [anon_sym_select] = ACTIONS(3880),
    [anon_sym_DQUOTE] = ACTIONS(3880),
    [anon_sym_stackalloc] = ACTIONS(3880),
    [anon_sym_sizeof] = ACTIONS(3880),
    [anon_sym_typeof] = ACTIONS(3880),
    [anon_sym___makeref] = ACTIONS(3880),
    [anon_sym___reftype] = ACTIONS(3880),
    [anon_sym___refvalue] = ACTIONS(3880),
    [sym_null_literal] = ACTIONS(3880),
    [anon_sym_SQUOTE] = ACTIONS(3882),
    [sym_integer_literal] = ACTIONS(3880),
    [sym_real_literal] = ACTIONS(3882),
    [sym_verbatim_string_literal] = ACTIONS(3882),
    [sym_raw_string_literal] = ACTIONS(3882),
    [aux_sym_preproc_if_token1] = ACTIONS(3882),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3882),
    [sym_interpolation_verbatim_start] = ACTIONS(3882),
    [sym_interpolation_raw_start] = ACTIONS(3882),
  },
  [2516] = {
    [sym_preproc_region] = STATE(2516),
    [sym_preproc_endregion] = STATE(2516),
    [sym_preproc_line] = STATE(2516),
    [sym_preproc_pragma] = STATE(2516),
    [sym_preproc_nullable] = STATE(2516),
    [sym_preproc_error] = STATE(2516),
    [sym_preproc_define] = STATE(2516),
    [sym_preproc_undef] = STATE(2516),
    [ts_builtin_sym_end] = ACTIONS(3475),
    [sym__identifier_token] = ACTIONS(3473),
    [anon_sym_extern] = ACTIONS(3473),
    [anon_sym_alias] = ACTIONS(3473),
    [anon_sym_SEMI] = ACTIONS(3475),
    [anon_sym_global] = ACTIONS(3473),
    [anon_sym_using] = ACTIONS(3473),
    [anon_sym_unsafe] = ACTIONS(3473),
    [anon_sym_static] = ACTIONS(3473),
    [anon_sym_LBRACK] = ACTIONS(3475),
    [anon_sym_LPAREN] = ACTIONS(3475),
    [anon_sym_return] = ACTIONS(3473),
    [anon_sym_namespace] = ACTIONS(3473),
    [anon_sym_class] = ACTIONS(3473),
    [anon_sym_ref] = ACTIONS(3473),
    [anon_sym_struct] = ACTIONS(3473),
    [anon_sym_enum] = ACTIONS(3473),
    [anon_sym_LBRACE] = ACTIONS(3475),
    [anon_sym_interface] = ACTIONS(3473),
    [anon_sym_delegate] = ACTIONS(3473),
    [anon_sym_record] = ACTIONS(3473),
    [anon_sym_abstract] = ACTIONS(3473),
    [anon_sym_async] = ACTIONS(3473),
    [anon_sym_const] = ACTIONS(3473),
    [anon_sym_file] = ACTIONS(3473),
    [anon_sym_fixed] = ACTIONS(3473),
    [anon_sym_internal] = ACTIONS(3473),
    [anon_sym_new] = ACTIONS(3473),
    [anon_sym_override] = ACTIONS(3473),
    [anon_sym_partial] = ACTIONS(3473),
    [anon_sym_private] = ACTIONS(3473),
    [anon_sym_protected] = ACTIONS(3473),
    [anon_sym_public] = ACTIONS(3473),
    [anon_sym_readonly] = ACTIONS(3473),
    [anon_sym_required] = ACTIONS(3473),
    [anon_sym_sealed] = ACTIONS(3473),
    [anon_sym_virtual] = ACTIONS(3473),
    [anon_sym_volatile] = ACTIONS(3473),
    [anon_sym_where] = ACTIONS(3473),
    [anon_sym_notnull] = ACTIONS(3473),
    [anon_sym_unmanaged] = ACTIONS(3473),
    [anon_sym_checked] = ACTIONS(3473),
    [anon_sym_BANG] = ACTIONS(3475),
    [anon_sym_TILDE] = ACTIONS(3475),
    [anon_sym_PLUS_PLUS] = ACTIONS(3475),
    [anon_sym_DASH_DASH] = ACTIONS(3475),
    [anon_sym_true] = ACTIONS(3473),
    [anon_sym_false] = ACTIONS(3473),
    [anon_sym_PLUS] = ACTIONS(3473),
    [anon_sym_DASH] = ACTIONS(3473),
    [anon_sym_STAR] = ACTIONS(3475),
    [anon_sym_CARET] = ACTIONS(3475),
    [anon_sym_AMP] = ACTIONS(3475),
    [anon_sym_this] = ACTIONS(3473),
    [anon_sym_scoped] = ACTIONS(3473),
    [anon_sym_var] = ACTIONS(3473),
    [sym_predefined_type] = ACTIONS(3473),
    [anon_sym_break] = ACTIONS(3473),
    [anon_sym_unchecked] = ACTIONS(3473),
    [anon_sym_continue] = ACTIONS(3473),
    [anon_sym_do] = ACTIONS(3473),
    [anon_sym_while] = ACTIONS(3473),
    [anon_sym_for] = ACTIONS(3473),
    [anon_sym_lock] = ACTIONS(3473),
    [anon_sym_yield] = ACTIONS(3473),
    [anon_sym_switch] = ACTIONS(3473),
    [anon_sym_default] = ACTIONS(3473),
    [anon_sym_throw] = ACTIONS(3473),
    [anon_sym_try] = ACTIONS(3473),
    [anon_sym_when] = ACTIONS(3473),
    [anon_sym_await] = ACTIONS(3473),
    [anon_sym_foreach] = ACTIONS(3473),
    [anon_sym_goto] = ACTIONS(3473),
    [anon_sym_if] = ACTIONS(3473),
    [anon_sym_DOT_DOT] = ACTIONS(3475),
    [anon_sym_from] = ACTIONS(3473),
    [anon_sym_into] = ACTIONS(3473),
    [anon_sym_join] = ACTIONS(3473),
    [anon_sym_on] = ACTIONS(3473),
    [anon_sym_equals] = ACTIONS(3473),
    [anon_sym_let] = ACTIONS(3473),
    [anon_sym_orderby] = ACTIONS(3473),
    [anon_sym_ascending] = ACTIONS(3473),
    [anon_sym_descending] = ACTIONS(3473),
    [anon_sym_group] = ACTIONS(3473),
    [anon_sym_by] = ACTIONS(3473),
    [anon_sym_select] = ACTIONS(3473),
    [anon_sym_DQUOTE] = ACTIONS(3473),
    [anon_sym_stackalloc] = ACTIONS(3473),
    [anon_sym_sizeof] = ACTIONS(3473),
    [anon_sym_typeof] = ACTIONS(3473),
    [anon_sym___makeref] = ACTIONS(3473),
    [anon_sym___reftype] = ACTIONS(3473),
    [anon_sym___refvalue] = ACTIONS(3473),
    [sym_null_literal] = ACTIONS(3473),
    [anon_sym_SQUOTE] = ACTIONS(3475),
    [sym_integer_literal] = ACTIONS(3473),
    [sym_real_literal] = ACTIONS(3475),
    [sym_verbatim_string_literal] = ACTIONS(3475),
    [sym_raw_string_literal] = ACTIONS(3475),
    [aux_sym_preproc_if_token1] = ACTIONS(3475),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3475),
    [sym_interpolation_verbatim_start] = ACTIONS(3475),
    [sym_interpolation_raw_start] = ACTIONS(3475),
  },
  [2517] = {
    [sym_preproc_region] = STATE(2517),
    [sym_preproc_endregion] = STATE(2517),
    [sym_preproc_line] = STATE(2517),
    [sym_preproc_pragma] = STATE(2517),
    [sym_preproc_nullable] = STATE(2517),
    [sym_preproc_error] = STATE(2517),
    [sym_preproc_define] = STATE(2517),
    [sym_preproc_undef] = STATE(2517),
    [ts_builtin_sym_end] = ACTIONS(3886),
    [sym__identifier_token] = ACTIONS(3884),
    [anon_sym_extern] = ACTIONS(3884),
    [anon_sym_alias] = ACTIONS(3884),
    [anon_sym_SEMI] = ACTIONS(3886),
    [anon_sym_global] = ACTIONS(3884),
    [anon_sym_using] = ACTIONS(3884),
    [anon_sym_unsafe] = ACTIONS(3884),
    [anon_sym_static] = ACTIONS(3884),
    [anon_sym_LBRACK] = ACTIONS(3886),
    [anon_sym_LPAREN] = ACTIONS(3886),
    [anon_sym_return] = ACTIONS(3884),
    [anon_sym_namespace] = ACTIONS(3884),
    [anon_sym_class] = ACTIONS(3884),
    [anon_sym_ref] = ACTIONS(3884),
    [anon_sym_struct] = ACTIONS(3884),
    [anon_sym_enum] = ACTIONS(3884),
    [anon_sym_LBRACE] = ACTIONS(3886),
    [anon_sym_interface] = ACTIONS(3884),
    [anon_sym_delegate] = ACTIONS(3884),
    [anon_sym_record] = ACTIONS(3884),
    [anon_sym_abstract] = ACTIONS(3884),
    [anon_sym_async] = ACTIONS(3884),
    [anon_sym_const] = ACTIONS(3884),
    [anon_sym_file] = ACTIONS(3884),
    [anon_sym_fixed] = ACTIONS(3884),
    [anon_sym_internal] = ACTIONS(3884),
    [anon_sym_new] = ACTIONS(3884),
    [anon_sym_override] = ACTIONS(3884),
    [anon_sym_partial] = ACTIONS(3884),
    [anon_sym_private] = ACTIONS(3884),
    [anon_sym_protected] = ACTIONS(3884),
    [anon_sym_public] = ACTIONS(3884),
    [anon_sym_readonly] = ACTIONS(3884),
    [anon_sym_required] = ACTIONS(3884),
    [anon_sym_sealed] = ACTIONS(3884),
    [anon_sym_virtual] = ACTIONS(3884),
    [anon_sym_volatile] = ACTIONS(3884),
    [anon_sym_where] = ACTIONS(3884),
    [anon_sym_notnull] = ACTIONS(3884),
    [anon_sym_unmanaged] = ACTIONS(3884),
    [anon_sym_checked] = ACTIONS(3884),
    [anon_sym_BANG] = ACTIONS(3886),
    [anon_sym_TILDE] = ACTIONS(3886),
    [anon_sym_PLUS_PLUS] = ACTIONS(3886),
    [anon_sym_DASH_DASH] = ACTIONS(3886),
    [anon_sym_true] = ACTIONS(3884),
    [anon_sym_false] = ACTIONS(3884),
    [anon_sym_PLUS] = ACTIONS(3884),
    [anon_sym_DASH] = ACTIONS(3884),
    [anon_sym_STAR] = ACTIONS(3886),
    [anon_sym_CARET] = ACTIONS(3886),
    [anon_sym_AMP] = ACTIONS(3886),
    [anon_sym_this] = ACTIONS(3884),
    [anon_sym_scoped] = ACTIONS(3884),
    [anon_sym_var] = ACTIONS(3884),
    [sym_predefined_type] = ACTIONS(3884),
    [anon_sym_break] = ACTIONS(3884),
    [anon_sym_unchecked] = ACTIONS(3884),
    [anon_sym_continue] = ACTIONS(3884),
    [anon_sym_do] = ACTIONS(3884),
    [anon_sym_while] = ACTIONS(3884),
    [anon_sym_for] = ACTIONS(3884),
    [anon_sym_lock] = ACTIONS(3884),
    [anon_sym_yield] = ACTIONS(3884),
    [anon_sym_switch] = ACTIONS(3884),
    [anon_sym_default] = ACTIONS(3884),
    [anon_sym_throw] = ACTIONS(3884),
    [anon_sym_try] = ACTIONS(3884),
    [anon_sym_when] = ACTIONS(3884),
    [anon_sym_await] = ACTIONS(3884),
    [anon_sym_foreach] = ACTIONS(3884),
    [anon_sym_goto] = ACTIONS(3884),
    [anon_sym_if] = ACTIONS(3884),
    [anon_sym_DOT_DOT] = ACTIONS(3886),
    [anon_sym_from] = ACTIONS(3884),
    [anon_sym_into] = ACTIONS(3884),
    [anon_sym_join] = ACTIONS(3884),
    [anon_sym_on] = ACTIONS(3884),
    [anon_sym_equals] = ACTIONS(3884),
    [anon_sym_let] = ACTIONS(3884),
    [anon_sym_orderby] = ACTIONS(3884),
    [anon_sym_ascending] = ACTIONS(3884),
    [anon_sym_descending] = ACTIONS(3884),
    [anon_sym_group] = ACTIONS(3884),
    [anon_sym_by] = ACTIONS(3884),
    [anon_sym_select] = ACTIONS(3884),
    [anon_sym_DQUOTE] = ACTIONS(3884),
    [anon_sym_stackalloc] = ACTIONS(3884),
    [anon_sym_sizeof] = ACTIONS(3884),
    [anon_sym_typeof] = ACTIONS(3884),
    [anon_sym___makeref] = ACTIONS(3884),
    [anon_sym___reftype] = ACTIONS(3884),
    [anon_sym___refvalue] = ACTIONS(3884),
    [sym_null_literal] = ACTIONS(3884),
    [anon_sym_SQUOTE] = ACTIONS(3886),
    [sym_integer_literal] = ACTIONS(3884),
    [sym_real_literal] = ACTIONS(3886),
    [sym_verbatim_string_literal] = ACTIONS(3886),
    [sym_raw_string_literal] = ACTIONS(3886),
    [aux_sym_preproc_if_token1] = ACTIONS(3886),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3886),
    [sym_interpolation_verbatim_start] = ACTIONS(3886),
    [sym_interpolation_raw_start] = ACTIONS(3886),
  },
  [2518] = {
    [sym_preproc_region] = STATE(2518),
    [sym_preproc_endregion] = STATE(2518),
    [sym_preproc_line] = STATE(2518),
    [sym_preproc_pragma] = STATE(2518),
    [sym_preproc_nullable] = STATE(2518),
    [sym_preproc_error] = STATE(2518),
    [sym_preproc_define] = STATE(2518),
    [sym_preproc_undef] = STATE(2518),
    [ts_builtin_sym_end] = ACTIONS(3471),
    [sym__identifier_token] = ACTIONS(3469),
    [anon_sym_extern] = ACTIONS(3469),
    [anon_sym_alias] = ACTIONS(3469),
    [anon_sym_SEMI] = ACTIONS(3471),
    [anon_sym_global] = ACTIONS(3469),
    [anon_sym_using] = ACTIONS(3469),
    [anon_sym_unsafe] = ACTIONS(3469),
    [anon_sym_static] = ACTIONS(3469),
    [anon_sym_LBRACK] = ACTIONS(3471),
    [anon_sym_LPAREN] = ACTIONS(3471),
    [anon_sym_return] = ACTIONS(3469),
    [anon_sym_namespace] = ACTIONS(3469),
    [anon_sym_class] = ACTIONS(3469),
    [anon_sym_ref] = ACTIONS(3469),
    [anon_sym_struct] = ACTIONS(3469),
    [anon_sym_enum] = ACTIONS(3469),
    [anon_sym_LBRACE] = ACTIONS(3471),
    [anon_sym_interface] = ACTIONS(3469),
    [anon_sym_delegate] = ACTIONS(3469),
    [anon_sym_record] = ACTIONS(3469),
    [anon_sym_abstract] = ACTIONS(3469),
    [anon_sym_async] = ACTIONS(3469),
    [anon_sym_const] = ACTIONS(3469),
    [anon_sym_file] = ACTIONS(3469),
    [anon_sym_fixed] = ACTIONS(3469),
    [anon_sym_internal] = ACTIONS(3469),
    [anon_sym_new] = ACTIONS(3469),
    [anon_sym_override] = ACTIONS(3469),
    [anon_sym_partial] = ACTIONS(3469),
    [anon_sym_private] = ACTIONS(3469),
    [anon_sym_protected] = ACTIONS(3469),
    [anon_sym_public] = ACTIONS(3469),
    [anon_sym_readonly] = ACTIONS(3469),
    [anon_sym_required] = ACTIONS(3469),
    [anon_sym_sealed] = ACTIONS(3469),
    [anon_sym_virtual] = ACTIONS(3469),
    [anon_sym_volatile] = ACTIONS(3469),
    [anon_sym_where] = ACTIONS(3469),
    [anon_sym_notnull] = ACTIONS(3469),
    [anon_sym_unmanaged] = ACTIONS(3469),
    [anon_sym_checked] = ACTIONS(3469),
    [anon_sym_BANG] = ACTIONS(3471),
    [anon_sym_TILDE] = ACTIONS(3471),
    [anon_sym_PLUS_PLUS] = ACTIONS(3471),
    [anon_sym_DASH_DASH] = ACTIONS(3471),
    [anon_sym_true] = ACTIONS(3469),
    [anon_sym_false] = ACTIONS(3469),
    [anon_sym_PLUS] = ACTIONS(3469),
    [anon_sym_DASH] = ACTIONS(3469),
    [anon_sym_STAR] = ACTIONS(3471),
    [anon_sym_CARET] = ACTIONS(3471),
    [anon_sym_AMP] = ACTIONS(3471),
    [anon_sym_this] = ACTIONS(3469),
    [anon_sym_scoped] = ACTIONS(3469),
    [anon_sym_var] = ACTIONS(3469),
    [sym_predefined_type] = ACTIONS(3469),
    [anon_sym_break] = ACTIONS(3469),
    [anon_sym_unchecked] = ACTIONS(3469),
    [anon_sym_continue] = ACTIONS(3469),
    [anon_sym_do] = ACTIONS(3469),
    [anon_sym_while] = ACTIONS(3469),
    [anon_sym_for] = ACTIONS(3469),
    [anon_sym_lock] = ACTIONS(3469),
    [anon_sym_yield] = ACTIONS(3469),
    [anon_sym_switch] = ACTIONS(3469),
    [anon_sym_default] = ACTIONS(3469),
    [anon_sym_throw] = ACTIONS(3469),
    [anon_sym_try] = ACTIONS(3469),
    [anon_sym_when] = ACTIONS(3469),
    [anon_sym_await] = ACTIONS(3469),
    [anon_sym_foreach] = ACTIONS(3469),
    [anon_sym_goto] = ACTIONS(3469),
    [anon_sym_if] = ACTIONS(3469),
    [anon_sym_DOT_DOT] = ACTIONS(3471),
    [anon_sym_from] = ACTIONS(3469),
    [anon_sym_into] = ACTIONS(3469),
    [anon_sym_join] = ACTIONS(3469),
    [anon_sym_on] = ACTIONS(3469),
    [anon_sym_equals] = ACTIONS(3469),
    [anon_sym_let] = ACTIONS(3469),
    [anon_sym_orderby] = ACTIONS(3469),
    [anon_sym_ascending] = ACTIONS(3469),
    [anon_sym_descending] = ACTIONS(3469),
    [anon_sym_group] = ACTIONS(3469),
    [anon_sym_by] = ACTIONS(3469),
    [anon_sym_select] = ACTIONS(3469),
    [anon_sym_DQUOTE] = ACTIONS(3469),
    [anon_sym_stackalloc] = ACTIONS(3469),
    [anon_sym_sizeof] = ACTIONS(3469),
    [anon_sym_typeof] = ACTIONS(3469),
    [anon_sym___makeref] = ACTIONS(3469),
    [anon_sym___reftype] = ACTIONS(3469),
    [anon_sym___refvalue] = ACTIONS(3469),
    [sym_null_literal] = ACTIONS(3469),
    [anon_sym_SQUOTE] = ACTIONS(3471),
    [sym_integer_literal] = ACTIONS(3469),
    [sym_real_literal] = ACTIONS(3471),
    [sym_verbatim_string_literal] = ACTIONS(3471),
    [sym_raw_string_literal] = ACTIONS(3471),
    [aux_sym_preproc_if_token1] = ACTIONS(3471),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3471),
    [sym_interpolation_verbatim_start] = ACTIONS(3471),
    [sym_interpolation_raw_start] = ACTIONS(3471),
  },
  [2519] = {
    [sym_preproc_region] = STATE(2519),
    [sym_preproc_endregion] = STATE(2519),
    [sym_preproc_line] = STATE(2519),
    [sym_preproc_pragma] = STATE(2519),
    [sym_preproc_nullable] = STATE(2519),
    [sym_preproc_error] = STATE(2519),
    [sym_preproc_define] = STATE(2519),
    [sym_preproc_undef] = STATE(2519),
    [ts_builtin_sym_end] = ACTIONS(3890),
    [sym__identifier_token] = ACTIONS(3888),
    [anon_sym_extern] = ACTIONS(3888),
    [anon_sym_alias] = ACTIONS(3888),
    [anon_sym_SEMI] = ACTIONS(3890),
    [anon_sym_global] = ACTIONS(3888),
    [anon_sym_using] = ACTIONS(3888),
    [anon_sym_unsafe] = ACTIONS(3888),
    [anon_sym_static] = ACTIONS(3888),
    [anon_sym_LBRACK] = ACTIONS(3890),
    [anon_sym_LPAREN] = ACTIONS(3890),
    [anon_sym_return] = ACTIONS(3888),
    [anon_sym_namespace] = ACTIONS(3888),
    [anon_sym_class] = ACTIONS(3888),
    [anon_sym_ref] = ACTIONS(3888),
    [anon_sym_struct] = ACTIONS(3888),
    [anon_sym_enum] = ACTIONS(3888),
    [anon_sym_LBRACE] = ACTIONS(3890),
    [anon_sym_interface] = ACTIONS(3888),
    [anon_sym_delegate] = ACTIONS(3888),
    [anon_sym_record] = ACTIONS(3888),
    [anon_sym_abstract] = ACTIONS(3888),
    [anon_sym_async] = ACTIONS(3888),
    [anon_sym_const] = ACTIONS(3888),
    [anon_sym_file] = ACTIONS(3888),
    [anon_sym_fixed] = ACTIONS(3888),
    [anon_sym_internal] = ACTIONS(3888),
    [anon_sym_new] = ACTIONS(3888),
    [anon_sym_override] = ACTIONS(3888),
    [anon_sym_partial] = ACTIONS(3888),
    [anon_sym_private] = ACTIONS(3888),
    [anon_sym_protected] = ACTIONS(3888),
    [anon_sym_public] = ACTIONS(3888),
    [anon_sym_readonly] = ACTIONS(3888),
    [anon_sym_required] = ACTIONS(3888),
    [anon_sym_sealed] = ACTIONS(3888),
    [anon_sym_virtual] = ACTIONS(3888),
    [anon_sym_volatile] = ACTIONS(3888),
    [anon_sym_where] = ACTIONS(3888),
    [anon_sym_notnull] = ACTIONS(3888),
    [anon_sym_unmanaged] = ACTIONS(3888),
    [anon_sym_checked] = ACTIONS(3888),
    [anon_sym_BANG] = ACTIONS(3890),
    [anon_sym_TILDE] = ACTIONS(3890),
    [anon_sym_PLUS_PLUS] = ACTIONS(3890),
    [anon_sym_DASH_DASH] = ACTIONS(3890),
    [anon_sym_true] = ACTIONS(3888),
    [anon_sym_false] = ACTIONS(3888),
    [anon_sym_PLUS] = ACTIONS(3888),
    [anon_sym_DASH] = ACTIONS(3888),
    [anon_sym_STAR] = ACTIONS(3890),
    [anon_sym_CARET] = ACTIONS(3890),
    [anon_sym_AMP] = ACTIONS(3890),
    [anon_sym_this] = ACTIONS(3888),
    [anon_sym_scoped] = ACTIONS(3888),
    [anon_sym_var] = ACTIONS(3888),
    [sym_predefined_type] = ACTIONS(3888),
    [anon_sym_break] = ACTIONS(3888),
    [anon_sym_unchecked] = ACTIONS(3888),
    [anon_sym_continue] = ACTIONS(3888),
    [anon_sym_do] = ACTIONS(3888),
    [anon_sym_while] = ACTIONS(3888),
    [anon_sym_for] = ACTIONS(3888),
    [anon_sym_lock] = ACTIONS(3888),
    [anon_sym_yield] = ACTIONS(3888),
    [anon_sym_switch] = ACTIONS(3888),
    [anon_sym_default] = ACTIONS(3888),
    [anon_sym_throw] = ACTIONS(3888),
    [anon_sym_try] = ACTIONS(3888),
    [anon_sym_when] = ACTIONS(3888),
    [anon_sym_await] = ACTIONS(3888),
    [anon_sym_foreach] = ACTIONS(3888),
    [anon_sym_goto] = ACTIONS(3888),
    [anon_sym_if] = ACTIONS(3888),
    [anon_sym_DOT_DOT] = ACTIONS(3890),
    [anon_sym_from] = ACTIONS(3888),
    [anon_sym_into] = ACTIONS(3888),
    [anon_sym_join] = ACTIONS(3888),
    [anon_sym_on] = ACTIONS(3888),
    [anon_sym_equals] = ACTIONS(3888),
    [anon_sym_let] = ACTIONS(3888),
    [anon_sym_orderby] = ACTIONS(3888),
    [anon_sym_ascending] = ACTIONS(3888),
    [anon_sym_descending] = ACTIONS(3888),
    [anon_sym_group] = ACTIONS(3888),
    [anon_sym_by] = ACTIONS(3888),
    [anon_sym_select] = ACTIONS(3888),
    [anon_sym_DQUOTE] = ACTIONS(3888),
    [anon_sym_stackalloc] = ACTIONS(3888),
    [anon_sym_sizeof] = ACTIONS(3888),
    [anon_sym_typeof] = ACTIONS(3888),
    [anon_sym___makeref] = ACTIONS(3888),
    [anon_sym___reftype] = ACTIONS(3888),
    [anon_sym___refvalue] = ACTIONS(3888),
    [sym_null_literal] = ACTIONS(3888),
    [anon_sym_SQUOTE] = ACTIONS(3890),
    [sym_integer_literal] = ACTIONS(3888),
    [sym_real_literal] = ACTIONS(3890),
    [sym_verbatim_string_literal] = ACTIONS(3890),
    [sym_raw_string_literal] = ACTIONS(3890),
    [aux_sym_preproc_if_token1] = ACTIONS(3890),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3890),
    [sym_interpolation_verbatim_start] = ACTIONS(3890),
    [sym_interpolation_raw_start] = ACTIONS(3890),
  },
  [2520] = {
    [sym_preproc_region] = STATE(2520),
    [sym_preproc_endregion] = STATE(2520),
    [sym_preproc_line] = STATE(2520),
    [sym_preproc_pragma] = STATE(2520),
    [sym_preproc_nullable] = STATE(2520),
    [sym_preproc_error] = STATE(2520),
    [sym_preproc_define] = STATE(2520),
    [sym_preproc_undef] = STATE(2520),
    [ts_builtin_sym_end] = ACTIONS(3894),
    [sym__identifier_token] = ACTIONS(3892),
    [anon_sym_extern] = ACTIONS(3892),
    [anon_sym_alias] = ACTIONS(3892),
    [anon_sym_SEMI] = ACTIONS(3894),
    [anon_sym_global] = ACTIONS(3892),
    [anon_sym_using] = ACTIONS(3892),
    [anon_sym_unsafe] = ACTIONS(3892),
    [anon_sym_static] = ACTIONS(3892),
    [anon_sym_LBRACK] = ACTIONS(3894),
    [anon_sym_LPAREN] = ACTIONS(3894),
    [anon_sym_return] = ACTIONS(3892),
    [anon_sym_namespace] = ACTIONS(3892),
    [anon_sym_class] = ACTIONS(3892),
    [anon_sym_ref] = ACTIONS(3892),
    [anon_sym_struct] = ACTIONS(3892),
    [anon_sym_enum] = ACTIONS(3892),
    [anon_sym_LBRACE] = ACTIONS(3894),
    [anon_sym_interface] = ACTIONS(3892),
    [anon_sym_delegate] = ACTIONS(3892),
    [anon_sym_record] = ACTIONS(3892),
    [anon_sym_abstract] = ACTIONS(3892),
    [anon_sym_async] = ACTIONS(3892),
    [anon_sym_const] = ACTIONS(3892),
    [anon_sym_file] = ACTIONS(3892),
    [anon_sym_fixed] = ACTIONS(3892),
    [anon_sym_internal] = ACTIONS(3892),
    [anon_sym_new] = ACTIONS(3892),
    [anon_sym_override] = ACTIONS(3892),
    [anon_sym_partial] = ACTIONS(3892),
    [anon_sym_private] = ACTIONS(3892),
    [anon_sym_protected] = ACTIONS(3892),
    [anon_sym_public] = ACTIONS(3892),
    [anon_sym_readonly] = ACTIONS(3892),
    [anon_sym_required] = ACTIONS(3892),
    [anon_sym_sealed] = ACTIONS(3892),
    [anon_sym_virtual] = ACTIONS(3892),
    [anon_sym_volatile] = ACTIONS(3892),
    [anon_sym_where] = ACTIONS(3892),
    [anon_sym_notnull] = ACTIONS(3892),
    [anon_sym_unmanaged] = ACTIONS(3892),
    [anon_sym_checked] = ACTIONS(3892),
    [anon_sym_BANG] = ACTIONS(3894),
    [anon_sym_TILDE] = ACTIONS(3894),
    [anon_sym_PLUS_PLUS] = ACTIONS(3894),
    [anon_sym_DASH_DASH] = ACTIONS(3894),
    [anon_sym_true] = ACTIONS(3892),
    [anon_sym_false] = ACTIONS(3892),
    [anon_sym_PLUS] = ACTIONS(3892),
    [anon_sym_DASH] = ACTIONS(3892),
    [anon_sym_STAR] = ACTIONS(3894),
    [anon_sym_CARET] = ACTIONS(3894),
    [anon_sym_AMP] = ACTIONS(3894),
    [anon_sym_this] = ACTIONS(3892),
    [anon_sym_scoped] = ACTIONS(3892),
    [anon_sym_var] = ACTIONS(3892),
    [sym_predefined_type] = ACTIONS(3892),
    [anon_sym_break] = ACTIONS(3892),
    [anon_sym_unchecked] = ACTIONS(3892),
    [anon_sym_continue] = ACTIONS(3892),
    [anon_sym_do] = ACTIONS(3892),
    [anon_sym_while] = ACTIONS(3892),
    [anon_sym_for] = ACTIONS(3892),
    [anon_sym_lock] = ACTIONS(3892),
    [anon_sym_yield] = ACTIONS(3892),
    [anon_sym_switch] = ACTIONS(3892),
    [anon_sym_default] = ACTIONS(3892),
    [anon_sym_throw] = ACTIONS(3892),
    [anon_sym_try] = ACTIONS(3892),
    [anon_sym_when] = ACTIONS(3892),
    [anon_sym_await] = ACTIONS(3892),
    [anon_sym_foreach] = ACTIONS(3892),
    [anon_sym_goto] = ACTIONS(3892),
    [anon_sym_if] = ACTIONS(3892),
    [anon_sym_DOT_DOT] = ACTIONS(3894),
    [anon_sym_from] = ACTIONS(3892),
    [anon_sym_into] = ACTIONS(3892),
    [anon_sym_join] = ACTIONS(3892),
    [anon_sym_on] = ACTIONS(3892),
    [anon_sym_equals] = ACTIONS(3892),
    [anon_sym_let] = ACTIONS(3892),
    [anon_sym_orderby] = ACTIONS(3892),
    [anon_sym_ascending] = ACTIONS(3892),
    [anon_sym_descending] = ACTIONS(3892),
    [anon_sym_group] = ACTIONS(3892),
    [anon_sym_by] = ACTIONS(3892),
    [anon_sym_select] = ACTIONS(3892),
    [anon_sym_DQUOTE] = ACTIONS(3892),
    [anon_sym_stackalloc] = ACTIONS(3892),
    [anon_sym_sizeof] = ACTIONS(3892),
    [anon_sym_typeof] = ACTIONS(3892),
    [anon_sym___makeref] = ACTIONS(3892),
    [anon_sym___reftype] = ACTIONS(3892),
    [anon_sym___refvalue] = ACTIONS(3892),
    [sym_null_literal] = ACTIONS(3892),
    [anon_sym_SQUOTE] = ACTIONS(3894),
    [sym_integer_literal] = ACTIONS(3892),
    [sym_real_literal] = ACTIONS(3894),
    [sym_verbatim_string_literal] = ACTIONS(3894),
    [sym_raw_string_literal] = ACTIONS(3894),
    [aux_sym_preproc_if_token1] = ACTIONS(3894),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3894),
    [sym_interpolation_verbatim_start] = ACTIONS(3894),
    [sym_interpolation_raw_start] = ACTIONS(3894),
  },
  [2521] = {
    [sym_preproc_region] = STATE(2521),
    [sym_preproc_endregion] = STATE(2521),
    [sym_preproc_line] = STATE(2521),
    [sym_preproc_pragma] = STATE(2521),
    [sym_preproc_nullable] = STATE(2521),
    [sym_preproc_error] = STATE(2521),
    [sym_preproc_define] = STATE(2521),
    [sym_preproc_undef] = STATE(2521),
    [ts_builtin_sym_end] = ACTIONS(3898),
    [sym__identifier_token] = ACTIONS(3896),
    [anon_sym_extern] = ACTIONS(3896),
    [anon_sym_alias] = ACTIONS(3896),
    [anon_sym_SEMI] = ACTIONS(3898),
    [anon_sym_global] = ACTIONS(3896),
    [anon_sym_using] = ACTIONS(3896),
    [anon_sym_unsafe] = ACTIONS(3896),
    [anon_sym_static] = ACTIONS(3896),
    [anon_sym_LBRACK] = ACTIONS(3898),
    [anon_sym_LPAREN] = ACTIONS(3898),
    [anon_sym_return] = ACTIONS(3896),
    [anon_sym_namespace] = ACTIONS(3896),
    [anon_sym_class] = ACTIONS(3896),
    [anon_sym_ref] = ACTIONS(3896),
    [anon_sym_struct] = ACTIONS(3896),
    [anon_sym_enum] = ACTIONS(3896),
    [anon_sym_LBRACE] = ACTIONS(3898),
    [anon_sym_interface] = ACTIONS(3896),
    [anon_sym_delegate] = ACTIONS(3896),
    [anon_sym_record] = ACTIONS(3896),
    [anon_sym_abstract] = ACTIONS(3896),
    [anon_sym_async] = ACTIONS(3896),
    [anon_sym_const] = ACTIONS(3896),
    [anon_sym_file] = ACTIONS(3896),
    [anon_sym_fixed] = ACTIONS(3896),
    [anon_sym_internal] = ACTIONS(3896),
    [anon_sym_new] = ACTIONS(3896),
    [anon_sym_override] = ACTIONS(3896),
    [anon_sym_partial] = ACTIONS(3896),
    [anon_sym_private] = ACTIONS(3896),
    [anon_sym_protected] = ACTIONS(3896),
    [anon_sym_public] = ACTIONS(3896),
    [anon_sym_readonly] = ACTIONS(3896),
    [anon_sym_required] = ACTIONS(3896),
    [anon_sym_sealed] = ACTIONS(3896),
    [anon_sym_virtual] = ACTIONS(3896),
    [anon_sym_volatile] = ACTIONS(3896),
    [anon_sym_where] = ACTIONS(3896),
    [anon_sym_notnull] = ACTIONS(3896),
    [anon_sym_unmanaged] = ACTIONS(3896),
    [anon_sym_checked] = ACTIONS(3896),
    [anon_sym_BANG] = ACTIONS(3898),
    [anon_sym_TILDE] = ACTIONS(3898),
    [anon_sym_PLUS_PLUS] = ACTIONS(3898),
    [anon_sym_DASH_DASH] = ACTIONS(3898),
    [anon_sym_true] = ACTIONS(3896),
    [anon_sym_false] = ACTIONS(3896),
    [anon_sym_PLUS] = ACTIONS(3896),
    [anon_sym_DASH] = ACTIONS(3896),
    [anon_sym_STAR] = ACTIONS(3898),
    [anon_sym_CARET] = ACTIONS(3898),
    [anon_sym_AMP] = ACTIONS(3898),
    [anon_sym_this] = ACTIONS(3896),
    [anon_sym_scoped] = ACTIONS(3896),
    [anon_sym_var] = ACTIONS(3896),
    [sym_predefined_type] = ACTIONS(3896),
    [anon_sym_break] = ACTIONS(3896),
    [anon_sym_unchecked] = ACTIONS(3896),
    [anon_sym_continue] = ACTIONS(3896),
    [anon_sym_do] = ACTIONS(3896),
    [anon_sym_while] = ACTIONS(3896),
    [anon_sym_for] = ACTIONS(3896),
    [anon_sym_lock] = ACTIONS(3896),
    [anon_sym_yield] = ACTIONS(3896),
    [anon_sym_switch] = ACTIONS(3896),
    [anon_sym_default] = ACTIONS(3896),
    [anon_sym_throw] = ACTIONS(3896),
    [anon_sym_try] = ACTIONS(3896),
    [anon_sym_when] = ACTIONS(3896),
    [anon_sym_await] = ACTIONS(3896),
    [anon_sym_foreach] = ACTIONS(3896),
    [anon_sym_goto] = ACTIONS(3896),
    [anon_sym_if] = ACTIONS(3896),
    [anon_sym_DOT_DOT] = ACTIONS(3898),
    [anon_sym_from] = ACTIONS(3896),
    [anon_sym_into] = ACTIONS(3896),
    [anon_sym_join] = ACTIONS(3896),
    [anon_sym_on] = ACTIONS(3896),
    [anon_sym_equals] = ACTIONS(3896),
    [anon_sym_let] = ACTIONS(3896),
    [anon_sym_orderby] = ACTIONS(3896),
    [anon_sym_ascending] = ACTIONS(3896),
    [anon_sym_descending] = ACTIONS(3896),
    [anon_sym_group] = ACTIONS(3896),
    [anon_sym_by] = ACTIONS(3896),
    [anon_sym_select] = ACTIONS(3896),
    [anon_sym_DQUOTE] = ACTIONS(3896),
    [anon_sym_stackalloc] = ACTIONS(3896),
    [anon_sym_sizeof] = ACTIONS(3896),
    [anon_sym_typeof] = ACTIONS(3896),
    [anon_sym___makeref] = ACTIONS(3896),
    [anon_sym___reftype] = ACTIONS(3896),
    [anon_sym___refvalue] = ACTIONS(3896),
    [sym_null_literal] = ACTIONS(3896),
    [anon_sym_SQUOTE] = ACTIONS(3898),
    [sym_integer_literal] = ACTIONS(3896),
    [sym_real_literal] = ACTIONS(3898),
    [sym_verbatim_string_literal] = ACTIONS(3898),
    [sym_raw_string_literal] = ACTIONS(3898),
    [aux_sym_preproc_if_token1] = ACTIONS(3898),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3898),
    [sym_interpolation_verbatim_start] = ACTIONS(3898),
    [sym_interpolation_raw_start] = ACTIONS(3898),
  },
  [2522] = {
    [sym_preproc_region] = STATE(2522),
    [sym_preproc_endregion] = STATE(2522),
    [sym_preproc_line] = STATE(2522),
    [sym_preproc_pragma] = STATE(2522),
    [sym_preproc_nullable] = STATE(2522),
    [sym_preproc_error] = STATE(2522),
    [sym_preproc_define] = STATE(2522),
    [sym_preproc_undef] = STATE(2522),
    [ts_builtin_sym_end] = ACTIONS(3467),
    [sym__identifier_token] = ACTIONS(3465),
    [anon_sym_extern] = ACTIONS(3465),
    [anon_sym_alias] = ACTIONS(3465),
    [anon_sym_SEMI] = ACTIONS(3467),
    [anon_sym_global] = ACTIONS(3465),
    [anon_sym_using] = ACTIONS(3465),
    [anon_sym_unsafe] = ACTIONS(3465),
    [anon_sym_static] = ACTIONS(3465),
    [anon_sym_LBRACK] = ACTIONS(3467),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_return] = ACTIONS(3465),
    [anon_sym_namespace] = ACTIONS(3465),
    [anon_sym_class] = ACTIONS(3465),
    [anon_sym_ref] = ACTIONS(3465),
    [anon_sym_struct] = ACTIONS(3465),
    [anon_sym_enum] = ACTIONS(3465),
    [anon_sym_LBRACE] = ACTIONS(3467),
    [anon_sym_interface] = ACTIONS(3465),
    [anon_sym_delegate] = ACTIONS(3465),
    [anon_sym_record] = ACTIONS(3465),
    [anon_sym_abstract] = ACTIONS(3465),
    [anon_sym_async] = ACTIONS(3465),
    [anon_sym_const] = ACTIONS(3465),
    [anon_sym_file] = ACTIONS(3465),
    [anon_sym_fixed] = ACTIONS(3465),
    [anon_sym_internal] = ACTIONS(3465),
    [anon_sym_new] = ACTIONS(3465),
    [anon_sym_override] = ACTIONS(3465),
    [anon_sym_partial] = ACTIONS(3465),
    [anon_sym_private] = ACTIONS(3465),
    [anon_sym_protected] = ACTIONS(3465),
    [anon_sym_public] = ACTIONS(3465),
    [anon_sym_readonly] = ACTIONS(3465),
    [anon_sym_required] = ACTIONS(3465),
    [anon_sym_sealed] = ACTIONS(3465),
    [anon_sym_virtual] = ACTIONS(3465),
    [anon_sym_volatile] = ACTIONS(3465),
    [anon_sym_where] = ACTIONS(3465),
    [anon_sym_notnull] = ACTIONS(3465),
    [anon_sym_unmanaged] = ACTIONS(3465),
    [anon_sym_checked] = ACTIONS(3465),
    [anon_sym_BANG] = ACTIONS(3467),
    [anon_sym_TILDE] = ACTIONS(3467),
    [anon_sym_PLUS_PLUS] = ACTIONS(3467),
    [anon_sym_DASH_DASH] = ACTIONS(3467),
    [anon_sym_true] = ACTIONS(3465),
    [anon_sym_false] = ACTIONS(3465),
    [anon_sym_PLUS] = ACTIONS(3465),
    [anon_sym_DASH] = ACTIONS(3465),
    [anon_sym_STAR] = ACTIONS(3467),
    [anon_sym_CARET] = ACTIONS(3467),
    [anon_sym_AMP] = ACTIONS(3467),
    [anon_sym_this] = ACTIONS(3465),
    [anon_sym_scoped] = ACTIONS(3465),
    [anon_sym_var] = ACTIONS(3465),
    [sym_predefined_type] = ACTIONS(3465),
    [anon_sym_break] = ACTIONS(3465),
    [anon_sym_unchecked] = ACTIONS(3465),
    [anon_sym_continue] = ACTIONS(3465),
    [anon_sym_do] = ACTIONS(3465),
    [anon_sym_while] = ACTIONS(3465),
    [anon_sym_for] = ACTIONS(3465),
    [anon_sym_lock] = ACTIONS(3465),
    [anon_sym_yield] = ACTIONS(3465),
    [anon_sym_switch] = ACTIONS(3465),
    [anon_sym_default] = ACTIONS(3465),
    [anon_sym_throw] = ACTIONS(3465),
    [anon_sym_try] = ACTIONS(3465),
    [anon_sym_when] = ACTIONS(3465),
    [anon_sym_await] = ACTIONS(3465),
    [anon_sym_foreach] = ACTIONS(3465),
    [anon_sym_goto] = ACTIONS(3465),
    [anon_sym_if] = ACTIONS(3465),
    [anon_sym_DOT_DOT] = ACTIONS(3467),
    [anon_sym_from] = ACTIONS(3465),
    [anon_sym_into] = ACTIONS(3465),
    [anon_sym_join] = ACTIONS(3465),
    [anon_sym_on] = ACTIONS(3465),
    [anon_sym_equals] = ACTIONS(3465),
    [anon_sym_let] = ACTIONS(3465),
    [anon_sym_orderby] = ACTIONS(3465),
    [anon_sym_ascending] = ACTIONS(3465),
    [anon_sym_descending] = ACTIONS(3465),
    [anon_sym_group] = ACTIONS(3465),
    [anon_sym_by] = ACTIONS(3465),
    [anon_sym_select] = ACTIONS(3465),
    [anon_sym_DQUOTE] = ACTIONS(3465),
    [anon_sym_stackalloc] = ACTIONS(3465),
    [anon_sym_sizeof] = ACTIONS(3465),
    [anon_sym_typeof] = ACTIONS(3465),
    [anon_sym___makeref] = ACTIONS(3465),
    [anon_sym___reftype] = ACTIONS(3465),
    [anon_sym___refvalue] = ACTIONS(3465),
    [sym_null_literal] = ACTIONS(3465),
    [anon_sym_SQUOTE] = ACTIONS(3467),
    [sym_integer_literal] = ACTIONS(3465),
    [sym_real_literal] = ACTIONS(3467),
    [sym_verbatim_string_literal] = ACTIONS(3467),
    [sym_raw_string_literal] = ACTIONS(3467),
    [aux_sym_preproc_if_token1] = ACTIONS(3467),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3467),
    [sym_interpolation_verbatim_start] = ACTIONS(3467),
    [sym_interpolation_raw_start] = ACTIONS(3467),
  },
  [2523] = {
    [sym_preproc_region] = STATE(2523),
    [sym_preproc_endregion] = STATE(2523),
    [sym_preproc_line] = STATE(2523),
    [sym_preproc_pragma] = STATE(2523),
    [sym_preproc_nullable] = STATE(2523),
    [sym_preproc_error] = STATE(2523),
    [sym_preproc_define] = STATE(2523),
    [sym_preproc_undef] = STATE(2523),
    [ts_builtin_sym_end] = ACTIONS(3902),
    [sym__identifier_token] = ACTIONS(3900),
    [anon_sym_extern] = ACTIONS(3900),
    [anon_sym_alias] = ACTIONS(3900),
    [anon_sym_SEMI] = ACTIONS(3902),
    [anon_sym_global] = ACTIONS(3900),
    [anon_sym_using] = ACTIONS(3900),
    [anon_sym_unsafe] = ACTIONS(3900),
    [anon_sym_static] = ACTIONS(3900),
    [anon_sym_LBRACK] = ACTIONS(3902),
    [anon_sym_LPAREN] = ACTIONS(3902),
    [anon_sym_return] = ACTIONS(3900),
    [anon_sym_namespace] = ACTIONS(3900),
    [anon_sym_class] = ACTIONS(3900),
    [anon_sym_ref] = ACTIONS(3900),
    [anon_sym_struct] = ACTIONS(3900),
    [anon_sym_enum] = ACTIONS(3900),
    [anon_sym_LBRACE] = ACTIONS(3902),
    [anon_sym_interface] = ACTIONS(3900),
    [anon_sym_delegate] = ACTIONS(3900),
    [anon_sym_record] = ACTIONS(3900),
    [anon_sym_abstract] = ACTIONS(3900),
    [anon_sym_async] = ACTIONS(3900),
    [anon_sym_const] = ACTIONS(3900),
    [anon_sym_file] = ACTIONS(3900),
    [anon_sym_fixed] = ACTIONS(3900),
    [anon_sym_internal] = ACTIONS(3900),
    [anon_sym_new] = ACTIONS(3900),
    [anon_sym_override] = ACTIONS(3900),
    [anon_sym_partial] = ACTIONS(3900),
    [anon_sym_private] = ACTIONS(3900),
    [anon_sym_protected] = ACTIONS(3900),
    [anon_sym_public] = ACTIONS(3900),
    [anon_sym_readonly] = ACTIONS(3900),
    [anon_sym_required] = ACTIONS(3900),
    [anon_sym_sealed] = ACTIONS(3900),
    [anon_sym_virtual] = ACTIONS(3900),
    [anon_sym_volatile] = ACTIONS(3900),
    [anon_sym_where] = ACTIONS(3900),
    [anon_sym_notnull] = ACTIONS(3900),
    [anon_sym_unmanaged] = ACTIONS(3900),
    [anon_sym_checked] = ACTIONS(3900),
    [anon_sym_BANG] = ACTIONS(3902),
    [anon_sym_TILDE] = ACTIONS(3902),
    [anon_sym_PLUS_PLUS] = ACTIONS(3902),
    [anon_sym_DASH_DASH] = ACTIONS(3902),
    [anon_sym_true] = ACTIONS(3900),
    [anon_sym_false] = ACTIONS(3900),
    [anon_sym_PLUS] = ACTIONS(3900),
    [anon_sym_DASH] = ACTIONS(3900),
    [anon_sym_STAR] = ACTIONS(3902),
    [anon_sym_CARET] = ACTIONS(3902),
    [anon_sym_AMP] = ACTIONS(3902),
    [anon_sym_this] = ACTIONS(3900),
    [anon_sym_scoped] = ACTIONS(3900),
    [anon_sym_var] = ACTIONS(3900),
    [sym_predefined_type] = ACTIONS(3900),
    [anon_sym_break] = ACTIONS(3900),
    [anon_sym_unchecked] = ACTIONS(3900),
    [anon_sym_continue] = ACTIONS(3900),
    [anon_sym_do] = ACTIONS(3900),
    [anon_sym_while] = ACTIONS(3900),
    [anon_sym_for] = ACTIONS(3900),
    [anon_sym_lock] = ACTIONS(3900),
    [anon_sym_yield] = ACTIONS(3900),
    [anon_sym_switch] = ACTIONS(3900),
    [anon_sym_default] = ACTIONS(3900),
    [anon_sym_throw] = ACTIONS(3900),
    [anon_sym_try] = ACTIONS(3900),
    [anon_sym_when] = ACTIONS(3900),
    [anon_sym_await] = ACTIONS(3900),
    [anon_sym_foreach] = ACTIONS(3900),
    [anon_sym_goto] = ACTIONS(3900),
    [anon_sym_if] = ACTIONS(3900),
    [anon_sym_DOT_DOT] = ACTIONS(3902),
    [anon_sym_from] = ACTIONS(3900),
    [anon_sym_into] = ACTIONS(3900),
    [anon_sym_join] = ACTIONS(3900),
    [anon_sym_on] = ACTIONS(3900),
    [anon_sym_equals] = ACTIONS(3900),
    [anon_sym_let] = ACTIONS(3900),
    [anon_sym_orderby] = ACTIONS(3900),
    [anon_sym_ascending] = ACTIONS(3900),
    [anon_sym_descending] = ACTIONS(3900),
    [anon_sym_group] = ACTIONS(3900),
    [anon_sym_by] = ACTIONS(3900),
    [anon_sym_select] = ACTIONS(3900),
    [anon_sym_DQUOTE] = ACTIONS(3900),
    [anon_sym_stackalloc] = ACTIONS(3900),
    [anon_sym_sizeof] = ACTIONS(3900),
    [anon_sym_typeof] = ACTIONS(3900),
    [anon_sym___makeref] = ACTIONS(3900),
    [anon_sym___reftype] = ACTIONS(3900),
    [anon_sym___refvalue] = ACTIONS(3900),
    [sym_null_literal] = ACTIONS(3900),
    [anon_sym_SQUOTE] = ACTIONS(3902),
    [sym_integer_literal] = ACTIONS(3900),
    [sym_real_literal] = ACTIONS(3902),
    [sym_verbatim_string_literal] = ACTIONS(3902),
    [sym_raw_string_literal] = ACTIONS(3902),
    [aux_sym_preproc_if_token1] = ACTIONS(3902),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3902),
    [sym_interpolation_verbatim_start] = ACTIONS(3902),
    [sym_interpolation_raw_start] = ACTIONS(3902),
  },
  [2524] = {
    [sym_preproc_region] = STATE(2524),
    [sym_preproc_endregion] = STATE(2524),
    [sym_preproc_line] = STATE(2524),
    [sym_preproc_pragma] = STATE(2524),
    [sym_preproc_nullable] = STATE(2524),
    [sym_preproc_error] = STATE(2524),
    [sym_preproc_define] = STATE(2524),
    [sym_preproc_undef] = STATE(2524),
    [ts_builtin_sym_end] = ACTIONS(3906),
    [sym__identifier_token] = ACTIONS(3904),
    [anon_sym_extern] = ACTIONS(3904),
    [anon_sym_alias] = ACTIONS(3904),
    [anon_sym_SEMI] = ACTIONS(3906),
    [anon_sym_global] = ACTIONS(3904),
    [anon_sym_using] = ACTIONS(3904),
    [anon_sym_unsafe] = ACTIONS(3904),
    [anon_sym_static] = ACTIONS(3904),
    [anon_sym_LBRACK] = ACTIONS(3906),
    [anon_sym_LPAREN] = ACTIONS(3906),
    [anon_sym_return] = ACTIONS(3904),
    [anon_sym_namespace] = ACTIONS(3904),
    [anon_sym_class] = ACTIONS(3904),
    [anon_sym_ref] = ACTIONS(3904),
    [anon_sym_struct] = ACTIONS(3904),
    [anon_sym_enum] = ACTIONS(3904),
    [anon_sym_LBRACE] = ACTIONS(3906),
    [anon_sym_interface] = ACTIONS(3904),
    [anon_sym_delegate] = ACTIONS(3904),
    [anon_sym_record] = ACTIONS(3904),
    [anon_sym_abstract] = ACTIONS(3904),
    [anon_sym_async] = ACTIONS(3904),
    [anon_sym_const] = ACTIONS(3904),
    [anon_sym_file] = ACTIONS(3904),
    [anon_sym_fixed] = ACTIONS(3904),
    [anon_sym_internal] = ACTIONS(3904),
    [anon_sym_new] = ACTIONS(3904),
    [anon_sym_override] = ACTIONS(3904),
    [anon_sym_partial] = ACTIONS(3904),
    [anon_sym_private] = ACTIONS(3904),
    [anon_sym_protected] = ACTIONS(3904),
    [anon_sym_public] = ACTIONS(3904),
    [anon_sym_readonly] = ACTIONS(3904),
    [anon_sym_required] = ACTIONS(3904),
    [anon_sym_sealed] = ACTIONS(3904),
    [anon_sym_virtual] = ACTIONS(3904),
    [anon_sym_volatile] = ACTIONS(3904),
    [anon_sym_where] = ACTIONS(3904),
    [anon_sym_notnull] = ACTIONS(3904),
    [anon_sym_unmanaged] = ACTIONS(3904),
    [anon_sym_checked] = ACTIONS(3904),
    [anon_sym_BANG] = ACTIONS(3906),
    [anon_sym_TILDE] = ACTIONS(3906),
    [anon_sym_PLUS_PLUS] = ACTIONS(3906),
    [anon_sym_DASH_DASH] = ACTIONS(3906),
    [anon_sym_true] = ACTIONS(3904),
    [anon_sym_false] = ACTIONS(3904),
    [anon_sym_PLUS] = ACTIONS(3904),
    [anon_sym_DASH] = ACTIONS(3904),
    [anon_sym_STAR] = ACTIONS(3906),
    [anon_sym_CARET] = ACTIONS(3906),
    [anon_sym_AMP] = ACTIONS(3906),
    [anon_sym_this] = ACTIONS(3904),
    [anon_sym_scoped] = ACTIONS(3904),
    [anon_sym_var] = ACTIONS(3904),
    [sym_predefined_type] = ACTIONS(3904),
    [anon_sym_break] = ACTIONS(3904),
    [anon_sym_unchecked] = ACTIONS(3904),
    [anon_sym_continue] = ACTIONS(3904),
    [anon_sym_do] = ACTIONS(3904),
    [anon_sym_while] = ACTIONS(3904),
    [anon_sym_for] = ACTIONS(3904),
    [anon_sym_lock] = ACTIONS(3904),
    [anon_sym_yield] = ACTIONS(3904),
    [anon_sym_switch] = ACTIONS(3904),
    [anon_sym_default] = ACTIONS(3904),
    [anon_sym_throw] = ACTIONS(3904),
    [anon_sym_try] = ACTIONS(3904),
    [anon_sym_when] = ACTIONS(3904),
    [anon_sym_await] = ACTIONS(3904),
    [anon_sym_foreach] = ACTIONS(3904),
    [anon_sym_goto] = ACTIONS(3904),
    [anon_sym_if] = ACTIONS(3904),
    [anon_sym_DOT_DOT] = ACTIONS(3906),
    [anon_sym_from] = ACTIONS(3904),
    [anon_sym_into] = ACTIONS(3904),
    [anon_sym_join] = ACTIONS(3904),
    [anon_sym_on] = ACTIONS(3904),
    [anon_sym_equals] = ACTIONS(3904),
    [anon_sym_let] = ACTIONS(3904),
    [anon_sym_orderby] = ACTIONS(3904),
    [anon_sym_ascending] = ACTIONS(3904),
    [anon_sym_descending] = ACTIONS(3904),
    [anon_sym_group] = ACTIONS(3904),
    [anon_sym_by] = ACTIONS(3904),
    [anon_sym_select] = ACTIONS(3904),
    [anon_sym_DQUOTE] = ACTIONS(3904),
    [anon_sym_stackalloc] = ACTIONS(3904),
    [anon_sym_sizeof] = ACTIONS(3904),
    [anon_sym_typeof] = ACTIONS(3904),
    [anon_sym___makeref] = ACTIONS(3904),
    [anon_sym___reftype] = ACTIONS(3904),
    [anon_sym___refvalue] = ACTIONS(3904),
    [sym_null_literal] = ACTIONS(3904),
    [anon_sym_SQUOTE] = ACTIONS(3906),
    [sym_integer_literal] = ACTIONS(3904),
    [sym_real_literal] = ACTIONS(3906),
    [sym_verbatim_string_literal] = ACTIONS(3906),
    [sym_raw_string_literal] = ACTIONS(3906),
    [aux_sym_preproc_if_token1] = ACTIONS(3906),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3906),
    [sym_interpolation_verbatim_start] = ACTIONS(3906),
    [sym_interpolation_raw_start] = ACTIONS(3906),
  },
  [2525] = {
    [sym_preproc_region] = STATE(2525),
    [sym_preproc_endregion] = STATE(2525),
    [sym_preproc_line] = STATE(2525),
    [sym_preproc_pragma] = STATE(2525),
    [sym_preproc_nullable] = STATE(2525),
    [sym_preproc_error] = STATE(2525),
    [sym_preproc_define] = STATE(2525),
    [sym_preproc_undef] = STATE(2525),
    [ts_builtin_sym_end] = ACTIONS(3675),
    [sym__identifier_token] = ACTIONS(3673),
    [anon_sym_extern] = ACTIONS(3673),
    [anon_sym_alias] = ACTIONS(3673),
    [anon_sym_SEMI] = ACTIONS(3675),
    [anon_sym_global] = ACTIONS(3673),
    [anon_sym_using] = ACTIONS(3673),
    [anon_sym_unsafe] = ACTIONS(3673),
    [anon_sym_static] = ACTIONS(3673),
    [anon_sym_LBRACK] = ACTIONS(3675),
    [anon_sym_LPAREN] = ACTIONS(3675),
    [anon_sym_return] = ACTIONS(3673),
    [anon_sym_namespace] = ACTIONS(3673),
    [anon_sym_class] = ACTIONS(3673),
    [anon_sym_ref] = ACTIONS(3673),
    [anon_sym_struct] = ACTIONS(3673),
    [anon_sym_enum] = ACTIONS(3673),
    [anon_sym_LBRACE] = ACTIONS(3675),
    [anon_sym_interface] = ACTIONS(3673),
    [anon_sym_delegate] = ACTIONS(3673),
    [anon_sym_record] = ACTIONS(3673),
    [anon_sym_abstract] = ACTIONS(3673),
    [anon_sym_async] = ACTIONS(3673),
    [anon_sym_const] = ACTIONS(3673),
    [anon_sym_file] = ACTIONS(3673),
    [anon_sym_fixed] = ACTIONS(3673),
    [anon_sym_internal] = ACTIONS(3673),
    [anon_sym_new] = ACTIONS(3673),
    [anon_sym_override] = ACTIONS(3673),
    [anon_sym_partial] = ACTIONS(3673),
    [anon_sym_private] = ACTIONS(3673),
    [anon_sym_protected] = ACTIONS(3673),
    [anon_sym_public] = ACTIONS(3673),
    [anon_sym_readonly] = ACTIONS(3673),
    [anon_sym_required] = ACTIONS(3673),
    [anon_sym_sealed] = ACTIONS(3673),
    [anon_sym_virtual] = ACTIONS(3673),
    [anon_sym_volatile] = ACTIONS(3673),
    [anon_sym_where] = ACTIONS(3673),
    [anon_sym_notnull] = ACTIONS(3673),
    [anon_sym_unmanaged] = ACTIONS(3673),
    [anon_sym_checked] = ACTIONS(3673),
    [anon_sym_BANG] = ACTIONS(3675),
    [anon_sym_TILDE] = ACTIONS(3675),
    [anon_sym_PLUS_PLUS] = ACTIONS(3675),
    [anon_sym_DASH_DASH] = ACTIONS(3675),
    [anon_sym_true] = ACTIONS(3673),
    [anon_sym_false] = ACTIONS(3673),
    [anon_sym_PLUS] = ACTIONS(3673),
    [anon_sym_DASH] = ACTIONS(3673),
    [anon_sym_STAR] = ACTIONS(3675),
    [anon_sym_CARET] = ACTIONS(3675),
    [anon_sym_AMP] = ACTIONS(3675),
    [anon_sym_this] = ACTIONS(3673),
    [anon_sym_scoped] = ACTIONS(3673),
    [anon_sym_var] = ACTIONS(3673),
    [sym_predefined_type] = ACTIONS(3673),
    [anon_sym_break] = ACTIONS(3673),
    [anon_sym_unchecked] = ACTIONS(3673),
    [anon_sym_continue] = ACTIONS(3673),
    [anon_sym_do] = ACTIONS(3673),
    [anon_sym_while] = ACTIONS(3673),
    [anon_sym_for] = ACTIONS(3673),
    [anon_sym_lock] = ACTIONS(3673),
    [anon_sym_yield] = ACTIONS(3673),
    [anon_sym_switch] = ACTIONS(3673),
    [anon_sym_default] = ACTIONS(3673),
    [anon_sym_throw] = ACTIONS(3673),
    [anon_sym_try] = ACTIONS(3673),
    [anon_sym_when] = ACTIONS(3673),
    [anon_sym_await] = ACTIONS(3673),
    [anon_sym_foreach] = ACTIONS(3673),
    [anon_sym_goto] = ACTIONS(3673),
    [anon_sym_if] = ACTIONS(3673),
    [anon_sym_DOT_DOT] = ACTIONS(3675),
    [anon_sym_from] = ACTIONS(3673),
    [anon_sym_into] = ACTIONS(3673),
    [anon_sym_join] = ACTIONS(3673),
    [anon_sym_on] = ACTIONS(3673),
    [anon_sym_equals] = ACTIONS(3673),
    [anon_sym_let] = ACTIONS(3673),
    [anon_sym_orderby] = ACTIONS(3673),
    [anon_sym_ascending] = ACTIONS(3673),
    [anon_sym_descending] = ACTIONS(3673),
    [anon_sym_group] = ACTIONS(3673),
    [anon_sym_by] = ACTIONS(3673),
    [anon_sym_select] = ACTIONS(3673),
    [anon_sym_DQUOTE] = ACTIONS(3673),
    [anon_sym_stackalloc] = ACTIONS(3673),
    [anon_sym_sizeof] = ACTIONS(3673),
    [anon_sym_typeof] = ACTIONS(3673),
    [anon_sym___makeref] = ACTIONS(3673),
    [anon_sym___reftype] = ACTIONS(3673),
    [anon_sym___refvalue] = ACTIONS(3673),
    [sym_null_literal] = ACTIONS(3673),
    [anon_sym_SQUOTE] = ACTIONS(3675),
    [sym_integer_literal] = ACTIONS(3673),
    [sym_real_literal] = ACTIONS(3675),
    [sym_verbatim_string_literal] = ACTIONS(3675),
    [sym_raw_string_literal] = ACTIONS(3675),
    [aux_sym_preproc_if_token1] = ACTIONS(3675),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3675),
    [sym_interpolation_verbatim_start] = ACTIONS(3675),
    [sym_interpolation_raw_start] = ACTIONS(3675),
  },
  [2526] = {
    [sym_preproc_region] = STATE(2526),
    [sym_preproc_endregion] = STATE(2526),
    [sym_preproc_line] = STATE(2526),
    [sym_preproc_pragma] = STATE(2526),
    [sym_preproc_nullable] = STATE(2526),
    [sym_preproc_error] = STATE(2526),
    [sym_preproc_define] = STATE(2526),
    [sym_preproc_undef] = STATE(2526),
    [ts_builtin_sym_end] = ACTIONS(3435),
    [sym__identifier_token] = ACTIONS(3433),
    [anon_sym_extern] = ACTIONS(3433),
    [anon_sym_alias] = ACTIONS(3433),
    [anon_sym_SEMI] = ACTIONS(3435),
    [anon_sym_global] = ACTIONS(3433),
    [anon_sym_using] = ACTIONS(3433),
    [anon_sym_unsafe] = ACTIONS(3433),
    [anon_sym_static] = ACTIONS(3433),
    [anon_sym_LBRACK] = ACTIONS(3435),
    [anon_sym_LPAREN] = ACTIONS(3435),
    [anon_sym_return] = ACTIONS(3433),
    [anon_sym_namespace] = ACTIONS(3433),
    [anon_sym_class] = ACTIONS(3433),
    [anon_sym_ref] = ACTIONS(3433),
    [anon_sym_struct] = ACTIONS(3433),
    [anon_sym_enum] = ACTIONS(3433),
    [anon_sym_LBRACE] = ACTIONS(3435),
    [anon_sym_interface] = ACTIONS(3433),
    [anon_sym_delegate] = ACTIONS(3433),
    [anon_sym_record] = ACTIONS(3433),
    [anon_sym_abstract] = ACTIONS(3433),
    [anon_sym_async] = ACTIONS(3433),
    [anon_sym_const] = ACTIONS(3433),
    [anon_sym_file] = ACTIONS(3433),
    [anon_sym_fixed] = ACTIONS(3433),
    [anon_sym_internal] = ACTIONS(3433),
    [anon_sym_new] = ACTIONS(3433),
    [anon_sym_override] = ACTIONS(3433),
    [anon_sym_partial] = ACTIONS(3433),
    [anon_sym_private] = ACTIONS(3433),
    [anon_sym_protected] = ACTIONS(3433),
    [anon_sym_public] = ACTIONS(3433),
    [anon_sym_readonly] = ACTIONS(3433),
    [anon_sym_required] = ACTIONS(3433),
    [anon_sym_sealed] = ACTIONS(3433),
    [anon_sym_virtual] = ACTIONS(3433),
    [anon_sym_volatile] = ACTIONS(3433),
    [anon_sym_where] = ACTIONS(3433),
    [anon_sym_notnull] = ACTIONS(3433),
    [anon_sym_unmanaged] = ACTIONS(3433),
    [anon_sym_checked] = ACTIONS(3433),
    [anon_sym_BANG] = ACTIONS(3435),
    [anon_sym_TILDE] = ACTIONS(3435),
    [anon_sym_PLUS_PLUS] = ACTIONS(3435),
    [anon_sym_DASH_DASH] = ACTIONS(3435),
    [anon_sym_true] = ACTIONS(3433),
    [anon_sym_false] = ACTIONS(3433),
    [anon_sym_PLUS] = ACTIONS(3433),
    [anon_sym_DASH] = ACTIONS(3433),
    [anon_sym_STAR] = ACTIONS(3435),
    [anon_sym_CARET] = ACTIONS(3435),
    [anon_sym_AMP] = ACTIONS(3435),
    [anon_sym_this] = ACTIONS(3433),
    [anon_sym_scoped] = ACTIONS(3433),
    [anon_sym_var] = ACTIONS(3433),
    [sym_predefined_type] = ACTIONS(3433),
    [anon_sym_break] = ACTIONS(3433),
    [anon_sym_unchecked] = ACTIONS(3433),
    [anon_sym_continue] = ACTIONS(3433),
    [anon_sym_do] = ACTIONS(3433),
    [anon_sym_while] = ACTIONS(3433),
    [anon_sym_for] = ACTIONS(3433),
    [anon_sym_lock] = ACTIONS(3433),
    [anon_sym_yield] = ACTIONS(3433),
    [anon_sym_switch] = ACTIONS(3433),
    [anon_sym_default] = ACTIONS(3433),
    [anon_sym_throw] = ACTIONS(3433),
    [anon_sym_try] = ACTIONS(3433),
    [anon_sym_when] = ACTIONS(3433),
    [anon_sym_await] = ACTIONS(3433),
    [anon_sym_foreach] = ACTIONS(3433),
    [anon_sym_goto] = ACTIONS(3433),
    [anon_sym_if] = ACTIONS(3433),
    [anon_sym_DOT_DOT] = ACTIONS(3435),
    [anon_sym_from] = ACTIONS(3433),
    [anon_sym_into] = ACTIONS(3433),
    [anon_sym_join] = ACTIONS(3433),
    [anon_sym_on] = ACTIONS(3433),
    [anon_sym_equals] = ACTIONS(3433),
    [anon_sym_let] = ACTIONS(3433),
    [anon_sym_orderby] = ACTIONS(3433),
    [anon_sym_ascending] = ACTIONS(3433),
    [anon_sym_descending] = ACTIONS(3433),
    [anon_sym_group] = ACTIONS(3433),
    [anon_sym_by] = ACTIONS(3433),
    [anon_sym_select] = ACTIONS(3433),
    [anon_sym_DQUOTE] = ACTIONS(3433),
    [anon_sym_stackalloc] = ACTIONS(3433),
    [anon_sym_sizeof] = ACTIONS(3433),
    [anon_sym_typeof] = ACTIONS(3433),
    [anon_sym___makeref] = ACTIONS(3433),
    [anon_sym___reftype] = ACTIONS(3433),
    [anon_sym___refvalue] = ACTIONS(3433),
    [sym_null_literal] = ACTIONS(3433),
    [anon_sym_SQUOTE] = ACTIONS(3435),
    [sym_integer_literal] = ACTIONS(3433),
    [sym_real_literal] = ACTIONS(3435),
    [sym_verbatim_string_literal] = ACTIONS(3435),
    [sym_raw_string_literal] = ACTIONS(3435),
    [aux_sym_preproc_if_token1] = ACTIONS(3435),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3435),
    [sym_interpolation_verbatim_start] = ACTIONS(3435),
    [sym_interpolation_raw_start] = ACTIONS(3435),
  },
  [2527] = {
    [sym_preproc_region] = STATE(2527),
    [sym_preproc_endregion] = STATE(2527),
    [sym_preproc_line] = STATE(2527),
    [sym_preproc_pragma] = STATE(2527),
    [sym_preproc_nullable] = STATE(2527),
    [sym_preproc_error] = STATE(2527),
    [sym_preproc_define] = STATE(2527),
    [sym_preproc_undef] = STATE(2527),
    [ts_builtin_sym_end] = ACTIONS(3543),
    [sym__identifier_token] = ACTIONS(3541),
    [anon_sym_extern] = ACTIONS(3541),
    [anon_sym_alias] = ACTIONS(3541),
    [anon_sym_SEMI] = ACTIONS(3543),
    [anon_sym_global] = ACTIONS(3541),
    [anon_sym_using] = ACTIONS(3541),
    [anon_sym_unsafe] = ACTIONS(3541),
    [anon_sym_static] = ACTIONS(3541),
    [anon_sym_LBRACK] = ACTIONS(3543),
    [anon_sym_LPAREN] = ACTIONS(3543),
    [anon_sym_return] = ACTIONS(3541),
    [anon_sym_namespace] = ACTIONS(3541),
    [anon_sym_class] = ACTIONS(3541),
    [anon_sym_ref] = ACTIONS(3541),
    [anon_sym_struct] = ACTIONS(3541),
    [anon_sym_enum] = ACTIONS(3541),
    [anon_sym_LBRACE] = ACTIONS(3543),
    [anon_sym_interface] = ACTIONS(3541),
    [anon_sym_delegate] = ACTIONS(3541),
    [anon_sym_record] = ACTIONS(3541),
    [anon_sym_abstract] = ACTIONS(3541),
    [anon_sym_async] = ACTIONS(3541),
    [anon_sym_const] = ACTIONS(3541),
    [anon_sym_file] = ACTIONS(3541),
    [anon_sym_fixed] = ACTIONS(3541),
    [anon_sym_internal] = ACTIONS(3541),
    [anon_sym_new] = ACTIONS(3541),
    [anon_sym_override] = ACTIONS(3541),
    [anon_sym_partial] = ACTIONS(3541),
    [anon_sym_private] = ACTIONS(3541),
    [anon_sym_protected] = ACTIONS(3541),
    [anon_sym_public] = ACTIONS(3541),
    [anon_sym_readonly] = ACTIONS(3541),
    [anon_sym_required] = ACTIONS(3541),
    [anon_sym_sealed] = ACTIONS(3541),
    [anon_sym_virtual] = ACTIONS(3541),
    [anon_sym_volatile] = ACTIONS(3541),
    [anon_sym_where] = ACTIONS(3541),
    [anon_sym_notnull] = ACTIONS(3541),
    [anon_sym_unmanaged] = ACTIONS(3541),
    [anon_sym_checked] = ACTIONS(3541),
    [anon_sym_BANG] = ACTIONS(3543),
    [anon_sym_TILDE] = ACTIONS(3543),
    [anon_sym_PLUS_PLUS] = ACTIONS(3543),
    [anon_sym_DASH_DASH] = ACTIONS(3543),
    [anon_sym_true] = ACTIONS(3541),
    [anon_sym_false] = ACTIONS(3541),
    [anon_sym_PLUS] = ACTIONS(3541),
    [anon_sym_DASH] = ACTIONS(3541),
    [anon_sym_STAR] = ACTIONS(3543),
    [anon_sym_CARET] = ACTIONS(3543),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_this] = ACTIONS(3541),
    [anon_sym_scoped] = ACTIONS(3541),
    [anon_sym_var] = ACTIONS(3541),
    [sym_predefined_type] = ACTIONS(3541),
    [anon_sym_break] = ACTIONS(3541),
    [anon_sym_unchecked] = ACTIONS(3541),
    [anon_sym_continue] = ACTIONS(3541),
    [anon_sym_do] = ACTIONS(3541),
    [anon_sym_while] = ACTIONS(3541),
    [anon_sym_for] = ACTIONS(3541),
    [anon_sym_lock] = ACTIONS(3541),
    [anon_sym_yield] = ACTIONS(3541),
    [anon_sym_switch] = ACTIONS(3541),
    [anon_sym_default] = ACTIONS(3541),
    [anon_sym_throw] = ACTIONS(3541),
    [anon_sym_try] = ACTIONS(3541),
    [anon_sym_when] = ACTIONS(3541),
    [anon_sym_await] = ACTIONS(3541),
    [anon_sym_foreach] = ACTIONS(3541),
    [anon_sym_goto] = ACTIONS(3541),
    [anon_sym_if] = ACTIONS(3541),
    [anon_sym_DOT_DOT] = ACTIONS(3543),
    [anon_sym_from] = ACTIONS(3541),
    [anon_sym_into] = ACTIONS(3541),
    [anon_sym_join] = ACTIONS(3541),
    [anon_sym_on] = ACTIONS(3541),
    [anon_sym_equals] = ACTIONS(3541),
    [anon_sym_let] = ACTIONS(3541),
    [anon_sym_orderby] = ACTIONS(3541),
    [anon_sym_ascending] = ACTIONS(3541),
    [anon_sym_descending] = ACTIONS(3541),
    [anon_sym_group] = ACTIONS(3541),
    [anon_sym_by] = ACTIONS(3541),
    [anon_sym_select] = ACTIONS(3541),
    [anon_sym_DQUOTE] = ACTIONS(3541),
    [anon_sym_stackalloc] = ACTIONS(3541),
    [anon_sym_sizeof] = ACTIONS(3541),
    [anon_sym_typeof] = ACTIONS(3541),
    [anon_sym___makeref] = ACTIONS(3541),
    [anon_sym___reftype] = ACTIONS(3541),
    [anon_sym___refvalue] = ACTIONS(3541),
    [sym_null_literal] = ACTIONS(3541),
    [anon_sym_SQUOTE] = ACTIONS(3543),
    [sym_integer_literal] = ACTIONS(3541),
    [sym_real_literal] = ACTIONS(3543),
    [sym_verbatim_string_literal] = ACTIONS(3543),
    [sym_raw_string_literal] = ACTIONS(3543),
    [aux_sym_preproc_if_token1] = ACTIONS(3543),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3543),
    [sym_interpolation_verbatim_start] = ACTIONS(3543),
    [sym_interpolation_raw_start] = ACTIONS(3543),
  },
  [2528] = {
    [sym_preproc_region] = STATE(2528),
    [sym_preproc_endregion] = STATE(2528),
    [sym_preproc_line] = STATE(2528),
    [sym_preproc_pragma] = STATE(2528),
    [sym_preproc_nullable] = STATE(2528),
    [sym_preproc_error] = STATE(2528),
    [sym_preproc_define] = STATE(2528),
    [sym_preproc_undef] = STATE(2528),
    [ts_builtin_sym_end] = ACTIONS(3683),
    [sym__identifier_token] = ACTIONS(3681),
    [anon_sym_extern] = ACTIONS(3681),
    [anon_sym_alias] = ACTIONS(3681),
    [anon_sym_SEMI] = ACTIONS(3683),
    [anon_sym_global] = ACTIONS(3681),
    [anon_sym_using] = ACTIONS(3681),
    [anon_sym_unsafe] = ACTIONS(3681),
    [anon_sym_static] = ACTIONS(3681),
    [anon_sym_LBRACK] = ACTIONS(3683),
    [anon_sym_LPAREN] = ACTIONS(3683),
    [anon_sym_return] = ACTIONS(3681),
    [anon_sym_namespace] = ACTIONS(3681),
    [anon_sym_class] = ACTIONS(3681),
    [anon_sym_ref] = ACTIONS(3681),
    [anon_sym_struct] = ACTIONS(3681),
    [anon_sym_enum] = ACTIONS(3681),
    [anon_sym_LBRACE] = ACTIONS(3683),
    [anon_sym_interface] = ACTIONS(3681),
    [anon_sym_delegate] = ACTIONS(3681),
    [anon_sym_record] = ACTIONS(3681),
    [anon_sym_abstract] = ACTIONS(3681),
    [anon_sym_async] = ACTIONS(3681),
    [anon_sym_const] = ACTIONS(3681),
    [anon_sym_file] = ACTIONS(3681),
    [anon_sym_fixed] = ACTIONS(3681),
    [anon_sym_internal] = ACTIONS(3681),
    [anon_sym_new] = ACTIONS(3681),
    [anon_sym_override] = ACTIONS(3681),
    [anon_sym_partial] = ACTIONS(3681),
    [anon_sym_private] = ACTIONS(3681),
    [anon_sym_protected] = ACTIONS(3681),
    [anon_sym_public] = ACTIONS(3681),
    [anon_sym_readonly] = ACTIONS(3681),
    [anon_sym_required] = ACTIONS(3681),
    [anon_sym_sealed] = ACTIONS(3681),
    [anon_sym_virtual] = ACTIONS(3681),
    [anon_sym_volatile] = ACTIONS(3681),
    [anon_sym_where] = ACTIONS(3681),
    [anon_sym_notnull] = ACTIONS(3681),
    [anon_sym_unmanaged] = ACTIONS(3681),
    [anon_sym_checked] = ACTIONS(3681),
    [anon_sym_BANG] = ACTIONS(3683),
    [anon_sym_TILDE] = ACTIONS(3683),
    [anon_sym_PLUS_PLUS] = ACTIONS(3683),
    [anon_sym_DASH_DASH] = ACTIONS(3683),
    [anon_sym_true] = ACTIONS(3681),
    [anon_sym_false] = ACTIONS(3681),
    [anon_sym_PLUS] = ACTIONS(3681),
    [anon_sym_DASH] = ACTIONS(3681),
    [anon_sym_STAR] = ACTIONS(3683),
    [anon_sym_CARET] = ACTIONS(3683),
    [anon_sym_AMP] = ACTIONS(3683),
    [anon_sym_this] = ACTIONS(3681),
    [anon_sym_scoped] = ACTIONS(3681),
    [anon_sym_var] = ACTIONS(3681),
    [sym_predefined_type] = ACTIONS(3681),
    [anon_sym_break] = ACTIONS(3681),
    [anon_sym_unchecked] = ACTIONS(3681),
    [anon_sym_continue] = ACTIONS(3681),
    [anon_sym_do] = ACTIONS(3681),
    [anon_sym_while] = ACTIONS(3681),
    [anon_sym_for] = ACTIONS(3681),
    [anon_sym_lock] = ACTIONS(3681),
    [anon_sym_yield] = ACTIONS(3681),
    [anon_sym_switch] = ACTIONS(3681),
    [anon_sym_default] = ACTIONS(3681),
    [anon_sym_throw] = ACTIONS(3681),
    [anon_sym_try] = ACTIONS(3681),
    [anon_sym_when] = ACTIONS(3681),
    [anon_sym_await] = ACTIONS(3681),
    [anon_sym_foreach] = ACTIONS(3681),
    [anon_sym_goto] = ACTIONS(3681),
    [anon_sym_if] = ACTIONS(3681),
    [anon_sym_DOT_DOT] = ACTIONS(3683),
    [anon_sym_from] = ACTIONS(3681),
    [anon_sym_into] = ACTIONS(3681),
    [anon_sym_join] = ACTIONS(3681),
    [anon_sym_on] = ACTIONS(3681),
    [anon_sym_equals] = ACTIONS(3681),
    [anon_sym_let] = ACTIONS(3681),
    [anon_sym_orderby] = ACTIONS(3681),
    [anon_sym_ascending] = ACTIONS(3681),
    [anon_sym_descending] = ACTIONS(3681),
    [anon_sym_group] = ACTIONS(3681),
    [anon_sym_by] = ACTIONS(3681),
    [anon_sym_select] = ACTIONS(3681),
    [anon_sym_DQUOTE] = ACTIONS(3681),
    [anon_sym_stackalloc] = ACTIONS(3681),
    [anon_sym_sizeof] = ACTIONS(3681),
    [anon_sym_typeof] = ACTIONS(3681),
    [anon_sym___makeref] = ACTIONS(3681),
    [anon_sym___reftype] = ACTIONS(3681),
    [anon_sym___refvalue] = ACTIONS(3681),
    [sym_null_literal] = ACTIONS(3681),
    [anon_sym_SQUOTE] = ACTIONS(3683),
    [sym_integer_literal] = ACTIONS(3681),
    [sym_real_literal] = ACTIONS(3683),
    [sym_verbatim_string_literal] = ACTIONS(3683),
    [sym_raw_string_literal] = ACTIONS(3683),
    [aux_sym_preproc_if_token1] = ACTIONS(3683),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3683),
    [sym_interpolation_verbatim_start] = ACTIONS(3683),
    [sym_interpolation_raw_start] = ACTIONS(3683),
  },
  [2529] = {
    [sym_preproc_region] = STATE(2529),
    [sym_preproc_endregion] = STATE(2529),
    [sym_preproc_line] = STATE(2529),
    [sym_preproc_pragma] = STATE(2529),
    [sym_preproc_nullable] = STATE(2529),
    [sym_preproc_error] = STATE(2529),
    [sym_preproc_define] = STATE(2529),
    [sym_preproc_undef] = STATE(2529),
    [ts_builtin_sym_end] = ACTIONS(3926),
    [sym__identifier_token] = ACTIONS(3924),
    [anon_sym_extern] = ACTIONS(3924),
    [anon_sym_alias] = ACTIONS(3924),
    [anon_sym_SEMI] = ACTIONS(3926),
    [anon_sym_global] = ACTIONS(3924),
    [anon_sym_using] = ACTIONS(3924),
    [anon_sym_unsafe] = ACTIONS(3924),
    [anon_sym_static] = ACTIONS(3924),
    [anon_sym_LBRACK] = ACTIONS(3926),
    [anon_sym_LPAREN] = ACTIONS(3926),
    [anon_sym_return] = ACTIONS(3924),
    [anon_sym_namespace] = ACTIONS(3924),
    [anon_sym_class] = ACTIONS(3924),
    [anon_sym_ref] = ACTIONS(3924),
    [anon_sym_struct] = ACTIONS(3924),
    [anon_sym_enum] = ACTIONS(3924),
    [anon_sym_LBRACE] = ACTIONS(3926),
    [anon_sym_interface] = ACTIONS(3924),
    [anon_sym_delegate] = ACTIONS(3924),
    [anon_sym_record] = ACTIONS(3924),
    [anon_sym_abstract] = ACTIONS(3924),
    [anon_sym_async] = ACTIONS(3924),
    [anon_sym_const] = ACTIONS(3924),
    [anon_sym_file] = ACTIONS(3924),
    [anon_sym_fixed] = ACTIONS(3924),
    [anon_sym_internal] = ACTIONS(3924),
    [anon_sym_new] = ACTIONS(3924),
    [anon_sym_override] = ACTIONS(3924),
    [anon_sym_partial] = ACTIONS(3924),
    [anon_sym_private] = ACTIONS(3924),
    [anon_sym_protected] = ACTIONS(3924),
    [anon_sym_public] = ACTIONS(3924),
    [anon_sym_readonly] = ACTIONS(3924),
    [anon_sym_required] = ACTIONS(3924),
    [anon_sym_sealed] = ACTIONS(3924),
    [anon_sym_virtual] = ACTIONS(3924),
    [anon_sym_volatile] = ACTIONS(3924),
    [anon_sym_where] = ACTIONS(3924),
    [anon_sym_notnull] = ACTIONS(3924),
    [anon_sym_unmanaged] = ACTIONS(3924),
    [anon_sym_checked] = ACTIONS(3924),
    [anon_sym_BANG] = ACTIONS(3926),
    [anon_sym_TILDE] = ACTIONS(3926),
    [anon_sym_PLUS_PLUS] = ACTIONS(3926),
    [anon_sym_DASH_DASH] = ACTIONS(3926),
    [anon_sym_true] = ACTIONS(3924),
    [anon_sym_false] = ACTIONS(3924),
    [anon_sym_PLUS] = ACTIONS(3924),
    [anon_sym_DASH] = ACTIONS(3924),
    [anon_sym_STAR] = ACTIONS(3926),
    [anon_sym_CARET] = ACTIONS(3926),
    [anon_sym_AMP] = ACTIONS(3926),
    [anon_sym_this] = ACTIONS(3924),
    [anon_sym_scoped] = ACTIONS(3924),
    [anon_sym_var] = ACTIONS(3924),
    [sym_predefined_type] = ACTIONS(3924),
    [anon_sym_break] = ACTIONS(3924),
    [anon_sym_unchecked] = ACTIONS(3924),
    [anon_sym_continue] = ACTIONS(3924),
    [anon_sym_do] = ACTIONS(3924),
    [anon_sym_while] = ACTIONS(3924),
    [anon_sym_for] = ACTIONS(3924),
    [anon_sym_lock] = ACTIONS(3924),
    [anon_sym_yield] = ACTIONS(3924),
    [anon_sym_switch] = ACTIONS(3924),
    [anon_sym_default] = ACTIONS(3924),
    [anon_sym_throw] = ACTIONS(3924),
    [anon_sym_try] = ACTIONS(3924),
    [anon_sym_when] = ACTIONS(3924),
    [anon_sym_await] = ACTIONS(3924),
    [anon_sym_foreach] = ACTIONS(3924),
    [anon_sym_goto] = ACTIONS(3924),
    [anon_sym_if] = ACTIONS(3924),
    [anon_sym_DOT_DOT] = ACTIONS(3926),
    [anon_sym_from] = ACTIONS(3924),
    [anon_sym_into] = ACTIONS(3924),
    [anon_sym_join] = ACTIONS(3924),
    [anon_sym_on] = ACTIONS(3924),
    [anon_sym_equals] = ACTIONS(3924),
    [anon_sym_let] = ACTIONS(3924),
    [anon_sym_orderby] = ACTIONS(3924),
    [anon_sym_ascending] = ACTIONS(3924),
    [anon_sym_descending] = ACTIONS(3924),
    [anon_sym_group] = ACTIONS(3924),
    [anon_sym_by] = ACTIONS(3924),
    [anon_sym_select] = ACTIONS(3924),
    [anon_sym_DQUOTE] = ACTIONS(3924),
    [anon_sym_stackalloc] = ACTIONS(3924),
    [anon_sym_sizeof] = ACTIONS(3924),
    [anon_sym_typeof] = ACTIONS(3924),
    [anon_sym___makeref] = ACTIONS(3924),
    [anon_sym___reftype] = ACTIONS(3924),
    [anon_sym___refvalue] = ACTIONS(3924),
    [sym_null_literal] = ACTIONS(3924),
    [anon_sym_SQUOTE] = ACTIONS(3926),
    [sym_integer_literal] = ACTIONS(3924),
    [sym_real_literal] = ACTIONS(3926),
    [sym_verbatim_string_literal] = ACTIONS(3926),
    [sym_raw_string_literal] = ACTIONS(3926),
    [aux_sym_preproc_if_token1] = ACTIONS(3926),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3926),
    [sym_interpolation_verbatim_start] = ACTIONS(3926),
    [sym_interpolation_raw_start] = ACTIONS(3926),
  },
  [2530] = {
    [sym_preproc_region] = STATE(2530),
    [sym_preproc_endregion] = STATE(2530),
    [sym_preproc_line] = STATE(2530),
    [sym_preproc_pragma] = STATE(2530),
    [sym_preproc_nullable] = STATE(2530),
    [sym_preproc_error] = STATE(2530),
    [sym_preproc_define] = STATE(2530),
    [sym_preproc_undef] = STATE(2530),
    [ts_builtin_sym_end] = ACTIONS(3930),
    [sym__identifier_token] = ACTIONS(3928),
    [anon_sym_extern] = ACTIONS(3928),
    [anon_sym_alias] = ACTIONS(3928),
    [anon_sym_SEMI] = ACTIONS(3930),
    [anon_sym_global] = ACTIONS(3928),
    [anon_sym_using] = ACTIONS(3928),
    [anon_sym_unsafe] = ACTIONS(3928),
    [anon_sym_static] = ACTIONS(3928),
    [anon_sym_LBRACK] = ACTIONS(3930),
    [anon_sym_LPAREN] = ACTIONS(3930),
    [anon_sym_return] = ACTIONS(3928),
    [anon_sym_namespace] = ACTIONS(3928),
    [anon_sym_class] = ACTIONS(3928),
    [anon_sym_ref] = ACTIONS(3928),
    [anon_sym_struct] = ACTIONS(3928),
    [anon_sym_enum] = ACTIONS(3928),
    [anon_sym_LBRACE] = ACTIONS(3930),
    [anon_sym_interface] = ACTIONS(3928),
    [anon_sym_delegate] = ACTIONS(3928),
    [anon_sym_record] = ACTIONS(3928),
    [anon_sym_abstract] = ACTIONS(3928),
    [anon_sym_async] = ACTIONS(3928),
    [anon_sym_const] = ACTIONS(3928),
    [anon_sym_file] = ACTIONS(3928),
    [anon_sym_fixed] = ACTIONS(3928),
    [anon_sym_internal] = ACTIONS(3928),
    [anon_sym_new] = ACTIONS(3928),
    [anon_sym_override] = ACTIONS(3928),
    [anon_sym_partial] = ACTIONS(3928),
    [anon_sym_private] = ACTIONS(3928),
    [anon_sym_protected] = ACTIONS(3928),
    [anon_sym_public] = ACTIONS(3928),
    [anon_sym_readonly] = ACTIONS(3928),
    [anon_sym_required] = ACTIONS(3928),
    [anon_sym_sealed] = ACTIONS(3928),
    [anon_sym_virtual] = ACTIONS(3928),
    [anon_sym_volatile] = ACTIONS(3928),
    [anon_sym_where] = ACTIONS(3928),
    [anon_sym_notnull] = ACTIONS(3928),
    [anon_sym_unmanaged] = ACTIONS(3928),
    [anon_sym_checked] = ACTIONS(3928),
    [anon_sym_BANG] = ACTIONS(3930),
    [anon_sym_TILDE] = ACTIONS(3930),
    [anon_sym_PLUS_PLUS] = ACTIONS(3930),
    [anon_sym_DASH_DASH] = ACTIONS(3930),
    [anon_sym_true] = ACTIONS(3928),
    [anon_sym_false] = ACTIONS(3928),
    [anon_sym_PLUS] = ACTIONS(3928),
    [anon_sym_DASH] = ACTIONS(3928),
    [anon_sym_STAR] = ACTIONS(3930),
    [anon_sym_CARET] = ACTIONS(3930),
    [anon_sym_AMP] = ACTIONS(3930),
    [anon_sym_this] = ACTIONS(3928),
    [anon_sym_scoped] = ACTIONS(3928),
    [anon_sym_var] = ACTIONS(3928),
    [sym_predefined_type] = ACTIONS(3928),
    [anon_sym_break] = ACTIONS(3928),
    [anon_sym_unchecked] = ACTIONS(3928),
    [anon_sym_continue] = ACTIONS(3928),
    [anon_sym_do] = ACTIONS(3928),
    [anon_sym_while] = ACTIONS(3928),
    [anon_sym_for] = ACTIONS(3928),
    [anon_sym_lock] = ACTIONS(3928),
    [anon_sym_yield] = ACTIONS(3928),
    [anon_sym_switch] = ACTIONS(3928),
    [anon_sym_default] = ACTIONS(3928),
    [anon_sym_throw] = ACTIONS(3928),
    [anon_sym_try] = ACTIONS(3928),
    [anon_sym_when] = ACTIONS(3928),
    [anon_sym_await] = ACTIONS(3928),
    [anon_sym_foreach] = ACTIONS(3928),
    [anon_sym_goto] = ACTIONS(3928),
    [anon_sym_if] = ACTIONS(3928),
    [anon_sym_DOT_DOT] = ACTIONS(3930),
    [anon_sym_from] = ACTIONS(3928),
    [anon_sym_into] = ACTIONS(3928),
    [anon_sym_join] = ACTIONS(3928),
    [anon_sym_on] = ACTIONS(3928),
    [anon_sym_equals] = ACTIONS(3928),
    [anon_sym_let] = ACTIONS(3928),
    [anon_sym_orderby] = ACTIONS(3928),
    [anon_sym_ascending] = ACTIONS(3928),
    [anon_sym_descending] = ACTIONS(3928),
    [anon_sym_group] = ACTIONS(3928),
    [anon_sym_by] = ACTIONS(3928),
    [anon_sym_select] = ACTIONS(3928),
    [anon_sym_DQUOTE] = ACTIONS(3928),
    [anon_sym_stackalloc] = ACTIONS(3928),
    [anon_sym_sizeof] = ACTIONS(3928),
    [anon_sym_typeof] = ACTIONS(3928),
    [anon_sym___makeref] = ACTIONS(3928),
    [anon_sym___reftype] = ACTIONS(3928),
    [anon_sym___refvalue] = ACTIONS(3928),
    [sym_null_literal] = ACTIONS(3928),
    [anon_sym_SQUOTE] = ACTIONS(3930),
    [sym_integer_literal] = ACTIONS(3928),
    [sym_real_literal] = ACTIONS(3930),
    [sym_verbatim_string_literal] = ACTIONS(3930),
    [sym_raw_string_literal] = ACTIONS(3930),
    [aux_sym_preproc_if_token1] = ACTIONS(3930),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3930),
    [sym_interpolation_verbatim_start] = ACTIONS(3930),
    [sym_interpolation_raw_start] = ACTIONS(3930),
  },
  [2531] = {
    [sym_preproc_region] = STATE(2531),
    [sym_preproc_endregion] = STATE(2531),
    [sym_preproc_line] = STATE(2531),
    [sym_preproc_pragma] = STATE(2531),
    [sym_preproc_nullable] = STATE(2531),
    [sym_preproc_error] = STATE(2531),
    [sym_preproc_define] = STATE(2531),
    [sym_preproc_undef] = STATE(2531),
    [ts_builtin_sym_end] = ACTIONS(3934),
    [sym__identifier_token] = ACTIONS(3932),
    [anon_sym_extern] = ACTIONS(3932),
    [anon_sym_alias] = ACTIONS(3932),
    [anon_sym_SEMI] = ACTIONS(3934),
    [anon_sym_global] = ACTIONS(3932),
    [anon_sym_using] = ACTIONS(3932),
    [anon_sym_unsafe] = ACTIONS(3932),
    [anon_sym_static] = ACTIONS(3932),
    [anon_sym_LBRACK] = ACTIONS(3934),
    [anon_sym_LPAREN] = ACTIONS(3934),
    [anon_sym_return] = ACTIONS(3932),
    [anon_sym_namespace] = ACTIONS(3932),
    [anon_sym_class] = ACTIONS(3932),
    [anon_sym_ref] = ACTIONS(3932),
    [anon_sym_struct] = ACTIONS(3932),
    [anon_sym_enum] = ACTIONS(3932),
    [anon_sym_LBRACE] = ACTIONS(3934),
    [anon_sym_interface] = ACTIONS(3932),
    [anon_sym_delegate] = ACTIONS(3932),
    [anon_sym_record] = ACTIONS(3932),
    [anon_sym_abstract] = ACTIONS(3932),
    [anon_sym_async] = ACTIONS(3932),
    [anon_sym_const] = ACTIONS(3932),
    [anon_sym_file] = ACTIONS(3932),
    [anon_sym_fixed] = ACTIONS(3932),
    [anon_sym_internal] = ACTIONS(3932),
    [anon_sym_new] = ACTIONS(3932),
    [anon_sym_override] = ACTIONS(3932),
    [anon_sym_partial] = ACTIONS(3932),
    [anon_sym_private] = ACTIONS(3932),
    [anon_sym_protected] = ACTIONS(3932),
    [anon_sym_public] = ACTIONS(3932),
    [anon_sym_readonly] = ACTIONS(3932),
    [anon_sym_required] = ACTIONS(3932),
    [anon_sym_sealed] = ACTIONS(3932),
    [anon_sym_virtual] = ACTIONS(3932),
    [anon_sym_volatile] = ACTIONS(3932),
    [anon_sym_where] = ACTIONS(3932),
    [anon_sym_notnull] = ACTIONS(3932),
    [anon_sym_unmanaged] = ACTIONS(3932),
    [anon_sym_checked] = ACTIONS(3932),
    [anon_sym_BANG] = ACTIONS(3934),
    [anon_sym_TILDE] = ACTIONS(3934),
    [anon_sym_PLUS_PLUS] = ACTIONS(3934),
    [anon_sym_DASH_DASH] = ACTIONS(3934),
    [anon_sym_true] = ACTIONS(3932),
    [anon_sym_false] = ACTIONS(3932),
    [anon_sym_PLUS] = ACTIONS(3932),
    [anon_sym_DASH] = ACTIONS(3932),
    [anon_sym_STAR] = ACTIONS(3934),
    [anon_sym_CARET] = ACTIONS(3934),
    [anon_sym_AMP] = ACTIONS(3934),
    [anon_sym_this] = ACTIONS(3932),
    [anon_sym_scoped] = ACTIONS(3932),
    [anon_sym_var] = ACTIONS(3932),
    [sym_predefined_type] = ACTIONS(3932),
    [anon_sym_break] = ACTIONS(3932),
    [anon_sym_unchecked] = ACTIONS(3932),
    [anon_sym_continue] = ACTIONS(3932),
    [anon_sym_do] = ACTIONS(3932),
    [anon_sym_while] = ACTIONS(3932),
    [anon_sym_for] = ACTIONS(3932),
    [anon_sym_lock] = ACTIONS(3932),
    [anon_sym_yield] = ACTIONS(3932),
    [anon_sym_switch] = ACTIONS(3932),
    [anon_sym_default] = ACTIONS(3932),
    [anon_sym_throw] = ACTIONS(3932),
    [anon_sym_try] = ACTIONS(3932),
    [anon_sym_when] = ACTIONS(3932),
    [anon_sym_await] = ACTIONS(3932),
    [anon_sym_foreach] = ACTIONS(3932),
    [anon_sym_goto] = ACTIONS(3932),
    [anon_sym_if] = ACTIONS(3932),
    [anon_sym_DOT_DOT] = ACTIONS(3934),
    [anon_sym_from] = ACTIONS(3932),
    [anon_sym_into] = ACTIONS(3932),
    [anon_sym_join] = ACTIONS(3932),
    [anon_sym_on] = ACTIONS(3932),
    [anon_sym_equals] = ACTIONS(3932),
    [anon_sym_let] = ACTIONS(3932),
    [anon_sym_orderby] = ACTIONS(3932),
    [anon_sym_ascending] = ACTIONS(3932),
    [anon_sym_descending] = ACTIONS(3932),
    [anon_sym_group] = ACTIONS(3932),
    [anon_sym_by] = ACTIONS(3932),
    [anon_sym_select] = ACTIONS(3932),
    [anon_sym_DQUOTE] = ACTIONS(3932),
    [anon_sym_stackalloc] = ACTIONS(3932),
    [anon_sym_sizeof] = ACTIONS(3932),
    [anon_sym_typeof] = ACTIONS(3932),
    [anon_sym___makeref] = ACTIONS(3932),
    [anon_sym___reftype] = ACTIONS(3932),
    [anon_sym___refvalue] = ACTIONS(3932),
    [sym_null_literal] = ACTIONS(3932),
    [anon_sym_SQUOTE] = ACTIONS(3934),
    [sym_integer_literal] = ACTIONS(3932),
    [sym_real_literal] = ACTIONS(3934),
    [sym_verbatim_string_literal] = ACTIONS(3934),
    [sym_raw_string_literal] = ACTIONS(3934),
    [aux_sym_preproc_if_token1] = ACTIONS(3934),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3934),
    [sym_interpolation_verbatim_start] = ACTIONS(3934),
    [sym_interpolation_raw_start] = ACTIONS(3934),
  },
  [2532] = {
    [sym_preproc_region] = STATE(2532),
    [sym_preproc_endregion] = STATE(2532),
    [sym_preproc_line] = STATE(2532),
    [sym_preproc_pragma] = STATE(2532),
    [sym_preproc_nullable] = STATE(2532),
    [sym_preproc_error] = STATE(2532),
    [sym_preproc_define] = STATE(2532),
    [sym_preproc_undef] = STATE(2532),
    [ts_builtin_sym_end] = ACTIONS(3699),
    [sym__identifier_token] = ACTIONS(3697),
    [anon_sym_extern] = ACTIONS(3697),
    [anon_sym_alias] = ACTIONS(3697),
    [anon_sym_SEMI] = ACTIONS(3699),
    [anon_sym_global] = ACTIONS(3697),
    [anon_sym_using] = ACTIONS(3697),
    [anon_sym_unsafe] = ACTIONS(3697),
    [anon_sym_static] = ACTIONS(3697),
    [anon_sym_LBRACK] = ACTIONS(3699),
    [anon_sym_LPAREN] = ACTIONS(3699),
    [anon_sym_return] = ACTIONS(3697),
    [anon_sym_namespace] = ACTIONS(3697),
    [anon_sym_class] = ACTIONS(3697),
    [anon_sym_ref] = ACTIONS(3697),
    [anon_sym_struct] = ACTIONS(3697),
    [anon_sym_enum] = ACTIONS(3697),
    [anon_sym_LBRACE] = ACTIONS(3699),
    [anon_sym_interface] = ACTIONS(3697),
    [anon_sym_delegate] = ACTIONS(3697),
    [anon_sym_record] = ACTIONS(3697),
    [anon_sym_abstract] = ACTIONS(3697),
    [anon_sym_async] = ACTIONS(3697),
    [anon_sym_const] = ACTIONS(3697),
    [anon_sym_file] = ACTIONS(3697),
    [anon_sym_fixed] = ACTIONS(3697),
    [anon_sym_internal] = ACTIONS(3697),
    [anon_sym_new] = ACTIONS(3697),
    [anon_sym_override] = ACTIONS(3697),
    [anon_sym_partial] = ACTIONS(3697),
    [anon_sym_private] = ACTIONS(3697),
    [anon_sym_protected] = ACTIONS(3697),
    [anon_sym_public] = ACTIONS(3697),
    [anon_sym_readonly] = ACTIONS(3697),
    [anon_sym_required] = ACTIONS(3697),
    [anon_sym_sealed] = ACTIONS(3697),
    [anon_sym_virtual] = ACTIONS(3697),
    [anon_sym_volatile] = ACTIONS(3697),
    [anon_sym_where] = ACTIONS(3697),
    [anon_sym_notnull] = ACTIONS(3697),
    [anon_sym_unmanaged] = ACTIONS(3697),
    [anon_sym_checked] = ACTIONS(3697),
    [anon_sym_BANG] = ACTIONS(3699),
    [anon_sym_TILDE] = ACTIONS(3699),
    [anon_sym_PLUS_PLUS] = ACTIONS(3699),
    [anon_sym_DASH_DASH] = ACTIONS(3699),
    [anon_sym_true] = ACTIONS(3697),
    [anon_sym_false] = ACTIONS(3697),
    [anon_sym_PLUS] = ACTIONS(3697),
    [anon_sym_DASH] = ACTIONS(3697),
    [anon_sym_STAR] = ACTIONS(3699),
    [anon_sym_CARET] = ACTIONS(3699),
    [anon_sym_AMP] = ACTIONS(3699),
    [anon_sym_this] = ACTIONS(3697),
    [anon_sym_scoped] = ACTIONS(3697),
    [anon_sym_var] = ACTIONS(3697),
    [sym_predefined_type] = ACTIONS(3697),
    [anon_sym_break] = ACTIONS(3697),
    [anon_sym_unchecked] = ACTIONS(3697),
    [anon_sym_continue] = ACTIONS(3697),
    [anon_sym_do] = ACTIONS(3697),
    [anon_sym_while] = ACTIONS(3697),
    [anon_sym_for] = ACTIONS(3697),
    [anon_sym_lock] = ACTIONS(3697),
    [anon_sym_yield] = ACTIONS(3697),
    [anon_sym_switch] = ACTIONS(3697),
    [anon_sym_default] = ACTIONS(3697),
    [anon_sym_throw] = ACTIONS(3697),
    [anon_sym_try] = ACTIONS(3697),
    [anon_sym_when] = ACTIONS(3697),
    [anon_sym_await] = ACTIONS(3697),
    [anon_sym_foreach] = ACTIONS(3697),
    [anon_sym_goto] = ACTIONS(3697),
    [anon_sym_if] = ACTIONS(3697),
    [anon_sym_DOT_DOT] = ACTIONS(3699),
    [anon_sym_from] = ACTIONS(3697),
    [anon_sym_into] = ACTIONS(3697),
    [anon_sym_join] = ACTIONS(3697),
    [anon_sym_on] = ACTIONS(3697),
    [anon_sym_equals] = ACTIONS(3697),
    [anon_sym_let] = ACTIONS(3697),
    [anon_sym_orderby] = ACTIONS(3697),
    [anon_sym_ascending] = ACTIONS(3697),
    [anon_sym_descending] = ACTIONS(3697),
    [anon_sym_group] = ACTIONS(3697),
    [anon_sym_by] = ACTIONS(3697),
    [anon_sym_select] = ACTIONS(3697),
    [anon_sym_DQUOTE] = ACTIONS(3697),
    [anon_sym_stackalloc] = ACTIONS(3697),
    [anon_sym_sizeof] = ACTIONS(3697),
    [anon_sym_typeof] = ACTIONS(3697),
    [anon_sym___makeref] = ACTIONS(3697),
    [anon_sym___reftype] = ACTIONS(3697),
    [anon_sym___refvalue] = ACTIONS(3697),
    [sym_null_literal] = ACTIONS(3697),
    [anon_sym_SQUOTE] = ACTIONS(3699),
    [sym_integer_literal] = ACTIONS(3697),
    [sym_real_literal] = ACTIONS(3699),
    [sym_verbatim_string_literal] = ACTIONS(3699),
    [sym_raw_string_literal] = ACTIONS(3699),
    [aux_sym_preproc_if_token1] = ACTIONS(3699),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3699),
    [sym_interpolation_verbatim_start] = ACTIONS(3699),
    [sym_interpolation_raw_start] = ACTIONS(3699),
  },
  [2533] = {
    [sym_preproc_region] = STATE(2533),
    [sym_preproc_endregion] = STATE(2533),
    [sym_preproc_line] = STATE(2533),
    [sym_preproc_pragma] = STATE(2533),
    [sym_preproc_nullable] = STATE(2533),
    [sym_preproc_error] = STATE(2533),
    [sym_preproc_define] = STATE(2533),
    [sym_preproc_undef] = STATE(2533),
    [ts_builtin_sym_end] = ACTIONS(3938),
    [sym__identifier_token] = ACTIONS(3936),
    [anon_sym_extern] = ACTIONS(3936),
    [anon_sym_alias] = ACTIONS(3936),
    [anon_sym_SEMI] = ACTIONS(3938),
    [anon_sym_global] = ACTIONS(3936),
    [anon_sym_using] = ACTIONS(3936),
    [anon_sym_unsafe] = ACTIONS(3936),
    [anon_sym_static] = ACTIONS(3936),
    [anon_sym_LBRACK] = ACTIONS(3938),
    [anon_sym_LPAREN] = ACTIONS(3938),
    [anon_sym_return] = ACTIONS(3936),
    [anon_sym_namespace] = ACTIONS(3936),
    [anon_sym_class] = ACTIONS(3936),
    [anon_sym_ref] = ACTIONS(3936),
    [anon_sym_struct] = ACTIONS(3936),
    [anon_sym_enum] = ACTIONS(3936),
    [anon_sym_LBRACE] = ACTIONS(3938),
    [anon_sym_interface] = ACTIONS(3936),
    [anon_sym_delegate] = ACTIONS(3936),
    [anon_sym_record] = ACTIONS(3936),
    [anon_sym_abstract] = ACTIONS(3936),
    [anon_sym_async] = ACTIONS(3936),
    [anon_sym_const] = ACTIONS(3936),
    [anon_sym_file] = ACTIONS(3936),
    [anon_sym_fixed] = ACTIONS(3936),
    [anon_sym_internal] = ACTIONS(3936),
    [anon_sym_new] = ACTIONS(3936),
    [anon_sym_override] = ACTIONS(3936),
    [anon_sym_partial] = ACTIONS(3936),
    [anon_sym_private] = ACTIONS(3936),
    [anon_sym_protected] = ACTIONS(3936),
    [anon_sym_public] = ACTIONS(3936),
    [anon_sym_readonly] = ACTIONS(3936),
    [anon_sym_required] = ACTIONS(3936),
    [anon_sym_sealed] = ACTIONS(3936),
    [anon_sym_virtual] = ACTIONS(3936),
    [anon_sym_volatile] = ACTIONS(3936),
    [anon_sym_where] = ACTIONS(3936),
    [anon_sym_notnull] = ACTIONS(3936),
    [anon_sym_unmanaged] = ACTIONS(3936),
    [anon_sym_checked] = ACTIONS(3936),
    [anon_sym_BANG] = ACTIONS(3938),
    [anon_sym_TILDE] = ACTIONS(3938),
    [anon_sym_PLUS_PLUS] = ACTIONS(3938),
    [anon_sym_DASH_DASH] = ACTIONS(3938),
    [anon_sym_true] = ACTIONS(3936),
    [anon_sym_false] = ACTIONS(3936),
    [anon_sym_PLUS] = ACTIONS(3936),
    [anon_sym_DASH] = ACTIONS(3936),
    [anon_sym_STAR] = ACTIONS(3938),
    [anon_sym_CARET] = ACTIONS(3938),
    [anon_sym_AMP] = ACTIONS(3938),
    [anon_sym_this] = ACTIONS(3936),
    [anon_sym_scoped] = ACTIONS(3936),
    [anon_sym_var] = ACTIONS(3936),
    [sym_predefined_type] = ACTIONS(3936),
    [anon_sym_break] = ACTIONS(3936),
    [anon_sym_unchecked] = ACTIONS(3936),
    [anon_sym_continue] = ACTIONS(3936),
    [anon_sym_do] = ACTIONS(3936),
    [anon_sym_while] = ACTIONS(3936),
    [anon_sym_for] = ACTIONS(3936),
    [anon_sym_lock] = ACTIONS(3936),
    [anon_sym_yield] = ACTIONS(3936),
    [anon_sym_switch] = ACTIONS(3936),
    [anon_sym_default] = ACTIONS(3936),
    [anon_sym_throw] = ACTIONS(3936),
    [anon_sym_try] = ACTIONS(3936),
    [anon_sym_when] = ACTIONS(3936),
    [anon_sym_await] = ACTIONS(3936),
    [anon_sym_foreach] = ACTIONS(3936),
    [anon_sym_goto] = ACTIONS(3936),
    [anon_sym_if] = ACTIONS(3936),
    [anon_sym_DOT_DOT] = ACTIONS(3938),
    [anon_sym_from] = ACTIONS(3936),
    [anon_sym_into] = ACTIONS(3936),
    [anon_sym_join] = ACTIONS(3936),
    [anon_sym_on] = ACTIONS(3936),
    [anon_sym_equals] = ACTIONS(3936),
    [anon_sym_let] = ACTIONS(3936),
    [anon_sym_orderby] = ACTIONS(3936),
    [anon_sym_ascending] = ACTIONS(3936),
    [anon_sym_descending] = ACTIONS(3936),
    [anon_sym_group] = ACTIONS(3936),
    [anon_sym_by] = ACTIONS(3936),
    [anon_sym_select] = ACTIONS(3936),
    [anon_sym_DQUOTE] = ACTIONS(3936),
    [anon_sym_stackalloc] = ACTIONS(3936),
    [anon_sym_sizeof] = ACTIONS(3936),
    [anon_sym_typeof] = ACTIONS(3936),
    [anon_sym___makeref] = ACTIONS(3936),
    [anon_sym___reftype] = ACTIONS(3936),
    [anon_sym___refvalue] = ACTIONS(3936),
    [sym_null_literal] = ACTIONS(3936),
    [anon_sym_SQUOTE] = ACTIONS(3938),
    [sym_integer_literal] = ACTIONS(3936),
    [sym_real_literal] = ACTIONS(3938),
    [sym_verbatim_string_literal] = ACTIONS(3938),
    [sym_raw_string_literal] = ACTIONS(3938),
    [aux_sym_preproc_if_token1] = ACTIONS(3938),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3938),
    [sym_interpolation_verbatim_start] = ACTIONS(3938),
    [sym_interpolation_raw_start] = ACTIONS(3938),
  },
  [2534] = {
    [sym_preproc_region] = STATE(2534),
    [sym_preproc_endregion] = STATE(2534),
    [sym_preproc_line] = STATE(2534),
    [sym_preproc_pragma] = STATE(2534),
    [sym_preproc_nullable] = STATE(2534),
    [sym_preproc_error] = STATE(2534),
    [sym_preproc_define] = STATE(2534),
    [sym_preproc_undef] = STATE(2534),
    [ts_builtin_sym_end] = ACTIONS(3942),
    [sym__identifier_token] = ACTIONS(3940),
    [anon_sym_extern] = ACTIONS(3940),
    [anon_sym_alias] = ACTIONS(3940),
    [anon_sym_SEMI] = ACTIONS(3942),
    [anon_sym_global] = ACTIONS(3940),
    [anon_sym_using] = ACTIONS(3940),
    [anon_sym_unsafe] = ACTIONS(3940),
    [anon_sym_static] = ACTIONS(3940),
    [anon_sym_LBRACK] = ACTIONS(3942),
    [anon_sym_LPAREN] = ACTIONS(3942),
    [anon_sym_return] = ACTIONS(3940),
    [anon_sym_namespace] = ACTIONS(3940),
    [anon_sym_class] = ACTIONS(3940),
    [anon_sym_ref] = ACTIONS(3940),
    [anon_sym_struct] = ACTIONS(3940),
    [anon_sym_enum] = ACTIONS(3940),
    [anon_sym_LBRACE] = ACTIONS(3942),
    [anon_sym_interface] = ACTIONS(3940),
    [anon_sym_delegate] = ACTIONS(3940),
    [anon_sym_record] = ACTIONS(3940),
    [anon_sym_abstract] = ACTIONS(3940),
    [anon_sym_async] = ACTIONS(3940),
    [anon_sym_const] = ACTIONS(3940),
    [anon_sym_file] = ACTIONS(3940),
    [anon_sym_fixed] = ACTIONS(3940),
    [anon_sym_internal] = ACTIONS(3940),
    [anon_sym_new] = ACTIONS(3940),
    [anon_sym_override] = ACTIONS(3940),
    [anon_sym_partial] = ACTIONS(3940),
    [anon_sym_private] = ACTIONS(3940),
    [anon_sym_protected] = ACTIONS(3940),
    [anon_sym_public] = ACTIONS(3940),
    [anon_sym_readonly] = ACTIONS(3940),
    [anon_sym_required] = ACTIONS(3940),
    [anon_sym_sealed] = ACTIONS(3940),
    [anon_sym_virtual] = ACTIONS(3940),
    [anon_sym_volatile] = ACTIONS(3940),
    [anon_sym_where] = ACTIONS(3940),
    [anon_sym_notnull] = ACTIONS(3940),
    [anon_sym_unmanaged] = ACTIONS(3940),
    [anon_sym_checked] = ACTIONS(3940),
    [anon_sym_BANG] = ACTIONS(3942),
    [anon_sym_TILDE] = ACTIONS(3942),
    [anon_sym_PLUS_PLUS] = ACTIONS(3942),
    [anon_sym_DASH_DASH] = ACTIONS(3942),
    [anon_sym_true] = ACTIONS(3940),
    [anon_sym_false] = ACTIONS(3940),
    [anon_sym_PLUS] = ACTIONS(3940),
    [anon_sym_DASH] = ACTIONS(3940),
    [anon_sym_STAR] = ACTIONS(3942),
    [anon_sym_CARET] = ACTIONS(3942),
    [anon_sym_AMP] = ACTIONS(3942),
    [anon_sym_this] = ACTIONS(3940),
    [anon_sym_scoped] = ACTIONS(3940),
    [anon_sym_var] = ACTIONS(3940),
    [sym_predefined_type] = ACTIONS(3940),
    [anon_sym_break] = ACTIONS(3940),
    [anon_sym_unchecked] = ACTIONS(3940),
    [anon_sym_continue] = ACTIONS(3940),
    [anon_sym_do] = ACTIONS(3940),
    [anon_sym_while] = ACTIONS(3940),
    [anon_sym_for] = ACTIONS(3940),
    [anon_sym_lock] = ACTIONS(3940),
    [anon_sym_yield] = ACTIONS(3940),
    [anon_sym_switch] = ACTIONS(3940),
    [anon_sym_default] = ACTIONS(3940),
    [anon_sym_throw] = ACTIONS(3940),
    [anon_sym_try] = ACTIONS(3940),
    [anon_sym_when] = ACTIONS(3940),
    [anon_sym_await] = ACTIONS(3940),
    [anon_sym_foreach] = ACTIONS(3940),
    [anon_sym_goto] = ACTIONS(3940),
    [anon_sym_if] = ACTIONS(3940),
    [anon_sym_DOT_DOT] = ACTIONS(3942),
    [anon_sym_from] = ACTIONS(3940),
    [anon_sym_into] = ACTIONS(3940),
    [anon_sym_join] = ACTIONS(3940),
    [anon_sym_on] = ACTIONS(3940),
    [anon_sym_equals] = ACTIONS(3940),
    [anon_sym_let] = ACTIONS(3940),
    [anon_sym_orderby] = ACTIONS(3940),
    [anon_sym_ascending] = ACTIONS(3940),
    [anon_sym_descending] = ACTIONS(3940),
    [anon_sym_group] = ACTIONS(3940),
    [anon_sym_by] = ACTIONS(3940),
    [anon_sym_select] = ACTIONS(3940),
    [anon_sym_DQUOTE] = ACTIONS(3940),
    [anon_sym_stackalloc] = ACTIONS(3940),
    [anon_sym_sizeof] = ACTIONS(3940),
    [anon_sym_typeof] = ACTIONS(3940),
    [anon_sym___makeref] = ACTIONS(3940),
    [anon_sym___reftype] = ACTIONS(3940),
    [anon_sym___refvalue] = ACTIONS(3940),
    [sym_null_literal] = ACTIONS(3940),
    [anon_sym_SQUOTE] = ACTIONS(3942),
    [sym_integer_literal] = ACTIONS(3940),
    [sym_real_literal] = ACTIONS(3942),
    [sym_verbatim_string_literal] = ACTIONS(3942),
    [sym_raw_string_literal] = ACTIONS(3942),
    [aux_sym_preproc_if_token1] = ACTIONS(3942),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3942),
    [sym_interpolation_verbatim_start] = ACTIONS(3942),
    [sym_interpolation_raw_start] = ACTIONS(3942),
  },
  [2535] = {
    [sym_preproc_region] = STATE(2535),
    [sym_preproc_endregion] = STATE(2535),
    [sym_preproc_line] = STATE(2535),
    [sym_preproc_pragma] = STATE(2535),
    [sym_preproc_nullable] = STATE(2535),
    [sym_preproc_error] = STATE(2535),
    [sym_preproc_define] = STATE(2535),
    [sym_preproc_undef] = STATE(2535),
    [ts_builtin_sym_end] = ACTIONS(3603),
    [sym__identifier_token] = ACTIONS(3601),
    [anon_sym_extern] = ACTIONS(3601),
    [anon_sym_alias] = ACTIONS(3601),
    [anon_sym_SEMI] = ACTIONS(3603),
    [anon_sym_global] = ACTIONS(3601),
    [anon_sym_using] = ACTIONS(3601),
    [anon_sym_unsafe] = ACTIONS(3601),
    [anon_sym_static] = ACTIONS(3601),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_LPAREN] = ACTIONS(3603),
    [anon_sym_return] = ACTIONS(3601),
    [anon_sym_namespace] = ACTIONS(3601),
    [anon_sym_class] = ACTIONS(3601),
    [anon_sym_ref] = ACTIONS(3601),
    [anon_sym_struct] = ACTIONS(3601),
    [anon_sym_enum] = ACTIONS(3601),
    [anon_sym_LBRACE] = ACTIONS(3603),
    [anon_sym_interface] = ACTIONS(3601),
    [anon_sym_delegate] = ACTIONS(3601),
    [anon_sym_record] = ACTIONS(3601),
    [anon_sym_abstract] = ACTIONS(3601),
    [anon_sym_async] = ACTIONS(3601),
    [anon_sym_const] = ACTIONS(3601),
    [anon_sym_file] = ACTIONS(3601),
    [anon_sym_fixed] = ACTIONS(3601),
    [anon_sym_internal] = ACTIONS(3601),
    [anon_sym_new] = ACTIONS(3601),
    [anon_sym_override] = ACTIONS(3601),
    [anon_sym_partial] = ACTIONS(3601),
    [anon_sym_private] = ACTIONS(3601),
    [anon_sym_protected] = ACTIONS(3601),
    [anon_sym_public] = ACTIONS(3601),
    [anon_sym_readonly] = ACTIONS(3601),
    [anon_sym_required] = ACTIONS(3601),
    [anon_sym_sealed] = ACTIONS(3601),
    [anon_sym_virtual] = ACTIONS(3601),
    [anon_sym_volatile] = ACTIONS(3601),
    [anon_sym_where] = ACTIONS(3601),
    [anon_sym_notnull] = ACTIONS(3601),
    [anon_sym_unmanaged] = ACTIONS(3601),
    [anon_sym_checked] = ACTIONS(3601),
    [anon_sym_BANG] = ACTIONS(3603),
    [anon_sym_TILDE] = ACTIONS(3603),
    [anon_sym_PLUS_PLUS] = ACTIONS(3603),
    [anon_sym_DASH_DASH] = ACTIONS(3603),
    [anon_sym_true] = ACTIONS(3601),
    [anon_sym_false] = ACTIONS(3601),
    [anon_sym_PLUS] = ACTIONS(3601),
    [anon_sym_DASH] = ACTIONS(3601),
    [anon_sym_STAR] = ACTIONS(3603),
    [anon_sym_CARET] = ACTIONS(3603),
    [anon_sym_AMP] = ACTIONS(3603),
    [anon_sym_this] = ACTIONS(3601),
    [anon_sym_scoped] = ACTIONS(3601),
    [anon_sym_var] = ACTIONS(3601),
    [sym_predefined_type] = ACTIONS(3601),
    [anon_sym_break] = ACTIONS(3601),
    [anon_sym_unchecked] = ACTIONS(3601),
    [anon_sym_continue] = ACTIONS(3601),
    [anon_sym_do] = ACTIONS(3601),
    [anon_sym_while] = ACTIONS(3601),
    [anon_sym_for] = ACTIONS(3601),
    [anon_sym_lock] = ACTIONS(3601),
    [anon_sym_yield] = ACTIONS(3601),
    [anon_sym_switch] = ACTIONS(3601),
    [anon_sym_default] = ACTIONS(3601),
    [anon_sym_throw] = ACTIONS(3601),
    [anon_sym_try] = ACTIONS(3601),
    [anon_sym_when] = ACTIONS(3601),
    [anon_sym_await] = ACTIONS(3601),
    [anon_sym_foreach] = ACTIONS(3601),
    [anon_sym_goto] = ACTIONS(3601),
    [anon_sym_if] = ACTIONS(3601),
    [anon_sym_DOT_DOT] = ACTIONS(3603),
    [anon_sym_from] = ACTIONS(3601),
    [anon_sym_into] = ACTIONS(3601),
    [anon_sym_join] = ACTIONS(3601),
    [anon_sym_on] = ACTIONS(3601),
    [anon_sym_equals] = ACTIONS(3601),
    [anon_sym_let] = ACTIONS(3601),
    [anon_sym_orderby] = ACTIONS(3601),
    [anon_sym_ascending] = ACTIONS(3601),
    [anon_sym_descending] = ACTIONS(3601),
    [anon_sym_group] = ACTIONS(3601),
    [anon_sym_by] = ACTIONS(3601),
    [anon_sym_select] = ACTIONS(3601),
    [anon_sym_DQUOTE] = ACTIONS(3601),
    [anon_sym_stackalloc] = ACTIONS(3601),
    [anon_sym_sizeof] = ACTIONS(3601),
    [anon_sym_typeof] = ACTIONS(3601),
    [anon_sym___makeref] = ACTIONS(3601),
    [anon_sym___reftype] = ACTIONS(3601),
    [anon_sym___refvalue] = ACTIONS(3601),
    [sym_null_literal] = ACTIONS(3601),
    [anon_sym_SQUOTE] = ACTIONS(3603),
    [sym_integer_literal] = ACTIONS(3601),
    [sym_real_literal] = ACTIONS(3603),
    [sym_verbatim_string_literal] = ACTIONS(3603),
    [sym_raw_string_literal] = ACTIONS(3603),
    [aux_sym_preproc_if_token1] = ACTIONS(3603),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3603),
    [sym_interpolation_verbatim_start] = ACTIONS(3603),
    [sym_interpolation_raw_start] = ACTIONS(3603),
  },
  [2536] = {
    [sym_preproc_region] = STATE(2536),
    [sym_preproc_endregion] = STATE(2536),
    [sym_preproc_line] = STATE(2536),
    [sym_preproc_pragma] = STATE(2536),
    [sym_preproc_nullable] = STATE(2536),
    [sym_preproc_error] = STATE(2536),
    [sym_preproc_define] = STATE(2536),
    [sym_preproc_undef] = STATE(2536),
    [ts_builtin_sym_end] = ACTIONS(3774),
    [sym__identifier_token] = ACTIONS(3772),
    [anon_sym_extern] = ACTIONS(3772),
    [anon_sym_alias] = ACTIONS(3772),
    [anon_sym_SEMI] = ACTIONS(3774),
    [anon_sym_global] = ACTIONS(3772),
    [anon_sym_using] = ACTIONS(3772),
    [anon_sym_unsafe] = ACTIONS(3772),
    [anon_sym_static] = ACTIONS(3772),
    [anon_sym_LBRACK] = ACTIONS(3774),
    [anon_sym_LPAREN] = ACTIONS(3774),
    [anon_sym_return] = ACTIONS(3772),
    [anon_sym_namespace] = ACTIONS(3772),
    [anon_sym_class] = ACTIONS(3772),
    [anon_sym_ref] = ACTIONS(3772),
    [anon_sym_struct] = ACTIONS(3772),
    [anon_sym_enum] = ACTIONS(3772),
    [anon_sym_LBRACE] = ACTIONS(3774),
    [anon_sym_interface] = ACTIONS(3772),
    [anon_sym_delegate] = ACTIONS(3772),
    [anon_sym_record] = ACTIONS(3772),
    [anon_sym_abstract] = ACTIONS(3772),
    [anon_sym_async] = ACTIONS(3772),
    [anon_sym_const] = ACTIONS(3772),
    [anon_sym_file] = ACTIONS(3772),
    [anon_sym_fixed] = ACTIONS(3772),
    [anon_sym_internal] = ACTIONS(3772),
    [anon_sym_new] = ACTIONS(3772),
    [anon_sym_override] = ACTIONS(3772),
    [anon_sym_partial] = ACTIONS(3772),
    [anon_sym_private] = ACTIONS(3772),
    [anon_sym_protected] = ACTIONS(3772),
    [anon_sym_public] = ACTIONS(3772),
    [anon_sym_readonly] = ACTIONS(3772),
    [anon_sym_required] = ACTIONS(3772),
    [anon_sym_sealed] = ACTIONS(3772),
    [anon_sym_virtual] = ACTIONS(3772),
    [anon_sym_volatile] = ACTIONS(3772),
    [anon_sym_where] = ACTIONS(3772),
    [anon_sym_notnull] = ACTIONS(3772),
    [anon_sym_unmanaged] = ACTIONS(3772),
    [anon_sym_checked] = ACTIONS(3772),
    [anon_sym_BANG] = ACTIONS(3774),
    [anon_sym_TILDE] = ACTIONS(3774),
    [anon_sym_PLUS_PLUS] = ACTIONS(3774),
    [anon_sym_DASH_DASH] = ACTIONS(3774),
    [anon_sym_true] = ACTIONS(3772),
    [anon_sym_false] = ACTIONS(3772),
    [anon_sym_PLUS] = ACTIONS(3772),
    [anon_sym_DASH] = ACTIONS(3772),
    [anon_sym_STAR] = ACTIONS(3774),
    [anon_sym_CARET] = ACTIONS(3774),
    [anon_sym_AMP] = ACTIONS(3774),
    [anon_sym_this] = ACTIONS(3772),
    [anon_sym_scoped] = ACTIONS(3772),
    [anon_sym_var] = ACTIONS(3772),
    [sym_predefined_type] = ACTIONS(3772),
    [anon_sym_break] = ACTIONS(3772),
    [anon_sym_unchecked] = ACTIONS(3772),
    [anon_sym_continue] = ACTIONS(3772),
    [anon_sym_do] = ACTIONS(3772),
    [anon_sym_while] = ACTIONS(3772),
    [anon_sym_for] = ACTIONS(3772),
    [anon_sym_lock] = ACTIONS(3772),
    [anon_sym_yield] = ACTIONS(3772),
    [anon_sym_switch] = ACTIONS(3772),
    [anon_sym_default] = ACTIONS(3772),
    [anon_sym_throw] = ACTIONS(3772),
    [anon_sym_try] = ACTIONS(3772),
    [anon_sym_when] = ACTIONS(3772),
    [anon_sym_await] = ACTIONS(3772),
    [anon_sym_foreach] = ACTIONS(3772),
    [anon_sym_goto] = ACTIONS(3772),
    [anon_sym_if] = ACTIONS(3772),
    [anon_sym_DOT_DOT] = ACTIONS(3774),
    [anon_sym_from] = ACTIONS(3772),
    [anon_sym_into] = ACTIONS(3772),
    [anon_sym_join] = ACTIONS(3772),
    [anon_sym_on] = ACTIONS(3772),
    [anon_sym_equals] = ACTIONS(3772),
    [anon_sym_let] = ACTIONS(3772),
    [anon_sym_orderby] = ACTIONS(3772),
    [anon_sym_ascending] = ACTIONS(3772),
    [anon_sym_descending] = ACTIONS(3772),
    [anon_sym_group] = ACTIONS(3772),
    [anon_sym_by] = ACTIONS(3772),
    [anon_sym_select] = ACTIONS(3772),
    [anon_sym_DQUOTE] = ACTIONS(3772),
    [anon_sym_stackalloc] = ACTIONS(3772),
    [anon_sym_sizeof] = ACTIONS(3772),
    [anon_sym_typeof] = ACTIONS(3772),
    [anon_sym___makeref] = ACTIONS(3772),
    [anon_sym___reftype] = ACTIONS(3772),
    [anon_sym___refvalue] = ACTIONS(3772),
    [sym_null_literal] = ACTIONS(3772),
    [anon_sym_SQUOTE] = ACTIONS(3774),
    [sym_integer_literal] = ACTIONS(3772),
    [sym_real_literal] = ACTIONS(3774),
    [sym_verbatim_string_literal] = ACTIONS(3774),
    [sym_raw_string_literal] = ACTIONS(3774),
    [aux_sym_preproc_if_token1] = ACTIONS(3774),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3774),
    [sym_interpolation_verbatim_start] = ACTIONS(3774),
    [sym_interpolation_raw_start] = ACTIONS(3774),
  },
  [2537] = {
    [sym_preproc_region] = STATE(2537),
    [sym_preproc_endregion] = STATE(2537),
    [sym_preproc_line] = STATE(2537),
    [sym_preproc_pragma] = STATE(2537),
    [sym_preproc_nullable] = STATE(2537),
    [sym_preproc_error] = STATE(2537),
    [sym_preproc_define] = STATE(2537),
    [sym_preproc_undef] = STATE(2537),
    [ts_builtin_sym_end] = ACTIONS(3451),
    [sym__identifier_token] = ACTIONS(3449),
    [anon_sym_extern] = ACTIONS(3449),
    [anon_sym_alias] = ACTIONS(3449),
    [anon_sym_SEMI] = ACTIONS(3451),
    [anon_sym_global] = ACTIONS(3449),
    [anon_sym_using] = ACTIONS(3449),
    [anon_sym_unsafe] = ACTIONS(3449),
    [anon_sym_static] = ACTIONS(3449),
    [anon_sym_LBRACK] = ACTIONS(3451),
    [anon_sym_LPAREN] = ACTIONS(3451),
    [anon_sym_return] = ACTIONS(3449),
    [anon_sym_namespace] = ACTIONS(3449),
    [anon_sym_class] = ACTIONS(3449),
    [anon_sym_ref] = ACTIONS(3449),
    [anon_sym_struct] = ACTIONS(3449),
    [anon_sym_enum] = ACTIONS(3449),
    [anon_sym_LBRACE] = ACTIONS(3451),
    [anon_sym_interface] = ACTIONS(3449),
    [anon_sym_delegate] = ACTIONS(3449),
    [anon_sym_record] = ACTIONS(3449),
    [anon_sym_abstract] = ACTIONS(3449),
    [anon_sym_async] = ACTIONS(3449),
    [anon_sym_const] = ACTIONS(3449),
    [anon_sym_file] = ACTIONS(3449),
    [anon_sym_fixed] = ACTIONS(3449),
    [anon_sym_internal] = ACTIONS(3449),
    [anon_sym_new] = ACTIONS(3449),
    [anon_sym_override] = ACTIONS(3449),
    [anon_sym_partial] = ACTIONS(3449),
    [anon_sym_private] = ACTIONS(3449),
    [anon_sym_protected] = ACTIONS(3449),
    [anon_sym_public] = ACTIONS(3449),
    [anon_sym_readonly] = ACTIONS(3449),
    [anon_sym_required] = ACTIONS(3449),
    [anon_sym_sealed] = ACTIONS(3449),
    [anon_sym_virtual] = ACTIONS(3449),
    [anon_sym_volatile] = ACTIONS(3449),
    [anon_sym_where] = ACTIONS(3449),
    [anon_sym_notnull] = ACTIONS(3449),
    [anon_sym_unmanaged] = ACTIONS(3449),
    [anon_sym_checked] = ACTIONS(3449),
    [anon_sym_BANG] = ACTIONS(3451),
    [anon_sym_TILDE] = ACTIONS(3451),
    [anon_sym_PLUS_PLUS] = ACTIONS(3451),
    [anon_sym_DASH_DASH] = ACTIONS(3451),
    [anon_sym_true] = ACTIONS(3449),
    [anon_sym_false] = ACTIONS(3449),
    [anon_sym_PLUS] = ACTIONS(3449),
    [anon_sym_DASH] = ACTIONS(3449),
    [anon_sym_STAR] = ACTIONS(3451),
    [anon_sym_CARET] = ACTIONS(3451),
    [anon_sym_AMP] = ACTIONS(3451),
    [anon_sym_this] = ACTIONS(3449),
    [anon_sym_scoped] = ACTIONS(3449),
    [anon_sym_var] = ACTIONS(3449),
    [sym_predefined_type] = ACTIONS(3449),
    [anon_sym_break] = ACTIONS(3449),
    [anon_sym_unchecked] = ACTIONS(3449),
    [anon_sym_continue] = ACTIONS(3449),
    [anon_sym_do] = ACTIONS(3449),
    [anon_sym_while] = ACTIONS(3449),
    [anon_sym_for] = ACTIONS(3449),
    [anon_sym_lock] = ACTIONS(3449),
    [anon_sym_yield] = ACTIONS(3449),
    [anon_sym_switch] = ACTIONS(3449),
    [anon_sym_default] = ACTIONS(3449),
    [anon_sym_throw] = ACTIONS(3449),
    [anon_sym_try] = ACTIONS(3449),
    [anon_sym_when] = ACTIONS(3449),
    [anon_sym_await] = ACTIONS(3449),
    [anon_sym_foreach] = ACTIONS(3449),
    [anon_sym_goto] = ACTIONS(3449),
    [anon_sym_if] = ACTIONS(3449),
    [anon_sym_DOT_DOT] = ACTIONS(3451),
    [anon_sym_from] = ACTIONS(3449),
    [anon_sym_into] = ACTIONS(3449),
    [anon_sym_join] = ACTIONS(3449),
    [anon_sym_on] = ACTIONS(3449),
    [anon_sym_equals] = ACTIONS(3449),
    [anon_sym_let] = ACTIONS(3449),
    [anon_sym_orderby] = ACTIONS(3449),
    [anon_sym_ascending] = ACTIONS(3449),
    [anon_sym_descending] = ACTIONS(3449),
    [anon_sym_group] = ACTIONS(3449),
    [anon_sym_by] = ACTIONS(3449),
    [anon_sym_select] = ACTIONS(3449),
    [anon_sym_DQUOTE] = ACTIONS(3449),
    [anon_sym_stackalloc] = ACTIONS(3449),
    [anon_sym_sizeof] = ACTIONS(3449),
    [anon_sym_typeof] = ACTIONS(3449),
    [anon_sym___makeref] = ACTIONS(3449),
    [anon_sym___reftype] = ACTIONS(3449),
    [anon_sym___refvalue] = ACTIONS(3449),
    [sym_null_literal] = ACTIONS(3449),
    [anon_sym_SQUOTE] = ACTIONS(3451),
    [sym_integer_literal] = ACTIONS(3449),
    [sym_real_literal] = ACTIONS(3451),
    [sym_verbatim_string_literal] = ACTIONS(3451),
    [sym_raw_string_literal] = ACTIONS(3451),
    [aux_sym_preproc_if_token1] = ACTIONS(3451),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3451),
    [sym_interpolation_verbatim_start] = ACTIONS(3451),
    [sym_interpolation_raw_start] = ACTIONS(3451),
  },
  [2538] = {
    [sym_preproc_region] = STATE(2538),
    [sym_preproc_endregion] = STATE(2538),
    [sym_preproc_line] = STATE(2538),
    [sym_preproc_pragma] = STATE(2538),
    [sym_preproc_nullable] = STATE(2538),
    [sym_preproc_error] = STATE(2538),
    [sym_preproc_define] = STATE(2538),
    [sym_preproc_undef] = STATE(2538),
    [ts_builtin_sym_end] = ACTIONS(3455),
    [sym__identifier_token] = ACTIONS(3453),
    [anon_sym_extern] = ACTIONS(3453),
    [anon_sym_alias] = ACTIONS(3453),
    [anon_sym_SEMI] = ACTIONS(3455),
    [anon_sym_global] = ACTIONS(3453),
    [anon_sym_using] = ACTIONS(3453),
    [anon_sym_unsafe] = ACTIONS(3453),
    [anon_sym_static] = ACTIONS(3453),
    [anon_sym_LBRACK] = ACTIONS(3455),
    [anon_sym_LPAREN] = ACTIONS(3455),
    [anon_sym_return] = ACTIONS(3453),
    [anon_sym_namespace] = ACTIONS(3453),
    [anon_sym_class] = ACTIONS(3453),
    [anon_sym_ref] = ACTIONS(3453),
    [anon_sym_struct] = ACTIONS(3453),
    [anon_sym_enum] = ACTIONS(3453),
    [anon_sym_LBRACE] = ACTIONS(3455),
    [anon_sym_interface] = ACTIONS(3453),
    [anon_sym_delegate] = ACTIONS(3453),
    [anon_sym_record] = ACTIONS(3453),
    [anon_sym_abstract] = ACTIONS(3453),
    [anon_sym_async] = ACTIONS(3453),
    [anon_sym_const] = ACTIONS(3453),
    [anon_sym_file] = ACTIONS(3453),
    [anon_sym_fixed] = ACTIONS(3453),
    [anon_sym_internal] = ACTIONS(3453),
    [anon_sym_new] = ACTIONS(3453),
    [anon_sym_override] = ACTIONS(3453),
    [anon_sym_partial] = ACTIONS(3453),
    [anon_sym_private] = ACTIONS(3453),
    [anon_sym_protected] = ACTIONS(3453),
    [anon_sym_public] = ACTIONS(3453),
    [anon_sym_readonly] = ACTIONS(3453),
    [anon_sym_required] = ACTIONS(3453),
    [anon_sym_sealed] = ACTIONS(3453),
    [anon_sym_virtual] = ACTIONS(3453),
    [anon_sym_volatile] = ACTIONS(3453),
    [anon_sym_where] = ACTIONS(3453),
    [anon_sym_notnull] = ACTIONS(3453),
    [anon_sym_unmanaged] = ACTIONS(3453),
    [anon_sym_checked] = ACTIONS(3453),
    [anon_sym_BANG] = ACTIONS(3455),
    [anon_sym_TILDE] = ACTIONS(3455),
    [anon_sym_PLUS_PLUS] = ACTIONS(3455),
    [anon_sym_DASH_DASH] = ACTIONS(3455),
    [anon_sym_true] = ACTIONS(3453),
    [anon_sym_false] = ACTIONS(3453),
    [anon_sym_PLUS] = ACTIONS(3453),
    [anon_sym_DASH] = ACTIONS(3453),
    [anon_sym_STAR] = ACTIONS(3455),
    [anon_sym_CARET] = ACTIONS(3455),
    [anon_sym_AMP] = ACTIONS(3455),
    [anon_sym_this] = ACTIONS(3453),
    [anon_sym_scoped] = ACTIONS(3453),
    [anon_sym_var] = ACTIONS(3453),
    [sym_predefined_type] = ACTIONS(3453),
    [anon_sym_break] = ACTIONS(3453),
    [anon_sym_unchecked] = ACTIONS(3453),
    [anon_sym_continue] = ACTIONS(3453),
    [anon_sym_do] = ACTIONS(3453),
    [anon_sym_while] = ACTIONS(3453),
    [anon_sym_for] = ACTIONS(3453),
    [anon_sym_lock] = ACTIONS(3453),
    [anon_sym_yield] = ACTIONS(3453),
    [anon_sym_switch] = ACTIONS(3453),
    [anon_sym_default] = ACTIONS(3453),
    [anon_sym_throw] = ACTIONS(3453),
    [anon_sym_try] = ACTIONS(3453),
    [anon_sym_when] = ACTIONS(3453),
    [anon_sym_await] = ACTIONS(3453),
    [anon_sym_foreach] = ACTIONS(3453),
    [anon_sym_goto] = ACTIONS(3453),
    [anon_sym_if] = ACTIONS(3453),
    [anon_sym_DOT_DOT] = ACTIONS(3455),
    [anon_sym_from] = ACTIONS(3453),
    [anon_sym_into] = ACTIONS(3453),
    [anon_sym_join] = ACTIONS(3453),
    [anon_sym_on] = ACTIONS(3453),
    [anon_sym_equals] = ACTIONS(3453),
    [anon_sym_let] = ACTIONS(3453),
    [anon_sym_orderby] = ACTIONS(3453),
    [anon_sym_ascending] = ACTIONS(3453),
    [anon_sym_descending] = ACTIONS(3453),
    [anon_sym_group] = ACTIONS(3453),
    [anon_sym_by] = ACTIONS(3453),
    [anon_sym_select] = ACTIONS(3453),
    [anon_sym_DQUOTE] = ACTIONS(3453),
    [anon_sym_stackalloc] = ACTIONS(3453),
    [anon_sym_sizeof] = ACTIONS(3453),
    [anon_sym_typeof] = ACTIONS(3453),
    [anon_sym___makeref] = ACTIONS(3453),
    [anon_sym___reftype] = ACTIONS(3453),
    [anon_sym___refvalue] = ACTIONS(3453),
    [sym_null_literal] = ACTIONS(3453),
    [anon_sym_SQUOTE] = ACTIONS(3455),
    [sym_integer_literal] = ACTIONS(3453),
    [sym_real_literal] = ACTIONS(3455),
    [sym_verbatim_string_literal] = ACTIONS(3455),
    [sym_raw_string_literal] = ACTIONS(3455),
    [aux_sym_preproc_if_token1] = ACTIONS(3455),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3455),
    [sym_interpolation_verbatim_start] = ACTIONS(3455),
    [sym_interpolation_raw_start] = ACTIONS(3455),
  },
  [2539] = {
    [sym_preproc_region] = STATE(2539),
    [sym_preproc_endregion] = STATE(2539),
    [sym_preproc_line] = STATE(2539),
    [sym_preproc_pragma] = STATE(2539),
    [sym_preproc_nullable] = STATE(2539),
    [sym_preproc_error] = STATE(2539),
    [sym_preproc_define] = STATE(2539),
    [sym_preproc_undef] = STATE(2539),
    [ts_builtin_sym_end] = ACTIONS(3826),
    [sym__identifier_token] = ACTIONS(3824),
    [anon_sym_extern] = ACTIONS(3824),
    [anon_sym_alias] = ACTIONS(3824),
    [anon_sym_SEMI] = ACTIONS(3826),
    [anon_sym_global] = ACTIONS(3824),
    [anon_sym_using] = ACTIONS(3824),
    [anon_sym_unsafe] = ACTIONS(3824),
    [anon_sym_static] = ACTIONS(3824),
    [anon_sym_LBRACK] = ACTIONS(3826),
    [anon_sym_LPAREN] = ACTIONS(3826),
    [anon_sym_return] = ACTIONS(3824),
    [anon_sym_namespace] = ACTIONS(3824),
    [anon_sym_class] = ACTIONS(3824),
    [anon_sym_ref] = ACTIONS(3824),
    [anon_sym_struct] = ACTIONS(3824),
    [anon_sym_enum] = ACTIONS(3824),
    [anon_sym_LBRACE] = ACTIONS(3826),
    [anon_sym_interface] = ACTIONS(3824),
    [anon_sym_delegate] = ACTIONS(3824),
    [anon_sym_record] = ACTIONS(3824),
    [anon_sym_abstract] = ACTIONS(3824),
    [anon_sym_async] = ACTIONS(3824),
    [anon_sym_const] = ACTIONS(3824),
    [anon_sym_file] = ACTIONS(3824),
    [anon_sym_fixed] = ACTIONS(3824),
    [anon_sym_internal] = ACTIONS(3824),
    [anon_sym_new] = ACTIONS(3824),
    [anon_sym_override] = ACTIONS(3824),
    [anon_sym_partial] = ACTIONS(3824),
    [anon_sym_private] = ACTIONS(3824),
    [anon_sym_protected] = ACTIONS(3824),
    [anon_sym_public] = ACTIONS(3824),
    [anon_sym_readonly] = ACTIONS(3824),
    [anon_sym_required] = ACTIONS(3824),
    [anon_sym_sealed] = ACTIONS(3824),
    [anon_sym_virtual] = ACTIONS(3824),
    [anon_sym_volatile] = ACTIONS(3824),
    [anon_sym_where] = ACTIONS(3824),
    [anon_sym_notnull] = ACTIONS(3824),
    [anon_sym_unmanaged] = ACTIONS(3824),
    [anon_sym_checked] = ACTIONS(3824),
    [anon_sym_BANG] = ACTIONS(3826),
    [anon_sym_TILDE] = ACTIONS(3826),
    [anon_sym_PLUS_PLUS] = ACTIONS(3826),
    [anon_sym_DASH_DASH] = ACTIONS(3826),
    [anon_sym_true] = ACTIONS(3824),
    [anon_sym_false] = ACTIONS(3824),
    [anon_sym_PLUS] = ACTIONS(3824),
    [anon_sym_DASH] = ACTIONS(3824),
    [anon_sym_STAR] = ACTIONS(3826),
    [anon_sym_CARET] = ACTIONS(3826),
    [anon_sym_AMP] = ACTIONS(3826),
    [anon_sym_this] = ACTIONS(3824),
    [anon_sym_scoped] = ACTIONS(3824),
    [anon_sym_var] = ACTIONS(3824),
    [sym_predefined_type] = ACTIONS(3824),
    [anon_sym_break] = ACTIONS(3824),
    [anon_sym_unchecked] = ACTIONS(3824),
    [anon_sym_continue] = ACTIONS(3824),
    [anon_sym_do] = ACTIONS(3824),
    [anon_sym_while] = ACTIONS(3824),
    [anon_sym_for] = ACTIONS(3824),
    [anon_sym_lock] = ACTIONS(3824),
    [anon_sym_yield] = ACTIONS(3824),
    [anon_sym_switch] = ACTIONS(3824),
    [anon_sym_default] = ACTIONS(3824),
    [anon_sym_throw] = ACTIONS(3824),
    [anon_sym_try] = ACTIONS(3824),
    [anon_sym_when] = ACTIONS(3824),
    [anon_sym_await] = ACTIONS(3824),
    [anon_sym_foreach] = ACTIONS(3824),
    [anon_sym_goto] = ACTIONS(3824),
    [anon_sym_if] = ACTIONS(3824),
    [anon_sym_DOT_DOT] = ACTIONS(3826),
    [anon_sym_from] = ACTIONS(3824),
    [anon_sym_into] = ACTIONS(3824),
    [anon_sym_join] = ACTIONS(3824),
    [anon_sym_on] = ACTIONS(3824),
    [anon_sym_equals] = ACTIONS(3824),
    [anon_sym_let] = ACTIONS(3824),
    [anon_sym_orderby] = ACTIONS(3824),
    [anon_sym_ascending] = ACTIONS(3824),
    [anon_sym_descending] = ACTIONS(3824),
    [anon_sym_group] = ACTIONS(3824),
    [anon_sym_by] = ACTIONS(3824),
    [anon_sym_select] = ACTIONS(3824),
    [anon_sym_DQUOTE] = ACTIONS(3824),
    [anon_sym_stackalloc] = ACTIONS(3824),
    [anon_sym_sizeof] = ACTIONS(3824),
    [anon_sym_typeof] = ACTIONS(3824),
    [anon_sym___makeref] = ACTIONS(3824),
    [anon_sym___reftype] = ACTIONS(3824),
    [anon_sym___refvalue] = ACTIONS(3824),
    [sym_null_literal] = ACTIONS(3824),
    [anon_sym_SQUOTE] = ACTIONS(3826),
    [sym_integer_literal] = ACTIONS(3824),
    [sym_real_literal] = ACTIONS(3826),
    [sym_verbatim_string_literal] = ACTIONS(3826),
    [sym_raw_string_literal] = ACTIONS(3826),
    [aux_sym_preproc_if_token1] = ACTIONS(3826),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3826),
    [sym_interpolation_verbatim_start] = ACTIONS(3826),
    [sym_interpolation_raw_start] = ACTIONS(3826),
  },
  [2540] = {
    [sym_preproc_region] = STATE(2540),
    [sym_preproc_endregion] = STATE(2540),
    [sym_preproc_line] = STATE(2540),
    [sym_preproc_pragma] = STATE(2540),
    [sym_preproc_nullable] = STATE(2540),
    [sym_preproc_error] = STATE(2540),
    [sym_preproc_define] = STATE(2540),
    [sym_preproc_undef] = STATE(2540),
    [ts_builtin_sym_end] = ACTIONS(3952),
    [sym__identifier_token] = ACTIONS(3954),
    [anon_sym_extern] = ACTIONS(3954),
    [anon_sym_alias] = ACTIONS(3954),
    [anon_sym_SEMI] = ACTIONS(3952),
    [anon_sym_global] = ACTIONS(3954),
    [anon_sym_using] = ACTIONS(3954),
    [anon_sym_unsafe] = ACTIONS(3954),
    [anon_sym_static] = ACTIONS(3954),
    [anon_sym_LBRACK] = ACTIONS(3952),
    [anon_sym_LPAREN] = ACTIONS(3952),
    [anon_sym_return] = ACTIONS(3954),
    [anon_sym_namespace] = ACTIONS(3954),
    [anon_sym_class] = ACTIONS(3954),
    [anon_sym_ref] = ACTIONS(3954),
    [anon_sym_struct] = ACTIONS(3954),
    [anon_sym_enum] = ACTIONS(3954),
    [anon_sym_LBRACE] = ACTIONS(3952),
    [anon_sym_interface] = ACTIONS(3954),
    [anon_sym_delegate] = ACTIONS(3954),
    [anon_sym_record] = ACTIONS(3954),
    [anon_sym_abstract] = ACTIONS(3954),
    [anon_sym_async] = ACTIONS(3954),
    [anon_sym_const] = ACTIONS(3954),
    [anon_sym_file] = ACTIONS(3954),
    [anon_sym_fixed] = ACTIONS(3954),
    [anon_sym_internal] = ACTIONS(3954),
    [anon_sym_new] = ACTIONS(3954),
    [anon_sym_override] = ACTIONS(3954),
    [anon_sym_partial] = ACTIONS(3954),
    [anon_sym_private] = ACTIONS(3954),
    [anon_sym_protected] = ACTIONS(3954),
    [anon_sym_public] = ACTIONS(3954),
    [anon_sym_readonly] = ACTIONS(3954),
    [anon_sym_required] = ACTIONS(3954),
    [anon_sym_sealed] = ACTIONS(3954),
    [anon_sym_virtual] = ACTIONS(3954),
    [anon_sym_volatile] = ACTIONS(3954),
    [anon_sym_where] = ACTIONS(3954),
    [anon_sym_notnull] = ACTIONS(3954),
    [anon_sym_unmanaged] = ACTIONS(3954),
    [anon_sym_checked] = ACTIONS(3954),
    [anon_sym_BANG] = ACTIONS(3952),
    [anon_sym_TILDE] = ACTIONS(3952),
    [anon_sym_PLUS_PLUS] = ACTIONS(3952),
    [anon_sym_DASH_DASH] = ACTIONS(3952),
    [anon_sym_true] = ACTIONS(3954),
    [anon_sym_false] = ACTIONS(3954),
    [anon_sym_PLUS] = ACTIONS(3954),
    [anon_sym_DASH] = ACTIONS(3954),
    [anon_sym_STAR] = ACTIONS(3952),
    [anon_sym_CARET] = ACTIONS(3952),
    [anon_sym_AMP] = ACTIONS(3952),
    [anon_sym_this] = ACTIONS(3954),
    [anon_sym_scoped] = ACTIONS(3954),
    [anon_sym_var] = ACTIONS(3954),
    [sym_predefined_type] = ACTIONS(3954),
    [anon_sym_break] = ACTIONS(3954),
    [anon_sym_unchecked] = ACTIONS(3954),
    [anon_sym_continue] = ACTIONS(3954),
    [anon_sym_do] = ACTIONS(3954),
    [anon_sym_while] = ACTIONS(3954),
    [anon_sym_for] = ACTIONS(3954),
    [anon_sym_lock] = ACTIONS(3954),
    [anon_sym_yield] = ACTIONS(3954),
    [anon_sym_switch] = ACTIONS(3954),
    [anon_sym_default] = ACTIONS(3954),
    [anon_sym_throw] = ACTIONS(3954),
    [anon_sym_try] = ACTIONS(3954),
    [anon_sym_when] = ACTIONS(3954),
    [anon_sym_await] = ACTIONS(3954),
    [anon_sym_foreach] = ACTIONS(3954),
    [anon_sym_goto] = ACTIONS(3954),
    [anon_sym_if] = ACTIONS(3954),
    [anon_sym_DOT_DOT] = ACTIONS(3952),
    [anon_sym_from] = ACTIONS(3954),
    [anon_sym_into] = ACTIONS(3954),
    [anon_sym_join] = ACTIONS(3954),
    [anon_sym_on] = ACTIONS(3954),
    [anon_sym_equals] = ACTIONS(3954),
    [anon_sym_let] = ACTIONS(3954),
    [anon_sym_orderby] = ACTIONS(3954),
    [anon_sym_ascending] = ACTIONS(3954),
    [anon_sym_descending] = ACTIONS(3954),
    [anon_sym_group] = ACTIONS(3954),
    [anon_sym_by] = ACTIONS(3954),
    [anon_sym_select] = ACTIONS(3954),
    [anon_sym_DQUOTE] = ACTIONS(3954),
    [anon_sym_stackalloc] = ACTIONS(3954),
    [anon_sym_sizeof] = ACTIONS(3954),
    [anon_sym_typeof] = ACTIONS(3954),
    [anon_sym___makeref] = ACTIONS(3954),
    [anon_sym___reftype] = ACTIONS(3954),
    [anon_sym___refvalue] = ACTIONS(3954),
    [sym_null_literal] = ACTIONS(3954),
    [anon_sym_SQUOTE] = ACTIONS(3952),
    [sym_integer_literal] = ACTIONS(3954),
    [sym_real_literal] = ACTIONS(3952),
    [sym_verbatim_string_literal] = ACTIONS(3952),
    [sym_raw_string_literal] = ACTIONS(3952),
    [aux_sym_preproc_if_token1] = ACTIONS(3952),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3952),
    [sym_interpolation_verbatim_start] = ACTIONS(3952),
    [sym_interpolation_raw_start] = ACTIONS(3952),
  },
  [2541] = {
    [sym_preproc_region] = STATE(2541),
    [sym_preproc_endregion] = STATE(2541),
    [sym_preproc_line] = STATE(2541),
    [sym_preproc_pragma] = STATE(2541),
    [sym_preproc_nullable] = STATE(2541),
    [sym_preproc_error] = STATE(2541),
    [sym_preproc_define] = STATE(2541),
    [sym_preproc_undef] = STATE(2541),
    [ts_builtin_sym_end] = ACTIONS(3922),
    [sym__identifier_token] = ACTIONS(3920),
    [anon_sym_extern] = ACTIONS(3920),
    [anon_sym_alias] = ACTIONS(3920),
    [anon_sym_SEMI] = ACTIONS(3922),
    [anon_sym_global] = ACTIONS(3920),
    [anon_sym_using] = ACTIONS(3920),
    [anon_sym_unsafe] = ACTIONS(3920),
    [anon_sym_static] = ACTIONS(3920),
    [anon_sym_LBRACK] = ACTIONS(3922),
    [anon_sym_LPAREN] = ACTIONS(3922),
    [anon_sym_return] = ACTIONS(3920),
    [anon_sym_namespace] = ACTIONS(3920),
    [anon_sym_class] = ACTIONS(3920),
    [anon_sym_ref] = ACTIONS(3920),
    [anon_sym_struct] = ACTIONS(3920),
    [anon_sym_enum] = ACTIONS(3920),
    [anon_sym_LBRACE] = ACTIONS(3922),
    [anon_sym_interface] = ACTIONS(3920),
    [anon_sym_delegate] = ACTIONS(3920),
    [anon_sym_record] = ACTIONS(3920),
    [anon_sym_abstract] = ACTIONS(3920),
    [anon_sym_async] = ACTIONS(3920),
    [anon_sym_const] = ACTIONS(3920),
    [anon_sym_file] = ACTIONS(3920),
    [anon_sym_fixed] = ACTIONS(3920),
    [anon_sym_internal] = ACTIONS(3920),
    [anon_sym_new] = ACTIONS(3920),
    [anon_sym_override] = ACTIONS(3920),
    [anon_sym_partial] = ACTIONS(3920),
    [anon_sym_private] = ACTIONS(3920),
    [anon_sym_protected] = ACTIONS(3920),
    [anon_sym_public] = ACTIONS(3920),
    [anon_sym_readonly] = ACTIONS(3920),
    [anon_sym_required] = ACTIONS(3920),
    [anon_sym_sealed] = ACTIONS(3920),
    [anon_sym_virtual] = ACTIONS(3920),
    [anon_sym_volatile] = ACTIONS(3920),
    [anon_sym_where] = ACTIONS(3920),
    [anon_sym_notnull] = ACTIONS(3920),
    [anon_sym_unmanaged] = ACTIONS(3920),
    [anon_sym_checked] = ACTIONS(3920),
    [anon_sym_BANG] = ACTIONS(3922),
    [anon_sym_TILDE] = ACTIONS(3922),
    [anon_sym_PLUS_PLUS] = ACTIONS(3922),
    [anon_sym_DASH_DASH] = ACTIONS(3922),
    [anon_sym_true] = ACTIONS(3920),
    [anon_sym_false] = ACTIONS(3920),
    [anon_sym_PLUS] = ACTIONS(3920),
    [anon_sym_DASH] = ACTIONS(3920),
    [anon_sym_STAR] = ACTIONS(3922),
    [anon_sym_CARET] = ACTIONS(3922),
    [anon_sym_AMP] = ACTIONS(3922),
    [anon_sym_this] = ACTIONS(3920),
    [anon_sym_scoped] = ACTIONS(3920),
    [anon_sym_var] = ACTIONS(3920),
    [sym_predefined_type] = ACTIONS(3920),
    [anon_sym_break] = ACTIONS(3920),
    [anon_sym_unchecked] = ACTIONS(3920),
    [anon_sym_continue] = ACTIONS(3920),
    [anon_sym_do] = ACTIONS(3920),
    [anon_sym_while] = ACTIONS(3920),
    [anon_sym_for] = ACTIONS(3920),
    [anon_sym_lock] = ACTIONS(3920),
    [anon_sym_yield] = ACTIONS(3920),
    [anon_sym_switch] = ACTIONS(3920),
    [anon_sym_default] = ACTIONS(3920),
    [anon_sym_throw] = ACTIONS(3920),
    [anon_sym_try] = ACTIONS(3920),
    [anon_sym_when] = ACTIONS(3920),
    [anon_sym_await] = ACTIONS(3920),
    [anon_sym_foreach] = ACTIONS(3920),
    [anon_sym_goto] = ACTIONS(3920),
    [anon_sym_if] = ACTIONS(3920),
    [anon_sym_DOT_DOT] = ACTIONS(3922),
    [anon_sym_from] = ACTIONS(3920),
    [anon_sym_into] = ACTIONS(3920),
    [anon_sym_join] = ACTIONS(3920),
    [anon_sym_on] = ACTIONS(3920),
    [anon_sym_equals] = ACTIONS(3920),
    [anon_sym_let] = ACTIONS(3920),
    [anon_sym_orderby] = ACTIONS(3920),
    [anon_sym_ascending] = ACTIONS(3920),
    [anon_sym_descending] = ACTIONS(3920),
    [anon_sym_group] = ACTIONS(3920),
    [anon_sym_by] = ACTIONS(3920),
    [anon_sym_select] = ACTIONS(3920),
    [anon_sym_DQUOTE] = ACTIONS(3920),
    [anon_sym_stackalloc] = ACTIONS(3920),
    [anon_sym_sizeof] = ACTIONS(3920),
    [anon_sym_typeof] = ACTIONS(3920),
    [anon_sym___makeref] = ACTIONS(3920),
    [anon_sym___reftype] = ACTIONS(3920),
    [anon_sym___refvalue] = ACTIONS(3920),
    [sym_null_literal] = ACTIONS(3920),
    [anon_sym_SQUOTE] = ACTIONS(3922),
    [sym_integer_literal] = ACTIONS(3920),
    [sym_real_literal] = ACTIONS(3922),
    [sym_verbatim_string_literal] = ACTIONS(3922),
    [sym_raw_string_literal] = ACTIONS(3922),
    [aux_sym_preproc_if_token1] = ACTIONS(3922),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3922),
    [sym_interpolation_verbatim_start] = ACTIONS(3922),
    [sym_interpolation_raw_start] = ACTIONS(3922),
  },
  [2542] = {
    [sym_preproc_region] = STATE(2542),
    [sym_preproc_endregion] = STATE(2542),
    [sym_preproc_line] = STATE(2542),
    [sym_preproc_pragma] = STATE(2542),
    [sym_preproc_nullable] = STATE(2542),
    [sym_preproc_error] = STATE(2542),
    [sym_preproc_define] = STATE(2542),
    [sym_preproc_undef] = STATE(2542),
    [ts_builtin_sym_end] = ACTIONS(3495),
    [sym__identifier_token] = ACTIONS(3493),
    [anon_sym_extern] = ACTIONS(3493),
    [anon_sym_alias] = ACTIONS(3493),
    [anon_sym_SEMI] = ACTIONS(3495),
    [anon_sym_global] = ACTIONS(3493),
    [anon_sym_using] = ACTIONS(3493),
    [anon_sym_unsafe] = ACTIONS(3493),
    [anon_sym_static] = ACTIONS(3493),
    [anon_sym_LBRACK] = ACTIONS(3495),
    [anon_sym_LPAREN] = ACTIONS(3495),
    [anon_sym_return] = ACTIONS(3493),
    [anon_sym_namespace] = ACTIONS(3493),
    [anon_sym_class] = ACTIONS(3493),
    [anon_sym_ref] = ACTIONS(3493),
    [anon_sym_struct] = ACTIONS(3493),
    [anon_sym_enum] = ACTIONS(3493),
    [anon_sym_LBRACE] = ACTIONS(3495),
    [anon_sym_interface] = ACTIONS(3493),
    [anon_sym_delegate] = ACTIONS(3493),
    [anon_sym_record] = ACTIONS(3493),
    [anon_sym_abstract] = ACTIONS(3493),
    [anon_sym_async] = ACTIONS(3493),
    [anon_sym_const] = ACTIONS(3493),
    [anon_sym_file] = ACTIONS(3493),
    [anon_sym_fixed] = ACTIONS(3493),
    [anon_sym_internal] = ACTIONS(3493),
    [anon_sym_new] = ACTIONS(3493),
    [anon_sym_override] = ACTIONS(3493),
    [anon_sym_partial] = ACTIONS(3493),
    [anon_sym_private] = ACTIONS(3493),
    [anon_sym_protected] = ACTIONS(3493),
    [anon_sym_public] = ACTIONS(3493),
    [anon_sym_readonly] = ACTIONS(3493),
    [anon_sym_required] = ACTIONS(3493),
    [anon_sym_sealed] = ACTIONS(3493),
    [anon_sym_virtual] = ACTIONS(3493),
    [anon_sym_volatile] = ACTIONS(3493),
    [anon_sym_where] = ACTIONS(3493),
    [anon_sym_notnull] = ACTIONS(3493),
    [anon_sym_unmanaged] = ACTIONS(3493),
    [anon_sym_checked] = ACTIONS(3493),
    [anon_sym_BANG] = ACTIONS(3495),
    [anon_sym_TILDE] = ACTIONS(3495),
    [anon_sym_PLUS_PLUS] = ACTIONS(3495),
    [anon_sym_DASH_DASH] = ACTIONS(3495),
    [anon_sym_true] = ACTIONS(3493),
    [anon_sym_false] = ACTIONS(3493),
    [anon_sym_PLUS] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(3493),
    [anon_sym_STAR] = ACTIONS(3495),
    [anon_sym_CARET] = ACTIONS(3495),
    [anon_sym_AMP] = ACTIONS(3495),
    [anon_sym_this] = ACTIONS(3493),
    [anon_sym_scoped] = ACTIONS(3493),
    [anon_sym_var] = ACTIONS(3493),
    [sym_predefined_type] = ACTIONS(3493),
    [anon_sym_break] = ACTIONS(3493),
    [anon_sym_unchecked] = ACTIONS(3493),
    [anon_sym_continue] = ACTIONS(3493),
    [anon_sym_do] = ACTIONS(3493),
    [anon_sym_while] = ACTIONS(3493),
    [anon_sym_for] = ACTIONS(3493),
    [anon_sym_lock] = ACTIONS(3493),
    [anon_sym_yield] = ACTIONS(3493),
    [anon_sym_switch] = ACTIONS(3493),
    [anon_sym_default] = ACTIONS(3493),
    [anon_sym_throw] = ACTIONS(3493),
    [anon_sym_try] = ACTIONS(3493),
    [anon_sym_when] = ACTIONS(3493),
    [anon_sym_await] = ACTIONS(3493),
    [anon_sym_foreach] = ACTIONS(3493),
    [anon_sym_goto] = ACTIONS(3493),
    [anon_sym_if] = ACTIONS(3493),
    [anon_sym_DOT_DOT] = ACTIONS(3495),
    [anon_sym_from] = ACTIONS(3493),
    [anon_sym_into] = ACTIONS(3493),
    [anon_sym_join] = ACTIONS(3493),
    [anon_sym_on] = ACTIONS(3493),
    [anon_sym_equals] = ACTIONS(3493),
    [anon_sym_let] = ACTIONS(3493),
    [anon_sym_orderby] = ACTIONS(3493),
    [anon_sym_ascending] = ACTIONS(3493),
    [anon_sym_descending] = ACTIONS(3493),
    [anon_sym_group] = ACTIONS(3493),
    [anon_sym_by] = ACTIONS(3493),
    [anon_sym_select] = ACTIONS(3493),
    [anon_sym_DQUOTE] = ACTIONS(3493),
    [anon_sym_stackalloc] = ACTIONS(3493),
    [anon_sym_sizeof] = ACTIONS(3493),
    [anon_sym_typeof] = ACTIONS(3493),
    [anon_sym___makeref] = ACTIONS(3493),
    [anon_sym___reftype] = ACTIONS(3493),
    [anon_sym___refvalue] = ACTIONS(3493),
    [sym_null_literal] = ACTIONS(3493),
    [anon_sym_SQUOTE] = ACTIONS(3495),
    [sym_integer_literal] = ACTIONS(3493),
    [sym_real_literal] = ACTIONS(3495),
    [sym_verbatim_string_literal] = ACTIONS(3495),
    [sym_raw_string_literal] = ACTIONS(3495),
    [aux_sym_preproc_if_token1] = ACTIONS(3495),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3495),
    [sym_interpolation_verbatim_start] = ACTIONS(3495),
    [sym_interpolation_raw_start] = ACTIONS(3495),
  },
  [2543] = {
    [sym_preproc_region] = STATE(2543),
    [sym_preproc_endregion] = STATE(2543),
    [sym_preproc_line] = STATE(2543),
    [sym_preproc_pragma] = STATE(2543),
    [sym_preproc_nullable] = STATE(2543),
    [sym_preproc_error] = STATE(2543),
    [sym_preproc_define] = STATE(2543),
    [sym_preproc_undef] = STATE(2543),
    [ts_builtin_sym_end] = ACTIONS(3918),
    [sym__identifier_token] = ACTIONS(3916),
    [anon_sym_extern] = ACTIONS(3916),
    [anon_sym_alias] = ACTIONS(3916),
    [anon_sym_SEMI] = ACTIONS(3918),
    [anon_sym_global] = ACTIONS(3916),
    [anon_sym_using] = ACTIONS(3916),
    [anon_sym_unsafe] = ACTIONS(3916),
    [anon_sym_static] = ACTIONS(3916),
    [anon_sym_LBRACK] = ACTIONS(3918),
    [anon_sym_LPAREN] = ACTIONS(3918),
    [anon_sym_return] = ACTIONS(3916),
    [anon_sym_namespace] = ACTIONS(3916),
    [anon_sym_class] = ACTIONS(3916),
    [anon_sym_ref] = ACTIONS(3916),
    [anon_sym_struct] = ACTIONS(3916),
    [anon_sym_enum] = ACTIONS(3916),
    [anon_sym_LBRACE] = ACTIONS(3918),
    [anon_sym_interface] = ACTIONS(3916),
    [anon_sym_delegate] = ACTIONS(3916),
    [anon_sym_record] = ACTIONS(3916),
    [anon_sym_abstract] = ACTIONS(3916),
    [anon_sym_async] = ACTIONS(3916),
    [anon_sym_const] = ACTIONS(3916),
    [anon_sym_file] = ACTIONS(3916),
    [anon_sym_fixed] = ACTIONS(3916),
    [anon_sym_internal] = ACTIONS(3916),
    [anon_sym_new] = ACTIONS(3916),
    [anon_sym_override] = ACTIONS(3916),
    [anon_sym_partial] = ACTIONS(3916),
    [anon_sym_private] = ACTIONS(3916),
    [anon_sym_protected] = ACTIONS(3916),
    [anon_sym_public] = ACTIONS(3916),
    [anon_sym_readonly] = ACTIONS(3916),
    [anon_sym_required] = ACTIONS(3916),
    [anon_sym_sealed] = ACTIONS(3916),
    [anon_sym_virtual] = ACTIONS(3916),
    [anon_sym_volatile] = ACTIONS(3916),
    [anon_sym_where] = ACTIONS(3916),
    [anon_sym_notnull] = ACTIONS(3916),
    [anon_sym_unmanaged] = ACTIONS(3916),
    [anon_sym_checked] = ACTIONS(3916),
    [anon_sym_BANG] = ACTIONS(3918),
    [anon_sym_TILDE] = ACTIONS(3918),
    [anon_sym_PLUS_PLUS] = ACTIONS(3918),
    [anon_sym_DASH_DASH] = ACTIONS(3918),
    [anon_sym_true] = ACTIONS(3916),
    [anon_sym_false] = ACTIONS(3916),
    [anon_sym_PLUS] = ACTIONS(3916),
    [anon_sym_DASH] = ACTIONS(3916),
    [anon_sym_STAR] = ACTIONS(3918),
    [anon_sym_CARET] = ACTIONS(3918),
    [anon_sym_AMP] = ACTIONS(3918),
    [anon_sym_this] = ACTIONS(3916),
    [anon_sym_scoped] = ACTIONS(3916),
    [anon_sym_var] = ACTIONS(3916),
    [sym_predefined_type] = ACTIONS(3916),
    [anon_sym_break] = ACTIONS(3916),
    [anon_sym_unchecked] = ACTIONS(3916),
    [anon_sym_continue] = ACTIONS(3916),
    [anon_sym_do] = ACTIONS(3916),
    [anon_sym_while] = ACTIONS(3916),
    [anon_sym_for] = ACTIONS(3916),
    [anon_sym_lock] = ACTIONS(3916),
    [anon_sym_yield] = ACTIONS(3916),
    [anon_sym_switch] = ACTIONS(3916),
    [anon_sym_default] = ACTIONS(3916),
    [anon_sym_throw] = ACTIONS(3916),
    [anon_sym_try] = ACTIONS(3916),
    [anon_sym_when] = ACTIONS(3916),
    [anon_sym_await] = ACTIONS(3916),
    [anon_sym_foreach] = ACTIONS(3916),
    [anon_sym_goto] = ACTIONS(3916),
    [anon_sym_if] = ACTIONS(3916),
    [anon_sym_DOT_DOT] = ACTIONS(3918),
    [anon_sym_from] = ACTIONS(3916),
    [anon_sym_into] = ACTIONS(3916),
    [anon_sym_join] = ACTIONS(3916),
    [anon_sym_on] = ACTIONS(3916),
    [anon_sym_equals] = ACTIONS(3916),
    [anon_sym_let] = ACTIONS(3916),
    [anon_sym_orderby] = ACTIONS(3916),
    [anon_sym_ascending] = ACTIONS(3916),
    [anon_sym_descending] = ACTIONS(3916),
    [anon_sym_group] = ACTIONS(3916),
    [anon_sym_by] = ACTIONS(3916),
    [anon_sym_select] = ACTIONS(3916),
    [anon_sym_DQUOTE] = ACTIONS(3916),
    [anon_sym_stackalloc] = ACTIONS(3916),
    [anon_sym_sizeof] = ACTIONS(3916),
    [anon_sym_typeof] = ACTIONS(3916),
    [anon_sym___makeref] = ACTIONS(3916),
    [anon_sym___reftype] = ACTIONS(3916),
    [anon_sym___refvalue] = ACTIONS(3916),
    [sym_null_literal] = ACTIONS(3916),
    [anon_sym_SQUOTE] = ACTIONS(3918),
    [sym_integer_literal] = ACTIONS(3916),
    [sym_real_literal] = ACTIONS(3918),
    [sym_verbatim_string_literal] = ACTIONS(3918),
    [sym_raw_string_literal] = ACTIONS(3918),
    [aux_sym_preproc_if_token1] = ACTIONS(3918),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3918),
    [sym_interpolation_verbatim_start] = ACTIONS(3918),
    [sym_interpolation_raw_start] = ACTIONS(3918),
  },
  [2544] = {
    [sym_preproc_region] = STATE(2544),
    [sym_preproc_endregion] = STATE(2544),
    [sym_preproc_line] = STATE(2544),
    [sym_preproc_pragma] = STATE(2544),
    [sym_preproc_nullable] = STATE(2544),
    [sym_preproc_error] = STATE(2544),
    [sym_preproc_define] = STATE(2544),
    [sym_preproc_undef] = STATE(2544),
    [ts_builtin_sym_end] = ACTIONS(3914),
    [sym__identifier_token] = ACTIONS(3912),
    [anon_sym_extern] = ACTIONS(3912),
    [anon_sym_alias] = ACTIONS(3912),
    [anon_sym_SEMI] = ACTIONS(3914),
    [anon_sym_global] = ACTIONS(3912),
    [anon_sym_using] = ACTIONS(3912),
    [anon_sym_unsafe] = ACTIONS(3912),
    [anon_sym_static] = ACTIONS(3912),
    [anon_sym_LBRACK] = ACTIONS(3914),
    [anon_sym_LPAREN] = ACTIONS(3914),
    [anon_sym_return] = ACTIONS(3912),
    [anon_sym_namespace] = ACTIONS(3912),
    [anon_sym_class] = ACTIONS(3912),
    [anon_sym_ref] = ACTIONS(3912),
    [anon_sym_struct] = ACTIONS(3912),
    [anon_sym_enum] = ACTIONS(3912),
    [anon_sym_LBRACE] = ACTIONS(3914),
    [anon_sym_interface] = ACTIONS(3912),
    [anon_sym_delegate] = ACTIONS(3912),
    [anon_sym_record] = ACTIONS(3912),
    [anon_sym_abstract] = ACTIONS(3912),
    [anon_sym_async] = ACTIONS(3912),
    [anon_sym_const] = ACTIONS(3912),
    [anon_sym_file] = ACTIONS(3912),
    [anon_sym_fixed] = ACTIONS(3912),
    [anon_sym_internal] = ACTIONS(3912),
    [anon_sym_new] = ACTIONS(3912),
    [anon_sym_override] = ACTIONS(3912),
    [anon_sym_partial] = ACTIONS(3912),
    [anon_sym_private] = ACTIONS(3912),
    [anon_sym_protected] = ACTIONS(3912),
    [anon_sym_public] = ACTIONS(3912),
    [anon_sym_readonly] = ACTIONS(3912),
    [anon_sym_required] = ACTIONS(3912),
    [anon_sym_sealed] = ACTIONS(3912),
    [anon_sym_virtual] = ACTIONS(3912),
    [anon_sym_volatile] = ACTIONS(3912),
    [anon_sym_where] = ACTIONS(3912),
    [anon_sym_notnull] = ACTIONS(3912),
    [anon_sym_unmanaged] = ACTIONS(3912),
    [anon_sym_checked] = ACTIONS(3912),
    [anon_sym_BANG] = ACTIONS(3914),
    [anon_sym_TILDE] = ACTIONS(3914),
    [anon_sym_PLUS_PLUS] = ACTIONS(3914),
    [anon_sym_DASH_DASH] = ACTIONS(3914),
    [anon_sym_true] = ACTIONS(3912),
    [anon_sym_false] = ACTIONS(3912),
    [anon_sym_PLUS] = ACTIONS(3912),
    [anon_sym_DASH] = ACTIONS(3912),
    [anon_sym_STAR] = ACTIONS(3914),
    [anon_sym_CARET] = ACTIONS(3914),
    [anon_sym_AMP] = ACTIONS(3914),
    [anon_sym_this] = ACTIONS(3912),
    [anon_sym_scoped] = ACTIONS(3912),
    [anon_sym_var] = ACTIONS(3912),
    [sym_predefined_type] = ACTIONS(3912),
    [anon_sym_break] = ACTIONS(3912),
    [anon_sym_unchecked] = ACTIONS(3912),
    [anon_sym_continue] = ACTIONS(3912),
    [anon_sym_do] = ACTIONS(3912),
    [anon_sym_while] = ACTIONS(3912),
    [anon_sym_for] = ACTIONS(3912),
    [anon_sym_lock] = ACTIONS(3912),
    [anon_sym_yield] = ACTIONS(3912),
    [anon_sym_switch] = ACTIONS(3912),
    [anon_sym_default] = ACTIONS(3912),
    [anon_sym_throw] = ACTIONS(3912),
    [anon_sym_try] = ACTIONS(3912),
    [anon_sym_when] = ACTIONS(3912),
    [anon_sym_await] = ACTIONS(3912),
    [anon_sym_foreach] = ACTIONS(3912),
    [anon_sym_goto] = ACTIONS(3912),
    [anon_sym_if] = ACTIONS(3912),
    [anon_sym_DOT_DOT] = ACTIONS(3914),
    [anon_sym_from] = ACTIONS(3912),
    [anon_sym_into] = ACTIONS(3912),
    [anon_sym_join] = ACTIONS(3912),
    [anon_sym_on] = ACTIONS(3912),
    [anon_sym_equals] = ACTIONS(3912),
    [anon_sym_let] = ACTIONS(3912),
    [anon_sym_orderby] = ACTIONS(3912),
    [anon_sym_ascending] = ACTIONS(3912),
    [anon_sym_descending] = ACTIONS(3912),
    [anon_sym_group] = ACTIONS(3912),
    [anon_sym_by] = ACTIONS(3912),
    [anon_sym_select] = ACTIONS(3912),
    [anon_sym_DQUOTE] = ACTIONS(3912),
    [anon_sym_stackalloc] = ACTIONS(3912),
    [anon_sym_sizeof] = ACTIONS(3912),
    [anon_sym_typeof] = ACTIONS(3912),
    [anon_sym___makeref] = ACTIONS(3912),
    [anon_sym___reftype] = ACTIONS(3912),
    [anon_sym___refvalue] = ACTIONS(3912),
    [sym_null_literal] = ACTIONS(3912),
    [anon_sym_SQUOTE] = ACTIONS(3914),
    [sym_integer_literal] = ACTIONS(3912),
    [sym_real_literal] = ACTIONS(3914),
    [sym_verbatim_string_literal] = ACTIONS(3914),
    [sym_raw_string_literal] = ACTIONS(3914),
    [aux_sym_preproc_if_token1] = ACTIONS(3914),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3914),
    [sym_interpolation_verbatim_start] = ACTIONS(3914),
    [sym_interpolation_raw_start] = ACTIONS(3914),
  },
  [2545] = {
    [sym_preproc_region] = STATE(2545),
    [sym_preproc_endregion] = STATE(2545),
    [sym_preproc_line] = STATE(2545),
    [sym_preproc_pragma] = STATE(2545),
    [sym_preproc_nullable] = STATE(2545),
    [sym_preproc_error] = STATE(2545),
    [sym_preproc_define] = STATE(2545),
    [sym_preproc_undef] = STATE(2545),
    [ts_builtin_sym_end] = ACTIONS(3547),
    [sym__identifier_token] = ACTIONS(3545),
    [anon_sym_extern] = ACTIONS(3545),
    [anon_sym_alias] = ACTIONS(3545),
    [anon_sym_SEMI] = ACTIONS(3547),
    [anon_sym_global] = ACTIONS(3545),
    [anon_sym_using] = ACTIONS(3545),
    [anon_sym_unsafe] = ACTIONS(3545),
    [anon_sym_static] = ACTIONS(3545),
    [anon_sym_LBRACK] = ACTIONS(3547),
    [anon_sym_LPAREN] = ACTIONS(3547),
    [anon_sym_return] = ACTIONS(3545),
    [anon_sym_namespace] = ACTIONS(3545),
    [anon_sym_class] = ACTIONS(3545),
    [anon_sym_ref] = ACTIONS(3545),
    [anon_sym_struct] = ACTIONS(3545),
    [anon_sym_enum] = ACTIONS(3545),
    [anon_sym_LBRACE] = ACTIONS(3547),
    [anon_sym_interface] = ACTIONS(3545),
    [anon_sym_delegate] = ACTIONS(3545),
    [anon_sym_record] = ACTIONS(3545),
    [anon_sym_abstract] = ACTIONS(3545),
    [anon_sym_async] = ACTIONS(3545),
    [anon_sym_const] = ACTIONS(3545),
    [anon_sym_file] = ACTIONS(3545),
    [anon_sym_fixed] = ACTIONS(3545),
    [anon_sym_internal] = ACTIONS(3545),
    [anon_sym_new] = ACTIONS(3545),
    [anon_sym_override] = ACTIONS(3545),
    [anon_sym_partial] = ACTIONS(3545),
    [anon_sym_private] = ACTIONS(3545),
    [anon_sym_protected] = ACTIONS(3545),
    [anon_sym_public] = ACTIONS(3545),
    [anon_sym_readonly] = ACTIONS(3545),
    [anon_sym_required] = ACTIONS(3545),
    [anon_sym_sealed] = ACTIONS(3545),
    [anon_sym_virtual] = ACTIONS(3545),
    [anon_sym_volatile] = ACTIONS(3545),
    [anon_sym_where] = ACTIONS(3545),
    [anon_sym_notnull] = ACTIONS(3545),
    [anon_sym_unmanaged] = ACTIONS(3545),
    [anon_sym_checked] = ACTIONS(3545),
    [anon_sym_BANG] = ACTIONS(3547),
    [anon_sym_TILDE] = ACTIONS(3547),
    [anon_sym_PLUS_PLUS] = ACTIONS(3547),
    [anon_sym_DASH_DASH] = ACTIONS(3547),
    [anon_sym_true] = ACTIONS(3545),
    [anon_sym_false] = ACTIONS(3545),
    [anon_sym_PLUS] = ACTIONS(3545),
    [anon_sym_DASH] = ACTIONS(3545),
    [anon_sym_STAR] = ACTIONS(3547),
    [anon_sym_CARET] = ACTIONS(3547),
    [anon_sym_AMP] = ACTIONS(3547),
    [anon_sym_this] = ACTIONS(3545),
    [anon_sym_scoped] = ACTIONS(3545),
    [anon_sym_var] = ACTIONS(3545),
    [sym_predefined_type] = ACTIONS(3545),
    [anon_sym_break] = ACTIONS(3545),
    [anon_sym_unchecked] = ACTIONS(3545),
    [anon_sym_continue] = ACTIONS(3545),
    [anon_sym_do] = ACTIONS(3545),
    [anon_sym_while] = ACTIONS(3545),
    [anon_sym_for] = ACTIONS(3545),
    [anon_sym_lock] = ACTIONS(3545),
    [anon_sym_yield] = ACTIONS(3545),
    [anon_sym_switch] = ACTIONS(3545),
    [anon_sym_default] = ACTIONS(3545),
    [anon_sym_throw] = ACTIONS(3545),
    [anon_sym_try] = ACTIONS(3545),
    [anon_sym_when] = ACTIONS(3545),
    [anon_sym_await] = ACTIONS(3545),
    [anon_sym_foreach] = ACTIONS(3545),
    [anon_sym_goto] = ACTIONS(3545),
    [anon_sym_if] = ACTIONS(3545),
    [anon_sym_DOT_DOT] = ACTIONS(3547),
    [anon_sym_from] = ACTIONS(3545),
    [anon_sym_into] = ACTIONS(3545),
    [anon_sym_join] = ACTIONS(3545),
    [anon_sym_on] = ACTIONS(3545),
    [anon_sym_equals] = ACTIONS(3545),
    [anon_sym_let] = ACTIONS(3545),
    [anon_sym_orderby] = ACTIONS(3545),
    [anon_sym_ascending] = ACTIONS(3545),
    [anon_sym_descending] = ACTIONS(3545),
    [anon_sym_group] = ACTIONS(3545),
    [anon_sym_by] = ACTIONS(3545),
    [anon_sym_select] = ACTIONS(3545),
    [anon_sym_DQUOTE] = ACTIONS(3545),
    [anon_sym_stackalloc] = ACTIONS(3545),
    [anon_sym_sizeof] = ACTIONS(3545),
    [anon_sym_typeof] = ACTIONS(3545),
    [anon_sym___makeref] = ACTIONS(3545),
    [anon_sym___reftype] = ACTIONS(3545),
    [anon_sym___refvalue] = ACTIONS(3545),
    [sym_null_literal] = ACTIONS(3545),
    [anon_sym_SQUOTE] = ACTIONS(3547),
    [sym_integer_literal] = ACTIONS(3545),
    [sym_real_literal] = ACTIONS(3547),
    [sym_verbatim_string_literal] = ACTIONS(3547),
    [sym_raw_string_literal] = ACTIONS(3547),
    [aux_sym_preproc_if_token1] = ACTIONS(3547),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3547),
    [sym_interpolation_verbatim_start] = ACTIONS(3547),
    [sym_interpolation_raw_start] = ACTIONS(3547),
  },
  [2546] = {
    [sym_preproc_region] = STATE(2546),
    [sym_preproc_endregion] = STATE(2546),
    [sym_preproc_line] = STATE(2546),
    [sym_preproc_pragma] = STATE(2546),
    [sym_preproc_nullable] = STATE(2546),
    [sym_preproc_error] = STATE(2546),
    [sym_preproc_define] = STATE(2546),
    [sym_preproc_undef] = STATE(2546),
    [ts_builtin_sym_end] = ACTIONS(3910),
    [sym__identifier_token] = ACTIONS(3908),
    [anon_sym_extern] = ACTIONS(3908),
    [anon_sym_alias] = ACTIONS(3908),
    [anon_sym_SEMI] = ACTIONS(3910),
    [anon_sym_global] = ACTIONS(3908),
    [anon_sym_using] = ACTIONS(3908),
    [anon_sym_unsafe] = ACTIONS(3908),
    [anon_sym_static] = ACTIONS(3908),
    [anon_sym_LBRACK] = ACTIONS(3910),
    [anon_sym_LPAREN] = ACTIONS(3910),
    [anon_sym_return] = ACTIONS(3908),
    [anon_sym_namespace] = ACTIONS(3908),
    [anon_sym_class] = ACTIONS(3908),
    [anon_sym_ref] = ACTIONS(3908),
    [anon_sym_struct] = ACTIONS(3908),
    [anon_sym_enum] = ACTIONS(3908),
    [anon_sym_LBRACE] = ACTIONS(3910),
    [anon_sym_interface] = ACTIONS(3908),
    [anon_sym_delegate] = ACTIONS(3908),
    [anon_sym_record] = ACTIONS(3908),
    [anon_sym_abstract] = ACTIONS(3908),
    [anon_sym_async] = ACTIONS(3908),
    [anon_sym_const] = ACTIONS(3908),
    [anon_sym_file] = ACTIONS(3908),
    [anon_sym_fixed] = ACTIONS(3908),
    [anon_sym_internal] = ACTIONS(3908),
    [anon_sym_new] = ACTIONS(3908),
    [anon_sym_override] = ACTIONS(3908),
    [anon_sym_partial] = ACTIONS(3908),
    [anon_sym_private] = ACTIONS(3908),
    [anon_sym_protected] = ACTIONS(3908),
    [anon_sym_public] = ACTIONS(3908),
    [anon_sym_readonly] = ACTIONS(3908),
    [anon_sym_required] = ACTIONS(3908),
    [anon_sym_sealed] = ACTIONS(3908),
    [anon_sym_virtual] = ACTIONS(3908),
    [anon_sym_volatile] = ACTIONS(3908),
    [anon_sym_where] = ACTIONS(3908),
    [anon_sym_notnull] = ACTIONS(3908),
    [anon_sym_unmanaged] = ACTIONS(3908),
    [anon_sym_checked] = ACTIONS(3908),
    [anon_sym_BANG] = ACTIONS(3910),
    [anon_sym_TILDE] = ACTIONS(3910),
    [anon_sym_PLUS_PLUS] = ACTIONS(3910),
    [anon_sym_DASH_DASH] = ACTIONS(3910),
    [anon_sym_true] = ACTIONS(3908),
    [anon_sym_false] = ACTIONS(3908),
    [anon_sym_PLUS] = ACTIONS(3908),
    [anon_sym_DASH] = ACTIONS(3908),
    [anon_sym_STAR] = ACTIONS(3910),
    [anon_sym_CARET] = ACTIONS(3910),
    [anon_sym_AMP] = ACTIONS(3910),
    [anon_sym_this] = ACTIONS(3908),
    [anon_sym_scoped] = ACTIONS(3908),
    [anon_sym_var] = ACTIONS(3908),
    [sym_predefined_type] = ACTIONS(3908),
    [anon_sym_break] = ACTIONS(3908),
    [anon_sym_unchecked] = ACTIONS(3908),
    [anon_sym_continue] = ACTIONS(3908),
    [anon_sym_do] = ACTIONS(3908),
    [anon_sym_while] = ACTIONS(3908),
    [anon_sym_for] = ACTIONS(3908),
    [anon_sym_lock] = ACTIONS(3908),
    [anon_sym_yield] = ACTIONS(3908),
    [anon_sym_switch] = ACTIONS(3908),
    [anon_sym_default] = ACTIONS(3908),
    [anon_sym_throw] = ACTIONS(3908),
    [anon_sym_try] = ACTIONS(3908),
    [anon_sym_when] = ACTIONS(3908),
    [anon_sym_await] = ACTIONS(3908),
    [anon_sym_foreach] = ACTIONS(3908),
    [anon_sym_goto] = ACTIONS(3908),
    [anon_sym_if] = ACTIONS(3908),
    [anon_sym_DOT_DOT] = ACTIONS(3910),
    [anon_sym_from] = ACTIONS(3908),
    [anon_sym_into] = ACTIONS(3908),
    [anon_sym_join] = ACTIONS(3908),
    [anon_sym_on] = ACTIONS(3908),
    [anon_sym_equals] = ACTIONS(3908),
    [anon_sym_let] = ACTIONS(3908),
    [anon_sym_orderby] = ACTIONS(3908),
    [anon_sym_ascending] = ACTIONS(3908),
    [anon_sym_descending] = ACTIONS(3908),
    [anon_sym_group] = ACTIONS(3908),
    [anon_sym_by] = ACTIONS(3908),
    [anon_sym_select] = ACTIONS(3908),
    [anon_sym_DQUOTE] = ACTIONS(3908),
    [anon_sym_stackalloc] = ACTIONS(3908),
    [anon_sym_sizeof] = ACTIONS(3908),
    [anon_sym_typeof] = ACTIONS(3908),
    [anon_sym___makeref] = ACTIONS(3908),
    [anon_sym___reftype] = ACTIONS(3908),
    [anon_sym___refvalue] = ACTIONS(3908),
    [sym_null_literal] = ACTIONS(3908),
    [anon_sym_SQUOTE] = ACTIONS(3910),
    [sym_integer_literal] = ACTIONS(3908),
    [sym_real_literal] = ACTIONS(3910),
    [sym_verbatim_string_literal] = ACTIONS(3910),
    [sym_raw_string_literal] = ACTIONS(3910),
    [aux_sym_preproc_if_token1] = ACTIONS(3910),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3910),
    [sym_interpolation_verbatim_start] = ACTIONS(3910),
    [sym_interpolation_raw_start] = ACTIONS(3910),
  },
  [2547] = {
    [sym_preproc_region] = STATE(2547),
    [sym_preproc_endregion] = STATE(2547),
    [sym_preproc_line] = STATE(2547),
    [sym_preproc_pragma] = STATE(2547),
    [sym_preproc_nullable] = STATE(2547),
    [sym_preproc_error] = STATE(2547),
    [sym_preproc_define] = STATE(2547),
    [sym_preproc_undef] = STATE(2547),
    [ts_builtin_sym_end] = ACTIONS(3956),
    [sym__identifier_token] = ACTIONS(3958),
    [anon_sym_extern] = ACTIONS(3958),
    [anon_sym_alias] = ACTIONS(3958),
    [anon_sym_SEMI] = ACTIONS(3956),
    [anon_sym_global] = ACTIONS(3958),
    [anon_sym_using] = ACTIONS(3958),
    [anon_sym_unsafe] = ACTIONS(3958),
    [anon_sym_static] = ACTIONS(3958),
    [anon_sym_LBRACK] = ACTIONS(3956),
    [anon_sym_LPAREN] = ACTIONS(3956),
    [anon_sym_return] = ACTIONS(3958),
    [anon_sym_namespace] = ACTIONS(3958),
    [anon_sym_class] = ACTIONS(3958),
    [anon_sym_ref] = ACTIONS(3958),
    [anon_sym_struct] = ACTIONS(3958),
    [anon_sym_enum] = ACTIONS(3958),
    [anon_sym_LBRACE] = ACTIONS(3956),
    [anon_sym_interface] = ACTIONS(3958),
    [anon_sym_delegate] = ACTIONS(3958),
    [anon_sym_record] = ACTIONS(3958),
    [anon_sym_abstract] = ACTIONS(3958),
    [anon_sym_async] = ACTIONS(3958),
    [anon_sym_const] = ACTIONS(3958),
    [anon_sym_file] = ACTIONS(3958),
    [anon_sym_fixed] = ACTIONS(3958),
    [anon_sym_internal] = ACTIONS(3958),
    [anon_sym_new] = ACTIONS(3958),
    [anon_sym_override] = ACTIONS(3958),
    [anon_sym_partial] = ACTIONS(3958),
    [anon_sym_private] = ACTIONS(3958),
    [anon_sym_protected] = ACTIONS(3958),
    [anon_sym_public] = ACTIONS(3958),
    [anon_sym_readonly] = ACTIONS(3958),
    [anon_sym_required] = ACTIONS(3958),
    [anon_sym_sealed] = ACTIONS(3958),
    [anon_sym_virtual] = ACTIONS(3958),
    [anon_sym_volatile] = ACTIONS(3958),
    [anon_sym_where] = ACTIONS(3958),
    [anon_sym_notnull] = ACTIONS(3958),
    [anon_sym_unmanaged] = ACTIONS(3958),
    [anon_sym_checked] = ACTIONS(3958),
    [anon_sym_BANG] = ACTIONS(3956),
    [anon_sym_TILDE] = ACTIONS(3956),
    [anon_sym_PLUS_PLUS] = ACTIONS(3956),
    [anon_sym_DASH_DASH] = ACTIONS(3956),
    [anon_sym_true] = ACTIONS(3958),
    [anon_sym_false] = ACTIONS(3958),
    [anon_sym_PLUS] = ACTIONS(3958),
    [anon_sym_DASH] = ACTIONS(3958),
    [anon_sym_STAR] = ACTIONS(3956),
    [anon_sym_CARET] = ACTIONS(3956),
    [anon_sym_AMP] = ACTIONS(3956),
    [anon_sym_this] = ACTIONS(3958),
    [anon_sym_scoped] = ACTIONS(3958),
    [anon_sym_var] = ACTIONS(3958),
    [sym_predefined_type] = ACTIONS(3958),
    [anon_sym_break] = ACTIONS(3958),
    [anon_sym_unchecked] = ACTIONS(3958),
    [anon_sym_continue] = ACTIONS(3958),
    [anon_sym_do] = ACTIONS(3958),
    [anon_sym_while] = ACTIONS(3958),
    [anon_sym_for] = ACTIONS(3958),
    [anon_sym_lock] = ACTIONS(3958),
    [anon_sym_yield] = ACTIONS(3958),
    [anon_sym_switch] = ACTIONS(3958),
    [anon_sym_default] = ACTIONS(3958),
    [anon_sym_throw] = ACTIONS(3958),
    [anon_sym_try] = ACTIONS(3958),
    [anon_sym_when] = ACTIONS(3958),
    [anon_sym_await] = ACTIONS(3958),
    [anon_sym_foreach] = ACTIONS(3958),
    [anon_sym_goto] = ACTIONS(3958),
    [anon_sym_if] = ACTIONS(3958),
    [anon_sym_DOT_DOT] = ACTIONS(3956),
    [anon_sym_from] = ACTIONS(3958),
    [anon_sym_into] = ACTIONS(3958),
    [anon_sym_join] = ACTIONS(3958),
    [anon_sym_on] = ACTIONS(3958),
    [anon_sym_equals] = ACTIONS(3958),
    [anon_sym_let] = ACTIONS(3958),
    [anon_sym_orderby] = ACTIONS(3958),
    [anon_sym_ascending] = ACTIONS(3958),
    [anon_sym_descending] = ACTIONS(3958),
    [anon_sym_group] = ACTIONS(3958),
    [anon_sym_by] = ACTIONS(3958),
    [anon_sym_select] = ACTIONS(3958),
    [anon_sym_DQUOTE] = ACTIONS(3958),
    [anon_sym_stackalloc] = ACTIONS(3958),
    [anon_sym_sizeof] = ACTIONS(3958),
    [anon_sym_typeof] = ACTIONS(3958),
    [anon_sym___makeref] = ACTIONS(3958),
    [anon_sym___reftype] = ACTIONS(3958),
    [anon_sym___refvalue] = ACTIONS(3958),
    [sym_null_literal] = ACTIONS(3958),
    [anon_sym_SQUOTE] = ACTIONS(3956),
    [sym_integer_literal] = ACTIONS(3958),
    [sym_real_literal] = ACTIONS(3956),
    [sym_verbatim_string_literal] = ACTIONS(3956),
    [sym_raw_string_literal] = ACTIONS(3956),
    [aux_sym_preproc_if_token1] = ACTIONS(3956),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3956),
    [sym_interpolation_verbatim_start] = ACTIONS(3956),
    [sym_interpolation_raw_start] = ACTIONS(3956),
  },
  [2548] = {
    [sym_preproc_region] = STATE(2548),
    [sym_preproc_endregion] = STATE(2548),
    [sym_preproc_line] = STATE(2548),
    [sym_preproc_pragma] = STATE(2548),
    [sym_preproc_nullable] = STATE(2548),
    [sym_preproc_error] = STATE(2548),
    [sym_preproc_define] = STATE(2548),
    [sym_preproc_undef] = STATE(2548),
    [ts_builtin_sym_end] = ACTIONS(3830),
    [sym__identifier_token] = ACTIONS(3828),
    [anon_sym_extern] = ACTIONS(3828),
    [anon_sym_alias] = ACTIONS(3828),
    [anon_sym_SEMI] = ACTIONS(3830),
    [anon_sym_global] = ACTIONS(3828),
    [anon_sym_using] = ACTIONS(3828),
    [anon_sym_unsafe] = ACTIONS(3828),
    [anon_sym_static] = ACTIONS(3828),
    [anon_sym_LBRACK] = ACTIONS(3830),
    [anon_sym_LPAREN] = ACTIONS(3830),
    [anon_sym_return] = ACTIONS(3828),
    [anon_sym_namespace] = ACTIONS(3828),
    [anon_sym_class] = ACTIONS(3828),
    [anon_sym_ref] = ACTIONS(3828),
    [anon_sym_struct] = ACTIONS(3828),
    [anon_sym_enum] = ACTIONS(3828),
    [anon_sym_LBRACE] = ACTIONS(3830),
    [anon_sym_interface] = ACTIONS(3828),
    [anon_sym_delegate] = ACTIONS(3828),
    [anon_sym_record] = ACTIONS(3828),
    [anon_sym_abstract] = ACTIONS(3828),
    [anon_sym_async] = ACTIONS(3828),
    [anon_sym_const] = ACTIONS(3828),
    [anon_sym_file] = ACTIONS(3828),
    [anon_sym_fixed] = ACTIONS(3828),
    [anon_sym_internal] = ACTIONS(3828),
    [anon_sym_new] = ACTIONS(3828),
    [anon_sym_override] = ACTIONS(3828),
    [anon_sym_partial] = ACTIONS(3828),
    [anon_sym_private] = ACTIONS(3828),
    [anon_sym_protected] = ACTIONS(3828),
    [anon_sym_public] = ACTIONS(3828),
    [anon_sym_readonly] = ACTIONS(3828),
    [anon_sym_required] = ACTIONS(3828),
    [anon_sym_sealed] = ACTIONS(3828),
    [anon_sym_virtual] = ACTIONS(3828),
    [anon_sym_volatile] = ACTIONS(3828),
    [anon_sym_where] = ACTIONS(3828),
    [anon_sym_notnull] = ACTIONS(3828),
    [anon_sym_unmanaged] = ACTIONS(3828),
    [anon_sym_checked] = ACTIONS(3828),
    [anon_sym_BANG] = ACTIONS(3830),
    [anon_sym_TILDE] = ACTIONS(3830),
    [anon_sym_PLUS_PLUS] = ACTIONS(3830),
    [anon_sym_DASH_DASH] = ACTIONS(3830),
    [anon_sym_true] = ACTIONS(3828),
    [anon_sym_false] = ACTIONS(3828),
    [anon_sym_PLUS] = ACTIONS(3828),
    [anon_sym_DASH] = ACTIONS(3828),
    [anon_sym_STAR] = ACTIONS(3830),
    [anon_sym_CARET] = ACTIONS(3830),
    [anon_sym_AMP] = ACTIONS(3830),
    [anon_sym_this] = ACTIONS(3828),
    [anon_sym_scoped] = ACTIONS(3828),
    [anon_sym_var] = ACTIONS(3828),
    [sym_predefined_type] = ACTIONS(3828),
    [anon_sym_break] = ACTIONS(3828),
    [anon_sym_unchecked] = ACTIONS(3828),
    [anon_sym_continue] = ACTIONS(3828),
    [anon_sym_do] = ACTIONS(3828),
    [anon_sym_while] = ACTIONS(3828),
    [anon_sym_for] = ACTIONS(3828),
    [anon_sym_lock] = ACTIONS(3828),
    [anon_sym_yield] = ACTIONS(3828),
    [anon_sym_switch] = ACTIONS(3828),
    [anon_sym_default] = ACTIONS(3828),
    [anon_sym_throw] = ACTIONS(3828),
    [anon_sym_try] = ACTIONS(3828),
    [anon_sym_when] = ACTIONS(3828),
    [anon_sym_await] = ACTIONS(3828),
    [anon_sym_foreach] = ACTIONS(3828),
    [anon_sym_goto] = ACTIONS(3828),
    [anon_sym_if] = ACTIONS(3828),
    [anon_sym_DOT_DOT] = ACTIONS(3830),
    [anon_sym_from] = ACTIONS(3828),
    [anon_sym_into] = ACTIONS(3828),
    [anon_sym_join] = ACTIONS(3828),
    [anon_sym_on] = ACTIONS(3828),
    [anon_sym_equals] = ACTIONS(3828),
    [anon_sym_let] = ACTIONS(3828),
    [anon_sym_orderby] = ACTIONS(3828),
    [anon_sym_ascending] = ACTIONS(3828),
    [anon_sym_descending] = ACTIONS(3828),
    [anon_sym_group] = ACTIONS(3828),
    [anon_sym_by] = ACTIONS(3828),
    [anon_sym_select] = ACTIONS(3828),
    [anon_sym_DQUOTE] = ACTIONS(3828),
    [anon_sym_stackalloc] = ACTIONS(3828),
    [anon_sym_sizeof] = ACTIONS(3828),
    [anon_sym_typeof] = ACTIONS(3828),
    [anon_sym___makeref] = ACTIONS(3828),
    [anon_sym___reftype] = ACTIONS(3828),
    [anon_sym___refvalue] = ACTIONS(3828),
    [sym_null_literal] = ACTIONS(3828),
    [anon_sym_SQUOTE] = ACTIONS(3830),
    [sym_integer_literal] = ACTIONS(3828),
    [sym_real_literal] = ACTIONS(3830),
    [sym_verbatim_string_literal] = ACTIONS(3830),
    [sym_raw_string_literal] = ACTIONS(3830),
    [aux_sym_preproc_if_token1] = ACTIONS(3830),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3830),
    [sym_interpolation_verbatim_start] = ACTIONS(3830),
    [sym_interpolation_raw_start] = ACTIONS(3830),
  },
  [2549] = {
    [sym_preproc_region] = STATE(2549),
    [sym_preproc_endregion] = STATE(2549),
    [sym_preproc_line] = STATE(2549),
    [sym_preproc_pragma] = STATE(2549),
    [sym_preproc_nullable] = STATE(2549),
    [sym_preproc_error] = STATE(2549),
    [sym_preproc_define] = STATE(2549),
    [sym_preproc_undef] = STATE(2549),
    [ts_builtin_sym_end] = ACTIONS(3822),
    [sym__identifier_token] = ACTIONS(3820),
    [anon_sym_extern] = ACTIONS(3820),
    [anon_sym_alias] = ACTIONS(3820),
    [anon_sym_SEMI] = ACTIONS(3822),
    [anon_sym_global] = ACTIONS(3820),
    [anon_sym_using] = ACTIONS(3820),
    [anon_sym_unsafe] = ACTIONS(3820),
    [anon_sym_static] = ACTIONS(3820),
    [anon_sym_LBRACK] = ACTIONS(3822),
    [anon_sym_LPAREN] = ACTIONS(3822),
    [anon_sym_return] = ACTIONS(3820),
    [anon_sym_namespace] = ACTIONS(3820),
    [anon_sym_class] = ACTIONS(3820),
    [anon_sym_ref] = ACTIONS(3820),
    [anon_sym_struct] = ACTIONS(3820),
    [anon_sym_enum] = ACTIONS(3820),
    [anon_sym_LBRACE] = ACTIONS(3822),
    [anon_sym_interface] = ACTIONS(3820),
    [anon_sym_delegate] = ACTIONS(3820),
    [anon_sym_record] = ACTIONS(3820),
    [anon_sym_abstract] = ACTIONS(3820),
    [anon_sym_async] = ACTIONS(3820),
    [anon_sym_const] = ACTIONS(3820),
    [anon_sym_file] = ACTIONS(3820),
    [anon_sym_fixed] = ACTIONS(3820),
    [anon_sym_internal] = ACTIONS(3820),
    [anon_sym_new] = ACTIONS(3820),
    [anon_sym_override] = ACTIONS(3820),
    [anon_sym_partial] = ACTIONS(3820),
    [anon_sym_private] = ACTIONS(3820),
    [anon_sym_protected] = ACTIONS(3820),
    [anon_sym_public] = ACTIONS(3820),
    [anon_sym_readonly] = ACTIONS(3820),
    [anon_sym_required] = ACTIONS(3820),
    [anon_sym_sealed] = ACTIONS(3820),
    [anon_sym_virtual] = ACTIONS(3820),
    [anon_sym_volatile] = ACTIONS(3820),
    [anon_sym_where] = ACTIONS(3820),
    [anon_sym_notnull] = ACTIONS(3820),
    [anon_sym_unmanaged] = ACTIONS(3820),
    [anon_sym_checked] = ACTIONS(3820),
    [anon_sym_BANG] = ACTIONS(3822),
    [anon_sym_TILDE] = ACTIONS(3822),
    [anon_sym_PLUS_PLUS] = ACTIONS(3822),
    [anon_sym_DASH_DASH] = ACTIONS(3822),
    [anon_sym_true] = ACTIONS(3820),
    [anon_sym_false] = ACTIONS(3820),
    [anon_sym_PLUS] = ACTIONS(3820),
    [anon_sym_DASH] = ACTIONS(3820),
    [anon_sym_STAR] = ACTIONS(3822),
    [anon_sym_CARET] = ACTIONS(3822),
    [anon_sym_AMP] = ACTIONS(3822),
    [anon_sym_this] = ACTIONS(3820),
    [anon_sym_scoped] = ACTIONS(3820),
    [anon_sym_var] = ACTIONS(3820),
    [sym_predefined_type] = ACTIONS(3820),
    [anon_sym_break] = ACTIONS(3820),
    [anon_sym_unchecked] = ACTIONS(3820),
    [anon_sym_continue] = ACTIONS(3820),
    [anon_sym_do] = ACTIONS(3820),
    [anon_sym_while] = ACTIONS(3820),
    [anon_sym_for] = ACTIONS(3820),
    [anon_sym_lock] = ACTIONS(3820),
    [anon_sym_yield] = ACTIONS(3820),
    [anon_sym_switch] = ACTIONS(3820),
    [anon_sym_default] = ACTIONS(3820),
    [anon_sym_throw] = ACTIONS(3820),
    [anon_sym_try] = ACTIONS(3820),
    [anon_sym_when] = ACTIONS(3820),
    [anon_sym_await] = ACTIONS(3820),
    [anon_sym_foreach] = ACTIONS(3820),
    [anon_sym_goto] = ACTIONS(3820),
    [anon_sym_if] = ACTIONS(3820),
    [anon_sym_DOT_DOT] = ACTIONS(3822),
    [anon_sym_from] = ACTIONS(3820),
    [anon_sym_into] = ACTIONS(3820),
    [anon_sym_join] = ACTIONS(3820),
    [anon_sym_on] = ACTIONS(3820),
    [anon_sym_equals] = ACTIONS(3820),
    [anon_sym_let] = ACTIONS(3820),
    [anon_sym_orderby] = ACTIONS(3820),
    [anon_sym_ascending] = ACTIONS(3820),
    [anon_sym_descending] = ACTIONS(3820),
    [anon_sym_group] = ACTIONS(3820),
    [anon_sym_by] = ACTIONS(3820),
    [anon_sym_select] = ACTIONS(3820),
    [anon_sym_DQUOTE] = ACTIONS(3820),
    [anon_sym_stackalloc] = ACTIONS(3820),
    [anon_sym_sizeof] = ACTIONS(3820),
    [anon_sym_typeof] = ACTIONS(3820),
    [anon_sym___makeref] = ACTIONS(3820),
    [anon_sym___reftype] = ACTIONS(3820),
    [anon_sym___refvalue] = ACTIONS(3820),
    [sym_null_literal] = ACTIONS(3820),
    [anon_sym_SQUOTE] = ACTIONS(3822),
    [sym_integer_literal] = ACTIONS(3820),
    [sym_real_literal] = ACTIONS(3822),
    [sym_verbatim_string_literal] = ACTIONS(3822),
    [sym_raw_string_literal] = ACTIONS(3822),
    [aux_sym_preproc_if_token1] = ACTIONS(3822),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3822),
    [sym_interpolation_verbatim_start] = ACTIONS(3822),
    [sym_interpolation_raw_start] = ACTIONS(3822),
  },
  [2550] = {
    [sym_preproc_region] = STATE(2550),
    [sym_preproc_endregion] = STATE(2550),
    [sym_preproc_line] = STATE(2550),
    [sym_preproc_pragma] = STATE(2550),
    [sym_preproc_nullable] = STATE(2550),
    [sym_preproc_error] = STATE(2550),
    [sym_preproc_define] = STATE(2550),
    [sym_preproc_undef] = STATE(2550),
    [ts_builtin_sym_end] = ACTIONS(3818),
    [sym__identifier_token] = ACTIONS(3816),
    [anon_sym_extern] = ACTIONS(3816),
    [anon_sym_alias] = ACTIONS(3816),
    [anon_sym_SEMI] = ACTIONS(3818),
    [anon_sym_global] = ACTIONS(3816),
    [anon_sym_using] = ACTIONS(3816),
    [anon_sym_unsafe] = ACTIONS(3816),
    [anon_sym_static] = ACTIONS(3816),
    [anon_sym_LBRACK] = ACTIONS(3818),
    [anon_sym_LPAREN] = ACTIONS(3818),
    [anon_sym_return] = ACTIONS(3816),
    [anon_sym_namespace] = ACTIONS(3816),
    [anon_sym_class] = ACTIONS(3816),
    [anon_sym_ref] = ACTIONS(3816),
    [anon_sym_struct] = ACTIONS(3816),
    [anon_sym_enum] = ACTIONS(3816),
    [anon_sym_LBRACE] = ACTIONS(3818),
    [anon_sym_interface] = ACTIONS(3816),
    [anon_sym_delegate] = ACTIONS(3816),
    [anon_sym_record] = ACTIONS(3816),
    [anon_sym_abstract] = ACTIONS(3816),
    [anon_sym_async] = ACTIONS(3816),
    [anon_sym_const] = ACTIONS(3816),
    [anon_sym_file] = ACTIONS(3816),
    [anon_sym_fixed] = ACTIONS(3816),
    [anon_sym_internal] = ACTIONS(3816),
    [anon_sym_new] = ACTIONS(3816),
    [anon_sym_override] = ACTIONS(3816),
    [anon_sym_partial] = ACTIONS(3816),
    [anon_sym_private] = ACTIONS(3816),
    [anon_sym_protected] = ACTIONS(3816),
    [anon_sym_public] = ACTIONS(3816),
    [anon_sym_readonly] = ACTIONS(3816),
    [anon_sym_required] = ACTIONS(3816),
    [anon_sym_sealed] = ACTIONS(3816),
    [anon_sym_virtual] = ACTIONS(3816),
    [anon_sym_volatile] = ACTIONS(3816),
    [anon_sym_where] = ACTIONS(3816),
    [anon_sym_notnull] = ACTIONS(3816),
    [anon_sym_unmanaged] = ACTIONS(3816),
    [anon_sym_checked] = ACTIONS(3816),
    [anon_sym_BANG] = ACTIONS(3818),
    [anon_sym_TILDE] = ACTIONS(3818),
    [anon_sym_PLUS_PLUS] = ACTIONS(3818),
    [anon_sym_DASH_DASH] = ACTIONS(3818),
    [anon_sym_true] = ACTIONS(3816),
    [anon_sym_false] = ACTIONS(3816),
    [anon_sym_PLUS] = ACTIONS(3816),
    [anon_sym_DASH] = ACTIONS(3816),
    [anon_sym_STAR] = ACTIONS(3818),
    [anon_sym_CARET] = ACTIONS(3818),
    [anon_sym_AMP] = ACTIONS(3818),
    [anon_sym_this] = ACTIONS(3816),
    [anon_sym_scoped] = ACTIONS(3816),
    [anon_sym_var] = ACTIONS(3816),
    [sym_predefined_type] = ACTIONS(3816),
    [anon_sym_break] = ACTIONS(3816),
    [anon_sym_unchecked] = ACTIONS(3816),
    [anon_sym_continue] = ACTIONS(3816),
    [anon_sym_do] = ACTIONS(3816),
    [anon_sym_while] = ACTIONS(3816),
    [anon_sym_for] = ACTIONS(3816),
    [anon_sym_lock] = ACTIONS(3816),
    [anon_sym_yield] = ACTIONS(3816),
    [anon_sym_switch] = ACTIONS(3816),
    [anon_sym_default] = ACTIONS(3816),
    [anon_sym_throw] = ACTIONS(3816),
    [anon_sym_try] = ACTIONS(3816),
    [anon_sym_when] = ACTIONS(3816),
    [anon_sym_await] = ACTIONS(3816),
    [anon_sym_foreach] = ACTIONS(3816),
    [anon_sym_goto] = ACTIONS(3816),
    [anon_sym_if] = ACTIONS(3816),
    [anon_sym_DOT_DOT] = ACTIONS(3818),
    [anon_sym_from] = ACTIONS(3816),
    [anon_sym_into] = ACTIONS(3816),
    [anon_sym_join] = ACTIONS(3816),
    [anon_sym_on] = ACTIONS(3816),
    [anon_sym_equals] = ACTIONS(3816),
    [anon_sym_let] = ACTIONS(3816),
    [anon_sym_orderby] = ACTIONS(3816),
    [anon_sym_ascending] = ACTIONS(3816),
    [anon_sym_descending] = ACTIONS(3816),
    [anon_sym_group] = ACTIONS(3816),
    [anon_sym_by] = ACTIONS(3816),
    [anon_sym_select] = ACTIONS(3816),
    [anon_sym_DQUOTE] = ACTIONS(3816),
    [anon_sym_stackalloc] = ACTIONS(3816),
    [anon_sym_sizeof] = ACTIONS(3816),
    [anon_sym_typeof] = ACTIONS(3816),
    [anon_sym___makeref] = ACTIONS(3816),
    [anon_sym___reftype] = ACTIONS(3816),
    [anon_sym___refvalue] = ACTIONS(3816),
    [sym_null_literal] = ACTIONS(3816),
    [anon_sym_SQUOTE] = ACTIONS(3818),
    [sym_integer_literal] = ACTIONS(3816),
    [sym_real_literal] = ACTIONS(3818),
    [sym_verbatim_string_literal] = ACTIONS(3818),
    [sym_raw_string_literal] = ACTIONS(3818),
    [aux_sym_preproc_if_token1] = ACTIONS(3818),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3818),
    [sym_interpolation_verbatim_start] = ACTIONS(3818),
    [sym_interpolation_raw_start] = ACTIONS(3818),
  },
  [2551] = {
    [sym_preproc_region] = STATE(2551),
    [sym_preproc_endregion] = STATE(2551),
    [sym_preproc_line] = STATE(2551),
    [sym_preproc_pragma] = STATE(2551),
    [sym_preproc_nullable] = STATE(2551),
    [sym_preproc_error] = STATE(2551),
    [sym_preproc_define] = STATE(2551),
    [sym_preproc_undef] = STATE(2551),
    [ts_builtin_sym_end] = ACTIONS(3782),
    [sym__identifier_token] = ACTIONS(3780),
    [anon_sym_extern] = ACTIONS(3780),
    [anon_sym_alias] = ACTIONS(3780),
    [anon_sym_SEMI] = ACTIONS(3782),
    [anon_sym_global] = ACTIONS(3780),
    [anon_sym_using] = ACTIONS(3780),
    [anon_sym_unsafe] = ACTIONS(3780),
    [anon_sym_static] = ACTIONS(3780),
    [anon_sym_LBRACK] = ACTIONS(3782),
    [anon_sym_LPAREN] = ACTIONS(3782),
    [anon_sym_return] = ACTIONS(3780),
    [anon_sym_namespace] = ACTIONS(3780),
    [anon_sym_class] = ACTIONS(3780),
    [anon_sym_ref] = ACTIONS(3780),
    [anon_sym_struct] = ACTIONS(3780),
    [anon_sym_enum] = ACTIONS(3780),
    [anon_sym_LBRACE] = ACTIONS(3782),
    [anon_sym_interface] = ACTIONS(3780),
    [anon_sym_delegate] = ACTIONS(3780),
    [anon_sym_record] = ACTIONS(3780),
    [anon_sym_abstract] = ACTIONS(3780),
    [anon_sym_async] = ACTIONS(3780),
    [anon_sym_const] = ACTIONS(3780),
    [anon_sym_file] = ACTIONS(3780),
    [anon_sym_fixed] = ACTIONS(3780),
    [anon_sym_internal] = ACTIONS(3780),
    [anon_sym_new] = ACTIONS(3780),
    [anon_sym_override] = ACTIONS(3780),
    [anon_sym_partial] = ACTIONS(3780),
    [anon_sym_private] = ACTIONS(3780),
    [anon_sym_protected] = ACTIONS(3780),
    [anon_sym_public] = ACTIONS(3780),
    [anon_sym_readonly] = ACTIONS(3780),
    [anon_sym_required] = ACTIONS(3780),
    [anon_sym_sealed] = ACTIONS(3780),
    [anon_sym_virtual] = ACTIONS(3780),
    [anon_sym_volatile] = ACTIONS(3780),
    [anon_sym_where] = ACTIONS(3780),
    [anon_sym_notnull] = ACTIONS(3780),
    [anon_sym_unmanaged] = ACTIONS(3780),
    [anon_sym_checked] = ACTIONS(3780),
    [anon_sym_BANG] = ACTIONS(3782),
    [anon_sym_TILDE] = ACTIONS(3782),
    [anon_sym_PLUS_PLUS] = ACTIONS(3782),
    [anon_sym_DASH_DASH] = ACTIONS(3782),
    [anon_sym_true] = ACTIONS(3780),
    [anon_sym_false] = ACTIONS(3780),
    [anon_sym_PLUS] = ACTIONS(3780),
    [anon_sym_DASH] = ACTIONS(3780),
    [anon_sym_STAR] = ACTIONS(3782),
    [anon_sym_CARET] = ACTIONS(3782),
    [anon_sym_AMP] = ACTIONS(3782),
    [anon_sym_this] = ACTIONS(3780),
    [anon_sym_scoped] = ACTIONS(3780),
    [anon_sym_var] = ACTIONS(3780),
    [sym_predefined_type] = ACTIONS(3780),
    [anon_sym_break] = ACTIONS(3780),
    [anon_sym_unchecked] = ACTIONS(3780),
    [anon_sym_continue] = ACTIONS(3780),
    [anon_sym_do] = ACTIONS(3780),
    [anon_sym_while] = ACTIONS(3780),
    [anon_sym_for] = ACTIONS(3780),
    [anon_sym_lock] = ACTIONS(3780),
    [anon_sym_yield] = ACTIONS(3780),
    [anon_sym_switch] = ACTIONS(3780),
    [anon_sym_default] = ACTIONS(3780),
    [anon_sym_throw] = ACTIONS(3780),
    [anon_sym_try] = ACTIONS(3780),
    [anon_sym_when] = ACTIONS(3780),
    [anon_sym_await] = ACTIONS(3780),
    [anon_sym_foreach] = ACTIONS(3780),
    [anon_sym_goto] = ACTIONS(3780),
    [anon_sym_if] = ACTIONS(3780),
    [anon_sym_DOT_DOT] = ACTIONS(3782),
    [anon_sym_from] = ACTIONS(3780),
    [anon_sym_into] = ACTIONS(3780),
    [anon_sym_join] = ACTIONS(3780),
    [anon_sym_on] = ACTIONS(3780),
    [anon_sym_equals] = ACTIONS(3780),
    [anon_sym_let] = ACTIONS(3780),
    [anon_sym_orderby] = ACTIONS(3780),
    [anon_sym_ascending] = ACTIONS(3780),
    [anon_sym_descending] = ACTIONS(3780),
    [anon_sym_group] = ACTIONS(3780),
    [anon_sym_by] = ACTIONS(3780),
    [anon_sym_select] = ACTIONS(3780),
    [anon_sym_DQUOTE] = ACTIONS(3780),
    [anon_sym_stackalloc] = ACTIONS(3780),
    [anon_sym_sizeof] = ACTIONS(3780),
    [anon_sym_typeof] = ACTIONS(3780),
    [anon_sym___makeref] = ACTIONS(3780),
    [anon_sym___reftype] = ACTIONS(3780),
    [anon_sym___refvalue] = ACTIONS(3780),
    [sym_null_literal] = ACTIONS(3780),
    [anon_sym_SQUOTE] = ACTIONS(3782),
    [sym_integer_literal] = ACTIONS(3780),
    [sym_real_literal] = ACTIONS(3782),
    [sym_verbatim_string_literal] = ACTIONS(3782),
    [sym_raw_string_literal] = ACTIONS(3782),
    [aux_sym_preproc_if_token1] = ACTIONS(3782),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3782),
    [sym_interpolation_verbatim_start] = ACTIONS(3782),
    [sym_interpolation_raw_start] = ACTIONS(3782),
  },
  [2552] = {
    [sym_preproc_region] = STATE(2552),
    [sym_preproc_endregion] = STATE(2552),
    [sym_preproc_line] = STATE(2552),
    [sym_preproc_pragma] = STATE(2552),
    [sym_preproc_nullable] = STATE(2552),
    [sym_preproc_error] = STATE(2552),
    [sym_preproc_define] = STATE(2552),
    [sym_preproc_undef] = STATE(2552),
    [ts_builtin_sym_end] = ACTIONS(3814),
    [sym__identifier_token] = ACTIONS(3812),
    [anon_sym_extern] = ACTIONS(3812),
    [anon_sym_alias] = ACTIONS(3812),
    [anon_sym_SEMI] = ACTIONS(3814),
    [anon_sym_global] = ACTIONS(3812),
    [anon_sym_using] = ACTIONS(3812),
    [anon_sym_unsafe] = ACTIONS(3812),
    [anon_sym_static] = ACTIONS(3812),
    [anon_sym_LBRACK] = ACTIONS(3814),
    [anon_sym_LPAREN] = ACTIONS(3814),
    [anon_sym_return] = ACTIONS(3812),
    [anon_sym_namespace] = ACTIONS(3812),
    [anon_sym_class] = ACTIONS(3812),
    [anon_sym_ref] = ACTIONS(3812),
    [anon_sym_struct] = ACTIONS(3812),
    [anon_sym_enum] = ACTIONS(3812),
    [anon_sym_LBRACE] = ACTIONS(3814),
    [anon_sym_interface] = ACTIONS(3812),
    [anon_sym_delegate] = ACTIONS(3812),
    [anon_sym_record] = ACTIONS(3812),
    [anon_sym_abstract] = ACTIONS(3812),
    [anon_sym_async] = ACTIONS(3812),
    [anon_sym_const] = ACTIONS(3812),
    [anon_sym_file] = ACTIONS(3812),
    [anon_sym_fixed] = ACTIONS(3812),
    [anon_sym_internal] = ACTIONS(3812),
    [anon_sym_new] = ACTIONS(3812),
    [anon_sym_override] = ACTIONS(3812),
    [anon_sym_partial] = ACTIONS(3812),
    [anon_sym_private] = ACTIONS(3812),
    [anon_sym_protected] = ACTIONS(3812),
    [anon_sym_public] = ACTIONS(3812),
    [anon_sym_readonly] = ACTIONS(3812),
    [anon_sym_required] = ACTIONS(3812),
    [anon_sym_sealed] = ACTIONS(3812),
    [anon_sym_virtual] = ACTIONS(3812),
    [anon_sym_volatile] = ACTIONS(3812),
    [anon_sym_where] = ACTIONS(3812),
    [anon_sym_notnull] = ACTIONS(3812),
    [anon_sym_unmanaged] = ACTIONS(3812),
    [anon_sym_checked] = ACTIONS(3812),
    [anon_sym_BANG] = ACTIONS(3814),
    [anon_sym_TILDE] = ACTIONS(3814),
    [anon_sym_PLUS_PLUS] = ACTIONS(3814),
    [anon_sym_DASH_DASH] = ACTIONS(3814),
    [anon_sym_true] = ACTIONS(3812),
    [anon_sym_false] = ACTIONS(3812),
    [anon_sym_PLUS] = ACTIONS(3812),
    [anon_sym_DASH] = ACTIONS(3812),
    [anon_sym_STAR] = ACTIONS(3814),
    [anon_sym_CARET] = ACTIONS(3814),
    [anon_sym_AMP] = ACTIONS(3814),
    [anon_sym_this] = ACTIONS(3812),
    [anon_sym_scoped] = ACTIONS(3812),
    [anon_sym_var] = ACTIONS(3812),
    [sym_predefined_type] = ACTIONS(3812),
    [anon_sym_break] = ACTIONS(3812),
    [anon_sym_unchecked] = ACTIONS(3812),
    [anon_sym_continue] = ACTIONS(3812),
    [anon_sym_do] = ACTIONS(3812),
    [anon_sym_while] = ACTIONS(3812),
    [anon_sym_for] = ACTIONS(3812),
    [anon_sym_lock] = ACTIONS(3812),
    [anon_sym_yield] = ACTIONS(3812),
    [anon_sym_switch] = ACTIONS(3812),
    [anon_sym_default] = ACTIONS(3812),
    [anon_sym_throw] = ACTIONS(3812),
    [anon_sym_try] = ACTIONS(3812),
    [anon_sym_when] = ACTIONS(3812),
    [anon_sym_await] = ACTIONS(3812),
    [anon_sym_foreach] = ACTIONS(3812),
    [anon_sym_goto] = ACTIONS(3812),
    [anon_sym_if] = ACTIONS(3812),
    [anon_sym_DOT_DOT] = ACTIONS(3814),
    [anon_sym_from] = ACTIONS(3812),
    [anon_sym_into] = ACTIONS(3812),
    [anon_sym_join] = ACTIONS(3812),
    [anon_sym_on] = ACTIONS(3812),
    [anon_sym_equals] = ACTIONS(3812),
    [anon_sym_let] = ACTIONS(3812),
    [anon_sym_orderby] = ACTIONS(3812),
    [anon_sym_ascending] = ACTIONS(3812),
    [anon_sym_descending] = ACTIONS(3812),
    [anon_sym_group] = ACTIONS(3812),
    [anon_sym_by] = ACTIONS(3812),
    [anon_sym_select] = ACTIONS(3812),
    [anon_sym_DQUOTE] = ACTIONS(3812),
    [anon_sym_stackalloc] = ACTIONS(3812),
    [anon_sym_sizeof] = ACTIONS(3812),
    [anon_sym_typeof] = ACTIONS(3812),
    [anon_sym___makeref] = ACTIONS(3812),
    [anon_sym___reftype] = ACTIONS(3812),
    [anon_sym___refvalue] = ACTIONS(3812),
    [sym_null_literal] = ACTIONS(3812),
    [anon_sym_SQUOTE] = ACTIONS(3814),
    [sym_integer_literal] = ACTIONS(3812),
    [sym_real_literal] = ACTIONS(3814),
    [sym_verbatim_string_literal] = ACTIONS(3814),
    [sym_raw_string_literal] = ACTIONS(3814),
    [aux_sym_preproc_if_token1] = ACTIONS(3814),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3814),
    [sym_interpolation_verbatim_start] = ACTIONS(3814),
    [sym_interpolation_raw_start] = ACTIONS(3814),
  },
  [2553] = {
    [sym_preproc_region] = STATE(2553),
    [sym_preproc_endregion] = STATE(2553),
    [sym_preproc_line] = STATE(2553),
    [sym_preproc_pragma] = STATE(2553),
    [sym_preproc_nullable] = STATE(2553),
    [sym_preproc_error] = STATE(2553),
    [sym_preproc_define] = STATE(2553),
    [sym_preproc_undef] = STATE(2553),
    [ts_builtin_sym_end] = ACTIONS(3878),
    [sym__identifier_token] = ACTIONS(3876),
    [anon_sym_extern] = ACTIONS(3876),
    [anon_sym_alias] = ACTIONS(3876),
    [anon_sym_SEMI] = ACTIONS(3878),
    [anon_sym_global] = ACTIONS(3876),
    [anon_sym_using] = ACTIONS(3876),
    [anon_sym_unsafe] = ACTIONS(3876),
    [anon_sym_static] = ACTIONS(3876),
    [anon_sym_LBRACK] = ACTIONS(3878),
    [anon_sym_LPAREN] = ACTIONS(3878),
    [anon_sym_return] = ACTIONS(3876),
    [anon_sym_namespace] = ACTIONS(3876),
    [anon_sym_class] = ACTIONS(3876),
    [anon_sym_ref] = ACTIONS(3876),
    [anon_sym_struct] = ACTIONS(3876),
    [anon_sym_enum] = ACTIONS(3876),
    [anon_sym_LBRACE] = ACTIONS(3878),
    [anon_sym_interface] = ACTIONS(3876),
    [anon_sym_delegate] = ACTIONS(3876),
    [anon_sym_record] = ACTIONS(3876),
    [anon_sym_abstract] = ACTIONS(3876),
    [anon_sym_async] = ACTIONS(3876),
    [anon_sym_const] = ACTIONS(3876),
    [anon_sym_file] = ACTIONS(3876),
    [anon_sym_fixed] = ACTIONS(3876),
    [anon_sym_internal] = ACTIONS(3876),
    [anon_sym_new] = ACTIONS(3876),
    [anon_sym_override] = ACTIONS(3876),
    [anon_sym_partial] = ACTIONS(3876),
    [anon_sym_private] = ACTIONS(3876),
    [anon_sym_protected] = ACTIONS(3876),
    [anon_sym_public] = ACTIONS(3876),
    [anon_sym_readonly] = ACTIONS(3876),
    [anon_sym_required] = ACTIONS(3876),
    [anon_sym_sealed] = ACTIONS(3876),
    [anon_sym_virtual] = ACTIONS(3876),
    [anon_sym_volatile] = ACTIONS(3876),
    [anon_sym_where] = ACTIONS(3876),
    [anon_sym_notnull] = ACTIONS(3876),
    [anon_sym_unmanaged] = ACTIONS(3876),
    [anon_sym_checked] = ACTIONS(3876),
    [anon_sym_BANG] = ACTIONS(3878),
    [anon_sym_TILDE] = ACTIONS(3878),
    [anon_sym_PLUS_PLUS] = ACTIONS(3878),
    [anon_sym_DASH_DASH] = ACTIONS(3878),
    [anon_sym_true] = ACTIONS(3876),
    [anon_sym_false] = ACTIONS(3876),
    [anon_sym_PLUS] = ACTIONS(3876),
    [anon_sym_DASH] = ACTIONS(3876),
    [anon_sym_STAR] = ACTIONS(3878),
    [anon_sym_CARET] = ACTIONS(3878),
    [anon_sym_AMP] = ACTIONS(3878),
    [anon_sym_this] = ACTIONS(3876),
    [anon_sym_scoped] = ACTIONS(3876),
    [anon_sym_var] = ACTIONS(3876),
    [sym_predefined_type] = ACTIONS(3876),
    [anon_sym_break] = ACTIONS(3876),
    [anon_sym_unchecked] = ACTIONS(3876),
    [anon_sym_continue] = ACTIONS(3876),
    [anon_sym_do] = ACTIONS(3876),
    [anon_sym_while] = ACTIONS(3876),
    [anon_sym_for] = ACTIONS(3876),
    [anon_sym_lock] = ACTIONS(3876),
    [anon_sym_yield] = ACTIONS(3876),
    [anon_sym_switch] = ACTIONS(3876),
    [anon_sym_default] = ACTIONS(3876),
    [anon_sym_throw] = ACTIONS(3876),
    [anon_sym_try] = ACTIONS(3876),
    [anon_sym_when] = ACTIONS(3876),
    [anon_sym_await] = ACTIONS(3876),
    [anon_sym_foreach] = ACTIONS(3876),
    [anon_sym_goto] = ACTIONS(3876),
    [anon_sym_if] = ACTIONS(3876),
    [anon_sym_DOT_DOT] = ACTIONS(3878),
    [anon_sym_from] = ACTIONS(3876),
    [anon_sym_into] = ACTIONS(3876),
    [anon_sym_join] = ACTIONS(3876),
    [anon_sym_on] = ACTIONS(3876),
    [anon_sym_equals] = ACTIONS(3876),
    [anon_sym_let] = ACTIONS(3876),
    [anon_sym_orderby] = ACTIONS(3876),
    [anon_sym_ascending] = ACTIONS(3876),
    [anon_sym_descending] = ACTIONS(3876),
    [anon_sym_group] = ACTIONS(3876),
    [anon_sym_by] = ACTIONS(3876),
    [anon_sym_select] = ACTIONS(3876),
    [anon_sym_DQUOTE] = ACTIONS(3876),
    [anon_sym_stackalloc] = ACTIONS(3876),
    [anon_sym_sizeof] = ACTIONS(3876),
    [anon_sym_typeof] = ACTIONS(3876),
    [anon_sym___makeref] = ACTIONS(3876),
    [anon_sym___reftype] = ACTIONS(3876),
    [anon_sym___refvalue] = ACTIONS(3876),
    [sym_null_literal] = ACTIONS(3876),
    [anon_sym_SQUOTE] = ACTIONS(3878),
    [sym_integer_literal] = ACTIONS(3876),
    [sym_real_literal] = ACTIONS(3878),
    [sym_verbatim_string_literal] = ACTIONS(3878),
    [sym_raw_string_literal] = ACTIONS(3878),
    [aux_sym_preproc_if_token1] = ACTIONS(3878),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3878),
    [sym_interpolation_verbatim_start] = ACTIONS(3878),
    [sym_interpolation_raw_start] = ACTIONS(3878),
  },
  [2554] = {
    [sym_preproc_region] = STATE(2554),
    [sym_preproc_endregion] = STATE(2554),
    [sym_preproc_line] = STATE(2554),
    [sym_preproc_pragma] = STATE(2554),
    [sym_preproc_nullable] = STATE(2554),
    [sym_preproc_error] = STATE(2554),
    [sym_preproc_define] = STATE(2554),
    [sym_preproc_undef] = STATE(2554),
    [ts_builtin_sym_end] = ACTIONS(3687),
    [sym__identifier_token] = ACTIONS(3685),
    [anon_sym_extern] = ACTIONS(3685),
    [anon_sym_alias] = ACTIONS(3685),
    [anon_sym_SEMI] = ACTIONS(3687),
    [anon_sym_global] = ACTIONS(3685),
    [anon_sym_using] = ACTIONS(3685),
    [anon_sym_unsafe] = ACTIONS(3685),
    [anon_sym_static] = ACTIONS(3685),
    [anon_sym_LBRACK] = ACTIONS(3687),
    [anon_sym_LPAREN] = ACTIONS(3687),
    [anon_sym_return] = ACTIONS(3685),
    [anon_sym_namespace] = ACTIONS(3685),
    [anon_sym_class] = ACTIONS(3685),
    [anon_sym_ref] = ACTIONS(3685),
    [anon_sym_struct] = ACTIONS(3685),
    [anon_sym_enum] = ACTIONS(3685),
    [anon_sym_LBRACE] = ACTIONS(3687),
    [anon_sym_interface] = ACTIONS(3685),
    [anon_sym_delegate] = ACTIONS(3685),
    [anon_sym_record] = ACTIONS(3685),
    [anon_sym_abstract] = ACTIONS(3685),
    [anon_sym_async] = ACTIONS(3685),
    [anon_sym_const] = ACTIONS(3685),
    [anon_sym_file] = ACTIONS(3685),
    [anon_sym_fixed] = ACTIONS(3685),
    [anon_sym_internal] = ACTIONS(3685),
    [anon_sym_new] = ACTIONS(3685),
    [anon_sym_override] = ACTIONS(3685),
    [anon_sym_partial] = ACTIONS(3685),
    [anon_sym_private] = ACTIONS(3685),
    [anon_sym_protected] = ACTIONS(3685),
    [anon_sym_public] = ACTIONS(3685),
    [anon_sym_readonly] = ACTIONS(3685),
    [anon_sym_required] = ACTIONS(3685),
    [anon_sym_sealed] = ACTIONS(3685),
    [anon_sym_virtual] = ACTIONS(3685),
    [anon_sym_volatile] = ACTIONS(3685),
    [anon_sym_where] = ACTIONS(3685),
    [anon_sym_notnull] = ACTIONS(3685),
    [anon_sym_unmanaged] = ACTIONS(3685),
    [anon_sym_checked] = ACTIONS(3685),
    [anon_sym_BANG] = ACTIONS(3687),
    [anon_sym_TILDE] = ACTIONS(3687),
    [anon_sym_PLUS_PLUS] = ACTIONS(3687),
    [anon_sym_DASH_DASH] = ACTIONS(3687),
    [anon_sym_true] = ACTIONS(3685),
    [anon_sym_false] = ACTIONS(3685),
    [anon_sym_PLUS] = ACTIONS(3685),
    [anon_sym_DASH] = ACTIONS(3685),
    [anon_sym_STAR] = ACTIONS(3687),
    [anon_sym_CARET] = ACTIONS(3687),
    [anon_sym_AMP] = ACTIONS(3687),
    [anon_sym_this] = ACTIONS(3685),
    [anon_sym_scoped] = ACTIONS(3685),
    [anon_sym_var] = ACTIONS(3685),
    [sym_predefined_type] = ACTIONS(3685),
    [anon_sym_break] = ACTIONS(3685),
    [anon_sym_unchecked] = ACTIONS(3685),
    [anon_sym_continue] = ACTIONS(3685),
    [anon_sym_do] = ACTIONS(3685),
    [anon_sym_while] = ACTIONS(3685),
    [anon_sym_for] = ACTIONS(3685),
    [anon_sym_lock] = ACTIONS(3685),
    [anon_sym_yield] = ACTIONS(3685),
    [anon_sym_switch] = ACTIONS(3685),
    [anon_sym_default] = ACTIONS(3685),
    [anon_sym_throw] = ACTIONS(3685),
    [anon_sym_try] = ACTIONS(3685),
    [anon_sym_when] = ACTIONS(3685),
    [anon_sym_await] = ACTIONS(3685),
    [anon_sym_foreach] = ACTIONS(3685),
    [anon_sym_goto] = ACTIONS(3685),
    [anon_sym_if] = ACTIONS(3685),
    [anon_sym_DOT_DOT] = ACTIONS(3687),
    [anon_sym_from] = ACTIONS(3685),
    [anon_sym_into] = ACTIONS(3685),
    [anon_sym_join] = ACTIONS(3685),
    [anon_sym_on] = ACTIONS(3685),
    [anon_sym_equals] = ACTIONS(3685),
    [anon_sym_let] = ACTIONS(3685),
    [anon_sym_orderby] = ACTIONS(3685),
    [anon_sym_ascending] = ACTIONS(3685),
    [anon_sym_descending] = ACTIONS(3685),
    [anon_sym_group] = ACTIONS(3685),
    [anon_sym_by] = ACTIONS(3685),
    [anon_sym_select] = ACTIONS(3685),
    [anon_sym_DQUOTE] = ACTIONS(3685),
    [anon_sym_stackalloc] = ACTIONS(3685),
    [anon_sym_sizeof] = ACTIONS(3685),
    [anon_sym_typeof] = ACTIONS(3685),
    [anon_sym___makeref] = ACTIONS(3685),
    [anon_sym___reftype] = ACTIONS(3685),
    [anon_sym___refvalue] = ACTIONS(3685),
    [sym_null_literal] = ACTIONS(3685),
    [anon_sym_SQUOTE] = ACTIONS(3687),
    [sym_integer_literal] = ACTIONS(3685),
    [sym_real_literal] = ACTIONS(3687),
    [sym_verbatim_string_literal] = ACTIONS(3687),
    [sym_raw_string_literal] = ACTIONS(3687),
    [aux_sym_preproc_if_token1] = ACTIONS(3687),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3687),
    [sym_interpolation_verbatim_start] = ACTIONS(3687),
    [sym_interpolation_raw_start] = ACTIONS(3687),
  },
  [2555] = {
    [sym_preproc_region] = STATE(2555),
    [sym_preproc_endregion] = STATE(2555),
    [sym_preproc_line] = STATE(2555),
    [sym_preproc_pragma] = STATE(2555),
    [sym_preproc_nullable] = STATE(2555),
    [sym_preproc_error] = STATE(2555),
    [sym_preproc_define] = STATE(2555),
    [sym_preproc_undef] = STATE(2555),
    [ts_builtin_sym_end] = ACTIONS(3874),
    [sym__identifier_token] = ACTIONS(3872),
    [anon_sym_extern] = ACTIONS(3872),
    [anon_sym_alias] = ACTIONS(3872),
    [anon_sym_SEMI] = ACTIONS(3874),
    [anon_sym_global] = ACTIONS(3872),
    [anon_sym_using] = ACTIONS(3872),
    [anon_sym_unsafe] = ACTIONS(3872),
    [anon_sym_static] = ACTIONS(3872),
    [anon_sym_LBRACK] = ACTIONS(3874),
    [anon_sym_LPAREN] = ACTIONS(3874),
    [anon_sym_return] = ACTIONS(3872),
    [anon_sym_namespace] = ACTIONS(3872),
    [anon_sym_class] = ACTIONS(3872),
    [anon_sym_ref] = ACTIONS(3872),
    [anon_sym_struct] = ACTIONS(3872),
    [anon_sym_enum] = ACTIONS(3872),
    [anon_sym_LBRACE] = ACTIONS(3874),
    [anon_sym_interface] = ACTIONS(3872),
    [anon_sym_delegate] = ACTIONS(3872),
    [anon_sym_record] = ACTIONS(3872),
    [anon_sym_abstract] = ACTIONS(3872),
    [anon_sym_async] = ACTIONS(3872),
    [anon_sym_const] = ACTIONS(3872),
    [anon_sym_file] = ACTIONS(3872),
    [anon_sym_fixed] = ACTIONS(3872),
    [anon_sym_internal] = ACTIONS(3872),
    [anon_sym_new] = ACTIONS(3872),
    [anon_sym_override] = ACTIONS(3872),
    [anon_sym_partial] = ACTIONS(3872),
    [anon_sym_private] = ACTIONS(3872),
    [anon_sym_protected] = ACTIONS(3872),
    [anon_sym_public] = ACTIONS(3872),
    [anon_sym_readonly] = ACTIONS(3872),
    [anon_sym_required] = ACTIONS(3872),
    [anon_sym_sealed] = ACTIONS(3872),
    [anon_sym_virtual] = ACTIONS(3872),
    [anon_sym_volatile] = ACTIONS(3872),
    [anon_sym_where] = ACTIONS(3872),
    [anon_sym_notnull] = ACTIONS(3872),
    [anon_sym_unmanaged] = ACTIONS(3872),
    [anon_sym_checked] = ACTIONS(3872),
    [anon_sym_BANG] = ACTIONS(3874),
    [anon_sym_TILDE] = ACTIONS(3874),
    [anon_sym_PLUS_PLUS] = ACTIONS(3874),
    [anon_sym_DASH_DASH] = ACTIONS(3874),
    [anon_sym_true] = ACTIONS(3872),
    [anon_sym_false] = ACTIONS(3872),
    [anon_sym_PLUS] = ACTIONS(3872),
    [anon_sym_DASH] = ACTIONS(3872),
    [anon_sym_STAR] = ACTIONS(3874),
    [anon_sym_CARET] = ACTIONS(3874),
    [anon_sym_AMP] = ACTIONS(3874),
    [anon_sym_this] = ACTIONS(3872),
    [anon_sym_scoped] = ACTIONS(3872),
    [anon_sym_var] = ACTIONS(3872),
    [sym_predefined_type] = ACTIONS(3872),
    [anon_sym_break] = ACTIONS(3872),
    [anon_sym_unchecked] = ACTIONS(3872),
    [anon_sym_continue] = ACTIONS(3872),
    [anon_sym_do] = ACTIONS(3872),
    [anon_sym_while] = ACTIONS(3872),
    [anon_sym_for] = ACTIONS(3872),
    [anon_sym_lock] = ACTIONS(3872),
    [anon_sym_yield] = ACTIONS(3872),
    [anon_sym_switch] = ACTIONS(3872),
    [anon_sym_default] = ACTIONS(3872),
    [anon_sym_throw] = ACTIONS(3872),
    [anon_sym_try] = ACTIONS(3872),
    [anon_sym_when] = ACTIONS(3872),
    [anon_sym_await] = ACTIONS(3872),
    [anon_sym_foreach] = ACTIONS(3872),
    [anon_sym_goto] = ACTIONS(3872),
    [anon_sym_if] = ACTIONS(3872),
    [anon_sym_DOT_DOT] = ACTIONS(3874),
    [anon_sym_from] = ACTIONS(3872),
    [anon_sym_into] = ACTIONS(3872),
    [anon_sym_join] = ACTIONS(3872),
    [anon_sym_on] = ACTIONS(3872),
    [anon_sym_equals] = ACTIONS(3872),
    [anon_sym_let] = ACTIONS(3872),
    [anon_sym_orderby] = ACTIONS(3872),
    [anon_sym_ascending] = ACTIONS(3872),
    [anon_sym_descending] = ACTIONS(3872),
    [anon_sym_group] = ACTIONS(3872),
    [anon_sym_by] = ACTIONS(3872),
    [anon_sym_select] = ACTIONS(3872),
    [anon_sym_DQUOTE] = ACTIONS(3872),
    [anon_sym_stackalloc] = ACTIONS(3872),
    [anon_sym_sizeof] = ACTIONS(3872),
    [anon_sym_typeof] = ACTIONS(3872),
    [anon_sym___makeref] = ACTIONS(3872),
    [anon_sym___reftype] = ACTIONS(3872),
    [anon_sym___refvalue] = ACTIONS(3872),
    [sym_null_literal] = ACTIONS(3872),
    [anon_sym_SQUOTE] = ACTIONS(3874),
    [sym_integer_literal] = ACTIONS(3872),
    [sym_real_literal] = ACTIONS(3874),
    [sym_verbatim_string_literal] = ACTIONS(3874),
    [sym_raw_string_literal] = ACTIONS(3874),
    [aux_sym_preproc_if_token1] = ACTIONS(3874),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3874),
    [sym_interpolation_verbatim_start] = ACTIONS(3874),
    [sym_interpolation_raw_start] = ACTIONS(3874),
  },
  [2556] = {
    [sym_preproc_region] = STATE(2556),
    [sym_preproc_endregion] = STATE(2556),
    [sym_preproc_line] = STATE(2556),
    [sym_preproc_pragma] = STATE(2556),
    [sym_preproc_nullable] = STATE(2556),
    [sym_preproc_error] = STATE(2556),
    [sym_preproc_define] = STATE(2556),
    [sym_preproc_undef] = STATE(2556),
    [ts_builtin_sym_end] = ACTIONS(3507),
    [sym__identifier_token] = ACTIONS(3505),
    [anon_sym_extern] = ACTIONS(3505),
    [anon_sym_alias] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(3507),
    [anon_sym_global] = ACTIONS(3505),
    [anon_sym_using] = ACTIONS(3505),
    [anon_sym_unsafe] = ACTIONS(3505),
    [anon_sym_static] = ACTIONS(3505),
    [anon_sym_LBRACK] = ACTIONS(3507),
    [anon_sym_LPAREN] = ACTIONS(3507),
    [anon_sym_return] = ACTIONS(3505),
    [anon_sym_namespace] = ACTIONS(3505),
    [anon_sym_class] = ACTIONS(3505),
    [anon_sym_ref] = ACTIONS(3505),
    [anon_sym_struct] = ACTIONS(3505),
    [anon_sym_enum] = ACTIONS(3505),
    [anon_sym_LBRACE] = ACTIONS(3507),
    [anon_sym_interface] = ACTIONS(3505),
    [anon_sym_delegate] = ACTIONS(3505),
    [anon_sym_record] = ACTIONS(3505),
    [anon_sym_abstract] = ACTIONS(3505),
    [anon_sym_async] = ACTIONS(3505),
    [anon_sym_const] = ACTIONS(3505),
    [anon_sym_file] = ACTIONS(3505),
    [anon_sym_fixed] = ACTIONS(3505),
    [anon_sym_internal] = ACTIONS(3505),
    [anon_sym_new] = ACTIONS(3505),
    [anon_sym_override] = ACTIONS(3505),
    [anon_sym_partial] = ACTIONS(3505),
    [anon_sym_private] = ACTIONS(3505),
    [anon_sym_protected] = ACTIONS(3505),
    [anon_sym_public] = ACTIONS(3505),
    [anon_sym_readonly] = ACTIONS(3505),
    [anon_sym_required] = ACTIONS(3505),
    [anon_sym_sealed] = ACTIONS(3505),
    [anon_sym_virtual] = ACTIONS(3505),
    [anon_sym_volatile] = ACTIONS(3505),
    [anon_sym_where] = ACTIONS(3505),
    [anon_sym_notnull] = ACTIONS(3505),
    [anon_sym_unmanaged] = ACTIONS(3505),
    [anon_sym_checked] = ACTIONS(3505),
    [anon_sym_BANG] = ACTIONS(3507),
    [anon_sym_TILDE] = ACTIONS(3507),
    [anon_sym_PLUS_PLUS] = ACTIONS(3507),
    [anon_sym_DASH_DASH] = ACTIONS(3507),
    [anon_sym_true] = ACTIONS(3505),
    [anon_sym_false] = ACTIONS(3505),
    [anon_sym_PLUS] = ACTIONS(3505),
    [anon_sym_DASH] = ACTIONS(3505),
    [anon_sym_STAR] = ACTIONS(3507),
    [anon_sym_CARET] = ACTIONS(3507),
    [anon_sym_AMP] = ACTIONS(3507),
    [anon_sym_this] = ACTIONS(3505),
    [anon_sym_scoped] = ACTIONS(3505),
    [anon_sym_var] = ACTIONS(3505),
    [sym_predefined_type] = ACTIONS(3505),
    [anon_sym_break] = ACTIONS(3505),
    [anon_sym_unchecked] = ACTIONS(3505),
    [anon_sym_continue] = ACTIONS(3505),
    [anon_sym_do] = ACTIONS(3505),
    [anon_sym_while] = ACTIONS(3505),
    [anon_sym_for] = ACTIONS(3505),
    [anon_sym_lock] = ACTIONS(3505),
    [anon_sym_yield] = ACTIONS(3505),
    [anon_sym_switch] = ACTIONS(3505),
    [anon_sym_default] = ACTIONS(3505),
    [anon_sym_throw] = ACTIONS(3505),
    [anon_sym_try] = ACTIONS(3505),
    [anon_sym_when] = ACTIONS(3505),
    [anon_sym_await] = ACTIONS(3505),
    [anon_sym_foreach] = ACTIONS(3505),
    [anon_sym_goto] = ACTIONS(3505),
    [anon_sym_if] = ACTIONS(3505),
    [anon_sym_DOT_DOT] = ACTIONS(3507),
    [anon_sym_from] = ACTIONS(3505),
    [anon_sym_into] = ACTIONS(3505),
    [anon_sym_join] = ACTIONS(3505),
    [anon_sym_on] = ACTIONS(3505),
    [anon_sym_equals] = ACTIONS(3505),
    [anon_sym_let] = ACTIONS(3505),
    [anon_sym_orderby] = ACTIONS(3505),
    [anon_sym_ascending] = ACTIONS(3505),
    [anon_sym_descending] = ACTIONS(3505),
    [anon_sym_group] = ACTIONS(3505),
    [anon_sym_by] = ACTIONS(3505),
    [anon_sym_select] = ACTIONS(3505),
    [anon_sym_DQUOTE] = ACTIONS(3505),
    [anon_sym_stackalloc] = ACTIONS(3505),
    [anon_sym_sizeof] = ACTIONS(3505),
    [anon_sym_typeof] = ACTIONS(3505),
    [anon_sym___makeref] = ACTIONS(3505),
    [anon_sym___reftype] = ACTIONS(3505),
    [anon_sym___refvalue] = ACTIONS(3505),
    [sym_null_literal] = ACTIONS(3505),
    [anon_sym_SQUOTE] = ACTIONS(3507),
    [sym_integer_literal] = ACTIONS(3505),
    [sym_real_literal] = ACTIONS(3507),
    [sym_verbatim_string_literal] = ACTIONS(3507),
    [sym_raw_string_literal] = ACTIONS(3507),
    [aux_sym_preproc_if_token1] = ACTIONS(3507),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3507),
    [sym_interpolation_verbatim_start] = ACTIONS(3507),
    [sym_interpolation_raw_start] = ACTIONS(3507),
  },
  [2557] = {
    [sym_using_directive] = STATE(3272),
    [sym_attribute_list] = STATE(3753),
    [sym_namespace_declaration] = STATE(3272),
    [sym_class_declaration] = STATE(3272),
    [sym_struct_declaration] = STATE(3272),
    [sym_enum_declaration] = STATE(3272),
    [sym_interface_declaration] = STATE(3272),
    [sym_delegate_declaration] = STATE(3272),
    [sym_record_declaration] = STATE(3272),
    [sym_modifier] = STATE(3780),
    [sym_operator_declaration] = STATE(3272),
    [sym_conversion_operator_declaration] = STATE(3272),
    [sym_declaration] = STATE(3284),
    [sym_field_declaration] = STATE(3272),
    [sym_constructor_declaration] = STATE(3272),
    [sym_destructor_declaration] = STATE(3272),
    [sym_method_declaration] = STATE(3272),
    [sym_event_declaration] = STATE(3272),
    [sym_event_field_declaration] = STATE(3272),
    [sym_indexer_declaration] = STATE(3272),
    [sym_property_declaration] = STATE(3272),
    [sym_variable_declaration] = STATE(9222),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(6306),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_identifier] = STATE(6719),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_if] = STATE(3272),
    [sym_preproc_region] = STATE(2557),
    [sym_preproc_endregion] = STATE(2557),
    [sym_preproc_line] = STATE(2557),
    [sym_preproc_pragma] = STATE(2557),
    [sym_preproc_nullable] = STATE(2557),
    [sym_preproc_error] = STATE(2557),
    [sym_preproc_define] = STATE(2557),
    [sym_preproc_undef] = STATE(2557),
    [aux_sym_class_declaration_repeat1] = STATE(2782),
    [aux_sym_class_declaration_repeat2] = STATE(2834),
    [aux_sym_declaration_list_repeat1] = STATE(2626),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_extern] = ACTIONS(2985),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2989),
    [anon_sym_using] = ACTIONS(2991),
    [anon_sym_unsafe] = ACTIONS(63),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_LBRACK] = ACTIONS(2993),
    [anon_sym_LPAREN] = ACTIONS(2995),
    [anon_sym_event] = ACTIONS(2997),
    [anon_sym_namespace] = ACTIONS(2999),
    [anon_sym_class] = ACTIONS(3001),
    [anon_sym_ref] = ACTIONS(3003),
    [anon_sym_struct] = ACTIONS(3005),
    [anon_sym_enum] = ACTIONS(3007),
    [anon_sym_interface] = ACTIONS(3009),
    [anon_sym_delegate] = ACTIONS(3011),
    [anon_sym_record] = ACTIONS(3013),
    [anon_sym_abstract] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_file] = ACTIONS(3015),
    [anon_sym_fixed] = ACTIONS(63),
    [anon_sym_internal] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(63),
    [anon_sym_override] = ACTIONS(63),
    [anon_sym_partial] = ACTIONS(63),
    [anon_sym_private] = ACTIONS(63),
    [anon_sym_protected] = ACTIONS(63),
    [anon_sym_public] = ACTIONS(63),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_required] = ACTIONS(63),
    [anon_sym_sealed] = ACTIONS(63),
    [anon_sym_virtual] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_TILDE] = ACTIONS(3017),
    [anon_sym_implicit] = ACTIONS(3019),
    [anon_sym_explicit] = ACTIONS(3019),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_if_token1] = ACTIONS(3027),
    [aux_sym_preproc_if_token3] = ACTIONS(3960),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2558] = {
    [sym_preproc_region] = STATE(2558),
    [sym_preproc_endregion] = STATE(2558),
    [sym_preproc_line] = STATE(2558),
    [sym_preproc_pragma] = STATE(2558),
    [sym_preproc_nullable] = STATE(2558),
    [sym_preproc_error] = STATE(2558),
    [sym_preproc_define] = STATE(2558),
    [sym_preproc_undef] = STATE(2558),
    [ts_builtin_sym_end] = ACTIONS(3750),
    [sym__identifier_token] = ACTIONS(3748),
    [anon_sym_extern] = ACTIONS(3748),
    [anon_sym_alias] = ACTIONS(3748),
    [anon_sym_SEMI] = ACTIONS(3750),
    [anon_sym_global] = ACTIONS(3748),
    [anon_sym_using] = ACTIONS(3748),
    [anon_sym_unsafe] = ACTIONS(3748),
    [anon_sym_static] = ACTIONS(3748),
    [anon_sym_LBRACK] = ACTIONS(3750),
    [anon_sym_LPAREN] = ACTIONS(3750),
    [anon_sym_return] = ACTIONS(3748),
    [anon_sym_namespace] = ACTIONS(3748),
    [anon_sym_class] = ACTIONS(3748),
    [anon_sym_ref] = ACTIONS(3748),
    [anon_sym_struct] = ACTIONS(3748),
    [anon_sym_enum] = ACTIONS(3748),
    [anon_sym_LBRACE] = ACTIONS(3750),
    [anon_sym_interface] = ACTIONS(3748),
    [anon_sym_delegate] = ACTIONS(3748),
    [anon_sym_record] = ACTIONS(3748),
    [anon_sym_abstract] = ACTIONS(3748),
    [anon_sym_async] = ACTIONS(3748),
    [anon_sym_const] = ACTIONS(3748),
    [anon_sym_file] = ACTIONS(3748),
    [anon_sym_fixed] = ACTIONS(3748),
    [anon_sym_internal] = ACTIONS(3748),
    [anon_sym_new] = ACTIONS(3748),
    [anon_sym_override] = ACTIONS(3748),
    [anon_sym_partial] = ACTIONS(3748),
    [anon_sym_private] = ACTIONS(3748),
    [anon_sym_protected] = ACTIONS(3748),
    [anon_sym_public] = ACTIONS(3748),
    [anon_sym_readonly] = ACTIONS(3748),
    [anon_sym_required] = ACTIONS(3748),
    [anon_sym_sealed] = ACTIONS(3748),
    [anon_sym_virtual] = ACTIONS(3748),
    [anon_sym_volatile] = ACTIONS(3748),
    [anon_sym_where] = ACTIONS(3748),
    [anon_sym_notnull] = ACTIONS(3748),
    [anon_sym_unmanaged] = ACTIONS(3748),
    [anon_sym_checked] = ACTIONS(3748),
    [anon_sym_BANG] = ACTIONS(3750),
    [anon_sym_TILDE] = ACTIONS(3750),
    [anon_sym_PLUS_PLUS] = ACTIONS(3750),
    [anon_sym_DASH_DASH] = ACTIONS(3750),
    [anon_sym_true] = ACTIONS(3748),
    [anon_sym_false] = ACTIONS(3748),
    [anon_sym_PLUS] = ACTIONS(3748),
    [anon_sym_DASH] = ACTIONS(3748),
    [anon_sym_STAR] = ACTIONS(3750),
    [anon_sym_CARET] = ACTIONS(3750),
    [anon_sym_AMP] = ACTIONS(3750),
    [anon_sym_this] = ACTIONS(3748),
    [anon_sym_scoped] = ACTIONS(3748),
    [anon_sym_var] = ACTIONS(3748),
    [sym_predefined_type] = ACTIONS(3748),
    [anon_sym_break] = ACTIONS(3748),
    [anon_sym_unchecked] = ACTIONS(3748),
    [anon_sym_continue] = ACTIONS(3748),
    [anon_sym_do] = ACTIONS(3748),
    [anon_sym_while] = ACTIONS(3748),
    [anon_sym_for] = ACTIONS(3748),
    [anon_sym_lock] = ACTIONS(3748),
    [anon_sym_yield] = ACTIONS(3748),
    [anon_sym_switch] = ACTIONS(3748),
    [anon_sym_default] = ACTIONS(3748),
    [anon_sym_throw] = ACTIONS(3748),
    [anon_sym_try] = ACTIONS(3748),
    [anon_sym_when] = ACTIONS(3748),
    [anon_sym_await] = ACTIONS(3748),
    [anon_sym_foreach] = ACTIONS(3748),
    [anon_sym_goto] = ACTIONS(3748),
    [anon_sym_if] = ACTIONS(3748),
    [anon_sym_DOT_DOT] = ACTIONS(3750),
    [anon_sym_from] = ACTIONS(3748),
    [anon_sym_into] = ACTIONS(3748),
    [anon_sym_join] = ACTIONS(3748),
    [anon_sym_on] = ACTIONS(3748),
    [anon_sym_equals] = ACTIONS(3748),
    [anon_sym_let] = ACTIONS(3748),
    [anon_sym_orderby] = ACTIONS(3748),
    [anon_sym_ascending] = ACTIONS(3748),
    [anon_sym_descending] = ACTIONS(3748),
    [anon_sym_group] = ACTIONS(3748),
    [anon_sym_by] = ACTIONS(3748),
    [anon_sym_select] = ACTIONS(3748),
    [anon_sym_DQUOTE] = ACTIONS(3748),
    [anon_sym_stackalloc] = ACTIONS(3748),
    [anon_sym_sizeof] = ACTIONS(3748),
    [anon_sym_typeof] = ACTIONS(3748),
    [anon_sym___makeref] = ACTIONS(3748),
    [anon_sym___reftype] = ACTIONS(3748),
    [anon_sym___refvalue] = ACTIONS(3748),
    [sym_null_literal] = ACTIONS(3748),
    [anon_sym_SQUOTE] = ACTIONS(3750),
    [sym_integer_literal] = ACTIONS(3748),
    [sym_real_literal] = ACTIONS(3750),
    [sym_verbatim_string_literal] = ACTIONS(3750),
    [sym_raw_string_literal] = ACTIONS(3750),
    [aux_sym_preproc_if_token1] = ACTIONS(3750),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3750),
    [sym_interpolation_verbatim_start] = ACTIONS(3750),
    [sym_interpolation_raw_start] = ACTIONS(3750),
  },
  [2559] = {
    [sym_preproc_region] = STATE(2559),
    [sym_preproc_endregion] = STATE(2559),
    [sym_preproc_line] = STATE(2559),
    [sym_preproc_pragma] = STATE(2559),
    [sym_preproc_nullable] = STATE(2559),
    [sym_preproc_error] = STATE(2559),
    [sym_preproc_define] = STATE(2559),
    [sym_preproc_undef] = STATE(2559),
    [ts_builtin_sym_end] = ACTIONS(3870),
    [sym__identifier_token] = ACTIONS(3868),
    [anon_sym_extern] = ACTIONS(3868),
    [anon_sym_alias] = ACTIONS(3868),
    [anon_sym_SEMI] = ACTIONS(3870),
    [anon_sym_global] = ACTIONS(3868),
    [anon_sym_using] = ACTIONS(3868),
    [anon_sym_unsafe] = ACTIONS(3868),
    [anon_sym_static] = ACTIONS(3868),
    [anon_sym_LBRACK] = ACTIONS(3870),
    [anon_sym_LPAREN] = ACTIONS(3870),
    [anon_sym_return] = ACTIONS(3868),
    [anon_sym_namespace] = ACTIONS(3868),
    [anon_sym_class] = ACTIONS(3868),
    [anon_sym_ref] = ACTIONS(3868),
    [anon_sym_struct] = ACTIONS(3868),
    [anon_sym_enum] = ACTIONS(3868),
    [anon_sym_LBRACE] = ACTIONS(3870),
    [anon_sym_interface] = ACTIONS(3868),
    [anon_sym_delegate] = ACTIONS(3868),
    [anon_sym_record] = ACTIONS(3868),
    [anon_sym_abstract] = ACTIONS(3868),
    [anon_sym_async] = ACTIONS(3868),
    [anon_sym_const] = ACTIONS(3868),
    [anon_sym_file] = ACTIONS(3868),
    [anon_sym_fixed] = ACTIONS(3868),
    [anon_sym_internal] = ACTIONS(3868),
    [anon_sym_new] = ACTIONS(3868),
    [anon_sym_override] = ACTIONS(3868),
    [anon_sym_partial] = ACTIONS(3868),
    [anon_sym_private] = ACTIONS(3868),
    [anon_sym_protected] = ACTIONS(3868),
    [anon_sym_public] = ACTIONS(3868),
    [anon_sym_readonly] = ACTIONS(3868),
    [anon_sym_required] = ACTIONS(3868),
    [anon_sym_sealed] = ACTIONS(3868),
    [anon_sym_virtual] = ACTIONS(3868),
    [anon_sym_volatile] = ACTIONS(3868),
    [anon_sym_where] = ACTIONS(3868),
    [anon_sym_notnull] = ACTIONS(3868),
    [anon_sym_unmanaged] = ACTIONS(3868),
    [anon_sym_checked] = ACTIONS(3868),
    [anon_sym_BANG] = ACTIONS(3870),
    [anon_sym_TILDE] = ACTIONS(3870),
    [anon_sym_PLUS_PLUS] = ACTIONS(3870),
    [anon_sym_DASH_DASH] = ACTIONS(3870),
    [anon_sym_true] = ACTIONS(3868),
    [anon_sym_false] = ACTIONS(3868),
    [anon_sym_PLUS] = ACTIONS(3868),
    [anon_sym_DASH] = ACTIONS(3868),
    [anon_sym_STAR] = ACTIONS(3870),
    [anon_sym_CARET] = ACTIONS(3870),
    [anon_sym_AMP] = ACTIONS(3870),
    [anon_sym_this] = ACTIONS(3868),
    [anon_sym_scoped] = ACTIONS(3868),
    [anon_sym_var] = ACTIONS(3868),
    [sym_predefined_type] = ACTIONS(3868),
    [anon_sym_break] = ACTIONS(3868),
    [anon_sym_unchecked] = ACTIONS(3868),
    [anon_sym_continue] = ACTIONS(3868),
    [anon_sym_do] = ACTIONS(3868),
    [anon_sym_while] = ACTIONS(3868),
    [anon_sym_for] = ACTIONS(3868),
    [anon_sym_lock] = ACTIONS(3868),
    [anon_sym_yield] = ACTIONS(3868),
    [anon_sym_switch] = ACTIONS(3868),
    [anon_sym_default] = ACTIONS(3868),
    [anon_sym_throw] = ACTIONS(3868),
    [anon_sym_try] = ACTIONS(3868),
    [anon_sym_when] = ACTIONS(3868),
    [anon_sym_await] = ACTIONS(3868),
    [anon_sym_foreach] = ACTIONS(3868),
    [anon_sym_goto] = ACTIONS(3868),
    [anon_sym_if] = ACTIONS(3868),
    [anon_sym_DOT_DOT] = ACTIONS(3870),
    [anon_sym_from] = ACTIONS(3868),
    [anon_sym_into] = ACTIONS(3868),
    [anon_sym_join] = ACTIONS(3868),
    [anon_sym_on] = ACTIONS(3868),
    [anon_sym_equals] = ACTIONS(3868),
    [anon_sym_let] = ACTIONS(3868),
    [anon_sym_orderby] = ACTIONS(3868),
    [anon_sym_ascending] = ACTIONS(3868),
    [anon_sym_descending] = ACTIONS(3868),
    [anon_sym_group] = ACTIONS(3868),
    [anon_sym_by] = ACTIONS(3868),
    [anon_sym_select] = ACTIONS(3868),
    [anon_sym_DQUOTE] = ACTIONS(3868),
    [anon_sym_stackalloc] = ACTIONS(3868),
    [anon_sym_sizeof] = ACTIONS(3868),
    [anon_sym_typeof] = ACTIONS(3868),
    [anon_sym___makeref] = ACTIONS(3868),
    [anon_sym___reftype] = ACTIONS(3868),
    [anon_sym___refvalue] = ACTIONS(3868),
    [sym_null_literal] = ACTIONS(3868),
    [anon_sym_SQUOTE] = ACTIONS(3870),
    [sym_integer_literal] = ACTIONS(3868),
    [sym_real_literal] = ACTIONS(3870),
    [sym_verbatim_string_literal] = ACTIONS(3870),
    [sym_raw_string_literal] = ACTIONS(3870),
    [aux_sym_preproc_if_token1] = ACTIONS(3870),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3870),
    [sym_interpolation_verbatim_start] = ACTIONS(3870),
    [sym_interpolation_raw_start] = ACTIONS(3870),
  },
  [2560] = {
    [sym_preproc_region] = STATE(2560),
    [sym_preproc_endregion] = STATE(2560),
    [sym_preproc_line] = STATE(2560),
    [sym_preproc_pragma] = STATE(2560),
    [sym_preproc_nullable] = STATE(2560),
    [sym_preproc_error] = STATE(2560),
    [sym_preproc_define] = STATE(2560),
    [sym_preproc_undef] = STATE(2560),
    [ts_builtin_sym_end] = ACTIONS(3758),
    [sym__identifier_token] = ACTIONS(3756),
    [anon_sym_extern] = ACTIONS(3756),
    [anon_sym_alias] = ACTIONS(3756),
    [anon_sym_SEMI] = ACTIONS(3758),
    [anon_sym_global] = ACTIONS(3756),
    [anon_sym_using] = ACTIONS(3756),
    [anon_sym_unsafe] = ACTIONS(3756),
    [anon_sym_static] = ACTIONS(3756),
    [anon_sym_LBRACK] = ACTIONS(3758),
    [anon_sym_LPAREN] = ACTIONS(3758),
    [anon_sym_return] = ACTIONS(3756),
    [anon_sym_namespace] = ACTIONS(3756),
    [anon_sym_class] = ACTIONS(3756),
    [anon_sym_ref] = ACTIONS(3756),
    [anon_sym_struct] = ACTIONS(3756),
    [anon_sym_enum] = ACTIONS(3756),
    [anon_sym_LBRACE] = ACTIONS(3758),
    [anon_sym_interface] = ACTIONS(3756),
    [anon_sym_delegate] = ACTIONS(3756),
    [anon_sym_record] = ACTIONS(3756),
    [anon_sym_abstract] = ACTIONS(3756),
    [anon_sym_async] = ACTIONS(3756),
    [anon_sym_const] = ACTIONS(3756),
    [anon_sym_file] = ACTIONS(3756),
    [anon_sym_fixed] = ACTIONS(3756),
    [anon_sym_internal] = ACTIONS(3756),
    [anon_sym_new] = ACTIONS(3756),
    [anon_sym_override] = ACTIONS(3756),
    [anon_sym_partial] = ACTIONS(3756),
    [anon_sym_private] = ACTIONS(3756),
    [anon_sym_protected] = ACTIONS(3756),
    [anon_sym_public] = ACTIONS(3756),
    [anon_sym_readonly] = ACTIONS(3756),
    [anon_sym_required] = ACTIONS(3756),
    [anon_sym_sealed] = ACTIONS(3756),
    [anon_sym_virtual] = ACTIONS(3756),
    [anon_sym_volatile] = ACTIONS(3756),
    [anon_sym_where] = ACTIONS(3756),
    [anon_sym_notnull] = ACTIONS(3756),
    [anon_sym_unmanaged] = ACTIONS(3756),
    [anon_sym_checked] = ACTIONS(3756),
    [anon_sym_BANG] = ACTIONS(3758),
    [anon_sym_TILDE] = ACTIONS(3758),
    [anon_sym_PLUS_PLUS] = ACTIONS(3758),
    [anon_sym_DASH_DASH] = ACTIONS(3758),
    [anon_sym_true] = ACTIONS(3756),
    [anon_sym_false] = ACTIONS(3756),
    [anon_sym_PLUS] = ACTIONS(3756),
    [anon_sym_DASH] = ACTIONS(3756),
    [anon_sym_STAR] = ACTIONS(3758),
    [anon_sym_CARET] = ACTIONS(3758),
    [anon_sym_AMP] = ACTIONS(3758),
    [anon_sym_this] = ACTIONS(3756),
    [anon_sym_scoped] = ACTIONS(3756),
    [anon_sym_var] = ACTIONS(3756),
    [sym_predefined_type] = ACTIONS(3756),
    [anon_sym_break] = ACTIONS(3756),
    [anon_sym_unchecked] = ACTIONS(3756),
    [anon_sym_continue] = ACTIONS(3756),
    [anon_sym_do] = ACTIONS(3756),
    [anon_sym_while] = ACTIONS(3756),
    [anon_sym_for] = ACTIONS(3756),
    [anon_sym_lock] = ACTIONS(3756),
    [anon_sym_yield] = ACTIONS(3756),
    [anon_sym_switch] = ACTIONS(3756),
    [anon_sym_default] = ACTIONS(3756),
    [anon_sym_throw] = ACTIONS(3756),
    [anon_sym_try] = ACTIONS(3756),
    [anon_sym_when] = ACTIONS(3756),
    [anon_sym_await] = ACTIONS(3756),
    [anon_sym_foreach] = ACTIONS(3756),
    [anon_sym_goto] = ACTIONS(3756),
    [anon_sym_if] = ACTIONS(3756),
    [anon_sym_DOT_DOT] = ACTIONS(3758),
    [anon_sym_from] = ACTIONS(3756),
    [anon_sym_into] = ACTIONS(3756),
    [anon_sym_join] = ACTIONS(3756),
    [anon_sym_on] = ACTIONS(3756),
    [anon_sym_equals] = ACTIONS(3756),
    [anon_sym_let] = ACTIONS(3756),
    [anon_sym_orderby] = ACTIONS(3756),
    [anon_sym_ascending] = ACTIONS(3756),
    [anon_sym_descending] = ACTIONS(3756),
    [anon_sym_group] = ACTIONS(3756),
    [anon_sym_by] = ACTIONS(3756),
    [anon_sym_select] = ACTIONS(3756),
    [anon_sym_DQUOTE] = ACTIONS(3756),
    [anon_sym_stackalloc] = ACTIONS(3756),
    [anon_sym_sizeof] = ACTIONS(3756),
    [anon_sym_typeof] = ACTIONS(3756),
    [anon_sym___makeref] = ACTIONS(3756),
    [anon_sym___reftype] = ACTIONS(3756),
    [anon_sym___refvalue] = ACTIONS(3756),
    [sym_null_literal] = ACTIONS(3756),
    [anon_sym_SQUOTE] = ACTIONS(3758),
    [sym_integer_literal] = ACTIONS(3756),
    [sym_real_literal] = ACTIONS(3758),
    [sym_verbatim_string_literal] = ACTIONS(3758),
    [sym_raw_string_literal] = ACTIONS(3758),
    [aux_sym_preproc_if_token1] = ACTIONS(3758),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3758),
    [sym_interpolation_verbatim_start] = ACTIONS(3758),
    [sym_interpolation_raw_start] = ACTIONS(3758),
  },
  [2561] = {
    [sym_preproc_region] = STATE(2561),
    [sym_preproc_endregion] = STATE(2561),
    [sym_preproc_line] = STATE(2561),
    [sym_preproc_pragma] = STATE(2561),
    [sym_preproc_nullable] = STATE(2561),
    [sym_preproc_error] = STATE(2561),
    [sym_preproc_define] = STATE(2561),
    [sym_preproc_undef] = STATE(2561),
    [ts_builtin_sym_end] = ACTIONS(3703),
    [sym__identifier_token] = ACTIONS(3701),
    [anon_sym_extern] = ACTIONS(3701),
    [anon_sym_alias] = ACTIONS(3701),
    [anon_sym_SEMI] = ACTIONS(3703),
    [anon_sym_global] = ACTIONS(3701),
    [anon_sym_using] = ACTIONS(3701),
    [anon_sym_unsafe] = ACTIONS(3701),
    [anon_sym_static] = ACTIONS(3701),
    [anon_sym_LBRACK] = ACTIONS(3703),
    [anon_sym_LPAREN] = ACTIONS(3703),
    [anon_sym_return] = ACTIONS(3701),
    [anon_sym_namespace] = ACTIONS(3701),
    [anon_sym_class] = ACTIONS(3701),
    [anon_sym_ref] = ACTIONS(3701),
    [anon_sym_struct] = ACTIONS(3701),
    [anon_sym_enum] = ACTIONS(3701),
    [anon_sym_LBRACE] = ACTIONS(3703),
    [anon_sym_interface] = ACTIONS(3701),
    [anon_sym_delegate] = ACTIONS(3701),
    [anon_sym_record] = ACTIONS(3701),
    [anon_sym_abstract] = ACTIONS(3701),
    [anon_sym_async] = ACTIONS(3701),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_file] = ACTIONS(3701),
    [anon_sym_fixed] = ACTIONS(3701),
    [anon_sym_internal] = ACTIONS(3701),
    [anon_sym_new] = ACTIONS(3701),
    [anon_sym_override] = ACTIONS(3701),
    [anon_sym_partial] = ACTIONS(3701),
    [anon_sym_private] = ACTIONS(3701),
    [anon_sym_protected] = ACTIONS(3701),
    [anon_sym_public] = ACTIONS(3701),
    [anon_sym_readonly] = ACTIONS(3701),
    [anon_sym_required] = ACTIONS(3701),
    [anon_sym_sealed] = ACTIONS(3701),
    [anon_sym_virtual] = ACTIONS(3701),
    [anon_sym_volatile] = ACTIONS(3701),
    [anon_sym_where] = ACTIONS(3701),
    [anon_sym_notnull] = ACTIONS(3701),
    [anon_sym_unmanaged] = ACTIONS(3701),
    [anon_sym_checked] = ACTIONS(3701),
    [anon_sym_BANG] = ACTIONS(3703),
    [anon_sym_TILDE] = ACTIONS(3703),
    [anon_sym_PLUS_PLUS] = ACTIONS(3703),
    [anon_sym_DASH_DASH] = ACTIONS(3703),
    [anon_sym_true] = ACTIONS(3701),
    [anon_sym_false] = ACTIONS(3701),
    [anon_sym_PLUS] = ACTIONS(3701),
    [anon_sym_DASH] = ACTIONS(3701),
    [anon_sym_STAR] = ACTIONS(3703),
    [anon_sym_CARET] = ACTIONS(3703),
    [anon_sym_AMP] = ACTIONS(3703),
    [anon_sym_this] = ACTIONS(3701),
    [anon_sym_scoped] = ACTIONS(3701),
    [anon_sym_var] = ACTIONS(3701),
    [sym_predefined_type] = ACTIONS(3701),
    [anon_sym_break] = ACTIONS(3701),
    [anon_sym_unchecked] = ACTIONS(3701),
    [anon_sym_continue] = ACTIONS(3701),
    [anon_sym_do] = ACTIONS(3701),
    [anon_sym_while] = ACTIONS(3701),
    [anon_sym_for] = ACTIONS(3701),
    [anon_sym_lock] = ACTIONS(3701),
    [anon_sym_yield] = ACTIONS(3701),
    [anon_sym_switch] = ACTIONS(3701),
    [anon_sym_default] = ACTIONS(3701),
    [anon_sym_throw] = ACTIONS(3701),
    [anon_sym_try] = ACTIONS(3701),
    [anon_sym_when] = ACTIONS(3701),
    [anon_sym_await] = ACTIONS(3701),
    [anon_sym_foreach] = ACTIONS(3701),
    [anon_sym_goto] = ACTIONS(3701),
    [anon_sym_if] = ACTIONS(3701),
    [anon_sym_DOT_DOT] = ACTIONS(3703),
    [anon_sym_from] = ACTIONS(3701),
    [anon_sym_into] = ACTIONS(3701),
    [anon_sym_join] = ACTIONS(3701),
    [anon_sym_on] = ACTIONS(3701),
    [anon_sym_equals] = ACTIONS(3701),
    [anon_sym_let] = ACTIONS(3701),
    [anon_sym_orderby] = ACTIONS(3701),
    [anon_sym_ascending] = ACTIONS(3701),
    [anon_sym_descending] = ACTIONS(3701),
    [anon_sym_group] = ACTIONS(3701),
    [anon_sym_by] = ACTIONS(3701),
    [anon_sym_select] = ACTIONS(3701),
    [anon_sym_DQUOTE] = ACTIONS(3701),
    [anon_sym_stackalloc] = ACTIONS(3701),
    [anon_sym_sizeof] = ACTIONS(3701),
    [anon_sym_typeof] = ACTIONS(3701),
    [anon_sym___makeref] = ACTIONS(3701),
    [anon_sym___reftype] = ACTIONS(3701),
    [anon_sym___refvalue] = ACTIONS(3701),
    [sym_null_literal] = ACTIONS(3701),
    [anon_sym_SQUOTE] = ACTIONS(3703),
    [sym_integer_literal] = ACTIONS(3701),
    [sym_real_literal] = ACTIONS(3703),
    [sym_verbatim_string_literal] = ACTIONS(3703),
    [sym_raw_string_literal] = ACTIONS(3703),
    [aux_sym_preproc_if_token1] = ACTIONS(3703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3703),
    [sym_interpolation_verbatim_start] = ACTIONS(3703),
    [sym_interpolation_raw_start] = ACTIONS(3703),
  },
  [2562] = {
    [sym_preproc_region] = STATE(2562),
    [sym_preproc_endregion] = STATE(2562),
    [sym_preproc_line] = STATE(2562),
    [sym_preproc_pragma] = STATE(2562),
    [sym_preproc_nullable] = STATE(2562),
    [sym_preproc_error] = STATE(2562),
    [sym_preproc_define] = STATE(2562),
    [sym_preproc_undef] = STATE(2562),
    [ts_builtin_sym_end] = ACTIONS(3707),
    [sym__identifier_token] = ACTIONS(3705),
    [anon_sym_extern] = ACTIONS(3705),
    [anon_sym_alias] = ACTIONS(3705),
    [anon_sym_SEMI] = ACTIONS(3707),
    [anon_sym_global] = ACTIONS(3705),
    [anon_sym_using] = ACTIONS(3705),
    [anon_sym_unsafe] = ACTIONS(3705),
    [anon_sym_static] = ACTIONS(3705),
    [anon_sym_LBRACK] = ACTIONS(3707),
    [anon_sym_LPAREN] = ACTIONS(3707),
    [anon_sym_return] = ACTIONS(3705),
    [anon_sym_namespace] = ACTIONS(3705),
    [anon_sym_class] = ACTIONS(3705),
    [anon_sym_ref] = ACTIONS(3705),
    [anon_sym_struct] = ACTIONS(3705),
    [anon_sym_enum] = ACTIONS(3705),
    [anon_sym_LBRACE] = ACTIONS(3707),
    [anon_sym_interface] = ACTIONS(3705),
    [anon_sym_delegate] = ACTIONS(3705),
    [anon_sym_record] = ACTIONS(3705),
    [anon_sym_abstract] = ACTIONS(3705),
    [anon_sym_async] = ACTIONS(3705),
    [anon_sym_const] = ACTIONS(3705),
    [anon_sym_file] = ACTIONS(3705),
    [anon_sym_fixed] = ACTIONS(3705),
    [anon_sym_internal] = ACTIONS(3705),
    [anon_sym_new] = ACTIONS(3705),
    [anon_sym_override] = ACTIONS(3705),
    [anon_sym_partial] = ACTIONS(3705),
    [anon_sym_private] = ACTIONS(3705),
    [anon_sym_protected] = ACTIONS(3705),
    [anon_sym_public] = ACTIONS(3705),
    [anon_sym_readonly] = ACTIONS(3705),
    [anon_sym_required] = ACTIONS(3705),
    [anon_sym_sealed] = ACTIONS(3705),
    [anon_sym_virtual] = ACTIONS(3705),
    [anon_sym_volatile] = ACTIONS(3705),
    [anon_sym_where] = ACTIONS(3705),
    [anon_sym_notnull] = ACTIONS(3705),
    [anon_sym_unmanaged] = ACTIONS(3705),
    [anon_sym_checked] = ACTIONS(3705),
    [anon_sym_BANG] = ACTIONS(3707),
    [anon_sym_TILDE] = ACTIONS(3707),
    [anon_sym_PLUS_PLUS] = ACTIONS(3707),
    [anon_sym_DASH_DASH] = ACTIONS(3707),
    [anon_sym_true] = ACTIONS(3705),
    [anon_sym_false] = ACTIONS(3705),
    [anon_sym_PLUS] = ACTIONS(3705),
    [anon_sym_DASH] = ACTIONS(3705),
    [anon_sym_STAR] = ACTIONS(3707),
    [anon_sym_CARET] = ACTIONS(3707),
    [anon_sym_AMP] = ACTIONS(3707),
    [anon_sym_this] = ACTIONS(3705),
    [anon_sym_scoped] = ACTIONS(3705),
    [anon_sym_var] = ACTIONS(3705),
    [sym_predefined_type] = ACTIONS(3705),
    [anon_sym_break] = ACTIONS(3705),
    [anon_sym_unchecked] = ACTIONS(3705),
    [anon_sym_continue] = ACTIONS(3705),
    [anon_sym_do] = ACTIONS(3705),
    [anon_sym_while] = ACTIONS(3705),
    [anon_sym_for] = ACTIONS(3705),
    [anon_sym_lock] = ACTIONS(3705),
    [anon_sym_yield] = ACTIONS(3705),
    [anon_sym_switch] = ACTIONS(3705),
    [anon_sym_default] = ACTIONS(3705),
    [anon_sym_throw] = ACTIONS(3705),
    [anon_sym_try] = ACTIONS(3705),
    [anon_sym_when] = ACTIONS(3705),
    [anon_sym_await] = ACTIONS(3705),
    [anon_sym_foreach] = ACTIONS(3705),
    [anon_sym_goto] = ACTIONS(3705),
    [anon_sym_if] = ACTIONS(3705),
    [anon_sym_DOT_DOT] = ACTIONS(3707),
    [anon_sym_from] = ACTIONS(3705),
    [anon_sym_into] = ACTIONS(3705),
    [anon_sym_join] = ACTIONS(3705),
    [anon_sym_on] = ACTIONS(3705),
    [anon_sym_equals] = ACTIONS(3705),
    [anon_sym_let] = ACTIONS(3705),
    [anon_sym_orderby] = ACTIONS(3705),
    [anon_sym_ascending] = ACTIONS(3705),
    [anon_sym_descending] = ACTIONS(3705),
    [anon_sym_group] = ACTIONS(3705),
    [anon_sym_by] = ACTIONS(3705),
    [anon_sym_select] = ACTIONS(3705),
    [anon_sym_DQUOTE] = ACTIONS(3705),
    [anon_sym_stackalloc] = ACTIONS(3705),
    [anon_sym_sizeof] = ACTIONS(3705),
    [anon_sym_typeof] = ACTIONS(3705),
    [anon_sym___makeref] = ACTIONS(3705),
    [anon_sym___reftype] = ACTIONS(3705),
    [anon_sym___refvalue] = ACTIONS(3705),
    [sym_null_literal] = ACTIONS(3705),
    [anon_sym_SQUOTE] = ACTIONS(3707),
    [sym_integer_literal] = ACTIONS(3705),
    [sym_real_literal] = ACTIONS(3707),
    [sym_verbatim_string_literal] = ACTIONS(3707),
    [sym_raw_string_literal] = ACTIONS(3707),
    [aux_sym_preproc_if_token1] = ACTIONS(3707),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3707),
    [sym_interpolation_verbatim_start] = ACTIONS(3707),
    [sym_interpolation_raw_start] = ACTIONS(3707),
  },
  [2563] = {
    [sym_preproc_region] = STATE(2563),
    [sym_preproc_endregion] = STATE(2563),
    [sym_preproc_line] = STATE(2563),
    [sym_preproc_pragma] = STATE(2563),
    [sym_preproc_nullable] = STATE(2563),
    [sym_preproc_error] = STATE(2563),
    [sym_preproc_define] = STATE(2563),
    [sym_preproc_undef] = STATE(2563),
    [ts_builtin_sym_end] = ACTIONS(3738),
    [sym__identifier_token] = ACTIONS(3736),
    [anon_sym_extern] = ACTIONS(3736),
    [anon_sym_alias] = ACTIONS(3736),
    [anon_sym_SEMI] = ACTIONS(3738),
    [anon_sym_global] = ACTIONS(3736),
    [anon_sym_using] = ACTIONS(3736),
    [anon_sym_unsafe] = ACTIONS(3736),
    [anon_sym_static] = ACTIONS(3736),
    [anon_sym_LBRACK] = ACTIONS(3738),
    [anon_sym_LPAREN] = ACTIONS(3738),
    [anon_sym_return] = ACTIONS(3736),
    [anon_sym_namespace] = ACTIONS(3736),
    [anon_sym_class] = ACTIONS(3736),
    [anon_sym_ref] = ACTIONS(3736),
    [anon_sym_struct] = ACTIONS(3736),
    [anon_sym_enum] = ACTIONS(3736),
    [anon_sym_LBRACE] = ACTIONS(3738),
    [anon_sym_interface] = ACTIONS(3736),
    [anon_sym_delegate] = ACTIONS(3736),
    [anon_sym_record] = ACTIONS(3736),
    [anon_sym_abstract] = ACTIONS(3736),
    [anon_sym_async] = ACTIONS(3736),
    [anon_sym_const] = ACTIONS(3736),
    [anon_sym_file] = ACTIONS(3736),
    [anon_sym_fixed] = ACTIONS(3736),
    [anon_sym_internal] = ACTIONS(3736),
    [anon_sym_new] = ACTIONS(3736),
    [anon_sym_override] = ACTIONS(3736),
    [anon_sym_partial] = ACTIONS(3736),
    [anon_sym_private] = ACTIONS(3736),
    [anon_sym_protected] = ACTIONS(3736),
    [anon_sym_public] = ACTIONS(3736),
    [anon_sym_readonly] = ACTIONS(3736),
    [anon_sym_required] = ACTIONS(3736),
    [anon_sym_sealed] = ACTIONS(3736),
    [anon_sym_virtual] = ACTIONS(3736),
    [anon_sym_volatile] = ACTIONS(3736),
    [anon_sym_where] = ACTIONS(3736),
    [anon_sym_notnull] = ACTIONS(3736),
    [anon_sym_unmanaged] = ACTIONS(3736),
    [anon_sym_checked] = ACTIONS(3736),
    [anon_sym_BANG] = ACTIONS(3738),
    [anon_sym_TILDE] = ACTIONS(3738),
    [anon_sym_PLUS_PLUS] = ACTIONS(3738),
    [anon_sym_DASH_DASH] = ACTIONS(3738),
    [anon_sym_true] = ACTIONS(3736),
    [anon_sym_false] = ACTIONS(3736),
    [anon_sym_PLUS] = ACTIONS(3736),
    [anon_sym_DASH] = ACTIONS(3736),
    [anon_sym_STAR] = ACTIONS(3738),
    [anon_sym_CARET] = ACTIONS(3738),
    [anon_sym_AMP] = ACTIONS(3738),
    [anon_sym_this] = ACTIONS(3736),
    [anon_sym_scoped] = ACTIONS(3736),
    [anon_sym_var] = ACTIONS(3736),
    [sym_predefined_type] = ACTIONS(3736),
    [anon_sym_break] = ACTIONS(3736),
    [anon_sym_unchecked] = ACTIONS(3736),
    [anon_sym_continue] = ACTIONS(3736),
    [anon_sym_do] = ACTIONS(3736),
    [anon_sym_while] = ACTIONS(3736),
    [anon_sym_for] = ACTIONS(3736),
    [anon_sym_lock] = ACTIONS(3736),
    [anon_sym_yield] = ACTIONS(3736),
    [anon_sym_switch] = ACTIONS(3736),
    [anon_sym_default] = ACTIONS(3736),
    [anon_sym_throw] = ACTIONS(3736),
    [anon_sym_try] = ACTIONS(3736),
    [anon_sym_when] = ACTIONS(3736),
    [anon_sym_await] = ACTIONS(3736),
    [anon_sym_foreach] = ACTIONS(3736),
    [anon_sym_goto] = ACTIONS(3736),
    [anon_sym_if] = ACTIONS(3736),
    [anon_sym_DOT_DOT] = ACTIONS(3738),
    [anon_sym_from] = ACTIONS(3736),
    [anon_sym_into] = ACTIONS(3736),
    [anon_sym_join] = ACTIONS(3736),
    [anon_sym_on] = ACTIONS(3736),
    [anon_sym_equals] = ACTIONS(3736),
    [anon_sym_let] = ACTIONS(3736),
    [anon_sym_orderby] = ACTIONS(3736),
    [anon_sym_ascending] = ACTIONS(3736),
    [anon_sym_descending] = ACTIONS(3736),
    [anon_sym_group] = ACTIONS(3736),
    [anon_sym_by] = ACTIONS(3736),
    [anon_sym_select] = ACTIONS(3736),
    [anon_sym_DQUOTE] = ACTIONS(3736),
    [anon_sym_stackalloc] = ACTIONS(3736),
    [anon_sym_sizeof] = ACTIONS(3736),
    [anon_sym_typeof] = ACTIONS(3736),
    [anon_sym___makeref] = ACTIONS(3736),
    [anon_sym___reftype] = ACTIONS(3736),
    [anon_sym___refvalue] = ACTIONS(3736),
    [sym_null_literal] = ACTIONS(3736),
    [anon_sym_SQUOTE] = ACTIONS(3738),
    [sym_integer_literal] = ACTIONS(3736),
    [sym_real_literal] = ACTIONS(3738),
    [sym_verbatim_string_literal] = ACTIONS(3738),
    [sym_raw_string_literal] = ACTIONS(3738),
    [aux_sym_preproc_if_token1] = ACTIONS(3738),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3738),
    [sym_interpolation_verbatim_start] = ACTIONS(3738),
    [sym_interpolation_raw_start] = ACTIONS(3738),
  },
  [2564] = {
    [sym_preproc_region] = STATE(2564),
    [sym_preproc_endregion] = STATE(2564),
    [sym_preproc_line] = STATE(2564),
    [sym_preproc_pragma] = STATE(2564),
    [sym_preproc_nullable] = STATE(2564),
    [sym_preproc_error] = STATE(2564),
    [sym_preproc_define] = STATE(2564),
    [sym_preproc_undef] = STATE(2564),
    [ts_builtin_sym_end] = ACTIONS(3599),
    [sym__identifier_token] = ACTIONS(3597),
    [anon_sym_extern] = ACTIONS(3597),
    [anon_sym_alias] = ACTIONS(3597),
    [anon_sym_SEMI] = ACTIONS(3599),
    [anon_sym_global] = ACTIONS(3597),
    [anon_sym_using] = ACTIONS(3597),
    [anon_sym_unsafe] = ACTIONS(3597),
    [anon_sym_static] = ACTIONS(3597),
    [anon_sym_LBRACK] = ACTIONS(3599),
    [anon_sym_LPAREN] = ACTIONS(3599),
    [anon_sym_return] = ACTIONS(3597),
    [anon_sym_namespace] = ACTIONS(3597),
    [anon_sym_class] = ACTIONS(3597),
    [anon_sym_ref] = ACTIONS(3597),
    [anon_sym_struct] = ACTIONS(3597),
    [anon_sym_enum] = ACTIONS(3597),
    [anon_sym_LBRACE] = ACTIONS(3599),
    [anon_sym_interface] = ACTIONS(3597),
    [anon_sym_delegate] = ACTIONS(3597),
    [anon_sym_record] = ACTIONS(3597),
    [anon_sym_abstract] = ACTIONS(3597),
    [anon_sym_async] = ACTIONS(3597),
    [anon_sym_const] = ACTIONS(3597),
    [anon_sym_file] = ACTIONS(3597),
    [anon_sym_fixed] = ACTIONS(3597),
    [anon_sym_internal] = ACTIONS(3597),
    [anon_sym_new] = ACTIONS(3597),
    [anon_sym_override] = ACTIONS(3597),
    [anon_sym_partial] = ACTIONS(3597),
    [anon_sym_private] = ACTIONS(3597),
    [anon_sym_protected] = ACTIONS(3597),
    [anon_sym_public] = ACTIONS(3597),
    [anon_sym_readonly] = ACTIONS(3597),
    [anon_sym_required] = ACTIONS(3597),
    [anon_sym_sealed] = ACTIONS(3597),
    [anon_sym_virtual] = ACTIONS(3597),
    [anon_sym_volatile] = ACTIONS(3597),
    [anon_sym_where] = ACTIONS(3597),
    [anon_sym_notnull] = ACTIONS(3597),
    [anon_sym_unmanaged] = ACTIONS(3597),
    [anon_sym_checked] = ACTIONS(3597),
    [anon_sym_BANG] = ACTIONS(3599),
    [anon_sym_TILDE] = ACTIONS(3599),
    [anon_sym_PLUS_PLUS] = ACTIONS(3599),
    [anon_sym_DASH_DASH] = ACTIONS(3599),
    [anon_sym_true] = ACTIONS(3597),
    [anon_sym_false] = ACTIONS(3597),
    [anon_sym_PLUS] = ACTIONS(3597),
    [anon_sym_DASH] = ACTIONS(3597),
    [anon_sym_STAR] = ACTIONS(3599),
    [anon_sym_CARET] = ACTIONS(3599),
    [anon_sym_AMP] = ACTIONS(3599),
    [anon_sym_this] = ACTIONS(3597),
    [anon_sym_scoped] = ACTIONS(3597),
    [anon_sym_var] = ACTIONS(3597),
    [sym_predefined_type] = ACTIONS(3597),
    [anon_sym_break] = ACTIONS(3597),
    [anon_sym_unchecked] = ACTIONS(3597),
    [anon_sym_continue] = ACTIONS(3597),
    [anon_sym_do] = ACTIONS(3597),
    [anon_sym_while] = ACTIONS(3597),
    [anon_sym_for] = ACTIONS(3597),
    [anon_sym_lock] = ACTIONS(3597),
    [anon_sym_yield] = ACTIONS(3597),
    [anon_sym_switch] = ACTIONS(3597),
    [anon_sym_default] = ACTIONS(3597),
    [anon_sym_throw] = ACTIONS(3597),
    [anon_sym_try] = ACTIONS(3597),
    [anon_sym_when] = ACTIONS(3597),
    [anon_sym_await] = ACTIONS(3597),
    [anon_sym_foreach] = ACTIONS(3597),
    [anon_sym_goto] = ACTIONS(3597),
    [anon_sym_if] = ACTIONS(3597),
    [anon_sym_DOT_DOT] = ACTIONS(3599),
    [anon_sym_from] = ACTIONS(3597),
    [anon_sym_into] = ACTIONS(3597),
    [anon_sym_join] = ACTIONS(3597),
    [anon_sym_on] = ACTIONS(3597),
    [anon_sym_equals] = ACTIONS(3597),
    [anon_sym_let] = ACTIONS(3597),
    [anon_sym_orderby] = ACTIONS(3597),
    [anon_sym_ascending] = ACTIONS(3597),
    [anon_sym_descending] = ACTIONS(3597),
    [anon_sym_group] = ACTIONS(3597),
    [anon_sym_by] = ACTIONS(3597),
    [anon_sym_select] = ACTIONS(3597),
    [anon_sym_DQUOTE] = ACTIONS(3597),
    [anon_sym_stackalloc] = ACTIONS(3597),
    [anon_sym_sizeof] = ACTIONS(3597),
    [anon_sym_typeof] = ACTIONS(3597),
    [anon_sym___makeref] = ACTIONS(3597),
    [anon_sym___reftype] = ACTIONS(3597),
    [anon_sym___refvalue] = ACTIONS(3597),
    [sym_null_literal] = ACTIONS(3597),
    [anon_sym_SQUOTE] = ACTIONS(3599),
    [sym_integer_literal] = ACTIONS(3597),
    [sym_real_literal] = ACTIONS(3599),
    [sym_verbatim_string_literal] = ACTIONS(3599),
    [sym_raw_string_literal] = ACTIONS(3599),
    [aux_sym_preproc_if_token1] = ACTIONS(3599),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3599),
    [sym_interpolation_verbatim_start] = ACTIONS(3599),
    [sym_interpolation_raw_start] = ACTIONS(3599),
  },
  [2565] = {
    [sym_preproc_region] = STATE(2565),
    [sym_preproc_endregion] = STATE(2565),
    [sym_preproc_line] = STATE(2565),
    [sym_preproc_pragma] = STATE(2565),
    [sym_preproc_nullable] = STATE(2565),
    [sym_preproc_error] = STATE(2565),
    [sym_preproc_define] = STATE(2565),
    [sym_preproc_undef] = STATE(2565),
    [ts_builtin_sym_end] = ACTIONS(3962),
    [sym__identifier_token] = ACTIONS(3964),
    [anon_sym_extern] = ACTIONS(3964),
    [anon_sym_alias] = ACTIONS(3964),
    [anon_sym_SEMI] = ACTIONS(3962),
    [anon_sym_global] = ACTIONS(3964),
    [anon_sym_using] = ACTIONS(3964),
    [anon_sym_unsafe] = ACTIONS(3964),
    [anon_sym_static] = ACTIONS(3964),
    [anon_sym_LBRACK] = ACTIONS(3962),
    [anon_sym_LPAREN] = ACTIONS(3962),
    [anon_sym_return] = ACTIONS(3964),
    [anon_sym_namespace] = ACTIONS(3964),
    [anon_sym_class] = ACTIONS(3964),
    [anon_sym_ref] = ACTIONS(3964),
    [anon_sym_struct] = ACTIONS(3964),
    [anon_sym_enum] = ACTIONS(3964),
    [anon_sym_LBRACE] = ACTIONS(3962),
    [anon_sym_interface] = ACTIONS(3964),
    [anon_sym_delegate] = ACTIONS(3964),
    [anon_sym_record] = ACTIONS(3964),
    [anon_sym_abstract] = ACTIONS(3964),
    [anon_sym_async] = ACTIONS(3964),
    [anon_sym_const] = ACTIONS(3964),
    [anon_sym_file] = ACTIONS(3964),
    [anon_sym_fixed] = ACTIONS(3964),
    [anon_sym_internal] = ACTIONS(3964),
    [anon_sym_new] = ACTIONS(3964),
    [anon_sym_override] = ACTIONS(3964),
    [anon_sym_partial] = ACTIONS(3964),
    [anon_sym_private] = ACTIONS(3964),
    [anon_sym_protected] = ACTIONS(3964),
    [anon_sym_public] = ACTIONS(3964),
    [anon_sym_readonly] = ACTIONS(3964),
    [anon_sym_required] = ACTIONS(3964),
    [anon_sym_sealed] = ACTIONS(3964),
    [anon_sym_virtual] = ACTIONS(3964),
    [anon_sym_volatile] = ACTIONS(3964),
    [anon_sym_where] = ACTIONS(3964),
    [anon_sym_notnull] = ACTIONS(3964),
    [anon_sym_unmanaged] = ACTIONS(3964),
    [anon_sym_checked] = ACTIONS(3964),
    [anon_sym_BANG] = ACTIONS(3962),
    [anon_sym_TILDE] = ACTIONS(3962),
    [anon_sym_PLUS_PLUS] = ACTIONS(3962),
    [anon_sym_DASH_DASH] = ACTIONS(3962),
    [anon_sym_true] = ACTIONS(3964),
    [anon_sym_false] = ACTIONS(3964),
    [anon_sym_PLUS] = ACTIONS(3964),
    [anon_sym_DASH] = ACTIONS(3964),
    [anon_sym_STAR] = ACTIONS(3962),
    [anon_sym_CARET] = ACTIONS(3962),
    [anon_sym_AMP] = ACTIONS(3962),
    [anon_sym_this] = ACTIONS(3964),
    [anon_sym_scoped] = ACTIONS(3964),
    [anon_sym_var] = ACTIONS(3964),
    [sym_predefined_type] = ACTIONS(3964),
    [anon_sym_break] = ACTIONS(3964),
    [anon_sym_unchecked] = ACTIONS(3964),
    [anon_sym_continue] = ACTIONS(3964),
    [anon_sym_do] = ACTIONS(3964),
    [anon_sym_while] = ACTIONS(3964),
    [anon_sym_for] = ACTIONS(3964),
    [anon_sym_lock] = ACTIONS(3964),
    [anon_sym_yield] = ACTIONS(3964),
    [anon_sym_switch] = ACTIONS(3964),
    [anon_sym_default] = ACTIONS(3964),
    [anon_sym_throw] = ACTIONS(3964),
    [anon_sym_try] = ACTIONS(3964),
    [anon_sym_when] = ACTIONS(3964),
    [anon_sym_await] = ACTIONS(3964),
    [anon_sym_foreach] = ACTIONS(3964),
    [anon_sym_goto] = ACTIONS(3964),
    [anon_sym_if] = ACTIONS(3964),
    [anon_sym_DOT_DOT] = ACTIONS(3962),
    [anon_sym_from] = ACTIONS(3964),
    [anon_sym_into] = ACTIONS(3964),
    [anon_sym_join] = ACTIONS(3964),
    [anon_sym_on] = ACTIONS(3964),
    [anon_sym_equals] = ACTIONS(3964),
    [anon_sym_let] = ACTIONS(3964),
    [anon_sym_orderby] = ACTIONS(3964),
    [anon_sym_ascending] = ACTIONS(3964),
    [anon_sym_descending] = ACTIONS(3964),
    [anon_sym_group] = ACTIONS(3964),
    [anon_sym_by] = ACTIONS(3964),
    [anon_sym_select] = ACTIONS(3964),
    [anon_sym_DQUOTE] = ACTIONS(3964),
    [anon_sym_stackalloc] = ACTIONS(3964),
    [anon_sym_sizeof] = ACTIONS(3964),
    [anon_sym_typeof] = ACTIONS(3964),
    [anon_sym___makeref] = ACTIONS(3964),
    [anon_sym___reftype] = ACTIONS(3964),
    [anon_sym___refvalue] = ACTIONS(3964),
    [sym_null_literal] = ACTIONS(3964),
    [anon_sym_SQUOTE] = ACTIONS(3962),
    [sym_integer_literal] = ACTIONS(3964),
    [sym_real_literal] = ACTIONS(3962),
    [sym_verbatim_string_literal] = ACTIONS(3962),
    [sym_raw_string_literal] = ACTIONS(3962),
    [aux_sym_preproc_if_token1] = ACTIONS(3962),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3962),
    [sym_interpolation_verbatim_start] = ACTIONS(3962),
    [sym_interpolation_raw_start] = ACTIONS(3962),
  },
  [2566] = {
    [sym_preproc_region] = STATE(2566),
    [sym_preproc_endregion] = STATE(2566),
    [sym_preproc_line] = STATE(2566),
    [sym_preproc_pragma] = STATE(2566),
    [sym_preproc_nullable] = STATE(2566),
    [sym_preproc_error] = STATE(2566),
    [sym_preproc_define] = STATE(2566),
    [sym_preproc_undef] = STATE(2566),
    [ts_builtin_sym_end] = ACTIONS(3866),
    [sym__identifier_token] = ACTIONS(3864),
    [anon_sym_extern] = ACTIONS(3864),
    [anon_sym_alias] = ACTIONS(3864),
    [anon_sym_SEMI] = ACTIONS(3866),
    [anon_sym_global] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3864),
    [anon_sym_unsafe] = ACTIONS(3864),
    [anon_sym_static] = ACTIONS(3864),
    [anon_sym_LBRACK] = ACTIONS(3866),
    [anon_sym_LPAREN] = ACTIONS(3866),
    [anon_sym_return] = ACTIONS(3864),
    [anon_sym_namespace] = ACTIONS(3864),
    [anon_sym_class] = ACTIONS(3864),
    [anon_sym_ref] = ACTIONS(3864),
    [anon_sym_struct] = ACTIONS(3864),
    [anon_sym_enum] = ACTIONS(3864),
    [anon_sym_LBRACE] = ACTIONS(3866),
    [anon_sym_interface] = ACTIONS(3864),
    [anon_sym_delegate] = ACTIONS(3864),
    [anon_sym_record] = ACTIONS(3864),
    [anon_sym_abstract] = ACTIONS(3864),
    [anon_sym_async] = ACTIONS(3864),
    [anon_sym_const] = ACTIONS(3864),
    [anon_sym_file] = ACTIONS(3864),
    [anon_sym_fixed] = ACTIONS(3864),
    [anon_sym_internal] = ACTIONS(3864),
    [anon_sym_new] = ACTIONS(3864),
    [anon_sym_override] = ACTIONS(3864),
    [anon_sym_partial] = ACTIONS(3864),
    [anon_sym_private] = ACTIONS(3864),
    [anon_sym_protected] = ACTIONS(3864),
    [anon_sym_public] = ACTIONS(3864),
    [anon_sym_readonly] = ACTIONS(3864),
    [anon_sym_required] = ACTIONS(3864),
    [anon_sym_sealed] = ACTIONS(3864),
    [anon_sym_virtual] = ACTIONS(3864),
    [anon_sym_volatile] = ACTIONS(3864),
    [anon_sym_where] = ACTIONS(3864),
    [anon_sym_notnull] = ACTIONS(3864),
    [anon_sym_unmanaged] = ACTIONS(3864),
    [anon_sym_checked] = ACTIONS(3864),
    [anon_sym_BANG] = ACTIONS(3866),
    [anon_sym_TILDE] = ACTIONS(3866),
    [anon_sym_PLUS_PLUS] = ACTIONS(3866),
    [anon_sym_DASH_DASH] = ACTIONS(3866),
    [anon_sym_true] = ACTIONS(3864),
    [anon_sym_false] = ACTIONS(3864),
    [anon_sym_PLUS] = ACTIONS(3864),
    [anon_sym_DASH] = ACTIONS(3864),
    [anon_sym_STAR] = ACTIONS(3866),
    [anon_sym_CARET] = ACTIONS(3866),
    [anon_sym_AMP] = ACTIONS(3866),
    [anon_sym_this] = ACTIONS(3864),
    [anon_sym_scoped] = ACTIONS(3864),
    [anon_sym_var] = ACTIONS(3864),
    [sym_predefined_type] = ACTIONS(3864),
    [anon_sym_break] = ACTIONS(3864),
    [anon_sym_unchecked] = ACTIONS(3864),
    [anon_sym_continue] = ACTIONS(3864),
    [anon_sym_do] = ACTIONS(3864),
    [anon_sym_while] = ACTIONS(3864),
    [anon_sym_for] = ACTIONS(3864),
    [anon_sym_lock] = ACTIONS(3864),
    [anon_sym_yield] = ACTIONS(3864),
    [anon_sym_switch] = ACTIONS(3864),
    [anon_sym_default] = ACTIONS(3864),
    [anon_sym_throw] = ACTIONS(3864),
    [anon_sym_try] = ACTIONS(3864),
    [anon_sym_when] = ACTIONS(3864),
    [anon_sym_await] = ACTIONS(3864),
    [anon_sym_foreach] = ACTIONS(3864),
    [anon_sym_goto] = ACTIONS(3864),
    [anon_sym_if] = ACTIONS(3864),
    [anon_sym_DOT_DOT] = ACTIONS(3866),
    [anon_sym_from] = ACTIONS(3864),
    [anon_sym_into] = ACTIONS(3864),
    [anon_sym_join] = ACTIONS(3864),
    [anon_sym_on] = ACTIONS(3864),
    [anon_sym_equals] = ACTIONS(3864),
    [anon_sym_let] = ACTIONS(3864),
    [anon_sym_orderby] = ACTIONS(3864),
    [anon_sym_ascending] = ACTIONS(3864),
    [anon_sym_descending] = ACTIONS(3864),
    [anon_sym_group] = ACTIONS(3864),
    [anon_sym_by] = ACTIONS(3864),
    [anon_sym_select] = ACTIONS(3864),
    [anon_sym_DQUOTE] = ACTIONS(3864),
    [anon_sym_stackalloc] = ACTIONS(3864),
    [anon_sym_sizeof] = ACTIONS(3864),
    [anon_sym_typeof] = ACTIONS(3864),
    [anon_sym___makeref] = ACTIONS(3864),
    [anon_sym___reftype] = ACTIONS(3864),
    [anon_sym___refvalue] = ACTIONS(3864),
    [sym_null_literal] = ACTIONS(3864),
    [anon_sym_SQUOTE] = ACTIONS(3866),
    [sym_integer_literal] = ACTIONS(3864),
    [sym_real_literal] = ACTIONS(3866),
    [sym_verbatim_string_literal] = ACTIONS(3866),
    [sym_raw_string_literal] = ACTIONS(3866),
    [aux_sym_preproc_if_token1] = ACTIONS(3866),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3866),
    [sym_interpolation_verbatim_start] = ACTIONS(3866),
    [sym_interpolation_raw_start] = ACTIONS(3866),
  },
  [2567] = {
    [sym_preproc_region] = STATE(2567),
    [sym_preproc_endregion] = STATE(2567),
    [sym_preproc_line] = STATE(2567),
    [sym_preproc_pragma] = STATE(2567),
    [sym_preproc_nullable] = STATE(2567),
    [sym_preproc_error] = STATE(2567),
    [sym_preproc_define] = STATE(2567),
    [sym_preproc_undef] = STATE(2567),
    [ts_builtin_sym_end] = ACTIONS(3503),
    [sym__identifier_token] = ACTIONS(3501),
    [anon_sym_extern] = ACTIONS(3501),
    [anon_sym_alias] = ACTIONS(3501),
    [anon_sym_SEMI] = ACTIONS(3503),
    [anon_sym_global] = ACTIONS(3501),
    [anon_sym_using] = ACTIONS(3501),
    [anon_sym_unsafe] = ACTIONS(3501),
    [anon_sym_static] = ACTIONS(3501),
    [anon_sym_LBRACK] = ACTIONS(3503),
    [anon_sym_LPAREN] = ACTIONS(3503),
    [anon_sym_return] = ACTIONS(3501),
    [anon_sym_namespace] = ACTIONS(3501),
    [anon_sym_class] = ACTIONS(3501),
    [anon_sym_ref] = ACTIONS(3501),
    [anon_sym_struct] = ACTIONS(3501),
    [anon_sym_enum] = ACTIONS(3501),
    [anon_sym_LBRACE] = ACTIONS(3503),
    [anon_sym_interface] = ACTIONS(3501),
    [anon_sym_delegate] = ACTIONS(3501),
    [anon_sym_record] = ACTIONS(3501),
    [anon_sym_abstract] = ACTIONS(3501),
    [anon_sym_async] = ACTIONS(3501),
    [anon_sym_const] = ACTIONS(3501),
    [anon_sym_file] = ACTIONS(3501),
    [anon_sym_fixed] = ACTIONS(3501),
    [anon_sym_internal] = ACTIONS(3501),
    [anon_sym_new] = ACTIONS(3501),
    [anon_sym_override] = ACTIONS(3501),
    [anon_sym_partial] = ACTIONS(3501),
    [anon_sym_private] = ACTIONS(3501),
    [anon_sym_protected] = ACTIONS(3501),
    [anon_sym_public] = ACTIONS(3501),
    [anon_sym_readonly] = ACTIONS(3501),
    [anon_sym_required] = ACTIONS(3501),
    [anon_sym_sealed] = ACTIONS(3501),
    [anon_sym_virtual] = ACTIONS(3501),
    [anon_sym_volatile] = ACTIONS(3501),
    [anon_sym_where] = ACTIONS(3501),
    [anon_sym_notnull] = ACTIONS(3501),
    [anon_sym_unmanaged] = ACTIONS(3501),
    [anon_sym_checked] = ACTIONS(3501),
    [anon_sym_BANG] = ACTIONS(3503),
    [anon_sym_TILDE] = ACTIONS(3503),
    [anon_sym_PLUS_PLUS] = ACTIONS(3503),
    [anon_sym_DASH_DASH] = ACTIONS(3503),
    [anon_sym_true] = ACTIONS(3501),
    [anon_sym_false] = ACTIONS(3501),
    [anon_sym_PLUS] = ACTIONS(3501),
    [anon_sym_DASH] = ACTIONS(3501),
    [anon_sym_STAR] = ACTIONS(3503),
    [anon_sym_CARET] = ACTIONS(3503),
    [anon_sym_AMP] = ACTIONS(3503),
    [anon_sym_this] = ACTIONS(3501),
    [anon_sym_scoped] = ACTIONS(3501),
    [anon_sym_var] = ACTIONS(3501),
    [sym_predefined_type] = ACTIONS(3501),
    [anon_sym_break] = ACTIONS(3501),
    [anon_sym_unchecked] = ACTIONS(3501),
    [anon_sym_continue] = ACTIONS(3501),
    [anon_sym_do] = ACTIONS(3501),
    [anon_sym_while] = ACTIONS(3501),
    [anon_sym_for] = ACTIONS(3501),
    [anon_sym_lock] = ACTIONS(3501),
    [anon_sym_yield] = ACTIONS(3501),
    [anon_sym_switch] = ACTIONS(3501),
    [anon_sym_default] = ACTIONS(3501),
    [anon_sym_throw] = ACTIONS(3501),
    [anon_sym_try] = ACTIONS(3501),
    [anon_sym_when] = ACTIONS(3501),
    [anon_sym_await] = ACTIONS(3501),
    [anon_sym_foreach] = ACTIONS(3501),
    [anon_sym_goto] = ACTIONS(3501),
    [anon_sym_if] = ACTIONS(3501),
    [anon_sym_DOT_DOT] = ACTIONS(3503),
    [anon_sym_from] = ACTIONS(3501),
    [anon_sym_into] = ACTIONS(3501),
    [anon_sym_join] = ACTIONS(3501),
    [anon_sym_on] = ACTIONS(3501),
    [anon_sym_equals] = ACTIONS(3501),
    [anon_sym_let] = ACTIONS(3501),
    [anon_sym_orderby] = ACTIONS(3501),
    [anon_sym_ascending] = ACTIONS(3501),
    [anon_sym_descending] = ACTIONS(3501),
    [anon_sym_group] = ACTIONS(3501),
    [anon_sym_by] = ACTIONS(3501),
    [anon_sym_select] = ACTIONS(3501),
    [anon_sym_DQUOTE] = ACTIONS(3501),
    [anon_sym_stackalloc] = ACTIONS(3501),
    [anon_sym_sizeof] = ACTIONS(3501),
    [anon_sym_typeof] = ACTIONS(3501),
    [anon_sym___makeref] = ACTIONS(3501),
    [anon_sym___reftype] = ACTIONS(3501),
    [anon_sym___refvalue] = ACTIONS(3501),
    [sym_null_literal] = ACTIONS(3501),
    [anon_sym_SQUOTE] = ACTIONS(3503),
    [sym_integer_literal] = ACTIONS(3501),
    [sym_real_literal] = ACTIONS(3503),
    [sym_verbatim_string_literal] = ACTIONS(3503),
    [sym_raw_string_literal] = ACTIONS(3503),
    [aux_sym_preproc_if_token1] = ACTIONS(3503),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3503),
    [sym_interpolation_verbatim_start] = ACTIONS(3503),
    [sym_interpolation_raw_start] = ACTIONS(3503),
  },
  [2568] = {
    [sym_preproc_region] = STATE(2568),
    [sym_preproc_endregion] = STATE(2568),
    [sym_preproc_line] = STATE(2568),
    [sym_preproc_pragma] = STATE(2568),
    [sym_preproc_nullable] = STATE(2568),
    [sym_preproc_error] = STATE(2568),
    [sym_preproc_define] = STATE(2568),
    [sym_preproc_undef] = STATE(2568),
    [ts_builtin_sym_end] = ACTIONS(3742),
    [sym__identifier_token] = ACTIONS(3740),
    [anon_sym_extern] = ACTIONS(3740),
    [anon_sym_alias] = ACTIONS(3740),
    [anon_sym_SEMI] = ACTIONS(3742),
    [anon_sym_global] = ACTIONS(3740),
    [anon_sym_using] = ACTIONS(3740),
    [anon_sym_unsafe] = ACTIONS(3740),
    [anon_sym_static] = ACTIONS(3740),
    [anon_sym_LBRACK] = ACTIONS(3742),
    [anon_sym_LPAREN] = ACTIONS(3742),
    [anon_sym_return] = ACTIONS(3740),
    [anon_sym_namespace] = ACTIONS(3740),
    [anon_sym_class] = ACTIONS(3740),
    [anon_sym_ref] = ACTIONS(3740),
    [anon_sym_struct] = ACTIONS(3740),
    [anon_sym_enum] = ACTIONS(3740),
    [anon_sym_LBRACE] = ACTIONS(3742),
    [anon_sym_interface] = ACTIONS(3740),
    [anon_sym_delegate] = ACTIONS(3740),
    [anon_sym_record] = ACTIONS(3740),
    [anon_sym_abstract] = ACTIONS(3740),
    [anon_sym_async] = ACTIONS(3740),
    [anon_sym_const] = ACTIONS(3740),
    [anon_sym_file] = ACTIONS(3740),
    [anon_sym_fixed] = ACTIONS(3740),
    [anon_sym_internal] = ACTIONS(3740),
    [anon_sym_new] = ACTIONS(3740),
    [anon_sym_override] = ACTIONS(3740),
    [anon_sym_partial] = ACTIONS(3740),
    [anon_sym_private] = ACTIONS(3740),
    [anon_sym_protected] = ACTIONS(3740),
    [anon_sym_public] = ACTIONS(3740),
    [anon_sym_readonly] = ACTIONS(3740),
    [anon_sym_required] = ACTIONS(3740),
    [anon_sym_sealed] = ACTIONS(3740),
    [anon_sym_virtual] = ACTIONS(3740),
    [anon_sym_volatile] = ACTIONS(3740),
    [anon_sym_where] = ACTIONS(3740),
    [anon_sym_notnull] = ACTIONS(3740),
    [anon_sym_unmanaged] = ACTIONS(3740),
    [anon_sym_checked] = ACTIONS(3740),
    [anon_sym_BANG] = ACTIONS(3742),
    [anon_sym_TILDE] = ACTIONS(3742),
    [anon_sym_PLUS_PLUS] = ACTIONS(3742),
    [anon_sym_DASH_DASH] = ACTIONS(3742),
    [anon_sym_true] = ACTIONS(3740),
    [anon_sym_false] = ACTIONS(3740),
    [anon_sym_PLUS] = ACTIONS(3740),
    [anon_sym_DASH] = ACTIONS(3740),
    [anon_sym_STAR] = ACTIONS(3742),
    [anon_sym_CARET] = ACTIONS(3742),
    [anon_sym_AMP] = ACTIONS(3742),
    [anon_sym_this] = ACTIONS(3740),
    [anon_sym_scoped] = ACTIONS(3740),
    [anon_sym_var] = ACTIONS(3740),
    [sym_predefined_type] = ACTIONS(3740),
    [anon_sym_break] = ACTIONS(3740),
    [anon_sym_unchecked] = ACTIONS(3740),
    [anon_sym_continue] = ACTIONS(3740),
    [anon_sym_do] = ACTIONS(3740),
    [anon_sym_while] = ACTIONS(3740),
    [anon_sym_for] = ACTIONS(3740),
    [anon_sym_lock] = ACTIONS(3740),
    [anon_sym_yield] = ACTIONS(3740),
    [anon_sym_switch] = ACTIONS(3740),
    [anon_sym_default] = ACTIONS(3740),
    [anon_sym_throw] = ACTIONS(3740),
    [anon_sym_try] = ACTIONS(3740),
    [anon_sym_when] = ACTIONS(3740),
    [anon_sym_await] = ACTIONS(3740),
    [anon_sym_foreach] = ACTIONS(3740),
    [anon_sym_goto] = ACTIONS(3740),
    [anon_sym_if] = ACTIONS(3740),
    [anon_sym_DOT_DOT] = ACTIONS(3742),
    [anon_sym_from] = ACTIONS(3740),
    [anon_sym_into] = ACTIONS(3740),
    [anon_sym_join] = ACTIONS(3740),
    [anon_sym_on] = ACTIONS(3740),
    [anon_sym_equals] = ACTIONS(3740),
    [anon_sym_let] = ACTIONS(3740),
    [anon_sym_orderby] = ACTIONS(3740),
    [anon_sym_ascending] = ACTIONS(3740),
    [anon_sym_descending] = ACTIONS(3740),
    [anon_sym_group] = ACTIONS(3740),
    [anon_sym_by] = ACTIONS(3740),
    [anon_sym_select] = ACTIONS(3740),
    [anon_sym_DQUOTE] = ACTIONS(3740),
    [anon_sym_stackalloc] = ACTIONS(3740),
    [anon_sym_sizeof] = ACTIONS(3740),
    [anon_sym_typeof] = ACTIONS(3740),
    [anon_sym___makeref] = ACTIONS(3740),
    [anon_sym___reftype] = ACTIONS(3740),
    [anon_sym___refvalue] = ACTIONS(3740),
    [sym_null_literal] = ACTIONS(3740),
    [anon_sym_SQUOTE] = ACTIONS(3742),
    [sym_integer_literal] = ACTIONS(3740),
    [sym_real_literal] = ACTIONS(3742),
    [sym_verbatim_string_literal] = ACTIONS(3742),
    [sym_raw_string_literal] = ACTIONS(3742),
    [aux_sym_preproc_if_token1] = ACTIONS(3742),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3742),
    [sym_interpolation_verbatim_start] = ACTIONS(3742),
    [sym_interpolation_raw_start] = ACTIONS(3742),
  },
  [2569] = {
    [sym_preproc_region] = STATE(2569),
    [sym_preproc_endregion] = STATE(2569),
    [sym_preproc_line] = STATE(2569),
    [sym_preproc_pragma] = STATE(2569),
    [sym_preproc_nullable] = STATE(2569),
    [sym_preproc_error] = STATE(2569),
    [sym_preproc_define] = STATE(2569),
    [sym_preproc_undef] = STATE(2569),
    [ts_builtin_sym_end] = ACTIONS(3746),
    [sym__identifier_token] = ACTIONS(3744),
    [anon_sym_extern] = ACTIONS(3744),
    [anon_sym_alias] = ACTIONS(3744),
    [anon_sym_SEMI] = ACTIONS(3746),
    [anon_sym_global] = ACTIONS(3744),
    [anon_sym_using] = ACTIONS(3744),
    [anon_sym_unsafe] = ACTIONS(3744),
    [anon_sym_static] = ACTIONS(3744),
    [anon_sym_LBRACK] = ACTIONS(3746),
    [anon_sym_LPAREN] = ACTIONS(3746),
    [anon_sym_return] = ACTIONS(3744),
    [anon_sym_namespace] = ACTIONS(3744),
    [anon_sym_class] = ACTIONS(3744),
    [anon_sym_ref] = ACTIONS(3744),
    [anon_sym_struct] = ACTIONS(3744),
    [anon_sym_enum] = ACTIONS(3744),
    [anon_sym_LBRACE] = ACTIONS(3746),
    [anon_sym_interface] = ACTIONS(3744),
    [anon_sym_delegate] = ACTIONS(3744),
    [anon_sym_record] = ACTIONS(3744),
    [anon_sym_abstract] = ACTIONS(3744),
    [anon_sym_async] = ACTIONS(3744),
    [anon_sym_const] = ACTIONS(3744),
    [anon_sym_file] = ACTIONS(3744),
    [anon_sym_fixed] = ACTIONS(3744),
    [anon_sym_internal] = ACTIONS(3744),
    [anon_sym_new] = ACTIONS(3744),
    [anon_sym_override] = ACTIONS(3744),
    [anon_sym_partial] = ACTIONS(3744),
    [anon_sym_private] = ACTIONS(3744),
    [anon_sym_protected] = ACTIONS(3744),
    [anon_sym_public] = ACTIONS(3744),
    [anon_sym_readonly] = ACTIONS(3744),
    [anon_sym_required] = ACTIONS(3744),
    [anon_sym_sealed] = ACTIONS(3744),
    [anon_sym_virtual] = ACTIONS(3744),
    [anon_sym_volatile] = ACTIONS(3744),
    [anon_sym_where] = ACTIONS(3744),
    [anon_sym_notnull] = ACTIONS(3744),
    [anon_sym_unmanaged] = ACTIONS(3744),
    [anon_sym_checked] = ACTIONS(3744),
    [anon_sym_BANG] = ACTIONS(3746),
    [anon_sym_TILDE] = ACTIONS(3746),
    [anon_sym_PLUS_PLUS] = ACTIONS(3746),
    [anon_sym_DASH_DASH] = ACTIONS(3746),
    [anon_sym_true] = ACTIONS(3744),
    [anon_sym_false] = ACTIONS(3744),
    [anon_sym_PLUS] = ACTIONS(3744),
    [anon_sym_DASH] = ACTIONS(3744),
    [anon_sym_STAR] = ACTIONS(3746),
    [anon_sym_CARET] = ACTIONS(3746),
    [anon_sym_AMP] = ACTIONS(3746),
    [anon_sym_this] = ACTIONS(3744),
    [anon_sym_scoped] = ACTIONS(3744),
    [anon_sym_var] = ACTIONS(3744),
    [sym_predefined_type] = ACTIONS(3744),
    [anon_sym_break] = ACTIONS(3744),
    [anon_sym_unchecked] = ACTIONS(3744),
    [anon_sym_continue] = ACTIONS(3744),
    [anon_sym_do] = ACTIONS(3744),
    [anon_sym_while] = ACTIONS(3744),
    [anon_sym_for] = ACTIONS(3744),
    [anon_sym_lock] = ACTIONS(3744),
    [anon_sym_yield] = ACTIONS(3744),
    [anon_sym_switch] = ACTIONS(3744),
    [anon_sym_default] = ACTIONS(3744),
    [anon_sym_throw] = ACTIONS(3744),
    [anon_sym_try] = ACTIONS(3744),
    [anon_sym_when] = ACTIONS(3744),
    [anon_sym_await] = ACTIONS(3744),
    [anon_sym_foreach] = ACTIONS(3744),
    [anon_sym_goto] = ACTIONS(3744),
    [anon_sym_if] = ACTIONS(3744),
    [anon_sym_DOT_DOT] = ACTIONS(3746),
    [anon_sym_from] = ACTIONS(3744),
    [anon_sym_into] = ACTIONS(3744),
    [anon_sym_join] = ACTIONS(3744),
    [anon_sym_on] = ACTIONS(3744),
    [anon_sym_equals] = ACTIONS(3744),
    [anon_sym_let] = ACTIONS(3744),
    [anon_sym_orderby] = ACTIONS(3744),
    [anon_sym_ascending] = ACTIONS(3744),
    [anon_sym_descending] = ACTIONS(3744),
    [anon_sym_group] = ACTIONS(3744),
    [anon_sym_by] = ACTIONS(3744),
    [anon_sym_select] = ACTIONS(3744),
    [anon_sym_DQUOTE] = ACTIONS(3744),
    [anon_sym_stackalloc] = ACTIONS(3744),
    [anon_sym_sizeof] = ACTIONS(3744),
    [anon_sym_typeof] = ACTIONS(3744),
    [anon_sym___makeref] = ACTIONS(3744),
    [anon_sym___reftype] = ACTIONS(3744),
    [anon_sym___refvalue] = ACTIONS(3744),
    [sym_null_literal] = ACTIONS(3744),
    [anon_sym_SQUOTE] = ACTIONS(3746),
    [sym_integer_literal] = ACTIONS(3744),
    [sym_real_literal] = ACTIONS(3746),
    [sym_verbatim_string_literal] = ACTIONS(3746),
    [sym_raw_string_literal] = ACTIONS(3746),
    [aux_sym_preproc_if_token1] = ACTIONS(3746),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3746),
    [sym_interpolation_verbatim_start] = ACTIONS(3746),
    [sym_interpolation_raw_start] = ACTIONS(3746),
  },
  [2570] = {
    [sym_preproc_region] = STATE(2570),
    [sym_preproc_endregion] = STATE(2570),
    [sym_preproc_line] = STATE(2570),
    [sym_preproc_pragma] = STATE(2570),
    [sym_preproc_nullable] = STATE(2570),
    [sym_preproc_error] = STATE(2570),
    [sym_preproc_define] = STATE(2570),
    [sym_preproc_undef] = STATE(2570),
    [ts_builtin_sym_end] = ACTIONS(3762),
    [sym__identifier_token] = ACTIONS(3760),
    [anon_sym_extern] = ACTIONS(3760),
    [anon_sym_alias] = ACTIONS(3760),
    [anon_sym_SEMI] = ACTIONS(3762),
    [anon_sym_global] = ACTIONS(3760),
    [anon_sym_using] = ACTIONS(3760),
    [anon_sym_unsafe] = ACTIONS(3760),
    [anon_sym_static] = ACTIONS(3760),
    [anon_sym_LBRACK] = ACTIONS(3762),
    [anon_sym_LPAREN] = ACTIONS(3762),
    [anon_sym_return] = ACTIONS(3760),
    [anon_sym_namespace] = ACTIONS(3760),
    [anon_sym_class] = ACTIONS(3760),
    [anon_sym_ref] = ACTIONS(3760),
    [anon_sym_struct] = ACTIONS(3760),
    [anon_sym_enum] = ACTIONS(3760),
    [anon_sym_LBRACE] = ACTIONS(3762),
    [anon_sym_interface] = ACTIONS(3760),
    [anon_sym_delegate] = ACTIONS(3760),
    [anon_sym_record] = ACTIONS(3760),
    [anon_sym_abstract] = ACTIONS(3760),
    [anon_sym_async] = ACTIONS(3760),
    [anon_sym_const] = ACTIONS(3760),
    [anon_sym_file] = ACTIONS(3760),
    [anon_sym_fixed] = ACTIONS(3760),
    [anon_sym_internal] = ACTIONS(3760),
    [anon_sym_new] = ACTIONS(3760),
    [anon_sym_override] = ACTIONS(3760),
    [anon_sym_partial] = ACTIONS(3760),
    [anon_sym_private] = ACTIONS(3760),
    [anon_sym_protected] = ACTIONS(3760),
    [anon_sym_public] = ACTIONS(3760),
    [anon_sym_readonly] = ACTIONS(3760),
    [anon_sym_required] = ACTIONS(3760),
    [anon_sym_sealed] = ACTIONS(3760),
    [anon_sym_virtual] = ACTIONS(3760),
    [anon_sym_volatile] = ACTIONS(3760),
    [anon_sym_where] = ACTIONS(3760),
    [anon_sym_notnull] = ACTIONS(3760),
    [anon_sym_unmanaged] = ACTIONS(3760),
    [anon_sym_checked] = ACTIONS(3760),
    [anon_sym_BANG] = ACTIONS(3762),
    [anon_sym_TILDE] = ACTIONS(3762),
    [anon_sym_PLUS_PLUS] = ACTIONS(3762),
    [anon_sym_DASH_DASH] = ACTIONS(3762),
    [anon_sym_true] = ACTIONS(3760),
    [anon_sym_false] = ACTIONS(3760),
    [anon_sym_PLUS] = ACTIONS(3760),
    [anon_sym_DASH] = ACTIONS(3760),
    [anon_sym_STAR] = ACTIONS(3762),
    [anon_sym_CARET] = ACTIONS(3762),
    [anon_sym_AMP] = ACTIONS(3762),
    [anon_sym_this] = ACTIONS(3760),
    [anon_sym_scoped] = ACTIONS(3760),
    [anon_sym_var] = ACTIONS(3760),
    [sym_predefined_type] = ACTIONS(3760),
    [anon_sym_break] = ACTIONS(3760),
    [anon_sym_unchecked] = ACTIONS(3760),
    [anon_sym_continue] = ACTIONS(3760),
    [anon_sym_do] = ACTIONS(3760),
    [anon_sym_while] = ACTIONS(3760),
    [anon_sym_for] = ACTIONS(3760),
    [anon_sym_lock] = ACTIONS(3760),
    [anon_sym_yield] = ACTIONS(3760),
    [anon_sym_switch] = ACTIONS(3760),
    [anon_sym_default] = ACTIONS(3760),
    [anon_sym_throw] = ACTIONS(3760),
    [anon_sym_try] = ACTIONS(3760),
    [anon_sym_when] = ACTIONS(3760),
    [anon_sym_await] = ACTIONS(3760),
    [anon_sym_foreach] = ACTIONS(3760),
    [anon_sym_goto] = ACTIONS(3760),
    [anon_sym_if] = ACTIONS(3760),
    [anon_sym_DOT_DOT] = ACTIONS(3762),
    [anon_sym_from] = ACTIONS(3760),
    [anon_sym_into] = ACTIONS(3760),
    [anon_sym_join] = ACTIONS(3760),
    [anon_sym_on] = ACTIONS(3760),
    [anon_sym_equals] = ACTIONS(3760),
    [anon_sym_let] = ACTIONS(3760),
    [anon_sym_orderby] = ACTIONS(3760),
    [anon_sym_ascending] = ACTIONS(3760),
    [anon_sym_descending] = ACTIONS(3760),
    [anon_sym_group] = ACTIONS(3760),
    [anon_sym_by] = ACTIONS(3760),
    [anon_sym_select] = ACTIONS(3760),
    [anon_sym_DQUOTE] = ACTIONS(3760),
    [anon_sym_stackalloc] = ACTIONS(3760),
    [anon_sym_sizeof] = ACTIONS(3760),
    [anon_sym_typeof] = ACTIONS(3760),
    [anon_sym___makeref] = ACTIONS(3760),
    [anon_sym___reftype] = ACTIONS(3760),
    [anon_sym___refvalue] = ACTIONS(3760),
    [sym_null_literal] = ACTIONS(3760),
    [anon_sym_SQUOTE] = ACTIONS(3762),
    [sym_integer_literal] = ACTIONS(3760),
    [sym_real_literal] = ACTIONS(3762),
    [sym_verbatim_string_literal] = ACTIONS(3762),
    [sym_raw_string_literal] = ACTIONS(3762),
    [aux_sym_preproc_if_token1] = ACTIONS(3762),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3762),
    [sym_interpolation_verbatim_start] = ACTIONS(3762),
    [sym_interpolation_raw_start] = ACTIONS(3762),
  },
  [2571] = {
    [sym_preproc_region] = STATE(2571),
    [sym_preproc_endregion] = STATE(2571),
    [sym_preproc_line] = STATE(2571),
    [sym_preproc_pragma] = STATE(2571),
    [sym_preproc_nullable] = STATE(2571),
    [sym_preproc_error] = STATE(2571),
    [sym_preproc_define] = STATE(2571),
    [sym_preproc_undef] = STATE(2571),
    [ts_builtin_sym_end] = ACTIONS(3766),
    [sym__identifier_token] = ACTIONS(3764),
    [anon_sym_extern] = ACTIONS(3764),
    [anon_sym_alias] = ACTIONS(3764),
    [anon_sym_SEMI] = ACTIONS(3766),
    [anon_sym_global] = ACTIONS(3764),
    [anon_sym_using] = ACTIONS(3764),
    [anon_sym_unsafe] = ACTIONS(3764),
    [anon_sym_static] = ACTIONS(3764),
    [anon_sym_LBRACK] = ACTIONS(3766),
    [anon_sym_LPAREN] = ACTIONS(3766),
    [anon_sym_return] = ACTIONS(3764),
    [anon_sym_namespace] = ACTIONS(3764),
    [anon_sym_class] = ACTIONS(3764),
    [anon_sym_ref] = ACTIONS(3764),
    [anon_sym_struct] = ACTIONS(3764),
    [anon_sym_enum] = ACTIONS(3764),
    [anon_sym_LBRACE] = ACTIONS(3766),
    [anon_sym_interface] = ACTIONS(3764),
    [anon_sym_delegate] = ACTIONS(3764),
    [anon_sym_record] = ACTIONS(3764),
    [anon_sym_abstract] = ACTIONS(3764),
    [anon_sym_async] = ACTIONS(3764),
    [anon_sym_const] = ACTIONS(3764),
    [anon_sym_file] = ACTIONS(3764),
    [anon_sym_fixed] = ACTIONS(3764),
    [anon_sym_internal] = ACTIONS(3764),
    [anon_sym_new] = ACTIONS(3764),
    [anon_sym_override] = ACTIONS(3764),
    [anon_sym_partial] = ACTIONS(3764),
    [anon_sym_private] = ACTIONS(3764),
    [anon_sym_protected] = ACTIONS(3764),
    [anon_sym_public] = ACTIONS(3764),
    [anon_sym_readonly] = ACTIONS(3764),
    [anon_sym_required] = ACTIONS(3764),
    [anon_sym_sealed] = ACTIONS(3764),
    [anon_sym_virtual] = ACTIONS(3764),
    [anon_sym_volatile] = ACTIONS(3764),
    [anon_sym_where] = ACTIONS(3764),
    [anon_sym_notnull] = ACTIONS(3764),
    [anon_sym_unmanaged] = ACTIONS(3764),
    [anon_sym_checked] = ACTIONS(3764),
    [anon_sym_BANG] = ACTIONS(3766),
    [anon_sym_TILDE] = ACTIONS(3766),
    [anon_sym_PLUS_PLUS] = ACTIONS(3766),
    [anon_sym_DASH_DASH] = ACTIONS(3766),
    [anon_sym_true] = ACTIONS(3764),
    [anon_sym_false] = ACTIONS(3764),
    [anon_sym_PLUS] = ACTIONS(3764),
    [anon_sym_DASH] = ACTIONS(3764),
    [anon_sym_STAR] = ACTIONS(3766),
    [anon_sym_CARET] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3766),
    [anon_sym_this] = ACTIONS(3764),
    [anon_sym_scoped] = ACTIONS(3764),
    [anon_sym_var] = ACTIONS(3764),
    [sym_predefined_type] = ACTIONS(3764),
    [anon_sym_break] = ACTIONS(3764),
    [anon_sym_unchecked] = ACTIONS(3764),
    [anon_sym_continue] = ACTIONS(3764),
    [anon_sym_do] = ACTIONS(3764),
    [anon_sym_while] = ACTIONS(3764),
    [anon_sym_for] = ACTIONS(3764),
    [anon_sym_lock] = ACTIONS(3764),
    [anon_sym_yield] = ACTIONS(3764),
    [anon_sym_switch] = ACTIONS(3764),
    [anon_sym_default] = ACTIONS(3764),
    [anon_sym_throw] = ACTIONS(3764),
    [anon_sym_try] = ACTIONS(3764),
    [anon_sym_when] = ACTIONS(3764),
    [anon_sym_await] = ACTIONS(3764),
    [anon_sym_foreach] = ACTIONS(3764),
    [anon_sym_goto] = ACTIONS(3764),
    [anon_sym_if] = ACTIONS(3764),
    [anon_sym_DOT_DOT] = ACTIONS(3766),
    [anon_sym_from] = ACTIONS(3764),
    [anon_sym_into] = ACTIONS(3764),
    [anon_sym_join] = ACTIONS(3764),
    [anon_sym_on] = ACTIONS(3764),
    [anon_sym_equals] = ACTIONS(3764),
    [anon_sym_let] = ACTIONS(3764),
    [anon_sym_orderby] = ACTIONS(3764),
    [anon_sym_ascending] = ACTIONS(3764),
    [anon_sym_descending] = ACTIONS(3764),
    [anon_sym_group] = ACTIONS(3764),
    [anon_sym_by] = ACTIONS(3764),
    [anon_sym_select] = ACTIONS(3764),
    [anon_sym_DQUOTE] = ACTIONS(3764),
    [anon_sym_stackalloc] = ACTIONS(3764),
    [anon_sym_sizeof] = ACTIONS(3764),
    [anon_sym_typeof] = ACTIONS(3764),
    [anon_sym___makeref] = ACTIONS(3764),
    [anon_sym___reftype] = ACTIONS(3764),
    [anon_sym___refvalue] = ACTIONS(3764),
    [sym_null_literal] = ACTIONS(3764),
    [anon_sym_SQUOTE] = ACTIONS(3766),
    [sym_integer_literal] = ACTIONS(3764),
    [sym_real_literal] = ACTIONS(3766),
    [sym_verbatim_string_literal] = ACTIONS(3766),
    [sym_raw_string_literal] = ACTIONS(3766),
    [aux_sym_preproc_if_token1] = ACTIONS(3766),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3766),
    [sym_interpolation_verbatim_start] = ACTIONS(3766),
    [sym_interpolation_raw_start] = ACTIONS(3766),
  },
  [2572] = {
    [sym_preproc_region] = STATE(2572),
    [sym_preproc_endregion] = STATE(2572),
    [sym_preproc_line] = STATE(2572),
    [sym_preproc_pragma] = STATE(2572),
    [sym_preproc_nullable] = STATE(2572),
    [sym_preproc_error] = STATE(2572),
    [sym_preproc_define] = STATE(2572),
    [sym_preproc_undef] = STATE(2572),
    [ts_builtin_sym_end] = ACTIONS(3459),
    [sym__identifier_token] = ACTIONS(3457),
    [anon_sym_extern] = ACTIONS(3457),
    [anon_sym_alias] = ACTIONS(3457),
    [anon_sym_SEMI] = ACTIONS(3459),
    [anon_sym_global] = ACTIONS(3457),
    [anon_sym_using] = ACTIONS(3457),
    [anon_sym_unsafe] = ACTIONS(3457),
    [anon_sym_static] = ACTIONS(3457),
    [anon_sym_LBRACK] = ACTIONS(3459),
    [anon_sym_LPAREN] = ACTIONS(3459),
    [anon_sym_return] = ACTIONS(3457),
    [anon_sym_namespace] = ACTIONS(3457),
    [anon_sym_class] = ACTIONS(3457),
    [anon_sym_ref] = ACTIONS(3457),
    [anon_sym_struct] = ACTIONS(3457),
    [anon_sym_enum] = ACTIONS(3457),
    [anon_sym_LBRACE] = ACTIONS(3459),
    [anon_sym_interface] = ACTIONS(3457),
    [anon_sym_delegate] = ACTIONS(3457),
    [anon_sym_record] = ACTIONS(3457),
    [anon_sym_abstract] = ACTIONS(3457),
    [anon_sym_async] = ACTIONS(3457),
    [anon_sym_const] = ACTIONS(3457),
    [anon_sym_file] = ACTIONS(3457),
    [anon_sym_fixed] = ACTIONS(3457),
    [anon_sym_internal] = ACTIONS(3457),
    [anon_sym_new] = ACTIONS(3457),
    [anon_sym_override] = ACTIONS(3457),
    [anon_sym_partial] = ACTIONS(3457),
    [anon_sym_private] = ACTIONS(3457),
    [anon_sym_protected] = ACTIONS(3457),
    [anon_sym_public] = ACTIONS(3457),
    [anon_sym_readonly] = ACTIONS(3457),
    [anon_sym_required] = ACTIONS(3457),
    [anon_sym_sealed] = ACTIONS(3457),
    [anon_sym_virtual] = ACTIONS(3457),
    [anon_sym_volatile] = ACTIONS(3457),
    [anon_sym_where] = ACTIONS(3457),
    [anon_sym_notnull] = ACTIONS(3457),
    [anon_sym_unmanaged] = ACTIONS(3457),
    [anon_sym_checked] = ACTIONS(3457),
    [anon_sym_BANG] = ACTIONS(3459),
    [anon_sym_TILDE] = ACTIONS(3459),
    [anon_sym_PLUS_PLUS] = ACTIONS(3459),
    [anon_sym_DASH_DASH] = ACTIONS(3459),
    [anon_sym_true] = ACTIONS(3457),
    [anon_sym_false] = ACTIONS(3457),
    [anon_sym_PLUS] = ACTIONS(3457),
    [anon_sym_DASH] = ACTIONS(3457),
    [anon_sym_STAR] = ACTIONS(3459),
    [anon_sym_CARET] = ACTIONS(3459),
    [anon_sym_AMP] = ACTIONS(3459),
    [anon_sym_this] = ACTIONS(3457),
    [anon_sym_scoped] = ACTIONS(3457),
    [anon_sym_var] = ACTIONS(3457),
    [sym_predefined_type] = ACTIONS(3457),
    [anon_sym_break] = ACTIONS(3457),
    [anon_sym_unchecked] = ACTIONS(3457),
    [anon_sym_continue] = ACTIONS(3457),
    [anon_sym_do] = ACTIONS(3457),
    [anon_sym_while] = ACTIONS(3457),
    [anon_sym_for] = ACTIONS(3457),
    [anon_sym_lock] = ACTIONS(3457),
    [anon_sym_yield] = ACTIONS(3457),
    [anon_sym_switch] = ACTIONS(3457),
    [anon_sym_default] = ACTIONS(3457),
    [anon_sym_throw] = ACTIONS(3457),
    [anon_sym_try] = ACTIONS(3457),
    [anon_sym_when] = ACTIONS(3457),
    [anon_sym_await] = ACTIONS(3457),
    [anon_sym_foreach] = ACTIONS(3457),
    [anon_sym_goto] = ACTIONS(3457),
    [anon_sym_if] = ACTIONS(3457),
    [anon_sym_DOT_DOT] = ACTIONS(3459),
    [anon_sym_from] = ACTIONS(3457),
    [anon_sym_into] = ACTIONS(3457),
    [anon_sym_join] = ACTIONS(3457),
    [anon_sym_on] = ACTIONS(3457),
    [anon_sym_equals] = ACTIONS(3457),
    [anon_sym_let] = ACTIONS(3457),
    [anon_sym_orderby] = ACTIONS(3457),
    [anon_sym_ascending] = ACTIONS(3457),
    [anon_sym_descending] = ACTIONS(3457),
    [anon_sym_group] = ACTIONS(3457),
    [anon_sym_by] = ACTIONS(3457),
    [anon_sym_select] = ACTIONS(3457),
    [anon_sym_DQUOTE] = ACTIONS(3457),
    [anon_sym_stackalloc] = ACTIONS(3457),
    [anon_sym_sizeof] = ACTIONS(3457),
    [anon_sym_typeof] = ACTIONS(3457),
    [anon_sym___makeref] = ACTIONS(3457),
    [anon_sym___reftype] = ACTIONS(3457),
    [anon_sym___refvalue] = ACTIONS(3457),
    [sym_null_literal] = ACTIONS(3457),
    [anon_sym_SQUOTE] = ACTIONS(3459),
    [sym_integer_literal] = ACTIONS(3457),
    [sym_real_literal] = ACTIONS(3459),
    [sym_verbatim_string_literal] = ACTIONS(3459),
    [sym_raw_string_literal] = ACTIONS(3459),
    [aux_sym_preproc_if_token1] = ACTIONS(3459),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3459),
    [sym_interpolation_verbatim_start] = ACTIONS(3459),
    [sym_interpolation_raw_start] = ACTIONS(3459),
  },
  [2573] = {
    [sym_preproc_region] = STATE(2573),
    [sym_preproc_endregion] = STATE(2573),
    [sym_preproc_line] = STATE(2573),
    [sym_preproc_pragma] = STATE(2573),
    [sym_preproc_nullable] = STATE(2573),
    [sym_preproc_error] = STATE(2573),
    [sym_preproc_define] = STATE(2573),
    [sym_preproc_undef] = STATE(2573),
    [ts_builtin_sym_end] = ACTIONS(3519),
    [sym__identifier_token] = ACTIONS(3517),
    [anon_sym_extern] = ACTIONS(3517),
    [anon_sym_alias] = ACTIONS(3517),
    [anon_sym_SEMI] = ACTIONS(3519),
    [anon_sym_global] = ACTIONS(3517),
    [anon_sym_using] = ACTIONS(3517),
    [anon_sym_unsafe] = ACTIONS(3517),
    [anon_sym_static] = ACTIONS(3517),
    [anon_sym_LBRACK] = ACTIONS(3519),
    [anon_sym_LPAREN] = ACTIONS(3519),
    [anon_sym_return] = ACTIONS(3517),
    [anon_sym_namespace] = ACTIONS(3517),
    [anon_sym_class] = ACTIONS(3517),
    [anon_sym_ref] = ACTIONS(3517),
    [anon_sym_struct] = ACTIONS(3517),
    [anon_sym_enum] = ACTIONS(3517),
    [anon_sym_LBRACE] = ACTIONS(3519),
    [anon_sym_interface] = ACTIONS(3517),
    [anon_sym_delegate] = ACTIONS(3517),
    [anon_sym_record] = ACTIONS(3517),
    [anon_sym_abstract] = ACTIONS(3517),
    [anon_sym_async] = ACTIONS(3517),
    [anon_sym_const] = ACTIONS(3517),
    [anon_sym_file] = ACTIONS(3517),
    [anon_sym_fixed] = ACTIONS(3517),
    [anon_sym_internal] = ACTIONS(3517),
    [anon_sym_new] = ACTIONS(3517),
    [anon_sym_override] = ACTIONS(3517),
    [anon_sym_partial] = ACTIONS(3517),
    [anon_sym_private] = ACTIONS(3517),
    [anon_sym_protected] = ACTIONS(3517),
    [anon_sym_public] = ACTIONS(3517),
    [anon_sym_readonly] = ACTIONS(3517),
    [anon_sym_required] = ACTIONS(3517),
    [anon_sym_sealed] = ACTIONS(3517),
    [anon_sym_virtual] = ACTIONS(3517),
    [anon_sym_volatile] = ACTIONS(3517),
    [anon_sym_where] = ACTIONS(3517),
    [anon_sym_notnull] = ACTIONS(3517),
    [anon_sym_unmanaged] = ACTIONS(3517),
    [anon_sym_checked] = ACTIONS(3517),
    [anon_sym_BANG] = ACTIONS(3519),
    [anon_sym_TILDE] = ACTIONS(3519),
    [anon_sym_PLUS_PLUS] = ACTIONS(3519),
    [anon_sym_DASH_DASH] = ACTIONS(3519),
    [anon_sym_true] = ACTIONS(3517),
    [anon_sym_false] = ACTIONS(3517),
    [anon_sym_PLUS] = ACTIONS(3517),
    [anon_sym_DASH] = ACTIONS(3517),
    [anon_sym_STAR] = ACTIONS(3519),
    [anon_sym_CARET] = ACTIONS(3519),
    [anon_sym_AMP] = ACTIONS(3519),
    [anon_sym_this] = ACTIONS(3517),
    [anon_sym_scoped] = ACTIONS(3517),
    [anon_sym_var] = ACTIONS(3517),
    [sym_predefined_type] = ACTIONS(3517),
    [anon_sym_break] = ACTIONS(3517),
    [anon_sym_unchecked] = ACTIONS(3517),
    [anon_sym_continue] = ACTIONS(3517),
    [anon_sym_do] = ACTIONS(3517),
    [anon_sym_while] = ACTIONS(3517),
    [anon_sym_for] = ACTIONS(3517),
    [anon_sym_lock] = ACTIONS(3517),
    [anon_sym_yield] = ACTIONS(3517),
    [anon_sym_switch] = ACTIONS(3517),
    [anon_sym_default] = ACTIONS(3517),
    [anon_sym_throw] = ACTIONS(3517),
    [anon_sym_try] = ACTIONS(3517),
    [anon_sym_when] = ACTIONS(3517),
    [anon_sym_await] = ACTIONS(3517),
    [anon_sym_foreach] = ACTIONS(3517),
    [anon_sym_goto] = ACTIONS(3517),
    [anon_sym_if] = ACTIONS(3517),
    [anon_sym_DOT_DOT] = ACTIONS(3519),
    [anon_sym_from] = ACTIONS(3517),
    [anon_sym_into] = ACTIONS(3517),
    [anon_sym_join] = ACTIONS(3517),
    [anon_sym_on] = ACTIONS(3517),
    [anon_sym_equals] = ACTIONS(3517),
    [anon_sym_let] = ACTIONS(3517),
    [anon_sym_orderby] = ACTIONS(3517),
    [anon_sym_ascending] = ACTIONS(3517),
    [anon_sym_descending] = ACTIONS(3517),
    [anon_sym_group] = ACTIONS(3517),
    [anon_sym_by] = ACTIONS(3517),
    [anon_sym_select] = ACTIONS(3517),
    [anon_sym_DQUOTE] = ACTIONS(3517),
    [anon_sym_stackalloc] = ACTIONS(3517),
    [anon_sym_sizeof] = ACTIONS(3517),
    [anon_sym_typeof] = ACTIONS(3517),
    [anon_sym___makeref] = ACTIONS(3517),
    [anon_sym___reftype] = ACTIONS(3517),
    [anon_sym___refvalue] = ACTIONS(3517),
    [sym_null_literal] = ACTIONS(3517),
    [anon_sym_SQUOTE] = ACTIONS(3519),
    [sym_integer_literal] = ACTIONS(3517),
    [sym_real_literal] = ACTIONS(3519),
    [sym_verbatim_string_literal] = ACTIONS(3519),
    [sym_raw_string_literal] = ACTIONS(3519),
    [aux_sym_preproc_if_token1] = ACTIONS(3519),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3519),
    [sym_interpolation_verbatim_start] = ACTIONS(3519),
    [sym_interpolation_raw_start] = ACTIONS(3519),
  },
  [2574] = {
    [sym_preproc_region] = STATE(2574),
    [sym_preproc_endregion] = STATE(2574),
    [sym_preproc_line] = STATE(2574),
    [sym_preproc_pragma] = STATE(2574),
    [sym_preproc_nullable] = STATE(2574),
    [sym_preproc_error] = STATE(2574),
    [sym_preproc_define] = STATE(2574),
    [sym_preproc_undef] = STATE(2574),
    [ts_builtin_sym_end] = ACTIONS(3527),
    [sym__identifier_token] = ACTIONS(3525),
    [anon_sym_extern] = ACTIONS(3525),
    [anon_sym_alias] = ACTIONS(3525),
    [anon_sym_SEMI] = ACTIONS(3527),
    [anon_sym_global] = ACTIONS(3525),
    [anon_sym_using] = ACTIONS(3525),
    [anon_sym_unsafe] = ACTIONS(3525),
    [anon_sym_static] = ACTIONS(3525),
    [anon_sym_LBRACK] = ACTIONS(3527),
    [anon_sym_LPAREN] = ACTIONS(3527),
    [anon_sym_return] = ACTIONS(3525),
    [anon_sym_namespace] = ACTIONS(3525),
    [anon_sym_class] = ACTIONS(3525),
    [anon_sym_ref] = ACTIONS(3525),
    [anon_sym_struct] = ACTIONS(3525),
    [anon_sym_enum] = ACTIONS(3525),
    [anon_sym_LBRACE] = ACTIONS(3527),
    [anon_sym_interface] = ACTIONS(3525),
    [anon_sym_delegate] = ACTIONS(3525),
    [anon_sym_record] = ACTIONS(3525),
    [anon_sym_abstract] = ACTIONS(3525),
    [anon_sym_async] = ACTIONS(3525),
    [anon_sym_const] = ACTIONS(3525),
    [anon_sym_file] = ACTIONS(3525),
    [anon_sym_fixed] = ACTIONS(3525),
    [anon_sym_internal] = ACTIONS(3525),
    [anon_sym_new] = ACTIONS(3525),
    [anon_sym_override] = ACTIONS(3525),
    [anon_sym_partial] = ACTIONS(3525),
    [anon_sym_private] = ACTIONS(3525),
    [anon_sym_protected] = ACTIONS(3525),
    [anon_sym_public] = ACTIONS(3525),
    [anon_sym_readonly] = ACTIONS(3525),
    [anon_sym_required] = ACTIONS(3525),
    [anon_sym_sealed] = ACTIONS(3525),
    [anon_sym_virtual] = ACTIONS(3525),
    [anon_sym_volatile] = ACTIONS(3525),
    [anon_sym_where] = ACTIONS(3525),
    [anon_sym_notnull] = ACTIONS(3525),
    [anon_sym_unmanaged] = ACTIONS(3525),
    [anon_sym_checked] = ACTIONS(3525),
    [anon_sym_BANG] = ACTIONS(3527),
    [anon_sym_TILDE] = ACTIONS(3527),
    [anon_sym_PLUS_PLUS] = ACTIONS(3527),
    [anon_sym_DASH_DASH] = ACTIONS(3527),
    [anon_sym_true] = ACTIONS(3525),
    [anon_sym_false] = ACTIONS(3525),
    [anon_sym_PLUS] = ACTIONS(3525),
    [anon_sym_DASH] = ACTIONS(3525),
    [anon_sym_STAR] = ACTIONS(3527),
    [anon_sym_CARET] = ACTIONS(3527),
    [anon_sym_AMP] = ACTIONS(3527),
    [anon_sym_this] = ACTIONS(3525),
    [anon_sym_scoped] = ACTIONS(3525),
    [anon_sym_var] = ACTIONS(3525),
    [sym_predefined_type] = ACTIONS(3525),
    [anon_sym_break] = ACTIONS(3525),
    [anon_sym_unchecked] = ACTIONS(3525),
    [anon_sym_continue] = ACTIONS(3525),
    [anon_sym_do] = ACTIONS(3525),
    [anon_sym_while] = ACTIONS(3525),
    [anon_sym_for] = ACTIONS(3525),
    [anon_sym_lock] = ACTIONS(3525),
    [anon_sym_yield] = ACTIONS(3525),
    [anon_sym_switch] = ACTIONS(3525),
    [anon_sym_default] = ACTIONS(3525),
    [anon_sym_throw] = ACTIONS(3525),
    [anon_sym_try] = ACTIONS(3525),
    [anon_sym_when] = ACTIONS(3525),
    [anon_sym_await] = ACTIONS(3525),
    [anon_sym_foreach] = ACTIONS(3525),
    [anon_sym_goto] = ACTIONS(3525),
    [anon_sym_if] = ACTIONS(3525),
    [anon_sym_DOT_DOT] = ACTIONS(3527),
    [anon_sym_from] = ACTIONS(3525),
    [anon_sym_into] = ACTIONS(3525),
    [anon_sym_join] = ACTIONS(3525),
    [anon_sym_on] = ACTIONS(3525),
    [anon_sym_equals] = ACTIONS(3525),
    [anon_sym_let] = ACTIONS(3525),
    [anon_sym_orderby] = ACTIONS(3525),
    [anon_sym_ascending] = ACTIONS(3525),
    [anon_sym_descending] = ACTIONS(3525),
    [anon_sym_group] = ACTIONS(3525),
    [anon_sym_by] = ACTIONS(3525),
    [anon_sym_select] = ACTIONS(3525),
    [anon_sym_DQUOTE] = ACTIONS(3525),
    [anon_sym_stackalloc] = ACTIONS(3525),
    [anon_sym_sizeof] = ACTIONS(3525),
    [anon_sym_typeof] = ACTIONS(3525),
    [anon_sym___makeref] = ACTIONS(3525),
    [anon_sym___reftype] = ACTIONS(3525),
    [anon_sym___refvalue] = ACTIONS(3525),
    [sym_null_literal] = ACTIONS(3525),
    [anon_sym_SQUOTE] = ACTIONS(3527),
    [sym_integer_literal] = ACTIONS(3525),
    [sym_real_literal] = ACTIONS(3527),
    [sym_verbatim_string_literal] = ACTIONS(3527),
    [sym_raw_string_literal] = ACTIONS(3527),
    [aux_sym_preproc_if_token1] = ACTIONS(3527),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3527),
    [sym_interpolation_verbatim_start] = ACTIONS(3527),
    [sym_interpolation_raw_start] = ACTIONS(3527),
  },
  [2575] = {
    [sym_preproc_region] = STATE(2575),
    [sym_preproc_endregion] = STATE(2575),
    [sym_preproc_line] = STATE(2575),
    [sym_preproc_pragma] = STATE(2575),
    [sym_preproc_nullable] = STATE(2575),
    [sym_preproc_error] = STATE(2575),
    [sym_preproc_define] = STATE(2575),
    [sym_preproc_undef] = STATE(2575),
    [ts_builtin_sym_end] = ACTIONS(3531),
    [sym__identifier_token] = ACTIONS(3529),
    [anon_sym_extern] = ACTIONS(3529),
    [anon_sym_alias] = ACTIONS(3529),
    [anon_sym_SEMI] = ACTIONS(3531),
    [anon_sym_global] = ACTIONS(3529),
    [anon_sym_using] = ACTIONS(3529),
    [anon_sym_unsafe] = ACTIONS(3529),
    [anon_sym_static] = ACTIONS(3529),
    [anon_sym_LBRACK] = ACTIONS(3531),
    [anon_sym_LPAREN] = ACTIONS(3531),
    [anon_sym_return] = ACTIONS(3529),
    [anon_sym_namespace] = ACTIONS(3529),
    [anon_sym_class] = ACTIONS(3529),
    [anon_sym_ref] = ACTIONS(3529),
    [anon_sym_struct] = ACTIONS(3529),
    [anon_sym_enum] = ACTIONS(3529),
    [anon_sym_LBRACE] = ACTIONS(3531),
    [anon_sym_interface] = ACTIONS(3529),
    [anon_sym_delegate] = ACTIONS(3529),
    [anon_sym_record] = ACTIONS(3529),
    [anon_sym_abstract] = ACTIONS(3529),
    [anon_sym_async] = ACTIONS(3529),
    [anon_sym_const] = ACTIONS(3529),
    [anon_sym_file] = ACTIONS(3529),
    [anon_sym_fixed] = ACTIONS(3529),
    [anon_sym_internal] = ACTIONS(3529),
    [anon_sym_new] = ACTIONS(3529),
    [anon_sym_override] = ACTIONS(3529),
    [anon_sym_partial] = ACTIONS(3529),
    [anon_sym_private] = ACTIONS(3529),
    [anon_sym_protected] = ACTIONS(3529),
    [anon_sym_public] = ACTIONS(3529),
    [anon_sym_readonly] = ACTIONS(3529),
    [anon_sym_required] = ACTIONS(3529),
    [anon_sym_sealed] = ACTIONS(3529),
    [anon_sym_virtual] = ACTIONS(3529),
    [anon_sym_volatile] = ACTIONS(3529),
    [anon_sym_where] = ACTIONS(3529),
    [anon_sym_notnull] = ACTIONS(3529),
    [anon_sym_unmanaged] = ACTIONS(3529),
    [anon_sym_checked] = ACTIONS(3529),
    [anon_sym_BANG] = ACTIONS(3531),
    [anon_sym_TILDE] = ACTIONS(3531),
    [anon_sym_PLUS_PLUS] = ACTIONS(3531),
    [anon_sym_DASH_DASH] = ACTIONS(3531),
    [anon_sym_true] = ACTIONS(3529),
    [anon_sym_false] = ACTIONS(3529),
    [anon_sym_PLUS] = ACTIONS(3529),
    [anon_sym_DASH] = ACTIONS(3529),
    [anon_sym_STAR] = ACTIONS(3531),
    [anon_sym_CARET] = ACTIONS(3531),
    [anon_sym_AMP] = ACTIONS(3531),
    [anon_sym_this] = ACTIONS(3529),
    [anon_sym_scoped] = ACTIONS(3529),
    [anon_sym_var] = ACTIONS(3529),
    [sym_predefined_type] = ACTIONS(3529),
    [anon_sym_break] = ACTIONS(3529),
    [anon_sym_unchecked] = ACTIONS(3529),
    [anon_sym_continue] = ACTIONS(3529),
    [anon_sym_do] = ACTIONS(3529),
    [anon_sym_while] = ACTIONS(3529),
    [anon_sym_for] = ACTIONS(3529),
    [anon_sym_lock] = ACTIONS(3529),
    [anon_sym_yield] = ACTIONS(3529),
    [anon_sym_switch] = ACTIONS(3529),
    [anon_sym_default] = ACTIONS(3529),
    [anon_sym_throw] = ACTIONS(3529),
    [anon_sym_try] = ACTIONS(3529),
    [anon_sym_when] = ACTIONS(3529),
    [anon_sym_await] = ACTIONS(3529),
    [anon_sym_foreach] = ACTIONS(3529),
    [anon_sym_goto] = ACTIONS(3529),
    [anon_sym_if] = ACTIONS(3529),
    [anon_sym_DOT_DOT] = ACTIONS(3531),
    [anon_sym_from] = ACTIONS(3529),
    [anon_sym_into] = ACTIONS(3529),
    [anon_sym_join] = ACTIONS(3529),
    [anon_sym_on] = ACTIONS(3529),
    [anon_sym_equals] = ACTIONS(3529),
    [anon_sym_let] = ACTIONS(3529),
    [anon_sym_orderby] = ACTIONS(3529),
    [anon_sym_ascending] = ACTIONS(3529),
    [anon_sym_descending] = ACTIONS(3529),
    [anon_sym_group] = ACTIONS(3529),
    [anon_sym_by] = ACTIONS(3529),
    [anon_sym_select] = ACTIONS(3529),
    [anon_sym_DQUOTE] = ACTIONS(3529),
    [anon_sym_stackalloc] = ACTIONS(3529),
    [anon_sym_sizeof] = ACTIONS(3529),
    [anon_sym_typeof] = ACTIONS(3529),
    [anon_sym___makeref] = ACTIONS(3529),
    [anon_sym___reftype] = ACTIONS(3529),
    [anon_sym___refvalue] = ACTIONS(3529),
    [sym_null_literal] = ACTIONS(3529),
    [anon_sym_SQUOTE] = ACTIONS(3531),
    [sym_integer_literal] = ACTIONS(3529),
    [sym_real_literal] = ACTIONS(3531),
    [sym_verbatim_string_literal] = ACTIONS(3531),
    [sym_raw_string_literal] = ACTIONS(3531),
    [aux_sym_preproc_if_token1] = ACTIONS(3531),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3531),
    [sym_interpolation_verbatim_start] = ACTIONS(3531),
    [sym_interpolation_raw_start] = ACTIONS(3531),
  },
  [2576] = {
    [sym_preproc_region] = STATE(2576),
    [sym_preproc_endregion] = STATE(2576),
    [sym_preproc_line] = STATE(2576),
    [sym_preproc_pragma] = STATE(2576),
    [sym_preproc_nullable] = STATE(2576),
    [sym_preproc_error] = STATE(2576),
    [sym_preproc_define] = STATE(2576),
    [sym_preproc_undef] = STATE(2576),
    [ts_builtin_sym_end] = ACTIONS(3790),
    [sym__identifier_token] = ACTIONS(3788),
    [anon_sym_extern] = ACTIONS(3788),
    [anon_sym_alias] = ACTIONS(3788),
    [anon_sym_SEMI] = ACTIONS(3790),
    [anon_sym_global] = ACTIONS(3788),
    [anon_sym_using] = ACTIONS(3788),
    [anon_sym_unsafe] = ACTIONS(3788),
    [anon_sym_static] = ACTIONS(3788),
    [anon_sym_LBRACK] = ACTIONS(3790),
    [anon_sym_LPAREN] = ACTIONS(3790),
    [anon_sym_return] = ACTIONS(3788),
    [anon_sym_namespace] = ACTIONS(3788),
    [anon_sym_class] = ACTIONS(3788),
    [anon_sym_ref] = ACTIONS(3788),
    [anon_sym_struct] = ACTIONS(3788),
    [anon_sym_enum] = ACTIONS(3788),
    [anon_sym_LBRACE] = ACTIONS(3790),
    [anon_sym_interface] = ACTIONS(3788),
    [anon_sym_delegate] = ACTIONS(3788),
    [anon_sym_record] = ACTIONS(3788),
    [anon_sym_abstract] = ACTIONS(3788),
    [anon_sym_async] = ACTIONS(3788),
    [anon_sym_const] = ACTIONS(3788),
    [anon_sym_file] = ACTIONS(3788),
    [anon_sym_fixed] = ACTIONS(3788),
    [anon_sym_internal] = ACTIONS(3788),
    [anon_sym_new] = ACTIONS(3788),
    [anon_sym_override] = ACTIONS(3788),
    [anon_sym_partial] = ACTIONS(3788),
    [anon_sym_private] = ACTIONS(3788),
    [anon_sym_protected] = ACTIONS(3788),
    [anon_sym_public] = ACTIONS(3788),
    [anon_sym_readonly] = ACTIONS(3788),
    [anon_sym_required] = ACTIONS(3788),
    [anon_sym_sealed] = ACTIONS(3788),
    [anon_sym_virtual] = ACTIONS(3788),
    [anon_sym_volatile] = ACTIONS(3788),
    [anon_sym_where] = ACTIONS(3788),
    [anon_sym_notnull] = ACTIONS(3788),
    [anon_sym_unmanaged] = ACTIONS(3788),
    [anon_sym_checked] = ACTIONS(3788),
    [anon_sym_BANG] = ACTIONS(3790),
    [anon_sym_TILDE] = ACTIONS(3790),
    [anon_sym_PLUS_PLUS] = ACTIONS(3790),
    [anon_sym_DASH_DASH] = ACTIONS(3790),
    [anon_sym_true] = ACTIONS(3788),
    [anon_sym_false] = ACTIONS(3788),
    [anon_sym_PLUS] = ACTIONS(3788),
    [anon_sym_DASH] = ACTIONS(3788),
    [anon_sym_STAR] = ACTIONS(3790),
    [anon_sym_CARET] = ACTIONS(3790),
    [anon_sym_AMP] = ACTIONS(3790),
    [anon_sym_this] = ACTIONS(3788),
    [anon_sym_scoped] = ACTIONS(3788),
    [anon_sym_var] = ACTIONS(3788),
    [sym_predefined_type] = ACTIONS(3788),
    [anon_sym_break] = ACTIONS(3788),
    [anon_sym_unchecked] = ACTIONS(3788),
    [anon_sym_continue] = ACTIONS(3788),
    [anon_sym_do] = ACTIONS(3788),
    [anon_sym_while] = ACTIONS(3788),
    [anon_sym_for] = ACTIONS(3788),
    [anon_sym_lock] = ACTIONS(3788),
    [anon_sym_yield] = ACTIONS(3788),
    [anon_sym_switch] = ACTIONS(3788),
    [anon_sym_default] = ACTIONS(3788),
    [anon_sym_throw] = ACTIONS(3788),
    [anon_sym_try] = ACTIONS(3788),
    [anon_sym_when] = ACTIONS(3788),
    [anon_sym_await] = ACTIONS(3788),
    [anon_sym_foreach] = ACTIONS(3788),
    [anon_sym_goto] = ACTIONS(3788),
    [anon_sym_if] = ACTIONS(3788),
    [anon_sym_DOT_DOT] = ACTIONS(3790),
    [anon_sym_from] = ACTIONS(3788),
    [anon_sym_into] = ACTIONS(3788),
    [anon_sym_join] = ACTIONS(3788),
    [anon_sym_on] = ACTIONS(3788),
    [anon_sym_equals] = ACTIONS(3788),
    [anon_sym_let] = ACTIONS(3788),
    [anon_sym_orderby] = ACTIONS(3788),
    [anon_sym_ascending] = ACTIONS(3788),
    [anon_sym_descending] = ACTIONS(3788),
    [anon_sym_group] = ACTIONS(3788),
    [anon_sym_by] = ACTIONS(3788),
    [anon_sym_select] = ACTIONS(3788),
    [anon_sym_DQUOTE] = ACTIONS(3788),
    [anon_sym_stackalloc] = ACTIONS(3788),
    [anon_sym_sizeof] = ACTIONS(3788),
    [anon_sym_typeof] = ACTIONS(3788),
    [anon_sym___makeref] = ACTIONS(3788),
    [anon_sym___reftype] = ACTIONS(3788),
    [anon_sym___refvalue] = ACTIONS(3788),
    [sym_null_literal] = ACTIONS(3788),
    [anon_sym_SQUOTE] = ACTIONS(3790),
    [sym_integer_literal] = ACTIONS(3788),
    [sym_real_literal] = ACTIONS(3790),
    [sym_verbatim_string_literal] = ACTIONS(3790),
    [sym_raw_string_literal] = ACTIONS(3790),
    [aux_sym_preproc_if_token1] = ACTIONS(3790),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3790),
    [sym_interpolation_verbatim_start] = ACTIONS(3790),
    [sym_interpolation_raw_start] = ACTIONS(3790),
  },
  [2577] = {
    [sym_preproc_region] = STATE(2577),
    [sym_preproc_endregion] = STATE(2577),
    [sym_preproc_line] = STATE(2577),
    [sym_preproc_pragma] = STATE(2577),
    [sym_preproc_nullable] = STATE(2577),
    [sym_preproc_error] = STATE(2577),
    [sym_preproc_define] = STATE(2577),
    [sym_preproc_undef] = STATE(2577),
    [ts_builtin_sym_end] = ACTIONS(3671),
    [sym__identifier_token] = ACTIONS(3669),
    [anon_sym_extern] = ACTIONS(3669),
    [anon_sym_alias] = ACTIONS(3669),
    [anon_sym_SEMI] = ACTIONS(3671),
    [anon_sym_global] = ACTIONS(3669),
    [anon_sym_using] = ACTIONS(3669),
    [anon_sym_unsafe] = ACTIONS(3669),
    [anon_sym_static] = ACTIONS(3669),
    [anon_sym_LBRACK] = ACTIONS(3671),
    [anon_sym_LPAREN] = ACTIONS(3671),
    [anon_sym_return] = ACTIONS(3669),
    [anon_sym_namespace] = ACTIONS(3669),
    [anon_sym_class] = ACTIONS(3669),
    [anon_sym_ref] = ACTIONS(3669),
    [anon_sym_struct] = ACTIONS(3669),
    [anon_sym_enum] = ACTIONS(3669),
    [anon_sym_LBRACE] = ACTIONS(3671),
    [anon_sym_interface] = ACTIONS(3669),
    [anon_sym_delegate] = ACTIONS(3669),
    [anon_sym_record] = ACTIONS(3669),
    [anon_sym_abstract] = ACTIONS(3669),
    [anon_sym_async] = ACTIONS(3669),
    [anon_sym_const] = ACTIONS(3669),
    [anon_sym_file] = ACTIONS(3669),
    [anon_sym_fixed] = ACTIONS(3669),
    [anon_sym_internal] = ACTIONS(3669),
    [anon_sym_new] = ACTIONS(3669),
    [anon_sym_override] = ACTIONS(3669),
    [anon_sym_partial] = ACTIONS(3669),
    [anon_sym_private] = ACTIONS(3669),
    [anon_sym_protected] = ACTIONS(3669),
    [anon_sym_public] = ACTIONS(3669),
    [anon_sym_readonly] = ACTIONS(3669),
    [anon_sym_required] = ACTIONS(3669),
    [anon_sym_sealed] = ACTIONS(3669),
    [anon_sym_virtual] = ACTIONS(3669),
    [anon_sym_volatile] = ACTIONS(3669),
    [anon_sym_where] = ACTIONS(3669),
    [anon_sym_notnull] = ACTIONS(3669),
    [anon_sym_unmanaged] = ACTIONS(3669),
    [anon_sym_checked] = ACTIONS(3669),
    [anon_sym_BANG] = ACTIONS(3671),
    [anon_sym_TILDE] = ACTIONS(3671),
    [anon_sym_PLUS_PLUS] = ACTIONS(3671),
    [anon_sym_DASH_DASH] = ACTIONS(3671),
    [anon_sym_true] = ACTIONS(3669),
    [anon_sym_false] = ACTIONS(3669),
    [anon_sym_PLUS] = ACTIONS(3669),
    [anon_sym_DASH] = ACTIONS(3669),
    [anon_sym_STAR] = ACTIONS(3671),
    [anon_sym_CARET] = ACTIONS(3671),
    [anon_sym_AMP] = ACTIONS(3671),
    [anon_sym_this] = ACTIONS(3669),
    [anon_sym_scoped] = ACTIONS(3669),
    [anon_sym_var] = ACTIONS(3669),
    [sym_predefined_type] = ACTIONS(3669),
    [anon_sym_break] = ACTIONS(3669),
    [anon_sym_unchecked] = ACTIONS(3669),
    [anon_sym_continue] = ACTIONS(3669),
    [anon_sym_do] = ACTIONS(3669),
    [anon_sym_while] = ACTIONS(3669),
    [anon_sym_for] = ACTIONS(3669),
    [anon_sym_lock] = ACTIONS(3669),
    [anon_sym_yield] = ACTIONS(3669),
    [anon_sym_switch] = ACTIONS(3669),
    [anon_sym_default] = ACTIONS(3669),
    [anon_sym_throw] = ACTIONS(3669),
    [anon_sym_try] = ACTIONS(3669),
    [anon_sym_when] = ACTIONS(3669),
    [anon_sym_await] = ACTIONS(3669),
    [anon_sym_foreach] = ACTIONS(3669),
    [anon_sym_goto] = ACTIONS(3669),
    [anon_sym_if] = ACTIONS(3669),
    [anon_sym_DOT_DOT] = ACTIONS(3671),
    [anon_sym_from] = ACTIONS(3669),
    [anon_sym_into] = ACTIONS(3669),
    [anon_sym_join] = ACTIONS(3669),
    [anon_sym_on] = ACTIONS(3669),
    [anon_sym_equals] = ACTIONS(3669),
    [anon_sym_let] = ACTIONS(3669),
    [anon_sym_orderby] = ACTIONS(3669),
    [anon_sym_ascending] = ACTIONS(3669),
    [anon_sym_descending] = ACTIONS(3669),
    [anon_sym_group] = ACTIONS(3669),
    [anon_sym_by] = ACTIONS(3669),
    [anon_sym_select] = ACTIONS(3669),
    [anon_sym_DQUOTE] = ACTIONS(3669),
    [anon_sym_stackalloc] = ACTIONS(3669),
    [anon_sym_sizeof] = ACTIONS(3669),
    [anon_sym_typeof] = ACTIONS(3669),
    [anon_sym___makeref] = ACTIONS(3669),
    [anon_sym___reftype] = ACTIONS(3669),
    [anon_sym___refvalue] = ACTIONS(3669),
    [sym_null_literal] = ACTIONS(3669),
    [anon_sym_SQUOTE] = ACTIONS(3671),
    [sym_integer_literal] = ACTIONS(3669),
    [sym_real_literal] = ACTIONS(3671),
    [sym_verbatim_string_literal] = ACTIONS(3671),
    [sym_raw_string_literal] = ACTIONS(3671),
    [aux_sym_preproc_if_token1] = ACTIONS(3671),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3671),
    [sym_interpolation_verbatim_start] = ACTIONS(3671),
    [sym_interpolation_raw_start] = ACTIONS(3671),
  },
  [2578] = {
    [sym_preproc_region] = STATE(2578),
    [sym_preproc_endregion] = STATE(2578),
    [sym_preproc_line] = STATE(2578),
    [sym_preproc_pragma] = STATE(2578),
    [sym_preproc_nullable] = STATE(2578),
    [sym_preproc_error] = STATE(2578),
    [sym_preproc_define] = STATE(2578),
    [sym_preproc_undef] = STATE(2578),
    [ts_builtin_sym_end] = ACTIONS(3535),
    [sym__identifier_token] = ACTIONS(3533),
    [anon_sym_extern] = ACTIONS(3533),
    [anon_sym_alias] = ACTIONS(3533),
    [anon_sym_SEMI] = ACTIONS(3535),
    [anon_sym_global] = ACTIONS(3533),
    [anon_sym_using] = ACTIONS(3533),
    [anon_sym_unsafe] = ACTIONS(3533),
    [anon_sym_static] = ACTIONS(3533),
    [anon_sym_LBRACK] = ACTIONS(3535),
    [anon_sym_LPAREN] = ACTIONS(3535),
    [anon_sym_return] = ACTIONS(3533),
    [anon_sym_namespace] = ACTIONS(3533),
    [anon_sym_class] = ACTIONS(3533),
    [anon_sym_ref] = ACTIONS(3533),
    [anon_sym_struct] = ACTIONS(3533),
    [anon_sym_enum] = ACTIONS(3533),
    [anon_sym_LBRACE] = ACTIONS(3535),
    [anon_sym_interface] = ACTIONS(3533),
    [anon_sym_delegate] = ACTIONS(3533),
    [anon_sym_record] = ACTIONS(3533),
    [anon_sym_abstract] = ACTIONS(3533),
    [anon_sym_async] = ACTIONS(3533),
    [anon_sym_const] = ACTIONS(3533),
    [anon_sym_file] = ACTIONS(3533),
    [anon_sym_fixed] = ACTIONS(3533),
    [anon_sym_internal] = ACTIONS(3533),
    [anon_sym_new] = ACTIONS(3533),
    [anon_sym_override] = ACTIONS(3533),
    [anon_sym_partial] = ACTIONS(3533),
    [anon_sym_private] = ACTIONS(3533),
    [anon_sym_protected] = ACTIONS(3533),
    [anon_sym_public] = ACTIONS(3533),
    [anon_sym_readonly] = ACTIONS(3533),
    [anon_sym_required] = ACTIONS(3533),
    [anon_sym_sealed] = ACTIONS(3533),
    [anon_sym_virtual] = ACTIONS(3533),
    [anon_sym_volatile] = ACTIONS(3533),
    [anon_sym_where] = ACTIONS(3533),
    [anon_sym_notnull] = ACTIONS(3533),
    [anon_sym_unmanaged] = ACTIONS(3533),
    [anon_sym_checked] = ACTIONS(3533),
    [anon_sym_BANG] = ACTIONS(3535),
    [anon_sym_TILDE] = ACTIONS(3535),
    [anon_sym_PLUS_PLUS] = ACTIONS(3535),
    [anon_sym_DASH_DASH] = ACTIONS(3535),
    [anon_sym_true] = ACTIONS(3533),
    [anon_sym_false] = ACTIONS(3533),
    [anon_sym_PLUS] = ACTIONS(3533),
    [anon_sym_DASH] = ACTIONS(3533),
    [anon_sym_STAR] = ACTIONS(3535),
    [anon_sym_CARET] = ACTIONS(3535),
    [anon_sym_AMP] = ACTIONS(3535),
    [anon_sym_this] = ACTIONS(3533),
    [anon_sym_scoped] = ACTIONS(3533),
    [anon_sym_var] = ACTIONS(3533),
    [sym_predefined_type] = ACTIONS(3533),
    [anon_sym_break] = ACTIONS(3533),
    [anon_sym_unchecked] = ACTIONS(3533),
    [anon_sym_continue] = ACTIONS(3533),
    [anon_sym_do] = ACTIONS(3533),
    [anon_sym_while] = ACTIONS(3533),
    [anon_sym_for] = ACTIONS(3533),
    [anon_sym_lock] = ACTIONS(3533),
    [anon_sym_yield] = ACTIONS(3533),
    [anon_sym_switch] = ACTIONS(3533),
    [anon_sym_default] = ACTIONS(3533),
    [anon_sym_throw] = ACTIONS(3533),
    [anon_sym_try] = ACTIONS(3533),
    [anon_sym_when] = ACTIONS(3533),
    [anon_sym_await] = ACTIONS(3533),
    [anon_sym_foreach] = ACTIONS(3533),
    [anon_sym_goto] = ACTIONS(3533),
    [anon_sym_if] = ACTIONS(3533),
    [anon_sym_DOT_DOT] = ACTIONS(3535),
    [anon_sym_from] = ACTIONS(3533),
    [anon_sym_into] = ACTIONS(3533),
    [anon_sym_join] = ACTIONS(3533),
    [anon_sym_on] = ACTIONS(3533),
    [anon_sym_equals] = ACTIONS(3533),
    [anon_sym_let] = ACTIONS(3533),
    [anon_sym_orderby] = ACTIONS(3533),
    [anon_sym_ascending] = ACTIONS(3533),
    [anon_sym_descending] = ACTIONS(3533),
    [anon_sym_group] = ACTIONS(3533),
    [anon_sym_by] = ACTIONS(3533),
    [anon_sym_select] = ACTIONS(3533),
    [anon_sym_DQUOTE] = ACTIONS(3533),
    [anon_sym_stackalloc] = ACTIONS(3533),
    [anon_sym_sizeof] = ACTIONS(3533),
    [anon_sym_typeof] = ACTIONS(3533),
    [anon_sym___makeref] = ACTIONS(3533),
    [anon_sym___reftype] = ACTIONS(3533),
    [anon_sym___refvalue] = ACTIONS(3533),
    [sym_null_literal] = ACTIONS(3533),
    [anon_sym_SQUOTE] = ACTIONS(3535),
    [sym_integer_literal] = ACTIONS(3533),
    [sym_real_literal] = ACTIONS(3535),
    [sym_verbatim_string_literal] = ACTIONS(3535),
    [sym_raw_string_literal] = ACTIONS(3535),
    [aux_sym_preproc_if_token1] = ACTIONS(3535),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3535),
    [sym_interpolation_verbatim_start] = ACTIONS(3535),
    [sym_interpolation_raw_start] = ACTIONS(3535),
  },
  [2579] = {
    [sym_preproc_region] = STATE(2579),
    [sym_preproc_endregion] = STATE(2579),
    [sym_preproc_line] = STATE(2579),
    [sym_preproc_pragma] = STATE(2579),
    [sym_preproc_nullable] = STATE(2579),
    [sym_preproc_error] = STATE(2579),
    [sym_preproc_define] = STATE(2579),
    [sym_preproc_undef] = STATE(2579),
    [ts_builtin_sym_end] = ACTIONS(3862),
    [sym__identifier_token] = ACTIONS(3860),
    [anon_sym_extern] = ACTIONS(3860),
    [anon_sym_alias] = ACTIONS(3860),
    [anon_sym_SEMI] = ACTIONS(3862),
    [anon_sym_global] = ACTIONS(3860),
    [anon_sym_using] = ACTIONS(3860),
    [anon_sym_unsafe] = ACTIONS(3860),
    [anon_sym_static] = ACTIONS(3860),
    [anon_sym_LBRACK] = ACTIONS(3862),
    [anon_sym_LPAREN] = ACTIONS(3862),
    [anon_sym_return] = ACTIONS(3860),
    [anon_sym_namespace] = ACTIONS(3860),
    [anon_sym_class] = ACTIONS(3860),
    [anon_sym_ref] = ACTIONS(3860),
    [anon_sym_struct] = ACTIONS(3860),
    [anon_sym_enum] = ACTIONS(3860),
    [anon_sym_LBRACE] = ACTIONS(3862),
    [anon_sym_interface] = ACTIONS(3860),
    [anon_sym_delegate] = ACTIONS(3860),
    [anon_sym_record] = ACTIONS(3860),
    [anon_sym_abstract] = ACTIONS(3860),
    [anon_sym_async] = ACTIONS(3860),
    [anon_sym_const] = ACTIONS(3860),
    [anon_sym_file] = ACTIONS(3860),
    [anon_sym_fixed] = ACTIONS(3860),
    [anon_sym_internal] = ACTIONS(3860),
    [anon_sym_new] = ACTIONS(3860),
    [anon_sym_override] = ACTIONS(3860),
    [anon_sym_partial] = ACTIONS(3860),
    [anon_sym_private] = ACTIONS(3860),
    [anon_sym_protected] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3860),
    [anon_sym_readonly] = ACTIONS(3860),
    [anon_sym_required] = ACTIONS(3860),
    [anon_sym_sealed] = ACTIONS(3860),
    [anon_sym_virtual] = ACTIONS(3860),
    [anon_sym_volatile] = ACTIONS(3860),
    [anon_sym_where] = ACTIONS(3860),
    [anon_sym_notnull] = ACTIONS(3860),
    [anon_sym_unmanaged] = ACTIONS(3860),
    [anon_sym_checked] = ACTIONS(3860),
    [anon_sym_BANG] = ACTIONS(3862),
    [anon_sym_TILDE] = ACTIONS(3862),
    [anon_sym_PLUS_PLUS] = ACTIONS(3862),
    [anon_sym_DASH_DASH] = ACTIONS(3862),
    [anon_sym_true] = ACTIONS(3860),
    [anon_sym_false] = ACTIONS(3860),
    [anon_sym_PLUS] = ACTIONS(3860),
    [anon_sym_DASH] = ACTIONS(3860),
    [anon_sym_STAR] = ACTIONS(3862),
    [anon_sym_CARET] = ACTIONS(3862),
    [anon_sym_AMP] = ACTIONS(3862),
    [anon_sym_this] = ACTIONS(3860),
    [anon_sym_scoped] = ACTIONS(3860),
    [anon_sym_var] = ACTIONS(3860),
    [sym_predefined_type] = ACTIONS(3860),
    [anon_sym_break] = ACTIONS(3860),
    [anon_sym_unchecked] = ACTIONS(3860),
    [anon_sym_continue] = ACTIONS(3860),
    [anon_sym_do] = ACTIONS(3860),
    [anon_sym_while] = ACTIONS(3860),
    [anon_sym_for] = ACTIONS(3860),
    [anon_sym_lock] = ACTIONS(3860),
    [anon_sym_yield] = ACTIONS(3860),
    [anon_sym_switch] = ACTIONS(3860),
    [anon_sym_default] = ACTIONS(3860),
    [anon_sym_throw] = ACTIONS(3860),
    [anon_sym_try] = ACTIONS(3860),
    [anon_sym_when] = ACTIONS(3860),
    [anon_sym_await] = ACTIONS(3860),
    [anon_sym_foreach] = ACTIONS(3860),
    [anon_sym_goto] = ACTIONS(3860),
    [anon_sym_if] = ACTIONS(3860),
    [anon_sym_DOT_DOT] = ACTIONS(3862),
    [anon_sym_from] = ACTIONS(3860),
    [anon_sym_into] = ACTIONS(3860),
    [anon_sym_join] = ACTIONS(3860),
    [anon_sym_on] = ACTIONS(3860),
    [anon_sym_equals] = ACTIONS(3860),
    [anon_sym_let] = ACTIONS(3860),
    [anon_sym_orderby] = ACTIONS(3860),
    [anon_sym_ascending] = ACTIONS(3860),
    [anon_sym_descending] = ACTIONS(3860),
    [anon_sym_group] = ACTIONS(3860),
    [anon_sym_by] = ACTIONS(3860),
    [anon_sym_select] = ACTIONS(3860),
    [anon_sym_DQUOTE] = ACTIONS(3860),
    [anon_sym_stackalloc] = ACTIONS(3860),
    [anon_sym_sizeof] = ACTIONS(3860),
    [anon_sym_typeof] = ACTIONS(3860),
    [anon_sym___makeref] = ACTIONS(3860),
    [anon_sym___reftype] = ACTIONS(3860),
    [anon_sym___refvalue] = ACTIONS(3860),
    [sym_null_literal] = ACTIONS(3860),
    [anon_sym_SQUOTE] = ACTIONS(3862),
    [sym_integer_literal] = ACTIONS(3860),
    [sym_real_literal] = ACTIONS(3862),
    [sym_verbatim_string_literal] = ACTIONS(3862),
    [sym_raw_string_literal] = ACTIONS(3862),
    [aux_sym_preproc_if_token1] = ACTIONS(3862),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3862),
    [sym_interpolation_verbatim_start] = ACTIONS(3862),
    [sym_interpolation_raw_start] = ACTIONS(3862),
  },
  [2580] = {
    [sym_preproc_region] = STATE(2580),
    [sym_preproc_endregion] = STATE(2580),
    [sym_preproc_line] = STATE(2580),
    [sym_preproc_pragma] = STATE(2580),
    [sym_preproc_nullable] = STATE(2580),
    [sym_preproc_error] = STATE(2580),
    [sym_preproc_define] = STATE(2580),
    [sym_preproc_undef] = STATE(2580),
    [ts_builtin_sym_end] = ACTIONS(3419),
    [sym__identifier_token] = ACTIONS(3417),
    [anon_sym_extern] = ACTIONS(3417),
    [anon_sym_alias] = ACTIONS(3417),
    [anon_sym_SEMI] = ACTIONS(3419),
    [anon_sym_global] = ACTIONS(3417),
    [anon_sym_using] = ACTIONS(3417),
    [anon_sym_unsafe] = ACTIONS(3417),
    [anon_sym_static] = ACTIONS(3417),
    [anon_sym_LBRACK] = ACTIONS(3419),
    [anon_sym_LPAREN] = ACTIONS(3419),
    [anon_sym_return] = ACTIONS(3417),
    [anon_sym_namespace] = ACTIONS(3417),
    [anon_sym_class] = ACTIONS(3417),
    [anon_sym_ref] = ACTIONS(3417),
    [anon_sym_struct] = ACTIONS(3417),
    [anon_sym_enum] = ACTIONS(3417),
    [anon_sym_LBRACE] = ACTIONS(3419),
    [anon_sym_interface] = ACTIONS(3417),
    [anon_sym_delegate] = ACTIONS(3417),
    [anon_sym_record] = ACTIONS(3417),
    [anon_sym_abstract] = ACTIONS(3417),
    [anon_sym_async] = ACTIONS(3417),
    [anon_sym_const] = ACTIONS(3417),
    [anon_sym_file] = ACTIONS(3417),
    [anon_sym_fixed] = ACTIONS(3417),
    [anon_sym_internal] = ACTIONS(3417),
    [anon_sym_new] = ACTIONS(3417),
    [anon_sym_override] = ACTIONS(3417),
    [anon_sym_partial] = ACTIONS(3417),
    [anon_sym_private] = ACTIONS(3417),
    [anon_sym_protected] = ACTIONS(3417),
    [anon_sym_public] = ACTIONS(3417),
    [anon_sym_readonly] = ACTIONS(3417),
    [anon_sym_required] = ACTIONS(3417),
    [anon_sym_sealed] = ACTIONS(3417),
    [anon_sym_virtual] = ACTIONS(3417),
    [anon_sym_volatile] = ACTIONS(3417),
    [anon_sym_where] = ACTIONS(3417),
    [anon_sym_notnull] = ACTIONS(3417),
    [anon_sym_unmanaged] = ACTIONS(3417),
    [anon_sym_checked] = ACTIONS(3417),
    [anon_sym_BANG] = ACTIONS(3419),
    [anon_sym_TILDE] = ACTIONS(3419),
    [anon_sym_PLUS_PLUS] = ACTIONS(3419),
    [anon_sym_DASH_DASH] = ACTIONS(3419),
    [anon_sym_true] = ACTIONS(3417),
    [anon_sym_false] = ACTIONS(3417),
    [anon_sym_PLUS] = ACTIONS(3417),
    [anon_sym_DASH] = ACTIONS(3417),
    [anon_sym_STAR] = ACTIONS(3419),
    [anon_sym_CARET] = ACTIONS(3419),
    [anon_sym_AMP] = ACTIONS(3419),
    [anon_sym_this] = ACTIONS(3417),
    [anon_sym_scoped] = ACTIONS(3417),
    [anon_sym_var] = ACTIONS(3417),
    [sym_predefined_type] = ACTIONS(3417),
    [anon_sym_break] = ACTIONS(3417),
    [anon_sym_unchecked] = ACTIONS(3417),
    [anon_sym_continue] = ACTIONS(3417),
    [anon_sym_do] = ACTIONS(3417),
    [anon_sym_while] = ACTIONS(3417),
    [anon_sym_for] = ACTIONS(3417),
    [anon_sym_lock] = ACTIONS(3417),
    [anon_sym_yield] = ACTIONS(3417),
    [anon_sym_switch] = ACTIONS(3417),
    [anon_sym_default] = ACTIONS(3417),
    [anon_sym_throw] = ACTIONS(3417),
    [anon_sym_try] = ACTIONS(3417),
    [anon_sym_when] = ACTIONS(3417),
    [anon_sym_await] = ACTIONS(3417),
    [anon_sym_foreach] = ACTIONS(3417),
    [anon_sym_goto] = ACTIONS(3417),
    [anon_sym_if] = ACTIONS(3417),
    [anon_sym_DOT_DOT] = ACTIONS(3419),
    [anon_sym_from] = ACTIONS(3417),
    [anon_sym_into] = ACTIONS(3417),
    [anon_sym_join] = ACTIONS(3417),
    [anon_sym_on] = ACTIONS(3417),
    [anon_sym_equals] = ACTIONS(3417),
    [anon_sym_let] = ACTIONS(3417),
    [anon_sym_orderby] = ACTIONS(3417),
    [anon_sym_ascending] = ACTIONS(3417),
    [anon_sym_descending] = ACTIONS(3417),
    [anon_sym_group] = ACTIONS(3417),
    [anon_sym_by] = ACTIONS(3417),
    [anon_sym_select] = ACTIONS(3417),
    [anon_sym_DQUOTE] = ACTIONS(3417),
    [anon_sym_stackalloc] = ACTIONS(3417),
    [anon_sym_sizeof] = ACTIONS(3417),
    [anon_sym_typeof] = ACTIONS(3417),
    [anon_sym___makeref] = ACTIONS(3417),
    [anon_sym___reftype] = ACTIONS(3417),
    [anon_sym___refvalue] = ACTIONS(3417),
    [sym_null_literal] = ACTIONS(3417),
    [anon_sym_SQUOTE] = ACTIONS(3419),
    [sym_integer_literal] = ACTIONS(3417),
    [sym_real_literal] = ACTIONS(3419),
    [sym_verbatim_string_literal] = ACTIONS(3419),
    [sym_raw_string_literal] = ACTIONS(3419),
    [aux_sym_preproc_if_token1] = ACTIONS(3419),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3419),
    [sym_interpolation_verbatim_start] = ACTIONS(3419),
    [sym_interpolation_raw_start] = ACTIONS(3419),
  },
  [2581] = {
    [sym_preproc_region] = STATE(2581),
    [sym_preproc_endregion] = STATE(2581),
    [sym_preproc_line] = STATE(2581),
    [sym_preproc_pragma] = STATE(2581),
    [sym_preproc_nullable] = STATE(2581),
    [sym_preproc_error] = STATE(2581),
    [sym_preproc_define] = STATE(2581),
    [sym_preproc_undef] = STATE(2581),
    [ts_builtin_sym_end] = ACTIONS(3463),
    [sym__identifier_token] = ACTIONS(3461),
    [anon_sym_extern] = ACTIONS(3461),
    [anon_sym_alias] = ACTIONS(3461),
    [anon_sym_SEMI] = ACTIONS(3463),
    [anon_sym_global] = ACTIONS(3461),
    [anon_sym_using] = ACTIONS(3461),
    [anon_sym_unsafe] = ACTIONS(3461),
    [anon_sym_static] = ACTIONS(3461),
    [anon_sym_LBRACK] = ACTIONS(3463),
    [anon_sym_LPAREN] = ACTIONS(3463),
    [anon_sym_return] = ACTIONS(3461),
    [anon_sym_namespace] = ACTIONS(3461),
    [anon_sym_class] = ACTIONS(3461),
    [anon_sym_ref] = ACTIONS(3461),
    [anon_sym_struct] = ACTIONS(3461),
    [anon_sym_enum] = ACTIONS(3461),
    [anon_sym_LBRACE] = ACTIONS(3463),
    [anon_sym_interface] = ACTIONS(3461),
    [anon_sym_delegate] = ACTIONS(3461),
    [anon_sym_record] = ACTIONS(3461),
    [anon_sym_abstract] = ACTIONS(3461),
    [anon_sym_async] = ACTIONS(3461),
    [anon_sym_const] = ACTIONS(3461),
    [anon_sym_file] = ACTIONS(3461),
    [anon_sym_fixed] = ACTIONS(3461),
    [anon_sym_internal] = ACTIONS(3461),
    [anon_sym_new] = ACTIONS(3461),
    [anon_sym_override] = ACTIONS(3461),
    [anon_sym_partial] = ACTIONS(3461),
    [anon_sym_private] = ACTIONS(3461),
    [anon_sym_protected] = ACTIONS(3461),
    [anon_sym_public] = ACTIONS(3461),
    [anon_sym_readonly] = ACTIONS(3461),
    [anon_sym_required] = ACTIONS(3461),
    [anon_sym_sealed] = ACTIONS(3461),
    [anon_sym_virtual] = ACTIONS(3461),
    [anon_sym_volatile] = ACTIONS(3461),
    [anon_sym_where] = ACTIONS(3461),
    [anon_sym_notnull] = ACTIONS(3461),
    [anon_sym_unmanaged] = ACTIONS(3461),
    [anon_sym_checked] = ACTIONS(3461),
    [anon_sym_BANG] = ACTIONS(3463),
    [anon_sym_TILDE] = ACTIONS(3463),
    [anon_sym_PLUS_PLUS] = ACTIONS(3463),
    [anon_sym_DASH_DASH] = ACTIONS(3463),
    [anon_sym_true] = ACTIONS(3461),
    [anon_sym_false] = ACTIONS(3461),
    [anon_sym_PLUS] = ACTIONS(3461),
    [anon_sym_DASH] = ACTIONS(3461),
    [anon_sym_STAR] = ACTIONS(3463),
    [anon_sym_CARET] = ACTIONS(3463),
    [anon_sym_AMP] = ACTIONS(3463),
    [anon_sym_this] = ACTIONS(3461),
    [anon_sym_scoped] = ACTIONS(3461),
    [anon_sym_var] = ACTIONS(3461),
    [sym_predefined_type] = ACTIONS(3461),
    [anon_sym_break] = ACTIONS(3461),
    [anon_sym_unchecked] = ACTIONS(3461),
    [anon_sym_continue] = ACTIONS(3461),
    [anon_sym_do] = ACTIONS(3461),
    [anon_sym_while] = ACTIONS(3461),
    [anon_sym_for] = ACTIONS(3461),
    [anon_sym_lock] = ACTIONS(3461),
    [anon_sym_yield] = ACTIONS(3461),
    [anon_sym_switch] = ACTIONS(3461),
    [anon_sym_default] = ACTIONS(3461),
    [anon_sym_throw] = ACTIONS(3461),
    [anon_sym_try] = ACTIONS(3461),
    [anon_sym_when] = ACTIONS(3461),
    [anon_sym_await] = ACTIONS(3461),
    [anon_sym_foreach] = ACTIONS(3461),
    [anon_sym_goto] = ACTIONS(3461),
    [anon_sym_if] = ACTIONS(3461),
    [anon_sym_DOT_DOT] = ACTIONS(3463),
    [anon_sym_from] = ACTIONS(3461),
    [anon_sym_into] = ACTIONS(3461),
    [anon_sym_join] = ACTIONS(3461),
    [anon_sym_on] = ACTIONS(3461),
    [anon_sym_equals] = ACTIONS(3461),
    [anon_sym_let] = ACTIONS(3461),
    [anon_sym_orderby] = ACTIONS(3461),
    [anon_sym_ascending] = ACTIONS(3461),
    [anon_sym_descending] = ACTIONS(3461),
    [anon_sym_group] = ACTIONS(3461),
    [anon_sym_by] = ACTIONS(3461),
    [anon_sym_select] = ACTIONS(3461),
    [anon_sym_DQUOTE] = ACTIONS(3461),
    [anon_sym_stackalloc] = ACTIONS(3461),
    [anon_sym_sizeof] = ACTIONS(3461),
    [anon_sym_typeof] = ACTIONS(3461),
    [anon_sym___makeref] = ACTIONS(3461),
    [anon_sym___reftype] = ACTIONS(3461),
    [anon_sym___refvalue] = ACTIONS(3461),
    [sym_null_literal] = ACTIONS(3461),
    [anon_sym_SQUOTE] = ACTIONS(3463),
    [sym_integer_literal] = ACTIONS(3461),
    [sym_real_literal] = ACTIONS(3463),
    [sym_verbatim_string_literal] = ACTIONS(3463),
    [sym_raw_string_literal] = ACTIONS(3463),
    [aux_sym_preproc_if_token1] = ACTIONS(3463),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3463),
    [sym_interpolation_verbatim_start] = ACTIONS(3463),
    [sym_interpolation_raw_start] = ACTIONS(3463),
  },
  [2582] = {
    [sym_preproc_region] = STATE(2582),
    [sym_preproc_endregion] = STATE(2582),
    [sym_preproc_line] = STATE(2582),
    [sym_preproc_pragma] = STATE(2582),
    [sym_preproc_nullable] = STATE(2582),
    [sym_preproc_error] = STATE(2582),
    [sym_preproc_define] = STATE(2582),
    [sym_preproc_undef] = STATE(2582),
    [ts_builtin_sym_end] = ACTIONS(3802),
    [sym__identifier_token] = ACTIONS(3800),
    [anon_sym_extern] = ACTIONS(3800),
    [anon_sym_alias] = ACTIONS(3800),
    [anon_sym_SEMI] = ACTIONS(3802),
    [anon_sym_global] = ACTIONS(3800),
    [anon_sym_using] = ACTIONS(3800),
    [anon_sym_unsafe] = ACTIONS(3800),
    [anon_sym_static] = ACTIONS(3800),
    [anon_sym_LBRACK] = ACTIONS(3802),
    [anon_sym_LPAREN] = ACTIONS(3802),
    [anon_sym_return] = ACTIONS(3800),
    [anon_sym_namespace] = ACTIONS(3800),
    [anon_sym_class] = ACTIONS(3800),
    [anon_sym_ref] = ACTIONS(3800),
    [anon_sym_struct] = ACTIONS(3800),
    [anon_sym_enum] = ACTIONS(3800),
    [anon_sym_LBRACE] = ACTIONS(3802),
    [anon_sym_interface] = ACTIONS(3800),
    [anon_sym_delegate] = ACTIONS(3800),
    [anon_sym_record] = ACTIONS(3800),
    [anon_sym_abstract] = ACTIONS(3800),
    [anon_sym_async] = ACTIONS(3800),
    [anon_sym_const] = ACTIONS(3800),
    [anon_sym_file] = ACTIONS(3800),
    [anon_sym_fixed] = ACTIONS(3800),
    [anon_sym_internal] = ACTIONS(3800),
    [anon_sym_new] = ACTIONS(3800),
    [anon_sym_override] = ACTIONS(3800),
    [anon_sym_partial] = ACTIONS(3800),
    [anon_sym_private] = ACTIONS(3800),
    [anon_sym_protected] = ACTIONS(3800),
    [anon_sym_public] = ACTIONS(3800),
    [anon_sym_readonly] = ACTIONS(3800),
    [anon_sym_required] = ACTIONS(3800),
    [anon_sym_sealed] = ACTIONS(3800),
    [anon_sym_virtual] = ACTIONS(3800),
    [anon_sym_volatile] = ACTIONS(3800),
    [anon_sym_where] = ACTIONS(3800),
    [anon_sym_notnull] = ACTIONS(3800),
    [anon_sym_unmanaged] = ACTIONS(3800),
    [anon_sym_checked] = ACTIONS(3800),
    [anon_sym_BANG] = ACTIONS(3802),
    [anon_sym_TILDE] = ACTIONS(3802),
    [anon_sym_PLUS_PLUS] = ACTIONS(3802),
    [anon_sym_DASH_DASH] = ACTIONS(3802),
    [anon_sym_true] = ACTIONS(3800),
    [anon_sym_false] = ACTIONS(3800),
    [anon_sym_PLUS] = ACTIONS(3800),
    [anon_sym_DASH] = ACTIONS(3800),
    [anon_sym_STAR] = ACTIONS(3802),
    [anon_sym_CARET] = ACTIONS(3802),
    [anon_sym_AMP] = ACTIONS(3802),
    [anon_sym_this] = ACTIONS(3800),
    [anon_sym_scoped] = ACTIONS(3800),
    [anon_sym_var] = ACTIONS(3800),
    [sym_predefined_type] = ACTIONS(3800),
    [anon_sym_break] = ACTIONS(3800),
    [anon_sym_unchecked] = ACTIONS(3800),
    [anon_sym_continue] = ACTIONS(3800),
    [anon_sym_do] = ACTIONS(3800),
    [anon_sym_while] = ACTIONS(3800),
    [anon_sym_for] = ACTIONS(3800),
    [anon_sym_lock] = ACTIONS(3800),
    [anon_sym_yield] = ACTIONS(3800),
    [anon_sym_switch] = ACTIONS(3800),
    [anon_sym_default] = ACTIONS(3800),
    [anon_sym_throw] = ACTIONS(3800),
    [anon_sym_try] = ACTIONS(3800),
    [anon_sym_when] = ACTIONS(3800),
    [anon_sym_await] = ACTIONS(3800),
    [anon_sym_foreach] = ACTIONS(3800),
    [anon_sym_goto] = ACTIONS(3800),
    [anon_sym_if] = ACTIONS(3800),
    [anon_sym_DOT_DOT] = ACTIONS(3802),
    [anon_sym_from] = ACTIONS(3800),
    [anon_sym_into] = ACTIONS(3800),
    [anon_sym_join] = ACTIONS(3800),
    [anon_sym_on] = ACTIONS(3800),
    [anon_sym_equals] = ACTIONS(3800),
    [anon_sym_let] = ACTIONS(3800),
    [anon_sym_orderby] = ACTIONS(3800),
    [anon_sym_ascending] = ACTIONS(3800),
    [anon_sym_descending] = ACTIONS(3800),
    [anon_sym_group] = ACTIONS(3800),
    [anon_sym_by] = ACTIONS(3800),
    [anon_sym_select] = ACTIONS(3800),
    [anon_sym_DQUOTE] = ACTIONS(3800),
    [anon_sym_stackalloc] = ACTIONS(3800),
    [anon_sym_sizeof] = ACTIONS(3800),
    [anon_sym_typeof] = ACTIONS(3800),
    [anon_sym___makeref] = ACTIONS(3800),
    [anon_sym___reftype] = ACTIONS(3800),
    [anon_sym___refvalue] = ACTIONS(3800),
    [sym_null_literal] = ACTIONS(3800),
    [anon_sym_SQUOTE] = ACTIONS(3802),
    [sym_integer_literal] = ACTIONS(3800),
    [sym_real_literal] = ACTIONS(3802),
    [sym_verbatim_string_literal] = ACTIONS(3802),
    [sym_raw_string_literal] = ACTIONS(3802),
    [aux_sym_preproc_if_token1] = ACTIONS(3802),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3802),
    [sym_interpolation_verbatim_start] = ACTIONS(3802),
    [sym_interpolation_raw_start] = ACTIONS(3802),
  },
  [2583] = {
    [sym_preproc_region] = STATE(2583),
    [sym_preproc_endregion] = STATE(2583),
    [sym_preproc_line] = STATE(2583),
    [sym_preproc_pragma] = STATE(2583),
    [sym_preproc_nullable] = STATE(2583),
    [sym_preproc_error] = STATE(2583),
    [sym_preproc_define] = STATE(2583),
    [sym_preproc_undef] = STATE(2583),
    [ts_builtin_sym_end] = ACTIONS(3539),
    [sym__identifier_token] = ACTIONS(3537),
    [anon_sym_extern] = ACTIONS(3537),
    [anon_sym_alias] = ACTIONS(3537),
    [anon_sym_SEMI] = ACTIONS(3539),
    [anon_sym_global] = ACTIONS(3537),
    [anon_sym_using] = ACTIONS(3537),
    [anon_sym_unsafe] = ACTIONS(3537),
    [anon_sym_static] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(3539),
    [anon_sym_LPAREN] = ACTIONS(3539),
    [anon_sym_return] = ACTIONS(3537),
    [anon_sym_namespace] = ACTIONS(3537),
    [anon_sym_class] = ACTIONS(3537),
    [anon_sym_ref] = ACTIONS(3537),
    [anon_sym_struct] = ACTIONS(3537),
    [anon_sym_enum] = ACTIONS(3537),
    [anon_sym_LBRACE] = ACTIONS(3539),
    [anon_sym_interface] = ACTIONS(3537),
    [anon_sym_delegate] = ACTIONS(3537),
    [anon_sym_record] = ACTIONS(3537),
    [anon_sym_abstract] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(3537),
    [anon_sym_const] = ACTIONS(3537),
    [anon_sym_file] = ACTIONS(3537),
    [anon_sym_fixed] = ACTIONS(3537),
    [anon_sym_internal] = ACTIONS(3537),
    [anon_sym_new] = ACTIONS(3537),
    [anon_sym_override] = ACTIONS(3537),
    [anon_sym_partial] = ACTIONS(3537),
    [anon_sym_private] = ACTIONS(3537),
    [anon_sym_protected] = ACTIONS(3537),
    [anon_sym_public] = ACTIONS(3537),
    [anon_sym_readonly] = ACTIONS(3537),
    [anon_sym_required] = ACTIONS(3537),
    [anon_sym_sealed] = ACTIONS(3537),
    [anon_sym_virtual] = ACTIONS(3537),
    [anon_sym_volatile] = ACTIONS(3537),
    [anon_sym_where] = ACTIONS(3537),
    [anon_sym_notnull] = ACTIONS(3537),
    [anon_sym_unmanaged] = ACTIONS(3537),
    [anon_sym_checked] = ACTIONS(3537),
    [anon_sym_BANG] = ACTIONS(3539),
    [anon_sym_TILDE] = ACTIONS(3539),
    [anon_sym_PLUS_PLUS] = ACTIONS(3539),
    [anon_sym_DASH_DASH] = ACTIONS(3539),
    [anon_sym_true] = ACTIONS(3537),
    [anon_sym_false] = ACTIONS(3537),
    [anon_sym_PLUS] = ACTIONS(3537),
    [anon_sym_DASH] = ACTIONS(3537),
    [anon_sym_STAR] = ACTIONS(3539),
    [anon_sym_CARET] = ACTIONS(3539),
    [anon_sym_AMP] = ACTIONS(3539),
    [anon_sym_this] = ACTIONS(3537),
    [anon_sym_scoped] = ACTIONS(3537),
    [anon_sym_var] = ACTIONS(3537),
    [sym_predefined_type] = ACTIONS(3537),
    [anon_sym_break] = ACTIONS(3537),
    [anon_sym_unchecked] = ACTIONS(3537),
    [anon_sym_continue] = ACTIONS(3537),
    [anon_sym_do] = ACTIONS(3537),
    [anon_sym_while] = ACTIONS(3537),
    [anon_sym_for] = ACTIONS(3537),
    [anon_sym_lock] = ACTIONS(3537),
    [anon_sym_yield] = ACTIONS(3537),
    [anon_sym_switch] = ACTIONS(3537),
    [anon_sym_default] = ACTIONS(3537),
    [anon_sym_throw] = ACTIONS(3537),
    [anon_sym_try] = ACTIONS(3537),
    [anon_sym_when] = ACTIONS(3537),
    [anon_sym_await] = ACTIONS(3537),
    [anon_sym_foreach] = ACTIONS(3537),
    [anon_sym_goto] = ACTIONS(3537),
    [anon_sym_if] = ACTIONS(3537),
    [anon_sym_DOT_DOT] = ACTIONS(3539),
    [anon_sym_from] = ACTIONS(3537),
    [anon_sym_into] = ACTIONS(3537),
    [anon_sym_join] = ACTIONS(3537),
    [anon_sym_on] = ACTIONS(3537),
    [anon_sym_equals] = ACTIONS(3537),
    [anon_sym_let] = ACTIONS(3537),
    [anon_sym_orderby] = ACTIONS(3537),
    [anon_sym_ascending] = ACTIONS(3537),
    [anon_sym_descending] = ACTIONS(3537),
    [anon_sym_group] = ACTIONS(3537),
    [anon_sym_by] = ACTIONS(3537),
    [anon_sym_select] = ACTIONS(3537),
    [anon_sym_DQUOTE] = ACTIONS(3537),
    [anon_sym_stackalloc] = ACTIONS(3537),
    [anon_sym_sizeof] = ACTIONS(3537),
    [anon_sym_typeof] = ACTIONS(3537),
    [anon_sym___makeref] = ACTIONS(3537),
    [anon_sym___reftype] = ACTIONS(3537),
    [anon_sym___refvalue] = ACTIONS(3537),
    [sym_null_literal] = ACTIONS(3537),
    [anon_sym_SQUOTE] = ACTIONS(3539),
    [sym_integer_literal] = ACTIONS(3537),
    [sym_real_literal] = ACTIONS(3539),
    [sym_verbatim_string_literal] = ACTIONS(3539),
    [sym_raw_string_literal] = ACTIONS(3539),
    [aux_sym_preproc_if_token1] = ACTIONS(3539),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3539),
    [sym_interpolation_verbatim_start] = ACTIONS(3539),
    [sym_interpolation_raw_start] = ACTIONS(3539),
  },
  [2584] = {
    [sym_preproc_region] = STATE(2584),
    [sym_preproc_endregion] = STATE(2584),
    [sym_preproc_line] = STATE(2584),
    [sym_preproc_pragma] = STATE(2584),
    [sym_preproc_nullable] = STATE(2584),
    [sym_preproc_error] = STATE(2584),
    [sym_preproc_define] = STATE(2584),
    [sym_preproc_undef] = STATE(2584),
    [ts_builtin_sym_end] = ACTIONS(3571),
    [sym__identifier_token] = ACTIONS(3569),
    [anon_sym_extern] = ACTIONS(3569),
    [anon_sym_alias] = ACTIONS(3569),
    [anon_sym_SEMI] = ACTIONS(3571),
    [anon_sym_global] = ACTIONS(3569),
    [anon_sym_using] = ACTIONS(3569),
    [anon_sym_unsafe] = ACTIONS(3569),
    [anon_sym_static] = ACTIONS(3569),
    [anon_sym_LBRACK] = ACTIONS(3571),
    [anon_sym_LPAREN] = ACTIONS(3571),
    [anon_sym_return] = ACTIONS(3569),
    [anon_sym_namespace] = ACTIONS(3569),
    [anon_sym_class] = ACTIONS(3569),
    [anon_sym_ref] = ACTIONS(3569),
    [anon_sym_struct] = ACTIONS(3569),
    [anon_sym_enum] = ACTIONS(3569),
    [anon_sym_LBRACE] = ACTIONS(3571),
    [anon_sym_interface] = ACTIONS(3569),
    [anon_sym_delegate] = ACTIONS(3569),
    [anon_sym_record] = ACTIONS(3569),
    [anon_sym_abstract] = ACTIONS(3569),
    [anon_sym_async] = ACTIONS(3569),
    [anon_sym_const] = ACTIONS(3569),
    [anon_sym_file] = ACTIONS(3569),
    [anon_sym_fixed] = ACTIONS(3569),
    [anon_sym_internal] = ACTIONS(3569),
    [anon_sym_new] = ACTIONS(3569),
    [anon_sym_override] = ACTIONS(3569),
    [anon_sym_partial] = ACTIONS(3569),
    [anon_sym_private] = ACTIONS(3569),
    [anon_sym_protected] = ACTIONS(3569),
    [anon_sym_public] = ACTIONS(3569),
    [anon_sym_readonly] = ACTIONS(3569),
    [anon_sym_required] = ACTIONS(3569),
    [anon_sym_sealed] = ACTIONS(3569),
    [anon_sym_virtual] = ACTIONS(3569),
    [anon_sym_volatile] = ACTIONS(3569),
    [anon_sym_where] = ACTIONS(3569),
    [anon_sym_notnull] = ACTIONS(3569),
    [anon_sym_unmanaged] = ACTIONS(3569),
    [anon_sym_checked] = ACTIONS(3569),
    [anon_sym_BANG] = ACTIONS(3571),
    [anon_sym_TILDE] = ACTIONS(3571),
    [anon_sym_PLUS_PLUS] = ACTIONS(3571),
    [anon_sym_DASH_DASH] = ACTIONS(3571),
    [anon_sym_true] = ACTIONS(3569),
    [anon_sym_false] = ACTIONS(3569),
    [anon_sym_PLUS] = ACTIONS(3569),
    [anon_sym_DASH] = ACTIONS(3569),
    [anon_sym_STAR] = ACTIONS(3571),
    [anon_sym_CARET] = ACTIONS(3571),
    [anon_sym_AMP] = ACTIONS(3571),
    [anon_sym_this] = ACTIONS(3569),
    [anon_sym_scoped] = ACTIONS(3569),
    [anon_sym_var] = ACTIONS(3569),
    [sym_predefined_type] = ACTIONS(3569),
    [anon_sym_break] = ACTIONS(3569),
    [anon_sym_unchecked] = ACTIONS(3569),
    [anon_sym_continue] = ACTIONS(3569),
    [anon_sym_do] = ACTIONS(3569),
    [anon_sym_while] = ACTIONS(3569),
    [anon_sym_for] = ACTIONS(3569),
    [anon_sym_lock] = ACTIONS(3569),
    [anon_sym_yield] = ACTIONS(3569),
    [anon_sym_switch] = ACTIONS(3569),
    [anon_sym_default] = ACTIONS(3569),
    [anon_sym_throw] = ACTIONS(3569),
    [anon_sym_try] = ACTIONS(3569),
    [anon_sym_when] = ACTIONS(3569),
    [anon_sym_await] = ACTIONS(3569),
    [anon_sym_foreach] = ACTIONS(3569),
    [anon_sym_goto] = ACTIONS(3569),
    [anon_sym_if] = ACTIONS(3569),
    [anon_sym_DOT_DOT] = ACTIONS(3571),
    [anon_sym_from] = ACTIONS(3569),
    [anon_sym_into] = ACTIONS(3569),
    [anon_sym_join] = ACTIONS(3569),
    [anon_sym_on] = ACTIONS(3569),
    [anon_sym_equals] = ACTIONS(3569),
    [anon_sym_let] = ACTIONS(3569),
    [anon_sym_orderby] = ACTIONS(3569),
    [anon_sym_ascending] = ACTIONS(3569),
    [anon_sym_descending] = ACTIONS(3569),
    [anon_sym_group] = ACTIONS(3569),
    [anon_sym_by] = ACTIONS(3569),
    [anon_sym_select] = ACTIONS(3569),
    [anon_sym_DQUOTE] = ACTIONS(3569),
    [anon_sym_stackalloc] = ACTIONS(3569),
    [anon_sym_sizeof] = ACTIONS(3569),
    [anon_sym_typeof] = ACTIONS(3569),
    [anon_sym___makeref] = ACTIONS(3569),
    [anon_sym___reftype] = ACTIONS(3569),
    [anon_sym___refvalue] = ACTIONS(3569),
    [sym_null_literal] = ACTIONS(3569),
    [anon_sym_SQUOTE] = ACTIONS(3571),
    [sym_integer_literal] = ACTIONS(3569),
    [sym_real_literal] = ACTIONS(3571),
    [sym_verbatim_string_literal] = ACTIONS(3571),
    [sym_raw_string_literal] = ACTIONS(3571),
    [aux_sym_preproc_if_token1] = ACTIONS(3571),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3571),
    [sym_interpolation_verbatim_start] = ACTIONS(3571),
    [sym_interpolation_raw_start] = ACTIONS(3571),
  },
  [2585] = {
    [sym_preproc_region] = STATE(2585),
    [sym_preproc_endregion] = STATE(2585),
    [sym_preproc_line] = STATE(2585),
    [sym_preproc_pragma] = STATE(2585),
    [sym_preproc_nullable] = STATE(2585),
    [sym_preproc_error] = STATE(2585),
    [sym_preproc_define] = STATE(2585),
    [sym_preproc_undef] = STATE(2585),
    [ts_builtin_sym_end] = ACTIONS(3798),
    [sym__identifier_token] = ACTIONS(3796),
    [anon_sym_extern] = ACTIONS(3796),
    [anon_sym_alias] = ACTIONS(3796),
    [anon_sym_SEMI] = ACTIONS(3798),
    [anon_sym_global] = ACTIONS(3796),
    [anon_sym_using] = ACTIONS(3796),
    [anon_sym_unsafe] = ACTIONS(3796),
    [anon_sym_static] = ACTIONS(3796),
    [anon_sym_LBRACK] = ACTIONS(3798),
    [anon_sym_LPAREN] = ACTIONS(3798),
    [anon_sym_return] = ACTIONS(3796),
    [anon_sym_namespace] = ACTIONS(3796),
    [anon_sym_class] = ACTIONS(3796),
    [anon_sym_ref] = ACTIONS(3796),
    [anon_sym_struct] = ACTIONS(3796),
    [anon_sym_enum] = ACTIONS(3796),
    [anon_sym_LBRACE] = ACTIONS(3798),
    [anon_sym_interface] = ACTIONS(3796),
    [anon_sym_delegate] = ACTIONS(3796),
    [anon_sym_record] = ACTIONS(3796),
    [anon_sym_abstract] = ACTIONS(3796),
    [anon_sym_async] = ACTIONS(3796),
    [anon_sym_const] = ACTIONS(3796),
    [anon_sym_file] = ACTIONS(3796),
    [anon_sym_fixed] = ACTIONS(3796),
    [anon_sym_internal] = ACTIONS(3796),
    [anon_sym_new] = ACTIONS(3796),
    [anon_sym_override] = ACTIONS(3796),
    [anon_sym_partial] = ACTIONS(3796),
    [anon_sym_private] = ACTIONS(3796),
    [anon_sym_protected] = ACTIONS(3796),
    [anon_sym_public] = ACTIONS(3796),
    [anon_sym_readonly] = ACTIONS(3796),
    [anon_sym_required] = ACTIONS(3796),
    [anon_sym_sealed] = ACTIONS(3796),
    [anon_sym_virtual] = ACTIONS(3796),
    [anon_sym_volatile] = ACTIONS(3796),
    [anon_sym_where] = ACTIONS(3796),
    [anon_sym_notnull] = ACTIONS(3796),
    [anon_sym_unmanaged] = ACTIONS(3796),
    [anon_sym_checked] = ACTIONS(3796),
    [anon_sym_BANG] = ACTIONS(3798),
    [anon_sym_TILDE] = ACTIONS(3798),
    [anon_sym_PLUS_PLUS] = ACTIONS(3798),
    [anon_sym_DASH_DASH] = ACTIONS(3798),
    [anon_sym_true] = ACTIONS(3796),
    [anon_sym_false] = ACTIONS(3796),
    [anon_sym_PLUS] = ACTIONS(3796),
    [anon_sym_DASH] = ACTIONS(3796),
    [anon_sym_STAR] = ACTIONS(3798),
    [anon_sym_CARET] = ACTIONS(3798),
    [anon_sym_AMP] = ACTIONS(3798),
    [anon_sym_this] = ACTIONS(3796),
    [anon_sym_scoped] = ACTIONS(3796),
    [anon_sym_var] = ACTIONS(3796),
    [sym_predefined_type] = ACTIONS(3796),
    [anon_sym_break] = ACTIONS(3796),
    [anon_sym_unchecked] = ACTIONS(3796),
    [anon_sym_continue] = ACTIONS(3796),
    [anon_sym_do] = ACTIONS(3796),
    [anon_sym_while] = ACTIONS(3796),
    [anon_sym_for] = ACTIONS(3796),
    [anon_sym_lock] = ACTIONS(3796),
    [anon_sym_yield] = ACTIONS(3796),
    [anon_sym_switch] = ACTIONS(3796),
    [anon_sym_default] = ACTIONS(3796),
    [anon_sym_throw] = ACTIONS(3796),
    [anon_sym_try] = ACTIONS(3796),
    [anon_sym_when] = ACTIONS(3796),
    [anon_sym_await] = ACTIONS(3796),
    [anon_sym_foreach] = ACTIONS(3796),
    [anon_sym_goto] = ACTIONS(3796),
    [anon_sym_if] = ACTIONS(3796),
    [anon_sym_DOT_DOT] = ACTIONS(3798),
    [anon_sym_from] = ACTIONS(3796),
    [anon_sym_into] = ACTIONS(3796),
    [anon_sym_join] = ACTIONS(3796),
    [anon_sym_on] = ACTIONS(3796),
    [anon_sym_equals] = ACTIONS(3796),
    [anon_sym_let] = ACTIONS(3796),
    [anon_sym_orderby] = ACTIONS(3796),
    [anon_sym_ascending] = ACTIONS(3796),
    [anon_sym_descending] = ACTIONS(3796),
    [anon_sym_group] = ACTIONS(3796),
    [anon_sym_by] = ACTIONS(3796),
    [anon_sym_select] = ACTIONS(3796),
    [anon_sym_DQUOTE] = ACTIONS(3796),
    [anon_sym_stackalloc] = ACTIONS(3796),
    [anon_sym_sizeof] = ACTIONS(3796),
    [anon_sym_typeof] = ACTIONS(3796),
    [anon_sym___makeref] = ACTIONS(3796),
    [anon_sym___reftype] = ACTIONS(3796),
    [anon_sym___refvalue] = ACTIONS(3796),
    [sym_null_literal] = ACTIONS(3796),
    [anon_sym_SQUOTE] = ACTIONS(3798),
    [sym_integer_literal] = ACTIONS(3796),
    [sym_real_literal] = ACTIONS(3798),
    [sym_verbatim_string_literal] = ACTIONS(3798),
    [sym_raw_string_literal] = ACTIONS(3798),
    [aux_sym_preproc_if_token1] = ACTIONS(3798),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3798),
    [sym_interpolation_verbatim_start] = ACTIONS(3798),
    [sym_interpolation_raw_start] = ACTIONS(3798),
  },
  [2586] = {
    [sym_preproc_region] = STATE(2586),
    [sym_preproc_endregion] = STATE(2586),
    [sym_preproc_line] = STATE(2586),
    [sym_preproc_pragma] = STATE(2586),
    [sym_preproc_nullable] = STATE(2586),
    [sym_preproc_error] = STATE(2586),
    [sym_preproc_define] = STATE(2586),
    [sym_preproc_undef] = STATE(2586),
    [ts_builtin_sym_end] = ACTIONS(3579),
    [sym__identifier_token] = ACTIONS(3577),
    [anon_sym_extern] = ACTIONS(3577),
    [anon_sym_alias] = ACTIONS(3577),
    [anon_sym_SEMI] = ACTIONS(3579),
    [anon_sym_global] = ACTIONS(3577),
    [anon_sym_using] = ACTIONS(3577),
    [anon_sym_unsafe] = ACTIONS(3577),
    [anon_sym_static] = ACTIONS(3577),
    [anon_sym_LBRACK] = ACTIONS(3579),
    [anon_sym_LPAREN] = ACTIONS(3579),
    [anon_sym_return] = ACTIONS(3577),
    [anon_sym_namespace] = ACTIONS(3577),
    [anon_sym_class] = ACTIONS(3577),
    [anon_sym_ref] = ACTIONS(3577),
    [anon_sym_struct] = ACTIONS(3577),
    [anon_sym_enum] = ACTIONS(3577),
    [anon_sym_LBRACE] = ACTIONS(3579),
    [anon_sym_interface] = ACTIONS(3577),
    [anon_sym_delegate] = ACTIONS(3577),
    [anon_sym_record] = ACTIONS(3577),
    [anon_sym_abstract] = ACTIONS(3577),
    [anon_sym_async] = ACTIONS(3577),
    [anon_sym_const] = ACTIONS(3577),
    [anon_sym_file] = ACTIONS(3577),
    [anon_sym_fixed] = ACTIONS(3577),
    [anon_sym_internal] = ACTIONS(3577),
    [anon_sym_new] = ACTIONS(3577),
    [anon_sym_override] = ACTIONS(3577),
    [anon_sym_partial] = ACTIONS(3577),
    [anon_sym_private] = ACTIONS(3577),
    [anon_sym_protected] = ACTIONS(3577),
    [anon_sym_public] = ACTIONS(3577),
    [anon_sym_readonly] = ACTIONS(3577),
    [anon_sym_required] = ACTIONS(3577),
    [anon_sym_sealed] = ACTIONS(3577),
    [anon_sym_virtual] = ACTIONS(3577),
    [anon_sym_volatile] = ACTIONS(3577),
    [anon_sym_where] = ACTIONS(3577),
    [anon_sym_notnull] = ACTIONS(3577),
    [anon_sym_unmanaged] = ACTIONS(3577),
    [anon_sym_checked] = ACTIONS(3577),
    [anon_sym_BANG] = ACTIONS(3579),
    [anon_sym_TILDE] = ACTIONS(3579),
    [anon_sym_PLUS_PLUS] = ACTIONS(3579),
    [anon_sym_DASH_DASH] = ACTIONS(3579),
    [anon_sym_true] = ACTIONS(3577),
    [anon_sym_false] = ACTIONS(3577),
    [anon_sym_PLUS] = ACTIONS(3577),
    [anon_sym_DASH] = ACTIONS(3577),
    [anon_sym_STAR] = ACTIONS(3579),
    [anon_sym_CARET] = ACTIONS(3579),
    [anon_sym_AMP] = ACTIONS(3579),
    [anon_sym_this] = ACTIONS(3577),
    [anon_sym_scoped] = ACTIONS(3577),
    [anon_sym_var] = ACTIONS(3577),
    [sym_predefined_type] = ACTIONS(3577),
    [anon_sym_break] = ACTIONS(3577),
    [anon_sym_unchecked] = ACTIONS(3577),
    [anon_sym_continue] = ACTIONS(3577),
    [anon_sym_do] = ACTIONS(3577),
    [anon_sym_while] = ACTIONS(3577),
    [anon_sym_for] = ACTIONS(3577),
    [anon_sym_lock] = ACTIONS(3577),
    [anon_sym_yield] = ACTIONS(3577),
    [anon_sym_switch] = ACTIONS(3577),
    [anon_sym_default] = ACTIONS(3577),
    [anon_sym_throw] = ACTIONS(3577),
    [anon_sym_try] = ACTIONS(3577),
    [anon_sym_when] = ACTIONS(3577),
    [anon_sym_await] = ACTIONS(3577),
    [anon_sym_foreach] = ACTIONS(3577),
    [anon_sym_goto] = ACTIONS(3577),
    [anon_sym_if] = ACTIONS(3577),
    [anon_sym_DOT_DOT] = ACTIONS(3579),
    [anon_sym_from] = ACTIONS(3577),
    [anon_sym_into] = ACTIONS(3577),
    [anon_sym_join] = ACTIONS(3577),
    [anon_sym_on] = ACTIONS(3577),
    [anon_sym_equals] = ACTIONS(3577),
    [anon_sym_let] = ACTIONS(3577),
    [anon_sym_orderby] = ACTIONS(3577),
    [anon_sym_ascending] = ACTIONS(3577),
    [anon_sym_descending] = ACTIONS(3577),
    [anon_sym_group] = ACTIONS(3577),
    [anon_sym_by] = ACTIONS(3577),
    [anon_sym_select] = ACTIONS(3577),
    [anon_sym_DQUOTE] = ACTIONS(3577),
    [anon_sym_stackalloc] = ACTIONS(3577),
    [anon_sym_sizeof] = ACTIONS(3577),
    [anon_sym_typeof] = ACTIONS(3577),
    [anon_sym___makeref] = ACTIONS(3577),
    [anon_sym___reftype] = ACTIONS(3577),
    [anon_sym___refvalue] = ACTIONS(3577),
    [sym_null_literal] = ACTIONS(3577),
    [anon_sym_SQUOTE] = ACTIONS(3579),
    [sym_integer_literal] = ACTIONS(3577),
    [sym_real_literal] = ACTIONS(3579),
    [sym_verbatim_string_literal] = ACTIONS(3579),
    [sym_raw_string_literal] = ACTIONS(3579),
    [aux_sym_preproc_if_token1] = ACTIONS(3579),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3579),
    [sym_interpolation_verbatim_start] = ACTIONS(3579),
    [sym_interpolation_raw_start] = ACTIONS(3579),
  },
  [2587] = {
    [sym_preproc_region] = STATE(2587),
    [sym_preproc_endregion] = STATE(2587),
    [sym_preproc_line] = STATE(2587),
    [sym_preproc_pragma] = STATE(2587),
    [sym_preproc_nullable] = STATE(2587),
    [sym_preproc_error] = STATE(2587),
    [sym_preproc_define] = STATE(2587),
    [sym_preproc_undef] = STATE(2587),
    [ts_builtin_sym_end] = ACTIONS(3607),
    [sym__identifier_token] = ACTIONS(3605),
    [anon_sym_extern] = ACTIONS(3605),
    [anon_sym_alias] = ACTIONS(3605),
    [anon_sym_SEMI] = ACTIONS(3607),
    [anon_sym_global] = ACTIONS(3605),
    [anon_sym_using] = ACTIONS(3605),
    [anon_sym_unsafe] = ACTIONS(3605),
    [anon_sym_static] = ACTIONS(3605),
    [anon_sym_LBRACK] = ACTIONS(3607),
    [anon_sym_LPAREN] = ACTIONS(3607),
    [anon_sym_return] = ACTIONS(3605),
    [anon_sym_namespace] = ACTIONS(3605),
    [anon_sym_class] = ACTIONS(3605),
    [anon_sym_ref] = ACTIONS(3605),
    [anon_sym_struct] = ACTIONS(3605),
    [anon_sym_enum] = ACTIONS(3605),
    [anon_sym_LBRACE] = ACTIONS(3607),
    [anon_sym_interface] = ACTIONS(3605),
    [anon_sym_delegate] = ACTIONS(3605),
    [anon_sym_record] = ACTIONS(3605),
    [anon_sym_abstract] = ACTIONS(3605),
    [anon_sym_async] = ACTIONS(3605),
    [anon_sym_const] = ACTIONS(3605),
    [anon_sym_file] = ACTIONS(3605),
    [anon_sym_fixed] = ACTIONS(3605),
    [anon_sym_internal] = ACTIONS(3605),
    [anon_sym_new] = ACTIONS(3605),
    [anon_sym_override] = ACTIONS(3605),
    [anon_sym_partial] = ACTIONS(3605),
    [anon_sym_private] = ACTIONS(3605),
    [anon_sym_protected] = ACTIONS(3605),
    [anon_sym_public] = ACTIONS(3605),
    [anon_sym_readonly] = ACTIONS(3605),
    [anon_sym_required] = ACTIONS(3605),
    [anon_sym_sealed] = ACTIONS(3605),
    [anon_sym_virtual] = ACTIONS(3605),
    [anon_sym_volatile] = ACTIONS(3605),
    [anon_sym_where] = ACTIONS(3605),
    [anon_sym_notnull] = ACTIONS(3605),
    [anon_sym_unmanaged] = ACTIONS(3605),
    [anon_sym_checked] = ACTIONS(3605),
    [anon_sym_BANG] = ACTIONS(3607),
    [anon_sym_TILDE] = ACTIONS(3607),
    [anon_sym_PLUS_PLUS] = ACTIONS(3607),
    [anon_sym_DASH_DASH] = ACTIONS(3607),
    [anon_sym_true] = ACTIONS(3605),
    [anon_sym_false] = ACTIONS(3605),
    [anon_sym_PLUS] = ACTIONS(3605),
    [anon_sym_DASH] = ACTIONS(3605),
    [anon_sym_STAR] = ACTIONS(3607),
    [anon_sym_CARET] = ACTIONS(3607),
    [anon_sym_AMP] = ACTIONS(3607),
    [anon_sym_this] = ACTIONS(3605),
    [anon_sym_scoped] = ACTIONS(3605),
    [anon_sym_var] = ACTIONS(3605),
    [sym_predefined_type] = ACTIONS(3605),
    [anon_sym_break] = ACTIONS(3605),
    [anon_sym_unchecked] = ACTIONS(3605),
    [anon_sym_continue] = ACTIONS(3605),
    [anon_sym_do] = ACTIONS(3605),
    [anon_sym_while] = ACTIONS(3605),
    [anon_sym_for] = ACTIONS(3605),
    [anon_sym_lock] = ACTIONS(3605),
    [anon_sym_yield] = ACTIONS(3605),
    [anon_sym_switch] = ACTIONS(3605),
    [anon_sym_default] = ACTIONS(3605),
    [anon_sym_throw] = ACTIONS(3605),
    [anon_sym_try] = ACTIONS(3605),
    [anon_sym_when] = ACTIONS(3605),
    [anon_sym_await] = ACTIONS(3605),
    [anon_sym_foreach] = ACTIONS(3605),
    [anon_sym_goto] = ACTIONS(3605),
    [anon_sym_if] = ACTIONS(3605),
    [anon_sym_DOT_DOT] = ACTIONS(3607),
    [anon_sym_from] = ACTIONS(3605),
    [anon_sym_into] = ACTIONS(3605),
    [anon_sym_join] = ACTIONS(3605),
    [anon_sym_on] = ACTIONS(3605),
    [anon_sym_equals] = ACTIONS(3605),
    [anon_sym_let] = ACTIONS(3605),
    [anon_sym_orderby] = ACTIONS(3605),
    [anon_sym_ascending] = ACTIONS(3605),
    [anon_sym_descending] = ACTIONS(3605),
    [anon_sym_group] = ACTIONS(3605),
    [anon_sym_by] = ACTIONS(3605),
    [anon_sym_select] = ACTIONS(3605),
    [anon_sym_DQUOTE] = ACTIONS(3605),
    [anon_sym_stackalloc] = ACTIONS(3605),
    [anon_sym_sizeof] = ACTIONS(3605),
    [anon_sym_typeof] = ACTIONS(3605),
    [anon_sym___makeref] = ACTIONS(3605),
    [anon_sym___reftype] = ACTIONS(3605),
    [anon_sym___refvalue] = ACTIONS(3605),
    [sym_null_literal] = ACTIONS(3605),
    [anon_sym_SQUOTE] = ACTIONS(3607),
    [sym_integer_literal] = ACTIONS(3605),
    [sym_real_literal] = ACTIONS(3607),
    [sym_verbatim_string_literal] = ACTIONS(3607),
    [sym_raw_string_literal] = ACTIONS(3607),
    [aux_sym_preproc_if_token1] = ACTIONS(3607),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3607),
    [sym_interpolation_verbatim_start] = ACTIONS(3607),
    [sym_interpolation_raw_start] = ACTIONS(3607),
  },
  [2588] = {
    [sym_preproc_region] = STATE(2588),
    [sym_preproc_endregion] = STATE(2588),
    [sym_preproc_line] = STATE(2588),
    [sym_preproc_pragma] = STATE(2588),
    [sym_preproc_nullable] = STATE(2588),
    [sym_preproc_error] = STATE(2588),
    [sym_preproc_define] = STATE(2588),
    [sym_preproc_undef] = STATE(2588),
    [ts_builtin_sym_end] = ACTIONS(3659),
    [sym__identifier_token] = ACTIONS(3657),
    [anon_sym_extern] = ACTIONS(3657),
    [anon_sym_alias] = ACTIONS(3657),
    [anon_sym_SEMI] = ACTIONS(3659),
    [anon_sym_global] = ACTIONS(3657),
    [anon_sym_using] = ACTIONS(3657),
    [anon_sym_unsafe] = ACTIONS(3657),
    [anon_sym_static] = ACTIONS(3657),
    [anon_sym_LBRACK] = ACTIONS(3659),
    [anon_sym_LPAREN] = ACTIONS(3659),
    [anon_sym_return] = ACTIONS(3657),
    [anon_sym_namespace] = ACTIONS(3657),
    [anon_sym_class] = ACTIONS(3657),
    [anon_sym_ref] = ACTIONS(3657),
    [anon_sym_struct] = ACTIONS(3657),
    [anon_sym_enum] = ACTIONS(3657),
    [anon_sym_LBRACE] = ACTIONS(3659),
    [anon_sym_interface] = ACTIONS(3657),
    [anon_sym_delegate] = ACTIONS(3657),
    [anon_sym_record] = ACTIONS(3657),
    [anon_sym_abstract] = ACTIONS(3657),
    [anon_sym_async] = ACTIONS(3657),
    [anon_sym_const] = ACTIONS(3657),
    [anon_sym_file] = ACTIONS(3657),
    [anon_sym_fixed] = ACTIONS(3657),
    [anon_sym_internal] = ACTIONS(3657),
    [anon_sym_new] = ACTIONS(3657),
    [anon_sym_override] = ACTIONS(3657),
    [anon_sym_partial] = ACTIONS(3657),
    [anon_sym_private] = ACTIONS(3657),
    [anon_sym_protected] = ACTIONS(3657),
    [anon_sym_public] = ACTIONS(3657),
    [anon_sym_readonly] = ACTIONS(3657),
    [anon_sym_required] = ACTIONS(3657),
    [anon_sym_sealed] = ACTIONS(3657),
    [anon_sym_virtual] = ACTIONS(3657),
    [anon_sym_volatile] = ACTIONS(3657),
    [anon_sym_where] = ACTIONS(3657),
    [anon_sym_notnull] = ACTIONS(3657),
    [anon_sym_unmanaged] = ACTIONS(3657),
    [anon_sym_checked] = ACTIONS(3657),
    [anon_sym_BANG] = ACTIONS(3659),
    [anon_sym_TILDE] = ACTIONS(3659),
    [anon_sym_PLUS_PLUS] = ACTIONS(3659),
    [anon_sym_DASH_DASH] = ACTIONS(3659),
    [anon_sym_true] = ACTIONS(3657),
    [anon_sym_false] = ACTIONS(3657),
    [anon_sym_PLUS] = ACTIONS(3657),
    [anon_sym_DASH] = ACTIONS(3657),
    [anon_sym_STAR] = ACTIONS(3659),
    [anon_sym_CARET] = ACTIONS(3659),
    [anon_sym_AMP] = ACTIONS(3659),
    [anon_sym_this] = ACTIONS(3657),
    [anon_sym_scoped] = ACTIONS(3657),
    [anon_sym_var] = ACTIONS(3657),
    [sym_predefined_type] = ACTIONS(3657),
    [anon_sym_break] = ACTIONS(3657),
    [anon_sym_unchecked] = ACTIONS(3657),
    [anon_sym_continue] = ACTIONS(3657),
    [anon_sym_do] = ACTIONS(3657),
    [anon_sym_while] = ACTIONS(3657),
    [anon_sym_for] = ACTIONS(3657),
    [anon_sym_lock] = ACTIONS(3657),
    [anon_sym_yield] = ACTIONS(3657),
    [anon_sym_switch] = ACTIONS(3657),
    [anon_sym_default] = ACTIONS(3657),
    [anon_sym_throw] = ACTIONS(3657),
    [anon_sym_try] = ACTIONS(3657),
    [anon_sym_when] = ACTIONS(3657),
    [anon_sym_await] = ACTIONS(3657),
    [anon_sym_foreach] = ACTIONS(3657),
    [anon_sym_goto] = ACTIONS(3657),
    [anon_sym_if] = ACTIONS(3657),
    [anon_sym_DOT_DOT] = ACTIONS(3659),
    [anon_sym_from] = ACTIONS(3657),
    [anon_sym_into] = ACTIONS(3657),
    [anon_sym_join] = ACTIONS(3657),
    [anon_sym_on] = ACTIONS(3657),
    [anon_sym_equals] = ACTIONS(3657),
    [anon_sym_let] = ACTIONS(3657),
    [anon_sym_orderby] = ACTIONS(3657),
    [anon_sym_ascending] = ACTIONS(3657),
    [anon_sym_descending] = ACTIONS(3657),
    [anon_sym_group] = ACTIONS(3657),
    [anon_sym_by] = ACTIONS(3657),
    [anon_sym_select] = ACTIONS(3657),
    [anon_sym_DQUOTE] = ACTIONS(3657),
    [anon_sym_stackalloc] = ACTIONS(3657),
    [anon_sym_sizeof] = ACTIONS(3657),
    [anon_sym_typeof] = ACTIONS(3657),
    [anon_sym___makeref] = ACTIONS(3657),
    [anon_sym___reftype] = ACTIONS(3657),
    [anon_sym___refvalue] = ACTIONS(3657),
    [sym_null_literal] = ACTIONS(3657),
    [anon_sym_SQUOTE] = ACTIONS(3659),
    [sym_integer_literal] = ACTIONS(3657),
    [sym_real_literal] = ACTIONS(3659),
    [sym_verbatim_string_literal] = ACTIONS(3659),
    [sym_raw_string_literal] = ACTIONS(3659),
    [aux_sym_preproc_if_token1] = ACTIONS(3659),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3659),
    [sym_interpolation_verbatim_start] = ACTIONS(3659),
    [sym_interpolation_raw_start] = ACTIONS(3659),
  },
  [2589] = {
    [sym_preproc_region] = STATE(2589),
    [sym_preproc_endregion] = STATE(2589),
    [sym_preproc_line] = STATE(2589),
    [sym_preproc_pragma] = STATE(2589),
    [sym_preproc_nullable] = STATE(2589),
    [sym_preproc_error] = STATE(2589),
    [sym_preproc_define] = STATE(2589),
    [sym_preproc_undef] = STATE(2589),
    [ts_builtin_sym_end] = ACTIONS(3794),
    [sym__identifier_token] = ACTIONS(3792),
    [anon_sym_extern] = ACTIONS(3792),
    [anon_sym_alias] = ACTIONS(3792),
    [anon_sym_SEMI] = ACTIONS(3794),
    [anon_sym_global] = ACTIONS(3792),
    [anon_sym_using] = ACTIONS(3792),
    [anon_sym_unsafe] = ACTIONS(3792),
    [anon_sym_static] = ACTIONS(3792),
    [anon_sym_LBRACK] = ACTIONS(3794),
    [anon_sym_LPAREN] = ACTIONS(3794),
    [anon_sym_return] = ACTIONS(3792),
    [anon_sym_namespace] = ACTIONS(3792),
    [anon_sym_class] = ACTIONS(3792),
    [anon_sym_ref] = ACTIONS(3792),
    [anon_sym_struct] = ACTIONS(3792),
    [anon_sym_enum] = ACTIONS(3792),
    [anon_sym_LBRACE] = ACTIONS(3794),
    [anon_sym_interface] = ACTIONS(3792),
    [anon_sym_delegate] = ACTIONS(3792),
    [anon_sym_record] = ACTIONS(3792),
    [anon_sym_abstract] = ACTIONS(3792),
    [anon_sym_async] = ACTIONS(3792),
    [anon_sym_const] = ACTIONS(3792),
    [anon_sym_file] = ACTIONS(3792),
    [anon_sym_fixed] = ACTIONS(3792),
    [anon_sym_internal] = ACTIONS(3792),
    [anon_sym_new] = ACTIONS(3792),
    [anon_sym_override] = ACTIONS(3792),
    [anon_sym_partial] = ACTIONS(3792),
    [anon_sym_private] = ACTIONS(3792),
    [anon_sym_protected] = ACTIONS(3792),
    [anon_sym_public] = ACTIONS(3792),
    [anon_sym_readonly] = ACTIONS(3792),
    [anon_sym_required] = ACTIONS(3792),
    [anon_sym_sealed] = ACTIONS(3792),
    [anon_sym_virtual] = ACTIONS(3792),
    [anon_sym_volatile] = ACTIONS(3792),
    [anon_sym_where] = ACTIONS(3792),
    [anon_sym_notnull] = ACTIONS(3792),
    [anon_sym_unmanaged] = ACTIONS(3792),
    [anon_sym_checked] = ACTIONS(3792),
    [anon_sym_BANG] = ACTIONS(3794),
    [anon_sym_TILDE] = ACTIONS(3794),
    [anon_sym_PLUS_PLUS] = ACTIONS(3794),
    [anon_sym_DASH_DASH] = ACTIONS(3794),
    [anon_sym_true] = ACTIONS(3792),
    [anon_sym_false] = ACTIONS(3792),
    [anon_sym_PLUS] = ACTIONS(3792),
    [anon_sym_DASH] = ACTIONS(3792),
    [anon_sym_STAR] = ACTIONS(3794),
    [anon_sym_CARET] = ACTIONS(3794),
    [anon_sym_AMP] = ACTIONS(3794),
    [anon_sym_this] = ACTIONS(3792),
    [anon_sym_scoped] = ACTIONS(3792),
    [anon_sym_var] = ACTIONS(3792),
    [sym_predefined_type] = ACTIONS(3792),
    [anon_sym_break] = ACTIONS(3792),
    [anon_sym_unchecked] = ACTIONS(3792),
    [anon_sym_continue] = ACTIONS(3792),
    [anon_sym_do] = ACTIONS(3792),
    [anon_sym_while] = ACTIONS(3792),
    [anon_sym_for] = ACTIONS(3792),
    [anon_sym_lock] = ACTIONS(3792),
    [anon_sym_yield] = ACTIONS(3792),
    [anon_sym_switch] = ACTIONS(3792),
    [anon_sym_default] = ACTIONS(3792),
    [anon_sym_throw] = ACTIONS(3792),
    [anon_sym_try] = ACTIONS(3792),
    [anon_sym_when] = ACTIONS(3792),
    [anon_sym_await] = ACTIONS(3792),
    [anon_sym_foreach] = ACTIONS(3792),
    [anon_sym_goto] = ACTIONS(3792),
    [anon_sym_if] = ACTIONS(3792),
    [anon_sym_DOT_DOT] = ACTIONS(3794),
    [anon_sym_from] = ACTIONS(3792),
    [anon_sym_into] = ACTIONS(3792),
    [anon_sym_join] = ACTIONS(3792),
    [anon_sym_on] = ACTIONS(3792),
    [anon_sym_equals] = ACTIONS(3792),
    [anon_sym_let] = ACTIONS(3792),
    [anon_sym_orderby] = ACTIONS(3792),
    [anon_sym_ascending] = ACTIONS(3792),
    [anon_sym_descending] = ACTIONS(3792),
    [anon_sym_group] = ACTIONS(3792),
    [anon_sym_by] = ACTIONS(3792),
    [anon_sym_select] = ACTIONS(3792),
    [anon_sym_DQUOTE] = ACTIONS(3792),
    [anon_sym_stackalloc] = ACTIONS(3792),
    [anon_sym_sizeof] = ACTIONS(3792),
    [anon_sym_typeof] = ACTIONS(3792),
    [anon_sym___makeref] = ACTIONS(3792),
    [anon_sym___reftype] = ACTIONS(3792),
    [anon_sym___refvalue] = ACTIONS(3792),
    [sym_null_literal] = ACTIONS(3792),
    [anon_sym_SQUOTE] = ACTIONS(3794),
    [sym_integer_literal] = ACTIONS(3792),
    [sym_real_literal] = ACTIONS(3794),
    [sym_verbatim_string_literal] = ACTIONS(3794),
    [sym_raw_string_literal] = ACTIONS(3794),
    [aux_sym_preproc_if_token1] = ACTIONS(3794),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3794),
    [sym_interpolation_verbatim_start] = ACTIONS(3794),
    [sym_interpolation_raw_start] = ACTIONS(3794),
  },
  [2590] = {
    [sym_preproc_region] = STATE(2590),
    [sym_preproc_endregion] = STATE(2590),
    [sym_preproc_line] = STATE(2590),
    [sym_preproc_pragma] = STATE(2590),
    [sym_preproc_nullable] = STATE(2590),
    [sym_preproc_error] = STATE(2590),
    [sym_preproc_define] = STATE(2590),
    [sym_preproc_undef] = STATE(2590),
    [ts_builtin_sym_end] = ACTIONS(3447),
    [sym__identifier_token] = ACTIONS(3445),
    [anon_sym_extern] = ACTIONS(3445),
    [anon_sym_alias] = ACTIONS(3445),
    [anon_sym_SEMI] = ACTIONS(3447),
    [anon_sym_global] = ACTIONS(3445),
    [anon_sym_using] = ACTIONS(3445),
    [anon_sym_unsafe] = ACTIONS(3445),
    [anon_sym_static] = ACTIONS(3445),
    [anon_sym_LBRACK] = ACTIONS(3447),
    [anon_sym_LPAREN] = ACTIONS(3447),
    [anon_sym_return] = ACTIONS(3445),
    [anon_sym_namespace] = ACTIONS(3445),
    [anon_sym_class] = ACTIONS(3445),
    [anon_sym_ref] = ACTIONS(3445),
    [anon_sym_struct] = ACTIONS(3445),
    [anon_sym_enum] = ACTIONS(3445),
    [anon_sym_LBRACE] = ACTIONS(3447),
    [anon_sym_interface] = ACTIONS(3445),
    [anon_sym_delegate] = ACTIONS(3445),
    [anon_sym_record] = ACTIONS(3445),
    [anon_sym_abstract] = ACTIONS(3445),
    [anon_sym_async] = ACTIONS(3445),
    [anon_sym_const] = ACTIONS(3445),
    [anon_sym_file] = ACTIONS(3445),
    [anon_sym_fixed] = ACTIONS(3445),
    [anon_sym_internal] = ACTIONS(3445),
    [anon_sym_new] = ACTIONS(3445),
    [anon_sym_override] = ACTIONS(3445),
    [anon_sym_partial] = ACTIONS(3445),
    [anon_sym_private] = ACTIONS(3445),
    [anon_sym_protected] = ACTIONS(3445),
    [anon_sym_public] = ACTIONS(3445),
    [anon_sym_readonly] = ACTIONS(3445),
    [anon_sym_required] = ACTIONS(3445),
    [anon_sym_sealed] = ACTIONS(3445),
    [anon_sym_virtual] = ACTIONS(3445),
    [anon_sym_volatile] = ACTIONS(3445),
    [anon_sym_where] = ACTIONS(3445),
    [anon_sym_notnull] = ACTIONS(3445),
    [anon_sym_unmanaged] = ACTIONS(3445),
    [anon_sym_checked] = ACTIONS(3445),
    [anon_sym_BANG] = ACTIONS(3447),
    [anon_sym_TILDE] = ACTIONS(3447),
    [anon_sym_PLUS_PLUS] = ACTIONS(3447),
    [anon_sym_DASH_DASH] = ACTIONS(3447),
    [anon_sym_true] = ACTIONS(3445),
    [anon_sym_false] = ACTIONS(3445),
    [anon_sym_PLUS] = ACTIONS(3445),
    [anon_sym_DASH] = ACTIONS(3445),
    [anon_sym_STAR] = ACTIONS(3447),
    [anon_sym_CARET] = ACTIONS(3447),
    [anon_sym_AMP] = ACTIONS(3447),
    [anon_sym_this] = ACTIONS(3445),
    [anon_sym_scoped] = ACTIONS(3445),
    [anon_sym_var] = ACTIONS(3445),
    [sym_predefined_type] = ACTIONS(3445),
    [anon_sym_break] = ACTIONS(3445),
    [anon_sym_unchecked] = ACTIONS(3445),
    [anon_sym_continue] = ACTIONS(3445),
    [anon_sym_do] = ACTIONS(3445),
    [anon_sym_while] = ACTIONS(3445),
    [anon_sym_for] = ACTIONS(3445),
    [anon_sym_lock] = ACTIONS(3445),
    [anon_sym_yield] = ACTIONS(3445),
    [anon_sym_switch] = ACTIONS(3445),
    [anon_sym_default] = ACTIONS(3445),
    [anon_sym_throw] = ACTIONS(3445),
    [anon_sym_try] = ACTIONS(3445),
    [anon_sym_when] = ACTIONS(3445),
    [anon_sym_await] = ACTIONS(3445),
    [anon_sym_foreach] = ACTIONS(3445),
    [anon_sym_goto] = ACTIONS(3445),
    [anon_sym_if] = ACTIONS(3445),
    [anon_sym_DOT_DOT] = ACTIONS(3447),
    [anon_sym_from] = ACTIONS(3445),
    [anon_sym_into] = ACTIONS(3445),
    [anon_sym_join] = ACTIONS(3445),
    [anon_sym_on] = ACTIONS(3445),
    [anon_sym_equals] = ACTIONS(3445),
    [anon_sym_let] = ACTIONS(3445),
    [anon_sym_orderby] = ACTIONS(3445),
    [anon_sym_ascending] = ACTIONS(3445),
    [anon_sym_descending] = ACTIONS(3445),
    [anon_sym_group] = ACTIONS(3445),
    [anon_sym_by] = ACTIONS(3445),
    [anon_sym_select] = ACTIONS(3445),
    [anon_sym_DQUOTE] = ACTIONS(3445),
    [anon_sym_stackalloc] = ACTIONS(3445),
    [anon_sym_sizeof] = ACTIONS(3445),
    [anon_sym_typeof] = ACTIONS(3445),
    [anon_sym___makeref] = ACTIONS(3445),
    [anon_sym___reftype] = ACTIONS(3445),
    [anon_sym___refvalue] = ACTIONS(3445),
    [sym_null_literal] = ACTIONS(3445),
    [anon_sym_SQUOTE] = ACTIONS(3447),
    [sym_integer_literal] = ACTIONS(3445),
    [sym_real_literal] = ACTIONS(3447),
    [sym_verbatim_string_literal] = ACTIONS(3447),
    [sym_raw_string_literal] = ACTIONS(3447),
    [aux_sym_preproc_if_token1] = ACTIONS(3447),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3447),
    [sym_interpolation_verbatim_start] = ACTIONS(3447),
    [sym_interpolation_raw_start] = ACTIONS(3447),
  },
  [2591] = {
    [sym_preproc_region] = STATE(2591),
    [sym_preproc_endregion] = STATE(2591),
    [sym_preproc_line] = STATE(2591),
    [sym_preproc_pragma] = STATE(2591),
    [sym_preproc_nullable] = STATE(2591),
    [sym_preproc_error] = STATE(2591),
    [sym_preproc_define] = STATE(2591),
    [sym_preproc_undef] = STATE(2591),
    [ts_builtin_sym_end] = ACTIONS(3770),
    [sym__identifier_token] = ACTIONS(3768),
    [anon_sym_extern] = ACTIONS(3768),
    [anon_sym_alias] = ACTIONS(3768),
    [anon_sym_SEMI] = ACTIONS(3770),
    [anon_sym_global] = ACTIONS(3768),
    [anon_sym_using] = ACTIONS(3768),
    [anon_sym_unsafe] = ACTIONS(3768),
    [anon_sym_static] = ACTIONS(3768),
    [anon_sym_LBRACK] = ACTIONS(3770),
    [anon_sym_LPAREN] = ACTIONS(3770),
    [anon_sym_return] = ACTIONS(3768),
    [anon_sym_namespace] = ACTIONS(3768),
    [anon_sym_class] = ACTIONS(3768),
    [anon_sym_ref] = ACTIONS(3768),
    [anon_sym_struct] = ACTIONS(3768),
    [anon_sym_enum] = ACTIONS(3768),
    [anon_sym_LBRACE] = ACTIONS(3770),
    [anon_sym_interface] = ACTIONS(3768),
    [anon_sym_delegate] = ACTIONS(3768),
    [anon_sym_record] = ACTIONS(3768),
    [anon_sym_abstract] = ACTIONS(3768),
    [anon_sym_async] = ACTIONS(3768),
    [anon_sym_const] = ACTIONS(3768),
    [anon_sym_file] = ACTIONS(3768),
    [anon_sym_fixed] = ACTIONS(3768),
    [anon_sym_internal] = ACTIONS(3768),
    [anon_sym_new] = ACTIONS(3768),
    [anon_sym_override] = ACTIONS(3768),
    [anon_sym_partial] = ACTIONS(3768),
    [anon_sym_private] = ACTIONS(3768),
    [anon_sym_protected] = ACTIONS(3768),
    [anon_sym_public] = ACTIONS(3768),
    [anon_sym_readonly] = ACTIONS(3768),
    [anon_sym_required] = ACTIONS(3768),
    [anon_sym_sealed] = ACTIONS(3768),
    [anon_sym_virtual] = ACTIONS(3768),
    [anon_sym_volatile] = ACTIONS(3768),
    [anon_sym_where] = ACTIONS(3768),
    [anon_sym_notnull] = ACTIONS(3768),
    [anon_sym_unmanaged] = ACTIONS(3768),
    [anon_sym_checked] = ACTIONS(3768),
    [anon_sym_BANG] = ACTIONS(3770),
    [anon_sym_TILDE] = ACTIONS(3770),
    [anon_sym_PLUS_PLUS] = ACTIONS(3770),
    [anon_sym_DASH_DASH] = ACTIONS(3770),
    [anon_sym_true] = ACTIONS(3768),
    [anon_sym_false] = ACTIONS(3768),
    [anon_sym_PLUS] = ACTIONS(3768),
    [anon_sym_DASH] = ACTIONS(3768),
    [anon_sym_STAR] = ACTIONS(3770),
    [anon_sym_CARET] = ACTIONS(3770),
    [anon_sym_AMP] = ACTIONS(3770),
    [anon_sym_this] = ACTIONS(3768),
    [anon_sym_scoped] = ACTIONS(3768),
    [anon_sym_var] = ACTIONS(3768),
    [sym_predefined_type] = ACTIONS(3768),
    [anon_sym_break] = ACTIONS(3768),
    [anon_sym_unchecked] = ACTIONS(3768),
    [anon_sym_continue] = ACTIONS(3768),
    [anon_sym_do] = ACTIONS(3768),
    [anon_sym_while] = ACTIONS(3768),
    [anon_sym_for] = ACTIONS(3768),
    [anon_sym_lock] = ACTIONS(3768),
    [anon_sym_yield] = ACTIONS(3768),
    [anon_sym_switch] = ACTIONS(3768),
    [anon_sym_default] = ACTIONS(3768),
    [anon_sym_throw] = ACTIONS(3768),
    [anon_sym_try] = ACTIONS(3768),
    [anon_sym_when] = ACTIONS(3768),
    [anon_sym_await] = ACTIONS(3768),
    [anon_sym_foreach] = ACTIONS(3768),
    [anon_sym_goto] = ACTIONS(3768),
    [anon_sym_if] = ACTIONS(3768),
    [anon_sym_DOT_DOT] = ACTIONS(3770),
    [anon_sym_from] = ACTIONS(3768),
    [anon_sym_into] = ACTIONS(3768),
    [anon_sym_join] = ACTIONS(3768),
    [anon_sym_on] = ACTIONS(3768),
    [anon_sym_equals] = ACTIONS(3768),
    [anon_sym_let] = ACTIONS(3768),
    [anon_sym_orderby] = ACTIONS(3768),
    [anon_sym_ascending] = ACTIONS(3768),
    [anon_sym_descending] = ACTIONS(3768),
    [anon_sym_group] = ACTIONS(3768),
    [anon_sym_by] = ACTIONS(3768),
    [anon_sym_select] = ACTIONS(3768),
    [anon_sym_DQUOTE] = ACTIONS(3768),
    [anon_sym_stackalloc] = ACTIONS(3768),
    [anon_sym_sizeof] = ACTIONS(3768),
    [anon_sym_typeof] = ACTIONS(3768),
    [anon_sym___makeref] = ACTIONS(3768),
    [anon_sym___reftype] = ACTIONS(3768),
    [anon_sym___refvalue] = ACTIONS(3768),
    [sym_null_literal] = ACTIONS(3768),
    [anon_sym_SQUOTE] = ACTIONS(3770),
    [sym_integer_literal] = ACTIONS(3768),
    [sym_real_literal] = ACTIONS(3770),
    [sym_verbatim_string_literal] = ACTIONS(3770),
    [sym_raw_string_literal] = ACTIONS(3770),
    [aux_sym_preproc_if_token1] = ACTIONS(3770),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3770),
    [sym_interpolation_verbatim_start] = ACTIONS(3770),
    [sym_interpolation_raw_start] = ACTIONS(3770),
  },
  [2592] = {
    [sym_preproc_region] = STATE(2592),
    [sym_preproc_endregion] = STATE(2592),
    [sym_preproc_line] = STATE(2592),
    [sym_preproc_pragma] = STATE(2592),
    [sym_preproc_nullable] = STATE(2592),
    [sym_preproc_error] = STATE(2592),
    [sym_preproc_define] = STATE(2592),
    [sym_preproc_undef] = STATE(2592),
    [ts_builtin_sym_end] = ACTIONS(3443),
    [sym__identifier_token] = ACTIONS(3441),
    [anon_sym_extern] = ACTIONS(3441),
    [anon_sym_alias] = ACTIONS(3441),
    [anon_sym_SEMI] = ACTIONS(3443),
    [anon_sym_global] = ACTIONS(3441),
    [anon_sym_using] = ACTIONS(3441),
    [anon_sym_unsafe] = ACTIONS(3441),
    [anon_sym_static] = ACTIONS(3441),
    [anon_sym_LBRACK] = ACTIONS(3443),
    [anon_sym_LPAREN] = ACTIONS(3443),
    [anon_sym_return] = ACTIONS(3441),
    [anon_sym_namespace] = ACTIONS(3441),
    [anon_sym_class] = ACTIONS(3441),
    [anon_sym_ref] = ACTIONS(3441),
    [anon_sym_struct] = ACTIONS(3441),
    [anon_sym_enum] = ACTIONS(3441),
    [anon_sym_LBRACE] = ACTIONS(3443),
    [anon_sym_interface] = ACTIONS(3441),
    [anon_sym_delegate] = ACTIONS(3441),
    [anon_sym_record] = ACTIONS(3441),
    [anon_sym_abstract] = ACTIONS(3441),
    [anon_sym_async] = ACTIONS(3441),
    [anon_sym_const] = ACTIONS(3441),
    [anon_sym_file] = ACTIONS(3441),
    [anon_sym_fixed] = ACTIONS(3441),
    [anon_sym_internal] = ACTIONS(3441),
    [anon_sym_new] = ACTIONS(3441),
    [anon_sym_override] = ACTIONS(3441),
    [anon_sym_partial] = ACTIONS(3441),
    [anon_sym_private] = ACTIONS(3441),
    [anon_sym_protected] = ACTIONS(3441),
    [anon_sym_public] = ACTIONS(3441),
    [anon_sym_readonly] = ACTIONS(3441),
    [anon_sym_required] = ACTIONS(3441),
    [anon_sym_sealed] = ACTIONS(3441),
    [anon_sym_virtual] = ACTIONS(3441),
    [anon_sym_volatile] = ACTIONS(3441),
    [anon_sym_where] = ACTIONS(3441),
    [anon_sym_notnull] = ACTIONS(3441),
    [anon_sym_unmanaged] = ACTIONS(3441),
    [anon_sym_checked] = ACTIONS(3441),
    [anon_sym_BANG] = ACTIONS(3443),
    [anon_sym_TILDE] = ACTIONS(3443),
    [anon_sym_PLUS_PLUS] = ACTIONS(3443),
    [anon_sym_DASH_DASH] = ACTIONS(3443),
    [anon_sym_true] = ACTIONS(3441),
    [anon_sym_false] = ACTIONS(3441),
    [anon_sym_PLUS] = ACTIONS(3441),
    [anon_sym_DASH] = ACTIONS(3441),
    [anon_sym_STAR] = ACTIONS(3443),
    [anon_sym_CARET] = ACTIONS(3443),
    [anon_sym_AMP] = ACTIONS(3443),
    [anon_sym_this] = ACTIONS(3441),
    [anon_sym_scoped] = ACTIONS(3441),
    [anon_sym_var] = ACTIONS(3441),
    [sym_predefined_type] = ACTIONS(3441),
    [anon_sym_break] = ACTIONS(3441),
    [anon_sym_unchecked] = ACTIONS(3441),
    [anon_sym_continue] = ACTIONS(3441),
    [anon_sym_do] = ACTIONS(3441),
    [anon_sym_while] = ACTIONS(3441),
    [anon_sym_for] = ACTIONS(3441),
    [anon_sym_lock] = ACTIONS(3441),
    [anon_sym_yield] = ACTIONS(3441),
    [anon_sym_switch] = ACTIONS(3441),
    [anon_sym_default] = ACTIONS(3441),
    [anon_sym_throw] = ACTIONS(3441),
    [anon_sym_try] = ACTIONS(3441),
    [anon_sym_when] = ACTIONS(3441),
    [anon_sym_await] = ACTIONS(3441),
    [anon_sym_foreach] = ACTIONS(3441),
    [anon_sym_goto] = ACTIONS(3441),
    [anon_sym_if] = ACTIONS(3441),
    [anon_sym_DOT_DOT] = ACTIONS(3443),
    [anon_sym_from] = ACTIONS(3441),
    [anon_sym_into] = ACTIONS(3441),
    [anon_sym_join] = ACTIONS(3441),
    [anon_sym_on] = ACTIONS(3441),
    [anon_sym_equals] = ACTIONS(3441),
    [anon_sym_let] = ACTIONS(3441),
    [anon_sym_orderby] = ACTIONS(3441),
    [anon_sym_ascending] = ACTIONS(3441),
    [anon_sym_descending] = ACTIONS(3441),
    [anon_sym_group] = ACTIONS(3441),
    [anon_sym_by] = ACTIONS(3441),
    [anon_sym_select] = ACTIONS(3441),
    [anon_sym_DQUOTE] = ACTIONS(3441),
    [anon_sym_stackalloc] = ACTIONS(3441),
    [anon_sym_sizeof] = ACTIONS(3441),
    [anon_sym_typeof] = ACTIONS(3441),
    [anon_sym___makeref] = ACTIONS(3441),
    [anon_sym___reftype] = ACTIONS(3441),
    [anon_sym___refvalue] = ACTIONS(3441),
    [sym_null_literal] = ACTIONS(3441),
    [anon_sym_SQUOTE] = ACTIONS(3443),
    [sym_integer_literal] = ACTIONS(3441),
    [sym_real_literal] = ACTIONS(3443),
    [sym_verbatim_string_literal] = ACTIONS(3443),
    [sym_raw_string_literal] = ACTIONS(3443),
    [aux_sym_preproc_if_token1] = ACTIONS(3443),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3443),
    [sym_interpolation_verbatim_start] = ACTIONS(3443),
    [sym_interpolation_raw_start] = ACTIONS(3443),
  },
  [2593] = {
    [sym_preproc_region] = STATE(2593),
    [sym_preproc_endregion] = STATE(2593),
    [sym_preproc_line] = STATE(2593),
    [sym_preproc_pragma] = STATE(2593),
    [sym_preproc_nullable] = STATE(2593),
    [sym_preproc_error] = STATE(2593),
    [sym_preproc_define] = STATE(2593),
    [sym_preproc_undef] = STATE(2593),
    [ts_builtin_sym_end] = ACTIONS(3427),
    [sym__identifier_token] = ACTIONS(3425),
    [anon_sym_extern] = ACTIONS(3425),
    [anon_sym_alias] = ACTIONS(3425),
    [anon_sym_SEMI] = ACTIONS(3427),
    [anon_sym_global] = ACTIONS(3425),
    [anon_sym_using] = ACTIONS(3425),
    [anon_sym_unsafe] = ACTIONS(3425),
    [anon_sym_static] = ACTIONS(3425),
    [anon_sym_LBRACK] = ACTIONS(3427),
    [anon_sym_LPAREN] = ACTIONS(3427),
    [anon_sym_return] = ACTIONS(3425),
    [anon_sym_namespace] = ACTIONS(3425),
    [anon_sym_class] = ACTIONS(3425),
    [anon_sym_ref] = ACTIONS(3425),
    [anon_sym_struct] = ACTIONS(3425),
    [anon_sym_enum] = ACTIONS(3425),
    [anon_sym_LBRACE] = ACTIONS(3427),
    [anon_sym_interface] = ACTIONS(3425),
    [anon_sym_delegate] = ACTIONS(3425),
    [anon_sym_record] = ACTIONS(3425),
    [anon_sym_abstract] = ACTIONS(3425),
    [anon_sym_async] = ACTIONS(3425),
    [anon_sym_const] = ACTIONS(3425),
    [anon_sym_file] = ACTIONS(3425),
    [anon_sym_fixed] = ACTIONS(3425),
    [anon_sym_internal] = ACTIONS(3425),
    [anon_sym_new] = ACTIONS(3425),
    [anon_sym_override] = ACTIONS(3425),
    [anon_sym_partial] = ACTIONS(3425),
    [anon_sym_private] = ACTIONS(3425),
    [anon_sym_protected] = ACTIONS(3425),
    [anon_sym_public] = ACTIONS(3425),
    [anon_sym_readonly] = ACTIONS(3425),
    [anon_sym_required] = ACTIONS(3425),
    [anon_sym_sealed] = ACTIONS(3425),
    [anon_sym_virtual] = ACTIONS(3425),
    [anon_sym_volatile] = ACTIONS(3425),
    [anon_sym_where] = ACTIONS(3425),
    [anon_sym_notnull] = ACTIONS(3425),
    [anon_sym_unmanaged] = ACTIONS(3425),
    [anon_sym_checked] = ACTIONS(3425),
    [anon_sym_BANG] = ACTIONS(3427),
    [anon_sym_TILDE] = ACTIONS(3427),
    [anon_sym_PLUS_PLUS] = ACTIONS(3427),
    [anon_sym_DASH_DASH] = ACTIONS(3427),
    [anon_sym_true] = ACTIONS(3425),
    [anon_sym_false] = ACTIONS(3425),
    [anon_sym_PLUS] = ACTIONS(3425),
    [anon_sym_DASH] = ACTIONS(3425),
    [anon_sym_STAR] = ACTIONS(3427),
    [anon_sym_CARET] = ACTIONS(3427),
    [anon_sym_AMP] = ACTIONS(3427),
    [anon_sym_this] = ACTIONS(3425),
    [anon_sym_scoped] = ACTIONS(3425),
    [anon_sym_var] = ACTIONS(3425),
    [sym_predefined_type] = ACTIONS(3425),
    [anon_sym_break] = ACTIONS(3425),
    [anon_sym_unchecked] = ACTIONS(3425),
    [anon_sym_continue] = ACTIONS(3425),
    [anon_sym_do] = ACTIONS(3425),
    [anon_sym_while] = ACTIONS(3425),
    [anon_sym_for] = ACTIONS(3425),
    [anon_sym_lock] = ACTIONS(3425),
    [anon_sym_yield] = ACTIONS(3425),
    [anon_sym_switch] = ACTIONS(3425),
    [anon_sym_default] = ACTIONS(3425),
    [anon_sym_throw] = ACTIONS(3425),
    [anon_sym_try] = ACTIONS(3425),
    [anon_sym_when] = ACTIONS(3425),
    [anon_sym_await] = ACTIONS(3425),
    [anon_sym_foreach] = ACTIONS(3425),
    [anon_sym_goto] = ACTIONS(3425),
    [anon_sym_if] = ACTIONS(3425),
    [anon_sym_DOT_DOT] = ACTIONS(3427),
    [anon_sym_from] = ACTIONS(3425),
    [anon_sym_into] = ACTIONS(3425),
    [anon_sym_join] = ACTIONS(3425),
    [anon_sym_on] = ACTIONS(3425),
    [anon_sym_equals] = ACTIONS(3425),
    [anon_sym_let] = ACTIONS(3425),
    [anon_sym_orderby] = ACTIONS(3425),
    [anon_sym_ascending] = ACTIONS(3425),
    [anon_sym_descending] = ACTIONS(3425),
    [anon_sym_group] = ACTIONS(3425),
    [anon_sym_by] = ACTIONS(3425),
    [anon_sym_select] = ACTIONS(3425),
    [anon_sym_DQUOTE] = ACTIONS(3425),
    [anon_sym_stackalloc] = ACTIONS(3425),
    [anon_sym_sizeof] = ACTIONS(3425),
    [anon_sym_typeof] = ACTIONS(3425),
    [anon_sym___makeref] = ACTIONS(3425),
    [anon_sym___reftype] = ACTIONS(3425),
    [anon_sym___refvalue] = ACTIONS(3425),
    [sym_null_literal] = ACTIONS(3425),
    [anon_sym_SQUOTE] = ACTIONS(3427),
    [sym_integer_literal] = ACTIONS(3425),
    [sym_real_literal] = ACTIONS(3427),
    [sym_verbatim_string_literal] = ACTIONS(3427),
    [sym_raw_string_literal] = ACTIONS(3427),
    [aux_sym_preproc_if_token1] = ACTIONS(3427),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3427),
    [sym_interpolation_verbatim_start] = ACTIONS(3427),
    [sym_interpolation_raw_start] = ACTIONS(3427),
  },
  [2594] = {
    [sym_preproc_region] = STATE(2594),
    [sym_preproc_endregion] = STATE(2594),
    [sym_preproc_line] = STATE(2594),
    [sym_preproc_pragma] = STATE(2594),
    [sym_preproc_nullable] = STATE(2594),
    [sym_preproc_error] = STATE(2594),
    [sym_preproc_define] = STATE(2594),
    [sym_preproc_undef] = STATE(2594),
    [ts_builtin_sym_end] = ACTIONS(3786),
    [sym__identifier_token] = ACTIONS(3784),
    [anon_sym_extern] = ACTIONS(3784),
    [anon_sym_alias] = ACTIONS(3784),
    [anon_sym_SEMI] = ACTIONS(3786),
    [anon_sym_global] = ACTIONS(3784),
    [anon_sym_using] = ACTIONS(3784),
    [anon_sym_unsafe] = ACTIONS(3784),
    [anon_sym_static] = ACTIONS(3784),
    [anon_sym_LBRACK] = ACTIONS(3786),
    [anon_sym_LPAREN] = ACTIONS(3786),
    [anon_sym_return] = ACTIONS(3784),
    [anon_sym_namespace] = ACTIONS(3784),
    [anon_sym_class] = ACTIONS(3784),
    [anon_sym_ref] = ACTIONS(3784),
    [anon_sym_struct] = ACTIONS(3784),
    [anon_sym_enum] = ACTIONS(3784),
    [anon_sym_LBRACE] = ACTIONS(3786),
    [anon_sym_interface] = ACTIONS(3784),
    [anon_sym_delegate] = ACTIONS(3784),
    [anon_sym_record] = ACTIONS(3784),
    [anon_sym_abstract] = ACTIONS(3784),
    [anon_sym_async] = ACTIONS(3784),
    [anon_sym_const] = ACTIONS(3784),
    [anon_sym_file] = ACTIONS(3784),
    [anon_sym_fixed] = ACTIONS(3784),
    [anon_sym_internal] = ACTIONS(3784),
    [anon_sym_new] = ACTIONS(3784),
    [anon_sym_override] = ACTIONS(3784),
    [anon_sym_partial] = ACTIONS(3784),
    [anon_sym_private] = ACTIONS(3784),
    [anon_sym_protected] = ACTIONS(3784),
    [anon_sym_public] = ACTIONS(3784),
    [anon_sym_readonly] = ACTIONS(3784),
    [anon_sym_required] = ACTIONS(3784),
    [anon_sym_sealed] = ACTIONS(3784),
    [anon_sym_virtual] = ACTIONS(3784),
    [anon_sym_volatile] = ACTIONS(3784),
    [anon_sym_where] = ACTIONS(3784),
    [anon_sym_notnull] = ACTIONS(3784),
    [anon_sym_unmanaged] = ACTIONS(3784),
    [anon_sym_checked] = ACTIONS(3784),
    [anon_sym_BANG] = ACTIONS(3786),
    [anon_sym_TILDE] = ACTIONS(3786),
    [anon_sym_PLUS_PLUS] = ACTIONS(3786),
    [anon_sym_DASH_DASH] = ACTIONS(3786),
    [anon_sym_true] = ACTIONS(3784),
    [anon_sym_false] = ACTIONS(3784),
    [anon_sym_PLUS] = ACTIONS(3784),
    [anon_sym_DASH] = ACTIONS(3784),
    [anon_sym_STAR] = ACTIONS(3786),
    [anon_sym_CARET] = ACTIONS(3786),
    [anon_sym_AMP] = ACTIONS(3786),
    [anon_sym_this] = ACTIONS(3784),
    [anon_sym_scoped] = ACTIONS(3784),
    [anon_sym_var] = ACTIONS(3784),
    [sym_predefined_type] = ACTIONS(3784),
    [anon_sym_break] = ACTIONS(3784),
    [anon_sym_unchecked] = ACTIONS(3784),
    [anon_sym_continue] = ACTIONS(3784),
    [anon_sym_do] = ACTIONS(3784),
    [anon_sym_while] = ACTIONS(3784),
    [anon_sym_for] = ACTIONS(3784),
    [anon_sym_lock] = ACTIONS(3784),
    [anon_sym_yield] = ACTIONS(3784),
    [anon_sym_switch] = ACTIONS(3784),
    [anon_sym_default] = ACTIONS(3784),
    [anon_sym_throw] = ACTIONS(3784),
    [anon_sym_try] = ACTIONS(3784),
    [anon_sym_when] = ACTIONS(3784),
    [anon_sym_await] = ACTIONS(3784),
    [anon_sym_foreach] = ACTIONS(3784),
    [anon_sym_goto] = ACTIONS(3784),
    [anon_sym_if] = ACTIONS(3784),
    [anon_sym_DOT_DOT] = ACTIONS(3786),
    [anon_sym_from] = ACTIONS(3784),
    [anon_sym_into] = ACTIONS(3784),
    [anon_sym_join] = ACTIONS(3784),
    [anon_sym_on] = ACTIONS(3784),
    [anon_sym_equals] = ACTIONS(3784),
    [anon_sym_let] = ACTIONS(3784),
    [anon_sym_orderby] = ACTIONS(3784),
    [anon_sym_ascending] = ACTIONS(3784),
    [anon_sym_descending] = ACTIONS(3784),
    [anon_sym_group] = ACTIONS(3784),
    [anon_sym_by] = ACTIONS(3784),
    [anon_sym_select] = ACTIONS(3784),
    [anon_sym_DQUOTE] = ACTIONS(3784),
    [anon_sym_stackalloc] = ACTIONS(3784),
    [anon_sym_sizeof] = ACTIONS(3784),
    [anon_sym_typeof] = ACTIONS(3784),
    [anon_sym___makeref] = ACTIONS(3784),
    [anon_sym___reftype] = ACTIONS(3784),
    [anon_sym___refvalue] = ACTIONS(3784),
    [sym_null_literal] = ACTIONS(3784),
    [anon_sym_SQUOTE] = ACTIONS(3786),
    [sym_integer_literal] = ACTIONS(3784),
    [sym_real_literal] = ACTIONS(3786),
    [sym_verbatim_string_literal] = ACTIONS(3786),
    [sym_raw_string_literal] = ACTIONS(3786),
    [aux_sym_preproc_if_token1] = ACTIONS(3786),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3786),
    [sym_interpolation_verbatim_start] = ACTIONS(3786),
    [sym_interpolation_raw_start] = ACTIONS(3786),
  },
  [2595] = {
    [sym_preproc_region] = STATE(2595),
    [sym_preproc_endregion] = STATE(2595),
    [sym_preproc_line] = STATE(2595),
    [sym_preproc_pragma] = STATE(2595),
    [sym_preproc_nullable] = STATE(2595),
    [sym_preproc_error] = STATE(2595),
    [sym_preproc_define] = STATE(2595),
    [sym_preproc_undef] = STATE(2595),
    [ts_builtin_sym_end] = ACTIONS(3591),
    [sym__identifier_token] = ACTIONS(3589),
    [anon_sym_extern] = ACTIONS(3589),
    [anon_sym_alias] = ACTIONS(3589),
    [anon_sym_SEMI] = ACTIONS(3591),
    [anon_sym_global] = ACTIONS(3589),
    [anon_sym_using] = ACTIONS(3589),
    [anon_sym_unsafe] = ACTIONS(3589),
    [anon_sym_static] = ACTIONS(3589),
    [anon_sym_LBRACK] = ACTIONS(3591),
    [anon_sym_LPAREN] = ACTIONS(3591),
    [anon_sym_return] = ACTIONS(3589),
    [anon_sym_namespace] = ACTIONS(3589),
    [anon_sym_class] = ACTIONS(3589),
    [anon_sym_ref] = ACTIONS(3589),
    [anon_sym_struct] = ACTIONS(3589),
    [anon_sym_enum] = ACTIONS(3589),
    [anon_sym_LBRACE] = ACTIONS(3591),
    [anon_sym_interface] = ACTIONS(3589),
    [anon_sym_delegate] = ACTIONS(3589),
    [anon_sym_record] = ACTIONS(3589),
    [anon_sym_abstract] = ACTIONS(3589),
    [anon_sym_async] = ACTIONS(3589),
    [anon_sym_const] = ACTIONS(3589),
    [anon_sym_file] = ACTIONS(3589),
    [anon_sym_fixed] = ACTIONS(3589),
    [anon_sym_internal] = ACTIONS(3589),
    [anon_sym_new] = ACTIONS(3589),
    [anon_sym_override] = ACTIONS(3589),
    [anon_sym_partial] = ACTIONS(3589),
    [anon_sym_private] = ACTIONS(3589),
    [anon_sym_protected] = ACTIONS(3589),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_readonly] = ACTIONS(3589),
    [anon_sym_required] = ACTIONS(3589),
    [anon_sym_sealed] = ACTIONS(3589),
    [anon_sym_virtual] = ACTIONS(3589),
    [anon_sym_volatile] = ACTIONS(3589),
    [anon_sym_where] = ACTIONS(3589),
    [anon_sym_notnull] = ACTIONS(3589),
    [anon_sym_unmanaged] = ACTIONS(3589),
    [anon_sym_checked] = ACTIONS(3589),
    [anon_sym_BANG] = ACTIONS(3591),
    [anon_sym_TILDE] = ACTIONS(3591),
    [anon_sym_PLUS_PLUS] = ACTIONS(3591),
    [anon_sym_DASH_DASH] = ACTIONS(3591),
    [anon_sym_true] = ACTIONS(3589),
    [anon_sym_false] = ACTIONS(3589),
    [anon_sym_PLUS] = ACTIONS(3589),
    [anon_sym_DASH] = ACTIONS(3589),
    [anon_sym_STAR] = ACTIONS(3591),
    [anon_sym_CARET] = ACTIONS(3591),
    [anon_sym_AMP] = ACTIONS(3591),
    [anon_sym_this] = ACTIONS(3589),
    [anon_sym_scoped] = ACTIONS(3589),
    [anon_sym_var] = ACTIONS(3589),
    [sym_predefined_type] = ACTIONS(3589),
    [anon_sym_break] = ACTIONS(3589),
    [anon_sym_unchecked] = ACTIONS(3589),
    [anon_sym_continue] = ACTIONS(3589),
    [anon_sym_do] = ACTIONS(3589),
    [anon_sym_while] = ACTIONS(3589),
    [anon_sym_for] = ACTIONS(3589),
    [anon_sym_lock] = ACTIONS(3589),
    [anon_sym_yield] = ACTIONS(3589),
    [anon_sym_switch] = ACTIONS(3589),
    [anon_sym_default] = ACTIONS(3589),
    [anon_sym_throw] = ACTIONS(3589),
    [anon_sym_try] = ACTIONS(3589),
    [anon_sym_when] = ACTIONS(3589),
    [anon_sym_await] = ACTIONS(3589),
    [anon_sym_foreach] = ACTIONS(3589),
    [anon_sym_goto] = ACTIONS(3589),
    [anon_sym_if] = ACTIONS(3589),
    [anon_sym_DOT_DOT] = ACTIONS(3591),
    [anon_sym_from] = ACTIONS(3589),
    [anon_sym_into] = ACTIONS(3589),
    [anon_sym_join] = ACTIONS(3589),
    [anon_sym_on] = ACTIONS(3589),
    [anon_sym_equals] = ACTIONS(3589),
    [anon_sym_let] = ACTIONS(3589),
    [anon_sym_orderby] = ACTIONS(3589),
    [anon_sym_ascending] = ACTIONS(3589),
    [anon_sym_descending] = ACTIONS(3589),
    [anon_sym_group] = ACTIONS(3589),
    [anon_sym_by] = ACTIONS(3589),
    [anon_sym_select] = ACTIONS(3589),
    [anon_sym_DQUOTE] = ACTIONS(3589),
    [anon_sym_stackalloc] = ACTIONS(3589),
    [anon_sym_sizeof] = ACTIONS(3589),
    [anon_sym_typeof] = ACTIONS(3589),
    [anon_sym___makeref] = ACTIONS(3589),
    [anon_sym___reftype] = ACTIONS(3589),
    [anon_sym___refvalue] = ACTIONS(3589),
    [sym_null_literal] = ACTIONS(3589),
    [anon_sym_SQUOTE] = ACTIONS(3591),
    [sym_integer_literal] = ACTIONS(3589),
    [sym_real_literal] = ACTIONS(3591),
    [sym_verbatim_string_literal] = ACTIONS(3591),
    [sym_raw_string_literal] = ACTIONS(3591),
    [aux_sym_preproc_if_token1] = ACTIONS(3591),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3591),
    [sym_interpolation_verbatim_start] = ACTIONS(3591),
    [sym_interpolation_raw_start] = ACTIONS(3591),
  },
  [2596] = {
    [sym_preproc_region] = STATE(2596),
    [sym_preproc_endregion] = STATE(2596),
    [sym_preproc_line] = STATE(2596),
    [sym_preproc_pragma] = STATE(2596),
    [sym_preproc_nullable] = STATE(2596),
    [sym_preproc_error] = STATE(2596),
    [sym_preproc_define] = STATE(2596),
    [sym_preproc_undef] = STATE(2596),
    [ts_builtin_sym_end] = ACTIONS(3575),
    [sym__identifier_token] = ACTIONS(3573),
    [anon_sym_extern] = ACTIONS(3573),
    [anon_sym_alias] = ACTIONS(3573),
    [anon_sym_SEMI] = ACTIONS(3575),
    [anon_sym_global] = ACTIONS(3573),
    [anon_sym_using] = ACTIONS(3573),
    [anon_sym_unsafe] = ACTIONS(3573),
    [anon_sym_static] = ACTIONS(3573),
    [anon_sym_LBRACK] = ACTIONS(3575),
    [anon_sym_LPAREN] = ACTIONS(3575),
    [anon_sym_return] = ACTIONS(3573),
    [anon_sym_namespace] = ACTIONS(3573),
    [anon_sym_class] = ACTIONS(3573),
    [anon_sym_ref] = ACTIONS(3573),
    [anon_sym_struct] = ACTIONS(3573),
    [anon_sym_enum] = ACTIONS(3573),
    [anon_sym_LBRACE] = ACTIONS(3575),
    [anon_sym_interface] = ACTIONS(3573),
    [anon_sym_delegate] = ACTIONS(3573),
    [anon_sym_record] = ACTIONS(3573),
    [anon_sym_abstract] = ACTIONS(3573),
    [anon_sym_async] = ACTIONS(3573),
    [anon_sym_const] = ACTIONS(3573),
    [anon_sym_file] = ACTIONS(3573),
    [anon_sym_fixed] = ACTIONS(3573),
    [anon_sym_internal] = ACTIONS(3573),
    [anon_sym_new] = ACTIONS(3573),
    [anon_sym_override] = ACTIONS(3573),
    [anon_sym_partial] = ACTIONS(3573),
    [anon_sym_private] = ACTIONS(3573),
    [anon_sym_protected] = ACTIONS(3573),
    [anon_sym_public] = ACTIONS(3573),
    [anon_sym_readonly] = ACTIONS(3573),
    [anon_sym_required] = ACTIONS(3573),
    [anon_sym_sealed] = ACTIONS(3573),
    [anon_sym_virtual] = ACTIONS(3573),
    [anon_sym_volatile] = ACTIONS(3573),
    [anon_sym_where] = ACTIONS(3573),
    [anon_sym_notnull] = ACTIONS(3573),
    [anon_sym_unmanaged] = ACTIONS(3573),
    [anon_sym_checked] = ACTIONS(3573),
    [anon_sym_BANG] = ACTIONS(3575),
    [anon_sym_TILDE] = ACTIONS(3575),
    [anon_sym_PLUS_PLUS] = ACTIONS(3575),
    [anon_sym_DASH_DASH] = ACTIONS(3575),
    [anon_sym_true] = ACTIONS(3573),
    [anon_sym_false] = ACTIONS(3573),
    [anon_sym_PLUS] = ACTIONS(3573),
    [anon_sym_DASH] = ACTIONS(3573),
    [anon_sym_STAR] = ACTIONS(3575),
    [anon_sym_CARET] = ACTIONS(3575),
    [anon_sym_AMP] = ACTIONS(3575),
    [anon_sym_this] = ACTIONS(3573),
    [anon_sym_scoped] = ACTIONS(3573),
    [anon_sym_var] = ACTIONS(3573),
    [sym_predefined_type] = ACTIONS(3573),
    [anon_sym_break] = ACTIONS(3573),
    [anon_sym_unchecked] = ACTIONS(3573),
    [anon_sym_continue] = ACTIONS(3573),
    [anon_sym_do] = ACTIONS(3573),
    [anon_sym_while] = ACTIONS(3573),
    [anon_sym_for] = ACTIONS(3573),
    [anon_sym_lock] = ACTIONS(3573),
    [anon_sym_yield] = ACTIONS(3573),
    [anon_sym_switch] = ACTIONS(3573),
    [anon_sym_default] = ACTIONS(3573),
    [anon_sym_throw] = ACTIONS(3573),
    [anon_sym_try] = ACTIONS(3573),
    [anon_sym_when] = ACTIONS(3573),
    [anon_sym_await] = ACTIONS(3573),
    [anon_sym_foreach] = ACTIONS(3573),
    [anon_sym_goto] = ACTIONS(3573),
    [anon_sym_if] = ACTIONS(3573),
    [anon_sym_DOT_DOT] = ACTIONS(3575),
    [anon_sym_from] = ACTIONS(3573),
    [anon_sym_into] = ACTIONS(3573),
    [anon_sym_join] = ACTIONS(3573),
    [anon_sym_on] = ACTIONS(3573),
    [anon_sym_equals] = ACTIONS(3573),
    [anon_sym_let] = ACTIONS(3573),
    [anon_sym_orderby] = ACTIONS(3573),
    [anon_sym_ascending] = ACTIONS(3573),
    [anon_sym_descending] = ACTIONS(3573),
    [anon_sym_group] = ACTIONS(3573),
    [anon_sym_by] = ACTIONS(3573),
    [anon_sym_select] = ACTIONS(3573),
    [anon_sym_DQUOTE] = ACTIONS(3573),
    [anon_sym_stackalloc] = ACTIONS(3573),
    [anon_sym_sizeof] = ACTIONS(3573),
    [anon_sym_typeof] = ACTIONS(3573),
    [anon_sym___makeref] = ACTIONS(3573),
    [anon_sym___reftype] = ACTIONS(3573),
    [anon_sym___refvalue] = ACTIONS(3573),
    [sym_null_literal] = ACTIONS(3573),
    [anon_sym_SQUOTE] = ACTIONS(3575),
    [sym_integer_literal] = ACTIONS(3573),
    [sym_real_literal] = ACTIONS(3575),
    [sym_verbatim_string_literal] = ACTIONS(3575),
    [sym_raw_string_literal] = ACTIONS(3575),
    [aux_sym_preproc_if_token1] = ACTIONS(3575),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3575),
    [sym_interpolation_verbatim_start] = ACTIONS(3575),
    [sym_interpolation_raw_start] = ACTIONS(3575),
  },
  [2597] = {
    [sym_preproc_region] = STATE(2597),
    [sym_preproc_endregion] = STATE(2597),
    [sym_preproc_line] = STATE(2597),
    [sym_preproc_pragma] = STATE(2597),
    [sym_preproc_nullable] = STATE(2597),
    [sym_preproc_error] = STATE(2597),
    [sym_preproc_define] = STATE(2597),
    [sym_preproc_undef] = STATE(2597),
    [ts_builtin_sym_end] = ACTIONS(3587),
    [sym__identifier_token] = ACTIONS(3585),
    [anon_sym_extern] = ACTIONS(3585),
    [anon_sym_alias] = ACTIONS(3585),
    [anon_sym_SEMI] = ACTIONS(3587),
    [anon_sym_global] = ACTIONS(3585),
    [anon_sym_using] = ACTIONS(3585),
    [anon_sym_unsafe] = ACTIONS(3585),
    [anon_sym_static] = ACTIONS(3585),
    [anon_sym_LBRACK] = ACTIONS(3587),
    [anon_sym_LPAREN] = ACTIONS(3587),
    [anon_sym_return] = ACTIONS(3585),
    [anon_sym_namespace] = ACTIONS(3585),
    [anon_sym_class] = ACTIONS(3585),
    [anon_sym_ref] = ACTIONS(3585),
    [anon_sym_struct] = ACTIONS(3585),
    [anon_sym_enum] = ACTIONS(3585),
    [anon_sym_LBRACE] = ACTIONS(3587),
    [anon_sym_interface] = ACTIONS(3585),
    [anon_sym_delegate] = ACTIONS(3585),
    [anon_sym_record] = ACTIONS(3585),
    [anon_sym_abstract] = ACTIONS(3585),
    [anon_sym_async] = ACTIONS(3585),
    [anon_sym_const] = ACTIONS(3585),
    [anon_sym_file] = ACTIONS(3585),
    [anon_sym_fixed] = ACTIONS(3585),
    [anon_sym_internal] = ACTIONS(3585),
    [anon_sym_new] = ACTIONS(3585),
    [anon_sym_override] = ACTIONS(3585),
    [anon_sym_partial] = ACTIONS(3585),
    [anon_sym_private] = ACTIONS(3585),
    [anon_sym_protected] = ACTIONS(3585),
    [anon_sym_public] = ACTIONS(3585),
    [anon_sym_readonly] = ACTIONS(3585),
    [anon_sym_required] = ACTIONS(3585),
    [anon_sym_sealed] = ACTIONS(3585),
    [anon_sym_virtual] = ACTIONS(3585),
    [anon_sym_volatile] = ACTIONS(3585),
    [anon_sym_where] = ACTIONS(3585),
    [anon_sym_notnull] = ACTIONS(3585),
    [anon_sym_unmanaged] = ACTIONS(3585),
    [anon_sym_checked] = ACTIONS(3585),
    [anon_sym_BANG] = ACTIONS(3587),
    [anon_sym_TILDE] = ACTIONS(3587),
    [anon_sym_PLUS_PLUS] = ACTIONS(3587),
    [anon_sym_DASH_DASH] = ACTIONS(3587),
    [anon_sym_true] = ACTIONS(3585),
    [anon_sym_false] = ACTIONS(3585),
    [anon_sym_PLUS] = ACTIONS(3585),
    [anon_sym_DASH] = ACTIONS(3585),
    [anon_sym_STAR] = ACTIONS(3587),
    [anon_sym_CARET] = ACTIONS(3587),
    [anon_sym_AMP] = ACTIONS(3587),
    [anon_sym_this] = ACTIONS(3585),
    [anon_sym_scoped] = ACTIONS(3585),
    [anon_sym_var] = ACTIONS(3585),
    [sym_predefined_type] = ACTIONS(3585),
    [anon_sym_break] = ACTIONS(3585),
    [anon_sym_unchecked] = ACTIONS(3585),
    [anon_sym_continue] = ACTIONS(3585),
    [anon_sym_do] = ACTIONS(3585),
    [anon_sym_while] = ACTIONS(3585),
    [anon_sym_for] = ACTIONS(3585),
    [anon_sym_lock] = ACTIONS(3585),
    [anon_sym_yield] = ACTIONS(3585),
    [anon_sym_switch] = ACTIONS(3585),
    [anon_sym_default] = ACTIONS(3585),
    [anon_sym_throw] = ACTIONS(3585),
    [anon_sym_try] = ACTIONS(3585),
    [anon_sym_when] = ACTIONS(3585),
    [anon_sym_await] = ACTIONS(3585),
    [anon_sym_foreach] = ACTIONS(3585),
    [anon_sym_goto] = ACTIONS(3585),
    [anon_sym_if] = ACTIONS(3585),
    [anon_sym_DOT_DOT] = ACTIONS(3587),
    [anon_sym_from] = ACTIONS(3585),
    [anon_sym_into] = ACTIONS(3585),
    [anon_sym_join] = ACTIONS(3585),
    [anon_sym_on] = ACTIONS(3585),
    [anon_sym_equals] = ACTIONS(3585),
    [anon_sym_let] = ACTIONS(3585),
    [anon_sym_orderby] = ACTIONS(3585),
    [anon_sym_ascending] = ACTIONS(3585),
    [anon_sym_descending] = ACTIONS(3585),
    [anon_sym_group] = ACTIONS(3585),
    [anon_sym_by] = ACTIONS(3585),
    [anon_sym_select] = ACTIONS(3585),
    [anon_sym_DQUOTE] = ACTIONS(3585),
    [anon_sym_stackalloc] = ACTIONS(3585),
    [anon_sym_sizeof] = ACTIONS(3585),
    [anon_sym_typeof] = ACTIONS(3585),
    [anon_sym___makeref] = ACTIONS(3585),
    [anon_sym___reftype] = ACTIONS(3585),
    [anon_sym___refvalue] = ACTIONS(3585),
    [sym_null_literal] = ACTIONS(3585),
    [anon_sym_SQUOTE] = ACTIONS(3587),
    [sym_integer_literal] = ACTIONS(3585),
    [sym_real_literal] = ACTIONS(3587),
    [sym_verbatim_string_literal] = ACTIONS(3587),
    [sym_raw_string_literal] = ACTIONS(3587),
    [aux_sym_preproc_if_token1] = ACTIONS(3587),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3587),
    [sym_interpolation_verbatim_start] = ACTIONS(3587),
    [sym_interpolation_raw_start] = ACTIONS(3587),
  },
  [2598] = {
    [sym_preproc_region] = STATE(2598),
    [sym_preproc_endregion] = STATE(2598),
    [sym_preproc_line] = STATE(2598),
    [sym_preproc_pragma] = STATE(2598),
    [sym_preproc_nullable] = STATE(2598),
    [sym_preproc_error] = STATE(2598),
    [sym_preproc_define] = STATE(2598),
    [sym_preproc_undef] = STATE(2598),
    [ts_builtin_sym_end] = ACTIONS(3583),
    [sym__identifier_token] = ACTIONS(3581),
    [anon_sym_extern] = ACTIONS(3581),
    [anon_sym_alias] = ACTIONS(3581),
    [anon_sym_SEMI] = ACTIONS(3583),
    [anon_sym_global] = ACTIONS(3581),
    [anon_sym_using] = ACTIONS(3581),
    [anon_sym_unsafe] = ACTIONS(3581),
    [anon_sym_static] = ACTIONS(3581),
    [anon_sym_LBRACK] = ACTIONS(3583),
    [anon_sym_LPAREN] = ACTIONS(3583),
    [anon_sym_return] = ACTIONS(3581),
    [anon_sym_namespace] = ACTIONS(3581),
    [anon_sym_class] = ACTIONS(3581),
    [anon_sym_ref] = ACTIONS(3581),
    [anon_sym_struct] = ACTIONS(3581),
    [anon_sym_enum] = ACTIONS(3581),
    [anon_sym_LBRACE] = ACTIONS(3583),
    [anon_sym_interface] = ACTIONS(3581),
    [anon_sym_delegate] = ACTIONS(3581),
    [anon_sym_record] = ACTIONS(3581),
    [anon_sym_abstract] = ACTIONS(3581),
    [anon_sym_async] = ACTIONS(3581),
    [anon_sym_const] = ACTIONS(3581),
    [anon_sym_file] = ACTIONS(3581),
    [anon_sym_fixed] = ACTIONS(3581),
    [anon_sym_internal] = ACTIONS(3581),
    [anon_sym_new] = ACTIONS(3581),
    [anon_sym_override] = ACTIONS(3581),
    [anon_sym_partial] = ACTIONS(3581),
    [anon_sym_private] = ACTIONS(3581),
    [anon_sym_protected] = ACTIONS(3581),
    [anon_sym_public] = ACTIONS(3581),
    [anon_sym_readonly] = ACTIONS(3581),
    [anon_sym_required] = ACTIONS(3581),
    [anon_sym_sealed] = ACTIONS(3581),
    [anon_sym_virtual] = ACTIONS(3581),
    [anon_sym_volatile] = ACTIONS(3581),
    [anon_sym_where] = ACTIONS(3581),
    [anon_sym_notnull] = ACTIONS(3581),
    [anon_sym_unmanaged] = ACTIONS(3581),
    [anon_sym_checked] = ACTIONS(3581),
    [anon_sym_BANG] = ACTIONS(3583),
    [anon_sym_TILDE] = ACTIONS(3583),
    [anon_sym_PLUS_PLUS] = ACTIONS(3583),
    [anon_sym_DASH_DASH] = ACTIONS(3583),
    [anon_sym_true] = ACTIONS(3581),
    [anon_sym_false] = ACTIONS(3581),
    [anon_sym_PLUS] = ACTIONS(3581),
    [anon_sym_DASH] = ACTIONS(3581),
    [anon_sym_STAR] = ACTIONS(3583),
    [anon_sym_CARET] = ACTIONS(3583),
    [anon_sym_AMP] = ACTIONS(3583),
    [anon_sym_this] = ACTIONS(3581),
    [anon_sym_scoped] = ACTIONS(3581),
    [anon_sym_var] = ACTIONS(3581),
    [sym_predefined_type] = ACTIONS(3581),
    [anon_sym_break] = ACTIONS(3581),
    [anon_sym_unchecked] = ACTIONS(3581),
    [anon_sym_continue] = ACTIONS(3581),
    [anon_sym_do] = ACTIONS(3581),
    [anon_sym_while] = ACTIONS(3581),
    [anon_sym_for] = ACTIONS(3581),
    [anon_sym_lock] = ACTIONS(3581),
    [anon_sym_yield] = ACTIONS(3581),
    [anon_sym_switch] = ACTIONS(3581),
    [anon_sym_default] = ACTIONS(3581),
    [anon_sym_throw] = ACTIONS(3581),
    [anon_sym_try] = ACTIONS(3581),
    [anon_sym_when] = ACTIONS(3581),
    [anon_sym_await] = ACTIONS(3581),
    [anon_sym_foreach] = ACTIONS(3581),
    [anon_sym_goto] = ACTIONS(3581),
    [anon_sym_if] = ACTIONS(3581),
    [anon_sym_DOT_DOT] = ACTIONS(3583),
    [anon_sym_from] = ACTIONS(3581),
    [anon_sym_into] = ACTIONS(3581),
    [anon_sym_join] = ACTIONS(3581),
    [anon_sym_on] = ACTIONS(3581),
    [anon_sym_equals] = ACTIONS(3581),
    [anon_sym_let] = ACTIONS(3581),
    [anon_sym_orderby] = ACTIONS(3581),
    [anon_sym_ascending] = ACTIONS(3581),
    [anon_sym_descending] = ACTIONS(3581),
    [anon_sym_group] = ACTIONS(3581),
    [anon_sym_by] = ACTIONS(3581),
    [anon_sym_select] = ACTIONS(3581),
    [anon_sym_DQUOTE] = ACTIONS(3581),
    [anon_sym_stackalloc] = ACTIONS(3581),
    [anon_sym_sizeof] = ACTIONS(3581),
    [anon_sym_typeof] = ACTIONS(3581),
    [anon_sym___makeref] = ACTIONS(3581),
    [anon_sym___reftype] = ACTIONS(3581),
    [anon_sym___refvalue] = ACTIONS(3581),
    [sym_null_literal] = ACTIONS(3581),
    [anon_sym_SQUOTE] = ACTIONS(3583),
    [sym_integer_literal] = ACTIONS(3581),
    [sym_real_literal] = ACTIONS(3583),
    [sym_verbatim_string_literal] = ACTIONS(3583),
    [sym_raw_string_literal] = ACTIONS(3583),
    [aux_sym_preproc_if_token1] = ACTIONS(3583),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3583),
    [sym_interpolation_verbatim_start] = ACTIONS(3583),
    [sym_interpolation_raw_start] = ACTIONS(3583),
  },
  [2599] = {
    [sym_preproc_region] = STATE(2599),
    [sym_preproc_endregion] = STATE(2599),
    [sym_preproc_line] = STATE(2599),
    [sym_preproc_pragma] = STATE(2599),
    [sym_preproc_nullable] = STATE(2599),
    [sym_preproc_error] = STATE(2599),
    [sym_preproc_define] = STATE(2599),
    [sym_preproc_undef] = STATE(2599),
    [ts_builtin_sym_end] = ACTIONS(3439),
    [sym__identifier_token] = ACTIONS(3437),
    [anon_sym_extern] = ACTIONS(3437),
    [anon_sym_alias] = ACTIONS(3437),
    [anon_sym_SEMI] = ACTIONS(3439),
    [anon_sym_global] = ACTIONS(3437),
    [anon_sym_using] = ACTIONS(3437),
    [anon_sym_unsafe] = ACTIONS(3437),
    [anon_sym_static] = ACTIONS(3437),
    [anon_sym_LBRACK] = ACTIONS(3439),
    [anon_sym_LPAREN] = ACTIONS(3439),
    [anon_sym_return] = ACTIONS(3437),
    [anon_sym_namespace] = ACTIONS(3437),
    [anon_sym_class] = ACTIONS(3437),
    [anon_sym_ref] = ACTIONS(3437),
    [anon_sym_struct] = ACTIONS(3437),
    [anon_sym_enum] = ACTIONS(3437),
    [anon_sym_LBRACE] = ACTIONS(3439),
    [anon_sym_interface] = ACTIONS(3437),
    [anon_sym_delegate] = ACTIONS(3437),
    [anon_sym_record] = ACTIONS(3437),
    [anon_sym_abstract] = ACTIONS(3437),
    [anon_sym_async] = ACTIONS(3437),
    [anon_sym_const] = ACTIONS(3437),
    [anon_sym_file] = ACTIONS(3437),
    [anon_sym_fixed] = ACTIONS(3437),
    [anon_sym_internal] = ACTIONS(3437),
    [anon_sym_new] = ACTIONS(3437),
    [anon_sym_override] = ACTIONS(3437),
    [anon_sym_partial] = ACTIONS(3437),
    [anon_sym_private] = ACTIONS(3437),
    [anon_sym_protected] = ACTIONS(3437),
    [anon_sym_public] = ACTIONS(3437),
    [anon_sym_readonly] = ACTIONS(3437),
    [anon_sym_required] = ACTIONS(3437),
    [anon_sym_sealed] = ACTIONS(3437),
    [anon_sym_virtual] = ACTIONS(3437),
    [anon_sym_volatile] = ACTIONS(3437),
    [anon_sym_where] = ACTIONS(3437),
    [anon_sym_notnull] = ACTIONS(3437),
    [anon_sym_unmanaged] = ACTIONS(3437),
    [anon_sym_checked] = ACTIONS(3437),
    [anon_sym_BANG] = ACTIONS(3439),
    [anon_sym_TILDE] = ACTIONS(3439),
    [anon_sym_PLUS_PLUS] = ACTIONS(3439),
    [anon_sym_DASH_DASH] = ACTIONS(3439),
    [anon_sym_true] = ACTIONS(3437),
    [anon_sym_false] = ACTIONS(3437),
    [anon_sym_PLUS] = ACTIONS(3437),
    [anon_sym_DASH] = ACTIONS(3437),
    [anon_sym_STAR] = ACTIONS(3439),
    [anon_sym_CARET] = ACTIONS(3439),
    [anon_sym_AMP] = ACTIONS(3439),
    [anon_sym_this] = ACTIONS(3437),
    [anon_sym_scoped] = ACTIONS(3437),
    [anon_sym_var] = ACTIONS(3437),
    [sym_predefined_type] = ACTIONS(3437),
    [anon_sym_break] = ACTIONS(3437),
    [anon_sym_unchecked] = ACTIONS(3437),
    [anon_sym_continue] = ACTIONS(3437),
    [anon_sym_do] = ACTIONS(3437),
    [anon_sym_while] = ACTIONS(3437),
    [anon_sym_for] = ACTIONS(3437),
    [anon_sym_lock] = ACTIONS(3437),
    [anon_sym_yield] = ACTIONS(3437),
    [anon_sym_switch] = ACTIONS(3437),
    [anon_sym_default] = ACTIONS(3437),
    [anon_sym_throw] = ACTIONS(3437),
    [anon_sym_try] = ACTIONS(3437),
    [anon_sym_when] = ACTIONS(3437),
    [anon_sym_await] = ACTIONS(3437),
    [anon_sym_foreach] = ACTIONS(3437),
    [anon_sym_goto] = ACTIONS(3437),
    [anon_sym_if] = ACTIONS(3437),
    [anon_sym_DOT_DOT] = ACTIONS(3439),
    [anon_sym_from] = ACTIONS(3437),
    [anon_sym_into] = ACTIONS(3437),
    [anon_sym_join] = ACTIONS(3437),
    [anon_sym_on] = ACTIONS(3437),
    [anon_sym_equals] = ACTIONS(3437),
    [anon_sym_let] = ACTIONS(3437),
    [anon_sym_orderby] = ACTIONS(3437),
    [anon_sym_ascending] = ACTIONS(3437),
    [anon_sym_descending] = ACTIONS(3437),
    [anon_sym_group] = ACTIONS(3437),
    [anon_sym_by] = ACTIONS(3437),
    [anon_sym_select] = ACTIONS(3437),
    [anon_sym_DQUOTE] = ACTIONS(3437),
    [anon_sym_stackalloc] = ACTIONS(3437),
    [anon_sym_sizeof] = ACTIONS(3437),
    [anon_sym_typeof] = ACTIONS(3437),
    [anon_sym___makeref] = ACTIONS(3437),
    [anon_sym___reftype] = ACTIONS(3437),
    [anon_sym___refvalue] = ACTIONS(3437),
    [sym_null_literal] = ACTIONS(3437),
    [anon_sym_SQUOTE] = ACTIONS(3439),
    [sym_integer_literal] = ACTIONS(3437),
    [sym_real_literal] = ACTIONS(3439),
    [sym_verbatim_string_literal] = ACTIONS(3439),
    [sym_raw_string_literal] = ACTIONS(3439),
    [aux_sym_preproc_if_token1] = ACTIONS(3439),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3439),
    [sym_interpolation_verbatim_start] = ACTIONS(3439),
    [sym_interpolation_raw_start] = ACTIONS(3439),
  },
  [2600] = {
    [sym_preproc_region] = STATE(2600),
    [sym_preproc_endregion] = STATE(2600),
    [sym_preproc_line] = STATE(2600),
    [sym_preproc_pragma] = STATE(2600),
    [sym_preproc_nullable] = STATE(2600),
    [sym_preproc_error] = STATE(2600),
    [sym_preproc_define] = STATE(2600),
    [sym_preproc_undef] = STATE(2600),
    [ts_builtin_sym_end] = ACTIONS(3647),
    [sym__identifier_token] = ACTIONS(3645),
    [anon_sym_extern] = ACTIONS(3645),
    [anon_sym_alias] = ACTIONS(3645),
    [anon_sym_SEMI] = ACTIONS(3647),
    [anon_sym_global] = ACTIONS(3645),
    [anon_sym_using] = ACTIONS(3645),
    [anon_sym_unsafe] = ACTIONS(3645),
    [anon_sym_static] = ACTIONS(3645),
    [anon_sym_LBRACK] = ACTIONS(3647),
    [anon_sym_LPAREN] = ACTIONS(3647),
    [anon_sym_return] = ACTIONS(3645),
    [anon_sym_namespace] = ACTIONS(3645),
    [anon_sym_class] = ACTIONS(3645),
    [anon_sym_ref] = ACTIONS(3645),
    [anon_sym_struct] = ACTIONS(3645),
    [anon_sym_enum] = ACTIONS(3645),
    [anon_sym_LBRACE] = ACTIONS(3647),
    [anon_sym_interface] = ACTIONS(3645),
    [anon_sym_delegate] = ACTIONS(3645),
    [anon_sym_record] = ACTIONS(3645),
    [anon_sym_abstract] = ACTIONS(3645),
    [anon_sym_async] = ACTIONS(3645),
    [anon_sym_const] = ACTIONS(3645),
    [anon_sym_file] = ACTIONS(3645),
    [anon_sym_fixed] = ACTIONS(3645),
    [anon_sym_internal] = ACTIONS(3645),
    [anon_sym_new] = ACTIONS(3645),
    [anon_sym_override] = ACTIONS(3645),
    [anon_sym_partial] = ACTIONS(3645),
    [anon_sym_private] = ACTIONS(3645),
    [anon_sym_protected] = ACTIONS(3645),
    [anon_sym_public] = ACTIONS(3645),
    [anon_sym_readonly] = ACTIONS(3645),
    [anon_sym_required] = ACTIONS(3645),
    [anon_sym_sealed] = ACTIONS(3645),
    [anon_sym_virtual] = ACTIONS(3645),
    [anon_sym_volatile] = ACTIONS(3645),
    [anon_sym_where] = ACTIONS(3645),
    [anon_sym_notnull] = ACTIONS(3645),
    [anon_sym_unmanaged] = ACTIONS(3645),
    [anon_sym_checked] = ACTIONS(3645),
    [anon_sym_BANG] = ACTIONS(3647),
    [anon_sym_TILDE] = ACTIONS(3647),
    [anon_sym_PLUS_PLUS] = ACTIONS(3647),
    [anon_sym_DASH_DASH] = ACTIONS(3647),
    [anon_sym_true] = ACTIONS(3645),
    [anon_sym_false] = ACTIONS(3645),
    [anon_sym_PLUS] = ACTIONS(3645),
    [anon_sym_DASH] = ACTIONS(3645),
    [anon_sym_STAR] = ACTIONS(3647),
    [anon_sym_CARET] = ACTIONS(3647),
    [anon_sym_AMP] = ACTIONS(3647),
    [anon_sym_this] = ACTIONS(3645),
    [anon_sym_scoped] = ACTIONS(3645),
    [anon_sym_var] = ACTIONS(3645),
    [sym_predefined_type] = ACTIONS(3645),
    [anon_sym_break] = ACTIONS(3645),
    [anon_sym_unchecked] = ACTIONS(3645),
    [anon_sym_continue] = ACTIONS(3645),
    [anon_sym_do] = ACTIONS(3645),
    [anon_sym_while] = ACTIONS(3645),
    [anon_sym_for] = ACTIONS(3645),
    [anon_sym_lock] = ACTIONS(3645),
    [anon_sym_yield] = ACTIONS(3645),
    [anon_sym_switch] = ACTIONS(3645),
    [anon_sym_default] = ACTIONS(3645),
    [anon_sym_throw] = ACTIONS(3645),
    [anon_sym_try] = ACTIONS(3645),
    [anon_sym_when] = ACTIONS(3645),
    [anon_sym_await] = ACTIONS(3645),
    [anon_sym_foreach] = ACTIONS(3645),
    [anon_sym_goto] = ACTIONS(3645),
    [anon_sym_if] = ACTIONS(3645),
    [anon_sym_DOT_DOT] = ACTIONS(3647),
    [anon_sym_from] = ACTIONS(3645),
    [anon_sym_into] = ACTIONS(3645),
    [anon_sym_join] = ACTIONS(3645),
    [anon_sym_on] = ACTIONS(3645),
    [anon_sym_equals] = ACTIONS(3645),
    [anon_sym_let] = ACTIONS(3645),
    [anon_sym_orderby] = ACTIONS(3645),
    [anon_sym_ascending] = ACTIONS(3645),
    [anon_sym_descending] = ACTIONS(3645),
    [anon_sym_group] = ACTIONS(3645),
    [anon_sym_by] = ACTIONS(3645),
    [anon_sym_select] = ACTIONS(3645),
    [anon_sym_DQUOTE] = ACTIONS(3645),
    [anon_sym_stackalloc] = ACTIONS(3645),
    [anon_sym_sizeof] = ACTIONS(3645),
    [anon_sym_typeof] = ACTIONS(3645),
    [anon_sym___makeref] = ACTIONS(3645),
    [anon_sym___reftype] = ACTIONS(3645),
    [anon_sym___refvalue] = ACTIONS(3645),
    [sym_null_literal] = ACTIONS(3645),
    [anon_sym_SQUOTE] = ACTIONS(3647),
    [sym_integer_literal] = ACTIONS(3645),
    [sym_real_literal] = ACTIONS(3647),
    [sym_verbatim_string_literal] = ACTIONS(3647),
    [sym_raw_string_literal] = ACTIONS(3647),
    [aux_sym_preproc_if_token1] = ACTIONS(3647),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3647),
    [sym_interpolation_verbatim_start] = ACTIONS(3647),
    [sym_interpolation_raw_start] = ACTIONS(3647),
  },
  [2601] = {
    [sym_preproc_region] = STATE(2601),
    [sym_preproc_endregion] = STATE(2601),
    [sym_preproc_line] = STATE(2601),
    [sym_preproc_pragma] = STATE(2601),
    [sym_preproc_nullable] = STATE(2601),
    [sym_preproc_error] = STATE(2601),
    [sym_preproc_define] = STATE(2601),
    [sym_preproc_undef] = STATE(2601),
    [ts_builtin_sym_end] = ACTIONS(3778),
    [sym__identifier_token] = ACTIONS(3776),
    [anon_sym_extern] = ACTIONS(3776),
    [anon_sym_alias] = ACTIONS(3776),
    [anon_sym_SEMI] = ACTIONS(3778),
    [anon_sym_global] = ACTIONS(3776),
    [anon_sym_using] = ACTIONS(3776),
    [anon_sym_unsafe] = ACTIONS(3776),
    [anon_sym_static] = ACTIONS(3776),
    [anon_sym_LBRACK] = ACTIONS(3778),
    [anon_sym_LPAREN] = ACTIONS(3778),
    [anon_sym_return] = ACTIONS(3776),
    [anon_sym_namespace] = ACTIONS(3776),
    [anon_sym_class] = ACTIONS(3776),
    [anon_sym_ref] = ACTIONS(3776),
    [anon_sym_struct] = ACTIONS(3776),
    [anon_sym_enum] = ACTIONS(3776),
    [anon_sym_LBRACE] = ACTIONS(3778),
    [anon_sym_interface] = ACTIONS(3776),
    [anon_sym_delegate] = ACTIONS(3776),
    [anon_sym_record] = ACTIONS(3776),
    [anon_sym_abstract] = ACTIONS(3776),
    [anon_sym_async] = ACTIONS(3776),
    [anon_sym_const] = ACTIONS(3776),
    [anon_sym_file] = ACTIONS(3776),
    [anon_sym_fixed] = ACTIONS(3776),
    [anon_sym_internal] = ACTIONS(3776),
    [anon_sym_new] = ACTIONS(3776),
    [anon_sym_override] = ACTIONS(3776),
    [anon_sym_partial] = ACTIONS(3776),
    [anon_sym_private] = ACTIONS(3776),
    [anon_sym_protected] = ACTIONS(3776),
    [anon_sym_public] = ACTIONS(3776),
    [anon_sym_readonly] = ACTIONS(3776),
    [anon_sym_required] = ACTIONS(3776),
    [anon_sym_sealed] = ACTIONS(3776),
    [anon_sym_virtual] = ACTIONS(3776),
    [anon_sym_volatile] = ACTIONS(3776),
    [anon_sym_where] = ACTIONS(3776),
    [anon_sym_notnull] = ACTIONS(3776),
    [anon_sym_unmanaged] = ACTIONS(3776),
    [anon_sym_checked] = ACTIONS(3776),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_TILDE] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3778),
    [anon_sym_DASH_DASH] = ACTIONS(3778),
    [anon_sym_true] = ACTIONS(3776),
    [anon_sym_false] = ACTIONS(3776),
    [anon_sym_PLUS] = ACTIONS(3776),
    [anon_sym_DASH] = ACTIONS(3776),
    [anon_sym_STAR] = ACTIONS(3778),
    [anon_sym_CARET] = ACTIONS(3778),
    [anon_sym_AMP] = ACTIONS(3778),
    [anon_sym_this] = ACTIONS(3776),
    [anon_sym_scoped] = ACTIONS(3776),
    [anon_sym_var] = ACTIONS(3776),
    [sym_predefined_type] = ACTIONS(3776),
    [anon_sym_break] = ACTIONS(3776),
    [anon_sym_unchecked] = ACTIONS(3776),
    [anon_sym_continue] = ACTIONS(3776),
    [anon_sym_do] = ACTIONS(3776),
    [anon_sym_while] = ACTIONS(3776),
    [anon_sym_for] = ACTIONS(3776),
    [anon_sym_lock] = ACTIONS(3776),
    [anon_sym_yield] = ACTIONS(3776),
    [anon_sym_switch] = ACTIONS(3776),
    [anon_sym_default] = ACTIONS(3776),
    [anon_sym_throw] = ACTIONS(3776),
    [anon_sym_try] = ACTIONS(3776),
    [anon_sym_when] = ACTIONS(3776),
    [anon_sym_await] = ACTIONS(3776),
    [anon_sym_foreach] = ACTIONS(3776),
    [anon_sym_goto] = ACTIONS(3776),
    [anon_sym_if] = ACTIONS(3776),
    [anon_sym_DOT_DOT] = ACTIONS(3778),
    [anon_sym_from] = ACTIONS(3776),
    [anon_sym_into] = ACTIONS(3776),
    [anon_sym_join] = ACTIONS(3776),
    [anon_sym_on] = ACTIONS(3776),
    [anon_sym_equals] = ACTIONS(3776),
    [anon_sym_let] = ACTIONS(3776),
    [anon_sym_orderby] = ACTIONS(3776),
    [anon_sym_ascending] = ACTIONS(3776),
    [anon_sym_descending] = ACTIONS(3776),
    [anon_sym_group] = ACTIONS(3776),
    [anon_sym_by] = ACTIONS(3776),
    [anon_sym_select] = ACTIONS(3776),
    [anon_sym_DQUOTE] = ACTIONS(3776),
    [anon_sym_stackalloc] = ACTIONS(3776),
    [anon_sym_sizeof] = ACTIONS(3776),
    [anon_sym_typeof] = ACTIONS(3776),
    [anon_sym___makeref] = ACTIONS(3776),
    [anon_sym___reftype] = ACTIONS(3776),
    [anon_sym___refvalue] = ACTIONS(3776),
    [sym_null_literal] = ACTIONS(3776),
    [anon_sym_SQUOTE] = ACTIONS(3778),
    [sym_integer_literal] = ACTIONS(3776),
    [sym_real_literal] = ACTIONS(3778),
    [sym_verbatim_string_literal] = ACTIONS(3778),
    [sym_raw_string_literal] = ACTIONS(3778),
    [aux_sym_preproc_if_token1] = ACTIONS(3778),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3778),
    [sym_interpolation_verbatim_start] = ACTIONS(3778),
    [sym_interpolation_raw_start] = ACTIONS(3778),
  },
  [2602] = {
    [sym_preproc_region] = STATE(2602),
    [sym_preproc_endregion] = STATE(2602),
    [sym_preproc_line] = STATE(2602),
    [sym_preproc_pragma] = STATE(2602),
    [sym_preproc_nullable] = STATE(2602),
    [sym_preproc_error] = STATE(2602),
    [sym_preproc_define] = STATE(2602),
    [sym_preproc_undef] = STATE(2602),
    [ts_builtin_sym_end] = ACTIONS(3952),
    [sym__identifier_token] = ACTIONS(3954),
    [anon_sym_extern] = ACTIONS(3954),
    [anon_sym_alias] = ACTIONS(3954),
    [anon_sym_SEMI] = ACTIONS(3952),
    [anon_sym_global] = ACTIONS(3954),
    [anon_sym_using] = ACTIONS(3954),
    [anon_sym_unsafe] = ACTIONS(3954),
    [anon_sym_static] = ACTIONS(3954),
    [anon_sym_LBRACK] = ACTIONS(3952),
    [anon_sym_LPAREN] = ACTIONS(3952),
    [anon_sym_return] = ACTIONS(3954),
    [anon_sym_namespace] = ACTIONS(3954),
    [anon_sym_class] = ACTIONS(3954),
    [anon_sym_ref] = ACTIONS(3954),
    [anon_sym_struct] = ACTIONS(3954),
    [anon_sym_enum] = ACTIONS(3954),
    [anon_sym_LBRACE] = ACTIONS(3952),
    [anon_sym_interface] = ACTIONS(3954),
    [anon_sym_delegate] = ACTIONS(3954),
    [anon_sym_record] = ACTIONS(3954),
    [anon_sym_abstract] = ACTIONS(3954),
    [anon_sym_async] = ACTIONS(3954),
    [anon_sym_const] = ACTIONS(3954),
    [anon_sym_file] = ACTIONS(3954),
    [anon_sym_fixed] = ACTIONS(3954),
    [anon_sym_internal] = ACTIONS(3954),
    [anon_sym_new] = ACTIONS(3954),
    [anon_sym_override] = ACTIONS(3954),
    [anon_sym_partial] = ACTIONS(3954),
    [anon_sym_private] = ACTIONS(3954),
    [anon_sym_protected] = ACTIONS(3954),
    [anon_sym_public] = ACTIONS(3954),
    [anon_sym_readonly] = ACTIONS(3954),
    [anon_sym_required] = ACTIONS(3954),
    [anon_sym_sealed] = ACTIONS(3954),
    [anon_sym_virtual] = ACTIONS(3954),
    [anon_sym_volatile] = ACTIONS(3954),
    [anon_sym_where] = ACTIONS(3954),
    [anon_sym_notnull] = ACTIONS(3954),
    [anon_sym_unmanaged] = ACTIONS(3954),
    [anon_sym_checked] = ACTIONS(3954),
    [anon_sym_BANG] = ACTIONS(3952),
    [anon_sym_TILDE] = ACTIONS(3952),
    [anon_sym_PLUS_PLUS] = ACTIONS(3952),
    [anon_sym_DASH_DASH] = ACTIONS(3952),
    [anon_sym_true] = ACTIONS(3954),
    [anon_sym_false] = ACTIONS(3954),
    [anon_sym_PLUS] = ACTIONS(3954),
    [anon_sym_DASH] = ACTIONS(3954),
    [anon_sym_STAR] = ACTIONS(3952),
    [anon_sym_CARET] = ACTIONS(3952),
    [anon_sym_AMP] = ACTIONS(3952),
    [anon_sym_this] = ACTIONS(3954),
    [anon_sym_scoped] = ACTIONS(3954),
    [anon_sym_var] = ACTIONS(3954),
    [sym_predefined_type] = ACTIONS(3954),
    [anon_sym_break] = ACTIONS(3954),
    [anon_sym_unchecked] = ACTIONS(3954),
    [anon_sym_continue] = ACTIONS(3954),
    [anon_sym_do] = ACTIONS(3954),
    [anon_sym_while] = ACTIONS(3954),
    [anon_sym_for] = ACTIONS(3954),
    [anon_sym_lock] = ACTIONS(3954),
    [anon_sym_yield] = ACTIONS(3954),
    [anon_sym_switch] = ACTIONS(3954),
    [anon_sym_default] = ACTIONS(3954),
    [anon_sym_throw] = ACTIONS(3954),
    [anon_sym_try] = ACTIONS(3954),
    [anon_sym_when] = ACTIONS(3954),
    [anon_sym_await] = ACTIONS(3954),
    [anon_sym_foreach] = ACTIONS(3954),
    [anon_sym_goto] = ACTIONS(3954),
    [anon_sym_if] = ACTIONS(3954),
    [anon_sym_DOT_DOT] = ACTIONS(3952),
    [anon_sym_from] = ACTIONS(3954),
    [anon_sym_into] = ACTIONS(3954),
    [anon_sym_join] = ACTIONS(3954),
    [anon_sym_on] = ACTIONS(3954),
    [anon_sym_equals] = ACTIONS(3954),
    [anon_sym_let] = ACTIONS(3954),
    [anon_sym_orderby] = ACTIONS(3954),
    [anon_sym_ascending] = ACTIONS(3954),
    [anon_sym_descending] = ACTIONS(3954),
    [anon_sym_group] = ACTIONS(3954),
    [anon_sym_by] = ACTIONS(3954),
    [anon_sym_select] = ACTIONS(3954),
    [anon_sym_DQUOTE] = ACTIONS(3954),
    [anon_sym_stackalloc] = ACTIONS(3954),
    [anon_sym_sizeof] = ACTIONS(3954),
    [anon_sym_typeof] = ACTIONS(3954),
    [anon_sym___makeref] = ACTIONS(3954),
    [anon_sym___reftype] = ACTIONS(3954),
    [anon_sym___refvalue] = ACTIONS(3954),
    [sym_null_literal] = ACTIONS(3954),
    [anon_sym_SQUOTE] = ACTIONS(3952),
    [sym_integer_literal] = ACTIONS(3954),
    [sym_real_literal] = ACTIONS(3952),
    [sym_verbatim_string_literal] = ACTIONS(3952),
    [sym_raw_string_literal] = ACTIONS(3952),
    [aux_sym_preproc_if_token1] = ACTIONS(3952),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3952),
    [sym_interpolation_verbatim_start] = ACTIONS(3952),
    [sym_interpolation_raw_start] = ACTIONS(3952),
  },
  [2603] = {
    [sym_preproc_region] = STATE(2603),
    [sym_preproc_endregion] = STATE(2603),
    [sym_preproc_line] = STATE(2603),
    [sym_preproc_pragma] = STATE(2603),
    [sym_preproc_nullable] = STATE(2603),
    [sym_preproc_error] = STATE(2603),
    [sym_preproc_define] = STATE(2603),
    [sym_preproc_undef] = STATE(2603),
    [ts_builtin_sym_end] = ACTIONS(3679),
    [sym__identifier_token] = ACTIONS(3677),
    [anon_sym_extern] = ACTIONS(3677),
    [anon_sym_alias] = ACTIONS(3677),
    [anon_sym_SEMI] = ACTIONS(3679),
    [anon_sym_global] = ACTIONS(3677),
    [anon_sym_using] = ACTIONS(3677),
    [anon_sym_unsafe] = ACTIONS(3677),
    [anon_sym_static] = ACTIONS(3677),
    [anon_sym_LBRACK] = ACTIONS(3679),
    [anon_sym_LPAREN] = ACTIONS(3679),
    [anon_sym_return] = ACTIONS(3677),
    [anon_sym_namespace] = ACTIONS(3677),
    [anon_sym_class] = ACTIONS(3677),
    [anon_sym_ref] = ACTIONS(3677),
    [anon_sym_struct] = ACTIONS(3677),
    [anon_sym_enum] = ACTIONS(3677),
    [anon_sym_LBRACE] = ACTIONS(3679),
    [anon_sym_interface] = ACTIONS(3677),
    [anon_sym_delegate] = ACTIONS(3677),
    [anon_sym_record] = ACTIONS(3677),
    [anon_sym_abstract] = ACTIONS(3677),
    [anon_sym_async] = ACTIONS(3677),
    [anon_sym_const] = ACTIONS(3677),
    [anon_sym_file] = ACTIONS(3677),
    [anon_sym_fixed] = ACTIONS(3677),
    [anon_sym_internal] = ACTIONS(3677),
    [anon_sym_new] = ACTIONS(3677),
    [anon_sym_override] = ACTIONS(3677),
    [anon_sym_partial] = ACTIONS(3677),
    [anon_sym_private] = ACTIONS(3677),
    [anon_sym_protected] = ACTIONS(3677),
    [anon_sym_public] = ACTIONS(3677),
    [anon_sym_readonly] = ACTIONS(3677),
    [anon_sym_required] = ACTIONS(3677),
    [anon_sym_sealed] = ACTIONS(3677),
    [anon_sym_virtual] = ACTIONS(3677),
    [anon_sym_volatile] = ACTIONS(3677),
    [anon_sym_where] = ACTIONS(3677),
    [anon_sym_notnull] = ACTIONS(3677),
    [anon_sym_unmanaged] = ACTIONS(3677),
    [anon_sym_checked] = ACTIONS(3677),
    [anon_sym_BANG] = ACTIONS(3679),
    [anon_sym_TILDE] = ACTIONS(3679),
    [anon_sym_PLUS_PLUS] = ACTIONS(3679),
    [anon_sym_DASH_DASH] = ACTIONS(3679),
    [anon_sym_true] = ACTIONS(3677),
    [anon_sym_false] = ACTIONS(3677),
    [anon_sym_PLUS] = ACTIONS(3677),
    [anon_sym_DASH] = ACTIONS(3677),
    [anon_sym_STAR] = ACTIONS(3679),
    [anon_sym_CARET] = ACTIONS(3679),
    [anon_sym_AMP] = ACTIONS(3679),
    [anon_sym_this] = ACTIONS(3677),
    [anon_sym_scoped] = ACTIONS(3677),
    [anon_sym_var] = ACTIONS(3677),
    [sym_predefined_type] = ACTIONS(3677),
    [anon_sym_break] = ACTIONS(3677),
    [anon_sym_unchecked] = ACTIONS(3677),
    [anon_sym_continue] = ACTIONS(3677),
    [anon_sym_do] = ACTIONS(3677),
    [anon_sym_while] = ACTIONS(3677),
    [anon_sym_for] = ACTIONS(3677),
    [anon_sym_lock] = ACTIONS(3677),
    [anon_sym_yield] = ACTIONS(3677),
    [anon_sym_switch] = ACTIONS(3677),
    [anon_sym_default] = ACTIONS(3677),
    [anon_sym_throw] = ACTIONS(3677),
    [anon_sym_try] = ACTIONS(3677),
    [anon_sym_when] = ACTIONS(3677),
    [anon_sym_await] = ACTIONS(3677),
    [anon_sym_foreach] = ACTIONS(3677),
    [anon_sym_goto] = ACTIONS(3677),
    [anon_sym_if] = ACTIONS(3677),
    [anon_sym_DOT_DOT] = ACTIONS(3679),
    [anon_sym_from] = ACTIONS(3677),
    [anon_sym_into] = ACTIONS(3677),
    [anon_sym_join] = ACTIONS(3677),
    [anon_sym_on] = ACTIONS(3677),
    [anon_sym_equals] = ACTIONS(3677),
    [anon_sym_let] = ACTIONS(3677),
    [anon_sym_orderby] = ACTIONS(3677),
    [anon_sym_ascending] = ACTIONS(3677),
    [anon_sym_descending] = ACTIONS(3677),
    [anon_sym_group] = ACTIONS(3677),
    [anon_sym_by] = ACTIONS(3677),
    [anon_sym_select] = ACTIONS(3677),
    [anon_sym_DQUOTE] = ACTIONS(3677),
    [anon_sym_stackalloc] = ACTIONS(3677),
    [anon_sym_sizeof] = ACTIONS(3677),
    [anon_sym_typeof] = ACTIONS(3677),
    [anon_sym___makeref] = ACTIONS(3677),
    [anon_sym___reftype] = ACTIONS(3677),
    [anon_sym___refvalue] = ACTIONS(3677),
    [sym_null_literal] = ACTIONS(3677),
    [anon_sym_SQUOTE] = ACTIONS(3679),
    [sym_integer_literal] = ACTIONS(3677),
    [sym_real_literal] = ACTIONS(3679),
    [sym_verbatim_string_literal] = ACTIONS(3679),
    [sym_raw_string_literal] = ACTIONS(3679),
    [aux_sym_preproc_if_token1] = ACTIONS(3679),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3679),
    [sym_interpolation_verbatim_start] = ACTIONS(3679),
    [sym_interpolation_raw_start] = ACTIONS(3679),
  },
  [2604] = {
    [sym_preproc_region] = STATE(2604),
    [sym_preproc_endregion] = STATE(2604),
    [sym_preproc_line] = STATE(2604),
    [sym_preproc_pragma] = STATE(2604),
    [sym_preproc_nullable] = STATE(2604),
    [sym_preproc_error] = STATE(2604),
    [sym_preproc_define] = STATE(2604),
    [sym_preproc_undef] = STATE(2604),
    [ts_builtin_sym_end] = ACTIONS(3651),
    [sym__identifier_token] = ACTIONS(3649),
    [anon_sym_extern] = ACTIONS(3649),
    [anon_sym_alias] = ACTIONS(3649),
    [anon_sym_SEMI] = ACTIONS(3651),
    [anon_sym_global] = ACTIONS(3649),
    [anon_sym_using] = ACTIONS(3649),
    [anon_sym_unsafe] = ACTIONS(3649),
    [anon_sym_static] = ACTIONS(3649),
    [anon_sym_LBRACK] = ACTIONS(3651),
    [anon_sym_LPAREN] = ACTIONS(3651),
    [anon_sym_return] = ACTIONS(3649),
    [anon_sym_namespace] = ACTIONS(3649),
    [anon_sym_class] = ACTIONS(3649),
    [anon_sym_ref] = ACTIONS(3649),
    [anon_sym_struct] = ACTIONS(3649),
    [anon_sym_enum] = ACTIONS(3649),
    [anon_sym_LBRACE] = ACTIONS(3651),
    [anon_sym_interface] = ACTIONS(3649),
    [anon_sym_delegate] = ACTIONS(3649),
    [anon_sym_record] = ACTIONS(3649),
    [anon_sym_abstract] = ACTIONS(3649),
    [anon_sym_async] = ACTIONS(3649),
    [anon_sym_const] = ACTIONS(3649),
    [anon_sym_file] = ACTIONS(3649),
    [anon_sym_fixed] = ACTIONS(3649),
    [anon_sym_internal] = ACTIONS(3649),
    [anon_sym_new] = ACTIONS(3649),
    [anon_sym_override] = ACTIONS(3649),
    [anon_sym_partial] = ACTIONS(3649),
    [anon_sym_private] = ACTIONS(3649),
    [anon_sym_protected] = ACTIONS(3649),
    [anon_sym_public] = ACTIONS(3649),
    [anon_sym_readonly] = ACTIONS(3649),
    [anon_sym_required] = ACTIONS(3649),
    [anon_sym_sealed] = ACTIONS(3649),
    [anon_sym_virtual] = ACTIONS(3649),
    [anon_sym_volatile] = ACTIONS(3649),
    [anon_sym_where] = ACTIONS(3649),
    [anon_sym_notnull] = ACTIONS(3649),
    [anon_sym_unmanaged] = ACTIONS(3649),
    [anon_sym_checked] = ACTIONS(3649),
    [anon_sym_BANG] = ACTIONS(3651),
    [anon_sym_TILDE] = ACTIONS(3651),
    [anon_sym_PLUS_PLUS] = ACTIONS(3651),
    [anon_sym_DASH_DASH] = ACTIONS(3651),
    [anon_sym_true] = ACTIONS(3649),
    [anon_sym_false] = ACTIONS(3649),
    [anon_sym_PLUS] = ACTIONS(3649),
    [anon_sym_DASH] = ACTIONS(3649),
    [anon_sym_STAR] = ACTIONS(3651),
    [anon_sym_CARET] = ACTIONS(3651),
    [anon_sym_AMP] = ACTIONS(3651),
    [anon_sym_this] = ACTIONS(3649),
    [anon_sym_scoped] = ACTIONS(3649),
    [anon_sym_var] = ACTIONS(3649),
    [sym_predefined_type] = ACTIONS(3649),
    [anon_sym_break] = ACTIONS(3649),
    [anon_sym_unchecked] = ACTIONS(3649),
    [anon_sym_continue] = ACTIONS(3649),
    [anon_sym_do] = ACTIONS(3649),
    [anon_sym_while] = ACTIONS(3649),
    [anon_sym_for] = ACTIONS(3649),
    [anon_sym_lock] = ACTIONS(3649),
    [anon_sym_yield] = ACTIONS(3649),
    [anon_sym_switch] = ACTIONS(3649),
    [anon_sym_default] = ACTIONS(3649),
    [anon_sym_throw] = ACTIONS(3649),
    [anon_sym_try] = ACTIONS(3649),
    [anon_sym_when] = ACTIONS(3649),
    [anon_sym_await] = ACTIONS(3649),
    [anon_sym_foreach] = ACTIONS(3649),
    [anon_sym_goto] = ACTIONS(3649),
    [anon_sym_if] = ACTIONS(3649),
    [anon_sym_DOT_DOT] = ACTIONS(3651),
    [anon_sym_from] = ACTIONS(3649),
    [anon_sym_into] = ACTIONS(3649),
    [anon_sym_join] = ACTIONS(3649),
    [anon_sym_on] = ACTIONS(3649),
    [anon_sym_equals] = ACTIONS(3649),
    [anon_sym_let] = ACTIONS(3649),
    [anon_sym_orderby] = ACTIONS(3649),
    [anon_sym_ascending] = ACTIONS(3649),
    [anon_sym_descending] = ACTIONS(3649),
    [anon_sym_group] = ACTIONS(3649),
    [anon_sym_by] = ACTIONS(3649),
    [anon_sym_select] = ACTIONS(3649),
    [anon_sym_DQUOTE] = ACTIONS(3649),
    [anon_sym_stackalloc] = ACTIONS(3649),
    [anon_sym_sizeof] = ACTIONS(3649),
    [anon_sym_typeof] = ACTIONS(3649),
    [anon_sym___makeref] = ACTIONS(3649),
    [anon_sym___reftype] = ACTIONS(3649),
    [anon_sym___refvalue] = ACTIONS(3649),
    [sym_null_literal] = ACTIONS(3649),
    [anon_sym_SQUOTE] = ACTIONS(3651),
    [sym_integer_literal] = ACTIONS(3649),
    [sym_real_literal] = ACTIONS(3651),
    [sym_verbatim_string_literal] = ACTIONS(3651),
    [sym_raw_string_literal] = ACTIONS(3651),
    [aux_sym_preproc_if_token1] = ACTIONS(3651),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3651),
    [sym_interpolation_verbatim_start] = ACTIONS(3651),
    [sym_interpolation_raw_start] = ACTIONS(3651),
  },
  [2605] = {
    [sym_preproc_region] = STATE(2605),
    [sym_preproc_endregion] = STATE(2605),
    [sym_preproc_line] = STATE(2605),
    [sym_preproc_pragma] = STATE(2605),
    [sym_preproc_nullable] = STATE(2605),
    [sym_preproc_error] = STATE(2605),
    [sym_preproc_define] = STATE(2605),
    [sym_preproc_undef] = STATE(2605),
    [ts_builtin_sym_end] = ACTIONS(3423),
    [sym__identifier_token] = ACTIONS(3421),
    [anon_sym_extern] = ACTIONS(3421),
    [anon_sym_alias] = ACTIONS(3421),
    [anon_sym_SEMI] = ACTIONS(3423),
    [anon_sym_global] = ACTIONS(3421),
    [anon_sym_using] = ACTIONS(3421),
    [anon_sym_unsafe] = ACTIONS(3421),
    [anon_sym_static] = ACTIONS(3421),
    [anon_sym_LBRACK] = ACTIONS(3423),
    [anon_sym_LPAREN] = ACTIONS(3423),
    [anon_sym_return] = ACTIONS(3421),
    [anon_sym_namespace] = ACTIONS(3421),
    [anon_sym_class] = ACTIONS(3421),
    [anon_sym_ref] = ACTIONS(3421),
    [anon_sym_struct] = ACTIONS(3421),
    [anon_sym_enum] = ACTIONS(3421),
    [anon_sym_LBRACE] = ACTIONS(3423),
    [anon_sym_interface] = ACTIONS(3421),
    [anon_sym_delegate] = ACTIONS(3421),
    [anon_sym_record] = ACTIONS(3421),
    [anon_sym_abstract] = ACTIONS(3421),
    [anon_sym_async] = ACTIONS(3421),
    [anon_sym_const] = ACTIONS(3421),
    [anon_sym_file] = ACTIONS(3421),
    [anon_sym_fixed] = ACTIONS(3421),
    [anon_sym_internal] = ACTIONS(3421),
    [anon_sym_new] = ACTIONS(3421),
    [anon_sym_override] = ACTIONS(3421),
    [anon_sym_partial] = ACTIONS(3421),
    [anon_sym_private] = ACTIONS(3421),
    [anon_sym_protected] = ACTIONS(3421),
    [anon_sym_public] = ACTIONS(3421),
    [anon_sym_readonly] = ACTIONS(3421),
    [anon_sym_required] = ACTIONS(3421),
    [anon_sym_sealed] = ACTIONS(3421),
    [anon_sym_virtual] = ACTIONS(3421),
    [anon_sym_volatile] = ACTIONS(3421),
    [anon_sym_where] = ACTIONS(3421),
    [anon_sym_notnull] = ACTIONS(3421),
    [anon_sym_unmanaged] = ACTIONS(3421),
    [anon_sym_checked] = ACTIONS(3421),
    [anon_sym_BANG] = ACTIONS(3423),
    [anon_sym_TILDE] = ACTIONS(3423),
    [anon_sym_PLUS_PLUS] = ACTIONS(3423),
    [anon_sym_DASH_DASH] = ACTIONS(3423),
    [anon_sym_true] = ACTIONS(3421),
    [anon_sym_false] = ACTIONS(3421),
    [anon_sym_PLUS] = ACTIONS(3421),
    [anon_sym_DASH] = ACTIONS(3421),
    [anon_sym_STAR] = ACTIONS(3423),
    [anon_sym_CARET] = ACTIONS(3423),
    [anon_sym_AMP] = ACTIONS(3423),
    [anon_sym_this] = ACTIONS(3421),
    [anon_sym_scoped] = ACTIONS(3421),
    [anon_sym_var] = ACTIONS(3421),
    [sym_predefined_type] = ACTIONS(3421),
    [anon_sym_break] = ACTIONS(3421),
    [anon_sym_unchecked] = ACTIONS(3421),
    [anon_sym_continue] = ACTIONS(3421),
    [anon_sym_do] = ACTIONS(3421),
    [anon_sym_while] = ACTIONS(3421),
    [anon_sym_for] = ACTIONS(3421),
    [anon_sym_lock] = ACTIONS(3421),
    [anon_sym_yield] = ACTIONS(3421),
    [anon_sym_switch] = ACTIONS(3421),
    [anon_sym_default] = ACTIONS(3421),
    [anon_sym_throw] = ACTIONS(3421),
    [anon_sym_try] = ACTIONS(3421),
    [anon_sym_when] = ACTIONS(3421),
    [anon_sym_await] = ACTIONS(3421),
    [anon_sym_foreach] = ACTIONS(3421),
    [anon_sym_goto] = ACTIONS(3421),
    [anon_sym_if] = ACTIONS(3421),
    [anon_sym_DOT_DOT] = ACTIONS(3423),
    [anon_sym_from] = ACTIONS(3421),
    [anon_sym_into] = ACTIONS(3421),
    [anon_sym_join] = ACTIONS(3421),
    [anon_sym_on] = ACTIONS(3421),
    [anon_sym_equals] = ACTIONS(3421),
    [anon_sym_let] = ACTIONS(3421),
    [anon_sym_orderby] = ACTIONS(3421),
    [anon_sym_ascending] = ACTIONS(3421),
    [anon_sym_descending] = ACTIONS(3421),
    [anon_sym_group] = ACTIONS(3421),
    [anon_sym_by] = ACTIONS(3421),
    [anon_sym_select] = ACTIONS(3421),
    [anon_sym_DQUOTE] = ACTIONS(3421),
    [anon_sym_stackalloc] = ACTIONS(3421),
    [anon_sym_sizeof] = ACTIONS(3421),
    [anon_sym_typeof] = ACTIONS(3421),
    [anon_sym___makeref] = ACTIONS(3421),
    [anon_sym___reftype] = ACTIONS(3421),
    [anon_sym___refvalue] = ACTIONS(3421),
    [sym_null_literal] = ACTIONS(3421),
    [anon_sym_SQUOTE] = ACTIONS(3423),
    [sym_integer_literal] = ACTIONS(3421),
    [sym_real_literal] = ACTIONS(3423),
    [sym_verbatim_string_literal] = ACTIONS(3423),
    [sym_raw_string_literal] = ACTIONS(3423),
    [aux_sym_preproc_if_token1] = ACTIONS(3423),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3423),
    [sym_interpolation_verbatim_start] = ACTIONS(3423),
    [sym_interpolation_raw_start] = ACTIONS(3423),
  },
  [2606] = {
    [sym_preproc_region] = STATE(2606),
    [sym_preproc_endregion] = STATE(2606),
    [sym_preproc_line] = STATE(2606),
    [sym_preproc_pragma] = STATE(2606),
    [sym_preproc_nullable] = STATE(2606),
    [sym_preproc_error] = STATE(2606),
    [sym_preproc_define] = STATE(2606),
    [sym_preproc_undef] = STATE(2606),
    [ts_builtin_sym_end] = ACTIONS(3667),
    [sym__identifier_token] = ACTIONS(3665),
    [anon_sym_extern] = ACTIONS(3665),
    [anon_sym_alias] = ACTIONS(3665),
    [anon_sym_SEMI] = ACTIONS(3667),
    [anon_sym_global] = ACTIONS(3665),
    [anon_sym_using] = ACTIONS(3665),
    [anon_sym_unsafe] = ACTIONS(3665),
    [anon_sym_static] = ACTIONS(3665),
    [anon_sym_LBRACK] = ACTIONS(3667),
    [anon_sym_LPAREN] = ACTIONS(3667),
    [anon_sym_return] = ACTIONS(3665),
    [anon_sym_namespace] = ACTIONS(3665),
    [anon_sym_class] = ACTIONS(3665),
    [anon_sym_ref] = ACTIONS(3665),
    [anon_sym_struct] = ACTIONS(3665),
    [anon_sym_enum] = ACTIONS(3665),
    [anon_sym_LBRACE] = ACTIONS(3667),
    [anon_sym_interface] = ACTIONS(3665),
    [anon_sym_delegate] = ACTIONS(3665),
    [anon_sym_record] = ACTIONS(3665),
    [anon_sym_abstract] = ACTIONS(3665),
    [anon_sym_async] = ACTIONS(3665),
    [anon_sym_const] = ACTIONS(3665),
    [anon_sym_file] = ACTIONS(3665),
    [anon_sym_fixed] = ACTIONS(3665),
    [anon_sym_internal] = ACTIONS(3665),
    [anon_sym_new] = ACTIONS(3665),
    [anon_sym_override] = ACTIONS(3665),
    [anon_sym_partial] = ACTIONS(3665),
    [anon_sym_private] = ACTIONS(3665),
    [anon_sym_protected] = ACTIONS(3665),
    [anon_sym_public] = ACTIONS(3665),
    [anon_sym_readonly] = ACTIONS(3665),
    [anon_sym_required] = ACTIONS(3665),
    [anon_sym_sealed] = ACTIONS(3665),
    [anon_sym_virtual] = ACTIONS(3665),
    [anon_sym_volatile] = ACTIONS(3665),
    [anon_sym_where] = ACTIONS(3665),
    [anon_sym_notnull] = ACTIONS(3665),
    [anon_sym_unmanaged] = ACTIONS(3665),
    [anon_sym_checked] = ACTIONS(3665),
    [anon_sym_BANG] = ACTIONS(3667),
    [anon_sym_TILDE] = ACTIONS(3667),
    [anon_sym_PLUS_PLUS] = ACTIONS(3667),
    [anon_sym_DASH_DASH] = ACTIONS(3667),
    [anon_sym_true] = ACTIONS(3665),
    [anon_sym_false] = ACTIONS(3665),
    [anon_sym_PLUS] = ACTIONS(3665),
    [anon_sym_DASH] = ACTIONS(3665),
    [anon_sym_STAR] = ACTIONS(3667),
    [anon_sym_CARET] = ACTIONS(3667),
    [anon_sym_AMP] = ACTIONS(3667),
    [anon_sym_this] = ACTIONS(3665),
    [anon_sym_scoped] = ACTIONS(3665),
    [anon_sym_var] = ACTIONS(3665),
    [sym_predefined_type] = ACTIONS(3665),
    [anon_sym_break] = ACTIONS(3665),
    [anon_sym_unchecked] = ACTIONS(3665),
    [anon_sym_continue] = ACTIONS(3665),
    [anon_sym_do] = ACTIONS(3665),
    [anon_sym_while] = ACTIONS(3665),
    [anon_sym_for] = ACTIONS(3665),
    [anon_sym_lock] = ACTIONS(3665),
    [anon_sym_yield] = ACTIONS(3665),
    [anon_sym_switch] = ACTIONS(3665),
    [anon_sym_default] = ACTIONS(3665),
    [anon_sym_throw] = ACTIONS(3665),
    [anon_sym_try] = ACTIONS(3665),
    [anon_sym_when] = ACTIONS(3665),
    [anon_sym_await] = ACTIONS(3665),
    [anon_sym_foreach] = ACTIONS(3665),
    [anon_sym_goto] = ACTIONS(3665),
    [anon_sym_if] = ACTIONS(3665),
    [anon_sym_DOT_DOT] = ACTIONS(3667),
    [anon_sym_from] = ACTIONS(3665),
    [anon_sym_into] = ACTIONS(3665),
    [anon_sym_join] = ACTIONS(3665),
    [anon_sym_on] = ACTIONS(3665),
    [anon_sym_equals] = ACTIONS(3665),
    [anon_sym_let] = ACTIONS(3665),
    [anon_sym_orderby] = ACTIONS(3665),
    [anon_sym_ascending] = ACTIONS(3665),
    [anon_sym_descending] = ACTIONS(3665),
    [anon_sym_group] = ACTIONS(3665),
    [anon_sym_by] = ACTIONS(3665),
    [anon_sym_select] = ACTIONS(3665),
    [anon_sym_DQUOTE] = ACTIONS(3665),
    [anon_sym_stackalloc] = ACTIONS(3665),
    [anon_sym_sizeof] = ACTIONS(3665),
    [anon_sym_typeof] = ACTIONS(3665),
    [anon_sym___makeref] = ACTIONS(3665),
    [anon_sym___reftype] = ACTIONS(3665),
    [anon_sym___refvalue] = ACTIONS(3665),
    [sym_null_literal] = ACTIONS(3665),
    [anon_sym_SQUOTE] = ACTIONS(3667),
    [sym_integer_literal] = ACTIONS(3665),
    [sym_real_literal] = ACTIONS(3667),
    [sym_verbatim_string_literal] = ACTIONS(3667),
    [sym_raw_string_literal] = ACTIONS(3667),
    [aux_sym_preproc_if_token1] = ACTIONS(3667),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3667),
    [sym_interpolation_verbatim_start] = ACTIONS(3667),
    [sym_interpolation_raw_start] = ACTIONS(3667),
  },
  [2607] = {
    [sym_preproc_region] = STATE(2607),
    [sym_preproc_endregion] = STATE(2607),
    [sym_preproc_line] = STATE(2607),
    [sym_preproc_pragma] = STATE(2607),
    [sym_preproc_nullable] = STATE(2607),
    [sym_preproc_error] = STATE(2607),
    [sym_preproc_define] = STATE(2607),
    [sym_preproc_undef] = STATE(2607),
    [ts_builtin_sym_end] = ACTIONS(3663),
    [sym__identifier_token] = ACTIONS(3661),
    [anon_sym_extern] = ACTIONS(3661),
    [anon_sym_alias] = ACTIONS(3661),
    [anon_sym_SEMI] = ACTIONS(3663),
    [anon_sym_global] = ACTIONS(3661),
    [anon_sym_using] = ACTIONS(3661),
    [anon_sym_unsafe] = ACTIONS(3661),
    [anon_sym_static] = ACTIONS(3661),
    [anon_sym_LBRACK] = ACTIONS(3663),
    [anon_sym_LPAREN] = ACTIONS(3663),
    [anon_sym_return] = ACTIONS(3661),
    [anon_sym_namespace] = ACTIONS(3661),
    [anon_sym_class] = ACTIONS(3661),
    [anon_sym_ref] = ACTIONS(3661),
    [anon_sym_struct] = ACTIONS(3661),
    [anon_sym_enum] = ACTIONS(3661),
    [anon_sym_LBRACE] = ACTIONS(3663),
    [anon_sym_interface] = ACTIONS(3661),
    [anon_sym_delegate] = ACTIONS(3661),
    [anon_sym_record] = ACTIONS(3661),
    [anon_sym_abstract] = ACTIONS(3661),
    [anon_sym_async] = ACTIONS(3661),
    [anon_sym_const] = ACTIONS(3661),
    [anon_sym_file] = ACTIONS(3661),
    [anon_sym_fixed] = ACTIONS(3661),
    [anon_sym_internal] = ACTIONS(3661),
    [anon_sym_new] = ACTIONS(3661),
    [anon_sym_override] = ACTIONS(3661),
    [anon_sym_partial] = ACTIONS(3661),
    [anon_sym_private] = ACTIONS(3661),
    [anon_sym_protected] = ACTIONS(3661),
    [anon_sym_public] = ACTIONS(3661),
    [anon_sym_readonly] = ACTIONS(3661),
    [anon_sym_required] = ACTIONS(3661),
    [anon_sym_sealed] = ACTIONS(3661),
    [anon_sym_virtual] = ACTIONS(3661),
    [anon_sym_volatile] = ACTIONS(3661),
    [anon_sym_where] = ACTIONS(3661),
    [anon_sym_notnull] = ACTIONS(3661),
    [anon_sym_unmanaged] = ACTIONS(3661),
    [anon_sym_checked] = ACTIONS(3661),
    [anon_sym_BANG] = ACTIONS(3663),
    [anon_sym_TILDE] = ACTIONS(3663),
    [anon_sym_PLUS_PLUS] = ACTIONS(3663),
    [anon_sym_DASH_DASH] = ACTIONS(3663),
    [anon_sym_true] = ACTIONS(3661),
    [anon_sym_false] = ACTIONS(3661),
    [anon_sym_PLUS] = ACTIONS(3661),
    [anon_sym_DASH] = ACTIONS(3661),
    [anon_sym_STAR] = ACTIONS(3663),
    [anon_sym_CARET] = ACTIONS(3663),
    [anon_sym_AMP] = ACTIONS(3663),
    [anon_sym_this] = ACTIONS(3661),
    [anon_sym_scoped] = ACTIONS(3661),
    [anon_sym_var] = ACTIONS(3661),
    [sym_predefined_type] = ACTIONS(3661),
    [anon_sym_break] = ACTIONS(3661),
    [anon_sym_unchecked] = ACTIONS(3661),
    [anon_sym_continue] = ACTIONS(3661),
    [anon_sym_do] = ACTIONS(3661),
    [anon_sym_while] = ACTIONS(3661),
    [anon_sym_for] = ACTIONS(3661),
    [anon_sym_lock] = ACTIONS(3661),
    [anon_sym_yield] = ACTIONS(3661),
    [anon_sym_switch] = ACTIONS(3661),
    [anon_sym_default] = ACTIONS(3661),
    [anon_sym_throw] = ACTIONS(3661),
    [anon_sym_try] = ACTIONS(3661),
    [anon_sym_when] = ACTIONS(3661),
    [anon_sym_await] = ACTIONS(3661),
    [anon_sym_foreach] = ACTIONS(3661),
    [anon_sym_goto] = ACTIONS(3661),
    [anon_sym_if] = ACTIONS(3661),
    [anon_sym_DOT_DOT] = ACTIONS(3663),
    [anon_sym_from] = ACTIONS(3661),
    [anon_sym_into] = ACTIONS(3661),
    [anon_sym_join] = ACTIONS(3661),
    [anon_sym_on] = ACTIONS(3661),
    [anon_sym_equals] = ACTIONS(3661),
    [anon_sym_let] = ACTIONS(3661),
    [anon_sym_orderby] = ACTIONS(3661),
    [anon_sym_ascending] = ACTIONS(3661),
    [anon_sym_descending] = ACTIONS(3661),
    [anon_sym_group] = ACTIONS(3661),
    [anon_sym_by] = ACTIONS(3661),
    [anon_sym_select] = ACTIONS(3661),
    [anon_sym_DQUOTE] = ACTIONS(3661),
    [anon_sym_stackalloc] = ACTIONS(3661),
    [anon_sym_sizeof] = ACTIONS(3661),
    [anon_sym_typeof] = ACTIONS(3661),
    [anon_sym___makeref] = ACTIONS(3661),
    [anon_sym___reftype] = ACTIONS(3661),
    [anon_sym___refvalue] = ACTIONS(3661),
    [sym_null_literal] = ACTIONS(3661),
    [anon_sym_SQUOTE] = ACTIONS(3663),
    [sym_integer_literal] = ACTIONS(3661),
    [sym_real_literal] = ACTIONS(3663),
    [sym_verbatim_string_literal] = ACTIONS(3663),
    [sym_raw_string_literal] = ACTIONS(3663),
    [aux_sym_preproc_if_token1] = ACTIONS(3663),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3663),
    [sym_interpolation_verbatim_start] = ACTIONS(3663),
    [sym_interpolation_raw_start] = ACTIONS(3663),
  },
  [2608] = {
    [sym_preproc_region] = STATE(2608),
    [sym_preproc_endregion] = STATE(2608),
    [sym_preproc_line] = STATE(2608),
    [sym_preproc_pragma] = STATE(2608),
    [sym_preproc_nullable] = STATE(2608),
    [sym_preproc_error] = STATE(2608),
    [sym_preproc_define] = STATE(2608),
    [sym_preproc_undef] = STATE(2608),
    [ts_builtin_sym_end] = ACTIONS(3655),
    [sym__identifier_token] = ACTIONS(3653),
    [anon_sym_extern] = ACTIONS(3653),
    [anon_sym_alias] = ACTIONS(3653),
    [anon_sym_SEMI] = ACTIONS(3655),
    [anon_sym_global] = ACTIONS(3653),
    [anon_sym_using] = ACTIONS(3653),
    [anon_sym_unsafe] = ACTIONS(3653),
    [anon_sym_static] = ACTIONS(3653),
    [anon_sym_LBRACK] = ACTIONS(3655),
    [anon_sym_LPAREN] = ACTIONS(3655),
    [anon_sym_return] = ACTIONS(3653),
    [anon_sym_namespace] = ACTIONS(3653),
    [anon_sym_class] = ACTIONS(3653),
    [anon_sym_ref] = ACTIONS(3653),
    [anon_sym_struct] = ACTIONS(3653),
    [anon_sym_enum] = ACTIONS(3653),
    [anon_sym_LBRACE] = ACTIONS(3655),
    [anon_sym_interface] = ACTIONS(3653),
    [anon_sym_delegate] = ACTIONS(3653),
    [anon_sym_record] = ACTIONS(3653),
    [anon_sym_abstract] = ACTIONS(3653),
    [anon_sym_async] = ACTIONS(3653),
    [anon_sym_const] = ACTIONS(3653),
    [anon_sym_file] = ACTIONS(3653),
    [anon_sym_fixed] = ACTIONS(3653),
    [anon_sym_internal] = ACTIONS(3653),
    [anon_sym_new] = ACTIONS(3653),
    [anon_sym_override] = ACTIONS(3653),
    [anon_sym_partial] = ACTIONS(3653),
    [anon_sym_private] = ACTIONS(3653),
    [anon_sym_protected] = ACTIONS(3653),
    [anon_sym_public] = ACTIONS(3653),
    [anon_sym_readonly] = ACTIONS(3653),
    [anon_sym_required] = ACTIONS(3653),
    [anon_sym_sealed] = ACTIONS(3653),
    [anon_sym_virtual] = ACTIONS(3653),
    [anon_sym_volatile] = ACTIONS(3653),
    [anon_sym_where] = ACTIONS(3653),
    [anon_sym_notnull] = ACTIONS(3653),
    [anon_sym_unmanaged] = ACTIONS(3653),
    [anon_sym_checked] = ACTIONS(3653),
    [anon_sym_BANG] = ACTIONS(3655),
    [anon_sym_TILDE] = ACTIONS(3655),
    [anon_sym_PLUS_PLUS] = ACTIONS(3655),
    [anon_sym_DASH_DASH] = ACTIONS(3655),
    [anon_sym_true] = ACTIONS(3653),
    [anon_sym_false] = ACTIONS(3653),
    [anon_sym_PLUS] = ACTIONS(3653),
    [anon_sym_DASH] = ACTIONS(3653),
    [anon_sym_STAR] = ACTIONS(3655),
    [anon_sym_CARET] = ACTIONS(3655),
    [anon_sym_AMP] = ACTIONS(3655),
    [anon_sym_this] = ACTIONS(3653),
    [anon_sym_scoped] = ACTIONS(3653),
    [anon_sym_var] = ACTIONS(3653),
    [sym_predefined_type] = ACTIONS(3653),
    [anon_sym_break] = ACTIONS(3653),
    [anon_sym_unchecked] = ACTIONS(3653),
    [anon_sym_continue] = ACTIONS(3653),
    [anon_sym_do] = ACTIONS(3653),
    [anon_sym_while] = ACTIONS(3653),
    [anon_sym_for] = ACTIONS(3653),
    [anon_sym_lock] = ACTIONS(3653),
    [anon_sym_yield] = ACTIONS(3653),
    [anon_sym_switch] = ACTIONS(3653),
    [anon_sym_default] = ACTIONS(3653),
    [anon_sym_throw] = ACTIONS(3653),
    [anon_sym_try] = ACTIONS(3653),
    [anon_sym_when] = ACTIONS(3653),
    [anon_sym_await] = ACTIONS(3653),
    [anon_sym_foreach] = ACTIONS(3653),
    [anon_sym_goto] = ACTIONS(3653),
    [anon_sym_if] = ACTIONS(3653),
    [anon_sym_DOT_DOT] = ACTIONS(3655),
    [anon_sym_from] = ACTIONS(3653),
    [anon_sym_into] = ACTIONS(3653),
    [anon_sym_join] = ACTIONS(3653),
    [anon_sym_on] = ACTIONS(3653),
    [anon_sym_equals] = ACTIONS(3653),
    [anon_sym_let] = ACTIONS(3653),
    [anon_sym_orderby] = ACTIONS(3653),
    [anon_sym_ascending] = ACTIONS(3653),
    [anon_sym_descending] = ACTIONS(3653),
    [anon_sym_group] = ACTIONS(3653),
    [anon_sym_by] = ACTIONS(3653),
    [anon_sym_select] = ACTIONS(3653),
    [anon_sym_DQUOTE] = ACTIONS(3653),
    [anon_sym_stackalloc] = ACTIONS(3653),
    [anon_sym_sizeof] = ACTIONS(3653),
    [anon_sym_typeof] = ACTIONS(3653),
    [anon_sym___makeref] = ACTIONS(3653),
    [anon_sym___reftype] = ACTIONS(3653),
    [anon_sym___refvalue] = ACTIONS(3653),
    [sym_null_literal] = ACTIONS(3653),
    [anon_sym_SQUOTE] = ACTIONS(3655),
    [sym_integer_literal] = ACTIONS(3653),
    [sym_real_literal] = ACTIONS(3655),
    [sym_verbatim_string_literal] = ACTIONS(3655),
    [sym_raw_string_literal] = ACTIONS(3655),
    [aux_sym_preproc_if_token1] = ACTIONS(3655),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3655),
    [sym_interpolation_verbatim_start] = ACTIONS(3655),
    [sym_interpolation_raw_start] = ACTIONS(3655),
  },
  [2609] = {
    [sym_preproc_region] = STATE(2609),
    [sym_preproc_endregion] = STATE(2609),
    [sym_preproc_line] = STATE(2609),
    [sym_preproc_pragma] = STATE(2609),
    [sym_preproc_nullable] = STATE(2609),
    [sym_preproc_error] = STATE(2609),
    [sym_preproc_define] = STATE(2609),
    [sym_preproc_undef] = STATE(2609),
    [ts_builtin_sym_end] = ACTIONS(3643),
    [sym__identifier_token] = ACTIONS(3641),
    [anon_sym_extern] = ACTIONS(3641),
    [anon_sym_alias] = ACTIONS(3641),
    [anon_sym_SEMI] = ACTIONS(3643),
    [anon_sym_global] = ACTIONS(3641),
    [anon_sym_using] = ACTIONS(3641),
    [anon_sym_unsafe] = ACTIONS(3641),
    [anon_sym_static] = ACTIONS(3641),
    [anon_sym_LBRACK] = ACTIONS(3643),
    [anon_sym_LPAREN] = ACTIONS(3643),
    [anon_sym_return] = ACTIONS(3641),
    [anon_sym_namespace] = ACTIONS(3641),
    [anon_sym_class] = ACTIONS(3641),
    [anon_sym_ref] = ACTIONS(3641),
    [anon_sym_struct] = ACTIONS(3641),
    [anon_sym_enum] = ACTIONS(3641),
    [anon_sym_LBRACE] = ACTIONS(3643),
    [anon_sym_interface] = ACTIONS(3641),
    [anon_sym_delegate] = ACTIONS(3641),
    [anon_sym_record] = ACTIONS(3641),
    [anon_sym_abstract] = ACTIONS(3641),
    [anon_sym_async] = ACTIONS(3641),
    [anon_sym_const] = ACTIONS(3641),
    [anon_sym_file] = ACTIONS(3641),
    [anon_sym_fixed] = ACTIONS(3641),
    [anon_sym_internal] = ACTIONS(3641),
    [anon_sym_new] = ACTIONS(3641),
    [anon_sym_override] = ACTIONS(3641),
    [anon_sym_partial] = ACTIONS(3641),
    [anon_sym_private] = ACTIONS(3641),
    [anon_sym_protected] = ACTIONS(3641),
    [anon_sym_public] = ACTIONS(3641),
    [anon_sym_readonly] = ACTIONS(3641),
    [anon_sym_required] = ACTIONS(3641),
    [anon_sym_sealed] = ACTIONS(3641),
    [anon_sym_virtual] = ACTIONS(3641),
    [anon_sym_volatile] = ACTIONS(3641),
    [anon_sym_where] = ACTIONS(3641),
    [anon_sym_notnull] = ACTIONS(3641),
    [anon_sym_unmanaged] = ACTIONS(3641),
    [anon_sym_checked] = ACTIONS(3641),
    [anon_sym_BANG] = ACTIONS(3643),
    [anon_sym_TILDE] = ACTIONS(3643),
    [anon_sym_PLUS_PLUS] = ACTIONS(3643),
    [anon_sym_DASH_DASH] = ACTIONS(3643),
    [anon_sym_true] = ACTIONS(3641),
    [anon_sym_false] = ACTIONS(3641),
    [anon_sym_PLUS] = ACTIONS(3641),
    [anon_sym_DASH] = ACTIONS(3641),
    [anon_sym_STAR] = ACTIONS(3643),
    [anon_sym_CARET] = ACTIONS(3643),
    [anon_sym_AMP] = ACTIONS(3643),
    [anon_sym_this] = ACTIONS(3641),
    [anon_sym_scoped] = ACTIONS(3641),
    [anon_sym_var] = ACTIONS(3641),
    [sym_predefined_type] = ACTIONS(3641),
    [anon_sym_break] = ACTIONS(3641),
    [anon_sym_unchecked] = ACTIONS(3641),
    [anon_sym_continue] = ACTIONS(3641),
    [anon_sym_do] = ACTIONS(3641),
    [anon_sym_while] = ACTIONS(3641),
    [anon_sym_for] = ACTIONS(3641),
    [anon_sym_lock] = ACTIONS(3641),
    [anon_sym_yield] = ACTIONS(3641),
    [anon_sym_switch] = ACTIONS(3641),
    [anon_sym_default] = ACTIONS(3641),
    [anon_sym_throw] = ACTIONS(3641),
    [anon_sym_try] = ACTIONS(3641),
    [anon_sym_when] = ACTIONS(3641),
    [anon_sym_await] = ACTIONS(3641),
    [anon_sym_foreach] = ACTIONS(3641),
    [anon_sym_goto] = ACTIONS(3641),
    [anon_sym_if] = ACTIONS(3641),
    [anon_sym_DOT_DOT] = ACTIONS(3643),
    [anon_sym_from] = ACTIONS(3641),
    [anon_sym_into] = ACTIONS(3641),
    [anon_sym_join] = ACTIONS(3641),
    [anon_sym_on] = ACTIONS(3641),
    [anon_sym_equals] = ACTIONS(3641),
    [anon_sym_let] = ACTIONS(3641),
    [anon_sym_orderby] = ACTIONS(3641),
    [anon_sym_ascending] = ACTIONS(3641),
    [anon_sym_descending] = ACTIONS(3641),
    [anon_sym_group] = ACTIONS(3641),
    [anon_sym_by] = ACTIONS(3641),
    [anon_sym_select] = ACTIONS(3641),
    [anon_sym_DQUOTE] = ACTIONS(3641),
    [anon_sym_stackalloc] = ACTIONS(3641),
    [anon_sym_sizeof] = ACTIONS(3641),
    [anon_sym_typeof] = ACTIONS(3641),
    [anon_sym___makeref] = ACTIONS(3641),
    [anon_sym___reftype] = ACTIONS(3641),
    [anon_sym___refvalue] = ACTIONS(3641),
    [sym_null_literal] = ACTIONS(3641),
    [anon_sym_SQUOTE] = ACTIONS(3643),
    [sym_integer_literal] = ACTIONS(3641),
    [sym_real_literal] = ACTIONS(3643),
    [sym_verbatim_string_literal] = ACTIONS(3643),
    [sym_raw_string_literal] = ACTIONS(3643),
    [aux_sym_preproc_if_token1] = ACTIONS(3643),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3643),
    [sym_interpolation_verbatim_start] = ACTIONS(3643),
    [sym_interpolation_raw_start] = ACTIONS(3643),
  },
  [2610] = {
    [sym_catch_clause] = STATE(2642),
    [sym_preproc_region] = STATE(2610),
    [sym_preproc_endregion] = STATE(2610),
    [sym_preproc_line] = STATE(2610),
    [sym_preproc_pragma] = STATE(2610),
    [sym_preproc_nullable] = STATE(2610),
    [sym_preproc_error] = STATE(2610),
    [sym_preproc_define] = STATE(2610),
    [sym_preproc_undef] = STATE(2610),
    [aux_sym_try_statement_repeat1] = STATE(2610),
    [sym__identifier_token] = ACTIONS(2949),
    [anon_sym_extern] = ACTIONS(2949),
    [anon_sym_alias] = ACTIONS(2949),
    [anon_sym_SEMI] = ACTIONS(2951),
    [anon_sym_global] = ACTIONS(2949),
    [anon_sym_using] = ACTIONS(2949),
    [anon_sym_unsafe] = ACTIONS(2949),
    [anon_sym_static] = ACTIONS(2949),
    [anon_sym_LBRACK] = ACTIONS(2951),
    [anon_sym_LPAREN] = ACTIONS(2951),
    [anon_sym_return] = ACTIONS(2949),
    [anon_sym_ref] = ACTIONS(2949),
    [anon_sym_LBRACE] = ACTIONS(2951),
    [anon_sym_RBRACE] = ACTIONS(2951),
    [anon_sym_delegate] = ACTIONS(2949),
    [anon_sym_abstract] = ACTIONS(2949),
    [anon_sym_async] = ACTIONS(2949),
    [anon_sym_const] = ACTIONS(2949),
    [anon_sym_file] = ACTIONS(2949),
    [anon_sym_fixed] = ACTIONS(2949),
    [anon_sym_internal] = ACTIONS(2949),
    [anon_sym_new] = ACTIONS(2949),
    [anon_sym_override] = ACTIONS(2949),
    [anon_sym_partial] = ACTIONS(2949),
    [anon_sym_private] = ACTIONS(2949),
    [anon_sym_protected] = ACTIONS(2949),
    [anon_sym_public] = ACTIONS(2949),
    [anon_sym_readonly] = ACTIONS(2949),
    [anon_sym_required] = ACTIONS(2949),
    [anon_sym_sealed] = ACTIONS(2949),
    [anon_sym_virtual] = ACTIONS(2949),
    [anon_sym_volatile] = ACTIONS(2949),
    [anon_sym_where] = ACTIONS(2949),
    [anon_sym_notnull] = ACTIONS(2949),
    [anon_sym_unmanaged] = ACTIONS(2949),
    [anon_sym_checked] = ACTIONS(2949),
    [anon_sym_BANG] = ACTIONS(2951),
    [anon_sym_TILDE] = ACTIONS(2951),
    [anon_sym_PLUS_PLUS] = ACTIONS(2951),
    [anon_sym_DASH_DASH] = ACTIONS(2951),
    [anon_sym_true] = ACTIONS(2949),
    [anon_sym_false] = ACTIONS(2949),
    [anon_sym_PLUS] = ACTIONS(2949),
    [anon_sym_DASH] = ACTIONS(2949),
    [anon_sym_STAR] = ACTIONS(2951),
    [anon_sym_CARET] = ACTIONS(2951),
    [anon_sym_AMP] = ACTIONS(2951),
    [anon_sym_this] = ACTIONS(2949),
    [anon_sym_scoped] = ACTIONS(2949),
    [anon_sym_var] = ACTIONS(2949),
    [sym_predefined_type] = ACTIONS(2949),
    [anon_sym_break] = ACTIONS(2949),
    [anon_sym_unchecked] = ACTIONS(2949),
    [anon_sym_continue] = ACTIONS(2949),
    [anon_sym_do] = ACTIONS(2949),
    [anon_sym_while] = ACTIONS(2949),
    [anon_sym_for] = ACTIONS(2949),
    [anon_sym_lock] = ACTIONS(2949),
    [anon_sym_yield] = ACTIONS(2949),
    [anon_sym_switch] = ACTIONS(2949),
    [anon_sym_case] = ACTIONS(2949),
    [anon_sym_default] = ACTIONS(2949),
    [anon_sym_throw] = ACTIONS(2949),
    [anon_sym_try] = ACTIONS(2949),
    [anon_sym_catch] = ACTIONS(3966),
    [anon_sym_when] = ACTIONS(2949),
    [anon_sym_finally] = ACTIONS(2949),
    [anon_sym_await] = ACTIONS(2949),
    [anon_sym_foreach] = ACTIONS(2949),
    [anon_sym_goto] = ACTIONS(2949),
    [anon_sym_if] = ACTIONS(2949),
    [anon_sym_else] = ACTIONS(2949),
    [anon_sym_DOT_DOT] = ACTIONS(2951),
    [anon_sym_from] = ACTIONS(2949),
    [anon_sym_into] = ACTIONS(2949),
    [anon_sym_join] = ACTIONS(2949),
    [anon_sym_on] = ACTIONS(2949),
    [anon_sym_equals] = ACTIONS(2949),
    [anon_sym_let] = ACTIONS(2949),
    [anon_sym_orderby] = ACTIONS(2949),
    [anon_sym_ascending] = ACTIONS(2949),
    [anon_sym_descending] = ACTIONS(2949),
    [anon_sym_group] = ACTIONS(2949),
    [anon_sym_by] = ACTIONS(2949),
    [anon_sym_select] = ACTIONS(2949),
    [anon_sym_DQUOTE] = ACTIONS(2949),
    [anon_sym_stackalloc] = ACTIONS(2949),
    [anon_sym_sizeof] = ACTIONS(2949),
    [anon_sym_typeof] = ACTIONS(2949),
    [anon_sym___makeref] = ACTIONS(2949),
    [anon_sym___reftype] = ACTIONS(2949),
    [anon_sym___refvalue] = ACTIONS(2949),
    [sym_null_literal] = ACTIONS(2949),
    [anon_sym_SQUOTE] = ACTIONS(2951),
    [sym_integer_literal] = ACTIONS(2949),
    [sym_real_literal] = ACTIONS(2951),
    [sym_verbatim_string_literal] = ACTIONS(2951),
    [sym_raw_string_literal] = ACTIONS(2951),
    [aux_sym_preproc_if_token1] = ACTIONS(2951),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(2951),
    [sym_interpolation_verbatim_start] = ACTIONS(2951),
    [sym_interpolation_raw_start] = ACTIONS(2951),
  },
  [2611] = {
    [sym_preproc_region] = STATE(2611),
    [sym_preproc_endregion] = STATE(2611),
    [sym_preproc_line] = STATE(2611),
    [sym_preproc_pragma] = STATE(2611),
    [sym_preproc_nullable] = STATE(2611),
    [sym_preproc_error] = STATE(2611),
    [sym_preproc_define] = STATE(2611),
    [sym_preproc_undef] = STATE(2611),
    [ts_builtin_sym_end] = ACTIONS(3858),
    [sym__identifier_token] = ACTIONS(3856),
    [anon_sym_extern] = ACTIONS(3856),
    [anon_sym_alias] = ACTIONS(3856),
    [anon_sym_SEMI] = ACTIONS(3858),
    [anon_sym_global] = ACTIONS(3856),
    [anon_sym_using] = ACTIONS(3856),
    [anon_sym_unsafe] = ACTIONS(3856),
    [anon_sym_static] = ACTIONS(3856),
    [anon_sym_LBRACK] = ACTIONS(3858),
    [anon_sym_LPAREN] = ACTIONS(3858),
    [anon_sym_return] = ACTIONS(3856),
    [anon_sym_namespace] = ACTIONS(3856),
    [anon_sym_class] = ACTIONS(3856),
    [anon_sym_ref] = ACTIONS(3856),
    [anon_sym_struct] = ACTIONS(3856),
    [anon_sym_enum] = ACTIONS(3856),
    [anon_sym_LBRACE] = ACTIONS(3858),
    [anon_sym_interface] = ACTIONS(3856),
    [anon_sym_delegate] = ACTIONS(3856),
    [anon_sym_record] = ACTIONS(3856),
    [anon_sym_abstract] = ACTIONS(3856),
    [anon_sym_async] = ACTIONS(3856),
    [anon_sym_const] = ACTIONS(3856),
    [anon_sym_file] = ACTIONS(3856),
    [anon_sym_fixed] = ACTIONS(3856),
    [anon_sym_internal] = ACTIONS(3856),
    [anon_sym_new] = ACTIONS(3856),
    [anon_sym_override] = ACTIONS(3856),
    [anon_sym_partial] = ACTIONS(3856),
    [anon_sym_private] = ACTIONS(3856),
    [anon_sym_protected] = ACTIONS(3856),
    [anon_sym_public] = ACTIONS(3856),
    [anon_sym_readonly] = ACTIONS(3856),
    [anon_sym_required] = ACTIONS(3856),
    [anon_sym_sealed] = ACTIONS(3856),
    [anon_sym_virtual] = ACTIONS(3856),
    [anon_sym_volatile] = ACTIONS(3856),
    [anon_sym_where] = ACTIONS(3856),
    [anon_sym_notnull] = ACTIONS(3856),
    [anon_sym_unmanaged] = ACTIONS(3856),
    [anon_sym_checked] = ACTIONS(3856),
    [anon_sym_BANG] = ACTIONS(3858),
    [anon_sym_TILDE] = ACTIONS(3858),
    [anon_sym_PLUS_PLUS] = ACTIONS(3858),
    [anon_sym_DASH_DASH] = ACTIONS(3858),
    [anon_sym_true] = ACTIONS(3856),
    [anon_sym_false] = ACTIONS(3856),
    [anon_sym_PLUS] = ACTIONS(3856),
    [anon_sym_DASH] = ACTIONS(3856),
    [anon_sym_STAR] = ACTIONS(3858),
    [anon_sym_CARET] = ACTIONS(3858),
    [anon_sym_AMP] = ACTIONS(3858),
    [anon_sym_this] = ACTIONS(3856),
    [anon_sym_scoped] = ACTIONS(3856),
    [anon_sym_var] = ACTIONS(3856),
    [sym_predefined_type] = ACTIONS(3856),
    [anon_sym_break] = ACTIONS(3856),
    [anon_sym_unchecked] = ACTIONS(3856),
    [anon_sym_continue] = ACTIONS(3856),
    [anon_sym_do] = ACTIONS(3856),
    [anon_sym_while] = ACTIONS(3856),
    [anon_sym_for] = ACTIONS(3856),
    [anon_sym_lock] = ACTIONS(3856),
    [anon_sym_yield] = ACTIONS(3856),
    [anon_sym_switch] = ACTIONS(3856),
    [anon_sym_default] = ACTIONS(3856),
    [anon_sym_throw] = ACTIONS(3856),
    [anon_sym_try] = ACTIONS(3856),
    [anon_sym_when] = ACTIONS(3856),
    [anon_sym_await] = ACTIONS(3856),
    [anon_sym_foreach] = ACTIONS(3856),
    [anon_sym_goto] = ACTIONS(3856),
    [anon_sym_if] = ACTIONS(3856),
    [anon_sym_DOT_DOT] = ACTIONS(3858),
    [anon_sym_from] = ACTIONS(3856),
    [anon_sym_into] = ACTIONS(3856),
    [anon_sym_join] = ACTIONS(3856),
    [anon_sym_on] = ACTIONS(3856),
    [anon_sym_equals] = ACTIONS(3856),
    [anon_sym_let] = ACTIONS(3856),
    [anon_sym_orderby] = ACTIONS(3856),
    [anon_sym_ascending] = ACTIONS(3856),
    [anon_sym_descending] = ACTIONS(3856),
    [anon_sym_group] = ACTIONS(3856),
    [anon_sym_by] = ACTIONS(3856),
    [anon_sym_select] = ACTIONS(3856),
    [anon_sym_DQUOTE] = ACTIONS(3856),
    [anon_sym_stackalloc] = ACTIONS(3856),
    [anon_sym_sizeof] = ACTIONS(3856),
    [anon_sym_typeof] = ACTIONS(3856),
    [anon_sym___makeref] = ACTIONS(3856),
    [anon_sym___reftype] = ACTIONS(3856),
    [anon_sym___refvalue] = ACTIONS(3856),
    [sym_null_literal] = ACTIONS(3856),
    [anon_sym_SQUOTE] = ACTIONS(3858),
    [sym_integer_literal] = ACTIONS(3856),
    [sym_real_literal] = ACTIONS(3858),
    [sym_verbatim_string_literal] = ACTIONS(3858),
    [sym_raw_string_literal] = ACTIONS(3858),
    [aux_sym_preproc_if_token1] = ACTIONS(3858),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3858),
    [sym_interpolation_verbatim_start] = ACTIONS(3858),
    [sym_interpolation_raw_start] = ACTIONS(3858),
  },
  [2612] = {
    [sym_preproc_region] = STATE(2612),
    [sym_preproc_endregion] = STATE(2612),
    [sym_preproc_line] = STATE(2612),
    [sym_preproc_pragma] = STATE(2612),
    [sym_preproc_nullable] = STATE(2612),
    [sym_preproc_error] = STATE(2612),
    [sym_preproc_define] = STATE(2612),
    [sym_preproc_undef] = STATE(2612),
    [ts_builtin_sym_end] = ACTIONS(3515),
    [sym__identifier_token] = ACTIONS(3513),
    [anon_sym_extern] = ACTIONS(3513),
    [anon_sym_alias] = ACTIONS(3513),
    [anon_sym_SEMI] = ACTIONS(3515),
    [anon_sym_global] = ACTIONS(3513),
    [anon_sym_using] = ACTIONS(3513),
    [anon_sym_unsafe] = ACTIONS(3513),
    [anon_sym_static] = ACTIONS(3513),
    [anon_sym_LBRACK] = ACTIONS(3515),
    [anon_sym_LPAREN] = ACTIONS(3515),
    [anon_sym_return] = ACTIONS(3513),
    [anon_sym_namespace] = ACTIONS(3513),
    [anon_sym_class] = ACTIONS(3513),
    [anon_sym_ref] = ACTIONS(3513),
    [anon_sym_struct] = ACTIONS(3513),
    [anon_sym_enum] = ACTIONS(3513),
    [anon_sym_LBRACE] = ACTIONS(3515),
    [anon_sym_interface] = ACTIONS(3513),
    [anon_sym_delegate] = ACTIONS(3513),
    [anon_sym_record] = ACTIONS(3513),
    [anon_sym_abstract] = ACTIONS(3513),
    [anon_sym_async] = ACTIONS(3513),
    [anon_sym_const] = ACTIONS(3513),
    [anon_sym_file] = ACTIONS(3513),
    [anon_sym_fixed] = ACTIONS(3513),
    [anon_sym_internal] = ACTIONS(3513),
    [anon_sym_new] = ACTIONS(3513),
    [anon_sym_override] = ACTIONS(3513),
    [anon_sym_partial] = ACTIONS(3513),
    [anon_sym_private] = ACTIONS(3513),
    [anon_sym_protected] = ACTIONS(3513),
    [anon_sym_public] = ACTIONS(3513),
    [anon_sym_readonly] = ACTIONS(3513),
    [anon_sym_required] = ACTIONS(3513),
    [anon_sym_sealed] = ACTIONS(3513),
    [anon_sym_virtual] = ACTIONS(3513),
    [anon_sym_volatile] = ACTIONS(3513),
    [anon_sym_where] = ACTIONS(3513),
    [anon_sym_notnull] = ACTIONS(3513),
    [anon_sym_unmanaged] = ACTIONS(3513),
    [anon_sym_checked] = ACTIONS(3513),
    [anon_sym_BANG] = ACTIONS(3515),
    [anon_sym_TILDE] = ACTIONS(3515),
    [anon_sym_PLUS_PLUS] = ACTIONS(3515),
    [anon_sym_DASH_DASH] = ACTIONS(3515),
    [anon_sym_true] = ACTIONS(3513),
    [anon_sym_false] = ACTIONS(3513),
    [anon_sym_PLUS] = ACTIONS(3513),
    [anon_sym_DASH] = ACTIONS(3513),
    [anon_sym_STAR] = ACTIONS(3515),
    [anon_sym_CARET] = ACTIONS(3515),
    [anon_sym_AMP] = ACTIONS(3515),
    [anon_sym_this] = ACTIONS(3513),
    [anon_sym_scoped] = ACTIONS(3513),
    [anon_sym_var] = ACTIONS(3513),
    [sym_predefined_type] = ACTIONS(3513),
    [anon_sym_break] = ACTIONS(3513),
    [anon_sym_unchecked] = ACTIONS(3513),
    [anon_sym_continue] = ACTIONS(3513),
    [anon_sym_do] = ACTIONS(3513),
    [anon_sym_while] = ACTIONS(3513),
    [anon_sym_for] = ACTIONS(3513),
    [anon_sym_lock] = ACTIONS(3513),
    [anon_sym_yield] = ACTIONS(3513),
    [anon_sym_switch] = ACTIONS(3513),
    [anon_sym_default] = ACTIONS(3513),
    [anon_sym_throw] = ACTIONS(3513),
    [anon_sym_try] = ACTIONS(3513),
    [anon_sym_when] = ACTIONS(3513),
    [anon_sym_await] = ACTIONS(3513),
    [anon_sym_foreach] = ACTIONS(3513),
    [anon_sym_goto] = ACTIONS(3513),
    [anon_sym_if] = ACTIONS(3513),
    [anon_sym_DOT_DOT] = ACTIONS(3515),
    [anon_sym_from] = ACTIONS(3513),
    [anon_sym_into] = ACTIONS(3513),
    [anon_sym_join] = ACTIONS(3513),
    [anon_sym_on] = ACTIONS(3513),
    [anon_sym_equals] = ACTIONS(3513),
    [anon_sym_let] = ACTIONS(3513),
    [anon_sym_orderby] = ACTIONS(3513),
    [anon_sym_ascending] = ACTIONS(3513),
    [anon_sym_descending] = ACTIONS(3513),
    [anon_sym_group] = ACTIONS(3513),
    [anon_sym_by] = ACTIONS(3513),
    [anon_sym_select] = ACTIONS(3513),
    [anon_sym_DQUOTE] = ACTIONS(3513),
    [anon_sym_stackalloc] = ACTIONS(3513),
    [anon_sym_sizeof] = ACTIONS(3513),
    [anon_sym_typeof] = ACTIONS(3513),
    [anon_sym___makeref] = ACTIONS(3513),
    [anon_sym___reftype] = ACTIONS(3513),
    [anon_sym___refvalue] = ACTIONS(3513),
    [sym_null_literal] = ACTIONS(3513),
    [anon_sym_SQUOTE] = ACTIONS(3515),
    [sym_integer_literal] = ACTIONS(3513),
    [sym_real_literal] = ACTIONS(3515),
    [sym_verbatim_string_literal] = ACTIONS(3515),
    [sym_raw_string_literal] = ACTIONS(3515),
    [aux_sym_preproc_if_token1] = ACTIONS(3515),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3515),
    [sym_interpolation_verbatim_start] = ACTIONS(3515),
    [sym_interpolation_raw_start] = ACTIONS(3515),
  },
  [2613] = {
    [sym_preproc_region] = STATE(2613),
    [sym_preproc_endregion] = STATE(2613),
    [sym_preproc_line] = STATE(2613),
    [sym_preproc_pragma] = STATE(2613),
    [sym_preproc_nullable] = STATE(2613),
    [sym_preproc_error] = STATE(2613),
    [sym_preproc_define] = STATE(2613),
    [sym_preproc_undef] = STATE(2613),
    [ts_builtin_sym_end] = ACTIONS(3850),
    [sym__identifier_token] = ACTIONS(3848),
    [anon_sym_extern] = ACTIONS(3848),
    [anon_sym_alias] = ACTIONS(3848),
    [anon_sym_SEMI] = ACTIONS(3850),
    [anon_sym_global] = ACTIONS(3848),
    [anon_sym_using] = ACTIONS(3848),
    [anon_sym_unsafe] = ACTIONS(3848),
    [anon_sym_static] = ACTIONS(3848),
    [anon_sym_LBRACK] = ACTIONS(3850),
    [anon_sym_LPAREN] = ACTIONS(3850),
    [anon_sym_return] = ACTIONS(3848),
    [anon_sym_namespace] = ACTIONS(3848),
    [anon_sym_class] = ACTIONS(3848),
    [anon_sym_ref] = ACTIONS(3848),
    [anon_sym_struct] = ACTIONS(3848),
    [anon_sym_enum] = ACTIONS(3848),
    [anon_sym_LBRACE] = ACTIONS(3850),
    [anon_sym_interface] = ACTIONS(3848),
    [anon_sym_delegate] = ACTIONS(3848),
    [anon_sym_record] = ACTIONS(3848),
    [anon_sym_abstract] = ACTIONS(3848),
    [anon_sym_async] = ACTIONS(3848),
    [anon_sym_const] = ACTIONS(3848),
    [anon_sym_file] = ACTIONS(3848),
    [anon_sym_fixed] = ACTIONS(3848),
    [anon_sym_internal] = ACTIONS(3848),
    [anon_sym_new] = ACTIONS(3848),
    [anon_sym_override] = ACTIONS(3848),
    [anon_sym_partial] = ACTIONS(3848),
    [anon_sym_private] = ACTIONS(3848),
    [anon_sym_protected] = ACTIONS(3848),
    [anon_sym_public] = ACTIONS(3848),
    [anon_sym_readonly] = ACTIONS(3848),
    [anon_sym_required] = ACTIONS(3848),
    [anon_sym_sealed] = ACTIONS(3848),
    [anon_sym_virtual] = ACTIONS(3848),
    [anon_sym_volatile] = ACTIONS(3848),
    [anon_sym_where] = ACTIONS(3848),
    [anon_sym_notnull] = ACTIONS(3848),
    [anon_sym_unmanaged] = ACTIONS(3848),
    [anon_sym_checked] = ACTIONS(3848),
    [anon_sym_BANG] = ACTIONS(3850),
    [anon_sym_TILDE] = ACTIONS(3850),
    [anon_sym_PLUS_PLUS] = ACTIONS(3850),
    [anon_sym_DASH_DASH] = ACTIONS(3850),
    [anon_sym_true] = ACTIONS(3848),
    [anon_sym_false] = ACTIONS(3848),
    [anon_sym_PLUS] = ACTIONS(3848),
    [anon_sym_DASH] = ACTIONS(3848),
    [anon_sym_STAR] = ACTIONS(3850),
    [anon_sym_CARET] = ACTIONS(3850),
    [anon_sym_AMP] = ACTIONS(3850),
    [anon_sym_this] = ACTIONS(3848),
    [anon_sym_scoped] = ACTIONS(3848),
    [anon_sym_var] = ACTIONS(3848),
    [sym_predefined_type] = ACTIONS(3848),
    [anon_sym_break] = ACTIONS(3848),
    [anon_sym_unchecked] = ACTIONS(3848),
    [anon_sym_continue] = ACTIONS(3848),
    [anon_sym_do] = ACTIONS(3848),
    [anon_sym_while] = ACTIONS(3848),
    [anon_sym_for] = ACTIONS(3848),
    [anon_sym_lock] = ACTIONS(3848),
    [anon_sym_yield] = ACTIONS(3848),
    [anon_sym_switch] = ACTIONS(3848),
    [anon_sym_default] = ACTIONS(3848),
    [anon_sym_throw] = ACTIONS(3848),
    [anon_sym_try] = ACTIONS(3848),
    [anon_sym_when] = ACTIONS(3848),
    [anon_sym_await] = ACTIONS(3848),
    [anon_sym_foreach] = ACTIONS(3848),
    [anon_sym_goto] = ACTIONS(3848),
    [anon_sym_if] = ACTIONS(3848),
    [anon_sym_DOT_DOT] = ACTIONS(3850),
    [anon_sym_from] = ACTIONS(3848),
    [anon_sym_into] = ACTIONS(3848),
    [anon_sym_join] = ACTIONS(3848),
    [anon_sym_on] = ACTIONS(3848),
    [anon_sym_equals] = ACTIONS(3848),
    [anon_sym_let] = ACTIONS(3848),
    [anon_sym_orderby] = ACTIONS(3848),
    [anon_sym_ascending] = ACTIONS(3848),
    [anon_sym_descending] = ACTIONS(3848),
    [anon_sym_group] = ACTIONS(3848),
    [anon_sym_by] = ACTIONS(3848),
    [anon_sym_select] = ACTIONS(3848),
    [anon_sym_DQUOTE] = ACTIONS(3848),
    [anon_sym_stackalloc] = ACTIONS(3848),
    [anon_sym_sizeof] = ACTIONS(3848),
    [anon_sym_typeof] = ACTIONS(3848),
    [anon_sym___makeref] = ACTIONS(3848),
    [anon_sym___reftype] = ACTIONS(3848),
    [anon_sym___refvalue] = ACTIONS(3848),
    [sym_null_literal] = ACTIONS(3848),
    [anon_sym_SQUOTE] = ACTIONS(3850),
    [sym_integer_literal] = ACTIONS(3848),
    [sym_real_literal] = ACTIONS(3850),
    [sym_verbatim_string_literal] = ACTIONS(3850),
    [sym_raw_string_literal] = ACTIONS(3850),
    [aux_sym_preproc_if_token1] = ACTIONS(3850),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3850),
    [sym_interpolation_verbatim_start] = ACTIONS(3850),
    [sym_interpolation_raw_start] = ACTIONS(3850),
  },
  [2614] = {
    [sym_preproc_region] = STATE(2614),
    [sym_preproc_endregion] = STATE(2614),
    [sym_preproc_line] = STATE(2614),
    [sym_preproc_pragma] = STATE(2614),
    [sym_preproc_nullable] = STATE(2614),
    [sym_preproc_error] = STATE(2614),
    [sym_preproc_define] = STATE(2614),
    [sym_preproc_undef] = STATE(2614),
    [ts_builtin_sym_end] = ACTIONS(3639),
    [sym__identifier_token] = ACTIONS(3637),
    [anon_sym_extern] = ACTIONS(3637),
    [anon_sym_alias] = ACTIONS(3637),
    [anon_sym_SEMI] = ACTIONS(3639),
    [anon_sym_global] = ACTIONS(3637),
    [anon_sym_using] = ACTIONS(3637),
    [anon_sym_unsafe] = ACTIONS(3637),
    [anon_sym_static] = ACTIONS(3637),
    [anon_sym_LBRACK] = ACTIONS(3639),
    [anon_sym_LPAREN] = ACTIONS(3639),
    [anon_sym_return] = ACTIONS(3637),
    [anon_sym_namespace] = ACTIONS(3637),
    [anon_sym_class] = ACTIONS(3637),
    [anon_sym_ref] = ACTIONS(3637),
    [anon_sym_struct] = ACTIONS(3637),
    [anon_sym_enum] = ACTIONS(3637),
    [anon_sym_LBRACE] = ACTIONS(3639),
    [anon_sym_interface] = ACTIONS(3637),
    [anon_sym_delegate] = ACTIONS(3637),
    [anon_sym_record] = ACTIONS(3637),
    [anon_sym_abstract] = ACTIONS(3637),
    [anon_sym_async] = ACTIONS(3637),
    [anon_sym_const] = ACTIONS(3637),
    [anon_sym_file] = ACTIONS(3637),
    [anon_sym_fixed] = ACTIONS(3637),
    [anon_sym_internal] = ACTIONS(3637),
    [anon_sym_new] = ACTIONS(3637),
    [anon_sym_override] = ACTIONS(3637),
    [anon_sym_partial] = ACTIONS(3637),
    [anon_sym_private] = ACTIONS(3637),
    [anon_sym_protected] = ACTIONS(3637),
    [anon_sym_public] = ACTIONS(3637),
    [anon_sym_readonly] = ACTIONS(3637),
    [anon_sym_required] = ACTIONS(3637),
    [anon_sym_sealed] = ACTIONS(3637),
    [anon_sym_virtual] = ACTIONS(3637),
    [anon_sym_volatile] = ACTIONS(3637),
    [anon_sym_where] = ACTIONS(3637),
    [anon_sym_notnull] = ACTIONS(3637),
    [anon_sym_unmanaged] = ACTIONS(3637),
    [anon_sym_checked] = ACTIONS(3637),
    [anon_sym_BANG] = ACTIONS(3639),
    [anon_sym_TILDE] = ACTIONS(3639),
    [anon_sym_PLUS_PLUS] = ACTIONS(3639),
    [anon_sym_DASH_DASH] = ACTIONS(3639),
    [anon_sym_true] = ACTIONS(3637),
    [anon_sym_false] = ACTIONS(3637),
    [anon_sym_PLUS] = ACTIONS(3637),
    [anon_sym_DASH] = ACTIONS(3637),
    [anon_sym_STAR] = ACTIONS(3639),
    [anon_sym_CARET] = ACTIONS(3639),
    [anon_sym_AMP] = ACTIONS(3639),
    [anon_sym_this] = ACTIONS(3637),
    [anon_sym_scoped] = ACTIONS(3637),
    [anon_sym_var] = ACTIONS(3637),
    [sym_predefined_type] = ACTIONS(3637),
    [anon_sym_break] = ACTIONS(3637),
    [anon_sym_unchecked] = ACTIONS(3637),
    [anon_sym_continue] = ACTIONS(3637),
    [anon_sym_do] = ACTIONS(3637),
    [anon_sym_while] = ACTIONS(3637),
    [anon_sym_for] = ACTIONS(3637),
    [anon_sym_lock] = ACTIONS(3637),
    [anon_sym_yield] = ACTIONS(3637),
    [anon_sym_switch] = ACTIONS(3637),
    [anon_sym_default] = ACTIONS(3637),
    [anon_sym_throw] = ACTIONS(3637),
    [anon_sym_try] = ACTIONS(3637),
    [anon_sym_when] = ACTIONS(3637),
    [anon_sym_await] = ACTIONS(3637),
    [anon_sym_foreach] = ACTIONS(3637),
    [anon_sym_goto] = ACTIONS(3637),
    [anon_sym_if] = ACTIONS(3637),
    [anon_sym_DOT_DOT] = ACTIONS(3639),
    [anon_sym_from] = ACTIONS(3637),
    [anon_sym_into] = ACTIONS(3637),
    [anon_sym_join] = ACTIONS(3637),
    [anon_sym_on] = ACTIONS(3637),
    [anon_sym_equals] = ACTIONS(3637),
    [anon_sym_let] = ACTIONS(3637),
    [anon_sym_orderby] = ACTIONS(3637),
    [anon_sym_ascending] = ACTIONS(3637),
    [anon_sym_descending] = ACTIONS(3637),
    [anon_sym_group] = ACTIONS(3637),
    [anon_sym_by] = ACTIONS(3637),
    [anon_sym_select] = ACTIONS(3637),
    [anon_sym_DQUOTE] = ACTIONS(3637),
    [anon_sym_stackalloc] = ACTIONS(3637),
    [anon_sym_sizeof] = ACTIONS(3637),
    [anon_sym_typeof] = ACTIONS(3637),
    [anon_sym___makeref] = ACTIONS(3637),
    [anon_sym___reftype] = ACTIONS(3637),
    [anon_sym___refvalue] = ACTIONS(3637),
    [sym_null_literal] = ACTIONS(3637),
    [anon_sym_SQUOTE] = ACTIONS(3639),
    [sym_integer_literal] = ACTIONS(3637),
    [sym_real_literal] = ACTIONS(3639),
    [sym_verbatim_string_literal] = ACTIONS(3639),
    [sym_raw_string_literal] = ACTIONS(3639),
    [aux_sym_preproc_if_token1] = ACTIONS(3639),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3639),
    [sym_interpolation_verbatim_start] = ACTIONS(3639),
    [sym_interpolation_raw_start] = ACTIONS(3639),
  },
  [2615] = {
    [sym_preproc_region] = STATE(2615),
    [sym_preproc_endregion] = STATE(2615),
    [sym_preproc_line] = STATE(2615),
    [sym_preproc_pragma] = STATE(2615),
    [sym_preproc_nullable] = STATE(2615),
    [sym_preproc_error] = STATE(2615),
    [sym_preproc_define] = STATE(2615),
    [sym_preproc_undef] = STATE(2615),
    [ts_builtin_sym_end] = ACTIONS(3846),
    [sym__identifier_token] = ACTIONS(3844),
    [anon_sym_extern] = ACTIONS(3844),
    [anon_sym_alias] = ACTIONS(3844),
    [anon_sym_SEMI] = ACTIONS(3846),
    [anon_sym_global] = ACTIONS(3844),
    [anon_sym_using] = ACTIONS(3844),
    [anon_sym_unsafe] = ACTIONS(3844),
    [anon_sym_static] = ACTIONS(3844),
    [anon_sym_LBRACK] = ACTIONS(3846),
    [anon_sym_LPAREN] = ACTIONS(3846),
    [anon_sym_return] = ACTIONS(3844),
    [anon_sym_namespace] = ACTIONS(3844),
    [anon_sym_class] = ACTIONS(3844),
    [anon_sym_ref] = ACTIONS(3844),
    [anon_sym_struct] = ACTIONS(3844),
    [anon_sym_enum] = ACTIONS(3844),
    [anon_sym_LBRACE] = ACTIONS(3846),
    [anon_sym_interface] = ACTIONS(3844),
    [anon_sym_delegate] = ACTIONS(3844),
    [anon_sym_record] = ACTIONS(3844),
    [anon_sym_abstract] = ACTIONS(3844),
    [anon_sym_async] = ACTIONS(3844),
    [anon_sym_const] = ACTIONS(3844),
    [anon_sym_file] = ACTIONS(3844),
    [anon_sym_fixed] = ACTIONS(3844),
    [anon_sym_internal] = ACTIONS(3844),
    [anon_sym_new] = ACTIONS(3844),
    [anon_sym_override] = ACTIONS(3844),
    [anon_sym_partial] = ACTIONS(3844),
    [anon_sym_private] = ACTIONS(3844),
    [anon_sym_protected] = ACTIONS(3844),
    [anon_sym_public] = ACTIONS(3844),
    [anon_sym_readonly] = ACTIONS(3844),
    [anon_sym_required] = ACTIONS(3844),
    [anon_sym_sealed] = ACTIONS(3844),
    [anon_sym_virtual] = ACTIONS(3844),
    [anon_sym_volatile] = ACTIONS(3844),
    [anon_sym_where] = ACTIONS(3844),
    [anon_sym_notnull] = ACTIONS(3844),
    [anon_sym_unmanaged] = ACTIONS(3844),
    [anon_sym_checked] = ACTIONS(3844),
    [anon_sym_BANG] = ACTIONS(3846),
    [anon_sym_TILDE] = ACTIONS(3846),
    [anon_sym_PLUS_PLUS] = ACTIONS(3846),
    [anon_sym_DASH_DASH] = ACTIONS(3846),
    [anon_sym_true] = ACTIONS(3844),
    [anon_sym_false] = ACTIONS(3844),
    [anon_sym_PLUS] = ACTIONS(3844),
    [anon_sym_DASH] = ACTIONS(3844),
    [anon_sym_STAR] = ACTIONS(3846),
    [anon_sym_CARET] = ACTIONS(3846),
    [anon_sym_AMP] = ACTIONS(3846),
    [anon_sym_this] = ACTIONS(3844),
    [anon_sym_scoped] = ACTIONS(3844),
    [anon_sym_var] = ACTIONS(3844),
    [sym_predefined_type] = ACTIONS(3844),
    [anon_sym_break] = ACTIONS(3844),
    [anon_sym_unchecked] = ACTIONS(3844),
    [anon_sym_continue] = ACTIONS(3844),
    [anon_sym_do] = ACTIONS(3844),
    [anon_sym_while] = ACTIONS(3844),
    [anon_sym_for] = ACTIONS(3844),
    [anon_sym_lock] = ACTIONS(3844),
    [anon_sym_yield] = ACTIONS(3844),
    [anon_sym_switch] = ACTIONS(3844),
    [anon_sym_default] = ACTIONS(3844),
    [anon_sym_throw] = ACTIONS(3844),
    [anon_sym_try] = ACTIONS(3844),
    [anon_sym_when] = ACTIONS(3844),
    [anon_sym_await] = ACTIONS(3844),
    [anon_sym_foreach] = ACTIONS(3844),
    [anon_sym_goto] = ACTIONS(3844),
    [anon_sym_if] = ACTIONS(3844),
    [anon_sym_DOT_DOT] = ACTIONS(3846),
    [anon_sym_from] = ACTIONS(3844),
    [anon_sym_into] = ACTIONS(3844),
    [anon_sym_join] = ACTIONS(3844),
    [anon_sym_on] = ACTIONS(3844),
    [anon_sym_equals] = ACTIONS(3844),
    [anon_sym_let] = ACTIONS(3844),
    [anon_sym_orderby] = ACTIONS(3844),
    [anon_sym_ascending] = ACTIONS(3844),
    [anon_sym_descending] = ACTIONS(3844),
    [anon_sym_group] = ACTIONS(3844),
    [anon_sym_by] = ACTIONS(3844),
    [anon_sym_select] = ACTIONS(3844),
    [anon_sym_DQUOTE] = ACTIONS(3844),
    [anon_sym_stackalloc] = ACTIONS(3844),
    [anon_sym_sizeof] = ACTIONS(3844),
    [anon_sym_typeof] = ACTIONS(3844),
    [anon_sym___makeref] = ACTIONS(3844),
    [anon_sym___reftype] = ACTIONS(3844),
    [anon_sym___refvalue] = ACTIONS(3844),
    [sym_null_literal] = ACTIONS(3844),
    [anon_sym_SQUOTE] = ACTIONS(3846),
    [sym_integer_literal] = ACTIONS(3844),
    [sym_real_literal] = ACTIONS(3846),
    [sym_verbatim_string_literal] = ACTIONS(3846),
    [sym_raw_string_literal] = ACTIONS(3846),
    [aux_sym_preproc_if_token1] = ACTIONS(3846),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3846),
    [sym_interpolation_verbatim_start] = ACTIONS(3846),
    [sym_interpolation_raw_start] = ACTIONS(3846),
  },
  [2616] = {
    [sym_preproc_region] = STATE(2616),
    [sym_preproc_endregion] = STATE(2616),
    [sym_preproc_line] = STATE(2616),
    [sym_preproc_pragma] = STATE(2616),
    [sym_preproc_nullable] = STATE(2616),
    [sym_preproc_error] = STATE(2616),
    [sym_preproc_define] = STATE(2616),
    [sym_preproc_undef] = STATE(2616),
    [ts_builtin_sym_end] = ACTIONS(3842),
    [sym__identifier_token] = ACTIONS(3840),
    [anon_sym_extern] = ACTIONS(3840),
    [anon_sym_alias] = ACTIONS(3840),
    [anon_sym_SEMI] = ACTIONS(3842),
    [anon_sym_global] = ACTIONS(3840),
    [anon_sym_using] = ACTIONS(3840),
    [anon_sym_unsafe] = ACTIONS(3840),
    [anon_sym_static] = ACTIONS(3840),
    [anon_sym_LBRACK] = ACTIONS(3842),
    [anon_sym_LPAREN] = ACTIONS(3842),
    [anon_sym_return] = ACTIONS(3840),
    [anon_sym_namespace] = ACTIONS(3840),
    [anon_sym_class] = ACTIONS(3840),
    [anon_sym_ref] = ACTIONS(3840),
    [anon_sym_struct] = ACTIONS(3840),
    [anon_sym_enum] = ACTIONS(3840),
    [anon_sym_LBRACE] = ACTIONS(3842),
    [anon_sym_interface] = ACTIONS(3840),
    [anon_sym_delegate] = ACTIONS(3840),
    [anon_sym_record] = ACTIONS(3840),
    [anon_sym_abstract] = ACTIONS(3840),
    [anon_sym_async] = ACTIONS(3840),
    [anon_sym_const] = ACTIONS(3840),
    [anon_sym_file] = ACTIONS(3840),
    [anon_sym_fixed] = ACTIONS(3840),
    [anon_sym_internal] = ACTIONS(3840),
    [anon_sym_new] = ACTIONS(3840),
    [anon_sym_override] = ACTIONS(3840),
    [anon_sym_partial] = ACTIONS(3840),
    [anon_sym_private] = ACTIONS(3840),
    [anon_sym_protected] = ACTIONS(3840),
    [anon_sym_public] = ACTIONS(3840),
    [anon_sym_readonly] = ACTIONS(3840),
    [anon_sym_required] = ACTIONS(3840),
    [anon_sym_sealed] = ACTIONS(3840),
    [anon_sym_virtual] = ACTIONS(3840),
    [anon_sym_volatile] = ACTIONS(3840),
    [anon_sym_where] = ACTIONS(3840),
    [anon_sym_notnull] = ACTIONS(3840),
    [anon_sym_unmanaged] = ACTIONS(3840),
    [anon_sym_checked] = ACTIONS(3840),
    [anon_sym_BANG] = ACTIONS(3842),
    [anon_sym_TILDE] = ACTIONS(3842),
    [anon_sym_PLUS_PLUS] = ACTIONS(3842),
    [anon_sym_DASH_DASH] = ACTIONS(3842),
    [anon_sym_true] = ACTIONS(3840),
    [anon_sym_false] = ACTIONS(3840),
    [anon_sym_PLUS] = ACTIONS(3840),
    [anon_sym_DASH] = ACTIONS(3840),
    [anon_sym_STAR] = ACTIONS(3842),
    [anon_sym_CARET] = ACTIONS(3842),
    [anon_sym_AMP] = ACTIONS(3842),
    [anon_sym_this] = ACTIONS(3840),
    [anon_sym_scoped] = ACTIONS(3840),
    [anon_sym_var] = ACTIONS(3840),
    [sym_predefined_type] = ACTIONS(3840),
    [anon_sym_break] = ACTIONS(3840),
    [anon_sym_unchecked] = ACTIONS(3840),
    [anon_sym_continue] = ACTIONS(3840),
    [anon_sym_do] = ACTIONS(3840),
    [anon_sym_while] = ACTIONS(3840),
    [anon_sym_for] = ACTIONS(3840),
    [anon_sym_lock] = ACTIONS(3840),
    [anon_sym_yield] = ACTIONS(3840),
    [anon_sym_switch] = ACTIONS(3840),
    [anon_sym_default] = ACTIONS(3840),
    [anon_sym_throw] = ACTIONS(3840),
    [anon_sym_try] = ACTIONS(3840),
    [anon_sym_when] = ACTIONS(3840),
    [anon_sym_await] = ACTIONS(3840),
    [anon_sym_foreach] = ACTIONS(3840),
    [anon_sym_goto] = ACTIONS(3840),
    [anon_sym_if] = ACTIONS(3840),
    [anon_sym_DOT_DOT] = ACTIONS(3842),
    [anon_sym_from] = ACTIONS(3840),
    [anon_sym_into] = ACTIONS(3840),
    [anon_sym_join] = ACTIONS(3840),
    [anon_sym_on] = ACTIONS(3840),
    [anon_sym_equals] = ACTIONS(3840),
    [anon_sym_let] = ACTIONS(3840),
    [anon_sym_orderby] = ACTIONS(3840),
    [anon_sym_ascending] = ACTIONS(3840),
    [anon_sym_descending] = ACTIONS(3840),
    [anon_sym_group] = ACTIONS(3840),
    [anon_sym_by] = ACTIONS(3840),
    [anon_sym_select] = ACTIONS(3840),
    [anon_sym_DQUOTE] = ACTIONS(3840),
    [anon_sym_stackalloc] = ACTIONS(3840),
    [anon_sym_sizeof] = ACTIONS(3840),
    [anon_sym_typeof] = ACTIONS(3840),
    [anon_sym___makeref] = ACTIONS(3840),
    [anon_sym___reftype] = ACTIONS(3840),
    [anon_sym___refvalue] = ACTIONS(3840),
    [sym_null_literal] = ACTIONS(3840),
    [anon_sym_SQUOTE] = ACTIONS(3842),
    [sym_integer_literal] = ACTIONS(3840),
    [sym_real_literal] = ACTIONS(3842),
    [sym_verbatim_string_literal] = ACTIONS(3842),
    [sym_raw_string_literal] = ACTIONS(3842),
    [aux_sym_preproc_if_token1] = ACTIONS(3842),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3842),
    [sym_interpolation_verbatim_start] = ACTIONS(3842),
    [sym_interpolation_raw_start] = ACTIONS(3842),
  },
  [2617] = {
    [sym_preproc_region] = STATE(2617),
    [sym_preproc_endregion] = STATE(2617),
    [sym_preproc_line] = STATE(2617),
    [sym_preproc_pragma] = STATE(2617),
    [sym_preproc_nullable] = STATE(2617),
    [sym_preproc_error] = STATE(2617),
    [sym_preproc_define] = STATE(2617),
    [sym_preproc_undef] = STATE(2617),
    [ts_builtin_sym_end] = ACTIONS(3511),
    [sym__identifier_token] = ACTIONS(3509),
    [anon_sym_extern] = ACTIONS(3509),
    [anon_sym_alias] = ACTIONS(3509),
    [anon_sym_SEMI] = ACTIONS(3511),
    [anon_sym_global] = ACTIONS(3509),
    [anon_sym_using] = ACTIONS(3509),
    [anon_sym_unsafe] = ACTIONS(3509),
    [anon_sym_static] = ACTIONS(3509),
    [anon_sym_LBRACK] = ACTIONS(3511),
    [anon_sym_LPAREN] = ACTIONS(3511),
    [anon_sym_return] = ACTIONS(3509),
    [anon_sym_namespace] = ACTIONS(3509),
    [anon_sym_class] = ACTIONS(3509),
    [anon_sym_ref] = ACTIONS(3509),
    [anon_sym_struct] = ACTIONS(3509),
    [anon_sym_enum] = ACTIONS(3509),
    [anon_sym_LBRACE] = ACTIONS(3511),
    [anon_sym_interface] = ACTIONS(3509),
    [anon_sym_delegate] = ACTIONS(3509),
    [anon_sym_record] = ACTIONS(3509),
    [anon_sym_abstract] = ACTIONS(3509),
    [anon_sym_async] = ACTIONS(3509),
    [anon_sym_const] = ACTIONS(3509),
    [anon_sym_file] = ACTIONS(3509),
    [anon_sym_fixed] = ACTIONS(3509),
    [anon_sym_internal] = ACTIONS(3509),
    [anon_sym_new] = ACTIONS(3509),
    [anon_sym_override] = ACTIONS(3509),
    [anon_sym_partial] = ACTIONS(3509),
    [anon_sym_private] = ACTIONS(3509),
    [anon_sym_protected] = ACTIONS(3509),
    [anon_sym_public] = ACTIONS(3509),
    [anon_sym_readonly] = ACTIONS(3509),
    [anon_sym_required] = ACTIONS(3509),
    [anon_sym_sealed] = ACTIONS(3509),
    [anon_sym_virtual] = ACTIONS(3509),
    [anon_sym_volatile] = ACTIONS(3509),
    [anon_sym_where] = ACTIONS(3509),
    [anon_sym_notnull] = ACTIONS(3509),
    [anon_sym_unmanaged] = ACTIONS(3509),
    [anon_sym_checked] = ACTIONS(3509),
    [anon_sym_BANG] = ACTIONS(3511),
    [anon_sym_TILDE] = ACTIONS(3511),
    [anon_sym_PLUS_PLUS] = ACTIONS(3511),
    [anon_sym_DASH_DASH] = ACTIONS(3511),
    [anon_sym_true] = ACTIONS(3509),
    [anon_sym_false] = ACTIONS(3509),
    [anon_sym_PLUS] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3509),
    [anon_sym_STAR] = ACTIONS(3511),
    [anon_sym_CARET] = ACTIONS(3511),
    [anon_sym_AMP] = ACTIONS(3511),
    [anon_sym_this] = ACTIONS(3509),
    [anon_sym_scoped] = ACTIONS(3509),
    [anon_sym_var] = ACTIONS(3509),
    [sym_predefined_type] = ACTIONS(3509),
    [anon_sym_break] = ACTIONS(3509),
    [anon_sym_unchecked] = ACTIONS(3509),
    [anon_sym_continue] = ACTIONS(3509),
    [anon_sym_do] = ACTIONS(3509),
    [anon_sym_while] = ACTIONS(3509),
    [anon_sym_for] = ACTIONS(3509),
    [anon_sym_lock] = ACTIONS(3509),
    [anon_sym_yield] = ACTIONS(3509),
    [anon_sym_switch] = ACTIONS(3509),
    [anon_sym_default] = ACTIONS(3509),
    [anon_sym_throw] = ACTIONS(3509),
    [anon_sym_try] = ACTIONS(3509),
    [anon_sym_when] = ACTIONS(3509),
    [anon_sym_await] = ACTIONS(3509),
    [anon_sym_foreach] = ACTIONS(3509),
    [anon_sym_goto] = ACTIONS(3509),
    [anon_sym_if] = ACTIONS(3509),
    [anon_sym_DOT_DOT] = ACTIONS(3511),
    [anon_sym_from] = ACTIONS(3509),
    [anon_sym_into] = ACTIONS(3509),
    [anon_sym_join] = ACTIONS(3509),
    [anon_sym_on] = ACTIONS(3509),
    [anon_sym_equals] = ACTIONS(3509),
    [anon_sym_let] = ACTIONS(3509),
    [anon_sym_orderby] = ACTIONS(3509),
    [anon_sym_ascending] = ACTIONS(3509),
    [anon_sym_descending] = ACTIONS(3509),
    [anon_sym_group] = ACTIONS(3509),
    [anon_sym_by] = ACTIONS(3509),
    [anon_sym_select] = ACTIONS(3509),
    [anon_sym_DQUOTE] = ACTIONS(3509),
    [anon_sym_stackalloc] = ACTIONS(3509),
    [anon_sym_sizeof] = ACTIONS(3509),
    [anon_sym_typeof] = ACTIONS(3509),
    [anon_sym___makeref] = ACTIONS(3509),
    [anon_sym___reftype] = ACTIONS(3509),
    [anon_sym___refvalue] = ACTIONS(3509),
    [sym_null_literal] = ACTIONS(3509),
    [anon_sym_SQUOTE] = ACTIONS(3511),
    [sym_integer_literal] = ACTIONS(3509),
    [sym_real_literal] = ACTIONS(3511),
    [sym_verbatim_string_literal] = ACTIONS(3511),
    [sym_raw_string_literal] = ACTIONS(3511),
    [aux_sym_preproc_if_token1] = ACTIONS(3511),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3511),
    [sym_interpolation_verbatim_start] = ACTIONS(3511),
    [sym_interpolation_raw_start] = ACTIONS(3511),
  },
  [2618] = {
    [sym_preproc_region] = STATE(2618),
    [sym_preproc_endregion] = STATE(2618),
    [sym_preproc_line] = STATE(2618),
    [sym_preproc_pragma] = STATE(2618),
    [sym_preproc_nullable] = STATE(2618),
    [sym_preproc_error] = STATE(2618),
    [sym_preproc_define] = STATE(2618),
    [sym_preproc_undef] = STATE(2618),
    [ts_builtin_sym_end] = ACTIONS(3838),
    [sym__identifier_token] = ACTIONS(3836),
    [anon_sym_extern] = ACTIONS(3836),
    [anon_sym_alias] = ACTIONS(3836),
    [anon_sym_SEMI] = ACTIONS(3838),
    [anon_sym_global] = ACTIONS(3836),
    [anon_sym_using] = ACTIONS(3836),
    [anon_sym_unsafe] = ACTIONS(3836),
    [anon_sym_static] = ACTIONS(3836),
    [anon_sym_LBRACK] = ACTIONS(3838),
    [anon_sym_LPAREN] = ACTIONS(3838),
    [anon_sym_return] = ACTIONS(3836),
    [anon_sym_namespace] = ACTIONS(3836),
    [anon_sym_class] = ACTIONS(3836),
    [anon_sym_ref] = ACTIONS(3836),
    [anon_sym_struct] = ACTIONS(3836),
    [anon_sym_enum] = ACTIONS(3836),
    [anon_sym_LBRACE] = ACTIONS(3838),
    [anon_sym_interface] = ACTIONS(3836),
    [anon_sym_delegate] = ACTIONS(3836),
    [anon_sym_record] = ACTIONS(3836),
    [anon_sym_abstract] = ACTIONS(3836),
    [anon_sym_async] = ACTIONS(3836),
    [anon_sym_const] = ACTIONS(3836),
    [anon_sym_file] = ACTIONS(3836),
    [anon_sym_fixed] = ACTIONS(3836),
    [anon_sym_internal] = ACTIONS(3836),
    [anon_sym_new] = ACTIONS(3836),
    [anon_sym_override] = ACTIONS(3836),
    [anon_sym_partial] = ACTIONS(3836),
    [anon_sym_private] = ACTIONS(3836),
    [anon_sym_protected] = ACTIONS(3836),
    [anon_sym_public] = ACTIONS(3836),
    [anon_sym_readonly] = ACTIONS(3836),
    [anon_sym_required] = ACTIONS(3836),
    [anon_sym_sealed] = ACTIONS(3836),
    [anon_sym_virtual] = ACTIONS(3836),
    [anon_sym_volatile] = ACTIONS(3836),
    [anon_sym_where] = ACTIONS(3836),
    [anon_sym_notnull] = ACTIONS(3836),
    [anon_sym_unmanaged] = ACTIONS(3836),
    [anon_sym_checked] = ACTIONS(3836),
    [anon_sym_BANG] = ACTIONS(3838),
    [anon_sym_TILDE] = ACTIONS(3838),
    [anon_sym_PLUS_PLUS] = ACTIONS(3838),
    [anon_sym_DASH_DASH] = ACTIONS(3838),
    [anon_sym_true] = ACTIONS(3836),
    [anon_sym_false] = ACTIONS(3836),
    [anon_sym_PLUS] = ACTIONS(3836),
    [anon_sym_DASH] = ACTIONS(3836),
    [anon_sym_STAR] = ACTIONS(3838),
    [anon_sym_CARET] = ACTIONS(3838),
    [anon_sym_AMP] = ACTIONS(3838),
    [anon_sym_this] = ACTIONS(3836),
    [anon_sym_scoped] = ACTIONS(3836),
    [anon_sym_var] = ACTIONS(3836),
    [sym_predefined_type] = ACTIONS(3836),
    [anon_sym_break] = ACTIONS(3836),
    [anon_sym_unchecked] = ACTIONS(3836),
    [anon_sym_continue] = ACTIONS(3836),
    [anon_sym_do] = ACTIONS(3836),
    [anon_sym_while] = ACTIONS(3836),
    [anon_sym_for] = ACTIONS(3836),
    [anon_sym_lock] = ACTIONS(3836),
    [anon_sym_yield] = ACTIONS(3836),
    [anon_sym_switch] = ACTIONS(3836),
    [anon_sym_default] = ACTIONS(3836),
    [anon_sym_throw] = ACTIONS(3836),
    [anon_sym_try] = ACTIONS(3836),
    [anon_sym_when] = ACTIONS(3836),
    [anon_sym_await] = ACTIONS(3836),
    [anon_sym_foreach] = ACTIONS(3836),
    [anon_sym_goto] = ACTIONS(3836),
    [anon_sym_if] = ACTIONS(3836),
    [anon_sym_DOT_DOT] = ACTIONS(3838),
    [anon_sym_from] = ACTIONS(3836),
    [anon_sym_into] = ACTIONS(3836),
    [anon_sym_join] = ACTIONS(3836),
    [anon_sym_on] = ACTIONS(3836),
    [anon_sym_equals] = ACTIONS(3836),
    [anon_sym_let] = ACTIONS(3836),
    [anon_sym_orderby] = ACTIONS(3836),
    [anon_sym_ascending] = ACTIONS(3836),
    [anon_sym_descending] = ACTIONS(3836),
    [anon_sym_group] = ACTIONS(3836),
    [anon_sym_by] = ACTIONS(3836),
    [anon_sym_select] = ACTIONS(3836),
    [anon_sym_DQUOTE] = ACTIONS(3836),
    [anon_sym_stackalloc] = ACTIONS(3836),
    [anon_sym_sizeof] = ACTIONS(3836),
    [anon_sym_typeof] = ACTIONS(3836),
    [anon_sym___makeref] = ACTIONS(3836),
    [anon_sym___reftype] = ACTIONS(3836),
    [anon_sym___refvalue] = ACTIONS(3836),
    [sym_null_literal] = ACTIONS(3836),
    [anon_sym_SQUOTE] = ACTIONS(3838),
    [sym_integer_literal] = ACTIONS(3836),
    [sym_real_literal] = ACTIONS(3838),
    [sym_verbatim_string_literal] = ACTIONS(3838),
    [sym_raw_string_literal] = ACTIONS(3838),
    [aux_sym_preproc_if_token1] = ACTIONS(3838),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3838),
    [sym_interpolation_verbatim_start] = ACTIONS(3838),
    [sym_interpolation_raw_start] = ACTIONS(3838),
  },
  [2619] = {
    [sym_preproc_region] = STATE(2619),
    [sym_preproc_endregion] = STATE(2619),
    [sym_preproc_line] = STATE(2619),
    [sym_preproc_pragma] = STATE(2619),
    [sym_preproc_nullable] = STATE(2619),
    [sym_preproc_error] = STATE(2619),
    [sym_preproc_define] = STATE(2619),
    [sym_preproc_undef] = STATE(2619),
    [ts_builtin_sym_end] = ACTIONS(3806),
    [sym__identifier_token] = ACTIONS(3804),
    [anon_sym_extern] = ACTIONS(3804),
    [anon_sym_alias] = ACTIONS(3804),
    [anon_sym_SEMI] = ACTIONS(3806),
    [anon_sym_global] = ACTIONS(3804),
    [anon_sym_using] = ACTIONS(3804),
    [anon_sym_unsafe] = ACTIONS(3804),
    [anon_sym_static] = ACTIONS(3804),
    [anon_sym_LBRACK] = ACTIONS(3806),
    [anon_sym_LPAREN] = ACTIONS(3806),
    [anon_sym_return] = ACTIONS(3804),
    [anon_sym_namespace] = ACTIONS(3804),
    [anon_sym_class] = ACTIONS(3804),
    [anon_sym_ref] = ACTIONS(3804),
    [anon_sym_struct] = ACTIONS(3804),
    [anon_sym_enum] = ACTIONS(3804),
    [anon_sym_LBRACE] = ACTIONS(3806),
    [anon_sym_interface] = ACTIONS(3804),
    [anon_sym_delegate] = ACTIONS(3804),
    [anon_sym_record] = ACTIONS(3804),
    [anon_sym_abstract] = ACTIONS(3804),
    [anon_sym_async] = ACTIONS(3804),
    [anon_sym_const] = ACTIONS(3804),
    [anon_sym_file] = ACTIONS(3804),
    [anon_sym_fixed] = ACTIONS(3804),
    [anon_sym_internal] = ACTIONS(3804),
    [anon_sym_new] = ACTIONS(3804),
    [anon_sym_override] = ACTIONS(3804),
    [anon_sym_partial] = ACTIONS(3804),
    [anon_sym_private] = ACTIONS(3804),
    [anon_sym_protected] = ACTIONS(3804),
    [anon_sym_public] = ACTIONS(3804),
    [anon_sym_readonly] = ACTIONS(3804),
    [anon_sym_required] = ACTIONS(3804),
    [anon_sym_sealed] = ACTIONS(3804),
    [anon_sym_virtual] = ACTIONS(3804),
    [anon_sym_volatile] = ACTIONS(3804),
    [anon_sym_where] = ACTIONS(3804),
    [anon_sym_notnull] = ACTIONS(3804),
    [anon_sym_unmanaged] = ACTIONS(3804),
    [anon_sym_checked] = ACTIONS(3804),
    [anon_sym_BANG] = ACTIONS(3806),
    [anon_sym_TILDE] = ACTIONS(3806),
    [anon_sym_PLUS_PLUS] = ACTIONS(3806),
    [anon_sym_DASH_DASH] = ACTIONS(3806),
    [anon_sym_true] = ACTIONS(3804),
    [anon_sym_false] = ACTIONS(3804),
    [anon_sym_PLUS] = ACTIONS(3804),
    [anon_sym_DASH] = ACTIONS(3804),
    [anon_sym_STAR] = ACTIONS(3806),
    [anon_sym_CARET] = ACTIONS(3806),
    [anon_sym_AMP] = ACTIONS(3806),
    [anon_sym_this] = ACTIONS(3804),
    [anon_sym_scoped] = ACTIONS(3804),
    [anon_sym_var] = ACTIONS(3804),
    [sym_predefined_type] = ACTIONS(3804),
    [anon_sym_break] = ACTIONS(3804),
    [anon_sym_unchecked] = ACTIONS(3804),
    [anon_sym_continue] = ACTIONS(3804),
    [anon_sym_do] = ACTIONS(3804),
    [anon_sym_while] = ACTIONS(3804),
    [anon_sym_for] = ACTIONS(3804),
    [anon_sym_lock] = ACTIONS(3804),
    [anon_sym_yield] = ACTIONS(3804),
    [anon_sym_switch] = ACTIONS(3804),
    [anon_sym_default] = ACTIONS(3804),
    [anon_sym_throw] = ACTIONS(3804),
    [anon_sym_try] = ACTIONS(3804),
    [anon_sym_when] = ACTIONS(3804),
    [anon_sym_await] = ACTIONS(3804),
    [anon_sym_foreach] = ACTIONS(3804),
    [anon_sym_goto] = ACTIONS(3804),
    [anon_sym_if] = ACTIONS(3804),
    [anon_sym_DOT_DOT] = ACTIONS(3806),
    [anon_sym_from] = ACTIONS(3804),
    [anon_sym_into] = ACTIONS(3804),
    [anon_sym_join] = ACTIONS(3804),
    [anon_sym_on] = ACTIONS(3804),
    [anon_sym_equals] = ACTIONS(3804),
    [anon_sym_let] = ACTIONS(3804),
    [anon_sym_orderby] = ACTIONS(3804),
    [anon_sym_ascending] = ACTIONS(3804),
    [anon_sym_descending] = ACTIONS(3804),
    [anon_sym_group] = ACTIONS(3804),
    [anon_sym_by] = ACTIONS(3804),
    [anon_sym_select] = ACTIONS(3804),
    [anon_sym_DQUOTE] = ACTIONS(3804),
    [anon_sym_stackalloc] = ACTIONS(3804),
    [anon_sym_sizeof] = ACTIONS(3804),
    [anon_sym_typeof] = ACTIONS(3804),
    [anon_sym___makeref] = ACTIONS(3804),
    [anon_sym___reftype] = ACTIONS(3804),
    [anon_sym___refvalue] = ACTIONS(3804),
    [sym_null_literal] = ACTIONS(3804),
    [anon_sym_SQUOTE] = ACTIONS(3806),
    [sym_integer_literal] = ACTIONS(3804),
    [sym_real_literal] = ACTIONS(3806),
    [sym_verbatim_string_literal] = ACTIONS(3806),
    [sym_raw_string_literal] = ACTIONS(3806),
    [aux_sym_preproc_if_token1] = ACTIONS(3806),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3806),
    [sym_interpolation_verbatim_start] = ACTIONS(3806),
    [sym_interpolation_raw_start] = ACTIONS(3806),
  },
  [2620] = {
    [sym_preproc_region] = STATE(2620),
    [sym_preproc_endregion] = STATE(2620),
    [sym_preproc_line] = STATE(2620),
    [sym_preproc_pragma] = STATE(2620),
    [sym_preproc_nullable] = STATE(2620),
    [sym_preproc_error] = STATE(2620),
    [sym_preproc_define] = STATE(2620),
    [sym_preproc_undef] = STATE(2620),
    [ts_builtin_sym_end] = ACTIONS(3834),
    [sym__identifier_token] = ACTIONS(3832),
    [anon_sym_extern] = ACTIONS(3832),
    [anon_sym_alias] = ACTIONS(3832),
    [anon_sym_SEMI] = ACTIONS(3834),
    [anon_sym_global] = ACTIONS(3832),
    [anon_sym_using] = ACTIONS(3832),
    [anon_sym_unsafe] = ACTIONS(3832),
    [anon_sym_static] = ACTIONS(3832),
    [anon_sym_LBRACK] = ACTIONS(3834),
    [anon_sym_LPAREN] = ACTIONS(3834),
    [anon_sym_return] = ACTIONS(3832),
    [anon_sym_namespace] = ACTIONS(3832),
    [anon_sym_class] = ACTIONS(3832),
    [anon_sym_ref] = ACTIONS(3832),
    [anon_sym_struct] = ACTIONS(3832),
    [anon_sym_enum] = ACTIONS(3832),
    [anon_sym_LBRACE] = ACTIONS(3834),
    [anon_sym_interface] = ACTIONS(3832),
    [anon_sym_delegate] = ACTIONS(3832),
    [anon_sym_record] = ACTIONS(3832),
    [anon_sym_abstract] = ACTIONS(3832),
    [anon_sym_async] = ACTIONS(3832),
    [anon_sym_const] = ACTIONS(3832),
    [anon_sym_file] = ACTIONS(3832),
    [anon_sym_fixed] = ACTIONS(3832),
    [anon_sym_internal] = ACTIONS(3832),
    [anon_sym_new] = ACTIONS(3832),
    [anon_sym_override] = ACTIONS(3832),
    [anon_sym_partial] = ACTIONS(3832),
    [anon_sym_private] = ACTIONS(3832),
    [anon_sym_protected] = ACTIONS(3832),
    [anon_sym_public] = ACTIONS(3832),
    [anon_sym_readonly] = ACTIONS(3832),
    [anon_sym_required] = ACTIONS(3832),
    [anon_sym_sealed] = ACTIONS(3832),
    [anon_sym_virtual] = ACTIONS(3832),
    [anon_sym_volatile] = ACTIONS(3832),
    [anon_sym_where] = ACTIONS(3832),
    [anon_sym_notnull] = ACTIONS(3832),
    [anon_sym_unmanaged] = ACTIONS(3832),
    [anon_sym_checked] = ACTIONS(3832),
    [anon_sym_BANG] = ACTIONS(3834),
    [anon_sym_TILDE] = ACTIONS(3834),
    [anon_sym_PLUS_PLUS] = ACTIONS(3834),
    [anon_sym_DASH_DASH] = ACTIONS(3834),
    [anon_sym_true] = ACTIONS(3832),
    [anon_sym_false] = ACTIONS(3832),
    [anon_sym_PLUS] = ACTIONS(3832),
    [anon_sym_DASH] = ACTIONS(3832),
    [anon_sym_STAR] = ACTIONS(3834),
    [anon_sym_CARET] = ACTIONS(3834),
    [anon_sym_AMP] = ACTIONS(3834),
    [anon_sym_this] = ACTIONS(3832),
    [anon_sym_scoped] = ACTIONS(3832),
    [anon_sym_var] = ACTIONS(3832),
    [sym_predefined_type] = ACTIONS(3832),
    [anon_sym_break] = ACTIONS(3832),
    [anon_sym_unchecked] = ACTIONS(3832),
    [anon_sym_continue] = ACTIONS(3832),
    [anon_sym_do] = ACTIONS(3832),
    [anon_sym_while] = ACTIONS(3832),
    [anon_sym_for] = ACTIONS(3832),
    [anon_sym_lock] = ACTIONS(3832),
    [anon_sym_yield] = ACTIONS(3832),
    [anon_sym_switch] = ACTIONS(3832),
    [anon_sym_default] = ACTIONS(3832),
    [anon_sym_throw] = ACTIONS(3832),
    [anon_sym_try] = ACTIONS(3832),
    [anon_sym_when] = ACTIONS(3832),
    [anon_sym_await] = ACTIONS(3832),
    [anon_sym_foreach] = ACTIONS(3832),
    [anon_sym_goto] = ACTIONS(3832),
    [anon_sym_if] = ACTIONS(3832),
    [anon_sym_DOT_DOT] = ACTIONS(3834),
    [anon_sym_from] = ACTIONS(3832),
    [anon_sym_into] = ACTIONS(3832),
    [anon_sym_join] = ACTIONS(3832),
    [anon_sym_on] = ACTIONS(3832),
    [anon_sym_equals] = ACTIONS(3832),
    [anon_sym_let] = ACTIONS(3832),
    [anon_sym_orderby] = ACTIONS(3832),
    [anon_sym_ascending] = ACTIONS(3832),
    [anon_sym_descending] = ACTIONS(3832),
    [anon_sym_group] = ACTIONS(3832),
    [anon_sym_by] = ACTIONS(3832),
    [anon_sym_select] = ACTIONS(3832),
    [anon_sym_DQUOTE] = ACTIONS(3832),
    [anon_sym_stackalloc] = ACTIONS(3832),
    [anon_sym_sizeof] = ACTIONS(3832),
    [anon_sym_typeof] = ACTIONS(3832),
    [anon_sym___makeref] = ACTIONS(3832),
    [anon_sym___reftype] = ACTIONS(3832),
    [anon_sym___refvalue] = ACTIONS(3832),
    [sym_null_literal] = ACTIONS(3832),
    [anon_sym_SQUOTE] = ACTIONS(3834),
    [sym_integer_literal] = ACTIONS(3832),
    [sym_real_literal] = ACTIONS(3834),
    [sym_verbatim_string_literal] = ACTIONS(3834),
    [sym_raw_string_literal] = ACTIONS(3834),
    [aux_sym_preproc_if_token1] = ACTIONS(3834),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3834),
    [sym_interpolation_verbatim_start] = ACTIONS(3834),
    [sym_interpolation_raw_start] = ACTIONS(3834),
  },
  [2621] = {
    [sym_preproc_region] = STATE(2621),
    [sym_preproc_endregion] = STATE(2621),
    [sym_preproc_line] = STATE(2621),
    [sym_preproc_pragma] = STATE(2621),
    [sym_preproc_nullable] = STATE(2621),
    [sym_preproc_error] = STATE(2621),
    [sym_preproc_define] = STATE(2621),
    [sym_preproc_undef] = STATE(2621),
    [ts_builtin_sym_end] = ACTIONS(3810),
    [sym__identifier_token] = ACTIONS(3808),
    [anon_sym_extern] = ACTIONS(3808),
    [anon_sym_alias] = ACTIONS(3808),
    [anon_sym_SEMI] = ACTIONS(3810),
    [anon_sym_global] = ACTIONS(3808),
    [anon_sym_using] = ACTIONS(3808),
    [anon_sym_unsafe] = ACTIONS(3808),
    [anon_sym_static] = ACTIONS(3808),
    [anon_sym_LBRACK] = ACTIONS(3810),
    [anon_sym_LPAREN] = ACTIONS(3810),
    [anon_sym_return] = ACTIONS(3808),
    [anon_sym_namespace] = ACTIONS(3808),
    [anon_sym_class] = ACTIONS(3808),
    [anon_sym_ref] = ACTIONS(3808),
    [anon_sym_struct] = ACTIONS(3808),
    [anon_sym_enum] = ACTIONS(3808),
    [anon_sym_LBRACE] = ACTIONS(3810),
    [anon_sym_interface] = ACTIONS(3808),
    [anon_sym_delegate] = ACTIONS(3808),
    [anon_sym_record] = ACTIONS(3808),
    [anon_sym_abstract] = ACTIONS(3808),
    [anon_sym_async] = ACTIONS(3808),
    [anon_sym_const] = ACTIONS(3808),
    [anon_sym_file] = ACTIONS(3808),
    [anon_sym_fixed] = ACTIONS(3808),
    [anon_sym_internal] = ACTIONS(3808),
    [anon_sym_new] = ACTIONS(3808),
    [anon_sym_override] = ACTIONS(3808),
    [anon_sym_partial] = ACTIONS(3808),
    [anon_sym_private] = ACTIONS(3808),
    [anon_sym_protected] = ACTIONS(3808),
    [anon_sym_public] = ACTIONS(3808),
    [anon_sym_readonly] = ACTIONS(3808),
    [anon_sym_required] = ACTIONS(3808),
    [anon_sym_sealed] = ACTIONS(3808),
    [anon_sym_virtual] = ACTIONS(3808),
    [anon_sym_volatile] = ACTIONS(3808),
    [anon_sym_where] = ACTIONS(3808),
    [anon_sym_notnull] = ACTIONS(3808),
    [anon_sym_unmanaged] = ACTIONS(3808),
    [anon_sym_checked] = ACTIONS(3808),
    [anon_sym_BANG] = ACTIONS(3810),
    [anon_sym_TILDE] = ACTIONS(3810),
    [anon_sym_PLUS_PLUS] = ACTIONS(3810),
    [anon_sym_DASH_DASH] = ACTIONS(3810),
    [anon_sym_true] = ACTIONS(3808),
    [anon_sym_false] = ACTIONS(3808),
    [anon_sym_PLUS] = ACTIONS(3808),
    [anon_sym_DASH] = ACTIONS(3808),
    [anon_sym_STAR] = ACTIONS(3810),
    [anon_sym_CARET] = ACTIONS(3810),
    [anon_sym_AMP] = ACTIONS(3810),
    [anon_sym_this] = ACTIONS(3808),
    [anon_sym_scoped] = ACTIONS(3808),
    [anon_sym_var] = ACTIONS(3808),
    [sym_predefined_type] = ACTIONS(3808),
    [anon_sym_break] = ACTIONS(3808),
    [anon_sym_unchecked] = ACTIONS(3808),
    [anon_sym_continue] = ACTIONS(3808),
    [anon_sym_do] = ACTIONS(3808),
    [anon_sym_while] = ACTIONS(3808),
    [anon_sym_for] = ACTIONS(3808),
    [anon_sym_lock] = ACTIONS(3808),
    [anon_sym_yield] = ACTIONS(3808),
    [anon_sym_switch] = ACTIONS(3808),
    [anon_sym_default] = ACTIONS(3808),
    [anon_sym_throw] = ACTIONS(3808),
    [anon_sym_try] = ACTIONS(3808),
    [anon_sym_when] = ACTIONS(3808),
    [anon_sym_await] = ACTIONS(3808),
    [anon_sym_foreach] = ACTIONS(3808),
    [anon_sym_goto] = ACTIONS(3808),
    [anon_sym_if] = ACTIONS(3808),
    [anon_sym_DOT_DOT] = ACTIONS(3810),
    [anon_sym_from] = ACTIONS(3808),
    [anon_sym_into] = ACTIONS(3808),
    [anon_sym_join] = ACTIONS(3808),
    [anon_sym_on] = ACTIONS(3808),
    [anon_sym_equals] = ACTIONS(3808),
    [anon_sym_let] = ACTIONS(3808),
    [anon_sym_orderby] = ACTIONS(3808),
    [anon_sym_ascending] = ACTIONS(3808),
    [anon_sym_descending] = ACTIONS(3808),
    [anon_sym_group] = ACTIONS(3808),
    [anon_sym_by] = ACTIONS(3808),
    [anon_sym_select] = ACTIONS(3808),
    [anon_sym_DQUOTE] = ACTIONS(3808),
    [anon_sym_stackalloc] = ACTIONS(3808),
    [anon_sym_sizeof] = ACTIONS(3808),
    [anon_sym_typeof] = ACTIONS(3808),
    [anon_sym___makeref] = ACTIONS(3808),
    [anon_sym___reftype] = ACTIONS(3808),
    [anon_sym___refvalue] = ACTIONS(3808),
    [sym_null_literal] = ACTIONS(3808),
    [anon_sym_SQUOTE] = ACTIONS(3810),
    [sym_integer_literal] = ACTIONS(3808),
    [sym_real_literal] = ACTIONS(3810),
    [sym_verbatim_string_literal] = ACTIONS(3810),
    [sym_raw_string_literal] = ACTIONS(3810),
    [aux_sym_preproc_if_token1] = ACTIONS(3810),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3810),
    [sym_interpolation_verbatim_start] = ACTIONS(3810),
    [sym_interpolation_raw_start] = ACTIONS(3810),
  },
  [2622] = {
    [sym_preproc_region] = STATE(2622),
    [sym_preproc_endregion] = STATE(2622),
    [sym_preproc_line] = STATE(2622),
    [sym_preproc_pragma] = STATE(2622),
    [sym_preproc_nullable] = STATE(2622),
    [sym_preproc_error] = STATE(2622),
    [sym_preproc_define] = STATE(2622),
    [sym_preproc_undef] = STATE(2622),
    [ts_builtin_sym_end] = ACTIONS(3551),
    [sym__identifier_token] = ACTIONS(3549),
    [anon_sym_extern] = ACTIONS(3549),
    [anon_sym_alias] = ACTIONS(3549),
    [anon_sym_SEMI] = ACTIONS(3551),
    [anon_sym_global] = ACTIONS(3549),
    [anon_sym_using] = ACTIONS(3549),
    [anon_sym_unsafe] = ACTIONS(3549),
    [anon_sym_static] = ACTIONS(3549),
    [anon_sym_LBRACK] = ACTIONS(3551),
    [anon_sym_LPAREN] = ACTIONS(3551),
    [anon_sym_return] = ACTIONS(3549),
    [anon_sym_namespace] = ACTIONS(3549),
    [anon_sym_class] = ACTIONS(3549),
    [anon_sym_ref] = ACTIONS(3549),
    [anon_sym_struct] = ACTIONS(3549),
    [anon_sym_enum] = ACTIONS(3549),
    [anon_sym_LBRACE] = ACTIONS(3551),
    [anon_sym_interface] = ACTIONS(3549),
    [anon_sym_delegate] = ACTIONS(3549),
    [anon_sym_record] = ACTIONS(3549),
    [anon_sym_abstract] = ACTIONS(3549),
    [anon_sym_async] = ACTIONS(3549),
    [anon_sym_const] = ACTIONS(3549),
    [anon_sym_file] = ACTIONS(3549),
    [anon_sym_fixed] = ACTIONS(3549),
    [anon_sym_internal] = ACTIONS(3549),
    [anon_sym_new] = ACTIONS(3549),
    [anon_sym_override] = ACTIONS(3549),
    [anon_sym_partial] = ACTIONS(3549),
    [anon_sym_private] = ACTIONS(3549),
    [anon_sym_protected] = ACTIONS(3549),
    [anon_sym_public] = ACTIONS(3549),
    [anon_sym_readonly] = ACTIONS(3549),
    [anon_sym_required] = ACTIONS(3549),
    [anon_sym_sealed] = ACTIONS(3549),
    [anon_sym_virtual] = ACTIONS(3549),
    [anon_sym_volatile] = ACTIONS(3549),
    [anon_sym_where] = ACTIONS(3549),
    [anon_sym_notnull] = ACTIONS(3549),
    [anon_sym_unmanaged] = ACTIONS(3549),
    [anon_sym_checked] = ACTIONS(3549),
    [anon_sym_BANG] = ACTIONS(3551),
    [anon_sym_TILDE] = ACTIONS(3551),
    [anon_sym_PLUS_PLUS] = ACTIONS(3551),
    [anon_sym_DASH_DASH] = ACTIONS(3551),
    [anon_sym_true] = ACTIONS(3549),
    [anon_sym_false] = ACTIONS(3549),
    [anon_sym_PLUS] = ACTIONS(3549),
    [anon_sym_DASH] = ACTIONS(3549),
    [anon_sym_STAR] = ACTIONS(3551),
    [anon_sym_CARET] = ACTIONS(3551),
    [anon_sym_AMP] = ACTIONS(3551),
    [anon_sym_this] = ACTIONS(3549),
    [anon_sym_scoped] = ACTIONS(3549),
    [anon_sym_var] = ACTIONS(3549),
    [sym_predefined_type] = ACTIONS(3549),
    [anon_sym_break] = ACTIONS(3549),
    [anon_sym_unchecked] = ACTIONS(3549),
    [anon_sym_continue] = ACTIONS(3549),
    [anon_sym_do] = ACTIONS(3549),
    [anon_sym_while] = ACTIONS(3549),
    [anon_sym_for] = ACTIONS(3549),
    [anon_sym_lock] = ACTIONS(3549),
    [anon_sym_yield] = ACTIONS(3549),
    [anon_sym_switch] = ACTIONS(3549),
    [anon_sym_default] = ACTIONS(3549),
    [anon_sym_throw] = ACTIONS(3549),
    [anon_sym_try] = ACTIONS(3549),
    [anon_sym_when] = ACTIONS(3549),
    [anon_sym_await] = ACTIONS(3549),
    [anon_sym_foreach] = ACTIONS(3549),
    [anon_sym_goto] = ACTIONS(3549),
    [anon_sym_if] = ACTIONS(3549),
    [anon_sym_DOT_DOT] = ACTIONS(3551),
    [anon_sym_from] = ACTIONS(3549),
    [anon_sym_into] = ACTIONS(3549),
    [anon_sym_join] = ACTIONS(3549),
    [anon_sym_on] = ACTIONS(3549),
    [anon_sym_equals] = ACTIONS(3549),
    [anon_sym_let] = ACTIONS(3549),
    [anon_sym_orderby] = ACTIONS(3549),
    [anon_sym_ascending] = ACTIONS(3549),
    [anon_sym_descending] = ACTIONS(3549),
    [anon_sym_group] = ACTIONS(3549),
    [anon_sym_by] = ACTIONS(3549),
    [anon_sym_select] = ACTIONS(3549),
    [anon_sym_DQUOTE] = ACTIONS(3549),
    [anon_sym_stackalloc] = ACTIONS(3549),
    [anon_sym_sizeof] = ACTIONS(3549),
    [anon_sym_typeof] = ACTIONS(3549),
    [anon_sym___makeref] = ACTIONS(3549),
    [anon_sym___reftype] = ACTIONS(3549),
    [anon_sym___refvalue] = ACTIONS(3549),
    [sym_null_literal] = ACTIONS(3549),
    [anon_sym_SQUOTE] = ACTIONS(3551),
    [sym_integer_literal] = ACTIONS(3549),
    [sym_real_literal] = ACTIONS(3551),
    [sym_verbatim_string_literal] = ACTIONS(3551),
    [sym_raw_string_literal] = ACTIONS(3551),
    [aux_sym_preproc_if_token1] = ACTIONS(3551),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3551),
    [sym_interpolation_verbatim_start] = ACTIONS(3551),
    [sym_interpolation_raw_start] = ACTIONS(3551),
  },
  [2623] = {
    [sym_preproc_region] = STATE(2623),
    [sym_preproc_endregion] = STATE(2623),
    [sym_preproc_line] = STATE(2623),
    [sym_preproc_pragma] = STATE(2623),
    [sym_preproc_nullable] = STATE(2623),
    [sym_preproc_error] = STATE(2623),
    [sym_preproc_define] = STATE(2623),
    [sym_preproc_undef] = STATE(2623),
    [ts_builtin_sym_end] = ACTIONS(3635),
    [sym__identifier_token] = ACTIONS(3633),
    [anon_sym_extern] = ACTIONS(3633),
    [anon_sym_alias] = ACTIONS(3633),
    [anon_sym_SEMI] = ACTIONS(3635),
    [anon_sym_global] = ACTIONS(3633),
    [anon_sym_using] = ACTIONS(3633),
    [anon_sym_unsafe] = ACTIONS(3633),
    [anon_sym_static] = ACTIONS(3633),
    [anon_sym_LBRACK] = ACTIONS(3635),
    [anon_sym_LPAREN] = ACTIONS(3635),
    [anon_sym_return] = ACTIONS(3633),
    [anon_sym_namespace] = ACTIONS(3633),
    [anon_sym_class] = ACTIONS(3633),
    [anon_sym_ref] = ACTIONS(3633),
    [anon_sym_struct] = ACTIONS(3633),
    [anon_sym_enum] = ACTIONS(3633),
    [anon_sym_LBRACE] = ACTIONS(3635),
    [anon_sym_interface] = ACTIONS(3633),
    [anon_sym_delegate] = ACTIONS(3633),
    [anon_sym_record] = ACTIONS(3633),
    [anon_sym_abstract] = ACTIONS(3633),
    [anon_sym_async] = ACTIONS(3633),
    [anon_sym_const] = ACTIONS(3633),
    [anon_sym_file] = ACTIONS(3633),
    [anon_sym_fixed] = ACTIONS(3633),
    [anon_sym_internal] = ACTIONS(3633),
    [anon_sym_new] = ACTIONS(3633),
    [anon_sym_override] = ACTIONS(3633),
    [anon_sym_partial] = ACTIONS(3633),
    [anon_sym_private] = ACTIONS(3633),
    [anon_sym_protected] = ACTIONS(3633),
    [anon_sym_public] = ACTIONS(3633),
    [anon_sym_readonly] = ACTIONS(3633),
    [anon_sym_required] = ACTIONS(3633),
    [anon_sym_sealed] = ACTIONS(3633),
    [anon_sym_virtual] = ACTIONS(3633),
    [anon_sym_volatile] = ACTIONS(3633),
    [anon_sym_where] = ACTIONS(3633),
    [anon_sym_notnull] = ACTIONS(3633),
    [anon_sym_unmanaged] = ACTIONS(3633),
    [anon_sym_checked] = ACTIONS(3633),
    [anon_sym_BANG] = ACTIONS(3635),
    [anon_sym_TILDE] = ACTIONS(3635),
    [anon_sym_PLUS_PLUS] = ACTIONS(3635),
    [anon_sym_DASH_DASH] = ACTIONS(3635),
    [anon_sym_true] = ACTIONS(3633),
    [anon_sym_false] = ACTIONS(3633),
    [anon_sym_PLUS] = ACTIONS(3633),
    [anon_sym_DASH] = ACTIONS(3633),
    [anon_sym_STAR] = ACTIONS(3635),
    [anon_sym_CARET] = ACTIONS(3635),
    [anon_sym_AMP] = ACTIONS(3635),
    [anon_sym_this] = ACTIONS(3633),
    [anon_sym_scoped] = ACTIONS(3633),
    [anon_sym_var] = ACTIONS(3633),
    [sym_predefined_type] = ACTIONS(3633),
    [anon_sym_break] = ACTIONS(3633),
    [anon_sym_unchecked] = ACTIONS(3633),
    [anon_sym_continue] = ACTIONS(3633),
    [anon_sym_do] = ACTIONS(3633),
    [anon_sym_while] = ACTIONS(3633),
    [anon_sym_for] = ACTIONS(3633),
    [anon_sym_lock] = ACTIONS(3633),
    [anon_sym_yield] = ACTIONS(3633),
    [anon_sym_switch] = ACTIONS(3633),
    [anon_sym_default] = ACTIONS(3633),
    [anon_sym_throw] = ACTIONS(3633),
    [anon_sym_try] = ACTIONS(3633),
    [anon_sym_when] = ACTIONS(3633),
    [anon_sym_await] = ACTIONS(3633),
    [anon_sym_foreach] = ACTIONS(3633),
    [anon_sym_goto] = ACTIONS(3633),
    [anon_sym_if] = ACTIONS(3633),
    [anon_sym_DOT_DOT] = ACTIONS(3635),
    [anon_sym_from] = ACTIONS(3633),
    [anon_sym_into] = ACTIONS(3633),
    [anon_sym_join] = ACTIONS(3633),
    [anon_sym_on] = ACTIONS(3633),
    [anon_sym_equals] = ACTIONS(3633),
    [anon_sym_let] = ACTIONS(3633),
    [anon_sym_orderby] = ACTIONS(3633),
    [anon_sym_ascending] = ACTIONS(3633),
    [anon_sym_descending] = ACTIONS(3633),
    [anon_sym_group] = ACTIONS(3633),
    [anon_sym_by] = ACTIONS(3633),
    [anon_sym_select] = ACTIONS(3633),
    [anon_sym_DQUOTE] = ACTIONS(3633),
    [anon_sym_stackalloc] = ACTIONS(3633),
    [anon_sym_sizeof] = ACTIONS(3633),
    [anon_sym_typeof] = ACTIONS(3633),
    [anon_sym___makeref] = ACTIONS(3633),
    [anon_sym___reftype] = ACTIONS(3633),
    [anon_sym___refvalue] = ACTIONS(3633),
    [sym_null_literal] = ACTIONS(3633),
    [anon_sym_SQUOTE] = ACTIONS(3635),
    [sym_integer_literal] = ACTIONS(3633),
    [sym_real_literal] = ACTIONS(3635),
    [sym_verbatim_string_literal] = ACTIONS(3635),
    [sym_raw_string_literal] = ACTIONS(3635),
    [aux_sym_preproc_if_token1] = ACTIONS(3635),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3635),
    [sym_interpolation_verbatim_start] = ACTIONS(3635),
    [sym_interpolation_raw_start] = ACTIONS(3635),
  },
  [2624] = {
    [sym_preproc_region] = STATE(2624),
    [sym_preproc_endregion] = STATE(2624),
    [sym_preproc_line] = STATE(2624),
    [sym_preproc_pragma] = STATE(2624),
    [sym_preproc_nullable] = STATE(2624),
    [sym_preproc_error] = STATE(2624),
    [sym_preproc_define] = STATE(2624),
    [sym_preproc_undef] = STATE(2624),
    [ts_builtin_sym_end] = ACTIONS(3631),
    [sym__identifier_token] = ACTIONS(3629),
    [anon_sym_extern] = ACTIONS(3629),
    [anon_sym_alias] = ACTIONS(3629),
    [anon_sym_SEMI] = ACTIONS(3631),
    [anon_sym_global] = ACTIONS(3629),
    [anon_sym_using] = ACTIONS(3629),
    [anon_sym_unsafe] = ACTIONS(3629),
    [anon_sym_static] = ACTIONS(3629),
    [anon_sym_LBRACK] = ACTIONS(3631),
    [anon_sym_LPAREN] = ACTIONS(3631),
    [anon_sym_return] = ACTIONS(3629),
    [anon_sym_namespace] = ACTIONS(3629),
    [anon_sym_class] = ACTIONS(3629),
    [anon_sym_ref] = ACTIONS(3629),
    [anon_sym_struct] = ACTIONS(3629),
    [anon_sym_enum] = ACTIONS(3629),
    [anon_sym_LBRACE] = ACTIONS(3631),
    [anon_sym_interface] = ACTIONS(3629),
    [anon_sym_delegate] = ACTIONS(3629),
    [anon_sym_record] = ACTIONS(3629),
    [anon_sym_abstract] = ACTIONS(3629),
    [anon_sym_async] = ACTIONS(3629),
    [anon_sym_const] = ACTIONS(3629),
    [anon_sym_file] = ACTIONS(3629),
    [anon_sym_fixed] = ACTIONS(3629),
    [anon_sym_internal] = ACTIONS(3629),
    [anon_sym_new] = ACTIONS(3629),
    [anon_sym_override] = ACTIONS(3629),
    [anon_sym_partial] = ACTIONS(3629),
    [anon_sym_private] = ACTIONS(3629),
    [anon_sym_protected] = ACTIONS(3629),
    [anon_sym_public] = ACTIONS(3629),
    [anon_sym_readonly] = ACTIONS(3629),
    [anon_sym_required] = ACTIONS(3629),
    [anon_sym_sealed] = ACTIONS(3629),
    [anon_sym_virtual] = ACTIONS(3629),
    [anon_sym_volatile] = ACTIONS(3629),
    [anon_sym_where] = ACTIONS(3629),
    [anon_sym_notnull] = ACTIONS(3629),
    [anon_sym_unmanaged] = ACTIONS(3629),
    [anon_sym_checked] = ACTIONS(3629),
    [anon_sym_BANG] = ACTIONS(3631),
    [anon_sym_TILDE] = ACTIONS(3631),
    [anon_sym_PLUS_PLUS] = ACTIONS(3631),
    [anon_sym_DASH_DASH] = ACTIONS(3631),
    [anon_sym_true] = ACTIONS(3629),
    [anon_sym_false] = ACTIONS(3629),
    [anon_sym_PLUS] = ACTIONS(3629),
    [anon_sym_DASH] = ACTIONS(3629),
    [anon_sym_STAR] = ACTIONS(3631),
    [anon_sym_CARET] = ACTIONS(3631),
    [anon_sym_AMP] = ACTIONS(3631),
    [anon_sym_this] = ACTIONS(3629),
    [anon_sym_scoped] = ACTIONS(3629),
    [anon_sym_var] = ACTIONS(3629),
    [sym_predefined_type] = ACTIONS(3629),
    [anon_sym_break] = ACTIONS(3629),
    [anon_sym_unchecked] = ACTIONS(3629),
    [anon_sym_continue] = ACTIONS(3629),
    [anon_sym_do] = ACTIONS(3629),
    [anon_sym_while] = ACTIONS(3629),
    [anon_sym_for] = ACTIONS(3629),
    [anon_sym_lock] = ACTIONS(3629),
    [anon_sym_yield] = ACTIONS(3629),
    [anon_sym_switch] = ACTIONS(3629),
    [anon_sym_default] = ACTIONS(3629),
    [anon_sym_throw] = ACTIONS(3629),
    [anon_sym_try] = ACTIONS(3629),
    [anon_sym_when] = ACTIONS(3629),
    [anon_sym_await] = ACTIONS(3629),
    [anon_sym_foreach] = ACTIONS(3629),
    [anon_sym_goto] = ACTIONS(3629),
    [anon_sym_if] = ACTIONS(3629),
    [anon_sym_DOT_DOT] = ACTIONS(3631),
    [anon_sym_from] = ACTIONS(3629),
    [anon_sym_into] = ACTIONS(3629),
    [anon_sym_join] = ACTIONS(3629),
    [anon_sym_on] = ACTIONS(3629),
    [anon_sym_equals] = ACTIONS(3629),
    [anon_sym_let] = ACTIONS(3629),
    [anon_sym_orderby] = ACTIONS(3629),
    [anon_sym_ascending] = ACTIONS(3629),
    [anon_sym_descending] = ACTIONS(3629),
    [anon_sym_group] = ACTIONS(3629),
    [anon_sym_by] = ACTIONS(3629),
    [anon_sym_select] = ACTIONS(3629),
    [anon_sym_DQUOTE] = ACTIONS(3629),
    [anon_sym_stackalloc] = ACTIONS(3629),
    [anon_sym_sizeof] = ACTIONS(3629),
    [anon_sym_typeof] = ACTIONS(3629),
    [anon_sym___makeref] = ACTIONS(3629),
    [anon_sym___reftype] = ACTIONS(3629),
    [anon_sym___refvalue] = ACTIONS(3629),
    [sym_null_literal] = ACTIONS(3629),
    [anon_sym_SQUOTE] = ACTIONS(3631),
    [sym_integer_literal] = ACTIONS(3629),
    [sym_real_literal] = ACTIONS(3631),
    [sym_verbatim_string_literal] = ACTIONS(3631),
    [sym_raw_string_literal] = ACTIONS(3631),
    [aux_sym_preproc_if_token1] = ACTIONS(3631),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3631),
    [sym_interpolation_verbatim_start] = ACTIONS(3631),
    [sym_interpolation_raw_start] = ACTIONS(3631),
  },
  [2625] = {
    [sym_preproc_region] = STATE(2625),
    [sym_preproc_endregion] = STATE(2625),
    [sym_preproc_line] = STATE(2625),
    [sym_preproc_pragma] = STATE(2625),
    [sym_preproc_nullable] = STATE(2625),
    [sym_preproc_error] = STATE(2625),
    [sym_preproc_define] = STATE(2625),
    [sym_preproc_undef] = STATE(2625),
    [ts_builtin_sym_end] = ACTIONS(3627),
    [sym__identifier_token] = ACTIONS(3625),
    [anon_sym_extern] = ACTIONS(3625),
    [anon_sym_alias] = ACTIONS(3625),
    [anon_sym_SEMI] = ACTIONS(3627),
    [anon_sym_global] = ACTIONS(3625),
    [anon_sym_using] = ACTIONS(3625),
    [anon_sym_unsafe] = ACTIONS(3625),
    [anon_sym_static] = ACTIONS(3625),
    [anon_sym_LBRACK] = ACTIONS(3627),
    [anon_sym_LPAREN] = ACTIONS(3627),
    [anon_sym_return] = ACTIONS(3625),
    [anon_sym_namespace] = ACTIONS(3625),
    [anon_sym_class] = ACTIONS(3625),
    [anon_sym_ref] = ACTIONS(3625),
    [anon_sym_struct] = ACTIONS(3625),
    [anon_sym_enum] = ACTIONS(3625),
    [anon_sym_LBRACE] = ACTIONS(3627),
    [anon_sym_interface] = ACTIONS(3625),
    [anon_sym_delegate] = ACTIONS(3625),
    [anon_sym_record] = ACTIONS(3625),
    [anon_sym_abstract] = ACTIONS(3625),
    [anon_sym_async] = ACTIONS(3625),
    [anon_sym_const] = ACTIONS(3625),
    [anon_sym_file] = ACTIONS(3625),
    [anon_sym_fixed] = ACTIONS(3625),
    [anon_sym_internal] = ACTIONS(3625),
    [anon_sym_new] = ACTIONS(3625),
    [anon_sym_override] = ACTIONS(3625),
    [anon_sym_partial] = ACTIONS(3625),
    [anon_sym_private] = ACTIONS(3625),
    [anon_sym_protected] = ACTIONS(3625),
    [anon_sym_public] = ACTIONS(3625),
    [anon_sym_readonly] = ACTIONS(3625),
    [anon_sym_required] = ACTIONS(3625),
    [anon_sym_sealed] = ACTIONS(3625),
    [anon_sym_virtual] = ACTIONS(3625),
    [anon_sym_volatile] = ACTIONS(3625),
    [anon_sym_where] = ACTIONS(3625),
    [anon_sym_notnull] = ACTIONS(3625),
    [anon_sym_unmanaged] = ACTIONS(3625),
    [anon_sym_checked] = ACTIONS(3625),
    [anon_sym_BANG] = ACTIONS(3627),
    [anon_sym_TILDE] = ACTIONS(3627),
    [anon_sym_PLUS_PLUS] = ACTIONS(3627),
    [anon_sym_DASH_DASH] = ACTIONS(3627),
    [anon_sym_true] = ACTIONS(3625),
    [anon_sym_false] = ACTIONS(3625),
    [anon_sym_PLUS] = ACTIONS(3625),
    [anon_sym_DASH] = ACTIONS(3625),
    [anon_sym_STAR] = ACTIONS(3627),
    [anon_sym_CARET] = ACTIONS(3627),
    [anon_sym_AMP] = ACTIONS(3627),
    [anon_sym_this] = ACTIONS(3625),
    [anon_sym_scoped] = ACTIONS(3625),
    [anon_sym_var] = ACTIONS(3625),
    [sym_predefined_type] = ACTIONS(3625),
    [anon_sym_break] = ACTIONS(3625),
    [anon_sym_unchecked] = ACTIONS(3625),
    [anon_sym_continue] = ACTIONS(3625),
    [anon_sym_do] = ACTIONS(3625),
    [anon_sym_while] = ACTIONS(3625),
    [anon_sym_for] = ACTIONS(3625),
    [anon_sym_lock] = ACTIONS(3625),
    [anon_sym_yield] = ACTIONS(3625),
    [anon_sym_switch] = ACTIONS(3625),
    [anon_sym_default] = ACTIONS(3625),
    [anon_sym_throw] = ACTIONS(3625),
    [anon_sym_try] = ACTIONS(3625),
    [anon_sym_when] = ACTIONS(3625),
    [anon_sym_await] = ACTIONS(3625),
    [anon_sym_foreach] = ACTIONS(3625),
    [anon_sym_goto] = ACTIONS(3625),
    [anon_sym_if] = ACTIONS(3625),
    [anon_sym_DOT_DOT] = ACTIONS(3627),
    [anon_sym_from] = ACTIONS(3625),
    [anon_sym_into] = ACTIONS(3625),
    [anon_sym_join] = ACTIONS(3625),
    [anon_sym_on] = ACTIONS(3625),
    [anon_sym_equals] = ACTIONS(3625),
    [anon_sym_let] = ACTIONS(3625),
    [anon_sym_orderby] = ACTIONS(3625),
    [anon_sym_ascending] = ACTIONS(3625),
    [anon_sym_descending] = ACTIONS(3625),
    [anon_sym_group] = ACTIONS(3625),
    [anon_sym_by] = ACTIONS(3625),
    [anon_sym_select] = ACTIONS(3625),
    [anon_sym_DQUOTE] = ACTIONS(3625),
    [anon_sym_stackalloc] = ACTIONS(3625),
    [anon_sym_sizeof] = ACTIONS(3625),
    [anon_sym_typeof] = ACTIONS(3625),
    [anon_sym___makeref] = ACTIONS(3625),
    [anon_sym___reftype] = ACTIONS(3625),
    [anon_sym___refvalue] = ACTIONS(3625),
    [sym_null_literal] = ACTIONS(3625),
    [anon_sym_SQUOTE] = ACTIONS(3627),
    [sym_integer_literal] = ACTIONS(3625),
    [sym_real_literal] = ACTIONS(3627),
    [sym_verbatim_string_literal] = ACTIONS(3627),
    [sym_raw_string_literal] = ACTIONS(3627),
    [aux_sym_preproc_if_token1] = ACTIONS(3627),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3627),
    [sym_interpolation_verbatim_start] = ACTIONS(3627),
    [sym_interpolation_raw_start] = ACTIONS(3627),
  },
  [2626] = {
    [sym_using_directive] = STATE(3272),
    [sym_attribute_list] = STATE(3753),
    [sym_namespace_declaration] = STATE(3272),
    [sym_class_declaration] = STATE(3272),
    [sym_struct_declaration] = STATE(3272),
    [sym_enum_declaration] = STATE(3272),
    [sym_interface_declaration] = STATE(3272),
    [sym_delegate_declaration] = STATE(3272),
    [sym_record_declaration] = STATE(3272),
    [sym_modifier] = STATE(3780),
    [sym_operator_declaration] = STATE(3272),
    [sym_conversion_operator_declaration] = STATE(3272),
    [sym_declaration] = STATE(3284),
    [sym_field_declaration] = STATE(3272),
    [sym_constructor_declaration] = STATE(3272),
    [sym_destructor_declaration] = STATE(3272),
    [sym_method_declaration] = STATE(3272),
    [sym_event_declaration] = STATE(3272),
    [sym_event_field_declaration] = STATE(3272),
    [sym_indexer_declaration] = STATE(3272),
    [sym_property_declaration] = STATE(3272),
    [sym_variable_declaration] = STATE(9222),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(6306),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_identifier] = STATE(6719),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_if] = STATE(3272),
    [sym_preproc_region] = STATE(2626),
    [sym_preproc_endregion] = STATE(2626),
    [sym_preproc_line] = STATE(2626),
    [sym_preproc_pragma] = STATE(2626),
    [sym_preproc_nullable] = STATE(2626),
    [sym_preproc_error] = STATE(2626),
    [sym_preproc_define] = STATE(2626),
    [sym_preproc_undef] = STATE(2626),
    [aux_sym_class_declaration_repeat1] = STATE(2782),
    [aux_sym_class_declaration_repeat2] = STATE(2834),
    [aux_sym_declaration_list_repeat1] = STATE(2233),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_extern] = ACTIONS(2985),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2989),
    [anon_sym_using] = ACTIONS(2991),
    [anon_sym_unsafe] = ACTIONS(63),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_LBRACK] = ACTIONS(2993),
    [anon_sym_LPAREN] = ACTIONS(2995),
    [anon_sym_event] = ACTIONS(2997),
    [anon_sym_namespace] = ACTIONS(2999),
    [anon_sym_class] = ACTIONS(3001),
    [anon_sym_ref] = ACTIONS(3003),
    [anon_sym_struct] = ACTIONS(3005),
    [anon_sym_enum] = ACTIONS(3007),
    [anon_sym_interface] = ACTIONS(3009),
    [anon_sym_delegate] = ACTIONS(3011),
    [anon_sym_record] = ACTIONS(3013),
    [anon_sym_abstract] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_file] = ACTIONS(3015),
    [anon_sym_fixed] = ACTIONS(63),
    [anon_sym_internal] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(63),
    [anon_sym_override] = ACTIONS(63),
    [anon_sym_partial] = ACTIONS(63),
    [anon_sym_private] = ACTIONS(63),
    [anon_sym_protected] = ACTIONS(63),
    [anon_sym_public] = ACTIONS(63),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_required] = ACTIONS(63),
    [anon_sym_sealed] = ACTIONS(63),
    [anon_sym_virtual] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_TILDE] = ACTIONS(3017),
    [anon_sym_implicit] = ACTIONS(3019),
    [anon_sym_explicit] = ACTIONS(3019),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_if_token1] = ACTIONS(3027),
    [aux_sym_preproc_if_token3] = ACTIONS(3969),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2627] = {
    [sym_preproc_region] = STATE(2627),
    [sym_preproc_endregion] = STATE(2627),
    [sym_preproc_line] = STATE(2627),
    [sym_preproc_pragma] = STATE(2627),
    [sym_preproc_nullable] = STATE(2627),
    [sym_preproc_error] = STATE(2627),
    [sym_preproc_define] = STATE(2627),
    [sym_preproc_undef] = STATE(2627),
    [ts_builtin_sym_end] = ACTIONS(3623),
    [sym__identifier_token] = ACTIONS(3621),
    [anon_sym_extern] = ACTIONS(3621),
    [anon_sym_alias] = ACTIONS(3621),
    [anon_sym_SEMI] = ACTIONS(3623),
    [anon_sym_global] = ACTIONS(3621),
    [anon_sym_using] = ACTIONS(3621),
    [anon_sym_unsafe] = ACTIONS(3621),
    [anon_sym_static] = ACTIONS(3621),
    [anon_sym_LBRACK] = ACTIONS(3623),
    [anon_sym_LPAREN] = ACTIONS(3623),
    [anon_sym_return] = ACTIONS(3621),
    [anon_sym_namespace] = ACTIONS(3621),
    [anon_sym_class] = ACTIONS(3621),
    [anon_sym_ref] = ACTIONS(3621),
    [anon_sym_struct] = ACTIONS(3621),
    [anon_sym_enum] = ACTIONS(3621),
    [anon_sym_LBRACE] = ACTIONS(3623),
    [anon_sym_interface] = ACTIONS(3621),
    [anon_sym_delegate] = ACTIONS(3621),
    [anon_sym_record] = ACTIONS(3621),
    [anon_sym_abstract] = ACTIONS(3621),
    [anon_sym_async] = ACTIONS(3621),
    [anon_sym_const] = ACTIONS(3621),
    [anon_sym_file] = ACTIONS(3621),
    [anon_sym_fixed] = ACTIONS(3621),
    [anon_sym_internal] = ACTIONS(3621),
    [anon_sym_new] = ACTIONS(3621),
    [anon_sym_override] = ACTIONS(3621),
    [anon_sym_partial] = ACTIONS(3621),
    [anon_sym_private] = ACTIONS(3621),
    [anon_sym_protected] = ACTIONS(3621),
    [anon_sym_public] = ACTIONS(3621),
    [anon_sym_readonly] = ACTIONS(3621),
    [anon_sym_required] = ACTIONS(3621),
    [anon_sym_sealed] = ACTIONS(3621),
    [anon_sym_virtual] = ACTIONS(3621),
    [anon_sym_volatile] = ACTIONS(3621),
    [anon_sym_where] = ACTIONS(3621),
    [anon_sym_notnull] = ACTIONS(3621),
    [anon_sym_unmanaged] = ACTIONS(3621),
    [anon_sym_checked] = ACTIONS(3621),
    [anon_sym_BANG] = ACTIONS(3623),
    [anon_sym_TILDE] = ACTIONS(3623),
    [anon_sym_PLUS_PLUS] = ACTIONS(3623),
    [anon_sym_DASH_DASH] = ACTIONS(3623),
    [anon_sym_true] = ACTIONS(3621),
    [anon_sym_false] = ACTIONS(3621),
    [anon_sym_PLUS] = ACTIONS(3621),
    [anon_sym_DASH] = ACTIONS(3621),
    [anon_sym_STAR] = ACTIONS(3623),
    [anon_sym_CARET] = ACTIONS(3623),
    [anon_sym_AMP] = ACTIONS(3623),
    [anon_sym_this] = ACTIONS(3621),
    [anon_sym_scoped] = ACTIONS(3621),
    [anon_sym_var] = ACTIONS(3621),
    [sym_predefined_type] = ACTIONS(3621),
    [anon_sym_break] = ACTIONS(3621),
    [anon_sym_unchecked] = ACTIONS(3621),
    [anon_sym_continue] = ACTIONS(3621),
    [anon_sym_do] = ACTIONS(3621),
    [anon_sym_while] = ACTIONS(3621),
    [anon_sym_for] = ACTIONS(3621),
    [anon_sym_lock] = ACTIONS(3621),
    [anon_sym_yield] = ACTIONS(3621),
    [anon_sym_switch] = ACTIONS(3621),
    [anon_sym_default] = ACTIONS(3621),
    [anon_sym_throw] = ACTIONS(3621),
    [anon_sym_try] = ACTIONS(3621),
    [anon_sym_when] = ACTIONS(3621),
    [anon_sym_await] = ACTIONS(3621),
    [anon_sym_foreach] = ACTIONS(3621),
    [anon_sym_goto] = ACTIONS(3621),
    [anon_sym_if] = ACTIONS(3621),
    [anon_sym_DOT_DOT] = ACTIONS(3623),
    [anon_sym_from] = ACTIONS(3621),
    [anon_sym_into] = ACTIONS(3621),
    [anon_sym_join] = ACTIONS(3621),
    [anon_sym_on] = ACTIONS(3621),
    [anon_sym_equals] = ACTIONS(3621),
    [anon_sym_let] = ACTIONS(3621),
    [anon_sym_orderby] = ACTIONS(3621),
    [anon_sym_ascending] = ACTIONS(3621),
    [anon_sym_descending] = ACTIONS(3621),
    [anon_sym_group] = ACTIONS(3621),
    [anon_sym_by] = ACTIONS(3621),
    [anon_sym_select] = ACTIONS(3621),
    [anon_sym_DQUOTE] = ACTIONS(3621),
    [anon_sym_stackalloc] = ACTIONS(3621),
    [anon_sym_sizeof] = ACTIONS(3621),
    [anon_sym_typeof] = ACTIONS(3621),
    [anon_sym___makeref] = ACTIONS(3621),
    [anon_sym___reftype] = ACTIONS(3621),
    [anon_sym___refvalue] = ACTIONS(3621),
    [sym_null_literal] = ACTIONS(3621),
    [anon_sym_SQUOTE] = ACTIONS(3623),
    [sym_integer_literal] = ACTIONS(3621),
    [sym_real_literal] = ACTIONS(3623),
    [sym_verbatim_string_literal] = ACTIONS(3623),
    [sym_raw_string_literal] = ACTIONS(3623),
    [aux_sym_preproc_if_token1] = ACTIONS(3623),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3623),
    [sym_interpolation_verbatim_start] = ACTIONS(3623),
    [sym_interpolation_raw_start] = ACTIONS(3623),
  },
  [2628] = {
    [sym_preproc_region] = STATE(2628),
    [sym_preproc_endregion] = STATE(2628),
    [sym_preproc_line] = STATE(2628),
    [sym_preproc_pragma] = STATE(2628),
    [sym_preproc_nullable] = STATE(2628),
    [sym_preproc_error] = STATE(2628),
    [sym_preproc_define] = STATE(2628),
    [sym_preproc_undef] = STATE(2628),
    [ts_builtin_sym_end] = ACTIONS(3619),
    [sym__identifier_token] = ACTIONS(3617),
    [anon_sym_extern] = ACTIONS(3617),
    [anon_sym_alias] = ACTIONS(3617),
    [anon_sym_SEMI] = ACTIONS(3619),
    [anon_sym_global] = ACTIONS(3617),
    [anon_sym_using] = ACTIONS(3617),
    [anon_sym_unsafe] = ACTIONS(3617),
    [anon_sym_static] = ACTIONS(3617),
    [anon_sym_LBRACK] = ACTIONS(3619),
    [anon_sym_LPAREN] = ACTIONS(3619),
    [anon_sym_return] = ACTIONS(3617),
    [anon_sym_namespace] = ACTIONS(3617),
    [anon_sym_class] = ACTIONS(3617),
    [anon_sym_ref] = ACTIONS(3617),
    [anon_sym_struct] = ACTIONS(3617),
    [anon_sym_enum] = ACTIONS(3617),
    [anon_sym_LBRACE] = ACTIONS(3619),
    [anon_sym_interface] = ACTIONS(3617),
    [anon_sym_delegate] = ACTIONS(3617),
    [anon_sym_record] = ACTIONS(3617),
    [anon_sym_abstract] = ACTIONS(3617),
    [anon_sym_async] = ACTIONS(3617),
    [anon_sym_const] = ACTIONS(3617),
    [anon_sym_file] = ACTIONS(3617),
    [anon_sym_fixed] = ACTIONS(3617),
    [anon_sym_internal] = ACTIONS(3617),
    [anon_sym_new] = ACTIONS(3617),
    [anon_sym_override] = ACTIONS(3617),
    [anon_sym_partial] = ACTIONS(3617),
    [anon_sym_private] = ACTIONS(3617),
    [anon_sym_protected] = ACTIONS(3617),
    [anon_sym_public] = ACTIONS(3617),
    [anon_sym_readonly] = ACTIONS(3617),
    [anon_sym_required] = ACTIONS(3617),
    [anon_sym_sealed] = ACTIONS(3617),
    [anon_sym_virtual] = ACTIONS(3617),
    [anon_sym_volatile] = ACTIONS(3617),
    [anon_sym_where] = ACTIONS(3617),
    [anon_sym_notnull] = ACTIONS(3617),
    [anon_sym_unmanaged] = ACTIONS(3617),
    [anon_sym_checked] = ACTIONS(3617),
    [anon_sym_BANG] = ACTIONS(3619),
    [anon_sym_TILDE] = ACTIONS(3619),
    [anon_sym_PLUS_PLUS] = ACTIONS(3619),
    [anon_sym_DASH_DASH] = ACTIONS(3619),
    [anon_sym_true] = ACTIONS(3617),
    [anon_sym_false] = ACTIONS(3617),
    [anon_sym_PLUS] = ACTIONS(3617),
    [anon_sym_DASH] = ACTIONS(3617),
    [anon_sym_STAR] = ACTIONS(3619),
    [anon_sym_CARET] = ACTIONS(3619),
    [anon_sym_AMP] = ACTIONS(3619),
    [anon_sym_this] = ACTIONS(3617),
    [anon_sym_scoped] = ACTIONS(3617),
    [anon_sym_var] = ACTIONS(3617),
    [sym_predefined_type] = ACTIONS(3617),
    [anon_sym_break] = ACTIONS(3617),
    [anon_sym_unchecked] = ACTIONS(3617),
    [anon_sym_continue] = ACTIONS(3617),
    [anon_sym_do] = ACTIONS(3617),
    [anon_sym_while] = ACTIONS(3617),
    [anon_sym_for] = ACTIONS(3617),
    [anon_sym_lock] = ACTIONS(3617),
    [anon_sym_yield] = ACTIONS(3617),
    [anon_sym_switch] = ACTIONS(3617),
    [anon_sym_default] = ACTIONS(3617),
    [anon_sym_throw] = ACTIONS(3617),
    [anon_sym_try] = ACTIONS(3617),
    [anon_sym_when] = ACTIONS(3617),
    [anon_sym_await] = ACTIONS(3617),
    [anon_sym_foreach] = ACTIONS(3617),
    [anon_sym_goto] = ACTIONS(3617),
    [anon_sym_if] = ACTIONS(3617),
    [anon_sym_DOT_DOT] = ACTIONS(3619),
    [anon_sym_from] = ACTIONS(3617),
    [anon_sym_into] = ACTIONS(3617),
    [anon_sym_join] = ACTIONS(3617),
    [anon_sym_on] = ACTIONS(3617),
    [anon_sym_equals] = ACTIONS(3617),
    [anon_sym_let] = ACTIONS(3617),
    [anon_sym_orderby] = ACTIONS(3617),
    [anon_sym_ascending] = ACTIONS(3617),
    [anon_sym_descending] = ACTIONS(3617),
    [anon_sym_group] = ACTIONS(3617),
    [anon_sym_by] = ACTIONS(3617),
    [anon_sym_select] = ACTIONS(3617),
    [anon_sym_DQUOTE] = ACTIONS(3617),
    [anon_sym_stackalloc] = ACTIONS(3617),
    [anon_sym_sizeof] = ACTIONS(3617),
    [anon_sym_typeof] = ACTIONS(3617),
    [anon_sym___makeref] = ACTIONS(3617),
    [anon_sym___reftype] = ACTIONS(3617),
    [anon_sym___refvalue] = ACTIONS(3617),
    [sym_null_literal] = ACTIONS(3617),
    [anon_sym_SQUOTE] = ACTIONS(3619),
    [sym_integer_literal] = ACTIONS(3617),
    [sym_real_literal] = ACTIONS(3619),
    [sym_verbatim_string_literal] = ACTIONS(3619),
    [sym_raw_string_literal] = ACTIONS(3619),
    [aux_sym_preproc_if_token1] = ACTIONS(3619),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3619),
    [sym_interpolation_verbatim_start] = ACTIONS(3619),
    [sym_interpolation_raw_start] = ACTIONS(3619),
  },
  [2629] = {
    [sym_preproc_region] = STATE(2629),
    [sym_preproc_endregion] = STATE(2629),
    [sym_preproc_line] = STATE(2629),
    [sym_preproc_pragma] = STATE(2629),
    [sym_preproc_nullable] = STATE(2629),
    [sym_preproc_error] = STATE(2629),
    [sym_preproc_define] = STATE(2629),
    [sym_preproc_undef] = STATE(2629),
    [ts_builtin_sym_end] = ACTIONS(3555),
    [sym__identifier_token] = ACTIONS(3553),
    [anon_sym_extern] = ACTIONS(3553),
    [anon_sym_alias] = ACTIONS(3553),
    [anon_sym_SEMI] = ACTIONS(3555),
    [anon_sym_global] = ACTIONS(3553),
    [anon_sym_using] = ACTIONS(3553),
    [anon_sym_unsafe] = ACTIONS(3553),
    [anon_sym_static] = ACTIONS(3553),
    [anon_sym_LBRACK] = ACTIONS(3555),
    [anon_sym_LPAREN] = ACTIONS(3555),
    [anon_sym_return] = ACTIONS(3553),
    [anon_sym_namespace] = ACTIONS(3553),
    [anon_sym_class] = ACTIONS(3553),
    [anon_sym_ref] = ACTIONS(3553),
    [anon_sym_struct] = ACTIONS(3553),
    [anon_sym_enum] = ACTIONS(3553),
    [anon_sym_LBRACE] = ACTIONS(3555),
    [anon_sym_interface] = ACTIONS(3553),
    [anon_sym_delegate] = ACTIONS(3553),
    [anon_sym_record] = ACTIONS(3553),
    [anon_sym_abstract] = ACTIONS(3553),
    [anon_sym_async] = ACTIONS(3553),
    [anon_sym_const] = ACTIONS(3553),
    [anon_sym_file] = ACTIONS(3553),
    [anon_sym_fixed] = ACTIONS(3553),
    [anon_sym_internal] = ACTIONS(3553),
    [anon_sym_new] = ACTIONS(3553),
    [anon_sym_override] = ACTIONS(3553),
    [anon_sym_partial] = ACTIONS(3553),
    [anon_sym_private] = ACTIONS(3553),
    [anon_sym_protected] = ACTIONS(3553),
    [anon_sym_public] = ACTIONS(3553),
    [anon_sym_readonly] = ACTIONS(3553),
    [anon_sym_required] = ACTIONS(3553),
    [anon_sym_sealed] = ACTIONS(3553),
    [anon_sym_virtual] = ACTIONS(3553),
    [anon_sym_volatile] = ACTIONS(3553),
    [anon_sym_where] = ACTIONS(3553),
    [anon_sym_notnull] = ACTIONS(3553),
    [anon_sym_unmanaged] = ACTIONS(3553),
    [anon_sym_checked] = ACTIONS(3553),
    [anon_sym_BANG] = ACTIONS(3555),
    [anon_sym_TILDE] = ACTIONS(3555),
    [anon_sym_PLUS_PLUS] = ACTIONS(3555),
    [anon_sym_DASH_DASH] = ACTIONS(3555),
    [anon_sym_true] = ACTIONS(3553),
    [anon_sym_false] = ACTIONS(3553),
    [anon_sym_PLUS] = ACTIONS(3553),
    [anon_sym_DASH] = ACTIONS(3553),
    [anon_sym_STAR] = ACTIONS(3555),
    [anon_sym_CARET] = ACTIONS(3555),
    [anon_sym_AMP] = ACTIONS(3555),
    [anon_sym_this] = ACTIONS(3553),
    [anon_sym_scoped] = ACTIONS(3553),
    [anon_sym_var] = ACTIONS(3553),
    [sym_predefined_type] = ACTIONS(3553),
    [anon_sym_break] = ACTIONS(3553),
    [anon_sym_unchecked] = ACTIONS(3553),
    [anon_sym_continue] = ACTIONS(3553),
    [anon_sym_do] = ACTIONS(3553),
    [anon_sym_while] = ACTIONS(3553),
    [anon_sym_for] = ACTIONS(3553),
    [anon_sym_lock] = ACTIONS(3553),
    [anon_sym_yield] = ACTIONS(3553),
    [anon_sym_switch] = ACTIONS(3553),
    [anon_sym_default] = ACTIONS(3553),
    [anon_sym_throw] = ACTIONS(3553),
    [anon_sym_try] = ACTIONS(3553),
    [anon_sym_when] = ACTIONS(3553),
    [anon_sym_await] = ACTIONS(3553),
    [anon_sym_foreach] = ACTIONS(3553),
    [anon_sym_goto] = ACTIONS(3553),
    [anon_sym_if] = ACTIONS(3553),
    [anon_sym_DOT_DOT] = ACTIONS(3555),
    [anon_sym_from] = ACTIONS(3553),
    [anon_sym_into] = ACTIONS(3553),
    [anon_sym_join] = ACTIONS(3553),
    [anon_sym_on] = ACTIONS(3553),
    [anon_sym_equals] = ACTIONS(3553),
    [anon_sym_let] = ACTIONS(3553),
    [anon_sym_orderby] = ACTIONS(3553),
    [anon_sym_ascending] = ACTIONS(3553),
    [anon_sym_descending] = ACTIONS(3553),
    [anon_sym_group] = ACTIONS(3553),
    [anon_sym_by] = ACTIONS(3553),
    [anon_sym_select] = ACTIONS(3553),
    [anon_sym_DQUOTE] = ACTIONS(3553),
    [anon_sym_stackalloc] = ACTIONS(3553),
    [anon_sym_sizeof] = ACTIONS(3553),
    [anon_sym_typeof] = ACTIONS(3553),
    [anon_sym___makeref] = ACTIONS(3553),
    [anon_sym___reftype] = ACTIONS(3553),
    [anon_sym___refvalue] = ACTIONS(3553),
    [sym_null_literal] = ACTIONS(3553),
    [anon_sym_SQUOTE] = ACTIONS(3555),
    [sym_integer_literal] = ACTIONS(3553),
    [sym_real_literal] = ACTIONS(3555),
    [sym_verbatim_string_literal] = ACTIONS(3555),
    [sym_raw_string_literal] = ACTIONS(3555),
    [aux_sym_preproc_if_token1] = ACTIONS(3555),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3555),
    [sym_interpolation_verbatim_start] = ACTIONS(3555),
    [sym_interpolation_raw_start] = ACTIONS(3555),
  },
  [2630] = {
    [sym_preproc_region] = STATE(2630),
    [sym_preproc_endregion] = STATE(2630),
    [sym_preproc_line] = STATE(2630),
    [sym_preproc_pragma] = STATE(2630),
    [sym_preproc_nullable] = STATE(2630),
    [sym_preproc_error] = STATE(2630),
    [sym_preproc_define] = STATE(2630),
    [sym_preproc_undef] = STATE(2630),
    [ts_builtin_sym_end] = ACTIONS(3615),
    [sym__identifier_token] = ACTIONS(3613),
    [anon_sym_extern] = ACTIONS(3613),
    [anon_sym_alias] = ACTIONS(3613),
    [anon_sym_SEMI] = ACTIONS(3615),
    [anon_sym_global] = ACTIONS(3613),
    [anon_sym_using] = ACTIONS(3613),
    [anon_sym_unsafe] = ACTIONS(3613),
    [anon_sym_static] = ACTIONS(3613),
    [anon_sym_LBRACK] = ACTIONS(3615),
    [anon_sym_LPAREN] = ACTIONS(3615),
    [anon_sym_return] = ACTIONS(3613),
    [anon_sym_namespace] = ACTIONS(3613),
    [anon_sym_class] = ACTIONS(3613),
    [anon_sym_ref] = ACTIONS(3613),
    [anon_sym_struct] = ACTIONS(3613),
    [anon_sym_enum] = ACTIONS(3613),
    [anon_sym_LBRACE] = ACTIONS(3615),
    [anon_sym_interface] = ACTIONS(3613),
    [anon_sym_delegate] = ACTIONS(3613),
    [anon_sym_record] = ACTIONS(3613),
    [anon_sym_abstract] = ACTIONS(3613),
    [anon_sym_async] = ACTIONS(3613),
    [anon_sym_const] = ACTIONS(3613),
    [anon_sym_file] = ACTIONS(3613),
    [anon_sym_fixed] = ACTIONS(3613),
    [anon_sym_internal] = ACTIONS(3613),
    [anon_sym_new] = ACTIONS(3613),
    [anon_sym_override] = ACTIONS(3613),
    [anon_sym_partial] = ACTIONS(3613),
    [anon_sym_private] = ACTIONS(3613),
    [anon_sym_protected] = ACTIONS(3613),
    [anon_sym_public] = ACTIONS(3613),
    [anon_sym_readonly] = ACTIONS(3613),
    [anon_sym_required] = ACTIONS(3613),
    [anon_sym_sealed] = ACTIONS(3613),
    [anon_sym_virtual] = ACTIONS(3613),
    [anon_sym_volatile] = ACTIONS(3613),
    [anon_sym_where] = ACTIONS(3613),
    [anon_sym_notnull] = ACTIONS(3613),
    [anon_sym_unmanaged] = ACTIONS(3613),
    [anon_sym_checked] = ACTIONS(3613),
    [anon_sym_BANG] = ACTIONS(3615),
    [anon_sym_TILDE] = ACTIONS(3615),
    [anon_sym_PLUS_PLUS] = ACTIONS(3615),
    [anon_sym_DASH_DASH] = ACTIONS(3615),
    [anon_sym_true] = ACTIONS(3613),
    [anon_sym_false] = ACTIONS(3613),
    [anon_sym_PLUS] = ACTIONS(3613),
    [anon_sym_DASH] = ACTIONS(3613),
    [anon_sym_STAR] = ACTIONS(3615),
    [anon_sym_CARET] = ACTIONS(3615),
    [anon_sym_AMP] = ACTIONS(3615),
    [anon_sym_this] = ACTIONS(3613),
    [anon_sym_scoped] = ACTIONS(3613),
    [anon_sym_var] = ACTIONS(3613),
    [sym_predefined_type] = ACTIONS(3613),
    [anon_sym_break] = ACTIONS(3613),
    [anon_sym_unchecked] = ACTIONS(3613),
    [anon_sym_continue] = ACTIONS(3613),
    [anon_sym_do] = ACTIONS(3613),
    [anon_sym_while] = ACTIONS(3613),
    [anon_sym_for] = ACTIONS(3613),
    [anon_sym_lock] = ACTIONS(3613),
    [anon_sym_yield] = ACTIONS(3613),
    [anon_sym_switch] = ACTIONS(3613),
    [anon_sym_default] = ACTIONS(3613),
    [anon_sym_throw] = ACTIONS(3613),
    [anon_sym_try] = ACTIONS(3613),
    [anon_sym_when] = ACTIONS(3613),
    [anon_sym_await] = ACTIONS(3613),
    [anon_sym_foreach] = ACTIONS(3613),
    [anon_sym_goto] = ACTIONS(3613),
    [anon_sym_if] = ACTIONS(3613),
    [anon_sym_DOT_DOT] = ACTIONS(3615),
    [anon_sym_from] = ACTIONS(3613),
    [anon_sym_into] = ACTIONS(3613),
    [anon_sym_join] = ACTIONS(3613),
    [anon_sym_on] = ACTIONS(3613),
    [anon_sym_equals] = ACTIONS(3613),
    [anon_sym_let] = ACTIONS(3613),
    [anon_sym_orderby] = ACTIONS(3613),
    [anon_sym_ascending] = ACTIONS(3613),
    [anon_sym_descending] = ACTIONS(3613),
    [anon_sym_group] = ACTIONS(3613),
    [anon_sym_by] = ACTIONS(3613),
    [anon_sym_select] = ACTIONS(3613),
    [anon_sym_DQUOTE] = ACTIONS(3613),
    [anon_sym_stackalloc] = ACTIONS(3613),
    [anon_sym_sizeof] = ACTIONS(3613),
    [anon_sym_typeof] = ACTIONS(3613),
    [anon_sym___makeref] = ACTIONS(3613),
    [anon_sym___reftype] = ACTIONS(3613),
    [anon_sym___refvalue] = ACTIONS(3613),
    [sym_null_literal] = ACTIONS(3613),
    [anon_sym_SQUOTE] = ACTIONS(3615),
    [sym_integer_literal] = ACTIONS(3613),
    [sym_real_literal] = ACTIONS(3615),
    [sym_verbatim_string_literal] = ACTIONS(3615),
    [sym_raw_string_literal] = ACTIONS(3615),
    [aux_sym_preproc_if_token1] = ACTIONS(3615),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3615),
    [sym_interpolation_verbatim_start] = ACTIONS(3615),
    [sym_interpolation_raw_start] = ACTIONS(3615),
  },
  [2631] = {
    [sym_preproc_region] = STATE(2631),
    [sym_preproc_endregion] = STATE(2631),
    [sym_preproc_line] = STATE(2631),
    [sym_preproc_pragma] = STATE(2631),
    [sym_preproc_nullable] = STATE(2631),
    [sym_preproc_error] = STATE(2631),
    [sym_preproc_define] = STATE(2631),
    [sym_preproc_undef] = STATE(2631),
    [ts_builtin_sym_end] = ACTIONS(3595),
    [sym__identifier_token] = ACTIONS(3593),
    [anon_sym_extern] = ACTIONS(3593),
    [anon_sym_alias] = ACTIONS(3593),
    [anon_sym_SEMI] = ACTIONS(3595),
    [anon_sym_global] = ACTIONS(3593),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_unsafe] = ACTIONS(3593),
    [anon_sym_static] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(3595),
    [anon_sym_LPAREN] = ACTIONS(3595),
    [anon_sym_return] = ACTIONS(3593),
    [anon_sym_namespace] = ACTIONS(3593),
    [anon_sym_class] = ACTIONS(3593),
    [anon_sym_ref] = ACTIONS(3593),
    [anon_sym_struct] = ACTIONS(3593),
    [anon_sym_enum] = ACTIONS(3593),
    [anon_sym_LBRACE] = ACTIONS(3595),
    [anon_sym_interface] = ACTIONS(3593),
    [anon_sym_delegate] = ACTIONS(3593),
    [anon_sym_record] = ACTIONS(3593),
    [anon_sym_abstract] = ACTIONS(3593),
    [anon_sym_async] = ACTIONS(3593),
    [anon_sym_const] = ACTIONS(3593),
    [anon_sym_file] = ACTIONS(3593),
    [anon_sym_fixed] = ACTIONS(3593),
    [anon_sym_internal] = ACTIONS(3593),
    [anon_sym_new] = ACTIONS(3593),
    [anon_sym_override] = ACTIONS(3593),
    [anon_sym_partial] = ACTIONS(3593),
    [anon_sym_private] = ACTIONS(3593),
    [anon_sym_protected] = ACTIONS(3593),
    [anon_sym_public] = ACTIONS(3593),
    [anon_sym_readonly] = ACTIONS(3593),
    [anon_sym_required] = ACTIONS(3593),
    [anon_sym_sealed] = ACTIONS(3593),
    [anon_sym_virtual] = ACTIONS(3593),
    [anon_sym_volatile] = ACTIONS(3593),
    [anon_sym_where] = ACTIONS(3593),
    [anon_sym_notnull] = ACTIONS(3593),
    [anon_sym_unmanaged] = ACTIONS(3593),
    [anon_sym_checked] = ACTIONS(3593),
    [anon_sym_BANG] = ACTIONS(3595),
    [anon_sym_TILDE] = ACTIONS(3595),
    [anon_sym_PLUS_PLUS] = ACTIONS(3595),
    [anon_sym_DASH_DASH] = ACTIONS(3595),
    [anon_sym_true] = ACTIONS(3593),
    [anon_sym_false] = ACTIONS(3593),
    [anon_sym_PLUS] = ACTIONS(3593),
    [anon_sym_DASH] = ACTIONS(3593),
    [anon_sym_STAR] = ACTIONS(3595),
    [anon_sym_CARET] = ACTIONS(3595),
    [anon_sym_AMP] = ACTIONS(3595),
    [anon_sym_this] = ACTIONS(3593),
    [anon_sym_scoped] = ACTIONS(3593),
    [anon_sym_var] = ACTIONS(3593),
    [sym_predefined_type] = ACTIONS(3593),
    [anon_sym_break] = ACTIONS(3593),
    [anon_sym_unchecked] = ACTIONS(3593),
    [anon_sym_continue] = ACTIONS(3593),
    [anon_sym_do] = ACTIONS(3593),
    [anon_sym_while] = ACTIONS(3593),
    [anon_sym_for] = ACTIONS(3593),
    [anon_sym_lock] = ACTIONS(3593),
    [anon_sym_yield] = ACTIONS(3593),
    [anon_sym_switch] = ACTIONS(3593),
    [anon_sym_default] = ACTIONS(3593),
    [anon_sym_throw] = ACTIONS(3593),
    [anon_sym_try] = ACTIONS(3593),
    [anon_sym_when] = ACTIONS(3593),
    [anon_sym_await] = ACTIONS(3593),
    [anon_sym_foreach] = ACTIONS(3593),
    [anon_sym_goto] = ACTIONS(3593),
    [anon_sym_if] = ACTIONS(3593),
    [anon_sym_DOT_DOT] = ACTIONS(3595),
    [anon_sym_from] = ACTIONS(3593),
    [anon_sym_into] = ACTIONS(3593),
    [anon_sym_join] = ACTIONS(3593),
    [anon_sym_on] = ACTIONS(3593),
    [anon_sym_equals] = ACTIONS(3593),
    [anon_sym_let] = ACTIONS(3593),
    [anon_sym_orderby] = ACTIONS(3593),
    [anon_sym_ascending] = ACTIONS(3593),
    [anon_sym_descending] = ACTIONS(3593),
    [anon_sym_group] = ACTIONS(3593),
    [anon_sym_by] = ACTIONS(3593),
    [anon_sym_select] = ACTIONS(3593),
    [anon_sym_DQUOTE] = ACTIONS(3593),
    [anon_sym_stackalloc] = ACTIONS(3593),
    [anon_sym_sizeof] = ACTIONS(3593),
    [anon_sym_typeof] = ACTIONS(3593),
    [anon_sym___makeref] = ACTIONS(3593),
    [anon_sym___reftype] = ACTIONS(3593),
    [anon_sym___refvalue] = ACTIONS(3593),
    [sym_null_literal] = ACTIONS(3593),
    [anon_sym_SQUOTE] = ACTIONS(3595),
    [sym_integer_literal] = ACTIONS(3593),
    [sym_real_literal] = ACTIONS(3595),
    [sym_verbatim_string_literal] = ACTIONS(3595),
    [sym_raw_string_literal] = ACTIONS(3595),
    [aux_sym_preproc_if_token1] = ACTIONS(3595),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3595),
    [sym_interpolation_verbatim_start] = ACTIONS(3595),
    [sym_interpolation_raw_start] = ACTIONS(3595),
  },
  [2632] = {
    [sym_using_directive] = STATE(3272),
    [sym_attribute_list] = STATE(3753),
    [sym_namespace_declaration] = STATE(3272),
    [sym_class_declaration] = STATE(3272),
    [sym_struct_declaration] = STATE(3272),
    [sym_enum_declaration] = STATE(3272),
    [sym_interface_declaration] = STATE(3272),
    [sym_delegate_declaration] = STATE(3272),
    [sym_record_declaration] = STATE(3272),
    [sym_modifier] = STATE(3780),
    [sym_operator_declaration] = STATE(3272),
    [sym_conversion_operator_declaration] = STATE(3272),
    [sym_declaration] = STATE(3284),
    [sym_field_declaration] = STATE(3272),
    [sym_constructor_declaration] = STATE(3272),
    [sym_destructor_declaration] = STATE(3272),
    [sym_method_declaration] = STATE(3272),
    [sym_event_declaration] = STATE(3272),
    [sym_event_field_declaration] = STATE(3272),
    [sym_indexer_declaration] = STATE(3272),
    [sym_property_declaration] = STATE(3272),
    [sym_variable_declaration] = STATE(9222),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(6306),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_identifier] = STATE(6719),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_if] = STATE(3272),
    [sym_preproc_region] = STATE(2632),
    [sym_preproc_endregion] = STATE(2632),
    [sym_preproc_line] = STATE(2632),
    [sym_preproc_pragma] = STATE(2632),
    [sym_preproc_nullable] = STATE(2632),
    [sym_preproc_error] = STATE(2632),
    [sym_preproc_define] = STATE(2632),
    [sym_preproc_undef] = STATE(2632),
    [aux_sym_class_declaration_repeat1] = STATE(2782),
    [aux_sym_class_declaration_repeat2] = STATE(2834),
    [aux_sym_declaration_list_repeat1] = STATE(2233),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_extern] = ACTIONS(2985),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2989),
    [anon_sym_using] = ACTIONS(2991),
    [anon_sym_unsafe] = ACTIONS(63),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_LBRACK] = ACTIONS(2993),
    [anon_sym_LPAREN] = ACTIONS(2995),
    [anon_sym_event] = ACTIONS(2997),
    [anon_sym_namespace] = ACTIONS(2999),
    [anon_sym_class] = ACTIONS(3001),
    [anon_sym_ref] = ACTIONS(3003),
    [anon_sym_struct] = ACTIONS(3005),
    [anon_sym_enum] = ACTIONS(3007),
    [anon_sym_RBRACE] = ACTIONS(3971),
    [anon_sym_interface] = ACTIONS(3009),
    [anon_sym_delegate] = ACTIONS(3011),
    [anon_sym_record] = ACTIONS(3013),
    [anon_sym_abstract] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_file] = ACTIONS(3015),
    [anon_sym_fixed] = ACTIONS(63),
    [anon_sym_internal] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(63),
    [anon_sym_override] = ACTIONS(63),
    [anon_sym_partial] = ACTIONS(63),
    [anon_sym_private] = ACTIONS(63),
    [anon_sym_protected] = ACTIONS(63),
    [anon_sym_public] = ACTIONS(63),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_required] = ACTIONS(63),
    [anon_sym_sealed] = ACTIONS(63),
    [anon_sym_virtual] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_TILDE] = ACTIONS(3017),
    [anon_sym_implicit] = ACTIONS(3019),
    [anon_sym_explicit] = ACTIONS(3019),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_if_token1] = ACTIONS(3027),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2633] = {
    [sym_preproc_region] = STATE(2633),
    [sym_preproc_endregion] = STATE(2633),
    [sym_preproc_line] = STATE(2633),
    [sym_preproc_pragma] = STATE(2633),
    [sym_preproc_nullable] = STATE(2633),
    [sym_preproc_error] = STATE(2633),
    [sym_preproc_define] = STATE(2633),
    [sym_preproc_undef] = STATE(2633),
    [ts_builtin_sym_end] = ACTIONS(3567),
    [sym__identifier_token] = ACTIONS(3565),
    [anon_sym_extern] = ACTIONS(3565),
    [anon_sym_alias] = ACTIONS(3565),
    [anon_sym_SEMI] = ACTIONS(3567),
    [anon_sym_global] = ACTIONS(3565),
    [anon_sym_using] = ACTIONS(3565),
    [anon_sym_unsafe] = ACTIONS(3565),
    [anon_sym_static] = ACTIONS(3565),
    [anon_sym_LBRACK] = ACTIONS(3567),
    [anon_sym_LPAREN] = ACTIONS(3567),
    [anon_sym_return] = ACTIONS(3565),
    [anon_sym_namespace] = ACTIONS(3565),
    [anon_sym_class] = ACTIONS(3565),
    [anon_sym_ref] = ACTIONS(3565),
    [anon_sym_struct] = ACTIONS(3565),
    [anon_sym_enum] = ACTIONS(3565),
    [anon_sym_LBRACE] = ACTIONS(3567),
    [anon_sym_interface] = ACTIONS(3565),
    [anon_sym_delegate] = ACTIONS(3565),
    [anon_sym_record] = ACTIONS(3565),
    [anon_sym_abstract] = ACTIONS(3565),
    [anon_sym_async] = ACTIONS(3565),
    [anon_sym_const] = ACTIONS(3565),
    [anon_sym_file] = ACTIONS(3565),
    [anon_sym_fixed] = ACTIONS(3565),
    [anon_sym_internal] = ACTIONS(3565),
    [anon_sym_new] = ACTIONS(3565),
    [anon_sym_override] = ACTIONS(3565),
    [anon_sym_partial] = ACTIONS(3565),
    [anon_sym_private] = ACTIONS(3565),
    [anon_sym_protected] = ACTIONS(3565),
    [anon_sym_public] = ACTIONS(3565),
    [anon_sym_readonly] = ACTIONS(3565),
    [anon_sym_required] = ACTIONS(3565),
    [anon_sym_sealed] = ACTIONS(3565),
    [anon_sym_virtual] = ACTIONS(3565),
    [anon_sym_volatile] = ACTIONS(3565),
    [anon_sym_where] = ACTIONS(3565),
    [anon_sym_notnull] = ACTIONS(3565),
    [anon_sym_unmanaged] = ACTIONS(3565),
    [anon_sym_checked] = ACTIONS(3565),
    [anon_sym_BANG] = ACTIONS(3567),
    [anon_sym_TILDE] = ACTIONS(3567),
    [anon_sym_PLUS_PLUS] = ACTIONS(3567),
    [anon_sym_DASH_DASH] = ACTIONS(3567),
    [anon_sym_true] = ACTIONS(3565),
    [anon_sym_false] = ACTIONS(3565),
    [anon_sym_PLUS] = ACTIONS(3565),
    [anon_sym_DASH] = ACTIONS(3565),
    [anon_sym_STAR] = ACTIONS(3567),
    [anon_sym_CARET] = ACTIONS(3567),
    [anon_sym_AMP] = ACTIONS(3567),
    [anon_sym_this] = ACTIONS(3565),
    [anon_sym_scoped] = ACTIONS(3565),
    [anon_sym_var] = ACTIONS(3565),
    [sym_predefined_type] = ACTIONS(3565),
    [anon_sym_break] = ACTIONS(3565),
    [anon_sym_unchecked] = ACTIONS(3565),
    [anon_sym_continue] = ACTIONS(3565),
    [anon_sym_do] = ACTIONS(3565),
    [anon_sym_while] = ACTIONS(3565),
    [anon_sym_for] = ACTIONS(3565),
    [anon_sym_lock] = ACTIONS(3565),
    [anon_sym_yield] = ACTIONS(3565),
    [anon_sym_switch] = ACTIONS(3565),
    [anon_sym_default] = ACTIONS(3565),
    [anon_sym_throw] = ACTIONS(3565),
    [anon_sym_try] = ACTIONS(3565),
    [anon_sym_when] = ACTIONS(3565),
    [anon_sym_await] = ACTIONS(3565),
    [anon_sym_foreach] = ACTIONS(3565),
    [anon_sym_goto] = ACTIONS(3565),
    [anon_sym_if] = ACTIONS(3565),
    [anon_sym_DOT_DOT] = ACTIONS(3567),
    [anon_sym_from] = ACTIONS(3565),
    [anon_sym_into] = ACTIONS(3565),
    [anon_sym_join] = ACTIONS(3565),
    [anon_sym_on] = ACTIONS(3565),
    [anon_sym_equals] = ACTIONS(3565),
    [anon_sym_let] = ACTIONS(3565),
    [anon_sym_orderby] = ACTIONS(3565),
    [anon_sym_ascending] = ACTIONS(3565),
    [anon_sym_descending] = ACTIONS(3565),
    [anon_sym_group] = ACTIONS(3565),
    [anon_sym_by] = ACTIONS(3565),
    [anon_sym_select] = ACTIONS(3565),
    [anon_sym_DQUOTE] = ACTIONS(3565),
    [anon_sym_stackalloc] = ACTIONS(3565),
    [anon_sym_sizeof] = ACTIONS(3565),
    [anon_sym_typeof] = ACTIONS(3565),
    [anon_sym___makeref] = ACTIONS(3565),
    [anon_sym___reftype] = ACTIONS(3565),
    [anon_sym___refvalue] = ACTIONS(3565),
    [sym_null_literal] = ACTIONS(3565),
    [anon_sym_SQUOTE] = ACTIONS(3567),
    [sym_integer_literal] = ACTIONS(3565),
    [sym_real_literal] = ACTIONS(3567),
    [sym_verbatim_string_literal] = ACTIONS(3567),
    [sym_raw_string_literal] = ACTIONS(3567),
    [aux_sym_preproc_if_token1] = ACTIONS(3567),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3567),
    [sym_interpolation_verbatim_start] = ACTIONS(3567),
    [sym_interpolation_raw_start] = ACTIONS(3567),
  },
  [2634] = {
    [sym_preproc_region] = STATE(2634),
    [sym_preproc_endregion] = STATE(2634),
    [sym_preproc_line] = STATE(2634),
    [sym_preproc_pragma] = STATE(2634),
    [sym_preproc_nullable] = STATE(2634),
    [sym_preproc_error] = STATE(2634),
    [sym_preproc_define] = STATE(2634),
    [sym_preproc_undef] = STATE(2634),
    [ts_builtin_sym_end] = ACTIONS(3559),
    [sym__identifier_token] = ACTIONS(3557),
    [anon_sym_extern] = ACTIONS(3557),
    [anon_sym_alias] = ACTIONS(3557),
    [anon_sym_SEMI] = ACTIONS(3559),
    [anon_sym_global] = ACTIONS(3557),
    [anon_sym_using] = ACTIONS(3557),
    [anon_sym_unsafe] = ACTIONS(3557),
    [anon_sym_static] = ACTIONS(3557),
    [anon_sym_LBRACK] = ACTIONS(3559),
    [anon_sym_LPAREN] = ACTIONS(3559),
    [anon_sym_return] = ACTIONS(3557),
    [anon_sym_namespace] = ACTIONS(3557),
    [anon_sym_class] = ACTIONS(3557),
    [anon_sym_ref] = ACTIONS(3557),
    [anon_sym_struct] = ACTIONS(3557),
    [anon_sym_enum] = ACTIONS(3557),
    [anon_sym_LBRACE] = ACTIONS(3559),
    [anon_sym_interface] = ACTIONS(3557),
    [anon_sym_delegate] = ACTIONS(3557),
    [anon_sym_record] = ACTIONS(3557),
    [anon_sym_abstract] = ACTIONS(3557),
    [anon_sym_async] = ACTIONS(3557),
    [anon_sym_const] = ACTIONS(3557),
    [anon_sym_file] = ACTIONS(3557),
    [anon_sym_fixed] = ACTIONS(3557),
    [anon_sym_internal] = ACTIONS(3557),
    [anon_sym_new] = ACTIONS(3557),
    [anon_sym_override] = ACTIONS(3557),
    [anon_sym_partial] = ACTIONS(3557),
    [anon_sym_private] = ACTIONS(3557),
    [anon_sym_protected] = ACTIONS(3557),
    [anon_sym_public] = ACTIONS(3557),
    [anon_sym_readonly] = ACTIONS(3557),
    [anon_sym_required] = ACTIONS(3557),
    [anon_sym_sealed] = ACTIONS(3557),
    [anon_sym_virtual] = ACTIONS(3557),
    [anon_sym_volatile] = ACTIONS(3557),
    [anon_sym_where] = ACTIONS(3557),
    [anon_sym_notnull] = ACTIONS(3557),
    [anon_sym_unmanaged] = ACTIONS(3557),
    [anon_sym_checked] = ACTIONS(3557),
    [anon_sym_BANG] = ACTIONS(3559),
    [anon_sym_TILDE] = ACTIONS(3559),
    [anon_sym_PLUS_PLUS] = ACTIONS(3559),
    [anon_sym_DASH_DASH] = ACTIONS(3559),
    [anon_sym_true] = ACTIONS(3557),
    [anon_sym_false] = ACTIONS(3557),
    [anon_sym_PLUS] = ACTIONS(3557),
    [anon_sym_DASH] = ACTIONS(3557),
    [anon_sym_STAR] = ACTIONS(3559),
    [anon_sym_CARET] = ACTIONS(3559),
    [anon_sym_AMP] = ACTIONS(3559),
    [anon_sym_this] = ACTIONS(3557),
    [anon_sym_scoped] = ACTIONS(3557),
    [anon_sym_var] = ACTIONS(3557),
    [sym_predefined_type] = ACTIONS(3557),
    [anon_sym_break] = ACTIONS(3557),
    [anon_sym_unchecked] = ACTIONS(3557),
    [anon_sym_continue] = ACTIONS(3557),
    [anon_sym_do] = ACTIONS(3557),
    [anon_sym_while] = ACTIONS(3557),
    [anon_sym_for] = ACTIONS(3557),
    [anon_sym_lock] = ACTIONS(3557),
    [anon_sym_yield] = ACTIONS(3557),
    [anon_sym_switch] = ACTIONS(3557),
    [anon_sym_default] = ACTIONS(3557),
    [anon_sym_throw] = ACTIONS(3557),
    [anon_sym_try] = ACTIONS(3557),
    [anon_sym_when] = ACTIONS(3557),
    [anon_sym_await] = ACTIONS(3557),
    [anon_sym_foreach] = ACTIONS(3557),
    [anon_sym_goto] = ACTIONS(3557),
    [anon_sym_if] = ACTIONS(3557),
    [anon_sym_DOT_DOT] = ACTIONS(3559),
    [anon_sym_from] = ACTIONS(3557),
    [anon_sym_into] = ACTIONS(3557),
    [anon_sym_join] = ACTIONS(3557),
    [anon_sym_on] = ACTIONS(3557),
    [anon_sym_equals] = ACTIONS(3557),
    [anon_sym_let] = ACTIONS(3557),
    [anon_sym_orderby] = ACTIONS(3557),
    [anon_sym_ascending] = ACTIONS(3557),
    [anon_sym_descending] = ACTIONS(3557),
    [anon_sym_group] = ACTIONS(3557),
    [anon_sym_by] = ACTIONS(3557),
    [anon_sym_select] = ACTIONS(3557),
    [anon_sym_DQUOTE] = ACTIONS(3557),
    [anon_sym_stackalloc] = ACTIONS(3557),
    [anon_sym_sizeof] = ACTIONS(3557),
    [anon_sym_typeof] = ACTIONS(3557),
    [anon_sym___makeref] = ACTIONS(3557),
    [anon_sym___reftype] = ACTIONS(3557),
    [anon_sym___refvalue] = ACTIONS(3557),
    [sym_null_literal] = ACTIONS(3557),
    [anon_sym_SQUOTE] = ACTIONS(3559),
    [sym_integer_literal] = ACTIONS(3557),
    [sym_real_literal] = ACTIONS(3559),
    [sym_verbatim_string_literal] = ACTIONS(3559),
    [sym_raw_string_literal] = ACTIONS(3559),
    [aux_sym_preproc_if_token1] = ACTIONS(3559),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3559),
    [sym_interpolation_verbatim_start] = ACTIONS(3559),
    [sym_interpolation_raw_start] = ACTIONS(3559),
  },
  [2635] = {
    [sym_preproc_region] = STATE(2635),
    [sym_preproc_endregion] = STATE(2635),
    [sym_preproc_line] = STATE(2635),
    [sym_preproc_pragma] = STATE(2635),
    [sym_preproc_nullable] = STATE(2635),
    [sym_preproc_error] = STATE(2635),
    [sym_preproc_define] = STATE(2635),
    [sym_preproc_undef] = STATE(2635),
    [ts_builtin_sym_end] = ACTIONS(3691),
    [sym__identifier_token] = ACTIONS(3689),
    [anon_sym_extern] = ACTIONS(3689),
    [anon_sym_alias] = ACTIONS(3689),
    [anon_sym_SEMI] = ACTIONS(3691),
    [anon_sym_global] = ACTIONS(3689),
    [anon_sym_using] = ACTIONS(3689),
    [anon_sym_unsafe] = ACTIONS(3689),
    [anon_sym_static] = ACTIONS(3689),
    [anon_sym_LBRACK] = ACTIONS(3691),
    [anon_sym_LPAREN] = ACTIONS(3691),
    [anon_sym_return] = ACTIONS(3689),
    [anon_sym_namespace] = ACTIONS(3689),
    [anon_sym_class] = ACTIONS(3689),
    [anon_sym_ref] = ACTIONS(3689),
    [anon_sym_struct] = ACTIONS(3689),
    [anon_sym_enum] = ACTIONS(3689),
    [anon_sym_LBRACE] = ACTIONS(3691),
    [anon_sym_interface] = ACTIONS(3689),
    [anon_sym_delegate] = ACTIONS(3689),
    [anon_sym_record] = ACTIONS(3689),
    [anon_sym_abstract] = ACTIONS(3689),
    [anon_sym_async] = ACTIONS(3689),
    [anon_sym_const] = ACTIONS(3689),
    [anon_sym_file] = ACTIONS(3689),
    [anon_sym_fixed] = ACTIONS(3689),
    [anon_sym_internal] = ACTIONS(3689),
    [anon_sym_new] = ACTIONS(3689),
    [anon_sym_override] = ACTIONS(3689),
    [anon_sym_partial] = ACTIONS(3689),
    [anon_sym_private] = ACTIONS(3689),
    [anon_sym_protected] = ACTIONS(3689),
    [anon_sym_public] = ACTIONS(3689),
    [anon_sym_readonly] = ACTIONS(3689),
    [anon_sym_required] = ACTIONS(3689),
    [anon_sym_sealed] = ACTIONS(3689),
    [anon_sym_virtual] = ACTIONS(3689),
    [anon_sym_volatile] = ACTIONS(3689),
    [anon_sym_where] = ACTIONS(3689),
    [anon_sym_notnull] = ACTIONS(3689),
    [anon_sym_unmanaged] = ACTIONS(3689),
    [anon_sym_checked] = ACTIONS(3689),
    [anon_sym_BANG] = ACTIONS(3691),
    [anon_sym_TILDE] = ACTIONS(3691),
    [anon_sym_PLUS_PLUS] = ACTIONS(3691),
    [anon_sym_DASH_DASH] = ACTIONS(3691),
    [anon_sym_true] = ACTIONS(3689),
    [anon_sym_false] = ACTIONS(3689),
    [anon_sym_PLUS] = ACTIONS(3689),
    [anon_sym_DASH] = ACTIONS(3689),
    [anon_sym_STAR] = ACTIONS(3691),
    [anon_sym_CARET] = ACTIONS(3691),
    [anon_sym_AMP] = ACTIONS(3691),
    [anon_sym_this] = ACTIONS(3689),
    [anon_sym_scoped] = ACTIONS(3689),
    [anon_sym_var] = ACTIONS(3689),
    [sym_predefined_type] = ACTIONS(3689),
    [anon_sym_break] = ACTIONS(3689),
    [anon_sym_unchecked] = ACTIONS(3689),
    [anon_sym_continue] = ACTIONS(3689),
    [anon_sym_do] = ACTIONS(3689),
    [anon_sym_while] = ACTIONS(3689),
    [anon_sym_for] = ACTIONS(3689),
    [anon_sym_lock] = ACTIONS(3689),
    [anon_sym_yield] = ACTIONS(3689),
    [anon_sym_switch] = ACTIONS(3689),
    [anon_sym_default] = ACTIONS(3689),
    [anon_sym_throw] = ACTIONS(3689),
    [anon_sym_try] = ACTIONS(3689),
    [anon_sym_when] = ACTIONS(3689),
    [anon_sym_await] = ACTIONS(3689),
    [anon_sym_foreach] = ACTIONS(3689),
    [anon_sym_goto] = ACTIONS(3689),
    [anon_sym_if] = ACTIONS(3689),
    [anon_sym_DOT_DOT] = ACTIONS(3691),
    [anon_sym_from] = ACTIONS(3689),
    [anon_sym_into] = ACTIONS(3689),
    [anon_sym_join] = ACTIONS(3689),
    [anon_sym_on] = ACTIONS(3689),
    [anon_sym_equals] = ACTIONS(3689),
    [anon_sym_let] = ACTIONS(3689),
    [anon_sym_orderby] = ACTIONS(3689),
    [anon_sym_ascending] = ACTIONS(3689),
    [anon_sym_descending] = ACTIONS(3689),
    [anon_sym_group] = ACTIONS(3689),
    [anon_sym_by] = ACTIONS(3689),
    [anon_sym_select] = ACTIONS(3689),
    [anon_sym_DQUOTE] = ACTIONS(3689),
    [anon_sym_stackalloc] = ACTIONS(3689),
    [anon_sym_sizeof] = ACTIONS(3689),
    [anon_sym_typeof] = ACTIONS(3689),
    [anon_sym___makeref] = ACTIONS(3689),
    [anon_sym___reftype] = ACTIONS(3689),
    [anon_sym___refvalue] = ACTIONS(3689),
    [sym_null_literal] = ACTIONS(3689),
    [anon_sym_SQUOTE] = ACTIONS(3691),
    [sym_integer_literal] = ACTIONS(3689),
    [sym_real_literal] = ACTIONS(3691),
    [sym_verbatim_string_literal] = ACTIONS(3691),
    [sym_raw_string_literal] = ACTIONS(3691),
    [aux_sym_preproc_if_token1] = ACTIONS(3691),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3691),
    [sym_interpolation_verbatim_start] = ACTIONS(3691),
    [sym_interpolation_raw_start] = ACTIONS(3691),
  },
  [2636] = {
    [sym_preproc_region] = STATE(2636),
    [sym_preproc_endregion] = STATE(2636),
    [sym_preproc_line] = STATE(2636),
    [sym_preproc_pragma] = STATE(2636),
    [sym_preproc_nullable] = STATE(2636),
    [sym_preproc_error] = STATE(2636),
    [sym_preproc_define] = STATE(2636),
    [sym_preproc_undef] = STATE(2636),
    [ts_builtin_sym_end] = ACTIONS(3563),
    [sym__identifier_token] = ACTIONS(3561),
    [anon_sym_extern] = ACTIONS(3561),
    [anon_sym_alias] = ACTIONS(3561),
    [anon_sym_SEMI] = ACTIONS(3563),
    [anon_sym_global] = ACTIONS(3561),
    [anon_sym_using] = ACTIONS(3561),
    [anon_sym_unsafe] = ACTIONS(3561),
    [anon_sym_static] = ACTIONS(3561),
    [anon_sym_LBRACK] = ACTIONS(3563),
    [anon_sym_LPAREN] = ACTIONS(3563),
    [anon_sym_return] = ACTIONS(3561),
    [anon_sym_namespace] = ACTIONS(3561),
    [anon_sym_class] = ACTIONS(3561),
    [anon_sym_ref] = ACTIONS(3561),
    [anon_sym_struct] = ACTIONS(3561),
    [anon_sym_enum] = ACTIONS(3561),
    [anon_sym_LBRACE] = ACTIONS(3563),
    [anon_sym_interface] = ACTIONS(3561),
    [anon_sym_delegate] = ACTIONS(3561),
    [anon_sym_record] = ACTIONS(3561),
    [anon_sym_abstract] = ACTIONS(3561),
    [anon_sym_async] = ACTIONS(3561),
    [anon_sym_const] = ACTIONS(3561),
    [anon_sym_file] = ACTIONS(3561),
    [anon_sym_fixed] = ACTIONS(3561),
    [anon_sym_internal] = ACTIONS(3561),
    [anon_sym_new] = ACTIONS(3561),
    [anon_sym_override] = ACTIONS(3561),
    [anon_sym_partial] = ACTIONS(3561),
    [anon_sym_private] = ACTIONS(3561),
    [anon_sym_protected] = ACTIONS(3561),
    [anon_sym_public] = ACTIONS(3561),
    [anon_sym_readonly] = ACTIONS(3561),
    [anon_sym_required] = ACTIONS(3561),
    [anon_sym_sealed] = ACTIONS(3561),
    [anon_sym_virtual] = ACTIONS(3561),
    [anon_sym_volatile] = ACTIONS(3561),
    [anon_sym_where] = ACTIONS(3561),
    [anon_sym_notnull] = ACTIONS(3561),
    [anon_sym_unmanaged] = ACTIONS(3561),
    [anon_sym_checked] = ACTIONS(3561),
    [anon_sym_BANG] = ACTIONS(3563),
    [anon_sym_TILDE] = ACTIONS(3563),
    [anon_sym_PLUS_PLUS] = ACTIONS(3563),
    [anon_sym_DASH_DASH] = ACTIONS(3563),
    [anon_sym_true] = ACTIONS(3561),
    [anon_sym_false] = ACTIONS(3561),
    [anon_sym_PLUS] = ACTIONS(3561),
    [anon_sym_DASH] = ACTIONS(3561),
    [anon_sym_STAR] = ACTIONS(3563),
    [anon_sym_CARET] = ACTIONS(3563),
    [anon_sym_AMP] = ACTIONS(3563),
    [anon_sym_this] = ACTIONS(3561),
    [anon_sym_scoped] = ACTIONS(3561),
    [anon_sym_var] = ACTIONS(3561),
    [sym_predefined_type] = ACTIONS(3561),
    [anon_sym_break] = ACTIONS(3561),
    [anon_sym_unchecked] = ACTIONS(3561),
    [anon_sym_continue] = ACTIONS(3561),
    [anon_sym_do] = ACTIONS(3561),
    [anon_sym_while] = ACTIONS(3561),
    [anon_sym_for] = ACTIONS(3561),
    [anon_sym_lock] = ACTIONS(3561),
    [anon_sym_yield] = ACTIONS(3561),
    [anon_sym_switch] = ACTIONS(3561),
    [anon_sym_default] = ACTIONS(3561),
    [anon_sym_throw] = ACTIONS(3561),
    [anon_sym_try] = ACTIONS(3561),
    [anon_sym_when] = ACTIONS(3561),
    [anon_sym_await] = ACTIONS(3561),
    [anon_sym_foreach] = ACTIONS(3561),
    [anon_sym_goto] = ACTIONS(3561),
    [anon_sym_if] = ACTIONS(3561),
    [anon_sym_DOT_DOT] = ACTIONS(3563),
    [anon_sym_from] = ACTIONS(3561),
    [anon_sym_into] = ACTIONS(3561),
    [anon_sym_join] = ACTIONS(3561),
    [anon_sym_on] = ACTIONS(3561),
    [anon_sym_equals] = ACTIONS(3561),
    [anon_sym_let] = ACTIONS(3561),
    [anon_sym_orderby] = ACTIONS(3561),
    [anon_sym_ascending] = ACTIONS(3561),
    [anon_sym_descending] = ACTIONS(3561),
    [anon_sym_group] = ACTIONS(3561),
    [anon_sym_by] = ACTIONS(3561),
    [anon_sym_select] = ACTIONS(3561),
    [anon_sym_DQUOTE] = ACTIONS(3561),
    [anon_sym_stackalloc] = ACTIONS(3561),
    [anon_sym_sizeof] = ACTIONS(3561),
    [anon_sym_typeof] = ACTIONS(3561),
    [anon_sym___makeref] = ACTIONS(3561),
    [anon_sym___reftype] = ACTIONS(3561),
    [anon_sym___refvalue] = ACTIONS(3561),
    [sym_null_literal] = ACTIONS(3561),
    [anon_sym_SQUOTE] = ACTIONS(3563),
    [sym_integer_literal] = ACTIONS(3561),
    [sym_real_literal] = ACTIONS(3563),
    [sym_verbatim_string_literal] = ACTIONS(3563),
    [sym_raw_string_literal] = ACTIONS(3563),
    [aux_sym_preproc_if_token1] = ACTIONS(3563),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3563),
    [sym_interpolation_verbatim_start] = ACTIONS(3563),
    [sym_interpolation_raw_start] = ACTIONS(3563),
  },
  [2637] = {
    [sym_preproc_region] = STATE(2637),
    [sym_preproc_endregion] = STATE(2637),
    [sym_preproc_line] = STATE(2637),
    [sym_preproc_pragma] = STATE(2637),
    [sym_preproc_nullable] = STATE(2637),
    [sym_preproc_error] = STATE(2637),
    [sym_preproc_define] = STATE(2637),
    [sym_preproc_undef] = STATE(2637),
    [sym__identifier_token] = ACTIONS(2921),
    [anon_sym_extern] = ACTIONS(2921),
    [anon_sym_alias] = ACTIONS(2921),
    [anon_sym_SEMI] = ACTIONS(2923),
    [anon_sym_global] = ACTIONS(2921),
    [anon_sym_using] = ACTIONS(2921),
    [anon_sym_unsafe] = ACTIONS(2921),
    [anon_sym_static] = ACTIONS(2921),
    [anon_sym_LBRACK] = ACTIONS(2923),
    [anon_sym_LPAREN] = ACTIONS(2923),
    [anon_sym_return] = ACTIONS(2921),
    [anon_sym_ref] = ACTIONS(2921),
    [anon_sym_LBRACE] = ACTIONS(2923),
    [anon_sym_RBRACE] = ACTIONS(2923),
    [anon_sym_delegate] = ACTIONS(2921),
    [anon_sym_abstract] = ACTIONS(2921),
    [anon_sym_async] = ACTIONS(2921),
    [anon_sym_const] = ACTIONS(2921),
    [anon_sym_file] = ACTIONS(2921),
    [anon_sym_fixed] = ACTIONS(2921),
    [anon_sym_internal] = ACTIONS(2921),
    [anon_sym_new] = ACTIONS(2921),
    [anon_sym_override] = ACTIONS(2921),
    [anon_sym_partial] = ACTIONS(2921),
    [anon_sym_private] = ACTIONS(2921),
    [anon_sym_protected] = ACTIONS(2921),
    [anon_sym_public] = ACTIONS(2921),
    [anon_sym_readonly] = ACTIONS(2921),
    [anon_sym_required] = ACTIONS(2921),
    [anon_sym_sealed] = ACTIONS(2921),
    [anon_sym_virtual] = ACTIONS(2921),
    [anon_sym_volatile] = ACTIONS(2921),
    [anon_sym_where] = ACTIONS(2921),
    [anon_sym_notnull] = ACTIONS(2921),
    [anon_sym_unmanaged] = ACTIONS(2921),
    [anon_sym_checked] = ACTIONS(2921),
    [anon_sym_BANG] = ACTIONS(2923),
    [anon_sym_TILDE] = ACTIONS(2923),
    [anon_sym_PLUS_PLUS] = ACTIONS(2923),
    [anon_sym_DASH_DASH] = ACTIONS(2923),
    [anon_sym_true] = ACTIONS(2921),
    [anon_sym_false] = ACTIONS(2921),
    [anon_sym_PLUS] = ACTIONS(2921),
    [anon_sym_DASH] = ACTIONS(2921),
    [anon_sym_STAR] = ACTIONS(2923),
    [anon_sym_CARET] = ACTIONS(2923),
    [anon_sym_AMP] = ACTIONS(2923),
    [anon_sym_this] = ACTIONS(2921),
    [anon_sym_scoped] = ACTIONS(2921),
    [anon_sym_var] = ACTIONS(2921),
    [sym_predefined_type] = ACTIONS(2921),
    [anon_sym_break] = ACTIONS(2921),
    [anon_sym_unchecked] = ACTIONS(2921),
    [anon_sym_continue] = ACTIONS(2921),
    [anon_sym_do] = ACTIONS(2921),
    [anon_sym_while] = ACTIONS(2921),
    [anon_sym_for] = ACTIONS(2921),
    [anon_sym_lock] = ACTIONS(2921),
    [anon_sym_yield] = ACTIONS(2921),
    [anon_sym_switch] = ACTIONS(2921),
    [anon_sym_case] = ACTIONS(2921),
    [anon_sym_default] = ACTIONS(2921),
    [anon_sym_throw] = ACTIONS(2921),
    [anon_sym_try] = ACTIONS(2921),
    [anon_sym_catch] = ACTIONS(2921),
    [anon_sym_when] = ACTIONS(2921),
    [anon_sym_finally] = ACTIONS(2921),
    [anon_sym_await] = ACTIONS(2921),
    [anon_sym_foreach] = ACTIONS(2921),
    [anon_sym_goto] = ACTIONS(2921),
    [anon_sym_if] = ACTIONS(2921),
    [anon_sym_else] = ACTIONS(2921),
    [anon_sym_DOT_DOT] = ACTIONS(2923),
    [anon_sym_from] = ACTIONS(2921),
    [anon_sym_into] = ACTIONS(2921),
    [anon_sym_join] = ACTIONS(2921),
    [anon_sym_on] = ACTIONS(2921),
    [anon_sym_equals] = ACTIONS(2921),
    [anon_sym_let] = ACTIONS(2921),
    [anon_sym_orderby] = ACTIONS(2921),
    [anon_sym_ascending] = ACTIONS(2921),
    [anon_sym_descending] = ACTIONS(2921),
    [anon_sym_group] = ACTIONS(2921),
    [anon_sym_by] = ACTIONS(2921),
    [anon_sym_select] = ACTIONS(2921),
    [anon_sym_DQUOTE] = ACTIONS(2921),
    [anon_sym_stackalloc] = ACTIONS(2921),
    [anon_sym_sizeof] = ACTIONS(2921),
    [anon_sym_typeof] = ACTIONS(2921),
    [anon_sym___makeref] = ACTIONS(2921),
    [anon_sym___reftype] = ACTIONS(2921),
    [anon_sym___refvalue] = ACTIONS(2921),
    [sym_null_literal] = ACTIONS(2921),
    [anon_sym_SQUOTE] = ACTIONS(2923),
    [sym_integer_literal] = ACTIONS(2921),
    [sym_real_literal] = ACTIONS(2923),
    [sym_verbatim_string_literal] = ACTIONS(2923),
    [sym_raw_string_literal] = ACTIONS(2923),
    [aux_sym_preproc_if_token1] = ACTIONS(2923),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(2923),
    [sym_interpolation_verbatim_start] = ACTIONS(2923),
    [sym_interpolation_raw_start] = ACTIONS(2923),
  },
  [2638] = {
    [sym_preproc_region] = STATE(2638),
    [sym_preproc_endregion] = STATE(2638),
    [sym_preproc_line] = STATE(2638),
    [sym_preproc_pragma] = STATE(2638),
    [sym_preproc_nullable] = STATE(2638),
    [sym_preproc_error] = STATE(2638),
    [sym_preproc_define] = STATE(2638),
    [sym_preproc_undef] = STATE(2638),
    [sym__identifier_token] = ACTIONS(2967),
    [anon_sym_extern] = ACTIONS(2967),
    [anon_sym_alias] = ACTIONS(2967),
    [anon_sym_SEMI] = ACTIONS(2969),
    [anon_sym_global] = ACTIONS(2967),
    [anon_sym_using] = ACTIONS(2967),
    [anon_sym_unsafe] = ACTIONS(2967),
    [anon_sym_static] = ACTIONS(2967),
    [anon_sym_LBRACK] = ACTIONS(2969),
    [anon_sym_LPAREN] = ACTIONS(2969),
    [anon_sym_return] = ACTIONS(2967),
    [anon_sym_ref] = ACTIONS(2967),
    [anon_sym_LBRACE] = ACTIONS(2969),
    [anon_sym_RBRACE] = ACTIONS(2969),
    [anon_sym_delegate] = ACTIONS(2967),
    [anon_sym_abstract] = ACTIONS(2967),
    [anon_sym_async] = ACTIONS(2967),
    [anon_sym_const] = ACTIONS(2967),
    [anon_sym_file] = ACTIONS(2967),
    [anon_sym_fixed] = ACTIONS(2967),
    [anon_sym_internal] = ACTIONS(2967),
    [anon_sym_new] = ACTIONS(2967),
    [anon_sym_override] = ACTIONS(2967),
    [anon_sym_partial] = ACTIONS(2967),
    [anon_sym_private] = ACTIONS(2967),
    [anon_sym_protected] = ACTIONS(2967),
    [anon_sym_public] = ACTIONS(2967),
    [anon_sym_readonly] = ACTIONS(2967),
    [anon_sym_required] = ACTIONS(2967),
    [anon_sym_sealed] = ACTIONS(2967),
    [anon_sym_virtual] = ACTIONS(2967),
    [anon_sym_volatile] = ACTIONS(2967),
    [anon_sym_where] = ACTIONS(2967),
    [anon_sym_notnull] = ACTIONS(2967),
    [anon_sym_unmanaged] = ACTIONS(2967),
    [anon_sym_checked] = ACTIONS(2967),
    [anon_sym_BANG] = ACTIONS(2969),
    [anon_sym_TILDE] = ACTIONS(2969),
    [anon_sym_PLUS_PLUS] = ACTIONS(2969),
    [anon_sym_DASH_DASH] = ACTIONS(2969),
    [anon_sym_true] = ACTIONS(2967),
    [anon_sym_false] = ACTIONS(2967),
    [anon_sym_PLUS] = ACTIONS(2967),
    [anon_sym_DASH] = ACTIONS(2967),
    [anon_sym_STAR] = ACTIONS(2969),
    [anon_sym_CARET] = ACTIONS(2969),
    [anon_sym_AMP] = ACTIONS(2969),
    [anon_sym_this] = ACTIONS(2967),
    [anon_sym_scoped] = ACTIONS(2967),
    [anon_sym_var] = ACTIONS(2967),
    [sym_predefined_type] = ACTIONS(2967),
    [anon_sym_break] = ACTIONS(2967),
    [anon_sym_unchecked] = ACTIONS(2967),
    [anon_sym_continue] = ACTIONS(2967),
    [anon_sym_do] = ACTIONS(2967),
    [anon_sym_while] = ACTIONS(2967),
    [anon_sym_for] = ACTIONS(2967),
    [anon_sym_lock] = ACTIONS(2967),
    [anon_sym_yield] = ACTIONS(2967),
    [anon_sym_switch] = ACTIONS(2967),
    [anon_sym_case] = ACTIONS(2967),
    [anon_sym_default] = ACTIONS(2967),
    [anon_sym_throw] = ACTIONS(2967),
    [anon_sym_try] = ACTIONS(2967),
    [anon_sym_catch] = ACTIONS(2967),
    [anon_sym_when] = ACTIONS(2967),
    [anon_sym_finally] = ACTIONS(2967),
    [anon_sym_await] = ACTIONS(2967),
    [anon_sym_foreach] = ACTIONS(2967),
    [anon_sym_goto] = ACTIONS(2967),
    [anon_sym_if] = ACTIONS(2967),
    [anon_sym_else] = ACTIONS(2967),
    [anon_sym_DOT_DOT] = ACTIONS(2969),
    [anon_sym_from] = ACTIONS(2967),
    [anon_sym_into] = ACTIONS(2967),
    [anon_sym_join] = ACTIONS(2967),
    [anon_sym_on] = ACTIONS(2967),
    [anon_sym_equals] = ACTIONS(2967),
    [anon_sym_let] = ACTIONS(2967),
    [anon_sym_orderby] = ACTIONS(2967),
    [anon_sym_ascending] = ACTIONS(2967),
    [anon_sym_descending] = ACTIONS(2967),
    [anon_sym_group] = ACTIONS(2967),
    [anon_sym_by] = ACTIONS(2967),
    [anon_sym_select] = ACTIONS(2967),
    [anon_sym_DQUOTE] = ACTIONS(2967),
    [anon_sym_stackalloc] = ACTIONS(2967),
    [anon_sym_sizeof] = ACTIONS(2967),
    [anon_sym_typeof] = ACTIONS(2967),
    [anon_sym___makeref] = ACTIONS(2967),
    [anon_sym___reftype] = ACTIONS(2967),
    [anon_sym___refvalue] = ACTIONS(2967),
    [sym_null_literal] = ACTIONS(2967),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [sym_integer_literal] = ACTIONS(2967),
    [sym_real_literal] = ACTIONS(2969),
    [sym_verbatim_string_literal] = ACTIONS(2969),
    [sym_raw_string_literal] = ACTIONS(2969),
    [aux_sym_preproc_if_token1] = ACTIONS(2969),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(2969),
    [sym_interpolation_verbatim_start] = ACTIONS(2969),
    [sym_interpolation_raw_start] = ACTIONS(2969),
  },
  [2639] = {
    [sym_preproc_region] = STATE(2639),
    [sym_preproc_endregion] = STATE(2639),
    [sym_preproc_line] = STATE(2639),
    [sym_preproc_pragma] = STATE(2639),
    [sym_preproc_nullable] = STATE(2639),
    [sym_preproc_error] = STATE(2639),
    [sym_preproc_define] = STATE(2639),
    [sym_preproc_undef] = STATE(2639),
    [sym__identifier_token] = ACTIONS(3973),
    [anon_sym_extern] = ACTIONS(3976),
    [anon_sym_alias] = ACTIONS(3973),
    [anon_sym_global] = ACTIONS(3973),
    [anon_sym_unsafe] = ACTIONS(3976),
    [anon_sym_EQ] = ACTIONS(3721),
    [anon_sym_static] = ACTIONS(3976),
    [anon_sym_LBRACK] = ACTIONS(3719),
    [anon_sym_COLON] = ACTIONS(3721),
    [anon_sym_LPAREN] = ACTIONS(3978),
    [anon_sym_class] = ACTIONS(3976),
    [anon_sym_ref] = ACTIONS(3976),
    [anon_sym_struct] = ACTIONS(3976),
    [anon_sym_enum] = ACTIONS(3976),
    [anon_sym_interface] = ACTIONS(3976),
    [anon_sym_delegate] = ACTIONS(3976),
    [anon_sym_record] = ACTIONS(3976),
    [anon_sym_abstract] = ACTIONS(3976),
    [anon_sym_async] = ACTIONS(3976),
    [anon_sym_const] = ACTIONS(3976),
    [anon_sym_file] = ACTIONS(3973),
    [anon_sym_fixed] = ACTIONS(3976),
    [anon_sym_internal] = ACTIONS(3976),
    [anon_sym_new] = ACTIONS(3976),
    [anon_sym_override] = ACTIONS(3976),
    [anon_sym_partial] = ACTIONS(3976),
    [anon_sym_private] = ACTIONS(3976),
    [anon_sym_protected] = ACTIONS(3976),
    [anon_sym_public] = ACTIONS(3976),
    [anon_sym_readonly] = ACTIONS(3976),
    [anon_sym_required] = ACTIONS(3976),
    [anon_sym_sealed] = ACTIONS(3976),
    [anon_sym_virtual] = ACTIONS(3976),
    [anon_sym_volatile] = ACTIONS(3976),
    [anon_sym_LT] = ACTIONS(3721),
    [anon_sym_GT] = ACTIONS(3721),
    [anon_sym_where] = ACTIONS(3973),
    [anon_sym_QMARK] = ACTIONS(3721),
    [anon_sym_notnull] = ACTIONS(3973),
    [anon_sym_unmanaged] = ACTIONS(3973),
    [anon_sym_BANG] = ACTIONS(3721),
    [anon_sym_PLUS_PLUS] = ACTIONS(3719),
    [anon_sym_DASH_DASH] = ACTIONS(3719),
    [anon_sym_PLUS] = ACTIONS(3721),
    [anon_sym_DASH] = ACTIONS(3721),
    [anon_sym_STAR] = ACTIONS(3721),
    [anon_sym_SLASH] = ACTIONS(3721),
    [anon_sym_PERCENT] = ACTIONS(3721),
    [anon_sym_CARET] = ACTIONS(3721),
    [anon_sym_PIPE] = ACTIONS(3721),
    [anon_sym_AMP] = ACTIONS(3721),
    [anon_sym_LT_LT] = ACTIONS(3721),
    [anon_sym_GT_GT] = ACTIONS(3721),
    [anon_sym_GT_GT_GT] = ACTIONS(3721),
    [anon_sym_EQ_EQ] = ACTIONS(3719),
    [anon_sym_BANG_EQ] = ACTIONS(3719),
    [anon_sym_GT_EQ] = ACTIONS(3719),
    [anon_sym_LT_EQ] = ACTIONS(3719),
    [anon_sym_DOT] = ACTIONS(3721),
    [anon_sym_scoped] = ACTIONS(3973),
    [anon_sym_EQ_GT] = ACTIONS(3719),
    [anon_sym_COLON_COLON] = ACTIONS(3719),
    [anon_sym_var] = ACTIONS(3973),
    [sym_predefined_type] = ACTIONS(3976),
    [anon_sym_yield] = ACTIONS(3973),
    [anon_sym_switch] = ACTIONS(3721),
    [anon_sym_when] = ACTIONS(3973),
    [anon_sym_DOT_DOT] = ACTIONS(3719),
    [anon_sym_PLUS_EQ] = ACTIONS(3719),
    [anon_sym_DASH_EQ] = ACTIONS(3719),
    [anon_sym_STAR_EQ] = ACTIONS(3719),
    [anon_sym_SLASH_EQ] = ACTIONS(3719),
    [anon_sym_PERCENT_EQ] = ACTIONS(3719),
    [anon_sym_AMP_EQ] = ACTIONS(3719),
    [anon_sym_CARET_EQ] = ACTIONS(3719),
    [anon_sym_PIPE_EQ] = ACTIONS(3719),
    [anon_sym_LT_LT_EQ] = ACTIONS(3719),
    [anon_sym_GT_GT_EQ] = ACTIONS(3719),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3719),
    [anon_sym_AMP_AMP] = ACTIONS(3719),
    [anon_sym_PIPE_PIPE] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK] = ACTIONS(3721),
    [anon_sym_from] = ACTIONS(3973),
    [anon_sym_into] = ACTIONS(3973),
    [anon_sym_join] = ACTIONS(3973),
    [anon_sym_on] = ACTIONS(3973),
    [anon_sym_equals] = ACTIONS(3973),
    [anon_sym_let] = ACTIONS(3973),
    [anon_sym_orderby] = ACTIONS(3973),
    [anon_sym_ascending] = ACTIONS(3973),
    [anon_sym_descending] = ACTIONS(3973),
    [anon_sym_group] = ACTIONS(3973),
    [anon_sym_by] = ACTIONS(3973),
    [anon_sym_select] = ACTIONS(3973),
    [anon_sym_as] = ACTIONS(3721),
    [anon_sym_is] = ACTIONS(3721),
    [anon_sym_DASH_GT] = ACTIONS(3719),
    [anon_sym_with] = ACTIONS(3721),
    [aux_sym_preproc_if_token3] = ACTIONS(3719),
    [aux_sym_preproc_else_token1] = ACTIONS(3719),
    [aux_sym_preproc_elif_token1] = ACTIONS(3719),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2640] = {
    [sym_preproc_region] = STATE(2640),
    [sym_preproc_endregion] = STATE(2640),
    [sym_preproc_line] = STATE(2640),
    [sym_preproc_pragma] = STATE(2640),
    [sym_preproc_nullable] = STATE(2640),
    [sym_preproc_error] = STATE(2640),
    [sym_preproc_define] = STATE(2640),
    [sym_preproc_undef] = STATE(2640),
    [sym__identifier_token] = ACTIONS(2971),
    [anon_sym_extern] = ACTIONS(2971),
    [anon_sym_alias] = ACTIONS(2971),
    [anon_sym_SEMI] = ACTIONS(2973),
    [anon_sym_global] = ACTIONS(2971),
    [anon_sym_using] = ACTIONS(2971),
    [anon_sym_unsafe] = ACTIONS(2971),
    [anon_sym_static] = ACTIONS(2971),
    [anon_sym_LBRACK] = ACTIONS(2973),
    [anon_sym_LPAREN] = ACTIONS(2973),
    [anon_sym_return] = ACTIONS(2971),
    [anon_sym_ref] = ACTIONS(2971),
    [anon_sym_LBRACE] = ACTIONS(2973),
    [anon_sym_RBRACE] = ACTIONS(2973),
    [anon_sym_delegate] = ACTIONS(2971),
    [anon_sym_abstract] = ACTIONS(2971),
    [anon_sym_async] = ACTIONS(2971),
    [anon_sym_const] = ACTIONS(2971),
    [anon_sym_file] = ACTIONS(2971),
    [anon_sym_fixed] = ACTIONS(2971),
    [anon_sym_internal] = ACTIONS(2971),
    [anon_sym_new] = ACTIONS(2971),
    [anon_sym_override] = ACTIONS(2971),
    [anon_sym_partial] = ACTIONS(2971),
    [anon_sym_private] = ACTIONS(2971),
    [anon_sym_protected] = ACTIONS(2971),
    [anon_sym_public] = ACTIONS(2971),
    [anon_sym_readonly] = ACTIONS(2971),
    [anon_sym_required] = ACTIONS(2971),
    [anon_sym_sealed] = ACTIONS(2971),
    [anon_sym_virtual] = ACTIONS(2971),
    [anon_sym_volatile] = ACTIONS(2971),
    [anon_sym_where] = ACTIONS(2971),
    [anon_sym_notnull] = ACTIONS(2971),
    [anon_sym_unmanaged] = ACTIONS(2971),
    [anon_sym_checked] = ACTIONS(2971),
    [anon_sym_BANG] = ACTIONS(2973),
    [anon_sym_TILDE] = ACTIONS(2973),
    [anon_sym_PLUS_PLUS] = ACTIONS(2973),
    [anon_sym_DASH_DASH] = ACTIONS(2973),
    [anon_sym_true] = ACTIONS(2971),
    [anon_sym_false] = ACTIONS(2971),
    [anon_sym_PLUS] = ACTIONS(2971),
    [anon_sym_DASH] = ACTIONS(2971),
    [anon_sym_STAR] = ACTIONS(2973),
    [anon_sym_CARET] = ACTIONS(2973),
    [anon_sym_AMP] = ACTIONS(2973),
    [anon_sym_this] = ACTIONS(2971),
    [anon_sym_scoped] = ACTIONS(2971),
    [anon_sym_var] = ACTIONS(2971),
    [sym_predefined_type] = ACTIONS(2971),
    [anon_sym_break] = ACTIONS(2971),
    [anon_sym_unchecked] = ACTIONS(2971),
    [anon_sym_continue] = ACTIONS(2971),
    [anon_sym_do] = ACTIONS(2971),
    [anon_sym_while] = ACTIONS(2971),
    [anon_sym_for] = ACTIONS(2971),
    [anon_sym_lock] = ACTIONS(2971),
    [anon_sym_yield] = ACTIONS(2971),
    [anon_sym_switch] = ACTIONS(2971),
    [anon_sym_case] = ACTIONS(2971),
    [anon_sym_default] = ACTIONS(2971),
    [anon_sym_throw] = ACTIONS(2971),
    [anon_sym_try] = ACTIONS(2971),
    [anon_sym_catch] = ACTIONS(2971),
    [anon_sym_when] = ACTIONS(2971),
    [anon_sym_finally] = ACTIONS(2971),
    [anon_sym_await] = ACTIONS(2971),
    [anon_sym_foreach] = ACTIONS(2971),
    [anon_sym_goto] = ACTIONS(2971),
    [anon_sym_if] = ACTIONS(2971),
    [anon_sym_else] = ACTIONS(2971),
    [anon_sym_DOT_DOT] = ACTIONS(2973),
    [anon_sym_from] = ACTIONS(2971),
    [anon_sym_into] = ACTIONS(2971),
    [anon_sym_join] = ACTIONS(2971),
    [anon_sym_on] = ACTIONS(2971),
    [anon_sym_equals] = ACTIONS(2971),
    [anon_sym_let] = ACTIONS(2971),
    [anon_sym_orderby] = ACTIONS(2971),
    [anon_sym_ascending] = ACTIONS(2971),
    [anon_sym_descending] = ACTIONS(2971),
    [anon_sym_group] = ACTIONS(2971),
    [anon_sym_by] = ACTIONS(2971),
    [anon_sym_select] = ACTIONS(2971),
    [anon_sym_DQUOTE] = ACTIONS(2971),
    [anon_sym_stackalloc] = ACTIONS(2971),
    [anon_sym_sizeof] = ACTIONS(2971),
    [anon_sym_typeof] = ACTIONS(2971),
    [anon_sym___makeref] = ACTIONS(2971),
    [anon_sym___reftype] = ACTIONS(2971),
    [anon_sym___refvalue] = ACTIONS(2971),
    [sym_null_literal] = ACTIONS(2971),
    [anon_sym_SQUOTE] = ACTIONS(2973),
    [sym_integer_literal] = ACTIONS(2971),
    [sym_real_literal] = ACTIONS(2973),
    [sym_verbatim_string_literal] = ACTIONS(2973),
    [sym_raw_string_literal] = ACTIONS(2973),
    [aux_sym_preproc_if_token1] = ACTIONS(2973),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(2973),
    [sym_interpolation_verbatim_start] = ACTIONS(2973),
    [sym_interpolation_raw_start] = ACTIONS(2973),
  },
  [2641] = {
    [sym_preproc_region] = STATE(2641),
    [sym_preproc_endregion] = STATE(2641),
    [sym_preproc_line] = STATE(2641),
    [sym_preproc_pragma] = STATE(2641),
    [sym_preproc_nullable] = STATE(2641),
    [sym_preproc_error] = STATE(2641),
    [sym_preproc_define] = STATE(2641),
    [sym_preproc_undef] = STATE(2641),
    [sym__identifier_token] = ACTIONS(2979),
    [anon_sym_extern] = ACTIONS(2979),
    [anon_sym_alias] = ACTIONS(2979),
    [anon_sym_SEMI] = ACTIONS(2981),
    [anon_sym_global] = ACTIONS(2979),
    [anon_sym_using] = ACTIONS(2979),
    [anon_sym_unsafe] = ACTIONS(2979),
    [anon_sym_static] = ACTIONS(2979),
    [anon_sym_LBRACK] = ACTIONS(2981),
    [anon_sym_LPAREN] = ACTIONS(2981),
    [anon_sym_return] = ACTIONS(2979),
    [anon_sym_ref] = ACTIONS(2979),
    [anon_sym_LBRACE] = ACTIONS(2981),
    [anon_sym_RBRACE] = ACTIONS(2981),
    [anon_sym_delegate] = ACTIONS(2979),
    [anon_sym_abstract] = ACTIONS(2979),
    [anon_sym_async] = ACTIONS(2979),
    [anon_sym_const] = ACTIONS(2979),
    [anon_sym_file] = ACTIONS(2979),
    [anon_sym_fixed] = ACTIONS(2979),
    [anon_sym_internal] = ACTIONS(2979),
    [anon_sym_new] = ACTIONS(2979),
    [anon_sym_override] = ACTIONS(2979),
    [anon_sym_partial] = ACTIONS(2979),
    [anon_sym_private] = ACTIONS(2979),
    [anon_sym_protected] = ACTIONS(2979),
    [anon_sym_public] = ACTIONS(2979),
    [anon_sym_readonly] = ACTIONS(2979),
    [anon_sym_required] = ACTIONS(2979),
    [anon_sym_sealed] = ACTIONS(2979),
    [anon_sym_virtual] = ACTIONS(2979),
    [anon_sym_volatile] = ACTIONS(2979),
    [anon_sym_where] = ACTIONS(2979),
    [anon_sym_notnull] = ACTIONS(2979),
    [anon_sym_unmanaged] = ACTIONS(2979),
    [anon_sym_checked] = ACTIONS(2979),
    [anon_sym_BANG] = ACTIONS(2981),
    [anon_sym_TILDE] = ACTIONS(2981),
    [anon_sym_PLUS_PLUS] = ACTIONS(2981),
    [anon_sym_DASH_DASH] = ACTIONS(2981),
    [anon_sym_true] = ACTIONS(2979),
    [anon_sym_false] = ACTIONS(2979),
    [anon_sym_PLUS] = ACTIONS(2979),
    [anon_sym_DASH] = ACTIONS(2979),
    [anon_sym_STAR] = ACTIONS(2981),
    [anon_sym_CARET] = ACTIONS(2981),
    [anon_sym_AMP] = ACTIONS(2981),
    [anon_sym_this] = ACTIONS(2979),
    [anon_sym_scoped] = ACTIONS(2979),
    [anon_sym_var] = ACTIONS(2979),
    [sym_predefined_type] = ACTIONS(2979),
    [anon_sym_break] = ACTIONS(2979),
    [anon_sym_unchecked] = ACTIONS(2979),
    [anon_sym_continue] = ACTIONS(2979),
    [anon_sym_do] = ACTIONS(2979),
    [anon_sym_while] = ACTIONS(2979),
    [anon_sym_for] = ACTIONS(2979),
    [anon_sym_lock] = ACTIONS(2979),
    [anon_sym_yield] = ACTIONS(2979),
    [anon_sym_switch] = ACTIONS(2979),
    [anon_sym_case] = ACTIONS(2979),
    [anon_sym_default] = ACTIONS(2979),
    [anon_sym_throw] = ACTIONS(2979),
    [anon_sym_try] = ACTIONS(2979),
    [anon_sym_catch] = ACTIONS(2979),
    [anon_sym_when] = ACTIONS(2979),
    [anon_sym_finally] = ACTIONS(2979),
    [anon_sym_await] = ACTIONS(2979),
    [anon_sym_foreach] = ACTIONS(2979),
    [anon_sym_goto] = ACTIONS(2979),
    [anon_sym_if] = ACTIONS(2979),
    [anon_sym_else] = ACTIONS(2979),
    [anon_sym_DOT_DOT] = ACTIONS(2981),
    [anon_sym_from] = ACTIONS(2979),
    [anon_sym_into] = ACTIONS(2979),
    [anon_sym_join] = ACTIONS(2979),
    [anon_sym_on] = ACTIONS(2979),
    [anon_sym_equals] = ACTIONS(2979),
    [anon_sym_let] = ACTIONS(2979),
    [anon_sym_orderby] = ACTIONS(2979),
    [anon_sym_ascending] = ACTIONS(2979),
    [anon_sym_descending] = ACTIONS(2979),
    [anon_sym_group] = ACTIONS(2979),
    [anon_sym_by] = ACTIONS(2979),
    [anon_sym_select] = ACTIONS(2979),
    [anon_sym_DQUOTE] = ACTIONS(2979),
    [anon_sym_stackalloc] = ACTIONS(2979),
    [anon_sym_sizeof] = ACTIONS(2979),
    [anon_sym_typeof] = ACTIONS(2979),
    [anon_sym___makeref] = ACTIONS(2979),
    [anon_sym___reftype] = ACTIONS(2979),
    [anon_sym___refvalue] = ACTIONS(2979),
    [sym_null_literal] = ACTIONS(2979),
    [anon_sym_SQUOTE] = ACTIONS(2981),
    [sym_integer_literal] = ACTIONS(2979),
    [sym_real_literal] = ACTIONS(2981),
    [sym_verbatim_string_literal] = ACTIONS(2981),
    [sym_raw_string_literal] = ACTIONS(2981),
    [aux_sym_preproc_if_token1] = ACTIONS(2981),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(2981),
    [sym_interpolation_verbatim_start] = ACTIONS(2981),
    [sym_interpolation_raw_start] = ACTIONS(2981),
  },
  [2642] = {
    [sym_preproc_region] = STATE(2642),
    [sym_preproc_endregion] = STATE(2642),
    [sym_preproc_line] = STATE(2642),
    [sym_preproc_pragma] = STATE(2642),
    [sym_preproc_nullable] = STATE(2642),
    [sym_preproc_error] = STATE(2642),
    [sym_preproc_define] = STATE(2642),
    [sym_preproc_undef] = STATE(2642),
    [sym__identifier_token] = ACTIONS(2975),
    [anon_sym_extern] = ACTIONS(2975),
    [anon_sym_alias] = ACTIONS(2975),
    [anon_sym_SEMI] = ACTIONS(2977),
    [anon_sym_global] = ACTIONS(2975),
    [anon_sym_using] = ACTIONS(2975),
    [anon_sym_unsafe] = ACTIONS(2975),
    [anon_sym_static] = ACTIONS(2975),
    [anon_sym_LBRACK] = ACTIONS(2977),
    [anon_sym_LPAREN] = ACTIONS(2977),
    [anon_sym_return] = ACTIONS(2975),
    [anon_sym_ref] = ACTIONS(2975),
    [anon_sym_LBRACE] = ACTIONS(2977),
    [anon_sym_RBRACE] = ACTIONS(2977),
    [anon_sym_delegate] = ACTIONS(2975),
    [anon_sym_abstract] = ACTIONS(2975),
    [anon_sym_async] = ACTIONS(2975),
    [anon_sym_const] = ACTIONS(2975),
    [anon_sym_file] = ACTIONS(2975),
    [anon_sym_fixed] = ACTIONS(2975),
    [anon_sym_internal] = ACTIONS(2975),
    [anon_sym_new] = ACTIONS(2975),
    [anon_sym_override] = ACTIONS(2975),
    [anon_sym_partial] = ACTIONS(2975),
    [anon_sym_private] = ACTIONS(2975),
    [anon_sym_protected] = ACTIONS(2975),
    [anon_sym_public] = ACTIONS(2975),
    [anon_sym_readonly] = ACTIONS(2975),
    [anon_sym_required] = ACTIONS(2975),
    [anon_sym_sealed] = ACTIONS(2975),
    [anon_sym_virtual] = ACTIONS(2975),
    [anon_sym_volatile] = ACTIONS(2975),
    [anon_sym_where] = ACTIONS(2975),
    [anon_sym_notnull] = ACTIONS(2975),
    [anon_sym_unmanaged] = ACTIONS(2975),
    [anon_sym_checked] = ACTIONS(2975),
    [anon_sym_BANG] = ACTIONS(2977),
    [anon_sym_TILDE] = ACTIONS(2977),
    [anon_sym_PLUS_PLUS] = ACTIONS(2977),
    [anon_sym_DASH_DASH] = ACTIONS(2977),
    [anon_sym_true] = ACTIONS(2975),
    [anon_sym_false] = ACTIONS(2975),
    [anon_sym_PLUS] = ACTIONS(2975),
    [anon_sym_DASH] = ACTIONS(2975),
    [anon_sym_STAR] = ACTIONS(2977),
    [anon_sym_CARET] = ACTIONS(2977),
    [anon_sym_AMP] = ACTIONS(2977),
    [anon_sym_this] = ACTIONS(2975),
    [anon_sym_scoped] = ACTIONS(2975),
    [anon_sym_var] = ACTIONS(2975),
    [sym_predefined_type] = ACTIONS(2975),
    [anon_sym_break] = ACTIONS(2975),
    [anon_sym_unchecked] = ACTIONS(2975),
    [anon_sym_continue] = ACTIONS(2975),
    [anon_sym_do] = ACTIONS(2975),
    [anon_sym_while] = ACTIONS(2975),
    [anon_sym_for] = ACTIONS(2975),
    [anon_sym_lock] = ACTIONS(2975),
    [anon_sym_yield] = ACTIONS(2975),
    [anon_sym_switch] = ACTIONS(2975),
    [anon_sym_case] = ACTIONS(2975),
    [anon_sym_default] = ACTIONS(2975),
    [anon_sym_throw] = ACTIONS(2975),
    [anon_sym_try] = ACTIONS(2975),
    [anon_sym_catch] = ACTIONS(2975),
    [anon_sym_when] = ACTIONS(2975),
    [anon_sym_finally] = ACTIONS(2975),
    [anon_sym_await] = ACTIONS(2975),
    [anon_sym_foreach] = ACTIONS(2975),
    [anon_sym_goto] = ACTIONS(2975),
    [anon_sym_if] = ACTIONS(2975),
    [anon_sym_else] = ACTIONS(2975),
    [anon_sym_DOT_DOT] = ACTIONS(2977),
    [anon_sym_from] = ACTIONS(2975),
    [anon_sym_into] = ACTIONS(2975),
    [anon_sym_join] = ACTIONS(2975),
    [anon_sym_on] = ACTIONS(2975),
    [anon_sym_equals] = ACTIONS(2975),
    [anon_sym_let] = ACTIONS(2975),
    [anon_sym_orderby] = ACTIONS(2975),
    [anon_sym_ascending] = ACTIONS(2975),
    [anon_sym_descending] = ACTIONS(2975),
    [anon_sym_group] = ACTIONS(2975),
    [anon_sym_by] = ACTIONS(2975),
    [anon_sym_select] = ACTIONS(2975),
    [anon_sym_DQUOTE] = ACTIONS(2975),
    [anon_sym_stackalloc] = ACTIONS(2975),
    [anon_sym_sizeof] = ACTIONS(2975),
    [anon_sym_typeof] = ACTIONS(2975),
    [anon_sym___makeref] = ACTIONS(2975),
    [anon_sym___reftype] = ACTIONS(2975),
    [anon_sym___refvalue] = ACTIONS(2975),
    [sym_null_literal] = ACTIONS(2975),
    [anon_sym_SQUOTE] = ACTIONS(2977),
    [sym_integer_literal] = ACTIONS(2975),
    [sym_real_literal] = ACTIONS(2977),
    [sym_verbatim_string_literal] = ACTIONS(2977),
    [sym_raw_string_literal] = ACTIONS(2977),
    [aux_sym_preproc_if_token1] = ACTIONS(2977),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(2977),
    [sym_interpolation_verbatim_start] = ACTIONS(2977),
    [sym_interpolation_raw_start] = ACTIONS(2977),
  },
  [2643] = {
    [sym_preproc_region] = STATE(2643),
    [sym_preproc_endregion] = STATE(2643),
    [sym_preproc_line] = STATE(2643),
    [sym_preproc_pragma] = STATE(2643),
    [sym_preproc_nullable] = STATE(2643),
    [sym_preproc_error] = STATE(2643),
    [sym_preproc_define] = STATE(2643),
    [sym_preproc_undef] = STATE(2643),
    [sym__identifier_token] = ACTIONS(2963),
    [anon_sym_extern] = ACTIONS(2963),
    [anon_sym_alias] = ACTIONS(2963),
    [anon_sym_SEMI] = ACTIONS(2965),
    [anon_sym_global] = ACTIONS(2963),
    [anon_sym_using] = ACTIONS(2963),
    [anon_sym_unsafe] = ACTIONS(2963),
    [anon_sym_static] = ACTIONS(2963),
    [anon_sym_LBRACK] = ACTIONS(2965),
    [anon_sym_LPAREN] = ACTIONS(2965),
    [anon_sym_return] = ACTIONS(2963),
    [anon_sym_ref] = ACTIONS(2963),
    [anon_sym_LBRACE] = ACTIONS(2965),
    [anon_sym_RBRACE] = ACTIONS(2965),
    [anon_sym_delegate] = ACTIONS(2963),
    [anon_sym_abstract] = ACTIONS(2963),
    [anon_sym_async] = ACTIONS(2963),
    [anon_sym_const] = ACTIONS(2963),
    [anon_sym_file] = ACTIONS(2963),
    [anon_sym_fixed] = ACTIONS(2963),
    [anon_sym_internal] = ACTIONS(2963),
    [anon_sym_new] = ACTIONS(2963),
    [anon_sym_override] = ACTIONS(2963),
    [anon_sym_partial] = ACTIONS(2963),
    [anon_sym_private] = ACTIONS(2963),
    [anon_sym_protected] = ACTIONS(2963),
    [anon_sym_public] = ACTIONS(2963),
    [anon_sym_readonly] = ACTIONS(2963),
    [anon_sym_required] = ACTIONS(2963),
    [anon_sym_sealed] = ACTIONS(2963),
    [anon_sym_virtual] = ACTIONS(2963),
    [anon_sym_volatile] = ACTIONS(2963),
    [anon_sym_where] = ACTIONS(2963),
    [anon_sym_notnull] = ACTIONS(2963),
    [anon_sym_unmanaged] = ACTIONS(2963),
    [anon_sym_checked] = ACTIONS(2963),
    [anon_sym_BANG] = ACTIONS(2965),
    [anon_sym_TILDE] = ACTIONS(2965),
    [anon_sym_PLUS_PLUS] = ACTIONS(2965),
    [anon_sym_DASH_DASH] = ACTIONS(2965),
    [anon_sym_true] = ACTIONS(2963),
    [anon_sym_false] = ACTIONS(2963),
    [anon_sym_PLUS] = ACTIONS(2963),
    [anon_sym_DASH] = ACTIONS(2963),
    [anon_sym_STAR] = ACTIONS(2965),
    [anon_sym_CARET] = ACTIONS(2965),
    [anon_sym_AMP] = ACTIONS(2965),
    [anon_sym_this] = ACTIONS(2963),
    [anon_sym_scoped] = ACTIONS(2963),
    [anon_sym_var] = ACTIONS(2963),
    [sym_predefined_type] = ACTIONS(2963),
    [anon_sym_break] = ACTIONS(2963),
    [anon_sym_unchecked] = ACTIONS(2963),
    [anon_sym_continue] = ACTIONS(2963),
    [anon_sym_do] = ACTIONS(2963),
    [anon_sym_while] = ACTIONS(2963),
    [anon_sym_for] = ACTIONS(2963),
    [anon_sym_lock] = ACTIONS(2963),
    [anon_sym_yield] = ACTIONS(2963),
    [anon_sym_switch] = ACTIONS(2963),
    [anon_sym_case] = ACTIONS(2963),
    [anon_sym_default] = ACTIONS(2963),
    [anon_sym_throw] = ACTIONS(2963),
    [anon_sym_try] = ACTIONS(2963),
    [anon_sym_catch] = ACTIONS(2963),
    [anon_sym_when] = ACTIONS(2963),
    [anon_sym_finally] = ACTIONS(2963),
    [anon_sym_await] = ACTIONS(2963),
    [anon_sym_foreach] = ACTIONS(2963),
    [anon_sym_goto] = ACTIONS(2963),
    [anon_sym_if] = ACTIONS(2963),
    [anon_sym_else] = ACTIONS(2963),
    [anon_sym_DOT_DOT] = ACTIONS(2965),
    [anon_sym_from] = ACTIONS(2963),
    [anon_sym_into] = ACTIONS(2963),
    [anon_sym_join] = ACTIONS(2963),
    [anon_sym_on] = ACTIONS(2963),
    [anon_sym_equals] = ACTIONS(2963),
    [anon_sym_let] = ACTIONS(2963),
    [anon_sym_orderby] = ACTIONS(2963),
    [anon_sym_ascending] = ACTIONS(2963),
    [anon_sym_descending] = ACTIONS(2963),
    [anon_sym_group] = ACTIONS(2963),
    [anon_sym_by] = ACTIONS(2963),
    [anon_sym_select] = ACTIONS(2963),
    [anon_sym_DQUOTE] = ACTIONS(2963),
    [anon_sym_stackalloc] = ACTIONS(2963),
    [anon_sym_sizeof] = ACTIONS(2963),
    [anon_sym_typeof] = ACTIONS(2963),
    [anon_sym___makeref] = ACTIONS(2963),
    [anon_sym___reftype] = ACTIONS(2963),
    [anon_sym___refvalue] = ACTIONS(2963),
    [sym_null_literal] = ACTIONS(2963),
    [anon_sym_SQUOTE] = ACTIONS(2965),
    [sym_integer_literal] = ACTIONS(2963),
    [sym_real_literal] = ACTIONS(2965),
    [sym_verbatim_string_literal] = ACTIONS(2965),
    [sym_raw_string_literal] = ACTIONS(2965),
    [aux_sym_preproc_if_token1] = ACTIONS(2965),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(2965),
    [sym_interpolation_verbatim_start] = ACTIONS(2965),
    [sym_interpolation_raw_start] = ACTIONS(2965),
  },
  [2644] = {
    [sym_preproc_region] = STATE(2644),
    [sym_preproc_endregion] = STATE(2644),
    [sym_preproc_line] = STATE(2644),
    [sym_preproc_pragma] = STATE(2644),
    [sym_preproc_nullable] = STATE(2644),
    [sym_preproc_error] = STATE(2644),
    [sym_preproc_define] = STATE(2644),
    [sym_preproc_undef] = STATE(2644),
    [sym__identifier_token] = ACTIONS(3397),
    [anon_sym_extern] = ACTIONS(3397),
    [anon_sym_alias] = ACTIONS(3397),
    [anon_sym_SEMI] = ACTIONS(3399),
    [anon_sym_global] = ACTIONS(3397),
    [anon_sym_using] = ACTIONS(3397),
    [anon_sym_unsafe] = ACTIONS(3397),
    [anon_sym_static] = ACTIONS(3397),
    [anon_sym_LBRACK] = ACTIONS(3399),
    [anon_sym_LPAREN] = ACTIONS(3399),
    [anon_sym_return] = ACTIONS(3397),
    [anon_sym_ref] = ACTIONS(3397),
    [anon_sym_LBRACE] = ACTIONS(3399),
    [anon_sym_RBRACE] = ACTIONS(3399),
    [anon_sym_delegate] = ACTIONS(3397),
    [anon_sym_abstract] = ACTIONS(3397),
    [anon_sym_async] = ACTIONS(3397),
    [anon_sym_const] = ACTIONS(3397),
    [anon_sym_file] = ACTIONS(3397),
    [anon_sym_fixed] = ACTIONS(3397),
    [anon_sym_internal] = ACTIONS(3397),
    [anon_sym_new] = ACTIONS(3397),
    [anon_sym_override] = ACTIONS(3397),
    [anon_sym_partial] = ACTIONS(3397),
    [anon_sym_private] = ACTIONS(3397),
    [anon_sym_protected] = ACTIONS(3397),
    [anon_sym_public] = ACTIONS(3397),
    [anon_sym_readonly] = ACTIONS(3397),
    [anon_sym_required] = ACTIONS(3397),
    [anon_sym_sealed] = ACTIONS(3397),
    [anon_sym_virtual] = ACTIONS(3397),
    [anon_sym_volatile] = ACTIONS(3397),
    [anon_sym_where] = ACTIONS(3397),
    [anon_sym_notnull] = ACTIONS(3397),
    [anon_sym_unmanaged] = ACTIONS(3397),
    [anon_sym_checked] = ACTIONS(3397),
    [anon_sym_BANG] = ACTIONS(3399),
    [anon_sym_TILDE] = ACTIONS(3399),
    [anon_sym_PLUS_PLUS] = ACTIONS(3399),
    [anon_sym_DASH_DASH] = ACTIONS(3399),
    [anon_sym_true] = ACTIONS(3397),
    [anon_sym_false] = ACTIONS(3397),
    [anon_sym_PLUS] = ACTIONS(3397),
    [anon_sym_DASH] = ACTIONS(3397),
    [anon_sym_STAR] = ACTIONS(3399),
    [anon_sym_CARET] = ACTIONS(3399),
    [anon_sym_AMP] = ACTIONS(3399),
    [anon_sym_this] = ACTIONS(3397),
    [anon_sym_scoped] = ACTIONS(3397),
    [anon_sym_var] = ACTIONS(3397),
    [sym_predefined_type] = ACTIONS(3397),
    [anon_sym_break] = ACTIONS(3397),
    [anon_sym_unchecked] = ACTIONS(3397),
    [anon_sym_continue] = ACTIONS(3397),
    [anon_sym_do] = ACTIONS(3397),
    [anon_sym_while] = ACTIONS(3397),
    [anon_sym_for] = ACTIONS(3397),
    [anon_sym_lock] = ACTIONS(3397),
    [anon_sym_yield] = ACTIONS(3397),
    [anon_sym_switch] = ACTIONS(3397),
    [anon_sym_case] = ACTIONS(3397),
    [anon_sym_default] = ACTIONS(3397),
    [anon_sym_throw] = ACTIONS(3397),
    [anon_sym_try] = ACTIONS(3397),
    [anon_sym_when] = ACTIONS(3397),
    [anon_sym_await] = ACTIONS(3397),
    [anon_sym_foreach] = ACTIONS(3397),
    [anon_sym_goto] = ACTIONS(3397),
    [anon_sym_if] = ACTIONS(3397),
    [anon_sym_else] = ACTIONS(3397),
    [anon_sym_DOT_DOT] = ACTIONS(3399),
    [anon_sym_from] = ACTIONS(3397),
    [anon_sym_into] = ACTIONS(3397),
    [anon_sym_join] = ACTIONS(3397),
    [anon_sym_on] = ACTIONS(3397),
    [anon_sym_equals] = ACTIONS(3397),
    [anon_sym_let] = ACTIONS(3397),
    [anon_sym_orderby] = ACTIONS(3397),
    [anon_sym_ascending] = ACTIONS(3397),
    [anon_sym_descending] = ACTIONS(3397),
    [anon_sym_group] = ACTIONS(3397),
    [anon_sym_by] = ACTIONS(3397),
    [anon_sym_select] = ACTIONS(3397),
    [anon_sym_DQUOTE] = ACTIONS(3397),
    [anon_sym_stackalloc] = ACTIONS(3397),
    [anon_sym_sizeof] = ACTIONS(3397),
    [anon_sym_typeof] = ACTIONS(3397),
    [anon_sym___makeref] = ACTIONS(3397),
    [anon_sym___reftype] = ACTIONS(3397),
    [anon_sym___refvalue] = ACTIONS(3397),
    [sym_null_literal] = ACTIONS(3397),
    [anon_sym_SQUOTE] = ACTIONS(3399),
    [sym_integer_literal] = ACTIONS(3397),
    [sym_real_literal] = ACTIONS(3399),
    [sym_verbatim_string_literal] = ACTIONS(3399),
    [sym_raw_string_literal] = ACTIONS(3399),
    [aux_sym_preproc_if_token1] = ACTIONS(3399),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3399),
    [sym_interpolation_verbatim_start] = ACTIONS(3399),
    [sym_interpolation_raw_start] = ACTIONS(3399),
  },
  [2645] = {
    [sym_preproc_region] = STATE(2645),
    [sym_preproc_endregion] = STATE(2645),
    [sym_preproc_line] = STATE(2645),
    [sym_preproc_pragma] = STATE(2645),
    [sym_preproc_nullable] = STATE(2645),
    [sym_preproc_error] = STATE(2645),
    [sym_preproc_define] = STATE(2645),
    [sym_preproc_undef] = STATE(2645),
    [sym__identifier_token] = ACTIONS(3187),
    [anon_sym_extern] = ACTIONS(3187),
    [anon_sym_alias] = ACTIONS(3187),
    [anon_sym_SEMI] = ACTIONS(3189),
    [anon_sym_global] = ACTIONS(3187),
    [anon_sym_using] = ACTIONS(3187),
    [anon_sym_unsafe] = ACTIONS(3187),
    [anon_sym_static] = ACTIONS(3187),
    [anon_sym_LBRACK] = ACTIONS(3189),
    [anon_sym_LPAREN] = ACTIONS(3189),
    [anon_sym_return] = ACTIONS(3187),
    [anon_sym_ref] = ACTIONS(3187),
    [anon_sym_LBRACE] = ACTIONS(3189),
    [anon_sym_RBRACE] = ACTIONS(3189),
    [anon_sym_delegate] = ACTIONS(3187),
    [anon_sym_abstract] = ACTIONS(3187),
    [anon_sym_async] = ACTIONS(3187),
    [anon_sym_const] = ACTIONS(3187),
    [anon_sym_file] = ACTIONS(3187),
    [anon_sym_fixed] = ACTIONS(3187),
    [anon_sym_internal] = ACTIONS(3187),
    [anon_sym_new] = ACTIONS(3187),
    [anon_sym_override] = ACTIONS(3187),
    [anon_sym_partial] = ACTIONS(3187),
    [anon_sym_private] = ACTIONS(3187),
    [anon_sym_protected] = ACTIONS(3187),
    [anon_sym_public] = ACTIONS(3187),
    [anon_sym_readonly] = ACTIONS(3187),
    [anon_sym_required] = ACTIONS(3187),
    [anon_sym_sealed] = ACTIONS(3187),
    [anon_sym_virtual] = ACTIONS(3187),
    [anon_sym_volatile] = ACTIONS(3187),
    [anon_sym_where] = ACTIONS(3187),
    [anon_sym_notnull] = ACTIONS(3187),
    [anon_sym_unmanaged] = ACTIONS(3187),
    [anon_sym_checked] = ACTIONS(3187),
    [anon_sym_BANG] = ACTIONS(3189),
    [anon_sym_TILDE] = ACTIONS(3189),
    [anon_sym_PLUS_PLUS] = ACTIONS(3189),
    [anon_sym_DASH_DASH] = ACTIONS(3189),
    [anon_sym_true] = ACTIONS(3187),
    [anon_sym_false] = ACTIONS(3187),
    [anon_sym_PLUS] = ACTIONS(3187),
    [anon_sym_DASH] = ACTIONS(3187),
    [anon_sym_STAR] = ACTIONS(3189),
    [anon_sym_CARET] = ACTIONS(3189),
    [anon_sym_AMP] = ACTIONS(3189),
    [anon_sym_this] = ACTIONS(3187),
    [anon_sym_scoped] = ACTIONS(3187),
    [anon_sym_var] = ACTIONS(3187),
    [sym_predefined_type] = ACTIONS(3187),
    [anon_sym_break] = ACTIONS(3187),
    [anon_sym_unchecked] = ACTIONS(3187),
    [anon_sym_continue] = ACTIONS(3187),
    [anon_sym_do] = ACTIONS(3187),
    [anon_sym_while] = ACTIONS(3187),
    [anon_sym_for] = ACTIONS(3187),
    [anon_sym_lock] = ACTIONS(3187),
    [anon_sym_yield] = ACTIONS(3187),
    [anon_sym_switch] = ACTIONS(3187),
    [anon_sym_case] = ACTIONS(3187),
    [anon_sym_default] = ACTIONS(3187),
    [anon_sym_throw] = ACTIONS(3187),
    [anon_sym_try] = ACTIONS(3187),
    [anon_sym_when] = ACTIONS(3187),
    [anon_sym_await] = ACTIONS(3187),
    [anon_sym_foreach] = ACTIONS(3187),
    [anon_sym_goto] = ACTIONS(3187),
    [anon_sym_if] = ACTIONS(3187),
    [anon_sym_else] = ACTIONS(3187),
    [anon_sym_DOT_DOT] = ACTIONS(3189),
    [anon_sym_from] = ACTIONS(3187),
    [anon_sym_into] = ACTIONS(3187),
    [anon_sym_join] = ACTIONS(3187),
    [anon_sym_on] = ACTIONS(3187),
    [anon_sym_equals] = ACTIONS(3187),
    [anon_sym_let] = ACTIONS(3187),
    [anon_sym_orderby] = ACTIONS(3187),
    [anon_sym_ascending] = ACTIONS(3187),
    [anon_sym_descending] = ACTIONS(3187),
    [anon_sym_group] = ACTIONS(3187),
    [anon_sym_by] = ACTIONS(3187),
    [anon_sym_select] = ACTIONS(3187),
    [anon_sym_DQUOTE] = ACTIONS(3187),
    [anon_sym_stackalloc] = ACTIONS(3187),
    [anon_sym_sizeof] = ACTIONS(3187),
    [anon_sym_typeof] = ACTIONS(3187),
    [anon_sym___makeref] = ACTIONS(3187),
    [anon_sym___reftype] = ACTIONS(3187),
    [anon_sym___refvalue] = ACTIONS(3187),
    [sym_null_literal] = ACTIONS(3187),
    [anon_sym_SQUOTE] = ACTIONS(3189),
    [sym_integer_literal] = ACTIONS(3187),
    [sym_real_literal] = ACTIONS(3189),
    [sym_verbatim_string_literal] = ACTIONS(3189),
    [sym_raw_string_literal] = ACTIONS(3189),
    [aux_sym_preproc_if_token1] = ACTIONS(3189),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3189),
    [sym_interpolation_verbatim_start] = ACTIONS(3189),
    [sym_interpolation_raw_start] = ACTIONS(3189),
  },
  [2646] = {
    [sym_preproc_region] = STATE(2646),
    [sym_preproc_endregion] = STATE(2646),
    [sym_preproc_line] = STATE(2646),
    [sym_preproc_pragma] = STATE(2646),
    [sym_preproc_nullable] = STATE(2646),
    [sym_preproc_error] = STATE(2646),
    [sym_preproc_define] = STATE(2646),
    [sym_preproc_undef] = STATE(2646),
    [sym__identifier_token] = ACTIONS(3097),
    [anon_sym_extern] = ACTIONS(3097),
    [anon_sym_alias] = ACTIONS(3097),
    [anon_sym_SEMI] = ACTIONS(3099),
    [anon_sym_global] = ACTIONS(3097),
    [anon_sym_using] = ACTIONS(3097),
    [anon_sym_unsafe] = ACTIONS(3097),
    [anon_sym_static] = ACTIONS(3097),
    [anon_sym_LBRACK] = ACTIONS(3099),
    [anon_sym_LPAREN] = ACTIONS(3099),
    [anon_sym_return] = ACTIONS(3097),
    [anon_sym_ref] = ACTIONS(3097),
    [anon_sym_LBRACE] = ACTIONS(3099),
    [anon_sym_RBRACE] = ACTIONS(3099),
    [anon_sym_delegate] = ACTIONS(3097),
    [anon_sym_abstract] = ACTIONS(3097),
    [anon_sym_async] = ACTIONS(3097),
    [anon_sym_const] = ACTIONS(3097),
    [anon_sym_file] = ACTIONS(3097),
    [anon_sym_fixed] = ACTIONS(3097),
    [anon_sym_internal] = ACTIONS(3097),
    [anon_sym_new] = ACTIONS(3097),
    [anon_sym_override] = ACTIONS(3097),
    [anon_sym_partial] = ACTIONS(3097),
    [anon_sym_private] = ACTIONS(3097),
    [anon_sym_protected] = ACTIONS(3097),
    [anon_sym_public] = ACTIONS(3097),
    [anon_sym_readonly] = ACTIONS(3097),
    [anon_sym_required] = ACTIONS(3097),
    [anon_sym_sealed] = ACTIONS(3097),
    [anon_sym_virtual] = ACTIONS(3097),
    [anon_sym_volatile] = ACTIONS(3097),
    [anon_sym_where] = ACTIONS(3097),
    [anon_sym_notnull] = ACTIONS(3097),
    [anon_sym_unmanaged] = ACTIONS(3097),
    [anon_sym_checked] = ACTIONS(3097),
    [anon_sym_BANG] = ACTIONS(3099),
    [anon_sym_TILDE] = ACTIONS(3099),
    [anon_sym_PLUS_PLUS] = ACTIONS(3099),
    [anon_sym_DASH_DASH] = ACTIONS(3099),
    [anon_sym_true] = ACTIONS(3097),
    [anon_sym_false] = ACTIONS(3097),
    [anon_sym_PLUS] = ACTIONS(3097),
    [anon_sym_DASH] = ACTIONS(3097),
    [anon_sym_STAR] = ACTIONS(3099),
    [anon_sym_CARET] = ACTIONS(3099),
    [anon_sym_AMP] = ACTIONS(3099),
    [anon_sym_this] = ACTIONS(3097),
    [anon_sym_scoped] = ACTIONS(3097),
    [anon_sym_var] = ACTIONS(3097),
    [sym_predefined_type] = ACTIONS(3097),
    [anon_sym_break] = ACTIONS(3097),
    [anon_sym_unchecked] = ACTIONS(3097),
    [anon_sym_continue] = ACTIONS(3097),
    [anon_sym_do] = ACTIONS(3097),
    [anon_sym_while] = ACTIONS(3097),
    [anon_sym_for] = ACTIONS(3097),
    [anon_sym_lock] = ACTIONS(3097),
    [anon_sym_yield] = ACTIONS(3097),
    [anon_sym_switch] = ACTIONS(3097),
    [anon_sym_case] = ACTIONS(3097),
    [anon_sym_default] = ACTIONS(3097),
    [anon_sym_throw] = ACTIONS(3097),
    [anon_sym_try] = ACTIONS(3097),
    [anon_sym_when] = ACTIONS(3097),
    [anon_sym_await] = ACTIONS(3097),
    [anon_sym_foreach] = ACTIONS(3097),
    [anon_sym_goto] = ACTIONS(3097),
    [anon_sym_if] = ACTIONS(3097),
    [anon_sym_else] = ACTIONS(3097),
    [anon_sym_DOT_DOT] = ACTIONS(3099),
    [anon_sym_from] = ACTIONS(3097),
    [anon_sym_into] = ACTIONS(3097),
    [anon_sym_join] = ACTIONS(3097),
    [anon_sym_on] = ACTIONS(3097),
    [anon_sym_equals] = ACTIONS(3097),
    [anon_sym_let] = ACTIONS(3097),
    [anon_sym_orderby] = ACTIONS(3097),
    [anon_sym_ascending] = ACTIONS(3097),
    [anon_sym_descending] = ACTIONS(3097),
    [anon_sym_group] = ACTIONS(3097),
    [anon_sym_by] = ACTIONS(3097),
    [anon_sym_select] = ACTIONS(3097),
    [anon_sym_DQUOTE] = ACTIONS(3097),
    [anon_sym_stackalloc] = ACTIONS(3097),
    [anon_sym_sizeof] = ACTIONS(3097),
    [anon_sym_typeof] = ACTIONS(3097),
    [anon_sym___makeref] = ACTIONS(3097),
    [anon_sym___reftype] = ACTIONS(3097),
    [anon_sym___refvalue] = ACTIONS(3097),
    [sym_null_literal] = ACTIONS(3097),
    [anon_sym_SQUOTE] = ACTIONS(3099),
    [sym_integer_literal] = ACTIONS(3097),
    [sym_real_literal] = ACTIONS(3099),
    [sym_verbatim_string_literal] = ACTIONS(3099),
    [sym_raw_string_literal] = ACTIONS(3099),
    [aux_sym_preproc_if_token1] = ACTIONS(3099),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3099),
    [sym_interpolation_verbatim_start] = ACTIONS(3099),
    [sym_interpolation_raw_start] = ACTIONS(3099),
  },
  [2647] = {
    [sym_preproc_region] = STATE(2647),
    [sym_preproc_endregion] = STATE(2647),
    [sym_preproc_line] = STATE(2647),
    [sym_preproc_pragma] = STATE(2647),
    [sym_preproc_nullable] = STATE(2647),
    [sym_preproc_error] = STATE(2647),
    [sym_preproc_define] = STATE(2647),
    [sym_preproc_undef] = STATE(2647),
    [sym__identifier_token] = ACTIONS(3065),
    [anon_sym_extern] = ACTIONS(3065),
    [anon_sym_alias] = ACTIONS(3065),
    [anon_sym_SEMI] = ACTIONS(3067),
    [anon_sym_global] = ACTIONS(3065),
    [anon_sym_using] = ACTIONS(3065),
    [anon_sym_unsafe] = ACTIONS(3065),
    [anon_sym_static] = ACTIONS(3065),
    [anon_sym_LBRACK] = ACTIONS(3067),
    [anon_sym_LPAREN] = ACTIONS(3067),
    [anon_sym_return] = ACTIONS(3065),
    [anon_sym_ref] = ACTIONS(3065),
    [anon_sym_LBRACE] = ACTIONS(3067),
    [anon_sym_RBRACE] = ACTIONS(3067),
    [anon_sym_delegate] = ACTIONS(3065),
    [anon_sym_abstract] = ACTIONS(3065),
    [anon_sym_async] = ACTIONS(3065),
    [anon_sym_const] = ACTIONS(3065),
    [anon_sym_file] = ACTIONS(3065),
    [anon_sym_fixed] = ACTIONS(3065),
    [anon_sym_internal] = ACTIONS(3065),
    [anon_sym_new] = ACTIONS(3065),
    [anon_sym_override] = ACTIONS(3065),
    [anon_sym_partial] = ACTIONS(3065),
    [anon_sym_private] = ACTIONS(3065),
    [anon_sym_protected] = ACTIONS(3065),
    [anon_sym_public] = ACTIONS(3065),
    [anon_sym_readonly] = ACTIONS(3065),
    [anon_sym_required] = ACTIONS(3065),
    [anon_sym_sealed] = ACTIONS(3065),
    [anon_sym_virtual] = ACTIONS(3065),
    [anon_sym_volatile] = ACTIONS(3065),
    [anon_sym_where] = ACTIONS(3065),
    [anon_sym_notnull] = ACTIONS(3065),
    [anon_sym_unmanaged] = ACTIONS(3065),
    [anon_sym_checked] = ACTIONS(3065),
    [anon_sym_BANG] = ACTIONS(3067),
    [anon_sym_TILDE] = ACTIONS(3067),
    [anon_sym_PLUS_PLUS] = ACTIONS(3067),
    [anon_sym_DASH_DASH] = ACTIONS(3067),
    [anon_sym_true] = ACTIONS(3065),
    [anon_sym_false] = ACTIONS(3065),
    [anon_sym_PLUS] = ACTIONS(3065),
    [anon_sym_DASH] = ACTIONS(3065),
    [anon_sym_STAR] = ACTIONS(3067),
    [anon_sym_CARET] = ACTIONS(3067),
    [anon_sym_AMP] = ACTIONS(3067),
    [anon_sym_this] = ACTIONS(3065),
    [anon_sym_scoped] = ACTIONS(3065),
    [anon_sym_var] = ACTIONS(3065),
    [sym_predefined_type] = ACTIONS(3065),
    [anon_sym_break] = ACTIONS(3065),
    [anon_sym_unchecked] = ACTIONS(3065),
    [anon_sym_continue] = ACTIONS(3065),
    [anon_sym_do] = ACTIONS(3065),
    [anon_sym_while] = ACTIONS(3065),
    [anon_sym_for] = ACTIONS(3065),
    [anon_sym_lock] = ACTIONS(3065),
    [anon_sym_yield] = ACTIONS(3065),
    [anon_sym_switch] = ACTIONS(3065),
    [anon_sym_case] = ACTIONS(3065),
    [anon_sym_default] = ACTIONS(3065),
    [anon_sym_throw] = ACTIONS(3065),
    [anon_sym_try] = ACTIONS(3065),
    [anon_sym_when] = ACTIONS(3065),
    [anon_sym_await] = ACTIONS(3065),
    [anon_sym_foreach] = ACTIONS(3065),
    [anon_sym_goto] = ACTIONS(3065),
    [anon_sym_if] = ACTIONS(3065),
    [anon_sym_else] = ACTIONS(3065),
    [anon_sym_DOT_DOT] = ACTIONS(3067),
    [anon_sym_from] = ACTIONS(3065),
    [anon_sym_into] = ACTIONS(3065),
    [anon_sym_join] = ACTIONS(3065),
    [anon_sym_on] = ACTIONS(3065),
    [anon_sym_equals] = ACTIONS(3065),
    [anon_sym_let] = ACTIONS(3065),
    [anon_sym_orderby] = ACTIONS(3065),
    [anon_sym_ascending] = ACTIONS(3065),
    [anon_sym_descending] = ACTIONS(3065),
    [anon_sym_group] = ACTIONS(3065),
    [anon_sym_by] = ACTIONS(3065),
    [anon_sym_select] = ACTIONS(3065),
    [anon_sym_DQUOTE] = ACTIONS(3065),
    [anon_sym_stackalloc] = ACTIONS(3065),
    [anon_sym_sizeof] = ACTIONS(3065),
    [anon_sym_typeof] = ACTIONS(3065),
    [anon_sym___makeref] = ACTIONS(3065),
    [anon_sym___reftype] = ACTIONS(3065),
    [anon_sym___refvalue] = ACTIONS(3065),
    [sym_null_literal] = ACTIONS(3065),
    [anon_sym_SQUOTE] = ACTIONS(3067),
    [sym_integer_literal] = ACTIONS(3065),
    [sym_real_literal] = ACTIONS(3067),
    [sym_verbatim_string_literal] = ACTIONS(3067),
    [sym_raw_string_literal] = ACTIONS(3067),
    [aux_sym_preproc_if_token1] = ACTIONS(3067),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3067),
    [sym_interpolation_verbatim_start] = ACTIONS(3067),
    [sym_interpolation_raw_start] = ACTIONS(3067),
  },
  [2648] = {
    [sym_preproc_region] = STATE(2648),
    [sym_preproc_endregion] = STATE(2648),
    [sym_preproc_line] = STATE(2648),
    [sym_preproc_pragma] = STATE(2648),
    [sym_preproc_nullable] = STATE(2648),
    [sym_preproc_error] = STATE(2648),
    [sym_preproc_define] = STATE(2648),
    [sym_preproc_undef] = STATE(2648),
    [sym__identifier_token] = ACTIONS(3211),
    [anon_sym_extern] = ACTIONS(3211),
    [anon_sym_alias] = ACTIONS(3211),
    [anon_sym_SEMI] = ACTIONS(3213),
    [anon_sym_global] = ACTIONS(3211),
    [anon_sym_using] = ACTIONS(3211),
    [anon_sym_unsafe] = ACTIONS(3211),
    [anon_sym_static] = ACTIONS(3211),
    [anon_sym_LBRACK] = ACTIONS(3213),
    [anon_sym_LPAREN] = ACTIONS(3213),
    [anon_sym_return] = ACTIONS(3211),
    [anon_sym_ref] = ACTIONS(3211),
    [anon_sym_LBRACE] = ACTIONS(3213),
    [anon_sym_RBRACE] = ACTIONS(3213),
    [anon_sym_delegate] = ACTIONS(3211),
    [anon_sym_abstract] = ACTIONS(3211),
    [anon_sym_async] = ACTIONS(3211),
    [anon_sym_const] = ACTIONS(3211),
    [anon_sym_file] = ACTIONS(3211),
    [anon_sym_fixed] = ACTIONS(3211),
    [anon_sym_internal] = ACTIONS(3211),
    [anon_sym_new] = ACTIONS(3211),
    [anon_sym_override] = ACTIONS(3211),
    [anon_sym_partial] = ACTIONS(3211),
    [anon_sym_private] = ACTIONS(3211),
    [anon_sym_protected] = ACTIONS(3211),
    [anon_sym_public] = ACTIONS(3211),
    [anon_sym_readonly] = ACTIONS(3211),
    [anon_sym_required] = ACTIONS(3211),
    [anon_sym_sealed] = ACTIONS(3211),
    [anon_sym_virtual] = ACTIONS(3211),
    [anon_sym_volatile] = ACTIONS(3211),
    [anon_sym_where] = ACTIONS(3211),
    [anon_sym_notnull] = ACTIONS(3211),
    [anon_sym_unmanaged] = ACTIONS(3211),
    [anon_sym_checked] = ACTIONS(3211),
    [anon_sym_BANG] = ACTIONS(3213),
    [anon_sym_TILDE] = ACTIONS(3213),
    [anon_sym_PLUS_PLUS] = ACTIONS(3213),
    [anon_sym_DASH_DASH] = ACTIONS(3213),
    [anon_sym_true] = ACTIONS(3211),
    [anon_sym_false] = ACTIONS(3211),
    [anon_sym_PLUS] = ACTIONS(3211),
    [anon_sym_DASH] = ACTIONS(3211),
    [anon_sym_STAR] = ACTIONS(3213),
    [anon_sym_CARET] = ACTIONS(3213),
    [anon_sym_AMP] = ACTIONS(3213),
    [anon_sym_this] = ACTIONS(3211),
    [anon_sym_scoped] = ACTIONS(3211),
    [anon_sym_var] = ACTIONS(3211),
    [sym_predefined_type] = ACTIONS(3211),
    [anon_sym_break] = ACTIONS(3211),
    [anon_sym_unchecked] = ACTIONS(3211),
    [anon_sym_continue] = ACTIONS(3211),
    [anon_sym_do] = ACTIONS(3211),
    [anon_sym_while] = ACTIONS(3211),
    [anon_sym_for] = ACTIONS(3211),
    [anon_sym_lock] = ACTIONS(3211),
    [anon_sym_yield] = ACTIONS(3211),
    [anon_sym_switch] = ACTIONS(3211),
    [anon_sym_case] = ACTIONS(3211),
    [anon_sym_default] = ACTIONS(3211),
    [anon_sym_throw] = ACTIONS(3211),
    [anon_sym_try] = ACTIONS(3211),
    [anon_sym_when] = ACTIONS(3211),
    [anon_sym_await] = ACTIONS(3211),
    [anon_sym_foreach] = ACTIONS(3211),
    [anon_sym_goto] = ACTIONS(3211),
    [anon_sym_if] = ACTIONS(3211),
    [anon_sym_else] = ACTIONS(3211),
    [anon_sym_DOT_DOT] = ACTIONS(3213),
    [anon_sym_from] = ACTIONS(3211),
    [anon_sym_into] = ACTIONS(3211),
    [anon_sym_join] = ACTIONS(3211),
    [anon_sym_on] = ACTIONS(3211),
    [anon_sym_equals] = ACTIONS(3211),
    [anon_sym_let] = ACTIONS(3211),
    [anon_sym_orderby] = ACTIONS(3211),
    [anon_sym_ascending] = ACTIONS(3211),
    [anon_sym_descending] = ACTIONS(3211),
    [anon_sym_group] = ACTIONS(3211),
    [anon_sym_by] = ACTIONS(3211),
    [anon_sym_select] = ACTIONS(3211),
    [anon_sym_DQUOTE] = ACTIONS(3211),
    [anon_sym_stackalloc] = ACTIONS(3211),
    [anon_sym_sizeof] = ACTIONS(3211),
    [anon_sym_typeof] = ACTIONS(3211),
    [anon_sym___makeref] = ACTIONS(3211),
    [anon_sym___reftype] = ACTIONS(3211),
    [anon_sym___refvalue] = ACTIONS(3211),
    [sym_null_literal] = ACTIONS(3211),
    [anon_sym_SQUOTE] = ACTIONS(3213),
    [sym_integer_literal] = ACTIONS(3211),
    [sym_real_literal] = ACTIONS(3213),
    [sym_verbatim_string_literal] = ACTIONS(3213),
    [sym_raw_string_literal] = ACTIONS(3213),
    [aux_sym_preproc_if_token1] = ACTIONS(3213),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3213),
    [sym_interpolation_verbatim_start] = ACTIONS(3213),
    [sym_interpolation_raw_start] = ACTIONS(3213),
  },
  [2649] = {
    [sym_preproc_region] = STATE(2649),
    [sym_preproc_endregion] = STATE(2649),
    [sym_preproc_line] = STATE(2649),
    [sym_preproc_pragma] = STATE(2649),
    [sym_preproc_nullable] = STATE(2649),
    [sym_preproc_error] = STATE(2649),
    [sym_preproc_define] = STATE(2649),
    [sym_preproc_undef] = STATE(2649),
    [sym__identifier_token] = ACTIONS(3327),
    [anon_sym_extern] = ACTIONS(3327),
    [anon_sym_alias] = ACTIONS(3327),
    [anon_sym_SEMI] = ACTIONS(3329),
    [anon_sym_global] = ACTIONS(3327),
    [anon_sym_using] = ACTIONS(3327),
    [anon_sym_unsafe] = ACTIONS(3327),
    [anon_sym_static] = ACTIONS(3327),
    [anon_sym_LBRACK] = ACTIONS(3329),
    [anon_sym_LPAREN] = ACTIONS(3329),
    [anon_sym_return] = ACTIONS(3327),
    [anon_sym_ref] = ACTIONS(3327),
    [anon_sym_LBRACE] = ACTIONS(3329),
    [anon_sym_RBRACE] = ACTIONS(3329),
    [anon_sym_delegate] = ACTIONS(3327),
    [anon_sym_abstract] = ACTIONS(3327),
    [anon_sym_async] = ACTIONS(3327),
    [anon_sym_const] = ACTIONS(3327),
    [anon_sym_file] = ACTIONS(3327),
    [anon_sym_fixed] = ACTIONS(3327),
    [anon_sym_internal] = ACTIONS(3327),
    [anon_sym_new] = ACTIONS(3327),
    [anon_sym_override] = ACTIONS(3327),
    [anon_sym_partial] = ACTIONS(3327),
    [anon_sym_private] = ACTIONS(3327),
    [anon_sym_protected] = ACTIONS(3327),
    [anon_sym_public] = ACTIONS(3327),
    [anon_sym_readonly] = ACTIONS(3327),
    [anon_sym_required] = ACTIONS(3327),
    [anon_sym_sealed] = ACTIONS(3327),
    [anon_sym_virtual] = ACTIONS(3327),
    [anon_sym_volatile] = ACTIONS(3327),
    [anon_sym_where] = ACTIONS(3327),
    [anon_sym_notnull] = ACTIONS(3327),
    [anon_sym_unmanaged] = ACTIONS(3327),
    [anon_sym_checked] = ACTIONS(3327),
    [anon_sym_BANG] = ACTIONS(3329),
    [anon_sym_TILDE] = ACTIONS(3329),
    [anon_sym_PLUS_PLUS] = ACTIONS(3329),
    [anon_sym_DASH_DASH] = ACTIONS(3329),
    [anon_sym_true] = ACTIONS(3327),
    [anon_sym_false] = ACTIONS(3327),
    [anon_sym_PLUS] = ACTIONS(3327),
    [anon_sym_DASH] = ACTIONS(3327),
    [anon_sym_STAR] = ACTIONS(3329),
    [anon_sym_CARET] = ACTIONS(3329),
    [anon_sym_AMP] = ACTIONS(3329),
    [anon_sym_this] = ACTIONS(3327),
    [anon_sym_scoped] = ACTIONS(3327),
    [anon_sym_var] = ACTIONS(3327),
    [sym_predefined_type] = ACTIONS(3327),
    [anon_sym_break] = ACTIONS(3327),
    [anon_sym_unchecked] = ACTIONS(3327),
    [anon_sym_continue] = ACTIONS(3327),
    [anon_sym_do] = ACTIONS(3327),
    [anon_sym_while] = ACTIONS(3327),
    [anon_sym_for] = ACTIONS(3327),
    [anon_sym_lock] = ACTIONS(3327),
    [anon_sym_yield] = ACTIONS(3327),
    [anon_sym_switch] = ACTIONS(3327),
    [anon_sym_case] = ACTIONS(3327),
    [anon_sym_default] = ACTIONS(3327),
    [anon_sym_throw] = ACTIONS(3327),
    [anon_sym_try] = ACTIONS(3327),
    [anon_sym_when] = ACTIONS(3327),
    [anon_sym_await] = ACTIONS(3327),
    [anon_sym_foreach] = ACTIONS(3327),
    [anon_sym_goto] = ACTIONS(3327),
    [anon_sym_if] = ACTIONS(3327),
    [anon_sym_else] = ACTIONS(3327),
    [anon_sym_DOT_DOT] = ACTIONS(3329),
    [anon_sym_from] = ACTIONS(3327),
    [anon_sym_into] = ACTIONS(3327),
    [anon_sym_join] = ACTIONS(3327),
    [anon_sym_on] = ACTIONS(3327),
    [anon_sym_equals] = ACTIONS(3327),
    [anon_sym_let] = ACTIONS(3327),
    [anon_sym_orderby] = ACTIONS(3327),
    [anon_sym_ascending] = ACTIONS(3327),
    [anon_sym_descending] = ACTIONS(3327),
    [anon_sym_group] = ACTIONS(3327),
    [anon_sym_by] = ACTIONS(3327),
    [anon_sym_select] = ACTIONS(3327),
    [anon_sym_DQUOTE] = ACTIONS(3327),
    [anon_sym_stackalloc] = ACTIONS(3327),
    [anon_sym_sizeof] = ACTIONS(3327),
    [anon_sym_typeof] = ACTIONS(3327),
    [anon_sym___makeref] = ACTIONS(3327),
    [anon_sym___reftype] = ACTIONS(3327),
    [anon_sym___refvalue] = ACTIONS(3327),
    [sym_null_literal] = ACTIONS(3327),
    [anon_sym_SQUOTE] = ACTIONS(3329),
    [sym_integer_literal] = ACTIONS(3327),
    [sym_real_literal] = ACTIONS(3329),
    [sym_verbatim_string_literal] = ACTIONS(3329),
    [sym_raw_string_literal] = ACTIONS(3329),
    [aux_sym_preproc_if_token1] = ACTIONS(3329),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3329),
    [sym_interpolation_verbatim_start] = ACTIONS(3329),
    [sym_interpolation_raw_start] = ACTIONS(3329),
  },
  [2650] = {
    [sym_preproc_region] = STATE(2650),
    [sym_preproc_endregion] = STATE(2650),
    [sym_preproc_line] = STATE(2650),
    [sym_preproc_pragma] = STATE(2650),
    [sym_preproc_nullable] = STATE(2650),
    [sym_preproc_error] = STATE(2650),
    [sym_preproc_define] = STATE(2650),
    [sym_preproc_undef] = STATE(2650),
    [sym__identifier_token] = ACTIONS(3323),
    [anon_sym_extern] = ACTIONS(3323),
    [anon_sym_alias] = ACTIONS(3323),
    [anon_sym_SEMI] = ACTIONS(3325),
    [anon_sym_global] = ACTIONS(3323),
    [anon_sym_using] = ACTIONS(3323),
    [anon_sym_unsafe] = ACTIONS(3323),
    [anon_sym_static] = ACTIONS(3323),
    [anon_sym_LBRACK] = ACTIONS(3325),
    [anon_sym_LPAREN] = ACTIONS(3325),
    [anon_sym_return] = ACTIONS(3323),
    [anon_sym_ref] = ACTIONS(3323),
    [anon_sym_LBRACE] = ACTIONS(3325),
    [anon_sym_RBRACE] = ACTIONS(3325),
    [anon_sym_delegate] = ACTIONS(3323),
    [anon_sym_abstract] = ACTIONS(3323),
    [anon_sym_async] = ACTIONS(3323),
    [anon_sym_const] = ACTIONS(3323),
    [anon_sym_file] = ACTIONS(3323),
    [anon_sym_fixed] = ACTIONS(3323),
    [anon_sym_internal] = ACTIONS(3323),
    [anon_sym_new] = ACTIONS(3323),
    [anon_sym_override] = ACTIONS(3323),
    [anon_sym_partial] = ACTIONS(3323),
    [anon_sym_private] = ACTIONS(3323),
    [anon_sym_protected] = ACTIONS(3323),
    [anon_sym_public] = ACTIONS(3323),
    [anon_sym_readonly] = ACTIONS(3323),
    [anon_sym_required] = ACTIONS(3323),
    [anon_sym_sealed] = ACTIONS(3323),
    [anon_sym_virtual] = ACTIONS(3323),
    [anon_sym_volatile] = ACTIONS(3323),
    [anon_sym_where] = ACTIONS(3323),
    [anon_sym_notnull] = ACTIONS(3323),
    [anon_sym_unmanaged] = ACTIONS(3323),
    [anon_sym_checked] = ACTIONS(3323),
    [anon_sym_BANG] = ACTIONS(3325),
    [anon_sym_TILDE] = ACTIONS(3325),
    [anon_sym_PLUS_PLUS] = ACTIONS(3325),
    [anon_sym_DASH_DASH] = ACTIONS(3325),
    [anon_sym_true] = ACTIONS(3323),
    [anon_sym_false] = ACTIONS(3323),
    [anon_sym_PLUS] = ACTIONS(3323),
    [anon_sym_DASH] = ACTIONS(3323),
    [anon_sym_STAR] = ACTIONS(3325),
    [anon_sym_CARET] = ACTIONS(3325),
    [anon_sym_AMP] = ACTIONS(3325),
    [anon_sym_this] = ACTIONS(3323),
    [anon_sym_scoped] = ACTIONS(3323),
    [anon_sym_var] = ACTIONS(3323),
    [sym_predefined_type] = ACTIONS(3323),
    [anon_sym_break] = ACTIONS(3323),
    [anon_sym_unchecked] = ACTIONS(3323),
    [anon_sym_continue] = ACTIONS(3323),
    [anon_sym_do] = ACTIONS(3323),
    [anon_sym_while] = ACTIONS(3323),
    [anon_sym_for] = ACTIONS(3323),
    [anon_sym_lock] = ACTIONS(3323),
    [anon_sym_yield] = ACTIONS(3323),
    [anon_sym_switch] = ACTIONS(3323),
    [anon_sym_case] = ACTIONS(3323),
    [anon_sym_default] = ACTIONS(3323),
    [anon_sym_throw] = ACTIONS(3323),
    [anon_sym_try] = ACTIONS(3323),
    [anon_sym_when] = ACTIONS(3323),
    [anon_sym_await] = ACTIONS(3323),
    [anon_sym_foreach] = ACTIONS(3323),
    [anon_sym_goto] = ACTIONS(3323),
    [anon_sym_if] = ACTIONS(3323),
    [anon_sym_else] = ACTIONS(3323),
    [anon_sym_DOT_DOT] = ACTIONS(3325),
    [anon_sym_from] = ACTIONS(3323),
    [anon_sym_into] = ACTIONS(3323),
    [anon_sym_join] = ACTIONS(3323),
    [anon_sym_on] = ACTIONS(3323),
    [anon_sym_equals] = ACTIONS(3323),
    [anon_sym_let] = ACTIONS(3323),
    [anon_sym_orderby] = ACTIONS(3323),
    [anon_sym_ascending] = ACTIONS(3323),
    [anon_sym_descending] = ACTIONS(3323),
    [anon_sym_group] = ACTIONS(3323),
    [anon_sym_by] = ACTIONS(3323),
    [anon_sym_select] = ACTIONS(3323),
    [anon_sym_DQUOTE] = ACTIONS(3323),
    [anon_sym_stackalloc] = ACTIONS(3323),
    [anon_sym_sizeof] = ACTIONS(3323),
    [anon_sym_typeof] = ACTIONS(3323),
    [anon_sym___makeref] = ACTIONS(3323),
    [anon_sym___reftype] = ACTIONS(3323),
    [anon_sym___refvalue] = ACTIONS(3323),
    [sym_null_literal] = ACTIONS(3323),
    [anon_sym_SQUOTE] = ACTIONS(3325),
    [sym_integer_literal] = ACTIONS(3323),
    [sym_real_literal] = ACTIONS(3325),
    [sym_verbatim_string_literal] = ACTIONS(3325),
    [sym_raw_string_literal] = ACTIONS(3325),
    [aux_sym_preproc_if_token1] = ACTIONS(3325),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3325),
    [sym_interpolation_verbatim_start] = ACTIONS(3325),
    [sym_interpolation_raw_start] = ACTIONS(3325),
  },
  [2651] = {
    [sym_preproc_region] = STATE(2651),
    [sym_preproc_endregion] = STATE(2651),
    [sym_preproc_line] = STATE(2651),
    [sym_preproc_pragma] = STATE(2651),
    [sym_preproc_nullable] = STATE(2651),
    [sym_preproc_error] = STATE(2651),
    [sym_preproc_define] = STATE(2651),
    [sym_preproc_undef] = STATE(2651),
    [sym__identifier_token] = ACTIONS(3089),
    [anon_sym_extern] = ACTIONS(3089),
    [anon_sym_alias] = ACTIONS(3089),
    [anon_sym_SEMI] = ACTIONS(3091),
    [anon_sym_global] = ACTIONS(3089),
    [anon_sym_using] = ACTIONS(3089),
    [anon_sym_unsafe] = ACTIONS(3089),
    [anon_sym_static] = ACTIONS(3089),
    [anon_sym_LBRACK] = ACTIONS(3091),
    [anon_sym_LPAREN] = ACTIONS(3091),
    [anon_sym_return] = ACTIONS(3089),
    [anon_sym_ref] = ACTIONS(3089),
    [anon_sym_LBRACE] = ACTIONS(3091),
    [anon_sym_RBRACE] = ACTIONS(3091),
    [anon_sym_delegate] = ACTIONS(3089),
    [anon_sym_abstract] = ACTIONS(3089),
    [anon_sym_async] = ACTIONS(3089),
    [anon_sym_const] = ACTIONS(3089),
    [anon_sym_file] = ACTIONS(3089),
    [anon_sym_fixed] = ACTIONS(3089),
    [anon_sym_internal] = ACTIONS(3089),
    [anon_sym_new] = ACTIONS(3089),
    [anon_sym_override] = ACTIONS(3089),
    [anon_sym_partial] = ACTIONS(3089),
    [anon_sym_private] = ACTIONS(3089),
    [anon_sym_protected] = ACTIONS(3089),
    [anon_sym_public] = ACTIONS(3089),
    [anon_sym_readonly] = ACTIONS(3089),
    [anon_sym_required] = ACTIONS(3089),
    [anon_sym_sealed] = ACTIONS(3089),
    [anon_sym_virtual] = ACTIONS(3089),
    [anon_sym_volatile] = ACTIONS(3089),
    [anon_sym_where] = ACTIONS(3089),
    [anon_sym_notnull] = ACTIONS(3089),
    [anon_sym_unmanaged] = ACTIONS(3089),
    [anon_sym_checked] = ACTIONS(3089),
    [anon_sym_BANG] = ACTIONS(3091),
    [anon_sym_TILDE] = ACTIONS(3091),
    [anon_sym_PLUS_PLUS] = ACTIONS(3091),
    [anon_sym_DASH_DASH] = ACTIONS(3091),
    [anon_sym_true] = ACTIONS(3089),
    [anon_sym_false] = ACTIONS(3089),
    [anon_sym_PLUS] = ACTIONS(3089),
    [anon_sym_DASH] = ACTIONS(3089),
    [anon_sym_STAR] = ACTIONS(3091),
    [anon_sym_CARET] = ACTIONS(3091),
    [anon_sym_AMP] = ACTIONS(3091),
    [anon_sym_this] = ACTIONS(3089),
    [anon_sym_scoped] = ACTIONS(3089),
    [anon_sym_var] = ACTIONS(3089),
    [sym_predefined_type] = ACTIONS(3089),
    [anon_sym_break] = ACTIONS(3089),
    [anon_sym_unchecked] = ACTIONS(3089),
    [anon_sym_continue] = ACTIONS(3089),
    [anon_sym_do] = ACTIONS(3089),
    [anon_sym_while] = ACTIONS(3089),
    [anon_sym_for] = ACTIONS(3089),
    [anon_sym_lock] = ACTIONS(3089),
    [anon_sym_yield] = ACTIONS(3089),
    [anon_sym_switch] = ACTIONS(3089),
    [anon_sym_case] = ACTIONS(3089),
    [anon_sym_default] = ACTIONS(3089),
    [anon_sym_throw] = ACTIONS(3089),
    [anon_sym_try] = ACTIONS(3089),
    [anon_sym_when] = ACTIONS(3089),
    [anon_sym_await] = ACTIONS(3089),
    [anon_sym_foreach] = ACTIONS(3089),
    [anon_sym_goto] = ACTIONS(3089),
    [anon_sym_if] = ACTIONS(3089),
    [anon_sym_else] = ACTIONS(3089),
    [anon_sym_DOT_DOT] = ACTIONS(3091),
    [anon_sym_from] = ACTIONS(3089),
    [anon_sym_into] = ACTIONS(3089),
    [anon_sym_join] = ACTIONS(3089),
    [anon_sym_on] = ACTIONS(3089),
    [anon_sym_equals] = ACTIONS(3089),
    [anon_sym_let] = ACTIONS(3089),
    [anon_sym_orderby] = ACTIONS(3089),
    [anon_sym_ascending] = ACTIONS(3089),
    [anon_sym_descending] = ACTIONS(3089),
    [anon_sym_group] = ACTIONS(3089),
    [anon_sym_by] = ACTIONS(3089),
    [anon_sym_select] = ACTIONS(3089),
    [anon_sym_DQUOTE] = ACTIONS(3089),
    [anon_sym_stackalloc] = ACTIONS(3089),
    [anon_sym_sizeof] = ACTIONS(3089),
    [anon_sym_typeof] = ACTIONS(3089),
    [anon_sym___makeref] = ACTIONS(3089),
    [anon_sym___reftype] = ACTIONS(3089),
    [anon_sym___refvalue] = ACTIONS(3089),
    [sym_null_literal] = ACTIONS(3089),
    [anon_sym_SQUOTE] = ACTIONS(3091),
    [sym_integer_literal] = ACTIONS(3089),
    [sym_real_literal] = ACTIONS(3091),
    [sym_verbatim_string_literal] = ACTIONS(3091),
    [sym_raw_string_literal] = ACTIONS(3091),
    [aux_sym_preproc_if_token1] = ACTIONS(3091),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3091),
    [sym_interpolation_verbatim_start] = ACTIONS(3091),
    [sym_interpolation_raw_start] = ACTIONS(3091),
  },
  [2652] = {
    [sym_preproc_region] = STATE(2652),
    [sym_preproc_endregion] = STATE(2652),
    [sym_preproc_line] = STATE(2652),
    [sym_preproc_pragma] = STATE(2652),
    [sym_preproc_nullable] = STATE(2652),
    [sym_preproc_error] = STATE(2652),
    [sym_preproc_define] = STATE(2652),
    [sym_preproc_undef] = STATE(2652),
    [sym__identifier_token] = ACTIONS(3085),
    [anon_sym_extern] = ACTIONS(3085),
    [anon_sym_alias] = ACTIONS(3085),
    [anon_sym_SEMI] = ACTIONS(3087),
    [anon_sym_global] = ACTIONS(3085),
    [anon_sym_using] = ACTIONS(3085),
    [anon_sym_unsafe] = ACTIONS(3085),
    [anon_sym_static] = ACTIONS(3085),
    [anon_sym_LBRACK] = ACTIONS(3087),
    [anon_sym_LPAREN] = ACTIONS(3087),
    [anon_sym_return] = ACTIONS(3085),
    [anon_sym_ref] = ACTIONS(3085),
    [anon_sym_LBRACE] = ACTIONS(3087),
    [anon_sym_RBRACE] = ACTIONS(3087),
    [anon_sym_delegate] = ACTIONS(3085),
    [anon_sym_abstract] = ACTIONS(3085),
    [anon_sym_async] = ACTIONS(3085),
    [anon_sym_const] = ACTIONS(3085),
    [anon_sym_file] = ACTIONS(3085),
    [anon_sym_fixed] = ACTIONS(3085),
    [anon_sym_internal] = ACTIONS(3085),
    [anon_sym_new] = ACTIONS(3085),
    [anon_sym_override] = ACTIONS(3085),
    [anon_sym_partial] = ACTIONS(3085),
    [anon_sym_private] = ACTIONS(3085),
    [anon_sym_protected] = ACTIONS(3085),
    [anon_sym_public] = ACTIONS(3085),
    [anon_sym_readonly] = ACTIONS(3085),
    [anon_sym_required] = ACTIONS(3085),
    [anon_sym_sealed] = ACTIONS(3085),
    [anon_sym_virtual] = ACTIONS(3085),
    [anon_sym_volatile] = ACTIONS(3085),
    [anon_sym_where] = ACTIONS(3085),
    [anon_sym_notnull] = ACTIONS(3085),
    [anon_sym_unmanaged] = ACTIONS(3085),
    [anon_sym_checked] = ACTIONS(3085),
    [anon_sym_BANG] = ACTIONS(3087),
    [anon_sym_TILDE] = ACTIONS(3087),
    [anon_sym_PLUS_PLUS] = ACTIONS(3087),
    [anon_sym_DASH_DASH] = ACTIONS(3087),
    [anon_sym_true] = ACTIONS(3085),
    [anon_sym_false] = ACTIONS(3085),
    [anon_sym_PLUS] = ACTIONS(3085),
    [anon_sym_DASH] = ACTIONS(3085),
    [anon_sym_STAR] = ACTIONS(3087),
    [anon_sym_CARET] = ACTIONS(3087),
    [anon_sym_AMP] = ACTIONS(3087),
    [anon_sym_this] = ACTIONS(3085),
    [anon_sym_scoped] = ACTIONS(3085),
    [anon_sym_var] = ACTIONS(3085),
    [sym_predefined_type] = ACTIONS(3085),
    [anon_sym_break] = ACTIONS(3085),
    [anon_sym_unchecked] = ACTIONS(3085),
    [anon_sym_continue] = ACTIONS(3085),
    [anon_sym_do] = ACTIONS(3085),
    [anon_sym_while] = ACTIONS(3085),
    [anon_sym_for] = ACTIONS(3085),
    [anon_sym_lock] = ACTIONS(3085),
    [anon_sym_yield] = ACTIONS(3085),
    [anon_sym_switch] = ACTIONS(3085),
    [anon_sym_case] = ACTIONS(3085),
    [anon_sym_default] = ACTIONS(3085),
    [anon_sym_throw] = ACTIONS(3085),
    [anon_sym_try] = ACTIONS(3085),
    [anon_sym_when] = ACTIONS(3085),
    [anon_sym_await] = ACTIONS(3085),
    [anon_sym_foreach] = ACTIONS(3085),
    [anon_sym_goto] = ACTIONS(3085),
    [anon_sym_if] = ACTIONS(3085),
    [anon_sym_else] = ACTIONS(3085),
    [anon_sym_DOT_DOT] = ACTIONS(3087),
    [anon_sym_from] = ACTIONS(3085),
    [anon_sym_into] = ACTIONS(3085),
    [anon_sym_join] = ACTIONS(3085),
    [anon_sym_on] = ACTIONS(3085),
    [anon_sym_equals] = ACTIONS(3085),
    [anon_sym_let] = ACTIONS(3085),
    [anon_sym_orderby] = ACTIONS(3085),
    [anon_sym_ascending] = ACTIONS(3085),
    [anon_sym_descending] = ACTIONS(3085),
    [anon_sym_group] = ACTIONS(3085),
    [anon_sym_by] = ACTIONS(3085),
    [anon_sym_select] = ACTIONS(3085),
    [anon_sym_DQUOTE] = ACTIONS(3085),
    [anon_sym_stackalloc] = ACTIONS(3085),
    [anon_sym_sizeof] = ACTIONS(3085),
    [anon_sym_typeof] = ACTIONS(3085),
    [anon_sym___makeref] = ACTIONS(3085),
    [anon_sym___reftype] = ACTIONS(3085),
    [anon_sym___refvalue] = ACTIONS(3085),
    [sym_null_literal] = ACTIONS(3085),
    [anon_sym_SQUOTE] = ACTIONS(3087),
    [sym_integer_literal] = ACTIONS(3085),
    [sym_real_literal] = ACTIONS(3087),
    [sym_verbatim_string_literal] = ACTIONS(3087),
    [sym_raw_string_literal] = ACTIONS(3087),
    [aux_sym_preproc_if_token1] = ACTIONS(3087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3087),
    [sym_interpolation_verbatim_start] = ACTIONS(3087),
    [sym_interpolation_raw_start] = ACTIONS(3087),
  },
  [2653] = {
    [sym_preproc_region] = STATE(2653),
    [sym_preproc_endregion] = STATE(2653),
    [sym_preproc_line] = STATE(2653),
    [sym_preproc_pragma] = STATE(2653),
    [sym_preproc_nullable] = STATE(2653),
    [sym_preproc_error] = STATE(2653),
    [sym_preproc_define] = STATE(2653),
    [sym_preproc_undef] = STATE(2653),
    [sym__identifier_token] = ACTIONS(3375),
    [anon_sym_extern] = ACTIONS(3375),
    [anon_sym_alias] = ACTIONS(3375),
    [anon_sym_SEMI] = ACTIONS(3377),
    [anon_sym_global] = ACTIONS(3375),
    [anon_sym_using] = ACTIONS(3375),
    [anon_sym_unsafe] = ACTIONS(3375),
    [anon_sym_static] = ACTIONS(3375),
    [anon_sym_LBRACK] = ACTIONS(3377),
    [anon_sym_LPAREN] = ACTIONS(3377),
    [anon_sym_return] = ACTIONS(3375),
    [anon_sym_ref] = ACTIONS(3375),
    [anon_sym_LBRACE] = ACTIONS(3377),
    [anon_sym_RBRACE] = ACTIONS(3377),
    [anon_sym_delegate] = ACTIONS(3375),
    [anon_sym_abstract] = ACTIONS(3375),
    [anon_sym_async] = ACTIONS(3375),
    [anon_sym_const] = ACTIONS(3375),
    [anon_sym_file] = ACTIONS(3375),
    [anon_sym_fixed] = ACTIONS(3375),
    [anon_sym_internal] = ACTIONS(3375),
    [anon_sym_new] = ACTIONS(3375),
    [anon_sym_override] = ACTIONS(3375),
    [anon_sym_partial] = ACTIONS(3375),
    [anon_sym_private] = ACTIONS(3375),
    [anon_sym_protected] = ACTIONS(3375),
    [anon_sym_public] = ACTIONS(3375),
    [anon_sym_readonly] = ACTIONS(3375),
    [anon_sym_required] = ACTIONS(3375),
    [anon_sym_sealed] = ACTIONS(3375),
    [anon_sym_virtual] = ACTIONS(3375),
    [anon_sym_volatile] = ACTIONS(3375),
    [anon_sym_where] = ACTIONS(3375),
    [anon_sym_notnull] = ACTIONS(3375),
    [anon_sym_unmanaged] = ACTIONS(3375),
    [anon_sym_checked] = ACTIONS(3375),
    [anon_sym_BANG] = ACTIONS(3377),
    [anon_sym_TILDE] = ACTIONS(3377),
    [anon_sym_PLUS_PLUS] = ACTIONS(3377),
    [anon_sym_DASH_DASH] = ACTIONS(3377),
    [anon_sym_true] = ACTIONS(3375),
    [anon_sym_false] = ACTIONS(3375),
    [anon_sym_PLUS] = ACTIONS(3375),
    [anon_sym_DASH] = ACTIONS(3375),
    [anon_sym_STAR] = ACTIONS(3377),
    [anon_sym_CARET] = ACTIONS(3377),
    [anon_sym_AMP] = ACTIONS(3377),
    [anon_sym_this] = ACTIONS(3375),
    [anon_sym_scoped] = ACTIONS(3375),
    [anon_sym_var] = ACTIONS(3375),
    [sym_predefined_type] = ACTIONS(3375),
    [anon_sym_break] = ACTIONS(3375),
    [anon_sym_unchecked] = ACTIONS(3375),
    [anon_sym_continue] = ACTIONS(3375),
    [anon_sym_do] = ACTIONS(3375),
    [anon_sym_while] = ACTIONS(3375),
    [anon_sym_for] = ACTIONS(3375),
    [anon_sym_lock] = ACTIONS(3375),
    [anon_sym_yield] = ACTIONS(3375),
    [anon_sym_switch] = ACTIONS(3375),
    [anon_sym_case] = ACTIONS(3375),
    [anon_sym_default] = ACTIONS(3375),
    [anon_sym_throw] = ACTIONS(3375),
    [anon_sym_try] = ACTIONS(3375),
    [anon_sym_when] = ACTIONS(3375),
    [anon_sym_await] = ACTIONS(3375),
    [anon_sym_foreach] = ACTIONS(3375),
    [anon_sym_goto] = ACTIONS(3375),
    [anon_sym_if] = ACTIONS(3375),
    [anon_sym_else] = ACTIONS(3375),
    [anon_sym_DOT_DOT] = ACTIONS(3377),
    [anon_sym_from] = ACTIONS(3375),
    [anon_sym_into] = ACTIONS(3375),
    [anon_sym_join] = ACTIONS(3375),
    [anon_sym_on] = ACTIONS(3375),
    [anon_sym_equals] = ACTIONS(3375),
    [anon_sym_let] = ACTIONS(3375),
    [anon_sym_orderby] = ACTIONS(3375),
    [anon_sym_ascending] = ACTIONS(3375),
    [anon_sym_descending] = ACTIONS(3375),
    [anon_sym_group] = ACTIONS(3375),
    [anon_sym_by] = ACTIONS(3375),
    [anon_sym_select] = ACTIONS(3375),
    [anon_sym_DQUOTE] = ACTIONS(3375),
    [anon_sym_stackalloc] = ACTIONS(3375),
    [anon_sym_sizeof] = ACTIONS(3375),
    [anon_sym_typeof] = ACTIONS(3375),
    [anon_sym___makeref] = ACTIONS(3375),
    [anon_sym___reftype] = ACTIONS(3375),
    [anon_sym___refvalue] = ACTIONS(3375),
    [sym_null_literal] = ACTIONS(3375),
    [anon_sym_SQUOTE] = ACTIONS(3377),
    [sym_integer_literal] = ACTIONS(3375),
    [sym_real_literal] = ACTIONS(3377),
    [sym_verbatim_string_literal] = ACTIONS(3377),
    [sym_raw_string_literal] = ACTIONS(3377),
    [aux_sym_preproc_if_token1] = ACTIONS(3377),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3377),
    [sym_interpolation_verbatim_start] = ACTIONS(3377),
    [sym_interpolation_raw_start] = ACTIONS(3377),
  },
  [2654] = {
    [sym_preproc_region] = STATE(2654),
    [sym_preproc_endregion] = STATE(2654),
    [sym_preproc_line] = STATE(2654),
    [sym_preproc_pragma] = STATE(2654),
    [sym_preproc_nullable] = STATE(2654),
    [sym_preproc_error] = STATE(2654),
    [sym_preproc_define] = STATE(2654),
    [sym_preproc_undef] = STATE(2654),
    [sym__identifier_token] = ACTIONS(3379),
    [anon_sym_extern] = ACTIONS(3379),
    [anon_sym_alias] = ACTIONS(3379),
    [anon_sym_SEMI] = ACTIONS(3381),
    [anon_sym_global] = ACTIONS(3379),
    [anon_sym_using] = ACTIONS(3379),
    [anon_sym_unsafe] = ACTIONS(3379),
    [anon_sym_static] = ACTIONS(3379),
    [anon_sym_LBRACK] = ACTIONS(3381),
    [anon_sym_LPAREN] = ACTIONS(3381),
    [anon_sym_return] = ACTIONS(3379),
    [anon_sym_ref] = ACTIONS(3379),
    [anon_sym_LBRACE] = ACTIONS(3381),
    [anon_sym_RBRACE] = ACTIONS(3381),
    [anon_sym_delegate] = ACTIONS(3379),
    [anon_sym_abstract] = ACTIONS(3379),
    [anon_sym_async] = ACTIONS(3379),
    [anon_sym_const] = ACTIONS(3379),
    [anon_sym_file] = ACTIONS(3379),
    [anon_sym_fixed] = ACTIONS(3379),
    [anon_sym_internal] = ACTIONS(3379),
    [anon_sym_new] = ACTIONS(3379),
    [anon_sym_override] = ACTIONS(3379),
    [anon_sym_partial] = ACTIONS(3379),
    [anon_sym_private] = ACTIONS(3379),
    [anon_sym_protected] = ACTIONS(3379),
    [anon_sym_public] = ACTIONS(3379),
    [anon_sym_readonly] = ACTIONS(3379),
    [anon_sym_required] = ACTIONS(3379),
    [anon_sym_sealed] = ACTIONS(3379),
    [anon_sym_virtual] = ACTIONS(3379),
    [anon_sym_volatile] = ACTIONS(3379),
    [anon_sym_where] = ACTIONS(3379),
    [anon_sym_notnull] = ACTIONS(3379),
    [anon_sym_unmanaged] = ACTIONS(3379),
    [anon_sym_checked] = ACTIONS(3379),
    [anon_sym_BANG] = ACTIONS(3381),
    [anon_sym_TILDE] = ACTIONS(3381),
    [anon_sym_PLUS_PLUS] = ACTIONS(3381),
    [anon_sym_DASH_DASH] = ACTIONS(3381),
    [anon_sym_true] = ACTIONS(3379),
    [anon_sym_false] = ACTIONS(3379),
    [anon_sym_PLUS] = ACTIONS(3379),
    [anon_sym_DASH] = ACTIONS(3379),
    [anon_sym_STAR] = ACTIONS(3381),
    [anon_sym_CARET] = ACTIONS(3381),
    [anon_sym_AMP] = ACTIONS(3381),
    [anon_sym_this] = ACTIONS(3379),
    [anon_sym_scoped] = ACTIONS(3379),
    [anon_sym_var] = ACTIONS(3379),
    [sym_predefined_type] = ACTIONS(3379),
    [anon_sym_break] = ACTIONS(3379),
    [anon_sym_unchecked] = ACTIONS(3379),
    [anon_sym_continue] = ACTIONS(3379),
    [anon_sym_do] = ACTIONS(3379),
    [anon_sym_while] = ACTIONS(3379),
    [anon_sym_for] = ACTIONS(3379),
    [anon_sym_lock] = ACTIONS(3379),
    [anon_sym_yield] = ACTIONS(3379),
    [anon_sym_switch] = ACTIONS(3379),
    [anon_sym_case] = ACTIONS(3379),
    [anon_sym_default] = ACTIONS(3379),
    [anon_sym_throw] = ACTIONS(3379),
    [anon_sym_try] = ACTIONS(3379),
    [anon_sym_when] = ACTIONS(3379),
    [anon_sym_await] = ACTIONS(3379),
    [anon_sym_foreach] = ACTIONS(3379),
    [anon_sym_goto] = ACTIONS(3379),
    [anon_sym_if] = ACTIONS(3379),
    [anon_sym_else] = ACTIONS(3379),
    [anon_sym_DOT_DOT] = ACTIONS(3381),
    [anon_sym_from] = ACTIONS(3379),
    [anon_sym_into] = ACTIONS(3379),
    [anon_sym_join] = ACTIONS(3379),
    [anon_sym_on] = ACTIONS(3379),
    [anon_sym_equals] = ACTIONS(3379),
    [anon_sym_let] = ACTIONS(3379),
    [anon_sym_orderby] = ACTIONS(3379),
    [anon_sym_ascending] = ACTIONS(3379),
    [anon_sym_descending] = ACTIONS(3379),
    [anon_sym_group] = ACTIONS(3379),
    [anon_sym_by] = ACTIONS(3379),
    [anon_sym_select] = ACTIONS(3379),
    [anon_sym_DQUOTE] = ACTIONS(3379),
    [anon_sym_stackalloc] = ACTIONS(3379),
    [anon_sym_sizeof] = ACTIONS(3379),
    [anon_sym_typeof] = ACTIONS(3379),
    [anon_sym___makeref] = ACTIONS(3379),
    [anon_sym___reftype] = ACTIONS(3379),
    [anon_sym___refvalue] = ACTIONS(3379),
    [sym_null_literal] = ACTIONS(3379),
    [anon_sym_SQUOTE] = ACTIONS(3381),
    [sym_integer_literal] = ACTIONS(3379),
    [sym_real_literal] = ACTIONS(3381),
    [sym_verbatim_string_literal] = ACTIONS(3381),
    [sym_raw_string_literal] = ACTIONS(3381),
    [aux_sym_preproc_if_token1] = ACTIONS(3381),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3381),
    [sym_interpolation_verbatim_start] = ACTIONS(3381),
    [sym_interpolation_raw_start] = ACTIONS(3381),
  },
  [2655] = {
    [sym_preproc_region] = STATE(2655),
    [sym_preproc_endregion] = STATE(2655),
    [sym_preproc_line] = STATE(2655),
    [sym_preproc_pragma] = STATE(2655),
    [sym_preproc_nullable] = STATE(2655),
    [sym_preproc_error] = STATE(2655),
    [sym_preproc_define] = STATE(2655),
    [sym_preproc_undef] = STATE(2655),
    [sym__identifier_token] = ACTIONS(3199),
    [anon_sym_extern] = ACTIONS(3199),
    [anon_sym_alias] = ACTIONS(3199),
    [anon_sym_SEMI] = ACTIONS(3201),
    [anon_sym_global] = ACTIONS(3199),
    [anon_sym_using] = ACTIONS(3199),
    [anon_sym_unsafe] = ACTIONS(3199),
    [anon_sym_static] = ACTIONS(3199),
    [anon_sym_LBRACK] = ACTIONS(3201),
    [anon_sym_LPAREN] = ACTIONS(3201),
    [anon_sym_return] = ACTIONS(3199),
    [anon_sym_ref] = ACTIONS(3199),
    [anon_sym_LBRACE] = ACTIONS(3201),
    [anon_sym_RBRACE] = ACTIONS(3201),
    [anon_sym_delegate] = ACTIONS(3199),
    [anon_sym_abstract] = ACTIONS(3199),
    [anon_sym_async] = ACTIONS(3199),
    [anon_sym_const] = ACTIONS(3199),
    [anon_sym_file] = ACTIONS(3199),
    [anon_sym_fixed] = ACTIONS(3199),
    [anon_sym_internal] = ACTIONS(3199),
    [anon_sym_new] = ACTIONS(3199),
    [anon_sym_override] = ACTIONS(3199),
    [anon_sym_partial] = ACTIONS(3199),
    [anon_sym_private] = ACTIONS(3199),
    [anon_sym_protected] = ACTIONS(3199),
    [anon_sym_public] = ACTIONS(3199),
    [anon_sym_readonly] = ACTIONS(3199),
    [anon_sym_required] = ACTIONS(3199),
    [anon_sym_sealed] = ACTIONS(3199),
    [anon_sym_virtual] = ACTIONS(3199),
    [anon_sym_volatile] = ACTIONS(3199),
    [anon_sym_where] = ACTIONS(3199),
    [anon_sym_notnull] = ACTIONS(3199),
    [anon_sym_unmanaged] = ACTIONS(3199),
    [anon_sym_checked] = ACTIONS(3199),
    [anon_sym_BANG] = ACTIONS(3201),
    [anon_sym_TILDE] = ACTIONS(3201),
    [anon_sym_PLUS_PLUS] = ACTIONS(3201),
    [anon_sym_DASH_DASH] = ACTIONS(3201),
    [anon_sym_true] = ACTIONS(3199),
    [anon_sym_false] = ACTIONS(3199),
    [anon_sym_PLUS] = ACTIONS(3199),
    [anon_sym_DASH] = ACTIONS(3199),
    [anon_sym_STAR] = ACTIONS(3201),
    [anon_sym_CARET] = ACTIONS(3201),
    [anon_sym_AMP] = ACTIONS(3201),
    [anon_sym_this] = ACTIONS(3199),
    [anon_sym_scoped] = ACTIONS(3199),
    [anon_sym_var] = ACTIONS(3199),
    [sym_predefined_type] = ACTIONS(3199),
    [anon_sym_break] = ACTIONS(3199),
    [anon_sym_unchecked] = ACTIONS(3199),
    [anon_sym_continue] = ACTIONS(3199),
    [anon_sym_do] = ACTIONS(3199),
    [anon_sym_while] = ACTIONS(3199),
    [anon_sym_for] = ACTIONS(3199),
    [anon_sym_lock] = ACTIONS(3199),
    [anon_sym_yield] = ACTIONS(3199),
    [anon_sym_switch] = ACTIONS(3199),
    [anon_sym_case] = ACTIONS(3199),
    [anon_sym_default] = ACTIONS(3199),
    [anon_sym_throw] = ACTIONS(3199),
    [anon_sym_try] = ACTIONS(3199),
    [anon_sym_when] = ACTIONS(3199),
    [anon_sym_await] = ACTIONS(3199),
    [anon_sym_foreach] = ACTIONS(3199),
    [anon_sym_goto] = ACTIONS(3199),
    [anon_sym_if] = ACTIONS(3199),
    [anon_sym_else] = ACTIONS(3199),
    [anon_sym_DOT_DOT] = ACTIONS(3201),
    [anon_sym_from] = ACTIONS(3199),
    [anon_sym_into] = ACTIONS(3199),
    [anon_sym_join] = ACTIONS(3199),
    [anon_sym_on] = ACTIONS(3199),
    [anon_sym_equals] = ACTIONS(3199),
    [anon_sym_let] = ACTIONS(3199),
    [anon_sym_orderby] = ACTIONS(3199),
    [anon_sym_ascending] = ACTIONS(3199),
    [anon_sym_descending] = ACTIONS(3199),
    [anon_sym_group] = ACTIONS(3199),
    [anon_sym_by] = ACTIONS(3199),
    [anon_sym_select] = ACTIONS(3199),
    [anon_sym_DQUOTE] = ACTIONS(3199),
    [anon_sym_stackalloc] = ACTIONS(3199),
    [anon_sym_sizeof] = ACTIONS(3199),
    [anon_sym_typeof] = ACTIONS(3199),
    [anon_sym___makeref] = ACTIONS(3199),
    [anon_sym___reftype] = ACTIONS(3199),
    [anon_sym___refvalue] = ACTIONS(3199),
    [sym_null_literal] = ACTIONS(3199),
    [anon_sym_SQUOTE] = ACTIONS(3201),
    [sym_integer_literal] = ACTIONS(3199),
    [sym_real_literal] = ACTIONS(3201),
    [sym_verbatim_string_literal] = ACTIONS(3201),
    [sym_raw_string_literal] = ACTIONS(3201),
    [aux_sym_preproc_if_token1] = ACTIONS(3201),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3201),
    [sym_interpolation_verbatim_start] = ACTIONS(3201),
    [sym_interpolation_raw_start] = ACTIONS(3201),
  },
  [2656] = {
    [sym_preproc_region] = STATE(2656),
    [sym_preproc_endregion] = STATE(2656),
    [sym_preproc_line] = STATE(2656),
    [sym_preproc_pragma] = STATE(2656),
    [sym_preproc_nullable] = STATE(2656),
    [sym_preproc_error] = STATE(2656),
    [sym_preproc_define] = STATE(2656),
    [sym_preproc_undef] = STATE(2656),
    [sym__identifier_token] = ACTIONS(3101),
    [anon_sym_extern] = ACTIONS(3101),
    [anon_sym_alias] = ACTIONS(3101),
    [anon_sym_SEMI] = ACTIONS(3103),
    [anon_sym_global] = ACTIONS(3101),
    [anon_sym_using] = ACTIONS(3101),
    [anon_sym_unsafe] = ACTIONS(3101),
    [anon_sym_static] = ACTIONS(3101),
    [anon_sym_LBRACK] = ACTIONS(3103),
    [anon_sym_LPAREN] = ACTIONS(3103),
    [anon_sym_return] = ACTIONS(3101),
    [anon_sym_ref] = ACTIONS(3101),
    [anon_sym_LBRACE] = ACTIONS(3103),
    [anon_sym_RBRACE] = ACTIONS(3103),
    [anon_sym_delegate] = ACTIONS(3101),
    [anon_sym_abstract] = ACTIONS(3101),
    [anon_sym_async] = ACTIONS(3101),
    [anon_sym_const] = ACTIONS(3101),
    [anon_sym_file] = ACTIONS(3101),
    [anon_sym_fixed] = ACTIONS(3101),
    [anon_sym_internal] = ACTIONS(3101),
    [anon_sym_new] = ACTIONS(3101),
    [anon_sym_override] = ACTIONS(3101),
    [anon_sym_partial] = ACTIONS(3101),
    [anon_sym_private] = ACTIONS(3101),
    [anon_sym_protected] = ACTIONS(3101),
    [anon_sym_public] = ACTIONS(3101),
    [anon_sym_readonly] = ACTIONS(3101),
    [anon_sym_required] = ACTIONS(3101),
    [anon_sym_sealed] = ACTIONS(3101),
    [anon_sym_virtual] = ACTIONS(3101),
    [anon_sym_volatile] = ACTIONS(3101),
    [anon_sym_where] = ACTIONS(3101),
    [anon_sym_notnull] = ACTIONS(3101),
    [anon_sym_unmanaged] = ACTIONS(3101),
    [anon_sym_checked] = ACTIONS(3101),
    [anon_sym_BANG] = ACTIONS(3103),
    [anon_sym_TILDE] = ACTIONS(3103),
    [anon_sym_PLUS_PLUS] = ACTIONS(3103),
    [anon_sym_DASH_DASH] = ACTIONS(3103),
    [anon_sym_true] = ACTIONS(3101),
    [anon_sym_false] = ACTIONS(3101),
    [anon_sym_PLUS] = ACTIONS(3101),
    [anon_sym_DASH] = ACTIONS(3101),
    [anon_sym_STAR] = ACTIONS(3103),
    [anon_sym_CARET] = ACTIONS(3103),
    [anon_sym_AMP] = ACTIONS(3103),
    [anon_sym_this] = ACTIONS(3101),
    [anon_sym_scoped] = ACTIONS(3101),
    [anon_sym_var] = ACTIONS(3101),
    [sym_predefined_type] = ACTIONS(3101),
    [anon_sym_break] = ACTIONS(3101),
    [anon_sym_unchecked] = ACTIONS(3101),
    [anon_sym_continue] = ACTIONS(3101),
    [anon_sym_do] = ACTIONS(3101),
    [anon_sym_while] = ACTIONS(3101),
    [anon_sym_for] = ACTIONS(3101),
    [anon_sym_lock] = ACTIONS(3101),
    [anon_sym_yield] = ACTIONS(3101),
    [anon_sym_switch] = ACTIONS(3101),
    [anon_sym_case] = ACTIONS(3101),
    [anon_sym_default] = ACTIONS(3101),
    [anon_sym_throw] = ACTIONS(3101),
    [anon_sym_try] = ACTIONS(3101),
    [anon_sym_when] = ACTIONS(3101),
    [anon_sym_await] = ACTIONS(3101),
    [anon_sym_foreach] = ACTIONS(3101),
    [anon_sym_goto] = ACTIONS(3101),
    [anon_sym_if] = ACTIONS(3101),
    [anon_sym_else] = ACTIONS(3101),
    [anon_sym_DOT_DOT] = ACTIONS(3103),
    [anon_sym_from] = ACTIONS(3101),
    [anon_sym_into] = ACTIONS(3101),
    [anon_sym_join] = ACTIONS(3101),
    [anon_sym_on] = ACTIONS(3101),
    [anon_sym_equals] = ACTIONS(3101),
    [anon_sym_let] = ACTIONS(3101),
    [anon_sym_orderby] = ACTIONS(3101),
    [anon_sym_ascending] = ACTIONS(3101),
    [anon_sym_descending] = ACTIONS(3101),
    [anon_sym_group] = ACTIONS(3101),
    [anon_sym_by] = ACTIONS(3101),
    [anon_sym_select] = ACTIONS(3101),
    [anon_sym_DQUOTE] = ACTIONS(3101),
    [anon_sym_stackalloc] = ACTIONS(3101),
    [anon_sym_sizeof] = ACTIONS(3101),
    [anon_sym_typeof] = ACTIONS(3101),
    [anon_sym___makeref] = ACTIONS(3101),
    [anon_sym___reftype] = ACTIONS(3101),
    [anon_sym___refvalue] = ACTIONS(3101),
    [sym_null_literal] = ACTIONS(3101),
    [anon_sym_SQUOTE] = ACTIONS(3103),
    [sym_integer_literal] = ACTIONS(3101),
    [sym_real_literal] = ACTIONS(3103),
    [sym_verbatim_string_literal] = ACTIONS(3103),
    [sym_raw_string_literal] = ACTIONS(3103),
    [aux_sym_preproc_if_token1] = ACTIONS(3103),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3103),
    [sym_interpolation_verbatim_start] = ACTIONS(3103),
    [sym_interpolation_raw_start] = ACTIONS(3103),
  },
  [2657] = {
    [sym_preproc_region] = STATE(2657),
    [sym_preproc_endregion] = STATE(2657),
    [sym_preproc_line] = STATE(2657),
    [sym_preproc_pragma] = STATE(2657),
    [sym_preproc_nullable] = STATE(2657),
    [sym_preproc_error] = STATE(2657),
    [sym_preproc_define] = STATE(2657),
    [sym_preproc_undef] = STATE(2657),
    [sym__identifier_token] = ACTIONS(3191),
    [anon_sym_extern] = ACTIONS(3191),
    [anon_sym_alias] = ACTIONS(3191),
    [anon_sym_SEMI] = ACTIONS(3193),
    [anon_sym_global] = ACTIONS(3191),
    [anon_sym_using] = ACTIONS(3191),
    [anon_sym_unsafe] = ACTIONS(3191),
    [anon_sym_static] = ACTIONS(3191),
    [anon_sym_LBRACK] = ACTIONS(3193),
    [anon_sym_LPAREN] = ACTIONS(3193),
    [anon_sym_return] = ACTIONS(3191),
    [anon_sym_ref] = ACTIONS(3191),
    [anon_sym_LBRACE] = ACTIONS(3193),
    [anon_sym_RBRACE] = ACTIONS(3193),
    [anon_sym_delegate] = ACTIONS(3191),
    [anon_sym_abstract] = ACTIONS(3191),
    [anon_sym_async] = ACTIONS(3191),
    [anon_sym_const] = ACTIONS(3191),
    [anon_sym_file] = ACTIONS(3191),
    [anon_sym_fixed] = ACTIONS(3191),
    [anon_sym_internal] = ACTIONS(3191),
    [anon_sym_new] = ACTIONS(3191),
    [anon_sym_override] = ACTIONS(3191),
    [anon_sym_partial] = ACTIONS(3191),
    [anon_sym_private] = ACTIONS(3191),
    [anon_sym_protected] = ACTIONS(3191),
    [anon_sym_public] = ACTIONS(3191),
    [anon_sym_readonly] = ACTIONS(3191),
    [anon_sym_required] = ACTIONS(3191),
    [anon_sym_sealed] = ACTIONS(3191),
    [anon_sym_virtual] = ACTIONS(3191),
    [anon_sym_volatile] = ACTIONS(3191),
    [anon_sym_where] = ACTIONS(3191),
    [anon_sym_notnull] = ACTIONS(3191),
    [anon_sym_unmanaged] = ACTIONS(3191),
    [anon_sym_checked] = ACTIONS(3191),
    [anon_sym_BANG] = ACTIONS(3193),
    [anon_sym_TILDE] = ACTIONS(3193),
    [anon_sym_PLUS_PLUS] = ACTIONS(3193),
    [anon_sym_DASH_DASH] = ACTIONS(3193),
    [anon_sym_true] = ACTIONS(3191),
    [anon_sym_false] = ACTIONS(3191),
    [anon_sym_PLUS] = ACTIONS(3191),
    [anon_sym_DASH] = ACTIONS(3191),
    [anon_sym_STAR] = ACTIONS(3193),
    [anon_sym_CARET] = ACTIONS(3193),
    [anon_sym_AMP] = ACTIONS(3193),
    [anon_sym_this] = ACTIONS(3191),
    [anon_sym_scoped] = ACTIONS(3191),
    [anon_sym_var] = ACTIONS(3191),
    [sym_predefined_type] = ACTIONS(3191),
    [anon_sym_break] = ACTIONS(3191),
    [anon_sym_unchecked] = ACTIONS(3191),
    [anon_sym_continue] = ACTIONS(3191),
    [anon_sym_do] = ACTIONS(3191),
    [anon_sym_while] = ACTIONS(3191),
    [anon_sym_for] = ACTIONS(3191),
    [anon_sym_lock] = ACTIONS(3191),
    [anon_sym_yield] = ACTIONS(3191),
    [anon_sym_switch] = ACTIONS(3191),
    [anon_sym_case] = ACTIONS(3191),
    [anon_sym_default] = ACTIONS(3191),
    [anon_sym_throw] = ACTIONS(3191),
    [anon_sym_try] = ACTIONS(3191),
    [anon_sym_when] = ACTIONS(3191),
    [anon_sym_await] = ACTIONS(3191),
    [anon_sym_foreach] = ACTIONS(3191),
    [anon_sym_goto] = ACTIONS(3191),
    [anon_sym_if] = ACTIONS(3191),
    [anon_sym_else] = ACTIONS(3191),
    [anon_sym_DOT_DOT] = ACTIONS(3193),
    [anon_sym_from] = ACTIONS(3191),
    [anon_sym_into] = ACTIONS(3191),
    [anon_sym_join] = ACTIONS(3191),
    [anon_sym_on] = ACTIONS(3191),
    [anon_sym_equals] = ACTIONS(3191),
    [anon_sym_let] = ACTIONS(3191),
    [anon_sym_orderby] = ACTIONS(3191),
    [anon_sym_ascending] = ACTIONS(3191),
    [anon_sym_descending] = ACTIONS(3191),
    [anon_sym_group] = ACTIONS(3191),
    [anon_sym_by] = ACTIONS(3191),
    [anon_sym_select] = ACTIONS(3191),
    [anon_sym_DQUOTE] = ACTIONS(3191),
    [anon_sym_stackalloc] = ACTIONS(3191),
    [anon_sym_sizeof] = ACTIONS(3191),
    [anon_sym_typeof] = ACTIONS(3191),
    [anon_sym___makeref] = ACTIONS(3191),
    [anon_sym___reftype] = ACTIONS(3191),
    [anon_sym___refvalue] = ACTIONS(3191),
    [sym_null_literal] = ACTIONS(3191),
    [anon_sym_SQUOTE] = ACTIONS(3193),
    [sym_integer_literal] = ACTIONS(3191),
    [sym_real_literal] = ACTIONS(3193),
    [sym_verbatim_string_literal] = ACTIONS(3193),
    [sym_raw_string_literal] = ACTIONS(3193),
    [aux_sym_preproc_if_token1] = ACTIONS(3193),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3193),
    [sym_interpolation_verbatim_start] = ACTIONS(3193),
    [sym_interpolation_raw_start] = ACTIONS(3193),
  },
  [2658] = {
    [sym_preproc_region] = STATE(2658),
    [sym_preproc_endregion] = STATE(2658),
    [sym_preproc_line] = STATE(2658),
    [sym_preproc_pragma] = STATE(2658),
    [sym_preproc_nullable] = STATE(2658),
    [sym_preproc_error] = STATE(2658),
    [sym_preproc_define] = STATE(2658),
    [sym_preproc_undef] = STATE(2658),
    [sym__identifier_token] = ACTIONS(3109),
    [anon_sym_extern] = ACTIONS(3109),
    [anon_sym_alias] = ACTIONS(3109),
    [anon_sym_SEMI] = ACTIONS(3111),
    [anon_sym_global] = ACTIONS(3109),
    [anon_sym_using] = ACTIONS(3109),
    [anon_sym_unsafe] = ACTIONS(3109),
    [anon_sym_static] = ACTIONS(3109),
    [anon_sym_LBRACK] = ACTIONS(3111),
    [anon_sym_LPAREN] = ACTIONS(3111),
    [anon_sym_return] = ACTIONS(3109),
    [anon_sym_ref] = ACTIONS(3109),
    [anon_sym_LBRACE] = ACTIONS(3111),
    [anon_sym_RBRACE] = ACTIONS(3111),
    [anon_sym_delegate] = ACTIONS(3109),
    [anon_sym_abstract] = ACTIONS(3109),
    [anon_sym_async] = ACTIONS(3109),
    [anon_sym_const] = ACTIONS(3109),
    [anon_sym_file] = ACTIONS(3109),
    [anon_sym_fixed] = ACTIONS(3109),
    [anon_sym_internal] = ACTIONS(3109),
    [anon_sym_new] = ACTIONS(3109),
    [anon_sym_override] = ACTIONS(3109),
    [anon_sym_partial] = ACTIONS(3109),
    [anon_sym_private] = ACTIONS(3109),
    [anon_sym_protected] = ACTIONS(3109),
    [anon_sym_public] = ACTIONS(3109),
    [anon_sym_readonly] = ACTIONS(3109),
    [anon_sym_required] = ACTIONS(3109),
    [anon_sym_sealed] = ACTIONS(3109),
    [anon_sym_virtual] = ACTIONS(3109),
    [anon_sym_volatile] = ACTIONS(3109),
    [anon_sym_where] = ACTIONS(3109),
    [anon_sym_notnull] = ACTIONS(3109),
    [anon_sym_unmanaged] = ACTIONS(3109),
    [anon_sym_checked] = ACTIONS(3109),
    [anon_sym_BANG] = ACTIONS(3111),
    [anon_sym_TILDE] = ACTIONS(3111),
    [anon_sym_PLUS_PLUS] = ACTIONS(3111),
    [anon_sym_DASH_DASH] = ACTIONS(3111),
    [anon_sym_true] = ACTIONS(3109),
    [anon_sym_false] = ACTIONS(3109),
    [anon_sym_PLUS] = ACTIONS(3109),
    [anon_sym_DASH] = ACTIONS(3109),
    [anon_sym_STAR] = ACTIONS(3111),
    [anon_sym_CARET] = ACTIONS(3111),
    [anon_sym_AMP] = ACTIONS(3111),
    [anon_sym_this] = ACTIONS(3109),
    [anon_sym_scoped] = ACTIONS(3109),
    [anon_sym_var] = ACTIONS(3109),
    [sym_predefined_type] = ACTIONS(3109),
    [anon_sym_break] = ACTIONS(3109),
    [anon_sym_unchecked] = ACTIONS(3109),
    [anon_sym_continue] = ACTIONS(3109),
    [anon_sym_do] = ACTIONS(3109),
    [anon_sym_while] = ACTIONS(3109),
    [anon_sym_for] = ACTIONS(3109),
    [anon_sym_lock] = ACTIONS(3109),
    [anon_sym_yield] = ACTIONS(3109),
    [anon_sym_switch] = ACTIONS(3109),
    [anon_sym_case] = ACTIONS(3109),
    [anon_sym_default] = ACTIONS(3109),
    [anon_sym_throw] = ACTIONS(3109),
    [anon_sym_try] = ACTIONS(3109),
    [anon_sym_when] = ACTIONS(3109),
    [anon_sym_await] = ACTIONS(3109),
    [anon_sym_foreach] = ACTIONS(3109),
    [anon_sym_goto] = ACTIONS(3109),
    [anon_sym_if] = ACTIONS(3109),
    [anon_sym_else] = ACTIONS(3109),
    [anon_sym_DOT_DOT] = ACTIONS(3111),
    [anon_sym_from] = ACTIONS(3109),
    [anon_sym_into] = ACTIONS(3109),
    [anon_sym_join] = ACTIONS(3109),
    [anon_sym_on] = ACTIONS(3109),
    [anon_sym_equals] = ACTIONS(3109),
    [anon_sym_let] = ACTIONS(3109),
    [anon_sym_orderby] = ACTIONS(3109),
    [anon_sym_ascending] = ACTIONS(3109),
    [anon_sym_descending] = ACTIONS(3109),
    [anon_sym_group] = ACTIONS(3109),
    [anon_sym_by] = ACTIONS(3109),
    [anon_sym_select] = ACTIONS(3109),
    [anon_sym_DQUOTE] = ACTIONS(3109),
    [anon_sym_stackalloc] = ACTIONS(3109),
    [anon_sym_sizeof] = ACTIONS(3109),
    [anon_sym_typeof] = ACTIONS(3109),
    [anon_sym___makeref] = ACTIONS(3109),
    [anon_sym___reftype] = ACTIONS(3109),
    [anon_sym___refvalue] = ACTIONS(3109),
    [sym_null_literal] = ACTIONS(3109),
    [anon_sym_SQUOTE] = ACTIONS(3111),
    [sym_integer_literal] = ACTIONS(3109),
    [sym_real_literal] = ACTIONS(3111),
    [sym_verbatim_string_literal] = ACTIONS(3111),
    [sym_raw_string_literal] = ACTIONS(3111),
    [aux_sym_preproc_if_token1] = ACTIONS(3111),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3111),
    [sym_interpolation_verbatim_start] = ACTIONS(3111),
    [sym_interpolation_raw_start] = ACTIONS(3111),
  },
  [2659] = {
    [sym_preproc_region] = STATE(2659),
    [sym_preproc_endregion] = STATE(2659),
    [sym_preproc_line] = STATE(2659),
    [sym_preproc_pragma] = STATE(2659),
    [sym_preproc_nullable] = STATE(2659),
    [sym_preproc_error] = STATE(2659),
    [sym_preproc_define] = STATE(2659),
    [sym_preproc_undef] = STATE(2659),
    [sym__identifier_token] = ACTIONS(3195),
    [anon_sym_extern] = ACTIONS(3195),
    [anon_sym_alias] = ACTIONS(3195),
    [anon_sym_SEMI] = ACTIONS(3197),
    [anon_sym_global] = ACTIONS(3195),
    [anon_sym_using] = ACTIONS(3195),
    [anon_sym_unsafe] = ACTIONS(3195),
    [anon_sym_static] = ACTIONS(3195),
    [anon_sym_LBRACK] = ACTIONS(3197),
    [anon_sym_LPAREN] = ACTIONS(3197),
    [anon_sym_return] = ACTIONS(3195),
    [anon_sym_ref] = ACTIONS(3195),
    [anon_sym_LBRACE] = ACTIONS(3197),
    [anon_sym_RBRACE] = ACTIONS(3197),
    [anon_sym_delegate] = ACTIONS(3195),
    [anon_sym_abstract] = ACTIONS(3195),
    [anon_sym_async] = ACTIONS(3195),
    [anon_sym_const] = ACTIONS(3195),
    [anon_sym_file] = ACTIONS(3195),
    [anon_sym_fixed] = ACTIONS(3195),
    [anon_sym_internal] = ACTIONS(3195),
    [anon_sym_new] = ACTIONS(3195),
    [anon_sym_override] = ACTIONS(3195),
    [anon_sym_partial] = ACTIONS(3195),
    [anon_sym_private] = ACTIONS(3195),
    [anon_sym_protected] = ACTIONS(3195),
    [anon_sym_public] = ACTIONS(3195),
    [anon_sym_readonly] = ACTIONS(3195),
    [anon_sym_required] = ACTIONS(3195),
    [anon_sym_sealed] = ACTIONS(3195),
    [anon_sym_virtual] = ACTIONS(3195),
    [anon_sym_volatile] = ACTIONS(3195),
    [anon_sym_where] = ACTIONS(3195),
    [anon_sym_notnull] = ACTIONS(3195),
    [anon_sym_unmanaged] = ACTIONS(3195),
    [anon_sym_checked] = ACTIONS(3195),
    [anon_sym_BANG] = ACTIONS(3197),
    [anon_sym_TILDE] = ACTIONS(3197),
    [anon_sym_PLUS_PLUS] = ACTIONS(3197),
    [anon_sym_DASH_DASH] = ACTIONS(3197),
    [anon_sym_true] = ACTIONS(3195),
    [anon_sym_false] = ACTIONS(3195),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_STAR] = ACTIONS(3197),
    [anon_sym_CARET] = ACTIONS(3197),
    [anon_sym_AMP] = ACTIONS(3197),
    [anon_sym_this] = ACTIONS(3195),
    [anon_sym_scoped] = ACTIONS(3195),
    [anon_sym_var] = ACTIONS(3195),
    [sym_predefined_type] = ACTIONS(3195),
    [anon_sym_break] = ACTIONS(3195),
    [anon_sym_unchecked] = ACTIONS(3195),
    [anon_sym_continue] = ACTIONS(3195),
    [anon_sym_do] = ACTIONS(3195),
    [anon_sym_while] = ACTIONS(3195),
    [anon_sym_for] = ACTIONS(3195),
    [anon_sym_lock] = ACTIONS(3195),
    [anon_sym_yield] = ACTIONS(3195),
    [anon_sym_switch] = ACTIONS(3195),
    [anon_sym_case] = ACTIONS(3195),
    [anon_sym_default] = ACTIONS(3195),
    [anon_sym_throw] = ACTIONS(3195),
    [anon_sym_try] = ACTIONS(3195),
    [anon_sym_when] = ACTIONS(3195),
    [anon_sym_await] = ACTIONS(3195),
    [anon_sym_foreach] = ACTIONS(3195),
    [anon_sym_goto] = ACTIONS(3195),
    [anon_sym_if] = ACTIONS(3195),
    [anon_sym_else] = ACTIONS(3195),
    [anon_sym_DOT_DOT] = ACTIONS(3197),
    [anon_sym_from] = ACTIONS(3195),
    [anon_sym_into] = ACTIONS(3195),
    [anon_sym_join] = ACTIONS(3195),
    [anon_sym_on] = ACTIONS(3195),
    [anon_sym_equals] = ACTIONS(3195),
    [anon_sym_let] = ACTIONS(3195),
    [anon_sym_orderby] = ACTIONS(3195),
    [anon_sym_ascending] = ACTIONS(3195),
    [anon_sym_descending] = ACTIONS(3195),
    [anon_sym_group] = ACTIONS(3195),
    [anon_sym_by] = ACTIONS(3195),
    [anon_sym_select] = ACTIONS(3195),
    [anon_sym_DQUOTE] = ACTIONS(3195),
    [anon_sym_stackalloc] = ACTIONS(3195),
    [anon_sym_sizeof] = ACTIONS(3195),
    [anon_sym_typeof] = ACTIONS(3195),
    [anon_sym___makeref] = ACTIONS(3195),
    [anon_sym___reftype] = ACTIONS(3195),
    [anon_sym___refvalue] = ACTIONS(3195),
    [sym_null_literal] = ACTIONS(3195),
    [anon_sym_SQUOTE] = ACTIONS(3197),
    [sym_integer_literal] = ACTIONS(3195),
    [sym_real_literal] = ACTIONS(3197),
    [sym_verbatim_string_literal] = ACTIONS(3197),
    [sym_raw_string_literal] = ACTIONS(3197),
    [aux_sym_preproc_if_token1] = ACTIONS(3197),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3197),
    [sym_interpolation_verbatim_start] = ACTIONS(3197),
    [sym_interpolation_raw_start] = ACTIONS(3197),
  },
  [2660] = {
    [sym_preproc_region] = STATE(2660),
    [sym_preproc_endregion] = STATE(2660),
    [sym_preproc_line] = STATE(2660),
    [sym_preproc_pragma] = STATE(2660),
    [sym_preproc_nullable] = STATE(2660),
    [sym_preproc_error] = STATE(2660),
    [sym_preproc_define] = STATE(2660),
    [sym_preproc_undef] = STATE(2660),
    [sym__identifier_token] = ACTIONS(3413),
    [anon_sym_extern] = ACTIONS(3413),
    [anon_sym_alias] = ACTIONS(3413),
    [anon_sym_SEMI] = ACTIONS(3415),
    [anon_sym_global] = ACTIONS(3413),
    [anon_sym_using] = ACTIONS(3413),
    [anon_sym_unsafe] = ACTIONS(3413),
    [anon_sym_static] = ACTIONS(3413),
    [anon_sym_LBRACK] = ACTIONS(3415),
    [anon_sym_LPAREN] = ACTIONS(3415),
    [anon_sym_return] = ACTIONS(3413),
    [anon_sym_ref] = ACTIONS(3413),
    [anon_sym_LBRACE] = ACTIONS(3415),
    [anon_sym_RBRACE] = ACTIONS(3415),
    [anon_sym_delegate] = ACTIONS(3413),
    [anon_sym_abstract] = ACTIONS(3413),
    [anon_sym_async] = ACTIONS(3413),
    [anon_sym_const] = ACTIONS(3413),
    [anon_sym_file] = ACTIONS(3413),
    [anon_sym_fixed] = ACTIONS(3413),
    [anon_sym_internal] = ACTIONS(3413),
    [anon_sym_new] = ACTIONS(3413),
    [anon_sym_override] = ACTIONS(3413),
    [anon_sym_partial] = ACTIONS(3413),
    [anon_sym_private] = ACTIONS(3413),
    [anon_sym_protected] = ACTIONS(3413),
    [anon_sym_public] = ACTIONS(3413),
    [anon_sym_readonly] = ACTIONS(3413),
    [anon_sym_required] = ACTIONS(3413),
    [anon_sym_sealed] = ACTIONS(3413),
    [anon_sym_virtual] = ACTIONS(3413),
    [anon_sym_volatile] = ACTIONS(3413),
    [anon_sym_where] = ACTIONS(3413),
    [anon_sym_notnull] = ACTIONS(3413),
    [anon_sym_unmanaged] = ACTIONS(3413),
    [anon_sym_checked] = ACTIONS(3413),
    [anon_sym_BANG] = ACTIONS(3415),
    [anon_sym_TILDE] = ACTIONS(3415),
    [anon_sym_PLUS_PLUS] = ACTIONS(3415),
    [anon_sym_DASH_DASH] = ACTIONS(3415),
    [anon_sym_true] = ACTIONS(3413),
    [anon_sym_false] = ACTIONS(3413),
    [anon_sym_PLUS] = ACTIONS(3413),
    [anon_sym_DASH] = ACTIONS(3413),
    [anon_sym_STAR] = ACTIONS(3415),
    [anon_sym_CARET] = ACTIONS(3415),
    [anon_sym_AMP] = ACTIONS(3415),
    [anon_sym_this] = ACTIONS(3413),
    [anon_sym_scoped] = ACTIONS(3413),
    [anon_sym_var] = ACTIONS(3413),
    [sym_predefined_type] = ACTIONS(3413),
    [anon_sym_break] = ACTIONS(3413),
    [anon_sym_unchecked] = ACTIONS(3413),
    [anon_sym_continue] = ACTIONS(3413),
    [anon_sym_do] = ACTIONS(3413),
    [anon_sym_while] = ACTIONS(3413),
    [anon_sym_for] = ACTIONS(3413),
    [anon_sym_lock] = ACTIONS(3413),
    [anon_sym_yield] = ACTIONS(3413),
    [anon_sym_switch] = ACTIONS(3413),
    [anon_sym_case] = ACTIONS(3413),
    [anon_sym_default] = ACTIONS(3413),
    [anon_sym_throw] = ACTIONS(3413),
    [anon_sym_try] = ACTIONS(3413),
    [anon_sym_when] = ACTIONS(3413),
    [anon_sym_await] = ACTIONS(3413),
    [anon_sym_foreach] = ACTIONS(3413),
    [anon_sym_goto] = ACTIONS(3413),
    [anon_sym_if] = ACTIONS(3413),
    [anon_sym_else] = ACTIONS(3413),
    [anon_sym_DOT_DOT] = ACTIONS(3415),
    [anon_sym_from] = ACTIONS(3413),
    [anon_sym_into] = ACTIONS(3413),
    [anon_sym_join] = ACTIONS(3413),
    [anon_sym_on] = ACTIONS(3413),
    [anon_sym_equals] = ACTIONS(3413),
    [anon_sym_let] = ACTIONS(3413),
    [anon_sym_orderby] = ACTIONS(3413),
    [anon_sym_ascending] = ACTIONS(3413),
    [anon_sym_descending] = ACTIONS(3413),
    [anon_sym_group] = ACTIONS(3413),
    [anon_sym_by] = ACTIONS(3413),
    [anon_sym_select] = ACTIONS(3413),
    [anon_sym_DQUOTE] = ACTIONS(3413),
    [anon_sym_stackalloc] = ACTIONS(3413),
    [anon_sym_sizeof] = ACTIONS(3413),
    [anon_sym_typeof] = ACTIONS(3413),
    [anon_sym___makeref] = ACTIONS(3413),
    [anon_sym___reftype] = ACTIONS(3413),
    [anon_sym___refvalue] = ACTIONS(3413),
    [sym_null_literal] = ACTIONS(3413),
    [anon_sym_SQUOTE] = ACTIONS(3415),
    [sym_integer_literal] = ACTIONS(3413),
    [sym_real_literal] = ACTIONS(3415),
    [sym_verbatim_string_literal] = ACTIONS(3415),
    [sym_raw_string_literal] = ACTIONS(3415),
    [aux_sym_preproc_if_token1] = ACTIONS(3415),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3415),
    [sym_interpolation_verbatim_start] = ACTIONS(3415),
    [sym_interpolation_raw_start] = ACTIONS(3415),
  },
  [2661] = {
    [sym_preproc_region] = STATE(2661),
    [sym_preproc_endregion] = STATE(2661),
    [sym_preproc_line] = STATE(2661),
    [sym_preproc_pragma] = STATE(2661),
    [sym_preproc_nullable] = STATE(2661),
    [sym_preproc_error] = STATE(2661),
    [sym_preproc_define] = STATE(2661),
    [sym_preproc_undef] = STATE(2661),
    [sym__identifier_token] = ACTIONS(3405),
    [anon_sym_extern] = ACTIONS(3405),
    [anon_sym_alias] = ACTIONS(3405),
    [anon_sym_SEMI] = ACTIONS(3407),
    [anon_sym_global] = ACTIONS(3405),
    [anon_sym_using] = ACTIONS(3405),
    [anon_sym_unsafe] = ACTIONS(3405),
    [anon_sym_static] = ACTIONS(3405),
    [anon_sym_LBRACK] = ACTIONS(3407),
    [anon_sym_LPAREN] = ACTIONS(3407),
    [anon_sym_return] = ACTIONS(3405),
    [anon_sym_ref] = ACTIONS(3405),
    [anon_sym_LBRACE] = ACTIONS(3407),
    [anon_sym_RBRACE] = ACTIONS(3407),
    [anon_sym_delegate] = ACTIONS(3405),
    [anon_sym_abstract] = ACTIONS(3405),
    [anon_sym_async] = ACTIONS(3405),
    [anon_sym_const] = ACTIONS(3405),
    [anon_sym_file] = ACTIONS(3405),
    [anon_sym_fixed] = ACTIONS(3405),
    [anon_sym_internal] = ACTIONS(3405),
    [anon_sym_new] = ACTIONS(3405),
    [anon_sym_override] = ACTIONS(3405),
    [anon_sym_partial] = ACTIONS(3405),
    [anon_sym_private] = ACTIONS(3405),
    [anon_sym_protected] = ACTIONS(3405),
    [anon_sym_public] = ACTIONS(3405),
    [anon_sym_readonly] = ACTIONS(3405),
    [anon_sym_required] = ACTIONS(3405),
    [anon_sym_sealed] = ACTIONS(3405),
    [anon_sym_virtual] = ACTIONS(3405),
    [anon_sym_volatile] = ACTIONS(3405),
    [anon_sym_where] = ACTIONS(3405),
    [anon_sym_notnull] = ACTIONS(3405),
    [anon_sym_unmanaged] = ACTIONS(3405),
    [anon_sym_checked] = ACTIONS(3405),
    [anon_sym_BANG] = ACTIONS(3407),
    [anon_sym_TILDE] = ACTIONS(3407),
    [anon_sym_PLUS_PLUS] = ACTIONS(3407),
    [anon_sym_DASH_DASH] = ACTIONS(3407),
    [anon_sym_true] = ACTIONS(3405),
    [anon_sym_false] = ACTIONS(3405),
    [anon_sym_PLUS] = ACTIONS(3405),
    [anon_sym_DASH] = ACTIONS(3405),
    [anon_sym_STAR] = ACTIONS(3407),
    [anon_sym_CARET] = ACTIONS(3407),
    [anon_sym_AMP] = ACTIONS(3407),
    [anon_sym_this] = ACTIONS(3405),
    [anon_sym_scoped] = ACTIONS(3405),
    [anon_sym_var] = ACTIONS(3405),
    [sym_predefined_type] = ACTIONS(3405),
    [anon_sym_break] = ACTIONS(3405),
    [anon_sym_unchecked] = ACTIONS(3405),
    [anon_sym_continue] = ACTIONS(3405),
    [anon_sym_do] = ACTIONS(3405),
    [anon_sym_while] = ACTIONS(3405),
    [anon_sym_for] = ACTIONS(3405),
    [anon_sym_lock] = ACTIONS(3405),
    [anon_sym_yield] = ACTIONS(3405),
    [anon_sym_switch] = ACTIONS(3405),
    [anon_sym_case] = ACTIONS(3405),
    [anon_sym_default] = ACTIONS(3405),
    [anon_sym_throw] = ACTIONS(3405),
    [anon_sym_try] = ACTIONS(3405),
    [anon_sym_when] = ACTIONS(3405),
    [anon_sym_await] = ACTIONS(3405),
    [anon_sym_foreach] = ACTIONS(3405),
    [anon_sym_goto] = ACTIONS(3405),
    [anon_sym_if] = ACTIONS(3405),
    [anon_sym_else] = ACTIONS(3405),
    [anon_sym_DOT_DOT] = ACTIONS(3407),
    [anon_sym_from] = ACTIONS(3405),
    [anon_sym_into] = ACTIONS(3405),
    [anon_sym_join] = ACTIONS(3405),
    [anon_sym_on] = ACTIONS(3405),
    [anon_sym_equals] = ACTIONS(3405),
    [anon_sym_let] = ACTIONS(3405),
    [anon_sym_orderby] = ACTIONS(3405),
    [anon_sym_ascending] = ACTIONS(3405),
    [anon_sym_descending] = ACTIONS(3405),
    [anon_sym_group] = ACTIONS(3405),
    [anon_sym_by] = ACTIONS(3405),
    [anon_sym_select] = ACTIONS(3405),
    [anon_sym_DQUOTE] = ACTIONS(3405),
    [anon_sym_stackalloc] = ACTIONS(3405),
    [anon_sym_sizeof] = ACTIONS(3405),
    [anon_sym_typeof] = ACTIONS(3405),
    [anon_sym___makeref] = ACTIONS(3405),
    [anon_sym___reftype] = ACTIONS(3405),
    [anon_sym___refvalue] = ACTIONS(3405),
    [sym_null_literal] = ACTIONS(3405),
    [anon_sym_SQUOTE] = ACTIONS(3407),
    [sym_integer_literal] = ACTIONS(3405),
    [sym_real_literal] = ACTIONS(3407),
    [sym_verbatim_string_literal] = ACTIONS(3407),
    [sym_raw_string_literal] = ACTIONS(3407),
    [aux_sym_preproc_if_token1] = ACTIONS(3407),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3407),
    [sym_interpolation_verbatim_start] = ACTIONS(3407),
    [sym_interpolation_raw_start] = ACTIONS(3407),
  },
  [2662] = {
    [sym_preproc_region] = STATE(2662),
    [sym_preproc_endregion] = STATE(2662),
    [sym_preproc_line] = STATE(2662),
    [sym_preproc_pragma] = STATE(2662),
    [sym_preproc_nullable] = STATE(2662),
    [sym_preproc_error] = STATE(2662),
    [sym_preproc_define] = STATE(2662),
    [sym_preproc_undef] = STATE(2662),
    [sym__identifier_token] = ACTIONS(3367),
    [anon_sym_extern] = ACTIONS(3367),
    [anon_sym_alias] = ACTIONS(3367),
    [anon_sym_SEMI] = ACTIONS(3369),
    [anon_sym_global] = ACTIONS(3367),
    [anon_sym_using] = ACTIONS(3367),
    [anon_sym_unsafe] = ACTIONS(3367),
    [anon_sym_static] = ACTIONS(3367),
    [anon_sym_LBRACK] = ACTIONS(3369),
    [anon_sym_LPAREN] = ACTIONS(3369),
    [anon_sym_return] = ACTIONS(3367),
    [anon_sym_ref] = ACTIONS(3367),
    [anon_sym_LBRACE] = ACTIONS(3369),
    [anon_sym_RBRACE] = ACTIONS(3369),
    [anon_sym_delegate] = ACTIONS(3367),
    [anon_sym_abstract] = ACTIONS(3367),
    [anon_sym_async] = ACTIONS(3367),
    [anon_sym_const] = ACTIONS(3367),
    [anon_sym_file] = ACTIONS(3367),
    [anon_sym_fixed] = ACTIONS(3367),
    [anon_sym_internal] = ACTIONS(3367),
    [anon_sym_new] = ACTIONS(3367),
    [anon_sym_override] = ACTIONS(3367),
    [anon_sym_partial] = ACTIONS(3367),
    [anon_sym_private] = ACTIONS(3367),
    [anon_sym_protected] = ACTIONS(3367),
    [anon_sym_public] = ACTIONS(3367),
    [anon_sym_readonly] = ACTIONS(3367),
    [anon_sym_required] = ACTIONS(3367),
    [anon_sym_sealed] = ACTIONS(3367),
    [anon_sym_virtual] = ACTIONS(3367),
    [anon_sym_volatile] = ACTIONS(3367),
    [anon_sym_where] = ACTIONS(3367),
    [anon_sym_notnull] = ACTIONS(3367),
    [anon_sym_unmanaged] = ACTIONS(3367),
    [anon_sym_checked] = ACTIONS(3367),
    [anon_sym_BANG] = ACTIONS(3369),
    [anon_sym_TILDE] = ACTIONS(3369),
    [anon_sym_PLUS_PLUS] = ACTIONS(3369),
    [anon_sym_DASH_DASH] = ACTIONS(3369),
    [anon_sym_true] = ACTIONS(3367),
    [anon_sym_false] = ACTIONS(3367),
    [anon_sym_PLUS] = ACTIONS(3367),
    [anon_sym_DASH] = ACTIONS(3367),
    [anon_sym_STAR] = ACTIONS(3369),
    [anon_sym_CARET] = ACTIONS(3369),
    [anon_sym_AMP] = ACTIONS(3369),
    [anon_sym_this] = ACTIONS(3367),
    [anon_sym_scoped] = ACTIONS(3367),
    [anon_sym_var] = ACTIONS(3367),
    [sym_predefined_type] = ACTIONS(3367),
    [anon_sym_break] = ACTIONS(3367),
    [anon_sym_unchecked] = ACTIONS(3367),
    [anon_sym_continue] = ACTIONS(3367),
    [anon_sym_do] = ACTIONS(3367),
    [anon_sym_while] = ACTIONS(3367),
    [anon_sym_for] = ACTIONS(3367),
    [anon_sym_lock] = ACTIONS(3367),
    [anon_sym_yield] = ACTIONS(3367),
    [anon_sym_switch] = ACTIONS(3367),
    [anon_sym_case] = ACTIONS(3367),
    [anon_sym_default] = ACTIONS(3367),
    [anon_sym_throw] = ACTIONS(3367),
    [anon_sym_try] = ACTIONS(3367),
    [anon_sym_when] = ACTIONS(3367),
    [anon_sym_await] = ACTIONS(3367),
    [anon_sym_foreach] = ACTIONS(3367),
    [anon_sym_goto] = ACTIONS(3367),
    [anon_sym_if] = ACTIONS(3367),
    [anon_sym_else] = ACTIONS(3367),
    [anon_sym_DOT_DOT] = ACTIONS(3369),
    [anon_sym_from] = ACTIONS(3367),
    [anon_sym_into] = ACTIONS(3367),
    [anon_sym_join] = ACTIONS(3367),
    [anon_sym_on] = ACTIONS(3367),
    [anon_sym_equals] = ACTIONS(3367),
    [anon_sym_let] = ACTIONS(3367),
    [anon_sym_orderby] = ACTIONS(3367),
    [anon_sym_ascending] = ACTIONS(3367),
    [anon_sym_descending] = ACTIONS(3367),
    [anon_sym_group] = ACTIONS(3367),
    [anon_sym_by] = ACTIONS(3367),
    [anon_sym_select] = ACTIONS(3367),
    [anon_sym_DQUOTE] = ACTIONS(3367),
    [anon_sym_stackalloc] = ACTIONS(3367),
    [anon_sym_sizeof] = ACTIONS(3367),
    [anon_sym_typeof] = ACTIONS(3367),
    [anon_sym___makeref] = ACTIONS(3367),
    [anon_sym___reftype] = ACTIONS(3367),
    [anon_sym___refvalue] = ACTIONS(3367),
    [sym_null_literal] = ACTIONS(3367),
    [anon_sym_SQUOTE] = ACTIONS(3369),
    [sym_integer_literal] = ACTIONS(3367),
    [sym_real_literal] = ACTIONS(3369),
    [sym_verbatim_string_literal] = ACTIONS(3369),
    [sym_raw_string_literal] = ACTIONS(3369),
    [aux_sym_preproc_if_token1] = ACTIONS(3369),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3369),
    [sym_interpolation_verbatim_start] = ACTIONS(3369),
    [sym_interpolation_raw_start] = ACTIONS(3369),
  },
  [2663] = {
    [sym_preproc_region] = STATE(2663),
    [sym_preproc_endregion] = STATE(2663),
    [sym_preproc_line] = STATE(2663),
    [sym_preproc_pragma] = STATE(2663),
    [sym_preproc_nullable] = STATE(2663),
    [sym_preproc_error] = STATE(2663),
    [sym_preproc_define] = STATE(2663),
    [sym_preproc_undef] = STATE(2663),
    [sym__identifier_token] = ACTIONS(3303),
    [anon_sym_extern] = ACTIONS(3303),
    [anon_sym_alias] = ACTIONS(3303),
    [anon_sym_SEMI] = ACTIONS(3305),
    [anon_sym_global] = ACTIONS(3303),
    [anon_sym_using] = ACTIONS(3303),
    [anon_sym_unsafe] = ACTIONS(3303),
    [anon_sym_static] = ACTIONS(3303),
    [anon_sym_LBRACK] = ACTIONS(3305),
    [anon_sym_LPAREN] = ACTIONS(3305),
    [anon_sym_return] = ACTIONS(3303),
    [anon_sym_ref] = ACTIONS(3303),
    [anon_sym_LBRACE] = ACTIONS(3305),
    [anon_sym_RBRACE] = ACTIONS(3305),
    [anon_sym_delegate] = ACTIONS(3303),
    [anon_sym_abstract] = ACTIONS(3303),
    [anon_sym_async] = ACTIONS(3303),
    [anon_sym_const] = ACTIONS(3303),
    [anon_sym_file] = ACTIONS(3303),
    [anon_sym_fixed] = ACTIONS(3303),
    [anon_sym_internal] = ACTIONS(3303),
    [anon_sym_new] = ACTIONS(3303),
    [anon_sym_override] = ACTIONS(3303),
    [anon_sym_partial] = ACTIONS(3303),
    [anon_sym_private] = ACTIONS(3303),
    [anon_sym_protected] = ACTIONS(3303),
    [anon_sym_public] = ACTIONS(3303),
    [anon_sym_readonly] = ACTIONS(3303),
    [anon_sym_required] = ACTIONS(3303),
    [anon_sym_sealed] = ACTIONS(3303),
    [anon_sym_virtual] = ACTIONS(3303),
    [anon_sym_volatile] = ACTIONS(3303),
    [anon_sym_where] = ACTIONS(3303),
    [anon_sym_notnull] = ACTIONS(3303),
    [anon_sym_unmanaged] = ACTIONS(3303),
    [anon_sym_checked] = ACTIONS(3303),
    [anon_sym_BANG] = ACTIONS(3305),
    [anon_sym_TILDE] = ACTIONS(3305),
    [anon_sym_PLUS_PLUS] = ACTIONS(3305),
    [anon_sym_DASH_DASH] = ACTIONS(3305),
    [anon_sym_true] = ACTIONS(3303),
    [anon_sym_false] = ACTIONS(3303),
    [anon_sym_PLUS] = ACTIONS(3303),
    [anon_sym_DASH] = ACTIONS(3303),
    [anon_sym_STAR] = ACTIONS(3305),
    [anon_sym_CARET] = ACTIONS(3305),
    [anon_sym_AMP] = ACTIONS(3305),
    [anon_sym_this] = ACTIONS(3303),
    [anon_sym_scoped] = ACTIONS(3303),
    [anon_sym_var] = ACTIONS(3303),
    [sym_predefined_type] = ACTIONS(3303),
    [anon_sym_break] = ACTIONS(3303),
    [anon_sym_unchecked] = ACTIONS(3303),
    [anon_sym_continue] = ACTIONS(3303),
    [anon_sym_do] = ACTIONS(3303),
    [anon_sym_while] = ACTIONS(3303),
    [anon_sym_for] = ACTIONS(3303),
    [anon_sym_lock] = ACTIONS(3303),
    [anon_sym_yield] = ACTIONS(3303),
    [anon_sym_switch] = ACTIONS(3303),
    [anon_sym_case] = ACTIONS(3303),
    [anon_sym_default] = ACTIONS(3303),
    [anon_sym_throw] = ACTIONS(3303),
    [anon_sym_try] = ACTIONS(3303),
    [anon_sym_when] = ACTIONS(3303),
    [anon_sym_await] = ACTIONS(3303),
    [anon_sym_foreach] = ACTIONS(3303),
    [anon_sym_goto] = ACTIONS(3303),
    [anon_sym_if] = ACTIONS(3303),
    [anon_sym_else] = ACTIONS(3303),
    [anon_sym_DOT_DOT] = ACTIONS(3305),
    [anon_sym_from] = ACTIONS(3303),
    [anon_sym_into] = ACTIONS(3303),
    [anon_sym_join] = ACTIONS(3303),
    [anon_sym_on] = ACTIONS(3303),
    [anon_sym_equals] = ACTIONS(3303),
    [anon_sym_let] = ACTIONS(3303),
    [anon_sym_orderby] = ACTIONS(3303),
    [anon_sym_ascending] = ACTIONS(3303),
    [anon_sym_descending] = ACTIONS(3303),
    [anon_sym_group] = ACTIONS(3303),
    [anon_sym_by] = ACTIONS(3303),
    [anon_sym_select] = ACTIONS(3303),
    [anon_sym_DQUOTE] = ACTIONS(3303),
    [anon_sym_stackalloc] = ACTIONS(3303),
    [anon_sym_sizeof] = ACTIONS(3303),
    [anon_sym_typeof] = ACTIONS(3303),
    [anon_sym___makeref] = ACTIONS(3303),
    [anon_sym___reftype] = ACTIONS(3303),
    [anon_sym___refvalue] = ACTIONS(3303),
    [sym_null_literal] = ACTIONS(3303),
    [anon_sym_SQUOTE] = ACTIONS(3305),
    [sym_integer_literal] = ACTIONS(3303),
    [sym_real_literal] = ACTIONS(3305),
    [sym_verbatim_string_literal] = ACTIONS(3305),
    [sym_raw_string_literal] = ACTIONS(3305),
    [aux_sym_preproc_if_token1] = ACTIONS(3305),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3305),
    [sym_interpolation_verbatim_start] = ACTIONS(3305),
    [sym_interpolation_raw_start] = ACTIONS(3305),
  },
  [2664] = {
    [sym_preproc_region] = STATE(2664),
    [sym_preproc_endregion] = STATE(2664),
    [sym_preproc_line] = STATE(2664),
    [sym_preproc_pragma] = STATE(2664),
    [sym_preproc_nullable] = STATE(2664),
    [sym_preproc_error] = STATE(2664),
    [sym_preproc_define] = STATE(2664),
    [sym_preproc_undef] = STATE(2664),
    [sym__identifier_token] = ACTIONS(3299),
    [anon_sym_extern] = ACTIONS(3299),
    [anon_sym_alias] = ACTIONS(3299),
    [anon_sym_SEMI] = ACTIONS(3301),
    [anon_sym_global] = ACTIONS(3299),
    [anon_sym_using] = ACTIONS(3299),
    [anon_sym_unsafe] = ACTIONS(3299),
    [anon_sym_static] = ACTIONS(3299),
    [anon_sym_LBRACK] = ACTIONS(3301),
    [anon_sym_LPAREN] = ACTIONS(3301),
    [anon_sym_return] = ACTIONS(3299),
    [anon_sym_ref] = ACTIONS(3299),
    [anon_sym_LBRACE] = ACTIONS(3301),
    [anon_sym_RBRACE] = ACTIONS(3301),
    [anon_sym_delegate] = ACTIONS(3299),
    [anon_sym_abstract] = ACTIONS(3299),
    [anon_sym_async] = ACTIONS(3299),
    [anon_sym_const] = ACTIONS(3299),
    [anon_sym_file] = ACTIONS(3299),
    [anon_sym_fixed] = ACTIONS(3299),
    [anon_sym_internal] = ACTIONS(3299),
    [anon_sym_new] = ACTIONS(3299),
    [anon_sym_override] = ACTIONS(3299),
    [anon_sym_partial] = ACTIONS(3299),
    [anon_sym_private] = ACTIONS(3299),
    [anon_sym_protected] = ACTIONS(3299),
    [anon_sym_public] = ACTIONS(3299),
    [anon_sym_readonly] = ACTIONS(3299),
    [anon_sym_required] = ACTIONS(3299),
    [anon_sym_sealed] = ACTIONS(3299),
    [anon_sym_virtual] = ACTIONS(3299),
    [anon_sym_volatile] = ACTIONS(3299),
    [anon_sym_where] = ACTIONS(3299),
    [anon_sym_notnull] = ACTIONS(3299),
    [anon_sym_unmanaged] = ACTIONS(3299),
    [anon_sym_checked] = ACTIONS(3299),
    [anon_sym_BANG] = ACTIONS(3301),
    [anon_sym_TILDE] = ACTIONS(3301),
    [anon_sym_PLUS_PLUS] = ACTIONS(3301),
    [anon_sym_DASH_DASH] = ACTIONS(3301),
    [anon_sym_true] = ACTIONS(3299),
    [anon_sym_false] = ACTIONS(3299),
    [anon_sym_PLUS] = ACTIONS(3299),
    [anon_sym_DASH] = ACTIONS(3299),
    [anon_sym_STAR] = ACTIONS(3301),
    [anon_sym_CARET] = ACTIONS(3301),
    [anon_sym_AMP] = ACTIONS(3301),
    [anon_sym_this] = ACTIONS(3299),
    [anon_sym_scoped] = ACTIONS(3299),
    [anon_sym_var] = ACTIONS(3299),
    [sym_predefined_type] = ACTIONS(3299),
    [anon_sym_break] = ACTIONS(3299),
    [anon_sym_unchecked] = ACTIONS(3299),
    [anon_sym_continue] = ACTIONS(3299),
    [anon_sym_do] = ACTIONS(3299),
    [anon_sym_while] = ACTIONS(3299),
    [anon_sym_for] = ACTIONS(3299),
    [anon_sym_lock] = ACTIONS(3299),
    [anon_sym_yield] = ACTIONS(3299),
    [anon_sym_switch] = ACTIONS(3299),
    [anon_sym_case] = ACTIONS(3299),
    [anon_sym_default] = ACTIONS(3299),
    [anon_sym_throw] = ACTIONS(3299),
    [anon_sym_try] = ACTIONS(3299),
    [anon_sym_when] = ACTIONS(3299),
    [anon_sym_await] = ACTIONS(3299),
    [anon_sym_foreach] = ACTIONS(3299),
    [anon_sym_goto] = ACTIONS(3299),
    [anon_sym_if] = ACTIONS(3299),
    [anon_sym_else] = ACTIONS(3299),
    [anon_sym_DOT_DOT] = ACTIONS(3301),
    [anon_sym_from] = ACTIONS(3299),
    [anon_sym_into] = ACTIONS(3299),
    [anon_sym_join] = ACTIONS(3299),
    [anon_sym_on] = ACTIONS(3299),
    [anon_sym_equals] = ACTIONS(3299),
    [anon_sym_let] = ACTIONS(3299),
    [anon_sym_orderby] = ACTIONS(3299),
    [anon_sym_ascending] = ACTIONS(3299),
    [anon_sym_descending] = ACTIONS(3299),
    [anon_sym_group] = ACTIONS(3299),
    [anon_sym_by] = ACTIONS(3299),
    [anon_sym_select] = ACTIONS(3299),
    [anon_sym_DQUOTE] = ACTIONS(3299),
    [anon_sym_stackalloc] = ACTIONS(3299),
    [anon_sym_sizeof] = ACTIONS(3299),
    [anon_sym_typeof] = ACTIONS(3299),
    [anon_sym___makeref] = ACTIONS(3299),
    [anon_sym___reftype] = ACTIONS(3299),
    [anon_sym___refvalue] = ACTIONS(3299),
    [sym_null_literal] = ACTIONS(3299),
    [anon_sym_SQUOTE] = ACTIONS(3301),
    [sym_integer_literal] = ACTIONS(3299),
    [sym_real_literal] = ACTIONS(3301),
    [sym_verbatim_string_literal] = ACTIONS(3301),
    [sym_raw_string_literal] = ACTIONS(3301),
    [aux_sym_preproc_if_token1] = ACTIONS(3301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3301),
    [sym_interpolation_verbatim_start] = ACTIONS(3301),
    [sym_interpolation_raw_start] = ACTIONS(3301),
  },
  [2665] = {
    [sym_preproc_region] = STATE(2665),
    [sym_preproc_endregion] = STATE(2665),
    [sym_preproc_line] = STATE(2665),
    [sym_preproc_pragma] = STATE(2665),
    [sym_preproc_nullable] = STATE(2665),
    [sym_preproc_error] = STATE(2665),
    [sym_preproc_define] = STATE(2665),
    [sym_preproc_undef] = STATE(2665),
    [sym__identifier_token] = ACTIONS(3203),
    [anon_sym_extern] = ACTIONS(3203),
    [anon_sym_alias] = ACTIONS(3203),
    [anon_sym_SEMI] = ACTIONS(3205),
    [anon_sym_global] = ACTIONS(3203),
    [anon_sym_using] = ACTIONS(3203),
    [anon_sym_unsafe] = ACTIONS(3203),
    [anon_sym_static] = ACTIONS(3203),
    [anon_sym_LBRACK] = ACTIONS(3205),
    [anon_sym_LPAREN] = ACTIONS(3205),
    [anon_sym_return] = ACTIONS(3203),
    [anon_sym_ref] = ACTIONS(3203),
    [anon_sym_LBRACE] = ACTIONS(3205),
    [anon_sym_RBRACE] = ACTIONS(3205),
    [anon_sym_delegate] = ACTIONS(3203),
    [anon_sym_abstract] = ACTIONS(3203),
    [anon_sym_async] = ACTIONS(3203),
    [anon_sym_const] = ACTIONS(3203),
    [anon_sym_file] = ACTIONS(3203),
    [anon_sym_fixed] = ACTIONS(3203),
    [anon_sym_internal] = ACTIONS(3203),
    [anon_sym_new] = ACTIONS(3203),
    [anon_sym_override] = ACTIONS(3203),
    [anon_sym_partial] = ACTIONS(3203),
    [anon_sym_private] = ACTIONS(3203),
    [anon_sym_protected] = ACTIONS(3203),
    [anon_sym_public] = ACTIONS(3203),
    [anon_sym_readonly] = ACTIONS(3203),
    [anon_sym_required] = ACTIONS(3203),
    [anon_sym_sealed] = ACTIONS(3203),
    [anon_sym_virtual] = ACTIONS(3203),
    [anon_sym_volatile] = ACTIONS(3203),
    [anon_sym_where] = ACTIONS(3203),
    [anon_sym_notnull] = ACTIONS(3203),
    [anon_sym_unmanaged] = ACTIONS(3203),
    [anon_sym_checked] = ACTIONS(3203),
    [anon_sym_BANG] = ACTIONS(3205),
    [anon_sym_TILDE] = ACTIONS(3205),
    [anon_sym_PLUS_PLUS] = ACTIONS(3205),
    [anon_sym_DASH_DASH] = ACTIONS(3205),
    [anon_sym_true] = ACTIONS(3203),
    [anon_sym_false] = ACTIONS(3203),
    [anon_sym_PLUS] = ACTIONS(3203),
    [anon_sym_DASH] = ACTIONS(3203),
    [anon_sym_STAR] = ACTIONS(3205),
    [anon_sym_CARET] = ACTIONS(3205),
    [anon_sym_AMP] = ACTIONS(3205),
    [anon_sym_this] = ACTIONS(3203),
    [anon_sym_scoped] = ACTIONS(3203),
    [anon_sym_var] = ACTIONS(3203),
    [sym_predefined_type] = ACTIONS(3203),
    [anon_sym_break] = ACTIONS(3203),
    [anon_sym_unchecked] = ACTIONS(3203),
    [anon_sym_continue] = ACTIONS(3203),
    [anon_sym_do] = ACTIONS(3203),
    [anon_sym_while] = ACTIONS(3203),
    [anon_sym_for] = ACTIONS(3203),
    [anon_sym_lock] = ACTIONS(3203),
    [anon_sym_yield] = ACTIONS(3203),
    [anon_sym_switch] = ACTIONS(3203),
    [anon_sym_case] = ACTIONS(3203),
    [anon_sym_default] = ACTIONS(3203),
    [anon_sym_throw] = ACTIONS(3203),
    [anon_sym_try] = ACTIONS(3203),
    [anon_sym_when] = ACTIONS(3203),
    [anon_sym_await] = ACTIONS(3203),
    [anon_sym_foreach] = ACTIONS(3203),
    [anon_sym_goto] = ACTIONS(3203),
    [anon_sym_if] = ACTIONS(3203),
    [anon_sym_else] = ACTIONS(3203),
    [anon_sym_DOT_DOT] = ACTIONS(3205),
    [anon_sym_from] = ACTIONS(3203),
    [anon_sym_into] = ACTIONS(3203),
    [anon_sym_join] = ACTIONS(3203),
    [anon_sym_on] = ACTIONS(3203),
    [anon_sym_equals] = ACTIONS(3203),
    [anon_sym_let] = ACTIONS(3203),
    [anon_sym_orderby] = ACTIONS(3203),
    [anon_sym_ascending] = ACTIONS(3203),
    [anon_sym_descending] = ACTIONS(3203),
    [anon_sym_group] = ACTIONS(3203),
    [anon_sym_by] = ACTIONS(3203),
    [anon_sym_select] = ACTIONS(3203),
    [anon_sym_DQUOTE] = ACTIONS(3203),
    [anon_sym_stackalloc] = ACTIONS(3203),
    [anon_sym_sizeof] = ACTIONS(3203),
    [anon_sym_typeof] = ACTIONS(3203),
    [anon_sym___makeref] = ACTIONS(3203),
    [anon_sym___reftype] = ACTIONS(3203),
    [anon_sym___refvalue] = ACTIONS(3203),
    [sym_null_literal] = ACTIONS(3203),
    [anon_sym_SQUOTE] = ACTIONS(3205),
    [sym_integer_literal] = ACTIONS(3203),
    [sym_real_literal] = ACTIONS(3205),
    [sym_verbatim_string_literal] = ACTIONS(3205),
    [sym_raw_string_literal] = ACTIONS(3205),
    [aux_sym_preproc_if_token1] = ACTIONS(3205),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3205),
    [sym_interpolation_verbatim_start] = ACTIONS(3205),
    [sym_interpolation_raw_start] = ACTIONS(3205),
  },
  [2666] = {
    [sym_preproc_region] = STATE(2666),
    [sym_preproc_endregion] = STATE(2666),
    [sym_preproc_line] = STATE(2666),
    [sym_preproc_pragma] = STATE(2666),
    [sym_preproc_nullable] = STATE(2666),
    [sym_preproc_error] = STATE(2666),
    [sym_preproc_define] = STATE(2666),
    [sym_preproc_undef] = STATE(2666),
    [sym__identifier_token] = ACTIONS(3207),
    [anon_sym_extern] = ACTIONS(3207),
    [anon_sym_alias] = ACTIONS(3207),
    [anon_sym_SEMI] = ACTIONS(3209),
    [anon_sym_global] = ACTIONS(3207),
    [anon_sym_using] = ACTIONS(3207),
    [anon_sym_unsafe] = ACTIONS(3207),
    [anon_sym_static] = ACTIONS(3207),
    [anon_sym_LBRACK] = ACTIONS(3209),
    [anon_sym_LPAREN] = ACTIONS(3209),
    [anon_sym_return] = ACTIONS(3207),
    [anon_sym_ref] = ACTIONS(3207),
    [anon_sym_LBRACE] = ACTIONS(3209),
    [anon_sym_RBRACE] = ACTIONS(3209),
    [anon_sym_delegate] = ACTIONS(3207),
    [anon_sym_abstract] = ACTIONS(3207),
    [anon_sym_async] = ACTIONS(3207),
    [anon_sym_const] = ACTIONS(3207),
    [anon_sym_file] = ACTIONS(3207),
    [anon_sym_fixed] = ACTIONS(3207),
    [anon_sym_internal] = ACTIONS(3207),
    [anon_sym_new] = ACTIONS(3207),
    [anon_sym_override] = ACTIONS(3207),
    [anon_sym_partial] = ACTIONS(3207),
    [anon_sym_private] = ACTIONS(3207),
    [anon_sym_protected] = ACTIONS(3207),
    [anon_sym_public] = ACTIONS(3207),
    [anon_sym_readonly] = ACTIONS(3207),
    [anon_sym_required] = ACTIONS(3207),
    [anon_sym_sealed] = ACTIONS(3207),
    [anon_sym_virtual] = ACTIONS(3207),
    [anon_sym_volatile] = ACTIONS(3207),
    [anon_sym_where] = ACTIONS(3207),
    [anon_sym_notnull] = ACTIONS(3207),
    [anon_sym_unmanaged] = ACTIONS(3207),
    [anon_sym_checked] = ACTIONS(3207),
    [anon_sym_BANG] = ACTIONS(3209),
    [anon_sym_TILDE] = ACTIONS(3209),
    [anon_sym_PLUS_PLUS] = ACTIONS(3209),
    [anon_sym_DASH_DASH] = ACTIONS(3209),
    [anon_sym_true] = ACTIONS(3207),
    [anon_sym_false] = ACTIONS(3207),
    [anon_sym_PLUS] = ACTIONS(3207),
    [anon_sym_DASH] = ACTIONS(3207),
    [anon_sym_STAR] = ACTIONS(3209),
    [anon_sym_CARET] = ACTIONS(3209),
    [anon_sym_AMP] = ACTIONS(3209),
    [anon_sym_this] = ACTIONS(3207),
    [anon_sym_scoped] = ACTIONS(3207),
    [anon_sym_var] = ACTIONS(3207),
    [sym_predefined_type] = ACTIONS(3207),
    [anon_sym_break] = ACTIONS(3207),
    [anon_sym_unchecked] = ACTIONS(3207),
    [anon_sym_continue] = ACTIONS(3207),
    [anon_sym_do] = ACTIONS(3207),
    [anon_sym_while] = ACTIONS(3207),
    [anon_sym_for] = ACTIONS(3207),
    [anon_sym_lock] = ACTIONS(3207),
    [anon_sym_yield] = ACTIONS(3207),
    [anon_sym_switch] = ACTIONS(3207),
    [anon_sym_case] = ACTIONS(3207),
    [anon_sym_default] = ACTIONS(3207),
    [anon_sym_throw] = ACTIONS(3207),
    [anon_sym_try] = ACTIONS(3207),
    [anon_sym_when] = ACTIONS(3207),
    [anon_sym_await] = ACTIONS(3207),
    [anon_sym_foreach] = ACTIONS(3207),
    [anon_sym_goto] = ACTIONS(3207),
    [anon_sym_if] = ACTIONS(3207),
    [anon_sym_else] = ACTIONS(3207),
    [anon_sym_DOT_DOT] = ACTIONS(3209),
    [anon_sym_from] = ACTIONS(3207),
    [anon_sym_into] = ACTIONS(3207),
    [anon_sym_join] = ACTIONS(3207),
    [anon_sym_on] = ACTIONS(3207),
    [anon_sym_equals] = ACTIONS(3207),
    [anon_sym_let] = ACTIONS(3207),
    [anon_sym_orderby] = ACTIONS(3207),
    [anon_sym_ascending] = ACTIONS(3207),
    [anon_sym_descending] = ACTIONS(3207),
    [anon_sym_group] = ACTIONS(3207),
    [anon_sym_by] = ACTIONS(3207),
    [anon_sym_select] = ACTIONS(3207),
    [anon_sym_DQUOTE] = ACTIONS(3207),
    [anon_sym_stackalloc] = ACTIONS(3207),
    [anon_sym_sizeof] = ACTIONS(3207),
    [anon_sym_typeof] = ACTIONS(3207),
    [anon_sym___makeref] = ACTIONS(3207),
    [anon_sym___reftype] = ACTIONS(3207),
    [anon_sym___refvalue] = ACTIONS(3207),
    [sym_null_literal] = ACTIONS(3207),
    [anon_sym_SQUOTE] = ACTIONS(3209),
    [sym_integer_literal] = ACTIONS(3207),
    [sym_real_literal] = ACTIONS(3209),
    [sym_verbatim_string_literal] = ACTIONS(3209),
    [sym_raw_string_literal] = ACTIONS(3209),
    [aux_sym_preproc_if_token1] = ACTIONS(3209),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3209),
    [sym_interpolation_verbatim_start] = ACTIONS(3209),
    [sym_interpolation_raw_start] = ACTIONS(3209),
  },
  [2667] = {
    [sym_preproc_region] = STATE(2667),
    [sym_preproc_endregion] = STATE(2667),
    [sym_preproc_line] = STATE(2667),
    [sym_preproc_pragma] = STATE(2667),
    [sym_preproc_nullable] = STATE(2667),
    [sym_preproc_error] = STATE(2667),
    [sym_preproc_define] = STATE(2667),
    [sym_preproc_undef] = STATE(2667),
    [sym__identifier_token] = ACTIONS(3215),
    [anon_sym_extern] = ACTIONS(3215),
    [anon_sym_alias] = ACTIONS(3215),
    [anon_sym_SEMI] = ACTIONS(3217),
    [anon_sym_global] = ACTIONS(3215),
    [anon_sym_using] = ACTIONS(3215),
    [anon_sym_unsafe] = ACTIONS(3215),
    [anon_sym_static] = ACTIONS(3215),
    [anon_sym_LBRACK] = ACTIONS(3217),
    [anon_sym_LPAREN] = ACTIONS(3217),
    [anon_sym_return] = ACTIONS(3215),
    [anon_sym_ref] = ACTIONS(3215),
    [anon_sym_LBRACE] = ACTIONS(3217),
    [anon_sym_RBRACE] = ACTIONS(3217),
    [anon_sym_delegate] = ACTIONS(3215),
    [anon_sym_abstract] = ACTIONS(3215),
    [anon_sym_async] = ACTIONS(3215),
    [anon_sym_const] = ACTIONS(3215),
    [anon_sym_file] = ACTIONS(3215),
    [anon_sym_fixed] = ACTIONS(3215),
    [anon_sym_internal] = ACTIONS(3215),
    [anon_sym_new] = ACTIONS(3215),
    [anon_sym_override] = ACTIONS(3215),
    [anon_sym_partial] = ACTIONS(3215),
    [anon_sym_private] = ACTIONS(3215),
    [anon_sym_protected] = ACTIONS(3215),
    [anon_sym_public] = ACTIONS(3215),
    [anon_sym_readonly] = ACTIONS(3215),
    [anon_sym_required] = ACTIONS(3215),
    [anon_sym_sealed] = ACTIONS(3215),
    [anon_sym_virtual] = ACTIONS(3215),
    [anon_sym_volatile] = ACTIONS(3215),
    [anon_sym_where] = ACTIONS(3215),
    [anon_sym_notnull] = ACTIONS(3215),
    [anon_sym_unmanaged] = ACTIONS(3215),
    [anon_sym_checked] = ACTIONS(3215),
    [anon_sym_BANG] = ACTIONS(3217),
    [anon_sym_TILDE] = ACTIONS(3217),
    [anon_sym_PLUS_PLUS] = ACTIONS(3217),
    [anon_sym_DASH_DASH] = ACTIONS(3217),
    [anon_sym_true] = ACTIONS(3215),
    [anon_sym_false] = ACTIONS(3215),
    [anon_sym_PLUS] = ACTIONS(3215),
    [anon_sym_DASH] = ACTIONS(3215),
    [anon_sym_STAR] = ACTIONS(3217),
    [anon_sym_CARET] = ACTIONS(3217),
    [anon_sym_AMP] = ACTIONS(3217),
    [anon_sym_this] = ACTIONS(3215),
    [anon_sym_scoped] = ACTIONS(3215),
    [anon_sym_var] = ACTIONS(3215),
    [sym_predefined_type] = ACTIONS(3215),
    [anon_sym_break] = ACTIONS(3215),
    [anon_sym_unchecked] = ACTIONS(3215),
    [anon_sym_continue] = ACTIONS(3215),
    [anon_sym_do] = ACTIONS(3215),
    [anon_sym_while] = ACTIONS(3215),
    [anon_sym_for] = ACTIONS(3215),
    [anon_sym_lock] = ACTIONS(3215),
    [anon_sym_yield] = ACTIONS(3215),
    [anon_sym_switch] = ACTIONS(3215),
    [anon_sym_case] = ACTIONS(3215),
    [anon_sym_default] = ACTIONS(3215),
    [anon_sym_throw] = ACTIONS(3215),
    [anon_sym_try] = ACTIONS(3215),
    [anon_sym_when] = ACTIONS(3215),
    [anon_sym_await] = ACTIONS(3215),
    [anon_sym_foreach] = ACTIONS(3215),
    [anon_sym_goto] = ACTIONS(3215),
    [anon_sym_if] = ACTIONS(3215),
    [anon_sym_else] = ACTIONS(3215),
    [anon_sym_DOT_DOT] = ACTIONS(3217),
    [anon_sym_from] = ACTIONS(3215),
    [anon_sym_into] = ACTIONS(3215),
    [anon_sym_join] = ACTIONS(3215),
    [anon_sym_on] = ACTIONS(3215),
    [anon_sym_equals] = ACTIONS(3215),
    [anon_sym_let] = ACTIONS(3215),
    [anon_sym_orderby] = ACTIONS(3215),
    [anon_sym_ascending] = ACTIONS(3215),
    [anon_sym_descending] = ACTIONS(3215),
    [anon_sym_group] = ACTIONS(3215),
    [anon_sym_by] = ACTIONS(3215),
    [anon_sym_select] = ACTIONS(3215),
    [anon_sym_DQUOTE] = ACTIONS(3215),
    [anon_sym_stackalloc] = ACTIONS(3215),
    [anon_sym_sizeof] = ACTIONS(3215),
    [anon_sym_typeof] = ACTIONS(3215),
    [anon_sym___makeref] = ACTIONS(3215),
    [anon_sym___reftype] = ACTIONS(3215),
    [anon_sym___refvalue] = ACTIONS(3215),
    [sym_null_literal] = ACTIONS(3215),
    [anon_sym_SQUOTE] = ACTIONS(3217),
    [sym_integer_literal] = ACTIONS(3215),
    [sym_real_literal] = ACTIONS(3217),
    [sym_verbatim_string_literal] = ACTIONS(3217),
    [sym_raw_string_literal] = ACTIONS(3217),
    [aux_sym_preproc_if_token1] = ACTIONS(3217),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3217),
    [sym_interpolation_verbatim_start] = ACTIONS(3217),
    [sym_interpolation_raw_start] = ACTIONS(3217),
  },
  [2668] = {
    [sym_preproc_region] = STATE(2668),
    [sym_preproc_endregion] = STATE(2668),
    [sym_preproc_line] = STATE(2668),
    [sym_preproc_pragma] = STATE(2668),
    [sym_preproc_nullable] = STATE(2668),
    [sym_preproc_error] = STATE(2668),
    [sym_preproc_define] = STATE(2668),
    [sym_preproc_undef] = STATE(2668),
    [sym__identifier_token] = ACTIONS(3235),
    [anon_sym_extern] = ACTIONS(3235),
    [anon_sym_alias] = ACTIONS(3235),
    [anon_sym_SEMI] = ACTIONS(3237),
    [anon_sym_global] = ACTIONS(3235),
    [anon_sym_using] = ACTIONS(3235),
    [anon_sym_unsafe] = ACTIONS(3235),
    [anon_sym_static] = ACTIONS(3235),
    [anon_sym_LBRACK] = ACTIONS(3237),
    [anon_sym_LPAREN] = ACTIONS(3237),
    [anon_sym_return] = ACTIONS(3235),
    [anon_sym_ref] = ACTIONS(3235),
    [anon_sym_LBRACE] = ACTIONS(3237),
    [anon_sym_RBRACE] = ACTIONS(3237),
    [anon_sym_delegate] = ACTIONS(3235),
    [anon_sym_abstract] = ACTIONS(3235),
    [anon_sym_async] = ACTIONS(3235),
    [anon_sym_const] = ACTIONS(3235),
    [anon_sym_file] = ACTIONS(3235),
    [anon_sym_fixed] = ACTIONS(3235),
    [anon_sym_internal] = ACTIONS(3235),
    [anon_sym_new] = ACTIONS(3235),
    [anon_sym_override] = ACTIONS(3235),
    [anon_sym_partial] = ACTIONS(3235),
    [anon_sym_private] = ACTIONS(3235),
    [anon_sym_protected] = ACTIONS(3235),
    [anon_sym_public] = ACTIONS(3235),
    [anon_sym_readonly] = ACTIONS(3235),
    [anon_sym_required] = ACTIONS(3235),
    [anon_sym_sealed] = ACTIONS(3235),
    [anon_sym_virtual] = ACTIONS(3235),
    [anon_sym_volatile] = ACTIONS(3235),
    [anon_sym_where] = ACTIONS(3235),
    [anon_sym_notnull] = ACTIONS(3235),
    [anon_sym_unmanaged] = ACTIONS(3235),
    [anon_sym_checked] = ACTIONS(3235),
    [anon_sym_BANG] = ACTIONS(3237),
    [anon_sym_TILDE] = ACTIONS(3237),
    [anon_sym_PLUS_PLUS] = ACTIONS(3237),
    [anon_sym_DASH_DASH] = ACTIONS(3237),
    [anon_sym_true] = ACTIONS(3235),
    [anon_sym_false] = ACTIONS(3235),
    [anon_sym_PLUS] = ACTIONS(3235),
    [anon_sym_DASH] = ACTIONS(3235),
    [anon_sym_STAR] = ACTIONS(3237),
    [anon_sym_CARET] = ACTIONS(3237),
    [anon_sym_AMP] = ACTIONS(3237),
    [anon_sym_this] = ACTIONS(3235),
    [anon_sym_scoped] = ACTIONS(3235),
    [anon_sym_var] = ACTIONS(3235),
    [sym_predefined_type] = ACTIONS(3235),
    [anon_sym_break] = ACTIONS(3235),
    [anon_sym_unchecked] = ACTIONS(3235),
    [anon_sym_continue] = ACTIONS(3235),
    [anon_sym_do] = ACTIONS(3235),
    [anon_sym_while] = ACTIONS(3235),
    [anon_sym_for] = ACTIONS(3235),
    [anon_sym_lock] = ACTIONS(3235),
    [anon_sym_yield] = ACTIONS(3235),
    [anon_sym_switch] = ACTIONS(3235),
    [anon_sym_case] = ACTIONS(3235),
    [anon_sym_default] = ACTIONS(3235),
    [anon_sym_throw] = ACTIONS(3235),
    [anon_sym_try] = ACTIONS(3235),
    [anon_sym_when] = ACTIONS(3235),
    [anon_sym_await] = ACTIONS(3235),
    [anon_sym_foreach] = ACTIONS(3235),
    [anon_sym_goto] = ACTIONS(3235),
    [anon_sym_if] = ACTIONS(3235),
    [anon_sym_else] = ACTIONS(3235),
    [anon_sym_DOT_DOT] = ACTIONS(3237),
    [anon_sym_from] = ACTIONS(3235),
    [anon_sym_into] = ACTIONS(3235),
    [anon_sym_join] = ACTIONS(3235),
    [anon_sym_on] = ACTIONS(3235),
    [anon_sym_equals] = ACTIONS(3235),
    [anon_sym_let] = ACTIONS(3235),
    [anon_sym_orderby] = ACTIONS(3235),
    [anon_sym_ascending] = ACTIONS(3235),
    [anon_sym_descending] = ACTIONS(3235),
    [anon_sym_group] = ACTIONS(3235),
    [anon_sym_by] = ACTIONS(3235),
    [anon_sym_select] = ACTIONS(3235),
    [anon_sym_DQUOTE] = ACTIONS(3235),
    [anon_sym_stackalloc] = ACTIONS(3235),
    [anon_sym_sizeof] = ACTIONS(3235),
    [anon_sym_typeof] = ACTIONS(3235),
    [anon_sym___makeref] = ACTIONS(3235),
    [anon_sym___reftype] = ACTIONS(3235),
    [anon_sym___refvalue] = ACTIONS(3235),
    [sym_null_literal] = ACTIONS(3235),
    [anon_sym_SQUOTE] = ACTIONS(3237),
    [sym_integer_literal] = ACTIONS(3235),
    [sym_real_literal] = ACTIONS(3237),
    [sym_verbatim_string_literal] = ACTIONS(3237),
    [sym_raw_string_literal] = ACTIONS(3237),
    [aux_sym_preproc_if_token1] = ACTIONS(3237),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3237),
    [sym_interpolation_verbatim_start] = ACTIONS(3237),
    [sym_interpolation_raw_start] = ACTIONS(3237),
  },
  [2669] = {
    [sym_preproc_region] = STATE(2669),
    [sym_preproc_endregion] = STATE(2669),
    [sym_preproc_line] = STATE(2669),
    [sym_preproc_pragma] = STATE(2669),
    [sym_preproc_nullable] = STATE(2669),
    [sym_preproc_error] = STATE(2669),
    [sym_preproc_define] = STATE(2669),
    [sym_preproc_undef] = STATE(2669),
    [sym__identifier_token] = ACTIONS(3105),
    [anon_sym_extern] = ACTIONS(3105),
    [anon_sym_alias] = ACTIONS(3105),
    [anon_sym_SEMI] = ACTIONS(3107),
    [anon_sym_global] = ACTIONS(3105),
    [anon_sym_using] = ACTIONS(3105),
    [anon_sym_unsafe] = ACTIONS(3105),
    [anon_sym_static] = ACTIONS(3105),
    [anon_sym_LBRACK] = ACTIONS(3107),
    [anon_sym_LPAREN] = ACTIONS(3107),
    [anon_sym_return] = ACTIONS(3105),
    [anon_sym_ref] = ACTIONS(3105),
    [anon_sym_LBRACE] = ACTIONS(3107),
    [anon_sym_RBRACE] = ACTIONS(3107),
    [anon_sym_delegate] = ACTIONS(3105),
    [anon_sym_abstract] = ACTIONS(3105),
    [anon_sym_async] = ACTIONS(3105),
    [anon_sym_const] = ACTIONS(3105),
    [anon_sym_file] = ACTIONS(3105),
    [anon_sym_fixed] = ACTIONS(3105),
    [anon_sym_internal] = ACTIONS(3105),
    [anon_sym_new] = ACTIONS(3105),
    [anon_sym_override] = ACTIONS(3105),
    [anon_sym_partial] = ACTIONS(3105),
    [anon_sym_private] = ACTIONS(3105),
    [anon_sym_protected] = ACTIONS(3105),
    [anon_sym_public] = ACTIONS(3105),
    [anon_sym_readonly] = ACTIONS(3105),
    [anon_sym_required] = ACTIONS(3105),
    [anon_sym_sealed] = ACTIONS(3105),
    [anon_sym_virtual] = ACTIONS(3105),
    [anon_sym_volatile] = ACTIONS(3105),
    [anon_sym_where] = ACTIONS(3105),
    [anon_sym_notnull] = ACTIONS(3105),
    [anon_sym_unmanaged] = ACTIONS(3105),
    [anon_sym_checked] = ACTIONS(3105),
    [anon_sym_BANG] = ACTIONS(3107),
    [anon_sym_TILDE] = ACTIONS(3107),
    [anon_sym_PLUS_PLUS] = ACTIONS(3107),
    [anon_sym_DASH_DASH] = ACTIONS(3107),
    [anon_sym_true] = ACTIONS(3105),
    [anon_sym_false] = ACTIONS(3105),
    [anon_sym_PLUS] = ACTIONS(3105),
    [anon_sym_DASH] = ACTIONS(3105),
    [anon_sym_STAR] = ACTIONS(3107),
    [anon_sym_CARET] = ACTIONS(3107),
    [anon_sym_AMP] = ACTIONS(3107),
    [anon_sym_this] = ACTIONS(3105),
    [anon_sym_scoped] = ACTIONS(3105),
    [anon_sym_var] = ACTIONS(3105),
    [sym_predefined_type] = ACTIONS(3105),
    [anon_sym_break] = ACTIONS(3105),
    [anon_sym_unchecked] = ACTIONS(3105),
    [anon_sym_continue] = ACTIONS(3105),
    [anon_sym_do] = ACTIONS(3105),
    [anon_sym_while] = ACTIONS(3105),
    [anon_sym_for] = ACTIONS(3105),
    [anon_sym_lock] = ACTIONS(3105),
    [anon_sym_yield] = ACTIONS(3105),
    [anon_sym_switch] = ACTIONS(3105),
    [anon_sym_case] = ACTIONS(3105),
    [anon_sym_default] = ACTIONS(3105),
    [anon_sym_throw] = ACTIONS(3105),
    [anon_sym_try] = ACTIONS(3105),
    [anon_sym_when] = ACTIONS(3105),
    [anon_sym_await] = ACTIONS(3105),
    [anon_sym_foreach] = ACTIONS(3105),
    [anon_sym_goto] = ACTIONS(3105),
    [anon_sym_if] = ACTIONS(3105),
    [anon_sym_else] = ACTIONS(3105),
    [anon_sym_DOT_DOT] = ACTIONS(3107),
    [anon_sym_from] = ACTIONS(3105),
    [anon_sym_into] = ACTIONS(3105),
    [anon_sym_join] = ACTIONS(3105),
    [anon_sym_on] = ACTIONS(3105),
    [anon_sym_equals] = ACTIONS(3105),
    [anon_sym_let] = ACTIONS(3105),
    [anon_sym_orderby] = ACTIONS(3105),
    [anon_sym_ascending] = ACTIONS(3105),
    [anon_sym_descending] = ACTIONS(3105),
    [anon_sym_group] = ACTIONS(3105),
    [anon_sym_by] = ACTIONS(3105),
    [anon_sym_select] = ACTIONS(3105),
    [anon_sym_DQUOTE] = ACTIONS(3105),
    [anon_sym_stackalloc] = ACTIONS(3105),
    [anon_sym_sizeof] = ACTIONS(3105),
    [anon_sym_typeof] = ACTIONS(3105),
    [anon_sym___makeref] = ACTIONS(3105),
    [anon_sym___reftype] = ACTIONS(3105),
    [anon_sym___refvalue] = ACTIONS(3105),
    [sym_null_literal] = ACTIONS(3105),
    [anon_sym_SQUOTE] = ACTIONS(3107),
    [sym_integer_literal] = ACTIONS(3105),
    [sym_real_literal] = ACTIONS(3107),
    [sym_verbatim_string_literal] = ACTIONS(3107),
    [sym_raw_string_literal] = ACTIONS(3107),
    [aux_sym_preproc_if_token1] = ACTIONS(3107),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3107),
    [sym_interpolation_verbatim_start] = ACTIONS(3107),
    [sym_interpolation_raw_start] = ACTIONS(3107),
  },
  [2670] = {
    [sym_preproc_region] = STATE(2670),
    [sym_preproc_endregion] = STATE(2670),
    [sym_preproc_line] = STATE(2670),
    [sym_preproc_pragma] = STATE(2670),
    [sym_preproc_nullable] = STATE(2670),
    [sym_preproc_error] = STATE(2670),
    [sym_preproc_define] = STATE(2670),
    [sym_preproc_undef] = STATE(2670),
    [sym__identifier_token] = ACTIONS(3219),
    [anon_sym_extern] = ACTIONS(3219),
    [anon_sym_alias] = ACTIONS(3219),
    [anon_sym_SEMI] = ACTIONS(3221),
    [anon_sym_global] = ACTIONS(3219),
    [anon_sym_using] = ACTIONS(3219),
    [anon_sym_unsafe] = ACTIONS(3219),
    [anon_sym_static] = ACTIONS(3219),
    [anon_sym_LBRACK] = ACTIONS(3221),
    [anon_sym_LPAREN] = ACTIONS(3221),
    [anon_sym_return] = ACTIONS(3219),
    [anon_sym_ref] = ACTIONS(3219),
    [anon_sym_LBRACE] = ACTIONS(3221),
    [anon_sym_RBRACE] = ACTIONS(3221),
    [anon_sym_delegate] = ACTIONS(3219),
    [anon_sym_abstract] = ACTIONS(3219),
    [anon_sym_async] = ACTIONS(3219),
    [anon_sym_const] = ACTIONS(3219),
    [anon_sym_file] = ACTIONS(3219),
    [anon_sym_fixed] = ACTIONS(3219),
    [anon_sym_internal] = ACTIONS(3219),
    [anon_sym_new] = ACTIONS(3219),
    [anon_sym_override] = ACTIONS(3219),
    [anon_sym_partial] = ACTIONS(3219),
    [anon_sym_private] = ACTIONS(3219),
    [anon_sym_protected] = ACTIONS(3219),
    [anon_sym_public] = ACTIONS(3219),
    [anon_sym_readonly] = ACTIONS(3219),
    [anon_sym_required] = ACTIONS(3219),
    [anon_sym_sealed] = ACTIONS(3219),
    [anon_sym_virtual] = ACTIONS(3219),
    [anon_sym_volatile] = ACTIONS(3219),
    [anon_sym_where] = ACTIONS(3219),
    [anon_sym_notnull] = ACTIONS(3219),
    [anon_sym_unmanaged] = ACTIONS(3219),
    [anon_sym_checked] = ACTIONS(3219),
    [anon_sym_BANG] = ACTIONS(3221),
    [anon_sym_TILDE] = ACTIONS(3221),
    [anon_sym_PLUS_PLUS] = ACTIONS(3221),
    [anon_sym_DASH_DASH] = ACTIONS(3221),
    [anon_sym_true] = ACTIONS(3219),
    [anon_sym_false] = ACTIONS(3219),
    [anon_sym_PLUS] = ACTIONS(3219),
    [anon_sym_DASH] = ACTIONS(3219),
    [anon_sym_STAR] = ACTIONS(3221),
    [anon_sym_CARET] = ACTIONS(3221),
    [anon_sym_AMP] = ACTIONS(3221),
    [anon_sym_this] = ACTIONS(3219),
    [anon_sym_scoped] = ACTIONS(3219),
    [anon_sym_var] = ACTIONS(3219),
    [sym_predefined_type] = ACTIONS(3219),
    [anon_sym_break] = ACTIONS(3219),
    [anon_sym_unchecked] = ACTIONS(3219),
    [anon_sym_continue] = ACTIONS(3219),
    [anon_sym_do] = ACTIONS(3219),
    [anon_sym_while] = ACTIONS(3219),
    [anon_sym_for] = ACTIONS(3219),
    [anon_sym_lock] = ACTIONS(3219),
    [anon_sym_yield] = ACTIONS(3219),
    [anon_sym_switch] = ACTIONS(3219),
    [anon_sym_case] = ACTIONS(3219),
    [anon_sym_default] = ACTIONS(3219),
    [anon_sym_throw] = ACTIONS(3219),
    [anon_sym_try] = ACTIONS(3219),
    [anon_sym_when] = ACTIONS(3219),
    [anon_sym_await] = ACTIONS(3219),
    [anon_sym_foreach] = ACTIONS(3219),
    [anon_sym_goto] = ACTIONS(3219),
    [anon_sym_if] = ACTIONS(3219),
    [anon_sym_else] = ACTIONS(3219),
    [anon_sym_DOT_DOT] = ACTIONS(3221),
    [anon_sym_from] = ACTIONS(3219),
    [anon_sym_into] = ACTIONS(3219),
    [anon_sym_join] = ACTIONS(3219),
    [anon_sym_on] = ACTIONS(3219),
    [anon_sym_equals] = ACTIONS(3219),
    [anon_sym_let] = ACTIONS(3219),
    [anon_sym_orderby] = ACTIONS(3219),
    [anon_sym_ascending] = ACTIONS(3219),
    [anon_sym_descending] = ACTIONS(3219),
    [anon_sym_group] = ACTIONS(3219),
    [anon_sym_by] = ACTIONS(3219),
    [anon_sym_select] = ACTIONS(3219),
    [anon_sym_DQUOTE] = ACTIONS(3219),
    [anon_sym_stackalloc] = ACTIONS(3219),
    [anon_sym_sizeof] = ACTIONS(3219),
    [anon_sym_typeof] = ACTIONS(3219),
    [anon_sym___makeref] = ACTIONS(3219),
    [anon_sym___reftype] = ACTIONS(3219),
    [anon_sym___refvalue] = ACTIONS(3219),
    [sym_null_literal] = ACTIONS(3219),
    [anon_sym_SQUOTE] = ACTIONS(3221),
    [sym_integer_literal] = ACTIONS(3219),
    [sym_real_literal] = ACTIONS(3221),
    [sym_verbatim_string_literal] = ACTIONS(3221),
    [sym_raw_string_literal] = ACTIONS(3221),
    [aux_sym_preproc_if_token1] = ACTIONS(3221),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3221),
    [sym_interpolation_verbatim_start] = ACTIONS(3221),
    [sym_interpolation_raw_start] = ACTIONS(3221),
  },
  [2671] = {
    [sym_preproc_region] = STATE(2671),
    [sym_preproc_endregion] = STATE(2671),
    [sym_preproc_line] = STATE(2671),
    [sym_preproc_pragma] = STATE(2671),
    [sym_preproc_nullable] = STATE(2671),
    [sym_preproc_error] = STATE(2671),
    [sym_preproc_define] = STATE(2671),
    [sym_preproc_undef] = STATE(2671),
    [sym__identifier_token] = ACTIONS(3247),
    [anon_sym_extern] = ACTIONS(3247),
    [anon_sym_alias] = ACTIONS(3247),
    [anon_sym_SEMI] = ACTIONS(3249),
    [anon_sym_global] = ACTIONS(3247),
    [anon_sym_using] = ACTIONS(3247),
    [anon_sym_unsafe] = ACTIONS(3247),
    [anon_sym_static] = ACTIONS(3247),
    [anon_sym_LBRACK] = ACTIONS(3249),
    [anon_sym_LPAREN] = ACTIONS(3249),
    [anon_sym_return] = ACTIONS(3247),
    [anon_sym_ref] = ACTIONS(3247),
    [anon_sym_LBRACE] = ACTIONS(3249),
    [anon_sym_RBRACE] = ACTIONS(3249),
    [anon_sym_delegate] = ACTIONS(3247),
    [anon_sym_abstract] = ACTIONS(3247),
    [anon_sym_async] = ACTIONS(3247),
    [anon_sym_const] = ACTIONS(3247),
    [anon_sym_file] = ACTIONS(3247),
    [anon_sym_fixed] = ACTIONS(3247),
    [anon_sym_internal] = ACTIONS(3247),
    [anon_sym_new] = ACTIONS(3247),
    [anon_sym_override] = ACTIONS(3247),
    [anon_sym_partial] = ACTIONS(3247),
    [anon_sym_private] = ACTIONS(3247),
    [anon_sym_protected] = ACTIONS(3247),
    [anon_sym_public] = ACTIONS(3247),
    [anon_sym_readonly] = ACTIONS(3247),
    [anon_sym_required] = ACTIONS(3247),
    [anon_sym_sealed] = ACTIONS(3247),
    [anon_sym_virtual] = ACTIONS(3247),
    [anon_sym_volatile] = ACTIONS(3247),
    [anon_sym_where] = ACTIONS(3247),
    [anon_sym_notnull] = ACTIONS(3247),
    [anon_sym_unmanaged] = ACTIONS(3247),
    [anon_sym_checked] = ACTIONS(3247),
    [anon_sym_BANG] = ACTIONS(3249),
    [anon_sym_TILDE] = ACTIONS(3249),
    [anon_sym_PLUS_PLUS] = ACTIONS(3249),
    [anon_sym_DASH_DASH] = ACTIONS(3249),
    [anon_sym_true] = ACTIONS(3247),
    [anon_sym_false] = ACTIONS(3247),
    [anon_sym_PLUS] = ACTIONS(3247),
    [anon_sym_DASH] = ACTIONS(3247),
    [anon_sym_STAR] = ACTIONS(3249),
    [anon_sym_CARET] = ACTIONS(3249),
    [anon_sym_AMP] = ACTIONS(3249),
    [anon_sym_this] = ACTIONS(3247),
    [anon_sym_scoped] = ACTIONS(3247),
    [anon_sym_var] = ACTIONS(3247),
    [sym_predefined_type] = ACTIONS(3247),
    [anon_sym_break] = ACTIONS(3247),
    [anon_sym_unchecked] = ACTIONS(3247),
    [anon_sym_continue] = ACTIONS(3247),
    [anon_sym_do] = ACTIONS(3247),
    [anon_sym_while] = ACTIONS(3247),
    [anon_sym_for] = ACTIONS(3247),
    [anon_sym_lock] = ACTIONS(3247),
    [anon_sym_yield] = ACTIONS(3247),
    [anon_sym_switch] = ACTIONS(3247),
    [anon_sym_case] = ACTIONS(3247),
    [anon_sym_default] = ACTIONS(3247),
    [anon_sym_throw] = ACTIONS(3247),
    [anon_sym_try] = ACTIONS(3247),
    [anon_sym_when] = ACTIONS(3247),
    [anon_sym_await] = ACTIONS(3247),
    [anon_sym_foreach] = ACTIONS(3247),
    [anon_sym_goto] = ACTIONS(3247),
    [anon_sym_if] = ACTIONS(3247),
    [anon_sym_else] = ACTIONS(3247),
    [anon_sym_DOT_DOT] = ACTIONS(3249),
    [anon_sym_from] = ACTIONS(3247),
    [anon_sym_into] = ACTIONS(3247),
    [anon_sym_join] = ACTIONS(3247),
    [anon_sym_on] = ACTIONS(3247),
    [anon_sym_equals] = ACTIONS(3247),
    [anon_sym_let] = ACTIONS(3247),
    [anon_sym_orderby] = ACTIONS(3247),
    [anon_sym_ascending] = ACTIONS(3247),
    [anon_sym_descending] = ACTIONS(3247),
    [anon_sym_group] = ACTIONS(3247),
    [anon_sym_by] = ACTIONS(3247),
    [anon_sym_select] = ACTIONS(3247),
    [anon_sym_DQUOTE] = ACTIONS(3247),
    [anon_sym_stackalloc] = ACTIONS(3247),
    [anon_sym_sizeof] = ACTIONS(3247),
    [anon_sym_typeof] = ACTIONS(3247),
    [anon_sym___makeref] = ACTIONS(3247),
    [anon_sym___reftype] = ACTIONS(3247),
    [anon_sym___refvalue] = ACTIONS(3247),
    [sym_null_literal] = ACTIONS(3247),
    [anon_sym_SQUOTE] = ACTIONS(3249),
    [sym_integer_literal] = ACTIONS(3247),
    [sym_real_literal] = ACTIONS(3249),
    [sym_verbatim_string_literal] = ACTIONS(3249),
    [sym_raw_string_literal] = ACTIONS(3249),
    [aux_sym_preproc_if_token1] = ACTIONS(3249),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3249),
    [sym_interpolation_verbatim_start] = ACTIONS(3249),
    [sym_interpolation_raw_start] = ACTIONS(3249),
  },
  [2672] = {
    [sym_preproc_region] = STATE(2672),
    [sym_preproc_endregion] = STATE(2672),
    [sym_preproc_line] = STATE(2672),
    [sym_preproc_pragma] = STATE(2672),
    [sym_preproc_nullable] = STATE(2672),
    [sym_preproc_error] = STATE(2672),
    [sym_preproc_define] = STATE(2672),
    [sym_preproc_undef] = STATE(2672),
    [sym__identifier_token] = ACTIONS(3291),
    [anon_sym_extern] = ACTIONS(3291),
    [anon_sym_alias] = ACTIONS(3291),
    [anon_sym_SEMI] = ACTIONS(3293),
    [anon_sym_global] = ACTIONS(3291),
    [anon_sym_using] = ACTIONS(3291),
    [anon_sym_unsafe] = ACTIONS(3291),
    [anon_sym_static] = ACTIONS(3291),
    [anon_sym_LBRACK] = ACTIONS(3293),
    [anon_sym_LPAREN] = ACTIONS(3293),
    [anon_sym_return] = ACTIONS(3291),
    [anon_sym_ref] = ACTIONS(3291),
    [anon_sym_LBRACE] = ACTIONS(3293),
    [anon_sym_RBRACE] = ACTIONS(3293),
    [anon_sym_delegate] = ACTIONS(3291),
    [anon_sym_abstract] = ACTIONS(3291),
    [anon_sym_async] = ACTIONS(3291),
    [anon_sym_const] = ACTIONS(3291),
    [anon_sym_file] = ACTIONS(3291),
    [anon_sym_fixed] = ACTIONS(3291),
    [anon_sym_internal] = ACTIONS(3291),
    [anon_sym_new] = ACTIONS(3291),
    [anon_sym_override] = ACTIONS(3291),
    [anon_sym_partial] = ACTIONS(3291),
    [anon_sym_private] = ACTIONS(3291),
    [anon_sym_protected] = ACTIONS(3291),
    [anon_sym_public] = ACTIONS(3291),
    [anon_sym_readonly] = ACTIONS(3291),
    [anon_sym_required] = ACTIONS(3291),
    [anon_sym_sealed] = ACTIONS(3291),
    [anon_sym_virtual] = ACTIONS(3291),
    [anon_sym_volatile] = ACTIONS(3291),
    [anon_sym_where] = ACTIONS(3291),
    [anon_sym_notnull] = ACTIONS(3291),
    [anon_sym_unmanaged] = ACTIONS(3291),
    [anon_sym_checked] = ACTIONS(3291),
    [anon_sym_BANG] = ACTIONS(3293),
    [anon_sym_TILDE] = ACTIONS(3293),
    [anon_sym_PLUS_PLUS] = ACTIONS(3293),
    [anon_sym_DASH_DASH] = ACTIONS(3293),
    [anon_sym_true] = ACTIONS(3291),
    [anon_sym_false] = ACTIONS(3291),
    [anon_sym_PLUS] = ACTIONS(3291),
    [anon_sym_DASH] = ACTIONS(3291),
    [anon_sym_STAR] = ACTIONS(3293),
    [anon_sym_CARET] = ACTIONS(3293),
    [anon_sym_AMP] = ACTIONS(3293),
    [anon_sym_this] = ACTIONS(3291),
    [anon_sym_scoped] = ACTIONS(3291),
    [anon_sym_var] = ACTIONS(3291),
    [sym_predefined_type] = ACTIONS(3291),
    [anon_sym_break] = ACTIONS(3291),
    [anon_sym_unchecked] = ACTIONS(3291),
    [anon_sym_continue] = ACTIONS(3291),
    [anon_sym_do] = ACTIONS(3291),
    [anon_sym_while] = ACTIONS(3291),
    [anon_sym_for] = ACTIONS(3291),
    [anon_sym_lock] = ACTIONS(3291),
    [anon_sym_yield] = ACTIONS(3291),
    [anon_sym_switch] = ACTIONS(3291),
    [anon_sym_case] = ACTIONS(3291),
    [anon_sym_default] = ACTIONS(3291),
    [anon_sym_throw] = ACTIONS(3291),
    [anon_sym_try] = ACTIONS(3291),
    [anon_sym_when] = ACTIONS(3291),
    [anon_sym_await] = ACTIONS(3291),
    [anon_sym_foreach] = ACTIONS(3291),
    [anon_sym_goto] = ACTIONS(3291),
    [anon_sym_if] = ACTIONS(3291),
    [anon_sym_else] = ACTIONS(3291),
    [anon_sym_DOT_DOT] = ACTIONS(3293),
    [anon_sym_from] = ACTIONS(3291),
    [anon_sym_into] = ACTIONS(3291),
    [anon_sym_join] = ACTIONS(3291),
    [anon_sym_on] = ACTIONS(3291),
    [anon_sym_equals] = ACTIONS(3291),
    [anon_sym_let] = ACTIONS(3291),
    [anon_sym_orderby] = ACTIONS(3291),
    [anon_sym_ascending] = ACTIONS(3291),
    [anon_sym_descending] = ACTIONS(3291),
    [anon_sym_group] = ACTIONS(3291),
    [anon_sym_by] = ACTIONS(3291),
    [anon_sym_select] = ACTIONS(3291),
    [anon_sym_DQUOTE] = ACTIONS(3291),
    [anon_sym_stackalloc] = ACTIONS(3291),
    [anon_sym_sizeof] = ACTIONS(3291),
    [anon_sym_typeof] = ACTIONS(3291),
    [anon_sym___makeref] = ACTIONS(3291),
    [anon_sym___reftype] = ACTIONS(3291),
    [anon_sym___refvalue] = ACTIONS(3291),
    [sym_null_literal] = ACTIONS(3291),
    [anon_sym_SQUOTE] = ACTIONS(3293),
    [sym_integer_literal] = ACTIONS(3291),
    [sym_real_literal] = ACTIONS(3293),
    [sym_verbatim_string_literal] = ACTIONS(3293),
    [sym_raw_string_literal] = ACTIONS(3293),
    [aux_sym_preproc_if_token1] = ACTIONS(3293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3293),
    [sym_interpolation_verbatim_start] = ACTIONS(3293),
    [sym_interpolation_raw_start] = ACTIONS(3293),
  },
  [2673] = {
    [sym_preproc_region] = STATE(2673),
    [sym_preproc_endregion] = STATE(2673),
    [sym_preproc_line] = STATE(2673),
    [sym_preproc_pragma] = STATE(2673),
    [sym_preproc_nullable] = STATE(2673),
    [sym_preproc_error] = STATE(2673),
    [sym_preproc_define] = STATE(2673),
    [sym_preproc_undef] = STATE(2673),
    [sym__identifier_token] = ACTIONS(3307),
    [anon_sym_extern] = ACTIONS(3307),
    [anon_sym_alias] = ACTIONS(3307),
    [anon_sym_SEMI] = ACTIONS(3309),
    [anon_sym_global] = ACTIONS(3307),
    [anon_sym_using] = ACTIONS(3307),
    [anon_sym_unsafe] = ACTIONS(3307),
    [anon_sym_static] = ACTIONS(3307),
    [anon_sym_LBRACK] = ACTIONS(3309),
    [anon_sym_LPAREN] = ACTIONS(3309),
    [anon_sym_return] = ACTIONS(3307),
    [anon_sym_ref] = ACTIONS(3307),
    [anon_sym_LBRACE] = ACTIONS(3309),
    [anon_sym_RBRACE] = ACTIONS(3309),
    [anon_sym_delegate] = ACTIONS(3307),
    [anon_sym_abstract] = ACTIONS(3307),
    [anon_sym_async] = ACTIONS(3307),
    [anon_sym_const] = ACTIONS(3307),
    [anon_sym_file] = ACTIONS(3307),
    [anon_sym_fixed] = ACTIONS(3307),
    [anon_sym_internal] = ACTIONS(3307),
    [anon_sym_new] = ACTIONS(3307),
    [anon_sym_override] = ACTIONS(3307),
    [anon_sym_partial] = ACTIONS(3307),
    [anon_sym_private] = ACTIONS(3307),
    [anon_sym_protected] = ACTIONS(3307),
    [anon_sym_public] = ACTIONS(3307),
    [anon_sym_readonly] = ACTIONS(3307),
    [anon_sym_required] = ACTIONS(3307),
    [anon_sym_sealed] = ACTIONS(3307),
    [anon_sym_virtual] = ACTIONS(3307),
    [anon_sym_volatile] = ACTIONS(3307),
    [anon_sym_where] = ACTIONS(3307),
    [anon_sym_notnull] = ACTIONS(3307),
    [anon_sym_unmanaged] = ACTIONS(3307),
    [anon_sym_checked] = ACTIONS(3307),
    [anon_sym_BANG] = ACTIONS(3309),
    [anon_sym_TILDE] = ACTIONS(3309),
    [anon_sym_PLUS_PLUS] = ACTIONS(3309),
    [anon_sym_DASH_DASH] = ACTIONS(3309),
    [anon_sym_true] = ACTIONS(3307),
    [anon_sym_false] = ACTIONS(3307),
    [anon_sym_PLUS] = ACTIONS(3307),
    [anon_sym_DASH] = ACTIONS(3307),
    [anon_sym_STAR] = ACTIONS(3309),
    [anon_sym_CARET] = ACTIONS(3309),
    [anon_sym_AMP] = ACTIONS(3309),
    [anon_sym_this] = ACTIONS(3307),
    [anon_sym_scoped] = ACTIONS(3307),
    [anon_sym_var] = ACTIONS(3307),
    [sym_predefined_type] = ACTIONS(3307),
    [anon_sym_break] = ACTIONS(3307),
    [anon_sym_unchecked] = ACTIONS(3307),
    [anon_sym_continue] = ACTIONS(3307),
    [anon_sym_do] = ACTIONS(3307),
    [anon_sym_while] = ACTIONS(3307),
    [anon_sym_for] = ACTIONS(3307),
    [anon_sym_lock] = ACTIONS(3307),
    [anon_sym_yield] = ACTIONS(3307),
    [anon_sym_switch] = ACTIONS(3307),
    [anon_sym_case] = ACTIONS(3307),
    [anon_sym_default] = ACTIONS(3307),
    [anon_sym_throw] = ACTIONS(3307),
    [anon_sym_try] = ACTIONS(3307),
    [anon_sym_when] = ACTIONS(3307),
    [anon_sym_await] = ACTIONS(3307),
    [anon_sym_foreach] = ACTIONS(3307),
    [anon_sym_goto] = ACTIONS(3307),
    [anon_sym_if] = ACTIONS(3307),
    [anon_sym_else] = ACTIONS(3307),
    [anon_sym_DOT_DOT] = ACTIONS(3309),
    [anon_sym_from] = ACTIONS(3307),
    [anon_sym_into] = ACTIONS(3307),
    [anon_sym_join] = ACTIONS(3307),
    [anon_sym_on] = ACTIONS(3307),
    [anon_sym_equals] = ACTIONS(3307),
    [anon_sym_let] = ACTIONS(3307),
    [anon_sym_orderby] = ACTIONS(3307),
    [anon_sym_ascending] = ACTIONS(3307),
    [anon_sym_descending] = ACTIONS(3307),
    [anon_sym_group] = ACTIONS(3307),
    [anon_sym_by] = ACTIONS(3307),
    [anon_sym_select] = ACTIONS(3307),
    [anon_sym_DQUOTE] = ACTIONS(3307),
    [anon_sym_stackalloc] = ACTIONS(3307),
    [anon_sym_sizeof] = ACTIONS(3307),
    [anon_sym_typeof] = ACTIONS(3307),
    [anon_sym___makeref] = ACTIONS(3307),
    [anon_sym___reftype] = ACTIONS(3307),
    [anon_sym___refvalue] = ACTIONS(3307),
    [sym_null_literal] = ACTIONS(3307),
    [anon_sym_SQUOTE] = ACTIONS(3309),
    [sym_integer_literal] = ACTIONS(3307),
    [sym_real_literal] = ACTIONS(3309),
    [sym_verbatim_string_literal] = ACTIONS(3309),
    [sym_raw_string_literal] = ACTIONS(3309),
    [aux_sym_preproc_if_token1] = ACTIONS(3309),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3309),
    [sym_interpolation_verbatim_start] = ACTIONS(3309),
    [sym_interpolation_raw_start] = ACTIONS(3309),
  },
  [2674] = {
    [sym_preproc_region] = STATE(2674),
    [sym_preproc_endregion] = STATE(2674),
    [sym_preproc_line] = STATE(2674),
    [sym_preproc_pragma] = STATE(2674),
    [sym_preproc_nullable] = STATE(2674),
    [sym_preproc_error] = STATE(2674),
    [sym_preproc_define] = STATE(2674),
    [sym_preproc_undef] = STATE(2674),
    [sym__identifier_token] = ACTIONS(3371),
    [anon_sym_extern] = ACTIONS(3371),
    [anon_sym_alias] = ACTIONS(3371),
    [anon_sym_SEMI] = ACTIONS(3373),
    [anon_sym_global] = ACTIONS(3371),
    [anon_sym_using] = ACTIONS(3371),
    [anon_sym_unsafe] = ACTIONS(3371),
    [anon_sym_static] = ACTIONS(3371),
    [anon_sym_LBRACK] = ACTIONS(3373),
    [anon_sym_LPAREN] = ACTIONS(3373),
    [anon_sym_return] = ACTIONS(3371),
    [anon_sym_ref] = ACTIONS(3371),
    [anon_sym_LBRACE] = ACTIONS(3373),
    [anon_sym_RBRACE] = ACTIONS(3373),
    [anon_sym_delegate] = ACTIONS(3371),
    [anon_sym_abstract] = ACTIONS(3371),
    [anon_sym_async] = ACTIONS(3371),
    [anon_sym_const] = ACTIONS(3371),
    [anon_sym_file] = ACTIONS(3371),
    [anon_sym_fixed] = ACTIONS(3371),
    [anon_sym_internal] = ACTIONS(3371),
    [anon_sym_new] = ACTIONS(3371),
    [anon_sym_override] = ACTIONS(3371),
    [anon_sym_partial] = ACTIONS(3371),
    [anon_sym_private] = ACTIONS(3371),
    [anon_sym_protected] = ACTIONS(3371),
    [anon_sym_public] = ACTIONS(3371),
    [anon_sym_readonly] = ACTIONS(3371),
    [anon_sym_required] = ACTIONS(3371),
    [anon_sym_sealed] = ACTIONS(3371),
    [anon_sym_virtual] = ACTIONS(3371),
    [anon_sym_volatile] = ACTIONS(3371),
    [anon_sym_where] = ACTIONS(3371),
    [anon_sym_notnull] = ACTIONS(3371),
    [anon_sym_unmanaged] = ACTIONS(3371),
    [anon_sym_checked] = ACTIONS(3371),
    [anon_sym_BANG] = ACTIONS(3373),
    [anon_sym_TILDE] = ACTIONS(3373),
    [anon_sym_PLUS_PLUS] = ACTIONS(3373),
    [anon_sym_DASH_DASH] = ACTIONS(3373),
    [anon_sym_true] = ACTIONS(3371),
    [anon_sym_false] = ACTIONS(3371),
    [anon_sym_PLUS] = ACTIONS(3371),
    [anon_sym_DASH] = ACTIONS(3371),
    [anon_sym_STAR] = ACTIONS(3373),
    [anon_sym_CARET] = ACTIONS(3373),
    [anon_sym_AMP] = ACTIONS(3373),
    [anon_sym_this] = ACTIONS(3371),
    [anon_sym_scoped] = ACTIONS(3371),
    [anon_sym_var] = ACTIONS(3371),
    [sym_predefined_type] = ACTIONS(3371),
    [anon_sym_break] = ACTIONS(3371),
    [anon_sym_unchecked] = ACTIONS(3371),
    [anon_sym_continue] = ACTIONS(3371),
    [anon_sym_do] = ACTIONS(3371),
    [anon_sym_while] = ACTIONS(3371),
    [anon_sym_for] = ACTIONS(3371),
    [anon_sym_lock] = ACTIONS(3371),
    [anon_sym_yield] = ACTIONS(3371),
    [anon_sym_switch] = ACTIONS(3371),
    [anon_sym_case] = ACTIONS(3371),
    [anon_sym_default] = ACTIONS(3371),
    [anon_sym_throw] = ACTIONS(3371),
    [anon_sym_try] = ACTIONS(3371),
    [anon_sym_when] = ACTIONS(3371),
    [anon_sym_await] = ACTIONS(3371),
    [anon_sym_foreach] = ACTIONS(3371),
    [anon_sym_goto] = ACTIONS(3371),
    [anon_sym_if] = ACTIONS(3371),
    [anon_sym_else] = ACTIONS(3371),
    [anon_sym_DOT_DOT] = ACTIONS(3373),
    [anon_sym_from] = ACTIONS(3371),
    [anon_sym_into] = ACTIONS(3371),
    [anon_sym_join] = ACTIONS(3371),
    [anon_sym_on] = ACTIONS(3371),
    [anon_sym_equals] = ACTIONS(3371),
    [anon_sym_let] = ACTIONS(3371),
    [anon_sym_orderby] = ACTIONS(3371),
    [anon_sym_ascending] = ACTIONS(3371),
    [anon_sym_descending] = ACTIONS(3371),
    [anon_sym_group] = ACTIONS(3371),
    [anon_sym_by] = ACTIONS(3371),
    [anon_sym_select] = ACTIONS(3371),
    [anon_sym_DQUOTE] = ACTIONS(3371),
    [anon_sym_stackalloc] = ACTIONS(3371),
    [anon_sym_sizeof] = ACTIONS(3371),
    [anon_sym_typeof] = ACTIONS(3371),
    [anon_sym___makeref] = ACTIONS(3371),
    [anon_sym___reftype] = ACTIONS(3371),
    [anon_sym___refvalue] = ACTIONS(3371),
    [sym_null_literal] = ACTIONS(3371),
    [anon_sym_SQUOTE] = ACTIONS(3373),
    [sym_integer_literal] = ACTIONS(3371),
    [sym_real_literal] = ACTIONS(3373),
    [sym_verbatim_string_literal] = ACTIONS(3373),
    [sym_raw_string_literal] = ACTIONS(3373),
    [aux_sym_preproc_if_token1] = ACTIONS(3373),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3373),
    [sym_interpolation_verbatim_start] = ACTIONS(3373),
    [sym_interpolation_raw_start] = ACTIONS(3373),
  },
  [2675] = {
    [sym_preproc_region] = STATE(2675),
    [sym_preproc_endregion] = STATE(2675),
    [sym_preproc_line] = STATE(2675),
    [sym_preproc_pragma] = STATE(2675),
    [sym_preproc_nullable] = STATE(2675),
    [sym_preproc_error] = STATE(2675),
    [sym_preproc_define] = STATE(2675),
    [sym_preproc_undef] = STATE(2675),
    [sym__identifier_token] = ACTIONS(3343),
    [anon_sym_extern] = ACTIONS(3343),
    [anon_sym_alias] = ACTIONS(3343),
    [anon_sym_SEMI] = ACTIONS(3345),
    [anon_sym_global] = ACTIONS(3343),
    [anon_sym_using] = ACTIONS(3343),
    [anon_sym_unsafe] = ACTIONS(3343),
    [anon_sym_static] = ACTIONS(3343),
    [anon_sym_LBRACK] = ACTIONS(3345),
    [anon_sym_LPAREN] = ACTIONS(3345),
    [anon_sym_return] = ACTIONS(3343),
    [anon_sym_ref] = ACTIONS(3343),
    [anon_sym_LBRACE] = ACTIONS(3345),
    [anon_sym_RBRACE] = ACTIONS(3345),
    [anon_sym_delegate] = ACTIONS(3343),
    [anon_sym_abstract] = ACTIONS(3343),
    [anon_sym_async] = ACTIONS(3343),
    [anon_sym_const] = ACTIONS(3343),
    [anon_sym_file] = ACTIONS(3343),
    [anon_sym_fixed] = ACTIONS(3343),
    [anon_sym_internal] = ACTIONS(3343),
    [anon_sym_new] = ACTIONS(3343),
    [anon_sym_override] = ACTIONS(3343),
    [anon_sym_partial] = ACTIONS(3343),
    [anon_sym_private] = ACTIONS(3343),
    [anon_sym_protected] = ACTIONS(3343),
    [anon_sym_public] = ACTIONS(3343),
    [anon_sym_readonly] = ACTIONS(3343),
    [anon_sym_required] = ACTIONS(3343),
    [anon_sym_sealed] = ACTIONS(3343),
    [anon_sym_virtual] = ACTIONS(3343),
    [anon_sym_volatile] = ACTIONS(3343),
    [anon_sym_where] = ACTIONS(3343),
    [anon_sym_notnull] = ACTIONS(3343),
    [anon_sym_unmanaged] = ACTIONS(3343),
    [anon_sym_checked] = ACTIONS(3343),
    [anon_sym_BANG] = ACTIONS(3345),
    [anon_sym_TILDE] = ACTIONS(3345),
    [anon_sym_PLUS_PLUS] = ACTIONS(3345),
    [anon_sym_DASH_DASH] = ACTIONS(3345),
    [anon_sym_true] = ACTIONS(3343),
    [anon_sym_false] = ACTIONS(3343),
    [anon_sym_PLUS] = ACTIONS(3343),
    [anon_sym_DASH] = ACTIONS(3343),
    [anon_sym_STAR] = ACTIONS(3345),
    [anon_sym_CARET] = ACTIONS(3345),
    [anon_sym_AMP] = ACTIONS(3345),
    [anon_sym_this] = ACTIONS(3343),
    [anon_sym_scoped] = ACTIONS(3343),
    [anon_sym_var] = ACTIONS(3343),
    [sym_predefined_type] = ACTIONS(3343),
    [anon_sym_break] = ACTIONS(3343),
    [anon_sym_unchecked] = ACTIONS(3343),
    [anon_sym_continue] = ACTIONS(3343),
    [anon_sym_do] = ACTIONS(3343),
    [anon_sym_while] = ACTIONS(3343),
    [anon_sym_for] = ACTIONS(3343),
    [anon_sym_lock] = ACTIONS(3343),
    [anon_sym_yield] = ACTIONS(3343),
    [anon_sym_switch] = ACTIONS(3343),
    [anon_sym_case] = ACTIONS(3343),
    [anon_sym_default] = ACTIONS(3343),
    [anon_sym_throw] = ACTIONS(3343),
    [anon_sym_try] = ACTIONS(3343),
    [anon_sym_when] = ACTIONS(3343),
    [anon_sym_await] = ACTIONS(3343),
    [anon_sym_foreach] = ACTIONS(3343),
    [anon_sym_goto] = ACTIONS(3343),
    [anon_sym_if] = ACTIONS(3343),
    [anon_sym_else] = ACTIONS(3343),
    [anon_sym_DOT_DOT] = ACTIONS(3345),
    [anon_sym_from] = ACTIONS(3343),
    [anon_sym_into] = ACTIONS(3343),
    [anon_sym_join] = ACTIONS(3343),
    [anon_sym_on] = ACTIONS(3343),
    [anon_sym_equals] = ACTIONS(3343),
    [anon_sym_let] = ACTIONS(3343),
    [anon_sym_orderby] = ACTIONS(3343),
    [anon_sym_ascending] = ACTIONS(3343),
    [anon_sym_descending] = ACTIONS(3343),
    [anon_sym_group] = ACTIONS(3343),
    [anon_sym_by] = ACTIONS(3343),
    [anon_sym_select] = ACTIONS(3343),
    [anon_sym_DQUOTE] = ACTIONS(3343),
    [anon_sym_stackalloc] = ACTIONS(3343),
    [anon_sym_sizeof] = ACTIONS(3343),
    [anon_sym_typeof] = ACTIONS(3343),
    [anon_sym___makeref] = ACTIONS(3343),
    [anon_sym___reftype] = ACTIONS(3343),
    [anon_sym___refvalue] = ACTIONS(3343),
    [sym_null_literal] = ACTIONS(3343),
    [anon_sym_SQUOTE] = ACTIONS(3345),
    [sym_integer_literal] = ACTIONS(3343),
    [sym_real_literal] = ACTIONS(3345),
    [sym_verbatim_string_literal] = ACTIONS(3345),
    [sym_raw_string_literal] = ACTIONS(3345),
    [aux_sym_preproc_if_token1] = ACTIONS(3345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3345),
    [sym_interpolation_verbatim_start] = ACTIONS(3345),
    [sym_interpolation_raw_start] = ACTIONS(3345),
  },
  [2676] = {
    [sym_preproc_region] = STATE(2676),
    [sym_preproc_endregion] = STATE(2676),
    [sym_preproc_line] = STATE(2676),
    [sym_preproc_pragma] = STATE(2676),
    [sym_preproc_nullable] = STATE(2676),
    [sym_preproc_error] = STATE(2676),
    [sym_preproc_define] = STATE(2676),
    [sym_preproc_undef] = STATE(2676),
    [sym__identifier_token] = ACTIONS(3041),
    [anon_sym_extern] = ACTIONS(3041),
    [anon_sym_alias] = ACTIONS(3041),
    [anon_sym_SEMI] = ACTIONS(3043),
    [anon_sym_global] = ACTIONS(3041),
    [anon_sym_using] = ACTIONS(3041),
    [anon_sym_unsafe] = ACTIONS(3041),
    [anon_sym_static] = ACTIONS(3041),
    [anon_sym_LBRACK] = ACTIONS(3043),
    [anon_sym_LPAREN] = ACTIONS(3043),
    [anon_sym_return] = ACTIONS(3041),
    [anon_sym_ref] = ACTIONS(3041),
    [anon_sym_LBRACE] = ACTIONS(3043),
    [anon_sym_RBRACE] = ACTIONS(3043),
    [anon_sym_delegate] = ACTIONS(3041),
    [anon_sym_abstract] = ACTIONS(3041),
    [anon_sym_async] = ACTIONS(3041),
    [anon_sym_const] = ACTIONS(3041),
    [anon_sym_file] = ACTIONS(3041),
    [anon_sym_fixed] = ACTIONS(3041),
    [anon_sym_internal] = ACTIONS(3041),
    [anon_sym_new] = ACTIONS(3041),
    [anon_sym_override] = ACTIONS(3041),
    [anon_sym_partial] = ACTIONS(3041),
    [anon_sym_private] = ACTIONS(3041),
    [anon_sym_protected] = ACTIONS(3041),
    [anon_sym_public] = ACTIONS(3041),
    [anon_sym_readonly] = ACTIONS(3041),
    [anon_sym_required] = ACTIONS(3041),
    [anon_sym_sealed] = ACTIONS(3041),
    [anon_sym_virtual] = ACTIONS(3041),
    [anon_sym_volatile] = ACTIONS(3041),
    [anon_sym_where] = ACTIONS(3041),
    [anon_sym_notnull] = ACTIONS(3041),
    [anon_sym_unmanaged] = ACTIONS(3041),
    [anon_sym_checked] = ACTIONS(3041),
    [anon_sym_BANG] = ACTIONS(3043),
    [anon_sym_TILDE] = ACTIONS(3043),
    [anon_sym_PLUS_PLUS] = ACTIONS(3043),
    [anon_sym_DASH_DASH] = ACTIONS(3043),
    [anon_sym_true] = ACTIONS(3041),
    [anon_sym_false] = ACTIONS(3041),
    [anon_sym_PLUS] = ACTIONS(3041),
    [anon_sym_DASH] = ACTIONS(3041),
    [anon_sym_STAR] = ACTIONS(3043),
    [anon_sym_CARET] = ACTIONS(3043),
    [anon_sym_AMP] = ACTIONS(3043),
    [anon_sym_this] = ACTIONS(3041),
    [anon_sym_scoped] = ACTIONS(3041),
    [anon_sym_var] = ACTIONS(3041),
    [sym_predefined_type] = ACTIONS(3041),
    [anon_sym_break] = ACTIONS(3041),
    [anon_sym_unchecked] = ACTIONS(3041),
    [anon_sym_continue] = ACTIONS(3041),
    [anon_sym_do] = ACTIONS(3041),
    [anon_sym_while] = ACTIONS(3041),
    [anon_sym_for] = ACTIONS(3041),
    [anon_sym_lock] = ACTIONS(3041),
    [anon_sym_yield] = ACTIONS(3041),
    [anon_sym_switch] = ACTIONS(3041),
    [anon_sym_case] = ACTIONS(3041),
    [anon_sym_default] = ACTIONS(3041),
    [anon_sym_throw] = ACTIONS(3041),
    [anon_sym_try] = ACTIONS(3041),
    [anon_sym_when] = ACTIONS(3041),
    [anon_sym_await] = ACTIONS(3041),
    [anon_sym_foreach] = ACTIONS(3041),
    [anon_sym_goto] = ACTIONS(3041),
    [anon_sym_if] = ACTIONS(3041),
    [anon_sym_else] = ACTIONS(3041),
    [anon_sym_DOT_DOT] = ACTIONS(3043),
    [anon_sym_from] = ACTIONS(3041),
    [anon_sym_into] = ACTIONS(3041),
    [anon_sym_join] = ACTIONS(3041),
    [anon_sym_on] = ACTIONS(3041),
    [anon_sym_equals] = ACTIONS(3041),
    [anon_sym_let] = ACTIONS(3041),
    [anon_sym_orderby] = ACTIONS(3041),
    [anon_sym_ascending] = ACTIONS(3041),
    [anon_sym_descending] = ACTIONS(3041),
    [anon_sym_group] = ACTIONS(3041),
    [anon_sym_by] = ACTIONS(3041),
    [anon_sym_select] = ACTIONS(3041),
    [anon_sym_DQUOTE] = ACTIONS(3041),
    [anon_sym_stackalloc] = ACTIONS(3041),
    [anon_sym_sizeof] = ACTIONS(3041),
    [anon_sym_typeof] = ACTIONS(3041),
    [anon_sym___makeref] = ACTIONS(3041),
    [anon_sym___reftype] = ACTIONS(3041),
    [anon_sym___refvalue] = ACTIONS(3041),
    [sym_null_literal] = ACTIONS(3041),
    [anon_sym_SQUOTE] = ACTIONS(3043),
    [sym_integer_literal] = ACTIONS(3041),
    [sym_real_literal] = ACTIONS(3043),
    [sym_verbatim_string_literal] = ACTIONS(3043),
    [sym_raw_string_literal] = ACTIONS(3043),
    [aux_sym_preproc_if_token1] = ACTIONS(3043),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3043),
    [sym_interpolation_verbatim_start] = ACTIONS(3043),
    [sym_interpolation_raw_start] = ACTIONS(3043),
  },
  [2677] = {
    [sym_preproc_region] = STATE(2677),
    [sym_preproc_endregion] = STATE(2677),
    [sym_preproc_line] = STATE(2677),
    [sym_preproc_pragma] = STATE(2677),
    [sym_preproc_nullable] = STATE(2677),
    [sym_preproc_error] = STATE(2677),
    [sym_preproc_define] = STATE(2677),
    [sym_preproc_undef] = STATE(2677),
    [sym__identifier_token] = ACTIONS(3231),
    [anon_sym_extern] = ACTIONS(3231),
    [anon_sym_alias] = ACTIONS(3231),
    [anon_sym_SEMI] = ACTIONS(3233),
    [anon_sym_global] = ACTIONS(3231),
    [anon_sym_using] = ACTIONS(3231),
    [anon_sym_unsafe] = ACTIONS(3231),
    [anon_sym_static] = ACTIONS(3231),
    [anon_sym_LBRACK] = ACTIONS(3233),
    [anon_sym_LPAREN] = ACTIONS(3233),
    [anon_sym_return] = ACTIONS(3231),
    [anon_sym_ref] = ACTIONS(3231),
    [anon_sym_LBRACE] = ACTIONS(3233),
    [anon_sym_RBRACE] = ACTIONS(3233),
    [anon_sym_delegate] = ACTIONS(3231),
    [anon_sym_abstract] = ACTIONS(3231),
    [anon_sym_async] = ACTIONS(3231),
    [anon_sym_const] = ACTIONS(3231),
    [anon_sym_file] = ACTIONS(3231),
    [anon_sym_fixed] = ACTIONS(3231),
    [anon_sym_internal] = ACTIONS(3231),
    [anon_sym_new] = ACTIONS(3231),
    [anon_sym_override] = ACTIONS(3231),
    [anon_sym_partial] = ACTIONS(3231),
    [anon_sym_private] = ACTIONS(3231),
    [anon_sym_protected] = ACTIONS(3231),
    [anon_sym_public] = ACTIONS(3231),
    [anon_sym_readonly] = ACTIONS(3231),
    [anon_sym_required] = ACTIONS(3231),
    [anon_sym_sealed] = ACTIONS(3231),
    [anon_sym_virtual] = ACTIONS(3231),
    [anon_sym_volatile] = ACTIONS(3231),
    [anon_sym_where] = ACTIONS(3231),
    [anon_sym_notnull] = ACTIONS(3231),
    [anon_sym_unmanaged] = ACTIONS(3231),
    [anon_sym_checked] = ACTIONS(3231),
    [anon_sym_BANG] = ACTIONS(3233),
    [anon_sym_TILDE] = ACTIONS(3233),
    [anon_sym_PLUS_PLUS] = ACTIONS(3233),
    [anon_sym_DASH_DASH] = ACTIONS(3233),
    [anon_sym_true] = ACTIONS(3231),
    [anon_sym_false] = ACTIONS(3231),
    [anon_sym_PLUS] = ACTIONS(3231),
    [anon_sym_DASH] = ACTIONS(3231),
    [anon_sym_STAR] = ACTIONS(3233),
    [anon_sym_CARET] = ACTIONS(3233),
    [anon_sym_AMP] = ACTIONS(3233),
    [anon_sym_this] = ACTIONS(3231),
    [anon_sym_scoped] = ACTIONS(3231),
    [anon_sym_var] = ACTIONS(3231),
    [sym_predefined_type] = ACTIONS(3231),
    [anon_sym_break] = ACTIONS(3231),
    [anon_sym_unchecked] = ACTIONS(3231),
    [anon_sym_continue] = ACTIONS(3231),
    [anon_sym_do] = ACTIONS(3231),
    [anon_sym_while] = ACTIONS(3231),
    [anon_sym_for] = ACTIONS(3231),
    [anon_sym_lock] = ACTIONS(3231),
    [anon_sym_yield] = ACTIONS(3231),
    [anon_sym_switch] = ACTIONS(3231),
    [anon_sym_case] = ACTIONS(3231),
    [anon_sym_default] = ACTIONS(3231),
    [anon_sym_throw] = ACTIONS(3231),
    [anon_sym_try] = ACTIONS(3231),
    [anon_sym_when] = ACTIONS(3231),
    [anon_sym_await] = ACTIONS(3231),
    [anon_sym_foreach] = ACTIONS(3231),
    [anon_sym_goto] = ACTIONS(3231),
    [anon_sym_if] = ACTIONS(3231),
    [anon_sym_else] = ACTIONS(3231),
    [anon_sym_DOT_DOT] = ACTIONS(3233),
    [anon_sym_from] = ACTIONS(3231),
    [anon_sym_into] = ACTIONS(3231),
    [anon_sym_join] = ACTIONS(3231),
    [anon_sym_on] = ACTIONS(3231),
    [anon_sym_equals] = ACTIONS(3231),
    [anon_sym_let] = ACTIONS(3231),
    [anon_sym_orderby] = ACTIONS(3231),
    [anon_sym_ascending] = ACTIONS(3231),
    [anon_sym_descending] = ACTIONS(3231),
    [anon_sym_group] = ACTIONS(3231),
    [anon_sym_by] = ACTIONS(3231),
    [anon_sym_select] = ACTIONS(3231),
    [anon_sym_DQUOTE] = ACTIONS(3231),
    [anon_sym_stackalloc] = ACTIONS(3231),
    [anon_sym_sizeof] = ACTIONS(3231),
    [anon_sym_typeof] = ACTIONS(3231),
    [anon_sym___makeref] = ACTIONS(3231),
    [anon_sym___reftype] = ACTIONS(3231),
    [anon_sym___refvalue] = ACTIONS(3231),
    [sym_null_literal] = ACTIONS(3231),
    [anon_sym_SQUOTE] = ACTIONS(3233),
    [sym_integer_literal] = ACTIONS(3231),
    [sym_real_literal] = ACTIONS(3233),
    [sym_verbatim_string_literal] = ACTIONS(3233),
    [sym_raw_string_literal] = ACTIONS(3233),
    [aux_sym_preproc_if_token1] = ACTIONS(3233),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3233),
    [sym_interpolation_verbatim_start] = ACTIONS(3233),
    [sym_interpolation_raw_start] = ACTIONS(3233),
  },
  [2678] = {
    [sym_preproc_region] = STATE(2678),
    [sym_preproc_endregion] = STATE(2678),
    [sym_preproc_line] = STATE(2678),
    [sym_preproc_pragma] = STATE(2678),
    [sym_preproc_nullable] = STATE(2678),
    [sym_preproc_error] = STATE(2678),
    [sym_preproc_define] = STATE(2678),
    [sym_preproc_undef] = STATE(2678),
    [sym__identifier_token] = ACTIONS(3239),
    [anon_sym_extern] = ACTIONS(3239),
    [anon_sym_alias] = ACTIONS(3239),
    [anon_sym_SEMI] = ACTIONS(3241),
    [anon_sym_global] = ACTIONS(3239),
    [anon_sym_using] = ACTIONS(3239),
    [anon_sym_unsafe] = ACTIONS(3239),
    [anon_sym_static] = ACTIONS(3239),
    [anon_sym_LBRACK] = ACTIONS(3241),
    [anon_sym_LPAREN] = ACTIONS(3241),
    [anon_sym_return] = ACTIONS(3239),
    [anon_sym_ref] = ACTIONS(3239),
    [anon_sym_LBRACE] = ACTIONS(3241),
    [anon_sym_RBRACE] = ACTIONS(3241),
    [anon_sym_delegate] = ACTIONS(3239),
    [anon_sym_abstract] = ACTIONS(3239),
    [anon_sym_async] = ACTIONS(3239),
    [anon_sym_const] = ACTIONS(3239),
    [anon_sym_file] = ACTIONS(3239),
    [anon_sym_fixed] = ACTIONS(3239),
    [anon_sym_internal] = ACTIONS(3239),
    [anon_sym_new] = ACTIONS(3239),
    [anon_sym_override] = ACTIONS(3239),
    [anon_sym_partial] = ACTIONS(3239),
    [anon_sym_private] = ACTIONS(3239),
    [anon_sym_protected] = ACTIONS(3239),
    [anon_sym_public] = ACTIONS(3239),
    [anon_sym_readonly] = ACTIONS(3239),
    [anon_sym_required] = ACTIONS(3239),
    [anon_sym_sealed] = ACTIONS(3239),
    [anon_sym_virtual] = ACTIONS(3239),
    [anon_sym_volatile] = ACTIONS(3239),
    [anon_sym_where] = ACTIONS(3239),
    [anon_sym_notnull] = ACTIONS(3239),
    [anon_sym_unmanaged] = ACTIONS(3239),
    [anon_sym_checked] = ACTIONS(3239),
    [anon_sym_BANG] = ACTIONS(3241),
    [anon_sym_TILDE] = ACTIONS(3241),
    [anon_sym_PLUS_PLUS] = ACTIONS(3241),
    [anon_sym_DASH_DASH] = ACTIONS(3241),
    [anon_sym_true] = ACTIONS(3239),
    [anon_sym_false] = ACTIONS(3239),
    [anon_sym_PLUS] = ACTIONS(3239),
    [anon_sym_DASH] = ACTIONS(3239),
    [anon_sym_STAR] = ACTIONS(3241),
    [anon_sym_CARET] = ACTIONS(3241),
    [anon_sym_AMP] = ACTIONS(3241),
    [anon_sym_this] = ACTIONS(3239),
    [anon_sym_scoped] = ACTIONS(3239),
    [anon_sym_var] = ACTIONS(3239),
    [sym_predefined_type] = ACTIONS(3239),
    [anon_sym_break] = ACTIONS(3239),
    [anon_sym_unchecked] = ACTIONS(3239),
    [anon_sym_continue] = ACTIONS(3239),
    [anon_sym_do] = ACTIONS(3239),
    [anon_sym_while] = ACTIONS(3239),
    [anon_sym_for] = ACTIONS(3239),
    [anon_sym_lock] = ACTIONS(3239),
    [anon_sym_yield] = ACTIONS(3239),
    [anon_sym_switch] = ACTIONS(3239),
    [anon_sym_case] = ACTIONS(3239),
    [anon_sym_default] = ACTIONS(3239),
    [anon_sym_throw] = ACTIONS(3239),
    [anon_sym_try] = ACTIONS(3239),
    [anon_sym_when] = ACTIONS(3239),
    [anon_sym_await] = ACTIONS(3239),
    [anon_sym_foreach] = ACTIONS(3239),
    [anon_sym_goto] = ACTIONS(3239),
    [anon_sym_if] = ACTIONS(3239),
    [anon_sym_else] = ACTIONS(3239),
    [anon_sym_DOT_DOT] = ACTIONS(3241),
    [anon_sym_from] = ACTIONS(3239),
    [anon_sym_into] = ACTIONS(3239),
    [anon_sym_join] = ACTIONS(3239),
    [anon_sym_on] = ACTIONS(3239),
    [anon_sym_equals] = ACTIONS(3239),
    [anon_sym_let] = ACTIONS(3239),
    [anon_sym_orderby] = ACTIONS(3239),
    [anon_sym_ascending] = ACTIONS(3239),
    [anon_sym_descending] = ACTIONS(3239),
    [anon_sym_group] = ACTIONS(3239),
    [anon_sym_by] = ACTIONS(3239),
    [anon_sym_select] = ACTIONS(3239),
    [anon_sym_DQUOTE] = ACTIONS(3239),
    [anon_sym_stackalloc] = ACTIONS(3239),
    [anon_sym_sizeof] = ACTIONS(3239),
    [anon_sym_typeof] = ACTIONS(3239),
    [anon_sym___makeref] = ACTIONS(3239),
    [anon_sym___reftype] = ACTIONS(3239),
    [anon_sym___refvalue] = ACTIONS(3239),
    [sym_null_literal] = ACTIONS(3239),
    [anon_sym_SQUOTE] = ACTIONS(3241),
    [sym_integer_literal] = ACTIONS(3239),
    [sym_real_literal] = ACTIONS(3241),
    [sym_verbatim_string_literal] = ACTIONS(3241),
    [sym_raw_string_literal] = ACTIONS(3241),
    [aux_sym_preproc_if_token1] = ACTIONS(3241),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3241),
    [sym_interpolation_verbatim_start] = ACTIONS(3241),
    [sym_interpolation_raw_start] = ACTIONS(3241),
  },
  [2679] = {
    [sym_preproc_region] = STATE(2679),
    [sym_preproc_endregion] = STATE(2679),
    [sym_preproc_line] = STATE(2679),
    [sym_preproc_pragma] = STATE(2679),
    [sym_preproc_nullable] = STATE(2679),
    [sym_preproc_error] = STATE(2679),
    [sym_preproc_define] = STATE(2679),
    [sym_preproc_undef] = STATE(2679),
    [sym__identifier_token] = ACTIONS(3243),
    [anon_sym_extern] = ACTIONS(3243),
    [anon_sym_alias] = ACTIONS(3243),
    [anon_sym_SEMI] = ACTIONS(3245),
    [anon_sym_global] = ACTIONS(3243),
    [anon_sym_using] = ACTIONS(3243),
    [anon_sym_unsafe] = ACTIONS(3243),
    [anon_sym_static] = ACTIONS(3243),
    [anon_sym_LBRACK] = ACTIONS(3245),
    [anon_sym_LPAREN] = ACTIONS(3245),
    [anon_sym_return] = ACTIONS(3243),
    [anon_sym_ref] = ACTIONS(3243),
    [anon_sym_LBRACE] = ACTIONS(3245),
    [anon_sym_RBRACE] = ACTIONS(3245),
    [anon_sym_delegate] = ACTIONS(3243),
    [anon_sym_abstract] = ACTIONS(3243),
    [anon_sym_async] = ACTIONS(3243),
    [anon_sym_const] = ACTIONS(3243),
    [anon_sym_file] = ACTIONS(3243),
    [anon_sym_fixed] = ACTIONS(3243),
    [anon_sym_internal] = ACTIONS(3243),
    [anon_sym_new] = ACTIONS(3243),
    [anon_sym_override] = ACTIONS(3243),
    [anon_sym_partial] = ACTIONS(3243),
    [anon_sym_private] = ACTIONS(3243),
    [anon_sym_protected] = ACTIONS(3243),
    [anon_sym_public] = ACTIONS(3243),
    [anon_sym_readonly] = ACTIONS(3243),
    [anon_sym_required] = ACTIONS(3243),
    [anon_sym_sealed] = ACTIONS(3243),
    [anon_sym_virtual] = ACTIONS(3243),
    [anon_sym_volatile] = ACTIONS(3243),
    [anon_sym_where] = ACTIONS(3243),
    [anon_sym_notnull] = ACTIONS(3243),
    [anon_sym_unmanaged] = ACTIONS(3243),
    [anon_sym_checked] = ACTIONS(3243),
    [anon_sym_BANG] = ACTIONS(3245),
    [anon_sym_TILDE] = ACTIONS(3245),
    [anon_sym_PLUS_PLUS] = ACTIONS(3245),
    [anon_sym_DASH_DASH] = ACTIONS(3245),
    [anon_sym_true] = ACTIONS(3243),
    [anon_sym_false] = ACTIONS(3243),
    [anon_sym_PLUS] = ACTIONS(3243),
    [anon_sym_DASH] = ACTIONS(3243),
    [anon_sym_STAR] = ACTIONS(3245),
    [anon_sym_CARET] = ACTIONS(3245),
    [anon_sym_AMP] = ACTIONS(3245),
    [anon_sym_this] = ACTIONS(3243),
    [anon_sym_scoped] = ACTIONS(3243),
    [anon_sym_var] = ACTIONS(3243),
    [sym_predefined_type] = ACTIONS(3243),
    [anon_sym_break] = ACTIONS(3243),
    [anon_sym_unchecked] = ACTIONS(3243),
    [anon_sym_continue] = ACTIONS(3243),
    [anon_sym_do] = ACTIONS(3243),
    [anon_sym_while] = ACTIONS(3243),
    [anon_sym_for] = ACTIONS(3243),
    [anon_sym_lock] = ACTIONS(3243),
    [anon_sym_yield] = ACTIONS(3243),
    [anon_sym_switch] = ACTIONS(3243),
    [anon_sym_case] = ACTIONS(3243),
    [anon_sym_default] = ACTIONS(3243),
    [anon_sym_throw] = ACTIONS(3243),
    [anon_sym_try] = ACTIONS(3243),
    [anon_sym_when] = ACTIONS(3243),
    [anon_sym_await] = ACTIONS(3243),
    [anon_sym_foreach] = ACTIONS(3243),
    [anon_sym_goto] = ACTIONS(3243),
    [anon_sym_if] = ACTIONS(3243),
    [anon_sym_else] = ACTIONS(3243),
    [anon_sym_DOT_DOT] = ACTIONS(3245),
    [anon_sym_from] = ACTIONS(3243),
    [anon_sym_into] = ACTIONS(3243),
    [anon_sym_join] = ACTIONS(3243),
    [anon_sym_on] = ACTIONS(3243),
    [anon_sym_equals] = ACTIONS(3243),
    [anon_sym_let] = ACTIONS(3243),
    [anon_sym_orderby] = ACTIONS(3243),
    [anon_sym_ascending] = ACTIONS(3243),
    [anon_sym_descending] = ACTIONS(3243),
    [anon_sym_group] = ACTIONS(3243),
    [anon_sym_by] = ACTIONS(3243),
    [anon_sym_select] = ACTIONS(3243),
    [anon_sym_DQUOTE] = ACTIONS(3243),
    [anon_sym_stackalloc] = ACTIONS(3243),
    [anon_sym_sizeof] = ACTIONS(3243),
    [anon_sym_typeof] = ACTIONS(3243),
    [anon_sym___makeref] = ACTIONS(3243),
    [anon_sym___reftype] = ACTIONS(3243),
    [anon_sym___refvalue] = ACTIONS(3243),
    [sym_null_literal] = ACTIONS(3243),
    [anon_sym_SQUOTE] = ACTIONS(3245),
    [sym_integer_literal] = ACTIONS(3243),
    [sym_real_literal] = ACTIONS(3245),
    [sym_verbatim_string_literal] = ACTIONS(3245),
    [sym_raw_string_literal] = ACTIONS(3245),
    [aux_sym_preproc_if_token1] = ACTIONS(3245),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3245),
    [sym_interpolation_verbatim_start] = ACTIONS(3245),
    [sym_interpolation_raw_start] = ACTIONS(3245),
  },
  [2680] = {
    [sym_preproc_region] = STATE(2680),
    [sym_preproc_endregion] = STATE(2680),
    [sym_preproc_line] = STATE(2680),
    [sym_preproc_pragma] = STATE(2680),
    [sym_preproc_nullable] = STATE(2680),
    [sym_preproc_error] = STATE(2680),
    [sym_preproc_define] = STATE(2680),
    [sym_preproc_undef] = STATE(2680),
    [sym__identifier_token] = ACTIONS(3973),
    [anon_sym_extern] = ACTIONS(3976),
    [anon_sym_alias] = ACTIONS(3973),
    [anon_sym_SEMI] = ACTIONS(3719),
    [anon_sym_global] = ACTIONS(3973),
    [anon_sym_unsafe] = ACTIONS(3976),
    [anon_sym_EQ] = ACTIONS(3721),
    [anon_sym_static] = ACTIONS(3976),
    [anon_sym_LBRACK] = ACTIONS(3719),
    [anon_sym_COLON] = ACTIONS(3721),
    [anon_sym_COMMA] = ACTIONS(3719),
    [anon_sym_LPAREN] = ACTIONS(3978),
    [anon_sym_ref] = ACTIONS(3976),
    [anon_sym_RBRACE] = ACTIONS(3719),
    [anon_sym_delegate] = ACTIONS(3976),
    [anon_sym_abstract] = ACTIONS(3976),
    [anon_sym_async] = ACTIONS(3976),
    [anon_sym_const] = ACTIONS(3976),
    [anon_sym_file] = ACTIONS(3973),
    [anon_sym_fixed] = ACTIONS(3976),
    [anon_sym_internal] = ACTIONS(3976),
    [anon_sym_new] = ACTIONS(3976),
    [anon_sym_override] = ACTIONS(3976),
    [anon_sym_partial] = ACTIONS(3976),
    [anon_sym_private] = ACTIONS(3976),
    [anon_sym_protected] = ACTIONS(3976),
    [anon_sym_public] = ACTIONS(3976),
    [anon_sym_readonly] = ACTIONS(3976),
    [anon_sym_required] = ACTIONS(3976),
    [anon_sym_sealed] = ACTIONS(3976),
    [anon_sym_virtual] = ACTIONS(3976),
    [anon_sym_volatile] = ACTIONS(3976),
    [anon_sym_LT] = ACTIONS(3721),
    [anon_sym_GT] = ACTIONS(3721),
    [anon_sym_where] = ACTIONS(3973),
    [anon_sym_QMARK] = ACTIONS(3721),
    [anon_sym_notnull] = ACTIONS(3973),
    [anon_sym_unmanaged] = ACTIONS(3973),
    [anon_sym_BANG] = ACTIONS(3721),
    [anon_sym_PLUS_PLUS] = ACTIONS(3719),
    [anon_sym_DASH_DASH] = ACTIONS(3719),
    [anon_sym_PLUS] = ACTIONS(3721),
    [anon_sym_DASH] = ACTIONS(3721),
    [anon_sym_STAR] = ACTIONS(3721),
    [anon_sym_SLASH] = ACTIONS(3721),
    [anon_sym_PERCENT] = ACTIONS(3721),
    [anon_sym_CARET] = ACTIONS(3721),
    [anon_sym_PIPE] = ACTIONS(3721),
    [anon_sym_AMP] = ACTIONS(3721),
    [anon_sym_LT_LT] = ACTIONS(3721),
    [anon_sym_GT_GT] = ACTIONS(3721),
    [anon_sym_GT_GT_GT] = ACTIONS(3721),
    [anon_sym_EQ_EQ] = ACTIONS(3719),
    [anon_sym_BANG_EQ] = ACTIONS(3719),
    [anon_sym_GT_EQ] = ACTIONS(3719),
    [anon_sym_LT_EQ] = ACTIONS(3719),
    [anon_sym_DOT] = ACTIONS(3721),
    [anon_sym_scoped] = ACTIONS(3973),
    [anon_sym_EQ_GT] = ACTIONS(3719),
    [anon_sym_COLON_COLON] = ACTIONS(3719),
    [anon_sym_var] = ACTIONS(3973),
    [sym_predefined_type] = ACTIONS(3976),
    [anon_sym_yield] = ACTIONS(3973),
    [anon_sym_switch] = ACTIONS(3721),
    [anon_sym_when] = ACTIONS(3973),
    [anon_sym_DOT_DOT] = ACTIONS(3719),
    [anon_sym_PLUS_EQ] = ACTIONS(3719),
    [anon_sym_DASH_EQ] = ACTIONS(3719),
    [anon_sym_STAR_EQ] = ACTIONS(3719),
    [anon_sym_SLASH_EQ] = ACTIONS(3719),
    [anon_sym_PERCENT_EQ] = ACTIONS(3719),
    [anon_sym_AMP_EQ] = ACTIONS(3719),
    [anon_sym_CARET_EQ] = ACTIONS(3719),
    [anon_sym_PIPE_EQ] = ACTIONS(3719),
    [anon_sym_LT_LT_EQ] = ACTIONS(3719),
    [anon_sym_GT_GT_EQ] = ACTIONS(3719),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3719),
    [anon_sym_AMP_AMP] = ACTIONS(3719),
    [anon_sym_PIPE_PIPE] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK] = ACTIONS(3721),
    [anon_sym_from] = ACTIONS(3973),
    [anon_sym_into] = ACTIONS(3973),
    [anon_sym_join] = ACTIONS(3973),
    [anon_sym_on] = ACTIONS(3973),
    [anon_sym_equals] = ACTIONS(3973),
    [anon_sym_let] = ACTIONS(3973),
    [anon_sym_orderby] = ACTIONS(3973),
    [anon_sym_ascending] = ACTIONS(3973),
    [anon_sym_descending] = ACTIONS(3973),
    [anon_sym_group] = ACTIONS(3973),
    [anon_sym_by] = ACTIONS(3973),
    [anon_sym_select] = ACTIONS(3973),
    [anon_sym_as] = ACTIONS(3721),
    [anon_sym_is] = ACTIONS(3721),
    [anon_sym_DASH_GT] = ACTIONS(3719),
    [anon_sym_with] = ACTIONS(3721),
    [aux_sym_preproc_if_token3] = ACTIONS(3719),
    [aux_sym_preproc_else_token1] = ACTIONS(3719),
    [aux_sym_preproc_elif_token1] = ACTIONS(3719),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2681] = {
    [sym_preproc_region] = STATE(2681),
    [sym_preproc_endregion] = STATE(2681),
    [sym_preproc_line] = STATE(2681),
    [sym_preproc_pragma] = STATE(2681),
    [sym_preproc_nullable] = STATE(2681),
    [sym_preproc_error] = STATE(2681),
    [sym_preproc_define] = STATE(2681),
    [sym_preproc_undef] = STATE(2681),
    [sym__identifier_token] = ACTIONS(3081),
    [anon_sym_extern] = ACTIONS(3081),
    [anon_sym_alias] = ACTIONS(3081),
    [anon_sym_SEMI] = ACTIONS(3083),
    [anon_sym_global] = ACTIONS(3081),
    [anon_sym_using] = ACTIONS(3081),
    [anon_sym_unsafe] = ACTIONS(3081),
    [anon_sym_static] = ACTIONS(3081),
    [anon_sym_LBRACK] = ACTIONS(3083),
    [anon_sym_LPAREN] = ACTIONS(3083),
    [anon_sym_return] = ACTIONS(3081),
    [anon_sym_ref] = ACTIONS(3081),
    [anon_sym_LBRACE] = ACTIONS(3083),
    [anon_sym_RBRACE] = ACTIONS(3083),
    [anon_sym_delegate] = ACTIONS(3081),
    [anon_sym_abstract] = ACTIONS(3081),
    [anon_sym_async] = ACTIONS(3081),
    [anon_sym_const] = ACTIONS(3081),
    [anon_sym_file] = ACTIONS(3081),
    [anon_sym_fixed] = ACTIONS(3081),
    [anon_sym_internal] = ACTIONS(3081),
    [anon_sym_new] = ACTIONS(3081),
    [anon_sym_override] = ACTIONS(3081),
    [anon_sym_partial] = ACTIONS(3081),
    [anon_sym_private] = ACTIONS(3081),
    [anon_sym_protected] = ACTIONS(3081),
    [anon_sym_public] = ACTIONS(3081),
    [anon_sym_readonly] = ACTIONS(3081),
    [anon_sym_required] = ACTIONS(3081),
    [anon_sym_sealed] = ACTIONS(3081),
    [anon_sym_virtual] = ACTIONS(3081),
    [anon_sym_volatile] = ACTIONS(3081),
    [anon_sym_where] = ACTIONS(3081),
    [anon_sym_notnull] = ACTIONS(3081),
    [anon_sym_unmanaged] = ACTIONS(3081),
    [anon_sym_checked] = ACTIONS(3081),
    [anon_sym_BANG] = ACTIONS(3083),
    [anon_sym_TILDE] = ACTIONS(3083),
    [anon_sym_PLUS_PLUS] = ACTIONS(3083),
    [anon_sym_DASH_DASH] = ACTIONS(3083),
    [anon_sym_true] = ACTIONS(3081),
    [anon_sym_false] = ACTIONS(3081),
    [anon_sym_PLUS] = ACTIONS(3081),
    [anon_sym_DASH] = ACTIONS(3081),
    [anon_sym_STAR] = ACTIONS(3083),
    [anon_sym_CARET] = ACTIONS(3083),
    [anon_sym_AMP] = ACTIONS(3083),
    [anon_sym_this] = ACTIONS(3081),
    [anon_sym_scoped] = ACTIONS(3081),
    [anon_sym_var] = ACTIONS(3081),
    [sym_predefined_type] = ACTIONS(3081),
    [anon_sym_break] = ACTIONS(3081),
    [anon_sym_unchecked] = ACTIONS(3081),
    [anon_sym_continue] = ACTIONS(3081),
    [anon_sym_do] = ACTIONS(3081),
    [anon_sym_while] = ACTIONS(3081),
    [anon_sym_for] = ACTIONS(3081),
    [anon_sym_lock] = ACTIONS(3081),
    [anon_sym_yield] = ACTIONS(3081),
    [anon_sym_switch] = ACTIONS(3081),
    [anon_sym_case] = ACTIONS(3081),
    [anon_sym_default] = ACTIONS(3081),
    [anon_sym_throw] = ACTIONS(3081),
    [anon_sym_try] = ACTIONS(3081),
    [anon_sym_when] = ACTIONS(3081),
    [anon_sym_await] = ACTIONS(3081),
    [anon_sym_foreach] = ACTIONS(3081),
    [anon_sym_goto] = ACTIONS(3081),
    [anon_sym_if] = ACTIONS(3081),
    [anon_sym_else] = ACTIONS(3081),
    [anon_sym_DOT_DOT] = ACTIONS(3083),
    [anon_sym_from] = ACTIONS(3081),
    [anon_sym_into] = ACTIONS(3081),
    [anon_sym_join] = ACTIONS(3081),
    [anon_sym_on] = ACTIONS(3081),
    [anon_sym_equals] = ACTIONS(3081),
    [anon_sym_let] = ACTIONS(3081),
    [anon_sym_orderby] = ACTIONS(3081),
    [anon_sym_ascending] = ACTIONS(3081),
    [anon_sym_descending] = ACTIONS(3081),
    [anon_sym_group] = ACTIONS(3081),
    [anon_sym_by] = ACTIONS(3081),
    [anon_sym_select] = ACTIONS(3081),
    [anon_sym_DQUOTE] = ACTIONS(3081),
    [anon_sym_stackalloc] = ACTIONS(3081),
    [anon_sym_sizeof] = ACTIONS(3081),
    [anon_sym_typeof] = ACTIONS(3081),
    [anon_sym___makeref] = ACTIONS(3081),
    [anon_sym___reftype] = ACTIONS(3081),
    [anon_sym___refvalue] = ACTIONS(3081),
    [sym_null_literal] = ACTIONS(3081),
    [anon_sym_SQUOTE] = ACTIONS(3083),
    [sym_integer_literal] = ACTIONS(3081),
    [sym_real_literal] = ACTIONS(3083),
    [sym_verbatim_string_literal] = ACTIONS(3083),
    [sym_raw_string_literal] = ACTIONS(3083),
    [aux_sym_preproc_if_token1] = ACTIONS(3083),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3083),
    [sym_interpolation_verbatim_start] = ACTIONS(3083),
    [sym_interpolation_raw_start] = ACTIONS(3083),
  },
  [2682] = {
    [sym_preproc_region] = STATE(2682),
    [sym_preproc_endregion] = STATE(2682),
    [sym_preproc_line] = STATE(2682),
    [sym_preproc_pragma] = STATE(2682),
    [sym_preproc_nullable] = STATE(2682),
    [sym_preproc_error] = STATE(2682),
    [sym_preproc_define] = STATE(2682),
    [sym_preproc_undef] = STATE(2682),
    [sym__identifier_token] = ACTIONS(3255),
    [anon_sym_extern] = ACTIONS(3255),
    [anon_sym_alias] = ACTIONS(3255),
    [anon_sym_SEMI] = ACTIONS(3257),
    [anon_sym_global] = ACTIONS(3255),
    [anon_sym_using] = ACTIONS(3255),
    [anon_sym_unsafe] = ACTIONS(3255),
    [anon_sym_static] = ACTIONS(3255),
    [anon_sym_LBRACK] = ACTIONS(3257),
    [anon_sym_LPAREN] = ACTIONS(3257),
    [anon_sym_return] = ACTIONS(3255),
    [anon_sym_ref] = ACTIONS(3255),
    [anon_sym_LBRACE] = ACTIONS(3257),
    [anon_sym_RBRACE] = ACTIONS(3257),
    [anon_sym_delegate] = ACTIONS(3255),
    [anon_sym_abstract] = ACTIONS(3255),
    [anon_sym_async] = ACTIONS(3255),
    [anon_sym_const] = ACTIONS(3255),
    [anon_sym_file] = ACTIONS(3255),
    [anon_sym_fixed] = ACTIONS(3255),
    [anon_sym_internal] = ACTIONS(3255),
    [anon_sym_new] = ACTIONS(3255),
    [anon_sym_override] = ACTIONS(3255),
    [anon_sym_partial] = ACTIONS(3255),
    [anon_sym_private] = ACTIONS(3255),
    [anon_sym_protected] = ACTIONS(3255),
    [anon_sym_public] = ACTIONS(3255),
    [anon_sym_readonly] = ACTIONS(3255),
    [anon_sym_required] = ACTIONS(3255),
    [anon_sym_sealed] = ACTIONS(3255),
    [anon_sym_virtual] = ACTIONS(3255),
    [anon_sym_volatile] = ACTIONS(3255),
    [anon_sym_where] = ACTIONS(3255),
    [anon_sym_notnull] = ACTIONS(3255),
    [anon_sym_unmanaged] = ACTIONS(3255),
    [anon_sym_checked] = ACTIONS(3255),
    [anon_sym_BANG] = ACTIONS(3257),
    [anon_sym_TILDE] = ACTIONS(3257),
    [anon_sym_PLUS_PLUS] = ACTIONS(3257),
    [anon_sym_DASH_DASH] = ACTIONS(3257),
    [anon_sym_true] = ACTIONS(3255),
    [anon_sym_false] = ACTIONS(3255),
    [anon_sym_PLUS] = ACTIONS(3255),
    [anon_sym_DASH] = ACTIONS(3255),
    [anon_sym_STAR] = ACTIONS(3257),
    [anon_sym_CARET] = ACTIONS(3257),
    [anon_sym_AMP] = ACTIONS(3257),
    [anon_sym_this] = ACTIONS(3255),
    [anon_sym_scoped] = ACTIONS(3255),
    [anon_sym_var] = ACTIONS(3255),
    [sym_predefined_type] = ACTIONS(3255),
    [anon_sym_break] = ACTIONS(3255),
    [anon_sym_unchecked] = ACTIONS(3255),
    [anon_sym_continue] = ACTIONS(3255),
    [anon_sym_do] = ACTIONS(3255),
    [anon_sym_while] = ACTIONS(3255),
    [anon_sym_for] = ACTIONS(3255),
    [anon_sym_lock] = ACTIONS(3255),
    [anon_sym_yield] = ACTIONS(3255),
    [anon_sym_switch] = ACTIONS(3255),
    [anon_sym_case] = ACTIONS(3255),
    [anon_sym_default] = ACTIONS(3255),
    [anon_sym_throw] = ACTIONS(3255),
    [anon_sym_try] = ACTIONS(3255),
    [anon_sym_when] = ACTIONS(3255),
    [anon_sym_await] = ACTIONS(3255),
    [anon_sym_foreach] = ACTIONS(3255),
    [anon_sym_goto] = ACTIONS(3255),
    [anon_sym_if] = ACTIONS(3255),
    [anon_sym_else] = ACTIONS(3255),
    [anon_sym_DOT_DOT] = ACTIONS(3257),
    [anon_sym_from] = ACTIONS(3255),
    [anon_sym_into] = ACTIONS(3255),
    [anon_sym_join] = ACTIONS(3255),
    [anon_sym_on] = ACTIONS(3255),
    [anon_sym_equals] = ACTIONS(3255),
    [anon_sym_let] = ACTIONS(3255),
    [anon_sym_orderby] = ACTIONS(3255),
    [anon_sym_ascending] = ACTIONS(3255),
    [anon_sym_descending] = ACTIONS(3255),
    [anon_sym_group] = ACTIONS(3255),
    [anon_sym_by] = ACTIONS(3255),
    [anon_sym_select] = ACTIONS(3255),
    [anon_sym_DQUOTE] = ACTIONS(3255),
    [anon_sym_stackalloc] = ACTIONS(3255),
    [anon_sym_sizeof] = ACTIONS(3255),
    [anon_sym_typeof] = ACTIONS(3255),
    [anon_sym___makeref] = ACTIONS(3255),
    [anon_sym___reftype] = ACTIONS(3255),
    [anon_sym___refvalue] = ACTIONS(3255),
    [sym_null_literal] = ACTIONS(3255),
    [anon_sym_SQUOTE] = ACTIONS(3257),
    [sym_integer_literal] = ACTIONS(3255),
    [sym_real_literal] = ACTIONS(3257),
    [sym_verbatim_string_literal] = ACTIONS(3257),
    [sym_raw_string_literal] = ACTIONS(3257),
    [aux_sym_preproc_if_token1] = ACTIONS(3257),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3257),
    [sym_interpolation_verbatim_start] = ACTIONS(3257),
    [sym_interpolation_raw_start] = ACTIONS(3257),
  },
  [2683] = {
    [sym_preproc_region] = STATE(2683),
    [sym_preproc_endregion] = STATE(2683),
    [sym_preproc_line] = STATE(2683),
    [sym_preproc_pragma] = STATE(2683),
    [sym_preproc_nullable] = STATE(2683),
    [sym_preproc_error] = STATE(2683),
    [sym_preproc_define] = STATE(2683),
    [sym_preproc_undef] = STATE(2683),
    [sym__identifier_token] = ACTIONS(3339),
    [anon_sym_extern] = ACTIONS(3339),
    [anon_sym_alias] = ACTIONS(3339),
    [anon_sym_SEMI] = ACTIONS(3341),
    [anon_sym_global] = ACTIONS(3339),
    [anon_sym_using] = ACTIONS(3339),
    [anon_sym_unsafe] = ACTIONS(3339),
    [anon_sym_static] = ACTIONS(3339),
    [anon_sym_LBRACK] = ACTIONS(3341),
    [anon_sym_LPAREN] = ACTIONS(3341),
    [anon_sym_return] = ACTIONS(3339),
    [anon_sym_ref] = ACTIONS(3339),
    [anon_sym_LBRACE] = ACTIONS(3341),
    [anon_sym_RBRACE] = ACTIONS(3341),
    [anon_sym_delegate] = ACTIONS(3339),
    [anon_sym_abstract] = ACTIONS(3339),
    [anon_sym_async] = ACTIONS(3339),
    [anon_sym_const] = ACTIONS(3339),
    [anon_sym_file] = ACTIONS(3339),
    [anon_sym_fixed] = ACTIONS(3339),
    [anon_sym_internal] = ACTIONS(3339),
    [anon_sym_new] = ACTIONS(3339),
    [anon_sym_override] = ACTIONS(3339),
    [anon_sym_partial] = ACTIONS(3339),
    [anon_sym_private] = ACTIONS(3339),
    [anon_sym_protected] = ACTIONS(3339),
    [anon_sym_public] = ACTIONS(3339),
    [anon_sym_readonly] = ACTIONS(3339),
    [anon_sym_required] = ACTIONS(3339),
    [anon_sym_sealed] = ACTIONS(3339),
    [anon_sym_virtual] = ACTIONS(3339),
    [anon_sym_volatile] = ACTIONS(3339),
    [anon_sym_where] = ACTIONS(3339),
    [anon_sym_notnull] = ACTIONS(3339),
    [anon_sym_unmanaged] = ACTIONS(3339),
    [anon_sym_checked] = ACTIONS(3339),
    [anon_sym_BANG] = ACTIONS(3341),
    [anon_sym_TILDE] = ACTIONS(3341),
    [anon_sym_PLUS_PLUS] = ACTIONS(3341),
    [anon_sym_DASH_DASH] = ACTIONS(3341),
    [anon_sym_true] = ACTIONS(3339),
    [anon_sym_false] = ACTIONS(3339),
    [anon_sym_PLUS] = ACTIONS(3339),
    [anon_sym_DASH] = ACTIONS(3339),
    [anon_sym_STAR] = ACTIONS(3341),
    [anon_sym_CARET] = ACTIONS(3341),
    [anon_sym_AMP] = ACTIONS(3341),
    [anon_sym_this] = ACTIONS(3339),
    [anon_sym_scoped] = ACTIONS(3339),
    [anon_sym_var] = ACTIONS(3339),
    [sym_predefined_type] = ACTIONS(3339),
    [anon_sym_break] = ACTIONS(3339),
    [anon_sym_unchecked] = ACTIONS(3339),
    [anon_sym_continue] = ACTIONS(3339),
    [anon_sym_do] = ACTIONS(3339),
    [anon_sym_while] = ACTIONS(3339),
    [anon_sym_for] = ACTIONS(3339),
    [anon_sym_lock] = ACTIONS(3339),
    [anon_sym_yield] = ACTIONS(3339),
    [anon_sym_switch] = ACTIONS(3339),
    [anon_sym_case] = ACTIONS(3339),
    [anon_sym_default] = ACTIONS(3339),
    [anon_sym_throw] = ACTIONS(3339),
    [anon_sym_try] = ACTIONS(3339),
    [anon_sym_when] = ACTIONS(3339),
    [anon_sym_await] = ACTIONS(3339),
    [anon_sym_foreach] = ACTIONS(3339),
    [anon_sym_goto] = ACTIONS(3339),
    [anon_sym_if] = ACTIONS(3339),
    [anon_sym_else] = ACTIONS(3339),
    [anon_sym_DOT_DOT] = ACTIONS(3341),
    [anon_sym_from] = ACTIONS(3339),
    [anon_sym_into] = ACTIONS(3339),
    [anon_sym_join] = ACTIONS(3339),
    [anon_sym_on] = ACTIONS(3339),
    [anon_sym_equals] = ACTIONS(3339),
    [anon_sym_let] = ACTIONS(3339),
    [anon_sym_orderby] = ACTIONS(3339),
    [anon_sym_ascending] = ACTIONS(3339),
    [anon_sym_descending] = ACTIONS(3339),
    [anon_sym_group] = ACTIONS(3339),
    [anon_sym_by] = ACTIONS(3339),
    [anon_sym_select] = ACTIONS(3339),
    [anon_sym_DQUOTE] = ACTIONS(3339),
    [anon_sym_stackalloc] = ACTIONS(3339),
    [anon_sym_sizeof] = ACTIONS(3339),
    [anon_sym_typeof] = ACTIONS(3339),
    [anon_sym___makeref] = ACTIONS(3339),
    [anon_sym___reftype] = ACTIONS(3339),
    [anon_sym___refvalue] = ACTIONS(3339),
    [sym_null_literal] = ACTIONS(3339),
    [anon_sym_SQUOTE] = ACTIONS(3341),
    [sym_integer_literal] = ACTIONS(3339),
    [sym_real_literal] = ACTIONS(3341),
    [sym_verbatim_string_literal] = ACTIONS(3341),
    [sym_raw_string_literal] = ACTIONS(3341),
    [aux_sym_preproc_if_token1] = ACTIONS(3341),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3341),
    [sym_interpolation_verbatim_start] = ACTIONS(3341),
    [sym_interpolation_raw_start] = ACTIONS(3341),
  },
  [2684] = {
    [sym_preproc_region] = STATE(2684),
    [sym_preproc_endregion] = STATE(2684),
    [sym_preproc_line] = STATE(2684),
    [sym_preproc_pragma] = STATE(2684),
    [sym_preproc_nullable] = STATE(2684),
    [sym_preproc_error] = STATE(2684),
    [sym_preproc_define] = STATE(2684),
    [sym_preproc_undef] = STATE(2684),
    [sym__identifier_token] = ACTIONS(3287),
    [anon_sym_extern] = ACTIONS(3287),
    [anon_sym_alias] = ACTIONS(3287),
    [anon_sym_SEMI] = ACTIONS(3289),
    [anon_sym_global] = ACTIONS(3287),
    [anon_sym_using] = ACTIONS(3287),
    [anon_sym_unsafe] = ACTIONS(3287),
    [anon_sym_static] = ACTIONS(3287),
    [anon_sym_LBRACK] = ACTIONS(3289),
    [anon_sym_LPAREN] = ACTIONS(3289),
    [anon_sym_return] = ACTIONS(3287),
    [anon_sym_ref] = ACTIONS(3287),
    [anon_sym_LBRACE] = ACTIONS(3289),
    [anon_sym_RBRACE] = ACTIONS(3289),
    [anon_sym_delegate] = ACTIONS(3287),
    [anon_sym_abstract] = ACTIONS(3287),
    [anon_sym_async] = ACTIONS(3287),
    [anon_sym_const] = ACTIONS(3287),
    [anon_sym_file] = ACTIONS(3287),
    [anon_sym_fixed] = ACTIONS(3287),
    [anon_sym_internal] = ACTIONS(3287),
    [anon_sym_new] = ACTIONS(3287),
    [anon_sym_override] = ACTIONS(3287),
    [anon_sym_partial] = ACTIONS(3287),
    [anon_sym_private] = ACTIONS(3287),
    [anon_sym_protected] = ACTIONS(3287),
    [anon_sym_public] = ACTIONS(3287),
    [anon_sym_readonly] = ACTIONS(3287),
    [anon_sym_required] = ACTIONS(3287),
    [anon_sym_sealed] = ACTIONS(3287),
    [anon_sym_virtual] = ACTIONS(3287),
    [anon_sym_volatile] = ACTIONS(3287),
    [anon_sym_where] = ACTIONS(3287),
    [anon_sym_notnull] = ACTIONS(3287),
    [anon_sym_unmanaged] = ACTIONS(3287),
    [anon_sym_checked] = ACTIONS(3287),
    [anon_sym_BANG] = ACTIONS(3289),
    [anon_sym_TILDE] = ACTIONS(3289),
    [anon_sym_PLUS_PLUS] = ACTIONS(3289),
    [anon_sym_DASH_DASH] = ACTIONS(3289),
    [anon_sym_true] = ACTIONS(3287),
    [anon_sym_false] = ACTIONS(3287),
    [anon_sym_PLUS] = ACTIONS(3287),
    [anon_sym_DASH] = ACTIONS(3287),
    [anon_sym_STAR] = ACTIONS(3289),
    [anon_sym_CARET] = ACTIONS(3289),
    [anon_sym_AMP] = ACTIONS(3289),
    [anon_sym_this] = ACTIONS(3287),
    [anon_sym_scoped] = ACTIONS(3287),
    [anon_sym_var] = ACTIONS(3287),
    [sym_predefined_type] = ACTIONS(3287),
    [anon_sym_break] = ACTIONS(3287),
    [anon_sym_unchecked] = ACTIONS(3287),
    [anon_sym_continue] = ACTIONS(3287),
    [anon_sym_do] = ACTIONS(3287),
    [anon_sym_while] = ACTIONS(3287),
    [anon_sym_for] = ACTIONS(3287),
    [anon_sym_lock] = ACTIONS(3287),
    [anon_sym_yield] = ACTIONS(3287),
    [anon_sym_switch] = ACTIONS(3287),
    [anon_sym_case] = ACTIONS(3287),
    [anon_sym_default] = ACTIONS(3287),
    [anon_sym_throw] = ACTIONS(3287),
    [anon_sym_try] = ACTIONS(3287),
    [anon_sym_when] = ACTIONS(3287),
    [anon_sym_await] = ACTIONS(3287),
    [anon_sym_foreach] = ACTIONS(3287),
    [anon_sym_goto] = ACTIONS(3287),
    [anon_sym_if] = ACTIONS(3287),
    [anon_sym_else] = ACTIONS(3287),
    [anon_sym_DOT_DOT] = ACTIONS(3289),
    [anon_sym_from] = ACTIONS(3287),
    [anon_sym_into] = ACTIONS(3287),
    [anon_sym_join] = ACTIONS(3287),
    [anon_sym_on] = ACTIONS(3287),
    [anon_sym_equals] = ACTIONS(3287),
    [anon_sym_let] = ACTIONS(3287),
    [anon_sym_orderby] = ACTIONS(3287),
    [anon_sym_ascending] = ACTIONS(3287),
    [anon_sym_descending] = ACTIONS(3287),
    [anon_sym_group] = ACTIONS(3287),
    [anon_sym_by] = ACTIONS(3287),
    [anon_sym_select] = ACTIONS(3287),
    [anon_sym_DQUOTE] = ACTIONS(3287),
    [anon_sym_stackalloc] = ACTIONS(3287),
    [anon_sym_sizeof] = ACTIONS(3287),
    [anon_sym_typeof] = ACTIONS(3287),
    [anon_sym___makeref] = ACTIONS(3287),
    [anon_sym___reftype] = ACTIONS(3287),
    [anon_sym___refvalue] = ACTIONS(3287),
    [sym_null_literal] = ACTIONS(3287),
    [anon_sym_SQUOTE] = ACTIONS(3289),
    [sym_integer_literal] = ACTIONS(3287),
    [sym_real_literal] = ACTIONS(3289),
    [sym_verbatim_string_literal] = ACTIONS(3289),
    [sym_raw_string_literal] = ACTIONS(3289),
    [aux_sym_preproc_if_token1] = ACTIONS(3289),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3289),
    [sym_interpolation_verbatim_start] = ACTIONS(3289),
    [sym_interpolation_raw_start] = ACTIONS(3289),
  },
  [2685] = {
    [sym_preproc_region] = STATE(2685),
    [sym_preproc_endregion] = STATE(2685),
    [sym_preproc_line] = STATE(2685),
    [sym_preproc_pragma] = STATE(2685),
    [sym_preproc_nullable] = STATE(2685),
    [sym_preproc_error] = STATE(2685),
    [sym_preproc_define] = STATE(2685),
    [sym_preproc_undef] = STATE(2685),
    [sym__identifier_token] = ACTIONS(3311),
    [anon_sym_extern] = ACTIONS(3311),
    [anon_sym_alias] = ACTIONS(3311),
    [anon_sym_SEMI] = ACTIONS(3313),
    [anon_sym_global] = ACTIONS(3311),
    [anon_sym_using] = ACTIONS(3311),
    [anon_sym_unsafe] = ACTIONS(3311),
    [anon_sym_static] = ACTIONS(3311),
    [anon_sym_LBRACK] = ACTIONS(3313),
    [anon_sym_LPAREN] = ACTIONS(3313),
    [anon_sym_return] = ACTIONS(3311),
    [anon_sym_ref] = ACTIONS(3311),
    [anon_sym_LBRACE] = ACTIONS(3313),
    [anon_sym_RBRACE] = ACTIONS(3313),
    [anon_sym_delegate] = ACTIONS(3311),
    [anon_sym_abstract] = ACTIONS(3311),
    [anon_sym_async] = ACTIONS(3311),
    [anon_sym_const] = ACTIONS(3311),
    [anon_sym_file] = ACTIONS(3311),
    [anon_sym_fixed] = ACTIONS(3311),
    [anon_sym_internal] = ACTIONS(3311),
    [anon_sym_new] = ACTIONS(3311),
    [anon_sym_override] = ACTIONS(3311),
    [anon_sym_partial] = ACTIONS(3311),
    [anon_sym_private] = ACTIONS(3311),
    [anon_sym_protected] = ACTIONS(3311),
    [anon_sym_public] = ACTIONS(3311),
    [anon_sym_readonly] = ACTIONS(3311),
    [anon_sym_required] = ACTIONS(3311),
    [anon_sym_sealed] = ACTIONS(3311),
    [anon_sym_virtual] = ACTIONS(3311),
    [anon_sym_volatile] = ACTIONS(3311),
    [anon_sym_where] = ACTIONS(3311),
    [anon_sym_notnull] = ACTIONS(3311),
    [anon_sym_unmanaged] = ACTIONS(3311),
    [anon_sym_checked] = ACTIONS(3311),
    [anon_sym_BANG] = ACTIONS(3313),
    [anon_sym_TILDE] = ACTIONS(3313),
    [anon_sym_PLUS_PLUS] = ACTIONS(3313),
    [anon_sym_DASH_DASH] = ACTIONS(3313),
    [anon_sym_true] = ACTIONS(3311),
    [anon_sym_false] = ACTIONS(3311),
    [anon_sym_PLUS] = ACTIONS(3311),
    [anon_sym_DASH] = ACTIONS(3311),
    [anon_sym_STAR] = ACTIONS(3313),
    [anon_sym_CARET] = ACTIONS(3313),
    [anon_sym_AMP] = ACTIONS(3313),
    [anon_sym_this] = ACTIONS(3311),
    [anon_sym_scoped] = ACTIONS(3311),
    [anon_sym_var] = ACTIONS(3311),
    [sym_predefined_type] = ACTIONS(3311),
    [anon_sym_break] = ACTIONS(3311),
    [anon_sym_unchecked] = ACTIONS(3311),
    [anon_sym_continue] = ACTIONS(3311),
    [anon_sym_do] = ACTIONS(3311),
    [anon_sym_while] = ACTIONS(3311),
    [anon_sym_for] = ACTIONS(3311),
    [anon_sym_lock] = ACTIONS(3311),
    [anon_sym_yield] = ACTIONS(3311),
    [anon_sym_switch] = ACTIONS(3311),
    [anon_sym_case] = ACTIONS(3311),
    [anon_sym_default] = ACTIONS(3311),
    [anon_sym_throw] = ACTIONS(3311),
    [anon_sym_try] = ACTIONS(3311),
    [anon_sym_when] = ACTIONS(3311),
    [anon_sym_await] = ACTIONS(3311),
    [anon_sym_foreach] = ACTIONS(3311),
    [anon_sym_goto] = ACTIONS(3311),
    [anon_sym_if] = ACTIONS(3311),
    [anon_sym_else] = ACTIONS(3311),
    [anon_sym_DOT_DOT] = ACTIONS(3313),
    [anon_sym_from] = ACTIONS(3311),
    [anon_sym_into] = ACTIONS(3311),
    [anon_sym_join] = ACTIONS(3311),
    [anon_sym_on] = ACTIONS(3311),
    [anon_sym_equals] = ACTIONS(3311),
    [anon_sym_let] = ACTIONS(3311),
    [anon_sym_orderby] = ACTIONS(3311),
    [anon_sym_ascending] = ACTIONS(3311),
    [anon_sym_descending] = ACTIONS(3311),
    [anon_sym_group] = ACTIONS(3311),
    [anon_sym_by] = ACTIONS(3311),
    [anon_sym_select] = ACTIONS(3311),
    [anon_sym_DQUOTE] = ACTIONS(3311),
    [anon_sym_stackalloc] = ACTIONS(3311),
    [anon_sym_sizeof] = ACTIONS(3311),
    [anon_sym_typeof] = ACTIONS(3311),
    [anon_sym___makeref] = ACTIONS(3311),
    [anon_sym___reftype] = ACTIONS(3311),
    [anon_sym___refvalue] = ACTIONS(3311),
    [sym_null_literal] = ACTIONS(3311),
    [anon_sym_SQUOTE] = ACTIONS(3313),
    [sym_integer_literal] = ACTIONS(3311),
    [sym_real_literal] = ACTIONS(3313),
    [sym_verbatim_string_literal] = ACTIONS(3313),
    [sym_raw_string_literal] = ACTIONS(3313),
    [aux_sym_preproc_if_token1] = ACTIONS(3313),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3313),
    [sym_interpolation_verbatim_start] = ACTIONS(3313),
    [sym_interpolation_raw_start] = ACTIONS(3313),
  },
  [2686] = {
    [sym_preproc_region] = STATE(2686),
    [sym_preproc_endregion] = STATE(2686),
    [sym_preproc_line] = STATE(2686),
    [sym_preproc_pragma] = STATE(2686),
    [sym_preproc_nullable] = STATE(2686),
    [sym_preproc_error] = STATE(2686),
    [sym_preproc_define] = STATE(2686),
    [sym_preproc_undef] = STATE(2686),
    [sym__identifier_token] = ACTIONS(3077),
    [anon_sym_extern] = ACTIONS(3077),
    [anon_sym_alias] = ACTIONS(3077),
    [anon_sym_SEMI] = ACTIONS(3079),
    [anon_sym_global] = ACTIONS(3077),
    [anon_sym_using] = ACTIONS(3077),
    [anon_sym_unsafe] = ACTIONS(3077),
    [anon_sym_static] = ACTIONS(3077),
    [anon_sym_LBRACK] = ACTIONS(3079),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_return] = ACTIONS(3077),
    [anon_sym_ref] = ACTIONS(3077),
    [anon_sym_LBRACE] = ACTIONS(3079),
    [anon_sym_RBRACE] = ACTIONS(3079),
    [anon_sym_delegate] = ACTIONS(3077),
    [anon_sym_abstract] = ACTIONS(3077),
    [anon_sym_async] = ACTIONS(3077),
    [anon_sym_const] = ACTIONS(3077),
    [anon_sym_file] = ACTIONS(3077),
    [anon_sym_fixed] = ACTIONS(3077),
    [anon_sym_internal] = ACTIONS(3077),
    [anon_sym_new] = ACTIONS(3077),
    [anon_sym_override] = ACTIONS(3077),
    [anon_sym_partial] = ACTIONS(3077),
    [anon_sym_private] = ACTIONS(3077),
    [anon_sym_protected] = ACTIONS(3077),
    [anon_sym_public] = ACTIONS(3077),
    [anon_sym_readonly] = ACTIONS(3077),
    [anon_sym_required] = ACTIONS(3077),
    [anon_sym_sealed] = ACTIONS(3077),
    [anon_sym_virtual] = ACTIONS(3077),
    [anon_sym_volatile] = ACTIONS(3077),
    [anon_sym_where] = ACTIONS(3077),
    [anon_sym_notnull] = ACTIONS(3077),
    [anon_sym_unmanaged] = ACTIONS(3077),
    [anon_sym_checked] = ACTIONS(3077),
    [anon_sym_BANG] = ACTIONS(3079),
    [anon_sym_TILDE] = ACTIONS(3079),
    [anon_sym_PLUS_PLUS] = ACTIONS(3079),
    [anon_sym_DASH_DASH] = ACTIONS(3079),
    [anon_sym_true] = ACTIONS(3077),
    [anon_sym_false] = ACTIONS(3077),
    [anon_sym_PLUS] = ACTIONS(3077),
    [anon_sym_DASH] = ACTIONS(3077),
    [anon_sym_STAR] = ACTIONS(3079),
    [anon_sym_CARET] = ACTIONS(3079),
    [anon_sym_AMP] = ACTIONS(3079),
    [anon_sym_this] = ACTIONS(3077),
    [anon_sym_scoped] = ACTIONS(3077),
    [anon_sym_var] = ACTIONS(3077),
    [sym_predefined_type] = ACTIONS(3077),
    [anon_sym_break] = ACTIONS(3077),
    [anon_sym_unchecked] = ACTIONS(3077),
    [anon_sym_continue] = ACTIONS(3077),
    [anon_sym_do] = ACTIONS(3077),
    [anon_sym_while] = ACTIONS(3077),
    [anon_sym_for] = ACTIONS(3077),
    [anon_sym_lock] = ACTIONS(3077),
    [anon_sym_yield] = ACTIONS(3077),
    [anon_sym_switch] = ACTIONS(3077),
    [anon_sym_case] = ACTIONS(3077),
    [anon_sym_default] = ACTIONS(3077),
    [anon_sym_throw] = ACTIONS(3077),
    [anon_sym_try] = ACTIONS(3077),
    [anon_sym_when] = ACTIONS(3077),
    [anon_sym_await] = ACTIONS(3077),
    [anon_sym_foreach] = ACTIONS(3077),
    [anon_sym_goto] = ACTIONS(3077),
    [anon_sym_if] = ACTIONS(3077),
    [anon_sym_else] = ACTIONS(3077),
    [anon_sym_DOT_DOT] = ACTIONS(3079),
    [anon_sym_from] = ACTIONS(3077),
    [anon_sym_into] = ACTIONS(3077),
    [anon_sym_join] = ACTIONS(3077),
    [anon_sym_on] = ACTIONS(3077),
    [anon_sym_equals] = ACTIONS(3077),
    [anon_sym_let] = ACTIONS(3077),
    [anon_sym_orderby] = ACTIONS(3077),
    [anon_sym_ascending] = ACTIONS(3077),
    [anon_sym_descending] = ACTIONS(3077),
    [anon_sym_group] = ACTIONS(3077),
    [anon_sym_by] = ACTIONS(3077),
    [anon_sym_select] = ACTIONS(3077),
    [anon_sym_DQUOTE] = ACTIONS(3077),
    [anon_sym_stackalloc] = ACTIONS(3077),
    [anon_sym_sizeof] = ACTIONS(3077),
    [anon_sym_typeof] = ACTIONS(3077),
    [anon_sym___makeref] = ACTIONS(3077),
    [anon_sym___reftype] = ACTIONS(3077),
    [anon_sym___refvalue] = ACTIONS(3077),
    [sym_null_literal] = ACTIONS(3077),
    [anon_sym_SQUOTE] = ACTIONS(3079),
    [sym_integer_literal] = ACTIONS(3077),
    [sym_real_literal] = ACTIONS(3079),
    [sym_verbatim_string_literal] = ACTIONS(3079),
    [sym_raw_string_literal] = ACTIONS(3079),
    [aux_sym_preproc_if_token1] = ACTIONS(3079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3079),
    [sym_interpolation_verbatim_start] = ACTIONS(3079),
    [sym_interpolation_raw_start] = ACTIONS(3079),
  },
  [2687] = {
    [sym_preproc_region] = STATE(2687),
    [sym_preproc_endregion] = STATE(2687),
    [sym_preproc_line] = STATE(2687),
    [sym_preproc_pragma] = STATE(2687),
    [sym_preproc_nullable] = STATE(2687),
    [sym_preproc_error] = STATE(2687),
    [sym_preproc_define] = STATE(2687),
    [sym_preproc_undef] = STATE(2687),
    [sym__identifier_token] = ACTIONS(3283),
    [anon_sym_extern] = ACTIONS(3283),
    [anon_sym_alias] = ACTIONS(3283),
    [anon_sym_SEMI] = ACTIONS(3285),
    [anon_sym_global] = ACTIONS(3283),
    [anon_sym_using] = ACTIONS(3283),
    [anon_sym_unsafe] = ACTIONS(3283),
    [anon_sym_static] = ACTIONS(3283),
    [anon_sym_LBRACK] = ACTIONS(3285),
    [anon_sym_LPAREN] = ACTIONS(3285),
    [anon_sym_return] = ACTIONS(3283),
    [anon_sym_ref] = ACTIONS(3283),
    [anon_sym_LBRACE] = ACTIONS(3285),
    [anon_sym_RBRACE] = ACTIONS(3285),
    [anon_sym_delegate] = ACTIONS(3283),
    [anon_sym_abstract] = ACTIONS(3283),
    [anon_sym_async] = ACTIONS(3283),
    [anon_sym_const] = ACTIONS(3283),
    [anon_sym_file] = ACTIONS(3283),
    [anon_sym_fixed] = ACTIONS(3283),
    [anon_sym_internal] = ACTIONS(3283),
    [anon_sym_new] = ACTIONS(3283),
    [anon_sym_override] = ACTIONS(3283),
    [anon_sym_partial] = ACTIONS(3283),
    [anon_sym_private] = ACTIONS(3283),
    [anon_sym_protected] = ACTIONS(3283),
    [anon_sym_public] = ACTIONS(3283),
    [anon_sym_readonly] = ACTIONS(3283),
    [anon_sym_required] = ACTIONS(3283),
    [anon_sym_sealed] = ACTIONS(3283),
    [anon_sym_virtual] = ACTIONS(3283),
    [anon_sym_volatile] = ACTIONS(3283),
    [anon_sym_where] = ACTIONS(3283),
    [anon_sym_notnull] = ACTIONS(3283),
    [anon_sym_unmanaged] = ACTIONS(3283),
    [anon_sym_checked] = ACTIONS(3283),
    [anon_sym_BANG] = ACTIONS(3285),
    [anon_sym_TILDE] = ACTIONS(3285),
    [anon_sym_PLUS_PLUS] = ACTIONS(3285),
    [anon_sym_DASH_DASH] = ACTIONS(3285),
    [anon_sym_true] = ACTIONS(3283),
    [anon_sym_false] = ACTIONS(3283),
    [anon_sym_PLUS] = ACTIONS(3283),
    [anon_sym_DASH] = ACTIONS(3283),
    [anon_sym_STAR] = ACTIONS(3285),
    [anon_sym_CARET] = ACTIONS(3285),
    [anon_sym_AMP] = ACTIONS(3285),
    [anon_sym_this] = ACTIONS(3283),
    [anon_sym_scoped] = ACTIONS(3283),
    [anon_sym_var] = ACTIONS(3283),
    [sym_predefined_type] = ACTIONS(3283),
    [anon_sym_break] = ACTIONS(3283),
    [anon_sym_unchecked] = ACTIONS(3283),
    [anon_sym_continue] = ACTIONS(3283),
    [anon_sym_do] = ACTIONS(3283),
    [anon_sym_while] = ACTIONS(3283),
    [anon_sym_for] = ACTIONS(3283),
    [anon_sym_lock] = ACTIONS(3283),
    [anon_sym_yield] = ACTIONS(3283),
    [anon_sym_switch] = ACTIONS(3283),
    [anon_sym_case] = ACTIONS(3283),
    [anon_sym_default] = ACTIONS(3283),
    [anon_sym_throw] = ACTIONS(3283),
    [anon_sym_try] = ACTIONS(3283),
    [anon_sym_when] = ACTIONS(3283),
    [anon_sym_await] = ACTIONS(3283),
    [anon_sym_foreach] = ACTIONS(3283),
    [anon_sym_goto] = ACTIONS(3283),
    [anon_sym_if] = ACTIONS(3283),
    [anon_sym_else] = ACTIONS(3283),
    [anon_sym_DOT_DOT] = ACTIONS(3285),
    [anon_sym_from] = ACTIONS(3283),
    [anon_sym_into] = ACTIONS(3283),
    [anon_sym_join] = ACTIONS(3283),
    [anon_sym_on] = ACTIONS(3283),
    [anon_sym_equals] = ACTIONS(3283),
    [anon_sym_let] = ACTIONS(3283),
    [anon_sym_orderby] = ACTIONS(3283),
    [anon_sym_ascending] = ACTIONS(3283),
    [anon_sym_descending] = ACTIONS(3283),
    [anon_sym_group] = ACTIONS(3283),
    [anon_sym_by] = ACTIONS(3283),
    [anon_sym_select] = ACTIONS(3283),
    [anon_sym_DQUOTE] = ACTIONS(3283),
    [anon_sym_stackalloc] = ACTIONS(3283),
    [anon_sym_sizeof] = ACTIONS(3283),
    [anon_sym_typeof] = ACTIONS(3283),
    [anon_sym___makeref] = ACTIONS(3283),
    [anon_sym___reftype] = ACTIONS(3283),
    [anon_sym___refvalue] = ACTIONS(3283),
    [sym_null_literal] = ACTIONS(3283),
    [anon_sym_SQUOTE] = ACTIONS(3285),
    [sym_integer_literal] = ACTIONS(3283),
    [sym_real_literal] = ACTIONS(3285),
    [sym_verbatim_string_literal] = ACTIONS(3285),
    [sym_raw_string_literal] = ACTIONS(3285),
    [aux_sym_preproc_if_token1] = ACTIONS(3285),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3285),
    [sym_interpolation_verbatim_start] = ACTIONS(3285),
    [sym_interpolation_raw_start] = ACTIONS(3285),
  },
  [2688] = {
    [sym_preproc_region] = STATE(2688),
    [sym_preproc_endregion] = STATE(2688),
    [sym_preproc_line] = STATE(2688),
    [sym_preproc_pragma] = STATE(2688),
    [sym_preproc_nullable] = STATE(2688),
    [sym_preproc_error] = STATE(2688),
    [sym_preproc_define] = STATE(2688),
    [sym_preproc_undef] = STATE(2688),
    [sym__identifier_token] = ACTIONS(3073),
    [anon_sym_extern] = ACTIONS(3073),
    [anon_sym_alias] = ACTIONS(3073),
    [anon_sym_SEMI] = ACTIONS(3075),
    [anon_sym_global] = ACTIONS(3073),
    [anon_sym_using] = ACTIONS(3073),
    [anon_sym_unsafe] = ACTIONS(3073),
    [anon_sym_static] = ACTIONS(3073),
    [anon_sym_LBRACK] = ACTIONS(3075),
    [anon_sym_LPAREN] = ACTIONS(3075),
    [anon_sym_return] = ACTIONS(3073),
    [anon_sym_ref] = ACTIONS(3073),
    [anon_sym_LBRACE] = ACTIONS(3075),
    [anon_sym_RBRACE] = ACTIONS(3075),
    [anon_sym_delegate] = ACTIONS(3073),
    [anon_sym_abstract] = ACTIONS(3073),
    [anon_sym_async] = ACTIONS(3073),
    [anon_sym_const] = ACTIONS(3073),
    [anon_sym_file] = ACTIONS(3073),
    [anon_sym_fixed] = ACTIONS(3073),
    [anon_sym_internal] = ACTIONS(3073),
    [anon_sym_new] = ACTIONS(3073),
    [anon_sym_override] = ACTIONS(3073),
    [anon_sym_partial] = ACTIONS(3073),
    [anon_sym_private] = ACTIONS(3073),
    [anon_sym_protected] = ACTIONS(3073),
    [anon_sym_public] = ACTIONS(3073),
    [anon_sym_readonly] = ACTIONS(3073),
    [anon_sym_required] = ACTIONS(3073),
    [anon_sym_sealed] = ACTIONS(3073),
    [anon_sym_virtual] = ACTIONS(3073),
    [anon_sym_volatile] = ACTIONS(3073),
    [anon_sym_where] = ACTIONS(3073),
    [anon_sym_notnull] = ACTIONS(3073),
    [anon_sym_unmanaged] = ACTIONS(3073),
    [anon_sym_checked] = ACTIONS(3073),
    [anon_sym_BANG] = ACTIONS(3075),
    [anon_sym_TILDE] = ACTIONS(3075),
    [anon_sym_PLUS_PLUS] = ACTIONS(3075),
    [anon_sym_DASH_DASH] = ACTIONS(3075),
    [anon_sym_true] = ACTIONS(3073),
    [anon_sym_false] = ACTIONS(3073),
    [anon_sym_PLUS] = ACTIONS(3073),
    [anon_sym_DASH] = ACTIONS(3073),
    [anon_sym_STAR] = ACTIONS(3075),
    [anon_sym_CARET] = ACTIONS(3075),
    [anon_sym_AMP] = ACTIONS(3075),
    [anon_sym_this] = ACTIONS(3073),
    [anon_sym_scoped] = ACTIONS(3073),
    [anon_sym_var] = ACTIONS(3073),
    [sym_predefined_type] = ACTIONS(3073),
    [anon_sym_break] = ACTIONS(3073),
    [anon_sym_unchecked] = ACTIONS(3073),
    [anon_sym_continue] = ACTIONS(3073),
    [anon_sym_do] = ACTIONS(3073),
    [anon_sym_while] = ACTIONS(3073),
    [anon_sym_for] = ACTIONS(3073),
    [anon_sym_lock] = ACTIONS(3073),
    [anon_sym_yield] = ACTIONS(3073),
    [anon_sym_switch] = ACTIONS(3073),
    [anon_sym_case] = ACTIONS(3073),
    [anon_sym_default] = ACTIONS(3073),
    [anon_sym_throw] = ACTIONS(3073),
    [anon_sym_try] = ACTIONS(3073),
    [anon_sym_when] = ACTIONS(3073),
    [anon_sym_await] = ACTIONS(3073),
    [anon_sym_foreach] = ACTIONS(3073),
    [anon_sym_goto] = ACTIONS(3073),
    [anon_sym_if] = ACTIONS(3073),
    [anon_sym_else] = ACTIONS(3073),
    [anon_sym_DOT_DOT] = ACTIONS(3075),
    [anon_sym_from] = ACTIONS(3073),
    [anon_sym_into] = ACTIONS(3073),
    [anon_sym_join] = ACTIONS(3073),
    [anon_sym_on] = ACTIONS(3073),
    [anon_sym_equals] = ACTIONS(3073),
    [anon_sym_let] = ACTIONS(3073),
    [anon_sym_orderby] = ACTIONS(3073),
    [anon_sym_ascending] = ACTIONS(3073),
    [anon_sym_descending] = ACTIONS(3073),
    [anon_sym_group] = ACTIONS(3073),
    [anon_sym_by] = ACTIONS(3073),
    [anon_sym_select] = ACTIONS(3073),
    [anon_sym_DQUOTE] = ACTIONS(3073),
    [anon_sym_stackalloc] = ACTIONS(3073),
    [anon_sym_sizeof] = ACTIONS(3073),
    [anon_sym_typeof] = ACTIONS(3073),
    [anon_sym___makeref] = ACTIONS(3073),
    [anon_sym___reftype] = ACTIONS(3073),
    [anon_sym___refvalue] = ACTIONS(3073),
    [sym_null_literal] = ACTIONS(3073),
    [anon_sym_SQUOTE] = ACTIONS(3075),
    [sym_integer_literal] = ACTIONS(3073),
    [sym_real_literal] = ACTIONS(3075),
    [sym_verbatim_string_literal] = ACTIONS(3075),
    [sym_raw_string_literal] = ACTIONS(3075),
    [aux_sym_preproc_if_token1] = ACTIONS(3075),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3075),
    [sym_interpolation_verbatim_start] = ACTIONS(3075),
    [sym_interpolation_raw_start] = ACTIONS(3075),
  },
  [2689] = {
    [sym_preproc_region] = STATE(2689),
    [sym_preproc_endregion] = STATE(2689),
    [sym_preproc_line] = STATE(2689),
    [sym_preproc_pragma] = STATE(2689),
    [sym_preproc_nullable] = STATE(2689),
    [sym_preproc_error] = STATE(2689),
    [sym_preproc_define] = STATE(2689),
    [sym_preproc_undef] = STATE(2689),
    [sym__identifier_token] = ACTIONS(3069),
    [anon_sym_extern] = ACTIONS(3069),
    [anon_sym_alias] = ACTIONS(3069),
    [anon_sym_SEMI] = ACTIONS(3071),
    [anon_sym_global] = ACTIONS(3069),
    [anon_sym_using] = ACTIONS(3069),
    [anon_sym_unsafe] = ACTIONS(3069),
    [anon_sym_static] = ACTIONS(3069),
    [anon_sym_LBRACK] = ACTIONS(3071),
    [anon_sym_LPAREN] = ACTIONS(3071),
    [anon_sym_return] = ACTIONS(3069),
    [anon_sym_ref] = ACTIONS(3069),
    [anon_sym_LBRACE] = ACTIONS(3071),
    [anon_sym_RBRACE] = ACTIONS(3071),
    [anon_sym_delegate] = ACTIONS(3069),
    [anon_sym_abstract] = ACTIONS(3069),
    [anon_sym_async] = ACTIONS(3069),
    [anon_sym_const] = ACTIONS(3069),
    [anon_sym_file] = ACTIONS(3069),
    [anon_sym_fixed] = ACTIONS(3069),
    [anon_sym_internal] = ACTIONS(3069),
    [anon_sym_new] = ACTIONS(3069),
    [anon_sym_override] = ACTIONS(3069),
    [anon_sym_partial] = ACTIONS(3069),
    [anon_sym_private] = ACTIONS(3069),
    [anon_sym_protected] = ACTIONS(3069),
    [anon_sym_public] = ACTIONS(3069),
    [anon_sym_readonly] = ACTIONS(3069),
    [anon_sym_required] = ACTIONS(3069),
    [anon_sym_sealed] = ACTIONS(3069),
    [anon_sym_virtual] = ACTIONS(3069),
    [anon_sym_volatile] = ACTIONS(3069),
    [anon_sym_where] = ACTIONS(3069),
    [anon_sym_notnull] = ACTIONS(3069),
    [anon_sym_unmanaged] = ACTIONS(3069),
    [anon_sym_checked] = ACTIONS(3069),
    [anon_sym_BANG] = ACTIONS(3071),
    [anon_sym_TILDE] = ACTIONS(3071),
    [anon_sym_PLUS_PLUS] = ACTIONS(3071),
    [anon_sym_DASH_DASH] = ACTIONS(3071),
    [anon_sym_true] = ACTIONS(3069),
    [anon_sym_false] = ACTIONS(3069),
    [anon_sym_PLUS] = ACTIONS(3069),
    [anon_sym_DASH] = ACTIONS(3069),
    [anon_sym_STAR] = ACTIONS(3071),
    [anon_sym_CARET] = ACTIONS(3071),
    [anon_sym_AMP] = ACTIONS(3071),
    [anon_sym_this] = ACTIONS(3069),
    [anon_sym_scoped] = ACTIONS(3069),
    [anon_sym_var] = ACTIONS(3069),
    [sym_predefined_type] = ACTIONS(3069),
    [anon_sym_break] = ACTIONS(3069),
    [anon_sym_unchecked] = ACTIONS(3069),
    [anon_sym_continue] = ACTIONS(3069),
    [anon_sym_do] = ACTIONS(3069),
    [anon_sym_while] = ACTIONS(3069),
    [anon_sym_for] = ACTIONS(3069),
    [anon_sym_lock] = ACTIONS(3069),
    [anon_sym_yield] = ACTIONS(3069),
    [anon_sym_switch] = ACTIONS(3069),
    [anon_sym_case] = ACTIONS(3069),
    [anon_sym_default] = ACTIONS(3069),
    [anon_sym_throw] = ACTIONS(3069),
    [anon_sym_try] = ACTIONS(3069),
    [anon_sym_when] = ACTIONS(3069),
    [anon_sym_await] = ACTIONS(3069),
    [anon_sym_foreach] = ACTIONS(3069),
    [anon_sym_goto] = ACTIONS(3069),
    [anon_sym_if] = ACTIONS(3069),
    [anon_sym_else] = ACTIONS(3069),
    [anon_sym_DOT_DOT] = ACTIONS(3071),
    [anon_sym_from] = ACTIONS(3069),
    [anon_sym_into] = ACTIONS(3069),
    [anon_sym_join] = ACTIONS(3069),
    [anon_sym_on] = ACTIONS(3069),
    [anon_sym_equals] = ACTIONS(3069),
    [anon_sym_let] = ACTIONS(3069),
    [anon_sym_orderby] = ACTIONS(3069),
    [anon_sym_ascending] = ACTIONS(3069),
    [anon_sym_descending] = ACTIONS(3069),
    [anon_sym_group] = ACTIONS(3069),
    [anon_sym_by] = ACTIONS(3069),
    [anon_sym_select] = ACTIONS(3069),
    [anon_sym_DQUOTE] = ACTIONS(3069),
    [anon_sym_stackalloc] = ACTIONS(3069),
    [anon_sym_sizeof] = ACTIONS(3069),
    [anon_sym_typeof] = ACTIONS(3069),
    [anon_sym___makeref] = ACTIONS(3069),
    [anon_sym___reftype] = ACTIONS(3069),
    [anon_sym___refvalue] = ACTIONS(3069),
    [sym_null_literal] = ACTIONS(3069),
    [anon_sym_SQUOTE] = ACTIONS(3071),
    [sym_integer_literal] = ACTIONS(3069),
    [sym_real_literal] = ACTIONS(3071),
    [sym_verbatim_string_literal] = ACTIONS(3071),
    [sym_raw_string_literal] = ACTIONS(3071),
    [aux_sym_preproc_if_token1] = ACTIONS(3071),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3071),
    [sym_interpolation_verbatim_start] = ACTIONS(3071),
    [sym_interpolation_raw_start] = ACTIONS(3071),
  },
  [2690] = {
    [sym_preproc_region] = STATE(2690),
    [sym_preproc_endregion] = STATE(2690),
    [sym_preproc_line] = STATE(2690),
    [sym_preproc_pragma] = STATE(2690),
    [sym_preproc_nullable] = STATE(2690),
    [sym_preproc_error] = STATE(2690),
    [sym_preproc_define] = STATE(2690),
    [sym_preproc_undef] = STATE(2690),
    [sym__identifier_token] = ACTIONS(3271),
    [anon_sym_extern] = ACTIONS(3271),
    [anon_sym_alias] = ACTIONS(3271),
    [anon_sym_SEMI] = ACTIONS(3273),
    [anon_sym_global] = ACTIONS(3271),
    [anon_sym_using] = ACTIONS(3271),
    [anon_sym_unsafe] = ACTIONS(3271),
    [anon_sym_static] = ACTIONS(3271),
    [anon_sym_LBRACK] = ACTIONS(3273),
    [anon_sym_LPAREN] = ACTIONS(3273),
    [anon_sym_return] = ACTIONS(3271),
    [anon_sym_ref] = ACTIONS(3271),
    [anon_sym_LBRACE] = ACTIONS(3273),
    [anon_sym_RBRACE] = ACTIONS(3273),
    [anon_sym_delegate] = ACTIONS(3271),
    [anon_sym_abstract] = ACTIONS(3271),
    [anon_sym_async] = ACTIONS(3271),
    [anon_sym_const] = ACTIONS(3271),
    [anon_sym_file] = ACTIONS(3271),
    [anon_sym_fixed] = ACTIONS(3271),
    [anon_sym_internal] = ACTIONS(3271),
    [anon_sym_new] = ACTIONS(3271),
    [anon_sym_override] = ACTIONS(3271),
    [anon_sym_partial] = ACTIONS(3271),
    [anon_sym_private] = ACTIONS(3271),
    [anon_sym_protected] = ACTIONS(3271),
    [anon_sym_public] = ACTIONS(3271),
    [anon_sym_readonly] = ACTIONS(3271),
    [anon_sym_required] = ACTIONS(3271),
    [anon_sym_sealed] = ACTIONS(3271),
    [anon_sym_virtual] = ACTIONS(3271),
    [anon_sym_volatile] = ACTIONS(3271),
    [anon_sym_where] = ACTIONS(3271),
    [anon_sym_notnull] = ACTIONS(3271),
    [anon_sym_unmanaged] = ACTIONS(3271),
    [anon_sym_checked] = ACTIONS(3271),
    [anon_sym_BANG] = ACTIONS(3273),
    [anon_sym_TILDE] = ACTIONS(3273),
    [anon_sym_PLUS_PLUS] = ACTIONS(3273),
    [anon_sym_DASH_DASH] = ACTIONS(3273),
    [anon_sym_true] = ACTIONS(3271),
    [anon_sym_false] = ACTIONS(3271),
    [anon_sym_PLUS] = ACTIONS(3271),
    [anon_sym_DASH] = ACTIONS(3271),
    [anon_sym_STAR] = ACTIONS(3273),
    [anon_sym_CARET] = ACTIONS(3273),
    [anon_sym_AMP] = ACTIONS(3273),
    [anon_sym_this] = ACTIONS(3271),
    [anon_sym_scoped] = ACTIONS(3271),
    [anon_sym_var] = ACTIONS(3271),
    [sym_predefined_type] = ACTIONS(3271),
    [anon_sym_break] = ACTIONS(3271),
    [anon_sym_unchecked] = ACTIONS(3271),
    [anon_sym_continue] = ACTIONS(3271),
    [anon_sym_do] = ACTIONS(3271),
    [anon_sym_while] = ACTIONS(3271),
    [anon_sym_for] = ACTIONS(3271),
    [anon_sym_lock] = ACTIONS(3271),
    [anon_sym_yield] = ACTIONS(3271),
    [anon_sym_switch] = ACTIONS(3271),
    [anon_sym_case] = ACTIONS(3271),
    [anon_sym_default] = ACTIONS(3271),
    [anon_sym_throw] = ACTIONS(3271),
    [anon_sym_try] = ACTIONS(3271),
    [anon_sym_when] = ACTIONS(3271),
    [anon_sym_await] = ACTIONS(3271),
    [anon_sym_foreach] = ACTIONS(3271),
    [anon_sym_goto] = ACTIONS(3271),
    [anon_sym_if] = ACTIONS(3271),
    [anon_sym_else] = ACTIONS(3271),
    [anon_sym_DOT_DOT] = ACTIONS(3273),
    [anon_sym_from] = ACTIONS(3271),
    [anon_sym_into] = ACTIONS(3271),
    [anon_sym_join] = ACTIONS(3271),
    [anon_sym_on] = ACTIONS(3271),
    [anon_sym_equals] = ACTIONS(3271),
    [anon_sym_let] = ACTIONS(3271),
    [anon_sym_orderby] = ACTIONS(3271),
    [anon_sym_ascending] = ACTIONS(3271),
    [anon_sym_descending] = ACTIONS(3271),
    [anon_sym_group] = ACTIONS(3271),
    [anon_sym_by] = ACTIONS(3271),
    [anon_sym_select] = ACTIONS(3271),
    [anon_sym_DQUOTE] = ACTIONS(3271),
    [anon_sym_stackalloc] = ACTIONS(3271),
    [anon_sym_sizeof] = ACTIONS(3271),
    [anon_sym_typeof] = ACTIONS(3271),
    [anon_sym___makeref] = ACTIONS(3271),
    [anon_sym___reftype] = ACTIONS(3271),
    [anon_sym___refvalue] = ACTIONS(3271),
    [sym_null_literal] = ACTIONS(3271),
    [anon_sym_SQUOTE] = ACTIONS(3273),
    [sym_integer_literal] = ACTIONS(3271),
    [sym_real_literal] = ACTIONS(3273),
    [sym_verbatim_string_literal] = ACTIONS(3273),
    [sym_raw_string_literal] = ACTIONS(3273),
    [aux_sym_preproc_if_token1] = ACTIONS(3273),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3273),
    [sym_interpolation_verbatim_start] = ACTIONS(3273),
    [sym_interpolation_raw_start] = ACTIONS(3273),
  },
  [2691] = {
    [sym_preproc_region] = STATE(2691),
    [sym_preproc_endregion] = STATE(2691),
    [sym_preproc_line] = STATE(2691),
    [sym_preproc_pragma] = STATE(2691),
    [sym_preproc_nullable] = STATE(2691),
    [sym_preproc_error] = STATE(2691),
    [sym_preproc_define] = STATE(2691),
    [sym_preproc_undef] = STATE(2691),
    [sym__identifier_token] = ACTIONS(3387),
    [anon_sym_extern] = ACTIONS(3387),
    [anon_sym_alias] = ACTIONS(3387),
    [anon_sym_SEMI] = ACTIONS(3389),
    [anon_sym_global] = ACTIONS(3387),
    [anon_sym_using] = ACTIONS(3387),
    [anon_sym_unsafe] = ACTIONS(3387),
    [anon_sym_static] = ACTIONS(3387),
    [anon_sym_LBRACK] = ACTIONS(3389),
    [anon_sym_LPAREN] = ACTIONS(3389),
    [anon_sym_return] = ACTIONS(3387),
    [anon_sym_ref] = ACTIONS(3387),
    [anon_sym_LBRACE] = ACTIONS(3389),
    [anon_sym_RBRACE] = ACTIONS(3389),
    [anon_sym_delegate] = ACTIONS(3387),
    [anon_sym_abstract] = ACTIONS(3387),
    [anon_sym_async] = ACTIONS(3387),
    [anon_sym_const] = ACTIONS(3387),
    [anon_sym_file] = ACTIONS(3387),
    [anon_sym_fixed] = ACTIONS(3387),
    [anon_sym_internal] = ACTIONS(3387),
    [anon_sym_new] = ACTIONS(3387),
    [anon_sym_override] = ACTIONS(3387),
    [anon_sym_partial] = ACTIONS(3387),
    [anon_sym_private] = ACTIONS(3387),
    [anon_sym_protected] = ACTIONS(3387),
    [anon_sym_public] = ACTIONS(3387),
    [anon_sym_readonly] = ACTIONS(3387),
    [anon_sym_required] = ACTIONS(3387),
    [anon_sym_sealed] = ACTIONS(3387),
    [anon_sym_virtual] = ACTIONS(3387),
    [anon_sym_volatile] = ACTIONS(3387),
    [anon_sym_where] = ACTIONS(3387),
    [anon_sym_notnull] = ACTIONS(3387),
    [anon_sym_unmanaged] = ACTIONS(3387),
    [anon_sym_checked] = ACTIONS(3387),
    [anon_sym_BANG] = ACTIONS(3389),
    [anon_sym_TILDE] = ACTIONS(3389),
    [anon_sym_PLUS_PLUS] = ACTIONS(3389),
    [anon_sym_DASH_DASH] = ACTIONS(3389),
    [anon_sym_true] = ACTIONS(3387),
    [anon_sym_false] = ACTIONS(3387),
    [anon_sym_PLUS] = ACTIONS(3387),
    [anon_sym_DASH] = ACTIONS(3387),
    [anon_sym_STAR] = ACTIONS(3389),
    [anon_sym_CARET] = ACTIONS(3389),
    [anon_sym_AMP] = ACTIONS(3389),
    [anon_sym_this] = ACTIONS(3387),
    [anon_sym_scoped] = ACTIONS(3387),
    [anon_sym_var] = ACTIONS(3387),
    [sym_predefined_type] = ACTIONS(3387),
    [anon_sym_break] = ACTIONS(3387),
    [anon_sym_unchecked] = ACTIONS(3387),
    [anon_sym_continue] = ACTIONS(3387),
    [anon_sym_do] = ACTIONS(3387),
    [anon_sym_while] = ACTIONS(3387),
    [anon_sym_for] = ACTIONS(3387),
    [anon_sym_lock] = ACTIONS(3387),
    [anon_sym_yield] = ACTIONS(3387),
    [anon_sym_switch] = ACTIONS(3387),
    [anon_sym_case] = ACTIONS(3387),
    [anon_sym_default] = ACTIONS(3387),
    [anon_sym_throw] = ACTIONS(3387),
    [anon_sym_try] = ACTIONS(3387),
    [anon_sym_when] = ACTIONS(3387),
    [anon_sym_await] = ACTIONS(3387),
    [anon_sym_foreach] = ACTIONS(3387),
    [anon_sym_goto] = ACTIONS(3387),
    [anon_sym_if] = ACTIONS(3387),
    [anon_sym_else] = ACTIONS(3387),
    [anon_sym_DOT_DOT] = ACTIONS(3389),
    [anon_sym_from] = ACTIONS(3387),
    [anon_sym_into] = ACTIONS(3387),
    [anon_sym_join] = ACTIONS(3387),
    [anon_sym_on] = ACTIONS(3387),
    [anon_sym_equals] = ACTIONS(3387),
    [anon_sym_let] = ACTIONS(3387),
    [anon_sym_orderby] = ACTIONS(3387),
    [anon_sym_ascending] = ACTIONS(3387),
    [anon_sym_descending] = ACTIONS(3387),
    [anon_sym_group] = ACTIONS(3387),
    [anon_sym_by] = ACTIONS(3387),
    [anon_sym_select] = ACTIONS(3387),
    [anon_sym_DQUOTE] = ACTIONS(3387),
    [anon_sym_stackalloc] = ACTIONS(3387),
    [anon_sym_sizeof] = ACTIONS(3387),
    [anon_sym_typeof] = ACTIONS(3387),
    [anon_sym___makeref] = ACTIONS(3387),
    [anon_sym___reftype] = ACTIONS(3387),
    [anon_sym___refvalue] = ACTIONS(3387),
    [sym_null_literal] = ACTIONS(3387),
    [anon_sym_SQUOTE] = ACTIONS(3389),
    [sym_integer_literal] = ACTIONS(3387),
    [sym_real_literal] = ACTIONS(3389),
    [sym_verbatim_string_literal] = ACTIONS(3389),
    [sym_raw_string_literal] = ACTIONS(3389),
    [aux_sym_preproc_if_token1] = ACTIONS(3389),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3389),
    [sym_interpolation_verbatim_start] = ACTIONS(3389),
    [sym_interpolation_raw_start] = ACTIONS(3389),
  },
  [2692] = {
    [sym_preproc_region] = STATE(2692),
    [sym_preproc_endregion] = STATE(2692),
    [sym_preproc_line] = STATE(2692),
    [sym_preproc_pragma] = STATE(2692),
    [sym_preproc_nullable] = STATE(2692),
    [sym_preproc_error] = STATE(2692),
    [sym_preproc_define] = STATE(2692),
    [sym_preproc_undef] = STATE(2692),
    [sym__identifier_token] = ACTIONS(3347),
    [anon_sym_extern] = ACTIONS(3347),
    [anon_sym_alias] = ACTIONS(3347),
    [anon_sym_SEMI] = ACTIONS(3349),
    [anon_sym_global] = ACTIONS(3347),
    [anon_sym_using] = ACTIONS(3347),
    [anon_sym_unsafe] = ACTIONS(3347),
    [anon_sym_static] = ACTIONS(3347),
    [anon_sym_LBRACK] = ACTIONS(3349),
    [anon_sym_LPAREN] = ACTIONS(3349),
    [anon_sym_return] = ACTIONS(3347),
    [anon_sym_ref] = ACTIONS(3347),
    [anon_sym_LBRACE] = ACTIONS(3349),
    [anon_sym_RBRACE] = ACTIONS(3349),
    [anon_sym_delegate] = ACTIONS(3347),
    [anon_sym_abstract] = ACTIONS(3347),
    [anon_sym_async] = ACTIONS(3347),
    [anon_sym_const] = ACTIONS(3347),
    [anon_sym_file] = ACTIONS(3347),
    [anon_sym_fixed] = ACTIONS(3347),
    [anon_sym_internal] = ACTIONS(3347),
    [anon_sym_new] = ACTIONS(3347),
    [anon_sym_override] = ACTIONS(3347),
    [anon_sym_partial] = ACTIONS(3347),
    [anon_sym_private] = ACTIONS(3347),
    [anon_sym_protected] = ACTIONS(3347),
    [anon_sym_public] = ACTIONS(3347),
    [anon_sym_readonly] = ACTIONS(3347),
    [anon_sym_required] = ACTIONS(3347),
    [anon_sym_sealed] = ACTIONS(3347),
    [anon_sym_virtual] = ACTIONS(3347),
    [anon_sym_volatile] = ACTIONS(3347),
    [anon_sym_where] = ACTIONS(3347),
    [anon_sym_notnull] = ACTIONS(3347),
    [anon_sym_unmanaged] = ACTIONS(3347),
    [anon_sym_checked] = ACTIONS(3347),
    [anon_sym_BANG] = ACTIONS(3349),
    [anon_sym_TILDE] = ACTIONS(3349),
    [anon_sym_PLUS_PLUS] = ACTIONS(3349),
    [anon_sym_DASH_DASH] = ACTIONS(3349),
    [anon_sym_true] = ACTIONS(3347),
    [anon_sym_false] = ACTIONS(3347),
    [anon_sym_PLUS] = ACTIONS(3347),
    [anon_sym_DASH] = ACTIONS(3347),
    [anon_sym_STAR] = ACTIONS(3349),
    [anon_sym_CARET] = ACTIONS(3349),
    [anon_sym_AMP] = ACTIONS(3349),
    [anon_sym_this] = ACTIONS(3347),
    [anon_sym_scoped] = ACTIONS(3347),
    [anon_sym_var] = ACTIONS(3347),
    [sym_predefined_type] = ACTIONS(3347),
    [anon_sym_break] = ACTIONS(3347),
    [anon_sym_unchecked] = ACTIONS(3347),
    [anon_sym_continue] = ACTIONS(3347),
    [anon_sym_do] = ACTIONS(3347),
    [anon_sym_while] = ACTIONS(3347),
    [anon_sym_for] = ACTIONS(3347),
    [anon_sym_lock] = ACTIONS(3347),
    [anon_sym_yield] = ACTIONS(3347),
    [anon_sym_switch] = ACTIONS(3347),
    [anon_sym_case] = ACTIONS(3347),
    [anon_sym_default] = ACTIONS(3347),
    [anon_sym_throw] = ACTIONS(3347),
    [anon_sym_try] = ACTIONS(3347),
    [anon_sym_when] = ACTIONS(3347),
    [anon_sym_await] = ACTIONS(3347),
    [anon_sym_foreach] = ACTIONS(3347),
    [anon_sym_goto] = ACTIONS(3347),
    [anon_sym_if] = ACTIONS(3347),
    [anon_sym_else] = ACTIONS(3347),
    [anon_sym_DOT_DOT] = ACTIONS(3349),
    [anon_sym_from] = ACTIONS(3347),
    [anon_sym_into] = ACTIONS(3347),
    [anon_sym_join] = ACTIONS(3347),
    [anon_sym_on] = ACTIONS(3347),
    [anon_sym_equals] = ACTIONS(3347),
    [anon_sym_let] = ACTIONS(3347),
    [anon_sym_orderby] = ACTIONS(3347),
    [anon_sym_ascending] = ACTIONS(3347),
    [anon_sym_descending] = ACTIONS(3347),
    [anon_sym_group] = ACTIONS(3347),
    [anon_sym_by] = ACTIONS(3347),
    [anon_sym_select] = ACTIONS(3347),
    [anon_sym_DQUOTE] = ACTIONS(3347),
    [anon_sym_stackalloc] = ACTIONS(3347),
    [anon_sym_sizeof] = ACTIONS(3347),
    [anon_sym_typeof] = ACTIONS(3347),
    [anon_sym___makeref] = ACTIONS(3347),
    [anon_sym___reftype] = ACTIONS(3347),
    [anon_sym___refvalue] = ACTIONS(3347),
    [sym_null_literal] = ACTIONS(3347),
    [anon_sym_SQUOTE] = ACTIONS(3349),
    [sym_integer_literal] = ACTIONS(3347),
    [sym_real_literal] = ACTIONS(3349),
    [sym_verbatim_string_literal] = ACTIONS(3349),
    [sym_raw_string_literal] = ACTIONS(3349),
    [aux_sym_preproc_if_token1] = ACTIONS(3349),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3349),
    [sym_interpolation_verbatim_start] = ACTIONS(3349),
    [sym_interpolation_raw_start] = ACTIONS(3349),
  },
  [2693] = {
    [sym_preproc_region] = STATE(2693),
    [sym_preproc_endregion] = STATE(2693),
    [sym_preproc_line] = STATE(2693),
    [sym_preproc_pragma] = STATE(2693),
    [sym_preproc_nullable] = STATE(2693),
    [sym_preproc_error] = STATE(2693),
    [sym_preproc_define] = STATE(2693),
    [sym_preproc_undef] = STATE(2693),
    [sym__identifier_token] = ACTIONS(3275),
    [anon_sym_extern] = ACTIONS(3275),
    [anon_sym_alias] = ACTIONS(3275),
    [anon_sym_SEMI] = ACTIONS(3277),
    [anon_sym_global] = ACTIONS(3275),
    [anon_sym_using] = ACTIONS(3275),
    [anon_sym_unsafe] = ACTIONS(3275),
    [anon_sym_static] = ACTIONS(3275),
    [anon_sym_LBRACK] = ACTIONS(3277),
    [anon_sym_LPAREN] = ACTIONS(3277),
    [anon_sym_return] = ACTIONS(3275),
    [anon_sym_ref] = ACTIONS(3275),
    [anon_sym_LBRACE] = ACTIONS(3277),
    [anon_sym_RBRACE] = ACTIONS(3277),
    [anon_sym_delegate] = ACTIONS(3275),
    [anon_sym_abstract] = ACTIONS(3275),
    [anon_sym_async] = ACTIONS(3275),
    [anon_sym_const] = ACTIONS(3275),
    [anon_sym_file] = ACTIONS(3275),
    [anon_sym_fixed] = ACTIONS(3275),
    [anon_sym_internal] = ACTIONS(3275),
    [anon_sym_new] = ACTIONS(3275),
    [anon_sym_override] = ACTIONS(3275),
    [anon_sym_partial] = ACTIONS(3275),
    [anon_sym_private] = ACTIONS(3275),
    [anon_sym_protected] = ACTIONS(3275),
    [anon_sym_public] = ACTIONS(3275),
    [anon_sym_readonly] = ACTIONS(3275),
    [anon_sym_required] = ACTIONS(3275),
    [anon_sym_sealed] = ACTIONS(3275),
    [anon_sym_virtual] = ACTIONS(3275),
    [anon_sym_volatile] = ACTIONS(3275),
    [anon_sym_where] = ACTIONS(3275),
    [anon_sym_notnull] = ACTIONS(3275),
    [anon_sym_unmanaged] = ACTIONS(3275),
    [anon_sym_checked] = ACTIONS(3275),
    [anon_sym_BANG] = ACTIONS(3277),
    [anon_sym_TILDE] = ACTIONS(3277),
    [anon_sym_PLUS_PLUS] = ACTIONS(3277),
    [anon_sym_DASH_DASH] = ACTIONS(3277),
    [anon_sym_true] = ACTIONS(3275),
    [anon_sym_false] = ACTIONS(3275),
    [anon_sym_PLUS] = ACTIONS(3275),
    [anon_sym_DASH] = ACTIONS(3275),
    [anon_sym_STAR] = ACTIONS(3277),
    [anon_sym_CARET] = ACTIONS(3277),
    [anon_sym_AMP] = ACTIONS(3277),
    [anon_sym_this] = ACTIONS(3275),
    [anon_sym_scoped] = ACTIONS(3275),
    [anon_sym_var] = ACTIONS(3275),
    [sym_predefined_type] = ACTIONS(3275),
    [anon_sym_break] = ACTIONS(3275),
    [anon_sym_unchecked] = ACTIONS(3275),
    [anon_sym_continue] = ACTIONS(3275),
    [anon_sym_do] = ACTIONS(3275),
    [anon_sym_while] = ACTIONS(3275),
    [anon_sym_for] = ACTIONS(3275),
    [anon_sym_lock] = ACTIONS(3275),
    [anon_sym_yield] = ACTIONS(3275),
    [anon_sym_switch] = ACTIONS(3275),
    [anon_sym_case] = ACTIONS(3275),
    [anon_sym_default] = ACTIONS(3275),
    [anon_sym_throw] = ACTIONS(3275),
    [anon_sym_try] = ACTIONS(3275),
    [anon_sym_when] = ACTIONS(3275),
    [anon_sym_await] = ACTIONS(3275),
    [anon_sym_foreach] = ACTIONS(3275),
    [anon_sym_goto] = ACTIONS(3275),
    [anon_sym_if] = ACTIONS(3275),
    [anon_sym_else] = ACTIONS(3275),
    [anon_sym_DOT_DOT] = ACTIONS(3277),
    [anon_sym_from] = ACTIONS(3275),
    [anon_sym_into] = ACTIONS(3275),
    [anon_sym_join] = ACTIONS(3275),
    [anon_sym_on] = ACTIONS(3275),
    [anon_sym_equals] = ACTIONS(3275),
    [anon_sym_let] = ACTIONS(3275),
    [anon_sym_orderby] = ACTIONS(3275),
    [anon_sym_ascending] = ACTIONS(3275),
    [anon_sym_descending] = ACTIONS(3275),
    [anon_sym_group] = ACTIONS(3275),
    [anon_sym_by] = ACTIONS(3275),
    [anon_sym_select] = ACTIONS(3275),
    [anon_sym_DQUOTE] = ACTIONS(3275),
    [anon_sym_stackalloc] = ACTIONS(3275),
    [anon_sym_sizeof] = ACTIONS(3275),
    [anon_sym_typeof] = ACTIONS(3275),
    [anon_sym___makeref] = ACTIONS(3275),
    [anon_sym___reftype] = ACTIONS(3275),
    [anon_sym___refvalue] = ACTIONS(3275),
    [sym_null_literal] = ACTIONS(3275),
    [anon_sym_SQUOTE] = ACTIONS(3277),
    [sym_integer_literal] = ACTIONS(3275),
    [sym_real_literal] = ACTIONS(3277),
    [sym_verbatim_string_literal] = ACTIONS(3277),
    [sym_raw_string_literal] = ACTIONS(3277),
    [aux_sym_preproc_if_token1] = ACTIONS(3277),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3277),
    [sym_interpolation_verbatim_start] = ACTIONS(3277),
    [sym_interpolation_raw_start] = ACTIONS(3277),
  },
  [2694] = {
    [sym_preproc_region] = STATE(2694),
    [sym_preproc_endregion] = STATE(2694),
    [sym_preproc_line] = STATE(2694),
    [sym_preproc_pragma] = STATE(2694),
    [sym_preproc_nullable] = STATE(2694),
    [sym_preproc_error] = STATE(2694),
    [sym_preproc_define] = STATE(2694),
    [sym_preproc_undef] = STATE(2694),
    [sym__identifier_token] = ACTIONS(3351),
    [anon_sym_extern] = ACTIONS(3351),
    [anon_sym_alias] = ACTIONS(3351),
    [anon_sym_SEMI] = ACTIONS(3353),
    [anon_sym_global] = ACTIONS(3351),
    [anon_sym_using] = ACTIONS(3351),
    [anon_sym_unsafe] = ACTIONS(3351),
    [anon_sym_static] = ACTIONS(3351),
    [anon_sym_LBRACK] = ACTIONS(3353),
    [anon_sym_LPAREN] = ACTIONS(3353),
    [anon_sym_return] = ACTIONS(3351),
    [anon_sym_ref] = ACTIONS(3351),
    [anon_sym_LBRACE] = ACTIONS(3353),
    [anon_sym_RBRACE] = ACTIONS(3353),
    [anon_sym_delegate] = ACTIONS(3351),
    [anon_sym_abstract] = ACTIONS(3351),
    [anon_sym_async] = ACTIONS(3351),
    [anon_sym_const] = ACTIONS(3351),
    [anon_sym_file] = ACTIONS(3351),
    [anon_sym_fixed] = ACTIONS(3351),
    [anon_sym_internal] = ACTIONS(3351),
    [anon_sym_new] = ACTIONS(3351),
    [anon_sym_override] = ACTIONS(3351),
    [anon_sym_partial] = ACTIONS(3351),
    [anon_sym_private] = ACTIONS(3351),
    [anon_sym_protected] = ACTIONS(3351),
    [anon_sym_public] = ACTIONS(3351),
    [anon_sym_readonly] = ACTIONS(3351),
    [anon_sym_required] = ACTIONS(3351),
    [anon_sym_sealed] = ACTIONS(3351),
    [anon_sym_virtual] = ACTIONS(3351),
    [anon_sym_volatile] = ACTIONS(3351),
    [anon_sym_where] = ACTIONS(3351),
    [anon_sym_notnull] = ACTIONS(3351),
    [anon_sym_unmanaged] = ACTIONS(3351),
    [anon_sym_checked] = ACTIONS(3351),
    [anon_sym_BANG] = ACTIONS(3353),
    [anon_sym_TILDE] = ACTIONS(3353),
    [anon_sym_PLUS_PLUS] = ACTIONS(3353),
    [anon_sym_DASH_DASH] = ACTIONS(3353),
    [anon_sym_true] = ACTIONS(3351),
    [anon_sym_false] = ACTIONS(3351),
    [anon_sym_PLUS] = ACTIONS(3351),
    [anon_sym_DASH] = ACTIONS(3351),
    [anon_sym_STAR] = ACTIONS(3353),
    [anon_sym_CARET] = ACTIONS(3353),
    [anon_sym_AMP] = ACTIONS(3353),
    [anon_sym_this] = ACTIONS(3351),
    [anon_sym_scoped] = ACTIONS(3351),
    [anon_sym_var] = ACTIONS(3351),
    [sym_predefined_type] = ACTIONS(3351),
    [anon_sym_break] = ACTIONS(3351),
    [anon_sym_unchecked] = ACTIONS(3351),
    [anon_sym_continue] = ACTIONS(3351),
    [anon_sym_do] = ACTIONS(3351),
    [anon_sym_while] = ACTIONS(3351),
    [anon_sym_for] = ACTIONS(3351),
    [anon_sym_lock] = ACTIONS(3351),
    [anon_sym_yield] = ACTIONS(3351),
    [anon_sym_switch] = ACTIONS(3351),
    [anon_sym_case] = ACTIONS(3351),
    [anon_sym_default] = ACTIONS(3351),
    [anon_sym_throw] = ACTIONS(3351),
    [anon_sym_try] = ACTIONS(3351),
    [anon_sym_when] = ACTIONS(3351),
    [anon_sym_await] = ACTIONS(3351),
    [anon_sym_foreach] = ACTIONS(3351),
    [anon_sym_goto] = ACTIONS(3351),
    [anon_sym_if] = ACTIONS(3351),
    [anon_sym_else] = ACTIONS(3351),
    [anon_sym_DOT_DOT] = ACTIONS(3353),
    [anon_sym_from] = ACTIONS(3351),
    [anon_sym_into] = ACTIONS(3351),
    [anon_sym_join] = ACTIONS(3351),
    [anon_sym_on] = ACTIONS(3351),
    [anon_sym_equals] = ACTIONS(3351),
    [anon_sym_let] = ACTIONS(3351),
    [anon_sym_orderby] = ACTIONS(3351),
    [anon_sym_ascending] = ACTIONS(3351),
    [anon_sym_descending] = ACTIONS(3351),
    [anon_sym_group] = ACTIONS(3351),
    [anon_sym_by] = ACTIONS(3351),
    [anon_sym_select] = ACTIONS(3351),
    [anon_sym_DQUOTE] = ACTIONS(3351),
    [anon_sym_stackalloc] = ACTIONS(3351),
    [anon_sym_sizeof] = ACTIONS(3351),
    [anon_sym_typeof] = ACTIONS(3351),
    [anon_sym___makeref] = ACTIONS(3351),
    [anon_sym___reftype] = ACTIONS(3351),
    [anon_sym___refvalue] = ACTIONS(3351),
    [sym_null_literal] = ACTIONS(3351),
    [anon_sym_SQUOTE] = ACTIONS(3353),
    [sym_integer_literal] = ACTIONS(3351),
    [sym_real_literal] = ACTIONS(3353),
    [sym_verbatim_string_literal] = ACTIONS(3353),
    [sym_raw_string_literal] = ACTIONS(3353),
    [aux_sym_preproc_if_token1] = ACTIONS(3353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3353),
    [sym_interpolation_verbatim_start] = ACTIONS(3353),
    [sym_interpolation_raw_start] = ACTIONS(3353),
  },
  [2695] = {
    [sym_preproc_region] = STATE(2695),
    [sym_preproc_endregion] = STATE(2695),
    [sym_preproc_line] = STATE(2695),
    [sym_preproc_pragma] = STATE(2695),
    [sym_preproc_nullable] = STATE(2695),
    [sym_preproc_error] = STATE(2695),
    [sym_preproc_define] = STATE(2695),
    [sym_preproc_undef] = STATE(2695),
    [sym__identifier_token] = ACTIONS(2937),
    [anon_sym_extern] = ACTIONS(2937),
    [anon_sym_alias] = ACTIONS(2937),
    [anon_sym_SEMI] = ACTIONS(2939),
    [anon_sym_global] = ACTIONS(2937),
    [anon_sym_using] = ACTIONS(2937),
    [anon_sym_unsafe] = ACTIONS(2937),
    [anon_sym_static] = ACTIONS(2937),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_LPAREN] = ACTIONS(2939),
    [anon_sym_return] = ACTIONS(2937),
    [anon_sym_ref] = ACTIONS(2937),
    [anon_sym_LBRACE] = ACTIONS(2939),
    [anon_sym_RBRACE] = ACTIONS(2939),
    [anon_sym_delegate] = ACTIONS(2937),
    [anon_sym_abstract] = ACTIONS(2937),
    [anon_sym_async] = ACTIONS(2937),
    [anon_sym_const] = ACTIONS(2937),
    [anon_sym_file] = ACTIONS(2937),
    [anon_sym_fixed] = ACTIONS(2937),
    [anon_sym_internal] = ACTIONS(2937),
    [anon_sym_new] = ACTIONS(2937),
    [anon_sym_override] = ACTIONS(2937),
    [anon_sym_partial] = ACTIONS(2937),
    [anon_sym_private] = ACTIONS(2937),
    [anon_sym_protected] = ACTIONS(2937),
    [anon_sym_public] = ACTIONS(2937),
    [anon_sym_readonly] = ACTIONS(2937),
    [anon_sym_required] = ACTIONS(2937),
    [anon_sym_sealed] = ACTIONS(2937),
    [anon_sym_virtual] = ACTIONS(2937),
    [anon_sym_volatile] = ACTIONS(2937),
    [anon_sym_where] = ACTIONS(2937),
    [anon_sym_notnull] = ACTIONS(2937),
    [anon_sym_unmanaged] = ACTIONS(2937),
    [anon_sym_checked] = ACTIONS(2937),
    [anon_sym_BANG] = ACTIONS(2939),
    [anon_sym_TILDE] = ACTIONS(2939),
    [anon_sym_PLUS_PLUS] = ACTIONS(2939),
    [anon_sym_DASH_DASH] = ACTIONS(2939),
    [anon_sym_true] = ACTIONS(2937),
    [anon_sym_false] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(2937),
    [anon_sym_DASH] = ACTIONS(2937),
    [anon_sym_STAR] = ACTIONS(2939),
    [anon_sym_CARET] = ACTIONS(2939),
    [anon_sym_AMP] = ACTIONS(2939),
    [anon_sym_this] = ACTIONS(2937),
    [anon_sym_scoped] = ACTIONS(2937),
    [anon_sym_var] = ACTIONS(2937),
    [sym_predefined_type] = ACTIONS(2937),
    [anon_sym_break] = ACTIONS(2937),
    [anon_sym_unchecked] = ACTIONS(2937),
    [anon_sym_continue] = ACTIONS(2937),
    [anon_sym_do] = ACTIONS(2937),
    [anon_sym_while] = ACTIONS(2937),
    [anon_sym_for] = ACTIONS(2937),
    [anon_sym_lock] = ACTIONS(2937),
    [anon_sym_yield] = ACTIONS(2937),
    [anon_sym_switch] = ACTIONS(2937),
    [anon_sym_case] = ACTIONS(2937),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_throw] = ACTIONS(2937),
    [anon_sym_try] = ACTIONS(2937),
    [anon_sym_when] = ACTIONS(2937),
    [anon_sym_await] = ACTIONS(2937),
    [anon_sym_foreach] = ACTIONS(2937),
    [anon_sym_goto] = ACTIONS(2937),
    [anon_sym_if] = ACTIONS(2937),
    [anon_sym_else] = ACTIONS(2937),
    [anon_sym_DOT_DOT] = ACTIONS(2939),
    [anon_sym_from] = ACTIONS(2937),
    [anon_sym_into] = ACTIONS(2937),
    [anon_sym_join] = ACTIONS(2937),
    [anon_sym_on] = ACTIONS(2937),
    [anon_sym_equals] = ACTIONS(2937),
    [anon_sym_let] = ACTIONS(2937),
    [anon_sym_orderby] = ACTIONS(2937),
    [anon_sym_ascending] = ACTIONS(2937),
    [anon_sym_descending] = ACTIONS(2937),
    [anon_sym_group] = ACTIONS(2937),
    [anon_sym_by] = ACTIONS(2937),
    [anon_sym_select] = ACTIONS(2937),
    [anon_sym_DQUOTE] = ACTIONS(2937),
    [anon_sym_stackalloc] = ACTIONS(2937),
    [anon_sym_sizeof] = ACTIONS(2937),
    [anon_sym_typeof] = ACTIONS(2937),
    [anon_sym___makeref] = ACTIONS(2937),
    [anon_sym___reftype] = ACTIONS(2937),
    [anon_sym___refvalue] = ACTIONS(2937),
    [sym_null_literal] = ACTIONS(2937),
    [anon_sym_SQUOTE] = ACTIONS(2939),
    [sym_integer_literal] = ACTIONS(2937),
    [sym_real_literal] = ACTIONS(2939),
    [sym_verbatim_string_literal] = ACTIONS(2939),
    [sym_raw_string_literal] = ACTIONS(2939),
    [aux_sym_preproc_if_token1] = ACTIONS(2939),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(2939),
    [sym_interpolation_verbatim_start] = ACTIONS(2939),
    [sym_interpolation_raw_start] = ACTIONS(2939),
  },
  [2696] = {
    [sym_preproc_region] = STATE(2696),
    [sym_preproc_endregion] = STATE(2696),
    [sym_preproc_line] = STATE(2696),
    [sym_preproc_pragma] = STATE(2696),
    [sym_preproc_nullable] = STATE(2696),
    [sym_preproc_error] = STATE(2696),
    [sym_preproc_define] = STATE(2696),
    [sym_preproc_undef] = STATE(2696),
    [sym__identifier_token] = ACTIONS(3409),
    [anon_sym_extern] = ACTIONS(3409),
    [anon_sym_alias] = ACTIONS(3409),
    [anon_sym_SEMI] = ACTIONS(3411),
    [anon_sym_global] = ACTIONS(3409),
    [anon_sym_using] = ACTIONS(3409),
    [anon_sym_unsafe] = ACTIONS(3409),
    [anon_sym_static] = ACTIONS(3409),
    [anon_sym_LBRACK] = ACTIONS(3411),
    [anon_sym_LPAREN] = ACTIONS(3411),
    [anon_sym_return] = ACTIONS(3409),
    [anon_sym_ref] = ACTIONS(3409),
    [anon_sym_LBRACE] = ACTIONS(3411),
    [anon_sym_RBRACE] = ACTIONS(3411),
    [anon_sym_delegate] = ACTIONS(3409),
    [anon_sym_abstract] = ACTIONS(3409),
    [anon_sym_async] = ACTIONS(3409),
    [anon_sym_const] = ACTIONS(3409),
    [anon_sym_file] = ACTIONS(3409),
    [anon_sym_fixed] = ACTIONS(3409),
    [anon_sym_internal] = ACTIONS(3409),
    [anon_sym_new] = ACTIONS(3409),
    [anon_sym_override] = ACTIONS(3409),
    [anon_sym_partial] = ACTIONS(3409),
    [anon_sym_private] = ACTIONS(3409),
    [anon_sym_protected] = ACTIONS(3409),
    [anon_sym_public] = ACTIONS(3409),
    [anon_sym_readonly] = ACTIONS(3409),
    [anon_sym_required] = ACTIONS(3409),
    [anon_sym_sealed] = ACTIONS(3409),
    [anon_sym_virtual] = ACTIONS(3409),
    [anon_sym_volatile] = ACTIONS(3409),
    [anon_sym_where] = ACTIONS(3409),
    [anon_sym_notnull] = ACTIONS(3409),
    [anon_sym_unmanaged] = ACTIONS(3409),
    [anon_sym_checked] = ACTIONS(3409),
    [anon_sym_BANG] = ACTIONS(3411),
    [anon_sym_TILDE] = ACTIONS(3411),
    [anon_sym_PLUS_PLUS] = ACTIONS(3411),
    [anon_sym_DASH_DASH] = ACTIONS(3411),
    [anon_sym_true] = ACTIONS(3409),
    [anon_sym_false] = ACTIONS(3409),
    [anon_sym_PLUS] = ACTIONS(3409),
    [anon_sym_DASH] = ACTIONS(3409),
    [anon_sym_STAR] = ACTIONS(3411),
    [anon_sym_CARET] = ACTIONS(3411),
    [anon_sym_AMP] = ACTIONS(3411),
    [anon_sym_this] = ACTIONS(3409),
    [anon_sym_scoped] = ACTIONS(3409),
    [anon_sym_var] = ACTIONS(3409),
    [sym_predefined_type] = ACTIONS(3409),
    [anon_sym_break] = ACTIONS(3409),
    [anon_sym_unchecked] = ACTIONS(3409),
    [anon_sym_continue] = ACTIONS(3409),
    [anon_sym_do] = ACTIONS(3409),
    [anon_sym_while] = ACTIONS(3409),
    [anon_sym_for] = ACTIONS(3409),
    [anon_sym_lock] = ACTIONS(3409),
    [anon_sym_yield] = ACTIONS(3409),
    [anon_sym_switch] = ACTIONS(3409),
    [anon_sym_case] = ACTIONS(3409),
    [anon_sym_default] = ACTIONS(3409),
    [anon_sym_throw] = ACTIONS(3409),
    [anon_sym_try] = ACTIONS(3409),
    [anon_sym_when] = ACTIONS(3409),
    [anon_sym_await] = ACTIONS(3409),
    [anon_sym_foreach] = ACTIONS(3409),
    [anon_sym_goto] = ACTIONS(3409),
    [anon_sym_if] = ACTIONS(3409),
    [anon_sym_else] = ACTIONS(3409),
    [anon_sym_DOT_DOT] = ACTIONS(3411),
    [anon_sym_from] = ACTIONS(3409),
    [anon_sym_into] = ACTIONS(3409),
    [anon_sym_join] = ACTIONS(3409),
    [anon_sym_on] = ACTIONS(3409),
    [anon_sym_equals] = ACTIONS(3409),
    [anon_sym_let] = ACTIONS(3409),
    [anon_sym_orderby] = ACTIONS(3409),
    [anon_sym_ascending] = ACTIONS(3409),
    [anon_sym_descending] = ACTIONS(3409),
    [anon_sym_group] = ACTIONS(3409),
    [anon_sym_by] = ACTIONS(3409),
    [anon_sym_select] = ACTIONS(3409),
    [anon_sym_DQUOTE] = ACTIONS(3409),
    [anon_sym_stackalloc] = ACTIONS(3409),
    [anon_sym_sizeof] = ACTIONS(3409),
    [anon_sym_typeof] = ACTIONS(3409),
    [anon_sym___makeref] = ACTIONS(3409),
    [anon_sym___reftype] = ACTIONS(3409),
    [anon_sym___refvalue] = ACTIONS(3409),
    [sym_null_literal] = ACTIONS(3409),
    [anon_sym_SQUOTE] = ACTIONS(3411),
    [sym_integer_literal] = ACTIONS(3409),
    [sym_real_literal] = ACTIONS(3411),
    [sym_verbatim_string_literal] = ACTIONS(3411),
    [sym_raw_string_literal] = ACTIONS(3411),
    [aux_sym_preproc_if_token1] = ACTIONS(3411),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3411),
    [sym_interpolation_verbatim_start] = ACTIONS(3411),
    [sym_interpolation_raw_start] = ACTIONS(3411),
  },
  [2697] = {
    [sym_preproc_region] = STATE(2697),
    [sym_preproc_endregion] = STATE(2697),
    [sym_preproc_line] = STATE(2697),
    [sym_preproc_pragma] = STATE(2697),
    [sym_preproc_nullable] = STATE(2697),
    [sym_preproc_error] = STATE(2697),
    [sym_preproc_define] = STATE(2697),
    [sym_preproc_undef] = STATE(2697),
    [sym__identifier_token] = ACTIONS(3061),
    [anon_sym_extern] = ACTIONS(3061),
    [anon_sym_alias] = ACTIONS(3061),
    [anon_sym_SEMI] = ACTIONS(3063),
    [anon_sym_global] = ACTIONS(3061),
    [anon_sym_using] = ACTIONS(3061),
    [anon_sym_unsafe] = ACTIONS(3061),
    [anon_sym_static] = ACTIONS(3061),
    [anon_sym_LBRACK] = ACTIONS(3063),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_return] = ACTIONS(3061),
    [anon_sym_ref] = ACTIONS(3061),
    [anon_sym_LBRACE] = ACTIONS(3063),
    [anon_sym_RBRACE] = ACTIONS(3063),
    [anon_sym_delegate] = ACTIONS(3061),
    [anon_sym_abstract] = ACTIONS(3061),
    [anon_sym_async] = ACTIONS(3061),
    [anon_sym_const] = ACTIONS(3061),
    [anon_sym_file] = ACTIONS(3061),
    [anon_sym_fixed] = ACTIONS(3061),
    [anon_sym_internal] = ACTIONS(3061),
    [anon_sym_new] = ACTIONS(3061),
    [anon_sym_override] = ACTIONS(3061),
    [anon_sym_partial] = ACTIONS(3061),
    [anon_sym_private] = ACTIONS(3061),
    [anon_sym_protected] = ACTIONS(3061),
    [anon_sym_public] = ACTIONS(3061),
    [anon_sym_readonly] = ACTIONS(3061),
    [anon_sym_required] = ACTIONS(3061),
    [anon_sym_sealed] = ACTIONS(3061),
    [anon_sym_virtual] = ACTIONS(3061),
    [anon_sym_volatile] = ACTIONS(3061),
    [anon_sym_where] = ACTIONS(3061),
    [anon_sym_notnull] = ACTIONS(3061),
    [anon_sym_unmanaged] = ACTIONS(3061),
    [anon_sym_checked] = ACTIONS(3061),
    [anon_sym_BANG] = ACTIONS(3063),
    [anon_sym_TILDE] = ACTIONS(3063),
    [anon_sym_PLUS_PLUS] = ACTIONS(3063),
    [anon_sym_DASH_DASH] = ACTIONS(3063),
    [anon_sym_true] = ACTIONS(3061),
    [anon_sym_false] = ACTIONS(3061),
    [anon_sym_PLUS] = ACTIONS(3061),
    [anon_sym_DASH] = ACTIONS(3061),
    [anon_sym_STAR] = ACTIONS(3063),
    [anon_sym_CARET] = ACTIONS(3063),
    [anon_sym_AMP] = ACTIONS(3063),
    [anon_sym_this] = ACTIONS(3061),
    [anon_sym_scoped] = ACTIONS(3061),
    [anon_sym_var] = ACTIONS(3061),
    [sym_predefined_type] = ACTIONS(3061),
    [anon_sym_break] = ACTIONS(3061),
    [anon_sym_unchecked] = ACTIONS(3061),
    [anon_sym_continue] = ACTIONS(3061),
    [anon_sym_do] = ACTIONS(3061),
    [anon_sym_while] = ACTIONS(3061),
    [anon_sym_for] = ACTIONS(3061),
    [anon_sym_lock] = ACTIONS(3061),
    [anon_sym_yield] = ACTIONS(3061),
    [anon_sym_switch] = ACTIONS(3061),
    [anon_sym_case] = ACTIONS(3061),
    [anon_sym_default] = ACTIONS(3061),
    [anon_sym_throw] = ACTIONS(3061),
    [anon_sym_try] = ACTIONS(3061),
    [anon_sym_when] = ACTIONS(3061),
    [anon_sym_await] = ACTIONS(3061),
    [anon_sym_foreach] = ACTIONS(3061),
    [anon_sym_goto] = ACTIONS(3061),
    [anon_sym_if] = ACTIONS(3061),
    [anon_sym_else] = ACTIONS(3061),
    [anon_sym_DOT_DOT] = ACTIONS(3063),
    [anon_sym_from] = ACTIONS(3061),
    [anon_sym_into] = ACTIONS(3061),
    [anon_sym_join] = ACTIONS(3061),
    [anon_sym_on] = ACTIONS(3061),
    [anon_sym_equals] = ACTIONS(3061),
    [anon_sym_let] = ACTIONS(3061),
    [anon_sym_orderby] = ACTIONS(3061),
    [anon_sym_ascending] = ACTIONS(3061),
    [anon_sym_descending] = ACTIONS(3061),
    [anon_sym_group] = ACTIONS(3061),
    [anon_sym_by] = ACTIONS(3061),
    [anon_sym_select] = ACTIONS(3061),
    [anon_sym_DQUOTE] = ACTIONS(3061),
    [anon_sym_stackalloc] = ACTIONS(3061),
    [anon_sym_sizeof] = ACTIONS(3061),
    [anon_sym_typeof] = ACTIONS(3061),
    [anon_sym___makeref] = ACTIONS(3061),
    [anon_sym___reftype] = ACTIONS(3061),
    [anon_sym___refvalue] = ACTIONS(3061),
    [sym_null_literal] = ACTIONS(3061),
    [anon_sym_SQUOTE] = ACTIONS(3063),
    [sym_integer_literal] = ACTIONS(3061),
    [sym_real_literal] = ACTIONS(3063),
    [sym_verbatim_string_literal] = ACTIONS(3063),
    [sym_raw_string_literal] = ACTIONS(3063),
    [aux_sym_preproc_if_token1] = ACTIONS(3063),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3063),
    [sym_interpolation_verbatim_start] = ACTIONS(3063),
    [sym_interpolation_raw_start] = ACTIONS(3063),
  },
  [2698] = {
    [sym_preproc_region] = STATE(2698),
    [sym_preproc_endregion] = STATE(2698),
    [sym_preproc_line] = STATE(2698),
    [sym_preproc_pragma] = STATE(2698),
    [sym_preproc_nullable] = STATE(2698),
    [sym_preproc_error] = STATE(2698),
    [sym_preproc_define] = STATE(2698),
    [sym_preproc_undef] = STATE(2698),
    [sym__identifier_token] = ACTIONS(3279),
    [anon_sym_extern] = ACTIONS(3279),
    [anon_sym_alias] = ACTIONS(3279),
    [anon_sym_SEMI] = ACTIONS(3281),
    [anon_sym_global] = ACTIONS(3279),
    [anon_sym_using] = ACTIONS(3279),
    [anon_sym_unsafe] = ACTIONS(3279),
    [anon_sym_static] = ACTIONS(3279),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_LPAREN] = ACTIONS(3281),
    [anon_sym_return] = ACTIONS(3279),
    [anon_sym_ref] = ACTIONS(3279),
    [anon_sym_LBRACE] = ACTIONS(3281),
    [anon_sym_RBRACE] = ACTIONS(3281),
    [anon_sym_delegate] = ACTIONS(3279),
    [anon_sym_abstract] = ACTIONS(3279),
    [anon_sym_async] = ACTIONS(3279),
    [anon_sym_const] = ACTIONS(3279),
    [anon_sym_file] = ACTIONS(3279),
    [anon_sym_fixed] = ACTIONS(3279),
    [anon_sym_internal] = ACTIONS(3279),
    [anon_sym_new] = ACTIONS(3279),
    [anon_sym_override] = ACTIONS(3279),
    [anon_sym_partial] = ACTIONS(3279),
    [anon_sym_private] = ACTIONS(3279),
    [anon_sym_protected] = ACTIONS(3279),
    [anon_sym_public] = ACTIONS(3279),
    [anon_sym_readonly] = ACTIONS(3279),
    [anon_sym_required] = ACTIONS(3279),
    [anon_sym_sealed] = ACTIONS(3279),
    [anon_sym_virtual] = ACTIONS(3279),
    [anon_sym_volatile] = ACTIONS(3279),
    [anon_sym_where] = ACTIONS(3279),
    [anon_sym_notnull] = ACTIONS(3279),
    [anon_sym_unmanaged] = ACTIONS(3279),
    [anon_sym_checked] = ACTIONS(3279),
    [anon_sym_BANG] = ACTIONS(3281),
    [anon_sym_TILDE] = ACTIONS(3281),
    [anon_sym_PLUS_PLUS] = ACTIONS(3281),
    [anon_sym_DASH_DASH] = ACTIONS(3281),
    [anon_sym_true] = ACTIONS(3279),
    [anon_sym_false] = ACTIONS(3279),
    [anon_sym_PLUS] = ACTIONS(3279),
    [anon_sym_DASH] = ACTIONS(3279),
    [anon_sym_STAR] = ACTIONS(3281),
    [anon_sym_CARET] = ACTIONS(3281),
    [anon_sym_AMP] = ACTIONS(3281),
    [anon_sym_this] = ACTIONS(3279),
    [anon_sym_scoped] = ACTIONS(3279),
    [anon_sym_var] = ACTIONS(3279),
    [sym_predefined_type] = ACTIONS(3279),
    [anon_sym_break] = ACTIONS(3279),
    [anon_sym_unchecked] = ACTIONS(3279),
    [anon_sym_continue] = ACTIONS(3279),
    [anon_sym_do] = ACTIONS(3279),
    [anon_sym_while] = ACTIONS(3279),
    [anon_sym_for] = ACTIONS(3279),
    [anon_sym_lock] = ACTIONS(3279),
    [anon_sym_yield] = ACTIONS(3279),
    [anon_sym_switch] = ACTIONS(3279),
    [anon_sym_case] = ACTIONS(3279),
    [anon_sym_default] = ACTIONS(3279),
    [anon_sym_throw] = ACTIONS(3279),
    [anon_sym_try] = ACTIONS(3279),
    [anon_sym_when] = ACTIONS(3279),
    [anon_sym_await] = ACTIONS(3279),
    [anon_sym_foreach] = ACTIONS(3279),
    [anon_sym_goto] = ACTIONS(3279),
    [anon_sym_if] = ACTIONS(3279),
    [anon_sym_else] = ACTIONS(3279),
    [anon_sym_DOT_DOT] = ACTIONS(3281),
    [anon_sym_from] = ACTIONS(3279),
    [anon_sym_into] = ACTIONS(3279),
    [anon_sym_join] = ACTIONS(3279),
    [anon_sym_on] = ACTIONS(3279),
    [anon_sym_equals] = ACTIONS(3279),
    [anon_sym_let] = ACTIONS(3279),
    [anon_sym_orderby] = ACTIONS(3279),
    [anon_sym_ascending] = ACTIONS(3279),
    [anon_sym_descending] = ACTIONS(3279),
    [anon_sym_group] = ACTIONS(3279),
    [anon_sym_by] = ACTIONS(3279),
    [anon_sym_select] = ACTIONS(3279),
    [anon_sym_DQUOTE] = ACTIONS(3279),
    [anon_sym_stackalloc] = ACTIONS(3279),
    [anon_sym_sizeof] = ACTIONS(3279),
    [anon_sym_typeof] = ACTIONS(3279),
    [anon_sym___makeref] = ACTIONS(3279),
    [anon_sym___reftype] = ACTIONS(3279),
    [anon_sym___refvalue] = ACTIONS(3279),
    [sym_null_literal] = ACTIONS(3279),
    [anon_sym_SQUOTE] = ACTIONS(3281),
    [sym_integer_literal] = ACTIONS(3279),
    [sym_real_literal] = ACTIONS(3281),
    [sym_verbatim_string_literal] = ACTIONS(3281),
    [sym_raw_string_literal] = ACTIONS(3281),
    [aux_sym_preproc_if_token1] = ACTIONS(3281),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3281),
    [sym_interpolation_verbatim_start] = ACTIONS(3281),
    [sym_interpolation_raw_start] = ACTIONS(3281),
  },
  [2699] = {
    [sym_preproc_region] = STATE(2699),
    [sym_preproc_endregion] = STATE(2699),
    [sym_preproc_line] = STATE(2699),
    [sym_preproc_pragma] = STATE(2699),
    [sym_preproc_nullable] = STATE(2699),
    [sym_preproc_error] = STATE(2699),
    [sym_preproc_define] = STATE(2699),
    [sym_preproc_undef] = STATE(2699),
    [sym__identifier_token] = ACTIONS(3263),
    [anon_sym_extern] = ACTIONS(3263),
    [anon_sym_alias] = ACTIONS(3263),
    [anon_sym_SEMI] = ACTIONS(3265),
    [anon_sym_global] = ACTIONS(3263),
    [anon_sym_using] = ACTIONS(3263),
    [anon_sym_unsafe] = ACTIONS(3263),
    [anon_sym_static] = ACTIONS(3263),
    [anon_sym_LBRACK] = ACTIONS(3265),
    [anon_sym_LPAREN] = ACTIONS(3265),
    [anon_sym_return] = ACTIONS(3263),
    [anon_sym_ref] = ACTIONS(3263),
    [anon_sym_LBRACE] = ACTIONS(3265),
    [anon_sym_RBRACE] = ACTIONS(3265),
    [anon_sym_delegate] = ACTIONS(3263),
    [anon_sym_abstract] = ACTIONS(3263),
    [anon_sym_async] = ACTIONS(3263),
    [anon_sym_const] = ACTIONS(3263),
    [anon_sym_file] = ACTIONS(3263),
    [anon_sym_fixed] = ACTIONS(3263),
    [anon_sym_internal] = ACTIONS(3263),
    [anon_sym_new] = ACTIONS(3263),
    [anon_sym_override] = ACTIONS(3263),
    [anon_sym_partial] = ACTIONS(3263),
    [anon_sym_private] = ACTIONS(3263),
    [anon_sym_protected] = ACTIONS(3263),
    [anon_sym_public] = ACTIONS(3263),
    [anon_sym_readonly] = ACTIONS(3263),
    [anon_sym_required] = ACTIONS(3263),
    [anon_sym_sealed] = ACTIONS(3263),
    [anon_sym_virtual] = ACTIONS(3263),
    [anon_sym_volatile] = ACTIONS(3263),
    [anon_sym_where] = ACTIONS(3263),
    [anon_sym_notnull] = ACTIONS(3263),
    [anon_sym_unmanaged] = ACTIONS(3263),
    [anon_sym_checked] = ACTIONS(3263),
    [anon_sym_BANG] = ACTIONS(3265),
    [anon_sym_TILDE] = ACTIONS(3265),
    [anon_sym_PLUS_PLUS] = ACTIONS(3265),
    [anon_sym_DASH_DASH] = ACTIONS(3265),
    [anon_sym_true] = ACTIONS(3263),
    [anon_sym_false] = ACTIONS(3263),
    [anon_sym_PLUS] = ACTIONS(3263),
    [anon_sym_DASH] = ACTIONS(3263),
    [anon_sym_STAR] = ACTIONS(3265),
    [anon_sym_CARET] = ACTIONS(3265),
    [anon_sym_AMP] = ACTIONS(3265),
    [anon_sym_this] = ACTIONS(3263),
    [anon_sym_scoped] = ACTIONS(3263),
    [anon_sym_var] = ACTIONS(3263),
    [sym_predefined_type] = ACTIONS(3263),
    [anon_sym_break] = ACTIONS(3263),
    [anon_sym_unchecked] = ACTIONS(3263),
    [anon_sym_continue] = ACTIONS(3263),
    [anon_sym_do] = ACTIONS(3263),
    [anon_sym_while] = ACTIONS(3263),
    [anon_sym_for] = ACTIONS(3263),
    [anon_sym_lock] = ACTIONS(3263),
    [anon_sym_yield] = ACTIONS(3263),
    [anon_sym_switch] = ACTIONS(3263),
    [anon_sym_case] = ACTIONS(3263),
    [anon_sym_default] = ACTIONS(3263),
    [anon_sym_throw] = ACTIONS(3263),
    [anon_sym_try] = ACTIONS(3263),
    [anon_sym_when] = ACTIONS(3263),
    [anon_sym_await] = ACTIONS(3263),
    [anon_sym_foreach] = ACTIONS(3263),
    [anon_sym_goto] = ACTIONS(3263),
    [anon_sym_if] = ACTIONS(3263),
    [anon_sym_else] = ACTIONS(3263),
    [anon_sym_DOT_DOT] = ACTIONS(3265),
    [anon_sym_from] = ACTIONS(3263),
    [anon_sym_into] = ACTIONS(3263),
    [anon_sym_join] = ACTIONS(3263),
    [anon_sym_on] = ACTIONS(3263),
    [anon_sym_equals] = ACTIONS(3263),
    [anon_sym_let] = ACTIONS(3263),
    [anon_sym_orderby] = ACTIONS(3263),
    [anon_sym_ascending] = ACTIONS(3263),
    [anon_sym_descending] = ACTIONS(3263),
    [anon_sym_group] = ACTIONS(3263),
    [anon_sym_by] = ACTIONS(3263),
    [anon_sym_select] = ACTIONS(3263),
    [anon_sym_DQUOTE] = ACTIONS(3263),
    [anon_sym_stackalloc] = ACTIONS(3263),
    [anon_sym_sizeof] = ACTIONS(3263),
    [anon_sym_typeof] = ACTIONS(3263),
    [anon_sym___makeref] = ACTIONS(3263),
    [anon_sym___reftype] = ACTIONS(3263),
    [anon_sym___refvalue] = ACTIONS(3263),
    [sym_null_literal] = ACTIONS(3263),
    [anon_sym_SQUOTE] = ACTIONS(3265),
    [sym_integer_literal] = ACTIONS(3263),
    [sym_real_literal] = ACTIONS(3265),
    [sym_verbatim_string_literal] = ACTIONS(3265),
    [sym_raw_string_literal] = ACTIONS(3265),
    [aux_sym_preproc_if_token1] = ACTIONS(3265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3265),
    [sym_interpolation_verbatim_start] = ACTIONS(3265),
    [sym_interpolation_raw_start] = ACTIONS(3265),
  },
  [2700] = {
    [sym_preproc_region] = STATE(2700),
    [sym_preproc_endregion] = STATE(2700),
    [sym_preproc_line] = STATE(2700),
    [sym_preproc_pragma] = STATE(2700),
    [sym_preproc_nullable] = STATE(2700),
    [sym_preproc_error] = STATE(2700),
    [sym_preproc_define] = STATE(2700),
    [sym_preproc_undef] = STATE(2700),
    [sym__identifier_token] = ACTIONS(3335),
    [anon_sym_extern] = ACTIONS(3335),
    [anon_sym_alias] = ACTIONS(3335),
    [anon_sym_SEMI] = ACTIONS(3337),
    [anon_sym_global] = ACTIONS(3335),
    [anon_sym_using] = ACTIONS(3335),
    [anon_sym_unsafe] = ACTIONS(3335),
    [anon_sym_static] = ACTIONS(3335),
    [anon_sym_LBRACK] = ACTIONS(3337),
    [anon_sym_LPAREN] = ACTIONS(3337),
    [anon_sym_return] = ACTIONS(3335),
    [anon_sym_ref] = ACTIONS(3335),
    [anon_sym_LBRACE] = ACTIONS(3337),
    [anon_sym_RBRACE] = ACTIONS(3337),
    [anon_sym_delegate] = ACTIONS(3335),
    [anon_sym_abstract] = ACTIONS(3335),
    [anon_sym_async] = ACTIONS(3335),
    [anon_sym_const] = ACTIONS(3335),
    [anon_sym_file] = ACTIONS(3335),
    [anon_sym_fixed] = ACTIONS(3335),
    [anon_sym_internal] = ACTIONS(3335),
    [anon_sym_new] = ACTIONS(3335),
    [anon_sym_override] = ACTIONS(3335),
    [anon_sym_partial] = ACTIONS(3335),
    [anon_sym_private] = ACTIONS(3335),
    [anon_sym_protected] = ACTIONS(3335),
    [anon_sym_public] = ACTIONS(3335),
    [anon_sym_readonly] = ACTIONS(3335),
    [anon_sym_required] = ACTIONS(3335),
    [anon_sym_sealed] = ACTIONS(3335),
    [anon_sym_virtual] = ACTIONS(3335),
    [anon_sym_volatile] = ACTIONS(3335),
    [anon_sym_where] = ACTIONS(3335),
    [anon_sym_notnull] = ACTIONS(3335),
    [anon_sym_unmanaged] = ACTIONS(3335),
    [anon_sym_checked] = ACTIONS(3335),
    [anon_sym_BANG] = ACTIONS(3337),
    [anon_sym_TILDE] = ACTIONS(3337),
    [anon_sym_PLUS_PLUS] = ACTIONS(3337),
    [anon_sym_DASH_DASH] = ACTIONS(3337),
    [anon_sym_true] = ACTIONS(3335),
    [anon_sym_false] = ACTIONS(3335),
    [anon_sym_PLUS] = ACTIONS(3335),
    [anon_sym_DASH] = ACTIONS(3335),
    [anon_sym_STAR] = ACTIONS(3337),
    [anon_sym_CARET] = ACTIONS(3337),
    [anon_sym_AMP] = ACTIONS(3337),
    [anon_sym_this] = ACTIONS(3335),
    [anon_sym_scoped] = ACTIONS(3335),
    [anon_sym_var] = ACTIONS(3335),
    [sym_predefined_type] = ACTIONS(3335),
    [anon_sym_break] = ACTIONS(3335),
    [anon_sym_unchecked] = ACTIONS(3335),
    [anon_sym_continue] = ACTIONS(3335),
    [anon_sym_do] = ACTIONS(3335),
    [anon_sym_while] = ACTIONS(3335),
    [anon_sym_for] = ACTIONS(3335),
    [anon_sym_lock] = ACTIONS(3335),
    [anon_sym_yield] = ACTIONS(3335),
    [anon_sym_switch] = ACTIONS(3335),
    [anon_sym_case] = ACTIONS(3335),
    [anon_sym_default] = ACTIONS(3335),
    [anon_sym_throw] = ACTIONS(3335),
    [anon_sym_try] = ACTIONS(3335),
    [anon_sym_when] = ACTIONS(3335),
    [anon_sym_await] = ACTIONS(3335),
    [anon_sym_foreach] = ACTIONS(3335),
    [anon_sym_goto] = ACTIONS(3335),
    [anon_sym_if] = ACTIONS(3335),
    [anon_sym_else] = ACTIONS(3335),
    [anon_sym_DOT_DOT] = ACTIONS(3337),
    [anon_sym_from] = ACTIONS(3335),
    [anon_sym_into] = ACTIONS(3335),
    [anon_sym_join] = ACTIONS(3335),
    [anon_sym_on] = ACTIONS(3335),
    [anon_sym_equals] = ACTIONS(3335),
    [anon_sym_let] = ACTIONS(3335),
    [anon_sym_orderby] = ACTIONS(3335),
    [anon_sym_ascending] = ACTIONS(3335),
    [anon_sym_descending] = ACTIONS(3335),
    [anon_sym_group] = ACTIONS(3335),
    [anon_sym_by] = ACTIONS(3335),
    [anon_sym_select] = ACTIONS(3335),
    [anon_sym_DQUOTE] = ACTIONS(3335),
    [anon_sym_stackalloc] = ACTIONS(3335),
    [anon_sym_sizeof] = ACTIONS(3335),
    [anon_sym_typeof] = ACTIONS(3335),
    [anon_sym___makeref] = ACTIONS(3335),
    [anon_sym___reftype] = ACTIONS(3335),
    [anon_sym___refvalue] = ACTIONS(3335),
    [sym_null_literal] = ACTIONS(3335),
    [anon_sym_SQUOTE] = ACTIONS(3337),
    [sym_integer_literal] = ACTIONS(3335),
    [sym_real_literal] = ACTIONS(3337),
    [sym_verbatim_string_literal] = ACTIONS(3337),
    [sym_raw_string_literal] = ACTIONS(3337),
    [aux_sym_preproc_if_token1] = ACTIONS(3337),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3337),
    [sym_interpolation_verbatim_start] = ACTIONS(3337),
    [sym_interpolation_raw_start] = ACTIONS(3337),
  },
  [2701] = {
    [sym_preproc_region] = STATE(2701),
    [sym_preproc_endregion] = STATE(2701),
    [sym_preproc_line] = STATE(2701),
    [sym_preproc_pragma] = STATE(2701),
    [sym_preproc_nullable] = STATE(2701),
    [sym_preproc_error] = STATE(2701),
    [sym_preproc_define] = STATE(2701),
    [sym_preproc_undef] = STATE(2701),
    [sym__identifier_token] = ACTIONS(3401),
    [anon_sym_extern] = ACTIONS(3401),
    [anon_sym_alias] = ACTIONS(3401),
    [anon_sym_SEMI] = ACTIONS(3403),
    [anon_sym_global] = ACTIONS(3401),
    [anon_sym_using] = ACTIONS(3401),
    [anon_sym_unsafe] = ACTIONS(3401),
    [anon_sym_static] = ACTIONS(3401),
    [anon_sym_LBRACK] = ACTIONS(3403),
    [anon_sym_LPAREN] = ACTIONS(3403),
    [anon_sym_return] = ACTIONS(3401),
    [anon_sym_ref] = ACTIONS(3401),
    [anon_sym_LBRACE] = ACTIONS(3403),
    [anon_sym_RBRACE] = ACTIONS(3403),
    [anon_sym_delegate] = ACTIONS(3401),
    [anon_sym_abstract] = ACTIONS(3401),
    [anon_sym_async] = ACTIONS(3401),
    [anon_sym_const] = ACTIONS(3401),
    [anon_sym_file] = ACTIONS(3401),
    [anon_sym_fixed] = ACTIONS(3401),
    [anon_sym_internal] = ACTIONS(3401),
    [anon_sym_new] = ACTIONS(3401),
    [anon_sym_override] = ACTIONS(3401),
    [anon_sym_partial] = ACTIONS(3401),
    [anon_sym_private] = ACTIONS(3401),
    [anon_sym_protected] = ACTIONS(3401),
    [anon_sym_public] = ACTIONS(3401),
    [anon_sym_readonly] = ACTIONS(3401),
    [anon_sym_required] = ACTIONS(3401),
    [anon_sym_sealed] = ACTIONS(3401),
    [anon_sym_virtual] = ACTIONS(3401),
    [anon_sym_volatile] = ACTIONS(3401),
    [anon_sym_where] = ACTIONS(3401),
    [anon_sym_notnull] = ACTIONS(3401),
    [anon_sym_unmanaged] = ACTIONS(3401),
    [anon_sym_checked] = ACTIONS(3401),
    [anon_sym_BANG] = ACTIONS(3403),
    [anon_sym_TILDE] = ACTIONS(3403),
    [anon_sym_PLUS_PLUS] = ACTIONS(3403),
    [anon_sym_DASH_DASH] = ACTIONS(3403),
    [anon_sym_true] = ACTIONS(3401),
    [anon_sym_false] = ACTIONS(3401),
    [anon_sym_PLUS] = ACTIONS(3401),
    [anon_sym_DASH] = ACTIONS(3401),
    [anon_sym_STAR] = ACTIONS(3403),
    [anon_sym_CARET] = ACTIONS(3403),
    [anon_sym_AMP] = ACTIONS(3403),
    [anon_sym_this] = ACTIONS(3401),
    [anon_sym_scoped] = ACTIONS(3401),
    [anon_sym_var] = ACTIONS(3401),
    [sym_predefined_type] = ACTIONS(3401),
    [anon_sym_break] = ACTIONS(3401),
    [anon_sym_unchecked] = ACTIONS(3401),
    [anon_sym_continue] = ACTIONS(3401),
    [anon_sym_do] = ACTIONS(3401),
    [anon_sym_while] = ACTIONS(3401),
    [anon_sym_for] = ACTIONS(3401),
    [anon_sym_lock] = ACTIONS(3401),
    [anon_sym_yield] = ACTIONS(3401),
    [anon_sym_switch] = ACTIONS(3401),
    [anon_sym_case] = ACTIONS(3401),
    [anon_sym_default] = ACTIONS(3401),
    [anon_sym_throw] = ACTIONS(3401),
    [anon_sym_try] = ACTIONS(3401),
    [anon_sym_when] = ACTIONS(3401),
    [anon_sym_await] = ACTIONS(3401),
    [anon_sym_foreach] = ACTIONS(3401),
    [anon_sym_goto] = ACTIONS(3401),
    [anon_sym_if] = ACTIONS(3401),
    [anon_sym_else] = ACTIONS(3401),
    [anon_sym_DOT_DOT] = ACTIONS(3403),
    [anon_sym_from] = ACTIONS(3401),
    [anon_sym_into] = ACTIONS(3401),
    [anon_sym_join] = ACTIONS(3401),
    [anon_sym_on] = ACTIONS(3401),
    [anon_sym_equals] = ACTIONS(3401),
    [anon_sym_let] = ACTIONS(3401),
    [anon_sym_orderby] = ACTIONS(3401),
    [anon_sym_ascending] = ACTIONS(3401),
    [anon_sym_descending] = ACTIONS(3401),
    [anon_sym_group] = ACTIONS(3401),
    [anon_sym_by] = ACTIONS(3401),
    [anon_sym_select] = ACTIONS(3401),
    [anon_sym_DQUOTE] = ACTIONS(3401),
    [anon_sym_stackalloc] = ACTIONS(3401),
    [anon_sym_sizeof] = ACTIONS(3401),
    [anon_sym_typeof] = ACTIONS(3401),
    [anon_sym___makeref] = ACTIONS(3401),
    [anon_sym___reftype] = ACTIONS(3401),
    [anon_sym___refvalue] = ACTIONS(3401),
    [sym_null_literal] = ACTIONS(3401),
    [anon_sym_SQUOTE] = ACTIONS(3403),
    [sym_integer_literal] = ACTIONS(3401),
    [sym_real_literal] = ACTIONS(3403),
    [sym_verbatim_string_literal] = ACTIONS(3403),
    [sym_raw_string_literal] = ACTIONS(3403),
    [aux_sym_preproc_if_token1] = ACTIONS(3403),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3403),
    [sym_interpolation_verbatim_start] = ACTIONS(3403),
    [sym_interpolation_raw_start] = ACTIONS(3403),
  },
  [2702] = {
    [sym_preproc_region] = STATE(2702),
    [sym_preproc_endregion] = STATE(2702),
    [sym_preproc_line] = STATE(2702),
    [sym_preproc_pragma] = STATE(2702),
    [sym_preproc_nullable] = STATE(2702),
    [sym_preproc_error] = STATE(2702),
    [sym_preproc_define] = STATE(2702),
    [sym_preproc_undef] = STATE(2702),
    [sym__identifier_token] = ACTIONS(3251),
    [anon_sym_extern] = ACTIONS(3251),
    [anon_sym_alias] = ACTIONS(3251),
    [anon_sym_SEMI] = ACTIONS(3253),
    [anon_sym_global] = ACTIONS(3251),
    [anon_sym_using] = ACTIONS(3251),
    [anon_sym_unsafe] = ACTIONS(3251),
    [anon_sym_static] = ACTIONS(3251),
    [anon_sym_LBRACK] = ACTIONS(3253),
    [anon_sym_LPAREN] = ACTIONS(3253),
    [anon_sym_return] = ACTIONS(3251),
    [anon_sym_ref] = ACTIONS(3251),
    [anon_sym_LBRACE] = ACTIONS(3253),
    [anon_sym_RBRACE] = ACTIONS(3253),
    [anon_sym_delegate] = ACTIONS(3251),
    [anon_sym_abstract] = ACTIONS(3251),
    [anon_sym_async] = ACTIONS(3251),
    [anon_sym_const] = ACTIONS(3251),
    [anon_sym_file] = ACTIONS(3251),
    [anon_sym_fixed] = ACTIONS(3251),
    [anon_sym_internal] = ACTIONS(3251),
    [anon_sym_new] = ACTIONS(3251),
    [anon_sym_override] = ACTIONS(3251),
    [anon_sym_partial] = ACTIONS(3251),
    [anon_sym_private] = ACTIONS(3251),
    [anon_sym_protected] = ACTIONS(3251),
    [anon_sym_public] = ACTIONS(3251),
    [anon_sym_readonly] = ACTIONS(3251),
    [anon_sym_required] = ACTIONS(3251),
    [anon_sym_sealed] = ACTIONS(3251),
    [anon_sym_virtual] = ACTIONS(3251),
    [anon_sym_volatile] = ACTIONS(3251),
    [anon_sym_where] = ACTIONS(3251),
    [anon_sym_notnull] = ACTIONS(3251),
    [anon_sym_unmanaged] = ACTIONS(3251),
    [anon_sym_checked] = ACTIONS(3251),
    [anon_sym_BANG] = ACTIONS(3253),
    [anon_sym_TILDE] = ACTIONS(3253),
    [anon_sym_PLUS_PLUS] = ACTIONS(3253),
    [anon_sym_DASH_DASH] = ACTIONS(3253),
    [anon_sym_true] = ACTIONS(3251),
    [anon_sym_false] = ACTIONS(3251),
    [anon_sym_PLUS] = ACTIONS(3251),
    [anon_sym_DASH] = ACTIONS(3251),
    [anon_sym_STAR] = ACTIONS(3253),
    [anon_sym_CARET] = ACTIONS(3253),
    [anon_sym_AMP] = ACTIONS(3253),
    [anon_sym_this] = ACTIONS(3251),
    [anon_sym_scoped] = ACTIONS(3251),
    [anon_sym_var] = ACTIONS(3251),
    [sym_predefined_type] = ACTIONS(3251),
    [anon_sym_break] = ACTIONS(3251),
    [anon_sym_unchecked] = ACTIONS(3251),
    [anon_sym_continue] = ACTIONS(3251),
    [anon_sym_do] = ACTIONS(3251),
    [anon_sym_while] = ACTIONS(3251),
    [anon_sym_for] = ACTIONS(3251),
    [anon_sym_lock] = ACTIONS(3251),
    [anon_sym_yield] = ACTIONS(3251),
    [anon_sym_switch] = ACTIONS(3251),
    [anon_sym_case] = ACTIONS(3251),
    [anon_sym_default] = ACTIONS(3251),
    [anon_sym_throw] = ACTIONS(3251),
    [anon_sym_try] = ACTIONS(3251),
    [anon_sym_when] = ACTIONS(3251),
    [anon_sym_await] = ACTIONS(3251),
    [anon_sym_foreach] = ACTIONS(3251),
    [anon_sym_goto] = ACTIONS(3251),
    [anon_sym_if] = ACTIONS(3251),
    [anon_sym_else] = ACTIONS(3251),
    [anon_sym_DOT_DOT] = ACTIONS(3253),
    [anon_sym_from] = ACTIONS(3251),
    [anon_sym_into] = ACTIONS(3251),
    [anon_sym_join] = ACTIONS(3251),
    [anon_sym_on] = ACTIONS(3251),
    [anon_sym_equals] = ACTIONS(3251),
    [anon_sym_let] = ACTIONS(3251),
    [anon_sym_orderby] = ACTIONS(3251),
    [anon_sym_ascending] = ACTIONS(3251),
    [anon_sym_descending] = ACTIONS(3251),
    [anon_sym_group] = ACTIONS(3251),
    [anon_sym_by] = ACTIONS(3251),
    [anon_sym_select] = ACTIONS(3251),
    [anon_sym_DQUOTE] = ACTIONS(3251),
    [anon_sym_stackalloc] = ACTIONS(3251),
    [anon_sym_sizeof] = ACTIONS(3251),
    [anon_sym_typeof] = ACTIONS(3251),
    [anon_sym___makeref] = ACTIONS(3251),
    [anon_sym___reftype] = ACTIONS(3251),
    [anon_sym___refvalue] = ACTIONS(3251),
    [sym_null_literal] = ACTIONS(3251),
    [anon_sym_SQUOTE] = ACTIONS(3253),
    [sym_integer_literal] = ACTIONS(3251),
    [sym_real_literal] = ACTIONS(3253),
    [sym_verbatim_string_literal] = ACTIONS(3253),
    [sym_raw_string_literal] = ACTIONS(3253),
    [aux_sym_preproc_if_token1] = ACTIONS(3253),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3253),
    [sym_interpolation_verbatim_start] = ACTIONS(3253),
    [sym_interpolation_raw_start] = ACTIONS(3253),
  },
  [2703] = {
    [sym_preproc_region] = STATE(2703),
    [sym_preproc_endregion] = STATE(2703),
    [sym_preproc_line] = STATE(2703),
    [sym_preproc_pragma] = STATE(2703),
    [sym_preproc_nullable] = STATE(2703),
    [sym_preproc_error] = STATE(2703),
    [sym_preproc_define] = STATE(2703),
    [sym_preproc_undef] = STATE(2703),
    [sym__identifier_token] = ACTIONS(3057),
    [anon_sym_extern] = ACTIONS(3057),
    [anon_sym_alias] = ACTIONS(3057),
    [anon_sym_SEMI] = ACTIONS(3059),
    [anon_sym_global] = ACTIONS(3057),
    [anon_sym_using] = ACTIONS(3057),
    [anon_sym_unsafe] = ACTIONS(3057),
    [anon_sym_static] = ACTIONS(3057),
    [anon_sym_LBRACK] = ACTIONS(3059),
    [anon_sym_LPAREN] = ACTIONS(3059),
    [anon_sym_return] = ACTIONS(3057),
    [anon_sym_ref] = ACTIONS(3057),
    [anon_sym_LBRACE] = ACTIONS(3059),
    [anon_sym_RBRACE] = ACTIONS(3059),
    [anon_sym_delegate] = ACTIONS(3057),
    [anon_sym_abstract] = ACTIONS(3057),
    [anon_sym_async] = ACTIONS(3057),
    [anon_sym_const] = ACTIONS(3057),
    [anon_sym_file] = ACTIONS(3057),
    [anon_sym_fixed] = ACTIONS(3057),
    [anon_sym_internal] = ACTIONS(3057),
    [anon_sym_new] = ACTIONS(3057),
    [anon_sym_override] = ACTIONS(3057),
    [anon_sym_partial] = ACTIONS(3057),
    [anon_sym_private] = ACTIONS(3057),
    [anon_sym_protected] = ACTIONS(3057),
    [anon_sym_public] = ACTIONS(3057),
    [anon_sym_readonly] = ACTIONS(3057),
    [anon_sym_required] = ACTIONS(3057),
    [anon_sym_sealed] = ACTIONS(3057),
    [anon_sym_virtual] = ACTIONS(3057),
    [anon_sym_volatile] = ACTIONS(3057),
    [anon_sym_where] = ACTIONS(3057),
    [anon_sym_notnull] = ACTIONS(3057),
    [anon_sym_unmanaged] = ACTIONS(3057),
    [anon_sym_checked] = ACTIONS(3057),
    [anon_sym_BANG] = ACTIONS(3059),
    [anon_sym_TILDE] = ACTIONS(3059),
    [anon_sym_PLUS_PLUS] = ACTIONS(3059),
    [anon_sym_DASH_DASH] = ACTIONS(3059),
    [anon_sym_true] = ACTIONS(3057),
    [anon_sym_false] = ACTIONS(3057),
    [anon_sym_PLUS] = ACTIONS(3057),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_STAR] = ACTIONS(3059),
    [anon_sym_CARET] = ACTIONS(3059),
    [anon_sym_AMP] = ACTIONS(3059),
    [anon_sym_this] = ACTIONS(3057),
    [anon_sym_scoped] = ACTIONS(3057),
    [anon_sym_var] = ACTIONS(3057),
    [sym_predefined_type] = ACTIONS(3057),
    [anon_sym_break] = ACTIONS(3057),
    [anon_sym_unchecked] = ACTIONS(3057),
    [anon_sym_continue] = ACTIONS(3057),
    [anon_sym_do] = ACTIONS(3057),
    [anon_sym_while] = ACTIONS(3057),
    [anon_sym_for] = ACTIONS(3057),
    [anon_sym_lock] = ACTIONS(3057),
    [anon_sym_yield] = ACTIONS(3057),
    [anon_sym_switch] = ACTIONS(3057),
    [anon_sym_case] = ACTIONS(3057),
    [anon_sym_default] = ACTIONS(3057),
    [anon_sym_throw] = ACTIONS(3057),
    [anon_sym_try] = ACTIONS(3057),
    [anon_sym_when] = ACTIONS(3057),
    [anon_sym_await] = ACTIONS(3057),
    [anon_sym_foreach] = ACTIONS(3057),
    [anon_sym_goto] = ACTIONS(3057),
    [anon_sym_if] = ACTIONS(3057),
    [anon_sym_else] = ACTIONS(3057),
    [anon_sym_DOT_DOT] = ACTIONS(3059),
    [anon_sym_from] = ACTIONS(3057),
    [anon_sym_into] = ACTIONS(3057),
    [anon_sym_join] = ACTIONS(3057),
    [anon_sym_on] = ACTIONS(3057),
    [anon_sym_equals] = ACTIONS(3057),
    [anon_sym_let] = ACTIONS(3057),
    [anon_sym_orderby] = ACTIONS(3057),
    [anon_sym_ascending] = ACTIONS(3057),
    [anon_sym_descending] = ACTIONS(3057),
    [anon_sym_group] = ACTIONS(3057),
    [anon_sym_by] = ACTIONS(3057),
    [anon_sym_select] = ACTIONS(3057),
    [anon_sym_DQUOTE] = ACTIONS(3057),
    [anon_sym_stackalloc] = ACTIONS(3057),
    [anon_sym_sizeof] = ACTIONS(3057),
    [anon_sym_typeof] = ACTIONS(3057),
    [anon_sym___makeref] = ACTIONS(3057),
    [anon_sym___reftype] = ACTIONS(3057),
    [anon_sym___refvalue] = ACTIONS(3057),
    [sym_null_literal] = ACTIONS(3057),
    [anon_sym_SQUOTE] = ACTIONS(3059),
    [sym_integer_literal] = ACTIONS(3057),
    [sym_real_literal] = ACTIONS(3059),
    [sym_verbatim_string_literal] = ACTIONS(3059),
    [sym_raw_string_literal] = ACTIONS(3059),
    [aux_sym_preproc_if_token1] = ACTIONS(3059),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3059),
    [sym_interpolation_verbatim_start] = ACTIONS(3059),
    [sym_interpolation_raw_start] = ACTIONS(3059),
  },
  [2704] = {
    [sym_preproc_region] = STATE(2704),
    [sym_preproc_endregion] = STATE(2704),
    [sym_preproc_line] = STATE(2704),
    [sym_preproc_pragma] = STATE(2704),
    [sym_preproc_nullable] = STATE(2704),
    [sym_preproc_error] = STATE(2704),
    [sym_preproc_define] = STATE(2704),
    [sym_preproc_undef] = STATE(2704),
    [sym__identifier_token] = ACTIONS(3053),
    [anon_sym_extern] = ACTIONS(3053),
    [anon_sym_alias] = ACTIONS(3053),
    [anon_sym_SEMI] = ACTIONS(3055),
    [anon_sym_global] = ACTIONS(3053),
    [anon_sym_using] = ACTIONS(3053),
    [anon_sym_unsafe] = ACTIONS(3053),
    [anon_sym_static] = ACTIONS(3053),
    [anon_sym_LBRACK] = ACTIONS(3055),
    [anon_sym_LPAREN] = ACTIONS(3055),
    [anon_sym_return] = ACTIONS(3053),
    [anon_sym_ref] = ACTIONS(3053),
    [anon_sym_LBRACE] = ACTIONS(3055),
    [anon_sym_RBRACE] = ACTIONS(3055),
    [anon_sym_delegate] = ACTIONS(3053),
    [anon_sym_abstract] = ACTIONS(3053),
    [anon_sym_async] = ACTIONS(3053),
    [anon_sym_const] = ACTIONS(3053),
    [anon_sym_file] = ACTIONS(3053),
    [anon_sym_fixed] = ACTIONS(3053),
    [anon_sym_internal] = ACTIONS(3053),
    [anon_sym_new] = ACTIONS(3053),
    [anon_sym_override] = ACTIONS(3053),
    [anon_sym_partial] = ACTIONS(3053),
    [anon_sym_private] = ACTIONS(3053),
    [anon_sym_protected] = ACTIONS(3053),
    [anon_sym_public] = ACTIONS(3053),
    [anon_sym_readonly] = ACTIONS(3053),
    [anon_sym_required] = ACTIONS(3053),
    [anon_sym_sealed] = ACTIONS(3053),
    [anon_sym_virtual] = ACTIONS(3053),
    [anon_sym_volatile] = ACTIONS(3053),
    [anon_sym_where] = ACTIONS(3053),
    [anon_sym_notnull] = ACTIONS(3053),
    [anon_sym_unmanaged] = ACTIONS(3053),
    [anon_sym_checked] = ACTIONS(3053),
    [anon_sym_BANG] = ACTIONS(3055),
    [anon_sym_TILDE] = ACTIONS(3055),
    [anon_sym_PLUS_PLUS] = ACTIONS(3055),
    [anon_sym_DASH_DASH] = ACTIONS(3055),
    [anon_sym_true] = ACTIONS(3053),
    [anon_sym_false] = ACTIONS(3053),
    [anon_sym_PLUS] = ACTIONS(3053),
    [anon_sym_DASH] = ACTIONS(3053),
    [anon_sym_STAR] = ACTIONS(3055),
    [anon_sym_CARET] = ACTIONS(3055),
    [anon_sym_AMP] = ACTIONS(3055),
    [anon_sym_this] = ACTIONS(3053),
    [anon_sym_scoped] = ACTIONS(3053),
    [anon_sym_var] = ACTIONS(3053),
    [sym_predefined_type] = ACTIONS(3053),
    [anon_sym_break] = ACTIONS(3053),
    [anon_sym_unchecked] = ACTIONS(3053),
    [anon_sym_continue] = ACTIONS(3053),
    [anon_sym_do] = ACTIONS(3053),
    [anon_sym_while] = ACTIONS(3053),
    [anon_sym_for] = ACTIONS(3053),
    [anon_sym_lock] = ACTIONS(3053),
    [anon_sym_yield] = ACTIONS(3053),
    [anon_sym_switch] = ACTIONS(3053),
    [anon_sym_case] = ACTIONS(3053),
    [anon_sym_default] = ACTIONS(3053),
    [anon_sym_throw] = ACTIONS(3053),
    [anon_sym_try] = ACTIONS(3053),
    [anon_sym_when] = ACTIONS(3053),
    [anon_sym_await] = ACTIONS(3053),
    [anon_sym_foreach] = ACTIONS(3053),
    [anon_sym_goto] = ACTIONS(3053),
    [anon_sym_if] = ACTIONS(3053),
    [anon_sym_else] = ACTIONS(3053),
    [anon_sym_DOT_DOT] = ACTIONS(3055),
    [anon_sym_from] = ACTIONS(3053),
    [anon_sym_into] = ACTIONS(3053),
    [anon_sym_join] = ACTIONS(3053),
    [anon_sym_on] = ACTIONS(3053),
    [anon_sym_equals] = ACTIONS(3053),
    [anon_sym_let] = ACTIONS(3053),
    [anon_sym_orderby] = ACTIONS(3053),
    [anon_sym_ascending] = ACTIONS(3053),
    [anon_sym_descending] = ACTIONS(3053),
    [anon_sym_group] = ACTIONS(3053),
    [anon_sym_by] = ACTIONS(3053),
    [anon_sym_select] = ACTIONS(3053),
    [anon_sym_DQUOTE] = ACTIONS(3053),
    [anon_sym_stackalloc] = ACTIONS(3053),
    [anon_sym_sizeof] = ACTIONS(3053),
    [anon_sym_typeof] = ACTIONS(3053),
    [anon_sym___makeref] = ACTIONS(3053),
    [anon_sym___reftype] = ACTIONS(3053),
    [anon_sym___refvalue] = ACTIONS(3053),
    [sym_null_literal] = ACTIONS(3053),
    [anon_sym_SQUOTE] = ACTIONS(3055),
    [sym_integer_literal] = ACTIONS(3053),
    [sym_real_literal] = ACTIONS(3055),
    [sym_verbatim_string_literal] = ACTIONS(3055),
    [sym_raw_string_literal] = ACTIONS(3055),
    [aux_sym_preproc_if_token1] = ACTIONS(3055),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3055),
    [sym_interpolation_verbatim_start] = ACTIONS(3055),
    [sym_interpolation_raw_start] = ACTIONS(3055),
  },
  [2705] = {
    [sym_preproc_region] = STATE(2705),
    [sym_preproc_endregion] = STATE(2705),
    [sym_preproc_line] = STATE(2705),
    [sym_preproc_pragma] = STATE(2705),
    [sym_preproc_nullable] = STATE(2705),
    [sym_preproc_error] = STATE(2705),
    [sym_preproc_define] = STATE(2705),
    [sym_preproc_undef] = STATE(2705),
    [sym__identifier_token] = ACTIONS(3391),
    [anon_sym_extern] = ACTIONS(3391),
    [anon_sym_alias] = ACTIONS(3391),
    [anon_sym_SEMI] = ACTIONS(3393),
    [anon_sym_global] = ACTIONS(3391),
    [anon_sym_using] = ACTIONS(3391),
    [anon_sym_unsafe] = ACTIONS(3391),
    [anon_sym_static] = ACTIONS(3391),
    [anon_sym_LBRACK] = ACTIONS(3393),
    [anon_sym_LPAREN] = ACTIONS(3393),
    [anon_sym_return] = ACTIONS(3391),
    [anon_sym_ref] = ACTIONS(3391),
    [anon_sym_LBRACE] = ACTIONS(3393),
    [anon_sym_RBRACE] = ACTIONS(3393),
    [anon_sym_delegate] = ACTIONS(3391),
    [anon_sym_abstract] = ACTIONS(3391),
    [anon_sym_async] = ACTIONS(3391),
    [anon_sym_const] = ACTIONS(3391),
    [anon_sym_file] = ACTIONS(3391),
    [anon_sym_fixed] = ACTIONS(3391),
    [anon_sym_internal] = ACTIONS(3391),
    [anon_sym_new] = ACTIONS(3391),
    [anon_sym_override] = ACTIONS(3391),
    [anon_sym_partial] = ACTIONS(3391),
    [anon_sym_private] = ACTIONS(3391),
    [anon_sym_protected] = ACTIONS(3391),
    [anon_sym_public] = ACTIONS(3391),
    [anon_sym_readonly] = ACTIONS(3391),
    [anon_sym_required] = ACTIONS(3391),
    [anon_sym_sealed] = ACTIONS(3391),
    [anon_sym_virtual] = ACTIONS(3391),
    [anon_sym_volatile] = ACTIONS(3391),
    [anon_sym_where] = ACTIONS(3391),
    [anon_sym_notnull] = ACTIONS(3391),
    [anon_sym_unmanaged] = ACTIONS(3391),
    [anon_sym_checked] = ACTIONS(3391),
    [anon_sym_BANG] = ACTIONS(3393),
    [anon_sym_TILDE] = ACTIONS(3393),
    [anon_sym_PLUS_PLUS] = ACTIONS(3393),
    [anon_sym_DASH_DASH] = ACTIONS(3393),
    [anon_sym_true] = ACTIONS(3391),
    [anon_sym_false] = ACTIONS(3391),
    [anon_sym_PLUS] = ACTIONS(3391),
    [anon_sym_DASH] = ACTIONS(3391),
    [anon_sym_STAR] = ACTIONS(3393),
    [anon_sym_CARET] = ACTIONS(3393),
    [anon_sym_AMP] = ACTIONS(3393),
    [anon_sym_this] = ACTIONS(3391),
    [anon_sym_scoped] = ACTIONS(3391),
    [anon_sym_var] = ACTIONS(3391),
    [sym_predefined_type] = ACTIONS(3391),
    [anon_sym_break] = ACTIONS(3391),
    [anon_sym_unchecked] = ACTIONS(3391),
    [anon_sym_continue] = ACTIONS(3391),
    [anon_sym_do] = ACTIONS(3391),
    [anon_sym_while] = ACTIONS(3391),
    [anon_sym_for] = ACTIONS(3391),
    [anon_sym_lock] = ACTIONS(3391),
    [anon_sym_yield] = ACTIONS(3391),
    [anon_sym_switch] = ACTIONS(3391),
    [anon_sym_case] = ACTIONS(3391),
    [anon_sym_default] = ACTIONS(3391),
    [anon_sym_throw] = ACTIONS(3391),
    [anon_sym_try] = ACTIONS(3391),
    [anon_sym_when] = ACTIONS(3391),
    [anon_sym_await] = ACTIONS(3391),
    [anon_sym_foreach] = ACTIONS(3391),
    [anon_sym_goto] = ACTIONS(3391),
    [anon_sym_if] = ACTIONS(3391),
    [anon_sym_else] = ACTIONS(3981),
    [anon_sym_DOT_DOT] = ACTIONS(3393),
    [anon_sym_from] = ACTIONS(3391),
    [anon_sym_into] = ACTIONS(3391),
    [anon_sym_join] = ACTIONS(3391),
    [anon_sym_on] = ACTIONS(3391),
    [anon_sym_equals] = ACTIONS(3391),
    [anon_sym_let] = ACTIONS(3391),
    [anon_sym_orderby] = ACTIONS(3391),
    [anon_sym_ascending] = ACTIONS(3391),
    [anon_sym_descending] = ACTIONS(3391),
    [anon_sym_group] = ACTIONS(3391),
    [anon_sym_by] = ACTIONS(3391),
    [anon_sym_select] = ACTIONS(3391),
    [anon_sym_DQUOTE] = ACTIONS(3391),
    [anon_sym_stackalloc] = ACTIONS(3391),
    [anon_sym_sizeof] = ACTIONS(3391),
    [anon_sym_typeof] = ACTIONS(3391),
    [anon_sym___makeref] = ACTIONS(3391),
    [anon_sym___reftype] = ACTIONS(3391),
    [anon_sym___refvalue] = ACTIONS(3391),
    [sym_null_literal] = ACTIONS(3391),
    [anon_sym_SQUOTE] = ACTIONS(3393),
    [sym_integer_literal] = ACTIONS(3391),
    [sym_real_literal] = ACTIONS(3393),
    [sym_verbatim_string_literal] = ACTIONS(3393),
    [sym_raw_string_literal] = ACTIONS(3393),
    [aux_sym_preproc_if_token1] = ACTIONS(3393),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3393),
    [sym_interpolation_verbatim_start] = ACTIONS(3393),
    [sym_interpolation_raw_start] = ACTIONS(3393),
  },
  [2706] = {
    [sym_preproc_region] = STATE(2706),
    [sym_preproc_endregion] = STATE(2706),
    [sym_preproc_line] = STATE(2706),
    [sym_preproc_pragma] = STATE(2706),
    [sym_preproc_nullable] = STATE(2706),
    [sym_preproc_error] = STATE(2706),
    [sym_preproc_define] = STATE(2706),
    [sym_preproc_undef] = STATE(2706),
    [sym__identifier_token] = ACTIONS(3331),
    [anon_sym_extern] = ACTIONS(3331),
    [anon_sym_alias] = ACTIONS(3331),
    [anon_sym_SEMI] = ACTIONS(3333),
    [anon_sym_global] = ACTIONS(3331),
    [anon_sym_using] = ACTIONS(3331),
    [anon_sym_unsafe] = ACTIONS(3331),
    [anon_sym_static] = ACTIONS(3331),
    [anon_sym_LBRACK] = ACTIONS(3333),
    [anon_sym_LPAREN] = ACTIONS(3333),
    [anon_sym_return] = ACTIONS(3331),
    [anon_sym_ref] = ACTIONS(3331),
    [anon_sym_LBRACE] = ACTIONS(3333),
    [anon_sym_RBRACE] = ACTIONS(3333),
    [anon_sym_delegate] = ACTIONS(3331),
    [anon_sym_abstract] = ACTIONS(3331),
    [anon_sym_async] = ACTIONS(3331),
    [anon_sym_const] = ACTIONS(3331),
    [anon_sym_file] = ACTIONS(3331),
    [anon_sym_fixed] = ACTIONS(3331),
    [anon_sym_internal] = ACTIONS(3331),
    [anon_sym_new] = ACTIONS(3331),
    [anon_sym_override] = ACTIONS(3331),
    [anon_sym_partial] = ACTIONS(3331),
    [anon_sym_private] = ACTIONS(3331),
    [anon_sym_protected] = ACTIONS(3331),
    [anon_sym_public] = ACTIONS(3331),
    [anon_sym_readonly] = ACTIONS(3331),
    [anon_sym_required] = ACTIONS(3331),
    [anon_sym_sealed] = ACTIONS(3331),
    [anon_sym_virtual] = ACTIONS(3331),
    [anon_sym_volatile] = ACTIONS(3331),
    [anon_sym_where] = ACTIONS(3331),
    [anon_sym_notnull] = ACTIONS(3331),
    [anon_sym_unmanaged] = ACTIONS(3331),
    [anon_sym_checked] = ACTIONS(3331),
    [anon_sym_BANG] = ACTIONS(3333),
    [anon_sym_TILDE] = ACTIONS(3333),
    [anon_sym_PLUS_PLUS] = ACTIONS(3333),
    [anon_sym_DASH_DASH] = ACTIONS(3333),
    [anon_sym_true] = ACTIONS(3331),
    [anon_sym_false] = ACTIONS(3331),
    [anon_sym_PLUS] = ACTIONS(3331),
    [anon_sym_DASH] = ACTIONS(3331),
    [anon_sym_STAR] = ACTIONS(3333),
    [anon_sym_CARET] = ACTIONS(3333),
    [anon_sym_AMP] = ACTIONS(3333),
    [anon_sym_this] = ACTIONS(3331),
    [anon_sym_scoped] = ACTIONS(3331),
    [anon_sym_var] = ACTIONS(3331),
    [sym_predefined_type] = ACTIONS(3331),
    [anon_sym_break] = ACTIONS(3331),
    [anon_sym_unchecked] = ACTIONS(3331),
    [anon_sym_continue] = ACTIONS(3331),
    [anon_sym_do] = ACTIONS(3331),
    [anon_sym_while] = ACTIONS(3331),
    [anon_sym_for] = ACTIONS(3331),
    [anon_sym_lock] = ACTIONS(3331),
    [anon_sym_yield] = ACTIONS(3331),
    [anon_sym_switch] = ACTIONS(3331),
    [anon_sym_case] = ACTIONS(3331),
    [anon_sym_default] = ACTIONS(3331),
    [anon_sym_throw] = ACTIONS(3331),
    [anon_sym_try] = ACTIONS(3331),
    [anon_sym_when] = ACTIONS(3331),
    [anon_sym_await] = ACTIONS(3331),
    [anon_sym_foreach] = ACTIONS(3331),
    [anon_sym_goto] = ACTIONS(3331),
    [anon_sym_if] = ACTIONS(3331),
    [anon_sym_else] = ACTIONS(3331),
    [anon_sym_DOT_DOT] = ACTIONS(3333),
    [anon_sym_from] = ACTIONS(3331),
    [anon_sym_into] = ACTIONS(3331),
    [anon_sym_join] = ACTIONS(3331),
    [anon_sym_on] = ACTIONS(3331),
    [anon_sym_equals] = ACTIONS(3331),
    [anon_sym_let] = ACTIONS(3331),
    [anon_sym_orderby] = ACTIONS(3331),
    [anon_sym_ascending] = ACTIONS(3331),
    [anon_sym_descending] = ACTIONS(3331),
    [anon_sym_group] = ACTIONS(3331),
    [anon_sym_by] = ACTIONS(3331),
    [anon_sym_select] = ACTIONS(3331),
    [anon_sym_DQUOTE] = ACTIONS(3331),
    [anon_sym_stackalloc] = ACTIONS(3331),
    [anon_sym_sizeof] = ACTIONS(3331),
    [anon_sym_typeof] = ACTIONS(3331),
    [anon_sym___makeref] = ACTIONS(3331),
    [anon_sym___reftype] = ACTIONS(3331),
    [anon_sym___refvalue] = ACTIONS(3331),
    [sym_null_literal] = ACTIONS(3331),
    [anon_sym_SQUOTE] = ACTIONS(3333),
    [sym_integer_literal] = ACTIONS(3331),
    [sym_real_literal] = ACTIONS(3333),
    [sym_verbatim_string_literal] = ACTIONS(3333),
    [sym_raw_string_literal] = ACTIONS(3333),
    [aux_sym_preproc_if_token1] = ACTIONS(3333),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3333),
    [sym_interpolation_verbatim_start] = ACTIONS(3333),
    [sym_interpolation_raw_start] = ACTIONS(3333),
  },
  [2707] = {
    [sym_preproc_region] = STATE(2707),
    [sym_preproc_endregion] = STATE(2707),
    [sym_preproc_line] = STATE(2707),
    [sym_preproc_pragma] = STATE(2707),
    [sym_preproc_nullable] = STATE(2707),
    [sym_preproc_error] = STATE(2707),
    [sym_preproc_define] = STATE(2707),
    [sym_preproc_undef] = STATE(2707),
    [sym__identifier_token] = ACTIONS(3319),
    [anon_sym_extern] = ACTIONS(3319),
    [anon_sym_alias] = ACTIONS(3319),
    [anon_sym_SEMI] = ACTIONS(3321),
    [anon_sym_global] = ACTIONS(3319),
    [anon_sym_using] = ACTIONS(3319),
    [anon_sym_unsafe] = ACTIONS(3319),
    [anon_sym_static] = ACTIONS(3319),
    [anon_sym_LBRACK] = ACTIONS(3321),
    [anon_sym_LPAREN] = ACTIONS(3321),
    [anon_sym_return] = ACTIONS(3319),
    [anon_sym_ref] = ACTIONS(3319),
    [anon_sym_LBRACE] = ACTIONS(3321),
    [anon_sym_RBRACE] = ACTIONS(3321),
    [anon_sym_delegate] = ACTIONS(3319),
    [anon_sym_abstract] = ACTIONS(3319),
    [anon_sym_async] = ACTIONS(3319),
    [anon_sym_const] = ACTIONS(3319),
    [anon_sym_file] = ACTIONS(3319),
    [anon_sym_fixed] = ACTIONS(3319),
    [anon_sym_internal] = ACTIONS(3319),
    [anon_sym_new] = ACTIONS(3319),
    [anon_sym_override] = ACTIONS(3319),
    [anon_sym_partial] = ACTIONS(3319),
    [anon_sym_private] = ACTIONS(3319),
    [anon_sym_protected] = ACTIONS(3319),
    [anon_sym_public] = ACTIONS(3319),
    [anon_sym_readonly] = ACTIONS(3319),
    [anon_sym_required] = ACTIONS(3319),
    [anon_sym_sealed] = ACTIONS(3319),
    [anon_sym_virtual] = ACTIONS(3319),
    [anon_sym_volatile] = ACTIONS(3319),
    [anon_sym_where] = ACTIONS(3319),
    [anon_sym_notnull] = ACTIONS(3319),
    [anon_sym_unmanaged] = ACTIONS(3319),
    [anon_sym_checked] = ACTIONS(3319),
    [anon_sym_BANG] = ACTIONS(3321),
    [anon_sym_TILDE] = ACTIONS(3321),
    [anon_sym_PLUS_PLUS] = ACTIONS(3321),
    [anon_sym_DASH_DASH] = ACTIONS(3321),
    [anon_sym_true] = ACTIONS(3319),
    [anon_sym_false] = ACTIONS(3319),
    [anon_sym_PLUS] = ACTIONS(3319),
    [anon_sym_DASH] = ACTIONS(3319),
    [anon_sym_STAR] = ACTIONS(3321),
    [anon_sym_CARET] = ACTIONS(3321),
    [anon_sym_AMP] = ACTIONS(3321),
    [anon_sym_this] = ACTIONS(3319),
    [anon_sym_scoped] = ACTIONS(3319),
    [anon_sym_var] = ACTIONS(3319),
    [sym_predefined_type] = ACTIONS(3319),
    [anon_sym_break] = ACTIONS(3319),
    [anon_sym_unchecked] = ACTIONS(3319),
    [anon_sym_continue] = ACTIONS(3319),
    [anon_sym_do] = ACTIONS(3319),
    [anon_sym_while] = ACTIONS(3319),
    [anon_sym_for] = ACTIONS(3319),
    [anon_sym_lock] = ACTIONS(3319),
    [anon_sym_yield] = ACTIONS(3319),
    [anon_sym_switch] = ACTIONS(3319),
    [anon_sym_case] = ACTIONS(3319),
    [anon_sym_default] = ACTIONS(3319),
    [anon_sym_throw] = ACTIONS(3319),
    [anon_sym_try] = ACTIONS(3319),
    [anon_sym_when] = ACTIONS(3319),
    [anon_sym_await] = ACTIONS(3319),
    [anon_sym_foreach] = ACTIONS(3319),
    [anon_sym_goto] = ACTIONS(3319),
    [anon_sym_if] = ACTIONS(3319),
    [anon_sym_else] = ACTIONS(3319),
    [anon_sym_DOT_DOT] = ACTIONS(3321),
    [anon_sym_from] = ACTIONS(3319),
    [anon_sym_into] = ACTIONS(3319),
    [anon_sym_join] = ACTIONS(3319),
    [anon_sym_on] = ACTIONS(3319),
    [anon_sym_equals] = ACTIONS(3319),
    [anon_sym_let] = ACTIONS(3319),
    [anon_sym_orderby] = ACTIONS(3319),
    [anon_sym_ascending] = ACTIONS(3319),
    [anon_sym_descending] = ACTIONS(3319),
    [anon_sym_group] = ACTIONS(3319),
    [anon_sym_by] = ACTIONS(3319),
    [anon_sym_select] = ACTIONS(3319),
    [anon_sym_DQUOTE] = ACTIONS(3319),
    [anon_sym_stackalloc] = ACTIONS(3319),
    [anon_sym_sizeof] = ACTIONS(3319),
    [anon_sym_typeof] = ACTIONS(3319),
    [anon_sym___makeref] = ACTIONS(3319),
    [anon_sym___reftype] = ACTIONS(3319),
    [anon_sym___refvalue] = ACTIONS(3319),
    [sym_null_literal] = ACTIONS(3319),
    [anon_sym_SQUOTE] = ACTIONS(3321),
    [sym_integer_literal] = ACTIONS(3319),
    [sym_real_literal] = ACTIONS(3321),
    [sym_verbatim_string_literal] = ACTIONS(3321),
    [sym_raw_string_literal] = ACTIONS(3321),
    [aux_sym_preproc_if_token1] = ACTIONS(3321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3321),
    [sym_interpolation_verbatim_start] = ACTIONS(3321),
    [sym_interpolation_raw_start] = ACTIONS(3321),
  },
  [2708] = {
    [sym_preproc_region] = STATE(2708),
    [sym_preproc_endregion] = STATE(2708),
    [sym_preproc_line] = STATE(2708),
    [sym_preproc_pragma] = STATE(2708),
    [sym_preproc_nullable] = STATE(2708),
    [sym_preproc_error] = STATE(2708),
    [sym_preproc_define] = STATE(2708),
    [sym_preproc_undef] = STATE(2708),
    [sym__identifier_token] = ACTIONS(3383),
    [anon_sym_extern] = ACTIONS(3383),
    [anon_sym_alias] = ACTIONS(3383),
    [anon_sym_SEMI] = ACTIONS(3385),
    [anon_sym_global] = ACTIONS(3383),
    [anon_sym_using] = ACTIONS(3383),
    [anon_sym_unsafe] = ACTIONS(3383),
    [anon_sym_static] = ACTIONS(3383),
    [anon_sym_LBRACK] = ACTIONS(3385),
    [anon_sym_LPAREN] = ACTIONS(3385),
    [anon_sym_return] = ACTIONS(3383),
    [anon_sym_ref] = ACTIONS(3383),
    [anon_sym_LBRACE] = ACTIONS(3385),
    [anon_sym_RBRACE] = ACTIONS(3385),
    [anon_sym_delegate] = ACTIONS(3383),
    [anon_sym_abstract] = ACTIONS(3383),
    [anon_sym_async] = ACTIONS(3383),
    [anon_sym_const] = ACTIONS(3383),
    [anon_sym_file] = ACTIONS(3383),
    [anon_sym_fixed] = ACTIONS(3383),
    [anon_sym_internal] = ACTIONS(3383),
    [anon_sym_new] = ACTIONS(3383),
    [anon_sym_override] = ACTIONS(3383),
    [anon_sym_partial] = ACTIONS(3383),
    [anon_sym_private] = ACTIONS(3383),
    [anon_sym_protected] = ACTIONS(3383),
    [anon_sym_public] = ACTIONS(3383),
    [anon_sym_readonly] = ACTIONS(3383),
    [anon_sym_required] = ACTIONS(3383),
    [anon_sym_sealed] = ACTIONS(3383),
    [anon_sym_virtual] = ACTIONS(3383),
    [anon_sym_volatile] = ACTIONS(3383),
    [anon_sym_where] = ACTIONS(3383),
    [anon_sym_notnull] = ACTIONS(3383),
    [anon_sym_unmanaged] = ACTIONS(3383),
    [anon_sym_checked] = ACTIONS(3383),
    [anon_sym_BANG] = ACTIONS(3385),
    [anon_sym_TILDE] = ACTIONS(3385),
    [anon_sym_PLUS_PLUS] = ACTIONS(3385),
    [anon_sym_DASH_DASH] = ACTIONS(3385),
    [anon_sym_true] = ACTIONS(3383),
    [anon_sym_false] = ACTIONS(3383),
    [anon_sym_PLUS] = ACTIONS(3383),
    [anon_sym_DASH] = ACTIONS(3383),
    [anon_sym_STAR] = ACTIONS(3385),
    [anon_sym_CARET] = ACTIONS(3385),
    [anon_sym_AMP] = ACTIONS(3385),
    [anon_sym_this] = ACTIONS(3383),
    [anon_sym_scoped] = ACTIONS(3383),
    [anon_sym_var] = ACTIONS(3383),
    [sym_predefined_type] = ACTIONS(3383),
    [anon_sym_break] = ACTIONS(3383),
    [anon_sym_unchecked] = ACTIONS(3383),
    [anon_sym_continue] = ACTIONS(3383),
    [anon_sym_do] = ACTIONS(3383),
    [anon_sym_while] = ACTIONS(3383),
    [anon_sym_for] = ACTIONS(3383),
    [anon_sym_lock] = ACTIONS(3383),
    [anon_sym_yield] = ACTIONS(3383),
    [anon_sym_switch] = ACTIONS(3383),
    [anon_sym_case] = ACTIONS(3383),
    [anon_sym_default] = ACTIONS(3383),
    [anon_sym_throw] = ACTIONS(3383),
    [anon_sym_try] = ACTIONS(3383),
    [anon_sym_when] = ACTIONS(3383),
    [anon_sym_await] = ACTIONS(3383),
    [anon_sym_foreach] = ACTIONS(3383),
    [anon_sym_goto] = ACTIONS(3383),
    [anon_sym_if] = ACTIONS(3383),
    [anon_sym_else] = ACTIONS(3383),
    [anon_sym_DOT_DOT] = ACTIONS(3385),
    [anon_sym_from] = ACTIONS(3383),
    [anon_sym_into] = ACTIONS(3383),
    [anon_sym_join] = ACTIONS(3383),
    [anon_sym_on] = ACTIONS(3383),
    [anon_sym_equals] = ACTIONS(3383),
    [anon_sym_let] = ACTIONS(3383),
    [anon_sym_orderby] = ACTIONS(3383),
    [anon_sym_ascending] = ACTIONS(3383),
    [anon_sym_descending] = ACTIONS(3383),
    [anon_sym_group] = ACTIONS(3383),
    [anon_sym_by] = ACTIONS(3383),
    [anon_sym_select] = ACTIONS(3383),
    [anon_sym_DQUOTE] = ACTIONS(3383),
    [anon_sym_stackalloc] = ACTIONS(3383),
    [anon_sym_sizeof] = ACTIONS(3383),
    [anon_sym_typeof] = ACTIONS(3383),
    [anon_sym___makeref] = ACTIONS(3383),
    [anon_sym___reftype] = ACTIONS(3383),
    [anon_sym___refvalue] = ACTIONS(3383),
    [sym_null_literal] = ACTIONS(3383),
    [anon_sym_SQUOTE] = ACTIONS(3385),
    [sym_integer_literal] = ACTIONS(3383),
    [sym_real_literal] = ACTIONS(3385),
    [sym_verbatim_string_literal] = ACTIONS(3385),
    [sym_raw_string_literal] = ACTIONS(3385),
    [aux_sym_preproc_if_token1] = ACTIONS(3385),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3385),
    [sym_interpolation_verbatim_start] = ACTIONS(3385),
    [sym_interpolation_raw_start] = ACTIONS(3385),
  },
  [2709] = {
    [sym_preproc_region] = STATE(2709),
    [sym_preproc_endregion] = STATE(2709),
    [sym_preproc_line] = STATE(2709),
    [sym_preproc_pragma] = STATE(2709),
    [sym_preproc_nullable] = STATE(2709),
    [sym_preproc_error] = STATE(2709),
    [sym_preproc_define] = STATE(2709),
    [sym_preproc_undef] = STATE(2709),
    [sym__identifier_token] = ACTIONS(3093),
    [anon_sym_extern] = ACTIONS(3093),
    [anon_sym_alias] = ACTIONS(3093),
    [anon_sym_SEMI] = ACTIONS(3095),
    [anon_sym_global] = ACTIONS(3093),
    [anon_sym_using] = ACTIONS(3093),
    [anon_sym_unsafe] = ACTIONS(3093),
    [anon_sym_static] = ACTIONS(3093),
    [anon_sym_LBRACK] = ACTIONS(3095),
    [anon_sym_LPAREN] = ACTIONS(3095),
    [anon_sym_return] = ACTIONS(3093),
    [anon_sym_ref] = ACTIONS(3093),
    [anon_sym_LBRACE] = ACTIONS(3095),
    [anon_sym_RBRACE] = ACTIONS(3095),
    [anon_sym_delegate] = ACTIONS(3093),
    [anon_sym_abstract] = ACTIONS(3093),
    [anon_sym_async] = ACTIONS(3093),
    [anon_sym_const] = ACTIONS(3093),
    [anon_sym_file] = ACTIONS(3093),
    [anon_sym_fixed] = ACTIONS(3093),
    [anon_sym_internal] = ACTIONS(3093),
    [anon_sym_new] = ACTIONS(3093),
    [anon_sym_override] = ACTIONS(3093),
    [anon_sym_partial] = ACTIONS(3093),
    [anon_sym_private] = ACTIONS(3093),
    [anon_sym_protected] = ACTIONS(3093),
    [anon_sym_public] = ACTIONS(3093),
    [anon_sym_readonly] = ACTIONS(3093),
    [anon_sym_required] = ACTIONS(3093),
    [anon_sym_sealed] = ACTIONS(3093),
    [anon_sym_virtual] = ACTIONS(3093),
    [anon_sym_volatile] = ACTIONS(3093),
    [anon_sym_where] = ACTIONS(3093),
    [anon_sym_notnull] = ACTIONS(3093),
    [anon_sym_unmanaged] = ACTIONS(3093),
    [anon_sym_checked] = ACTIONS(3093),
    [anon_sym_BANG] = ACTIONS(3095),
    [anon_sym_TILDE] = ACTIONS(3095),
    [anon_sym_PLUS_PLUS] = ACTIONS(3095),
    [anon_sym_DASH_DASH] = ACTIONS(3095),
    [anon_sym_true] = ACTIONS(3093),
    [anon_sym_false] = ACTIONS(3093),
    [anon_sym_PLUS] = ACTIONS(3093),
    [anon_sym_DASH] = ACTIONS(3093),
    [anon_sym_STAR] = ACTIONS(3095),
    [anon_sym_CARET] = ACTIONS(3095),
    [anon_sym_AMP] = ACTIONS(3095),
    [anon_sym_this] = ACTIONS(3093),
    [anon_sym_scoped] = ACTIONS(3093),
    [anon_sym_var] = ACTIONS(3093),
    [sym_predefined_type] = ACTIONS(3093),
    [anon_sym_break] = ACTIONS(3093),
    [anon_sym_unchecked] = ACTIONS(3093),
    [anon_sym_continue] = ACTIONS(3093),
    [anon_sym_do] = ACTIONS(3093),
    [anon_sym_while] = ACTIONS(3093),
    [anon_sym_for] = ACTIONS(3093),
    [anon_sym_lock] = ACTIONS(3093),
    [anon_sym_yield] = ACTIONS(3093),
    [anon_sym_switch] = ACTIONS(3093),
    [anon_sym_case] = ACTIONS(3093),
    [anon_sym_default] = ACTIONS(3093),
    [anon_sym_throw] = ACTIONS(3093),
    [anon_sym_try] = ACTIONS(3093),
    [anon_sym_when] = ACTIONS(3093),
    [anon_sym_await] = ACTIONS(3093),
    [anon_sym_foreach] = ACTIONS(3093),
    [anon_sym_goto] = ACTIONS(3093),
    [anon_sym_if] = ACTIONS(3093),
    [anon_sym_else] = ACTIONS(3093),
    [anon_sym_DOT_DOT] = ACTIONS(3095),
    [anon_sym_from] = ACTIONS(3093),
    [anon_sym_into] = ACTIONS(3093),
    [anon_sym_join] = ACTIONS(3093),
    [anon_sym_on] = ACTIONS(3093),
    [anon_sym_equals] = ACTIONS(3093),
    [anon_sym_let] = ACTIONS(3093),
    [anon_sym_orderby] = ACTIONS(3093),
    [anon_sym_ascending] = ACTIONS(3093),
    [anon_sym_descending] = ACTIONS(3093),
    [anon_sym_group] = ACTIONS(3093),
    [anon_sym_by] = ACTIONS(3093),
    [anon_sym_select] = ACTIONS(3093),
    [anon_sym_DQUOTE] = ACTIONS(3093),
    [anon_sym_stackalloc] = ACTIONS(3093),
    [anon_sym_sizeof] = ACTIONS(3093),
    [anon_sym_typeof] = ACTIONS(3093),
    [anon_sym___makeref] = ACTIONS(3093),
    [anon_sym___reftype] = ACTIONS(3093),
    [anon_sym___refvalue] = ACTIONS(3093),
    [sym_null_literal] = ACTIONS(3093),
    [anon_sym_SQUOTE] = ACTIONS(3095),
    [sym_integer_literal] = ACTIONS(3093),
    [sym_real_literal] = ACTIONS(3095),
    [sym_verbatim_string_literal] = ACTIONS(3095),
    [sym_raw_string_literal] = ACTIONS(3095),
    [aux_sym_preproc_if_token1] = ACTIONS(3095),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3095),
    [sym_interpolation_verbatim_start] = ACTIONS(3095),
    [sym_interpolation_raw_start] = ACTIONS(3095),
  },
  [2710] = {
    [sym_preproc_region] = STATE(2710),
    [sym_preproc_endregion] = STATE(2710),
    [sym_preproc_line] = STATE(2710),
    [sym_preproc_pragma] = STATE(2710),
    [sym_preproc_nullable] = STATE(2710),
    [sym_preproc_error] = STATE(2710),
    [sym_preproc_define] = STATE(2710),
    [sym_preproc_undef] = STATE(2710),
    [sym__identifier_token] = ACTIONS(3315),
    [anon_sym_extern] = ACTIONS(3315),
    [anon_sym_alias] = ACTIONS(3315),
    [anon_sym_SEMI] = ACTIONS(3317),
    [anon_sym_global] = ACTIONS(3315),
    [anon_sym_using] = ACTIONS(3315),
    [anon_sym_unsafe] = ACTIONS(3315),
    [anon_sym_static] = ACTIONS(3315),
    [anon_sym_LBRACK] = ACTIONS(3317),
    [anon_sym_LPAREN] = ACTIONS(3317),
    [anon_sym_return] = ACTIONS(3315),
    [anon_sym_ref] = ACTIONS(3315),
    [anon_sym_LBRACE] = ACTIONS(3317),
    [anon_sym_RBRACE] = ACTIONS(3317),
    [anon_sym_delegate] = ACTIONS(3315),
    [anon_sym_abstract] = ACTIONS(3315),
    [anon_sym_async] = ACTIONS(3315),
    [anon_sym_const] = ACTIONS(3315),
    [anon_sym_file] = ACTIONS(3315),
    [anon_sym_fixed] = ACTIONS(3315),
    [anon_sym_internal] = ACTIONS(3315),
    [anon_sym_new] = ACTIONS(3315),
    [anon_sym_override] = ACTIONS(3315),
    [anon_sym_partial] = ACTIONS(3315),
    [anon_sym_private] = ACTIONS(3315),
    [anon_sym_protected] = ACTIONS(3315),
    [anon_sym_public] = ACTIONS(3315),
    [anon_sym_readonly] = ACTIONS(3315),
    [anon_sym_required] = ACTIONS(3315),
    [anon_sym_sealed] = ACTIONS(3315),
    [anon_sym_virtual] = ACTIONS(3315),
    [anon_sym_volatile] = ACTIONS(3315),
    [anon_sym_where] = ACTIONS(3315),
    [anon_sym_notnull] = ACTIONS(3315),
    [anon_sym_unmanaged] = ACTIONS(3315),
    [anon_sym_checked] = ACTIONS(3315),
    [anon_sym_BANG] = ACTIONS(3317),
    [anon_sym_TILDE] = ACTIONS(3317),
    [anon_sym_PLUS_PLUS] = ACTIONS(3317),
    [anon_sym_DASH_DASH] = ACTIONS(3317),
    [anon_sym_true] = ACTIONS(3315),
    [anon_sym_false] = ACTIONS(3315),
    [anon_sym_PLUS] = ACTIONS(3315),
    [anon_sym_DASH] = ACTIONS(3315),
    [anon_sym_STAR] = ACTIONS(3317),
    [anon_sym_CARET] = ACTIONS(3317),
    [anon_sym_AMP] = ACTIONS(3317),
    [anon_sym_this] = ACTIONS(3315),
    [anon_sym_scoped] = ACTIONS(3315),
    [anon_sym_var] = ACTIONS(3315),
    [sym_predefined_type] = ACTIONS(3315),
    [anon_sym_break] = ACTIONS(3315),
    [anon_sym_unchecked] = ACTIONS(3315),
    [anon_sym_continue] = ACTIONS(3315),
    [anon_sym_do] = ACTIONS(3315),
    [anon_sym_while] = ACTIONS(3315),
    [anon_sym_for] = ACTIONS(3315),
    [anon_sym_lock] = ACTIONS(3315),
    [anon_sym_yield] = ACTIONS(3315),
    [anon_sym_switch] = ACTIONS(3315),
    [anon_sym_case] = ACTIONS(3315),
    [anon_sym_default] = ACTIONS(3315),
    [anon_sym_throw] = ACTIONS(3315),
    [anon_sym_try] = ACTIONS(3315),
    [anon_sym_when] = ACTIONS(3315),
    [anon_sym_await] = ACTIONS(3315),
    [anon_sym_foreach] = ACTIONS(3315),
    [anon_sym_goto] = ACTIONS(3315),
    [anon_sym_if] = ACTIONS(3315),
    [anon_sym_else] = ACTIONS(3315),
    [anon_sym_DOT_DOT] = ACTIONS(3317),
    [anon_sym_from] = ACTIONS(3315),
    [anon_sym_into] = ACTIONS(3315),
    [anon_sym_join] = ACTIONS(3315),
    [anon_sym_on] = ACTIONS(3315),
    [anon_sym_equals] = ACTIONS(3315),
    [anon_sym_let] = ACTIONS(3315),
    [anon_sym_orderby] = ACTIONS(3315),
    [anon_sym_ascending] = ACTIONS(3315),
    [anon_sym_descending] = ACTIONS(3315),
    [anon_sym_group] = ACTIONS(3315),
    [anon_sym_by] = ACTIONS(3315),
    [anon_sym_select] = ACTIONS(3315),
    [anon_sym_DQUOTE] = ACTIONS(3315),
    [anon_sym_stackalloc] = ACTIONS(3315),
    [anon_sym_sizeof] = ACTIONS(3315),
    [anon_sym_typeof] = ACTIONS(3315),
    [anon_sym___makeref] = ACTIONS(3315),
    [anon_sym___reftype] = ACTIONS(3315),
    [anon_sym___refvalue] = ACTIONS(3315),
    [sym_null_literal] = ACTIONS(3315),
    [anon_sym_SQUOTE] = ACTIONS(3317),
    [sym_integer_literal] = ACTIONS(3315),
    [sym_real_literal] = ACTIONS(3317),
    [sym_verbatim_string_literal] = ACTIONS(3317),
    [sym_raw_string_literal] = ACTIONS(3317),
    [aux_sym_preproc_if_token1] = ACTIONS(3317),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3317),
    [sym_interpolation_verbatim_start] = ACTIONS(3317),
    [sym_interpolation_raw_start] = ACTIONS(3317),
  },
  [2711] = {
    [sym_preproc_region] = STATE(2711),
    [sym_preproc_endregion] = STATE(2711),
    [sym_preproc_line] = STATE(2711),
    [sym_preproc_pragma] = STATE(2711),
    [sym_preproc_nullable] = STATE(2711),
    [sym_preproc_error] = STATE(2711),
    [sym_preproc_define] = STATE(2711),
    [sym_preproc_undef] = STATE(2711),
    [sym__identifier_token] = ACTIONS(3259),
    [anon_sym_extern] = ACTIONS(3259),
    [anon_sym_alias] = ACTIONS(3259),
    [anon_sym_SEMI] = ACTIONS(3261),
    [anon_sym_global] = ACTIONS(3259),
    [anon_sym_using] = ACTIONS(3259),
    [anon_sym_unsafe] = ACTIONS(3259),
    [anon_sym_static] = ACTIONS(3259),
    [anon_sym_LBRACK] = ACTIONS(3261),
    [anon_sym_LPAREN] = ACTIONS(3261),
    [anon_sym_return] = ACTIONS(3259),
    [anon_sym_ref] = ACTIONS(3259),
    [anon_sym_LBRACE] = ACTIONS(3261),
    [anon_sym_RBRACE] = ACTIONS(3261),
    [anon_sym_delegate] = ACTIONS(3259),
    [anon_sym_abstract] = ACTIONS(3259),
    [anon_sym_async] = ACTIONS(3259),
    [anon_sym_const] = ACTIONS(3259),
    [anon_sym_file] = ACTIONS(3259),
    [anon_sym_fixed] = ACTIONS(3259),
    [anon_sym_internal] = ACTIONS(3259),
    [anon_sym_new] = ACTIONS(3259),
    [anon_sym_override] = ACTIONS(3259),
    [anon_sym_partial] = ACTIONS(3259),
    [anon_sym_private] = ACTIONS(3259),
    [anon_sym_protected] = ACTIONS(3259),
    [anon_sym_public] = ACTIONS(3259),
    [anon_sym_readonly] = ACTIONS(3259),
    [anon_sym_required] = ACTIONS(3259),
    [anon_sym_sealed] = ACTIONS(3259),
    [anon_sym_virtual] = ACTIONS(3259),
    [anon_sym_volatile] = ACTIONS(3259),
    [anon_sym_where] = ACTIONS(3259),
    [anon_sym_notnull] = ACTIONS(3259),
    [anon_sym_unmanaged] = ACTIONS(3259),
    [anon_sym_checked] = ACTIONS(3259),
    [anon_sym_BANG] = ACTIONS(3261),
    [anon_sym_TILDE] = ACTIONS(3261),
    [anon_sym_PLUS_PLUS] = ACTIONS(3261),
    [anon_sym_DASH_DASH] = ACTIONS(3261),
    [anon_sym_true] = ACTIONS(3259),
    [anon_sym_false] = ACTIONS(3259),
    [anon_sym_PLUS] = ACTIONS(3259),
    [anon_sym_DASH] = ACTIONS(3259),
    [anon_sym_STAR] = ACTIONS(3261),
    [anon_sym_CARET] = ACTIONS(3261),
    [anon_sym_AMP] = ACTIONS(3261),
    [anon_sym_this] = ACTIONS(3259),
    [anon_sym_scoped] = ACTIONS(3259),
    [anon_sym_var] = ACTIONS(3259),
    [sym_predefined_type] = ACTIONS(3259),
    [anon_sym_break] = ACTIONS(3259),
    [anon_sym_unchecked] = ACTIONS(3259),
    [anon_sym_continue] = ACTIONS(3259),
    [anon_sym_do] = ACTIONS(3259),
    [anon_sym_while] = ACTIONS(3259),
    [anon_sym_for] = ACTIONS(3259),
    [anon_sym_lock] = ACTIONS(3259),
    [anon_sym_yield] = ACTIONS(3259),
    [anon_sym_switch] = ACTIONS(3259),
    [anon_sym_case] = ACTIONS(3259),
    [anon_sym_default] = ACTIONS(3259),
    [anon_sym_throw] = ACTIONS(3259),
    [anon_sym_try] = ACTIONS(3259),
    [anon_sym_when] = ACTIONS(3259),
    [anon_sym_await] = ACTIONS(3259),
    [anon_sym_foreach] = ACTIONS(3259),
    [anon_sym_goto] = ACTIONS(3259),
    [anon_sym_if] = ACTIONS(3259),
    [anon_sym_else] = ACTIONS(3259),
    [anon_sym_DOT_DOT] = ACTIONS(3261),
    [anon_sym_from] = ACTIONS(3259),
    [anon_sym_into] = ACTIONS(3259),
    [anon_sym_join] = ACTIONS(3259),
    [anon_sym_on] = ACTIONS(3259),
    [anon_sym_equals] = ACTIONS(3259),
    [anon_sym_let] = ACTIONS(3259),
    [anon_sym_orderby] = ACTIONS(3259),
    [anon_sym_ascending] = ACTIONS(3259),
    [anon_sym_descending] = ACTIONS(3259),
    [anon_sym_group] = ACTIONS(3259),
    [anon_sym_by] = ACTIONS(3259),
    [anon_sym_select] = ACTIONS(3259),
    [anon_sym_DQUOTE] = ACTIONS(3259),
    [anon_sym_stackalloc] = ACTIONS(3259),
    [anon_sym_sizeof] = ACTIONS(3259),
    [anon_sym_typeof] = ACTIONS(3259),
    [anon_sym___makeref] = ACTIONS(3259),
    [anon_sym___reftype] = ACTIONS(3259),
    [anon_sym___refvalue] = ACTIONS(3259),
    [sym_null_literal] = ACTIONS(3259),
    [anon_sym_SQUOTE] = ACTIONS(3261),
    [sym_integer_literal] = ACTIONS(3259),
    [sym_real_literal] = ACTIONS(3261),
    [sym_verbatim_string_literal] = ACTIONS(3261),
    [sym_raw_string_literal] = ACTIONS(3261),
    [aux_sym_preproc_if_token1] = ACTIONS(3261),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3261),
    [sym_interpolation_verbatim_start] = ACTIONS(3261),
    [sym_interpolation_raw_start] = ACTIONS(3261),
  },
  [2712] = {
    [sym_preproc_region] = STATE(2712),
    [sym_preproc_endregion] = STATE(2712),
    [sym_preproc_line] = STATE(2712),
    [sym_preproc_pragma] = STATE(2712),
    [sym_preproc_nullable] = STATE(2712),
    [sym_preproc_error] = STATE(2712),
    [sym_preproc_define] = STATE(2712),
    [sym_preproc_undef] = STATE(2712),
    [sym__identifier_token] = ACTIONS(3267),
    [anon_sym_extern] = ACTIONS(3267),
    [anon_sym_alias] = ACTIONS(3267),
    [anon_sym_SEMI] = ACTIONS(3269),
    [anon_sym_global] = ACTIONS(3267),
    [anon_sym_using] = ACTIONS(3267),
    [anon_sym_unsafe] = ACTIONS(3267),
    [anon_sym_static] = ACTIONS(3267),
    [anon_sym_LBRACK] = ACTIONS(3269),
    [anon_sym_LPAREN] = ACTIONS(3269),
    [anon_sym_return] = ACTIONS(3267),
    [anon_sym_ref] = ACTIONS(3267),
    [anon_sym_LBRACE] = ACTIONS(3269),
    [anon_sym_RBRACE] = ACTIONS(3269),
    [anon_sym_delegate] = ACTIONS(3267),
    [anon_sym_abstract] = ACTIONS(3267),
    [anon_sym_async] = ACTIONS(3267),
    [anon_sym_const] = ACTIONS(3267),
    [anon_sym_file] = ACTIONS(3267),
    [anon_sym_fixed] = ACTIONS(3267),
    [anon_sym_internal] = ACTIONS(3267),
    [anon_sym_new] = ACTIONS(3267),
    [anon_sym_override] = ACTIONS(3267),
    [anon_sym_partial] = ACTIONS(3267),
    [anon_sym_private] = ACTIONS(3267),
    [anon_sym_protected] = ACTIONS(3267),
    [anon_sym_public] = ACTIONS(3267),
    [anon_sym_readonly] = ACTIONS(3267),
    [anon_sym_required] = ACTIONS(3267),
    [anon_sym_sealed] = ACTIONS(3267),
    [anon_sym_virtual] = ACTIONS(3267),
    [anon_sym_volatile] = ACTIONS(3267),
    [anon_sym_where] = ACTIONS(3267),
    [anon_sym_notnull] = ACTIONS(3267),
    [anon_sym_unmanaged] = ACTIONS(3267),
    [anon_sym_checked] = ACTIONS(3267),
    [anon_sym_BANG] = ACTIONS(3269),
    [anon_sym_TILDE] = ACTIONS(3269),
    [anon_sym_PLUS_PLUS] = ACTIONS(3269),
    [anon_sym_DASH_DASH] = ACTIONS(3269),
    [anon_sym_true] = ACTIONS(3267),
    [anon_sym_false] = ACTIONS(3267),
    [anon_sym_PLUS] = ACTIONS(3267),
    [anon_sym_DASH] = ACTIONS(3267),
    [anon_sym_STAR] = ACTIONS(3269),
    [anon_sym_CARET] = ACTIONS(3269),
    [anon_sym_AMP] = ACTIONS(3269),
    [anon_sym_this] = ACTIONS(3267),
    [anon_sym_scoped] = ACTIONS(3267),
    [anon_sym_var] = ACTIONS(3267),
    [sym_predefined_type] = ACTIONS(3267),
    [anon_sym_break] = ACTIONS(3267),
    [anon_sym_unchecked] = ACTIONS(3267),
    [anon_sym_continue] = ACTIONS(3267),
    [anon_sym_do] = ACTIONS(3267),
    [anon_sym_while] = ACTIONS(3267),
    [anon_sym_for] = ACTIONS(3267),
    [anon_sym_lock] = ACTIONS(3267),
    [anon_sym_yield] = ACTIONS(3267),
    [anon_sym_switch] = ACTIONS(3267),
    [anon_sym_case] = ACTIONS(3267),
    [anon_sym_default] = ACTIONS(3267),
    [anon_sym_throw] = ACTIONS(3267),
    [anon_sym_try] = ACTIONS(3267),
    [anon_sym_when] = ACTIONS(3267),
    [anon_sym_await] = ACTIONS(3267),
    [anon_sym_foreach] = ACTIONS(3267),
    [anon_sym_goto] = ACTIONS(3267),
    [anon_sym_if] = ACTIONS(3267),
    [anon_sym_else] = ACTIONS(3267),
    [anon_sym_DOT_DOT] = ACTIONS(3269),
    [anon_sym_from] = ACTIONS(3267),
    [anon_sym_into] = ACTIONS(3267),
    [anon_sym_join] = ACTIONS(3267),
    [anon_sym_on] = ACTIONS(3267),
    [anon_sym_equals] = ACTIONS(3267),
    [anon_sym_let] = ACTIONS(3267),
    [anon_sym_orderby] = ACTIONS(3267),
    [anon_sym_ascending] = ACTIONS(3267),
    [anon_sym_descending] = ACTIONS(3267),
    [anon_sym_group] = ACTIONS(3267),
    [anon_sym_by] = ACTIONS(3267),
    [anon_sym_select] = ACTIONS(3267),
    [anon_sym_DQUOTE] = ACTIONS(3267),
    [anon_sym_stackalloc] = ACTIONS(3267),
    [anon_sym_sizeof] = ACTIONS(3267),
    [anon_sym_typeof] = ACTIONS(3267),
    [anon_sym___makeref] = ACTIONS(3267),
    [anon_sym___reftype] = ACTIONS(3267),
    [anon_sym___refvalue] = ACTIONS(3267),
    [sym_null_literal] = ACTIONS(3267),
    [anon_sym_SQUOTE] = ACTIONS(3269),
    [sym_integer_literal] = ACTIONS(3267),
    [sym_real_literal] = ACTIONS(3269),
    [sym_verbatim_string_literal] = ACTIONS(3269),
    [sym_raw_string_literal] = ACTIONS(3269),
    [aux_sym_preproc_if_token1] = ACTIONS(3269),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3269),
    [sym_interpolation_verbatim_start] = ACTIONS(3269),
    [sym_interpolation_raw_start] = ACTIONS(3269),
  },
  [2713] = {
    [sym_preproc_region] = STATE(2713),
    [sym_preproc_endregion] = STATE(2713),
    [sym_preproc_line] = STATE(2713),
    [sym_preproc_pragma] = STATE(2713),
    [sym_preproc_nullable] = STATE(2713),
    [sym_preproc_error] = STATE(2713),
    [sym_preproc_define] = STATE(2713),
    [sym_preproc_undef] = STATE(2713),
    [sym__identifier_token] = ACTIONS(3355),
    [anon_sym_extern] = ACTIONS(3355),
    [anon_sym_alias] = ACTIONS(3355),
    [anon_sym_SEMI] = ACTIONS(3357),
    [anon_sym_global] = ACTIONS(3355),
    [anon_sym_using] = ACTIONS(3355),
    [anon_sym_unsafe] = ACTIONS(3355),
    [anon_sym_static] = ACTIONS(3355),
    [anon_sym_LBRACK] = ACTIONS(3357),
    [anon_sym_LPAREN] = ACTIONS(3357),
    [anon_sym_return] = ACTIONS(3355),
    [anon_sym_ref] = ACTIONS(3355),
    [anon_sym_LBRACE] = ACTIONS(3357),
    [anon_sym_RBRACE] = ACTIONS(3357),
    [anon_sym_delegate] = ACTIONS(3355),
    [anon_sym_abstract] = ACTIONS(3355),
    [anon_sym_async] = ACTIONS(3355),
    [anon_sym_const] = ACTIONS(3355),
    [anon_sym_file] = ACTIONS(3355),
    [anon_sym_fixed] = ACTIONS(3355),
    [anon_sym_internal] = ACTIONS(3355),
    [anon_sym_new] = ACTIONS(3355),
    [anon_sym_override] = ACTIONS(3355),
    [anon_sym_partial] = ACTIONS(3355),
    [anon_sym_private] = ACTIONS(3355),
    [anon_sym_protected] = ACTIONS(3355),
    [anon_sym_public] = ACTIONS(3355),
    [anon_sym_readonly] = ACTIONS(3355),
    [anon_sym_required] = ACTIONS(3355),
    [anon_sym_sealed] = ACTIONS(3355),
    [anon_sym_virtual] = ACTIONS(3355),
    [anon_sym_volatile] = ACTIONS(3355),
    [anon_sym_where] = ACTIONS(3355),
    [anon_sym_notnull] = ACTIONS(3355),
    [anon_sym_unmanaged] = ACTIONS(3355),
    [anon_sym_checked] = ACTIONS(3355),
    [anon_sym_BANG] = ACTIONS(3357),
    [anon_sym_TILDE] = ACTIONS(3357),
    [anon_sym_PLUS_PLUS] = ACTIONS(3357),
    [anon_sym_DASH_DASH] = ACTIONS(3357),
    [anon_sym_true] = ACTIONS(3355),
    [anon_sym_false] = ACTIONS(3355),
    [anon_sym_PLUS] = ACTIONS(3355),
    [anon_sym_DASH] = ACTIONS(3355),
    [anon_sym_STAR] = ACTIONS(3357),
    [anon_sym_CARET] = ACTIONS(3357),
    [anon_sym_AMP] = ACTIONS(3357),
    [anon_sym_this] = ACTIONS(3355),
    [anon_sym_scoped] = ACTIONS(3355),
    [anon_sym_var] = ACTIONS(3355),
    [sym_predefined_type] = ACTIONS(3355),
    [anon_sym_break] = ACTIONS(3355),
    [anon_sym_unchecked] = ACTIONS(3355),
    [anon_sym_continue] = ACTIONS(3355),
    [anon_sym_do] = ACTIONS(3355),
    [anon_sym_while] = ACTIONS(3355),
    [anon_sym_for] = ACTIONS(3355),
    [anon_sym_lock] = ACTIONS(3355),
    [anon_sym_yield] = ACTIONS(3355),
    [anon_sym_switch] = ACTIONS(3355),
    [anon_sym_case] = ACTIONS(3355),
    [anon_sym_default] = ACTIONS(3355),
    [anon_sym_throw] = ACTIONS(3355),
    [anon_sym_try] = ACTIONS(3355),
    [anon_sym_when] = ACTIONS(3355),
    [anon_sym_await] = ACTIONS(3355),
    [anon_sym_foreach] = ACTIONS(3355),
    [anon_sym_goto] = ACTIONS(3355),
    [anon_sym_if] = ACTIONS(3355),
    [anon_sym_else] = ACTIONS(3355),
    [anon_sym_DOT_DOT] = ACTIONS(3357),
    [anon_sym_from] = ACTIONS(3355),
    [anon_sym_into] = ACTIONS(3355),
    [anon_sym_join] = ACTIONS(3355),
    [anon_sym_on] = ACTIONS(3355),
    [anon_sym_equals] = ACTIONS(3355),
    [anon_sym_let] = ACTIONS(3355),
    [anon_sym_orderby] = ACTIONS(3355),
    [anon_sym_ascending] = ACTIONS(3355),
    [anon_sym_descending] = ACTIONS(3355),
    [anon_sym_group] = ACTIONS(3355),
    [anon_sym_by] = ACTIONS(3355),
    [anon_sym_select] = ACTIONS(3355),
    [anon_sym_DQUOTE] = ACTIONS(3355),
    [anon_sym_stackalloc] = ACTIONS(3355),
    [anon_sym_sizeof] = ACTIONS(3355),
    [anon_sym_typeof] = ACTIONS(3355),
    [anon_sym___makeref] = ACTIONS(3355),
    [anon_sym___reftype] = ACTIONS(3355),
    [anon_sym___refvalue] = ACTIONS(3355),
    [sym_null_literal] = ACTIONS(3355),
    [anon_sym_SQUOTE] = ACTIONS(3357),
    [sym_integer_literal] = ACTIONS(3355),
    [sym_real_literal] = ACTIONS(3357),
    [sym_verbatim_string_literal] = ACTIONS(3357),
    [sym_raw_string_literal] = ACTIONS(3357),
    [aux_sym_preproc_if_token1] = ACTIONS(3357),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3357),
    [sym_interpolation_verbatim_start] = ACTIONS(3357),
    [sym_interpolation_raw_start] = ACTIONS(3357),
  },
  [2714] = {
    [sym_preproc_region] = STATE(2714),
    [sym_preproc_endregion] = STATE(2714),
    [sym_preproc_line] = STATE(2714),
    [sym_preproc_pragma] = STATE(2714),
    [sym_preproc_nullable] = STATE(2714),
    [sym_preproc_error] = STATE(2714),
    [sym_preproc_define] = STATE(2714),
    [sym_preproc_undef] = STATE(2714),
    [sym__identifier_token] = ACTIONS(3049),
    [anon_sym_extern] = ACTIONS(3049),
    [anon_sym_alias] = ACTIONS(3049),
    [anon_sym_SEMI] = ACTIONS(3051),
    [anon_sym_global] = ACTIONS(3049),
    [anon_sym_using] = ACTIONS(3049),
    [anon_sym_unsafe] = ACTIONS(3049),
    [anon_sym_static] = ACTIONS(3049),
    [anon_sym_LBRACK] = ACTIONS(3051),
    [anon_sym_LPAREN] = ACTIONS(3051),
    [anon_sym_return] = ACTIONS(3049),
    [anon_sym_ref] = ACTIONS(3049),
    [anon_sym_LBRACE] = ACTIONS(3051),
    [anon_sym_RBRACE] = ACTIONS(3051),
    [anon_sym_delegate] = ACTIONS(3049),
    [anon_sym_abstract] = ACTIONS(3049),
    [anon_sym_async] = ACTIONS(3049),
    [anon_sym_const] = ACTIONS(3049),
    [anon_sym_file] = ACTIONS(3049),
    [anon_sym_fixed] = ACTIONS(3049),
    [anon_sym_internal] = ACTIONS(3049),
    [anon_sym_new] = ACTIONS(3049),
    [anon_sym_override] = ACTIONS(3049),
    [anon_sym_partial] = ACTIONS(3049),
    [anon_sym_private] = ACTIONS(3049),
    [anon_sym_protected] = ACTIONS(3049),
    [anon_sym_public] = ACTIONS(3049),
    [anon_sym_readonly] = ACTIONS(3049),
    [anon_sym_required] = ACTIONS(3049),
    [anon_sym_sealed] = ACTIONS(3049),
    [anon_sym_virtual] = ACTIONS(3049),
    [anon_sym_volatile] = ACTIONS(3049),
    [anon_sym_where] = ACTIONS(3049),
    [anon_sym_notnull] = ACTIONS(3049),
    [anon_sym_unmanaged] = ACTIONS(3049),
    [anon_sym_checked] = ACTIONS(3049),
    [anon_sym_BANG] = ACTIONS(3051),
    [anon_sym_TILDE] = ACTIONS(3051),
    [anon_sym_PLUS_PLUS] = ACTIONS(3051),
    [anon_sym_DASH_DASH] = ACTIONS(3051),
    [anon_sym_true] = ACTIONS(3049),
    [anon_sym_false] = ACTIONS(3049),
    [anon_sym_PLUS] = ACTIONS(3049),
    [anon_sym_DASH] = ACTIONS(3049),
    [anon_sym_STAR] = ACTIONS(3051),
    [anon_sym_CARET] = ACTIONS(3051),
    [anon_sym_AMP] = ACTIONS(3051),
    [anon_sym_this] = ACTIONS(3049),
    [anon_sym_scoped] = ACTIONS(3049),
    [anon_sym_var] = ACTIONS(3049),
    [sym_predefined_type] = ACTIONS(3049),
    [anon_sym_break] = ACTIONS(3049),
    [anon_sym_unchecked] = ACTIONS(3049),
    [anon_sym_continue] = ACTIONS(3049),
    [anon_sym_do] = ACTIONS(3049),
    [anon_sym_while] = ACTIONS(3049),
    [anon_sym_for] = ACTIONS(3049),
    [anon_sym_lock] = ACTIONS(3049),
    [anon_sym_yield] = ACTIONS(3049),
    [anon_sym_switch] = ACTIONS(3049),
    [anon_sym_case] = ACTIONS(3049),
    [anon_sym_default] = ACTIONS(3049),
    [anon_sym_throw] = ACTIONS(3049),
    [anon_sym_try] = ACTIONS(3049),
    [anon_sym_when] = ACTIONS(3049),
    [anon_sym_await] = ACTIONS(3049),
    [anon_sym_foreach] = ACTIONS(3049),
    [anon_sym_goto] = ACTIONS(3049),
    [anon_sym_if] = ACTIONS(3049),
    [anon_sym_else] = ACTIONS(3049),
    [anon_sym_DOT_DOT] = ACTIONS(3051),
    [anon_sym_from] = ACTIONS(3049),
    [anon_sym_into] = ACTIONS(3049),
    [anon_sym_join] = ACTIONS(3049),
    [anon_sym_on] = ACTIONS(3049),
    [anon_sym_equals] = ACTIONS(3049),
    [anon_sym_let] = ACTIONS(3049),
    [anon_sym_orderby] = ACTIONS(3049),
    [anon_sym_ascending] = ACTIONS(3049),
    [anon_sym_descending] = ACTIONS(3049),
    [anon_sym_group] = ACTIONS(3049),
    [anon_sym_by] = ACTIONS(3049),
    [anon_sym_select] = ACTIONS(3049),
    [anon_sym_DQUOTE] = ACTIONS(3049),
    [anon_sym_stackalloc] = ACTIONS(3049),
    [anon_sym_sizeof] = ACTIONS(3049),
    [anon_sym_typeof] = ACTIONS(3049),
    [anon_sym___makeref] = ACTIONS(3049),
    [anon_sym___reftype] = ACTIONS(3049),
    [anon_sym___refvalue] = ACTIONS(3049),
    [sym_null_literal] = ACTIONS(3049),
    [anon_sym_SQUOTE] = ACTIONS(3051),
    [sym_integer_literal] = ACTIONS(3049),
    [sym_real_literal] = ACTIONS(3051),
    [sym_verbatim_string_literal] = ACTIONS(3051),
    [sym_raw_string_literal] = ACTIONS(3051),
    [aux_sym_preproc_if_token1] = ACTIONS(3051),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3051),
    [sym_interpolation_verbatim_start] = ACTIONS(3051),
    [sym_interpolation_raw_start] = ACTIONS(3051),
  },
  [2715] = {
    [sym_preproc_region] = STATE(2715),
    [sym_preproc_endregion] = STATE(2715),
    [sym_preproc_line] = STATE(2715),
    [sym_preproc_pragma] = STATE(2715),
    [sym_preproc_nullable] = STATE(2715),
    [sym_preproc_error] = STATE(2715),
    [sym_preproc_define] = STATE(2715),
    [sym_preproc_undef] = STATE(2715),
    [sym__identifier_token] = ACTIONS(3045),
    [anon_sym_extern] = ACTIONS(3045),
    [anon_sym_alias] = ACTIONS(3045),
    [anon_sym_SEMI] = ACTIONS(3047),
    [anon_sym_global] = ACTIONS(3045),
    [anon_sym_using] = ACTIONS(3045),
    [anon_sym_unsafe] = ACTIONS(3045),
    [anon_sym_static] = ACTIONS(3045),
    [anon_sym_LBRACK] = ACTIONS(3047),
    [anon_sym_LPAREN] = ACTIONS(3047),
    [anon_sym_return] = ACTIONS(3045),
    [anon_sym_ref] = ACTIONS(3045),
    [anon_sym_LBRACE] = ACTIONS(3047),
    [anon_sym_RBRACE] = ACTIONS(3047),
    [anon_sym_delegate] = ACTIONS(3045),
    [anon_sym_abstract] = ACTIONS(3045),
    [anon_sym_async] = ACTIONS(3045),
    [anon_sym_const] = ACTIONS(3045),
    [anon_sym_file] = ACTIONS(3045),
    [anon_sym_fixed] = ACTIONS(3045),
    [anon_sym_internal] = ACTIONS(3045),
    [anon_sym_new] = ACTIONS(3045),
    [anon_sym_override] = ACTIONS(3045),
    [anon_sym_partial] = ACTIONS(3045),
    [anon_sym_private] = ACTIONS(3045),
    [anon_sym_protected] = ACTIONS(3045),
    [anon_sym_public] = ACTIONS(3045),
    [anon_sym_readonly] = ACTIONS(3045),
    [anon_sym_required] = ACTIONS(3045),
    [anon_sym_sealed] = ACTIONS(3045),
    [anon_sym_virtual] = ACTIONS(3045),
    [anon_sym_volatile] = ACTIONS(3045),
    [anon_sym_where] = ACTIONS(3045),
    [anon_sym_notnull] = ACTIONS(3045),
    [anon_sym_unmanaged] = ACTIONS(3045),
    [anon_sym_checked] = ACTIONS(3045),
    [anon_sym_BANG] = ACTIONS(3047),
    [anon_sym_TILDE] = ACTIONS(3047),
    [anon_sym_PLUS_PLUS] = ACTIONS(3047),
    [anon_sym_DASH_DASH] = ACTIONS(3047),
    [anon_sym_true] = ACTIONS(3045),
    [anon_sym_false] = ACTIONS(3045),
    [anon_sym_PLUS] = ACTIONS(3045),
    [anon_sym_DASH] = ACTIONS(3045),
    [anon_sym_STAR] = ACTIONS(3047),
    [anon_sym_CARET] = ACTIONS(3047),
    [anon_sym_AMP] = ACTIONS(3047),
    [anon_sym_this] = ACTIONS(3045),
    [anon_sym_scoped] = ACTIONS(3045),
    [anon_sym_var] = ACTIONS(3045),
    [sym_predefined_type] = ACTIONS(3045),
    [anon_sym_break] = ACTIONS(3045),
    [anon_sym_unchecked] = ACTIONS(3045),
    [anon_sym_continue] = ACTIONS(3045),
    [anon_sym_do] = ACTIONS(3045),
    [anon_sym_while] = ACTIONS(3045),
    [anon_sym_for] = ACTIONS(3045),
    [anon_sym_lock] = ACTIONS(3045),
    [anon_sym_yield] = ACTIONS(3045),
    [anon_sym_switch] = ACTIONS(3045),
    [anon_sym_case] = ACTIONS(3045),
    [anon_sym_default] = ACTIONS(3045),
    [anon_sym_throw] = ACTIONS(3045),
    [anon_sym_try] = ACTIONS(3045),
    [anon_sym_when] = ACTIONS(3045),
    [anon_sym_await] = ACTIONS(3045),
    [anon_sym_foreach] = ACTIONS(3045),
    [anon_sym_goto] = ACTIONS(3045),
    [anon_sym_if] = ACTIONS(3045),
    [anon_sym_else] = ACTIONS(3045),
    [anon_sym_DOT_DOT] = ACTIONS(3047),
    [anon_sym_from] = ACTIONS(3045),
    [anon_sym_into] = ACTIONS(3045),
    [anon_sym_join] = ACTIONS(3045),
    [anon_sym_on] = ACTIONS(3045),
    [anon_sym_equals] = ACTIONS(3045),
    [anon_sym_let] = ACTIONS(3045),
    [anon_sym_orderby] = ACTIONS(3045),
    [anon_sym_ascending] = ACTIONS(3045),
    [anon_sym_descending] = ACTIONS(3045),
    [anon_sym_group] = ACTIONS(3045),
    [anon_sym_by] = ACTIONS(3045),
    [anon_sym_select] = ACTIONS(3045),
    [anon_sym_DQUOTE] = ACTIONS(3045),
    [anon_sym_stackalloc] = ACTIONS(3045),
    [anon_sym_sizeof] = ACTIONS(3045),
    [anon_sym_typeof] = ACTIONS(3045),
    [anon_sym___makeref] = ACTIONS(3045),
    [anon_sym___reftype] = ACTIONS(3045),
    [anon_sym___refvalue] = ACTIONS(3045),
    [sym_null_literal] = ACTIONS(3045),
    [anon_sym_SQUOTE] = ACTIONS(3047),
    [sym_integer_literal] = ACTIONS(3045),
    [sym_real_literal] = ACTIONS(3047),
    [sym_verbatim_string_literal] = ACTIONS(3047),
    [sym_raw_string_literal] = ACTIONS(3047),
    [aux_sym_preproc_if_token1] = ACTIONS(3047),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3047),
    [sym_interpolation_verbatim_start] = ACTIONS(3047),
    [sym_interpolation_raw_start] = ACTIONS(3047),
  },
  [2716] = {
    [sym_preproc_region] = STATE(2716),
    [sym_preproc_endregion] = STATE(2716),
    [sym_preproc_line] = STATE(2716),
    [sym_preproc_pragma] = STATE(2716),
    [sym_preproc_nullable] = STATE(2716),
    [sym_preproc_error] = STATE(2716),
    [sym_preproc_define] = STATE(2716),
    [sym_preproc_undef] = STATE(2716),
    [sym__identifier_token] = ACTIONS(3359),
    [anon_sym_extern] = ACTIONS(3359),
    [anon_sym_alias] = ACTIONS(3359),
    [anon_sym_SEMI] = ACTIONS(3361),
    [anon_sym_global] = ACTIONS(3359),
    [anon_sym_using] = ACTIONS(3359),
    [anon_sym_unsafe] = ACTIONS(3359),
    [anon_sym_static] = ACTIONS(3359),
    [anon_sym_LBRACK] = ACTIONS(3361),
    [anon_sym_LPAREN] = ACTIONS(3361),
    [anon_sym_return] = ACTIONS(3359),
    [anon_sym_ref] = ACTIONS(3359),
    [anon_sym_LBRACE] = ACTIONS(3361),
    [anon_sym_RBRACE] = ACTIONS(3361),
    [anon_sym_delegate] = ACTIONS(3359),
    [anon_sym_abstract] = ACTIONS(3359),
    [anon_sym_async] = ACTIONS(3359),
    [anon_sym_const] = ACTIONS(3359),
    [anon_sym_file] = ACTIONS(3359),
    [anon_sym_fixed] = ACTIONS(3359),
    [anon_sym_internal] = ACTIONS(3359),
    [anon_sym_new] = ACTIONS(3359),
    [anon_sym_override] = ACTIONS(3359),
    [anon_sym_partial] = ACTIONS(3359),
    [anon_sym_private] = ACTIONS(3359),
    [anon_sym_protected] = ACTIONS(3359),
    [anon_sym_public] = ACTIONS(3359),
    [anon_sym_readonly] = ACTIONS(3359),
    [anon_sym_required] = ACTIONS(3359),
    [anon_sym_sealed] = ACTIONS(3359),
    [anon_sym_virtual] = ACTIONS(3359),
    [anon_sym_volatile] = ACTIONS(3359),
    [anon_sym_where] = ACTIONS(3359),
    [anon_sym_notnull] = ACTIONS(3359),
    [anon_sym_unmanaged] = ACTIONS(3359),
    [anon_sym_checked] = ACTIONS(3359),
    [anon_sym_BANG] = ACTIONS(3361),
    [anon_sym_TILDE] = ACTIONS(3361),
    [anon_sym_PLUS_PLUS] = ACTIONS(3361),
    [anon_sym_DASH_DASH] = ACTIONS(3361),
    [anon_sym_true] = ACTIONS(3359),
    [anon_sym_false] = ACTIONS(3359),
    [anon_sym_PLUS] = ACTIONS(3359),
    [anon_sym_DASH] = ACTIONS(3359),
    [anon_sym_STAR] = ACTIONS(3361),
    [anon_sym_CARET] = ACTIONS(3361),
    [anon_sym_AMP] = ACTIONS(3361),
    [anon_sym_this] = ACTIONS(3359),
    [anon_sym_scoped] = ACTIONS(3359),
    [anon_sym_var] = ACTIONS(3359),
    [sym_predefined_type] = ACTIONS(3359),
    [anon_sym_break] = ACTIONS(3359),
    [anon_sym_unchecked] = ACTIONS(3359),
    [anon_sym_continue] = ACTIONS(3359),
    [anon_sym_do] = ACTIONS(3359),
    [anon_sym_while] = ACTIONS(3359),
    [anon_sym_for] = ACTIONS(3359),
    [anon_sym_lock] = ACTIONS(3359),
    [anon_sym_yield] = ACTIONS(3359),
    [anon_sym_switch] = ACTIONS(3359),
    [anon_sym_case] = ACTIONS(3359),
    [anon_sym_default] = ACTIONS(3359),
    [anon_sym_throw] = ACTIONS(3359),
    [anon_sym_try] = ACTIONS(3359),
    [anon_sym_when] = ACTIONS(3359),
    [anon_sym_await] = ACTIONS(3359),
    [anon_sym_foreach] = ACTIONS(3359),
    [anon_sym_goto] = ACTIONS(3359),
    [anon_sym_if] = ACTIONS(3359),
    [anon_sym_else] = ACTIONS(3359),
    [anon_sym_DOT_DOT] = ACTIONS(3361),
    [anon_sym_from] = ACTIONS(3359),
    [anon_sym_into] = ACTIONS(3359),
    [anon_sym_join] = ACTIONS(3359),
    [anon_sym_on] = ACTIONS(3359),
    [anon_sym_equals] = ACTIONS(3359),
    [anon_sym_let] = ACTIONS(3359),
    [anon_sym_orderby] = ACTIONS(3359),
    [anon_sym_ascending] = ACTIONS(3359),
    [anon_sym_descending] = ACTIONS(3359),
    [anon_sym_group] = ACTIONS(3359),
    [anon_sym_by] = ACTIONS(3359),
    [anon_sym_select] = ACTIONS(3359),
    [anon_sym_DQUOTE] = ACTIONS(3359),
    [anon_sym_stackalloc] = ACTIONS(3359),
    [anon_sym_sizeof] = ACTIONS(3359),
    [anon_sym_typeof] = ACTIONS(3359),
    [anon_sym___makeref] = ACTIONS(3359),
    [anon_sym___reftype] = ACTIONS(3359),
    [anon_sym___refvalue] = ACTIONS(3359),
    [sym_null_literal] = ACTIONS(3359),
    [anon_sym_SQUOTE] = ACTIONS(3361),
    [sym_integer_literal] = ACTIONS(3359),
    [sym_real_literal] = ACTIONS(3361),
    [sym_verbatim_string_literal] = ACTIONS(3361),
    [sym_raw_string_literal] = ACTIONS(3361),
    [aux_sym_preproc_if_token1] = ACTIONS(3361),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3361),
    [sym_interpolation_verbatim_start] = ACTIONS(3361),
    [sym_interpolation_raw_start] = ACTIONS(3361),
  },
  [2717] = {
    [sym_preproc_region] = STATE(2717),
    [sym_preproc_endregion] = STATE(2717),
    [sym_preproc_line] = STATE(2717),
    [sym_preproc_pragma] = STATE(2717),
    [sym_preproc_nullable] = STATE(2717),
    [sym_preproc_error] = STATE(2717),
    [sym_preproc_define] = STATE(2717),
    [sym_preproc_undef] = STATE(2717),
    [sym__identifier_token] = ACTIONS(3363),
    [anon_sym_extern] = ACTIONS(3363),
    [anon_sym_alias] = ACTIONS(3363),
    [anon_sym_SEMI] = ACTIONS(3365),
    [anon_sym_global] = ACTIONS(3363),
    [anon_sym_using] = ACTIONS(3363),
    [anon_sym_unsafe] = ACTIONS(3363),
    [anon_sym_static] = ACTIONS(3363),
    [anon_sym_LBRACK] = ACTIONS(3365),
    [anon_sym_LPAREN] = ACTIONS(3365),
    [anon_sym_return] = ACTIONS(3363),
    [anon_sym_ref] = ACTIONS(3363),
    [anon_sym_LBRACE] = ACTIONS(3365),
    [anon_sym_RBRACE] = ACTIONS(3365),
    [anon_sym_delegate] = ACTIONS(3363),
    [anon_sym_abstract] = ACTIONS(3363),
    [anon_sym_async] = ACTIONS(3363),
    [anon_sym_const] = ACTIONS(3363),
    [anon_sym_file] = ACTIONS(3363),
    [anon_sym_fixed] = ACTIONS(3363),
    [anon_sym_internal] = ACTIONS(3363),
    [anon_sym_new] = ACTIONS(3363),
    [anon_sym_override] = ACTIONS(3363),
    [anon_sym_partial] = ACTIONS(3363),
    [anon_sym_private] = ACTIONS(3363),
    [anon_sym_protected] = ACTIONS(3363),
    [anon_sym_public] = ACTIONS(3363),
    [anon_sym_readonly] = ACTIONS(3363),
    [anon_sym_required] = ACTIONS(3363),
    [anon_sym_sealed] = ACTIONS(3363),
    [anon_sym_virtual] = ACTIONS(3363),
    [anon_sym_volatile] = ACTIONS(3363),
    [anon_sym_where] = ACTIONS(3363),
    [anon_sym_notnull] = ACTIONS(3363),
    [anon_sym_unmanaged] = ACTIONS(3363),
    [anon_sym_checked] = ACTIONS(3363),
    [anon_sym_BANG] = ACTIONS(3365),
    [anon_sym_TILDE] = ACTIONS(3365),
    [anon_sym_PLUS_PLUS] = ACTIONS(3365),
    [anon_sym_DASH_DASH] = ACTIONS(3365),
    [anon_sym_true] = ACTIONS(3363),
    [anon_sym_false] = ACTIONS(3363),
    [anon_sym_PLUS] = ACTIONS(3363),
    [anon_sym_DASH] = ACTIONS(3363),
    [anon_sym_STAR] = ACTIONS(3365),
    [anon_sym_CARET] = ACTIONS(3365),
    [anon_sym_AMP] = ACTIONS(3365),
    [anon_sym_this] = ACTIONS(3363),
    [anon_sym_scoped] = ACTIONS(3363),
    [anon_sym_var] = ACTIONS(3363),
    [sym_predefined_type] = ACTIONS(3363),
    [anon_sym_break] = ACTIONS(3363),
    [anon_sym_unchecked] = ACTIONS(3363),
    [anon_sym_continue] = ACTIONS(3363),
    [anon_sym_do] = ACTIONS(3363),
    [anon_sym_while] = ACTIONS(3363),
    [anon_sym_for] = ACTIONS(3363),
    [anon_sym_lock] = ACTIONS(3363),
    [anon_sym_yield] = ACTIONS(3363),
    [anon_sym_switch] = ACTIONS(3363),
    [anon_sym_case] = ACTIONS(3363),
    [anon_sym_default] = ACTIONS(3363),
    [anon_sym_throw] = ACTIONS(3363),
    [anon_sym_try] = ACTIONS(3363),
    [anon_sym_when] = ACTIONS(3363),
    [anon_sym_await] = ACTIONS(3363),
    [anon_sym_foreach] = ACTIONS(3363),
    [anon_sym_goto] = ACTIONS(3363),
    [anon_sym_if] = ACTIONS(3363),
    [anon_sym_else] = ACTIONS(3363),
    [anon_sym_DOT_DOT] = ACTIONS(3365),
    [anon_sym_from] = ACTIONS(3363),
    [anon_sym_into] = ACTIONS(3363),
    [anon_sym_join] = ACTIONS(3363),
    [anon_sym_on] = ACTIONS(3363),
    [anon_sym_equals] = ACTIONS(3363),
    [anon_sym_let] = ACTIONS(3363),
    [anon_sym_orderby] = ACTIONS(3363),
    [anon_sym_ascending] = ACTIONS(3363),
    [anon_sym_descending] = ACTIONS(3363),
    [anon_sym_group] = ACTIONS(3363),
    [anon_sym_by] = ACTIONS(3363),
    [anon_sym_select] = ACTIONS(3363),
    [anon_sym_DQUOTE] = ACTIONS(3363),
    [anon_sym_stackalloc] = ACTIONS(3363),
    [anon_sym_sizeof] = ACTIONS(3363),
    [anon_sym_typeof] = ACTIONS(3363),
    [anon_sym___makeref] = ACTIONS(3363),
    [anon_sym___reftype] = ACTIONS(3363),
    [anon_sym___refvalue] = ACTIONS(3363),
    [sym_null_literal] = ACTIONS(3363),
    [anon_sym_SQUOTE] = ACTIONS(3365),
    [sym_integer_literal] = ACTIONS(3363),
    [sym_real_literal] = ACTIONS(3365),
    [sym_verbatim_string_literal] = ACTIONS(3365),
    [sym_raw_string_literal] = ACTIONS(3365),
    [aux_sym_preproc_if_token1] = ACTIONS(3365),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3365),
    [sym_interpolation_verbatim_start] = ACTIONS(3365),
    [sym_interpolation_raw_start] = ACTIONS(3365),
  },
  [2718] = {
    [sym_preproc_region] = STATE(2718),
    [sym_preproc_endregion] = STATE(2718),
    [sym_preproc_line] = STATE(2718),
    [sym_preproc_pragma] = STATE(2718),
    [sym_preproc_nullable] = STATE(2718),
    [sym_preproc_error] = STATE(2718),
    [sym_preproc_define] = STATE(2718),
    [sym_preproc_undef] = STATE(2718),
    [sym__identifier_token] = ACTIONS(3227),
    [anon_sym_extern] = ACTIONS(3227),
    [anon_sym_alias] = ACTIONS(3227),
    [anon_sym_SEMI] = ACTIONS(3229),
    [anon_sym_global] = ACTIONS(3227),
    [anon_sym_using] = ACTIONS(3227),
    [anon_sym_unsafe] = ACTIONS(3227),
    [anon_sym_static] = ACTIONS(3227),
    [anon_sym_LBRACK] = ACTIONS(3229),
    [anon_sym_LPAREN] = ACTIONS(3229),
    [anon_sym_return] = ACTIONS(3227),
    [anon_sym_ref] = ACTIONS(3227),
    [anon_sym_LBRACE] = ACTIONS(3229),
    [anon_sym_RBRACE] = ACTIONS(3229),
    [anon_sym_delegate] = ACTIONS(3227),
    [anon_sym_abstract] = ACTIONS(3227),
    [anon_sym_async] = ACTIONS(3227),
    [anon_sym_const] = ACTIONS(3227),
    [anon_sym_file] = ACTIONS(3227),
    [anon_sym_fixed] = ACTIONS(3227),
    [anon_sym_internal] = ACTIONS(3227),
    [anon_sym_new] = ACTIONS(3227),
    [anon_sym_override] = ACTIONS(3227),
    [anon_sym_partial] = ACTIONS(3227),
    [anon_sym_private] = ACTIONS(3227),
    [anon_sym_protected] = ACTIONS(3227),
    [anon_sym_public] = ACTIONS(3227),
    [anon_sym_readonly] = ACTIONS(3227),
    [anon_sym_required] = ACTIONS(3227),
    [anon_sym_sealed] = ACTIONS(3227),
    [anon_sym_virtual] = ACTIONS(3227),
    [anon_sym_volatile] = ACTIONS(3227),
    [anon_sym_where] = ACTIONS(3227),
    [anon_sym_notnull] = ACTIONS(3227),
    [anon_sym_unmanaged] = ACTIONS(3227),
    [anon_sym_checked] = ACTIONS(3227),
    [anon_sym_BANG] = ACTIONS(3229),
    [anon_sym_TILDE] = ACTIONS(3229),
    [anon_sym_PLUS_PLUS] = ACTIONS(3229),
    [anon_sym_DASH_DASH] = ACTIONS(3229),
    [anon_sym_true] = ACTIONS(3227),
    [anon_sym_false] = ACTIONS(3227),
    [anon_sym_PLUS] = ACTIONS(3227),
    [anon_sym_DASH] = ACTIONS(3227),
    [anon_sym_STAR] = ACTIONS(3229),
    [anon_sym_CARET] = ACTIONS(3229),
    [anon_sym_AMP] = ACTIONS(3229),
    [anon_sym_this] = ACTIONS(3227),
    [anon_sym_scoped] = ACTIONS(3227),
    [anon_sym_var] = ACTIONS(3227),
    [sym_predefined_type] = ACTIONS(3227),
    [anon_sym_break] = ACTIONS(3227),
    [anon_sym_unchecked] = ACTIONS(3227),
    [anon_sym_continue] = ACTIONS(3227),
    [anon_sym_do] = ACTIONS(3227),
    [anon_sym_while] = ACTIONS(3227),
    [anon_sym_for] = ACTIONS(3227),
    [anon_sym_lock] = ACTIONS(3227),
    [anon_sym_yield] = ACTIONS(3227),
    [anon_sym_switch] = ACTIONS(3227),
    [anon_sym_case] = ACTIONS(3227),
    [anon_sym_default] = ACTIONS(3227),
    [anon_sym_throw] = ACTIONS(3227),
    [anon_sym_try] = ACTIONS(3227),
    [anon_sym_when] = ACTIONS(3227),
    [anon_sym_await] = ACTIONS(3227),
    [anon_sym_foreach] = ACTIONS(3227),
    [anon_sym_goto] = ACTIONS(3227),
    [anon_sym_if] = ACTIONS(3227),
    [anon_sym_else] = ACTIONS(3227),
    [anon_sym_DOT_DOT] = ACTIONS(3229),
    [anon_sym_from] = ACTIONS(3227),
    [anon_sym_into] = ACTIONS(3227),
    [anon_sym_join] = ACTIONS(3227),
    [anon_sym_on] = ACTIONS(3227),
    [anon_sym_equals] = ACTIONS(3227),
    [anon_sym_let] = ACTIONS(3227),
    [anon_sym_orderby] = ACTIONS(3227),
    [anon_sym_ascending] = ACTIONS(3227),
    [anon_sym_descending] = ACTIONS(3227),
    [anon_sym_group] = ACTIONS(3227),
    [anon_sym_by] = ACTIONS(3227),
    [anon_sym_select] = ACTIONS(3227),
    [anon_sym_DQUOTE] = ACTIONS(3227),
    [anon_sym_stackalloc] = ACTIONS(3227),
    [anon_sym_sizeof] = ACTIONS(3227),
    [anon_sym_typeof] = ACTIONS(3227),
    [anon_sym___makeref] = ACTIONS(3227),
    [anon_sym___reftype] = ACTIONS(3227),
    [anon_sym___refvalue] = ACTIONS(3227),
    [sym_null_literal] = ACTIONS(3227),
    [anon_sym_SQUOTE] = ACTIONS(3229),
    [sym_integer_literal] = ACTIONS(3227),
    [sym_real_literal] = ACTIONS(3229),
    [sym_verbatim_string_literal] = ACTIONS(3229),
    [sym_raw_string_literal] = ACTIONS(3229),
    [aux_sym_preproc_if_token1] = ACTIONS(3229),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3229),
    [sym_interpolation_verbatim_start] = ACTIONS(3229),
    [sym_interpolation_raw_start] = ACTIONS(3229),
  },
  [2719] = {
    [sym_preproc_region] = STATE(2719),
    [sym_preproc_endregion] = STATE(2719),
    [sym_preproc_line] = STATE(2719),
    [sym_preproc_pragma] = STATE(2719),
    [sym_preproc_nullable] = STATE(2719),
    [sym_preproc_error] = STATE(2719),
    [sym_preproc_define] = STATE(2719),
    [sym_preproc_undef] = STATE(2719),
    [sym__identifier_token] = ACTIONS(3223),
    [anon_sym_extern] = ACTIONS(3223),
    [anon_sym_alias] = ACTIONS(3223),
    [anon_sym_SEMI] = ACTIONS(3225),
    [anon_sym_global] = ACTIONS(3223),
    [anon_sym_using] = ACTIONS(3223),
    [anon_sym_unsafe] = ACTIONS(3223),
    [anon_sym_static] = ACTIONS(3223),
    [anon_sym_LBRACK] = ACTIONS(3225),
    [anon_sym_LPAREN] = ACTIONS(3225),
    [anon_sym_return] = ACTIONS(3223),
    [anon_sym_ref] = ACTIONS(3223),
    [anon_sym_LBRACE] = ACTIONS(3225),
    [anon_sym_RBRACE] = ACTIONS(3225),
    [anon_sym_delegate] = ACTIONS(3223),
    [anon_sym_abstract] = ACTIONS(3223),
    [anon_sym_async] = ACTIONS(3223),
    [anon_sym_const] = ACTIONS(3223),
    [anon_sym_file] = ACTIONS(3223),
    [anon_sym_fixed] = ACTIONS(3223),
    [anon_sym_internal] = ACTIONS(3223),
    [anon_sym_new] = ACTIONS(3223),
    [anon_sym_override] = ACTIONS(3223),
    [anon_sym_partial] = ACTIONS(3223),
    [anon_sym_private] = ACTIONS(3223),
    [anon_sym_protected] = ACTIONS(3223),
    [anon_sym_public] = ACTIONS(3223),
    [anon_sym_readonly] = ACTIONS(3223),
    [anon_sym_required] = ACTIONS(3223),
    [anon_sym_sealed] = ACTIONS(3223),
    [anon_sym_virtual] = ACTIONS(3223),
    [anon_sym_volatile] = ACTIONS(3223),
    [anon_sym_where] = ACTIONS(3223),
    [anon_sym_notnull] = ACTIONS(3223),
    [anon_sym_unmanaged] = ACTIONS(3223),
    [anon_sym_checked] = ACTIONS(3223),
    [anon_sym_BANG] = ACTIONS(3225),
    [anon_sym_TILDE] = ACTIONS(3225),
    [anon_sym_PLUS_PLUS] = ACTIONS(3225),
    [anon_sym_DASH_DASH] = ACTIONS(3225),
    [anon_sym_true] = ACTIONS(3223),
    [anon_sym_false] = ACTIONS(3223),
    [anon_sym_PLUS] = ACTIONS(3223),
    [anon_sym_DASH] = ACTIONS(3223),
    [anon_sym_STAR] = ACTIONS(3225),
    [anon_sym_CARET] = ACTIONS(3225),
    [anon_sym_AMP] = ACTIONS(3225),
    [anon_sym_this] = ACTIONS(3223),
    [anon_sym_scoped] = ACTIONS(3223),
    [anon_sym_var] = ACTIONS(3223),
    [sym_predefined_type] = ACTIONS(3223),
    [anon_sym_break] = ACTIONS(3223),
    [anon_sym_unchecked] = ACTIONS(3223),
    [anon_sym_continue] = ACTIONS(3223),
    [anon_sym_do] = ACTIONS(3223),
    [anon_sym_while] = ACTIONS(3223),
    [anon_sym_for] = ACTIONS(3223),
    [anon_sym_lock] = ACTIONS(3223),
    [anon_sym_yield] = ACTIONS(3223),
    [anon_sym_switch] = ACTIONS(3223),
    [anon_sym_case] = ACTIONS(3223),
    [anon_sym_default] = ACTIONS(3223),
    [anon_sym_throw] = ACTIONS(3223),
    [anon_sym_try] = ACTIONS(3223),
    [anon_sym_when] = ACTIONS(3223),
    [anon_sym_await] = ACTIONS(3223),
    [anon_sym_foreach] = ACTIONS(3223),
    [anon_sym_goto] = ACTIONS(3223),
    [anon_sym_if] = ACTIONS(3223),
    [anon_sym_else] = ACTIONS(3223),
    [anon_sym_DOT_DOT] = ACTIONS(3225),
    [anon_sym_from] = ACTIONS(3223),
    [anon_sym_into] = ACTIONS(3223),
    [anon_sym_join] = ACTIONS(3223),
    [anon_sym_on] = ACTIONS(3223),
    [anon_sym_equals] = ACTIONS(3223),
    [anon_sym_let] = ACTIONS(3223),
    [anon_sym_orderby] = ACTIONS(3223),
    [anon_sym_ascending] = ACTIONS(3223),
    [anon_sym_descending] = ACTIONS(3223),
    [anon_sym_group] = ACTIONS(3223),
    [anon_sym_by] = ACTIONS(3223),
    [anon_sym_select] = ACTIONS(3223),
    [anon_sym_DQUOTE] = ACTIONS(3223),
    [anon_sym_stackalloc] = ACTIONS(3223),
    [anon_sym_sizeof] = ACTIONS(3223),
    [anon_sym_typeof] = ACTIONS(3223),
    [anon_sym___makeref] = ACTIONS(3223),
    [anon_sym___reftype] = ACTIONS(3223),
    [anon_sym___refvalue] = ACTIONS(3223),
    [sym_null_literal] = ACTIONS(3223),
    [anon_sym_SQUOTE] = ACTIONS(3225),
    [sym_integer_literal] = ACTIONS(3223),
    [sym_real_literal] = ACTIONS(3225),
    [sym_verbatim_string_literal] = ACTIONS(3225),
    [sym_raw_string_literal] = ACTIONS(3225),
    [aux_sym_preproc_if_token1] = ACTIONS(3225),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3225),
    [sym_interpolation_verbatim_start] = ACTIONS(3225),
    [sym_interpolation_raw_start] = ACTIONS(3225),
  },
  [2720] = {
    [sym_preproc_region] = STATE(2720),
    [sym_preproc_endregion] = STATE(2720),
    [sym_preproc_line] = STATE(2720),
    [sym_preproc_pragma] = STATE(2720),
    [sym_preproc_nullable] = STATE(2720),
    [sym_preproc_error] = STATE(2720),
    [sym_preproc_define] = STATE(2720),
    [sym_preproc_undef] = STATE(2720),
    [sym__identifier_token] = ACTIONS(3295),
    [anon_sym_extern] = ACTIONS(3295),
    [anon_sym_alias] = ACTIONS(3295),
    [anon_sym_SEMI] = ACTIONS(3297),
    [anon_sym_global] = ACTIONS(3295),
    [anon_sym_using] = ACTIONS(3295),
    [anon_sym_unsafe] = ACTIONS(3295),
    [anon_sym_static] = ACTIONS(3295),
    [anon_sym_LBRACK] = ACTIONS(3297),
    [anon_sym_LPAREN] = ACTIONS(3297),
    [anon_sym_return] = ACTIONS(3295),
    [anon_sym_ref] = ACTIONS(3295),
    [anon_sym_LBRACE] = ACTIONS(3297),
    [anon_sym_RBRACE] = ACTIONS(3297),
    [anon_sym_delegate] = ACTIONS(3295),
    [anon_sym_abstract] = ACTIONS(3295),
    [anon_sym_async] = ACTIONS(3295),
    [anon_sym_const] = ACTIONS(3295),
    [anon_sym_file] = ACTIONS(3295),
    [anon_sym_fixed] = ACTIONS(3295),
    [anon_sym_internal] = ACTIONS(3295),
    [anon_sym_new] = ACTIONS(3295),
    [anon_sym_override] = ACTIONS(3295),
    [anon_sym_partial] = ACTIONS(3295),
    [anon_sym_private] = ACTIONS(3295),
    [anon_sym_protected] = ACTIONS(3295),
    [anon_sym_public] = ACTIONS(3295),
    [anon_sym_readonly] = ACTIONS(3295),
    [anon_sym_required] = ACTIONS(3295),
    [anon_sym_sealed] = ACTIONS(3295),
    [anon_sym_virtual] = ACTIONS(3295),
    [anon_sym_volatile] = ACTIONS(3295),
    [anon_sym_where] = ACTIONS(3295),
    [anon_sym_notnull] = ACTIONS(3295),
    [anon_sym_unmanaged] = ACTIONS(3295),
    [anon_sym_checked] = ACTIONS(3295),
    [anon_sym_BANG] = ACTIONS(3297),
    [anon_sym_TILDE] = ACTIONS(3297),
    [anon_sym_PLUS_PLUS] = ACTIONS(3297),
    [anon_sym_DASH_DASH] = ACTIONS(3297),
    [anon_sym_true] = ACTIONS(3295),
    [anon_sym_false] = ACTIONS(3295),
    [anon_sym_PLUS] = ACTIONS(3295),
    [anon_sym_DASH] = ACTIONS(3295),
    [anon_sym_STAR] = ACTIONS(3297),
    [anon_sym_CARET] = ACTIONS(3297),
    [anon_sym_AMP] = ACTIONS(3297),
    [anon_sym_this] = ACTIONS(3295),
    [anon_sym_scoped] = ACTIONS(3295),
    [anon_sym_var] = ACTIONS(3295),
    [sym_predefined_type] = ACTIONS(3295),
    [anon_sym_break] = ACTIONS(3295),
    [anon_sym_unchecked] = ACTIONS(3295),
    [anon_sym_continue] = ACTIONS(3295),
    [anon_sym_do] = ACTIONS(3295),
    [anon_sym_while] = ACTIONS(3295),
    [anon_sym_for] = ACTIONS(3295),
    [anon_sym_lock] = ACTIONS(3295),
    [anon_sym_yield] = ACTIONS(3295),
    [anon_sym_switch] = ACTIONS(3295),
    [anon_sym_case] = ACTIONS(3295),
    [anon_sym_default] = ACTIONS(3295),
    [anon_sym_throw] = ACTIONS(3295),
    [anon_sym_try] = ACTIONS(3295),
    [anon_sym_when] = ACTIONS(3295),
    [anon_sym_await] = ACTIONS(3295),
    [anon_sym_foreach] = ACTIONS(3295),
    [anon_sym_goto] = ACTIONS(3295),
    [anon_sym_if] = ACTIONS(3295),
    [anon_sym_else] = ACTIONS(3295),
    [anon_sym_DOT_DOT] = ACTIONS(3297),
    [anon_sym_from] = ACTIONS(3295),
    [anon_sym_into] = ACTIONS(3295),
    [anon_sym_join] = ACTIONS(3295),
    [anon_sym_on] = ACTIONS(3295),
    [anon_sym_equals] = ACTIONS(3295),
    [anon_sym_let] = ACTIONS(3295),
    [anon_sym_orderby] = ACTIONS(3295),
    [anon_sym_ascending] = ACTIONS(3295),
    [anon_sym_descending] = ACTIONS(3295),
    [anon_sym_group] = ACTIONS(3295),
    [anon_sym_by] = ACTIONS(3295),
    [anon_sym_select] = ACTIONS(3295),
    [anon_sym_DQUOTE] = ACTIONS(3295),
    [anon_sym_stackalloc] = ACTIONS(3295),
    [anon_sym_sizeof] = ACTIONS(3295),
    [anon_sym_typeof] = ACTIONS(3295),
    [anon_sym___makeref] = ACTIONS(3295),
    [anon_sym___reftype] = ACTIONS(3295),
    [anon_sym___refvalue] = ACTIONS(3295),
    [sym_null_literal] = ACTIONS(3295),
    [anon_sym_SQUOTE] = ACTIONS(3297),
    [sym_integer_literal] = ACTIONS(3295),
    [sym_real_literal] = ACTIONS(3297),
    [sym_verbatim_string_literal] = ACTIONS(3297),
    [sym_raw_string_literal] = ACTIONS(3297),
    [aux_sym_preproc_if_token1] = ACTIONS(3297),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3297),
    [sym_interpolation_verbatim_start] = ACTIONS(3297),
    [sym_interpolation_raw_start] = ACTIONS(3297),
  },
  [2721] = {
    [sym_preproc_region] = STATE(2721),
    [sym_preproc_endregion] = STATE(2721),
    [sym_preproc_line] = STATE(2721),
    [sym_preproc_pragma] = STATE(2721),
    [sym_preproc_nullable] = STATE(2721),
    [sym_preproc_error] = STATE(2721),
    [sym_preproc_define] = STATE(2721),
    [sym_preproc_undef] = STATE(2721),
    [sym__identifier_token] = ACTIONS(3983),
    [anon_sym_extern] = ACTIONS(3983),
    [anon_sym_alias] = ACTIONS(3983),
    [anon_sym_SEMI] = ACTIONS(3985),
    [anon_sym_global] = ACTIONS(3983),
    [anon_sym_using] = ACTIONS(3983),
    [anon_sym_unsafe] = ACTIONS(3983),
    [anon_sym_static] = ACTIONS(3983),
    [anon_sym_LBRACK] = ACTIONS(3985),
    [anon_sym_LPAREN] = ACTIONS(3985),
    [anon_sym_return] = ACTIONS(3983),
    [anon_sym_ref] = ACTIONS(3983),
    [anon_sym_LBRACE] = ACTIONS(3985),
    [anon_sym_RBRACE] = ACTIONS(3985),
    [anon_sym_delegate] = ACTIONS(3983),
    [anon_sym_abstract] = ACTIONS(3983),
    [anon_sym_async] = ACTIONS(3983),
    [anon_sym_const] = ACTIONS(3983),
    [anon_sym_file] = ACTIONS(3983),
    [anon_sym_fixed] = ACTIONS(3983),
    [anon_sym_internal] = ACTIONS(3983),
    [anon_sym_new] = ACTIONS(3983),
    [anon_sym_override] = ACTIONS(3983),
    [anon_sym_partial] = ACTIONS(3983),
    [anon_sym_private] = ACTIONS(3983),
    [anon_sym_protected] = ACTIONS(3983),
    [anon_sym_public] = ACTIONS(3983),
    [anon_sym_readonly] = ACTIONS(3983),
    [anon_sym_required] = ACTIONS(3983),
    [anon_sym_sealed] = ACTIONS(3983),
    [anon_sym_virtual] = ACTIONS(3983),
    [anon_sym_volatile] = ACTIONS(3983),
    [anon_sym_where] = ACTIONS(3983),
    [anon_sym_notnull] = ACTIONS(3983),
    [anon_sym_unmanaged] = ACTIONS(3983),
    [anon_sym_checked] = ACTIONS(3983),
    [anon_sym_BANG] = ACTIONS(3985),
    [anon_sym_TILDE] = ACTIONS(3985),
    [anon_sym_PLUS_PLUS] = ACTIONS(3985),
    [anon_sym_DASH_DASH] = ACTIONS(3985),
    [anon_sym_true] = ACTIONS(3983),
    [anon_sym_false] = ACTIONS(3983),
    [anon_sym_PLUS] = ACTIONS(3983),
    [anon_sym_DASH] = ACTIONS(3983),
    [anon_sym_STAR] = ACTIONS(3985),
    [anon_sym_CARET] = ACTIONS(3985),
    [anon_sym_AMP] = ACTIONS(3985),
    [anon_sym_this] = ACTIONS(3983),
    [anon_sym_scoped] = ACTIONS(3983),
    [anon_sym_var] = ACTIONS(3983),
    [sym_predefined_type] = ACTIONS(3983),
    [anon_sym_break] = ACTIONS(3983),
    [anon_sym_unchecked] = ACTIONS(3983),
    [anon_sym_continue] = ACTIONS(3983),
    [anon_sym_do] = ACTIONS(3983),
    [anon_sym_while] = ACTIONS(3983),
    [anon_sym_for] = ACTIONS(3983),
    [anon_sym_lock] = ACTIONS(3983),
    [anon_sym_yield] = ACTIONS(3983),
    [anon_sym_switch] = ACTIONS(3983),
    [anon_sym_case] = ACTIONS(3983),
    [anon_sym_default] = ACTIONS(3983),
    [anon_sym_throw] = ACTIONS(3983),
    [anon_sym_try] = ACTIONS(3983),
    [anon_sym_when] = ACTIONS(3983),
    [anon_sym_await] = ACTIONS(3983),
    [anon_sym_foreach] = ACTIONS(3983),
    [anon_sym_goto] = ACTIONS(3983),
    [anon_sym_if] = ACTIONS(3983),
    [anon_sym_DOT_DOT] = ACTIONS(3985),
    [anon_sym_from] = ACTIONS(3983),
    [anon_sym_into] = ACTIONS(3983),
    [anon_sym_join] = ACTIONS(3983),
    [anon_sym_on] = ACTIONS(3983),
    [anon_sym_equals] = ACTIONS(3983),
    [anon_sym_let] = ACTIONS(3983),
    [anon_sym_orderby] = ACTIONS(3983),
    [anon_sym_ascending] = ACTIONS(3983),
    [anon_sym_descending] = ACTIONS(3983),
    [anon_sym_group] = ACTIONS(3983),
    [anon_sym_by] = ACTIONS(3983),
    [anon_sym_select] = ACTIONS(3983),
    [anon_sym_DQUOTE] = ACTIONS(3983),
    [anon_sym_stackalloc] = ACTIONS(3983),
    [anon_sym_sizeof] = ACTIONS(3983),
    [anon_sym_typeof] = ACTIONS(3983),
    [anon_sym___makeref] = ACTIONS(3983),
    [anon_sym___reftype] = ACTIONS(3983),
    [anon_sym___refvalue] = ACTIONS(3983),
    [sym_null_literal] = ACTIONS(3983),
    [anon_sym_SQUOTE] = ACTIONS(3985),
    [sym_integer_literal] = ACTIONS(3983),
    [sym_real_literal] = ACTIONS(3985),
    [sym_verbatim_string_literal] = ACTIONS(3985),
    [sym_raw_string_literal] = ACTIONS(3985),
    [aux_sym_preproc_if_token1] = ACTIONS(3985),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3985),
    [sym_interpolation_verbatim_start] = ACTIONS(3985),
    [sym_interpolation_raw_start] = ACTIONS(3985),
  },
  [2722] = {
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7330),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_identifier] = STATE(6784),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(2722),
    [sym_preproc_endregion] = STATE(2722),
    [sym_preproc_line] = STATE(2722),
    [sym_preproc_pragma] = STATE(2722),
    [sym_preproc_nullable] = STATE(2722),
    [sym_preproc_error] = STATE(2722),
    [sym_preproc_define] = STATE(2722),
    [sym_preproc_undef] = STATE(2722),
    [sym__identifier_token] = ACTIONS(3713),
    [anon_sym_alias] = ACTIONS(3716),
    [anon_sym_global] = ACTIONS(3716),
    [anon_sym_EQ] = ACTIONS(3721),
    [anon_sym_LBRACK] = ACTIONS(3719),
    [anon_sym_COLON] = ACTIONS(3721),
    [anon_sym_COMMA] = ACTIONS(3719),
    [anon_sym_LPAREN] = ACTIONS(3723),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_LBRACE] = ACTIONS(3719),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_file] = ACTIONS(3716),
    [anon_sym_LT] = ACTIONS(3721),
    [anon_sym_GT] = ACTIONS(3721),
    [anon_sym_where] = ACTIONS(3716),
    [anon_sym_QMARK] = ACTIONS(3721),
    [anon_sym_notnull] = ACTIONS(3716),
    [anon_sym_unmanaged] = ACTIONS(3716),
    [anon_sym_BANG] = ACTIONS(3721),
    [anon_sym_PLUS_PLUS] = ACTIONS(3719),
    [anon_sym_DASH_DASH] = ACTIONS(3719),
    [anon_sym_PLUS] = ACTIONS(3721),
    [anon_sym_DASH] = ACTIONS(3721),
    [anon_sym_STAR] = ACTIONS(3721),
    [anon_sym_SLASH] = ACTIONS(3721),
    [anon_sym_PERCENT] = ACTIONS(3721),
    [anon_sym_CARET] = ACTIONS(3721),
    [anon_sym_PIPE] = ACTIONS(3721),
    [anon_sym_AMP] = ACTIONS(3721),
    [anon_sym_LT_LT] = ACTIONS(3721),
    [anon_sym_GT_GT] = ACTIONS(3721),
    [anon_sym_GT_GT_GT] = ACTIONS(3721),
    [anon_sym_EQ_EQ] = ACTIONS(3719),
    [anon_sym_BANG_EQ] = ACTIONS(3719),
    [anon_sym_GT_EQ] = ACTIONS(3719),
    [anon_sym_LT_EQ] = ACTIONS(3719),
    [anon_sym_DOT] = ACTIONS(3721),
    [anon_sym_scoped] = ACTIONS(3730),
    [anon_sym_EQ_GT] = ACTIONS(3719),
    [anon_sym_COLON_COLON] = ACTIONS(3719),
    [anon_sym_var] = ACTIONS(3733),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(3716),
    [anon_sym_switch] = ACTIONS(3721),
    [anon_sym_when] = ACTIONS(3716),
    [sym_discard] = ACTIONS(3721),
    [anon_sym_DOT_DOT] = ACTIONS(3719),
    [anon_sym_and] = ACTIONS(3721),
    [anon_sym_or] = ACTIONS(3721),
    [anon_sym_PLUS_EQ] = ACTIONS(3719),
    [anon_sym_DASH_EQ] = ACTIONS(3719),
    [anon_sym_STAR_EQ] = ACTIONS(3719),
    [anon_sym_SLASH_EQ] = ACTIONS(3719),
    [anon_sym_PERCENT_EQ] = ACTIONS(3719),
    [anon_sym_AMP_EQ] = ACTIONS(3719),
    [anon_sym_CARET_EQ] = ACTIONS(3719),
    [anon_sym_PIPE_EQ] = ACTIONS(3719),
    [anon_sym_LT_LT_EQ] = ACTIONS(3719),
    [anon_sym_GT_GT_EQ] = ACTIONS(3719),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3719),
    [anon_sym_AMP_AMP] = ACTIONS(3719),
    [anon_sym_PIPE_PIPE] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK] = ACTIONS(3721),
    [anon_sym_from] = ACTIONS(3716),
    [anon_sym_into] = ACTIONS(3716),
    [anon_sym_join] = ACTIONS(3716),
    [anon_sym_on] = ACTIONS(3716),
    [anon_sym_equals] = ACTIONS(3716),
    [anon_sym_let] = ACTIONS(3716),
    [anon_sym_orderby] = ACTIONS(3716),
    [anon_sym_ascending] = ACTIONS(3716),
    [anon_sym_descending] = ACTIONS(3716),
    [anon_sym_group] = ACTIONS(3716),
    [anon_sym_by] = ACTIONS(3716),
    [anon_sym_select] = ACTIONS(3716),
    [anon_sym_as] = ACTIONS(3721),
    [anon_sym_is] = ACTIONS(3721),
    [anon_sym_DASH_GT] = ACTIONS(3719),
    [anon_sym_with] = ACTIONS(3721),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(3719),
  },
  [2723] = {
    [sym__name] = STATE(6160),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_ref_type] = STATE(2899),
    [sym__scoped_base_type] = STATE(2907),
    [sym_identifier] = STATE(5368),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_region] = STATE(2723),
    [sym_preproc_endregion] = STATE(2723),
    [sym_preproc_line] = STATE(2723),
    [sym_preproc_pragma] = STATE(2723),
    [sym_preproc_nullable] = STATE(2723),
    [sym_preproc_error] = STATE(2723),
    [sym_preproc_define] = STATE(2723),
    [sym_preproc_undef] = STATE(2723),
    [sym__identifier_token] = ACTIONS(3987),
    [anon_sym_alias] = ACTIONS(3991),
    [anon_sym_global] = ACTIONS(3991),
    [anon_sym_EQ] = ACTIONS(3721),
    [anon_sym_LBRACK] = ACTIONS(3719),
    [anon_sym_COLON] = ACTIONS(3721),
    [anon_sym_COMMA] = ACTIONS(3719),
    [anon_sym_LPAREN] = ACTIONS(3995),
    [anon_sym_RPAREN] = ACTIONS(3719),
    [anon_sym_ref] = ACTIONS(2603),
    [anon_sym_LBRACE] = ACTIONS(3719),
    [anon_sym_delegate] = ACTIONS(2603),
    [anon_sym_file] = ACTIONS(3991),
    [anon_sym_readonly] = ACTIONS(2603),
    [anon_sym_LT] = ACTIONS(3721),
    [anon_sym_GT] = ACTIONS(3721),
    [anon_sym_in] = ACTIONS(2603),
    [anon_sym_out] = ACTIONS(2603),
    [anon_sym_where] = ACTIONS(3991),
    [anon_sym_QMARK] = ACTIONS(3721),
    [anon_sym_notnull] = ACTIONS(3991),
    [anon_sym_unmanaged] = ACTIONS(3991),
    [anon_sym_BANG] = ACTIONS(3721),
    [anon_sym_PLUS_PLUS] = ACTIONS(3719),
    [anon_sym_DASH_DASH] = ACTIONS(3719),
    [anon_sym_PLUS] = ACTIONS(3721),
    [anon_sym_DASH] = ACTIONS(3721),
    [anon_sym_STAR] = ACTIONS(3721),
    [anon_sym_SLASH] = ACTIONS(3721),
    [anon_sym_PERCENT] = ACTIONS(3721),
    [anon_sym_CARET] = ACTIONS(3721),
    [anon_sym_PIPE] = ACTIONS(3721),
    [anon_sym_AMP] = ACTIONS(3721),
    [anon_sym_LT_LT] = ACTIONS(3721),
    [anon_sym_GT_GT] = ACTIONS(3721),
    [anon_sym_GT_GT_GT] = ACTIONS(3721),
    [anon_sym_EQ_EQ] = ACTIONS(3719),
    [anon_sym_BANG_EQ] = ACTIONS(3719),
    [anon_sym_GT_EQ] = ACTIONS(3719),
    [anon_sym_LT_EQ] = ACTIONS(3719),
    [anon_sym_this] = ACTIONS(2603),
    [anon_sym_DOT] = ACTIONS(3721),
    [anon_sym_scoped] = ACTIONS(3991),
    [anon_sym_EQ_GT] = ACTIONS(3719),
    [anon_sym_COLON_COLON] = ACTIONS(3719),
    [anon_sym_var] = ACTIONS(3991),
    [sym_predefined_type] = ACTIONS(2603),
    [anon_sym_yield] = ACTIONS(3991),
    [anon_sym_switch] = ACTIONS(3721),
    [anon_sym_when] = ACTIONS(3991),
    [sym_discard] = ACTIONS(3721),
    [anon_sym_DOT_DOT] = ACTIONS(3719),
    [anon_sym_and] = ACTIONS(3721),
    [anon_sym_or] = ACTIONS(3721),
    [anon_sym_PLUS_EQ] = ACTIONS(3719),
    [anon_sym_DASH_EQ] = ACTIONS(3719),
    [anon_sym_STAR_EQ] = ACTIONS(3719),
    [anon_sym_SLASH_EQ] = ACTIONS(3719),
    [anon_sym_PERCENT_EQ] = ACTIONS(3719),
    [anon_sym_AMP_EQ] = ACTIONS(3719),
    [anon_sym_CARET_EQ] = ACTIONS(3719),
    [anon_sym_PIPE_EQ] = ACTIONS(3719),
    [anon_sym_LT_LT_EQ] = ACTIONS(3719),
    [anon_sym_GT_GT_EQ] = ACTIONS(3719),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3719),
    [anon_sym_AMP_AMP] = ACTIONS(3719),
    [anon_sym_PIPE_PIPE] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK] = ACTIONS(3721),
    [anon_sym_from] = ACTIONS(3991),
    [anon_sym_into] = ACTIONS(3991),
    [anon_sym_join] = ACTIONS(3991),
    [anon_sym_on] = ACTIONS(3991),
    [anon_sym_equals] = ACTIONS(3991),
    [anon_sym_let] = ACTIONS(3991),
    [anon_sym_orderby] = ACTIONS(3991),
    [anon_sym_ascending] = ACTIONS(3991),
    [anon_sym_descending] = ACTIONS(3991),
    [anon_sym_group] = ACTIONS(3991),
    [anon_sym_by] = ACTIONS(3991),
    [anon_sym_select] = ACTIONS(3991),
    [anon_sym_as] = ACTIONS(3721),
    [anon_sym_is] = ACTIONS(3721),
    [anon_sym_DASH_GT] = ACTIONS(3719),
    [anon_sym_with] = ACTIONS(3721),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2724] = {
    [sym__name] = STATE(3008),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2977),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2956),
    [sym_ref_type] = STATE(2899),
    [sym__scoped_base_type] = STATE(2907),
    [sym_identifier] = STATE(2913),
    [sym__reserved_identifier] = STATE(2914),
    [sym_preproc_region] = STATE(2724),
    [sym_preproc_endregion] = STATE(2724),
    [sym_preproc_line] = STATE(2724),
    [sym_preproc_pragma] = STATE(2724),
    [sym_preproc_nullable] = STATE(2724),
    [sym_preproc_error] = STATE(2724),
    [sym_preproc_define] = STATE(2724),
    [sym_preproc_undef] = STATE(2724),
    [sym__identifier_token] = ACTIONS(3998),
    [anon_sym_alias] = ACTIONS(4001),
    [anon_sym_SEMI] = ACTIONS(3719),
    [anon_sym_global] = ACTIONS(4001),
    [anon_sym_EQ] = ACTIONS(3721),
    [anon_sym_LBRACK] = ACTIONS(3719),
    [anon_sym_COMMA] = ACTIONS(3719),
    [anon_sym_RBRACK] = ACTIONS(3719),
    [anon_sym_LPAREN] = ACTIONS(3719),
    [anon_sym_RPAREN] = ACTIONS(3719),
    [anon_sym_ref] = ACTIONS(4004),
    [anon_sym_LBRACE] = ACTIONS(3719),
    [anon_sym_RBRACE] = ACTIONS(3719),
    [anon_sym_file] = ACTIONS(4001),
    [anon_sym_LT] = ACTIONS(3721),
    [anon_sym_GT] = ACTIONS(3721),
    [anon_sym_in] = ACTIONS(3721),
    [anon_sym_where] = ACTIONS(4001),
    [anon_sym_QMARK] = ACTIONS(3721),
    [anon_sym_notnull] = ACTIONS(4001),
    [anon_sym_unmanaged] = ACTIONS(4001),
    [anon_sym_BANG] = ACTIONS(3721),
    [anon_sym_PLUS_PLUS] = ACTIONS(3719),
    [anon_sym_DASH_DASH] = ACTIONS(3719),
    [anon_sym_PLUS] = ACTIONS(3721),
    [anon_sym_DASH] = ACTIONS(3721),
    [anon_sym_STAR] = ACTIONS(3721),
    [anon_sym_SLASH] = ACTIONS(3721),
    [anon_sym_PERCENT] = ACTIONS(3721),
    [anon_sym_CARET] = ACTIONS(3721),
    [anon_sym_PIPE] = ACTIONS(3721),
    [anon_sym_AMP] = ACTIONS(3721),
    [anon_sym_LT_LT] = ACTIONS(3721),
    [anon_sym_GT_GT] = ACTIONS(3721),
    [anon_sym_GT_GT_GT] = ACTIONS(3721),
    [anon_sym_EQ_EQ] = ACTIONS(3719),
    [anon_sym_BANG_EQ] = ACTIONS(3719),
    [anon_sym_GT_EQ] = ACTIONS(3719),
    [anon_sym_LT_EQ] = ACTIONS(3719),
    [anon_sym_DOT] = ACTIONS(3721),
    [anon_sym_scoped] = ACTIONS(4001),
    [anon_sym_EQ_GT] = ACTIONS(3719),
    [anon_sym_COLON_COLON] = ACTIONS(3719),
    [anon_sym_var] = ACTIONS(4001),
    [anon_sym_yield] = ACTIONS(4001),
    [anon_sym_switch] = ACTIONS(3721),
    [anon_sym_when] = ACTIONS(4001),
    [sym_discard] = ACTIONS(3721),
    [anon_sym_DOT_DOT] = ACTIONS(3719),
    [anon_sym_and] = ACTIONS(3721),
    [anon_sym_or] = ACTIONS(3721),
    [anon_sym_PLUS_EQ] = ACTIONS(3719),
    [anon_sym_DASH_EQ] = ACTIONS(3719),
    [anon_sym_STAR_EQ] = ACTIONS(3719),
    [anon_sym_SLASH_EQ] = ACTIONS(3719),
    [anon_sym_PERCENT_EQ] = ACTIONS(3719),
    [anon_sym_AMP_EQ] = ACTIONS(3719),
    [anon_sym_CARET_EQ] = ACTIONS(3719),
    [anon_sym_PIPE_EQ] = ACTIONS(3719),
    [anon_sym_LT_LT_EQ] = ACTIONS(3719),
    [anon_sym_GT_GT_EQ] = ACTIONS(3719),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3719),
    [anon_sym_AMP_AMP] = ACTIONS(3719),
    [anon_sym_PIPE_PIPE] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK] = ACTIONS(3721),
    [anon_sym_from] = ACTIONS(4001),
    [anon_sym_into] = ACTIONS(4001),
    [anon_sym_join] = ACTIONS(4001),
    [anon_sym_on] = ACTIONS(4001),
    [anon_sym_equals] = ACTIONS(4001),
    [anon_sym_let] = ACTIONS(4001),
    [anon_sym_orderby] = ACTIONS(4001),
    [anon_sym_ascending] = ACTIONS(4001),
    [anon_sym_descending] = ACTIONS(4001),
    [anon_sym_group] = ACTIONS(4001),
    [anon_sym_by] = ACTIONS(4001),
    [anon_sym_select] = ACTIONS(4001),
    [anon_sym_as] = ACTIONS(3721),
    [anon_sym_is] = ACTIONS(3721),
    [anon_sym_DASH_GT] = ACTIONS(3719),
    [anon_sym_with] = ACTIONS(3721),
    [aux_sym_preproc_if_token3] = ACTIONS(3719),
    [aux_sym_preproc_else_token1] = ACTIONS(3719),
    [aux_sym_preproc_elif_token1] = ACTIONS(3719),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2725] = {
    [sym__name] = STATE(6160),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_ref_type] = STATE(2899),
    [sym__scoped_base_type] = STATE(2907),
    [sym_identifier] = STATE(5368),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_region] = STATE(2725),
    [sym_preproc_endregion] = STATE(2725),
    [sym_preproc_line] = STATE(2725),
    [sym_preproc_pragma] = STATE(2725),
    [sym_preproc_nullable] = STATE(2725),
    [sym_preproc_error] = STATE(2725),
    [sym_preproc_define] = STATE(2725),
    [sym_preproc_undef] = STATE(2725),
    [sym__identifier_token] = ACTIONS(4006),
    [anon_sym_alias] = ACTIONS(4009),
    [anon_sym_SEMI] = ACTIONS(3719),
    [anon_sym_global] = ACTIONS(4009),
    [anon_sym_EQ] = ACTIONS(3721),
    [anon_sym_LBRACK] = ACTIONS(3719),
    [anon_sym_COLON] = ACTIONS(3721),
    [anon_sym_COMMA] = ACTIONS(3719),
    [anon_sym_RBRACK] = ACTIONS(3719),
    [anon_sym_LPAREN] = ACTIONS(3719),
    [anon_sym_RPAREN] = ACTIONS(3719),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_RBRACE] = ACTIONS(3719),
    [anon_sym_file] = ACTIONS(4009),
    [anon_sym_LT] = ACTIONS(3721),
    [anon_sym_GT] = ACTIONS(3721),
    [anon_sym_in] = ACTIONS(3721),
    [anon_sym_where] = ACTIONS(4009),
    [anon_sym_QMARK] = ACTIONS(3721),
    [anon_sym_notnull] = ACTIONS(4009),
    [anon_sym_unmanaged] = ACTIONS(4009),
    [anon_sym_BANG] = ACTIONS(3721),
    [anon_sym_PLUS_PLUS] = ACTIONS(3719),
    [anon_sym_DASH_DASH] = ACTIONS(3719),
    [anon_sym_PLUS] = ACTIONS(3721),
    [anon_sym_DASH] = ACTIONS(3721),
    [anon_sym_STAR] = ACTIONS(3721),
    [anon_sym_SLASH] = ACTIONS(3721),
    [anon_sym_PERCENT] = ACTIONS(3721),
    [anon_sym_CARET] = ACTIONS(3721),
    [anon_sym_PIPE] = ACTIONS(3721),
    [anon_sym_AMP] = ACTIONS(3721),
    [anon_sym_LT_LT] = ACTIONS(3721),
    [anon_sym_GT_GT] = ACTIONS(3721),
    [anon_sym_GT_GT_GT] = ACTIONS(3721),
    [anon_sym_EQ_EQ] = ACTIONS(3719),
    [anon_sym_BANG_EQ] = ACTIONS(3719),
    [anon_sym_GT_EQ] = ACTIONS(3719),
    [anon_sym_LT_EQ] = ACTIONS(3719),
    [anon_sym_DOT] = ACTIONS(3721),
    [anon_sym_scoped] = ACTIONS(4009),
    [anon_sym_EQ_GT] = ACTIONS(3719),
    [anon_sym_COLON_COLON] = ACTIONS(3719),
    [anon_sym_var] = ACTIONS(4009),
    [anon_sym_yield] = ACTIONS(4009),
    [anon_sym_switch] = ACTIONS(3721),
    [anon_sym_when] = ACTIONS(4009),
    [anon_sym_DOT_DOT] = ACTIONS(3719),
    [anon_sym_and] = ACTIONS(3721),
    [anon_sym_or] = ACTIONS(3721),
    [anon_sym_PLUS_EQ] = ACTIONS(3719),
    [anon_sym_DASH_EQ] = ACTIONS(3719),
    [anon_sym_STAR_EQ] = ACTIONS(3719),
    [anon_sym_SLASH_EQ] = ACTIONS(3719),
    [anon_sym_PERCENT_EQ] = ACTIONS(3719),
    [anon_sym_AMP_EQ] = ACTIONS(3719),
    [anon_sym_CARET_EQ] = ACTIONS(3719),
    [anon_sym_PIPE_EQ] = ACTIONS(3719),
    [anon_sym_LT_LT_EQ] = ACTIONS(3719),
    [anon_sym_GT_GT_EQ] = ACTIONS(3719),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3719),
    [anon_sym_AMP_AMP] = ACTIONS(3719),
    [anon_sym_PIPE_PIPE] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK] = ACTIONS(3721),
    [anon_sym_from] = ACTIONS(4009),
    [anon_sym_into] = ACTIONS(4009),
    [anon_sym_join] = ACTIONS(4009),
    [anon_sym_on] = ACTIONS(4009),
    [anon_sym_equals] = ACTIONS(4009),
    [anon_sym_let] = ACTIONS(4009),
    [anon_sym_orderby] = ACTIONS(4009),
    [anon_sym_ascending] = ACTIONS(4009),
    [anon_sym_descending] = ACTIONS(4009),
    [anon_sym_group] = ACTIONS(4009),
    [anon_sym_by] = ACTIONS(4009),
    [anon_sym_select] = ACTIONS(4009),
    [anon_sym_as] = ACTIONS(3721),
    [anon_sym_is] = ACTIONS(3721),
    [anon_sym_DASH_GT] = ACTIONS(3719),
    [anon_sym_with] = ACTIONS(3721),
    [aux_sym_preproc_if_token3] = ACTIONS(3719),
    [aux_sym_preproc_else_token1] = ACTIONS(3719),
    [aux_sym_preproc_elif_token1] = ACTIONS(3719),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2726] = {
    [sym__name] = STATE(6160),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_ref_type] = STATE(2899),
    [sym__scoped_base_type] = STATE(2907),
    [sym_identifier] = STATE(5368),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_region] = STATE(2726),
    [sym_preproc_endregion] = STATE(2726),
    [sym_preproc_line] = STATE(2726),
    [sym_preproc_pragma] = STATE(2726),
    [sym_preproc_nullable] = STATE(2726),
    [sym_preproc_error] = STATE(2726),
    [sym_preproc_define] = STATE(2726),
    [sym_preproc_undef] = STATE(2726),
    [sym__identifier_token] = ACTIONS(4006),
    [anon_sym_alias] = ACTIONS(4009),
    [anon_sym_global] = ACTIONS(4009),
    [anon_sym_EQ] = ACTIONS(3721),
    [anon_sym_LBRACK] = ACTIONS(3719),
    [anon_sym_COLON] = ACTIONS(3721),
    [anon_sym_COMMA] = ACTIONS(3719),
    [anon_sym_RBRACK] = ACTIONS(3719),
    [anon_sym_LPAREN] = ACTIONS(3719),
    [anon_sym_RPAREN] = ACTIONS(3719),
    [anon_sym_ref] = ACTIONS(4012),
    [anon_sym_LBRACE] = ACTIONS(3719),
    [anon_sym_RBRACE] = ACTIONS(3719),
    [anon_sym_file] = ACTIONS(4009),
    [anon_sym_LT] = ACTIONS(3721),
    [anon_sym_GT] = ACTIONS(3721),
    [anon_sym_where] = ACTIONS(4009),
    [anon_sym_QMARK] = ACTIONS(3721),
    [anon_sym_notnull] = ACTIONS(4009),
    [anon_sym_unmanaged] = ACTIONS(4009),
    [anon_sym_BANG] = ACTIONS(3721),
    [anon_sym_PLUS_PLUS] = ACTIONS(3719),
    [anon_sym_DASH_DASH] = ACTIONS(3719),
    [anon_sym_PLUS] = ACTIONS(3721),
    [anon_sym_DASH] = ACTIONS(3721),
    [anon_sym_STAR] = ACTIONS(3721),
    [anon_sym_SLASH] = ACTIONS(3721),
    [anon_sym_PERCENT] = ACTIONS(3721),
    [anon_sym_CARET] = ACTIONS(3721),
    [anon_sym_PIPE] = ACTIONS(3721),
    [anon_sym_AMP] = ACTIONS(3721),
    [anon_sym_LT_LT] = ACTIONS(3721),
    [anon_sym_GT_GT] = ACTIONS(3721),
    [anon_sym_GT_GT_GT] = ACTIONS(3721),
    [anon_sym_EQ_EQ] = ACTIONS(3719),
    [anon_sym_BANG_EQ] = ACTIONS(3719),
    [anon_sym_GT_EQ] = ACTIONS(3719),
    [anon_sym_LT_EQ] = ACTIONS(3719),
    [anon_sym_DOT] = ACTIONS(3721),
    [anon_sym_scoped] = ACTIONS(4009),
    [anon_sym_EQ_GT] = ACTIONS(3719),
    [anon_sym_COLON_COLON] = ACTIONS(3719),
    [anon_sym_var] = ACTIONS(4009),
    [anon_sym_yield] = ACTIONS(4009),
    [anon_sym_switch] = ACTIONS(3721),
    [anon_sym_when] = ACTIONS(4009),
    [sym_discard] = ACTIONS(3721),
    [anon_sym_DOT_DOT] = ACTIONS(3719),
    [anon_sym_and] = ACTIONS(3721),
    [anon_sym_or] = ACTIONS(3721),
    [anon_sym_PLUS_EQ] = ACTIONS(3719),
    [anon_sym_DASH_EQ] = ACTIONS(3719),
    [anon_sym_STAR_EQ] = ACTIONS(3719),
    [anon_sym_SLASH_EQ] = ACTIONS(3719),
    [anon_sym_PERCENT_EQ] = ACTIONS(3719),
    [anon_sym_AMP_EQ] = ACTIONS(3719),
    [anon_sym_CARET_EQ] = ACTIONS(3719),
    [anon_sym_PIPE_EQ] = ACTIONS(3719),
    [anon_sym_LT_LT_EQ] = ACTIONS(3719),
    [anon_sym_GT_GT_EQ] = ACTIONS(3719),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3719),
    [anon_sym_AMP_AMP] = ACTIONS(3719),
    [anon_sym_PIPE_PIPE] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK] = ACTIONS(3721),
    [anon_sym_from] = ACTIONS(4009),
    [anon_sym_into] = ACTIONS(4009),
    [anon_sym_join] = ACTIONS(4009),
    [anon_sym_on] = ACTIONS(4009),
    [anon_sym_equals] = ACTIONS(4009),
    [anon_sym_let] = ACTIONS(4009),
    [anon_sym_orderby] = ACTIONS(4009),
    [anon_sym_ascending] = ACTIONS(4009),
    [anon_sym_descending] = ACTIONS(4009),
    [anon_sym_group] = ACTIONS(4009),
    [anon_sym_by] = ACTIONS(4009),
    [anon_sym_select] = ACTIONS(4009),
    [anon_sym_as] = ACTIONS(3721),
    [anon_sym_is] = ACTIONS(3721),
    [anon_sym_DASH_GT] = ACTIONS(3719),
    [anon_sym_with] = ACTIONS(3721),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2727] = {
    [sym__name] = STATE(3184),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2977),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2956),
    [sym_ref_type] = STATE(2899),
    [sym__scoped_base_type] = STATE(2907),
    [sym_identifier] = STATE(3126),
    [sym__reserved_identifier] = STATE(2914),
    [sym_preproc_region] = STATE(2727),
    [sym_preproc_endregion] = STATE(2727),
    [sym_preproc_line] = STATE(2727),
    [sym_preproc_pragma] = STATE(2727),
    [sym_preproc_nullable] = STATE(2727),
    [sym_preproc_error] = STATE(2727),
    [sym_preproc_define] = STATE(2727),
    [sym_preproc_undef] = STATE(2727),
    [sym__identifier_token] = ACTIONS(3998),
    [anon_sym_alias] = ACTIONS(4001),
    [anon_sym_global] = ACTIONS(4001),
    [anon_sym_EQ] = ACTIONS(3721),
    [anon_sym_LBRACK] = ACTIONS(3719),
    [anon_sym_COLON] = ACTIONS(3721),
    [anon_sym_COMMA] = ACTIONS(3719),
    [anon_sym_LPAREN] = ACTIONS(3719),
    [anon_sym_RPAREN] = ACTIONS(3719),
    [anon_sym_ref] = ACTIONS(4014),
    [anon_sym_LBRACE] = ACTIONS(3719),
    [anon_sym_RBRACE] = ACTIONS(3719),
    [anon_sym_file] = ACTIONS(4001),
    [anon_sym_LT] = ACTIONS(3721),
    [anon_sym_GT] = ACTIONS(3721),
    [anon_sym_where] = ACTIONS(4001),
    [anon_sym_QMARK] = ACTIONS(3721),
    [anon_sym_notnull] = ACTIONS(4001),
    [anon_sym_unmanaged] = ACTIONS(4001),
    [anon_sym_BANG] = ACTIONS(3721),
    [anon_sym_PLUS_PLUS] = ACTIONS(3719),
    [anon_sym_DASH_DASH] = ACTIONS(3719),
    [anon_sym_PLUS] = ACTIONS(3721),
    [anon_sym_DASH] = ACTIONS(3721),
    [anon_sym_STAR] = ACTIONS(3721),
    [anon_sym_SLASH] = ACTIONS(3721),
    [anon_sym_PERCENT] = ACTIONS(3721),
    [anon_sym_CARET] = ACTIONS(3721),
    [anon_sym_PIPE] = ACTIONS(3721),
    [anon_sym_AMP] = ACTIONS(3721),
    [anon_sym_LT_LT] = ACTIONS(3721),
    [anon_sym_GT_GT] = ACTIONS(3721),
    [anon_sym_GT_GT_GT] = ACTIONS(3721),
    [anon_sym_EQ_EQ] = ACTIONS(3719),
    [anon_sym_BANG_EQ] = ACTIONS(3719),
    [anon_sym_GT_EQ] = ACTIONS(3719),
    [anon_sym_LT_EQ] = ACTIONS(3719),
    [anon_sym_DOT] = ACTIONS(3721),
    [anon_sym_scoped] = ACTIONS(4001),
    [anon_sym_EQ_GT] = ACTIONS(3719),
    [anon_sym_COLON_COLON] = ACTIONS(3719),
    [anon_sym_var] = ACTIONS(4001),
    [anon_sym_yield] = ACTIONS(4001),
    [anon_sym_switch] = ACTIONS(3721),
    [anon_sym_when] = ACTIONS(4001),
    [sym_discard] = ACTIONS(3721),
    [anon_sym_DOT_DOT] = ACTIONS(3719),
    [anon_sym_and] = ACTIONS(3721),
    [anon_sym_or] = ACTIONS(3721),
    [anon_sym_PLUS_EQ] = ACTIONS(3719),
    [anon_sym_DASH_EQ] = ACTIONS(3719),
    [anon_sym_STAR_EQ] = ACTIONS(3719),
    [anon_sym_SLASH_EQ] = ACTIONS(3719),
    [anon_sym_PERCENT_EQ] = ACTIONS(3719),
    [anon_sym_AMP_EQ] = ACTIONS(3719),
    [anon_sym_CARET_EQ] = ACTIONS(3719),
    [anon_sym_PIPE_EQ] = ACTIONS(3719),
    [anon_sym_LT_LT_EQ] = ACTIONS(3719),
    [anon_sym_GT_GT_EQ] = ACTIONS(3719),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3719),
    [anon_sym_AMP_AMP] = ACTIONS(3719),
    [anon_sym_PIPE_PIPE] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK] = ACTIONS(3721),
    [anon_sym_from] = ACTIONS(4001),
    [anon_sym_into] = ACTIONS(4001),
    [anon_sym_join] = ACTIONS(4001),
    [anon_sym_on] = ACTIONS(4001),
    [anon_sym_equals] = ACTIONS(4001),
    [anon_sym_let] = ACTIONS(4001),
    [anon_sym_orderby] = ACTIONS(4001),
    [anon_sym_ascending] = ACTIONS(4001),
    [anon_sym_descending] = ACTIONS(4001),
    [anon_sym_group] = ACTIONS(4001),
    [anon_sym_by] = ACTIONS(4001),
    [anon_sym_select] = ACTIONS(4001),
    [anon_sym_as] = ACTIONS(3721),
    [anon_sym_is] = ACTIONS(3721),
    [anon_sym_DASH_GT] = ACTIONS(3719),
    [anon_sym_with] = ACTIONS(3721),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2728] = {
    [sym__variable_designation] = STATE(4017),
    [sym_parenthesized_variable_designation] = STATE(4015),
    [sym_identifier] = STATE(4020),
    [sym__reserved_identifier] = STATE(3908),
    [sym_preproc_region] = STATE(2728),
    [sym_preproc_endregion] = STATE(2728),
    [sym_preproc_line] = STATE(2728),
    [sym_preproc_pragma] = STATE(2728),
    [sym_preproc_nullable] = STATE(2728),
    [sym_preproc_error] = STATE(2728),
    [sym_preproc_define] = STATE(2728),
    [sym_preproc_undef] = STATE(2728),
    [sym__identifier_token] = ACTIONS(4016),
    [anon_sym_alias] = ACTIONS(4020),
    [anon_sym_SEMI] = ACTIONS(4024),
    [anon_sym_global] = ACTIONS(4020),
    [anon_sym_EQ] = ACTIONS(3721),
    [anon_sym_LBRACK] = ACTIONS(4024),
    [anon_sym_COLON] = ACTIONS(4027),
    [anon_sym_COMMA] = ACTIONS(4024),
    [anon_sym_RBRACK] = ACTIONS(4024),
    [anon_sym_LPAREN] = ACTIONS(4030),
    [anon_sym_RPAREN] = ACTIONS(4024),
    [anon_sym_LBRACE] = ACTIONS(4024),
    [anon_sym_RBRACE] = ACTIONS(4024),
    [anon_sym_file] = ACTIONS(4020),
    [anon_sym_LT] = ACTIONS(4027),
    [anon_sym_GT] = ACTIONS(4027),
    [anon_sym_in] = ACTIONS(4027),
    [anon_sym_where] = ACTIONS(4020),
    [anon_sym_QMARK] = ACTIONS(4027),
    [anon_sym_notnull] = ACTIONS(4020),
    [anon_sym_unmanaged] = ACTIONS(4020),
    [anon_sym_BANG] = ACTIONS(4027),
    [anon_sym_PLUS_PLUS] = ACTIONS(4024),
    [anon_sym_DASH_DASH] = ACTIONS(4024),
    [anon_sym_PLUS] = ACTIONS(4027),
    [anon_sym_DASH] = ACTIONS(4027),
    [anon_sym_STAR] = ACTIONS(4027),
    [anon_sym_SLASH] = ACTIONS(4027),
    [anon_sym_PERCENT] = ACTIONS(4027),
    [anon_sym_CARET] = ACTIONS(4027),
    [anon_sym_PIPE] = ACTIONS(4027),
    [anon_sym_AMP] = ACTIONS(4027),
    [anon_sym_LT_LT] = ACTIONS(4027),
    [anon_sym_GT_GT] = ACTIONS(4027),
    [anon_sym_GT_GT_GT] = ACTIONS(4027),
    [anon_sym_EQ_EQ] = ACTIONS(4024),
    [anon_sym_BANG_EQ] = ACTIONS(4024),
    [anon_sym_GT_EQ] = ACTIONS(4024),
    [anon_sym_LT_EQ] = ACTIONS(4024),
    [anon_sym_DOT] = ACTIONS(4027),
    [anon_sym_scoped] = ACTIONS(4020),
    [anon_sym_EQ_GT] = ACTIONS(3719),
    [anon_sym_COLON_COLON] = ACTIONS(3719),
    [anon_sym_var] = ACTIONS(4020),
    [anon_sym_yield] = ACTIONS(4020),
    [anon_sym_switch] = ACTIONS(4027),
    [anon_sym_when] = ACTIONS(4020),
    [sym_discard] = ACTIONS(4034),
    [anon_sym_DOT_DOT] = ACTIONS(4024),
    [anon_sym_and] = ACTIONS(4027),
    [anon_sym_or] = ACTIONS(4027),
    [anon_sym_PLUS_EQ] = ACTIONS(3719),
    [anon_sym_DASH_EQ] = ACTIONS(3719),
    [anon_sym_STAR_EQ] = ACTIONS(3719),
    [anon_sym_SLASH_EQ] = ACTIONS(3719),
    [anon_sym_PERCENT_EQ] = ACTIONS(3719),
    [anon_sym_AMP_EQ] = ACTIONS(3719),
    [anon_sym_CARET_EQ] = ACTIONS(3719),
    [anon_sym_PIPE_EQ] = ACTIONS(3719),
    [anon_sym_LT_LT_EQ] = ACTIONS(3719),
    [anon_sym_GT_GT_EQ] = ACTIONS(3719),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3719),
    [anon_sym_AMP_AMP] = ACTIONS(4024),
    [anon_sym_PIPE_PIPE] = ACTIONS(4024),
    [anon_sym_QMARK_QMARK] = ACTIONS(4027),
    [anon_sym_from] = ACTIONS(4020),
    [anon_sym_into] = ACTIONS(4020),
    [anon_sym_join] = ACTIONS(4020),
    [anon_sym_on] = ACTIONS(4020),
    [anon_sym_equals] = ACTIONS(4020),
    [anon_sym_let] = ACTIONS(4020),
    [anon_sym_orderby] = ACTIONS(4020),
    [anon_sym_ascending] = ACTIONS(4020),
    [anon_sym_descending] = ACTIONS(4020),
    [anon_sym_group] = ACTIONS(4020),
    [anon_sym_by] = ACTIONS(4020),
    [anon_sym_select] = ACTIONS(4020),
    [anon_sym_as] = ACTIONS(4027),
    [anon_sym_is] = ACTIONS(4027),
    [anon_sym_DASH_GT] = ACTIONS(4024),
    [anon_sym_with] = ACTIONS(4027),
    [aux_sym_preproc_if_token3] = ACTIONS(4024),
    [aux_sym_preproc_else_token1] = ACTIONS(4024),
    [aux_sym_preproc_elif_token1] = ACTIONS(4024),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2729] = {
    [sym__name] = STATE(3380),
    [sym_alias_qualified_name] = STATE(3430),
    [sym__simple_name] = STATE(3430),
    [sym_qualified_name] = STATE(3430),
    [sym_generic_name] = STATE(3314),
    [sym_ref_type] = STATE(3379),
    [sym__scoped_base_type] = STATE(3378),
    [sym_identifier] = STATE(3133),
    [sym__reserved_identifier] = STATE(3163),
    [sym_preproc_region] = STATE(2729),
    [sym_preproc_endregion] = STATE(2729),
    [sym_preproc_line] = STATE(2729),
    [sym_preproc_pragma] = STATE(2729),
    [sym_preproc_nullable] = STATE(2729),
    [sym_preproc_error] = STATE(2729),
    [sym_preproc_define] = STATE(2729),
    [sym_preproc_undef] = STATE(2729),
    [sym__identifier_token] = ACTIONS(4038),
    [anon_sym_alias] = ACTIONS(4041),
    [anon_sym_global] = ACTIONS(4041),
    [anon_sym_EQ] = ACTIONS(3721),
    [anon_sym_LBRACK] = ACTIONS(3719),
    [anon_sym_COLON] = ACTIONS(3721),
    [anon_sym_COMMA] = ACTIONS(3719),
    [anon_sym_LPAREN] = ACTIONS(3719),
    [anon_sym_ref] = ACTIONS(4044),
    [anon_sym_LBRACE] = ACTIONS(3719),
    [anon_sym_file] = ACTIONS(4041),
    [anon_sym_LT] = ACTIONS(3721),
    [anon_sym_GT] = ACTIONS(3721),
    [anon_sym_where] = ACTIONS(4041),
    [anon_sym_QMARK] = ACTIONS(3721),
    [anon_sym_notnull] = ACTIONS(4041),
    [anon_sym_unmanaged] = ACTIONS(4041),
    [anon_sym_BANG] = ACTIONS(3721),
    [anon_sym_PLUS_PLUS] = ACTIONS(3719),
    [anon_sym_DASH_DASH] = ACTIONS(3719),
    [anon_sym_PLUS] = ACTIONS(3721),
    [anon_sym_DASH] = ACTIONS(3721),
    [anon_sym_STAR] = ACTIONS(3721),
    [anon_sym_SLASH] = ACTIONS(3721),
    [anon_sym_PERCENT] = ACTIONS(3721),
    [anon_sym_CARET] = ACTIONS(3721),
    [anon_sym_PIPE] = ACTIONS(3721),
    [anon_sym_AMP] = ACTIONS(3721),
    [anon_sym_LT_LT] = ACTIONS(3721),
    [anon_sym_GT_GT] = ACTIONS(3721),
    [anon_sym_GT_GT_GT] = ACTIONS(3721),
    [anon_sym_EQ_EQ] = ACTIONS(3719),
    [anon_sym_BANG_EQ] = ACTIONS(3719),
    [anon_sym_GT_EQ] = ACTIONS(3719),
    [anon_sym_LT_EQ] = ACTIONS(3719),
    [anon_sym_DOT] = ACTIONS(3721),
    [anon_sym_scoped] = ACTIONS(4041),
    [anon_sym_EQ_GT] = ACTIONS(3719),
    [anon_sym_COLON_COLON] = ACTIONS(3719),
    [anon_sym_var] = ACTIONS(4041),
    [anon_sym_yield] = ACTIONS(4041),
    [anon_sym_switch] = ACTIONS(3721),
    [anon_sym_when] = ACTIONS(4041),
    [sym_discard] = ACTIONS(3721),
    [anon_sym_DOT_DOT] = ACTIONS(3719),
    [anon_sym_and] = ACTIONS(3721),
    [anon_sym_or] = ACTIONS(3721),
    [anon_sym_PLUS_EQ] = ACTIONS(3719),
    [anon_sym_DASH_EQ] = ACTIONS(3719),
    [anon_sym_STAR_EQ] = ACTIONS(3719),
    [anon_sym_SLASH_EQ] = ACTIONS(3719),
    [anon_sym_PERCENT_EQ] = ACTIONS(3719),
    [anon_sym_AMP_EQ] = ACTIONS(3719),
    [anon_sym_CARET_EQ] = ACTIONS(3719),
    [anon_sym_PIPE_EQ] = ACTIONS(3719),
    [anon_sym_LT_LT_EQ] = ACTIONS(3719),
    [anon_sym_GT_GT_EQ] = ACTIONS(3719),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3719),
    [anon_sym_AMP_AMP] = ACTIONS(3719),
    [anon_sym_PIPE_PIPE] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK] = ACTIONS(3721),
    [anon_sym_from] = ACTIONS(4041),
    [anon_sym_into] = ACTIONS(4041),
    [anon_sym_join] = ACTIONS(4041),
    [anon_sym_on] = ACTIONS(4041),
    [anon_sym_equals] = ACTIONS(4041),
    [anon_sym_let] = ACTIONS(4041),
    [anon_sym_orderby] = ACTIONS(4041),
    [anon_sym_ascending] = ACTIONS(4041),
    [anon_sym_descending] = ACTIONS(4041),
    [anon_sym_group] = ACTIONS(4041),
    [anon_sym_by] = ACTIONS(4041),
    [anon_sym_select] = ACTIONS(4041),
    [anon_sym_as] = ACTIONS(3721),
    [anon_sym_is] = ACTIONS(3721),
    [anon_sym_DASH_GT] = ACTIONS(3719),
    [anon_sym_with] = ACTIONS(3721),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(3719),
  },
  [2730] = {
    [sym__variable_designation] = STATE(4270),
    [sym_parenthesized_variable_designation] = STATE(4274),
    [sym_identifier] = STATE(4269),
    [sym__reserved_identifier] = STATE(3908),
    [sym_preproc_region] = STATE(2730),
    [sym_preproc_endregion] = STATE(2730),
    [sym_preproc_line] = STATE(2730),
    [sym_preproc_pragma] = STATE(2730),
    [sym_preproc_nullable] = STATE(2730),
    [sym_preproc_error] = STATE(2730),
    [sym_preproc_define] = STATE(2730),
    [sym_preproc_undef] = STATE(2730),
    [sym__identifier_token] = ACTIONS(4016),
    [anon_sym_alias] = ACTIONS(4020),
    [anon_sym_SEMI] = ACTIONS(4024),
    [anon_sym_global] = ACTIONS(4020),
    [anon_sym_EQ] = ACTIONS(3721),
    [anon_sym_LBRACK] = ACTIONS(4024),
    [anon_sym_COLON] = ACTIONS(4027),
    [anon_sym_COMMA] = ACTIONS(4024),
    [anon_sym_RBRACK] = ACTIONS(4024),
    [anon_sym_LPAREN] = ACTIONS(4046),
    [anon_sym_RPAREN] = ACTIONS(4024),
    [anon_sym_LBRACE] = ACTIONS(4024),
    [anon_sym_RBRACE] = ACTIONS(4024),
    [anon_sym_file] = ACTIONS(4020),
    [anon_sym_LT] = ACTIONS(4027),
    [anon_sym_GT] = ACTIONS(4027),
    [anon_sym_where] = ACTIONS(4020),
    [anon_sym_QMARK] = ACTIONS(4027),
    [anon_sym_notnull] = ACTIONS(4020),
    [anon_sym_unmanaged] = ACTIONS(4020),
    [anon_sym_BANG] = ACTIONS(4027),
    [anon_sym_PLUS_PLUS] = ACTIONS(4024),
    [anon_sym_DASH_DASH] = ACTIONS(4024),
    [anon_sym_PLUS] = ACTIONS(4027),
    [anon_sym_DASH] = ACTIONS(4027),
    [anon_sym_STAR] = ACTIONS(4027),
    [anon_sym_SLASH] = ACTIONS(4027),
    [anon_sym_PERCENT] = ACTIONS(4027),
    [anon_sym_CARET] = ACTIONS(4027),
    [anon_sym_PIPE] = ACTIONS(4027),
    [anon_sym_AMP] = ACTIONS(4027),
    [anon_sym_LT_LT] = ACTIONS(4027),
    [anon_sym_GT_GT] = ACTIONS(4027),
    [anon_sym_GT_GT_GT] = ACTIONS(4027),
    [anon_sym_EQ_EQ] = ACTIONS(4024),
    [anon_sym_BANG_EQ] = ACTIONS(4024),
    [anon_sym_GT_EQ] = ACTIONS(4024),
    [anon_sym_LT_EQ] = ACTIONS(4024),
    [anon_sym_DOT] = ACTIONS(4027),
    [anon_sym_scoped] = ACTIONS(4020),
    [anon_sym_EQ_GT] = ACTIONS(3719),
    [anon_sym_COLON_COLON] = ACTIONS(3719),
    [anon_sym_var] = ACTIONS(4020),
    [anon_sym_yield] = ACTIONS(4020),
    [anon_sym_switch] = ACTIONS(4027),
    [anon_sym_when] = ACTIONS(4020),
    [sym_discard] = ACTIONS(4050),
    [anon_sym_DOT_DOT] = ACTIONS(4024),
    [anon_sym_and] = ACTIONS(4027),
    [anon_sym_or] = ACTIONS(4027),
    [anon_sym_PLUS_EQ] = ACTIONS(3719),
    [anon_sym_DASH_EQ] = ACTIONS(3719),
    [anon_sym_STAR_EQ] = ACTIONS(3719),
    [anon_sym_SLASH_EQ] = ACTIONS(3719),
    [anon_sym_PERCENT_EQ] = ACTIONS(3719),
    [anon_sym_AMP_EQ] = ACTIONS(3719),
    [anon_sym_CARET_EQ] = ACTIONS(3719),
    [anon_sym_PIPE_EQ] = ACTIONS(3719),
    [anon_sym_LT_LT_EQ] = ACTIONS(3719),
    [anon_sym_GT_GT_EQ] = ACTIONS(3719),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3719),
    [anon_sym_AMP_AMP] = ACTIONS(4024),
    [anon_sym_PIPE_PIPE] = ACTIONS(4024),
    [anon_sym_QMARK_QMARK] = ACTIONS(4027),
    [anon_sym_from] = ACTIONS(4020),
    [anon_sym_into] = ACTIONS(4020),
    [anon_sym_join] = ACTIONS(4020),
    [anon_sym_on] = ACTIONS(4020),
    [anon_sym_equals] = ACTIONS(4020),
    [anon_sym_let] = ACTIONS(4020),
    [anon_sym_orderby] = ACTIONS(4020),
    [anon_sym_ascending] = ACTIONS(4020),
    [anon_sym_descending] = ACTIONS(4020),
    [anon_sym_group] = ACTIONS(4020),
    [anon_sym_by] = ACTIONS(4020),
    [anon_sym_select] = ACTIONS(4020),
    [anon_sym_as] = ACTIONS(4027),
    [anon_sym_is] = ACTIONS(4027),
    [anon_sym_DASH_GT] = ACTIONS(4024),
    [anon_sym_with] = ACTIONS(4027),
    [aux_sym_preproc_if_token3] = ACTIONS(4024),
    [aux_sym_preproc_else_token1] = ACTIONS(4024),
    [aux_sym_preproc_elif_token1] = ACTIONS(4024),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2731] = {
    [sym__name] = STATE(6160),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_ref_type] = STATE(2899),
    [sym__scoped_base_type] = STATE(2907),
    [sym_identifier] = STATE(5368),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_region] = STATE(2731),
    [sym_preproc_endregion] = STATE(2731),
    [sym_preproc_line] = STATE(2731),
    [sym_preproc_pragma] = STATE(2731),
    [sym_preproc_nullable] = STATE(2731),
    [sym_preproc_error] = STATE(2731),
    [sym_preproc_define] = STATE(2731),
    [sym_preproc_undef] = STATE(2731),
    [sym__identifier_token] = ACTIONS(4006),
    [anon_sym_alias] = ACTIONS(4009),
    [anon_sym_global] = ACTIONS(4009),
    [anon_sym_EQ] = ACTIONS(3721),
    [anon_sym_LBRACK] = ACTIONS(3719),
    [anon_sym_COLON] = ACTIONS(3721),
    [anon_sym_COMMA] = ACTIONS(3719),
    [anon_sym_LPAREN] = ACTIONS(3719),
    [anon_sym_RPAREN] = ACTIONS(3719),
    [anon_sym_ref] = ACTIONS(4054),
    [anon_sym_LBRACE] = ACTIONS(3719),
    [anon_sym_file] = ACTIONS(4009),
    [anon_sym_LT] = ACTIONS(3721),
    [anon_sym_GT] = ACTIONS(3721),
    [anon_sym_where] = ACTIONS(4009),
    [anon_sym_QMARK] = ACTIONS(3721),
    [anon_sym_notnull] = ACTIONS(4009),
    [anon_sym_unmanaged] = ACTIONS(4009),
    [anon_sym_BANG] = ACTIONS(3721),
    [anon_sym_PLUS_PLUS] = ACTIONS(3719),
    [anon_sym_DASH_DASH] = ACTIONS(3719),
    [anon_sym_PLUS] = ACTIONS(3721),
    [anon_sym_DASH] = ACTIONS(3721),
    [anon_sym_STAR] = ACTIONS(3721),
    [anon_sym_SLASH] = ACTIONS(3721),
    [anon_sym_PERCENT] = ACTIONS(3721),
    [anon_sym_CARET] = ACTIONS(3721),
    [anon_sym_PIPE] = ACTIONS(3721),
    [anon_sym_AMP] = ACTIONS(3721),
    [anon_sym_LT_LT] = ACTIONS(3721),
    [anon_sym_GT_GT] = ACTIONS(3721),
    [anon_sym_GT_GT_GT] = ACTIONS(3721),
    [anon_sym_EQ_EQ] = ACTIONS(3719),
    [anon_sym_BANG_EQ] = ACTIONS(3719),
    [anon_sym_GT_EQ] = ACTIONS(3719),
    [anon_sym_LT_EQ] = ACTIONS(3719),
    [anon_sym_DOT] = ACTIONS(3721),
    [anon_sym_scoped] = ACTIONS(4009),
    [anon_sym_EQ_GT] = ACTIONS(3719),
    [anon_sym_COLON_COLON] = ACTIONS(3719),
    [anon_sym_var] = ACTIONS(4009),
    [anon_sym_yield] = ACTIONS(4009),
    [anon_sym_switch] = ACTIONS(3721),
    [anon_sym_when] = ACTIONS(4009),
    [sym_discard] = ACTIONS(3721),
    [anon_sym_DOT_DOT] = ACTIONS(3719),
    [anon_sym_and] = ACTIONS(3721),
    [anon_sym_or] = ACTIONS(3721),
    [anon_sym_PLUS_EQ] = ACTIONS(3719),
    [anon_sym_DASH_EQ] = ACTIONS(3719),
    [anon_sym_STAR_EQ] = ACTIONS(3719),
    [anon_sym_SLASH_EQ] = ACTIONS(3719),
    [anon_sym_PERCENT_EQ] = ACTIONS(3719),
    [anon_sym_AMP_EQ] = ACTIONS(3719),
    [anon_sym_CARET_EQ] = ACTIONS(3719),
    [anon_sym_PIPE_EQ] = ACTIONS(3719),
    [anon_sym_LT_LT_EQ] = ACTIONS(3719),
    [anon_sym_GT_GT_EQ] = ACTIONS(3719),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3719),
    [anon_sym_AMP_AMP] = ACTIONS(3719),
    [anon_sym_PIPE_PIPE] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK] = ACTIONS(3721),
    [anon_sym_from] = ACTIONS(4009),
    [anon_sym_into] = ACTIONS(4009),
    [anon_sym_join] = ACTIONS(4009),
    [anon_sym_on] = ACTIONS(4009),
    [anon_sym_equals] = ACTIONS(4009),
    [anon_sym_let] = ACTIONS(4009),
    [anon_sym_orderby] = ACTIONS(4009),
    [anon_sym_ascending] = ACTIONS(4009),
    [anon_sym_descending] = ACTIONS(4009),
    [anon_sym_group] = ACTIONS(4009),
    [anon_sym_by] = ACTIONS(4009),
    [anon_sym_select] = ACTIONS(4009),
    [anon_sym_as] = ACTIONS(3721),
    [anon_sym_is] = ACTIONS(3721),
    [anon_sym_DASH_GT] = ACTIONS(3719),
    [anon_sym_with] = ACTIONS(3721),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2732] = {
    [sym_preproc_region] = STATE(2732),
    [sym_preproc_endregion] = STATE(2732),
    [sym_preproc_line] = STATE(2732),
    [sym_preproc_pragma] = STATE(2732),
    [sym_preproc_nullable] = STATE(2732),
    [sym_preproc_error] = STATE(2732),
    [sym_preproc_define] = STATE(2732),
    [sym_preproc_undef] = STATE(2732),
    [sym__identifier_token] = ACTIONS(3721),
    [anon_sym_alias] = ACTIONS(3721),
    [anon_sym_SEMI] = ACTIONS(3719),
    [anon_sym_global] = ACTIONS(3721),
    [anon_sym_EQ] = ACTIONS(3721),
    [anon_sym_LBRACK] = ACTIONS(3719),
    [anon_sym_COLON] = ACTIONS(3721),
    [anon_sym_COMMA] = ACTIONS(3719),
    [anon_sym_RBRACK] = ACTIONS(3719),
    [anon_sym_LPAREN] = ACTIONS(3719),
    [anon_sym_RPAREN] = ACTIONS(3719),
    [anon_sym_LBRACE] = ACTIONS(3719),
    [anon_sym_RBRACE] = ACTIONS(3719),
    [anon_sym_file] = ACTIONS(3721),
    [anon_sym_LT] = ACTIONS(3721),
    [anon_sym_GT] = ACTIONS(3721),
    [anon_sym_in] = ACTIONS(3721),
    [anon_sym_where] = ACTIONS(3721),
    [anon_sym_QMARK] = ACTIONS(3721),
    [anon_sym_notnull] = ACTIONS(3721),
    [anon_sym_unmanaged] = ACTIONS(3721),
    [anon_sym_operator] = ACTIONS(3721),
    [anon_sym_BANG] = ACTIONS(3721),
    [anon_sym_PLUS_PLUS] = ACTIONS(3719),
    [anon_sym_DASH_DASH] = ACTIONS(3719),
    [anon_sym_PLUS] = ACTIONS(3721),
    [anon_sym_DASH] = ACTIONS(3721),
    [anon_sym_STAR] = ACTIONS(3721),
    [anon_sym_SLASH] = ACTIONS(3721),
    [anon_sym_PERCENT] = ACTIONS(3721),
    [anon_sym_CARET] = ACTIONS(3721),
    [anon_sym_PIPE] = ACTIONS(3721),
    [anon_sym_AMP] = ACTIONS(3721),
    [anon_sym_LT_LT] = ACTIONS(3721),
    [anon_sym_GT_GT] = ACTIONS(3721),
    [anon_sym_GT_GT_GT] = ACTIONS(3721),
    [anon_sym_EQ_EQ] = ACTIONS(3719),
    [anon_sym_BANG_EQ] = ACTIONS(3719),
    [anon_sym_GT_EQ] = ACTIONS(3719),
    [anon_sym_LT_EQ] = ACTIONS(3719),
    [anon_sym_this] = ACTIONS(3721),
    [anon_sym_DOT] = ACTIONS(3721),
    [anon_sym_scoped] = ACTIONS(3721),
    [anon_sym_EQ_GT] = ACTIONS(3719),
    [anon_sym_COLON_COLON] = ACTIONS(3719),
    [anon_sym_var] = ACTIONS(3721),
    [anon_sym_yield] = ACTIONS(3721),
    [anon_sym_switch] = ACTIONS(3721),
    [anon_sym_when] = ACTIONS(3721),
    [sym_discard] = ACTIONS(3721),
    [anon_sym_DOT_DOT] = ACTIONS(3719),
    [anon_sym_and] = ACTIONS(3721),
    [anon_sym_or] = ACTIONS(3721),
    [anon_sym_PLUS_EQ] = ACTIONS(3719),
    [anon_sym_DASH_EQ] = ACTIONS(3719),
    [anon_sym_STAR_EQ] = ACTIONS(3719),
    [anon_sym_SLASH_EQ] = ACTIONS(3719),
    [anon_sym_PERCENT_EQ] = ACTIONS(3719),
    [anon_sym_AMP_EQ] = ACTIONS(3719),
    [anon_sym_CARET_EQ] = ACTIONS(3719),
    [anon_sym_PIPE_EQ] = ACTIONS(3719),
    [anon_sym_LT_LT_EQ] = ACTIONS(3719),
    [anon_sym_GT_GT_EQ] = ACTIONS(3719),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3719),
    [anon_sym_AMP_AMP] = ACTIONS(3719),
    [anon_sym_PIPE_PIPE] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK] = ACTIONS(3721),
    [anon_sym_from] = ACTIONS(3721),
    [anon_sym_into] = ACTIONS(3721),
    [anon_sym_join] = ACTIONS(3721),
    [anon_sym_on] = ACTIONS(3721),
    [anon_sym_equals] = ACTIONS(3721),
    [anon_sym_let] = ACTIONS(3721),
    [anon_sym_orderby] = ACTIONS(3721),
    [anon_sym_ascending] = ACTIONS(3721),
    [anon_sym_descending] = ACTIONS(3721),
    [anon_sym_group] = ACTIONS(3721),
    [anon_sym_by] = ACTIONS(3721),
    [anon_sym_select] = ACTIONS(3721),
    [anon_sym_as] = ACTIONS(3721),
    [anon_sym_is] = ACTIONS(3721),
    [anon_sym_DASH_GT] = ACTIONS(3719),
    [anon_sym_with] = ACTIONS(3721),
    [aux_sym_preproc_if_token3] = ACTIONS(3719),
    [aux_sym_preproc_else_token1] = ACTIONS(3719),
    [aux_sym_preproc_elif_token1] = ACTIONS(3719),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2733] = {
    [sym_preproc_region] = STATE(2733),
    [sym_preproc_endregion] = STATE(2733),
    [sym_preproc_line] = STATE(2733),
    [sym_preproc_pragma] = STATE(2733),
    [sym_preproc_nullable] = STATE(2733),
    [sym_preproc_error] = STATE(2733),
    [sym_preproc_define] = STATE(2733),
    [sym_preproc_undef] = STATE(2733),
    [sym__identifier_token] = ACTIONS(4056),
    [anon_sym_alias] = ACTIONS(4056),
    [anon_sym_SEMI] = ACTIONS(4058),
    [anon_sym_global] = ACTIONS(4056),
    [anon_sym_EQ] = ACTIONS(4056),
    [anon_sym_LBRACK] = ACTIONS(4058),
    [anon_sym_COLON] = ACTIONS(4056),
    [anon_sym_COMMA] = ACTIONS(4058),
    [anon_sym_RBRACK] = ACTIONS(4058),
    [anon_sym_LPAREN] = ACTIONS(4058),
    [anon_sym_RPAREN] = ACTIONS(4058),
    [anon_sym_LBRACE] = ACTIONS(4058),
    [anon_sym_RBRACE] = ACTIONS(4058),
    [anon_sym_file] = ACTIONS(4056),
    [anon_sym_LT] = ACTIONS(4056),
    [anon_sym_GT] = ACTIONS(4056),
    [anon_sym_in] = ACTIONS(4056),
    [anon_sym_where] = ACTIONS(4056),
    [anon_sym_QMARK] = ACTIONS(4056),
    [anon_sym_notnull] = ACTIONS(4056),
    [anon_sym_unmanaged] = ACTIONS(4056),
    [anon_sym_operator] = ACTIONS(4056),
    [anon_sym_BANG] = ACTIONS(4056),
    [anon_sym_PLUS_PLUS] = ACTIONS(4058),
    [anon_sym_DASH_DASH] = ACTIONS(4058),
    [anon_sym_PLUS] = ACTIONS(4056),
    [anon_sym_DASH] = ACTIONS(4056),
    [anon_sym_STAR] = ACTIONS(4056),
    [anon_sym_SLASH] = ACTIONS(4056),
    [anon_sym_PERCENT] = ACTIONS(4056),
    [anon_sym_CARET] = ACTIONS(4056),
    [anon_sym_PIPE] = ACTIONS(4056),
    [anon_sym_AMP] = ACTIONS(4056),
    [anon_sym_LT_LT] = ACTIONS(4056),
    [anon_sym_GT_GT] = ACTIONS(4056),
    [anon_sym_GT_GT_GT] = ACTIONS(4056),
    [anon_sym_EQ_EQ] = ACTIONS(4058),
    [anon_sym_BANG_EQ] = ACTIONS(4058),
    [anon_sym_GT_EQ] = ACTIONS(4058),
    [anon_sym_LT_EQ] = ACTIONS(4058),
    [anon_sym_this] = ACTIONS(4056),
    [anon_sym_DOT] = ACTIONS(4056),
    [anon_sym_scoped] = ACTIONS(4056),
    [anon_sym_EQ_GT] = ACTIONS(4058),
    [anon_sym_COLON_COLON] = ACTIONS(4058),
    [anon_sym_var] = ACTIONS(4056),
    [anon_sym_yield] = ACTIONS(4056),
    [anon_sym_switch] = ACTIONS(4056),
    [anon_sym_when] = ACTIONS(4056),
    [sym_discard] = ACTIONS(4056),
    [anon_sym_DOT_DOT] = ACTIONS(4058),
    [anon_sym_and] = ACTIONS(4056),
    [anon_sym_or] = ACTIONS(4056),
    [anon_sym_PLUS_EQ] = ACTIONS(4058),
    [anon_sym_DASH_EQ] = ACTIONS(4058),
    [anon_sym_STAR_EQ] = ACTIONS(4058),
    [anon_sym_SLASH_EQ] = ACTIONS(4058),
    [anon_sym_PERCENT_EQ] = ACTIONS(4058),
    [anon_sym_AMP_EQ] = ACTIONS(4058),
    [anon_sym_CARET_EQ] = ACTIONS(4058),
    [anon_sym_PIPE_EQ] = ACTIONS(4058),
    [anon_sym_LT_LT_EQ] = ACTIONS(4058),
    [anon_sym_GT_GT_EQ] = ACTIONS(4058),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4058),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4058),
    [anon_sym_AMP_AMP] = ACTIONS(4058),
    [anon_sym_PIPE_PIPE] = ACTIONS(4058),
    [anon_sym_QMARK_QMARK] = ACTIONS(4056),
    [anon_sym_from] = ACTIONS(4056),
    [anon_sym_into] = ACTIONS(4056),
    [anon_sym_join] = ACTIONS(4056),
    [anon_sym_on] = ACTIONS(4056),
    [anon_sym_equals] = ACTIONS(4056),
    [anon_sym_let] = ACTIONS(4056),
    [anon_sym_orderby] = ACTIONS(4056),
    [anon_sym_ascending] = ACTIONS(4056),
    [anon_sym_descending] = ACTIONS(4056),
    [anon_sym_group] = ACTIONS(4056),
    [anon_sym_by] = ACTIONS(4056),
    [anon_sym_select] = ACTIONS(4056),
    [anon_sym_as] = ACTIONS(4056),
    [anon_sym_is] = ACTIONS(4056),
    [anon_sym_DASH_GT] = ACTIONS(4058),
    [anon_sym_with] = ACTIONS(4056),
    [aux_sym_preproc_if_token3] = ACTIONS(4058),
    [aux_sym_preproc_else_token1] = ACTIONS(4058),
    [aux_sym_preproc_elif_token1] = ACTIONS(4058),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2734] = {
    [sym_preproc_region] = STATE(2734),
    [sym_preproc_endregion] = STATE(2734),
    [sym_preproc_line] = STATE(2734),
    [sym_preproc_pragma] = STATE(2734),
    [sym_preproc_nullable] = STATE(2734),
    [sym_preproc_error] = STATE(2734),
    [sym_preproc_define] = STATE(2734),
    [sym_preproc_undef] = STATE(2734),
    [sym__identifier_token] = ACTIONS(4060),
    [anon_sym_alias] = ACTIONS(4060),
    [anon_sym_SEMI] = ACTIONS(4062),
    [anon_sym_global] = ACTIONS(4060),
    [anon_sym_EQ] = ACTIONS(4060),
    [anon_sym_LBRACK] = ACTIONS(4062),
    [anon_sym_COLON] = ACTIONS(4062),
    [anon_sym_COMMA] = ACTIONS(4062),
    [anon_sym_RBRACK] = ACTIONS(4062),
    [anon_sym_LPAREN] = ACTIONS(4062),
    [anon_sym_RPAREN] = ACTIONS(4062),
    [anon_sym_LBRACE] = ACTIONS(4062),
    [anon_sym_RBRACE] = ACTIONS(4062),
    [anon_sym_file] = ACTIONS(4060),
    [anon_sym_LT] = ACTIONS(4060),
    [anon_sym_GT] = ACTIONS(4060),
    [anon_sym_in] = ACTIONS(4060),
    [anon_sym_where] = ACTIONS(4060),
    [anon_sym_QMARK] = ACTIONS(4060),
    [anon_sym_notnull] = ACTIONS(4060),
    [anon_sym_unmanaged] = ACTIONS(4060),
    [anon_sym_operator] = ACTIONS(4060),
    [anon_sym_BANG] = ACTIONS(4060),
    [anon_sym_PLUS_PLUS] = ACTIONS(4062),
    [anon_sym_DASH_DASH] = ACTIONS(4062),
    [anon_sym_PLUS] = ACTIONS(4060),
    [anon_sym_DASH] = ACTIONS(4060),
    [anon_sym_STAR] = ACTIONS(4060),
    [anon_sym_SLASH] = ACTIONS(4060),
    [anon_sym_PERCENT] = ACTIONS(4060),
    [anon_sym_CARET] = ACTIONS(4060),
    [anon_sym_PIPE] = ACTIONS(4060),
    [anon_sym_AMP] = ACTIONS(4060),
    [anon_sym_LT_LT] = ACTIONS(4060),
    [anon_sym_GT_GT] = ACTIONS(4060),
    [anon_sym_GT_GT_GT] = ACTIONS(4060),
    [anon_sym_EQ_EQ] = ACTIONS(4062),
    [anon_sym_BANG_EQ] = ACTIONS(4062),
    [anon_sym_GT_EQ] = ACTIONS(4062),
    [anon_sym_LT_EQ] = ACTIONS(4062),
    [anon_sym_this] = ACTIONS(4060),
    [anon_sym_DOT] = ACTIONS(4060),
    [anon_sym_scoped] = ACTIONS(4060),
    [anon_sym_EQ_GT] = ACTIONS(4062),
    [anon_sym_var] = ACTIONS(4060),
    [anon_sym_yield] = ACTIONS(4060),
    [anon_sym_switch] = ACTIONS(4060),
    [anon_sym_when] = ACTIONS(4060),
    [sym_discard] = ACTIONS(4060),
    [anon_sym_DOT_DOT] = ACTIONS(4062),
    [anon_sym_and] = ACTIONS(4060),
    [anon_sym_or] = ACTIONS(4060),
    [anon_sym_PLUS_EQ] = ACTIONS(4062),
    [anon_sym_DASH_EQ] = ACTIONS(4062),
    [anon_sym_STAR_EQ] = ACTIONS(4062),
    [anon_sym_SLASH_EQ] = ACTIONS(4062),
    [anon_sym_PERCENT_EQ] = ACTIONS(4062),
    [anon_sym_AMP_EQ] = ACTIONS(4062),
    [anon_sym_CARET_EQ] = ACTIONS(4062),
    [anon_sym_PIPE_EQ] = ACTIONS(4062),
    [anon_sym_LT_LT_EQ] = ACTIONS(4062),
    [anon_sym_GT_GT_EQ] = ACTIONS(4062),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4062),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4062),
    [anon_sym_AMP_AMP] = ACTIONS(4062),
    [anon_sym_PIPE_PIPE] = ACTIONS(4062),
    [anon_sym_QMARK_QMARK] = ACTIONS(4060),
    [anon_sym_from] = ACTIONS(4060),
    [anon_sym_into] = ACTIONS(4060),
    [anon_sym_join] = ACTIONS(4060),
    [anon_sym_on] = ACTIONS(4060),
    [anon_sym_equals] = ACTIONS(4060),
    [anon_sym_let] = ACTIONS(4060),
    [anon_sym_orderby] = ACTIONS(4060),
    [anon_sym_ascending] = ACTIONS(4060),
    [anon_sym_descending] = ACTIONS(4060),
    [anon_sym_group] = ACTIONS(4060),
    [anon_sym_by] = ACTIONS(4060),
    [anon_sym_select] = ACTIONS(4060),
    [anon_sym_as] = ACTIONS(4060),
    [anon_sym_is] = ACTIONS(4060),
    [anon_sym_DASH_GT] = ACTIONS(4062),
    [anon_sym_with] = ACTIONS(4060),
    [aux_sym_preproc_if_token3] = ACTIONS(4062),
    [aux_sym_preproc_else_token1] = ACTIONS(4062),
    [aux_sym_preproc_elif_token1] = ACTIONS(4062),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2735] = {
    [sym__name] = STATE(6820),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_ref_type] = STATE(2899),
    [sym__scoped_base_type] = STATE(2907),
    [sym_identifier] = STATE(6733),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_region] = STATE(2735),
    [sym_preproc_endregion] = STATE(2735),
    [sym_preproc_line] = STATE(2735),
    [sym_preproc_pragma] = STATE(2735),
    [sym_preproc_nullable] = STATE(2735),
    [sym_preproc_error] = STATE(2735),
    [sym_preproc_define] = STATE(2735),
    [sym_preproc_undef] = STATE(2735),
    [sym__identifier_token] = ACTIONS(4006),
    [anon_sym_alias] = ACTIONS(4009),
    [anon_sym_global] = ACTIONS(4009),
    [anon_sym_EQ] = ACTIONS(3721),
    [anon_sym_LBRACK] = ACTIONS(3719),
    [anon_sym_COLON] = ACTIONS(3721),
    [anon_sym_LPAREN] = ACTIONS(3719),
    [anon_sym_ref] = ACTIONS(4064),
    [anon_sym_LBRACE] = ACTIONS(3719),
    [anon_sym_file] = ACTIONS(4009),
    [anon_sym_LT] = ACTIONS(3721),
    [anon_sym_GT] = ACTIONS(3721),
    [anon_sym_where] = ACTIONS(4009),
    [anon_sym_QMARK] = ACTIONS(3721),
    [anon_sym_notnull] = ACTIONS(4009),
    [anon_sym_unmanaged] = ACTIONS(4009),
    [anon_sym_BANG] = ACTIONS(3721),
    [anon_sym_PLUS_PLUS] = ACTIONS(3719),
    [anon_sym_DASH_DASH] = ACTIONS(3719),
    [anon_sym_PLUS] = ACTIONS(3721),
    [anon_sym_DASH] = ACTIONS(3721),
    [anon_sym_STAR] = ACTIONS(3721),
    [anon_sym_SLASH] = ACTIONS(3721),
    [anon_sym_PERCENT] = ACTIONS(3721),
    [anon_sym_CARET] = ACTIONS(3721),
    [anon_sym_PIPE] = ACTIONS(3721),
    [anon_sym_AMP] = ACTIONS(3721),
    [anon_sym_LT_LT] = ACTIONS(3721),
    [anon_sym_GT_GT] = ACTIONS(3721),
    [anon_sym_GT_GT_GT] = ACTIONS(3721),
    [anon_sym_EQ_EQ] = ACTIONS(3719),
    [anon_sym_BANG_EQ] = ACTIONS(3719),
    [anon_sym_GT_EQ] = ACTIONS(3719),
    [anon_sym_LT_EQ] = ACTIONS(3719),
    [anon_sym_DOT] = ACTIONS(3721),
    [anon_sym_scoped] = ACTIONS(4009),
    [anon_sym_EQ_GT] = ACTIONS(3719),
    [anon_sym_COLON_COLON] = ACTIONS(3719),
    [anon_sym_var] = ACTIONS(4009),
    [anon_sym_yield] = ACTIONS(4009),
    [anon_sym_switch] = ACTIONS(3721),
    [anon_sym_when] = ACTIONS(4009),
    [sym_discard] = ACTIONS(3721),
    [anon_sym_DOT_DOT] = ACTIONS(3719),
    [anon_sym_and] = ACTIONS(3721),
    [anon_sym_or] = ACTIONS(3721),
    [anon_sym_PLUS_EQ] = ACTIONS(3719),
    [anon_sym_DASH_EQ] = ACTIONS(3719),
    [anon_sym_STAR_EQ] = ACTIONS(3719),
    [anon_sym_SLASH_EQ] = ACTIONS(3719),
    [anon_sym_PERCENT_EQ] = ACTIONS(3719),
    [anon_sym_AMP_EQ] = ACTIONS(3719),
    [anon_sym_CARET_EQ] = ACTIONS(3719),
    [anon_sym_PIPE_EQ] = ACTIONS(3719),
    [anon_sym_LT_LT_EQ] = ACTIONS(3719),
    [anon_sym_GT_GT_EQ] = ACTIONS(3719),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3719),
    [anon_sym_AMP_AMP] = ACTIONS(3719),
    [anon_sym_PIPE_PIPE] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK] = ACTIONS(3721),
    [anon_sym_from] = ACTIONS(4009),
    [anon_sym_into] = ACTIONS(4009),
    [anon_sym_join] = ACTIONS(4009),
    [anon_sym_on] = ACTIONS(4009),
    [anon_sym_equals] = ACTIONS(4009),
    [anon_sym_let] = ACTIONS(4009),
    [anon_sym_orderby] = ACTIONS(4009),
    [anon_sym_ascending] = ACTIONS(4009),
    [anon_sym_descending] = ACTIONS(4009),
    [anon_sym_group] = ACTIONS(4009),
    [anon_sym_by] = ACTIONS(4009),
    [anon_sym_select] = ACTIONS(4009),
    [anon_sym_as] = ACTIONS(3721),
    [anon_sym_is] = ACTIONS(3721),
    [anon_sym_DASH_GT] = ACTIONS(3719),
    [anon_sym_with] = ACTIONS(3721),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2736] = {
    [sym_preproc_region] = STATE(2736),
    [sym_preproc_endregion] = STATE(2736),
    [sym_preproc_line] = STATE(2736),
    [sym_preproc_pragma] = STATE(2736),
    [sym_preproc_nullable] = STATE(2736),
    [sym_preproc_error] = STATE(2736),
    [sym_preproc_define] = STATE(2736),
    [sym_preproc_undef] = STATE(2736),
    [sym__identifier_token] = ACTIONS(4066),
    [anon_sym_alias] = ACTIONS(4066),
    [anon_sym_SEMI] = ACTIONS(4068),
    [anon_sym_global] = ACTIONS(4066),
    [anon_sym_EQ] = ACTIONS(4066),
    [anon_sym_LBRACK] = ACTIONS(4068),
    [anon_sym_COLON] = ACTIONS(4068),
    [anon_sym_COMMA] = ACTIONS(4068),
    [anon_sym_RBRACK] = ACTIONS(4068),
    [anon_sym_LPAREN] = ACTIONS(4068),
    [anon_sym_RPAREN] = ACTIONS(4068),
    [anon_sym_LBRACE] = ACTIONS(4068),
    [anon_sym_RBRACE] = ACTIONS(4068),
    [anon_sym_file] = ACTIONS(4066),
    [anon_sym_LT] = ACTIONS(4066),
    [anon_sym_GT] = ACTIONS(4066),
    [anon_sym_in] = ACTIONS(4066),
    [anon_sym_where] = ACTIONS(4066),
    [anon_sym_QMARK] = ACTIONS(4066),
    [anon_sym_notnull] = ACTIONS(4066),
    [anon_sym_unmanaged] = ACTIONS(4066),
    [anon_sym_operator] = ACTIONS(4066),
    [anon_sym_BANG] = ACTIONS(4066),
    [anon_sym_PLUS_PLUS] = ACTIONS(4068),
    [anon_sym_DASH_DASH] = ACTIONS(4068),
    [anon_sym_PLUS] = ACTIONS(4066),
    [anon_sym_DASH] = ACTIONS(4066),
    [anon_sym_STAR] = ACTIONS(4066),
    [anon_sym_SLASH] = ACTIONS(4066),
    [anon_sym_PERCENT] = ACTIONS(4066),
    [anon_sym_CARET] = ACTIONS(4066),
    [anon_sym_PIPE] = ACTIONS(4066),
    [anon_sym_AMP] = ACTIONS(4066),
    [anon_sym_LT_LT] = ACTIONS(4066),
    [anon_sym_GT_GT] = ACTIONS(4066),
    [anon_sym_GT_GT_GT] = ACTIONS(4066),
    [anon_sym_EQ_EQ] = ACTIONS(4068),
    [anon_sym_BANG_EQ] = ACTIONS(4068),
    [anon_sym_GT_EQ] = ACTIONS(4068),
    [anon_sym_LT_EQ] = ACTIONS(4068),
    [anon_sym_this] = ACTIONS(4066),
    [anon_sym_DOT] = ACTIONS(4066),
    [anon_sym_scoped] = ACTIONS(4066),
    [anon_sym_EQ_GT] = ACTIONS(4068),
    [anon_sym_var] = ACTIONS(4066),
    [anon_sym_yield] = ACTIONS(4066),
    [anon_sym_switch] = ACTIONS(4066),
    [anon_sym_when] = ACTIONS(4066),
    [sym_discard] = ACTIONS(4066),
    [anon_sym_DOT_DOT] = ACTIONS(4068),
    [anon_sym_and] = ACTIONS(4066),
    [anon_sym_or] = ACTIONS(4066),
    [anon_sym_PLUS_EQ] = ACTIONS(4068),
    [anon_sym_DASH_EQ] = ACTIONS(4068),
    [anon_sym_STAR_EQ] = ACTIONS(4068),
    [anon_sym_SLASH_EQ] = ACTIONS(4068),
    [anon_sym_PERCENT_EQ] = ACTIONS(4068),
    [anon_sym_AMP_EQ] = ACTIONS(4068),
    [anon_sym_CARET_EQ] = ACTIONS(4068),
    [anon_sym_PIPE_EQ] = ACTIONS(4068),
    [anon_sym_LT_LT_EQ] = ACTIONS(4068),
    [anon_sym_GT_GT_EQ] = ACTIONS(4068),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4068),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4068),
    [anon_sym_AMP_AMP] = ACTIONS(4068),
    [anon_sym_PIPE_PIPE] = ACTIONS(4068),
    [anon_sym_QMARK_QMARK] = ACTIONS(4066),
    [anon_sym_from] = ACTIONS(4066),
    [anon_sym_into] = ACTIONS(4066),
    [anon_sym_join] = ACTIONS(4066),
    [anon_sym_on] = ACTIONS(4066),
    [anon_sym_equals] = ACTIONS(4066),
    [anon_sym_let] = ACTIONS(4066),
    [anon_sym_orderby] = ACTIONS(4066),
    [anon_sym_ascending] = ACTIONS(4066),
    [anon_sym_descending] = ACTIONS(4066),
    [anon_sym_group] = ACTIONS(4066),
    [anon_sym_by] = ACTIONS(4066),
    [anon_sym_select] = ACTIONS(4066),
    [anon_sym_as] = ACTIONS(4066),
    [anon_sym_is] = ACTIONS(4066),
    [anon_sym_DASH_GT] = ACTIONS(4068),
    [anon_sym_with] = ACTIONS(4066),
    [aux_sym_preproc_if_token3] = ACTIONS(4068),
    [aux_sym_preproc_else_token1] = ACTIONS(4068),
    [aux_sym_preproc_elif_token1] = ACTIONS(4068),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2737] = {
    [sym_preproc_region] = STATE(2737),
    [sym_preproc_endregion] = STATE(2737),
    [sym_preproc_line] = STATE(2737),
    [sym_preproc_pragma] = STATE(2737),
    [sym_preproc_nullable] = STATE(2737),
    [sym_preproc_error] = STATE(2737),
    [sym_preproc_define] = STATE(2737),
    [sym_preproc_undef] = STATE(2737),
    [sym__identifier_token] = ACTIONS(4070),
    [anon_sym_alias] = ACTIONS(4070),
    [anon_sym_SEMI] = ACTIONS(4072),
    [anon_sym_global] = ACTIONS(4070),
    [anon_sym_EQ] = ACTIONS(4070),
    [anon_sym_LBRACK] = ACTIONS(4072),
    [anon_sym_COLON] = ACTIONS(4072),
    [anon_sym_COMMA] = ACTIONS(4072),
    [anon_sym_RBRACK] = ACTIONS(4072),
    [anon_sym_LPAREN] = ACTIONS(4072),
    [anon_sym_RPAREN] = ACTIONS(4072),
    [anon_sym_LBRACE] = ACTIONS(4072),
    [anon_sym_RBRACE] = ACTIONS(4072),
    [anon_sym_file] = ACTIONS(4070),
    [anon_sym_LT] = ACTIONS(4070),
    [anon_sym_GT] = ACTIONS(4070),
    [anon_sym_in] = ACTIONS(4070),
    [anon_sym_where] = ACTIONS(4070),
    [anon_sym_QMARK] = ACTIONS(4070),
    [anon_sym_notnull] = ACTIONS(4070),
    [anon_sym_unmanaged] = ACTIONS(4070),
    [anon_sym_operator] = ACTIONS(4070),
    [anon_sym_BANG] = ACTIONS(4070),
    [anon_sym_PLUS_PLUS] = ACTIONS(4072),
    [anon_sym_DASH_DASH] = ACTIONS(4072),
    [anon_sym_PLUS] = ACTIONS(4070),
    [anon_sym_DASH] = ACTIONS(4070),
    [anon_sym_STAR] = ACTIONS(4070),
    [anon_sym_SLASH] = ACTIONS(4070),
    [anon_sym_PERCENT] = ACTIONS(4070),
    [anon_sym_CARET] = ACTIONS(4070),
    [anon_sym_PIPE] = ACTIONS(4070),
    [anon_sym_AMP] = ACTIONS(4070),
    [anon_sym_LT_LT] = ACTIONS(4070),
    [anon_sym_GT_GT] = ACTIONS(4070),
    [anon_sym_GT_GT_GT] = ACTIONS(4070),
    [anon_sym_EQ_EQ] = ACTIONS(4072),
    [anon_sym_BANG_EQ] = ACTIONS(4072),
    [anon_sym_GT_EQ] = ACTIONS(4072),
    [anon_sym_LT_EQ] = ACTIONS(4072),
    [anon_sym_this] = ACTIONS(4070),
    [anon_sym_DOT] = ACTIONS(4070),
    [anon_sym_scoped] = ACTIONS(4070),
    [anon_sym_EQ_GT] = ACTIONS(4072),
    [anon_sym_var] = ACTIONS(4070),
    [anon_sym_yield] = ACTIONS(4070),
    [anon_sym_switch] = ACTIONS(4070),
    [anon_sym_when] = ACTIONS(4070),
    [sym_discard] = ACTIONS(4070),
    [anon_sym_DOT_DOT] = ACTIONS(4072),
    [anon_sym_and] = ACTIONS(4070),
    [anon_sym_or] = ACTIONS(4070),
    [anon_sym_PLUS_EQ] = ACTIONS(4072),
    [anon_sym_DASH_EQ] = ACTIONS(4072),
    [anon_sym_STAR_EQ] = ACTIONS(4072),
    [anon_sym_SLASH_EQ] = ACTIONS(4072),
    [anon_sym_PERCENT_EQ] = ACTIONS(4072),
    [anon_sym_AMP_EQ] = ACTIONS(4072),
    [anon_sym_CARET_EQ] = ACTIONS(4072),
    [anon_sym_PIPE_EQ] = ACTIONS(4072),
    [anon_sym_LT_LT_EQ] = ACTIONS(4072),
    [anon_sym_GT_GT_EQ] = ACTIONS(4072),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4072),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4072),
    [anon_sym_AMP_AMP] = ACTIONS(4072),
    [anon_sym_PIPE_PIPE] = ACTIONS(4072),
    [anon_sym_QMARK_QMARK] = ACTIONS(4070),
    [anon_sym_from] = ACTIONS(4070),
    [anon_sym_into] = ACTIONS(4070),
    [anon_sym_join] = ACTIONS(4070),
    [anon_sym_on] = ACTIONS(4070),
    [anon_sym_equals] = ACTIONS(4070),
    [anon_sym_let] = ACTIONS(4070),
    [anon_sym_orderby] = ACTIONS(4070),
    [anon_sym_ascending] = ACTIONS(4070),
    [anon_sym_descending] = ACTIONS(4070),
    [anon_sym_group] = ACTIONS(4070),
    [anon_sym_by] = ACTIONS(4070),
    [anon_sym_select] = ACTIONS(4070),
    [anon_sym_as] = ACTIONS(4070),
    [anon_sym_is] = ACTIONS(4070),
    [anon_sym_DASH_GT] = ACTIONS(4072),
    [anon_sym_with] = ACTIONS(4070),
    [aux_sym_preproc_if_token3] = ACTIONS(4072),
    [aux_sym_preproc_else_token1] = ACTIONS(4072),
    [aux_sym_preproc_elif_token1] = ACTIONS(4072),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2738] = {
    [sym_preproc_region] = STATE(2738),
    [sym_preproc_endregion] = STATE(2738),
    [sym_preproc_line] = STATE(2738),
    [sym_preproc_pragma] = STATE(2738),
    [sym_preproc_nullable] = STATE(2738),
    [sym_preproc_error] = STATE(2738),
    [sym_preproc_define] = STATE(2738),
    [sym_preproc_undef] = STATE(2738),
    [sym__identifier_token] = ACTIONS(4074),
    [anon_sym_alias] = ACTIONS(4074),
    [anon_sym_SEMI] = ACTIONS(4076),
    [anon_sym_global] = ACTIONS(4074),
    [anon_sym_EQ] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4076),
    [anon_sym_COLON] = ACTIONS(4076),
    [anon_sym_COMMA] = ACTIONS(4076),
    [anon_sym_RBRACK] = ACTIONS(4076),
    [anon_sym_LPAREN] = ACTIONS(4076),
    [anon_sym_RPAREN] = ACTIONS(4076),
    [anon_sym_LBRACE] = ACTIONS(4076),
    [anon_sym_RBRACE] = ACTIONS(4076),
    [anon_sym_file] = ACTIONS(4074),
    [anon_sym_LT] = ACTIONS(4074),
    [anon_sym_GT] = ACTIONS(4074),
    [anon_sym_in] = ACTIONS(4074),
    [anon_sym_where] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(4074),
    [anon_sym_notnull] = ACTIONS(4074),
    [anon_sym_unmanaged] = ACTIONS(4074),
    [anon_sym_operator] = ACTIONS(4074),
    [anon_sym_BANG] = ACTIONS(4074),
    [anon_sym_PLUS_PLUS] = ACTIONS(4076),
    [anon_sym_DASH_DASH] = ACTIONS(4076),
    [anon_sym_PLUS] = ACTIONS(4074),
    [anon_sym_DASH] = ACTIONS(4074),
    [anon_sym_STAR] = ACTIONS(4074),
    [anon_sym_SLASH] = ACTIONS(4074),
    [anon_sym_PERCENT] = ACTIONS(4074),
    [anon_sym_CARET] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(4074),
    [anon_sym_AMP] = ACTIONS(4074),
    [anon_sym_LT_LT] = ACTIONS(4074),
    [anon_sym_GT_GT] = ACTIONS(4074),
    [anon_sym_GT_GT_GT] = ACTIONS(4074),
    [anon_sym_EQ_EQ] = ACTIONS(4076),
    [anon_sym_BANG_EQ] = ACTIONS(4076),
    [anon_sym_GT_EQ] = ACTIONS(4076),
    [anon_sym_LT_EQ] = ACTIONS(4076),
    [anon_sym_this] = ACTIONS(4074),
    [anon_sym_DOT] = ACTIONS(4074),
    [anon_sym_scoped] = ACTIONS(4074),
    [anon_sym_EQ_GT] = ACTIONS(4076),
    [anon_sym_var] = ACTIONS(4074),
    [anon_sym_yield] = ACTIONS(4074),
    [anon_sym_switch] = ACTIONS(4074),
    [anon_sym_when] = ACTIONS(4074),
    [sym_discard] = ACTIONS(4074),
    [anon_sym_DOT_DOT] = ACTIONS(4076),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_PLUS_EQ] = ACTIONS(4076),
    [anon_sym_DASH_EQ] = ACTIONS(4076),
    [anon_sym_STAR_EQ] = ACTIONS(4076),
    [anon_sym_SLASH_EQ] = ACTIONS(4076),
    [anon_sym_PERCENT_EQ] = ACTIONS(4076),
    [anon_sym_AMP_EQ] = ACTIONS(4076),
    [anon_sym_CARET_EQ] = ACTIONS(4076),
    [anon_sym_PIPE_EQ] = ACTIONS(4076),
    [anon_sym_LT_LT_EQ] = ACTIONS(4076),
    [anon_sym_GT_GT_EQ] = ACTIONS(4076),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4076),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4076),
    [anon_sym_AMP_AMP] = ACTIONS(4076),
    [anon_sym_PIPE_PIPE] = ACTIONS(4076),
    [anon_sym_QMARK_QMARK] = ACTIONS(4074),
    [anon_sym_from] = ACTIONS(4074),
    [anon_sym_into] = ACTIONS(4074),
    [anon_sym_join] = ACTIONS(4074),
    [anon_sym_on] = ACTIONS(4074),
    [anon_sym_equals] = ACTIONS(4074),
    [anon_sym_let] = ACTIONS(4074),
    [anon_sym_orderby] = ACTIONS(4074),
    [anon_sym_ascending] = ACTIONS(4074),
    [anon_sym_descending] = ACTIONS(4074),
    [anon_sym_group] = ACTIONS(4074),
    [anon_sym_by] = ACTIONS(4074),
    [anon_sym_select] = ACTIONS(4074),
    [anon_sym_as] = ACTIONS(4074),
    [anon_sym_is] = ACTIONS(4074),
    [anon_sym_DASH_GT] = ACTIONS(4076),
    [anon_sym_with] = ACTIONS(4074),
    [aux_sym_preproc_if_token3] = ACTIONS(4076),
    [aux_sym_preproc_else_token1] = ACTIONS(4076),
    [aux_sym_preproc_elif_token1] = ACTIONS(4076),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2739] = {
    [sym__name] = STATE(6160),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_ref_type] = STATE(2899),
    [sym__scoped_base_type] = STATE(2907),
    [sym_identifier] = STATE(5368),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_region] = STATE(2739),
    [sym_preproc_endregion] = STATE(2739),
    [sym_preproc_line] = STATE(2739),
    [sym_preproc_pragma] = STATE(2739),
    [sym_preproc_nullable] = STATE(2739),
    [sym_preproc_error] = STATE(2739),
    [sym_preproc_define] = STATE(2739),
    [sym_preproc_undef] = STATE(2739),
    [sym__identifier_token] = ACTIONS(4006),
    [anon_sym_alias] = ACTIONS(4009),
    [anon_sym_global] = ACTIONS(4009),
    [anon_sym_EQ] = ACTIONS(3721),
    [anon_sym_LBRACK] = ACTIONS(3719),
    [anon_sym_COLON] = ACTIONS(3721),
    [anon_sym_COMMA] = ACTIONS(3719),
    [anon_sym_LPAREN] = ACTIONS(3719),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_file] = ACTIONS(4009),
    [anon_sym_LT] = ACTIONS(3721),
    [anon_sym_GT] = ACTIONS(3721),
    [anon_sym_where] = ACTIONS(4009),
    [anon_sym_QMARK] = ACTIONS(3721),
    [anon_sym_notnull] = ACTIONS(4009),
    [anon_sym_unmanaged] = ACTIONS(4009),
    [anon_sym_BANG] = ACTIONS(3721),
    [anon_sym_PLUS_PLUS] = ACTIONS(3719),
    [anon_sym_DASH_DASH] = ACTIONS(3719),
    [anon_sym_PLUS] = ACTIONS(3721),
    [anon_sym_DASH] = ACTIONS(3721),
    [anon_sym_STAR] = ACTIONS(3721),
    [anon_sym_SLASH] = ACTIONS(3721),
    [anon_sym_PERCENT] = ACTIONS(3721),
    [anon_sym_CARET] = ACTIONS(3721),
    [anon_sym_PIPE] = ACTIONS(3721),
    [anon_sym_AMP] = ACTIONS(3721),
    [anon_sym_LT_LT] = ACTIONS(3721),
    [anon_sym_GT_GT] = ACTIONS(3721),
    [anon_sym_GT_GT_GT] = ACTIONS(3721),
    [anon_sym_EQ_EQ] = ACTIONS(3719),
    [anon_sym_BANG_EQ] = ACTIONS(3719),
    [anon_sym_GT_EQ] = ACTIONS(3719),
    [anon_sym_LT_EQ] = ACTIONS(3719),
    [anon_sym_DOT] = ACTIONS(3721),
    [anon_sym_scoped] = ACTIONS(4009),
    [anon_sym_EQ_GT] = ACTIONS(3719),
    [anon_sym_COLON_COLON] = ACTIONS(3719),
    [anon_sym_var] = ACTIONS(4009),
    [anon_sym_yield] = ACTIONS(4009),
    [anon_sym_switch] = ACTIONS(3721),
    [anon_sym_when] = ACTIONS(4009),
    [anon_sym_DOT_DOT] = ACTIONS(3719),
    [anon_sym_and] = ACTIONS(3721),
    [anon_sym_or] = ACTIONS(3721),
    [anon_sym_PLUS_EQ] = ACTIONS(3719),
    [anon_sym_DASH_EQ] = ACTIONS(3719),
    [anon_sym_STAR_EQ] = ACTIONS(3719),
    [anon_sym_SLASH_EQ] = ACTIONS(3719),
    [anon_sym_PERCENT_EQ] = ACTIONS(3719),
    [anon_sym_AMP_EQ] = ACTIONS(3719),
    [anon_sym_CARET_EQ] = ACTIONS(3719),
    [anon_sym_PIPE_EQ] = ACTIONS(3719),
    [anon_sym_LT_LT_EQ] = ACTIONS(3719),
    [anon_sym_GT_GT_EQ] = ACTIONS(3719),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3719),
    [anon_sym_AMP_AMP] = ACTIONS(3719),
    [anon_sym_PIPE_PIPE] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK] = ACTIONS(3721),
    [anon_sym_from] = ACTIONS(4009),
    [anon_sym_into] = ACTIONS(4009),
    [anon_sym_join] = ACTIONS(4009),
    [anon_sym_on] = ACTIONS(4009),
    [anon_sym_equals] = ACTIONS(4009),
    [anon_sym_let] = ACTIONS(4009),
    [anon_sym_orderby] = ACTIONS(4009),
    [anon_sym_ascending] = ACTIONS(4009),
    [anon_sym_descending] = ACTIONS(4009),
    [anon_sym_group] = ACTIONS(4009),
    [anon_sym_by] = ACTIONS(4009),
    [anon_sym_select] = ACTIONS(4009),
    [anon_sym_as] = ACTIONS(3721),
    [anon_sym_is] = ACTIONS(3721),
    [anon_sym_DASH_GT] = ACTIONS(3719),
    [anon_sym_with] = ACTIONS(3721),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(3719),
  },
  [2740] = {
    [sym_type_argument_list] = STATE(2736),
    [sym_preproc_region] = STATE(2740),
    [sym_preproc_endregion] = STATE(2740),
    [sym_preproc_line] = STATE(2740),
    [sym_preproc_pragma] = STATE(2740),
    [sym_preproc_nullable] = STATE(2740),
    [sym_preproc_error] = STATE(2740),
    [sym_preproc_define] = STATE(2740),
    [sym_preproc_undef] = STATE(2740),
    [sym__identifier_token] = ACTIONS(4074),
    [anon_sym_alias] = ACTIONS(4074),
    [anon_sym_SEMI] = ACTIONS(4076),
    [anon_sym_global] = ACTIONS(4074),
    [anon_sym_EQ] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4076),
    [anon_sym_COLON] = ACTIONS(4074),
    [anon_sym_COMMA] = ACTIONS(4076),
    [anon_sym_RBRACK] = ACTIONS(4076),
    [anon_sym_LPAREN] = ACTIONS(4076),
    [anon_sym_RPAREN] = ACTIONS(4076),
    [anon_sym_LBRACE] = ACTIONS(4076),
    [anon_sym_RBRACE] = ACTIONS(4076),
    [anon_sym_file] = ACTIONS(4074),
    [anon_sym_LT] = ACTIONS(4078),
    [anon_sym_GT] = ACTIONS(4074),
    [anon_sym_in] = ACTIONS(4074),
    [anon_sym_where] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(4074),
    [anon_sym_notnull] = ACTIONS(4074),
    [anon_sym_unmanaged] = ACTIONS(4074),
    [anon_sym_BANG] = ACTIONS(4074),
    [anon_sym_PLUS_PLUS] = ACTIONS(4076),
    [anon_sym_DASH_DASH] = ACTIONS(4076),
    [anon_sym_PLUS] = ACTIONS(4074),
    [anon_sym_DASH] = ACTIONS(4074),
    [anon_sym_STAR] = ACTIONS(4074),
    [anon_sym_SLASH] = ACTIONS(4074),
    [anon_sym_PERCENT] = ACTIONS(4074),
    [anon_sym_CARET] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(4074),
    [anon_sym_AMP] = ACTIONS(4074),
    [anon_sym_LT_LT] = ACTIONS(4074),
    [anon_sym_GT_GT] = ACTIONS(4074),
    [anon_sym_GT_GT_GT] = ACTIONS(4074),
    [anon_sym_EQ_EQ] = ACTIONS(4076),
    [anon_sym_BANG_EQ] = ACTIONS(4076),
    [anon_sym_GT_EQ] = ACTIONS(4076),
    [anon_sym_LT_EQ] = ACTIONS(4076),
    [anon_sym_DOT] = ACTIONS(4074),
    [anon_sym_scoped] = ACTIONS(4074),
    [anon_sym_EQ_GT] = ACTIONS(4081),
    [anon_sym_COLON_COLON] = ACTIONS(4083),
    [anon_sym_var] = ACTIONS(4074),
    [anon_sym_yield] = ACTIONS(4074),
    [anon_sym_switch] = ACTIONS(4074),
    [anon_sym_when] = ACTIONS(4074),
    [sym_discard] = ACTIONS(4074),
    [anon_sym_DOT_DOT] = ACTIONS(4076),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_PLUS_EQ] = ACTIONS(4076),
    [anon_sym_DASH_EQ] = ACTIONS(4076),
    [anon_sym_STAR_EQ] = ACTIONS(4076),
    [anon_sym_SLASH_EQ] = ACTIONS(4076),
    [anon_sym_PERCENT_EQ] = ACTIONS(4076),
    [anon_sym_AMP_EQ] = ACTIONS(4076),
    [anon_sym_CARET_EQ] = ACTIONS(4076),
    [anon_sym_PIPE_EQ] = ACTIONS(4076),
    [anon_sym_LT_LT_EQ] = ACTIONS(4076),
    [anon_sym_GT_GT_EQ] = ACTIONS(4076),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4076),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4076),
    [anon_sym_AMP_AMP] = ACTIONS(4076),
    [anon_sym_PIPE_PIPE] = ACTIONS(4076),
    [anon_sym_QMARK_QMARK] = ACTIONS(4074),
    [anon_sym_from] = ACTIONS(4074),
    [anon_sym_into] = ACTIONS(4074),
    [anon_sym_join] = ACTIONS(4074),
    [anon_sym_on] = ACTIONS(4074),
    [anon_sym_equals] = ACTIONS(4074),
    [anon_sym_let] = ACTIONS(4074),
    [anon_sym_orderby] = ACTIONS(4074),
    [anon_sym_ascending] = ACTIONS(4074),
    [anon_sym_descending] = ACTIONS(4074),
    [anon_sym_group] = ACTIONS(4074),
    [anon_sym_by] = ACTIONS(4074),
    [anon_sym_select] = ACTIONS(4074),
    [anon_sym_as] = ACTIONS(4074),
    [anon_sym_is] = ACTIONS(4074),
    [anon_sym_DASH_GT] = ACTIONS(4076),
    [anon_sym_with] = ACTIONS(4074),
    [aux_sym_preproc_if_token3] = ACTIONS(4076),
    [aux_sym_preproc_else_token1] = ACTIONS(4076),
    [aux_sym_preproc_elif_token1] = ACTIONS(4076),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2741] = {
    [sym_preproc_region] = STATE(2741),
    [sym_preproc_endregion] = STATE(2741),
    [sym_preproc_line] = STATE(2741),
    [sym_preproc_pragma] = STATE(2741),
    [sym_preproc_nullable] = STATE(2741),
    [sym_preproc_error] = STATE(2741),
    [sym_preproc_define] = STATE(2741),
    [sym_preproc_undef] = STATE(2741),
    [sym__identifier_token] = ACTIONS(4085),
    [anon_sym_alias] = ACTIONS(4085),
    [anon_sym_SEMI] = ACTIONS(4087),
    [anon_sym_global] = ACTIONS(4085),
    [anon_sym_EQ] = ACTIONS(4085),
    [anon_sym_LBRACK] = ACTIONS(4087),
    [anon_sym_COLON] = ACTIONS(4087),
    [anon_sym_COMMA] = ACTIONS(4087),
    [anon_sym_RBRACK] = ACTIONS(4087),
    [anon_sym_LPAREN] = ACTIONS(4087),
    [anon_sym_RPAREN] = ACTIONS(4087),
    [anon_sym_LBRACE] = ACTIONS(4087),
    [anon_sym_RBRACE] = ACTIONS(4087),
    [anon_sym_file] = ACTIONS(4085),
    [anon_sym_LT] = ACTIONS(4085),
    [anon_sym_GT] = ACTIONS(4085),
    [anon_sym_in] = ACTIONS(4085),
    [anon_sym_where] = ACTIONS(4085),
    [anon_sym_QMARK] = ACTIONS(4085),
    [anon_sym_notnull] = ACTIONS(4085),
    [anon_sym_unmanaged] = ACTIONS(4085),
    [anon_sym_operator] = ACTIONS(4085),
    [anon_sym_BANG] = ACTIONS(4085),
    [anon_sym_PLUS_PLUS] = ACTIONS(4087),
    [anon_sym_DASH_DASH] = ACTIONS(4087),
    [anon_sym_PLUS] = ACTIONS(4085),
    [anon_sym_DASH] = ACTIONS(4085),
    [anon_sym_STAR] = ACTIONS(4085),
    [anon_sym_SLASH] = ACTIONS(4085),
    [anon_sym_PERCENT] = ACTIONS(4085),
    [anon_sym_CARET] = ACTIONS(4085),
    [anon_sym_PIPE] = ACTIONS(4085),
    [anon_sym_AMP] = ACTIONS(4085),
    [anon_sym_LT_LT] = ACTIONS(4085),
    [anon_sym_GT_GT] = ACTIONS(4085),
    [anon_sym_GT_GT_GT] = ACTIONS(4085),
    [anon_sym_EQ_EQ] = ACTIONS(4087),
    [anon_sym_BANG_EQ] = ACTIONS(4087),
    [anon_sym_GT_EQ] = ACTIONS(4087),
    [anon_sym_LT_EQ] = ACTIONS(4087),
    [anon_sym_this] = ACTIONS(4085),
    [anon_sym_DOT] = ACTIONS(4085),
    [anon_sym_scoped] = ACTIONS(4085),
    [anon_sym_EQ_GT] = ACTIONS(4087),
    [anon_sym_var] = ACTIONS(4085),
    [anon_sym_yield] = ACTIONS(4085),
    [anon_sym_switch] = ACTIONS(4085),
    [anon_sym_when] = ACTIONS(4085),
    [sym_discard] = ACTIONS(4085),
    [anon_sym_DOT_DOT] = ACTIONS(4087),
    [anon_sym_and] = ACTIONS(4085),
    [anon_sym_or] = ACTIONS(4085),
    [anon_sym_PLUS_EQ] = ACTIONS(4087),
    [anon_sym_DASH_EQ] = ACTIONS(4087),
    [anon_sym_STAR_EQ] = ACTIONS(4087),
    [anon_sym_SLASH_EQ] = ACTIONS(4087),
    [anon_sym_PERCENT_EQ] = ACTIONS(4087),
    [anon_sym_AMP_EQ] = ACTIONS(4087),
    [anon_sym_CARET_EQ] = ACTIONS(4087),
    [anon_sym_PIPE_EQ] = ACTIONS(4087),
    [anon_sym_LT_LT_EQ] = ACTIONS(4087),
    [anon_sym_GT_GT_EQ] = ACTIONS(4087),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4087),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4087),
    [anon_sym_AMP_AMP] = ACTIONS(4087),
    [anon_sym_PIPE_PIPE] = ACTIONS(4087),
    [anon_sym_QMARK_QMARK] = ACTIONS(4085),
    [anon_sym_from] = ACTIONS(4085),
    [anon_sym_into] = ACTIONS(4085),
    [anon_sym_join] = ACTIONS(4085),
    [anon_sym_on] = ACTIONS(4085),
    [anon_sym_equals] = ACTIONS(4085),
    [anon_sym_let] = ACTIONS(4085),
    [anon_sym_orderby] = ACTIONS(4085),
    [anon_sym_ascending] = ACTIONS(4085),
    [anon_sym_descending] = ACTIONS(4085),
    [anon_sym_group] = ACTIONS(4085),
    [anon_sym_by] = ACTIONS(4085),
    [anon_sym_select] = ACTIONS(4085),
    [anon_sym_as] = ACTIONS(4085),
    [anon_sym_is] = ACTIONS(4085),
    [anon_sym_DASH_GT] = ACTIONS(4087),
    [anon_sym_with] = ACTIONS(4085),
    [aux_sym_preproc_if_token3] = ACTIONS(4087),
    [aux_sym_preproc_else_token1] = ACTIONS(4087),
    [aux_sym_preproc_elif_token1] = ACTIONS(4087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2742] = {
    [sym_type_argument_list] = STATE(2736),
    [sym_preproc_region] = STATE(2742),
    [sym_preproc_endregion] = STATE(2742),
    [sym_preproc_line] = STATE(2742),
    [sym_preproc_pragma] = STATE(2742),
    [sym_preproc_nullable] = STATE(2742),
    [sym_preproc_error] = STATE(2742),
    [sym_preproc_define] = STATE(2742),
    [sym_preproc_undef] = STATE(2742),
    [sym__identifier_token] = ACTIONS(4074),
    [anon_sym_alias] = ACTIONS(4074),
    [anon_sym_SEMI] = ACTIONS(4076),
    [anon_sym_global] = ACTIONS(4074),
    [anon_sym_EQ] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4076),
    [anon_sym_COMMA] = ACTIONS(4076),
    [anon_sym_RBRACK] = ACTIONS(4076),
    [anon_sym_LPAREN] = ACTIONS(4076),
    [anon_sym_RPAREN] = ACTIONS(4076),
    [anon_sym_LBRACE] = ACTIONS(4076),
    [anon_sym_RBRACE] = ACTIONS(4076),
    [anon_sym_file] = ACTIONS(4074),
    [anon_sym_LT] = ACTIONS(4078),
    [anon_sym_GT] = ACTIONS(4074),
    [anon_sym_in] = ACTIONS(4074),
    [anon_sym_where] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(4074),
    [anon_sym_notnull] = ACTIONS(4074),
    [anon_sym_unmanaged] = ACTIONS(4074),
    [anon_sym_BANG] = ACTIONS(4074),
    [anon_sym_PLUS_PLUS] = ACTIONS(4076),
    [anon_sym_DASH_DASH] = ACTIONS(4076),
    [anon_sym_PLUS] = ACTIONS(4074),
    [anon_sym_DASH] = ACTIONS(4074),
    [anon_sym_STAR] = ACTIONS(4074),
    [anon_sym_SLASH] = ACTIONS(4074),
    [anon_sym_PERCENT] = ACTIONS(4074),
    [anon_sym_CARET] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(4074),
    [anon_sym_AMP] = ACTIONS(4074),
    [anon_sym_LT_LT] = ACTIONS(4074),
    [anon_sym_GT_GT] = ACTIONS(4074),
    [anon_sym_GT_GT_GT] = ACTIONS(4074),
    [anon_sym_EQ_EQ] = ACTIONS(4076),
    [anon_sym_BANG_EQ] = ACTIONS(4076),
    [anon_sym_GT_EQ] = ACTIONS(4076),
    [anon_sym_LT_EQ] = ACTIONS(4076),
    [anon_sym_DOT] = ACTIONS(4074),
    [anon_sym_scoped] = ACTIONS(4074),
    [anon_sym_EQ_GT] = ACTIONS(4081),
    [anon_sym_COLON_COLON] = ACTIONS(4089),
    [anon_sym_var] = ACTIONS(4074),
    [anon_sym_yield] = ACTIONS(4074),
    [anon_sym_switch] = ACTIONS(4074),
    [anon_sym_when] = ACTIONS(4074),
    [sym_discard] = ACTIONS(4074),
    [anon_sym_DOT_DOT] = ACTIONS(4076),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_PLUS_EQ] = ACTIONS(4076),
    [anon_sym_DASH_EQ] = ACTIONS(4076),
    [anon_sym_STAR_EQ] = ACTIONS(4076),
    [anon_sym_SLASH_EQ] = ACTIONS(4076),
    [anon_sym_PERCENT_EQ] = ACTIONS(4076),
    [anon_sym_AMP_EQ] = ACTIONS(4076),
    [anon_sym_CARET_EQ] = ACTIONS(4076),
    [anon_sym_PIPE_EQ] = ACTIONS(4076),
    [anon_sym_LT_LT_EQ] = ACTIONS(4076),
    [anon_sym_GT_GT_EQ] = ACTIONS(4076),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4076),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4076),
    [anon_sym_AMP_AMP] = ACTIONS(4076),
    [anon_sym_PIPE_PIPE] = ACTIONS(4076),
    [anon_sym_QMARK_QMARK] = ACTIONS(4074),
    [anon_sym_from] = ACTIONS(4074),
    [anon_sym_into] = ACTIONS(4074),
    [anon_sym_join] = ACTIONS(4074),
    [anon_sym_on] = ACTIONS(4074),
    [anon_sym_equals] = ACTIONS(4074),
    [anon_sym_let] = ACTIONS(4074),
    [anon_sym_orderby] = ACTIONS(4074),
    [anon_sym_ascending] = ACTIONS(4074),
    [anon_sym_descending] = ACTIONS(4074),
    [anon_sym_group] = ACTIONS(4074),
    [anon_sym_by] = ACTIONS(4074),
    [anon_sym_select] = ACTIONS(4074),
    [anon_sym_as] = ACTIONS(4074),
    [anon_sym_is] = ACTIONS(4074),
    [anon_sym_DASH_GT] = ACTIONS(4076),
    [anon_sym_with] = ACTIONS(4074),
    [aux_sym_preproc_if_token3] = ACTIONS(4076),
    [aux_sym_preproc_else_token1] = ACTIONS(4076),
    [aux_sym_preproc_elif_token1] = ACTIONS(4076),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2743] = {
    [sym_preproc_region] = STATE(2743),
    [sym_preproc_endregion] = STATE(2743),
    [sym_preproc_line] = STATE(2743),
    [sym_preproc_pragma] = STATE(2743),
    [sym_preproc_nullable] = STATE(2743),
    [sym_preproc_error] = STATE(2743),
    [sym_preproc_define] = STATE(2743),
    [sym_preproc_undef] = STATE(2743),
    [sym__identifier_token] = ACTIONS(4027),
    [anon_sym_alias] = ACTIONS(4027),
    [anon_sym_SEMI] = ACTIONS(4024),
    [anon_sym_global] = ACTIONS(4027),
    [anon_sym_EQ] = ACTIONS(3721),
    [anon_sym_LBRACK] = ACTIONS(4024),
    [anon_sym_COLON] = ACTIONS(4027),
    [anon_sym_COMMA] = ACTIONS(4024),
    [anon_sym_RBRACK] = ACTIONS(4024),
    [anon_sym_LPAREN] = ACTIONS(4024),
    [anon_sym_RPAREN] = ACTIONS(4024),
    [anon_sym_LBRACE] = ACTIONS(4024),
    [anon_sym_RBRACE] = ACTIONS(4024),
    [anon_sym_file] = ACTIONS(4027),
    [anon_sym_LT] = ACTIONS(4027),
    [anon_sym_GT] = ACTIONS(4027),
    [anon_sym_in] = ACTIONS(4027),
    [anon_sym_where] = ACTIONS(4027),
    [anon_sym_QMARK] = ACTIONS(4027),
    [anon_sym_notnull] = ACTIONS(4027),
    [anon_sym_unmanaged] = ACTIONS(4027),
    [anon_sym_BANG] = ACTIONS(4027),
    [anon_sym_PLUS_PLUS] = ACTIONS(4024),
    [anon_sym_DASH_DASH] = ACTIONS(4024),
    [anon_sym_PLUS] = ACTIONS(4027),
    [anon_sym_DASH] = ACTIONS(4027),
    [anon_sym_STAR] = ACTIONS(4027),
    [anon_sym_SLASH] = ACTIONS(4027),
    [anon_sym_PERCENT] = ACTIONS(4027),
    [anon_sym_CARET] = ACTIONS(4027),
    [anon_sym_PIPE] = ACTIONS(4027),
    [anon_sym_AMP] = ACTIONS(4027),
    [anon_sym_LT_LT] = ACTIONS(4027),
    [anon_sym_GT_GT] = ACTIONS(4027),
    [anon_sym_GT_GT_GT] = ACTIONS(4027),
    [anon_sym_EQ_EQ] = ACTIONS(4024),
    [anon_sym_BANG_EQ] = ACTIONS(4024),
    [anon_sym_GT_EQ] = ACTIONS(4024),
    [anon_sym_LT_EQ] = ACTIONS(4024),
    [anon_sym_DOT] = ACTIONS(4027),
    [anon_sym_scoped] = ACTIONS(4027),
    [anon_sym_EQ_GT] = ACTIONS(3719),
    [anon_sym_COLON_COLON] = ACTIONS(3719),
    [anon_sym_var] = ACTIONS(4027),
    [anon_sym_yield] = ACTIONS(4027),
    [anon_sym_switch] = ACTIONS(4027),
    [anon_sym_when] = ACTIONS(4027),
    [sym_discard] = ACTIONS(4027),
    [anon_sym_DOT_DOT] = ACTIONS(4024),
    [anon_sym_and] = ACTIONS(4027),
    [anon_sym_or] = ACTIONS(4027),
    [anon_sym_PLUS_EQ] = ACTIONS(3719),
    [anon_sym_DASH_EQ] = ACTIONS(3719),
    [anon_sym_STAR_EQ] = ACTIONS(3719),
    [anon_sym_SLASH_EQ] = ACTIONS(3719),
    [anon_sym_PERCENT_EQ] = ACTIONS(3719),
    [anon_sym_AMP_EQ] = ACTIONS(3719),
    [anon_sym_CARET_EQ] = ACTIONS(3719),
    [anon_sym_PIPE_EQ] = ACTIONS(3719),
    [anon_sym_LT_LT_EQ] = ACTIONS(3719),
    [anon_sym_GT_GT_EQ] = ACTIONS(3719),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3719),
    [anon_sym_AMP_AMP] = ACTIONS(4024),
    [anon_sym_PIPE_PIPE] = ACTIONS(4024),
    [anon_sym_QMARK_QMARK] = ACTIONS(4027),
    [anon_sym_from] = ACTIONS(4027),
    [anon_sym_into] = ACTIONS(4027),
    [anon_sym_join] = ACTIONS(4027),
    [anon_sym_on] = ACTIONS(4027),
    [anon_sym_equals] = ACTIONS(4027),
    [anon_sym_let] = ACTIONS(4027),
    [anon_sym_orderby] = ACTIONS(4027),
    [anon_sym_ascending] = ACTIONS(4027),
    [anon_sym_descending] = ACTIONS(4027),
    [anon_sym_group] = ACTIONS(4027),
    [anon_sym_by] = ACTIONS(4027),
    [anon_sym_select] = ACTIONS(4027),
    [anon_sym_as] = ACTIONS(4027),
    [anon_sym_is] = ACTIONS(4027),
    [anon_sym_DASH_GT] = ACTIONS(4024),
    [anon_sym_with] = ACTIONS(4027),
    [aux_sym_preproc_if_token3] = ACTIONS(4024),
    [aux_sym_preproc_else_token1] = ACTIONS(4024),
    [aux_sym_preproc_elif_token1] = ACTIONS(4024),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2744] = {
    [sym_type_argument_list] = STATE(2736),
    [sym_preproc_region] = STATE(2744),
    [sym_preproc_endregion] = STATE(2744),
    [sym_preproc_line] = STATE(2744),
    [sym_preproc_pragma] = STATE(2744),
    [sym_preproc_nullable] = STATE(2744),
    [sym_preproc_error] = STATE(2744),
    [sym_preproc_define] = STATE(2744),
    [sym_preproc_undef] = STATE(2744),
    [sym__identifier_token] = ACTIONS(4074),
    [anon_sym_alias] = ACTIONS(4074),
    [anon_sym_SEMI] = ACTIONS(4076),
    [anon_sym_global] = ACTIONS(4074),
    [anon_sym_EQ] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4076),
    [anon_sym_COLON] = ACTIONS(4076),
    [anon_sym_COMMA] = ACTIONS(4076),
    [anon_sym_RBRACK] = ACTIONS(4076),
    [anon_sym_LPAREN] = ACTIONS(4076),
    [anon_sym_RPAREN] = ACTIONS(4076),
    [anon_sym_LBRACE] = ACTIONS(4076),
    [anon_sym_RBRACE] = ACTIONS(4076),
    [anon_sym_file] = ACTIONS(4074),
    [anon_sym_LT] = ACTIONS(4078),
    [anon_sym_GT] = ACTIONS(4074),
    [anon_sym_in] = ACTIONS(4074),
    [anon_sym_where] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(4074),
    [anon_sym_notnull] = ACTIONS(4074),
    [anon_sym_unmanaged] = ACTIONS(4074),
    [anon_sym_BANG] = ACTIONS(4074),
    [anon_sym_PLUS_PLUS] = ACTIONS(4076),
    [anon_sym_DASH_DASH] = ACTIONS(4076),
    [anon_sym_PLUS] = ACTIONS(4074),
    [anon_sym_DASH] = ACTIONS(4074),
    [anon_sym_STAR] = ACTIONS(4074),
    [anon_sym_SLASH] = ACTIONS(4074),
    [anon_sym_PERCENT] = ACTIONS(4074),
    [anon_sym_CARET] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(4074),
    [anon_sym_AMP] = ACTIONS(4074),
    [anon_sym_LT_LT] = ACTIONS(4074),
    [anon_sym_GT_GT] = ACTIONS(4074),
    [anon_sym_GT_GT_GT] = ACTIONS(4074),
    [anon_sym_EQ_EQ] = ACTIONS(4076),
    [anon_sym_BANG_EQ] = ACTIONS(4076),
    [anon_sym_GT_EQ] = ACTIONS(4076),
    [anon_sym_LT_EQ] = ACTIONS(4076),
    [anon_sym_DOT] = ACTIONS(4074),
    [anon_sym_scoped] = ACTIONS(4074),
    [anon_sym_EQ_GT] = ACTIONS(4076),
    [anon_sym_var] = ACTIONS(4074),
    [anon_sym_yield] = ACTIONS(4074),
    [anon_sym_switch] = ACTIONS(4074),
    [anon_sym_when] = ACTIONS(4074),
    [sym_discard] = ACTIONS(4074),
    [anon_sym_DOT_DOT] = ACTIONS(4076),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_PLUS_EQ] = ACTIONS(4076),
    [anon_sym_DASH_EQ] = ACTIONS(4076),
    [anon_sym_STAR_EQ] = ACTIONS(4076),
    [anon_sym_SLASH_EQ] = ACTIONS(4076),
    [anon_sym_PERCENT_EQ] = ACTIONS(4076),
    [anon_sym_AMP_EQ] = ACTIONS(4076),
    [anon_sym_CARET_EQ] = ACTIONS(4076),
    [anon_sym_PIPE_EQ] = ACTIONS(4076),
    [anon_sym_LT_LT_EQ] = ACTIONS(4076),
    [anon_sym_GT_GT_EQ] = ACTIONS(4076),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4076),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4076),
    [anon_sym_AMP_AMP] = ACTIONS(4076),
    [anon_sym_PIPE_PIPE] = ACTIONS(4076),
    [anon_sym_QMARK_QMARK] = ACTIONS(4074),
    [anon_sym_from] = ACTIONS(4074),
    [anon_sym_into] = ACTIONS(4074),
    [anon_sym_join] = ACTIONS(4074),
    [anon_sym_on] = ACTIONS(4074),
    [anon_sym_equals] = ACTIONS(4074),
    [anon_sym_let] = ACTIONS(4074),
    [anon_sym_orderby] = ACTIONS(4074),
    [anon_sym_ascending] = ACTIONS(4074),
    [anon_sym_descending] = ACTIONS(4074),
    [anon_sym_group] = ACTIONS(4074),
    [anon_sym_by] = ACTIONS(4074),
    [anon_sym_select] = ACTIONS(4074),
    [anon_sym_as] = ACTIONS(4074),
    [anon_sym_is] = ACTIONS(4074),
    [anon_sym_DASH_GT] = ACTIONS(4076),
    [anon_sym_with] = ACTIONS(4074),
    [aux_sym_preproc_if_token3] = ACTIONS(4076),
    [aux_sym_preproc_else_token1] = ACTIONS(4076),
    [aux_sym_preproc_elif_token1] = ACTIONS(4076),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2745] = {
    [sym__variable_designation] = STATE(4270),
    [sym_parenthesized_variable_designation] = STATE(4274),
    [sym_identifier] = STATE(4269),
    [sym__reserved_identifier] = STATE(3127),
    [sym_preproc_region] = STATE(2745),
    [sym_preproc_endregion] = STATE(2745),
    [sym_preproc_line] = STATE(2745),
    [sym_preproc_pragma] = STATE(2745),
    [sym_preproc_nullable] = STATE(2745),
    [sym_preproc_error] = STATE(2745),
    [sym_preproc_define] = STATE(2745),
    [sym_preproc_undef] = STATE(2745),
    [sym__identifier_token] = ACTIONS(4091),
    [anon_sym_alias] = ACTIONS(4095),
    [anon_sym_global] = ACTIONS(4095),
    [anon_sym_EQ] = ACTIONS(3721),
    [anon_sym_LBRACK] = ACTIONS(3719),
    [anon_sym_COLON] = ACTIONS(3721),
    [anon_sym_COMMA] = ACTIONS(4024),
    [anon_sym_RBRACK] = ACTIONS(4024),
    [anon_sym_LPAREN] = ACTIONS(4046),
    [anon_sym_RPAREN] = ACTIONS(4024),
    [anon_sym_LBRACE] = ACTIONS(4024),
    [anon_sym_RBRACE] = ACTIONS(4024),
    [anon_sym_file] = ACTIONS(4095),
    [anon_sym_LT] = ACTIONS(3721),
    [anon_sym_GT] = ACTIONS(3721),
    [anon_sym_where] = ACTIONS(4095),
    [anon_sym_QMARK] = ACTIONS(3721),
    [anon_sym_notnull] = ACTIONS(4095),
    [anon_sym_unmanaged] = ACTIONS(4095),
    [anon_sym_BANG] = ACTIONS(3721),
    [anon_sym_PLUS_PLUS] = ACTIONS(3719),
    [anon_sym_DASH_DASH] = ACTIONS(3719),
    [anon_sym_PLUS] = ACTIONS(3721),
    [anon_sym_DASH] = ACTIONS(3721),
    [anon_sym_STAR] = ACTIONS(3721),
    [anon_sym_SLASH] = ACTIONS(3721),
    [anon_sym_PERCENT] = ACTIONS(3721),
    [anon_sym_CARET] = ACTIONS(3721),
    [anon_sym_PIPE] = ACTIONS(3721),
    [anon_sym_AMP] = ACTIONS(3721),
    [anon_sym_LT_LT] = ACTIONS(3721),
    [anon_sym_GT_GT] = ACTIONS(3721),
    [anon_sym_GT_GT_GT] = ACTIONS(3721),
    [anon_sym_EQ_EQ] = ACTIONS(3719),
    [anon_sym_BANG_EQ] = ACTIONS(3719),
    [anon_sym_GT_EQ] = ACTIONS(3719),
    [anon_sym_LT_EQ] = ACTIONS(3719),
    [anon_sym_DOT] = ACTIONS(3721),
    [anon_sym_scoped] = ACTIONS(4095),
    [anon_sym_EQ_GT] = ACTIONS(3719),
    [anon_sym_COLON_COLON] = ACTIONS(3719),
    [anon_sym_var] = ACTIONS(4095),
    [anon_sym_yield] = ACTIONS(4095),
    [anon_sym_switch] = ACTIONS(3721),
    [anon_sym_when] = ACTIONS(4095),
    [sym_discard] = ACTIONS(4050),
    [anon_sym_DOT_DOT] = ACTIONS(3719),
    [anon_sym_and] = ACTIONS(4027),
    [anon_sym_or] = ACTIONS(4027),
    [anon_sym_PLUS_EQ] = ACTIONS(3719),
    [anon_sym_DASH_EQ] = ACTIONS(3719),
    [anon_sym_STAR_EQ] = ACTIONS(3719),
    [anon_sym_SLASH_EQ] = ACTIONS(3719),
    [anon_sym_PERCENT_EQ] = ACTIONS(3719),
    [anon_sym_AMP_EQ] = ACTIONS(3719),
    [anon_sym_CARET_EQ] = ACTIONS(3719),
    [anon_sym_PIPE_EQ] = ACTIONS(3719),
    [anon_sym_LT_LT_EQ] = ACTIONS(3719),
    [anon_sym_GT_GT_EQ] = ACTIONS(3719),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3719),
    [anon_sym_AMP_AMP] = ACTIONS(3719),
    [anon_sym_PIPE_PIPE] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK] = ACTIONS(3721),
    [anon_sym_from] = ACTIONS(4095),
    [anon_sym_into] = ACTIONS(4095),
    [anon_sym_join] = ACTIONS(4095),
    [anon_sym_on] = ACTIONS(4095),
    [anon_sym_equals] = ACTIONS(4095),
    [anon_sym_let] = ACTIONS(4095),
    [anon_sym_orderby] = ACTIONS(4095),
    [anon_sym_ascending] = ACTIONS(4095),
    [anon_sym_descending] = ACTIONS(4095),
    [anon_sym_group] = ACTIONS(4095),
    [anon_sym_by] = ACTIONS(4095),
    [anon_sym_select] = ACTIONS(4095),
    [anon_sym_as] = ACTIONS(3721),
    [anon_sym_is] = ACTIONS(3721),
    [anon_sym_DASH_GT] = ACTIONS(3719),
    [anon_sym_with] = ACTIONS(3721),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2746] = {
    [sym_preproc_region] = STATE(2746),
    [sym_preproc_endregion] = STATE(2746),
    [sym_preproc_line] = STATE(2746),
    [sym_preproc_pragma] = STATE(2746),
    [sym_preproc_nullable] = STATE(2746),
    [sym_preproc_error] = STATE(2746),
    [sym_preproc_define] = STATE(2746),
    [sym_preproc_undef] = STATE(2746),
    [sym__identifier_token] = ACTIONS(4099),
    [anon_sym_alias] = ACTIONS(4099),
    [anon_sym_SEMI] = ACTIONS(4101),
    [anon_sym_global] = ACTIONS(4099),
    [anon_sym_EQ] = ACTIONS(4104),
    [anon_sym_LBRACK] = ACTIONS(4101),
    [anon_sym_COLON] = ACTIONS(4101),
    [anon_sym_COMMA] = ACTIONS(4101),
    [anon_sym_RBRACK] = ACTIONS(4101),
    [anon_sym_LPAREN] = ACTIONS(4101),
    [anon_sym_RPAREN] = ACTIONS(4101),
    [anon_sym_LBRACE] = ACTIONS(4106),
    [anon_sym_RBRACE] = ACTIONS(4101),
    [anon_sym_file] = ACTIONS(4099),
    [anon_sym_LT] = ACTIONS(4108),
    [anon_sym_GT] = ACTIONS(4108),
    [anon_sym_in] = ACTIONS(4108),
    [anon_sym_where] = ACTIONS(4099),
    [anon_sym_QMARK] = ACTIONS(4108),
    [anon_sym_notnull] = ACTIONS(4099),
    [anon_sym_unmanaged] = ACTIONS(4099),
    [anon_sym_BANG] = ACTIONS(4108),
    [anon_sym_PLUS_PLUS] = ACTIONS(4101),
    [anon_sym_DASH_DASH] = ACTIONS(4101),
    [anon_sym_PLUS] = ACTIONS(4108),
    [anon_sym_DASH] = ACTIONS(4108),
    [anon_sym_STAR] = ACTIONS(4108),
    [anon_sym_SLASH] = ACTIONS(4108),
    [anon_sym_PERCENT] = ACTIONS(4108),
    [anon_sym_CARET] = ACTIONS(4108),
    [anon_sym_PIPE] = ACTIONS(4108),
    [anon_sym_AMP] = ACTIONS(4108),
    [anon_sym_LT_LT] = ACTIONS(4108),
    [anon_sym_GT_GT] = ACTIONS(4108),
    [anon_sym_GT_GT_GT] = ACTIONS(4108),
    [anon_sym_EQ_EQ] = ACTIONS(4101),
    [anon_sym_BANG_EQ] = ACTIONS(4101),
    [anon_sym_GT_EQ] = ACTIONS(4101),
    [anon_sym_LT_EQ] = ACTIONS(4101),
    [anon_sym_DOT] = ACTIONS(4108),
    [anon_sym_scoped] = ACTIONS(4099),
    [anon_sym_EQ_GT] = ACTIONS(4101),
    [anon_sym_var] = ACTIONS(4099),
    [anon_sym_yield] = ACTIONS(4099),
    [anon_sym_switch] = ACTIONS(4108),
    [anon_sym_when] = ACTIONS(4099),
    [sym_discard] = ACTIONS(4099),
    [anon_sym_DOT_DOT] = ACTIONS(4101),
    [anon_sym_and] = ACTIONS(4108),
    [anon_sym_or] = ACTIONS(4108),
    [anon_sym_PLUS_EQ] = ACTIONS(4111),
    [anon_sym_DASH_EQ] = ACTIONS(4111),
    [anon_sym_STAR_EQ] = ACTIONS(4111),
    [anon_sym_SLASH_EQ] = ACTIONS(4111),
    [anon_sym_PERCENT_EQ] = ACTIONS(4111),
    [anon_sym_AMP_EQ] = ACTIONS(4111),
    [anon_sym_CARET_EQ] = ACTIONS(4111),
    [anon_sym_PIPE_EQ] = ACTIONS(4111),
    [anon_sym_LT_LT_EQ] = ACTIONS(4111),
    [anon_sym_GT_GT_EQ] = ACTIONS(4111),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4111),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4111),
    [anon_sym_AMP_AMP] = ACTIONS(4101),
    [anon_sym_PIPE_PIPE] = ACTIONS(4101),
    [anon_sym_QMARK_QMARK] = ACTIONS(4108),
    [anon_sym_from] = ACTIONS(4099),
    [anon_sym_into] = ACTIONS(4108),
    [anon_sym_join] = ACTIONS(4099),
    [anon_sym_on] = ACTIONS(4099),
    [anon_sym_equals] = ACTIONS(4099),
    [anon_sym_let] = ACTIONS(4099),
    [anon_sym_orderby] = ACTIONS(4099),
    [anon_sym_ascending] = ACTIONS(4099),
    [anon_sym_descending] = ACTIONS(4099),
    [anon_sym_group] = ACTIONS(4099),
    [anon_sym_by] = ACTIONS(4099),
    [anon_sym_select] = ACTIONS(4099),
    [anon_sym_as] = ACTIONS(4108),
    [anon_sym_is] = ACTIONS(4108),
    [anon_sym_DASH_GT] = ACTIONS(4101),
    [anon_sym_with] = ACTIONS(4108),
    [aux_sym_preproc_if_token3] = ACTIONS(4101),
    [aux_sym_preproc_else_token1] = ACTIONS(4101),
    [aux_sym_preproc_elif_token1] = ACTIONS(4101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2747] = {
    [sym_preproc_region] = STATE(2747),
    [sym_preproc_endregion] = STATE(2747),
    [sym_preproc_line] = STATE(2747),
    [sym_preproc_pragma] = STATE(2747),
    [sym_preproc_nullable] = STATE(2747),
    [sym_preproc_error] = STATE(2747),
    [sym_preproc_define] = STATE(2747),
    [sym_preproc_undef] = STATE(2747),
    [sym__identifier_token] = ACTIONS(4113),
    [anon_sym_alias] = ACTIONS(4113),
    [anon_sym_SEMI] = ACTIONS(4115),
    [anon_sym_global] = ACTIONS(4113),
    [anon_sym_EQ] = ACTIONS(4118),
    [anon_sym_LBRACK] = ACTIONS(4120),
    [anon_sym_COLON] = ACTIONS(4115),
    [anon_sym_COMMA] = ACTIONS(4115),
    [anon_sym_RBRACK] = ACTIONS(4115),
    [anon_sym_LPAREN] = ACTIONS(4120),
    [anon_sym_RPAREN] = ACTIONS(4115),
    [anon_sym_LBRACE] = ACTIONS(4124),
    [anon_sym_RBRACE] = ACTIONS(4115),
    [anon_sym_file] = ACTIONS(4113),
    [anon_sym_LT] = ACTIONS(4126),
    [anon_sym_GT] = ACTIONS(4126),
    [anon_sym_in] = ACTIONS(4130),
    [anon_sym_where] = ACTIONS(4113),
    [anon_sym_QMARK] = ACTIONS(4126),
    [anon_sym_notnull] = ACTIONS(4113),
    [anon_sym_unmanaged] = ACTIONS(4113),
    [anon_sym_BANG] = ACTIONS(4126),
    [anon_sym_PLUS_PLUS] = ACTIONS(4120),
    [anon_sym_DASH_DASH] = ACTIONS(4120),
    [anon_sym_PLUS] = ACTIONS(4126),
    [anon_sym_DASH] = ACTIONS(4126),
    [anon_sym_STAR] = ACTIONS(4126),
    [anon_sym_SLASH] = ACTIONS(4126),
    [anon_sym_PERCENT] = ACTIONS(4126),
    [anon_sym_CARET] = ACTIONS(4126),
    [anon_sym_PIPE] = ACTIONS(4126),
    [anon_sym_AMP] = ACTIONS(4126),
    [anon_sym_LT_LT] = ACTIONS(4126),
    [anon_sym_GT_GT] = ACTIONS(4126),
    [anon_sym_GT_GT_GT] = ACTIONS(4126),
    [anon_sym_EQ_EQ] = ACTIONS(4120),
    [anon_sym_BANG_EQ] = ACTIONS(4120),
    [anon_sym_GT_EQ] = ACTIONS(4120),
    [anon_sym_LT_EQ] = ACTIONS(4120),
    [anon_sym_DOT] = ACTIONS(4126),
    [anon_sym_scoped] = ACTIONS(4113),
    [anon_sym_EQ_GT] = ACTIONS(4115),
    [anon_sym_var] = ACTIONS(4113),
    [anon_sym_yield] = ACTIONS(4113),
    [anon_sym_switch] = ACTIONS(4126),
    [anon_sym_when] = ACTIONS(4113),
    [sym_discard] = ACTIONS(4113),
    [anon_sym_DOT_DOT] = ACTIONS(4120),
    [anon_sym_and] = ACTIONS(4130),
    [anon_sym_or] = ACTIONS(4130),
    [anon_sym_PLUS_EQ] = ACTIONS(4133),
    [anon_sym_DASH_EQ] = ACTIONS(4133),
    [anon_sym_STAR_EQ] = ACTIONS(4133),
    [anon_sym_SLASH_EQ] = ACTIONS(4133),
    [anon_sym_PERCENT_EQ] = ACTIONS(4133),
    [anon_sym_AMP_EQ] = ACTIONS(4133),
    [anon_sym_CARET_EQ] = ACTIONS(4133),
    [anon_sym_PIPE_EQ] = ACTIONS(4133),
    [anon_sym_LT_LT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4133),
    [anon_sym_AMP_AMP] = ACTIONS(4120),
    [anon_sym_PIPE_PIPE] = ACTIONS(4120),
    [anon_sym_QMARK_QMARK] = ACTIONS(4126),
    [anon_sym_from] = ACTIONS(4113),
    [anon_sym_into] = ACTIONS(4130),
    [anon_sym_join] = ACTIONS(4113),
    [anon_sym_on] = ACTIONS(4113),
    [anon_sym_equals] = ACTIONS(4113),
    [anon_sym_let] = ACTIONS(4113),
    [anon_sym_orderby] = ACTIONS(4113),
    [anon_sym_ascending] = ACTIONS(4113),
    [anon_sym_descending] = ACTIONS(4113),
    [anon_sym_group] = ACTIONS(4113),
    [anon_sym_by] = ACTIONS(4113),
    [anon_sym_select] = ACTIONS(4113),
    [anon_sym_as] = ACTIONS(4126),
    [anon_sym_is] = ACTIONS(4126),
    [anon_sym_DASH_GT] = ACTIONS(4120),
    [anon_sym_with] = ACTIONS(4126),
    [aux_sym_preproc_if_token3] = ACTIONS(4115),
    [aux_sym_preproc_else_token1] = ACTIONS(4115),
    [aux_sym_preproc_elif_token1] = ACTIONS(4115),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2748] = {
    [sym_preproc_region] = STATE(2748),
    [sym_preproc_endregion] = STATE(2748),
    [sym_preproc_line] = STATE(2748),
    [sym_preproc_pragma] = STATE(2748),
    [sym_preproc_nullable] = STATE(2748),
    [sym_preproc_error] = STATE(2748),
    [sym_preproc_define] = STATE(2748),
    [sym_preproc_undef] = STATE(2748),
    [sym__identifier_token] = ACTIONS(4099),
    [anon_sym_alias] = ACTIONS(4099),
    [anon_sym_SEMI] = ACTIONS(4106),
    [anon_sym_global] = ACTIONS(4099),
    [anon_sym_EQ] = ACTIONS(4104),
    [anon_sym_LBRACK] = ACTIONS(4101),
    [anon_sym_COLON] = ACTIONS(4106),
    [anon_sym_COMMA] = ACTIONS(4106),
    [anon_sym_RBRACK] = ACTIONS(4106),
    [anon_sym_LPAREN] = ACTIONS(4101),
    [anon_sym_RPAREN] = ACTIONS(4106),
    [anon_sym_LBRACE] = ACTIONS(4106),
    [anon_sym_RBRACE] = ACTIONS(4106),
    [anon_sym_file] = ACTIONS(4099),
    [anon_sym_LT] = ACTIONS(4108),
    [anon_sym_GT] = ACTIONS(4108),
    [anon_sym_in] = ACTIONS(4099),
    [anon_sym_where] = ACTIONS(4099),
    [anon_sym_QMARK] = ACTIONS(4108),
    [anon_sym_notnull] = ACTIONS(4099),
    [anon_sym_unmanaged] = ACTIONS(4099),
    [anon_sym_BANG] = ACTIONS(4108),
    [anon_sym_PLUS_PLUS] = ACTIONS(4101),
    [anon_sym_DASH_DASH] = ACTIONS(4101),
    [anon_sym_PLUS] = ACTIONS(4108),
    [anon_sym_DASH] = ACTIONS(4108),
    [anon_sym_STAR] = ACTIONS(4108),
    [anon_sym_SLASH] = ACTIONS(4108),
    [anon_sym_PERCENT] = ACTIONS(4108),
    [anon_sym_CARET] = ACTIONS(4108),
    [anon_sym_PIPE] = ACTIONS(4108),
    [anon_sym_AMP] = ACTIONS(4108),
    [anon_sym_LT_LT] = ACTIONS(4108),
    [anon_sym_GT_GT] = ACTIONS(4108),
    [anon_sym_GT_GT_GT] = ACTIONS(4108),
    [anon_sym_EQ_EQ] = ACTIONS(4101),
    [anon_sym_BANG_EQ] = ACTIONS(4101),
    [anon_sym_GT_EQ] = ACTIONS(4101),
    [anon_sym_LT_EQ] = ACTIONS(4101),
    [anon_sym_DOT] = ACTIONS(4108),
    [anon_sym_scoped] = ACTIONS(4099),
    [anon_sym_EQ_GT] = ACTIONS(4106),
    [anon_sym_var] = ACTIONS(4099),
    [anon_sym_yield] = ACTIONS(4099),
    [anon_sym_switch] = ACTIONS(4108),
    [anon_sym_when] = ACTIONS(4099),
    [sym_discard] = ACTIONS(4099),
    [anon_sym_DOT_DOT] = ACTIONS(4101),
    [anon_sym_and] = ACTIONS(4099),
    [anon_sym_or] = ACTIONS(4099),
    [anon_sym_PLUS_EQ] = ACTIONS(4111),
    [anon_sym_DASH_EQ] = ACTIONS(4111),
    [anon_sym_STAR_EQ] = ACTIONS(4111),
    [anon_sym_SLASH_EQ] = ACTIONS(4111),
    [anon_sym_PERCENT_EQ] = ACTIONS(4111),
    [anon_sym_AMP_EQ] = ACTIONS(4111),
    [anon_sym_CARET_EQ] = ACTIONS(4111),
    [anon_sym_PIPE_EQ] = ACTIONS(4111),
    [anon_sym_LT_LT_EQ] = ACTIONS(4111),
    [anon_sym_GT_GT_EQ] = ACTIONS(4111),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4111),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4111),
    [anon_sym_AMP_AMP] = ACTIONS(4101),
    [anon_sym_PIPE_PIPE] = ACTIONS(4101),
    [anon_sym_QMARK_QMARK] = ACTIONS(4108),
    [anon_sym_from] = ACTIONS(4099),
    [anon_sym_into] = ACTIONS(4099),
    [anon_sym_join] = ACTIONS(4099),
    [anon_sym_on] = ACTIONS(4099),
    [anon_sym_equals] = ACTIONS(4099),
    [anon_sym_let] = ACTIONS(4099),
    [anon_sym_orderby] = ACTIONS(4099),
    [anon_sym_ascending] = ACTIONS(4099),
    [anon_sym_descending] = ACTIONS(4099),
    [anon_sym_group] = ACTIONS(4099),
    [anon_sym_by] = ACTIONS(4099),
    [anon_sym_select] = ACTIONS(4099),
    [anon_sym_as] = ACTIONS(4108),
    [anon_sym_is] = ACTIONS(4108),
    [anon_sym_DASH_GT] = ACTIONS(4101),
    [anon_sym_with] = ACTIONS(4108),
    [aux_sym_preproc_if_token3] = ACTIONS(4106),
    [aux_sym_preproc_else_token1] = ACTIONS(4106),
    [aux_sym_preproc_elif_token1] = ACTIONS(4106),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2749] = {
    [sym_preproc_region] = STATE(2749),
    [sym_preproc_endregion] = STATE(2749),
    [sym_preproc_line] = STATE(2749),
    [sym_preproc_pragma] = STATE(2749),
    [sym_preproc_nullable] = STATE(2749),
    [sym_preproc_error] = STATE(2749),
    [sym_preproc_define] = STATE(2749),
    [sym_preproc_undef] = STATE(2749),
    [sym__identifier_token] = ACTIONS(4113),
    [anon_sym_alias] = ACTIONS(4113),
    [anon_sym_SEMI] = ACTIONS(4115),
    [anon_sym_global] = ACTIONS(4113),
    [anon_sym_EQ] = ACTIONS(4118),
    [anon_sym_LBRACK] = ACTIONS(4120),
    [anon_sym_COLON] = ACTIONS(4115),
    [anon_sym_COMMA] = ACTIONS(4115),
    [anon_sym_RBRACK] = ACTIONS(4115),
    [anon_sym_LPAREN] = ACTIONS(4120),
    [anon_sym_RPAREN] = ACTIONS(4115),
    [anon_sym_LBRACE] = ACTIONS(4124),
    [anon_sym_RBRACE] = ACTIONS(4115),
    [anon_sym_file] = ACTIONS(4113),
    [anon_sym_LT] = ACTIONS(4126),
    [anon_sym_GT] = ACTIONS(4126),
    [anon_sym_in] = ACTIONS(4130),
    [anon_sym_where] = ACTIONS(4113),
    [anon_sym_QMARK] = ACTIONS(4126),
    [anon_sym_notnull] = ACTIONS(4113),
    [anon_sym_unmanaged] = ACTIONS(4113),
    [anon_sym_BANG] = ACTIONS(4126),
    [anon_sym_PLUS_PLUS] = ACTIONS(4120),
    [anon_sym_DASH_DASH] = ACTIONS(4120),
    [anon_sym_PLUS] = ACTIONS(4126),
    [anon_sym_DASH] = ACTIONS(4126),
    [anon_sym_STAR] = ACTIONS(4126),
    [anon_sym_SLASH] = ACTIONS(4126),
    [anon_sym_PERCENT] = ACTIONS(4126),
    [anon_sym_CARET] = ACTIONS(4126),
    [anon_sym_PIPE] = ACTIONS(4126),
    [anon_sym_AMP] = ACTIONS(4126),
    [anon_sym_LT_LT] = ACTIONS(4126),
    [anon_sym_GT_GT] = ACTIONS(4126),
    [anon_sym_GT_GT_GT] = ACTIONS(4126),
    [anon_sym_EQ_EQ] = ACTIONS(4120),
    [anon_sym_BANG_EQ] = ACTIONS(4120),
    [anon_sym_GT_EQ] = ACTIONS(4120),
    [anon_sym_LT_EQ] = ACTIONS(4120),
    [anon_sym_DOT] = ACTIONS(4126),
    [anon_sym_scoped] = ACTIONS(4113),
    [anon_sym_EQ_GT] = ACTIONS(4115),
    [anon_sym_var] = ACTIONS(4113),
    [anon_sym_yield] = ACTIONS(4113),
    [anon_sym_switch] = ACTIONS(4126),
    [anon_sym_when] = ACTIONS(4113),
    [sym_discard] = ACTIONS(4113),
    [anon_sym_DOT_DOT] = ACTIONS(4120),
    [anon_sym_and] = ACTIONS(4130),
    [anon_sym_or] = ACTIONS(4130),
    [anon_sym_PLUS_EQ] = ACTIONS(4133),
    [anon_sym_DASH_EQ] = ACTIONS(4133),
    [anon_sym_STAR_EQ] = ACTIONS(4133),
    [anon_sym_SLASH_EQ] = ACTIONS(4133),
    [anon_sym_PERCENT_EQ] = ACTIONS(4133),
    [anon_sym_AMP_EQ] = ACTIONS(4133),
    [anon_sym_CARET_EQ] = ACTIONS(4133),
    [anon_sym_PIPE_EQ] = ACTIONS(4133),
    [anon_sym_LT_LT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4133),
    [anon_sym_AMP_AMP] = ACTIONS(4120),
    [anon_sym_PIPE_PIPE] = ACTIONS(4120),
    [anon_sym_QMARK_QMARK] = ACTIONS(4126),
    [anon_sym_from] = ACTIONS(4113),
    [anon_sym_into] = ACTIONS(4113),
    [anon_sym_join] = ACTIONS(4113),
    [anon_sym_on] = ACTIONS(4113),
    [anon_sym_equals] = ACTIONS(4113),
    [anon_sym_let] = ACTIONS(4113),
    [anon_sym_orderby] = ACTIONS(4113),
    [anon_sym_ascending] = ACTIONS(4113),
    [anon_sym_descending] = ACTIONS(4113),
    [anon_sym_group] = ACTIONS(4113),
    [anon_sym_by] = ACTIONS(4113),
    [anon_sym_select] = ACTIONS(4113),
    [anon_sym_as] = ACTIONS(4126),
    [anon_sym_is] = ACTIONS(4126),
    [anon_sym_DASH_GT] = ACTIONS(4120),
    [anon_sym_with] = ACTIONS(4126),
    [aux_sym_preproc_if_token3] = ACTIONS(4115),
    [aux_sym_preproc_else_token1] = ACTIONS(4115),
    [aux_sym_preproc_elif_token1] = ACTIONS(4115),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2750] = {
    [sym_preproc_region] = STATE(2750),
    [sym_preproc_endregion] = STATE(2750),
    [sym_preproc_line] = STATE(2750),
    [sym_preproc_pragma] = STATE(2750),
    [sym_preproc_nullable] = STATE(2750),
    [sym_preproc_error] = STATE(2750),
    [sym_preproc_define] = STATE(2750),
    [sym_preproc_undef] = STATE(2750),
    [sym__identifier_token] = ACTIONS(4099),
    [anon_sym_alias] = ACTIONS(4099),
    [anon_sym_SEMI] = ACTIONS(4101),
    [anon_sym_global] = ACTIONS(4099),
    [anon_sym_EQ] = ACTIONS(4104),
    [anon_sym_LBRACK] = ACTIONS(4101),
    [anon_sym_COLON] = ACTIONS(4101),
    [anon_sym_COMMA] = ACTIONS(4101),
    [anon_sym_RBRACK] = ACTIONS(4101),
    [anon_sym_LPAREN] = ACTIONS(4101),
    [anon_sym_RPAREN] = ACTIONS(4101),
    [anon_sym_LBRACE] = ACTIONS(4106),
    [anon_sym_RBRACE] = ACTIONS(4101),
    [anon_sym_file] = ACTIONS(4099),
    [anon_sym_LT] = ACTIONS(4108),
    [anon_sym_GT] = ACTIONS(4108),
    [anon_sym_in] = ACTIONS(4108),
    [anon_sym_where] = ACTIONS(4099),
    [anon_sym_QMARK] = ACTIONS(4108),
    [anon_sym_notnull] = ACTIONS(4099),
    [anon_sym_unmanaged] = ACTIONS(4099),
    [anon_sym_BANG] = ACTIONS(4108),
    [anon_sym_PLUS_PLUS] = ACTIONS(4101),
    [anon_sym_DASH_DASH] = ACTIONS(4101),
    [anon_sym_PLUS] = ACTIONS(4108),
    [anon_sym_DASH] = ACTIONS(4108),
    [anon_sym_STAR] = ACTIONS(4108),
    [anon_sym_SLASH] = ACTIONS(4108),
    [anon_sym_PERCENT] = ACTIONS(4108),
    [anon_sym_CARET] = ACTIONS(4108),
    [anon_sym_PIPE] = ACTIONS(4108),
    [anon_sym_AMP] = ACTIONS(4108),
    [anon_sym_LT_LT] = ACTIONS(4108),
    [anon_sym_GT_GT] = ACTIONS(4108),
    [anon_sym_GT_GT_GT] = ACTIONS(4108),
    [anon_sym_EQ_EQ] = ACTIONS(4101),
    [anon_sym_BANG_EQ] = ACTIONS(4101),
    [anon_sym_GT_EQ] = ACTIONS(4101),
    [anon_sym_LT_EQ] = ACTIONS(4101),
    [anon_sym_DOT] = ACTIONS(4108),
    [anon_sym_scoped] = ACTIONS(4099),
    [anon_sym_EQ_GT] = ACTIONS(4101),
    [anon_sym_var] = ACTIONS(4099),
    [anon_sym_yield] = ACTIONS(4099),
    [anon_sym_switch] = ACTIONS(4108),
    [anon_sym_when] = ACTIONS(4099),
    [sym_discard] = ACTIONS(4099),
    [anon_sym_DOT_DOT] = ACTIONS(4101),
    [anon_sym_and] = ACTIONS(4108),
    [anon_sym_or] = ACTIONS(4108),
    [anon_sym_PLUS_EQ] = ACTIONS(4111),
    [anon_sym_DASH_EQ] = ACTIONS(4111),
    [anon_sym_STAR_EQ] = ACTIONS(4111),
    [anon_sym_SLASH_EQ] = ACTIONS(4111),
    [anon_sym_PERCENT_EQ] = ACTIONS(4111),
    [anon_sym_AMP_EQ] = ACTIONS(4111),
    [anon_sym_CARET_EQ] = ACTIONS(4111),
    [anon_sym_PIPE_EQ] = ACTIONS(4111),
    [anon_sym_LT_LT_EQ] = ACTIONS(4111),
    [anon_sym_GT_GT_EQ] = ACTIONS(4111),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4111),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4111),
    [anon_sym_AMP_AMP] = ACTIONS(4101),
    [anon_sym_PIPE_PIPE] = ACTIONS(4101),
    [anon_sym_QMARK_QMARK] = ACTIONS(4108),
    [anon_sym_from] = ACTIONS(4099),
    [anon_sym_into] = ACTIONS(4099),
    [anon_sym_join] = ACTIONS(4099),
    [anon_sym_on] = ACTIONS(4099),
    [anon_sym_equals] = ACTIONS(4099),
    [anon_sym_let] = ACTIONS(4099),
    [anon_sym_orderby] = ACTIONS(4099),
    [anon_sym_ascending] = ACTIONS(4099),
    [anon_sym_descending] = ACTIONS(4099),
    [anon_sym_group] = ACTIONS(4099),
    [anon_sym_by] = ACTIONS(4099),
    [anon_sym_select] = ACTIONS(4099),
    [anon_sym_as] = ACTIONS(4108),
    [anon_sym_is] = ACTIONS(4108),
    [anon_sym_DASH_GT] = ACTIONS(4101),
    [anon_sym_with] = ACTIONS(4108),
    [aux_sym_preproc_if_token3] = ACTIONS(4101),
    [aux_sym_preproc_else_token1] = ACTIONS(4101),
    [aux_sym_preproc_elif_token1] = ACTIONS(4101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2751] = {
    [sym_preproc_region] = STATE(2751),
    [sym_preproc_endregion] = STATE(2751),
    [sym_preproc_line] = STATE(2751),
    [sym_preproc_pragma] = STATE(2751),
    [sym_preproc_nullable] = STATE(2751),
    [sym_preproc_error] = STATE(2751),
    [sym_preproc_define] = STATE(2751),
    [sym_preproc_undef] = STATE(2751),
    [sym__identifier_token] = ACTIONS(4113),
    [anon_sym_alias] = ACTIONS(4113),
    [anon_sym_SEMI] = ACTIONS(4124),
    [anon_sym_global] = ACTIONS(4113),
    [anon_sym_EQ] = ACTIONS(4118),
    [anon_sym_LBRACK] = ACTIONS(4135),
    [anon_sym_COLON] = ACTIONS(4124),
    [anon_sym_COMMA] = ACTIONS(4124),
    [anon_sym_RBRACK] = ACTIONS(4124),
    [anon_sym_LPAREN] = ACTIONS(4135),
    [anon_sym_RPAREN] = ACTIONS(4124),
    [anon_sym_LBRACE] = ACTIONS(4124),
    [anon_sym_RBRACE] = ACTIONS(4124),
    [anon_sym_file] = ACTIONS(4113),
    [anon_sym_LT] = ACTIONS(4138),
    [anon_sym_GT] = ACTIONS(4138),
    [anon_sym_in] = ACTIONS(4113),
    [anon_sym_where] = ACTIONS(4113),
    [anon_sym_QMARK] = ACTIONS(4138),
    [anon_sym_notnull] = ACTIONS(4113),
    [anon_sym_unmanaged] = ACTIONS(4113),
    [anon_sym_BANG] = ACTIONS(4138),
    [anon_sym_PLUS_PLUS] = ACTIONS(4135),
    [anon_sym_DASH_DASH] = ACTIONS(4135),
    [anon_sym_PLUS] = ACTIONS(4138),
    [anon_sym_DASH] = ACTIONS(4138),
    [anon_sym_STAR] = ACTIONS(4138),
    [anon_sym_SLASH] = ACTIONS(4138),
    [anon_sym_PERCENT] = ACTIONS(4138),
    [anon_sym_CARET] = ACTIONS(4138),
    [anon_sym_PIPE] = ACTIONS(4138),
    [anon_sym_AMP] = ACTIONS(4138),
    [anon_sym_LT_LT] = ACTIONS(4138),
    [anon_sym_GT_GT] = ACTIONS(4138),
    [anon_sym_GT_GT_GT] = ACTIONS(4138),
    [anon_sym_EQ_EQ] = ACTIONS(4135),
    [anon_sym_BANG_EQ] = ACTIONS(4135),
    [anon_sym_GT_EQ] = ACTIONS(4135),
    [anon_sym_LT_EQ] = ACTIONS(4135),
    [anon_sym_DOT] = ACTIONS(4138),
    [anon_sym_scoped] = ACTIONS(4113),
    [anon_sym_EQ_GT] = ACTIONS(4124),
    [anon_sym_var] = ACTIONS(4113),
    [anon_sym_yield] = ACTIONS(4113),
    [anon_sym_switch] = ACTIONS(4138),
    [anon_sym_when] = ACTIONS(4113),
    [sym_discard] = ACTIONS(4113),
    [anon_sym_DOT_DOT] = ACTIONS(4135),
    [anon_sym_and] = ACTIONS(4113),
    [anon_sym_or] = ACTIONS(4113),
    [anon_sym_PLUS_EQ] = ACTIONS(4133),
    [anon_sym_DASH_EQ] = ACTIONS(4133),
    [anon_sym_STAR_EQ] = ACTIONS(4133),
    [anon_sym_SLASH_EQ] = ACTIONS(4133),
    [anon_sym_PERCENT_EQ] = ACTIONS(4133),
    [anon_sym_AMP_EQ] = ACTIONS(4133),
    [anon_sym_CARET_EQ] = ACTIONS(4133),
    [anon_sym_PIPE_EQ] = ACTIONS(4133),
    [anon_sym_LT_LT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4133),
    [anon_sym_AMP_AMP] = ACTIONS(4135),
    [anon_sym_PIPE_PIPE] = ACTIONS(4135),
    [anon_sym_QMARK_QMARK] = ACTIONS(4138),
    [anon_sym_from] = ACTIONS(4113),
    [anon_sym_into] = ACTIONS(4113),
    [anon_sym_join] = ACTIONS(4113),
    [anon_sym_on] = ACTIONS(4113),
    [anon_sym_equals] = ACTIONS(4113),
    [anon_sym_let] = ACTIONS(4113),
    [anon_sym_orderby] = ACTIONS(4113),
    [anon_sym_ascending] = ACTIONS(4113),
    [anon_sym_descending] = ACTIONS(4113),
    [anon_sym_group] = ACTIONS(4113),
    [anon_sym_by] = ACTIONS(4113),
    [anon_sym_select] = ACTIONS(4113),
    [anon_sym_as] = ACTIONS(4138),
    [anon_sym_is] = ACTIONS(4138),
    [anon_sym_DASH_GT] = ACTIONS(4135),
    [anon_sym_with] = ACTIONS(4138),
    [aux_sym_preproc_if_token3] = ACTIONS(4124),
    [aux_sym_preproc_else_token1] = ACTIONS(4124),
    [aux_sym_preproc_elif_token1] = ACTIONS(4124),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2752] = {
    [sym_preproc_region] = STATE(2752),
    [sym_preproc_endregion] = STATE(2752),
    [sym_preproc_line] = STATE(2752),
    [sym_preproc_pragma] = STATE(2752),
    [sym_preproc_nullable] = STATE(2752),
    [sym_preproc_error] = STATE(2752),
    [sym_preproc_define] = STATE(2752),
    [sym_preproc_undef] = STATE(2752),
    [sym__identifier_token] = ACTIONS(4099),
    [anon_sym_alias] = ACTIONS(4099),
    [anon_sym_SEMI] = ACTIONS(4111),
    [anon_sym_global] = ACTIONS(4099),
    [anon_sym_EQ] = ACTIONS(4104),
    [anon_sym_LBRACK] = ACTIONS(4101),
    [anon_sym_COLON] = ACTIONS(4111),
    [anon_sym_COMMA] = ACTIONS(4101),
    [anon_sym_RBRACK] = ACTIONS(4101),
    [anon_sym_LPAREN] = ACTIONS(4101),
    [anon_sym_RPAREN] = ACTIONS(4101),
    [anon_sym_LBRACE] = ACTIONS(4106),
    [anon_sym_RBRACE] = ACTIONS(4101),
    [anon_sym_file] = ACTIONS(4099),
    [anon_sym_LT] = ACTIONS(4104),
    [anon_sym_GT] = ACTIONS(4104),
    [anon_sym_in] = ACTIONS(4104),
    [anon_sym_where] = ACTIONS(4099),
    [anon_sym_QMARK] = ACTIONS(4108),
    [anon_sym_notnull] = ACTIONS(4099),
    [anon_sym_unmanaged] = ACTIONS(4099),
    [anon_sym_BANG] = ACTIONS(4104),
    [anon_sym_PLUS_PLUS] = ACTIONS(4111),
    [anon_sym_DASH_DASH] = ACTIONS(4111),
    [anon_sym_PLUS] = ACTIONS(4104),
    [anon_sym_DASH] = ACTIONS(4104),
    [anon_sym_STAR] = ACTIONS(4108),
    [anon_sym_SLASH] = ACTIONS(4104),
    [anon_sym_PERCENT] = ACTIONS(4104),
    [anon_sym_CARET] = ACTIONS(4104),
    [anon_sym_PIPE] = ACTIONS(4104),
    [anon_sym_AMP] = ACTIONS(4104),
    [anon_sym_LT_LT] = ACTIONS(4104),
    [anon_sym_GT_GT] = ACTIONS(4104),
    [anon_sym_GT_GT_GT] = ACTIONS(4104),
    [anon_sym_EQ_EQ] = ACTIONS(4111),
    [anon_sym_BANG_EQ] = ACTIONS(4111),
    [anon_sym_GT_EQ] = ACTIONS(4111),
    [anon_sym_LT_EQ] = ACTIONS(4111),
    [anon_sym_DOT] = ACTIONS(4108),
    [anon_sym_scoped] = ACTIONS(4099),
    [anon_sym_EQ_GT] = ACTIONS(4111),
    [anon_sym_var] = ACTIONS(4099),
    [anon_sym_yield] = ACTIONS(4099),
    [anon_sym_switch] = ACTIONS(4104),
    [anon_sym_when] = ACTIONS(4099),
    [sym_discard] = ACTIONS(4099),
    [anon_sym_DOT_DOT] = ACTIONS(4111),
    [anon_sym_and] = ACTIONS(4108),
    [anon_sym_or] = ACTIONS(4108),
    [anon_sym_PLUS_EQ] = ACTIONS(4111),
    [anon_sym_DASH_EQ] = ACTIONS(4111),
    [anon_sym_STAR_EQ] = ACTIONS(4111),
    [anon_sym_SLASH_EQ] = ACTIONS(4111),
    [anon_sym_PERCENT_EQ] = ACTIONS(4111),
    [anon_sym_AMP_EQ] = ACTIONS(4111),
    [anon_sym_CARET_EQ] = ACTIONS(4111),
    [anon_sym_PIPE_EQ] = ACTIONS(4111),
    [anon_sym_LT_LT_EQ] = ACTIONS(4111),
    [anon_sym_GT_GT_EQ] = ACTIONS(4111),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4111),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4111),
    [anon_sym_AMP_AMP] = ACTIONS(4111),
    [anon_sym_PIPE_PIPE] = ACTIONS(4111),
    [anon_sym_QMARK_QMARK] = ACTIONS(4104),
    [anon_sym_from] = ACTIONS(4099),
    [anon_sym_into] = ACTIONS(4099),
    [anon_sym_join] = ACTIONS(4099),
    [anon_sym_on] = ACTIONS(4099),
    [anon_sym_equals] = ACTIONS(4099),
    [anon_sym_let] = ACTIONS(4099),
    [anon_sym_orderby] = ACTIONS(4099),
    [anon_sym_ascending] = ACTIONS(4099),
    [anon_sym_descending] = ACTIONS(4099),
    [anon_sym_group] = ACTIONS(4099),
    [anon_sym_by] = ACTIONS(4099),
    [anon_sym_select] = ACTIONS(4099),
    [anon_sym_as] = ACTIONS(4104),
    [anon_sym_is] = ACTIONS(4104),
    [anon_sym_DASH_GT] = ACTIONS(4101),
    [anon_sym_with] = ACTIONS(4104),
    [aux_sym_preproc_if_token3] = ACTIONS(4111),
    [aux_sym_preproc_else_token1] = ACTIONS(4111),
    [aux_sym_preproc_elif_token1] = ACTIONS(4111),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2753] = {
    [sym_preproc_region] = STATE(2753),
    [sym_preproc_endregion] = STATE(2753),
    [sym_preproc_line] = STATE(2753),
    [sym_preproc_pragma] = STATE(2753),
    [sym_preproc_nullable] = STATE(2753),
    [sym_preproc_error] = STATE(2753),
    [sym_preproc_define] = STATE(2753),
    [sym_preproc_undef] = STATE(2753),
    [sym__identifier_token] = ACTIONS(4027),
    [anon_sym_alias] = ACTIONS(4027),
    [anon_sym_SEMI] = ACTIONS(3719),
    [anon_sym_global] = ACTIONS(4027),
    [anon_sym_EQ] = ACTIONS(3721),
    [anon_sym_LBRACK] = ACTIONS(3719),
    [anon_sym_COLON] = ACTIONS(3721),
    [anon_sym_COMMA] = ACTIONS(3719),
    [anon_sym_RBRACK] = ACTIONS(3719),
    [anon_sym_LPAREN] = ACTIONS(4024),
    [anon_sym_RPAREN] = ACTIONS(3719),
    [anon_sym_RBRACE] = ACTIONS(3719),
    [anon_sym_file] = ACTIONS(4027),
    [anon_sym_LT] = ACTIONS(3721),
    [anon_sym_GT] = ACTIONS(3721),
    [anon_sym_in] = ACTIONS(3721),
    [anon_sym_where] = ACTIONS(4027),
    [anon_sym_QMARK] = ACTIONS(3721),
    [anon_sym_notnull] = ACTIONS(4027),
    [anon_sym_unmanaged] = ACTIONS(4027),
    [anon_sym_BANG] = ACTIONS(3721),
    [anon_sym_PLUS_PLUS] = ACTIONS(3719),
    [anon_sym_DASH_DASH] = ACTIONS(3719),
    [anon_sym_PLUS] = ACTIONS(3721),
    [anon_sym_DASH] = ACTIONS(3721),
    [anon_sym_STAR] = ACTIONS(3721),
    [anon_sym_SLASH] = ACTIONS(3721),
    [anon_sym_PERCENT] = ACTIONS(3721),
    [anon_sym_CARET] = ACTIONS(3721),
    [anon_sym_PIPE] = ACTIONS(3721),
    [anon_sym_AMP] = ACTIONS(3721),
    [anon_sym_LT_LT] = ACTIONS(3721),
    [anon_sym_GT_GT] = ACTIONS(3721),
    [anon_sym_GT_GT_GT] = ACTIONS(3721),
    [anon_sym_EQ_EQ] = ACTIONS(3719),
    [anon_sym_BANG_EQ] = ACTIONS(3719),
    [anon_sym_GT_EQ] = ACTIONS(3719),
    [anon_sym_LT_EQ] = ACTIONS(3719),
    [anon_sym_DOT] = ACTIONS(3721),
    [anon_sym_scoped] = ACTIONS(4027),
    [anon_sym_EQ_GT] = ACTIONS(3719),
    [anon_sym_COLON_COLON] = ACTIONS(3719),
    [anon_sym_var] = ACTIONS(4027),
    [anon_sym_yield] = ACTIONS(4027),
    [anon_sym_switch] = ACTIONS(3721),
    [anon_sym_when] = ACTIONS(4027),
    [anon_sym_DOT_DOT] = ACTIONS(3719),
    [anon_sym_and] = ACTIONS(3721),
    [anon_sym_or] = ACTIONS(3721),
    [anon_sym_PLUS_EQ] = ACTIONS(3719),
    [anon_sym_DASH_EQ] = ACTIONS(3719),
    [anon_sym_STAR_EQ] = ACTIONS(3719),
    [anon_sym_SLASH_EQ] = ACTIONS(3719),
    [anon_sym_PERCENT_EQ] = ACTIONS(3719),
    [anon_sym_AMP_EQ] = ACTIONS(3719),
    [anon_sym_CARET_EQ] = ACTIONS(3719),
    [anon_sym_PIPE_EQ] = ACTIONS(3719),
    [anon_sym_LT_LT_EQ] = ACTIONS(3719),
    [anon_sym_GT_GT_EQ] = ACTIONS(3719),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3719),
    [anon_sym_AMP_AMP] = ACTIONS(3719),
    [anon_sym_PIPE_PIPE] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK] = ACTIONS(3721),
    [anon_sym_from] = ACTIONS(4027),
    [anon_sym_into] = ACTIONS(4027),
    [anon_sym_join] = ACTIONS(4027),
    [anon_sym_on] = ACTIONS(4027),
    [anon_sym_equals] = ACTIONS(4027),
    [anon_sym_let] = ACTIONS(4027),
    [anon_sym_orderby] = ACTIONS(4027),
    [anon_sym_ascending] = ACTIONS(4027),
    [anon_sym_descending] = ACTIONS(4027),
    [anon_sym_group] = ACTIONS(4027),
    [anon_sym_by] = ACTIONS(4027),
    [anon_sym_select] = ACTIONS(4027),
    [anon_sym_as] = ACTIONS(3721),
    [anon_sym_is] = ACTIONS(3721),
    [anon_sym_DASH_GT] = ACTIONS(3719),
    [anon_sym_with] = ACTIONS(3721),
    [aux_sym_preproc_if_token3] = ACTIONS(3719),
    [aux_sym_preproc_else_token1] = ACTIONS(3719),
    [aux_sym_preproc_elif_token1] = ACTIONS(3719),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2754] = {
    [sym_preproc_region] = STATE(2754),
    [sym_preproc_endregion] = STATE(2754),
    [sym_preproc_line] = STATE(2754),
    [sym_preproc_pragma] = STATE(2754),
    [sym_preproc_nullable] = STATE(2754),
    [sym_preproc_error] = STATE(2754),
    [sym_preproc_define] = STATE(2754),
    [sym_preproc_undef] = STATE(2754),
    [sym__identifier_token] = ACTIONS(4099),
    [anon_sym_alias] = ACTIONS(4099),
    [anon_sym_SEMI] = ACTIONS(4111),
    [anon_sym_global] = ACTIONS(4099),
    [anon_sym_EQ] = ACTIONS(4104),
    [anon_sym_LBRACK] = ACTIONS(4101),
    [anon_sym_COLON] = ACTIONS(4111),
    [anon_sym_COMMA] = ACTIONS(4111),
    [anon_sym_RBRACK] = ACTIONS(4111),
    [anon_sym_LPAREN] = ACTIONS(4101),
    [anon_sym_RPAREN] = ACTIONS(4111),
    [anon_sym_RBRACE] = ACTIONS(4111),
    [anon_sym_file] = ACTIONS(4099),
    [anon_sym_LT] = ACTIONS(4104),
    [anon_sym_GT] = ACTIONS(4104),
    [anon_sym_in] = ACTIONS(4104),
    [anon_sym_where] = ACTIONS(4099),
    [anon_sym_QMARK] = ACTIONS(4108),
    [anon_sym_notnull] = ACTIONS(4099),
    [anon_sym_unmanaged] = ACTIONS(4099),
    [anon_sym_BANG] = ACTIONS(4104),
    [anon_sym_PLUS_PLUS] = ACTIONS(4111),
    [anon_sym_DASH_DASH] = ACTIONS(4111),
    [anon_sym_PLUS] = ACTIONS(4104),
    [anon_sym_DASH] = ACTIONS(4104),
    [anon_sym_STAR] = ACTIONS(4108),
    [anon_sym_SLASH] = ACTIONS(4104),
    [anon_sym_PERCENT] = ACTIONS(4104),
    [anon_sym_CARET] = ACTIONS(4104),
    [anon_sym_PIPE] = ACTIONS(4104),
    [anon_sym_AMP] = ACTIONS(4104),
    [anon_sym_LT_LT] = ACTIONS(4104),
    [anon_sym_GT_GT] = ACTIONS(4104),
    [anon_sym_GT_GT_GT] = ACTIONS(4104),
    [anon_sym_EQ_EQ] = ACTIONS(4111),
    [anon_sym_BANG_EQ] = ACTIONS(4111),
    [anon_sym_GT_EQ] = ACTIONS(4111),
    [anon_sym_LT_EQ] = ACTIONS(4111),
    [anon_sym_DOT] = ACTIONS(4108),
    [anon_sym_scoped] = ACTIONS(4099),
    [anon_sym_EQ_GT] = ACTIONS(4111),
    [anon_sym_var] = ACTIONS(4099),
    [anon_sym_yield] = ACTIONS(4099),
    [anon_sym_switch] = ACTIONS(4104),
    [anon_sym_when] = ACTIONS(4099),
    [anon_sym_DOT_DOT] = ACTIONS(4111),
    [anon_sym_and] = ACTIONS(4104),
    [anon_sym_or] = ACTIONS(4104),
    [anon_sym_PLUS_EQ] = ACTIONS(4111),
    [anon_sym_DASH_EQ] = ACTIONS(4111),
    [anon_sym_STAR_EQ] = ACTIONS(4111),
    [anon_sym_SLASH_EQ] = ACTIONS(4111),
    [anon_sym_PERCENT_EQ] = ACTIONS(4111),
    [anon_sym_AMP_EQ] = ACTIONS(4111),
    [anon_sym_CARET_EQ] = ACTIONS(4111),
    [anon_sym_PIPE_EQ] = ACTIONS(4111),
    [anon_sym_LT_LT_EQ] = ACTIONS(4111),
    [anon_sym_GT_GT_EQ] = ACTIONS(4111),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4111),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4111),
    [anon_sym_AMP_AMP] = ACTIONS(4111),
    [anon_sym_PIPE_PIPE] = ACTIONS(4111),
    [anon_sym_QMARK_QMARK] = ACTIONS(4104),
    [anon_sym_from] = ACTIONS(4099),
    [anon_sym_into] = ACTIONS(4099),
    [anon_sym_join] = ACTIONS(4099),
    [anon_sym_on] = ACTIONS(4099),
    [anon_sym_equals] = ACTIONS(4099),
    [anon_sym_let] = ACTIONS(4099),
    [anon_sym_orderby] = ACTIONS(4099),
    [anon_sym_ascending] = ACTIONS(4099),
    [anon_sym_descending] = ACTIONS(4099),
    [anon_sym_group] = ACTIONS(4099),
    [anon_sym_by] = ACTIONS(4099),
    [anon_sym_select] = ACTIONS(4099),
    [anon_sym_as] = ACTIONS(4104),
    [anon_sym_is] = ACTIONS(4104),
    [anon_sym_DASH_GT] = ACTIONS(4101),
    [anon_sym_with] = ACTIONS(4104),
    [aux_sym_preproc_if_token3] = ACTIONS(4111),
    [aux_sym_preproc_else_token1] = ACTIONS(4111),
    [aux_sym_preproc_elif_token1] = ACTIONS(4111),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2755] = {
    [sym_preproc_region] = STATE(2755),
    [sym_preproc_endregion] = STATE(2755),
    [sym_preproc_line] = STATE(2755),
    [sym_preproc_pragma] = STATE(2755),
    [sym_preproc_nullable] = STATE(2755),
    [sym_preproc_error] = STATE(2755),
    [sym_preproc_define] = STATE(2755),
    [sym_preproc_undef] = STATE(2755),
    [sym__identifier_token] = ACTIONS(4113),
    [anon_sym_alias] = ACTIONS(4113),
    [anon_sym_SEMI] = ACTIONS(4133),
    [anon_sym_global] = ACTIONS(4113),
    [anon_sym_EQ] = ACTIONS(4118),
    [anon_sym_LBRACK] = ACTIONS(4135),
    [anon_sym_COLON] = ACTIONS(4133),
    [anon_sym_COMMA] = ACTIONS(4133),
    [anon_sym_RBRACK] = ACTIONS(4133),
    [anon_sym_LPAREN] = ACTIONS(4135),
    [anon_sym_RPAREN] = ACTIONS(4133),
    [anon_sym_RBRACE] = ACTIONS(4133),
    [anon_sym_file] = ACTIONS(4113),
    [anon_sym_LT] = ACTIONS(4118),
    [anon_sym_GT] = ACTIONS(4118),
    [anon_sym_in] = ACTIONS(4118),
    [anon_sym_where] = ACTIONS(4113),
    [anon_sym_QMARK] = ACTIONS(4138),
    [anon_sym_notnull] = ACTIONS(4113),
    [anon_sym_unmanaged] = ACTIONS(4113),
    [anon_sym_BANG] = ACTIONS(4118),
    [anon_sym_PLUS_PLUS] = ACTIONS(4133),
    [anon_sym_DASH_DASH] = ACTIONS(4133),
    [anon_sym_PLUS] = ACTIONS(4118),
    [anon_sym_DASH] = ACTIONS(4118),
    [anon_sym_STAR] = ACTIONS(4138),
    [anon_sym_SLASH] = ACTIONS(4118),
    [anon_sym_PERCENT] = ACTIONS(4118),
    [anon_sym_CARET] = ACTIONS(4118),
    [anon_sym_PIPE] = ACTIONS(4118),
    [anon_sym_AMP] = ACTIONS(4118),
    [anon_sym_LT_LT] = ACTIONS(4118),
    [anon_sym_GT_GT] = ACTIONS(4118),
    [anon_sym_GT_GT_GT] = ACTIONS(4118),
    [anon_sym_EQ_EQ] = ACTIONS(4133),
    [anon_sym_BANG_EQ] = ACTIONS(4133),
    [anon_sym_GT_EQ] = ACTIONS(4133),
    [anon_sym_LT_EQ] = ACTIONS(4133),
    [anon_sym_DOT] = ACTIONS(4138),
    [anon_sym_scoped] = ACTIONS(4113),
    [anon_sym_EQ_GT] = ACTIONS(4133),
    [anon_sym_var] = ACTIONS(4113),
    [anon_sym_yield] = ACTIONS(4113),
    [anon_sym_switch] = ACTIONS(4118),
    [anon_sym_when] = ACTIONS(4113),
    [anon_sym_DOT_DOT] = ACTIONS(4133),
    [anon_sym_and] = ACTIONS(4118),
    [anon_sym_or] = ACTIONS(4118),
    [anon_sym_PLUS_EQ] = ACTIONS(4133),
    [anon_sym_DASH_EQ] = ACTIONS(4133),
    [anon_sym_STAR_EQ] = ACTIONS(4133),
    [anon_sym_SLASH_EQ] = ACTIONS(4133),
    [anon_sym_PERCENT_EQ] = ACTIONS(4133),
    [anon_sym_AMP_EQ] = ACTIONS(4133),
    [anon_sym_CARET_EQ] = ACTIONS(4133),
    [anon_sym_PIPE_EQ] = ACTIONS(4133),
    [anon_sym_LT_LT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4133),
    [anon_sym_AMP_AMP] = ACTIONS(4133),
    [anon_sym_PIPE_PIPE] = ACTIONS(4133),
    [anon_sym_QMARK_QMARK] = ACTIONS(4118),
    [anon_sym_from] = ACTIONS(4113),
    [anon_sym_into] = ACTIONS(4138),
    [anon_sym_join] = ACTIONS(4113),
    [anon_sym_on] = ACTIONS(4113),
    [anon_sym_equals] = ACTIONS(4113),
    [anon_sym_let] = ACTIONS(4113),
    [anon_sym_orderby] = ACTIONS(4113),
    [anon_sym_ascending] = ACTIONS(4113),
    [anon_sym_descending] = ACTIONS(4113),
    [anon_sym_group] = ACTIONS(4113),
    [anon_sym_by] = ACTIONS(4113),
    [anon_sym_select] = ACTIONS(4113),
    [anon_sym_as] = ACTIONS(4118),
    [anon_sym_is] = ACTIONS(4118),
    [anon_sym_DASH_GT] = ACTIONS(4135),
    [anon_sym_with] = ACTIONS(4118),
    [aux_sym_preproc_if_token3] = ACTIONS(4133),
    [aux_sym_preproc_else_token1] = ACTIONS(4133),
    [aux_sym_preproc_elif_token1] = ACTIONS(4133),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2756] = {
    [sym__variable_designation] = STATE(4270),
    [sym_parenthesized_variable_designation] = STATE(4274),
    [sym_identifier] = STATE(4269),
    [sym__reserved_identifier] = STATE(3127),
    [sym_preproc_region] = STATE(2756),
    [sym_preproc_endregion] = STATE(2756),
    [sym_preproc_line] = STATE(2756),
    [sym_preproc_pragma] = STATE(2756),
    [sym_preproc_nullable] = STATE(2756),
    [sym_preproc_error] = STATE(2756),
    [sym_preproc_define] = STATE(2756),
    [sym_preproc_undef] = STATE(2756),
    [sym__identifier_token] = ACTIONS(4091),
    [anon_sym_alias] = ACTIONS(4095),
    [anon_sym_global] = ACTIONS(4095),
    [anon_sym_EQ] = ACTIONS(3721),
    [anon_sym_LBRACK] = ACTIONS(3719),
    [anon_sym_COLON] = ACTIONS(3721),
    [anon_sym_COMMA] = ACTIONS(4024),
    [anon_sym_LPAREN] = ACTIONS(4046),
    [anon_sym_RPAREN] = ACTIONS(3719),
    [anon_sym_LBRACE] = ACTIONS(4024),
    [anon_sym_file] = ACTIONS(4095),
    [anon_sym_LT] = ACTIONS(3721),
    [anon_sym_GT] = ACTIONS(3721),
    [anon_sym_where] = ACTIONS(4095),
    [anon_sym_QMARK] = ACTIONS(3721),
    [anon_sym_notnull] = ACTIONS(4095),
    [anon_sym_unmanaged] = ACTIONS(4095),
    [anon_sym_BANG] = ACTIONS(3721),
    [anon_sym_PLUS_PLUS] = ACTIONS(3719),
    [anon_sym_DASH_DASH] = ACTIONS(3719),
    [anon_sym_PLUS] = ACTIONS(3721),
    [anon_sym_DASH] = ACTIONS(3721),
    [anon_sym_STAR] = ACTIONS(3721),
    [anon_sym_SLASH] = ACTIONS(3721),
    [anon_sym_PERCENT] = ACTIONS(3721),
    [anon_sym_CARET] = ACTIONS(3721),
    [anon_sym_PIPE] = ACTIONS(3721),
    [anon_sym_AMP] = ACTIONS(3721),
    [anon_sym_LT_LT] = ACTIONS(3721),
    [anon_sym_GT_GT] = ACTIONS(3721),
    [anon_sym_GT_GT_GT] = ACTIONS(3721),
    [anon_sym_EQ_EQ] = ACTIONS(3719),
    [anon_sym_BANG_EQ] = ACTIONS(3719),
    [anon_sym_GT_EQ] = ACTIONS(3719),
    [anon_sym_LT_EQ] = ACTIONS(3719),
    [anon_sym_DOT] = ACTIONS(3721),
    [anon_sym_scoped] = ACTIONS(4095),
    [anon_sym_EQ_GT] = ACTIONS(3719),
    [anon_sym_COLON_COLON] = ACTIONS(3719),
    [anon_sym_var] = ACTIONS(4095),
    [anon_sym_yield] = ACTIONS(4095),
    [anon_sym_switch] = ACTIONS(3721),
    [anon_sym_when] = ACTIONS(4095),
    [sym_discard] = ACTIONS(4050),
    [anon_sym_DOT_DOT] = ACTIONS(3719),
    [anon_sym_and] = ACTIONS(4027),
    [anon_sym_or] = ACTIONS(4027),
    [anon_sym_PLUS_EQ] = ACTIONS(3719),
    [anon_sym_DASH_EQ] = ACTIONS(3719),
    [anon_sym_STAR_EQ] = ACTIONS(3719),
    [anon_sym_SLASH_EQ] = ACTIONS(3719),
    [anon_sym_PERCENT_EQ] = ACTIONS(3719),
    [anon_sym_AMP_EQ] = ACTIONS(3719),
    [anon_sym_CARET_EQ] = ACTIONS(3719),
    [anon_sym_PIPE_EQ] = ACTIONS(3719),
    [anon_sym_LT_LT_EQ] = ACTIONS(3719),
    [anon_sym_GT_GT_EQ] = ACTIONS(3719),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3719),
    [anon_sym_AMP_AMP] = ACTIONS(3719),
    [anon_sym_PIPE_PIPE] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK] = ACTIONS(3721),
    [anon_sym_from] = ACTIONS(4095),
    [anon_sym_into] = ACTIONS(4095),
    [anon_sym_join] = ACTIONS(4095),
    [anon_sym_on] = ACTIONS(4095),
    [anon_sym_equals] = ACTIONS(4095),
    [anon_sym_let] = ACTIONS(4095),
    [anon_sym_orderby] = ACTIONS(4095),
    [anon_sym_ascending] = ACTIONS(4095),
    [anon_sym_descending] = ACTIONS(4095),
    [anon_sym_group] = ACTIONS(4095),
    [anon_sym_by] = ACTIONS(4095),
    [anon_sym_select] = ACTIONS(4095),
    [anon_sym_as] = ACTIONS(3721),
    [anon_sym_is] = ACTIONS(3721),
    [anon_sym_DASH_GT] = ACTIONS(3719),
    [anon_sym_with] = ACTIONS(3721),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2757] = {
    [sym__variable_designation] = STATE(5392),
    [sym_parenthesized_variable_designation] = STATE(5390),
    [sym_identifier] = STATE(5396),
    [sym__reserved_identifier] = STATE(5128),
    [sym_preproc_region] = STATE(2757),
    [sym_preproc_endregion] = STATE(2757),
    [sym_preproc_line] = STATE(2757),
    [sym_preproc_pragma] = STATE(2757),
    [sym_preproc_nullable] = STATE(2757),
    [sym_preproc_error] = STATE(2757),
    [sym_preproc_define] = STATE(2757),
    [sym_preproc_undef] = STATE(2757),
    [sym__identifier_token] = ACTIONS(4141),
    [anon_sym_alias] = ACTIONS(4145),
    [anon_sym_global] = ACTIONS(4145),
    [anon_sym_EQ] = ACTIONS(3721),
    [anon_sym_LBRACK] = ACTIONS(4024),
    [anon_sym_COLON] = ACTIONS(4027),
    [anon_sym_COMMA] = ACTIONS(4024),
    [anon_sym_LPAREN] = ACTIONS(4149),
    [anon_sym_LBRACE] = ACTIONS(4024),
    [anon_sym_file] = ACTIONS(4145),
    [anon_sym_LT] = ACTIONS(4027),
    [anon_sym_GT] = ACTIONS(4027),
    [anon_sym_where] = ACTIONS(4145),
    [anon_sym_QMARK] = ACTIONS(4027),
    [anon_sym_notnull] = ACTIONS(4145),
    [anon_sym_unmanaged] = ACTIONS(4145),
    [anon_sym_BANG] = ACTIONS(4027),
    [anon_sym_PLUS_PLUS] = ACTIONS(4024),
    [anon_sym_DASH_DASH] = ACTIONS(4024),
    [anon_sym_PLUS] = ACTIONS(4027),
    [anon_sym_DASH] = ACTIONS(4027),
    [anon_sym_STAR] = ACTIONS(4027),
    [anon_sym_SLASH] = ACTIONS(4027),
    [anon_sym_PERCENT] = ACTIONS(4027),
    [anon_sym_CARET] = ACTIONS(4027),
    [anon_sym_PIPE] = ACTIONS(4027),
    [anon_sym_AMP] = ACTIONS(4027),
    [anon_sym_LT_LT] = ACTIONS(4027),
    [anon_sym_GT_GT] = ACTIONS(4027),
    [anon_sym_GT_GT_GT] = ACTIONS(4027),
    [anon_sym_EQ_EQ] = ACTIONS(4024),
    [anon_sym_BANG_EQ] = ACTIONS(4024),
    [anon_sym_GT_EQ] = ACTIONS(4024),
    [anon_sym_LT_EQ] = ACTIONS(4024),
    [anon_sym_DOT] = ACTIONS(4027),
    [anon_sym_scoped] = ACTIONS(4145),
    [anon_sym_EQ_GT] = ACTIONS(3719),
    [anon_sym_COLON_COLON] = ACTIONS(3719),
    [anon_sym_var] = ACTIONS(4145),
    [anon_sym_yield] = ACTIONS(4145),
    [anon_sym_switch] = ACTIONS(4027),
    [anon_sym_when] = ACTIONS(4145),
    [sym_discard] = ACTIONS(4153),
    [anon_sym_DOT_DOT] = ACTIONS(4024),
    [anon_sym_and] = ACTIONS(4027),
    [anon_sym_or] = ACTIONS(4027),
    [anon_sym_PLUS_EQ] = ACTIONS(3719),
    [anon_sym_DASH_EQ] = ACTIONS(3719),
    [anon_sym_STAR_EQ] = ACTIONS(3719),
    [anon_sym_SLASH_EQ] = ACTIONS(3719),
    [anon_sym_PERCENT_EQ] = ACTIONS(3719),
    [anon_sym_AMP_EQ] = ACTIONS(3719),
    [anon_sym_CARET_EQ] = ACTIONS(3719),
    [anon_sym_PIPE_EQ] = ACTIONS(3719),
    [anon_sym_LT_LT_EQ] = ACTIONS(3719),
    [anon_sym_GT_GT_EQ] = ACTIONS(3719),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3719),
    [anon_sym_AMP_AMP] = ACTIONS(4024),
    [anon_sym_PIPE_PIPE] = ACTIONS(4024),
    [anon_sym_QMARK_QMARK] = ACTIONS(4027),
    [anon_sym_from] = ACTIONS(4145),
    [anon_sym_into] = ACTIONS(4145),
    [anon_sym_join] = ACTIONS(4145),
    [anon_sym_on] = ACTIONS(4145),
    [anon_sym_equals] = ACTIONS(4145),
    [anon_sym_let] = ACTIONS(4145),
    [anon_sym_orderby] = ACTIONS(4145),
    [anon_sym_ascending] = ACTIONS(4145),
    [anon_sym_descending] = ACTIONS(4145),
    [anon_sym_group] = ACTIONS(4145),
    [anon_sym_by] = ACTIONS(4145),
    [anon_sym_select] = ACTIONS(4145),
    [anon_sym_as] = ACTIONS(4027),
    [anon_sym_is] = ACTIONS(4027),
    [anon_sym_DASH_GT] = ACTIONS(4024),
    [anon_sym_with] = ACTIONS(4027),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4024),
  },
  [2758] = {
    [sym_preproc_region] = STATE(2758),
    [sym_preproc_endregion] = STATE(2758),
    [sym_preproc_line] = STATE(2758),
    [sym_preproc_pragma] = STATE(2758),
    [sym_preproc_nullable] = STATE(2758),
    [sym_preproc_error] = STATE(2758),
    [sym_preproc_define] = STATE(2758),
    [sym_preproc_undef] = STATE(2758),
    [sym__identifier_token] = ACTIONS(4099),
    [anon_sym_alias] = ACTIONS(4099),
    [anon_sym_SEMI] = ACTIONS(4111),
    [anon_sym_global] = ACTIONS(4099),
    [anon_sym_EQ] = ACTIONS(4104),
    [anon_sym_LBRACK] = ACTIONS(4101),
    [anon_sym_COLON] = ACTIONS(4111),
    [anon_sym_COMMA] = ACTIONS(4111),
    [anon_sym_RBRACK] = ACTIONS(4111),
    [anon_sym_LPAREN] = ACTIONS(4101),
    [anon_sym_RPAREN] = ACTIONS(4111),
    [anon_sym_RBRACE] = ACTIONS(4111),
    [anon_sym_file] = ACTIONS(4099),
    [anon_sym_LT] = ACTIONS(4104),
    [anon_sym_GT] = ACTIONS(4104),
    [anon_sym_in] = ACTIONS(4104),
    [anon_sym_where] = ACTIONS(4099),
    [anon_sym_QMARK] = ACTIONS(4108),
    [anon_sym_notnull] = ACTIONS(4099),
    [anon_sym_unmanaged] = ACTIONS(4099),
    [anon_sym_BANG] = ACTIONS(4104),
    [anon_sym_PLUS_PLUS] = ACTIONS(4111),
    [anon_sym_DASH_DASH] = ACTIONS(4111),
    [anon_sym_PLUS] = ACTIONS(4104),
    [anon_sym_DASH] = ACTIONS(4104),
    [anon_sym_STAR] = ACTIONS(4108),
    [anon_sym_SLASH] = ACTIONS(4104),
    [anon_sym_PERCENT] = ACTIONS(4104),
    [anon_sym_CARET] = ACTIONS(4104),
    [anon_sym_PIPE] = ACTIONS(4104),
    [anon_sym_AMP] = ACTIONS(4104),
    [anon_sym_LT_LT] = ACTIONS(4104),
    [anon_sym_GT_GT] = ACTIONS(4104),
    [anon_sym_GT_GT_GT] = ACTIONS(4104),
    [anon_sym_EQ_EQ] = ACTIONS(4111),
    [anon_sym_BANG_EQ] = ACTIONS(4111),
    [anon_sym_GT_EQ] = ACTIONS(4111),
    [anon_sym_LT_EQ] = ACTIONS(4111),
    [anon_sym_DOT] = ACTIONS(4108),
    [anon_sym_scoped] = ACTIONS(4099),
    [anon_sym_EQ_GT] = ACTIONS(4111),
    [anon_sym_var] = ACTIONS(4099),
    [anon_sym_yield] = ACTIONS(4099),
    [anon_sym_switch] = ACTIONS(4104),
    [anon_sym_when] = ACTIONS(4099),
    [anon_sym_DOT_DOT] = ACTIONS(4111),
    [anon_sym_and] = ACTIONS(4104),
    [anon_sym_or] = ACTIONS(4104),
    [anon_sym_PLUS_EQ] = ACTIONS(4111),
    [anon_sym_DASH_EQ] = ACTIONS(4111),
    [anon_sym_STAR_EQ] = ACTIONS(4111),
    [anon_sym_SLASH_EQ] = ACTIONS(4111),
    [anon_sym_PERCENT_EQ] = ACTIONS(4111),
    [anon_sym_AMP_EQ] = ACTIONS(4111),
    [anon_sym_CARET_EQ] = ACTIONS(4111),
    [anon_sym_PIPE_EQ] = ACTIONS(4111),
    [anon_sym_LT_LT_EQ] = ACTIONS(4111),
    [anon_sym_GT_GT_EQ] = ACTIONS(4111),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4111),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4111),
    [anon_sym_AMP_AMP] = ACTIONS(4111),
    [anon_sym_PIPE_PIPE] = ACTIONS(4111),
    [anon_sym_QMARK_QMARK] = ACTIONS(4104),
    [anon_sym_from] = ACTIONS(4099),
    [anon_sym_into] = ACTIONS(4108),
    [anon_sym_join] = ACTIONS(4099),
    [anon_sym_on] = ACTIONS(4099),
    [anon_sym_equals] = ACTIONS(4099),
    [anon_sym_let] = ACTIONS(4099),
    [anon_sym_orderby] = ACTIONS(4099),
    [anon_sym_ascending] = ACTIONS(4099),
    [anon_sym_descending] = ACTIONS(4099),
    [anon_sym_group] = ACTIONS(4099),
    [anon_sym_by] = ACTIONS(4099),
    [anon_sym_select] = ACTIONS(4099),
    [anon_sym_as] = ACTIONS(4104),
    [anon_sym_is] = ACTIONS(4104),
    [anon_sym_DASH_GT] = ACTIONS(4101),
    [anon_sym_with] = ACTIONS(4104),
    [aux_sym_preproc_if_token3] = ACTIONS(4111),
    [aux_sym_preproc_else_token1] = ACTIONS(4111),
    [aux_sym_preproc_elif_token1] = ACTIONS(4111),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2759] = {
    [sym__name] = STATE(3926),
    [sym_alias_qualified_name] = STATE(3912),
    [sym__simple_name] = STATE(3912),
    [sym_qualified_name] = STATE(3912),
    [sym_generic_name] = STATE(3874),
    [sym_ref_type] = STATE(3927),
    [sym__scoped_base_type] = STATE(3930),
    [sym_identifier] = STATE(3787),
    [sym__reserved_identifier] = STATE(3838),
    [sym_preproc_region] = STATE(2759),
    [sym_preproc_endregion] = STATE(2759),
    [sym_preproc_line] = STATE(2759),
    [sym_preproc_pragma] = STATE(2759),
    [sym_preproc_nullable] = STATE(2759),
    [sym_preproc_error] = STATE(2759),
    [sym_preproc_define] = STATE(2759),
    [sym_preproc_undef] = STATE(2759),
    [sym__identifier_token] = ACTIONS(4157),
    [anon_sym_alias] = ACTIONS(4159),
    [anon_sym_SEMI] = ACTIONS(3719),
    [anon_sym_global] = ACTIONS(4159),
    [anon_sym_LBRACK] = ACTIONS(3719),
    [anon_sym_COLON] = ACTIONS(3721),
    [anon_sym_COMMA] = ACTIONS(3719),
    [anon_sym_RBRACK] = ACTIONS(3719),
    [anon_sym_LPAREN] = ACTIONS(3719),
    [anon_sym_RPAREN] = ACTIONS(3719),
    [anon_sym_ref] = ACTIONS(4161),
    [anon_sym_LBRACE] = ACTIONS(3719),
    [anon_sym_RBRACE] = ACTIONS(3719),
    [anon_sym_file] = ACTIONS(4159),
    [anon_sym_LT] = ACTIONS(3721),
    [anon_sym_GT] = ACTIONS(3721),
    [anon_sym_in] = ACTIONS(3721),
    [anon_sym_where] = ACTIONS(4159),
    [anon_sym_QMARK] = ACTIONS(3721),
    [anon_sym_notnull] = ACTIONS(4159),
    [anon_sym_unmanaged] = ACTIONS(4159),
    [anon_sym_BANG] = ACTIONS(3721),
    [anon_sym_PLUS_PLUS] = ACTIONS(3719),
    [anon_sym_DASH_DASH] = ACTIONS(3719),
    [anon_sym_PLUS] = ACTIONS(3721),
    [anon_sym_DASH] = ACTIONS(3721),
    [anon_sym_STAR] = ACTIONS(3719),
    [anon_sym_SLASH] = ACTIONS(3721),
    [anon_sym_PERCENT] = ACTIONS(3719),
    [anon_sym_CARET] = ACTIONS(3719),
    [anon_sym_PIPE] = ACTIONS(3721),
    [anon_sym_AMP] = ACTIONS(3721),
    [anon_sym_LT_LT] = ACTIONS(3719),
    [anon_sym_GT_GT] = ACTIONS(3721),
    [anon_sym_GT_GT_GT] = ACTIONS(3719),
    [anon_sym_EQ_EQ] = ACTIONS(3719),
    [anon_sym_BANG_EQ] = ACTIONS(3719),
    [anon_sym_GT_EQ] = ACTIONS(3719),
    [anon_sym_LT_EQ] = ACTIONS(3719),
    [anon_sym_DOT] = ACTIONS(3721),
    [anon_sym_scoped] = ACTIONS(4159),
    [anon_sym_EQ_GT] = ACTIONS(3719),
    [anon_sym_COLON_COLON] = ACTIONS(3719),
    [anon_sym_var] = ACTIONS(4159),
    [anon_sym_yield] = ACTIONS(4159),
    [anon_sym_switch] = ACTIONS(3721),
    [anon_sym_when] = ACTIONS(4159),
    [anon_sym_DOT_DOT] = ACTIONS(3719),
    [anon_sym_and] = ACTIONS(3721),
    [anon_sym_or] = ACTIONS(3721),
    [anon_sym_AMP_AMP] = ACTIONS(3719),
    [anon_sym_PIPE_PIPE] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK] = ACTIONS(3719),
    [anon_sym_from] = ACTIONS(4159),
    [anon_sym_into] = ACTIONS(4163),
    [anon_sym_join] = ACTIONS(4159),
    [anon_sym_on] = ACTIONS(4159),
    [anon_sym_equals] = ACTIONS(4159),
    [anon_sym_let] = ACTIONS(4159),
    [anon_sym_orderby] = ACTIONS(4159),
    [anon_sym_ascending] = ACTIONS(4159),
    [anon_sym_descending] = ACTIONS(4159),
    [anon_sym_group] = ACTIONS(4159),
    [anon_sym_by] = ACTIONS(4159),
    [anon_sym_select] = ACTIONS(4159),
    [anon_sym_as] = ACTIONS(3721),
    [anon_sym_is] = ACTIONS(3721),
    [anon_sym_DASH_GT] = ACTIONS(3719),
    [anon_sym_with] = ACTIONS(3721),
    [aux_sym_preproc_if_token3] = ACTIONS(3719),
    [aux_sym_preproc_else_token1] = ACTIONS(3719),
    [aux_sym_preproc_elif_token1] = ACTIONS(3719),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2760] = {
    [sym__name] = STATE(3008),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2977),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2956),
    [sym_ref_type] = STATE(2899),
    [sym__scoped_base_type] = STATE(2907),
    [sym_identifier] = STATE(2913),
    [sym__reserved_identifier] = STATE(2914),
    [sym_preproc_region] = STATE(2760),
    [sym_preproc_endregion] = STATE(2760),
    [sym_preproc_line] = STATE(2760),
    [sym_preproc_pragma] = STATE(2760),
    [sym_preproc_nullable] = STATE(2760),
    [sym_preproc_error] = STATE(2760),
    [sym_preproc_define] = STATE(2760),
    [sym_preproc_undef] = STATE(2760),
    [sym__identifier_token] = ACTIONS(3998),
    [anon_sym_alias] = ACTIONS(4001),
    [anon_sym_SEMI] = ACTIONS(3719),
    [anon_sym_global] = ACTIONS(4001),
    [anon_sym_LBRACK] = ACTIONS(3719),
    [anon_sym_COMMA] = ACTIONS(3719),
    [anon_sym_RBRACK] = ACTIONS(3719),
    [anon_sym_LPAREN] = ACTIONS(3719),
    [anon_sym_RPAREN] = ACTIONS(3719),
    [anon_sym_ref] = ACTIONS(4004),
    [anon_sym_LBRACE] = ACTIONS(3719),
    [anon_sym_RBRACE] = ACTIONS(3719),
    [anon_sym_file] = ACTIONS(4001),
    [anon_sym_LT] = ACTIONS(3721),
    [anon_sym_GT] = ACTIONS(3721),
    [anon_sym_in] = ACTIONS(3721),
    [anon_sym_where] = ACTIONS(4001),
    [anon_sym_QMARK] = ACTIONS(3721),
    [anon_sym_notnull] = ACTIONS(4001),
    [anon_sym_unmanaged] = ACTIONS(4001),
    [anon_sym_BANG] = ACTIONS(3721),
    [anon_sym_PLUS_PLUS] = ACTIONS(3719),
    [anon_sym_DASH_DASH] = ACTIONS(3719),
    [anon_sym_PLUS] = ACTIONS(3721),
    [anon_sym_DASH] = ACTIONS(3721),
    [anon_sym_STAR] = ACTIONS(3719),
    [anon_sym_SLASH] = ACTIONS(3721),
    [anon_sym_PERCENT] = ACTIONS(3719),
    [anon_sym_CARET] = ACTIONS(3719),
    [anon_sym_PIPE] = ACTIONS(3721),
    [anon_sym_AMP] = ACTIONS(3721),
    [anon_sym_LT_LT] = ACTIONS(3719),
    [anon_sym_GT_GT] = ACTIONS(3721),
    [anon_sym_GT_GT_GT] = ACTIONS(3719),
    [anon_sym_EQ_EQ] = ACTIONS(3719),
    [anon_sym_BANG_EQ] = ACTIONS(3719),
    [anon_sym_GT_EQ] = ACTIONS(3719),
    [anon_sym_LT_EQ] = ACTIONS(3719),
    [anon_sym_DOT] = ACTIONS(3721),
    [anon_sym_scoped] = ACTIONS(4001),
    [anon_sym_EQ_GT] = ACTIONS(3719),
    [anon_sym_COLON_COLON] = ACTIONS(3719),
    [anon_sym_var] = ACTIONS(4001),
    [anon_sym_yield] = ACTIONS(4001),
    [anon_sym_switch] = ACTIONS(3721),
    [anon_sym_when] = ACTIONS(4001),
    [sym_discard] = ACTIONS(3721),
    [anon_sym_DOT_DOT] = ACTIONS(3719),
    [anon_sym_and] = ACTIONS(3721),
    [anon_sym_or] = ACTIONS(3721),
    [anon_sym_AMP_AMP] = ACTIONS(3719),
    [anon_sym_PIPE_PIPE] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK] = ACTIONS(3719),
    [anon_sym_from] = ACTIONS(4001),
    [anon_sym_into] = ACTIONS(4001),
    [anon_sym_join] = ACTIONS(4001),
    [anon_sym_on] = ACTIONS(4001),
    [anon_sym_equals] = ACTIONS(4001),
    [anon_sym_let] = ACTIONS(4001),
    [anon_sym_orderby] = ACTIONS(4001),
    [anon_sym_ascending] = ACTIONS(4001),
    [anon_sym_descending] = ACTIONS(4001),
    [anon_sym_group] = ACTIONS(4001),
    [anon_sym_by] = ACTIONS(4001),
    [anon_sym_select] = ACTIONS(4001),
    [anon_sym_as] = ACTIONS(3721),
    [anon_sym_is] = ACTIONS(3721),
    [anon_sym_DASH_GT] = ACTIONS(3719),
    [anon_sym_with] = ACTIONS(3721),
    [aux_sym_preproc_if_token3] = ACTIONS(3719),
    [aux_sym_preproc_else_token1] = ACTIONS(3719),
    [aux_sym_preproc_elif_token1] = ACTIONS(3719),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2761] = {
    [sym_preproc_region] = STATE(2761),
    [sym_preproc_endregion] = STATE(2761),
    [sym_preproc_line] = STATE(2761),
    [sym_preproc_pragma] = STATE(2761),
    [sym_preproc_nullable] = STATE(2761),
    [sym_preproc_error] = STATE(2761),
    [sym_preproc_define] = STATE(2761),
    [sym_preproc_undef] = STATE(2761),
    [sym__identifier_token] = ACTIONS(4113),
    [anon_sym_alias] = ACTIONS(4113),
    [anon_sym_SEMI] = ACTIONS(4133),
    [anon_sym_global] = ACTIONS(4113),
    [anon_sym_EQ] = ACTIONS(4118),
    [anon_sym_LBRACK] = ACTIONS(4135),
    [anon_sym_COLON] = ACTIONS(4133),
    [anon_sym_COMMA] = ACTIONS(4135),
    [anon_sym_RBRACK] = ACTIONS(4135),
    [anon_sym_LPAREN] = ACTIONS(4135),
    [anon_sym_RPAREN] = ACTIONS(4135),
    [anon_sym_file] = ACTIONS(4113),
    [anon_sym_LT] = ACTIONS(4118),
    [anon_sym_GT] = ACTIONS(4118),
    [anon_sym_in] = ACTIONS(4118),
    [anon_sym_where] = ACTIONS(4113),
    [anon_sym_QMARK] = ACTIONS(4138),
    [anon_sym_notnull] = ACTIONS(4113),
    [anon_sym_unmanaged] = ACTIONS(4113),
    [anon_sym_BANG] = ACTIONS(4118),
    [anon_sym_PLUS_PLUS] = ACTIONS(4133),
    [anon_sym_DASH_DASH] = ACTIONS(4133),
    [anon_sym_PLUS] = ACTIONS(4118),
    [anon_sym_DASH] = ACTIONS(4118),
    [anon_sym_STAR] = ACTIONS(4138),
    [anon_sym_SLASH] = ACTIONS(4118),
    [anon_sym_PERCENT] = ACTIONS(4118),
    [anon_sym_CARET] = ACTIONS(4118),
    [anon_sym_PIPE] = ACTIONS(4118),
    [anon_sym_AMP] = ACTIONS(4118),
    [anon_sym_LT_LT] = ACTIONS(4118),
    [anon_sym_GT_GT] = ACTIONS(4118),
    [anon_sym_GT_GT_GT] = ACTIONS(4118),
    [anon_sym_EQ_EQ] = ACTIONS(4133),
    [anon_sym_BANG_EQ] = ACTIONS(4133),
    [anon_sym_GT_EQ] = ACTIONS(4133),
    [anon_sym_LT_EQ] = ACTIONS(4133),
    [anon_sym_DOT] = ACTIONS(4138),
    [anon_sym_scoped] = ACTIONS(4113),
    [anon_sym_EQ_GT] = ACTIONS(4133),
    [anon_sym_var] = ACTIONS(4113),
    [anon_sym_yield] = ACTIONS(4113),
    [anon_sym_switch] = ACTIONS(4118),
    [anon_sym_when] = ACTIONS(4113),
    [anon_sym_DOT_DOT] = ACTIONS(4133),
    [anon_sym_and] = ACTIONS(4118),
    [anon_sym_or] = ACTIONS(4118),
    [anon_sym_PLUS_EQ] = ACTIONS(4133),
    [anon_sym_DASH_EQ] = ACTIONS(4133),
    [anon_sym_STAR_EQ] = ACTIONS(4133),
    [anon_sym_SLASH_EQ] = ACTIONS(4133),
    [anon_sym_PERCENT_EQ] = ACTIONS(4133),
    [anon_sym_AMP_EQ] = ACTIONS(4133),
    [anon_sym_CARET_EQ] = ACTIONS(4133),
    [anon_sym_PIPE_EQ] = ACTIONS(4133),
    [anon_sym_LT_LT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4133),
    [anon_sym_AMP_AMP] = ACTIONS(4133),
    [anon_sym_PIPE_PIPE] = ACTIONS(4133),
    [anon_sym_QMARK_QMARK] = ACTIONS(4118),
    [anon_sym_from] = ACTIONS(4113),
    [anon_sym_into] = ACTIONS(4113),
    [anon_sym_join] = ACTIONS(4113),
    [anon_sym_on] = ACTIONS(4113),
    [anon_sym_equals] = ACTIONS(4113),
    [anon_sym_let] = ACTIONS(4113),
    [anon_sym_orderby] = ACTIONS(4113),
    [anon_sym_ascending] = ACTIONS(4113),
    [anon_sym_descending] = ACTIONS(4113),
    [anon_sym_group] = ACTIONS(4113),
    [anon_sym_by] = ACTIONS(4113),
    [anon_sym_select] = ACTIONS(4113),
    [anon_sym_as] = ACTIONS(4118),
    [anon_sym_is] = ACTIONS(4118),
    [anon_sym_DASH_GT] = ACTIONS(4135),
    [anon_sym_with] = ACTIONS(4118),
    [aux_sym_preproc_if_token3] = ACTIONS(4133),
    [aux_sym_preproc_else_token1] = ACTIONS(4133),
    [aux_sym_preproc_elif_token1] = ACTIONS(4133),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2762] = {
    [sym_type_argument_list] = STATE(2736),
    [sym_preproc_region] = STATE(2762),
    [sym_preproc_endregion] = STATE(2762),
    [sym_preproc_line] = STATE(2762),
    [sym_preproc_pragma] = STATE(2762),
    [sym_preproc_nullable] = STATE(2762),
    [sym_preproc_error] = STATE(2762),
    [sym_preproc_define] = STATE(2762),
    [sym_preproc_undef] = STATE(2762),
    [sym__identifier_token] = ACTIONS(4074),
    [anon_sym_alias] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4074),
    [anon_sym_EQ] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4076),
    [anon_sym_COLON] = ACTIONS(4074),
    [anon_sym_COMMA] = ACTIONS(4076),
    [anon_sym_LPAREN] = ACTIONS(4076),
    [anon_sym_RPAREN] = ACTIONS(4076),
    [anon_sym_LBRACE] = ACTIONS(4076),
    [anon_sym_RBRACE] = ACTIONS(4076),
    [anon_sym_file] = ACTIONS(4074),
    [anon_sym_LT] = ACTIONS(4078),
    [anon_sym_GT] = ACTIONS(4074),
    [anon_sym_where] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(4074),
    [anon_sym_notnull] = ACTIONS(4074),
    [anon_sym_unmanaged] = ACTIONS(4074),
    [anon_sym_BANG] = ACTIONS(4074),
    [anon_sym_PLUS_PLUS] = ACTIONS(4076),
    [anon_sym_DASH_DASH] = ACTIONS(4076),
    [anon_sym_PLUS] = ACTIONS(4074),
    [anon_sym_DASH] = ACTIONS(4074),
    [anon_sym_STAR] = ACTIONS(4074),
    [anon_sym_SLASH] = ACTIONS(4074),
    [anon_sym_PERCENT] = ACTIONS(4074),
    [anon_sym_CARET] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(4074),
    [anon_sym_AMP] = ACTIONS(4074),
    [anon_sym_LT_LT] = ACTIONS(4074),
    [anon_sym_GT_GT] = ACTIONS(4074),
    [anon_sym_GT_GT_GT] = ACTIONS(4074),
    [anon_sym_EQ_EQ] = ACTIONS(4076),
    [anon_sym_BANG_EQ] = ACTIONS(4076),
    [anon_sym_GT_EQ] = ACTIONS(4076),
    [anon_sym_LT_EQ] = ACTIONS(4076),
    [anon_sym_DOT] = ACTIONS(4074),
    [anon_sym_scoped] = ACTIONS(4074),
    [anon_sym_EQ_GT] = ACTIONS(4081),
    [anon_sym_COLON_COLON] = ACTIONS(4166),
    [anon_sym_var] = ACTIONS(4074),
    [anon_sym_yield] = ACTIONS(4074),
    [anon_sym_switch] = ACTIONS(4074),
    [anon_sym_when] = ACTIONS(4074),
    [sym_discard] = ACTIONS(4074),
    [anon_sym_DOT_DOT] = ACTIONS(4076),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_PLUS_EQ] = ACTIONS(4076),
    [anon_sym_DASH_EQ] = ACTIONS(4076),
    [anon_sym_STAR_EQ] = ACTIONS(4076),
    [anon_sym_SLASH_EQ] = ACTIONS(4076),
    [anon_sym_PERCENT_EQ] = ACTIONS(4076),
    [anon_sym_AMP_EQ] = ACTIONS(4076),
    [anon_sym_CARET_EQ] = ACTIONS(4076),
    [anon_sym_PIPE_EQ] = ACTIONS(4076),
    [anon_sym_LT_LT_EQ] = ACTIONS(4076),
    [anon_sym_GT_GT_EQ] = ACTIONS(4076),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4076),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4076),
    [anon_sym_AMP_AMP] = ACTIONS(4076),
    [anon_sym_PIPE_PIPE] = ACTIONS(4076),
    [anon_sym_QMARK_QMARK] = ACTIONS(4074),
    [anon_sym_from] = ACTIONS(4074),
    [anon_sym_into] = ACTIONS(4074),
    [anon_sym_join] = ACTIONS(4074),
    [anon_sym_on] = ACTIONS(4074),
    [anon_sym_equals] = ACTIONS(4074),
    [anon_sym_let] = ACTIONS(4074),
    [anon_sym_orderby] = ACTIONS(4074),
    [anon_sym_ascending] = ACTIONS(4074),
    [anon_sym_descending] = ACTIONS(4074),
    [anon_sym_group] = ACTIONS(4074),
    [anon_sym_by] = ACTIONS(4074),
    [anon_sym_select] = ACTIONS(4074),
    [anon_sym_as] = ACTIONS(4074),
    [anon_sym_is] = ACTIONS(4074),
    [anon_sym_DASH_GT] = ACTIONS(4076),
    [anon_sym_with] = ACTIONS(4074),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2763] = {
    [sym_preproc_region] = STATE(2763),
    [sym_preproc_endregion] = STATE(2763),
    [sym_preproc_line] = STATE(2763),
    [sym_preproc_pragma] = STATE(2763),
    [sym_preproc_nullable] = STATE(2763),
    [sym_preproc_error] = STATE(2763),
    [sym_preproc_define] = STATE(2763),
    [sym_preproc_undef] = STATE(2763),
    [sym__identifier_token] = ACTIONS(4027),
    [anon_sym_alias] = ACTIONS(4027),
    [anon_sym_global] = ACTIONS(4027),
    [anon_sym_EQ] = ACTIONS(3721),
    [anon_sym_LBRACK] = ACTIONS(3719),
    [anon_sym_COLON] = ACTIONS(4027),
    [anon_sym_COMMA] = ACTIONS(4024),
    [anon_sym_RBRACK] = ACTIONS(4024),
    [anon_sym_LPAREN] = ACTIONS(4024),
    [anon_sym_RPAREN] = ACTIONS(3719),
    [anon_sym_LBRACE] = ACTIONS(4024),
    [anon_sym_RBRACE] = ACTIONS(4024),
    [anon_sym_file] = ACTIONS(4027),
    [anon_sym_LT] = ACTIONS(3721),
    [anon_sym_GT] = ACTIONS(3721),
    [anon_sym_where] = ACTIONS(4027),
    [anon_sym_QMARK] = ACTIONS(3721),
    [anon_sym_notnull] = ACTIONS(4027),
    [anon_sym_unmanaged] = ACTIONS(4027),
    [anon_sym_BANG] = ACTIONS(3721),
    [anon_sym_PLUS_PLUS] = ACTIONS(3719),
    [anon_sym_DASH_DASH] = ACTIONS(3719),
    [anon_sym_PLUS] = ACTIONS(3721),
    [anon_sym_DASH] = ACTIONS(3721),
    [anon_sym_STAR] = ACTIONS(3721),
    [anon_sym_SLASH] = ACTIONS(3721),
    [anon_sym_PERCENT] = ACTIONS(3721),
    [anon_sym_CARET] = ACTIONS(3721),
    [anon_sym_PIPE] = ACTIONS(3721),
    [anon_sym_AMP] = ACTIONS(3721),
    [anon_sym_LT_LT] = ACTIONS(3721),
    [anon_sym_GT_GT] = ACTIONS(3721),
    [anon_sym_GT_GT_GT] = ACTIONS(3721),
    [anon_sym_EQ_EQ] = ACTIONS(3719),
    [anon_sym_BANG_EQ] = ACTIONS(3719),
    [anon_sym_GT_EQ] = ACTIONS(3719),
    [anon_sym_LT_EQ] = ACTIONS(3719),
    [anon_sym_DOT] = ACTIONS(3721),
    [anon_sym_scoped] = ACTIONS(4027),
    [anon_sym_EQ_GT] = ACTIONS(3719),
    [anon_sym_COLON_COLON] = ACTIONS(3719),
    [anon_sym_var] = ACTIONS(4027),
    [anon_sym_yield] = ACTIONS(4027),
    [anon_sym_switch] = ACTIONS(3721),
    [anon_sym_when] = ACTIONS(4027),
    [sym_discard] = ACTIONS(4027),
    [anon_sym_DOT_DOT] = ACTIONS(3719),
    [anon_sym_and] = ACTIONS(4027),
    [anon_sym_or] = ACTIONS(4027),
    [anon_sym_PLUS_EQ] = ACTIONS(3719),
    [anon_sym_DASH_EQ] = ACTIONS(3719),
    [anon_sym_STAR_EQ] = ACTIONS(3719),
    [anon_sym_SLASH_EQ] = ACTIONS(3719),
    [anon_sym_PERCENT_EQ] = ACTIONS(3719),
    [anon_sym_AMP_EQ] = ACTIONS(3719),
    [anon_sym_CARET_EQ] = ACTIONS(3719),
    [anon_sym_PIPE_EQ] = ACTIONS(3719),
    [anon_sym_LT_LT_EQ] = ACTIONS(3719),
    [anon_sym_GT_GT_EQ] = ACTIONS(3719),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3719),
    [anon_sym_AMP_AMP] = ACTIONS(3719),
    [anon_sym_PIPE_PIPE] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK] = ACTIONS(3721),
    [anon_sym_from] = ACTIONS(4027),
    [anon_sym_into] = ACTIONS(4027),
    [anon_sym_join] = ACTIONS(4027),
    [anon_sym_on] = ACTIONS(4027),
    [anon_sym_equals] = ACTIONS(4027),
    [anon_sym_let] = ACTIONS(4027),
    [anon_sym_orderby] = ACTIONS(4027),
    [anon_sym_ascending] = ACTIONS(4027),
    [anon_sym_descending] = ACTIONS(4027),
    [anon_sym_group] = ACTIONS(4027),
    [anon_sym_by] = ACTIONS(4027),
    [anon_sym_select] = ACTIONS(4027),
    [anon_sym_as] = ACTIONS(3721),
    [anon_sym_is] = ACTIONS(3721),
    [anon_sym_DASH_GT] = ACTIONS(3719),
    [anon_sym_with] = ACTIONS(3721),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2764] = {
    [sym__variable_designation] = STATE(4270),
    [sym_parenthesized_variable_designation] = STATE(4274),
    [sym_identifier] = STATE(4269),
    [sym__reserved_identifier] = STATE(3127),
    [sym_preproc_region] = STATE(2764),
    [sym_preproc_endregion] = STATE(2764),
    [sym_preproc_line] = STATE(2764),
    [sym_preproc_pragma] = STATE(2764),
    [sym_preproc_nullable] = STATE(2764),
    [sym_preproc_error] = STATE(2764),
    [sym_preproc_define] = STATE(2764),
    [sym_preproc_undef] = STATE(2764),
    [sym__identifier_token] = ACTIONS(4091),
    [anon_sym_alias] = ACTIONS(4095),
    [anon_sym_global] = ACTIONS(4095),
    [anon_sym_EQ] = ACTIONS(3721),
    [anon_sym_LBRACK] = ACTIONS(3719),
    [anon_sym_COLON] = ACTIONS(4027),
    [anon_sym_LPAREN] = ACTIONS(4046),
    [anon_sym_LBRACE] = ACTIONS(4024),
    [anon_sym_file] = ACTIONS(4095),
    [anon_sym_LT] = ACTIONS(3721),
    [anon_sym_GT] = ACTIONS(3721),
    [anon_sym_where] = ACTIONS(4095),
    [anon_sym_QMARK] = ACTIONS(3721),
    [anon_sym_notnull] = ACTIONS(4095),
    [anon_sym_unmanaged] = ACTIONS(4095),
    [anon_sym_BANG] = ACTIONS(3721),
    [anon_sym_PLUS_PLUS] = ACTIONS(3719),
    [anon_sym_DASH_DASH] = ACTIONS(3719),
    [anon_sym_PLUS] = ACTIONS(3721),
    [anon_sym_DASH] = ACTIONS(3721),
    [anon_sym_STAR] = ACTIONS(3721),
    [anon_sym_SLASH] = ACTIONS(3721),
    [anon_sym_PERCENT] = ACTIONS(3721),
    [anon_sym_CARET] = ACTIONS(3721),
    [anon_sym_PIPE] = ACTIONS(3721),
    [anon_sym_AMP] = ACTIONS(3721),
    [anon_sym_LT_LT] = ACTIONS(3721),
    [anon_sym_GT_GT] = ACTIONS(3721),
    [anon_sym_GT_GT_GT] = ACTIONS(3721),
    [anon_sym_EQ_EQ] = ACTIONS(3719),
    [anon_sym_BANG_EQ] = ACTIONS(3719),
    [anon_sym_GT_EQ] = ACTIONS(3719),
    [anon_sym_LT_EQ] = ACTIONS(3719),
    [anon_sym_DOT] = ACTIONS(3721),
    [anon_sym_scoped] = ACTIONS(4095),
    [anon_sym_EQ_GT] = ACTIONS(3719),
    [anon_sym_COLON_COLON] = ACTIONS(3719),
    [anon_sym_var] = ACTIONS(4095),
    [anon_sym_yield] = ACTIONS(4095),
    [anon_sym_switch] = ACTIONS(3721),
    [anon_sym_when] = ACTIONS(4095),
    [sym_discard] = ACTIONS(4050),
    [anon_sym_DOT_DOT] = ACTIONS(3719),
    [anon_sym_and] = ACTIONS(4027),
    [anon_sym_or] = ACTIONS(4027),
    [anon_sym_PLUS_EQ] = ACTIONS(3719),
    [anon_sym_DASH_EQ] = ACTIONS(3719),
    [anon_sym_STAR_EQ] = ACTIONS(3719),
    [anon_sym_SLASH_EQ] = ACTIONS(3719),
    [anon_sym_PERCENT_EQ] = ACTIONS(3719),
    [anon_sym_AMP_EQ] = ACTIONS(3719),
    [anon_sym_CARET_EQ] = ACTIONS(3719),
    [anon_sym_PIPE_EQ] = ACTIONS(3719),
    [anon_sym_LT_LT_EQ] = ACTIONS(3719),
    [anon_sym_GT_GT_EQ] = ACTIONS(3719),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3719),
    [anon_sym_AMP_AMP] = ACTIONS(3719),
    [anon_sym_PIPE_PIPE] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK] = ACTIONS(3721),
    [anon_sym_from] = ACTIONS(4095),
    [anon_sym_into] = ACTIONS(4095),
    [anon_sym_join] = ACTIONS(4095),
    [anon_sym_on] = ACTIONS(4095),
    [anon_sym_equals] = ACTIONS(4095),
    [anon_sym_let] = ACTIONS(4095),
    [anon_sym_orderby] = ACTIONS(4095),
    [anon_sym_ascending] = ACTIONS(4095),
    [anon_sym_descending] = ACTIONS(4095),
    [anon_sym_group] = ACTIONS(4095),
    [anon_sym_by] = ACTIONS(4095),
    [anon_sym_select] = ACTIONS(4095),
    [anon_sym_as] = ACTIONS(3721),
    [anon_sym_is] = ACTIONS(3721),
    [anon_sym_DASH_GT] = ACTIONS(3719),
    [anon_sym_with] = ACTIONS(3721),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2765] = {
    [sym__name] = STATE(4267),
    [sym_alias_qualified_name] = STATE(3955),
    [sym__simple_name] = STATE(3955),
    [sym_qualified_name] = STATE(3955),
    [sym_generic_name] = STATE(4047),
    [sym_ref_type] = STATE(4040),
    [sym__scoped_base_type] = STATE(4036),
    [sym_identifier] = STATE(3891),
    [sym__reserved_identifier] = STATE(3897),
    [sym_preproc_region] = STATE(2765),
    [sym_preproc_endregion] = STATE(2765),
    [sym_preproc_line] = STATE(2765),
    [sym_preproc_pragma] = STATE(2765),
    [sym_preproc_nullable] = STATE(2765),
    [sym_preproc_error] = STATE(2765),
    [sym_preproc_define] = STATE(2765),
    [sym_preproc_undef] = STATE(2765),
    [sym__identifier_token] = ACTIONS(4168),
    [anon_sym_alias] = ACTIONS(4170),
    [anon_sym_SEMI] = ACTIONS(3719),
    [anon_sym_global] = ACTIONS(4170),
    [anon_sym_LBRACK] = ACTIONS(3719),
    [anon_sym_COLON] = ACTIONS(3721),
    [anon_sym_COMMA] = ACTIONS(3719),
    [anon_sym_RBRACK] = ACTIONS(3719),
    [anon_sym_LPAREN] = ACTIONS(3719),
    [anon_sym_RPAREN] = ACTIONS(3719),
    [anon_sym_ref] = ACTIONS(4172),
    [anon_sym_LBRACE] = ACTIONS(3719),
    [anon_sym_RBRACE] = ACTIONS(3719),
    [anon_sym_file] = ACTIONS(4170),
    [anon_sym_LT] = ACTIONS(3721),
    [anon_sym_GT] = ACTIONS(3721),
    [anon_sym_where] = ACTIONS(4170),
    [anon_sym_QMARK] = ACTIONS(3721),
    [anon_sym_notnull] = ACTIONS(4170),
    [anon_sym_unmanaged] = ACTIONS(4170),
    [anon_sym_BANG] = ACTIONS(3721),
    [anon_sym_PLUS_PLUS] = ACTIONS(3719),
    [anon_sym_DASH_DASH] = ACTIONS(3719),
    [anon_sym_PLUS] = ACTIONS(3721),
    [anon_sym_DASH] = ACTIONS(3721),
    [anon_sym_STAR] = ACTIONS(3719),
    [anon_sym_SLASH] = ACTIONS(3721),
    [anon_sym_PERCENT] = ACTIONS(3719),
    [anon_sym_CARET] = ACTIONS(3719),
    [anon_sym_PIPE] = ACTIONS(3721),
    [anon_sym_AMP] = ACTIONS(3721),
    [anon_sym_LT_LT] = ACTIONS(3719),
    [anon_sym_GT_GT] = ACTIONS(3721),
    [anon_sym_GT_GT_GT] = ACTIONS(3719),
    [anon_sym_EQ_EQ] = ACTIONS(3719),
    [anon_sym_BANG_EQ] = ACTIONS(3719),
    [anon_sym_GT_EQ] = ACTIONS(3719),
    [anon_sym_LT_EQ] = ACTIONS(3719),
    [anon_sym_DOT] = ACTIONS(3721),
    [anon_sym_scoped] = ACTIONS(4170),
    [anon_sym_EQ_GT] = ACTIONS(3719),
    [anon_sym_COLON_COLON] = ACTIONS(3719),
    [anon_sym_var] = ACTIONS(4170),
    [anon_sym_yield] = ACTIONS(4170),
    [anon_sym_switch] = ACTIONS(3721),
    [anon_sym_when] = ACTIONS(4170),
    [anon_sym_DOT_DOT] = ACTIONS(3719),
    [anon_sym_and] = ACTIONS(3721),
    [anon_sym_or] = ACTIONS(3721),
    [anon_sym_AMP_AMP] = ACTIONS(3719),
    [anon_sym_PIPE_PIPE] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK] = ACTIONS(3719),
    [anon_sym_from] = ACTIONS(4170),
    [anon_sym_into] = ACTIONS(4170),
    [anon_sym_join] = ACTIONS(4170),
    [anon_sym_on] = ACTIONS(4170),
    [anon_sym_equals] = ACTIONS(4170),
    [anon_sym_let] = ACTIONS(4170),
    [anon_sym_orderby] = ACTIONS(4170),
    [anon_sym_ascending] = ACTIONS(4170),
    [anon_sym_descending] = ACTIONS(4170),
    [anon_sym_group] = ACTIONS(4170),
    [anon_sym_by] = ACTIONS(4170),
    [anon_sym_select] = ACTIONS(4170),
    [anon_sym_as] = ACTIONS(3721),
    [anon_sym_is] = ACTIONS(3721),
    [anon_sym_DASH_GT] = ACTIONS(3719),
    [anon_sym_with] = ACTIONS(3721),
    [aux_sym_preproc_if_token3] = ACTIONS(3719),
    [aux_sym_preproc_else_token1] = ACTIONS(3719),
    [aux_sym_preproc_elif_token1] = ACTIONS(3719),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2766] = {
    [sym__variable_designation] = STATE(4615),
    [sym_parenthesized_variable_designation] = STATE(4614),
    [sym_identifier] = STATE(4624),
    [sym__reserved_identifier] = STATE(2914),
    [sym_preproc_region] = STATE(2766),
    [sym_preproc_endregion] = STATE(2766),
    [sym_preproc_line] = STATE(2766),
    [sym_preproc_pragma] = STATE(2766),
    [sym_preproc_nullable] = STATE(2766),
    [sym_preproc_error] = STATE(2766),
    [sym_preproc_define] = STATE(2766),
    [sym_preproc_undef] = STATE(2766),
    [sym__identifier_token] = ACTIONS(4174),
    [anon_sym_alias] = ACTIONS(4178),
    [anon_sym_global] = ACTIONS(4178),
    [anon_sym_EQ] = ACTIONS(3721),
    [anon_sym_LBRACK] = ACTIONS(4024),
    [anon_sym_COMMA] = ACTIONS(4024),
    [anon_sym_LPAREN] = ACTIONS(4182),
    [anon_sym_LBRACE] = ACTIONS(4024),
    [anon_sym_file] = ACTIONS(4178),
    [anon_sym_LT] = ACTIONS(4027),
    [anon_sym_GT] = ACTIONS(4027),
    [anon_sym_where] = ACTIONS(4178),
    [anon_sym_QMARK] = ACTIONS(4027),
    [anon_sym_notnull] = ACTIONS(4178),
    [anon_sym_unmanaged] = ACTIONS(4178),
    [anon_sym_BANG] = ACTIONS(4027),
    [anon_sym_PLUS_PLUS] = ACTIONS(4024),
    [anon_sym_DASH_DASH] = ACTIONS(4024),
    [anon_sym_PLUS] = ACTIONS(4027),
    [anon_sym_DASH] = ACTIONS(4027),
    [anon_sym_STAR] = ACTIONS(4027),
    [anon_sym_SLASH] = ACTIONS(4027),
    [anon_sym_PERCENT] = ACTIONS(4027),
    [anon_sym_CARET] = ACTIONS(4027),
    [anon_sym_PIPE] = ACTIONS(4027),
    [anon_sym_AMP] = ACTIONS(4027),
    [anon_sym_LT_LT] = ACTIONS(4027),
    [anon_sym_GT_GT] = ACTIONS(4027),
    [anon_sym_GT_GT_GT] = ACTIONS(4027),
    [anon_sym_EQ_EQ] = ACTIONS(4024),
    [anon_sym_BANG_EQ] = ACTIONS(4024),
    [anon_sym_GT_EQ] = ACTIONS(4024),
    [anon_sym_LT_EQ] = ACTIONS(4024),
    [anon_sym_DOT] = ACTIONS(4027),
    [anon_sym_scoped] = ACTIONS(4178),
    [anon_sym_EQ_GT] = ACTIONS(3719),
    [anon_sym_COLON_COLON] = ACTIONS(3719),
    [anon_sym_var] = ACTIONS(4178),
    [anon_sym_yield] = ACTIONS(4178),
    [anon_sym_switch] = ACTIONS(4027),
    [anon_sym_when] = ACTIONS(4178),
    [sym_discard] = ACTIONS(4186),
    [anon_sym_DOT_DOT] = ACTIONS(4024),
    [anon_sym_and] = ACTIONS(4027),
    [anon_sym_or] = ACTIONS(4027),
    [anon_sym_PLUS_EQ] = ACTIONS(3719),
    [anon_sym_DASH_EQ] = ACTIONS(3719),
    [anon_sym_STAR_EQ] = ACTIONS(3719),
    [anon_sym_SLASH_EQ] = ACTIONS(3719),
    [anon_sym_PERCENT_EQ] = ACTIONS(3719),
    [anon_sym_AMP_EQ] = ACTIONS(3719),
    [anon_sym_CARET_EQ] = ACTIONS(3719),
    [anon_sym_PIPE_EQ] = ACTIONS(3719),
    [anon_sym_LT_LT_EQ] = ACTIONS(3719),
    [anon_sym_GT_GT_EQ] = ACTIONS(3719),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3719),
    [anon_sym_AMP_AMP] = ACTIONS(4024),
    [anon_sym_PIPE_PIPE] = ACTIONS(4024),
    [anon_sym_QMARK_QMARK] = ACTIONS(4027),
    [anon_sym_from] = ACTIONS(4178),
    [anon_sym_into] = ACTIONS(4178),
    [anon_sym_join] = ACTIONS(4178),
    [anon_sym_on] = ACTIONS(4178),
    [anon_sym_equals] = ACTIONS(4178),
    [anon_sym_let] = ACTIONS(4178),
    [anon_sym_orderby] = ACTIONS(4178),
    [anon_sym_ascending] = ACTIONS(4178),
    [anon_sym_descending] = ACTIONS(4178),
    [anon_sym_group] = ACTIONS(4178),
    [anon_sym_by] = ACTIONS(4178),
    [anon_sym_select] = ACTIONS(4178),
    [anon_sym_as] = ACTIONS(4027),
    [anon_sym_is] = ACTIONS(4027),
    [anon_sym_DASH_GT] = ACTIONS(4024),
    [anon_sym_with] = ACTIONS(4027),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2767] = {
    [sym_type_argument_list] = STATE(2736),
    [sym_preproc_region] = STATE(2767),
    [sym_preproc_endregion] = STATE(2767),
    [sym_preproc_line] = STATE(2767),
    [sym_preproc_pragma] = STATE(2767),
    [sym_preproc_nullable] = STATE(2767),
    [sym_preproc_error] = STATE(2767),
    [sym_preproc_define] = STATE(2767),
    [sym_preproc_undef] = STATE(2767),
    [sym__identifier_token] = ACTIONS(4074),
    [anon_sym_alias] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4074),
    [anon_sym_EQ] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4076),
    [anon_sym_COLON] = ACTIONS(4190),
    [anon_sym_COMMA] = ACTIONS(4076),
    [anon_sym_RBRACK] = ACTIONS(4076),
    [anon_sym_LPAREN] = ACTIONS(4076),
    [anon_sym_RPAREN] = ACTIONS(4076),
    [anon_sym_LBRACE] = ACTIONS(4076),
    [anon_sym_file] = ACTIONS(4074),
    [anon_sym_LT] = ACTIONS(4078),
    [anon_sym_GT] = ACTIONS(4074),
    [anon_sym_where] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(4074),
    [anon_sym_notnull] = ACTIONS(4074),
    [anon_sym_unmanaged] = ACTIONS(4074),
    [anon_sym_BANG] = ACTIONS(4074),
    [anon_sym_PLUS_PLUS] = ACTIONS(4076),
    [anon_sym_DASH_DASH] = ACTIONS(4076),
    [anon_sym_PLUS] = ACTIONS(4074),
    [anon_sym_DASH] = ACTIONS(4074),
    [anon_sym_STAR] = ACTIONS(4074),
    [anon_sym_SLASH] = ACTIONS(4074),
    [anon_sym_PERCENT] = ACTIONS(4074),
    [anon_sym_CARET] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(4074),
    [anon_sym_AMP] = ACTIONS(4074),
    [anon_sym_LT_LT] = ACTIONS(4074),
    [anon_sym_GT_GT] = ACTIONS(4074),
    [anon_sym_GT_GT_GT] = ACTIONS(4074),
    [anon_sym_EQ_EQ] = ACTIONS(4076),
    [anon_sym_BANG_EQ] = ACTIONS(4076),
    [anon_sym_GT_EQ] = ACTIONS(4076),
    [anon_sym_LT_EQ] = ACTIONS(4076),
    [anon_sym_DOT] = ACTIONS(4074),
    [anon_sym_scoped] = ACTIONS(4074),
    [anon_sym_EQ_GT] = ACTIONS(4081),
    [anon_sym_COLON_COLON] = ACTIONS(4083),
    [anon_sym_var] = ACTIONS(4074),
    [anon_sym_yield] = ACTIONS(4074),
    [anon_sym_switch] = ACTIONS(4074),
    [anon_sym_when] = ACTIONS(4074),
    [sym_discard] = ACTIONS(4074),
    [anon_sym_DOT_DOT] = ACTIONS(4076),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_PLUS_EQ] = ACTIONS(4076),
    [anon_sym_DASH_EQ] = ACTIONS(4076),
    [anon_sym_STAR_EQ] = ACTIONS(4076),
    [anon_sym_SLASH_EQ] = ACTIONS(4076),
    [anon_sym_PERCENT_EQ] = ACTIONS(4076),
    [anon_sym_AMP_EQ] = ACTIONS(4076),
    [anon_sym_CARET_EQ] = ACTIONS(4076),
    [anon_sym_PIPE_EQ] = ACTIONS(4076),
    [anon_sym_LT_LT_EQ] = ACTIONS(4076),
    [anon_sym_GT_GT_EQ] = ACTIONS(4076),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4076),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4076),
    [anon_sym_AMP_AMP] = ACTIONS(4076),
    [anon_sym_PIPE_PIPE] = ACTIONS(4076),
    [anon_sym_QMARK_QMARK] = ACTIONS(4074),
    [anon_sym_from] = ACTIONS(4074),
    [anon_sym_into] = ACTIONS(4074),
    [anon_sym_join] = ACTIONS(4074),
    [anon_sym_on] = ACTIONS(4074),
    [anon_sym_equals] = ACTIONS(4074),
    [anon_sym_let] = ACTIONS(4074),
    [anon_sym_orderby] = ACTIONS(4074),
    [anon_sym_ascending] = ACTIONS(4074),
    [anon_sym_descending] = ACTIONS(4074),
    [anon_sym_group] = ACTIONS(4074),
    [anon_sym_by] = ACTIONS(4074),
    [anon_sym_select] = ACTIONS(4074),
    [anon_sym_as] = ACTIONS(4074),
    [anon_sym_is] = ACTIONS(4074),
    [anon_sym_DASH_GT] = ACTIONS(4076),
    [anon_sym_with] = ACTIONS(4074),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2768] = {
    [sym__variable_designation] = STATE(4270),
    [sym_parenthesized_variable_designation] = STATE(4274),
    [sym_identifier] = STATE(4269),
    [sym__reserved_identifier] = STATE(3897),
    [sym_preproc_region] = STATE(2768),
    [sym_preproc_endregion] = STATE(2768),
    [sym_preproc_line] = STATE(2768),
    [sym_preproc_pragma] = STATE(2768),
    [sym_preproc_nullable] = STATE(2768),
    [sym_preproc_error] = STATE(2768),
    [sym_preproc_define] = STATE(2768),
    [sym_preproc_undef] = STATE(2768),
    [sym__identifier_token] = ACTIONS(4192),
    [anon_sym_alias] = ACTIONS(4196),
    [anon_sym_global] = ACTIONS(4196),
    [anon_sym_EQ] = ACTIONS(3721),
    [anon_sym_LBRACK] = ACTIONS(4024),
    [anon_sym_LPAREN] = ACTIONS(4046),
    [anon_sym_LBRACE] = ACTIONS(4024),
    [anon_sym_file] = ACTIONS(4196),
    [anon_sym_LT] = ACTIONS(4027),
    [anon_sym_GT] = ACTIONS(4027),
    [anon_sym_in] = ACTIONS(4027),
    [anon_sym_where] = ACTIONS(4196),
    [anon_sym_QMARK] = ACTIONS(4027),
    [anon_sym_notnull] = ACTIONS(4196),
    [anon_sym_unmanaged] = ACTIONS(4196),
    [anon_sym_BANG] = ACTIONS(4027),
    [anon_sym_PLUS_PLUS] = ACTIONS(4024),
    [anon_sym_DASH_DASH] = ACTIONS(4024),
    [anon_sym_PLUS] = ACTIONS(4027),
    [anon_sym_DASH] = ACTIONS(4027),
    [anon_sym_STAR] = ACTIONS(4027),
    [anon_sym_SLASH] = ACTIONS(4027),
    [anon_sym_PERCENT] = ACTIONS(4027),
    [anon_sym_CARET] = ACTIONS(4027),
    [anon_sym_PIPE] = ACTIONS(4027),
    [anon_sym_AMP] = ACTIONS(4027),
    [anon_sym_LT_LT] = ACTIONS(4027),
    [anon_sym_GT_GT] = ACTIONS(4027),
    [anon_sym_GT_GT_GT] = ACTIONS(4027),
    [anon_sym_EQ_EQ] = ACTIONS(4024),
    [anon_sym_BANG_EQ] = ACTIONS(4024),
    [anon_sym_GT_EQ] = ACTIONS(4024),
    [anon_sym_LT_EQ] = ACTIONS(4024),
    [anon_sym_DOT] = ACTIONS(4027),
    [anon_sym_scoped] = ACTIONS(4196),
    [anon_sym_EQ_GT] = ACTIONS(3719),
    [anon_sym_COLON_COLON] = ACTIONS(3719),
    [anon_sym_var] = ACTIONS(4196),
    [anon_sym_yield] = ACTIONS(4196),
    [anon_sym_switch] = ACTIONS(4027),
    [anon_sym_when] = ACTIONS(4196),
    [sym_discard] = ACTIONS(4050),
    [anon_sym_DOT_DOT] = ACTIONS(4024),
    [anon_sym_and] = ACTIONS(4027),
    [anon_sym_or] = ACTIONS(4027),
    [anon_sym_PLUS_EQ] = ACTIONS(3719),
    [anon_sym_DASH_EQ] = ACTIONS(3719),
    [anon_sym_STAR_EQ] = ACTIONS(3719),
    [anon_sym_SLASH_EQ] = ACTIONS(3719),
    [anon_sym_PERCENT_EQ] = ACTIONS(3719),
    [anon_sym_AMP_EQ] = ACTIONS(3719),
    [anon_sym_CARET_EQ] = ACTIONS(3719),
    [anon_sym_PIPE_EQ] = ACTIONS(3719),
    [anon_sym_LT_LT_EQ] = ACTIONS(3719),
    [anon_sym_GT_GT_EQ] = ACTIONS(3719),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3719),
    [anon_sym_AMP_AMP] = ACTIONS(4024),
    [anon_sym_PIPE_PIPE] = ACTIONS(4024),
    [anon_sym_QMARK_QMARK] = ACTIONS(4027),
    [anon_sym_from] = ACTIONS(4196),
    [anon_sym_into] = ACTIONS(4196),
    [anon_sym_join] = ACTIONS(4196),
    [anon_sym_on] = ACTIONS(4196),
    [anon_sym_equals] = ACTIONS(4196),
    [anon_sym_let] = ACTIONS(4196),
    [anon_sym_orderby] = ACTIONS(4196),
    [anon_sym_ascending] = ACTIONS(4196),
    [anon_sym_descending] = ACTIONS(4196),
    [anon_sym_group] = ACTIONS(4196),
    [anon_sym_by] = ACTIONS(4196),
    [anon_sym_select] = ACTIONS(4196),
    [anon_sym_as] = ACTIONS(4027),
    [anon_sym_is] = ACTIONS(4027),
    [anon_sym_DASH_GT] = ACTIONS(4024),
    [anon_sym_with] = ACTIONS(4027),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2769] = {
    [sym_preproc_region] = STATE(2769),
    [sym_preproc_endregion] = STATE(2769),
    [sym_preproc_line] = STATE(2769),
    [sym_preproc_pragma] = STATE(2769),
    [sym_preproc_nullable] = STATE(2769),
    [sym_preproc_error] = STATE(2769),
    [sym_preproc_define] = STATE(2769),
    [sym_preproc_undef] = STATE(2769),
    [sym__identifier_token] = ACTIONS(2603),
    [anon_sym_alias] = ACTIONS(2603),
    [anon_sym_global] = ACTIONS(2603),
    [anon_sym_EQ] = ACTIONS(4118),
    [anon_sym_LBRACK] = ACTIONS(4133),
    [anon_sym_COLON] = ACTIONS(4133),
    [anon_sym_COMMA] = ACTIONS(4133),
    [anon_sym_LPAREN] = ACTIONS(4200),
    [anon_sym_RPAREN] = ACTIONS(4133),
    [anon_sym_ref] = ACTIONS(2603),
    [anon_sym_delegate] = ACTIONS(2603),
    [anon_sym_file] = ACTIONS(2603),
    [anon_sym_readonly] = ACTIONS(2603),
    [anon_sym_LT] = ACTIONS(4118),
    [anon_sym_GT] = ACTIONS(4118),
    [anon_sym_in] = ACTIONS(2603),
    [anon_sym_out] = ACTIONS(2603),
    [anon_sym_where] = ACTIONS(2603),
    [anon_sym_QMARK] = ACTIONS(4118),
    [anon_sym_notnull] = ACTIONS(2603),
    [anon_sym_unmanaged] = ACTIONS(2603),
    [anon_sym_BANG] = ACTIONS(4118),
    [anon_sym_PLUS_PLUS] = ACTIONS(4133),
    [anon_sym_DASH_DASH] = ACTIONS(4133),
    [anon_sym_PLUS] = ACTIONS(4118),
    [anon_sym_DASH] = ACTIONS(4118),
    [anon_sym_STAR] = ACTIONS(4118),
    [anon_sym_SLASH] = ACTIONS(4118),
    [anon_sym_PERCENT] = ACTIONS(4118),
    [anon_sym_CARET] = ACTIONS(4118),
    [anon_sym_PIPE] = ACTIONS(4118),
    [anon_sym_AMP] = ACTIONS(4118),
    [anon_sym_LT_LT] = ACTIONS(4118),
    [anon_sym_GT_GT] = ACTIONS(4118),
    [anon_sym_GT_GT_GT] = ACTIONS(4118),
    [anon_sym_EQ_EQ] = ACTIONS(4133),
    [anon_sym_BANG_EQ] = ACTIONS(4133),
    [anon_sym_GT_EQ] = ACTIONS(4133),
    [anon_sym_LT_EQ] = ACTIONS(4133),
    [anon_sym_this] = ACTIONS(2603),
    [anon_sym_DOT] = ACTIONS(4118),
    [anon_sym_scoped] = ACTIONS(2603),
    [anon_sym_var] = ACTIONS(2603),
    [sym_predefined_type] = ACTIONS(2603),
    [anon_sym_yield] = ACTIONS(2603),
    [anon_sym_switch] = ACTIONS(4118),
    [anon_sym_when] = ACTIONS(2603),
    [anon_sym_DOT_DOT] = ACTIONS(4133),
    [anon_sym_PLUS_EQ] = ACTIONS(4133),
    [anon_sym_DASH_EQ] = ACTIONS(4133),
    [anon_sym_STAR_EQ] = ACTIONS(4133),
    [anon_sym_SLASH_EQ] = ACTIONS(4133),
    [anon_sym_PERCENT_EQ] = ACTIONS(4133),
    [anon_sym_AMP_EQ] = ACTIONS(4133),
    [anon_sym_CARET_EQ] = ACTIONS(4133),
    [anon_sym_PIPE_EQ] = ACTIONS(4133),
    [anon_sym_LT_LT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4133),
    [anon_sym_AMP_AMP] = ACTIONS(4133),
    [anon_sym_PIPE_PIPE] = ACTIONS(4133),
    [anon_sym_QMARK_QMARK] = ACTIONS(4118),
    [anon_sym_from] = ACTIONS(2603),
    [anon_sym_into] = ACTIONS(2603),
    [anon_sym_join] = ACTIONS(2603),
    [anon_sym_on] = ACTIONS(2603),
    [anon_sym_equals] = ACTIONS(2603),
    [anon_sym_let] = ACTIONS(2603),
    [anon_sym_orderby] = ACTIONS(2603),
    [anon_sym_ascending] = ACTIONS(2603),
    [anon_sym_descending] = ACTIONS(2603),
    [anon_sym_group] = ACTIONS(2603),
    [anon_sym_by] = ACTIONS(2603),
    [anon_sym_select] = ACTIONS(2603),
    [anon_sym_as] = ACTIONS(4118),
    [anon_sym_is] = ACTIONS(4118),
    [anon_sym_DASH_GT] = ACTIONS(4133),
    [anon_sym_with] = ACTIONS(4118),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2770] = {
    [sym__variable_designation] = STATE(4270),
    [sym_parenthesized_variable_designation] = STATE(4274),
    [sym_identifier] = STATE(4269),
    [sym__reserved_identifier] = STATE(3908),
    [sym_preproc_region] = STATE(2770),
    [sym_preproc_endregion] = STATE(2770),
    [sym_preproc_line] = STATE(2770),
    [sym_preproc_pragma] = STATE(2770),
    [sym_preproc_nullable] = STATE(2770),
    [sym_preproc_error] = STATE(2770),
    [sym_preproc_define] = STATE(2770),
    [sym_preproc_undef] = STATE(2770),
    [sym__identifier_token] = ACTIONS(4016),
    [anon_sym_alias] = ACTIONS(4020),
    [anon_sym_global] = ACTIONS(4020),
    [anon_sym_EQ] = ACTIONS(3721),
    [anon_sym_LBRACK] = ACTIONS(4024),
    [anon_sym_LPAREN] = ACTIONS(4046),
    [anon_sym_LBRACE] = ACTIONS(4024),
    [anon_sym_file] = ACTIONS(4020),
    [anon_sym_LT] = ACTIONS(4027),
    [anon_sym_GT] = ACTIONS(4027),
    [anon_sym_where] = ACTIONS(4020),
    [anon_sym_QMARK] = ACTIONS(4027),
    [anon_sym_notnull] = ACTIONS(4020),
    [anon_sym_unmanaged] = ACTIONS(4020),
    [anon_sym_BANG] = ACTIONS(4027),
    [anon_sym_PLUS_PLUS] = ACTIONS(4024),
    [anon_sym_DASH_DASH] = ACTIONS(4024),
    [anon_sym_PLUS] = ACTIONS(4027),
    [anon_sym_DASH] = ACTIONS(4027),
    [anon_sym_STAR] = ACTIONS(4027),
    [anon_sym_SLASH] = ACTIONS(4027),
    [anon_sym_PERCENT] = ACTIONS(4027),
    [anon_sym_CARET] = ACTIONS(4027),
    [anon_sym_PIPE] = ACTIONS(4027),
    [anon_sym_AMP] = ACTIONS(4027),
    [anon_sym_LT_LT] = ACTIONS(4027),
    [anon_sym_GT_GT] = ACTIONS(4027),
    [anon_sym_GT_GT_GT] = ACTIONS(4027),
    [anon_sym_EQ_EQ] = ACTIONS(4024),
    [anon_sym_BANG_EQ] = ACTIONS(4024),
    [anon_sym_GT_EQ] = ACTIONS(4024),
    [anon_sym_LT_EQ] = ACTIONS(4024),
    [anon_sym_DOT] = ACTIONS(4027),
    [anon_sym_scoped] = ACTIONS(4020),
    [anon_sym_EQ_GT] = ACTIONS(4024),
    [anon_sym_COLON_COLON] = ACTIONS(3719),
    [anon_sym_var] = ACTIONS(4020),
    [anon_sym_yield] = ACTIONS(4020),
    [anon_sym_switch] = ACTIONS(4027),
    [anon_sym_when] = ACTIONS(4020),
    [sym_discard] = ACTIONS(4050),
    [anon_sym_DOT_DOT] = ACTIONS(4024),
    [anon_sym_and] = ACTIONS(4027),
    [anon_sym_or] = ACTIONS(4027),
    [anon_sym_PLUS_EQ] = ACTIONS(3719),
    [anon_sym_DASH_EQ] = ACTIONS(3719),
    [anon_sym_STAR_EQ] = ACTIONS(3719),
    [anon_sym_SLASH_EQ] = ACTIONS(3719),
    [anon_sym_PERCENT_EQ] = ACTIONS(3719),
    [anon_sym_AMP_EQ] = ACTIONS(3719),
    [anon_sym_CARET_EQ] = ACTIONS(3719),
    [anon_sym_PIPE_EQ] = ACTIONS(3719),
    [anon_sym_LT_LT_EQ] = ACTIONS(3719),
    [anon_sym_GT_GT_EQ] = ACTIONS(3719),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3719),
    [anon_sym_AMP_AMP] = ACTIONS(4024),
    [anon_sym_PIPE_PIPE] = ACTIONS(4024),
    [anon_sym_QMARK_QMARK] = ACTIONS(4027),
    [anon_sym_from] = ACTIONS(4020),
    [anon_sym_into] = ACTIONS(4020),
    [anon_sym_join] = ACTIONS(4020),
    [anon_sym_on] = ACTIONS(4020),
    [anon_sym_equals] = ACTIONS(4020),
    [anon_sym_let] = ACTIONS(4020),
    [anon_sym_orderby] = ACTIONS(4020),
    [anon_sym_ascending] = ACTIONS(4020),
    [anon_sym_descending] = ACTIONS(4020),
    [anon_sym_group] = ACTIONS(4020),
    [anon_sym_by] = ACTIONS(4020),
    [anon_sym_select] = ACTIONS(4020),
    [anon_sym_as] = ACTIONS(4027),
    [anon_sym_is] = ACTIONS(4027),
    [anon_sym_DASH_GT] = ACTIONS(4024),
    [anon_sym_with] = ACTIONS(4027),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2771] = {
    [sym__variable_designation] = STATE(4270),
    [sym_parenthesized_variable_designation] = STATE(4274),
    [sym_identifier] = STATE(4269),
    [sym__reserved_identifier] = STATE(3127),
    [sym_preproc_region] = STATE(2771),
    [sym_preproc_endregion] = STATE(2771),
    [sym_preproc_line] = STATE(2771),
    [sym_preproc_pragma] = STATE(2771),
    [sym_preproc_nullable] = STATE(2771),
    [sym_preproc_error] = STATE(2771),
    [sym_preproc_define] = STATE(2771),
    [sym_preproc_undef] = STATE(2771),
    [sym__identifier_token] = ACTIONS(4091),
    [anon_sym_alias] = ACTIONS(4095),
    [anon_sym_global] = ACTIONS(4095),
    [anon_sym_EQ] = ACTIONS(3721),
    [anon_sym_LBRACK] = ACTIONS(3719),
    [anon_sym_LPAREN] = ACTIONS(4046),
    [anon_sym_LBRACE] = ACTIONS(4024),
    [anon_sym_file] = ACTIONS(4095),
    [anon_sym_LT] = ACTIONS(3721),
    [anon_sym_GT] = ACTIONS(3721),
    [anon_sym_where] = ACTIONS(4095),
    [anon_sym_QMARK] = ACTIONS(3721),
    [anon_sym_notnull] = ACTIONS(4095),
    [anon_sym_unmanaged] = ACTIONS(4095),
    [anon_sym_BANG] = ACTIONS(3721),
    [anon_sym_PLUS_PLUS] = ACTIONS(3719),
    [anon_sym_DASH_DASH] = ACTIONS(3719),
    [anon_sym_PLUS] = ACTIONS(3721),
    [anon_sym_DASH] = ACTIONS(3721),
    [anon_sym_STAR] = ACTIONS(3721),
    [anon_sym_SLASH] = ACTIONS(3721),
    [anon_sym_PERCENT] = ACTIONS(3721),
    [anon_sym_CARET] = ACTIONS(3721),
    [anon_sym_PIPE] = ACTIONS(3721),
    [anon_sym_AMP] = ACTIONS(3721),
    [anon_sym_LT_LT] = ACTIONS(3721),
    [anon_sym_GT_GT] = ACTIONS(3721),
    [anon_sym_GT_GT_GT] = ACTIONS(3721),
    [anon_sym_EQ_EQ] = ACTIONS(3719),
    [anon_sym_BANG_EQ] = ACTIONS(3719),
    [anon_sym_GT_EQ] = ACTIONS(3719),
    [anon_sym_LT_EQ] = ACTIONS(3719),
    [anon_sym_DOT] = ACTIONS(3721),
    [anon_sym_scoped] = ACTIONS(4095),
    [anon_sym_EQ_GT] = ACTIONS(4024),
    [anon_sym_COLON_COLON] = ACTIONS(3719),
    [anon_sym_var] = ACTIONS(4095),
    [anon_sym_yield] = ACTIONS(4095),
    [anon_sym_switch] = ACTIONS(3721),
    [anon_sym_when] = ACTIONS(4095),
    [sym_discard] = ACTIONS(4050),
    [anon_sym_DOT_DOT] = ACTIONS(3719),
    [anon_sym_and] = ACTIONS(4027),
    [anon_sym_or] = ACTIONS(4027),
    [anon_sym_PLUS_EQ] = ACTIONS(3719),
    [anon_sym_DASH_EQ] = ACTIONS(3719),
    [anon_sym_STAR_EQ] = ACTIONS(3719),
    [anon_sym_SLASH_EQ] = ACTIONS(3719),
    [anon_sym_PERCENT_EQ] = ACTIONS(3719),
    [anon_sym_AMP_EQ] = ACTIONS(3719),
    [anon_sym_CARET_EQ] = ACTIONS(3719),
    [anon_sym_PIPE_EQ] = ACTIONS(3719),
    [anon_sym_LT_LT_EQ] = ACTIONS(3719),
    [anon_sym_GT_GT_EQ] = ACTIONS(3719),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3719),
    [anon_sym_AMP_AMP] = ACTIONS(3719),
    [anon_sym_PIPE_PIPE] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK] = ACTIONS(3721),
    [anon_sym_from] = ACTIONS(4095),
    [anon_sym_into] = ACTIONS(4095),
    [anon_sym_join] = ACTIONS(4095),
    [anon_sym_on] = ACTIONS(4095),
    [anon_sym_equals] = ACTIONS(4095),
    [anon_sym_let] = ACTIONS(4095),
    [anon_sym_orderby] = ACTIONS(4095),
    [anon_sym_ascending] = ACTIONS(4095),
    [anon_sym_descending] = ACTIONS(4095),
    [anon_sym_group] = ACTIONS(4095),
    [anon_sym_by] = ACTIONS(4095),
    [anon_sym_select] = ACTIONS(4095),
    [anon_sym_as] = ACTIONS(3721),
    [anon_sym_is] = ACTIONS(3721),
    [anon_sym_DASH_GT] = ACTIONS(3719),
    [anon_sym_with] = ACTIONS(3721),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2772] = {
    [sym__variable_designation] = STATE(4969),
    [sym_parenthesized_variable_designation] = STATE(4957),
    [sym_identifier] = STATE(4971),
    [sym__reserved_identifier] = STATE(3558),
    [sym_preproc_region] = STATE(2772),
    [sym_preproc_endregion] = STATE(2772),
    [sym_preproc_line] = STATE(2772),
    [sym_preproc_pragma] = STATE(2772),
    [sym_preproc_nullable] = STATE(2772),
    [sym_preproc_error] = STATE(2772),
    [sym_preproc_define] = STATE(2772),
    [sym_preproc_undef] = STATE(2772),
    [sym__identifier_token] = ACTIONS(4203),
    [anon_sym_alias] = ACTIONS(4207),
    [anon_sym_global] = ACTIONS(4207),
    [anon_sym_EQ] = ACTIONS(3721),
    [anon_sym_LBRACK] = ACTIONS(4024),
    [anon_sym_LPAREN] = ACTIONS(4211),
    [anon_sym_LBRACE] = ACTIONS(4024),
    [anon_sym_file] = ACTIONS(4207),
    [anon_sym_LT] = ACTIONS(4027),
    [anon_sym_GT] = ACTIONS(4027),
    [anon_sym_where] = ACTIONS(4207),
    [anon_sym_QMARK] = ACTIONS(4027),
    [anon_sym_notnull] = ACTIONS(4207),
    [anon_sym_unmanaged] = ACTIONS(4207),
    [anon_sym_BANG] = ACTIONS(4027),
    [anon_sym_PLUS_PLUS] = ACTIONS(4024),
    [anon_sym_DASH_DASH] = ACTIONS(4024),
    [anon_sym_PLUS] = ACTIONS(4027),
    [anon_sym_DASH] = ACTIONS(4027),
    [anon_sym_STAR] = ACTIONS(4027),
    [anon_sym_SLASH] = ACTIONS(4027),
    [anon_sym_PERCENT] = ACTIONS(4027),
    [anon_sym_CARET] = ACTIONS(4027),
    [anon_sym_PIPE] = ACTIONS(4027),
    [anon_sym_AMP] = ACTIONS(4027),
    [anon_sym_LT_LT] = ACTIONS(4027),
    [anon_sym_GT_GT] = ACTIONS(4027),
    [anon_sym_GT_GT_GT] = ACTIONS(4027),
    [anon_sym_EQ_EQ] = ACTIONS(4024),
    [anon_sym_BANG_EQ] = ACTIONS(4024),
    [anon_sym_GT_EQ] = ACTIONS(4024),
    [anon_sym_LT_EQ] = ACTIONS(4024),
    [anon_sym_DOT] = ACTIONS(4027),
    [anon_sym_scoped] = ACTIONS(4207),
    [anon_sym_EQ_GT] = ACTIONS(3719),
    [anon_sym_COLON_COLON] = ACTIONS(3719),
    [anon_sym_var] = ACTIONS(4207),
    [anon_sym_yield] = ACTIONS(4207),
    [anon_sym_switch] = ACTIONS(4027),
    [anon_sym_when] = ACTIONS(4207),
    [sym_discard] = ACTIONS(4215),
    [anon_sym_DOT_DOT] = ACTIONS(4024),
    [anon_sym_and] = ACTIONS(4027),
    [anon_sym_or] = ACTIONS(4027),
    [anon_sym_PLUS_EQ] = ACTIONS(3719),
    [anon_sym_DASH_EQ] = ACTIONS(3719),
    [anon_sym_STAR_EQ] = ACTIONS(3719),
    [anon_sym_SLASH_EQ] = ACTIONS(3719),
    [anon_sym_PERCENT_EQ] = ACTIONS(3719),
    [anon_sym_AMP_EQ] = ACTIONS(3719),
    [anon_sym_CARET_EQ] = ACTIONS(3719),
    [anon_sym_PIPE_EQ] = ACTIONS(3719),
    [anon_sym_LT_LT_EQ] = ACTIONS(3719),
    [anon_sym_GT_GT_EQ] = ACTIONS(3719),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3719),
    [anon_sym_AMP_AMP] = ACTIONS(4024),
    [anon_sym_PIPE_PIPE] = ACTIONS(4024),
    [anon_sym_QMARK_QMARK] = ACTIONS(4027),
    [anon_sym_from] = ACTIONS(4207),
    [anon_sym_into] = ACTIONS(4207),
    [anon_sym_join] = ACTIONS(4207),
    [anon_sym_on] = ACTIONS(4207),
    [anon_sym_equals] = ACTIONS(4207),
    [anon_sym_let] = ACTIONS(4207),
    [anon_sym_orderby] = ACTIONS(4207),
    [anon_sym_ascending] = ACTIONS(4207),
    [anon_sym_descending] = ACTIONS(4207),
    [anon_sym_group] = ACTIONS(4207),
    [anon_sym_by] = ACTIONS(4207),
    [anon_sym_select] = ACTIONS(4207),
    [anon_sym_as] = ACTIONS(4027),
    [anon_sym_is] = ACTIONS(4027),
    [anon_sym_DASH_GT] = ACTIONS(4024),
    [anon_sym_with] = ACTIONS(4027),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2773] = {
    [sym_type_argument_list] = STATE(2736),
    [sym_preproc_region] = STATE(2773),
    [sym_preproc_endregion] = STATE(2773),
    [sym_preproc_line] = STATE(2773),
    [sym_preproc_pragma] = STATE(2773),
    [sym_preproc_nullable] = STATE(2773),
    [sym_preproc_error] = STATE(2773),
    [sym_preproc_define] = STATE(2773),
    [sym_preproc_undef] = STATE(2773),
    [sym__identifier_token] = ACTIONS(4074),
    [anon_sym_alias] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4074),
    [anon_sym_EQ] = ACTIONS(4219),
    [anon_sym_LBRACK] = ACTIONS(4076),
    [anon_sym_COLON] = ACTIONS(4190),
    [anon_sym_COMMA] = ACTIONS(4222),
    [anon_sym_LPAREN] = ACTIONS(4076),
    [anon_sym_RPAREN] = ACTIONS(4222),
    [anon_sym_LBRACE] = ACTIONS(4076),
    [anon_sym_file] = ACTIONS(4074),
    [anon_sym_LT] = ACTIONS(4078),
    [anon_sym_GT] = ACTIONS(4074),
    [anon_sym_where] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(4074),
    [anon_sym_notnull] = ACTIONS(4074),
    [anon_sym_unmanaged] = ACTIONS(4074),
    [anon_sym_BANG] = ACTIONS(4074),
    [anon_sym_PLUS_PLUS] = ACTIONS(4076),
    [anon_sym_DASH_DASH] = ACTIONS(4076),
    [anon_sym_PLUS] = ACTIONS(4074),
    [anon_sym_DASH] = ACTIONS(4074),
    [anon_sym_STAR] = ACTIONS(4074),
    [anon_sym_SLASH] = ACTIONS(4074),
    [anon_sym_PERCENT] = ACTIONS(4074),
    [anon_sym_CARET] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(4074),
    [anon_sym_AMP] = ACTIONS(4074),
    [anon_sym_LT_LT] = ACTIONS(4074),
    [anon_sym_GT_GT] = ACTIONS(4074),
    [anon_sym_GT_GT_GT] = ACTIONS(4074),
    [anon_sym_EQ_EQ] = ACTIONS(4076),
    [anon_sym_BANG_EQ] = ACTIONS(4076),
    [anon_sym_GT_EQ] = ACTIONS(4076),
    [anon_sym_LT_EQ] = ACTIONS(4076),
    [anon_sym_DOT] = ACTIONS(4074),
    [anon_sym_scoped] = ACTIONS(4074),
    [anon_sym_EQ_GT] = ACTIONS(4081),
    [anon_sym_COLON_COLON] = ACTIONS(4083),
    [anon_sym_var] = ACTIONS(4074),
    [anon_sym_yield] = ACTIONS(4074),
    [anon_sym_switch] = ACTIONS(4074),
    [anon_sym_when] = ACTIONS(4074),
    [sym_discard] = ACTIONS(4074),
    [anon_sym_DOT_DOT] = ACTIONS(4076),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_PLUS_EQ] = ACTIONS(4076),
    [anon_sym_DASH_EQ] = ACTIONS(4076),
    [anon_sym_STAR_EQ] = ACTIONS(4076),
    [anon_sym_SLASH_EQ] = ACTIONS(4076),
    [anon_sym_PERCENT_EQ] = ACTIONS(4076),
    [anon_sym_AMP_EQ] = ACTIONS(4076),
    [anon_sym_CARET_EQ] = ACTIONS(4076),
    [anon_sym_PIPE_EQ] = ACTIONS(4076),
    [anon_sym_LT_LT_EQ] = ACTIONS(4076),
    [anon_sym_GT_GT_EQ] = ACTIONS(4076),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4076),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4076),
    [anon_sym_AMP_AMP] = ACTIONS(4076),
    [anon_sym_PIPE_PIPE] = ACTIONS(4076),
    [anon_sym_QMARK_QMARK] = ACTIONS(4074),
    [anon_sym_from] = ACTIONS(4074),
    [anon_sym_into] = ACTIONS(4074),
    [anon_sym_join] = ACTIONS(4074),
    [anon_sym_on] = ACTIONS(4074),
    [anon_sym_equals] = ACTIONS(4074),
    [anon_sym_let] = ACTIONS(4074),
    [anon_sym_orderby] = ACTIONS(4074),
    [anon_sym_ascending] = ACTIONS(4074),
    [anon_sym_descending] = ACTIONS(4074),
    [anon_sym_group] = ACTIONS(4074),
    [anon_sym_by] = ACTIONS(4074),
    [anon_sym_select] = ACTIONS(4074),
    [anon_sym_as] = ACTIONS(4074),
    [anon_sym_is] = ACTIONS(4074),
    [anon_sym_DASH_GT] = ACTIONS(4076),
    [anon_sym_with] = ACTIONS(4074),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2774] = {
    [sym__name] = STATE(4327),
    [sym_alias_qualified_name] = STATE(3592),
    [sym__simple_name] = STATE(3592),
    [sym_qualified_name] = STATE(3592),
    [sym_generic_name] = STATE(3608),
    [sym_ref_type] = STATE(3574),
    [sym__scoped_base_type] = STATE(3573),
    [sym_identifier] = STATE(3989),
    [sym__reserved_identifier] = STATE(3558),
    [sym_preproc_region] = STATE(2774),
    [sym_preproc_endregion] = STATE(2774),
    [sym_preproc_line] = STATE(2774),
    [sym_preproc_pragma] = STATE(2774),
    [sym_preproc_nullable] = STATE(2774),
    [sym_preproc_error] = STATE(2774),
    [sym_preproc_define] = STATE(2774),
    [sym_preproc_undef] = STATE(2774),
    [sym__identifier_token] = ACTIONS(4225),
    [anon_sym_alias] = ACTIONS(4227),
    [anon_sym_SEMI] = ACTIONS(3719),
    [anon_sym_global] = ACTIONS(4227),
    [anon_sym_LBRACK] = ACTIONS(3719),
    [anon_sym_COLON] = ACTIONS(3721),
    [anon_sym_COMMA] = ACTIONS(3719),
    [anon_sym_RBRACK] = ACTIONS(3719),
    [anon_sym_LPAREN] = ACTIONS(3719),
    [anon_sym_RPAREN] = ACTIONS(3719),
    [anon_sym_ref] = ACTIONS(4229),
    [anon_sym_LBRACE] = ACTIONS(3719),
    [anon_sym_RBRACE] = ACTIONS(3719),
    [anon_sym_file] = ACTIONS(4227),
    [anon_sym_LT] = ACTIONS(3721),
    [anon_sym_GT] = ACTIONS(3721),
    [anon_sym_in] = ACTIONS(3721),
    [anon_sym_where] = ACTIONS(4227),
    [anon_sym_QMARK] = ACTIONS(3721),
    [anon_sym_notnull] = ACTIONS(4227),
    [anon_sym_unmanaged] = ACTIONS(4227),
    [anon_sym_BANG] = ACTIONS(3721),
    [anon_sym_PLUS_PLUS] = ACTIONS(3719),
    [anon_sym_DASH_DASH] = ACTIONS(3719),
    [anon_sym_PLUS] = ACTIONS(3721),
    [anon_sym_DASH] = ACTIONS(3721),
    [anon_sym_STAR] = ACTIONS(3719),
    [anon_sym_SLASH] = ACTIONS(3721),
    [anon_sym_PERCENT] = ACTIONS(3719),
    [anon_sym_CARET] = ACTIONS(3719),
    [anon_sym_PIPE] = ACTIONS(3721),
    [anon_sym_AMP] = ACTIONS(3721),
    [anon_sym_LT_LT] = ACTIONS(3719),
    [anon_sym_GT_GT] = ACTIONS(3721),
    [anon_sym_GT_GT_GT] = ACTIONS(3719),
    [anon_sym_EQ_EQ] = ACTIONS(3719),
    [anon_sym_BANG_EQ] = ACTIONS(3719),
    [anon_sym_GT_EQ] = ACTIONS(3719),
    [anon_sym_LT_EQ] = ACTIONS(3719),
    [anon_sym_DOT] = ACTIONS(3721),
    [anon_sym_scoped] = ACTIONS(4227),
    [anon_sym_EQ_GT] = ACTIONS(3719),
    [anon_sym_COLON_COLON] = ACTIONS(3719),
    [anon_sym_var] = ACTIONS(4227),
    [anon_sym_yield] = ACTIONS(4227),
    [anon_sym_switch] = ACTIONS(3721),
    [anon_sym_when] = ACTIONS(4227),
    [anon_sym_DOT_DOT] = ACTIONS(3719),
    [anon_sym_AMP_AMP] = ACTIONS(3719),
    [anon_sym_PIPE_PIPE] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK] = ACTIONS(3719),
    [anon_sym_from] = ACTIONS(4227),
    [anon_sym_into] = ACTIONS(4231),
    [anon_sym_join] = ACTIONS(4227),
    [anon_sym_on] = ACTIONS(4227),
    [anon_sym_equals] = ACTIONS(4227),
    [anon_sym_let] = ACTIONS(4227),
    [anon_sym_orderby] = ACTIONS(4227),
    [anon_sym_ascending] = ACTIONS(4227),
    [anon_sym_descending] = ACTIONS(4227),
    [anon_sym_group] = ACTIONS(4227),
    [anon_sym_by] = ACTIONS(4227),
    [anon_sym_select] = ACTIONS(4227),
    [anon_sym_as] = ACTIONS(3721),
    [anon_sym_is] = ACTIONS(3721),
    [anon_sym_DASH_GT] = ACTIONS(3719),
    [anon_sym_with] = ACTIONS(3721),
    [aux_sym_preproc_if_token3] = ACTIONS(3719),
    [aux_sym_preproc_else_token1] = ACTIONS(3719),
    [aux_sym_preproc_elif_token1] = ACTIONS(3719),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2775] = {
    [sym__variable_designation] = STATE(4017),
    [sym_parenthesized_variable_designation] = STATE(4015),
    [sym_identifier] = STATE(4020),
    [sym__reserved_identifier] = STATE(3908),
    [sym_preproc_region] = STATE(2775),
    [sym_preproc_endregion] = STATE(2775),
    [sym_preproc_line] = STATE(2775),
    [sym_preproc_pragma] = STATE(2775),
    [sym_preproc_nullable] = STATE(2775),
    [sym_preproc_error] = STATE(2775),
    [sym_preproc_define] = STATE(2775),
    [sym_preproc_undef] = STATE(2775),
    [sym__identifier_token] = ACTIONS(4016),
    [anon_sym_alias] = ACTIONS(4020),
    [anon_sym_global] = ACTIONS(4020),
    [anon_sym_EQ] = ACTIONS(3721),
    [anon_sym_LBRACK] = ACTIONS(4024),
    [anon_sym_LPAREN] = ACTIONS(4030),
    [anon_sym_LBRACE] = ACTIONS(4024),
    [anon_sym_file] = ACTIONS(4020),
    [anon_sym_LT] = ACTIONS(4027),
    [anon_sym_GT] = ACTIONS(4027),
    [anon_sym_where] = ACTIONS(4020),
    [anon_sym_QMARK] = ACTIONS(4027),
    [anon_sym_notnull] = ACTIONS(4020),
    [anon_sym_unmanaged] = ACTIONS(4020),
    [anon_sym_BANG] = ACTIONS(4027),
    [anon_sym_PLUS_PLUS] = ACTIONS(4024),
    [anon_sym_DASH_DASH] = ACTIONS(4024),
    [anon_sym_PLUS] = ACTIONS(4027),
    [anon_sym_DASH] = ACTIONS(4027),
    [anon_sym_STAR] = ACTIONS(4027),
    [anon_sym_SLASH] = ACTIONS(4027),
    [anon_sym_PERCENT] = ACTIONS(4027),
    [anon_sym_CARET] = ACTIONS(4027),
    [anon_sym_PIPE] = ACTIONS(4027),
    [anon_sym_AMP] = ACTIONS(4027),
    [anon_sym_LT_LT] = ACTIONS(4027),
    [anon_sym_GT_GT] = ACTIONS(4027),
    [anon_sym_GT_GT_GT] = ACTIONS(4027),
    [anon_sym_EQ_EQ] = ACTIONS(4024),
    [anon_sym_BANG_EQ] = ACTIONS(4024),
    [anon_sym_GT_EQ] = ACTIONS(4024),
    [anon_sym_LT_EQ] = ACTIONS(4024),
    [anon_sym_DOT] = ACTIONS(4027),
    [anon_sym_scoped] = ACTIONS(4020),
    [anon_sym_EQ_GT] = ACTIONS(4024),
    [anon_sym_COLON_COLON] = ACTIONS(3719),
    [anon_sym_var] = ACTIONS(4020),
    [anon_sym_yield] = ACTIONS(4020),
    [anon_sym_switch] = ACTIONS(4027),
    [anon_sym_when] = ACTIONS(4020),
    [sym_discard] = ACTIONS(4034),
    [anon_sym_DOT_DOT] = ACTIONS(4024),
    [anon_sym_and] = ACTIONS(4027),
    [anon_sym_or] = ACTIONS(4027),
    [anon_sym_PLUS_EQ] = ACTIONS(3719),
    [anon_sym_DASH_EQ] = ACTIONS(3719),
    [anon_sym_STAR_EQ] = ACTIONS(3719),
    [anon_sym_SLASH_EQ] = ACTIONS(3719),
    [anon_sym_PERCENT_EQ] = ACTIONS(3719),
    [anon_sym_AMP_EQ] = ACTIONS(3719),
    [anon_sym_CARET_EQ] = ACTIONS(3719),
    [anon_sym_PIPE_EQ] = ACTIONS(3719),
    [anon_sym_LT_LT_EQ] = ACTIONS(3719),
    [anon_sym_GT_GT_EQ] = ACTIONS(3719),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3719),
    [anon_sym_AMP_AMP] = ACTIONS(4024),
    [anon_sym_PIPE_PIPE] = ACTIONS(4024),
    [anon_sym_QMARK_QMARK] = ACTIONS(4027),
    [anon_sym_from] = ACTIONS(4020),
    [anon_sym_into] = ACTIONS(4020),
    [anon_sym_join] = ACTIONS(4020),
    [anon_sym_on] = ACTIONS(4020),
    [anon_sym_equals] = ACTIONS(4020),
    [anon_sym_let] = ACTIONS(4020),
    [anon_sym_orderby] = ACTIONS(4020),
    [anon_sym_ascending] = ACTIONS(4020),
    [anon_sym_descending] = ACTIONS(4020),
    [anon_sym_group] = ACTIONS(4020),
    [anon_sym_by] = ACTIONS(4020),
    [anon_sym_select] = ACTIONS(4020),
    [anon_sym_as] = ACTIONS(4027),
    [anon_sym_is] = ACTIONS(4027),
    [anon_sym_DASH_GT] = ACTIONS(4024),
    [anon_sym_with] = ACTIONS(4027),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2776] = {
    [sym_type_argument_list] = STATE(2823),
    [sym_preproc_region] = STATE(2776),
    [sym_preproc_endregion] = STATE(2776),
    [sym_preproc_line] = STATE(2776),
    [sym_preproc_pragma] = STATE(2776),
    [sym_preproc_nullable] = STATE(2776),
    [sym_preproc_error] = STATE(2776),
    [sym_preproc_define] = STATE(2776),
    [sym_preproc_undef] = STATE(2776),
    [sym__identifier_token] = ACTIONS(4074),
    [anon_sym_alias] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4074),
    [anon_sym_EQ] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4076),
    [anon_sym_COLON] = ACTIONS(4074),
    [anon_sym_COMMA] = ACTIONS(4076),
    [anon_sym_LPAREN] = ACTIONS(4076),
    [anon_sym_LBRACE] = ACTIONS(4076),
    [anon_sym_file] = ACTIONS(4074),
    [anon_sym_LT] = ACTIONS(4234),
    [anon_sym_GT] = ACTIONS(4074),
    [anon_sym_where] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(4074),
    [anon_sym_notnull] = ACTIONS(4074),
    [anon_sym_unmanaged] = ACTIONS(4074),
    [anon_sym_BANG] = ACTIONS(4074),
    [anon_sym_PLUS_PLUS] = ACTIONS(4076),
    [anon_sym_DASH_DASH] = ACTIONS(4076),
    [anon_sym_PLUS] = ACTIONS(4074),
    [anon_sym_DASH] = ACTIONS(4074),
    [anon_sym_STAR] = ACTIONS(4074),
    [anon_sym_SLASH] = ACTIONS(4074),
    [anon_sym_PERCENT] = ACTIONS(4074),
    [anon_sym_CARET] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(4074),
    [anon_sym_AMP] = ACTIONS(4074),
    [anon_sym_LT_LT] = ACTIONS(4074),
    [anon_sym_GT_GT] = ACTIONS(4074),
    [anon_sym_GT_GT_GT] = ACTIONS(4074),
    [anon_sym_EQ_EQ] = ACTIONS(4076),
    [anon_sym_BANG_EQ] = ACTIONS(4076),
    [anon_sym_GT_EQ] = ACTIONS(4076),
    [anon_sym_LT_EQ] = ACTIONS(4076),
    [anon_sym_DOT] = ACTIONS(4074),
    [anon_sym_scoped] = ACTIONS(4074),
    [anon_sym_EQ_GT] = ACTIONS(4081),
    [anon_sym_COLON_COLON] = ACTIONS(4237),
    [anon_sym_var] = ACTIONS(4074),
    [anon_sym_yield] = ACTIONS(4074),
    [anon_sym_switch] = ACTIONS(4074),
    [anon_sym_when] = ACTIONS(4074),
    [sym_discard] = ACTIONS(4074),
    [anon_sym_DOT_DOT] = ACTIONS(4076),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_PLUS_EQ] = ACTIONS(4076),
    [anon_sym_DASH_EQ] = ACTIONS(4076),
    [anon_sym_STAR_EQ] = ACTIONS(4076),
    [anon_sym_SLASH_EQ] = ACTIONS(4076),
    [anon_sym_PERCENT_EQ] = ACTIONS(4076),
    [anon_sym_AMP_EQ] = ACTIONS(4076),
    [anon_sym_CARET_EQ] = ACTIONS(4076),
    [anon_sym_PIPE_EQ] = ACTIONS(4076),
    [anon_sym_LT_LT_EQ] = ACTIONS(4076),
    [anon_sym_GT_GT_EQ] = ACTIONS(4076),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4076),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4076),
    [anon_sym_AMP_AMP] = ACTIONS(4076),
    [anon_sym_PIPE_PIPE] = ACTIONS(4076),
    [anon_sym_QMARK_QMARK] = ACTIONS(4074),
    [anon_sym_from] = ACTIONS(4074),
    [anon_sym_into] = ACTIONS(4074),
    [anon_sym_join] = ACTIONS(4074),
    [anon_sym_on] = ACTIONS(4074),
    [anon_sym_equals] = ACTIONS(4074),
    [anon_sym_let] = ACTIONS(4074),
    [anon_sym_orderby] = ACTIONS(4074),
    [anon_sym_ascending] = ACTIONS(4074),
    [anon_sym_descending] = ACTIONS(4074),
    [anon_sym_group] = ACTIONS(4074),
    [anon_sym_by] = ACTIONS(4074),
    [anon_sym_select] = ACTIONS(4074),
    [anon_sym_as] = ACTIONS(4074),
    [anon_sym_is] = ACTIONS(4074),
    [anon_sym_DASH_GT] = ACTIONS(4076),
    [anon_sym_with] = ACTIONS(4074),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4076),
  },
  [2777] = {
    [sym_preproc_region] = STATE(2777),
    [sym_preproc_endregion] = STATE(2777),
    [sym_preproc_line] = STATE(2777),
    [sym_preproc_pragma] = STATE(2777),
    [sym_preproc_nullable] = STATE(2777),
    [sym_preproc_error] = STATE(2777),
    [sym_preproc_define] = STATE(2777),
    [sym_preproc_undef] = STATE(2777),
    [sym__identifier_token] = ACTIONS(4099),
    [anon_sym_alias] = ACTIONS(4099),
    [anon_sym_global] = ACTIONS(4099),
    [anon_sym_EQ] = ACTIONS(4104),
    [anon_sym_LBRACK] = ACTIONS(4101),
    [anon_sym_COLON] = ACTIONS(4111),
    [anon_sym_COMMA] = ACTIONS(4106),
    [anon_sym_RBRACK] = ACTIONS(4106),
    [anon_sym_LPAREN] = ACTIONS(4101),
    [anon_sym_RPAREN] = ACTIONS(4111),
    [anon_sym_LBRACE] = ACTIONS(4106),
    [anon_sym_RBRACE] = ACTIONS(4106),
    [anon_sym_file] = ACTIONS(4099),
    [anon_sym_LT] = ACTIONS(4104),
    [anon_sym_GT] = ACTIONS(4104),
    [anon_sym_where] = ACTIONS(4099),
    [anon_sym_QMARK] = ACTIONS(4108),
    [anon_sym_notnull] = ACTIONS(4099),
    [anon_sym_unmanaged] = ACTIONS(4099),
    [anon_sym_BANG] = ACTIONS(4104),
    [anon_sym_PLUS_PLUS] = ACTIONS(4111),
    [anon_sym_DASH_DASH] = ACTIONS(4111),
    [anon_sym_PLUS] = ACTIONS(4104),
    [anon_sym_DASH] = ACTIONS(4104),
    [anon_sym_STAR] = ACTIONS(4108),
    [anon_sym_SLASH] = ACTIONS(4104),
    [anon_sym_PERCENT] = ACTIONS(4104),
    [anon_sym_CARET] = ACTIONS(4104),
    [anon_sym_PIPE] = ACTIONS(4104),
    [anon_sym_AMP] = ACTIONS(4104),
    [anon_sym_LT_LT] = ACTIONS(4104),
    [anon_sym_GT_GT] = ACTIONS(4104),
    [anon_sym_GT_GT_GT] = ACTIONS(4104),
    [anon_sym_EQ_EQ] = ACTIONS(4111),
    [anon_sym_BANG_EQ] = ACTIONS(4111),
    [anon_sym_GT_EQ] = ACTIONS(4111),
    [anon_sym_LT_EQ] = ACTIONS(4111),
    [anon_sym_DOT] = ACTIONS(4108),
    [anon_sym_scoped] = ACTIONS(4099),
    [anon_sym_EQ_GT] = ACTIONS(4106),
    [anon_sym_var] = ACTIONS(4099),
    [anon_sym_yield] = ACTIONS(4099),
    [anon_sym_switch] = ACTIONS(4104),
    [anon_sym_when] = ACTIONS(4099),
    [sym_discard] = ACTIONS(4099),
    [anon_sym_DOT_DOT] = ACTIONS(4111),
    [anon_sym_and] = ACTIONS(4099),
    [anon_sym_or] = ACTIONS(4099),
    [anon_sym_PLUS_EQ] = ACTIONS(4111),
    [anon_sym_DASH_EQ] = ACTIONS(4111),
    [anon_sym_STAR_EQ] = ACTIONS(4111),
    [anon_sym_SLASH_EQ] = ACTIONS(4111),
    [anon_sym_PERCENT_EQ] = ACTIONS(4111),
    [anon_sym_AMP_EQ] = ACTIONS(4111),
    [anon_sym_CARET_EQ] = ACTIONS(4111),
    [anon_sym_PIPE_EQ] = ACTIONS(4111),
    [anon_sym_LT_LT_EQ] = ACTIONS(4111),
    [anon_sym_GT_GT_EQ] = ACTIONS(4111),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4111),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4111),
    [anon_sym_AMP_AMP] = ACTIONS(4111),
    [anon_sym_PIPE_PIPE] = ACTIONS(4111),
    [anon_sym_QMARK_QMARK] = ACTIONS(4104),
    [anon_sym_from] = ACTIONS(4099),
    [anon_sym_into] = ACTIONS(4099),
    [anon_sym_join] = ACTIONS(4099),
    [anon_sym_on] = ACTIONS(4099),
    [anon_sym_equals] = ACTIONS(4099),
    [anon_sym_let] = ACTIONS(4099),
    [anon_sym_orderby] = ACTIONS(4099),
    [anon_sym_ascending] = ACTIONS(4099),
    [anon_sym_descending] = ACTIONS(4099),
    [anon_sym_group] = ACTIONS(4099),
    [anon_sym_by] = ACTIONS(4099),
    [anon_sym_select] = ACTIONS(4099),
    [anon_sym_as] = ACTIONS(4104),
    [anon_sym_is] = ACTIONS(4104),
    [anon_sym_DASH_GT] = ACTIONS(4101),
    [anon_sym_with] = ACTIONS(4104),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2778] = {
    [sym_preproc_region] = STATE(2778),
    [sym_preproc_endregion] = STATE(2778),
    [sym_preproc_line] = STATE(2778),
    [sym_preproc_pragma] = STATE(2778),
    [sym_preproc_nullable] = STATE(2778),
    [sym_preproc_error] = STATE(2778),
    [sym_preproc_define] = STATE(2778),
    [sym_preproc_undef] = STATE(2778),
    [sym__identifier_token] = ACTIONS(4027),
    [anon_sym_alias] = ACTIONS(4027),
    [anon_sym_global] = ACTIONS(4027),
    [anon_sym_EQ] = ACTIONS(3721),
    [anon_sym_LBRACK] = ACTIONS(3719),
    [anon_sym_COLON] = ACTIONS(3721),
    [anon_sym_COMMA] = ACTIONS(4024),
    [anon_sym_LPAREN] = ACTIONS(4024),
    [anon_sym_RPAREN] = ACTIONS(4024),
    [anon_sym_LBRACE] = ACTIONS(4024),
    [anon_sym_RBRACE] = ACTIONS(4024),
    [anon_sym_file] = ACTIONS(4027),
    [anon_sym_LT] = ACTIONS(3721),
    [anon_sym_GT] = ACTIONS(3721),
    [anon_sym_where] = ACTIONS(4027),
    [anon_sym_QMARK] = ACTIONS(3721),
    [anon_sym_notnull] = ACTIONS(4027),
    [anon_sym_unmanaged] = ACTIONS(4027),
    [anon_sym_BANG] = ACTIONS(3721),
    [anon_sym_PLUS_PLUS] = ACTIONS(3719),
    [anon_sym_DASH_DASH] = ACTIONS(3719),
    [anon_sym_PLUS] = ACTIONS(3721),
    [anon_sym_DASH] = ACTIONS(3721),
    [anon_sym_STAR] = ACTIONS(3721),
    [anon_sym_SLASH] = ACTIONS(3721),
    [anon_sym_PERCENT] = ACTIONS(3721),
    [anon_sym_CARET] = ACTIONS(3721),
    [anon_sym_PIPE] = ACTIONS(3721),
    [anon_sym_AMP] = ACTIONS(3721),
    [anon_sym_LT_LT] = ACTIONS(3721),
    [anon_sym_GT_GT] = ACTIONS(3721),
    [anon_sym_GT_GT_GT] = ACTIONS(3721),
    [anon_sym_EQ_EQ] = ACTIONS(3719),
    [anon_sym_BANG_EQ] = ACTIONS(3719),
    [anon_sym_GT_EQ] = ACTIONS(3719),
    [anon_sym_LT_EQ] = ACTIONS(3719),
    [anon_sym_DOT] = ACTIONS(3721),
    [anon_sym_scoped] = ACTIONS(4027),
    [anon_sym_EQ_GT] = ACTIONS(3719),
    [anon_sym_COLON_COLON] = ACTIONS(3719),
    [anon_sym_var] = ACTIONS(4027),
    [anon_sym_yield] = ACTIONS(4027),
    [anon_sym_switch] = ACTIONS(3721),
    [anon_sym_when] = ACTIONS(4027),
    [sym_discard] = ACTIONS(4027),
    [anon_sym_DOT_DOT] = ACTIONS(3719),
    [anon_sym_and] = ACTIONS(4027),
    [anon_sym_or] = ACTIONS(4027),
    [anon_sym_PLUS_EQ] = ACTIONS(3719),
    [anon_sym_DASH_EQ] = ACTIONS(3719),
    [anon_sym_STAR_EQ] = ACTIONS(3719),
    [anon_sym_SLASH_EQ] = ACTIONS(3719),
    [anon_sym_PERCENT_EQ] = ACTIONS(3719),
    [anon_sym_AMP_EQ] = ACTIONS(3719),
    [anon_sym_CARET_EQ] = ACTIONS(3719),
    [anon_sym_PIPE_EQ] = ACTIONS(3719),
    [anon_sym_LT_LT_EQ] = ACTIONS(3719),
    [anon_sym_GT_GT_EQ] = ACTIONS(3719),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3719),
    [anon_sym_AMP_AMP] = ACTIONS(3719),
    [anon_sym_PIPE_PIPE] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK] = ACTIONS(3721),
    [anon_sym_from] = ACTIONS(4027),
    [anon_sym_into] = ACTIONS(4027),
    [anon_sym_join] = ACTIONS(4027),
    [anon_sym_on] = ACTIONS(4027),
    [anon_sym_equals] = ACTIONS(4027),
    [anon_sym_let] = ACTIONS(4027),
    [anon_sym_orderby] = ACTIONS(4027),
    [anon_sym_ascending] = ACTIONS(4027),
    [anon_sym_descending] = ACTIONS(4027),
    [anon_sym_group] = ACTIONS(4027),
    [anon_sym_by] = ACTIONS(4027),
    [anon_sym_select] = ACTIONS(4027),
    [anon_sym_as] = ACTIONS(3721),
    [anon_sym_is] = ACTIONS(3721),
    [anon_sym_DASH_GT] = ACTIONS(3719),
    [anon_sym_with] = ACTIONS(3721),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2779] = {
    [sym_preproc_region] = STATE(2779),
    [sym_preproc_endregion] = STATE(2779),
    [sym_preproc_line] = STATE(2779),
    [sym_preproc_pragma] = STATE(2779),
    [sym_preproc_nullable] = STATE(2779),
    [sym_preproc_error] = STATE(2779),
    [sym_preproc_define] = STATE(2779),
    [sym_preproc_undef] = STATE(2779),
    [sym__identifier_token] = ACTIONS(4113),
    [anon_sym_alias] = ACTIONS(4113),
    [anon_sym_global] = ACTIONS(4113),
    [anon_sym_EQ] = ACTIONS(4118),
    [anon_sym_LBRACK] = ACTIONS(4135),
    [anon_sym_COLON] = ACTIONS(4133),
    [anon_sym_COMMA] = ACTIONS(4124),
    [anon_sym_RBRACK] = ACTIONS(4124),
    [anon_sym_LPAREN] = ACTIONS(4135),
    [anon_sym_RPAREN] = ACTIONS(4133),
    [anon_sym_LBRACE] = ACTIONS(4124),
    [anon_sym_RBRACE] = ACTIONS(4124),
    [anon_sym_file] = ACTIONS(4113),
    [anon_sym_LT] = ACTIONS(4118),
    [anon_sym_GT] = ACTIONS(4118),
    [anon_sym_where] = ACTIONS(4113),
    [anon_sym_QMARK] = ACTIONS(4138),
    [anon_sym_notnull] = ACTIONS(4113),
    [anon_sym_unmanaged] = ACTIONS(4113),
    [anon_sym_BANG] = ACTIONS(4118),
    [anon_sym_PLUS_PLUS] = ACTIONS(4133),
    [anon_sym_DASH_DASH] = ACTIONS(4133),
    [anon_sym_PLUS] = ACTIONS(4118),
    [anon_sym_DASH] = ACTIONS(4118),
    [anon_sym_STAR] = ACTIONS(4138),
    [anon_sym_SLASH] = ACTIONS(4118),
    [anon_sym_PERCENT] = ACTIONS(4118),
    [anon_sym_CARET] = ACTIONS(4118),
    [anon_sym_PIPE] = ACTIONS(4118),
    [anon_sym_AMP] = ACTIONS(4118),
    [anon_sym_LT_LT] = ACTIONS(4118),
    [anon_sym_GT_GT] = ACTIONS(4118),
    [anon_sym_GT_GT_GT] = ACTIONS(4118),
    [anon_sym_EQ_EQ] = ACTIONS(4133),
    [anon_sym_BANG_EQ] = ACTIONS(4133),
    [anon_sym_GT_EQ] = ACTIONS(4133),
    [anon_sym_LT_EQ] = ACTIONS(4133),
    [anon_sym_DOT] = ACTIONS(4138),
    [anon_sym_scoped] = ACTIONS(4113),
    [anon_sym_EQ_GT] = ACTIONS(4124),
    [anon_sym_var] = ACTIONS(4113),
    [anon_sym_yield] = ACTIONS(4113),
    [anon_sym_switch] = ACTIONS(4118),
    [anon_sym_when] = ACTIONS(4113),
    [sym_discard] = ACTIONS(4113),
    [anon_sym_DOT_DOT] = ACTIONS(4133),
    [anon_sym_and] = ACTIONS(4113),
    [anon_sym_or] = ACTIONS(4113),
    [anon_sym_PLUS_EQ] = ACTIONS(4133),
    [anon_sym_DASH_EQ] = ACTIONS(4133),
    [anon_sym_STAR_EQ] = ACTIONS(4133),
    [anon_sym_SLASH_EQ] = ACTIONS(4133),
    [anon_sym_PERCENT_EQ] = ACTIONS(4133),
    [anon_sym_AMP_EQ] = ACTIONS(4133),
    [anon_sym_CARET_EQ] = ACTIONS(4133),
    [anon_sym_PIPE_EQ] = ACTIONS(4133),
    [anon_sym_LT_LT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4133),
    [anon_sym_AMP_AMP] = ACTIONS(4133),
    [anon_sym_PIPE_PIPE] = ACTIONS(4133),
    [anon_sym_QMARK_QMARK] = ACTIONS(4118),
    [anon_sym_from] = ACTIONS(4113),
    [anon_sym_into] = ACTIONS(4113),
    [anon_sym_join] = ACTIONS(4113),
    [anon_sym_on] = ACTIONS(4113),
    [anon_sym_equals] = ACTIONS(4113),
    [anon_sym_let] = ACTIONS(4113),
    [anon_sym_orderby] = ACTIONS(4113),
    [anon_sym_ascending] = ACTIONS(4113),
    [anon_sym_descending] = ACTIONS(4113),
    [anon_sym_group] = ACTIONS(4113),
    [anon_sym_by] = ACTIONS(4113),
    [anon_sym_select] = ACTIONS(4113),
    [anon_sym_as] = ACTIONS(4118),
    [anon_sym_is] = ACTIONS(4118),
    [anon_sym_DASH_GT] = ACTIONS(4135),
    [anon_sym_with] = ACTIONS(4118),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2780] = {
    [sym__variable_designation] = STATE(4969),
    [sym_parenthesized_variable_designation] = STATE(4957),
    [sym_identifier] = STATE(4971),
    [sym__reserved_identifier] = STATE(3568),
    [sym_preproc_region] = STATE(2780),
    [sym_preproc_endregion] = STATE(2780),
    [sym_preproc_line] = STATE(2780),
    [sym_preproc_pragma] = STATE(2780),
    [sym_preproc_nullable] = STATE(2780),
    [sym_preproc_error] = STATE(2780),
    [sym_preproc_define] = STATE(2780),
    [sym_preproc_undef] = STATE(2780),
    [sym__identifier_token] = ACTIONS(4239),
    [anon_sym_alias] = ACTIONS(4243),
    [anon_sym_global] = ACTIONS(4243),
    [anon_sym_EQ] = ACTIONS(3721),
    [anon_sym_LBRACK] = ACTIONS(4024),
    [anon_sym_LPAREN] = ACTIONS(4211),
    [anon_sym_LBRACE] = ACTIONS(4024),
    [anon_sym_file] = ACTIONS(4243),
    [anon_sym_LT] = ACTIONS(4027),
    [anon_sym_GT] = ACTIONS(4027),
    [anon_sym_where] = ACTIONS(4243),
    [anon_sym_QMARK] = ACTIONS(4027),
    [anon_sym_notnull] = ACTIONS(4243),
    [anon_sym_unmanaged] = ACTIONS(4243),
    [anon_sym_BANG] = ACTIONS(4027),
    [anon_sym_PLUS_PLUS] = ACTIONS(4024),
    [anon_sym_DASH_DASH] = ACTIONS(4024),
    [anon_sym_PLUS] = ACTIONS(4027),
    [anon_sym_DASH] = ACTIONS(4027),
    [anon_sym_STAR] = ACTIONS(4027),
    [anon_sym_SLASH] = ACTIONS(4027),
    [anon_sym_PERCENT] = ACTIONS(4027),
    [anon_sym_CARET] = ACTIONS(4027),
    [anon_sym_PIPE] = ACTIONS(4027),
    [anon_sym_AMP] = ACTIONS(4027),
    [anon_sym_LT_LT] = ACTIONS(4027),
    [anon_sym_GT_GT] = ACTIONS(4027),
    [anon_sym_GT_GT_GT] = ACTIONS(4027),
    [anon_sym_EQ_EQ] = ACTIONS(4024),
    [anon_sym_BANG_EQ] = ACTIONS(4024),
    [anon_sym_GT_EQ] = ACTIONS(4024),
    [anon_sym_LT_EQ] = ACTIONS(4024),
    [anon_sym_DOT] = ACTIONS(4027),
    [anon_sym_scoped] = ACTIONS(4243),
    [anon_sym_EQ_GT] = ACTIONS(3719),
    [anon_sym_COLON_COLON] = ACTIONS(3719),
    [anon_sym_var] = ACTIONS(4243),
    [anon_sym_yield] = ACTIONS(4243),
    [anon_sym_switch] = ACTIONS(4027),
    [anon_sym_when] = ACTIONS(4243),
    [sym_discard] = ACTIONS(4215),
    [anon_sym_DOT_DOT] = ACTIONS(4024),
    [anon_sym_and] = ACTIONS(4027),
    [anon_sym_or] = ACTIONS(4027),
    [anon_sym_PLUS_EQ] = ACTIONS(3719),
    [anon_sym_DASH_EQ] = ACTIONS(3719),
    [anon_sym_STAR_EQ] = ACTIONS(3719),
    [anon_sym_SLASH_EQ] = ACTIONS(3719),
    [anon_sym_PERCENT_EQ] = ACTIONS(3719),
    [anon_sym_AMP_EQ] = ACTIONS(3719),
    [anon_sym_CARET_EQ] = ACTIONS(3719),
    [anon_sym_PIPE_EQ] = ACTIONS(3719),
    [anon_sym_LT_LT_EQ] = ACTIONS(3719),
    [anon_sym_GT_GT_EQ] = ACTIONS(3719),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3719),
    [anon_sym_AMP_AMP] = ACTIONS(4024),
    [anon_sym_PIPE_PIPE] = ACTIONS(4024),
    [anon_sym_QMARK_QMARK] = ACTIONS(4027),
    [anon_sym_from] = ACTIONS(4243),
    [anon_sym_into] = ACTIONS(4243),
    [anon_sym_join] = ACTIONS(4243),
    [anon_sym_on] = ACTIONS(4243),
    [anon_sym_equals] = ACTIONS(4243),
    [anon_sym_let] = ACTIONS(4243),
    [anon_sym_orderby] = ACTIONS(4243),
    [anon_sym_ascending] = ACTIONS(4243),
    [anon_sym_descending] = ACTIONS(4243),
    [anon_sym_group] = ACTIONS(4243),
    [anon_sym_by] = ACTIONS(4243),
    [anon_sym_select] = ACTIONS(4243),
    [anon_sym_as] = ACTIONS(4027),
    [anon_sym_is] = ACTIONS(4027),
    [anon_sym_DASH_GT] = ACTIONS(4024),
    [anon_sym_with] = ACTIONS(4027),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2781] = {
    [sym_type_argument_list] = STATE(2736),
    [sym_preproc_region] = STATE(2781),
    [sym_preproc_endregion] = STATE(2781),
    [sym_preproc_line] = STATE(2781),
    [sym_preproc_pragma] = STATE(2781),
    [sym_preproc_nullable] = STATE(2781),
    [sym_preproc_error] = STATE(2781),
    [sym_preproc_define] = STATE(2781),
    [sym_preproc_undef] = STATE(2781),
    [sym__identifier_token] = ACTIONS(4074),
    [anon_sym_alias] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4074),
    [anon_sym_EQ] = ACTIONS(4219),
    [anon_sym_LBRACK] = ACTIONS(4076),
    [anon_sym_COLON] = ACTIONS(4074),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_LPAREN] = ACTIONS(4076),
    [anon_sym_RPAREN] = ACTIONS(4247),
    [anon_sym_LBRACE] = ACTIONS(4076),
    [anon_sym_file] = ACTIONS(4074),
    [anon_sym_LT] = ACTIONS(4078),
    [anon_sym_GT] = ACTIONS(4074),
    [anon_sym_where] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(4074),
    [anon_sym_notnull] = ACTIONS(4074),
    [anon_sym_unmanaged] = ACTIONS(4074),
    [anon_sym_BANG] = ACTIONS(4074),
    [anon_sym_PLUS_PLUS] = ACTIONS(4076),
    [anon_sym_DASH_DASH] = ACTIONS(4076),
    [anon_sym_PLUS] = ACTIONS(4074),
    [anon_sym_DASH] = ACTIONS(4074),
    [anon_sym_STAR] = ACTIONS(4074),
    [anon_sym_SLASH] = ACTIONS(4074),
    [anon_sym_PERCENT] = ACTIONS(4074),
    [anon_sym_CARET] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(4074),
    [anon_sym_AMP] = ACTIONS(4074),
    [anon_sym_LT_LT] = ACTIONS(4074),
    [anon_sym_GT_GT] = ACTIONS(4074),
    [anon_sym_GT_GT_GT] = ACTIONS(4074),
    [anon_sym_EQ_EQ] = ACTIONS(4076),
    [anon_sym_BANG_EQ] = ACTIONS(4076),
    [anon_sym_GT_EQ] = ACTIONS(4076),
    [anon_sym_LT_EQ] = ACTIONS(4076),
    [anon_sym_DOT] = ACTIONS(4074),
    [anon_sym_scoped] = ACTIONS(4074),
    [anon_sym_EQ_GT] = ACTIONS(4081),
    [anon_sym_COLON_COLON] = ACTIONS(4083),
    [anon_sym_var] = ACTIONS(4074),
    [anon_sym_yield] = ACTIONS(4074),
    [anon_sym_switch] = ACTIONS(4074),
    [anon_sym_when] = ACTIONS(4074),
    [sym_discard] = ACTIONS(4074),
    [anon_sym_DOT_DOT] = ACTIONS(4076),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_PLUS_EQ] = ACTIONS(4076),
    [anon_sym_DASH_EQ] = ACTIONS(4076),
    [anon_sym_STAR_EQ] = ACTIONS(4076),
    [anon_sym_SLASH_EQ] = ACTIONS(4076),
    [anon_sym_PERCENT_EQ] = ACTIONS(4076),
    [anon_sym_AMP_EQ] = ACTIONS(4076),
    [anon_sym_CARET_EQ] = ACTIONS(4076),
    [anon_sym_PIPE_EQ] = ACTIONS(4076),
    [anon_sym_LT_LT_EQ] = ACTIONS(4076),
    [anon_sym_GT_GT_EQ] = ACTIONS(4076),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4076),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4076),
    [anon_sym_AMP_AMP] = ACTIONS(4076),
    [anon_sym_PIPE_PIPE] = ACTIONS(4076),
    [anon_sym_QMARK_QMARK] = ACTIONS(4074),
    [anon_sym_from] = ACTIONS(4074),
    [anon_sym_into] = ACTIONS(4074),
    [anon_sym_join] = ACTIONS(4074),
    [anon_sym_on] = ACTIONS(4074),
    [anon_sym_equals] = ACTIONS(4074),
    [anon_sym_let] = ACTIONS(4074),
    [anon_sym_orderby] = ACTIONS(4074),
    [anon_sym_ascending] = ACTIONS(4074),
    [anon_sym_descending] = ACTIONS(4074),
    [anon_sym_group] = ACTIONS(4074),
    [anon_sym_by] = ACTIONS(4074),
    [anon_sym_select] = ACTIONS(4074),
    [anon_sym_as] = ACTIONS(4074),
    [anon_sym_is] = ACTIONS(4074),
    [anon_sym_DASH_GT] = ACTIONS(4076),
    [anon_sym_with] = ACTIONS(4074),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2782] = {
    [sym_attribute_list] = STATE(3753),
    [sym_modifier] = STATE(3780),
    [sym_variable_declaration] = STATE(9527),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(6317),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_identifier] = STATE(6720),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(2782),
    [sym_preproc_endregion] = STATE(2782),
    [sym_preproc_line] = STATE(2782),
    [sym_preproc_pragma] = STATE(2782),
    [sym_preproc_nullable] = STATE(2782),
    [sym_preproc_error] = STATE(2782),
    [sym_preproc_define] = STATE(2782),
    [sym_preproc_undef] = STATE(2782),
    [aux_sym_class_declaration_repeat1] = STATE(3584),
    [aux_sym_class_declaration_repeat2] = STATE(2844),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_extern] = ACTIONS(4249),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_unsafe] = ACTIONS(63),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_LBRACK] = ACTIONS(2993),
    [anon_sym_LPAREN] = ACTIONS(2995),
    [anon_sym_event] = ACTIONS(4251),
    [anon_sym_class] = ACTIONS(4253),
    [anon_sym_ref] = ACTIONS(4255),
    [anon_sym_struct] = ACTIONS(4257),
    [anon_sym_enum] = ACTIONS(4259),
    [anon_sym_interface] = ACTIONS(4261),
    [anon_sym_delegate] = ACTIONS(4263),
    [anon_sym_record] = ACTIONS(4265),
    [anon_sym_abstract] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_file] = ACTIONS(3015),
    [anon_sym_fixed] = ACTIONS(63),
    [anon_sym_internal] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(63),
    [anon_sym_override] = ACTIONS(63),
    [anon_sym_partial] = ACTIONS(63),
    [anon_sym_private] = ACTIONS(63),
    [anon_sym_protected] = ACTIONS(63),
    [anon_sym_public] = ACTIONS(63),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_required] = ACTIONS(63),
    [anon_sym_sealed] = ACTIONS(63),
    [anon_sym_virtual] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_TILDE] = ACTIONS(4267),
    [anon_sym_implicit] = ACTIONS(4269),
    [anon_sym_explicit] = ACTIONS(4269),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2783] = {
    [sym_type_argument_list] = STATE(2736),
    [sym_preproc_region] = STATE(2783),
    [sym_preproc_endregion] = STATE(2783),
    [sym_preproc_line] = STATE(2783),
    [sym_preproc_pragma] = STATE(2783),
    [sym_preproc_nullable] = STATE(2783),
    [sym_preproc_error] = STATE(2783),
    [sym_preproc_define] = STATE(2783),
    [sym_preproc_undef] = STATE(2783),
    [sym__identifier_token] = ACTIONS(4074),
    [anon_sym_alias] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4074),
    [anon_sym_EQ] = ACTIONS(4219),
    [anon_sym_LBRACK] = ACTIONS(4076),
    [anon_sym_COLON] = ACTIONS(4190),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_LPAREN] = ACTIONS(4076),
    [anon_sym_RPAREN] = ACTIONS(4247),
    [anon_sym_LBRACE] = ACTIONS(4076),
    [anon_sym_file] = ACTIONS(4074),
    [anon_sym_LT] = ACTIONS(4078),
    [anon_sym_GT] = ACTIONS(4074),
    [anon_sym_where] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(4074),
    [anon_sym_notnull] = ACTIONS(4074),
    [anon_sym_unmanaged] = ACTIONS(4074),
    [anon_sym_BANG] = ACTIONS(4074),
    [anon_sym_PLUS_PLUS] = ACTIONS(4076),
    [anon_sym_DASH_DASH] = ACTIONS(4076),
    [anon_sym_PLUS] = ACTIONS(4074),
    [anon_sym_DASH] = ACTIONS(4074),
    [anon_sym_STAR] = ACTIONS(4074),
    [anon_sym_SLASH] = ACTIONS(4074),
    [anon_sym_PERCENT] = ACTIONS(4074),
    [anon_sym_CARET] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(4074),
    [anon_sym_AMP] = ACTIONS(4074),
    [anon_sym_LT_LT] = ACTIONS(4074),
    [anon_sym_GT_GT] = ACTIONS(4074),
    [anon_sym_GT_GT_GT] = ACTIONS(4074),
    [anon_sym_EQ_EQ] = ACTIONS(4076),
    [anon_sym_BANG_EQ] = ACTIONS(4076),
    [anon_sym_GT_EQ] = ACTIONS(4076),
    [anon_sym_LT_EQ] = ACTIONS(4076),
    [anon_sym_DOT] = ACTIONS(4074),
    [anon_sym_scoped] = ACTIONS(4074),
    [anon_sym_EQ_GT] = ACTIONS(4081),
    [anon_sym_COLON_COLON] = ACTIONS(4083),
    [anon_sym_var] = ACTIONS(4074),
    [anon_sym_yield] = ACTIONS(4074),
    [anon_sym_switch] = ACTIONS(4074),
    [anon_sym_when] = ACTIONS(4074),
    [sym_discard] = ACTIONS(4074),
    [anon_sym_DOT_DOT] = ACTIONS(4076),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_PLUS_EQ] = ACTIONS(4076),
    [anon_sym_DASH_EQ] = ACTIONS(4076),
    [anon_sym_STAR_EQ] = ACTIONS(4076),
    [anon_sym_SLASH_EQ] = ACTIONS(4076),
    [anon_sym_PERCENT_EQ] = ACTIONS(4076),
    [anon_sym_AMP_EQ] = ACTIONS(4076),
    [anon_sym_CARET_EQ] = ACTIONS(4076),
    [anon_sym_PIPE_EQ] = ACTIONS(4076),
    [anon_sym_LT_LT_EQ] = ACTIONS(4076),
    [anon_sym_GT_GT_EQ] = ACTIONS(4076),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4076),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4076),
    [anon_sym_AMP_AMP] = ACTIONS(4076),
    [anon_sym_PIPE_PIPE] = ACTIONS(4076),
    [anon_sym_QMARK_QMARK] = ACTIONS(4074),
    [anon_sym_from] = ACTIONS(4074),
    [anon_sym_into] = ACTIONS(4074),
    [anon_sym_join] = ACTIONS(4074),
    [anon_sym_on] = ACTIONS(4074),
    [anon_sym_equals] = ACTIONS(4074),
    [anon_sym_let] = ACTIONS(4074),
    [anon_sym_orderby] = ACTIONS(4074),
    [anon_sym_ascending] = ACTIONS(4074),
    [anon_sym_descending] = ACTIONS(4074),
    [anon_sym_group] = ACTIONS(4074),
    [anon_sym_by] = ACTIONS(4074),
    [anon_sym_select] = ACTIONS(4074),
    [anon_sym_as] = ACTIONS(4074),
    [anon_sym_is] = ACTIONS(4074),
    [anon_sym_DASH_GT] = ACTIONS(4076),
    [anon_sym_with] = ACTIONS(4074),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2784] = {
    [sym_preproc_region] = STATE(2784),
    [sym_preproc_endregion] = STATE(2784),
    [sym_preproc_line] = STATE(2784),
    [sym_preproc_pragma] = STATE(2784),
    [sym_preproc_nullable] = STATE(2784),
    [sym_preproc_error] = STATE(2784),
    [sym_preproc_define] = STATE(2784),
    [sym_preproc_undef] = STATE(2784),
    [sym__identifier_token] = ACTIONS(3721),
    [anon_sym_alias] = ACTIONS(3721),
    [anon_sym_global] = ACTIONS(3721),
    [anon_sym_EQ] = ACTIONS(3721),
    [anon_sym_LBRACK] = ACTIONS(3719),
    [anon_sym_COLON] = ACTIONS(3721),
    [anon_sym_COMMA] = ACTIONS(3719),
    [anon_sym_LPAREN] = ACTIONS(3719),
    [anon_sym_LBRACE] = ACTIONS(3719),
    [anon_sym_file] = ACTIONS(3721),
    [anon_sym_LT] = ACTIONS(3721),
    [anon_sym_GT] = ACTIONS(3721),
    [anon_sym_where] = ACTIONS(3721),
    [anon_sym_QMARK] = ACTIONS(3721),
    [anon_sym_notnull] = ACTIONS(3721),
    [anon_sym_unmanaged] = ACTIONS(3721),
    [anon_sym_BANG] = ACTIONS(3721),
    [anon_sym_PLUS_PLUS] = ACTIONS(3719),
    [anon_sym_DASH_DASH] = ACTIONS(3719),
    [anon_sym_PLUS] = ACTIONS(3721),
    [anon_sym_DASH] = ACTIONS(3721),
    [anon_sym_STAR] = ACTIONS(3721),
    [anon_sym_SLASH] = ACTIONS(3721),
    [anon_sym_PERCENT] = ACTIONS(3721),
    [anon_sym_CARET] = ACTIONS(3721),
    [anon_sym_PIPE] = ACTIONS(3721),
    [anon_sym_AMP] = ACTIONS(3721),
    [anon_sym_LT_LT] = ACTIONS(3721),
    [anon_sym_GT_GT] = ACTIONS(3721),
    [anon_sym_GT_GT_GT] = ACTIONS(3721),
    [anon_sym_EQ_EQ] = ACTIONS(3719),
    [anon_sym_BANG_EQ] = ACTIONS(3719),
    [anon_sym_GT_EQ] = ACTIONS(3719),
    [anon_sym_LT_EQ] = ACTIONS(3719),
    [anon_sym_DOT] = ACTIONS(3721),
    [anon_sym_scoped] = ACTIONS(3721),
    [anon_sym_EQ_GT] = ACTIONS(3719),
    [anon_sym_COLON_COLON] = ACTIONS(3719),
    [anon_sym_var] = ACTIONS(3721),
    [anon_sym_yield] = ACTIONS(3721),
    [anon_sym_switch] = ACTIONS(3721),
    [anon_sym_when] = ACTIONS(3721),
    [sym_discard] = ACTIONS(3721),
    [anon_sym_DOT_DOT] = ACTIONS(3719),
    [anon_sym_and] = ACTIONS(3721),
    [anon_sym_or] = ACTIONS(3721),
    [anon_sym_PLUS_EQ] = ACTIONS(3719),
    [anon_sym_DASH_EQ] = ACTIONS(3719),
    [anon_sym_STAR_EQ] = ACTIONS(3719),
    [anon_sym_SLASH_EQ] = ACTIONS(3719),
    [anon_sym_PERCENT_EQ] = ACTIONS(3719),
    [anon_sym_AMP_EQ] = ACTIONS(3719),
    [anon_sym_CARET_EQ] = ACTIONS(3719),
    [anon_sym_PIPE_EQ] = ACTIONS(3719),
    [anon_sym_LT_LT_EQ] = ACTIONS(3719),
    [anon_sym_GT_GT_EQ] = ACTIONS(3719),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3719),
    [anon_sym_AMP_AMP] = ACTIONS(3719),
    [anon_sym_PIPE_PIPE] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK] = ACTIONS(3721),
    [anon_sym_from] = ACTIONS(3721),
    [anon_sym_into] = ACTIONS(3721),
    [anon_sym_join] = ACTIONS(3721),
    [anon_sym_on] = ACTIONS(3721),
    [anon_sym_equals] = ACTIONS(3721),
    [anon_sym_let] = ACTIONS(3721),
    [anon_sym_orderby] = ACTIONS(3721),
    [anon_sym_ascending] = ACTIONS(3721),
    [anon_sym_descending] = ACTIONS(3721),
    [anon_sym_group] = ACTIONS(3721),
    [anon_sym_by] = ACTIONS(3721),
    [anon_sym_select] = ACTIONS(3721),
    [anon_sym_as] = ACTIONS(3721),
    [anon_sym_is] = ACTIONS(3721),
    [anon_sym_DASH_GT] = ACTIONS(3719),
    [anon_sym_with] = ACTIONS(3721),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(3719),
  },
  [2785] = {
    [sym_parameter_list] = STATE(9765),
    [sym_positional_pattern_clause] = STATE(2826),
    [sym_property_pattern_clause] = STATE(2859),
    [sym__variable_designation] = STATE(4021),
    [sym_parenthesized_variable_designation] = STATE(4015),
    [sym__lambda_parameters] = STATE(9127),
    [sym_identifier] = STATE(4055),
    [sym__reserved_identifier] = STATE(3908),
    [sym_preproc_region] = STATE(2785),
    [sym_preproc_endregion] = STATE(2785),
    [sym_preproc_line] = STATE(2785),
    [sym_preproc_pragma] = STATE(2785),
    [sym_preproc_nullable] = STATE(2785),
    [sym_preproc_error] = STATE(2785),
    [sym_preproc_define] = STATE(2785),
    [sym_preproc_undef] = STATE(2785),
    [sym__identifier_token] = ACTIONS(4271),
    [anon_sym_alias] = ACTIONS(4273),
    [anon_sym_SEMI] = ACTIONS(4275),
    [anon_sym_global] = ACTIONS(4273),
    [anon_sym_LBRACK] = ACTIONS(4275),
    [anon_sym_COLON] = ACTIONS(4275),
    [anon_sym_COMMA] = ACTIONS(4275),
    [anon_sym_RBRACK] = ACTIONS(4275),
    [anon_sym_LPAREN] = ACTIONS(4275),
    [anon_sym_RPAREN] = ACTIONS(4275),
    [anon_sym_LBRACE] = ACTIONS(4277),
    [anon_sym_RBRACE] = ACTIONS(4275),
    [anon_sym_file] = ACTIONS(4273),
    [anon_sym_LT] = ACTIONS(4279),
    [anon_sym_GT] = ACTIONS(4279),
    [anon_sym_in] = ACTIONS(4279),
    [anon_sym_where] = ACTIONS(4273),
    [anon_sym_QMARK] = ACTIONS(4279),
    [anon_sym_notnull] = ACTIONS(4273),
    [anon_sym_unmanaged] = ACTIONS(4273),
    [anon_sym_BANG] = ACTIONS(4279),
    [anon_sym_PLUS_PLUS] = ACTIONS(4275),
    [anon_sym_DASH_DASH] = ACTIONS(4275),
    [anon_sym_PLUS] = ACTIONS(4279),
    [anon_sym_DASH] = ACTIONS(4279),
    [anon_sym_STAR] = ACTIONS(4275),
    [anon_sym_SLASH] = ACTIONS(4279),
    [anon_sym_PERCENT] = ACTIONS(4275),
    [anon_sym_CARET] = ACTIONS(4275),
    [anon_sym_PIPE] = ACTIONS(4279),
    [anon_sym_AMP] = ACTIONS(4279),
    [anon_sym_LT_LT] = ACTIONS(4275),
    [anon_sym_GT_GT] = ACTIONS(4279),
    [anon_sym_GT_GT_GT] = ACTIONS(4275),
    [anon_sym_EQ_EQ] = ACTIONS(4275),
    [anon_sym_BANG_EQ] = ACTIONS(4275),
    [anon_sym_GT_EQ] = ACTIONS(4275),
    [anon_sym_LT_EQ] = ACTIONS(4275),
    [anon_sym_DOT] = ACTIONS(4279),
    [anon_sym_scoped] = ACTIONS(4273),
    [anon_sym_var] = ACTIONS(4273),
    [anon_sym_yield] = ACTIONS(4273),
    [anon_sym_switch] = ACTIONS(4279),
    [anon_sym_when] = ACTIONS(4273),
    [sym_discard] = ACTIONS(4281),
    [anon_sym_DOT_DOT] = ACTIONS(4275),
    [anon_sym_and] = ACTIONS(4279),
    [anon_sym_or] = ACTIONS(4279),
    [anon_sym_AMP_AMP] = ACTIONS(4275),
    [anon_sym_PIPE_PIPE] = ACTIONS(4275),
    [anon_sym_QMARK_QMARK] = ACTIONS(4275),
    [anon_sym_from] = ACTIONS(4273),
    [anon_sym_into] = ACTIONS(4279),
    [anon_sym_join] = ACTIONS(4273),
    [anon_sym_on] = ACTIONS(4273),
    [anon_sym_equals] = ACTIONS(4273),
    [anon_sym_let] = ACTIONS(4273),
    [anon_sym_orderby] = ACTIONS(4273),
    [anon_sym_ascending] = ACTIONS(4273),
    [anon_sym_descending] = ACTIONS(4273),
    [anon_sym_group] = ACTIONS(4273),
    [anon_sym_by] = ACTIONS(4273),
    [anon_sym_select] = ACTIONS(4273),
    [anon_sym_as] = ACTIONS(4279),
    [anon_sym_is] = ACTIONS(4279),
    [anon_sym_DASH_GT] = ACTIONS(4275),
    [anon_sym_with] = ACTIONS(4279),
    [aux_sym_preproc_if_token3] = ACTIONS(4275),
    [aux_sym_preproc_else_token1] = ACTIONS(4275),
    [aux_sym_preproc_elif_token1] = ACTIONS(4275),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2786] = {
    [sym_preproc_region] = STATE(2786),
    [sym_preproc_endregion] = STATE(2786),
    [sym_preproc_line] = STATE(2786),
    [sym_preproc_pragma] = STATE(2786),
    [sym_preproc_nullable] = STATE(2786),
    [sym_preproc_error] = STATE(2786),
    [sym_preproc_define] = STATE(2786),
    [sym_preproc_undef] = STATE(2786),
    [sym__identifier_token] = ACTIONS(4027),
    [anon_sym_alias] = ACTIONS(4027),
    [anon_sym_global] = ACTIONS(4027),
    [anon_sym_EQ] = ACTIONS(3721),
    [anon_sym_LBRACK] = ACTIONS(4024),
    [anon_sym_COLON] = ACTIONS(4027),
    [anon_sym_COMMA] = ACTIONS(4024),
    [anon_sym_LPAREN] = ACTIONS(4024),
    [anon_sym_LBRACE] = ACTIONS(4024),
    [anon_sym_file] = ACTIONS(4027),
    [anon_sym_LT] = ACTIONS(4027),
    [anon_sym_GT] = ACTIONS(4027),
    [anon_sym_where] = ACTIONS(4027),
    [anon_sym_QMARK] = ACTIONS(4027),
    [anon_sym_notnull] = ACTIONS(4027),
    [anon_sym_unmanaged] = ACTIONS(4027),
    [anon_sym_BANG] = ACTIONS(4027),
    [anon_sym_PLUS_PLUS] = ACTIONS(4024),
    [anon_sym_DASH_DASH] = ACTIONS(4024),
    [anon_sym_PLUS] = ACTIONS(4027),
    [anon_sym_DASH] = ACTIONS(4027),
    [anon_sym_STAR] = ACTIONS(4027),
    [anon_sym_SLASH] = ACTIONS(4027),
    [anon_sym_PERCENT] = ACTIONS(4027),
    [anon_sym_CARET] = ACTIONS(4027),
    [anon_sym_PIPE] = ACTIONS(4027),
    [anon_sym_AMP] = ACTIONS(4027),
    [anon_sym_LT_LT] = ACTIONS(4027),
    [anon_sym_GT_GT] = ACTIONS(4027),
    [anon_sym_GT_GT_GT] = ACTIONS(4027),
    [anon_sym_EQ_EQ] = ACTIONS(4024),
    [anon_sym_BANG_EQ] = ACTIONS(4024),
    [anon_sym_GT_EQ] = ACTIONS(4024),
    [anon_sym_LT_EQ] = ACTIONS(4024),
    [anon_sym_DOT] = ACTIONS(4027),
    [anon_sym_scoped] = ACTIONS(4027),
    [anon_sym_EQ_GT] = ACTIONS(3719),
    [anon_sym_COLON_COLON] = ACTIONS(3719),
    [anon_sym_var] = ACTIONS(4027),
    [anon_sym_yield] = ACTIONS(4027),
    [anon_sym_switch] = ACTIONS(4027),
    [anon_sym_when] = ACTIONS(4027),
    [sym_discard] = ACTIONS(4027),
    [anon_sym_DOT_DOT] = ACTIONS(4024),
    [anon_sym_and] = ACTIONS(4027),
    [anon_sym_or] = ACTIONS(4027),
    [anon_sym_PLUS_EQ] = ACTIONS(3719),
    [anon_sym_DASH_EQ] = ACTIONS(3719),
    [anon_sym_STAR_EQ] = ACTIONS(3719),
    [anon_sym_SLASH_EQ] = ACTIONS(3719),
    [anon_sym_PERCENT_EQ] = ACTIONS(3719),
    [anon_sym_AMP_EQ] = ACTIONS(3719),
    [anon_sym_CARET_EQ] = ACTIONS(3719),
    [anon_sym_PIPE_EQ] = ACTIONS(3719),
    [anon_sym_LT_LT_EQ] = ACTIONS(3719),
    [anon_sym_GT_GT_EQ] = ACTIONS(3719),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3719),
    [anon_sym_AMP_AMP] = ACTIONS(4024),
    [anon_sym_PIPE_PIPE] = ACTIONS(4024),
    [anon_sym_QMARK_QMARK] = ACTIONS(4027),
    [anon_sym_from] = ACTIONS(4027),
    [anon_sym_into] = ACTIONS(4027),
    [anon_sym_join] = ACTIONS(4027),
    [anon_sym_on] = ACTIONS(4027),
    [anon_sym_equals] = ACTIONS(4027),
    [anon_sym_let] = ACTIONS(4027),
    [anon_sym_orderby] = ACTIONS(4027),
    [anon_sym_ascending] = ACTIONS(4027),
    [anon_sym_descending] = ACTIONS(4027),
    [anon_sym_group] = ACTIONS(4027),
    [anon_sym_by] = ACTIONS(4027),
    [anon_sym_select] = ACTIONS(4027),
    [anon_sym_as] = ACTIONS(4027),
    [anon_sym_is] = ACTIONS(4027),
    [anon_sym_DASH_GT] = ACTIONS(4024),
    [anon_sym_with] = ACTIONS(4027),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4024),
  },
  [2787] = {
    [sym_preproc_region] = STATE(2787),
    [sym_preproc_endregion] = STATE(2787),
    [sym_preproc_line] = STATE(2787),
    [sym_preproc_pragma] = STATE(2787),
    [sym_preproc_nullable] = STATE(2787),
    [sym_preproc_error] = STATE(2787),
    [sym_preproc_define] = STATE(2787),
    [sym_preproc_undef] = STATE(2787),
    [sym__identifier_token] = ACTIONS(4113),
    [anon_sym_alias] = ACTIONS(4113),
    [anon_sym_global] = ACTIONS(4113),
    [anon_sym_EQ] = ACTIONS(4118),
    [anon_sym_LBRACK] = ACTIONS(4135),
    [anon_sym_COLON] = ACTIONS(4133),
    [anon_sym_COMMA] = ACTIONS(4120),
    [anon_sym_RBRACK] = ACTIONS(4120),
    [anon_sym_LPAREN] = ACTIONS(4135),
    [anon_sym_RPAREN] = ACTIONS(4120),
    [anon_sym_LBRACE] = ACTIONS(4124),
    [anon_sym_RBRACE] = ACTIONS(4120),
    [anon_sym_file] = ACTIONS(4113),
    [anon_sym_LT] = ACTIONS(4118),
    [anon_sym_GT] = ACTIONS(4118),
    [anon_sym_where] = ACTIONS(4113),
    [anon_sym_QMARK] = ACTIONS(4138),
    [anon_sym_notnull] = ACTIONS(4113),
    [anon_sym_unmanaged] = ACTIONS(4113),
    [anon_sym_BANG] = ACTIONS(4118),
    [anon_sym_PLUS_PLUS] = ACTIONS(4133),
    [anon_sym_DASH_DASH] = ACTIONS(4133),
    [anon_sym_PLUS] = ACTIONS(4118),
    [anon_sym_DASH] = ACTIONS(4118),
    [anon_sym_STAR] = ACTIONS(4138),
    [anon_sym_SLASH] = ACTIONS(4118),
    [anon_sym_PERCENT] = ACTIONS(4118),
    [anon_sym_CARET] = ACTIONS(4118),
    [anon_sym_PIPE] = ACTIONS(4118),
    [anon_sym_AMP] = ACTIONS(4118),
    [anon_sym_LT_LT] = ACTIONS(4118),
    [anon_sym_GT_GT] = ACTIONS(4118),
    [anon_sym_GT_GT_GT] = ACTIONS(4118),
    [anon_sym_EQ_EQ] = ACTIONS(4133),
    [anon_sym_BANG_EQ] = ACTIONS(4133),
    [anon_sym_GT_EQ] = ACTIONS(4133),
    [anon_sym_LT_EQ] = ACTIONS(4133),
    [anon_sym_DOT] = ACTIONS(4138),
    [anon_sym_scoped] = ACTIONS(4113),
    [anon_sym_var] = ACTIONS(4113),
    [anon_sym_yield] = ACTIONS(4113),
    [anon_sym_switch] = ACTIONS(4118),
    [anon_sym_when] = ACTIONS(4113),
    [sym_discard] = ACTIONS(4113),
    [anon_sym_DOT_DOT] = ACTIONS(4133),
    [anon_sym_and] = ACTIONS(4130),
    [anon_sym_or] = ACTIONS(4130),
    [anon_sym_PLUS_EQ] = ACTIONS(4133),
    [anon_sym_DASH_EQ] = ACTIONS(4133),
    [anon_sym_STAR_EQ] = ACTIONS(4133),
    [anon_sym_SLASH_EQ] = ACTIONS(4133),
    [anon_sym_PERCENT_EQ] = ACTIONS(4133),
    [anon_sym_AMP_EQ] = ACTIONS(4133),
    [anon_sym_CARET_EQ] = ACTIONS(4133),
    [anon_sym_PIPE_EQ] = ACTIONS(4133),
    [anon_sym_LT_LT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4133),
    [anon_sym_AMP_AMP] = ACTIONS(4133),
    [anon_sym_PIPE_PIPE] = ACTIONS(4133),
    [anon_sym_QMARK_QMARK] = ACTIONS(4118),
    [anon_sym_from] = ACTIONS(4113),
    [anon_sym_into] = ACTIONS(4113),
    [anon_sym_join] = ACTIONS(4113),
    [anon_sym_on] = ACTIONS(4113),
    [anon_sym_equals] = ACTIONS(4113),
    [anon_sym_let] = ACTIONS(4113),
    [anon_sym_orderby] = ACTIONS(4113),
    [anon_sym_ascending] = ACTIONS(4113),
    [anon_sym_descending] = ACTIONS(4113),
    [anon_sym_group] = ACTIONS(4113),
    [anon_sym_by] = ACTIONS(4113),
    [anon_sym_select] = ACTIONS(4113),
    [anon_sym_as] = ACTIONS(4118),
    [anon_sym_is] = ACTIONS(4118),
    [anon_sym_DASH_GT] = ACTIONS(4135),
    [anon_sym_with] = ACTIONS(4118),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2788] = {
    [sym_parameter_list] = STATE(9765),
    [sym_positional_pattern_clause] = STATE(2826),
    [sym_property_pattern_clause] = STATE(2859),
    [sym__variable_designation] = STATE(4021),
    [sym_parenthesized_variable_designation] = STATE(4015),
    [sym__lambda_parameters] = STATE(9127),
    [sym_identifier] = STATE(4055),
    [sym__reserved_identifier] = STATE(3908),
    [sym_preproc_region] = STATE(2788),
    [sym_preproc_endregion] = STATE(2788),
    [sym_preproc_line] = STATE(2788),
    [sym_preproc_pragma] = STATE(2788),
    [sym_preproc_nullable] = STATE(2788),
    [sym_preproc_error] = STATE(2788),
    [sym_preproc_define] = STATE(2788),
    [sym_preproc_undef] = STATE(2788),
    [sym__identifier_token] = ACTIONS(4271),
    [anon_sym_alias] = ACTIONS(4273),
    [anon_sym_SEMI] = ACTIONS(4283),
    [anon_sym_global] = ACTIONS(4273),
    [anon_sym_LBRACK] = ACTIONS(4283),
    [anon_sym_COLON] = ACTIONS(4283),
    [anon_sym_COMMA] = ACTIONS(4283),
    [anon_sym_RBRACK] = ACTIONS(4283),
    [anon_sym_LPAREN] = ACTIONS(4283),
    [anon_sym_RPAREN] = ACTIONS(4283),
    [anon_sym_LBRACE] = ACTIONS(4277),
    [anon_sym_RBRACE] = ACTIONS(4283),
    [anon_sym_file] = ACTIONS(4273),
    [anon_sym_LT] = ACTIONS(4285),
    [anon_sym_GT] = ACTIONS(4285),
    [anon_sym_in] = ACTIONS(4285),
    [anon_sym_where] = ACTIONS(4273),
    [anon_sym_QMARK] = ACTIONS(4285),
    [anon_sym_notnull] = ACTIONS(4273),
    [anon_sym_unmanaged] = ACTIONS(4273),
    [anon_sym_BANG] = ACTIONS(4285),
    [anon_sym_PLUS_PLUS] = ACTIONS(4283),
    [anon_sym_DASH_DASH] = ACTIONS(4283),
    [anon_sym_PLUS] = ACTIONS(4285),
    [anon_sym_DASH] = ACTIONS(4285),
    [anon_sym_STAR] = ACTIONS(4283),
    [anon_sym_SLASH] = ACTIONS(4285),
    [anon_sym_PERCENT] = ACTIONS(4283),
    [anon_sym_CARET] = ACTIONS(4283),
    [anon_sym_PIPE] = ACTIONS(4285),
    [anon_sym_AMP] = ACTIONS(4285),
    [anon_sym_LT_LT] = ACTIONS(4283),
    [anon_sym_GT_GT] = ACTIONS(4285),
    [anon_sym_GT_GT_GT] = ACTIONS(4283),
    [anon_sym_EQ_EQ] = ACTIONS(4283),
    [anon_sym_BANG_EQ] = ACTIONS(4283),
    [anon_sym_GT_EQ] = ACTIONS(4283),
    [anon_sym_LT_EQ] = ACTIONS(4283),
    [anon_sym_DOT] = ACTIONS(4285),
    [anon_sym_scoped] = ACTIONS(4273),
    [anon_sym_var] = ACTIONS(4273),
    [anon_sym_yield] = ACTIONS(4273),
    [anon_sym_switch] = ACTIONS(4285),
    [anon_sym_when] = ACTIONS(4273),
    [sym_discard] = ACTIONS(4281),
    [anon_sym_DOT_DOT] = ACTIONS(4283),
    [anon_sym_and] = ACTIONS(4279),
    [anon_sym_or] = ACTIONS(4279),
    [anon_sym_AMP_AMP] = ACTIONS(4283),
    [anon_sym_PIPE_PIPE] = ACTIONS(4283),
    [anon_sym_QMARK_QMARK] = ACTIONS(4283),
    [anon_sym_from] = ACTIONS(4273),
    [anon_sym_into] = ACTIONS(4285),
    [anon_sym_join] = ACTIONS(4273),
    [anon_sym_on] = ACTIONS(4273),
    [anon_sym_equals] = ACTIONS(4273),
    [anon_sym_let] = ACTIONS(4273),
    [anon_sym_orderby] = ACTIONS(4273),
    [anon_sym_ascending] = ACTIONS(4273),
    [anon_sym_descending] = ACTIONS(4273),
    [anon_sym_group] = ACTIONS(4273),
    [anon_sym_by] = ACTIONS(4273),
    [anon_sym_select] = ACTIONS(4273),
    [anon_sym_as] = ACTIONS(4285),
    [anon_sym_is] = ACTIONS(4285),
    [anon_sym_DASH_GT] = ACTIONS(4283),
    [anon_sym_with] = ACTIONS(4285),
    [aux_sym_preproc_if_token3] = ACTIONS(4283),
    [aux_sym_preproc_else_token1] = ACTIONS(4283),
    [aux_sym_preproc_elif_token1] = ACTIONS(4283),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2789] = {
    [sym_preproc_region] = STATE(2789),
    [sym_preproc_endregion] = STATE(2789),
    [sym_preproc_line] = STATE(2789),
    [sym_preproc_pragma] = STATE(2789),
    [sym_preproc_nullable] = STATE(2789),
    [sym_preproc_error] = STATE(2789),
    [sym_preproc_define] = STATE(2789),
    [sym_preproc_undef] = STATE(2789),
    [sym__identifier_token] = ACTIONS(4113),
    [anon_sym_alias] = ACTIONS(4113),
    [anon_sym_global] = ACTIONS(4113),
    [anon_sym_EQ] = ACTIONS(4118),
    [anon_sym_LBRACK] = ACTIONS(4135),
    [anon_sym_COLON] = ACTIONS(4133),
    [anon_sym_COMMA] = ACTIONS(4115),
    [anon_sym_RBRACK] = ACTIONS(4115),
    [anon_sym_LPAREN] = ACTIONS(4135),
    [anon_sym_RPAREN] = ACTIONS(4115),
    [anon_sym_LBRACE] = ACTIONS(4124),
    [anon_sym_RBRACE] = ACTIONS(4115),
    [anon_sym_file] = ACTIONS(4113),
    [anon_sym_LT] = ACTIONS(4118),
    [anon_sym_GT] = ACTIONS(4118),
    [anon_sym_where] = ACTIONS(4113),
    [anon_sym_QMARK] = ACTIONS(4138),
    [anon_sym_notnull] = ACTIONS(4113),
    [anon_sym_unmanaged] = ACTIONS(4113),
    [anon_sym_BANG] = ACTIONS(4118),
    [anon_sym_PLUS_PLUS] = ACTIONS(4133),
    [anon_sym_DASH_DASH] = ACTIONS(4133),
    [anon_sym_PLUS] = ACTIONS(4118),
    [anon_sym_DASH] = ACTIONS(4118),
    [anon_sym_STAR] = ACTIONS(4138),
    [anon_sym_SLASH] = ACTIONS(4118),
    [anon_sym_PERCENT] = ACTIONS(4118),
    [anon_sym_CARET] = ACTIONS(4118),
    [anon_sym_PIPE] = ACTIONS(4118),
    [anon_sym_AMP] = ACTIONS(4118),
    [anon_sym_LT_LT] = ACTIONS(4118),
    [anon_sym_GT_GT] = ACTIONS(4118),
    [anon_sym_GT_GT_GT] = ACTIONS(4118),
    [anon_sym_EQ_EQ] = ACTIONS(4133),
    [anon_sym_BANG_EQ] = ACTIONS(4133),
    [anon_sym_GT_EQ] = ACTIONS(4133),
    [anon_sym_LT_EQ] = ACTIONS(4133),
    [anon_sym_DOT] = ACTIONS(4138),
    [anon_sym_scoped] = ACTIONS(4113),
    [anon_sym_var] = ACTIONS(4113),
    [anon_sym_yield] = ACTIONS(4113),
    [anon_sym_switch] = ACTIONS(4118),
    [anon_sym_when] = ACTIONS(4113),
    [sym_discard] = ACTIONS(4113),
    [anon_sym_DOT_DOT] = ACTIONS(4133),
    [anon_sym_and] = ACTIONS(4130),
    [anon_sym_or] = ACTIONS(4130),
    [anon_sym_PLUS_EQ] = ACTIONS(4133),
    [anon_sym_DASH_EQ] = ACTIONS(4133),
    [anon_sym_STAR_EQ] = ACTIONS(4133),
    [anon_sym_SLASH_EQ] = ACTIONS(4133),
    [anon_sym_PERCENT_EQ] = ACTIONS(4133),
    [anon_sym_AMP_EQ] = ACTIONS(4133),
    [anon_sym_CARET_EQ] = ACTIONS(4133),
    [anon_sym_PIPE_EQ] = ACTIONS(4133),
    [anon_sym_LT_LT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4133),
    [anon_sym_AMP_AMP] = ACTIONS(4133),
    [anon_sym_PIPE_PIPE] = ACTIONS(4133),
    [anon_sym_QMARK_QMARK] = ACTIONS(4118),
    [anon_sym_from] = ACTIONS(4113),
    [anon_sym_into] = ACTIONS(4113),
    [anon_sym_join] = ACTIONS(4113),
    [anon_sym_on] = ACTIONS(4113),
    [anon_sym_equals] = ACTIONS(4113),
    [anon_sym_let] = ACTIONS(4113),
    [anon_sym_orderby] = ACTIONS(4113),
    [anon_sym_ascending] = ACTIONS(4113),
    [anon_sym_descending] = ACTIONS(4113),
    [anon_sym_group] = ACTIONS(4113),
    [anon_sym_by] = ACTIONS(4113),
    [anon_sym_select] = ACTIONS(4113),
    [anon_sym_as] = ACTIONS(4118),
    [anon_sym_is] = ACTIONS(4118),
    [anon_sym_DASH_GT] = ACTIONS(4135),
    [anon_sym_with] = ACTIONS(4118),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2790] = {
    [sym_preproc_region] = STATE(2790),
    [sym_preproc_endregion] = STATE(2790),
    [sym_preproc_line] = STATE(2790),
    [sym_preproc_pragma] = STATE(2790),
    [sym_preproc_nullable] = STATE(2790),
    [sym_preproc_error] = STATE(2790),
    [sym_preproc_define] = STATE(2790),
    [sym_preproc_undef] = STATE(2790),
    [sym__identifier_token] = ACTIONS(4113),
    [anon_sym_alias] = ACTIONS(4113),
    [anon_sym_global] = ACTIONS(4113),
    [anon_sym_EQ] = ACTIONS(4118),
    [anon_sym_LBRACK] = ACTIONS(4135),
    [anon_sym_COLON] = ACTIONS(4133),
    [anon_sym_COMMA] = ACTIONS(4135),
    [anon_sym_RBRACK] = ACTIONS(4135),
    [anon_sym_LPAREN] = ACTIONS(4135),
    [anon_sym_RPAREN] = ACTIONS(4133),
    [anon_sym_LBRACE] = ACTIONS(4124),
    [anon_sym_RBRACE] = ACTIONS(4135),
    [anon_sym_file] = ACTIONS(4113),
    [anon_sym_LT] = ACTIONS(4118),
    [anon_sym_GT] = ACTIONS(4118),
    [anon_sym_where] = ACTIONS(4113),
    [anon_sym_QMARK] = ACTIONS(4138),
    [anon_sym_notnull] = ACTIONS(4113),
    [anon_sym_unmanaged] = ACTIONS(4113),
    [anon_sym_BANG] = ACTIONS(4118),
    [anon_sym_PLUS_PLUS] = ACTIONS(4133),
    [anon_sym_DASH_DASH] = ACTIONS(4133),
    [anon_sym_PLUS] = ACTIONS(4118),
    [anon_sym_DASH] = ACTIONS(4118),
    [anon_sym_STAR] = ACTIONS(4138),
    [anon_sym_SLASH] = ACTIONS(4118),
    [anon_sym_PERCENT] = ACTIONS(4118),
    [anon_sym_CARET] = ACTIONS(4118),
    [anon_sym_PIPE] = ACTIONS(4118),
    [anon_sym_AMP] = ACTIONS(4118),
    [anon_sym_LT_LT] = ACTIONS(4118),
    [anon_sym_GT_GT] = ACTIONS(4118),
    [anon_sym_GT_GT_GT] = ACTIONS(4118),
    [anon_sym_EQ_EQ] = ACTIONS(4133),
    [anon_sym_BANG_EQ] = ACTIONS(4133),
    [anon_sym_GT_EQ] = ACTIONS(4133),
    [anon_sym_LT_EQ] = ACTIONS(4133),
    [anon_sym_DOT] = ACTIONS(4138),
    [anon_sym_scoped] = ACTIONS(4113),
    [anon_sym_var] = ACTIONS(4113),
    [anon_sym_yield] = ACTIONS(4113),
    [anon_sym_switch] = ACTIONS(4118),
    [anon_sym_when] = ACTIONS(4113),
    [sym_discard] = ACTIONS(4113),
    [anon_sym_DOT_DOT] = ACTIONS(4133),
    [anon_sym_and] = ACTIONS(4113),
    [anon_sym_or] = ACTIONS(4113),
    [anon_sym_PLUS_EQ] = ACTIONS(4133),
    [anon_sym_DASH_EQ] = ACTIONS(4133),
    [anon_sym_STAR_EQ] = ACTIONS(4133),
    [anon_sym_SLASH_EQ] = ACTIONS(4133),
    [anon_sym_PERCENT_EQ] = ACTIONS(4133),
    [anon_sym_AMP_EQ] = ACTIONS(4133),
    [anon_sym_CARET_EQ] = ACTIONS(4133),
    [anon_sym_PIPE_EQ] = ACTIONS(4133),
    [anon_sym_LT_LT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4133),
    [anon_sym_AMP_AMP] = ACTIONS(4133),
    [anon_sym_PIPE_PIPE] = ACTIONS(4133),
    [anon_sym_QMARK_QMARK] = ACTIONS(4118),
    [anon_sym_from] = ACTIONS(4113),
    [anon_sym_into] = ACTIONS(4113),
    [anon_sym_join] = ACTIONS(4113),
    [anon_sym_on] = ACTIONS(4113),
    [anon_sym_equals] = ACTIONS(4113),
    [anon_sym_let] = ACTIONS(4113),
    [anon_sym_orderby] = ACTIONS(4113),
    [anon_sym_ascending] = ACTIONS(4113),
    [anon_sym_descending] = ACTIONS(4113),
    [anon_sym_group] = ACTIONS(4113),
    [anon_sym_by] = ACTIONS(4113),
    [anon_sym_select] = ACTIONS(4113),
    [anon_sym_as] = ACTIONS(4118),
    [anon_sym_is] = ACTIONS(4118),
    [anon_sym_DASH_GT] = ACTIONS(4135),
    [anon_sym_with] = ACTIONS(4118),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2791] = {
    [sym_preproc_region] = STATE(2791),
    [sym_preproc_endregion] = STATE(2791),
    [sym_preproc_line] = STATE(2791),
    [sym_preproc_pragma] = STATE(2791),
    [sym_preproc_nullable] = STATE(2791),
    [sym_preproc_error] = STATE(2791),
    [sym_preproc_define] = STATE(2791),
    [sym_preproc_undef] = STATE(2791),
    [sym__identifier_token] = ACTIONS(4099),
    [anon_sym_alias] = ACTIONS(4099),
    [anon_sym_global] = ACTIONS(4099),
    [anon_sym_EQ] = ACTIONS(4104),
    [anon_sym_LBRACK] = ACTIONS(4101),
    [anon_sym_COLON] = ACTIONS(4111),
    [anon_sym_COMMA] = ACTIONS(4101),
    [anon_sym_RBRACK] = ACTIONS(4101),
    [anon_sym_LPAREN] = ACTIONS(4101),
    [anon_sym_RPAREN] = ACTIONS(4111),
    [anon_sym_LBRACE] = ACTIONS(4106),
    [anon_sym_RBRACE] = ACTIONS(4101),
    [anon_sym_file] = ACTIONS(4099),
    [anon_sym_LT] = ACTIONS(4104),
    [anon_sym_GT] = ACTIONS(4104),
    [anon_sym_where] = ACTIONS(4099),
    [anon_sym_QMARK] = ACTIONS(4108),
    [anon_sym_notnull] = ACTIONS(4099),
    [anon_sym_unmanaged] = ACTIONS(4099),
    [anon_sym_BANG] = ACTIONS(4104),
    [anon_sym_PLUS_PLUS] = ACTIONS(4111),
    [anon_sym_DASH_DASH] = ACTIONS(4111),
    [anon_sym_PLUS] = ACTIONS(4104),
    [anon_sym_DASH] = ACTIONS(4104),
    [anon_sym_STAR] = ACTIONS(4108),
    [anon_sym_SLASH] = ACTIONS(4104),
    [anon_sym_PERCENT] = ACTIONS(4104),
    [anon_sym_CARET] = ACTIONS(4104),
    [anon_sym_PIPE] = ACTIONS(4104),
    [anon_sym_AMP] = ACTIONS(4104),
    [anon_sym_LT_LT] = ACTIONS(4104),
    [anon_sym_GT_GT] = ACTIONS(4104),
    [anon_sym_GT_GT_GT] = ACTIONS(4104),
    [anon_sym_EQ_EQ] = ACTIONS(4111),
    [anon_sym_BANG_EQ] = ACTIONS(4111),
    [anon_sym_GT_EQ] = ACTIONS(4111),
    [anon_sym_LT_EQ] = ACTIONS(4111),
    [anon_sym_DOT] = ACTIONS(4108),
    [anon_sym_scoped] = ACTIONS(4099),
    [anon_sym_var] = ACTIONS(4099),
    [anon_sym_yield] = ACTIONS(4099),
    [anon_sym_switch] = ACTIONS(4104),
    [anon_sym_when] = ACTIONS(4099),
    [sym_discard] = ACTIONS(4099),
    [anon_sym_DOT_DOT] = ACTIONS(4111),
    [anon_sym_and] = ACTIONS(4099),
    [anon_sym_or] = ACTIONS(4099),
    [anon_sym_PLUS_EQ] = ACTIONS(4111),
    [anon_sym_DASH_EQ] = ACTIONS(4111),
    [anon_sym_STAR_EQ] = ACTIONS(4111),
    [anon_sym_SLASH_EQ] = ACTIONS(4111),
    [anon_sym_PERCENT_EQ] = ACTIONS(4111),
    [anon_sym_AMP_EQ] = ACTIONS(4111),
    [anon_sym_CARET_EQ] = ACTIONS(4111),
    [anon_sym_PIPE_EQ] = ACTIONS(4111),
    [anon_sym_LT_LT_EQ] = ACTIONS(4111),
    [anon_sym_GT_GT_EQ] = ACTIONS(4111),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4111),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4111),
    [anon_sym_AMP_AMP] = ACTIONS(4111),
    [anon_sym_PIPE_PIPE] = ACTIONS(4111),
    [anon_sym_QMARK_QMARK] = ACTIONS(4104),
    [anon_sym_from] = ACTIONS(4099),
    [anon_sym_into] = ACTIONS(4099),
    [anon_sym_join] = ACTIONS(4099),
    [anon_sym_on] = ACTIONS(4099),
    [anon_sym_equals] = ACTIONS(4099),
    [anon_sym_let] = ACTIONS(4099),
    [anon_sym_orderby] = ACTIONS(4099),
    [anon_sym_ascending] = ACTIONS(4099),
    [anon_sym_descending] = ACTIONS(4099),
    [anon_sym_group] = ACTIONS(4099),
    [anon_sym_by] = ACTIONS(4099),
    [anon_sym_select] = ACTIONS(4099),
    [anon_sym_as] = ACTIONS(4104),
    [anon_sym_is] = ACTIONS(4104),
    [anon_sym_DASH_GT] = ACTIONS(4101),
    [anon_sym_with] = ACTIONS(4104),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2792] = {
    [sym_preproc_region] = STATE(2792),
    [sym_preproc_endregion] = STATE(2792),
    [sym_preproc_line] = STATE(2792),
    [sym_preproc_pragma] = STATE(2792),
    [sym_preproc_nullable] = STATE(2792),
    [sym_preproc_error] = STATE(2792),
    [sym_preproc_define] = STATE(2792),
    [sym_preproc_undef] = STATE(2792),
    [sym__identifier_token] = ACTIONS(4056),
    [anon_sym_alias] = ACTIONS(4056),
    [anon_sym_global] = ACTIONS(4056),
    [anon_sym_EQ] = ACTIONS(4056),
    [anon_sym_LBRACK] = ACTIONS(4058),
    [anon_sym_COLON] = ACTIONS(4056),
    [anon_sym_COMMA] = ACTIONS(4058),
    [anon_sym_LPAREN] = ACTIONS(4058),
    [anon_sym_LBRACE] = ACTIONS(4058),
    [anon_sym_file] = ACTIONS(4056),
    [anon_sym_LT] = ACTIONS(4056),
    [anon_sym_GT] = ACTIONS(4056),
    [anon_sym_where] = ACTIONS(4056),
    [anon_sym_QMARK] = ACTIONS(4056),
    [anon_sym_notnull] = ACTIONS(4056),
    [anon_sym_unmanaged] = ACTIONS(4056),
    [anon_sym_BANG] = ACTIONS(4056),
    [anon_sym_PLUS_PLUS] = ACTIONS(4058),
    [anon_sym_DASH_DASH] = ACTIONS(4058),
    [anon_sym_PLUS] = ACTIONS(4056),
    [anon_sym_DASH] = ACTIONS(4056),
    [anon_sym_STAR] = ACTIONS(4056),
    [anon_sym_SLASH] = ACTIONS(4056),
    [anon_sym_PERCENT] = ACTIONS(4056),
    [anon_sym_CARET] = ACTIONS(4056),
    [anon_sym_PIPE] = ACTIONS(4056),
    [anon_sym_AMP] = ACTIONS(4056),
    [anon_sym_LT_LT] = ACTIONS(4056),
    [anon_sym_GT_GT] = ACTIONS(4056),
    [anon_sym_GT_GT_GT] = ACTIONS(4056),
    [anon_sym_EQ_EQ] = ACTIONS(4058),
    [anon_sym_BANG_EQ] = ACTIONS(4058),
    [anon_sym_GT_EQ] = ACTIONS(4058),
    [anon_sym_LT_EQ] = ACTIONS(4058),
    [anon_sym_DOT] = ACTIONS(4056),
    [anon_sym_scoped] = ACTIONS(4056),
    [anon_sym_EQ_GT] = ACTIONS(4058),
    [anon_sym_COLON_COLON] = ACTIONS(4058),
    [anon_sym_var] = ACTIONS(4056),
    [anon_sym_yield] = ACTIONS(4056),
    [anon_sym_switch] = ACTIONS(4056),
    [anon_sym_when] = ACTIONS(4056),
    [sym_discard] = ACTIONS(4056),
    [anon_sym_DOT_DOT] = ACTIONS(4058),
    [anon_sym_and] = ACTIONS(4056),
    [anon_sym_or] = ACTIONS(4056),
    [anon_sym_PLUS_EQ] = ACTIONS(4058),
    [anon_sym_DASH_EQ] = ACTIONS(4058),
    [anon_sym_STAR_EQ] = ACTIONS(4058),
    [anon_sym_SLASH_EQ] = ACTIONS(4058),
    [anon_sym_PERCENT_EQ] = ACTIONS(4058),
    [anon_sym_AMP_EQ] = ACTIONS(4058),
    [anon_sym_CARET_EQ] = ACTIONS(4058),
    [anon_sym_PIPE_EQ] = ACTIONS(4058),
    [anon_sym_LT_LT_EQ] = ACTIONS(4058),
    [anon_sym_GT_GT_EQ] = ACTIONS(4058),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4058),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4058),
    [anon_sym_AMP_AMP] = ACTIONS(4058),
    [anon_sym_PIPE_PIPE] = ACTIONS(4058),
    [anon_sym_QMARK_QMARK] = ACTIONS(4056),
    [anon_sym_from] = ACTIONS(4056),
    [anon_sym_into] = ACTIONS(4056),
    [anon_sym_join] = ACTIONS(4056),
    [anon_sym_on] = ACTIONS(4056),
    [anon_sym_equals] = ACTIONS(4056),
    [anon_sym_let] = ACTIONS(4056),
    [anon_sym_orderby] = ACTIONS(4056),
    [anon_sym_ascending] = ACTIONS(4056),
    [anon_sym_descending] = ACTIONS(4056),
    [anon_sym_group] = ACTIONS(4056),
    [anon_sym_by] = ACTIONS(4056),
    [anon_sym_select] = ACTIONS(4056),
    [anon_sym_as] = ACTIONS(4056),
    [anon_sym_is] = ACTIONS(4056),
    [anon_sym_DASH_GT] = ACTIONS(4058),
    [anon_sym_with] = ACTIONS(4056),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4058),
  },
  [2793] = {
    [sym__name] = STATE(3768),
    [sym_alias_qualified_name] = STATE(3635),
    [sym__simple_name] = STATE(3635),
    [sym_qualified_name] = STATE(3635),
    [sym_generic_name] = STATE(3708),
    [sym_ref_type] = STATE(3636),
    [sym__scoped_base_type] = STATE(3641),
    [sym_identifier] = STATE(3590),
    [sym__reserved_identifier] = STATE(3568),
    [sym_preproc_region] = STATE(2793),
    [sym_preproc_endregion] = STATE(2793),
    [sym_preproc_line] = STATE(2793),
    [sym_preproc_pragma] = STATE(2793),
    [sym_preproc_nullable] = STATE(2793),
    [sym_preproc_error] = STATE(2793),
    [sym_preproc_define] = STATE(2793),
    [sym_preproc_undef] = STATE(2793),
    [sym__identifier_token] = ACTIONS(4287),
    [anon_sym_alias] = ACTIONS(4289),
    [anon_sym_SEMI] = ACTIONS(3719),
    [anon_sym_global] = ACTIONS(4289),
    [anon_sym_LBRACK] = ACTIONS(3719),
    [anon_sym_COMMA] = ACTIONS(3719),
    [anon_sym_RBRACK] = ACTIONS(3719),
    [anon_sym_LPAREN] = ACTIONS(3719),
    [anon_sym_RPAREN] = ACTIONS(3719),
    [anon_sym_ref] = ACTIONS(4291),
    [anon_sym_LBRACE] = ACTIONS(3719),
    [anon_sym_RBRACE] = ACTIONS(3719),
    [anon_sym_file] = ACTIONS(4289),
    [anon_sym_LT] = ACTIONS(3721),
    [anon_sym_GT] = ACTIONS(3721),
    [anon_sym_in] = ACTIONS(3721),
    [anon_sym_where] = ACTIONS(4289),
    [anon_sym_QMARK] = ACTIONS(3721),
    [anon_sym_notnull] = ACTIONS(4289),
    [anon_sym_unmanaged] = ACTIONS(4289),
    [anon_sym_BANG] = ACTIONS(3721),
    [anon_sym_PLUS_PLUS] = ACTIONS(3719),
    [anon_sym_DASH_DASH] = ACTIONS(3719),
    [anon_sym_PLUS] = ACTIONS(3721),
    [anon_sym_DASH] = ACTIONS(3721),
    [anon_sym_STAR] = ACTIONS(3719),
    [anon_sym_SLASH] = ACTIONS(3721),
    [anon_sym_PERCENT] = ACTIONS(3719),
    [anon_sym_CARET] = ACTIONS(3719),
    [anon_sym_PIPE] = ACTIONS(3721),
    [anon_sym_AMP] = ACTIONS(3721),
    [anon_sym_LT_LT] = ACTIONS(3719),
    [anon_sym_GT_GT] = ACTIONS(3721),
    [anon_sym_GT_GT_GT] = ACTIONS(3719),
    [anon_sym_EQ_EQ] = ACTIONS(3719),
    [anon_sym_BANG_EQ] = ACTIONS(3719),
    [anon_sym_GT_EQ] = ACTIONS(3719),
    [anon_sym_LT_EQ] = ACTIONS(3719),
    [anon_sym_DOT] = ACTIONS(3721),
    [anon_sym_scoped] = ACTIONS(4289),
    [anon_sym_EQ_GT] = ACTIONS(3719),
    [anon_sym_COLON_COLON] = ACTIONS(3719),
    [anon_sym_var] = ACTIONS(4289),
    [anon_sym_yield] = ACTIONS(4289),
    [anon_sym_switch] = ACTIONS(3721),
    [anon_sym_when] = ACTIONS(4289),
    [anon_sym_DOT_DOT] = ACTIONS(3719),
    [anon_sym_AMP_AMP] = ACTIONS(3719),
    [anon_sym_PIPE_PIPE] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK] = ACTIONS(3719),
    [anon_sym_from] = ACTIONS(4289),
    [anon_sym_into] = ACTIONS(4289),
    [anon_sym_join] = ACTIONS(4289),
    [anon_sym_on] = ACTIONS(4289),
    [anon_sym_equals] = ACTIONS(4289),
    [anon_sym_let] = ACTIONS(4289),
    [anon_sym_orderby] = ACTIONS(4289),
    [anon_sym_ascending] = ACTIONS(4289),
    [anon_sym_descending] = ACTIONS(4289),
    [anon_sym_group] = ACTIONS(4289),
    [anon_sym_by] = ACTIONS(4289),
    [anon_sym_select] = ACTIONS(4289),
    [anon_sym_as] = ACTIONS(3721),
    [anon_sym_is] = ACTIONS(3721),
    [anon_sym_DASH_GT] = ACTIONS(3719),
    [anon_sym_with] = ACTIONS(3721),
    [aux_sym_preproc_if_token3] = ACTIONS(3719),
    [aux_sym_preproc_else_token1] = ACTIONS(3719),
    [aux_sym_preproc_elif_token1] = ACTIONS(3719),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2794] = {
    [sym_parameter_list] = STATE(9765),
    [sym_positional_pattern_clause] = STATE(2826),
    [sym_property_pattern_clause] = STATE(2859),
    [sym__variable_designation] = STATE(4021),
    [sym_parenthesized_variable_designation] = STATE(4015),
    [sym__lambda_parameters] = STATE(9127),
    [sym_identifier] = STATE(4055),
    [sym__reserved_identifier] = STATE(3908),
    [sym_preproc_region] = STATE(2794),
    [sym_preproc_endregion] = STATE(2794),
    [sym_preproc_line] = STATE(2794),
    [sym_preproc_pragma] = STATE(2794),
    [sym_preproc_nullable] = STATE(2794),
    [sym_preproc_error] = STATE(2794),
    [sym_preproc_define] = STATE(2794),
    [sym_preproc_undef] = STATE(2794),
    [sym__identifier_token] = ACTIONS(4271),
    [anon_sym_alias] = ACTIONS(4273),
    [anon_sym_SEMI] = ACTIONS(4283),
    [anon_sym_global] = ACTIONS(4273),
    [anon_sym_LBRACK] = ACTIONS(4283),
    [anon_sym_COLON] = ACTIONS(4283),
    [anon_sym_COMMA] = ACTIONS(4283),
    [anon_sym_RBRACK] = ACTIONS(4283),
    [anon_sym_LPAREN] = ACTIONS(4283),
    [anon_sym_RPAREN] = ACTIONS(4283),
    [anon_sym_LBRACE] = ACTIONS(4277),
    [anon_sym_RBRACE] = ACTIONS(4283),
    [anon_sym_file] = ACTIONS(4273),
    [anon_sym_LT] = ACTIONS(4285),
    [anon_sym_GT] = ACTIONS(4285),
    [anon_sym_in] = ACTIONS(4285),
    [anon_sym_where] = ACTIONS(4273),
    [anon_sym_QMARK] = ACTIONS(4285),
    [anon_sym_notnull] = ACTIONS(4273),
    [anon_sym_unmanaged] = ACTIONS(4273),
    [anon_sym_BANG] = ACTIONS(4285),
    [anon_sym_PLUS_PLUS] = ACTIONS(4283),
    [anon_sym_DASH_DASH] = ACTIONS(4283),
    [anon_sym_PLUS] = ACTIONS(4285),
    [anon_sym_DASH] = ACTIONS(4285),
    [anon_sym_STAR] = ACTIONS(4283),
    [anon_sym_SLASH] = ACTIONS(4285),
    [anon_sym_PERCENT] = ACTIONS(4283),
    [anon_sym_CARET] = ACTIONS(4283),
    [anon_sym_PIPE] = ACTIONS(4285),
    [anon_sym_AMP] = ACTIONS(4285),
    [anon_sym_LT_LT] = ACTIONS(4283),
    [anon_sym_GT_GT] = ACTIONS(4285),
    [anon_sym_GT_GT_GT] = ACTIONS(4283),
    [anon_sym_EQ_EQ] = ACTIONS(4283),
    [anon_sym_BANG_EQ] = ACTIONS(4283),
    [anon_sym_GT_EQ] = ACTIONS(4283),
    [anon_sym_LT_EQ] = ACTIONS(4283),
    [anon_sym_DOT] = ACTIONS(4285),
    [anon_sym_scoped] = ACTIONS(4273),
    [anon_sym_var] = ACTIONS(4273),
    [anon_sym_yield] = ACTIONS(4273),
    [anon_sym_switch] = ACTIONS(4285),
    [anon_sym_when] = ACTIONS(4273),
    [sym_discard] = ACTIONS(4281),
    [anon_sym_DOT_DOT] = ACTIONS(4283),
    [anon_sym_and] = ACTIONS(4285),
    [anon_sym_or] = ACTIONS(4285),
    [anon_sym_AMP_AMP] = ACTIONS(4283),
    [anon_sym_PIPE_PIPE] = ACTIONS(4283),
    [anon_sym_QMARK_QMARK] = ACTIONS(4283),
    [anon_sym_from] = ACTIONS(4273),
    [anon_sym_into] = ACTIONS(4285),
    [anon_sym_join] = ACTIONS(4273),
    [anon_sym_on] = ACTIONS(4273),
    [anon_sym_equals] = ACTIONS(4273),
    [anon_sym_let] = ACTIONS(4273),
    [anon_sym_orderby] = ACTIONS(4273),
    [anon_sym_ascending] = ACTIONS(4273),
    [anon_sym_descending] = ACTIONS(4273),
    [anon_sym_group] = ACTIONS(4273),
    [anon_sym_by] = ACTIONS(4273),
    [anon_sym_select] = ACTIONS(4273),
    [anon_sym_as] = ACTIONS(4285),
    [anon_sym_is] = ACTIONS(4285),
    [anon_sym_DASH_GT] = ACTIONS(4283),
    [anon_sym_with] = ACTIONS(4285),
    [aux_sym_preproc_if_token3] = ACTIONS(4283),
    [aux_sym_preproc_else_token1] = ACTIONS(4283),
    [aux_sym_preproc_elif_token1] = ACTIONS(4283),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2795] = {
    [sym_type_argument_list] = STATE(2736),
    [sym_preproc_region] = STATE(2795),
    [sym_preproc_endregion] = STATE(2795),
    [sym_preproc_line] = STATE(2795),
    [sym_preproc_pragma] = STATE(2795),
    [sym_preproc_nullable] = STATE(2795),
    [sym_preproc_error] = STATE(2795),
    [sym_preproc_define] = STATE(2795),
    [sym_preproc_undef] = STATE(2795),
    [sym__identifier_token] = ACTIONS(4074),
    [anon_sym_alias] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4074),
    [anon_sym_EQ] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4076),
    [anon_sym_COLON] = ACTIONS(4074),
    [anon_sym_LPAREN] = ACTIONS(4076),
    [anon_sym_LBRACE] = ACTIONS(4076),
    [anon_sym_file] = ACTIONS(4074),
    [anon_sym_LT] = ACTIONS(4078),
    [anon_sym_GT] = ACTIONS(4074),
    [anon_sym_where] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(4074),
    [anon_sym_notnull] = ACTIONS(4074),
    [anon_sym_unmanaged] = ACTIONS(4074),
    [anon_sym_BANG] = ACTIONS(4074),
    [anon_sym_PLUS_PLUS] = ACTIONS(4076),
    [anon_sym_DASH_DASH] = ACTIONS(4076),
    [anon_sym_PLUS] = ACTIONS(4074),
    [anon_sym_DASH] = ACTIONS(4074),
    [anon_sym_STAR] = ACTIONS(4074),
    [anon_sym_SLASH] = ACTIONS(4074),
    [anon_sym_PERCENT] = ACTIONS(4074),
    [anon_sym_CARET] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(4074),
    [anon_sym_AMP] = ACTIONS(4074),
    [anon_sym_LT_LT] = ACTIONS(4074),
    [anon_sym_GT_GT] = ACTIONS(4074),
    [anon_sym_GT_GT_GT] = ACTIONS(4074),
    [anon_sym_EQ_EQ] = ACTIONS(4076),
    [anon_sym_BANG_EQ] = ACTIONS(4076),
    [anon_sym_GT_EQ] = ACTIONS(4076),
    [anon_sym_LT_EQ] = ACTIONS(4076),
    [anon_sym_DOT] = ACTIONS(4074),
    [anon_sym_scoped] = ACTIONS(4074),
    [anon_sym_EQ_GT] = ACTIONS(4081),
    [anon_sym_COLON_COLON] = ACTIONS(4293),
    [anon_sym_var] = ACTIONS(4074),
    [anon_sym_yield] = ACTIONS(4074),
    [anon_sym_switch] = ACTIONS(4074),
    [anon_sym_when] = ACTIONS(4074),
    [sym_discard] = ACTIONS(4074),
    [anon_sym_DOT_DOT] = ACTIONS(4076),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_PLUS_EQ] = ACTIONS(4076),
    [anon_sym_DASH_EQ] = ACTIONS(4076),
    [anon_sym_STAR_EQ] = ACTIONS(4076),
    [anon_sym_SLASH_EQ] = ACTIONS(4076),
    [anon_sym_PERCENT_EQ] = ACTIONS(4076),
    [anon_sym_AMP_EQ] = ACTIONS(4076),
    [anon_sym_CARET_EQ] = ACTIONS(4076),
    [anon_sym_PIPE_EQ] = ACTIONS(4076),
    [anon_sym_LT_LT_EQ] = ACTIONS(4076),
    [anon_sym_GT_GT_EQ] = ACTIONS(4076),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4076),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4076),
    [anon_sym_AMP_AMP] = ACTIONS(4076),
    [anon_sym_PIPE_PIPE] = ACTIONS(4076),
    [anon_sym_QMARK_QMARK] = ACTIONS(4074),
    [anon_sym_from] = ACTIONS(4074),
    [anon_sym_into] = ACTIONS(4074),
    [anon_sym_join] = ACTIONS(4074),
    [anon_sym_on] = ACTIONS(4074),
    [anon_sym_equals] = ACTIONS(4074),
    [anon_sym_let] = ACTIONS(4074),
    [anon_sym_orderby] = ACTIONS(4074),
    [anon_sym_ascending] = ACTIONS(4074),
    [anon_sym_descending] = ACTIONS(4074),
    [anon_sym_group] = ACTIONS(4074),
    [anon_sym_by] = ACTIONS(4074),
    [anon_sym_select] = ACTIONS(4074),
    [anon_sym_as] = ACTIONS(4074),
    [anon_sym_is] = ACTIONS(4074),
    [anon_sym_DASH_GT] = ACTIONS(4076),
    [anon_sym_with] = ACTIONS(4074),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2796] = {
    [sym_type_argument_list] = STATE(2823),
    [sym_preproc_region] = STATE(2796),
    [sym_preproc_endregion] = STATE(2796),
    [sym_preproc_line] = STATE(2796),
    [sym_preproc_pragma] = STATE(2796),
    [sym_preproc_nullable] = STATE(2796),
    [sym_preproc_error] = STATE(2796),
    [sym_preproc_define] = STATE(2796),
    [sym_preproc_undef] = STATE(2796),
    [sym__identifier_token] = ACTIONS(4074),
    [anon_sym_alias] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4074),
    [anon_sym_EQ] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4076),
    [anon_sym_COLON] = ACTIONS(4076),
    [anon_sym_COMMA] = ACTIONS(4076),
    [anon_sym_LPAREN] = ACTIONS(4076),
    [anon_sym_LBRACE] = ACTIONS(4076),
    [anon_sym_file] = ACTIONS(4074),
    [anon_sym_LT] = ACTIONS(4234),
    [anon_sym_GT] = ACTIONS(4074),
    [anon_sym_where] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(4074),
    [anon_sym_notnull] = ACTIONS(4074),
    [anon_sym_unmanaged] = ACTIONS(4074),
    [anon_sym_BANG] = ACTIONS(4074),
    [anon_sym_PLUS_PLUS] = ACTIONS(4076),
    [anon_sym_DASH_DASH] = ACTIONS(4076),
    [anon_sym_PLUS] = ACTIONS(4074),
    [anon_sym_DASH] = ACTIONS(4074),
    [anon_sym_STAR] = ACTIONS(4074),
    [anon_sym_SLASH] = ACTIONS(4074),
    [anon_sym_PERCENT] = ACTIONS(4074),
    [anon_sym_CARET] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(4074),
    [anon_sym_AMP] = ACTIONS(4074),
    [anon_sym_LT_LT] = ACTIONS(4074),
    [anon_sym_GT_GT] = ACTIONS(4074),
    [anon_sym_GT_GT_GT] = ACTIONS(4074),
    [anon_sym_EQ_EQ] = ACTIONS(4076),
    [anon_sym_BANG_EQ] = ACTIONS(4076),
    [anon_sym_GT_EQ] = ACTIONS(4076),
    [anon_sym_LT_EQ] = ACTIONS(4076),
    [anon_sym_DOT] = ACTIONS(4074),
    [anon_sym_scoped] = ACTIONS(4074),
    [anon_sym_var] = ACTIONS(4074),
    [anon_sym_yield] = ACTIONS(4074),
    [anon_sym_switch] = ACTIONS(4074),
    [anon_sym_when] = ACTIONS(4074),
    [sym_discard] = ACTIONS(4074),
    [anon_sym_DOT_DOT] = ACTIONS(4076),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_PLUS_EQ] = ACTIONS(4076),
    [anon_sym_DASH_EQ] = ACTIONS(4076),
    [anon_sym_STAR_EQ] = ACTIONS(4076),
    [anon_sym_SLASH_EQ] = ACTIONS(4076),
    [anon_sym_PERCENT_EQ] = ACTIONS(4076),
    [anon_sym_AMP_EQ] = ACTIONS(4076),
    [anon_sym_CARET_EQ] = ACTIONS(4076),
    [anon_sym_PIPE_EQ] = ACTIONS(4076),
    [anon_sym_LT_LT_EQ] = ACTIONS(4076),
    [anon_sym_GT_GT_EQ] = ACTIONS(4076),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4076),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4076),
    [anon_sym_AMP_AMP] = ACTIONS(4076),
    [anon_sym_PIPE_PIPE] = ACTIONS(4076),
    [anon_sym_QMARK_QMARK] = ACTIONS(4074),
    [anon_sym_from] = ACTIONS(4074),
    [anon_sym_into] = ACTIONS(4074),
    [anon_sym_join] = ACTIONS(4074),
    [anon_sym_on] = ACTIONS(4074),
    [anon_sym_equals] = ACTIONS(4074),
    [anon_sym_let] = ACTIONS(4074),
    [anon_sym_orderby] = ACTIONS(4074),
    [anon_sym_ascending] = ACTIONS(4074),
    [anon_sym_descending] = ACTIONS(4074),
    [anon_sym_group] = ACTIONS(4074),
    [anon_sym_by] = ACTIONS(4074),
    [anon_sym_select] = ACTIONS(4074),
    [anon_sym_as] = ACTIONS(4074),
    [anon_sym_is] = ACTIONS(4074),
    [anon_sym_DASH_GT] = ACTIONS(4076),
    [anon_sym_with] = ACTIONS(4074),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4076),
  },
  [2797] = {
    [sym_parameter_list] = STATE(9765),
    [sym_positional_pattern_clause] = STATE(2840),
    [sym_property_pattern_clause] = STATE(2896),
    [sym__variable_designation] = STATE(4260),
    [sym_parenthesized_variable_designation] = STATE(4274),
    [sym__lambda_parameters] = STATE(9127),
    [sym_identifier] = STATE(4259),
    [sym__reserved_identifier] = STATE(3908),
    [sym_preproc_region] = STATE(2797),
    [sym_preproc_endregion] = STATE(2797),
    [sym_preproc_line] = STATE(2797),
    [sym_preproc_pragma] = STATE(2797),
    [sym_preproc_nullable] = STATE(2797),
    [sym_preproc_error] = STATE(2797),
    [sym_preproc_define] = STATE(2797),
    [sym_preproc_undef] = STATE(2797),
    [sym__identifier_token] = ACTIONS(4271),
    [anon_sym_alias] = ACTIONS(4273),
    [anon_sym_SEMI] = ACTIONS(4275),
    [anon_sym_global] = ACTIONS(4273),
    [anon_sym_LBRACK] = ACTIONS(4275),
    [anon_sym_COLON] = ACTIONS(4275),
    [anon_sym_COMMA] = ACTIONS(4275),
    [anon_sym_RBRACK] = ACTIONS(4275),
    [anon_sym_LPAREN] = ACTIONS(4275),
    [anon_sym_RPAREN] = ACTIONS(4275),
    [anon_sym_LBRACE] = ACTIONS(4277),
    [anon_sym_RBRACE] = ACTIONS(4275),
    [anon_sym_file] = ACTIONS(4273),
    [anon_sym_LT] = ACTIONS(4279),
    [anon_sym_GT] = ACTIONS(4279),
    [anon_sym_where] = ACTIONS(4273),
    [anon_sym_QMARK] = ACTIONS(4279),
    [anon_sym_notnull] = ACTIONS(4273),
    [anon_sym_unmanaged] = ACTIONS(4273),
    [anon_sym_BANG] = ACTIONS(4279),
    [anon_sym_PLUS_PLUS] = ACTIONS(4275),
    [anon_sym_DASH_DASH] = ACTIONS(4275),
    [anon_sym_PLUS] = ACTIONS(4279),
    [anon_sym_DASH] = ACTIONS(4279),
    [anon_sym_STAR] = ACTIONS(4275),
    [anon_sym_SLASH] = ACTIONS(4279),
    [anon_sym_PERCENT] = ACTIONS(4275),
    [anon_sym_CARET] = ACTIONS(4275),
    [anon_sym_PIPE] = ACTIONS(4279),
    [anon_sym_AMP] = ACTIONS(4279),
    [anon_sym_LT_LT] = ACTIONS(4275),
    [anon_sym_GT_GT] = ACTIONS(4279),
    [anon_sym_GT_GT_GT] = ACTIONS(4275),
    [anon_sym_EQ_EQ] = ACTIONS(4275),
    [anon_sym_BANG_EQ] = ACTIONS(4275),
    [anon_sym_GT_EQ] = ACTIONS(4275),
    [anon_sym_LT_EQ] = ACTIONS(4275),
    [anon_sym_DOT] = ACTIONS(4279),
    [anon_sym_scoped] = ACTIONS(4273),
    [anon_sym_var] = ACTIONS(4273),
    [anon_sym_yield] = ACTIONS(4273),
    [anon_sym_switch] = ACTIONS(4279),
    [anon_sym_when] = ACTIONS(4273),
    [sym_discard] = ACTIONS(4295),
    [anon_sym_DOT_DOT] = ACTIONS(4275),
    [anon_sym_and] = ACTIONS(4279),
    [anon_sym_or] = ACTIONS(4279),
    [anon_sym_AMP_AMP] = ACTIONS(4275),
    [anon_sym_PIPE_PIPE] = ACTIONS(4275),
    [anon_sym_QMARK_QMARK] = ACTIONS(4275),
    [anon_sym_from] = ACTIONS(4273),
    [anon_sym_into] = ACTIONS(4273),
    [anon_sym_join] = ACTIONS(4273),
    [anon_sym_on] = ACTIONS(4273),
    [anon_sym_equals] = ACTIONS(4273),
    [anon_sym_let] = ACTIONS(4273),
    [anon_sym_orderby] = ACTIONS(4273),
    [anon_sym_ascending] = ACTIONS(4273),
    [anon_sym_descending] = ACTIONS(4273),
    [anon_sym_group] = ACTIONS(4273),
    [anon_sym_by] = ACTIONS(4273),
    [anon_sym_select] = ACTIONS(4273),
    [anon_sym_as] = ACTIONS(4279),
    [anon_sym_is] = ACTIONS(4279),
    [anon_sym_DASH_GT] = ACTIONS(4275),
    [anon_sym_with] = ACTIONS(4279),
    [aux_sym_preproc_if_token3] = ACTIONS(4275),
    [aux_sym_preproc_else_token1] = ACTIONS(4275),
    [aux_sym_preproc_elif_token1] = ACTIONS(4275),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2798] = {
    [sym_type_argument_list] = STATE(2823),
    [sym_preproc_region] = STATE(2798),
    [sym_preproc_endregion] = STATE(2798),
    [sym_preproc_line] = STATE(2798),
    [sym_preproc_pragma] = STATE(2798),
    [sym_preproc_nullable] = STATE(2798),
    [sym_preproc_error] = STATE(2798),
    [sym_preproc_define] = STATE(2798),
    [sym_preproc_undef] = STATE(2798),
    [sym__identifier_token] = ACTIONS(4074),
    [anon_sym_alias] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4074),
    [anon_sym_EQ] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4076),
    [anon_sym_COLON] = ACTIONS(4074),
    [anon_sym_COMMA] = ACTIONS(4076),
    [anon_sym_LPAREN] = ACTIONS(4076),
    [anon_sym_file] = ACTIONS(4074),
    [anon_sym_LT] = ACTIONS(4234),
    [anon_sym_GT] = ACTIONS(4074),
    [anon_sym_where] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(4074),
    [anon_sym_notnull] = ACTIONS(4074),
    [anon_sym_unmanaged] = ACTIONS(4074),
    [anon_sym_BANG] = ACTIONS(4074),
    [anon_sym_PLUS_PLUS] = ACTIONS(4076),
    [anon_sym_DASH_DASH] = ACTIONS(4076),
    [anon_sym_PLUS] = ACTIONS(4074),
    [anon_sym_DASH] = ACTIONS(4074),
    [anon_sym_STAR] = ACTIONS(4074),
    [anon_sym_SLASH] = ACTIONS(4074),
    [anon_sym_PERCENT] = ACTIONS(4074),
    [anon_sym_CARET] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(4074),
    [anon_sym_AMP] = ACTIONS(4074),
    [anon_sym_LT_LT] = ACTIONS(4074),
    [anon_sym_GT_GT] = ACTIONS(4074),
    [anon_sym_GT_GT_GT] = ACTIONS(4074),
    [anon_sym_EQ_EQ] = ACTIONS(4076),
    [anon_sym_BANG_EQ] = ACTIONS(4076),
    [anon_sym_GT_EQ] = ACTIONS(4076),
    [anon_sym_LT_EQ] = ACTIONS(4076),
    [anon_sym_DOT] = ACTIONS(4074),
    [anon_sym_scoped] = ACTIONS(4074),
    [anon_sym_EQ_GT] = ACTIONS(4081),
    [anon_sym_COLON_COLON] = ACTIONS(4083),
    [anon_sym_var] = ACTIONS(4074),
    [anon_sym_yield] = ACTIONS(4074),
    [anon_sym_switch] = ACTIONS(4074),
    [anon_sym_when] = ACTIONS(4074),
    [anon_sym_DOT_DOT] = ACTIONS(4076),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_PLUS_EQ] = ACTIONS(4076),
    [anon_sym_DASH_EQ] = ACTIONS(4076),
    [anon_sym_STAR_EQ] = ACTIONS(4076),
    [anon_sym_SLASH_EQ] = ACTIONS(4076),
    [anon_sym_PERCENT_EQ] = ACTIONS(4076),
    [anon_sym_AMP_EQ] = ACTIONS(4076),
    [anon_sym_CARET_EQ] = ACTIONS(4076),
    [anon_sym_PIPE_EQ] = ACTIONS(4076),
    [anon_sym_LT_LT_EQ] = ACTIONS(4076),
    [anon_sym_GT_GT_EQ] = ACTIONS(4076),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4076),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4076),
    [anon_sym_AMP_AMP] = ACTIONS(4076),
    [anon_sym_PIPE_PIPE] = ACTIONS(4076),
    [anon_sym_QMARK_QMARK] = ACTIONS(4074),
    [anon_sym_from] = ACTIONS(4074),
    [anon_sym_into] = ACTIONS(4074),
    [anon_sym_join] = ACTIONS(4074),
    [anon_sym_on] = ACTIONS(4074),
    [anon_sym_equals] = ACTIONS(4074),
    [anon_sym_let] = ACTIONS(4074),
    [anon_sym_orderby] = ACTIONS(4074),
    [anon_sym_ascending] = ACTIONS(4074),
    [anon_sym_descending] = ACTIONS(4074),
    [anon_sym_group] = ACTIONS(4074),
    [anon_sym_by] = ACTIONS(4074),
    [anon_sym_select] = ACTIONS(4074),
    [anon_sym_as] = ACTIONS(4074),
    [anon_sym_is] = ACTIONS(4074),
    [anon_sym_DASH_GT] = ACTIONS(4076),
    [anon_sym_with] = ACTIONS(4074),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4076),
  },
  [2799] = {
    [sym_preproc_region] = STATE(2799),
    [sym_preproc_endregion] = STATE(2799),
    [sym_preproc_line] = STATE(2799),
    [sym_preproc_pragma] = STATE(2799),
    [sym_preproc_nullable] = STATE(2799),
    [sym_preproc_error] = STATE(2799),
    [sym_preproc_define] = STATE(2799),
    [sym_preproc_undef] = STATE(2799),
    [sym__identifier_token] = ACTIONS(4056),
    [anon_sym_alias] = ACTIONS(4056),
    [anon_sym_global] = ACTIONS(4056),
    [anon_sym_EQ] = ACTIONS(4056),
    [anon_sym_LBRACK] = ACTIONS(4058),
    [anon_sym_COLON] = ACTIONS(4058),
    [anon_sym_COMMA] = ACTIONS(4058),
    [anon_sym_LPAREN] = ACTIONS(4058),
    [anon_sym_RPAREN] = ACTIONS(4058),
    [anon_sym_LBRACE] = ACTIONS(4058),
    [anon_sym_RBRACE] = ACTIONS(4058),
    [anon_sym_file] = ACTIONS(4056),
    [anon_sym_LT] = ACTIONS(4056),
    [anon_sym_GT] = ACTIONS(4056),
    [anon_sym_where] = ACTIONS(4056),
    [anon_sym_QMARK] = ACTIONS(4056),
    [anon_sym_notnull] = ACTIONS(4056),
    [anon_sym_unmanaged] = ACTIONS(4056),
    [anon_sym_BANG] = ACTIONS(4056),
    [anon_sym_PLUS_PLUS] = ACTIONS(4058),
    [anon_sym_DASH_DASH] = ACTIONS(4058),
    [anon_sym_PLUS] = ACTIONS(4056),
    [anon_sym_DASH] = ACTIONS(4056),
    [anon_sym_STAR] = ACTIONS(4056),
    [anon_sym_SLASH] = ACTIONS(4056),
    [anon_sym_PERCENT] = ACTIONS(4056),
    [anon_sym_CARET] = ACTIONS(4056),
    [anon_sym_PIPE] = ACTIONS(4056),
    [anon_sym_AMP] = ACTIONS(4056),
    [anon_sym_LT_LT] = ACTIONS(4056),
    [anon_sym_GT_GT] = ACTIONS(4056),
    [anon_sym_GT_GT_GT] = ACTIONS(4056),
    [anon_sym_EQ_EQ] = ACTIONS(4058),
    [anon_sym_BANG_EQ] = ACTIONS(4058),
    [anon_sym_GT_EQ] = ACTIONS(4058),
    [anon_sym_LT_EQ] = ACTIONS(4058),
    [anon_sym_DOT] = ACTIONS(4056),
    [anon_sym_scoped] = ACTIONS(4056),
    [anon_sym_var] = ACTIONS(4056),
    [anon_sym_yield] = ACTIONS(4056),
    [anon_sym_switch] = ACTIONS(4056),
    [anon_sym_when] = ACTIONS(4056),
    [sym_discard] = ACTIONS(4056),
    [anon_sym_DOT_DOT] = ACTIONS(4058),
    [anon_sym_and] = ACTIONS(4056),
    [anon_sym_or] = ACTIONS(4056),
    [anon_sym_PLUS_EQ] = ACTIONS(4058),
    [anon_sym_DASH_EQ] = ACTIONS(4058),
    [anon_sym_STAR_EQ] = ACTIONS(4058),
    [anon_sym_SLASH_EQ] = ACTIONS(4058),
    [anon_sym_PERCENT_EQ] = ACTIONS(4058),
    [anon_sym_AMP_EQ] = ACTIONS(4058),
    [anon_sym_CARET_EQ] = ACTIONS(4058),
    [anon_sym_PIPE_EQ] = ACTIONS(4058),
    [anon_sym_LT_LT_EQ] = ACTIONS(4058),
    [anon_sym_GT_GT_EQ] = ACTIONS(4058),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4058),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4058),
    [anon_sym_AMP_AMP] = ACTIONS(4058),
    [anon_sym_PIPE_PIPE] = ACTIONS(4058),
    [anon_sym_QMARK_QMARK] = ACTIONS(4056),
    [anon_sym_from] = ACTIONS(4056),
    [anon_sym_into] = ACTIONS(4056),
    [anon_sym_join] = ACTIONS(4056),
    [anon_sym_on] = ACTIONS(4056),
    [anon_sym_equals] = ACTIONS(4056),
    [anon_sym_let] = ACTIONS(4056),
    [anon_sym_orderby] = ACTIONS(4056),
    [anon_sym_ascending] = ACTIONS(4056),
    [anon_sym_descending] = ACTIONS(4056),
    [anon_sym_group] = ACTIONS(4056),
    [anon_sym_by] = ACTIONS(4056),
    [anon_sym_select] = ACTIONS(4056),
    [anon_sym_as] = ACTIONS(4056),
    [anon_sym_is] = ACTIONS(4056),
    [anon_sym_DASH_GT] = ACTIONS(4058),
    [anon_sym_with] = ACTIONS(4056),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2800] = {
    [sym_attribute_list] = STATE(3753),
    [sym_modifier] = STATE(3780),
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7111),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9545),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(2800),
    [sym_preproc_endregion] = STATE(2800),
    [sym_preproc_line] = STATE(2800),
    [sym_preproc_pragma] = STATE(2800),
    [sym_preproc_nullable] = STATE(2800),
    [sym_preproc_error] = STATE(2800),
    [sym_preproc_define] = STATE(2800),
    [sym_preproc_undef] = STATE(2800),
    [aux_sym_class_declaration_repeat1] = STATE(3584),
    [aux_sym_class_declaration_repeat2] = STATE(2952),
    [aux_sym_lambda_expression_repeat1] = STATE(4147),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_unsafe] = ACTIONS(63),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(2993),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_class] = ACTIONS(4299),
    [anon_sym_ref] = ACTIONS(4301),
    [anon_sym_struct] = ACTIONS(2753),
    [anon_sym_enum] = ACTIONS(4303),
    [anon_sym_interface] = ACTIONS(4305),
    [anon_sym_delegate] = ACTIONS(4307),
    [anon_sym_record] = ACTIONS(4309),
    [anon_sym_abstract] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(37),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_file] = ACTIONS(3015),
    [anon_sym_fixed] = ACTIONS(63),
    [anon_sym_internal] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(63),
    [anon_sym_override] = ACTIONS(63),
    [anon_sym_partial] = ACTIONS(63),
    [anon_sym_private] = ACTIONS(63),
    [anon_sym_protected] = ACTIONS(63),
    [anon_sym_public] = ACTIONS(63),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_required] = ACTIONS(63),
    [anon_sym_sealed] = ACTIONS(63),
    [anon_sym_virtual] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2801] = {
    [sym_parameter_list] = STATE(9765),
    [sym_positional_pattern_clause] = STATE(2840),
    [sym_property_pattern_clause] = STATE(2896),
    [sym__variable_designation] = STATE(4260),
    [sym_parenthesized_variable_designation] = STATE(4274),
    [sym__lambda_parameters] = STATE(9127),
    [sym_identifier] = STATE(4259),
    [sym__reserved_identifier] = STATE(3908),
    [sym_preproc_region] = STATE(2801),
    [sym_preproc_endregion] = STATE(2801),
    [sym_preproc_line] = STATE(2801),
    [sym_preproc_pragma] = STATE(2801),
    [sym_preproc_nullable] = STATE(2801),
    [sym_preproc_error] = STATE(2801),
    [sym_preproc_define] = STATE(2801),
    [sym_preproc_undef] = STATE(2801),
    [sym__identifier_token] = ACTIONS(4271),
    [anon_sym_alias] = ACTIONS(4273),
    [anon_sym_SEMI] = ACTIONS(4283),
    [anon_sym_global] = ACTIONS(4273),
    [anon_sym_LBRACK] = ACTIONS(4283),
    [anon_sym_COLON] = ACTIONS(4283),
    [anon_sym_COMMA] = ACTIONS(4283),
    [anon_sym_RBRACK] = ACTIONS(4283),
    [anon_sym_LPAREN] = ACTIONS(4283),
    [anon_sym_RPAREN] = ACTIONS(4283),
    [anon_sym_LBRACE] = ACTIONS(4277),
    [anon_sym_RBRACE] = ACTIONS(4283),
    [anon_sym_file] = ACTIONS(4273),
    [anon_sym_LT] = ACTIONS(4285),
    [anon_sym_GT] = ACTIONS(4285),
    [anon_sym_where] = ACTIONS(4273),
    [anon_sym_QMARK] = ACTIONS(4285),
    [anon_sym_notnull] = ACTIONS(4273),
    [anon_sym_unmanaged] = ACTIONS(4273),
    [anon_sym_BANG] = ACTIONS(4285),
    [anon_sym_PLUS_PLUS] = ACTIONS(4283),
    [anon_sym_DASH_DASH] = ACTIONS(4283),
    [anon_sym_PLUS] = ACTIONS(4285),
    [anon_sym_DASH] = ACTIONS(4285),
    [anon_sym_STAR] = ACTIONS(4283),
    [anon_sym_SLASH] = ACTIONS(4285),
    [anon_sym_PERCENT] = ACTIONS(4283),
    [anon_sym_CARET] = ACTIONS(4283),
    [anon_sym_PIPE] = ACTIONS(4285),
    [anon_sym_AMP] = ACTIONS(4285),
    [anon_sym_LT_LT] = ACTIONS(4283),
    [anon_sym_GT_GT] = ACTIONS(4285),
    [anon_sym_GT_GT_GT] = ACTIONS(4283),
    [anon_sym_EQ_EQ] = ACTIONS(4283),
    [anon_sym_BANG_EQ] = ACTIONS(4283),
    [anon_sym_GT_EQ] = ACTIONS(4283),
    [anon_sym_LT_EQ] = ACTIONS(4283),
    [anon_sym_DOT] = ACTIONS(4285),
    [anon_sym_scoped] = ACTIONS(4273),
    [anon_sym_var] = ACTIONS(4273),
    [anon_sym_yield] = ACTIONS(4273),
    [anon_sym_switch] = ACTIONS(4285),
    [anon_sym_when] = ACTIONS(4273),
    [sym_discard] = ACTIONS(4295),
    [anon_sym_DOT_DOT] = ACTIONS(4283),
    [anon_sym_and] = ACTIONS(4279),
    [anon_sym_or] = ACTIONS(4279),
    [anon_sym_AMP_AMP] = ACTIONS(4283),
    [anon_sym_PIPE_PIPE] = ACTIONS(4283),
    [anon_sym_QMARK_QMARK] = ACTIONS(4283),
    [anon_sym_from] = ACTIONS(4273),
    [anon_sym_into] = ACTIONS(4273),
    [anon_sym_join] = ACTIONS(4273),
    [anon_sym_on] = ACTIONS(4273),
    [anon_sym_equals] = ACTIONS(4273),
    [anon_sym_let] = ACTIONS(4273),
    [anon_sym_orderby] = ACTIONS(4273),
    [anon_sym_ascending] = ACTIONS(4273),
    [anon_sym_descending] = ACTIONS(4273),
    [anon_sym_group] = ACTIONS(4273),
    [anon_sym_by] = ACTIONS(4273),
    [anon_sym_select] = ACTIONS(4273),
    [anon_sym_as] = ACTIONS(4285),
    [anon_sym_is] = ACTIONS(4285),
    [anon_sym_DASH_GT] = ACTIONS(4283),
    [anon_sym_with] = ACTIONS(4285),
    [aux_sym_preproc_if_token3] = ACTIONS(4283),
    [aux_sym_preproc_else_token1] = ACTIONS(4283),
    [aux_sym_preproc_elif_token1] = ACTIONS(4283),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2802] = {
    [sym_preproc_region] = STATE(2802),
    [sym_preproc_endregion] = STATE(2802),
    [sym_preproc_line] = STATE(2802),
    [sym_preproc_pragma] = STATE(2802),
    [sym_preproc_nullable] = STATE(2802),
    [sym_preproc_error] = STATE(2802),
    [sym_preproc_define] = STATE(2802),
    [sym_preproc_undef] = STATE(2802),
    [sym__identifier_token] = ACTIONS(4113),
    [anon_sym_alias] = ACTIONS(4113),
    [anon_sym_SEMI] = ACTIONS(4133),
    [anon_sym_global] = ACTIONS(4113),
    [anon_sym_EQ] = ACTIONS(4118),
    [anon_sym_LBRACK] = ACTIONS(4135),
    [anon_sym_COLON] = ACTIONS(4133),
    [anon_sym_COMMA] = ACTIONS(4133),
    [anon_sym_RBRACK] = ACTIONS(4133),
    [anon_sym_LPAREN] = ACTIONS(4135),
    [anon_sym_RPAREN] = ACTIONS(4133),
    [anon_sym_RBRACE] = ACTIONS(4133),
    [anon_sym_file] = ACTIONS(4113),
    [anon_sym_LT] = ACTIONS(4118),
    [anon_sym_GT] = ACTIONS(4118),
    [anon_sym_where] = ACTIONS(4113),
    [anon_sym_QMARK] = ACTIONS(4138),
    [anon_sym_notnull] = ACTIONS(4113),
    [anon_sym_unmanaged] = ACTIONS(4113),
    [anon_sym_BANG] = ACTIONS(4118),
    [anon_sym_PLUS_PLUS] = ACTIONS(4133),
    [anon_sym_DASH_DASH] = ACTIONS(4133),
    [anon_sym_PLUS] = ACTIONS(4118),
    [anon_sym_DASH] = ACTIONS(4118),
    [anon_sym_STAR] = ACTIONS(4138),
    [anon_sym_SLASH] = ACTIONS(4118),
    [anon_sym_PERCENT] = ACTIONS(4118),
    [anon_sym_CARET] = ACTIONS(4118),
    [anon_sym_PIPE] = ACTIONS(4118),
    [anon_sym_AMP] = ACTIONS(4118),
    [anon_sym_LT_LT] = ACTIONS(4118),
    [anon_sym_GT_GT] = ACTIONS(4118),
    [anon_sym_GT_GT_GT] = ACTIONS(4118),
    [anon_sym_EQ_EQ] = ACTIONS(4133),
    [anon_sym_BANG_EQ] = ACTIONS(4133),
    [anon_sym_GT_EQ] = ACTIONS(4133),
    [anon_sym_LT_EQ] = ACTIONS(4133),
    [anon_sym_DOT] = ACTIONS(4138),
    [anon_sym_scoped] = ACTIONS(4113),
    [anon_sym_var] = ACTIONS(4113),
    [anon_sym_yield] = ACTIONS(4113),
    [anon_sym_switch] = ACTIONS(4118),
    [anon_sym_when] = ACTIONS(4113),
    [anon_sym_DOT_DOT] = ACTIONS(4133),
    [anon_sym_and] = ACTIONS(4118),
    [anon_sym_or] = ACTIONS(4118),
    [anon_sym_PLUS_EQ] = ACTIONS(4133),
    [anon_sym_DASH_EQ] = ACTIONS(4133),
    [anon_sym_STAR_EQ] = ACTIONS(4133),
    [anon_sym_SLASH_EQ] = ACTIONS(4133),
    [anon_sym_PERCENT_EQ] = ACTIONS(4133),
    [anon_sym_AMP_EQ] = ACTIONS(4133),
    [anon_sym_CARET_EQ] = ACTIONS(4133),
    [anon_sym_PIPE_EQ] = ACTIONS(4133),
    [anon_sym_LT_LT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4133),
    [anon_sym_AMP_AMP] = ACTIONS(4133),
    [anon_sym_PIPE_PIPE] = ACTIONS(4133),
    [anon_sym_QMARK_QMARK] = ACTIONS(4118),
    [anon_sym_from] = ACTIONS(4113),
    [anon_sym_into] = ACTIONS(4113),
    [anon_sym_join] = ACTIONS(4113),
    [anon_sym_on] = ACTIONS(4113),
    [anon_sym_equals] = ACTIONS(4113),
    [anon_sym_let] = ACTIONS(4113),
    [anon_sym_orderby] = ACTIONS(4113),
    [anon_sym_ascending] = ACTIONS(4113),
    [anon_sym_descending] = ACTIONS(4113),
    [anon_sym_group] = ACTIONS(4113),
    [anon_sym_by] = ACTIONS(4113),
    [anon_sym_select] = ACTIONS(4113),
    [anon_sym_as] = ACTIONS(4118),
    [anon_sym_is] = ACTIONS(4118),
    [anon_sym_DASH_GT] = ACTIONS(4135),
    [anon_sym_with] = ACTIONS(4118),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2803] = {
    [sym_parameter_list] = STATE(9765),
    [sym_positional_pattern_clause] = STATE(2840),
    [sym_property_pattern_clause] = STATE(2896),
    [sym__variable_designation] = STATE(4260),
    [sym_parenthesized_variable_designation] = STATE(4274),
    [sym__lambda_parameters] = STATE(9127),
    [sym_identifier] = STATE(4259),
    [sym__reserved_identifier] = STATE(3908),
    [sym_preproc_region] = STATE(2803),
    [sym_preproc_endregion] = STATE(2803),
    [sym_preproc_line] = STATE(2803),
    [sym_preproc_pragma] = STATE(2803),
    [sym_preproc_nullable] = STATE(2803),
    [sym_preproc_error] = STATE(2803),
    [sym_preproc_define] = STATE(2803),
    [sym_preproc_undef] = STATE(2803),
    [sym__identifier_token] = ACTIONS(4271),
    [anon_sym_alias] = ACTIONS(4273),
    [anon_sym_SEMI] = ACTIONS(4283),
    [anon_sym_global] = ACTIONS(4273),
    [anon_sym_LBRACK] = ACTIONS(4283),
    [anon_sym_COLON] = ACTIONS(4283),
    [anon_sym_COMMA] = ACTIONS(4283),
    [anon_sym_RBRACK] = ACTIONS(4283),
    [anon_sym_LPAREN] = ACTIONS(4283),
    [anon_sym_RPAREN] = ACTIONS(4283),
    [anon_sym_LBRACE] = ACTIONS(4277),
    [anon_sym_RBRACE] = ACTIONS(4283),
    [anon_sym_file] = ACTIONS(4273),
    [anon_sym_LT] = ACTIONS(4285),
    [anon_sym_GT] = ACTIONS(4285),
    [anon_sym_where] = ACTIONS(4273),
    [anon_sym_QMARK] = ACTIONS(4285),
    [anon_sym_notnull] = ACTIONS(4273),
    [anon_sym_unmanaged] = ACTIONS(4273),
    [anon_sym_BANG] = ACTIONS(4285),
    [anon_sym_PLUS_PLUS] = ACTIONS(4283),
    [anon_sym_DASH_DASH] = ACTIONS(4283),
    [anon_sym_PLUS] = ACTIONS(4285),
    [anon_sym_DASH] = ACTIONS(4285),
    [anon_sym_STAR] = ACTIONS(4283),
    [anon_sym_SLASH] = ACTIONS(4285),
    [anon_sym_PERCENT] = ACTIONS(4283),
    [anon_sym_CARET] = ACTIONS(4283),
    [anon_sym_PIPE] = ACTIONS(4285),
    [anon_sym_AMP] = ACTIONS(4285),
    [anon_sym_LT_LT] = ACTIONS(4283),
    [anon_sym_GT_GT] = ACTIONS(4285),
    [anon_sym_GT_GT_GT] = ACTIONS(4283),
    [anon_sym_EQ_EQ] = ACTIONS(4283),
    [anon_sym_BANG_EQ] = ACTIONS(4283),
    [anon_sym_GT_EQ] = ACTIONS(4283),
    [anon_sym_LT_EQ] = ACTIONS(4283),
    [anon_sym_DOT] = ACTIONS(4285),
    [anon_sym_scoped] = ACTIONS(4273),
    [anon_sym_var] = ACTIONS(4273),
    [anon_sym_yield] = ACTIONS(4273),
    [anon_sym_switch] = ACTIONS(4285),
    [anon_sym_when] = ACTIONS(4273),
    [sym_discard] = ACTIONS(4295),
    [anon_sym_DOT_DOT] = ACTIONS(4283),
    [anon_sym_and] = ACTIONS(4285),
    [anon_sym_or] = ACTIONS(4285),
    [anon_sym_AMP_AMP] = ACTIONS(4283),
    [anon_sym_PIPE_PIPE] = ACTIONS(4283),
    [anon_sym_QMARK_QMARK] = ACTIONS(4283),
    [anon_sym_from] = ACTIONS(4273),
    [anon_sym_into] = ACTIONS(4273),
    [anon_sym_join] = ACTIONS(4273),
    [anon_sym_on] = ACTIONS(4273),
    [anon_sym_equals] = ACTIONS(4273),
    [anon_sym_let] = ACTIONS(4273),
    [anon_sym_orderby] = ACTIONS(4273),
    [anon_sym_ascending] = ACTIONS(4273),
    [anon_sym_descending] = ACTIONS(4273),
    [anon_sym_group] = ACTIONS(4273),
    [anon_sym_by] = ACTIONS(4273),
    [anon_sym_select] = ACTIONS(4273),
    [anon_sym_as] = ACTIONS(4285),
    [anon_sym_is] = ACTIONS(4285),
    [anon_sym_DASH_GT] = ACTIONS(4283),
    [anon_sym_with] = ACTIONS(4285),
    [aux_sym_preproc_if_token3] = ACTIONS(4283),
    [aux_sym_preproc_else_token1] = ACTIONS(4283),
    [aux_sym_preproc_elif_token1] = ACTIONS(4283),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2804] = {
    [sym_attribute_list] = STATE(3753),
    [sym_modifier] = STATE(3780),
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(6995),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9545),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(2804),
    [sym_preproc_endregion] = STATE(2804),
    [sym_preproc_line] = STATE(2804),
    [sym_preproc_pragma] = STATE(2804),
    [sym_preproc_nullable] = STATE(2804),
    [sym_preproc_error] = STATE(2804),
    [sym_preproc_define] = STATE(2804),
    [sym_preproc_undef] = STATE(2804),
    [aux_sym_class_declaration_repeat1] = STATE(3584),
    [aux_sym_class_declaration_repeat2] = STATE(2950),
    [aux_sym_lambda_expression_repeat1] = STATE(4147),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_unsafe] = ACTIONS(63),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(2993),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_class] = ACTIONS(4311),
    [anon_sym_ref] = ACTIONS(4313),
    [anon_sym_struct] = ACTIONS(2691),
    [anon_sym_enum] = ACTIONS(4315),
    [anon_sym_interface] = ACTIONS(4317),
    [anon_sym_delegate] = ACTIONS(4319),
    [anon_sym_record] = ACTIONS(4321),
    [anon_sym_abstract] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(37),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_file] = ACTIONS(3015),
    [anon_sym_fixed] = ACTIONS(63),
    [anon_sym_internal] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(63),
    [anon_sym_override] = ACTIONS(63),
    [anon_sym_partial] = ACTIONS(63),
    [anon_sym_private] = ACTIONS(63),
    [anon_sym_protected] = ACTIONS(63),
    [anon_sym_public] = ACTIONS(63),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_required] = ACTIONS(63),
    [anon_sym_sealed] = ACTIONS(63),
    [anon_sym_virtual] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2805] = {
    [sym_preproc_region] = STATE(2805),
    [sym_preproc_endregion] = STATE(2805),
    [sym_preproc_line] = STATE(2805),
    [sym_preproc_pragma] = STATE(2805),
    [sym_preproc_nullable] = STATE(2805),
    [sym_preproc_error] = STATE(2805),
    [sym_preproc_define] = STATE(2805),
    [sym_preproc_undef] = STATE(2805),
    [sym__identifier_token] = ACTIONS(3721),
    [anon_sym_alias] = ACTIONS(3721),
    [anon_sym_global] = ACTIONS(3721),
    [anon_sym_EQ] = ACTIONS(3721),
    [anon_sym_LBRACK] = ACTIONS(3719),
    [anon_sym_COLON] = ACTIONS(3721),
    [anon_sym_LPAREN] = ACTIONS(3719),
    [anon_sym_return] = ACTIONS(4323),
    [anon_sym_file] = ACTIONS(3721),
    [anon_sym_LT] = ACTIONS(3721),
    [anon_sym_GT] = ACTIONS(3721),
    [anon_sym_where] = ACTIONS(3721),
    [anon_sym_QMARK] = ACTIONS(3721),
    [anon_sym_notnull] = ACTIONS(3721),
    [anon_sym_unmanaged] = ACTIONS(3721),
    [anon_sym_BANG] = ACTIONS(3721),
    [anon_sym_PLUS_PLUS] = ACTIONS(3719),
    [anon_sym_DASH_DASH] = ACTIONS(3719),
    [anon_sym_PLUS] = ACTIONS(3721),
    [anon_sym_DASH] = ACTIONS(3721),
    [anon_sym_STAR] = ACTIONS(3721),
    [anon_sym_SLASH] = ACTIONS(3721),
    [anon_sym_PERCENT] = ACTIONS(3721),
    [anon_sym_CARET] = ACTIONS(3721),
    [anon_sym_PIPE] = ACTIONS(3721),
    [anon_sym_AMP] = ACTIONS(3721),
    [anon_sym_LT_LT] = ACTIONS(3721),
    [anon_sym_GT_GT] = ACTIONS(3721),
    [anon_sym_GT_GT_GT] = ACTIONS(3721),
    [anon_sym_EQ_EQ] = ACTIONS(3719),
    [anon_sym_BANG_EQ] = ACTIONS(3719),
    [anon_sym_GT_EQ] = ACTIONS(3719),
    [anon_sym_LT_EQ] = ACTIONS(3719),
    [anon_sym_DOT] = ACTIONS(3721),
    [anon_sym_scoped] = ACTIONS(3721),
    [anon_sym_EQ_GT] = ACTIONS(3719),
    [anon_sym_COLON_COLON] = ACTIONS(3719),
    [anon_sym_var] = ACTIONS(3721),
    [anon_sym_break] = ACTIONS(4325),
    [anon_sym_yield] = ACTIONS(3721),
    [anon_sym_switch] = ACTIONS(3721),
    [anon_sym_when] = ACTIONS(3721),
    [anon_sym_DOT_DOT] = ACTIONS(3719),
    [anon_sym_PLUS_EQ] = ACTIONS(3719),
    [anon_sym_DASH_EQ] = ACTIONS(3719),
    [anon_sym_STAR_EQ] = ACTIONS(3719),
    [anon_sym_SLASH_EQ] = ACTIONS(3719),
    [anon_sym_PERCENT_EQ] = ACTIONS(3719),
    [anon_sym_AMP_EQ] = ACTIONS(3719),
    [anon_sym_CARET_EQ] = ACTIONS(3719),
    [anon_sym_PIPE_EQ] = ACTIONS(3719),
    [anon_sym_LT_LT_EQ] = ACTIONS(3719),
    [anon_sym_GT_GT_EQ] = ACTIONS(3719),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3719),
    [anon_sym_AMP_AMP] = ACTIONS(3719),
    [anon_sym_PIPE_PIPE] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK] = ACTIONS(3721),
    [anon_sym_from] = ACTIONS(3721),
    [anon_sym_into] = ACTIONS(3721),
    [anon_sym_join] = ACTIONS(3721),
    [anon_sym_on] = ACTIONS(3721),
    [anon_sym_equals] = ACTIONS(3721),
    [anon_sym_let] = ACTIONS(3721),
    [anon_sym_orderby] = ACTIONS(3721),
    [anon_sym_ascending] = ACTIONS(3721),
    [anon_sym_descending] = ACTIONS(3721),
    [anon_sym_group] = ACTIONS(3721),
    [anon_sym_by] = ACTIONS(3721),
    [anon_sym_select] = ACTIONS(3721),
    [anon_sym_as] = ACTIONS(3721),
    [anon_sym_is] = ACTIONS(3721),
    [anon_sym_DASH_GT] = ACTIONS(3719),
    [anon_sym_with] = ACTIONS(3721),
    [aux_sym_preproc_if_token3] = ACTIONS(3719),
    [aux_sym_preproc_else_token1] = ACTIONS(3719),
    [aux_sym_preproc_elif_token1] = ACTIONS(3719),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2806] = {
    [sym_preproc_region] = STATE(2806),
    [sym_preproc_endregion] = STATE(2806),
    [sym_preproc_line] = STATE(2806),
    [sym_preproc_pragma] = STATE(2806),
    [sym_preproc_nullable] = STATE(2806),
    [sym_preproc_error] = STATE(2806),
    [sym_preproc_define] = STATE(2806),
    [sym_preproc_undef] = STATE(2806),
    [sym__identifier_token] = ACTIONS(3721),
    [anon_sym_alias] = ACTIONS(3721),
    [anon_sym_global] = ACTIONS(3721),
    [anon_sym_EQ] = ACTIONS(3721),
    [anon_sym_LBRACK] = ACTIONS(3719),
    [anon_sym_COLON] = ACTIONS(3719),
    [anon_sym_COMMA] = ACTIONS(3719),
    [anon_sym_LPAREN] = ACTIONS(3719),
    [anon_sym_RPAREN] = ACTIONS(3719),
    [anon_sym_LBRACE] = ACTIONS(3719),
    [anon_sym_RBRACE] = ACTIONS(3719),
    [anon_sym_file] = ACTIONS(3721),
    [anon_sym_LT] = ACTIONS(3721),
    [anon_sym_GT] = ACTIONS(3721),
    [anon_sym_where] = ACTIONS(3721),
    [anon_sym_QMARK] = ACTIONS(3721),
    [anon_sym_notnull] = ACTIONS(3721),
    [anon_sym_unmanaged] = ACTIONS(3721),
    [anon_sym_BANG] = ACTIONS(3721),
    [anon_sym_PLUS_PLUS] = ACTIONS(3719),
    [anon_sym_DASH_DASH] = ACTIONS(3719),
    [anon_sym_PLUS] = ACTIONS(3721),
    [anon_sym_DASH] = ACTIONS(3721),
    [anon_sym_STAR] = ACTIONS(3721),
    [anon_sym_SLASH] = ACTIONS(3721),
    [anon_sym_PERCENT] = ACTIONS(3721),
    [anon_sym_CARET] = ACTIONS(3721),
    [anon_sym_PIPE] = ACTIONS(3721),
    [anon_sym_AMP] = ACTIONS(3721),
    [anon_sym_LT_LT] = ACTIONS(3721),
    [anon_sym_GT_GT] = ACTIONS(3721),
    [anon_sym_GT_GT_GT] = ACTIONS(3721),
    [anon_sym_EQ_EQ] = ACTIONS(3719),
    [anon_sym_BANG_EQ] = ACTIONS(3719),
    [anon_sym_GT_EQ] = ACTIONS(3719),
    [anon_sym_LT_EQ] = ACTIONS(3719),
    [anon_sym_DOT] = ACTIONS(3721),
    [anon_sym_scoped] = ACTIONS(3721),
    [anon_sym_var] = ACTIONS(3721),
    [anon_sym_yield] = ACTIONS(3721),
    [anon_sym_switch] = ACTIONS(3721),
    [anon_sym_when] = ACTIONS(3721),
    [sym_discard] = ACTIONS(3721),
    [anon_sym_DOT_DOT] = ACTIONS(3719),
    [anon_sym_and] = ACTIONS(3721),
    [anon_sym_or] = ACTIONS(3721),
    [anon_sym_PLUS_EQ] = ACTIONS(3719),
    [anon_sym_DASH_EQ] = ACTIONS(3719),
    [anon_sym_STAR_EQ] = ACTIONS(3719),
    [anon_sym_SLASH_EQ] = ACTIONS(3719),
    [anon_sym_PERCENT_EQ] = ACTIONS(3719),
    [anon_sym_AMP_EQ] = ACTIONS(3719),
    [anon_sym_CARET_EQ] = ACTIONS(3719),
    [anon_sym_PIPE_EQ] = ACTIONS(3719),
    [anon_sym_LT_LT_EQ] = ACTIONS(3719),
    [anon_sym_GT_GT_EQ] = ACTIONS(3719),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3719),
    [anon_sym_AMP_AMP] = ACTIONS(3719),
    [anon_sym_PIPE_PIPE] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK] = ACTIONS(3721),
    [anon_sym_from] = ACTIONS(3721),
    [anon_sym_into] = ACTIONS(3721),
    [anon_sym_join] = ACTIONS(3721),
    [anon_sym_on] = ACTIONS(3721),
    [anon_sym_equals] = ACTIONS(3721),
    [anon_sym_let] = ACTIONS(3721),
    [anon_sym_orderby] = ACTIONS(3721),
    [anon_sym_ascending] = ACTIONS(3721),
    [anon_sym_descending] = ACTIONS(3721),
    [anon_sym_group] = ACTIONS(3721),
    [anon_sym_by] = ACTIONS(3721),
    [anon_sym_select] = ACTIONS(3721),
    [anon_sym_as] = ACTIONS(3721),
    [anon_sym_is] = ACTIONS(3721),
    [anon_sym_DASH_GT] = ACTIONS(3719),
    [anon_sym_with] = ACTIONS(3721),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2807] = {
    [sym_preproc_region] = STATE(2807),
    [sym_preproc_endregion] = STATE(2807),
    [sym_preproc_line] = STATE(2807),
    [sym_preproc_pragma] = STATE(2807),
    [sym_preproc_nullable] = STATE(2807),
    [sym_preproc_error] = STATE(2807),
    [sym_preproc_define] = STATE(2807),
    [sym_preproc_undef] = STATE(2807),
    [sym__identifier_token] = ACTIONS(4099),
    [anon_sym_alias] = ACTIONS(4099),
    [anon_sym_global] = ACTIONS(4099),
    [anon_sym_EQ] = ACTIONS(4104),
    [anon_sym_LBRACK] = ACTIONS(4101),
    [anon_sym_COLON] = ACTIONS(4101),
    [anon_sym_COMMA] = ACTIONS(4101),
    [anon_sym_LPAREN] = ACTIONS(4101),
    [anon_sym_LBRACE] = ACTIONS(4106),
    [anon_sym_file] = ACTIONS(4099),
    [anon_sym_LT] = ACTIONS(4108),
    [anon_sym_GT] = ACTIONS(4108),
    [anon_sym_where] = ACTIONS(4099),
    [anon_sym_QMARK] = ACTIONS(4108),
    [anon_sym_notnull] = ACTIONS(4099),
    [anon_sym_unmanaged] = ACTIONS(4099),
    [anon_sym_BANG] = ACTIONS(4108),
    [anon_sym_PLUS_PLUS] = ACTIONS(4101),
    [anon_sym_DASH_DASH] = ACTIONS(4101),
    [anon_sym_PLUS] = ACTIONS(4108),
    [anon_sym_DASH] = ACTIONS(4108),
    [anon_sym_STAR] = ACTIONS(4108),
    [anon_sym_SLASH] = ACTIONS(4108),
    [anon_sym_PERCENT] = ACTIONS(4108),
    [anon_sym_CARET] = ACTIONS(4108),
    [anon_sym_PIPE] = ACTIONS(4108),
    [anon_sym_AMP] = ACTIONS(4108),
    [anon_sym_LT_LT] = ACTIONS(4108),
    [anon_sym_GT_GT] = ACTIONS(4108),
    [anon_sym_GT_GT_GT] = ACTIONS(4108),
    [anon_sym_EQ_EQ] = ACTIONS(4101),
    [anon_sym_BANG_EQ] = ACTIONS(4101),
    [anon_sym_GT_EQ] = ACTIONS(4101),
    [anon_sym_LT_EQ] = ACTIONS(4101),
    [anon_sym_DOT] = ACTIONS(4108),
    [anon_sym_scoped] = ACTIONS(4099),
    [anon_sym_var] = ACTIONS(4099),
    [anon_sym_yield] = ACTIONS(4099),
    [anon_sym_switch] = ACTIONS(4108),
    [anon_sym_when] = ACTIONS(4099),
    [sym_discard] = ACTIONS(4099),
    [anon_sym_DOT_DOT] = ACTIONS(4101),
    [anon_sym_and] = ACTIONS(4108),
    [anon_sym_or] = ACTIONS(4108),
    [anon_sym_PLUS_EQ] = ACTIONS(4111),
    [anon_sym_DASH_EQ] = ACTIONS(4111),
    [anon_sym_STAR_EQ] = ACTIONS(4111),
    [anon_sym_SLASH_EQ] = ACTIONS(4111),
    [anon_sym_PERCENT_EQ] = ACTIONS(4111),
    [anon_sym_AMP_EQ] = ACTIONS(4111),
    [anon_sym_CARET_EQ] = ACTIONS(4111),
    [anon_sym_PIPE_EQ] = ACTIONS(4111),
    [anon_sym_LT_LT_EQ] = ACTIONS(4111),
    [anon_sym_GT_GT_EQ] = ACTIONS(4111),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4111),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4111),
    [anon_sym_AMP_AMP] = ACTIONS(4101),
    [anon_sym_PIPE_PIPE] = ACTIONS(4101),
    [anon_sym_QMARK_QMARK] = ACTIONS(4108),
    [anon_sym_from] = ACTIONS(4099),
    [anon_sym_into] = ACTIONS(4099),
    [anon_sym_join] = ACTIONS(4099),
    [anon_sym_on] = ACTIONS(4099),
    [anon_sym_equals] = ACTIONS(4099),
    [anon_sym_let] = ACTIONS(4099),
    [anon_sym_orderby] = ACTIONS(4099),
    [anon_sym_ascending] = ACTIONS(4099),
    [anon_sym_descending] = ACTIONS(4099),
    [anon_sym_group] = ACTIONS(4099),
    [anon_sym_by] = ACTIONS(4099),
    [anon_sym_select] = ACTIONS(4099),
    [anon_sym_as] = ACTIONS(4108),
    [anon_sym_is] = ACTIONS(4108),
    [anon_sym_DASH_GT] = ACTIONS(4101),
    [anon_sym_with] = ACTIONS(4108),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4101),
  },
  [2808] = {
    [sym_preproc_region] = STATE(2808),
    [sym_preproc_endregion] = STATE(2808),
    [sym_preproc_line] = STATE(2808),
    [sym_preproc_pragma] = STATE(2808),
    [sym_preproc_nullable] = STATE(2808),
    [sym_preproc_error] = STATE(2808),
    [sym_preproc_define] = STATE(2808),
    [sym_preproc_undef] = STATE(2808),
    [sym__identifier_token] = ACTIONS(3721),
    [anon_sym_alias] = ACTIONS(3721),
    [anon_sym_global] = ACTIONS(3721),
    [anon_sym_using] = ACTIONS(4327),
    [anon_sym_EQ] = ACTIONS(3721),
    [anon_sym_LBRACK] = ACTIONS(3719),
    [anon_sym_COLON] = ACTIONS(3721),
    [anon_sym_LPAREN] = ACTIONS(3719),
    [anon_sym_file] = ACTIONS(3721),
    [anon_sym_LT] = ACTIONS(3721),
    [anon_sym_GT] = ACTIONS(3721),
    [anon_sym_where] = ACTIONS(3721),
    [anon_sym_QMARK] = ACTIONS(3721),
    [anon_sym_notnull] = ACTIONS(3721),
    [anon_sym_unmanaged] = ACTIONS(3721),
    [anon_sym_BANG] = ACTIONS(3721),
    [anon_sym_PLUS_PLUS] = ACTIONS(3719),
    [anon_sym_DASH_DASH] = ACTIONS(3719),
    [anon_sym_PLUS] = ACTIONS(3721),
    [anon_sym_DASH] = ACTIONS(3721),
    [anon_sym_STAR] = ACTIONS(3721),
    [anon_sym_SLASH] = ACTIONS(3721),
    [anon_sym_PERCENT] = ACTIONS(3721),
    [anon_sym_CARET] = ACTIONS(3721),
    [anon_sym_PIPE] = ACTIONS(3721),
    [anon_sym_AMP] = ACTIONS(3721),
    [anon_sym_LT_LT] = ACTIONS(3721),
    [anon_sym_GT_GT] = ACTIONS(3721),
    [anon_sym_GT_GT_GT] = ACTIONS(3721),
    [anon_sym_EQ_EQ] = ACTIONS(3719),
    [anon_sym_BANG_EQ] = ACTIONS(3719),
    [anon_sym_GT_EQ] = ACTIONS(3719),
    [anon_sym_LT_EQ] = ACTIONS(3719),
    [anon_sym_DOT] = ACTIONS(3721),
    [anon_sym_scoped] = ACTIONS(3721),
    [anon_sym_EQ_GT] = ACTIONS(3719),
    [anon_sym_COLON_COLON] = ACTIONS(3719),
    [anon_sym_var] = ACTIONS(3721),
    [anon_sym_yield] = ACTIONS(3721),
    [anon_sym_switch] = ACTIONS(3721),
    [anon_sym_when] = ACTIONS(3721),
    [anon_sym_DOT_DOT] = ACTIONS(3719),
    [anon_sym_PLUS_EQ] = ACTIONS(3719),
    [anon_sym_DASH_EQ] = ACTIONS(3719),
    [anon_sym_STAR_EQ] = ACTIONS(3719),
    [anon_sym_SLASH_EQ] = ACTIONS(3719),
    [anon_sym_PERCENT_EQ] = ACTIONS(3719),
    [anon_sym_AMP_EQ] = ACTIONS(3719),
    [anon_sym_CARET_EQ] = ACTIONS(3719),
    [anon_sym_PIPE_EQ] = ACTIONS(3719),
    [anon_sym_LT_LT_EQ] = ACTIONS(3719),
    [anon_sym_GT_GT_EQ] = ACTIONS(3719),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3719),
    [anon_sym_AMP_AMP] = ACTIONS(3719),
    [anon_sym_PIPE_PIPE] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK] = ACTIONS(3721),
    [anon_sym_from] = ACTIONS(3721),
    [anon_sym_into] = ACTIONS(3721),
    [anon_sym_join] = ACTIONS(3721),
    [anon_sym_on] = ACTIONS(3721),
    [anon_sym_equals] = ACTIONS(3721),
    [anon_sym_let] = ACTIONS(3721),
    [anon_sym_orderby] = ACTIONS(3721),
    [anon_sym_ascending] = ACTIONS(3721),
    [anon_sym_descending] = ACTIONS(3721),
    [anon_sym_group] = ACTIONS(3721),
    [anon_sym_by] = ACTIONS(3721),
    [anon_sym_select] = ACTIONS(3721),
    [anon_sym_as] = ACTIONS(3721),
    [anon_sym_is] = ACTIONS(3721),
    [anon_sym_DASH_GT] = ACTIONS(3719),
    [anon_sym_with] = ACTIONS(3721),
    [aux_sym_preproc_if_token3] = ACTIONS(3719),
    [aux_sym_preproc_else_token1] = ACTIONS(3719),
    [aux_sym_preproc_elif_token1] = ACTIONS(3719),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2809] = {
    [sym_property_pattern_clause] = STATE(2853),
    [sym__variable_designation] = STATE(4023),
    [sym_parenthesized_variable_designation] = STATE(4015),
    [sym_identifier] = STATE(4020),
    [sym__reserved_identifier] = STATE(3908),
    [sym_preproc_region] = STATE(2809),
    [sym_preproc_endregion] = STATE(2809),
    [sym_preproc_line] = STATE(2809),
    [sym_preproc_pragma] = STATE(2809),
    [sym_preproc_nullable] = STATE(2809),
    [sym_preproc_error] = STATE(2809),
    [sym_preproc_define] = STATE(2809),
    [sym_preproc_undef] = STATE(2809),
    [sym__identifier_token] = ACTIONS(4271),
    [anon_sym_alias] = ACTIONS(4273),
    [anon_sym_SEMI] = ACTIONS(4329),
    [anon_sym_global] = ACTIONS(4273),
    [anon_sym_LBRACK] = ACTIONS(4329),
    [anon_sym_COLON] = ACTIONS(4329),
    [anon_sym_COMMA] = ACTIONS(4329),
    [anon_sym_RBRACK] = ACTIONS(4329),
    [anon_sym_LPAREN] = ACTIONS(4329),
    [anon_sym_RPAREN] = ACTIONS(4329),
    [anon_sym_LBRACE] = ACTIONS(4277),
    [anon_sym_RBRACE] = ACTIONS(4329),
    [anon_sym_file] = ACTIONS(4273),
    [anon_sym_LT] = ACTIONS(4331),
    [anon_sym_GT] = ACTIONS(4331),
    [anon_sym_in] = ACTIONS(4331),
    [anon_sym_where] = ACTIONS(4273),
    [anon_sym_QMARK] = ACTIONS(4331),
    [anon_sym_notnull] = ACTIONS(4273),
    [anon_sym_unmanaged] = ACTIONS(4273),
    [anon_sym_BANG] = ACTIONS(4331),
    [anon_sym_PLUS_PLUS] = ACTIONS(4329),
    [anon_sym_DASH_DASH] = ACTIONS(4329),
    [anon_sym_PLUS] = ACTIONS(4331),
    [anon_sym_DASH] = ACTIONS(4331),
    [anon_sym_STAR] = ACTIONS(4329),
    [anon_sym_SLASH] = ACTIONS(4331),
    [anon_sym_PERCENT] = ACTIONS(4329),
    [anon_sym_CARET] = ACTIONS(4329),
    [anon_sym_PIPE] = ACTIONS(4331),
    [anon_sym_AMP] = ACTIONS(4331),
    [anon_sym_LT_LT] = ACTIONS(4329),
    [anon_sym_GT_GT] = ACTIONS(4331),
    [anon_sym_GT_GT_GT] = ACTIONS(4329),
    [anon_sym_EQ_EQ] = ACTIONS(4329),
    [anon_sym_BANG_EQ] = ACTIONS(4329),
    [anon_sym_GT_EQ] = ACTIONS(4329),
    [anon_sym_LT_EQ] = ACTIONS(4329),
    [anon_sym_DOT] = ACTIONS(4331),
    [anon_sym_scoped] = ACTIONS(4273),
    [anon_sym_EQ_GT] = ACTIONS(4329),
    [anon_sym_var] = ACTIONS(4273),
    [anon_sym_yield] = ACTIONS(4273),
    [anon_sym_switch] = ACTIONS(4331),
    [anon_sym_when] = ACTIONS(4273),
    [sym_discard] = ACTIONS(4281),
    [anon_sym_DOT_DOT] = ACTIONS(4329),
    [anon_sym_and] = ACTIONS(4331),
    [anon_sym_or] = ACTIONS(4331),
    [anon_sym_AMP_AMP] = ACTIONS(4329),
    [anon_sym_PIPE_PIPE] = ACTIONS(4329),
    [anon_sym_QMARK_QMARK] = ACTIONS(4329),
    [anon_sym_from] = ACTIONS(4273),
    [anon_sym_into] = ACTIONS(4331),
    [anon_sym_join] = ACTIONS(4273),
    [anon_sym_on] = ACTIONS(4273),
    [anon_sym_equals] = ACTIONS(4273),
    [anon_sym_let] = ACTIONS(4273),
    [anon_sym_orderby] = ACTIONS(4273),
    [anon_sym_ascending] = ACTIONS(4273),
    [anon_sym_descending] = ACTIONS(4273),
    [anon_sym_group] = ACTIONS(4273),
    [anon_sym_by] = ACTIONS(4273),
    [anon_sym_select] = ACTIONS(4273),
    [anon_sym_as] = ACTIONS(4331),
    [anon_sym_is] = ACTIONS(4331),
    [anon_sym_DASH_GT] = ACTIONS(4329),
    [anon_sym_with] = ACTIONS(4331),
    [aux_sym_preproc_if_token3] = ACTIONS(4329),
    [aux_sym_preproc_else_token1] = ACTIONS(4329),
    [aux_sym_preproc_elif_token1] = ACTIONS(4329),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2810] = {
    [sym_type_argument_list] = STATE(2736),
    [sym_preproc_region] = STATE(2810),
    [sym_preproc_endregion] = STATE(2810),
    [sym_preproc_line] = STATE(2810),
    [sym_preproc_pragma] = STATE(2810),
    [sym_preproc_nullable] = STATE(2810),
    [sym_preproc_error] = STATE(2810),
    [sym_preproc_define] = STATE(2810),
    [sym_preproc_undef] = STATE(2810),
    [sym__identifier_token] = ACTIONS(4074),
    [anon_sym_alias] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4074),
    [anon_sym_EQ] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4076),
    [anon_sym_LPAREN] = ACTIONS(4076),
    [anon_sym_LBRACE] = ACTIONS(4076),
    [anon_sym_file] = ACTIONS(4074),
    [anon_sym_LT] = ACTIONS(4078),
    [anon_sym_GT] = ACTIONS(4074),
    [anon_sym_where] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(4074),
    [anon_sym_notnull] = ACTIONS(4074),
    [anon_sym_unmanaged] = ACTIONS(4074),
    [anon_sym_BANG] = ACTIONS(4074),
    [anon_sym_PLUS_PLUS] = ACTIONS(4076),
    [anon_sym_DASH_DASH] = ACTIONS(4076),
    [anon_sym_PLUS] = ACTIONS(4074),
    [anon_sym_DASH] = ACTIONS(4074),
    [anon_sym_STAR] = ACTIONS(4074),
    [anon_sym_SLASH] = ACTIONS(4074),
    [anon_sym_PERCENT] = ACTIONS(4074),
    [anon_sym_CARET] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(4074),
    [anon_sym_AMP] = ACTIONS(4074),
    [anon_sym_LT_LT] = ACTIONS(4074),
    [anon_sym_GT_GT] = ACTIONS(4074),
    [anon_sym_GT_GT_GT] = ACTIONS(4074),
    [anon_sym_EQ_EQ] = ACTIONS(4076),
    [anon_sym_BANG_EQ] = ACTIONS(4076),
    [anon_sym_GT_EQ] = ACTIONS(4076),
    [anon_sym_LT_EQ] = ACTIONS(4076),
    [anon_sym_DOT] = ACTIONS(4074),
    [anon_sym_scoped] = ACTIONS(4074),
    [anon_sym_EQ_GT] = ACTIONS(4076),
    [anon_sym_COLON_COLON] = ACTIONS(4089),
    [anon_sym_var] = ACTIONS(4074),
    [anon_sym_yield] = ACTIONS(4074),
    [anon_sym_switch] = ACTIONS(4074),
    [anon_sym_when] = ACTIONS(4074),
    [sym_discard] = ACTIONS(4074),
    [anon_sym_DOT_DOT] = ACTIONS(4076),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_PLUS_EQ] = ACTIONS(4076),
    [anon_sym_DASH_EQ] = ACTIONS(4076),
    [anon_sym_STAR_EQ] = ACTIONS(4076),
    [anon_sym_SLASH_EQ] = ACTIONS(4076),
    [anon_sym_PERCENT_EQ] = ACTIONS(4076),
    [anon_sym_AMP_EQ] = ACTIONS(4076),
    [anon_sym_CARET_EQ] = ACTIONS(4076),
    [anon_sym_PIPE_EQ] = ACTIONS(4076),
    [anon_sym_LT_LT_EQ] = ACTIONS(4076),
    [anon_sym_GT_GT_EQ] = ACTIONS(4076),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4076),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4076),
    [anon_sym_AMP_AMP] = ACTIONS(4076),
    [anon_sym_PIPE_PIPE] = ACTIONS(4076),
    [anon_sym_QMARK_QMARK] = ACTIONS(4074),
    [anon_sym_from] = ACTIONS(4074),
    [anon_sym_into] = ACTIONS(4074),
    [anon_sym_join] = ACTIONS(4074),
    [anon_sym_on] = ACTIONS(4074),
    [anon_sym_equals] = ACTIONS(4074),
    [anon_sym_let] = ACTIONS(4074),
    [anon_sym_orderby] = ACTIONS(4074),
    [anon_sym_ascending] = ACTIONS(4074),
    [anon_sym_descending] = ACTIONS(4074),
    [anon_sym_group] = ACTIONS(4074),
    [anon_sym_by] = ACTIONS(4074),
    [anon_sym_select] = ACTIONS(4074),
    [anon_sym_as] = ACTIONS(4074),
    [anon_sym_is] = ACTIONS(4074),
    [anon_sym_DASH_GT] = ACTIONS(4076),
    [anon_sym_with] = ACTIONS(4074),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2811] = {
    [sym_preproc_region] = STATE(2811),
    [sym_preproc_endregion] = STATE(2811),
    [sym_preproc_line] = STATE(2811),
    [sym_preproc_pragma] = STATE(2811),
    [sym_preproc_nullable] = STATE(2811),
    [sym_preproc_error] = STATE(2811),
    [sym_preproc_define] = STATE(2811),
    [sym_preproc_undef] = STATE(2811),
    [sym__identifier_token] = ACTIONS(4113),
    [anon_sym_alias] = ACTIONS(4113),
    [anon_sym_global] = ACTIONS(4113),
    [anon_sym_EQ] = ACTIONS(4118),
    [anon_sym_LBRACK] = ACTIONS(4135),
    [anon_sym_COLON] = ACTIONS(4133),
    [anon_sym_COMMA] = ACTIONS(4124),
    [anon_sym_LPAREN] = ACTIONS(4135),
    [anon_sym_RPAREN] = ACTIONS(4124),
    [anon_sym_LBRACE] = ACTIONS(4124),
    [anon_sym_file] = ACTIONS(4113),
    [anon_sym_LT] = ACTIONS(4118),
    [anon_sym_GT] = ACTIONS(4118),
    [anon_sym_where] = ACTIONS(4113),
    [anon_sym_QMARK] = ACTIONS(4138),
    [anon_sym_notnull] = ACTIONS(4113),
    [anon_sym_unmanaged] = ACTIONS(4113),
    [anon_sym_BANG] = ACTIONS(4118),
    [anon_sym_PLUS_PLUS] = ACTIONS(4133),
    [anon_sym_DASH_DASH] = ACTIONS(4133),
    [anon_sym_PLUS] = ACTIONS(4118),
    [anon_sym_DASH] = ACTIONS(4118),
    [anon_sym_STAR] = ACTIONS(4138),
    [anon_sym_SLASH] = ACTIONS(4118),
    [anon_sym_PERCENT] = ACTIONS(4118),
    [anon_sym_CARET] = ACTIONS(4118),
    [anon_sym_PIPE] = ACTIONS(4118),
    [anon_sym_AMP] = ACTIONS(4118),
    [anon_sym_LT_LT] = ACTIONS(4118),
    [anon_sym_GT_GT] = ACTIONS(4118),
    [anon_sym_GT_GT_GT] = ACTIONS(4118),
    [anon_sym_EQ_EQ] = ACTIONS(4133),
    [anon_sym_BANG_EQ] = ACTIONS(4133),
    [anon_sym_GT_EQ] = ACTIONS(4133),
    [anon_sym_LT_EQ] = ACTIONS(4133),
    [anon_sym_DOT] = ACTIONS(4138),
    [anon_sym_scoped] = ACTIONS(4113),
    [anon_sym_var] = ACTIONS(4113),
    [anon_sym_yield] = ACTIONS(4113),
    [anon_sym_switch] = ACTIONS(4118),
    [anon_sym_when] = ACTIONS(4113),
    [sym_discard] = ACTIONS(4113),
    [anon_sym_DOT_DOT] = ACTIONS(4133),
    [anon_sym_and] = ACTIONS(4113),
    [anon_sym_or] = ACTIONS(4113),
    [anon_sym_PLUS_EQ] = ACTIONS(4133),
    [anon_sym_DASH_EQ] = ACTIONS(4133),
    [anon_sym_STAR_EQ] = ACTIONS(4133),
    [anon_sym_SLASH_EQ] = ACTIONS(4133),
    [anon_sym_PERCENT_EQ] = ACTIONS(4133),
    [anon_sym_AMP_EQ] = ACTIONS(4133),
    [anon_sym_CARET_EQ] = ACTIONS(4133),
    [anon_sym_PIPE_EQ] = ACTIONS(4133),
    [anon_sym_LT_LT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4133),
    [anon_sym_AMP_AMP] = ACTIONS(4133),
    [anon_sym_PIPE_PIPE] = ACTIONS(4133),
    [anon_sym_QMARK_QMARK] = ACTIONS(4118),
    [anon_sym_from] = ACTIONS(4113),
    [anon_sym_into] = ACTIONS(4113),
    [anon_sym_join] = ACTIONS(4113),
    [anon_sym_on] = ACTIONS(4113),
    [anon_sym_equals] = ACTIONS(4113),
    [anon_sym_let] = ACTIONS(4113),
    [anon_sym_orderby] = ACTIONS(4113),
    [anon_sym_ascending] = ACTIONS(4113),
    [anon_sym_descending] = ACTIONS(4113),
    [anon_sym_group] = ACTIONS(4113),
    [anon_sym_by] = ACTIONS(4113),
    [anon_sym_select] = ACTIONS(4113),
    [anon_sym_as] = ACTIONS(4118),
    [anon_sym_is] = ACTIONS(4118),
    [anon_sym_DASH_GT] = ACTIONS(4135),
    [anon_sym_with] = ACTIONS(4118),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2812] = {
    [sym_preproc_region] = STATE(2812),
    [sym_preproc_endregion] = STATE(2812),
    [sym_preproc_line] = STATE(2812),
    [sym_preproc_pragma] = STATE(2812),
    [sym_preproc_nullable] = STATE(2812),
    [sym_preproc_error] = STATE(2812),
    [sym_preproc_define] = STATE(2812),
    [sym_preproc_undef] = STATE(2812),
    [sym__identifier_token] = ACTIONS(4099),
    [anon_sym_alias] = ACTIONS(4099),
    [anon_sym_global] = ACTIONS(4099),
    [anon_sym_EQ] = ACTIONS(4104),
    [anon_sym_LBRACK] = ACTIONS(4101),
    [anon_sym_COLON] = ACTIONS(4106),
    [anon_sym_COMMA] = ACTIONS(4106),
    [anon_sym_LPAREN] = ACTIONS(4101),
    [anon_sym_LBRACE] = ACTIONS(4106),
    [anon_sym_file] = ACTIONS(4099),
    [anon_sym_LT] = ACTIONS(4108),
    [anon_sym_GT] = ACTIONS(4108),
    [anon_sym_where] = ACTIONS(4099),
    [anon_sym_QMARK] = ACTIONS(4108),
    [anon_sym_notnull] = ACTIONS(4099),
    [anon_sym_unmanaged] = ACTIONS(4099),
    [anon_sym_BANG] = ACTIONS(4108),
    [anon_sym_PLUS_PLUS] = ACTIONS(4101),
    [anon_sym_DASH_DASH] = ACTIONS(4101),
    [anon_sym_PLUS] = ACTIONS(4108),
    [anon_sym_DASH] = ACTIONS(4108),
    [anon_sym_STAR] = ACTIONS(4108),
    [anon_sym_SLASH] = ACTIONS(4108),
    [anon_sym_PERCENT] = ACTIONS(4108),
    [anon_sym_CARET] = ACTIONS(4108),
    [anon_sym_PIPE] = ACTIONS(4108),
    [anon_sym_AMP] = ACTIONS(4108),
    [anon_sym_LT_LT] = ACTIONS(4108),
    [anon_sym_GT_GT] = ACTIONS(4108),
    [anon_sym_GT_GT_GT] = ACTIONS(4108),
    [anon_sym_EQ_EQ] = ACTIONS(4101),
    [anon_sym_BANG_EQ] = ACTIONS(4101),
    [anon_sym_GT_EQ] = ACTIONS(4101),
    [anon_sym_LT_EQ] = ACTIONS(4101),
    [anon_sym_DOT] = ACTIONS(4108),
    [anon_sym_scoped] = ACTIONS(4099),
    [anon_sym_var] = ACTIONS(4099),
    [anon_sym_yield] = ACTIONS(4099),
    [anon_sym_switch] = ACTIONS(4108),
    [anon_sym_when] = ACTIONS(4099),
    [sym_discard] = ACTIONS(4099),
    [anon_sym_DOT_DOT] = ACTIONS(4101),
    [anon_sym_and] = ACTIONS(4099),
    [anon_sym_or] = ACTIONS(4099),
    [anon_sym_PLUS_EQ] = ACTIONS(4111),
    [anon_sym_DASH_EQ] = ACTIONS(4111),
    [anon_sym_STAR_EQ] = ACTIONS(4111),
    [anon_sym_SLASH_EQ] = ACTIONS(4111),
    [anon_sym_PERCENT_EQ] = ACTIONS(4111),
    [anon_sym_AMP_EQ] = ACTIONS(4111),
    [anon_sym_CARET_EQ] = ACTIONS(4111),
    [anon_sym_PIPE_EQ] = ACTIONS(4111),
    [anon_sym_LT_LT_EQ] = ACTIONS(4111),
    [anon_sym_GT_GT_EQ] = ACTIONS(4111),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4111),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4111),
    [anon_sym_AMP_AMP] = ACTIONS(4101),
    [anon_sym_PIPE_PIPE] = ACTIONS(4101),
    [anon_sym_QMARK_QMARK] = ACTIONS(4108),
    [anon_sym_from] = ACTIONS(4099),
    [anon_sym_into] = ACTIONS(4099),
    [anon_sym_join] = ACTIONS(4099),
    [anon_sym_on] = ACTIONS(4099),
    [anon_sym_equals] = ACTIONS(4099),
    [anon_sym_let] = ACTIONS(4099),
    [anon_sym_orderby] = ACTIONS(4099),
    [anon_sym_ascending] = ACTIONS(4099),
    [anon_sym_descending] = ACTIONS(4099),
    [anon_sym_group] = ACTIONS(4099),
    [anon_sym_by] = ACTIONS(4099),
    [anon_sym_select] = ACTIONS(4099),
    [anon_sym_as] = ACTIONS(4108),
    [anon_sym_is] = ACTIONS(4108),
    [anon_sym_DASH_GT] = ACTIONS(4101),
    [anon_sym_with] = ACTIONS(4108),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4106),
  },
  [2813] = {
    [sym_preproc_region] = STATE(2813),
    [sym_preproc_endregion] = STATE(2813),
    [sym_preproc_line] = STATE(2813),
    [sym_preproc_pragma] = STATE(2813),
    [sym_preproc_nullable] = STATE(2813),
    [sym_preproc_error] = STATE(2813),
    [sym_preproc_define] = STATE(2813),
    [sym_preproc_undef] = STATE(2813),
    [sym__identifier_token] = ACTIONS(4074),
    [anon_sym_alias] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4074),
    [anon_sym_EQ] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4076),
    [anon_sym_COLON] = ACTIONS(4076),
    [anon_sym_COMMA] = ACTIONS(4076),
    [anon_sym_LPAREN] = ACTIONS(4076),
    [anon_sym_LBRACE] = ACTIONS(4076),
    [anon_sym_file] = ACTIONS(4074),
    [anon_sym_LT] = ACTIONS(4074),
    [anon_sym_GT] = ACTIONS(4074),
    [anon_sym_where] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(4074),
    [anon_sym_notnull] = ACTIONS(4074),
    [anon_sym_unmanaged] = ACTIONS(4074),
    [anon_sym_BANG] = ACTIONS(4074),
    [anon_sym_PLUS_PLUS] = ACTIONS(4076),
    [anon_sym_DASH_DASH] = ACTIONS(4076),
    [anon_sym_PLUS] = ACTIONS(4074),
    [anon_sym_DASH] = ACTIONS(4074),
    [anon_sym_STAR] = ACTIONS(4074),
    [anon_sym_SLASH] = ACTIONS(4074),
    [anon_sym_PERCENT] = ACTIONS(4074),
    [anon_sym_CARET] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(4074),
    [anon_sym_AMP] = ACTIONS(4074),
    [anon_sym_LT_LT] = ACTIONS(4074),
    [anon_sym_GT_GT] = ACTIONS(4074),
    [anon_sym_GT_GT_GT] = ACTIONS(4074),
    [anon_sym_EQ_EQ] = ACTIONS(4076),
    [anon_sym_BANG_EQ] = ACTIONS(4076),
    [anon_sym_GT_EQ] = ACTIONS(4076),
    [anon_sym_LT_EQ] = ACTIONS(4076),
    [anon_sym_DOT] = ACTIONS(4074),
    [anon_sym_scoped] = ACTIONS(4074),
    [anon_sym_var] = ACTIONS(4074),
    [anon_sym_yield] = ACTIONS(4074),
    [anon_sym_switch] = ACTIONS(4074),
    [anon_sym_when] = ACTIONS(4074),
    [sym_discard] = ACTIONS(4074),
    [anon_sym_DOT_DOT] = ACTIONS(4076),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_PLUS_EQ] = ACTIONS(4076),
    [anon_sym_DASH_EQ] = ACTIONS(4076),
    [anon_sym_STAR_EQ] = ACTIONS(4076),
    [anon_sym_SLASH_EQ] = ACTIONS(4076),
    [anon_sym_PERCENT_EQ] = ACTIONS(4076),
    [anon_sym_AMP_EQ] = ACTIONS(4076),
    [anon_sym_CARET_EQ] = ACTIONS(4076),
    [anon_sym_PIPE_EQ] = ACTIONS(4076),
    [anon_sym_LT_LT_EQ] = ACTIONS(4076),
    [anon_sym_GT_GT_EQ] = ACTIONS(4076),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4076),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4076),
    [anon_sym_AMP_AMP] = ACTIONS(4076),
    [anon_sym_PIPE_PIPE] = ACTIONS(4076),
    [anon_sym_QMARK_QMARK] = ACTIONS(4074),
    [anon_sym_from] = ACTIONS(4074),
    [anon_sym_into] = ACTIONS(4074),
    [anon_sym_join] = ACTIONS(4074),
    [anon_sym_on] = ACTIONS(4074),
    [anon_sym_equals] = ACTIONS(4074),
    [anon_sym_let] = ACTIONS(4074),
    [anon_sym_orderby] = ACTIONS(4074),
    [anon_sym_ascending] = ACTIONS(4074),
    [anon_sym_descending] = ACTIONS(4074),
    [anon_sym_group] = ACTIONS(4074),
    [anon_sym_by] = ACTIONS(4074),
    [anon_sym_select] = ACTIONS(4074),
    [anon_sym_as] = ACTIONS(4074),
    [anon_sym_is] = ACTIONS(4074),
    [anon_sym_DASH_GT] = ACTIONS(4076),
    [anon_sym_with] = ACTIONS(4074),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4076),
  },
  [2814] = {
    [sym_preproc_region] = STATE(2814),
    [sym_preproc_endregion] = STATE(2814),
    [sym_preproc_line] = STATE(2814),
    [sym_preproc_pragma] = STATE(2814),
    [sym_preproc_nullable] = STATE(2814),
    [sym_preproc_error] = STATE(2814),
    [sym_preproc_define] = STATE(2814),
    [sym_preproc_undef] = STATE(2814),
    [sym__identifier_token] = ACTIONS(4060),
    [anon_sym_alias] = ACTIONS(4060),
    [anon_sym_global] = ACTIONS(4060),
    [anon_sym_EQ] = ACTIONS(4060),
    [anon_sym_LBRACK] = ACTIONS(4062),
    [anon_sym_COLON] = ACTIONS(4062),
    [anon_sym_COMMA] = ACTIONS(4062),
    [anon_sym_LPAREN] = ACTIONS(4062),
    [anon_sym_LBRACE] = ACTIONS(4062),
    [anon_sym_file] = ACTIONS(4060),
    [anon_sym_LT] = ACTIONS(4060),
    [anon_sym_GT] = ACTIONS(4060),
    [anon_sym_where] = ACTIONS(4060),
    [anon_sym_QMARK] = ACTIONS(4060),
    [anon_sym_notnull] = ACTIONS(4060),
    [anon_sym_unmanaged] = ACTIONS(4060),
    [anon_sym_BANG] = ACTIONS(4060),
    [anon_sym_PLUS_PLUS] = ACTIONS(4062),
    [anon_sym_DASH_DASH] = ACTIONS(4062),
    [anon_sym_PLUS] = ACTIONS(4060),
    [anon_sym_DASH] = ACTIONS(4060),
    [anon_sym_STAR] = ACTIONS(4060),
    [anon_sym_SLASH] = ACTIONS(4060),
    [anon_sym_PERCENT] = ACTIONS(4060),
    [anon_sym_CARET] = ACTIONS(4060),
    [anon_sym_PIPE] = ACTIONS(4060),
    [anon_sym_AMP] = ACTIONS(4060),
    [anon_sym_LT_LT] = ACTIONS(4060),
    [anon_sym_GT_GT] = ACTIONS(4060),
    [anon_sym_GT_GT_GT] = ACTIONS(4060),
    [anon_sym_EQ_EQ] = ACTIONS(4062),
    [anon_sym_BANG_EQ] = ACTIONS(4062),
    [anon_sym_GT_EQ] = ACTIONS(4062),
    [anon_sym_LT_EQ] = ACTIONS(4062),
    [anon_sym_DOT] = ACTIONS(4060),
    [anon_sym_scoped] = ACTIONS(4060),
    [anon_sym_var] = ACTIONS(4060),
    [anon_sym_yield] = ACTIONS(4060),
    [anon_sym_switch] = ACTIONS(4060),
    [anon_sym_when] = ACTIONS(4060),
    [sym_discard] = ACTIONS(4060),
    [anon_sym_DOT_DOT] = ACTIONS(4062),
    [anon_sym_and] = ACTIONS(4060),
    [anon_sym_or] = ACTIONS(4060),
    [anon_sym_PLUS_EQ] = ACTIONS(4062),
    [anon_sym_DASH_EQ] = ACTIONS(4062),
    [anon_sym_STAR_EQ] = ACTIONS(4062),
    [anon_sym_SLASH_EQ] = ACTIONS(4062),
    [anon_sym_PERCENT_EQ] = ACTIONS(4062),
    [anon_sym_AMP_EQ] = ACTIONS(4062),
    [anon_sym_CARET_EQ] = ACTIONS(4062),
    [anon_sym_PIPE_EQ] = ACTIONS(4062),
    [anon_sym_LT_LT_EQ] = ACTIONS(4062),
    [anon_sym_GT_GT_EQ] = ACTIONS(4062),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4062),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4062),
    [anon_sym_AMP_AMP] = ACTIONS(4062),
    [anon_sym_PIPE_PIPE] = ACTIONS(4062),
    [anon_sym_QMARK_QMARK] = ACTIONS(4060),
    [anon_sym_from] = ACTIONS(4060),
    [anon_sym_into] = ACTIONS(4060),
    [anon_sym_join] = ACTIONS(4060),
    [anon_sym_on] = ACTIONS(4060),
    [anon_sym_equals] = ACTIONS(4060),
    [anon_sym_let] = ACTIONS(4060),
    [anon_sym_orderby] = ACTIONS(4060),
    [anon_sym_ascending] = ACTIONS(4060),
    [anon_sym_descending] = ACTIONS(4060),
    [anon_sym_group] = ACTIONS(4060),
    [anon_sym_by] = ACTIONS(4060),
    [anon_sym_select] = ACTIONS(4060),
    [anon_sym_as] = ACTIONS(4060),
    [anon_sym_is] = ACTIONS(4060),
    [anon_sym_DASH_GT] = ACTIONS(4062),
    [anon_sym_with] = ACTIONS(4060),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4062),
  },
  [2815] = {
    [sym_preproc_region] = STATE(2815),
    [sym_preproc_endregion] = STATE(2815),
    [sym_preproc_line] = STATE(2815),
    [sym_preproc_pragma] = STATE(2815),
    [sym_preproc_nullable] = STATE(2815),
    [sym_preproc_error] = STATE(2815),
    [sym_preproc_define] = STATE(2815),
    [sym_preproc_undef] = STATE(2815),
    [sym__identifier_token] = ACTIONS(4113),
    [anon_sym_alias] = ACTIONS(4113),
    [anon_sym_global] = ACTIONS(4113),
    [anon_sym_EQ] = ACTIONS(4118),
    [anon_sym_LBRACK] = ACTIONS(4120),
    [anon_sym_COLON] = ACTIONS(4115),
    [anon_sym_COMMA] = ACTIONS(4115),
    [anon_sym_LPAREN] = ACTIONS(4120),
    [anon_sym_LBRACE] = ACTIONS(4124),
    [anon_sym_file] = ACTIONS(4113),
    [anon_sym_LT] = ACTIONS(4126),
    [anon_sym_GT] = ACTIONS(4126),
    [anon_sym_where] = ACTIONS(4113),
    [anon_sym_QMARK] = ACTIONS(4126),
    [anon_sym_notnull] = ACTIONS(4113),
    [anon_sym_unmanaged] = ACTIONS(4113),
    [anon_sym_BANG] = ACTIONS(4126),
    [anon_sym_PLUS_PLUS] = ACTIONS(4120),
    [anon_sym_DASH_DASH] = ACTIONS(4120),
    [anon_sym_PLUS] = ACTIONS(4126),
    [anon_sym_DASH] = ACTIONS(4126),
    [anon_sym_STAR] = ACTIONS(4126),
    [anon_sym_SLASH] = ACTIONS(4126),
    [anon_sym_PERCENT] = ACTIONS(4126),
    [anon_sym_CARET] = ACTIONS(4126),
    [anon_sym_PIPE] = ACTIONS(4126),
    [anon_sym_AMP] = ACTIONS(4126),
    [anon_sym_LT_LT] = ACTIONS(4126),
    [anon_sym_GT_GT] = ACTIONS(4126),
    [anon_sym_GT_GT_GT] = ACTIONS(4126),
    [anon_sym_EQ_EQ] = ACTIONS(4120),
    [anon_sym_BANG_EQ] = ACTIONS(4120),
    [anon_sym_GT_EQ] = ACTIONS(4120),
    [anon_sym_LT_EQ] = ACTIONS(4120),
    [anon_sym_DOT] = ACTIONS(4126),
    [anon_sym_scoped] = ACTIONS(4113),
    [anon_sym_var] = ACTIONS(4113),
    [anon_sym_yield] = ACTIONS(4113),
    [anon_sym_switch] = ACTIONS(4126),
    [anon_sym_when] = ACTIONS(4113),
    [sym_discard] = ACTIONS(4113),
    [anon_sym_DOT_DOT] = ACTIONS(4120),
    [anon_sym_and] = ACTIONS(4130),
    [anon_sym_or] = ACTIONS(4130),
    [anon_sym_PLUS_EQ] = ACTIONS(4133),
    [anon_sym_DASH_EQ] = ACTIONS(4133),
    [anon_sym_STAR_EQ] = ACTIONS(4133),
    [anon_sym_SLASH_EQ] = ACTIONS(4133),
    [anon_sym_PERCENT_EQ] = ACTIONS(4133),
    [anon_sym_AMP_EQ] = ACTIONS(4133),
    [anon_sym_CARET_EQ] = ACTIONS(4133),
    [anon_sym_PIPE_EQ] = ACTIONS(4133),
    [anon_sym_LT_LT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4133),
    [anon_sym_AMP_AMP] = ACTIONS(4120),
    [anon_sym_PIPE_PIPE] = ACTIONS(4120),
    [anon_sym_QMARK_QMARK] = ACTIONS(4126),
    [anon_sym_from] = ACTIONS(4113),
    [anon_sym_into] = ACTIONS(4130),
    [anon_sym_join] = ACTIONS(4113),
    [anon_sym_on] = ACTIONS(4113),
    [anon_sym_equals] = ACTIONS(4113),
    [anon_sym_let] = ACTIONS(4113),
    [anon_sym_orderby] = ACTIONS(4113),
    [anon_sym_ascending] = ACTIONS(4113),
    [anon_sym_descending] = ACTIONS(4113),
    [anon_sym_group] = ACTIONS(4113),
    [anon_sym_by] = ACTIONS(4113),
    [anon_sym_select] = ACTIONS(4113),
    [anon_sym_as] = ACTIONS(4126),
    [anon_sym_is] = ACTIONS(4126),
    [anon_sym_DASH_GT] = ACTIONS(4120),
    [anon_sym_with] = ACTIONS(4126),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4115),
  },
  [2816] = {
    [sym_preproc_region] = STATE(2816),
    [sym_preproc_endregion] = STATE(2816),
    [sym_preproc_line] = STATE(2816),
    [sym_preproc_pragma] = STATE(2816),
    [sym_preproc_nullable] = STATE(2816),
    [sym_preproc_error] = STATE(2816),
    [sym_preproc_define] = STATE(2816),
    [sym_preproc_undef] = STATE(2816),
    [sym__identifier_token] = ACTIONS(4027),
    [anon_sym_alias] = ACTIONS(4027),
    [anon_sym_global] = ACTIONS(4027),
    [anon_sym_EQ] = ACTIONS(3721),
    [anon_sym_LBRACK] = ACTIONS(3719),
    [anon_sym_COLON] = ACTIONS(3721),
    [anon_sym_COMMA] = ACTIONS(3719),
    [anon_sym_LPAREN] = ACTIONS(4024),
    [anon_sym_file] = ACTIONS(4027),
    [anon_sym_LT] = ACTIONS(3721),
    [anon_sym_GT] = ACTIONS(3721),
    [anon_sym_where] = ACTIONS(4027),
    [anon_sym_QMARK] = ACTIONS(3721),
    [anon_sym_notnull] = ACTIONS(4027),
    [anon_sym_unmanaged] = ACTIONS(4027),
    [anon_sym_BANG] = ACTIONS(3721),
    [anon_sym_PLUS_PLUS] = ACTIONS(3719),
    [anon_sym_DASH_DASH] = ACTIONS(3719),
    [anon_sym_PLUS] = ACTIONS(3721),
    [anon_sym_DASH] = ACTIONS(3721),
    [anon_sym_STAR] = ACTIONS(3721),
    [anon_sym_SLASH] = ACTIONS(3721),
    [anon_sym_PERCENT] = ACTIONS(3721),
    [anon_sym_CARET] = ACTIONS(3721),
    [anon_sym_PIPE] = ACTIONS(3721),
    [anon_sym_AMP] = ACTIONS(3721),
    [anon_sym_LT_LT] = ACTIONS(3721),
    [anon_sym_GT_GT] = ACTIONS(3721),
    [anon_sym_GT_GT_GT] = ACTIONS(3721),
    [anon_sym_EQ_EQ] = ACTIONS(3719),
    [anon_sym_BANG_EQ] = ACTIONS(3719),
    [anon_sym_GT_EQ] = ACTIONS(3719),
    [anon_sym_LT_EQ] = ACTIONS(3719),
    [anon_sym_DOT] = ACTIONS(3721),
    [anon_sym_scoped] = ACTIONS(4027),
    [anon_sym_EQ_GT] = ACTIONS(3719),
    [anon_sym_COLON_COLON] = ACTIONS(3719),
    [anon_sym_var] = ACTIONS(4027),
    [anon_sym_yield] = ACTIONS(4027),
    [anon_sym_switch] = ACTIONS(3721),
    [anon_sym_when] = ACTIONS(4027),
    [anon_sym_DOT_DOT] = ACTIONS(3719),
    [anon_sym_and] = ACTIONS(3721),
    [anon_sym_or] = ACTIONS(3721),
    [anon_sym_PLUS_EQ] = ACTIONS(3719),
    [anon_sym_DASH_EQ] = ACTIONS(3719),
    [anon_sym_STAR_EQ] = ACTIONS(3719),
    [anon_sym_SLASH_EQ] = ACTIONS(3719),
    [anon_sym_PERCENT_EQ] = ACTIONS(3719),
    [anon_sym_AMP_EQ] = ACTIONS(3719),
    [anon_sym_CARET_EQ] = ACTIONS(3719),
    [anon_sym_PIPE_EQ] = ACTIONS(3719),
    [anon_sym_LT_LT_EQ] = ACTIONS(3719),
    [anon_sym_GT_GT_EQ] = ACTIONS(3719),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3719),
    [anon_sym_AMP_AMP] = ACTIONS(3719),
    [anon_sym_PIPE_PIPE] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK] = ACTIONS(3721),
    [anon_sym_from] = ACTIONS(4027),
    [anon_sym_into] = ACTIONS(4027),
    [anon_sym_join] = ACTIONS(4027),
    [anon_sym_on] = ACTIONS(4027),
    [anon_sym_equals] = ACTIONS(4027),
    [anon_sym_let] = ACTIONS(4027),
    [anon_sym_orderby] = ACTIONS(4027),
    [anon_sym_ascending] = ACTIONS(4027),
    [anon_sym_descending] = ACTIONS(4027),
    [anon_sym_group] = ACTIONS(4027),
    [anon_sym_by] = ACTIONS(4027),
    [anon_sym_select] = ACTIONS(4027),
    [anon_sym_as] = ACTIONS(3721),
    [anon_sym_is] = ACTIONS(3721),
    [anon_sym_DASH_GT] = ACTIONS(3719),
    [anon_sym_with] = ACTIONS(3721),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(3719),
  },
  [2817] = {
    [sym_preproc_region] = STATE(2817),
    [sym_preproc_endregion] = STATE(2817),
    [sym_preproc_line] = STATE(2817),
    [sym_preproc_pragma] = STATE(2817),
    [sym_preproc_nullable] = STATE(2817),
    [sym_preproc_error] = STATE(2817),
    [sym_preproc_define] = STATE(2817),
    [sym_preproc_undef] = STATE(2817),
    [sym__identifier_token] = ACTIONS(4113),
    [anon_sym_alias] = ACTIONS(4113),
    [anon_sym_global] = ACTIONS(4113),
    [anon_sym_EQ] = ACTIONS(4118),
    [anon_sym_LBRACK] = ACTIONS(4135),
    [anon_sym_COLON] = ACTIONS(4133),
    [anon_sym_COMMA] = ACTIONS(4135),
    [anon_sym_LPAREN] = ACTIONS(4135),
    [anon_sym_RPAREN] = ACTIONS(4135),
    [anon_sym_LBRACE] = ACTIONS(4124),
    [anon_sym_file] = ACTIONS(4113),
    [anon_sym_LT] = ACTIONS(4118),
    [anon_sym_GT] = ACTIONS(4118),
    [anon_sym_where] = ACTIONS(4113),
    [anon_sym_QMARK] = ACTIONS(4138),
    [anon_sym_notnull] = ACTIONS(4113),
    [anon_sym_unmanaged] = ACTIONS(4113),
    [anon_sym_BANG] = ACTIONS(4118),
    [anon_sym_PLUS_PLUS] = ACTIONS(4133),
    [anon_sym_DASH_DASH] = ACTIONS(4133),
    [anon_sym_PLUS] = ACTIONS(4118),
    [anon_sym_DASH] = ACTIONS(4118),
    [anon_sym_STAR] = ACTIONS(4138),
    [anon_sym_SLASH] = ACTIONS(4118),
    [anon_sym_PERCENT] = ACTIONS(4118),
    [anon_sym_CARET] = ACTIONS(4118),
    [anon_sym_PIPE] = ACTIONS(4118),
    [anon_sym_AMP] = ACTIONS(4118),
    [anon_sym_LT_LT] = ACTIONS(4118),
    [anon_sym_GT_GT] = ACTIONS(4118),
    [anon_sym_GT_GT_GT] = ACTIONS(4118),
    [anon_sym_EQ_EQ] = ACTIONS(4133),
    [anon_sym_BANG_EQ] = ACTIONS(4133),
    [anon_sym_GT_EQ] = ACTIONS(4133),
    [anon_sym_LT_EQ] = ACTIONS(4133),
    [anon_sym_DOT] = ACTIONS(4138),
    [anon_sym_scoped] = ACTIONS(4113),
    [anon_sym_var] = ACTIONS(4113),
    [anon_sym_yield] = ACTIONS(4113),
    [anon_sym_switch] = ACTIONS(4118),
    [anon_sym_when] = ACTIONS(4113),
    [sym_discard] = ACTIONS(4113),
    [anon_sym_DOT_DOT] = ACTIONS(4133),
    [anon_sym_and] = ACTIONS(4113),
    [anon_sym_or] = ACTIONS(4113),
    [anon_sym_PLUS_EQ] = ACTIONS(4133),
    [anon_sym_DASH_EQ] = ACTIONS(4133),
    [anon_sym_STAR_EQ] = ACTIONS(4133),
    [anon_sym_SLASH_EQ] = ACTIONS(4133),
    [anon_sym_PERCENT_EQ] = ACTIONS(4133),
    [anon_sym_AMP_EQ] = ACTIONS(4133),
    [anon_sym_CARET_EQ] = ACTIONS(4133),
    [anon_sym_PIPE_EQ] = ACTIONS(4133),
    [anon_sym_LT_LT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4133),
    [anon_sym_AMP_AMP] = ACTIONS(4133),
    [anon_sym_PIPE_PIPE] = ACTIONS(4133),
    [anon_sym_QMARK_QMARK] = ACTIONS(4118),
    [anon_sym_from] = ACTIONS(4113),
    [anon_sym_into] = ACTIONS(4113),
    [anon_sym_join] = ACTIONS(4113),
    [anon_sym_on] = ACTIONS(4113),
    [anon_sym_equals] = ACTIONS(4113),
    [anon_sym_let] = ACTIONS(4113),
    [anon_sym_orderby] = ACTIONS(4113),
    [anon_sym_ascending] = ACTIONS(4113),
    [anon_sym_descending] = ACTIONS(4113),
    [anon_sym_group] = ACTIONS(4113),
    [anon_sym_by] = ACTIONS(4113),
    [anon_sym_select] = ACTIONS(4113),
    [anon_sym_as] = ACTIONS(4118),
    [anon_sym_is] = ACTIONS(4118),
    [anon_sym_DASH_GT] = ACTIONS(4135),
    [anon_sym_with] = ACTIONS(4118),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2818] = {
    [sym_preproc_region] = STATE(2818),
    [sym_preproc_endregion] = STATE(2818),
    [sym_preproc_line] = STATE(2818),
    [sym_preproc_pragma] = STATE(2818),
    [sym_preproc_nullable] = STATE(2818),
    [sym_preproc_error] = STATE(2818),
    [sym_preproc_define] = STATE(2818),
    [sym_preproc_undef] = STATE(2818),
    [sym__identifier_token] = ACTIONS(3721),
    [anon_sym_alias] = ACTIONS(3721),
    [anon_sym_global] = ACTIONS(3721),
    [anon_sym_EQ] = ACTIONS(3721),
    [anon_sym_LBRACK] = ACTIONS(3719),
    [anon_sym_COLON] = ACTIONS(3719),
    [anon_sym_COMMA] = ACTIONS(3719),
    [anon_sym_LPAREN] = ACTIONS(3719),
    [anon_sym_LBRACE] = ACTIONS(3719),
    [anon_sym_file] = ACTIONS(3721),
    [anon_sym_LT] = ACTIONS(3721),
    [anon_sym_GT] = ACTIONS(3721),
    [anon_sym_where] = ACTIONS(3721),
    [anon_sym_QMARK] = ACTIONS(3721),
    [anon_sym_notnull] = ACTIONS(3721),
    [anon_sym_unmanaged] = ACTIONS(3721),
    [anon_sym_BANG] = ACTIONS(3721),
    [anon_sym_PLUS_PLUS] = ACTIONS(3719),
    [anon_sym_DASH_DASH] = ACTIONS(3719),
    [anon_sym_PLUS] = ACTIONS(3721),
    [anon_sym_DASH] = ACTIONS(3721),
    [anon_sym_STAR] = ACTIONS(3721),
    [anon_sym_SLASH] = ACTIONS(3721),
    [anon_sym_PERCENT] = ACTIONS(3721),
    [anon_sym_CARET] = ACTIONS(3721),
    [anon_sym_PIPE] = ACTIONS(3721),
    [anon_sym_AMP] = ACTIONS(3721),
    [anon_sym_LT_LT] = ACTIONS(3721),
    [anon_sym_GT_GT] = ACTIONS(3721),
    [anon_sym_GT_GT_GT] = ACTIONS(3721),
    [anon_sym_EQ_EQ] = ACTIONS(3719),
    [anon_sym_BANG_EQ] = ACTIONS(3719),
    [anon_sym_GT_EQ] = ACTIONS(3719),
    [anon_sym_LT_EQ] = ACTIONS(3719),
    [anon_sym_DOT] = ACTIONS(3721),
    [anon_sym_scoped] = ACTIONS(3721),
    [anon_sym_var] = ACTIONS(3721),
    [anon_sym_yield] = ACTIONS(3721),
    [anon_sym_switch] = ACTIONS(3721),
    [anon_sym_when] = ACTIONS(3721),
    [sym_discard] = ACTIONS(3721),
    [anon_sym_DOT_DOT] = ACTIONS(3719),
    [anon_sym_and] = ACTIONS(3721),
    [anon_sym_or] = ACTIONS(3721),
    [anon_sym_PLUS_EQ] = ACTIONS(3719),
    [anon_sym_DASH_EQ] = ACTIONS(3719),
    [anon_sym_STAR_EQ] = ACTIONS(3719),
    [anon_sym_SLASH_EQ] = ACTIONS(3719),
    [anon_sym_PERCENT_EQ] = ACTIONS(3719),
    [anon_sym_AMP_EQ] = ACTIONS(3719),
    [anon_sym_CARET_EQ] = ACTIONS(3719),
    [anon_sym_PIPE_EQ] = ACTIONS(3719),
    [anon_sym_LT_LT_EQ] = ACTIONS(3719),
    [anon_sym_GT_GT_EQ] = ACTIONS(3719),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3719),
    [anon_sym_AMP_AMP] = ACTIONS(3719),
    [anon_sym_PIPE_PIPE] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK] = ACTIONS(3721),
    [anon_sym_from] = ACTIONS(3721),
    [anon_sym_into] = ACTIONS(3721),
    [anon_sym_join] = ACTIONS(3721),
    [anon_sym_on] = ACTIONS(3721),
    [anon_sym_equals] = ACTIONS(3721),
    [anon_sym_let] = ACTIONS(3721),
    [anon_sym_orderby] = ACTIONS(3721),
    [anon_sym_ascending] = ACTIONS(3721),
    [anon_sym_descending] = ACTIONS(3721),
    [anon_sym_group] = ACTIONS(3721),
    [anon_sym_by] = ACTIONS(3721),
    [anon_sym_select] = ACTIONS(3721),
    [anon_sym_as] = ACTIONS(3721),
    [anon_sym_is] = ACTIONS(3721),
    [anon_sym_DASH_GT] = ACTIONS(3719),
    [anon_sym_with] = ACTIONS(3721),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(3719),
  },
  [2819] = {
    [sym_type_argument_list] = STATE(2736),
    [sym_preproc_region] = STATE(2819),
    [sym_preproc_endregion] = STATE(2819),
    [sym_preproc_line] = STATE(2819),
    [sym_preproc_pragma] = STATE(2819),
    [sym_preproc_nullable] = STATE(2819),
    [sym_preproc_error] = STATE(2819),
    [sym_preproc_define] = STATE(2819),
    [sym_preproc_undef] = STATE(2819),
    [sym__identifier_token] = ACTIONS(4074),
    [anon_sym_alias] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4074),
    [anon_sym_EQ] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4076),
    [anon_sym_COLON] = ACTIONS(4333),
    [anon_sym_LPAREN] = ACTIONS(4076),
    [anon_sym_file] = ACTIONS(4074),
    [anon_sym_LT] = ACTIONS(4078),
    [anon_sym_GT] = ACTIONS(4074),
    [anon_sym_where] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(4074),
    [anon_sym_notnull] = ACTIONS(4074),
    [anon_sym_unmanaged] = ACTIONS(4074),
    [anon_sym_BANG] = ACTIONS(4074),
    [anon_sym_PLUS_PLUS] = ACTIONS(4076),
    [anon_sym_DASH_DASH] = ACTIONS(4076),
    [anon_sym_PLUS] = ACTIONS(4074),
    [anon_sym_DASH] = ACTIONS(4074),
    [anon_sym_STAR] = ACTIONS(4074),
    [anon_sym_SLASH] = ACTIONS(4074),
    [anon_sym_PERCENT] = ACTIONS(4074),
    [anon_sym_CARET] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(4074),
    [anon_sym_AMP] = ACTIONS(4074),
    [anon_sym_LT_LT] = ACTIONS(4074),
    [anon_sym_GT_GT] = ACTIONS(4074),
    [anon_sym_GT_GT_GT] = ACTIONS(4074),
    [anon_sym_EQ_EQ] = ACTIONS(4076),
    [anon_sym_BANG_EQ] = ACTIONS(4076),
    [anon_sym_GT_EQ] = ACTIONS(4076),
    [anon_sym_LT_EQ] = ACTIONS(4076),
    [anon_sym_DOT] = ACTIONS(4074),
    [anon_sym_scoped] = ACTIONS(4074),
    [anon_sym_EQ_GT] = ACTIONS(4081),
    [anon_sym_COLON_COLON] = ACTIONS(4083),
    [anon_sym_var] = ACTIONS(4074),
    [anon_sym_yield] = ACTIONS(4074),
    [anon_sym_switch] = ACTIONS(4074),
    [anon_sym_when] = ACTIONS(4074),
    [anon_sym_DOT_DOT] = ACTIONS(4076),
    [anon_sym_PLUS_EQ] = ACTIONS(4076),
    [anon_sym_DASH_EQ] = ACTIONS(4076),
    [anon_sym_STAR_EQ] = ACTIONS(4076),
    [anon_sym_SLASH_EQ] = ACTIONS(4076),
    [anon_sym_PERCENT_EQ] = ACTIONS(4076),
    [anon_sym_AMP_EQ] = ACTIONS(4076),
    [anon_sym_CARET_EQ] = ACTIONS(4076),
    [anon_sym_PIPE_EQ] = ACTIONS(4076),
    [anon_sym_LT_LT_EQ] = ACTIONS(4076),
    [anon_sym_GT_GT_EQ] = ACTIONS(4076),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4076),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4076),
    [anon_sym_AMP_AMP] = ACTIONS(4076),
    [anon_sym_PIPE_PIPE] = ACTIONS(4076),
    [anon_sym_QMARK_QMARK] = ACTIONS(4074),
    [anon_sym_from] = ACTIONS(4074),
    [anon_sym_into] = ACTIONS(4074),
    [anon_sym_join] = ACTIONS(4074),
    [anon_sym_on] = ACTIONS(4074),
    [anon_sym_equals] = ACTIONS(4074),
    [anon_sym_let] = ACTIONS(4074),
    [anon_sym_orderby] = ACTIONS(4074),
    [anon_sym_ascending] = ACTIONS(4074),
    [anon_sym_descending] = ACTIONS(4074),
    [anon_sym_group] = ACTIONS(4074),
    [anon_sym_by] = ACTIONS(4074),
    [anon_sym_select] = ACTIONS(4074),
    [anon_sym_as] = ACTIONS(4074),
    [anon_sym_is] = ACTIONS(4074),
    [anon_sym_DASH_GT] = ACTIONS(4076),
    [anon_sym_with] = ACTIONS(4074),
    [aux_sym_preproc_if_token3] = ACTIONS(4076),
    [aux_sym_preproc_else_token1] = ACTIONS(4076),
    [aux_sym_preproc_elif_token1] = ACTIONS(4076),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2820] = {
    [sym_preproc_region] = STATE(2820),
    [sym_preproc_endregion] = STATE(2820),
    [sym_preproc_line] = STATE(2820),
    [sym_preproc_pragma] = STATE(2820),
    [sym_preproc_nullable] = STATE(2820),
    [sym_preproc_error] = STATE(2820),
    [sym_preproc_define] = STATE(2820),
    [sym_preproc_undef] = STATE(2820),
    [sym__identifier_token] = ACTIONS(4070),
    [anon_sym_alias] = ACTIONS(4070),
    [anon_sym_global] = ACTIONS(4070),
    [anon_sym_EQ] = ACTIONS(4070),
    [anon_sym_LBRACK] = ACTIONS(4072),
    [anon_sym_COLON] = ACTIONS(4072),
    [anon_sym_COMMA] = ACTIONS(4072),
    [anon_sym_LPAREN] = ACTIONS(4072),
    [anon_sym_LBRACE] = ACTIONS(4072),
    [anon_sym_file] = ACTIONS(4070),
    [anon_sym_LT] = ACTIONS(4070),
    [anon_sym_GT] = ACTIONS(4070),
    [anon_sym_where] = ACTIONS(4070),
    [anon_sym_QMARK] = ACTIONS(4070),
    [anon_sym_notnull] = ACTIONS(4070),
    [anon_sym_unmanaged] = ACTIONS(4070),
    [anon_sym_BANG] = ACTIONS(4070),
    [anon_sym_PLUS_PLUS] = ACTIONS(4072),
    [anon_sym_DASH_DASH] = ACTIONS(4072),
    [anon_sym_PLUS] = ACTIONS(4070),
    [anon_sym_DASH] = ACTIONS(4070),
    [anon_sym_STAR] = ACTIONS(4070),
    [anon_sym_SLASH] = ACTIONS(4070),
    [anon_sym_PERCENT] = ACTIONS(4070),
    [anon_sym_CARET] = ACTIONS(4070),
    [anon_sym_PIPE] = ACTIONS(4070),
    [anon_sym_AMP] = ACTIONS(4070),
    [anon_sym_LT_LT] = ACTIONS(4070),
    [anon_sym_GT_GT] = ACTIONS(4070),
    [anon_sym_GT_GT_GT] = ACTIONS(4070),
    [anon_sym_EQ_EQ] = ACTIONS(4072),
    [anon_sym_BANG_EQ] = ACTIONS(4072),
    [anon_sym_GT_EQ] = ACTIONS(4072),
    [anon_sym_LT_EQ] = ACTIONS(4072),
    [anon_sym_DOT] = ACTIONS(4070),
    [anon_sym_scoped] = ACTIONS(4070),
    [anon_sym_var] = ACTIONS(4070),
    [anon_sym_yield] = ACTIONS(4070),
    [anon_sym_switch] = ACTIONS(4070),
    [anon_sym_when] = ACTIONS(4070),
    [sym_discard] = ACTIONS(4070),
    [anon_sym_DOT_DOT] = ACTIONS(4072),
    [anon_sym_and] = ACTIONS(4070),
    [anon_sym_or] = ACTIONS(4070),
    [anon_sym_PLUS_EQ] = ACTIONS(4072),
    [anon_sym_DASH_EQ] = ACTIONS(4072),
    [anon_sym_STAR_EQ] = ACTIONS(4072),
    [anon_sym_SLASH_EQ] = ACTIONS(4072),
    [anon_sym_PERCENT_EQ] = ACTIONS(4072),
    [anon_sym_AMP_EQ] = ACTIONS(4072),
    [anon_sym_CARET_EQ] = ACTIONS(4072),
    [anon_sym_PIPE_EQ] = ACTIONS(4072),
    [anon_sym_LT_LT_EQ] = ACTIONS(4072),
    [anon_sym_GT_GT_EQ] = ACTIONS(4072),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4072),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4072),
    [anon_sym_AMP_AMP] = ACTIONS(4072),
    [anon_sym_PIPE_PIPE] = ACTIONS(4072),
    [anon_sym_QMARK_QMARK] = ACTIONS(4070),
    [anon_sym_from] = ACTIONS(4070),
    [anon_sym_into] = ACTIONS(4070),
    [anon_sym_join] = ACTIONS(4070),
    [anon_sym_on] = ACTIONS(4070),
    [anon_sym_equals] = ACTIONS(4070),
    [anon_sym_let] = ACTIONS(4070),
    [anon_sym_orderby] = ACTIONS(4070),
    [anon_sym_ascending] = ACTIONS(4070),
    [anon_sym_descending] = ACTIONS(4070),
    [anon_sym_group] = ACTIONS(4070),
    [anon_sym_by] = ACTIONS(4070),
    [anon_sym_select] = ACTIONS(4070),
    [anon_sym_as] = ACTIONS(4070),
    [anon_sym_is] = ACTIONS(4070),
    [anon_sym_DASH_GT] = ACTIONS(4072),
    [anon_sym_with] = ACTIONS(4070),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4072),
  },
  [2821] = {
    [sym_type_argument_list] = STATE(2736),
    [sym_preproc_region] = STATE(2821),
    [sym_preproc_endregion] = STATE(2821),
    [sym_preproc_line] = STATE(2821),
    [sym_preproc_pragma] = STATE(2821),
    [sym_preproc_nullable] = STATE(2821),
    [sym_preproc_error] = STATE(2821),
    [sym_preproc_define] = STATE(2821),
    [sym_preproc_undef] = STATE(2821),
    [sym__identifier_token] = ACTIONS(4074),
    [anon_sym_alias] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4074),
    [anon_sym_EQ] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4076),
    [anon_sym_LPAREN] = ACTIONS(4076),
    [anon_sym_LBRACE] = ACTIONS(4076),
    [anon_sym_file] = ACTIONS(4074),
    [anon_sym_LT] = ACTIONS(4078),
    [anon_sym_GT] = ACTIONS(4074),
    [anon_sym_where] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(4074),
    [anon_sym_notnull] = ACTIONS(4074),
    [anon_sym_unmanaged] = ACTIONS(4074),
    [anon_sym_BANG] = ACTIONS(4074),
    [anon_sym_PLUS_PLUS] = ACTIONS(4076),
    [anon_sym_DASH_DASH] = ACTIONS(4076),
    [anon_sym_PLUS] = ACTIONS(4074),
    [anon_sym_DASH] = ACTIONS(4074),
    [anon_sym_STAR] = ACTIONS(4074),
    [anon_sym_SLASH] = ACTIONS(4074),
    [anon_sym_PERCENT] = ACTIONS(4074),
    [anon_sym_CARET] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(4074),
    [anon_sym_AMP] = ACTIONS(4074),
    [anon_sym_LT_LT] = ACTIONS(4074),
    [anon_sym_GT_GT] = ACTIONS(4074),
    [anon_sym_GT_GT_GT] = ACTIONS(4074),
    [anon_sym_EQ_EQ] = ACTIONS(4076),
    [anon_sym_BANG_EQ] = ACTIONS(4076),
    [anon_sym_GT_EQ] = ACTIONS(4076),
    [anon_sym_LT_EQ] = ACTIONS(4076),
    [anon_sym_DOT] = ACTIONS(4074),
    [anon_sym_scoped] = ACTIONS(4074),
    [anon_sym_EQ_GT] = ACTIONS(4076),
    [anon_sym_COLON_COLON] = ACTIONS(4083),
    [anon_sym_var] = ACTIONS(4074),
    [anon_sym_yield] = ACTIONS(4074),
    [anon_sym_switch] = ACTIONS(4074),
    [anon_sym_when] = ACTIONS(4074),
    [sym_discard] = ACTIONS(4074),
    [anon_sym_DOT_DOT] = ACTIONS(4076),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_PLUS_EQ] = ACTIONS(4076),
    [anon_sym_DASH_EQ] = ACTIONS(4076),
    [anon_sym_STAR_EQ] = ACTIONS(4076),
    [anon_sym_SLASH_EQ] = ACTIONS(4076),
    [anon_sym_PERCENT_EQ] = ACTIONS(4076),
    [anon_sym_AMP_EQ] = ACTIONS(4076),
    [anon_sym_CARET_EQ] = ACTIONS(4076),
    [anon_sym_PIPE_EQ] = ACTIONS(4076),
    [anon_sym_LT_LT_EQ] = ACTIONS(4076),
    [anon_sym_GT_GT_EQ] = ACTIONS(4076),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4076),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4076),
    [anon_sym_AMP_AMP] = ACTIONS(4076),
    [anon_sym_PIPE_PIPE] = ACTIONS(4076),
    [anon_sym_QMARK_QMARK] = ACTIONS(4074),
    [anon_sym_from] = ACTIONS(4074),
    [anon_sym_into] = ACTIONS(4074),
    [anon_sym_join] = ACTIONS(4074),
    [anon_sym_on] = ACTIONS(4074),
    [anon_sym_equals] = ACTIONS(4074),
    [anon_sym_let] = ACTIONS(4074),
    [anon_sym_orderby] = ACTIONS(4074),
    [anon_sym_ascending] = ACTIONS(4074),
    [anon_sym_descending] = ACTIONS(4074),
    [anon_sym_group] = ACTIONS(4074),
    [anon_sym_by] = ACTIONS(4074),
    [anon_sym_select] = ACTIONS(4074),
    [anon_sym_as] = ACTIONS(4074),
    [anon_sym_is] = ACTIONS(4074),
    [anon_sym_DASH_GT] = ACTIONS(4076),
    [anon_sym_with] = ACTIONS(4074),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2822] = {
    [sym_preproc_region] = STATE(2822),
    [sym_preproc_endregion] = STATE(2822),
    [sym_preproc_line] = STATE(2822),
    [sym_preproc_pragma] = STATE(2822),
    [sym_preproc_nullable] = STATE(2822),
    [sym_preproc_error] = STATE(2822),
    [sym_preproc_define] = STATE(2822),
    [sym_preproc_undef] = STATE(2822),
    [sym__identifier_token] = ACTIONS(4113),
    [anon_sym_alias] = ACTIONS(4113),
    [anon_sym_global] = ACTIONS(4113),
    [anon_sym_EQ] = ACTIONS(4118),
    [anon_sym_LBRACK] = ACTIONS(4135),
    [anon_sym_COLON] = ACTIONS(4124),
    [anon_sym_COMMA] = ACTIONS(4124),
    [anon_sym_LPAREN] = ACTIONS(4135),
    [anon_sym_LBRACE] = ACTIONS(4124),
    [anon_sym_file] = ACTIONS(4113),
    [anon_sym_LT] = ACTIONS(4138),
    [anon_sym_GT] = ACTIONS(4138),
    [anon_sym_where] = ACTIONS(4113),
    [anon_sym_QMARK] = ACTIONS(4138),
    [anon_sym_notnull] = ACTIONS(4113),
    [anon_sym_unmanaged] = ACTIONS(4113),
    [anon_sym_BANG] = ACTIONS(4138),
    [anon_sym_PLUS_PLUS] = ACTIONS(4135),
    [anon_sym_DASH_DASH] = ACTIONS(4135),
    [anon_sym_PLUS] = ACTIONS(4138),
    [anon_sym_DASH] = ACTIONS(4138),
    [anon_sym_STAR] = ACTIONS(4138),
    [anon_sym_SLASH] = ACTIONS(4138),
    [anon_sym_PERCENT] = ACTIONS(4138),
    [anon_sym_CARET] = ACTIONS(4138),
    [anon_sym_PIPE] = ACTIONS(4138),
    [anon_sym_AMP] = ACTIONS(4138),
    [anon_sym_LT_LT] = ACTIONS(4138),
    [anon_sym_GT_GT] = ACTIONS(4138),
    [anon_sym_GT_GT_GT] = ACTIONS(4138),
    [anon_sym_EQ_EQ] = ACTIONS(4135),
    [anon_sym_BANG_EQ] = ACTIONS(4135),
    [anon_sym_GT_EQ] = ACTIONS(4135),
    [anon_sym_LT_EQ] = ACTIONS(4135),
    [anon_sym_DOT] = ACTIONS(4138),
    [anon_sym_scoped] = ACTIONS(4113),
    [anon_sym_var] = ACTIONS(4113),
    [anon_sym_yield] = ACTIONS(4113),
    [anon_sym_switch] = ACTIONS(4138),
    [anon_sym_when] = ACTIONS(4113),
    [sym_discard] = ACTIONS(4113),
    [anon_sym_DOT_DOT] = ACTIONS(4135),
    [anon_sym_and] = ACTIONS(4113),
    [anon_sym_or] = ACTIONS(4113),
    [anon_sym_PLUS_EQ] = ACTIONS(4133),
    [anon_sym_DASH_EQ] = ACTIONS(4133),
    [anon_sym_STAR_EQ] = ACTIONS(4133),
    [anon_sym_SLASH_EQ] = ACTIONS(4133),
    [anon_sym_PERCENT_EQ] = ACTIONS(4133),
    [anon_sym_AMP_EQ] = ACTIONS(4133),
    [anon_sym_CARET_EQ] = ACTIONS(4133),
    [anon_sym_PIPE_EQ] = ACTIONS(4133),
    [anon_sym_LT_LT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4133),
    [anon_sym_AMP_AMP] = ACTIONS(4135),
    [anon_sym_PIPE_PIPE] = ACTIONS(4135),
    [anon_sym_QMARK_QMARK] = ACTIONS(4138),
    [anon_sym_from] = ACTIONS(4113),
    [anon_sym_into] = ACTIONS(4113),
    [anon_sym_join] = ACTIONS(4113),
    [anon_sym_on] = ACTIONS(4113),
    [anon_sym_equals] = ACTIONS(4113),
    [anon_sym_let] = ACTIONS(4113),
    [anon_sym_orderby] = ACTIONS(4113),
    [anon_sym_ascending] = ACTIONS(4113),
    [anon_sym_descending] = ACTIONS(4113),
    [anon_sym_group] = ACTIONS(4113),
    [anon_sym_by] = ACTIONS(4113),
    [anon_sym_select] = ACTIONS(4113),
    [anon_sym_as] = ACTIONS(4138),
    [anon_sym_is] = ACTIONS(4138),
    [anon_sym_DASH_GT] = ACTIONS(4135),
    [anon_sym_with] = ACTIONS(4138),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4124),
  },
  [2823] = {
    [sym_preproc_region] = STATE(2823),
    [sym_preproc_endregion] = STATE(2823),
    [sym_preproc_line] = STATE(2823),
    [sym_preproc_pragma] = STATE(2823),
    [sym_preproc_nullable] = STATE(2823),
    [sym_preproc_error] = STATE(2823),
    [sym_preproc_define] = STATE(2823),
    [sym_preproc_undef] = STATE(2823),
    [sym__identifier_token] = ACTIONS(4066),
    [anon_sym_alias] = ACTIONS(4066),
    [anon_sym_global] = ACTIONS(4066),
    [anon_sym_EQ] = ACTIONS(4066),
    [anon_sym_LBRACK] = ACTIONS(4068),
    [anon_sym_COLON] = ACTIONS(4068),
    [anon_sym_COMMA] = ACTIONS(4068),
    [anon_sym_LPAREN] = ACTIONS(4068),
    [anon_sym_LBRACE] = ACTIONS(4068),
    [anon_sym_file] = ACTIONS(4066),
    [anon_sym_LT] = ACTIONS(4066),
    [anon_sym_GT] = ACTIONS(4066),
    [anon_sym_where] = ACTIONS(4066),
    [anon_sym_QMARK] = ACTIONS(4066),
    [anon_sym_notnull] = ACTIONS(4066),
    [anon_sym_unmanaged] = ACTIONS(4066),
    [anon_sym_BANG] = ACTIONS(4066),
    [anon_sym_PLUS_PLUS] = ACTIONS(4068),
    [anon_sym_DASH_DASH] = ACTIONS(4068),
    [anon_sym_PLUS] = ACTIONS(4066),
    [anon_sym_DASH] = ACTIONS(4066),
    [anon_sym_STAR] = ACTIONS(4066),
    [anon_sym_SLASH] = ACTIONS(4066),
    [anon_sym_PERCENT] = ACTIONS(4066),
    [anon_sym_CARET] = ACTIONS(4066),
    [anon_sym_PIPE] = ACTIONS(4066),
    [anon_sym_AMP] = ACTIONS(4066),
    [anon_sym_LT_LT] = ACTIONS(4066),
    [anon_sym_GT_GT] = ACTIONS(4066),
    [anon_sym_GT_GT_GT] = ACTIONS(4066),
    [anon_sym_EQ_EQ] = ACTIONS(4068),
    [anon_sym_BANG_EQ] = ACTIONS(4068),
    [anon_sym_GT_EQ] = ACTIONS(4068),
    [anon_sym_LT_EQ] = ACTIONS(4068),
    [anon_sym_DOT] = ACTIONS(4066),
    [anon_sym_scoped] = ACTIONS(4066),
    [anon_sym_var] = ACTIONS(4066),
    [anon_sym_yield] = ACTIONS(4066),
    [anon_sym_switch] = ACTIONS(4066),
    [anon_sym_when] = ACTIONS(4066),
    [sym_discard] = ACTIONS(4066),
    [anon_sym_DOT_DOT] = ACTIONS(4068),
    [anon_sym_and] = ACTIONS(4066),
    [anon_sym_or] = ACTIONS(4066),
    [anon_sym_PLUS_EQ] = ACTIONS(4068),
    [anon_sym_DASH_EQ] = ACTIONS(4068),
    [anon_sym_STAR_EQ] = ACTIONS(4068),
    [anon_sym_SLASH_EQ] = ACTIONS(4068),
    [anon_sym_PERCENT_EQ] = ACTIONS(4068),
    [anon_sym_AMP_EQ] = ACTIONS(4068),
    [anon_sym_CARET_EQ] = ACTIONS(4068),
    [anon_sym_PIPE_EQ] = ACTIONS(4068),
    [anon_sym_LT_LT_EQ] = ACTIONS(4068),
    [anon_sym_GT_GT_EQ] = ACTIONS(4068),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4068),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4068),
    [anon_sym_AMP_AMP] = ACTIONS(4068),
    [anon_sym_PIPE_PIPE] = ACTIONS(4068),
    [anon_sym_QMARK_QMARK] = ACTIONS(4066),
    [anon_sym_from] = ACTIONS(4066),
    [anon_sym_into] = ACTIONS(4066),
    [anon_sym_join] = ACTIONS(4066),
    [anon_sym_on] = ACTIONS(4066),
    [anon_sym_equals] = ACTIONS(4066),
    [anon_sym_let] = ACTIONS(4066),
    [anon_sym_orderby] = ACTIONS(4066),
    [anon_sym_ascending] = ACTIONS(4066),
    [anon_sym_descending] = ACTIONS(4066),
    [anon_sym_group] = ACTIONS(4066),
    [anon_sym_by] = ACTIONS(4066),
    [anon_sym_select] = ACTIONS(4066),
    [anon_sym_as] = ACTIONS(4066),
    [anon_sym_is] = ACTIONS(4066),
    [anon_sym_DASH_GT] = ACTIONS(4068),
    [anon_sym_with] = ACTIONS(4066),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4068),
  },
  [2824] = {
    [sym_preproc_region] = STATE(2824),
    [sym_preproc_endregion] = STATE(2824),
    [sym_preproc_line] = STATE(2824),
    [sym_preproc_pragma] = STATE(2824),
    [sym_preproc_nullable] = STATE(2824),
    [sym_preproc_error] = STATE(2824),
    [sym_preproc_define] = STATE(2824),
    [sym_preproc_undef] = STATE(2824),
    [sym__identifier_token] = ACTIONS(4113),
    [anon_sym_alias] = ACTIONS(4113),
    [anon_sym_global] = ACTIONS(4113),
    [anon_sym_EQ] = ACTIONS(4118),
    [anon_sym_LBRACK] = ACTIONS(4120),
    [anon_sym_COLON] = ACTIONS(4115),
    [anon_sym_COMMA] = ACTIONS(4115),
    [anon_sym_LPAREN] = ACTIONS(4120),
    [anon_sym_LBRACE] = ACTIONS(4124),
    [anon_sym_file] = ACTIONS(4113),
    [anon_sym_LT] = ACTIONS(4126),
    [anon_sym_GT] = ACTIONS(4126),
    [anon_sym_where] = ACTIONS(4113),
    [anon_sym_QMARK] = ACTIONS(4126),
    [anon_sym_notnull] = ACTIONS(4113),
    [anon_sym_unmanaged] = ACTIONS(4113),
    [anon_sym_BANG] = ACTIONS(4126),
    [anon_sym_PLUS_PLUS] = ACTIONS(4120),
    [anon_sym_DASH_DASH] = ACTIONS(4120),
    [anon_sym_PLUS] = ACTIONS(4126),
    [anon_sym_DASH] = ACTIONS(4126),
    [anon_sym_STAR] = ACTIONS(4126),
    [anon_sym_SLASH] = ACTIONS(4126),
    [anon_sym_PERCENT] = ACTIONS(4126),
    [anon_sym_CARET] = ACTIONS(4126),
    [anon_sym_PIPE] = ACTIONS(4126),
    [anon_sym_AMP] = ACTIONS(4126),
    [anon_sym_LT_LT] = ACTIONS(4126),
    [anon_sym_GT_GT] = ACTIONS(4126),
    [anon_sym_GT_GT_GT] = ACTIONS(4126),
    [anon_sym_EQ_EQ] = ACTIONS(4120),
    [anon_sym_BANG_EQ] = ACTIONS(4120),
    [anon_sym_GT_EQ] = ACTIONS(4120),
    [anon_sym_LT_EQ] = ACTIONS(4120),
    [anon_sym_DOT] = ACTIONS(4126),
    [anon_sym_scoped] = ACTIONS(4113),
    [anon_sym_var] = ACTIONS(4113),
    [anon_sym_yield] = ACTIONS(4113),
    [anon_sym_switch] = ACTIONS(4126),
    [anon_sym_when] = ACTIONS(4113),
    [sym_discard] = ACTIONS(4113),
    [anon_sym_DOT_DOT] = ACTIONS(4120),
    [anon_sym_and] = ACTIONS(4130),
    [anon_sym_or] = ACTIONS(4130),
    [anon_sym_PLUS_EQ] = ACTIONS(4133),
    [anon_sym_DASH_EQ] = ACTIONS(4133),
    [anon_sym_STAR_EQ] = ACTIONS(4133),
    [anon_sym_SLASH_EQ] = ACTIONS(4133),
    [anon_sym_PERCENT_EQ] = ACTIONS(4133),
    [anon_sym_AMP_EQ] = ACTIONS(4133),
    [anon_sym_CARET_EQ] = ACTIONS(4133),
    [anon_sym_PIPE_EQ] = ACTIONS(4133),
    [anon_sym_LT_LT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4133),
    [anon_sym_AMP_AMP] = ACTIONS(4120),
    [anon_sym_PIPE_PIPE] = ACTIONS(4120),
    [anon_sym_QMARK_QMARK] = ACTIONS(4126),
    [anon_sym_from] = ACTIONS(4113),
    [anon_sym_into] = ACTIONS(4113),
    [anon_sym_join] = ACTIONS(4113),
    [anon_sym_on] = ACTIONS(4113),
    [anon_sym_equals] = ACTIONS(4113),
    [anon_sym_let] = ACTIONS(4113),
    [anon_sym_orderby] = ACTIONS(4113),
    [anon_sym_ascending] = ACTIONS(4113),
    [anon_sym_descending] = ACTIONS(4113),
    [anon_sym_group] = ACTIONS(4113),
    [anon_sym_by] = ACTIONS(4113),
    [anon_sym_select] = ACTIONS(4113),
    [anon_sym_as] = ACTIONS(4126),
    [anon_sym_is] = ACTIONS(4126),
    [anon_sym_DASH_GT] = ACTIONS(4120),
    [anon_sym_with] = ACTIONS(4126),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4115),
  },
  [2825] = {
    [sym_preproc_region] = STATE(2825),
    [sym_preproc_endregion] = STATE(2825),
    [sym_preproc_line] = STATE(2825),
    [sym_preproc_pragma] = STATE(2825),
    [sym_preproc_nullable] = STATE(2825),
    [sym_preproc_error] = STATE(2825),
    [sym_preproc_define] = STATE(2825),
    [sym_preproc_undef] = STATE(2825),
    [sym__identifier_token] = ACTIONS(4099),
    [anon_sym_alias] = ACTIONS(4099),
    [anon_sym_global] = ACTIONS(4099),
    [anon_sym_EQ] = ACTIONS(4104),
    [anon_sym_LBRACK] = ACTIONS(4101),
    [anon_sym_COLON] = ACTIONS(4101),
    [anon_sym_COMMA] = ACTIONS(4101),
    [anon_sym_LPAREN] = ACTIONS(4101),
    [anon_sym_LBRACE] = ACTIONS(4106),
    [anon_sym_file] = ACTIONS(4099),
    [anon_sym_LT] = ACTIONS(4108),
    [anon_sym_GT] = ACTIONS(4108),
    [anon_sym_where] = ACTIONS(4099),
    [anon_sym_QMARK] = ACTIONS(4108),
    [anon_sym_notnull] = ACTIONS(4099),
    [anon_sym_unmanaged] = ACTIONS(4099),
    [anon_sym_BANG] = ACTIONS(4108),
    [anon_sym_PLUS_PLUS] = ACTIONS(4101),
    [anon_sym_DASH_DASH] = ACTIONS(4101),
    [anon_sym_PLUS] = ACTIONS(4108),
    [anon_sym_DASH] = ACTIONS(4108),
    [anon_sym_STAR] = ACTIONS(4108),
    [anon_sym_SLASH] = ACTIONS(4108),
    [anon_sym_PERCENT] = ACTIONS(4108),
    [anon_sym_CARET] = ACTIONS(4108),
    [anon_sym_PIPE] = ACTIONS(4108),
    [anon_sym_AMP] = ACTIONS(4108),
    [anon_sym_LT_LT] = ACTIONS(4108),
    [anon_sym_GT_GT] = ACTIONS(4108),
    [anon_sym_GT_GT_GT] = ACTIONS(4108),
    [anon_sym_EQ_EQ] = ACTIONS(4101),
    [anon_sym_BANG_EQ] = ACTIONS(4101),
    [anon_sym_GT_EQ] = ACTIONS(4101),
    [anon_sym_LT_EQ] = ACTIONS(4101),
    [anon_sym_DOT] = ACTIONS(4108),
    [anon_sym_scoped] = ACTIONS(4099),
    [anon_sym_var] = ACTIONS(4099),
    [anon_sym_yield] = ACTIONS(4099),
    [anon_sym_switch] = ACTIONS(4108),
    [anon_sym_when] = ACTIONS(4099),
    [sym_discard] = ACTIONS(4099),
    [anon_sym_DOT_DOT] = ACTIONS(4101),
    [anon_sym_and] = ACTIONS(4108),
    [anon_sym_or] = ACTIONS(4108),
    [anon_sym_PLUS_EQ] = ACTIONS(4111),
    [anon_sym_DASH_EQ] = ACTIONS(4111),
    [anon_sym_STAR_EQ] = ACTIONS(4111),
    [anon_sym_SLASH_EQ] = ACTIONS(4111),
    [anon_sym_PERCENT_EQ] = ACTIONS(4111),
    [anon_sym_AMP_EQ] = ACTIONS(4111),
    [anon_sym_CARET_EQ] = ACTIONS(4111),
    [anon_sym_PIPE_EQ] = ACTIONS(4111),
    [anon_sym_LT_LT_EQ] = ACTIONS(4111),
    [anon_sym_GT_GT_EQ] = ACTIONS(4111),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4111),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4111),
    [anon_sym_AMP_AMP] = ACTIONS(4101),
    [anon_sym_PIPE_PIPE] = ACTIONS(4101),
    [anon_sym_QMARK_QMARK] = ACTIONS(4108),
    [anon_sym_from] = ACTIONS(4099),
    [anon_sym_into] = ACTIONS(4108),
    [anon_sym_join] = ACTIONS(4099),
    [anon_sym_on] = ACTIONS(4099),
    [anon_sym_equals] = ACTIONS(4099),
    [anon_sym_let] = ACTIONS(4099),
    [anon_sym_orderby] = ACTIONS(4099),
    [anon_sym_ascending] = ACTIONS(4099),
    [anon_sym_descending] = ACTIONS(4099),
    [anon_sym_group] = ACTIONS(4099),
    [anon_sym_by] = ACTIONS(4099),
    [anon_sym_select] = ACTIONS(4099),
    [anon_sym_as] = ACTIONS(4108),
    [anon_sym_is] = ACTIONS(4108),
    [anon_sym_DASH_GT] = ACTIONS(4101),
    [anon_sym_with] = ACTIONS(4108),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4101),
  },
  [2826] = {
    [sym_property_pattern_clause] = STATE(2869),
    [sym__variable_designation] = STATE(4057),
    [sym_parenthesized_variable_designation] = STATE(4015),
    [sym_identifier] = STATE(4020),
    [sym__reserved_identifier] = STATE(3908),
    [sym_preproc_region] = STATE(2826),
    [sym_preproc_endregion] = STATE(2826),
    [sym_preproc_line] = STATE(2826),
    [sym_preproc_pragma] = STATE(2826),
    [sym_preproc_nullable] = STATE(2826),
    [sym_preproc_error] = STATE(2826),
    [sym_preproc_define] = STATE(2826),
    [sym_preproc_undef] = STATE(2826),
    [sym__identifier_token] = ACTIONS(4271),
    [anon_sym_alias] = ACTIONS(4273),
    [anon_sym_SEMI] = ACTIONS(4335),
    [anon_sym_global] = ACTIONS(4273),
    [anon_sym_LBRACK] = ACTIONS(4335),
    [anon_sym_COLON] = ACTIONS(4335),
    [anon_sym_COMMA] = ACTIONS(4335),
    [anon_sym_RBRACK] = ACTIONS(4335),
    [anon_sym_LPAREN] = ACTIONS(4335),
    [anon_sym_RPAREN] = ACTIONS(4335),
    [anon_sym_LBRACE] = ACTIONS(4277),
    [anon_sym_RBRACE] = ACTIONS(4335),
    [anon_sym_file] = ACTIONS(4273),
    [anon_sym_LT] = ACTIONS(4337),
    [anon_sym_GT] = ACTIONS(4337),
    [anon_sym_in] = ACTIONS(4337),
    [anon_sym_where] = ACTIONS(4273),
    [anon_sym_QMARK] = ACTIONS(4337),
    [anon_sym_notnull] = ACTIONS(4273),
    [anon_sym_unmanaged] = ACTIONS(4273),
    [anon_sym_BANG] = ACTIONS(4337),
    [anon_sym_PLUS_PLUS] = ACTIONS(4335),
    [anon_sym_DASH_DASH] = ACTIONS(4335),
    [anon_sym_PLUS] = ACTIONS(4337),
    [anon_sym_DASH] = ACTIONS(4337),
    [anon_sym_STAR] = ACTIONS(4335),
    [anon_sym_SLASH] = ACTIONS(4337),
    [anon_sym_PERCENT] = ACTIONS(4335),
    [anon_sym_CARET] = ACTIONS(4335),
    [anon_sym_PIPE] = ACTIONS(4337),
    [anon_sym_AMP] = ACTIONS(4337),
    [anon_sym_LT_LT] = ACTIONS(4335),
    [anon_sym_GT_GT] = ACTIONS(4337),
    [anon_sym_GT_GT_GT] = ACTIONS(4335),
    [anon_sym_EQ_EQ] = ACTIONS(4335),
    [anon_sym_BANG_EQ] = ACTIONS(4335),
    [anon_sym_GT_EQ] = ACTIONS(4335),
    [anon_sym_LT_EQ] = ACTIONS(4335),
    [anon_sym_DOT] = ACTIONS(4337),
    [anon_sym_scoped] = ACTIONS(4273),
    [anon_sym_EQ_GT] = ACTIONS(4335),
    [anon_sym_var] = ACTIONS(4273),
    [anon_sym_yield] = ACTIONS(4273),
    [anon_sym_switch] = ACTIONS(4337),
    [anon_sym_when] = ACTIONS(4273),
    [sym_discard] = ACTIONS(4281),
    [anon_sym_DOT_DOT] = ACTIONS(4335),
    [anon_sym_and] = ACTIONS(4337),
    [anon_sym_or] = ACTIONS(4337),
    [anon_sym_AMP_AMP] = ACTIONS(4335),
    [anon_sym_PIPE_PIPE] = ACTIONS(4335),
    [anon_sym_QMARK_QMARK] = ACTIONS(4335),
    [anon_sym_from] = ACTIONS(4273),
    [anon_sym_into] = ACTIONS(4337),
    [anon_sym_join] = ACTIONS(4273),
    [anon_sym_on] = ACTIONS(4273),
    [anon_sym_equals] = ACTIONS(4273),
    [anon_sym_let] = ACTIONS(4273),
    [anon_sym_orderby] = ACTIONS(4273),
    [anon_sym_ascending] = ACTIONS(4273),
    [anon_sym_descending] = ACTIONS(4273),
    [anon_sym_group] = ACTIONS(4273),
    [anon_sym_by] = ACTIONS(4273),
    [anon_sym_select] = ACTIONS(4273),
    [anon_sym_as] = ACTIONS(4337),
    [anon_sym_is] = ACTIONS(4337),
    [anon_sym_DASH_GT] = ACTIONS(4335),
    [anon_sym_with] = ACTIONS(4337),
    [aux_sym_preproc_if_token3] = ACTIONS(4335),
    [aux_sym_preproc_else_token1] = ACTIONS(4335),
    [aux_sym_preproc_elif_token1] = ACTIONS(4335),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2827] = {
    [sym_preproc_region] = STATE(2827),
    [sym_preproc_endregion] = STATE(2827),
    [sym_preproc_line] = STATE(2827),
    [sym_preproc_pragma] = STATE(2827),
    [sym_preproc_nullable] = STATE(2827),
    [sym_preproc_error] = STATE(2827),
    [sym_preproc_define] = STATE(2827),
    [sym_preproc_undef] = STATE(2827),
    [sym__identifier_token] = ACTIONS(4056),
    [anon_sym_alias] = ACTIONS(4056),
    [anon_sym_global] = ACTIONS(4056),
    [anon_sym_EQ] = ACTIONS(4056),
    [anon_sym_LBRACK] = ACTIONS(4058),
    [anon_sym_COLON] = ACTIONS(4058),
    [anon_sym_COMMA] = ACTIONS(4058),
    [anon_sym_LPAREN] = ACTIONS(4058),
    [anon_sym_LBRACE] = ACTIONS(4058),
    [anon_sym_file] = ACTIONS(4056),
    [anon_sym_LT] = ACTIONS(4056),
    [anon_sym_GT] = ACTIONS(4056),
    [anon_sym_where] = ACTIONS(4056),
    [anon_sym_QMARK] = ACTIONS(4056),
    [anon_sym_notnull] = ACTIONS(4056),
    [anon_sym_unmanaged] = ACTIONS(4056),
    [anon_sym_BANG] = ACTIONS(4056),
    [anon_sym_PLUS_PLUS] = ACTIONS(4058),
    [anon_sym_DASH_DASH] = ACTIONS(4058),
    [anon_sym_PLUS] = ACTIONS(4056),
    [anon_sym_DASH] = ACTIONS(4056),
    [anon_sym_STAR] = ACTIONS(4056),
    [anon_sym_SLASH] = ACTIONS(4056),
    [anon_sym_PERCENT] = ACTIONS(4056),
    [anon_sym_CARET] = ACTIONS(4056),
    [anon_sym_PIPE] = ACTIONS(4056),
    [anon_sym_AMP] = ACTIONS(4056),
    [anon_sym_LT_LT] = ACTIONS(4056),
    [anon_sym_GT_GT] = ACTIONS(4056),
    [anon_sym_GT_GT_GT] = ACTIONS(4056),
    [anon_sym_EQ_EQ] = ACTIONS(4058),
    [anon_sym_BANG_EQ] = ACTIONS(4058),
    [anon_sym_GT_EQ] = ACTIONS(4058),
    [anon_sym_LT_EQ] = ACTIONS(4058),
    [anon_sym_DOT] = ACTIONS(4056),
    [anon_sym_scoped] = ACTIONS(4056),
    [anon_sym_var] = ACTIONS(4056),
    [anon_sym_yield] = ACTIONS(4056),
    [anon_sym_switch] = ACTIONS(4056),
    [anon_sym_when] = ACTIONS(4056),
    [sym_discard] = ACTIONS(4056),
    [anon_sym_DOT_DOT] = ACTIONS(4058),
    [anon_sym_and] = ACTIONS(4056),
    [anon_sym_or] = ACTIONS(4056),
    [anon_sym_PLUS_EQ] = ACTIONS(4058),
    [anon_sym_DASH_EQ] = ACTIONS(4058),
    [anon_sym_STAR_EQ] = ACTIONS(4058),
    [anon_sym_SLASH_EQ] = ACTIONS(4058),
    [anon_sym_PERCENT_EQ] = ACTIONS(4058),
    [anon_sym_AMP_EQ] = ACTIONS(4058),
    [anon_sym_CARET_EQ] = ACTIONS(4058),
    [anon_sym_PIPE_EQ] = ACTIONS(4058),
    [anon_sym_LT_LT_EQ] = ACTIONS(4058),
    [anon_sym_GT_GT_EQ] = ACTIONS(4058),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4058),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4058),
    [anon_sym_AMP_AMP] = ACTIONS(4058),
    [anon_sym_PIPE_PIPE] = ACTIONS(4058),
    [anon_sym_QMARK_QMARK] = ACTIONS(4056),
    [anon_sym_from] = ACTIONS(4056),
    [anon_sym_into] = ACTIONS(4056),
    [anon_sym_join] = ACTIONS(4056),
    [anon_sym_on] = ACTIONS(4056),
    [anon_sym_equals] = ACTIONS(4056),
    [anon_sym_let] = ACTIONS(4056),
    [anon_sym_orderby] = ACTIONS(4056),
    [anon_sym_ascending] = ACTIONS(4056),
    [anon_sym_descending] = ACTIONS(4056),
    [anon_sym_group] = ACTIONS(4056),
    [anon_sym_by] = ACTIONS(4056),
    [anon_sym_select] = ACTIONS(4056),
    [anon_sym_as] = ACTIONS(4056),
    [anon_sym_is] = ACTIONS(4056),
    [anon_sym_DASH_GT] = ACTIONS(4058),
    [anon_sym_with] = ACTIONS(4056),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4058),
  },
  [2828] = {
    [sym_preproc_region] = STATE(2828),
    [sym_preproc_endregion] = STATE(2828),
    [sym_preproc_line] = STATE(2828),
    [sym_preproc_pragma] = STATE(2828),
    [sym_preproc_nullable] = STATE(2828),
    [sym_preproc_error] = STATE(2828),
    [sym_preproc_define] = STATE(2828),
    [sym_preproc_undef] = STATE(2828),
    [sym__identifier_token] = ACTIONS(4099),
    [anon_sym_alias] = ACTIONS(4099),
    [anon_sym_global] = ACTIONS(4099),
    [anon_sym_EQ] = ACTIONS(4104),
    [anon_sym_LBRACK] = ACTIONS(4101),
    [anon_sym_COLON] = ACTIONS(4111),
    [anon_sym_COMMA] = ACTIONS(4106),
    [anon_sym_LPAREN] = ACTIONS(4101),
    [anon_sym_RPAREN] = ACTIONS(4106),
    [anon_sym_LBRACE] = ACTIONS(4106),
    [anon_sym_file] = ACTIONS(4099),
    [anon_sym_LT] = ACTIONS(4104),
    [anon_sym_GT] = ACTIONS(4104),
    [anon_sym_where] = ACTIONS(4099),
    [anon_sym_QMARK] = ACTIONS(4108),
    [anon_sym_notnull] = ACTIONS(4099),
    [anon_sym_unmanaged] = ACTIONS(4099),
    [anon_sym_BANG] = ACTIONS(4104),
    [anon_sym_PLUS_PLUS] = ACTIONS(4111),
    [anon_sym_DASH_DASH] = ACTIONS(4111),
    [anon_sym_PLUS] = ACTIONS(4104),
    [anon_sym_DASH] = ACTIONS(4104),
    [anon_sym_STAR] = ACTIONS(4108),
    [anon_sym_SLASH] = ACTIONS(4104),
    [anon_sym_PERCENT] = ACTIONS(4104),
    [anon_sym_CARET] = ACTIONS(4104),
    [anon_sym_PIPE] = ACTIONS(4104),
    [anon_sym_AMP] = ACTIONS(4104),
    [anon_sym_LT_LT] = ACTIONS(4104),
    [anon_sym_GT_GT] = ACTIONS(4104),
    [anon_sym_GT_GT_GT] = ACTIONS(4104),
    [anon_sym_EQ_EQ] = ACTIONS(4111),
    [anon_sym_BANG_EQ] = ACTIONS(4111),
    [anon_sym_GT_EQ] = ACTIONS(4111),
    [anon_sym_LT_EQ] = ACTIONS(4111),
    [anon_sym_DOT] = ACTIONS(4108),
    [anon_sym_scoped] = ACTIONS(4099),
    [anon_sym_var] = ACTIONS(4099),
    [anon_sym_yield] = ACTIONS(4099),
    [anon_sym_switch] = ACTIONS(4104),
    [anon_sym_when] = ACTIONS(4099),
    [sym_discard] = ACTIONS(4099),
    [anon_sym_DOT_DOT] = ACTIONS(4111),
    [anon_sym_and] = ACTIONS(4099),
    [anon_sym_or] = ACTIONS(4099),
    [anon_sym_PLUS_EQ] = ACTIONS(4111),
    [anon_sym_DASH_EQ] = ACTIONS(4111),
    [anon_sym_STAR_EQ] = ACTIONS(4111),
    [anon_sym_SLASH_EQ] = ACTIONS(4111),
    [anon_sym_PERCENT_EQ] = ACTIONS(4111),
    [anon_sym_AMP_EQ] = ACTIONS(4111),
    [anon_sym_CARET_EQ] = ACTIONS(4111),
    [anon_sym_PIPE_EQ] = ACTIONS(4111),
    [anon_sym_LT_LT_EQ] = ACTIONS(4111),
    [anon_sym_GT_GT_EQ] = ACTIONS(4111),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4111),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4111),
    [anon_sym_AMP_AMP] = ACTIONS(4111),
    [anon_sym_PIPE_PIPE] = ACTIONS(4111),
    [anon_sym_QMARK_QMARK] = ACTIONS(4104),
    [anon_sym_from] = ACTIONS(4099),
    [anon_sym_into] = ACTIONS(4099),
    [anon_sym_join] = ACTIONS(4099),
    [anon_sym_on] = ACTIONS(4099),
    [anon_sym_equals] = ACTIONS(4099),
    [anon_sym_let] = ACTIONS(4099),
    [anon_sym_orderby] = ACTIONS(4099),
    [anon_sym_ascending] = ACTIONS(4099),
    [anon_sym_descending] = ACTIONS(4099),
    [anon_sym_group] = ACTIONS(4099),
    [anon_sym_by] = ACTIONS(4099),
    [anon_sym_select] = ACTIONS(4099),
    [anon_sym_as] = ACTIONS(4104),
    [anon_sym_is] = ACTIONS(4104),
    [anon_sym_DASH_GT] = ACTIONS(4101),
    [anon_sym_with] = ACTIONS(4104),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2829] = {
    [sym_preproc_region] = STATE(2829),
    [sym_preproc_endregion] = STATE(2829),
    [sym_preproc_line] = STATE(2829),
    [sym_preproc_pragma] = STATE(2829),
    [sym_preproc_nullable] = STATE(2829),
    [sym_preproc_error] = STATE(2829),
    [sym_preproc_define] = STATE(2829),
    [sym_preproc_undef] = STATE(2829),
    [sym__identifier_token] = ACTIONS(4099),
    [anon_sym_alias] = ACTIONS(4099),
    [anon_sym_global] = ACTIONS(4099),
    [anon_sym_EQ] = ACTIONS(4104),
    [anon_sym_LBRACK] = ACTIONS(4101),
    [anon_sym_COLON] = ACTIONS(4111),
    [anon_sym_COMMA] = ACTIONS(4101),
    [anon_sym_LPAREN] = ACTIONS(4101),
    [anon_sym_RPAREN] = ACTIONS(4101),
    [anon_sym_LBRACE] = ACTIONS(4106),
    [anon_sym_file] = ACTIONS(4099),
    [anon_sym_LT] = ACTIONS(4104),
    [anon_sym_GT] = ACTIONS(4104),
    [anon_sym_where] = ACTIONS(4099),
    [anon_sym_QMARK] = ACTIONS(4108),
    [anon_sym_notnull] = ACTIONS(4099),
    [anon_sym_unmanaged] = ACTIONS(4099),
    [anon_sym_BANG] = ACTIONS(4104),
    [anon_sym_PLUS_PLUS] = ACTIONS(4111),
    [anon_sym_DASH_DASH] = ACTIONS(4111),
    [anon_sym_PLUS] = ACTIONS(4104),
    [anon_sym_DASH] = ACTIONS(4104),
    [anon_sym_STAR] = ACTIONS(4108),
    [anon_sym_SLASH] = ACTIONS(4104),
    [anon_sym_PERCENT] = ACTIONS(4104),
    [anon_sym_CARET] = ACTIONS(4104),
    [anon_sym_PIPE] = ACTIONS(4104),
    [anon_sym_AMP] = ACTIONS(4104),
    [anon_sym_LT_LT] = ACTIONS(4104),
    [anon_sym_GT_GT] = ACTIONS(4104),
    [anon_sym_GT_GT_GT] = ACTIONS(4104),
    [anon_sym_EQ_EQ] = ACTIONS(4111),
    [anon_sym_BANG_EQ] = ACTIONS(4111),
    [anon_sym_GT_EQ] = ACTIONS(4111),
    [anon_sym_LT_EQ] = ACTIONS(4111),
    [anon_sym_DOT] = ACTIONS(4108),
    [anon_sym_scoped] = ACTIONS(4099),
    [anon_sym_var] = ACTIONS(4099),
    [anon_sym_yield] = ACTIONS(4099),
    [anon_sym_switch] = ACTIONS(4104),
    [anon_sym_when] = ACTIONS(4099),
    [sym_discard] = ACTIONS(4099),
    [anon_sym_DOT_DOT] = ACTIONS(4111),
    [anon_sym_and] = ACTIONS(4099),
    [anon_sym_or] = ACTIONS(4099),
    [anon_sym_PLUS_EQ] = ACTIONS(4111),
    [anon_sym_DASH_EQ] = ACTIONS(4111),
    [anon_sym_STAR_EQ] = ACTIONS(4111),
    [anon_sym_SLASH_EQ] = ACTIONS(4111),
    [anon_sym_PERCENT_EQ] = ACTIONS(4111),
    [anon_sym_AMP_EQ] = ACTIONS(4111),
    [anon_sym_CARET_EQ] = ACTIONS(4111),
    [anon_sym_PIPE_EQ] = ACTIONS(4111),
    [anon_sym_LT_LT_EQ] = ACTIONS(4111),
    [anon_sym_GT_GT_EQ] = ACTIONS(4111),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4111),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4111),
    [anon_sym_AMP_AMP] = ACTIONS(4111),
    [anon_sym_PIPE_PIPE] = ACTIONS(4111),
    [anon_sym_QMARK_QMARK] = ACTIONS(4104),
    [anon_sym_from] = ACTIONS(4099),
    [anon_sym_into] = ACTIONS(4099),
    [anon_sym_join] = ACTIONS(4099),
    [anon_sym_on] = ACTIONS(4099),
    [anon_sym_equals] = ACTIONS(4099),
    [anon_sym_let] = ACTIONS(4099),
    [anon_sym_orderby] = ACTIONS(4099),
    [anon_sym_ascending] = ACTIONS(4099),
    [anon_sym_descending] = ACTIONS(4099),
    [anon_sym_group] = ACTIONS(4099),
    [anon_sym_by] = ACTIONS(4099),
    [anon_sym_select] = ACTIONS(4099),
    [anon_sym_as] = ACTIONS(4104),
    [anon_sym_is] = ACTIONS(4104),
    [anon_sym_DASH_GT] = ACTIONS(4101),
    [anon_sym_with] = ACTIONS(4104),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2830] = {
    [sym_preproc_region] = STATE(2830),
    [sym_preproc_endregion] = STATE(2830),
    [sym_preproc_line] = STATE(2830),
    [sym_preproc_pragma] = STATE(2830),
    [sym_preproc_nullable] = STATE(2830),
    [sym_preproc_error] = STATE(2830),
    [sym_preproc_define] = STATE(2830),
    [sym_preproc_undef] = STATE(2830),
    [sym__identifier_token] = ACTIONS(3721),
    [anon_sym_alias] = ACTIONS(3721),
    [anon_sym_global] = ACTIONS(3721),
    [anon_sym_EQ] = ACTIONS(3721),
    [anon_sym_LBRACK] = ACTIONS(3719),
    [anon_sym_COLON] = ACTIONS(3721),
    [anon_sym_COMMA] = ACTIONS(3719),
    [anon_sym_LPAREN] = ACTIONS(3719),
    [anon_sym_return] = ACTIONS(4339),
    [anon_sym_RBRACE] = ACTIONS(3719),
    [anon_sym_file] = ACTIONS(3721),
    [anon_sym_LT] = ACTIONS(3721),
    [anon_sym_GT] = ACTIONS(3721),
    [anon_sym_where] = ACTIONS(3721),
    [anon_sym_QMARK] = ACTIONS(3721),
    [anon_sym_notnull] = ACTIONS(3721),
    [anon_sym_unmanaged] = ACTIONS(3721),
    [anon_sym_BANG] = ACTIONS(3721),
    [anon_sym_PLUS_PLUS] = ACTIONS(3719),
    [anon_sym_DASH_DASH] = ACTIONS(3719),
    [anon_sym_PLUS] = ACTIONS(3721),
    [anon_sym_DASH] = ACTIONS(3721),
    [anon_sym_STAR] = ACTIONS(3721),
    [anon_sym_SLASH] = ACTIONS(3721),
    [anon_sym_PERCENT] = ACTIONS(3721),
    [anon_sym_CARET] = ACTIONS(3721),
    [anon_sym_PIPE] = ACTIONS(3721),
    [anon_sym_AMP] = ACTIONS(3721),
    [anon_sym_LT_LT] = ACTIONS(3721),
    [anon_sym_GT_GT] = ACTIONS(3721),
    [anon_sym_GT_GT_GT] = ACTIONS(3721),
    [anon_sym_EQ_EQ] = ACTIONS(3719),
    [anon_sym_BANG_EQ] = ACTIONS(3719),
    [anon_sym_GT_EQ] = ACTIONS(3719),
    [anon_sym_LT_EQ] = ACTIONS(3719),
    [anon_sym_DOT] = ACTIONS(3721),
    [anon_sym_scoped] = ACTIONS(3721),
    [anon_sym_EQ_GT] = ACTIONS(3719),
    [anon_sym_COLON_COLON] = ACTIONS(3719),
    [anon_sym_var] = ACTIONS(3721),
    [anon_sym_break] = ACTIONS(4341),
    [anon_sym_yield] = ACTIONS(3721),
    [anon_sym_switch] = ACTIONS(3721),
    [anon_sym_when] = ACTIONS(3721),
    [anon_sym_DOT_DOT] = ACTIONS(3719),
    [anon_sym_PLUS_EQ] = ACTIONS(3719),
    [anon_sym_DASH_EQ] = ACTIONS(3719),
    [anon_sym_STAR_EQ] = ACTIONS(3719),
    [anon_sym_SLASH_EQ] = ACTIONS(3719),
    [anon_sym_PERCENT_EQ] = ACTIONS(3719),
    [anon_sym_AMP_EQ] = ACTIONS(3719),
    [anon_sym_CARET_EQ] = ACTIONS(3719),
    [anon_sym_PIPE_EQ] = ACTIONS(3719),
    [anon_sym_LT_LT_EQ] = ACTIONS(3719),
    [anon_sym_GT_GT_EQ] = ACTIONS(3719),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3719),
    [anon_sym_AMP_AMP] = ACTIONS(3719),
    [anon_sym_PIPE_PIPE] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK] = ACTIONS(3721),
    [anon_sym_from] = ACTIONS(3721),
    [anon_sym_into] = ACTIONS(3721),
    [anon_sym_join] = ACTIONS(3721),
    [anon_sym_on] = ACTIONS(3721),
    [anon_sym_equals] = ACTIONS(3721),
    [anon_sym_let] = ACTIONS(3721),
    [anon_sym_orderby] = ACTIONS(3721),
    [anon_sym_ascending] = ACTIONS(3721),
    [anon_sym_descending] = ACTIONS(3721),
    [anon_sym_group] = ACTIONS(3721),
    [anon_sym_by] = ACTIONS(3721),
    [anon_sym_select] = ACTIONS(3721),
    [anon_sym_as] = ACTIONS(3721),
    [anon_sym_is] = ACTIONS(3721),
    [anon_sym_DASH_GT] = ACTIONS(3719),
    [anon_sym_with] = ACTIONS(3721),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2831] = {
    [sym_preproc_region] = STATE(2831),
    [sym_preproc_endregion] = STATE(2831),
    [sym_preproc_line] = STATE(2831),
    [sym_preproc_pragma] = STATE(2831),
    [sym_preproc_nullable] = STATE(2831),
    [sym_preproc_error] = STATE(2831),
    [sym_preproc_define] = STATE(2831),
    [sym_preproc_undef] = STATE(2831),
    [sym__identifier_token] = ACTIONS(4085),
    [anon_sym_alias] = ACTIONS(4085),
    [anon_sym_global] = ACTIONS(4085),
    [anon_sym_EQ] = ACTIONS(4085),
    [anon_sym_LBRACK] = ACTIONS(4087),
    [anon_sym_COLON] = ACTIONS(4087),
    [anon_sym_COMMA] = ACTIONS(4087),
    [anon_sym_LPAREN] = ACTIONS(4087),
    [anon_sym_LBRACE] = ACTIONS(4087),
    [anon_sym_file] = ACTIONS(4085),
    [anon_sym_LT] = ACTIONS(4085),
    [anon_sym_GT] = ACTIONS(4085),
    [anon_sym_where] = ACTIONS(4085),
    [anon_sym_QMARK] = ACTIONS(4085),
    [anon_sym_notnull] = ACTIONS(4085),
    [anon_sym_unmanaged] = ACTIONS(4085),
    [anon_sym_BANG] = ACTIONS(4085),
    [anon_sym_PLUS_PLUS] = ACTIONS(4087),
    [anon_sym_DASH_DASH] = ACTIONS(4087),
    [anon_sym_PLUS] = ACTIONS(4085),
    [anon_sym_DASH] = ACTIONS(4085),
    [anon_sym_STAR] = ACTIONS(4085),
    [anon_sym_SLASH] = ACTIONS(4085),
    [anon_sym_PERCENT] = ACTIONS(4085),
    [anon_sym_CARET] = ACTIONS(4085),
    [anon_sym_PIPE] = ACTIONS(4085),
    [anon_sym_AMP] = ACTIONS(4085),
    [anon_sym_LT_LT] = ACTIONS(4085),
    [anon_sym_GT_GT] = ACTIONS(4085),
    [anon_sym_GT_GT_GT] = ACTIONS(4085),
    [anon_sym_EQ_EQ] = ACTIONS(4087),
    [anon_sym_BANG_EQ] = ACTIONS(4087),
    [anon_sym_GT_EQ] = ACTIONS(4087),
    [anon_sym_LT_EQ] = ACTIONS(4087),
    [anon_sym_DOT] = ACTIONS(4085),
    [anon_sym_scoped] = ACTIONS(4085),
    [anon_sym_var] = ACTIONS(4085),
    [anon_sym_yield] = ACTIONS(4085),
    [anon_sym_switch] = ACTIONS(4085),
    [anon_sym_when] = ACTIONS(4085),
    [sym_discard] = ACTIONS(4085),
    [anon_sym_DOT_DOT] = ACTIONS(4087),
    [anon_sym_and] = ACTIONS(4085),
    [anon_sym_or] = ACTIONS(4085),
    [anon_sym_PLUS_EQ] = ACTIONS(4087),
    [anon_sym_DASH_EQ] = ACTIONS(4087),
    [anon_sym_STAR_EQ] = ACTIONS(4087),
    [anon_sym_SLASH_EQ] = ACTIONS(4087),
    [anon_sym_PERCENT_EQ] = ACTIONS(4087),
    [anon_sym_AMP_EQ] = ACTIONS(4087),
    [anon_sym_CARET_EQ] = ACTIONS(4087),
    [anon_sym_PIPE_EQ] = ACTIONS(4087),
    [anon_sym_LT_LT_EQ] = ACTIONS(4087),
    [anon_sym_GT_GT_EQ] = ACTIONS(4087),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4087),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4087),
    [anon_sym_AMP_AMP] = ACTIONS(4087),
    [anon_sym_PIPE_PIPE] = ACTIONS(4087),
    [anon_sym_QMARK_QMARK] = ACTIONS(4085),
    [anon_sym_from] = ACTIONS(4085),
    [anon_sym_into] = ACTIONS(4085),
    [anon_sym_join] = ACTIONS(4085),
    [anon_sym_on] = ACTIONS(4085),
    [anon_sym_equals] = ACTIONS(4085),
    [anon_sym_let] = ACTIONS(4085),
    [anon_sym_orderby] = ACTIONS(4085),
    [anon_sym_ascending] = ACTIONS(4085),
    [anon_sym_descending] = ACTIONS(4085),
    [anon_sym_group] = ACTIONS(4085),
    [anon_sym_by] = ACTIONS(4085),
    [anon_sym_select] = ACTIONS(4085),
    [anon_sym_as] = ACTIONS(4085),
    [anon_sym_is] = ACTIONS(4085),
    [anon_sym_DASH_GT] = ACTIONS(4087),
    [anon_sym_with] = ACTIONS(4085),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4087),
  },
  [2832] = {
    [sym_preproc_region] = STATE(2832),
    [sym_preproc_endregion] = STATE(2832),
    [sym_preproc_line] = STATE(2832),
    [sym_preproc_pragma] = STATE(2832),
    [sym_preproc_nullable] = STATE(2832),
    [sym_preproc_error] = STATE(2832),
    [sym_preproc_define] = STATE(2832),
    [sym_preproc_undef] = STATE(2832),
    [sym__identifier_token] = ACTIONS(4099),
    [anon_sym_alias] = ACTIONS(4099),
    [anon_sym_global] = ACTIONS(4099),
    [anon_sym_EQ] = ACTIONS(4104),
    [anon_sym_LBRACK] = ACTIONS(4101),
    [anon_sym_COLON] = ACTIONS(4101),
    [anon_sym_LPAREN] = ACTIONS(4101),
    [anon_sym_LBRACE] = ACTIONS(4106),
    [anon_sym_file] = ACTIONS(4099),
    [anon_sym_LT] = ACTIONS(4108),
    [anon_sym_GT] = ACTIONS(4108),
    [anon_sym_where] = ACTIONS(4099),
    [anon_sym_QMARK] = ACTIONS(4108),
    [anon_sym_notnull] = ACTIONS(4099),
    [anon_sym_unmanaged] = ACTIONS(4099),
    [anon_sym_BANG] = ACTIONS(4108),
    [anon_sym_PLUS_PLUS] = ACTIONS(4101),
    [anon_sym_DASH_DASH] = ACTIONS(4101),
    [anon_sym_PLUS] = ACTIONS(4108),
    [anon_sym_DASH] = ACTIONS(4108),
    [anon_sym_STAR] = ACTIONS(4108),
    [anon_sym_SLASH] = ACTIONS(4108),
    [anon_sym_PERCENT] = ACTIONS(4108),
    [anon_sym_CARET] = ACTIONS(4108),
    [anon_sym_PIPE] = ACTIONS(4108),
    [anon_sym_AMP] = ACTIONS(4108),
    [anon_sym_LT_LT] = ACTIONS(4108),
    [anon_sym_GT_GT] = ACTIONS(4108),
    [anon_sym_GT_GT_GT] = ACTIONS(4108),
    [anon_sym_EQ_EQ] = ACTIONS(4101),
    [anon_sym_BANG_EQ] = ACTIONS(4101),
    [anon_sym_GT_EQ] = ACTIONS(4101),
    [anon_sym_LT_EQ] = ACTIONS(4101),
    [anon_sym_DOT] = ACTIONS(4108),
    [anon_sym_scoped] = ACTIONS(4099),
    [anon_sym_EQ_GT] = ACTIONS(4101),
    [anon_sym_var] = ACTIONS(4099),
    [anon_sym_yield] = ACTIONS(4099),
    [anon_sym_switch] = ACTIONS(4108),
    [anon_sym_when] = ACTIONS(4108),
    [sym_discard] = ACTIONS(4099),
    [anon_sym_DOT_DOT] = ACTIONS(4101),
    [anon_sym_and] = ACTIONS(4108),
    [anon_sym_or] = ACTIONS(4108),
    [anon_sym_PLUS_EQ] = ACTIONS(4111),
    [anon_sym_DASH_EQ] = ACTIONS(4111),
    [anon_sym_STAR_EQ] = ACTIONS(4111),
    [anon_sym_SLASH_EQ] = ACTIONS(4111),
    [anon_sym_PERCENT_EQ] = ACTIONS(4111),
    [anon_sym_AMP_EQ] = ACTIONS(4111),
    [anon_sym_CARET_EQ] = ACTIONS(4111),
    [anon_sym_PIPE_EQ] = ACTIONS(4111),
    [anon_sym_LT_LT_EQ] = ACTIONS(4111),
    [anon_sym_GT_GT_EQ] = ACTIONS(4111),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4111),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4111),
    [anon_sym_AMP_AMP] = ACTIONS(4101),
    [anon_sym_PIPE_PIPE] = ACTIONS(4101),
    [anon_sym_QMARK_QMARK] = ACTIONS(4108),
    [anon_sym_from] = ACTIONS(4099),
    [anon_sym_into] = ACTIONS(4099),
    [anon_sym_join] = ACTIONS(4099),
    [anon_sym_on] = ACTIONS(4099),
    [anon_sym_equals] = ACTIONS(4099),
    [anon_sym_let] = ACTIONS(4099),
    [anon_sym_orderby] = ACTIONS(4099),
    [anon_sym_ascending] = ACTIONS(4099),
    [anon_sym_descending] = ACTIONS(4099),
    [anon_sym_group] = ACTIONS(4099),
    [anon_sym_by] = ACTIONS(4099),
    [anon_sym_select] = ACTIONS(4099),
    [anon_sym_as] = ACTIONS(4108),
    [anon_sym_is] = ACTIONS(4108),
    [anon_sym_DASH_GT] = ACTIONS(4101),
    [anon_sym_with] = ACTIONS(4108),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2833] = {
    [sym_type_argument_list] = STATE(2736),
    [sym_preproc_region] = STATE(2833),
    [sym_preproc_endregion] = STATE(2833),
    [sym_preproc_line] = STATE(2833),
    [sym_preproc_pragma] = STATE(2833),
    [sym_preproc_nullable] = STATE(2833),
    [sym_preproc_error] = STATE(2833),
    [sym_preproc_define] = STATE(2833),
    [sym_preproc_undef] = STATE(2833),
    [sym__identifier_token] = ACTIONS(4074),
    [anon_sym_alias] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4074),
    [anon_sym_EQ] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4076),
    [anon_sym_COLON] = ACTIONS(4343),
    [anon_sym_COMMA] = ACTIONS(4076),
    [anon_sym_LPAREN] = ACTIONS(4076),
    [anon_sym_RPAREN] = ACTIONS(4076),
    [anon_sym_file] = ACTIONS(4074),
    [anon_sym_LT] = ACTIONS(4078),
    [anon_sym_GT] = ACTIONS(4074),
    [anon_sym_where] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(4074),
    [anon_sym_notnull] = ACTIONS(4074),
    [anon_sym_unmanaged] = ACTIONS(4074),
    [anon_sym_BANG] = ACTIONS(4074),
    [anon_sym_PLUS_PLUS] = ACTIONS(4076),
    [anon_sym_DASH_DASH] = ACTIONS(4076),
    [anon_sym_PLUS] = ACTIONS(4074),
    [anon_sym_DASH] = ACTIONS(4074),
    [anon_sym_STAR] = ACTIONS(4074),
    [anon_sym_SLASH] = ACTIONS(4074),
    [anon_sym_PERCENT] = ACTIONS(4074),
    [anon_sym_CARET] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(4074),
    [anon_sym_AMP] = ACTIONS(4074),
    [anon_sym_LT_LT] = ACTIONS(4074),
    [anon_sym_GT_GT] = ACTIONS(4074),
    [anon_sym_GT_GT_GT] = ACTIONS(4074),
    [anon_sym_EQ_EQ] = ACTIONS(4076),
    [anon_sym_BANG_EQ] = ACTIONS(4076),
    [anon_sym_GT_EQ] = ACTIONS(4076),
    [anon_sym_LT_EQ] = ACTIONS(4076),
    [anon_sym_DOT] = ACTIONS(4074),
    [anon_sym_scoped] = ACTIONS(4074),
    [anon_sym_EQ_GT] = ACTIONS(4081),
    [anon_sym_COLON_COLON] = ACTIONS(4083),
    [anon_sym_var] = ACTIONS(4074),
    [anon_sym_yield] = ACTIONS(4074),
    [anon_sym_switch] = ACTIONS(4074),
    [anon_sym_when] = ACTIONS(4074),
    [anon_sym_DOT_DOT] = ACTIONS(4076),
    [anon_sym_PLUS_EQ] = ACTIONS(4076),
    [anon_sym_DASH_EQ] = ACTIONS(4076),
    [anon_sym_STAR_EQ] = ACTIONS(4076),
    [anon_sym_SLASH_EQ] = ACTIONS(4076),
    [anon_sym_PERCENT_EQ] = ACTIONS(4076),
    [anon_sym_AMP_EQ] = ACTIONS(4076),
    [anon_sym_CARET_EQ] = ACTIONS(4076),
    [anon_sym_PIPE_EQ] = ACTIONS(4076),
    [anon_sym_LT_LT_EQ] = ACTIONS(4076),
    [anon_sym_GT_GT_EQ] = ACTIONS(4076),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4076),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4076),
    [anon_sym_AMP_AMP] = ACTIONS(4076),
    [anon_sym_PIPE_PIPE] = ACTIONS(4076),
    [anon_sym_QMARK_QMARK] = ACTIONS(4074),
    [anon_sym_from] = ACTIONS(4074),
    [anon_sym_into] = ACTIONS(4074),
    [anon_sym_join] = ACTIONS(4074),
    [anon_sym_on] = ACTIONS(4074),
    [anon_sym_equals] = ACTIONS(4074),
    [anon_sym_let] = ACTIONS(4074),
    [anon_sym_orderby] = ACTIONS(4074),
    [anon_sym_ascending] = ACTIONS(4074),
    [anon_sym_descending] = ACTIONS(4074),
    [anon_sym_group] = ACTIONS(4074),
    [anon_sym_by] = ACTIONS(4074),
    [anon_sym_select] = ACTIONS(4074),
    [anon_sym_as] = ACTIONS(4074),
    [anon_sym_is] = ACTIONS(4074),
    [anon_sym_DASH_GT] = ACTIONS(4076),
    [anon_sym_with] = ACTIONS(4074),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2834] = {
    [sym_modifier] = STATE(3780),
    [sym_variable_declaration] = STATE(9527),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(6317),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_identifier] = STATE(6720),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(2834),
    [sym_preproc_endregion] = STATE(2834),
    [sym_preproc_line] = STATE(2834),
    [sym_preproc_pragma] = STATE(2834),
    [sym_preproc_nullable] = STATE(2834),
    [sym_preproc_error] = STATE(2834),
    [sym_preproc_define] = STATE(2834),
    [sym_preproc_undef] = STATE(2834),
    [aux_sym_class_declaration_repeat2] = STATE(3757),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_unsafe] = ACTIONS(63),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(2995),
    [anon_sym_event] = ACTIONS(4251),
    [anon_sym_class] = ACTIONS(4253),
    [anon_sym_ref] = ACTIONS(4255),
    [anon_sym_struct] = ACTIONS(4257),
    [anon_sym_enum] = ACTIONS(4259),
    [anon_sym_interface] = ACTIONS(4261),
    [anon_sym_delegate] = ACTIONS(4263),
    [anon_sym_record] = ACTIONS(4265),
    [anon_sym_abstract] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_file] = ACTIONS(3015),
    [anon_sym_fixed] = ACTIONS(63),
    [anon_sym_internal] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(63),
    [anon_sym_override] = ACTIONS(63),
    [anon_sym_partial] = ACTIONS(63),
    [anon_sym_private] = ACTIONS(63),
    [anon_sym_protected] = ACTIONS(63),
    [anon_sym_public] = ACTIONS(63),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_required] = ACTIONS(63),
    [anon_sym_sealed] = ACTIONS(63),
    [anon_sym_virtual] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_implicit] = ACTIONS(4269),
    [anon_sym_explicit] = ACTIONS(4269),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2835] = {
    [sym_type_argument_list] = STATE(2736),
    [sym_preproc_region] = STATE(2835),
    [sym_preproc_endregion] = STATE(2835),
    [sym_preproc_line] = STATE(2835),
    [sym_preproc_pragma] = STATE(2835),
    [sym_preproc_nullable] = STATE(2835),
    [sym_preproc_error] = STATE(2835),
    [sym_preproc_define] = STATE(2835),
    [sym_preproc_undef] = STATE(2835),
    [sym__identifier_token] = ACTIONS(4074),
    [anon_sym_alias] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4074),
    [anon_sym_EQ] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4076),
    [anon_sym_COLON] = ACTIONS(4345),
    [anon_sym_COMMA] = ACTIONS(4076),
    [anon_sym_LPAREN] = ACTIONS(4076),
    [anon_sym_RBRACE] = ACTIONS(4076),
    [anon_sym_file] = ACTIONS(4074),
    [anon_sym_LT] = ACTIONS(4078),
    [anon_sym_GT] = ACTIONS(4074),
    [anon_sym_where] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(4074),
    [anon_sym_notnull] = ACTIONS(4074),
    [anon_sym_unmanaged] = ACTIONS(4074),
    [anon_sym_BANG] = ACTIONS(4074),
    [anon_sym_PLUS_PLUS] = ACTIONS(4076),
    [anon_sym_DASH_DASH] = ACTIONS(4076),
    [anon_sym_PLUS] = ACTIONS(4074),
    [anon_sym_DASH] = ACTIONS(4074),
    [anon_sym_STAR] = ACTIONS(4074),
    [anon_sym_SLASH] = ACTIONS(4074),
    [anon_sym_PERCENT] = ACTIONS(4074),
    [anon_sym_CARET] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(4074),
    [anon_sym_AMP] = ACTIONS(4074),
    [anon_sym_LT_LT] = ACTIONS(4074),
    [anon_sym_GT_GT] = ACTIONS(4074),
    [anon_sym_GT_GT_GT] = ACTIONS(4074),
    [anon_sym_EQ_EQ] = ACTIONS(4076),
    [anon_sym_BANG_EQ] = ACTIONS(4076),
    [anon_sym_GT_EQ] = ACTIONS(4076),
    [anon_sym_LT_EQ] = ACTIONS(4076),
    [anon_sym_DOT] = ACTIONS(4074),
    [anon_sym_scoped] = ACTIONS(4074),
    [anon_sym_EQ_GT] = ACTIONS(4081),
    [anon_sym_COLON_COLON] = ACTIONS(4083),
    [anon_sym_var] = ACTIONS(4074),
    [anon_sym_yield] = ACTIONS(4074),
    [anon_sym_switch] = ACTIONS(4074),
    [anon_sym_when] = ACTIONS(4074),
    [anon_sym_DOT_DOT] = ACTIONS(4076),
    [anon_sym_PLUS_EQ] = ACTIONS(4076),
    [anon_sym_DASH_EQ] = ACTIONS(4076),
    [anon_sym_STAR_EQ] = ACTIONS(4076),
    [anon_sym_SLASH_EQ] = ACTIONS(4076),
    [anon_sym_PERCENT_EQ] = ACTIONS(4076),
    [anon_sym_AMP_EQ] = ACTIONS(4076),
    [anon_sym_CARET_EQ] = ACTIONS(4076),
    [anon_sym_PIPE_EQ] = ACTIONS(4076),
    [anon_sym_LT_LT_EQ] = ACTIONS(4076),
    [anon_sym_GT_GT_EQ] = ACTIONS(4076),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4076),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4076),
    [anon_sym_AMP_AMP] = ACTIONS(4076),
    [anon_sym_PIPE_PIPE] = ACTIONS(4076),
    [anon_sym_QMARK_QMARK] = ACTIONS(4074),
    [anon_sym_from] = ACTIONS(4074),
    [anon_sym_into] = ACTIONS(4074),
    [anon_sym_join] = ACTIONS(4074),
    [anon_sym_on] = ACTIONS(4074),
    [anon_sym_equals] = ACTIONS(4074),
    [anon_sym_let] = ACTIONS(4074),
    [anon_sym_orderby] = ACTIONS(4074),
    [anon_sym_ascending] = ACTIONS(4074),
    [anon_sym_descending] = ACTIONS(4074),
    [anon_sym_group] = ACTIONS(4074),
    [anon_sym_by] = ACTIONS(4074),
    [anon_sym_select] = ACTIONS(4074),
    [anon_sym_as] = ACTIONS(4074),
    [anon_sym_is] = ACTIONS(4074),
    [anon_sym_DASH_GT] = ACTIONS(4076),
    [anon_sym_with] = ACTIONS(4074),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2836] = {
    [sym_preproc_region] = STATE(2836),
    [sym_preproc_endregion] = STATE(2836),
    [sym_preproc_line] = STATE(2836),
    [sym_preproc_pragma] = STATE(2836),
    [sym_preproc_nullable] = STATE(2836),
    [sym_preproc_error] = STATE(2836),
    [sym_preproc_define] = STATE(2836),
    [sym_preproc_undef] = STATE(2836),
    [sym__identifier_token] = ACTIONS(4027),
    [anon_sym_alias] = ACTIONS(4027),
    [anon_sym_global] = ACTIONS(4027),
    [anon_sym_EQ] = ACTIONS(3721),
    [anon_sym_LBRACK] = ACTIONS(4024),
    [anon_sym_LPAREN] = ACTIONS(4024),
    [anon_sym_LBRACE] = ACTIONS(4024),
    [anon_sym_file] = ACTIONS(4027),
    [anon_sym_LT] = ACTIONS(4027),
    [anon_sym_GT] = ACTIONS(4027),
    [anon_sym_where] = ACTIONS(4027),
    [anon_sym_QMARK] = ACTIONS(4027),
    [anon_sym_notnull] = ACTIONS(4027),
    [anon_sym_unmanaged] = ACTIONS(4027),
    [anon_sym_BANG] = ACTIONS(4027),
    [anon_sym_PLUS_PLUS] = ACTIONS(4024),
    [anon_sym_DASH_DASH] = ACTIONS(4024),
    [anon_sym_PLUS] = ACTIONS(4027),
    [anon_sym_DASH] = ACTIONS(4027),
    [anon_sym_STAR] = ACTIONS(4027),
    [anon_sym_SLASH] = ACTIONS(4027),
    [anon_sym_PERCENT] = ACTIONS(4027),
    [anon_sym_CARET] = ACTIONS(4027),
    [anon_sym_PIPE] = ACTIONS(4027),
    [anon_sym_AMP] = ACTIONS(4027),
    [anon_sym_LT_LT] = ACTIONS(4027),
    [anon_sym_GT_GT] = ACTIONS(4027),
    [anon_sym_GT_GT_GT] = ACTIONS(4027),
    [anon_sym_EQ_EQ] = ACTIONS(4024),
    [anon_sym_BANG_EQ] = ACTIONS(4024),
    [anon_sym_GT_EQ] = ACTIONS(4024),
    [anon_sym_LT_EQ] = ACTIONS(4024),
    [anon_sym_DOT] = ACTIONS(4027),
    [anon_sym_scoped] = ACTIONS(4027),
    [anon_sym_EQ_GT] = ACTIONS(4024),
    [anon_sym_COLON_COLON] = ACTIONS(3719),
    [anon_sym_var] = ACTIONS(4027),
    [anon_sym_yield] = ACTIONS(4027),
    [anon_sym_switch] = ACTIONS(4027),
    [anon_sym_when] = ACTIONS(4027),
    [sym_discard] = ACTIONS(4027),
    [anon_sym_DOT_DOT] = ACTIONS(4024),
    [anon_sym_and] = ACTIONS(4027),
    [anon_sym_or] = ACTIONS(4027),
    [anon_sym_PLUS_EQ] = ACTIONS(3719),
    [anon_sym_DASH_EQ] = ACTIONS(3719),
    [anon_sym_STAR_EQ] = ACTIONS(3719),
    [anon_sym_SLASH_EQ] = ACTIONS(3719),
    [anon_sym_PERCENT_EQ] = ACTIONS(3719),
    [anon_sym_AMP_EQ] = ACTIONS(3719),
    [anon_sym_CARET_EQ] = ACTIONS(3719),
    [anon_sym_PIPE_EQ] = ACTIONS(3719),
    [anon_sym_LT_LT_EQ] = ACTIONS(3719),
    [anon_sym_GT_GT_EQ] = ACTIONS(3719),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3719),
    [anon_sym_AMP_AMP] = ACTIONS(4024),
    [anon_sym_PIPE_PIPE] = ACTIONS(4024),
    [anon_sym_QMARK_QMARK] = ACTIONS(4027),
    [anon_sym_from] = ACTIONS(4027),
    [anon_sym_into] = ACTIONS(4027),
    [anon_sym_join] = ACTIONS(4027),
    [anon_sym_on] = ACTIONS(4027),
    [anon_sym_equals] = ACTIONS(4027),
    [anon_sym_let] = ACTIONS(4027),
    [anon_sym_orderby] = ACTIONS(4027),
    [anon_sym_ascending] = ACTIONS(4027),
    [anon_sym_descending] = ACTIONS(4027),
    [anon_sym_group] = ACTIONS(4027),
    [anon_sym_by] = ACTIONS(4027),
    [anon_sym_select] = ACTIONS(4027),
    [anon_sym_as] = ACTIONS(4027),
    [anon_sym_is] = ACTIONS(4027),
    [anon_sym_DASH_GT] = ACTIONS(4024),
    [anon_sym_with] = ACTIONS(4027),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2837] = {
    [sym_preproc_region] = STATE(2837),
    [sym_preproc_endregion] = STATE(2837),
    [sym_preproc_line] = STATE(2837),
    [sym_preproc_pragma] = STATE(2837),
    [sym_preproc_nullable] = STATE(2837),
    [sym_preproc_error] = STATE(2837),
    [sym_preproc_define] = STATE(2837),
    [sym_preproc_undef] = STATE(2837),
    [sym__identifier_token] = ACTIONS(4099),
    [anon_sym_alias] = ACTIONS(4099),
    [anon_sym_global] = ACTIONS(4099),
    [anon_sym_EQ] = ACTIONS(4104),
    [anon_sym_LBRACK] = ACTIONS(4101),
    [anon_sym_COLON] = ACTIONS(4101),
    [anon_sym_LPAREN] = ACTIONS(4101),
    [anon_sym_LBRACE] = ACTIONS(4106),
    [anon_sym_file] = ACTIONS(4099),
    [anon_sym_LT] = ACTIONS(4104),
    [anon_sym_GT] = ACTIONS(4104),
    [anon_sym_where] = ACTIONS(4099),
    [anon_sym_QMARK] = ACTIONS(4108),
    [anon_sym_notnull] = ACTIONS(4099),
    [anon_sym_unmanaged] = ACTIONS(4099),
    [anon_sym_BANG] = ACTIONS(4104),
    [anon_sym_PLUS_PLUS] = ACTIONS(4111),
    [anon_sym_DASH_DASH] = ACTIONS(4111),
    [anon_sym_PLUS] = ACTIONS(4104),
    [anon_sym_DASH] = ACTIONS(4104),
    [anon_sym_STAR] = ACTIONS(4108),
    [anon_sym_SLASH] = ACTIONS(4104),
    [anon_sym_PERCENT] = ACTIONS(4104),
    [anon_sym_CARET] = ACTIONS(4104),
    [anon_sym_PIPE] = ACTIONS(4104),
    [anon_sym_AMP] = ACTIONS(4104),
    [anon_sym_LT_LT] = ACTIONS(4104),
    [anon_sym_GT_GT] = ACTIONS(4104),
    [anon_sym_GT_GT_GT] = ACTIONS(4104),
    [anon_sym_EQ_EQ] = ACTIONS(4111),
    [anon_sym_BANG_EQ] = ACTIONS(4111),
    [anon_sym_GT_EQ] = ACTIONS(4111),
    [anon_sym_LT_EQ] = ACTIONS(4111),
    [anon_sym_DOT] = ACTIONS(4108),
    [anon_sym_scoped] = ACTIONS(4099),
    [anon_sym_EQ_GT] = ACTIONS(4101),
    [anon_sym_var] = ACTIONS(4099),
    [anon_sym_yield] = ACTIONS(4099),
    [anon_sym_switch] = ACTIONS(4104),
    [anon_sym_when] = ACTIONS(4108),
    [sym_discard] = ACTIONS(4099),
    [anon_sym_DOT_DOT] = ACTIONS(4111),
    [anon_sym_and] = ACTIONS(4108),
    [anon_sym_or] = ACTIONS(4108),
    [anon_sym_PLUS_EQ] = ACTIONS(4111),
    [anon_sym_DASH_EQ] = ACTIONS(4111),
    [anon_sym_STAR_EQ] = ACTIONS(4111),
    [anon_sym_SLASH_EQ] = ACTIONS(4111),
    [anon_sym_PERCENT_EQ] = ACTIONS(4111),
    [anon_sym_AMP_EQ] = ACTIONS(4111),
    [anon_sym_CARET_EQ] = ACTIONS(4111),
    [anon_sym_PIPE_EQ] = ACTIONS(4111),
    [anon_sym_LT_LT_EQ] = ACTIONS(4111),
    [anon_sym_GT_GT_EQ] = ACTIONS(4111),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4111),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4111),
    [anon_sym_AMP_AMP] = ACTIONS(4111),
    [anon_sym_PIPE_PIPE] = ACTIONS(4111),
    [anon_sym_QMARK_QMARK] = ACTIONS(4104),
    [anon_sym_from] = ACTIONS(4099),
    [anon_sym_into] = ACTIONS(4099),
    [anon_sym_join] = ACTIONS(4099),
    [anon_sym_on] = ACTIONS(4099),
    [anon_sym_equals] = ACTIONS(4099),
    [anon_sym_let] = ACTIONS(4099),
    [anon_sym_orderby] = ACTIONS(4099),
    [anon_sym_ascending] = ACTIONS(4099),
    [anon_sym_descending] = ACTIONS(4099),
    [anon_sym_group] = ACTIONS(4099),
    [anon_sym_by] = ACTIONS(4099),
    [anon_sym_select] = ACTIONS(4099),
    [anon_sym_as] = ACTIONS(4104),
    [anon_sym_is] = ACTIONS(4104),
    [anon_sym_DASH_GT] = ACTIONS(4101),
    [anon_sym_with] = ACTIONS(4104),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2838] = {
    [sym_preproc_region] = STATE(2838),
    [sym_preproc_endregion] = STATE(2838),
    [sym_preproc_line] = STATE(2838),
    [sym_preproc_pragma] = STATE(2838),
    [sym_preproc_nullable] = STATE(2838),
    [sym_preproc_error] = STATE(2838),
    [sym_preproc_define] = STATE(2838),
    [sym_preproc_undef] = STATE(2838),
    [sym__identifier_token] = ACTIONS(4027),
    [anon_sym_alias] = ACTIONS(4027),
    [anon_sym_global] = ACTIONS(4027),
    [anon_sym_EQ] = ACTIONS(3721),
    [anon_sym_LBRACK] = ACTIONS(3719),
    [anon_sym_LPAREN] = ACTIONS(4024),
    [anon_sym_LBRACE] = ACTIONS(4024),
    [anon_sym_file] = ACTIONS(4027),
    [anon_sym_LT] = ACTIONS(3721),
    [anon_sym_GT] = ACTIONS(3721),
    [anon_sym_where] = ACTIONS(4027),
    [anon_sym_QMARK] = ACTIONS(3721),
    [anon_sym_notnull] = ACTIONS(4027),
    [anon_sym_unmanaged] = ACTIONS(4027),
    [anon_sym_BANG] = ACTIONS(3721),
    [anon_sym_PLUS_PLUS] = ACTIONS(3719),
    [anon_sym_DASH_DASH] = ACTIONS(3719),
    [anon_sym_PLUS] = ACTIONS(3721),
    [anon_sym_DASH] = ACTIONS(3721),
    [anon_sym_STAR] = ACTIONS(3721),
    [anon_sym_SLASH] = ACTIONS(3721),
    [anon_sym_PERCENT] = ACTIONS(3721),
    [anon_sym_CARET] = ACTIONS(3721),
    [anon_sym_PIPE] = ACTIONS(3721),
    [anon_sym_AMP] = ACTIONS(3721),
    [anon_sym_LT_LT] = ACTIONS(3721),
    [anon_sym_GT_GT] = ACTIONS(3721),
    [anon_sym_GT_GT_GT] = ACTIONS(3721),
    [anon_sym_EQ_EQ] = ACTIONS(3719),
    [anon_sym_BANG_EQ] = ACTIONS(3719),
    [anon_sym_GT_EQ] = ACTIONS(3719),
    [anon_sym_LT_EQ] = ACTIONS(3719),
    [anon_sym_DOT] = ACTIONS(3721),
    [anon_sym_scoped] = ACTIONS(4027),
    [anon_sym_EQ_GT] = ACTIONS(4024),
    [anon_sym_COLON_COLON] = ACTIONS(3719),
    [anon_sym_var] = ACTIONS(4027),
    [anon_sym_yield] = ACTIONS(4027),
    [anon_sym_switch] = ACTIONS(3721),
    [anon_sym_when] = ACTIONS(4027),
    [sym_discard] = ACTIONS(4027),
    [anon_sym_DOT_DOT] = ACTIONS(3719),
    [anon_sym_and] = ACTIONS(4027),
    [anon_sym_or] = ACTIONS(4027),
    [anon_sym_PLUS_EQ] = ACTIONS(3719),
    [anon_sym_DASH_EQ] = ACTIONS(3719),
    [anon_sym_STAR_EQ] = ACTIONS(3719),
    [anon_sym_SLASH_EQ] = ACTIONS(3719),
    [anon_sym_PERCENT_EQ] = ACTIONS(3719),
    [anon_sym_AMP_EQ] = ACTIONS(3719),
    [anon_sym_CARET_EQ] = ACTIONS(3719),
    [anon_sym_PIPE_EQ] = ACTIONS(3719),
    [anon_sym_LT_LT_EQ] = ACTIONS(3719),
    [anon_sym_GT_GT_EQ] = ACTIONS(3719),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3719),
    [anon_sym_AMP_AMP] = ACTIONS(3719),
    [anon_sym_PIPE_PIPE] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK] = ACTIONS(3721),
    [anon_sym_from] = ACTIONS(4027),
    [anon_sym_into] = ACTIONS(4027),
    [anon_sym_join] = ACTIONS(4027),
    [anon_sym_on] = ACTIONS(4027),
    [anon_sym_equals] = ACTIONS(4027),
    [anon_sym_let] = ACTIONS(4027),
    [anon_sym_orderby] = ACTIONS(4027),
    [anon_sym_ascending] = ACTIONS(4027),
    [anon_sym_descending] = ACTIONS(4027),
    [anon_sym_group] = ACTIONS(4027),
    [anon_sym_by] = ACTIONS(4027),
    [anon_sym_select] = ACTIONS(4027),
    [anon_sym_as] = ACTIONS(3721),
    [anon_sym_is] = ACTIONS(3721),
    [anon_sym_DASH_GT] = ACTIONS(3719),
    [anon_sym_with] = ACTIONS(3721),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2839] = {
    [sym_preproc_region] = STATE(2839),
    [sym_preproc_endregion] = STATE(2839),
    [sym_preproc_line] = STATE(2839),
    [sym_preproc_pragma] = STATE(2839),
    [sym_preproc_nullable] = STATE(2839),
    [sym_preproc_error] = STATE(2839),
    [sym_preproc_define] = STATE(2839),
    [sym_preproc_undef] = STATE(2839),
    [sym__identifier_token] = ACTIONS(4113),
    [anon_sym_alias] = ACTIONS(4113),
    [anon_sym_global] = ACTIONS(4113),
    [anon_sym_EQ] = ACTIONS(4118),
    [anon_sym_LBRACK] = ACTIONS(4135),
    [anon_sym_COLON] = ACTIONS(4120),
    [anon_sym_LPAREN] = ACTIONS(4135),
    [anon_sym_LBRACE] = ACTIONS(4124),
    [anon_sym_file] = ACTIONS(4113),
    [anon_sym_LT] = ACTIONS(4118),
    [anon_sym_GT] = ACTIONS(4118),
    [anon_sym_where] = ACTIONS(4113),
    [anon_sym_QMARK] = ACTIONS(4138),
    [anon_sym_notnull] = ACTIONS(4113),
    [anon_sym_unmanaged] = ACTIONS(4113),
    [anon_sym_BANG] = ACTIONS(4118),
    [anon_sym_PLUS_PLUS] = ACTIONS(4133),
    [anon_sym_DASH_DASH] = ACTIONS(4133),
    [anon_sym_PLUS] = ACTIONS(4118),
    [anon_sym_DASH] = ACTIONS(4118),
    [anon_sym_STAR] = ACTIONS(4138),
    [anon_sym_SLASH] = ACTIONS(4118),
    [anon_sym_PERCENT] = ACTIONS(4118),
    [anon_sym_CARET] = ACTIONS(4118),
    [anon_sym_PIPE] = ACTIONS(4118),
    [anon_sym_AMP] = ACTIONS(4118),
    [anon_sym_LT_LT] = ACTIONS(4118),
    [anon_sym_GT_GT] = ACTIONS(4118),
    [anon_sym_GT_GT_GT] = ACTIONS(4118),
    [anon_sym_EQ_EQ] = ACTIONS(4133),
    [anon_sym_BANG_EQ] = ACTIONS(4133),
    [anon_sym_GT_EQ] = ACTIONS(4133),
    [anon_sym_LT_EQ] = ACTIONS(4133),
    [anon_sym_DOT] = ACTIONS(4138),
    [anon_sym_scoped] = ACTIONS(4113),
    [anon_sym_EQ_GT] = ACTIONS(4115),
    [anon_sym_var] = ACTIONS(4113),
    [anon_sym_yield] = ACTIONS(4113),
    [anon_sym_switch] = ACTIONS(4118),
    [anon_sym_when] = ACTIONS(4130),
    [sym_discard] = ACTIONS(4113),
    [anon_sym_DOT_DOT] = ACTIONS(4133),
    [anon_sym_and] = ACTIONS(4130),
    [anon_sym_or] = ACTIONS(4130),
    [anon_sym_PLUS_EQ] = ACTIONS(4133),
    [anon_sym_DASH_EQ] = ACTIONS(4133),
    [anon_sym_STAR_EQ] = ACTIONS(4133),
    [anon_sym_SLASH_EQ] = ACTIONS(4133),
    [anon_sym_PERCENT_EQ] = ACTIONS(4133),
    [anon_sym_AMP_EQ] = ACTIONS(4133),
    [anon_sym_CARET_EQ] = ACTIONS(4133),
    [anon_sym_PIPE_EQ] = ACTIONS(4133),
    [anon_sym_LT_LT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4133),
    [anon_sym_AMP_AMP] = ACTIONS(4133),
    [anon_sym_PIPE_PIPE] = ACTIONS(4133),
    [anon_sym_QMARK_QMARK] = ACTIONS(4118),
    [anon_sym_from] = ACTIONS(4113),
    [anon_sym_into] = ACTIONS(4113),
    [anon_sym_join] = ACTIONS(4113),
    [anon_sym_on] = ACTIONS(4113),
    [anon_sym_equals] = ACTIONS(4113),
    [anon_sym_let] = ACTIONS(4113),
    [anon_sym_orderby] = ACTIONS(4113),
    [anon_sym_ascending] = ACTIONS(4113),
    [anon_sym_descending] = ACTIONS(4113),
    [anon_sym_group] = ACTIONS(4113),
    [anon_sym_by] = ACTIONS(4113),
    [anon_sym_select] = ACTIONS(4113),
    [anon_sym_as] = ACTIONS(4118),
    [anon_sym_is] = ACTIONS(4118),
    [anon_sym_DASH_GT] = ACTIONS(4135),
    [anon_sym_with] = ACTIONS(4118),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2840] = {
    [sym_property_pattern_clause] = STATE(2886),
    [sym__variable_designation] = STATE(4124),
    [sym_parenthesized_variable_designation] = STATE(4274),
    [sym_identifier] = STATE(4269),
    [sym__reserved_identifier] = STATE(3908),
    [sym_preproc_region] = STATE(2840),
    [sym_preproc_endregion] = STATE(2840),
    [sym_preproc_line] = STATE(2840),
    [sym_preproc_pragma] = STATE(2840),
    [sym_preproc_nullable] = STATE(2840),
    [sym_preproc_error] = STATE(2840),
    [sym_preproc_define] = STATE(2840),
    [sym_preproc_undef] = STATE(2840),
    [sym__identifier_token] = ACTIONS(4271),
    [anon_sym_alias] = ACTIONS(4273),
    [anon_sym_SEMI] = ACTIONS(4335),
    [anon_sym_global] = ACTIONS(4273),
    [anon_sym_LBRACK] = ACTIONS(4335),
    [anon_sym_COLON] = ACTIONS(4335),
    [anon_sym_COMMA] = ACTIONS(4335),
    [anon_sym_RBRACK] = ACTIONS(4335),
    [anon_sym_LPAREN] = ACTIONS(4335),
    [anon_sym_RPAREN] = ACTIONS(4335),
    [anon_sym_LBRACE] = ACTIONS(4277),
    [anon_sym_RBRACE] = ACTIONS(4335),
    [anon_sym_file] = ACTIONS(4273),
    [anon_sym_LT] = ACTIONS(4337),
    [anon_sym_GT] = ACTIONS(4337),
    [anon_sym_where] = ACTIONS(4273),
    [anon_sym_QMARK] = ACTIONS(4337),
    [anon_sym_notnull] = ACTIONS(4273),
    [anon_sym_unmanaged] = ACTIONS(4273),
    [anon_sym_BANG] = ACTIONS(4337),
    [anon_sym_PLUS_PLUS] = ACTIONS(4335),
    [anon_sym_DASH_DASH] = ACTIONS(4335),
    [anon_sym_PLUS] = ACTIONS(4337),
    [anon_sym_DASH] = ACTIONS(4337),
    [anon_sym_STAR] = ACTIONS(4335),
    [anon_sym_SLASH] = ACTIONS(4337),
    [anon_sym_PERCENT] = ACTIONS(4335),
    [anon_sym_CARET] = ACTIONS(4335),
    [anon_sym_PIPE] = ACTIONS(4337),
    [anon_sym_AMP] = ACTIONS(4337),
    [anon_sym_LT_LT] = ACTIONS(4335),
    [anon_sym_GT_GT] = ACTIONS(4337),
    [anon_sym_GT_GT_GT] = ACTIONS(4335),
    [anon_sym_EQ_EQ] = ACTIONS(4335),
    [anon_sym_BANG_EQ] = ACTIONS(4335),
    [anon_sym_GT_EQ] = ACTIONS(4335),
    [anon_sym_LT_EQ] = ACTIONS(4335),
    [anon_sym_DOT] = ACTIONS(4337),
    [anon_sym_scoped] = ACTIONS(4273),
    [anon_sym_EQ_GT] = ACTIONS(4335),
    [anon_sym_var] = ACTIONS(4273),
    [anon_sym_yield] = ACTIONS(4273),
    [anon_sym_switch] = ACTIONS(4337),
    [anon_sym_when] = ACTIONS(4273),
    [sym_discard] = ACTIONS(4295),
    [anon_sym_DOT_DOT] = ACTIONS(4335),
    [anon_sym_and] = ACTIONS(4337),
    [anon_sym_or] = ACTIONS(4337),
    [anon_sym_AMP_AMP] = ACTIONS(4335),
    [anon_sym_PIPE_PIPE] = ACTIONS(4335),
    [anon_sym_QMARK_QMARK] = ACTIONS(4335),
    [anon_sym_from] = ACTIONS(4273),
    [anon_sym_into] = ACTIONS(4273),
    [anon_sym_join] = ACTIONS(4273),
    [anon_sym_on] = ACTIONS(4273),
    [anon_sym_equals] = ACTIONS(4273),
    [anon_sym_let] = ACTIONS(4273),
    [anon_sym_orderby] = ACTIONS(4273),
    [anon_sym_ascending] = ACTIONS(4273),
    [anon_sym_descending] = ACTIONS(4273),
    [anon_sym_group] = ACTIONS(4273),
    [anon_sym_by] = ACTIONS(4273),
    [anon_sym_select] = ACTIONS(4273),
    [anon_sym_as] = ACTIONS(4337),
    [anon_sym_is] = ACTIONS(4337),
    [anon_sym_DASH_GT] = ACTIONS(4335),
    [anon_sym_with] = ACTIONS(4337),
    [aux_sym_preproc_if_token3] = ACTIONS(4335),
    [aux_sym_preproc_else_token1] = ACTIONS(4335),
    [aux_sym_preproc_elif_token1] = ACTIONS(4335),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2841] = {
    [sym_preproc_region] = STATE(2841),
    [sym_preproc_endregion] = STATE(2841),
    [sym_preproc_line] = STATE(2841),
    [sym_preproc_pragma] = STATE(2841),
    [sym_preproc_nullable] = STATE(2841),
    [sym_preproc_error] = STATE(2841),
    [sym_preproc_define] = STATE(2841),
    [sym_preproc_undef] = STATE(2841),
    [sym__identifier_token] = ACTIONS(4099),
    [anon_sym_alias] = ACTIONS(4099),
    [anon_sym_global] = ACTIONS(4099),
    [anon_sym_EQ] = ACTIONS(4104),
    [anon_sym_LBRACK] = ACTIONS(4101),
    [anon_sym_COLON] = ACTIONS(4101),
    [anon_sym_LPAREN] = ACTIONS(4101),
    [anon_sym_LBRACE] = ACTIONS(4106),
    [anon_sym_file] = ACTIONS(4099),
    [anon_sym_LT] = ACTIONS(4108),
    [anon_sym_GT] = ACTIONS(4108),
    [anon_sym_where] = ACTIONS(4099),
    [anon_sym_QMARK] = ACTIONS(4108),
    [anon_sym_notnull] = ACTIONS(4099),
    [anon_sym_unmanaged] = ACTIONS(4099),
    [anon_sym_BANG] = ACTIONS(4108),
    [anon_sym_PLUS_PLUS] = ACTIONS(4101),
    [anon_sym_DASH_DASH] = ACTIONS(4101),
    [anon_sym_PLUS] = ACTIONS(4108),
    [anon_sym_DASH] = ACTIONS(4108),
    [anon_sym_STAR] = ACTIONS(4108),
    [anon_sym_SLASH] = ACTIONS(4108),
    [anon_sym_PERCENT] = ACTIONS(4108),
    [anon_sym_CARET] = ACTIONS(4108),
    [anon_sym_PIPE] = ACTIONS(4108),
    [anon_sym_AMP] = ACTIONS(4108),
    [anon_sym_LT_LT] = ACTIONS(4108),
    [anon_sym_GT_GT] = ACTIONS(4108),
    [anon_sym_GT_GT_GT] = ACTIONS(4108),
    [anon_sym_EQ_EQ] = ACTIONS(4101),
    [anon_sym_BANG_EQ] = ACTIONS(4101),
    [anon_sym_GT_EQ] = ACTIONS(4101),
    [anon_sym_LT_EQ] = ACTIONS(4101),
    [anon_sym_DOT] = ACTIONS(4108),
    [anon_sym_scoped] = ACTIONS(4099),
    [anon_sym_EQ_GT] = ACTIONS(4101),
    [anon_sym_var] = ACTIONS(4099),
    [anon_sym_yield] = ACTIONS(4099),
    [anon_sym_switch] = ACTIONS(4108),
    [anon_sym_when] = ACTIONS(4108),
    [sym_discard] = ACTIONS(4099),
    [anon_sym_DOT_DOT] = ACTIONS(4101),
    [anon_sym_and] = ACTIONS(4108),
    [anon_sym_or] = ACTIONS(4108),
    [anon_sym_PLUS_EQ] = ACTIONS(4111),
    [anon_sym_DASH_EQ] = ACTIONS(4111),
    [anon_sym_STAR_EQ] = ACTIONS(4111),
    [anon_sym_SLASH_EQ] = ACTIONS(4111),
    [anon_sym_PERCENT_EQ] = ACTIONS(4111),
    [anon_sym_AMP_EQ] = ACTIONS(4111),
    [anon_sym_CARET_EQ] = ACTIONS(4111),
    [anon_sym_PIPE_EQ] = ACTIONS(4111),
    [anon_sym_LT_LT_EQ] = ACTIONS(4111),
    [anon_sym_GT_GT_EQ] = ACTIONS(4111),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4111),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4111),
    [anon_sym_AMP_AMP] = ACTIONS(4101),
    [anon_sym_PIPE_PIPE] = ACTIONS(4101),
    [anon_sym_QMARK_QMARK] = ACTIONS(4108),
    [anon_sym_from] = ACTIONS(4099),
    [anon_sym_into] = ACTIONS(4108),
    [anon_sym_join] = ACTIONS(4099),
    [anon_sym_on] = ACTIONS(4099),
    [anon_sym_equals] = ACTIONS(4099),
    [anon_sym_let] = ACTIONS(4099),
    [anon_sym_orderby] = ACTIONS(4099),
    [anon_sym_ascending] = ACTIONS(4099),
    [anon_sym_descending] = ACTIONS(4099),
    [anon_sym_group] = ACTIONS(4099),
    [anon_sym_by] = ACTIONS(4099),
    [anon_sym_select] = ACTIONS(4099),
    [anon_sym_as] = ACTIONS(4108),
    [anon_sym_is] = ACTIONS(4108),
    [anon_sym_DASH_GT] = ACTIONS(4101),
    [anon_sym_with] = ACTIONS(4108),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2842] = {
    [sym_property_pattern_clause] = STATE(2880),
    [sym__variable_designation] = STATE(4256),
    [sym_parenthesized_variable_designation] = STATE(4274),
    [sym_identifier] = STATE(4269),
    [sym__reserved_identifier] = STATE(3908),
    [sym_preproc_region] = STATE(2842),
    [sym_preproc_endregion] = STATE(2842),
    [sym_preproc_line] = STATE(2842),
    [sym_preproc_pragma] = STATE(2842),
    [sym_preproc_nullable] = STATE(2842),
    [sym_preproc_error] = STATE(2842),
    [sym_preproc_define] = STATE(2842),
    [sym_preproc_undef] = STATE(2842),
    [sym__identifier_token] = ACTIONS(4271),
    [anon_sym_alias] = ACTIONS(4273),
    [anon_sym_SEMI] = ACTIONS(4329),
    [anon_sym_global] = ACTIONS(4273),
    [anon_sym_LBRACK] = ACTIONS(4329),
    [anon_sym_COLON] = ACTIONS(4329),
    [anon_sym_COMMA] = ACTIONS(4329),
    [anon_sym_RBRACK] = ACTIONS(4329),
    [anon_sym_LPAREN] = ACTIONS(4329),
    [anon_sym_RPAREN] = ACTIONS(4329),
    [anon_sym_LBRACE] = ACTIONS(4277),
    [anon_sym_RBRACE] = ACTIONS(4329),
    [anon_sym_file] = ACTIONS(4273),
    [anon_sym_LT] = ACTIONS(4331),
    [anon_sym_GT] = ACTIONS(4331),
    [anon_sym_where] = ACTIONS(4273),
    [anon_sym_QMARK] = ACTIONS(4331),
    [anon_sym_notnull] = ACTIONS(4273),
    [anon_sym_unmanaged] = ACTIONS(4273),
    [anon_sym_BANG] = ACTIONS(4331),
    [anon_sym_PLUS_PLUS] = ACTIONS(4329),
    [anon_sym_DASH_DASH] = ACTIONS(4329),
    [anon_sym_PLUS] = ACTIONS(4331),
    [anon_sym_DASH] = ACTIONS(4331),
    [anon_sym_STAR] = ACTIONS(4329),
    [anon_sym_SLASH] = ACTIONS(4331),
    [anon_sym_PERCENT] = ACTIONS(4329),
    [anon_sym_CARET] = ACTIONS(4329),
    [anon_sym_PIPE] = ACTIONS(4331),
    [anon_sym_AMP] = ACTIONS(4331),
    [anon_sym_LT_LT] = ACTIONS(4329),
    [anon_sym_GT_GT] = ACTIONS(4331),
    [anon_sym_GT_GT_GT] = ACTIONS(4329),
    [anon_sym_EQ_EQ] = ACTIONS(4329),
    [anon_sym_BANG_EQ] = ACTIONS(4329),
    [anon_sym_GT_EQ] = ACTIONS(4329),
    [anon_sym_LT_EQ] = ACTIONS(4329),
    [anon_sym_DOT] = ACTIONS(4331),
    [anon_sym_scoped] = ACTIONS(4273),
    [anon_sym_EQ_GT] = ACTIONS(4329),
    [anon_sym_var] = ACTIONS(4273),
    [anon_sym_yield] = ACTIONS(4273),
    [anon_sym_switch] = ACTIONS(4331),
    [anon_sym_when] = ACTIONS(4273),
    [sym_discard] = ACTIONS(4295),
    [anon_sym_DOT_DOT] = ACTIONS(4329),
    [anon_sym_and] = ACTIONS(4331),
    [anon_sym_or] = ACTIONS(4331),
    [anon_sym_AMP_AMP] = ACTIONS(4329),
    [anon_sym_PIPE_PIPE] = ACTIONS(4329),
    [anon_sym_QMARK_QMARK] = ACTIONS(4329),
    [anon_sym_from] = ACTIONS(4273),
    [anon_sym_into] = ACTIONS(4273),
    [anon_sym_join] = ACTIONS(4273),
    [anon_sym_on] = ACTIONS(4273),
    [anon_sym_equals] = ACTIONS(4273),
    [anon_sym_let] = ACTIONS(4273),
    [anon_sym_orderby] = ACTIONS(4273),
    [anon_sym_ascending] = ACTIONS(4273),
    [anon_sym_descending] = ACTIONS(4273),
    [anon_sym_group] = ACTIONS(4273),
    [anon_sym_by] = ACTIONS(4273),
    [anon_sym_select] = ACTIONS(4273),
    [anon_sym_as] = ACTIONS(4331),
    [anon_sym_is] = ACTIONS(4331),
    [anon_sym_DASH_GT] = ACTIONS(4329),
    [anon_sym_with] = ACTIONS(4331),
    [aux_sym_preproc_if_token3] = ACTIONS(4329),
    [aux_sym_preproc_else_token1] = ACTIONS(4329),
    [aux_sym_preproc_elif_token1] = ACTIONS(4329),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2843] = {
    [sym_parameter_list] = STATE(9765),
    [sym__lambda_parameters] = STATE(9127),
    [sym_identifier] = STATE(9443),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_region] = STATE(2843),
    [sym_preproc_endregion] = STATE(2843),
    [sym_preproc_line] = STATE(2843),
    [sym_preproc_pragma] = STATE(2843),
    [sym_preproc_nullable] = STATE(2843),
    [sym_preproc_error] = STATE(2843),
    [sym_preproc_define] = STATE(2843),
    [sym_preproc_undef] = STATE(2843),
    [sym__identifier_token] = ACTIONS(4347),
    [anon_sym_alias] = ACTIONS(4347),
    [anon_sym_SEMI] = ACTIONS(4349),
    [anon_sym_global] = ACTIONS(4347),
    [anon_sym_LBRACK] = ACTIONS(4349),
    [anon_sym_COLON] = ACTIONS(4349),
    [anon_sym_COMMA] = ACTIONS(4349),
    [anon_sym_RBRACK] = ACTIONS(4349),
    [anon_sym_LPAREN] = ACTIONS(4349),
    [anon_sym_RPAREN] = ACTIONS(4349),
    [anon_sym_LBRACE] = ACTIONS(4349),
    [anon_sym_RBRACE] = ACTIONS(4349),
    [anon_sym_file] = ACTIONS(4347),
    [anon_sym_LT] = ACTIONS(4347),
    [anon_sym_GT] = ACTIONS(4347),
    [anon_sym_in] = ACTIONS(4347),
    [anon_sym_where] = ACTIONS(4347),
    [anon_sym_QMARK] = ACTIONS(4347),
    [anon_sym_notnull] = ACTIONS(4347),
    [anon_sym_unmanaged] = ACTIONS(4347),
    [anon_sym_BANG] = ACTIONS(4347),
    [anon_sym_PLUS_PLUS] = ACTIONS(4349),
    [anon_sym_DASH_DASH] = ACTIONS(4349),
    [anon_sym_PLUS] = ACTIONS(4347),
    [anon_sym_DASH] = ACTIONS(4347),
    [anon_sym_STAR] = ACTIONS(4349),
    [anon_sym_SLASH] = ACTIONS(4347),
    [anon_sym_PERCENT] = ACTIONS(4349),
    [anon_sym_CARET] = ACTIONS(4349),
    [anon_sym_PIPE] = ACTIONS(4347),
    [anon_sym_AMP] = ACTIONS(4347),
    [anon_sym_LT_LT] = ACTIONS(4349),
    [anon_sym_GT_GT] = ACTIONS(4347),
    [anon_sym_GT_GT_GT] = ACTIONS(4349),
    [anon_sym_EQ_EQ] = ACTIONS(4349),
    [anon_sym_BANG_EQ] = ACTIONS(4349),
    [anon_sym_GT_EQ] = ACTIONS(4349),
    [anon_sym_LT_EQ] = ACTIONS(4349),
    [anon_sym_DOT] = ACTIONS(4347),
    [anon_sym_scoped] = ACTIONS(4347),
    [anon_sym_EQ_GT] = ACTIONS(4349),
    [anon_sym_var] = ACTIONS(4347),
    [anon_sym_yield] = ACTIONS(4347),
    [anon_sym_switch] = ACTIONS(4347),
    [anon_sym_when] = ACTIONS(4347),
    [sym_discard] = ACTIONS(4347),
    [anon_sym_DOT_DOT] = ACTIONS(4349),
    [anon_sym_and] = ACTIONS(4347),
    [anon_sym_or] = ACTIONS(4347),
    [anon_sym_AMP_AMP] = ACTIONS(4349),
    [anon_sym_PIPE_PIPE] = ACTIONS(4349),
    [anon_sym_QMARK_QMARK] = ACTIONS(4349),
    [anon_sym_from] = ACTIONS(4347),
    [anon_sym_into] = ACTIONS(4347),
    [anon_sym_join] = ACTIONS(4347),
    [anon_sym_on] = ACTIONS(4347),
    [anon_sym_equals] = ACTIONS(4347),
    [anon_sym_let] = ACTIONS(4347),
    [anon_sym_orderby] = ACTIONS(4347),
    [anon_sym_ascending] = ACTIONS(4347),
    [anon_sym_descending] = ACTIONS(4347),
    [anon_sym_group] = ACTIONS(4347),
    [anon_sym_by] = ACTIONS(4347),
    [anon_sym_select] = ACTIONS(4347),
    [anon_sym_as] = ACTIONS(4347),
    [anon_sym_is] = ACTIONS(4347),
    [anon_sym_DASH_GT] = ACTIONS(4349),
    [anon_sym_with] = ACTIONS(4347),
    [aux_sym_preproc_if_token3] = ACTIONS(4349),
    [aux_sym_preproc_else_token1] = ACTIONS(4349),
    [aux_sym_preproc_elif_token1] = ACTIONS(4349),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2844] = {
    [sym_modifier] = STATE(3780),
    [sym_variable_declaration] = STATE(9700),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(6507),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_identifier] = STATE(6713),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(2844),
    [sym_preproc_endregion] = STATE(2844),
    [sym_preproc_line] = STATE(2844),
    [sym_preproc_pragma] = STATE(2844),
    [sym_preproc_nullable] = STATE(2844),
    [sym_preproc_error] = STATE(2844),
    [sym_preproc_define] = STATE(2844),
    [sym_preproc_undef] = STATE(2844),
    [aux_sym_class_declaration_repeat2] = STATE(3757),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_unsafe] = ACTIONS(63),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(2995),
    [anon_sym_event] = ACTIONS(4351),
    [anon_sym_class] = ACTIONS(4353),
    [anon_sym_ref] = ACTIONS(4355),
    [anon_sym_struct] = ACTIONS(4357),
    [anon_sym_enum] = ACTIONS(4359),
    [anon_sym_interface] = ACTIONS(4361),
    [anon_sym_delegate] = ACTIONS(4363),
    [anon_sym_record] = ACTIONS(4365),
    [anon_sym_abstract] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_file] = ACTIONS(3015),
    [anon_sym_fixed] = ACTIONS(63),
    [anon_sym_internal] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(63),
    [anon_sym_override] = ACTIONS(63),
    [anon_sym_partial] = ACTIONS(63),
    [anon_sym_private] = ACTIONS(63),
    [anon_sym_protected] = ACTIONS(63),
    [anon_sym_public] = ACTIONS(63),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_required] = ACTIONS(63),
    [anon_sym_sealed] = ACTIONS(63),
    [anon_sym_virtual] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_implicit] = ACTIONS(4367),
    [anon_sym_explicit] = ACTIONS(4367),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2845] = {
    [sym_preproc_region] = STATE(2845),
    [sym_preproc_endregion] = STATE(2845),
    [sym_preproc_line] = STATE(2845),
    [sym_preproc_pragma] = STATE(2845),
    [sym_preproc_nullable] = STATE(2845),
    [sym_preproc_error] = STATE(2845),
    [sym_preproc_define] = STATE(2845),
    [sym_preproc_undef] = STATE(2845),
    [sym__identifier_token] = ACTIONS(4113),
    [anon_sym_alias] = ACTIONS(4113),
    [anon_sym_global] = ACTIONS(4113),
    [anon_sym_EQ] = ACTIONS(4118),
    [anon_sym_LBRACK] = ACTIONS(4120),
    [anon_sym_COLON] = ACTIONS(4115),
    [anon_sym_LPAREN] = ACTIONS(4120),
    [anon_sym_LBRACE] = ACTIONS(4124),
    [anon_sym_file] = ACTIONS(4113),
    [anon_sym_LT] = ACTIONS(4126),
    [anon_sym_GT] = ACTIONS(4126),
    [anon_sym_where] = ACTIONS(4113),
    [anon_sym_QMARK] = ACTIONS(4126),
    [anon_sym_notnull] = ACTIONS(4113),
    [anon_sym_unmanaged] = ACTIONS(4113),
    [anon_sym_BANG] = ACTIONS(4126),
    [anon_sym_PLUS_PLUS] = ACTIONS(4120),
    [anon_sym_DASH_DASH] = ACTIONS(4120),
    [anon_sym_PLUS] = ACTIONS(4126),
    [anon_sym_DASH] = ACTIONS(4126),
    [anon_sym_STAR] = ACTIONS(4126),
    [anon_sym_SLASH] = ACTIONS(4126),
    [anon_sym_PERCENT] = ACTIONS(4126),
    [anon_sym_CARET] = ACTIONS(4126),
    [anon_sym_PIPE] = ACTIONS(4126),
    [anon_sym_AMP] = ACTIONS(4126),
    [anon_sym_LT_LT] = ACTIONS(4126),
    [anon_sym_GT_GT] = ACTIONS(4126),
    [anon_sym_GT_GT_GT] = ACTIONS(4126),
    [anon_sym_EQ_EQ] = ACTIONS(4120),
    [anon_sym_BANG_EQ] = ACTIONS(4120),
    [anon_sym_GT_EQ] = ACTIONS(4120),
    [anon_sym_LT_EQ] = ACTIONS(4120),
    [anon_sym_DOT] = ACTIONS(4126),
    [anon_sym_scoped] = ACTIONS(4113),
    [anon_sym_EQ_GT] = ACTIONS(4115),
    [anon_sym_var] = ACTIONS(4113),
    [anon_sym_yield] = ACTIONS(4113),
    [anon_sym_switch] = ACTIONS(4126),
    [anon_sym_when] = ACTIONS(4130),
    [sym_discard] = ACTIONS(4113),
    [anon_sym_DOT_DOT] = ACTIONS(4120),
    [anon_sym_and] = ACTIONS(4130),
    [anon_sym_or] = ACTIONS(4130),
    [anon_sym_PLUS_EQ] = ACTIONS(4133),
    [anon_sym_DASH_EQ] = ACTIONS(4133),
    [anon_sym_STAR_EQ] = ACTIONS(4133),
    [anon_sym_SLASH_EQ] = ACTIONS(4133),
    [anon_sym_PERCENT_EQ] = ACTIONS(4133),
    [anon_sym_AMP_EQ] = ACTIONS(4133),
    [anon_sym_CARET_EQ] = ACTIONS(4133),
    [anon_sym_PIPE_EQ] = ACTIONS(4133),
    [anon_sym_LT_LT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4133),
    [anon_sym_AMP_AMP] = ACTIONS(4120),
    [anon_sym_PIPE_PIPE] = ACTIONS(4120),
    [anon_sym_QMARK_QMARK] = ACTIONS(4126),
    [anon_sym_from] = ACTIONS(4113),
    [anon_sym_into] = ACTIONS(4130),
    [anon_sym_join] = ACTIONS(4113),
    [anon_sym_on] = ACTIONS(4113),
    [anon_sym_equals] = ACTIONS(4113),
    [anon_sym_let] = ACTIONS(4113),
    [anon_sym_orderby] = ACTIONS(4113),
    [anon_sym_ascending] = ACTIONS(4113),
    [anon_sym_descending] = ACTIONS(4113),
    [anon_sym_group] = ACTIONS(4113),
    [anon_sym_by] = ACTIONS(4113),
    [anon_sym_select] = ACTIONS(4113),
    [anon_sym_as] = ACTIONS(4126),
    [anon_sym_is] = ACTIONS(4126),
    [anon_sym_DASH_GT] = ACTIONS(4120),
    [anon_sym_with] = ACTIONS(4126),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2846] = {
    [sym__name] = STATE(3184),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2977),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2956),
    [sym_ref_type] = STATE(2899),
    [sym__scoped_base_type] = STATE(2907),
    [sym_identifier] = STATE(3126),
    [sym__reserved_identifier] = STATE(2914),
    [sym_preproc_region] = STATE(2846),
    [sym_preproc_endregion] = STATE(2846),
    [sym_preproc_line] = STATE(2846),
    [sym_preproc_pragma] = STATE(2846),
    [sym_preproc_nullable] = STATE(2846),
    [sym_preproc_error] = STATE(2846),
    [sym_preproc_define] = STATE(2846),
    [sym_preproc_undef] = STATE(2846),
    [sym__identifier_token] = ACTIONS(3998),
    [anon_sym_alias] = ACTIONS(4001),
    [anon_sym_global] = ACTIONS(4001),
    [anon_sym_LBRACK] = ACTIONS(3719),
    [anon_sym_COLON] = ACTIONS(3721),
    [anon_sym_COMMA] = ACTIONS(3719),
    [anon_sym_LPAREN] = ACTIONS(3719),
    [anon_sym_RPAREN] = ACTIONS(3719),
    [anon_sym_ref] = ACTIONS(4014),
    [anon_sym_LBRACE] = ACTIONS(3719),
    [anon_sym_RBRACE] = ACTIONS(3719),
    [anon_sym_file] = ACTIONS(4001),
    [anon_sym_LT] = ACTIONS(3721),
    [anon_sym_GT] = ACTIONS(3721),
    [anon_sym_where] = ACTIONS(4001),
    [anon_sym_QMARK] = ACTIONS(3721),
    [anon_sym_notnull] = ACTIONS(4001),
    [anon_sym_unmanaged] = ACTIONS(4001),
    [anon_sym_BANG] = ACTIONS(3721),
    [anon_sym_PLUS_PLUS] = ACTIONS(3719),
    [anon_sym_DASH_DASH] = ACTIONS(3719),
    [anon_sym_PLUS] = ACTIONS(3721),
    [anon_sym_DASH] = ACTIONS(3721),
    [anon_sym_STAR] = ACTIONS(3719),
    [anon_sym_SLASH] = ACTIONS(3721),
    [anon_sym_PERCENT] = ACTIONS(3719),
    [anon_sym_CARET] = ACTIONS(3719),
    [anon_sym_PIPE] = ACTIONS(3721),
    [anon_sym_AMP] = ACTIONS(3721),
    [anon_sym_LT_LT] = ACTIONS(3719),
    [anon_sym_GT_GT] = ACTIONS(3721),
    [anon_sym_GT_GT_GT] = ACTIONS(3719),
    [anon_sym_EQ_EQ] = ACTIONS(3719),
    [anon_sym_BANG_EQ] = ACTIONS(3719),
    [anon_sym_GT_EQ] = ACTIONS(3719),
    [anon_sym_LT_EQ] = ACTIONS(3719),
    [anon_sym_DOT] = ACTIONS(3721),
    [anon_sym_scoped] = ACTIONS(4001),
    [anon_sym_COLON_COLON] = ACTIONS(3719),
    [anon_sym_var] = ACTIONS(4001),
    [anon_sym_yield] = ACTIONS(4001),
    [anon_sym_switch] = ACTIONS(3721),
    [anon_sym_when] = ACTIONS(4001),
    [sym_discard] = ACTIONS(3721),
    [anon_sym_DOT_DOT] = ACTIONS(3719),
    [anon_sym_and] = ACTIONS(3721),
    [anon_sym_or] = ACTIONS(3721),
    [anon_sym_AMP_AMP] = ACTIONS(3719),
    [anon_sym_PIPE_PIPE] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK] = ACTIONS(3719),
    [anon_sym_from] = ACTIONS(4001),
    [anon_sym_into] = ACTIONS(4001),
    [anon_sym_join] = ACTIONS(4001),
    [anon_sym_on] = ACTIONS(4001),
    [anon_sym_equals] = ACTIONS(4001),
    [anon_sym_let] = ACTIONS(4001),
    [anon_sym_orderby] = ACTIONS(4001),
    [anon_sym_ascending] = ACTIONS(4001),
    [anon_sym_descending] = ACTIONS(4001),
    [anon_sym_group] = ACTIONS(4001),
    [anon_sym_by] = ACTIONS(4001),
    [anon_sym_select] = ACTIONS(4001),
    [anon_sym_as] = ACTIONS(3721),
    [anon_sym_is] = ACTIONS(3721),
    [anon_sym_DASH_GT] = ACTIONS(3719),
    [anon_sym_with] = ACTIONS(3721),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2847] = {
    [sym_preproc_region] = STATE(2847),
    [sym_preproc_endregion] = STATE(2847),
    [sym_preproc_line] = STATE(2847),
    [sym_preproc_pragma] = STATE(2847),
    [sym_preproc_nullable] = STATE(2847),
    [sym_preproc_error] = STATE(2847),
    [sym_preproc_define] = STATE(2847),
    [sym_preproc_undef] = STATE(2847),
    [sym__identifier_token] = ACTIONS(4113),
    [anon_sym_alias] = ACTIONS(4113),
    [anon_sym_global] = ACTIONS(4113),
    [anon_sym_EQ] = ACTIONS(4118),
    [anon_sym_LBRACK] = ACTIONS(4120),
    [anon_sym_COLON] = ACTIONS(4115),
    [anon_sym_LPAREN] = ACTIONS(4120),
    [anon_sym_LBRACE] = ACTIONS(4124),
    [anon_sym_file] = ACTIONS(4113),
    [anon_sym_LT] = ACTIONS(4126),
    [anon_sym_GT] = ACTIONS(4126),
    [anon_sym_where] = ACTIONS(4113),
    [anon_sym_QMARK] = ACTIONS(4126),
    [anon_sym_notnull] = ACTIONS(4113),
    [anon_sym_unmanaged] = ACTIONS(4113),
    [anon_sym_BANG] = ACTIONS(4126),
    [anon_sym_PLUS_PLUS] = ACTIONS(4120),
    [anon_sym_DASH_DASH] = ACTIONS(4120),
    [anon_sym_PLUS] = ACTIONS(4126),
    [anon_sym_DASH] = ACTIONS(4126),
    [anon_sym_STAR] = ACTIONS(4126),
    [anon_sym_SLASH] = ACTIONS(4126),
    [anon_sym_PERCENT] = ACTIONS(4126),
    [anon_sym_CARET] = ACTIONS(4126),
    [anon_sym_PIPE] = ACTIONS(4126),
    [anon_sym_AMP] = ACTIONS(4126),
    [anon_sym_LT_LT] = ACTIONS(4126),
    [anon_sym_GT_GT] = ACTIONS(4126),
    [anon_sym_GT_GT_GT] = ACTIONS(4126),
    [anon_sym_EQ_EQ] = ACTIONS(4120),
    [anon_sym_BANG_EQ] = ACTIONS(4120),
    [anon_sym_GT_EQ] = ACTIONS(4120),
    [anon_sym_LT_EQ] = ACTIONS(4120),
    [anon_sym_DOT] = ACTIONS(4126),
    [anon_sym_scoped] = ACTIONS(4113),
    [anon_sym_EQ_GT] = ACTIONS(4115),
    [anon_sym_var] = ACTIONS(4113),
    [anon_sym_yield] = ACTIONS(4113),
    [anon_sym_switch] = ACTIONS(4126),
    [anon_sym_when] = ACTIONS(4130),
    [sym_discard] = ACTIONS(4113),
    [anon_sym_DOT_DOT] = ACTIONS(4120),
    [anon_sym_and] = ACTIONS(4130),
    [anon_sym_or] = ACTIONS(4130),
    [anon_sym_PLUS_EQ] = ACTIONS(4133),
    [anon_sym_DASH_EQ] = ACTIONS(4133),
    [anon_sym_STAR_EQ] = ACTIONS(4133),
    [anon_sym_SLASH_EQ] = ACTIONS(4133),
    [anon_sym_PERCENT_EQ] = ACTIONS(4133),
    [anon_sym_AMP_EQ] = ACTIONS(4133),
    [anon_sym_CARET_EQ] = ACTIONS(4133),
    [anon_sym_PIPE_EQ] = ACTIONS(4133),
    [anon_sym_LT_LT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4133),
    [anon_sym_AMP_AMP] = ACTIONS(4120),
    [anon_sym_PIPE_PIPE] = ACTIONS(4120),
    [anon_sym_QMARK_QMARK] = ACTIONS(4126),
    [anon_sym_from] = ACTIONS(4113),
    [anon_sym_into] = ACTIONS(4113),
    [anon_sym_join] = ACTIONS(4113),
    [anon_sym_on] = ACTIONS(4113),
    [anon_sym_equals] = ACTIONS(4113),
    [anon_sym_let] = ACTIONS(4113),
    [anon_sym_orderby] = ACTIONS(4113),
    [anon_sym_ascending] = ACTIONS(4113),
    [anon_sym_descending] = ACTIONS(4113),
    [anon_sym_group] = ACTIONS(4113),
    [anon_sym_by] = ACTIONS(4113),
    [anon_sym_select] = ACTIONS(4113),
    [anon_sym_as] = ACTIONS(4126),
    [anon_sym_is] = ACTIONS(4126),
    [anon_sym_DASH_GT] = ACTIONS(4120),
    [anon_sym_with] = ACTIONS(4126),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2848] = {
    [sym_preproc_region] = STATE(2848),
    [sym_preproc_endregion] = STATE(2848),
    [sym_preproc_line] = STATE(2848),
    [sym_preproc_pragma] = STATE(2848),
    [sym_preproc_nullable] = STATE(2848),
    [sym_preproc_error] = STATE(2848),
    [sym_preproc_define] = STATE(2848),
    [sym_preproc_undef] = STATE(2848),
    [sym__identifier_token] = ACTIONS(3721),
    [anon_sym_alias] = ACTIONS(3721),
    [anon_sym_global] = ACTIONS(3721),
    [anon_sym_EQ] = ACTIONS(3721),
    [anon_sym_LBRACK] = ACTIONS(3719),
    [anon_sym_COLON] = ACTIONS(3721),
    [anon_sym_LPAREN] = ACTIONS(3719),
    [anon_sym_return] = ACTIONS(4369),
    [anon_sym_file] = ACTIONS(3721),
    [anon_sym_LT] = ACTIONS(3721),
    [anon_sym_GT] = ACTIONS(3721),
    [anon_sym_where] = ACTIONS(3721),
    [anon_sym_QMARK] = ACTIONS(3721),
    [anon_sym_notnull] = ACTIONS(3721),
    [anon_sym_unmanaged] = ACTIONS(3721),
    [anon_sym_BANG] = ACTIONS(3721),
    [anon_sym_PLUS_PLUS] = ACTIONS(3719),
    [anon_sym_DASH_DASH] = ACTIONS(3719),
    [anon_sym_PLUS] = ACTIONS(3721),
    [anon_sym_DASH] = ACTIONS(3721),
    [anon_sym_STAR] = ACTIONS(3721),
    [anon_sym_SLASH] = ACTIONS(3721),
    [anon_sym_PERCENT] = ACTIONS(3721),
    [anon_sym_CARET] = ACTIONS(3721),
    [anon_sym_PIPE] = ACTIONS(3721),
    [anon_sym_AMP] = ACTIONS(3721),
    [anon_sym_LT_LT] = ACTIONS(3721),
    [anon_sym_GT_GT] = ACTIONS(3721),
    [anon_sym_GT_GT_GT] = ACTIONS(3721),
    [anon_sym_EQ_EQ] = ACTIONS(3719),
    [anon_sym_BANG_EQ] = ACTIONS(3719),
    [anon_sym_GT_EQ] = ACTIONS(3719),
    [anon_sym_LT_EQ] = ACTIONS(3719),
    [anon_sym_DOT] = ACTIONS(3721),
    [anon_sym_scoped] = ACTIONS(3721),
    [anon_sym_EQ_GT] = ACTIONS(3719),
    [anon_sym_COLON_COLON] = ACTIONS(3719),
    [anon_sym_var] = ACTIONS(3721),
    [anon_sym_break] = ACTIONS(4371),
    [anon_sym_yield] = ACTIONS(3721),
    [anon_sym_switch] = ACTIONS(3721),
    [anon_sym_when] = ACTIONS(3721),
    [anon_sym_DOT_DOT] = ACTIONS(3719),
    [anon_sym_PLUS_EQ] = ACTIONS(3719),
    [anon_sym_DASH_EQ] = ACTIONS(3719),
    [anon_sym_STAR_EQ] = ACTIONS(3719),
    [anon_sym_SLASH_EQ] = ACTIONS(3719),
    [anon_sym_PERCENT_EQ] = ACTIONS(3719),
    [anon_sym_AMP_EQ] = ACTIONS(3719),
    [anon_sym_CARET_EQ] = ACTIONS(3719),
    [anon_sym_PIPE_EQ] = ACTIONS(3719),
    [anon_sym_LT_LT_EQ] = ACTIONS(3719),
    [anon_sym_GT_GT_EQ] = ACTIONS(3719),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3719),
    [anon_sym_AMP_AMP] = ACTIONS(3719),
    [anon_sym_PIPE_PIPE] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK] = ACTIONS(3721),
    [anon_sym_from] = ACTIONS(3721),
    [anon_sym_into] = ACTIONS(3721),
    [anon_sym_join] = ACTIONS(3721),
    [anon_sym_on] = ACTIONS(3721),
    [anon_sym_equals] = ACTIONS(3721),
    [anon_sym_let] = ACTIONS(3721),
    [anon_sym_orderby] = ACTIONS(3721),
    [anon_sym_ascending] = ACTIONS(3721),
    [anon_sym_descending] = ACTIONS(3721),
    [anon_sym_group] = ACTIONS(3721),
    [anon_sym_by] = ACTIONS(3721),
    [anon_sym_select] = ACTIONS(3721),
    [anon_sym_as] = ACTIONS(3721),
    [anon_sym_is] = ACTIONS(3721),
    [anon_sym_DASH_GT] = ACTIONS(3719),
    [anon_sym_with] = ACTIONS(3721),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2849] = {
    [sym_preproc_region] = STATE(2849),
    [sym_preproc_endregion] = STATE(2849),
    [sym_preproc_line] = STATE(2849),
    [sym_preproc_pragma] = STATE(2849),
    [sym_preproc_nullable] = STATE(2849),
    [sym_preproc_error] = STATE(2849),
    [sym_preproc_define] = STATE(2849),
    [sym_preproc_undef] = STATE(2849),
    [sym__identifier_token] = ACTIONS(4099),
    [anon_sym_alias] = ACTIONS(4099),
    [anon_sym_global] = ACTIONS(4099),
    [anon_sym_EQ] = ACTIONS(4104),
    [anon_sym_LBRACK] = ACTIONS(4101),
    [anon_sym_COLON] = ACTIONS(4111),
    [anon_sym_COMMA] = ACTIONS(4111),
    [anon_sym_LPAREN] = ACTIONS(4101),
    [anon_sym_file] = ACTIONS(4099),
    [anon_sym_LT] = ACTIONS(4104),
    [anon_sym_GT] = ACTIONS(4104),
    [anon_sym_where] = ACTIONS(4099),
    [anon_sym_QMARK] = ACTIONS(4108),
    [anon_sym_notnull] = ACTIONS(4099),
    [anon_sym_unmanaged] = ACTIONS(4099),
    [anon_sym_BANG] = ACTIONS(4104),
    [anon_sym_PLUS_PLUS] = ACTIONS(4111),
    [anon_sym_DASH_DASH] = ACTIONS(4111),
    [anon_sym_PLUS] = ACTIONS(4104),
    [anon_sym_DASH] = ACTIONS(4104),
    [anon_sym_STAR] = ACTIONS(4108),
    [anon_sym_SLASH] = ACTIONS(4104),
    [anon_sym_PERCENT] = ACTIONS(4104),
    [anon_sym_CARET] = ACTIONS(4104),
    [anon_sym_PIPE] = ACTIONS(4104),
    [anon_sym_AMP] = ACTIONS(4104),
    [anon_sym_LT_LT] = ACTIONS(4104),
    [anon_sym_GT_GT] = ACTIONS(4104),
    [anon_sym_GT_GT_GT] = ACTIONS(4104),
    [anon_sym_EQ_EQ] = ACTIONS(4111),
    [anon_sym_BANG_EQ] = ACTIONS(4111),
    [anon_sym_GT_EQ] = ACTIONS(4111),
    [anon_sym_LT_EQ] = ACTIONS(4111),
    [anon_sym_DOT] = ACTIONS(4108),
    [anon_sym_scoped] = ACTIONS(4099),
    [anon_sym_var] = ACTIONS(4099),
    [anon_sym_yield] = ACTIONS(4099),
    [anon_sym_switch] = ACTIONS(4104),
    [anon_sym_when] = ACTIONS(4099),
    [anon_sym_DOT_DOT] = ACTIONS(4111),
    [anon_sym_and] = ACTIONS(4104),
    [anon_sym_or] = ACTIONS(4104),
    [anon_sym_PLUS_EQ] = ACTIONS(4111),
    [anon_sym_DASH_EQ] = ACTIONS(4111),
    [anon_sym_STAR_EQ] = ACTIONS(4111),
    [anon_sym_SLASH_EQ] = ACTIONS(4111),
    [anon_sym_PERCENT_EQ] = ACTIONS(4111),
    [anon_sym_AMP_EQ] = ACTIONS(4111),
    [anon_sym_CARET_EQ] = ACTIONS(4111),
    [anon_sym_PIPE_EQ] = ACTIONS(4111),
    [anon_sym_LT_LT_EQ] = ACTIONS(4111),
    [anon_sym_GT_GT_EQ] = ACTIONS(4111),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4111),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4111),
    [anon_sym_AMP_AMP] = ACTIONS(4111),
    [anon_sym_PIPE_PIPE] = ACTIONS(4111),
    [anon_sym_QMARK_QMARK] = ACTIONS(4104),
    [anon_sym_from] = ACTIONS(4099),
    [anon_sym_into] = ACTIONS(4108),
    [anon_sym_join] = ACTIONS(4099),
    [anon_sym_on] = ACTIONS(4099),
    [anon_sym_equals] = ACTIONS(4099),
    [anon_sym_let] = ACTIONS(4099),
    [anon_sym_orderby] = ACTIONS(4099),
    [anon_sym_ascending] = ACTIONS(4099),
    [anon_sym_descending] = ACTIONS(4099),
    [anon_sym_group] = ACTIONS(4099),
    [anon_sym_by] = ACTIONS(4099),
    [anon_sym_select] = ACTIONS(4099),
    [anon_sym_as] = ACTIONS(4104),
    [anon_sym_is] = ACTIONS(4104),
    [anon_sym_DASH_GT] = ACTIONS(4101),
    [anon_sym_with] = ACTIONS(4104),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4111),
  },
  [2850] = {
    [sym_preproc_region] = STATE(2850),
    [sym_preproc_endregion] = STATE(2850),
    [sym_preproc_line] = STATE(2850),
    [sym_preproc_pragma] = STATE(2850),
    [sym_preproc_nullable] = STATE(2850),
    [sym_preproc_error] = STATE(2850),
    [sym_preproc_define] = STATE(2850),
    [sym_preproc_undef] = STATE(2850),
    [sym__identifier_token] = ACTIONS(4113),
    [anon_sym_alias] = ACTIONS(4113),
    [anon_sym_global] = ACTIONS(4113),
    [anon_sym_EQ] = ACTIONS(4118),
    [anon_sym_LBRACK] = ACTIONS(4135),
    [anon_sym_COLON] = ACTIONS(4115),
    [anon_sym_LPAREN] = ACTIONS(4135),
    [anon_sym_LBRACE] = ACTIONS(4124),
    [anon_sym_file] = ACTIONS(4113),
    [anon_sym_LT] = ACTIONS(4118),
    [anon_sym_GT] = ACTIONS(4118),
    [anon_sym_where] = ACTIONS(4113),
    [anon_sym_QMARK] = ACTIONS(4138),
    [anon_sym_notnull] = ACTIONS(4113),
    [anon_sym_unmanaged] = ACTIONS(4113),
    [anon_sym_BANG] = ACTIONS(4118),
    [anon_sym_PLUS_PLUS] = ACTIONS(4133),
    [anon_sym_DASH_DASH] = ACTIONS(4133),
    [anon_sym_PLUS] = ACTIONS(4118),
    [anon_sym_DASH] = ACTIONS(4118),
    [anon_sym_STAR] = ACTIONS(4138),
    [anon_sym_SLASH] = ACTIONS(4118),
    [anon_sym_PERCENT] = ACTIONS(4118),
    [anon_sym_CARET] = ACTIONS(4118),
    [anon_sym_PIPE] = ACTIONS(4118),
    [anon_sym_AMP] = ACTIONS(4118),
    [anon_sym_LT_LT] = ACTIONS(4118),
    [anon_sym_GT_GT] = ACTIONS(4118),
    [anon_sym_GT_GT_GT] = ACTIONS(4118),
    [anon_sym_EQ_EQ] = ACTIONS(4133),
    [anon_sym_BANG_EQ] = ACTIONS(4133),
    [anon_sym_GT_EQ] = ACTIONS(4133),
    [anon_sym_LT_EQ] = ACTIONS(4133),
    [anon_sym_DOT] = ACTIONS(4138),
    [anon_sym_scoped] = ACTIONS(4113),
    [anon_sym_var] = ACTIONS(4113),
    [anon_sym_yield] = ACTIONS(4113),
    [anon_sym_switch] = ACTIONS(4118),
    [anon_sym_when] = ACTIONS(4130),
    [sym_discard] = ACTIONS(4113),
    [anon_sym_DOT_DOT] = ACTIONS(4133),
    [anon_sym_and] = ACTIONS(4130),
    [anon_sym_or] = ACTIONS(4130),
    [anon_sym_PLUS_EQ] = ACTIONS(4133),
    [anon_sym_DASH_EQ] = ACTIONS(4133),
    [anon_sym_STAR_EQ] = ACTIONS(4133),
    [anon_sym_SLASH_EQ] = ACTIONS(4133),
    [anon_sym_PERCENT_EQ] = ACTIONS(4133),
    [anon_sym_AMP_EQ] = ACTIONS(4133),
    [anon_sym_CARET_EQ] = ACTIONS(4133),
    [anon_sym_PIPE_EQ] = ACTIONS(4133),
    [anon_sym_LT_LT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4133),
    [anon_sym_AMP_AMP] = ACTIONS(4133),
    [anon_sym_PIPE_PIPE] = ACTIONS(4133),
    [anon_sym_QMARK_QMARK] = ACTIONS(4118),
    [anon_sym_from] = ACTIONS(4113),
    [anon_sym_into] = ACTIONS(4113),
    [anon_sym_join] = ACTIONS(4113),
    [anon_sym_on] = ACTIONS(4113),
    [anon_sym_equals] = ACTIONS(4113),
    [anon_sym_let] = ACTIONS(4113),
    [anon_sym_orderby] = ACTIONS(4113),
    [anon_sym_ascending] = ACTIONS(4113),
    [anon_sym_descending] = ACTIONS(4113),
    [anon_sym_group] = ACTIONS(4113),
    [anon_sym_by] = ACTIONS(4113),
    [anon_sym_select] = ACTIONS(4113),
    [anon_sym_as] = ACTIONS(4118),
    [anon_sym_is] = ACTIONS(4118),
    [anon_sym_DASH_GT] = ACTIONS(4135),
    [anon_sym_with] = ACTIONS(4118),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2851] = {
    [sym__variable_designation] = STATE(4025),
    [sym_parenthesized_variable_designation] = STATE(4015),
    [sym_identifier] = STATE(4020),
    [sym__reserved_identifier] = STATE(3908),
    [sym_preproc_region] = STATE(2851),
    [sym_preproc_endregion] = STATE(2851),
    [sym_preproc_line] = STATE(2851),
    [sym_preproc_pragma] = STATE(2851),
    [sym_preproc_nullable] = STATE(2851),
    [sym_preproc_error] = STATE(2851),
    [sym_preproc_define] = STATE(2851),
    [sym_preproc_undef] = STATE(2851),
    [sym__identifier_token] = ACTIONS(4271),
    [anon_sym_alias] = ACTIONS(4273),
    [anon_sym_SEMI] = ACTIONS(4329),
    [anon_sym_global] = ACTIONS(4273),
    [anon_sym_LBRACK] = ACTIONS(4329),
    [anon_sym_COLON] = ACTIONS(4329),
    [anon_sym_COMMA] = ACTIONS(4329),
    [anon_sym_RBRACK] = ACTIONS(4329),
    [anon_sym_LPAREN] = ACTIONS(4329),
    [anon_sym_RPAREN] = ACTIONS(4329),
    [anon_sym_RBRACE] = ACTIONS(4329),
    [anon_sym_file] = ACTIONS(4273),
    [anon_sym_LT] = ACTIONS(4331),
    [anon_sym_GT] = ACTIONS(4331),
    [anon_sym_in] = ACTIONS(4331),
    [anon_sym_where] = ACTIONS(4273),
    [anon_sym_QMARK] = ACTIONS(4331),
    [anon_sym_notnull] = ACTIONS(4273),
    [anon_sym_unmanaged] = ACTIONS(4273),
    [anon_sym_BANG] = ACTIONS(4331),
    [anon_sym_PLUS_PLUS] = ACTIONS(4329),
    [anon_sym_DASH_DASH] = ACTIONS(4329),
    [anon_sym_PLUS] = ACTIONS(4331),
    [anon_sym_DASH] = ACTIONS(4331),
    [anon_sym_STAR] = ACTIONS(4329),
    [anon_sym_SLASH] = ACTIONS(4331),
    [anon_sym_PERCENT] = ACTIONS(4329),
    [anon_sym_CARET] = ACTIONS(4329),
    [anon_sym_PIPE] = ACTIONS(4331),
    [anon_sym_AMP] = ACTIONS(4331),
    [anon_sym_LT_LT] = ACTIONS(4329),
    [anon_sym_GT_GT] = ACTIONS(4331),
    [anon_sym_GT_GT_GT] = ACTIONS(4329),
    [anon_sym_EQ_EQ] = ACTIONS(4329),
    [anon_sym_BANG_EQ] = ACTIONS(4329),
    [anon_sym_GT_EQ] = ACTIONS(4329),
    [anon_sym_LT_EQ] = ACTIONS(4329),
    [anon_sym_DOT] = ACTIONS(4331),
    [anon_sym_scoped] = ACTIONS(4273),
    [anon_sym_EQ_GT] = ACTIONS(4329),
    [anon_sym_var] = ACTIONS(4273),
    [anon_sym_yield] = ACTIONS(4273),
    [anon_sym_switch] = ACTIONS(4331),
    [anon_sym_when] = ACTIONS(4273),
    [sym_discard] = ACTIONS(4281),
    [anon_sym_DOT_DOT] = ACTIONS(4329),
    [anon_sym_and] = ACTIONS(4331),
    [anon_sym_or] = ACTIONS(4331),
    [anon_sym_AMP_AMP] = ACTIONS(4329),
    [anon_sym_PIPE_PIPE] = ACTIONS(4329),
    [anon_sym_QMARK_QMARK] = ACTIONS(4329),
    [anon_sym_from] = ACTIONS(4273),
    [anon_sym_into] = ACTIONS(4331),
    [anon_sym_join] = ACTIONS(4273),
    [anon_sym_on] = ACTIONS(4273),
    [anon_sym_equals] = ACTIONS(4273),
    [anon_sym_let] = ACTIONS(4273),
    [anon_sym_orderby] = ACTIONS(4273),
    [anon_sym_ascending] = ACTIONS(4273),
    [anon_sym_descending] = ACTIONS(4273),
    [anon_sym_group] = ACTIONS(4273),
    [anon_sym_by] = ACTIONS(4273),
    [anon_sym_select] = ACTIONS(4273),
    [anon_sym_as] = ACTIONS(4331),
    [anon_sym_is] = ACTIONS(4331),
    [anon_sym_DASH_GT] = ACTIONS(4329),
    [anon_sym_with] = ACTIONS(4331),
    [aux_sym_preproc_if_token3] = ACTIONS(4329),
    [aux_sym_preproc_else_token1] = ACTIONS(4329),
    [aux_sym_preproc_elif_token1] = ACTIONS(4329),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2852] = {
    [sym_preproc_region] = STATE(2852),
    [sym_preproc_endregion] = STATE(2852),
    [sym_preproc_line] = STATE(2852),
    [sym_preproc_pragma] = STATE(2852),
    [sym_preproc_nullable] = STATE(2852),
    [sym_preproc_error] = STATE(2852),
    [sym_preproc_define] = STATE(2852),
    [sym_preproc_undef] = STATE(2852),
    [sym__identifier_token] = ACTIONS(4113),
    [anon_sym_alias] = ACTIONS(4113),
    [anon_sym_global] = ACTIONS(4113),
    [anon_sym_EQ] = ACTIONS(4118),
    [anon_sym_LBRACK] = ACTIONS(4135),
    [anon_sym_COLON] = ACTIONS(4124),
    [anon_sym_LPAREN] = ACTIONS(4135),
    [anon_sym_LBRACE] = ACTIONS(4124),
    [anon_sym_file] = ACTIONS(4113),
    [anon_sym_LT] = ACTIONS(4118),
    [anon_sym_GT] = ACTIONS(4118),
    [anon_sym_where] = ACTIONS(4113),
    [anon_sym_QMARK] = ACTIONS(4138),
    [anon_sym_notnull] = ACTIONS(4113),
    [anon_sym_unmanaged] = ACTIONS(4113),
    [anon_sym_BANG] = ACTIONS(4118),
    [anon_sym_PLUS_PLUS] = ACTIONS(4133),
    [anon_sym_DASH_DASH] = ACTIONS(4133),
    [anon_sym_PLUS] = ACTIONS(4118),
    [anon_sym_DASH] = ACTIONS(4118),
    [anon_sym_STAR] = ACTIONS(4138),
    [anon_sym_SLASH] = ACTIONS(4118),
    [anon_sym_PERCENT] = ACTIONS(4118),
    [anon_sym_CARET] = ACTIONS(4118),
    [anon_sym_PIPE] = ACTIONS(4118),
    [anon_sym_AMP] = ACTIONS(4118),
    [anon_sym_LT_LT] = ACTIONS(4118),
    [anon_sym_GT_GT] = ACTIONS(4118),
    [anon_sym_GT_GT_GT] = ACTIONS(4118),
    [anon_sym_EQ_EQ] = ACTIONS(4133),
    [anon_sym_BANG_EQ] = ACTIONS(4133),
    [anon_sym_GT_EQ] = ACTIONS(4133),
    [anon_sym_LT_EQ] = ACTIONS(4133),
    [anon_sym_DOT] = ACTIONS(4138),
    [anon_sym_scoped] = ACTIONS(4113),
    [anon_sym_var] = ACTIONS(4113),
    [anon_sym_yield] = ACTIONS(4113),
    [anon_sym_switch] = ACTIONS(4118),
    [anon_sym_when] = ACTIONS(4113),
    [sym_discard] = ACTIONS(4113),
    [anon_sym_DOT_DOT] = ACTIONS(4133),
    [anon_sym_and] = ACTIONS(4113),
    [anon_sym_or] = ACTIONS(4113),
    [anon_sym_PLUS_EQ] = ACTIONS(4133),
    [anon_sym_DASH_EQ] = ACTIONS(4133),
    [anon_sym_STAR_EQ] = ACTIONS(4133),
    [anon_sym_SLASH_EQ] = ACTIONS(4133),
    [anon_sym_PERCENT_EQ] = ACTIONS(4133),
    [anon_sym_AMP_EQ] = ACTIONS(4133),
    [anon_sym_CARET_EQ] = ACTIONS(4133),
    [anon_sym_PIPE_EQ] = ACTIONS(4133),
    [anon_sym_LT_LT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4133),
    [anon_sym_AMP_AMP] = ACTIONS(4133),
    [anon_sym_PIPE_PIPE] = ACTIONS(4133),
    [anon_sym_QMARK_QMARK] = ACTIONS(4118),
    [anon_sym_from] = ACTIONS(4113),
    [anon_sym_into] = ACTIONS(4113),
    [anon_sym_join] = ACTIONS(4113),
    [anon_sym_on] = ACTIONS(4113),
    [anon_sym_equals] = ACTIONS(4113),
    [anon_sym_let] = ACTIONS(4113),
    [anon_sym_orderby] = ACTIONS(4113),
    [anon_sym_ascending] = ACTIONS(4113),
    [anon_sym_descending] = ACTIONS(4113),
    [anon_sym_group] = ACTIONS(4113),
    [anon_sym_by] = ACTIONS(4113),
    [anon_sym_select] = ACTIONS(4113),
    [anon_sym_as] = ACTIONS(4118),
    [anon_sym_is] = ACTIONS(4118),
    [anon_sym_DASH_GT] = ACTIONS(4135),
    [anon_sym_with] = ACTIONS(4118),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2853] = {
    [sym__variable_designation] = STATE(4063),
    [sym_parenthesized_variable_designation] = STATE(4015),
    [sym_identifier] = STATE(4020),
    [sym__reserved_identifier] = STATE(3908),
    [sym_preproc_region] = STATE(2853),
    [sym_preproc_endregion] = STATE(2853),
    [sym_preproc_line] = STATE(2853),
    [sym_preproc_pragma] = STATE(2853),
    [sym_preproc_nullable] = STATE(2853),
    [sym_preproc_error] = STATE(2853),
    [sym_preproc_define] = STATE(2853),
    [sym_preproc_undef] = STATE(2853),
    [sym__identifier_token] = ACTIONS(4271),
    [anon_sym_alias] = ACTIONS(4273),
    [anon_sym_SEMI] = ACTIONS(4373),
    [anon_sym_global] = ACTIONS(4273),
    [anon_sym_LBRACK] = ACTIONS(4373),
    [anon_sym_COLON] = ACTIONS(4373),
    [anon_sym_COMMA] = ACTIONS(4373),
    [anon_sym_RBRACK] = ACTIONS(4373),
    [anon_sym_LPAREN] = ACTIONS(4373),
    [anon_sym_RPAREN] = ACTIONS(4373),
    [anon_sym_RBRACE] = ACTIONS(4373),
    [anon_sym_file] = ACTIONS(4273),
    [anon_sym_LT] = ACTIONS(4375),
    [anon_sym_GT] = ACTIONS(4375),
    [anon_sym_in] = ACTIONS(4375),
    [anon_sym_where] = ACTIONS(4273),
    [anon_sym_QMARK] = ACTIONS(4375),
    [anon_sym_notnull] = ACTIONS(4273),
    [anon_sym_unmanaged] = ACTIONS(4273),
    [anon_sym_BANG] = ACTIONS(4375),
    [anon_sym_PLUS_PLUS] = ACTIONS(4373),
    [anon_sym_DASH_DASH] = ACTIONS(4373),
    [anon_sym_PLUS] = ACTIONS(4375),
    [anon_sym_DASH] = ACTIONS(4375),
    [anon_sym_STAR] = ACTIONS(4373),
    [anon_sym_SLASH] = ACTIONS(4375),
    [anon_sym_PERCENT] = ACTIONS(4373),
    [anon_sym_CARET] = ACTIONS(4373),
    [anon_sym_PIPE] = ACTIONS(4375),
    [anon_sym_AMP] = ACTIONS(4375),
    [anon_sym_LT_LT] = ACTIONS(4373),
    [anon_sym_GT_GT] = ACTIONS(4375),
    [anon_sym_GT_GT_GT] = ACTIONS(4373),
    [anon_sym_EQ_EQ] = ACTIONS(4373),
    [anon_sym_BANG_EQ] = ACTIONS(4373),
    [anon_sym_GT_EQ] = ACTIONS(4373),
    [anon_sym_LT_EQ] = ACTIONS(4373),
    [anon_sym_DOT] = ACTIONS(4375),
    [anon_sym_scoped] = ACTIONS(4273),
    [anon_sym_EQ_GT] = ACTIONS(4373),
    [anon_sym_var] = ACTIONS(4273),
    [anon_sym_yield] = ACTIONS(4273),
    [anon_sym_switch] = ACTIONS(4375),
    [anon_sym_when] = ACTIONS(4273),
    [sym_discard] = ACTIONS(4281),
    [anon_sym_DOT_DOT] = ACTIONS(4373),
    [anon_sym_and] = ACTIONS(4375),
    [anon_sym_or] = ACTIONS(4375),
    [anon_sym_AMP_AMP] = ACTIONS(4373),
    [anon_sym_PIPE_PIPE] = ACTIONS(4373),
    [anon_sym_QMARK_QMARK] = ACTIONS(4373),
    [anon_sym_from] = ACTIONS(4273),
    [anon_sym_into] = ACTIONS(4375),
    [anon_sym_join] = ACTIONS(4273),
    [anon_sym_on] = ACTIONS(4273),
    [anon_sym_equals] = ACTIONS(4273),
    [anon_sym_let] = ACTIONS(4273),
    [anon_sym_orderby] = ACTIONS(4273),
    [anon_sym_ascending] = ACTIONS(4273),
    [anon_sym_descending] = ACTIONS(4273),
    [anon_sym_group] = ACTIONS(4273),
    [anon_sym_by] = ACTIONS(4273),
    [anon_sym_select] = ACTIONS(4273),
    [anon_sym_as] = ACTIONS(4375),
    [anon_sym_is] = ACTIONS(4375),
    [anon_sym_DASH_GT] = ACTIONS(4373),
    [anon_sym_with] = ACTIONS(4375),
    [aux_sym_preproc_if_token3] = ACTIONS(4373),
    [aux_sym_preproc_else_token1] = ACTIONS(4373),
    [aux_sym_preproc_elif_token1] = ACTIONS(4373),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2854] = {
    [sym_preproc_region] = STATE(2854),
    [sym_preproc_endregion] = STATE(2854),
    [sym_preproc_line] = STATE(2854),
    [sym_preproc_pragma] = STATE(2854),
    [sym_preproc_nullable] = STATE(2854),
    [sym_preproc_error] = STATE(2854),
    [sym_preproc_define] = STATE(2854),
    [sym_preproc_undef] = STATE(2854),
    [sym__identifier_token] = ACTIONS(4113),
    [anon_sym_alias] = ACTIONS(4113),
    [anon_sym_global] = ACTIONS(4113),
    [anon_sym_EQ] = ACTIONS(4118),
    [anon_sym_LBRACK] = ACTIONS(4135),
    [anon_sym_COLON] = ACTIONS(4133),
    [anon_sym_COMMA] = ACTIONS(4133),
    [anon_sym_LPAREN] = ACTIONS(4135),
    [anon_sym_file] = ACTIONS(4113),
    [anon_sym_LT] = ACTIONS(4118),
    [anon_sym_GT] = ACTIONS(4118),
    [anon_sym_where] = ACTIONS(4113),
    [anon_sym_QMARK] = ACTIONS(4138),
    [anon_sym_notnull] = ACTIONS(4113),
    [anon_sym_unmanaged] = ACTIONS(4113),
    [anon_sym_BANG] = ACTIONS(4118),
    [anon_sym_PLUS_PLUS] = ACTIONS(4133),
    [anon_sym_DASH_DASH] = ACTIONS(4133),
    [anon_sym_PLUS] = ACTIONS(4118),
    [anon_sym_DASH] = ACTIONS(4118),
    [anon_sym_STAR] = ACTIONS(4138),
    [anon_sym_SLASH] = ACTIONS(4118),
    [anon_sym_PERCENT] = ACTIONS(4118),
    [anon_sym_CARET] = ACTIONS(4118),
    [anon_sym_PIPE] = ACTIONS(4118),
    [anon_sym_AMP] = ACTIONS(4118),
    [anon_sym_LT_LT] = ACTIONS(4118),
    [anon_sym_GT_GT] = ACTIONS(4118),
    [anon_sym_GT_GT_GT] = ACTIONS(4118),
    [anon_sym_EQ_EQ] = ACTIONS(4133),
    [anon_sym_BANG_EQ] = ACTIONS(4133),
    [anon_sym_GT_EQ] = ACTIONS(4133),
    [anon_sym_LT_EQ] = ACTIONS(4133),
    [anon_sym_DOT] = ACTIONS(4138),
    [anon_sym_scoped] = ACTIONS(4113),
    [anon_sym_var] = ACTIONS(4113),
    [anon_sym_yield] = ACTIONS(4113),
    [anon_sym_switch] = ACTIONS(4118),
    [anon_sym_when] = ACTIONS(4113),
    [anon_sym_DOT_DOT] = ACTIONS(4133),
    [anon_sym_and] = ACTIONS(4118),
    [anon_sym_or] = ACTIONS(4118),
    [anon_sym_PLUS_EQ] = ACTIONS(4133),
    [anon_sym_DASH_EQ] = ACTIONS(4133),
    [anon_sym_STAR_EQ] = ACTIONS(4133),
    [anon_sym_SLASH_EQ] = ACTIONS(4133),
    [anon_sym_PERCENT_EQ] = ACTIONS(4133),
    [anon_sym_AMP_EQ] = ACTIONS(4133),
    [anon_sym_CARET_EQ] = ACTIONS(4133),
    [anon_sym_PIPE_EQ] = ACTIONS(4133),
    [anon_sym_LT_LT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4133),
    [anon_sym_AMP_AMP] = ACTIONS(4133),
    [anon_sym_PIPE_PIPE] = ACTIONS(4133),
    [anon_sym_QMARK_QMARK] = ACTIONS(4118),
    [anon_sym_from] = ACTIONS(4113),
    [anon_sym_into] = ACTIONS(4138),
    [anon_sym_join] = ACTIONS(4113),
    [anon_sym_on] = ACTIONS(4113),
    [anon_sym_equals] = ACTIONS(4113),
    [anon_sym_let] = ACTIONS(4113),
    [anon_sym_orderby] = ACTIONS(4113),
    [anon_sym_ascending] = ACTIONS(4113),
    [anon_sym_descending] = ACTIONS(4113),
    [anon_sym_group] = ACTIONS(4113),
    [anon_sym_by] = ACTIONS(4113),
    [anon_sym_select] = ACTIONS(4113),
    [anon_sym_as] = ACTIONS(4118),
    [anon_sym_is] = ACTIONS(4118),
    [anon_sym_DASH_GT] = ACTIONS(4135),
    [anon_sym_with] = ACTIONS(4118),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4133),
  },
  [2855] = {
    [sym__name] = STATE(3380),
    [sym_alias_qualified_name] = STATE(3430),
    [sym__simple_name] = STATE(3430),
    [sym_qualified_name] = STATE(3430),
    [sym_generic_name] = STATE(3314),
    [sym_ref_type] = STATE(3379),
    [sym__scoped_base_type] = STATE(3378),
    [sym_identifier] = STATE(3133),
    [sym__reserved_identifier] = STATE(3163),
    [sym_preproc_region] = STATE(2855),
    [sym_preproc_endregion] = STATE(2855),
    [sym_preproc_line] = STATE(2855),
    [sym_preproc_pragma] = STATE(2855),
    [sym_preproc_nullable] = STATE(2855),
    [sym_preproc_error] = STATE(2855),
    [sym_preproc_define] = STATE(2855),
    [sym_preproc_undef] = STATE(2855),
    [sym__identifier_token] = ACTIONS(4038),
    [anon_sym_alias] = ACTIONS(4041),
    [anon_sym_global] = ACTIONS(4041),
    [anon_sym_LBRACK] = ACTIONS(3719),
    [anon_sym_COLON] = ACTIONS(3721),
    [anon_sym_COMMA] = ACTIONS(3719),
    [anon_sym_LPAREN] = ACTIONS(3719),
    [anon_sym_ref] = ACTIONS(4044),
    [anon_sym_LBRACE] = ACTIONS(3719),
    [anon_sym_file] = ACTIONS(4041),
    [anon_sym_LT] = ACTIONS(3721),
    [anon_sym_GT] = ACTIONS(3721),
    [anon_sym_where] = ACTIONS(4041),
    [anon_sym_QMARK] = ACTIONS(3721),
    [anon_sym_notnull] = ACTIONS(4041),
    [anon_sym_unmanaged] = ACTIONS(4041),
    [anon_sym_BANG] = ACTIONS(3721),
    [anon_sym_PLUS_PLUS] = ACTIONS(3719),
    [anon_sym_DASH_DASH] = ACTIONS(3719),
    [anon_sym_PLUS] = ACTIONS(3721),
    [anon_sym_DASH] = ACTIONS(3721),
    [anon_sym_STAR] = ACTIONS(3719),
    [anon_sym_SLASH] = ACTIONS(3721),
    [anon_sym_PERCENT] = ACTIONS(3719),
    [anon_sym_CARET] = ACTIONS(3719),
    [anon_sym_PIPE] = ACTIONS(3721),
    [anon_sym_AMP] = ACTIONS(3721),
    [anon_sym_LT_LT] = ACTIONS(3719),
    [anon_sym_GT_GT] = ACTIONS(3721),
    [anon_sym_GT_GT_GT] = ACTIONS(3719),
    [anon_sym_EQ_EQ] = ACTIONS(3719),
    [anon_sym_BANG_EQ] = ACTIONS(3719),
    [anon_sym_GT_EQ] = ACTIONS(3719),
    [anon_sym_LT_EQ] = ACTIONS(3719),
    [anon_sym_DOT] = ACTIONS(3721),
    [anon_sym_scoped] = ACTIONS(4041),
    [anon_sym_COLON_COLON] = ACTIONS(3719),
    [anon_sym_var] = ACTIONS(4041),
    [anon_sym_yield] = ACTIONS(4041),
    [anon_sym_switch] = ACTIONS(3721),
    [anon_sym_when] = ACTIONS(4041),
    [sym_discard] = ACTIONS(3721),
    [anon_sym_DOT_DOT] = ACTIONS(3719),
    [anon_sym_and] = ACTIONS(3721),
    [anon_sym_or] = ACTIONS(3721),
    [anon_sym_AMP_AMP] = ACTIONS(3719),
    [anon_sym_PIPE_PIPE] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK] = ACTIONS(3719),
    [anon_sym_from] = ACTIONS(4041),
    [anon_sym_into] = ACTIONS(4041),
    [anon_sym_join] = ACTIONS(4041),
    [anon_sym_on] = ACTIONS(4041),
    [anon_sym_equals] = ACTIONS(4041),
    [anon_sym_let] = ACTIONS(4041),
    [anon_sym_orderby] = ACTIONS(4041),
    [anon_sym_ascending] = ACTIONS(4041),
    [anon_sym_descending] = ACTIONS(4041),
    [anon_sym_group] = ACTIONS(4041),
    [anon_sym_by] = ACTIONS(4041),
    [anon_sym_select] = ACTIONS(4041),
    [anon_sym_as] = ACTIONS(3721),
    [anon_sym_is] = ACTIONS(3721),
    [anon_sym_DASH_GT] = ACTIONS(3719),
    [anon_sym_with] = ACTIONS(3721),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(3719),
  },
  [2856] = {
    [sym_preproc_region] = STATE(2856),
    [sym_preproc_endregion] = STATE(2856),
    [sym_preproc_line] = STATE(2856),
    [sym_preproc_pragma] = STATE(2856),
    [sym_preproc_nullable] = STATE(2856),
    [sym_preproc_error] = STATE(2856),
    [sym_preproc_define] = STATE(2856),
    [sym_preproc_undef] = STATE(2856),
    [sym__identifier_token] = ACTIONS(4099),
    [anon_sym_alias] = ACTIONS(4099),
    [anon_sym_global] = ACTIONS(4099),
    [anon_sym_EQ] = ACTIONS(4104),
    [anon_sym_LBRACK] = ACTIONS(4101),
    [anon_sym_COLON] = ACTIONS(4106),
    [anon_sym_LPAREN] = ACTIONS(4101),
    [anon_sym_LBRACE] = ACTIONS(4106),
    [anon_sym_file] = ACTIONS(4099),
    [anon_sym_LT] = ACTIONS(4104),
    [anon_sym_GT] = ACTIONS(4104),
    [anon_sym_where] = ACTIONS(4099),
    [anon_sym_QMARK] = ACTIONS(4108),
    [anon_sym_notnull] = ACTIONS(4099),
    [anon_sym_unmanaged] = ACTIONS(4099),
    [anon_sym_BANG] = ACTIONS(4104),
    [anon_sym_PLUS_PLUS] = ACTIONS(4111),
    [anon_sym_DASH_DASH] = ACTIONS(4111),
    [anon_sym_PLUS] = ACTIONS(4104),
    [anon_sym_DASH] = ACTIONS(4104),
    [anon_sym_STAR] = ACTIONS(4108),
    [anon_sym_SLASH] = ACTIONS(4104),
    [anon_sym_PERCENT] = ACTIONS(4104),
    [anon_sym_CARET] = ACTIONS(4104),
    [anon_sym_PIPE] = ACTIONS(4104),
    [anon_sym_AMP] = ACTIONS(4104),
    [anon_sym_LT_LT] = ACTIONS(4104),
    [anon_sym_GT_GT] = ACTIONS(4104),
    [anon_sym_GT_GT_GT] = ACTIONS(4104),
    [anon_sym_EQ_EQ] = ACTIONS(4111),
    [anon_sym_BANG_EQ] = ACTIONS(4111),
    [anon_sym_GT_EQ] = ACTIONS(4111),
    [anon_sym_LT_EQ] = ACTIONS(4111),
    [anon_sym_DOT] = ACTIONS(4108),
    [anon_sym_scoped] = ACTIONS(4099),
    [anon_sym_var] = ACTIONS(4099),
    [anon_sym_yield] = ACTIONS(4099),
    [anon_sym_switch] = ACTIONS(4104),
    [anon_sym_when] = ACTIONS(4099),
    [sym_discard] = ACTIONS(4099),
    [anon_sym_DOT_DOT] = ACTIONS(4111),
    [anon_sym_and] = ACTIONS(4099),
    [anon_sym_or] = ACTIONS(4099),
    [anon_sym_PLUS_EQ] = ACTIONS(4111),
    [anon_sym_DASH_EQ] = ACTIONS(4111),
    [anon_sym_STAR_EQ] = ACTIONS(4111),
    [anon_sym_SLASH_EQ] = ACTIONS(4111),
    [anon_sym_PERCENT_EQ] = ACTIONS(4111),
    [anon_sym_AMP_EQ] = ACTIONS(4111),
    [anon_sym_CARET_EQ] = ACTIONS(4111),
    [anon_sym_PIPE_EQ] = ACTIONS(4111),
    [anon_sym_LT_LT_EQ] = ACTIONS(4111),
    [anon_sym_GT_GT_EQ] = ACTIONS(4111),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4111),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4111),
    [anon_sym_AMP_AMP] = ACTIONS(4111),
    [anon_sym_PIPE_PIPE] = ACTIONS(4111),
    [anon_sym_QMARK_QMARK] = ACTIONS(4104),
    [anon_sym_from] = ACTIONS(4099),
    [anon_sym_into] = ACTIONS(4099),
    [anon_sym_join] = ACTIONS(4099),
    [anon_sym_on] = ACTIONS(4099),
    [anon_sym_equals] = ACTIONS(4099),
    [anon_sym_let] = ACTIONS(4099),
    [anon_sym_orderby] = ACTIONS(4099),
    [anon_sym_ascending] = ACTIONS(4099),
    [anon_sym_descending] = ACTIONS(4099),
    [anon_sym_group] = ACTIONS(4099),
    [anon_sym_by] = ACTIONS(4099),
    [anon_sym_select] = ACTIONS(4099),
    [anon_sym_as] = ACTIONS(4104),
    [anon_sym_is] = ACTIONS(4104),
    [anon_sym_DASH_GT] = ACTIONS(4101),
    [anon_sym_with] = ACTIONS(4104),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2857] = {
    [sym_preproc_region] = STATE(2857),
    [sym_preproc_endregion] = STATE(2857),
    [sym_preproc_line] = STATE(2857),
    [sym_preproc_pragma] = STATE(2857),
    [sym_preproc_nullable] = STATE(2857),
    [sym_preproc_error] = STATE(2857),
    [sym_preproc_define] = STATE(2857),
    [sym_preproc_undef] = STATE(2857),
    [sym__identifier_token] = ACTIONS(4099),
    [anon_sym_alias] = ACTIONS(4099),
    [anon_sym_global] = ACTIONS(4099),
    [anon_sym_EQ] = ACTIONS(4104),
    [anon_sym_LBRACK] = ACTIONS(4101),
    [anon_sym_COLON] = ACTIONS(4101),
    [anon_sym_LPAREN] = ACTIONS(4101),
    [anon_sym_LBRACE] = ACTIONS(4106),
    [anon_sym_file] = ACTIONS(4099),
    [anon_sym_LT] = ACTIONS(4104),
    [anon_sym_GT] = ACTIONS(4104),
    [anon_sym_where] = ACTIONS(4099),
    [anon_sym_QMARK] = ACTIONS(4108),
    [anon_sym_notnull] = ACTIONS(4099),
    [anon_sym_unmanaged] = ACTIONS(4099),
    [anon_sym_BANG] = ACTIONS(4104),
    [anon_sym_PLUS_PLUS] = ACTIONS(4111),
    [anon_sym_DASH_DASH] = ACTIONS(4111),
    [anon_sym_PLUS] = ACTIONS(4104),
    [anon_sym_DASH] = ACTIONS(4104),
    [anon_sym_STAR] = ACTIONS(4108),
    [anon_sym_SLASH] = ACTIONS(4104),
    [anon_sym_PERCENT] = ACTIONS(4104),
    [anon_sym_CARET] = ACTIONS(4104),
    [anon_sym_PIPE] = ACTIONS(4104),
    [anon_sym_AMP] = ACTIONS(4104),
    [anon_sym_LT_LT] = ACTIONS(4104),
    [anon_sym_GT_GT] = ACTIONS(4104),
    [anon_sym_GT_GT_GT] = ACTIONS(4104),
    [anon_sym_EQ_EQ] = ACTIONS(4111),
    [anon_sym_BANG_EQ] = ACTIONS(4111),
    [anon_sym_GT_EQ] = ACTIONS(4111),
    [anon_sym_LT_EQ] = ACTIONS(4111),
    [anon_sym_DOT] = ACTIONS(4108),
    [anon_sym_scoped] = ACTIONS(4099),
    [anon_sym_var] = ACTIONS(4099),
    [anon_sym_yield] = ACTIONS(4099),
    [anon_sym_switch] = ACTIONS(4104),
    [anon_sym_when] = ACTIONS(4099),
    [sym_discard] = ACTIONS(4099),
    [anon_sym_DOT_DOT] = ACTIONS(4111),
    [anon_sym_and] = ACTIONS(4099),
    [anon_sym_or] = ACTIONS(4099),
    [anon_sym_PLUS_EQ] = ACTIONS(4111),
    [anon_sym_DASH_EQ] = ACTIONS(4111),
    [anon_sym_STAR_EQ] = ACTIONS(4111),
    [anon_sym_SLASH_EQ] = ACTIONS(4111),
    [anon_sym_PERCENT_EQ] = ACTIONS(4111),
    [anon_sym_AMP_EQ] = ACTIONS(4111),
    [anon_sym_CARET_EQ] = ACTIONS(4111),
    [anon_sym_PIPE_EQ] = ACTIONS(4111),
    [anon_sym_LT_LT_EQ] = ACTIONS(4111),
    [anon_sym_GT_GT_EQ] = ACTIONS(4111),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4111),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4111),
    [anon_sym_AMP_AMP] = ACTIONS(4111),
    [anon_sym_PIPE_PIPE] = ACTIONS(4111),
    [anon_sym_QMARK_QMARK] = ACTIONS(4104),
    [anon_sym_from] = ACTIONS(4099),
    [anon_sym_into] = ACTIONS(4099),
    [anon_sym_join] = ACTIONS(4099),
    [anon_sym_on] = ACTIONS(4099),
    [anon_sym_equals] = ACTIONS(4099),
    [anon_sym_let] = ACTIONS(4099),
    [anon_sym_orderby] = ACTIONS(4099),
    [anon_sym_ascending] = ACTIONS(4099),
    [anon_sym_descending] = ACTIONS(4099),
    [anon_sym_group] = ACTIONS(4099),
    [anon_sym_by] = ACTIONS(4099),
    [anon_sym_select] = ACTIONS(4099),
    [anon_sym_as] = ACTIONS(4104),
    [anon_sym_is] = ACTIONS(4104),
    [anon_sym_DASH_GT] = ACTIONS(4101),
    [anon_sym_with] = ACTIONS(4104),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2858] = {
    [sym_type_argument_list] = STATE(2736),
    [sym_preproc_region] = STATE(2858),
    [sym_preproc_endregion] = STATE(2858),
    [sym_preproc_line] = STATE(2858),
    [sym_preproc_pragma] = STATE(2858),
    [sym_preproc_nullable] = STATE(2858),
    [sym_preproc_error] = STATE(2858),
    [sym_preproc_define] = STATE(2858),
    [sym_preproc_undef] = STATE(2858),
    [sym__identifier_token] = ACTIONS(4074),
    [anon_sym_alias] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4074),
    [anon_sym_EQ] = ACTIONS(4377),
    [anon_sym_LBRACK] = ACTIONS(4076),
    [anon_sym_COMMA] = ACTIONS(4076),
    [anon_sym_LPAREN] = ACTIONS(4076),
    [anon_sym_RBRACE] = ACTIONS(4076),
    [anon_sym_file] = ACTIONS(4074),
    [anon_sym_LT] = ACTIONS(4078),
    [anon_sym_GT] = ACTIONS(4074),
    [anon_sym_where] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(4074),
    [anon_sym_notnull] = ACTIONS(4074),
    [anon_sym_unmanaged] = ACTIONS(4074),
    [anon_sym_BANG] = ACTIONS(4074),
    [anon_sym_PLUS_PLUS] = ACTIONS(4076),
    [anon_sym_DASH_DASH] = ACTIONS(4076),
    [anon_sym_PLUS] = ACTIONS(4074),
    [anon_sym_DASH] = ACTIONS(4074),
    [anon_sym_STAR] = ACTIONS(4074),
    [anon_sym_SLASH] = ACTIONS(4074),
    [anon_sym_PERCENT] = ACTIONS(4074),
    [anon_sym_CARET] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(4074),
    [anon_sym_AMP] = ACTIONS(4074),
    [anon_sym_LT_LT] = ACTIONS(4074),
    [anon_sym_GT_GT] = ACTIONS(4074),
    [anon_sym_GT_GT_GT] = ACTIONS(4074),
    [anon_sym_EQ_EQ] = ACTIONS(4076),
    [anon_sym_BANG_EQ] = ACTIONS(4076),
    [anon_sym_GT_EQ] = ACTIONS(4076),
    [anon_sym_LT_EQ] = ACTIONS(4076),
    [anon_sym_DOT] = ACTIONS(4074),
    [anon_sym_scoped] = ACTIONS(4074),
    [anon_sym_EQ_GT] = ACTIONS(4081),
    [anon_sym_COLON_COLON] = ACTIONS(4083),
    [anon_sym_var] = ACTIONS(4074),
    [anon_sym_yield] = ACTIONS(4074),
    [anon_sym_switch] = ACTIONS(4074),
    [anon_sym_when] = ACTIONS(4074),
    [anon_sym_DOT_DOT] = ACTIONS(4076),
    [anon_sym_PLUS_EQ] = ACTIONS(4076),
    [anon_sym_DASH_EQ] = ACTIONS(4076),
    [anon_sym_STAR_EQ] = ACTIONS(4076),
    [anon_sym_SLASH_EQ] = ACTIONS(4076),
    [anon_sym_PERCENT_EQ] = ACTIONS(4076),
    [anon_sym_AMP_EQ] = ACTIONS(4076),
    [anon_sym_CARET_EQ] = ACTIONS(4076),
    [anon_sym_PIPE_EQ] = ACTIONS(4076),
    [anon_sym_LT_LT_EQ] = ACTIONS(4076),
    [anon_sym_GT_GT_EQ] = ACTIONS(4076),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4076),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4076),
    [anon_sym_AMP_AMP] = ACTIONS(4076),
    [anon_sym_PIPE_PIPE] = ACTIONS(4076),
    [anon_sym_QMARK_QMARK] = ACTIONS(4074),
    [anon_sym_from] = ACTIONS(4074),
    [anon_sym_into] = ACTIONS(4074),
    [anon_sym_join] = ACTIONS(4074),
    [anon_sym_on] = ACTIONS(4074),
    [anon_sym_equals] = ACTIONS(4074),
    [anon_sym_let] = ACTIONS(4074),
    [anon_sym_orderby] = ACTIONS(4074),
    [anon_sym_ascending] = ACTIONS(4074),
    [anon_sym_descending] = ACTIONS(4074),
    [anon_sym_group] = ACTIONS(4074),
    [anon_sym_by] = ACTIONS(4074),
    [anon_sym_select] = ACTIONS(4074),
    [anon_sym_as] = ACTIONS(4074),
    [anon_sym_is] = ACTIONS(4074),
    [anon_sym_DASH_GT] = ACTIONS(4076),
    [anon_sym_with] = ACTIONS(4074),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2859] = {
    [sym__variable_designation] = STATE(3965),
    [sym_parenthesized_variable_designation] = STATE(4015),
    [sym_identifier] = STATE(4020),
    [sym__reserved_identifier] = STATE(3908),
    [sym_preproc_region] = STATE(2859),
    [sym_preproc_endregion] = STATE(2859),
    [sym_preproc_line] = STATE(2859),
    [sym_preproc_pragma] = STATE(2859),
    [sym_preproc_nullable] = STATE(2859),
    [sym_preproc_error] = STATE(2859),
    [sym_preproc_define] = STATE(2859),
    [sym_preproc_undef] = STATE(2859),
    [sym__identifier_token] = ACTIONS(4271),
    [anon_sym_alias] = ACTIONS(4273),
    [anon_sym_SEMI] = ACTIONS(4335),
    [anon_sym_global] = ACTIONS(4273),
    [anon_sym_LBRACK] = ACTIONS(4335),
    [anon_sym_COLON] = ACTIONS(4335),
    [anon_sym_COMMA] = ACTIONS(4335),
    [anon_sym_RBRACK] = ACTIONS(4335),
    [anon_sym_LPAREN] = ACTIONS(4335),
    [anon_sym_RPAREN] = ACTIONS(4335),
    [anon_sym_RBRACE] = ACTIONS(4335),
    [anon_sym_file] = ACTIONS(4273),
    [anon_sym_LT] = ACTIONS(4337),
    [anon_sym_GT] = ACTIONS(4337),
    [anon_sym_in] = ACTIONS(4337),
    [anon_sym_where] = ACTIONS(4273),
    [anon_sym_QMARK] = ACTIONS(4337),
    [anon_sym_notnull] = ACTIONS(4273),
    [anon_sym_unmanaged] = ACTIONS(4273),
    [anon_sym_BANG] = ACTIONS(4337),
    [anon_sym_PLUS_PLUS] = ACTIONS(4335),
    [anon_sym_DASH_DASH] = ACTIONS(4335),
    [anon_sym_PLUS] = ACTIONS(4337),
    [anon_sym_DASH] = ACTIONS(4337),
    [anon_sym_STAR] = ACTIONS(4335),
    [anon_sym_SLASH] = ACTIONS(4337),
    [anon_sym_PERCENT] = ACTIONS(4335),
    [anon_sym_CARET] = ACTIONS(4335),
    [anon_sym_PIPE] = ACTIONS(4337),
    [anon_sym_AMP] = ACTIONS(4337),
    [anon_sym_LT_LT] = ACTIONS(4335),
    [anon_sym_GT_GT] = ACTIONS(4337),
    [anon_sym_GT_GT_GT] = ACTIONS(4335),
    [anon_sym_EQ_EQ] = ACTIONS(4335),
    [anon_sym_BANG_EQ] = ACTIONS(4335),
    [anon_sym_GT_EQ] = ACTIONS(4335),
    [anon_sym_LT_EQ] = ACTIONS(4335),
    [anon_sym_DOT] = ACTIONS(4337),
    [anon_sym_scoped] = ACTIONS(4273),
    [anon_sym_EQ_GT] = ACTIONS(4335),
    [anon_sym_var] = ACTIONS(4273),
    [anon_sym_yield] = ACTIONS(4273),
    [anon_sym_switch] = ACTIONS(4337),
    [anon_sym_when] = ACTIONS(4273),
    [sym_discard] = ACTIONS(4281),
    [anon_sym_DOT_DOT] = ACTIONS(4335),
    [anon_sym_and] = ACTIONS(4337),
    [anon_sym_or] = ACTIONS(4337),
    [anon_sym_AMP_AMP] = ACTIONS(4335),
    [anon_sym_PIPE_PIPE] = ACTIONS(4335),
    [anon_sym_QMARK_QMARK] = ACTIONS(4335),
    [anon_sym_from] = ACTIONS(4273),
    [anon_sym_into] = ACTIONS(4337),
    [anon_sym_join] = ACTIONS(4273),
    [anon_sym_on] = ACTIONS(4273),
    [anon_sym_equals] = ACTIONS(4273),
    [anon_sym_let] = ACTIONS(4273),
    [anon_sym_orderby] = ACTIONS(4273),
    [anon_sym_ascending] = ACTIONS(4273),
    [anon_sym_descending] = ACTIONS(4273),
    [anon_sym_group] = ACTIONS(4273),
    [anon_sym_by] = ACTIONS(4273),
    [anon_sym_select] = ACTIONS(4273),
    [anon_sym_as] = ACTIONS(4337),
    [anon_sym_is] = ACTIONS(4337),
    [anon_sym_DASH_GT] = ACTIONS(4335),
    [anon_sym_with] = ACTIONS(4337),
    [aux_sym_preproc_if_token3] = ACTIONS(4335),
    [aux_sym_preproc_else_token1] = ACTIONS(4335),
    [aux_sym_preproc_elif_token1] = ACTIONS(4335),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2860] = {
    [sym_preproc_region] = STATE(2860),
    [sym_preproc_endregion] = STATE(2860),
    [sym_preproc_line] = STATE(2860),
    [sym_preproc_pragma] = STATE(2860),
    [sym_preproc_nullable] = STATE(2860),
    [sym_preproc_error] = STATE(2860),
    [sym_preproc_define] = STATE(2860),
    [sym_preproc_undef] = STATE(2860),
    [sym__identifier_token] = ACTIONS(4113),
    [anon_sym_alias] = ACTIONS(4113),
    [anon_sym_global] = ACTIONS(4113),
    [anon_sym_EQ] = ACTIONS(4118),
    [anon_sym_LBRACK] = ACTIONS(4120),
    [anon_sym_COMMA] = ACTIONS(4115),
    [anon_sym_LPAREN] = ACTIONS(4120),
    [anon_sym_LBRACE] = ACTIONS(4124),
    [anon_sym_file] = ACTIONS(4113),
    [anon_sym_LT] = ACTIONS(4126),
    [anon_sym_GT] = ACTIONS(4126),
    [anon_sym_where] = ACTIONS(4130),
    [anon_sym_QMARK] = ACTIONS(4126),
    [anon_sym_notnull] = ACTIONS(4113),
    [anon_sym_unmanaged] = ACTIONS(4113),
    [anon_sym_BANG] = ACTIONS(4126),
    [anon_sym_PLUS_PLUS] = ACTIONS(4120),
    [anon_sym_DASH_DASH] = ACTIONS(4120),
    [anon_sym_PLUS] = ACTIONS(4126),
    [anon_sym_DASH] = ACTIONS(4126),
    [anon_sym_STAR] = ACTIONS(4126),
    [anon_sym_SLASH] = ACTIONS(4126),
    [anon_sym_PERCENT] = ACTIONS(4126),
    [anon_sym_CARET] = ACTIONS(4126),
    [anon_sym_PIPE] = ACTIONS(4126),
    [anon_sym_AMP] = ACTIONS(4126),
    [anon_sym_LT_LT] = ACTIONS(4126),
    [anon_sym_GT_GT] = ACTIONS(4126),
    [anon_sym_GT_GT_GT] = ACTIONS(4126),
    [anon_sym_EQ_EQ] = ACTIONS(4120),
    [anon_sym_BANG_EQ] = ACTIONS(4120),
    [anon_sym_GT_EQ] = ACTIONS(4120),
    [anon_sym_LT_EQ] = ACTIONS(4120),
    [anon_sym_DOT] = ACTIONS(4126),
    [anon_sym_scoped] = ACTIONS(4113),
    [anon_sym_var] = ACTIONS(4113),
    [anon_sym_yield] = ACTIONS(4113),
    [anon_sym_switch] = ACTIONS(4126),
    [anon_sym_when] = ACTIONS(4113),
    [sym_discard] = ACTIONS(4113),
    [anon_sym_DOT_DOT] = ACTIONS(4120),
    [anon_sym_and] = ACTIONS(4130),
    [anon_sym_or] = ACTIONS(4130),
    [anon_sym_PLUS_EQ] = ACTIONS(4133),
    [anon_sym_DASH_EQ] = ACTIONS(4133),
    [anon_sym_STAR_EQ] = ACTIONS(4133),
    [anon_sym_SLASH_EQ] = ACTIONS(4133),
    [anon_sym_PERCENT_EQ] = ACTIONS(4133),
    [anon_sym_AMP_EQ] = ACTIONS(4133),
    [anon_sym_CARET_EQ] = ACTIONS(4133),
    [anon_sym_PIPE_EQ] = ACTIONS(4133),
    [anon_sym_LT_LT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4133),
    [anon_sym_AMP_AMP] = ACTIONS(4120),
    [anon_sym_PIPE_PIPE] = ACTIONS(4120),
    [anon_sym_QMARK_QMARK] = ACTIONS(4126),
    [anon_sym_from] = ACTIONS(4130),
    [anon_sym_into] = ACTIONS(4130),
    [anon_sym_join] = ACTIONS(4130),
    [anon_sym_on] = ACTIONS(4113),
    [anon_sym_equals] = ACTIONS(4113),
    [anon_sym_let] = ACTIONS(4130),
    [anon_sym_orderby] = ACTIONS(4130),
    [anon_sym_ascending] = ACTIONS(4130),
    [anon_sym_descending] = ACTIONS(4130),
    [anon_sym_group] = ACTIONS(4130),
    [anon_sym_by] = ACTIONS(4113),
    [anon_sym_select] = ACTIONS(4130),
    [anon_sym_as] = ACTIONS(4126),
    [anon_sym_is] = ACTIONS(4126),
    [anon_sym_DASH_GT] = ACTIONS(4120),
    [anon_sym_with] = ACTIONS(4126),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2861] = {
    [sym_preproc_region] = STATE(2861),
    [sym_preproc_endregion] = STATE(2861),
    [sym_preproc_line] = STATE(2861),
    [sym_preproc_pragma] = STATE(2861),
    [sym_preproc_nullable] = STATE(2861),
    [sym_preproc_error] = STATE(2861),
    [sym_preproc_define] = STATE(2861),
    [sym_preproc_undef] = STATE(2861),
    [sym__identifier_token] = ACTIONS(4113),
    [anon_sym_alias] = ACTIONS(4113),
    [anon_sym_global] = ACTIONS(4113),
    [anon_sym_EQ] = ACTIONS(4118),
    [anon_sym_LBRACK] = ACTIONS(4135),
    [anon_sym_COLON] = ACTIONS(4135),
    [anon_sym_LPAREN] = ACTIONS(4135),
    [anon_sym_LBRACE] = ACTIONS(4124),
    [anon_sym_file] = ACTIONS(4113),
    [anon_sym_LT] = ACTIONS(4118),
    [anon_sym_GT] = ACTIONS(4118),
    [anon_sym_where] = ACTIONS(4113),
    [anon_sym_QMARK] = ACTIONS(4138),
    [anon_sym_notnull] = ACTIONS(4113),
    [anon_sym_unmanaged] = ACTIONS(4113),
    [anon_sym_BANG] = ACTIONS(4118),
    [anon_sym_PLUS_PLUS] = ACTIONS(4133),
    [anon_sym_DASH_DASH] = ACTIONS(4133),
    [anon_sym_PLUS] = ACTIONS(4118),
    [anon_sym_DASH] = ACTIONS(4118),
    [anon_sym_STAR] = ACTIONS(4138),
    [anon_sym_SLASH] = ACTIONS(4118),
    [anon_sym_PERCENT] = ACTIONS(4118),
    [anon_sym_CARET] = ACTIONS(4118),
    [anon_sym_PIPE] = ACTIONS(4118),
    [anon_sym_AMP] = ACTIONS(4118),
    [anon_sym_LT_LT] = ACTIONS(4118),
    [anon_sym_GT_GT] = ACTIONS(4118),
    [anon_sym_GT_GT_GT] = ACTIONS(4118),
    [anon_sym_EQ_EQ] = ACTIONS(4133),
    [anon_sym_BANG_EQ] = ACTIONS(4133),
    [anon_sym_GT_EQ] = ACTIONS(4133),
    [anon_sym_LT_EQ] = ACTIONS(4133),
    [anon_sym_DOT] = ACTIONS(4138),
    [anon_sym_scoped] = ACTIONS(4113),
    [anon_sym_var] = ACTIONS(4113),
    [anon_sym_yield] = ACTIONS(4113),
    [anon_sym_switch] = ACTIONS(4118),
    [anon_sym_when] = ACTIONS(4113),
    [sym_discard] = ACTIONS(4113),
    [anon_sym_DOT_DOT] = ACTIONS(4133),
    [anon_sym_and] = ACTIONS(4113),
    [anon_sym_or] = ACTIONS(4113),
    [anon_sym_PLUS_EQ] = ACTIONS(4133),
    [anon_sym_DASH_EQ] = ACTIONS(4133),
    [anon_sym_STAR_EQ] = ACTIONS(4133),
    [anon_sym_SLASH_EQ] = ACTIONS(4133),
    [anon_sym_PERCENT_EQ] = ACTIONS(4133),
    [anon_sym_AMP_EQ] = ACTIONS(4133),
    [anon_sym_CARET_EQ] = ACTIONS(4133),
    [anon_sym_PIPE_EQ] = ACTIONS(4133),
    [anon_sym_LT_LT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4133),
    [anon_sym_AMP_AMP] = ACTIONS(4133),
    [anon_sym_PIPE_PIPE] = ACTIONS(4133),
    [anon_sym_QMARK_QMARK] = ACTIONS(4118),
    [anon_sym_from] = ACTIONS(4113),
    [anon_sym_into] = ACTIONS(4113),
    [anon_sym_join] = ACTIONS(4113),
    [anon_sym_on] = ACTIONS(4113),
    [anon_sym_equals] = ACTIONS(4113),
    [anon_sym_let] = ACTIONS(4113),
    [anon_sym_orderby] = ACTIONS(4113),
    [anon_sym_ascending] = ACTIONS(4113),
    [anon_sym_descending] = ACTIONS(4113),
    [anon_sym_group] = ACTIONS(4113),
    [anon_sym_by] = ACTIONS(4113),
    [anon_sym_select] = ACTIONS(4113),
    [anon_sym_as] = ACTIONS(4118),
    [anon_sym_is] = ACTIONS(4118),
    [anon_sym_DASH_GT] = ACTIONS(4135),
    [anon_sym_with] = ACTIONS(4118),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2862] = {
    [sym_preproc_region] = STATE(2862),
    [sym_preproc_endregion] = STATE(2862),
    [sym_preproc_line] = STATE(2862),
    [sym_preproc_pragma] = STATE(2862),
    [sym_preproc_nullable] = STATE(2862),
    [sym_preproc_error] = STATE(2862),
    [sym_preproc_define] = STATE(2862),
    [sym_preproc_undef] = STATE(2862),
    [sym__identifier_token] = ACTIONS(4099),
    [anon_sym_alias] = ACTIONS(4099),
    [anon_sym_global] = ACTIONS(4099),
    [anon_sym_EQ] = ACTIONS(4104),
    [anon_sym_LBRACK] = ACTIONS(4101),
    [anon_sym_COLON] = ACTIONS(4111),
    [anon_sym_COMMA] = ACTIONS(4111),
    [anon_sym_LPAREN] = ACTIONS(4101),
    [anon_sym_file] = ACTIONS(4099),
    [anon_sym_LT] = ACTIONS(4104),
    [anon_sym_GT] = ACTIONS(4104),
    [anon_sym_where] = ACTIONS(4099),
    [anon_sym_QMARK] = ACTIONS(4108),
    [anon_sym_notnull] = ACTIONS(4099),
    [anon_sym_unmanaged] = ACTIONS(4099),
    [anon_sym_BANG] = ACTIONS(4104),
    [anon_sym_PLUS_PLUS] = ACTIONS(4111),
    [anon_sym_DASH_DASH] = ACTIONS(4111),
    [anon_sym_PLUS] = ACTIONS(4104),
    [anon_sym_DASH] = ACTIONS(4104),
    [anon_sym_STAR] = ACTIONS(4108),
    [anon_sym_SLASH] = ACTIONS(4104),
    [anon_sym_PERCENT] = ACTIONS(4104),
    [anon_sym_CARET] = ACTIONS(4104),
    [anon_sym_PIPE] = ACTIONS(4104),
    [anon_sym_AMP] = ACTIONS(4104),
    [anon_sym_LT_LT] = ACTIONS(4104),
    [anon_sym_GT_GT] = ACTIONS(4104),
    [anon_sym_GT_GT_GT] = ACTIONS(4104),
    [anon_sym_EQ_EQ] = ACTIONS(4111),
    [anon_sym_BANG_EQ] = ACTIONS(4111),
    [anon_sym_GT_EQ] = ACTIONS(4111),
    [anon_sym_LT_EQ] = ACTIONS(4111),
    [anon_sym_DOT] = ACTIONS(4108),
    [anon_sym_scoped] = ACTIONS(4099),
    [anon_sym_var] = ACTIONS(4099),
    [anon_sym_yield] = ACTIONS(4099),
    [anon_sym_switch] = ACTIONS(4104),
    [anon_sym_when] = ACTIONS(4099),
    [anon_sym_DOT_DOT] = ACTIONS(4111),
    [anon_sym_and] = ACTIONS(4104),
    [anon_sym_or] = ACTIONS(4104),
    [anon_sym_PLUS_EQ] = ACTIONS(4111),
    [anon_sym_DASH_EQ] = ACTIONS(4111),
    [anon_sym_STAR_EQ] = ACTIONS(4111),
    [anon_sym_SLASH_EQ] = ACTIONS(4111),
    [anon_sym_PERCENT_EQ] = ACTIONS(4111),
    [anon_sym_AMP_EQ] = ACTIONS(4111),
    [anon_sym_CARET_EQ] = ACTIONS(4111),
    [anon_sym_PIPE_EQ] = ACTIONS(4111),
    [anon_sym_LT_LT_EQ] = ACTIONS(4111),
    [anon_sym_GT_GT_EQ] = ACTIONS(4111),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4111),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4111),
    [anon_sym_AMP_AMP] = ACTIONS(4111),
    [anon_sym_PIPE_PIPE] = ACTIONS(4111),
    [anon_sym_QMARK_QMARK] = ACTIONS(4104),
    [anon_sym_from] = ACTIONS(4099),
    [anon_sym_into] = ACTIONS(4099),
    [anon_sym_join] = ACTIONS(4099),
    [anon_sym_on] = ACTIONS(4099),
    [anon_sym_equals] = ACTIONS(4099),
    [anon_sym_let] = ACTIONS(4099),
    [anon_sym_orderby] = ACTIONS(4099),
    [anon_sym_ascending] = ACTIONS(4099),
    [anon_sym_descending] = ACTIONS(4099),
    [anon_sym_group] = ACTIONS(4099),
    [anon_sym_by] = ACTIONS(4099),
    [anon_sym_select] = ACTIONS(4099),
    [anon_sym_as] = ACTIONS(4104),
    [anon_sym_is] = ACTIONS(4104),
    [anon_sym_DASH_GT] = ACTIONS(4101),
    [anon_sym_with] = ACTIONS(4104),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4111),
  },
  [2863] = {
    [sym_preproc_region] = STATE(2863),
    [sym_preproc_endregion] = STATE(2863),
    [sym_preproc_line] = STATE(2863),
    [sym_preproc_pragma] = STATE(2863),
    [sym_preproc_nullable] = STATE(2863),
    [sym_preproc_error] = STATE(2863),
    [sym_preproc_define] = STATE(2863),
    [sym_preproc_undef] = STATE(2863),
    [sym__identifier_token] = ACTIONS(4027),
    [anon_sym_alias] = ACTIONS(4027),
    [anon_sym_global] = ACTIONS(4027),
    [anon_sym_EQ] = ACTIONS(3721),
    [anon_sym_LBRACK] = ACTIONS(3719),
    [anon_sym_COLON] = ACTIONS(3721),
    [anon_sym_COMMA] = ACTIONS(4024),
    [anon_sym_LPAREN] = ACTIONS(4024),
    [anon_sym_RPAREN] = ACTIONS(3719),
    [anon_sym_file] = ACTIONS(4027),
    [anon_sym_LT] = ACTIONS(3721),
    [anon_sym_GT] = ACTIONS(3721),
    [anon_sym_where] = ACTIONS(4027),
    [anon_sym_QMARK] = ACTIONS(3721),
    [anon_sym_notnull] = ACTIONS(4027),
    [anon_sym_unmanaged] = ACTIONS(4027),
    [anon_sym_BANG] = ACTIONS(3721),
    [anon_sym_PLUS_PLUS] = ACTIONS(3719),
    [anon_sym_DASH_DASH] = ACTIONS(3719),
    [anon_sym_PLUS] = ACTIONS(3721),
    [anon_sym_DASH] = ACTIONS(3721),
    [anon_sym_STAR] = ACTIONS(3721),
    [anon_sym_SLASH] = ACTIONS(3721),
    [anon_sym_PERCENT] = ACTIONS(3721),
    [anon_sym_CARET] = ACTIONS(3721),
    [anon_sym_PIPE] = ACTIONS(3721),
    [anon_sym_AMP] = ACTIONS(3721),
    [anon_sym_LT_LT] = ACTIONS(3721),
    [anon_sym_GT_GT] = ACTIONS(3721),
    [anon_sym_GT_GT_GT] = ACTIONS(3721),
    [anon_sym_EQ_EQ] = ACTIONS(3719),
    [anon_sym_BANG_EQ] = ACTIONS(3719),
    [anon_sym_GT_EQ] = ACTIONS(3719),
    [anon_sym_LT_EQ] = ACTIONS(3719),
    [anon_sym_DOT] = ACTIONS(3721),
    [anon_sym_scoped] = ACTIONS(4027),
    [anon_sym_EQ_GT] = ACTIONS(3719),
    [anon_sym_COLON_COLON] = ACTIONS(3719),
    [anon_sym_var] = ACTIONS(4027),
    [anon_sym_yield] = ACTIONS(4027),
    [anon_sym_switch] = ACTIONS(3721),
    [anon_sym_when] = ACTIONS(4027),
    [anon_sym_DOT_DOT] = ACTIONS(3719),
    [anon_sym_PLUS_EQ] = ACTIONS(3719),
    [anon_sym_DASH_EQ] = ACTIONS(3719),
    [anon_sym_STAR_EQ] = ACTIONS(3719),
    [anon_sym_SLASH_EQ] = ACTIONS(3719),
    [anon_sym_PERCENT_EQ] = ACTIONS(3719),
    [anon_sym_AMP_EQ] = ACTIONS(3719),
    [anon_sym_CARET_EQ] = ACTIONS(3719),
    [anon_sym_PIPE_EQ] = ACTIONS(3719),
    [anon_sym_LT_LT_EQ] = ACTIONS(3719),
    [anon_sym_GT_GT_EQ] = ACTIONS(3719),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3719),
    [anon_sym_AMP_AMP] = ACTIONS(3719),
    [anon_sym_PIPE_PIPE] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK] = ACTIONS(3721),
    [anon_sym_from] = ACTIONS(4027),
    [anon_sym_into] = ACTIONS(4027),
    [anon_sym_join] = ACTIONS(4027),
    [anon_sym_on] = ACTIONS(4027),
    [anon_sym_equals] = ACTIONS(4027),
    [anon_sym_let] = ACTIONS(4027),
    [anon_sym_orderby] = ACTIONS(4027),
    [anon_sym_ascending] = ACTIONS(4027),
    [anon_sym_descending] = ACTIONS(4027),
    [anon_sym_group] = ACTIONS(4027),
    [anon_sym_by] = ACTIONS(4027),
    [anon_sym_select] = ACTIONS(4027),
    [anon_sym_as] = ACTIONS(3721),
    [anon_sym_is] = ACTIONS(3721),
    [anon_sym_DASH_GT] = ACTIONS(3719),
    [anon_sym_with] = ACTIONS(3721),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2864] = {
    [sym_preproc_region] = STATE(2864),
    [sym_preproc_endregion] = STATE(2864),
    [sym_preproc_line] = STATE(2864),
    [sym_preproc_pragma] = STATE(2864),
    [sym_preproc_nullable] = STATE(2864),
    [sym_preproc_error] = STATE(2864),
    [sym_preproc_define] = STATE(2864),
    [sym_preproc_undef] = STATE(2864),
    [sym__identifier_token] = ACTIONS(3721),
    [anon_sym_alias] = ACTIONS(3721),
    [anon_sym_global] = ACTIONS(3721),
    [anon_sym_EQ] = ACTIONS(3721),
    [anon_sym_LBRACK] = ACTIONS(3719),
    [anon_sym_COLON] = ACTIONS(3721),
    [anon_sym_LPAREN] = ACTIONS(3719),
    [anon_sym_return] = ACTIONS(4379),
    [anon_sym_file] = ACTIONS(3721),
    [anon_sym_LT] = ACTIONS(3721),
    [anon_sym_GT] = ACTIONS(3721),
    [anon_sym_where] = ACTIONS(3721),
    [anon_sym_QMARK] = ACTIONS(3721),
    [anon_sym_notnull] = ACTIONS(3721),
    [anon_sym_unmanaged] = ACTIONS(3721),
    [anon_sym_BANG] = ACTIONS(3721),
    [anon_sym_PLUS_PLUS] = ACTIONS(3719),
    [anon_sym_DASH_DASH] = ACTIONS(3719),
    [anon_sym_PLUS] = ACTIONS(3721),
    [anon_sym_DASH] = ACTIONS(3721),
    [anon_sym_STAR] = ACTIONS(3721),
    [anon_sym_SLASH] = ACTIONS(3721),
    [anon_sym_PERCENT] = ACTIONS(3721),
    [anon_sym_CARET] = ACTIONS(3721),
    [anon_sym_PIPE] = ACTIONS(3721),
    [anon_sym_AMP] = ACTIONS(3721),
    [anon_sym_LT_LT] = ACTIONS(3721),
    [anon_sym_GT_GT] = ACTIONS(3721),
    [anon_sym_GT_GT_GT] = ACTIONS(3721),
    [anon_sym_EQ_EQ] = ACTIONS(3719),
    [anon_sym_BANG_EQ] = ACTIONS(3719),
    [anon_sym_GT_EQ] = ACTIONS(3719),
    [anon_sym_LT_EQ] = ACTIONS(3719),
    [anon_sym_DOT] = ACTIONS(3721),
    [anon_sym_scoped] = ACTIONS(3721),
    [anon_sym_EQ_GT] = ACTIONS(3719),
    [anon_sym_COLON_COLON] = ACTIONS(3719),
    [anon_sym_var] = ACTIONS(3721),
    [anon_sym_break] = ACTIONS(4381),
    [anon_sym_yield] = ACTIONS(3721),
    [anon_sym_switch] = ACTIONS(3721),
    [anon_sym_when] = ACTIONS(3721),
    [anon_sym_DOT_DOT] = ACTIONS(3719),
    [anon_sym_PLUS_EQ] = ACTIONS(3719),
    [anon_sym_DASH_EQ] = ACTIONS(3719),
    [anon_sym_STAR_EQ] = ACTIONS(3719),
    [anon_sym_SLASH_EQ] = ACTIONS(3719),
    [anon_sym_PERCENT_EQ] = ACTIONS(3719),
    [anon_sym_AMP_EQ] = ACTIONS(3719),
    [anon_sym_CARET_EQ] = ACTIONS(3719),
    [anon_sym_PIPE_EQ] = ACTIONS(3719),
    [anon_sym_LT_LT_EQ] = ACTIONS(3719),
    [anon_sym_GT_GT_EQ] = ACTIONS(3719),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3719),
    [anon_sym_AMP_AMP] = ACTIONS(3719),
    [anon_sym_PIPE_PIPE] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK] = ACTIONS(3721),
    [anon_sym_from] = ACTIONS(3721),
    [anon_sym_into] = ACTIONS(3721),
    [anon_sym_join] = ACTIONS(3721),
    [anon_sym_on] = ACTIONS(3721),
    [anon_sym_equals] = ACTIONS(3721),
    [anon_sym_let] = ACTIONS(3721),
    [anon_sym_orderby] = ACTIONS(3721),
    [anon_sym_ascending] = ACTIONS(3721),
    [anon_sym_descending] = ACTIONS(3721),
    [anon_sym_group] = ACTIONS(3721),
    [anon_sym_by] = ACTIONS(3721),
    [anon_sym_select] = ACTIONS(3721),
    [anon_sym_as] = ACTIONS(3721),
    [anon_sym_is] = ACTIONS(3721),
    [anon_sym_DASH_GT] = ACTIONS(3719),
    [anon_sym_with] = ACTIONS(3721),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2865] = {
    [sym_preproc_region] = STATE(2865),
    [sym_preproc_endregion] = STATE(2865),
    [sym_preproc_line] = STATE(2865),
    [sym_preproc_pragma] = STATE(2865),
    [sym_preproc_nullable] = STATE(2865),
    [sym_preproc_error] = STATE(2865),
    [sym_preproc_define] = STATE(2865),
    [sym_preproc_undef] = STATE(2865),
    [sym__identifier_token] = ACTIONS(4099),
    [anon_sym_alias] = ACTIONS(4099),
    [anon_sym_global] = ACTIONS(4099),
    [anon_sym_EQ] = ACTIONS(4104),
    [anon_sym_LBRACK] = ACTIONS(4101),
    [anon_sym_COMMA] = ACTIONS(4101),
    [anon_sym_LPAREN] = ACTIONS(4101),
    [anon_sym_LBRACE] = ACTIONS(4106),
    [anon_sym_file] = ACTIONS(4099),
    [anon_sym_LT] = ACTIONS(4108),
    [anon_sym_GT] = ACTIONS(4108),
    [anon_sym_where] = ACTIONS(4108),
    [anon_sym_QMARK] = ACTIONS(4108),
    [anon_sym_notnull] = ACTIONS(4099),
    [anon_sym_unmanaged] = ACTIONS(4099),
    [anon_sym_BANG] = ACTIONS(4108),
    [anon_sym_PLUS_PLUS] = ACTIONS(4101),
    [anon_sym_DASH_DASH] = ACTIONS(4101),
    [anon_sym_PLUS] = ACTIONS(4108),
    [anon_sym_DASH] = ACTIONS(4108),
    [anon_sym_STAR] = ACTIONS(4108),
    [anon_sym_SLASH] = ACTIONS(4108),
    [anon_sym_PERCENT] = ACTIONS(4108),
    [anon_sym_CARET] = ACTIONS(4108),
    [anon_sym_PIPE] = ACTIONS(4108),
    [anon_sym_AMP] = ACTIONS(4108),
    [anon_sym_LT_LT] = ACTIONS(4108),
    [anon_sym_GT_GT] = ACTIONS(4108),
    [anon_sym_GT_GT_GT] = ACTIONS(4108),
    [anon_sym_EQ_EQ] = ACTIONS(4101),
    [anon_sym_BANG_EQ] = ACTIONS(4101),
    [anon_sym_GT_EQ] = ACTIONS(4101),
    [anon_sym_LT_EQ] = ACTIONS(4101),
    [anon_sym_DOT] = ACTIONS(4108),
    [anon_sym_scoped] = ACTIONS(4099),
    [anon_sym_var] = ACTIONS(4099),
    [anon_sym_yield] = ACTIONS(4099),
    [anon_sym_switch] = ACTIONS(4108),
    [anon_sym_when] = ACTIONS(4099),
    [sym_discard] = ACTIONS(4099),
    [anon_sym_DOT_DOT] = ACTIONS(4101),
    [anon_sym_and] = ACTIONS(4108),
    [anon_sym_or] = ACTIONS(4108),
    [anon_sym_PLUS_EQ] = ACTIONS(4111),
    [anon_sym_DASH_EQ] = ACTIONS(4111),
    [anon_sym_STAR_EQ] = ACTIONS(4111),
    [anon_sym_SLASH_EQ] = ACTIONS(4111),
    [anon_sym_PERCENT_EQ] = ACTIONS(4111),
    [anon_sym_AMP_EQ] = ACTIONS(4111),
    [anon_sym_CARET_EQ] = ACTIONS(4111),
    [anon_sym_PIPE_EQ] = ACTIONS(4111),
    [anon_sym_LT_LT_EQ] = ACTIONS(4111),
    [anon_sym_GT_GT_EQ] = ACTIONS(4111),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4111),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4111),
    [anon_sym_AMP_AMP] = ACTIONS(4101),
    [anon_sym_PIPE_PIPE] = ACTIONS(4101),
    [anon_sym_QMARK_QMARK] = ACTIONS(4108),
    [anon_sym_from] = ACTIONS(4108),
    [anon_sym_into] = ACTIONS(4099),
    [anon_sym_join] = ACTIONS(4108),
    [anon_sym_on] = ACTIONS(4099),
    [anon_sym_equals] = ACTIONS(4099),
    [anon_sym_let] = ACTIONS(4108),
    [anon_sym_orderby] = ACTIONS(4108),
    [anon_sym_ascending] = ACTIONS(4108),
    [anon_sym_descending] = ACTIONS(4108),
    [anon_sym_group] = ACTIONS(4108),
    [anon_sym_by] = ACTIONS(4099),
    [anon_sym_select] = ACTIONS(4108),
    [anon_sym_as] = ACTIONS(4108),
    [anon_sym_is] = ACTIONS(4108),
    [anon_sym_DASH_GT] = ACTIONS(4101),
    [anon_sym_with] = ACTIONS(4108),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2866] = {
    [sym_preproc_region] = STATE(2866),
    [sym_preproc_endregion] = STATE(2866),
    [sym_preproc_line] = STATE(2866),
    [sym_preproc_pragma] = STATE(2866),
    [sym_preproc_nullable] = STATE(2866),
    [sym_preproc_error] = STATE(2866),
    [sym_preproc_define] = STATE(2866),
    [sym_preproc_undef] = STATE(2866),
    [sym__identifier_token] = ACTIONS(4099),
    [anon_sym_alias] = ACTIONS(4099),
    [anon_sym_global] = ACTIONS(4099),
    [anon_sym_EQ] = ACTIONS(4104),
    [anon_sym_LBRACK] = ACTIONS(4101),
    [anon_sym_COMMA] = ACTIONS(4101),
    [anon_sym_LPAREN] = ACTIONS(4101),
    [anon_sym_LBRACE] = ACTIONS(4106),
    [anon_sym_file] = ACTIONS(4099),
    [anon_sym_LT] = ACTIONS(4108),
    [anon_sym_GT] = ACTIONS(4108),
    [anon_sym_where] = ACTIONS(4108),
    [anon_sym_QMARK] = ACTIONS(4108),
    [anon_sym_notnull] = ACTIONS(4099),
    [anon_sym_unmanaged] = ACTIONS(4099),
    [anon_sym_BANG] = ACTIONS(4108),
    [anon_sym_PLUS_PLUS] = ACTIONS(4101),
    [anon_sym_DASH_DASH] = ACTIONS(4101),
    [anon_sym_PLUS] = ACTIONS(4108),
    [anon_sym_DASH] = ACTIONS(4108),
    [anon_sym_STAR] = ACTIONS(4108),
    [anon_sym_SLASH] = ACTIONS(4108),
    [anon_sym_PERCENT] = ACTIONS(4108),
    [anon_sym_CARET] = ACTIONS(4108),
    [anon_sym_PIPE] = ACTIONS(4108),
    [anon_sym_AMP] = ACTIONS(4108),
    [anon_sym_LT_LT] = ACTIONS(4108),
    [anon_sym_GT_GT] = ACTIONS(4108),
    [anon_sym_GT_GT_GT] = ACTIONS(4108),
    [anon_sym_EQ_EQ] = ACTIONS(4101),
    [anon_sym_BANG_EQ] = ACTIONS(4101),
    [anon_sym_GT_EQ] = ACTIONS(4101),
    [anon_sym_LT_EQ] = ACTIONS(4101),
    [anon_sym_DOT] = ACTIONS(4108),
    [anon_sym_scoped] = ACTIONS(4099),
    [anon_sym_var] = ACTIONS(4099),
    [anon_sym_yield] = ACTIONS(4099),
    [anon_sym_switch] = ACTIONS(4108),
    [anon_sym_when] = ACTIONS(4099),
    [sym_discard] = ACTIONS(4099),
    [anon_sym_DOT_DOT] = ACTIONS(4101),
    [anon_sym_and] = ACTIONS(4108),
    [anon_sym_or] = ACTIONS(4108),
    [anon_sym_PLUS_EQ] = ACTIONS(4111),
    [anon_sym_DASH_EQ] = ACTIONS(4111),
    [anon_sym_STAR_EQ] = ACTIONS(4111),
    [anon_sym_SLASH_EQ] = ACTIONS(4111),
    [anon_sym_PERCENT_EQ] = ACTIONS(4111),
    [anon_sym_AMP_EQ] = ACTIONS(4111),
    [anon_sym_CARET_EQ] = ACTIONS(4111),
    [anon_sym_PIPE_EQ] = ACTIONS(4111),
    [anon_sym_LT_LT_EQ] = ACTIONS(4111),
    [anon_sym_GT_GT_EQ] = ACTIONS(4111),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4111),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4111),
    [anon_sym_AMP_AMP] = ACTIONS(4101),
    [anon_sym_PIPE_PIPE] = ACTIONS(4101),
    [anon_sym_QMARK_QMARK] = ACTIONS(4108),
    [anon_sym_from] = ACTIONS(4108),
    [anon_sym_into] = ACTIONS(4108),
    [anon_sym_join] = ACTIONS(4108),
    [anon_sym_on] = ACTIONS(4099),
    [anon_sym_equals] = ACTIONS(4099),
    [anon_sym_let] = ACTIONS(4108),
    [anon_sym_orderby] = ACTIONS(4108),
    [anon_sym_ascending] = ACTIONS(4108),
    [anon_sym_descending] = ACTIONS(4108),
    [anon_sym_group] = ACTIONS(4108),
    [anon_sym_by] = ACTIONS(4099),
    [anon_sym_select] = ACTIONS(4108),
    [anon_sym_as] = ACTIONS(4108),
    [anon_sym_is] = ACTIONS(4108),
    [anon_sym_DASH_GT] = ACTIONS(4101),
    [anon_sym_with] = ACTIONS(4108),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2867] = {
    [sym_preproc_region] = STATE(2867),
    [sym_preproc_endregion] = STATE(2867),
    [sym_preproc_line] = STATE(2867),
    [sym_preproc_pragma] = STATE(2867),
    [sym_preproc_nullable] = STATE(2867),
    [sym_preproc_error] = STATE(2867),
    [sym_preproc_define] = STATE(2867),
    [sym_preproc_undef] = STATE(2867),
    [sym__identifier_token] = ACTIONS(4113),
    [anon_sym_alias] = ACTIONS(4113),
    [anon_sym_global] = ACTIONS(4113),
    [anon_sym_EQ] = ACTIONS(4118),
    [anon_sym_LBRACK] = ACTIONS(4120),
    [anon_sym_COMMA] = ACTIONS(4115),
    [anon_sym_LPAREN] = ACTIONS(4120),
    [anon_sym_LBRACE] = ACTIONS(4124),
    [anon_sym_file] = ACTIONS(4113),
    [anon_sym_LT] = ACTIONS(4126),
    [anon_sym_GT] = ACTIONS(4126),
    [anon_sym_where] = ACTIONS(4130),
    [anon_sym_QMARK] = ACTIONS(4126),
    [anon_sym_notnull] = ACTIONS(4113),
    [anon_sym_unmanaged] = ACTIONS(4113),
    [anon_sym_BANG] = ACTIONS(4126),
    [anon_sym_PLUS_PLUS] = ACTIONS(4120),
    [anon_sym_DASH_DASH] = ACTIONS(4120),
    [anon_sym_PLUS] = ACTIONS(4126),
    [anon_sym_DASH] = ACTIONS(4126),
    [anon_sym_STAR] = ACTIONS(4126),
    [anon_sym_SLASH] = ACTIONS(4126),
    [anon_sym_PERCENT] = ACTIONS(4126),
    [anon_sym_CARET] = ACTIONS(4126),
    [anon_sym_PIPE] = ACTIONS(4126),
    [anon_sym_AMP] = ACTIONS(4126),
    [anon_sym_LT_LT] = ACTIONS(4126),
    [anon_sym_GT_GT] = ACTIONS(4126),
    [anon_sym_GT_GT_GT] = ACTIONS(4126),
    [anon_sym_EQ_EQ] = ACTIONS(4120),
    [anon_sym_BANG_EQ] = ACTIONS(4120),
    [anon_sym_GT_EQ] = ACTIONS(4120),
    [anon_sym_LT_EQ] = ACTIONS(4120),
    [anon_sym_DOT] = ACTIONS(4126),
    [anon_sym_scoped] = ACTIONS(4113),
    [anon_sym_var] = ACTIONS(4113),
    [anon_sym_yield] = ACTIONS(4113),
    [anon_sym_switch] = ACTIONS(4126),
    [anon_sym_when] = ACTIONS(4113),
    [sym_discard] = ACTIONS(4113),
    [anon_sym_DOT_DOT] = ACTIONS(4120),
    [anon_sym_and] = ACTIONS(4130),
    [anon_sym_or] = ACTIONS(4130),
    [anon_sym_PLUS_EQ] = ACTIONS(4133),
    [anon_sym_DASH_EQ] = ACTIONS(4133),
    [anon_sym_STAR_EQ] = ACTIONS(4133),
    [anon_sym_SLASH_EQ] = ACTIONS(4133),
    [anon_sym_PERCENT_EQ] = ACTIONS(4133),
    [anon_sym_AMP_EQ] = ACTIONS(4133),
    [anon_sym_CARET_EQ] = ACTIONS(4133),
    [anon_sym_PIPE_EQ] = ACTIONS(4133),
    [anon_sym_LT_LT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4133),
    [anon_sym_AMP_AMP] = ACTIONS(4120),
    [anon_sym_PIPE_PIPE] = ACTIONS(4120),
    [anon_sym_QMARK_QMARK] = ACTIONS(4126),
    [anon_sym_from] = ACTIONS(4130),
    [anon_sym_into] = ACTIONS(4113),
    [anon_sym_join] = ACTIONS(4130),
    [anon_sym_on] = ACTIONS(4113),
    [anon_sym_equals] = ACTIONS(4113),
    [anon_sym_let] = ACTIONS(4130),
    [anon_sym_orderby] = ACTIONS(4130),
    [anon_sym_ascending] = ACTIONS(4130),
    [anon_sym_descending] = ACTIONS(4130),
    [anon_sym_group] = ACTIONS(4130),
    [anon_sym_by] = ACTIONS(4113),
    [anon_sym_select] = ACTIONS(4130),
    [anon_sym_as] = ACTIONS(4126),
    [anon_sym_is] = ACTIONS(4126),
    [anon_sym_DASH_GT] = ACTIONS(4120),
    [anon_sym_with] = ACTIONS(4126),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2868] = {
    [sym_preproc_region] = STATE(2868),
    [sym_preproc_endregion] = STATE(2868),
    [sym_preproc_line] = STATE(2868),
    [sym_preproc_pragma] = STATE(2868),
    [sym_preproc_nullable] = STATE(2868),
    [sym_preproc_error] = STATE(2868),
    [sym_preproc_define] = STATE(2868),
    [sym_preproc_undef] = STATE(2868),
    [sym__identifier_token] = ACTIONS(4113),
    [anon_sym_alias] = ACTIONS(4113),
    [anon_sym_global] = ACTIONS(4113),
    [anon_sym_EQ] = ACTIONS(4118),
    [anon_sym_LBRACK] = ACTIONS(4135),
    [anon_sym_COLON] = ACTIONS(4133),
    [anon_sym_COMMA] = ACTIONS(4133),
    [anon_sym_LPAREN] = ACTIONS(4135),
    [anon_sym_file] = ACTIONS(4113),
    [anon_sym_LT] = ACTIONS(4118),
    [anon_sym_GT] = ACTIONS(4118),
    [anon_sym_where] = ACTIONS(4113),
    [anon_sym_QMARK] = ACTIONS(4138),
    [anon_sym_notnull] = ACTIONS(4113),
    [anon_sym_unmanaged] = ACTIONS(4113),
    [anon_sym_BANG] = ACTIONS(4118),
    [anon_sym_PLUS_PLUS] = ACTIONS(4133),
    [anon_sym_DASH_DASH] = ACTIONS(4133),
    [anon_sym_PLUS] = ACTIONS(4118),
    [anon_sym_DASH] = ACTIONS(4118),
    [anon_sym_STAR] = ACTIONS(4138),
    [anon_sym_SLASH] = ACTIONS(4118),
    [anon_sym_PERCENT] = ACTIONS(4118),
    [anon_sym_CARET] = ACTIONS(4118),
    [anon_sym_PIPE] = ACTIONS(4118),
    [anon_sym_AMP] = ACTIONS(4118),
    [anon_sym_LT_LT] = ACTIONS(4118),
    [anon_sym_GT_GT] = ACTIONS(4118),
    [anon_sym_GT_GT_GT] = ACTIONS(4118),
    [anon_sym_EQ_EQ] = ACTIONS(4133),
    [anon_sym_BANG_EQ] = ACTIONS(4133),
    [anon_sym_GT_EQ] = ACTIONS(4133),
    [anon_sym_LT_EQ] = ACTIONS(4133),
    [anon_sym_DOT] = ACTIONS(4138),
    [anon_sym_scoped] = ACTIONS(4113),
    [anon_sym_var] = ACTIONS(4113),
    [anon_sym_yield] = ACTIONS(4113),
    [anon_sym_switch] = ACTIONS(4118),
    [anon_sym_when] = ACTIONS(4113),
    [anon_sym_DOT_DOT] = ACTIONS(4133),
    [anon_sym_and] = ACTIONS(4118),
    [anon_sym_or] = ACTIONS(4118),
    [anon_sym_PLUS_EQ] = ACTIONS(4133),
    [anon_sym_DASH_EQ] = ACTIONS(4133),
    [anon_sym_STAR_EQ] = ACTIONS(4133),
    [anon_sym_SLASH_EQ] = ACTIONS(4133),
    [anon_sym_PERCENT_EQ] = ACTIONS(4133),
    [anon_sym_AMP_EQ] = ACTIONS(4133),
    [anon_sym_CARET_EQ] = ACTIONS(4133),
    [anon_sym_PIPE_EQ] = ACTIONS(4133),
    [anon_sym_LT_LT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4133),
    [anon_sym_AMP_AMP] = ACTIONS(4133),
    [anon_sym_PIPE_PIPE] = ACTIONS(4133),
    [anon_sym_QMARK_QMARK] = ACTIONS(4118),
    [anon_sym_from] = ACTIONS(4113),
    [anon_sym_into] = ACTIONS(4113),
    [anon_sym_join] = ACTIONS(4113),
    [anon_sym_on] = ACTIONS(4113),
    [anon_sym_equals] = ACTIONS(4113),
    [anon_sym_let] = ACTIONS(4113),
    [anon_sym_orderby] = ACTIONS(4113),
    [anon_sym_ascending] = ACTIONS(4113),
    [anon_sym_descending] = ACTIONS(4113),
    [anon_sym_group] = ACTIONS(4113),
    [anon_sym_by] = ACTIONS(4113),
    [anon_sym_select] = ACTIONS(4113),
    [anon_sym_as] = ACTIONS(4118),
    [anon_sym_is] = ACTIONS(4118),
    [anon_sym_DASH_GT] = ACTIONS(4135),
    [anon_sym_with] = ACTIONS(4118),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4133),
  },
  [2869] = {
    [sym__variable_designation] = STATE(4035),
    [sym_parenthesized_variable_designation] = STATE(4015),
    [sym_identifier] = STATE(4020),
    [sym__reserved_identifier] = STATE(3908),
    [sym_preproc_region] = STATE(2869),
    [sym_preproc_endregion] = STATE(2869),
    [sym_preproc_line] = STATE(2869),
    [sym_preproc_pragma] = STATE(2869),
    [sym_preproc_nullable] = STATE(2869),
    [sym_preproc_error] = STATE(2869),
    [sym_preproc_define] = STATE(2869),
    [sym_preproc_undef] = STATE(2869),
    [sym__identifier_token] = ACTIONS(4271),
    [anon_sym_alias] = ACTIONS(4273),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_global] = ACTIONS(4273),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON] = ACTIONS(4383),
    [anon_sym_COMMA] = ACTIONS(4383),
    [anon_sym_RBRACK] = ACTIONS(4383),
    [anon_sym_LPAREN] = ACTIONS(4383),
    [anon_sym_RPAREN] = ACTIONS(4383),
    [anon_sym_RBRACE] = ACTIONS(4383),
    [anon_sym_file] = ACTIONS(4273),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_in] = ACTIONS(4385),
    [anon_sym_where] = ACTIONS(4273),
    [anon_sym_QMARK] = ACTIONS(4385),
    [anon_sym_notnull] = ACTIONS(4273),
    [anon_sym_unmanaged] = ACTIONS(4273),
    [anon_sym_BANG] = ACTIONS(4385),
    [anon_sym_PLUS_PLUS] = ACTIONS(4383),
    [anon_sym_DASH_DASH] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_DASH] = ACTIONS(4385),
    [anon_sym_STAR] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4385),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4385),
    [anon_sym_GT_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4383),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_scoped] = ACTIONS(4273),
    [anon_sym_EQ_GT] = ACTIONS(4383),
    [anon_sym_var] = ACTIONS(4273),
    [anon_sym_yield] = ACTIONS(4273),
    [anon_sym_switch] = ACTIONS(4385),
    [anon_sym_when] = ACTIONS(4273),
    [sym_discard] = ACTIONS(4281),
    [anon_sym_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4385),
    [anon_sym_or] = ACTIONS(4385),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_QMARK_QMARK] = ACTIONS(4383),
    [anon_sym_from] = ACTIONS(4273),
    [anon_sym_into] = ACTIONS(4385),
    [anon_sym_join] = ACTIONS(4273),
    [anon_sym_on] = ACTIONS(4273),
    [anon_sym_equals] = ACTIONS(4273),
    [anon_sym_let] = ACTIONS(4273),
    [anon_sym_orderby] = ACTIONS(4273),
    [anon_sym_ascending] = ACTIONS(4273),
    [anon_sym_descending] = ACTIONS(4273),
    [anon_sym_group] = ACTIONS(4273),
    [anon_sym_by] = ACTIONS(4273),
    [anon_sym_select] = ACTIONS(4273),
    [anon_sym_as] = ACTIONS(4385),
    [anon_sym_is] = ACTIONS(4385),
    [anon_sym_DASH_GT] = ACTIONS(4383),
    [anon_sym_with] = ACTIONS(4385),
    [aux_sym_preproc_if_token3] = ACTIONS(4383),
    [aux_sym_preproc_else_token1] = ACTIONS(4383),
    [aux_sym_preproc_elif_token1] = ACTIONS(4383),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2870] = {
    [sym_preproc_region] = STATE(2870),
    [sym_preproc_endregion] = STATE(2870),
    [sym_preproc_line] = STATE(2870),
    [sym_preproc_pragma] = STATE(2870),
    [sym_preproc_nullable] = STATE(2870),
    [sym_preproc_error] = STATE(2870),
    [sym_preproc_define] = STATE(2870),
    [sym_preproc_undef] = STATE(2870),
    [sym__identifier_token] = ACTIONS(4113),
    [anon_sym_alias] = ACTIONS(4113),
    [anon_sym_global] = ACTIONS(4113),
    [anon_sym_EQ] = ACTIONS(4118),
    [anon_sym_LBRACK] = ACTIONS(4120),
    [anon_sym_LPAREN] = ACTIONS(4120),
    [anon_sym_LBRACE] = ACTIONS(4124),
    [anon_sym_file] = ACTIONS(4113),
    [anon_sym_LT] = ACTIONS(4126),
    [anon_sym_GT] = ACTIONS(4126),
    [anon_sym_where] = ACTIONS(4130),
    [anon_sym_QMARK] = ACTIONS(4126),
    [anon_sym_notnull] = ACTIONS(4113),
    [anon_sym_unmanaged] = ACTIONS(4113),
    [anon_sym_BANG] = ACTIONS(4126),
    [anon_sym_PLUS_PLUS] = ACTIONS(4120),
    [anon_sym_DASH_DASH] = ACTIONS(4120),
    [anon_sym_PLUS] = ACTIONS(4126),
    [anon_sym_DASH] = ACTIONS(4126),
    [anon_sym_STAR] = ACTIONS(4126),
    [anon_sym_SLASH] = ACTIONS(4126),
    [anon_sym_PERCENT] = ACTIONS(4126),
    [anon_sym_CARET] = ACTIONS(4126),
    [anon_sym_PIPE] = ACTIONS(4126),
    [anon_sym_AMP] = ACTIONS(4126),
    [anon_sym_LT_LT] = ACTIONS(4126),
    [anon_sym_GT_GT] = ACTIONS(4126),
    [anon_sym_GT_GT_GT] = ACTIONS(4126),
    [anon_sym_EQ_EQ] = ACTIONS(4120),
    [anon_sym_BANG_EQ] = ACTIONS(4120),
    [anon_sym_GT_EQ] = ACTIONS(4120),
    [anon_sym_LT_EQ] = ACTIONS(4120),
    [anon_sym_DOT] = ACTIONS(4126),
    [anon_sym_scoped] = ACTIONS(4113),
    [anon_sym_var] = ACTIONS(4113),
    [anon_sym_yield] = ACTIONS(4113),
    [anon_sym_switch] = ACTIONS(4126),
    [anon_sym_when] = ACTIONS(4113),
    [sym_discard] = ACTIONS(4113),
    [anon_sym_DOT_DOT] = ACTIONS(4120),
    [anon_sym_and] = ACTIONS(4130),
    [anon_sym_or] = ACTIONS(4130),
    [anon_sym_PLUS_EQ] = ACTIONS(4133),
    [anon_sym_DASH_EQ] = ACTIONS(4133),
    [anon_sym_STAR_EQ] = ACTIONS(4133),
    [anon_sym_SLASH_EQ] = ACTIONS(4133),
    [anon_sym_PERCENT_EQ] = ACTIONS(4133),
    [anon_sym_AMP_EQ] = ACTIONS(4133),
    [anon_sym_CARET_EQ] = ACTIONS(4133),
    [anon_sym_PIPE_EQ] = ACTIONS(4133),
    [anon_sym_LT_LT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4133),
    [anon_sym_AMP_AMP] = ACTIONS(4120),
    [anon_sym_PIPE_PIPE] = ACTIONS(4120),
    [anon_sym_QMARK_QMARK] = ACTIONS(4126),
    [anon_sym_from] = ACTIONS(4130),
    [anon_sym_into] = ACTIONS(4130),
    [anon_sym_join] = ACTIONS(4130),
    [anon_sym_on] = ACTIONS(4113),
    [anon_sym_equals] = ACTIONS(4113),
    [anon_sym_let] = ACTIONS(4130),
    [anon_sym_orderby] = ACTIONS(4130),
    [anon_sym_ascending] = ACTIONS(4113),
    [anon_sym_descending] = ACTIONS(4113),
    [anon_sym_group] = ACTIONS(4130),
    [anon_sym_by] = ACTIONS(4113),
    [anon_sym_select] = ACTIONS(4130),
    [anon_sym_as] = ACTIONS(4126),
    [anon_sym_is] = ACTIONS(4126),
    [anon_sym_DASH_GT] = ACTIONS(4120),
    [anon_sym_with] = ACTIONS(4126),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2871] = {
    [sym_preproc_region] = STATE(2871),
    [sym_preproc_endregion] = STATE(2871),
    [sym_preproc_line] = STATE(2871),
    [sym_preproc_pragma] = STATE(2871),
    [sym_preproc_nullable] = STATE(2871),
    [sym_preproc_error] = STATE(2871),
    [sym_preproc_define] = STATE(2871),
    [sym_preproc_undef] = STATE(2871),
    [sym__identifier_token] = ACTIONS(4387),
    [anon_sym_alias] = ACTIONS(4387),
    [anon_sym_SEMI] = ACTIONS(4389),
    [anon_sym_global] = ACTIONS(4387),
    [anon_sym_LBRACK] = ACTIONS(4389),
    [anon_sym_COLON] = ACTIONS(4389),
    [anon_sym_COMMA] = ACTIONS(4389),
    [anon_sym_RBRACK] = ACTIONS(4389),
    [anon_sym_LPAREN] = ACTIONS(4389),
    [anon_sym_RPAREN] = ACTIONS(4389),
    [anon_sym_LBRACE] = ACTIONS(4389),
    [anon_sym_RBRACE] = ACTIONS(4389),
    [anon_sym_file] = ACTIONS(4387),
    [anon_sym_LT] = ACTIONS(4387),
    [anon_sym_GT] = ACTIONS(4387),
    [anon_sym_in] = ACTIONS(4387),
    [anon_sym_where] = ACTIONS(4387),
    [anon_sym_QMARK] = ACTIONS(4387),
    [anon_sym_notnull] = ACTIONS(4387),
    [anon_sym_unmanaged] = ACTIONS(4387),
    [anon_sym_operator] = ACTIONS(4387),
    [anon_sym_BANG] = ACTIONS(4387),
    [anon_sym_PLUS_PLUS] = ACTIONS(4389),
    [anon_sym_DASH_DASH] = ACTIONS(4389),
    [anon_sym_PLUS] = ACTIONS(4387),
    [anon_sym_DASH] = ACTIONS(4387),
    [anon_sym_STAR] = ACTIONS(4389),
    [anon_sym_SLASH] = ACTIONS(4387),
    [anon_sym_PERCENT] = ACTIONS(4389),
    [anon_sym_CARET] = ACTIONS(4389),
    [anon_sym_PIPE] = ACTIONS(4387),
    [anon_sym_AMP] = ACTIONS(4387),
    [anon_sym_LT_LT] = ACTIONS(4389),
    [anon_sym_GT_GT] = ACTIONS(4387),
    [anon_sym_GT_GT_GT] = ACTIONS(4389),
    [anon_sym_EQ_EQ] = ACTIONS(4389),
    [anon_sym_BANG_EQ] = ACTIONS(4389),
    [anon_sym_GT_EQ] = ACTIONS(4389),
    [anon_sym_LT_EQ] = ACTIONS(4389),
    [anon_sym_this] = ACTIONS(4387),
    [anon_sym_DOT] = ACTIONS(4387),
    [anon_sym_scoped] = ACTIONS(4387),
    [anon_sym_EQ_GT] = ACTIONS(4389),
    [anon_sym_var] = ACTIONS(4387),
    [anon_sym_yield] = ACTIONS(4387),
    [anon_sym_switch] = ACTIONS(4387),
    [anon_sym_when] = ACTIONS(4387),
    [sym_discard] = ACTIONS(4387),
    [anon_sym_DOT_DOT] = ACTIONS(4389),
    [anon_sym_and] = ACTIONS(4387),
    [anon_sym_or] = ACTIONS(4387),
    [anon_sym_AMP_AMP] = ACTIONS(4389),
    [anon_sym_PIPE_PIPE] = ACTIONS(4389),
    [anon_sym_QMARK_QMARK] = ACTIONS(4389),
    [anon_sym_from] = ACTIONS(4387),
    [anon_sym_into] = ACTIONS(4387),
    [anon_sym_join] = ACTIONS(4387),
    [anon_sym_on] = ACTIONS(4387),
    [anon_sym_equals] = ACTIONS(4387),
    [anon_sym_let] = ACTIONS(4387),
    [anon_sym_orderby] = ACTIONS(4387),
    [anon_sym_ascending] = ACTIONS(4387),
    [anon_sym_descending] = ACTIONS(4387),
    [anon_sym_group] = ACTIONS(4387),
    [anon_sym_by] = ACTIONS(4387),
    [anon_sym_select] = ACTIONS(4387),
    [anon_sym_as] = ACTIONS(4387),
    [anon_sym_is] = ACTIONS(4387),
    [anon_sym_DASH_GT] = ACTIONS(4389),
    [anon_sym_with] = ACTIONS(4387),
    [aux_sym_preproc_if_token3] = ACTIONS(4389),
    [aux_sym_preproc_else_token1] = ACTIONS(4389),
    [aux_sym_preproc_elif_token1] = ACTIONS(4389),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2872] = {
    [sym__name] = STATE(5376),
    [sym_alias_qualified_name] = STATE(5302),
    [sym__simple_name] = STATE(5302),
    [sym_qualified_name] = STATE(5302),
    [sym_generic_name] = STATE(5211),
    [sym_ref_type] = STATE(5373),
    [sym__scoped_base_type] = STATE(5372),
    [sym_identifier] = STATE(5034),
    [sym__reserved_identifier] = STATE(5144),
    [sym_preproc_region] = STATE(2872),
    [sym_preproc_endregion] = STATE(2872),
    [sym_preproc_line] = STATE(2872),
    [sym_preproc_pragma] = STATE(2872),
    [sym_preproc_nullable] = STATE(2872),
    [sym_preproc_error] = STATE(2872),
    [sym_preproc_define] = STATE(2872),
    [sym_preproc_undef] = STATE(2872),
    [sym__identifier_token] = ACTIONS(4391),
    [anon_sym_alias] = ACTIONS(4393),
    [anon_sym_global] = ACTIONS(4393),
    [anon_sym_LBRACK] = ACTIONS(3719),
    [anon_sym_COLON] = ACTIONS(3721),
    [anon_sym_COMMA] = ACTIONS(3719),
    [anon_sym_LPAREN] = ACTIONS(3719),
    [anon_sym_ref] = ACTIONS(4395),
    [anon_sym_LBRACE] = ACTIONS(3719),
    [anon_sym_file] = ACTIONS(4393),
    [anon_sym_LT] = ACTIONS(3721),
    [anon_sym_GT] = ACTIONS(3721),
    [anon_sym_where] = ACTIONS(4393),
    [anon_sym_QMARK] = ACTIONS(3721),
    [anon_sym_notnull] = ACTIONS(4393),
    [anon_sym_unmanaged] = ACTIONS(4393),
    [anon_sym_BANG] = ACTIONS(3721),
    [anon_sym_PLUS_PLUS] = ACTIONS(3719),
    [anon_sym_DASH_DASH] = ACTIONS(3719),
    [anon_sym_PLUS] = ACTIONS(3721),
    [anon_sym_DASH] = ACTIONS(3721),
    [anon_sym_STAR] = ACTIONS(3719),
    [anon_sym_SLASH] = ACTIONS(3721),
    [anon_sym_PERCENT] = ACTIONS(3719),
    [anon_sym_CARET] = ACTIONS(3719),
    [anon_sym_PIPE] = ACTIONS(3721),
    [anon_sym_AMP] = ACTIONS(3721),
    [anon_sym_LT_LT] = ACTIONS(3719),
    [anon_sym_GT_GT] = ACTIONS(3721),
    [anon_sym_GT_GT_GT] = ACTIONS(3719),
    [anon_sym_EQ_EQ] = ACTIONS(3719),
    [anon_sym_BANG_EQ] = ACTIONS(3719),
    [anon_sym_GT_EQ] = ACTIONS(3719),
    [anon_sym_LT_EQ] = ACTIONS(3719),
    [anon_sym_DOT] = ACTIONS(3721),
    [anon_sym_scoped] = ACTIONS(4393),
    [anon_sym_COLON_COLON] = ACTIONS(3719),
    [anon_sym_var] = ACTIONS(4393),
    [anon_sym_yield] = ACTIONS(4393),
    [anon_sym_switch] = ACTIONS(3721),
    [anon_sym_when] = ACTIONS(4393),
    [anon_sym_DOT_DOT] = ACTIONS(3719),
    [anon_sym_and] = ACTIONS(3721),
    [anon_sym_or] = ACTIONS(3721),
    [anon_sym_AMP_AMP] = ACTIONS(3719),
    [anon_sym_PIPE_PIPE] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK] = ACTIONS(3719),
    [anon_sym_from] = ACTIONS(4393),
    [anon_sym_into] = ACTIONS(4393),
    [anon_sym_join] = ACTIONS(4393),
    [anon_sym_on] = ACTIONS(4393),
    [anon_sym_equals] = ACTIONS(4393),
    [anon_sym_let] = ACTIONS(4393),
    [anon_sym_orderby] = ACTIONS(4393),
    [anon_sym_ascending] = ACTIONS(4393),
    [anon_sym_descending] = ACTIONS(4393),
    [anon_sym_group] = ACTIONS(4393),
    [anon_sym_by] = ACTIONS(4393),
    [anon_sym_select] = ACTIONS(4393),
    [anon_sym_as] = ACTIONS(3721),
    [anon_sym_is] = ACTIONS(3721),
    [anon_sym_DASH_GT] = ACTIONS(3719),
    [anon_sym_with] = ACTIONS(3721),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(3719),
  },
  [2873] = {
    [sym__name] = STATE(5376),
    [sym_alias_qualified_name] = STATE(5302),
    [sym__simple_name] = STATE(5302),
    [sym_qualified_name] = STATE(5302),
    [sym_generic_name] = STATE(5211),
    [sym_ref_type] = STATE(5373),
    [sym__scoped_base_type] = STATE(5372),
    [sym_identifier] = STATE(5034),
    [sym__reserved_identifier] = STATE(5144),
    [sym_preproc_region] = STATE(2873),
    [sym_preproc_endregion] = STATE(2873),
    [sym_preproc_line] = STATE(2873),
    [sym_preproc_pragma] = STATE(2873),
    [sym_preproc_nullable] = STATE(2873),
    [sym_preproc_error] = STATE(2873),
    [sym_preproc_define] = STATE(2873),
    [sym_preproc_undef] = STATE(2873),
    [sym__identifier_token] = ACTIONS(4391),
    [anon_sym_alias] = ACTIONS(4393),
    [anon_sym_global] = ACTIONS(4393),
    [anon_sym_LBRACK] = ACTIONS(3719),
    [anon_sym_COLON] = ACTIONS(3721),
    [anon_sym_COMMA] = ACTIONS(3719),
    [anon_sym_LPAREN] = ACTIONS(3719),
    [anon_sym_ref] = ACTIONS(4397),
    [anon_sym_LBRACE] = ACTIONS(3719),
    [anon_sym_file] = ACTIONS(4393),
    [anon_sym_LT] = ACTIONS(3721),
    [anon_sym_GT] = ACTIONS(3721),
    [anon_sym_where] = ACTIONS(4393),
    [anon_sym_QMARK] = ACTIONS(3721),
    [anon_sym_notnull] = ACTIONS(4393),
    [anon_sym_unmanaged] = ACTIONS(4393),
    [anon_sym_BANG] = ACTIONS(3721),
    [anon_sym_PLUS_PLUS] = ACTIONS(3719),
    [anon_sym_DASH_DASH] = ACTIONS(3719),
    [anon_sym_PLUS] = ACTIONS(3721),
    [anon_sym_DASH] = ACTIONS(3721),
    [anon_sym_STAR] = ACTIONS(3719),
    [anon_sym_SLASH] = ACTIONS(3721),
    [anon_sym_PERCENT] = ACTIONS(3719),
    [anon_sym_CARET] = ACTIONS(3719),
    [anon_sym_PIPE] = ACTIONS(3721),
    [anon_sym_AMP] = ACTIONS(3721),
    [anon_sym_LT_LT] = ACTIONS(3719),
    [anon_sym_GT_GT] = ACTIONS(3721),
    [anon_sym_GT_GT_GT] = ACTIONS(3719),
    [anon_sym_EQ_EQ] = ACTIONS(3719),
    [anon_sym_BANG_EQ] = ACTIONS(3719),
    [anon_sym_GT_EQ] = ACTIONS(3719),
    [anon_sym_LT_EQ] = ACTIONS(3719),
    [anon_sym_DOT] = ACTIONS(3721),
    [anon_sym_scoped] = ACTIONS(4393),
    [anon_sym_COLON_COLON] = ACTIONS(3719),
    [anon_sym_var] = ACTIONS(4393),
    [anon_sym_yield] = ACTIONS(4393),
    [anon_sym_switch] = ACTIONS(3721),
    [anon_sym_when] = ACTIONS(4393),
    [anon_sym_DOT_DOT] = ACTIONS(3719),
    [anon_sym_and] = ACTIONS(3721),
    [anon_sym_or] = ACTIONS(3721),
    [anon_sym_AMP_AMP] = ACTIONS(3719),
    [anon_sym_PIPE_PIPE] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK] = ACTIONS(3719),
    [anon_sym_from] = ACTIONS(4393),
    [anon_sym_into] = ACTIONS(4399),
    [anon_sym_join] = ACTIONS(4393),
    [anon_sym_on] = ACTIONS(4393),
    [anon_sym_equals] = ACTIONS(4393),
    [anon_sym_let] = ACTIONS(4393),
    [anon_sym_orderby] = ACTIONS(4393),
    [anon_sym_ascending] = ACTIONS(4393),
    [anon_sym_descending] = ACTIONS(4393),
    [anon_sym_group] = ACTIONS(4393),
    [anon_sym_by] = ACTIONS(4393),
    [anon_sym_select] = ACTIONS(4393),
    [anon_sym_as] = ACTIONS(3721),
    [anon_sym_is] = ACTIONS(3721),
    [anon_sym_DASH_GT] = ACTIONS(3719),
    [anon_sym_with] = ACTIONS(3721),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(3719),
  },
  [2874] = {
    [sym_preproc_region] = STATE(2874),
    [sym_preproc_endregion] = STATE(2874),
    [sym_preproc_line] = STATE(2874),
    [sym_preproc_pragma] = STATE(2874),
    [sym_preproc_nullable] = STATE(2874),
    [sym_preproc_error] = STATE(2874),
    [sym_preproc_define] = STATE(2874),
    [sym_preproc_undef] = STATE(2874),
    [sym__identifier_token] = ACTIONS(4113),
    [anon_sym_alias] = ACTIONS(4113),
    [anon_sym_global] = ACTIONS(4113),
    [anon_sym_EQ] = ACTIONS(4118),
    [anon_sym_LBRACK] = ACTIONS(4135),
    [anon_sym_COLON] = ACTIONS(4133),
    [anon_sym_LPAREN] = ACTIONS(4135),
    [anon_sym_file] = ACTIONS(4113),
    [anon_sym_LT] = ACTIONS(4118),
    [anon_sym_GT] = ACTIONS(4118),
    [anon_sym_where] = ACTIONS(4113),
    [anon_sym_QMARK] = ACTIONS(4138),
    [anon_sym_notnull] = ACTIONS(4113),
    [anon_sym_unmanaged] = ACTIONS(4113),
    [anon_sym_BANG] = ACTIONS(4118),
    [anon_sym_PLUS_PLUS] = ACTIONS(4133),
    [anon_sym_DASH_DASH] = ACTIONS(4133),
    [anon_sym_PLUS] = ACTIONS(4118),
    [anon_sym_DASH] = ACTIONS(4118),
    [anon_sym_STAR] = ACTIONS(4138),
    [anon_sym_SLASH] = ACTIONS(4118),
    [anon_sym_PERCENT] = ACTIONS(4118),
    [anon_sym_CARET] = ACTIONS(4118),
    [anon_sym_PIPE] = ACTIONS(4118),
    [anon_sym_AMP] = ACTIONS(4118),
    [anon_sym_LT_LT] = ACTIONS(4118),
    [anon_sym_GT_GT] = ACTIONS(4118),
    [anon_sym_GT_GT_GT] = ACTIONS(4118),
    [anon_sym_EQ_EQ] = ACTIONS(4133),
    [anon_sym_BANG_EQ] = ACTIONS(4133),
    [anon_sym_GT_EQ] = ACTIONS(4133),
    [anon_sym_LT_EQ] = ACTIONS(4133),
    [anon_sym_DOT] = ACTIONS(4138),
    [anon_sym_scoped] = ACTIONS(4113),
    [anon_sym_EQ_GT] = ACTIONS(4133),
    [anon_sym_var] = ACTIONS(4113),
    [anon_sym_yield] = ACTIONS(4113),
    [anon_sym_switch] = ACTIONS(4118),
    [anon_sym_when] = ACTIONS(4138),
    [anon_sym_DOT_DOT] = ACTIONS(4133),
    [anon_sym_and] = ACTIONS(4118),
    [anon_sym_or] = ACTIONS(4118),
    [anon_sym_PLUS_EQ] = ACTIONS(4133),
    [anon_sym_DASH_EQ] = ACTIONS(4133),
    [anon_sym_STAR_EQ] = ACTIONS(4133),
    [anon_sym_SLASH_EQ] = ACTIONS(4133),
    [anon_sym_PERCENT_EQ] = ACTIONS(4133),
    [anon_sym_AMP_EQ] = ACTIONS(4133),
    [anon_sym_CARET_EQ] = ACTIONS(4133),
    [anon_sym_PIPE_EQ] = ACTIONS(4133),
    [anon_sym_LT_LT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4133),
    [anon_sym_AMP_AMP] = ACTIONS(4133),
    [anon_sym_PIPE_PIPE] = ACTIONS(4133),
    [anon_sym_QMARK_QMARK] = ACTIONS(4118),
    [anon_sym_from] = ACTIONS(4113),
    [anon_sym_into] = ACTIONS(4113),
    [anon_sym_join] = ACTIONS(4113),
    [anon_sym_on] = ACTIONS(4113),
    [anon_sym_equals] = ACTIONS(4113),
    [anon_sym_let] = ACTIONS(4113),
    [anon_sym_orderby] = ACTIONS(4113),
    [anon_sym_ascending] = ACTIONS(4113),
    [anon_sym_descending] = ACTIONS(4113),
    [anon_sym_group] = ACTIONS(4113),
    [anon_sym_by] = ACTIONS(4113),
    [anon_sym_select] = ACTIONS(4113),
    [anon_sym_as] = ACTIONS(4118),
    [anon_sym_is] = ACTIONS(4118),
    [anon_sym_DASH_GT] = ACTIONS(4135),
    [anon_sym_with] = ACTIONS(4118),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2875] = {
    [sym_preproc_region] = STATE(2875),
    [sym_preproc_endregion] = STATE(2875),
    [sym_preproc_line] = STATE(2875),
    [sym_preproc_pragma] = STATE(2875),
    [sym_preproc_nullable] = STATE(2875),
    [sym_preproc_error] = STATE(2875),
    [sym_preproc_define] = STATE(2875),
    [sym_preproc_undef] = STATE(2875),
    [sym__identifier_token] = ACTIONS(4099),
    [anon_sym_alias] = ACTIONS(4099),
    [anon_sym_global] = ACTIONS(4099),
    [anon_sym_EQ] = ACTIONS(4104),
    [anon_sym_LBRACK] = ACTIONS(4101),
    [anon_sym_LPAREN] = ACTIONS(4101),
    [anon_sym_LBRACE] = ACTIONS(4106),
    [anon_sym_file] = ACTIONS(4099),
    [anon_sym_LT] = ACTIONS(4108),
    [anon_sym_GT] = ACTIONS(4108),
    [anon_sym_where] = ACTIONS(4099),
    [anon_sym_QMARK] = ACTIONS(4108),
    [anon_sym_notnull] = ACTIONS(4099),
    [anon_sym_unmanaged] = ACTIONS(4099),
    [anon_sym_BANG] = ACTIONS(4108),
    [anon_sym_PLUS_PLUS] = ACTIONS(4101),
    [anon_sym_DASH_DASH] = ACTIONS(4101),
    [anon_sym_PLUS] = ACTIONS(4108),
    [anon_sym_DASH] = ACTIONS(4108),
    [anon_sym_STAR] = ACTIONS(4108),
    [anon_sym_SLASH] = ACTIONS(4108),
    [anon_sym_PERCENT] = ACTIONS(4108),
    [anon_sym_CARET] = ACTIONS(4108),
    [anon_sym_PIPE] = ACTIONS(4108),
    [anon_sym_AMP] = ACTIONS(4108),
    [anon_sym_LT_LT] = ACTIONS(4108),
    [anon_sym_GT_GT] = ACTIONS(4108),
    [anon_sym_GT_GT_GT] = ACTIONS(4108),
    [anon_sym_EQ_EQ] = ACTIONS(4101),
    [anon_sym_BANG_EQ] = ACTIONS(4101),
    [anon_sym_GT_EQ] = ACTIONS(4101),
    [anon_sym_LT_EQ] = ACTIONS(4101),
    [anon_sym_DOT] = ACTIONS(4108),
    [anon_sym_scoped] = ACTIONS(4099),
    [anon_sym_var] = ACTIONS(4099),
    [anon_sym_yield] = ACTIONS(4099),
    [anon_sym_switch] = ACTIONS(4108),
    [anon_sym_when] = ACTIONS(4099),
    [sym_discard] = ACTIONS(4099),
    [anon_sym_DOT_DOT] = ACTIONS(4101),
    [anon_sym_and] = ACTIONS(4108),
    [anon_sym_or] = ACTIONS(4108),
    [anon_sym_PLUS_EQ] = ACTIONS(4111),
    [anon_sym_DASH_EQ] = ACTIONS(4111),
    [anon_sym_STAR_EQ] = ACTIONS(4111),
    [anon_sym_SLASH_EQ] = ACTIONS(4111),
    [anon_sym_PERCENT_EQ] = ACTIONS(4111),
    [anon_sym_AMP_EQ] = ACTIONS(4111),
    [anon_sym_CARET_EQ] = ACTIONS(4111),
    [anon_sym_PIPE_EQ] = ACTIONS(4111),
    [anon_sym_LT_LT_EQ] = ACTIONS(4111),
    [anon_sym_GT_GT_EQ] = ACTIONS(4111),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4111),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4111),
    [anon_sym_AMP_AMP] = ACTIONS(4101),
    [anon_sym_PIPE_PIPE] = ACTIONS(4101),
    [anon_sym_QMARK_QMARK] = ACTIONS(4108),
    [anon_sym_from] = ACTIONS(4099),
    [anon_sym_into] = ACTIONS(4099),
    [anon_sym_join] = ACTIONS(4099),
    [anon_sym_on] = ACTIONS(4099),
    [anon_sym_equals] = ACTIONS(4099),
    [anon_sym_let] = ACTIONS(4099),
    [anon_sym_orderby] = ACTIONS(4099),
    [anon_sym_ascending] = ACTIONS(4099),
    [anon_sym_descending] = ACTIONS(4099),
    [anon_sym_group] = ACTIONS(4099),
    [anon_sym_by] = ACTIONS(4108),
    [anon_sym_select] = ACTIONS(4099),
    [anon_sym_as] = ACTIONS(4108),
    [anon_sym_is] = ACTIONS(4108),
    [anon_sym_DASH_GT] = ACTIONS(4101),
    [anon_sym_with] = ACTIONS(4108),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2876] = {
    [sym_preproc_region] = STATE(2876),
    [sym_preproc_endregion] = STATE(2876),
    [sym_preproc_line] = STATE(2876),
    [sym_preproc_pragma] = STATE(2876),
    [sym_preproc_nullable] = STATE(2876),
    [sym_preproc_error] = STATE(2876),
    [sym_preproc_define] = STATE(2876),
    [sym_preproc_undef] = STATE(2876),
    [sym__identifier_token] = ACTIONS(4113),
    [anon_sym_alias] = ACTIONS(4113),
    [anon_sym_global] = ACTIONS(4113),
    [anon_sym_EQ] = ACTIONS(4118),
    [anon_sym_LBRACK] = ACTIONS(4120),
    [anon_sym_LPAREN] = ACTIONS(4120),
    [anon_sym_LBRACE] = ACTIONS(4124),
    [anon_sym_file] = ACTIONS(4113),
    [anon_sym_LT] = ACTIONS(4126),
    [anon_sym_GT] = ACTIONS(4126),
    [anon_sym_where] = ACTIONS(4113),
    [anon_sym_QMARK] = ACTIONS(4126),
    [anon_sym_notnull] = ACTIONS(4113),
    [anon_sym_unmanaged] = ACTIONS(4113),
    [anon_sym_BANG] = ACTIONS(4126),
    [anon_sym_PLUS_PLUS] = ACTIONS(4120),
    [anon_sym_DASH_DASH] = ACTIONS(4120),
    [anon_sym_PLUS] = ACTIONS(4126),
    [anon_sym_DASH] = ACTIONS(4126),
    [anon_sym_STAR] = ACTIONS(4126),
    [anon_sym_SLASH] = ACTIONS(4126),
    [anon_sym_PERCENT] = ACTIONS(4126),
    [anon_sym_CARET] = ACTIONS(4126),
    [anon_sym_PIPE] = ACTIONS(4126),
    [anon_sym_AMP] = ACTIONS(4126),
    [anon_sym_LT_LT] = ACTIONS(4126),
    [anon_sym_GT_GT] = ACTIONS(4126),
    [anon_sym_GT_GT_GT] = ACTIONS(4126),
    [anon_sym_EQ_EQ] = ACTIONS(4120),
    [anon_sym_BANG_EQ] = ACTIONS(4120),
    [anon_sym_GT_EQ] = ACTIONS(4120),
    [anon_sym_LT_EQ] = ACTIONS(4120),
    [anon_sym_DOT] = ACTIONS(4126),
    [anon_sym_scoped] = ACTIONS(4113),
    [anon_sym_var] = ACTIONS(4113),
    [anon_sym_yield] = ACTIONS(4113),
    [anon_sym_switch] = ACTIONS(4126),
    [anon_sym_when] = ACTIONS(4113),
    [sym_discard] = ACTIONS(4113),
    [anon_sym_DOT_DOT] = ACTIONS(4120),
    [anon_sym_and] = ACTIONS(4130),
    [anon_sym_or] = ACTIONS(4130),
    [anon_sym_PLUS_EQ] = ACTIONS(4133),
    [anon_sym_DASH_EQ] = ACTIONS(4133),
    [anon_sym_STAR_EQ] = ACTIONS(4133),
    [anon_sym_SLASH_EQ] = ACTIONS(4133),
    [anon_sym_PERCENT_EQ] = ACTIONS(4133),
    [anon_sym_AMP_EQ] = ACTIONS(4133),
    [anon_sym_CARET_EQ] = ACTIONS(4133),
    [anon_sym_PIPE_EQ] = ACTIONS(4133),
    [anon_sym_LT_LT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4133),
    [anon_sym_AMP_AMP] = ACTIONS(4120),
    [anon_sym_PIPE_PIPE] = ACTIONS(4120),
    [anon_sym_QMARK_QMARK] = ACTIONS(4126),
    [anon_sym_from] = ACTIONS(4113),
    [anon_sym_into] = ACTIONS(4113),
    [anon_sym_join] = ACTIONS(4113),
    [anon_sym_on] = ACTIONS(4130),
    [anon_sym_equals] = ACTIONS(4113),
    [anon_sym_let] = ACTIONS(4113),
    [anon_sym_orderby] = ACTIONS(4113),
    [anon_sym_ascending] = ACTIONS(4113),
    [anon_sym_descending] = ACTIONS(4113),
    [anon_sym_group] = ACTIONS(4113),
    [anon_sym_by] = ACTIONS(4113),
    [anon_sym_select] = ACTIONS(4113),
    [anon_sym_as] = ACTIONS(4126),
    [anon_sym_is] = ACTIONS(4126),
    [anon_sym_DASH_GT] = ACTIONS(4120),
    [anon_sym_with] = ACTIONS(4126),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2877] = {
    [sym_preproc_region] = STATE(2877),
    [sym_preproc_endregion] = STATE(2877),
    [sym_preproc_line] = STATE(2877),
    [sym_preproc_pragma] = STATE(2877),
    [sym_preproc_nullable] = STATE(2877),
    [sym_preproc_error] = STATE(2877),
    [sym_preproc_define] = STATE(2877),
    [sym_preproc_undef] = STATE(2877),
    [sym__identifier_token] = ACTIONS(4402),
    [anon_sym_alias] = ACTIONS(4402),
    [anon_sym_SEMI] = ACTIONS(4404),
    [anon_sym_global] = ACTIONS(4402),
    [anon_sym_LBRACK] = ACTIONS(4404),
    [anon_sym_COLON] = ACTIONS(4404),
    [anon_sym_COMMA] = ACTIONS(4404),
    [anon_sym_RBRACK] = ACTIONS(4404),
    [anon_sym_LPAREN] = ACTIONS(4404),
    [anon_sym_RPAREN] = ACTIONS(4404),
    [anon_sym_LBRACE] = ACTIONS(4404),
    [anon_sym_RBRACE] = ACTIONS(4404),
    [anon_sym_file] = ACTIONS(4402),
    [anon_sym_LT] = ACTIONS(4402),
    [anon_sym_GT] = ACTIONS(4402),
    [anon_sym_in] = ACTIONS(4402),
    [anon_sym_where] = ACTIONS(4402),
    [anon_sym_QMARK] = ACTIONS(4402),
    [anon_sym_notnull] = ACTIONS(4402),
    [anon_sym_unmanaged] = ACTIONS(4402),
    [anon_sym_operator] = ACTIONS(4402),
    [anon_sym_BANG] = ACTIONS(4402),
    [anon_sym_PLUS_PLUS] = ACTIONS(4404),
    [anon_sym_DASH_DASH] = ACTIONS(4404),
    [anon_sym_PLUS] = ACTIONS(4402),
    [anon_sym_DASH] = ACTIONS(4402),
    [anon_sym_STAR] = ACTIONS(4404),
    [anon_sym_SLASH] = ACTIONS(4402),
    [anon_sym_PERCENT] = ACTIONS(4404),
    [anon_sym_CARET] = ACTIONS(4404),
    [anon_sym_PIPE] = ACTIONS(4402),
    [anon_sym_AMP] = ACTIONS(4402),
    [anon_sym_LT_LT] = ACTIONS(4404),
    [anon_sym_GT_GT] = ACTIONS(4402),
    [anon_sym_GT_GT_GT] = ACTIONS(4404),
    [anon_sym_EQ_EQ] = ACTIONS(4404),
    [anon_sym_BANG_EQ] = ACTIONS(4404),
    [anon_sym_GT_EQ] = ACTIONS(4404),
    [anon_sym_LT_EQ] = ACTIONS(4404),
    [anon_sym_this] = ACTIONS(4402),
    [anon_sym_DOT] = ACTIONS(4402),
    [anon_sym_scoped] = ACTIONS(4402),
    [anon_sym_EQ_GT] = ACTIONS(4404),
    [anon_sym_var] = ACTIONS(4402),
    [anon_sym_yield] = ACTIONS(4402),
    [anon_sym_switch] = ACTIONS(4402),
    [anon_sym_when] = ACTIONS(4402),
    [sym_discard] = ACTIONS(4402),
    [anon_sym_DOT_DOT] = ACTIONS(4404),
    [anon_sym_and] = ACTIONS(4402),
    [anon_sym_or] = ACTIONS(4402),
    [anon_sym_AMP_AMP] = ACTIONS(4404),
    [anon_sym_PIPE_PIPE] = ACTIONS(4404),
    [anon_sym_QMARK_QMARK] = ACTIONS(4404),
    [anon_sym_from] = ACTIONS(4402),
    [anon_sym_into] = ACTIONS(4402),
    [anon_sym_join] = ACTIONS(4402),
    [anon_sym_on] = ACTIONS(4402),
    [anon_sym_equals] = ACTIONS(4402),
    [anon_sym_let] = ACTIONS(4402),
    [anon_sym_orderby] = ACTIONS(4402),
    [anon_sym_ascending] = ACTIONS(4402),
    [anon_sym_descending] = ACTIONS(4402),
    [anon_sym_group] = ACTIONS(4402),
    [anon_sym_by] = ACTIONS(4402),
    [anon_sym_select] = ACTIONS(4402),
    [anon_sym_as] = ACTIONS(4402),
    [anon_sym_is] = ACTIONS(4402),
    [anon_sym_DASH_GT] = ACTIONS(4404),
    [anon_sym_with] = ACTIONS(4402),
    [aux_sym_preproc_if_token3] = ACTIONS(4404),
    [aux_sym_preproc_else_token1] = ACTIONS(4404),
    [aux_sym_preproc_elif_token1] = ACTIONS(4404),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2878] = {
    [sym_preproc_region] = STATE(2878),
    [sym_preproc_endregion] = STATE(2878),
    [sym_preproc_line] = STATE(2878),
    [sym_preproc_pragma] = STATE(2878),
    [sym_preproc_nullable] = STATE(2878),
    [sym_preproc_error] = STATE(2878),
    [sym_preproc_define] = STATE(2878),
    [sym_preproc_undef] = STATE(2878),
    [sym__identifier_token] = ACTIONS(4113),
    [anon_sym_alias] = ACTIONS(4113),
    [anon_sym_global] = ACTIONS(4113),
    [anon_sym_EQ] = ACTIONS(4118),
    [anon_sym_LBRACK] = ACTIONS(4120),
    [anon_sym_LPAREN] = ACTIONS(4120),
    [anon_sym_LBRACE] = ACTIONS(4124),
    [anon_sym_file] = ACTIONS(4113),
    [anon_sym_LT] = ACTIONS(4126),
    [anon_sym_GT] = ACTIONS(4126),
    [anon_sym_where] = ACTIONS(4130),
    [anon_sym_QMARK] = ACTIONS(4126),
    [anon_sym_notnull] = ACTIONS(4113),
    [anon_sym_unmanaged] = ACTIONS(4113),
    [anon_sym_BANG] = ACTIONS(4126),
    [anon_sym_PLUS_PLUS] = ACTIONS(4120),
    [anon_sym_DASH_DASH] = ACTIONS(4120),
    [anon_sym_PLUS] = ACTIONS(4126),
    [anon_sym_DASH] = ACTIONS(4126),
    [anon_sym_STAR] = ACTIONS(4126),
    [anon_sym_SLASH] = ACTIONS(4126),
    [anon_sym_PERCENT] = ACTIONS(4126),
    [anon_sym_CARET] = ACTIONS(4126),
    [anon_sym_PIPE] = ACTIONS(4126),
    [anon_sym_AMP] = ACTIONS(4126),
    [anon_sym_LT_LT] = ACTIONS(4126),
    [anon_sym_GT_GT] = ACTIONS(4126),
    [anon_sym_GT_GT_GT] = ACTIONS(4126),
    [anon_sym_EQ_EQ] = ACTIONS(4120),
    [anon_sym_BANG_EQ] = ACTIONS(4120),
    [anon_sym_GT_EQ] = ACTIONS(4120),
    [anon_sym_LT_EQ] = ACTIONS(4120),
    [anon_sym_DOT] = ACTIONS(4126),
    [anon_sym_scoped] = ACTIONS(4113),
    [anon_sym_var] = ACTIONS(4113),
    [anon_sym_yield] = ACTIONS(4113),
    [anon_sym_switch] = ACTIONS(4126),
    [anon_sym_when] = ACTIONS(4113),
    [sym_discard] = ACTIONS(4113),
    [anon_sym_DOT_DOT] = ACTIONS(4120),
    [anon_sym_and] = ACTIONS(4130),
    [anon_sym_or] = ACTIONS(4130),
    [anon_sym_PLUS_EQ] = ACTIONS(4133),
    [anon_sym_DASH_EQ] = ACTIONS(4133),
    [anon_sym_STAR_EQ] = ACTIONS(4133),
    [anon_sym_SLASH_EQ] = ACTIONS(4133),
    [anon_sym_PERCENT_EQ] = ACTIONS(4133),
    [anon_sym_AMP_EQ] = ACTIONS(4133),
    [anon_sym_CARET_EQ] = ACTIONS(4133),
    [anon_sym_PIPE_EQ] = ACTIONS(4133),
    [anon_sym_LT_LT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4133),
    [anon_sym_AMP_AMP] = ACTIONS(4120),
    [anon_sym_PIPE_PIPE] = ACTIONS(4120),
    [anon_sym_QMARK_QMARK] = ACTIONS(4126),
    [anon_sym_from] = ACTIONS(4130),
    [anon_sym_into] = ACTIONS(4113),
    [anon_sym_join] = ACTIONS(4130),
    [anon_sym_on] = ACTIONS(4113),
    [anon_sym_equals] = ACTIONS(4113),
    [anon_sym_let] = ACTIONS(4130),
    [anon_sym_orderby] = ACTIONS(4130),
    [anon_sym_ascending] = ACTIONS(4113),
    [anon_sym_descending] = ACTIONS(4113),
    [anon_sym_group] = ACTIONS(4130),
    [anon_sym_by] = ACTIONS(4113),
    [anon_sym_select] = ACTIONS(4130),
    [anon_sym_as] = ACTIONS(4126),
    [anon_sym_is] = ACTIONS(4126),
    [anon_sym_DASH_GT] = ACTIONS(4120),
    [anon_sym_with] = ACTIONS(4126),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2879] = {
    [sym_preproc_region] = STATE(2879),
    [sym_preproc_endregion] = STATE(2879),
    [sym_preproc_line] = STATE(2879),
    [sym_preproc_pragma] = STATE(2879),
    [sym_preproc_nullable] = STATE(2879),
    [sym_preproc_error] = STATE(2879),
    [sym_preproc_define] = STATE(2879),
    [sym_preproc_undef] = STATE(2879),
    [sym__identifier_token] = ACTIONS(4099),
    [anon_sym_alias] = ACTIONS(4099),
    [anon_sym_global] = ACTIONS(4099),
    [anon_sym_EQ] = ACTIONS(4104),
    [anon_sym_LBRACK] = ACTIONS(4101),
    [anon_sym_COLON] = ACTIONS(4111),
    [anon_sym_LPAREN] = ACTIONS(4101),
    [anon_sym_file] = ACTIONS(4099),
    [anon_sym_LT] = ACTIONS(4104),
    [anon_sym_GT] = ACTIONS(4104),
    [anon_sym_where] = ACTIONS(4099),
    [anon_sym_QMARK] = ACTIONS(4108),
    [anon_sym_notnull] = ACTIONS(4099),
    [anon_sym_unmanaged] = ACTIONS(4099),
    [anon_sym_BANG] = ACTIONS(4104),
    [anon_sym_PLUS_PLUS] = ACTIONS(4111),
    [anon_sym_DASH_DASH] = ACTIONS(4111),
    [anon_sym_PLUS] = ACTIONS(4104),
    [anon_sym_DASH] = ACTIONS(4104),
    [anon_sym_STAR] = ACTIONS(4108),
    [anon_sym_SLASH] = ACTIONS(4104),
    [anon_sym_PERCENT] = ACTIONS(4104),
    [anon_sym_CARET] = ACTIONS(4104),
    [anon_sym_PIPE] = ACTIONS(4104),
    [anon_sym_AMP] = ACTIONS(4104),
    [anon_sym_LT_LT] = ACTIONS(4104),
    [anon_sym_GT_GT] = ACTIONS(4104),
    [anon_sym_GT_GT_GT] = ACTIONS(4104),
    [anon_sym_EQ_EQ] = ACTIONS(4111),
    [anon_sym_BANG_EQ] = ACTIONS(4111),
    [anon_sym_GT_EQ] = ACTIONS(4111),
    [anon_sym_LT_EQ] = ACTIONS(4111),
    [anon_sym_DOT] = ACTIONS(4108),
    [anon_sym_scoped] = ACTIONS(4099),
    [anon_sym_EQ_GT] = ACTIONS(4111),
    [anon_sym_var] = ACTIONS(4099),
    [anon_sym_yield] = ACTIONS(4099),
    [anon_sym_switch] = ACTIONS(4104),
    [anon_sym_when] = ACTIONS(4108),
    [anon_sym_DOT_DOT] = ACTIONS(4111),
    [anon_sym_and] = ACTIONS(4104),
    [anon_sym_or] = ACTIONS(4104),
    [anon_sym_PLUS_EQ] = ACTIONS(4111),
    [anon_sym_DASH_EQ] = ACTIONS(4111),
    [anon_sym_STAR_EQ] = ACTIONS(4111),
    [anon_sym_SLASH_EQ] = ACTIONS(4111),
    [anon_sym_PERCENT_EQ] = ACTIONS(4111),
    [anon_sym_AMP_EQ] = ACTIONS(4111),
    [anon_sym_CARET_EQ] = ACTIONS(4111),
    [anon_sym_PIPE_EQ] = ACTIONS(4111),
    [anon_sym_LT_LT_EQ] = ACTIONS(4111),
    [anon_sym_GT_GT_EQ] = ACTIONS(4111),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4111),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4111),
    [anon_sym_AMP_AMP] = ACTIONS(4111),
    [anon_sym_PIPE_PIPE] = ACTIONS(4111),
    [anon_sym_QMARK_QMARK] = ACTIONS(4104),
    [anon_sym_from] = ACTIONS(4099),
    [anon_sym_into] = ACTIONS(4099),
    [anon_sym_join] = ACTIONS(4099),
    [anon_sym_on] = ACTIONS(4099),
    [anon_sym_equals] = ACTIONS(4099),
    [anon_sym_let] = ACTIONS(4099),
    [anon_sym_orderby] = ACTIONS(4099),
    [anon_sym_ascending] = ACTIONS(4099),
    [anon_sym_descending] = ACTIONS(4099),
    [anon_sym_group] = ACTIONS(4099),
    [anon_sym_by] = ACTIONS(4099),
    [anon_sym_select] = ACTIONS(4099),
    [anon_sym_as] = ACTIONS(4104),
    [anon_sym_is] = ACTIONS(4104),
    [anon_sym_DASH_GT] = ACTIONS(4101),
    [anon_sym_with] = ACTIONS(4104),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2880] = {
    [sym__variable_designation] = STATE(4113),
    [sym_parenthesized_variable_designation] = STATE(4274),
    [sym_identifier] = STATE(4269),
    [sym__reserved_identifier] = STATE(3908),
    [sym_preproc_region] = STATE(2880),
    [sym_preproc_endregion] = STATE(2880),
    [sym_preproc_line] = STATE(2880),
    [sym_preproc_pragma] = STATE(2880),
    [sym_preproc_nullable] = STATE(2880),
    [sym_preproc_error] = STATE(2880),
    [sym_preproc_define] = STATE(2880),
    [sym_preproc_undef] = STATE(2880),
    [sym__identifier_token] = ACTIONS(4271),
    [anon_sym_alias] = ACTIONS(4273),
    [anon_sym_SEMI] = ACTIONS(4373),
    [anon_sym_global] = ACTIONS(4273),
    [anon_sym_LBRACK] = ACTIONS(4373),
    [anon_sym_COLON] = ACTIONS(4373),
    [anon_sym_COMMA] = ACTIONS(4373),
    [anon_sym_RBRACK] = ACTIONS(4373),
    [anon_sym_LPAREN] = ACTIONS(4373),
    [anon_sym_RPAREN] = ACTIONS(4373),
    [anon_sym_RBRACE] = ACTIONS(4373),
    [anon_sym_file] = ACTIONS(4273),
    [anon_sym_LT] = ACTIONS(4375),
    [anon_sym_GT] = ACTIONS(4375),
    [anon_sym_where] = ACTIONS(4273),
    [anon_sym_QMARK] = ACTIONS(4375),
    [anon_sym_notnull] = ACTIONS(4273),
    [anon_sym_unmanaged] = ACTIONS(4273),
    [anon_sym_BANG] = ACTIONS(4375),
    [anon_sym_PLUS_PLUS] = ACTIONS(4373),
    [anon_sym_DASH_DASH] = ACTIONS(4373),
    [anon_sym_PLUS] = ACTIONS(4375),
    [anon_sym_DASH] = ACTIONS(4375),
    [anon_sym_STAR] = ACTIONS(4373),
    [anon_sym_SLASH] = ACTIONS(4375),
    [anon_sym_PERCENT] = ACTIONS(4373),
    [anon_sym_CARET] = ACTIONS(4373),
    [anon_sym_PIPE] = ACTIONS(4375),
    [anon_sym_AMP] = ACTIONS(4375),
    [anon_sym_LT_LT] = ACTIONS(4373),
    [anon_sym_GT_GT] = ACTIONS(4375),
    [anon_sym_GT_GT_GT] = ACTIONS(4373),
    [anon_sym_EQ_EQ] = ACTIONS(4373),
    [anon_sym_BANG_EQ] = ACTIONS(4373),
    [anon_sym_GT_EQ] = ACTIONS(4373),
    [anon_sym_LT_EQ] = ACTIONS(4373),
    [anon_sym_DOT] = ACTIONS(4375),
    [anon_sym_scoped] = ACTIONS(4273),
    [anon_sym_EQ_GT] = ACTIONS(4373),
    [anon_sym_var] = ACTIONS(4273),
    [anon_sym_yield] = ACTIONS(4273),
    [anon_sym_switch] = ACTIONS(4375),
    [anon_sym_when] = ACTIONS(4273),
    [sym_discard] = ACTIONS(4295),
    [anon_sym_DOT_DOT] = ACTIONS(4373),
    [anon_sym_and] = ACTIONS(4375),
    [anon_sym_or] = ACTIONS(4375),
    [anon_sym_AMP_AMP] = ACTIONS(4373),
    [anon_sym_PIPE_PIPE] = ACTIONS(4373),
    [anon_sym_QMARK_QMARK] = ACTIONS(4373),
    [anon_sym_from] = ACTIONS(4273),
    [anon_sym_into] = ACTIONS(4273),
    [anon_sym_join] = ACTIONS(4273),
    [anon_sym_on] = ACTIONS(4273),
    [anon_sym_equals] = ACTIONS(4273),
    [anon_sym_let] = ACTIONS(4273),
    [anon_sym_orderby] = ACTIONS(4273),
    [anon_sym_ascending] = ACTIONS(4273),
    [anon_sym_descending] = ACTIONS(4273),
    [anon_sym_group] = ACTIONS(4273),
    [anon_sym_by] = ACTIONS(4273),
    [anon_sym_select] = ACTIONS(4273),
    [anon_sym_as] = ACTIONS(4375),
    [anon_sym_is] = ACTIONS(4375),
    [anon_sym_DASH_GT] = ACTIONS(4373),
    [anon_sym_with] = ACTIONS(4375),
    [aux_sym_preproc_if_token3] = ACTIONS(4373),
    [aux_sym_preproc_else_token1] = ACTIONS(4373),
    [aux_sym_preproc_elif_token1] = ACTIONS(4373),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2881] = {
    [sym_preproc_region] = STATE(2881),
    [sym_preproc_endregion] = STATE(2881),
    [sym_preproc_line] = STATE(2881),
    [sym_preproc_pragma] = STATE(2881),
    [sym_preproc_nullable] = STATE(2881),
    [sym_preproc_error] = STATE(2881),
    [sym_preproc_define] = STATE(2881),
    [sym_preproc_undef] = STATE(2881),
    [sym__identifier_token] = ACTIONS(4406),
    [anon_sym_alias] = ACTIONS(4406),
    [anon_sym_SEMI] = ACTIONS(4408),
    [anon_sym_global] = ACTIONS(4406),
    [anon_sym_LBRACK] = ACTIONS(4408),
    [anon_sym_COLON] = ACTIONS(4408),
    [anon_sym_COMMA] = ACTIONS(4408),
    [anon_sym_RBRACK] = ACTIONS(4408),
    [anon_sym_LPAREN] = ACTIONS(4408),
    [anon_sym_RPAREN] = ACTIONS(4408),
    [anon_sym_LBRACE] = ACTIONS(4408),
    [anon_sym_RBRACE] = ACTIONS(4408),
    [anon_sym_file] = ACTIONS(4406),
    [anon_sym_LT] = ACTIONS(4406),
    [anon_sym_GT] = ACTIONS(4406),
    [anon_sym_in] = ACTIONS(4406),
    [anon_sym_where] = ACTIONS(4406),
    [anon_sym_QMARK] = ACTIONS(4406),
    [anon_sym_notnull] = ACTIONS(4406),
    [anon_sym_unmanaged] = ACTIONS(4406),
    [anon_sym_operator] = ACTIONS(4406),
    [anon_sym_BANG] = ACTIONS(4406),
    [anon_sym_PLUS_PLUS] = ACTIONS(4408),
    [anon_sym_DASH_DASH] = ACTIONS(4408),
    [anon_sym_PLUS] = ACTIONS(4406),
    [anon_sym_DASH] = ACTIONS(4406),
    [anon_sym_STAR] = ACTIONS(4408),
    [anon_sym_SLASH] = ACTIONS(4406),
    [anon_sym_PERCENT] = ACTIONS(4408),
    [anon_sym_CARET] = ACTIONS(4408),
    [anon_sym_PIPE] = ACTIONS(4406),
    [anon_sym_AMP] = ACTIONS(4406),
    [anon_sym_LT_LT] = ACTIONS(4408),
    [anon_sym_GT_GT] = ACTIONS(4406),
    [anon_sym_GT_GT_GT] = ACTIONS(4408),
    [anon_sym_EQ_EQ] = ACTIONS(4408),
    [anon_sym_BANG_EQ] = ACTIONS(4408),
    [anon_sym_GT_EQ] = ACTIONS(4408),
    [anon_sym_LT_EQ] = ACTIONS(4408),
    [anon_sym_this] = ACTIONS(4406),
    [anon_sym_DOT] = ACTIONS(4406),
    [anon_sym_scoped] = ACTIONS(4406),
    [anon_sym_EQ_GT] = ACTIONS(4408),
    [anon_sym_var] = ACTIONS(4406),
    [anon_sym_yield] = ACTIONS(4406),
    [anon_sym_switch] = ACTIONS(4406),
    [anon_sym_when] = ACTIONS(4406),
    [sym_discard] = ACTIONS(4406),
    [anon_sym_DOT_DOT] = ACTIONS(4408),
    [anon_sym_and] = ACTIONS(4406),
    [anon_sym_or] = ACTIONS(4406),
    [anon_sym_AMP_AMP] = ACTIONS(4408),
    [anon_sym_PIPE_PIPE] = ACTIONS(4408),
    [anon_sym_QMARK_QMARK] = ACTIONS(4408),
    [anon_sym_from] = ACTIONS(4406),
    [anon_sym_into] = ACTIONS(4406),
    [anon_sym_join] = ACTIONS(4406),
    [anon_sym_on] = ACTIONS(4406),
    [anon_sym_equals] = ACTIONS(4406),
    [anon_sym_let] = ACTIONS(4406),
    [anon_sym_orderby] = ACTIONS(4406),
    [anon_sym_ascending] = ACTIONS(4406),
    [anon_sym_descending] = ACTIONS(4406),
    [anon_sym_group] = ACTIONS(4406),
    [anon_sym_by] = ACTIONS(4406),
    [anon_sym_select] = ACTIONS(4406),
    [anon_sym_as] = ACTIONS(4406),
    [anon_sym_is] = ACTIONS(4406),
    [anon_sym_DASH_GT] = ACTIONS(4408),
    [anon_sym_with] = ACTIONS(4406),
    [aux_sym_preproc_if_token3] = ACTIONS(4408),
    [aux_sym_preproc_else_token1] = ACTIONS(4408),
    [aux_sym_preproc_elif_token1] = ACTIONS(4408),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2882] = {
    [sym_preproc_region] = STATE(2882),
    [sym_preproc_endregion] = STATE(2882),
    [sym_preproc_line] = STATE(2882),
    [sym_preproc_pragma] = STATE(2882),
    [sym_preproc_nullable] = STATE(2882),
    [sym_preproc_error] = STATE(2882),
    [sym_preproc_define] = STATE(2882),
    [sym_preproc_undef] = STATE(2882),
    [sym__identifier_token] = ACTIONS(4113),
    [anon_sym_alias] = ACTIONS(4113),
    [anon_sym_global] = ACTIONS(4113),
    [anon_sym_EQ] = ACTIONS(4118),
    [anon_sym_LBRACK] = ACTIONS(4135),
    [anon_sym_COLON] = ACTIONS(4133),
    [anon_sym_LPAREN] = ACTIONS(4135),
    [anon_sym_file] = ACTIONS(4113),
    [anon_sym_LT] = ACTIONS(4118),
    [anon_sym_GT] = ACTIONS(4118),
    [anon_sym_where] = ACTIONS(4113),
    [anon_sym_QMARK] = ACTIONS(4138),
    [anon_sym_notnull] = ACTIONS(4113),
    [anon_sym_unmanaged] = ACTIONS(4113),
    [anon_sym_BANG] = ACTIONS(4118),
    [anon_sym_PLUS_PLUS] = ACTIONS(4133),
    [anon_sym_DASH_DASH] = ACTIONS(4133),
    [anon_sym_PLUS] = ACTIONS(4118),
    [anon_sym_DASH] = ACTIONS(4118),
    [anon_sym_STAR] = ACTIONS(4138),
    [anon_sym_SLASH] = ACTIONS(4118),
    [anon_sym_PERCENT] = ACTIONS(4118),
    [anon_sym_CARET] = ACTIONS(4118),
    [anon_sym_PIPE] = ACTIONS(4118),
    [anon_sym_AMP] = ACTIONS(4118),
    [anon_sym_LT_LT] = ACTIONS(4118),
    [anon_sym_GT_GT] = ACTIONS(4118),
    [anon_sym_GT_GT_GT] = ACTIONS(4118),
    [anon_sym_EQ_EQ] = ACTIONS(4133),
    [anon_sym_BANG_EQ] = ACTIONS(4133),
    [anon_sym_GT_EQ] = ACTIONS(4133),
    [anon_sym_LT_EQ] = ACTIONS(4133),
    [anon_sym_DOT] = ACTIONS(4138),
    [anon_sym_scoped] = ACTIONS(4113),
    [anon_sym_EQ_GT] = ACTIONS(4133),
    [anon_sym_var] = ACTIONS(4113),
    [anon_sym_yield] = ACTIONS(4113),
    [anon_sym_switch] = ACTIONS(4118),
    [anon_sym_when] = ACTIONS(4138),
    [anon_sym_DOT_DOT] = ACTIONS(4133),
    [anon_sym_and] = ACTIONS(4118),
    [anon_sym_or] = ACTIONS(4118),
    [anon_sym_PLUS_EQ] = ACTIONS(4133),
    [anon_sym_DASH_EQ] = ACTIONS(4133),
    [anon_sym_STAR_EQ] = ACTIONS(4133),
    [anon_sym_SLASH_EQ] = ACTIONS(4133),
    [anon_sym_PERCENT_EQ] = ACTIONS(4133),
    [anon_sym_AMP_EQ] = ACTIONS(4133),
    [anon_sym_CARET_EQ] = ACTIONS(4133),
    [anon_sym_PIPE_EQ] = ACTIONS(4133),
    [anon_sym_LT_LT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4133),
    [anon_sym_AMP_AMP] = ACTIONS(4133),
    [anon_sym_PIPE_PIPE] = ACTIONS(4133),
    [anon_sym_QMARK_QMARK] = ACTIONS(4118),
    [anon_sym_from] = ACTIONS(4113),
    [anon_sym_into] = ACTIONS(4138),
    [anon_sym_join] = ACTIONS(4113),
    [anon_sym_on] = ACTIONS(4113),
    [anon_sym_equals] = ACTIONS(4113),
    [anon_sym_let] = ACTIONS(4113),
    [anon_sym_orderby] = ACTIONS(4113),
    [anon_sym_ascending] = ACTIONS(4113),
    [anon_sym_descending] = ACTIONS(4113),
    [anon_sym_group] = ACTIONS(4113),
    [anon_sym_by] = ACTIONS(4113),
    [anon_sym_select] = ACTIONS(4113),
    [anon_sym_as] = ACTIONS(4118),
    [anon_sym_is] = ACTIONS(4118),
    [anon_sym_DASH_GT] = ACTIONS(4135),
    [anon_sym_with] = ACTIONS(4118),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2883] = {
    [sym_preproc_region] = STATE(2883),
    [sym_preproc_endregion] = STATE(2883),
    [sym_preproc_line] = STATE(2883),
    [sym_preproc_pragma] = STATE(2883),
    [sym_preproc_nullable] = STATE(2883),
    [sym_preproc_error] = STATE(2883),
    [sym_preproc_define] = STATE(2883),
    [sym_preproc_undef] = STATE(2883),
    [sym__identifier_token] = ACTIONS(4099),
    [anon_sym_alias] = ACTIONS(4099),
    [anon_sym_global] = ACTIONS(4099),
    [anon_sym_EQ] = ACTIONS(4104),
    [anon_sym_LBRACK] = ACTIONS(4101),
    [anon_sym_LPAREN] = ACTIONS(4101),
    [anon_sym_LBRACE] = ACTIONS(4106),
    [anon_sym_file] = ACTIONS(4099),
    [anon_sym_LT] = ACTIONS(4108),
    [anon_sym_GT] = ACTIONS(4108),
    [anon_sym_where] = ACTIONS(4108),
    [anon_sym_QMARK] = ACTIONS(4108),
    [anon_sym_notnull] = ACTIONS(4099),
    [anon_sym_unmanaged] = ACTIONS(4099),
    [anon_sym_BANG] = ACTIONS(4108),
    [anon_sym_PLUS_PLUS] = ACTIONS(4101),
    [anon_sym_DASH_DASH] = ACTIONS(4101),
    [anon_sym_PLUS] = ACTIONS(4108),
    [anon_sym_DASH] = ACTIONS(4108),
    [anon_sym_STAR] = ACTIONS(4108),
    [anon_sym_SLASH] = ACTIONS(4108),
    [anon_sym_PERCENT] = ACTIONS(4108),
    [anon_sym_CARET] = ACTIONS(4108),
    [anon_sym_PIPE] = ACTIONS(4108),
    [anon_sym_AMP] = ACTIONS(4108),
    [anon_sym_LT_LT] = ACTIONS(4108),
    [anon_sym_GT_GT] = ACTIONS(4108),
    [anon_sym_GT_GT_GT] = ACTIONS(4108),
    [anon_sym_EQ_EQ] = ACTIONS(4101),
    [anon_sym_BANG_EQ] = ACTIONS(4101),
    [anon_sym_GT_EQ] = ACTIONS(4101),
    [anon_sym_LT_EQ] = ACTIONS(4101),
    [anon_sym_DOT] = ACTIONS(4108),
    [anon_sym_scoped] = ACTIONS(4099),
    [anon_sym_var] = ACTIONS(4099),
    [anon_sym_yield] = ACTIONS(4099),
    [anon_sym_switch] = ACTIONS(4108),
    [anon_sym_when] = ACTIONS(4099),
    [sym_discard] = ACTIONS(4099),
    [anon_sym_DOT_DOT] = ACTIONS(4101),
    [anon_sym_and] = ACTIONS(4108),
    [anon_sym_or] = ACTIONS(4108),
    [anon_sym_PLUS_EQ] = ACTIONS(4111),
    [anon_sym_DASH_EQ] = ACTIONS(4111),
    [anon_sym_STAR_EQ] = ACTIONS(4111),
    [anon_sym_SLASH_EQ] = ACTIONS(4111),
    [anon_sym_PERCENT_EQ] = ACTIONS(4111),
    [anon_sym_AMP_EQ] = ACTIONS(4111),
    [anon_sym_CARET_EQ] = ACTIONS(4111),
    [anon_sym_PIPE_EQ] = ACTIONS(4111),
    [anon_sym_LT_LT_EQ] = ACTIONS(4111),
    [anon_sym_GT_GT_EQ] = ACTIONS(4111),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4111),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4111),
    [anon_sym_AMP_AMP] = ACTIONS(4101),
    [anon_sym_PIPE_PIPE] = ACTIONS(4101),
    [anon_sym_QMARK_QMARK] = ACTIONS(4108),
    [anon_sym_from] = ACTIONS(4108),
    [anon_sym_into] = ACTIONS(4108),
    [anon_sym_join] = ACTIONS(4108),
    [anon_sym_on] = ACTIONS(4099),
    [anon_sym_equals] = ACTIONS(4099),
    [anon_sym_let] = ACTIONS(4108),
    [anon_sym_orderby] = ACTIONS(4108),
    [anon_sym_ascending] = ACTIONS(4099),
    [anon_sym_descending] = ACTIONS(4099),
    [anon_sym_group] = ACTIONS(4108),
    [anon_sym_by] = ACTIONS(4099),
    [anon_sym_select] = ACTIONS(4108),
    [anon_sym_as] = ACTIONS(4108),
    [anon_sym_is] = ACTIONS(4108),
    [anon_sym_DASH_GT] = ACTIONS(4101),
    [anon_sym_with] = ACTIONS(4108),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2884] = {
    [sym_preproc_region] = STATE(2884),
    [sym_preproc_endregion] = STATE(2884),
    [sym_preproc_line] = STATE(2884),
    [sym_preproc_pragma] = STATE(2884),
    [sym_preproc_nullable] = STATE(2884),
    [sym_preproc_error] = STATE(2884),
    [sym_preproc_define] = STATE(2884),
    [sym_preproc_undef] = STATE(2884),
    [sym__identifier_token] = ACTIONS(3721),
    [anon_sym_alias] = ACTIONS(3721),
    [anon_sym_global] = ACTIONS(3721),
    [anon_sym_using] = ACTIONS(4410),
    [anon_sym_EQ] = ACTIONS(3721),
    [anon_sym_LBRACK] = ACTIONS(3719),
    [anon_sym_COLON] = ACTIONS(3721),
    [anon_sym_LPAREN] = ACTIONS(3719),
    [anon_sym_file] = ACTIONS(3721),
    [anon_sym_LT] = ACTIONS(3721),
    [anon_sym_GT] = ACTIONS(3721),
    [anon_sym_where] = ACTIONS(3721),
    [anon_sym_QMARK] = ACTIONS(3721),
    [anon_sym_notnull] = ACTIONS(3721),
    [anon_sym_unmanaged] = ACTIONS(3721),
    [anon_sym_BANG] = ACTIONS(3721),
    [anon_sym_PLUS_PLUS] = ACTIONS(3719),
    [anon_sym_DASH_DASH] = ACTIONS(3719),
    [anon_sym_PLUS] = ACTIONS(3721),
    [anon_sym_DASH] = ACTIONS(3721),
    [anon_sym_STAR] = ACTIONS(3721),
    [anon_sym_SLASH] = ACTIONS(3721),
    [anon_sym_PERCENT] = ACTIONS(3721),
    [anon_sym_CARET] = ACTIONS(3721),
    [anon_sym_PIPE] = ACTIONS(3721),
    [anon_sym_AMP] = ACTIONS(3721),
    [anon_sym_LT_LT] = ACTIONS(3721),
    [anon_sym_GT_GT] = ACTIONS(3721),
    [anon_sym_GT_GT_GT] = ACTIONS(3721),
    [anon_sym_EQ_EQ] = ACTIONS(3719),
    [anon_sym_BANG_EQ] = ACTIONS(3719),
    [anon_sym_GT_EQ] = ACTIONS(3719),
    [anon_sym_LT_EQ] = ACTIONS(3719),
    [anon_sym_DOT] = ACTIONS(3721),
    [anon_sym_scoped] = ACTIONS(3721),
    [anon_sym_EQ_GT] = ACTIONS(3719),
    [anon_sym_COLON_COLON] = ACTIONS(3719),
    [anon_sym_var] = ACTIONS(3721),
    [anon_sym_yield] = ACTIONS(3721),
    [anon_sym_switch] = ACTIONS(3721),
    [anon_sym_when] = ACTIONS(3721),
    [anon_sym_DOT_DOT] = ACTIONS(3719),
    [anon_sym_PLUS_EQ] = ACTIONS(3719),
    [anon_sym_DASH_EQ] = ACTIONS(3719),
    [anon_sym_STAR_EQ] = ACTIONS(3719),
    [anon_sym_SLASH_EQ] = ACTIONS(3719),
    [anon_sym_PERCENT_EQ] = ACTIONS(3719),
    [anon_sym_AMP_EQ] = ACTIONS(3719),
    [anon_sym_CARET_EQ] = ACTIONS(3719),
    [anon_sym_PIPE_EQ] = ACTIONS(3719),
    [anon_sym_LT_LT_EQ] = ACTIONS(3719),
    [anon_sym_GT_GT_EQ] = ACTIONS(3719),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3719),
    [anon_sym_AMP_AMP] = ACTIONS(3719),
    [anon_sym_PIPE_PIPE] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK] = ACTIONS(3721),
    [anon_sym_from] = ACTIONS(3721),
    [anon_sym_into] = ACTIONS(3721),
    [anon_sym_join] = ACTIONS(3721),
    [anon_sym_on] = ACTIONS(3721),
    [anon_sym_equals] = ACTIONS(3721),
    [anon_sym_let] = ACTIONS(3721),
    [anon_sym_orderby] = ACTIONS(3721),
    [anon_sym_ascending] = ACTIONS(3721),
    [anon_sym_descending] = ACTIONS(3721),
    [anon_sym_group] = ACTIONS(3721),
    [anon_sym_by] = ACTIONS(3721),
    [anon_sym_select] = ACTIONS(3721),
    [anon_sym_as] = ACTIONS(3721),
    [anon_sym_is] = ACTIONS(3721),
    [anon_sym_DASH_GT] = ACTIONS(3719),
    [anon_sym_with] = ACTIONS(3721),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2885] = {
    [sym_preproc_region] = STATE(2885),
    [sym_preproc_endregion] = STATE(2885),
    [sym_preproc_line] = STATE(2885),
    [sym_preproc_pragma] = STATE(2885),
    [sym_preproc_nullable] = STATE(2885),
    [sym_preproc_error] = STATE(2885),
    [sym_preproc_define] = STATE(2885),
    [sym_preproc_undef] = STATE(2885),
    [sym__identifier_token] = ACTIONS(4099),
    [anon_sym_alias] = ACTIONS(4099),
    [anon_sym_global] = ACTIONS(4099),
    [anon_sym_EQ] = ACTIONS(4104),
    [anon_sym_LBRACK] = ACTIONS(4101),
    [anon_sym_LPAREN] = ACTIONS(4101),
    [anon_sym_LBRACE] = ACTIONS(4106),
    [anon_sym_file] = ACTIONS(4099),
    [anon_sym_LT] = ACTIONS(4108),
    [anon_sym_GT] = ACTIONS(4108),
    [anon_sym_where] = ACTIONS(4099),
    [anon_sym_QMARK] = ACTIONS(4108),
    [anon_sym_notnull] = ACTIONS(4099),
    [anon_sym_unmanaged] = ACTIONS(4099),
    [anon_sym_BANG] = ACTIONS(4108),
    [anon_sym_PLUS_PLUS] = ACTIONS(4101),
    [anon_sym_DASH_DASH] = ACTIONS(4101),
    [anon_sym_PLUS] = ACTIONS(4108),
    [anon_sym_DASH] = ACTIONS(4108),
    [anon_sym_STAR] = ACTIONS(4108),
    [anon_sym_SLASH] = ACTIONS(4108),
    [anon_sym_PERCENT] = ACTIONS(4108),
    [anon_sym_CARET] = ACTIONS(4108),
    [anon_sym_PIPE] = ACTIONS(4108),
    [anon_sym_AMP] = ACTIONS(4108),
    [anon_sym_LT_LT] = ACTIONS(4108),
    [anon_sym_GT_GT] = ACTIONS(4108),
    [anon_sym_GT_GT_GT] = ACTIONS(4108),
    [anon_sym_EQ_EQ] = ACTIONS(4101),
    [anon_sym_BANG_EQ] = ACTIONS(4101),
    [anon_sym_GT_EQ] = ACTIONS(4101),
    [anon_sym_LT_EQ] = ACTIONS(4101),
    [anon_sym_DOT] = ACTIONS(4108),
    [anon_sym_scoped] = ACTIONS(4099),
    [anon_sym_var] = ACTIONS(4099),
    [anon_sym_yield] = ACTIONS(4099),
    [anon_sym_switch] = ACTIONS(4108),
    [anon_sym_when] = ACTIONS(4099),
    [sym_discard] = ACTIONS(4099),
    [anon_sym_DOT_DOT] = ACTIONS(4101),
    [anon_sym_and] = ACTIONS(4108),
    [anon_sym_or] = ACTIONS(4108),
    [anon_sym_PLUS_EQ] = ACTIONS(4111),
    [anon_sym_DASH_EQ] = ACTIONS(4111),
    [anon_sym_STAR_EQ] = ACTIONS(4111),
    [anon_sym_SLASH_EQ] = ACTIONS(4111),
    [anon_sym_PERCENT_EQ] = ACTIONS(4111),
    [anon_sym_AMP_EQ] = ACTIONS(4111),
    [anon_sym_CARET_EQ] = ACTIONS(4111),
    [anon_sym_PIPE_EQ] = ACTIONS(4111),
    [anon_sym_LT_LT_EQ] = ACTIONS(4111),
    [anon_sym_GT_GT_EQ] = ACTIONS(4111),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4111),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4111),
    [anon_sym_AMP_AMP] = ACTIONS(4101),
    [anon_sym_PIPE_PIPE] = ACTIONS(4101),
    [anon_sym_QMARK_QMARK] = ACTIONS(4108),
    [anon_sym_from] = ACTIONS(4099),
    [anon_sym_into] = ACTIONS(4099),
    [anon_sym_join] = ACTIONS(4099),
    [anon_sym_on] = ACTIONS(4108),
    [anon_sym_equals] = ACTIONS(4099),
    [anon_sym_let] = ACTIONS(4099),
    [anon_sym_orderby] = ACTIONS(4099),
    [anon_sym_ascending] = ACTIONS(4099),
    [anon_sym_descending] = ACTIONS(4099),
    [anon_sym_group] = ACTIONS(4099),
    [anon_sym_by] = ACTIONS(4099),
    [anon_sym_select] = ACTIONS(4099),
    [anon_sym_as] = ACTIONS(4108),
    [anon_sym_is] = ACTIONS(4108),
    [anon_sym_DASH_GT] = ACTIONS(4101),
    [anon_sym_with] = ACTIONS(4108),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2886] = {
    [sym__variable_designation] = STATE(4082),
    [sym_parenthesized_variable_designation] = STATE(4274),
    [sym_identifier] = STATE(4269),
    [sym__reserved_identifier] = STATE(3908),
    [sym_preproc_region] = STATE(2886),
    [sym_preproc_endregion] = STATE(2886),
    [sym_preproc_line] = STATE(2886),
    [sym_preproc_pragma] = STATE(2886),
    [sym_preproc_nullable] = STATE(2886),
    [sym_preproc_error] = STATE(2886),
    [sym_preproc_define] = STATE(2886),
    [sym_preproc_undef] = STATE(2886),
    [sym__identifier_token] = ACTIONS(4271),
    [anon_sym_alias] = ACTIONS(4273),
    [anon_sym_SEMI] = ACTIONS(4383),
    [anon_sym_global] = ACTIONS(4273),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON] = ACTIONS(4383),
    [anon_sym_COMMA] = ACTIONS(4383),
    [anon_sym_RBRACK] = ACTIONS(4383),
    [anon_sym_LPAREN] = ACTIONS(4383),
    [anon_sym_RPAREN] = ACTIONS(4383),
    [anon_sym_RBRACE] = ACTIONS(4383),
    [anon_sym_file] = ACTIONS(4273),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_where] = ACTIONS(4273),
    [anon_sym_QMARK] = ACTIONS(4385),
    [anon_sym_notnull] = ACTIONS(4273),
    [anon_sym_unmanaged] = ACTIONS(4273),
    [anon_sym_BANG] = ACTIONS(4385),
    [anon_sym_PLUS_PLUS] = ACTIONS(4383),
    [anon_sym_DASH_DASH] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_DASH] = ACTIONS(4385),
    [anon_sym_STAR] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4385),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4385),
    [anon_sym_GT_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4383),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_scoped] = ACTIONS(4273),
    [anon_sym_EQ_GT] = ACTIONS(4383),
    [anon_sym_var] = ACTIONS(4273),
    [anon_sym_yield] = ACTIONS(4273),
    [anon_sym_switch] = ACTIONS(4385),
    [anon_sym_when] = ACTIONS(4273),
    [sym_discard] = ACTIONS(4295),
    [anon_sym_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4385),
    [anon_sym_or] = ACTIONS(4385),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_QMARK_QMARK] = ACTIONS(4383),
    [anon_sym_from] = ACTIONS(4273),
    [anon_sym_into] = ACTIONS(4273),
    [anon_sym_join] = ACTIONS(4273),
    [anon_sym_on] = ACTIONS(4273),
    [anon_sym_equals] = ACTIONS(4273),
    [anon_sym_let] = ACTIONS(4273),
    [anon_sym_orderby] = ACTIONS(4273),
    [anon_sym_ascending] = ACTIONS(4273),
    [anon_sym_descending] = ACTIONS(4273),
    [anon_sym_group] = ACTIONS(4273),
    [anon_sym_by] = ACTIONS(4273),
    [anon_sym_select] = ACTIONS(4273),
    [anon_sym_as] = ACTIONS(4385),
    [anon_sym_is] = ACTIONS(4385),
    [anon_sym_DASH_GT] = ACTIONS(4383),
    [anon_sym_with] = ACTIONS(4385),
    [aux_sym_preproc_if_token3] = ACTIONS(4383),
    [aux_sym_preproc_else_token1] = ACTIONS(4383),
    [aux_sym_preproc_elif_token1] = ACTIONS(4383),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2887] = {
    [sym_preproc_region] = STATE(2887),
    [sym_preproc_endregion] = STATE(2887),
    [sym_preproc_line] = STATE(2887),
    [sym_preproc_pragma] = STATE(2887),
    [sym_preproc_nullable] = STATE(2887),
    [sym_preproc_error] = STATE(2887),
    [sym_preproc_define] = STATE(2887),
    [sym_preproc_undef] = STATE(2887),
    [sym__identifier_token] = ACTIONS(4099),
    [anon_sym_alias] = ACTIONS(4099),
    [anon_sym_global] = ACTIONS(4099),
    [anon_sym_EQ] = ACTIONS(4104),
    [anon_sym_LBRACK] = ACTIONS(4101),
    [anon_sym_LPAREN] = ACTIONS(4101),
    [anon_sym_LBRACE] = ACTIONS(4106),
    [anon_sym_file] = ACTIONS(4099),
    [anon_sym_LT] = ACTIONS(4108),
    [anon_sym_GT] = ACTIONS(4108),
    [anon_sym_where] = ACTIONS(4108),
    [anon_sym_QMARK] = ACTIONS(4108),
    [anon_sym_notnull] = ACTIONS(4099),
    [anon_sym_unmanaged] = ACTIONS(4099),
    [anon_sym_BANG] = ACTIONS(4108),
    [anon_sym_PLUS_PLUS] = ACTIONS(4101),
    [anon_sym_DASH_DASH] = ACTIONS(4101),
    [anon_sym_PLUS] = ACTIONS(4108),
    [anon_sym_DASH] = ACTIONS(4108),
    [anon_sym_STAR] = ACTIONS(4108),
    [anon_sym_SLASH] = ACTIONS(4108),
    [anon_sym_PERCENT] = ACTIONS(4108),
    [anon_sym_CARET] = ACTIONS(4108),
    [anon_sym_PIPE] = ACTIONS(4108),
    [anon_sym_AMP] = ACTIONS(4108),
    [anon_sym_LT_LT] = ACTIONS(4108),
    [anon_sym_GT_GT] = ACTIONS(4108),
    [anon_sym_GT_GT_GT] = ACTIONS(4108),
    [anon_sym_EQ_EQ] = ACTIONS(4101),
    [anon_sym_BANG_EQ] = ACTIONS(4101),
    [anon_sym_GT_EQ] = ACTIONS(4101),
    [anon_sym_LT_EQ] = ACTIONS(4101),
    [anon_sym_DOT] = ACTIONS(4108),
    [anon_sym_scoped] = ACTIONS(4099),
    [anon_sym_var] = ACTIONS(4099),
    [anon_sym_yield] = ACTIONS(4099),
    [anon_sym_switch] = ACTIONS(4108),
    [anon_sym_when] = ACTIONS(4099),
    [sym_discard] = ACTIONS(4099),
    [anon_sym_DOT_DOT] = ACTIONS(4101),
    [anon_sym_and] = ACTIONS(4108),
    [anon_sym_or] = ACTIONS(4108),
    [anon_sym_PLUS_EQ] = ACTIONS(4111),
    [anon_sym_DASH_EQ] = ACTIONS(4111),
    [anon_sym_STAR_EQ] = ACTIONS(4111),
    [anon_sym_SLASH_EQ] = ACTIONS(4111),
    [anon_sym_PERCENT_EQ] = ACTIONS(4111),
    [anon_sym_AMP_EQ] = ACTIONS(4111),
    [anon_sym_CARET_EQ] = ACTIONS(4111),
    [anon_sym_PIPE_EQ] = ACTIONS(4111),
    [anon_sym_LT_LT_EQ] = ACTIONS(4111),
    [anon_sym_GT_GT_EQ] = ACTIONS(4111),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4111),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4111),
    [anon_sym_AMP_AMP] = ACTIONS(4101),
    [anon_sym_PIPE_PIPE] = ACTIONS(4101),
    [anon_sym_QMARK_QMARK] = ACTIONS(4108),
    [anon_sym_from] = ACTIONS(4108),
    [anon_sym_into] = ACTIONS(4099),
    [anon_sym_join] = ACTIONS(4108),
    [anon_sym_on] = ACTIONS(4099),
    [anon_sym_equals] = ACTIONS(4099),
    [anon_sym_let] = ACTIONS(4108),
    [anon_sym_orderby] = ACTIONS(4108),
    [anon_sym_ascending] = ACTIONS(4099),
    [anon_sym_descending] = ACTIONS(4099),
    [anon_sym_group] = ACTIONS(4108),
    [anon_sym_by] = ACTIONS(4099),
    [anon_sym_select] = ACTIONS(4108),
    [anon_sym_as] = ACTIONS(4108),
    [anon_sym_is] = ACTIONS(4108),
    [anon_sym_DASH_GT] = ACTIONS(4101),
    [anon_sym_with] = ACTIONS(4108),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2888] = {
    [sym_preproc_region] = STATE(2888),
    [sym_preproc_endregion] = STATE(2888),
    [sym_preproc_line] = STATE(2888),
    [sym_preproc_pragma] = STATE(2888),
    [sym_preproc_nullable] = STATE(2888),
    [sym_preproc_error] = STATE(2888),
    [sym_preproc_define] = STATE(2888),
    [sym_preproc_undef] = STATE(2888),
    [sym__identifier_token] = ACTIONS(4113),
    [anon_sym_alias] = ACTIONS(4113),
    [anon_sym_global] = ACTIONS(4113),
    [anon_sym_EQ] = ACTIONS(4118),
    [anon_sym_LBRACK] = ACTIONS(4120),
    [anon_sym_LPAREN] = ACTIONS(4120),
    [anon_sym_LBRACE] = ACTIONS(4124),
    [anon_sym_file] = ACTIONS(4113),
    [anon_sym_LT] = ACTIONS(4126),
    [anon_sym_GT] = ACTIONS(4126),
    [anon_sym_where] = ACTIONS(4113),
    [anon_sym_QMARK] = ACTIONS(4126),
    [anon_sym_notnull] = ACTIONS(4113),
    [anon_sym_unmanaged] = ACTIONS(4113),
    [anon_sym_BANG] = ACTIONS(4126),
    [anon_sym_PLUS_PLUS] = ACTIONS(4120),
    [anon_sym_DASH_DASH] = ACTIONS(4120),
    [anon_sym_PLUS] = ACTIONS(4126),
    [anon_sym_DASH] = ACTIONS(4126),
    [anon_sym_STAR] = ACTIONS(4126),
    [anon_sym_SLASH] = ACTIONS(4126),
    [anon_sym_PERCENT] = ACTIONS(4126),
    [anon_sym_CARET] = ACTIONS(4126),
    [anon_sym_PIPE] = ACTIONS(4126),
    [anon_sym_AMP] = ACTIONS(4126),
    [anon_sym_LT_LT] = ACTIONS(4126),
    [anon_sym_GT_GT] = ACTIONS(4126),
    [anon_sym_GT_GT_GT] = ACTIONS(4126),
    [anon_sym_EQ_EQ] = ACTIONS(4120),
    [anon_sym_BANG_EQ] = ACTIONS(4120),
    [anon_sym_GT_EQ] = ACTIONS(4120),
    [anon_sym_LT_EQ] = ACTIONS(4120),
    [anon_sym_DOT] = ACTIONS(4126),
    [anon_sym_scoped] = ACTIONS(4113),
    [anon_sym_var] = ACTIONS(4113),
    [anon_sym_yield] = ACTIONS(4113),
    [anon_sym_switch] = ACTIONS(4126),
    [anon_sym_when] = ACTIONS(4113),
    [sym_discard] = ACTIONS(4113),
    [anon_sym_DOT_DOT] = ACTIONS(4120),
    [anon_sym_and] = ACTIONS(4130),
    [anon_sym_or] = ACTIONS(4130),
    [anon_sym_PLUS_EQ] = ACTIONS(4133),
    [anon_sym_DASH_EQ] = ACTIONS(4133),
    [anon_sym_STAR_EQ] = ACTIONS(4133),
    [anon_sym_SLASH_EQ] = ACTIONS(4133),
    [anon_sym_PERCENT_EQ] = ACTIONS(4133),
    [anon_sym_AMP_EQ] = ACTIONS(4133),
    [anon_sym_CARET_EQ] = ACTIONS(4133),
    [anon_sym_PIPE_EQ] = ACTIONS(4133),
    [anon_sym_LT_LT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4133),
    [anon_sym_AMP_AMP] = ACTIONS(4120),
    [anon_sym_PIPE_PIPE] = ACTIONS(4120),
    [anon_sym_QMARK_QMARK] = ACTIONS(4126),
    [anon_sym_from] = ACTIONS(4113),
    [anon_sym_into] = ACTIONS(4130),
    [anon_sym_join] = ACTIONS(4113),
    [anon_sym_on] = ACTIONS(4130),
    [anon_sym_equals] = ACTIONS(4113),
    [anon_sym_let] = ACTIONS(4113),
    [anon_sym_orderby] = ACTIONS(4113),
    [anon_sym_ascending] = ACTIONS(4113),
    [anon_sym_descending] = ACTIONS(4113),
    [anon_sym_group] = ACTIONS(4113),
    [anon_sym_by] = ACTIONS(4113),
    [anon_sym_select] = ACTIONS(4113),
    [anon_sym_as] = ACTIONS(4126),
    [anon_sym_is] = ACTIONS(4126),
    [anon_sym_DASH_GT] = ACTIONS(4120),
    [anon_sym_with] = ACTIONS(4126),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2889] = {
    [sym_preproc_region] = STATE(2889),
    [sym_preproc_endregion] = STATE(2889),
    [sym_preproc_line] = STATE(2889),
    [sym_preproc_pragma] = STATE(2889),
    [sym_preproc_nullable] = STATE(2889),
    [sym_preproc_error] = STATE(2889),
    [sym_preproc_define] = STATE(2889),
    [sym_preproc_undef] = STATE(2889),
    [sym__identifier_token] = ACTIONS(4099),
    [anon_sym_alias] = ACTIONS(4099),
    [anon_sym_global] = ACTIONS(4099),
    [anon_sym_EQ] = ACTIONS(4104),
    [anon_sym_LBRACK] = ACTIONS(4101),
    [anon_sym_COLON] = ACTIONS(4111),
    [anon_sym_LPAREN] = ACTIONS(4101),
    [anon_sym_file] = ACTIONS(4099),
    [anon_sym_LT] = ACTIONS(4104),
    [anon_sym_GT] = ACTIONS(4104),
    [anon_sym_where] = ACTIONS(4099),
    [anon_sym_QMARK] = ACTIONS(4108),
    [anon_sym_notnull] = ACTIONS(4099),
    [anon_sym_unmanaged] = ACTIONS(4099),
    [anon_sym_BANG] = ACTIONS(4104),
    [anon_sym_PLUS_PLUS] = ACTIONS(4111),
    [anon_sym_DASH_DASH] = ACTIONS(4111),
    [anon_sym_PLUS] = ACTIONS(4104),
    [anon_sym_DASH] = ACTIONS(4104),
    [anon_sym_STAR] = ACTIONS(4108),
    [anon_sym_SLASH] = ACTIONS(4104),
    [anon_sym_PERCENT] = ACTIONS(4104),
    [anon_sym_CARET] = ACTIONS(4104),
    [anon_sym_PIPE] = ACTIONS(4104),
    [anon_sym_AMP] = ACTIONS(4104),
    [anon_sym_LT_LT] = ACTIONS(4104),
    [anon_sym_GT_GT] = ACTIONS(4104),
    [anon_sym_GT_GT_GT] = ACTIONS(4104),
    [anon_sym_EQ_EQ] = ACTIONS(4111),
    [anon_sym_BANG_EQ] = ACTIONS(4111),
    [anon_sym_GT_EQ] = ACTIONS(4111),
    [anon_sym_LT_EQ] = ACTIONS(4111),
    [anon_sym_DOT] = ACTIONS(4108),
    [anon_sym_scoped] = ACTIONS(4099),
    [anon_sym_EQ_GT] = ACTIONS(4111),
    [anon_sym_var] = ACTIONS(4099),
    [anon_sym_yield] = ACTIONS(4099),
    [anon_sym_switch] = ACTIONS(4104),
    [anon_sym_when] = ACTIONS(4108),
    [anon_sym_DOT_DOT] = ACTIONS(4111),
    [anon_sym_and] = ACTIONS(4104),
    [anon_sym_or] = ACTIONS(4104),
    [anon_sym_PLUS_EQ] = ACTIONS(4111),
    [anon_sym_DASH_EQ] = ACTIONS(4111),
    [anon_sym_STAR_EQ] = ACTIONS(4111),
    [anon_sym_SLASH_EQ] = ACTIONS(4111),
    [anon_sym_PERCENT_EQ] = ACTIONS(4111),
    [anon_sym_AMP_EQ] = ACTIONS(4111),
    [anon_sym_CARET_EQ] = ACTIONS(4111),
    [anon_sym_PIPE_EQ] = ACTIONS(4111),
    [anon_sym_LT_LT_EQ] = ACTIONS(4111),
    [anon_sym_GT_GT_EQ] = ACTIONS(4111),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4111),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4111),
    [anon_sym_AMP_AMP] = ACTIONS(4111),
    [anon_sym_PIPE_PIPE] = ACTIONS(4111),
    [anon_sym_QMARK_QMARK] = ACTIONS(4104),
    [anon_sym_from] = ACTIONS(4099),
    [anon_sym_into] = ACTIONS(4108),
    [anon_sym_join] = ACTIONS(4099),
    [anon_sym_on] = ACTIONS(4099),
    [anon_sym_equals] = ACTIONS(4099),
    [anon_sym_let] = ACTIONS(4099),
    [anon_sym_orderby] = ACTIONS(4099),
    [anon_sym_ascending] = ACTIONS(4099),
    [anon_sym_descending] = ACTIONS(4099),
    [anon_sym_group] = ACTIONS(4099),
    [anon_sym_by] = ACTIONS(4099),
    [anon_sym_select] = ACTIONS(4099),
    [anon_sym_as] = ACTIONS(4104),
    [anon_sym_is] = ACTIONS(4104),
    [anon_sym_DASH_GT] = ACTIONS(4101),
    [anon_sym_with] = ACTIONS(4104),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2890] = {
    [sym_type_argument_list] = STATE(2736),
    [sym_preproc_region] = STATE(2890),
    [sym_preproc_endregion] = STATE(2890),
    [sym_preproc_line] = STATE(2890),
    [sym_preproc_pragma] = STATE(2890),
    [sym_preproc_nullable] = STATE(2890),
    [sym_preproc_error] = STATE(2890),
    [sym_preproc_define] = STATE(2890),
    [sym_preproc_undef] = STATE(2890),
    [sym__identifier_token] = ACTIONS(4074),
    [anon_sym_alias] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4074),
    [anon_sym_EQ] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4076),
    [anon_sym_COLON] = ACTIONS(4412),
    [anon_sym_LPAREN] = ACTIONS(4076),
    [anon_sym_file] = ACTIONS(4074),
    [anon_sym_LT] = ACTIONS(4078),
    [anon_sym_GT] = ACTIONS(4074),
    [anon_sym_where] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(4074),
    [anon_sym_notnull] = ACTIONS(4074),
    [anon_sym_unmanaged] = ACTIONS(4074),
    [anon_sym_BANG] = ACTIONS(4074),
    [anon_sym_PLUS_PLUS] = ACTIONS(4076),
    [anon_sym_DASH_DASH] = ACTIONS(4076),
    [anon_sym_PLUS] = ACTIONS(4074),
    [anon_sym_DASH] = ACTIONS(4074),
    [anon_sym_STAR] = ACTIONS(4074),
    [anon_sym_SLASH] = ACTIONS(4074),
    [anon_sym_PERCENT] = ACTIONS(4074),
    [anon_sym_CARET] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(4074),
    [anon_sym_AMP] = ACTIONS(4074),
    [anon_sym_LT_LT] = ACTIONS(4074),
    [anon_sym_GT_GT] = ACTIONS(4074),
    [anon_sym_GT_GT_GT] = ACTIONS(4074),
    [anon_sym_EQ_EQ] = ACTIONS(4076),
    [anon_sym_BANG_EQ] = ACTIONS(4076),
    [anon_sym_GT_EQ] = ACTIONS(4076),
    [anon_sym_LT_EQ] = ACTIONS(4076),
    [anon_sym_DOT] = ACTIONS(4074),
    [anon_sym_scoped] = ACTIONS(4074),
    [anon_sym_EQ_GT] = ACTIONS(4081),
    [anon_sym_COLON_COLON] = ACTIONS(4083),
    [anon_sym_var] = ACTIONS(4074),
    [anon_sym_yield] = ACTIONS(4074),
    [anon_sym_switch] = ACTIONS(4074),
    [anon_sym_when] = ACTIONS(4074),
    [anon_sym_DOT_DOT] = ACTIONS(4076),
    [anon_sym_PLUS_EQ] = ACTIONS(4076),
    [anon_sym_DASH_EQ] = ACTIONS(4076),
    [anon_sym_STAR_EQ] = ACTIONS(4076),
    [anon_sym_SLASH_EQ] = ACTIONS(4076),
    [anon_sym_PERCENT_EQ] = ACTIONS(4076),
    [anon_sym_AMP_EQ] = ACTIONS(4076),
    [anon_sym_CARET_EQ] = ACTIONS(4076),
    [anon_sym_PIPE_EQ] = ACTIONS(4076),
    [anon_sym_LT_LT_EQ] = ACTIONS(4076),
    [anon_sym_GT_GT_EQ] = ACTIONS(4076),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4076),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4076),
    [anon_sym_AMP_AMP] = ACTIONS(4076),
    [anon_sym_PIPE_PIPE] = ACTIONS(4076),
    [anon_sym_QMARK_QMARK] = ACTIONS(4074),
    [anon_sym_from] = ACTIONS(4074),
    [anon_sym_into] = ACTIONS(4074),
    [anon_sym_join] = ACTIONS(4074),
    [anon_sym_on] = ACTIONS(4074),
    [anon_sym_equals] = ACTIONS(4074),
    [anon_sym_let] = ACTIONS(4074),
    [anon_sym_orderby] = ACTIONS(4074),
    [anon_sym_ascending] = ACTIONS(4074),
    [anon_sym_descending] = ACTIONS(4074),
    [anon_sym_group] = ACTIONS(4074),
    [anon_sym_by] = ACTIONS(4074),
    [anon_sym_select] = ACTIONS(4074),
    [anon_sym_as] = ACTIONS(4074),
    [anon_sym_is] = ACTIONS(4074),
    [anon_sym_DASH_GT] = ACTIONS(4076),
    [anon_sym_with] = ACTIONS(4074),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2891] = {
    [sym_preproc_region] = STATE(2891),
    [sym_preproc_endregion] = STATE(2891),
    [sym_preproc_line] = STATE(2891),
    [sym_preproc_pragma] = STATE(2891),
    [sym_preproc_nullable] = STATE(2891),
    [sym_preproc_error] = STATE(2891),
    [sym_preproc_define] = STATE(2891),
    [sym_preproc_undef] = STATE(2891),
    [sym__identifier_token] = ACTIONS(4113),
    [anon_sym_alias] = ACTIONS(4113),
    [anon_sym_global] = ACTIONS(4113),
    [anon_sym_EQ] = ACTIONS(4118),
    [anon_sym_LBRACK] = ACTIONS(4120),
    [anon_sym_LPAREN] = ACTIONS(4120),
    [anon_sym_LBRACE] = ACTIONS(4124),
    [anon_sym_file] = ACTIONS(4113),
    [anon_sym_LT] = ACTIONS(4126),
    [anon_sym_GT] = ACTIONS(4126),
    [anon_sym_where] = ACTIONS(4113),
    [anon_sym_QMARK] = ACTIONS(4126),
    [anon_sym_notnull] = ACTIONS(4113),
    [anon_sym_unmanaged] = ACTIONS(4113),
    [anon_sym_BANG] = ACTIONS(4126),
    [anon_sym_PLUS_PLUS] = ACTIONS(4120),
    [anon_sym_DASH_DASH] = ACTIONS(4120),
    [anon_sym_PLUS] = ACTIONS(4126),
    [anon_sym_DASH] = ACTIONS(4126),
    [anon_sym_STAR] = ACTIONS(4126),
    [anon_sym_SLASH] = ACTIONS(4126),
    [anon_sym_PERCENT] = ACTIONS(4126),
    [anon_sym_CARET] = ACTIONS(4126),
    [anon_sym_PIPE] = ACTIONS(4126),
    [anon_sym_AMP] = ACTIONS(4126),
    [anon_sym_LT_LT] = ACTIONS(4126),
    [anon_sym_GT_GT] = ACTIONS(4126),
    [anon_sym_GT_GT_GT] = ACTIONS(4126),
    [anon_sym_EQ_EQ] = ACTIONS(4120),
    [anon_sym_BANG_EQ] = ACTIONS(4120),
    [anon_sym_GT_EQ] = ACTIONS(4120),
    [anon_sym_LT_EQ] = ACTIONS(4120),
    [anon_sym_DOT] = ACTIONS(4126),
    [anon_sym_scoped] = ACTIONS(4113),
    [anon_sym_var] = ACTIONS(4113),
    [anon_sym_yield] = ACTIONS(4113),
    [anon_sym_switch] = ACTIONS(4126),
    [anon_sym_when] = ACTIONS(4113),
    [sym_discard] = ACTIONS(4113),
    [anon_sym_DOT_DOT] = ACTIONS(4120),
    [anon_sym_and] = ACTIONS(4130),
    [anon_sym_or] = ACTIONS(4130),
    [anon_sym_PLUS_EQ] = ACTIONS(4133),
    [anon_sym_DASH_EQ] = ACTIONS(4133),
    [anon_sym_STAR_EQ] = ACTIONS(4133),
    [anon_sym_SLASH_EQ] = ACTIONS(4133),
    [anon_sym_PERCENT_EQ] = ACTIONS(4133),
    [anon_sym_AMP_EQ] = ACTIONS(4133),
    [anon_sym_CARET_EQ] = ACTIONS(4133),
    [anon_sym_PIPE_EQ] = ACTIONS(4133),
    [anon_sym_LT_LT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4133),
    [anon_sym_AMP_AMP] = ACTIONS(4120),
    [anon_sym_PIPE_PIPE] = ACTIONS(4120),
    [anon_sym_QMARK_QMARK] = ACTIONS(4126),
    [anon_sym_from] = ACTIONS(4113),
    [anon_sym_into] = ACTIONS(4113),
    [anon_sym_join] = ACTIONS(4113),
    [anon_sym_on] = ACTIONS(4113),
    [anon_sym_equals] = ACTIONS(4113),
    [anon_sym_let] = ACTIONS(4113),
    [anon_sym_orderby] = ACTIONS(4113),
    [anon_sym_ascending] = ACTIONS(4113),
    [anon_sym_descending] = ACTIONS(4113),
    [anon_sym_group] = ACTIONS(4113),
    [anon_sym_by] = ACTIONS(4130),
    [anon_sym_select] = ACTIONS(4113),
    [anon_sym_as] = ACTIONS(4126),
    [anon_sym_is] = ACTIONS(4126),
    [anon_sym_DASH_GT] = ACTIONS(4120),
    [anon_sym_with] = ACTIONS(4126),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2892] = {
    [sym_preproc_region] = STATE(2892),
    [sym_preproc_endregion] = STATE(2892),
    [sym_preproc_line] = STATE(2892),
    [sym_preproc_pragma] = STATE(2892),
    [sym_preproc_nullable] = STATE(2892),
    [sym_preproc_error] = STATE(2892),
    [sym_preproc_define] = STATE(2892),
    [sym_preproc_undef] = STATE(2892),
    [sym__identifier_token] = ACTIONS(4414),
    [anon_sym_alias] = ACTIONS(4414),
    [anon_sym_SEMI] = ACTIONS(4416),
    [anon_sym_global] = ACTIONS(4414),
    [anon_sym_LBRACK] = ACTIONS(4416),
    [anon_sym_COLON] = ACTIONS(4416),
    [anon_sym_COMMA] = ACTIONS(4416),
    [anon_sym_RBRACK] = ACTIONS(4416),
    [anon_sym_LPAREN] = ACTIONS(4416),
    [anon_sym_RPAREN] = ACTIONS(4416),
    [anon_sym_LBRACE] = ACTIONS(4416),
    [anon_sym_RBRACE] = ACTIONS(4416),
    [anon_sym_file] = ACTIONS(4414),
    [anon_sym_LT] = ACTIONS(4414),
    [anon_sym_GT] = ACTIONS(4414),
    [anon_sym_in] = ACTIONS(4414),
    [anon_sym_where] = ACTIONS(4414),
    [anon_sym_QMARK] = ACTIONS(4414),
    [anon_sym_notnull] = ACTIONS(4414),
    [anon_sym_unmanaged] = ACTIONS(4414),
    [anon_sym_operator] = ACTIONS(4414),
    [anon_sym_BANG] = ACTIONS(4414),
    [anon_sym_PLUS_PLUS] = ACTIONS(4416),
    [anon_sym_DASH_DASH] = ACTIONS(4416),
    [anon_sym_PLUS] = ACTIONS(4414),
    [anon_sym_DASH] = ACTIONS(4414),
    [anon_sym_STAR] = ACTIONS(4416),
    [anon_sym_SLASH] = ACTIONS(4414),
    [anon_sym_PERCENT] = ACTIONS(4416),
    [anon_sym_CARET] = ACTIONS(4416),
    [anon_sym_PIPE] = ACTIONS(4414),
    [anon_sym_AMP] = ACTIONS(4414),
    [anon_sym_LT_LT] = ACTIONS(4416),
    [anon_sym_GT_GT] = ACTIONS(4414),
    [anon_sym_GT_GT_GT] = ACTIONS(4416),
    [anon_sym_EQ_EQ] = ACTIONS(4416),
    [anon_sym_BANG_EQ] = ACTIONS(4416),
    [anon_sym_GT_EQ] = ACTIONS(4416),
    [anon_sym_LT_EQ] = ACTIONS(4416),
    [anon_sym_this] = ACTIONS(4414),
    [anon_sym_DOT] = ACTIONS(4414),
    [anon_sym_scoped] = ACTIONS(4414),
    [anon_sym_EQ_GT] = ACTIONS(4416),
    [anon_sym_var] = ACTIONS(4414),
    [anon_sym_yield] = ACTIONS(4414),
    [anon_sym_switch] = ACTIONS(4414),
    [anon_sym_when] = ACTIONS(4414),
    [sym_discard] = ACTIONS(4414),
    [anon_sym_DOT_DOT] = ACTIONS(4416),
    [anon_sym_and] = ACTIONS(4414),
    [anon_sym_or] = ACTIONS(4414),
    [anon_sym_AMP_AMP] = ACTIONS(4416),
    [anon_sym_PIPE_PIPE] = ACTIONS(4416),
    [anon_sym_QMARK_QMARK] = ACTIONS(4416),
    [anon_sym_from] = ACTIONS(4414),
    [anon_sym_into] = ACTIONS(4414),
    [anon_sym_join] = ACTIONS(4414),
    [anon_sym_on] = ACTIONS(4414),
    [anon_sym_equals] = ACTIONS(4414),
    [anon_sym_let] = ACTIONS(4414),
    [anon_sym_orderby] = ACTIONS(4414),
    [anon_sym_ascending] = ACTIONS(4414),
    [anon_sym_descending] = ACTIONS(4414),
    [anon_sym_group] = ACTIONS(4414),
    [anon_sym_by] = ACTIONS(4414),
    [anon_sym_select] = ACTIONS(4414),
    [anon_sym_as] = ACTIONS(4414),
    [anon_sym_is] = ACTIONS(4414),
    [anon_sym_DASH_GT] = ACTIONS(4416),
    [anon_sym_with] = ACTIONS(4414),
    [aux_sym_preproc_if_token3] = ACTIONS(4416),
    [aux_sym_preproc_else_token1] = ACTIONS(4416),
    [aux_sym_preproc_elif_token1] = ACTIONS(4416),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2893] = {
    [sym__variable_designation] = STATE(4246),
    [sym_parenthesized_variable_designation] = STATE(4274),
    [sym_identifier] = STATE(4269),
    [sym__reserved_identifier] = STATE(3908),
    [sym_preproc_region] = STATE(2893),
    [sym_preproc_endregion] = STATE(2893),
    [sym_preproc_line] = STATE(2893),
    [sym_preproc_pragma] = STATE(2893),
    [sym_preproc_nullable] = STATE(2893),
    [sym_preproc_error] = STATE(2893),
    [sym_preproc_define] = STATE(2893),
    [sym_preproc_undef] = STATE(2893),
    [sym__identifier_token] = ACTIONS(4271),
    [anon_sym_alias] = ACTIONS(4273),
    [anon_sym_SEMI] = ACTIONS(4329),
    [anon_sym_global] = ACTIONS(4273),
    [anon_sym_LBRACK] = ACTIONS(4329),
    [anon_sym_COLON] = ACTIONS(4329),
    [anon_sym_COMMA] = ACTIONS(4329),
    [anon_sym_RBRACK] = ACTIONS(4329),
    [anon_sym_LPAREN] = ACTIONS(4329),
    [anon_sym_RPAREN] = ACTIONS(4329),
    [anon_sym_RBRACE] = ACTIONS(4329),
    [anon_sym_file] = ACTIONS(4273),
    [anon_sym_LT] = ACTIONS(4331),
    [anon_sym_GT] = ACTIONS(4331),
    [anon_sym_where] = ACTIONS(4273),
    [anon_sym_QMARK] = ACTIONS(4331),
    [anon_sym_notnull] = ACTIONS(4273),
    [anon_sym_unmanaged] = ACTIONS(4273),
    [anon_sym_BANG] = ACTIONS(4331),
    [anon_sym_PLUS_PLUS] = ACTIONS(4329),
    [anon_sym_DASH_DASH] = ACTIONS(4329),
    [anon_sym_PLUS] = ACTIONS(4331),
    [anon_sym_DASH] = ACTIONS(4331),
    [anon_sym_STAR] = ACTIONS(4329),
    [anon_sym_SLASH] = ACTIONS(4331),
    [anon_sym_PERCENT] = ACTIONS(4329),
    [anon_sym_CARET] = ACTIONS(4329),
    [anon_sym_PIPE] = ACTIONS(4331),
    [anon_sym_AMP] = ACTIONS(4331),
    [anon_sym_LT_LT] = ACTIONS(4329),
    [anon_sym_GT_GT] = ACTIONS(4331),
    [anon_sym_GT_GT_GT] = ACTIONS(4329),
    [anon_sym_EQ_EQ] = ACTIONS(4329),
    [anon_sym_BANG_EQ] = ACTIONS(4329),
    [anon_sym_GT_EQ] = ACTIONS(4329),
    [anon_sym_LT_EQ] = ACTIONS(4329),
    [anon_sym_DOT] = ACTIONS(4331),
    [anon_sym_scoped] = ACTIONS(4273),
    [anon_sym_EQ_GT] = ACTIONS(4329),
    [anon_sym_var] = ACTIONS(4273),
    [anon_sym_yield] = ACTIONS(4273),
    [anon_sym_switch] = ACTIONS(4331),
    [anon_sym_when] = ACTIONS(4273),
    [sym_discard] = ACTIONS(4295),
    [anon_sym_DOT_DOT] = ACTIONS(4329),
    [anon_sym_and] = ACTIONS(4331),
    [anon_sym_or] = ACTIONS(4331),
    [anon_sym_AMP_AMP] = ACTIONS(4329),
    [anon_sym_PIPE_PIPE] = ACTIONS(4329),
    [anon_sym_QMARK_QMARK] = ACTIONS(4329),
    [anon_sym_from] = ACTIONS(4273),
    [anon_sym_into] = ACTIONS(4273),
    [anon_sym_join] = ACTIONS(4273),
    [anon_sym_on] = ACTIONS(4273),
    [anon_sym_equals] = ACTIONS(4273),
    [anon_sym_let] = ACTIONS(4273),
    [anon_sym_orderby] = ACTIONS(4273),
    [anon_sym_ascending] = ACTIONS(4273),
    [anon_sym_descending] = ACTIONS(4273),
    [anon_sym_group] = ACTIONS(4273),
    [anon_sym_by] = ACTIONS(4273),
    [anon_sym_select] = ACTIONS(4273),
    [anon_sym_as] = ACTIONS(4331),
    [anon_sym_is] = ACTIONS(4331),
    [anon_sym_DASH_GT] = ACTIONS(4329),
    [anon_sym_with] = ACTIONS(4331),
    [aux_sym_preproc_if_token3] = ACTIONS(4329),
    [aux_sym_preproc_else_token1] = ACTIONS(4329),
    [aux_sym_preproc_elif_token1] = ACTIONS(4329),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2894] = {
    [sym_preproc_region] = STATE(2894),
    [sym_preproc_endregion] = STATE(2894),
    [sym_preproc_line] = STATE(2894),
    [sym_preproc_pragma] = STATE(2894),
    [sym_preproc_nullable] = STATE(2894),
    [sym_preproc_error] = STATE(2894),
    [sym_preproc_define] = STATE(2894),
    [sym_preproc_undef] = STATE(2894),
    [sym__identifier_token] = ACTIONS(4099),
    [anon_sym_alias] = ACTIONS(4099),
    [anon_sym_global] = ACTIONS(4099),
    [anon_sym_EQ] = ACTIONS(4104),
    [anon_sym_LBRACK] = ACTIONS(4101),
    [anon_sym_LPAREN] = ACTIONS(4101),
    [anon_sym_LBRACE] = ACTIONS(4106),
    [anon_sym_file] = ACTIONS(4099),
    [anon_sym_LT] = ACTIONS(4108),
    [anon_sym_GT] = ACTIONS(4108),
    [anon_sym_where] = ACTIONS(4099),
    [anon_sym_QMARK] = ACTIONS(4108),
    [anon_sym_notnull] = ACTIONS(4099),
    [anon_sym_unmanaged] = ACTIONS(4099),
    [anon_sym_BANG] = ACTIONS(4108),
    [anon_sym_PLUS_PLUS] = ACTIONS(4101),
    [anon_sym_DASH_DASH] = ACTIONS(4101),
    [anon_sym_PLUS] = ACTIONS(4108),
    [anon_sym_DASH] = ACTIONS(4108),
    [anon_sym_STAR] = ACTIONS(4108),
    [anon_sym_SLASH] = ACTIONS(4108),
    [anon_sym_PERCENT] = ACTIONS(4108),
    [anon_sym_CARET] = ACTIONS(4108),
    [anon_sym_PIPE] = ACTIONS(4108),
    [anon_sym_AMP] = ACTIONS(4108),
    [anon_sym_LT_LT] = ACTIONS(4108),
    [anon_sym_GT_GT] = ACTIONS(4108),
    [anon_sym_GT_GT_GT] = ACTIONS(4108),
    [anon_sym_EQ_EQ] = ACTIONS(4101),
    [anon_sym_BANG_EQ] = ACTIONS(4101),
    [anon_sym_GT_EQ] = ACTIONS(4101),
    [anon_sym_LT_EQ] = ACTIONS(4101),
    [anon_sym_DOT] = ACTIONS(4108),
    [anon_sym_scoped] = ACTIONS(4099),
    [anon_sym_var] = ACTIONS(4099),
    [anon_sym_yield] = ACTIONS(4099),
    [anon_sym_switch] = ACTIONS(4108),
    [anon_sym_when] = ACTIONS(4099),
    [sym_discard] = ACTIONS(4099),
    [anon_sym_DOT_DOT] = ACTIONS(4101),
    [anon_sym_and] = ACTIONS(4108),
    [anon_sym_or] = ACTIONS(4108),
    [anon_sym_PLUS_EQ] = ACTIONS(4111),
    [anon_sym_DASH_EQ] = ACTIONS(4111),
    [anon_sym_STAR_EQ] = ACTIONS(4111),
    [anon_sym_SLASH_EQ] = ACTIONS(4111),
    [anon_sym_PERCENT_EQ] = ACTIONS(4111),
    [anon_sym_AMP_EQ] = ACTIONS(4111),
    [anon_sym_CARET_EQ] = ACTIONS(4111),
    [anon_sym_PIPE_EQ] = ACTIONS(4111),
    [anon_sym_LT_LT_EQ] = ACTIONS(4111),
    [anon_sym_GT_GT_EQ] = ACTIONS(4111),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4111),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4111),
    [anon_sym_AMP_AMP] = ACTIONS(4101),
    [anon_sym_PIPE_PIPE] = ACTIONS(4101),
    [anon_sym_QMARK_QMARK] = ACTIONS(4108),
    [anon_sym_from] = ACTIONS(4099),
    [anon_sym_into] = ACTIONS(4108),
    [anon_sym_join] = ACTIONS(4099),
    [anon_sym_on] = ACTIONS(4099),
    [anon_sym_equals] = ACTIONS(4099),
    [anon_sym_let] = ACTIONS(4099),
    [anon_sym_orderby] = ACTIONS(4099),
    [anon_sym_ascending] = ACTIONS(4099),
    [anon_sym_descending] = ACTIONS(4099),
    [anon_sym_group] = ACTIONS(4099),
    [anon_sym_by] = ACTIONS(4108),
    [anon_sym_select] = ACTIONS(4099),
    [anon_sym_as] = ACTIONS(4108),
    [anon_sym_is] = ACTIONS(4108),
    [anon_sym_DASH_GT] = ACTIONS(4101),
    [anon_sym_with] = ACTIONS(4108),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2895] = {
    [sym_preproc_region] = STATE(2895),
    [sym_preproc_endregion] = STATE(2895),
    [sym_preproc_line] = STATE(2895),
    [sym_preproc_pragma] = STATE(2895),
    [sym_preproc_nullable] = STATE(2895),
    [sym_preproc_error] = STATE(2895),
    [sym_preproc_define] = STATE(2895),
    [sym_preproc_undef] = STATE(2895),
    [sym__identifier_token] = ACTIONS(4113),
    [anon_sym_alias] = ACTIONS(4113),
    [anon_sym_global] = ACTIONS(4113),
    [anon_sym_EQ] = ACTIONS(4118),
    [anon_sym_LBRACK] = ACTIONS(4120),
    [anon_sym_LPAREN] = ACTIONS(4120),
    [anon_sym_LBRACE] = ACTIONS(4124),
    [anon_sym_file] = ACTIONS(4113),
    [anon_sym_LT] = ACTIONS(4126),
    [anon_sym_GT] = ACTIONS(4126),
    [anon_sym_where] = ACTIONS(4113),
    [anon_sym_QMARK] = ACTIONS(4126),
    [anon_sym_notnull] = ACTIONS(4113),
    [anon_sym_unmanaged] = ACTIONS(4113),
    [anon_sym_BANG] = ACTIONS(4126),
    [anon_sym_PLUS_PLUS] = ACTIONS(4120),
    [anon_sym_DASH_DASH] = ACTIONS(4120),
    [anon_sym_PLUS] = ACTIONS(4126),
    [anon_sym_DASH] = ACTIONS(4126),
    [anon_sym_STAR] = ACTIONS(4126),
    [anon_sym_SLASH] = ACTIONS(4126),
    [anon_sym_PERCENT] = ACTIONS(4126),
    [anon_sym_CARET] = ACTIONS(4126),
    [anon_sym_PIPE] = ACTIONS(4126),
    [anon_sym_AMP] = ACTIONS(4126),
    [anon_sym_LT_LT] = ACTIONS(4126),
    [anon_sym_GT_GT] = ACTIONS(4126),
    [anon_sym_GT_GT_GT] = ACTIONS(4126),
    [anon_sym_EQ_EQ] = ACTIONS(4120),
    [anon_sym_BANG_EQ] = ACTIONS(4120),
    [anon_sym_GT_EQ] = ACTIONS(4120),
    [anon_sym_LT_EQ] = ACTIONS(4120),
    [anon_sym_DOT] = ACTIONS(4126),
    [anon_sym_scoped] = ACTIONS(4113),
    [anon_sym_var] = ACTIONS(4113),
    [anon_sym_yield] = ACTIONS(4113),
    [anon_sym_switch] = ACTIONS(4126),
    [anon_sym_when] = ACTIONS(4113),
    [sym_discard] = ACTIONS(4113),
    [anon_sym_DOT_DOT] = ACTIONS(4120),
    [anon_sym_and] = ACTIONS(4130),
    [anon_sym_or] = ACTIONS(4130),
    [anon_sym_PLUS_EQ] = ACTIONS(4133),
    [anon_sym_DASH_EQ] = ACTIONS(4133),
    [anon_sym_STAR_EQ] = ACTIONS(4133),
    [anon_sym_SLASH_EQ] = ACTIONS(4133),
    [anon_sym_PERCENT_EQ] = ACTIONS(4133),
    [anon_sym_AMP_EQ] = ACTIONS(4133),
    [anon_sym_CARET_EQ] = ACTIONS(4133),
    [anon_sym_PIPE_EQ] = ACTIONS(4133),
    [anon_sym_LT_LT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4133),
    [anon_sym_AMP_AMP] = ACTIONS(4120),
    [anon_sym_PIPE_PIPE] = ACTIONS(4120),
    [anon_sym_QMARK_QMARK] = ACTIONS(4126),
    [anon_sym_from] = ACTIONS(4113),
    [anon_sym_into] = ACTIONS(4130),
    [anon_sym_join] = ACTIONS(4113),
    [anon_sym_on] = ACTIONS(4113),
    [anon_sym_equals] = ACTIONS(4113),
    [anon_sym_let] = ACTIONS(4113),
    [anon_sym_orderby] = ACTIONS(4113),
    [anon_sym_ascending] = ACTIONS(4113),
    [anon_sym_descending] = ACTIONS(4113),
    [anon_sym_group] = ACTIONS(4113),
    [anon_sym_by] = ACTIONS(4130),
    [anon_sym_select] = ACTIONS(4113),
    [anon_sym_as] = ACTIONS(4126),
    [anon_sym_is] = ACTIONS(4126),
    [anon_sym_DASH_GT] = ACTIONS(4120),
    [anon_sym_with] = ACTIONS(4126),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2896] = {
    [sym__variable_designation] = STATE(4123),
    [sym_parenthesized_variable_designation] = STATE(4274),
    [sym_identifier] = STATE(4269),
    [sym__reserved_identifier] = STATE(3908),
    [sym_preproc_region] = STATE(2896),
    [sym_preproc_endregion] = STATE(2896),
    [sym_preproc_line] = STATE(2896),
    [sym_preproc_pragma] = STATE(2896),
    [sym_preproc_nullable] = STATE(2896),
    [sym_preproc_error] = STATE(2896),
    [sym_preproc_define] = STATE(2896),
    [sym_preproc_undef] = STATE(2896),
    [sym__identifier_token] = ACTIONS(4271),
    [anon_sym_alias] = ACTIONS(4273),
    [anon_sym_SEMI] = ACTIONS(4335),
    [anon_sym_global] = ACTIONS(4273),
    [anon_sym_LBRACK] = ACTIONS(4335),
    [anon_sym_COLON] = ACTIONS(4335),
    [anon_sym_COMMA] = ACTIONS(4335),
    [anon_sym_RBRACK] = ACTIONS(4335),
    [anon_sym_LPAREN] = ACTIONS(4335),
    [anon_sym_RPAREN] = ACTIONS(4335),
    [anon_sym_RBRACE] = ACTIONS(4335),
    [anon_sym_file] = ACTIONS(4273),
    [anon_sym_LT] = ACTIONS(4337),
    [anon_sym_GT] = ACTIONS(4337),
    [anon_sym_where] = ACTIONS(4273),
    [anon_sym_QMARK] = ACTIONS(4337),
    [anon_sym_notnull] = ACTIONS(4273),
    [anon_sym_unmanaged] = ACTIONS(4273),
    [anon_sym_BANG] = ACTIONS(4337),
    [anon_sym_PLUS_PLUS] = ACTIONS(4335),
    [anon_sym_DASH_DASH] = ACTIONS(4335),
    [anon_sym_PLUS] = ACTIONS(4337),
    [anon_sym_DASH] = ACTIONS(4337),
    [anon_sym_STAR] = ACTIONS(4335),
    [anon_sym_SLASH] = ACTIONS(4337),
    [anon_sym_PERCENT] = ACTIONS(4335),
    [anon_sym_CARET] = ACTIONS(4335),
    [anon_sym_PIPE] = ACTIONS(4337),
    [anon_sym_AMP] = ACTIONS(4337),
    [anon_sym_LT_LT] = ACTIONS(4335),
    [anon_sym_GT_GT] = ACTIONS(4337),
    [anon_sym_GT_GT_GT] = ACTIONS(4335),
    [anon_sym_EQ_EQ] = ACTIONS(4335),
    [anon_sym_BANG_EQ] = ACTIONS(4335),
    [anon_sym_GT_EQ] = ACTIONS(4335),
    [anon_sym_LT_EQ] = ACTIONS(4335),
    [anon_sym_DOT] = ACTIONS(4337),
    [anon_sym_scoped] = ACTIONS(4273),
    [anon_sym_EQ_GT] = ACTIONS(4335),
    [anon_sym_var] = ACTIONS(4273),
    [anon_sym_yield] = ACTIONS(4273),
    [anon_sym_switch] = ACTIONS(4337),
    [anon_sym_when] = ACTIONS(4273),
    [sym_discard] = ACTIONS(4295),
    [anon_sym_DOT_DOT] = ACTIONS(4335),
    [anon_sym_and] = ACTIONS(4337),
    [anon_sym_or] = ACTIONS(4337),
    [anon_sym_AMP_AMP] = ACTIONS(4335),
    [anon_sym_PIPE_PIPE] = ACTIONS(4335),
    [anon_sym_QMARK_QMARK] = ACTIONS(4335),
    [anon_sym_from] = ACTIONS(4273),
    [anon_sym_into] = ACTIONS(4273),
    [anon_sym_join] = ACTIONS(4273),
    [anon_sym_on] = ACTIONS(4273),
    [anon_sym_equals] = ACTIONS(4273),
    [anon_sym_let] = ACTIONS(4273),
    [anon_sym_orderby] = ACTIONS(4273),
    [anon_sym_ascending] = ACTIONS(4273),
    [anon_sym_descending] = ACTIONS(4273),
    [anon_sym_group] = ACTIONS(4273),
    [anon_sym_by] = ACTIONS(4273),
    [anon_sym_select] = ACTIONS(4273),
    [anon_sym_as] = ACTIONS(4337),
    [anon_sym_is] = ACTIONS(4337),
    [anon_sym_DASH_GT] = ACTIONS(4335),
    [anon_sym_with] = ACTIONS(4337),
    [aux_sym_preproc_if_token3] = ACTIONS(4335),
    [aux_sym_preproc_else_token1] = ACTIONS(4335),
    [aux_sym_preproc_elif_token1] = ACTIONS(4335),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2897] = {
    [sym_preproc_region] = STATE(2897),
    [sym_preproc_endregion] = STATE(2897),
    [sym_preproc_line] = STATE(2897),
    [sym_preproc_pragma] = STATE(2897),
    [sym_preproc_nullable] = STATE(2897),
    [sym_preproc_error] = STATE(2897),
    [sym_preproc_define] = STATE(2897),
    [sym_preproc_undef] = STATE(2897),
    [sym__identifier_token] = ACTIONS(4418),
    [anon_sym_alias] = ACTIONS(4418),
    [anon_sym_SEMI] = ACTIONS(4420),
    [anon_sym_global] = ACTIONS(4418),
    [anon_sym_LBRACK] = ACTIONS(4420),
    [anon_sym_COLON] = ACTIONS(4420),
    [anon_sym_COMMA] = ACTIONS(4420),
    [anon_sym_RBRACK] = ACTIONS(4420),
    [anon_sym_LPAREN] = ACTIONS(4420),
    [anon_sym_RPAREN] = ACTIONS(4420),
    [anon_sym_LBRACE] = ACTIONS(4420),
    [anon_sym_RBRACE] = ACTIONS(4420),
    [anon_sym_file] = ACTIONS(4418),
    [anon_sym_LT] = ACTIONS(4418),
    [anon_sym_GT] = ACTIONS(4418),
    [anon_sym_in] = ACTIONS(4418),
    [anon_sym_where] = ACTIONS(4418),
    [anon_sym_QMARK] = ACTIONS(4418),
    [anon_sym_notnull] = ACTIONS(4418),
    [anon_sym_unmanaged] = ACTIONS(4418),
    [anon_sym_operator] = ACTIONS(4418),
    [anon_sym_BANG] = ACTIONS(4418),
    [anon_sym_PLUS_PLUS] = ACTIONS(4420),
    [anon_sym_DASH_DASH] = ACTIONS(4420),
    [anon_sym_PLUS] = ACTIONS(4418),
    [anon_sym_DASH] = ACTIONS(4418),
    [anon_sym_STAR] = ACTIONS(4420),
    [anon_sym_SLASH] = ACTIONS(4418),
    [anon_sym_PERCENT] = ACTIONS(4420),
    [anon_sym_CARET] = ACTIONS(4420),
    [anon_sym_PIPE] = ACTIONS(4418),
    [anon_sym_AMP] = ACTIONS(4418),
    [anon_sym_LT_LT] = ACTIONS(4420),
    [anon_sym_GT_GT] = ACTIONS(4418),
    [anon_sym_GT_GT_GT] = ACTIONS(4420),
    [anon_sym_EQ_EQ] = ACTIONS(4420),
    [anon_sym_BANG_EQ] = ACTIONS(4420),
    [anon_sym_GT_EQ] = ACTIONS(4420),
    [anon_sym_LT_EQ] = ACTIONS(4420),
    [anon_sym_this] = ACTIONS(4418),
    [anon_sym_DOT] = ACTIONS(4418),
    [anon_sym_scoped] = ACTIONS(4418),
    [anon_sym_EQ_GT] = ACTIONS(4420),
    [anon_sym_var] = ACTIONS(4418),
    [anon_sym_yield] = ACTIONS(4418),
    [anon_sym_switch] = ACTIONS(4418),
    [anon_sym_when] = ACTIONS(4418),
    [sym_discard] = ACTIONS(4418),
    [anon_sym_DOT_DOT] = ACTIONS(4420),
    [anon_sym_and] = ACTIONS(4418),
    [anon_sym_or] = ACTIONS(4418),
    [anon_sym_AMP_AMP] = ACTIONS(4420),
    [anon_sym_PIPE_PIPE] = ACTIONS(4420),
    [anon_sym_QMARK_QMARK] = ACTIONS(4420),
    [anon_sym_from] = ACTIONS(4418),
    [anon_sym_into] = ACTIONS(4418),
    [anon_sym_join] = ACTIONS(4418),
    [anon_sym_on] = ACTIONS(4418),
    [anon_sym_equals] = ACTIONS(4418),
    [anon_sym_let] = ACTIONS(4418),
    [anon_sym_orderby] = ACTIONS(4418),
    [anon_sym_ascending] = ACTIONS(4418),
    [anon_sym_descending] = ACTIONS(4418),
    [anon_sym_group] = ACTIONS(4418),
    [anon_sym_by] = ACTIONS(4418),
    [anon_sym_select] = ACTIONS(4418),
    [anon_sym_as] = ACTIONS(4418),
    [anon_sym_is] = ACTIONS(4418),
    [anon_sym_DASH_GT] = ACTIONS(4420),
    [anon_sym_with] = ACTIONS(4418),
    [aux_sym_preproc_if_token3] = ACTIONS(4420),
    [aux_sym_preproc_else_token1] = ACTIONS(4420),
    [aux_sym_preproc_elif_token1] = ACTIONS(4420),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2898] = {
    [sym_preproc_region] = STATE(2898),
    [sym_preproc_endregion] = STATE(2898),
    [sym_preproc_line] = STATE(2898),
    [sym_preproc_pragma] = STATE(2898),
    [sym_preproc_nullable] = STATE(2898),
    [sym_preproc_error] = STATE(2898),
    [sym_preproc_define] = STATE(2898),
    [sym_preproc_undef] = STATE(2898),
    [sym__identifier_token] = ACTIONS(4422),
    [anon_sym_alias] = ACTIONS(4422),
    [anon_sym_SEMI] = ACTIONS(4424),
    [anon_sym_global] = ACTIONS(4422),
    [anon_sym_LBRACK] = ACTIONS(4424),
    [anon_sym_COLON] = ACTIONS(4424),
    [anon_sym_COMMA] = ACTIONS(4424),
    [anon_sym_RBRACK] = ACTIONS(4424),
    [anon_sym_LPAREN] = ACTIONS(4424),
    [anon_sym_RPAREN] = ACTIONS(4424),
    [anon_sym_LBRACE] = ACTIONS(4424),
    [anon_sym_RBRACE] = ACTIONS(4424),
    [anon_sym_file] = ACTIONS(4422),
    [anon_sym_LT] = ACTIONS(4422),
    [anon_sym_GT] = ACTIONS(4422),
    [anon_sym_in] = ACTIONS(4422),
    [anon_sym_where] = ACTIONS(4422),
    [anon_sym_QMARK] = ACTIONS(4422),
    [anon_sym_notnull] = ACTIONS(4422),
    [anon_sym_unmanaged] = ACTIONS(4422),
    [anon_sym_operator] = ACTIONS(4422),
    [anon_sym_BANG] = ACTIONS(4422),
    [anon_sym_PLUS_PLUS] = ACTIONS(4424),
    [anon_sym_DASH_DASH] = ACTIONS(4424),
    [anon_sym_PLUS] = ACTIONS(4422),
    [anon_sym_DASH] = ACTIONS(4422),
    [anon_sym_STAR] = ACTIONS(4424),
    [anon_sym_SLASH] = ACTIONS(4422),
    [anon_sym_PERCENT] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4424),
    [anon_sym_PIPE] = ACTIONS(4422),
    [anon_sym_AMP] = ACTIONS(4422),
    [anon_sym_LT_LT] = ACTIONS(4424),
    [anon_sym_GT_GT] = ACTIONS(4422),
    [anon_sym_GT_GT_GT] = ACTIONS(4424),
    [anon_sym_EQ_EQ] = ACTIONS(4424),
    [anon_sym_BANG_EQ] = ACTIONS(4424),
    [anon_sym_GT_EQ] = ACTIONS(4424),
    [anon_sym_LT_EQ] = ACTIONS(4424),
    [anon_sym_this] = ACTIONS(4422),
    [anon_sym_DOT] = ACTIONS(4422),
    [anon_sym_scoped] = ACTIONS(4422),
    [anon_sym_EQ_GT] = ACTIONS(4424),
    [anon_sym_var] = ACTIONS(4422),
    [anon_sym_yield] = ACTIONS(4422),
    [anon_sym_switch] = ACTIONS(4422),
    [anon_sym_when] = ACTIONS(4422),
    [sym_discard] = ACTIONS(4422),
    [anon_sym_DOT_DOT] = ACTIONS(4424),
    [anon_sym_and] = ACTIONS(4422),
    [anon_sym_or] = ACTIONS(4422),
    [anon_sym_AMP_AMP] = ACTIONS(4424),
    [anon_sym_PIPE_PIPE] = ACTIONS(4424),
    [anon_sym_QMARK_QMARK] = ACTIONS(4424),
    [anon_sym_from] = ACTIONS(4422),
    [anon_sym_into] = ACTIONS(4422),
    [anon_sym_join] = ACTIONS(4422),
    [anon_sym_on] = ACTIONS(4422),
    [anon_sym_equals] = ACTIONS(4422),
    [anon_sym_let] = ACTIONS(4422),
    [anon_sym_orderby] = ACTIONS(4422),
    [anon_sym_ascending] = ACTIONS(4422),
    [anon_sym_descending] = ACTIONS(4422),
    [anon_sym_group] = ACTIONS(4422),
    [anon_sym_by] = ACTIONS(4422),
    [anon_sym_select] = ACTIONS(4422),
    [anon_sym_as] = ACTIONS(4422),
    [anon_sym_is] = ACTIONS(4422),
    [anon_sym_DASH_GT] = ACTIONS(4424),
    [anon_sym_with] = ACTIONS(4422),
    [aux_sym_preproc_if_token3] = ACTIONS(4424),
    [aux_sym_preproc_else_token1] = ACTIONS(4424),
    [aux_sym_preproc_elif_token1] = ACTIONS(4424),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2899] = {
    [sym_preproc_region] = STATE(2899),
    [sym_preproc_endregion] = STATE(2899),
    [sym_preproc_line] = STATE(2899),
    [sym_preproc_pragma] = STATE(2899),
    [sym_preproc_nullable] = STATE(2899),
    [sym_preproc_error] = STATE(2899),
    [sym_preproc_define] = STATE(2899),
    [sym_preproc_undef] = STATE(2899),
    [sym__identifier_token] = ACTIONS(4426),
    [anon_sym_alias] = ACTIONS(4426),
    [anon_sym_SEMI] = ACTIONS(4428),
    [anon_sym_global] = ACTIONS(4426),
    [anon_sym_LBRACK] = ACTIONS(4428),
    [anon_sym_COLON] = ACTIONS(4428),
    [anon_sym_COMMA] = ACTIONS(4428),
    [anon_sym_RBRACK] = ACTIONS(4428),
    [anon_sym_LPAREN] = ACTIONS(4428),
    [anon_sym_RPAREN] = ACTIONS(4428),
    [anon_sym_LBRACE] = ACTIONS(4428),
    [anon_sym_RBRACE] = ACTIONS(4428),
    [anon_sym_file] = ACTIONS(4426),
    [anon_sym_LT] = ACTIONS(4426),
    [anon_sym_GT] = ACTIONS(4426),
    [anon_sym_in] = ACTIONS(4426),
    [anon_sym_where] = ACTIONS(4426),
    [anon_sym_QMARK] = ACTIONS(4426),
    [anon_sym_notnull] = ACTIONS(4426),
    [anon_sym_unmanaged] = ACTIONS(4426),
    [anon_sym_operator] = ACTIONS(4426),
    [anon_sym_BANG] = ACTIONS(4426),
    [anon_sym_PLUS_PLUS] = ACTIONS(4428),
    [anon_sym_DASH_DASH] = ACTIONS(4428),
    [anon_sym_PLUS] = ACTIONS(4426),
    [anon_sym_DASH] = ACTIONS(4426),
    [anon_sym_STAR] = ACTIONS(4428),
    [anon_sym_SLASH] = ACTIONS(4426),
    [anon_sym_PERCENT] = ACTIONS(4428),
    [anon_sym_CARET] = ACTIONS(4428),
    [anon_sym_PIPE] = ACTIONS(4426),
    [anon_sym_AMP] = ACTIONS(4426),
    [anon_sym_LT_LT] = ACTIONS(4428),
    [anon_sym_GT_GT] = ACTIONS(4426),
    [anon_sym_GT_GT_GT] = ACTIONS(4428),
    [anon_sym_EQ_EQ] = ACTIONS(4428),
    [anon_sym_BANG_EQ] = ACTIONS(4428),
    [anon_sym_GT_EQ] = ACTIONS(4428),
    [anon_sym_LT_EQ] = ACTIONS(4428),
    [anon_sym_this] = ACTIONS(4426),
    [anon_sym_DOT] = ACTIONS(4426),
    [anon_sym_scoped] = ACTIONS(4426),
    [anon_sym_EQ_GT] = ACTIONS(4428),
    [anon_sym_var] = ACTIONS(4426),
    [anon_sym_yield] = ACTIONS(4426),
    [anon_sym_switch] = ACTIONS(4426),
    [anon_sym_when] = ACTIONS(4426),
    [sym_discard] = ACTIONS(4426),
    [anon_sym_DOT_DOT] = ACTIONS(4428),
    [anon_sym_and] = ACTIONS(4426),
    [anon_sym_or] = ACTIONS(4426),
    [anon_sym_AMP_AMP] = ACTIONS(4428),
    [anon_sym_PIPE_PIPE] = ACTIONS(4428),
    [anon_sym_QMARK_QMARK] = ACTIONS(4428),
    [anon_sym_from] = ACTIONS(4426),
    [anon_sym_into] = ACTIONS(4426),
    [anon_sym_join] = ACTIONS(4426),
    [anon_sym_on] = ACTIONS(4426),
    [anon_sym_equals] = ACTIONS(4426),
    [anon_sym_let] = ACTIONS(4426),
    [anon_sym_orderby] = ACTIONS(4426),
    [anon_sym_ascending] = ACTIONS(4426),
    [anon_sym_descending] = ACTIONS(4426),
    [anon_sym_group] = ACTIONS(4426),
    [anon_sym_by] = ACTIONS(4426),
    [anon_sym_select] = ACTIONS(4426),
    [anon_sym_as] = ACTIONS(4426),
    [anon_sym_is] = ACTIONS(4426),
    [anon_sym_DASH_GT] = ACTIONS(4428),
    [anon_sym_with] = ACTIONS(4426),
    [aux_sym_preproc_if_token3] = ACTIONS(4428),
    [aux_sym_preproc_else_token1] = ACTIONS(4428),
    [aux_sym_preproc_elif_token1] = ACTIONS(4428),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2900] = {
    [sym_type_argument_list] = STATE(2736),
    [sym_preproc_region] = STATE(2900),
    [sym_preproc_endregion] = STATE(2900),
    [sym_preproc_line] = STATE(2900),
    [sym_preproc_pragma] = STATE(2900),
    [sym_preproc_nullable] = STATE(2900),
    [sym_preproc_error] = STATE(2900),
    [sym_preproc_define] = STATE(2900),
    [sym_preproc_undef] = STATE(2900),
    [sym__identifier_token] = ACTIONS(4074),
    [anon_sym_alias] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4074),
    [anon_sym_EQ] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4076),
    [anon_sym_COLON] = ACTIONS(4430),
    [anon_sym_LPAREN] = ACTIONS(4076),
    [anon_sym_file] = ACTIONS(4074),
    [anon_sym_LT] = ACTIONS(4078),
    [anon_sym_GT] = ACTIONS(4074),
    [anon_sym_where] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(4074),
    [anon_sym_notnull] = ACTIONS(4074),
    [anon_sym_unmanaged] = ACTIONS(4074),
    [anon_sym_BANG] = ACTIONS(4074),
    [anon_sym_PLUS_PLUS] = ACTIONS(4076),
    [anon_sym_DASH_DASH] = ACTIONS(4076),
    [anon_sym_PLUS] = ACTIONS(4074),
    [anon_sym_DASH] = ACTIONS(4074),
    [anon_sym_STAR] = ACTIONS(4074),
    [anon_sym_SLASH] = ACTIONS(4074),
    [anon_sym_PERCENT] = ACTIONS(4074),
    [anon_sym_CARET] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(4074),
    [anon_sym_AMP] = ACTIONS(4074),
    [anon_sym_LT_LT] = ACTIONS(4074),
    [anon_sym_GT_GT] = ACTIONS(4074),
    [anon_sym_GT_GT_GT] = ACTIONS(4074),
    [anon_sym_EQ_EQ] = ACTIONS(4076),
    [anon_sym_BANG_EQ] = ACTIONS(4076),
    [anon_sym_GT_EQ] = ACTIONS(4076),
    [anon_sym_LT_EQ] = ACTIONS(4076),
    [anon_sym_DOT] = ACTIONS(4074),
    [anon_sym_scoped] = ACTIONS(4074),
    [anon_sym_EQ_GT] = ACTIONS(4081),
    [anon_sym_COLON_COLON] = ACTIONS(4083),
    [anon_sym_var] = ACTIONS(4074),
    [anon_sym_yield] = ACTIONS(4074),
    [anon_sym_switch] = ACTIONS(4074),
    [anon_sym_when] = ACTIONS(4074),
    [anon_sym_DOT_DOT] = ACTIONS(4076),
    [anon_sym_PLUS_EQ] = ACTIONS(4076),
    [anon_sym_DASH_EQ] = ACTIONS(4076),
    [anon_sym_STAR_EQ] = ACTIONS(4076),
    [anon_sym_SLASH_EQ] = ACTIONS(4076),
    [anon_sym_PERCENT_EQ] = ACTIONS(4076),
    [anon_sym_AMP_EQ] = ACTIONS(4076),
    [anon_sym_CARET_EQ] = ACTIONS(4076),
    [anon_sym_PIPE_EQ] = ACTIONS(4076),
    [anon_sym_LT_LT_EQ] = ACTIONS(4076),
    [anon_sym_GT_GT_EQ] = ACTIONS(4076),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4076),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4076),
    [anon_sym_AMP_AMP] = ACTIONS(4076),
    [anon_sym_PIPE_PIPE] = ACTIONS(4076),
    [anon_sym_QMARK_QMARK] = ACTIONS(4074),
    [anon_sym_from] = ACTIONS(4074),
    [anon_sym_into] = ACTIONS(4074),
    [anon_sym_join] = ACTIONS(4074),
    [anon_sym_on] = ACTIONS(4074),
    [anon_sym_equals] = ACTIONS(4074),
    [anon_sym_let] = ACTIONS(4074),
    [anon_sym_orderby] = ACTIONS(4074),
    [anon_sym_ascending] = ACTIONS(4074),
    [anon_sym_descending] = ACTIONS(4074),
    [anon_sym_group] = ACTIONS(4074),
    [anon_sym_by] = ACTIONS(4074),
    [anon_sym_select] = ACTIONS(4074),
    [anon_sym_as] = ACTIONS(4074),
    [anon_sym_is] = ACTIONS(4074),
    [anon_sym_DASH_GT] = ACTIONS(4076),
    [anon_sym_with] = ACTIONS(4074),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2901] = {
    [sym_preproc_region] = STATE(2901),
    [sym_preproc_endregion] = STATE(2901),
    [sym_preproc_line] = STATE(2901),
    [sym_preproc_pragma] = STATE(2901),
    [sym_preproc_nullable] = STATE(2901),
    [sym_preproc_error] = STATE(2901),
    [sym_preproc_define] = STATE(2901),
    [sym_preproc_undef] = STATE(2901),
    [sym__identifier_token] = ACTIONS(4432),
    [anon_sym_alias] = ACTIONS(4432),
    [anon_sym_SEMI] = ACTIONS(4434),
    [anon_sym_global] = ACTIONS(4432),
    [anon_sym_LBRACK] = ACTIONS(4434),
    [anon_sym_COLON] = ACTIONS(4434),
    [anon_sym_COMMA] = ACTIONS(4434),
    [anon_sym_RBRACK] = ACTIONS(4434),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [anon_sym_RPAREN] = ACTIONS(4434),
    [anon_sym_LBRACE] = ACTIONS(4434),
    [anon_sym_RBRACE] = ACTIONS(4434),
    [anon_sym_file] = ACTIONS(4432),
    [anon_sym_LT] = ACTIONS(4432),
    [anon_sym_GT] = ACTIONS(4432),
    [anon_sym_in] = ACTIONS(4432),
    [anon_sym_where] = ACTIONS(4432),
    [anon_sym_QMARK] = ACTIONS(4432),
    [anon_sym_notnull] = ACTIONS(4432),
    [anon_sym_unmanaged] = ACTIONS(4432),
    [anon_sym_operator] = ACTIONS(4432),
    [anon_sym_BANG] = ACTIONS(4432),
    [anon_sym_PLUS_PLUS] = ACTIONS(4434),
    [anon_sym_DASH_DASH] = ACTIONS(4434),
    [anon_sym_PLUS] = ACTIONS(4432),
    [anon_sym_DASH] = ACTIONS(4432),
    [anon_sym_STAR] = ACTIONS(4434),
    [anon_sym_SLASH] = ACTIONS(4432),
    [anon_sym_PERCENT] = ACTIONS(4434),
    [anon_sym_CARET] = ACTIONS(4434),
    [anon_sym_PIPE] = ACTIONS(4432),
    [anon_sym_AMP] = ACTIONS(4432),
    [anon_sym_LT_LT] = ACTIONS(4434),
    [anon_sym_GT_GT] = ACTIONS(4432),
    [anon_sym_GT_GT_GT] = ACTIONS(4434),
    [anon_sym_EQ_EQ] = ACTIONS(4434),
    [anon_sym_BANG_EQ] = ACTIONS(4434),
    [anon_sym_GT_EQ] = ACTIONS(4434),
    [anon_sym_LT_EQ] = ACTIONS(4434),
    [anon_sym_this] = ACTIONS(4432),
    [anon_sym_DOT] = ACTIONS(4432),
    [anon_sym_scoped] = ACTIONS(4432),
    [anon_sym_EQ_GT] = ACTIONS(4434),
    [anon_sym_var] = ACTIONS(4432),
    [anon_sym_yield] = ACTIONS(4432),
    [anon_sym_switch] = ACTIONS(4432),
    [anon_sym_when] = ACTIONS(4432),
    [sym_discard] = ACTIONS(4432),
    [anon_sym_DOT_DOT] = ACTIONS(4434),
    [anon_sym_and] = ACTIONS(4432),
    [anon_sym_or] = ACTIONS(4432),
    [anon_sym_AMP_AMP] = ACTIONS(4434),
    [anon_sym_PIPE_PIPE] = ACTIONS(4434),
    [anon_sym_QMARK_QMARK] = ACTIONS(4434),
    [anon_sym_from] = ACTIONS(4432),
    [anon_sym_into] = ACTIONS(4432),
    [anon_sym_join] = ACTIONS(4432),
    [anon_sym_on] = ACTIONS(4432),
    [anon_sym_equals] = ACTIONS(4432),
    [anon_sym_let] = ACTIONS(4432),
    [anon_sym_orderby] = ACTIONS(4432),
    [anon_sym_ascending] = ACTIONS(4432),
    [anon_sym_descending] = ACTIONS(4432),
    [anon_sym_group] = ACTIONS(4432),
    [anon_sym_by] = ACTIONS(4432),
    [anon_sym_select] = ACTIONS(4432),
    [anon_sym_as] = ACTIONS(4432),
    [anon_sym_is] = ACTIONS(4432),
    [anon_sym_DASH_GT] = ACTIONS(4434),
    [anon_sym_with] = ACTIONS(4432),
    [aux_sym_preproc_if_token3] = ACTIONS(4434),
    [aux_sym_preproc_else_token1] = ACTIONS(4434),
    [aux_sym_preproc_elif_token1] = ACTIONS(4434),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2902] = {
    [sym_preproc_region] = STATE(2902),
    [sym_preproc_endregion] = STATE(2902),
    [sym_preproc_line] = STATE(2902),
    [sym_preproc_pragma] = STATE(2902),
    [sym_preproc_nullable] = STATE(2902),
    [sym_preproc_error] = STATE(2902),
    [sym_preproc_define] = STATE(2902),
    [sym_preproc_undef] = STATE(2902),
    [sym__identifier_token] = ACTIONS(4099),
    [anon_sym_alias] = ACTIONS(4099),
    [anon_sym_global] = ACTIONS(4099),
    [anon_sym_EQ] = ACTIONS(4104),
    [anon_sym_LBRACK] = ACTIONS(4101),
    [anon_sym_LPAREN] = ACTIONS(4101),
    [anon_sym_LBRACE] = ACTIONS(4106),
    [anon_sym_file] = ACTIONS(4099),
    [anon_sym_LT] = ACTIONS(4108),
    [anon_sym_GT] = ACTIONS(4108),
    [anon_sym_where] = ACTIONS(4099),
    [anon_sym_QMARK] = ACTIONS(4108),
    [anon_sym_notnull] = ACTIONS(4099),
    [anon_sym_unmanaged] = ACTIONS(4099),
    [anon_sym_BANG] = ACTIONS(4108),
    [anon_sym_PLUS_PLUS] = ACTIONS(4101),
    [anon_sym_DASH_DASH] = ACTIONS(4101),
    [anon_sym_PLUS] = ACTIONS(4108),
    [anon_sym_DASH] = ACTIONS(4108),
    [anon_sym_STAR] = ACTIONS(4108),
    [anon_sym_SLASH] = ACTIONS(4108),
    [anon_sym_PERCENT] = ACTIONS(4108),
    [anon_sym_CARET] = ACTIONS(4108),
    [anon_sym_PIPE] = ACTIONS(4108),
    [anon_sym_AMP] = ACTIONS(4108),
    [anon_sym_LT_LT] = ACTIONS(4108),
    [anon_sym_GT_GT] = ACTIONS(4108),
    [anon_sym_GT_GT_GT] = ACTIONS(4108),
    [anon_sym_EQ_EQ] = ACTIONS(4101),
    [anon_sym_BANG_EQ] = ACTIONS(4101),
    [anon_sym_GT_EQ] = ACTIONS(4101),
    [anon_sym_LT_EQ] = ACTIONS(4101),
    [anon_sym_DOT] = ACTIONS(4108),
    [anon_sym_scoped] = ACTIONS(4099),
    [anon_sym_var] = ACTIONS(4099),
    [anon_sym_yield] = ACTIONS(4099),
    [anon_sym_switch] = ACTIONS(4108),
    [anon_sym_when] = ACTIONS(4099),
    [sym_discard] = ACTIONS(4099),
    [anon_sym_DOT_DOT] = ACTIONS(4101),
    [anon_sym_and] = ACTIONS(4108),
    [anon_sym_or] = ACTIONS(4108),
    [anon_sym_PLUS_EQ] = ACTIONS(4111),
    [anon_sym_DASH_EQ] = ACTIONS(4111),
    [anon_sym_STAR_EQ] = ACTIONS(4111),
    [anon_sym_SLASH_EQ] = ACTIONS(4111),
    [anon_sym_PERCENT_EQ] = ACTIONS(4111),
    [anon_sym_AMP_EQ] = ACTIONS(4111),
    [anon_sym_CARET_EQ] = ACTIONS(4111),
    [anon_sym_PIPE_EQ] = ACTIONS(4111),
    [anon_sym_LT_LT_EQ] = ACTIONS(4111),
    [anon_sym_GT_GT_EQ] = ACTIONS(4111),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4111),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4111),
    [anon_sym_AMP_AMP] = ACTIONS(4101),
    [anon_sym_PIPE_PIPE] = ACTIONS(4101),
    [anon_sym_QMARK_QMARK] = ACTIONS(4108),
    [anon_sym_from] = ACTIONS(4099),
    [anon_sym_into] = ACTIONS(4099),
    [anon_sym_join] = ACTIONS(4099),
    [anon_sym_on] = ACTIONS(4099),
    [anon_sym_equals] = ACTIONS(4108),
    [anon_sym_let] = ACTIONS(4099),
    [anon_sym_orderby] = ACTIONS(4099),
    [anon_sym_ascending] = ACTIONS(4099),
    [anon_sym_descending] = ACTIONS(4099),
    [anon_sym_group] = ACTIONS(4099),
    [anon_sym_by] = ACTIONS(4099),
    [anon_sym_select] = ACTIONS(4099),
    [anon_sym_as] = ACTIONS(4108),
    [anon_sym_is] = ACTIONS(4108),
    [anon_sym_DASH_GT] = ACTIONS(4101),
    [anon_sym_with] = ACTIONS(4108),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2903] = {
    [sym_preproc_region] = STATE(2903),
    [sym_preproc_endregion] = STATE(2903),
    [sym_preproc_line] = STATE(2903),
    [sym_preproc_pragma] = STATE(2903),
    [sym_preproc_nullable] = STATE(2903),
    [sym_preproc_error] = STATE(2903),
    [sym_preproc_define] = STATE(2903),
    [sym_preproc_undef] = STATE(2903),
    [sym__identifier_token] = ACTIONS(4099),
    [anon_sym_alias] = ACTIONS(4099),
    [anon_sym_global] = ACTIONS(4099),
    [anon_sym_EQ] = ACTIONS(4104),
    [anon_sym_LBRACK] = ACTIONS(4101),
    [anon_sym_LPAREN] = ACTIONS(4101),
    [anon_sym_LBRACE] = ACTIONS(4106),
    [anon_sym_file] = ACTIONS(4099),
    [anon_sym_LT] = ACTIONS(4108),
    [anon_sym_GT] = ACTIONS(4108),
    [anon_sym_where] = ACTIONS(4099),
    [anon_sym_QMARK] = ACTIONS(4108),
    [anon_sym_notnull] = ACTIONS(4099),
    [anon_sym_unmanaged] = ACTIONS(4099),
    [anon_sym_BANG] = ACTIONS(4108),
    [anon_sym_PLUS_PLUS] = ACTIONS(4101),
    [anon_sym_DASH_DASH] = ACTIONS(4101),
    [anon_sym_PLUS] = ACTIONS(4108),
    [anon_sym_DASH] = ACTIONS(4108),
    [anon_sym_STAR] = ACTIONS(4108),
    [anon_sym_SLASH] = ACTIONS(4108),
    [anon_sym_PERCENT] = ACTIONS(4108),
    [anon_sym_CARET] = ACTIONS(4108),
    [anon_sym_PIPE] = ACTIONS(4108),
    [anon_sym_AMP] = ACTIONS(4108),
    [anon_sym_LT_LT] = ACTIONS(4108),
    [anon_sym_GT_GT] = ACTIONS(4108),
    [anon_sym_GT_GT_GT] = ACTIONS(4108),
    [anon_sym_EQ_EQ] = ACTIONS(4101),
    [anon_sym_BANG_EQ] = ACTIONS(4101),
    [anon_sym_GT_EQ] = ACTIONS(4101),
    [anon_sym_LT_EQ] = ACTIONS(4101),
    [anon_sym_DOT] = ACTIONS(4108),
    [anon_sym_scoped] = ACTIONS(4099),
    [anon_sym_var] = ACTIONS(4099),
    [anon_sym_yield] = ACTIONS(4099),
    [anon_sym_switch] = ACTIONS(4108),
    [anon_sym_when] = ACTIONS(4099),
    [sym_discard] = ACTIONS(4099),
    [anon_sym_DOT_DOT] = ACTIONS(4101),
    [anon_sym_and] = ACTIONS(4108),
    [anon_sym_or] = ACTIONS(4108),
    [anon_sym_PLUS_EQ] = ACTIONS(4111),
    [anon_sym_DASH_EQ] = ACTIONS(4111),
    [anon_sym_STAR_EQ] = ACTIONS(4111),
    [anon_sym_SLASH_EQ] = ACTIONS(4111),
    [anon_sym_PERCENT_EQ] = ACTIONS(4111),
    [anon_sym_AMP_EQ] = ACTIONS(4111),
    [anon_sym_CARET_EQ] = ACTIONS(4111),
    [anon_sym_PIPE_EQ] = ACTIONS(4111),
    [anon_sym_LT_LT_EQ] = ACTIONS(4111),
    [anon_sym_GT_GT_EQ] = ACTIONS(4111),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4111),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4111),
    [anon_sym_AMP_AMP] = ACTIONS(4101),
    [anon_sym_PIPE_PIPE] = ACTIONS(4101),
    [anon_sym_QMARK_QMARK] = ACTIONS(4108),
    [anon_sym_from] = ACTIONS(4099),
    [anon_sym_into] = ACTIONS(4108),
    [anon_sym_join] = ACTIONS(4099),
    [anon_sym_on] = ACTIONS(4099),
    [anon_sym_equals] = ACTIONS(4108),
    [anon_sym_let] = ACTIONS(4099),
    [anon_sym_orderby] = ACTIONS(4099),
    [anon_sym_ascending] = ACTIONS(4099),
    [anon_sym_descending] = ACTIONS(4099),
    [anon_sym_group] = ACTIONS(4099),
    [anon_sym_by] = ACTIONS(4099),
    [anon_sym_select] = ACTIONS(4099),
    [anon_sym_as] = ACTIONS(4108),
    [anon_sym_is] = ACTIONS(4108),
    [anon_sym_DASH_GT] = ACTIONS(4101),
    [anon_sym_with] = ACTIONS(4108),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2904] = {
    [sym_preproc_region] = STATE(2904),
    [sym_preproc_endregion] = STATE(2904),
    [sym_preproc_line] = STATE(2904),
    [sym_preproc_pragma] = STATE(2904),
    [sym_preproc_nullable] = STATE(2904),
    [sym_preproc_error] = STATE(2904),
    [sym_preproc_define] = STATE(2904),
    [sym_preproc_undef] = STATE(2904),
    [sym__identifier_token] = ACTIONS(4113),
    [anon_sym_alias] = ACTIONS(4113),
    [anon_sym_global] = ACTIONS(4113),
    [anon_sym_EQ] = ACTIONS(4118),
    [anon_sym_LBRACK] = ACTIONS(4120),
    [anon_sym_LPAREN] = ACTIONS(4120),
    [anon_sym_LBRACE] = ACTIONS(4124),
    [anon_sym_file] = ACTIONS(4113),
    [anon_sym_LT] = ACTIONS(4126),
    [anon_sym_GT] = ACTIONS(4126),
    [anon_sym_where] = ACTIONS(4113),
    [anon_sym_QMARK] = ACTIONS(4126),
    [anon_sym_notnull] = ACTIONS(4113),
    [anon_sym_unmanaged] = ACTIONS(4113),
    [anon_sym_BANG] = ACTIONS(4126),
    [anon_sym_PLUS_PLUS] = ACTIONS(4120),
    [anon_sym_DASH_DASH] = ACTIONS(4120),
    [anon_sym_PLUS] = ACTIONS(4126),
    [anon_sym_DASH] = ACTIONS(4126),
    [anon_sym_STAR] = ACTIONS(4126),
    [anon_sym_SLASH] = ACTIONS(4126),
    [anon_sym_PERCENT] = ACTIONS(4126),
    [anon_sym_CARET] = ACTIONS(4126),
    [anon_sym_PIPE] = ACTIONS(4126),
    [anon_sym_AMP] = ACTIONS(4126),
    [anon_sym_LT_LT] = ACTIONS(4126),
    [anon_sym_GT_GT] = ACTIONS(4126),
    [anon_sym_GT_GT_GT] = ACTIONS(4126),
    [anon_sym_EQ_EQ] = ACTIONS(4120),
    [anon_sym_BANG_EQ] = ACTIONS(4120),
    [anon_sym_GT_EQ] = ACTIONS(4120),
    [anon_sym_LT_EQ] = ACTIONS(4120),
    [anon_sym_DOT] = ACTIONS(4126),
    [anon_sym_scoped] = ACTIONS(4113),
    [anon_sym_var] = ACTIONS(4113),
    [anon_sym_yield] = ACTIONS(4113),
    [anon_sym_switch] = ACTIONS(4126),
    [anon_sym_when] = ACTIONS(4113),
    [sym_discard] = ACTIONS(4113),
    [anon_sym_DOT_DOT] = ACTIONS(4120),
    [anon_sym_and] = ACTIONS(4130),
    [anon_sym_or] = ACTIONS(4130),
    [anon_sym_PLUS_EQ] = ACTIONS(4133),
    [anon_sym_DASH_EQ] = ACTIONS(4133),
    [anon_sym_STAR_EQ] = ACTIONS(4133),
    [anon_sym_SLASH_EQ] = ACTIONS(4133),
    [anon_sym_PERCENT_EQ] = ACTIONS(4133),
    [anon_sym_AMP_EQ] = ACTIONS(4133),
    [anon_sym_CARET_EQ] = ACTIONS(4133),
    [anon_sym_PIPE_EQ] = ACTIONS(4133),
    [anon_sym_LT_LT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4133),
    [anon_sym_AMP_AMP] = ACTIONS(4120),
    [anon_sym_PIPE_PIPE] = ACTIONS(4120),
    [anon_sym_QMARK_QMARK] = ACTIONS(4126),
    [anon_sym_from] = ACTIONS(4113),
    [anon_sym_into] = ACTIONS(4113),
    [anon_sym_join] = ACTIONS(4113),
    [anon_sym_on] = ACTIONS(4113),
    [anon_sym_equals] = ACTIONS(4130),
    [anon_sym_let] = ACTIONS(4113),
    [anon_sym_orderby] = ACTIONS(4113),
    [anon_sym_ascending] = ACTIONS(4113),
    [anon_sym_descending] = ACTIONS(4113),
    [anon_sym_group] = ACTIONS(4113),
    [anon_sym_by] = ACTIONS(4113),
    [anon_sym_select] = ACTIONS(4113),
    [anon_sym_as] = ACTIONS(4126),
    [anon_sym_is] = ACTIONS(4126),
    [anon_sym_DASH_GT] = ACTIONS(4120),
    [anon_sym_with] = ACTIONS(4126),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2905] = {
    [sym_preproc_region] = STATE(2905),
    [sym_preproc_endregion] = STATE(2905),
    [sym_preproc_line] = STATE(2905),
    [sym_preproc_pragma] = STATE(2905),
    [sym_preproc_nullable] = STATE(2905),
    [sym_preproc_error] = STATE(2905),
    [sym_preproc_define] = STATE(2905),
    [sym_preproc_undef] = STATE(2905),
    [sym__identifier_token] = ACTIONS(4099),
    [anon_sym_alias] = ACTIONS(4099),
    [anon_sym_global] = ACTIONS(4099),
    [anon_sym_EQ] = ACTIONS(4104),
    [anon_sym_LBRACK] = ACTIONS(4101),
    [anon_sym_LPAREN] = ACTIONS(4101),
    [anon_sym_LBRACE] = ACTIONS(4106),
    [anon_sym_file] = ACTIONS(4099),
    [anon_sym_LT] = ACTIONS(4108),
    [anon_sym_GT] = ACTIONS(4108),
    [anon_sym_where] = ACTIONS(4099),
    [anon_sym_QMARK] = ACTIONS(4108),
    [anon_sym_notnull] = ACTIONS(4099),
    [anon_sym_unmanaged] = ACTIONS(4099),
    [anon_sym_BANG] = ACTIONS(4108),
    [anon_sym_PLUS_PLUS] = ACTIONS(4101),
    [anon_sym_DASH_DASH] = ACTIONS(4101),
    [anon_sym_PLUS] = ACTIONS(4108),
    [anon_sym_DASH] = ACTIONS(4108),
    [anon_sym_STAR] = ACTIONS(4108),
    [anon_sym_SLASH] = ACTIONS(4108),
    [anon_sym_PERCENT] = ACTIONS(4108),
    [anon_sym_CARET] = ACTIONS(4108),
    [anon_sym_PIPE] = ACTIONS(4108),
    [anon_sym_AMP] = ACTIONS(4108),
    [anon_sym_LT_LT] = ACTIONS(4108),
    [anon_sym_GT_GT] = ACTIONS(4108),
    [anon_sym_GT_GT_GT] = ACTIONS(4108),
    [anon_sym_EQ_EQ] = ACTIONS(4101),
    [anon_sym_BANG_EQ] = ACTIONS(4101),
    [anon_sym_GT_EQ] = ACTIONS(4101),
    [anon_sym_LT_EQ] = ACTIONS(4101),
    [anon_sym_DOT] = ACTIONS(4108),
    [anon_sym_scoped] = ACTIONS(4099),
    [anon_sym_var] = ACTIONS(4099),
    [anon_sym_yield] = ACTIONS(4099),
    [anon_sym_switch] = ACTIONS(4108),
    [anon_sym_when] = ACTIONS(4099),
    [sym_discard] = ACTIONS(4099),
    [anon_sym_DOT_DOT] = ACTIONS(4101),
    [anon_sym_and] = ACTIONS(4108),
    [anon_sym_or] = ACTIONS(4108),
    [anon_sym_PLUS_EQ] = ACTIONS(4111),
    [anon_sym_DASH_EQ] = ACTIONS(4111),
    [anon_sym_STAR_EQ] = ACTIONS(4111),
    [anon_sym_SLASH_EQ] = ACTIONS(4111),
    [anon_sym_PERCENT_EQ] = ACTIONS(4111),
    [anon_sym_AMP_EQ] = ACTIONS(4111),
    [anon_sym_CARET_EQ] = ACTIONS(4111),
    [anon_sym_PIPE_EQ] = ACTIONS(4111),
    [anon_sym_LT_LT_EQ] = ACTIONS(4111),
    [anon_sym_GT_GT_EQ] = ACTIONS(4111),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4111),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4111),
    [anon_sym_AMP_AMP] = ACTIONS(4101),
    [anon_sym_PIPE_PIPE] = ACTIONS(4101),
    [anon_sym_QMARK_QMARK] = ACTIONS(4108),
    [anon_sym_from] = ACTIONS(4099),
    [anon_sym_into] = ACTIONS(4108),
    [anon_sym_join] = ACTIONS(4099),
    [anon_sym_on] = ACTIONS(4108),
    [anon_sym_equals] = ACTIONS(4099),
    [anon_sym_let] = ACTIONS(4099),
    [anon_sym_orderby] = ACTIONS(4099),
    [anon_sym_ascending] = ACTIONS(4099),
    [anon_sym_descending] = ACTIONS(4099),
    [anon_sym_group] = ACTIONS(4099),
    [anon_sym_by] = ACTIONS(4099),
    [anon_sym_select] = ACTIONS(4099),
    [anon_sym_as] = ACTIONS(4108),
    [anon_sym_is] = ACTIONS(4108),
    [anon_sym_DASH_GT] = ACTIONS(4101),
    [anon_sym_with] = ACTIONS(4108),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2906] = {
    [sym_preproc_region] = STATE(2906),
    [sym_preproc_endregion] = STATE(2906),
    [sym_preproc_line] = STATE(2906),
    [sym_preproc_pragma] = STATE(2906),
    [sym_preproc_nullable] = STATE(2906),
    [sym_preproc_error] = STATE(2906),
    [sym_preproc_define] = STATE(2906),
    [sym_preproc_undef] = STATE(2906),
    [sym__identifier_token] = ACTIONS(4113),
    [anon_sym_alias] = ACTIONS(4113),
    [anon_sym_global] = ACTIONS(4113),
    [anon_sym_EQ] = ACTIONS(4118),
    [anon_sym_LBRACK] = ACTIONS(4120),
    [anon_sym_LPAREN] = ACTIONS(4120),
    [anon_sym_LBRACE] = ACTIONS(4124),
    [anon_sym_file] = ACTIONS(4113),
    [anon_sym_LT] = ACTIONS(4126),
    [anon_sym_GT] = ACTIONS(4126),
    [anon_sym_where] = ACTIONS(4113),
    [anon_sym_QMARK] = ACTIONS(4126),
    [anon_sym_notnull] = ACTIONS(4113),
    [anon_sym_unmanaged] = ACTIONS(4113),
    [anon_sym_BANG] = ACTIONS(4126),
    [anon_sym_PLUS_PLUS] = ACTIONS(4120),
    [anon_sym_DASH_DASH] = ACTIONS(4120),
    [anon_sym_PLUS] = ACTIONS(4126),
    [anon_sym_DASH] = ACTIONS(4126),
    [anon_sym_STAR] = ACTIONS(4126),
    [anon_sym_SLASH] = ACTIONS(4126),
    [anon_sym_PERCENT] = ACTIONS(4126),
    [anon_sym_CARET] = ACTIONS(4126),
    [anon_sym_PIPE] = ACTIONS(4126),
    [anon_sym_AMP] = ACTIONS(4126),
    [anon_sym_LT_LT] = ACTIONS(4126),
    [anon_sym_GT_GT] = ACTIONS(4126),
    [anon_sym_GT_GT_GT] = ACTIONS(4126),
    [anon_sym_EQ_EQ] = ACTIONS(4120),
    [anon_sym_BANG_EQ] = ACTIONS(4120),
    [anon_sym_GT_EQ] = ACTIONS(4120),
    [anon_sym_LT_EQ] = ACTIONS(4120),
    [anon_sym_DOT] = ACTIONS(4126),
    [anon_sym_scoped] = ACTIONS(4113),
    [anon_sym_var] = ACTIONS(4113),
    [anon_sym_yield] = ACTIONS(4113),
    [anon_sym_switch] = ACTIONS(4126),
    [anon_sym_when] = ACTIONS(4113),
    [sym_discard] = ACTIONS(4113),
    [anon_sym_DOT_DOT] = ACTIONS(4120),
    [anon_sym_and] = ACTIONS(4130),
    [anon_sym_or] = ACTIONS(4130),
    [anon_sym_PLUS_EQ] = ACTIONS(4133),
    [anon_sym_DASH_EQ] = ACTIONS(4133),
    [anon_sym_STAR_EQ] = ACTIONS(4133),
    [anon_sym_SLASH_EQ] = ACTIONS(4133),
    [anon_sym_PERCENT_EQ] = ACTIONS(4133),
    [anon_sym_AMP_EQ] = ACTIONS(4133),
    [anon_sym_CARET_EQ] = ACTIONS(4133),
    [anon_sym_PIPE_EQ] = ACTIONS(4133),
    [anon_sym_LT_LT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4133),
    [anon_sym_AMP_AMP] = ACTIONS(4120),
    [anon_sym_PIPE_PIPE] = ACTIONS(4120),
    [anon_sym_QMARK_QMARK] = ACTIONS(4126),
    [anon_sym_from] = ACTIONS(4113),
    [anon_sym_into] = ACTIONS(4130),
    [anon_sym_join] = ACTIONS(4113),
    [anon_sym_on] = ACTIONS(4113),
    [anon_sym_equals] = ACTIONS(4130),
    [anon_sym_let] = ACTIONS(4113),
    [anon_sym_orderby] = ACTIONS(4113),
    [anon_sym_ascending] = ACTIONS(4113),
    [anon_sym_descending] = ACTIONS(4113),
    [anon_sym_group] = ACTIONS(4113),
    [anon_sym_by] = ACTIONS(4113),
    [anon_sym_select] = ACTIONS(4113),
    [anon_sym_as] = ACTIONS(4126),
    [anon_sym_is] = ACTIONS(4126),
    [anon_sym_DASH_GT] = ACTIONS(4120),
    [anon_sym_with] = ACTIONS(4126),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2907] = {
    [sym_preproc_region] = STATE(2907),
    [sym_preproc_endregion] = STATE(2907),
    [sym_preproc_line] = STATE(2907),
    [sym_preproc_pragma] = STATE(2907),
    [sym_preproc_nullable] = STATE(2907),
    [sym_preproc_error] = STATE(2907),
    [sym_preproc_define] = STATE(2907),
    [sym_preproc_undef] = STATE(2907),
    [sym__identifier_token] = ACTIONS(4436),
    [anon_sym_alias] = ACTIONS(4436),
    [anon_sym_SEMI] = ACTIONS(4438),
    [anon_sym_global] = ACTIONS(4436),
    [anon_sym_LBRACK] = ACTIONS(4438),
    [anon_sym_COLON] = ACTIONS(4438),
    [anon_sym_COMMA] = ACTIONS(4438),
    [anon_sym_RBRACK] = ACTIONS(4438),
    [anon_sym_LPAREN] = ACTIONS(4438),
    [anon_sym_RPAREN] = ACTIONS(4438),
    [anon_sym_LBRACE] = ACTIONS(4438),
    [anon_sym_RBRACE] = ACTIONS(4438),
    [anon_sym_file] = ACTIONS(4436),
    [anon_sym_LT] = ACTIONS(4436),
    [anon_sym_GT] = ACTIONS(4436),
    [anon_sym_in] = ACTIONS(4436),
    [anon_sym_where] = ACTIONS(4436),
    [anon_sym_QMARK] = ACTIONS(4436),
    [anon_sym_notnull] = ACTIONS(4436),
    [anon_sym_unmanaged] = ACTIONS(4436),
    [anon_sym_operator] = ACTIONS(4436),
    [anon_sym_BANG] = ACTIONS(4436),
    [anon_sym_PLUS_PLUS] = ACTIONS(4438),
    [anon_sym_DASH_DASH] = ACTIONS(4438),
    [anon_sym_PLUS] = ACTIONS(4436),
    [anon_sym_DASH] = ACTIONS(4436),
    [anon_sym_STAR] = ACTIONS(4438),
    [anon_sym_SLASH] = ACTIONS(4436),
    [anon_sym_PERCENT] = ACTIONS(4438),
    [anon_sym_CARET] = ACTIONS(4438),
    [anon_sym_PIPE] = ACTIONS(4436),
    [anon_sym_AMP] = ACTIONS(4436),
    [anon_sym_LT_LT] = ACTIONS(4438),
    [anon_sym_GT_GT] = ACTIONS(4436),
    [anon_sym_GT_GT_GT] = ACTIONS(4438),
    [anon_sym_EQ_EQ] = ACTIONS(4438),
    [anon_sym_BANG_EQ] = ACTIONS(4438),
    [anon_sym_GT_EQ] = ACTIONS(4438),
    [anon_sym_LT_EQ] = ACTIONS(4438),
    [anon_sym_this] = ACTIONS(4436),
    [anon_sym_DOT] = ACTIONS(4436),
    [anon_sym_scoped] = ACTIONS(4436),
    [anon_sym_EQ_GT] = ACTIONS(4438),
    [anon_sym_var] = ACTIONS(4436),
    [anon_sym_yield] = ACTIONS(4436),
    [anon_sym_switch] = ACTIONS(4436),
    [anon_sym_when] = ACTIONS(4436),
    [sym_discard] = ACTIONS(4436),
    [anon_sym_DOT_DOT] = ACTIONS(4438),
    [anon_sym_and] = ACTIONS(4436),
    [anon_sym_or] = ACTIONS(4436),
    [anon_sym_AMP_AMP] = ACTIONS(4438),
    [anon_sym_PIPE_PIPE] = ACTIONS(4438),
    [anon_sym_QMARK_QMARK] = ACTIONS(4438),
    [anon_sym_from] = ACTIONS(4436),
    [anon_sym_into] = ACTIONS(4436),
    [anon_sym_join] = ACTIONS(4436),
    [anon_sym_on] = ACTIONS(4436),
    [anon_sym_equals] = ACTIONS(4436),
    [anon_sym_let] = ACTIONS(4436),
    [anon_sym_orderby] = ACTIONS(4436),
    [anon_sym_ascending] = ACTIONS(4436),
    [anon_sym_descending] = ACTIONS(4436),
    [anon_sym_group] = ACTIONS(4436),
    [anon_sym_by] = ACTIONS(4436),
    [anon_sym_select] = ACTIONS(4436),
    [anon_sym_as] = ACTIONS(4436),
    [anon_sym_is] = ACTIONS(4436),
    [anon_sym_DASH_GT] = ACTIONS(4438),
    [anon_sym_with] = ACTIONS(4436),
    [aux_sym_preproc_if_token3] = ACTIONS(4438),
    [aux_sym_preproc_else_token1] = ACTIONS(4438),
    [aux_sym_preproc_elif_token1] = ACTIONS(4438),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2908] = {
    [sym_preproc_region] = STATE(2908),
    [sym_preproc_endregion] = STATE(2908),
    [sym_preproc_line] = STATE(2908),
    [sym_preproc_pragma] = STATE(2908),
    [sym_preproc_nullable] = STATE(2908),
    [sym_preproc_error] = STATE(2908),
    [sym_preproc_define] = STATE(2908),
    [sym_preproc_undef] = STATE(2908),
    [sym__identifier_token] = ACTIONS(4113),
    [anon_sym_alias] = ACTIONS(4113),
    [anon_sym_global] = ACTIONS(4113),
    [anon_sym_EQ] = ACTIONS(4118),
    [anon_sym_LBRACK] = ACTIONS(4135),
    [anon_sym_COMMA] = ACTIONS(4133),
    [anon_sym_LPAREN] = ACTIONS(4135),
    [anon_sym_file] = ACTIONS(4113),
    [anon_sym_LT] = ACTIONS(4118),
    [anon_sym_GT] = ACTIONS(4118),
    [anon_sym_where] = ACTIONS(4138),
    [anon_sym_QMARK] = ACTIONS(4138),
    [anon_sym_notnull] = ACTIONS(4113),
    [anon_sym_unmanaged] = ACTIONS(4113),
    [anon_sym_BANG] = ACTIONS(4118),
    [anon_sym_PLUS_PLUS] = ACTIONS(4133),
    [anon_sym_DASH_DASH] = ACTIONS(4133),
    [anon_sym_PLUS] = ACTIONS(4118),
    [anon_sym_DASH] = ACTIONS(4118),
    [anon_sym_STAR] = ACTIONS(4138),
    [anon_sym_SLASH] = ACTIONS(4118),
    [anon_sym_PERCENT] = ACTIONS(4118),
    [anon_sym_CARET] = ACTIONS(4118),
    [anon_sym_PIPE] = ACTIONS(4118),
    [anon_sym_AMP] = ACTIONS(4118),
    [anon_sym_LT_LT] = ACTIONS(4118),
    [anon_sym_GT_GT] = ACTIONS(4118),
    [anon_sym_GT_GT_GT] = ACTIONS(4118),
    [anon_sym_EQ_EQ] = ACTIONS(4133),
    [anon_sym_BANG_EQ] = ACTIONS(4133),
    [anon_sym_GT_EQ] = ACTIONS(4133),
    [anon_sym_LT_EQ] = ACTIONS(4133),
    [anon_sym_DOT] = ACTIONS(4138),
    [anon_sym_scoped] = ACTIONS(4113),
    [anon_sym_var] = ACTIONS(4113),
    [anon_sym_yield] = ACTIONS(4113),
    [anon_sym_switch] = ACTIONS(4118),
    [anon_sym_when] = ACTIONS(4113),
    [anon_sym_DOT_DOT] = ACTIONS(4133),
    [anon_sym_and] = ACTIONS(4118),
    [anon_sym_or] = ACTIONS(4118),
    [anon_sym_PLUS_EQ] = ACTIONS(4133),
    [anon_sym_DASH_EQ] = ACTIONS(4133),
    [anon_sym_STAR_EQ] = ACTIONS(4133),
    [anon_sym_SLASH_EQ] = ACTIONS(4133),
    [anon_sym_PERCENT_EQ] = ACTIONS(4133),
    [anon_sym_AMP_EQ] = ACTIONS(4133),
    [anon_sym_CARET_EQ] = ACTIONS(4133),
    [anon_sym_PIPE_EQ] = ACTIONS(4133),
    [anon_sym_LT_LT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4133),
    [anon_sym_AMP_AMP] = ACTIONS(4133),
    [anon_sym_PIPE_PIPE] = ACTIONS(4133),
    [anon_sym_QMARK_QMARK] = ACTIONS(4118),
    [anon_sym_from] = ACTIONS(4138),
    [anon_sym_into] = ACTIONS(4138),
    [anon_sym_join] = ACTIONS(4138),
    [anon_sym_on] = ACTIONS(4113),
    [anon_sym_equals] = ACTIONS(4113),
    [anon_sym_let] = ACTIONS(4138),
    [anon_sym_orderby] = ACTIONS(4138),
    [anon_sym_ascending] = ACTIONS(4138),
    [anon_sym_descending] = ACTIONS(4138),
    [anon_sym_group] = ACTIONS(4138),
    [anon_sym_by] = ACTIONS(4113),
    [anon_sym_select] = ACTIONS(4138),
    [anon_sym_as] = ACTIONS(4118),
    [anon_sym_is] = ACTIONS(4118),
    [anon_sym_DASH_GT] = ACTIONS(4135),
    [anon_sym_with] = ACTIONS(4118),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2909] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7127),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9545),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(2909),
    [sym_preproc_endregion] = STATE(2909),
    [sym_preproc_line] = STATE(2909),
    [sym_preproc_pragma] = STATE(2909),
    [sym_preproc_nullable] = STATE(2909),
    [sym_preproc_error] = STATE(2909),
    [sym_preproc_define] = STATE(2909),
    [sym_preproc_undef] = STATE(2909),
    [aux_sym_class_declaration_repeat1] = STATE(4333),
    [aux_sym_class_declaration_repeat2] = STATE(3112),
    [aux_sym_lambda_expression_repeat1] = STATE(4147),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_unsafe] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(4442),
    [anon_sym_fixed] = ACTIONS(643),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(643),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2910] = {
    [sym__name] = STATE(6087),
    [sym_alias_qualified_name] = STATE(3635),
    [sym__simple_name] = STATE(3635),
    [sym_qualified_name] = STATE(3635),
    [sym_generic_name] = STATE(3708),
    [sym_ref_type] = STATE(3636),
    [sym__scoped_base_type] = STATE(3641),
    [sym_identifier] = STATE(5332),
    [sym__reserved_identifier] = STATE(3568),
    [sym_preproc_region] = STATE(2910),
    [sym_preproc_endregion] = STATE(2910),
    [sym_preproc_line] = STATE(2910),
    [sym_preproc_pragma] = STATE(2910),
    [sym_preproc_nullable] = STATE(2910),
    [sym_preproc_error] = STATE(2910),
    [sym_preproc_define] = STATE(2910),
    [sym_preproc_undef] = STATE(2910),
    [sym__identifier_token] = ACTIONS(4287),
    [anon_sym_alias] = ACTIONS(4289),
    [anon_sym_global] = ACTIONS(4289),
    [anon_sym_LBRACK] = ACTIONS(3719),
    [anon_sym_COLON] = ACTIONS(3721),
    [anon_sym_COMMA] = ACTIONS(3719),
    [anon_sym_LPAREN] = ACTIONS(3719),
    [anon_sym_RPAREN] = ACTIONS(3719),
    [anon_sym_ref] = ACTIONS(4444),
    [anon_sym_LBRACE] = ACTIONS(3719),
    [anon_sym_RBRACE] = ACTIONS(3719),
    [anon_sym_file] = ACTIONS(4289),
    [anon_sym_LT] = ACTIONS(3721),
    [anon_sym_GT] = ACTIONS(3721),
    [anon_sym_where] = ACTIONS(4289),
    [anon_sym_QMARK] = ACTIONS(3721),
    [anon_sym_notnull] = ACTIONS(4289),
    [anon_sym_unmanaged] = ACTIONS(4289),
    [anon_sym_BANG] = ACTIONS(3721),
    [anon_sym_PLUS_PLUS] = ACTIONS(3719),
    [anon_sym_DASH_DASH] = ACTIONS(3719),
    [anon_sym_PLUS] = ACTIONS(3721),
    [anon_sym_DASH] = ACTIONS(3721),
    [anon_sym_STAR] = ACTIONS(3719),
    [anon_sym_SLASH] = ACTIONS(3721),
    [anon_sym_PERCENT] = ACTIONS(3719),
    [anon_sym_CARET] = ACTIONS(3719),
    [anon_sym_PIPE] = ACTIONS(3721),
    [anon_sym_AMP] = ACTIONS(3721),
    [anon_sym_LT_LT] = ACTIONS(3719),
    [anon_sym_GT_GT] = ACTIONS(3721),
    [anon_sym_GT_GT_GT] = ACTIONS(3719),
    [anon_sym_EQ_EQ] = ACTIONS(3719),
    [anon_sym_BANG_EQ] = ACTIONS(3719),
    [anon_sym_GT_EQ] = ACTIONS(3719),
    [anon_sym_LT_EQ] = ACTIONS(3719),
    [anon_sym_DOT] = ACTIONS(3721),
    [anon_sym_scoped] = ACTIONS(4289),
    [anon_sym_COLON_COLON] = ACTIONS(3719),
    [anon_sym_var] = ACTIONS(4289),
    [anon_sym_yield] = ACTIONS(4289),
    [anon_sym_switch] = ACTIONS(3721),
    [anon_sym_when] = ACTIONS(4289),
    [anon_sym_DOT_DOT] = ACTIONS(3719),
    [anon_sym_AMP_AMP] = ACTIONS(3719),
    [anon_sym_PIPE_PIPE] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK] = ACTIONS(3719),
    [anon_sym_from] = ACTIONS(4289),
    [anon_sym_into] = ACTIONS(4289),
    [anon_sym_join] = ACTIONS(4289),
    [anon_sym_on] = ACTIONS(4289),
    [anon_sym_equals] = ACTIONS(4289),
    [anon_sym_let] = ACTIONS(4289),
    [anon_sym_orderby] = ACTIONS(4289),
    [anon_sym_ascending] = ACTIONS(4289),
    [anon_sym_descending] = ACTIONS(4289),
    [anon_sym_group] = ACTIONS(4289),
    [anon_sym_by] = ACTIONS(4289),
    [anon_sym_select] = ACTIONS(4289),
    [anon_sym_as] = ACTIONS(3721),
    [anon_sym_is] = ACTIONS(3721),
    [anon_sym_DASH_GT] = ACTIONS(3719),
    [anon_sym_with] = ACTIONS(3721),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2911] = {
    [sym_preproc_region] = STATE(2911),
    [sym_preproc_endregion] = STATE(2911),
    [sym_preproc_line] = STATE(2911),
    [sym_preproc_pragma] = STATE(2911),
    [sym_preproc_nullable] = STATE(2911),
    [sym_preproc_error] = STATE(2911),
    [sym_preproc_define] = STATE(2911),
    [sym_preproc_undef] = STATE(2911),
    [sym__identifier_token] = ACTIONS(4113),
    [anon_sym_alias] = ACTIONS(4113),
    [anon_sym_global] = ACTIONS(4113),
    [anon_sym_EQ] = ACTIONS(4118),
    [anon_sym_LBRACK] = ACTIONS(4135),
    [anon_sym_COMMA] = ACTIONS(4133),
    [anon_sym_LPAREN] = ACTIONS(4135),
    [anon_sym_file] = ACTIONS(4113),
    [anon_sym_LT] = ACTIONS(4118),
    [anon_sym_GT] = ACTIONS(4118),
    [anon_sym_where] = ACTIONS(4138),
    [anon_sym_QMARK] = ACTIONS(4138),
    [anon_sym_notnull] = ACTIONS(4113),
    [anon_sym_unmanaged] = ACTIONS(4113),
    [anon_sym_BANG] = ACTIONS(4118),
    [anon_sym_PLUS_PLUS] = ACTIONS(4133),
    [anon_sym_DASH_DASH] = ACTIONS(4133),
    [anon_sym_PLUS] = ACTIONS(4118),
    [anon_sym_DASH] = ACTIONS(4118),
    [anon_sym_STAR] = ACTIONS(4138),
    [anon_sym_SLASH] = ACTIONS(4118),
    [anon_sym_PERCENT] = ACTIONS(4118),
    [anon_sym_CARET] = ACTIONS(4118),
    [anon_sym_PIPE] = ACTIONS(4118),
    [anon_sym_AMP] = ACTIONS(4118),
    [anon_sym_LT_LT] = ACTIONS(4118),
    [anon_sym_GT_GT] = ACTIONS(4118),
    [anon_sym_GT_GT_GT] = ACTIONS(4118),
    [anon_sym_EQ_EQ] = ACTIONS(4133),
    [anon_sym_BANG_EQ] = ACTIONS(4133),
    [anon_sym_GT_EQ] = ACTIONS(4133),
    [anon_sym_LT_EQ] = ACTIONS(4133),
    [anon_sym_DOT] = ACTIONS(4138),
    [anon_sym_scoped] = ACTIONS(4113),
    [anon_sym_var] = ACTIONS(4113),
    [anon_sym_yield] = ACTIONS(4113),
    [anon_sym_switch] = ACTIONS(4118),
    [anon_sym_when] = ACTIONS(4113),
    [anon_sym_DOT_DOT] = ACTIONS(4133),
    [anon_sym_and] = ACTIONS(4118),
    [anon_sym_or] = ACTIONS(4118),
    [anon_sym_PLUS_EQ] = ACTIONS(4133),
    [anon_sym_DASH_EQ] = ACTIONS(4133),
    [anon_sym_STAR_EQ] = ACTIONS(4133),
    [anon_sym_SLASH_EQ] = ACTIONS(4133),
    [anon_sym_PERCENT_EQ] = ACTIONS(4133),
    [anon_sym_AMP_EQ] = ACTIONS(4133),
    [anon_sym_CARET_EQ] = ACTIONS(4133),
    [anon_sym_PIPE_EQ] = ACTIONS(4133),
    [anon_sym_LT_LT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4133),
    [anon_sym_AMP_AMP] = ACTIONS(4133),
    [anon_sym_PIPE_PIPE] = ACTIONS(4133),
    [anon_sym_QMARK_QMARK] = ACTIONS(4118),
    [anon_sym_from] = ACTIONS(4138),
    [anon_sym_into] = ACTIONS(4113),
    [anon_sym_join] = ACTIONS(4138),
    [anon_sym_on] = ACTIONS(4113),
    [anon_sym_equals] = ACTIONS(4113),
    [anon_sym_let] = ACTIONS(4138),
    [anon_sym_orderby] = ACTIONS(4138),
    [anon_sym_ascending] = ACTIONS(4138),
    [anon_sym_descending] = ACTIONS(4138),
    [anon_sym_group] = ACTIONS(4138),
    [anon_sym_by] = ACTIONS(4113),
    [anon_sym_select] = ACTIONS(4138),
    [anon_sym_as] = ACTIONS(4118),
    [anon_sym_is] = ACTIONS(4118),
    [anon_sym_DASH_GT] = ACTIONS(4135),
    [anon_sym_with] = ACTIONS(4118),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2912] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7053),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9081),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(2912),
    [sym_preproc_endregion] = STATE(2912),
    [sym_preproc_line] = STATE(2912),
    [sym_preproc_pragma] = STATE(2912),
    [sym_preproc_nullable] = STATE(2912),
    [sym_preproc_error] = STATE(2912),
    [sym_preproc_define] = STATE(2912),
    [sym_preproc_undef] = STATE(2912),
    [aux_sym_class_declaration_repeat1] = STATE(4333),
    [aux_sym_class_declaration_repeat2] = STATE(3122),
    [aux_sym_lambda_expression_repeat1] = STATE(4158),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_unsafe] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(4442),
    [anon_sym_fixed] = ACTIONS(643),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(643),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2913] = {
    [sym_type_argument_list] = STATE(2943),
    [sym_preproc_region] = STATE(2913),
    [sym_preproc_endregion] = STATE(2913),
    [sym_preproc_line] = STATE(2913),
    [sym_preproc_pragma] = STATE(2913),
    [sym_preproc_nullable] = STATE(2913),
    [sym_preproc_error] = STATE(2913),
    [sym_preproc_define] = STATE(2913),
    [sym_preproc_undef] = STATE(2913),
    [sym__identifier_token] = ACTIONS(4074),
    [anon_sym_alias] = ACTIONS(4074),
    [anon_sym_SEMI] = ACTIONS(4076),
    [anon_sym_global] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4076),
    [anon_sym_COMMA] = ACTIONS(4076),
    [anon_sym_RBRACK] = ACTIONS(4076),
    [anon_sym_LPAREN] = ACTIONS(4076),
    [anon_sym_RPAREN] = ACTIONS(4076),
    [anon_sym_LBRACE] = ACTIONS(4076),
    [anon_sym_RBRACE] = ACTIONS(4076),
    [anon_sym_file] = ACTIONS(4074),
    [anon_sym_LT] = ACTIONS(4446),
    [anon_sym_GT] = ACTIONS(4074),
    [anon_sym_in] = ACTIONS(4074),
    [anon_sym_where] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(4074),
    [anon_sym_notnull] = ACTIONS(4074),
    [anon_sym_unmanaged] = ACTIONS(4074),
    [anon_sym_BANG] = ACTIONS(4074),
    [anon_sym_PLUS_PLUS] = ACTIONS(4076),
    [anon_sym_DASH_DASH] = ACTIONS(4076),
    [anon_sym_PLUS] = ACTIONS(4074),
    [anon_sym_DASH] = ACTIONS(4074),
    [anon_sym_STAR] = ACTIONS(4076),
    [anon_sym_SLASH] = ACTIONS(4074),
    [anon_sym_PERCENT] = ACTIONS(4076),
    [anon_sym_CARET] = ACTIONS(4076),
    [anon_sym_PIPE] = ACTIONS(4074),
    [anon_sym_AMP] = ACTIONS(4074),
    [anon_sym_LT_LT] = ACTIONS(4076),
    [anon_sym_GT_GT] = ACTIONS(4074),
    [anon_sym_GT_GT_GT] = ACTIONS(4076),
    [anon_sym_EQ_EQ] = ACTIONS(4076),
    [anon_sym_BANG_EQ] = ACTIONS(4076),
    [anon_sym_GT_EQ] = ACTIONS(4076),
    [anon_sym_LT_EQ] = ACTIONS(4076),
    [anon_sym_DOT] = ACTIONS(4074),
    [anon_sym_scoped] = ACTIONS(4074),
    [anon_sym_EQ_GT] = ACTIONS(4076),
    [anon_sym_COLON_COLON] = ACTIONS(4089),
    [anon_sym_var] = ACTIONS(4074),
    [anon_sym_yield] = ACTIONS(4074),
    [anon_sym_switch] = ACTIONS(4074),
    [anon_sym_when] = ACTIONS(4074),
    [sym_discard] = ACTIONS(4074),
    [anon_sym_DOT_DOT] = ACTIONS(4076),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_AMP_AMP] = ACTIONS(4076),
    [anon_sym_PIPE_PIPE] = ACTIONS(4076),
    [anon_sym_QMARK_QMARK] = ACTIONS(4076),
    [anon_sym_from] = ACTIONS(4074),
    [anon_sym_into] = ACTIONS(4074),
    [anon_sym_join] = ACTIONS(4074),
    [anon_sym_on] = ACTIONS(4074),
    [anon_sym_equals] = ACTIONS(4074),
    [anon_sym_let] = ACTIONS(4074),
    [anon_sym_orderby] = ACTIONS(4074),
    [anon_sym_ascending] = ACTIONS(4074),
    [anon_sym_descending] = ACTIONS(4074),
    [anon_sym_group] = ACTIONS(4074),
    [anon_sym_by] = ACTIONS(4074),
    [anon_sym_select] = ACTIONS(4074),
    [anon_sym_as] = ACTIONS(4074),
    [anon_sym_is] = ACTIONS(4074),
    [anon_sym_DASH_GT] = ACTIONS(4076),
    [anon_sym_with] = ACTIONS(4074),
    [aux_sym_preproc_if_token3] = ACTIONS(4076),
    [aux_sym_preproc_else_token1] = ACTIONS(4076),
    [aux_sym_preproc_elif_token1] = ACTIONS(4076),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2914] = {
    [sym_preproc_region] = STATE(2914),
    [sym_preproc_endregion] = STATE(2914),
    [sym_preproc_line] = STATE(2914),
    [sym_preproc_pragma] = STATE(2914),
    [sym_preproc_nullable] = STATE(2914),
    [sym_preproc_error] = STATE(2914),
    [sym_preproc_define] = STATE(2914),
    [sym_preproc_undef] = STATE(2914),
    [sym__identifier_token] = ACTIONS(4056),
    [anon_sym_alias] = ACTIONS(4056),
    [anon_sym_SEMI] = ACTIONS(4058),
    [anon_sym_global] = ACTIONS(4056),
    [anon_sym_LBRACK] = ACTIONS(4058),
    [anon_sym_COLON] = ACTIONS(4056),
    [anon_sym_COMMA] = ACTIONS(4058),
    [anon_sym_RBRACK] = ACTIONS(4058),
    [anon_sym_LPAREN] = ACTIONS(4058),
    [anon_sym_RPAREN] = ACTIONS(4058),
    [anon_sym_LBRACE] = ACTIONS(4058),
    [anon_sym_RBRACE] = ACTIONS(4058),
    [anon_sym_file] = ACTIONS(4056),
    [anon_sym_LT] = ACTIONS(4056),
    [anon_sym_GT] = ACTIONS(4056),
    [anon_sym_in] = ACTIONS(4056),
    [anon_sym_where] = ACTIONS(4056),
    [anon_sym_QMARK] = ACTIONS(4056),
    [anon_sym_notnull] = ACTIONS(4056),
    [anon_sym_unmanaged] = ACTIONS(4056),
    [anon_sym_BANG] = ACTIONS(4056),
    [anon_sym_PLUS_PLUS] = ACTIONS(4058),
    [anon_sym_DASH_DASH] = ACTIONS(4058),
    [anon_sym_PLUS] = ACTIONS(4056),
    [anon_sym_DASH] = ACTIONS(4056),
    [anon_sym_STAR] = ACTIONS(4058),
    [anon_sym_SLASH] = ACTIONS(4056),
    [anon_sym_PERCENT] = ACTIONS(4058),
    [anon_sym_CARET] = ACTIONS(4058),
    [anon_sym_PIPE] = ACTIONS(4056),
    [anon_sym_AMP] = ACTIONS(4056),
    [anon_sym_LT_LT] = ACTIONS(4058),
    [anon_sym_GT_GT] = ACTIONS(4056),
    [anon_sym_GT_GT_GT] = ACTIONS(4058),
    [anon_sym_EQ_EQ] = ACTIONS(4058),
    [anon_sym_BANG_EQ] = ACTIONS(4058),
    [anon_sym_GT_EQ] = ACTIONS(4058),
    [anon_sym_LT_EQ] = ACTIONS(4058),
    [anon_sym_DOT] = ACTIONS(4056),
    [anon_sym_scoped] = ACTIONS(4056),
    [anon_sym_EQ_GT] = ACTIONS(4058),
    [anon_sym_COLON_COLON] = ACTIONS(4058),
    [anon_sym_var] = ACTIONS(4056),
    [anon_sym_yield] = ACTIONS(4056),
    [anon_sym_switch] = ACTIONS(4056),
    [anon_sym_when] = ACTIONS(4056),
    [sym_discard] = ACTIONS(4056),
    [anon_sym_DOT_DOT] = ACTIONS(4058),
    [anon_sym_and] = ACTIONS(4056),
    [anon_sym_or] = ACTIONS(4056),
    [anon_sym_AMP_AMP] = ACTIONS(4058),
    [anon_sym_PIPE_PIPE] = ACTIONS(4058),
    [anon_sym_QMARK_QMARK] = ACTIONS(4058),
    [anon_sym_from] = ACTIONS(4056),
    [anon_sym_into] = ACTIONS(4056),
    [anon_sym_join] = ACTIONS(4056),
    [anon_sym_on] = ACTIONS(4056),
    [anon_sym_equals] = ACTIONS(4056),
    [anon_sym_let] = ACTIONS(4056),
    [anon_sym_orderby] = ACTIONS(4056),
    [anon_sym_ascending] = ACTIONS(4056),
    [anon_sym_descending] = ACTIONS(4056),
    [anon_sym_group] = ACTIONS(4056),
    [anon_sym_by] = ACTIONS(4056),
    [anon_sym_select] = ACTIONS(4056),
    [anon_sym_as] = ACTIONS(4056),
    [anon_sym_is] = ACTIONS(4056),
    [anon_sym_DASH_GT] = ACTIONS(4058),
    [anon_sym_with] = ACTIONS(4056),
    [aux_sym_preproc_if_token3] = ACTIONS(4058),
    [aux_sym_preproc_else_token1] = ACTIONS(4058),
    [aux_sym_preproc_elif_token1] = ACTIONS(4058),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2915] = {
    [sym_preproc_region] = STATE(2915),
    [sym_preproc_endregion] = STATE(2915),
    [sym_preproc_line] = STATE(2915),
    [sym_preproc_pragma] = STATE(2915),
    [sym_preproc_nullable] = STATE(2915),
    [sym_preproc_error] = STATE(2915),
    [sym_preproc_define] = STATE(2915),
    [sym_preproc_undef] = STATE(2915),
    [sym__identifier_token] = ACTIONS(3721),
    [anon_sym_alias] = ACTIONS(3721),
    [anon_sym_SEMI] = ACTIONS(3719),
    [anon_sym_global] = ACTIONS(3721),
    [anon_sym_LBRACK] = ACTIONS(3719),
    [anon_sym_COLON] = ACTIONS(3721),
    [anon_sym_COMMA] = ACTIONS(3719),
    [anon_sym_RBRACK] = ACTIONS(3719),
    [anon_sym_LPAREN] = ACTIONS(3719),
    [anon_sym_RPAREN] = ACTIONS(3719),
    [anon_sym_LBRACE] = ACTIONS(3719),
    [anon_sym_RBRACE] = ACTIONS(3719),
    [anon_sym_file] = ACTIONS(3721),
    [anon_sym_LT] = ACTIONS(3721),
    [anon_sym_GT] = ACTIONS(3721),
    [anon_sym_in] = ACTIONS(3721),
    [anon_sym_where] = ACTIONS(3721),
    [anon_sym_QMARK] = ACTIONS(3721),
    [anon_sym_notnull] = ACTIONS(3721),
    [anon_sym_unmanaged] = ACTIONS(3721),
    [anon_sym_BANG] = ACTIONS(3721),
    [anon_sym_PLUS_PLUS] = ACTIONS(3719),
    [anon_sym_DASH_DASH] = ACTIONS(3719),
    [anon_sym_PLUS] = ACTIONS(3721),
    [anon_sym_DASH] = ACTIONS(3721),
    [anon_sym_STAR] = ACTIONS(3719),
    [anon_sym_SLASH] = ACTIONS(3721),
    [anon_sym_PERCENT] = ACTIONS(3719),
    [anon_sym_CARET] = ACTIONS(3719),
    [anon_sym_PIPE] = ACTIONS(3721),
    [anon_sym_AMP] = ACTIONS(3721),
    [anon_sym_LT_LT] = ACTIONS(3719),
    [anon_sym_GT_GT] = ACTIONS(3721),
    [anon_sym_GT_GT_GT] = ACTIONS(3719),
    [anon_sym_EQ_EQ] = ACTIONS(3719),
    [anon_sym_BANG_EQ] = ACTIONS(3719),
    [anon_sym_GT_EQ] = ACTIONS(3719),
    [anon_sym_LT_EQ] = ACTIONS(3719),
    [anon_sym_DOT] = ACTIONS(3721),
    [anon_sym_scoped] = ACTIONS(3721),
    [anon_sym_EQ_GT] = ACTIONS(3719),
    [anon_sym_COLON_COLON] = ACTIONS(3719),
    [anon_sym_var] = ACTIONS(3721),
    [anon_sym_yield] = ACTIONS(3721),
    [anon_sym_switch] = ACTIONS(3721),
    [anon_sym_when] = ACTIONS(3721),
    [sym_discard] = ACTIONS(3721),
    [anon_sym_DOT_DOT] = ACTIONS(3719),
    [anon_sym_and] = ACTIONS(3721),
    [anon_sym_or] = ACTIONS(3721),
    [anon_sym_AMP_AMP] = ACTIONS(3719),
    [anon_sym_PIPE_PIPE] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK] = ACTIONS(3719),
    [anon_sym_from] = ACTIONS(3721),
    [anon_sym_into] = ACTIONS(3721),
    [anon_sym_join] = ACTIONS(3721),
    [anon_sym_on] = ACTIONS(3721),
    [anon_sym_equals] = ACTIONS(3721),
    [anon_sym_let] = ACTIONS(3721),
    [anon_sym_orderby] = ACTIONS(3721),
    [anon_sym_ascending] = ACTIONS(3721),
    [anon_sym_descending] = ACTIONS(3721),
    [anon_sym_group] = ACTIONS(3721),
    [anon_sym_by] = ACTIONS(3721),
    [anon_sym_select] = ACTIONS(3721),
    [anon_sym_as] = ACTIONS(3721),
    [anon_sym_is] = ACTIONS(3721),
    [anon_sym_DASH_GT] = ACTIONS(3719),
    [anon_sym_with] = ACTIONS(3721),
    [aux_sym_preproc_if_token3] = ACTIONS(3719),
    [aux_sym_preproc_else_token1] = ACTIONS(3719),
    [aux_sym_preproc_elif_token1] = ACTIONS(3719),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2916] = {
    [sym_modifier] = STATE(3780),
    [sym_variable_declaration] = STATE(9571),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(6956),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_identifier] = STATE(4921),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(2916),
    [sym_preproc_endregion] = STATE(2916),
    [sym_preproc_line] = STATE(2916),
    [sym_preproc_pragma] = STATE(2916),
    [sym_preproc_nullable] = STATE(2916),
    [sym_preproc_error] = STATE(2916),
    [sym_preproc_define] = STATE(2916),
    [sym_preproc_undef] = STATE(2916),
    [aux_sym_class_declaration_repeat2] = STATE(3757),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_unsafe] = ACTIONS(63),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(2995),
    [anon_sym_class] = ACTIONS(4311),
    [anon_sym_ref] = ACTIONS(4313),
    [anon_sym_struct] = ACTIONS(2691),
    [anon_sym_enum] = ACTIONS(4315),
    [anon_sym_interface] = ACTIONS(4317),
    [anon_sym_delegate] = ACTIONS(4319),
    [anon_sym_record] = ACTIONS(4321),
    [anon_sym_abstract] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_file] = ACTIONS(3015),
    [anon_sym_fixed] = ACTIONS(63),
    [anon_sym_internal] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(63),
    [anon_sym_override] = ACTIONS(63),
    [anon_sym_partial] = ACTIONS(63),
    [anon_sym_private] = ACTIONS(63),
    [anon_sym_protected] = ACTIONS(63),
    [anon_sym_public] = ACTIONS(63),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_required] = ACTIONS(63),
    [anon_sym_sealed] = ACTIONS(63),
    [anon_sym_virtual] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2917] = {
    [sym_preproc_region] = STATE(2917),
    [sym_preproc_endregion] = STATE(2917),
    [sym_preproc_line] = STATE(2917),
    [sym_preproc_pragma] = STATE(2917),
    [sym_preproc_nullable] = STATE(2917),
    [sym_preproc_error] = STATE(2917),
    [sym_preproc_define] = STATE(2917),
    [sym_preproc_undef] = STATE(2917),
    [sym__identifier_token] = ACTIONS(4027),
    [anon_sym_alias] = ACTIONS(4027),
    [anon_sym_SEMI] = ACTIONS(4024),
    [anon_sym_global] = ACTIONS(4027),
    [anon_sym_LBRACK] = ACTIONS(4024),
    [anon_sym_COLON] = ACTIONS(4027),
    [anon_sym_COMMA] = ACTIONS(4024),
    [anon_sym_RBRACK] = ACTIONS(4024),
    [anon_sym_LPAREN] = ACTIONS(4024),
    [anon_sym_RPAREN] = ACTIONS(4024),
    [anon_sym_LBRACE] = ACTIONS(4024),
    [anon_sym_RBRACE] = ACTIONS(4024),
    [anon_sym_file] = ACTIONS(4027),
    [anon_sym_LT] = ACTIONS(4027),
    [anon_sym_GT] = ACTIONS(4027),
    [anon_sym_in] = ACTIONS(4027),
    [anon_sym_where] = ACTIONS(4027),
    [anon_sym_QMARK] = ACTIONS(4027),
    [anon_sym_notnull] = ACTIONS(4027),
    [anon_sym_unmanaged] = ACTIONS(4027),
    [anon_sym_BANG] = ACTIONS(4027),
    [anon_sym_PLUS_PLUS] = ACTIONS(4024),
    [anon_sym_DASH_DASH] = ACTIONS(4024),
    [anon_sym_PLUS] = ACTIONS(4027),
    [anon_sym_DASH] = ACTIONS(4027),
    [anon_sym_STAR] = ACTIONS(4024),
    [anon_sym_SLASH] = ACTIONS(4027),
    [anon_sym_PERCENT] = ACTIONS(4024),
    [anon_sym_CARET] = ACTIONS(4024),
    [anon_sym_PIPE] = ACTIONS(4027),
    [anon_sym_AMP] = ACTIONS(4027),
    [anon_sym_LT_LT] = ACTIONS(4024),
    [anon_sym_GT_GT] = ACTIONS(4027),
    [anon_sym_GT_GT_GT] = ACTIONS(4024),
    [anon_sym_EQ_EQ] = ACTIONS(4024),
    [anon_sym_BANG_EQ] = ACTIONS(4024),
    [anon_sym_GT_EQ] = ACTIONS(4024),
    [anon_sym_LT_EQ] = ACTIONS(4024),
    [anon_sym_DOT] = ACTIONS(4027),
    [anon_sym_scoped] = ACTIONS(4027),
    [anon_sym_EQ_GT] = ACTIONS(4024),
    [anon_sym_COLON_COLON] = ACTIONS(3719),
    [anon_sym_var] = ACTIONS(4027),
    [anon_sym_yield] = ACTIONS(4027),
    [anon_sym_switch] = ACTIONS(4027),
    [anon_sym_when] = ACTIONS(4027),
    [sym_discard] = ACTIONS(4027),
    [anon_sym_DOT_DOT] = ACTIONS(4024),
    [anon_sym_and] = ACTIONS(4027),
    [anon_sym_or] = ACTIONS(4027),
    [anon_sym_AMP_AMP] = ACTIONS(4024),
    [anon_sym_PIPE_PIPE] = ACTIONS(4024),
    [anon_sym_QMARK_QMARK] = ACTIONS(4024),
    [anon_sym_from] = ACTIONS(4027),
    [anon_sym_into] = ACTIONS(4027),
    [anon_sym_join] = ACTIONS(4027),
    [anon_sym_on] = ACTIONS(4027),
    [anon_sym_equals] = ACTIONS(4027),
    [anon_sym_let] = ACTIONS(4027),
    [anon_sym_orderby] = ACTIONS(4027),
    [anon_sym_ascending] = ACTIONS(4027),
    [anon_sym_descending] = ACTIONS(4027),
    [anon_sym_group] = ACTIONS(4027),
    [anon_sym_by] = ACTIONS(4027),
    [anon_sym_select] = ACTIONS(4027),
    [anon_sym_as] = ACTIONS(4027),
    [anon_sym_is] = ACTIONS(4027),
    [anon_sym_DASH_GT] = ACTIONS(4024),
    [anon_sym_with] = ACTIONS(4027),
    [aux_sym_preproc_if_token3] = ACTIONS(4024),
    [aux_sym_preproc_else_token1] = ACTIONS(4024),
    [aux_sym_preproc_elif_token1] = ACTIONS(4024),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2918] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7049),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9545),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(2918),
    [sym_preproc_endregion] = STATE(2918),
    [sym_preproc_line] = STATE(2918),
    [sym_preproc_pragma] = STATE(2918),
    [sym_preproc_nullable] = STATE(2918),
    [sym_preproc_error] = STATE(2918),
    [sym_preproc_define] = STATE(2918),
    [sym_preproc_undef] = STATE(2918),
    [aux_sym_class_declaration_repeat1] = STATE(4333),
    [aux_sym_class_declaration_repeat2] = STATE(3122),
    [aux_sym_lambda_expression_repeat1] = STATE(4147),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_unsafe] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(4442),
    [anon_sym_fixed] = ACTIONS(643),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(643),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2919] = {
    [sym_preproc_region] = STATE(2919),
    [sym_preproc_endregion] = STATE(2919),
    [sym_preproc_line] = STATE(2919),
    [sym_preproc_pragma] = STATE(2919),
    [sym_preproc_nullable] = STATE(2919),
    [sym_preproc_error] = STATE(2919),
    [sym_preproc_define] = STATE(2919),
    [sym_preproc_undef] = STATE(2919),
    [sym__identifier_token] = ACTIONS(4099),
    [anon_sym_alias] = ACTIONS(4099),
    [anon_sym_global] = ACTIONS(4099),
    [anon_sym_EQ] = ACTIONS(4104),
    [anon_sym_LBRACK] = ACTIONS(4101),
    [anon_sym_COMMA] = ACTIONS(4111),
    [anon_sym_LPAREN] = ACTIONS(4101),
    [anon_sym_file] = ACTIONS(4099),
    [anon_sym_LT] = ACTIONS(4104),
    [anon_sym_GT] = ACTIONS(4104),
    [anon_sym_where] = ACTIONS(4108),
    [anon_sym_QMARK] = ACTIONS(4108),
    [anon_sym_notnull] = ACTIONS(4099),
    [anon_sym_unmanaged] = ACTIONS(4099),
    [anon_sym_BANG] = ACTIONS(4104),
    [anon_sym_PLUS_PLUS] = ACTIONS(4111),
    [anon_sym_DASH_DASH] = ACTIONS(4111),
    [anon_sym_PLUS] = ACTIONS(4104),
    [anon_sym_DASH] = ACTIONS(4104),
    [anon_sym_STAR] = ACTIONS(4108),
    [anon_sym_SLASH] = ACTIONS(4104),
    [anon_sym_PERCENT] = ACTIONS(4104),
    [anon_sym_CARET] = ACTIONS(4104),
    [anon_sym_PIPE] = ACTIONS(4104),
    [anon_sym_AMP] = ACTIONS(4104),
    [anon_sym_LT_LT] = ACTIONS(4104),
    [anon_sym_GT_GT] = ACTIONS(4104),
    [anon_sym_GT_GT_GT] = ACTIONS(4104),
    [anon_sym_EQ_EQ] = ACTIONS(4111),
    [anon_sym_BANG_EQ] = ACTIONS(4111),
    [anon_sym_GT_EQ] = ACTIONS(4111),
    [anon_sym_LT_EQ] = ACTIONS(4111),
    [anon_sym_DOT] = ACTIONS(4108),
    [anon_sym_scoped] = ACTIONS(4099),
    [anon_sym_var] = ACTIONS(4099),
    [anon_sym_yield] = ACTIONS(4099),
    [anon_sym_switch] = ACTIONS(4104),
    [anon_sym_when] = ACTIONS(4099),
    [anon_sym_DOT_DOT] = ACTIONS(4111),
    [anon_sym_and] = ACTIONS(4104),
    [anon_sym_or] = ACTIONS(4104),
    [anon_sym_PLUS_EQ] = ACTIONS(4111),
    [anon_sym_DASH_EQ] = ACTIONS(4111),
    [anon_sym_STAR_EQ] = ACTIONS(4111),
    [anon_sym_SLASH_EQ] = ACTIONS(4111),
    [anon_sym_PERCENT_EQ] = ACTIONS(4111),
    [anon_sym_AMP_EQ] = ACTIONS(4111),
    [anon_sym_CARET_EQ] = ACTIONS(4111),
    [anon_sym_PIPE_EQ] = ACTIONS(4111),
    [anon_sym_LT_LT_EQ] = ACTIONS(4111),
    [anon_sym_GT_GT_EQ] = ACTIONS(4111),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4111),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4111),
    [anon_sym_AMP_AMP] = ACTIONS(4111),
    [anon_sym_PIPE_PIPE] = ACTIONS(4111),
    [anon_sym_QMARK_QMARK] = ACTIONS(4104),
    [anon_sym_from] = ACTIONS(4108),
    [anon_sym_into] = ACTIONS(4099),
    [anon_sym_join] = ACTIONS(4108),
    [anon_sym_on] = ACTIONS(4099),
    [anon_sym_equals] = ACTIONS(4099),
    [anon_sym_let] = ACTIONS(4108),
    [anon_sym_orderby] = ACTIONS(4108),
    [anon_sym_ascending] = ACTIONS(4108),
    [anon_sym_descending] = ACTIONS(4108),
    [anon_sym_group] = ACTIONS(4108),
    [anon_sym_by] = ACTIONS(4099),
    [anon_sym_select] = ACTIONS(4108),
    [anon_sym_as] = ACTIONS(4104),
    [anon_sym_is] = ACTIONS(4104),
    [anon_sym_DASH_GT] = ACTIONS(4101),
    [anon_sym_with] = ACTIONS(4104),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2920] = {
    [sym_argument_list] = STATE(3572),
    [sym__name] = STATE(3770),
    [sym_alias_qualified_name] = STATE(3635),
    [sym__simple_name] = STATE(3635),
    [sym_qualified_name] = STATE(3635),
    [sym_generic_name] = STATE(3708),
    [sym_type] = STATE(4257),
    [sym_implicit_type] = STATE(3706),
    [sym_array_type] = STATE(3601),
    [sym__array_base_type] = STATE(8888),
    [sym_nullable_type] = STATE(3618),
    [sym_pointer_type] = STATE(3618),
    [sym__pointer_base_type] = STATE(9386),
    [sym_function_pointer_type] = STATE(3618),
    [sym_ref_type] = STATE(3706),
    [sym_scoped_type] = STATE(3706),
    [sym_tuple_type] = STATE(3633),
    [sym_identifier] = STATE(3590),
    [sym__reserved_identifier] = STATE(3568),
    [sym_preproc_region] = STATE(2920),
    [sym_preproc_endregion] = STATE(2920),
    [sym_preproc_line] = STATE(2920),
    [sym_preproc_pragma] = STATE(2920),
    [sym_preproc_nullable] = STATE(2920),
    [sym_preproc_error] = STATE(2920),
    [sym_preproc_define] = STATE(2920),
    [sym_preproc_undef] = STATE(2920),
    [sym__identifier_token] = ACTIONS(4287),
    [anon_sym_extern] = ACTIONS(3976),
    [anon_sym_alias] = ACTIONS(4289),
    [anon_sym_global] = ACTIONS(4289),
    [anon_sym_unsafe] = ACTIONS(3976),
    [anon_sym_static] = ACTIONS(3976),
    [anon_sym_LBRACK] = ACTIONS(4449),
    [anon_sym_LPAREN] = ACTIONS(4451),
    [anon_sym_class] = ACTIONS(3976),
    [anon_sym_ref] = ACTIONS(4291),
    [anon_sym_struct] = ACTIONS(3976),
    [anon_sym_enum] = ACTIONS(3976),
    [anon_sym_LBRACE] = ACTIONS(4453),
    [anon_sym_interface] = ACTIONS(3976),
    [anon_sym_delegate] = ACTIONS(4455),
    [anon_sym_record] = ACTIONS(3976),
    [anon_sym_abstract] = ACTIONS(3976),
    [anon_sym_async] = ACTIONS(3976),
    [anon_sym_const] = ACTIONS(3976),
    [anon_sym_file] = ACTIONS(4289),
    [anon_sym_fixed] = ACTIONS(3976),
    [anon_sym_internal] = ACTIONS(3976),
    [anon_sym_new] = ACTIONS(3976),
    [anon_sym_override] = ACTIONS(3976),
    [anon_sym_partial] = ACTIONS(3976),
    [anon_sym_private] = ACTIONS(3976),
    [anon_sym_protected] = ACTIONS(3976),
    [anon_sym_public] = ACTIONS(3976),
    [anon_sym_readonly] = ACTIONS(3976),
    [anon_sym_required] = ACTIONS(3976),
    [anon_sym_sealed] = ACTIONS(3976),
    [anon_sym_virtual] = ACTIONS(3976),
    [anon_sym_volatile] = ACTIONS(3976),
    [anon_sym_where] = ACTIONS(4289),
    [anon_sym_notnull] = ACTIONS(4289),
    [anon_sym_unmanaged] = ACTIONS(4289),
    [anon_sym_scoped] = ACTIONS(4457),
    [anon_sym_var] = ACTIONS(4459),
    [sym_predefined_type] = ACTIONS(4461),
    [anon_sym_yield] = ACTIONS(4289),
    [anon_sym_when] = ACTIONS(4289),
    [anon_sym_from] = ACTIONS(4289),
    [anon_sym_into] = ACTIONS(4289),
    [anon_sym_join] = ACTIONS(4289),
    [anon_sym_on] = ACTIONS(4289),
    [anon_sym_equals] = ACTIONS(4289),
    [anon_sym_let] = ACTIONS(4289),
    [anon_sym_orderby] = ACTIONS(4289),
    [anon_sym_ascending] = ACTIONS(4289),
    [anon_sym_descending] = ACTIONS(4289),
    [anon_sym_group] = ACTIONS(4289),
    [anon_sym_by] = ACTIONS(4289),
    [anon_sym_select] = ACTIONS(4289),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2921] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(6995),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9545),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(2921),
    [sym_preproc_endregion] = STATE(2921),
    [sym_preproc_line] = STATE(2921),
    [sym_preproc_pragma] = STATE(2921),
    [sym_preproc_nullable] = STATE(2921),
    [sym_preproc_error] = STATE(2921),
    [sym_preproc_define] = STATE(2921),
    [sym_preproc_undef] = STATE(2921),
    [aux_sym_class_declaration_repeat1] = STATE(4333),
    [aux_sym_class_declaration_repeat2] = STATE(3121),
    [aux_sym_lambda_expression_repeat1] = STATE(4147),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_unsafe] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(4442),
    [anon_sym_fixed] = ACTIONS(643),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(643),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2922] = {
    [sym_modifier] = STATE(3780),
    [sym_variable_declaration] = STATE(9447),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7047),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_identifier] = STATE(4921),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(2922),
    [sym_preproc_endregion] = STATE(2922),
    [sym_preproc_line] = STATE(2922),
    [sym_preproc_pragma] = STATE(2922),
    [sym_preproc_nullable] = STATE(2922),
    [sym_preproc_error] = STATE(2922),
    [sym_preproc_define] = STATE(2922),
    [sym_preproc_undef] = STATE(2922),
    [aux_sym_class_declaration_repeat2] = STATE(3757),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_unsafe] = ACTIONS(63),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(2995),
    [anon_sym_class] = ACTIONS(4299),
    [anon_sym_ref] = ACTIONS(4301),
    [anon_sym_struct] = ACTIONS(2753),
    [anon_sym_enum] = ACTIONS(4303),
    [anon_sym_interface] = ACTIONS(4305),
    [anon_sym_delegate] = ACTIONS(4307),
    [anon_sym_record] = ACTIONS(4309),
    [anon_sym_abstract] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_file] = ACTIONS(3015),
    [anon_sym_fixed] = ACTIONS(63),
    [anon_sym_internal] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(63),
    [anon_sym_override] = ACTIONS(63),
    [anon_sym_partial] = ACTIONS(63),
    [anon_sym_private] = ACTIONS(63),
    [anon_sym_protected] = ACTIONS(63),
    [anon_sym_public] = ACTIONS(63),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_required] = ACTIONS(63),
    [anon_sym_sealed] = ACTIONS(63),
    [anon_sym_virtual] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2923] = {
    [sym_preproc_region] = STATE(2923),
    [sym_preproc_endregion] = STATE(2923),
    [sym_preproc_line] = STATE(2923),
    [sym_preproc_pragma] = STATE(2923),
    [sym_preproc_nullable] = STATE(2923),
    [sym_preproc_error] = STATE(2923),
    [sym_preproc_define] = STATE(2923),
    [sym_preproc_undef] = STATE(2923),
    [sym__identifier_token] = ACTIONS(4099),
    [anon_sym_alias] = ACTIONS(4099),
    [anon_sym_global] = ACTIONS(4099),
    [anon_sym_EQ] = ACTIONS(4104),
    [anon_sym_LBRACK] = ACTIONS(4101),
    [anon_sym_COMMA] = ACTIONS(4111),
    [anon_sym_LPAREN] = ACTIONS(4101),
    [anon_sym_file] = ACTIONS(4099),
    [anon_sym_LT] = ACTIONS(4104),
    [anon_sym_GT] = ACTIONS(4104),
    [anon_sym_where] = ACTIONS(4108),
    [anon_sym_QMARK] = ACTIONS(4108),
    [anon_sym_notnull] = ACTIONS(4099),
    [anon_sym_unmanaged] = ACTIONS(4099),
    [anon_sym_BANG] = ACTIONS(4104),
    [anon_sym_PLUS_PLUS] = ACTIONS(4111),
    [anon_sym_DASH_DASH] = ACTIONS(4111),
    [anon_sym_PLUS] = ACTIONS(4104),
    [anon_sym_DASH] = ACTIONS(4104),
    [anon_sym_STAR] = ACTIONS(4108),
    [anon_sym_SLASH] = ACTIONS(4104),
    [anon_sym_PERCENT] = ACTIONS(4104),
    [anon_sym_CARET] = ACTIONS(4104),
    [anon_sym_PIPE] = ACTIONS(4104),
    [anon_sym_AMP] = ACTIONS(4104),
    [anon_sym_LT_LT] = ACTIONS(4104),
    [anon_sym_GT_GT] = ACTIONS(4104),
    [anon_sym_GT_GT_GT] = ACTIONS(4104),
    [anon_sym_EQ_EQ] = ACTIONS(4111),
    [anon_sym_BANG_EQ] = ACTIONS(4111),
    [anon_sym_GT_EQ] = ACTIONS(4111),
    [anon_sym_LT_EQ] = ACTIONS(4111),
    [anon_sym_DOT] = ACTIONS(4108),
    [anon_sym_scoped] = ACTIONS(4099),
    [anon_sym_var] = ACTIONS(4099),
    [anon_sym_yield] = ACTIONS(4099),
    [anon_sym_switch] = ACTIONS(4104),
    [anon_sym_when] = ACTIONS(4099),
    [anon_sym_DOT_DOT] = ACTIONS(4111),
    [anon_sym_and] = ACTIONS(4104),
    [anon_sym_or] = ACTIONS(4104),
    [anon_sym_PLUS_EQ] = ACTIONS(4111),
    [anon_sym_DASH_EQ] = ACTIONS(4111),
    [anon_sym_STAR_EQ] = ACTIONS(4111),
    [anon_sym_SLASH_EQ] = ACTIONS(4111),
    [anon_sym_PERCENT_EQ] = ACTIONS(4111),
    [anon_sym_AMP_EQ] = ACTIONS(4111),
    [anon_sym_CARET_EQ] = ACTIONS(4111),
    [anon_sym_PIPE_EQ] = ACTIONS(4111),
    [anon_sym_LT_LT_EQ] = ACTIONS(4111),
    [anon_sym_GT_GT_EQ] = ACTIONS(4111),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4111),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4111),
    [anon_sym_AMP_AMP] = ACTIONS(4111),
    [anon_sym_PIPE_PIPE] = ACTIONS(4111),
    [anon_sym_QMARK_QMARK] = ACTIONS(4104),
    [anon_sym_from] = ACTIONS(4108),
    [anon_sym_into] = ACTIONS(4108),
    [anon_sym_join] = ACTIONS(4108),
    [anon_sym_on] = ACTIONS(4099),
    [anon_sym_equals] = ACTIONS(4099),
    [anon_sym_let] = ACTIONS(4108),
    [anon_sym_orderby] = ACTIONS(4108),
    [anon_sym_ascending] = ACTIONS(4108),
    [anon_sym_descending] = ACTIONS(4108),
    [anon_sym_group] = ACTIONS(4108),
    [anon_sym_by] = ACTIONS(4099),
    [anon_sym_select] = ACTIONS(4108),
    [anon_sym_as] = ACTIONS(4104),
    [anon_sym_is] = ACTIONS(4104),
    [anon_sym_DASH_GT] = ACTIONS(4101),
    [anon_sym_with] = ACTIONS(4104),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2924] = {
    [sym_attribute_list] = STATE(4467),
    [sym_modifier] = STATE(4545),
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7111),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9545),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(2924),
    [sym_preproc_endregion] = STATE(2924),
    [sym_preproc_line] = STATE(2924),
    [sym_preproc_pragma] = STATE(2924),
    [sym_preproc_nullable] = STATE(2924),
    [sym_preproc_error] = STATE(2924),
    [sym_preproc_define] = STATE(2924),
    [sym_preproc_undef] = STATE(2924),
    [aux_sym_class_declaration_repeat1] = STATE(4333),
    [aux_sym_class_declaration_repeat2] = STATE(3118),
    [aux_sym_lambda_expression_repeat1] = STATE(4147),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_unsafe] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(4440),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(651),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(4442),
    [anon_sym_fixed] = ACTIONS(643),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(643),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2925] = {
    [sym_type_argument_list] = STATE(2943),
    [sym_preproc_region] = STATE(2925),
    [sym_preproc_endregion] = STATE(2925),
    [sym_preproc_line] = STATE(2925),
    [sym_preproc_pragma] = STATE(2925),
    [sym_preproc_nullable] = STATE(2925),
    [sym_preproc_error] = STATE(2925),
    [sym_preproc_define] = STATE(2925),
    [sym_preproc_undef] = STATE(2925),
    [sym__identifier_token] = ACTIONS(4074),
    [anon_sym_alias] = ACTIONS(4074),
    [anon_sym_SEMI] = ACTIONS(4076),
    [anon_sym_global] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4076),
    [anon_sym_COLON] = ACTIONS(4076),
    [anon_sym_COMMA] = ACTIONS(4076),
    [anon_sym_RBRACK] = ACTIONS(4076),
    [anon_sym_LPAREN] = ACTIONS(4076),
    [anon_sym_RPAREN] = ACTIONS(4076),
    [anon_sym_LBRACE] = ACTIONS(4076),
    [anon_sym_RBRACE] = ACTIONS(4076),
    [anon_sym_file] = ACTIONS(4074),
    [anon_sym_LT] = ACTIONS(4446),
    [anon_sym_GT] = ACTIONS(4074),
    [anon_sym_in] = ACTIONS(4074),
    [anon_sym_where] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(4074),
    [anon_sym_notnull] = ACTIONS(4074),
    [anon_sym_unmanaged] = ACTIONS(4074),
    [anon_sym_BANG] = ACTIONS(4074),
    [anon_sym_PLUS_PLUS] = ACTIONS(4076),
    [anon_sym_DASH_DASH] = ACTIONS(4076),
    [anon_sym_PLUS] = ACTIONS(4074),
    [anon_sym_DASH] = ACTIONS(4074),
    [anon_sym_STAR] = ACTIONS(4076),
    [anon_sym_SLASH] = ACTIONS(4074),
    [anon_sym_PERCENT] = ACTIONS(4076),
    [anon_sym_CARET] = ACTIONS(4076),
    [anon_sym_PIPE] = ACTIONS(4074),
    [anon_sym_AMP] = ACTIONS(4074),
    [anon_sym_LT_LT] = ACTIONS(4076),
    [anon_sym_GT_GT] = ACTIONS(4074),
    [anon_sym_GT_GT_GT] = ACTIONS(4076),
    [anon_sym_EQ_EQ] = ACTIONS(4076),
    [anon_sym_BANG_EQ] = ACTIONS(4076),
    [anon_sym_GT_EQ] = ACTIONS(4076),
    [anon_sym_LT_EQ] = ACTIONS(4076),
    [anon_sym_DOT] = ACTIONS(4074),
    [anon_sym_scoped] = ACTIONS(4074),
    [anon_sym_EQ_GT] = ACTIONS(4076),
    [anon_sym_var] = ACTIONS(4074),
    [anon_sym_yield] = ACTIONS(4074),
    [anon_sym_switch] = ACTIONS(4074),
    [anon_sym_when] = ACTIONS(4074),
    [sym_discard] = ACTIONS(4074),
    [anon_sym_DOT_DOT] = ACTIONS(4076),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_AMP_AMP] = ACTIONS(4076),
    [anon_sym_PIPE_PIPE] = ACTIONS(4076),
    [anon_sym_QMARK_QMARK] = ACTIONS(4076),
    [anon_sym_from] = ACTIONS(4074),
    [anon_sym_into] = ACTIONS(4074),
    [anon_sym_join] = ACTIONS(4074),
    [anon_sym_on] = ACTIONS(4074),
    [anon_sym_equals] = ACTIONS(4074),
    [anon_sym_let] = ACTIONS(4074),
    [anon_sym_orderby] = ACTIONS(4074),
    [anon_sym_ascending] = ACTIONS(4074),
    [anon_sym_descending] = ACTIONS(4074),
    [anon_sym_group] = ACTIONS(4074),
    [anon_sym_by] = ACTIONS(4074),
    [anon_sym_select] = ACTIONS(4074),
    [anon_sym_as] = ACTIONS(4074),
    [anon_sym_is] = ACTIONS(4074),
    [anon_sym_DASH_GT] = ACTIONS(4076),
    [anon_sym_with] = ACTIONS(4074),
    [aux_sym_preproc_if_token3] = ACTIONS(4076),
    [aux_sym_preproc_else_token1] = ACTIONS(4076),
    [aux_sym_preproc_elif_token1] = ACTIONS(4076),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2926] = {
    [sym__name] = STATE(3926),
    [sym_alias_qualified_name] = STATE(3912),
    [sym__simple_name] = STATE(3912),
    [sym_qualified_name] = STATE(3912),
    [sym_generic_name] = STATE(3874),
    [sym_ref_type] = STATE(3927),
    [sym__scoped_base_type] = STATE(3930),
    [sym_identifier] = STATE(3787),
    [sym__reserved_identifier] = STATE(3838),
    [sym_preproc_region] = STATE(2926),
    [sym_preproc_endregion] = STATE(2926),
    [sym_preproc_line] = STATE(2926),
    [sym_preproc_pragma] = STATE(2926),
    [sym_preproc_nullable] = STATE(2926),
    [sym_preproc_error] = STATE(2926),
    [sym_preproc_define] = STATE(2926),
    [sym_preproc_undef] = STATE(2926),
    [sym__identifier_token] = ACTIONS(4157),
    [anon_sym_alias] = ACTIONS(4159),
    [anon_sym_global] = ACTIONS(4159),
    [anon_sym_LBRACK] = ACTIONS(3719),
    [anon_sym_COLON] = ACTIONS(3721),
    [anon_sym_LPAREN] = ACTIONS(3719),
    [anon_sym_ref] = ACTIONS(4463),
    [anon_sym_LBRACE] = ACTIONS(3719),
    [anon_sym_file] = ACTIONS(4159),
    [anon_sym_LT] = ACTIONS(3721),
    [anon_sym_GT] = ACTIONS(3721),
    [anon_sym_where] = ACTIONS(4159),
    [anon_sym_QMARK] = ACTIONS(3721),
    [anon_sym_notnull] = ACTIONS(4159),
    [anon_sym_unmanaged] = ACTIONS(4159),
    [anon_sym_BANG] = ACTIONS(3721),
    [anon_sym_PLUS_PLUS] = ACTIONS(3719),
    [anon_sym_DASH_DASH] = ACTIONS(3719),
    [anon_sym_PLUS] = ACTIONS(3721),
    [anon_sym_DASH] = ACTIONS(3721),
    [anon_sym_STAR] = ACTIONS(3719),
    [anon_sym_SLASH] = ACTIONS(3721),
    [anon_sym_PERCENT] = ACTIONS(3719),
    [anon_sym_CARET] = ACTIONS(3719),
    [anon_sym_PIPE] = ACTIONS(3721),
    [anon_sym_AMP] = ACTIONS(3721),
    [anon_sym_LT_LT] = ACTIONS(3719),
    [anon_sym_GT_GT] = ACTIONS(3721),
    [anon_sym_GT_GT_GT] = ACTIONS(3719),
    [anon_sym_EQ_EQ] = ACTIONS(3719),
    [anon_sym_BANG_EQ] = ACTIONS(3719),
    [anon_sym_GT_EQ] = ACTIONS(3719),
    [anon_sym_LT_EQ] = ACTIONS(3719),
    [anon_sym_DOT] = ACTIONS(3721),
    [anon_sym_scoped] = ACTIONS(4159),
    [anon_sym_EQ_GT] = ACTIONS(3719),
    [anon_sym_COLON_COLON] = ACTIONS(3719),
    [anon_sym_var] = ACTIONS(4159),
    [anon_sym_yield] = ACTIONS(4159),
    [anon_sym_switch] = ACTIONS(3721),
    [anon_sym_when] = ACTIONS(4163),
    [anon_sym_DOT_DOT] = ACTIONS(3719),
    [anon_sym_and] = ACTIONS(3721),
    [anon_sym_or] = ACTIONS(3721),
    [anon_sym_AMP_AMP] = ACTIONS(3719),
    [anon_sym_PIPE_PIPE] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK] = ACTIONS(3719),
    [anon_sym_from] = ACTIONS(4159),
    [anon_sym_into] = ACTIONS(4163),
    [anon_sym_join] = ACTIONS(4159),
    [anon_sym_on] = ACTIONS(4159),
    [anon_sym_equals] = ACTIONS(4159),
    [anon_sym_let] = ACTIONS(4159),
    [anon_sym_orderby] = ACTIONS(4159),
    [anon_sym_ascending] = ACTIONS(4159),
    [anon_sym_descending] = ACTIONS(4159),
    [anon_sym_group] = ACTIONS(4159),
    [anon_sym_by] = ACTIONS(4159),
    [anon_sym_select] = ACTIONS(4159),
    [anon_sym_as] = ACTIONS(3721),
    [anon_sym_is] = ACTIONS(3721),
    [anon_sym_DASH_GT] = ACTIONS(3719),
    [anon_sym_with] = ACTIONS(3721),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2927] = {
    [sym__name] = STATE(4267),
    [sym_alias_qualified_name] = STATE(3955),
    [sym__simple_name] = STATE(3955),
    [sym_qualified_name] = STATE(3955),
    [sym_generic_name] = STATE(4047),
    [sym_ref_type] = STATE(4040),
    [sym__scoped_base_type] = STATE(4036),
    [sym_identifier] = STATE(3891),
    [sym__reserved_identifier] = STATE(3897),
    [sym_preproc_region] = STATE(2927),
    [sym_preproc_endregion] = STATE(2927),
    [sym_preproc_line] = STATE(2927),
    [sym_preproc_pragma] = STATE(2927),
    [sym_preproc_nullable] = STATE(2927),
    [sym_preproc_error] = STATE(2927),
    [sym_preproc_define] = STATE(2927),
    [sym_preproc_undef] = STATE(2927),
    [sym__identifier_token] = ACTIONS(4168),
    [anon_sym_alias] = ACTIONS(4170),
    [anon_sym_global] = ACTIONS(4170),
    [anon_sym_LBRACK] = ACTIONS(3719),
    [anon_sym_COLON] = ACTIONS(3721),
    [anon_sym_LPAREN] = ACTIONS(3719),
    [anon_sym_ref] = ACTIONS(4465),
    [anon_sym_LBRACE] = ACTIONS(3719),
    [anon_sym_file] = ACTIONS(4170),
    [anon_sym_LT] = ACTIONS(3721),
    [anon_sym_GT] = ACTIONS(3721),
    [anon_sym_where] = ACTIONS(4170),
    [anon_sym_QMARK] = ACTIONS(3721),
    [anon_sym_notnull] = ACTIONS(4170),
    [anon_sym_unmanaged] = ACTIONS(4170),
    [anon_sym_BANG] = ACTIONS(3721),
    [anon_sym_PLUS_PLUS] = ACTIONS(3719),
    [anon_sym_DASH_DASH] = ACTIONS(3719),
    [anon_sym_PLUS] = ACTIONS(3721),
    [anon_sym_DASH] = ACTIONS(3721),
    [anon_sym_STAR] = ACTIONS(3719),
    [anon_sym_SLASH] = ACTIONS(3721),
    [anon_sym_PERCENT] = ACTIONS(3719),
    [anon_sym_CARET] = ACTIONS(3719),
    [anon_sym_PIPE] = ACTIONS(3721),
    [anon_sym_AMP] = ACTIONS(3721),
    [anon_sym_LT_LT] = ACTIONS(3719),
    [anon_sym_GT_GT] = ACTIONS(3721),
    [anon_sym_GT_GT_GT] = ACTIONS(3719),
    [anon_sym_EQ_EQ] = ACTIONS(3719),
    [anon_sym_BANG_EQ] = ACTIONS(3719),
    [anon_sym_GT_EQ] = ACTIONS(3719),
    [anon_sym_LT_EQ] = ACTIONS(3719),
    [anon_sym_DOT] = ACTIONS(3721),
    [anon_sym_scoped] = ACTIONS(4170),
    [anon_sym_EQ_GT] = ACTIONS(3719),
    [anon_sym_COLON_COLON] = ACTIONS(3719),
    [anon_sym_var] = ACTIONS(4170),
    [anon_sym_yield] = ACTIONS(4170),
    [anon_sym_switch] = ACTIONS(3721),
    [anon_sym_when] = ACTIONS(4467),
    [anon_sym_DOT_DOT] = ACTIONS(3719),
    [anon_sym_and] = ACTIONS(3721),
    [anon_sym_or] = ACTIONS(3721),
    [anon_sym_AMP_AMP] = ACTIONS(3719),
    [anon_sym_PIPE_PIPE] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK] = ACTIONS(3719),
    [anon_sym_from] = ACTIONS(4170),
    [anon_sym_into] = ACTIONS(4170),
    [anon_sym_join] = ACTIONS(4170),
    [anon_sym_on] = ACTIONS(4170),
    [anon_sym_equals] = ACTIONS(4170),
    [anon_sym_let] = ACTIONS(4170),
    [anon_sym_orderby] = ACTIONS(4170),
    [anon_sym_ascending] = ACTIONS(4170),
    [anon_sym_descending] = ACTIONS(4170),
    [anon_sym_group] = ACTIONS(4170),
    [anon_sym_by] = ACTIONS(4170),
    [anon_sym_select] = ACTIONS(4170),
    [anon_sym_as] = ACTIONS(3721),
    [anon_sym_is] = ACTIONS(3721),
    [anon_sym_DASH_GT] = ACTIONS(3719),
    [anon_sym_with] = ACTIONS(3721),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2928] = {
    [sym_preproc_region] = STATE(2928),
    [sym_preproc_endregion] = STATE(2928),
    [sym_preproc_line] = STATE(2928),
    [sym_preproc_pragma] = STATE(2928),
    [sym_preproc_nullable] = STATE(2928),
    [sym_preproc_error] = STATE(2928),
    [sym_preproc_define] = STATE(2928),
    [sym_preproc_undef] = STATE(2928),
    [sym__identifier_token] = ACTIONS(4470),
    [anon_sym_alias] = ACTIONS(4470),
    [anon_sym_SEMI] = ACTIONS(4472),
    [anon_sym_global] = ACTIONS(4470),
    [anon_sym_LBRACK] = ACTIONS(4472),
    [anon_sym_COLON] = ACTIONS(4472),
    [anon_sym_COMMA] = ACTIONS(4472),
    [anon_sym_RBRACK] = ACTIONS(4472),
    [anon_sym_LPAREN] = ACTIONS(4472),
    [anon_sym_RPAREN] = ACTIONS(4472),
    [anon_sym_LBRACE] = ACTIONS(4472),
    [anon_sym_RBRACE] = ACTIONS(4472),
    [anon_sym_file] = ACTIONS(4470),
    [anon_sym_LT] = ACTIONS(4470),
    [anon_sym_GT] = ACTIONS(4470),
    [anon_sym_in] = ACTIONS(4470),
    [anon_sym_where] = ACTIONS(4470),
    [anon_sym_QMARK] = ACTIONS(4470),
    [anon_sym_notnull] = ACTIONS(4470),
    [anon_sym_unmanaged] = ACTIONS(4470),
    [anon_sym_BANG] = ACTIONS(4470),
    [anon_sym_PLUS_PLUS] = ACTIONS(4472),
    [anon_sym_DASH_DASH] = ACTIONS(4472),
    [anon_sym_PLUS] = ACTIONS(4470),
    [anon_sym_DASH] = ACTIONS(4470),
    [anon_sym_STAR] = ACTIONS(4472),
    [anon_sym_SLASH] = ACTIONS(4470),
    [anon_sym_PERCENT] = ACTIONS(4472),
    [anon_sym_CARET] = ACTIONS(4472),
    [anon_sym_PIPE] = ACTIONS(4470),
    [anon_sym_AMP] = ACTIONS(4470),
    [anon_sym_LT_LT] = ACTIONS(4472),
    [anon_sym_GT_GT] = ACTIONS(4470),
    [anon_sym_GT_GT_GT] = ACTIONS(4472),
    [anon_sym_EQ_EQ] = ACTIONS(4472),
    [anon_sym_BANG_EQ] = ACTIONS(4472),
    [anon_sym_GT_EQ] = ACTIONS(4472),
    [anon_sym_LT_EQ] = ACTIONS(4472),
    [anon_sym_DOT] = ACTIONS(4470),
    [anon_sym_scoped] = ACTIONS(4470),
    [anon_sym_EQ_GT] = ACTIONS(4472),
    [anon_sym_var] = ACTIONS(4470),
    [anon_sym_yield] = ACTIONS(4470),
    [anon_sym_switch] = ACTIONS(4470),
    [anon_sym_when] = ACTIONS(4470),
    [sym_discard] = ACTIONS(4470),
    [anon_sym_DOT_DOT] = ACTIONS(4472),
    [anon_sym_and] = ACTIONS(4470),
    [anon_sym_or] = ACTIONS(4470),
    [anon_sym_AMP_AMP] = ACTIONS(4472),
    [anon_sym_PIPE_PIPE] = ACTIONS(4472),
    [anon_sym_QMARK_QMARK] = ACTIONS(4472),
    [anon_sym_from] = ACTIONS(4470),
    [anon_sym_into] = ACTIONS(4470),
    [anon_sym_join] = ACTIONS(4470),
    [anon_sym_on] = ACTIONS(4470),
    [anon_sym_equals] = ACTIONS(4470),
    [anon_sym_let] = ACTIONS(4470),
    [anon_sym_orderby] = ACTIONS(4470),
    [anon_sym_ascending] = ACTIONS(4470),
    [anon_sym_descending] = ACTIONS(4470),
    [anon_sym_group] = ACTIONS(4470),
    [anon_sym_by] = ACTIONS(4470),
    [anon_sym_select] = ACTIONS(4470),
    [anon_sym_as] = ACTIONS(4470),
    [anon_sym_is] = ACTIONS(4470),
    [anon_sym_DASH_GT] = ACTIONS(4472),
    [anon_sym_with] = ACTIONS(4470),
    [aux_sym_preproc_if_token3] = ACTIONS(4472),
    [aux_sym_preproc_else_token1] = ACTIONS(4472),
    [aux_sym_preproc_elif_token1] = ACTIONS(4472),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2929] = {
    [sym_preproc_region] = STATE(2929),
    [sym_preproc_endregion] = STATE(2929),
    [sym_preproc_line] = STATE(2929),
    [sym_preproc_pragma] = STATE(2929),
    [sym_preproc_nullable] = STATE(2929),
    [sym_preproc_error] = STATE(2929),
    [sym_preproc_define] = STATE(2929),
    [sym_preproc_undef] = STATE(2929),
    [sym__identifier_token] = ACTIONS(4474),
    [anon_sym_alias] = ACTIONS(4474),
    [anon_sym_SEMI] = ACTIONS(4476),
    [anon_sym_global] = ACTIONS(4474),
    [anon_sym_LBRACK] = ACTIONS(4476),
    [anon_sym_COLON] = ACTIONS(4476),
    [anon_sym_COMMA] = ACTIONS(4476),
    [anon_sym_RBRACK] = ACTIONS(4476),
    [anon_sym_LPAREN] = ACTIONS(4476),
    [anon_sym_RPAREN] = ACTIONS(4476),
    [anon_sym_LBRACE] = ACTIONS(4476),
    [anon_sym_RBRACE] = ACTIONS(4476),
    [anon_sym_file] = ACTIONS(4474),
    [anon_sym_LT] = ACTIONS(4474),
    [anon_sym_GT] = ACTIONS(4474),
    [anon_sym_in] = ACTIONS(4474),
    [anon_sym_where] = ACTIONS(4474),
    [anon_sym_QMARK] = ACTIONS(4474),
    [anon_sym_notnull] = ACTIONS(4474),
    [anon_sym_unmanaged] = ACTIONS(4474),
    [anon_sym_BANG] = ACTIONS(4474),
    [anon_sym_PLUS_PLUS] = ACTIONS(4476),
    [anon_sym_DASH_DASH] = ACTIONS(4476),
    [anon_sym_PLUS] = ACTIONS(4474),
    [anon_sym_DASH] = ACTIONS(4474),
    [anon_sym_STAR] = ACTIONS(4476),
    [anon_sym_SLASH] = ACTIONS(4474),
    [anon_sym_PERCENT] = ACTIONS(4476),
    [anon_sym_CARET] = ACTIONS(4476),
    [anon_sym_PIPE] = ACTIONS(4474),
    [anon_sym_AMP] = ACTIONS(4474),
    [anon_sym_LT_LT] = ACTIONS(4476),
    [anon_sym_GT_GT] = ACTIONS(4474),
    [anon_sym_GT_GT_GT] = ACTIONS(4476),
    [anon_sym_EQ_EQ] = ACTIONS(4476),
    [anon_sym_BANG_EQ] = ACTIONS(4476),
    [anon_sym_GT_EQ] = ACTIONS(4476),
    [anon_sym_LT_EQ] = ACTIONS(4476),
    [anon_sym_DOT] = ACTIONS(4474),
    [anon_sym_scoped] = ACTIONS(4474),
    [anon_sym_EQ_GT] = ACTIONS(4476),
    [anon_sym_var] = ACTIONS(4474),
    [anon_sym_yield] = ACTIONS(4474),
    [anon_sym_switch] = ACTIONS(4474),
    [anon_sym_when] = ACTIONS(4474),
    [sym_discard] = ACTIONS(4474),
    [anon_sym_DOT_DOT] = ACTIONS(4476),
    [anon_sym_and] = ACTIONS(4474),
    [anon_sym_or] = ACTIONS(4474),
    [anon_sym_AMP_AMP] = ACTIONS(4476),
    [anon_sym_PIPE_PIPE] = ACTIONS(4476),
    [anon_sym_QMARK_QMARK] = ACTIONS(4476),
    [anon_sym_from] = ACTIONS(4474),
    [anon_sym_into] = ACTIONS(4474),
    [anon_sym_join] = ACTIONS(4474),
    [anon_sym_on] = ACTIONS(4474),
    [anon_sym_equals] = ACTIONS(4474),
    [anon_sym_let] = ACTIONS(4474),
    [anon_sym_orderby] = ACTIONS(4474),
    [anon_sym_ascending] = ACTIONS(4474),
    [anon_sym_descending] = ACTIONS(4474),
    [anon_sym_group] = ACTIONS(4474),
    [anon_sym_by] = ACTIONS(4474),
    [anon_sym_select] = ACTIONS(4474),
    [anon_sym_as] = ACTIONS(4474),
    [anon_sym_is] = ACTIONS(4474),
    [anon_sym_DASH_GT] = ACTIONS(4476),
    [anon_sym_with] = ACTIONS(4474),
    [aux_sym_preproc_if_token3] = ACTIONS(4476),
    [aux_sym_preproc_else_token1] = ACTIONS(4476),
    [aux_sym_preproc_elif_token1] = ACTIONS(4476),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2930] = {
    [sym_preproc_region] = STATE(2930),
    [sym_preproc_endregion] = STATE(2930),
    [sym_preproc_line] = STATE(2930),
    [sym_preproc_pragma] = STATE(2930),
    [sym_preproc_nullable] = STATE(2930),
    [sym_preproc_error] = STATE(2930),
    [sym_preproc_define] = STATE(2930),
    [sym_preproc_undef] = STATE(2930),
    [sym__identifier_token] = ACTIONS(4478),
    [anon_sym_alias] = ACTIONS(4478),
    [anon_sym_SEMI] = ACTIONS(4480),
    [anon_sym_global] = ACTIONS(4478),
    [anon_sym_LBRACK] = ACTIONS(4480),
    [anon_sym_COLON] = ACTIONS(4480),
    [anon_sym_COMMA] = ACTIONS(4480),
    [anon_sym_RBRACK] = ACTIONS(4480),
    [anon_sym_LPAREN] = ACTIONS(4480),
    [anon_sym_RPAREN] = ACTIONS(4480),
    [anon_sym_LBRACE] = ACTIONS(4480),
    [anon_sym_RBRACE] = ACTIONS(4480),
    [anon_sym_file] = ACTIONS(4478),
    [anon_sym_LT] = ACTIONS(4478),
    [anon_sym_GT] = ACTIONS(4478),
    [anon_sym_in] = ACTIONS(4478),
    [anon_sym_where] = ACTIONS(4478),
    [anon_sym_QMARK] = ACTIONS(4478),
    [anon_sym_notnull] = ACTIONS(4478),
    [anon_sym_unmanaged] = ACTIONS(4478),
    [anon_sym_BANG] = ACTIONS(4478),
    [anon_sym_PLUS_PLUS] = ACTIONS(4480),
    [anon_sym_DASH_DASH] = ACTIONS(4480),
    [anon_sym_PLUS] = ACTIONS(4478),
    [anon_sym_DASH] = ACTIONS(4478),
    [anon_sym_STAR] = ACTIONS(4480),
    [anon_sym_SLASH] = ACTIONS(4478),
    [anon_sym_PERCENT] = ACTIONS(4480),
    [anon_sym_CARET] = ACTIONS(4480),
    [anon_sym_PIPE] = ACTIONS(4478),
    [anon_sym_AMP] = ACTIONS(4478),
    [anon_sym_LT_LT] = ACTIONS(4480),
    [anon_sym_GT_GT] = ACTIONS(4478),
    [anon_sym_GT_GT_GT] = ACTIONS(4480),
    [anon_sym_EQ_EQ] = ACTIONS(4480),
    [anon_sym_BANG_EQ] = ACTIONS(4480),
    [anon_sym_GT_EQ] = ACTIONS(4480),
    [anon_sym_LT_EQ] = ACTIONS(4480),
    [anon_sym_DOT] = ACTIONS(4478),
    [anon_sym_scoped] = ACTIONS(4478),
    [anon_sym_EQ_GT] = ACTIONS(4480),
    [anon_sym_var] = ACTIONS(4478),
    [anon_sym_yield] = ACTIONS(4478),
    [anon_sym_switch] = ACTIONS(4478),
    [anon_sym_when] = ACTIONS(4478),
    [sym_discard] = ACTIONS(4478),
    [anon_sym_DOT_DOT] = ACTIONS(4480),
    [anon_sym_and] = ACTIONS(4478),
    [anon_sym_or] = ACTIONS(4478),
    [anon_sym_AMP_AMP] = ACTIONS(4480),
    [anon_sym_PIPE_PIPE] = ACTIONS(4480),
    [anon_sym_QMARK_QMARK] = ACTIONS(4480),
    [anon_sym_from] = ACTIONS(4478),
    [anon_sym_into] = ACTIONS(4478),
    [anon_sym_join] = ACTIONS(4478),
    [anon_sym_on] = ACTIONS(4478),
    [anon_sym_equals] = ACTIONS(4478),
    [anon_sym_let] = ACTIONS(4478),
    [anon_sym_orderby] = ACTIONS(4478),
    [anon_sym_ascending] = ACTIONS(4478),
    [anon_sym_descending] = ACTIONS(4478),
    [anon_sym_group] = ACTIONS(4478),
    [anon_sym_by] = ACTIONS(4478),
    [anon_sym_select] = ACTIONS(4478),
    [anon_sym_as] = ACTIONS(4478),
    [anon_sym_is] = ACTIONS(4478),
    [anon_sym_DASH_GT] = ACTIONS(4480),
    [anon_sym_with] = ACTIONS(4478),
    [aux_sym_preproc_if_token3] = ACTIONS(4480),
    [aux_sym_preproc_else_token1] = ACTIONS(4480),
    [aux_sym_preproc_elif_token1] = ACTIONS(4480),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2931] = {
    [sym_parameter_list] = STATE(9765),
    [sym_positional_pattern_clause] = STATE(3047),
    [sym_property_pattern_clause] = STATE(3117),
    [sym__variable_designation] = STATE(5398),
    [sym_parenthesized_variable_designation] = STATE(5390),
    [sym__lambda_parameters] = STATE(9127),
    [sym_identifier] = STATE(5303),
    [sym__reserved_identifier] = STATE(5128),
    [sym_preproc_region] = STATE(2931),
    [sym_preproc_endregion] = STATE(2931),
    [sym_preproc_line] = STATE(2931),
    [sym_preproc_pragma] = STATE(2931),
    [sym_preproc_nullable] = STATE(2931),
    [sym_preproc_error] = STATE(2931),
    [sym_preproc_define] = STATE(2931),
    [sym_preproc_undef] = STATE(2931),
    [sym__identifier_token] = ACTIONS(4482),
    [anon_sym_alias] = ACTIONS(4484),
    [anon_sym_global] = ACTIONS(4484),
    [anon_sym_LBRACK] = ACTIONS(4275),
    [anon_sym_COLON] = ACTIONS(4275),
    [anon_sym_COMMA] = ACTIONS(4275),
    [anon_sym_LPAREN] = ACTIONS(4275),
    [anon_sym_LBRACE] = ACTIONS(4486),
    [anon_sym_file] = ACTIONS(4484),
    [anon_sym_LT] = ACTIONS(4279),
    [anon_sym_GT] = ACTIONS(4279),
    [anon_sym_where] = ACTIONS(4484),
    [anon_sym_QMARK] = ACTIONS(4279),
    [anon_sym_notnull] = ACTIONS(4484),
    [anon_sym_unmanaged] = ACTIONS(4484),
    [anon_sym_BANG] = ACTIONS(4279),
    [anon_sym_PLUS_PLUS] = ACTIONS(4275),
    [anon_sym_DASH_DASH] = ACTIONS(4275),
    [anon_sym_PLUS] = ACTIONS(4279),
    [anon_sym_DASH] = ACTIONS(4279),
    [anon_sym_STAR] = ACTIONS(4275),
    [anon_sym_SLASH] = ACTIONS(4279),
    [anon_sym_PERCENT] = ACTIONS(4275),
    [anon_sym_CARET] = ACTIONS(4275),
    [anon_sym_PIPE] = ACTIONS(4279),
    [anon_sym_AMP] = ACTIONS(4279),
    [anon_sym_LT_LT] = ACTIONS(4275),
    [anon_sym_GT_GT] = ACTIONS(4279),
    [anon_sym_GT_GT_GT] = ACTIONS(4275),
    [anon_sym_EQ_EQ] = ACTIONS(4275),
    [anon_sym_BANG_EQ] = ACTIONS(4275),
    [anon_sym_GT_EQ] = ACTIONS(4275),
    [anon_sym_LT_EQ] = ACTIONS(4275),
    [anon_sym_DOT] = ACTIONS(4279),
    [anon_sym_scoped] = ACTIONS(4484),
    [anon_sym_var] = ACTIONS(4484),
    [anon_sym_yield] = ACTIONS(4484),
    [anon_sym_switch] = ACTIONS(4279),
    [anon_sym_when] = ACTIONS(4484),
    [sym_discard] = ACTIONS(4488),
    [anon_sym_DOT_DOT] = ACTIONS(4275),
    [anon_sym_and] = ACTIONS(4279),
    [anon_sym_or] = ACTIONS(4279),
    [anon_sym_AMP_AMP] = ACTIONS(4275),
    [anon_sym_PIPE_PIPE] = ACTIONS(4275),
    [anon_sym_QMARK_QMARK] = ACTIONS(4275),
    [anon_sym_from] = ACTIONS(4484),
    [anon_sym_into] = ACTIONS(4484),
    [anon_sym_join] = ACTIONS(4484),
    [anon_sym_on] = ACTIONS(4484),
    [anon_sym_equals] = ACTIONS(4484),
    [anon_sym_let] = ACTIONS(4484),
    [anon_sym_orderby] = ACTIONS(4484),
    [anon_sym_ascending] = ACTIONS(4484),
    [anon_sym_descending] = ACTIONS(4484),
    [anon_sym_group] = ACTIONS(4484),
    [anon_sym_by] = ACTIONS(4484),
    [anon_sym_select] = ACTIONS(4484),
    [anon_sym_as] = ACTIONS(4279),
    [anon_sym_is] = ACTIONS(4279),
    [anon_sym_DASH_GT] = ACTIONS(4275),
    [anon_sym_with] = ACTIONS(4279),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4275),
  },
  [2932] = {
    [sym_preproc_region] = STATE(2932),
    [sym_preproc_endregion] = STATE(2932),
    [sym_preproc_line] = STATE(2932),
    [sym_preproc_pragma] = STATE(2932),
    [sym_preproc_nullable] = STATE(2932),
    [sym_preproc_error] = STATE(2932),
    [sym_preproc_define] = STATE(2932),
    [sym_preproc_undef] = STATE(2932),
    [sym__identifier_token] = ACTIONS(4099),
    [anon_sym_alias] = ACTIONS(4099),
    [anon_sym_global] = ACTIONS(4099),
    [anon_sym_EQ] = ACTIONS(4104),
    [anon_sym_LBRACK] = ACTIONS(4101),
    [anon_sym_LPAREN] = ACTIONS(4101),
    [anon_sym_file] = ACTIONS(4099),
    [anon_sym_LT] = ACTIONS(4104),
    [anon_sym_GT] = ACTIONS(4104),
    [anon_sym_where] = ACTIONS(4108),
    [anon_sym_QMARK] = ACTIONS(4108),
    [anon_sym_notnull] = ACTIONS(4099),
    [anon_sym_unmanaged] = ACTIONS(4099),
    [anon_sym_BANG] = ACTIONS(4104),
    [anon_sym_PLUS_PLUS] = ACTIONS(4111),
    [anon_sym_DASH_DASH] = ACTIONS(4111),
    [anon_sym_PLUS] = ACTIONS(4104),
    [anon_sym_DASH] = ACTIONS(4104),
    [anon_sym_STAR] = ACTIONS(4108),
    [anon_sym_SLASH] = ACTIONS(4104),
    [anon_sym_PERCENT] = ACTIONS(4104),
    [anon_sym_CARET] = ACTIONS(4104),
    [anon_sym_PIPE] = ACTIONS(4104),
    [anon_sym_AMP] = ACTIONS(4104),
    [anon_sym_LT_LT] = ACTIONS(4104),
    [anon_sym_GT_GT] = ACTIONS(4104),
    [anon_sym_GT_GT_GT] = ACTIONS(4104),
    [anon_sym_EQ_EQ] = ACTIONS(4111),
    [anon_sym_BANG_EQ] = ACTIONS(4111),
    [anon_sym_GT_EQ] = ACTIONS(4111),
    [anon_sym_LT_EQ] = ACTIONS(4111),
    [anon_sym_DOT] = ACTIONS(4108),
    [anon_sym_scoped] = ACTIONS(4099),
    [anon_sym_var] = ACTIONS(4099),
    [anon_sym_yield] = ACTIONS(4099),
    [anon_sym_switch] = ACTIONS(4104),
    [anon_sym_when] = ACTIONS(4099),
    [anon_sym_DOT_DOT] = ACTIONS(4111),
    [anon_sym_and] = ACTIONS(4104),
    [anon_sym_or] = ACTIONS(4104),
    [anon_sym_PLUS_EQ] = ACTIONS(4111),
    [anon_sym_DASH_EQ] = ACTIONS(4111),
    [anon_sym_STAR_EQ] = ACTIONS(4111),
    [anon_sym_SLASH_EQ] = ACTIONS(4111),
    [anon_sym_PERCENT_EQ] = ACTIONS(4111),
    [anon_sym_AMP_EQ] = ACTIONS(4111),
    [anon_sym_CARET_EQ] = ACTIONS(4111),
    [anon_sym_PIPE_EQ] = ACTIONS(4111),
    [anon_sym_LT_LT_EQ] = ACTIONS(4111),
    [anon_sym_GT_GT_EQ] = ACTIONS(4111),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4111),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4111),
    [anon_sym_AMP_AMP] = ACTIONS(4111),
    [anon_sym_PIPE_PIPE] = ACTIONS(4111),
    [anon_sym_QMARK_QMARK] = ACTIONS(4104),
    [anon_sym_from] = ACTIONS(4108),
    [anon_sym_into] = ACTIONS(4099),
    [anon_sym_join] = ACTIONS(4108),
    [anon_sym_on] = ACTIONS(4099),
    [anon_sym_equals] = ACTIONS(4099),
    [anon_sym_let] = ACTIONS(4108),
    [anon_sym_orderby] = ACTIONS(4108),
    [anon_sym_ascending] = ACTIONS(4099),
    [anon_sym_descending] = ACTIONS(4099),
    [anon_sym_group] = ACTIONS(4108),
    [anon_sym_by] = ACTIONS(4099),
    [anon_sym_select] = ACTIONS(4108),
    [anon_sym_as] = ACTIONS(4104),
    [anon_sym_is] = ACTIONS(4104),
    [anon_sym_DASH_GT] = ACTIONS(4101),
    [anon_sym_with] = ACTIONS(4104),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2933] = {
    [sym__name] = STATE(3008),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2977),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2956),
    [sym_ref_type] = STATE(2899),
    [sym__scoped_base_type] = STATE(2907),
    [sym_identifier] = STATE(2913),
    [sym__reserved_identifier] = STATE(2914),
    [sym_preproc_region] = STATE(2933),
    [sym_preproc_endregion] = STATE(2933),
    [sym_preproc_line] = STATE(2933),
    [sym_preproc_pragma] = STATE(2933),
    [sym_preproc_nullable] = STATE(2933),
    [sym_preproc_error] = STATE(2933),
    [sym_preproc_define] = STATE(2933),
    [sym_preproc_undef] = STATE(2933),
    [sym__identifier_token] = ACTIONS(4490),
    [anon_sym_alias] = ACTIONS(4492),
    [anon_sym_global] = ACTIONS(4492),
    [anon_sym_LBRACK] = ACTIONS(3719),
    [anon_sym_COMMA] = ACTIONS(3719),
    [anon_sym_LPAREN] = ACTIONS(3719),
    [anon_sym_ref] = ACTIONS(4494),
    [anon_sym_LBRACE] = ACTIONS(3719),
    [anon_sym_file] = ACTIONS(4492),
    [anon_sym_LT] = ACTIONS(3721),
    [anon_sym_GT] = ACTIONS(3721),
    [anon_sym_where] = ACTIONS(4001),
    [anon_sym_QMARK] = ACTIONS(3721),
    [anon_sym_notnull] = ACTIONS(4492),
    [anon_sym_unmanaged] = ACTIONS(4492),
    [anon_sym_BANG] = ACTIONS(3721),
    [anon_sym_PLUS_PLUS] = ACTIONS(3719),
    [anon_sym_DASH_DASH] = ACTIONS(3719),
    [anon_sym_PLUS] = ACTIONS(3721),
    [anon_sym_DASH] = ACTIONS(3721),
    [anon_sym_STAR] = ACTIONS(3719),
    [anon_sym_SLASH] = ACTIONS(3721),
    [anon_sym_PERCENT] = ACTIONS(3719),
    [anon_sym_CARET] = ACTIONS(3719),
    [anon_sym_PIPE] = ACTIONS(3721),
    [anon_sym_AMP] = ACTIONS(3721),
    [anon_sym_LT_LT] = ACTIONS(3719),
    [anon_sym_GT_GT] = ACTIONS(3721),
    [anon_sym_GT_GT_GT] = ACTIONS(3719),
    [anon_sym_EQ_EQ] = ACTIONS(3719),
    [anon_sym_BANG_EQ] = ACTIONS(3719),
    [anon_sym_GT_EQ] = ACTIONS(3719),
    [anon_sym_LT_EQ] = ACTIONS(3719),
    [anon_sym_DOT] = ACTIONS(3721),
    [anon_sym_scoped] = ACTIONS(4492),
    [anon_sym_COLON_COLON] = ACTIONS(3719),
    [anon_sym_var] = ACTIONS(4492),
    [anon_sym_yield] = ACTIONS(4492),
    [anon_sym_switch] = ACTIONS(3721),
    [anon_sym_when] = ACTIONS(4492),
    [anon_sym_DOT_DOT] = ACTIONS(3719),
    [anon_sym_and] = ACTIONS(3721),
    [anon_sym_or] = ACTIONS(3721),
    [anon_sym_AMP_AMP] = ACTIONS(3719),
    [anon_sym_PIPE_PIPE] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK] = ACTIONS(3719),
    [anon_sym_from] = ACTIONS(4001),
    [anon_sym_into] = ACTIONS(4492),
    [anon_sym_join] = ACTIONS(4001),
    [anon_sym_on] = ACTIONS(4492),
    [anon_sym_equals] = ACTIONS(4492),
    [anon_sym_let] = ACTIONS(4001),
    [anon_sym_orderby] = ACTIONS(4001),
    [anon_sym_ascending] = ACTIONS(4001),
    [anon_sym_descending] = ACTIONS(4001),
    [anon_sym_group] = ACTIONS(4001),
    [anon_sym_by] = ACTIONS(4492),
    [anon_sym_select] = ACTIONS(4001),
    [anon_sym_as] = ACTIONS(3721),
    [anon_sym_is] = ACTIONS(3721),
    [anon_sym_DASH_GT] = ACTIONS(3719),
    [anon_sym_with] = ACTIONS(3721),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2934] = {
    [sym_preproc_region] = STATE(2934),
    [sym_preproc_endregion] = STATE(2934),
    [sym_preproc_line] = STATE(2934),
    [sym_preproc_pragma] = STATE(2934),
    [sym_preproc_nullable] = STATE(2934),
    [sym_preproc_error] = STATE(2934),
    [sym_preproc_define] = STATE(2934),
    [sym_preproc_undef] = STATE(2934),
    [sym__identifier_token] = ACTIONS(4060),
    [anon_sym_alias] = ACTIONS(4060),
    [anon_sym_SEMI] = ACTIONS(4062),
    [anon_sym_global] = ACTIONS(4060),
    [anon_sym_LBRACK] = ACTIONS(4062),
    [anon_sym_COLON] = ACTIONS(4062),
    [anon_sym_COMMA] = ACTIONS(4062),
    [anon_sym_RBRACK] = ACTIONS(4062),
    [anon_sym_LPAREN] = ACTIONS(4062),
    [anon_sym_RPAREN] = ACTIONS(4062),
    [anon_sym_LBRACE] = ACTIONS(4062),
    [anon_sym_RBRACE] = ACTIONS(4062),
    [anon_sym_file] = ACTIONS(4060),
    [anon_sym_LT] = ACTIONS(4060),
    [anon_sym_GT] = ACTIONS(4060),
    [anon_sym_in] = ACTIONS(4060),
    [anon_sym_where] = ACTIONS(4060),
    [anon_sym_QMARK] = ACTIONS(4060),
    [anon_sym_notnull] = ACTIONS(4060),
    [anon_sym_unmanaged] = ACTIONS(4060),
    [anon_sym_BANG] = ACTIONS(4060),
    [anon_sym_PLUS_PLUS] = ACTIONS(4062),
    [anon_sym_DASH_DASH] = ACTIONS(4062),
    [anon_sym_PLUS] = ACTIONS(4060),
    [anon_sym_DASH] = ACTIONS(4060),
    [anon_sym_STAR] = ACTIONS(4062),
    [anon_sym_SLASH] = ACTIONS(4060),
    [anon_sym_PERCENT] = ACTIONS(4062),
    [anon_sym_CARET] = ACTIONS(4062),
    [anon_sym_PIPE] = ACTIONS(4060),
    [anon_sym_AMP] = ACTIONS(4060),
    [anon_sym_LT_LT] = ACTIONS(4062),
    [anon_sym_GT_GT] = ACTIONS(4060),
    [anon_sym_GT_GT_GT] = ACTIONS(4062),
    [anon_sym_EQ_EQ] = ACTIONS(4062),
    [anon_sym_BANG_EQ] = ACTIONS(4062),
    [anon_sym_GT_EQ] = ACTIONS(4062),
    [anon_sym_LT_EQ] = ACTIONS(4062),
    [anon_sym_DOT] = ACTIONS(4060),
    [anon_sym_scoped] = ACTIONS(4060),
    [anon_sym_EQ_GT] = ACTIONS(4062),
    [anon_sym_var] = ACTIONS(4060),
    [anon_sym_yield] = ACTIONS(4060),
    [anon_sym_switch] = ACTIONS(4060),
    [anon_sym_when] = ACTIONS(4060),
    [sym_discard] = ACTIONS(4060),
    [anon_sym_DOT_DOT] = ACTIONS(4062),
    [anon_sym_and] = ACTIONS(4060),
    [anon_sym_or] = ACTIONS(4060),
    [anon_sym_AMP_AMP] = ACTIONS(4062),
    [anon_sym_PIPE_PIPE] = ACTIONS(4062),
    [anon_sym_QMARK_QMARK] = ACTIONS(4062),
    [anon_sym_from] = ACTIONS(4060),
    [anon_sym_into] = ACTIONS(4060),
    [anon_sym_join] = ACTIONS(4060),
    [anon_sym_on] = ACTIONS(4060),
    [anon_sym_equals] = ACTIONS(4060),
    [anon_sym_let] = ACTIONS(4060),
    [anon_sym_orderby] = ACTIONS(4060),
    [anon_sym_ascending] = ACTIONS(4060),
    [anon_sym_descending] = ACTIONS(4060),
    [anon_sym_group] = ACTIONS(4060),
    [anon_sym_by] = ACTIONS(4060),
    [anon_sym_select] = ACTIONS(4060),
    [anon_sym_as] = ACTIONS(4060),
    [anon_sym_is] = ACTIONS(4060),
    [anon_sym_DASH_GT] = ACTIONS(4062),
    [anon_sym_with] = ACTIONS(4060),
    [aux_sym_preproc_if_token3] = ACTIONS(4062),
    [aux_sym_preproc_else_token1] = ACTIONS(4062),
    [aux_sym_preproc_elif_token1] = ACTIONS(4062),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2935] = {
    [sym_preproc_region] = STATE(2935),
    [sym_preproc_endregion] = STATE(2935),
    [sym_preproc_line] = STATE(2935),
    [sym_preproc_pragma] = STATE(2935),
    [sym_preproc_nullable] = STATE(2935),
    [sym_preproc_error] = STATE(2935),
    [sym_preproc_define] = STATE(2935),
    [sym_preproc_undef] = STATE(2935),
    [sym__identifier_token] = ACTIONS(4113),
    [anon_sym_alias] = ACTIONS(4113),
    [anon_sym_global] = ACTIONS(4113),
    [anon_sym_EQ] = ACTIONS(4118),
    [anon_sym_LBRACK] = ACTIONS(4135),
    [anon_sym_LPAREN] = ACTIONS(4135),
    [anon_sym_file] = ACTIONS(4113),
    [anon_sym_LT] = ACTIONS(4118),
    [anon_sym_GT] = ACTIONS(4118),
    [anon_sym_where] = ACTIONS(4113),
    [anon_sym_QMARK] = ACTIONS(4138),
    [anon_sym_notnull] = ACTIONS(4113),
    [anon_sym_unmanaged] = ACTIONS(4113),
    [anon_sym_BANG] = ACTIONS(4118),
    [anon_sym_PLUS_PLUS] = ACTIONS(4133),
    [anon_sym_DASH_DASH] = ACTIONS(4133),
    [anon_sym_PLUS] = ACTIONS(4118),
    [anon_sym_DASH] = ACTIONS(4118),
    [anon_sym_STAR] = ACTIONS(4138),
    [anon_sym_SLASH] = ACTIONS(4118),
    [anon_sym_PERCENT] = ACTIONS(4118),
    [anon_sym_CARET] = ACTIONS(4118),
    [anon_sym_PIPE] = ACTIONS(4118),
    [anon_sym_AMP] = ACTIONS(4118),
    [anon_sym_LT_LT] = ACTIONS(4118),
    [anon_sym_GT_GT] = ACTIONS(4118),
    [anon_sym_GT_GT_GT] = ACTIONS(4118),
    [anon_sym_EQ_EQ] = ACTIONS(4133),
    [anon_sym_BANG_EQ] = ACTIONS(4133),
    [anon_sym_GT_EQ] = ACTIONS(4133),
    [anon_sym_LT_EQ] = ACTIONS(4133),
    [anon_sym_DOT] = ACTIONS(4138),
    [anon_sym_scoped] = ACTIONS(4113),
    [anon_sym_var] = ACTIONS(4113),
    [anon_sym_yield] = ACTIONS(4113),
    [anon_sym_switch] = ACTIONS(4118),
    [anon_sym_when] = ACTIONS(4113),
    [anon_sym_DOT_DOT] = ACTIONS(4133),
    [anon_sym_and] = ACTIONS(4118),
    [anon_sym_or] = ACTIONS(4118),
    [anon_sym_PLUS_EQ] = ACTIONS(4133),
    [anon_sym_DASH_EQ] = ACTIONS(4133),
    [anon_sym_STAR_EQ] = ACTIONS(4133),
    [anon_sym_SLASH_EQ] = ACTIONS(4133),
    [anon_sym_PERCENT_EQ] = ACTIONS(4133),
    [anon_sym_AMP_EQ] = ACTIONS(4133),
    [anon_sym_CARET_EQ] = ACTIONS(4133),
    [anon_sym_PIPE_EQ] = ACTIONS(4133),
    [anon_sym_LT_LT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4133),
    [anon_sym_AMP_AMP] = ACTIONS(4133),
    [anon_sym_PIPE_PIPE] = ACTIONS(4133),
    [anon_sym_QMARK_QMARK] = ACTIONS(4118),
    [anon_sym_from] = ACTIONS(4113),
    [anon_sym_into] = ACTIONS(4138),
    [anon_sym_join] = ACTIONS(4113),
    [anon_sym_on] = ACTIONS(4113),
    [anon_sym_equals] = ACTIONS(4113),
    [anon_sym_let] = ACTIONS(4113),
    [anon_sym_orderby] = ACTIONS(4113),
    [anon_sym_ascending] = ACTIONS(4113),
    [anon_sym_descending] = ACTIONS(4113),
    [anon_sym_group] = ACTIONS(4113),
    [anon_sym_by] = ACTIONS(4138),
    [anon_sym_select] = ACTIONS(4113),
    [anon_sym_as] = ACTIONS(4118),
    [anon_sym_is] = ACTIONS(4118),
    [anon_sym_DASH_GT] = ACTIONS(4135),
    [anon_sym_with] = ACTIONS(4118),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2936] = {
    [sym_preproc_region] = STATE(2936),
    [sym_preproc_endregion] = STATE(2936),
    [sym_preproc_line] = STATE(2936),
    [sym_preproc_pragma] = STATE(2936),
    [sym_preproc_nullable] = STATE(2936),
    [sym_preproc_error] = STATE(2936),
    [sym_preproc_define] = STATE(2936),
    [sym_preproc_undef] = STATE(2936),
    [sym__identifier_token] = ACTIONS(4496),
    [anon_sym_alias] = ACTIONS(4496),
    [anon_sym_SEMI] = ACTIONS(4498),
    [anon_sym_global] = ACTIONS(4496),
    [anon_sym_LBRACK] = ACTIONS(4498),
    [anon_sym_COLON] = ACTIONS(4498),
    [anon_sym_COMMA] = ACTIONS(4498),
    [anon_sym_RBRACK] = ACTIONS(4498),
    [anon_sym_LPAREN] = ACTIONS(4498),
    [anon_sym_RPAREN] = ACTIONS(4498),
    [anon_sym_LBRACE] = ACTIONS(4498),
    [anon_sym_RBRACE] = ACTIONS(4498),
    [anon_sym_file] = ACTIONS(4496),
    [anon_sym_LT] = ACTIONS(4496),
    [anon_sym_GT] = ACTIONS(4496),
    [anon_sym_in] = ACTIONS(4496),
    [anon_sym_where] = ACTIONS(4496),
    [anon_sym_QMARK] = ACTIONS(4496),
    [anon_sym_notnull] = ACTIONS(4496),
    [anon_sym_unmanaged] = ACTIONS(4496),
    [anon_sym_BANG] = ACTIONS(4496),
    [anon_sym_PLUS_PLUS] = ACTIONS(4498),
    [anon_sym_DASH_DASH] = ACTIONS(4498),
    [anon_sym_PLUS] = ACTIONS(4496),
    [anon_sym_DASH] = ACTIONS(4496),
    [anon_sym_STAR] = ACTIONS(4498),
    [anon_sym_SLASH] = ACTIONS(4496),
    [anon_sym_PERCENT] = ACTIONS(4498),
    [anon_sym_CARET] = ACTIONS(4498),
    [anon_sym_PIPE] = ACTIONS(4496),
    [anon_sym_AMP] = ACTIONS(4496),
    [anon_sym_LT_LT] = ACTIONS(4498),
    [anon_sym_GT_GT] = ACTIONS(4496),
    [anon_sym_GT_GT_GT] = ACTIONS(4498),
    [anon_sym_EQ_EQ] = ACTIONS(4498),
    [anon_sym_BANG_EQ] = ACTIONS(4498),
    [anon_sym_GT_EQ] = ACTIONS(4498),
    [anon_sym_LT_EQ] = ACTIONS(4498),
    [anon_sym_DOT] = ACTIONS(4496),
    [anon_sym_scoped] = ACTIONS(4496),
    [anon_sym_EQ_GT] = ACTIONS(4500),
    [anon_sym_var] = ACTIONS(4496),
    [anon_sym_yield] = ACTIONS(4496),
    [anon_sym_switch] = ACTIONS(4496),
    [anon_sym_when] = ACTIONS(4496),
    [sym_discard] = ACTIONS(4496),
    [anon_sym_DOT_DOT] = ACTIONS(4498),
    [anon_sym_and] = ACTIONS(4496),
    [anon_sym_or] = ACTIONS(4496),
    [anon_sym_AMP_AMP] = ACTIONS(4498),
    [anon_sym_PIPE_PIPE] = ACTIONS(4498),
    [anon_sym_QMARK_QMARK] = ACTIONS(4498),
    [anon_sym_from] = ACTIONS(4496),
    [anon_sym_into] = ACTIONS(4496),
    [anon_sym_join] = ACTIONS(4496),
    [anon_sym_on] = ACTIONS(4496),
    [anon_sym_equals] = ACTIONS(4496),
    [anon_sym_let] = ACTIONS(4496),
    [anon_sym_orderby] = ACTIONS(4496),
    [anon_sym_ascending] = ACTIONS(4496),
    [anon_sym_descending] = ACTIONS(4496),
    [anon_sym_group] = ACTIONS(4496),
    [anon_sym_by] = ACTIONS(4496),
    [anon_sym_select] = ACTIONS(4496),
    [anon_sym_as] = ACTIONS(4496),
    [anon_sym_is] = ACTIONS(4496),
    [anon_sym_DASH_GT] = ACTIONS(4498),
    [anon_sym_with] = ACTIONS(4496),
    [aux_sym_preproc_if_token3] = ACTIONS(4498),
    [aux_sym_preproc_else_token1] = ACTIONS(4498),
    [aux_sym_preproc_elif_token1] = ACTIONS(4498),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2937] = {
    [sym_preproc_region] = STATE(2937),
    [sym_preproc_endregion] = STATE(2937),
    [sym_preproc_line] = STATE(2937),
    [sym_preproc_pragma] = STATE(2937),
    [sym_preproc_nullable] = STATE(2937),
    [sym_preproc_error] = STATE(2937),
    [sym_preproc_define] = STATE(2937),
    [sym_preproc_undef] = STATE(2937),
    [sym__identifier_token] = ACTIONS(4502),
    [anon_sym_alias] = ACTIONS(4502),
    [anon_sym_SEMI] = ACTIONS(4504),
    [anon_sym_global] = ACTIONS(4502),
    [anon_sym_LBRACK] = ACTIONS(4504),
    [anon_sym_COLON] = ACTIONS(4504),
    [anon_sym_COMMA] = ACTIONS(4504),
    [anon_sym_RBRACK] = ACTIONS(4504),
    [anon_sym_LPAREN] = ACTIONS(4504),
    [anon_sym_RPAREN] = ACTIONS(4504),
    [anon_sym_LBRACE] = ACTIONS(4504),
    [anon_sym_RBRACE] = ACTIONS(4504),
    [anon_sym_file] = ACTIONS(4502),
    [anon_sym_LT] = ACTIONS(4502),
    [anon_sym_GT] = ACTIONS(4502),
    [anon_sym_in] = ACTIONS(4502),
    [anon_sym_where] = ACTIONS(4502),
    [anon_sym_QMARK] = ACTIONS(4502),
    [anon_sym_notnull] = ACTIONS(4502),
    [anon_sym_unmanaged] = ACTIONS(4502),
    [anon_sym_BANG] = ACTIONS(4502),
    [anon_sym_PLUS_PLUS] = ACTIONS(4504),
    [anon_sym_DASH_DASH] = ACTIONS(4504),
    [anon_sym_PLUS] = ACTIONS(4502),
    [anon_sym_DASH] = ACTIONS(4502),
    [anon_sym_STAR] = ACTIONS(4504),
    [anon_sym_SLASH] = ACTIONS(4502),
    [anon_sym_PERCENT] = ACTIONS(4504),
    [anon_sym_CARET] = ACTIONS(4504),
    [anon_sym_PIPE] = ACTIONS(4502),
    [anon_sym_AMP] = ACTIONS(4502),
    [anon_sym_LT_LT] = ACTIONS(4504),
    [anon_sym_GT_GT] = ACTIONS(4502),
    [anon_sym_GT_GT_GT] = ACTIONS(4504),
    [anon_sym_EQ_EQ] = ACTIONS(4504),
    [anon_sym_BANG_EQ] = ACTIONS(4504),
    [anon_sym_GT_EQ] = ACTIONS(4504),
    [anon_sym_LT_EQ] = ACTIONS(4504),
    [anon_sym_DOT] = ACTIONS(4502),
    [anon_sym_scoped] = ACTIONS(4502),
    [anon_sym_EQ_GT] = ACTIONS(4504),
    [anon_sym_var] = ACTIONS(4502),
    [anon_sym_yield] = ACTIONS(4502),
    [anon_sym_switch] = ACTIONS(4502),
    [anon_sym_when] = ACTIONS(4502),
    [sym_discard] = ACTIONS(4502),
    [anon_sym_DOT_DOT] = ACTIONS(4504),
    [anon_sym_and] = ACTIONS(4502),
    [anon_sym_or] = ACTIONS(4502),
    [anon_sym_AMP_AMP] = ACTIONS(4504),
    [anon_sym_PIPE_PIPE] = ACTIONS(4504),
    [anon_sym_QMARK_QMARK] = ACTIONS(4504),
    [anon_sym_from] = ACTIONS(4502),
    [anon_sym_into] = ACTIONS(4502),
    [anon_sym_join] = ACTIONS(4502),
    [anon_sym_on] = ACTIONS(4502),
    [anon_sym_equals] = ACTIONS(4502),
    [anon_sym_let] = ACTIONS(4502),
    [anon_sym_orderby] = ACTIONS(4502),
    [anon_sym_ascending] = ACTIONS(4502),
    [anon_sym_descending] = ACTIONS(4502),
    [anon_sym_group] = ACTIONS(4502),
    [anon_sym_by] = ACTIONS(4502),
    [anon_sym_select] = ACTIONS(4502),
    [anon_sym_as] = ACTIONS(4502),
    [anon_sym_is] = ACTIONS(4502),
    [anon_sym_DASH_GT] = ACTIONS(4504),
    [anon_sym_with] = ACTIONS(4502),
    [aux_sym_preproc_if_token3] = ACTIONS(4504),
    [aux_sym_preproc_else_token1] = ACTIONS(4504),
    [aux_sym_preproc_elif_token1] = ACTIONS(4504),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2938] = {
    [sym_preproc_region] = STATE(2938),
    [sym_preproc_endregion] = STATE(2938),
    [sym_preproc_line] = STATE(2938),
    [sym_preproc_pragma] = STATE(2938),
    [sym_preproc_nullable] = STATE(2938),
    [sym_preproc_error] = STATE(2938),
    [sym_preproc_define] = STATE(2938),
    [sym_preproc_undef] = STATE(2938),
    [sym__identifier_token] = ACTIONS(4099),
    [anon_sym_alias] = ACTIONS(4099),
    [anon_sym_global] = ACTIONS(4099),
    [anon_sym_EQ] = ACTIONS(4104),
    [anon_sym_LBRACK] = ACTIONS(4101),
    [anon_sym_LPAREN] = ACTIONS(4101),
    [anon_sym_file] = ACTIONS(4099),
    [anon_sym_LT] = ACTIONS(4104),
    [anon_sym_GT] = ACTIONS(4104),
    [anon_sym_where] = ACTIONS(4099),
    [anon_sym_QMARK] = ACTIONS(4108),
    [anon_sym_notnull] = ACTIONS(4099),
    [anon_sym_unmanaged] = ACTIONS(4099),
    [anon_sym_BANG] = ACTIONS(4104),
    [anon_sym_PLUS_PLUS] = ACTIONS(4111),
    [anon_sym_DASH_DASH] = ACTIONS(4111),
    [anon_sym_PLUS] = ACTIONS(4104),
    [anon_sym_DASH] = ACTIONS(4104),
    [anon_sym_STAR] = ACTIONS(4108),
    [anon_sym_SLASH] = ACTIONS(4104),
    [anon_sym_PERCENT] = ACTIONS(4104),
    [anon_sym_CARET] = ACTIONS(4104),
    [anon_sym_PIPE] = ACTIONS(4104),
    [anon_sym_AMP] = ACTIONS(4104),
    [anon_sym_LT_LT] = ACTIONS(4104),
    [anon_sym_GT_GT] = ACTIONS(4104),
    [anon_sym_GT_GT_GT] = ACTIONS(4104),
    [anon_sym_EQ_EQ] = ACTIONS(4111),
    [anon_sym_BANG_EQ] = ACTIONS(4111),
    [anon_sym_GT_EQ] = ACTIONS(4111),
    [anon_sym_LT_EQ] = ACTIONS(4111),
    [anon_sym_DOT] = ACTIONS(4108),
    [anon_sym_scoped] = ACTIONS(4099),
    [anon_sym_var] = ACTIONS(4099),
    [anon_sym_yield] = ACTIONS(4099),
    [anon_sym_switch] = ACTIONS(4104),
    [anon_sym_when] = ACTIONS(4099),
    [anon_sym_DOT_DOT] = ACTIONS(4111),
    [anon_sym_and] = ACTIONS(4104),
    [anon_sym_or] = ACTIONS(4104),
    [anon_sym_PLUS_EQ] = ACTIONS(4111),
    [anon_sym_DASH_EQ] = ACTIONS(4111),
    [anon_sym_STAR_EQ] = ACTIONS(4111),
    [anon_sym_SLASH_EQ] = ACTIONS(4111),
    [anon_sym_PERCENT_EQ] = ACTIONS(4111),
    [anon_sym_AMP_EQ] = ACTIONS(4111),
    [anon_sym_CARET_EQ] = ACTIONS(4111),
    [anon_sym_PIPE_EQ] = ACTIONS(4111),
    [anon_sym_LT_LT_EQ] = ACTIONS(4111),
    [anon_sym_GT_GT_EQ] = ACTIONS(4111),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4111),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4111),
    [anon_sym_AMP_AMP] = ACTIONS(4111),
    [anon_sym_PIPE_PIPE] = ACTIONS(4111),
    [anon_sym_QMARK_QMARK] = ACTIONS(4104),
    [anon_sym_from] = ACTIONS(4099),
    [anon_sym_into] = ACTIONS(4099),
    [anon_sym_join] = ACTIONS(4099),
    [anon_sym_on] = ACTIONS(4099),
    [anon_sym_equals] = ACTIONS(4108),
    [anon_sym_let] = ACTIONS(4099),
    [anon_sym_orderby] = ACTIONS(4099),
    [anon_sym_ascending] = ACTIONS(4099),
    [anon_sym_descending] = ACTIONS(4099),
    [anon_sym_group] = ACTIONS(4099),
    [anon_sym_by] = ACTIONS(4099),
    [anon_sym_select] = ACTIONS(4099),
    [anon_sym_as] = ACTIONS(4104),
    [anon_sym_is] = ACTIONS(4104),
    [anon_sym_DASH_GT] = ACTIONS(4101),
    [anon_sym_with] = ACTIONS(4104),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2939] = {
    [sym_preproc_region] = STATE(2939),
    [sym_preproc_endregion] = STATE(2939),
    [sym_preproc_line] = STATE(2939),
    [sym_preproc_pragma] = STATE(2939),
    [sym_preproc_nullable] = STATE(2939),
    [sym_preproc_error] = STATE(2939),
    [sym_preproc_define] = STATE(2939),
    [sym_preproc_undef] = STATE(2939),
    [sym__identifier_token] = ACTIONS(4113),
    [anon_sym_alias] = ACTIONS(4113),
    [anon_sym_global] = ACTIONS(4113),
    [anon_sym_EQ] = ACTIONS(4118),
    [anon_sym_LBRACK] = ACTIONS(4135),
    [anon_sym_LPAREN] = ACTIONS(4135),
    [anon_sym_file] = ACTIONS(4113),
    [anon_sym_LT] = ACTIONS(4118),
    [anon_sym_GT] = ACTIONS(4118),
    [anon_sym_where] = ACTIONS(4113),
    [anon_sym_QMARK] = ACTIONS(4138),
    [anon_sym_notnull] = ACTIONS(4113),
    [anon_sym_unmanaged] = ACTIONS(4113),
    [anon_sym_BANG] = ACTIONS(4118),
    [anon_sym_PLUS_PLUS] = ACTIONS(4133),
    [anon_sym_DASH_DASH] = ACTIONS(4133),
    [anon_sym_PLUS] = ACTIONS(4118),
    [anon_sym_DASH] = ACTIONS(4118),
    [anon_sym_STAR] = ACTIONS(4138),
    [anon_sym_SLASH] = ACTIONS(4118),
    [anon_sym_PERCENT] = ACTIONS(4118),
    [anon_sym_CARET] = ACTIONS(4118),
    [anon_sym_PIPE] = ACTIONS(4118),
    [anon_sym_AMP] = ACTIONS(4118),
    [anon_sym_LT_LT] = ACTIONS(4118),
    [anon_sym_GT_GT] = ACTIONS(4118),
    [anon_sym_GT_GT_GT] = ACTIONS(4118),
    [anon_sym_EQ_EQ] = ACTIONS(4133),
    [anon_sym_BANG_EQ] = ACTIONS(4133),
    [anon_sym_GT_EQ] = ACTIONS(4133),
    [anon_sym_LT_EQ] = ACTIONS(4133),
    [anon_sym_DOT] = ACTIONS(4138),
    [anon_sym_scoped] = ACTIONS(4113),
    [anon_sym_var] = ACTIONS(4113),
    [anon_sym_yield] = ACTIONS(4113),
    [anon_sym_switch] = ACTIONS(4118),
    [anon_sym_when] = ACTIONS(4113),
    [anon_sym_DOT_DOT] = ACTIONS(4133),
    [anon_sym_and] = ACTIONS(4118),
    [anon_sym_or] = ACTIONS(4118),
    [anon_sym_PLUS_EQ] = ACTIONS(4133),
    [anon_sym_DASH_EQ] = ACTIONS(4133),
    [anon_sym_STAR_EQ] = ACTIONS(4133),
    [anon_sym_SLASH_EQ] = ACTIONS(4133),
    [anon_sym_PERCENT_EQ] = ACTIONS(4133),
    [anon_sym_AMP_EQ] = ACTIONS(4133),
    [anon_sym_CARET_EQ] = ACTIONS(4133),
    [anon_sym_PIPE_EQ] = ACTIONS(4133),
    [anon_sym_LT_LT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4133),
    [anon_sym_AMP_AMP] = ACTIONS(4133),
    [anon_sym_PIPE_PIPE] = ACTIONS(4133),
    [anon_sym_QMARK_QMARK] = ACTIONS(4118),
    [anon_sym_from] = ACTIONS(4113),
    [anon_sym_into] = ACTIONS(4113),
    [anon_sym_join] = ACTIONS(4113),
    [anon_sym_on] = ACTIONS(4113),
    [anon_sym_equals] = ACTIONS(4138),
    [anon_sym_let] = ACTIONS(4113),
    [anon_sym_orderby] = ACTIONS(4113),
    [anon_sym_ascending] = ACTIONS(4113),
    [anon_sym_descending] = ACTIONS(4113),
    [anon_sym_group] = ACTIONS(4113),
    [anon_sym_by] = ACTIONS(4113),
    [anon_sym_select] = ACTIONS(4113),
    [anon_sym_as] = ACTIONS(4118),
    [anon_sym_is] = ACTIONS(4118),
    [anon_sym_DASH_GT] = ACTIONS(4135),
    [anon_sym_with] = ACTIONS(4118),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2940] = {
    [sym_preproc_region] = STATE(2940),
    [sym_preproc_endregion] = STATE(2940),
    [sym_preproc_line] = STATE(2940),
    [sym_preproc_pragma] = STATE(2940),
    [sym_preproc_nullable] = STATE(2940),
    [sym_preproc_error] = STATE(2940),
    [sym_preproc_define] = STATE(2940),
    [sym_preproc_undef] = STATE(2940),
    [sym__identifier_token] = ACTIONS(4113),
    [anon_sym_alias] = ACTIONS(4113),
    [anon_sym_global] = ACTIONS(4113),
    [anon_sym_EQ] = ACTIONS(4118),
    [anon_sym_LBRACK] = ACTIONS(4135),
    [anon_sym_LPAREN] = ACTIONS(4135),
    [anon_sym_file] = ACTIONS(4113),
    [anon_sym_LT] = ACTIONS(4118),
    [anon_sym_GT] = ACTIONS(4118),
    [anon_sym_where] = ACTIONS(4113),
    [anon_sym_QMARK] = ACTIONS(4138),
    [anon_sym_notnull] = ACTIONS(4113),
    [anon_sym_unmanaged] = ACTIONS(4113),
    [anon_sym_BANG] = ACTIONS(4118),
    [anon_sym_PLUS_PLUS] = ACTIONS(4133),
    [anon_sym_DASH_DASH] = ACTIONS(4133),
    [anon_sym_PLUS] = ACTIONS(4118),
    [anon_sym_DASH] = ACTIONS(4118),
    [anon_sym_STAR] = ACTIONS(4138),
    [anon_sym_SLASH] = ACTIONS(4118),
    [anon_sym_PERCENT] = ACTIONS(4118),
    [anon_sym_CARET] = ACTIONS(4118),
    [anon_sym_PIPE] = ACTIONS(4118),
    [anon_sym_AMP] = ACTIONS(4118),
    [anon_sym_LT_LT] = ACTIONS(4118),
    [anon_sym_GT_GT] = ACTIONS(4118),
    [anon_sym_GT_GT_GT] = ACTIONS(4118),
    [anon_sym_EQ_EQ] = ACTIONS(4133),
    [anon_sym_BANG_EQ] = ACTIONS(4133),
    [anon_sym_GT_EQ] = ACTIONS(4133),
    [anon_sym_LT_EQ] = ACTIONS(4133),
    [anon_sym_DOT] = ACTIONS(4138),
    [anon_sym_scoped] = ACTIONS(4113),
    [anon_sym_var] = ACTIONS(4113),
    [anon_sym_yield] = ACTIONS(4113),
    [anon_sym_switch] = ACTIONS(4118),
    [anon_sym_when] = ACTIONS(4113),
    [anon_sym_DOT_DOT] = ACTIONS(4133),
    [anon_sym_and] = ACTIONS(4118),
    [anon_sym_or] = ACTIONS(4118),
    [anon_sym_PLUS_EQ] = ACTIONS(4133),
    [anon_sym_DASH_EQ] = ACTIONS(4133),
    [anon_sym_STAR_EQ] = ACTIONS(4133),
    [anon_sym_SLASH_EQ] = ACTIONS(4133),
    [anon_sym_PERCENT_EQ] = ACTIONS(4133),
    [anon_sym_AMP_EQ] = ACTIONS(4133),
    [anon_sym_CARET_EQ] = ACTIONS(4133),
    [anon_sym_PIPE_EQ] = ACTIONS(4133),
    [anon_sym_LT_LT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4133),
    [anon_sym_AMP_AMP] = ACTIONS(4133),
    [anon_sym_PIPE_PIPE] = ACTIONS(4133),
    [anon_sym_QMARK_QMARK] = ACTIONS(4118),
    [anon_sym_from] = ACTIONS(4113),
    [anon_sym_into] = ACTIONS(4113),
    [anon_sym_join] = ACTIONS(4113),
    [anon_sym_on] = ACTIONS(4113),
    [anon_sym_equals] = ACTIONS(4113),
    [anon_sym_let] = ACTIONS(4113),
    [anon_sym_orderby] = ACTIONS(4113),
    [anon_sym_ascending] = ACTIONS(4113),
    [anon_sym_descending] = ACTIONS(4113),
    [anon_sym_group] = ACTIONS(4113),
    [anon_sym_by] = ACTIONS(4138),
    [anon_sym_select] = ACTIONS(4113),
    [anon_sym_as] = ACTIONS(4118),
    [anon_sym_is] = ACTIONS(4118),
    [anon_sym_DASH_GT] = ACTIONS(4135),
    [anon_sym_with] = ACTIONS(4118),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2941] = {
    [sym_preproc_region] = STATE(2941),
    [sym_preproc_endregion] = STATE(2941),
    [sym_preproc_line] = STATE(2941),
    [sym_preproc_pragma] = STATE(2941),
    [sym_preproc_nullable] = STATE(2941),
    [sym_preproc_error] = STATE(2941),
    [sym_preproc_define] = STATE(2941),
    [sym_preproc_undef] = STATE(2941),
    [sym__identifier_token] = ACTIONS(4099),
    [anon_sym_alias] = ACTIONS(4099),
    [anon_sym_global] = ACTIONS(4099),
    [anon_sym_EQ] = ACTIONS(4104),
    [anon_sym_LBRACK] = ACTIONS(4101),
    [anon_sym_LPAREN] = ACTIONS(4101),
    [anon_sym_file] = ACTIONS(4099),
    [anon_sym_LT] = ACTIONS(4104),
    [anon_sym_GT] = ACTIONS(4104),
    [anon_sym_where] = ACTIONS(4099),
    [anon_sym_QMARK] = ACTIONS(4108),
    [anon_sym_notnull] = ACTIONS(4099),
    [anon_sym_unmanaged] = ACTIONS(4099),
    [anon_sym_BANG] = ACTIONS(4104),
    [anon_sym_PLUS_PLUS] = ACTIONS(4111),
    [anon_sym_DASH_DASH] = ACTIONS(4111),
    [anon_sym_PLUS] = ACTIONS(4104),
    [anon_sym_DASH] = ACTIONS(4104),
    [anon_sym_STAR] = ACTIONS(4108),
    [anon_sym_SLASH] = ACTIONS(4104),
    [anon_sym_PERCENT] = ACTIONS(4104),
    [anon_sym_CARET] = ACTIONS(4104),
    [anon_sym_PIPE] = ACTIONS(4104),
    [anon_sym_AMP] = ACTIONS(4104),
    [anon_sym_LT_LT] = ACTIONS(4104),
    [anon_sym_GT_GT] = ACTIONS(4104),
    [anon_sym_GT_GT_GT] = ACTIONS(4104),
    [anon_sym_EQ_EQ] = ACTIONS(4111),
    [anon_sym_BANG_EQ] = ACTIONS(4111),
    [anon_sym_GT_EQ] = ACTIONS(4111),
    [anon_sym_LT_EQ] = ACTIONS(4111),
    [anon_sym_DOT] = ACTIONS(4108),
    [anon_sym_scoped] = ACTIONS(4099),
    [anon_sym_var] = ACTIONS(4099),
    [anon_sym_yield] = ACTIONS(4099),
    [anon_sym_switch] = ACTIONS(4104),
    [anon_sym_when] = ACTIONS(4099),
    [anon_sym_DOT_DOT] = ACTIONS(4111),
    [anon_sym_and] = ACTIONS(4104),
    [anon_sym_or] = ACTIONS(4104),
    [anon_sym_PLUS_EQ] = ACTIONS(4111),
    [anon_sym_DASH_EQ] = ACTIONS(4111),
    [anon_sym_STAR_EQ] = ACTIONS(4111),
    [anon_sym_SLASH_EQ] = ACTIONS(4111),
    [anon_sym_PERCENT_EQ] = ACTIONS(4111),
    [anon_sym_AMP_EQ] = ACTIONS(4111),
    [anon_sym_CARET_EQ] = ACTIONS(4111),
    [anon_sym_PIPE_EQ] = ACTIONS(4111),
    [anon_sym_LT_LT_EQ] = ACTIONS(4111),
    [anon_sym_GT_GT_EQ] = ACTIONS(4111),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4111),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4111),
    [anon_sym_AMP_AMP] = ACTIONS(4111),
    [anon_sym_PIPE_PIPE] = ACTIONS(4111),
    [anon_sym_QMARK_QMARK] = ACTIONS(4104),
    [anon_sym_from] = ACTIONS(4099),
    [anon_sym_into] = ACTIONS(4099),
    [anon_sym_join] = ACTIONS(4099),
    [anon_sym_on] = ACTIONS(4099),
    [anon_sym_equals] = ACTIONS(4099),
    [anon_sym_let] = ACTIONS(4099),
    [anon_sym_orderby] = ACTIONS(4099),
    [anon_sym_ascending] = ACTIONS(4099),
    [anon_sym_descending] = ACTIONS(4099),
    [anon_sym_group] = ACTIONS(4099),
    [anon_sym_by] = ACTIONS(4108),
    [anon_sym_select] = ACTIONS(4099),
    [anon_sym_as] = ACTIONS(4104),
    [anon_sym_is] = ACTIONS(4104),
    [anon_sym_DASH_GT] = ACTIONS(4101),
    [anon_sym_with] = ACTIONS(4104),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2942] = {
    [sym_parameter_list] = STATE(9765),
    [sym_positional_pattern_clause] = STATE(3047),
    [sym_property_pattern_clause] = STATE(3117),
    [sym__variable_designation] = STATE(5398),
    [sym_parenthesized_variable_designation] = STATE(5390),
    [sym__lambda_parameters] = STATE(9127),
    [sym_identifier] = STATE(5303),
    [sym__reserved_identifier] = STATE(5128),
    [sym_preproc_region] = STATE(2942),
    [sym_preproc_endregion] = STATE(2942),
    [sym_preproc_line] = STATE(2942),
    [sym_preproc_pragma] = STATE(2942),
    [sym_preproc_nullable] = STATE(2942),
    [sym_preproc_error] = STATE(2942),
    [sym_preproc_define] = STATE(2942),
    [sym_preproc_undef] = STATE(2942),
    [sym__identifier_token] = ACTIONS(4482),
    [anon_sym_alias] = ACTIONS(4484),
    [anon_sym_global] = ACTIONS(4484),
    [anon_sym_LBRACK] = ACTIONS(4283),
    [anon_sym_COLON] = ACTIONS(4283),
    [anon_sym_COMMA] = ACTIONS(4283),
    [anon_sym_LPAREN] = ACTIONS(4283),
    [anon_sym_LBRACE] = ACTIONS(4486),
    [anon_sym_file] = ACTIONS(4484),
    [anon_sym_LT] = ACTIONS(4285),
    [anon_sym_GT] = ACTIONS(4285),
    [anon_sym_where] = ACTIONS(4484),
    [anon_sym_QMARK] = ACTIONS(4285),
    [anon_sym_notnull] = ACTIONS(4484),
    [anon_sym_unmanaged] = ACTIONS(4484),
    [anon_sym_BANG] = ACTIONS(4285),
    [anon_sym_PLUS_PLUS] = ACTIONS(4283),
    [anon_sym_DASH_DASH] = ACTIONS(4283),
    [anon_sym_PLUS] = ACTIONS(4285),
    [anon_sym_DASH] = ACTIONS(4285),
    [anon_sym_STAR] = ACTIONS(4283),
    [anon_sym_SLASH] = ACTIONS(4285),
    [anon_sym_PERCENT] = ACTIONS(4283),
    [anon_sym_CARET] = ACTIONS(4283),
    [anon_sym_PIPE] = ACTIONS(4285),
    [anon_sym_AMP] = ACTIONS(4285),
    [anon_sym_LT_LT] = ACTIONS(4283),
    [anon_sym_GT_GT] = ACTIONS(4285),
    [anon_sym_GT_GT_GT] = ACTIONS(4283),
    [anon_sym_EQ_EQ] = ACTIONS(4283),
    [anon_sym_BANG_EQ] = ACTIONS(4283),
    [anon_sym_GT_EQ] = ACTIONS(4283),
    [anon_sym_LT_EQ] = ACTIONS(4283),
    [anon_sym_DOT] = ACTIONS(4285),
    [anon_sym_scoped] = ACTIONS(4484),
    [anon_sym_var] = ACTIONS(4484),
    [anon_sym_yield] = ACTIONS(4484),
    [anon_sym_switch] = ACTIONS(4285),
    [anon_sym_when] = ACTIONS(4484),
    [sym_discard] = ACTIONS(4488),
    [anon_sym_DOT_DOT] = ACTIONS(4283),
    [anon_sym_and] = ACTIONS(4285),
    [anon_sym_or] = ACTIONS(4285),
    [anon_sym_AMP_AMP] = ACTIONS(4283),
    [anon_sym_PIPE_PIPE] = ACTIONS(4283),
    [anon_sym_QMARK_QMARK] = ACTIONS(4283),
    [anon_sym_from] = ACTIONS(4484),
    [anon_sym_into] = ACTIONS(4484),
    [anon_sym_join] = ACTIONS(4484),
    [anon_sym_on] = ACTIONS(4484),
    [anon_sym_equals] = ACTIONS(4484),
    [anon_sym_let] = ACTIONS(4484),
    [anon_sym_orderby] = ACTIONS(4484),
    [anon_sym_ascending] = ACTIONS(4484),
    [anon_sym_descending] = ACTIONS(4484),
    [anon_sym_group] = ACTIONS(4484),
    [anon_sym_by] = ACTIONS(4484),
    [anon_sym_select] = ACTIONS(4484),
    [anon_sym_as] = ACTIONS(4285),
    [anon_sym_is] = ACTIONS(4285),
    [anon_sym_DASH_GT] = ACTIONS(4283),
    [anon_sym_with] = ACTIONS(4285),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4283),
  },
  [2943] = {
    [sym_preproc_region] = STATE(2943),
    [sym_preproc_endregion] = STATE(2943),
    [sym_preproc_line] = STATE(2943),
    [sym_preproc_pragma] = STATE(2943),
    [sym_preproc_nullable] = STATE(2943),
    [sym_preproc_error] = STATE(2943),
    [sym_preproc_define] = STATE(2943),
    [sym_preproc_undef] = STATE(2943),
    [sym__identifier_token] = ACTIONS(4066),
    [anon_sym_alias] = ACTIONS(4066),
    [anon_sym_SEMI] = ACTIONS(4068),
    [anon_sym_global] = ACTIONS(4066),
    [anon_sym_LBRACK] = ACTIONS(4068),
    [anon_sym_COLON] = ACTIONS(4068),
    [anon_sym_COMMA] = ACTIONS(4068),
    [anon_sym_RBRACK] = ACTIONS(4068),
    [anon_sym_LPAREN] = ACTIONS(4068),
    [anon_sym_RPAREN] = ACTIONS(4068),
    [anon_sym_LBRACE] = ACTIONS(4068),
    [anon_sym_RBRACE] = ACTIONS(4068),
    [anon_sym_file] = ACTIONS(4066),
    [anon_sym_LT] = ACTIONS(4066),
    [anon_sym_GT] = ACTIONS(4066),
    [anon_sym_in] = ACTIONS(4066),
    [anon_sym_where] = ACTIONS(4066),
    [anon_sym_QMARK] = ACTIONS(4066),
    [anon_sym_notnull] = ACTIONS(4066),
    [anon_sym_unmanaged] = ACTIONS(4066),
    [anon_sym_BANG] = ACTIONS(4066),
    [anon_sym_PLUS_PLUS] = ACTIONS(4068),
    [anon_sym_DASH_DASH] = ACTIONS(4068),
    [anon_sym_PLUS] = ACTIONS(4066),
    [anon_sym_DASH] = ACTIONS(4066),
    [anon_sym_STAR] = ACTIONS(4068),
    [anon_sym_SLASH] = ACTIONS(4066),
    [anon_sym_PERCENT] = ACTIONS(4068),
    [anon_sym_CARET] = ACTIONS(4068),
    [anon_sym_PIPE] = ACTIONS(4066),
    [anon_sym_AMP] = ACTIONS(4066),
    [anon_sym_LT_LT] = ACTIONS(4068),
    [anon_sym_GT_GT] = ACTIONS(4066),
    [anon_sym_GT_GT_GT] = ACTIONS(4068),
    [anon_sym_EQ_EQ] = ACTIONS(4068),
    [anon_sym_BANG_EQ] = ACTIONS(4068),
    [anon_sym_GT_EQ] = ACTIONS(4068),
    [anon_sym_LT_EQ] = ACTIONS(4068),
    [anon_sym_DOT] = ACTIONS(4066),
    [anon_sym_scoped] = ACTIONS(4066),
    [anon_sym_EQ_GT] = ACTIONS(4068),
    [anon_sym_var] = ACTIONS(4066),
    [anon_sym_yield] = ACTIONS(4066),
    [anon_sym_switch] = ACTIONS(4066),
    [anon_sym_when] = ACTIONS(4066),
    [sym_discard] = ACTIONS(4066),
    [anon_sym_DOT_DOT] = ACTIONS(4068),
    [anon_sym_and] = ACTIONS(4066),
    [anon_sym_or] = ACTIONS(4066),
    [anon_sym_AMP_AMP] = ACTIONS(4068),
    [anon_sym_PIPE_PIPE] = ACTIONS(4068),
    [anon_sym_QMARK_QMARK] = ACTIONS(4068),
    [anon_sym_from] = ACTIONS(4066),
    [anon_sym_into] = ACTIONS(4066),
    [anon_sym_join] = ACTIONS(4066),
    [anon_sym_on] = ACTIONS(4066),
    [anon_sym_equals] = ACTIONS(4066),
    [anon_sym_let] = ACTIONS(4066),
    [anon_sym_orderby] = ACTIONS(4066),
    [anon_sym_ascending] = ACTIONS(4066),
    [anon_sym_descending] = ACTIONS(4066),
    [anon_sym_group] = ACTIONS(4066),
    [anon_sym_by] = ACTIONS(4066),
    [anon_sym_select] = ACTIONS(4066),
    [anon_sym_as] = ACTIONS(4066),
    [anon_sym_is] = ACTIONS(4066),
    [anon_sym_DASH_GT] = ACTIONS(4068),
    [anon_sym_with] = ACTIONS(4066),
    [aux_sym_preproc_if_token3] = ACTIONS(4068),
    [aux_sym_preproc_else_token1] = ACTIONS(4068),
    [aux_sym_preproc_elif_token1] = ACTIONS(4068),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2944] = {
    [sym_preproc_region] = STATE(2944),
    [sym_preproc_endregion] = STATE(2944),
    [sym_preproc_line] = STATE(2944),
    [sym_preproc_pragma] = STATE(2944),
    [sym_preproc_nullable] = STATE(2944),
    [sym_preproc_error] = STATE(2944),
    [sym_preproc_define] = STATE(2944),
    [sym_preproc_undef] = STATE(2944),
    [sym__identifier_token] = ACTIONS(4113),
    [anon_sym_alias] = ACTIONS(4113),
    [anon_sym_global] = ACTIONS(4113),
    [anon_sym_EQ] = ACTIONS(4118),
    [anon_sym_LBRACK] = ACTIONS(4135),
    [anon_sym_LPAREN] = ACTIONS(4135),
    [anon_sym_file] = ACTIONS(4113),
    [anon_sym_LT] = ACTIONS(4118),
    [anon_sym_GT] = ACTIONS(4118),
    [anon_sym_where] = ACTIONS(4113),
    [anon_sym_QMARK] = ACTIONS(4138),
    [anon_sym_notnull] = ACTIONS(4113),
    [anon_sym_unmanaged] = ACTIONS(4113),
    [anon_sym_BANG] = ACTIONS(4118),
    [anon_sym_PLUS_PLUS] = ACTIONS(4133),
    [anon_sym_DASH_DASH] = ACTIONS(4133),
    [anon_sym_PLUS] = ACTIONS(4118),
    [anon_sym_DASH] = ACTIONS(4118),
    [anon_sym_STAR] = ACTIONS(4138),
    [anon_sym_SLASH] = ACTIONS(4118),
    [anon_sym_PERCENT] = ACTIONS(4118),
    [anon_sym_CARET] = ACTIONS(4118),
    [anon_sym_PIPE] = ACTIONS(4118),
    [anon_sym_AMP] = ACTIONS(4118),
    [anon_sym_LT_LT] = ACTIONS(4118),
    [anon_sym_GT_GT] = ACTIONS(4118),
    [anon_sym_GT_GT_GT] = ACTIONS(4118),
    [anon_sym_EQ_EQ] = ACTIONS(4133),
    [anon_sym_BANG_EQ] = ACTIONS(4133),
    [anon_sym_GT_EQ] = ACTIONS(4133),
    [anon_sym_LT_EQ] = ACTIONS(4133),
    [anon_sym_DOT] = ACTIONS(4138),
    [anon_sym_scoped] = ACTIONS(4113),
    [anon_sym_var] = ACTIONS(4113),
    [anon_sym_yield] = ACTIONS(4113),
    [anon_sym_switch] = ACTIONS(4118),
    [anon_sym_when] = ACTIONS(4113),
    [anon_sym_DOT_DOT] = ACTIONS(4133),
    [anon_sym_and] = ACTIONS(4118),
    [anon_sym_or] = ACTIONS(4118),
    [anon_sym_PLUS_EQ] = ACTIONS(4133),
    [anon_sym_DASH_EQ] = ACTIONS(4133),
    [anon_sym_STAR_EQ] = ACTIONS(4133),
    [anon_sym_SLASH_EQ] = ACTIONS(4133),
    [anon_sym_PERCENT_EQ] = ACTIONS(4133),
    [anon_sym_AMP_EQ] = ACTIONS(4133),
    [anon_sym_CARET_EQ] = ACTIONS(4133),
    [anon_sym_PIPE_EQ] = ACTIONS(4133),
    [anon_sym_LT_LT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4133),
    [anon_sym_AMP_AMP] = ACTIONS(4133),
    [anon_sym_PIPE_PIPE] = ACTIONS(4133),
    [anon_sym_QMARK_QMARK] = ACTIONS(4118),
    [anon_sym_from] = ACTIONS(4113),
    [anon_sym_into] = ACTIONS(4138),
    [anon_sym_join] = ACTIONS(4113),
    [anon_sym_on] = ACTIONS(4113),
    [anon_sym_equals] = ACTIONS(4138),
    [anon_sym_let] = ACTIONS(4113),
    [anon_sym_orderby] = ACTIONS(4113),
    [anon_sym_ascending] = ACTIONS(4113),
    [anon_sym_descending] = ACTIONS(4113),
    [anon_sym_group] = ACTIONS(4113),
    [anon_sym_by] = ACTIONS(4113),
    [anon_sym_select] = ACTIONS(4113),
    [anon_sym_as] = ACTIONS(4118),
    [anon_sym_is] = ACTIONS(4118),
    [anon_sym_DASH_GT] = ACTIONS(4135),
    [anon_sym_with] = ACTIONS(4118),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2945] = {
    [sym_type_argument_list] = STATE(2979),
    [sym_preproc_region] = STATE(2945),
    [sym_preproc_endregion] = STATE(2945),
    [sym_preproc_line] = STATE(2945),
    [sym_preproc_pragma] = STATE(2945),
    [sym_preproc_nullable] = STATE(2945),
    [sym_preproc_error] = STATE(2945),
    [sym_preproc_define] = STATE(2945),
    [sym_preproc_undef] = STATE(2945),
    [anon_sym_SEMI] = ACTIONS(4076),
    [anon_sym_EQ] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4076),
    [anon_sym_COLON] = ACTIONS(4076),
    [anon_sym_COMMA] = ACTIONS(4076),
    [anon_sym_RBRACK] = ACTIONS(4076),
    [anon_sym_LPAREN] = ACTIONS(4076),
    [anon_sym_RPAREN] = ACTIONS(4076),
    [anon_sym_RBRACE] = ACTIONS(4076),
    [anon_sym_LT] = ACTIONS(4506),
    [anon_sym_GT] = ACTIONS(4074),
    [anon_sym_in] = ACTIONS(4074),
    [anon_sym_where] = ACTIONS(4076),
    [anon_sym_QMARK] = ACTIONS(4074),
    [anon_sym_BANG] = ACTIONS(4074),
    [anon_sym_PLUS_PLUS] = ACTIONS(4076),
    [anon_sym_DASH_DASH] = ACTIONS(4076),
    [anon_sym_PLUS] = ACTIONS(4074),
    [anon_sym_DASH] = ACTIONS(4074),
    [anon_sym_STAR] = ACTIONS(4074),
    [anon_sym_SLASH] = ACTIONS(4074),
    [anon_sym_PERCENT] = ACTIONS(4074),
    [anon_sym_CARET] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(4074),
    [anon_sym_AMP] = ACTIONS(4074),
    [anon_sym_LT_LT] = ACTIONS(4074),
    [anon_sym_GT_GT] = ACTIONS(4074),
    [anon_sym_GT_GT_GT] = ACTIONS(4074),
    [anon_sym_EQ_EQ] = ACTIONS(4076),
    [anon_sym_BANG_EQ] = ACTIONS(4076),
    [anon_sym_GT_EQ] = ACTIONS(4076),
    [anon_sym_LT_EQ] = ACTIONS(4076),
    [anon_sym_DOT] = ACTIONS(4074),
    [anon_sym_EQ_GT] = ACTIONS(4076),
    [anon_sym_switch] = ACTIONS(4076),
    [anon_sym_DOT_DOT] = ACTIONS(4076),
    [anon_sym_and] = ACTIONS(4076),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_PLUS_EQ] = ACTIONS(4076),
    [anon_sym_DASH_EQ] = ACTIONS(4076),
    [anon_sym_STAR_EQ] = ACTIONS(4076),
    [anon_sym_SLASH_EQ] = ACTIONS(4076),
    [anon_sym_PERCENT_EQ] = ACTIONS(4076),
    [anon_sym_AMP_EQ] = ACTIONS(4076),
    [anon_sym_CARET_EQ] = ACTIONS(4076),
    [anon_sym_PIPE_EQ] = ACTIONS(4076),
    [anon_sym_LT_LT_EQ] = ACTIONS(4076),
    [anon_sym_GT_GT_EQ] = ACTIONS(4076),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4076),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4076),
    [anon_sym_AMP_AMP] = ACTIONS(4076),
    [anon_sym_PIPE_PIPE] = ACTIONS(4076),
    [anon_sym_QMARK_QMARK] = ACTIONS(4074),
    [anon_sym_from] = ACTIONS(4076),
    [anon_sym_into] = ACTIONS(4076),
    [anon_sym_join] = ACTIONS(4076),
    [anon_sym_on] = ACTIONS(4076),
    [anon_sym_equals] = ACTIONS(4076),
    [anon_sym_let] = ACTIONS(4076),
    [anon_sym_orderby] = ACTIONS(4076),
    [anon_sym_group] = ACTIONS(4076),
    [anon_sym_by] = ACTIONS(4076),
    [anon_sym_select] = ACTIONS(4076),
    [anon_sym_as] = ACTIONS(4076),
    [anon_sym_is] = ACTIONS(4076),
    [anon_sym_DASH_GT] = ACTIONS(4076),
    [anon_sym_with] = ACTIONS(4076),
    [aux_sym_preproc_if_token3] = ACTIONS(4076),
    [aux_sym_preproc_else_token1] = ACTIONS(4076),
    [aux_sym_preproc_elif_token1] = ACTIONS(4076),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2946] = {
    [sym_parameter_list] = STATE(9765),
    [sym_positional_pattern_clause] = STATE(3047),
    [sym_property_pattern_clause] = STATE(3117),
    [sym__variable_designation] = STATE(5398),
    [sym_parenthesized_variable_designation] = STATE(5390),
    [sym__lambda_parameters] = STATE(9127),
    [sym_identifier] = STATE(5303),
    [sym__reserved_identifier] = STATE(5128),
    [sym_preproc_region] = STATE(2946),
    [sym_preproc_endregion] = STATE(2946),
    [sym_preproc_line] = STATE(2946),
    [sym_preproc_pragma] = STATE(2946),
    [sym_preproc_nullable] = STATE(2946),
    [sym_preproc_error] = STATE(2946),
    [sym_preproc_define] = STATE(2946),
    [sym_preproc_undef] = STATE(2946),
    [sym__identifier_token] = ACTIONS(4482),
    [anon_sym_alias] = ACTIONS(4484),
    [anon_sym_global] = ACTIONS(4484),
    [anon_sym_LBRACK] = ACTIONS(4283),
    [anon_sym_COLON] = ACTIONS(4283),
    [anon_sym_COMMA] = ACTIONS(4283),
    [anon_sym_LPAREN] = ACTIONS(4283),
    [anon_sym_LBRACE] = ACTIONS(4486),
    [anon_sym_file] = ACTIONS(4484),
    [anon_sym_LT] = ACTIONS(4285),
    [anon_sym_GT] = ACTIONS(4285),
    [anon_sym_where] = ACTIONS(4484),
    [anon_sym_QMARK] = ACTIONS(4285),
    [anon_sym_notnull] = ACTIONS(4484),
    [anon_sym_unmanaged] = ACTIONS(4484),
    [anon_sym_BANG] = ACTIONS(4285),
    [anon_sym_PLUS_PLUS] = ACTIONS(4283),
    [anon_sym_DASH_DASH] = ACTIONS(4283),
    [anon_sym_PLUS] = ACTIONS(4285),
    [anon_sym_DASH] = ACTIONS(4285),
    [anon_sym_STAR] = ACTIONS(4283),
    [anon_sym_SLASH] = ACTIONS(4285),
    [anon_sym_PERCENT] = ACTIONS(4283),
    [anon_sym_CARET] = ACTIONS(4283),
    [anon_sym_PIPE] = ACTIONS(4285),
    [anon_sym_AMP] = ACTIONS(4285),
    [anon_sym_LT_LT] = ACTIONS(4283),
    [anon_sym_GT_GT] = ACTIONS(4285),
    [anon_sym_GT_GT_GT] = ACTIONS(4283),
    [anon_sym_EQ_EQ] = ACTIONS(4283),
    [anon_sym_BANG_EQ] = ACTIONS(4283),
    [anon_sym_GT_EQ] = ACTIONS(4283),
    [anon_sym_LT_EQ] = ACTIONS(4283),
    [anon_sym_DOT] = ACTIONS(4285),
    [anon_sym_scoped] = ACTIONS(4484),
    [anon_sym_var] = ACTIONS(4484),
    [anon_sym_yield] = ACTIONS(4484),
    [anon_sym_switch] = ACTIONS(4285),
    [anon_sym_when] = ACTIONS(4484),
    [sym_discard] = ACTIONS(4488),
    [anon_sym_DOT_DOT] = ACTIONS(4283),
    [anon_sym_and] = ACTIONS(4279),
    [anon_sym_or] = ACTIONS(4279),
    [anon_sym_AMP_AMP] = ACTIONS(4283),
    [anon_sym_PIPE_PIPE] = ACTIONS(4283),
    [anon_sym_QMARK_QMARK] = ACTIONS(4283),
    [anon_sym_from] = ACTIONS(4484),
    [anon_sym_into] = ACTIONS(4484),
    [anon_sym_join] = ACTIONS(4484),
    [anon_sym_on] = ACTIONS(4484),
    [anon_sym_equals] = ACTIONS(4484),
    [anon_sym_let] = ACTIONS(4484),
    [anon_sym_orderby] = ACTIONS(4484),
    [anon_sym_ascending] = ACTIONS(4484),
    [anon_sym_descending] = ACTIONS(4484),
    [anon_sym_group] = ACTIONS(4484),
    [anon_sym_by] = ACTIONS(4484),
    [anon_sym_select] = ACTIONS(4484),
    [anon_sym_as] = ACTIONS(4285),
    [anon_sym_is] = ACTIONS(4285),
    [anon_sym_DASH_GT] = ACTIONS(4283),
    [anon_sym_with] = ACTIONS(4285),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4283),
  },
  [2947] = {
    [sym_preproc_region] = STATE(2947),
    [sym_preproc_endregion] = STATE(2947),
    [sym_preproc_line] = STATE(2947),
    [sym_preproc_pragma] = STATE(2947),
    [sym_preproc_nullable] = STATE(2947),
    [sym_preproc_error] = STATE(2947),
    [sym_preproc_define] = STATE(2947),
    [sym_preproc_undef] = STATE(2947),
    [sym__identifier_token] = ACTIONS(4070),
    [anon_sym_alias] = ACTIONS(4070),
    [anon_sym_SEMI] = ACTIONS(4072),
    [anon_sym_global] = ACTIONS(4070),
    [anon_sym_LBRACK] = ACTIONS(4072),
    [anon_sym_COLON] = ACTIONS(4072),
    [anon_sym_COMMA] = ACTIONS(4072),
    [anon_sym_RBRACK] = ACTIONS(4072),
    [anon_sym_LPAREN] = ACTIONS(4072),
    [anon_sym_RPAREN] = ACTIONS(4072),
    [anon_sym_LBRACE] = ACTIONS(4072),
    [anon_sym_RBRACE] = ACTIONS(4072),
    [anon_sym_file] = ACTIONS(4070),
    [anon_sym_LT] = ACTIONS(4070),
    [anon_sym_GT] = ACTIONS(4070),
    [anon_sym_in] = ACTIONS(4070),
    [anon_sym_where] = ACTIONS(4070),
    [anon_sym_QMARK] = ACTIONS(4070),
    [anon_sym_notnull] = ACTIONS(4070),
    [anon_sym_unmanaged] = ACTIONS(4070),
    [anon_sym_BANG] = ACTIONS(4070),
    [anon_sym_PLUS_PLUS] = ACTIONS(4072),
    [anon_sym_DASH_DASH] = ACTIONS(4072),
    [anon_sym_PLUS] = ACTIONS(4070),
    [anon_sym_DASH] = ACTIONS(4070),
    [anon_sym_STAR] = ACTIONS(4072),
    [anon_sym_SLASH] = ACTIONS(4070),
    [anon_sym_PERCENT] = ACTIONS(4072),
    [anon_sym_CARET] = ACTIONS(4072),
    [anon_sym_PIPE] = ACTIONS(4070),
    [anon_sym_AMP] = ACTIONS(4070),
    [anon_sym_LT_LT] = ACTIONS(4072),
    [anon_sym_GT_GT] = ACTIONS(4070),
    [anon_sym_GT_GT_GT] = ACTIONS(4072),
    [anon_sym_EQ_EQ] = ACTIONS(4072),
    [anon_sym_BANG_EQ] = ACTIONS(4072),
    [anon_sym_GT_EQ] = ACTIONS(4072),
    [anon_sym_LT_EQ] = ACTIONS(4072),
    [anon_sym_DOT] = ACTIONS(4070),
    [anon_sym_scoped] = ACTIONS(4070),
    [anon_sym_EQ_GT] = ACTIONS(4072),
    [anon_sym_var] = ACTIONS(4070),
    [anon_sym_yield] = ACTIONS(4070),
    [anon_sym_switch] = ACTIONS(4070),
    [anon_sym_when] = ACTIONS(4070),
    [sym_discard] = ACTIONS(4070),
    [anon_sym_DOT_DOT] = ACTIONS(4072),
    [anon_sym_and] = ACTIONS(4070),
    [anon_sym_or] = ACTIONS(4070),
    [anon_sym_AMP_AMP] = ACTIONS(4072),
    [anon_sym_PIPE_PIPE] = ACTIONS(4072),
    [anon_sym_QMARK_QMARK] = ACTIONS(4072),
    [anon_sym_from] = ACTIONS(4070),
    [anon_sym_into] = ACTIONS(4070),
    [anon_sym_join] = ACTIONS(4070),
    [anon_sym_on] = ACTIONS(4070),
    [anon_sym_equals] = ACTIONS(4070),
    [anon_sym_let] = ACTIONS(4070),
    [anon_sym_orderby] = ACTIONS(4070),
    [anon_sym_ascending] = ACTIONS(4070),
    [anon_sym_descending] = ACTIONS(4070),
    [anon_sym_group] = ACTIONS(4070),
    [anon_sym_by] = ACTIONS(4070),
    [anon_sym_select] = ACTIONS(4070),
    [anon_sym_as] = ACTIONS(4070),
    [anon_sym_is] = ACTIONS(4070),
    [anon_sym_DASH_GT] = ACTIONS(4072),
    [anon_sym_with] = ACTIONS(4070),
    [aux_sym_preproc_if_token3] = ACTIONS(4072),
    [aux_sym_preproc_else_token1] = ACTIONS(4072),
    [aux_sym_preproc_elif_token1] = ACTIONS(4072),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2948] = {
    [sym_preproc_region] = STATE(2948),
    [sym_preproc_endregion] = STATE(2948),
    [sym_preproc_line] = STATE(2948),
    [sym_preproc_pragma] = STATE(2948),
    [sym_preproc_nullable] = STATE(2948),
    [sym_preproc_error] = STATE(2948),
    [sym_preproc_define] = STATE(2948),
    [sym_preproc_undef] = STATE(2948),
    [sym__identifier_token] = ACTIONS(4099),
    [anon_sym_alias] = ACTIONS(4099),
    [anon_sym_global] = ACTIONS(4099),
    [anon_sym_EQ] = ACTIONS(4104),
    [anon_sym_LBRACK] = ACTIONS(4101),
    [anon_sym_LPAREN] = ACTIONS(4101),
    [anon_sym_file] = ACTIONS(4099),
    [anon_sym_LT] = ACTIONS(4104),
    [anon_sym_GT] = ACTIONS(4104),
    [anon_sym_where] = ACTIONS(4099),
    [anon_sym_QMARK] = ACTIONS(4108),
    [anon_sym_notnull] = ACTIONS(4099),
    [anon_sym_unmanaged] = ACTIONS(4099),
    [anon_sym_BANG] = ACTIONS(4104),
    [anon_sym_PLUS_PLUS] = ACTIONS(4111),
    [anon_sym_DASH_DASH] = ACTIONS(4111),
    [anon_sym_PLUS] = ACTIONS(4104),
    [anon_sym_DASH] = ACTIONS(4104),
    [anon_sym_STAR] = ACTIONS(4108),
    [anon_sym_SLASH] = ACTIONS(4104),
    [anon_sym_PERCENT] = ACTIONS(4104),
    [anon_sym_CARET] = ACTIONS(4104),
    [anon_sym_PIPE] = ACTIONS(4104),
    [anon_sym_AMP] = ACTIONS(4104),
    [anon_sym_LT_LT] = ACTIONS(4104),
    [anon_sym_GT_GT] = ACTIONS(4104),
    [anon_sym_GT_GT_GT] = ACTIONS(4104),
    [anon_sym_EQ_EQ] = ACTIONS(4111),
    [anon_sym_BANG_EQ] = ACTIONS(4111),
    [anon_sym_GT_EQ] = ACTIONS(4111),
    [anon_sym_LT_EQ] = ACTIONS(4111),
    [anon_sym_DOT] = ACTIONS(4108),
    [anon_sym_scoped] = ACTIONS(4099),
    [anon_sym_var] = ACTIONS(4099),
    [anon_sym_yield] = ACTIONS(4099),
    [anon_sym_switch] = ACTIONS(4104),
    [anon_sym_when] = ACTIONS(4099),
    [anon_sym_DOT_DOT] = ACTIONS(4111),
    [anon_sym_and] = ACTIONS(4104),
    [anon_sym_or] = ACTIONS(4104),
    [anon_sym_PLUS_EQ] = ACTIONS(4111),
    [anon_sym_DASH_EQ] = ACTIONS(4111),
    [anon_sym_STAR_EQ] = ACTIONS(4111),
    [anon_sym_SLASH_EQ] = ACTIONS(4111),
    [anon_sym_PERCENT_EQ] = ACTIONS(4111),
    [anon_sym_AMP_EQ] = ACTIONS(4111),
    [anon_sym_CARET_EQ] = ACTIONS(4111),
    [anon_sym_PIPE_EQ] = ACTIONS(4111),
    [anon_sym_LT_LT_EQ] = ACTIONS(4111),
    [anon_sym_GT_GT_EQ] = ACTIONS(4111),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4111),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4111),
    [anon_sym_AMP_AMP] = ACTIONS(4111),
    [anon_sym_PIPE_PIPE] = ACTIONS(4111),
    [anon_sym_QMARK_QMARK] = ACTIONS(4104),
    [anon_sym_from] = ACTIONS(4099),
    [anon_sym_into] = ACTIONS(4108),
    [anon_sym_join] = ACTIONS(4099),
    [anon_sym_on] = ACTIONS(4099),
    [anon_sym_equals] = ACTIONS(4108),
    [anon_sym_let] = ACTIONS(4099),
    [anon_sym_orderby] = ACTIONS(4099),
    [anon_sym_ascending] = ACTIONS(4099),
    [anon_sym_descending] = ACTIONS(4099),
    [anon_sym_group] = ACTIONS(4099),
    [anon_sym_by] = ACTIONS(4099),
    [anon_sym_select] = ACTIONS(4099),
    [anon_sym_as] = ACTIONS(4104),
    [anon_sym_is] = ACTIONS(4104),
    [anon_sym_DASH_GT] = ACTIONS(4101),
    [anon_sym_with] = ACTIONS(4104),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2949] = {
    [sym_preproc_region] = STATE(2949),
    [sym_preproc_endregion] = STATE(2949),
    [sym_preproc_line] = STATE(2949),
    [sym_preproc_pragma] = STATE(2949),
    [sym_preproc_nullable] = STATE(2949),
    [sym_preproc_error] = STATE(2949),
    [sym_preproc_define] = STATE(2949),
    [sym_preproc_undef] = STATE(2949),
    [sym__identifier_token] = ACTIONS(4347),
    [anon_sym_alias] = ACTIONS(4347),
    [anon_sym_SEMI] = ACTIONS(4349),
    [anon_sym_global] = ACTIONS(4347),
    [anon_sym_LBRACK] = ACTIONS(4349),
    [anon_sym_COLON] = ACTIONS(4349),
    [anon_sym_COMMA] = ACTIONS(4349),
    [anon_sym_RBRACK] = ACTIONS(4349),
    [anon_sym_LPAREN] = ACTIONS(4349),
    [anon_sym_RPAREN] = ACTIONS(4349),
    [anon_sym_LBRACE] = ACTIONS(4349),
    [anon_sym_RBRACE] = ACTIONS(4349),
    [anon_sym_file] = ACTIONS(4347),
    [anon_sym_LT] = ACTIONS(4347),
    [anon_sym_GT] = ACTIONS(4347),
    [anon_sym_in] = ACTIONS(4347),
    [anon_sym_where] = ACTIONS(4347),
    [anon_sym_QMARK] = ACTIONS(4347),
    [anon_sym_notnull] = ACTIONS(4347),
    [anon_sym_unmanaged] = ACTIONS(4347),
    [anon_sym_BANG] = ACTIONS(4347),
    [anon_sym_PLUS_PLUS] = ACTIONS(4349),
    [anon_sym_DASH_DASH] = ACTIONS(4349),
    [anon_sym_PLUS] = ACTIONS(4347),
    [anon_sym_DASH] = ACTIONS(4347),
    [anon_sym_STAR] = ACTIONS(4349),
    [anon_sym_SLASH] = ACTIONS(4347),
    [anon_sym_PERCENT] = ACTIONS(4349),
    [anon_sym_CARET] = ACTIONS(4349),
    [anon_sym_PIPE] = ACTIONS(4347),
    [anon_sym_AMP] = ACTIONS(4347),
    [anon_sym_LT_LT] = ACTIONS(4349),
    [anon_sym_GT_GT] = ACTIONS(4347),
    [anon_sym_GT_GT_GT] = ACTIONS(4349),
    [anon_sym_EQ_EQ] = ACTIONS(4349),
    [anon_sym_BANG_EQ] = ACTIONS(4349),
    [anon_sym_GT_EQ] = ACTIONS(4349),
    [anon_sym_LT_EQ] = ACTIONS(4349),
    [anon_sym_DOT] = ACTIONS(4347),
    [anon_sym_scoped] = ACTIONS(4347),
    [anon_sym_EQ_GT] = ACTIONS(4349),
    [anon_sym_var] = ACTIONS(4347),
    [anon_sym_yield] = ACTIONS(4347),
    [anon_sym_switch] = ACTIONS(4347),
    [anon_sym_when] = ACTIONS(4347),
    [sym_discard] = ACTIONS(4347),
    [anon_sym_DOT_DOT] = ACTIONS(4349),
    [anon_sym_and] = ACTIONS(4347),
    [anon_sym_or] = ACTIONS(4347),
    [anon_sym_AMP_AMP] = ACTIONS(4349),
    [anon_sym_PIPE_PIPE] = ACTIONS(4349),
    [anon_sym_QMARK_QMARK] = ACTIONS(4349),
    [anon_sym_from] = ACTIONS(4347),
    [anon_sym_into] = ACTIONS(4347),
    [anon_sym_join] = ACTIONS(4347),
    [anon_sym_on] = ACTIONS(4347),
    [anon_sym_equals] = ACTIONS(4347),
    [anon_sym_let] = ACTIONS(4347),
    [anon_sym_orderby] = ACTIONS(4347),
    [anon_sym_ascending] = ACTIONS(4347),
    [anon_sym_descending] = ACTIONS(4347),
    [anon_sym_group] = ACTIONS(4347),
    [anon_sym_by] = ACTIONS(4347),
    [anon_sym_select] = ACTIONS(4347),
    [anon_sym_as] = ACTIONS(4347),
    [anon_sym_is] = ACTIONS(4347),
    [anon_sym_DASH_GT] = ACTIONS(4349),
    [anon_sym_with] = ACTIONS(4347),
    [aux_sym_preproc_if_token3] = ACTIONS(4349),
    [aux_sym_preproc_else_token1] = ACTIONS(4349),
    [aux_sym_preproc_elif_token1] = ACTIONS(4349),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2950] = {
    [sym_modifier] = STATE(3780),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7360),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_identifier] = STATE(4921),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(2950),
    [sym_preproc_endregion] = STATE(2950),
    [sym_preproc_line] = STATE(2950),
    [sym_preproc_pragma] = STATE(2950),
    [sym_preproc_nullable] = STATE(2950),
    [sym_preproc_error] = STATE(2950),
    [sym_preproc_define] = STATE(2950),
    [sym_preproc_undef] = STATE(2950),
    [aux_sym_class_declaration_repeat2] = STATE(3757),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_unsafe] = ACTIONS(63),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(2995),
    [anon_sym_class] = ACTIONS(4509),
    [anon_sym_ref] = ACTIONS(4511),
    [anon_sym_struct] = ACTIONS(4513),
    [anon_sym_enum] = ACTIONS(4515),
    [anon_sym_interface] = ACTIONS(4517),
    [anon_sym_delegate] = ACTIONS(4519),
    [anon_sym_record] = ACTIONS(4521),
    [anon_sym_abstract] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_file] = ACTIONS(4523),
    [anon_sym_fixed] = ACTIONS(63),
    [anon_sym_internal] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(63),
    [anon_sym_override] = ACTIONS(63),
    [anon_sym_partial] = ACTIONS(63),
    [anon_sym_private] = ACTIONS(63),
    [anon_sym_protected] = ACTIONS(63),
    [anon_sym_public] = ACTIONS(63),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_required] = ACTIONS(63),
    [anon_sym_sealed] = ACTIONS(63),
    [anon_sym_virtual] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2951] = {
    [sym_preproc_region] = STATE(2951),
    [sym_preproc_endregion] = STATE(2951),
    [sym_preproc_line] = STATE(2951),
    [sym_preproc_pragma] = STATE(2951),
    [sym_preproc_nullable] = STATE(2951),
    [sym_preproc_error] = STATE(2951),
    [sym_preproc_define] = STATE(2951),
    [sym_preproc_undef] = STATE(2951),
    [sym__identifier_token] = ACTIONS(4525),
    [anon_sym_alias] = ACTIONS(4525),
    [anon_sym_SEMI] = ACTIONS(4527),
    [anon_sym_global] = ACTIONS(4525),
    [anon_sym_LBRACK] = ACTIONS(4527),
    [anon_sym_COLON] = ACTIONS(4527),
    [anon_sym_COMMA] = ACTIONS(4527),
    [anon_sym_RBRACK] = ACTIONS(4527),
    [anon_sym_LPAREN] = ACTIONS(4527),
    [anon_sym_RPAREN] = ACTIONS(4527),
    [anon_sym_LBRACE] = ACTIONS(4527),
    [anon_sym_RBRACE] = ACTIONS(4527),
    [anon_sym_file] = ACTIONS(4525),
    [anon_sym_LT] = ACTIONS(4525),
    [anon_sym_GT] = ACTIONS(4525),
    [anon_sym_in] = ACTIONS(4525),
    [anon_sym_where] = ACTIONS(4525),
    [anon_sym_QMARK] = ACTIONS(4525),
    [anon_sym_notnull] = ACTIONS(4525),
    [anon_sym_unmanaged] = ACTIONS(4525),
    [anon_sym_BANG] = ACTIONS(4525),
    [anon_sym_PLUS_PLUS] = ACTIONS(4527),
    [anon_sym_DASH_DASH] = ACTIONS(4527),
    [anon_sym_PLUS] = ACTIONS(4525),
    [anon_sym_DASH] = ACTIONS(4525),
    [anon_sym_STAR] = ACTIONS(4527),
    [anon_sym_SLASH] = ACTIONS(4525),
    [anon_sym_PERCENT] = ACTIONS(4527),
    [anon_sym_CARET] = ACTIONS(4527),
    [anon_sym_PIPE] = ACTIONS(4525),
    [anon_sym_AMP] = ACTIONS(4525),
    [anon_sym_LT_LT] = ACTIONS(4527),
    [anon_sym_GT_GT] = ACTIONS(4525),
    [anon_sym_GT_GT_GT] = ACTIONS(4527),
    [anon_sym_EQ_EQ] = ACTIONS(4527),
    [anon_sym_BANG_EQ] = ACTIONS(4527),
    [anon_sym_GT_EQ] = ACTIONS(4527),
    [anon_sym_LT_EQ] = ACTIONS(4527),
    [anon_sym_DOT] = ACTIONS(4525),
    [anon_sym_scoped] = ACTIONS(4525),
    [anon_sym_EQ_GT] = ACTIONS(4527),
    [anon_sym_var] = ACTIONS(4525),
    [anon_sym_yield] = ACTIONS(4525),
    [anon_sym_switch] = ACTIONS(4525),
    [anon_sym_when] = ACTIONS(4525),
    [sym_discard] = ACTIONS(4525),
    [anon_sym_DOT_DOT] = ACTIONS(4527),
    [anon_sym_and] = ACTIONS(4525),
    [anon_sym_or] = ACTIONS(4525),
    [anon_sym_AMP_AMP] = ACTIONS(4527),
    [anon_sym_PIPE_PIPE] = ACTIONS(4527),
    [anon_sym_QMARK_QMARK] = ACTIONS(4527),
    [anon_sym_from] = ACTIONS(4525),
    [anon_sym_into] = ACTIONS(4525),
    [anon_sym_join] = ACTIONS(4525),
    [anon_sym_on] = ACTIONS(4525),
    [anon_sym_equals] = ACTIONS(4525),
    [anon_sym_let] = ACTIONS(4525),
    [anon_sym_orderby] = ACTIONS(4525),
    [anon_sym_ascending] = ACTIONS(4525),
    [anon_sym_descending] = ACTIONS(4525),
    [anon_sym_group] = ACTIONS(4525),
    [anon_sym_by] = ACTIONS(4525),
    [anon_sym_select] = ACTIONS(4525),
    [anon_sym_as] = ACTIONS(4525),
    [anon_sym_is] = ACTIONS(4525),
    [anon_sym_DASH_GT] = ACTIONS(4527),
    [anon_sym_with] = ACTIONS(4525),
    [aux_sym_preproc_if_token3] = ACTIONS(4527),
    [aux_sym_preproc_else_token1] = ACTIONS(4527),
    [aux_sym_preproc_elif_token1] = ACTIONS(4527),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2952] = {
    [sym_modifier] = STATE(3780),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7328),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_identifier] = STATE(4921),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(2952),
    [sym_preproc_endregion] = STATE(2952),
    [sym_preproc_line] = STATE(2952),
    [sym_preproc_pragma] = STATE(2952),
    [sym_preproc_nullable] = STATE(2952),
    [sym_preproc_error] = STATE(2952),
    [sym_preproc_define] = STATE(2952),
    [sym_preproc_undef] = STATE(2952),
    [aux_sym_class_declaration_repeat2] = STATE(3757),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_unsafe] = ACTIONS(63),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(2995),
    [anon_sym_class] = ACTIONS(4529),
    [anon_sym_ref] = ACTIONS(4531),
    [anon_sym_struct] = ACTIONS(4533),
    [anon_sym_enum] = ACTIONS(4535),
    [anon_sym_interface] = ACTIONS(4537),
    [anon_sym_delegate] = ACTIONS(4539),
    [anon_sym_record] = ACTIONS(4541),
    [anon_sym_abstract] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_file] = ACTIONS(4523),
    [anon_sym_fixed] = ACTIONS(63),
    [anon_sym_internal] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(63),
    [anon_sym_override] = ACTIONS(63),
    [anon_sym_partial] = ACTIONS(63),
    [anon_sym_private] = ACTIONS(63),
    [anon_sym_protected] = ACTIONS(63),
    [anon_sym_public] = ACTIONS(63),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_required] = ACTIONS(63),
    [anon_sym_sealed] = ACTIONS(63),
    [anon_sym_virtual] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2953] = {
    [sym_preproc_region] = STATE(2953),
    [sym_preproc_endregion] = STATE(2953),
    [sym_preproc_line] = STATE(2953),
    [sym_preproc_pragma] = STATE(2953),
    [sym_preproc_nullable] = STATE(2953),
    [sym_preproc_error] = STATE(2953),
    [sym_preproc_define] = STATE(2953),
    [sym_preproc_undef] = STATE(2953),
    [sym__identifier_token] = ACTIONS(4085),
    [anon_sym_alias] = ACTIONS(4085),
    [anon_sym_SEMI] = ACTIONS(4087),
    [anon_sym_global] = ACTIONS(4085),
    [anon_sym_LBRACK] = ACTIONS(4087),
    [anon_sym_COLON] = ACTIONS(4087),
    [anon_sym_COMMA] = ACTIONS(4087),
    [anon_sym_RBRACK] = ACTIONS(4087),
    [anon_sym_LPAREN] = ACTIONS(4087),
    [anon_sym_RPAREN] = ACTIONS(4087),
    [anon_sym_LBRACE] = ACTIONS(4087),
    [anon_sym_RBRACE] = ACTIONS(4087),
    [anon_sym_file] = ACTIONS(4085),
    [anon_sym_LT] = ACTIONS(4085),
    [anon_sym_GT] = ACTIONS(4085),
    [anon_sym_in] = ACTIONS(4085),
    [anon_sym_where] = ACTIONS(4085),
    [anon_sym_QMARK] = ACTIONS(4085),
    [anon_sym_notnull] = ACTIONS(4085),
    [anon_sym_unmanaged] = ACTIONS(4085),
    [anon_sym_BANG] = ACTIONS(4085),
    [anon_sym_PLUS_PLUS] = ACTIONS(4087),
    [anon_sym_DASH_DASH] = ACTIONS(4087),
    [anon_sym_PLUS] = ACTIONS(4085),
    [anon_sym_DASH] = ACTIONS(4085),
    [anon_sym_STAR] = ACTIONS(4087),
    [anon_sym_SLASH] = ACTIONS(4085),
    [anon_sym_PERCENT] = ACTIONS(4087),
    [anon_sym_CARET] = ACTIONS(4087),
    [anon_sym_PIPE] = ACTIONS(4085),
    [anon_sym_AMP] = ACTIONS(4085),
    [anon_sym_LT_LT] = ACTIONS(4087),
    [anon_sym_GT_GT] = ACTIONS(4085),
    [anon_sym_GT_GT_GT] = ACTIONS(4087),
    [anon_sym_EQ_EQ] = ACTIONS(4087),
    [anon_sym_BANG_EQ] = ACTIONS(4087),
    [anon_sym_GT_EQ] = ACTIONS(4087),
    [anon_sym_LT_EQ] = ACTIONS(4087),
    [anon_sym_DOT] = ACTIONS(4085),
    [anon_sym_scoped] = ACTIONS(4085),
    [anon_sym_EQ_GT] = ACTIONS(4087),
    [anon_sym_var] = ACTIONS(4085),
    [anon_sym_yield] = ACTIONS(4085),
    [anon_sym_switch] = ACTIONS(4085),
    [anon_sym_when] = ACTIONS(4085),
    [sym_discard] = ACTIONS(4085),
    [anon_sym_DOT_DOT] = ACTIONS(4087),
    [anon_sym_and] = ACTIONS(4085),
    [anon_sym_or] = ACTIONS(4085),
    [anon_sym_AMP_AMP] = ACTIONS(4087),
    [anon_sym_PIPE_PIPE] = ACTIONS(4087),
    [anon_sym_QMARK_QMARK] = ACTIONS(4087),
    [anon_sym_from] = ACTIONS(4085),
    [anon_sym_into] = ACTIONS(4085),
    [anon_sym_join] = ACTIONS(4085),
    [anon_sym_on] = ACTIONS(4085),
    [anon_sym_equals] = ACTIONS(4085),
    [anon_sym_let] = ACTIONS(4085),
    [anon_sym_orderby] = ACTIONS(4085),
    [anon_sym_ascending] = ACTIONS(4085),
    [anon_sym_descending] = ACTIONS(4085),
    [anon_sym_group] = ACTIONS(4085),
    [anon_sym_by] = ACTIONS(4085),
    [anon_sym_select] = ACTIONS(4085),
    [anon_sym_as] = ACTIONS(4085),
    [anon_sym_is] = ACTIONS(4085),
    [anon_sym_DASH_GT] = ACTIONS(4087),
    [anon_sym_with] = ACTIONS(4085),
    [aux_sym_preproc_if_token3] = ACTIONS(4087),
    [aux_sym_preproc_else_token1] = ACTIONS(4087),
    [aux_sym_preproc_elif_token1] = ACTIONS(4087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2954] = {
    [sym__name] = STATE(6152),
    [sym_alias_qualified_name] = STATE(3955),
    [sym__simple_name] = STATE(3955),
    [sym_qualified_name] = STATE(3955),
    [sym_generic_name] = STATE(4047),
    [sym_ref_type] = STATE(4040),
    [sym__scoped_base_type] = STATE(4036),
    [sym_identifier] = STATE(5594),
    [sym__reserved_identifier] = STATE(3897),
    [sym_preproc_region] = STATE(2954),
    [sym_preproc_endregion] = STATE(2954),
    [sym_preproc_line] = STATE(2954),
    [sym_preproc_pragma] = STATE(2954),
    [sym_preproc_nullable] = STATE(2954),
    [sym_preproc_error] = STATE(2954),
    [sym_preproc_define] = STATE(2954),
    [sym_preproc_undef] = STATE(2954),
    [sym__identifier_token] = ACTIONS(4168),
    [anon_sym_alias] = ACTIONS(4170),
    [anon_sym_global] = ACTIONS(4170),
    [anon_sym_LBRACK] = ACTIONS(3719),
    [anon_sym_LPAREN] = ACTIONS(3719),
    [anon_sym_ref] = ACTIONS(4543),
    [anon_sym_LBRACE] = ACTIONS(3719),
    [anon_sym_file] = ACTIONS(4170),
    [anon_sym_LT] = ACTIONS(3721),
    [anon_sym_GT] = ACTIONS(3721),
    [anon_sym_in] = ACTIONS(3721),
    [anon_sym_where] = ACTIONS(4170),
    [anon_sym_QMARK] = ACTIONS(3721),
    [anon_sym_notnull] = ACTIONS(4170),
    [anon_sym_unmanaged] = ACTIONS(4170),
    [anon_sym_BANG] = ACTIONS(3721),
    [anon_sym_PLUS_PLUS] = ACTIONS(3719),
    [anon_sym_DASH_DASH] = ACTIONS(3719),
    [anon_sym_PLUS] = ACTIONS(3721),
    [anon_sym_DASH] = ACTIONS(3721),
    [anon_sym_STAR] = ACTIONS(3719),
    [anon_sym_SLASH] = ACTIONS(3721),
    [anon_sym_PERCENT] = ACTIONS(3719),
    [anon_sym_CARET] = ACTIONS(3719),
    [anon_sym_PIPE] = ACTIONS(3721),
    [anon_sym_AMP] = ACTIONS(3721),
    [anon_sym_LT_LT] = ACTIONS(3719),
    [anon_sym_GT_GT] = ACTIONS(3721),
    [anon_sym_GT_GT_GT] = ACTIONS(3719),
    [anon_sym_EQ_EQ] = ACTIONS(3719),
    [anon_sym_BANG_EQ] = ACTIONS(3719),
    [anon_sym_GT_EQ] = ACTIONS(3719),
    [anon_sym_LT_EQ] = ACTIONS(3719),
    [anon_sym_DOT] = ACTIONS(3721),
    [anon_sym_scoped] = ACTIONS(4170),
    [anon_sym_COLON_COLON] = ACTIONS(3719),
    [anon_sym_var] = ACTIONS(4170),
    [anon_sym_yield] = ACTIONS(4170),
    [anon_sym_switch] = ACTIONS(3721),
    [anon_sym_when] = ACTIONS(4170),
    [anon_sym_DOT_DOT] = ACTIONS(3719),
    [anon_sym_and] = ACTIONS(3721),
    [anon_sym_or] = ACTIONS(3721),
    [anon_sym_AMP_AMP] = ACTIONS(3719),
    [anon_sym_PIPE_PIPE] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK] = ACTIONS(3719),
    [anon_sym_from] = ACTIONS(4170),
    [anon_sym_into] = ACTIONS(4170),
    [anon_sym_join] = ACTIONS(4170),
    [anon_sym_on] = ACTIONS(4170),
    [anon_sym_equals] = ACTIONS(4170),
    [anon_sym_let] = ACTIONS(4170),
    [anon_sym_orderby] = ACTIONS(4170),
    [anon_sym_ascending] = ACTIONS(4170),
    [anon_sym_descending] = ACTIONS(4170),
    [anon_sym_group] = ACTIONS(4170),
    [anon_sym_by] = ACTIONS(4170),
    [anon_sym_select] = ACTIONS(4170),
    [anon_sym_as] = ACTIONS(3721),
    [anon_sym_is] = ACTIONS(3721),
    [anon_sym_DASH_GT] = ACTIONS(3719),
    [anon_sym_with] = ACTIONS(3721),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2955] = {
    [sym_preproc_region] = STATE(2955),
    [sym_preproc_endregion] = STATE(2955),
    [sym_preproc_line] = STATE(2955),
    [sym_preproc_pragma] = STATE(2955),
    [sym_preproc_nullable] = STATE(2955),
    [sym_preproc_error] = STATE(2955),
    [sym_preproc_define] = STATE(2955),
    [sym_preproc_undef] = STATE(2955),
    [sym__identifier_token] = ACTIONS(4113),
    [anon_sym_alias] = ACTIONS(4113),
    [anon_sym_global] = ACTIONS(4113),
    [anon_sym_EQ] = ACTIONS(4118),
    [anon_sym_LBRACK] = ACTIONS(4135),
    [anon_sym_LPAREN] = ACTIONS(4135),
    [anon_sym_file] = ACTIONS(4113),
    [anon_sym_LT] = ACTIONS(4118),
    [anon_sym_GT] = ACTIONS(4118),
    [anon_sym_where] = ACTIONS(4138),
    [anon_sym_QMARK] = ACTIONS(4138),
    [anon_sym_notnull] = ACTIONS(4113),
    [anon_sym_unmanaged] = ACTIONS(4113),
    [anon_sym_BANG] = ACTIONS(4118),
    [anon_sym_PLUS_PLUS] = ACTIONS(4133),
    [anon_sym_DASH_DASH] = ACTIONS(4133),
    [anon_sym_PLUS] = ACTIONS(4118),
    [anon_sym_DASH] = ACTIONS(4118),
    [anon_sym_STAR] = ACTIONS(4138),
    [anon_sym_SLASH] = ACTIONS(4118),
    [anon_sym_PERCENT] = ACTIONS(4118),
    [anon_sym_CARET] = ACTIONS(4118),
    [anon_sym_PIPE] = ACTIONS(4118),
    [anon_sym_AMP] = ACTIONS(4118),
    [anon_sym_LT_LT] = ACTIONS(4118),
    [anon_sym_GT_GT] = ACTIONS(4118),
    [anon_sym_GT_GT_GT] = ACTIONS(4118),
    [anon_sym_EQ_EQ] = ACTIONS(4133),
    [anon_sym_BANG_EQ] = ACTIONS(4133),
    [anon_sym_GT_EQ] = ACTIONS(4133),
    [anon_sym_LT_EQ] = ACTIONS(4133),
    [anon_sym_DOT] = ACTIONS(4138),
    [anon_sym_scoped] = ACTIONS(4113),
    [anon_sym_var] = ACTIONS(4113),
    [anon_sym_yield] = ACTIONS(4113),
    [anon_sym_switch] = ACTIONS(4118),
    [anon_sym_when] = ACTIONS(4113),
    [anon_sym_DOT_DOT] = ACTIONS(4133),
    [anon_sym_and] = ACTIONS(4118),
    [anon_sym_or] = ACTIONS(4118),
    [anon_sym_PLUS_EQ] = ACTIONS(4133),
    [anon_sym_DASH_EQ] = ACTIONS(4133),
    [anon_sym_STAR_EQ] = ACTIONS(4133),
    [anon_sym_SLASH_EQ] = ACTIONS(4133),
    [anon_sym_PERCENT_EQ] = ACTIONS(4133),
    [anon_sym_AMP_EQ] = ACTIONS(4133),
    [anon_sym_CARET_EQ] = ACTIONS(4133),
    [anon_sym_PIPE_EQ] = ACTIONS(4133),
    [anon_sym_LT_LT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4133),
    [anon_sym_AMP_AMP] = ACTIONS(4133),
    [anon_sym_PIPE_PIPE] = ACTIONS(4133),
    [anon_sym_QMARK_QMARK] = ACTIONS(4118),
    [anon_sym_from] = ACTIONS(4138),
    [anon_sym_into] = ACTIONS(4138),
    [anon_sym_join] = ACTIONS(4138),
    [anon_sym_on] = ACTIONS(4113),
    [anon_sym_equals] = ACTIONS(4113),
    [anon_sym_let] = ACTIONS(4138),
    [anon_sym_orderby] = ACTIONS(4138),
    [anon_sym_ascending] = ACTIONS(4113),
    [anon_sym_descending] = ACTIONS(4113),
    [anon_sym_group] = ACTIONS(4138),
    [anon_sym_by] = ACTIONS(4113),
    [anon_sym_select] = ACTIONS(4138),
    [anon_sym_as] = ACTIONS(4118),
    [anon_sym_is] = ACTIONS(4118),
    [anon_sym_DASH_GT] = ACTIONS(4135),
    [anon_sym_with] = ACTIONS(4118),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2956] = {
    [sym_preproc_region] = STATE(2956),
    [sym_preproc_endregion] = STATE(2956),
    [sym_preproc_line] = STATE(2956),
    [sym_preproc_pragma] = STATE(2956),
    [sym_preproc_nullable] = STATE(2956),
    [sym_preproc_error] = STATE(2956),
    [sym_preproc_define] = STATE(2956),
    [sym_preproc_undef] = STATE(2956),
    [sym__identifier_token] = ACTIONS(4074),
    [anon_sym_alias] = ACTIONS(4074),
    [anon_sym_SEMI] = ACTIONS(4076),
    [anon_sym_global] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4076),
    [anon_sym_COLON] = ACTIONS(4076),
    [anon_sym_COMMA] = ACTIONS(4076),
    [anon_sym_RBRACK] = ACTIONS(4076),
    [anon_sym_LPAREN] = ACTIONS(4076),
    [anon_sym_RPAREN] = ACTIONS(4076),
    [anon_sym_LBRACE] = ACTIONS(4076),
    [anon_sym_RBRACE] = ACTIONS(4076),
    [anon_sym_file] = ACTIONS(4074),
    [anon_sym_LT] = ACTIONS(4074),
    [anon_sym_GT] = ACTIONS(4074),
    [anon_sym_in] = ACTIONS(4074),
    [anon_sym_where] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(4074),
    [anon_sym_notnull] = ACTIONS(4074),
    [anon_sym_unmanaged] = ACTIONS(4074),
    [anon_sym_BANG] = ACTIONS(4074),
    [anon_sym_PLUS_PLUS] = ACTIONS(4076),
    [anon_sym_DASH_DASH] = ACTIONS(4076),
    [anon_sym_PLUS] = ACTIONS(4074),
    [anon_sym_DASH] = ACTIONS(4074),
    [anon_sym_STAR] = ACTIONS(4076),
    [anon_sym_SLASH] = ACTIONS(4074),
    [anon_sym_PERCENT] = ACTIONS(4076),
    [anon_sym_CARET] = ACTIONS(4076),
    [anon_sym_PIPE] = ACTIONS(4074),
    [anon_sym_AMP] = ACTIONS(4074),
    [anon_sym_LT_LT] = ACTIONS(4076),
    [anon_sym_GT_GT] = ACTIONS(4074),
    [anon_sym_GT_GT_GT] = ACTIONS(4076),
    [anon_sym_EQ_EQ] = ACTIONS(4076),
    [anon_sym_BANG_EQ] = ACTIONS(4076),
    [anon_sym_GT_EQ] = ACTIONS(4076),
    [anon_sym_LT_EQ] = ACTIONS(4076),
    [anon_sym_DOT] = ACTIONS(4074),
    [anon_sym_scoped] = ACTIONS(4074),
    [anon_sym_EQ_GT] = ACTIONS(4076),
    [anon_sym_var] = ACTIONS(4074),
    [anon_sym_yield] = ACTIONS(4074),
    [anon_sym_switch] = ACTIONS(4074),
    [anon_sym_when] = ACTIONS(4074),
    [sym_discard] = ACTIONS(4074),
    [anon_sym_DOT_DOT] = ACTIONS(4076),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_AMP_AMP] = ACTIONS(4076),
    [anon_sym_PIPE_PIPE] = ACTIONS(4076),
    [anon_sym_QMARK_QMARK] = ACTIONS(4076),
    [anon_sym_from] = ACTIONS(4074),
    [anon_sym_into] = ACTIONS(4074),
    [anon_sym_join] = ACTIONS(4074),
    [anon_sym_on] = ACTIONS(4074),
    [anon_sym_equals] = ACTIONS(4074),
    [anon_sym_let] = ACTIONS(4074),
    [anon_sym_orderby] = ACTIONS(4074),
    [anon_sym_ascending] = ACTIONS(4074),
    [anon_sym_descending] = ACTIONS(4074),
    [anon_sym_group] = ACTIONS(4074),
    [anon_sym_by] = ACTIONS(4074),
    [anon_sym_select] = ACTIONS(4074),
    [anon_sym_as] = ACTIONS(4074),
    [anon_sym_is] = ACTIONS(4074),
    [anon_sym_DASH_GT] = ACTIONS(4076),
    [anon_sym_with] = ACTIONS(4074),
    [aux_sym_preproc_if_token3] = ACTIONS(4076),
    [aux_sym_preproc_else_token1] = ACTIONS(4076),
    [aux_sym_preproc_elif_token1] = ACTIONS(4076),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2957] = {
    [sym_preproc_region] = STATE(2957),
    [sym_preproc_endregion] = STATE(2957),
    [sym_preproc_line] = STATE(2957),
    [sym_preproc_pragma] = STATE(2957),
    [sym_preproc_nullable] = STATE(2957),
    [sym_preproc_error] = STATE(2957),
    [sym_preproc_define] = STATE(2957),
    [sym_preproc_undef] = STATE(2957),
    [sym__identifier_token] = ACTIONS(4113),
    [anon_sym_alias] = ACTIONS(4113),
    [anon_sym_global] = ACTIONS(4113),
    [anon_sym_EQ] = ACTIONS(4118),
    [anon_sym_LBRACK] = ACTIONS(4135),
    [anon_sym_LPAREN] = ACTIONS(4135),
    [anon_sym_file] = ACTIONS(4113),
    [anon_sym_LT] = ACTIONS(4118),
    [anon_sym_GT] = ACTIONS(4118),
    [anon_sym_where] = ACTIONS(4138),
    [anon_sym_QMARK] = ACTIONS(4138),
    [anon_sym_notnull] = ACTIONS(4113),
    [anon_sym_unmanaged] = ACTIONS(4113),
    [anon_sym_BANG] = ACTIONS(4118),
    [anon_sym_PLUS_PLUS] = ACTIONS(4133),
    [anon_sym_DASH_DASH] = ACTIONS(4133),
    [anon_sym_PLUS] = ACTIONS(4118),
    [anon_sym_DASH] = ACTIONS(4118),
    [anon_sym_STAR] = ACTIONS(4138),
    [anon_sym_SLASH] = ACTIONS(4118),
    [anon_sym_PERCENT] = ACTIONS(4118),
    [anon_sym_CARET] = ACTIONS(4118),
    [anon_sym_PIPE] = ACTIONS(4118),
    [anon_sym_AMP] = ACTIONS(4118),
    [anon_sym_LT_LT] = ACTIONS(4118),
    [anon_sym_GT_GT] = ACTIONS(4118),
    [anon_sym_GT_GT_GT] = ACTIONS(4118),
    [anon_sym_EQ_EQ] = ACTIONS(4133),
    [anon_sym_BANG_EQ] = ACTIONS(4133),
    [anon_sym_GT_EQ] = ACTIONS(4133),
    [anon_sym_LT_EQ] = ACTIONS(4133),
    [anon_sym_DOT] = ACTIONS(4138),
    [anon_sym_scoped] = ACTIONS(4113),
    [anon_sym_var] = ACTIONS(4113),
    [anon_sym_yield] = ACTIONS(4113),
    [anon_sym_switch] = ACTIONS(4118),
    [anon_sym_when] = ACTIONS(4113),
    [anon_sym_DOT_DOT] = ACTIONS(4133),
    [anon_sym_and] = ACTIONS(4118),
    [anon_sym_or] = ACTIONS(4118),
    [anon_sym_PLUS_EQ] = ACTIONS(4133),
    [anon_sym_DASH_EQ] = ACTIONS(4133),
    [anon_sym_STAR_EQ] = ACTIONS(4133),
    [anon_sym_SLASH_EQ] = ACTIONS(4133),
    [anon_sym_PERCENT_EQ] = ACTIONS(4133),
    [anon_sym_AMP_EQ] = ACTIONS(4133),
    [anon_sym_CARET_EQ] = ACTIONS(4133),
    [anon_sym_PIPE_EQ] = ACTIONS(4133),
    [anon_sym_LT_LT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4133),
    [anon_sym_AMP_AMP] = ACTIONS(4133),
    [anon_sym_PIPE_PIPE] = ACTIONS(4133),
    [anon_sym_QMARK_QMARK] = ACTIONS(4118),
    [anon_sym_from] = ACTIONS(4138),
    [anon_sym_into] = ACTIONS(4113),
    [anon_sym_join] = ACTIONS(4138),
    [anon_sym_on] = ACTIONS(4113),
    [anon_sym_equals] = ACTIONS(4113),
    [anon_sym_let] = ACTIONS(4138),
    [anon_sym_orderby] = ACTIONS(4138),
    [anon_sym_ascending] = ACTIONS(4113),
    [anon_sym_descending] = ACTIONS(4113),
    [anon_sym_group] = ACTIONS(4138),
    [anon_sym_by] = ACTIONS(4113),
    [anon_sym_select] = ACTIONS(4138),
    [anon_sym_as] = ACTIONS(4118),
    [anon_sym_is] = ACTIONS(4118),
    [anon_sym_DASH_GT] = ACTIONS(4135),
    [anon_sym_with] = ACTIONS(4118),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2958] = {
    [sym_parameter_list] = STATE(9765),
    [sym_positional_pattern_clause] = STATE(3059),
    [sym_property_pattern_clause] = STATE(3116),
    [sym__variable_designation] = STATE(5398),
    [sym_parenthesized_variable_designation] = STATE(5390),
    [sym__lambda_parameters] = STATE(9127),
    [sym_identifier] = STATE(5303),
    [sym__reserved_identifier] = STATE(5128),
    [sym_preproc_region] = STATE(2958),
    [sym_preproc_endregion] = STATE(2958),
    [sym_preproc_line] = STATE(2958),
    [sym_preproc_pragma] = STATE(2958),
    [sym_preproc_nullable] = STATE(2958),
    [sym_preproc_error] = STATE(2958),
    [sym_preproc_define] = STATE(2958),
    [sym_preproc_undef] = STATE(2958),
    [sym__identifier_token] = ACTIONS(4482),
    [anon_sym_alias] = ACTIONS(4484),
    [anon_sym_global] = ACTIONS(4484),
    [anon_sym_LBRACK] = ACTIONS(4283),
    [anon_sym_COLON] = ACTIONS(4283),
    [anon_sym_COMMA] = ACTIONS(4283),
    [anon_sym_LPAREN] = ACTIONS(4283),
    [anon_sym_LBRACE] = ACTIONS(4486),
    [anon_sym_file] = ACTIONS(4484),
    [anon_sym_LT] = ACTIONS(4285),
    [anon_sym_GT] = ACTIONS(4285),
    [anon_sym_where] = ACTIONS(4484),
    [anon_sym_QMARK] = ACTIONS(4285),
    [anon_sym_notnull] = ACTIONS(4484),
    [anon_sym_unmanaged] = ACTIONS(4484),
    [anon_sym_BANG] = ACTIONS(4285),
    [anon_sym_PLUS_PLUS] = ACTIONS(4283),
    [anon_sym_DASH_DASH] = ACTIONS(4283),
    [anon_sym_PLUS] = ACTIONS(4285),
    [anon_sym_DASH] = ACTIONS(4285),
    [anon_sym_STAR] = ACTIONS(4283),
    [anon_sym_SLASH] = ACTIONS(4285),
    [anon_sym_PERCENT] = ACTIONS(4283),
    [anon_sym_CARET] = ACTIONS(4283),
    [anon_sym_PIPE] = ACTIONS(4285),
    [anon_sym_AMP] = ACTIONS(4285),
    [anon_sym_LT_LT] = ACTIONS(4283),
    [anon_sym_GT_GT] = ACTIONS(4285),
    [anon_sym_GT_GT_GT] = ACTIONS(4283),
    [anon_sym_EQ_EQ] = ACTIONS(4283),
    [anon_sym_BANG_EQ] = ACTIONS(4283),
    [anon_sym_GT_EQ] = ACTIONS(4283),
    [anon_sym_LT_EQ] = ACTIONS(4283),
    [anon_sym_DOT] = ACTIONS(4285),
    [anon_sym_scoped] = ACTIONS(4484),
    [anon_sym_var] = ACTIONS(4484),
    [anon_sym_yield] = ACTIONS(4484),
    [anon_sym_switch] = ACTIONS(4285),
    [anon_sym_when] = ACTIONS(4484),
    [sym_discard] = ACTIONS(4488),
    [anon_sym_DOT_DOT] = ACTIONS(4283),
    [anon_sym_and] = ACTIONS(4285),
    [anon_sym_or] = ACTIONS(4285),
    [anon_sym_AMP_AMP] = ACTIONS(4283),
    [anon_sym_PIPE_PIPE] = ACTIONS(4283),
    [anon_sym_QMARK_QMARK] = ACTIONS(4283),
    [anon_sym_from] = ACTIONS(4484),
    [anon_sym_into] = ACTIONS(4285),
    [anon_sym_join] = ACTIONS(4484),
    [anon_sym_on] = ACTIONS(4484),
    [anon_sym_equals] = ACTIONS(4484),
    [anon_sym_let] = ACTIONS(4484),
    [anon_sym_orderby] = ACTIONS(4484),
    [anon_sym_ascending] = ACTIONS(4484),
    [anon_sym_descending] = ACTIONS(4484),
    [anon_sym_group] = ACTIONS(4484),
    [anon_sym_by] = ACTIONS(4484),
    [anon_sym_select] = ACTIONS(4484),
    [anon_sym_as] = ACTIONS(4285),
    [anon_sym_is] = ACTIONS(4285),
    [anon_sym_DASH_GT] = ACTIONS(4283),
    [anon_sym_with] = ACTIONS(4285),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4283),
  },
  [2959] = {
    [sym_preproc_region] = STATE(2959),
    [sym_preproc_endregion] = STATE(2959),
    [sym_preproc_line] = STATE(2959),
    [sym_preproc_pragma] = STATE(2959),
    [sym_preproc_nullable] = STATE(2959),
    [sym_preproc_error] = STATE(2959),
    [sym_preproc_define] = STATE(2959),
    [sym_preproc_undef] = STATE(2959),
    [sym__identifier_token] = ACTIONS(4496),
    [anon_sym_alias] = ACTIONS(4496),
    [anon_sym_SEMI] = ACTIONS(4498),
    [anon_sym_global] = ACTIONS(4496),
    [anon_sym_LBRACK] = ACTIONS(4498),
    [anon_sym_COLON] = ACTIONS(4498),
    [anon_sym_COMMA] = ACTIONS(4498),
    [anon_sym_RBRACK] = ACTIONS(4498),
    [anon_sym_LPAREN] = ACTIONS(4498),
    [anon_sym_RPAREN] = ACTIONS(4498),
    [anon_sym_LBRACE] = ACTIONS(4498),
    [anon_sym_RBRACE] = ACTIONS(4498),
    [anon_sym_file] = ACTIONS(4496),
    [anon_sym_LT] = ACTIONS(4496),
    [anon_sym_GT] = ACTIONS(4496),
    [anon_sym_in] = ACTIONS(4496),
    [anon_sym_where] = ACTIONS(4496),
    [anon_sym_QMARK] = ACTIONS(4496),
    [anon_sym_notnull] = ACTIONS(4496),
    [anon_sym_unmanaged] = ACTIONS(4496),
    [anon_sym_BANG] = ACTIONS(4496),
    [anon_sym_PLUS_PLUS] = ACTIONS(4498),
    [anon_sym_DASH_DASH] = ACTIONS(4498),
    [anon_sym_PLUS] = ACTIONS(4496),
    [anon_sym_DASH] = ACTIONS(4496),
    [anon_sym_STAR] = ACTIONS(4498),
    [anon_sym_SLASH] = ACTIONS(4496),
    [anon_sym_PERCENT] = ACTIONS(4498),
    [anon_sym_CARET] = ACTIONS(4498),
    [anon_sym_PIPE] = ACTIONS(4496),
    [anon_sym_AMP] = ACTIONS(4496),
    [anon_sym_LT_LT] = ACTIONS(4498),
    [anon_sym_GT_GT] = ACTIONS(4496),
    [anon_sym_GT_GT_GT] = ACTIONS(4498),
    [anon_sym_EQ_EQ] = ACTIONS(4498),
    [anon_sym_BANG_EQ] = ACTIONS(4498),
    [anon_sym_GT_EQ] = ACTIONS(4498),
    [anon_sym_LT_EQ] = ACTIONS(4498),
    [anon_sym_DOT] = ACTIONS(4496),
    [anon_sym_scoped] = ACTIONS(4496),
    [anon_sym_EQ_GT] = ACTIONS(4500),
    [anon_sym_var] = ACTIONS(4496),
    [anon_sym_yield] = ACTIONS(4496),
    [anon_sym_switch] = ACTIONS(4496),
    [anon_sym_when] = ACTIONS(4496),
    [sym_discard] = ACTIONS(4496),
    [anon_sym_DOT_DOT] = ACTIONS(4498),
    [anon_sym_and] = ACTIONS(4496),
    [anon_sym_or] = ACTIONS(4496),
    [anon_sym_AMP_AMP] = ACTIONS(4498),
    [anon_sym_PIPE_PIPE] = ACTIONS(4498),
    [anon_sym_QMARK_QMARK] = ACTIONS(4498),
    [anon_sym_from] = ACTIONS(4496),
    [anon_sym_into] = ACTIONS(4496),
    [anon_sym_join] = ACTIONS(4496),
    [anon_sym_on] = ACTIONS(4496),
    [anon_sym_equals] = ACTIONS(4496),
    [anon_sym_let] = ACTIONS(4496),
    [anon_sym_orderby] = ACTIONS(4496),
    [anon_sym_ascending] = ACTIONS(4496),
    [anon_sym_descending] = ACTIONS(4496),
    [anon_sym_group] = ACTIONS(4496),
    [anon_sym_by] = ACTIONS(4496),
    [anon_sym_select] = ACTIONS(4496),
    [anon_sym_as] = ACTIONS(4496),
    [anon_sym_is] = ACTIONS(4496),
    [anon_sym_DASH_GT] = ACTIONS(4498),
    [anon_sym_with] = ACTIONS(4496),
    [aux_sym_preproc_if_token3] = ACTIONS(4498),
    [aux_sym_preproc_else_token1] = ACTIONS(4498),
    [aux_sym_preproc_elif_token1] = ACTIONS(4498),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2960] = {
    [sym_preproc_region] = STATE(2960),
    [sym_preproc_endregion] = STATE(2960),
    [sym_preproc_line] = STATE(2960),
    [sym_preproc_pragma] = STATE(2960),
    [sym_preproc_nullable] = STATE(2960),
    [sym_preproc_error] = STATE(2960),
    [sym_preproc_define] = STATE(2960),
    [sym_preproc_undef] = STATE(2960),
    [sym__identifier_token] = ACTIONS(4099),
    [anon_sym_alias] = ACTIONS(4099),
    [anon_sym_global] = ACTIONS(4099),
    [anon_sym_EQ] = ACTIONS(4104),
    [anon_sym_LBRACK] = ACTIONS(4101),
    [anon_sym_LPAREN] = ACTIONS(4101),
    [anon_sym_file] = ACTIONS(4099),
    [anon_sym_LT] = ACTIONS(4104),
    [anon_sym_GT] = ACTIONS(4104),
    [anon_sym_where] = ACTIONS(4099),
    [anon_sym_QMARK] = ACTIONS(4108),
    [anon_sym_notnull] = ACTIONS(4099),
    [anon_sym_unmanaged] = ACTIONS(4099),
    [anon_sym_BANG] = ACTIONS(4104),
    [anon_sym_PLUS_PLUS] = ACTIONS(4111),
    [anon_sym_DASH_DASH] = ACTIONS(4111),
    [anon_sym_PLUS] = ACTIONS(4104),
    [anon_sym_DASH] = ACTIONS(4104),
    [anon_sym_STAR] = ACTIONS(4108),
    [anon_sym_SLASH] = ACTIONS(4104),
    [anon_sym_PERCENT] = ACTIONS(4104),
    [anon_sym_CARET] = ACTIONS(4104),
    [anon_sym_PIPE] = ACTIONS(4104),
    [anon_sym_AMP] = ACTIONS(4104),
    [anon_sym_LT_LT] = ACTIONS(4104),
    [anon_sym_GT_GT] = ACTIONS(4104),
    [anon_sym_GT_GT_GT] = ACTIONS(4104),
    [anon_sym_EQ_EQ] = ACTIONS(4111),
    [anon_sym_BANG_EQ] = ACTIONS(4111),
    [anon_sym_GT_EQ] = ACTIONS(4111),
    [anon_sym_LT_EQ] = ACTIONS(4111),
    [anon_sym_DOT] = ACTIONS(4108),
    [anon_sym_scoped] = ACTIONS(4099),
    [anon_sym_var] = ACTIONS(4099),
    [anon_sym_yield] = ACTIONS(4099),
    [anon_sym_switch] = ACTIONS(4104),
    [anon_sym_when] = ACTIONS(4099),
    [anon_sym_DOT_DOT] = ACTIONS(4111),
    [anon_sym_and] = ACTIONS(4104),
    [anon_sym_or] = ACTIONS(4104),
    [anon_sym_PLUS_EQ] = ACTIONS(4111),
    [anon_sym_DASH_EQ] = ACTIONS(4111),
    [anon_sym_STAR_EQ] = ACTIONS(4111),
    [anon_sym_SLASH_EQ] = ACTIONS(4111),
    [anon_sym_PERCENT_EQ] = ACTIONS(4111),
    [anon_sym_AMP_EQ] = ACTIONS(4111),
    [anon_sym_CARET_EQ] = ACTIONS(4111),
    [anon_sym_PIPE_EQ] = ACTIONS(4111),
    [anon_sym_LT_LT_EQ] = ACTIONS(4111),
    [anon_sym_GT_GT_EQ] = ACTIONS(4111),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4111),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4111),
    [anon_sym_AMP_AMP] = ACTIONS(4111),
    [anon_sym_PIPE_PIPE] = ACTIONS(4111),
    [anon_sym_QMARK_QMARK] = ACTIONS(4104),
    [anon_sym_from] = ACTIONS(4099),
    [anon_sym_into] = ACTIONS(4099),
    [anon_sym_join] = ACTIONS(4099),
    [anon_sym_on] = ACTIONS(4108),
    [anon_sym_equals] = ACTIONS(4099),
    [anon_sym_let] = ACTIONS(4099),
    [anon_sym_orderby] = ACTIONS(4099),
    [anon_sym_ascending] = ACTIONS(4099),
    [anon_sym_descending] = ACTIONS(4099),
    [anon_sym_group] = ACTIONS(4099),
    [anon_sym_by] = ACTIONS(4099),
    [anon_sym_select] = ACTIONS(4099),
    [anon_sym_as] = ACTIONS(4104),
    [anon_sym_is] = ACTIONS(4104),
    [anon_sym_DASH_GT] = ACTIONS(4101),
    [anon_sym_with] = ACTIONS(4104),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2961] = {
    [sym__name] = STATE(3008),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2977),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2956),
    [sym_ref_type] = STATE(2899),
    [sym__scoped_base_type] = STATE(2907),
    [sym_identifier] = STATE(2913),
    [sym__reserved_identifier] = STATE(2914),
    [sym_preproc_region] = STATE(2961),
    [sym_preproc_endregion] = STATE(2961),
    [sym_preproc_line] = STATE(2961),
    [sym_preproc_pragma] = STATE(2961),
    [sym_preproc_nullable] = STATE(2961),
    [sym_preproc_error] = STATE(2961),
    [sym_preproc_define] = STATE(2961),
    [sym_preproc_undef] = STATE(2961),
    [sym__identifier_token] = ACTIONS(4490),
    [anon_sym_alias] = ACTIONS(4492),
    [anon_sym_global] = ACTIONS(4492),
    [anon_sym_LBRACK] = ACTIONS(3719),
    [anon_sym_COMMA] = ACTIONS(3719),
    [anon_sym_LPAREN] = ACTIONS(3719),
    [anon_sym_ref] = ACTIONS(4545),
    [anon_sym_LBRACE] = ACTIONS(3719),
    [anon_sym_file] = ACTIONS(4492),
    [anon_sym_LT] = ACTIONS(3721),
    [anon_sym_GT] = ACTIONS(3721),
    [anon_sym_where] = ACTIONS(4001),
    [anon_sym_QMARK] = ACTIONS(3721),
    [anon_sym_notnull] = ACTIONS(4492),
    [anon_sym_unmanaged] = ACTIONS(4492),
    [anon_sym_BANG] = ACTIONS(3721),
    [anon_sym_PLUS_PLUS] = ACTIONS(3719),
    [anon_sym_DASH_DASH] = ACTIONS(3719),
    [anon_sym_PLUS] = ACTIONS(3721),
    [anon_sym_DASH] = ACTIONS(3721),
    [anon_sym_STAR] = ACTIONS(3719),
    [anon_sym_SLASH] = ACTIONS(3721),
    [anon_sym_PERCENT] = ACTIONS(3719),
    [anon_sym_CARET] = ACTIONS(3719),
    [anon_sym_PIPE] = ACTIONS(3721),
    [anon_sym_AMP] = ACTIONS(3721),
    [anon_sym_LT_LT] = ACTIONS(3719),
    [anon_sym_GT_GT] = ACTIONS(3721),
    [anon_sym_GT_GT_GT] = ACTIONS(3719),
    [anon_sym_EQ_EQ] = ACTIONS(3719),
    [anon_sym_BANG_EQ] = ACTIONS(3719),
    [anon_sym_GT_EQ] = ACTIONS(3719),
    [anon_sym_LT_EQ] = ACTIONS(3719),
    [anon_sym_DOT] = ACTIONS(3721),
    [anon_sym_scoped] = ACTIONS(4492),
    [anon_sym_COLON_COLON] = ACTIONS(3719),
    [anon_sym_var] = ACTIONS(4492),
    [anon_sym_yield] = ACTIONS(4492),
    [anon_sym_switch] = ACTIONS(3721),
    [anon_sym_when] = ACTIONS(4492),
    [anon_sym_DOT_DOT] = ACTIONS(3719),
    [anon_sym_and] = ACTIONS(3721),
    [anon_sym_or] = ACTIONS(3721),
    [anon_sym_AMP_AMP] = ACTIONS(3719),
    [anon_sym_PIPE_PIPE] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK] = ACTIONS(3719),
    [anon_sym_from] = ACTIONS(4001),
    [anon_sym_into] = ACTIONS(4001),
    [anon_sym_join] = ACTIONS(4001),
    [anon_sym_on] = ACTIONS(4492),
    [anon_sym_equals] = ACTIONS(4492),
    [anon_sym_let] = ACTIONS(4001),
    [anon_sym_orderby] = ACTIONS(4001),
    [anon_sym_ascending] = ACTIONS(4001),
    [anon_sym_descending] = ACTIONS(4001),
    [anon_sym_group] = ACTIONS(4001),
    [anon_sym_by] = ACTIONS(4492),
    [anon_sym_select] = ACTIONS(4001),
    [anon_sym_as] = ACTIONS(3721),
    [anon_sym_is] = ACTIONS(3721),
    [anon_sym_DASH_GT] = ACTIONS(3719),
    [anon_sym_with] = ACTIONS(3721),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2962] = {
    [sym_preproc_region] = STATE(2962),
    [sym_preproc_endregion] = STATE(2962),
    [sym_preproc_line] = STATE(2962),
    [sym_preproc_pragma] = STATE(2962),
    [sym_preproc_nullable] = STATE(2962),
    [sym_preproc_error] = STATE(2962),
    [sym_preproc_define] = STATE(2962),
    [sym_preproc_undef] = STATE(2962),
    [sym__identifier_token] = ACTIONS(4422),
    [anon_sym_alias] = ACTIONS(4422),
    [anon_sym_SEMI] = ACTIONS(4424),
    [anon_sym_global] = ACTIONS(4422),
    [anon_sym_LBRACK] = ACTIONS(4547),
    [anon_sym_COLON] = ACTIONS(4424),
    [anon_sym_COMMA] = ACTIONS(4424),
    [anon_sym_RBRACK] = ACTIONS(4424),
    [anon_sym_LPAREN] = ACTIONS(4424),
    [anon_sym_RPAREN] = ACTIONS(4424),
    [anon_sym_LBRACE] = ACTIONS(4424),
    [anon_sym_RBRACE] = ACTIONS(4424),
    [anon_sym_file] = ACTIONS(4422),
    [anon_sym_LT] = ACTIONS(4422),
    [anon_sym_GT] = ACTIONS(4422),
    [anon_sym_in] = ACTIONS(4422),
    [anon_sym_where] = ACTIONS(4422),
    [anon_sym_QMARK] = ACTIONS(4550),
    [anon_sym_notnull] = ACTIONS(4422),
    [anon_sym_unmanaged] = ACTIONS(4422),
    [anon_sym_BANG] = ACTIONS(4422),
    [anon_sym_PLUS_PLUS] = ACTIONS(4424),
    [anon_sym_DASH_DASH] = ACTIONS(4424),
    [anon_sym_PLUS] = ACTIONS(4422),
    [anon_sym_DASH] = ACTIONS(4422),
    [anon_sym_STAR] = ACTIONS(4553),
    [anon_sym_SLASH] = ACTIONS(4422),
    [anon_sym_PERCENT] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4424),
    [anon_sym_PIPE] = ACTIONS(4422),
    [anon_sym_AMP] = ACTIONS(4422),
    [anon_sym_LT_LT] = ACTIONS(4424),
    [anon_sym_GT_GT] = ACTIONS(4422),
    [anon_sym_GT_GT_GT] = ACTIONS(4424),
    [anon_sym_EQ_EQ] = ACTIONS(4424),
    [anon_sym_BANG_EQ] = ACTIONS(4424),
    [anon_sym_GT_EQ] = ACTIONS(4424),
    [anon_sym_LT_EQ] = ACTIONS(4424),
    [anon_sym_DOT] = ACTIONS(4556),
    [anon_sym_scoped] = ACTIONS(4422),
    [anon_sym_EQ_GT] = ACTIONS(4424),
    [anon_sym_var] = ACTIONS(4422),
    [anon_sym_yield] = ACTIONS(4422),
    [anon_sym_switch] = ACTIONS(4422),
    [anon_sym_when] = ACTIONS(4422),
    [sym_discard] = ACTIONS(4422),
    [anon_sym_DOT_DOT] = ACTIONS(4424),
    [anon_sym_and] = ACTIONS(4422),
    [anon_sym_or] = ACTIONS(4422),
    [anon_sym_AMP_AMP] = ACTIONS(4424),
    [anon_sym_PIPE_PIPE] = ACTIONS(4424),
    [anon_sym_QMARK_QMARK] = ACTIONS(4424),
    [anon_sym_from] = ACTIONS(4422),
    [anon_sym_into] = ACTIONS(4422),
    [anon_sym_join] = ACTIONS(4422),
    [anon_sym_on] = ACTIONS(4422),
    [anon_sym_equals] = ACTIONS(4422),
    [anon_sym_let] = ACTIONS(4422),
    [anon_sym_orderby] = ACTIONS(4422),
    [anon_sym_ascending] = ACTIONS(4422),
    [anon_sym_descending] = ACTIONS(4422),
    [anon_sym_group] = ACTIONS(4422),
    [anon_sym_by] = ACTIONS(4422),
    [anon_sym_select] = ACTIONS(4422),
    [anon_sym_as] = ACTIONS(4422),
    [anon_sym_is] = ACTIONS(4422),
    [anon_sym_DASH_GT] = ACTIONS(4558),
    [anon_sym_with] = ACTIONS(4422),
    [aux_sym_preproc_if_token3] = ACTIONS(4424),
    [aux_sym_preproc_else_token1] = ACTIONS(4424),
    [aux_sym_preproc_elif_token1] = ACTIONS(4424),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2963] = {
    [sym_preproc_region] = STATE(2963),
    [sym_preproc_endregion] = STATE(2963),
    [sym_preproc_line] = STATE(2963),
    [sym_preproc_pragma] = STATE(2963),
    [sym_preproc_nullable] = STATE(2963),
    [sym_preproc_error] = STATE(2963),
    [sym_preproc_define] = STATE(2963),
    [sym_preproc_undef] = STATE(2963),
    [sym__identifier_token] = ACTIONS(4422),
    [anon_sym_alias] = ACTIONS(4422),
    [anon_sym_SEMI] = ACTIONS(4424),
    [anon_sym_global] = ACTIONS(4422),
    [anon_sym_LBRACK] = ACTIONS(4547),
    [anon_sym_COLON] = ACTIONS(4424),
    [anon_sym_COMMA] = ACTIONS(4424),
    [anon_sym_RBRACK] = ACTIONS(4424),
    [anon_sym_LPAREN] = ACTIONS(4424),
    [anon_sym_RPAREN] = ACTIONS(4424),
    [anon_sym_LBRACE] = ACTIONS(4424),
    [anon_sym_RBRACE] = ACTIONS(4424),
    [anon_sym_file] = ACTIONS(4422),
    [anon_sym_LT] = ACTIONS(4422),
    [anon_sym_GT] = ACTIONS(4422),
    [anon_sym_in] = ACTIONS(4422),
    [anon_sym_where] = ACTIONS(4422),
    [anon_sym_QMARK] = ACTIONS(4550),
    [anon_sym_notnull] = ACTIONS(4422),
    [anon_sym_unmanaged] = ACTIONS(4422),
    [anon_sym_BANG] = ACTIONS(4422),
    [anon_sym_PLUS_PLUS] = ACTIONS(4424),
    [anon_sym_DASH_DASH] = ACTIONS(4424),
    [anon_sym_PLUS] = ACTIONS(4422),
    [anon_sym_DASH] = ACTIONS(4422),
    [anon_sym_STAR] = ACTIONS(4553),
    [anon_sym_SLASH] = ACTIONS(4422),
    [anon_sym_PERCENT] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4424),
    [anon_sym_PIPE] = ACTIONS(4422),
    [anon_sym_AMP] = ACTIONS(4422),
    [anon_sym_LT_LT] = ACTIONS(4424),
    [anon_sym_GT_GT] = ACTIONS(4422),
    [anon_sym_GT_GT_GT] = ACTIONS(4424),
    [anon_sym_EQ_EQ] = ACTIONS(4424),
    [anon_sym_BANG_EQ] = ACTIONS(4424),
    [anon_sym_GT_EQ] = ACTIONS(4424),
    [anon_sym_LT_EQ] = ACTIONS(4424),
    [anon_sym_DOT] = ACTIONS(4560),
    [anon_sym_scoped] = ACTIONS(4422),
    [anon_sym_EQ_GT] = ACTIONS(4424),
    [anon_sym_var] = ACTIONS(4422),
    [anon_sym_yield] = ACTIONS(4422),
    [anon_sym_switch] = ACTIONS(4422),
    [anon_sym_when] = ACTIONS(4422),
    [sym_discard] = ACTIONS(4422),
    [anon_sym_DOT_DOT] = ACTIONS(4424),
    [anon_sym_and] = ACTIONS(4422),
    [anon_sym_or] = ACTIONS(4422),
    [anon_sym_AMP_AMP] = ACTIONS(4424),
    [anon_sym_PIPE_PIPE] = ACTIONS(4424),
    [anon_sym_QMARK_QMARK] = ACTIONS(4424),
    [anon_sym_from] = ACTIONS(4422),
    [anon_sym_into] = ACTIONS(4422),
    [anon_sym_join] = ACTIONS(4422),
    [anon_sym_on] = ACTIONS(4422),
    [anon_sym_equals] = ACTIONS(4422),
    [anon_sym_let] = ACTIONS(4422),
    [anon_sym_orderby] = ACTIONS(4422),
    [anon_sym_ascending] = ACTIONS(4422),
    [anon_sym_descending] = ACTIONS(4422),
    [anon_sym_group] = ACTIONS(4422),
    [anon_sym_by] = ACTIONS(4422),
    [anon_sym_select] = ACTIONS(4422),
    [anon_sym_as] = ACTIONS(4422),
    [anon_sym_is] = ACTIONS(4422),
    [anon_sym_DASH_GT] = ACTIONS(4562),
    [anon_sym_with] = ACTIONS(4422),
    [aux_sym_preproc_if_token3] = ACTIONS(4424),
    [aux_sym_preproc_else_token1] = ACTIONS(4424),
    [aux_sym_preproc_elif_token1] = ACTIONS(4424),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2964] = {
    [sym_preproc_region] = STATE(2964),
    [sym_preproc_endregion] = STATE(2964),
    [sym_preproc_line] = STATE(2964),
    [sym_preproc_pragma] = STATE(2964),
    [sym_preproc_nullable] = STATE(2964),
    [sym_preproc_error] = STATE(2964),
    [sym_preproc_define] = STATE(2964),
    [sym_preproc_undef] = STATE(2964),
    [sym__identifier_token] = ACTIONS(4113),
    [anon_sym_alias] = ACTIONS(4113),
    [anon_sym_global] = ACTIONS(4113),
    [anon_sym_EQ] = ACTIONS(4118),
    [anon_sym_LBRACK] = ACTIONS(4135),
    [anon_sym_LPAREN] = ACTIONS(4135),
    [anon_sym_file] = ACTIONS(4113),
    [anon_sym_LT] = ACTIONS(4118),
    [anon_sym_GT] = ACTIONS(4118),
    [anon_sym_where] = ACTIONS(4113),
    [anon_sym_QMARK] = ACTIONS(4138),
    [anon_sym_notnull] = ACTIONS(4113),
    [anon_sym_unmanaged] = ACTIONS(4113),
    [anon_sym_BANG] = ACTIONS(4118),
    [anon_sym_PLUS_PLUS] = ACTIONS(4133),
    [anon_sym_DASH_DASH] = ACTIONS(4133),
    [anon_sym_PLUS] = ACTIONS(4118),
    [anon_sym_DASH] = ACTIONS(4118),
    [anon_sym_STAR] = ACTIONS(4138),
    [anon_sym_SLASH] = ACTIONS(4118),
    [anon_sym_PERCENT] = ACTIONS(4118),
    [anon_sym_CARET] = ACTIONS(4118),
    [anon_sym_PIPE] = ACTIONS(4118),
    [anon_sym_AMP] = ACTIONS(4118),
    [anon_sym_LT_LT] = ACTIONS(4118),
    [anon_sym_GT_GT] = ACTIONS(4118),
    [anon_sym_GT_GT_GT] = ACTIONS(4118),
    [anon_sym_EQ_EQ] = ACTIONS(4133),
    [anon_sym_BANG_EQ] = ACTIONS(4133),
    [anon_sym_GT_EQ] = ACTIONS(4133),
    [anon_sym_LT_EQ] = ACTIONS(4133),
    [anon_sym_DOT] = ACTIONS(4138),
    [anon_sym_scoped] = ACTIONS(4113),
    [anon_sym_var] = ACTIONS(4113),
    [anon_sym_yield] = ACTIONS(4113),
    [anon_sym_switch] = ACTIONS(4118),
    [anon_sym_when] = ACTIONS(4113),
    [anon_sym_DOT_DOT] = ACTIONS(4133),
    [anon_sym_and] = ACTIONS(4118),
    [anon_sym_or] = ACTIONS(4118),
    [anon_sym_PLUS_EQ] = ACTIONS(4133),
    [anon_sym_DASH_EQ] = ACTIONS(4133),
    [anon_sym_STAR_EQ] = ACTIONS(4133),
    [anon_sym_SLASH_EQ] = ACTIONS(4133),
    [anon_sym_PERCENT_EQ] = ACTIONS(4133),
    [anon_sym_AMP_EQ] = ACTIONS(4133),
    [anon_sym_CARET_EQ] = ACTIONS(4133),
    [anon_sym_PIPE_EQ] = ACTIONS(4133),
    [anon_sym_LT_LT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4133),
    [anon_sym_AMP_AMP] = ACTIONS(4133),
    [anon_sym_PIPE_PIPE] = ACTIONS(4133),
    [anon_sym_QMARK_QMARK] = ACTIONS(4118),
    [anon_sym_from] = ACTIONS(4113),
    [anon_sym_into] = ACTIONS(4113),
    [anon_sym_join] = ACTIONS(4113),
    [anon_sym_on] = ACTIONS(4138),
    [anon_sym_equals] = ACTIONS(4113),
    [anon_sym_let] = ACTIONS(4113),
    [anon_sym_orderby] = ACTIONS(4113),
    [anon_sym_ascending] = ACTIONS(4113),
    [anon_sym_descending] = ACTIONS(4113),
    [anon_sym_group] = ACTIONS(4113),
    [anon_sym_by] = ACTIONS(4113),
    [anon_sym_select] = ACTIONS(4113),
    [anon_sym_as] = ACTIONS(4118),
    [anon_sym_is] = ACTIONS(4118),
    [anon_sym_DASH_GT] = ACTIONS(4135),
    [anon_sym_with] = ACTIONS(4118),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2965] = {
    [sym_parameter_list] = STATE(9765),
    [sym_positional_pattern_clause] = STATE(3059),
    [sym_property_pattern_clause] = STATE(3116),
    [sym__variable_designation] = STATE(5398),
    [sym_parenthesized_variable_designation] = STATE(5390),
    [sym__lambda_parameters] = STATE(9127),
    [sym_identifier] = STATE(5303),
    [sym__reserved_identifier] = STATE(5128),
    [sym_preproc_region] = STATE(2965),
    [sym_preproc_endregion] = STATE(2965),
    [sym_preproc_line] = STATE(2965),
    [sym_preproc_pragma] = STATE(2965),
    [sym_preproc_nullable] = STATE(2965),
    [sym_preproc_error] = STATE(2965),
    [sym_preproc_define] = STATE(2965),
    [sym_preproc_undef] = STATE(2965),
    [sym__identifier_token] = ACTIONS(4482),
    [anon_sym_alias] = ACTIONS(4484),
    [anon_sym_global] = ACTIONS(4484),
    [anon_sym_LBRACK] = ACTIONS(4283),
    [anon_sym_COLON] = ACTIONS(4283),
    [anon_sym_COMMA] = ACTIONS(4283),
    [anon_sym_LPAREN] = ACTIONS(4283),
    [anon_sym_LBRACE] = ACTIONS(4486),
    [anon_sym_file] = ACTIONS(4484),
    [anon_sym_LT] = ACTIONS(4285),
    [anon_sym_GT] = ACTIONS(4285),
    [anon_sym_where] = ACTIONS(4484),
    [anon_sym_QMARK] = ACTIONS(4285),
    [anon_sym_notnull] = ACTIONS(4484),
    [anon_sym_unmanaged] = ACTIONS(4484),
    [anon_sym_BANG] = ACTIONS(4285),
    [anon_sym_PLUS_PLUS] = ACTIONS(4283),
    [anon_sym_DASH_DASH] = ACTIONS(4283),
    [anon_sym_PLUS] = ACTIONS(4285),
    [anon_sym_DASH] = ACTIONS(4285),
    [anon_sym_STAR] = ACTIONS(4283),
    [anon_sym_SLASH] = ACTIONS(4285),
    [anon_sym_PERCENT] = ACTIONS(4283),
    [anon_sym_CARET] = ACTIONS(4283),
    [anon_sym_PIPE] = ACTIONS(4285),
    [anon_sym_AMP] = ACTIONS(4285),
    [anon_sym_LT_LT] = ACTIONS(4283),
    [anon_sym_GT_GT] = ACTIONS(4285),
    [anon_sym_GT_GT_GT] = ACTIONS(4283),
    [anon_sym_EQ_EQ] = ACTIONS(4283),
    [anon_sym_BANG_EQ] = ACTIONS(4283),
    [anon_sym_GT_EQ] = ACTIONS(4283),
    [anon_sym_LT_EQ] = ACTIONS(4283),
    [anon_sym_DOT] = ACTIONS(4285),
    [anon_sym_scoped] = ACTIONS(4484),
    [anon_sym_var] = ACTIONS(4484),
    [anon_sym_yield] = ACTIONS(4484),
    [anon_sym_switch] = ACTIONS(4285),
    [anon_sym_when] = ACTIONS(4484),
    [sym_discard] = ACTIONS(4488),
    [anon_sym_DOT_DOT] = ACTIONS(4283),
    [anon_sym_and] = ACTIONS(4279),
    [anon_sym_or] = ACTIONS(4279),
    [anon_sym_AMP_AMP] = ACTIONS(4283),
    [anon_sym_PIPE_PIPE] = ACTIONS(4283),
    [anon_sym_QMARK_QMARK] = ACTIONS(4283),
    [anon_sym_from] = ACTIONS(4484),
    [anon_sym_into] = ACTIONS(4285),
    [anon_sym_join] = ACTIONS(4484),
    [anon_sym_on] = ACTIONS(4484),
    [anon_sym_equals] = ACTIONS(4484),
    [anon_sym_let] = ACTIONS(4484),
    [anon_sym_orderby] = ACTIONS(4484),
    [anon_sym_ascending] = ACTIONS(4484),
    [anon_sym_descending] = ACTIONS(4484),
    [anon_sym_group] = ACTIONS(4484),
    [anon_sym_by] = ACTIONS(4484),
    [anon_sym_select] = ACTIONS(4484),
    [anon_sym_as] = ACTIONS(4285),
    [anon_sym_is] = ACTIONS(4285),
    [anon_sym_DASH_GT] = ACTIONS(4283),
    [anon_sym_with] = ACTIONS(4285),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4283),
  },
  [2966] = {
    [sym_preproc_region] = STATE(2966),
    [sym_preproc_endregion] = STATE(2966),
    [sym_preproc_line] = STATE(2966),
    [sym_preproc_pragma] = STATE(2966),
    [sym_preproc_nullable] = STATE(2966),
    [sym_preproc_error] = STATE(2966),
    [sym_preproc_define] = STATE(2966),
    [sym_preproc_undef] = STATE(2966),
    [sym__identifier_token] = ACTIONS(4564),
    [anon_sym_alias] = ACTIONS(4564),
    [anon_sym_SEMI] = ACTIONS(4566),
    [anon_sym_global] = ACTIONS(4564),
    [anon_sym_LBRACK] = ACTIONS(4566),
    [anon_sym_COLON] = ACTIONS(4566),
    [anon_sym_COMMA] = ACTIONS(4566),
    [anon_sym_RBRACK] = ACTIONS(4566),
    [anon_sym_LPAREN] = ACTIONS(4566),
    [anon_sym_RPAREN] = ACTIONS(4566),
    [anon_sym_LBRACE] = ACTIONS(4566),
    [anon_sym_RBRACE] = ACTIONS(4566),
    [anon_sym_file] = ACTIONS(4564),
    [anon_sym_LT] = ACTIONS(4564),
    [anon_sym_GT] = ACTIONS(4564),
    [anon_sym_in] = ACTIONS(4564),
    [anon_sym_where] = ACTIONS(4564),
    [anon_sym_QMARK] = ACTIONS(4564),
    [anon_sym_notnull] = ACTIONS(4564),
    [anon_sym_unmanaged] = ACTIONS(4564),
    [anon_sym_BANG] = ACTIONS(4564),
    [anon_sym_PLUS_PLUS] = ACTIONS(4566),
    [anon_sym_DASH_DASH] = ACTIONS(4566),
    [anon_sym_PLUS] = ACTIONS(4564),
    [anon_sym_DASH] = ACTIONS(4564),
    [anon_sym_STAR] = ACTIONS(4566),
    [anon_sym_SLASH] = ACTIONS(4564),
    [anon_sym_PERCENT] = ACTIONS(4566),
    [anon_sym_CARET] = ACTIONS(4566),
    [anon_sym_PIPE] = ACTIONS(4564),
    [anon_sym_AMP] = ACTIONS(4564),
    [anon_sym_LT_LT] = ACTIONS(4566),
    [anon_sym_GT_GT] = ACTIONS(4564),
    [anon_sym_GT_GT_GT] = ACTIONS(4566),
    [anon_sym_EQ_EQ] = ACTIONS(4566),
    [anon_sym_BANG_EQ] = ACTIONS(4566),
    [anon_sym_GT_EQ] = ACTIONS(4566),
    [anon_sym_LT_EQ] = ACTIONS(4566),
    [anon_sym_DOT] = ACTIONS(4564),
    [anon_sym_scoped] = ACTIONS(4564),
    [anon_sym_EQ_GT] = ACTIONS(4566),
    [anon_sym_var] = ACTIONS(4564),
    [anon_sym_yield] = ACTIONS(4564),
    [anon_sym_switch] = ACTIONS(4564),
    [anon_sym_when] = ACTIONS(4564),
    [sym_discard] = ACTIONS(4564),
    [anon_sym_DOT_DOT] = ACTIONS(4566),
    [anon_sym_and] = ACTIONS(4564),
    [anon_sym_or] = ACTIONS(4564),
    [anon_sym_AMP_AMP] = ACTIONS(4566),
    [anon_sym_PIPE_PIPE] = ACTIONS(4566),
    [anon_sym_QMARK_QMARK] = ACTIONS(4566),
    [anon_sym_from] = ACTIONS(4564),
    [anon_sym_into] = ACTIONS(4564),
    [anon_sym_join] = ACTIONS(4564),
    [anon_sym_on] = ACTIONS(4564),
    [anon_sym_equals] = ACTIONS(4564),
    [anon_sym_let] = ACTIONS(4564),
    [anon_sym_orderby] = ACTIONS(4564),
    [anon_sym_ascending] = ACTIONS(4564),
    [anon_sym_descending] = ACTIONS(4564),
    [anon_sym_group] = ACTIONS(4564),
    [anon_sym_by] = ACTIONS(4564),
    [anon_sym_select] = ACTIONS(4564),
    [anon_sym_as] = ACTIONS(4564),
    [anon_sym_is] = ACTIONS(4564),
    [anon_sym_DASH_GT] = ACTIONS(4566),
    [anon_sym_with] = ACTIONS(4564),
    [aux_sym_preproc_if_token3] = ACTIONS(4566),
    [aux_sym_preproc_else_token1] = ACTIONS(4566),
    [aux_sym_preproc_elif_token1] = ACTIONS(4566),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2967] = {
    [sym_preproc_region] = STATE(2967),
    [sym_preproc_endregion] = STATE(2967),
    [sym_preproc_line] = STATE(2967),
    [sym_preproc_pragma] = STATE(2967),
    [sym_preproc_nullable] = STATE(2967),
    [sym_preproc_error] = STATE(2967),
    [sym_preproc_define] = STATE(2967),
    [sym_preproc_undef] = STATE(2967),
    [sym__identifier_token] = ACTIONS(4099),
    [anon_sym_alias] = ACTIONS(4099),
    [anon_sym_global] = ACTIONS(4099),
    [anon_sym_EQ] = ACTIONS(4104),
    [anon_sym_LBRACK] = ACTIONS(4101),
    [anon_sym_LPAREN] = ACTIONS(4101),
    [anon_sym_file] = ACTIONS(4099),
    [anon_sym_LT] = ACTIONS(4104),
    [anon_sym_GT] = ACTIONS(4104),
    [anon_sym_where] = ACTIONS(4099),
    [anon_sym_QMARK] = ACTIONS(4108),
    [anon_sym_notnull] = ACTIONS(4099),
    [anon_sym_unmanaged] = ACTIONS(4099),
    [anon_sym_BANG] = ACTIONS(4104),
    [anon_sym_PLUS_PLUS] = ACTIONS(4111),
    [anon_sym_DASH_DASH] = ACTIONS(4111),
    [anon_sym_PLUS] = ACTIONS(4104),
    [anon_sym_DASH] = ACTIONS(4104),
    [anon_sym_STAR] = ACTIONS(4108),
    [anon_sym_SLASH] = ACTIONS(4104),
    [anon_sym_PERCENT] = ACTIONS(4104),
    [anon_sym_CARET] = ACTIONS(4104),
    [anon_sym_PIPE] = ACTIONS(4104),
    [anon_sym_AMP] = ACTIONS(4104),
    [anon_sym_LT_LT] = ACTIONS(4104),
    [anon_sym_GT_GT] = ACTIONS(4104),
    [anon_sym_GT_GT_GT] = ACTIONS(4104),
    [anon_sym_EQ_EQ] = ACTIONS(4111),
    [anon_sym_BANG_EQ] = ACTIONS(4111),
    [anon_sym_GT_EQ] = ACTIONS(4111),
    [anon_sym_LT_EQ] = ACTIONS(4111),
    [anon_sym_DOT] = ACTIONS(4108),
    [anon_sym_scoped] = ACTIONS(4099),
    [anon_sym_var] = ACTIONS(4099),
    [anon_sym_yield] = ACTIONS(4099),
    [anon_sym_switch] = ACTIONS(4104),
    [anon_sym_when] = ACTIONS(4099),
    [anon_sym_DOT_DOT] = ACTIONS(4111),
    [anon_sym_and] = ACTIONS(4104),
    [anon_sym_or] = ACTIONS(4104),
    [anon_sym_PLUS_EQ] = ACTIONS(4111),
    [anon_sym_DASH_EQ] = ACTIONS(4111),
    [anon_sym_STAR_EQ] = ACTIONS(4111),
    [anon_sym_SLASH_EQ] = ACTIONS(4111),
    [anon_sym_PERCENT_EQ] = ACTIONS(4111),
    [anon_sym_AMP_EQ] = ACTIONS(4111),
    [anon_sym_CARET_EQ] = ACTIONS(4111),
    [anon_sym_PIPE_EQ] = ACTIONS(4111),
    [anon_sym_LT_LT_EQ] = ACTIONS(4111),
    [anon_sym_GT_GT_EQ] = ACTIONS(4111),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4111),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4111),
    [anon_sym_AMP_AMP] = ACTIONS(4111),
    [anon_sym_PIPE_PIPE] = ACTIONS(4111),
    [anon_sym_QMARK_QMARK] = ACTIONS(4104),
    [anon_sym_from] = ACTIONS(4099),
    [anon_sym_into] = ACTIONS(4108),
    [anon_sym_join] = ACTIONS(4099),
    [anon_sym_on] = ACTIONS(4099),
    [anon_sym_equals] = ACTIONS(4099),
    [anon_sym_let] = ACTIONS(4099),
    [anon_sym_orderby] = ACTIONS(4099),
    [anon_sym_ascending] = ACTIONS(4099),
    [anon_sym_descending] = ACTIONS(4099),
    [anon_sym_group] = ACTIONS(4099),
    [anon_sym_by] = ACTIONS(4108),
    [anon_sym_select] = ACTIONS(4099),
    [anon_sym_as] = ACTIONS(4104),
    [anon_sym_is] = ACTIONS(4104),
    [anon_sym_DASH_GT] = ACTIONS(4101),
    [anon_sym_with] = ACTIONS(4104),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2968] = {
    [sym_preproc_region] = STATE(2968),
    [sym_preproc_endregion] = STATE(2968),
    [sym_preproc_line] = STATE(2968),
    [sym_preproc_pragma] = STATE(2968),
    [sym_preproc_nullable] = STATE(2968),
    [sym_preproc_error] = STATE(2968),
    [sym_preproc_define] = STATE(2968),
    [sym_preproc_undef] = STATE(2968),
    [sym__identifier_token] = ACTIONS(4113),
    [anon_sym_alias] = ACTIONS(4113),
    [anon_sym_global] = ACTIONS(4113),
    [anon_sym_EQ] = ACTIONS(4118),
    [anon_sym_LBRACK] = ACTIONS(4135),
    [anon_sym_LPAREN] = ACTIONS(4135),
    [anon_sym_file] = ACTIONS(4113),
    [anon_sym_LT] = ACTIONS(4118),
    [anon_sym_GT] = ACTIONS(4118),
    [anon_sym_where] = ACTIONS(4113),
    [anon_sym_QMARK] = ACTIONS(4138),
    [anon_sym_notnull] = ACTIONS(4113),
    [anon_sym_unmanaged] = ACTIONS(4113),
    [anon_sym_BANG] = ACTIONS(4118),
    [anon_sym_PLUS_PLUS] = ACTIONS(4133),
    [anon_sym_DASH_DASH] = ACTIONS(4133),
    [anon_sym_PLUS] = ACTIONS(4118),
    [anon_sym_DASH] = ACTIONS(4118),
    [anon_sym_STAR] = ACTIONS(4138),
    [anon_sym_SLASH] = ACTIONS(4118),
    [anon_sym_PERCENT] = ACTIONS(4118),
    [anon_sym_CARET] = ACTIONS(4118),
    [anon_sym_PIPE] = ACTIONS(4118),
    [anon_sym_AMP] = ACTIONS(4118),
    [anon_sym_LT_LT] = ACTIONS(4118),
    [anon_sym_GT_GT] = ACTIONS(4118),
    [anon_sym_GT_GT_GT] = ACTIONS(4118),
    [anon_sym_EQ_EQ] = ACTIONS(4133),
    [anon_sym_BANG_EQ] = ACTIONS(4133),
    [anon_sym_GT_EQ] = ACTIONS(4133),
    [anon_sym_LT_EQ] = ACTIONS(4133),
    [anon_sym_DOT] = ACTIONS(4138),
    [anon_sym_scoped] = ACTIONS(4113),
    [anon_sym_var] = ACTIONS(4113),
    [anon_sym_yield] = ACTIONS(4113),
    [anon_sym_switch] = ACTIONS(4118),
    [anon_sym_when] = ACTIONS(4113),
    [anon_sym_DOT_DOT] = ACTIONS(4133),
    [anon_sym_and] = ACTIONS(4118),
    [anon_sym_or] = ACTIONS(4118),
    [anon_sym_PLUS_EQ] = ACTIONS(4133),
    [anon_sym_DASH_EQ] = ACTIONS(4133),
    [anon_sym_STAR_EQ] = ACTIONS(4133),
    [anon_sym_SLASH_EQ] = ACTIONS(4133),
    [anon_sym_PERCENT_EQ] = ACTIONS(4133),
    [anon_sym_AMP_EQ] = ACTIONS(4133),
    [anon_sym_CARET_EQ] = ACTIONS(4133),
    [anon_sym_PIPE_EQ] = ACTIONS(4133),
    [anon_sym_LT_LT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4133),
    [anon_sym_AMP_AMP] = ACTIONS(4133),
    [anon_sym_PIPE_PIPE] = ACTIONS(4133),
    [anon_sym_QMARK_QMARK] = ACTIONS(4118),
    [anon_sym_from] = ACTIONS(4113),
    [anon_sym_into] = ACTIONS(4138),
    [anon_sym_join] = ACTIONS(4113),
    [anon_sym_on] = ACTIONS(4138),
    [anon_sym_equals] = ACTIONS(4113),
    [anon_sym_let] = ACTIONS(4113),
    [anon_sym_orderby] = ACTIONS(4113),
    [anon_sym_ascending] = ACTIONS(4113),
    [anon_sym_descending] = ACTIONS(4113),
    [anon_sym_group] = ACTIONS(4113),
    [anon_sym_by] = ACTIONS(4113),
    [anon_sym_select] = ACTIONS(4113),
    [anon_sym_as] = ACTIONS(4118),
    [anon_sym_is] = ACTIONS(4118),
    [anon_sym_DASH_GT] = ACTIONS(4135),
    [anon_sym_with] = ACTIONS(4118),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2969] = {
    [sym_preproc_region] = STATE(2969),
    [sym_preproc_endregion] = STATE(2969),
    [sym_preproc_line] = STATE(2969),
    [sym_preproc_pragma] = STATE(2969),
    [sym_preproc_nullable] = STATE(2969),
    [sym_preproc_error] = STATE(2969),
    [sym_preproc_define] = STATE(2969),
    [sym_preproc_undef] = STATE(2969),
    [sym__identifier_token] = ACTIONS(4099),
    [anon_sym_alias] = ACTIONS(4099),
    [anon_sym_global] = ACTIONS(4099),
    [anon_sym_EQ] = ACTIONS(4104),
    [anon_sym_LBRACK] = ACTIONS(4101),
    [anon_sym_LPAREN] = ACTIONS(4101),
    [anon_sym_file] = ACTIONS(4099),
    [anon_sym_LT] = ACTIONS(4104),
    [anon_sym_GT] = ACTIONS(4104),
    [anon_sym_where] = ACTIONS(4099),
    [anon_sym_QMARK] = ACTIONS(4108),
    [anon_sym_notnull] = ACTIONS(4099),
    [anon_sym_unmanaged] = ACTIONS(4099),
    [anon_sym_BANG] = ACTIONS(4104),
    [anon_sym_PLUS_PLUS] = ACTIONS(4111),
    [anon_sym_DASH_DASH] = ACTIONS(4111),
    [anon_sym_PLUS] = ACTIONS(4104),
    [anon_sym_DASH] = ACTIONS(4104),
    [anon_sym_STAR] = ACTIONS(4108),
    [anon_sym_SLASH] = ACTIONS(4104),
    [anon_sym_PERCENT] = ACTIONS(4104),
    [anon_sym_CARET] = ACTIONS(4104),
    [anon_sym_PIPE] = ACTIONS(4104),
    [anon_sym_AMP] = ACTIONS(4104),
    [anon_sym_LT_LT] = ACTIONS(4104),
    [anon_sym_GT_GT] = ACTIONS(4104),
    [anon_sym_GT_GT_GT] = ACTIONS(4104),
    [anon_sym_EQ_EQ] = ACTIONS(4111),
    [anon_sym_BANG_EQ] = ACTIONS(4111),
    [anon_sym_GT_EQ] = ACTIONS(4111),
    [anon_sym_LT_EQ] = ACTIONS(4111),
    [anon_sym_DOT] = ACTIONS(4108),
    [anon_sym_scoped] = ACTIONS(4099),
    [anon_sym_var] = ACTIONS(4099),
    [anon_sym_yield] = ACTIONS(4099),
    [anon_sym_switch] = ACTIONS(4104),
    [anon_sym_when] = ACTIONS(4099),
    [anon_sym_DOT_DOT] = ACTIONS(4111),
    [anon_sym_and] = ACTIONS(4104),
    [anon_sym_or] = ACTIONS(4104),
    [anon_sym_PLUS_EQ] = ACTIONS(4111),
    [anon_sym_DASH_EQ] = ACTIONS(4111),
    [anon_sym_STAR_EQ] = ACTIONS(4111),
    [anon_sym_SLASH_EQ] = ACTIONS(4111),
    [anon_sym_PERCENT_EQ] = ACTIONS(4111),
    [anon_sym_AMP_EQ] = ACTIONS(4111),
    [anon_sym_CARET_EQ] = ACTIONS(4111),
    [anon_sym_PIPE_EQ] = ACTIONS(4111),
    [anon_sym_LT_LT_EQ] = ACTIONS(4111),
    [anon_sym_GT_GT_EQ] = ACTIONS(4111),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4111),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4111),
    [anon_sym_AMP_AMP] = ACTIONS(4111),
    [anon_sym_PIPE_PIPE] = ACTIONS(4111),
    [anon_sym_QMARK_QMARK] = ACTIONS(4104),
    [anon_sym_from] = ACTIONS(4099),
    [anon_sym_into] = ACTIONS(4108),
    [anon_sym_join] = ACTIONS(4099),
    [anon_sym_on] = ACTIONS(4108),
    [anon_sym_equals] = ACTIONS(4099),
    [anon_sym_let] = ACTIONS(4099),
    [anon_sym_orderby] = ACTIONS(4099),
    [anon_sym_ascending] = ACTIONS(4099),
    [anon_sym_descending] = ACTIONS(4099),
    [anon_sym_group] = ACTIONS(4099),
    [anon_sym_by] = ACTIONS(4099),
    [anon_sym_select] = ACTIONS(4099),
    [anon_sym_as] = ACTIONS(4104),
    [anon_sym_is] = ACTIONS(4104),
    [anon_sym_DASH_GT] = ACTIONS(4101),
    [anon_sym_with] = ACTIONS(4104),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2970] = {
    [sym_parameter_list] = STATE(9765),
    [sym_positional_pattern_clause] = STATE(3059),
    [sym_property_pattern_clause] = STATE(3116),
    [sym__variable_designation] = STATE(5398),
    [sym_parenthesized_variable_designation] = STATE(5390),
    [sym__lambda_parameters] = STATE(9127),
    [sym_identifier] = STATE(5303),
    [sym__reserved_identifier] = STATE(5128),
    [sym_preproc_region] = STATE(2970),
    [sym_preproc_endregion] = STATE(2970),
    [sym_preproc_line] = STATE(2970),
    [sym_preproc_pragma] = STATE(2970),
    [sym_preproc_nullable] = STATE(2970),
    [sym_preproc_error] = STATE(2970),
    [sym_preproc_define] = STATE(2970),
    [sym_preproc_undef] = STATE(2970),
    [sym__identifier_token] = ACTIONS(4482),
    [anon_sym_alias] = ACTIONS(4484),
    [anon_sym_global] = ACTIONS(4484),
    [anon_sym_LBRACK] = ACTIONS(4275),
    [anon_sym_COLON] = ACTIONS(4275),
    [anon_sym_COMMA] = ACTIONS(4275),
    [anon_sym_LPAREN] = ACTIONS(4275),
    [anon_sym_LBRACE] = ACTIONS(4486),
    [anon_sym_file] = ACTIONS(4484),
    [anon_sym_LT] = ACTIONS(4279),
    [anon_sym_GT] = ACTIONS(4279),
    [anon_sym_where] = ACTIONS(4484),
    [anon_sym_QMARK] = ACTIONS(4279),
    [anon_sym_notnull] = ACTIONS(4484),
    [anon_sym_unmanaged] = ACTIONS(4484),
    [anon_sym_BANG] = ACTIONS(4279),
    [anon_sym_PLUS_PLUS] = ACTIONS(4275),
    [anon_sym_DASH_DASH] = ACTIONS(4275),
    [anon_sym_PLUS] = ACTIONS(4279),
    [anon_sym_DASH] = ACTIONS(4279),
    [anon_sym_STAR] = ACTIONS(4275),
    [anon_sym_SLASH] = ACTIONS(4279),
    [anon_sym_PERCENT] = ACTIONS(4275),
    [anon_sym_CARET] = ACTIONS(4275),
    [anon_sym_PIPE] = ACTIONS(4279),
    [anon_sym_AMP] = ACTIONS(4279),
    [anon_sym_LT_LT] = ACTIONS(4275),
    [anon_sym_GT_GT] = ACTIONS(4279),
    [anon_sym_GT_GT_GT] = ACTIONS(4275),
    [anon_sym_EQ_EQ] = ACTIONS(4275),
    [anon_sym_BANG_EQ] = ACTIONS(4275),
    [anon_sym_GT_EQ] = ACTIONS(4275),
    [anon_sym_LT_EQ] = ACTIONS(4275),
    [anon_sym_DOT] = ACTIONS(4279),
    [anon_sym_scoped] = ACTIONS(4484),
    [anon_sym_var] = ACTIONS(4484),
    [anon_sym_yield] = ACTIONS(4484),
    [anon_sym_switch] = ACTIONS(4279),
    [anon_sym_when] = ACTIONS(4484),
    [sym_discard] = ACTIONS(4488),
    [anon_sym_DOT_DOT] = ACTIONS(4275),
    [anon_sym_and] = ACTIONS(4279),
    [anon_sym_or] = ACTIONS(4279),
    [anon_sym_AMP_AMP] = ACTIONS(4275),
    [anon_sym_PIPE_PIPE] = ACTIONS(4275),
    [anon_sym_QMARK_QMARK] = ACTIONS(4275),
    [anon_sym_from] = ACTIONS(4484),
    [anon_sym_into] = ACTIONS(4279),
    [anon_sym_join] = ACTIONS(4484),
    [anon_sym_on] = ACTIONS(4484),
    [anon_sym_equals] = ACTIONS(4484),
    [anon_sym_let] = ACTIONS(4484),
    [anon_sym_orderby] = ACTIONS(4484),
    [anon_sym_ascending] = ACTIONS(4484),
    [anon_sym_descending] = ACTIONS(4484),
    [anon_sym_group] = ACTIONS(4484),
    [anon_sym_by] = ACTIONS(4484),
    [anon_sym_select] = ACTIONS(4484),
    [anon_sym_as] = ACTIONS(4279),
    [anon_sym_is] = ACTIONS(4279),
    [anon_sym_DASH_GT] = ACTIONS(4275),
    [anon_sym_with] = ACTIONS(4279),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4275),
  },
  [2971] = {
    [sym_preproc_region] = STATE(2971),
    [sym_preproc_endregion] = STATE(2971),
    [sym_preproc_line] = STATE(2971),
    [sym_preproc_pragma] = STATE(2971),
    [sym_preproc_nullable] = STATE(2971),
    [sym_preproc_error] = STATE(2971),
    [sym_preproc_define] = STATE(2971),
    [sym_preproc_undef] = STATE(2971),
    [sym__identifier_token] = ACTIONS(4568),
    [anon_sym_alias] = ACTIONS(4568),
    [anon_sym_SEMI] = ACTIONS(4570),
    [anon_sym_global] = ACTIONS(4568),
    [anon_sym_LBRACK] = ACTIONS(4570),
    [anon_sym_COLON] = ACTIONS(4570),
    [anon_sym_COMMA] = ACTIONS(4570),
    [anon_sym_RBRACK] = ACTIONS(4570),
    [anon_sym_LPAREN] = ACTIONS(4570),
    [anon_sym_RPAREN] = ACTIONS(4570),
    [anon_sym_LBRACE] = ACTIONS(4570),
    [anon_sym_RBRACE] = ACTIONS(4570),
    [anon_sym_file] = ACTIONS(4568),
    [anon_sym_LT] = ACTIONS(4568),
    [anon_sym_GT] = ACTIONS(4568),
    [anon_sym_in] = ACTIONS(4568),
    [anon_sym_where] = ACTIONS(4568),
    [anon_sym_QMARK] = ACTIONS(4568),
    [anon_sym_notnull] = ACTIONS(4568),
    [anon_sym_unmanaged] = ACTIONS(4568),
    [anon_sym_BANG] = ACTIONS(4568),
    [anon_sym_PLUS_PLUS] = ACTIONS(4570),
    [anon_sym_DASH_DASH] = ACTIONS(4570),
    [anon_sym_PLUS] = ACTIONS(4568),
    [anon_sym_DASH] = ACTIONS(4568),
    [anon_sym_STAR] = ACTIONS(4570),
    [anon_sym_SLASH] = ACTIONS(4568),
    [anon_sym_PERCENT] = ACTIONS(4570),
    [anon_sym_CARET] = ACTIONS(4570),
    [anon_sym_PIPE] = ACTIONS(4568),
    [anon_sym_AMP] = ACTIONS(4568),
    [anon_sym_LT_LT] = ACTIONS(4570),
    [anon_sym_GT_GT] = ACTIONS(4568),
    [anon_sym_GT_GT_GT] = ACTIONS(4570),
    [anon_sym_EQ_EQ] = ACTIONS(4570),
    [anon_sym_BANG_EQ] = ACTIONS(4570),
    [anon_sym_GT_EQ] = ACTIONS(4570),
    [anon_sym_LT_EQ] = ACTIONS(4570),
    [anon_sym_DOT] = ACTIONS(4568),
    [anon_sym_scoped] = ACTIONS(4568),
    [anon_sym_EQ_GT] = ACTIONS(4570),
    [anon_sym_var] = ACTIONS(4568),
    [anon_sym_yield] = ACTIONS(4568),
    [anon_sym_switch] = ACTIONS(4568),
    [anon_sym_when] = ACTIONS(4568),
    [sym_discard] = ACTIONS(4568),
    [anon_sym_DOT_DOT] = ACTIONS(4570),
    [anon_sym_and] = ACTIONS(4568),
    [anon_sym_or] = ACTIONS(4568),
    [anon_sym_AMP_AMP] = ACTIONS(4570),
    [anon_sym_PIPE_PIPE] = ACTIONS(4570),
    [anon_sym_QMARK_QMARK] = ACTIONS(4570),
    [anon_sym_from] = ACTIONS(4568),
    [anon_sym_into] = ACTIONS(4568),
    [anon_sym_join] = ACTIONS(4568),
    [anon_sym_on] = ACTIONS(4568),
    [anon_sym_equals] = ACTIONS(4568),
    [anon_sym_let] = ACTIONS(4568),
    [anon_sym_orderby] = ACTIONS(4568),
    [anon_sym_ascending] = ACTIONS(4568),
    [anon_sym_descending] = ACTIONS(4568),
    [anon_sym_group] = ACTIONS(4568),
    [anon_sym_by] = ACTIONS(4568),
    [anon_sym_select] = ACTIONS(4568),
    [anon_sym_as] = ACTIONS(4568),
    [anon_sym_is] = ACTIONS(4568),
    [anon_sym_DASH_GT] = ACTIONS(4570),
    [anon_sym_with] = ACTIONS(4568),
    [aux_sym_preproc_if_token3] = ACTIONS(4570),
    [aux_sym_preproc_else_token1] = ACTIONS(4570),
    [aux_sym_preproc_elif_token1] = ACTIONS(4570),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2972] = {
    [sym_preproc_region] = STATE(2972),
    [sym_preproc_endregion] = STATE(2972),
    [sym_preproc_line] = STATE(2972),
    [sym_preproc_pragma] = STATE(2972),
    [sym_preproc_nullable] = STATE(2972),
    [sym_preproc_error] = STATE(2972),
    [sym_preproc_define] = STATE(2972),
    [sym_preproc_undef] = STATE(2972),
    [sym__identifier_token] = ACTIONS(4099),
    [anon_sym_alias] = ACTIONS(4099),
    [anon_sym_SEMI] = ACTIONS(4106),
    [anon_sym_global] = ACTIONS(4099),
    [anon_sym_LBRACK] = ACTIONS(4106),
    [anon_sym_COLON] = ACTIONS(4106),
    [anon_sym_COMMA] = ACTIONS(4106),
    [anon_sym_RBRACK] = ACTIONS(4106),
    [anon_sym_LPAREN] = ACTIONS(4106),
    [anon_sym_RPAREN] = ACTIONS(4106),
    [anon_sym_LBRACE] = ACTIONS(4106),
    [anon_sym_RBRACE] = ACTIONS(4106),
    [anon_sym_file] = ACTIONS(4099),
    [anon_sym_LT] = ACTIONS(4099),
    [anon_sym_GT] = ACTIONS(4099),
    [anon_sym_in] = ACTIONS(4099),
    [anon_sym_where] = ACTIONS(4099),
    [anon_sym_QMARK] = ACTIONS(4099),
    [anon_sym_notnull] = ACTIONS(4099),
    [anon_sym_unmanaged] = ACTIONS(4099),
    [anon_sym_BANG] = ACTIONS(4099),
    [anon_sym_PLUS_PLUS] = ACTIONS(4106),
    [anon_sym_DASH_DASH] = ACTIONS(4106),
    [anon_sym_PLUS] = ACTIONS(4099),
    [anon_sym_DASH] = ACTIONS(4099),
    [anon_sym_STAR] = ACTIONS(4106),
    [anon_sym_SLASH] = ACTIONS(4099),
    [anon_sym_PERCENT] = ACTIONS(4106),
    [anon_sym_CARET] = ACTIONS(4106),
    [anon_sym_PIPE] = ACTIONS(4099),
    [anon_sym_AMP] = ACTIONS(4099),
    [anon_sym_LT_LT] = ACTIONS(4106),
    [anon_sym_GT_GT] = ACTIONS(4099),
    [anon_sym_GT_GT_GT] = ACTIONS(4106),
    [anon_sym_EQ_EQ] = ACTIONS(4106),
    [anon_sym_BANG_EQ] = ACTIONS(4106),
    [anon_sym_GT_EQ] = ACTIONS(4106),
    [anon_sym_LT_EQ] = ACTIONS(4106),
    [anon_sym_DOT] = ACTIONS(4099),
    [anon_sym_scoped] = ACTIONS(4099),
    [anon_sym_EQ_GT] = ACTIONS(4106),
    [anon_sym_var] = ACTIONS(4099),
    [anon_sym_yield] = ACTIONS(4099),
    [anon_sym_switch] = ACTIONS(4099),
    [anon_sym_when] = ACTIONS(4099),
    [sym_discard] = ACTIONS(4099),
    [anon_sym_DOT_DOT] = ACTIONS(4106),
    [anon_sym_and] = ACTIONS(4099),
    [anon_sym_or] = ACTIONS(4099),
    [anon_sym_AMP_AMP] = ACTIONS(4106),
    [anon_sym_PIPE_PIPE] = ACTIONS(4106),
    [anon_sym_QMARK_QMARK] = ACTIONS(4106),
    [anon_sym_from] = ACTIONS(4099),
    [anon_sym_into] = ACTIONS(4099),
    [anon_sym_join] = ACTIONS(4099),
    [anon_sym_on] = ACTIONS(4099),
    [anon_sym_equals] = ACTIONS(4099),
    [anon_sym_let] = ACTIONS(4099),
    [anon_sym_orderby] = ACTIONS(4099),
    [anon_sym_ascending] = ACTIONS(4099),
    [anon_sym_descending] = ACTIONS(4099),
    [anon_sym_group] = ACTIONS(4099),
    [anon_sym_by] = ACTIONS(4099),
    [anon_sym_select] = ACTIONS(4099),
    [anon_sym_as] = ACTIONS(4099),
    [anon_sym_is] = ACTIONS(4099),
    [anon_sym_DASH_GT] = ACTIONS(4106),
    [anon_sym_with] = ACTIONS(4099),
    [aux_sym_preproc_if_token3] = ACTIONS(4106),
    [aux_sym_preproc_else_token1] = ACTIONS(4106),
    [aux_sym_preproc_elif_token1] = ACTIONS(4106),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2973] = {
    [sym_preproc_region] = STATE(2973),
    [sym_preproc_endregion] = STATE(2973),
    [sym_preproc_line] = STATE(2973),
    [sym_preproc_pragma] = STATE(2973),
    [sym_preproc_nullable] = STATE(2973),
    [sym_preproc_error] = STATE(2973),
    [sym_preproc_define] = STATE(2973),
    [sym_preproc_undef] = STATE(2973),
    [sym__identifier_token] = ACTIONS(4422),
    [anon_sym_alias] = ACTIONS(4422),
    [anon_sym_SEMI] = ACTIONS(4424),
    [anon_sym_global] = ACTIONS(4422),
    [anon_sym_LBRACK] = ACTIONS(4547),
    [anon_sym_COLON] = ACTIONS(4424),
    [anon_sym_COMMA] = ACTIONS(4424),
    [anon_sym_RBRACK] = ACTIONS(4424),
    [anon_sym_LPAREN] = ACTIONS(4424),
    [anon_sym_RPAREN] = ACTIONS(4424),
    [anon_sym_LBRACE] = ACTIONS(4424),
    [anon_sym_RBRACE] = ACTIONS(4424),
    [anon_sym_file] = ACTIONS(4422),
    [anon_sym_LT] = ACTIONS(4422),
    [anon_sym_GT] = ACTIONS(4422),
    [anon_sym_in] = ACTIONS(4422),
    [anon_sym_where] = ACTIONS(4422),
    [anon_sym_QMARK] = ACTIONS(4550),
    [anon_sym_notnull] = ACTIONS(4422),
    [anon_sym_unmanaged] = ACTIONS(4422),
    [anon_sym_BANG] = ACTIONS(4422),
    [anon_sym_PLUS_PLUS] = ACTIONS(4424),
    [anon_sym_DASH_DASH] = ACTIONS(4424),
    [anon_sym_PLUS] = ACTIONS(4422),
    [anon_sym_DASH] = ACTIONS(4422),
    [anon_sym_STAR] = ACTIONS(4553),
    [anon_sym_SLASH] = ACTIONS(4422),
    [anon_sym_PERCENT] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4424),
    [anon_sym_PIPE] = ACTIONS(4422),
    [anon_sym_AMP] = ACTIONS(4422),
    [anon_sym_LT_LT] = ACTIONS(4424),
    [anon_sym_GT_GT] = ACTIONS(4422),
    [anon_sym_GT_GT_GT] = ACTIONS(4424),
    [anon_sym_EQ_EQ] = ACTIONS(4424),
    [anon_sym_BANG_EQ] = ACTIONS(4424),
    [anon_sym_GT_EQ] = ACTIONS(4424),
    [anon_sym_LT_EQ] = ACTIONS(4424),
    [anon_sym_DOT] = ACTIONS(4422),
    [anon_sym_scoped] = ACTIONS(4422),
    [anon_sym_EQ_GT] = ACTIONS(4424),
    [anon_sym_var] = ACTIONS(4422),
    [anon_sym_yield] = ACTIONS(4422),
    [anon_sym_switch] = ACTIONS(4422),
    [anon_sym_when] = ACTIONS(4422),
    [sym_discard] = ACTIONS(4422),
    [anon_sym_DOT_DOT] = ACTIONS(4424),
    [anon_sym_and] = ACTIONS(4422),
    [anon_sym_or] = ACTIONS(4422),
    [anon_sym_AMP_AMP] = ACTIONS(4424),
    [anon_sym_PIPE_PIPE] = ACTIONS(4424),
    [anon_sym_QMARK_QMARK] = ACTIONS(4424),
    [anon_sym_from] = ACTIONS(4422),
    [anon_sym_into] = ACTIONS(4422),
    [anon_sym_join] = ACTIONS(4422),
    [anon_sym_on] = ACTIONS(4422),
    [anon_sym_equals] = ACTIONS(4422),
    [anon_sym_let] = ACTIONS(4422),
    [anon_sym_orderby] = ACTIONS(4422),
    [anon_sym_ascending] = ACTIONS(4422),
    [anon_sym_descending] = ACTIONS(4422),
    [anon_sym_group] = ACTIONS(4422),
    [anon_sym_by] = ACTIONS(4422),
    [anon_sym_select] = ACTIONS(4422),
    [anon_sym_as] = ACTIONS(4422),
    [anon_sym_is] = ACTIONS(4422),
    [anon_sym_DASH_GT] = ACTIONS(4424),
    [anon_sym_with] = ACTIONS(4422),
    [aux_sym_preproc_if_token3] = ACTIONS(4424),
    [aux_sym_preproc_else_token1] = ACTIONS(4424),
    [aux_sym_preproc_elif_token1] = ACTIONS(4424),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2974] = {
    [sym_preproc_region] = STATE(2974),
    [sym_preproc_endregion] = STATE(2974),
    [sym_preproc_line] = STATE(2974),
    [sym_preproc_pragma] = STATE(2974),
    [sym_preproc_nullable] = STATE(2974),
    [sym_preproc_error] = STATE(2974),
    [sym_preproc_define] = STATE(2974),
    [sym_preproc_undef] = STATE(2974),
    [sym__identifier_token] = ACTIONS(4422),
    [anon_sym_alias] = ACTIONS(4422),
    [anon_sym_SEMI] = ACTIONS(4424),
    [anon_sym_global] = ACTIONS(4422),
    [anon_sym_LBRACK] = ACTIONS(4547),
    [anon_sym_COLON] = ACTIONS(4424),
    [anon_sym_COMMA] = ACTIONS(4424),
    [anon_sym_RBRACK] = ACTIONS(4424),
    [anon_sym_LPAREN] = ACTIONS(4424),
    [anon_sym_RPAREN] = ACTIONS(4424),
    [anon_sym_LBRACE] = ACTIONS(4424),
    [anon_sym_RBRACE] = ACTIONS(4424),
    [anon_sym_file] = ACTIONS(4422),
    [anon_sym_LT] = ACTIONS(4422),
    [anon_sym_GT] = ACTIONS(4422),
    [anon_sym_in] = ACTIONS(4422),
    [anon_sym_where] = ACTIONS(4422),
    [anon_sym_QMARK] = ACTIONS(4422),
    [anon_sym_notnull] = ACTIONS(4422),
    [anon_sym_unmanaged] = ACTIONS(4422),
    [anon_sym_BANG] = ACTIONS(4422),
    [anon_sym_PLUS_PLUS] = ACTIONS(4424),
    [anon_sym_DASH_DASH] = ACTIONS(4424),
    [anon_sym_PLUS] = ACTIONS(4422),
    [anon_sym_DASH] = ACTIONS(4422),
    [anon_sym_STAR] = ACTIONS(4553),
    [anon_sym_SLASH] = ACTIONS(4422),
    [anon_sym_PERCENT] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4424),
    [anon_sym_PIPE] = ACTIONS(4422),
    [anon_sym_AMP] = ACTIONS(4422),
    [anon_sym_LT_LT] = ACTIONS(4424),
    [anon_sym_GT_GT] = ACTIONS(4422),
    [anon_sym_GT_GT_GT] = ACTIONS(4424),
    [anon_sym_EQ_EQ] = ACTIONS(4424),
    [anon_sym_BANG_EQ] = ACTIONS(4424),
    [anon_sym_GT_EQ] = ACTIONS(4424),
    [anon_sym_LT_EQ] = ACTIONS(4424),
    [anon_sym_DOT] = ACTIONS(4422),
    [anon_sym_scoped] = ACTIONS(4422),
    [anon_sym_EQ_GT] = ACTIONS(4424),
    [anon_sym_var] = ACTIONS(4422),
    [anon_sym_yield] = ACTIONS(4422),
    [anon_sym_switch] = ACTIONS(4422),
    [anon_sym_when] = ACTIONS(4422),
    [sym_discard] = ACTIONS(4422),
    [anon_sym_DOT_DOT] = ACTIONS(4424),
    [anon_sym_and] = ACTIONS(4422),
    [anon_sym_or] = ACTIONS(4422),
    [anon_sym_AMP_AMP] = ACTIONS(4424),
    [anon_sym_PIPE_PIPE] = ACTIONS(4424),
    [anon_sym_QMARK_QMARK] = ACTIONS(4424),
    [anon_sym_from] = ACTIONS(4422),
    [anon_sym_into] = ACTIONS(4422),
    [anon_sym_join] = ACTIONS(4422),
    [anon_sym_on] = ACTIONS(4422),
    [anon_sym_equals] = ACTIONS(4422),
    [anon_sym_let] = ACTIONS(4422),
    [anon_sym_orderby] = ACTIONS(4422),
    [anon_sym_ascending] = ACTIONS(4422),
    [anon_sym_descending] = ACTIONS(4422),
    [anon_sym_group] = ACTIONS(4422),
    [anon_sym_by] = ACTIONS(4422),
    [anon_sym_select] = ACTIONS(4422),
    [anon_sym_as] = ACTIONS(4422),
    [anon_sym_is] = ACTIONS(4422),
    [anon_sym_DASH_GT] = ACTIONS(4424),
    [anon_sym_with] = ACTIONS(4422),
    [aux_sym_preproc_if_token3] = ACTIONS(4424),
    [aux_sym_preproc_else_token1] = ACTIONS(4424),
    [aux_sym_preproc_elif_token1] = ACTIONS(4424),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2975] = {
    [sym_preproc_region] = STATE(2975),
    [sym_preproc_endregion] = STATE(2975),
    [sym_preproc_line] = STATE(2975),
    [sym_preproc_pragma] = STATE(2975),
    [sym_preproc_nullable] = STATE(2975),
    [sym_preproc_error] = STATE(2975),
    [sym_preproc_define] = STATE(2975),
    [sym_preproc_undef] = STATE(2975),
    [sym__identifier_token] = ACTIONS(4422),
    [anon_sym_alias] = ACTIONS(4422),
    [anon_sym_SEMI] = ACTIONS(4424),
    [anon_sym_global] = ACTIONS(4422),
    [anon_sym_LBRACK] = ACTIONS(4547),
    [anon_sym_COLON] = ACTIONS(4424),
    [anon_sym_COMMA] = ACTIONS(4424),
    [anon_sym_RBRACK] = ACTIONS(4424),
    [anon_sym_LPAREN] = ACTIONS(4424),
    [anon_sym_RPAREN] = ACTIONS(4424),
    [anon_sym_LBRACE] = ACTIONS(4424),
    [anon_sym_RBRACE] = ACTIONS(4424),
    [anon_sym_file] = ACTIONS(4422),
    [anon_sym_LT] = ACTIONS(4422),
    [anon_sym_GT] = ACTIONS(4422),
    [anon_sym_in] = ACTIONS(4422),
    [anon_sym_where] = ACTIONS(4422),
    [anon_sym_QMARK] = ACTIONS(4550),
    [anon_sym_notnull] = ACTIONS(4422),
    [anon_sym_unmanaged] = ACTIONS(4422),
    [anon_sym_BANG] = ACTIONS(4422),
    [anon_sym_PLUS_PLUS] = ACTIONS(4424),
    [anon_sym_DASH_DASH] = ACTIONS(4424),
    [anon_sym_PLUS] = ACTIONS(4422),
    [anon_sym_DASH] = ACTIONS(4422),
    [anon_sym_STAR] = ACTIONS(4424),
    [anon_sym_SLASH] = ACTIONS(4422),
    [anon_sym_PERCENT] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4424),
    [anon_sym_PIPE] = ACTIONS(4422),
    [anon_sym_AMP] = ACTIONS(4422),
    [anon_sym_LT_LT] = ACTIONS(4424),
    [anon_sym_GT_GT] = ACTIONS(4422),
    [anon_sym_GT_GT_GT] = ACTIONS(4424),
    [anon_sym_EQ_EQ] = ACTIONS(4424),
    [anon_sym_BANG_EQ] = ACTIONS(4424),
    [anon_sym_GT_EQ] = ACTIONS(4424),
    [anon_sym_LT_EQ] = ACTIONS(4424),
    [anon_sym_DOT] = ACTIONS(4422),
    [anon_sym_scoped] = ACTIONS(4422),
    [anon_sym_EQ_GT] = ACTIONS(4424),
    [anon_sym_var] = ACTIONS(4422),
    [anon_sym_yield] = ACTIONS(4422),
    [anon_sym_switch] = ACTIONS(4422),
    [anon_sym_when] = ACTIONS(4422),
    [sym_discard] = ACTIONS(4422),
    [anon_sym_DOT_DOT] = ACTIONS(4424),
    [anon_sym_and] = ACTIONS(4422),
    [anon_sym_or] = ACTIONS(4422),
    [anon_sym_AMP_AMP] = ACTIONS(4424),
    [anon_sym_PIPE_PIPE] = ACTIONS(4424),
    [anon_sym_QMARK_QMARK] = ACTIONS(4424),
    [anon_sym_from] = ACTIONS(4422),
    [anon_sym_into] = ACTIONS(4422),
    [anon_sym_join] = ACTIONS(4422),
    [anon_sym_on] = ACTIONS(4422),
    [anon_sym_equals] = ACTIONS(4422),
    [anon_sym_let] = ACTIONS(4422),
    [anon_sym_orderby] = ACTIONS(4422),
    [anon_sym_ascending] = ACTIONS(4422),
    [anon_sym_descending] = ACTIONS(4422),
    [anon_sym_group] = ACTIONS(4422),
    [anon_sym_by] = ACTIONS(4422),
    [anon_sym_select] = ACTIONS(4422),
    [anon_sym_as] = ACTIONS(4422),
    [anon_sym_is] = ACTIONS(4422),
    [anon_sym_DASH_GT] = ACTIONS(4424),
    [anon_sym_with] = ACTIONS(4422),
    [aux_sym_preproc_if_token3] = ACTIONS(4424),
    [aux_sym_preproc_else_token1] = ACTIONS(4424),
    [aux_sym_preproc_elif_token1] = ACTIONS(4424),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2976] = {
    [sym_preproc_region] = STATE(2976),
    [sym_preproc_endregion] = STATE(2976),
    [sym_preproc_line] = STATE(2976),
    [sym_preproc_pragma] = STATE(2976),
    [sym_preproc_nullable] = STATE(2976),
    [sym_preproc_error] = STATE(2976),
    [sym_preproc_define] = STATE(2976),
    [sym_preproc_undef] = STATE(2976),
    [sym__identifier_token] = ACTIONS(4099),
    [anon_sym_alias] = ACTIONS(4099),
    [anon_sym_global] = ACTIONS(4099),
    [anon_sym_EQ] = ACTIONS(4104),
    [anon_sym_LBRACK] = ACTIONS(4101),
    [anon_sym_LPAREN] = ACTIONS(4101),
    [anon_sym_file] = ACTIONS(4099),
    [anon_sym_LT] = ACTIONS(4104),
    [anon_sym_GT] = ACTIONS(4104),
    [anon_sym_where] = ACTIONS(4108),
    [anon_sym_QMARK] = ACTIONS(4108),
    [anon_sym_notnull] = ACTIONS(4099),
    [anon_sym_unmanaged] = ACTIONS(4099),
    [anon_sym_BANG] = ACTIONS(4104),
    [anon_sym_PLUS_PLUS] = ACTIONS(4111),
    [anon_sym_DASH_DASH] = ACTIONS(4111),
    [anon_sym_PLUS] = ACTIONS(4104),
    [anon_sym_DASH] = ACTIONS(4104),
    [anon_sym_STAR] = ACTIONS(4108),
    [anon_sym_SLASH] = ACTIONS(4104),
    [anon_sym_PERCENT] = ACTIONS(4104),
    [anon_sym_CARET] = ACTIONS(4104),
    [anon_sym_PIPE] = ACTIONS(4104),
    [anon_sym_AMP] = ACTIONS(4104),
    [anon_sym_LT_LT] = ACTIONS(4104),
    [anon_sym_GT_GT] = ACTIONS(4104),
    [anon_sym_GT_GT_GT] = ACTIONS(4104),
    [anon_sym_EQ_EQ] = ACTIONS(4111),
    [anon_sym_BANG_EQ] = ACTIONS(4111),
    [anon_sym_GT_EQ] = ACTIONS(4111),
    [anon_sym_LT_EQ] = ACTIONS(4111),
    [anon_sym_DOT] = ACTIONS(4108),
    [anon_sym_scoped] = ACTIONS(4099),
    [anon_sym_var] = ACTIONS(4099),
    [anon_sym_yield] = ACTIONS(4099),
    [anon_sym_switch] = ACTIONS(4104),
    [anon_sym_when] = ACTIONS(4099),
    [anon_sym_DOT_DOT] = ACTIONS(4111),
    [anon_sym_and] = ACTIONS(4104),
    [anon_sym_or] = ACTIONS(4104),
    [anon_sym_PLUS_EQ] = ACTIONS(4111),
    [anon_sym_DASH_EQ] = ACTIONS(4111),
    [anon_sym_STAR_EQ] = ACTIONS(4111),
    [anon_sym_SLASH_EQ] = ACTIONS(4111),
    [anon_sym_PERCENT_EQ] = ACTIONS(4111),
    [anon_sym_AMP_EQ] = ACTIONS(4111),
    [anon_sym_CARET_EQ] = ACTIONS(4111),
    [anon_sym_PIPE_EQ] = ACTIONS(4111),
    [anon_sym_LT_LT_EQ] = ACTIONS(4111),
    [anon_sym_GT_GT_EQ] = ACTIONS(4111),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4111),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4111),
    [anon_sym_AMP_AMP] = ACTIONS(4111),
    [anon_sym_PIPE_PIPE] = ACTIONS(4111),
    [anon_sym_QMARK_QMARK] = ACTIONS(4104),
    [anon_sym_from] = ACTIONS(4108),
    [anon_sym_into] = ACTIONS(4108),
    [anon_sym_join] = ACTIONS(4108),
    [anon_sym_on] = ACTIONS(4099),
    [anon_sym_equals] = ACTIONS(4099),
    [anon_sym_let] = ACTIONS(4108),
    [anon_sym_orderby] = ACTIONS(4108),
    [anon_sym_ascending] = ACTIONS(4099),
    [anon_sym_descending] = ACTIONS(4099),
    [anon_sym_group] = ACTIONS(4108),
    [anon_sym_by] = ACTIONS(4099),
    [anon_sym_select] = ACTIONS(4108),
    [anon_sym_as] = ACTIONS(4104),
    [anon_sym_is] = ACTIONS(4104),
    [anon_sym_DASH_GT] = ACTIONS(4101),
    [anon_sym_with] = ACTIONS(4104),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2977] = {
    [sym_preproc_region] = STATE(2977),
    [sym_preproc_endregion] = STATE(2977),
    [sym_preproc_line] = STATE(2977),
    [sym_preproc_pragma] = STATE(2977),
    [sym_preproc_nullable] = STATE(2977),
    [sym_preproc_error] = STATE(2977),
    [sym_preproc_define] = STATE(2977),
    [sym_preproc_undef] = STATE(2977),
    [sym__identifier_token] = ACTIONS(4113),
    [anon_sym_alias] = ACTIONS(4113),
    [anon_sym_SEMI] = ACTIONS(4124),
    [anon_sym_global] = ACTIONS(4113),
    [anon_sym_LBRACK] = ACTIONS(4124),
    [anon_sym_COLON] = ACTIONS(4124),
    [anon_sym_COMMA] = ACTIONS(4124),
    [anon_sym_RBRACK] = ACTIONS(4124),
    [anon_sym_LPAREN] = ACTIONS(4124),
    [anon_sym_RPAREN] = ACTIONS(4124),
    [anon_sym_LBRACE] = ACTIONS(4124),
    [anon_sym_RBRACE] = ACTIONS(4124),
    [anon_sym_file] = ACTIONS(4113),
    [anon_sym_LT] = ACTIONS(4113),
    [anon_sym_GT] = ACTIONS(4113),
    [anon_sym_in] = ACTIONS(4113),
    [anon_sym_where] = ACTIONS(4113),
    [anon_sym_QMARK] = ACTIONS(4113),
    [anon_sym_notnull] = ACTIONS(4113),
    [anon_sym_unmanaged] = ACTIONS(4113),
    [anon_sym_BANG] = ACTIONS(4113),
    [anon_sym_PLUS_PLUS] = ACTIONS(4124),
    [anon_sym_DASH_DASH] = ACTIONS(4124),
    [anon_sym_PLUS] = ACTIONS(4113),
    [anon_sym_DASH] = ACTIONS(4113),
    [anon_sym_STAR] = ACTIONS(4124),
    [anon_sym_SLASH] = ACTIONS(4113),
    [anon_sym_PERCENT] = ACTIONS(4124),
    [anon_sym_CARET] = ACTIONS(4124),
    [anon_sym_PIPE] = ACTIONS(4113),
    [anon_sym_AMP] = ACTIONS(4113),
    [anon_sym_LT_LT] = ACTIONS(4124),
    [anon_sym_GT_GT] = ACTIONS(4113),
    [anon_sym_GT_GT_GT] = ACTIONS(4124),
    [anon_sym_EQ_EQ] = ACTIONS(4124),
    [anon_sym_BANG_EQ] = ACTIONS(4124),
    [anon_sym_GT_EQ] = ACTIONS(4124),
    [anon_sym_LT_EQ] = ACTIONS(4124),
    [anon_sym_DOT] = ACTIONS(4113),
    [anon_sym_scoped] = ACTIONS(4113),
    [anon_sym_EQ_GT] = ACTIONS(4124),
    [anon_sym_var] = ACTIONS(4113),
    [anon_sym_yield] = ACTIONS(4113),
    [anon_sym_switch] = ACTIONS(4113),
    [anon_sym_when] = ACTIONS(4113),
    [sym_discard] = ACTIONS(4113),
    [anon_sym_DOT_DOT] = ACTIONS(4124),
    [anon_sym_and] = ACTIONS(4113),
    [anon_sym_or] = ACTIONS(4113),
    [anon_sym_AMP_AMP] = ACTIONS(4124),
    [anon_sym_PIPE_PIPE] = ACTIONS(4124),
    [anon_sym_QMARK_QMARK] = ACTIONS(4124),
    [anon_sym_from] = ACTIONS(4113),
    [anon_sym_into] = ACTIONS(4113),
    [anon_sym_join] = ACTIONS(4113),
    [anon_sym_on] = ACTIONS(4113),
    [anon_sym_equals] = ACTIONS(4113),
    [anon_sym_let] = ACTIONS(4113),
    [anon_sym_orderby] = ACTIONS(4113),
    [anon_sym_ascending] = ACTIONS(4113),
    [anon_sym_descending] = ACTIONS(4113),
    [anon_sym_group] = ACTIONS(4113),
    [anon_sym_by] = ACTIONS(4113),
    [anon_sym_select] = ACTIONS(4113),
    [anon_sym_as] = ACTIONS(4113),
    [anon_sym_is] = ACTIONS(4113),
    [anon_sym_DASH_GT] = ACTIONS(4124),
    [anon_sym_with] = ACTIONS(4113),
    [aux_sym_preproc_if_token3] = ACTIONS(4124),
    [aux_sym_preproc_else_token1] = ACTIONS(4124),
    [aux_sym_preproc_elif_token1] = ACTIONS(4124),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2978] = {
    [sym__name] = STATE(3926),
    [sym_alias_qualified_name] = STATE(3912),
    [sym__simple_name] = STATE(3912),
    [sym_qualified_name] = STATE(3912),
    [sym_generic_name] = STATE(3874),
    [sym_ref_type] = STATE(3927),
    [sym__scoped_base_type] = STATE(3930),
    [sym_identifier] = STATE(3787),
    [sym__reserved_identifier] = STATE(3838),
    [sym_preproc_region] = STATE(2978),
    [sym_preproc_endregion] = STATE(2978),
    [sym_preproc_line] = STATE(2978),
    [sym_preproc_pragma] = STATE(2978),
    [sym_preproc_nullable] = STATE(2978),
    [sym_preproc_error] = STATE(2978),
    [sym_preproc_define] = STATE(2978),
    [sym_preproc_undef] = STATE(2978),
    [sym__identifier_token] = ACTIONS(4157),
    [anon_sym_alias] = ACTIONS(4159),
    [anon_sym_global] = ACTIONS(4159),
    [anon_sym_LBRACK] = ACTIONS(3719),
    [anon_sym_LPAREN] = ACTIONS(3719),
    [anon_sym_ref] = ACTIONS(4572),
    [anon_sym_LBRACE] = ACTIONS(3719),
    [anon_sym_file] = ACTIONS(4159),
    [anon_sym_LT] = ACTIONS(3721),
    [anon_sym_GT] = ACTIONS(3721),
    [anon_sym_where] = ACTIONS(4159),
    [anon_sym_QMARK] = ACTIONS(3721),
    [anon_sym_notnull] = ACTIONS(4159),
    [anon_sym_unmanaged] = ACTIONS(4159),
    [anon_sym_BANG] = ACTIONS(3721),
    [anon_sym_PLUS_PLUS] = ACTIONS(3719),
    [anon_sym_DASH_DASH] = ACTIONS(3719),
    [anon_sym_PLUS] = ACTIONS(3721),
    [anon_sym_DASH] = ACTIONS(3721),
    [anon_sym_STAR] = ACTIONS(3719),
    [anon_sym_SLASH] = ACTIONS(3721),
    [anon_sym_PERCENT] = ACTIONS(3719),
    [anon_sym_CARET] = ACTIONS(3719),
    [anon_sym_PIPE] = ACTIONS(3721),
    [anon_sym_AMP] = ACTIONS(3721),
    [anon_sym_LT_LT] = ACTIONS(3719),
    [anon_sym_GT_GT] = ACTIONS(3721),
    [anon_sym_GT_GT_GT] = ACTIONS(3719),
    [anon_sym_EQ_EQ] = ACTIONS(3719),
    [anon_sym_BANG_EQ] = ACTIONS(3719),
    [anon_sym_GT_EQ] = ACTIONS(3719),
    [anon_sym_LT_EQ] = ACTIONS(3719),
    [anon_sym_DOT] = ACTIONS(3721),
    [anon_sym_scoped] = ACTIONS(4159),
    [anon_sym_COLON_COLON] = ACTIONS(3719),
    [anon_sym_var] = ACTIONS(4159),
    [anon_sym_yield] = ACTIONS(4159),
    [anon_sym_switch] = ACTIONS(3721),
    [anon_sym_when] = ACTIONS(4159),
    [anon_sym_DOT_DOT] = ACTIONS(3719),
    [anon_sym_and] = ACTIONS(3721),
    [anon_sym_or] = ACTIONS(3721),
    [anon_sym_AMP_AMP] = ACTIONS(3719),
    [anon_sym_PIPE_PIPE] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK] = ACTIONS(3719),
    [anon_sym_from] = ACTIONS(4159),
    [anon_sym_into] = ACTIONS(4163),
    [anon_sym_join] = ACTIONS(4159),
    [anon_sym_on] = ACTIONS(4163),
    [anon_sym_equals] = ACTIONS(4159),
    [anon_sym_let] = ACTIONS(4159),
    [anon_sym_orderby] = ACTIONS(4159),
    [anon_sym_ascending] = ACTIONS(4159),
    [anon_sym_descending] = ACTIONS(4159),
    [anon_sym_group] = ACTIONS(4159),
    [anon_sym_by] = ACTIONS(4159),
    [anon_sym_select] = ACTIONS(4159),
    [anon_sym_as] = ACTIONS(3721),
    [anon_sym_is] = ACTIONS(3721),
    [anon_sym_DASH_GT] = ACTIONS(3719),
    [anon_sym_with] = ACTIONS(3721),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2979] = {
    [sym_preproc_region] = STATE(2979),
    [sym_preproc_endregion] = STATE(2979),
    [sym_preproc_line] = STATE(2979),
    [sym_preproc_pragma] = STATE(2979),
    [sym_preproc_nullable] = STATE(2979),
    [sym_preproc_error] = STATE(2979),
    [sym_preproc_define] = STATE(2979),
    [sym_preproc_undef] = STATE(2979),
    [anon_sym_SEMI] = ACTIONS(4068),
    [anon_sym_EQ] = ACTIONS(4066),
    [anon_sym_LBRACK] = ACTIONS(4068),
    [anon_sym_COLON] = ACTIONS(4068),
    [anon_sym_COMMA] = ACTIONS(4068),
    [anon_sym_RBRACK] = ACTIONS(4068),
    [anon_sym_LPAREN] = ACTIONS(4068),
    [anon_sym_RPAREN] = ACTIONS(4068),
    [anon_sym_RBRACE] = ACTIONS(4068),
    [anon_sym_LT] = ACTIONS(4066),
    [anon_sym_GT] = ACTIONS(4066),
    [anon_sym_in] = ACTIONS(4066),
    [anon_sym_where] = ACTIONS(4068),
    [anon_sym_QMARK] = ACTIONS(4066),
    [anon_sym_BANG] = ACTIONS(4066),
    [anon_sym_PLUS_PLUS] = ACTIONS(4068),
    [anon_sym_DASH_DASH] = ACTIONS(4068),
    [anon_sym_PLUS] = ACTIONS(4066),
    [anon_sym_DASH] = ACTIONS(4066),
    [anon_sym_STAR] = ACTIONS(4066),
    [anon_sym_SLASH] = ACTIONS(4066),
    [anon_sym_PERCENT] = ACTIONS(4066),
    [anon_sym_CARET] = ACTIONS(4066),
    [anon_sym_PIPE] = ACTIONS(4066),
    [anon_sym_AMP] = ACTIONS(4066),
    [anon_sym_LT_LT] = ACTIONS(4066),
    [anon_sym_GT_GT] = ACTIONS(4066),
    [anon_sym_GT_GT_GT] = ACTIONS(4066),
    [anon_sym_EQ_EQ] = ACTIONS(4068),
    [anon_sym_BANG_EQ] = ACTIONS(4068),
    [anon_sym_GT_EQ] = ACTIONS(4068),
    [anon_sym_LT_EQ] = ACTIONS(4068),
    [anon_sym_DOT] = ACTIONS(4066),
    [anon_sym_EQ_GT] = ACTIONS(4068),
    [anon_sym_switch] = ACTIONS(4068),
    [anon_sym_DOT_DOT] = ACTIONS(4068),
    [anon_sym_and] = ACTIONS(4068),
    [anon_sym_or] = ACTIONS(4066),
    [anon_sym_PLUS_EQ] = ACTIONS(4068),
    [anon_sym_DASH_EQ] = ACTIONS(4068),
    [anon_sym_STAR_EQ] = ACTIONS(4068),
    [anon_sym_SLASH_EQ] = ACTIONS(4068),
    [anon_sym_PERCENT_EQ] = ACTIONS(4068),
    [anon_sym_AMP_EQ] = ACTIONS(4068),
    [anon_sym_CARET_EQ] = ACTIONS(4068),
    [anon_sym_PIPE_EQ] = ACTIONS(4068),
    [anon_sym_LT_LT_EQ] = ACTIONS(4068),
    [anon_sym_GT_GT_EQ] = ACTIONS(4068),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4068),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4068),
    [anon_sym_AMP_AMP] = ACTIONS(4068),
    [anon_sym_PIPE_PIPE] = ACTIONS(4068),
    [anon_sym_QMARK_QMARK] = ACTIONS(4066),
    [anon_sym_from] = ACTIONS(4068),
    [anon_sym_into] = ACTIONS(4068),
    [anon_sym_join] = ACTIONS(4068),
    [anon_sym_on] = ACTIONS(4068),
    [anon_sym_equals] = ACTIONS(4068),
    [anon_sym_let] = ACTIONS(4068),
    [anon_sym_orderby] = ACTIONS(4068),
    [anon_sym_group] = ACTIONS(4068),
    [anon_sym_by] = ACTIONS(4068),
    [anon_sym_select] = ACTIONS(4068),
    [anon_sym_as] = ACTIONS(4068),
    [anon_sym_is] = ACTIONS(4068),
    [anon_sym_DASH_GT] = ACTIONS(4068),
    [anon_sym_with] = ACTIONS(4068),
    [aux_sym_preproc_if_token3] = ACTIONS(4068),
    [aux_sym_preproc_else_token1] = ACTIONS(4068),
    [aux_sym_preproc_elif_token1] = ACTIONS(4068),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2980] = {
    [sym_preproc_region] = STATE(2980),
    [sym_preproc_endregion] = STATE(2980),
    [sym_preproc_line] = STATE(2980),
    [sym_preproc_pragma] = STATE(2980),
    [sym_preproc_nullable] = STATE(2980),
    [sym_preproc_error] = STATE(2980),
    [sym_preproc_define] = STATE(2980),
    [sym_preproc_undef] = STATE(2980),
    [anon_sym_SEMI] = ACTIONS(4111),
    [anon_sym_EQ] = ACTIONS(4104),
    [anon_sym_LBRACK] = ACTIONS(4111),
    [anon_sym_COLON] = ACTIONS(4111),
    [anon_sym_COMMA] = ACTIONS(4111),
    [anon_sym_RBRACK] = ACTIONS(4111),
    [anon_sym_LPAREN] = ACTIONS(4111),
    [anon_sym_RPAREN] = ACTIONS(4111),
    [anon_sym_RBRACE] = ACTIONS(4111),
    [anon_sym_LT] = ACTIONS(4104),
    [anon_sym_GT] = ACTIONS(4104),
    [anon_sym_in] = ACTIONS(4104),
    [anon_sym_where] = ACTIONS(4111),
    [anon_sym_QMARK] = ACTIONS(4104),
    [anon_sym_BANG] = ACTIONS(4104),
    [anon_sym_PLUS_PLUS] = ACTIONS(4111),
    [anon_sym_DASH_DASH] = ACTIONS(4111),
    [anon_sym_PLUS] = ACTIONS(4104),
    [anon_sym_DASH] = ACTIONS(4104),
    [anon_sym_STAR] = ACTIONS(4104),
    [anon_sym_SLASH] = ACTIONS(4104),
    [anon_sym_PERCENT] = ACTIONS(4104),
    [anon_sym_CARET] = ACTIONS(4104),
    [anon_sym_PIPE] = ACTIONS(4104),
    [anon_sym_AMP] = ACTIONS(4104),
    [anon_sym_LT_LT] = ACTIONS(4104),
    [anon_sym_GT_GT] = ACTIONS(4104),
    [anon_sym_GT_GT_GT] = ACTIONS(4104),
    [anon_sym_EQ_EQ] = ACTIONS(4111),
    [anon_sym_BANG_EQ] = ACTIONS(4111),
    [anon_sym_GT_EQ] = ACTIONS(4111),
    [anon_sym_LT_EQ] = ACTIONS(4111),
    [anon_sym_DOT] = ACTIONS(4104),
    [anon_sym_EQ_GT] = ACTIONS(4111),
    [anon_sym_switch] = ACTIONS(4111),
    [anon_sym_DOT_DOT] = ACTIONS(4111),
    [anon_sym_and] = ACTIONS(4111),
    [anon_sym_or] = ACTIONS(4104),
    [anon_sym_PLUS_EQ] = ACTIONS(4111),
    [anon_sym_DASH_EQ] = ACTIONS(4111),
    [anon_sym_STAR_EQ] = ACTIONS(4111),
    [anon_sym_SLASH_EQ] = ACTIONS(4111),
    [anon_sym_PERCENT_EQ] = ACTIONS(4111),
    [anon_sym_AMP_EQ] = ACTIONS(4111),
    [anon_sym_CARET_EQ] = ACTIONS(4111),
    [anon_sym_PIPE_EQ] = ACTIONS(4111),
    [anon_sym_LT_LT_EQ] = ACTIONS(4111),
    [anon_sym_GT_GT_EQ] = ACTIONS(4111),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4111),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4111),
    [anon_sym_AMP_AMP] = ACTIONS(4111),
    [anon_sym_PIPE_PIPE] = ACTIONS(4111),
    [anon_sym_QMARK_QMARK] = ACTIONS(4104),
    [anon_sym_from] = ACTIONS(4111),
    [anon_sym_into] = ACTIONS(4111),
    [anon_sym_join] = ACTIONS(4111),
    [anon_sym_on] = ACTIONS(4111),
    [anon_sym_equals] = ACTIONS(4111),
    [anon_sym_let] = ACTIONS(4111),
    [anon_sym_orderby] = ACTIONS(4111),
    [anon_sym_group] = ACTIONS(4111),
    [anon_sym_by] = ACTIONS(4111),
    [anon_sym_select] = ACTIONS(4111),
    [anon_sym_as] = ACTIONS(4111),
    [anon_sym_is] = ACTIONS(4111),
    [anon_sym_DASH_GT] = ACTIONS(4111),
    [anon_sym_with] = ACTIONS(4111),
    [aux_sym_preproc_if_token3] = ACTIONS(4111),
    [aux_sym_preproc_else_token1] = ACTIONS(4111),
    [aux_sym_preproc_elif_token1] = ACTIONS(4111),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2981] = {
    [sym__name] = STATE(3926),
    [sym_alias_qualified_name] = STATE(3912),
    [sym__simple_name] = STATE(3912),
    [sym_qualified_name] = STATE(3912),
    [sym_generic_name] = STATE(3874),
    [sym_ref_type] = STATE(3927),
    [sym__scoped_base_type] = STATE(3930),
    [sym_identifier] = STATE(3787),
    [sym__reserved_identifier] = STATE(3838),
    [sym_preproc_region] = STATE(2981),
    [sym_preproc_endregion] = STATE(2981),
    [sym_preproc_line] = STATE(2981),
    [sym_preproc_pragma] = STATE(2981),
    [sym_preproc_nullable] = STATE(2981),
    [sym_preproc_error] = STATE(2981),
    [sym_preproc_define] = STATE(2981),
    [sym_preproc_undef] = STATE(2981),
    [sym__identifier_token] = ACTIONS(4157),
    [anon_sym_alias] = ACTIONS(4159),
    [anon_sym_global] = ACTIONS(4159),
    [anon_sym_LBRACK] = ACTIONS(3719),
    [anon_sym_LPAREN] = ACTIONS(3719),
    [anon_sym_ref] = ACTIONS(4574),
    [anon_sym_LBRACE] = ACTIONS(3719),
    [anon_sym_file] = ACTIONS(4159),
    [anon_sym_LT] = ACTIONS(3721),
    [anon_sym_GT] = ACTIONS(3721),
    [anon_sym_where] = ACTIONS(4159),
    [anon_sym_QMARK] = ACTIONS(3721),
    [anon_sym_notnull] = ACTIONS(4159),
    [anon_sym_unmanaged] = ACTIONS(4159),
    [anon_sym_BANG] = ACTIONS(3721),
    [anon_sym_PLUS_PLUS] = ACTIONS(3719),
    [anon_sym_DASH_DASH] = ACTIONS(3719),
    [anon_sym_PLUS] = ACTIONS(3721),
    [anon_sym_DASH] = ACTIONS(3721),
    [anon_sym_STAR] = ACTIONS(3719),
    [anon_sym_SLASH] = ACTIONS(3721),
    [anon_sym_PERCENT] = ACTIONS(3719),
    [anon_sym_CARET] = ACTIONS(3719),
    [anon_sym_PIPE] = ACTIONS(3721),
    [anon_sym_AMP] = ACTIONS(3721),
    [anon_sym_LT_LT] = ACTIONS(3719),
    [anon_sym_GT_GT] = ACTIONS(3721),
    [anon_sym_GT_GT_GT] = ACTIONS(3719),
    [anon_sym_EQ_EQ] = ACTIONS(3719),
    [anon_sym_BANG_EQ] = ACTIONS(3719),
    [anon_sym_GT_EQ] = ACTIONS(3719),
    [anon_sym_LT_EQ] = ACTIONS(3719),
    [anon_sym_DOT] = ACTIONS(3721),
    [anon_sym_scoped] = ACTIONS(4159),
    [anon_sym_COLON_COLON] = ACTIONS(3719),
    [anon_sym_var] = ACTIONS(4159),
    [anon_sym_yield] = ACTIONS(4159),
    [anon_sym_switch] = ACTIONS(3721),
    [anon_sym_when] = ACTIONS(4159),
    [anon_sym_DOT_DOT] = ACTIONS(3719),
    [anon_sym_and] = ACTIONS(3721),
    [anon_sym_or] = ACTIONS(3721),
    [anon_sym_AMP_AMP] = ACTIONS(3719),
    [anon_sym_PIPE_PIPE] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK] = ACTIONS(3719),
    [anon_sym_from] = ACTIONS(4159),
    [anon_sym_into] = ACTIONS(4163),
    [anon_sym_join] = ACTIONS(4159),
    [anon_sym_on] = ACTIONS(4159),
    [anon_sym_equals] = ACTIONS(4163),
    [anon_sym_let] = ACTIONS(4159),
    [anon_sym_orderby] = ACTIONS(4159),
    [anon_sym_ascending] = ACTIONS(4159),
    [anon_sym_descending] = ACTIONS(4159),
    [anon_sym_group] = ACTIONS(4159),
    [anon_sym_by] = ACTIONS(4159),
    [anon_sym_select] = ACTIONS(4159),
    [anon_sym_as] = ACTIONS(3721),
    [anon_sym_is] = ACTIONS(3721),
    [anon_sym_DASH_GT] = ACTIONS(3719),
    [anon_sym_with] = ACTIONS(3721),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2982] = {
    [sym_preproc_region] = STATE(2982),
    [sym_preproc_endregion] = STATE(2982),
    [sym_preproc_line] = STATE(2982),
    [sym_preproc_pragma] = STATE(2982),
    [sym_preproc_nullable] = STATE(2982),
    [sym_preproc_error] = STATE(2982),
    [sym_preproc_define] = STATE(2982),
    [sym_preproc_undef] = STATE(2982),
    [anon_sym_SEMI] = ACTIONS(4076),
    [anon_sym_EQ] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4076),
    [anon_sym_COLON] = ACTIONS(4076),
    [anon_sym_COMMA] = ACTIONS(4076),
    [anon_sym_RBRACK] = ACTIONS(4076),
    [anon_sym_LPAREN] = ACTIONS(4076),
    [anon_sym_RPAREN] = ACTIONS(4076),
    [anon_sym_RBRACE] = ACTIONS(4076),
    [anon_sym_LT] = ACTIONS(4074),
    [anon_sym_GT] = ACTIONS(4074),
    [anon_sym_in] = ACTIONS(4074),
    [anon_sym_where] = ACTIONS(4076),
    [anon_sym_QMARK] = ACTIONS(4074),
    [anon_sym_BANG] = ACTIONS(4074),
    [anon_sym_PLUS_PLUS] = ACTIONS(4076),
    [anon_sym_DASH_DASH] = ACTIONS(4076),
    [anon_sym_PLUS] = ACTIONS(4074),
    [anon_sym_DASH] = ACTIONS(4074),
    [anon_sym_STAR] = ACTIONS(4074),
    [anon_sym_SLASH] = ACTIONS(4074),
    [anon_sym_PERCENT] = ACTIONS(4074),
    [anon_sym_CARET] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(4074),
    [anon_sym_AMP] = ACTIONS(4074),
    [anon_sym_LT_LT] = ACTIONS(4074),
    [anon_sym_GT_GT] = ACTIONS(4074),
    [anon_sym_GT_GT_GT] = ACTIONS(4074),
    [anon_sym_EQ_EQ] = ACTIONS(4076),
    [anon_sym_BANG_EQ] = ACTIONS(4076),
    [anon_sym_GT_EQ] = ACTIONS(4076),
    [anon_sym_LT_EQ] = ACTIONS(4076),
    [anon_sym_DOT] = ACTIONS(4074),
    [anon_sym_EQ_GT] = ACTIONS(4076),
    [anon_sym_switch] = ACTIONS(4076),
    [anon_sym_DOT_DOT] = ACTIONS(4076),
    [anon_sym_and] = ACTIONS(4076),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_PLUS_EQ] = ACTIONS(4076),
    [anon_sym_DASH_EQ] = ACTIONS(4076),
    [anon_sym_STAR_EQ] = ACTIONS(4076),
    [anon_sym_SLASH_EQ] = ACTIONS(4076),
    [anon_sym_PERCENT_EQ] = ACTIONS(4076),
    [anon_sym_AMP_EQ] = ACTIONS(4076),
    [anon_sym_CARET_EQ] = ACTIONS(4076),
    [anon_sym_PIPE_EQ] = ACTIONS(4076),
    [anon_sym_LT_LT_EQ] = ACTIONS(4076),
    [anon_sym_GT_GT_EQ] = ACTIONS(4076),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4076),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4076),
    [anon_sym_AMP_AMP] = ACTIONS(4076),
    [anon_sym_PIPE_PIPE] = ACTIONS(4076),
    [anon_sym_QMARK_QMARK] = ACTIONS(4074),
    [anon_sym_from] = ACTIONS(4076),
    [anon_sym_into] = ACTIONS(4076),
    [anon_sym_join] = ACTIONS(4076),
    [anon_sym_on] = ACTIONS(4076),
    [anon_sym_equals] = ACTIONS(4076),
    [anon_sym_let] = ACTIONS(4076),
    [anon_sym_orderby] = ACTIONS(4076),
    [anon_sym_group] = ACTIONS(4076),
    [anon_sym_by] = ACTIONS(4076),
    [anon_sym_select] = ACTIONS(4076),
    [anon_sym_as] = ACTIONS(4076),
    [anon_sym_is] = ACTIONS(4076),
    [anon_sym_DASH_GT] = ACTIONS(4076),
    [anon_sym_with] = ACTIONS(4076),
    [aux_sym_preproc_if_token3] = ACTIONS(4076),
    [aux_sym_preproc_else_token1] = ACTIONS(4076),
    [aux_sym_preproc_elif_token1] = ACTIONS(4076),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2983] = {
    [sym_preproc_region] = STATE(2983),
    [sym_preproc_endregion] = STATE(2983),
    [sym_preproc_line] = STATE(2983),
    [sym_preproc_pragma] = STATE(2983),
    [sym_preproc_nullable] = STATE(2983),
    [sym_preproc_error] = STATE(2983),
    [sym_preproc_define] = STATE(2983),
    [sym_preproc_undef] = STATE(2983),
    [sym__identifier_token] = ACTIONS(4576),
    [anon_sym_alias] = ACTIONS(4576),
    [anon_sym_SEMI] = ACTIONS(4578),
    [anon_sym_global] = ACTIONS(4576),
    [anon_sym_LBRACK] = ACTIONS(4578),
    [anon_sym_COLON] = ACTIONS(4578),
    [anon_sym_COMMA] = ACTIONS(4578),
    [anon_sym_RBRACK] = ACTIONS(4578),
    [anon_sym_LPAREN] = ACTIONS(4578),
    [anon_sym_RPAREN] = ACTIONS(4578),
    [anon_sym_RBRACE] = ACTIONS(4578),
    [anon_sym_file] = ACTIONS(4576),
    [anon_sym_LT] = ACTIONS(4576),
    [anon_sym_GT] = ACTIONS(4576),
    [anon_sym_in] = ACTIONS(4576),
    [anon_sym_where] = ACTIONS(4576),
    [anon_sym_QMARK] = ACTIONS(4576),
    [anon_sym_notnull] = ACTIONS(4576),
    [anon_sym_unmanaged] = ACTIONS(4576),
    [anon_sym_BANG] = ACTIONS(4576),
    [anon_sym_PLUS_PLUS] = ACTIONS(4578),
    [anon_sym_DASH_DASH] = ACTIONS(4578),
    [anon_sym_PLUS] = ACTIONS(4576),
    [anon_sym_DASH] = ACTIONS(4576),
    [anon_sym_STAR] = ACTIONS(4578),
    [anon_sym_SLASH] = ACTIONS(4576),
    [anon_sym_PERCENT] = ACTIONS(4578),
    [anon_sym_CARET] = ACTIONS(4578),
    [anon_sym_PIPE] = ACTIONS(4576),
    [anon_sym_AMP] = ACTIONS(4576),
    [anon_sym_LT_LT] = ACTIONS(4578),
    [anon_sym_GT_GT] = ACTIONS(4576),
    [anon_sym_GT_GT_GT] = ACTIONS(4578),
    [anon_sym_EQ_EQ] = ACTIONS(4578),
    [anon_sym_BANG_EQ] = ACTIONS(4578),
    [anon_sym_GT_EQ] = ACTIONS(4578),
    [anon_sym_LT_EQ] = ACTIONS(4578),
    [anon_sym_DOT] = ACTIONS(4576),
    [anon_sym_scoped] = ACTIONS(4576),
    [anon_sym_EQ_GT] = ACTIONS(4578),
    [anon_sym_var] = ACTIONS(4576),
    [anon_sym_yield] = ACTIONS(4576),
    [anon_sym_switch] = ACTIONS(4576),
    [anon_sym_when] = ACTIONS(4576),
    [sym_discard] = ACTIONS(4576),
    [anon_sym_DOT_DOT] = ACTIONS(4578),
    [anon_sym_and] = ACTIONS(4576),
    [anon_sym_or] = ACTIONS(4576),
    [anon_sym_AMP_AMP] = ACTIONS(4578),
    [anon_sym_PIPE_PIPE] = ACTIONS(4578),
    [anon_sym_QMARK_QMARK] = ACTIONS(4578),
    [anon_sym_from] = ACTIONS(4576),
    [anon_sym_into] = ACTIONS(4576),
    [anon_sym_join] = ACTIONS(4576),
    [anon_sym_on] = ACTIONS(4576),
    [anon_sym_equals] = ACTIONS(4576),
    [anon_sym_let] = ACTIONS(4576),
    [anon_sym_orderby] = ACTIONS(4576),
    [anon_sym_ascending] = ACTIONS(4576),
    [anon_sym_descending] = ACTIONS(4576),
    [anon_sym_group] = ACTIONS(4576),
    [anon_sym_by] = ACTIONS(4576),
    [anon_sym_select] = ACTIONS(4576),
    [anon_sym_as] = ACTIONS(4576),
    [anon_sym_is] = ACTIONS(4576),
    [anon_sym_DASH_GT] = ACTIONS(4578),
    [anon_sym_with] = ACTIONS(4576),
    [aux_sym_preproc_if_token3] = ACTIONS(4578),
    [aux_sym_preproc_else_token1] = ACTIONS(4578),
    [aux_sym_preproc_elif_token1] = ACTIONS(4578),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2984] = {
    [sym_preproc_region] = STATE(2984),
    [sym_preproc_endregion] = STATE(2984),
    [sym_preproc_line] = STATE(2984),
    [sym_preproc_pragma] = STATE(2984),
    [sym_preproc_nullable] = STATE(2984),
    [sym_preproc_error] = STATE(2984),
    [sym_preproc_define] = STATE(2984),
    [sym_preproc_undef] = STATE(2984),
    [sym__identifier_token] = ACTIONS(4580),
    [anon_sym_alias] = ACTIONS(4580),
    [anon_sym_SEMI] = ACTIONS(4582),
    [anon_sym_global] = ACTIONS(4580),
    [anon_sym_LBRACK] = ACTIONS(4582),
    [anon_sym_COLON] = ACTIONS(4582),
    [anon_sym_COMMA] = ACTIONS(4582),
    [anon_sym_RBRACK] = ACTIONS(4582),
    [anon_sym_LPAREN] = ACTIONS(4582),
    [anon_sym_RPAREN] = ACTIONS(4582),
    [anon_sym_RBRACE] = ACTIONS(4582),
    [anon_sym_file] = ACTIONS(4580),
    [anon_sym_LT] = ACTIONS(4580),
    [anon_sym_GT] = ACTIONS(4580),
    [anon_sym_in] = ACTIONS(4580),
    [anon_sym_where] = ACTIONS(4580),
    [anon_sym_QMARK] = ACTIONS(4580),
    [anon_sym_notnull] = ACTIONS(4580),
    [anon_sym_unmanaged] = ACTIONS(4580),
    [anon_sym_BANG] = ACTIONS(4580),
    [anon_sym_PLUS_PLUS] = ACTIONS(4582),
    [anon_sym_DASH_DASH] = ACTIONS(4582),
    [anon_sym_PLUS] = ACTIONS(4580),
    [anon_sym_DASH] = ACTIONS(4580),
    [anon_sym_STAR] = ACTIONS(4582),
    [anon_sym_SLASH] = ACTIONS(4580),
    [anon_sym_PERCENT] = ACTIONS(4582),
    [anon_sym_CARET] = ACTIONS(4582),
    [anon_sym_PIPE] = ACTIONS(4580),
    [anon_sym_AMP] = ACTIONS(4580),
    [anon_sym_LT_LT] = ACTIONS(4582),
    [anon_sym_GT_GT] = ACTIONS(4580),
    [anon_sym_GT_GT_GT] = ACTIONS(4582),
    [anon_sym_EQ_EQ] = ACTIONS(4582),
    [anon_sym_BANG_EQ] = ACTIONS(4582),
    [anon_sym_GT_EQ] = ACTIONS(4582),
    [anon_sym_LT_EQ] = ACTIONS(4582),
    [anon_sym_DOT] = ACTIONS(4580),
    [anon_sym_scoped] = ACTIONS(4580),
    [anon_sym_EQ_GT] = ACTIONS(4582),
    [anon_sym_var] = ACTIONS(4580),
    [anon_sym_yield] = ACTIONS(4580),
    [anon_sym_switch] = ACTIONS(4580),
    [anon_sym_when] = ACTIONS(4580),
    [sym_discard] = ACTIONS(4580),
    [anon_sym_DOT_DOT] = ACTIONS(4582),
    [anon_sym_and] = ACTIONS(4580),
    [anon_sym_or] = ACTIONS(4580),
    [anon_sym_AMP_AMP] = ACTIONS(4582),
    [anon_sym_PIPE_PIPE] = ACTIONS(4582),
    [anon_sym_QMARK_QMARK] = ACTIONS(4582),
    [anon_sym_from] = ACTIONS(4580),
    [anon_sym_into] = ACTIONS(4580),
    [anon_sym_join] = ACTIONS(4580),
    [anon_sym_on] = ACTIONS(4580),
    [anon_sym_equals] = ACTIONS(4580),
    [anon_sym_let] = ACTIONS(4580),
    [anon_sym_orderby] = ACTIONS(4580),
    [anon_sym_ascending] = ACTIONS(4580),
    [anon_sym_descending] = ACTIONS(4580),
    [anon_sym_group] = ACTIONS(4580),
    [anon_sym_by] = ACTIONS(4580),
    [anon_sym_select] = ACTIONS(4580),
    [anon_sym_as] = ACTIONS(4580),
    [anon_sym_is] = ACTIONS(4580),
    [anon_sym_DASH_GT] = ACTIONS(4582),
    [anon_sym_with] = ACTIONS(4580),
    [aux_sym_preproc_if_token3] = ACTIONS(4582),
    [aux_sym_preproc_else_token1] = ACTIONS(4582),
    [aux_sym_preproc_elif_token1] = ACTIONS(4582),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2985] = {
    [sym__name] = STATE(4949),
    [sym_alias_qualified_name] = STATE(3592),
    [sym__simple_name] = STATE(3592),
    [sym_qualified_name] = STATE(3592),
    [sym_generic_name] = STATE(3608),
    [sym_ref_type] = STATE(3574),
    [sym__scoped_base_type] = STATE(3573),
    [sym_identifier] = STATE(4643),
    [sym__reserved_identifier] = STATE(3558),
    [sym_preproc_region] = STATE(2985),
    [sym_preproc_endregion] = STATE(2985),
    [sym_preproc_line] = STATE(2985),
    [sym_preproc_pragma] = STATE(2985),
    [sym_preproc_nullable] = STATE(2985),
    [sym_preproc_error] = STATE(2985),
    [sym_preproc_define] = STATE(2985),
    [sym_preproc_undef] = STATE(2985),
    [sym__identifier_token] = ACTIONS(4225),
    [anon_sym_alias] = ACTIONS(4227),
    [anon_sym_global] = ACTIONS(4227),
    [anon_sym_LBRACK] = ACTIONS(3719),
    [anon_sym_LPAREN] = ACTIONS(3719),
    [anon_sym_ref] = ACTIONS(4584),
    [anon_sym_LBRACE] = ACTIONS(3719),
    [anon_sym_file] = ACTIONS(4227),
    [anon_sym_LT] = ACTIONS(3721),
    [anon_sym_GT] = ACTIONS(3721),
    [anon_sym_where] = ACTIONS(4231),
    [anon_sym_QMARK] = ACTIONS(3721),
    [anon_sym_notnull] = ACTIONS(4227),
    [anon_sym_unmanaged] = ACTIONS(4227),
    [anon_sym_BANG] = ACTIONS(3721),
    [anon_sym_PLUS_PLUS] = ACTIONS(3719),
    [anon_sym_DASH_DASH] = ACTIONS(3719),
    [anon_sym_PLUS] = ACTIONS(3721),
    [anon_sym_DASH] = ACTIONS(3721),
    [anon_sym_STAR] = ACTIONS(3719),
    [anon_sym_SLASH] = ACTIONS(3721),
    [anon_sym_PERCENT] = ACTIONS(3719),
    [anon_sym_CARET] = ACTIONS(3719),
    [anon_sym_PIPE] = ACTIONS(3721),
    [anon_sym_AMP] = ACTIONS(3721),
    [anon_sym_LT_LT] = ACTIONS(3719),
    [anon_sym_GT_GT] = ACTIONS(3721),
    [anon_sym_GT_GT_GT] = ACTIONS(3719),
    [anon_sym_EQ_EQ] = ACTIONS(3719),
    [anon_sym_BANG_EQ] = ACTIONS(3719),
    [anon_sym_GT_EQ] = ACTIONS(3719),
    [anon_sym_LT_EQ] = ACTIONS(3719),
    [anon_sym_DOT] = ACTIONS(3721),
    [anon_sym_scoped] = ACTIONS(4227),
    [anon_sym_COLON_COLON] = ACTIONS(3719),
    [anon_sym_var] = ACTIONS(4227),
    [anon_sym_yield] = ACTIONS(4227),
    [anon_sym_switch] = ACTIONS(3721),
    [anon_sym_when] = ACTIONS(4227),
    [anon_sym_DOT_DOT] = ACTIONS(3719),
    [anon_sym_and] = ACTIONS(3721),
    [anon_sym_or] = ACTIONS(3721),
    [anon_sym_AMP_AMP] = ACTIONS(3719),
    [anon_sym_PIPE_PIPE] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK] = ACTIONS(3719),
    [anon_sym_from] = ACTIONS(4231),
    [anon_sym_into] = ACTIONS(4231),
    [anon_sym_join] = ACTIONS(4231),
    [anon_sym_on] = ACTIONS(4227),
    [anon_sym_equals] = ACTIONS(4227),
    [anon_sym_let] = ACTIONS(4231),
    [anon_sym_orderby] = ACTIONS(4231),
    [anon_sym_ascending] = ACTIONS(4227),
    [anon_sym_descending] = ACTIONS(4227),
    [anon_sym_group] = ACTIONS(4231),
    [anon_sym_by] = ACTIONS(4227),
    [anon_sym_select] = ACTIONS(4231),
    [anon_sym_as] = ACTIONS(3721),
    [anon_sym_is] = ACTIONS(3721),
    [anon_sym_DASH_GT] = ACTIONS(3719),
    [anon_sym_with] = ACTIONS(3721),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2986] = {
    [sym__name] = STATE(3926),
    [sym_alias_qualified_name] = STATE(3912),
    [sym__simple_name] = STATE(3912),
    [sym_qualified_name] = STATE(3912),
    [sym_generic_name] = STATE(3874),
    [sym_ref_type] = STATE(3927),
    [sym__scoped_base_type] = STATE(3930),
    [sym_identifier] = STATE(3787),
    [sym__reserved_identifier] = STATE(3838),
    [sym_preproc_region] = STATE(2986),
    [sym_preproc_endregion] = STATE(2986),
    [sym_preproc_line] = STATE(2986),
    [sym_preproc_pragma] = STATE(2986),
    [sym_preproc_nullable] = STATE(2986),
    [sym_preproc_error] = STATE(2986),
    [sym_preproc_define] = STATE(2986),
    [sym_preproc_undef] = STATE(2986),
    [sym__identifier_token] = ACTIONS(4157),
    [anon_sym_alias] = ACTIONS(4159),
    [anon_sym_global] = ACTIONS(4159),
    [anon_sym_LBRACK] = ACTIONS(3719),
    [anon_sym_LPAREN] = ACTIONS(3719),
    [anon_sym_ref] = ACTIONS(4586),
    [anon_sym_LBRACE] = ACTIONS(3719),
    [anon_sym_file] = ACTIONS(4159),
    [anon_sym_LT] = ACTIONS(3721),
    [anon_sym_GT] = ACTIONS(3721),
    [anon_sym_where] = ACTIONS(4159),
    [anon_sym_QMARK] = ACTIONS(3721),
    [anon_sym_notnull] = ACTIONS(4159),
    [anon_sym_unmanaged] = ACTIONS(4159),
    [anon_sym_BANG] = ACTIONS(3721),
    [anon_sym_PLUS_PLUS] = ACTIONS(3719),
    [anon_sym_DASH_DASH] = ACTIONS(3719),
    [anon_sym_PLUS] = ACTIONS(3721),
    [anon_sym_DASH] = ACTIONS(3721),
    [anon_sym_STAR] = ACTIONS(3719),
    [anon_sym_SLASH] = ACTIONS(3721),
    [anon_sym_PERCENT] = ACTIONS(3719),
    [anon_sym_CARET] = ACTIONS(3719),
    [anon_sym_PIPE] = ACTIONS(3721),
    [anon_sym_AMP] = ACTIONS(3721),
    [anon_sym_LT_LT] = ACTIONS(3719),
    [anon_sym_GT_GT] = ACTIONS(3721),
    [anon_sym_GT_GT_GT] = ACTIONS(3719),
    [anon_sym_EQ_EQ] = ACTIONS(3719),
    [anon_sym_BANG_EQ] = ACTIONS(3719),
    [anon_sym_GT_EQ] = ACTIONS(3719),
    [anon_sym_LT_EQ] = ACTIONS(3719),
    [anon_sym_DOT] = ACTIONS(3721),
    [anon_sym_scoped] = ACTIONS(4159),
    [anon_sym_COLON_COLON] = ACTIONS(3719),
    [anon_sym_var] = ACTIONS(4159),
    [anon_sym_yield] = ACTIONS(4159),
    [anon_sym_switch] = ACTIONS(3721),
    [anon_sym_when] = ACTIONS(4159),
    [anon_sym_DOT_DOT] = ACTIONS(3719),
    [anon_sym_and] = ACTIONS(3721),
    [anon_sym_or] = ACTIONS(3721),
    [anon_sym_AMP_AMP] = ACTIONS(3719),
    [anon_sym_PIPE_PIPE] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK] = ACTIONS(3719),
    [anon_sym_from] = ACTIONS(4159),
    [anon_sym_into] = ACTIONS(4163),
    [anon_sym_join] = ACTIONS(4159),
    [anon_sym_on] = ACTIONS(4159),
    [anon_sym_equals] = ACTIONS(4159),
    [anon_sym_let] = ACTIONS(4159),
    [anon_sym_orderby] = ACTIONS(4159),
    [anon_sym_ascending] = ACTIONS(4159),
    [anon_sym_descending] = ACTIONS(4159),
    [anon_sym_group] = ACTIONS(4159),
    [anon_sym_by] = ACTIONS(4163),
    [anon_sym_select] = ACTIONS(4159),
    [anon_sym_as] = ACTIONS(3721),
    [anon_sym_is] = ACTIONS(3721),
    [anon_sym_DASH_GT] = ACTIONS(3719),
    [anon_sym_with] = ACTIONS(3721),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2987] = {
    [sym_preproc_region] = STATE(2987),
    [sym_preproc_endregion] = STATE(2987),
    [sym_preproc_line] = STATE(2987),
    [sym_preproc_pragma] = STATE(2987),
    [sym_preproc_nullable] = STATE(2987),
    [sym_preproc_error] = STATE(2987),
    [sym_preproc_define] = STATE(2987),
    [sym_preproc_undef] = STATE(2987),
    [anon_sym_SEMI] = ACTIONS(3719),
    [anon_sym_EQ] = ACTIONS(3721),
    [anon_sym_LBRACK] = ACTIONS(3719),
    [anon_sym_COLON] = ACTIONS(3719),
    [anon_sym_COMMA] = ACTIONS(3719),
    [anon_sym_RBRACK] = ACTIONS(3719),
    [anon_sym_LPAREN] = ACTIONS(3719),
    [anon_sym_RPAREN] = ACTIONS(3719),
    [anon_sym_RBRACE] = ACTIONS(3719),
    [anon_sym_LT] = ACTIONS(3721),
    [anon_sym_GT] = ACTIONS(3721),
    [anon_sym_in] = ACTIONS(3721),
    [anon_sym_where] = ACTIONS(3719),
    [anon_sym_QMARK] = ACTIONS(3721),
    [anon_sym_BANG] = ACTIONS(3721),
    [anon_sym_PLUS_PLUS] = ACTIONS(3719),
    [anon_sym_DASH_DASH] = ACTIONS(3719),
    [anon_sym_PLUS] = ACTIONS(3721),
    [anon_sym_DASH] = ACTIONS(3721),
    [anon_sym_STAR] = ACTIONS(3721),
    [anon_sym_SLASH] = ACTIONS(3721),
    [anon_sym_PERCENT] = ACTIONS(3721),
    [anon_sym_CARET] = ACTIONS(3721),
    [anon_sym_PIPE] = ACTIONS(3721),
    [anon_sym_AMP] = ACTIONS(3721),
    [anon_sym_LT_LT] = ACTIONS(3721),
    [anon_sym_GT_GT] = ACTIONS(3721),
    [anon_sym_GT_GT_GT] = ACTIONS(3721),
    [anon_sym_EQ_EQ] = ACTIONS(3719),
    [anon_sym_BANG_EQ] = ACTIONS(3719),
    [anon_sym_GT_EQ] = ACTIONS(3719),
    [anon_sym_LT_EQ] = ACTIONS(3719),
    [anon_sym_DOT] = ACTIONS(3721),
    [anon_sym_EQ_GT] = ACTIONS(3719),
    [anon_sym_switch] = ACTIONS(3719),
    [anon_sym_DOT_DOT] = ACTIONS(3719),
    [anon_sym_and] = ACTIONS(3719),
    [anon_sym_or] = ACTIONS(3721),
    [anon_sym_PLUS_EQ] = ACTIONS(3719),
    [anon_sym_DASH_EQ] = ACTIONS(3719),
    [anon_sym_STAR_EQ] = ACTIONS(3719),
    [anon_sym_SLASH_EQ] = ACTIONS(3719),
    [anon_sym_PERCENT_EQ] = ACTIONS(3719),
    [anon_sym_AMP_EQ] = ACTIONS(3719),
    [anon_sym_CARET_EQ] = ACTIONS(3719),
    [anon_sym_PIPE_EQ] = ACTIONS(3719),
    [anon_sym_LT_LT_EQ] = ACTIONS(3719),
    [anon_sym_GT_GT_EQ] = ACTIONS(3719),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3719),
    [anon_sym_AMP_AMP] = ACTIONS(3719),
    [anon_sym_PIPE_PIPE] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK] = ACTIONS(3721),
    [anon_sym_from] = ACTIONS(3719),
    [anon_sym_into] = ACTIONS(3719),
    [anon_sym_join] = ACTIONS(3719),
    [anon_sym_on] = ACTIONS(3719),
    [anon_sym_equals] = ACTIONS(3719),
    [anon_sym_let] = ACTIONS(3719),
    [anon_sym_orderby] = ACTIONS(3719),
    [anon_sym_group] = ACTIONS(3719),
    [anon_sym_by] = ACTIONS(3719),
    [anon_sym_select] = ACTIONS(3719),
    [anon_sym_as] = ACTIONS(3719),
    [anon_sym_is] = ACTIONS(3719),
    [anon_sym_DASH_GT] = ACTIONS(3719),
    [anon_sym_with] = ACTIONS(3719),
    [aux_sym_preproc_if_token3] = ACTIONS(3719),
    [aux_sym_preproc_else_token1] = ACTIONS(3719),
    [aux_sym_preproc_elif_token1] = ACTIONS(3719),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2988] = {
    [sym_preproc_region] = STATE(2988),
    [sym_preproc_endregion] = STATE(2988),
    [sym_preproc_line] = STATE(2988),
    [sym_preproc_pragma] = STATE(2988),
    [sym_preproc_nullable] = STATE(2988),
    [sym_preproc_error] = STATE(2988),
    [sym_preproc_define] = STATE(2988),
    [sym_preproc_undef] = STATE(2988),
    [anon_sym_SEMI] = ACTIONS(4588),
    [anon_sym_EQ] = ACTIONS(4590),
    [anon_sym_LBRACK] = ACTIONS(4588),
    [anon_sym_COLON] = ACTIONS(4588),
    [anon_sym_COMMA] = ACTIONS(4588),
    [anon_sym_RBRACK] = ACTIONS(4588),
    [anon_sym_LPAREN] = ACTIONS(4588),
    [anon_sym_RPAREN] = ACTIONS(4588),
    [anon_sym_RBRACE] = ACTIONS(4588),
    [anon_sym_LT] = ACTIONS(4590),
    [anon_sym_GT] = ACTIONS(4590),
    [anon_sym_in] = ACTIONS(4590),
    [anon_sym_where] = ACTIONS(4588),
    [anon_sym_QMARK] = ACTIONS(4590),
    [anon_sym_BANG] = ACTIONS(4590),
    [anon_sym_PLUS_PLUS] = ACTIONS(4588),
    [anon_sym_DASH_DASH] = ACTIONS(4588),
    [anon_sym_PLUS] = ACTIONS(4590),
    [anon_sym_DASH] = ACTIONS(4590),
    [anon_sym_STAR] = ACTIONS(4590),
    [anon_sym_SLASH] = ACTIONS(4590),
    [anon_sym_PERCENT] = ACTIONS(4590),
    [anon_sym_CARET] = ACTIONS(4590),
    [anon_sym_PIPE] = ACTIONS(4590),
    [anon_sym_AMP] = ACTIONS(4590),
    [anon_sym_LT_LT] = ACTIONS(4590),
    [anon_sym_GT_GT] = ACTIONS(4590),
    [anon_sym_GT_GT_GT] = ACTIONS(4590),
    [anon_sym_EQ_EQ] = ACTIONS(4588),
    [anon_sym_BANG_EQ] = ACTIONS(4588),
    [anon_sym_GT_EQ] = ACTIONS(4588),
    [anon_sym_LT_EQ] = ACTIONS(4588),
    [anon_sym_DOT] = ACTIONS(4590),
    [anon_sym_EQ_GT] = ACTIONS(4588),
    [anon_sym_switch] = ACTIONS(4588),
    [anon_sym_DOT_DOT] = ACTIONS(4588),
    [anon_sym_and] = ACTIONS(4588),
    [anon_sym_or] = ACTIONS(4590),
    [anon_sym_PLUS_EQ] = ACTIONS(4588),
    [anon_sym_DASH_EQ] = ACTIONS(4588),
    [anon_sym_STAR_EQ] = ACTIONS(4588),
    [anon_sym_SLASH_EQ] = ACTIONS(4588),
    [anon_sym_PERCENT_EQ] = ACTIONS(4588),
    [anon_sym_AMP_EQ] = ACTIONS(4588),
    [anon_sym_CARET_EQ] = ACTIONS(4588),
    [anon_sym_PIPE_EQ] = ACTIONS(4588),
    [anon_sym_LT_LT_EQ] = ACTIONS(4588),
    [anon_sym_GT_GT_EQ] = ACTIONS(4588),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4588),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4588),
    [anon_sym_AMP_AMP] = ACTIONS(4588),
    [anon_sym_PIPE_PIPE] = ACTIONS(4588),
    [anon_sym_QMARK_QMARK] = ACTIONS(4590),
    [anon_sym_from] = ACTIONS(4588),
    [anon_sym_into] = ACTIONS(4588),
    [anon_sym_join] = ACTIONS(4588),
    [anon_sym_on] = ACTIONS(4588),
    [anon_sym_equals] = ACTIONS(4588),
    [anon_sym_let] = ACTIONS(4588),
    [anon_sym_orderby] = ACTIONS(4588),
    [anon_sym_group] = ACTIONS(4588),
    [anon_sym_by] = ACTIONS(4588),
    [anon_sym_select] = ACTIONS(4588),
    [anon_sym_as] = ACTIONS(4588),
    [anon_sym_is] = ACTIONS(4588),
    [anon_sym_DASH_GT] = ACTIONS(4588),
    [anon_sym_with] = ACTIONS(4588),
    [aux_sym_preproc_if_token3] = ACTIONS(4588),
    [aux_sym_preproc_else_token1] = ACTIONS(4588),
    [aux_sym_preproc_elif_token1] = ACTIONS(4588),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2989] = {
    [sym__name] = STATE(4267),
    [sym_alias_qualified_name] = STATE(3955),
    [sym__simple_name] = STATE(3955),
    [sym_qualified_name] = STATE(3955),
    [sym_generic_name] = STATE(4047),
    [sym_ref_type] = STATE(4040),
    [sym__scoped_base_type] = STATE(4036),
    [sym_identifier] = STATE(3891),
    [sym__reserved_identifier] = STATE(3897),
    [sym_preproc_region] = STATE(2989),
    [sym_preproc_endregion] = STATE(2989),
    [sym_preproc_line] = STATE(2989),
    [sym_preproc_pragma] = STATE(2989),
    [sym_preproc_nullable] = STATE(2989),
    [sym_preproc_error] = STATE(2989),
    [sym_preproc_define] = STATE(2989),
    [sym_preproc_undef] = STATE(2989),
    [sym__identifier_token] = ACTIONS(4168),
    [anon_sym_alias] = ACTIONS(4170),
    [anon_sym_global] = ACTIONS(4170),
    [anon_sym_LBRACK] = ACTIONS(3719),
    [anon_sym_LPAREN] = ACTIONS(3719),
    [anon_sym_ref] = ACTIONS(4592),
    [anon_sym_LBRACE] = ACTIONS(3719),
    [anon_sym_file] = ACTIONS(4170),
    [anon_sym_LT] = ACTIONS(3721),
    [anon_sym_GT] = ACTIONS(3721),
    [anon_sym_where] = ACTIONS(4170),
    [anon_sym_QMARK] = ACTIONS(3721),
    [anon_sym_notnull] = ACTIONS(4170),
    [anon_sym_unmanaged] = ACTIONS(4170),
    [anon_sym_BANG] = ACTIONS(3721),
    [anon_sym_PLUS_PLUS] = ACTIONS(3719),
    [anon_sym_DASH_DASH] = ACTIONS(3719),
    [anon_sym_PLUS] = ACTIONS(3721),
    [anon_sym_DASH] = ACTIONS(3721),
    [anon_sym_STAR] = ACTIONS(3719),
    [anon_sym_SLASH] = ACTIONS(3721),
    [anon_sym_PERCENT] = ACTIONS(3719),
    [anon_sym_CARET] = ACTIONS(3719),
    [anon_sym_PIPE] = ACTIONS(3721),
    [anon_sym_AMP] = ACTIONS(3721),
    [anon_sym_LT_LT] = ACTIONS(3719),
    [anon_sym_GT_GT] = ACTIONS(3721),
    [anon_sym_GT_GT_GT] = ACTIONS(3719),
    [anon_sym_EQ_EQ] = ACTIONS(3719),
    [anon_sym_BANG_EQ] = ACTIONS(3719),
    [anon_sym_GT_EQ] = ACTIONS(3719),
    [anon_sym_LT_EQ] = ACTIONS(3719),
    [anon_sym_DOT] = ACTIONS(3721),
    [anon_sym_scoped] = ACTIONS(4170),
    [anon_sym_COLON_COLON] = ACTIONS(3719),
    [anon_sym_var] = ACTIONS(4170),
    [anon_sym_yield] = ACTIONS(4170),
    [anon_sym_switch] = ACTIONS(3721),
    [anon_sym_when] = ACTIONS(4170),
    [anon_sym_DOT_DOT] = ACTIONS(3719),
    [anon_sym_and] = ACTIONS(3721),
    [anon_sym_or] = ACTIONS(3721),
    [anon_sym_AMP_AMP] = ACTIONS(3719),
    [anon_sym_PIPE_PIPE] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK] = ACTIONS(3719),
    [anon_sym_from] = ACTIONS(4170),
    [anon_sym_into] = ACTIONS(4170),
    [anon_sym_join] = ACTIONS(4170),
    [anon_sym_on] = ACTIONS(4467),
    [anon_sym_equals] = ACTIONS(4170),
    [anon_sym_let] = ACTIONS(4170),
    [anon_sym_orderby] = ACTIONS(4170),
    [anon_sym_ascending] = ACTIONS(4170),
    [anon_sym_descending] = ACTIONS(4170),
    [anon_sym_group] = ACTIONS(4170),
    [anon_sym_by] = ACTIONS(4170),
    [anon_sym_select] = ACTIONS(4170),
    [anon_sym_as] = ACTIONS(3721),
    [anon_sym_is] = ACTIONS(3721),
    [anon_sym_DASH_GT] = ACTIONS(3719),
    [anon_sym_with] = ACTIONS(3721),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2990] = {
    [sym_preproc_region] = STATE(2990),
    [sym_preproc_endregion] = STATE(2990),
    [sym_preproc_line] = STATE(2990),
    [sym_preproc_pragma] = STATE(2990),
    [sym_preproc_nullable] = STATE(2990),
    [sym_preproc_error] = STATE(2990),
    [sym_preproc_define] = STATE(2990),
    [sym_preproc_undef] = STATE(2990),
    [sym__identifier_token] = ACTIONS(4594),
    [anon_sym_alias] = ACTIONS(4594),
    [anon_sym_SEMI] = ACTIONS(4596),
    [anon_sym_global] = ACTIONS(4594),
    [anon_sym_LBRACK] = ACTIONS(4596),
    [anon_sym_COLON] = ACTIONS(4596),
    [anon_sym_COMMA] = ACTIONS(4596),
    [anon_sym_RBRACK] = ACTIONS(4596),
    [anon_sym_LPAREN] = ACTIONS(4596),
    [anon_sym_RPAREN] = ACTIONS(4596),
    [anon_sym_RBRACE] = ACTIONS(4596),
    [anon_sym_file] = ACTIONS(4594),
    [anon_sym_LT] = ACTIONS(4594),
    [anon_sym_GT] = ACTIONS(4594),
    [anon_sym_in] = ACTIONS(4594),
    [anon_sym_where] = ACTIONS(4594),
    [anon_sym_QMARK] = ACTIONS(4594),
    [anon_sym_notnull] = ACTIONS(4594),
    [anon_sym_unmanaged] = ACTIONS(4594),
    [anon_sym_BANG] = ACTIONS(4594),
    [anon_sym_PLUS_PLUS] = ACTIONS(4596),
    [anon_sym_DASH_DASH] = ACTIONS(4596),
    [anon_sym_PLUS] = ACTIONS(4594),
    [anon_sym_DASH] = ACTIONS(4594),
    [anon_sym_STAR] = ACTIONS(4596),
    [anon_sym_SLASH] = ACTIONS(4594),
    [anon_sym_PERCENT] = ACTIONS(4596),
    [anon_sym_CARET] = ACTIONS(4596),
    [anon_sym_PIPE] = ACTIONS(4594),
    [anon_sym_AMP] = ACTIONS(4594),
    [anon_sym_LT_LT] = ACTIONS(4596),
    [anon_sym_GT_GT] = ACTIONS(4594),
    [anon_sym_GT_GT_GT] = ACTIONS(4596),
    [anon_sym_EQ_EQ] = ACTIONS(4596),
    [anon_sym_BANG_EQ] = ACTIONS(4596),
    [anon_sym_GT_EQ] = ACTIONS(4596),
    [anon_sym_LT_EQ] = ACTIONS(4596),
    [anon_sym_DOT] = ACTIONS(4594),
    [anon_sym_scoped] = ACTIONS(4594),
    [anon_sym_EQ_GT] = ACTIONS(4596),
    [anon_sym_var] = ACTIONS(4594),
    [anon_sym_yield] = ACTIONS(4594),
    [anon_sym_switch] = ACTIONS(4594),
    [anon_sym_when] = ACTIONS(4594),
    [sym_discard] = ACTIONS(4594),
    [anon_sym_DOT_DOT] = ACTIONS(4596),
    [anon_sym_and] = ACTIONS(4594),
    [anon_sym_or] = ACTIONS(4594),
    [anon_sym_AMP_AMP] = ACTIONS(4596),
    [anon_sym_PIPE_PIPE] = ACTIONS(4596),
    [anon_sym_QMARK_QMARK] = ACTIONS(4596),
    [anon_sym_from] = ACTIONS(4594),
    [anon_sym_into] = ACTIONS(4594),
    [anon_sym_join] = ACTIONS(4594),
    [anon_sym_on] = ACTIONS(4594),
    [anon_sym_equals] = ACTIONS(4594),
    [anon_sym_let] = ACTIONS(4594),
    [anon_sym_orderby] = ACTIONS(4594),
    [anon_sym_ascending] = ACTIONS(4594),
    [anon_sym_descending] = ACTIONS(4594),
    [anon_sym_group] = ACTIONS(4594),
    [anon_sym_by] = ACTIONS(4594),
    [anon_sym_select] = ACTIONS(4594),
    [anon_sym_as] = ACTIONS(4594),
    [anon_sym_is] = ACTIONS(4594),
    [anon_sym_DASH_GT] = ACTIONS(4596),
    [anon_sym_with] = ACTIONS(4594),
    [aux_sym_preproc_if_token3] = ACTIONS(4596),
    [aux_sym_preproc_else_token1] = ACTIONS(4596),
    [aux_sym_preproc_elif_token1] = ACTIONS(4596),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2991] = {
    [sym__name] = STATE(4267),
    [sym_alias_qualified_name] = STATE(3955),
    [sym__simple_name] = STATE(3955),
    [sym_qualified_name] = STATE(3955),
    [sym_generic_name] = STATE(4047),
    [sym_ref_type] = STATE(4040),
    [sym__scoped_base_type] = STATE(4036),
    [sym_identifier] = STATE(3891),
    [sym__reserved_identifier] = STATE(3897),
    [sym_preproc_region] = STATE(2991),
    [sym_preproc_endregion] = STATE(2991),
    [sym_preproc_line] = STATE(2991),
    [sym_preproc_pragma] = STATE(2991),
    [sym_preproc_nullable] = STATE(2991),
    [sym_preproc_error] = STATE(2991),
    [sym_preproc_define] = STATE(2991),
    [sym_preproc_undef] = STATE(2991),
    [sym__identifier_token] = ACTIONS(4168),
    [anon_sym_alias] = ACTIONS(4170),
    [anon_sym_global] = ACTIONS(4170),
    [anon_sym_LBRACK] = ACTIONS(3719),
    [anon_sym_LPAREN] = ACTIONS(3719),
    [anon_sym_ref] = ACTIONS(4598),
    [anon_sym_LBRACE] = ACTIONS(3719),
    [anon_sym_file] = ACTIONS(4170),
    [anon_sym_LT] = ACTIONS(3721),
    [anon_sym_GT] = ACTIONS(3721),
    [anon_sym_where] = ACTIONS(4170),
    [anon_sym_QMARK] = ACTIONS(3721),
    [anon_sym_notnull] = ACTIONS(4170),
    [anon_sym_unmanaged] = ACTIONS(4170),
    [anon_sym_BANG] = ACTIONS(3721),
    [anon_sym_PLUS_PLUS] = ACTIONS(3719),
    [anon_sym_DASH_DASH] = ACTIONS(3719),
    [anon_sym_PLUS] = ACTIONS(3721),
    [anon_sym_DASH] = ACTIONS(3721),
    [anon_sym_STAR] = ACTIONS(3719),
    [anon_sym_SLASH] = ACTIONS(3721),
    [anon_sym_PERCENT] = ACTIONS(3719),
    [anon_sym_CARET] = ACTIONS(3719),
    [anon_sym_PIPE] = ACTIONS(3721),
    [anon_sym_AMP] = ACTIONS(3721),
    [anon_sym_LT_LT] = ACTIONS(3719),
    [anon_sym_GT_GT] = ACTIONS(3721),
    [anon_sym_GT_GT_GT] = ACTIONS(3719),
    [anon_sym_EQ_EQ] = ACTIONS(3719),
    [anon_sym_BANG_EQ] = ACTIONS(3719),
    [anon_sym_GT_EQ] = ACTIONS(3719),
    [anon_sym_LT_EQ] = ACTIONS(3719),
    [anon_sym_DOT] = ACTIONS(3721),
    [anon_sym_scoped] = ACTIONS(4170),
    [anon_sym_COLON_COLON] = ACTIONS(3719),
    [anon_sym_var] = ACTIONS(4170),
    [anon_sym_yield] = ACTIONS(4170),
    [anon_sym_switch] = ACTIONS(3721),
    [anon_sym_when] = ACTIONS(4170),
    [anon_sym_DOT_DOT] = ACTIONS(3719),
    [anon_sym_and] = ACTIONS(3721),
    [anon_sym_or] = ACTIONS(3721),
    [anon_sym_AMP_AMP] = ACTIONS(3719),
    [anon_sym_PIPE_PIPE] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK] = ACTIONS(3719),
    [anon_sym_from] = ACTIONS(4170),
    [anon_sym_into] = ACTIONS(4170),
    [anon_sym_join] = ACTIONS(4170),
    [anon_sym_on] = ACTIONS(4170),
    [anon_sym_equals] = ACTIONS(4467),
    [anon_sym_let] = ACTIONS(4170),
    [anon_sym_orderby] = ACTIONS(4170),
    [anon_sym_ascending] = ACTIONS(4170),
    [anon_sym_descending] = ACTIONS(4170),
    [anon_sym_group] = ACTIONS(4170),
    [anon_sym_by] = ACTIONS(4170),
    [anon_sym_select] = ACTIONS(4170),
    [anon_sym_as] = ACTIONS(3721),
    [anon_sym_is] = ACTIONS(3721),
    [anon_sym_DASH_GT] = ACTIONS(3719),
    [anon_sym_with] = ACTIONS(3721),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2992] = {
    [sym_preproc_region] = STATE(2992),
    [sym_preproc_endregion] = STATE(2992),
    [sym_preproc_line] = STATE(2992),
    [sym_preproc_pragma] = STATE(2992),
    [sym_preproc_nullable] = STATE(2992),
    [sym_preproc_error] = STATE(2992),
    [sym_preproc_define] = STATE(2992),
    [sym_preproc_undef] = STATE(2992),
    [sym__identifier_token] = ACTIONS(4422),
    [anon_sym_alias] = ACTIONS(4422),
    [anon_sym_SEMI] = ACTIONS(4424),
    [anon_sym_global] = ACTIONS(4422),
    [anon_sym_LBRACK] = ACTIONS(4547),
    [anon_sym_COMMA] = ACTIONS(4424),
    [anon_sym_RBRACK] = ACTIONS(4424),
    [anon_sym_LPAREN] = ACTIONS(4424),
    [anon_sym_RPAREN] = ACTIONS(4424),
    [anon_sym_LBRACE] = ACTIONS(4424),
    [anon_sym_RBRACE] = ACTIONS(4424),
    [anon_sym_file] = ACTIONS(4422),
    [anon_sym_LT] = ACTIONS(4422),
    [anon_sym_GT] = ACTIONS(4422),
    [anon_sym_in] = ACTIONS(4422),
    [anon_sym_where] = ACTIONS(4422),
    [anon_sym_QMARK] = ACTIONS(4550),
    [anon_sym_notnull] = ACTIONS(4422),
    [anon_sym_unmanaged] = ACTIONS(4422),
    [anon_sym_BANG] = ACTIONS(4422),
    [anon_sym_PLUS_PLUS] = ACTIONS(4424),
    [anon_sym_DASH_DASH] = ACTIONS(4424),
    [anon_sym_PLUS] = ACTIONS(4422),
    [anon_sym_DASH] = ACTIONS(4422),
    [anon_sym_STAR] = ACTIONS(4553),
    [anon_sym_SLASH] = ACTIONS(4422),
    [anon_sym_PERCENT] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4424),
    [anon_sym_PIPE] = ACTIONS(4422),
    [anon_sym_AMP] = ACTIONS(4422),
    [anon_sym_LT_LT] = ACTIONS(4424),
    [anon_sym_GT_GT] = ACTIONS(4422),
    [anon_sym_GT_GT_GT] = ACTIONS(4424),
    [anon_sym_EQ_EQ] = ACTIONS(4424),
    [anon_sym_BANG_EQ] = ACTIONS(4424),
    [anon_sym_GT_EQ] = ACTIONS(4424),
    [anon_sym_LT_EQ] = ACTIONS(4424),
    [anon_sym_DOT] = ACTIONS(4600),
    [anon_sym_scoped] = ACTIONS(4422),
    [anon_sym_EQ_GT] = ACTIONS(4424),
    [anon_sym_var] = ACTIONS(4422),
    [anon_sym_yield] = ACTIONS(4422),
    [anon_sym_switch] = ACTIONS(4422),
    [anon_sym_when] = ACTIONS(4422),
    [sym_discard] = ACTIONS(4422),
    [anon_sym_DOT_DOT] = ACTIONS(4424),
    [anon_sym_and] = ACTIONS(4422),
    [anon_sym_or] = ACTIONS(4422),
    [anon_sym_AMP_AMP] = ACTIONS(4424),
    [anon_sym_PIPE_PIPE] = ACTIONS(4424),
    [anon_sym_QMARK_QMARK] = ACTIONS(4424),
    [anon_sym_from] = ACTIONS(4422),
    [anon_sym_into] = ACTIONS(4422),
    [anon_sym_join] = ACTIONS(4422),
    [anon_sym_on] = ACTIONS(4422),
    [anon_sym_equals] = ACTIONS(4422),
    [anon_sym_let] = ACTIONS(4422),
    [anon_sym_orderby] = ACTIONS(4422),
    [anon_sym_ascending] = ACTIONS(4422),
    [anon_sym_descending] = ACTIONS(4422),
    [anon_sym_group] = ACTIONS(4422),
    [anon_sym_by] = ACTIONS(4422),
    [anon_sym_select] = ACTIONS(4422),
    [anon_sym_as] = ACTIONS(4422),
    [anon_sym_is] = ACTIONS(4422),
    [anon_sym_DASH_GT] = ACTIONS(4558),
    [anon_sym_with] = ACTIONS(4422),
    [aux_sym_preproc_if_token3] = ACTIONS(4424),
    [aux_sym_preproc_else_token1] = ACTIONS(4424),
    [aux_sym_preproc_elif_token1] = ACTIONS(4424),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2993] = {
    [sym_preproc_region] = STATE(2993),
    [sym_preproc_endregion] = STATE(2993),
    [sym_preproc_line] = STATE(2993),
    [sym_preproc_pragma] = STATE(2993),
    [sym_preproc_nullable] = STATE(2993),
    [sym_preproc_error] = STATE(2993),
    [sym_preproc_define] = STATE(2993),
    [sym_preproc_undef] = STATE(2993),
    [anon_sym_SEMI] = ACTIONS(4058),
    [anon_sym_EQ] = ACTIONS(4056),
    [anon_sym_LBRACK] = ACTIONS(4058),
    [anon_sym_COLON] = ACTIONS(4058),
    [anon_sym_COMMA] = ACTIONS(4058),
    [anon_sym_RBRACK] = ACTIONS(4058),
    [anon_sym_LPAREN] = ACTIONS(4058),
    [anon_sym_RPAREN] = ACTIONS(4058),
    [anon_sym_RBRACE] = ACTIONS(4058),
    [anon_sym_LT] = ACTIONS(4056),
    [anon_sym_GT] = ACTIONS(4056),
    [anon_sym_in] = ACTIONS(4056),
    [anon_sym_where] = ACTIONS(4058),
    [anon_sym_QMARK] = ACTIONS(4056),
    [anon_sym_BANG] = ACTIONS(4056),
    [anon_sym_PLUS_PLUS] = ACTIONS(4058),
    [anon_sym_DASH_DASH] = ACTIONS(4058),
    [anon_sym_PLUS] = ACTIONS(4056),
    [anon_sym_DASH] = ACTIONS(4056),
    [anon_sym_STAR] = ACTIONS(4056),
    [anon_sym_SLASH] = ACTIONS(4056),
    [anon_sym_PERCENT] = ACTIONS(4056),
    [anon_sym_CARET] = ACTIONS(4056),
    [anon_sym_PIPE] = ACTIONS(4056),
    [anon_sym_AMP] = ACTIONS(4056),
    [anon_sym_LT_LT] = ACTIONS(4056),
    [anon_sym_GT_GT] = ACTIONS(4056),
    [anon_sym_GT_GT_GT] = ACTIONS(4056),
    [anon_sym_EQ_EQ] = ACTIONS(4058),
    [anon_sym_BANG_EQ] = ACTIONS(4058),
    [anon_sym_GT_EQ] = ACTIONS(4058),
    [anon_sym_LT_EQ] = ACTIONS(4058),
    [anon_sym_DOT] = ACTIONS(4056),
    [anon_sym_EQ_GT] = ACTIONS(4058),
    [anon_sym_switch] = ACTIONS(4058),
    [anon_sym_DOT_DOT] = ACTIONS(4058),
    [anon_sym_and] = ACTIONS(4058),
    [anon_sym_or] = ACTIONS(4056),
    [anon_sym_PLUS_EQ] = ACTIONS(4058),
    [anon_sym_DASH_EQ] = ACTIONS(4058),
    [anon_sym_STAR_EQ] = ACTIONS(4058),
    [anon_sym_SLASH_EQ] = ACTIONS(4058),
    [anon_sym_PERCENT_EQ] = ACTIONS(4058),
    [anon_sym_AMP_EQ] = ACTIONS(4058),
    [anon_sym_CARET_EQ] = ACTIONS(4058),
    [anon_sym_PIPE_EQ] = ACTIONS(4058),
    [anon_sym_LT_LT_EQ] = ACTIONS(4058),
    [anon_sym_GT_GT_EQ] = ACTIONS(4058),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4058),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4058),
    [anon_sym_AMP_AMP] = ACTIONS(4058),
    [anon_sym_PIPE_PIPE] = ACTIONS(4058),
    [anon_sym_QMARK_QMARK] = ACTIONS(4056),
    [anon_sym_from] = ACTIONS(4058),
    [anon_sym_into] = ACTIONS(4058),
    [anon_sym_join] = ACTIONS(4058),
    [anon_sym_on] = ACTIONS(4058),
    [anon_sym_equals] = ACTIONS(4058),
    [anon_sym_let] = ACTIONS(4058),
    [anon_sym_orderby] = ACTIONS(4058),
    [anon_sym_group] = ACTIONS(4058),
    [anon_sym_by] = ACTIONS(4058),
    [anon_sym_select] = ACTIONS(4058),
    [anon_sym_as] = ACTIONS(4058),
    [anon_sym_is] = ACTIONS(4058),
    [anon_sym_DASH_GT] = ACTIONS(4058),
    [anon_sym_with] = ACTIONS(4058),
    [aux_sym_preproc_if_token3] = ACTIONS(4058),
    [aux_sym_preproc_else_token1] = ACTIONS(4058),
    [aux_sym_preproc_elif_token1] = ACTIONS(4058),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2994] = {
    [sym_preproc_region] = STATE(2994),
    [sym_preproc_endregion] = STATE(2994),
    [sym_preproc_line] = STATE(2994),
    [sym_preproc_pragma] = STATE(2994),
    [sym_preproc_nullable] = STATE(2994),
    [sym_preproc_error] = STATE(2994),
    [sym_preproc_define] = STATE(2994),
    [sym_preproc_undef] = STATE(2994),
    [sym__identifier_token] = ACTIONS(4576),
    [anon_sym_alias] = ACTIONS(4576),
    [anon_sym_SEMI] = ACTIONS(4578),
    [anon_sym_global] = ACTIONS(4576),
    [anon_sym_LBRACK] = ACTIONS(4578),
    [anon_sym_COLON] = ACTIONS(4578),
    [anon_sym_COMMA] = ACTIONS(4578),
    [anon_sym_RBRACK] = ACTIONS(4578),
    [anon_sym_LPAREN] = ACTIONS(4578),
    [anon_sym_RPAREN] = ACTIONS(4578),
    [anon_sym_RBRACE] = ACTIONS(4578),
    [anon_sym_file] = ACTIONS(4576),
    [anon_sym_LT] = ACTIONS(4576),
    [anon_sym_GT] = ACTIONS(4576),
    [anon_sym_in] = ACTIONS(4576),
    [anon_sym_where] = ACTIONS(4576),
    [anon_sym_QMARK] = ACTIONS(4576),
    [anon_sym_notnull] = ACTIONS(4576),
    [anon_sym_unmanaged] = ACTIONS(4576),
    [anon_sym_BANG] = ACTIONS(4576),
    [anon_sym_PLUS_PLUS] = ACTIONS(4578),
    [anon_sym_DASH_DASH] = ACTIONS(4578),
    [anon_sym_PLUS] = ACTIONS(4576),
    [anon_sym_DASH] = ACTIONS(4576),
    [anon_sym_STAR] = ACTIONS(4578),
    [anon_sym_SLASH] = ACTIONS(4576),
    [anon_sym_PERCENT] = ACTIONS(4578),
    [anon_sym_CARET] = ACTIONS(4578),
    [anon_sym_PIPE] = ACTIONS(4576),
    [anon_sym_AMP] = ACTIONS(4576),
    [anon_sym_LT_LT] = ACTIONS(4578),
    [anon_sym_GT_GT] = ACTIONS(4576),
    [anon_sym_GT_GT_GT] = ACTIONS(4578),
    [anon_sym_EQ_EQ] = ACTIONS(4578),
    [anon_sym_BANG_EQ] = ACTIONS(4578),
    [anon_sym_GT_EQ] = ACTIONS(4578),
    [anon_sym_LT_EQ] = ACTIONS(4578),
    [anon_sym_DOT] = ACTIONS(4576),
    [anon_sym_scoped] = ACTIONS(4576),
    [anon_sym_EQ_GT] = ACTIONS(4578),
    [anon_sym_var] = ACTIONS(4576),
    [anon_sym_yield] = ACTIONS(4576),
    [anon_sym_switch] = ACTIONS(4576),
    [anon_sym_when] = ACTIONS(4576),
    [sym_discard] = ACTIONS(4576),
    [anon_sym_DOT_DOT] = ACTIONS(4578),
    [anon_sym_and] = ACTIONS(4576),
    [anon_sym_or] = ACTIONS(4576),
    [anon_sym_AMP_AMP] = ACTIONS(4578),
    [anon_sym_PIPE_PIPE] = ACTIONS(4578),
    [anon_sym_QMARK_QMARK] = ACTIONS(4578),
    [anon_sym_from] = ACTIONS(4576),
    [anon_sym_into] = ACTIONS(4576),
    [anon_sym_join] = ACTIONS(4576),
    [anon_sym_on] = ACTIONS(4576),
    [anon_sym_equals] = ACTIONS(4576),
    [anon_sym_let] = ACTIONS(4576),
    [anon_sym_orderby] = ACTIONS(4576),
    [anon_sym_ascending] = ACTIONS(4576),
    [anon_sym_descending] = ACTIONS(4576),
    [anon_sym_group] = ACTIONS(4576),
    [anon_sym_by] = ACTIONS(4576),
    [anon_sym_select] = ACTIONS(4576),
    [anon_sym_as] = ACTIONS(4576),
    [anon_sym_is] = ACTIONS(4576),
    [anon_sym_DASH_GT] = ACTIONS(4578),
    [anon_sym_with] = ACTIONS(4576),
    [aux_sym_preproc_if_token3] = ACTIONS(4578),
    [aux_sym_preproc_else_token1] = ACTIONS(4578),
    [aux_sym_preproc_elif_token1] = ACTIONS(4578),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2995] = {
    [sym_preproc_region] = STATE(2995),
    [sym_preproc_endregion] = STATE(2995),
    [sym_preproc_line] = STATE(2995),
    [sym_preproc_pragma] = STATE(2995),
    [sym_preproc_nullable] = STATE(2995),
    [sym_preproc_error] = STATE(2995),
    [sym_preproc_define] = STATE(2995),
    [sym_preproc_undef] = STATE(2995),
    [sym__identifier_token] = ACTIONS(4422),
    [anon_sym_alias] = ACTIONS(4422),
    [anon_sym_SEMI] = ACTIONS(4424),
    [anon_sym_global] = ACTIONS(4422),
    [anon_sym_LBRACK] = ACTIONS(4547),
    [anon_sym_COMMA] = ACTIONS(4424),
    [anon_sym_RBRACK] = ACTIONS(4424),
    [anon_sym_LPAREN] = ACTIONS(4424),
    [anon_sym_RPAREN] = ACTIONS(4424),
    [anon_sym_LBRACE] = ACTIONS(4424),
    [anon_sym_RBRACE] = ACTIONS(4424),
    [anon_sym_file] = ACTIONS(4422),
    [anon_sym_LT] = ACTIONS(4422),
    [anon_sym_GT] = ACTIONS(4422),
    [anon_sym_in] = ACTIONS(4422),
    [anon_sym_where] = ACTIONS(4422),
    [anon_sym_QMARK] = ACTIONS(4550),
    [anon_sym_notnull] = ACTIONS(4422),
    [anon_sym_unmanaged] = ACTIONS(4422),
    [anon_sym_BANG] = ACTIONS(4422),
    [anon_sym_PLUS_PLUS] = ACTIONS(4424),
    [anon_sym_DASH_DASH] = ACTIONS(4424),
    [anon_sym_PLUS] = ACTIONS(4422),
    [anon_sym_DASH] = ACTIONS(4422),
    [anon_sym_STAR] = ACTIONS(4553),
    [anon_sym_SLASH] = ACTIONS(4422),
    [anon_sym_PERCENT] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4424),
    [anon_sym_PIPE] = ACTIONS(4422),
    [anon_sym_AMP] = ACTIONS(4422),
    [anon_sym_LT_LT] = ACTIONS(4424),
    [anon_sym_GT_GT] = ACTIONS(4422),
    [anon_sym_GT_GT_GT] = ACTIONS(4424),
    [anon_sym_EQ_EQ] = ACTIONS(4424),
    [anon_sym_BANG_EQ] = ACTIONS(4424),
    [anon_sym_GT_EQ] = ACTIONS(4424),
    [anon_sym_LT_EQ] = ACTIONS(4424),
    [anon_sym_DOT] = ACTIONS(4602),
    [anon_sym_scoped] = ACTIONS(4422),
    [anon_sym_EQ_GT] = ACTIONS(4424),
    [anon_sym_var] = ACTIONS(4422),
    [anon_sym_yield] = ACTIONS(4422),
    [anon_sym_switch] = ACTIONS(4422),
    [anon_sym_when] = ACTIONS(4422),
    [sym_discard] = ACTIONS(4422),
    [anon_sym_DOT_DOT] = ACTIONS(4424),
    [anon_sym_and] = ACTIONS(4422),
    [anon_sym_or] = ACTIONS(4422),
    [anon_sym_AMP_AMP] = ACTIONS(4424),
    [anon_sym_PIPE_PIPE] = ACTIONS(4424),
    [anon_sym_QMARK_QMARK] = ACTIONS(4424),
    [anon_sym_from] = ACTIONS(4422),
    [anon_sym_into] = ACTIONS(4422),
    [anon_sym_join] = ACTIONS(4422),
    [anon_sym_on] = ACTIONS(4422),
    [anon_sym_equals] = ACTIONS(4422),
    [anon_sym_let] = ACTIONS(4422),
    [anon_sym_orderby] = ACTIONS(4422),
    [anon_sym_ascending] = ACTIONS(4422),
    [anon_sym_descending] = ACTIONS(4422),
    [anon_sym_group] = ACTIONS(4422),
    [anon_sym_by] = ACTIONS(4422),
    [anon_sym_select] = ACTIONS(4422),
    [anon_sym_as] = ACTIONS(4422),
    [anon_sym_is] = ACTIONS(4422),
    [anon_sym_DASH_GT] = ACTIONS(4562),
    [anon_sym_with] = ACTIONS(4422),
    [aux_sym_preproc_if_token3] = ACTIONS(4424),
    [aux_sym_preproc_else_token1] = ACTIONS(4424),
    [aux_sym_preproc_elif_token1] = ACTIONS(4424),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2996] = {
    [sym_preproc_region] = STATE(2996),
    [sym_preproc_endregion] = STATE(2996),
    [sym_preproc_line] = STATE(2996),
    [sym_preproc_pragma] = STATE(2996),
    [sym_preproc_nullable] = STATE(2996),
    [sym_preproc_error] = STATE(2996),
    [sym_preproc_define] = STATE(2996),
    [sym_preproc_undef] = STATE(2996),
    [anon_sym_SEMI] = ACTIONS(4604),
    [anon_sym_EQ] = ACTIONS(4606),
    [anon_sym_LBRACK] = ACTIONS(4604),
    [anon_sym_COLON] = ACTIONS(4604),
    [anon_sym_COMMA] = ACTIONS(4604),
    [anon_sym_RBRACK] = ACTIONS(4604),
    [anon_sym_LPAREN] = ACTIONS(4604),
    [anon_sym_RPAREN] = ACTIONS(4604),
    [anon_sym_RBRACE] = ACTIONS(4604),
    [anon_sym_LT] = ACTIONS(4606),
    [anon_sym_GT] = ACTIONS(4606),
    [anon_sym_in] = ACTIONS(4606),
    [anon_sym_where] = ACTIONS(4604),
    [anon_sym_QMARK] = ACTIONS(4606),
    [anon_sym_BANG] = ACTIONS(4606),
    [anon_sym_PLUS_PLUS] = ACTIONS(4604),
    [anon_sym_DASH_DASH] = ACTIONS(4604),
    [anon_sym_PLUS] = ACTIONS(4606),
    [anon_sym_DASH] = ACTIONS(4606),
    [anon_sym_STAR] = ACTIONS(4606),
    [anon_sym_SLASH] = ACTIONS(4606),
    [anon_sym_PERCENT] = ACTIONS(4606),
    [anon_sym_CARET] = ACTIONS(4606),
    [anon_sym_PIPE] = ACTIONS(4606),
    [anon_sym_AMP] = ACTIONS(4606),
    [anon_sym_LT_LT] = ACTIONS(4606),
    [anon_sym_GT_GT] = ACTIONS(4606),
    [anon_sym_GT_GT_GT] = ACTIONS(4606),
    [anon_sym_EQ_EQ] = ACTIONS(4604),
    [anon_sym_BANG_EQ] = ACTIONS(4604),
    [anon_sym_GT_EQ] = ACTIONS(4604),
    [anon_sym_LT_EQ] = ACTIONS(4604),
    [anon_sym_DOT] = ACTIONS(4606),
    [anon_sym_EQ_GT] = ACTIONS(4604),
    [anon_sym_switch] = ACTIONS(4604),
    [anon_sym_DOT_DOT] = ACTIONS(4604),
    [anon_sym_and] = ACTIONS(4604),
    [anon_sym_or] = ACTIONS(4606),
    [anon_sym_PLUS_EQ] = ACTIONS(4604),
    [anon_sym_DASH_EQ] = ACTIONS(4604),
    [anon_sym_STAR_EQ] = ACTIONS(4604),
    [anon_sym_SLASH_EQ] = ACTIONS(4604),
    [anon_sym_PERCENT_EQ] = ACTIONS(4604),
    [anon_sym_AMP_EQ] = ACTIONS(4604),
    [anon_sym_CARET_EQ] = ACTIONS(4604),
    [anon_sym_PIPE_EQ] = ACTIONS(4604),
    [anon_sym_LT_LT_EQ] = ACTIONS(4604),
    [anon_sym_GT_GT_EQ] = ACTIONS(4604),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4604),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4604),
    [anon_sym_AMP_AMP] = ACTIONS(4604),
    [anon_sym_PIPE_PIPE] = ACTIONS(4604),
    [anon_sym_QMARK_QMARK] = ACTIONS(4606),
    [anon_sym_from] = ACTIONS(4604),
    [anon_sym_into] = ACTIONS(4604),
    [anon_sym_join] = ACTIONS(4604),
    [anon_sym_on] = ACTIONS(4604),
    [anon_sym_equals] = ACTIONS(4604),
    [anon_sym_let] = ACTIONS(4604),
    [anon_sym_orderby] = ACTIONS(4604),
    [anon_sym_group] = ACTIONS(4604),
    [anon_sym_by] = ACTIONS(4604),
    [anon_sym_select] = ACTIONS(4604),
    [anon_sym_as] = ACTIONS(4604),
    [anon_sym_is] = ACTIONS(4604),
    [anon_sym_DASH_GT] = ACTIONS(4604),
    [anon_sym_with] = ACTIONS(4604),
    [aux_sym_preproc_if_token3] = ACTIONS(4604),
    [aux_sym_preproc_else_token1] = ACTIONS(4604),
    [aux_sym_preproc_elif_token1] = ACTIONS(4604),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2997] = {
    [sym_preproc_region] = STATE(2997),
    [sym_preproc_endregion] = STATE(2997),
    [sym_preproc_line] = STATE(2997),
    [sym_preproc_pragma] = STATE(2997),
    [sym_preproc_nullable] = STATE(2997),
    [sym_preproc_error] = STATE(2997),
    [sym_preproc_define] = STATE(2997),
    [sym_preproc_undef] = STATE(2997),
    [sym__identifier_token] = ACTIONS(4422),
    [anon_sym_alias] = ACTIONS(4422),
    [anon_sym_SEMI] = ACTIONS(4424),
    [anon_sym_global] = ACTIONS(4422),
    [anon_sym_LBRACK] = ACTIONS(4547),
    [anon_sym_COMMA] = ACTIONS(4424),
    [anon_sym_RBRACK] = ACTIONS(4424),
    [anon_sym_LPAREN] = ACTIONS(4424),
    [anon_sym_RPAREN] = ACTIONS(4424),
    [anon_sym_LBRACE] = ACTIONS(4424),
    [anon_sym_RBRACE] = ACTIONS(4424),
    [anon_sym_file] = ACTIONS(4422),
    [anon_sym_LT] = ACTIONS(4422),
    [anon_sym_GT] = ACTIONS(4422),
    [anon_sym_in] = ACTIONS(4422),
    [anon_sym_where] = ACTIONS(4422),
    [anon_sym_QMARK] = ACTIONS(4550),
    [anon_sym_notnull] = ACTIONS(4422),
    [anon_sym_unmanaged] = ACTIONS(4422),
    [anon_sym_BANG] = ACTIONS(4422),
    [anon_sym_PLUS_PLUS] = ACTIONS(4424),
    [anon_sym_DASH_DASH] = ACTIONS(4424),
    [anon_sym_PLUS] = ACTIONS(4422),
    [anon_sym_DASH] = ACTIONS(4422),
    [anon_sym_STAR] = ACTIONS(4553),
    [anon_sym_SLASH] = ACTIONS(4422),
    [anon_sym_PERCENT] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4424),
    [anon_sym_PIPE] = ACTIONS(4422),
    [anon_sym_AMP] = ACTIONS(4422),
    [anon_sym_LT_LT] = ACTIONS(4424),
    [anon_sym_GT_GT] = ACTIONS(4422),
    [anon_sym_GT_GT_GT] = ACTIONS(4424),
    [anon_sym_EQ_EQ] = ACTIONS(4424),
    [anon_sym_BANG_EQ] = ACTIONS(4424),
    [anon_sym_GT_EQ] = ACTIONS(4424),
    [anon_sym_LT_EQ] = ACTIONS(4424),
    [anon_sym_DOT] = ACTIONS(4608),
    [anon_sym_scoped] = ACTIONS(4422),
    [anon_sym_EQ_GT] = ACTIONS(4424),
    [anon_sym_var] = ACTIONS(4422),
    [anon_sym_yield] = ACTIONS(4422),
    [anon_sym_switch] = ACTIONS(4422),
    [anon_sym_when] = ACTIONS(4422),
    [sym_discard] = ACTIONS(4422),
    [anon_sym_DOT_DOT] = ACTIONS(4424),
    [anon_sym_and] = ACTIONS(4422),
    [anon_sym_or] = ACTIONS(4422),
    [anon_sym_AMP_AMP] = ACTIONS(4424),
    [anon_sym_PIPE_PIPE] = ACTIONS(4424),
    [anon_sym_QMARK_QMARK] = ACTIONS(4424),
    [anon_sym_from] = ACTIONS(4422),
    [anon_sym_into] = ACTIONS(4422),
    [anon_sym_join] = ACTIONS(4422),
    [anon_sym_on] = ACTIONS(4422),
    [anon_sym_equals] = ACTIONS(4422),
    [anon_sym_let] = ACTIONS(4422),
    [anon_sym_orderby] = ACTIONS(4422),
    [anon_sym_ascending] = ACTIONS(4422),
    [anon_sym_descending] = ACTIONS(4422),
    [anon_sym_group] = ACTIONS(4422),
    [anon_sym_by] = ACTIONS(4422),
    [anon_sym_select] = ACTIONS(4422),
    [anon_sym_as] = ACTIONS(4422),
    [anon_sym_is] = ACTIONS(4422),
    [anon_sym_DASH_GT] = ACTIONS(4562),
    [anon_sym_with] = ACTIONS(4422),
    [aux_sym_preproc_if_token3] = ACTIONS(4424),
    [aux_sym_preproc_else_token1] = ACTIONS(4424),
    [aux_sym_preproc_elif_token1] = ACTIONS(4424),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2998] = {
    [sym_preproc_region] = STATE(2998),
    [sym_preproc_endregion] = STATE(2998),
    [sym_preproc_line] = STATE(2998),
    [sym_preproc_pragma] = STATE(2998),
    [sym_preproc_nullable] = STATE(2998),
    [sym_preproc_error] = STATE(2998),
    [sym_preproc_define] = STATE(2998),
    [sym_preproc_undef] = STATE(2998),
    [anon_sym_SEMI] = ACTIONS(4087),
    [anon_sym_EQ] = ACTIONS(4085),
    [anon_sym_LBRACK] = ACTIONS(4087),
    [anon_sym_COLON] = ACTIONS(4087),
    [anon_sym_COMMA] = ACTIONS(4087),
    [anon_sym_RBRACK] = ACTIONS(4087),
    [anon_sym_LPAREN] = ACTIONS(4087),
    [anon_sym_RPAREN] = ACTIONS(4087),
    [anon_sym_RBRACE] = ACTIONS(4087),
    [anon_sym_LT] = ACTIONS(4085),
    [anon_sym_GT] = ACTIONS(4085),
    [anon_sym_in] = ACTIONS(4085),
    [anon_sym_where] = ACTIONS(4087),
    [anon_sym_QMARK] = ACTIONS(4085),
    [anon_sym_BANG] = ACTIONS(4085),
    [anon_sym_PLUS_PLUS] = ACTIONS(4087),
    [anon_sym_DASH_DASH] = ACTIONS(4087),
    [anon_sym_PLUS] = ACTIONS(4085),
    [anon_sym_DASH] = ACTIONS(4085),
    [anon_sym_STAR] = ACTIONS(4085),
    [anon_sym_SLASH] = ACTIONS(4085),
    [anon_sym_PERCENT] = ACTIONS(4085),
    [anon_sym_CARET] = ACTIONS(4085),
    [anon_sym_PIPE] = ACTIONS(4085),
    [anon_sym_AMP] = ACTIONS(4085),
    [anon_sym_LT_LT] = ACTIONS(4085),
    [anon_sym_GT_GT] = ACTIONS(4085),
    [anon_sym_GT_GT_GT] = ACTIONS(4085),
    [anon_sym_EQ_EQ] = ACTIONS(4087),
    [anon_sym_BANG_EQ] = ACTIONS(4087),
    [anon_sym_GT_EQ] = ACTIONS(4087),
    [anon_sym_LT_EQ] = ACTIONS(4087),
    [anon_sym_DOT] = ACTIONS(4085),
    [anon_sym_EQ_GT] = ACTIONS(4087),
    [anon_sym_switch] = ACTIONS(4087),
    [anon_sym_DOT_DOT] = ACTIONS(4087),
    [anon_sym_and] = ACTIONS(4087),
    [anon_sym_or] = ACTIONS(4085),
    [anon_sym_PLUS_EQ] = ACTIONS(4087),
    [anon_sym_DASH_EQ] = ACTIONS(4087),
    [anon_sym_STAR_EQ] = ACTIONS(4087),
    [anon_sym_SLASH_EQ] = ACTIONS(4087),
    [anon_sym_PERCENT_EQ] = ACTIONS(4087),
    [anon_sym_AMP_EQ] = ACTIONS(4087),
    [anon_sym_CARET_EQ] = ACTIONS(4087),
    [anon_sym_PIPE_EQ] = ACTIONS(4087),
    [anon_sym_LT_LT_EQ] = ACTIONS(4087),
    [anon_sym_GT_GT_EQ] = ACTIONS(4087),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4087),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4087),
    [anon_sym_AMP_AMP] = ACTIONS(4087),
    [anon_sym_PIPE_PIPE] = ACTIONS(4087),
    [anon_sym_QMARK_QMARK] = ACTIONS(4085),
    [anon_sym_from] = ACTIONS(4087),
    [anon_sym_into] = ACTIONS(4087),
    [anon_sym_join] = ACTIONS(4087),
    [anon_sym_on] = ACTIONS(4087),
    [anon_sym_equals] = ACTIONS(4087),
    [anon_sym_let] = ACTIONS(4087),
    [anon_sym_orderby] = ACTIONS(4087),
    [anon_sym_group] = ACTIONS(4087),
    [anon_sym_by] = ACTIONS(4087),
    [anon_sym_select] = ACTIONS(4087),
    [anon_sym_as] = ACTIONS(4087),
    [anon_sym_is] = ACTIONS(4087),
    [anon_sym_DASH_GT] = ACTIONS(4087),
    [anon_sym_with] = ACTIONS(4087),
    [aux_sym_preproc_if_token3] = ACTIONS(4087),
    [aux_sym_preproc_else_token1] = ACTIONS(4087),
    [aux_sym_preproc_elif_token1] = ACTIONS(4087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2999] = {
    [sym__name] = STATE(3768),
    [sym_alias_qualified_name] = STATE(3635),
    [sym__simple_name] = STATE(3635),
    [sym_qualified_name] = STATE(3635),
    [sym_generic_name] = STATE(3708),
    [sym_ref_type] = STATE(3636),
    [sym__scoped_base_type] = STATE(3641),
    [sym_identifier] = STATE(3590),
    [sym__reserved_identifier] = STATE(3568),
    [sym_preproc_region] = STATE(2999),
    [sym_preproc_endregion] = STATE(2999),
    [sym_preproc_line] = STATE(2999),
    [sym_preproc_pragma] = STATE(2999),
    [sym_preproc_nullable] = STATE(2999),
    [sym_preproc_error] = STATE(2999),
    [sym_preproc_define] = STATE(2999),
    [sym_preproc_undef] = STATE(2999),
    [sym__identifier_token] = ACTIONS(4287),
    [anon_sym_alias] = ACTIONS(4289),
    [anon_sym_global] = ACTIONS(4289),
    [anon_sym_LBRACK] = ACTIONS(3719),
    [anon_sym_LPAREN] = ACTIONS(3719),
    [anon_sym_ref] = ACTIONS(4610),
    [anon_sym_LBRACE] = ACTIONS(3719),
    [anon_sym_file] = ACTIONS(4289),
    [anon_sym_LT] = ACTIONS(3721),
    [anon_sym_GT] = ACTIONS(3721),
    [anon_sym_where] = ACTIONS(4612),
    [anon_sym_QMARK] = ACTIONS(3721),
    [anon_sym_notnull] = ACTIONS(4289),
    [anon_sym_unmanaged] = ACTIONS(4289),
    [anon_sym_BANG] = ACTIONS(3721),
    [anon_sym_PLUS_PLUS] = ACTIONS(3719),
    [anon_sym_DASH_DASH] = ACTIONS(3719),
    [anon_sym_PLUS] = ACTIONS(3721),
    [anon_sym_DASH] = ACTIONS(3721),
    [anon_sym_STAR] = ACTIONS(3719),
    [anon_sym_SLASH] = ACTIONS(3721),
    [anon_sym_PERCENT] = ACTIONS(3719),
    [anon_sym_CARET] = ACTIONS(3719),
    [anon_sym_PIPE] = ACTIONS(3721),
    [anon_sym_AMP] = ACTIONS(3721),
    [anon_sym_LT_LT] = ACTIONS(3719),
    [anon_sym_GT_GT] = ACTIONS(3721),
    [anon_sym_GT_GT_GT] = ACTIONS(3719),
    [anon_sym_EQ_EQ] = ACTIONS(3719),
    [anon_sym_BANG_EQ] = ACTIONS(3719),
    [anon_sym_GT_EQ] = ACTIONS(3719),
    [anon_sym_LT_EQ] = ACTIONS(3719),
    [anon_sym_DOT] = ACTIONS(3721),
    [anon_sym_scoped] = ACTIONS(4289),
    [anon_sym_COLON_COLON] = ACTIONS(3719),
    [anon_sym_var] = ACTIONS(4289),
    [anon_sym_yield] = ACTIONS(4289),
    [anon_sym_switch] = ACTIONS(3721),
    [anon_sym_when] = ACTIONS(4289),
    [anon_sym_DOT_DOT] = ACTIONS(3719),
    [anon_sym_and] = ACTIONS(3721),
    [anon_sym_or] = ACTIONS(3721),
    [anon_sym_AMP_AMP] = ACTIONS(3719),
    [anon_sym_PIPE_PIPE] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK] = ACTIONS(3719),
    [anon_sym_from] = ACTIONS(4612),
    [anon_sym_into] = ACTIONS(4289),
    [anon_sym_join] = ACTIONS(4612),
    [anon_sym_on] = ACTIONS(4289),
    [anon_sym_equals] = ACTIONS(4289),
    [anon_sym_let] = ACTIONS(4612),
    [anon_sym_orderby] = ACTIONS(4612),
    [anon_sym_ascending] = ACTIONS(4289),
    [anon_sym_descending] = ACTIONS(4289),
    [anon_sym_group] = ACTIONS(4612),
    [anon_sym_by] = ACTIONS(4289),
    [anon_sym_select] = ACTIONS(4612),
    [anon_sym_as] = ACTIONS(3721),
    [anon_sym_is] = ACTIONS(3721),
    [anon_sym_DASH_GT] = ACTIONS(3719),
    [anon_sym_with] = ACTIONS(3721),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3000] = {
    [sym_preproc_region] = STATE(3000),
    [sym_preproc_endregion] = STATE(3000),
    [sym_preproc_line] = STATE(3000),
    [sym_preproc_pragma] = STATE(3000),
    [sym_preproc_nullable] = STATE(3000),
    [sym_preproc_error] = STATE(3000),
    [sym_preproc_define] = STATE(3000),
    [sym_preproc_undef] = STATE(3000),
    [anon_sym_SEMI] = ACTIONS(4615),
    [anon_sym_EQ] = ACTIONS(4617),
    [anon_sym_LBRACK] = ACTIONS(4615),
    [anon_sym_COLON] = ACTIONS(4615),
    [anon_sym_COMMA] = ACTIONS(4615),
    [anon_sym_RBRACK] = ACTIONS(4615),
    [anon_sym_LPAREN] = ACTIONS(4615),
    [anon_sym_RPAREN] = ACTIONS(4615),
    [anon_sym_RBRACE] = ACTIONS(4615),
    [anon_sym_LT] = ACTIONS(4617),
    [anon_sym_GT] = ACTIONS(4617),
    [anon_sym_in] = ACTIONS(4617),
    [anon_sym_where] = ACTIONS(4615),
    [anon_sym_QMARK] = ACTIONS(4617),
    [anon_sym_BANG] = ACTIONS(4617),
    [anon_sym_PLUS_PLUS] = ACTIONS(4615),
    [anon_sym_DASH_DASH] = ACTIONS(4615),
    [anon_sym_PLUS] = ACTIONS(4617),
    [anon_sym_DASH] = ACTIONS(4617),
    [anon_sym_STAR] = ACTIONS(4617),
    [anon_sym_SLASH] = ACTIONS(4617),
    [anon_sym_PERCENT] = ACTIONS(4617),
    [anon_sym_CARET] = ACTIONS(4617),
    [anon_sym_PIPE] = ACTIONS(4617),
    [anon_sym_AMP] = ACTIONS(4617),
    [anon_sym_LT_LT] = ACTIONS(4617),
    [anon_sym_GT_GT] = ACTIONS(4617),
    [anon_sym_GT_GT_GT] = ACTIONS(4617),
    [anon_sym_EQ_EQ] = ACTIONS(4615),
    [anon_sym_BANG_EQ] = ACTIONS(4615),
    [anon_sym_GT_EQ] = ACTIONS(4615),
    [anon_sym_LT_EQ] = ACTIONS(4615),
    [anon_sym_DOT] = ACTIONS(4617),
    [anon_sym_EQ_GT] = ACTIONS(4615),
    [anon_sym_switch] = ACTIONS(4615),
    [anon_sym_DOT_DOT] = ACTIONS(4615),
    [anon_sym_and] = ACTIONS(4615),
    [anon_sym_or] = ACTIONS(4617),
    [anon_sym_PLUS_EQ] = ACTIONS(4615),
    [anon_sym_DASH_EQ] = ACTIONS(4615),
    [anon_sym_STAR_EQ] = ACTIONS(4615),
    [anon_sym_SLASH_EQ] = ACTIONS(4615),
    [anon_sym_PERCENT_EQ] = ACTIONS(4615),
    [anon_sym_AMP_EQ] = ACTIONS(4615),
    [anon_sym_CARET_EQ] = ACTIONS(4615),
    [anon_sym_PIPE_EQ] = ACTIONS(4615),
    [anon_sym_LT_LT_EQ] = ACTIONS(4615),
    [anon_sym_GT_GT_EQ] = ACTIONS(4615),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4615),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4615),
    [anon_sym_AMP_AMP] = ACTIONS(4615),
    [anon_sym_PIPE_PIPE] = ACTIONS(4615),
    [anon_sym_QMARK_QMARK] = ACTIONS(4617),
    [anon_sym_from] = ACTIONS(4615),
    [anon_sym_into] = ACTIONS(4615),
    [anon_sym_join] = ACTIONS(4615),
    [anon_sym_on] = ACTIONS(4615),
    [anon_sym_equals] = ACTIONS(4615),
    [anon_sym_let] = ACTIONS(4615),
    [anon_sym_orderby] = ACTIONS(4615),
    [anon_sym_group] = ACTIONS(4615),
    [anon_sym_by] = ACTIONS(4615),
    [anon_sym_select] = ACTIONS(4615),
    [anon_sym_as] = ACTIONS(4615),
    [anon_sym_is] = ACTIONS(4615),
    [anon_sym_DASH_GT] = ACTIONS(4615),
    [anon_sym_with] = ACTIONS(4615),
    [aux_sym_preproc_if_token3] = ACTIONS(4615),
    [aux_sym_preproc_else_token1] = ACTIONS(4615),
    [aux_sym_preproc_elif_token1] = ACTIONS(4615),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3001] = {
    [sym__name] = STATE(4267),
    [sym_alias_qualified_name] = STATE(3955),
    [sym__simple_name] = STATE(3955),
    [sym_qualified_name] = STATE(3955),
    [sym_generic_name] = STATE(4047),
    [sym_ref_type] = STATE(4040),
    [sym__scoped_base_type] = STATE(4036),
    [sym_identifier] = STATE(3891),
    [sym__reserved_identifier] = STATE(3897),
    [sym_preproc_region] = STATE(3001),
    [sym_preproc_endregion] = STATE(3001),
    [sym_preproc_line] = STATE(3001),
    [sym_preproc_pragma] = STATE(3001),
    [sym_preproc_nullable] = STATE(3001),
    [sym_preproc_error] = STATE(3001),
    [sym_preproc_define] = STATE(3001),
    [sym_preproc_undef] = STATE(3001),
    [sym__identifier_token] = ACTIONS(4168),
    [anon_sym_alias] = ACTIONS(4170),
    [anon_sym_global] = ACTIONS(4170),
    [anon_sym_LBRACK] = ACTIONS(3719),
    [anon_sym_LPAREN] = ACTIONS(3719),
    [anon_sym_ref] = ACTIONS(4619),
    [anon_sym_LBRACE] = ACTIONS(3719),
    [anon_sym_file] = ACTIONS(4170),
    [anon_sym_LT] = ACTIONS(3721),
    [anon_sym_GT] = ACTIONS(3721),
    [anon_sym_where] = ACTIONS(4170),
    [anon_sym_QMARK] = ACTIONS(3721),
    [anon_sym_notnull] = ACTIONS(4170),
    [anon_sym_unmanaged] = ACTIONS(4170),
    [anon_sym_BANG] = ACTIONS(3721),
    [anon_sym_PLUS_PLUS] = ACTIONS(3719),
    [anon_sym_DASH_DASH] = ACTIONS(3719),
    [anon_sym_PLUS] = ACTIONS(3721),
    [anon_sym_DASH] = ACTIONS(3721),
    [anon_sym_STAR] = ACTIONS(3719),
    [anon_sym_SLASH] = ACTIONS(3721),
    [anon_sym_PERCENT] = ACTIONS(3719),
    [anon_sym_CARET] = ACTIONS(3719),
    [anon_sym_PIPE] = ACTIONS(3721),
    [anon_sym_AMP] = ACTIONS(3721),
    [anon_sym_LT_LT] = ACTIONS(3719),
    [anon_sym_GT_GT] = ACTIONS(3721),
    [anon_sym_GT_GT_GT] = ACTIONS(3719),
    [anon_sym_EQ_EQ] = ACTIONS(3719),
    [anon_sym_BANG_EQ] = ACTIONS(3719),
    [anon_sym_GT_EQ] = ACTIONS(3719),
    [anon_sym_LT_EQ] = ACTIONS(3719),
    [anon_sym_DOT] = ACTIONS(3721),
    [anon_sym_scoped] = ACTIONS(4170),
    [anon_sym_COLON_COLON] = ACTIONS(3719),
    [anon_sym_var] = ACTIONS(4170),
    [anon_sym_yield] = ACTIONS(4170),
    [anon_sym_switch] = ACTIONS(3721),
    [anon_sym_when] = ACTIONS(4170),
    [anon_sym_DOT_DOT] = ACTIONS(3719),
    [anon_sym_and] = ACTIONS(3721),
    [anon_sym_or] = ACTIONS(3721),
    [anon_sym_AMP_AMP] = ACTIONS(3719),
    [anon_sym_PIPE_PIPE] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK] = ACTIONS(3719),
    [anon_sym_from] = ACTIONS(4170),
    [anon_sym_into] = ACTIONS(4170),
    [anon_sym_join] = ACTIONS(4170),
    [anon_sym_on] = ACTIONS(4170),
    [anon_sym_equals] = ACTIONS(4170),
    [anon_sym_let] = ACTIONS(4170),
    [anon_sym_orderby] = ACTIONS(4170),
    [anon_sym_ascending] = ACTIONS(4170),
    [anon_sym_descending] = ACTIONS(4170),
    [anon_sym_group] = ACTIONS(4170),
    [anon_sym_by] = ACTIONS(4467),
    [anon_sym_select] = ACTIONS(4170),
    [anon_sym_as] = ACTIONS(3721),
    [anon_sym_is] = ACTIONS(3721),
    [anon_sym_DASH_GT] = ACTIONS(3719),
    [anon_sym_with] = ACTIONS(3721),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3002] = {
    [sym_preproc_region] = STATE(3002),
    [sym_preproc_endregion] = STATE(3002),
    [sym_preproc_line] = STATE(3002),
    [sym_preproc_pragma] = STATE(3002),
    [sym_preproc_nullable] = STATE(3002),
    [sym_preproc_error] = STATE(3002),
    [sym_preproc_define] = STATE(3002),
    [sym_preproc_undef] = STATE(3002),
    [sym__identifier_token] = ACTIONS(4422),
    [anon_sym_alias] = ACTIONS(4422),
    [anon_sym_SEMI] = ACTIONS(4424),
    [anon_sym_global] = ACTIONS(4422),
    [anon_sym_LBRACK] = ACTIONS(4547),
    [anon_sym_COMMA] = ACTIONS(4424),
    [anon_sym_RBRACK] = ACTIONS(4424),
    [anon_sym_LPAREN] = ACTIONS(4424),
    [anon_sym_RPAREN] = ACTIONS(4424),
    [anon_sym_LBRACE] = ACTIONS(4424),
    [anon_sym_RBRACE] = ACTIONS(4424),
    [anon_sym_file] = ACTIONS(4422),
    [anon_sym_LT] = ACTIONS(4422),
    [anon_sym_GT] = ACTIONS(4422),
    [anon_sym_in] = ACTIONS(4422),
    [anon_sym_where] = ACTIONS(4422),
    [anon_sym_QMARK] = ACTIONS(4550),
    [anon_sym_notnull] = ACTIONS(4422),
    [anon_sym_unmanaged] = ACTIONS(4422),
    [anon_sym_BANG] = ACTIONS(4422),
    [anon_sym_PLUS_PLUS] = ACTIONS(4424),
    [anon_sym_DASH_DASH] = ACTIONS(4424),
    [anon_sym_PLUS] = ACTIONS(4422),
    [anon_sym_DASH] = ACTIONS(4422),
    [anon_sym_STAR] = ACTIONS(4553),
    [anon_sym_SLASH] = ACTIONS(4422),
    [anon_sym_PERCENT] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4424),
    [anon_sym_PIPE] = ACTIONS(4422),
    [anon_sym_AMP] = ACTIONS(4422),
    [anon_sym_LT_LT] = ACTIONS(4424),
    [anon_sym_GT_GT] = ACTIONS(4422),
    [anon_sym_GT_GT_GT] = ACTIONS(4424),
    [anon_sym_EQ_EQ] = ACTIONS(4424),
    [anon_sym_BANG_EQ] = ACTIONS(4424),
    [anon_sym_GT_EQ] = ACTIONS(4424),
    [anon_sym_LT_EQ] = ACTIONS(4424),
    [anon_sym_DOT] = ACTIONS(4621),
    [anon_sym_scoped] = ACTIONS(4422),
    [anon_sym_EQ_GT] = ACTIONS(4424),
    [anon_sym_var] = ACTIONS(4422),
    [anon_sym_yield] = ACTIONS(4422),
    [anon_sym_switch] = ACTIONS(4422),
    [anon_sym_when] = ACTIONS(4422),
    [sym_discard] = ACTIONS(4422),
    [anon_sym_DOT_DOT] = ACTIONS(4424),
    [anon_sym_and] = ACTIONS(4422),
    [anon_sym_or] = ACTIONS(4422),
    [anon_sym_AMP_AMP] = ACTIONS(4424),
    [anon_sym_PIPE_PIPE] = ACTIONS(4424),
    [anon_sym_QMARK_QMARK] = ACTIONS(4424),
    [anon_sym_from] = ACTIONS(4422),
    [anon_sym_into] = ACTIONS(4422),
    [anon_sym_join] = ACTIONS(4422),
    [anon_sym_on] = ACTIONS(4422),
    [anon_sym_equals] = ACTIONS(4422),
    [anon_sym_let] = ACTIONS(4422),
    [anon_sym_orderby] = ACTIONS(4422),
    [anon_sym_ascending] = ACTIONS(4422),
    [anon_sym_descending] = ACTIONS(4422),
    [anon_sym_group] = ACTIONS(4422),
    [anon_sym_by] = ACTIONS(4422),
    [anon_sym_select] = ACTIONS(4422),
    [anon_sym_as] = ACTIONS(4422),
    [anon_sym_is] = ACTIONS(4422),
    [anon_sym_DASH_GT] = ACTIONS(4424),
    [anon_sym_with] = ACTIONS(4422),
    [aux_sym_preproc_if_token3] = ACTIONS(4424),
    [aux_sym_preproc_else_token1] = ACTIONS(4424),
    [aux_sym_preproc_elif_token1] = ACTIONS(4424),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3003] = {
    [sym_preproc_region] = STATE(3003),
    [sym_preproc_endregion] = STATE(3003),
    [sym_preproc_line] = STATE(3003),
    [sym_preproc_pragma] = STATE(3003),
    [sym_preproc_nullable] = STATE(3003),
    [sym_preproc_error] = STATE(3003),
    [sym_preproc_define] = STATE(3003),
    [sym_preproc_undef] = STATE(3003),
    [anon_sym_SEMI] = ACTIONS(4623),
    [anon_sym_EQ] = ACTIONS(4625),
    [anon_sym_LBRACK] = ACTIONS(4623),
    [anon_sym_COLON] = ACTIONS(4623),
    [anon_sym_COMMA] = ACTIONS(4623),
    [anon_sym_RBRACK] = ACTIONS(4623),
    [anon_sym_LPAREN] = ACTIONS(4623),
    [anon_sym_RPAREN] = ACTIONS(4623),
    [anon_sym_RBRACE] = ACTIONS(4623),
    [anon_sym_LT] = ACTIONS(4625),
    [anon_sym_GT] = ACTIONS(4625),
    [anon_sym_in] = ACTIONS(4625),
    [anon_sym_where] = ACTIONS(4623),
    [anon_sym_QMARK] = ACTIONS(4625),
    [anon_sym_BANG] = ACTIONS(4625),
    [anon_sym_PLUS_PLUS] = ACTIONS(4623),
    [anon_sym_DASH_DASH] = ACTIONS(4623),
    [anon_sym_PLUS] = ACTIONS(4625),
    [anon_sym_DASH] = ACTIONS(4625),
    [anon_sym_STAR] = ACTIONS(4625),
    [anon_sym_SLASH] = ACTIONS(4625),
    [anon_sym_PERCENT] = ACTIONS(4625),
    [anon_sym_CARET] = ACTIONS(4625),
    [anon_sym_PIPE] = ACTIONS(4625),
    [anon_sym_AMP] = ACTIONS(4625),
    [anon_sym_LT_LT] = ACTIONS(4625),
    [anon_sym_GT_GT] = ACTIONS(4625),
    [anon_sym_GT_GT_GT] = ACTIONS(4625),
    [anon_sym_EQ_EQ] = ACTIONS(4623),
    [anon_sym_BANG_EQ] = ACTIONS(4623),
    [anon_sym_GT_EQ] = ACTIONS(4623),
    [anon_sym_LT_EQ] = ACTIONS(4623),
    [anon_sym_DOT] = ACTIONS(4625),
    [anon_sym_EQ_GT] = ACTIONS(4623),
    [anon_sym_switch] = ACTIONS(4623),
    [anon_sym_DOT_DOT] = ACTIONS(4623),
    [anon_sym_and] = ACTIONS(4623),
    [anon_sym_or] = ACTIONS(4625),
    [anon_sym_PLUS_EQ] = ACTIONS(4623),
    [anon_sym_DASH_EQ] = ACTIONS(4623),
    [anon_sym_STAR_EQ] = ACTIONS(4623),
    [anon_sym_SLASH_EQ] = ACTIONS(4623),
    [anon_sym_PERCENT_EQ] = ACTIONS(4623),
    [anon_sym_AMP_EQ] = ACTIONS(4623),
    [anon_sym_CARET_EQ] = ACTIONS(4623),
    [anon_sym_PIPE_EQ] = ACTIONS(4623),
    [anon_sym_LT_LT_EQ] = ACTIONS(4623),
    [anon_sym_GT_GT_EQ] = ACTIONS(4623),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4623),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4623),
    [anon_sym_AMP_AMP] = ACTIONS(4623),
    [anon_sym_PIPE_PIPE] = ACTIONS(4623),
    [anon_sym_QMARK_QMARK] = ACTIONS(4625),
    [anon_sym_from] = ACTIONS(4623),
    [anon_sym_into] = ACTIONS(4623),
    [anon_sym_join] = ACTIONS(4623),
    [anon_sym_on] = ACTIONS(4623),
    [anon_sym_equals] = ACTIONS(4623),
    [anon_sym_let] = ACTIONS(4623),
    [anon_sym_orderby] = ACTIONS(4623),
    [anon_sym_group] = ACTIONS(4623),
    [anon_sym_by] = ACTIONS(4623),
    [anon_sym_select] = ACTIONS(4623),
    [anon_sym_as] = ACTIONS(4623),
    [anon_sym_is] = ACTIONS(4623),
    [anon_sym_DASH_GT] = ACTIONS(4623),
    [anon_sym_with] = ACTIONS(4623),
    [aux_sym_preproc_if_token3] = ACTIONS(4623),
    [aux_sym_preproc_else_token1] = ACTIONS(4623),
    [aux_sym_preproc_elif_token1] = ACTIONS(4623),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3004] = {
    [sym_preproc_region] = STATE(3004),
    [sym_preproc_endregion] = STATE(3004),
    [sym_preproc_line] = STATE(3004),
    [sym_preproc_pragma] = STATE(3004),
    [sym_preproc_nullable] = STATE(3004),
    [sym_preproc_error] = STATE(3004),
    [sym_preproc_define] = STATE(3004),
    [sym_preproc_undef] = STATE(3004),
    [sym__identifier_token] = ACTIONS(4580),
    [anon_sym_alias] = ACTIONS(4580),
    [anon_sym_SEMI] = ACTIONS(4582),
    [anon_sym_global] = ACTIONS(4580),
    [anon_sym_LBRACK] = ACTIONS(4582),
    [anon_sym_COLON] = ACTIONS(4582),
    [anon_sym_COMMA] = ACTIONS(4582),
    [anon_sym_RBRACK] = ACTIONS(4582),
    [anon_sym_LPAREN] = ACTIONS(4582),
    [anon_sym_RPAREN] = ACTIONS(4582),
    [anon_sym_RBRACE] = ACTIONS(4582),
    [anon_sym_file] = ACTIONS(4580),
    [anon_sym_LT] = ACTIONS(4580),
    [anon_sym_GT] = ACTIONS(4580),
    [anon_sym_in] = ACTIONS(4580),
    [anon_sym_where] = ACTIONS(4580),
    [anon_sym_QMARK] = ACTIONS(4580),
    [anon_sym_notnull] = ACTIONS(4580),
    [anon_sym_unmanaged] = ACTIONS(4580),
    [anon_sym_BANG] = ACTIONS(4580),
    [anon_sym_PLUS_PLUS] = ACTIONS(4582),
    [anon_sym_DASH_DASH] = ACTIONS(4582),
    [anon_sym_PLUS] = ACTIONS(4580),
    [anon_sym_DASH] = ACTIONS(4580),
    [anon_sym_STAR] = ACTIONS(4582),
    [anon_sym_SLASH] = ACTIONS(4580),
    [anon_sym_PERCENT] = ACTIONS(4582),
    [anon_sym_CARET] = ACTIONS(4582),
    [anon_sym_PIPE] = ACTIONS(4580),
    [anon_sym_AMP] = ACTIONS(4580),
    [anon_sym_LT_LT] = ACTIONS(4582),
    [anon_sym_GT_GT] = ACTIONS(4580),
    [anon_sym_GT_GT_GT] = ACTIONS(4582),
    [anon_sym_EQ_EQ] = ACTIONS(4582),
    [anon_sym_BANG_EQ] = ACTIONS(4582),
    [anon_sym_GT_EQ] = ACTIONS(4582),
    [anon_sym_LT_EQ] = ACTIONS(4582),
    [anon_sym_DOT] = ACTIONS(4580),
    [anon_sym_scoped] = ACTIONS(4580),
    [anon_sym_EQ_GT] = ACTIONS(4582),
    [anon_sym_var] = ACTIONS(4580),
    [anon_sym_yield] = ACTIONS(4580),
    [anon_sym_switch] = ACTIONS(4580),
    [anon_sym_when] = ACTIONS(4580),
    [sym_discard] = ACTIONS(4580),
    [anon_sym_DOT_DOT] = ACTIONS(4582),
    [anon_sym_and] = ACTIONS(4580),
    [anon_sym_or] = ACTIONS(4580),
    [anon_sym_AMP_AMP] = ACTIONS(4582),
    [anon_sym_PIPE_PIPE] = ACTIONS(4582),
    [anon_sym_QMARK_QMARK] = ACTIONS(4582),
    [anon_sym_from] = ACTIONS(4580),
    [anon_sym_into] = ACTIONS(4580),
    [anon_sym_join] = ACTIONS(4580),
    [anon_sym_on] = ACTIONS(4580),
    [anon_sym_equals] = ACTIONS(4580),
    [anon_sym_let] = ACTIONS(4580),
    [anon_sym_orderby] = ACTIONS(4580),
    [anon_sym_ascending] = ACTIONS(4580),
    [anon_sym_descending] = ACTIONS(4580),
    [anon_sym_group] = ACTIONS(4580),
    [anon_sym_by] = ACTIONS(4580),
    [anon_sym_select] = ACTIONS(4580),
    [anon_sym_as] = ACTIONS(4580),
    [anon_sym_is] = ACTIONS(4580),
    [anon_sym_DASH_GT] = ACTIONS(4582),
    [anon_sym_with] = ACTIONS(4580),
    [aux_sym_preproc_if_token3] = ACTIONS(4582),
    [aux_sym_preproc_else_token1] = ACTIONS(4582),
    [aux_sym_preproc_elif_token1] = ACTIONS(4582),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3005] = {
    [sym_preproc_region] = STATE(3005),
    [sym_preproc_endregion] = STATE(3005),
    [sym_preproc_line] = STATE(3005),
    [sym_preproc_pragma] = STATE(3005),
    [sym_preproc_nullable] = STATE(3005),
    [sym_preproc_error] = STATE(3005),
    [sym_preproc_define] = STATE(3005),
    [sym_preproc_undef] = STATE(3005),
    [sym__identifier_token] = ACTIONS(4627),
    [anon_sym_alias] = ACTIONS(4627),
    [anon_sym_SEMI] = ACTIONS(4629),
    [anon_sym_global] = ACTIONS(4627),
    [anon_sym_LBRACK] = ACTIONS(4629),
    [anon_sym_COLON] = ACTIONS(4629),
    [anon_sym_COMMA] = ACTIONS(4629),
    [anon_sym_RBRACK] = ACTIONS(4629),
    [anon_sym_LPAREN] = ACTIONS(4629),
    [anon_sym_RPAREN] = ACTIONS(4629),
    [anon_sym_RBRACE] = ACTIONS(4629),
    [anon_sym_file] = ACTIONS(4627),
    [anon_sym_LT] = ACTIONS(4627),
    [anon_sym_GT] = ACTIONS(4627),
    [anon_sym_in] = ACTIONS(4627),
    [anon_sym_where] = ACTIONS(4627),
    [anon_sym_QMARK] = ACTIONS(4627),
    [anon_sym_notnull] = ACTIONS(4627),
    [anon_sym_unmanaged] = ACTIONS(4627),
    [anon_sym_BANG] = ACTIONS(4627),
    [anon_sym_PLUS_PLUS] = ACTIONS(4629),
    [anon_sym_DASH_DASH] = ACTIONS(4629),
    [anon_sym_PLUS] = ACTIONS(4627),
    [anon_sym_DASH] = ACTIONS(4627),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_SLASH] = ACTIONS(4627),
    [anon_sym_PERCENT] = ACTIONS(4629),
    [anon_sym_CARET] = ACTIONS(4629),
    [anon_sym_PIPE] = ACTIONS(4627),
    [anon_sym_AMP] = ACTIONS(4627),
    [anon_sym_LT_LT] = ACTIONS(4629),
    [anon_sym_GT_GT] = ACTIONS(4627),
    [anon_sym_GT_GT_GT] = ACTIONS(4629),
    [anon_sym_EQ_EQ] = ACTIONS(4629),
    [anon_sym_BANG_EQ] = ACTIONS(4629),
    [anon_sym_GT_EQ] = ACTIONS(4629),
    [anon_sym_LT_EQ] = ACTIONS(4629),
    [anon_sym_DOT] = ACTIONS(4627),
    [anon_sym_scoped] = ACTIONS(4627),
    [anon_sym_EQ_GT] = ACTIONS(4629),
    [anon_sym_var] = ACTIONS(4627),
    [anon_sym_yield] = ACTIONS(4627),
    [anon_sym_switch] = ACTIONS(4627),
    [anon_sym_when] = ACTIONS(4627),
    [sym_discard] = ACTIONS(4627),
    [anon_sym_DOT_DOT] = ACTIONS(4629),
    [anon_sym_and] = ACTIONS(4627),
    [anon_sym_or] = ACTIONS(4627),
    [anon_sym_AMP_AMP] = ACTIONS(4629),
    [anon_sym_PIPE_PIPE] = ACTIONS(4629),
    [anon_sym_QMARK_QMARK] = ACTIONS(4629),
    [anon_sym_from] = ACTIONS(4627),
    [anon_sym_into] = ACTIONS(4627),
    [anon_sym_join] = ACTIONS(4627),
    [anon_sym_on] = ACTIONS(4627),
    [anon_sym_equals] = ACTIONS(4627),
    [anon_sym_let] = ACTIONS(4627),
    [anon_sym_orderby] = ACTIONS(4627),
    [anon_sym_ascending] = ACTIONS(4627),
    [anon_sym_descending] = ACTIONS(4627),
    [anon_sym_group] = ACTIONS(4627),
    [anon_sym_by] = ACTIONS(4627),
    [anon_sym_select] = ACTIONS(4627),
    [anon_sym_as] = ACTIONS(4627),
    [anon_sym_is] = ACTIONS(4627),
    [anon_sym_DASH_GT] = ACTIONS(4629),
    [anon_sym_with] = ACTIONS(4627),
    [aux_sym_preproc_if_token3] = ACTIONS(4629),
    [aux_sym_preproc_else_token1] = ACTIONS(4629),
    [aux_sym_preproc_elif_token1] = ACTIONS(4629),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3006] = {
    [sym_preproc_region] = STATE(3006),
    [sym_preproc_endregion] = STATE(3006),
    [sym_preproc_line] = STATE(3006),
    [sym_preproc_pragma] = STATE(3006),
    [sym_preproc_nullable] = STATE(3006),
    [sym_preproc_error] = STATE(3006),
    [sym_preproc_define] = STATE(3006),
    [sym_preproc_undef] = STATE(3006),
    [anon_sym_SEMI] = ACTIONS(4133),
    [anon_sym_EQ] = ACTIONS(4118),
    [anon_sym_LBRACK] = ACTIONS(4133),
    [anon_sym_COLON] = ACTIONS(4133),
    [anon_sym_COMMA] = ACTIONS(4133),
    [anon_sym_RBRACK] = ACTIONS(4133),
    [anon_sym_LPAREN] = ACTIONS(4133),
    [anon_sym_RPAREN] = ACTIONS(4133),
    [anon_sym_RBRACE] = ACTIONS(4133),
    [anon_sym_LT] = ACTIONS(4118),
    [anon_sym_GT] = ACTIONS(4118),
    [anon_sym_in] = ACTIONS(4118),
    [anon_sym_where] = ACTIONS(4133),
    [anon_sym_QMARK] = ACTIONS(4118),
    [anon_sym_BANG] = ACTIONS(4118),
    [anon_sym_PLUS_PLUS] = ACTIONS(4133),
    [anon_sym_DASH_DASH] = ACTIONS(4133),
    [anon_sym_PLUS] = ACTIONS(4118),
    [anon_sym_DASH] = ACTIONS(4118),
    [anon_sym_STAR] = ACTIONS(4118),
    [anon_sym_SLASH] = ACTIONS(4118),
    [anon_sym_PERCENT] = ACTIONS(4118),
    [anon_sym_CARET] = ACTIONS(4118),
    [anon_sym_PIPE] = ACTIONS(4118),
    [anon_sym_AMP] = ACTIONS(4118),
    [anon_sym_LT_LT] = ACTIONS(4118),
    [anon_sym_GT_GT] = ACTIONS(4118),
    [anon_sym_GT_GT_GT] = ACTIONS(4118),
    [anon_sym_EQ_EQ] = ACTIONS(4133),
    [anon_sym_BANG_EQ] = ACTIONS(4133),
    [anon_sym_GT_EQ] = ACTIONS(4133),
    [anon_sym_LT_EQ] = ACTIONS(4133),
    [anon_sym_DOT] = ACTIONS(4118),
    [anon_sym_EQ_GT] = ACTIONS(4133),
    [anon_sym_switch] = ACTIONS(4133),
    [anon_sym_DOT_DOT] = ACTIONS(4133),
    [anon_sym_and] = ACTIONS(4133),
    [anon_sym_or] = ACTIONS(4118),
    [anon_sym_PLUS_EQ] = ACTIONS(4133),
    [anon_sym_DASH_EQ] = ACTIONS(4133),
    [anon_sym_STAR_EQ] = ACTIONS(4133),
    [anon_sym_SLASH_EQ] = ACTIONS(4133),
    [anon_sym_PERCENT_EQ] = ACTIONS(4133),
    [anon_sym_AMP_EQ] = ACTIONS(4133),
    [anon_sym_CARET_EQ] = ACTIONS(4133),
    [anon_sym_PIPE_EQ] = ACTIONS(4133),
    [anon_sym_LT_LT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4133),
    [anon_sym_AMP_AMP] = ACTIONS(4133),
    [anon_sym_PIPE_PIPE] = ACTIONS(4133),
    [anon_sym_QMARK_QMARK] = ACTIONS(4118),
    [anon_sym_from] = ACTIONS(4133),
    [anon_sym_into] = ACTIONS(4133),
    [anon_sym_join] = ACTIONS(4133),
    [anon_sym_on] = ACTIONS(4133),
    [anon_sym_equals] = ACTIONS(4133),
    [anon_sym_let] = ACTIONS(4133),
    [anon_sym_orderby] = ACTIONS(4133),
    [anon_sym_group] = ACTIONS(4133),
    [anon_sym_by] = ACTIONS(4133),
    [anon_sym_select] = ACTIONS(4133),
    [anon_sym_as] = ACTIONS(4133),
    [anon_sym_is] = ACTIONS(4133),
    [anon_sym_DASH_GT] = ACTIONS(4133),
    [anon_sym_with] = ACTIONS(4133),
    [aux_sym_preproc_if_token3] = ACTIONS(4133),
    [aux_sym_preproc_else_token1] = ACTIONS(4133),
    [aux_sym_preproc_elif_token1] = ACTIONS(4133),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3007] = {
    [sym_preproc_region] = STATE(3007),
    [sym_preproc_endregion] = STATE(3007),
    [sym_preproc_line] = STATE(3007),
    [sym_preproc_pragma] = STATE(3007),
    [sym_preproc_nullable] = STATE(3007),
    [sym_preproc_error] = STATE(3007),
    [sym_preproc_define] = STATE(3007),
    [sym_preproc_undef] = STATE(3007),
    [anon_sym_SEMI] = ACTIONS(4631),
    [anon_sym_EQ] = ACTIONS(4633),
    [anon_sym_LBRACK] = ACTIONS(4631),
    [anon_sym_COLON] = ACTIONS(4631),
    [anon_sym_COMMA] = ACTIONS(4631),
    [anon_sym_RBRACK] = ACTIONS(4631),
    [anon_sym_LPAREN] = ACTIONS(4631),
    [anon_sym_RPAREN] = ACTIONS(4631),
    [anon_sym_RBRACE] = ACTIONS(4631),
    [anon_sym_LT] = ACTIONS(4633),
    [anon_sym_GT] = ACTIONS(4633),
    [anon_sym_in] = ACTIONS(4633),
    [anon_sym_where] = ACTIONS(4631),
    [anon_sym_QMARK] = ACTIONS(4633),
    [anon_sym_BANG] = ACTIONS(4633),
    [anon_sym_PLUS_PLUS] = ACTIONS(4631),
    [anon_sym_DASH_DASH] = ACTIONS(4631),
    [anon_sym_PLUS] = ACTIONS(4633),
    [anon_sym_DASH] = ACTIONS(4633),
    [anon_sym_STAR] = ACTIONS(4633),
    [anon_sym_SLASH] = ACTIONS(4633),
    [anon_sym_PERCENT] = ACTIONS(4633),
    [anon_sym_CARET] = ACTIONS(4633),
    [anon_sym_PIPE] = ACTIONS(4633),
    [anon_sym_AMP] = ACTIONS(4633),
    [anon_sym_LT_LT] = ACTIONS(4633),
    [anon_sym_GT_GT] = ACTIONS(4633),
    [anon_sym_GT_GT_GT] = ACTIONS(4633),
    [anon_sym_EQ_EQ] = ACTIONS(4631),
    [anon_sym_BANG_EQ] = ACTIONS(4631),
    [anon_sym_GT_EQ] = ACTIONS(4631),
    [anon_sym_LT_EQ] = ACTIONS(4631),
    [anon_sym_DOT] = ACTIONS(4633),
    [anon_sym_EQ_GT] = ACTIONS(4631),
    [anon_sym_switch] = ACTIONS(4631),
    [anon_sym_DOT_DOT] = ACTIONS(4631),
    [anon_sym_and] = ACTIONS(4631),
    [anon_sym_or] = ACTIONS(4633),
    [anon_sym_PLUS_EQ] = ACTIONS(4631),
    [anon_sym_DASH_EQ] = ACTIONS(4631),
    [anon_sym_STAR_EQ] = ACTIONS(4631),
    [anon_sym_SLASH_EQ] = ACTIONS(4631),
    [anon_sym_PERCENT_EQ] = ACTIONS(4631),
    [anon_sym_AMP_EQ] = ACTIONS(4631),
    [anon_sym_CARET_EQ] = ACTIONS(4631),
    [anon_sym_PIPE_EQ] = ACTIONS(4631),
    [anon_sym_LT_LT_EQ] = ACTIONS(4631),
    [anon_sym_GT_GT_EQ] = ACTIONS(4631),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4631),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4631),
    [anon_sym_AMP_AMP] = ACTIONS(4631),
    [anon_sym_PIPE_PIPE] = ACTIONS(4631),
    [anon_sym_QMARK_QMARK] = ACTIONS(4633),
    [anon_sym_from] = ACTIONS(4631),
    [anon_sym_into] = ACTIONS(4631),
    [anon_sym_join] = ACTIONS(4631),
    [anon_sym_on] = ACTIONS(4631),
    [anon_sym_equals] = ACTIONS(4631),
    [anon_sym_let] = ACTIONS(4631),
    [anon_sym_orderby] = ACTIONS(4631),
    [anon_sym_group] = ACTIONS(4631),
    [anon_sym_by] = ACTIONS(4631),
    [anon_sym_select] = ACTIONS(4631),
    [anon_sym_as] = ACTIONS(4631),
    [anon_sym_is] = ACTIONS(4631),
    [anon_sym_DASH_GT] = ACTIONS(4631),
    [anon_sym_with] = ACTIONS(4631),
    [aux_sym_preproc_if_token3] = ACTIONS(4631),
    [aux_sym_preproc_else_token1] = ACTIONS(4631),
    [aux_sym_preproc_elif_token1] = ACTIONS(4631),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3008] = {
    [sym_preproc_region] = STATE(3008),
    [sym_preproc_endregion] = STATE(3008),
    [sym_preproc_line] = STATE(3008),
    [sym_preproc_pragma] = STATE(3008),
    [sym_preproc_nullable] = STATE(3008),
    [sym_preproc_error] = STATE(3008),
    [sym_preproc_define] = STATE(3008),
    [sym_preproc_undef] = STATE(3008),
    [sym__identifier_token] = ACTIONS(4426),
    [anon_sym_alias] = ACTIONS(4426),
    [anon_sym_SEMI] = ACTIONS(4428),
    [anon_sym_global] = ACTIONS(4426),
    [anon_sym_LBRACK] = ACTIONS(4428),
    [anon_sym_COMMA] = ACTIONS(4428),
    [anon_sym_RBRACK] = ACTIONS(4428),
    [anon_sym_LPAREN] = ACTIONS(4428),
    [anon_sym_RPAREN] = ACTIONS(4428),
    [anon_sym_LBRACE] = ACTIONS(4428),
    [anon_sym_RBRACE] = ACTIONS(4428),
    [anon_sym_file] = ACTIONS(4426),
    [anon_sym_LT] = ACTIONS(4426),
    [anon_sym_GT] = ACTIONS(4426),
    [anon_sym_in] = ACTIONS(4426),
    [anon_sym_where] = ACTIONS(4426),
    [anon_sym_QMARK] = ACTIONS(4426),
    [anon_sym_notnull] = ACTIONS(4426),
    [anon_sym_unmanaged] = ACTIONS(4426),
    [anon_sym_BANG] = ACTIONS(4426),
    [anon_sym_PLUS_PLUS] = ACTIONS(4428),
    [anon_sym_DASH_DASH] = ACTIONS(4428),
    [anon_sym_PLUS] = ACTIONS(4426),
    [anon_sym_DASH] = ACTIONS(4426),
    [anon_sym_STAR] = ACTIONS(4428),
    [anon_sym_SLASH] = ACTIONS(4426),
    [anon_sym_PERCENT] = ACTIONS(4428),
    [anon_sym_CARET] = ACTIONS(4428),
    [anon_sym_PIPE] = ACTIONS(4426),
    [anon_sym_AMP] = ACTIONS(4426),
    [anon_sym_LT_LT] = ACTIONS(4428),
    [anon_sym_GT_GT] = ACTIONS(4426),
    [anon_sym_GT_GT_GT] = ACTIONS(4428),
    [anon_sym_EQ_EQ] = ACTIONS(4428),
    [anon_sym_BANG_EQ] = ACTIONS(4428),
    [anon_sym_GT_EQ] = ACTIONS(4428),
    [anon_sym_LT_EQ] = ACTIONS(4428),
    [anon_sym_DOT] = ACTIONS(4621),
    [anon_sym_scoped] = ACTIONS(4426),
    [anon_sym_EQ_GT] = ACTIONS(4428),
    [anon_sym_var] = ACTIONS(4426),
    [anon_sym_yield] = ACTIONS(4426),
    [anon_sym_switch] = ACTIONS(4426),
    [anon_sym_when] = ACTIONS(4426),
    [sym_discard] = ACTIONS(4426),
    [anon_sym_DOT_DOT] = ACTIONS(4428),
    [anon_sym_and] = ACTIONS(4426),
    [anon_sym_or] = ACTIONS(4426),
    [anon_sym_AMP_AMP] = ACTIONS(4428),
    [anon_sym_PIPE_PIPE] = ACTIONS(4428),
    [anon_sym_QMARK_QMARK] = ACTIONS(4428),
    [anon_sym_from] = ACTIONS(4426),
    [anon_sym_into] = ACTIONS(4426),
    [anon_sym_join] = ACTIONS(4426),
    [anon_sym_on] = ACTIONS(4426),
    [anon_sym_equals] = ACTIONS(4426),
    [anon_sym_let] = ACTIONS(4426),
    [anon_sym_orderby] = ACTIONS(4426),
    [anon_sym_ascending] = ACTIONS(4426),
    [anon_sym_descending] = ACTIONS(4426),
    [anon_sym_group] = ACTIONS(4426),
    [anon_sym_by] = ACTIONS(4426),
    [anon_sym_select] = ACTIONS(4426),
    [anon_sym_as] = ACTIONS(4426),
    [anon_sym_is] = ACTIONS(4426),
    [anon_sym_DASH_GT] = ACTIONS(4428),
    [anon_sym_with] = ACTIONS(4426),
    [aux_sym_preproc_if_token3] = ACTIONS(4428),
    [aux_sym_preproc_else_token1] = ACTIONS(4428),
    [aux_sym_preproc_elif_token1] = ACTIONS(4428),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3009] = {
    [sym_preproc_region] = STATE(3009),
    [sym_preproc_endregion] = STATE(3009),
    [sym_preproc_line] = STATE(3009),
    [sym_preproc_pragma] = STATE(3009),
    [sym_preproc_nullable] = STATE(3009),
    [sym_preproc_error] = STATE(3009),
    [sym_preproc_define] = STATE(3009),
    [sym_preproc_undef] = STATE(3009),
    [anon_sym_SEMI] = ACTIONS(4635),
    [anon_sym_EQ] = ACTIONS(4637),
    [anon_sym_LBRACK] = ACTIONS(4635),
    [anon_sym_COLON] = ACTIONS(4635),
    [anon_sym_COMMA] = ACTIONS(4635),
    [anon_sym_RBRACK] = ACTIONS(4635),
    [anon_sym_LPAREN] = ACTIONS(4635),
    [anon_sym_RPAREN] = ACTIONS(4635),
    [anon_sym_RBRACE] = ACTIONS(4635),
    [anon_sym_LT] = ACTIONS(4637),
    [anon_sym_GT] = ACTIONS(4637),
    [anon_sym_in] = ACTIONS(4637),
    [anon_sym_where] = ACTIONS(4635),
    [anon_sym_QMARK] = ACTIONS(4637),
    [anon_sym_BANG] = ACTIONS(4637),
    [anon_sym_PLUS_PLUS] = ACTIONS(4635),
    [anon_sym_DASH_DASH] = ACTIONS(4635),
    [anon_sym_PLUS] = ACTIONS(4637),
    [anon_sym_DASH] = ACTIONS(4637),
    [anon_sym_STAR] = ACTIONS(4637),
    [anon_sym_SLASH] = ACTIONS(4637),
    [anon_sym_PERCENT] = ACTIONS(4637),
    [anon_sym_CARET] = ACTIONS(4637),
    [anon_sym_PIPE] = ACTIONS(4637),
    [anon_sym_AMP] = ACTIONS(4637),
    [anon_sym_LT_LT] = ACTIONS(4637),
    [anon_sym_GT_GT] = ACTIONS(4637),
    [anon_sym_GT_GT_GT] = ACTIONS(4637),
    [anon_sym_EQ_EQ] = ACTIONS(4635),
    [anon_sym_BANG_EQ] = ACTIONS(4635),
    [anon_sym_GT_EQ] = ACTIONS(4635),
    [anon_sym_LT_EQ] = ACTIONS(4635),
    [anon_sym_DOT] = ACTIONS(4637),
    [anon_sym_EQ_GT] = ACTIONS(4635),
    [anon_sym_switch] = ACTIONS(4635),
    [anon_sym_DOT_DOT] = ACTIONS(4635),
    [anon_sym_and] = ACTIONS(4635),
    [anon_sym_or] = ACTIONS(4637),
    [anon_sym_PLUS_EQ] = ACTIONS(4635),
    [anon_sym_DASH_EQ] = ACTIONS(4635),
    [anon_sym_STAR_EQ] = ACTIONS(4635),
    [anon_sym_SLASH_EQ] = ACTIONS(4635),
    [anon_sym_PERCENT_EQ] = ACTIONS(4635),
    [anon_sym_AMP_EQ] = ACTIONS(4635),
    [anon_sym_CARET_EQ] = ACTIONS(4635),
    [anon_sym_PIPE_EQ] = ACTIONS(4635),
    [anon_sym_LT_LT_EQ] = ACTIONS(4635),
    [anon_sym_GT_GT_EQ] = ACTIONS(4635),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4635),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4635),
    [anon_sym_AMP_AMP] = ACTIONS(4635),
    [anon_sym_PIPE_PIPE] = ACTIONS(4635),
    [anon_sym_QMARK_QMARK] = ACTIONS(4637),
    [anon_sym_from] = ACTIONS(4635),
    [anon_sym_into] = ACTIONS(4635),
    [anon_sym_join] = ACTIONS(4635),
    [anon_sym_on] = ACTIONS(4635),
    [anon_sym_equals] = ACTIONS(4635),
    [anon_sym_let] = ACTIONS(4635),
    [anon_sym_orderby] = ACTIONS(4635),
    [anon_sym_group] = ACTIONS(4635),
    [anon_sym_by] = ACTIONS(4635),
    [anon_sym_select] = ACTIONS(4635),
    [anon_sym_as] = ACTIONS(4635),
    [anon_sym_is] = ACTIONS(4635),
    [anon_sym_DASH_GT] = ACTIONS(4635),
    [anon_sym_with] = ACTIONS(4635),
    [aux_sym_preproc_if_token3] = ACTIONS(4635),
    [aux_sym_preproc_else_token1] = ACTIONS(4635),
    [aux_sym_preproc_elif_token1] = ACTIONS(4635),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3010] = {
    [sym_preproc_region] = STATE(3010),
    [sym_preproc_endregion] = STATE(3010),
    [sym_preproc_line] = STATE(3010),
    [sym_preproc_pragma] = STATE(3010),
    [sym_preproc_nullable] = STATE(3010),
    [sym_preproc_error] = STATE(3010),
    [sym_preproc_define] = STATE(3010),
    [sym_preproc_undef] = STATE(3010),
    [anon_sym_SEMI] = ACTIONS(4639),
    [anon_sym_EQ] = ACTIONS(4625),
    [anon_sym_LBRACK] = ACTIONS(4639),
    [anon_sym_COLON] = ACTIONS(4623),
    [anon_sym_COMMA] = ACTIONS(4639),
    [anon_sym_RBRACK] = ACTIONS(4639),
    [anon_sym_LPAREN] = ACTIONS(4639),
    [anon_sym_RPAREN] = ACTIONS(4639),
    [anon_sym_RBRACE] = ACTIONS(4639),
    [anon_sym_LT] = ACTIONS(4641),
    [anon_sym_GT] = ACTIONS(4641),
    [anon_sym_in] = ACTIONS(4641),
    [anon_sym_where] = ACTIONS(4639),
    [anon_sym_QMARK] = ACTIONS(4641),
    [anon_sym_BANG] = ACTIONS(4641),
    [anon_sym_PLUS_PLUS] = ACTIONS(4639),
    [anon_sym_DASH_DASH] = ACTIONS(4639),
    [anon_sym_PLUS] = ACTIONS(4641),
    [anon_sym_DASH] = ACTIONS(4641),
    [anon_sym_STAR] = ACTIONS(4641),
    [anon_sym_SLASH] = ACTIONS(4641),
    [anon_sym_PERCENT] = ACTIONS(4641),
    [anon_sym_CARET] = ACTIONS(4641),
    [anon_sym_PIPE] = ACTIONS(4641),
    [anon_sym_AMP] = ACTIONS(4641),
    [anon_sym_LT_LT] = ACTIONS(4641),
    [anon_sym_GT_GT] = ACTIONS(4641),
    [anon_sym_GT_GT_GT] = ACTIONS(4641),
    [anon_sym_EQ_EQ] = ACTIONS(4639),
    [anon_sym_BANG_EQ] = ACTIONS(4639),
    [anon_sym_GT_EQ] = ACTIONS(4639),
    [anon_sym_LT_EQ] = ACTIONS(4639),
    [anon_sym_DOT] = ACTIONS(4641),
    [anon_sym_EQ_GT] = ACTIONS(4639),
    [anon_sym_switch] = ACTIONS(4639),
    [anon_sym_DOT_DOT] = ACTIONS(4639),
    [anon_sym_and] = ACTIONS(4639),
    [anon_sym_or] = ACTIONS(4641),
    [anon_sym_PLUS_EQ] = ACTIONS(4623),
    [anon_sym_DASH_EQ] = ACTIONS(4623),
    [anon_sym_STAR_EQ] = ACTIONS(4623),
    [anon_sym_SLASH_EQ] = ACTIONS(4623),
    [anon_sym_PERCENT_EQ] = ACTIONS(4623),
    [anon_sym_AMP_EQ] = ACTIONS(4623),
    [anon_sym_CARET_EQ] = ACTIONS(4623),
    [anon_sym_PIPE_EQ] = ACTIONS(4623),
    [anon_sym_LT_LT_EQ] = ACTIONS(4623),
    [anon_sym_GT_GT_EQ] = ACTIONS(4623),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4623),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4623),
    [anon_sym_AMP_AMP] = ACTIONS(4639),
    [anon_sym_PIPE_PIPE] = ACTIONS(4639),
    [anon_sym_QMARK_QMARK] = ACTIONS(4641),
    [anon_sym_from] = ACTIONS(4639),
    [anon_sym_into] = ACTIONS(4639),
    [anon_sym_join] = ACTIONS(4639),
    [anon_sym_on] = ACTIONS(4639),
    [anon_sym_equals] = ACTIONS(4639),
    [anon_sym_let] = ACTIONS(4639),
    [anon_sym_orderby] = ACTIONS(4639),
    [anon_sym_group] = ACTIONS(4639),
    [anon_sym_by] = ACTIONS(4639),
    [anon_sym_select] = ACTIONS(4639),
    [anon_sym_as] = ACTIONS(4639),
    [anon_sym_is] = ACTIONS(4639),
    [anon_sym_DASH_GT] = ACTIONS(4639),
    [anon_sym_with] = ACTIONS(4639),
    [aux_sym_preproc_if_token3] = ACTIONS(4639),
    [aux_sym_preproc_else_token1] = ACTIONS(4639),
    [aux_sym_preproc_elif_token1] = ACTIONS(4639),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3011] = {
    [sym_preproc_region] = STATE(3011),
    [sym_preproc_endregion] = STATE(3011),
    [sym_preproc_line] = STATE(3011),
    [sym_preproc_pragma] = STATE(3011),
    [sym_preproc_nullable] = STATE(3011),
    [sym_preproc_error] = STATE(3011),
    [sym_preproc_define] = STATE(3011),
    [sym_preproc_undef] = STATE(3011),
    [anon_sym_SEMI] = ACTIONS(4643),
    [anon_sym_EQ] = ACTIONS(4645),
    [anon_sym_LBRACK] = ACTIONS(4643),
    [anon_sym_COLON] = ACTIONS(4643),
    [anon_sym_COMMA] = ACTIONS(4643),
    [anon_sym_RBRACK] = ACTIONS(4643),
    [anon_sym_LPAREN] = ACTIONS(4643),
    [anon_sym_RPAREN] = ACTIONS(4643),
    [anon_sym_RBRACE] = ACTIONS(4643),
    [anon_sym_LT] = ACTIONS(4645),
    [anon_sym_GT] = ACTIONS(4645),
    [anon_sym_in] = ACTIONS(4645),
    [anon_sym_where] = ACTIONS(4643),
    [anon_sym_QMARK] = ACTIONS(4645),
    [anon_sym_BANG] = ACTIONS(4645),
    [anon_sym_PLUS_PLUS] = ACTIONS(4643),
    [anon_sym_DASH_DASH] = ACTIONS(4643),
    [anon_sym_PLUS] = ACTIONS(4645),
    [anon_sym_DASH] = ACTIONS(4645),
    [anon_sym_STAR] = ACTIONS(4645),
    [anon_sym_SLASH] = ACTIONS(4645),
    [anon_sym_PERCENT] = ACTIONS(4645),
    [anon_sym_CARET] = ACTIONS(4645),
    [anon_sym_PIPE] = ACTIONS(4645),
    [anon_sym_AMP] = ACTIONS(4645),
    [anon_sym_LT_LT] = ACTIONS(4645),
    [anon_sym_GT_GT] = ACTIONS(4645),
    [anon_sym_GT_GT_GT] = ACTIONS(4645),
    [anon_sym_EQ_EQ] = ACTIONS(4643),
    [anon_sym_BANG_EQ] = ACTIONS(4643),
    [anon_sym_GT_EQ] = ACTIONS(4643),
    [anon_sym_LT_EQ] = ACTIONS(4643),
    [anon_sym_DOT] = ACTIONS(4645),
    [anon_sym_EQ_GT] = ACTIONS(4643),
    [anon_sym_switch] = ACTIONS(4643),
    [anon_sym_DOT_DOT] = ACTIONS(4643),
    [anon_sym_and] = ACTIONS(4643),
    [anon_sym_or] = ACTIONS(4645),
    [anon_sym_PLUS_EQ] = ACTIONS(4643),
    [anon_sym_DASH_EQ] = ACTIONS(4643),
    [anon_sym_STAR_EQ] = ACTIONS(4643),
    [anon_sym_SLASH_EQ] = ACTIONS(4643),
    [anon_sym_PERCENT_EQ] = ACTIONS(4643),
    [anon_sym_AMP_EQ] = ACTIONS(4643),
    [anon_sym_CARET_EQ] = ACTIONS(4643),
    [anon_sym_PIPE_EQ] = ACTIONS(4643),
    [anon_sym_LT_LT_EQ] = ACTIONS(4643),
    [anon_sym_GT_GT_EQ] = ACTIONS(4643),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4643),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4643),
    [anon_sym_AMP_AMP] = ACTIONS(4643),
    [anon_sym_PIPE_PIPE] = ACTIONS(4643),
    [anon_sym_QMARK_QMARK] = ACTIONS(4645),
    [anon_sym_from] = ACTIONS(4643),
    [anon_sym_into] = ACTIONS(4643),
    [anon_sym_join] = ACTIONS(4643),
    [anon_sym_on] = ACTIONS(4643),
    [anon_sym_equals] = ACTIONS(4643),
    [anon_sym_let] = ACTIONS(4643),
    [anon_sym_orderby] = ACTIONS(4643),
    [anon_sym_group] = ACTIONS(4643),
    [anon_sym_by] = ACTIONS(4643),
    [anon_sym_select] = ACTIONS(4643),
    [anon_sym_as] = ACTIONS(4643),
    [anon_sym_is] = ACTIONS(4643),
    [anon_sym_DASH_GT] = ACTIONS(4643),
    [anon_sym_with] = ACTIONS(4643),
    [aux_sym_preproc_if_token3] = ACTIONS(4643),
    [aux_sym_preproc_else_token1] = ACTIONS(4643),
    [aux_sym_preproc_elif_token1] = ACTIONS(4643),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3012] = {
    [sym_preproc_region] = STATE(3012),
    [sym_preproc_endregion] = STATE(3012),
    [sym_preproc_line] = STATE(3012),
    [sym_preproc_pragma] = STATE(3012),
    [sym_preproc_nullable] = STATE(3012),
    [sym_preproc_error] = STATE(3012),
    [sym_preproc_define] = STATE(3012),
    [sym_preproc_undef] = STATE(3012),
    [anon_sym_SEMI] = ACTIONS(4062),
    [anon_sym_EQ] = ACTIONS(4060),
    [anon_sym_LBRACK] = ACTIONS(4062),
    [anon_sym_COLON] = ACTIONS(4062),
    [anon_sym_COMMA] = ACTIONS(4062),
    [anon_sym_RBRACK] = ACTIONS(4062),
    [anon_sym_LPAREN] = ACTIONS(4062),
    [anon_sym_RPAREN] = ACTIONS(4062),
    [anon_sym_RBRACE] = ACTIONS(4062),
    [anon_sym_LT] = ACTIONS(4060),
    [anon_sym_GT] = ACTIONS(4060),
    [anon_sym_in] = ACTIONS(4060),
    [anon_sym_where] = ACTIONS(4062),
    [anon_sym_QMARK] = ACTIONS(4060),
    [anon_sym_BANG] = ACTIONS(4060),
    [anon_sym_PLUS_PLUS] = ACTIONS(4062),
    [anon_sym_DASH_DASH] = ACTIONS(4062),
    [anon_sym_PLUS] = ACTIONS(4060),
    [anon_sym_DASH] = ACTIONS(4060),
    [anon_sym_STAR] = ACTIONS(4060),
    [anon_sym_SLASH] = ACTIONS(4060),
    [anon_sym_PERCENT] = ACTIONS(4060),
    [anon_sym_CARET] = ACTIONS(4060),
    [anon_sym_PIPE] = ACTIONS(4060),
    [anon_sym_AMP] = ACTIONS(4060),
    [anon_sym_LT_LT] = ACTIONS(4060),
    [anon_sym_GT_GT] = ACTIONS(4060),
    [anon_sym_GT_GT_GT] = ACTIONS(4060),
    [anon_sym_EQ_EQ] = ACTIONS(4062),
    [anon_sym_BANG_EQ] = ACTIONS(4062),
    [anon_sym_GT_EQ] = ACTIONS(4062),
    [anon_sym_LT_EQ] = ACTIONS(4062),
    [anon_sym_DOT] = ACTIONS(4060),
    [anon_sym_EQ_GT] = ACTIONS(4062),
    [anon_sym_switch] = ACTIONS(4062),
    [anon_sym_DOT_DOT] = ACTIONS(4062),
    [anon_sym_and] = ACTIONS(4062),
    [anon_sym_or] = ACTIONS(4060),
    [anon_sym_PLUS_EQ] = ACTIONS(4062),
    [anon_sym_DASH_EQ] = ACTIONS(4062),
    [anon_sym_STAR_EQ] = ACTIONS(4062),
    [anon_sym_SLASH_EQ] = ACTIONS(4062),
    [anon_sym_PERCENT_EQ] = ACTIONS(4062),
    [anon_sym_AMP_EQ] = ACTIONS(4062),
    [anon_sym_CARET_EQ] = ACTIONS(4062),
    [anon_sym_PIPE_EQ] = ACTIONS(4062),
    [anon_sym_LT_LT_EQ] = ACTIONS(4062),
    [anon_sym_GT_GT_EQ] = ACTIONS(4062),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4062),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4062),
    [anon_sym_AMP_AMP] = ACTIONS(4062),
    [anon_sym_PIPE_PIPE] = ACTIONS(4062),
    [anon_sym_QMARK_QMARK] = ACTIONS(4060),
    [anon_sym_from] = ACTIONS(4062),
    [anon_sym_into] = ACTIONS(4062),
    [anon_sym_join] = ACTIONS(4062),
    [anon_sym_on] = ACTIONS(4062),
    [anon_sym_equals] = ACTIONS(4062),
    [anon_sym_let] = ACTIONS(4062),
    [anon_sym_orderby] = ACTIONS(4062),
    [anon_sym_group] = ACTIONS(4062),
    [anon_sym_by] = ACTIONS(4062),
    [anon_sym_select] = ACTIONS(4062),
    [anon_sym_as] = ACTIONS(4062),
    [anon_sym_is] = ACTIONS(4062),
    [anon_sym_DASH_GT] = ACTIONS(4062),
    [anon_sym_with] = ACTIONS(4062),
    [aux_sym_preproc_if_token3] = ACTIONS(4062),
    [aux_sym_preproc_else_token1] = ACTIONS(4062),
    [aux_sym_preproc_elif_token1] = ACTIONS(4062),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3013] = {
    [sym_preproc_region] = STATE(3013),
    [sym_preproc_endregion] = STATE(3013),
    [sym_preproc_line] = STATE(3013),
    [sym_preproc_pragma] = STATE(3013),
    [sym_preproc_nullable] = STATE(3013),
    [sym_preproc_error] = STATE(3013),
    [sym_preproc_define] = STATE(3013),
    [sym_preproc_undef] = STATE(3013),
    [anon_sym_SEMI] = ACTIONS(4072),
    [anon_sym_EQ] = ACTIONS(4070),
    [anon_sym_LBRACK] = ACTIONS(4072),
    [anon_sym_COLON] = ACTIONS(4072),
    [anon_sym_COMMA] = ACTIONS(4072),
    [anon_sym_RBRACK] = ACTIONS(4072),
    [anon_sym_LPAREN] = ACTIONS(4072),
    [anon_sym_RPAREN] = ACTIONS(4072),
    [anon_sym_RBRACE] = ACTIONS(4072),
    [anon_sym_LT] = ACTIONS(4070),
    [anon_sym_GT] = ACTIONS(4070),
    [anon_sym_in] = ACTIONS(4070),
    [anon_sym_where] = ACTIONS(4072),
    [anon_sym_QMARK] = ACTIONS(4070),
    [anon_sym_BANG] = ACTIONS(4070),
    [anon_sym_PLUS_PLUS] = ACTIONS(4072),
    [anon_sym_DASH_DASH] = ACTIONS(4072),
    [anon_sym_PLUS] = ACTIONS(4070),
    [anon_sym_DASH] = ACTIONS(4070),
    [anon_sym_STAR] = ACTIONS(4070),
    [anon_sym_SLASH] = ACTIONS(4070),
    [anon_sym_PERCENT] = ACTIONS(4070),
    [anon_sym_CARET] = ACTIONS(4070),
    [anon_sym_PIPE] = ACTIONS(4070),
    [anon_sym_AMP] = ACTIONS(4070),
    [anon_sym_LT_LT] = ACTIONS(4070),
    [anon_sym_GT_GT] = ACTIONS(4070),
    [anon_sym_GT_GT_GT] = ACTIONS(4070),
    [anon_sym_EQ_EQ] = ACTIONS(4072),
    [anon_sym_BANG_EQ] = ACTIONS(4072),
    [anon_sym_GT_EQ] = ACTIONS(4072),
    [anon_sym_LT_EQ] = ACTIONS(4072),
    [anon_sym_DOT] = ACTIONS(4070),
    [anon_sym_EQ_GT] = ACTIONS(4072),
    [anon_sym_switch] = ACTIONS(4072),
    [anon_sym_DOT_DOT] = ACTIONS(4072),
    [anon_sym_and] = ACTIONS(4072),
    [anon_sym_or] = ACTIONS(4070),
    [anon_sym_PLUS_EQ] = ACTIONS(4072),
    [anon_sym_DASH_EQ] = ACTIONS(4072),
    [anon_sym_STAR_EQ] = ACTIONS(4072),
    [anon_sym_SLASH_EQ] = ACTIONS(4072),
    [anon_sym_PERCENT_EQ] = ACTIONS(4072),
    [anon_sym_AMP_EQ] = ACTIONS(4072),
    [anon_sym_CARET_EQ] = ACTIONS(4072),
    [anon_sym_PIPE_EQ] = ACTIONS(4072),
    [anon_sym_LT_LT_EQ] = ACTIONS(4072),
    [anon_sym_GT_GT_EQ] = ACTIONS(4072),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4072),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4072),
    [anon_sym_AMP_AMP] = ACTIONS(4072),
    [anon_sym_PIPE_PIPE] = ACTIONS(4072),
    [anon_sym_QMARK_QMARK] = ACTIONS(4070),
    [anon_sym_from] = ACTIONS(4072),
    [anon_sym_into] = ACTIONS(4072),
    [anon_sym_join] = ACTIONS(4072),
    [anon_sym_on] = ACTIONS(4072),
    [anon_sym_equals] = ACTIONS(4072),
    [anon_sym_let] = ACTIONS(4072),
    [anon_sym_orderby] = ACTIONS(4072),
    [anon_sym_group] = ACTIONS(4072),
    [anon_sym_by] = ACTIONS(4072),
    [anon_sym_select] = ACTIONS(4072),
    [anon_sym_as] = ACTIONS(4072),
    [anon_sym_is] = ACTIONS(4072),
    [anon_sym_DASH_GT] = ACTIONS(4072),
    [anon_sym_with] = ACTIONS(4072),
    [aux_sym_preproc_if_token3] = ACTIONS(4072),
    [aux_sym_preproc_else_token1] = ACTIONS(4072),
    [aux_sym_preproc_elif_token1] = ACTIONS(4072),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3014] = {
    [sym_preproc_region] = STATE(3014),
    [sym_preproc_endregion] = STATE(3014),
    [sym_preproc_line] = STATE(3014),
    [sym_preproc_pragma] = STATE(3014),
    [sym_preproc_nullable] = STATE(3014),
    [sym_preproc_error] = STATE(3014),
    [sym_preproc_define] = STATE(3014),
    [sym_preproc_undef] = STATE(3014),
    [anon_sym_SEMI] = ACTIONS(4588),
    [anon_sym_EQ] = ACTIONS(4590),
    [anon_sym_LBRACK] = ACTIONS(4588),
    [anon_sym_COLON] = ACTIONS(4588),
    [anon_sym_COMMA] = ACTIONS(4588),
    [anon_sym_RBRACK] = ACTIONS(4588),
    [anon_sym_LPAREN] = ACTIONS(4588),
    [anon_sym_RPAREN] = ACTIONS(4588),
    [anon_sym_RBRACE] = ACTIONS(4588),
    [anon_sym_LT] = ACTIONS(4590),
    [anon_sym_GT] = ACTIONS(4590),
    [anon_sym_in] = ACTIONS(4588),
    [anon_sym_where] = ACTIONS(4588),
    [anon_sym_QMARK] = ACTIONS(4590),
    [anon_sym_BANG] = ACTIONS(4590),
    [anon_sym_PLUS_PLUS] = ACTIONS(4588),
    [anon_sym_DASH_DASH] = ACTIONS(4588),
    [anon_sym_PLUS] = ACTIONS(4590),
    [anon_sym_DASH] = ACTIONS(4590),
    [anon_sym_STAR] = ACTIONS(4590),
    [anon_sym_SLASH] = ACTIONS(4590),
    [anon_sym_PERCENT] = ACTIONS(4590),
    [anon_sym_CARET] = ACTIONS(4590),
    [anon_sym_PIPE] = ACTIONS(4590),
    [anon_sym_AMP] = ACTIONS(4590),
    [anon_sym_LT_LT] = ACTIONS(4590),
    [anon_sym_GT_GT] = ACTIONS(4590),
    [anon_sym_GT_GT_GT] = ACTIONS(4590),
    [anon_sym_EQ_EQ] = ACTIONS(4588),
    [anon_sym_BANG_EQ] = ACTIONS(4588),
    [anon_sym_GT_EQ] = ACTIONS(4588),
    [anon_sym_LT_EQ] = ACTIONS(4588),
    [anon_sym_DOT] = ACTIONS(4590),
    [anon_sym_EQ_GT] = ACTIONS(4588),
    [anon_sym_switch] = ACTIONS(4588),
    [anon_sym_DOT_DOT] = ACTIONS(4588),
    [anon_sym_and] = ACTIONS(4588),
    [anon_sym_or] = ACTIONS(4590),
    [anon_sym_PLUS_EQ] = ACTIONS(4588),
    [anon_sym_DASH_EQ] = ACTIONS(4588),
    [anon_sym_STAR_EQ] = ACTIONS(4588),
    [anon_sym_SLASH_EQ] = ACTIONS(4588),
    [anon_sym_PERCENT_EQ] = ACTIONS(4588),
    [anon_sym_AMP_EQ] = ACTIONS(4588),
    [anon_sym_CARET_EQ] = ACTIONS(4588),
    [anon_sym_PIPE_EQ] = ACTIONS(4588),
    [anon_sym_LT_LT_EQ] = ACTIONS(4588),
    [anon_sym_GT_GT_EQ] = ACTIONS(4588),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4588),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4588),
    [anon_sym_AMP_AMP] = ACTIONS(4588),
    [anon_sym_PIPE_PIPE] = ACTIONS(4588),
    [anon_sym_QMARK_QMARK] = ACTIONS(4590),
    [anon_sym_from] = ACTIONS(4588),
    [anon_sym_join] = ACTIONS(4588),
    [anon_sym_on] = ACTIONS(4588),
    [anon_sym_equals] = ACTIONS(4588),
    [anon_sym_let] = ACTIONS(4588),
    [anon_sym_orderby] = ACTIONS(4588),
    [anon_sym_group] = ACTIONS(4588),
    [anon_sym_by] = ACTIONS(4588),
    [anon_sym_select] = ACTIONS(4588),
    [anon_sym_as] = ACTIONS(4588),
    [anon_sym_is] = ACTIONS(4588),
    [anon_sym_DASH_GT] = ACTIONS(4588),
    [anon_sym_with] = ACTIONS(4588),
    [aux_sym_preproc_if_token3] = ACTIONS(4588),
    [aux_sym_preproc_else_token1] = ACTIONS(4588),
    [aux_sym_preproc_elif_token1] = ACTIONS(4588),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3015] = {
    [sym_preproc_region] = STATE(3015),
    [sym_preproc_endregion] = STATE(3015),
    [sym_preproc_line] = STATE(3015),
    [sym_preproc_pragma] = STATE(3015),
    [sym_preproc_nullable] = STATE(3015),
    [sym_preproc_error] = STATE(3015),
    [sym_preproc_define] = STATE(3015),
    [sym_preproc_undef] = STATE(3015),
    [anon_sym_SEMI] = ACTIONS(4635),
    [anon_sym_EQ] = ACTIONS(4637),
    [anon_sym_LBRACK] = ACTIONS(4635),
    [anon_sym_COLON] = ACTIONS(4635),
    [anon_sym_COMMA] = ACTIONS(4635),
    [anon_sym_RBRACK] = ACTIONS(4635),
    [anon_sym_LPAREN] = ACTIONS(4635),
    [anon_sym_RPAREN] = ACTIONS(4635),
    [anon_sym_RBRACE] = ACTIONS(4635),
    [anon_sym_LT] = ACTIONS(4637),
    [anon_sym_GT] = ACTIONS(4637),
    [anon_sym_in] = ACTIONS(4635),
    [anon_sym_where] = ACTIONS(4635),
    [anon_sym_QMARK] = ACTIONS(4637),
    [anon_sym_BANG] = ACTIONS(4637),
    [anon_sym_PLUS_PLUS] = ACTIONS(4635),
    [anon_sym_DASH_DASH] = ACTIONS(4635),
    [anon_sym_PLUS] = ACTIONS(4637),
    [anon_sym_DASH] = ACTIONS(4637),
    [anon_sym_STAR] = ACTIONS(4637),
    [anon_sym_SLASH] = ACTIONS(4637),
    [anon_sym_PERCENT] = ACTIONS(4637),
    [anon_sym_CARET] = ACTIONS(4637),
    [anon_sym_PIPE] = ACTIONS(4637),
    [anon_sym_AMP] = ACTIONS(4637),
    [anon_sym_LT_LT] = ACTIONS(4637),
    [anon_sym_GT_GT] = ACTIONS(4637),
    [anon_sym_GT_GT_GT] = ACTIONS(4637),
    [anon_sym_EQ_EQ] = ACTIONS(4635),
    [anon_sym_BANG_EQ] = ACTIONS(4635),
    [anon_sym_GT_EQ] = ACTIONS(4635),
    [anon_sym_LT_EQ] = ACTIONS(4635),
    [anon_sym_DOT] = ACTIONS(4637),
    [anon_sym_EQ_GT] = ACTIONS(4635),
    [anon_sym_switch] = ACTIONS(4635),
    [anon_sym_DOT_DOT] = ACTIONS(4635),
    [anon_sym_and] = ACTIONS(4635),
    [anon_sym_or] = ACTIONS(4637),
    [anon_sym_PLUS_EQ] = ACTIONS(4635),
    [anon_sym_DASH_EQ] = ACTIONS(4635),
    [anon_sym_STAR_EQ] = ACTIONS(4635),
    [anon_sym_SLASH_EQ] = ACTIONS(4635),
    [anon_sym_PERCENT_EQ] = ACTIONS(4635),
    [anon_sym_AMP_EQ] = ACTIONS(4635),
    [anon_sym_CARET_EQ] = ACTIONS(4635),
    [anon_sym_PIPE_EQ] = ACTIONS(4635),
    [anon_sym_LT_LT_EQ] = ACTIONS(4635),
    [anon_sym_GT_GT_EQ] = ACTIONS(4635),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4635),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4635),
    [anon_sym_AMP_AMP] = ACTIONS(4635),
    [anon_sym_PIPE_PIPE] = ACTIONS(4635),
    [anon_sym_QMARK_QMARK] = ACTIONS(4637),
    [anon_sym_from] = ACTIONS(4635),
    [anon_sym_join] = ACTIONS(4635),
    [anon_sym_on] = ACTIONS(4635),
    [anon_sym_equals] = ACTIONS(4635),
    [anon_sym_let] = ACTIONS(4635),
    [anon_sym_orderby] = ACTIONS(4635),
    [anon_sym_group] = ACTIONS(4635),
    [anon_sym_by] = ACTIONS(4635),
    [anon_sym_select] = ACTIONS(4635),
    [anon_sym_as] = ACTIONS(4635),
    [anon_sym_is] = ACTIONS(4635),
    [anon_sym_DASH_GT] = ACTIONS(4635),
    [anon_sym_with] = ACTIONS(4635),
    [aux_sym_preproc_if_token3] = ACTIONS(4635),
    [aux_sym_preproc_else_token1] = ACTIONS(4635),
    [aux_sym_preproc_elif_token1] = ACTIONS(4635),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3016] = {
    [sym_parameter_list] = STATE(9765),
    [sym_positional_pattern_clause] = STATE(3110),
    [sym_property_pattern_clause] = STATE(3170),
    [sym__variable_designation] = STATE(4642),
    [sym_parenthesized_variable_designation] = STATE(4614),
    [sym__lambda_parameters] = STATE(9127),
    [sym_identifier] = STATE(4502),
    [sym__reserved_identifier] = STATE(2914),
    [sym_preproc_region] = STATE(3016),
    [sym_preproc_endregion] = STATE(3016),
    [sym_preproc_line] = STATE(3016),
    [sym_preproc_pragma] = STATE(3016),
    [sym_preproc_nullable] = STATE(3016),
    [sym_preproc_error] = STATE(3016),
    [sym_preproc_define] = STATE(3016),
    [sym_preproc_undef] = STATE(3016),
    [sym__identifier_token] = ACTIONS(4490),
    [anon_sym_alias] = ACTIONS(4492),
    [anon_sym_global] = ACTIONS(4492),
    [anon_sym_LBRACK] = ACTIONS(4283),
    [anon_sym_COMMA] = ACTIONS(4283),
    [anon_sym_LPAREN] = ACTIONS(4283),
    [anon_sym_LBRACE] = ACTIONS(4277),
    [anon_sym_file] = ACTIONS(4492),
    [anon_sym_LT] = ACTIONS(4285),
    [anon_sym_GT] = ACTIONS(4285),
    [anon_sym_where] = ACTIONS(4285),
    [anon_sym_QMARK] = ACTIONS(4285),
    [anon_sym_notnull] = ACTIONS(4492),
    [anon_sym_unmanaged] = ACTIONS(4492),
    [anon_sym_BANG] = ACTIONS(4285),
    [anon_sym_PLUS_PLUS] = ACTIONS(4283),
    [anon_sym_DASH_DASH] = ACTIONS(4283),
    [anon_sym_PLUS] = ACTIONS(4285),
    [anon_sym_DASH] = ACTIONS(4285),
    [anon_sym_STAR] = ACTIONS(4283),
    [anon_sym_SLASH] = ACTIONS(4285),
    [anon_sym_PERCENT] = ACTIONS(4283),
    [anon_sym_CARET] = ACTIONS(4283),
    [anon_sym_PIPE] = ACTIONS(4285),
    [anon_sym_AMP] = ACTIONS(4285),
    [anon_sym_LT_LT] = ACTIONS(4283),
    [anon_sym_GT_GT] = ACTIONS(4285),
    [anon_sym_GT_GT_GT] = ACTIONS(4283),
    [anon_sym_EQ_EQ] = ACTIONS(4283),
    [anon_sym_BANG_EQ] = ACTIONS(4283),
    [anon_sym_GT_EQ] = ACTIONS(4283),
    [anon_sym_LT_EQ] = ACTIONS(4283),
    [anon_sym_DOT] = ACTIONS(4285),
    [anon_sym_scoped] = ACTIONS(4492),
    [anon_sym_var] = ACTIONS(4492),
    [anon_sym_yield] = ACTIONS(4492),
    [anon_sym_switch] = ACTIONS(4285),
    [anon_sym_when] = ACTIONS(4492),
    [sym_discard] = ACTIONS(4647),
    [anon_sym_DOT_DOT] = ACTIONS(4283),
    [anon_sym_and] = ACTIONS(4285),
    [anon_sym_or] = ACTIONS(4285),
    [anon_sym_AMP_AMP] = ACTIONS(4283),
    [anon_sym_PIPE_PIPE] = ACTIONS(4283),
    [anon_sym_QMARK_QMARK] = ACTIONS(4283),
    [anon_sym_from] = ACTIONS(4285),
    [anon_sym_into] = ACTIONS(4492),
    [anon_sym_join] = ACTIONS(4285),
    [anon_sym_on] = ACTIONS(4492),
    [anon_sym_equals] = ACTIONS(4492),
    [anon_sym_let] = ACTIONS(4285),
    [anon_sym_orderby] = ACTIONS(4285),
    [anon_sym_ascending] = ACTIONS(4285),
    [anon_sym_descending] = ACTIONS(4285),
    [anon_sym_group] = ACTIONS(4285),
    [anon_sym_by] = ACTIONS(4492),
    [anon_sym_select] = ACTIONS(4285),
    [anon_sym_as] = ACTIONS(4285),
    [anon_sym_is] = ACTIONS(4285),
    [anon_sym_DASH_GT] = ACTIONS(4283),
    [anon_sym_with] = ACTIONS(4285),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3017] = {
    [sym_parameter_list] = STATE(9765),
    [sym_positional_pattern_clause] = STATE(3096),
    [sym_property_pattern_clause] = STATE(3159),
    [sym__variable_designation] = STATE(4021),
    [sym_parenthesized_variable_designation] = STATE(4015),
    [sym__lambda_parameters] = STATE(9127),
    [sym_identifier] = STATE(4055),
    [sym__reserved_identifier] = STATE(3908),
    [sym_preproc_region] = STATE(3017),
    [sym_preproc_endregion] = STATE(3017),
    [sym_preproc_line] = STATE(3017),
    [sym_preproc_pragma] = STATE(3017),
    [sym_preproc_nullable] = STATE(3017),
    [sym_preproc_error] = STATE(3017),
    [sym_preproc_define] = STATE(3017),
    [sym_preproc_undef] = STATE(3017),
    [sym__identifier_token] = ACTIONS(4271),
    [anon_sym_alias] = ACTIONS(4273),
    [anon_sym_global] = ACTIONS(4273),
    [anon_sym_LBRACK] = ACTIONS(4275),
    [anon_sym_COLON] = ACTIONS(4275),
    [anon_sym_LPAREN] = ACTIONS(4275),
    [anon_sym_LBRACE] = ACTIONS(4277),
    [anon_sym_file] = ACTIONS(4273),
    [anon_sym_LT] = ACTIONS(4279),
    [anon_sym_GT] = ACTIONS(4279),
    [anon_sym_where] = ACTIONS(4273),
    [anon_sym_QMARK] = ACTIONS(4279),
    [anon_sym_notnull] = ACTIONS(4273),
    [anon_sym_unmanaged] = ACTIONS(4273),
    [anon_sym_BANG] = ACTIONS(4279),
    [anon_sym_PLUS_PLUS] = ACTIONS(4275),
    [anon_sym_DASH_DASH] = ACTIONS(4275),
    [anon_sym_PLUS] = ACTIONS(4279),
    [anon_sym_DASH] = ACTIONS(4279),
    [anon_sym_STAR] = ACTIONS(4275),
    [anon_sym_SLASH] = ACTIONS(4279),
    [anon_sym_PERCENT] = ACTIONS(4275),
    [anon_sym_CARET] = ACTIONS(4275),
    [anon_sym_PIPE] = ACTIONS(4279),
    [anon_sym_AMP] = ACTIONS(4279),
    [anon_sym_LT_LT] = ACTIONS(4275),
    [anon_sym_GT_GT] = ACTIONS(4279),
    [anon_sym_GT_GT_GT] = ACTIONS(4275),
    [anon_sym_EQ_EQ] = ACTIONS(4275),
    [anon_sym_BANG_EQ] = ACTIONS(4275),
    [anon_sym_GT_EQ] = ACTIONS(4275),
    [anon_sym_LT_EQ] = ACTIONS(4275),
    [anon_sym_DOT] = ACTIONS(4279),
    [anon_sym_scoped] = ACTIONS(4273),
    [anon_sym_var] = ACTIONS(4273),
    [anon_sym_yield] = ACTIONS(4273),
    [anon_sym_switch] = ACTIONS(4279),
    [anon_sym_when] = ACTIONS(4279),
    [sym_discard] = ACTIONS(4281),
    [anon_sym_DOT_DOT] = ACTIONS(4275),
    [anon_sym_and] = ACTIONS(4279),
    [anon_sym_or] = ACTIONS(4279),
    [anon_sym_AMP_AMP] = ACTIONS(4275),
    [anon_sym_PIPE_PIPE] = ACTIONS(4275),
    [anon_sym_QMARK_QMARK] = ACTIONS(4275),
    [anon_sym_from] = ACTIONS(4273),
    [anon_sym_into] = ACTIONS(4279),
    [anon_sym_join] = ACTIONS(4273),
    [anon_sym_on] = ACTIONS(4273),
    [anon_sym_equals] = ACTIONS(4273),
    [anon_sym_let] = ACTIONS(4273),
    [anon_sym_orderby] = ACTIONS(4273),
    [anon_sym_ascending] = ACTIONS(4273),
    [anon_sym_descending] = ACTIONS(4273),
    [anon_sym_group] = ACTIONS(4273),
    [anon_sym_by] = ACTIONS(4273),
    [anon_sym_select] = ACTIONS(4273),
    [anon_sym_as] = ACTIONS(4279),
    [anon_sym_is] = ACTIONS(4279),
    [anon_sym_DASH_GT] = ACTIONS(4275),
    [anon_sym_with] = ACTIONS(4279),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3018] = {
    [sym_parameter_list] = STATE(9765),
    [sym_positional_pattern_clause] = STATE(2826),
    [sym_property_pattern_clause] = STATE(2859),
    [sym__variable_designation] = STATE(4021),
    [sym_parenthesized_variable_designation] = STATE(4015),
    [sym__lambda_parameters] = STATE(9127),
    [sym_identifier] = STATE(5933),
    [sym__reserved_identifier] = STATE(3908),
    [sym_preproc_region] = STATE(3018),
    [sym_preproc_endregion] = STATE(3018),
    [sym_preproc_line] = STATE(3018),
    [sym_preproc_pragma] = STATE(3018),
    [sym_preproc_nullable] = STATE(3018),
    [sym_preproc_error] = STATE(3018),
    [sym_preproc_define] = STATE(3018),
    [sym_preproc_undef] = STATE(3018),
    [sym__identifier_token] = ACTIONS(4271),
    [anon_sym_alias] = ACTIONS(4273),
    [anon_sym_global] = ACTIONS(4273),
    [anon_sym_LBRACK] = ACTIONS(4283),
    [anon_sym_LPAREN] = ACTIONS(4283),
    [anon_sym_LBRACE] = ACTIONS(4277),
    [anon_sym_file] = ACTIONS(4273),
    [anon_sym_LT] = ACTIONS(4285),
    [anon_sym_GT] = ACTIONS(4285),
    [anon_sym_where] = ACTIONS(4273),
    [anon_sym_QMARK] = ACTIONS(4285),
    [anon_sym_notnull] = ACTIONS(4273),
    [anon_sym_unmanaged] = ACTIONS(4273),
    [anon_sym_BANG] = ACTIONS(4285),
    [anon_sym_PLUS_PLUS] = ACTIONS(4283),
    [anon_sym_DASH_DASH] = ACTIONS(4283),
    [anon_sym_PLUS] = ACTIONS(4285),
    [anon_sym_DASH] = ACTIONS(4285),
    [anon_sym_STAR] = ACTIONS(4283),
    [anon_sym_SLASH] = ACTIONS(4285),
    [anon_sym_PERCENT] = ACTIONS(4283),
    [anon_sym_CARET] = ACTIONS(4283),
    [anon_sym_PIPE] = ACTIONS(4285),
    [anon_sym_AMP] = ACTIONS(4285),
    [anon_sym_LT_LT] = ACTIONS(4283),
    [anon_sym_GT_GT] = ACTIONS(4285),
    [anon_sym_GT_GT_GT] = ACTIONS(4283),
    [anon_sym_EQ_EQ] = ACTIONS(4283),
    [anon_sym_BANG_EQ] = ACTIONS(4283),
    [anon_sym_GT_EQ] = ACTIONS(4283),
    [anon_sym_LT_EQ] = ACTIONS(4283),
    [anon_sym_DOT] = ACTIONS(4285),
    [anon_sym_scoped] = ACTIONS(4273),
    [anon_sym_EQ_GT] = ACTIONS(4283),
    [anon_sym_var] = ACTIONS(4273),
    [anon_sym_yield] = ACTIONS(4273),
    [anon_sym_switch] = ACTIONS(4285),
    [anon_sym_when] = ACTIONS(4273),
    [sym_discard] = ACTIONS(4281),
    [anon_sym_DOT_DOT] = ACTIONS(4283),
    [anon_sym_and] = ACTIONS(4285),
    [anon_sym_or] = ACTIONS(4285),
    [anon_sym_AMP_AMP] = ACTIONS(4283),
    [anon_sym_PIPE_PIPE] = ACTIONS(4283),
    [anon_sym_QMARK_QMARK] = ACTIONS(4283),
    [anon_sym_from] = ACTIONS(4273),
    [anon_sym_into] = ACTIONS(4285),
    [anon_sym_join] = ACTIONS(4273),
    [anon_sym_on] = ACTIONS(4273),
    [anon_sym_equals] = ACTIONS(4273),
    [anon_sym_let] = ACTIONS(4273),
    [anon_sym_orderby] = ACTIONS(4273),
    [anon_sym_ascending] = ACTIONS(4273),
    [anon_sym_descending] = ACTIONS(4273),
    [anon_sym_group] = ACTIONS(4273),
    [anon_sym_by] = ACTIONS(4273),
    [anon_sym_select] = ACTIONS(4273),
    [anon_sym_as] = ACTIONS(4285),
    [anon_sym_is] = ACTIONS(4285),
    [anon_sym_DASH_GT] = ACTIONS(4283),
    [anon_sym_with] = ACTIONS(4285),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3019] = {
    [sym_parameter_list] = STATE(9765),
    [sym_positional_pattern_clause] = STATE(3096),
    [sym_property_pattern_clause] = STATE(3159),
    [sym__variable_designation] = STATE(4021),
    [sym_parenthesized_variable_designation] = STATE(4015),
    [sym__lambda_parameters] = STATE(9127),
    [sym_identifier] = STATE(5933),
    [sym__reserved_identifier] = STATE(3908),
    [sym_preproc_region] = STATE(3019),
    [sym_preproc_endregion] = STATE(3019),
    [sym_preproc_line] = STATE(3019),
    [sym_preproc_pragma] = STATE(3019),
    [sym_preproc_nullable] = STATE(3019),
    [sym_preproc_error] = STATE(3019),
    [sym_preproc_define] = STATE(3019),
    [sym_preproc_undef] = STATE(3019),
    [sym__identifier_token] = ACTIONS(4271),
    [anon_sym_alias] = ACTIONS(4273),
    [anon_sym_global] = ACTIONS(4273),
    [anon_sym_LBRACK] = ACTIONS(4275),
    [anon_sym_LPAREN] = ACTIONS(4275),
    [anon_sym_LBRACE] = ACTIONS(4277),
    [anon_sym_file] = ACTIONS(4273),
    [anon_sym_LT] = ACTIONS(4279),
    [anon_sym_GT] = ACTIONS(4279),
    [anon_sym_where] = ACTIONS(4273),
    [anon_sym_QMARK] = ACTIONS(4279),
    [anon_sym_notnull] = ACTIONS(4273),
    [anon_sym_unmanaged] = ACTIONS(4273),
    [anon_sym_BANG] = ACTIONS(4279),
    [anon_sym_PLUS_PLUS] = ACTIONS(4275),
    [anon_sym_DASH_DASH] = ACTIONS(4275),
    [anon_sym_PLUS] = ACTIONS(4279),
    [anon_sym_DASH] = ACTIONS(4279),
    [anon_sym_STAR] = ACTIONS(4275),
    [anon_sym_SLASH] = ACTIONS(4279),
    [anon_sym_PERCENT] = ACTIONS(4275),
    [anon_sym_CARET] = ACTIONS(4275),
    [anon_sym_PIPE] = ACTIONS(4279),
    [anon_sym_AMP] = ACTIONS(4279),
    [anon_sym_LT_LT] = ACTIONS(4275),
    [anon_sym_GT_GT] = ACTIONS(4279),
    [anon_sym_GT_GT_GT] = ACTIONS(4275),
    [anon_sym_EQ_EQ] = ACTIONS(4275),
    [anon_sym_BANG_EQ] = ACTIONS(4275),
    [anon_sym_GT_EQ] = ACTIONS(4275),
    [anon_sym_LT_EQ] = ACTIONS(4275),
    [anon_sym_DOT] = ACTIONS(4279),
    [anon_sym_scoped] = ACTIONS(4273),
    [anon_sym_EQ_GT] = ACTIONS(4275),
    [anon_sym_var] = ACTIONS(4273),
    [anon_sym_yield] = ACTIONS(4273),
    [anon_sym_switch] = ACTIONS(4279),
    [anon_sym_when] = ACTIONS(4279),
    [sym_discard] = ACTIONS(4281),
    [anon_sym_DOT_DOT] = ACTIONS(4275),
    [anon_sym_and] = ACTIONS(4279),
    [anon_sym_or] = ACTIONS(4279),
    [anon_sym_AMP_AMP] = ACTIONS(4275),
    [anon_sym_PIPE_PIPE] = ACTIONS(4275),
    [anon_sym_QMARK_QMARK] = ACTIONS(4275),
    [anon_sym_from] = ACTIONS(4273),
    [anon_sym_into] = ACTIONS(4279),
    [anon_sym_join] = ACTIONS(4273),
    [anon_sym_on] = ACTIONS(4273),
    [anon_sym_equals] = ACTIONS(4273),
    [anon_sym_let] = ACTIONS(4273),
    [anon_sym_orderby] = ACTIONS(4273),
    [anon_sym_ascending] = ACTIONS(4273),
    [anon_sym_descending] = ACTIONS(4273),
    [anon_sym_group] = ACTIONS(4273),
    [anon_sym_by] = ACTIONS(4273),
    [anon_sym_select] = ACTIONS(4273),
    [anon_sym_as] = ACTIONS(4279),
    [anon_sym_is] = ACTIONS(4279),
    [anon_sym_DASH_GT] = ACTIONS(4275),
    [anon_sym_with] = ACTIONS(4279),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3020] = {
    [sym_preproc_region] = STATE(3020),
    [sym_preproc_endregion] = STATE(3020),
    [sym_preproc_line] = STATE(3020),
    [sym_preproc_pragma] = STATE(3020),
    [sym_preproc_nullable] = STATE(3020),
    [sym_preproc_error] = STATE(3020),
    [sym_preproc_define] = STATE(3020),
    [sym_preproc_undef] = STATE(3020),
    [anon_sym_SEMI] = ACTIONS(4639),
    [anon_sym_EQ] = ACTIONS(4625),
    [anon_sym_LBRACK] = ACTIONS(4639),
    [anon_sym_COLON] = ACTIONS(4623),
    [anon_sym_COMMA] = ACTIONS(4639),
    [anon_sym_RBRACK] = ACTIONS(4639),
    [anon_sym_LPAREN] = ACTIONS(4639),
    [anon_sym_RPAREN] = ACTIONS(4639),
    [anon_sym_RBRACE] = ACTIONS(4639),
    [anon_sym_LT] = ACTIONS(4641),
    [anon_sym_GT] = ACTIONS(4641),
    [anon_sym_in] = ACTIONS(4639),
    [anon_sym_where] = ACTIONS(4639),
    [anon_sym_QMARK] = ACTIONS(4641),
    [anon_sym_BANG] = ACTIONS(4641),
    [anon_sym_PLUS_PLUS] = ACTIONS(4639),
    [anon_sym_DASH_DASH] = ACTIONS(4639),
    [anon_sym_PLUS] = ACTIONS(4641),
    [anon_sym_DASH] = ACTIONS(4641),
    [anon_sym_STAR] = ACTIONS(4641),
    [anon_sym_SLASH] = ACTIONS(4641),
    [anon_sym_PERCENT] = ACTIONS(4641),
    [anon_sym_CARET] = ACTIONS(4641),
    [anon_sym_PIPE] = ACTIONS(4641),
    [anon_sym_AMP] = ACTIONS(4641),
    [anon_sym_LT_LT] = ACTIONS(4641),
    [anon_sym_GT_GT] = ACTIONS(4641),
    [anon_sym_GT_GT_GT] = ACTIONS(4641),
    [anon_sym_EQ_EQ] = ACTIONS(4639),
    [anon_sym_BANG_EQ] = ACTIONS(4639),
    [anon_sym_GT_EQ] = ACTIONS(4639),
    [anon_sym_LT_EQ] = ACTIONS(4639),
    [anon_sym_DOT] = ACTIONS(4641),
    [anon_sym_EQ_GT] = ACTIONS(4639),
    [anon_sym_switch] = ACTIONS(4639),
    [anon_sym_DOT_DOT] = ACTIONS(4639),
    [anon_sym_and] = ACTIONS(4639),
    [anon_sym_or] = ACTIONS(4641),
    [anon_sym_PLUS_EQ] = ACTIONS(4623),
    [anon_sym_DASH_EQ] = ACTIONS(4623),
    [anon_sym_STAR_EQ] = ACTIONS(4623),
    [anon_sym_SLASH_EQ] = ACTIONS(4623),
    [anon_sym_PERCENT_EQ] = ACTIONS(4623),
    [anon_sym_AMP_EQ] = ACTIONS(4623),
    [anon_sym_CARET_EQ] = ACTIONS(4623),
    [anon_sym_PIPE_EQ] = ACTIONS(4623),
    [anon_sym_LT_LT_EQ] = ACTIONS(4623),
    [anon_sym_GT_GT_EQ] = ACTIONS(4623),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4623),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4623),
    [anon_sym_AMP_AMP] = ACTIONS(4639),
    [anon_sym_PIPE_PIPE] = ACTIONS(4639),
    [anon_sym_QMARK_QMARK] = ACTIONS(4641),
    [anon_sym_from] = ACTIONS(4639),
    [anon_sym_join] = ACTIONS(4639),
    [anon_sym_on] = ACTIONS(4639),
    [anon_sym_equals] = ACTIONS(4639),
    [anon_sym_let] = ACTIONS(4639),
    [anon_sym_orderby] = ACTIONS(4639),
    [anon_sym_group] = ACTIONS(4639),
    [anon_sym_by] = ACTIONS(4639),
    [anon_sym_select] = ACTIONS(4639),
    [anon_sym_as] = ACTIONS(4639),
    [anon_sym_is] = ACTIONS(4639),
    [anon_sym_DASH_GT] = ACTIONS(4639),
    [anon_sym_with] = ACTIONS(4639),
    [aux_sym_preproc_if_token3] = ACTIONS(4639),
    [aux_sym_preproc_else_token1] = ACTIONS(4639),
    [aux_sym_preproc_elif_token1] = ACTIONS(4639),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3021] = {
    [sym_parameter_list] = STATE(9765),
    [sym_positional_pattern_clause] = STATE(3095),
    [sym_property_pattern_clause] = STATE(3147),
    [sym__variable_designation] = STATE(4260),
    [sym_parenthesized_variable_designation] = STATE(4274),
    [sym__lambda_parameters] = STATE(9127),
    [sym_identifier] = STATE(4259),
    [sym__reserved_identifier] = STATE(3908),
    [sym_preproc_region] = STATE(3021),
    [sym_preproc_endregion] = STATE(3021),
    [sym_preproc_line] = STATE(3021),
    [sym_preproc_pragma] = STATE(3021),
    [sym_preproc_nullable] = STATE(3021),
    [sym_preproc_error] = STATE(3021),
    [sym_preproc_define] = STATE(3021),
    [sym_preproc_undef] = STATE(3021),
    [sym__identifier_token] = ACTIONS(4271),
    [anon_sym_alias] = ACTIONS(4273),
    [anon_sym_global] = ACTIONS(4273),
    [anon_sym_LBRACK] = ACTIONS(4275),
    [anon_sym_COLON] = ACTIONS(4275),
    [anon_sym_LPAREN] = ACTIONS(4275),
    [anon_sym_LBRACE] = ACTIONS(4277),
    [anon_sym_file] = ACTIONS(4273),
    [anon_sym_LT] = ACTIONS(4279),
    [anon_sym_GT] = ACTIONS(4279),
    [anon_sym_where] = ACTIONS(4273),
    [anon_sym_QMARK] = ACTIONS(4279),
    [anon_sym_notnull] = ACTIONS(4273),
    [anon_sym_unmanaged] = ACTIONS(4273),
    [anon_sym_BANG] = ACTIONS(4279),
    [anon_sym_PLUS_PLUS] = ACTIONS(4275),
    [anon_sym_DASH_DASH] = ACTIONS(4275),
    [anon_sym_PLUS] = ACTIONS(4279),
    [anon_sym_DASH] = ACTIONS(4279),
    [anon_sym_STAR] = ACTIONS(4275),
    [anon_sym_SLASH] = ACTIONS(4279),
    [anon_sym_PERCENT] = ACTIONS(4275),
    [anon_sym_CARET] = ACTIONS(4275),
    [anon_sym_PIPE] = ACTIONS(4279),
    [anon_sym_AMP] = ACTIONS(4279),
    [anon_sym_LT_LT] = ACTIONS(4275),
    [anon_sym_GT_GT] = ACTIONS(4279),
    [anon_sym_GT_GT_GT] = ACTIONS(4275),
    [anon_sym_EQ_EQ] = ACTIONS(4275),
    [anon_sym_BANG_EQ] = ACTIONS(4275),
    [anon_sym_GT_EQ] = ACTIONS(4275),
    [anon_sym_LT_EQ] = ACTIONS(4275),
    [anon_sym_DOT] = ACTIONS(4279),
    [anon_sym_scoped] = ACTIONS(4273),
    [anon_sym_var] = ACTIONS(4273),
    [anon_sym_yield] = ACTIONS(4273),
    [anon_sym_switch] = ACTIONS(4279),
    [anon_sym_when] = ACTIONS(4279),
    [sym_discard] = ACTIONS(4295),
    [anon_sym_DOT_DOT] = ACTIONS(4275),
    [anon_sym_and] = ACTIONS(4279),
    [anon_sym_or] = ACTIONS(4279),
    [anon_sym_AMP_AMP] = ACTIONS(4275),
    [anon_sym_PIPE_PIPE] = ACTIONS(4275),
    [anon_sym_QMARK_QMARK] = ACTIONS(4275),
    [anon_sym_from] = ACTIONS(4273),
    [anon_sym_into] = ACTIONS(4273),
    [anon_sym_join] = ACTIONS(4273),
    [anon_sym_on] = ACTIONS(4273),
    [anon_sym_equals] = ACTIONS(4273),
    [anon_sym_let] = ACTIONS(4273),
    [anon_sym_orderby] = ACTIONS(4273),
    [anon_sym_ascending] = ACTIONS(4273),
    [anon_sym_descending] = ACTIONS(4273),
    [anon_sym_group] = ACTIONS(4273),
    [anon_sym_by] = ACTIONS(4273),
    [anon_sym_select] = ACTIONS(4273),
    [anon_sym_as] = ACTIONS(4279),
    [anon_sym_is] = ACTIONS(4279),
    [anon_sym_DASH_GT] = ACTIONS(4275),
    [anon_sym_with] = ACTIONS(4279),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3022] = {
    [sym_parameter_list] = STATE(9765),
    [sym_positional_pattern_clause] = STATE(3095),
    [sym_property_pattern_clause] = STATE(3147),
    [sym__variable_designation] = STATE(4260),
    [sym_parenthesized_variable_designation] = STATE(4274),
    [sym__lambda_parameters] = STATE(9127),
    [sym_identifier] = STATE(4259),
    [sym__reserved_identifier] = STATE(3908),
    [sym_preproc_region] = STATE(3022),
    [sym_preproc_endregion] = STATE(3022),
    [sym_preproc_line] = STATE(3022),
    [sym_preproc_pragma] = STATE(3022),
    [sym_preproc_nullable] = STATE(3022),
    [sym_preproc_error] = STATE(3022),
    [sym_preproc_define] = STATE(3022),
    [sym_preproc_undef] = STATE(3022),
    [sym__identifier_token] = ACTIONS(4271),
    [anon_sym_alias] = ACTIONS(4273),
    [anon_sym_global] = ACTIONS(4273),
    [anon_sym_LBRACK] = ACTIONS(4283),
    [anon_sym_COLON] = ACTIONS(4283),
    [anon_sym_LPAREN] = ACTIONS(4283),
    [anon_sym_LBRACE] = ACTIONS(4277),
    [anon_sym_file] = ACTIONS(4273),
    [anon_sym_LT] = ACTIONS(4285),
    [anon_sym_GT] = ACTIONS(4285),
    [anon_sym_where] = ACTIONS(4273),
    [anon_sym_QMARK] = ACTIONS(4285),
    [anon_sym_notnull] = ACTIONS(4273),
    [anon_sym_unmanaged] = ACTIONS(4273),
    [anon_sym_BANG] = ACTIONS(4285),
    [anon_sym_PLUS_PLUS] = ACTIONS(4283),
    [anon_sym_DASH_DASH] = ACTIONS(4283),
    [anon_sym_PLUS] = ACTIONS(4285),
    [anon_sym_DASH] = ACTIONS(4285),
    [anon_sym_STAR] = ACTIONS(4283),
    [anon_sym_SLASH] = ACTIONS(4285),
    [anon_sym_PERCENT] = ACTIONS(4283),
    [anon_sym_CARET] = ACTIONS(4283),
    [anon_sym_PIPE] = ACTIONS(4285),
    [anon_sym_AMP] = ACTIONS(4285),
    [anon_sym_LT_LT] = ACTIONS(4283),
    [anon_sym_GT_GT] = ACTIONS(4285),
    [anon_sym_GT_GT_GT] = ACTIONS(4283),
    [anon_sym_EQ_EQ] = ACTIONS(4283),
    [anon_sym_BANG_EQ] = ACTIONS(4283),
    [anon_sym_GT_EQ] = ACTIONS(4283),
    [anon_sym_LT_EQ] = ACTIONS(4283),
    [anon_sym_DOT] = ACTIONS(4285),
    [anon_sym_scoped] = ACTIONS(4273),
    [anon_sym_var] = ACTIONS(4273),
    [anon_sym_yield] = ACTIONS(4273),
    [anon_sym_switch] = ACTIONS(4285),
    [anon_sym_when] = ACTIONS(4285),
    [sym_discard] = ACTIONS(4295),
    [anon_sym_DOT_DOT] = ACTIONS(4283),
    [anon_sym_and] = ACTIONS(4285),
    [anon_sym_or] = ACTIONS(4285),
    [anon_sym_AMP_AMP] = ACTIONS(4283),
    [anon_sym_PIPE_PIPE] = ACTIONS(4283),
    [anon_sym_QMARK_QMARK] = ACTIONS(4283),
    [anon_sym_from] = ACTIONS(4273),
    [anon_sym_into] = ACTIONS(4273),
    [anon_sym_join] = ACTIONS(4273),
    [anon_sym_on] = ACTIONS(4273),
    [anon_sym_equals] = ACTIONS(4273),
    [anon_sym_let] = ACTIONS(4273),
    [anon_sym_orderby] = ACTIONS(4273),
    [anon_sym_ascending] = ACTIONS(4273),
    [anon_sym_descending] = ACTIONS(4273),
    [anon_sym_group] = ACTIONS(4273),
    [anon_sym_by] = ACTIONS(4273),
    [anon_sym_select] = ACTIONS(4273),
    [anon_sym_as] = ACTIONS(4285),
    [anon_sym_is] = ACTIONS(4285),
    [anon_sym_DASH_GT] = ACTIONS(4283),
    [anon_sym_with] = ACTIONS(4285),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3023] = {
    [sym_preproc_region] = STATE(3023),
    [sym_preproc_endregion] = STATE(3023),
    [sym_preproc_line] = STATE(3023),
    [sym_preproc_pragma] = STATE(3023),
    [sym_preproc_nullable] = STATE(3023),
    [sym_preproc_error] = STATE(3023),
    [sym_preproc_define] = STATE(3023),
    [sym_preproc_undef] = STATE(3023),
    [anon_sym_SEMI] = ACTIONS(4604),
    [anon_sym_EQ] = ACTIONS(4606),
    [anon_sym_LBRACK] = ACTIONS(4604),
    [anon_sym_COLON] = ACTIONS(4604),
    [anon_sym_COMMA] = ACTIONS(4604),
    [anon_sym_RBRACK] = ACTIONS(4604),
    [anon_sym_LPAREN] = ACTIONS(4604),
    [anon_sym_RPAREN] = ACTIONS(4604),
    [anon_sym_RBRACE] = ACTIONS(4604),
    [anon_sym_LT] = ACTIONS(4606),
    [anon_sym_GT] = ACTIONS(4606),
    [anon_sym_in] = ACTIONS(4604),
    [anon_sym_where] = ACTIONS(4604),
    [anon_sym_QMARK] = ACTIONS(4606),
    [anon_sym_BANG] = ACTIONS(4606),
    [anon_sym_PLUS_PLUS] = ACTIONS(4604),
    [anon_sym_DASH_DASH] = ACTIONS(4604),
    [anon_sym_PLUS] = ACTIONS(4606),
    [anon_sym_DASH] = ACTIONS(4606),
    [anon_sym_STAR] = ACTIONS(4606),
    [anon_sym_SLASH] = ACTIONS(4606),
    [anon_sym_PERCENT] = ACTIONS(4606),
    [anon_sym_CARET] = ACTIONS(4606),
    [anon_sym_PIPE] = ACTIONS(4606),
    [anon_sym_AMP] = ACTIONS(4606),
    [anon_sym_LT_LT] = ACTIONS(4606),
    [anon_sym_GT_GT] = ACTIONS(4606),
    [anon_sym_GT_GT_GT] = ACTIONS(4606),
    [anon_sym_EQ_EQ] = ACTIONS(4604),
    [anon_sym_BANG_EQ] = ACTIONS(4604),
    [anon_sym_GT_EQ] = ACTIONS(4604),
    [anon_sym_LT_EQ] = ACTIONS(4604),
    [anon_sym_DOT] = ACTIONS(4606),
    [anon_sym_EQ_GT] = ACTIONS(4604),
    [anon_sym_switch] = ACTIONS(4604),
    [anon_sym_DOT_DOT] = ACTIONS(4604),
    [anon_sym_and] = ACTIONS(4604),
    [anon_sym_or] = ACTIONS(4606),
    [anon_sym_PLUS_EQ] = ACTIONS(4604),
    [anon_sym_DASH_EQ] = ACTIONS(4604),
    [anon_sym_STAR_EQ] = ACTIONS(4604),
    [anon_sym_SLASH_EQ] = ACTIONS(4604),
    [anon_sym_PERCENT_EQ] = ACTIONS(4604),
    [anon_sym_AMP_EQ] = ACTIONS(4604),
    [anon_sym_CARET_EQ] = ACTIONS(4604),
    [anon_sym_PIPE_EQ] = ACTIONS(4604),
    [anon_sym_LT_LT_EQ] = ACTIONS(4604),
    [anon_sym_GT_GT_EQ] = ACTIONS(4604),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4604),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4604),
    [anon_sym_AMP_AMP] = ACTIONS(4604),
    [anon_sym_PIPE_PIPE] = ACTIONS(4604),
    [anon_sym_QMARK_QMARK] = ACTIONS(4606),
    [anon_sym_from] = ACTIONS(4604),
    [anon_sym_join] = ACTIONS(4604),
    [anon_sym_on] = ACTIONS(4604),
    [anon_sym_equals] = ACTIONS(4604),
    [anon_sym_let] = ACTIONS(4604),
    [anon_sym_orderby] = ACTIONS(4604),
    [anon_sym_group] = ACTIONS(4604),
    [anon_sym_by] = ACTIONS(4604),
    [anon_sym_select] = ACTIONS(4604),
    [anon_sym_as] = ACTIONS(4604),
    [anon_sym_is] = ACTIONS(4604),
    [anon_sym_DASH_GT] = ACTIONS(4604),
    [anon_sym_with] = ACTIONS(4604),
    [aux_sym_preproc_if_token3] = ACTIONS(4604),
    [aux_sym_preproc_else_token1] = ACTIONS(4604),
    [aux_sym_preproc_elif_token1] = ACTIONS(4604),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3024] = {
    [sym_parameter_list] = STATE(9765),
    [sym_positional_pattern_clause] = STATE(3096),
    [sym_property_pattern_clause] = STATE(3159),
    [sym__variable_designation] = STATE(4021),
    [sym_parenthesized_variable_designation] = STATE(4015),
    [sym__lambda_parameters] = STATE(9127),
    [sym_identifier] = STATE(4055),
    [sym__reserved_identifier] = STATE(3908),
    [sym_preproc_region] = STATE(3024),
    [sym_preproc_endregion] = STATE(3024),
    [sym_preproc_line] = STATE(3024),
    [sym_preproc_pragma] = STATE(3024),
    [sym_preproc_nullable] = STATE(3024),
    [sym_preproc_error] = STATE(3024),
    [sym_preproc_define] = STATE(3024),
    [sym_preproc_undef] = STATE(3024),
    [sym__identifier_token] = ACTIONS(4271),
    [anon_sym_alias] = ACTIONS(4273),
    [anon_sym_global] = ACTIONS(4273),
    [anon_sym_LBRACK] = ACTIONS(4283),
    [anon_sym_COLON] = ACTIONS(4283),
    [anon_sym_LPAREN] = ACTIONS(4283),
    [anon_sym_LBRACE] = ACTIONS(4277),
    [anon_sym_file] = ACTIONS(4273),
    [anon_sym_LT] = ACTIONS(4285),
    [anon_sym_GT] = ACTIONS(4285),
    [anon_sym_where] = ACTIONS(4273),
    [anon_sym_QMARK] = ACTIONS(4285),
    [anon_sym_notnull] = ACTIONS(4273),
    [anon_sym_unmanaged] = ACTIONS(4273),
    [anon_sym_BANG] = ACTIONS(4285),
    [anon_sym_PLUS_PLUS] = ACTIONS(4283),
    [anon_sym_DASH_DASH] = ACTIONS(4283),
    [anon_sym_PLUS] = ACTIONS(4285),
    [anon_sym_DASH] = ACTIONS(4285),
    [anon_sym_STAR] = ACTIONS(4283),
    [anon_sym_SLASH] = ACTIONS(4285),
    [anon_sym_PERCENT] = ACTIONS(4283),
    [anon_sym_CARET] = ACTIONS(4283),
    [anon_sym_PIPE] = ACTIONS(4285),
    [anon_sym_AMP] = ACTIONS(4285),
    [anon_sym_LT_LT] = ACTIONS(4283),
    [anon_sym_GT_GT] = ACTIONS(4285),
    [anon_sym_GT_GT_GT] = ACTIONS(4283),
    [anon_sym_EQ_EQ] = ACTIONS(4283),
    [anon_sym_BANG_EQ] = ACTIONS(4283),
    [anon_sym_GT_EQ] = ACTIONS(4283),
    [anon_sym_LT_EQ] = ACTIONS(4283),
    [anon_sym_DOT] = ACTIONS(4285),
    [anon_sym_scoped] = ACTIONS(4273),
    [anon_sym_var] = ACTIONS(4273),
    [anon_sym_yield] = ACTIONS(4273),
    [anon_sym_switch] = ACTIONS(4285),
    [anon_sym_when] = ACTIONS(4285),
    [sym_discard] = ACTIONS(4281),
    [anon_sym_DOT_DOT] = ACTIONS(4283),
    [anon_sym_and] = ACTIONS(4285),
    [anon_sym_or] = ACTIONS(4285),
    [anon_sym_AMP_AMP] = ACTIONS(4283),
    [anon_sym_PIPE_PIPE] = ACTIONS(4283),
    [anon_sym_QMARK_QMARK] = ACTIONS(4283),
    [anon_sym_from] = ACTIONS(4273),
    [anon_sym_into] = ACTIONS(4285),
    [anon_sym_join] = ACTIONS(4273),
    [anon_sym_on] = ACTIONS(4273),
    [anon_sym_equals] = ACTIONS(4273),
    [anon_sym_let] = ACTIONS(4273),
    [anon_sym_orderby] = ACTIONS(4273),
    [anon_sym_ascending] = ACTIONS(4273),
    [anon_sym_descending] = ACTIONS(4273),
    [anon_sym_group] = ACTIONS(4273),
    [anon_sym_by] = ACTIONS(4273),
    [anon_sym_select] = ACTIONS(4273),
    [anon_sym_as] = ACTIONS(4285),
    [anon_sym_is] = ACTIONS(4285),
    [anon_sym_DASH_GT] = ACTIONS(4283),
    [anon_sym_with] = ACTIONS(4285),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3025] = {
    [sym_parameter_list] = STATE(9765),
    [sym_positional_pattern_clause] = STATE(3095),
    [sym_property_pattern_clause] = STATE(3147),
    [sym__variable_designation] = STATE(4260),
    [sym_parenthesized_variable_designation] = STATE(4274),
    [sym__lambda_parameters] = STATE(9127),
    [sym_identifier] = STATE(5933),
    [sym__reserved_identifier] = STATE(3908),
    [sym_preproc_region] = STATE(3025),
    [sym_preproc_endregion] = STATE(3025),
    [sym_preproc_line] = STATE(3025),
    [sym_preproc_pragma] = STATE(3025),
    [sym_preproc_nullable] = STATE(3025),
    [sym_preproc_error] = STATE(3025),
    [sym_preproc_define] = STATE(3025),
    [sym_preproc_undef] = STATE(3025),
    [sym__identifier_token] = ACTIONS(4271),
    [anon_sym_alias] = ACTIONS(4273),
    [anon_sym_global] = ACTIONS(4273),
    [anon_sym_LBRACK] = ACTIONS(4283),
    [anon_sym_LPAREN] = ACTIONS(4283),
    [anon_sym_LBRACE] = ACTIONS(4277),
    [anon_sym_file] = ACTIONS(4273),
    [anon_sym_LT] = ACTIONS(4285),
    [anon_sym_GT] = ACTIONS(4285),
    [anon_sym_where] = ACTIONS(4273),
    [anon_sym_QMARK] = ACTIONS(4285),
    [anon_sym_notnull] = ACTIONS(4273),
    [anon_sym_unmanaged] = ACTIONS(4273),
    [anon_sym_BANG] = ACTIONS(4285),
    [anon_sym_PLUS_PLUS] = ACTIONS(4283),
    [anon_sym_DASH_DASH] = ACTIONS(4283),
    [anon_sym_PLUS] = ACTIONS(4285),
    [anon_sym_DASH] = ACTIONS(4285),
    [anon_sym_STAR] = ACTIONS(4283),
    [anon_sym_SLASH] = ACTIONS(4285),
    [anon_sym_PERCENT] = ACTIONS(4283),
    [anon_sym_CARET] = ACTIONS(4283),
    [anon_sym_PIPE] = ACTIONS(4285),
    [anon_sym_AMP] = ACTIONS(4285),
    [anon_sym_LT_LT] = ACTIONS(4283),
    [anon_sym_GT_GT] = ACTIONS(4285),
    [anon_sym_GT_GT_GT] = ACTIONS(4283),
    [anon_sym_EQ_EQ] = ACTIONS(4283),
    [anon_sym_BANG_EQ] = ACTIONS(4283),
    [anon_sym_GT_EQ] = ACTIONS(4283),
    [anon_sym_LT_EQ] = ACTIONS(4283),
    [anon_sym_DOT] = ACTIONS(4285),
    [anon_sym_scoped] = ACTIONS(4273),
    [anon_sym_EQ_GT] = ACTIONS(4283),
    [anon_sym_var] = ACTIONS(4273),
    [anon_sym_yield] = ACTIONS(4273),
    [anon_sym_switch] = ACTIONS(4285),
    [anon_sym_when] = ACTIONS(4285),
    [sym_discard] = ACTIONS(4295),
    [anon_sym_DOT_DOT] = ACTIONS(4283),
    [anon_sym_and] = ACTIONS(4285),
    [anon_sym_or] = ACTIONS(4285),
    [anon_sym_AMP_AMP] = ACTIONS(4283),
    [anon_sym_PIPE_PIPE] = ACTIONS(4283),
    [anon_sym_QMARK_QMARK] = ACTIONS(4283),
    [anon_sym_from] = ACTIONS(4273),
    [anon_sym_into] = ACTIONS(4273),
    [anon_sym_join] = ACTIONS(4273),
    [anon_sym_on] = ACTIONS(4273),
    [anon_sym_equals] = ACTIONS(4273),
    [anon_sym_let] = ACTIONS(4273),
    [anon_sym_orderby] = ACTIONS(4273),
    [anon_sym_ascending] = ACTIONS(4273),
    [anon_sym_descending] = ACTIONS(4273),
    [anon_sym_group] = ACTIONS(4273),
    [anon_sym_by] = ACTIONS(4273),
    [anon_sym_select] = ACTIONS(4273),
    [anon_sym_as] = ACTIONS(4285),
    [anon_sym_is] = ACTIONS(4285),
    [anon_sym_DASH_GT] = ACTIONS(4283),
    [anon_sym_with] = ACTIONS(4285),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3026] = {
    [sym_parameter_list] = STATE(9765),
    [sym_positional_pattern_clause] = STATE(3114),
    [sym_property_pattern_clause] = STATE(3175),
    [sym__variable_designation] = STATE(4260),
    [sym_parenthesized_variable_designation] = STATE(4274),
    [sym__lambda_parameters] = STATE(9127),
    [sym_identifier] = STATE(4259),
    [sym__reserved_identifier] = STATE(3897),
    [sym_preproc_region] = STATE(3026),
    [sym_preproc_endregion] = STATE(3026),
    [sym_preproc_line] = STATE(3026),
    [sym_preproc_pragma] = STATE(3026),
    [sym_preproc_nullable] = STATE(3026),
    [sym_preproc_error] = STATE(3026),
    [sym_preproc_define] = STATE(3026),
    [sym_preproc_undef] = STATE(3026),
    [sym__identifier_token] = ACTIONS(4168),
    [anon_sym_alias] = ACTIONS(4170),
    [anon_sym_global] = ACTIONS(4170),
    [anon_sym_LBRACK] = ACTIONS(4283),
    [anon_sym_LPAREN] = ACTIONS(4283),
    [anon_sym_LBRACE] = ACTIONS(4277),
    [anon_sym_file] = ACTIONS(4170),
    [anon_sym_LT] = ACTIONS(4285),
    [anon_sym_GT] = ACTIONS(4285),
    [anon_sym_in] = ACTIONS(4285),
    [anon_sym_where] = ACTIONS(4170),
    [anon_sym_QMARK] = ACTIONS(4285),
    [anon_sym_notnull] = ACTIONS(4170),
    [anon_sym_unmanaged] = ACTIONS(4170),
    [anon_sym_BANG] = ACTIONS(4285),
    [anon_sym_PLUS_PLUS] = ACTIONS(4283),
    [anon_sym_DASH_DASH] = ACTIONS(4283),
    [anon_sym_PLUS] = ACTIONS(4285),
    [anon_sym_DASH] = ACTIONS(4285),
    [anon_sym_STAR] = ACTIONS(4283),
    [anon_sym_SLASH] = ACTIONS(4285),
    [anon_sym_PERCENT] = ACTIONS(4283),
    [anon_sym_CARET] = ACTIONS(4283),
    [anon_sym_PIPE] = ACTIONS(4285),
    [anon_sym_AMP] = ACTIONS(4285),
    [anon_sym_LT_LT] = ACTIONS(4283),
    [anon_sym_GT_GT] = ACTIONS(4285),
    [anon_sym_GT_GT_GT] = ACTIONS(4283),
    [anon_sym_EQ_EQ] = ACTIONS(4283),
    [anon_sym_BANG_EQ] = ACTIONS(4283),
    [anon_sym_GT_EQ] = ACTIONS(4283),
    [anon_sym_LT_EQ] = ACTIONS(4283),
    [anon_sym_DOT] = ACTIONS(4285),
    [anon_sym_scoped] = ACTIONS(4170),
    [anon_sym_var] = ACTIONS(4170),
    [anon_sym_yield] = ACTIONS(4170),
    [anon_sym_switch] = ACTIONS(4285),
    [anon_sym_when] = ACTIONS(4170),
    [sym_discard] = ACTIONS(4295),
    [anon_sym_DOT_DOT] = ACTIONS(4283),
    [anon_sym_and] = ACTIONS(4279),
    [anon_sym_or] = ACTIONS(4279),
    [anon_sym_AMP_AMP] = ACTIONS(4283),
    [anon_sym_PIPE_PIPE] = ACTIONS(4283),
    [anon_sym_QMARK_QMARK] = ACTIONS(4283),
    [anon_sym_from] = ACTIONS(4170),
    [anon_sym_into] = ACTIONS(4170),
    [anon_sym_join] = ACTIONS(4170),
    [anon_sym_on] = ACTIONS(4170),
    [anon_sym_equals] = ACTIONS(4170),
    [anon_sym_let] = ACTIONS(4170),
    [anon_sym_orderby] = ACTIONS(4170),
    [anon_sym_ascending] = ACTIONS(4170),
    [anon_sym_descending] = ACTIONS(4170),
    [anon_sym_group] = ACTIONS(4170),
    [anon_sym_by] = ACTIONS(4170),
    [anon_sym_select] = ACTIONS(4170),
    [anon_sym_as] = ACTIONS(4285),
    [anon_sym_is] = ACTIONS(4285),
    [anon_sym_DASH_GT] = ACTIONS(4283),
    [anon_sym_with] = ACTIONS(4285),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3027] = {
    [sym_parameter_list] = STATE(9765),
    [sym_positional_pattern_clause] = STATE(2840),
    [sym_property_pattern_clause] = STATE(2896),
    [sym__variable_designation] = STATE(4260),
    [sym_parenthesized_variable_designation] = STATE(4274),
    [sym__lambda_parameters] = STATE(9127),
    [sym_identifier] = STATE(5933),
    [sym__reserved_identifier] = STATE(3908),
    [sym_preproc_region] = STATE(3027),
    [sym_preproc_endregion] = STATE(3027),
    [sym_preproc_line] = STATE(3027),
    [sym_preproc_pragma] = STATE(3027),
    [sym_preproc_nullable] = STATE(3027),
    [sym_preproc_error] = STATE(3027),
    [sym_preproc_define] = STATE(3027),
    [sym_preproc_undef] = STATE(3027),
    [sym__identifier_token] = ACTIONS(4271),
    [anon_sym_alias] = ACTIONS(4273),
    [anon_sym_global] = ACTIONS(4273),
    [anon_sym_LBRACK] = ACTIONS(4283),
    [anon_sym_LPAREN] = ACTIONS(4283),
    [anon_sym_LBRACE] = ACTIONS(4277),
    [anon_sym_file] = ACTIONS(4273),
    [anon_sym_LT] = ACTIONS(4285),
    [anon_sym_GT] = ACTIONS(4285),
    [anon_sym_where] = ACTIONS(4273),
    [anon_sym_QMARK] = ACTIONS(4285),
    [anon_sym_notnull] = ACTIONS(4273),
    [anon_sym_unmanaged] = ACTIONS(4273),
    [anon_sym_BANG] = ACTIONS(4285),
    [anon_sym_PLUS_PLUS] = ACTIONS(4283),
    [anon_sym_DASH_DASH] = ACTIONS(4283),
    [anon_sym_PLUS] = ACTIONS(4285),
    [anon_sym_DASH] = ACTIONS(4285),
    [anon_sym_STAR] = ACTIONS(4283),
    [anon_sym_SLASH] = ACTIONS(4285),
    [anon_sym_PERCENT] = ACTIONS(4283),
    [anon_sym_CARET] = ACTIONS(4283),
    [anon_sym_PIPE] = ACTIONS(4285),
    [anon_sym_AMP] = ACTIONS(4285),
    [anon_sym_LT_LT] = ACTIONS(4283),
    [anon_sym_GT_GT] = ACTIONS(4285),
    [anon_sym_GT_GT_GT] = ACTIONS(4283),
    [anon_sym_EQ_EQ] = ACTIONS(4283),
    [anon_sym_BANG_EQ] = ACTIONS(4283),
    [anon_sym_GT_EQ] = ACTIONS(4283),
    [anon_sym_LT_EQ] = ACTIONS(4283),
    [anon_sym_DOT] = ACTIONS(4285),
    [anon_sym_scoped] = ACTIONS(4273),
    [anon_sym_EQ_GT] = ACTIONS(4283),
    [anon_sym_var] = ACTIONS(4273),
    [anon_sym_yield] = ACTIONS(4273),
    [anon_sym_switch] = ACTIONS(4285),
    [anon_sym_when] = ACTIONS(4273),
    [sym_discard] = ACTIONS(4295),
    [anon_sym_DOT_DOT] = ACTIONS(4283),
    [anon_sym_and] = ACTIONS(4279),
    [anon_sym_or] = ACTIONS(4279),
    [anon_sym_AMP_AMP] = ACTIONS(4283),
    [anon_sym_PIPE_PIPE] = ACTIONS(4283),
    [anon_sym_QMARK_QMARK] = ACTIONS(4283),
    [anon_sym_from] = ACTIONS(4273),
    [anon_sym_into] = ACTIONS(4273),
    [anon_sym_join] = ACTIONS(4273),
    [anon_sym_on] = ACTIONS(4273),
    [anon_sym_equals] = ACTIONS(4273),
    [anon_sym_let] = ACTIONS(4273),
    [anon_sym_orderby] = ACTIONS(4273),
    [anon_sym_ascending] = ACTIONS(4273),
    [anon_sym_descending] = ACTIONS(4273),
    [anon_sym_group] = ACTIONS(4273),
    [anon_sym_by] = ACTIONS(4273),
    [anon_sym_select] = ACTIONS(4273),
    [anon_sym_as] = ACTIONS(4285),
    [anon_sym_is] = ACTIONS(4285),
    [anon_sym_DASH_GT] = ACTIONS(4283),
    [anon_sym_with] = ACTIONS(4285),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3028] = {
    [sym_preproc_region] = STATE(3028),
    [sym_preproc_endregion] = STATE(3028),
    [sym_preproc_line] = STATE(3028),
    [sym_preproc_pragma] = STATE(3028),
    [sym_preproc_nullable] = STATE(3028),
    [sym_preproc_error] = STATE(3028),
    [sym_preproc_define] = STATE(3028),
    [sym_preproc_undef] = STATE(3028),
    [anon_sym_SEMI] = ACTIONS(4615),
    [anon_sym_EQ] = ACTIONS(4617),
    [anon_sym_LBRACK] = ACTIONS(4615),
    [anon_sym_COLON] = ACTIONS(4615),
    [anon_sym_COMMA] = ACTIONS(4615),
    [anon_sym_RBRACK] = ACTIONS(4615),
    [anon_sym_LPAREN] = ACTIONS(4615),
    [anon_sym_RPAREN] = ACTIONS(4615),
    [anon_sym_RBRACE] = ACTIONS(4615),
    [anon_sym_LT] = ACTIONS(4617),
    [anon_sym_GT] = ACTIONS(4617),
    [anon_sym_in] = ACTIONS(4615),
    [anon_sym_where] = ACTIONS(4615),
    [anon_sym_QMARK] = ACTIONS(4617),
    [anon_sym_BANG] = ACTIONS(4617),
    [anon_sym_PLUS_PLUS] = ACTIONS(4615),
    [anon_sym_DASH_DASH] = ACTIONS(4615),
    [anon_sym_PLUS] = ACTIONS(4617),
    [anon_sym_DASH] = ACTIONS(4617),
    [anon_sym_STAR] = ACTIONS(4617),
    [anon_sym_SLASH] = ACTIONS(4617),
    [anon_sym_PERCENT] = ACTIONS(4617),
    [anon_sym_CARET] = ACTIONS(4617),
    [anon_sym_PIPE] = ACTIONS(4617),
    [anon_sym_AMP] = ACTIONS(4617),
    [anon_sym_LT_LT] = ACTIONS(4617),
    [anon_sym_GT_GT] = ACTIONS(4617),
    [anon_sym_GT_GT_GT] = ACTIONS(4617),
    [anon_sym_EQ_EQ] = ACTIONS(4615),
    [anon_sym_BANG_EQ] = ACTIONS(4615),
    [anon_sym_GT_EQ] = ACTIONS(4615),
    [anon_sym_LT_EQ] = ACTIONS(4615),
    [anon_sym_DOT] = ACTIONS(4617),
    [anon_sym_EQ_GT] = ACTIONS(4615),
    [anon_sym_switch] = ACTIONS(4615),
    [anon_sym_DOT_DOT] = ACTIONS(4615),
    [anon_sym_and] = ACTIONS(4615),
    [anon_sym_or] = ACTIONS(4617),
    [anon_sym_PLUS_EQ] = ACTIONS(4615),
    [anon_sym_DASH_EQ] = ACTIONS(4615),
    [anon_sym_STAR_EQ] = ACTIONS(4615),
    [anon_sym_SLASH_EQ] = ACTIONS(4615),
    [anon_sym_PERCENT_EQ] = ACTIONS(4615),
    [anon_sym_AMP_EQ] = ACTIONS(4615),
    [anon_sym_CARET_EQ] = ACTIONS(4615),
    [anon_sym_PIPE_EQ] = ACTIONS(4615),
    [anon_sym_LT_LT_EQ] = ACTIONS(4615),
    [anon_sym_GT_GT_EQ] = ACTIONS(4615),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4615),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4615),
    [anon_sym_AMP_AMP] = ACTIONS(4615),
    [anon_sym_PIPE_PIPE] = ACTIONS(4615),
    [anon_sym_QMARK_QMARK] = ACTIONS(4617),
    [anon_sym_from] = ACTIONS(4615),
    [anon_sym_join] = ACTIONS(4615),
    [anon_sym_on] = ACTIONS(4615),
    [anon_sym_equals] = ACTIONS(4615),
    [anon_sym_let] = ACTIONS(4615),
    [anon_sym_orderby] = ACTIONS(4615),
    [anon_sym_group] = ACTIONS(4615),
    [anon_sym_by] = ACTIONS(4615),
    [anon_sym_select] = ACTIONS(4615),
    [anon_sym_as] = ACTIONS(4615),
    [anon_sym_is] = ACTIONS(4615),
    [anon_sym_DASH_GT] = ACTIONS(4615),
    [anon_sym_with] = ACTIONS(4615),
    [aux_sym_preproc_if_token3] = ACTIONS(4615),
    [aux_sym_preproc_else_token1] = ACTIONS(4615),
    [aux_sym_preproc_elif_token1] = ACTIONS(4615),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3029] = {
    [sym_parameter_list] = STATE(9765),
    [sym_positional_pattern_clause] = STATE(3110),
    [sym_property_pattern_clause] = STATE(3170),
    [sym__variable_designation] = STATE(4642),
    [sym_parenthesized_variable_designation] = STATE(4614),
    [sym__lambda_parameters] = STATE(9127),
    [sym_identifier] = STATE(4502),
    [sym__reserved_identifier] = STATE(2914),
    [sym_preproc_region] = STATE(3029),
    [sym_preproc_endregion] = STATE(3029),
    [sym_preproc_line] = STATE(3029),
    [sym_preproc_pragma] = STATE(3029),
    [sym_preproc_nullable] = STATE(3029),
    [sym_preproc_error] = STATE(3029),
    [sym_preproc_define] = STATE(3029),
    [sym_preproc_undef] = STATE(3029),
    [sym__identifier_token] = ACTIONS(4490),
    [anon_sym_alias] = ACTIONS(4492),
    [anon_sym_global] = ACTIONS(4492),
    [anon_sym_LBRACK] = ACTIONS(4275),
    [anon_sym_COMMA] = ACTIONS(4275),
    [anon_sym_LPAREN] = ACTIONS(4275),
    [anon_sym_LBRACE] = ACTIONS(4277),
    [anon_sym_file] = ACTIONS(4492),
    [anon_sym_LT] = ACTIONS(4279),
    [anon_sym_GT] = ACTIONS(4279),
    [anon_sym_where] = ACTIONS(4279),
    [anon_sym_QMARK] = ACTIONS(4279),
    [anon_sym_notnull] = ACTIONS(4492),
    [anon_sym_unmanaged] = ACTIONS(4492),
    [anon_sym_BANG] = ACTIONS(4279),
    [anon_sym_PLUS_PLUS] = ACTIONS(4275),
    [anon_sym_DASH_DASH] = ACTIONS(4275),
    [anon_sym_PLUS] = ACTIONS(4279),
    [anon_sym_DASH] = ACTIONS(4279),
    [anon_sym_STAR] = ACTIONS(4275),
    [anon_sym_SLASH] = ACTIONS(4279),
    [anon_sym_PERCENT] = ACTIONS(4275),
    [anon_sym_CARET] = ACTIONS(4275),
    [anon_sym_PIPE] = ACTIONS(4279),
    [anon_sym_AMP] = ACTIONS(4279),
    [anon_sym_LT_LT] = ACTIONS(4275),
    [anon_sym_GT_GT] = ACTIONS(4279),
    [anon_sym_GT_GT_GT] = ACTIONS(4275),
    [anon_sym_EQ_EQ] = ACTIONS(4275),
    [anon_sym_BANG_EQ] = ACTIONS(4275),
    [anon_sym_GT_EQ] = ACTIONS(4275),
    [anon_sym_LT_EQ] = ACTIONS(4275),
    [anon_sym_DOT] = ACTIONS(4279),
    [anon_sym_scoped] = ACTIONS(4492),
    [anon_sym_var] = ACTIONS(4492),
    [anon_sym_yield] = ACTIONS(4492),
    [anon_sym_switch] = ACTIONS(4279),
    [anon_sym_when] = ACTIONS(4492),
    [sym_discard] = ACTIONS(4647),
    [anon_sym_DOT_DOT] = ACTIONS(4275),
    [anon_sym_and] = ACTIONS(4279),
    [anon_sym_or] = ACTIONS(4279),
    [anon_sym_AMP_AMP] = ACTIONS(4275),
    [anon_sym_PIPE_PIPE] = ACTIONS(4275),
    [anon_sym_QMARK_QMARK] = ACTIONS(4275),
    [anon_sym_from] = ACTIONS(4279),
    [anon_sym_into] = ACTIONS(4492),
    [anon_sym_join] = ACTIONS(4279),
    [anon_sym_on] = ACTIONS(4492),
    [anon_sym_equals] = ACTIONS(4492),
    [anon_sym_let] = ACTIONS(4279),
    [anon_sym_orderby] = ACTIONS(4279),
    [anon_sym_ascending] = ACTIONS(4279),
    [anon_sym_descending] = ACTIONS(4279),
    [anon_sym_group] = ACTIONS(4279),
    [anon_sym_by] = ACTIONS(4492),
    [anon_sym_select] = ACTIONS(4279),
    [anon_sym_as] = ACTIONS(4279),
    [anon_sym_is] = ACTIONS(4279),
    [anon_sym_DASH_GT] = ACTIONS(4275),
    [anon_sym_with] = ACTIONS(4279),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3030] = {
    [sym_parameter_list] = STATE(9765),
    [sym_positional_pattern_clause] = STATE(2826),
    [sym_property_pattern_clause] = STATE(2859),
    [sym__variable_designation] = STATE(4021),
    [sym_parenthesized_variable_designation] = STATE(4015),
    [sym__lambda_parameters] = STATE(9127),
    [sym_identifier] = STATE(5933),
    [sym__reserved_identifier] = STATE(3908),
    [sym_preproc_region] = STATE(3030),
    [sym_preproc_endregion] = STATE(3030),
    [sym_preproc_line] = STATE(3030),
    [sym_preproc_pragma] = STATE(3030),
    [sym_preproc_nullable] = STATE(3030),
    [sym_preproc_error] = STATE(3030),
    [sym_preproc_define] = STATE(3030),
    [sym_preproc_undef] = STATE(3030),
    [sym__identifier_token] = ACTIONS(4271),
    [anon_sym_alias] = ACTIONS(4273),
    [anon_sym_global] = ACTIONS(4273),
    [anon_sym_LBRACK] = ACTIONS(4275),
    [anon_sym_LPAREN] = ACTIONS(4275),
    [anon_sym_LBRACE] = ACTIONS(4277),
    [anon_sym_file] = ACTIONS(4273),
    [anon_sym_LT] = ACTIONS(4279),
    [anon_sym_GT] = ACTIONS(4279),
    [anon_sym_where] = ACTIONS(4273),
    [anon_sym_QMARK] = ACTIONS(4279),
    [anon_sym_notnull] = ACTIONS(4273),
    [anon_sym_unmanaged] = ACTIONS(4273),
    [anon_sym_BANG] = ACTIONS(4279),
    [anon_sym_PLUS_PLUS] = ACTIONS(4275),
    [anon_sym_DASH_DASH] = ACTIONS(4275),
    [anon_sym_PLUS] = ACTIONS(4279),
    [anon_sym_DASH] = ACTIONS(4279),
    [anon_sym_STAR] = ACTIONS(4275),
    [anon_sym_SLASH] = ACTIONS(4279),
    [anon_sym_PERCENT] = ACTIONS(4275),
    [anon_sym_CARET] = ACTIONS(4275),
    [anon_sym_PIPE] = ACTIONS(4279),
    [anon_sym_AMP] = ACTIONS(4279),
    [anon_sym_LT_LT] = ACTIONS(4275),
    [anon_sym_GT_GT] = ACTIONS(4279),
    [anon_sym_GT_GT_GT] = ACTIONS(4275),
    [anon_sym_EQ_EQ] = ACTIONS(4275),
    [anon_sym_BANG_EQ] = ACTIONS(4275),
    [anon_sym_GT_EQ] = ACTIONS(4275),
    [anon_sym_LT_EQ] = ACTIONS(4275),
    [anon_sym_DOT] = ACTIONS(4279),
    [anon_sym_scoped] = ACTIONS(4273),
    [anon_sym_EQ_GT] = ACTIONS(4275),
    [anon_sym_var] = ACTIONS(4273),
    [anon_sym_yield] = ACTIONS(4273),
    [anon_sym_switch] = ACTIONS(4279),
    [anon_sym_when] = ACTIONS(4273),
    [sym_discard] = ACTIONS(4281),
    [anon_sym_DOT_DOT] = ACTIONS(4275),
    [anon_sym_and] = ACTIONS(4279),
    [anon_sym_or] = ACTIONS(4279),
    [anon_sym_AMP_AMP] = ACTIONS(4275),
    [anon_sym_PIPE_PIPE] = ACTIONS(4275),
    [anon_sym_QMARK_QMARK] = ACTIONS(4275),
    [anon_sym_from] = ACTIONS(4273),
    [anon_sym_into] = ACTIONS(4279),
    [anon_sym_join] = ACTIONS(4273),
    [anon_sym_on] = ACTIONS(4273),
    [anon_sym_equals] = ACTIONS(4273),
    [anon_sym_let] = ACTIONS(4273),
    [anon_sym_orderby] = ACTIONS(4273),
    [anon_sym_ascending] = ACTIONS(4273),
    [anon_sym_descending] = ACTIONS(4273),
    [anon_sym_group] = ACTIONS(4273),
    [anon_sym_by] = ACTIONS(4273),
    [anon_sym_select] = ACTIONS(4273),
    [anon_sym_as] = ACTIONS(4279),
    [anon_sym_is] = ACTIONS(4279),
    [anon_sym_DASH_GT] = ACTIONS(4275),
    [anon_sym_with] = ACTIONS(4279),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3031] = {
    [sym_parameter_list] = STATE(9765),
    [sym_positional_pattern_clause] = STATE(3125),
    [sym_property_pattern_clause] = STATE(3194),
    [sym__variable_designation] = STATE(4642),
    [sym_parenthesized_variable_designation] = STATE(4614),
    [sym__lambda_parameters] = STATE(9127),
    [sym_identifier] = STATE(4502),
    [sym__reserved_identifier] = STATE(2914),
    [sym_preproc_region] = STATE(3031),
    [sym_preproc_endregion] = STATE(3031),
    [sym_preproc_line] = STATE(3031),
    [sym_preproc_pragma] = STATE(3031),
    [sym_preproc_nullable] = STATE(3031),
    [sym_preproc_error] = STATE(3031),
    [sym_preproc_define] = STATE(3031),
    [sym_preproc_undef] = STATE(3031),
    [sym__identifier_token] = ACTIONS(4490),
    [anon_sym_alias] = ACTIONS(4492),
    [anon_sym_global] = ACTIONS(4492),
    [anon_sym_LBRACK] = ACTIONS(4283),
    [anon_sym_COMMA] = ACTIONS(4283),
    [anon_sym_LPAREN] = ACTIONS(4283),
    [anon_sym_LBRACE] = ACTIONS(4277),
    [anon_sym_file] = ACTIONS(4492),
    [anon_sym_LT] = ACTIONS(4285),
    [anon_sym_GT] = ACTIONS(4285),
    [anon_sym_where] = ACTIONS(4285),
    [anon_sym_QMARK] = ACTIONS(4285),
    [anon_sym_notnull] = ACTIONS(4492),
    [anon_sym_unmanaged] = ACTIONS(4492),
    [anon_sym_BANG] = ACTIONS(4285),
    [anon_sym_PLUS_PLUS] = ACTIONS(4283),
    [anon_sym_DASH_DASH] = ACTIONS(4283),
    [anon_sym_PLUS] = ACTIONS(4285),
    [anon_sym_DASH] = ACTIONS(4285),
    [anon_sym_STAR] = ACTIONS(4283),
    [anon_sym_SLASH] = ACTIONS(4285),
    [anon_sym_PERCENT] = ACTIONS(4283),
    [anon_sym_CARET] = ACTIONS(4283),
    [anon_sym_PIPE] = ACTIONS(4285),
    [anon_sym_AMP] = ACTIONS(4285),
    [anon_sym_LT_LT] = ACTIONS(4283),
    [anon_sym_GT_GT] = ACTIONS(4285),
    [anon_sym_GT_GT_GT] = ACTIONS(4283),
    [anon_sym_EQ_EQ] = ACTIONS(4283),
    [anon_sym_BANG_EQ] = ACTIONS(4283),
    [anon_sym_GT_EQ] = ACTIONS(4283),
    [anon_sym_LT_EQ] = ACTIONS(4283),
    [anon_sym_DOT] = ACTIONS(4285),
    [anon_sym_scoped] = ACTIONS(4492),
    [anon_sym_var] = ACTIONS(4492),
    [anon_sym_yield] = ACTIONS(4492),
    [anon_sym_switch] = ACTIONS(4285),
    [anon_sym_when] = ACTIONS(4492),
    [sym_discard] = ACTIONS(4647),
    [anon_sym_DOT_DOT] = ACTIONS(4283),
    [anon_sym_and] = ACTIONS(4279),
    [anon_sym_or] = ACTIONS(4279),
    [anon_sym_AMP_AMP] = ACTIONS(4283),
    [anon_sym_PIPE_PIPE] = ACTIONS(4283),
    [anon_sym_QMARK_QMARK] = ACTIONS(4283),
    [anon_sym_from] = ACTIONS(4285),
    [anon_sym_into] = ACTIONS(4285),
    [anon_sym_join] = ACTIONS(4285),
    [anon_sym_on] = ACTIONS(4492),
    [anon_sym_equals] = ACTIONS(4492),
    [anon_sym_let] = ACTIONS(4285),
    [anon_sym_orderby] = ACTIONS(4285),
    [anon_sym_ascending] = ACTIONS(4285),
    [anon_sym_descending] = ACTIONS(4285),
    [anon_sym_group] = ACTIONS(4285),
    [anon_sym_by] = ACTIONS(4492),
    [anon_sym_select] = ACTIONS(4285),
    [anon_sym_as] = ACTIONS(4285),
    [anon_sym_is] = ACTIONS(4285),
    [anon_sym_DASH_GT] = ACTIONS(4283),
    [anon_sym_with] = ACTIONS(4285),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3032] = {
    [sym_parameter_list] = STATE(9765),
    [sym_positional_pattern_clause] = STATE(3114),
    [sym_property_pattern_clause] = STATE(3175),
    [sym__variable_designation] = STATE(4260),
    [sym_parenthesized_variable_designation] = STATE(4274),
    [sym__lambda_parameters] = STATE(9127),
    [sym_identifier] = STATE(4259),
    [sym__reserved_identifier] = STATE(3897),
    [sym_preproc_region] = STATE(3032),
    [sym_preproc_endregion] = STATE(3032),
    [sym_preproc_line] = STATE(3032),
    [sym_preproc_pragma] = STATE(3032),
    [sym_preproc_nullable] = STATE(3032),
    [sym_preproc_error] = STATE(3032),
    [sym_preproc_define] = STATE(3032),
    [sym_preproc_undef] = STATE(3032),
    [sym__identifier_token] = ACTIONS(4168),
    [anon_sym_alias] = ACTIONS(4170),
    [anon_sym_global] = ACTIONS(4170),
    [anon_sym_LBRACK] = ACTIONS(4283),
    [anon_sym_LPAREN] = ACTIONS(4283),
    [anon_sym_LBRACE] = ACTIONS(4277),
    [anon_sym_file] = ACTIONS(4170),
    [anon_sym_LT] = ACTIONS(4285),
    [anon_sym_GT] = ACTIONS(4285),
    [anon_sym_in] = ACTIONS(4285),
    [anon_sym_where] = ACTIONS(4170),
    [anon_sym_QMARK] = ACTIONS(4285),
    [anon_sym_notnull] = ACTIONS(4170),
    [anon_sym_unmanaged] = ACTIONS(4170),
    [anon_sym_BANG] = ACTIONS(4285),
    [anon_sym_PLUS_PLUS] = ACTIONS(4283),
    [anon_sym_DASH_DASH] = ACTIONS(4283),
    [anon_sym_PLUS] = ACTIONS(4285),
    [anon_sym_DASH] = ACTIONS(4285),
    [anon_sym_STAR] = ACTIONS(4283),
    [anon_sym_SLASH] = ACTIONS(4285),
    [anon_sym_PERCENT] = ACTIONS(4283),
    [anon_sym_CARET] = ACTIONS(4283),
    [anon_sym_PIPE] = ACTIONS(4285),
    [anon_sym_AMP] = ACTIONS(4285),
    [anon_sym_LT_LT] = ACTIONS(4283),
    [anon_sym_GT_GT] = ACTIONS(4285),
    [anon_sym_GT_GT_GT] = ACTIONS(4283),
    [anon_sym_EQ_EQ] = ACTIONS(4283),
    [anon_sym_BANG_EQ] = ACTIONS(4283),
    [anon_sym_GT_EQ] = ACTIONS(4283),
    [anon_sym_LT_EQ] = ACTIONS(4283),
    [anon_sym_DOT] = ACTIONS(4285),
    [anon_sym_scoped] = ACTIONS(4170),
    [anon_sym_var] = ACTIONS(4170),
    [anon_sym_yield] = ACTIONS(4170),
    [anon_sym_switch] = ACTIONS(4285),
    [anon_sym_when] = ACTIONS(4170),
    [sym_discard] = ACTIONS(4295),
    [anon_sym_DOT_DOT] = ACTIONS(4283),
    [anon_sym_and] = ACTIONS(4285),
    [anon_sym_or] = ACTIONS(4285),
    [anon_sym_AMP_AMP] = ACTIONS(4283),
    [anon_sym_PIPE_PIPE] = ACTIONS(4283),
    [anon_sym_QMARK_QMARK] = ACTIONS(4283),
    [anon_sym_from] = ACTIONS(4170),
    [anon_sym_into] = ACTIONS(4170),
    [anon_sym_join] = ACTIONS(4170),
    [anon_sym_on] = ACTIONS(4170),
    [anon_sym_equals] = ACTIONS(4170),
    [anon_sym_let] = ACTIONS(4170),
    [anon_sym_orderby] = ACTIONS(4170),
    [anon_sym_ascending] = ACTIONS(4170),
    [anon_sym_descending] = ACTIONS(4170),
    [anon_sym_group] = ACTIONS(4170),
    [anon_sym_by] = ACTIONS(4170),
    [anon_sym_select] = ACTIONS(4170),
    [anon_sym_as] = ACTIONS(4285),
    [anon_sym_is] = ACTIONS(4285),
    [anon_sym_DASH_GT] = ACTIONS(4283),
    [anon_sym_with] = ACTIONS(4285),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3033] = {
    [sym_parameter_list] = STATE(9765),
    [sym_positional_pattern_clause] = STATE(2840),
    [sym_property_pattern_clause] = STATE(2896),
    [sym__variable_designation] = STATE(4260),
    [sym_parenthesized_variable_designation] = STATE(4274),
    [sym__lambda_parameters] = STATE(9127),
    [sym_identifier] = STATE(5933),
    [sym__reserved_identifier] = STATE(3908),
    [sym_preproc_region] = STATE(3033),
    [sym_preproc_endregion] = STATE(3033),
    [sym_preproc_line] = STATE(3033),
    [sym_preproc_pragma] = STATE(3033),
    [sym_preproc_nullable] = STATE(3033),
    [sym_preproc_error] = STATE(3033),
    [sym_preproc_define] = STATE(3033),
    [sym_preproc_undef] = STATE(3033),
    [sym__identifier_token] = ACTIONS(4271),
    [anon_sym_alias] = ACTIONS(4273),
    [anon_sym_global] = ACTIONS(4273),
    [anon_sym_LBRACK] = ACTIONS(4283),
    [anon_sym_LPAREN] = ACTIONS(4283),
    [anon_sym_LBRACE] = ACTIONS(4277),
    [anon_sym_file] = ACTIONS(4273),
    [anon_sym_LT] = ACTIONS(4285),
    [anon_sym_GT] = ACTIONS(4285),
    [anon_sym_where] = ACTIONS(4273),
    [anon_sym_QMARK] = ACTIONS(4285),
    [anon_sym_notnull] = ACTIONS(4273),
    [anon_sym_unmanaged] = ACTIONS(4273),
    [anon_sym_BANG] = ACTIONS(4285),
    [anon_sym_PLUS_PLUS] = ACTIONS(4283),
    [anon_sym_DASH_DASH] = ACTIONS(4283),
    [anon_sym_PLUS] = ACTIONS(4285),
    [anon_sym_DASH] = ACTIONS(4285),
    [anon_sym_STAR] = ACTIONS(4283),
    [anon_sym_SLASH] = ACTIONS(4285),
    [anon_sym_PERCENT] = ACTIONS(4283),
    [anon_sym_CARET] = ACTIONS(4283),
    [anon_sym_PIPE] = ACTIONS(4285),
    [anon_sym_AMP] = ACTIONS(4285),
    [anon_sym_LT_LT] = ACTIONS(4283),
    [anon_sym_GT_GT] = ACTIONS(4285),
    [anon_sym_GT_GT_GT] = ACTIONS(4283),
    [anon_sym_EQ_EQ] = ACTIONS(4283),
    [anon_sym_BANG_EQ] = ACTIONS(4283),
    [anon_sym_GT_EQ] = ACTIONS(4283),
    [anon_sym_LT_EQ] = ACTIONS(4283),
    [anon_sym_DOT] = ACTIONS(4285),
    [anon_sym_scoped] = ACTIONS(4273),
    [anon_sym_EQ_GT] = ACTIONS(4283),
    [anon_sym_var] = ACTIONS(4273),
    [anon_sym_yield] = ACTIONS(4273),
    [anon_sym_switch] = ACTIONS(4285),
    [anon_sym_when] = ACTIONS(4273),
    [sym_discard] = ACTIONS(4295),
    [anon_sym_DOT_DOT] = ACTIONS(4283),
    [anon_sym_and] = ACTIONS(4285),
    [anon_sym_or] = ACTIONS(4285),
    [anon_sym_AMP_AMP] = ACTIONS(4283),
    [anon_sym_PIPE_PIPE] = ACTIONS(4283),
    [anon_sym_QMARK_QMARK] = ACTIONS(4283),
    [anon_sym_from] = ACTIONS(4273),
    [anon_sym_into] = ACTIONS(4273),
    [anon_sym_join] = ACTIONS(4273),
    [anon_sym_on] = ACTIONS(4273),
    [anon_sym_equals] = ACTIONS(4273),
    [anon_sym_let] = ACTIONS(4273),
    [anon_sym_orderby] = ACTIONS(4273),
    [anon_sym_ascending] = ACTIONS(4273),
    [anon_sym_descending] = ACTIONS(4273),
    [anon_sym_group] = ACTIONS(4273),
    [anon_sym_by] = ACTIONS(4273),
    [anon_sym_select] = ACTIONS(4273),
    [anon_sym_as] = ACTIONS(4285),
    [anon_sym_is] = ACTIONS(4285),
    [anon_sym_DASH_GT] = ACTIONS(4283),
    [anon_sym_with] = ACTIONS(4285),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3034] = {
    [sym_parameter_list] = STATE(9765),
    [sym_positional_pattern_clause] = STATE(3095),
    [sym_property_pattern_clause] = STATE(3147),
    [sym__variable_designation] = STATE(4260),
    [sym_parenthesized_variable_designation] = STATE(4274),
    [sym__lambda_parameters] = STATE(9127),
    [sym_identifier] = STATE(5933),
    [sym__reserved_identifier] = STATE(3908),
    [sym_preproc_region] = STATE(3034),
    [sym_preproc_endregion] = STATE(3034),
    [sym_preproc_line] = STATE(3034),
    [sym_preproc_pragma] = STATE(3034),
    [sym_preproc_nullable] = STATE(3034),
    [sym_preproc_error] = STATE(3034),
    [sym_preproc_define] = STATE(3034),
    [sym_preproc_undef] = STATE(3034),
    [sym__identifier_token] = ACTIONS(4271),
    [anon_sym_alias] = ACTIONS(4273),
    [anon_sym_global] = ACTIONS(4273),
    [anon_sym_LBRACK] = ACTIONS(4275),
    [anon_sym_LPAREN] = ACTIONS(4275),
    [anon_sym_LBRACE] = ACTIONS(4277),
    [anon_sym_file] = ACTIONS(4273),
    [anon_sym_LT] = ACTIONS(4279),
    [anon_sym_GT] = ACTIONS(4279),
    [anon_sym_where] = ACTIONS(4273),
    [anon_sym_QMARK] = ACTIONS(4279),
    [anon_sym_notnull] = ACTIONS(4273),
    [anon_sym_unmanaged] = ACTIONS(4273),
    [anon_sym_BANG] = ACTIONS(4279),
    [anon_sym_PLUS_PLUS] = ACTIONS(4275),
    [anon_sym_DASH_DASH] = ACTIONS(4275),
    [anon_sym_PLUS] = ACTIONS(4279),
    [anon_sym_DASH] = ACTIONS(4279),
    [anon_sym_STAR] = ACTIONS(4275),
    [anon_sym_SLASH] = ACTIONS(4279),
    [anon_sym_PERCENT] = ACTIONS(4275),
    [anon_sym_CARET] = ACTIONS(4275),
    [anon_sym_PIPE] = ACTIONS(4279),
    [anon_sym_AMP] = ACTIONS(4279),
    [anon_sym_LT_LT] = ACTIONS(4275),
    [anon_sym_GT_GT] = ACTIONS(4279),
    [anon_sym_GT_GT_GT] = ACTIONS(4275),
    [anon_sym_EQ_EQ] = ACTIONS(4275),
    [anon_sym_BANG_EQ] = ACTIONS(4275),
    [anon_sym_GT_EQ] = ACTIONS(4275),
    [anon_sym_LT_EQ] = ACTIONS(4275),
    [anon_sym_DOT] = ACTIONS(4279),
    [anon_sym_scoped] = ACTIONS(4273),
    [anon_sym_EQ_GT] = ACTIONS(4275),
    [anon_sym_var] = ACTIONS(4273),
    [anon_sym_yield] = ACTIONS(4273),
    [anon_sym_switch] = ACTIONS(4279),
    [anon_sym_when] = ACTIONS(4279),
    [sym_discard] = ACTIONS(4295),
    [anon_sym_DOT_DOT] = ACTIONS(4275),
    [anon_sym_and] = ACTIONS(4279),
    [anon_sym_or] = ACTIONS(4279),
    [anon_sym_AMP_AMP] = ACTIONS(4275),
    [anon_sym_PIPE_PIPE] = ACTIONS(4275),
    [anon_sym_QMARK_QMARK] = ACTIONS(4275),
    [anon_sym_from] = ACTIONS(4273),
    [anon_sym_into] = ACTIONS(4273),
    [anon_sym_join] = ACTIONS(4273),
    [anon_sym_on] = ACTIONS(4273),
    [anon_sym_equals] = ACTIONS(4273),
    [anon_sym_let] = ACTIONS(4273),
    [anon_sym_orderby] = ACTIONS(4273),
    [anon_sym_ascending] = ACTIONS(4273),
    [anon_sym_descending] = ACTIONS(4273),
    [anon_sym_group] = ACTIONS(4273),
    [anon_sym_by] = ACTIONS(4273),
    [anon_sym_select] = ACTIONS(4273),
    [anon_sym_as] = ACTIONS(4279),
    [anon_sym_is] = ACTIONS(4279),
    [anon_sym_DASH_GT] = ACTIONS(4275),
    [anon_sym_with] = ACTIONS(4279),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3035] = {
    [sym_parameter_list] = STATE(9765),
    [sym_positional_pattern_clause] = STATE(3125),
    [sym_property_pattern_clause] = STATE(3194),
    [sym__variable_designation] = STATE(4642),
    [sym_parenthesized_variable_designation] = STATE(4614),
    [sym__lambda_parameters] = STATE(9127),
    [sym_identifier] = STATE(4502),
    [sym__reserved_identifier] = STATE(2914),
    [sym_preproc_region] = STATE(3035),
    [sym_preproc_endregion] = STATE(3035),
    [sym_preproc_line] = STATE(3035),
    [sym_preproc_pragma] = STATE(3035),
    [sym_preproc_nullable] = STATE(3035),
    [sym_preproc_error] = STATE(3035),
    [sym_preproc_define] = STATE(3035),
    [sym_preproc_undef] = STATE(3035),
    [sym__identifier_token] = ACTIONS(4490),
    [anon_sym_alias] = ACTIONS(4492),
    [anon_sym_global] = ACTIONS(4492),
    [anon_sym_LBRACK] = ACTIONS(4283),
    [anon_sym_COMMA] = ACTIONS(4283),
    [anon_sym_LPAREN] = ACTIONS(4283),
    [anon_sym_LBRACE] = ACTIONS(4277),
    [anon_sym_file] = ACTIONS(4492),
    [anon_sym_LT] = ACTIONS(4285),
    [anon_sym_GT] = ACTIONS(4285),
    [anon_sym_where] = ACTIONS(4285),
    [anon_sym_QMARK] = ACTIONS(4285),
    [anon_sym_notnull] = ACTIONS(4492),
    [anon_sym_unmanaged] = ACTIONS(4492),
    [anon_sym_BANG] = ACTIONS(4285),
    [anon_sym_PLUS_PLUS] = ACTIONS(4283),
    [anon_sym_DASH_DASH] = ACTIONS(4283),
    [anon_sym_PLUS] = ACTIONS(4285),
    [anon_sym_DASH] = ACTIONS(4285),
    [anon_sym_STAR] = ACTIONS(4283),
    [anon_sym_SLASH] = ACTIONS(4285),
    [anon_sym_PERCENT] = ACTIONS(4283),
    [anon_sym_CARET] = ACTIONS(4283),
    [anon_sym_PIPE] = ACTIONS(4285),
    [anon_sym_AMP] = ACTIONS(4285),
    [anon_sym_LT_LT] = ACTIONS(4283),
    [anon_sym_GT_GT] = ACTIONS(4285),
    [anon_sym_GT_GT_GT] = ACTIONS(4283),
    [anon_sym_EQ_EQ] = ACTIONS(4283),
    [anon_sym_BANG_EQ] = ACTIONS(4283),
    [anon_sym_GT_EQ] = ACTIONS(4283),
    [anon_sym_LT_EQ] = ACTIONS(4283),
    [anon_sym_DOT] = ACTIONS(4285),
    [anon_sym_scoped] = ACTIONS(4492),
    [anon_sym_var] = ACTIONS(4492),
    [anon_sym_yield] = ACTIONS(4492),
    [anon_sym_switch] = ACTIONS(4285),
    [anon_sym_when] = ACTIONS(4492),
    [sym_discard] = ACTIONS(4647),
    [anon_sym_DOT_DOT] = ACTIONS(4283),
    [anon_sym_and] = ACTIONS(4285),
    [anon_sym_or] = ACTIONS(4285),
    [anon_sym_AMP_AMP] = ACTIONS(4283),
    [anon_sym_PIPE_PIPE] = ACTIONS(4283),
    [anon_sym_QMARK_QMARK] = ACTIONS(4283),
    [anon_sym_from] = ACTIONS(4285),
    [anon_sym_into] = ACTIONS(4285),
    [anon_sym_join] = ACTIONS(4285),
    [anon_sym_on] = ACTIONS(4492),
    [anon_sym_equals] = ACTIONS(4492),
    [anon_sym_let] = ACTIONS(4285),
    [anon_sym_orderby] = ACTIONS(4285),
    [anon_sym_ascending] = ACTIONS(4285),
    [anon_sym_descending] = ACTIONS(4285),
    [anon_sym_group] = ACTIONS(4285),
    [anon_sym_by] = ACTIONS(4492),
    [anon_sym_select] = ACTIONS(4285),
    [anon_sym_as] = ACTIONS(4285),
    [anon_sym_is] = ACTIONS(4285),
    [anon_sym_DASH_GT] = ACTIONS(4283),
    [anon_sym_with] = ACTIONS(4285),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3036] = {
    [sym_parameter_list] = STATE(9765),
    [sym_positional_pattern_clause] = STATE(3114),
    [sym_property_pattern_clause] = STATE(3175),
    [sym__variable_designation] = STATE(4260),
    [sym_parenthesized_variable_designation] = STATE(4274),
    [sym__lambda_parameters] = STATE(9127),
    [sym_identifier] = STATE(4259),
    [sym__reserved_identifier] = STATE(3897),
    [sym_preproc_region] = STATE(3036),
    [sym_preproc_endregion] = STATE(3036),
    [sym_preproc_line] = STATE(3036),
    [sym_preproc_pragma] = STATE(3036),
    [sym_preproc_nullable] = STATE(3036),
    [sym_preproc_error] = STATE(3036),
    [sym_preproc_define] = STATE(3036),
    [sym_preproc_undef] = STATE(3036),
    [sym__identifier_token] = ACTIONS(4168),
    [anon_sym_alias] = ACTIONS(4170),
    [anon_sym_global] = ACTIONS(4170),
    [anon_sym_LBRACK] = ACTIONS(4275),
    [anon_sym_LPAREN] = ACTIONS(4275),
    [anon_sym_LBRACE] = ACTIONS(4277),
    [anon_sym_file] = ACTIONS(4170),
    [anon_sym_LT] = ACTIONS(4279),
    [anon_sym_GT] = ACTIONS(4279),
    [anon_sym_in] = ACTIONS(4279),
    [anon_sym_where] = ACTIONS(4170),
    [anon_sym_QMARK] = ACTIONS(4279),
    [anon_sym_notnull] = ACTIONS(4170),
    [anon_sym_unmanaged] = ACTIONS(4170),
    [anon_sym_BANG] = ACTIONS(4279),
    [anon_sym_PLUS_PLUS] = ACTIONS(4275),
    [anon_sym_DASH_DASH] = ACTIONS(4275),
    [anon_sym_PLUS] = ACTIONS(4279),
    [anon_sym_DASH] = ACTIONS(4279),
    [anon_sym_STAR] = ACTIONS(4275),
    [anon_sym_SLASH] = ACTIONS(4279),
    [anon_sym_PERCENT] = ACTIONS(4275),
    [anon_sym_CARET] = ACTIONS(4275),
    [anon_sym_PIPE] = ACTIONS(4279),
    [anon_sym_AMP] = ACTIONS(4279),
    [anon_sym_LT_LT] = ACTIONS(4275),
    [anon_sym_GT_GT] = ACTIONS(4279),
    [anon_sym_GT_GT_GT] = ACTIONS(4275),
    [anon_sym_EQ_EQ] = ACTIONS(4275),
    [anon_sym_BANG_EQ] = ACTIONS(4275),
    [anon_sym_GT_EQ] = ACTIONS(4275),
    [anon_sym_LT_EQ] = ACTIONS(4275),
    [anon_sym_DOT] = ACTIONS(4279),
    [anon_sym_scoped] = ACTIONS(4170),
    [anon_sym_var] = ACTIONS(4170),
    [anon_sym_yield] = ACTIONS(4170),
    [anon_sym_switch] = ACTIONS(4279),
    [anon_sym_when] = ACTIONS(4170),
    [sym_discard] = ACTIONS(4295),
    [anon_sym_DOT_DOT] = ACTIONS(4275),
    [anon_sym_and] = ACTIONS(4279),
    [anon_sym_or] = ACTIONS(4279),
    [anon_sym_AMP_AMP] = ACTIONS(4275),
    [anon_sym_PIPE_PIPE] = ACTIONS(4275),
    [anon_sym_QMARK_QMARK] = ACTIONS(4275),
    [anon_sym_from] = ACTIONS(4170),
    [anon_sym_into] = ACTIONS(4170),
    [anon_sym_join] = ACTIONS(4170),
    [anon_sym_on] = ACTIONS(4170),
    [anon_sym_equals] = ACTIONS(4170),
    [anon_sym_let] = ACTIONS(4170),
    [anon_sym_orderby] = ACTIONS(4170),
    [anon_sym_ascending] = ACTIONS(4170),
    [anon_sym_descending] = ACTIONS(4170),
    [anon_sym_group] = ACTIONS(4170),
    [anon_sym_by] = ACTIONS(4170),
    [anon_sym_select] = ACTIONS(4170),
    [anon_sym_as] = ACTIONS(4279),
    [anon_sym_is] = ACTIONS(4279),
    [anon_sym_DASH_GT] = ACTIONS(4275),
    [anon_sym_with] = ACTIONS(4279),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3037] = {
    [sym_parameter_list] = STATE(9765),
    [sym_positional_pattern_clause] = STATE(3096),
    [sym_property_pattern_clause] = STATE(3159),
    [sym__variable_designation] = STATE(4021),
    [sym_parenthesized_variable_designation] = STATE(4015),
    [sym__lambda_parameters] = STATE(9127),
    [sym_identifier] = STATE(5933),
    [sym__reserved_identifier] = STATE(3908),
    [sym_preproc_region] = STATE(3037),
    [sym_preproc_endregion] = STATE(3037),
    [sym_preproc_line] = STATE(3037),
    [sym_preproc_pragma] = STATE(3037),
    [sym_preproc_nullable] = STATE(3037),
    [sym_preproc_error] = STATE(3037),
    [sym_preproc_define] = STATE(3037),
    [sym_preproc_undef] = STATE(3037),
    [sym__identifier_token] = ACTIONS(4271),
    [anon_sym_alias] = ACTIONS(4273),
    [anon_sym_global] = ACTIONS(4273),
    [anon_sym_LBRACK] = ACTIONS(4283),
    [anon_sym_LPAREN] = ACTIONS(4283),
    [anon_sym_LBRACE] = ACTIONS(4277),
    [anon_sym_file] = ACTIONS(4273),
    [anon_sym_LT] = ACTIONS(4285),
    [anon_sym_GT] = ACTIONS(4285),
    [anon_sym_where] = ACTIONS(4273),
    [anon_sym_QMARK] = ACTIONS(4285),
    [anon_sym_notnull] = ACTIONS(4273),
    [anon_sym_unmanaged] = ACTIONS(4273),
    [anon_sym_BANG] = ACTIONS(4285),
    [anon_sym_PLUS_PLUS] = ACTIONS(4283),
    [anon_sym_DASH_DASH] = ACTIONS(4283),
    [anon_sym_PLUS] = ACTIONS(4285),
    [anon_sym_DASH] = ACTIONS(4285),
    [anon_sym_STAR] = ACTIONS(4283),
    [anon_sym_SLASH] = ACTIONS(4285),
    [anon_sym_PERCENT] = ACTIONS(4283),
    [anon_sym_CARET] = ACTIONS(4283),
    [anon_sym_PIPE] = ACTIONS(4285),
    [anon_sym_AMP] = ACTIONS(4285),
    [anon_sym_LT_LT] = ACTIONS(4283),
    [anon_sym_GT_GT] = ACTIONS(4285),
    [anon_sym_GT_GT_GT] = ACTIONS(4283),
    [anon_sym_EQ_EQ] = ACTIONS(4283),
    [anon_sym_BANG_EQ] = ACTIONS(4283),
    [anon_sym_GT_EQ] = ACTIONS(4283),
    [anon_sym_LT_EQ] = ACTIONS(4283),
    [anon_sym_DOT] = ACTIONS(4285),
    [anon_sym_scoped] = ACTIONS(4273),
    [anon_sym_EQ_GT] = ACTIONS(4283),
    [anon_sym_var] = ACTIONS(4273),
    [anon_sym_yield] = ACTIONS(4273),
    [anon_sym_switch] = ACTIONS(4285),
    [anon_sym_when] = ACTIONS(4285),
    [sym_discard] = ACTIONS(4281),
    [anon_sym_DOT_DOT] = ACTIONS(4283),
    [anon_sym_and] = ACTIONS(4285),
    [anon_sym_or] = ACTIONS(4285),
    [anon_sym_AMP_AMP] = ACTIONS(4283),
    [anon_sym_PIPE_PIPE] = ACTIONS(4283),
    [anon_sym_QMARK_QMARK] = ACTIONS(4283),
    [anon_sym_from] = ACTIONS(4273),
    [anon_sym_into] = ACTIONS(4285),
    [anon_sym_join] = ACTIONS(4273),
    [anon_sym_on] = ACTIONS(4273),
    [anon_sym_equals] = ACTIONS(4273),
    [anon_sym_let] = ACTIONS(4273),
    [anon_sym_orderby] = ACTIONS(4273),
    [anon_sym_ascending] = ACTIONS(4273),
    [anon_sym_descending] = ACTIONS(4273),
    [anon_sym_group] = ACTIONS(4273),
    [anon_sym_by] = ACTIONS(4273),
    [anon_sym_select] = ACTIONS(4273),
    [anon_sym_as] = ACTIONS(4285),
    [anon_sym_is] = ACTIONS(4285),
    [anon_sym_DASH_GT] = ACTIONS(4283),
    [anon_sym_with] = ACTIONS(4285),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3038] = {
    [sym_parameter_list] = STATE(9765),
    [sym_positional_pattern_clause] = STATE(3110),
    [sym_property_pattern_clause] = STATE(3170),
    [sym__variable_designation] = STATE(4642),
    [sym_parenthesized_variable_designation] = STATE(4614),
    [sym__lambda_parameters] = STATE(9127),
    [sym_identifier] = STATE(4502),
    [sym__reserved_identifier] = STATE(2914),
    [sym_preproc_region] = STATE(3038),
    [sym_preproc_endregion] = STATE(3038),
    [sym_preproc_line] = STATE(3038),
    [sym_preproc_pragma] = STATE(3038),
    [sym_preproc_nullable] = STATE(3038),
    [sym_preproc_error] = STATE(3038),
    [sym_preproc_define] = STATE(3038),
    [sym_preproc_undef] = STATE(3038),
    [sym__identifier_token] = ACTIONS(4490),
    [anon_sym_alias] = ACTIONS(4492),
    [anon_sym_global] = ACTIONS(4492),
    [anon_sym_LBRACK] = ACTIONS(4283),
    [anon_sym_COMMA] = ACTIONS(4283),
    [anon_sym_LPAREN] = ACTIONS(4283),
    [anon_sym_LBRACE] = ACTIONS(4277),
    [anon_sym_file] = ACTIONS(4492),
    [anon_sym_LT] = ACTIONS(4285),
    [anon_sym_GT] = ACTIONS(4285),
    [anon_sym_where] = ACTIONS(4285),
    [anon_sym_QMARK] = ACTIONS(4285),
    [anon_sym_notnull] = ACTIONS(4492),
    [anon_sym_unmanaged] = ACTIONS(4492),
    [anon_sym_BANG] = ACTIONS(4285),
    [anon_sym_PLUS_PLUS] = ACTIONS(4283),
    [anon_sym_DASH_DASH] = ACTIONS(4283),
    [anon_sym_PLUS] = ACTIONS(4285),
    [anon_sym_DASH] = ACTIONS(4285),
    [anon_sym_STAR] = ACTIONS(4283),
    [anon_sym_SLASH] = ACTIONS(4285),
    [anon_sym_PERCENT] = ACTIONS(4283),
    [anon_sym_CARET] = ACTIONS(4283),
    [anon_sym_PIPE] = ACTIONS(4285),
    [anon_sym_AMP] = ACTIONS(4285),
    [anon_sym_LT_LT] = ACTIONS(4283),
    [anon_sym_GT_GT] = ACTIONS(4285),
    [anon_sym_GT_GT_GT] = ACTIONS(4283),
    [anon_sym_EQ_EQ] = ACTIONS(4283),
    [anon_sym_BANG_EQ] = ACTIONS(4283),
    [anon_sym_GT_EQ] = ACTIONS(4283),
    [anon_sym_LT_EQ] = ACTIONS(4283),
    [anon_sym_DOT] = ACTIONS(4285),
    [anon_sym_scoped] = ACTIONS(4492),
    [anon_sym_var] = ACTIONS(4492),
    [anon_sym_yield] = ACTIONS(4492),
    [anon_sym_switch] = ACTIONS(4285),
    [anon_sym_when] = ACTIONS(4492),
    [sym_discard] = ACTIONS(4647),
    [anon_sym_DOT_DOT] = ACTIONS(4283),
    [anon_sym_and] = ACTIONS(4279),
    [anon_sym_or] = ACTIONS(4279),
    [anon_sym_AMP_AMP] = ACTIONS(4283),
    [anon_sym_PIPE_PIPE] = ACTIONS(4283),
    [anon_sym_QMARK_QMARK] = ACTIONS(4283),
    [anon_sym_from] = ACTIONS(4285),
    [anon_sym_into] = ACTIONS(4492),
    [anon_sym_join] = ACTIONS(4285),
    [anon_sym_on] = ACTIONS(4492),
    [anon_sym_equals] = ACTIONS(4492),
    [anon_sym_let] = ACTIONS(4285),
    [anon_sym_orderby] = ACTIONS(4285),
    [anon_sym_ascending] = ACTIONS(4285),
    [anon_sym_descending] = ACTIONS(4285),
    [anon_sym_group] = ACTIONS(4285),
    [anon_sym_by] = ACTIONS(4492),
    [anon_sym_select] = ACTIONS(4285),
    [anon_sym_as] = ACTIONS(4285),
    [anon_sym_is] = ACTIONS(4285),
    [anon_sym_DASH_GT] = ACTIONS(4283),
    [anon_sym_with] = ACTIONS(4285),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3039] = {
    [sym_preproc_region] = STATE(3039),
    [sym_preproc_endregion] = STATE(3039),
    [sym_preproc_line] = STATE(3039),
    [sym_preproc_pragma] = STATE(3039),
    [sym_preproc_nullable] = STATE(3039),
    [sym_preproc_error] = STATE(3039),
    [sym_preproc_define] = STATE(3039),
    [sym_preproc_undef] = STATE(3039),
    [anon_sym_SEMI] = ACTIONS(4631),
    [anon_sym_EQ] = ACTIONS(4633),
    [anon_sym_LBRACK] = ACTIONS(4631),
    [anon_sym_COLON] = ACTIONS(4631),
    [anon_sym_COMMA] = ACTIONS(4631),
    [anon_sym_RBRACK] = ACTIONS(4631),
    [anon_sym_LPAREN] = ACTIONS(4631),
    [anon_sym_RPAREN] = ACTIONS(4631),
    [anon_sym_RBRACE] = ACTIONS(4631),
    [anon_sym_LT] = ACTIONS(4633),
    [anon_sym_GT] = ACTIONS(4633),
    [anon_sym_in] = ACTIONS(4631),
    [anon_sym_where] = ACTIONS(4631),
    [anon_sym_QMARK] = ACTIONS(4633),
    [anon_sym_BANG] = ACTIONS(4633),
    [anon_sym_PLUS_PLUS] = ACTIONS(4631),
    [anon_sym_DASH_DASH] = ACTIONS(4631),
    [anon_sym_PLUS] = ACTIONS(4633),
    [anon_sym_DASH] = ACTIONS(4633),
    [anon_sym_STAR] = ACTIONS(4633),
    [anon_sym_SLASH] = ACTIONS(4633),
    [anon_sym_PERCENT] = ACTIONS(4633),
    [anon_sym_CARET] = ACTIONS(4633),
    [anon_sym_PIPE] = ACTIONS(4633),
    [anon_sym_AMP] = ACTIONS(4633),
    [anon_sym_LT_LT] = ACTIONS(4633),
    [anon_sym_GT_GT] = ACTIONS(4633),
    [anon_sym_GT_GT_GT] = ACTIONS(4633),
    [anon_sym_EQ_EQ] = ACTIONS(4631),
    [anon_sym_BANG_EQ] = ACTIONS(4631),
    [anon_sym_GT_EQ] = ACTIONS(4631),
    [anon_sym_LT_EQ] = ACTIONS(4631),
    [anon_sym_DOT] = ACTIONS(4633),
    [anon_sym_EQ_GT] = ACTIONS(4631),
    [anon_sym_switch] = ACTIONS(4631),
    [anon_sym_DOT_DOT] = ACTIONS(4631),
    [anon_sym_and] = ACTIONS(4631),
    [anon_sym_or] = ACTIONS(4633),
    [anon_sym_PLUS_EQ] = ACTIONS(4631),
    [anon_sym_DASH_EQ] = ACTIONS(4631),
    [anon_sym_STAR_EQ] = ACTIONS(4631),
    [anon_sym_SLASH_EQ] = ACTIONS(4631),
    [anon_sym_PERCENT_EQ] = ACTIONS(4631),
    [anon_sym_AMP_EQ] = ACTIONS(4631),
    [anon_sym_CARET_EQ] = ACTIONS(4631),
    [anon_sym_PIPE_EQ] = ACTIONS(4631),
    [anon_sym_LT_LT_EQ] = ACTIONS(4631),
    [anon_sym_GT_GT_EQ] = ACTIONS(4631),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4631),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4631),
    [anon_sym_AMP_AMP] = ACTIONS(4631),
    [anon_sym_PIPE_PIPE] = ACTIONS(4631),
    [anon_sym_QMARK_QMARK] = ACTIONS(4633),
    [anon_sym_from] = ACTIONS(4631),
    [anon_sym_join] = ACTIONS(4631),
    [anon_sym_on] = ACTIONS(4631),
    [anon_sym_equals] = ACTIONS(4631),
    [anon_sym_let] = ACTIONS(4631),
    [anon_sym_orderby] = ACTIONS(4631),
    [anon_sym_group] = ACTIONS(4631),
    [anon_sym_by] = ACTIONS(4631),
    [anon_sym_select] = ACTIONS(4631),
    [anon_sym_as] = ACTIONS(4631),
    [anon_sym_is] = ACTIONS(4631),
    [anon_sym_DASH_GT] = ACTIONS(4631),
    [anon_sym_with] = ACTIONS(4631),
    [aux_sym_preproc_if_token3] = ACTIONS(4631),
    [aux_sym_preproc_else_token1] = ACTIONS(4631),
    [aux_sym_preproc_elif_token1] = ACTIONS(4631),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3040] = {
    [sym_preproc_region] = STATE(3040),
    [sym_preproc_endregion] = STATE(3040),
    [sym_preproc_line] = STATE(3040),
    [sym_preproc_pragma] = STATE(3040),
    [sym_preproc_nullable] = STATE(3040),
    [sym_preproc_error] = STATE(3040),
    [sym_preproc_define] = STATE(3040),
    [sym_preproc_undef] = STATE(3040),
    [anon_sym_SEMI] = ACTIONS(4623),
    [anon_sym_EQ] = ACTIONS(4625),
    [anon_sym_LBRACK] = ACTIONS(4623),
    [anon_sym_COLON] = ACTIONS(4623),
    [anon_sym_COMMA] = ACTIONS(4623),
    [anon_sym_RBRACK] = ACTIONS(4623),
    [anon_sym_LPAREN] = ACTIONS(4623),
    [anon_sym_RPAREN] = ACTIONS(4623),
    [anon_sym_RBRACE] = ACTIONS(4623),
    [anon_sym_LT] = ACTIONS(4625),
    [anon_sym_GT] = ACTIONS(4625),
    [anon_sym_in] = ACTIONS(4623),
    [anon_sym_where] = ACTIONS(4623),
    [anon_sym_QMARK] = ACTIONS(4625),
    [anon_sym_BANG] = ACTIONS(4625),
    [anon_sym_PLUS_PLUS] = ACTIONS(4623),
    [anon_sym_DASH_DASH] = ACTIONS(4623),
    [anon_sym_PLUS] = ACTIONS(4625),
    [anon_sym_DASH] = ACTIONS(4625),
    [anon_sym_STAR] = ACTIONS(4625),
    [anon_sym_SLASH] = ACTIONS(4625),
    [anon_sym_PERCENT] = ACTIONS(4625),
    [anon_sym_CARET] = ACTIONS(4625),
    [anon_sym_PIPE] = ACTIONS(4625),
    [anon_sym_AMP] = ACTIONS(4625),
    [anon_sym_LT_LT] = ACTIONS(4625),
    [anon_sym_GT_GT] = ACTIONS(4625),
    [anon_sym_GT_GT_GT] = ACTIONS(4625),
    [anon_sym_EQ_EQ] = ACTIONS(4623),
    [anon_sym_BANG_EQ] = ACTIONS(4623),
    [anon_sym_GT_EQ] = ACTIONS(4623),
    [anon_sym_LT_EQ] = ACTIONS(4623),
    [anon_sym_DOT] = ACTIONS(4625),
    [anon_sym_EQ_GT] = ACTIONS(4623),
    [anon_sym_switch] = ACTIONS(4623),
    [anon_sym_DOT_DOT] = ACTIONS(4623),
    [anon_sym_and] = ACTIONS(4623),
    [anon_sym_or] = ACTIONS(4625),
    [anon_sym_PLUS_EQ] = ACTIONS(4623),
    [anon_sym_DASH_EQ] = ACTIONS(4623),
    [anon_sym_STAR_EQ] = ACTIONS(4623),
    [anon_sym_SLASH_EQ] = ACTIONS(4623),
    [anon_sym_PERCENT_EQ] = ACTIONS(4623),
    [anon_sym_AMP_EQ] = ACTIONS(4623),
    [anon_sym_CARET_EQ] = ACTIONS(4623),
    [anon_sym_PIPE_EQ] = ACTIONS(4623),
    [anon_sym_LT_LT_EQ] = ACTIONS(4623),
    [anon_sym_GT_GT_EQ] = ACTIONS(4623),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4623),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4623),
    [anon_sym_AMP_AMP] = ACTIONS(4623),
    [anon_sym_PIPE_PIPE] = ACTIONS(4623),
    [anon_sym_QMARK_QMARK] = ACTIONS(4625),
    [anon_sym_from] = ACTIONS(4623),
    [anon_sym_join] = ACTIONS(4623),
    [anon_sym_on] = ACTIONS(4623),
    [anon_sym_equals] = ACTIONS(4623),
    [anon_sym_let] = ACTIONS(4623),
    [anon_sym_orderby] = ACTIONS(4623),
    [anon_sym_group] = ACTIONS(4623),
    [anon_sym_by] = ACTIONS(4623),
    [anon_sym_select] = ACTIONS(4623),
    [anon_sym_as] = ACTIONS(4623),
    [anon_sym_is] = ACTIONS(4623),
    [anon_sym_DASH_GT] = ACTIONS(4623),
    [anon_sym_with] = ACTIONS(4623),
    [aux_sym_preproc_if_token3] = ACTIONS(4623),
    [aux_sym_preproc_else_token1] = ACTIONS(4623),
    [aux_sym_preproc_elif_token1] = ACTIONS(4623),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3041] = {
    [sym_parameter_list] = STATE(9765),
    [sym_positional_pattern_clause] = STATE(3125),
    [sym_property_pattern_clause] = STATE(3194),
    [sym__variable_designation] = STATE(4642),
    [sym_parenthesized_variable_designation] = STATE(4614),
    [sym__lambda_parameters] = STATE(9127),
    [sym_identifier] = STATE(4502),
    [sym__reserved_identifier] = STATE(2914),
    [sym_preproc_region] = STATE(3041),
    [sym_preproc_endregion] = STATE(3041),
    [sym_preproc_line] = STATE(3041),
    [sym_preproc_pragma] = STATE(3041),
    [sym_preproc_nullable] = STATE(3041),
    [sym_preproc_error] = STATE(3041),
    [sym_preproc_define] = STATE(3041),
    [sym_preproc_undef] = STATE(3041),
    [sym__identifier_token] = ACTIONS(4490),
    [anon_sym_alias] = ACTIONS(4492),
    [anon_sym_global] = ACTIONS(4492),
    [anon_sym_LBRACK] = ACTIONS(4275),
    [anon_sym_COMMA] = ACTIONS(4275),
    [anon_sym_LPAREN] = ACTIONS(4275),
    [anon_sym_LBRACE] = ACTIONS(4277),
    [anon_sym_file] = ACTIONS(4492),
    [anon_sym_LT] = ACTIONS(4279),
    [anon_sym_GT] = ACTIONS(4279),
    [anon_sym_where] = ACTIONS(4279),
    [anon_sym_QMARK] = ACTIONS(4279),
    [anon_sym_notnull] = ACTIONS(4492),
    [anon_sym_unmanaged] = ACTIONS(4492),
    [anon_sym_BANG] = ACTIONS(4279),
    [anon_sym_PLUS_PLUS] = ACTIONS(4275),
    [anon_sym_DASH_DASH] = ACTIONS(4275),
    [anon_sym_PLUS] = ACTIONS(4279),
    [anon_sym_DASH] = ACTIONS(4279),
    [anon_sym_STAR] = ACTIONS(4275),
    [anon_sym_SLASH] = ACTIONS(4279),
    [anon_sym_PERCENT] = ACTIONS(4275),
    [anon_sym_CARET] = ACTIONS(4275),
    [anon_sym_PIPE] = ACTIONS(4279),
    [anon_sym_AMP] = ACTIONS(4279),
    [anon_sym_LT_LT] = ACTIONS(4275),
    [anon_sym_GT_GT] = ACTIONS(4279),
    [anon_sym_GT_GT_GT] = ACTIONS(4275),
    [anon_sym_EQ_EQ] = ACTIONS(4275),
    [anon_sym_BANG_EQ] = ACTIONS(4275),
    [anon_sym_GT_EQ] = ACTIONS(4275),
    [anon_sym_LT_EQ] = ACTIONS(4275),
    [anon_sym_DOT] = ACTIONS(4279),
    [anon_sym_scoped] = ACTIONS(4492),
    [anon_sym_var] = ACTIONS(4492),
    [anon_sym_yield] = ACTIONS(4492),
    [anon_sym_switch] = ACTIONS(4279),
    [anon_sym_when] = ACTIONS(4492),
    [sym_discard] = ACTIONS(4647),
    [anon_sym_DOT_DOT] = ACTIONS(4275),
    [anon_sym_and] = ACTIONS(4279),
    [anon_sym_or] = ACTIONS(4279),
    [anon_sym_AMP_AMP] = ACTIONS(4275),
    [anon_sym_PIPE_PIPE] = ACTIONS(4275),
    [anon_sym_QMARK_QMARK] = ACTIONS(4275),
    [anon_sym_from] = ACTIONS(4279),
    [anon_sym_into] = ACTIONS(4279),
    [anon_sym_join] = ACTIONS(4279),
    [anon_sym_on] = ACTIONS(4492),
    [anon_sym_equals] = ACTIONS(4492),
    [anon_sym_let] = ACTIONS(4279),
    [anon_sym_orderby] = ACTIONS(4279),
    [anon_sym_ascending] = ACTIONS(4279),
    [anon_sym_descending] = ACTIONS(4279),
    [anon_sym_group] = ACTIONS(4279),
    [anon_sym_by] = ACTIONS(4492),
    [anon_sym_select] = ACTIONS(4279),
    [anon_sym_as] = ACTIONS(4279),
    [anon_sym_is] = ACTIONS(4279),
    [anon_sym_DASH_GT] = ACTIONS(4275),
    [anon_sym_with] = ACTIONS(4279),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3042] = {
    [sym_preproc_region] = STATE(3042),
    [sym_preproc_endregion] = STATE(3042),
    [sym_preproc_line] = STATE(3042),
    [sym_preproc_pragma] = STATE(3042),
    [sym_preproc_nullable] = STATE(3042),
    [sym_preproc_error] = STATE(3042),
    [sym_preproc_define] = STATE(3042),
    [sym_preproc_undef] = STATE(3042),
    [anon_sym_SEMI] = ACTIONS(4133),
    [anon_sym_EQ] = ACTIONS(4118),
    [anon_sym_LBRACK] = ACTIONS(4133),
    [anon_sym_COLON] = ACTIONS(4133),
    [anon_sym_COMMA] = ACTIONS(4133),
    [anon_sym_RBRACK] = ACTIONS(4133),
    [anon_sym_LPAREN] = ACTIONS(4133),
    [anon_sym_RPAREN] = ACTIONS(4133),
    [anon_sym_RBRACE] = ACTIONS(4133),
    [anon_sym_LT] = ACTIONS(4118),
    [anon_sym_GT] = ACTIONS(4118),
    [anon_sym_in] = ACTIONS(4133),
    [anon_sym_where] = ACTIONS(4133),
    [anon_sym_QMARK] = ACTIONS(4118),
    [anon_sym_BANG] = ACTIONS(4118),
    [anon_sym_PLUS_PLUS] = ACTIONS(4133),
    [anon_sym_DASH_DASH] = ACTIONS(4133),
    [anon_sym_PLUS] = ACTIONS(4118),
    [anon_sym_DASH] = ACTIONS(4118),
    [anon_sym_STAR] = ACTIONS(4118),
    [anon_sym_SLASH] = ACTIONS(4118),
    [anon_sym_PERCENT] = ACTIONS(4118),
    [anon_sym_CARET] = ACTIONS(4118),
    [anon_sym_PIPE] = ACTIONS(4118),
    [anon_sym_AMP] = ACTIONS(4118),
    [anon_sym_LT_LT] = ACTIONS(4118),
    [anon_sym_GT_GT] = ACTIONS(4118),
    [anon_sym_GT_GT_GT] = ACTIONS(4118),
    [anon_sym_EQ_EQ] = ACTIONS(4133),
    [anon_sym_BANG_EQ] = ACTIONS(4133),
    [anon_sym_GT_EQ] = ACTIONS(4133),
    [anon_sym_LT_EQ] = ACTIONS(4133),
    [anon_sym_DOT] = ACTIONS(4118),
    [anon_sym_EQ_GT] = ACTIONS(4133),
    [anon_sym_switch] = ACTIONS(4133),
    [anon_sym_DOT_DOT] = ACTIONS(4133),
    [anon_sym_and] = ACTIONS(4133),
    [anon_sym_or] = ACTIONS(4118),
    [anon_sym_PLUS_EQ] = ACTIONS(4133),
    [anon_sym_DASH_EQ] = ACTIONS(4133),
    [anon_sym_STAR_EQ] = ACTIONS(4133),
    [anon_sym_SLASH_EQ] = ACTIONS(4133),
    [anon_sym_PERCENT_EQ] = ACTIONS(4133),
    [anon_sym_AMP_EQ] = ACTIONS(4133),
    [anon_sym_CARET_EQ] = ACTIONS(4133),
    [anon_sym_PIPE_EQ] = ACTIONS(4133),
    [anon_sym_LT_LT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4133),
    [anon_sym_AMP_AMP] = ACTIONS(4133),
    [anon_sym_PIPE_PIPE] = ACTIONS(4133),
    [anon_sym_QMARK_QMARK] = ACTIONS(4118),
    [anon_sym_from] = ACTIONS(4133),
    [anon_sym_join] = ACTIONS(4133),
    [anon_sym_on] = ACTIONS(4133),
    [anon_sym_equals] = ACTIONS(4133),
    [anon_sym_let] = ACTIONS(4133),
    [anon_sym_orderby] = ACTIONS(4133),
    [anon_sym_group] = ACTIONS(4133),
    [anon_sym_by] = ACTIONS(4133),
    [anon_sym_select] = ACTIONS(4133),
    [anon_sym_as] = ACTIONS(4133),
    [anon_sym_is] = ACTIONS(4133),
    [anon_sym_DASH_GT] = ACTIONS(4133),
    [anon_sym_with] = ACTIONS(4133),
    [aux_sym_preproc_if_token3] = ACTIONS(4133),
    [aux_sym_preproc_else_token1] = ACTIONS(4133),
    [aux_sym_preproc_elif_token1] = ACTIONS(4133),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3043] = {
    [sym_parameter_list] = STATE(9765),
    [sym_positional_pattern_clause] = STATE(2826),
    [sym_property_pattern_clause] = STATE(2859),
    [sym__variable_designation] = STATE(4021),
    [sym_parenthesized_variable_designation] = STATE(4015),
    [sym__lambda_parameters] = STATE(9127),
    [sym_identifier] = STATE(5933),
    [sym__reserved_identifier] = STATE(3908),
    [sym_preproc_region] = STATE(3043),
    [sym_preproc_endregion] = STATE(3043),
    [sym_preproc_line] = STATE(3043),
    [sym_preproc_pragma] = STATE(3043),
    [sym_preproc_nullable] = STATE(3043),
    [sym_preproc_error] = STATE(3043),
    [sym_preproc_define] = STATE(3043),
    [sym_preproc_undef] = STATE(3043),
    [sym__identifier_token] = ACTIONS(4271),
    [anon_sym_alias] = ACTIONS(4273),
    [anon_sym_global] = ACTIONS(4273),
    [anon_sym_LBRACK] = ACTIONS(4283),
    [anon_sym_LPAREN] = ACTIONS(4283),
    [anon_sym_LBRACE] = ACTIONS(4277),
    [anon_sym_file] = ACTIONS(4273),
    [anon_sym_LT] = ACTIONS(4285),
    [anon_sym_GT] = ACTIONS(4285),
    [anon_sym_where] = ACTIONS(4273),
    [anon_sym_QMARK] = ACTIONS(4285),
    [anon_sym_notnull] = ACTIONS(4273),
    [anon_sym_unmanaged] = ACTIONS(4273),
    [anon_sym_BANG] = ACTIONS(4285),
    [anon_sym_PLUS_PLUS] = ACTIONS(4283),
    [anon_sym_DASH_DASH] = ACTIONS(4283),
    [anon_sym_PLUS] = ACTIONS(4285),
    [anon_sym_DASH] = ACTIONS(4285),
    [anon_sym_STAR] = ACTIONS(4283),
    [anon_sym_SLASH] = ACTIONS(4285),
    [anon_sym_PERCENT] = ACTIONS(4283),
    [anon_sym_CARET] = ACTIONS(4283),
    [anon_sym_PIPE] = ACTIONS(4285),
    [anon_sym_AMP] = ACTIONS(4285),
    [anon_sym_LT_LT] = ACTIONS(4283),
    [anon_sym_GT_GT] = ACTIONS(4285),
    [anon_sym_GT_GT_GT] = ACTIONS(4283),
    [anon_sym_EQ_EQ] = ACTIONS(4283),
    [anon_sym_BANG_EQ] = ACTIONS(4283),
    [anon_sym_GT_EQ] = ACTIONS(4283),
    [anon_sym_LT_EQ] = ACTIONS(4283),
    [anon_sym_DOT] = ACTIONS(4285),
    [anon_sym_scoped] = ACTIONS(4273),
    [anon_sym_EQ_GT] = ACTIONS(4283),
    [anon_sym_var] = ACTIONS(4273),
    [anon_sym_yield] = ACTIONS(4273),
    [anon_sym_switch] = ACTIONS(4285),
    [anon_sym_when] = ACTIONS(4273),
    [sym_discard] = ACTIONS(4281),
    [anon_sym_DOT_DOT] = ACTIONS(4283),
    [anon_sym_and] = ACTIONS(4279),
    [anon_sym_or] = ACTIONS(4279),
    [anon_sym_AMP_AMP] = ACTIONS(4283),
    [anon_sym_PIPE_PIPE] = ACTIONS(4283),
    [anon_sym_QMARK_QMARK] = ACTIONS(4283),
    [anon_sym_from] = ACTIONS(4273),
    [anon_sym_into] = ACTIONS(4285),
    [anon_sym_join] = ACTIONS(4273),
    [anon_sym_on] = ACTIONS(4273),
    [anon_sym_equals] = ACTIONS(4273),
    [anon_sym_let] = ACTIONS(4273),
    [anon_sym_orderby] = ACTIONS(4273),
    [anon_sym_ascending] = ACTIONS(4273),
    [anon_sym_descending] = ACTIONS(4273),
    [anon_sym_group] = ACTIONS(4273),
    [anon_sym_by] = ACTIONS(4273),
    [anon_sym_select] = ACTIONS(4273),
    [anon_sym_as] = ACTIONS(4285),
    [anon_sym_is] = ACTIONS(4285),
    [anon_sym_DASH_GT] = ACTIONS(4283),
    [anon_sym_with] = ACTIONS(4285),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3044] = {
    [sym_parameter_list] = STATE(9765),
    [sym_positional_pattern_clause] = STATE(2840),
    [sym_property_pattern_clause] = STATE(2896),
    [sym__variable_designation] = STATE(4260),
    [sym_parenthesized_variable_designation] = STATE(4274),
    [sym__lambda_parameters] = STATE(9127),
    [sym_identifier] = STATE(5933),
    [sym__reserved_identifier] = STATE(3908),
    [sym_preproc_region] = STATE(3044),
    [sym_preproc_endregion] = STATE(3044),
    [sym_preproc_line] = STATE(3044),
    [sym_preproc_pragma] = STATE(3044),
    [sym_preproc_nullable] = STATE(3044),
    [sym_preproc_error] = STATE(3044),
    [sym_preproc_define] = STATE(3044),
    [sym_preproc_undef] = STATE(3044),
    [sym__identifier_token] = ACTIONS(4271),
    [anon_sym_alias] = ACTIONS(4273),
    [anon_sym_global] = ACTIONS(4273),
    [anon_sym_LBRACK] = ACTIONS(4275),
    [anon_sym_LPAREN] = ACTIONS(4275),
    [anon_sym_LBRACE] = ACTIONS(4277),
    [anon_sym_file] = ACTIONS(4273),
    [anon_sym_LT] = ACTIONS(4279),
    [anon_sym_GT] = ACTIONS(4279),
    [anon_sym_where] = ACTIONS(4273),
    [anon_sym_QMARK] = ACTIONS(4279),
    [anon_sym_notnull] = ACTIONS(4273),
    [anon_sym_unmanaged] = ACTIONS(4273),
    [anon_sym_BANG] = ACTIONS(4279),
    [anon_sym_PLUS_PLUS] = ACTIONS(4275),
    [anon_sym_DASH_DASH] = ACTIONS(4275),
    [anon_sym_PLUS] = ACTIONS(4279),
    [anon_sym_DASH] = ACTIONS(4279),
    [anon_sym_STAR] = ACTIONS(4275),
    [anon_sym_SLASH] = ACTIONS(4279),
    [anon_sym_PERCENT] = ACTIONS(4275),
    [anon_sym_CARET] = ACTIONS(4275),
    [anon_sym_PIPE] = ACTIONS(4279),
    [anon_sym_AMP] = ACTIONS(4279),
    [anon_sym_LT_LT] = ACTIONS(4275),
    [anon_sym_GT_GT] = ACTIONS(4279),
    [anon_sym_GT_GT_GT] = ACTIONS(4275),
    [anon_sym_EQ_EQ] = ACTIONS(4275),
    [anon_sym_BANG_EQ] = ACTIONS(4275),
    [anon_sym_GT_EQ] = ACTIONS(4275),
    [anon_sym_LT_EQ] = ACTIONS(4275),
    [anon_sym_DOT] = ACTIONS(4279),
    [anon_sym_scoped] = ACTIONS(4273),
    [anon_sym_EQ_GT] = ACTIONS(4275),
    [anon_sym_var] = ACTIONS(4273),
    [anon_sym_yield] = ACTIONS(4273),
    [anon_sym_switch] = ACTIONS(4279),
    [anon_sym_when] = ACTIONS(4273),
    [sym_discard] = ACTIONS(4295),
    [anon_sym_DOT_DOT] = ACTIONS(4275),
    [anon_sym_and] = ACTIONS(4279),
    [anon_sym_or] = ACTIONS(4279),
    [anon_sym_AMP_AMP] = ACTIONS(4275),
    [anon_sym_PIPE_PIPE] = ACTIONS(4275),
    [anon_sym_QMARK_QMARK] = ACTIONS(4275),
    [anon_sym_from] = ACTIONS(4273),
    [anon_sym_into] = ACTIONS(4273),
    [anon_sym_join] = ACTIONS(4273),
    [anon_sym_on] = ACTIONS(4273),
    [anon_sym_equals] = ACTIONS(4273),
    [anon_sym_let] = ACTIONS(4273),
    [anon_sym_orderby] = ACTIONS(4273),
    [anon_sym_ascending] = ACTIONS(4273),
    [anon_sym_descending] = ACTIONS(4273),
    [anon_sym_group] = ACTIONS(4273),
    [anon_sym_by] = ACTIONS(4273),
    [anon_sym_select] = ACTIONS(4273),
    [anon_sym_as] = ACTIONS(4279),
    [anon_sym_is] = ACTIONS(4279),
    [anon_sym_DASH_GT] = ACTIONS(4275),
    [anon_sym_with] = ACTIONS(4279),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3045] = {
    [sym_parameter_list] = STATE(9765),
    [sym_positional_pattern_clause] = STATE(3158),
    [sym_property_pattern_clause] = STATE(3215),
    [sym__variable_designation] = STATE(4260),
    [sym_parenthesized_variable_designation] = STATE(4274),
    [sym__lambda_parameters] = STATE(9127),
    [sym_identifier] = STATE(4259),
    [sym__reserved_identifier] = STATE(3908),
    [sym_preproc_region] = STATE(3045),
    [sym_preproc_endregion] = STATE(3045),
    [sym_preproc_line] = STATE(3045),
    [sym_preproc_pragma] = STATE(3045),
    [sym_preproc_nullable] = STATE(3045),
    [sym_preproc_error] = STATE(3045),
    [sym_preproc_define] = STATE(3045),
    [sym_preproc_undef] = STATE(3045),
    [sym__identifier_token] = ACTIONS(4271),
    [anon_sym_alias] = ACTIONS(4273),
    [anon_sym_global] = ACTIONS(4273),
    [anon_sym_LBRACK] = ACTIONS(4283),
    [anon_sym_LPAREN] = ACTIONS(4283),
    [anon_sym_LBRACE] = ACTIONS(4277),
    [anon_sym_file] = ACTIONS(4273),
    [anon_sym_LT] = ACTIONS(4285),
    [anon_sym_GT] = ACTIONS(4285),
    [anon_sym_where] = ACTIONS(4273),
    [anon_sym_QMARK] = ACTIONS(4285),
    [anon_sym_notnull] = ACTIONS(4273),
    [anon_sym_unmanaged] = ACTIONS(4273),
    [anon_sym_BANG] = ACTIONS(4285),
    [anon_sym_PLUS_PLUS] = ACTIONS(4283),
    [anon_sym_DASH_DASH] = ACTIONS(4283),
    [anon_sym_PLUS] = ACTIONS(4285),
    [anon_sym_DASH] = ACTIONS(4285),
    [anon_sym_STAR] = ACTIONS(4283),
    [anon_sym_SLASH] = ACTIONS(4285),
    [anon_sym_PERCENT] = ACTIONS(4283),
    [anon_sym_CARET] = ACTIONS(4283),
    [anon_sym_PIPE] = ACTIONS(4285),
    [anon_sym_AMP] = ACTIONS(4285),
    [anon_sym_LT_LT] = ACTIONS(4283),
    [anon_sym_GT_GT] = ACTIONS(4285),
    [anon_sym_GT_GT_GT] = ACTIONS(4283),
    [anon_sym_EQ_EQ] = ACTIONS(4283),
    [anon_sym_BANG_EQ] = ACTIONS(4283),
    [anon_sym_GT_EQ] = ACTIONS(4283),
    [anon_sym_LT_EQ] = ACTIONS(4283),
    [anon_sym_DOT] = ACTIONS(4285),
    [anon_sym_scoped] = ACTIONS(4273),
    [anon_sym_var] = ACTIONS(4273),
    [anon_sym_yield] = ACTIONS(4273),
    [anon_sym_switch] = ACTIONS(4285),
    [anon_sym_when] = ACTIONS(4273),
    [sym_discard] = ACTIONS(4295),
    [anon_sym_DOT_DOT] = ACTIONS(4283),
    [anon_sym_and] = ACTIONS(4285),
    [anon_sym_or] = ACTIONS(4285),
    [anon_sym_AMP_AMP] = ACTIONS(4283),
    [anon_sym_PIPE_PIPE] = ACTIONS(4283),
    [anon_sym_QMARK_QMARK] = ACTIONS(4283),
    [anon_sym_from] = ACTIONS(4273),
    [anon_sym_into] = ACTIONS(4273),
    [anon_sym_join] = ACTIONS(4273),
    [anon_sym_on] = ACTIONS(4273),
    [anon_sym_equals] = ACTIONS(4273),
    [anon_sym_let] = ACTIONS(4273),
    [anon_sym_orderby] = ACTIONS(4273),
    [anon_sym_ascending] = ACTIONS(4273),
    [anon_sym_descending] = ACTIONS(4273),
    [anon_sym_group] = ACTIONS(4273),
    [anon_sym_by] = ACTIONS(4285),
    [anon_sym_select] = ACTIONS(4273),
    [anon_sym_as] = ACTIONS(4285),
    [anon_sym_is] = ACTIONS(4285),
    [anon_sym_DASH_GT] = ACTIONS(4283),
    [anon_sym_with] = ACTIONS(4285),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3046] = {
    [sym_parameter_list] = STATE(9765),
    [sym_positional_pattern_clause] = STATE(3136),
    [sym_property_pattern_clause] = STATE(3346),
    [sym__variable_designation] = STATE(5001),
    [sym_parenthesized_variable_designation] = STATE(4957),
    [sym__lambda_parameters] = STATE(9127),
    [sym_identifier] = STATE(4944),
    [sym__reserved_identifier] = STATE(3558),
    [sym_preproc_region] = STATE(3046),
    [sym_preproc_endregion] = STATE(3046),
    [sym_preproc_line] = STATE(3046),
    [sym_preproc_pragma] = STATE(3046),
    [sym_preproc_nullable] = STATE(3046),
    [sym_preproc_error] = STATE(3046),
    [sym_preproc_define] = STATE(3046),
    [sym_preproc_undef] = STATE(3046),
    [sym__identifier_token] = ACTIONS(4225),
    [anon_sym_alias] = ACTIONS(4227),
    [anon_sym_global] = ACTIONS(4227),
    [anon_sym_LBRACK] = ACTIONS(4283),
    [anon_sym_LPAREN] = ACTIONS(4283),
    [anon_sym_LBRACE] = ACTIONS(4277),
    [anon_sym_file] = ACTIONS(4227),
    [anon_sym_LT] = ACTIONS(4285),
    [anon_sym_GT] = ACTIONS(4285),
    [anon_sym_where] = ACTIONS(4285),
    [anon_sym_QMARK] = ACTIONS(4285),
    [anon_sym_notnull] = ACTIONS(4227),
    [anon_sym_unmanaged] = ACTIONS(4227),
    [anon_sym_BANG] = ACTIONS(4285),
    [anon_sym_PLUS_PLUS] = ACTIONS(4283),
    [anon_sym_DASH_DASH] = ACTIONS(4283),
    [anon_sym_PLUS] = ACTIONS(4285),
    [anon_sym_DASH] = ACTIONS(4285),
    [anon_sym_STAR] = ACTIONS(4283),
    [anon_sym_SLASH] = ACTIONS(4285),
    [anon_sym_PERCENT] = ACTIONS(4283),
    [anon_sym_CARET] = ACTIONS(4283),
    [anon_sym_PIPE] = ACTIONS(4285),
    [anon_sym_AMP] = ACTIONS(4285),
    [anon_sym_LT_LT] = ACTIONS(4283),
    [anon_sym_GT_GT] = ACTIONS(4285),
    [anon_sym_GT_GT_GT] = ACTIONS(4283),
    [anon_sym_EQ_EQ] = ACTIONS(4283),
    [anon_sym_BANG_EQ] = ACTIONS(4283),
    [anon_sym_GT_EQ] = ACTIONS(4283),
    [anon_sym_LT_EQ] = ACTIONS(4283),
    [anon_sym_DOT] = ACTIONS(4285),
    [anon_sym_scoped] = ACTIONS(4227),
    [anon_sym_var] = ACTIONS(4227),
    [anon_sym_yield] = ACTIONS(4227),
    [anon_sym_switch] = ACTIONS(4285),
    [anon_sym_when] = ACTIONS(4227),
    [sym_discard] = ACTIONS(4649),
    [anon_sym_DOT_DOT] = ACTIONS(4283),
    [anon_sym_and] = ACTIONS(4285),
    [anon_sym_or] = ACTIONS(4285),
    [anon_sym_AMP_AMP] = ACTIONS(4283),
    [anon_sym_PIPE_PIPE] = ACTIONS(4283),
    [anon_sym_QMARK_QMARK] = ACTIONS(4283),
    [anon_sym_from] = ACTIONS(4285),
    [anon_sym_into] = ACTIONS(4285),
    [anon_sym_join] = ACTIONS(4285),
    [anon_sym_on] = ACTIONS(4227),
    [anon_sym_equals] = ACTIONS(4227),
    [anon_sym_let] = ACTIONS(4285),
    [anon_sym_orderby] = ACTIONS(4285),
    [anon_sym_ascending] = ACTIONS(4227),
    [anon_sym_descending] = ACTIONS(4227),
    [anon_sym_group] = ACTIONS(4285),
    [anon_sym_by] = ACTIONS(4227),
    [anon_sym_select] = ACTIONS(4285),
    [anon_sym_as] = ACTIONS(4285),
    [anon_sym_is] = ACTIONS(4285),
    [anon_sym_DASH_GT] = ACTIONS(4283),
    [anon_sym_with] = ACTIONS(4285),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3047] = {
    [sym_property_pattern_clause] = STATE(3120),
    [sym__variable_designation] = STATE(5410),
    [sym_parenthesized_variable_designation] = STATE(5390),
    [sym_identifier] = STATE(5396),
    [sym__reserved_identifier] = STATE(5128),
    [sym_preproc_region] = STATE(3047),
    [sym_preproc_endregion] = STATE(3047),
    [sym_preproc_line] = STATE(3047),
    [sym_preproc_pragma] = STATE(3047),
    [sym_preproc_nullable] = STATE(3047),
    [sym_preproc_error] = STATE(3047),
    [sym_preproc_define] = STATE(3047),
    [sym_preproc_undef] = STATE(3047),
    [sym__identifier_token] = ACTIONS(4482),
    [anon_sym_alias] = ACTIONS(4484),
    [anon_sym_global] = ACTIONS(4484),
    [anon_sym_LBRACK] = ACTIONS(4335),
    [anon_sym_COLON] = ACTIONS(4335),
    [anon_sym_COMMA] = ACTIONS(4335),
    [anon_sym_LPAREN] = ACTIONS(4335),
    [anon_sym_LBRACE] = ACTIONS(4486),
    [anon_sym_file] = ACTIONS(4484),
    [anon_sym_LT] = ACTIONS(4337),
    [anon_sym_GT] = ACTIONS(4337),
    [anon_sym_where] = ACTIONS(4484),
    [anon_sym_QMARK] = ACTIONS(4337),
    [anon_sym_notnull] = ACTIONS(4484),
    [anon_sym_unmanaged] = ACTIONS(4484),
    [anon_sym_BANG] = ACTIONS(4337),
    [anon_sym_PLUS_PLUS] = ACTIONS(4335),
    [anon_sym_DASH_DASH] = ACTIONS(4335),
    [anon_sym_PLUS] = ACTIONS(4337),
    [anon_sym_DASH] = ACTIONS(4337),
    [anon_sym_STAR] = ACTIONS(4335),
    [anon_sym_SLASH] = ACTIONS(4337),
    [anon_sym_PERCENT] = ACTIONS(4335),
    [anon_sym_CARET] = ACTIONS(4335),
    [anon_sym_PIPE] = ACTIONS(4337),
    [anon_sym_AMP] = ACTIONS(4337),
    [anon_sym_LT_LT] = ACTIONS(4335),
    [anon_sym_GT_GT] = ACTIONS(4337),
    [anon_sym_GT_GT_GT] = ACTIONS(4335),
    [anon_sym_EQ_EQ] = ACTIONS(4335),
    [anon_sym_BANG_EQ] = ACTIONS(4335),
    [anon_sym_GT_EQ] = ACTIONS(4335),
    [anon_sym_LT_EQ] = ACTIONS(4335),
    [anon_sym_DOT] = ACTIONS(4337),
    [anon_sym_scoped] = ACTIONS(4484),
    [anon_sym_var] = ACTIONS(4484),
    [anon_sym_yield] = ACTIONS(4484),
    [anon_sym_switch] = ACTIONS(4337),
    [anon_sym_when] = ACTIONS(4484),
    [sym_discard] = ACTIONS(4488),
    [anon_sym_DOT_DOT] = ACTIONS(4335),
    [anon_sym_and] = ACTIONS(4337),
    [anon_sym_or] = ACTIONS(4337),
    [anon_sym_AMP_AMP] = ACTIONS(4335),
    [anon_sym_PIPE_PIPE] = ACTIONS(4335),
    [anon_sym_QMARK_QMARK] = ACTIONS(4335),
    [anon_sym_from] = ACTIONS(4484),
    [anon_sym_into] = ACTIONS(4484),
    [anon_sym_join] = ACTIONS(4484),
    [anon_sym_on] = ACTIONS(4484),
    [anon_sym_equals] = ACTIONS(4484),
    [anon_sym_let] = ACTIONS(4484),
    [anon_sym_orderby] = ACTIONS(4484),
    [anon_sym_ascending] = ACTIONS(4484),
    [anon_sym_descending] = ACTIONS(4484),
    [anon_sym_group] = ACTIONS(4484),
    [anon_sym_by] = ACTIONS(4484),
    [anon_sym_select] = ACTIONS(4484),
    [anon_sym_as] = ACTIONS(4337),
    [anon_sym_is] = ACTIONS(4337),
    [anon_sym_DASH_GT] = ACTIONS(4335),
    [anon_sym_with] = ACTIONS(4337),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4335),
  },
  [3048] = {
    [sym_parameter_list] = STATE(9765),
    [sym_positional_pattern_clause] = STATE(3134),
    [sym_property_pattern_clause] = STATE(3268),
    [sym__variable_designation] = STATE(5001),
    [sym_parenthesized_variable_designation] = STATE(4957),
    [sym__lambda_parameters] = STATE(9127),
    [sym_identifier] = STATE(4944),
    [sym__reserved_identifier] = STATE(3568),
    [sym_preproc_region] = STATE(3048),
    [sym_preproc_endregion] = STATE(3048),
    [sym_preproc_line] = STATE(3048),
    [sym_preproc_pragma] = STATE(3048),
    [sym_preproc_nullable] = STATE(3048),
    [sym_preproc_error] = STATE(3048),
    [sym_preproc_define] = STATE(3048),
    [sym_preproc_undef] = STATE(3048),
    [sym__identifier_token] = ACTIONS(4287),
    [anon_sym_alias] = ACTIONS(4289),
    [anon_sym_global] = ACTIONS(4289),
    [anon_sym_LBRACK] = ACTIONS(4283),
    [anon_sym_LPAREN] = ACTIONS(4283),
    [anon_sym_LBRACE] = ACTIONS(4277),
    [anon_sym_file] = ACTIONS(4289),
    [anon_sym_LT] = ACTIONS(4285),
    [anon_sym_GT] = ACTIONS(4285),
    [anon_sym_where] = ACTIONS(4285),
    [anon_sym_QMARK] = ACTIONS(4285),
    [anon_sym_notnull] = ACTIONS(4289),
    [anon_sym_unmanaged] = ACTIONS(4289),
    [anon_sym_BANG] = ACTIONS(4285),
    [anon_sym_PLUS_PLUS] = ACTIONS(4283),
    [anon_sym_DASH_DASH] = ACTIONS(4283),
    [anon_sym_PLUS] = ACTIONS(4285),
    [anon_sym_DASH] = ACTIONS(4285),
    [anon_sym_STAR] = ACTIONS(4283),
    [anon_sym_SLASH] = ACTIONS(4285),
    [anon_sym_PERCENT] = ACTIONS(4283),
    [anon_sym_CARET] = ACTIONS(4283),
    [anon_sym_PIPE] = ACTIONS(4285),
    [anon_sym_AMP] = ACTIONS(4285),
    [anon_sym_LT_LT] = ACTIONS(4283),
    [anon_sym_GT_GT] = ACTIONS(4285),
    [anon_sym_GT_GT_GT] = ACTIONS(4283),
    [anon_sym_EQ_EQ] = ACTIONS(4283),
    [anon_sym_BANG_EQ] = ACTIONS(4283),
    [anon_sym_GT_EQ] = ACTIONS(4283),
    [anon_sym_LT_EQ] = ACTIONS(4283),
    [anon_sym_DOT] = ACTIONS(4285),
    [anon_sym_scoped] = ACTIONS(4289),
    [anon_sym_var] = ACTIONS(4289),
    [anon_sym_yield] = ACTIONS(4289),
    [anon_sym_switch] = ACTIONS(4285),
    [anon_sym_when] = ACTIONS(4289),
    [sym_discard] = ACTIONS(4649),
    [anon_sym_DOT_DOT] = ACTIONS(4283),
    [anon_sym_and] = ACTIONS(4285),
    [anon_sym_or] = ACTIONS(4285),
    [anon_sym_AMP_AMP] = ACTIONS(4283),
    [anon_sym_PIPE_PIPE] = ACTIONS(4283),
    [anon_sym_QMARK_QMARK] = ACTIONS(4283),
    [anon_sym_from] = ACTIONS(4285),
    [anon_sym_into] = ACTIONS(4289),
    [anon_sym_join] = ACTIONS(4285),
    [anon_sym_on] = ACTIONS(4289),
    [anon_sym_equals] = ACTIONS(4289),
    [anon_sym_let] = ACTIONS(4285),
    [anon_sym_orderby] = ACTIONS(4285),
    [anon_sym_ascending] = ACTIONS(4289),
    [anon_sym_descending] = ACTIONS(4289),
    [anon_sym_group] = ACTIONS(4285),
    [anon_sym_by] = ACTIONS(4289),
    [anon_sym_select] = ACTIONS(4285),
    [anon_sym_as] = ACTIONS(4285),
    [anon_sym_is] = ACTIONS(4285),
    [anon_sym_DASH_GT] = ACTIONS(4283),
    [anon_sym_with] = ACTIONS(4285),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3049] = {
    [sym_parameter_list] = STATE(9765),
    [sym_positional_pattern_clause] = STATE(3157),
    [sym_property_pattern_clause] = STATE(3409),
    [sym__variable_designation] = STATE(4021),
    [sym_parenthesized_variable_designation] = STATE(4015),
    [sym__lambda_parameters] = STATE(9127),
    [sym_identifier] = STATE(4055),
    [sym__reserved_identifier] = STATE(3908),
    [sym_preproc_region] = STATE(3049),
    [sym_preproc_endregion] = STATE(3049),
    [sym_preproc_line] = STATE(3049),
    [sym_preproc_pragma] = STATE(3049),
    [sym_preproc_nullable] = STATE(3049),
    [sym_preproc_error] = STATE(3049),
    [sym_preproc_define] = STATE(3049),
    [sym_preproc_undef] = STATE(3049),
    [sym__identifier_token] = ACTIONS(4271),
    [anon_sym_alias] = ACTIONS(4273),
    [anon_sym_global] = ACTIONS(4273),
    [anon_sym_LBRACK] = ACTIONS(4275),
    [anon_sym_LPAREN] = ACTIONS(4275),
    [anon_sym_LBRACE] = ACTIONS(4277),
    [anon_sym_file] = ACTIONS(4273),
    [anon_sym_LT] = ACTIONS(4279),
    [anon_sym_GT] = ACTIONS(4279),
    [anon_sym_where] = ACTIONS(4273),
    [anon_sym_QMARK] = ACTIONS(4279),
    [anon_sym_notnull] = ACTIONS(4273),
    [anon_sym_unmanaged] = ACTIONS(4273),
    [anon_sym_BANG] = ACTIONS(4279),
    [anon_sym_PLUS_PLUS] = ACTIONS(4275),
    [anon_sym_DASH_DASH] = ACTIONS(4275),
    [anon_sym_PLUS] = ACTIONS(4279),
    [anon_sym_DASH] = ACTIONS(4279),
    [anon_sym_STAR] = ACTIONS(4275),
    [anon_sym_SLASH] = ACTIONS(4279),
    [anon_sym_PERCENT] = ACTIONS(4275),
    [anon_sym_CARET] = ACTIONS(4275),
    [anon_sym_PIPE] = ACTIONS(4279),
    [anon_sym_AMP] = ACTIONS(4279),
    [anon_sym_LT_LT] = ACTIONS(4275),
    [anon_sym_GT_GT] = ACTIONS(4279),
    [anon_sym_GT_GT_GT] = ACTIONS(4275),
    [anon_sym_EQ_EQ] = ACTIONS(4275),
    [anon_sym_BANG_EQ] = ACTIONS(4275),
    [anon_sym_GT_EQ] = ACTIONS(4275),
    [anon_sym_LT_EQ] = ACTIONS(4275),
    [anon_sym_DOT] = ACTIONS(4279),
    [anon_sym_scoped] = ACTIONS(4273),
    [anon_sym_var] = ACTIONS(4273),
    [anon_sym_yield] = ACTIONS(4273),
    [anon_sym_switch] = ACTIONS(4279),
    [anon_sym_when] = ACTIONS(4273),
    [sym_discard] = ACTIONS(4281),
    [anon_sym_DOT_DOT] = ACTIONS(4275),
    [anon_sym_and] = ACTIONS(4279),
    [anon_sym_or] = ACTIONS(4279),
    [anon_sym_AMP_AMP] = ACTIONS(4275),
    [anon_sym_PIPE_PIPE] = ACTIONS(4275),
    [anon_sym_QMARK_QMARK] = ACTIONS(4275),
    [anon_sym_from] = ACTIONS(4273),
    [anon_sym_into] = ACTIONS(4279),
    [anon_sym_join] = ACTIONS(4273),
    [anon_sym_on] = ACTIONS(4273),
    [anon_sym_equals] = ACTIONS(4273),
    [anon_sym_let] = ACTIONS(4273),
    [anon_sym_orderby] = ACTIONS(4273),
    [anon_sym_ascending] = ACTIONS(4273),
    [anon_sym_descending] = ACTIONS(4273),
    [anon_sym_group] = ACTIONS(4273),
    [anon_sym_by] = ACTIONS(4279),
    [anon_sym_select] = ACTIONS(4273),
    [anon_sym_as] = ACTIONS(4279),
    [anon_sym_is] = ACTIONS(4279),
    [anon_sym_DASH_GT] = ACTIONS(4275),
    [anon_sym_with] = ACTIONS(4279),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3050] = {
    [sym_parameter_list] = STATE(9765),
    [sym_positional_pattern_clause] = STATE(3134),
    [sym_property_pattern_clause] = STATE(3268),
    [sym__variable_designation] = STATE(5001),
    [sym_parenthesized_variable_designation] = STATE(4957),
    [sym__lambda_parameters] = STATE(9127),
    [sym_identifier] = STATE(4944),
    [sym__reserved_identifier] = STATE(3568),
    [sym_preproc_region] = STATE(3050),
    [sym_preproc_endregion] = STATE(3050),
    [sym_preproc_line] = STATE(3050),
    [sym_preproc_pragma] = STATE(3050),
    [sym_preproc_nullable] = STATE(3050),
    [sym_preproc_error] = STATE(3050),
    [sym_preproc_define] = STATE(3050),
    [sym_preproc_undef] = STATE(3050),
    [sym__identifier_token] = ACTIONS(4287),
    [anon_sym_alias] = ACTIONS(4289),
    [anon_sym_global] = ACTIONS(4289),
    [anon_sym_LBRACK] = ACTIONS(4283),
    [anon_sym_LPAREN] = ACTIONS(4283),
    [anon_sym_LBRACE] = ACTIONS(4277),
    [anon_sym_file] = ACTIONS(4289),
    [anon_sym_LT] = ACTIONS(4285),
    [anon_sym_GT] = ACTIONS(4285),
    [anon_sym_where] = ACTIONS(4285),
    [anon_sym_QMARK] = ACTIONS(4285),
    [anon_sym_notnull] = ACTIONS(4289),
    [anon_sym_unmanaged] = ACTIONS(4289),
    [anon_sym_BANG] = ACTIONS(4285),
    [anon_sym_PLUS_PLUS] = ACTIONS(4283),
    [anon_sym_DASH_DASH] = ACTIONS(4283),
    [anon_sym_PLUS] = ACTIONS(4285),
    [anon_sym_DASH] = ACTIONS(4285),
    [anon_sym_STAR] = ACTIONS(4283),
    [anon_sym_SLASH] = ACTIONS(4285),
    [anon_sym_PERCENT] = ACTIONS(4283),
    [anon_sym_CARET] = ACTIONS(4283),
    [anon_sym_PIPE] = ACTIONS(4285),
    [anon_sym_AMP] = ACTIONS(4285),
    [anon_sym_LT_LT] = ACTIONS(4283),
    [anon_sym_GT_GT] = ACTIONS(4285),
    [anon_sym_GT_GT_GT] = ACTIONS(4283),
    [anon_sym_EQ_EQ] = ACTIONS(4283),
    [anon_sym_BANG_EQ] = ACTIONS(4283),
    [anon_sym_GT_EQ] = ACTIONS(4283),
    [anon_sym_LT_EQ] = ACTIONS(4283),
    [anon_sym_DOT] = ACTIONS(4285),
    [anon_sym_scoped] = ACTIONS(4289),
    [anon_sym_var] = ACTIONS(4289),
    [anon_sym_yield] = ACTIONS(4289),
    [anon_sym_switch] = ACTIONS(4285),
    [anon_sym_when] = ACTIONS(4289),
    [sym_discard] = ACTIONS(4649),
    [anon_sym_DOT_DOT] = ACTIONS(4283),
    [anon_sym_and] = ACTIONS(4279),
    [anon_sym_or] = ACTIONS(4279),
    [anon_sym_AMP_AMP] = ACTIONS(4283),
    [anon_sym_PIPE_PIPE] = ACTIONS(4283),
    [anon_sym_QMARK_QMARK] = ACTIONS(4283),
    [anon_sym_from] = ACTIONS(4285),
    [anon_sym_into] = ACTIONS(4289),
    [anon_sym_join] = ACTIONS(4285),
    [anon_sym_on] = ACTIONS(4289),
    [anon_sym_equals] = ACTIONS(4289),
    [anon_sym_let] = ACTIONS(4285),
    [anon_sym_orderby] = ACTIONS(4285),
    [anon_sym_ascending] = ACTIONS(4289),
    [anon_sym_descending] = ACTIONS(4289),
    [anon_sym_group] = ACTIONS(4285),
    [anon_sym_by] = ACTIONS(4289),
    [anon_sym_select] = ACTIONS(4285),
    [anon_sym_as] = ACTIONS(4285),
    [anon_sym_is] = ACTIONS(4285),
    [anon_sym_DASH_GT] = ACTIONS(4283),
    [anon_sym_with] = ACTIONS(4285),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3051] = {
    [sym__name] = STATE(4327),
    [sym_alias_qualified_name] = STATE(3592),
    [sym__simple_name] = STATE(3592),
    [sym_qualified_name] = STATE(3592),
    [sym_generic_name] = STATE(3608),
    [sym_ref_type] = STATE(3574),
    [sym__scoped_base_type] = STATE(3573),
    [sym_identifier] = STATE(3989),
    [sym__reserved_identifier] = STATE(3558),
    [sym_preproc_region] = STATE(3051),
    [sym_preproc_endregion] = STATE(3051),
    [sym_preproc_line] = STATE(3051),
    [sym_preproc_pragma] = STATE(3051),
    [sym_preproc_nullable] = STATE(3051),
    [sym_preproc_error] = STATE(3051),
    [sym_preproc_define] = STATE(3051),
    [sym_preproc_undef] = STATE(3051),
    [sym__identifier_token] = ACTIONS(4225),
    [anon_sym_alias] = ACTIONS(4227),
    [anon_sym_global] = ACTIONS(4227),
    [anon_sym_LBRACK] = ACTIONS(3719),
    [anon_sym_LPAREN] = ACTIONS(3719),
    [anon_sym_ref] = ACTIONS(4651),
    [anon_sym_LBRACE] = ACTIONS(3719),
    [anon_sym_file] = ACTIONS(4227),
    [anon_sym_LT] = ACTIONS(3721),
    [anon_sym_GT] = ACTIONS(3721),
    [anon_sym_where] = ACTIONS(4227),
    [anon_sym_QMARK] = ACTIONS(3721),
    [anon_sym_notnull] = ACTIONS(4227),
    [anon_sym_unmanaged] = ACTIONS(4227),
    [anon_sym_BANG] = ACTIONS(3721),
    [anon_sym_PLUS_PLUS] = ACTIONS(3719),
    [anon_sym_DASH_DASH] = ACTIONS(3719),
    [anon_sym_PLUS] = ACTIONS(3721),
    [anon_sym_DASH] = ACTIONS(3721),
    [anon_sym_STAR] = ACTIONS(3719),
    [anon_sym_SLASH] = ACTIONS(3721),
    [anon_sym_PERCENT] = ACTIONS(3719),
    [anon_sym_CARET] = ACTIONS(3719),
    [anon_sym_PIPE] = ACTIONS(3721),
    [anon_sym_AMP] = ACTIONS(3721),
    [anon_sym_LT_LT] = ACTIONS(3719),
    [anon_sym_GT_GT] = ACTIONS(3721),
    [anon_sym_GT_GT_GT] = ACTIONS(3719),
    [anon_sym_EQ_EQ] = ACTIONS(3719),
    [anon_sym_BANG_EQ] = ACTIONS(3719),
    [anon_sym_GT_EQ] = ACTIONS(3719),
    [anon_sym_LT_EQ] = ACTIONS(3719),
    [anon_sym_DOT] = ACTIONS(3721),
    [anon_sym_scoped] = ACTIONS(4227),
    [anon_sym_COLON_COLON] = ACTIONS(3719),
    [anon_sym_var] = ACTIONS(4227),
    [anon_sym_yield] = ACTIONS(4227),
    [anon_sym_switch] = ACTIONS(3721),
    [anon_sym_when] = ACTIONS(4227),
    [anon_sym_DOT_DOT] = ACTIONS(3719),
    [anon_sym_AMP_AMP] = ACTIONS(3719),
    [anon_sym_PIPE_PIPE] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK] = ACTIONS(3719),
    [anon_sym_from] = ACTIONS(4227),
    [anon_sym_into] = ACTIONS(4231),
    [anon_sym_join] = ACTIONS(4227),
    [anon_sym_on] = ACTIONS(4227),
    [anon_sym_equals] = ACTIONS(4231),
    [anon_sym_let] = ACTIONS(4227),
    [anon_sym_orderby] = ACTIONS(4227),
    [anon_sym_ascending] = ACTIONS(4227),
    [anon_sym_descending] = ACTIONS(4227),
    [anon_sym_group] = ACTIONS(4227),
    [anon_sym_by] = ACTIONS(4227),
    [anon_sym_select] = ACTIONS(4227),
    [anon_sym_as] = ACTIONS(3721),
    [anon_sym_is] = ACTIONS(3721),
    [anon_sym_DASH_GT] = ACTIONS(3719),
    [anon_sym_with] = ACTIONS(3721),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3052] = {
    [sym_parameter_list] = STATE(9765),
    [sym_positional_pattern_clause] = STATE(3157),
    [sym_property_pattern_clause] = STATE(3409),
    [sym__variable_designation] = STATE(4021),
    [sym_parenthesized_variable_designation] = STATE(4015),
    [sym__lambda_parameters] = STATE(9127),
    [sym_identifier] = STATE(4055),
    [sym__reserved_identifier] = STATE(3908),
    [sym_preproc_region] = STATE(3052),
    [sym_preproc_endregion] = STATE(3052),
    [sym_preproc_line] = STATE(3052),
    [sym_preproc_pragma] = STATE(3052),
    [sym_preproc_nullable] = STATE(3052),
    [sym_preproc_error] = STATE(3052),
    [sym_preproc_define] = STATE(3052),
    [sym_preproc_undef] = STATE(3052),
    [sym__identifier_token] = ACTIONS(4271),
    [anon_sym_alias] = ACTIONS(4273),
    [anon_sym_global] = ACTIONS(4273),
    [anon_sym_LBRACK] = ACTIONS(4283),
    [anon_sym_LPAREN] = ACTIONS(4283),
    [anon_sym_LBRACE] = ACTIONS(4277),
    [anon_sym_file] = ACTIONS(4273),
    [anon_sym_LT] = ACTIONS(4285),
    [anon_sym_GT] = ACTIONS(4285),
    [anon_sym_where] = ACTIONS(4273),
    [anon_sym_QMARK] = ACTIONS(4285),
    [anon_sym_notnull] = ACTIONS(4273),
    [anon_sym_unmanaged] = ACTIONS(4273),
    [anon_sym_BANG] = ACTIONS(4285),
    [anon_sym_PLUS_PLUS] = ACTIONS(4283),
    [anon_sym_DASH_DASH] = ACTIONS(4283),
    [anon_sym_PLUS] = ACTIONS(4285),
    [anon_sym_DASH] = ACTIONS(4285),
    [anon_sym_STAR] = ACTIONS(4283),
    [anon_sym_SLASH] = ACTIONS(4285),
    [anon_sym_PERCENT] = ACTIONS(4283),
    [anon_sym_CARET] = ACTIONS(4283),
    [anon_sym_PIPE] = ACTIONS(4285),
    [anon_sym_AMP] = ACTIONS(4285),
    [anon_sym_LT_LT] = ACTIONS(4283),
    [anon_sym_GT_GT] = ACTIONS(4285),
    [anon_sym_GT_GT_GT] = ACTIONS(4283),
    [anon_sym_EQ_EQ] = ACTIONS(4283),
    [anon_sym_BANG_EQ] = ACTIONS(4283),
    [anon_sym_GT_EQ] = ACTIONS(4283),
    [anon_sym_LT_EQ] = ACTIONS(4283),
    [anon_sym_DOT] = ACTIONS(4285),
    [anon_sym_scoped] = ACTIONS(4273),
    [anon_sym_var] = ACTIONS(4273),
    [anon_sym_yield] = ACTIONS(4273),
    [anon_sym_switch] = ACTIONS(4285),
    [anon_sym_when] = ACTIONS(4273),
    [sym_discard] = ACTIONS(4281),
    [anon_sym_DOT_DOT] = ACTIONS(4283),
    [anon_sym_and] = ACTIONS(4279),
    [anon_sym_or] = ACTIONS(4279),
    [anon_sym_AMP_AMP] = ACTIONS(4283),
    [anon_sym_PIPE_PIPE] = ACTIONS(4283),
    [anon_sym_QMARK_QMARK] = ACTIONS(4283),
    [anon_sym_from] = ACTIONS(4273),
    [anon_sym_into] = ACTIONS(4285),
    [anon_sym_join] = ACTIONS(4273),
    [anon_sym_on] = ACTIONS(4273),
    [anon_sym_equals] = ACTIONS(4273),
    [anon_sym_let] = ACTIONS(4273),
    [anon_sym_orderby] = ACTIONS(4273),
    [anon_sym_ascending] = ACTIONS(4273),
    [anon_sym_descending] = ACTIONS(4273),
    [anon_sym_group] = ACTIONS(4273),
    [anon_sym_by] = ACTIONS(4285),
    [anon_sym_select] = ACTIONS(4273),
    [anon_sym_as] = ACTIONS(4285),
    [anon_sym_is] = ACTIONS(4285),
    [anon_sym_DASH_GT] = ACTIONS(4283),
    [anon_sym_with] = ACTIONS(4285),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3053] = {
    [sym_property_pattern_clause] = STATE(3108),
    [sym__variable_designation] = STATE(5399),
    [sym_parenthesized_variable_designation] = STATE(5390),
    [sym_identifier] = STATE(5396),
    [sym__reserved_identifier] = STATE(5128),
    [sym_preproc_region] = STATE(3053),
    [sym_preproc_endregion] = STATE(3053),
    [sym_preproc_line] = STATE(3053),
    [sym_preproc_pragma] = STATE(3053),
    [sym_preproc_nullable] = STATE(3053),
    [sym_preproc_error] = STATE(3053),
    [sym_preproc_define] = STATE(3053),
    [sym_preproc_undef] = STATE(3053),
    [sym__identifier_token] = ACTIONS(4482),
    [anon_sym_alias] = ACTIONS(4484),
    [anon_sym_global] = ACTIONS(4484),
    [anon_sym_LBRACK] = ACTIONS(4329),
    [anon_sym_COLON] = ACTIONS(4329),
    [anon_sym_COMMA] = ACTIONS(4329),
    [anon_sym_LPAREN] = ACTIONS(4329),
    [anon_sym_LBRACE] = ACTIONS(4486),
    [anon_sym_file] = ACTIONS(4484),
    [anon_sym_LT] = ACTIONS(4331),
    [anon_sym_GT] = ACTIONS(4331),
    [anon_sym_where] = ACTIONS(4484),
    [anon_sym_QMARK] = ACTIONS(4331),
    [anon_sym_notnull] = ACTIONS(4484),
    [anon_sym_unmanaged] = ACTIONS(4484),
    [anon_sym_BANG] = ACTIONS(4331),
    [anon_sym_PLUS_PLUS] = ACTIONS(4329),
    [anon_sym_DASH_DASH] = ACTIONS(4329),
    [anon_sym_PLUS] = ACTIONS(4331),
    [anon_sym_DASH] = ACTIONS(4331),
    [anon_sym_STAR] = ACTIONS(4329),
    [anon_sym_SLASH] = ACTIONS(4331),
    [anon_sym_PERCENT] = ACTIONS(4329),
    [anon_sym_CARET] = ACTIONS(4329),
    [anon_sym_PIPE] = ACTIONS(4331),
    [anon_sym_AMP] = ACTIONS(4331),
    [anon_sym_LT_LT] = ACTIONS(4329),
    [anon_sym_GT_GT] = ACTIONS(4331),
    [anon_sym_GT_GT_GT] = ACTIONS(4329),
    [anon_sym_EQ_EQ] = ACTIONS(4329),
    [anon_sym_BANG_EQ] = ACTIONS(4329),
    [anon_sym_GT_EQ] = ACTIONS(4329),
    [anon_sym_LT_EQ] = ACTIONS(4329),
    [anon_sym_DOT] = ACTIONS(4331),
    [anon_sym_scoped] = ACTIONS(4484),
    [anon_sym_var] = ACTIONS(4484),
    [anon_sym_yield] = ACTIONS(4484),
    [anon_sym_switch] = ACTIONS(4331),
    [anon_sym_when] = ACTIONS(4484),
    [sym_discard] = ACTIONS(4488),
    [anon_sym_DOT_DOT] = ACTIONS(4329),
    [anon_sym_and] = ACTIONS(4331),
    [anon_sym_or] = ACTIONS(4331),
    [anon_sym_AMP_AMP] = ACTIONS(4329),
    [anon_sym_PIPE_PIPE] = ACTIONS(4329),
    [anon_sym_QMARK_QMARK] = ACTIONS(4329),
    [anon_sym_from] = ACTIONS(4484),
    [anon_sym_into] = ACTIONS(4331),
    [anon_sym_join] = ACTIONS(4484),
    [anon_sym_on] = ACTIONS(4484),
    [anon_sym_equals] = ACTIONS(4484),
    [anon_sym_let] = ACTIONS(4484),
    [anon_sym_orderby] = ACTIONS(4484),
    [anon_sym_ascending] = ACTIONS(4484),
    [anon_sym_descending] = ACTIONS(4484),
    [anon_sym_group] = ACTIONS(4484),
    [anon_sym_by] = ACTIONS(4484),
    [anon_sym_select] = ACTIONS(4484),
    [anon_sym_as] = ACTIONS(4331),
    [anon_sym_is] = ACTIONS(4331),
    [anon_sym_DASH_GT] = ACTIONS(4329),
    [anon_sym_with] = ACTIONS(4331),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4329),
  },
  [3054] = {
    [sym_parameter_list] = STATE(9765),
    [sym_positional_pattern_clause] = STATE(3158),
    [sym_property_pattern_clause] = STATE(3215),
    [sym__variable_designation] = STATE(4260),
    [sym_parenthesized_variable_designation] = STATE(4274),
    [sym__lambda_parameters] = STATE(9127),
    [sym_identifier] = STATE(4259),
    [sym__reserved_identifier] = STATE(3908),
    [sym_preproc_region] = STATE(3054),
    [sym_preproc_endregion] = STATE(3054),
    [sym_preproc_line] = STATE(3054),
    [sym_preproc_pragma] = STATE(3054),
    [sym_preproc_nullable] = STATE(3054),
    [sym_preproc_error] = STATE(3054),
    [sym_preproc_define] = STATE(3054),
    [sym_preproc_undef] = STATE(3054),
    [sym__identifier_token] = ACTIONS(4271),
    [anon_sym_alias] = ACTIONS(4273),
    [anon_sym_global] = ACTIONS(4273),
    [anon_sym_LBRACK] = ACTIONS(4283),
    [anon_sym_LPAREN] = ACTIONS(4283),
    [anon_sym_LBRACE] = ACTIONS(4277),
    [anon_sym_file] = ACTIONS(4273),
    [anon_sym_LT] = ACTIONS(4285),
    [anon_sym_GT] = ACTIONS(4285),
    [anon_sym_where] = ACTIONS(4273),
    [anon_sym_QMARK] = ACTIONS(4285),
    [anon_sym_notnull] = ACTIONS(4273),
    [anon_sym_unmanaged] = ACTIONS(4273),
    [anon_sym_BANG] = ACTIONS(4285),
    [anon_sym_PLUS_PLUS] = ACTIONS(4283),
    [anon_sym_DASH_DASH] = ACTIONS(4283),
    [anon_sym_PLUS] = ACTIONS(4285),
    [anon_sym_DASH] = ACTIONS(4285),
    [anon_sym_STAR] = ACTIONS(4283),
    [anon_sym_SLASH] = ACTIONS(4285),
    [anon_sym_PERCENT] = ACTIONS(4283),
    [anon_sym_CARET] = ACTIONS(4283),
    [anon_sym_PIPE] = ACTIONS(4285),
    [anon_sym_AMP] = ACTIONS(4285),
    [anon_sym_LT_LT] = ACTIONS(4283),
    [anon_sym_GT_GT] = ACTIONS(4285),
    [anon_sym_GT_GT_GT] = ACTIONS(4283),
    [anon_sym_EQ_EQ] = ACTIONS(4283),
    [anon_sym_BANG_EQ] = ACTIONS(4283),
    [anon_sym_GT_EQ] = ACTIONS(4283),
    [anon_sym_LT_EQ] = ACTIONS(4283),
    [anon_sym_DOT] = ACTIONS(4285),
    [anon_sym_scoped] = ACTIONS(4273),
    [anon_sym_var] = ACTIONS(4273),
    [anon_sym_yield] = ACTIONS(4273),
    [anon_sym_switch] = ACTIONS(4285),
    [anon_sym_when] = ACTIONS(4273),
    [sym_discard] = ACTIONS(4295),
    [anon_sym_DOT_DOT] = ACTIONS(4283),
    [anon_sym_and] = ACTIONS(4279),
    [anon_sym_or] = ACTIONS(4279),
    [anon_sym_AMP_AMP] = ACTIONS(4283),
    [anon_sym_PIPE_PIPE] = ACTIONS(4283),
    [anon_sym_QMARK_QMARK] = ACTIONS(4283),
    [anon_sym_from] = ACTIONS(4273),
    [anon_sym_into] = ACTIONS(4273),
    [anon_sym_join] = ACTIONS(4273),
    [anon_sym_on] = ACTIONS(4273),
    [anon_sym_equals] = ACTIONS(4273),
    [anon_sym_let] = ACTIONS(4273),
    [anon_sym_orderby] = ACTIONS(4273),
    [anon_sym_ascending] = ACTIONS(4273),
    [anon_sym_descending] = ACTIONS(4273),
    [anon_sym_group] = ACTIONS(4273),
    [anon_sym_by] = ACTIONS(4285),
    [anon_sym_select] = ACTIONS(4273),
    [anon_sym_as] = ACTIONS(4285),
    [anon_sym_is] = ACTIONS(4285),
    [anon_sym_DASH_GT] = ACTIONS(4283),
    [anon_sym_with] = ACTIONS(4285),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3055] = {
    [sym_parameter_list] = STATE(9765),
    [sym_positional_pattern_clause] = STATE(3154),
    [sym_property_pattern_clause] = STATE(3454),
    [sym__variable_designation] = STATE(4021),
    [sym_parenthesized_variable_designation] = STATE(4015),
    [sym__lambda_parameters] = STATE(9127),
    [sym_identifier] = STATE(4055),
    [sym__reserved_identifier] = STATE(3908),
    [sym_preproc_region] = STATE(3055),
    [sym_preproc_endregion] = STATE(3055),
    [sym_preproc_line] = STATE(3055),
    [sym_preproc_pragma] = STATE(3055),
    [sym_preproc_nullable] = STATE(3055),
    [sym_preproc_error] = STATE(3055),
    [sym_preproc_define] = STATE(3055),
    [sym_preproc_undef] = STATE(3055),
    [sym__identifier_token] = ACTIONS(4271),
    [anon_sym_alias] = ACTIONS(4273),
    [anon_sym_global] = ACTIONS(4273),
    [anon_sym_LBRACK] = ACTIONS(4283),
    [anon_sym_LPAREN] = ACTIONS(4283),
    [anon_sym_LBRACE] = ACTIONS(4277),
    [anon_sym_file] = ACTIONS(4273),
    [anon_sym_LT] = ACTIONS(4285),
    [anon_sym_GT] = ACTIONS(4285),
    [anon_sym_where] = ACTIONS(4273),
    [anon_sym_QMARK] = ACTIONS(4285),
    [anon_sym_notnull] = ACTIONS(4273),
    [anon_sym_unmanaged] = ACTIONS(4273),
    [anon_sym_BANG] = ACTIONS(4285),
    [anon_sym_PLUS_PLUS] = ACTIONS(4283),
    [anon_sym_DASH_DASH] = ACTIONS(4283),
    [anon_sym_PLUS] = ACTIONS(4285),
    [anon_sym_DASH] = ACTIONS(4285),
    [anon_sym_STAR] = ACTIONS(4283),
    [anon_sym_SLASH] = ACTIONS(4285),
    [anon_sym_PERCENT] = ACTIONS(4283),
    [anon_sym_CARET] = ACTIONS(4283),
    [anon_sym_PIPE] = ACTIONS(4285),
    [anon_sym_AMP] = ACTIONS(4285),
    [anon_sym_LT_LT] = ACTIONS(4283),
    [anon_sym_GT_GT] = ACTIONS(4285),
    [anon_sym_GT_GT_GT] = ACTIONS(4283),
    [anon_sym_EQ_EQ] = ACTIONS(4283),
    [anon_sym_BANG_EQ] = ACTIONS(4283),
    [anon_sym_GT_EQ] = ACTIONS(4283),
    [anon_sym_LT_EQ] = ACTIONS(4283),
    [anon_sym_DOT] = ACTIONS(4285),
    [anon_sym_scoped] = ACTIONS(4273),
    [anon_sym_var] = ACTIONS(4273),
    [anon_sym_yield] = ACTIONS(4273),
    [anon_sym_switch] = ACTIONS(4285),
    [anon_sym_when] = ACTIONS(4273),
    [sym_discard] = ACTIONS(4281),
    [anon_sym_DOT_DOT] = ACTIONS(4283),
    [anon_sym_and] = ACTIONS(4285),
    [anon_sym_or] = ACTIONS(4285),
    [anon_sym_AMP_AMP] = ACTIONS(4283),
    [anon_sym_PIPE_PIPE] = ACTIONS(4283),
    [anon_sym_QMARK_QMARK] = ACTIONS(4283),
    [anon_sym_from] = ACTIONS(4273),
    [anon_sym_into] = ACTIONS(4285),
    [anon_sym_join] = ACTIONS(4273),
    [anon_sym_on] = ACTIONS(4285),
    [anon_sym_equals] = ACTIONS(4273),
    [anon_sym_let] = ACTIONS(4273),
    [anon_sym_orderby] = ACTIONS(4273),
    [anon_sym_ascending] = ACTIONS(4273),
    [anon_sym_descending] = ACTIONS(4273),
    [anon_sym_group] = ACTIONS(4273),
    [anon_sym_by] = ACTIONS(4273),
    [anon_sym_select] = ACTIONS(4273),
    [anon_sym_as] = ACTIONS(4285),
    [anon_sym_is] = ACTIONS(4285),
    [anon_sym_DASH_GT] = ACTIONS(4283),
    [anon_sym_with] = ACTIONS(4285),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3056] = {
    [sym_parameter_list] = STATE(9765),
    [sym_positional_pattern_clause] = STATE(3155),
    [sym_property_pattern_clause] = STATE(3363),
    [sym__variable_designation] = STATE(4260),
    [sym_parenthesized_variable_designation] = STATE(4274),
    [sym__lambda_parameters] = STATE(9127),
    [sym_identifier] = STATE(4259),
    [sym__reserved_identifier] = STATE(3908),
    [sym_preproc_region] = STATE(3056),
    [sym_preproc_endregion] = STATE(3056),
    [sym_preproc_line] = STATE(3056),
    [sym_preproc_pragma] = STATE(3056),
    [sym_preproc_nullable] = STATE(3056),
    [sym_preproc_error] = STATE(3056),
    [sym_preproc_define] = STATE(3056),
    [sym_preproc_undef] = STATE(3056),
    [sym__identifier_token] = ACTIONS(4271),
    [anon_sym_alias] = ACTIONS(4273),
    [anon_sym_global] = ACTIONS(4273),
    [anon_sym_LBRACK] = ACTIONS(4283),
    [anon_sym_LPAREN] = ACTIONS(4283),
    [anon_sym_LBRACE] = ACTIONS(4277),
    [anon_sym_file] = ACTIONS(4273),
    [anon_sym_LT] = ACTIONS(4285),
    [anon_sym_GT] = ACTIONS(4285),
    [anon_sym_where] = ACTIONS(4273),
    [anon_sym_QMARK] = ACTIONS(4285),
    [anon_sym_notnull] = ACTIONS(4273),
    [anon_sym_unmanaged] = ACTIONS(4273),
    [anon_sym_BANG] = ACTIONS(4285),
    [anon_sym_PLUS_PLUS] = ACTIONS(4283),
    [anon_sym_DASH_DASH] = ACTIONS(4283),
    [anon_sym_PLUS] = ACTIONS(4285),
    [anon_sym_DASH] = ACTIONS(4285),
    [anon_sym_STAR] = ACTIONS(4283),
    [anon_sym_SLASH] = ACTIONS(4285),
    [anon_sym_PERCENT] = ACTIONS(4283),
    [anon_sym_CARET] = ACTIONS(4283),
    [anon_sym_PIPE] = ACTIONS(4285),
    [anon_sym_AMP] = ACTIONS(4285),
    [anon_sym_LT_LT] = ACTIONS(4283),
    [anon_sym_GT_GT] = ACTIONS(4285),
    [anon_sym_GT_GT_GT] = ACTIONS(4283),
    [anon_sym_EQ_EQ] = ACTIONS(4283),
    [anon_sym_BANG_EQ] = ACTIONS(4283),
    [anon_sym_GT_EQ] = ACTIONS(4283),
    [anon_sym_LT_EQ] = ACTIONS(4283),
    [anon_sym_DOT] = ACTIONS(4285),
    [anon_sym_scoped] = ACTIONS(4273),
    [anon_sym_var] = ACTIONS(4273),
    [anon_sym_yield] = ACTIONS(4273),
    [anon_sym_switch] = ACTIONS(4285),
    [anon_sym_when] = ACTIONS(4273),
    [sym_discard] = ACTIONS(4295),
    [anon_sym_DOT_DOT] = ACTIONS(4283),
    [anon_sym_and] = ACTIONS(4279),
    [anon_sym_or] = ACTIONS(4279),
    [anon_sym_AMP_AMP] = ACTIONS(4283),
    [anon_sym_PIPE_PIPE] = ACTIONS(4283),
    [anon_sym_QMARK_QMARK] = ACTIONS(4283),
    [anon_sym_from] = ACTIONS(4273),
    [anon_sym_into] = ACTIONS(4273),
    [anon_sym_join] = ACTIONS(4273),
    [anon_sym_on] = ACTIONS(4273),
    [anon_sym_equals] = ACTIONS(4285),
    [anon_sym_let] = ACTIONS(4273),
    [anon_sym_orderby] = ACTIONS(4273),
    [anon_sym_ascending] = ACTIONS(4273),
    [anon_sym_descending] = ACTIONS(4273),
    [anon_sym_group] = ACTIONS(4273),
    [anon_sym_by] = ACTIONS(4273),
    [anon_sym_select] = ACTIONS(4273),
    [anon_sym_as] = ACTIONS(4285),
    [anon_sym_is] = ACTIONS(4285),
    [anon_sym_DASH_GT] = ACTIONS(4283),
    [anon_sym_with] = ACTIONS(4285),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3057] = {
    [sym_parameter_list] = STATE(9765),
    [sym_positional_pattern_clause] = STATE(3136),
    [sym_property_pattern_clause] = STATE(3346),
    [sym__variable_designation] = STATE(5001),
    [sym_parenthesized_variable_designation] = STATE(4957),
    [sym__lambda_parameters] = STATE(9127),
    [sym_identifier] = STATE(4944),
    [sym__reserved_identifier] = STATE(3558),
    [sym_preproc_region] = STATE(3057),
    [sym_preproc_endregion] = STATE(3057),
    [sym_preproc_line] = STATE(3057),
    [sym_preproc_pragma] = STATE(3057),
    [sym_preproc_nullable] = STATE(3057),
    [sym_preproc_error] = STATE(3057),
    [sym_preproc_define] = STATE(3057),
    [sym_preproc_undef] = STATE(3057),
    [sym__identifier_token] = ACTIONS(4225),
    [anon_sym_alias] = ACTIONS(4227),
    [anon_sym_global] = ACTIONS(4227),
    [anon_sym_LBRACK] = ACTIONS(4275),
    [anon_sym_LPAREN] = ACTIONS(4275),
    [anon_sym_LBRACE] = ACTIONS(4277),
    [anon_sym_file] = ACTIONS(4227),
    [anon_sym_LT] = ACTIONS(4279),
    [anon_sym_GT] = ACTIONS(4279),
    [anon_sym_where] = ACTIONS(4279),
    [anon_sym_QMARK] = ACTIONS(4279),
    [anon_sym_notnull] = ACTIONS(4227),
    [anon_sym_unmanaged] = ACTIONS(4227),
    [anon_sym_BANG] = ACTIONS(4279),
    [anon_sym_PLUS_PLUS] = ACTIONS(4275),
    [anon_sym_DASH_DASH] = ACTIONS(4275),
    [anon_sym_PLUS] = ACTIONS(4279),
    [anon_sym_DASH] = ACTIONS(4279),
    [anon_sym_STAR] = ACTIONS(4275),
    [anon_sym_SLASH] = ACTIONS(4279),
    [anon_sym_PERCENT] = ACTIONS(4275),
    [anon_sym_CARET] = ACTIONS(4275),
    [anon_sym_PIPE] = ACTIONS(4279),
    [anon_sym_AMP] = ACTIONS(4279),
    [anon_sym_LT_LT] = ACTIONS(4275),
    [anon_sym_GT_GT] = ACTIONS(4279),
    [anon_sym_GT_GT_GT] = ACTIONS(4275),
    [anon_sym_EQ_EQ] = ACTIONS(4275),
    [anon_sym_BANG_EQ] = ACTIONS(4275),
    [anon_sym_GT_EQ] = ACTIONS(4275),
    [anon_sym_LT_EQ] = ACTIONS(4275),
    [anon_sym_DOT] = ACTIONS(4279),
    [anon_sym_scoped] = ACTIONS(4227),
    [anon_sym_var] = ACTIONS(4227),
    [anon_sym_yield] = ACTIONS(4227),
    [anon_sym_switch] = ACTIONS(4279),
    [anon_sym_when] = ACTIONS(4227),
    [sym_discard] = ACTIONS(4649),
    [anon_sym_DOT_DOT] = ACTIONS(4275),
    [anon_sym_and] = ACTIONS(4279),
    [anon_sym_or] = ACTIONS(4279),
    [anon_sym_AMP_AMP] = ACTIONS(4275),
    [anon_sym_PIPE_PIPE] = ACTIONS(4275),
    [anon_sym_QMARK_QMARK] = ACTIONS(4275),
    [anon_sym_from] = ACTIONS(4279),
    [anon_sym_into] = ACTIONS(4279),
    [anon_sym_join] = ACTIONS(4279),
    [anon_sym_on] = ACTIONS(4227),
    [anon_sym_equals] = ACTIONS(4227),
    [anon_sym_let] = ACTIONS(4279),
    [anon_sym_orderby] = ACTIONS(4279),
    [anon_sym_ascending] = ACTIONS(4227),
    [anon_sym_descending] = ACTIONS(4227),
    [anon_sym_group] = ACTIONS(4279),
    [anon_sym_by] = ACTIONS(4227),
    [anon_sym_select] = ACTIONS(4279),
    [anon_sym_as] = ACTIONS(4279),
    [anon_sym_is] = ACTIONS(4279),
    [anon_sym_DASH_GT] = ACTIONS(4275),
    [anon_sym_with] = ACTIONS(4279),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3058] = {
    [sym_parameter_list] = STATE(9765),
    [sym_positional_pattern_clause] = STATE(3134),
    [sym_property_pattern_clause] = STATE(3268),
    [sym__variable_designation] = STATE(5001),
    [sym_parenthesized_variable_designation] = STATE(4957),
    [sym__lambda_parameters] = STATE(9127),
    [sym_identifier] = STATE(4944),
    [sym__reserved_identifier] = STATE(3568),
    [sym_preproc_region] = STATE(3058),
    [sym_preproc_endregion] = STATE(3058),
    [sym_preproc_line] = STATE(3058),
    [sym_preproc_pragma] = STATE(3058),
    [sym_preproc_nullable] = STATE(3058),
    [sym_preproc_error] = STATE(3058),
    [sym_preproc_define] = STATE(3058),
    [sym_preproc_undef] = STATE(3058),
    [sym__identifier_token] = ACTIONS(4287),
    [anon_sym_alias] = ACTIONS(4289),
    [anon_sym_global] = ACTIONS(4289),
    [anon_sym_LBRACK] = ACTIONS(4275),
    [anon_sym_LPAREN] = ACTIONS(4275),
    [anon_sym_LBRACE] = ACTIONS(4277),
    [anon_sym_file] = ACTIONS(4289),
    [anon_sym_LT] = ACTIONS(4279),
    [anon_sym_GT] = ACTIONS(4279),
    [anon_sym_where] = ACTIONS(4279),
    [anon_sym_QMARK] = ACTIONS(4279),
    [anon_sym_notnull] = ACTIONS(4289),
    [anon_sym_unmanaged] = ACTIONS(4289),
    [anon_sym_BANG] = ACTIONS(4279),
    [anon_sym_PLUS_PLUS] = ACTIONS(4275),
    [anon_sym_DASH_DASH] = ACTIONS(4275),
    [anon_sym_PLUS] = ACTIONS(4279),
    [anon_sym_DASH] = ACTIONS(4279),
    [anon_sym_STAR] = ACTIONS(4275),
    [anon_sym_SLASH] = ACTIONS(4279),
    [anon_sym_PERCENT] = ACTIONS(4275),
    [anon_sym_CARET] = ACTIONS(4275),
    [anon_sym_PIPE] = ACTIONS(4279),
    [anon_sym_AMP] = ACTIONS(4279),
    [anon_sym_LT_LT] = ACTIONS(4275),
    [anon_sym_GT_GT] = ACTIONS(4279),
    [anon_sym_GT_GT_GT] = ACTIONS(4275),
    [anon_sym_EQ_EQ] = ACTIONS(4275),
    [anon_sym_BANG_EQ] = ACTIONS(4275),
    [anon_sym_GT_EQ] = ACTIONS(4275),
    [anon_sym_LT_EQ] = ACTIONS(4275),
    [anon_sym_DOT] = ACTIONS(4279),
    [anon_sym_scoped] = ACTIONS(4289),
    [anon_sym_var] = ACTIONS(4289),
    [anon_sym_yield] = ACTIONS(4289),
    [anon_sym_switch] = ACTIONS(4279),
    [anon_sym_when] = ACTIONS(4289),
    [sym_discard] = ACTIONS(4649),
    [anon_sym_DOT_DOT] = ACTIONS(4275),
    [anon_sym_and] = ACTIONS(4279),
    [anon_sym_or] = ACTIONS(4279),
    [anon_sym_AMP_AMP] = ACTIONS(4275),
    [anon_sym_PIPE_PIPE] = ACTIONS(4275),
    [anon_sym_QMARK_QMARK] = ACTIONS(4275),
    [anon_sym_from] = ACTIONS(4279),
    [anon_sym_into] = ACTIONS(4289),
    [anon_sym_join] = ACTIONS(4279),
    [anon_sym_on] = ACTIONS(4289),
    [anon_sym_equals] = ACTIONS(4289),
    [anon_sym_let] = ACTIONS(4279),
    [anon_sym_orderby] = ACTIONS(4279),
    [anon_sym_ascending] = ACTIONS(4289),
    [anon_sym_descending] = ACTIONS(4289),
    [anon_sym_group] = ACTIONS(4279),
    [anon_sym_by] = ACTIONS(4289),
    [anon_sym_select] = ACTIONS(4279),
    [anon_sym_as] = ACTIONS(4279),
    [anon_sym_is] = ACTIONS(4279),
    [anon_sym_DASH_GT] = ACTIONS(4275),
    [anon_sym_with] = ACTIONS(4279),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3059] = {
    [sym_property_pattern_clause] = STATE(3115),
    [sym__variable_designation] = STATE(5410),
    [sym_parenthesized_variable_designation] = STATE(5390),
    [sym_identifier] = STATE(5396),
    [sym__reserved_identifier] = STATE(5128),
    [sym_preproc_region] = STATE(3059),
    [sym_preproc_endregion] = STATE(3059),
    [sym_preproc_line] = STATE(3059),
    [sym_preproc_pragma] = STATE(3059),
    [sym_preproc_nullable] = STATE(3059),
    [sym_preproc_error] = STATE(3059),
    [sym_preproc_define] = STATE(3059),
    [sym_preproc_undef] = STATE(3059),
    [sym__identifier_token] = ACTIONS(4482),
    [anon_sym_alias] = ACTIONS(4484),
    [anon_sym_global] = ACTIONS(4484),
    [anon_sym_LBRACK] = ACTIONS(4335),
    [anon_sym_COLON] = ACTIONS(4335),
    [anon_sym_COMMA] = ACTIONS(4335),
    [anon_sym_LPAREN] = ACTIONS(4335),
    [anon_sym_LBRACE] = ACTIONS(4486),
    [anon_sym_file] = ACTIONS(4484),
    [anon_sym_LT] = ACTIONS(4337),
    [anon_sym_GT] = ACTIONS(4337),
    [anon_sym_where] = ACTIONS(4484),
    [anon_sym_QMARK] = ACTIONS(4337),
    [anon_sym_notnull] = ACTIONS(4484),
    [anon_sym_unmanaged] = ACTIONS(4484),
    [anon_sym_BANG] = ACTIONS(4337),
    [anon_sym_PLUS_PLUS] = ACTIONS(4335),
    [anon_sym_DASH_DASH] = ACTIONS(4335),
    [anon_sym_PLUS] = ACTIONS(4337),
    [anon_sym_DASH] = ACTIONS(4337),
    [anon_sym_STAR] = ACTIONS(4335),
    [anon_sym_SLASH] = ACTIONS(4337),
    [anon_sym_PERCENT] = ACTIONS(4335),
    [anon_sym_CARET] = ACTIONS(4335),
    [anon_sym_PIPE] = ACTIONS(4337),
    [anon_sym_AMP] = ACTIONS(4337),
    [anon_sym_LT_LT] = ACTIONS(4335),
    [anon_sym_GT_GT] = ACTIONS(4337),
    [anon_sym_GT_GT_GT] = ACTIONS(4335),
    [anon_sym_EQ_EQ] = ACTIONS(4335),
    [anon_sym_BANG_EQ] = ACTIONS(4335),
    [anon_sym_GT_EQ] = ACTIONS(4335),
    [anon_sym_LT_EQ] = ACTIONS(4335),
    [anon_sym_DOT] = ACTIONS(4337),
    [anon_sym_scoped] = ACTIONS(4484),
    [anon_sym_var] = ACTIONS(4484),
    [anon_sym_yield] = ACTIONS(4484),
    [anon_sym_switch] = ACTIONS(4337),
    [anon_sym_when] = ACTIONS(4484),
    [sym_discard] = ACTIONS(4488),
    [anon_sym_DOT_DOT] = ACTIONS(4335),
    [anon_sym_and] = ACTIONS(4337),
    [anon_sym_or] = ACTIONS(4337),
    [anon_sym_AMP_AMP] = ACTIONS(4335),
    [anon_sym_PIPE_PIPE] = ACTIONS(4335),
    [anon_sym_QMARK_QMARK] = ACTIONS(4335),
    [anon_sym_from] = ACTIONS(4484),
    [anon_sym_into] = ACTIONS(4337),
    [anon_sym_join] = ACTIONS(4484),
    [anon_sym_on] = ACTIONS(4484),
    [anon_sym_equals] = ACTIONS(4484),
    [anon_sym_let] = ACTIONS(4484),
    [anon_sym_orderby] = ACTIONS(4484),
    [anon_sym_ascending] = ACTIONS(4484),
    [anon_sym_descending] = ACTIONS(4484),
    [anon_sym_group] = ACTIONS(4484),
    [anon_sym_by] = ACTIONS(4484),
    [anon_sym_select] = ACTIONS(4484),
    [anon_sym_as] = ACTIONS(4337),
    [anon_sym_is] = ACTIONS(4337),
    [anon_sym_DASH_GT] = ACTIONS(4335),
    [anon_sym_with] = ACTIONS(4337),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4335),
  },
  [3060] = {
    [sym__name] = STATE(3768),
    [sym_alias_qualified_name] = STATE(3635),
    [sym__simple_name] = STATE(3635),
    [sym_qualified_name] = STATE(3635),
    [sym_generic_name] = STATE(3708),
    [sym_ref_type] = STATE(3636),
    [sym__scoped_base_type] = STATE(3641),
    [sym_identifier] = STATE(3590),
    [sym__reserved_identifier] = STATE(3568),
    [sym_preproc_region] = STATE(3060),
    [sym_preproc_endregion] = STATE(3060),
    [sym_preproc_line] = STATE(3060),
    [sym_preproc_pragma] = STATE(3060),
    [sym_preproc_nullable] = STATE(3060),
    [sym_preproc_error] = STATE(3060),
    [sym_preproc_define] = STATE(3060),
    [sym_preproc_undef] = STATE(3060),
    [sym__identifier_token] = ACTIONS(4287),
    [anon_sym_alias] = ACTIONS(4289),
    [anon_sym_global] = ACTIONS(4289),
    [anon_sym_LBRACK] = ACTIONS(3719),
    [anon_sym_LPAREN] = ACTIONS(3719),
    [anon_sym_ref] = ACTIONS(4653),
    [anon_sym_LBRACE] = ACTIONS(3719),
    [anon_sym_file] = ACTIONS(4289),
    [anon_sym_LT] = ACTIONS(3721),
    [anon_sym_GT] = ACTIONS(3721),
    [anon_sym_where] = ACTIONS(4289),
    [anon_sym_QMARK] = ACTIONS(3721),
    [anon_sym_notnull] = ACTIONS(4289),
    [anon_sym_unmanaged] = ACTIONS(4289),
    [anon_sym_BANG] = ACTIONS(3721),
    [anon_sym_PLUS_PLUS] = ACTIONS(3719),
    [anon_sym_DASH_DASH] = ACTIONS(3719),
    [anon_sym_PLUS] = ACTIONS(3721),
    [anon_sym_DASH] = ACTIONS(3721),
    [anon_sym_STAR] = ACTIONS(3719),
    [anon_sym_SLASH] = ACTIONS(3721),
    [anon_sym_PERCENT] = ACTIONS(3719),
    [anon_sym_CARET] = ACTIONS(3719),
    [anon_sym_PIPE] = ACTIONS(3721),
    [anon_sym_AMP] = ACTIONS(3721),
    [anon_sym_LT_LT] = ACTIONS(3719),
    [anon_sym_GT_GT] = ACTIONS(3721),
    [anon_sym_GT_GT_GT] = ACTIONS(3719),
    [anon_sym_EQ_EQ] = ACTIONS(3719),
    [anon_sym_BANG_EQ] = ACTIONS(3719),
    [anon_sym_GT_EQ] = ACTIONS(3719),
    [anon_sym_LT_EQ] = ACTIONS(3719),
    [anon_sym_DOT] = ACTIONS(3721),
    [anon_sym_scoped] = ACTIONS(4289),
    [anon_sym_COLON_COLON] = ACTIONS(3719),
    [anon_sym_var] = ACTIONS(4289),
    [anon_sym_yield] = ACTIONS(4289),
    [anon_sym_switch] = ACTIONS(3721),
    [anon_sym_when] = ACTIONS(4289),
    [anon_sym_DOT_DOT] = ACTIONS(3719),
    [anon_sym_AMP_AMP] = ACTIONS(3719),
    [anon_sym_PIPE_PIPE] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK] = ACTIONS(3719),
    [anon_sym_from] = ACTIONS(4289),
    [anon_sym_into] = ACTIONS(4289),
    [anon_sym_join] = ACTIONS(4289),
    [anon_sym_on] = ACTIONS(4289),
    [anon_sym_equals] = ACTIONS(4289),
    [anon_sym_let] = ACTIONS(4289),
    [anon_sym_orderby] = ACTIONS(4289),
    [anon_sym_ascending] = ACTIONS(4289),
    [anon_sym_descending] = ACTIONS(4289),
    [anon_sym_group] = ACTIONS(4289),
    [anon_sym_by] = ACTIONS(4612),
    [anon_sym_select] = ACTIONS(4289),
    [anon_sym_as] = ACTIONS(3721),
    [anon_sym_is] = ACTIONS(3721),
    [anon_sym_DASH_GT] = ACTIONS(3719),
    [anon_sym_with] = ACTIONS(3721),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3061] = {
    [sym_parameter_list] = STATE(9765),
    [sym_positional_pattern_clause] = STATE(3145),
    [sym_property_pattern_clause] = STATE(3484),
    [sym__variable_designation] = STATE(4021),
    [sym_parenthesized_variable_designation] = STATE(4015),
    [sym__lambda_parameters] = STATE(9127),
    [sym_identifier] = STATE(4055),
    [sym__reserved_identifier] = STATE(3908),
    [sym_preproc_region] = STATE(3061),
    [sym_preproc_endregion] = STATE(3061),
    [sym_preproc_line] = STATE(3061),
    [sym_preproc_pragma] = STATE(3061),
    [sym_preproc_nullable] = STATE(3061),
    [sym_preproc_error] = STATE(3061),
    [sym_preproc_define] = STATE(3061),
    [sym_preproc_undef] = STATE(3061),
    [sym__identifier_token] = ACTIONS(4271),
    [anon_sym_alias] = ACTIONS(4273),
    [anon_sym_global] = ACTIONS(4273),
    [anon_sym_LBRACK] = ACTIONS(4275),
    [anon_sym_LPAREN] = ACTIONS(4275),
    [anon_sym_LBRACE] = ACTIONS(4277),
    [anon_sym_file] = ACTIONS(4273),
    [anon_sym_LT] = ACTIONS(4279),
    [anon_sym_GT] = ACTIONS(4279),
    [anon_sym_where] = ACTIONS(4273),
    [anon_sym_QMARK] = ACTIONS(4279),
    [anon_sym_notnull] = ACTIONS(4273),
    [anon_sym_unmanaged] = ACTIONS(4273),
    [anon_sym_BANG] = ACTIONS(4279),
    [anon_sym_PLUS_PLUS] = ACTIONS(4275),
    [anon_sym_DASH_DASH] = ACTIONS(4275),
    [anon_sym_PLUS] = ACTIONS(4279),
    [anon_sym_DASH] = ACTIONS(4279),
    [anon_sym_STAR] = ACTIONS(4275),
    [anon_sym_SLASH] = ACTIONS(4279),
    [anon_sym_PERCENT] = ACTIONS(4275),
    [anon_sym_CARET] = ACTIONS(4275),
    [anon_sym_PIPE] = ACTIONS(4279),
    [anon_sym_AMP] = ACTIONS(4279),
    [anon_sym_LT_LT] = ACTIONS(4275),
    [anon_sym_GT_GT] = ACTIONS(4279),
    [anon_sym_GT_GT_GT] = ACTIONS(4275),
    [anon_sym_EQ_EQ] = ACTIONS(4275),
    [anon_sym_BANG_EQ] = ACTIONS(4275),
    [anon_sym_GT_EQ] = ACTIONS(4275),
    [anon_sym_LT_EQ] = ACTIONS(4275),
    [anon_sym_DOT] = ACTIONS(4279),
    [anon_sym_scoped] = ACTIONS(4273),
    [anon_sym_var] = ACTIONS(4273),
    [anon_sym_yield] = ACTIONS(4273),
    [anon_sym_switch] = ACTIONS(4279),
    [anon_sym_when] = ACTIONS(4273),
    [sym_discard] = ACTIONS(4281),
    [anon_sym_DOT_DOT] = ACTIONS(4275),
    [anon_sym_and] = ACTIONS(4279),
    [anon_sym_or] = ACTIONS(4279),
    [anon_sym_AMP_AMP] = ACTIONS(4275),
    [anon_sym_PIPE_PIPE] = ACTIONS(4275),
    [anon_sym_QMARK_QMARK] = ACTIONS(4275),
    [anon_sym_from] = ACTIONS(4273),
    [anon_sym_into] = ACTIONS(4279),
    [anon_sym_join] = ACTIONS(4273),
    [anon_sym_on] = ACTIONS(4273),
    [anon_sym_equals] = ACTIONS(4279),
    [anon_sym_let] = ACTIONS(4273),
    [anon_sym_orderby] = ACTIONS(4273),
    [anon_sym_ascending] = ACTIONS(4273),
    [anon_sym_descending] = ACTIONS(4273),
    [anon_sym_group] = ACTIONS(4273),
    [anon_sym_by] = ACTIONS(4273),
    [anon_sym_select] = ACTIONS(4273),
    [anon_sym_as] = ACTIONS(4279),
    [anon_sym_is] = ACTIONS(4279),
    [anon_sym_DASH_GT] = ACTIONS(4275),
    [anon_sym_with] = ACTIONS(4279),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3062] = {
    [sym_parameter_list] = STATE(9765),
    [sym_positional_pattern_clause] = STATE(3141),
    [sym_property_pattern_clause] = STATE(3389),
    [sym__variable_designation] = STATE(4260),
    [sym_parenthesized_variable_designation] = STATE(4274),
    [sym__lambda_parameters] = STATE(9127),
    [sym_identifier] = STATE(4259),
    [sym__reserved_identifier] = STATE(3908),
    [sym_preproc_region] = STATE(3062),
    [sym_preproc_endregion] = STATE(3062),
    [sym_preproc_line] = STATE(3062),
    [sym_preproc_pragma] = STATE(3062),
    [sym_preproc_nullable] = STATE(3062),
    [sym_preproc_error] = STATE(3062),
    [sym_preproc_define] = STATE(3062),
    [sym_preproc_undef] = STATE(3062),
    [sym__identifier_token] = ACTIONS(4271),
    [anon_sym_alias] = ACTIONS(4273),
    [anon_sym_global] = ACTIONS(4273),
    [anon_sym_LBRACK] = ACTIONS(4283),
    [anon_sym_LPAREN] = ACTIONS(4283),
    [anon_sym_LBRACE] = ACTIONS(4277),
    [anon_sym_file] = ACTIONS(4273),
    [anon_sym_LT] = ACTIONS(4285),
    [anon_sym_GT] = ACTIONS(4285),
    [anon_sym_where] = ACTIONS(4273),
    [anon_sym_QMARK] = ACTIONS(4285),
    [anon_sym_notnull] = ACTIONS(4273),
    [anon_sym_unmanaged] = ACTIONS(4273),
    [anon_sym_BANG] = ACTIONS(4285),
    [anon_sym_PLUS_PLUS] = ACTIONS(4283),
    [anon_sym_DASH_DASH] = ACTIONS(4283),
    [anon_sym_PLUS] = ACTIONS(4285),
    [anon_sym_DASH] = ACTIONS(4285),
    [anon_sym_STAR] = ACTIONS(4283),
    [anon_sym_SLASH] = ACTIONS(4285),
    [anon_sym_PERCENT] = ACTIONS(4283),
    [anon_sym_CARET] = ACTIONS(4283),
    [anon_sym_PIPE] = ACTIONS(4285),
    [anon_sym_AMP] = ACTIONS(4285),
    [anon_sym_LT_LT] = ACTIONS(4283),
    [anon_sym_GT_GT] = ACTIONS(4285),
    [anon_sym_GT_GT_GT] = ACTIONS(4283),
    [anon_sym_EQ_EQ] = ACTIONS(4283),
    [anon_sym_BANG_EQ] = ACTIONS(4283),
    [anon_sym_GT_EQ] = ACTIONS(4283),
    [anon_sym_LT_EQ] = ACTIONS(4283),
    [anon_sym_DOT] = ACTIONS(4285),
    [anon_sym_scoped] = ACTIONS(4273),
    [anon_sym_var] = ACTIONS(4273),
    [anon_sym_yield] = ACTIONS(4273),
    [anon_sym_switch] = ACTIONS(4285),
    [anon_sym_when] = ACTIONS(4273),
    [sym_discard] = ACTIONS(4295),
    [anon_sym_DOT_DOT] = ACTIONS(4283),
    [anon_sym_and] = ACTIONS(4279),
    [anon_sym_or] = ACTIONS(4279),
    [anon_sym_AMP_AMP] = ACTIONS(4283),
    [anon_sym_PIPE_PIPE] = ACTIONS(4283),
    [anon_sym_QMARK_QMARK] = ACTIONS(4283),
    [anon_sym_from] = ACTIONS(4273),
    [anon_sym_into] = ACTIONS(4273),
    [anon_sym_join] = ACTIONS(4273),
    [anon_sym_on] = ACTIONS(4285),
    [anon_sym_equals] = ACTIONS(4273),
    [anon_sym_let] = ACTIONS(4273),
    [anon_sym_orderby] = ACTIONS(4273),
    [anon_sym_ascending] = ACTIONS(4273),
    [anon_sym_descending] = ACTIONS(4273),
    [anon_sym_group] = ACTIONS(4273),
    [anon_sym_by] = ACTIONS(4273),
    [anon_sym_select] = ACTIONS(4273),
    [anon_sym_as] = ACTIONS(4285),
    [anon_sym_is] = ACTIONS(4285),
    [anon_sym_DASH_GT] = ACTIONS(4283),
    [anon_sym_with] = ACTIONS(4285),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3063] = {
    [sym_parameter_list] = STATE(9765),
    [sym_positional_pattern_clause] = STATE(3145),
    [sym_property_pattern_clause] = STATE(3484),
    [sym__variable_designation] = STATE(4021),
    [sym_parenthesized_variable_designation] = STATE(4015),
    [sym__lambda_parameters] = STATE(9127),
    [sym_identifier] = STATE(4055),
    [sym__reserved_identifier] = STATE(3908),
    [sym_preproc_region] = STATE(3063),
    [sym_preproc_endregion] = STATE(3063),
    [sym_preproc_line] = STATE(3063),
    [sym_preproc_pragma] = STATE(3063),
    [sym_preproc_nullable] = STATE(3063),
    [sym_preproc_error] = STATE(3063),
    [sym_preproc_define] = STATE(3063),
    [sym_preproc_undef] = STATE(3063),
    [sym__identifier_token] = ACTIONS(4271),
    [anon_sym_alias] = ACTIONS(4273),
    [anon_sym_global] = ACTIONS(4273),
    [anon_sym_LBRACK] = ACTIONS(4283),
    [anon_sym_LPAREN] = ACTIONS(4283),
    [anon_sym_LBRACE] = ACTIONS(4277),
    [anon_sym_file] = ACTIONS(4273),
    [anon_sym_LT] = ACTIONS(4285),
    [anon_sym_GT] = ACTIONS(4285),
    [anon_sym_where] = ACTIONS(4273),
    [anon_sym_QMARK] = ACTIONS(4285),
    [anon_sym_notnull] = ACTIONS(4273),
    [anon_sym_unmanaged] = ACTIONS(4273),
    [anon_sym_BANG] = ACTIONS(4285),
    [anon_sym_PLUS_PLUS] = ACTIONS(4283),
    [anon_sym_DASH_DASH] = ACTIONS(4283),
    [anon_sym_PLUS] = ACTIONS(4285),
    [anon_sym_DASH] = ACTIONS(4285),
    [anon_sym_STAR] = ACTIONS(4283),
    [anon_sym_SLASH] = ACTIONS(4285),
    [anon_sym_PERCENT] = ACTIONS(4283),
    [anon_sym_CARET] = ACTIONS(4283),
    [anon_sym_PIPE] = ACTIONS(4285),
    [anon_sym_AMP] = ACTIONS(4285),
    [anon_sym_LT_LT] = ACTIONS(4283),
    [anon_sym_GT_GT] = ACTIONS(4285),
    [anon_sym_GT_GT_GT] = ACTIONS(4283),
    [anon_sym_EQ_EQ] = ACTIONS(4283),
    [anon_sym_BANG_EQ] = ACTIONS(4283),
    [anon_sym_GT_EQ] = ACTIONS(4283),
    [anon_sym_LT_EQ] = ACTIONS(4283),
    [anon_sym_DOT] = ACTIONS(4285),
    [anon_sym_scoped] = ACTIONS(4273),
    [anon_sym_var] = ACTIONS(4273),
    [anon_sym_yield] = ACTIONS(4273),
    [anon_sym_switch] = ACTIONS(4285),
    [anon_sym_when] = ACTIONS(4273),
    [sym_discard] = ACTIONS(4281),
    [anon_sym_DOT_DOT] = ACTIONS(4283),
    [anon_sym_and] = ACTIONS(4285),
    [anon_sym_or] = ACTIONS(4285),
    [anon_sym_AMP_AMP] = ACTIONS(4283),
    [anon_sym_PIPE_PIPE] = ACTIONS(4283),
    [anon_sym_QMARK_QMARK] = ACTIONS(4283),
    [anon_sym_from] = ACTIONS(4273),
    [anon_sym_into] = ACTIONS(4285),
    [anon_sym_join] = ACTIONS(4273),
    [anon_sym_on] = ACTIONS(4273),
    [anon_sym_equals] = ACTIONS(4285),
    [anon_sym_let] = ACTIONS(4273),
    [anon_sym_orderby] = ACTIONS(4273),
    [anon_sym_ascending] = ACTIONS(4273),
    [anon_sym_descending] = ACTIONS(4273),
    [anon_sym_group] = ACTIONS(4273),
    [anon_sym_by] = ACTIONS(4273),
    [anon_sym_select] = ACTIONS(4273),
    [anon_sym_as] = ACTIONS(4285),
    [anon_sym_is] = ACTIONS(4285),
    [anon_sym_DASH_GT] = ACTIONS(4283),
    [anon_sym_with] = ACTIONS(4285),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3064] = {
    [sym_parameter_list] = STATE(9765),
    [sym_positional_pattern_clause] = STATE(3155),
    [sym_property_pattern_clause] = STATE(3363),
    [sym__variable_designation] = STATE(4260),
    [sym_parenthesized_variable_designation] = STATE(4274),
    [sym__lambda_parameters] = STATE(9127),
    [sym_identifier] = STATE(4259),
    [sym__reserved_identifier] = STATE(3908),
    [sym_preproc_region] = STATE(3064),
    [sym_preproc_endregion] = STATE(3064),
    [sym_preproc_line] = STATE(3064),
    [sym_preproc_pragma] = STATE(3064),
    [sym_preproc_nullable] = STATE(3064),
    [sym_preproc_error] = STATE(3064),
    [sym_preproc_define] = STATE(3064),
    [sym_preproc_undef] = STATE(3064),
    [sym__identifier_token] = ACTIONS(4271),
    [anon_sym_alias] = ACTIONS(4273),
    [anon_sym_global] = ACTIONS(4273),
    [anon_sym_LBRACK] = ACTIONS(4275),
    [anon_sym_LPAREN] = ACTIONS(4275),
    [anon_sym_LBRACE] = ACTIONS(4277),
    [anon_sym_file] = ACTIONS(4273),
    [anon_sym_LT] = ACTIONS(4279),
    [anon_sym_GT] = ACTIONS(4279),
    [anon_sym_where] = ACTIONS(4273),
    [anon_sym_QMARK] = ACTIONS(4279),
    [anon_sym_notnull] = ACTIONS(4273),
    [anon_sym_unmanaged] = ACTIONS(4273),
    [anon_sym_BANG] = ACTIONS(4279),
    [anon_sym_PLUS_PLUS] = ACTIONS(4275),
    [anon_sym_DASH_DASH] = ACTIONS(4275),
    [anon_sym_PLUS] = ACTIONS(4279),
    [anon_sym_DASH] = ACTIONS(4279),
    [anon_sym_STAR] = ACTIONS(4275),
    [anon_sym_SLASH] = ACTIONS(4279),
    [anon_sym_PERCENT] = ACTIONS(4275),
    [anon_sym_CARET] = ACTIONS(4275),
    [anon_sym_PIPE] = ACTIONS(4279),
    [anon_sym_AMP] = ACTIONS(4279),
    [anon_sym_LT_LT] = ACTIONS(4275),
    [anon_sym_GT_GT] = ACTIONS(4279),
    [anon_sym_GT_GT_GT] = ACTIONS(4275),
    [anon_sym_EQ_EQ] = ACTIONS(4275),
    [anon_sym_BANG_EQ] = ACTIONS(4275),
    [anon_sym_GT_EQ] = ACTIONS(4275),
    [anon_sym_LT_EQ] = ACTIONS(4275),
    [anon_sym_DOT] = ACTIONS(4279),
    [anon_sym_scoped] = ACTIONS(4273),
    [anon_sym_var] = ACTIONS(4273),
    [anon_sym_yield] = ACTIONS(4273),
    [anon_sym_switch] = ACTIONS(4279),
    [anon_sym_when] = ACTIONS(4273),
    [sym_discard] = ACTIONS(4295),
    [anon_sym_DOT_DOT] = ACTIONS(4275),
    [anon_sym_and] = ACTIONS(4279),
    [anon_sym_or] = ACTIONS(4279),
    [anon_sym_AMP_AMP] = ACTIONS(4275),
    [anon_sym_PIPE_PIPE] = ACTIONS(4275),
    [anon_sym_QMARK_QMARK] = ACTIONS(4275),
    [anon_sym_from] = ACTIONS(4273),
    [anon_sym_into] = ACTIONS(4273),
    [anon_sym_join] = ACTIONS(4273),
    [anon_sym_on] = ACTIONS(4273),
    [anon_sym_equals] = ACTIONS(4279),
    [anon_sym_let] = ACTIONS(4273),
    [anon_sym_orderby] = ACTIONS(4273),
    [anon_sym_ascending] = ACTIONS(4273),
    [anon_sym_descending] = ACTIONS(4273),
    [anon_sym_group] = ACTIONS(4273),
    [anon_sym_by] = ACTIONS(4273),
    [anon_sym_select] = ACTIONS(4273),
    [anon_sym_as] = ACTIONS(4279),
    [anon_sym_is] = ACTIONS(4279),
    [anon_sym_DASH_GT] = ACTIONS(4275),
    [anon_sym_with] = ACTIONS(4279),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3065] = {
    [sym_parameter_list] = STATE(9765),
    [sym_positional_pattern_clause] = STATE(3154),
    [sym_property_pattern_clause] = STATE(3454),
    [sym__variable_designation] = STATE(4021),
    [sym_parenthesized_variable_designation] = STATE(4015),
    [sym__lambda_parameters] = STATE(9127),
    [sym_identifier] = STATE(4055),
    [sym__reserved_identifier] = STATE(3908),
    [sym_preproc_region] = STATE(3065),
    [sym_preproc_endregion] = STATE(3065),
    [sym_preproc_line] = STATE(3065),
    [sym_preproc_pragma] = STATE(3065),
    [sym_preproc_nullable] = STATE(3065),
    [sym_preproc_error] = STATE(3065),
    [sym_preproc_define] = STATE(3065),
    [sym_preproc_undef] = STATE(3065),
    [sym__identifier_token] = ACTIONS(4271),
    [anon_sym_alias] = ACTIONS(4273),
    [anon_sym_global] = ACTIONS(4273),
    [anon_sym_LBRACK] = ACTIONS(4275),
    [anon_sym_LPAREN] = ACTIONS(4275),
    [anon_sym_LBRACE] = ACTIONS(4277),
    [anon_sym_file] = ACTIONS(4273),
    [anon_sym_LT] = ACTIONS(4279),
    [anon_sym_GT] = ACTIONS(4279),
    [anon_sym_where] = ACTIONS(4273),
    [anon_sym_QMARK] = ACTIONS(4279),
    [anon_sym_notnull] = ACTIONS(4273),
    [anon_sym_unmanaged] = ACTIONS(4273),
    [anon_sym_BANG] = ACTIONS(4279),
    [anon_sym_PLUS_PLUS] = ACTIONS(4275),
    [anon_sym_DASH_DASH] = ACTIONS(4275),
    [anon_sym_PLUS] = ACTIONS(4279),
    [anon_sym_DASH] = ACTIONS(4279),
    [anon_sym_STAR] = ACTIONS(4275),
    [anon_sym_SLASH] = ACTIONS(4279),
    [anon_sym_PERCENT] = ACTIONS(4275),
    [anon_sym_CARET] = ACTIONS(4275),
    [anon_sym_PIPE] = ACTIONS(4279),
    [anon_sym_AMP] = ACTIONS(4279),
    [anon_sym_LT_LT] = ACTIONS(4275),
    [anon_sym_GT_GT] = ACTIONS(4279),
    [anon_sym_GT_GT_GT] = ACTIONS(4275),
    [anon_sym_EQ_EQ] = ACTIONS(4275),
    [anon_sym_BANG_EQ] = ACTIONS(4275),
    [anon_sym_GT_EQ] = ACTIONS(4275),
    [anon_sym_LT_EQ] = ACTIONS(4275),
    [anon_sym_DOT] = ACTIONS(4279),
    [anon_sym_scoped] = ACTIONS(4273),
    [anon_sym_var] = ACTIONS(4273),
    [anon_sym_yield] = ACTIONS(4273),
    [anon_sym_switch] = ACTIONS(4279),
    [anon_sym_when] = ACTIONS(4273),
    [sym_discard] = ACTIONS(4281),
    [anon_sym_DOT_DOT] = ACTIONS(4275),
    [anon_sym_and] = ACTIONS(4279),
    [anon_sym_or] = ACTIONS(4279),
    [anon_sym_AMP_AMP] = ACTIONS(4275),
    [anon_sym_PIPE_PIPE] = ACTIONS(4275),
    [anon_sym_QMARK_QMARK] = ACTIONS(4275),
    [anon_sym_from] = ACTIONS(4273),
    [anon_sym_into] = ACTIONS(4279),
    [anon_sym_join] = ACTIONS(4273),
    [anon_sym_on] = ACTIONS(4279),
    [anon_sym_equals] = ACTIONS(4273),
    [anon_sym_let] = ACTIONS(4273),
    [anon_sym_orderby] = ACTIONS(4273),
    [anon_sym_ascending] = ACTIONS(4273),
    [anon_sym_descending] = ACTIONS(4273),
    [anon_sym_group] = ACTIONS(4273),
    [anon_sym_by] = ACTIONS(4273),
    [anon_sym_select] = ACTIONS(4273),
    [anon_sym_as] = ACTIONS(4279),
    [anon_sym_is] = ACTIONS(4279),
    [anon_sym_DASH_GT] = ACTIONS(4275),
    [anon_sym_with] = ACTIONS(4279),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3066] = {
    [sym_parameter_list] = STATE(9765),
    [sym_positional_pattern_clause] = STATE(3141),
    [sym_property_pattern_clause] = STATE(3389),
    [sym__variable_designation] = STATE(4260),
    [sym_parenthesized_variable_designation] = STATE(4274),
    [sym__lambda_parameters] = STATE(9127),
    [sym_identifier] = STATE(4259),
    [sym__reserved_identifier] = STATE(3908),
    [sym_preproc_region] = STATE(3066),
    [sym_preproc_endregion] = STATE(3066),
    [sym_preproc_line] = STATE(3066),
    [sym_preproc_pragma] = STATE(3066),
    [sym_preproc_nullable] = STATE(3066),
    [sym_preproc_error] = STATE(3066),
    [sym_preproc_define] = STATE(3066),
    [sym_preproc_undef] = STATE(3066),
    [sym__identifier_token] = ACTIONS(4271),
    [anon_sym_alias] = ACTIONS(4273),
    [anon_sym_global] = ACTIONS(4273),
    [anon_sym_LBRACK] = ACTIONS(4275),
    [anon_sym_LPAREN] = ACTIONS(4275),
    [anon_sym_LBRACE] = ACTIONS(4277),
    [anon_sym_file] = ACTIONS(4273),
    [anon_sym_LT] = ACTIONS(4279),
    [anon_sym_GT] = ACTIONS(4279),
    [anon_sym_where] = ACTIONS(4273),
    [anon_sym_QMARK] = ACTIONS(4279),
    [anon_sym_notnull] = ACTIONS(4273),
    [anon_sym_unmanaged] = ACTIONS(4273),
    [anon_sym_BANG] = ACTIONS(4279),
    [anon_sym_PLUS_PLUS] = ACTIONS(4275),
    [anon_sym_DASH_DASH] = ACTIONS(4275),
    [anon_sym_PLUS] = ACTIONS(4279),
    [anon_sym_DASH] = ACTIONS(4279),
    [anon_sym_STAR] = ACTIONS(4275),
    [anon_sym_SLASH] = ACTIONS(4279),
    [anon_sym_PERCENT] = ACTIONS(4275),
    [anon_sym_CARET] = ACTIONS(4275),
    [anon_sym_PIPE] = ACTIONS(4279),
    [anon_sym_AMP] = ACTIONS(4279),
    [anon_sym_LT_LT] = ACTIONS(4275),
    [anon_sym_GT_GT] = ACTIONS(4279),
    [anon_sym_GT_GT_GT] = ACTIONS(4275),
    [anon_sym_EQ_EQ] = ACTIONS(4275),
    [anon_sym_BANG_EQ] = ACTIONS(4275),
    [anon_sym_GT_EQ] = ACTIONS(4275),
    [anon_sym_LT_EQ] = ACTIONS(4275),
    [anon_sym_DOT] = ACTIONS(4279),
    [anon_sym_scoped] = ACTIONS(4273),
    [anon_sym_var] = ACTIONS(4273),
    [anon_sym_yield] = ACTIONS(4273),
    [anon_sym_switch] = ACTIONS(4279),
    [anon_sym_when] = ACTIONS(4273),
    [sym_discard] = ACTIONS(4295),
    [anon_sym_DOT_DOT] = ACTIONS(4275),
    [anon_sym_and] = ACTIONS(4279),
    [anon_sym_or] = ACTIONS(4279),
    [anon_sym_AMP_AMP] = ACTIONS(4275),
    [anon_sym_PIPE_PIPE] = ACTIONS(4275),
    [anon_sym_QMARK_QMARK] = ACTIONS(4275),
    [anon_sym_from] = ACTIONS(4273),
    [anon_sym_into] = ACTIONS(4273),
    [anon_sym_join] = ACTIONS(4273),
    [anon_sym_on] = ACTIONS(4279),
    [anon_sym_equals] = ACTIONS(4273),
    [anon_sym_let] = ACTIONS(4273),
    [anon_sym_orderby] = ACTIONS(4273),
    [anon_sym_ascending] = ACTIONS(4273),
    [anon_sym_descending] = ACTIONS(4273),
    [anon_sym_group] = ACTIONS(4273),
    [anon_sym_by] = ACTIONS(4273),
    [anon_sym_select] = ACTIONS(4273),
    [anon_sym_as] = ACTIONS(4279),
    [anon_sym_is] = ACTIONS(4279),
    [anon_sym_DASH_GT] = ACTIONS(4275),
    [anon_sym_with] = ACTIONS(4279),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3067] = {
    [sym__name] = STATE(3768),
    [sym_alias_qualified_name] = STATE(3635),
    [sym__simple_name] = STATE(3635),
    [sym_qualified_name] = STATE(3635),
    [sym_generic_name] = STATE(3708),
    [sym_ref_type] = STATE(3636),
    [sym__scoped_base_type] = STATE(3641),
    [sym_identifier] = STATE(3590),
    [sym__reserved_identifier] = STATE(3568),
    [sym_preproc_region] = STATE(3067),
    [sym_preproc_endregion] = STATE(3067),
    [sym_preproc_line] = STATE(3067),
    [sym_preproc_pragma] = STATE(3067),
    [sym_preproc_nullable] = STATE(3067),
    [sym_preproc_error] = STATE(3067),
    [sym_preproc_define] = STATE(3067),
    [sym_preproc_undef] = STATE(3067),
    [sym__identifier_token] = ACTIONS(4287),
    [anon_sym_alias] = ACTIONS(4289),
    [anon_sym_global] = ACTIONS(4289),
    [anon_sym_LBRACK] = ACTIONS(3719),
    [anon_sym_LPAREN] = ACTIONS(3719),
    [anon_sym_ref] = ACTIONS(4655),
    [anon_sym_LBRACE] = ACTIONS(3719),
    [anon_sym_file] = ACTIONS(4289),
    [anon_sym_LT] = ACTIONS(3721),
    [anon_sym_GT] = ACTIONS(3721),
    [anon_sym_where] = ACTIONS(4289),
    [anon_sym_QMARK] = ACTIONS(3721),
    [anon_sym_notnull] = ACTIONS(4289),
    [anon_sym_unmanaged] = ACTIONS(4289),
    [anon_sym_BANG] = ACTIONS(3721),
    [anon_sym_PLUS_PLUS] = ACTIONS(3719),
    [anon_sym_DASH_DASH] = ACTIONS(3719),
    [anon_sym_PLUS] = ACTIONS(3721),
    [anon_sym_DASH] = ACTIONS(3721),
    [anon_sym_STAR] = ACTIONS(3719),
    [anon_sym_SLASH] = ACTIONS(3721),
    [anon_sym_PERCENT] = ACTIONS(3719),
    [anon_sym_CARET] = ACTIONS(3719),
    [anon_sym_PIPE] = ACTIONS(3721),
    [anon_sym_AMP] = ACTIONS(3721),
    [anon_sym_LT_LT] = ACTIONS(3719),
    [anon_sym_GT_GT] = ACTIONS(3721),
    [anon_sym_GT_GT_GT] = ACTIONS(3719),
    [anon_sym_EQ_EQ] = ACTIONS(3719),
    [anon_sym_BANG_EQ] = ACTIONS(3719),
    [anon_sym_GT_EQ] = ACTIONS(3719),
    [anon_sym_LT_EQ] = ACTIONS(3719),
    [anon_sym_DOT] = ACTIONS(3721),
    [anon_sym_scoped] = ACTIONS(4289),
    [anon_sym_COLON_COLON] = ACTIONS(3719),
    [anon_sym_var] = ACTIONS(4289),
    [anon_sym_yield] = ACTIONS(4289),
    [anon_sym_switch] = ACTIONS(3721),
    [anon_sym_when] = ACTIONS(4289),
    [anon_sym_DOT_DOT] = ACTIONS(3719),
    [anon_sym_AMP_AMP] = ACTIONS(3719),
    [anon_sym_PIPE_PIPE] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK] = ACTIONS(3719),
    [anon_sym_from] = ACTIONS(4289),
    [anon_sym_into] = ACTIONS(4289),
    [anon_sym_join] = ACTIONS(4289),
    [anon_sym_on] = ACTIONS(4289),
    [anon_sym_equals] = ACTIONS(4612),
    [anon_sym_let] = ACTIONS(4289),
    [anon_sym_orderby] = ACTIONS(4289),
    [anon_sym_ascending] = ACTIONS(4289),
    [anon_sym_descending] = ACTIONS(4289),
    [anon_sym_group] = ACTIONS(4289),
    [anon_sym_by] = ACTIONS(4289),
    [anon_sym_select] = ACTIONS(4289),
    [anon_sym_as] = ACTIONS(3721),
    [anon_sym_is] = ACTIONS(3721),
    [anon_sym_DASH_GT] = ACTIONS(3719),
    [anon_sym_with] = ACTIONS(3721),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3068] = {
    [sym_parameter_list] = STATE(9765),
    [sym_positional_pattern_clause] = STATE(3158),
    [sym_property_pattern_clause] = STATE(3215),
    [sym__variable_designation] = STATE(4260),
    [sym_parenthesized_variable_designation] = STATE(4274),
    [sym__lambda_parameters] = STATE(9127),
    [sym_identifier] = STATE(4259),
    [sym__reserved_identifier] = STATE(3908),
    [sym_preproc_region] = STATE(3068),
    [sym_preproc_endregion] = STATE(3068),
    [sym_preproc_line] = STATE(3068),
    [sym_preproc_pragma] = STATE(3068),
    [sym_preproc_nullable] = STATE(3068),
    [sym_preproc_error] = STATE(3068),
    [sym_preproc_define] = STATE(3068),
    [sym_preproc_undef] = STATE(3068),
    [sym__identifier_token] = ACTIONS(4271),
    [anon_sym_alias] = ACTIONS(4273),
    [anon_sym_global] = ACTIONS(4273),
    [anon_sym_LBRACK] = ACTIONS(4275),
    [anon_sym_LPAREN] = ACTIONS(4275),
    [anon_sym_LBRACE] = ACTIONS(4277),
    [anon_sym_file] = ACTIONS(4273),
    [anon_sym_LT] = ACTIONS(4279),
    [anon_sym_GT] = ACTIONS(4279),
    [anon_sym_where] = ACTIONS(4273),
    [anon_sym_QMARK] = ACTIONS(4279),
    [anon_sym_notnull] = ACTIONS(4273),
    [anon_sym_unmanaged] = ACTIONS(4273),
    [anon_sym_BANG] = ACTIONS(4279),
    [anon_sym_PLUS_PLUS] = ACTIONS(4275),
    [anon_sym_DASH_DASH] = ACTIONS(4275),
    [anon_sym_PLUS] = ACTIONS(4279),
    [anon_sym_DASH] = ACTIONS(4279),
    [anon_sym_STAR] = ACTIONS(4275),
    [anon_sym_SLASH] = ACTIONS(4279),
    [anon_sym_PERCENT] = ACTIONS(4275),
    [anon_sym_CARET] = ACTIONS(4275),
    [anon_sym_PIPE] = ACTIONS(4279),
    [anon_sym_AMP] = ACTIONS(4279),
    [anon_sym_LT_LT] = ACTIONS(4275),
    [anon_sym_GT_GT] = ACTIONS(4279),
    [anon_sym_GT_GT_GT] = ACTIONS(4275),
    [anon_sym_EQ_EQ] = ACTIONS(4275),
    [anon_sym_BANG_EQ] = ACTIONS(4275),
    [anon_sym_GT_EQ] = ACTIONS(4275),
    [anon_sym_LT_EQ] = ACTIONS(4275),
    [anon_sym_DOT] = ACTIONS(4279),
    [anon_sym_scoped] = ACTIONS(4273),
    [anon_sym_var] = ACTIONS(4273),
    [anon_sym_yield] = ACTIONS(4273),
    [anon_sym_switch] = ACTIONS(4279),
    [anon_sym_when] = ACTIONS(4273),
    [sym_discard] = ACTIONS(4295),
    [anon_sym_DOT_DOT] = ACTIONS(4275),
    [anon_sym_and] = ACTIONS(4279),
    [anon_sym_or] = ACTIONS(4279),
    [anon_sym_AMP_AMP] = ACTIONS(4275),
    [anon_sym_PIPE_PIPE] = ACTIONS(4275),
    [anon_sym_QMARK_QMARK] = ACTIONS(4275),
    [anon_sym_from] = ACTIONS(4273),
    [anon_sym_into] = ACTIONS(4273),
    [anon_sym_join] = ACTIONS(4273),
    [anon_sym_on] = ACTIONS(4273),
    [anon_sym_equals] = ACTIONS(4273),
    [anon_sym_let] = ACTIONS(4273),
    [anon_sym_orderby] = ACTIONS(4273),
    [anon_sym_ascending] = ACTIONS(4273),
    [anon_sym_descending] = ACTIONS(4273),
    [anon_sym_group] = ACTIONS(4273),
    [anon_sym_by] = ACTIONS(4279),
    [anon_sym_select] = ACTIONS(4273),
    [anon_sym_as] = ACTIONS(4279),
    [anon_sym_is] = ACTIONS(4279),
    [anon_sym_DASH_GT] = ACTIONS(4275),
    [anon_sym_with] = ACTIONS(4279),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3069] = {
    [sym__name] = STATE(3768),
    [sym_alias_qualified_name] = STATE(3635),
    [sym__simple_name] = STATE(3635),
    [sym_qualified_name] = STATE(3635),
    [sym_generic_name] = STATE(3708),
    [sym_ref_type] = STATE(3636),
    [sym__scoped_base_type] = STATE(3641),
    [sym_identifier] = STATE(3590),
    [sym__reserved_identifier] = STATE(3568),
    [sym_preproc_region] = STATE(3069),
    [sym_preproc_endregion] = STATE(3069),
    [sym_preproc_line] = STATE(3069),
    [sym_preproc_pragma] = STATE(3069),
    [sym_preproc_nullable] = STATE(3069),
    [sym_preproc_error] = STATE(3069),
    [sym_preproc_define] = STATE(3069),
    [sym_preproc_undef] = STATE(3069),
    [sym__identifier_token] = ACTIONS(4287),
    [anon_sym_alias] = ACTIONS(4289),
    [anon_sym_global] = ACTIONS(4289),
    [anon_sym_LBRACK] = ACTIONS(3719),
    [anon_sym_LPAREN] = ACTIONS(3719),
    [anon_sym_ref] = ACTIONS(4657),
    [anon_sym_LBRACE] = ACTIONS(3719),
    [anon_sym_file] = ACTIONS(4289),
    [anon_sym_LT] = ACTIONS(3721),
    [anon_sym_GT] = ACTIONS(3721),
    [anon_sym_where] = ACTIONS(4289),
    [anon_sym_QMARK] = ACTIONS(3721),
    [anon_sym_notnull] = ACTIONS(4289),
    [anon_sym_unmanaged] = ACTIONS(4289),
    [anon_sym_BANG] = ACTIONS(3721),
    [anon_sym_PLUS_PLUS] = ACTIONS(3719),
    [anon_sym_DASH_DASH] = ACTIONS(3719),
    [anon_sym_PLUS] = ACTIONS(3721),
    [anon_sym_DASH] = ACTIONS(3721),
    [anon_sym_STAR] = ACTIONS(3719),
    [anon_sym_SLASH] = ACTIONS(3721),
    [anon_sym_PERCENT] = ACTIONS(3719),
    [anon_sym_CARET] = ACTIONS(3719),
    [anon_sym_PIPE] = ACTIONS(3721),
    [anon_sym_AMP] = ACTIONS(3721),
    [anon_sym_LT_LT] = ACTIONS(3719),
    [anon_sym_GT_GT] = ACTIONS(3721),
    [anon_sym_GT_GT_GT] = ACTIONS(3719),
    [anon_sym_EQ_EQ] = ACTIONS(3719),
    [anon_sym_BANG_EQ] = ACTIONS(3719),
    [anon_sym_GT_EQ] = ACTIONS(3719),
    [anon_sym_LT_EQ] = ACTIONS(3719),
    [anon_sym_DOT] = ACTIONS(3721),
    [anon_sym_scoped] = ACTIONS(4289),
    [anon_sym_COLON_COLON] = ACTIONS(3719),
    [anon_sym_var] = ACTIONS(4289),
    [anon_sym_yield] = ACTIONS(4289),
    [anon_sym_switch] = ACTIONS(3721),
    [anon_sym_when] = ACTIONS(4289),
    [anon_sym_DOT_DOT] = ACTIONS(3719),
    [anon_sym_AMP_AMP] = ACTIONS(3719),
    [anon_sym_PIPE_PIPE] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK] = ACTIONS(3719),
    [anon_sym_from] = ACTIONS(4289),
    [anon_sym_into] = ACTIONS(4289),
    [anon_sym_join] = ACTIONS(4289),
    [anon_sym_on] = ACTIONS(4612),
    [anon_sym_equals] = ACTIONS(4289),
    [anon_sym_let] = ACTIONS(4289),
    [anon_sym_orderby] = ACTIONS(4289),
    [anon_sym_ascending] = ACTIONS(4289),
    [anon_sym_descending] = ACTIONS(4289),
    [anon_sym_group] = ACTIONS(4289),
    [anon_sym_by] = ACTIONS(4289),
    [anon_sym_select] = ACTIONS(4289),
    [anon_sym_as] = ACTIONS(3721),
    [anon_sym_is] = ACTIONS(3721),
    [anon_sym_DASH_GT] = ACTIONS(3719),
    [anon_sym_with] = ACTIONS(3721),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3070] = {
    [sym_property_pattern_clause] = STATE(3111),
    [sym__variable_designation] = STATE(5399),
    [sym_parenthesized_variable_designation] = STATE(5390),
    [sym_identifier] = STATE(5396),
    [sym__reserved_identifier] = STATE(5128),
    [sym_preproc_region] = STATE(3070),
    [sym_preproc_endregion] = STATE(3070),
    [sym_preproc_line] = STATE(3070),
    [sym_preproc_pragma] = STATE(3070),
    [sym_preproc_nullable] = STATE(3070),
    [sym_preproc_error] = STATE(3070),
    [sym_preproc_define] = STATE(3070),
    [sym_preproc_undef] = STATE(3070),
    [sym__identifier_token] = ACTIONS(4482),
    [anon_sym_alias] = ACTIONS(4484),
    [anon_sym_global] = ACTIONS(4484),
    [anon_sym_LBRACK] = ACTIONS(4329),
    [anon_sym_COLON] = ACTIONS(4329),
    [anon_sym_COMMA] = ACTIONS(4329),
    [anon_sym_LPAREN] = ACTIONS(4329),
    [anon_sym_LBRACE] = ACTIONS(4486),
    [anon_sym_file] = ACTIONS(4484),
    [anon_sym_LT] = ACTIONS(4331),
    [anon_sym_GT] = ACTIONS(4331),
    [anon_sym_where] = ACTIONS(4484),
    [anon_sym_QMARK] = ACTIONS(4331),
    [anon_sym_notnull] = ACTIONS(4484),
    [anon_sym_unmanaged] = ACTIONS(4484),
    [anon_sym_BANG] = ACTIONS(4331),
    [anon_sym_PLUS_PLUS] = ACTIONS(4329),
    [anon_sym_DASH_DASH] = ACTIONS(4329),
    [anon_sym_PLUS] = ACTIONS(4331),
    [anon_sym_DASH] = ACTIONS(4331),
    [anon_sym_STAR] = ACTIONS(4329),
    [anon_sym_SLASH] = ACTIONS(4331),
    [anon_sym_PERCENT] = ACTIONS(4329),
    [anon_sym_CARET] = ACTIONS(4329),
    [anon_sym_PIPE] = ACTIONS(4331),
    [anon_sym_AMP] = ACTIONS(4331),
    [anon_sym_LT_LT] = ACTIONS(4329),
    [anon_sym_GT_GT] = ACTIONS(4331),
    [anon_sym_GT_GT_GT] = ACTIONS(4329),
    [anon_sym_EQ_EQ] = ACTIONS(4329),
    [anon_sym_BANG_EQ] = ACTIONS(4329),
    [anon_sym_GT_EQ] = ACTIONS(4329),
    [anon_sym_LT_EQ] = ACTIONS(4329),
    [anon_sym_DOT] = ACTIONS(4331),
    [anon_sym_scoped] = ACTIONS(4484),
    [anon_sym_var] = ACTIONS(4484),
    [anon_sym_yield] = ACTIONS(4484),
    [anon_sym_switch] = ACTIONS(4331),
    [anon_sym_when] = ACTIONS(4484),
    [sym_discard] = ACTIONS(4488),
    [anon_sym_DOT_DOT] = ACTIONS(4329),
    [anon_sym_and] = ACTIONS(4331),
    [anon_sym_or] = ACTIONS(4331),
    [anon_sym_AMP_AMP] = ACTIONS(4329),
    [anon_sym_PIPE_PIPE] = ACTIONS(4329),
    [anon_sym_QMARK_QMARK] = ACTIONS(4329),
    [anon_sym_from] = ACTIONS(4484),
    [anon_sym_into] = ACTIONS(4484),
    [anon_sym_join] = ACTIONS(4484),
    [anon_sym_on] = ACTIONS(4484),
    [anon_sym_equals] = ACTIONS(4484),
    [anon_sym_let] = ACTIONS(4484),
    [anon_sym_orderby] = ACTIONS(4484),
    [anon_sym_ascending] = ACTIONS(4484),
    [anon_sym_descending] = ACTIONS(4484),
    [anon_sym_group] = ACTIONS(4484),
    [anon_sym_by] = ACTIONS(4484),
    [anon_sym_select] = ACTIONS(4484),
    [anon_sym_as] = ACTIONS(4331),
    [anon_sym_is] = ACTIONS(4331),
    [anon_sym_DASH_GT] = ACTIONS(4329),
    [anon_sym_with] = ACTIONS(4331),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4329),
  },
  [3071] = {
    [sym_parameter_list] = STATE(9765),
    [sym_positional_pattern_clause] = STATE(3136),
    [sym_property_pattern_clause] = STATE(3346),
    [sym__variable_designation] = STATE(5001),
    [sym_parenthesized_variable_designation] = STATE(4957),
    [sym__lambda_parameters] = STATE(9127),
    [sym_identifier] = STATE(4944),
    [sym__reserved_identifier] = STATE(3558),
    [sym_preproc_region] = STATE(3071),
    [sym_preproc_endregion] = STATE(3071),
    [sym_preproc_line] = STATE(3071),
    [sym_preproc_pragma] = STATE(3071),
    [sym_preproc_nullable] = STATE(3071),
    [sym_preproc_error] = STATE(3071),
    [sym_preproc_define] = STATE(3071),
    [sym_preproc_undef] = STATE(3071),
    [sym__identifier_token] = ACTIONS(4225),
    [anon_sym_alias] = ACTIONS(4227),
    [anon_sym_global] = ACTIONS(4227),
    [anon_sym_LBRACK] = ACTIONS(4283),
    [anon_sym_LPAREN] = ACTIONS(4283),
    [anon_sym_LBRACE] = ACTIONS(4277),
    [anon_sym_file] = ACTIONS(4227),
    [anon_sym_LT] = ACTIONS(4285),
    [anon_sym_GT] = ACTIONS(4285),
    [anon_sym_where] = ACTIONS(4285),
    [anon_sym_QMARK] = ACTIONS(4285),
    [anon_sym_notnull] = ACTIONS(4227),
    [anon_sym_unmanaged] = ACTIONS(4227),
    [anon_sym_BANG] = ACTIONS(4285),
    [anon_sym_PLUS_PLUS] = ACTIONS(4283),
    [anon_sym_DASH_DASH] = ACTIONS(4283),
    [anon_sym_PLUS] = ACTIONS(4285),
    [anon_sym_DASH] = ACTIONS(4285),
    [anon_sym_STAR] = ACTIONS(4283),
    [anon_sym_SLASH] = ACTIONS(4285),
    [anon_sym_PERCENT] = ACTIONS(4283),
    [anon_sym_CARET] = ACTIONS(4283),
    [anon_sym_PIPE] = ACTIONS(4285),
    [anon_sym_AMP] = ACTIONS(4285),
    [anon_sym_LT_LT] = ACTIONS(4283),
    [anon_sym_GT_GT] = ACTIONS(4285),
    [anon_sym_GT_GT_GT] = ACTIONS(4283),
    [anon_sym_EQ_EQ] = ACTIONS(4283),
    [anon_sym_BANG_EQ] = ACTIONS(4283),
    [anon_sym_GT_EQ] = ACTIONS(4283),
    [anon_sym_LT_EQ] = ACTIONS(4283),
    [anon_sym_DOT] = ACTIONS(4285),
    [anon_sym_scoped] = ACTIONS(4227),
    [anon_sym_var] = ACTIONS(4227),
    [anon_sym_yield] = ACTIONS(4227),
    [anon_sym_switch] = ACTIONS(4285),
    [anon_sym_when] = ACTIONS(4227),
    [sym_discard] = ACTIONS(4649),
    [anon_sym_DOT_DOT] = ACTIONS(4283),
    [anon_sym_and] = ACTIONS(4279),
    [anon_sym_or] = ACTIONS(4279),
    [anon_sym_AMP_AMP] = ACTIONS(4283),
    [anon_sym_PIPE_PIPE] = ACTIONS(4283),
    [anon_sym_QMARK_QMARK] = ACTIONS(4283),
    [anon_sym_from] = ACTIONS(4285),
    [anon_sym_into] = ACTIONS(4285),
    [anon_sym_join] = ACTIONS(4285),
    [anon_sym_on] = ACTIONS(4227),
    [anon_sym_equals] = ACTIONS(4227),
    [anon_sym_let] = ACTIONS(4285),
    [anon_sym_orderby] = ACTIONS(4285),
    [anon_sym_ascending] = ACTIONS(4227),
    [anon_sym_descending] = ACTIONS(4227),
    [anon_sym_group] = ACTIONS(4285),
    [anon_sym_by] = ACTIONS(4227),
    [anon_sym_select] = ACTIONS(4285),
    [anon_sym_as] = ACTIONS(4285),
    [anon_sym_is] = ACTIONS(4285),
    [anon_sym_DASH_GT] = ACTIONS(4283),
    [anon_sym_with] = ACTIONS(4285),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3072] = {
    [sym__name] = STATE(4327),
    [sym_alias_qualified_name] = STATE(3592),
    [sym__simple_name] = STATE(3592),
    [sym_qualified_name] = STATE(3592),
    [sym_generic_name] = STATE(3608),
    [sym_ref_type] = STATE(3574),
    [sym__scoped_base_type] = STATE(3573),
    [sym_identifier] = STATE(3989),
    [sym__reserved_identifier] = STATE(3558),
    [sym_preproc_region] = STATE(3072),
    [sym_preproc_endregion] = STATE(3072),
    [sym_preproc_line] = STATE(3072),
    [sym_preproc_pragma] = STATE(3072),
    [sym_preproc_nullable] = STATE(3072),
    [sym_preproc_error] = STATE(3072),
    [sym_preproc_define] = STATE(3072),
    [sym_preproc_undef] = STATE(3072),
    [sym__identifier_token] = ACTIONS(4225),
    [anon_sym_alias] = ACTIONS(4227),
    [anon_sym_global] = ACTIONS(4227),
    [anon_sym_LBRACK] = ACTIONS(3719),
    [anon_sym_LPAREN] = ACTIONS(3719),
    [anon_sym_ref] = ACTIONS(4659),
    [anon_sym_LBRACE] = ACTIONS(3719),
    [anon_sym_file] = ACTIONS(4227),
    [anon_sym_LT] = ACTIONS(3721),
    [anon_sym_GT] = ACTIONS(3721),
    [anon_sym_where] = ACTIONS(4227),
    [anon_sym_QMARK] = ACTIONS(3721),
    [anon_sym_notnull] = ACTIONS(4227),
    [anon_sym_unmanaged] = ACTIONS(4227),
    [anon_sym_BANG] = ACTIONS(3721),
    [anon_sym_PLUS_PLUS] = ACTIONS(3719),
    [anon_sym_DASH_DASH] = ACTIONS(3719),
    [anon_sym_PLUS] = ACTIONS(3721),
    [anon_sym_DASH] = ACTIONS(3721),
    [anon_sym_STAR] = ACTIONS(3719),
    [anon_sym_SLASH] = ACTIONS(3721),
    [anon_sym_PERCENT] = ACTIONS(3719),
    [anon_sym_CARET] = ACTIONS(3719),
    [anon_sym_PIPE] = ACTIONS(3721),
    [anon_sym_AMP] = ACTIONS(3721),
    [anon_sym_LT_LT] = ACTIONS(3719),
    [anon_sym_GT_GT] = ACTIONS(3721),
    [anon_sym_GT_GT_GT] = ACTIONS(3719),
    [anon_sym_EQ_EQ] = ACTIONS(3719),
    [anon_sym_BANG_EQ] = ACTIONS(3719),
    [anon_sym_GT_EQ] = ACTIONS(3719),
    [anon_sym_LT_EQ] = ACTIONS(3719),
    [anon_sym_DOT] = ACTIONS(3721),
    [anon_sym_scoped] = ACTIONS(4227),
    [anon_sym_COLON_COLON] = ACTIONS(3719),
    [anon_sym_var] = ACTIONS(4227),
    [anon_sym_yield] = ACTIONS(4227),
    [anon_sym_switch] = ACTIONS(3721),
    [anon_sym_when] = ACTIONS(4227),
    [anon_sym_DOT_DOT] = ACTIONS(3719),
    [anon_sym_AMP_AMP] = ACTIONS(3719),
    [anon_sym_PIPE_PIPE] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK] = ACTIONS(3719),
    [anon_sym_from] = ACTIONS(4227),
    [anon_sym_into] = ACTIONS(4231),
    [anon_sym_join] = ACTIONS(4227),
    [anon_sym_on] = ACTIONS(4231),
    [anon_sym_equals] = ACTIONS(4227),
    [anon_sym_let] = ACTIONS(4227),
    [anon_sym_orderby] = ACTIONS(4227),
    [anon_sym_ascending] = ACTIONS(4227),
    [anon_sym_descending] = ACTIONS(4227),
    [anon_sym_group] = ACTIONS(4227),
    [anon_sym_by] = ACTIONS(4227),
    [anon_sym_select] = ACTIONS(4227),
    [anon_sym_as] = ACTIONS(3721),
    [anon_sym_is] = ACTIONS(3721),
    [anon_sym_DASH_GT] = ACTIONS(3719),
    [anon_sym_with] = ACTIONS(3721),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3073] = {
    [sym_parameter_list] = STATE(9765),
    [sym_positional_pattern_clause] = STATE(3145),
    [sym_property_pattern_clause] = STATE(3484),
    [sym__variable_designation] = STATE(4021),
    [sym_parenthesized_variable_designation] = STATE(4015),
    [sym__lambda_parameters] = STATE(9127),
    [sym_identifier] = STATE(4055),
    [sym__reserved_identifier] = STATE(3908),
    [sym_preproc_region] = STATE(3073),
    [sym_preproc_endregion] = STATE(3073),
    [sym_preproc_line] = STATE(3073),
    [sym_preproc_pragma] = STATE(3073),
    [sym_preproc_nullable] = STATE(3073),
    [sym_preproc_error] = STATE(3073),
    [sym_preproc_define] = STATE(3073),
    [sym_preproc_undef] = STATE(3073),
    [sym__identifier_token] = ACTIONS(4271),
    [anon_sym_alias] = ACTIONS(4273),
    [anon_sym_global] = ACTIONS(4273),
    [anon_sym_LBRACK] = ACTIONS(4283),
    [anon_sym_LPAREN] = ACTIONS(4283),
    [anon_sym_LBRACE] = ACTIONS(4277),
    [anon_sym_file] = ACTIONS(4273),
    [anon_sym_LT] = ACTIONS(4285),
    [anon_sym_GT] = ACTIONS(4285),
    [anon_sym_where] = ACTIONS(4273),
    [anon_sym_QMARK] = ACTIONS(4285),
    [anon_sym_notnull] = ACTIONS(4273),
    [anon_sym_unmanaged] = ACTIONS(4273),
    [anon_sym_BANG] = ACTIONS(4285),
    [anon_sym_PLUS_PLUS] = ACTIONS(4283),
    [anon_sym_DASH_DASH] = ACTIONS(4283),
    [anon_sym_PLUS] = ACTIONS(4285),
    [anon_sym_DASH] = ACTIONS(4285),
    [anon_sym_STAR] = ACTIONS(4283),
    [anon_sym_SLASH] = ACTIONS(4285),
    [anon_sym_PERCENT] = ACTIONS(4283),
    [anon_sym_CARET] = ACTIONS(4283),
    [anon_sym_PIPE] = ACTIONS(4285),
    [anon_sym_AMP] = ACTIONS(4285),
    [anon_sym_LT_LT] = ACTIONS(4283),
    [anon_sym_GT_GT] = ACTIONS(4285),
    [anon_sym_GT_GT_GT] = ACTIONS(4283),
    [anon_sym_EQ_EQ] = ACTIONS(4283),
    [anon_sym_BANG_EQ] = ACTIONS(4283),
    [anon_sym_GT_EQ] = ACTIONS(4283),
    [anon_sym_LT_EQ] = ACTIONS(4283),
    [anon_sym_DOT] = ACTIONS(4285),
    [anon_sym_scoped] = ACTIONS(4273),
    [anon_sym_var] = ACTIONS(4273),
    [anon_sym_yield] = ACTIONS(4273),
    [anon_sym_switch] = ACTIONS(4285),
    [anon_sym_when] = ACTIONS(4273),
    [sym_discard] = ACTIONS(4281),
    [anon_sym_DOT_DOT] = ACTIONS(4283),
    [anon_sym_and] = ACTIONS(4279),
    [anon_sym_or] = ACTIONS(4279),
    [anon_sym_AMP_AMP] = ACTIONS(4283),
    [anon_sym_PIPE_PIPE] = ACTIONS(4283),
    [anon_sym_QMARK_QMARK] = ACTIONS(4283),
    [anon_sym_from] = ACTIONS(4273),
    [anon_sym_into] = ACTIONS(4285),
    [anon_sym_join] = ACTIONS(4273),
    [anon_sym_on] = ACTIONS(4273),
    [anon_sym_equals] = ACTIONS(4285),
    [anon_sym_let] = ACTIONS(4273),
    [anon_sym_orderby] = ACTIONS(4273),
    [anon_sym_ascending] = ACTIONS(4273),
    [anon_sym_descending] = ACTIONS(4273),
    [anon_sym_group] = ACTIONS(4273),
    [anon_sym_by] = ACTIONS(4273),
    [anon_sym_select] = ACTIONS(4273),
    [anon_sym_as] = ACTIONS(4285),
    [anon_sym_is] = ACTIONS(4285),
    [anon_sym_DASH_GT] = ACTIONS(4283),
    [anon_sym_with] = ACTIONS(4285),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3074] = {
    [sym__name] = STATE(4327),
    [sym_alias_qualified_name] = STATE(3592),
    [sym__simple_name] = STATE(3592),
    [sym_qualified_name] = STATE(3592),
    [sym_generic_name] = STATE(3608),
    [sym_ref_type] = STATE(3574),
    [sym__scoped_base_type] = STATE(3573),
    [sym_identifier] = STATE(3989),
    [sym__reserved_identifier] = STATE(3558),
    [sym_preproc_region] = STATE(3074),
    [sym_preproc_endregion] = STATE(3074),
    [sym_preproc_line] = STATE(3074),
    [sym_preproc_pragma] = STATE(3074),
    [sym_preproc_nullable] = STATE(3074),
    [sym_preproc_error] = STATE(3074),
    [sym_preproc_define] = STATE(3074),
    [sym_preproc_undef] = STATE(3074),
    [sym__identifier_token] = ACTIONS(4225),
    [anon_sym_alias] = ACTIONS(4227),
    [anon_sym_global] = ACTIONS(4227),
    [anon_sym_LBRACK] = ACTIONS(3719),
    [anon_sym_LPAREN] = ACTIONS(3719),
    [anon_sym_ref] = ACTIONS(4661),
    [anon_sym_LBRACE] = ACTIONS(3719),
    [anon_sym_file] = ACTIONS(4227),
    [anon_sym_LT] = ACTIONS(3721),
    [anon_sym_GT] = ACTIONS(3721),
    [anon_sym_where] = ACTIONS(4227),
    [anon_sym_QMARK] = ACTIONS(3721),
    [anon_sym_notnull] = ACTIONS(4227),
    [anon_sym_unmanaged] = ACTIONS(4227),
    [anon_sym_BANG] = ACTIONS(3721),
    [anon_sym_PLUS_PLUS] = ACTIONS(3719),
    [anon_sym_DASH_DASH] = ACTIONS(3719),
    [anon_sym_PLUS] = ACTIONS(3721),
    [anon_sym_DASH] = ACTIONS(3721),
    [anon_sym_STAR] = ACTIONS(3719),
    [anon_sym_SLASH] = ACTIONS(3721),
    [anon_sym_PERCENT] = ACTIONS(3719),
    [anon_sym_CARET] = ACTIONS(3719),
    [anon_sym_PIPE] = ACTIONS(3721),
    [anon_sym_AMP] = ACTIONS(3721),
    [anon_sym_LT_LT] = ACTIONS(3719),
    [anon_sym_GT_GT] = ACTIONS(3721),
    [anon_sym_GT_GT_GT] = ACTIONS(3719),
    [anon_sym_EQ_EQ] = ACTIONS(3719),
    [anon_sym_BANG_EQ] = ACTIONS(3719),
    [anon_sym_GT_EQ] = ACTIONS(3719),
    [anon_sym_LT_EQ] = ACTIONS(3719),
    [anon_sym_DOT] = ACTIONS(3721),
    [anon_sym_scoped] = ACTIONS(4227),
    [anon_sym_COLON_COLON] = ACTIONS(3719),
    [anon_sym_var] = ACTIONS(4227),
    [anon_sym_yield] = ACTIONS(4227),
    [anon_sym_switch] = ACTIONS(3721),
    [anon_sym_when] = ACTIONS(4227),
    [anon_sym_DOT_DOT] = ACTIONS(3719),
    [anon_sym_AMP_AMP] = ACTIONS(3719),
    [anon_sym_PIPE_PIPE] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK] = ACTIONS(3719),
    [anon_sym_from] = ACTIONS(4227),
    [anon_sym_into] = ACTIONS(4231),
    [anon_sym_join] = ACTIONS(4227),
    [anon_sym_on] = ACTIONS(4227),
    [anon_sym_equals] = ACTIONS(4227),
    [anon_sym_let] = ACTIONS(4227),
    [anon_sym_orderby] = ACTIONS(4227),
    [anon_sym_ascending] = ACTIONS(4227),
    [anon_sym_descending] = ACTIONS(4227),
    [anon_sym_group] = ACTIONS(4227),
    [anon_sym_by] = ACTIONS(4231),
    [anon_sym_select] = ACTIONS(4227),
    [anon_sym_as] = ACTIONS(3721),
    [anon_sym_is] = ACTIONS(3721),
    [anon_sym_DASH_GT] = ACTIONS(3719),
    [anon_sym_with] = ACTIONS(3721),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3075] = {
    [sym_parameter_list] = STATE(9765),
    [sym_positional_pattern_clause] = STATE(3154),
    [sym_property_pattern_clause] = STATE(3454),
    [sym__variable_designation] = STATE(4021),
    [sym_parenthesized_variable_designation] = STATE(4015),
    [sym__lambda_parameters] = STATE(9127),
    [sym_identifier] = STATE(4055),
    [sym__reserved_identifier] = STATE(3908),
    [sym_preproc_region] = STATE(3075),
    [sym_preproc_endregion] = STATE(3075),
    [sym_preproc_line] = STATE(3075),
    [sym_preproc_pragma] = STATE(3075),
    [sym_preproc_nullable] = STATE(3075),
    [sym_preproc_error] = STATE(3075),
    [sym_preproc_define] = STATE(3075),
    [sym_preproc_undef] = STATE(3075),
    [sym__identifier_token] = ACTIONS(4271),
    [anon_sym_alias] = ACTIONS(4273),
    [anon_sym_global] = ACTIONS(4273),
    [anon_sym_LBRACK] = ACTIONS(4283),
    [anon_sym_LPAREN] = ACTIONS(4283),
    [anon_sym_LBRACE] = ACTIONS(4277),
    [anon_sym_file] = ACTIONS(4273),
    [anon_sym_LT] = ACTIONS(4285),
    [anon_sym_GT] = ACTIONS(4285),
    [anon_sym_where] = ACTIONS(4273),
    [anon_sym_QMARK] = ACTIONS(4285),
    [anon_sym_notnull] = ACTIONS(4273),
    [anon_sym_unmanaged] = ACTIONS(4273),
    [anon_sym_BANG] = ACTIONS(4285),
    [anon_sym_PLUS_PLUS] = ACTIONS(4283),
    [anon_sym_DASH_DASH] = ACTIONS(4283),
    [anon_sym_PLUS] = ACTIONS(4285),
    [anon_sym_DASH] = ACTIONS(4285),
    [anon_sym_STAR] = ACTIONS(4283),
    [anon_sym_SLASH] = ACTIONS(4285),
    [anon_sym_PERCENT] = ACTIONS(4283),
    [anon_sym_CARET] = ACTIONS(4283),
    [anon_sym_PIPE] = ACTIONS(4285),
    [anon_sym_AMP] = ACTIONS(4285),
    [anon_sym_LT_LT] = ACTIONS(4283),
    [anon_sym_GT_GT] = ACTIONS(4285),
    [anon_sym_GT_GT_GT] = ACTIONS(4283),
    [anon_sym_EQ_EQ] = ACTIONS(4283),
    [anon_sym_BANG_EQ] = ACTIONS(4283),
    [anon_sym_GT_EQ] = ACTIONS(4283),
    [anon_sym_LT_EQ] = ACTIONS(4283),
    [anon_sym_DOT] = ACTIONS(4285),
    [anon_sym_scoped] = ACTIONS(4273),
    [anon_sym_var] = ACTIONS(4273),
    [anon_sym_yield] = ACTIONS(4273),
    [anon_sym_switch] = ACTIONS(4285),
    [anon_sym_when] = ACTIONS(4273),
    [sym_discard] = ACTIONS(4281),
    [anon_sym_DOT_DOT] = ACTIONS(4283),
    [anon_sym_and] = ACTIONS(4279),
    [anon_sym_or] = ACTIONS(4279),
    [anon_sym_AMP_AMP] = ACTIONS(4283),
    [anon_sym_PIPE_PIPE] = ACTIONS(4283),
    [anon_sym_QMARK_QMARK] = ACTIONS(4283),
    [anon_sym_from] = ACTIONS(4273),
    [anon_sym_into] = ACTIONS(4285),
    [anon_sym_join] = ACTIONS(4273),
    [anon_sym_on] = ACTIONS(4285),
    [anon_sym_equals] = ACTIONS(4273),
    [anon_sym_let] = ACTIONS(4273),
    [anon_sym_orderby] = ACTIONS(4273),
    [anon_sym_ascending] = ACTIONS(4273),
    [anon_sym_descending] = ACTIONS(4273),
    [anon_sym_group] = ACTIONS(4273),
    [anon_sym_by] = ACTIONS(4273),
    [anon_sym_select] = ACTIONS(4273),
    [anon_sym_as] = ACTIONS(4285),
    [anon_sym_is] = ACTIONS(4285),
    [anon_sym_DASH_GT] = ACTIONS(4283),
    [anon_sym_with] = ACTIONS(4285),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3076] = {
    [sym_parameter_list] = STATE(9765),
    [sym_positional_pattern_clause] = STATE(3157),
    [sym_property_pattern_clause] = STATE(3409),
    [sym__variable_designation] = STATE(4021),
    [sym_parenthesized_variable_designation] = STATE(4015),
    [sym__lambda_parameters] = STATE(9127),
    [sym_identifier] = STATE(4055),
    [sym__reserved_identifier] = STATE(3908),
    [sym_preproc_region] = STATE(3076),
    [sym_preproc_endregion] = STATE(3076),
    [sym_preproc_line] = STATE(3076),
    [sym_preproc_pragma] = STATE(3076),
    [sym_preproc_nullable] = STATE(3076),
    [sym_preproc_error] = STATE(3076),
    [sym_preproc_define] = STATE(3076),
    [sym_preproc_undef] = STATE(3076),
    [sym__identifier_token] = ACTIONS(4271),
    [anon_sym_alias] = ACTIONS(4273),
    [anon_sym_global] = ACTIONS(4273),
    [anon_sym_LBRACK] = ACTIONS(4283),
    [anon_sym_LPAREN] = ACTIONS(4283),
    [anon_sym_LBRACE] = ACTIONS(4277),
    [anon_sym_file] = ACTIONS(4273),
    [anon_sym_LT] = ACTIONS(4285),
    [anon_sym_GT] = ACTIONS(4285),
    [anon_sym_where] = ACTIONS(4273),
    [anon_sym_QMARK] = ACTIONS(4285),
    [anon_sym_notnull] = ACTIONS(4273),
    [anon_sym_unmanaged] = ACTIONS(4273),
    [anon_sym_BANG] = ACTIONS(4285),
    [anon_sym_PLUS_PLUS] = ACTIONS(4283),
    [anon_sym_DASH_DASH] = ACTIONS(4283),
    [anon_sym_PLUS] = ACTIONS(4285),
    [anon_sym_DASH] = ACTIONS(4285),
    [anon_sym_STAR] = ACTIONS(4283),
    [anon_sym_SLASH] = ACTIONS(4285),
    [anon_sym_PERCENT] = ACTIONS(4283),
    [anon_sym_CARET] = ACTIONS(4283),
    [anon_sym_PIPE] = ACTIONS(4285),
    [anon_sym_AMP] = ACTIONS(4285),
    [anon_sym_LT_LT] = ACTIONS(4283),
    [anon_sym_GT_GT] = ACTIONS(4285),
    [anon_sym_GT_GT_GT] = ACTIONS(4283),
    [anon_sym_EQ_EQ] = ACTIONS(4283),
    [anon_sym_BANG_EQ] = ACTIONS(4283),
    [anon_sym_GT_EQ] = ACTIONS(4283),
    [anon_sym_LT_EQ] = ACTIONS(4283),
    [anon_sym_DOT] = ACTIONS(4285),
    [anon_sym_scoped] = ACTIONS(4273),
    [anon_sym_var] = ACTIONS(4273),
    [anon_sym_yield] = ACTIONS(4273),
    [anon_sym_switch] = ACTIONS(4285),
    [anon_sym_when] = ACTIONS(4273),
    [sym_discard] = ACTIONS(4281),
    [anon_sym_DOT_DOT] = ACTIONS(4283),
    [anon_sym_and] = ACTIONS(4285),
    [anon_sym_or] = ACTIONS(4285),
    [anon_sym_AMP_AMP] = ACTIONS(4283),
    [anon_sym_PIPE_PIPE] = ACTIONS(4283),
    [anon_sym_QMARK_QMARK] = ACTIONS(4283),
    [anon_sym_from] = ACTIONS(4273),
    [anon_sym_into] = ACTIONS(4285),
    [anon_sym_join] = ACTIONS(4273),
    [anon_sym_on] = ACTIONS(4273),
    [anon_sym_equals] = ACTIONS(4273),
    [anon_sym_let] = ACTIONS(4273),
    [anon_sym_orderby] = ACTIONS(4273),
    [anon_sym_ascending] = ACTIONS(4273),
    [anon_sym_descending] = ACTIONS(4273),
    [anon_sym_group] = ACTIONS(4273),
    [anon_sym_by] = ACTIONS(4285),
    [anon_sym_select] = ACTIONS(4273),
    [anon_sym_as] = ACTIONS(4285),
    [anon_sym_is] = ACTIONS(4285),
    [anon_sym_DASH_GT] = ACTIONS(4283),
    [anon_sym_with] = ACTIONS(4285),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3077] = {
    [sym_parameter_list] = STATE(9765),
    [sym_positional_pattern_clause] = STATE(3141),
    [sym_property_pattern_clause] = STATE(3389),
    [sym__variable_designation] = STATE(4260),
    [sym_parenthesized_variable_designation] = STATE(4274),
    [sym__lambda_parameters] = STATE(9127),
    [sym_identifier] = STATE(4259),
    [sym__reserved_identifier] = STATE(3908),
    [sym_preproc_region] = STATE(3077),
    [sym_preproc_endregion] = STATE(3077),
    [sym_preproc_line] = STATE(3077),
    [sym_preproc_pragma] = STATE(3077),
    [sym_preproc_nullable] = STATE(3077),
    [sym_preproc_error] = STATE(3077),
    [sym_preproc_define] = STATE(3077),
    [sym_preproc_undef] = STATE(3077),
    [sym__identifier_token] = ACTIONS(4271),
    [anon_sym_alias] = ACTIONS(4273),
    [anon_sym_global] = ACTIONS(4273),
    [anon_sym_LBRACK] = ACTIONS(4283),
    [anon_sym_LPAREN] = ACTIONS(4283),
    [anon_sym_LBRACE] = ACTIONS(4277),
    [anon_sym_file] = ACTIONS(4273),
    [anon_sym_LT] = ACTIONS(4285),
    [anon_sym_GT] = ACTIONS(4285),
    [anon_sym_where] = ACTIONS(4273),
    [anon_sym_QMARK] = ACTIONS(4285),
    [anon_sym_notnull] = ACTIONS(4273),
    [anon_sym_unmanaged] = ACTIONS(4273),
    [anon_sym_BANG] = ACTIONS(4285),
    [anon_sym_PLUS_PLUS] = ACTIONS(4283),
    [anon_sym_DASH_DASH] = ACTIONS(4283),
    [anon_sym_PLUS] = ACTIONS(4285),
    [anon_sym_DASH] = ACTIONS(4285),
    [anon_sym_STAR] = ACTIONS(4283),
    [anon_sym_SLASH] = ACTIONS(4285),
    [anon_sym_PERCENT] = ACTIONS(4283),
    [anon_sym_CARET] = ACTIONS(4283),
    [anon_sym_PIPE] = ACTIONS(4285),
    [anon_sym_AMP] = ACTIONS(4285),
    [anon_sym_LT_LT] = ACTIONS(4283),
    [anon_sym_GT_GT] = ACTIONS(4285),
    [anon_sym_GT_GT_GT] = ACTIONS(4283),
    [anon_sym_EQ_EQ] = ACTIONS(4283),
    [anon_sym_BANG_EQ] = ACTIONS(4283),
    [anon_sym_GT_EQ] = ACTIONS(4283),
    [anon_sym_LT_EQ] = ACTIONS(4283),
    [anon_sym_DOT] = ACTIONS(4285),
    [anon_sym_scoped] = ACTIONS(4273),
    [anon_sym_var] = ACTIONS(4273),
    [anon_sym_yield] = ACTIONS(4273),
    [anon_sym_switch] = ACTIONS(4285),
    [anon_sym_when] = ACTIONS(4273),
    [sym_discard] = ACTIONS(4295),
    [anon_sym_DOT_DOT] = ACTIONS(4283),
    [anon_sym_and] = ACTIONS(4285),
    [anon_sym_or] = ACTIONS(4285),
    [anon_sym_AMP_AMP] = ACTIONS(4283),
    [anon_sym_PIPE_PIPE] = ACTIONS(4283),
    [anon_sym_QMARK_QMARK] = ACTIONS(4283),
    [anon_sym_from] = ACTIONS(4273),
    [anon_sym_into] = ACTIONS(4273),
    [anon_sym_join] = ACTIONS(4273),
    [anon_sym_on] = ACTIONS(4285),
    [anon_sym_equals] = ACTIONS(4273),
    [anon_sym_let] = ACTIONS(4273),
    [anon_sym_orderby] = ACTIONS(4273),
    [anon_sym_ascending] = ACTIONS(4273),
    [anon_sym_descending] = ACTIONS(4273),
    [anon_sym_group] = ACTIONS(4273),
    [anon_sym_by] = ACTIONS(4273),
    [anon_sym_select] = ACTIONS(4273),
    [anon_sym_as] = ACTIONS(4285),
    [anon_sym_is] = ACTIONS(4285),
    [anon_sym_DASH_GT] = ACTIONS(4283),
    [anon_sym_with] = ACTIONS(4285),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3078] = {
    [sym_parameter_list] = STATE(9765),
    [sym_positional_pattern_clause] = STATE(3155),
    [sym_property_pattern_clause] = STATE(3363),
    [sym__variable_designation] = STATE(4260),
    [sym_parenthesized_variable_designation] = STATE(4274),
    [sym__lambda_parameters] = STATE(9127),
    [sym_identifier] = STATE(4259),
    [sym__reserved_identifier] = STATE(3908),
    [sym_preproc_region] = STATE(3078),
    [sym_preproc_endregion] = STATE(3078),
    [sym_preproc_line] = STATE(3078),
    [sym_preproc_pragma] = STATE(3078),
    [sym_preproc_nullable] = STATE(3078),
    [sym_preproc_error] = STATE(3078),
    [sym_preproc_define] = STATE(3078),
    [sym_preproc_undef] = STATE(3078),
    [sym__identifier_token] = ACTIONS(4271),
    [anon_sym_alias] = ACTIONS(4273),
    [anon_sym_global] = ACTIONS(4273),
    [anon_sym_LBRACK] = ACTIONS(4283),
    [anon_sym_LPAREN] = ACTIONS(4283),
    [anon_sym_LBRACE] = ACTIONS(4277),
    [anon_sym_file] = ACTIONS(4273),
    [anon_sym_LT] = ACTIONS(4285),
    [anon_sym_GT] = ACTIONS(4285),
    [anon_sym_where] = ACTIONS(4273),
    [anon_sym_QMARK] = ACTIONS(4285),
    [anon_sym_notnull] = ACTIONS(4273),
    [anon_sym_unmanaged] = ACTIONS(4273),
    [anon_sym_BANG] = ACTIONS(4285),
    [anon_sym_PLUS_PLUS] = ACTIONS(4283),
    [anon_sym_DASH_DASH] = ACTIONS(4283),
    [anon_sym_PLUS] = ACTIONS(4285),
    [anon_sym_DASH] = ACTIONS(4285),
    [anon_sym_STAR] = ACTIONS(4283),
    [anon_sym_SLASH] = ACTIONS(4285),
    [anon_sym_PERCENT] = ACTIONS(4283),
    [anon_sym_CARET] = ACTIONS(4283),
    [anon_sym_PIPE] = ACTIONS(4285),
    [anon_sym_AMP] = ACTIONS(4285),
    [anon_sym_LT_LT] = ACTIONS(4283),
    [anon_sym_GT_GT] = ACTIONS(4285),
    [anon_sym_GT_GT_GT] = ACTIONS(4283),
    [anon_sym_EQ_EQ] = ACTIONS(4283),
    [anon_sym_BANG_EQ] = ACTIONS(4283),
    [anon_sym_GT_EQ] = ACTIONS(4283),
    [anon_sym_LT_EQ] = ACTIONS(4283),
    [anon_sym_DOT] = ACTIONS(4285),
    [anon_sym_scoped] = ACTIONS(4273),
    [anon_sym_var] = ACTIONS(4273),
    [anon_sym_yield] = ACTIONS(4273),
    [anon_sym_switch] = ACTIONS(4285),
    [anon_sym_when] = ACTIONS(4273),
    [sym_discard] = ACTIONS(4295),
    [anon_sym_DOT_DOT] = ACTIONS(4283),
    [anon_sym_and] = ACTIONS(4285),
    [anon_sym_or] = ACTIONS(4285),
    [anon_sym_AMP_AMP] = ACTIONS(4283),
    [anon_sym_PIPE_PIPE] = ACTIONS(4283),
    [anon_sym_QMARK_QMARK] = ACTIONS(4283),
    [anon_sym_from] = ACTIONS(4273),
    [anon_sym_into] = ACTIONS(4273),
    [anon_sym_join] = ACTIONS(4273),
    [anon_sym_on] = ACTIONS(4273),
    [anon_sym_equals] = ACTIONS(4285),
    [anon_sym_let] = ACTIONS(4273),
    [anon_sym_orderby] = ACTIONS(4273),
    [anon_sym_ascending] = ACTIONS(4273),
    [anon_sym_descending] = ACTIONS(4273),
    [anon_sym_group] = ACTIONS(4273),
    [anon_sym_by] = ACTIONS(4273),
    [anon_sym_select] = ACTIONS(4273),
    [anon_sym_as] = ACTIONS(4285),
    [anon_sym_is] = ACTIONS(4285),
    [anon_sym_DASH_GT] = ACTIONS(4283),
    [anon_sym_with] = ACTIONS(4285),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3079] = {
    [sym_modifier] = STATE(4545),
    [sym_variable_declaration] = STATE(9266),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7114),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_identifier] = STATE(4921),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(3079),
    [sym_preproc_endregion] = STATE(3079),
    [sym_preproc_line] = STATE(3079),
    [sym_preproc_pragma] = STATE(3079),
    [sym_preproc_nullable] = STATE(3079),
    [sym_preproc_error] = STATE(3079),
    [sym_preproc_define] = STATE(3079),
    [sym_preproc_undef] = STATE(3079),
    [aux_sym_class_declaration_repeat2] = STATE(4360),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_unsafe] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(643),
    [anon_sym_LPAREN] = ACTIONS(2995),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(643),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(4442),
    [anon_sym_fixed] = ACTIONS(643),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(643),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3080] = {
    [sym_modifier] = STATE(4545),
    [sym_variable_declaration] = STATE(9447),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7047),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_identifier] = STATE(4921),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(3080),
    [sym_preproc_endregion] = STATE(3080),
    [sym_preproc_line] = STATE(3080),
    [sym_preproc_pragma] = STATE(3080),
    [sym_preproc_nullable] = STATE(3080),
    [sym_preproc_error] = STATE(3080),
    [sym_preproc_define] = STATE(3080),
    [sym_preproc_undef] = STATE(3080),
    [aux_sym_class_declaration_repeat2] = STATE(4360),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_unsafe] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(643),
    [anon_sym_LPAREN] = ACTIONS(2995),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(643),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(4442),
    [anon_sym_fixed] = ACTIONS(643),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(643),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3081] = {
    [sym_property_pattern_clause] = STATE(3129),
    [sym__variable_designation] = STATE(4256),
    [sym_parenthesized_variable_designation] = STATE(4274),
    [sym_identifier] = STATE(4269),
    [sym__reserved_identifier] = STATE(3908),
    [sym_preproc_region] = STATE(3081),
    [sym_preproc_endregion] = STATE(3081),
    [sym_preproc_line] = STATE(3081),
    [sym_preproc_pragma] = STATE(3081),
    [sym_preproc_nullable] = STATE(3081),
    [sym_preproc_error] = STATE(3081),
    [sym_preproc_define] = STATE(3081),
    [sym_preproc_undef] = STATE(3081),
    [sym__identifier_token] = ACTIONS(4271),
    [anon_sym_alias] = ACTIONS(4273),
    [anon_sym_global] = ACTIONS(4273),
    [anon_sym_LBRACK] = ACTIONS(4329),
    [anon_sym_COLON] = ACTIONS(4329),
    [anon_sym_LPAREN] = ACTIONS(4329),
    [anon_sym_LBRACE] = ACTIONS(4277),
    [anon_sym_file] = ACTIONS(4273),
    [anon_sym_LT] = ACTIONS(4331),
    [anon_sym_GT] = ACTIONS(4331),
    [anon_sym_where] = ACTIONS(4273),
    [anon_sym_QMARK] = ACTIONS(4331),
    [anon_sym_notnull] = ACTIONS(4273),
    [anon_sym_unmanaged] = ACTIONS(4273),
    [anon_sym_BANG] = ACTIONS(4331),
    [anon_sym_PLUS_PLUS] = ACTIONS(4329),
    [anon_sym_DASH_DASH] = ACTIONS(4329),
    [anon_sym_PLUS] = ACTIONS(4331),
    [anon_sym_DASH] = ACTIONS(4331),
    [anon_sym_STAR] = ACTIONS(4329),
    [anon_sym_SLASH] = ACTIONS(4331),
    [anon_sym_PERCENT] = ACTIONS(4329),
    [anon_sym_CARET] = ACTIONS(4329),
    [anon_sym_PIPE] = ACTIONS(4331),
    [anon_sym_AMP] = ACTIONS(4331),
    [anon_sym_LT_LT] = ACTIONS(4329),
    [anon_sym_GT_GT] = ACTIONS(4331),
    [anon_sym_GT_GT_GT] = ACTIONS(4329),
    [anon_sym_EQ_EQ] = ACTIONS(4329),
    [anon_sym_BANG_EQ] = ACTIONS(4329),
    [anon_sym_GT_EQ] = ACTIONS(4329),
    [anon_sym_LT_EQ] = ACTIONS(4329),
    [anon_sym_DOT] = ACTIONS(4331),
    [anon_sym_scoped] = ACTIONS(4273),
    [anon_sym_EQ_GT] = ACTIONS(4329),
    [anon_sym_var] = ACTIONS(4273),
    [anon_sym_yield] = ACTIONS(4273),
    [anon_sym_switch] = ACTIONS(4331),
    [anon_sym_when] = ACTIONS(4331),
    [sym_discard] = ACTIONS(4295),
    [anon_sym_DOT_DOT] = ACTIONS(4329),
    [anon_sym_and] = ACTIONS(4331),
    [anon_sym_or] = ACTIONS(4331),
    [anon_sym_AMP_AMP] = ACTIONS(4329),
    [anon_sym_PIPE_PIPE] = ACTIONS(4329),
    [anon_sym_QMARK_QMARK] = ACTIONS(4329),
    [anon_sym_from] = ACTIONS(4273),
    [anon_sym_into] = ACTIONS(4273),
    [anon_sym_join] = ACTIONS(4273),
    [anon_sym_on] = ACTIONS(4273),
    [anon_sym_equals] = ACTIONS(4273),
    [anon_sym_let] = ACTIONS(4273),
    [anon_sym_orderby] = ACTIONS(4273),
    [anon_sym_ascending] = ACTIONS(4273),
    [anon_sym_descending] = ACTIONS(4273),
    [anon_sym_group] = ACTIONS(4273),
    [anon_sym_by] = ACTIONS(4273),
    [anon_sym_select] = ACTIONS(4273),
    [anon_sym_as] = ACTIONS(4331),
    [anon_sym_is] = ACTIONS(4331),
    [anon_sym_DASH_GT] = ACTIONS(4329),
    [anon_sym_with] = ACTIONS(4331),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3082] = {
    [sym_modifier] = STATE(4545),
    [sym_variable_declaration] = STATE(9447),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7114),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_identifier] = STATE(4921),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(3082),
    [sym_preproc_endregion] = STATE(3082),
    [sym_preproc_line] = STATE(3082),
    [sym_preproc_pragma] = STATE(3082),
    [sym_preproc_nullable] = STATE(3082),
    [sym_preproc_error] = STATE(3082),
    [sym_preproc_define] = STATE(3082),
    [sym_preproc_undef] = STATE(3082),
    [aux_sym_class_declaration_repeat2] = STATE(3099),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_unsafe] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(643),
    [anon_sym_LPAREN] = ACTIONS(4663),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(643),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(4442),
    [anon_sym_fixed] = ACTIONS(643),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(643),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3083] = {
    [sym_modifier] = STATE(4545),
    [sym_variable_declaration] = STATE(9511),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7114),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_identifier] = STATE(4921),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(3083),
    [sym_preproc_endregion] = STATE(3083),
    [sym_preproc_line] = STATE(3083),
    [sym_preproc_pragma] = STATE(3083),
    [sym_preproc_nullable] = STATE(3083),
    [sym_preproc_error] = STATE(3083),
    [sym_preproc_define] = STATE(3083),
    [sym_preproc_undef] = STATE(3083),
    [aux_sym_class_declaration_repeat2] = STATE(4360),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_unsafe] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(643),
    [anon_sym_LPAREN] = ACTIONS(2995),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(643),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(4442),
    [anon_sym_fixed] = ACTIONS(643),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(643),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3084] = {
    [sym_modifier] = STATE(4545),
    [sym_variable_declaration] = STATE(9907),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7114),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_identifier] = STATE(4921),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(3084),
    [sym_preproc_endregion] = STATE(3084),
    [sym_preproc_line] = STATE(3084),
    [sym_preproc_pragma] = STATE(3084),
    [sym_preproc_nullable] = STATE(3084),
    [sym_preproc_error] = STATE(3084),
    [sym_preproc_define] = STATE(3084),
    [sym_preproc_undef] = STATE(3084),
    [aux_sym_class_declaration_repeat2] = STATE(3094),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_unsafe] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(643),
    [anon_sym_LPAREN] = ACTIONS(4665),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(643),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(4442),
    [anon_sym_fixed] = ACTIONS(643),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(643),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3085] = {
    [sym_argument_list] = STATE(3572),
    [sym__name] = STATE(3770),
    [sym_alias_qualified_name] = STATE(3635),
    [sym__simple_name] = STATE(3635),
    [sym_qualified_name] = STATE(3635),
    [sym_generic_name] = STATE(3708),
    [sym_type] = STATE(4257),
    [sym_implicit_type] = STATE(3706),
    [sym_array_type] = STATE(5137),
    [sym__array_base_type] = STATE(8888),
    [sym_nullable_type] = STATE(3618),
    [sym_pointer_type] = STATE(3618),
    [sym__pointer_base_type] = STATE(9386),
    [sym_function_pointer_type] = STATE(3618),
    [sym_ref_type] = STATE(3706),
    [sym_scoped_type] = STATE(3706),
    [sym_tuple_type] = STATE(3633),
    [sym_identifier] = STATE(3590),
    [sym__reserved_identifier] = STATE(3568),
    [sym_preproc_region] = STATE(3085),
    [sym_preproc_endregion] = STATE(3085),
    [sym_preproc_line] = STATE(3085),
    [sym_preproc_pragma] = STATE(3085),
    [sym_preproc_nullable] = STATE(3085),
    [sym_preproc_error] = STATE(3085),
    [sym_preproc_define] = STATE(3085),
    [sym_preproc_undef] = STATE(3085),
    [sym__identifier_token] = ACTIONS(4287),
    [anon_sym_extern] = ACTIONS(3976),
    [anon_sym_alias] = ACTIONS(4289),
    [anon_sym_global] = ACTIONS(4289),
    [anon_sym_unsafe] = ACTIONS(3976),
    [anon_sym_static] = ACTIONS(3976),
    [anon_sym_LBRACK] = ACTIONS(4449),
    [anon_sym_LPAREN] = ACTIONS(4451),
    [anon_sym_ref] = ACTIONS(4291),
    [anon_sym_LBRACE] = ACTIONS(4453),
    [anon_sym_delegate] = ACTIONS(4455),
    [anon_sym_abstract] = ACTIONS(3976),
    [anon_sym_async] = ACTIONS(3976),
    [anon_sym_const] = ACTIONS(3976),
    [anon_sym_file] = ACTIONS(4289),
    [anon_sym_fixed] = ACTIONS(3976),
    [anon_sym_internal] = ACTIONS(3976),
    [anon_sym_new] = ACTIONS(3976),
    [anon_sym_override] = ACTIONS(3976),
    [anon_sym_partial] = ACTIONS(3976),
    [anon_sym_private] = ACTIONS(3976),
    [anon_sym_protected] = ACTIONS(3976),
    [anon_sym_public] = ACTIONS(3976),
    [anon_sym_readonly] = ACTIONS(3976),
    [anon_sym_required] = ACTIONS(3976),
    [anon_sym_sealed] = ACTIONS(3976),
    [anon_sym_virtual] = ACTIONS(3976),
    [anon_sym_volatile] = ACTIONS(3976),
    [anon_sym_where] = ACTIONS(4289),
    [anon_sym_notnull] = ACTIONS(4289),
    [anon_sym_unmanaged] = ACTIONS(4289),
    [anon_sym_scoped] = ACTIONS(4457),
    [anon_sym_var] = ACTIONS(4459),
    [sym_predefined_type] = ACTIONS(4461),
    [anon_sym_yield] = ACTIONS(4289),
    [anon_sym_when] = ACTIONS(4289),
    [anon_sym_from] = ACTIONS(4289),
    [anon_sym_into] = ACTIONS(4289),
    [anon_sym_join] = ACTIONS(4289),
    [anon_sym_on] = ACTIONS(4289),
    [anon_sym_equals] = ACTIONS(4289),
    [anon_sym_let] = ACTIONS(4289),
    [anon_sym_orderby] = ACTIONS(4289),
    [anon_sym_ascending] = ACTIONS(4289),
    [anon_sym_descending] = ACTIONS(4289),
    [anon_sym_group] = ACTIONS(4289),
    [anon_sym_by] = ACTIONS(4289),
    [anon_sym_select] = ACTIONS(4289),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3086] = {
    [sym_modifier] = STATE(4545),
    [sym_variable_declaration] = STATE(9511),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7114),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_identifier] = STATE(4921),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(3086),
    [sym_preproc_endregion] = STATE(3086),
    [sym_preproc_line] = STATE(3086),
    [sym_preproc_pragma] = STATE(3086),
    [sym_preproc_nullable] = STATE(3086),
    [sym_preproc_error] = STATE(3086),
    [sym_preproc_define] = STATE(3086),
    [sym_preproc_undef] = STATE(3086),
    [aux_sym_class_declaration_repeat2] = STATE(3087),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_unsafe] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(643),
    [anon_sym_LPAREN] = ACTIONS(4667),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(643),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(4442),
    [anon_sym_fixed] = ACTIONS(643),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(643),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3087] = {
    [sym_modifier] = STATE(4545),
    [sym_variable_declaration] = STATE(8977),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7114),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_identifier] = STATE(4921),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(3087),
    [sym_preproc_endregion] = STATE(3087),
    [sym_preproc_line] = STATE(3087),
    [sym_preproc_pragma] = STATE(3087),
    [sym_preproc_nullable] = STATE(3087),
    [sym_preproc_error] = STATE(3087),
    [sym_preproc_define] = STATE(3087),
    [sym_preproc_undef] = STATE(3087),
    [aux_sym_class_declaration_repeat2] = STATE(4360),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_unsafe] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(643),
    [anon_sym_LPAREN] = ACTIONS(2995),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(643),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(4442),
    [anon_sym_fixed] = ACTIONS(643),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(643),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3088] = {
    [sym_modifier] = STATE(4545),
    [sym_variable_declaration] = STATE(9366),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7114),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_identifier] = STATE(4921),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(3088),
    [sym_preproc_endregion] = STATE(3088),
    [sym_preproc_line] = STATE(3088),
    [sym_preproc_pragma] = STATE(3088),
    [sym_preproc_nullable] = STATE(3088),
    [sym_preproc_error] = STATE(3088),
    [sym_preproc_define] = STATE(3088),
    [sym_preproc_undef] = STATE(3088),
    [aux_sym_class_declaration_repeat2] = STATE(3079),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_unsafe] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(643),
    [anon_sym_LPAREN] = ACTIONS(4669),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(643),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(4442),
    [anon_sym_fixed] = ACTIONS(643),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(643),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3089] = {
    [sym_argument_list] = STATE(3572),
    [sym__name] = STATE(3770),
    [sym_alias_qualified_name] = STATE(3635),
    [sym__simple_name] = STATE(3635),
    [sym_qualified_name] = STATE(3635),
    [sym_generic_name] = STATE(3708),
    [sym_type] = STATE(4257),
    [sym_implicit_type] = STATE(3706),
    [sym_array_type] = STATE(3601),
    [sym__array_base_type] = STATE(8888),
    [sym_nullable_type] = STATE(3618),
    [sym_pointer_type] = STATE(3618),
    [sym__pointer_base_type] = STATE(9386),
    [sym_function_pointer_type] = STATE(3618),
    [sym_ref_type] = STATE(3706),
    [sym_scoped_type] = STATE(3706),
    [sym_tuple_type] = STATE(3633),
    [sym_identifier] = STATE(3590),
    [sym__reserved_identifier] = STATE(3568),
    [sym_preproc_region] = STATE(3089),
    [sym_preproc_endregion] = STATE(3089),
    [sym_preproc_line] = STATE(3089),
    [sym_preproc_pragma] = STATE(3089),
    [sym_preproc_nullable] = STATE(3089),
    [sym_preproc_error] = STATE(3089),
    [sym_preproc_define] = STATE(3089),
    [sym_preproc_undef] = STATE(3089),
    [sym__identifier_token] = ACTIONS(4287),
    [anon_sym_extern] = ACTIONS(3976),
    [anon_sym_alias] = ACTIONS(4289),
    [anon_sym_global] = ACTIONS(4289),
    [anon_sym_unsafe] = ACTIONS(3976),
    [anon_sym_static] = ACTIONS(3976),
    [anon_sym_LBRACK] = ACTIONS(4449),
    [anon_sym_LPAREN] = ACTIONS(4451),
    [anon_sym_ref] = ACTIONS(4291),
    [anon_sym_LBRACE] = ACTIONS(4453),
    [anon_sym_delegate] = ACTIONS(4455),
    [anon_sym_abstract] = ACTIONS(3976),
    [anon_sym_async] = ACTIONS(3976),
    [anon_sym_const] = ACTIONS(3976),
    [anon_sym_file] = ACTIONS(4289),
    [anon_sym_fixed] = ACTIONS(3976),
    [anon_sym_internal] = ACTIONS(3976),
    [anon_sym_new] = ACTIONS(3976),
    [anon_sym_override] = ACTIONS(3976),
    [anon_sym_partial] = ACTIONS(3976),
    [anon_sym_private] = ACTIONS(3976),
    [anon_sym_protected] = ACTIONS(3976),
    [anon_sym_public] = ACTIONS(3976),
    [anon_sym_readonly] = ACTIONS(3976),
    [anon_sym_required] = ACTIONS(3976),
    [anon_sym_sealed] = ACTIONS(3976),
    [anon_sym_virtual] = ACTIONS(3976),
    [anon_sym_volatile] = ACTIONS(3976),
    [anon_sym_where] = ACTIONS(4289),
    [anon_sym_notnull] = ACTIONS(4289),
    [anon_sym_unmanaged] = ACTIONS(4289),
    [anon_sym_scoped] = ACTIONS(4457),
    [anon_sym_var] = ACTIONS(4459),
    [sym_predefined_type] = ACTIONS(4461),
    [anon_sym_yield] = ACTIONS(4289),
    [anon_sym_when] = ACTIONS(4289),
    [anon_sym_from] = ACTIONS(4289),
    [anon_sym_into] = ACTIONS(4289),
    [anon_sym_join] = ACTIONS(4289),
    [anon_sym_on] = ACTIONS(4289),
    [anon_sym_equals] = ACTIONS(4289),
    [anon_sym_let] = ACTIONS(4289),
    [anon_sym_orderby] = ACTIONS(4289),
    [anon_sym_ascending] = ACTIONS(4289),
    [anon_sym_descending] = ACTIONS(4289),
    [anon_sym_group] = ACTIONS(4289),
    [anon_sym_by] = ACTIONS(4289),
    [anon_sym_select] = ACTIONS(4289),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3090] = {
    [sym_modifier] = STATE(4545),
    [sym_variable_declaration] = STATE(9907),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7114),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_identifier] = STATE(4921),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(3090),
    [sym_preproc_endregion] = STATE(3090),
    [sym_preproc_line] = STATE(3090),
    [sym_preproc_pragma] = STATE(3090),
    [sym_preproc_nullable] = STATE(3090),
    [sym_preproc_error] = STATE(3090),
    [sym_preproc_define] = STATE(3090),
    [sym_preproc_undef] = STATE(3090),
    [aux_sym_class_declaration_repeat2] = STATE(4360),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_unsafe] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(643),
    [anon_sym_LPAREN] = ACTIONS(2995),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(643),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(4442),
    [anon_sym_fixed] = ACTIONS(643),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(643),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3091] = {
    [sym_modifier] = STATE(4545),
    [sym_variable_declaration] = STATE(9571),
    [sym__name] = STATE(6895),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7114),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_identifier] = STATE(6732),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(3091),
    [sym_preproc_endregion] = STATE(3091),
    [sym_preproc_line] = STATE(3091),
    [sym_preproc_pragma] = STATE(3091),
    [sym_preproc_nullable] = STATE(3091),
    [sym_preproc_error] = STATE(3091),
    [sym_preproc_define] = STATE(3091),
    [sym_preproc_undef] = STATE(3091),
    [aux_sym_class_declaration_repeat2] = STATE(3090),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_unsafe] = ACTIONS(4671),
    [anon_sym_static] = ACTIONS(4673),
    [anon_sym_LPAREN] = ACTIONS(4675),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(643),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(4442),
    [anon_sym_fixed] = ACTIONS(643),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(643),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3092] = {
    [sym_parameter_list] = STATE(9765),
    [sym__lambda_parameters] = STATE(9127),
    [sym_identifier] = STATE(9443),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_region] = STATE(3092),
    [sym_preproc_endregion] = STATE(3092),
    [sym_preproc_line] = STATE(3092),
    [sym_preproc_pragma] = STATE(3092),
    [sym_preproc_nullable] = STATE(3092),
    [sym_preproc_error] = STATE(3092),
    [sym_preproc_define] = STATE(3092),
    [sym_preproc_undef] = STATE(3092),
    [sym__identifier_token] = ACTIONS(4347),
    [anon_sym_alias] = ACTIONS(4347),
    [anon_sym_global] = ACTIONS(4347),
    [anon_sym_LBRACK] = ACTIONS(4349),
    [anon_sym_COLON] = ACTIONS(4349),
    [anon_sym_COMMA] = ACTIONS(4349),
    [anon_sym_LPAREN] = ACTIONS(4349),
    [anon_sym_LBRACE] = ACTIONS(4349),
    [anon_sym_file] = ACTIONS(4347),
    [anon_sym_LT] = ACTIONS(4347),
    [anon_sym_GT] = ACTIONS(4347),
    [anon_sym_where] = ACTIONS(4347),
    [anon_sym_QMARK] = ACTIONS(4347),
    [anon_sym_notnull] = ACTIONS(4347),
    [anon_sym_unmanaged] = ACTIONS(4347),
    [anon_sym_BANG] = ACTIONS(4347),
    [anon_sym_PLUS_PLUS] = ACTIONS(4349),
    [anon_sym_DASH_DASH] = ACTIONS(4349),
    [anon_sym_PLUS] = ACTIONS(4347),
    [anon_sym_DASH] = ACTIONS(4347),
    [anon_sym_STAR] = ACTIONS(4349),
    [anon_sym_SLASH] = ACTIONS(4347),
    [anon_sym_PERCENT] = ACTIONS(4349),
    [anon_sym_CARET] = ACTIONS(4349),
    [anon_sym_PIPE] = ACTIONS(4347),
    [anon_sym_AMP] = ACTIONS(4347),
    [anon_sym_LT_LT] = ACTIONS(4349),
    [anon_sym_GT_GT] = ACTIONS(4347),
    [anon_sym_GT_GT_GT] = ACTIONS(4349),
    [anon_sym_EQ_EQ] = ACTIONS(4349),
    [anon_sym_BANG_EQ] = ACTIONS(4349),
    [anon_sym_GT_EQ] = ACTIONS(4349),
    [anon_sym_LT_EQ] = ACTIONS(4349),
    [anon_sym_DOT] = ACTIONS(4347),
    [anon_sym_scoped] = ACTIONS(4347),
    [anon_sym_var] = ACTIONS(4347),
    [anon_sym_yield] = ACTIONS(4347),
    [anon_sym_switch] = ACTIONS(4347),
    [anon_sym_when] = ACTIONS(4347),
    [sym_discard] = ACTIONS(4347),
    [anon_sym_DOT_DOT] = ACTIONS(4349),
    [anon_sym_and] = ACTIONS(4347),
    [anon_sym_or] = ACTIONS(4347),
    [anon_sym_AMP_AMP] = ACTIONS(4349),
    [anon_sym_PIPE_PIPE] = ACTIONS(4349),
    [anon_sym_QMARK_QMARK] = ACTIONS(4349),
    [anon_sym_from] = ACTIONS(4347),
    [anon_sym_into] = ACTIONS(4347),
    [anon_sym_join] = ACTIONS(4347),
    [anon_sym_on] = ACTIONS(4347),
    [anon_sym_equals] = ACTIONS(4347),
    [anon_sym_let] = ACTIONS(4347),
    [anon_sym_orderby] = ACTIONS(4347),
    [anon_sym_ascending] = ACTIONS(4347),
    [anon_sym_descending] = ACTIONS(4347),
    [anon_sym_group] = ACTIONS(4347),
    [anon_sym_by] = ACTIONS(4347),
    [anon_sym_select] = ACTIONS(4347),
    [anon_sym_as] = ACTIONS(4347),
    [anon_sym_is] = ACTIONS(4347),
    [anon_sym_DASH_GT] = ACTIONS(4349),
    [anon_sym_with] = ACTIONS(4347),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4349),
  },
  [3093] = {
    [sym_modifier] = STATE(4545),
    [sym_variable_declaration] = STATE(9048),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7114),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_identifier] = STATE(4921),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(3093),
    [sym_preproc_endregion] = STATE(3093),
    [sym_preproc_line] = STATE(3093),
    [sym_preproc_pragma] = STATE(3093),
    [sym_preproc_nullable] = STATE(3093),
    [sym_preproc_error] = STATE(3093),
    [sym_preproc_define] = STATE(3093),
    [sym_preproc_undef] = STATE(3093),
    [aux_sym_class_declaration_repeat2] = STATE(4360),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_unsafe] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(643),
    [anon_sym_LPAREN] = ACTIONS(2995),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(643),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(4442),
    [anon_sym_fixed] = ACTIONS(643),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(643),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3094] = {
    [sym_modifier] = STATE(4545),
    [sym_variable_declaration] = STATE(9392),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7114),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_identifier] = STATE(4921),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(3094),
    [sym_preproc_endregion] = STATE(3094),
    [sym_preproc_line] = STATE(3094),
    [sym_preproc_pragma] = STATE(3094),
    [sym_preproc_nullable] = STATE(3094),
    [sym_preproc_error] = STATE(3094),
    [sym_preproc_define] = STATE(3094),
    [sym_preproc_undef] = STATE(3094),
    [aux_sym_class_declaration_repeat2] = STATE(4360),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_unsafe] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(643),
    [anon_sym_LPAREN] = ACTIONS(2995),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(643),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(4442),
    [anon_sym_fixed] = ACTIONS(643),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(643),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3095] = {
    [sym_property_pattern_clause] = STATE(3130),
    [sym__variable_designation] = STATE(4124),
    [sym_parenthesized_variable_designation] = STATE(4274),
    [sym_identifier] = STATE(4269),
    [sym__reserved_identifier] = STATE(3908),
    [sym_preproc_region] = STATE(3095),
    [sym_preproc_endregion] = STATE(3095),
    [sym_preproc_line] = STATE(3095),
    [sym_preproc_pragma] = STATE(3095),
    [sym_preproc_nullable] = STATE(3095),
    [sym_preproc_error] = STATE(3095),
    [sym_preproc_define] = STATE(3095),
    [sym_preproc_undef] = STATE(3095),
    [sym__identifier_token] = ACTIONS(4271),
    [anon_sym_alias] = ACTIONS(4273),
    [anon_sym_global] = ACTIONS(4273),
    [anon_sym_LBRACK] = ACTIONS(4335),
    [anon_sym_COLON] = ACTIONS(4335),
    [anon_sym_LPAREN] = ACTIONS(4335),
    [anon_sym_LBRACE] = ACTIONS(4277),
    [anon_sym_file] = ACTIONS(4273),
    [anon_sym_LT] = ACTIONS(4337),
    [anon_sym_GT] = ACTIONS(4337),
    [anon_sym_where] = ACTIONS(4273),
    [anon_sym_QMARK] = ACTIONS(4337),
    [anon_sym_notnull] = ACTIONS(4273),
    [anon_sym_unmanaged] = ACTIONS(4273),
    [anon_sym_BANG] = ACTIONS(4337),
    [anon_sym_PLUS_PLUS] = ACTIONS(4335),
    [anon_sym_DASH_DASH] = ACTIONS(4335),
    [anon_sym_PLUS] = ACTIONS(4337),
    [anon_sym_DASH] = ACTIONS(4337),
    [anon_sym_STAR] = ACTIONS(4335),
    [anon_sym_SLASH] = ACTIONS(4337),
    [anon_sym_PERCENT] = ACTIONS(4335),
    [anon_sym_CARET] = ACTIONS(4335),
    [anon_sym_PIPE] = ACTIONS(4337),
    [anon_sym_AMP] = ACTIONS(4337),
    [anon_sym_LT_LT] = ACTIONS(4335),
    [anon_sym_GT_GT] = ACTIONS(4337),
    [anon_sym_GT_GT_GT] = ACTIONS(4335),
    [anon_sym_EQ_EQ] = ACTIONS(4335),
    [anon_sym_BANG_EQ] = ACTIONS(4335),
    [anon_sym_GT_EQ] = ACTIONS(4335),
    [anon_sym_LT_EQ] = ACTIONS(4335),
    [anon_sym_DOT] = ACTIONS(4337),
    [anon_sym_scoped] = ACTIONS(4273),
    [anon_sym_EQ_GT] = ACTIONS(4335),
    [anon_sym_var] = ACTIONS(4273),
    [anon_sym_yield] = ACTIONS(4273),
    [anon_sym_switch] = ACTIONS(4337),
    [anon_sym_when] = ACTIONS(4337),
    [sym_discard] = ACTIONS(4295),
    [anon_sym_DOT_DOT] = ACTIONS(4335),
    [anon_sym_and] = ACTIONS(4337),
    [anon_sym_or] = ACTIONS(4337),
    [anon_sym_AMP_AMP] = ACTIONS(4335),
    [anon_sym_PIPE_PIPE] = ACTIONS(4335),
    [anon_sym_QMARK_QMARK] = ACTIONS(4335),
    [anon_sym_from] = ACTIONS(4273),
    [anon_sym_into] = ACTIONS(4273),
    [anon_sym_join] = ACTIONS(4273),
    [anon_sym_on] = ACTIONS(4273),
    [anon_sym_equals] = ACTIONS(4273),
    [anon_sym_let] = ACTIONS(4273),
    [anon_sym_orderby] = ACTIONS(4273),
    [anon_sym_ascending] = ACTIONS(4273),
    [anon_sym_descending] = ACTIONS(4273),
    [anon_sym_group] = ACTIONS(4273),
    [anon_sym_by] = ACTIONS(4273),
    [anon_sym_select] = ACTIONS(4273),
    [anon_sym_as] = ACTIONS(4337),
    [anon_sym_is] = ACTIONS(4337),
    [anon_sym_DASH_GT] = ACTIONS(4335),
    [anon_sym_with] = ACTIONS(4337),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3096] = {
    [sym_property_pattern_clause] = STATE(3143),
    [sym__variable_designation] = STATE(4057),
    [sym_parenthesized_variable_designation] = STATE(4015),
    [sym_identifier] = STATE(4020),
    [sym__reserved_identifier] = STATE(3908),
    [sym_preproc_region] = STATE(3096),
    [sym_preproc_endregion] = STATE(3096),
    [sym_preproc_line] = STATE(3096),
    [sym_preproc_pragma] = STATE(3096),
    [sym_preproc_nullable] = STATE(3096),
    [sym_preproc_error] = STATE(3096),
    [sym_preproc_define] = STATE(3096),
    [sym_preproc_undef] = STATE(3096),
    [sym__identifier_token] = ACTIONS(4271),
    [anon_sym_alias] = ACTIONS(4273),
    [anon_sym_global] = ACTIONS(4273),
    [anon_sym_LBRACK] = ACTIONS(4335),
    [anon_sym_COLON] = ACTIONS(4335),
    [anon_sym_LPAREN] = ACTIONS(4335),
    [anon_sym_LBRACE] = ACTIONS(4277),
    [anon_sym_file] = ACTIONS(4273),
    [anon_sym_LT] = ACTIONS(4337),
    [anon_sym_GT] = ACTIONS(4337),
    [anon_sym_where] = ACTIONS(4273),
    [anon_sym_QMARK] = ACTIONS(4337),
    [anon_sym_notnull] = ACTIONS(4273),
    [anon_sym_unmanaged] = ACTIONS(4273),
    [anon_sym_BANG] = ACTIONS(4337),
    [anon_sym_PLUS_PLUS] = ACTIONS(4335),
    [anon_sym_DASH_DASH] = ACTIONS(4335),
    [anon_sym_PLUS] = ACTIONS(4337),
    [anon_sym_DASH] = ACTIONS(4337),
    [anon_sym_STAR] = ACTIONS(4335),
    [anon_sym_SLASH] = ACTIONS(4337),
    [anon_sym_PERCENT] = ACTIONS(4335),
    [anon_sym_CARET] = ACTIONS(4335),
    [anon_sym_PIPE] = ACTIONS(4337),
    [anon_sym_AMP] = ACTIONS(4337),
    [anon_sym_LT_LT] = ACTIONS(4335),
    [anon_sym_GT_GT] = ACTIONS(4337),
    [anon_sym_GT_GT_GT] = ACTIONS(4335),
    [anon_sym_EQ_EQ] = ACTIONS(4335),
    [anon_sym_BANG_EQ] = ACTIONS(4335),
    [anon_sym_GT_EQ] = ACTIONS(4335),
    [anon_sym_LT_EQ] = ACTIONS(4335),
    [anon_sym_DOT] = ACTIONS(4337),
    [anon_sym_scoped] = ACTIONS(4273),
    [anon_sym_EQ_GT] = ACTIONS(4335),
    [anon_sym_var] = ACTIONS(4273),
    [anon_sym_yield] = ACTIONS(4273),
    [anon_sym_switch] = ACTIONS(4337),
    [anon_sym_when] = ACTIONS(4337),
    [sym_discard] = ACTIONS(4281),
    [anon_sym_DOT_DOT] = ACTIONS(4335),
    [anon_sym_and] = ACTIONS(4337),
    [anon_sym_or] = ACTIONS(4337),
    [anon_sym_AMP_AMP] = ACTIONS(4335),
    [anon_sym_PIPE_PIPE] = ACTIONS(4335),
    [anon_sym_QMARK_QMARK] = ACTIONS(4335),
    [anon_sym_from] = ACTIONS(4273),
    [anon_sym_into] = ACTIONS(4337),
    [anon_sym_join] = ACTIONS(4273),
    [anon_sym_on] = ACTIONS(4273),
    [anon_sym_equals] = ACTIONS(4273),
    [anon_sym_let] = ACTIONS(4273),
    [anon_sym_orderby] = ACTIONS(4273),
    [anon_sym_ascending] = ACTIONS(4273),
    [anon_sym_descending] = ACTIONS(4273),
    [anon_sym_group] = ACTIONS(4273),
    [anon_sym_by] = ACTIONS(4273),
    [anon_sym_select] = ACTIONS(4273),
    [anon_sym_as] = ACTIONS(4337),
    [anon_sym_is] = ACTIONS(4337),
    [anon_sym_DASH_GT] = ACTIONS(4335),
    [anon_sym_with] = ACTIONS(4337),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3097] = {
    [sym_modifier] = STATE(4545),
    [sym_variable_declaration] = STATE(9449),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7114),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_identifier] = STATE(4921),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(3097),
    [sym_preproc_endregion] = STATE(3097),
    [sym_preproc_line] = STATE(3097),
    [sym_preproc_pragma] = STATE(3097),
    [sym_preproc_nullable] = STATE(3097),
    [sym_preproc_error] = STATE(3097),
    [sym_preproc_define] = STATE(3097),
    [sym_preproc_undef] = STATE(3097),
    [aux_sym_class_declaration_repeat2] = STATE(3103),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_unsafe] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(643),
    [anon_sym_LPAREN] = ACTIONS(4677),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(643),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(4442),
    [anon_sym_fixed] = ACTIONS(643),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(643),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3098] = {
    [sym_modifier] = STATE(4545),
    [sym_variable_declaration] = STATE(9447),
    [sym__name] = STATE(6900),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7114),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_identifier] = STATE(6737),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(3098),
    [sym_preproc_endregion] = STATE(3098),
    [sym_preproc_line] = STATE(3098),
    [sym_preproc_pragma] = STATE(3098),
    [sym_preproc_nullable] = STATE(3098),
    [sym_preproc_error] = STATE(3098),
    [sym_preproc_define] = STATE(3098),
    [sym_preproc_undef] = STATE(3098),
    [aux_sym_class_declaration_repeat2] = STATE(3099),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_unsafe] = ACTIONS(4679),
    [anon_sym_static] = ACTIONS(4681),
    [anon_sym_LPAREN] = ACTIONS(4663),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(643),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(4442),
    [anon_sym_fixed] = ACTIONS(643),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(643),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3099] = {
    [sym_modifier] = STATE(4545),
    [sym_variable_declaration] = STATE(9449),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7114),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_identifier] = STATE(4921),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(3099),
    [sym_preproc_endregion] = STATE(3099),
    [sym_preproc_line] = STATE(3099),
    [sym_preproc_pragma] = STATE(3099),
    [sym_preproc_nullable] = STATE(3099),
    [sym_preproc_error] = STATE(3099),
    [sym_preproc_define] = STATE(3099),
    [sym_preproc_undef] = STATE(3099),
    [aux_sym_class_declaration_repeat2] = STATE(4360),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_unsafe] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(643),
    [anon_sym_LPAREN] = ACTIONS(2995),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(643),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(4442),
    [anon_sym_fixed] = ACTIONS(643),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(643),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3100] = {
    [sym_modifier] = STATE(4545),
    [sym_variable_declaration] = STATE(9684),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7114),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_identifier] = STATE(4921),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(3100),
    [sym_preproc_endregion] = STATE(3100),
    [sym_preproc_line] = STATE(3100),
    [sym_preproc_pragma] = STATE(3100),
    [sym_preproc_nullable] = STATE(3100),
    [sym_preproc_error] = STATE(3100),
    [sym_preproc_define] = STATE(3100),
    [sym_preproc_undef] = STATE(3100),
    [aux_sym_class_declaration_repeat2] = STATE(3083),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_unsafe] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(643),
    [anon_sym_LPAREN] = ACTIONS(4683),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(643),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(4442),
    [anon_sym_fixed] = ACTIONS(643),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(643),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3101] = {
    [sym_modifier] = STATE(4545),
    [sym_variable_declaration] = STATE(9684),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7102),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_identifier] = STATE(4921),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(3101),
    [sym_preproc_endregion] = STATE(3101),
    [sym_preproc_line] = STATE(3101),
    [sym_preproc_pragma] = STATE(3101),
    [sym_preproc_nullable] = STATE(3101),
    [sym_preproc_error] = STATE(3101),
    [sym_preproc_define] = STATE(3101),
    [sym_preproc_undef] = STATE(3101),
    [aux_sym_class_declaration_repeat2] = STATE(4360),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_unsafe] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(643),
    [anon_sym_LPAREN] = ACTIONS(2995),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(643),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(4442),
    [anon_sym_fixed] = ACTIONS(643),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(643),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3102] = {
    [sym_property_pattern_clause] = STATE(3156),
    [sym__variable_designation] = STATE(4023),
    [sym_parenthesized_variable_designation] = STATE(4015),
    [sym_identifier] = STATE(4020),
    [sym__reserved_identifier] = STATE(3908),
    [sym_preproc_region] = STATE(3102),
    [sym_preproc_endregion] = STATE(3102),
    [sym_preproc_line] = STATE(3102),
    [sym_preproc_pragma] = STATE(3102),
    [sym_preproc_nullable] = STATE(3102),
    [sym_preproc_error] = STATE(3102),
    [sym_preproc_define] = STATE(3102),
    [sym_preproc_undef] = STATE(3102),
    [sym__identifier_token] = ACTIONS(4271),
    [anon_sym_alias] = ACTIONS(4273),
    [anon_sym_global] = ACTIONS(4273),
    [anon_sym_LBRACK] = ACTIONS(4329),
    [anon_sym_COLON] = ACTIONS(4329),
    [anon_sym_LPAREN] = ACTIONS(4329),
    [anon_sym_LBRACE] = ACTIONS(4277),
    [anon_sym_file] = ACTIONS(4273),
    [anon_sym_LT] = ACTIONS(4331),
    [anon_sym_GT] = ACTIONS(4331),
    [anon_sym_where] = ACTIONS(4273),
    [anon_sym_QMARK] = ACTIONS(4331),
    [anon_sym_notnull] = ACTIONS(4273),
    [anon_sym_unmanaged] = ACTIONS(4273),
    [anon_sym_BANG] = ACTIONS(4331),
    [anon_sym_PLUS_PLUS] = ACTIONS(4329),
    [anon_sym_DASH_DASH] = ACTIONS(4329),
    [anon_sym_PLUS] = ACTIONS(4331),
    [anon_sym_DASH] = ACTIONS(4331),
    [anon_sym_STAR] = ACTIONS(4329),
    [anon_sym_SLASH] = ACTIONS(4331),
    [anon_sym_PERCENT] = ACTIONS(4329),
    [anon_sym_CARET] = ACTIONS(4329),
    [anon_sym_PIPE] = ACTIONS(4331),
    [anon_sym_AMP] = ACTIONS(4331),
    [anon_sym_LT_LT] = ACTIONS(4329),
    [anon_sym_GT_GT] = ACTIONS(4331),
    [anon_sym_GT_GT_GT] = ACTIONS(4329),
    [anon_sym_EQ_EQ] = ACTIONS(4329),
    [anon_sym_BANG_EQ] = ACTIONS(4329),
    [anon_sym_GT_EQ] = ACTIONS(4329),
    [anon_sym_LT_EQ] = ACTIONS(4329),
    [anon_sym_DOT] = ACTIONS(4331),
    [anon_sym_scoped] = ACTIONS(4273),
    [anon_sym_EQ_GT] = ACTIONS(4329),
    [anon_sym_var] = ACTIONS(4273),
    [anon_sym_yield] = ACTIONS(4273),
    [anon_sym_switch] = ACTIONS(4331),
    [anon_sym_when] = ACTIONS(4331),
    [sym_discard] = ACTIONS(4281),
    [anon_sym_DOT_DOT] = ACTIONS(4329),
    [anon_sym_and] = ACTIONS(4331),
    [anon_sym_or] = ACTIONS(4331),
    [anon_sym_AMP_AMP] = ACTIONS(4329),
    [anon_sym_PIPE_PIPE] = ACTIONS(4329),
    [anon_sym_QMARK_QMARK] = ACTIONS(4329),
    [anon_sym_from] = ACTIONS(4273),
    [anon_sym_into] = ACTIONS(4331),
    [anon_sym_join] = ACTIONS(4273),
    [anon_sym_on] = ACTIONS(4273),
    [anon_sym_equals] = ACTIONS(4273),
    [anon_sym_let] = ACTIONS(4273),
    [anon_sym_orderby] = ACTIONS(4273),
    [anon_sym_ascending] = ACTIONS(4273),
    [anon_sym_descending] = ACTIONS(4273),
    [anon_sym_group] = ACTIONS(4273),
    [anon_sym_by] = ACTIONS(4273),
    [anon_sym_select] = ACTIONS(4273),
    [anon_sym_as] = ACTIONS(4331),
    [anon_sym_is] = ACTIONS(4331),
    [anon_sym_DASH_GT] = ACTIONS(4329),
    [anon_sym_with] = ACTIONS(4331),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3103] = {
    [sym_modifier] = STATE(4545),
    [sym_variable_declaration] = STATE(9578),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7114),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_identifier] = STATE(4921),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(3103),
    [sym_preproc_endregion] = STATE(3103),
    [sym_preproc_line] = STATE(3103),
    [sym_preproc_pragma] = STATE(3103),
    [sym_preproc_nullable] = STATE(3103),
    [sym_preproc_error] = STATE(3103),
    [sym_preproc_define] = STATE(3103),
    [sym_preproc_undef] = STATE(3103),
    [aux_sym_class_declaration_repeat2] = STATE(4360),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_unsafe] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(643),
    [anon_sym_LPAREN] = ACTIONS(2995),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(643),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(4442),
    [anon_sym_fixed] = ACTIONS(643),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(643),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3104] = {
    [sym_modifier] = STATE(4545),
    [sym_variable_declaration] = STATE(9571),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7114),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_identifier] = STATE(4921),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(3104),
    [sym_preproc_endregion] = STATE(3104),
    [sym_preproc_line] = STATE(3104),
    [sym_preproc_pragma] = STATE(3104),
    [sym_preproc_nullable] = STATE(3104),
    [sym_preproc_error] = STATE(3104),
    [sym_preproc_define] = STATE(3104),
    [sym_preproc_undef] = STATE(3104),
    [aux_sym_class_declaration_repeat2] = STATE(3090),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_unsafe] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(643),
    [anon_sym_LPAREN] = ACTIONS(4675),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(643),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(4442),
    [anon_sym_fixed] = ACTIONS(643),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(643),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3105] = {
    [sym_modifier] = STATE(4545),
    [sym_variable_declaration] = STATE(9571),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(6956),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_identifier] = STATE(4921),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(3105),
    [sym_preproc_endregion] = STATE(3105),
    [sym_preproc_line] = STATE(3105),
    [sym_preproc_pragma] = STATE(3105),
    [sym_preproc_nullable] = STATE(3105),
    [sym_preproc_error] = STATE(3105),
    [sym_preproc_define] = STATE(3105),
    [sym_preproc_undef] = STATE(3105),
    [aux_sym_class_declaration_repeat2] = STATE(4360),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_unsafe] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(643),
    [anon_sym_LPAREN] = ACTIONS(2995),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(643),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(4442),
    [anon_sym_fixed] = ACTIONS(643),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(643),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3106] = {
    [sym_modifier] = STATE(4545),
    [sym_variable_declaration] = STATE(9366),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7044),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_identifier] = STATE(4921),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(3106),
    [sym_preproc_endregion] = STATE(3106),
    [sym_preproc_line] = STATE(3106),
    [sym_preproc_pragma] = STATE(3106),
    [sym_preproc_nullable] = STATE(3106),
    [sym_preproc_error] = STATE(3106),
    [sym_preproc_define] = STATE(3106),
    [sym_preproc_undef] = STATE(3106),
    [aux_sym_class_declaration_repeat2] = STATE(4360),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_unsafe] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(643),
    [anon_sym_LPAREN] = ACTIONS(2995),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(643),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(4442),
    [anon_sym_fixed] = ACTIONS(643),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(643),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3107] = {
    [sym_modifier] = STATE(4545),
    [sym_variable_declaration] = STATE(9266),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7114),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_identifier] = STATE(4921),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(3107),
    [sym_preproc_endregion] = STATE(3107),
    [sym_preproc_line] = STATE(3107),
    [sym_preproc_pragma] = STATE(3107),
    [sym_preproc_nullable] = STATE(3107),
    [sym_preproc_error] = STATE(3107),
    [sym_preproc_define] = STATE(3107),
    [sym_preproc_undef] = STATE(3107),
    [aux_sym_class_declaration_repeat2] = STATE(3093),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_unsafe] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(643),
    [anon_sym_LPAREN] = ACTIONS(4685),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(643),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(4442),
    [anon_sym_fixed] = ACTIONS(643),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(643),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3108] = {
    [sym__variable_designation] = STATE(5413),
    [sym_parenthesized_variable_designation] = STATE(5390),
    [sym_identifier] = STATE(5396),
    [sym__reserved_identifier] = STATE(5128),
    [sym_preproc_region] = STATE(3108),
    [sym_preproc_endregion] = STATE(3108),
    [sym_preproc_line] = STATE(3108),
    [sym_preproc_pragma] = STATE(3108),
    [sym_preproc_nullable] = STATE(3108),
    [sym_preproc_error] = STATE(3108),
    [sym_preproc_define] = STATE(3108),
    [sym_preproc_undef] = STATE(3108),
    [sym__identifier_token] = ACTIONS(4482),
    [anon_sym_alias] = ACTIONS(4484),
    [anon_sym_global] = ACTIONS(4484),
    [anon_sym_LBRACK] = ACTIONS(4373),
    [anon_sym_COLON] = ACTIONS(4373),
    [anon_sym_COMMA] = ACTIONS(4373),
    [anon_sym_LPAREN] = ACTIONS(4373),
    [anon_sym_file] = ACTIONS(4484),
    [anon_sym_LT] = ACTIONS(4375),
    [anon_sym_GT] = ACTIONS(4375),
    [anon_sym_where] = ACTIONS(4484),
    [anon_sym_QMARK] = ACTIONS(4375),
    [anon_sym_notnull] = ACTIONS(4484),
    [anon_sym_unmanaged] = ACTIONS(4484),
    [anon_sym_BANG] = ACTIONS(4375),
    [anon_sym_PLUS_PLUS] = ACTIONS(4373),
    [anon_sym_DASH_DASH] = ACTIONS(4373),
    [anon_sym_PLUS] = ACTIONS(4375),
    [anon_sym_DASH] = ACTIONS(4375),
    [anon_sym_STAR] = ACTIONS(4373),
    [anon_sym_SLASH] = ACTIONS(4375),
    [anon_sym_PERCENT] = ACTIONS(4373),
    [anon_sym_CARET] = ACTIONS(4373),
    [anon_sym_PIPE] = ACTIONS(4375),
    [anon_sym_AMP] = ACTIONS(4375),
    [anon_sym_LT_LT] = ACTIONS(4373),
    [anon_sym_GT_GT] = ACTIONS(4375),
    [anon_sym_GT_GT_GT] = ACTIONS(4373),
    [anon_sym_EQ_EQ] = ACTIONS(4373),
    [anon_sym_BANG_EQ] = ACTIONS(4373),
    [anon_sym_GT_EQ] = ACTIONS(4373),
    [anon_sym_LT_EQ] = ACTIONS(4373),
    [anon_sym_DOT] = ACTIONS(4375),
    [anon_sym_scoped] = ACTIONS(4484),
    [anon_sym_var] = ACTIONS(4484),
    [anon_sym_yield] = ACTIONS(4484),
    [anon_sym_switch] = ACTIONS(4375),
    [anon_sym_when] = ACTIONS(4484),
    [sym_discard] = ACTIONS(4488),
    [anon_sym_DOT_DOT] = ACTIONS(4373),
    [anon_sym_and] = ACTIONS(4375),
    [anon_sym_or] = ACTIONS(4375),
    [anon_sym_AMP_AMP] = ACTIONS(4373),
    [anon_sym_PIPE_PIPE] = ACTIONS(4373),
    [anon_sym_QMARK_QMARK] = ACTIONS(4373),
    [anon_sym_from] = ACTIONS(4484),
    [anon_sym_into] = ACTIONS(4375),
    [anon_sym_join] = ACTIONS(4484),
    [anon_sym_on] = ACTIONS(4484),
    [anon_sym_equals] = ACTIONS(4484),
    [anon_sym_let] = ACTIONS(4484),
    [anon_sym_orderby] = ACTIONS(4484),
    [anon_sym_ascending] = ACTIONS(4484),
    [anon_sym_descending] = ACTIONS(4484),
    [anon_sym_group] = ACTIONS(4484),
    [anon_sym_by] = ACTIONS(4484),
    [anon_sym_select] = ACTIONS(4484),
    [anon_sym_as] = ACTIONS(4375),
    [anon_sym_is] = ACTIONS(4375),
    [anon_sym_DASH_GT] = ACTIONS(4373),
    [anon_sym_with] = ACTIONS(4375),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4373),
  },
  [3109] = {
    [sym_property_pattern_clause] = STATE(3196),
    [sym__variable_designation] = STATE(4650),
    [sym_parenthesized_variable_designation] = STATE(4614),
    [sym_identifier] = STATE(4624),
    [sym__reserved_identifier] = STATE(2914),
    [sym_preproc_region] = STATE(3109),
    [sym_preproc_endregion] = STATE(3109),
    [sym_preproc_line] = STATE(3109),
    [sym_preproc_pragma] = STATE(3109),
    [sym_preproc_nullable] = STATE(3109),
    [sym_preproc_error] = STATE(3109),
    [sym_preproc_define] = STATE(3109),
    [sym_preproc_undef] = STATE(3109),
    [sym__identifier_token] = ACTIONS(4490),
    [anon_sym_alias] = ACTIONS(4492),
    [anon_sym_global] = ACTIONS(4492),
    [anon_sym_LBRACK] = ACTIONS(4329),
    [anon_sym_COMMA] = ACTIONS(4329),
    [anon_sym_LPAREN] = ACTIONS(4329),
    [anon_sym_LBRACE] = ACTIONS(4277),
    [anon_sym_file] = ACTIONS(4492),
    [anon_sym_LT] = ACTIONS(4331),
    [anon_sym_GT] = ACTIONS(4331),
    [anon_sym_where] = ACTIONS(4331),
    [anon_sym_QMARK] = ACTIONS(4331),
    [anon_sym_notnull] = ACTIONS(4492),
    [anon_sym_unmanaged] = ACTIONS(4492),
    [anon_sym_BANG] = ACTIONS(4331),
    [anon_sym_PLUS_PLUS] = ACTIONS(4329),
    [anon_sym_DASH_DASH] = ACTIONS(4329),
    [anon_sym_PLUS] = ACTIONS(4331),
    [anon_sym_DASH] = ACTIONS(4331),
    [anon_sym_STAR] = ACTIONS(4329),
    [anon_sym_SLASH] = ACTIONS(4331),
    [anon_sym_PERCENT] = ACTIONS(4329),
    [anon_sym_CARET] = ACTIONS(4329),
    [anon_sym_PIPE] = ACTIONS(4331),
    [anon_sym_AMP] = ACTIONS(4331),
    [anon_sym_LT_LT] = ACTIONS(4329),
    [anon_sym_GT_GT] = ACTIONS(4331),
    [anon_sym_GT_GT_GT] = ACTIONS(4329),
    [anon_sym_EQ_EQ] = ACTIONS(4329),
    [anon_sym_BANG_EQ] = ACTIONS(4329),
    [anon_sym_GT_EQ] = ACTIONS(4329),
    [anon_sym_LT_EQ] = ACTIONS(4329),
    [anon_sym_DOT] = ACTIONS(4331),
    [anon_sym_scoped] = ACTIONS(4492),
    [anon_sym_var] = ACTIONS(4492),
    [anon_sym_yield] = ACTIONS(4492),
    [anon_sym_switch] = ACTIONS(4331),
    [anon_sym_when] = ACTIONS(4492),
    [sym_discard] = ACTIONS(4647),
    [anon_sym_DOT_DOT] = ACTIONS(4329),
    [anon_sym_and] = ACTIONS(4331),
    [anon_sym_or] = ACTIONS(4331),
    [anon_sym_AMP_AMP] = ACTIONS(4329),
    [anon_sym_PIPE_PIPE] = ACTIONS(4329),
    [anon_sym_QMARK_QMARK] = ACTIONS(4329),
    [anon_sym_from] = ACTIONS(4331),
    [anon_sym_into] = ACTIONS(4331),
    [anon_sym_join] = ACTIONS(4331),
    [anon_sym_on] = ACTIONS(4492),
    [anon_sym_equals] = ACTIONS(4492),
    [anon_sym_let] = ACTIONS(4331),
    [anon_sym_orderby] = ACTIONS(4331),
    [anon_sym_ascending] = ACTIONS(4331),
    [anon_sym_descending] = ACTIONS(4331),
    [anon_sym_group] = ACTIONS(4331),
    [anon_sym_by] = ACTIONS(4492),
    [anon_sym_select] = ACTIONS(4331),
    [anon_sym_as] = ACTIONS(4331),
    [anon_sym_is] = ACTIONS(4331),
    [anon_sym_DASH_GT] = ACTIONS(4329),
    [anon_sym_with] = ACTIONS(4331),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3110] = {
    [sym_property_pattern_clause] = STATE(3177),
    [sym__variable_designation] = STATE(4693),
    [sym_parenthesized_variable_designation] = STATE(4614),
    [sym_identifier] = STATE(4624),
    [sym__reserved_identifier] = STATE(2914),
    [sym_preproc_region] = STATE(3110),
    [sym_preproc_endregion] = STATE(3110),
    [sym_preproc_line] = STATE(3110),
    [sym_preproc_pragma] = STATE(3110),
    [sym_preproc_nullable] = STATE(3110),
    [sym_preproc_error] = STATE(3110),
    [sym_preproc_define] = STATE(3110),
    [sym_preproc_undef] = STATE(3110),
    [sym__identifier_token] = ACTIONS(4490),
    [anon_sym_alias] = ACTIONS(4492),
    [anon_sym_global] = ACTIONS(4492),
    [anon_sym_LBRACK] = ACTIONS(4335),
    [anon_sym_COMMA] = ACTIONS(4335),
    [anon_sym_LPAREN] = ACTIONS(4335),
    [anon_sym_LBRACE] = ACTIONS(4277),
    [anon_sym_file] = ACTIONS(4492),
    [anon_sym_LT] = ACTIONS(4337),
    [anon_sym_GT] = ACTIONS(4337),
    [anon_sym_where] = ACTIONS(4337),
    [anon_sym_QMARK] = ACTIONS(4337),
    [anon_sym_notnull] = ACTIONS(4492),
    [anon_sym_unmanaged] = ACTIONS(4492),
    [anon_sym_BANG] = ACTIONS(4337),
    [anon_sym_PLUS_PLUS] = ACTIONS(4335),
    [anon_sym_DASH_DASH] = ACTIONS(4335),
    [anon_sym_PLUS] = ACTIONS(4337),
    [anon_sym_DASH] = ACTIONS(4337),
    [anon_sym_STAR] = ACTIONS(4335),
    [anon_sym_SLASH] = ACTIONS(4337),
    [anon_sym_PERCENT] = ACTIONS(4335),
    [anon_sym_CARET] = ACTIONS(4335),
    [anon_sym_PIPE] = ACTIONS(4337),
    [anon_sym_AMP] = ACTIONS(4337),
    [anon_sym_LT_LT] = ACTIONS(4335),
    [anon_sym_GT_GT] = ACTIONS(4337),
    [anon_sym_GT_GT_GT] = ACTIONS(4335),
    [anon_sym_EQ_EQ] = ACTIONS(4335),
    [anon_sym_BANG_EQ] = ACTIONS(4335),
    [anon_sym_GT_EQ] = ACTIONS(4335),
    [anon_sym_LT_EQ] = ACTIONS(4335),
    [anon_sym_DOT] = ACTIONS(4337),
    [anon_sym_scoped] = ACTIONS(4492),
    [anon_sym_var] = ACTIONS(4492),
    [anon_sym_yield] = ACTIONS(4492),
    [anon_sym_switch] = ACTIONS(4337),
    [anon_sym_when] = ACTIONS(4492),
    [sym_discard] = ACTIONS(4647),
    [anon_sym_DOT_DOT] = ACTIONS(4335),
    [anon_sym_and] = ACTIONS(4337),
    [anon_sym_or] = ACTIONS(4337),
    [anon_sym_AMP_AMP] = ACTIONS(4335),
    [anon_sym_PIPE_PIPE] = ACTIONS(4335),
    [anon_sym_QMARK_QMARK] = ACTIONS(4335),
    [anon_sym_from] = ACTIONS(4337),
    [anon_sym_into] = ACTIONS(4492),
    [anon_sym_join] = ACTIONS(4337),
    [anon_sym_on] = ACTIONS(4492),
    [anon_sym_equals] = ACTIONS(4492),
    [anon_sym_let] = ACTIONS(4337),
    [anon_sym_orderby] = ACTIONS(4337),
    [anon_sym_ascending] = ACTIONS(4337),
    [anon_sym_descending] = ACTIONS(4337),
    [anon_sym_group] = ACTIONS(4337),
    [anon_sym_by] = ACTIONS(4492),
    [anon_sym_select] = ACTIONS(4337),
    [anon_sym_as] = ACTIONS(4337),
    [anon_sym_is] = ACTIONS(4337),
    [anon_sym_DASH_GT] = ACTIONS(4335),
    [anon_sym_with] = ACTIONS(4337),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3111] = {
    [sym__variable_designation] = STATE(5413),
    [sym_parenthesized_variable_designation] = STATE(5390),
    [sym_identifier] = STATE(5396),
    [sym__reserved_identifier] = STATE(5128),
    [sym_preproc_region] = STATE(3111),
    [sym_preproc_endregion] = STATE(3111),
    [sym_preproc_line] = STATE(3111),
    [sym_preproc_pragma] = STATE(3111),
    [sym_preproc_nullable] = STATE(3111),
    [sym_preproc_error] = STATE(3111),
    [sym_preproc_define] = STATE(3111),
    [sym_preproc_undef] = STATE(3111),
    [sym__identifier_token] = ACTIONS(4482),
    [anon_sym_alias] = ACTIONS(4484),
    [anon_sym_global] = ACTIONS(4484),
    [anon_sym_LBRACK] = ACTIONS(4373),
    [anon_sym_COLON] = ACTIONS(4373),
    [anon_sym_COMMA] = ACTIONS(4373),
    [anon_sym_LPAREN] = ACTIONS(4373),
    [anon_sym_file] = ACTIONS(4484),
    [anon_sym_LT] = ACTIONS(4375),
    [anon_sym_GT] = ACTIONS(4375),
    [anon_sym_where] = ACTIONS(4484),
    [anon_sym_QMARK] = ACTIONS(4375),
    [anon_sym_notnull] = ACTIONS(4484),
    [anon_sym_unmanaged] = ACTIONS(4484),
    [anon_sym_BANG] = ACTIONS(4375),
    [anon_sym_PLUS_PLUS] = ACTIONS(4373),
    [anon_sym_DASH_DASH] = ACTIONS(4373),
    [anon_sym_PLUS] = ACTIONS(4375),
    [anon_sym_DASH] = ACTIONS(4375),
    [anon_sym_STAR] = ACTIONS(4373),
    [anon_sym_SLASH] = ACTIONS(4375),
    [anon_sym_PERCENT] = ACTIONS(4373),
    [anon_sym_CARET] = ACTIONS(4373),
    [anon_sym_PIPE] = ACTIONS(4375),
    [anon_sym_AMP] = ACTIONS(4375),
    [anon_sym_LT_LT] = ACTIONS(4373),
    [anon_sym_GT_GT] = ACTIONS(4375),
    [anon_sym_GT_GT_GT] = ACTIONS(4373),
    [anon_sym_EQ_EQ] = ACTIONS(4373),
    [anon_sym_BANG_EQ] = ACTIONS(4373),
    [anon_sym_GT_EQ] = ACTIONS(4373),
    [anon_sym_LT_EQ] = ACTIONS(4373),
    [anon_sym_DOT] = ACTIONS(4375),
    [anon_sym_scoped] = ACTIONS(4484),
    [anon_sym_var] = ACTIONS(4484),
    [anon_sym_yield] = ACTIONS(4484),
    [anon_sym_switch] = ACTIONS(4375),
    [anon_sym_when] = ACTIONS(4484),
    [sym_discard] = ACTIONS(4488),
    [anon_sym_DOT_DOT] = ACTIONS(4373),
    [anon_sym_and] = ACTIONS(4375),
    [anon_sym_or] = ACTIONS(4375),
    [anon_sym_AMP_AMP] = ACTIONS(4373),
    [anon_sym_PIPE_PIPE] = ACTIONS(4373),
    [anon_sym_QMARK_QMARK] = ACTIONS(4373),
    [anon_sym_from] = ACTIONS(4484),
    [anon_sym_into] = ACTIONS(4484),
    [anon_sym_join] = ACTIONS(4484),
    [anon_sym_on] = ACTIONS(4484),
    [anon_sym_equals] = ACTIONS(4484),
    [anon_sym_let] = ACTIONS(4484),
    [anon_sym_orderby] = ACTIONS(4484),
    [anon_sym_ascending] = ACTIONS(4484),
    [anon_sym_descending] = ACTIONS(4484),
    [anon_sym_group] = ACTIONS(4484),
    [anon_sym_by] = ACTIONS(4484),
    [anon_sym_select] = ACTIONS(4484),
    [anon_sym_as] = ACTIONS(4375),
    [anon_sym_is] = ACTIONS(4375),
    [anon_sym_DASH_GT] = ACTIONS(4373),
    [anon_sym_with] = ACTIONS(4375),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4373),
  },
  [3112] = {
    [sym_modifier] = STATE(4545),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7270),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_identifier] = STATE(4921),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(3112),
    [sym_preproc_endregion] = STATE(3112),
    [sym_preproc_line] = STATE(3112),
    [sym_preproc_pragma] = STATE(3112),
    [sym_preproc_nullable] = STATE(3112),
    [sym_preproc_error] = STATE(3112),
    [sym_preproc_define] = STATE(3112),
    [sym_preproc_undef] = STATE(3112),
    [aux_sym_class_declaration_repeat2] = STATE(4360),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_unsafe] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(643),
    [anon_sym_LPAREN] = ACTIONS(2995),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(643),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(4687),
    [anon_sym_fixed] = ACTIONS(643),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(643),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3113] = {
    [sym__variable_designation] = STATE(5400),
    [sym_parenthesized_variable_designation] = STATE(5390),
    [sym_identifier] = STATE(5396),
    [sym__reserved_identifier] = STATE(5128),
    [sym_preproc_region] = STATE(3113),
    [sym_preproc_endregion] = STATE(3113),
    [sym_preproc_line] = STATE(3113),
    [sym_preproc_pragma] = STATE(3113),
    [sym_preproc_nullable] = STATE(3113),
    [sym_preproc_error] = STATE(3113),
    [sym_preproc_define] = STATE(3113),
    [sym_preproc_undef] = STATE(3113),
    [sym__identifier_token] = ACTIONS(4482),
    [anon_sym_alias] = ACTIONS(4484),
    [anon_sym_global] = ACTIONS(4484),
    [anon_sym_LBRACK] = ACTIONS(4329),
    [anon_sym_COLON] = ACTIONS(4329),
    [anon_sym_COMMA] = ACTIONS(4329),
    [anon_sym_LPAREN] = ACTIONS(4329),
    [anon_sym_file] = ACTIONS(4484),
    [anon_sym_LT] = ACTIONS(4331),
    [anon_sym_GT] = ACTIONS(4331),
    [anon_sym_where] = ACTIONS(4484),
    [anon_sym_QMARK] = ACTIONS(4331),
    [anon_sym_notnull] = ACTIONS(4484),
    [anon_sym_unmanaged] = ACTIONS(4484),
    [anon_sym_BANG] = ACTIONS(4331),
    [anon_sym_PLUS_PLUS] = ACTIONS(4329),
    [anon_sym_DASH_DASH] = ACTIONS(4329),
    [anon_sym_PLUS] = ACTIONS(4331),
    [anon_sym_DASH] = ACTIONS(4331),
    [anon_sym_STAR] = ACTIONS(4329),
    [anon_sym_SLASH] = ACTIONS(4331),
    [anon_sym_PERCENT] = ACTIONS(4329),
    [anon_sym_CARET] = ACTIONS(4329),
    [anon_sym_PIPE] = ACTIONS(4331),
    [anon_sym_AMP] = ACTIONS(4331),
    [anon_sym_LT_LT] = ACTIONS(4329),
    [anon_sym_GT_GT] = ACTIONS(4331),
    [anon_sym_GT_GT_GT] = ACTIONS(4329),
    [anon_sym_EQ_EQ] = ACTIONS(4329),
    [anon_sym_BANG_EQ] = ACTIONS(4329),
    [anon_sym_GT_EQ] = ACTIONS(4329),
    [anon_sym_LT_EQ] = ACTIONS(4329),
    [anon_sym_DOT] = ACTIONS(4331),
    [anon_sym_scoped] = ACTIONS(4484),
    [anon_sym_var] = ACTIONS(4484),
    [anon_sym_yield] = ACTIONS(4484),
    [anon_sym_switch] = ACTIONS(4331),
    [anon_sym_when] = ACTIONS(4484),
    [sym_discard] = ACTIONS(4488),
    [anon_sym_DOT_DOT] = ACTIONS(4329),
    [anon_sym_and] = ACTIONS(4331),
    [anon_sym_or] = ACTIONS(4331),
    [anon_sym_AMP_AMP] = ACTIONS(4329),
    [anon_sym_PIPE_PIPE] = ACTIONS(4329),
    [anon_sym_QMARK_QMARK] = ACTIONS(4329),
    [anon_sym_from] = ACTIONS(4484),
    [anon_sym_into] = ACTIONS(4484),
    [anon_sym_join] = ACTIONS(4484),
    [anon_sym_on] = ACTIONS(4484),
    [anon_sym_equals] = ACTIONS(4484),
    [anon_sym_let] = ACTIONS(4484),
    [anon_sym_orderby] = ACTIONS(4484),
    [anon_sym_ascending] = ACTIONS(4484),
    [anon_sym_descending] = ACTIONS(4484),
    [anon_sym_group] = ACTIONS(4484),
    [anon_sym_by] = ACTIONS(4484),
    [anon_sym_select] = ACTIONS(4484),
    [anon_sym_as] = ACTIONS(4331),
    [anon_sym_is] = ACTIONS(4331),
    [anon_sym_DASH_GT] = ACTIONS(4329),
    [anon_sym_with] = ACTIONS(4331),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4329),
  },
  [3114] = {
    [sym_property_pattern_clause] = STATE(3169),
    [sym__variable_designation] = STATE(4124),
    [sym_parenthesized_variable_designation] = STATE(4274),
    [sym_identifier] = STATE(4269),
    [sym__reserved_identifier] = STATE(3897),
    [sym_preproc_region] = STATE(3114),
    [sym_preproc_endregion] = STATE(3114),
    [sym_preproc_line] = STATE(3114),
    [sym_preproc_pragma] = STATE(3114),
    [sym_preproc_nullable] = STATE(3114),
    [sym_preproc_error] = STATE(3114),
    [sym_preproc_define] = STATE(3114),
    [sym_preproc_undef] = STATE(3114),
    [sym__identifier_token] = ACTIONS(4168),
    [anon_sym_alias] = ACTIONS(4170),
    [anon_sym_global] = ACTIONS(4170),
    [anon_sym_LBRACK] = ACTIONS(4335),
    [anon_sym_LPAREN] = ACTIONS(4335),
    [anon_sym_LBRACE] = ACTIONS(4277),
    [anon_sym_file] = ACTIONS(4170),
    [anon_sym_LT] = ACTIONS(4337),
    [anon_sym_GT] = ACTIONS(4337),
    [anon_sym_in] = ACTIONS(4337),
    [anon_sym_where] = ACTIONS(4170),
    [anon_sym_QMARK] = ACTIONS(4337),
    [anon_sym_notnull] = ACTIONS(4170),
    [anon_sym_unmanaged] = ACTIONS(4170),
    [anon_sym_BANG] = ACTIONS(4337),
    [anon_sym_PLUS_PLUS] = ACTIONS(4335),
    [anon_sym_DASH_DASH] = ACTIONS(4335),
    [anon_sym_PLUS] = ACTIONS(4337),
    [anon_sym_DASH] = ACTIONS(4337),
    [anon_sym_STAR] = ACTIONS(4335),
    [anon_sym_SLASH] = ACTIONS(4337),
    [anon_sym_PERCENT] = ACTIONS(4335),
    [anon_sym_CARET] = ACTIONS(4335),
    [anon_sym_PIPE] = ACTIONS(4337),
    [anon_sym_AMP] = ACTIONS(4337),
    [anon_sym_LT_LT] = ACTIONS(4335),
    [anon_sym_GT_GT] = ACTIONS(4337),
    [anon_sym_GT_GT_GT] = ACTIONS(4335),
    [anon_sym_EQ_EQ] = ACTIONS(4335),
    [anon_sym_BANG_EQ] = ACTIONS(4335),
    [anon_sym_GT_EQ] = ACTIONS(4335),
    [anon_sym_LT_EQ] = ACTIONS(4335),
    [anon_sym_DOT] = ACTIONS(4337),
    [anon_sym_scoped] = ACTIONS(4170),
    [anon_sym_var] = ACTIONS(4170),
    [anon_sym_yield] = ACTIONS(4170),
    [anon_sym_switch] = ACTIONS(4337),
    [anon_sym_when] = ACTIONS(4170),
    [sym_discard] = ACTIONS(4295),
    [anon_sym_DOT_DOT] = ACTIONS(4335),
    [anon_sym_and] = ACTIONS(4337),
    [anon_sym_or] = ACTIONS(4337),
    [anon_sym_AMP_AMP] = ACTIONS(4335),
    [anon_sym_PIPE_PIPE] = ACTIONS(4335),
    [anon_sym_QMARK_QMARK] = ACTIONS(4335),
    [anon_sym_from] = ACTIONS(4170),
    [anon_sym_into] = ACTIONS(4170),
    [anon_sym_join] = ACTIONS(4170),
    [anon_sym_on] = ACTIONS(4170),
    [anon_sym_equals] = ACTIONS(4170),
    [anon_sym_let] = ACTIONS(4170),
    [anon_sym_orderby] = ACTIONS(4170),
    [anon_sym_ascending] = ACTIONS(4170),
    [anon_sym_descending] = ACTIONS(4170),
    [anon_sym_group] = ACTIONS(4170),
    [anon_sym_by] = ACTIONS(4170),
    [anon_sym_select] = ACTIONS(4170),
    [anon_sym_as] = ACTIONS(4337),
    [anon_sym_is] = ACTIONS(4337),
    [anon_sym_DASH_GT] = ACTIONS(4335),
    [anon_sym_with] = ACTIONS(4337),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3115] = {
    [sym__variable_designation] = STATE(5425),
    [sym_parenthesized_variable_designation] = STATE(5390),
    [sym_identifier] = STATE(5396),
    [sym__reserved_identifier] = STATE(5128),
    [sym_preproc_region] = STATE(3115),
    [sym_preproc_endregion] = STATE(3115),
    [sym_preproc_line] = STATE(3115),
    [sym_preproc_pragma] = STATE(3115),
    [sym_preproc_nullable] = STATE(3115),
    [sym_preproc_error] = STATE(3115),
    [sym_preproc_define] = STATE(3115),
    [sym_preproc_undef] = STATE(3115),
    [sym__identifier_token] = ACTIONS(4482),
    [anon_sym_alias] = ACTIONS(4484),
    [anon_sym_global] = ACTIONS(4484),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON] = ACTIONS(4383),
    [anon_sym_COMMA] = ACTIONS(4383),
    [anon_sym_LPAREN] = ACTIONS(4383),
    [anon_sym_file] = ACTIONS(4484),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_where] = ACTIONS(4484),
    [anon_sym_QMARK] = ACTIONS(4385),
    [anon_sym_notnull] = ACTIONS(4484),
    [anon_sym_unmanaged] = ACTIONS(4484),
    [anon_sym_BANG] = ACTIONS(4385),
    [anon_sym_PLUS_PLUS] = ACTIONS(4383),
    [anon_sym_DASH_DASH] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_DASH] = ACTIONS(4385),
    [anon_sym_STAR] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4385),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4385),
    [anon_sym_GT_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4383),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_scoped] = ACTIONS(4484),
    [anon_sym_var] = ACTIONS(4484),
    [anon_sym_yield] = ACTIONS(4484),
    [anon_sym_switch] = ACTIONS(4385),
    [anon_sym_when] = ACTIONS(4484),
    [sym_discard] = ACTIONS(4488),
    [anon_sym_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4385),
    [anon_sym_or] = ACTIONS(4385),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_QMARK_QMARK] = ACTIONS(4383),
    [anon_sym_from] = ACTIONS(4484),
    [anon_sym_into] = ACTIONS(4385),
    [anon_sym_join] = ACTIONS(4484),
    [anon_sym_on] = ACTIONS(4484),
    [anon_sym_equals] = ACTIONS(4484),
    [anon_sym_let] = ACTIONS(4484),
    [anon_sym_orderby] = ACTIONS(4484),
    [anon_sym_ascending] = ACTIONS(4484),
    [anon_sym_descending] = ACTIONS(4484),
    [anon_sym_group] = ACTIONS(4484),
    [anon_sym_by] = ACTIONS(4484),
    [anon_sym_select] = ACTIONS(4484),
    [anon_sym_as] = ACTIONS(4385),
    [anon_sym_is] = ACTIONS(4385),
    [anon_sym_DASH_GT] = ACTIONS(4383),
    [anon_sym_with] = ACTIONS(4385),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4383),
  },
  [3116] = {
    [sym__variable_designation] = STATE(5411),
    [sym_parenthesized_variable_designation] = STATE(5390),
    [sym_identifier] = STATE(5396),
    [sym__reserved_identifier] = STATE(5128),
    [sym_preproc_region] = STATE(3116),
    [sym_preproc_endregion] = STATE(3116),
    [sym_preproc_line] = STATE(3116),
    [sym_preproc_pragma] = STATE(3116),
    [sym_preproc_nullable] = STATE(3116),
    [sym_preproc_error] = STATE(3116),
    [sym_preproc_define] = STATE(3116),
    [sym_preproc_undef] = STATE(3116),
    [sym__identifier_token] = ACTIONS(4482),
    [anon_sym_alias] = ACTIONS(4484),
    [anon_sym_global] = ACTIONS(4484),
    [anon_sym_LBRACK] = ACTIONS(4335),
    [anon_sym_COLON] = ACTIONS(4335),
    [anon_sym_COMMA] = ACTIONS(4335),
    [anon_sym_LPAREN] = ACTIONS(4335),
    [anon_sym_file] = ACTIONS(4484),
    [anon_sym_LT] = ACTIONS(4337),
    [anon_sym_GT] = ACTIONS(4337),
    [anon_sym_where] = ACTIONS(4484),
    [anon_sym_QMARK] = ACTIONS(4337),
    [anon_sym_notnull] = ACTIONS(4484),
    [anon_sym_unmanaged] = ACTIONS(4484),
    [anon_sym_BANG] = ACTIONS(4337),
    [anon_sym_PLUS_PLUS] = ACTIONS(4335),
    [anon_sym_DASH_DASH] = ACTIONS(4335),
    [anon_sym_PLUS] = ACTIONS(4337),
    [anon_sym_DASH] = ACTIONS(4337),
    [anon_sym_STAR] = ACTIONS(4335),
    [anon_sym_SLASH] = ACTIONS(4337),
    [anon_sym_PERCENT] = ACTIONS(4335),
    [anon_sym_CARET] = ACTIONS(4335),
    [anon_sym_PIPE] = ACTIONS(4337),
    [anon_sym_AMP] = ACTIONS(4337),
    [anon_sym_LT_LT] = ACTIONS(4335),
    [anon_sym_GT_GT] = ACTIONS(4337),
    [anon_sym_GT_GT_GT] = ACTIONS(4335),
    [anon_sym_EQ_EQ] = ACTIONS(4335),
    [anon_sym_BANG_EQ] = ACTIONS(4335),
    [anon_sym_GT_EQ] = ACTIONS(4335),
    [anon_sym_LT_EQ] = ACTIONS(4335),
    [anon_sym_DOT] = ACTIONS(4337),
    [anon_sym_scoped] = ACTIONS(4484),
    [anon_sym_var] = ACTIONS(4484),
    [anon_sym_yield] = ACTIONS(4484),
    [anon_sym_switch] = ACTIONS(4337),
    [anon_sym_when] = ACTIONS(4484),
    [sym_discard] = ACTIONS(4488),
    [anon_sym_DOT_DOT] = ACTIONS(4335),
    [anon_sym_and] = ACTIONS(4337),
    [anon_sym_or] = ACTIONS(4337),
    [anon_sym_AMP_AMP] = ACTIONS(4335),
    [anon_sym_PIPE_PIPE] = ACTIONS(4335),
    [anon_sym_QMARK_QMARK] = ACTIONS(4335),
    [anon_sym_from] = ACTIONS(4484),
    [anon_sym_into] = ACTIONS(4337),
    [anon_sym_join] = ACTIONS(4484),
    [anon_sym_on] = ACTIONS(4484),
    [anon_sym_equals] = ACTIONS(4484),
    [anon_sym_let] = ACTIONS(4484),
    [anon_sym_orderby] = ACTIONS(4484),
    [anon_sym_ascending] = ACTIONS(4484),
    [anon_sym_descending] = ACTIONS(4484),
    [anon_sym_group] = ACTIONS(4484),
    [anon_sym_by] = ACTIONS(4484),
    [anon_sym_select] = ACTIONS(4484),
    [anon_sym_as] = ACTIONS(4337),
    [anon_sym_is] = ACTIONS(4337),
    [anon_sym_DASH_GT] = ACTIONS(4335),
    [anon_sym_with] = ACTIONS(4337),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4335),
  },
  [3117] = {
    [sym__variable_designation] = STATE(5411),
    [sym_parenthesized_variable_designation] = STATE(5390),
    [sym_identifier] = STATE(5396),
    [sym__reserved_identifier] = STATE(5128),
    [sym_preproc_region] = STATE(3117),
    [sym_preproc_endregion] = STATE(3117),
    [sym_preproc_line] = STATE(3117),
    [sym_preproc_pragma] = STATE(3117),
    [sym_preproc_nullable] = STATE(3117),
    [sym_preproc_error] = STATE(3117),
    [sym_preproc_define] = STATE(3117),
    [sym_preproc_undef] = STATE(3117),
    [sym__identifier_token] = ACTIONS(4482),
    [anon_sym_alias] = ACTIONS(4484),
    [anon_sym_global] = ACTIONS(4484),
    [anon_sym_LBRACK] = ACTIONS(4335),
    [anon_sym_COLON] = ACTIONS(4335),
    [anon_sym_COMMA] = ACTIONS(4335),
    [anon_sym_LPAREN] = ACTIONS(4335),
    [anon_sym_file] = ACTIONS(4484),
    [anon_sym_LT] = ACTIONS(4337),
    [anon_sym_GT] = ACTIONS(4337),
    [anon_sym_where] = ACTIONS(4484),
    [anon_sym_QMARK] = ACTIONS(4337),
    [anon_sym_notnull] = ACTIONS(4484),
    [anon_sym_unmanaged] = ACTIONS(4484),
    [anon_sym_BANG] = ACTIONS(4337),
    [anon_sym_PLUS_PLUS] = ACTIONS(4335),
    [anon_sym_DASH_DASH] = ACTIONS(4335),
    [anon_sym_PLUS] = ACTIONS(4337),
    [anon_sym_DASH] = ACTIONS(4337),
    [anon_sym_STAR] = ACTIONS(4335),
    [anon_sym_SLASH] = ACTIONS(4337),
    [anon_sym_PERCENT] = ACTIONS(4335),
    [anon_sym_CARET] = ACTIONS(4335),
    [anon_sym_PIPE] = ACTIONS(4337),
    [anon_sym_AMP] = ACTIONS(4337),
    [anon_sym_LT_LT] = ACTIONS(4335),
    [anon_sym_GT_GT] = ACTIONS(4337),
    [anon_sym_GT_GT_GT] = ACTIONS(4335),
    [anon_sym_EQ_EQ] = ACTIONS(4335),
    [anon_sym_BANG_EQ] = ACTIONS(4335),
    [anon_sym_GT_EQ] = ACTIONS(4335),
    [anon_sym_LT_EQ] = ACTIONS(4335),
    [anon_sym_DOT] = ACTIONS(4337),
    [anon_sym_scoped] = ACTIONS(4484),
    [anon_sym_var] = ACTIONS(4484),
    [anon_sym_yield] = ACTIONS(4484),
    [anon_sym_switch] = ACTIONS(4337),
    [anon_sym_when] = ACTIONS(4484),
    [sym_discard] = ACTIONS(4488),
    [anon_sym_DOT_DOT] = ACTIONS(4335),
    [anon_sym_and] = ACTIONS(4337),
    [anon_sym_or] = ACTIONS(4337),
    [anon_sym_AMP_AMP] = ACTIONS(4335),
    [anon_sym_PIPE_PIPE] = ACTIONS(4335),
    [anon_sym_QMARK_QMARK] = ACTIONS(4335),
    [anon_sym_from] = ACTIONS(4484),
    [anon_sym_into] = ACTIONS(4484),
    [anon_sym_join] = ACTIONS(4484),
    [anon_sym_on] = ACTIONS(4484),
    [anon_sym_equals] = ACTIONS(4484),
    [anon_sym_let] = ACTIONS(4484),
    [anon_sym_orderby] = ACTIONS(4484),
    [anon_sym_ascending] = ACTIONS(4484),
    [anon_sym_descending] = ACTIONS(4484),
    [anon_sym_group] = ACTIONS(4484),
    [anon_sym_by] = ACTIONS(4484),
    [anon_sym_select] = ACTIONS(4484),
    [anon_sym_as] = ACTIONS(4337),
    [anon_sym_is] = ACTIONS(4337),
    [anon_sym_DASH_GT] = ACTIONS(4335),
    [anon_sym_with] = ACTIONS(4337),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4335),
  },
  [3118] = {
    [sym_modifier] = STATE(4545),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7328),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_identifier] = STATE(4921),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(3118),
    [sym_preproc_endregion] = STATE(3118),
    [sym_preproc_line] = STATE(3118),
    [sym_preproc_pragma] = STATE(3118),
    [sym_preproc_nullable] = STATE(3118),
    [sym_preproc_error] = STATE(3118),
    [sym_preproc_define] = STATE(3118),
    [sym_preproc_undef] = STATE(3118),
    [aux_sym_class_declaration_repeat2] = STATE(4360),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_unsafe] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(643),
    [anon_sym_LPAREN] = ACTIONS(2995),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(643),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(4687),
    [anon_sym_fixed] = ACTIONS(643),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(643),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3119] = {
    [sym_property_pattern_clause] = STATE(3173),
    [sym__variable_designation] = STATE(4256),
    [sym_parenthesized_variable_designation] = STATE(4274),
    [sym_identifier] = STATE(4269),
    [sym__reserved_identifier] = STATE(3897),
    [sym_preproc_region] = STATE(3119),
    [sym_preproc_endregion] = STATE(3119),
    [sym_preproc_line] = STATE(3119),
    [sym_preproc_pragma] = STATE(3119),
    [sym_preproc_nullable] = STATE(3119),
    [sym_preproc_error] = STATE(3119),
    [sym_preproc_define] = STATE(3119),
    [sym_preproc_undef] = STATE(3119),
    [sym__identifier_token] = ACTIONS(4168),
    [anon_sym_alias] = ACTIONS(4170),
    [anon_sym_global] = ACTIONS(4170),
    [anon_sym_LBRACK] = ACTIONS(4329),
    [anon_sym_LPAREN] = ACTIONS(4329),
    [anon_sym_LBRACE] = ACTIONS(4277),
    [anon_sym_file] = ACTIONS(4170),
    [anon_sym_LT] = ACTIONS(4331),
    [anon_sym_GT] = ACTIONS(4331),
    [anon_sym_in] = ACTIONS(4331),
    [anon_sym_where] = ACTIONS(4170),
    [anon_sym_QMARK] = ACTIONS(4331),
    [anon_sym_notnull] = ACTIONS(4170),
    [anon_sym_unmanaged] = ACTIONS(4170),
    [anon_sym_BANG] = ACTIONS(4331),
    [anon_sym_PLUS_PLUS] = ACTIONS(4329),
    [anon_sym_DASH_DASH] = ACTIONS(4329),
    [anon_sym_PLUS] = ACTIONS(4331),
    [anon_sym_DASH] = ACTIONS(4331),
    [anon_sym_STAR] = ACTIONS(4329),
    [anon_sym_SLASH] = ACTIONS(4331),
    [anon_sym_PERCENT] = ACTIONS(4329),
    [anon_sym_CARET] = ACTIONS(4329),
    [anon_sym_PIPE] = ACTIONS(4331),
    [anon_sym_AMP] = ACTIONS(4331),
    [anon_sym_LT_LT] = ACTIONS(4329),
    [anon_sym_GT_GT] = ACTIONS(4331),
    [anon_sym_GT_GT_GT] = ACTIONS(4329),
    [anon_sym_EQ_EQ] = ACTIONS(4329),
    [anon_sym_BANG_EQ] = ACTIONS(4329),
    [anon_sym_GT_EQ] = ACTIONS(4329),
    [anon_sym_LT_EQ] = ACTIONS(4329),
    [anon_sym_DOT] = ACTIONS(4331),
    [anon_sym_scoped] = ACTIONS(4170),
    [anon_sym_var] = ACTIONS(4170),
    [anon_sym_yield] = ACTIONS(4170),
    [anon_sym_switch] = ACTIONS(4331),
    [anon_sym_when] = ACTIONS(4170),
    [sym_discard] = ACTIONS(4295),
    [anon_sym_DOT_DOT] = ACTIONS(4329),
    [anon_sym_and] = ACTIONS(4331),
    [anon_sym_or] = ACTIONS(4331),
    [anon_sym_AMP_AMP] = ACTIONS(4329),
    [anon_sym_PIPE_PIPE] = ACTIONS(4329),
    [anon_sym_QMARK_QMARK] = ACTIONS(4329),
    [anon_sym_from] = ACTIONS(4170),
    [anon_sym_into] = ACTIONS(4170),
    [anon_sym_join] = ACTIONS(4170),
    [anon_sym_on] = ACTIONS(4170),
    [anon_sym_equals] = ACTIONS(4170),
    [anon_sym_let] = ACTIONS(4170),
    [anon_sym_orderby] = ACTIONS(4170),
    [anon_sym_ascending] = ACTIONS(4170),
    [anon_sym_descending] = ACTIONS(4170),
    [anon_sym_group] = ACTIONS(4170),
    [anon_sym_by] = ACTIONS(4170),
    [anon_sym_select] = ACTIONS(4170),
    [anon_sym_as] = ACTIONS(4331),
    [anon_sym_is] = ACTIONS(4331),
    [anon_sym_DASH_GT] = ACTIONS(4329),
    [anon_sym_with] = ACTIONS(4331),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3120] = {
    [sym__variable_designation] = STATE(5425),
    [sym_parenthesized_variable_designation] = STATE(5390),
    [sym_identifier] = STATE(5396),
    [sym__reserved_identifier] = STATE(5128),
    [sym_preproc_region] = STATE(3120),
    [sym_preproc_endregion] = STATE(3120),
    [sym_preproc_line] = STATE(3120),
    [sym_preproc_pragma] = STATE(3120),
    [sym_preproc_nullable] = STATE(3120),
    [sym_preproc_error] = STATE(3120),
    [sym_preproc_define] = STATE(3120),
    [sym_preproc_undef] = STATE(3120),
    [sym__identifier_token] = ACTIONS(4482),
    [anon_sym_alias] = ACTIONS(4484),
    [anon_sym_global] = ACTIONS(4484),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON] = ACTIONS(4383),
    [anon_sym_COMMA] = ACTIONS(4383),
    [anon_sym_LPAREN] = ACTIONS(4383),
    [anon_sym_file] = ACTIONS(4484),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_where] = ACTIONS(4484),
    [anon_sym_QMARK] = ACTIONS(4385),
    [anon_sym_notnull] = ACTIONS(4484),
    [anon_sym_unmanaged] = ACTIONS(4484),
    [anon_sym_BANG] = ACTIONS(4385),
    [anon_sym_PLUS_PLUS] = ACTIONS(4383),
    [anon_sym_DASH_DASH] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_DASH] = ACTIONS(4385),
    [anon_sym_STAR] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4385),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4385),
    [anon_sym_GT_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4383),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_scoped] = ACTIONS(4484),
    [anon_sym_var] = ACTIONS(4484),
    [anon_sym_yield] = ACTIONS(4484),
    [anon_sym_switch] = ACTIONS(4385),
    [anon_sym_when] = ACTIONS(4484),
    [sym_discard] = ACTIONS(4488),
    [anon_sym_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4385),
    [anon_sym_or] = ACTIONS(4385),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_QMARK_QMARK] = ACTIONS(4383),
    [anon_sym_from] = ACTIONS(4484),
    [anon_sym_into] = ACTIONS(4484),
    [anon_sym_join] = ACTIONS(4484),
    [anon_sym_on] = ACTIONS(4484),
    [anon_sym_equals] = ACTIONS(4484),
    [anon_sym_let] = ACTIONS(4484),
    [anon_sym_orderby] = ACTIONS(4484),
    [anon_sym_ascending] = ACTIONS(4484),
    [anon_sym_descending] = ACTIONS(4484),
    [anon_sym_group] = ACTIONS(4484),
    [anon_sym_by] = ACTIONS(4484),
    [anon_sym_select] = ACTIONS(4484),
    [anon_sym_as] = ACTIONS(4385),
    [anon_sym_is] = ACTIONS(4385),
    [anon_sym_DASH_GT] = ACTIONS(4383),
    [anon_sym_with] = ACTIONS(4385),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4383),
  },
  [3121] = {
    [sym_modifier] = STATE(4545),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7360),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_identifier] = STATE(4921),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(3121),
    [sym_preproc_endregion] = STATE(3121),
    [sym_preproc_line] = STATE(3121),
    [sym_preproc_pragma] = STATE(3121),
    [sym_preproc_nullable] = STATE(3121),
    [sym_preproc_error] = STATE(3121),
    [sym_preproc_define] = STATE(3121),
    [sym_preproc_undef] = STATE(3121),
    [aux_sym_class_declaration_repeat2] = STATE(4360),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_unsafe] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(643),
    [anon_sym_LPAREN] = ACTIONS(2995),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(643),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(4687),
    [anon_sym_fixed] = ACTIONS(643),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(643),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3122] = {
    [sym_modifier] = STATE(4545),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7333),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_identifier] = STATE(4921),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(3122),
    [sym_preproc_endregion] = STATE(3122),
    [sym_preproc_line] = STATE(3122),
    [sym_preproc_pragma] = STATE(3122),
    [sym_preproc_nullable] = STATE(3122),
    [sym_preproc_error] = STATE(3122),
    [sym_preproc_define] = STATE(3122),
    [sym_preproc_undef] = STATE(3122),
    [aux_sym_class_declaration_repeat2] = STATE(4360),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_extern] = ACTIONS(643),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_unsafe] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(643),
    [anon_sym_LPAREN] = ACTIONS(2995),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(643),
    [anon_sym_const] = ACTIONS(643),
    [anon_sym_file] = ACTIONS(4687),
    [anon_sym_fixed] = ACTIONS(643),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(643),
    [anon_sym_override] = ACTIONS(643),
    [anon_sym_partial] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_required] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_virtual] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3123] = {
    [sym_property_pattern_clause] = STATE(3162),
    [sym__variable_designation] = STATE(4650),
    [sym_parenthesized_variable_designation] = STATE(4614),
    [sym_identifier] = STATE(4624),
    [sym__reserved_identifier] = STATE(2914),
    [sym_preproc_region] = STATE(3123),
    [sym_preproc_endregion] = STATE(3123),
    [sym_preproc_line] = STATE(3123),
    [sym_preproc_pragma] = STATE(3123),
    [sym_preproc_nullable] = STATE(3123),
    [sym_preproc_error] = STATE(3123),
    [sym_preproc_define] = STATE(3123),
    [sym_preproc_undef] = STATE(3123),
    [sym__identifier_token] = ACTIONS(4490),
    [anon_sym_alias] = ACTIONS(4492),
    [anon_sym_global] = ACTIONS(4492),
    [anon_sym_LBRACK] = ACTIONS(4329),
    [anon_sym_COMMA] = ACTIONS(4329),
    [anon_sym_LPAREN] = ACTIONS(4329),
    [anon_sym_LBRACE] = ACTIONS(4277),
    [anon_sym_file] = ACTIONS(4492),
    [anon_sym_LT] = ACTIONS(4331),
    [anon_sym_GT] = ACTIONS(4331),
    [anon_sym_where] = ACTIONS(4331),
    [anon_sym_QMARK] = ACTIONS(4331),
    [anon_sym_notnull] = ACTIONS(4492),
    [anon_sym_unmanaged] = ACTIONS(4492),
    [anon_sym_BANG] = ACTIONS(4331),
    [anon_sym_PLUS_PLUS] = ACTIONS(4329),
    [anon_sym_DASH_DASH] = ACTIONS(4329),
    [anon_sym_PLUS] = ACTIONS(4331),
    [anon_sym_DASH] = ACTIONS(4331),
    [anon_sym_STAR] = ACTIONS(4329),
    [anon_sym_SLASH] = ACTIONS(4331),
    [anon_sym_PERCENT] = ACTIONS(4329),
    [anon_sym_CARET] = ACTIONS(4329),
    [anon_sym_PIPE] = ACTIONS(4331),
    [anon_sym_AMP] = ACTIONS(4331),
    [anon_sym_LT_LT] = ACTIONS(4329),
    [anon_sym_GT_GT] = ACTIONS(4331),
    [anon_sym_GT_GT_GT] = ACTIONS(4329),
    [anon_sym_EQ_EQ] = ACTIONS(4329),
    [anon_sym_BANG_EQ] = ACTIONS(4329),
    [anon_sym_GT_EQ] = ACTIONS(4329),
    [anon_sym_LT_EQ] = ACTIONS(4329),
    [anon_sym_DOT] = ACTIONS(4331),
    [anon_sym_scoped] = ACTIONS(4492),
    [anon_sym_var] = ACTIONS(4492),
    [anon_sym_yield] = ACTIONS(4492),
    [anon_sym_switch] = ACTIONS(4331),
    [anon_sym_when] = ACTIONS(4492),
    [sym_discard] = ACTIONS(4647),
    [anon_sym_DOT_DOT] = ACTIONS(4329),
    [anon_sym_and] = ACTIONS(4331),
    [anon_sym_or] = ACTIONS(4331),
    [anon_sym_AMP_AMP] = ACTIONS(4329),
    [anon_sym_PIPE_PIPE] = ACTIONS(4329),
    [anon_sym_QMARK_QMARK] = ACTIONS(4329),
    [anon_sym_from] = ACTIONS(4331),
    [anon_sym_into] = ACTIONS(4492),
    [anon_sym_join] = ACTIONS(4331),
    [anon_sym_on] = ACTIONS(4492),
    [anon_sym_equals] = ACTIONS(4492),
    [anon_sym_let] = ACTIONS(4331),
    [anon_sym_orderby] = ACTIONS(4331),
    [anon_sym_ascending] = ACTIONS(4331),
    [anon_sym_descending] = ACTIONS(4331),
    [anon_sym_group] = ACTIONS(4331),
    [anon_sym_by] = ACTIONS(4492),
    [anon_sym_select] = ACTIONS(4331),
    [anon_sym_as] = ACTIONS(4331),
    [anon_sym_is] = ACTIONS(4331),
    [anon_sym_DASH_GT] = ACTIONS(4329),
    [anon_sym_with] = ACTIONS(4331),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3124] = {
    [sym__variable_designation] = STATE(5400),
    [sym_parenthesized_variable_designation] = STATE(5390),
    [sym_identifier] = STATE(5396),
    [sym__reserved_identifier] = STATE(5128),
    [sym_preproc_region] = STATE(3124),
    [sym_preproc_endregion] = STATE(3124),
    [sym_preproc_line] = STATE(3124),
    [sym_preproc_pragma] = STATE(3124),
    [sym_preproc_nullable] = STATE(3124),
    [sym_preproc_error] = STATE(3124),
    [sym_preproc_define] = STATE(3124),
    [sym_preproc_undef] = STATE(3124),
    [sym__identifier_token] = ACTIONS(4482),
    [anon_sym_alias] = ACTIONS(4484),
    [anon_sym_global] = ACTIONS(4484),
    [anon_sym_LBRACK] = ACTIONS(4329),
    [anon_sym_COLON] = ACTIONS(4329),
    [anon_sym_COMMA] = ACTIONS(4329),
    [anon_sym_LPAREN] = ACTIONS(4329),
    [anon_sym_file] = ACTIONS(4484),
    [anon_sym_LT] = ACTIONS(4331),
    [anon_sym_GT] = ACTIONS(4331),
    [anon_sym_where] = ACTIONS(4484),
    [anon_sym_QMARK] = ACTIONS(4331),
    [anon_sym_notnull] = ACTIONS(4484),
    [anon_sym_unmanaged] = ACTIONS(4484),
    [anon_sym_BANG] = ACTIONS(4331),
    [anon_sym_PLUS_PLUS] = ACTIONS(4329),
    [anon_sym_DASH_DASH] = ACTIONS(4329),
    [anon_sym_PLUS] = ACTIONS(4331),
    [anon_sym_DASH] = ACTIONS(4331),
    [anon_sym_STAR] = ACTIONS(4329),
    [anon_sym_SLASH] = ACTIONS(4331),
    [anon_sym_PERCENT] = ACTIONS(4329),
    [anon_sym_CARET] = ACTIONS(4329),
    [anon_sym_PIPE] = ACTIONS(4331),
    [anon_sym_AMP] = ACTIONS(4331),
    [anon_sym_LT_LT] = ACTIONS(4329),
    [anon_sym_GT_GT] = ACTIONS(4331),
    [anon_sym_GT_GT_GT] = ACTIONS(4329),
    [anon_sym_EQ_EQ] = ACTIONS(4329),
    [anon_sym_BANG_EQ] = ACTIONS(4329),
    [anon_sym_GT_EQ] = ACTIONS(4329),
    [anon_sym_LT_EQ] = ACTIONS(4329),
    [anon_sym_DOT] = ACTIONS(4331),
    [anon_sym_scoped] = ACTIONS(4484),
    [anon_sym_var] = ACTIONS(4484),
    [anon_sym_yield] = ACTIONS(4484),
    [anon_sym_switch] = ACTIONS(4331),
    [anon_sym_when] = ACTIONS(4484),
    [sym_discard] = ACTIONS(4488),
    [anon_sym_DOT_DOT] = ACTIONS(4329),
    [anon_sym_and] = ACTIONS(4331),
    [anon_sym_or] = ACTIONS(4331),
    [anon_sym_AMP_AMP] = ACTIONS(4329),
    [anon_sym_PIPE_PIPE] = ACTIONS(4329),
    [anon_sym_QMARK_QMARK] = ACTIONS(4329),
    [anon_sym_from] = ACTIONS(4484),
    [anon_sym_into] = ACTIONS(4331),
    [anon_sym_join] = ACTIONS(4484),
    [anon_sym_on] = ACTIONS(4484),
    [anon_sym_equals] = ACTIONS(4484),
    [anon_sym_let] = ACTIONS(4484),
    [anon_sym_orderby] = ACTIONS(4484),
    [anon_sym_ascending] = ACTIONS(4484),
    [anon_sym_descending] = ACTIONS(4484),
    [anon_sym_group] = ACTIONS(4484),
    [anon_sym_by] = ACTIONS(4484),
    [anon_sym_select] = ACTIONS(4484),
    [anon_sym_as] = ACTIONS(4331),
    [anon_sym_is] = ACTIONS(4331),
    [anon_sym_DASH_GT] = ACTIONS(4329),
    [anon_sym_with] = ACTIONS(4331),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4329),
  },
  [3125] = {
    [sym_property_pattern_clause] = STATE(3199),
    [sym__variable_designation] = STATE(4693),
    [sym_parenthesized_variable_designation] = STATE(4614),
    [sym_identifier] = STATE(4624),
    [sym__reserved_identifier] = STATE(2914),
    [sym_preproc_region] = STATE(3125),
    [sym_preproc_endregion] = STATE(3125),
    [sym_preproc_line] = STATE(3125),
    [sym_preproc_pragma] = STATE(3125),
    [sym_preproc_nullable] = STATE(3125),
    [sym_preproc_error] = STATE(3125),
    [sym_preproc_define] = STATE(3125),
    [sym_preproc_undef] = STATE(3125),
    [sym__identifier_token] = ACTIONS(4490),
    [anon_sym_alias] = ACTIONS(4492),
    [anon_sym_global] = ACTIONS(4492),
    [anon_sym_LBRACK] = ACTIONS(4335),
    [anon_sym_COMMA] = ACTIONS(4335),
    [anon_sym_LPAREN] = ACTIONS(4335),
    [anon_sym_LBRACE] = ACTIONS(4277),
    [anon_sym_file] = ACTIONS(4492),
    [anon_sym_LT] = ACTIONS(4337),
    [anon_sym_GT] = ACTIONS(4337),
    [anon_sym_where] = ACTIONS(4337),
    [anon_sym_QMARK] = ACTIONS(4337),
    [anon_sym_notnull] = ACTIONS(4492),
    [anon_sym_unmanaged] = ACTIONS(4492),
    [anon_sym_BANG] = ACTIONS(4337),
    [anon_sym_PLUS_PLUS] = ACTIONS(4335),
    [anon_sym_DASH_DASH] = ACTIONS(4335),
    [anon_sym_PLUS] = ACTIONS(4337),
    [anon_sym_DASH] = ACTIONS(4337),
    [anon_sym_STAR] = ACTIONS(4335),
    [anon_sym_SLASH] = ACTIONS(4337),
    [anon_sym_PERCENT] = ACTIONS(4335),
    [anon_sym_CARET] = ACTIONS(4335),
    [anon_sym_PIPE] = ACTIONS(4337),
    [anon_sym_AMP] = ACTIONS(4337),
    [anon_sym_LT_LT] = ACTIONS(4335),
    [anon_sym_GT_GT] = ACTIONS(4337),
    [anon_sym_GT_GT_GT] = ACTIONS(4335),
    [anon_sym_EQ_EQ] = ACTIONS(4335),
    [anon_sym_BANG_EQ] = ACTIONS(4335),
    [anon_sym_GT_EQ] = ACTIONS(4335),
    [anon_sym_LT_EQ] = ACTIONS(4335),
    [anon_sym_DOT] = ACTIONS(4337),
    [anon_sym_scoped] = ACTIONS(4492),
    [anon_sym_var] = ACTIONS(4492),
    [anon_sym_yield] = ACTIONS(4492),
    [anon_sym_switch] = ACTIONS(4337),
    [anon_sym_when] = ACTIONS(4492),
    [sym_discard] = ACTIONS(4647),
    [anon_sym_DOT_DOT] = ACTIONS(4335),
    [anon_sym_and] = ACTIONS(4337),
    [anon_sym_or] = ACTIONS(4337),
    [anon_sym_AMP_AMP] = ACTIONS(4335),
    [anon_sym_PIPE_PIPE] = ACTIONS(4335),
    [anon_sym_QMARK_QMARK] = ACTIONS(4335),
    [anon_sym_from] = ACTIONS(4337),
    [anon_sym_into] = ACTIONS(4337),
    [anon_sym_join] = ACTIONS(4337),
    [anon_sym_on] = ACTIONS(4492),
    [anon_sym_equals] = ACTIONS(4492),
    [anon_sym_let] = ACTIONS(4337),
    [anon_sym_orderby] = ACTIONS(4337),
    [anon_sym_ascending] = ACTIONS(4337),
    [anon_sym_descending] = ACTIONS(4337),
    [anon_sym_group] = ACTIONS(4337),
    [anon_sym_by] = ACTIONS(4492),
    [anon_sym_select] = ACTIONS(4337),
    [anon_sym_as] = ACTIONS(4337),
    [anon_sym_is] = ACTIONS(4337),
    [anon_sym_DASH_GT] = ACTIONS(4335),
    [anon_sym_with] = ACTIONS(4337),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3126] = {
    [sym_type_argument_list] = STATE(2943),
    [sym_preproc_region] = STATE(3126),
    [sym_preproc_endregion] = STATE(3126),
    [sym_preproc_line] = STATE(3126),
    [sym_preproc_pragma] = STATE(3126),
    [sym_preproc_nullable] = STATE(3126),
    [sym_preproc_error] = STATE(3126),
    [sym_preproc_define] = STATE(3126),
    [sym_preproc_undef] = STATE(3126),
    [sym__identifier_token] = ACTIONS(4074),
    [anon_sym_alias] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4076),
    [anon_sym_COLON] = ACTIONS(4074),
    [anon_sym_COMMA] = ACTIONS(4076),
    [anon_sym_LPAREN] = ACTIONS(4076),
    [anon_sym_RPAREN] = ACTIONS(4076),
    [anon_sym_LBRACE] = ACTIONS(4076),
    [anon_sym_RBRACE] = ACTIONS(4076),
    [anon_sym_file] = ACTIONS(4074),
    [anon_sym_LT] = ACTIONS(4446),
    [anon_sym_GT] = ACTIONS(4074),
    [anon_sym_where] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(4074),
    [anon_sym_notnull] = ACTIONS(4074),
    [anon_sym_unmanaged] = ACTIONS(4074),
    [anon_sym_BANG] = ACTIONS(4074),
    [anon_sym_PLUS_PLUS] = ACTIONS(4076),
    [anon_sym_DASH_DASH] = ACTIONS(4076),
    [anon_sym_PLUS] = ACTIONS(4074),
    [anon_sym_DASH] = ACTIONS(4074),
    [anon_sym_STAR] = ACTIONS(4076),
    [anon_sym_SLASH] = ACTIONS(4074),
    [anon_sym_PERCENT] = ACTIONS(4076),
    [anon_sym_CARET] = ACTIONS(4076),
    [anon_sym_PIPE] = ACTIONS(4074),
    [anon_sym_AMP] = ACTIONS(4074),
    [anon_sym_LT_LT] = ACTIONS(4076),
    [anon_sym_GT_GT] = ACTIONS(4074),
    [anon_sym_GT_GT_GT] = ACTIONS(4076),
    [anon_sym_EQ_EQ] = ACTIONS(4076),
    [anon_sym_BANG_EQ] = ACTIONS(4076),
    [anon_sym_GT_EQ] = ACTIONS(4076),
    [anon_sym_LT_EQ] = ACTIONS(4076),
    [anon_sym_DOT] = ACTIONS(4074),
    [anon_sym_scoped] = ACTIONS(4074),
    [anon_sym_COLON_COLON] = ACTIONS(4166),
    [anon_sym_var] = ACTIONS(4074),
    [anon_sym_yield] = ACTIONS(4074),
    [anon_sym_switch] = ACTIONS(4074),
    [anon_sym_when] = ACTIONS(4074),
    [sym_discard] = ACTIONS(4074),
    [anon_sym_DOT_DOT] = ACTIONS(4076),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_AMP_AMP] = ACTIONS(4076),
    [anon_sym_PIPE_PIPE] = ACTIONS(4076),
    [anon_sym_QMARK_QMARK] = ACTIONS(4076),
    [anon_sym_from] = ACTIONS(4074),
    [anon_sym_into] = ACTIONS(4074),
    [anon_sym_join] = ACTIONS(4074),
    [anon_sym_on] = ACTIONS(4074),
    [anon_sym_equals] = ACTIONS(4074),
    [anon_sym_let] = ACTIONS(4074),
    [anon_sym_orderby] = ACTIONS(4074),
    [anon_sym_ascending] = ACTIONS(4074),
    [anon_sym_descending] = ACTIONS(4074),
    [anon_sym_group] = ACTIONS(4074),
    [anon_sym_by] = ACTIONS(4074),
    [anon_sym_select] = ACTIONS(4074),
    [anon_sym_as] = ACTIONS(4074),
    [anon_sym_is] = ACTIONS(4074),
    [anon_sym_DASH_GT] = ACTIONS(4076),
    [anon_sym_with] = ACTIONS(4074),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3127] = {
    [sym_preproc_region] = STATE(3127),
    [sym_preproc_endregion] = STATE(3127),
    [sym_preproc_line] = STATE(3127),
    [sym_preproc_pragma] = STATE(3127),
    [sym_preproc_nullable] = STATE(3127),
    [sym_preproc_error] = STATE(3127),
    [sym_preproc_define] = STATE(3127),
    [sym_preproc_undef] = STATE(3127),
    [anon_sym_SEMI] = ACTIONS(4058),
    [anon_sym_EQ] = ACTIONS(4056),
    [anon_sym_LBRACK] = ACTIONS(4058),
    [anon_sym_COLON] = ACTIONS(4058),
    [anon_sym_COMMA] = ACTIONS(4058),
    [anon_sym_RBRACK] = ACTIONS(4058),
    [anon_sym_LPAREN] = ACTIONS(4058),
    [anon_sym_RPAREN] = ACTIONS(4058),
    [anon_sym_LBRACE] = ACTIONS(4058),
    [anon_sym_RBRACE] = ACTIONS(4058),
    [anon_sym_LT] = ACTIONS(4056),
    [anon_sym_GT] = ACTIONS(4056),
    [anon_sym_in] = ACTIONS(4058),
    [anon_sym_where] = ACTIONS(4058),
    [anon_sym_QMARK] = ACTIONS(4056),
    [anon_sym_BANG] = ACTIONS(4056),
    [anon_sym_PLUS_PLUS] = ACTIONS(4058),
    [anon_sym_DASH_DASH] = ACTIONS(4058),
    [anon_sym_PLUS] = ACTIONS(4056),
    [anon_sym_DASH] = ACTIONS(4056),
    [anon_sym_STAR] = ACTIONS(4056),
    [anon_sym_SLASH] = ACTIONS(4056),
    [anon_sym_PERCENT] = ACTIONS(4056),
    [anon_sym_CARET] = ACTIONS(4056),
    [anon_sym_PIPE] = ACTIONS(4056),
    [anon_sym_AMP] = ACTIONS(4056),
    [anon_sym_LT_LT] = ACTIONS(4056),
    [anon_sym_GT_GT] = ACTIONS(4056),
    [anon_sym_GT_GT_GT] = ACTIONS(4056),
    [anon_sym_EQ_EQ] = ACTIONS(4058),
    [anon_sym_BANG_EQ] = ACTIONS(4058),
    [anon_sym_GT_EQ] = ACTIONS(4058),
    [anon_sym_LT_EQ] = ACTIONS(4058),
    [anon_sym_DOT] = ACTIONS(4056),
    [anon_sym_EQ_GT] = ACTIONS(4058),
    [anon_sym_switch] = ACTIONS(4058),
    [anon_sym_when] = ACTIONS(4058),
    [anon_sym_DOT_DOT] = ACTIONS(4058),
    [anon_sym_and] = ACTIONS(4058),
    [anon_sym_or] = ACTIONS(4058),
    [anon_sym_PLUS_EQ] = ACTIONS(4058),
    [anon_sym_DASH_EQ] = ACTIONS(4058),
    [anon_sym_STAR_EQ] = ACTIONS(4058),
    [anon_sym_SLASH_EQ] = ACTIONS(4058),
    [anon_sym_PERCENT_EQ] = ACTIONS(4058),
    [anon_sym_AMP_EQ] = ACTIONS(4058),
    [anon_sym_CARET_EQ] = ACTIONS(4058),
    [anon_sym_PIPE_EQ] = ACTIONS(4058),
    [anon_sym_LT_LT_EQ] = ACTIONS(4058),
    [anon_sym_GT_GT_EQ] = ACTIONS(4058),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4058),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4058),
    [anon_sym_AMP_AMP] = ACTIONS(4058),
    [anon_sym_PIPE_PIPE] = ACTIONS(4058),
    [anon_sym_QMARK_QMARK] = ACTIONS(4056),
    [anon_sym_on] = ACTIONS(4058),
    [anon_sym_equals] = ACTIONS(4058),
    [anon_sym_by] = ACTIONS(4058),
    [anon_sym_as] = ACTIONS(4058),
    [anon_sym_is] = ACTIONS(4058),
    [anon_sym_DASH_GT] = ACTIONS(4058),
    [anon_sym_with] = ACTIONS(4058),
    [aux_sym_preproc_if_token3] = ACTIONS(4058),
    [aux_sym_preproc_else_token1] = ACTIONS(4058),
    [aux_sym_preproc_elif_token1] = ACTIONS(4058),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3128] = {
    [sym_preproc_region] = STATE(3128),
    [sym_preproc_endregion] = STATE(3128),
    [sym_preproc_line] = STATE(3128),
    [sym_preproc_pragma] = STATE(3128),
    [sym_preproc_nullable] = STATE(3128),
    [sym_preproc_error] = STATE(3128),
    [sym_preproc_define] = STATE(3128),
    [sym_preproc_undef] = STATE(3128),
    [sym__identifier_token] = ACTIONS(3347),
    [anon_sym_extern] = ACTIONS(3347),
    [anon_sym_alias] = ACTIONS(3347),
    [anon_sym_global] = ACTIONS(3347),
    [anon_sym_using] = ACTIONS(3347),
    [anon_sym_unsafe] = ACTIONS(3347),
    [anon_sym_static] = ACTIONS(3347),
    [anon_sym_LBRACK] = ACTIONS(3349),
    [anon_sym_LPAREN] = ACTIONS(3349),
    [anon_sym_event] = ACTIONS(3347),
    [anon_sym_namespace] = ACTIONS(3347),
    [anon_sym_class] = ACTIONS(3347),
    [anon_sym_ref] = ACTIONS(3347),
    [anon_sym_struct] = ACTIONS(3347),
    [anon_sym_enum] = ACTIONS(3347),
    [anon_sym_RBRACE] = ACTIONS(3349),
    [anon_sym_interface] = ACTIONS(3347),
    [anon_sym_delegate] = ACTIONS(3347),
    [anon_sym_record] = ACTIONS(3347),
    [anon_sym_abstract] = ACTIONS(3347),
    [anon_sym_async] = ACTIONS(3347),
    [anon_sym_const] = ACTIONS(3347),
    [anon_sym_file] = ACTIONS(3347),
    [anon_sym_fixed] = ACTIONS(3347),
    [anon_sym_internal] = ACTIONS(3347),
    [anon_sym_new] = ACTIONS(3347),
    [anon_sym_override] = ACTIONS(3347),
    [anon_sym_partial] = ACTIONS(3347),
    [anon_sym_private] = ACTIONS(3347),
    [anon_sym_protected] = ACTIONS(3347),
    [anon_sym_public] = ACTIONS(3347),
    [anon_sym_readonly] = ACTIONS(3347),
    [anon_sym_required] = ACTIONS(3347),
    [anon_sym_sealed] = ACTIONS(3347),
    [anon_sym_virtual] = ACTIONS(3347),
    [anon_sym_volatile] = ACTIONS(3347),
    [anon_sym_where] = ACTIONS(3347),
    [anon_sym_notnull] = ACTIONS(3347),
    [anon_sym_unmanaged] = ACTIONS(3347),
    [anon_sym_TILDE] = ACTIONS(3349),
    [anon_sym_implicit] = ACTIONS(3347),
    [anon_sym_explicit] = ACTIONS(3347),
    [anon_sym_scoped] = ACTIONS(3347),
    [anon_sym_var] = ACTIONS(3347),
    [sym_predefined_type] = ACTIONS(3347),
    [anon_sym_while] = ACTIONS(3347),
    [anon_sym_yield] = ACTIONS(3347),
    [anon_sym_when] = ACTIONS(3347),
    [anon_sym_else] = ACTIONS(3347),
    [anon_sym_from] = ACTIONS(3347),
    [anon_sym_into] = ACTIONS(3347),
    [anon_sym_join] = ACTIONS(3347),
    [anon_sym_on] = ACTIONS(3347),
    [anon_sym_equals] = ACTIONS(3347),
    [anon_sym_let] = ACTIONS(3347),
    [anon_sym_orderby] = ACTIONS(3347),
    [anon_sym_ascending] = ACTIONS(3347),
    [anon_sym_descending] = ACTIONS(3347),
    [anon_sym_group] = ACTIONS(3347),
    [anon_sym_by] = ACTIONS(3347),
    [anon_sym_select] = ACTIONS(3347),
    [aux_sym_preproc_if_token1] = ACTIONS(3349),
    [aux_sym_preproc_if_token3] = ACTIONS(3349),
    [aux_sym_preproc_else_token1] = ACTIONS(3349),
    [aux_sym_preproc_elif_token1] = ACTIONS(3349),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3129] = {
    [sym__variable_designation] = STATE(4113),
    [sym_parenthesized_variable_designation] = STATE(4274),
    [sym_identifier] = STATE(4269),
    [sym__reserved_identifier] = STATE(3908),
    [sym_preproc_region] = STATE(3129),
    [sym_preproc_endregion] = STATE(3129),
    [sym_preproc_line] = STATE(3129),
    [sym_preproc_pragma] = STATE(3129),
    [sym_preproc_nullable] = STATE(3129),
    [sym_preproc_error] = STATE(3129),
    [sym_preproc_define] = STATE(3129),
    [sym_preproc_undef] = STATE(3129),
    [sym__identifier_token] = ACTIONS(4271),
    [anon_sym_alias] = ACTIONS(4273),
    [anon_sym_global] = ACTIONS(4273),
    [anon_sym_LBRACK] = ACTIONS(4373),
    [anon_sym_COLON] = ACTIONS(4373),
    [anon_sym_LPAREN] = ACTIONS(4373),
    [anon_sym_file] = ACTIONS(4273),
    [anon_sym_LT] = ACTIONS(4375),
    [anon_sym_GT] = ACTIONS(4375),
    [anon_sym_where] = ACTIONS(4273),
    [anon_sym_QMARK] = ACTIONS(4375),
    [anon_sym_notnull] = ACTIONS(4273),
    [anon_sym_unmanaged] = ACTIONS(4273),
    [anon_sym_BANG] = ACTIONS(4375),
    [anon_sym_PLUS_PLUS] = ACTIONS(4373),
    [anon_sym_DASH_DASH] = ACTIONS(4373),
    [anon_sym_PLUS] = ACTIONS(4375),
    [anon_sym_DASH] = ACTIONS(4375),
    [anon_sym_STAR] = ACTIONS(4373),
    [anon_sym_SLASH] = ACTIONS(4375),
    [anon_sym_PERCENT] = ACTIONS(4373),
    [anon_sym_CARET] = ACTIONS(4373),
    [anon_sym_PIPE] = ACTIONS(4375),
    [anon_sym_AMP] = ACTIONS(4375),
    [anon_sym_LT_LT] = ACTIONS(4373),
    [anon_sym_GT_GT] = ACTIONS(4375),
    [anon_sym_GT_GT_GT] = ACTIONS(4373),
    [anon_sym_EQ_EQ] = ACTIONS(4373),
    [anon_sym_BANG_EQ] = ACTIONS(4373),
    [anon_sym_GT_EQ] = ACTIONS(4373),
    [anon_sym_LT_EQ] = ACTIONS(4373),
    [anon_sym_DOT] = ACTIONS(4375),
    [anon_sym_scoped] = ACTIONS(4273),
    [anon_sym_EQ_GT] = ACTIONS(4373),
    [anon_sym_var] = ACTIONS(4273),
    [anon_sym_yield] = ACTIONS(4273),
    [anon_sym_switch] = ACTIONS(4375),
    [anon_sym_when] = ACTIONS(4375),
    [sym_discard] = ACTIONS(4295),
    [anon_sym_DOT_DOT] = ACTIONS(4373),
    [anon_sym_and] = ACTIONS(4375),
    [anon_sym_or] = ACTIONS(4375),
    [anon_sym_AMP_AMP] = ACTIONS(4373),
    [anon_sym_PIPE_PIPE] = ACTIONS(4373),
    [anon_sym_QMARK_QMARK] = ACTIONS(4373),
    [anon_sym_from] = ACTIONS(4273),
    [anon_sym_into] = ACTIONS(4273),
    [anon_sym_join] = ACTIONS(4273),
    [anon_sym_on] = ACTIONS(4273),
    [anon_sym_equals] = ACTIONS(4273),
    [anon_sym_let] = ACTIONS(4273),
    [anon_sym_orderby] = ACTIONS(4273),
    [anon_sym_ascending] = ACTIONS(4273),
    [anon_sym_descending] = ACTIONS(4273),
    [anon_sym_group] = ACTIONS(4273),
    [anon_sym_by] = ACTIONS(4273),
    [anon_sym_select] = ACTIONS(4273),
    [anon_sym_as] = ACTIONS(4375),
    [anon_sym_is] = ACTIONS(4375),
    [anon_sym_DASH_GT] = ACTIONS(4373),
    [anon_sym_with] = ACTIONS(4375),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3130] = {
    [sym__variable_designation] = STATE(4082),
    [sym_parenthesized_variable_designation] = STATE(4274),
    [sym_identifier] = STATE(4269),
    [sym__reserved_identifier] = STATE(3908),
    [sym_preproc_region] = STATE(3130),
    [sym_preproc_endregion] = STATE(3130),
    [sym_preproc_line] = STATE(3130),
    [sym_preproc_pragma] = STATE(3130),
    [sym_preproc_nullable] = STATE(3130),
    [sym_preproc_error] = STATE(3130),
    [sym_preproc_define] = STATE(3130),
    [sym_preproc_undef] = STATE(3130),
    [sym__identifier_token] = ACTIONS(4271),
    [anon_sym_alias] = ACTIONS(4273),
    [anon_sym_global] = ACTIONS(4273),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON] = ACTIONS(4383),
    [anon_sym_LPAREN] = ACTIONS(4383),
    [anon_sym_file] = ACTIONS(4273),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_where] = ACTIONS(4273),
    [anon_sym_QMARK] = ACTIONS(4385),
    [anon_sym_notnull] = ACTIONS(4273),
    [anon_sym_unmanaged] = ACTIONS(4273),
    [anon_sym_BANG] = ACTIONS(4385),
    [anon_sym_PLUS_PLUS] = ACTIONS(4383),
    [anon_sym_DASH_DASH] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_DASH] = ACTIONS(4385),
    [anon_sym_STAR] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4385),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4385),
    [anon_sym_GT_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4383),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_scoped] = ACTIONS(4273),
    [anon_sym_EQ_GT] = ACTIONS(4383),
    [anon_sym_var] = ACTIONS(4273),
    [anon_sym_yield] = ACTIONS(4273),
    [anon_sym_switch] = ACTIONS(4385),
    [anon_sym_when] = ACTIONS(4385),
    [sym_discard] = ACTIONS(4295),
    [anon_sym_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4385),
    [anon_sym_or] = ACTIONS(4385),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_QMARK_QMARK] = ACTIONS(4383),
    [anon_sym_from] = ACTIONS(4273),
    [anon_sym_into] = ACTIONS(4273),
    [anon_sym_join] = ACTIONS(4273),
    [anon_sym_on] = ACTIONS(4273),
    [anon_sym_equals] = ACTIONS(4273),
    [anon_sym_let] = ACTIONS(4273),
    [anon_sym_orderby] = ACTIONS(4273),
    [anon_sym_ascending] = ACTIONS(4273),
    [anon_sym_descending] = ACTIONS(4273),
    [anon_sym_group] = ACTIONS(4273),
    [anon_sym_by] = ACTIONS(4273),
    [anon_sym_select] = ACTIONS(4273),
    [anon_sym_as] = ACTIONS(4385),
    [anon_sym_is] = ACTIONS(4385),
    [anon_sym_DASH_GT] = ACTIONS(4383),
    [anon_sym_with] = ACTIONS(4385),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3131] = {
    [sym_property_pattern_clause] = STATE(3349),
    [sym__variable_designation] = STATE(4998),
    [sym_parenthesized_variable_designation] = STATE(4957),
    [sym_identifier] = STATE(4971),
    [sym__reserved_identifier] = STATE(3558),
    [sym_preproc_region] = STATE(3131),
    [sym_preproc_endregion] = STATE(3131),
    [sym_preproc_line] = STATE(3131),
    [sym_preproc_pragma] = STATE(3131),
    [sym_preproc_nullable] = STATE(3131),
    [sym_preproc_error] = STATE(3131),
    [sym_preproc_define] = STATE(3131),
    [sym_preproc_undef] = STATE(3131),
    [sym__identifier_token] = ACTIONS(4225),
    [anon_sym_alias] = ACTIONS(4227),
    [anon_sym_global] = ACTIONS(4227),
    [anon_sym_LBRACK] = ACTIONS(4329),
    [anon_sym_LPAREN] = ACTIONS(4329),
    [anon_sym_LBRACE] = ACTIONS(4277),
    [anon_sym_file] = ACTIONS(4227),
    [anon_sym_LT] = ACTIONS(4331),
    [anon_sym_GT] = ACTIONS(4331),
    [anon_sym_where] = ACTIONS(4331),
    [anon_sym_QMARK] = ACTIONS(4331),
    [anon_sym_notnull] = ACTIONS(4227),
    [anon_sym_unmanaged] = ACTIONS(4227),
    [anon_sym_BANG] = ACTIONS(4331),
    [anon_sym_PLUS_PLUS] = ACTIONS(4329),
    [anon_sym_DASH_DASH] = ACTIONS(4329),
    [anon_sym_PLUS] = ACTIONS(4331),
    [anon_sym_DASH] = ACTIONS(4331),
    [anon_sym_STAR] = ACTIONS(4329),
    [anon_sym_SLASH] = ACTIONS(4331),
    [anon_sym_PERCENT] = ACTIONS(4329),
    [anon_sym_CARET] = ACTIONS(4329),
    [anon_sym_PIPE] = ACTIONS(4331),
    [anon_sym_AMP] = ACTIONS(4331),
    [anon_sym_LT_LT] = ACTIONS(4329),
    [anon_sym_GT_GT] = ACTIONS(4331),
    [anon_sym_GT_GT_GT] = ACTIONS(4329),
    [anon_sym_EQ_EQ] = ACTIONS(4329),
    [anon_sym_BANG_EQ] = ACTIONS(4329),
    [anon_sym_GT_EQ] = ACTIONS(4329),
    [anon_sym_LT_EQ] = ACTIONS(4329),
    [anon_sym_DOT] = ACTIONS(4331),
    [anon_sym_scoped] = ACTIONS(4227),
    [anon_sym_var] = ACTIONS(4227),
    [anon_sym_yield] = ACTIONS(4227),
    [anon_sym_switch] = ACTIONS(4331),
    [anon_sym_when] = ACTIONS(4227),
    [sym_discard] = ACTIONS(4649),
    [anon_sym_DOT_DOT] = ACTIONS(4329),
    [anon_sym_and] = ACTIONS(4331),
    [anon_sym_or] = ACTIONS(4331),
    [anon_sym_AMP_AMP] = ACTIONS(4329),
    [anon_sym_PIPE_PIPE] = ACTIONS(4329),
    [anon_sym_QMARK_QMARK] = ACTIONS(4329),
    [anon_sym_from] = ACTIONS(4331),
    [anon_sym_into] = ACTIONS(4331),
    [anon_sym_join] = ACTIONS(4331),
    [anon_sym_on] = ACTIONS(4227),
    [anon_sym_equals] = ACTIONS(4227),
    [anon_sym_let] = ACTIONS(4331),
    [anon_sym_orderby] = ACTIONS(4331),
    [anon_sym_ascending] = ACTIONS(4227),
    [anon_sym_descending] = ACTIONS(4227),
    [anon_sym_group] = ACTIONS(4331),
    [anon_sym_by] = ACTIONS(4227),
    [anon_sym_select] = ACTIONS(4331),
    [anon_sym_as] = ACTIONS(4331),
    [anon_sym_is] = ACTIONS(4331),
    [anon_sym_DASH_GT] = ACTIONS(4329),
    [anon_sym_with] = ACTIONS(4331),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3132] = {
    [sym_property_pattern_clause] = STATE(3483),
    [sym__variable_designation] = STATE(4023),
    [sym_parenthesized_variable_designation] = STATE(4015),
    [sym_identifier] = STATE(4020),
    [sym__reserved_identifier] = STATE(3908),
    [sym_preproc_region] = STATE(3132),
    [sym_preproc_endregion] = STATE(3132),
    [sym_preproc_line] = STATE(3132),
    [sym_preproc_pragma] = STATE(3132),
    [sym_preproc_nullable] = STATE(3132),
    [sym_preproc_error] = STATE(3132),
    [sym_preproc_define] = STATE(3132),
    [sym_preproc_undef] = STATE(3132),
    [sym__identifier_token] = ACTIONS(4271),
    [anon_sym_alias] = ACTIONS(4273),
    [anon_sym_global] = ACTIONS(4273),
    [anon_sym_LBRACK] = ACTIONS(4329),
    [anon_sym_LPAREN] = ACTIONS(4329),
    [anon_sym_LBRACE] = ACTIONS(4277),
    [anon_sym_file] = ACTIONS(4273),
    [anon_sym_LT] = ACTIONS(4331),
    [anon_sym_GT] = ACTIONS(4331),
    [anon_sym_where] = ACTIONS(4273),
    [anon_sym_QMARK] = ACTIONS(4331),
    [anon_sym_notnull] = ACTIONS(4273),
    [anon_sym_unmanaged] = ACTIONS(4273),
    [anon_sym_BANG] = ACTIONS(4331),
    [anon_sym_PLUS_PLUS] = ACTIONS(4329),
    [anon_sym_DASH_DASH] = ACTIONS(4329),
    [anon_sym_PLUS] = ACTIONS(4331),
    [anon_sym_DASH] = ACTIONS(4331),
    [anon_sym_STAR] = ACTIONS(4329),
    [anon_sym_SLASH] = ACTIONS(4331),
    [anon_sym_PERCENT] = ACTIONS(4329),
    [anon_sym_CARET] = ACTIONS(4329),
    [anon_sym_PIPE] = ACTIONS(4331),
    [anon_sym_AMP] = ACTIONS(4331),
    [anon_sym_LT_LT] = ACTIONS(4329),
    [anon_sym_GT_GT] = ACTIONS(4331),
    [anon_sym_GT_GT_GT] = ACTIONS(4329),
    [anon_sym_EQ_EQ] = ACTIONS(4329),
    [anon_sym_BANG_EQ] = ACTIONS(4329),
    [anon_sym_GT_EQ] = ACTIONS(4329),
    [anon_sym_LT_EQ] = ACTIONS(4329),
    [anon_sym_DOT] = ACTIONS(4331),
    [anon_sym_scoped] = ACTIONS(4273),
    [anon_sym_var] = ACTIONS(4273),
    [anon_sym_yield] = ACTIONS(4273),
    [anon_sym_switch] = ACTIONS(4331),
    [anon_sym_when] = ACTIONS(4273),
    [sym_discard] = ACTIONS(4281),
    [anon_sym_DOT_DOT] = ACTIONS(4329),
    [anon_sym_and] = ACTIONS(4331),
    [anon_sym_or] = ACTIONS(4331),
    [anon_sym_AMP_AMP] = ACTIONS(4329),
    [anon_sym_PIPE_PIPE] = ACTIONS(4329),
    [anon_sym_QMARK_QMARK] = ACTIONS(4329),
    [anon_sym_from] = ACTIONS(4273),
    [anon_sym_into] = ACTIONS(4331),
    [anon_sym_join] = ACTIONS(4273),
    [anon_sym_on] = ACTIONS(4273),
    [anon_sym_equals] = ACTIONS(4331),
    [anon_sym_let] = ACTIONS(4273),
    [anon_sym_orderby] = ACTIONS(4273),
    [anon_sym_ascending] = ACTIONS(4273),
    [anon_sym_descending] = ACTIONS(4273),
    [anon_sym_group] = ACTIONS(4273),
    [anon_sym_by] = ACTIONS(4273),
    [anon_sym_select] = ACTIONS(4273),
    [anon_sym_as] = ACTIONS(4331),
    [anon_sym_is] = ACTIONS(4331),
    [anon_sym_DASH_GT] = ACTIONS(4329),
    [anon_sym_with] = ACTIONS(4331),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3133] = {
    [sym_type_argument_list] = STATE(3317),
    [sym_preproc_region] = STATE(3133),
    [sym_preproc_endregion] = STATE(3133),
    [sym_preproc_line] = STATE(3133),
    [sym_preproc_pragma] = STATE(3133),
    [sym_preproc_nullable] = STATE(3133),
    [sym_preproc_error] = STATE(3133),
    [sym_preproc_define] = STATE(3133),
    [sym_preproc_undef] = STATE(3133),
    [sym__identifier_token] = ACTIONS(4074),
    [anon_sym_alias] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4076),
    [anon_sym_COLON] = ACTIONS(4074),
    [anon_sym_COMMA] = ACTIONS(4076),
    [anon_sym_LPAREN] = ACTIONS(4076),
    [anon_sym_LBRACE] = ACTIONS(4076),
    [anon_sym_file] = ACTIONS(4074),
    [anon_sym_LT] = ACTIONS(4689),
    [anon_sym_GT] = ACTIONS(4074),
    [anon_sym_where] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(4074),
    [anon_sym_notnull] = ACTIONS(4074),
    [anon_sym_unmanaged] = ACTIONS(4074),
    [anon_sym_BANG] = ACTIONS(4074),
    [anon_sym_PLUS_PLUS] = ACTIONS(4076),
    [anon_sym_DASH_DASH] = ACTIONS(4076),
    [anon_sym_PLUS] = ACTIONS(4074),
    [anon_sym_DASH] = ACTIONS(4074),
    [anon_sym_STAR] = ACTIONS(4076),
    [anon_sym_SLASH] = ACTIONS(4074),
    [anon_sym_PERCENT] = ACTIONS(4076),
    [anon_sym_CARET] = ACTIONS(4076),
    [anon_sym_PIPE] = ACTIONS(4074),
    [anon_sym_AMP] = ACTIONS(4074),
    [anon_sym_LT_LT] = ACTIONS(4076),
    [anon_sym_GT_GT] = ACTIONS(4074),
    [anon_sym_GT_GT_GT] = ACTIONS(4076),
    [anon_sym_EQ_EQ] = ACTIONS(4076),
    [anon_sym_BANG_EQ] = ACTIONS(4076),
    [anon_sym_GT_EQ] = ACTIONS(4076),
    [anon_sym_LT_EQ] = ACTIONS(4076),
    [anon_sym_DOT] = ACTIONS(4074),
    [anon_sym_scoped] = ACTIONS(4074),
    [anon_sym_COLON_COLON] = ACTIONS(4237),
    [anon_sym_var] = ACTIONS(4074),
    [anon_sym_yield] = ACTIONS(4074),
    [anon_sym_switch] = ACTIONS(4074),
    [anon_sym_when] = ACTIONS(4074),
    [sym_discard] = ACTIONS(4074),
    [anon_sym_DOT_DOT] = ACTIONS(4076),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_AMP_AMP] = ACTIONS(4076),
    [anon_sym_PIPE_PIPE] = ACTIONS(4076),
    [anon_sym_QMARK_QMARK] = ACTIONS(4076),
    [anon_sym_from] = ACTIONS(4074),
    [anon_sym_into] = ACTIONS(4074),
    [anon_sym_join] = ACTIONS(4074),
    [anon_sym_on] = ACTIONS(4074),
    [anon_sym_equals] = ACTIONS(4074),
    [anon_sym_let] = ACTIONS(4074),
    [anon_sym_orderby] = ACTIONS(4074),
    [anon_sym_ascending] = ACTIONS(4074),
    [anon_sym_descending] = ACTIONS(4074),
    [anon_sym_group] = ACTIONS(4074),
    [anon_sym_by] = ACTIONS(4074),
    [anon_sym_select] = ACTIONS(4074),
    [anon_sym_as] = ACTIONS(4074),
    [anon_sym_is] = ACTIONS(4074),
    [anon_sym_DASH_GT] = ACTIONS(4076),
    [anon_sym_with] = ACTIONS(4074),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4076),
  },
  [3134] = {
    [sym_property_pattern_clause] = STATE(3320),
    [sym__variable_designation] = STATE(5010),
    [sym_parenthesized_variable_designation] = STATE(4957),
    [sym_identifier] = STATE(4971),
    [sym__reserved_identifier] = STATE(3568),
    [sym_preproc_region] = STATE(3134),
    [sym_preproc_endregion] = STATE(3134),
    [sym_preproc_line] = STATE(3134),
    [sym_preproc_pragma] = STATE(3134),
    [sym_preproc_nullable] = STATE(3134),
    [sym_preproc_error] = STATE(3134),
    [sym_preproc_define] = STATE(3134),
    [sym_preproc_undef] = STATE(3134),
    [sym__identifier_token] = ACTIONS(4287),
    [anon_sym_alias] = ACTIONS(4289),
    [anon_sym_global] = ACTIONS(4289),
    [anon_sym_LBRACK] = ACTIONS(4335),
    [anon_sym_LPAREN] = ACTIONS(4335),
    [anon_sym_LBRACE] = ACTIONS(4277),
    [anon_sym_file] = ACTIONS(4289),
    [anon_sym_LT] = ACTIONS(4337),
    [anon_sym_GT] = ACTIONS(4337),
    [anon_sym_where] = ACTIONS(4337),
    [anon_sym_QMARK] = ACTIONS(4337),
    [anon_sym_notnull] = ACTIONS(4289),
    [anon_sym_unmanaged] = ACTIONS(4289),
    [anon_sym_BANG] = ACTIONS(4337),
    [anon_sym_PLUS_PLUS] = ACTIONS(4335),
    [anon_sym_DASH_DASH] = ACTIONS(4335),
    [anon_sym_PLUS] = ACTIONS(4337),
    [anon_sym_DASH] = ACTIONS(4337),
    [anon_sym_STAR] = ACTIONS(4335),
    [anon_sym_SLASH] = ACTIONS(4337),
    [anon_sym_PERCENT] = ACTIONS(4335),
    [anon_sym_CARET] = ACTIONS(4335),
    [anon_sym_PIPE] = ACTIONS(4337),
    [anon_sym_AMP] = ACTIONS(4337),
    [anon_sym_LT_LT] = ACTIONS(4335),
    [anon_sym_GT_GT] = ACTIONS(4337),
    [anon_sym_GT_GT_GT] = ACTIONS(4335),
    [anon_sym_EQ_EQ] = ACTIONS(4335),
    [anon_sym_BANG_EQ] = ACTIONS(4335),
    [anon_sym_GT_EQ] = ACTIONS(4335),
    [anon_sym_LT_EQ] = ACTIONS(4335),
    [anon_sym_DOT] = ACTIONS(4337),
    [anon_sym_scoped] = ACTIONS(4289),
    [anon_sym_var] = ACTIONS(4289),
    [anon_sym_yield] = ACTIONS(4289),
    [anon_sym_switch] = ACTIONS(4337),
    [anon_sym_when] = ACTIONS(4289),
    [sym_discard] = ACTIONS(4649),
    [anon_sym_DOT_DOT] = ACTIONS(4335),
    [anon_sym_and] = ACTIONS(4337),
    [anon_sym_or] = ACTIONS(4337),
    [anon_sym_AMP_AMP] = ACTIONS(4335),
    [anon_sym_PIPE_PIPE] = ACTIONS(4335),
    [anon_sym_QMARK_QMARK] = ACTIONS(4335),
    [anon_sym_from] = ACTIONS(4337),
    [anon_sym_into] = ACTIONS(4289),
    [anon_sym_join] = ACTIONS(4337),
    [anon_sym_on] = ACTIONS(4289),
    [anon_sym_equals] = ACTIONS(4289),
    [anon_sym_let] = ACTIONS(4337),
    [anon_sym_orderby] = ACTIONS(4337),
    [anon_sym_ascending] = ACTIONS(4289),
    [anon_sym_descending] = ACTIONS(4289),
    [anon_sym_group] = ACTIONS(4337),
    [anon_sym_by] = ACTIONS(4289),
    [anon_sym_select] = ACTIONS(4337),
    [anon_sym_as] = ACTIONS(4337),
    [anon_sym_is] = ACTIONS(4337),
    [anon_sym_DASH_GT] = ACTIONS(4335),
    [anon_sym_with] = ACTIONS(4337),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3135] = {
    [sym_type_argument_list] = STATE(3207),
    [sym_preproc_region] = STATE(3135),
    [sym_preproc_endregion] = STATE(3135),
    [sym_preproc_line] = STATE(3135),
    [sym_preproc_pragma] = STATE(3135),
    [sym_preproc_nullable] = STATE(3135),
    [sym_preproc_error] = STATE(3135),
    [sym_preproc_define] = STATE(3135),
    [sym_preproc_undef] = STATE(3135),
    [anon_sym_SEMI] = ACTIONS(4076),
    [anon_sym_EQ] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4076),
    [anon_sym_COLON] = ACTIONS(4076),
    [anon_sym_COMMA] = ACTIONS(4076),
    [anon_sym_RBRACK] = ACTIONS(4076),
    [anon_sym_LPAREN] = ACTIONS(4076),
    [anon_sym_RPAREN] = ACTIONS(4076),
    [anon_sym_RBRACE] = ACTIONS(4076),
    [anon_sym_LT] = ACTIONS(4692),
    [anon_sym_GT] = ACTIONS(4074),
    [anon_sym_in] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(4074),
    [anon_sym_BANG] = ACTIONS(4074),
    [anon_sym_PLUS_PLUS] = ACTIONS(4076),
    [anon_sym_DASH_DASH] = ACTIONS(4076),
    [anon_sym_PLUS] = ACTIONS(4074),
    [anon_sym_DASH] = ACTIONS(4074),
    [anon_sym_STAR] = ACTIONS(4074),
    [anon_sym_SLASH] = ACTIONS(4074),
    [anon_sym_PERCENT] = ACTIONS(4074),
    [anon_sym_CARET] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(4074),
    [anon_sym_AMP] = ACTIONS(4074),
    [anon_sym_LT_LT] = ACTIONS(4074),
    [anon_sym_GT_GT] = ACTIONS(4074),
    [anon_sym_GT_GT_GT] = ACTIONS(4074),
    [anon_sym_EQ_EQ] = ACTIONS(4076),
    [anon_sym_BANG_EQ] = ACTIONS(4076),
    [anon_sym_GT_EQ] = ACTIONS(4076),
    [anon_sym_LT_EQ] = ACTIONS(4076),
    [anon_sym_DOT] = ACTIONS(4074),
    [anon_sym_EQ_GT] = ACTIONS(4076),
    [anon_sym_switch] = ACTIONS(4076),
    [anon_sym_when] = ACTIONS(4076),
    [anon_sym_DOT_DOT] = ACTIONS(4076),
    [anon_sym_and] = ACTIONS(4076),
    [anon_sym_or] = ACTIONS(4076),
    [anon_sym_PLUS_EQ] = ACTIONS(4076),
    [anon_sym_DASH_EQ] = ACTIONS(4076),
    [anon_sym_STAR_EQ] = ACTIONS(4076),
    [anon_sym_SLASH_EQ] = ACTIONS(4076),
    [anon_sym_PERCENT_EQ] = ACTIONS(4076),
    [anon_sym_AMP_EQ] = ACTIONS(4076),
    [anon_sym_CARET_EQ] = ACTIONS(4076),
    [anon_sym_PIPE_EQ] = ACTIONS(4076),
    [anon_sym_LT_LT_EQ] = ACTIONS(4076),
    [anon_sym_GT_GT_EQ] = ACTIONS(4076),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4076),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4076),
    [anon_sym_AMP_AMP] = ACTIONS(4076),
    [anon_sym_PIPE_PIPE] = ACTIONS(4076),
    [anon_sym_QMARK_QMARK] = ACTIONS(4074),
    [anon_sym_into] = ACTIONS(4076),
    [anon_sym_on] = ACTIONS(4076),
    [anon_sym_equals] = ACTIONS(4076),
    [anon_sym_by] = ACTIONS(4076),
    [anon_sym_as] = ACTIONS(4076),
    [anon_sym_is] = ACTIONS(4076),
    [anon_sym_DASH_GT] = ACTIONS(4076),
    [anon_sym_with] = ACTIONS(4076),
    [aux_sym_preproc_if_token3] = ACTIONS(4076),
    [aux_sym_preproc_else_token1] = ACTIONS(4076),
    [aux_sym_preproc_elif_token1] = ACTIONS(4076),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3136] = {
    [sym_property_pattern_clause] = STATE(3350),
    [sym__variable_designation] = STATE(5010),
    [sym_parenthesized_variable_designation] = STATE(4957),
    [sym_identifier] = STATE(4971),
    [sym__reserved_identifier] = STATE(3558),
    [sym_preproc_region] = STATE(3136),
    [sym_preproc_endregion] = STATE(3136),
    [sym_preproc_line] = STATE(3136),
    [sym_preproc_pragma] = STATE(3136),
    [sym_preproc_nullable] = STATE(3136),
    [sym_preproc_error] = STATE(3136),
    [sym_preproc_define] = STATE(3136),
    [sym_preproc_undef] = STATE(3136),
    [sym__identifier_token] = ACTIONS(4225),
    [anon_sym_alias] = ACTIONS(4227),
    [anon_sym_global] = ACTIONS(4227),
    [anon_sym_LBRACK] = ACTIONS(4335),
    [anon_sym_LPAREN] = ACTIONS(4335),
    [anon_sym_LBRACE] = ACTIONS(4277),
    [anon_sym_file] = ACTIONS(4227),
    [anon_sym_LT] = ACTIONS(4337),
    [anon_sym_GT] = ACTIONS(4337),
    [anon_sym_where] = ACTIONS(4337),
    [anon_sym_QMARK] = ACTIONS(4337),
    [anon_sym_notnull] = ACTIONS(4227),
    [anon_sym_unmanaged] = ACTIONS(4227),
    [anon_sym_BANG] = ACTIONS(4337),
    [anon_sym_PLUS_PLUS] = ACTIONS(4335),
    [anon_sym_DASH_DASH] = ACTIONS(4335),
    [anon_sym_PLUS] = ACTIONS(4337),
    [anon_sym_DASH] = ACTIONS(4337),
    [anon_sym_STAR] = ACTIONS(4335),
    [anon_sym_SLASH] = ACTIONS(4337),
    [anon_sym_PERCENT] = ACTIONS(4335),
    [anon_sym_CARET] = ACTIONS(4335),
    [anon_sym_PIPE] = ACTIONS(4337),
    [anon_sym_AMP] = ACTIONS(4337),
    [anon_sym_LT_LT] = ACTIONS(4335),
    [anon_sym_GT_GT] = ACTIONS(4337),
    [anon_sym_GT_GT_GT] = ACTIONS(4335),
    [anon_sym_EQ_EQ] = ACTIONS(4335),
    [anon_sym_BANG_EQ] = ACTIONS(4335),
    [anon_sym_GT_EQ] = ACTIONS(4335),
    [anon_sym_LT_EQ] = ACTIONS(4335),
    [anon_sym_DOT] = ACTIONS(4337),
    [anon_sym_scoped] = ACTIONS(4227),
    [anon_sym_var] = ACTIONS(4227),
    [anon_sym_yield] = ACTIONS(4227),
    [anon_sym_switch] = ACTIONS(4337),
    [anon_sym_when] = ACTIONS(4227),
    [sym_discard] = ACTIONS(4649),
    [anon_sym_DOT_DOT] = ACTIONS(4335),
    [anon_sym_and] = ACTIONS(4337),
    [anon_sym_or] = ACTIONS(4337),
    [anon_sym_AMP_AMP] = ACTIONS(4335),
    [anon_sym_PIPE_PIPE] = ACTIONS(4335),
    [anon_sym_QMARK_QMARK] = ACTIONS(4335),
    [anon_sym_from] = ACTIONS(4337),
    [anon_sym_into] = ACTIONS(4337),
    [anon_sym_join] = ACTIONS(4337),
    [anon_sym_on] = ACTIONS(4227),
    [anon_sym_equals] = ACTIONS(4227),
    [anon_sym_let] = ACTIONS(4337),
    [anon_sym_orderby] = ACTIONS(4337),
    [anon_sym_ascending] = ACTIONS(4227),
    [anon_sym_descending] = ACTIONS(4227),
    [anon_sym_group] = ACTIONS(4337),
    [anon_sym_by] = ACTIONS(4227),
    [anon_sym_select] = ACTIONS(4337),
    [anon_sym_as] = ACTIONS(4337),
    [anon_sym_is] = ACTIONS(4337),
    [anon_sym_DASH_GT] = ACTIONS(4335),
    [anon_sym_with] = ACTIONS(4337),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3137] = {
    [sym_preproc_region] = STATE(3137),
    [sym_preproc_endregion] = STATE(3137),
    [sym_preproc_line] = STATE(3137),
    [sym_preproc_pragma] = STATE(3137),
    [sym_preproc_nullable] = STATE(3137),
    [sym_preproc_error] = STATE(3137),
    [sym_preproc_define] = STATE(3137),
    [sym_preproc_undef] = STATE(3137),
    [sym__identifier_token] = ACTIONS(4576),
    [anon_sym_alias] = ACTIONS(4576),
    [anon_sym_global] = ACTIONS(4576),
    [anon_sym_LBRACK] = ACTIONS(4695),
    [anon_sym_COLON] = ACTIONS(4695),
    [anon_sym_COMMA] = ACTIONS(4578),
    [anon_sym_RBRACK] = ACTIONS(4578),
    [anon_sym_LPAREN] = ACTIONS(4578),
    [anon_sym_RPAREN] = ACTIONS(4578),
    [anon_sym_RBRACE] = ACTIONS(4578),
    [anon_sym_file] = ACTIONS(4576),
    [anon_sym_LT] = ACTIONS(4697),
    [anon_sym_GT] = ACTIONS(4697),
    [anon_sym_where] = ACTIONS(4576),
    [anon_sym_QMARK] = ACTIONS(4697),
    [anon_sym_notnull] = ACTIONS(4576),
    [anon_sym_unmanaged] = ACTIONS(4576),
    [anon_sym_BANG] = ACTIONS(4697),
    [anon_sym_PLUS_PLUS] = ACTIONS(4695),
    [anon_sym_DASH_DASH] = ACTIONS(4695),
    [anon_sym_PLUS] = ACTIONS(4697),
    [anon_sym_DASH] = ACTIONS(4697),
    [anon_sym_STAR] = ACTIONS(4695),
    [anon_sym_SLASH] = ACTIONS(4697),
    [anon_sym_PERCENT] = ACTIONS(4695),
    [anon_sym_CARET] = ACTIONS(4695),
    [anon_sym_PIPE] = ACTIONS(4697),
    [anon_sym_AMP] = ACTIONS(4697),
    [anon_sym_LT_LT] = ACTIONS(4695),
    [anon_sym_GT_GT] = ACTIONS(4697),
    [anon_sym_GT_GT_GT] = ACTIONS(4695),
    [anon_sym_EQ_EQ] = ACTIONS(4695),
    [anon_sym_BANG_EQ] = ACTIONS(4695),
    [anon_sym_GT_EQ] = ACTIONS(4695),
    [anon_sym_LT_EQ] = ACTIONS(4695),
    [anon_sym_DOT] = ACTIONS(4697),
    [anon_sym_scoped] = ACTIONS(4576),
    [anon_sym_EQ_GT] = ACTIONS(4578),
    [anon_sym_var] = ACTIONS(4576),
    [anon_sym_yield] = ACTIONS(4576),
    [anon_sym_switch] = ACTIONS(4697),
    [anon_sym_when] = ACTIONS(4576),
    [sym_discard] = ACTIONS(4576),
    [anon_sym_DOT_DOT] = ACTIONS(4695),
    [anon_sym_and] = ACTIONS(4576),
    [anon_sym_or] = ACTIONS(4576),
    [anon_sym_AMP_AMP] = ACTIONS(4695),
    [anon_sym_PIPE_PIPE] = ACTIONS(4695),
    [anon_sym_QMARK_QMARK] = ACTIONS(4695),
    [anon_sym_from] = ACTIONS(4576),
    [anon_sym_into] = ACTIONS(4576),
    [anon_sym_join] = ACTIONS(4576),
    [anon_sym_on] = ACTIONS(4576),
    [anon_sym_equals] = ACTIONS(4576),
    [anon_sym_let] = ACTIONS(4576),
    [anon_sym_orderby] = ACTIONS(4576),
    [anon_sym_ascending] = ACTIONS(4576),
    [anon_sym_descending] = ACTIONS(4576),
    [anon_sym_group] = ACTIONS(4576),
    [anon_sym_by] = ACTIONS(4576),
    [anon_sym_select] = ACTIONS(4576),
    [anon_sym_as] = ACTIONS(4697),
    [anon_sym_is] = ACTIONS(4697),
    [anon_sym_DASH_GT] = ACTIONS(4695),
    [anon_sym_with] = ACTIONS(4697),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3138] = {
    [sym__variable_designation] = STATE(4025),
    [sym_parenthesized_variable_designation] = STATE(4015),
    [sym_identifier] = STATE(4020),
    [sym__reserved_identifier] = STATE(3908),
    [sym_preproc_region] = STATE(3138),
    [sym_preproc_endregion] = STATE(3138),
    [sym_preproc_line] = STATE(3138),
    [sym_preproc_pragma] = STATE(3138),
    [sym_preproc_nullable] = STATE(3138),
    [sym_preproc_error] = STATE(3138),
    [sym_preproc_define] = STATE(3138),
    [sym_preproc_undef] = STATE(3138),
    [sym__identifier_token] = ACTIONS(4271),
    [anon_sym_alias] = ACTIONS(4273),
    [anon_sym_global] = ACTIONS(4273),
    [anon_sym_LBRACK] = ACTIONS(4329),
    [anon_sym_COLON] = ACTIONS(4329),
    [anon_sym_LPAREN] = ACTIONS(4329),
    [anon_sym_file] = ACTIONS(4273),
    [anon_sym_LT] = ACTIONS(4331),
    [anon_sym_GT] = ACTIONS(4331),
    [anon_sym_where] = ACTIONS(4273),
    [anon_sym_QMARK] = ACTIONS(4331),
    [anon_sym_notnull] = ACTIONS(4273),
    [anon_sym_unmanaged] = ACTIONS(4273),
    [anon_sym_BANG] = ACTIONS(4331),
    [anon_sym_PLUS_PLUS] = ACTIONS(4329),
    [anon_sym_DASH_DASH] = ACTIONS(4329),
    [anon_sym_PLUS] = ACTIONS(4331),
    [anon_sym_DASH] = ACTIONS(4331),
    [anon_sym_STAR] = ACTIONS(4329),
    [anon_sym_SLASH] = ACTIONS(4331),
    [anon_sym_PERCENT] = ACTIONS(4329),
    [anon_sym_CARET] = ACTIONS(4329),
    [anon_sym_PIPE] = ACTIONS(4331),
    [anon_sym_AMP] = ACTIONS(4331),
    [anon_sym_LT_LT] = ACTIONS(4329),
    [anon_sym_GT_GT] = ACTIONS(4331),
    [anon_sym_GT_GT_GT] = ACTIONS(4329),
    [anon_sym_EQ_EQ] = ACTIONS(4329),
    [anon_sym_BANG_EQ] = ACTIONS(4329),
    [anon_sym_GT_EQ] = ACTIONS(4329),
    [anon_sym_LT_EQ] = ACTIONS(4329),
    [anon_sym_DOT] = ACTIONS(4331),
    [anon_sym_scoped] = ACTIONS(4273),
    [anon_sym_EQ_GT] = ACTIONS(4329),
    [anon_sym_var] = ACTIONS(4273),
    [anon_sym_yield] = ACTIONS(4273),
    [anon_sym_switch] = ACTIONS(4331),
    [anon_sym_when] = ACTIONS(4331),
    [sym_discard] = ACTIONS(4281),
    [anon_sym_DOT_DOT] = ACTIONS(4329),
    [anon_sym_and] = ACTIONS(4331),
    [anon_sym_or] = ACTIONS(4331),
    [anon_sym_AMP_AMP] = ACTIONS(4329),
    [anon_sym_PIPE_PIPE] = ACTIONS(4329),
    [anon_sym_QMARK_QMARK] = ACTIONS(4329),
    [anon_sym_from] = ACTIONS(4273),
    [anon_sym_into] = ACTIONS(4331),
    [anon_sym_join] = ACTIONS(4273),
    [anon_sym_on] = ACTIONS(4273),
    [anon_sym_equals] = ACTIONS(4273),
    [anon_sym_let] = ACTIONS(4273),
    [anon_sym_orderby] = ACTIONS(4273),
    [anon_sym_ascending] = ACTIONS(4273),
    [anon_sym_descending] = ACTIONS(4273),
    [anon_sym_group] = ACTIONS(4273),
    [anon_sym_by] = ACTIONS(4273),
    [anon_sym_select] = ACTIONS(4273),
    [anon_sym_as] = ACTIONS(4331),
    [anon_sym_is] = ACTIONS(4331),
    [anon_sym_DASH_GT] = ACTIONS(4329),
    [anon_sym_with] = ACTIONS(4331),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3139] = {
    [sym_property_pattern_clause] = STATE(3273),
    [sym__variable_designation] = STATE(4998),
    [sym_parenthesized_variable_designation] = STATE(4957),
    [sym_identifier] = STATE(4971),
    [sym__reserved_identifier] = STATE(3568),
    [sym_preproc_region] = STATE(3139),
    [sym_preproc_endregion] = STATE(3139),
    [sym_preproc_line] = STATE(3139),
    [sym_preproc_pragma] = STATE(3139),
    [sym_preproc_nullable] = STATE(3139),
    [sym_preproc_error] = STATE(3139),
    [sym_preproc_define] = STATE(3139),
    [sym_preproc_undef] = STATE(3139),
    [sym__identifier_token] = ACTIONS(4287),
    [anon_sym_alias] = ACTIONS(4289),
    [anon_sym_global] = ACTIONS(4289),
    [anon_sym_LBRACK] = ACTIONS(4329),
    [anon_sym_LPAREN] = ACTIONS(4329),
    [anon_sym_LBRACE] = ACTIONS(4277),
    [anon_sym_file] = ACTIONS(4289),
    [anon_sym_LT] = ACTIONS(4331),
    [anon_sym_GT] = ACTIONS(4331),
    [anon_sym_where] = ACTIONS(4331),
    [anon_sym_QMARK] = ACTIONS(4331),
    [anon_sym_notnull] = ACTIONS(4289),
    [anon_sym_unmanaged] = ACTIONS(4289),
    [anon_sym_BANG] = ACTIONS(4331),
    [anon_sym_PLUS_PLUS] = ACTIONS(4329),
    [anon_sym_DASH_DASH] = ACTIONS(4329),
    [anon_sym_PLUS] = ACTIONS(4331),
    [anon_sym_DASH] = ACTIONS(4331),
    [anon_sym_STAR] = ACTIONS(4329),
    [anon_sym_SLASH] = ACTIONS(4331),
    [anon_sym_PERCENT] = ACTIONS(4329),
    [anon_sym_CARET] = ACTIONS(4329),
    [anon_sym_PIPE] = ACTIONS(4331),
    [anon_sym_AMP] = ACTIONS(4331),
    [anon_sym_LT_LT] = ACTIONS(4329),
    [anon_sym_GT_GT] = ACTIONS(4331),
    [anon_sym_GT_GT_GT] = ACTIONS(4329),
    [anon_sym_EQ_EQ] = ACTIONS(4329),
    [anon_sym_BANG_EQ] = ACTIONS(4329),
    [anon_sym_GT_EQ] = ACTIONS(4329),
    [anon_sym_LT_EQ] = ACTIONS(4329),
    [anon_sym_DOT] = ACTIONS(4331),
    [anon_sym_scoped] = ACTIONS(4289),
    [anon_sym_var] = ACTIONS(4289),
    [anon_sym_yield] = ACTIONS(4289),
    [anon_sym_switch] = ACTIONS(4331),
    [anon_sym_when] = ACTIONS(4289),
    [sym_discard] = ACTIONS(4649),
    [anon_sym_DOT_DOT] = ACTIONS(4329),
    [anon_sym_and] = ACTIONS(4331),
    [anon_sym_or] = ACTIONS(4331),
    [anon_sym_AMP_AMP] = ACTIONS(4329),
    [anon_sym_PIPE_PIPE] = ACTIONS(4329),
    [anon_sym_QMARK_QMARK] = ACTIONS(4329),
    [anon_sym_from] = ACTIONS(4331),
    [anon_sym_into] = ACTIONS(4289),
    [anon_sym_join] = ACTIONS(4331),
    [anon_sym_on] = ACTIONS(4289),
    [anon_sym_equals] = ACTIONS(4289),
    [anon_sym_let] = ACTIONS(4331),
    [anon_sym_orderby] = ACTIONS(4331),
    [anon_sym_ascending] = ACTIONS(4289),
    [anon_sym_descending] = ACTIONS(4289),
    [anon_sym_group] = ACTIONS(4331),
    [anon_sym_by] = ACTIONS(4289),
    [anon_sym_select] = ACTIONS(4331),
    [anon_sym_as] = ACTIONS(4331),
    [anon_sym_is] = ACTIONS(4331),
    [anon_sym_DASH_GT] = ACTIONS(4329),
    [anon_sym_with] = ACTIONS(4331),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3140] = {
    [sym_property_pattern_clause] = STATE(3501),
    [sym__variable_designation] = STATE(4256),
    [sym_parenthesized_variable_designation] = STATE(4274),
    [sym_identifier] = STATE(4269),
    [sym__reserved_identifier] = STATE(3908),
    [sym_preproc_region] = STATE(3140),
    [sym_preproc_endregion] = STATE(3140),
    [sym_preproc_line] = STATE(3140),
    [sym_preproc_pragma] = STATE(3140),
    [sym_preproc_nullable] = STATE(3140),
    [sym_preproc_error] = STATE(3140),
    [sym_preproc_define] = STATE(3140),
    [sym_preproc_undef] = STATE(3140),
    [sym__identifier_token] = ACTIONS(4271),
    [anon_sym_alias] = ACTIONS(4273),
    [anon_sym_global] = ACTIONS(4273),
    [anon_sym_LBRACK] = ACTIONS(4329),
    [anon_sym_LPAREN] = ACTIONS(4329),
    [anon_sym_LBRACE] = ACTIONS(4277),
    [anon_sym_file] = ACTIONS(4273),
    [anon_sym_LT] = ACTIONS(4331),
    [anon_sym_GT] = ACTIONS(4331),
    [anon_sym_where] = ACTIONS(4273),
    [anon_sym_QMARK] = ACTIONS(4331),
    [anon_sym_notnull] = ACTIONS(4273),
    [anon_sym_unmanaged] = ACTIONS(4273),
    [anon_sym_BANG] = ACTIONS(4331),
    [anon_sym_PLUS_PLUS] = ACTIONS(4329),
    [anon_sym_DASH_DASH] = ACTIONS(4329),
    [anon_sym_PLUS] = ACTIONS(4331),
    [anon_sym_DASH] = ACTIONS(4331),
    [anon_sym_STAR] = ACTIONS(4329),
    [anon_sym_SLASH] = ACTIONS(4331),
    [anon_sym_PERCENT] = ACTIONS(4329),
    [anon_sym_CARET] = ACTIONS(4329),
    [anon_sym_PIPE] = ACTIONS(4331),
    [anon_sym_AMP] = ACTIONS(4331),
    [anon_sym_LT_LT] = ACTIONS(4329),
    [anon_sym_GT_GT] = ACTIONS(4331),
    [anon_sym_GT_GT_GT] = ACTIONS(4329),
    [anon_sym_EQ_EQ] = ACTIONS(4329),
    [anon_sym_BANG_EQ] = ACTIONS(4329),
    [anon_sym_GT_EQ] = ACTIONS(4329),
    [anon_sym_LT_EQ] = ACTIONS(4329),
    [anon_sym_DOT] = ACTIONS(4331),
    [anon_sym_scoped] = ACTIONS(4273),
    [anon_sym_var] = ACTIONS(4273),
    [anon_sym_yield] = ACTIONS(4273),
    [anon_sym_switch] = ACTIONS(4331),
    [anon_sym_when] = ACTIONS(4273),
    [sym_discard] = ACTIONS(4295),
    [anon_sym_DOT_DOT] = ACTIONS(4329),
    [anon_sym_and] = ACTIONS(4331),
    [anon_sym_or] = ACTIONS(4331),
    [anon_sym_AMP_AMP] = ACTIONS(4329),
    [anon_sym_PIPE_PIPE] = ACTIONS(4329),
    [anon_sym_QMARK_QMARK] = ACTIONS(4329),
    [anon_sym_from] = ACTIONS(4273),
    [anon_sym_into] = ACTIONS(4273),
    [anon_sym_join] = ACTIONS(4273),
    [anon_sym_on] = ACTIONS(4273),
    [anon_sym_equals] = ACTIONS(4273),
    [anon_sym_let] = ACTIONS(4273),
    [anon_sym_orderby] = ACTIONS(4273),
    [anon_sym_ascending] = ACTIONS(4273),
    [anon_sym_descending] = ACTIONS(4273),
    [anon_sym_group] = ACTIONS(4273),
    [anon_sym_by] = ACTIONS(4331),
    [anon_sym_select] = ACTIONS(4273),
    [anon_sym_as] = ACTIONS(4331),
    [anon_sym_is] = ACTIONS(4331),
    [anon_sym_DASH_GT] = ACTIONS(4329),
    [anon_sym_with] = ACTIONS(4331),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3141] = {
    [sym_property_pattern_clause] = STATE(3391),
    [sym__variable_designation] = STATE(4124),
    [sym_parenthesized_variable_designation] = STATE(4274),
    [sym_identifier] = STATE(4269),
    [sym__reserved_identifier] = STATE(3908),
    [sym_preproc_region] = STATE(3141),
    [sym_preproc_endregion] = STATE(3141),
    [sym_preproc_line] = STATE(3141),
    [sym_preproc_pragma] = STATE(3141),
    [sym_preproc_nullable] = STATE(3141),
    [sym_preproc_error] = STATE(3141),
    [sym_preproc_define] = STATE(3141),
    [sym_preproc_undef] = STATE(3141),
    [sym__identifier_token] = ACTIONS(4271),
    [anon_sym_alias] = ACTIONS(4273),
    [anon_sym_global] = ACTIONS(4273),
    [anon_sym_LBRACK] = ACTIONS(4335),
    [anon_sym_LPAREN] = ACTIONS(4335),
    [anon_sym_LBRACE] = ACTIONS(4277),
    [anon_sym_file] = ACTIONS(4273),
    [anon_sym_LT] = ACTIONS(4337),
    [anon_sym_GT] = ACTIONS(4337),
    [anon_sym_where] = ACTIONS(4273),
    [anon_sym_QMARK] = ACTIONS(4337),
    [anon_sym_notnull] = ACTIONS(4273),
    [anon_sym_unmanaged] = ACTIONS(4273),
    [anon_sym_BANG] = ACTIONS(4337),
    [anon_sym_PLUS_PLUS] = ACTIONS(4335),
    [anon_sym_DASH_DASH] = ACTIONS(4335),
    [anon_sym_PLUS] = ACTIONS(4337),
    [anon_sym_DASH] = ACTIONS(4337),
    [anon_sym_STAR] = ACTIONS(4335),
    [anon_sym_SLASH] = ACTIONS(4337),
    [anon_sym_PERCENT] = ACTIONS(4335),
    [anon_sym_CARET] = ACTIONS(4335),
    [anon_sym_PIPE] = ACTIONS(4337),
    [anon_sym_AMP] = ACTIONS(4337),
    [anon_sym_LT_LT] = ACTIONS(4335),
    [anon_sym_GT_GT] = ACTIONS(4337),
    [anon_sym_GT_GT_GT] = ACTIONS(4335),
    [anon_sym_EQ_EQ] = ACTIONS(4335),
    [anon_sym_BANG_EQ] = ACTIONS(4335),
    [anon_sym_GT_EQ] = ACTIONS(4335),
    [anon_sym_LT_EQ] = ACTIONS(4335),
    [anon_sym_DOT] = ACTIONS(4337),
    [anon_sym_scoped] = ACTIONS(4273),
    [anon_sym_var] = ACTIONS(4273),
    [anon_sym_yield] = ACTIONS(4273),
    [anon_sym_switch] = ACTIONS(4337),
    [anon_sym_when] = ACTIONS(4273),
    [sym_discard] = ACTIONS(4295),
    [anon_sym_DOT_DOT] = ACTIONS(4335),
    [anon_sym_and] = ACTIONS(4337),
    [anon_sym_or] = ACTIONS(4337),
    [anon_sym_AMP_AMP] = ACTIONS(4335),
    [anon_sym_PIPE_PIPE] = ACTIONS(4335),
    [anon_sym_QMARK_QMARK] = ACTIONS(4335),
    [anon_sym_from] = ACTIONS(4273),
    [anon_sym_into] = ACTIONS(4273),
    [anon_sym_join] = ACTIONS(4273),
    [anon_sym_on] = ACTIONS(4337),
    [anon_sym_equals] = ACTIONS(4273),
    [anon_sym_let] = ACTIONS(4273),
    [anon_sym_orderby] = ACTIONS(4273),
    [anon_sym_ascending] = ACTIONS(4273),
    [anon_sym_descending] = ACTIONS(4273),
    [anon_sym_group] = ACTIONS(4273),
    [anon_sym_by] = ACTIONS(4273),
    [anon_sym_select] = ACTIONS(4273),
    [anon_sym_as] = ACTIONS(4337),
    [anon_sym_is] = ACTIONS(4337),
    [anon_sym_DASH_GT] = ACTIONS(4335),
    [anon_sym_with] = ACTIONS(4337),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3142] = {
    [sym_preproc_region] = STATE(3142),
    [sym_preproc_endregion] = STATE(3142),
    [sym_preproc_line] = STATE(3142),
    [sym_preproc_pragma] = STATE(3142),
    [sym_preproc_nullable] = STATE(3142),
    [sym_preproc_error] = STATE(3142),
    [sym_preproc_define] = STATE(3142),
    [sym_preproc_undef] = STATE(3142),
    [sym__identifier_token] = ACTIONS(3247),
    [anon_sym_extern] = ACTIONS(3247),
    [anon_sym_alias] = ACTIONS(3247),
    [anon_sym_global] = ACTIONS(3247),
    [anon_sym_using] = ACTIONS(3247),
    [anon_sym_unsafe] = ACTIONS(3247),
    [anon_sym_static] = ACTIONS(3247),
    [anon_sym_LBRACK] = ACTIONS(3249),
    [anon_sym_LPAREN] = ACTIONS(3249),
    [anon_sym_event] = ACTIONS(3247),
    [anon_sym_namespace] = ACTIONS(3247),
    [anon_sym_class] = ACTIONS(3247),
    [anon_sym_ref] = ACTIONS(3247),
    [anon_sym_struct] = ACTIONS(3247),
    [anon_sym_enum] = ACTIONS(3247),
    [anon_sym_RBRACE] = ACTIONS(3249),
    [anon_sym_interface] = ACTIONS(3247),
    [anon_sym_delegate] = ACTIONS(3247),
    [anon_sym_record] = ACTIONS(3247),
    [anon_sym_abstract] = ACTIONS(3247),
    [anon_sym_async] = ACTIONS(3247),
    [anon_sym_const] = ACTIONS(3247),
    [anon_sym_file] = ACTIONS(3247),
    [anon_sym_fixed] = ACTIONS(3247),
    [anon_sym_internal] = ACTIONS(3247),
    [anon_sym_new] = ACTIONS(3247),
    [anon_sym_override] = ACTIONS(3247),
    [anon_sym_partial] = ACTIONS(3247),
    [anon_sym_private] = ACTIONS(3247),
    [anon_sym_protected] = ACTIONS(3247),
    [anon_sym_public] = ACTIONS(3247),
    [anon_sym_readonly] = ACTIONS(3247),
    [anon_sym_required] = ACTIONS(3247),
    [anon_sym_sealed] = ACTIONS(3247),
    [anon_sym_virtual] = ACTIONS(3247),
    [anon_sym_volatile] = ACTIONS(3247),
    [anon_sym_where] = ACTIONS(3247),
    [anon_sym_notnull] = ACTIONS(3247),
    [anon_sym_unmanaged] = ACTIONS(3247),
    [anon_sym_TILDE] = ACTIONS(3249),
    [anon_sym_implicit] = ACTIONS(3247),
    [anon_sym_explicit] = ACTIONS(3247),
    [anon_sym_scoped] = ACTIONS(3247),
    [anon_sym_var] = ACTIONS(3247),
    [sym_predefined_type] = ACTIONS(3247),
    [anon_sym_while] = ACTIONS(3247),
    [anon_sym_yield] = ACTIONS(3247),
    [anon_sym_when] = ACTIONS(3247),
    [anon_sym_else] = ACTIONS(3247),
    [anon_sym_from] = ACTIONS(3247),
    [anon_sym_into] = ACTIONS(3247),
    [anon_sym_join] = ACTIONS(3247),
    [anon_sym_on] = ACTIONS(3247),
    [anon_sym_equals] = ACTIONS(3247),
    [anon_sym_let] = ACTIONS(3247),
    [anon_sym_orderby] = ACTIONS(3247),
    [anon_sym_ascending] = ACTIONS(3247),
    [anon_sym_descending] = ACTIONS(3247),
    [anon_sym_group] = ACTIONS(3247),
    [anon_sym_by] = ACTIONS(3247),
    [anon_sym_select] = ACTIONS(3247),
    [aux_sym_preproc_if_token1] = ACTIONS(3249),
    [aux_sym_preproc_if_token3] = ACTIONS(3249),
    [aux_sym_preproc_else_token1] = ACTIONS(3249),
    [aux_sym_preproc_elif_token1] = ACTIONS(3249),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3143] = {
    [sym__variable_designation] = STATE(4035),
    [sym_parenthesized_variable_designation] = STATE(4015),
    [sym_identifier] = STATE(4020),
    [sym__reserved_identifier] = STATE(3908),
    [sym_preproc_region] = STATE(3143),
    [sym_preproc_endregion] = STATE(3143),
    [sym_preproc_line] = STATE(3143),
    [sym_preproc_pragma] = STATE(3143),
    [sym_preproc_nullable] = STATE(3143),
    [sym_preproc_error] = STATE(3143),
    [sym_preproc_define] = STATE(3143),
    [sym_preproc_undef] = STATE(3143),
    [sym__identifier_token] = ACTIONS(4271),
    [anon_sym_alias] = ACTIONS(4273),
    [anon_sym_global] = ACTIONS(4273),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COLON] = ACTIONS(4383),
    [anon_sym_LPAREN] = ACTIONS(4383),
    [anon_sym_file] = ACTIONS(4273),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_where] = ACTIONS(4273),
    [anon_sym_QMARK] = ACTIONS(4385),
    [anon_sym_notnull] = ACTIONS(4273),
    [anon_sym_unmanaged] = ACTIONS(4273),
    [anon_sym_BANG] = ACTIONS(4385),
    [anon_sym_PLUS_PLUS] = ACTIONS(4383),
    [anon_sym_DASH_DASH] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_DASH] = ACTIONS(4385),
    [anon_sym_STAR] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4385),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4385),
    [anon_sym_GT_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4383),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_scoped] = ACTIONS(4273),
    [anon_sym_EQ_GT] = ACTIONS(4383),
    [anon_sym_var] = ACTIONS(4273),
    [anon_sym_yield] = ACTIONS(4273),
    [anon_sym_switch] = ACTIONS(4385),
    [anon_sym_when] = ACTIONS(4385),
    [sym_discard] = ACTIONS(4281),
    [anon_sym_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4385),
    [anon_sym_or] = ACTIONS(4385),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_QMARK_QMARK] = ACTIONS(4383),
    [anon_sym_from] = ACTIONS(4273),
    [anon_sym_into] = ACTIONS(4385),
    [anon_sym_join] = ACTIONS(4273),
    [anon_sym_on] = ACTIONS(4273),
    [anon_sym_equals] = ACTIONS(4273),
    [anon_sym_let] = ACTIONS(4273),
    [anon_sym_orderby] = ACTIONS(4273),
    [anon_sym_ascending] = ACTIONS(4273),
    [anon_sym_descending] = ACTIONS(4273),
    [anon_sym_group] = ACTIONS(4273),
    [anon_sym_by] = ACTIONS(4273),
    [anon_sym_select] = ACTIONS(4273),
    [anon_sym_as] = ACTIONS(4385),
    [anon_sym_is] = ACTIONS(4385),
    [anon_sym_DASH_GT] = ACTIONS(4383),
    [anon_sym_with] = ACTIONS(4385),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3144] = {
    [sym_preproc_region] = STATE(3144),
    [sym_preproc_endregion] = STATE(3144),
    [sym_preproc_line] = STATE(3144),
    [sym_preproc_pragma] = STATE(3144),
    [sym_preproc_nullable] = STATE(3144),
    [sym_preproc_error] = STATE(3144),
    [sym_preproc_define] = STATE(3144),
    [sym_preproc_undef] = STATE(3144),
    [sym__identifier_token] = ACTIONS(3271),
    [anon_sym_extern] = ACTIONS(3271),
    [anon_sym_alias] = ACTIONS(3271),
    [anon_sym_global] = ACTIONS(3271),
    [anon_sym_using] = ACTIONS(3271),
    [anon_sym_unsafe] = ACTIONS(3271),
    [anon_sym_static] = ACTIONS(3271),
    [anon_sym_LBRACK] = ACTIONS(3273),
    [anon_sym_LPAREN] = ACTIONS(3273),
    [anon_sym_event] = ACTIONS(3271),
    [anon_sym_namespace] = ACTIONS(3271),
    [anon_sym_class] = ACTIONS(3271),
    [anon_sym_ref] = ACTIONS(3271),
    [anon_sym_struct] = ACTIONS(3271),
    [anon_sym_enum] = ACTIONS(3271),
    [anon_sym_RBRACE] = ACTIONS(3273),
    [anon_sym_interface] = ACTIONS(3271),
    [anon_sym_delegate] = ACTIONS(3271),
    [anon_sym_record] = ACTIONS(3271),
    [anon_sym_abstract] = ACTIONS(3271),
    [anon_sym_async] = ACTIONS(3271),
    [anon_sym_const] = ACTIONS(3271),
    [anon_sym_file] = ACTIONS(3271),
    [anon_sym_fixed] = ACTIONS(3271),
    [anon_sym_internal] = ACTIONS(3271),
    [anon_sym_new] = ACTIONS(3271),
    [anon_sym_override] = ACTIONS(3271),
    [anon_sym_partial] = ACTIONS(3271),
    [anon_sym_private] = ACTIONS(3271),
    [anon_sym_protected] = ACTIONS(3271),
    [anon_sym_public] = ACTIONS(3271),
    [anon_sym_readonly] = ACTIONS(3271),
    [anon_sym_required] = ACTIONS(3271),
    [anon_sym_sealed] = ACTIONS(3271),
    [anon_sym_virtual] = ACTIONS(3271),
    [anon_sym_volatile] = ACTIONS(3271),
    [anon_sym_where] = ACTIONS(3271),
    [anon_sym_notnull] = ACTIONS(3271),
    [anon_sym_unmanaged] = ACTIONS(3271),
    [anon_sym_TILDE] = ACTIONS(3273),
    [anon_sym_implicit] = ACTIONS(3271),
    [anon_sym_explicit] = ACTIONS(3271),
    [anon_sym_scoped] = ACTIONS(3271),
    [anon_sym_var] = ACTIONS(3271),
    [sym_predefined_type] = ACTIONS(3271),
    [anon_sym_while] = ACTIONS(3271),
    [anon_sym_yield] = ACTIONS(3271),
    [anon_sym_when] = ACTIONS(3271),
    [anon_sym_else] = ACTIONS(3271),
    [anon_sym_from] = ACTIONS(3271),
    [anon_sym_into] = ACTIONS(3271),
    [anon_sym_join] = ACTIONS(3271),
    [anon_sym_on] = ACTIONS(3271),
    [anon_sym_equals] = ACTIONS(3271),
    [anon_sym_let] = ACTIONS(3271),
    [anon_sym_orderby] = ACTIONS(3271),
    [anon_sym_ascending] = ACTIONS(3271),
    [anon_sym_descending] = ACTIONS(3271),
    [anon_sym_group] = ACTIONS(3271),
    [anon_sym_by] = ACTIONS(3271),
    [anon_sym_select] = ACTIONS(3271),
    [aux_sym_preproc_if_token1] = ACTIONS(3273),
    [aux_sym_preproc_if_token3] = ACTIONS(3273),
    [aux_sym_preproc_else_token1] = ACTIONS(3273),
    [aux_sym_preproc_elif_token1] = ACTIONS(3273),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3145] = {
    [sym_property_pattern_clause] = STATE(3480),
    [sym__variable_designation] = STATE(4057),
    [sym_parenthesized_variable_designation] = STATE(4015),
    [sym_identifier] = STATE(4020),
    [sym__reserved_identifier] = STATE(3908),
    [sym_preproc_region] = STATE(3145),
    [sym_preproc_endregion] = STATE(3145),
    [sym_preproc_line] = STATE(3145),
    [sym_preproc_pragma] = STATE(3145),
    [sym_preproc_nullable] = STATE(3145),
    [sym_preproc_error] = STATE(3145),
    [sym_preproc_define] = STATE(3145),
    [sym_preproc_undef] = STATE(3145),
    [sym__identifier_token] = ACTIONS(4271),
    [anon_sym_alias] = ACTIONS(4273),
    [anon_sym_global] = ACTIONS(4273),
    [anon_sym_LBRACK] = ACTIONS(4335),
    [anon_sym_LPAREN] = ACTIONS(4335),
    [anon_sym_LBRACE] = ACTIONS(4277),
    [anon_sym_file] = ACTIONS(4273),
    [anon_sym_LT] = ACTIONS(4337),
    [anon_sym_GT] = ACTIONS(4337),
    [anon_sym_where] = ACTIONS(4273),
    [anon_sym_QMARK] = ACTIONS(4337),
    [anon_sym_notnull] = ACTIONS(4273),
    [anon_sym_unmanaged] = ACTIONS(4273),
    [anon_sym_BANG] = ACTIONS(4337),
    [anon_sym_PLUS_PLUS] = ACTIONS(4335),
    [anon_sym_DASH_DASH] = ACTIONS(4335),
    [anon_sym_PLUS] = ACTIONS(4337),
    [anon_sym_DASH] = ACTIONS(4337),
    [anon_sym_STAR] = ACTIONS(4335),
    [anon_sym_SLASH] = ACTIONS(4337),
    [anon_sym_PERCENT] = ACTIONS(4335),
    [anon_sym_CARET] = ACTIONS(4335),
    [anon_sym_PIPE] = ACTIONS(4337),
    [anon_sym_AMP] = ACTIONS(4337),
    [anon_sym_LT_LT] = ACTIONS(4335),
    [anon_sym_GT_GT] = ACTIONS(4337),
    [anon_sym_GT_GT_GT] = ACTIONS(4335),
    [anon_sym_EQ_EQ] = ACTIONS(4335),
    [anon_sym_BANG_EQ] = ACTIONS(4335),
    [anon_sym_GT_EQ] = ACTIONS(4335),
    [anon_sym_LT_EQ] = ACTIONS(4335),
    [anon_sym_DOT] = ACTIONS(4337),
    [anon_sym_scoped] = ACTIONS(4273),
    [anon_sym_var] = ACTIONS(4273),
    [anon_sym_yield] = ACTIONS(4273),
    [anon_sym_switch] = ACTIONS(4337),
    [anon_sym_when] = ACTIONS(4273),
    [sym_discard] = ACTIONS(4281),
    [anon_sym_DOT_DOT] = ACTIONS(4335),
    [anon_sym_and] = ACTIONS(4337),
    [anon_sym_or] = ACTIONS(4337),
    [anon_sym_AMP_AMP] = ACTIONS(4335),
    [anon_sym_PIPE_PIPE] = ACTIONS(4335),
    [anon_sym_QMARK_QMARK] = ACTIONS(4335),
    [anon_sym_from] = ACTIONS(4273),
    [anon_sym_into] = ACTIONS(4337),
    [anon_sym_join] = ACTIONS(4273),
    [anon_sym_on] = ACTIONS(4273),
    [anon_sym_equals] = ACTIONS(4337),
    [anon_sym_let] = ACTIONS(4273),
    [anon_sym_orderby] = ACTIONS(4273),
    [anon_sym_ascending] = ACTIONS(4273),
    [anon_sym_descending] = ACTIONS(4273),
    [anon_sym_group] = ACTIONS(4273),
    [anon_sym_by] = ACTIONS(4273),
    [anon_sym_select] = ACTIONS(4273),
    [anon_sym_as] = ACTIONS(4337),
    [anon_sym_is] = ACTIONS(4337),
    [anon_sym_DASH_GT] = ACTIONS(4335),
    [anon_sym_with] = ACTIONS(4337),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3146] = {
    [sym_preproc_region] = STATE(3146),
    [sym_preproc_endregion] = STATE(3146),
    [sym_preproc_line] = STATE(3146),
    [sym_preproc_pragma] = STATE(3146),
    [sym_preproc_nullable] = STATE(3146),
    [sym_preproc_error] = STATE(3146),
    [sym_preproc_define] = STATE(3146),
    [sym_preproc_undef] = STATE(3146),
    [anon_sym_SEMI] = ACTIONS(3719),
    [anon_sym_EQ] = ACTIONS(3721),
    [anon_sym_LBRACK] = ACTIONS(3719),
    [anon_sym_COLON] = ACTIONS(3719),
    [anon_sym_COMMA] = ACTIONS(3719),
    [anon_sym_RBRACK] = ACTIONS(3719),
    [anon_sym_LPAREN] = ACTIONS(3719),
    [anon_sym_RPAREN] = ACTIONS(3719),
    [anon_sym_LBRACE] = ACTIONS(3719),
    [anon_sym_RBRACE] = ACTIONS(3719),
    [anon_sym_LT] = ACTIONS(3721),
    [anon_sym_GT] = ACTIONS(3721),
    [anon_sym_in] = ACTIONS(3719),
    [anon_sym_where] = ACTIONS(3719),
    [anon_sym_QMARK] = ACTIONS(3721),
    [anon_sym_BANG] = ACTIONS(3721),
    [anon_sym_PLUS_PLUS] = ACTIONS(3719),
    [anon_sym_DASH_DASH] = ACTIONS(3719),
    [anon_sym_PLUS] = ACTIONS(3721),
    [anon_sym_DASH] = ACTIONS(3721),
    [anon_sym_STAR] = ACTIONS(3721),
    [anon_sym_SLASH] = ACTIONS(3721),
    [anon_sym_PERCENT] = ACTIONS(3721),
    [anon_sym_CARET] = ACTIONS(3721),
    [anon_sym_PIPE] = ACTIONS(3721),
    [anon_sym_AMP] = ACTIONS(3721),
    [anon_sym_LT_LT] = ACTIONS(3721),
    [anon_sym_GT_GT] = ACTIONS(3721),
    [anon_sym_GT_GT_GT] = ACTIONS(3721),
    [anon_sym_EQ_EQ] = ACTIONS(3719),
    [anon_sym_BANG_EQ] = ACTIONS(3719),
    [anon_sym_GT_EQ] = ACTIONS(3719),
    [anon_sym_LT_EQ] = ACTIONS(3719),
    [anon_sym_DOT] = ACTIONS(3721),
    [anon_sym_EQ_GT] = ACTIONS(3719),
    [anon_sym_switch] = ACTIONS(3719),
    [anon_sym_when] = ACTIONS(3719),
    [anon_sym_DOT_DOT] = ACTIONS(3719),
    [anon_sym_and] = ACTIONS(3719),
    [anon_sym_or] = ACTIONS(3719),
    [anon_sym_PLUS_EQ] = ACTIONS(3719),
    [anon_sym_DASH_EQ] = ACTIONS(3719),
    [anon_sym_STAR_EQ] = ACTIONS(3719),
    [anon_sym_SLASH_EQ] = ACTIONS(3719),
    [anon_sym_PERCENT_EQ] = ACTIONS(3719),
    [anon_sym_AMP_EQ] = ACTIONS(3719),
    [anon_sym_CARET_EQ] = ACTIONS(3719),
    [anon_sym_PIPE_EQ] = ACTIONS(3719),
    [anon_sym_LT_LT_EQ] = ACTIONS(3719),
    [anon_sym_GT_GT_EQ] = ACTIONS(3719),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3719),
    [anon_sym_AMP_AMP] = ACTIONS(3719),
    [anon_sym_PIPE_PIPE] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK] = ACTIONS(3721),
    [anon_sym_on] = ACTIONS(3719),
    [anon_sym_equals] = ACTIONS(3719),
    [anon_sym_by] = ACTIONS(3719),
    [anon_sym_as] = ACTIONS(3719),
    [anon_sym_is] = ACTIONS(3719),
    [anon_sym_DASH_GT] = ACTIONS(3719),
    [anon_sym_with] = ACTIONS(3719),
    [aux_sym_preproc_if_token3] = ACTIONS(3719),
    [aux_sym_preproc_else_token1] = ACTIONS(3719),
    [aux_sym_preproc_elif_token1] = ACTIONS(3719),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3147] = {
    [sym__variable_designation] = STATE(4123),
    [sym_parenthesized_variable_designation] = STATE(4274),
    [sym_identifier] = STATE(4269),
    [sym__reserved_identifier] = STATE(3908),
    [sym_preproc_region] = STATE(3147),
    [sym_preproc_endregion] = STATE(3147),
    [sym_preproc_line] = STATE(3147),
    [sym_preproc_pragma] = STATE(3147),
    [sym_preproc_nullable] = STATE(3147),
    [sym_preproc_error] = STATE(3147),
    [sym_preproc_define] = STATE(3147),
    [sym_preproc_undef] = STATE(3147),
    [sym__identifier_token] = ACTIONS(4271),
    [anon_sym_alias] = ACTIONS(4273),
    [anon_sym_global] = ACTIONS(4273),
    [anon_sym_LBRACK] = ACTIONS(4335),
    [anon_sym_COLON] = ACTIONS(4335),
    [anon_sym_LPAREN] = ACTIONS(4335),
    [anon_sym_file] = ACTIONS(4273),
    [anon_sym_LT] = ACTIONS(4337),
    [anon_sym_GT] = ACTIONS(4337),
    [anon_sym_where] = ACTIONS(4273),
    [anon_sym_QMARK] = ACTIONS(4337),
    [anon_sym_notnull] = ACTIONS(4273),
    [anon_sym_unmanaged] = ACTIONS(4273),
    [anon_sym_BANG] = ACTIONS(4337),
    [anon_sym_PLUS_PLUS] = ACTIONS(4335),
    [anon_sym_DASH_DASH] = ACTIONS(4335),
    [anon_sym_PLUS] = ACTIONS(4337),
    [anon_sym_DASH] = ACTIONS(4337),
    [anon_sym_STAR] = ACTIONS(4335),
    [anon_sym_SLASH] = ACTIONS(4337),
    [anon_sym_PERCENT] = ACTIONS(4335),
    [anon_sym_CARET] = ACTIONS(4335),
    [anon_sym_PIPE] = ACTIONS(4337),
    [anon_sym_AMP] = ACTIONS(4337),
    [anon_sym_LT_LT] = ACTIONS(4335),
    [anon_sym_GT_GT] = ACTIONS(4337),
    [anon_sym_GT_GT_GT] = ACTIONS(4335),
    [anon_sym_EQ_EQ] = ACTIONS(4335),
    [anon_sym_BANG_EQ] = ACTIONS(4335),
    [anon_sym_GT_EQ] = ACTIONS(4335),
    [anon_sym_LT_EQ] = ACTIONS(4335),
    [anon_sym_DOT] = ACTIONS(4337),
    [anon_sym_scoped] = ACTIONS(4273),
    [anon_sym_EQ_GT] = ACTIONS(4335),
    [anon_sym_var] = ACTIONS(4273),
    [anon_sym_yield] = ACTIONS(4273),
    [anon_sym_switch] = ACTIONS(4337),
    [anon_sym_when] = ACTIONS(4337),
    [sym_discard] = ACTIONS(4295),
    [anon_sym_DOT_DOT] = ACTIONS(4335),
    [anon_sym_and] = ACTIONS(4337),
    [anon_sym_or] = ACTIONS(4337),
    [anon_sym_AMP_AMP] = ACTIONS(4335),
    [anon_sym_PIPE_PIPE] = ACTIONS(4335),
    [anon_sym_QMARK_QMARK] = ACTIONS(4335),
    [anon_sym_from] = ACTIONS(4273),
    [anon_sym_into] = ACTIONS(4273),
    [anon_sym_join] = ACTIONS(4273),
    [anon_sym_on] = ACTIONS(4273),
    [anon_sym_equals] = ACTIONS(4273),
    [anon_sym_let] = ACTIONS(4273),
    [anon_sym_orderby] = ACTIONS(4273),
    [anon_sym_ascending] = ACTIONS(4273),
    [anon_sym_descending] = ACTIONS(4273),
    [anon_sym_group] = ACTIONS(4273),
    [anon_sym_by] = ACTIONS(4273),
    [anon_sym_select] = ACTIONS(4273),
    [anon_sym_as] = ACTIONS(4337),
    [anon_sym_is] = ACTIONS(4337),
    [anon_sym_DASH_GT] = ACTIONS(4335),
    [anon_sym_with] = ACTIONS(4337),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3148] = {
    [sym__variable_designation] = STATE(4246),
    [sym_parenthesized_variable_designation] = STATE(4274),
    [sym_identifier] = STATE(4269),
    [sym__reserved_identifier] = STATE(3908),
    [sym_preproc_region] = STATE(3148),
    [sym_preproc_endregion] = STATE(3148),
    [sym_preproc_line] = STATE(3148),
    [sym_preproc_pragma] = STATE(3148),
    [sym_preproc_nullable] = STATE(3148),
    [sym_preproc_error] = STATE(3148),
    [sym_preproc_define] = STATE(3148),
    [sym_preproc_undef] = STATE(3148),
    [sym__identifier_token] = ACTIONS(4271),
    [anon_sym_alias] = ACTIONS(4273),
    [anon_sym_global] = ACTIONS(4273),
    [anon_sym_LBRACK] = ACTIONS(4329),
    [anon_sym_COLON] = ACTIONS(4329),
    [anon_sym_LPAREN] = ACTIONS(4329),
    [anon_sym_file] = ACTIONS(4273),
    [anon_sym_LT] = ACTIONS(4331),
    [anon_sym_GT] = ACTIONS(4331),
    [anon_sym_where] = ACTIONS(4273),
    [anon_sym_QMARK] = ACTIONS(4331),
    [anon_sym_notnull] = ACTIONS(4273),
    [anon_sym_unmanaged] = ACTIONS(4273),
    [anon_sym_BANG] = ACTIONS(4331),
    [anon_sym_PLUS_PLUS] = ACTIONS(4329),
    [anon_sym_DASH_DASH] = ACTIONS(4329),
    [anon_sym_PLUS] = ACTIONS(4331),
    [anon_sym_DASH] = ACTIONS(4331),
    [anon_sym_STAR] = ACTIONS(4329),
    [anon_sym_SLASH] = ACTIONS(4331),
    [anon_sym_PERCENT] = ACTIONS(4329),
    [anon_sym_CARET] = ACTIONS(4329),
    [anon_sym_PIPE] = ACTIONS(4331),
    [anon_sym_AMP] = ACTIONS(4331),
    [anon_sym_LT_LT] = ACTIONS(4329),
    [anon_sym_GT_GT] = ACTIONS(4331),
    [anon_sym_GT_GT_GT] = ACTIONS(4329),
    [anon_sym_EQ_EQ] = ACTIONS(4329),
    [anon_sym_BANG_EQ] = ACTIONS(4329),
    [anon_sym_GT_EQ] = ACTIONS(4329),
    [anon_sym_LT_EQ] = ACTIONS(4329),
    [anon_sym_DOT] = ACTIONS(4331),
    [anon_sym_scoped] = ACTIONS(4273),
    [anon_sym_EQ_GT] = ACTIONS(4329),
    [anon_sym_var] = ACTIONS(4273),
    [anon_sym_yield] = ACTIONS(4273),
    [anon_sym_switch] = ACTIONS(4331),
    [anon_sym_when] = ACTIONS(4331),
    [sym_discard] = ACTIONS(4295),
    [anon_sym_DOT_DOT] = ACTIONS(4329),
    [anon_sym_and] = ACTIONS(4331),
    [anon_sym_or] = ACTIONS(4331),
    [anon_sym_AMP_AMP] = ACTIONS(4329),
    [anon_sym_PIPE_PIPE] = ACTIONS(4329),
    [anon_sym_QMARK_QMARK] = ACTIONS(4329),
    [anon_sym_from] = ACTIONS(4273),
    [anon_sym_into] = ACTIONS(4273),
    [anon_sym_join] = ACTIONS(4273),
    [anon_sym_on] = ACTIONS(4273),
    [anon_sym_equals] = ACTIONS(4273),
    [anon_sym_let] = ACTIONS(4273),
    [anon_sym_orderby] = ACTIONS(4273),
    [anon_sym_ascending] = ACTIONS(4273),
    [anon_sym_descending] = ACTIONS(4273),
    [anon_sym_group] = ACTIONS(4273),
    [anon_sym_by] = ACTIONS(4273),
    [anon_sym_select] = ACTIONS(4273),
    [anon_sym_as] = ACTIONS(4331),
    [anon_sym_is] = ACTIONS(4331),
    [anon_sym_DASH_GT] = ACTIONS(4329),
    [anon_sym_with] = ACTIONS(4331),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3149] = {
    [sym_property_pattern_clause] = STATE(3452),
    [sym__variable_designation] = STATE(4023),
    [sym_parenthesized_variable_designation] = STATE(4015),
    [sym_identifier] = STATE(4020),
    [sym__reserved_identifier] = STATE(3908),
    [sym_preproc_region] = STATE(3149),
    [sym_preproc_endregion] = STATE(3149),
    [sym_preproc_line] = STATE(3149),
    [sym_preproc_pragma] = STATE(3149),
    [sym_preproc_nullable] = STATE(3149),
    [sym_preproc_error] = STATE(3149),
    [sym_preproc_define] = STATE(3149),
    [sym_preproc_undef] = STATE(3149),
    [sym__identifier_token] = ACTIONS(4271),
    [anon_sym_alias] = ACTIONS(4273),
    [anon_sym_global] = ACTIONS(4273),
    [anon_sym_LBRACK] = ACTIONS(4329),
    [anon_sym_LPAREN] = ACTIONS(4329),
    [anon_sym_LBRACE] = ACTIONS(4277),
    [anon_sym_file] = ACTIONS(4273),
    [anon_sym_LT] = ACTIONS(4331),
    [anon_sym_GT] = ACTIONS(4331),
    [anon_sym_where] = ACTIONS(4273),
    [anon_sym_QMARK] = ACTIONS(4331),
    [anon_sym_notnull] = ACTIONS(4273),
    [anon_sym_unmanaged] = ACTIONS(4273),
    [anon_sym_BANG] = ACTIONS(4331),
    [anon_sym_PLUS_PLUS] = ACTIONS(4329),
    [anon_sym_DASH_DASH] = ACTIONS(4329),
    [anon_sym_PLUS] = ACTIONS(4331),
    [anon_sym_DASH] = ACTIONS(4331),
    [anon_sym_STAR] = ACTIONS(4329),
    [anon_sym_SLASH] = ACTIONS(4331),
    [anon_sym_PERCENT] = ACTIONS(4329),
    [anon_sym_CARET] = ACTIONS(4329),
    [anon_sym_PIPE] = ACTIONS(4331),
    [anon_sym_AMP] = ACTIONS(4331),
    [anon_sym_LT_LT] = ACTIONS(4329),
    [anon_sym_GT_GT] = ACTIONS(4331),
    [anon_sym_GT_GT_GT] = ACTIONS(4329),
    [anon_sym_EQ_EQ] = ACTIONS(4329),
    [anon_sym_BANG_EQ] = ACTIONS(4329),
    [anon_sym_GT_EQ] = ACTIONS(4329),
    [anon_sym_LT_EQ] = ACTIONS(4329),
    [anon_sym_DOT] = ACTIONS(4331),
    [anon_sym_scoped] = ACTIONS(4273),
    [anon_sym_var] = ACTIONS(4273),
    [anon_sym_yield] = ACTIONS(4273),
    [anon_sym_switch] = ACTIONS(4331),
    [anon_sym_when] = ACTIONS(4273),
    [sym_discard] = ACTIONS(4281),
    [anon_sym_DOT_DOT] = ACTIONS(4329),
    [anon_sym_and] = ACTIONS(4331),
    [anon_sym_or] = ACTIONS(4331),
    [anon_sym_AMP_AMP] = ACTIONS(4329),
    [anon_sym_PIPE_PIPE] = ACTIONS(4329),
    [anon_sym_QMARK_QMARK] = ACTIONS(4329),
    [anon_sym_from] = ACTIONS(4273),
    [anon_sym_into] = ACTIONS(4331),
    [anon_sym_join] = ACTIONS(4273),
    [anon_sym_on] = ACTIONS(4331),
    [anon_sym_equals] = ACTIONS(4273),
    [anon_sym_let] = ACTIONS(4273),
    [anon_sym_orderby] = ACTIONS(4273),
    [anon_sym_ascending] = ACTIONS(4273),
    [anon_sym_descending] = ACTIONS(4273),
    [anon_sym_group] = ACTIONS(4273),
    [anon_sym_by] = ACTIONS(4273),
    [anon_sym_select] = ACTIONS(4273),
    [anon_sym_as] = ACTIONS(4331),
    [anon_sym_is] = ACTIONS(4331),
    [anon_sym_DASH_GT] = ACTIONS(4329),
    [anon_sym_with] = ACTIONS(4331),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3150] = {
    [sym_property_pattern_clause] = STATE(3369),
    [sym__variable_designation] = STATE(4256),
    [sym_parenthesized_variable_designation] = STATE(4274),
    [sym_identifier] = STATE(4269),
    [sym__reserved_identifier] = STATE(3908),
    [sym_preproc_region] = STATE(3150),
    [sym_preproc_endregion] = STATE(3150),
    [sym_preproc_line] = STATE(3150),
    [sym_preproc_pragma] = STATE(3150),
    [sym_preproc_nullable] = STATE(3150),
    [sym_preproc_error] = STATE(3150),
    [sym_preproc_define] = STATE(3150),
    [sym_preproc_undef] = STATE(3150),
    [sym__identifier_token] = ACTIONS(4271),
    [anon_sym_alias] = ACTIONS(4273),
    [anon_sym_global] = ACTIONS(4273),
    [anon_sym_LBRACK] = ACTIONS(4329),
    [anon_sym_LPAREN] = ACTIONS(4329),
    [anon_sym_LBRACE] = ACTIONS(4277),
    [anon_sym_file] = ACTIONS(4273),
    [anon_sym_LT] = ACTIONS(4331),
    [anon_sym_GT] = ACTIONS(4331),
    [anon_sym_where] = ACTIONS(4273),
    [anon_sym_QMARK] = ACTIONS(4331),
    [anon_sym_notnull] = ACTIONS(4273),
    [anon_sym_unmanaged] = ACTIONS(4273),
    [anon_sym_BANG] = ACTIONS(4331),
    [anon_sym_PLUS_PLUS] = ACTIONS(4329),
    [anon_sym_DASH_DASH] = ACTIONS(4329),
    [anon_sym_PLUS] = ACTIONS(4331),
    [anon_sym_DASH] = ACTIONS(4331),
    [anon_sym_STAR] = ACTIONS(4329),
    [anon_sym_SLASH] = ACTIONS(4331),
    [anon_sym_PERCENT] = ACTIONS(4329),
    [anon_sym_CARET] = ACTIONS(4329),
    [anon_sym_PIPE] = ACTIONS(4331),
    [anon_sym_AMP] = ACTIONS(4331),
    [anon_sym_LT_LT] = ACTIONS(4329),
    [anon_sym_GT_GT] = ACTIONS(4331),
    [anon_sym_GT_GT_GT] = ACTIONS(4329),
    [anon_sym_EQ_EQ] = ACTIONS(4329),
    [anon_sym_BANG_EQ] = ACTIONS(4329),
    [anon_sym_GT_EQ] = ACTIONS(4329),
    [anon_sym_LT_EQ] = ACTIONS(4329),
    [anon_sym_DOT] = ACTIONS(4331),
    [anon_sym_scoped] = ACTIONS(4273),
    [anon_sym_var] = ACTIONS(4273),
    [anon_sym_yield] = ACTIONS(4273),
    [anon_sym_switch] = ACTIONS(4331),
    [anon_sym_when] = ACTIONS(4273),
    [sym_discard] = ACTIONS(4295),
    [anon_sym_DOT_DOT] = ACTIONS(4329),
    [anon_sym_and] = ACTIONS(4331),
    [anon_sym_or] = ACTIONS(4331),
    [anon_sym_AMP_AMP] = ACTIONS(4329),
    [anon_sym_PIPE_PIPE] = ACTIONS(4329),
    [anon_sym_QMARK_QMARK] = ACTIONS(4329),
    [anon_sym_from] = ACTIONS(4273),
    [anon_sym_into] = ACTIONS(4273),
    [anon_sym_join] = ACTIONS(4273),
    [anon_sym_on] = ACTIONS(4273),
    [anon_sym_equals] = ACTIONS(4331),
    [anon_sym_let] = ACTIONS(4273),
    [anon_sym_orderby] = ACTIONS(4273),
    [anon_sym_ascending] = ACTIONS(4273),
    [anon_sym_descending] = ACTIONS(4273),
    [anon_sym_group] = ACTIONS(4273),
    [anon_sym_by] = ACTIONS(4273),
    [anon_sym_select] = ACTIONS(4273),
    [anon_sym_as] = ACTIONS(4331),
    [anon_sym_is] = ACTIONS(4331),
    [anon_sym_DASH_GT] = ACTIONS(4329),
    [anon_sym_with] = ACTIONS(4331),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3151] = {
    [sym_property_pattern_clause] = STATE(3390),
    [sym__variable_designation] = STATE(4256),
    [sym_parenthesized_variable_designation] = STATE(4274),
    [sym_identifier] = STATE(4269),
    [sym__reserved_identifier] = STATE(3908),
    [sym_preproc_region] = STATE(3151),
    [sym_preproc_endregion] = STATE(3151),
    [sym_preproc_line] = STATE(3151),
    [sym_preproc_pragma] = STATE(3151),
    [sym_preproc_nullable] = STATE(3151),
    [sym_preproc_error] = STATE(3151),
    [sym_preproc_define] = STATE(3151),
    [sym_preproc_undef] = STATE(3151),
    [sym__identifier_token] = ACTIONS(4271),
    [anon_sym_alias] = ACTIONS(4273),
    [anon_sym_global] = ACTIONS(4273),
    [anon_sym_LBRACK] = ACTIONS(4329),
    [anon_sym_LPAREN] = ACTIONS(4329),
    [anon_sym_LBRACE] = ACTIONS(4277),
    [anon_sym_file] = ACTIONS(4273),
    [anon_sym_LT] = ACTIONS(4331),
    [anon_sym_GT] = ACTIONS(4331),
    [anon_sym_where] = ACTIONS(4273),
    [anon_sym_QMARK] = ACTIONS(4331),
    [anon_sym_notnull] = ACTIONS(4273),
    [anon_sym_unmanaged] = ACTIONS(4273),
    [anon_sym_BANG] = ACTIONS(4331),
    [anon_sym_PLUS_PLUS] = ACTIONS(4329),
    [anon_sym_DASH_DASH] = ACTIONS(4329),
    [anon_sym_PLUS] = ACTIONS(4331),
    [anon_sym_DASH] = ACTIONS(4331),
    [anon_sym_STAR] = ACTIONS(4329),
    [anon_sym_SLASH] = ACTIONS(4331),
    [anon_sym_PERCENT] = ACTIONS(4329),
    [anon_sym_CARET] = ACTIONS(4329),
    [anon_sym_PIPE] = ACTIONS(4331),
    [anon_sym_AMP] = ACTIONS(4331),
    [anon_sym_LT_LT] = ACTIONS(4329),
    [anon_sym_GT_GT] = ACTIONS(4331),
    [anon_sym_GT_GT_GT] = ACTIONS(4329),
    [anon_sym_EQ_EQ] = ACTIONS(4329),
    [anon_sym_BANG_EQ] = ACTIONS(4329),
    [anon_sym_GT_EQ] = ACTIONS(4329),
    [anon_sym_LT_EQ] = ACTIONS(4329),
    [anon_sym_DOT] = ACTIONS(4331),
    [anon_sym_scoped] = ACTIONS(4273),
    [anon_sym_var] = ACTIONS(4273),
    [anon_sym_yield] = ACTIONS(4273),
    [anon_sym_switch] = ACTIONS(4331),
    [anon_sym_when] = ACTIONS(4273),
    [sym_discard] = ACTIONS(4295),
    [anon_sym_DOT_DOT] = ACTIONS(4329),
    [anon_sym_and] = ACTIONS(4331),
    [anon_sym_or] = ACTIONS(4331),
    [anon_sym_AMP_AMP] = ACTIONS(4329),
    [anon_sym_PIPE_PIPE] = ACTIONS(4329),
    [anon_sym_QMARK_QMARK] = ACTIONS(4329),
    [anon_sym_from] = ACTIONS(4273),
    [anon_sym_into] = ACTIONS(4273),
    [anon_sym_join] = ACTIONS(4273),
    [anon_sym_on] = ACTIONS(4331),
    [anon_sym_equals] = ACTIONS(4273),
    [anon_sym_let] = ACTIONS(4273),
    [anon_sym_orderby] = ACTIONS(4273),
    [anon_sym_ascending] = ACTIONS(4273),
    [anon_sym_descending] = ACTIONS(4273),
    [anon_sym_group] = ACTIONS(4273),
    [anon_sym_by] = ACTIONS(4273),
    [anon_sym_select] = ACTIONS(4273),
    [anon_sym_as] = ACTIONS(4331),
    [anon_sym_is] = ACTIONS(4331),
    [anon_sym_DASH_GT] = ACTIONS(4329),
    [anon_sym_with] = ACTIONS(4331),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3152] = {
    [sym_preproc_region] = STATE(3152),
    [sym_preproc_endregion] = STATE(3152),
    [sym_preproc_line] = STATE(3152),
    [sym_preproc_pragma] = STATE(3152),
    [sym_preproc_nullable] = STATE(3152),
    [sym_preproc_error] = STATE(3152),
    [sym_preproc_define] = STATE(3152),
    [sym_preproc_undef] = STATE(3152),
    [sym__identifier_token] = ACTIONS(4580),
    [anon_sym_alias] = ACTIONS(4580),
    [anon_sym_global] = ACTIONS(4580),
    [anon_sym_LBRACK] = ACTIONS(2927),
    [anon_sym_COLON] = ACTIONS(2927),
    [anon_sym_COMMA] = ACTIONS(4582),
    [anon_sym_RBRACK] = ACTIONS(4582),
    [anon_sym_LPAREN] = ACTIONS(4582),
    [anon_sym_RPAREN] = ACTIONS(4582),
    [anon_sym_RBRACE] = ACTIONS(4582),
    [anon_sym_file] = ACTIONS(4580),
    [anon_sym_LT] = ACTIONS(2925),
    [anon_sym_GT] = ACTIONS(2925),
    [anon_sym_where] = ACTIONS(4580),
    [anon_sym_QMARK] = ACTIONS(2925),
    [anon_sym_notnull] = ACTIONS(4580),
    [anon_sym_unmanaged] = ACTIONS(4580),
    [anon_sym_BANG] = ACTIONS(2925),
    [anon_sym_PLUS_PLUS] = ACTIONS(2927),
    [anon_sym_DASH_DASH] = ACTIONS(2927),
    [anon_sym_PLUS] = ACTIONS(2925),
    [anon_sym_DASH] = ACTIONS(2925),
    [anon_sym_STAR] = ACTIONS(2927),
    [anon_sym_SLASH] = ACTIONS(2925),
    [anon_sym_PERCENT] = ACTIONS(2927),
    [anon_sym_CARET] = ACTIONS(2927),
    [anon_sym_PIPE] = ACTIONS(2925),
    [anon_sym_AMP] = ACTIONS(2925),
    [anon_sym_LT_LT] = ACTIONS(2927),
    [anon_sym_GT_GT] = ACTIONS(2925),
    [anon_sym_GT_GT_GT] = ACTIONS(2927),
    [anon_sym_EQ_EQ] = ACTIONS(2927),
    [anon_sym_BANG_EQ] = ACTIONS(2927),
    [anon_sym_GT_EQ] = ACTIONS(2927),
    [anon_sym_LT_EQ] = ACTIONS(2927),
    [anon_sym_DOT] = ACTIONS(2925),
    [anon_sym_scoped] = ACTIONS(4580),
    [anon_sym_EQ_GT] = ACTIONS(4582),
    [anon_sym_var] = ACTIONS(4580),
    [anon_sym_yield] = ACTIONS(4580),
    [anon_sym_switch] = ACTIONS(2925),
    [anon_sym_when] = ACTIONS(4580),
    [sym_discard] = ACTIONS(4580),
    [anon_sym_DOT_DOT] = ACTIONS(2927),
    [anon_sym_and] = ACTIONS(4580),
    [anon_sym_or] = ACTIONS(4580),
    [anon_sym_AMP_AMP] = ACTIONS(2927),
    [anon_sym_PIPE_PIPE] = ACTIONS(2927),
    [anon_sym_QMARK_QMARK] = ACTIONS(2927),
    [anon_sym_from] = ACTIONS(4580),
    [anon_sym_into] = ACTIONS(4580),
    [anon_sym_join] = ACTIONS(4580),
    [anon_sym_on] = ACTIONS(4580),
    [anon_sym_equals] = ACTIONS(4580),
    [anon_sym_let] = ACTIONS(4580),
    [anon_sym_orderby] = ACTIONS(4580),
    [anon_sym_ascending] = ACTIONS(4580),
    [anon_sym_descending] = ACTIONS(4580),
    [anon_sym_group] = ACTIONS(4580),
    [anon_sym_by] = ACTIONS(4580),
    [anon_sym_select] = ACTIONS(4580),
    [anon_sym_as] = ACTIONS(2925),
    [anon_sym_is] = ACTIONS(2925),
    [anon_sym_DASH_GT] = ACTIONS(2927),
    [anon_sym_with] = ACTIONS(2925),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3153] = {
    [sym_property_pattern_clause] = STATE(3410),
    [sym__variable_designation] = STATE(4023),
    [sym_parenthesized_variable_designation] = STATE(4015),
    [sym_identifier] = STATE(4020),
    [sym__reserved_identifier] = STATE(3908),
    [sym_preproc_region] = STATE(3153),
    [sym_preproc_endregion] = STATE(3153),
    [sym_preproc_line] = STATE(3153),
    [sym_preproc_pragma] = STATE(3153),
    [sym_preproc_nullable] = STATE(3153),
    [sym_preproc_error] = STATE(3153),
    [sym_preproc_define] = STATE(3153),
    [sym_preproc_undef] = STATE(3153),
    [sym__identifier_token] = ACTIONS(4271),
    [anon_sym_alias] = ACTIONS(4273),
    [anon_sym_global] = ACTIONS(4273),
    [anon_sym_LBRACK] = ACTIONS(4329),
    [anon_sym_LPAREN] = ACTIONS(4329),
    [anon_sym_LBRACE] = ACTIONS(4277),
    [anon_sym_file] = ACTIONS(4273),
    [anon_sym_LT] = ACTIONS(4331),
    [anon_sym_GT] = ACTIONS(4331),
    [anon_sym_where] = ACTIONS(4273),
    [anon_sym_QMARK] = ACTIONS(4331),
    [anon_sym_notnull] = ACTIONS(4273),
    [anon_sym_unmanaged] = ACTIONS(4273),
    [anon_sym_BANG] = ACTIONS(4331),
    [anon_sym_PLUS_PLUS] = ACTIONS(4329),
    [anon_sym_DASH_DASH] = ACTIONS(4329),
    [anon_sym_PLUS] = ACTIONS(4331),
    [anon_sym_DASH] = ACTIONS(4331),
    [anon_sym_STAR] = ACTIONS(4329),
    [anon_sym_SLASH] = ACTIONS(4331),
    [anon_sym_PERCENT] = ACTIONS(4329),
    [anon_sym_CARET] = ACTIONS(4329),
    [anon_sym_PIPE] = ACTIONS(4331),
    [anon_sym_AMP] = ACTIONS(4331),
    [anon_sym_LT_LT] = ACTIONS(4329),
    [anon_sym_GT_GT] = ACTIONS(4331),
    [anon_sym_GT_GT_GT] = ACTIONS(4329),
    [anon_sym_EQ_EQ] = ACTIONS(4329),
    [anon_sym_BANG_EQ] = ACTIONS(4329),
    [anon_sym_GT_EQ] = ACTIONS(4329),
    [anon_sym_LT_EQ] = ACTIONS(4329),
    [anon_sym_DOT] = ACTIONS(4331),
    [anon_sym_scoped] = ACTIONS(4273),
    [anon_sym_var] = ACTIONS(4273),
    [anon_sym_yield] = ACTIONS(4273),
    [anon_sym_switch] = ACTIONS(4331),
    [anon_sym_when] = ACTIONS(4273),
    [sym_discard] = ACTIONS(4281),
    [anon_sym_DOT_DOT] = ACTIONS(4329),
    [anon_sym_and] = ACTIONS(4331),
    [anon_sym_or] = ACTIONS(4331),
    [anon_sym_AMP_AMP] = ACTIONS(4329),
    [anon_sym_PIPE_PIPE] = ACTIONS(4329),
    [anon_sym_QMARK_QMARK] = ACTIONS(4329),
    [anon_sym_from] = ACTIONS(4273),
    [anon_sym_into] = ACTIONS(4331),
    [anon_sym_join] = ACTIONS(4273),
    [anon_sym_on] = ACTIONS(4273),
    [anon_sym_equals] = ACTIONS(4273),
    [anon_sym_let] = ACTIONS(4273),
    [anon_sym_orderby] = ACTIONS(4273),
    [anon_sym_ascending] = ACTIONS(4273),
    [anon_sym_descending] = ACTIONS(4273),
    [anon_sym_group] = ACTIONS(4273),
    [anon_sym_by] = ACTIONS(4331),
    [anon_sym_select] = ACTIONS(4273),
    [anon_sym_as] = ACTIONS(4331),
    [anon_sym_is] = ACTIONS(4331),
    [anon_sym_DASH_GT] = ACTIONS(4329),
    [anon_sym_with] = ACTIONS(4331),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3154] = {
    [sym_property_pattern_clause] = STATE(3451),
    [sym__variable_designation] = STATE(4057),
    [sym_parenthesized_variable_designation] = STATE(4015),
    [sym_identifier] = STATE(4020),
    [sym__reserved_identifier] = STATE(3908),
    [sym_preproc_region] = STATE(3154),
    [sym_preproc_endregion] = STATE(3154),
    [sym_preproc_line] = STATE(3154),
    [sym_preproc_pragma] = STATE(3154),
    [sym_preproc_nullable] = STATE(3154),
    [sym_preproc_error] = STATE(3154),
    [sym_preproc_define] = STATE(3154),
    [sym_preproc_undef] = STATE(3154),
    [sym__identifier_token] = ACTIONS(4271),
    [anon_sym_alias] = ACTIONS(4273),
    [anon_sym_global] = ACTIONS(4273),
    [anon_sym_LBRACK] = ACTIONS(4335),
    [anon_sym_LPAREN] = ACTIONS(4335),
    [anon_sym_LBRACE] = ACTIONS(4277),
    [anon_sym_file] = ACTIONS(4273),
    [anon_sym_LT] = ACTIONS(4337),
    [anon_sym_GT] = ACTIONS(4337),
    [anon_sym_where] = ACTIONS(4273),
    [anon_sym_QMARK] = ACTIONS(4337),
    [anon_sym_notnull] = ACTIONS(4273),
    [anon_sym_unmanaged] = ACTIONS(4273),
    [anon_sym_BANG] = ACTIONS(4337),
    [anon_sym_PLUS_PLUS] = ACTIONS(4335),
    [anon_sym_DASH_DASH] = ACTIONS(4335),
    [anon_sym_PLUS] = ACTIONS(4337),
    [anon_sym_DASH] = ACTIONS(4337),
    [anon_sym_STAR] = ACTIONS(4335),
    [anon_sym_SLASH] = ACTIONS(4337),
    [anon_sym_PERCENT] = ACTIONS(4335),
    [anon_sym_CARET] = ACTIONS(4335),
    [anon_sym_PIPE] = ACTIONS(4337),
    [anon_sym_AMP] = ACTIONS(4337),
    [anon_sym_LT_LT] = ACTIONS(4335),
    [anon_sym_GT_GT] = ACTIONS(4337),
    [anon_sym_GT_GT_GT] = ACTIONS(4335),
    [anon_sym_EQ_EQ] = ACTIONS(4335),
    [anon_sym_BANG_EQ] = ACTIONS(4335),
    [anon_sym_GT_EQ] = ACTIONS(4335),
    [anon_sym_LT_EQ] = ACTIONS(4335),
    [anon_sym_DOT] = ACTIONS(4337),
    [anon_sym_scoped] = ACTIONS(4273),
    [anon_sym_var] = ACTIONS(4273),
    [anon_sym_yield] = ACTIONS(4273),
    [anon_sym_switch] = ACTIONS(4337),
    [anon_sym_when] = ACTIONS(4273),
    [sym_discard] = ACTIONS(4281),
    [anon_sym_DOT_DOT] = ACTIONS(4335),
    [anon_sym_and] = ACTIONS(4337),
    [anon_sym_or] = ACTIONS(4337),
    [anon_sym_AMP_AMP] = ACTIONS(4335),
    [anon_sym_PIPE_PIPE] = ACTIONS(4335),
    [anon_sym_QMARK_QMARK] = ACTIONS(4335),
    [anon_sym_from] = ACTIONS(4273),
    [anon_sym_into] = ACTIONS(4337),
    [anon_sym_join] = ACTIONS(4273),
    [anon_sym_on] = ACTIONS(4337),
    [anon_sym_equals] = ACTIONS(4273),
    [anon_sym_let] = ACTIONS(4273),
    [anon_sym_orderby] = ACTIONS(4273),
    [anon_sym_ascending] = ACTIONS(4273),
    [anon_sym_descending] = ACTIONS(4273),
    [anon_sym_group] = ACTIONS(4273),
    [anon_sym_by] = ACTIONS(4273),
    [anon_sym_select] = ACTIONS(4273),
    [anon_sym_as] = ACTIONS(4337),
    [anon_sym_is] = ACTIONS(4337),
    [anon_sym_DASH_GT] = ACTIONS(4335),
    [anon_sym_with] = ACTIONS(4337),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3155] = {
    [sym_property_pattern_clause] = STATE(3370),
    [sym__variable_designation] = STATE(4124),
    [sym_parenthesized_variable_designation] = STATE(4274),
    [sym_identifier] = STATE(4269),
    [sym__reserved_identifier] = STATE(3908),
    [sym_preproc_region] = STATE(3155),
    [sym_preproc_endregion] = STATE(3155),
    [sym_preproc_line] = STATE(3155),
    [sym_preproc_pragma] = STATE(3155),
    [sym_preproc_nullable] = STATE(3155),
    [sym_preproc_error] = STATE(3155),
    [sym_preproc_define] = STATE(3155),
    [sym_preproc_undef] = STATE(3155),
    [sym__identifier_token] = ACTIONS(4271),
    [anon_sym_alias] = ACTIONS(4273),
    [anon_sym_global] = ACTIONS(4273),
    [anon_sym_LBRACK] = ACTIONS(4335),
    [anon_sym_LPAREN] = ACTIONS(4335),
    [anon_sym_LBRACE] = ACTIONS(4277),
    [anon_sym_file] = ACTIONS(4273),
    [anon_sym_LT] = ACTIONS(4337),
    [anon_sym_GT] = ACTIONS(4337),
    [anon_sym_where] = ACTIONS(4273),
    [anon_sym_QMARK] = ACTIONS(4337),
    [anon_sym_notnull] = ACTIONS(4273),
    [anon_sym_unmanaged] = ACTIONS(4273),
    [anon_sym_BANG] = ACTIONS(4337),
    [anon_sym_PLUS_PLUS] = ACTIONS(4335),
    [anon_sym_DASH_DASH] = ACTIONS(4335),
    [anon_sym_PLUS] = ACTIONS(4337),
    [anon_sym_DASH] = ACTIONS(4337),
    [anon_sym_STAR] = ACTIONS(4335),
    [anon_sym_SLASH] = ACTIONS(4337),
    [anon_sym_PERCENT] = ACTIONS(4335),
    [anon_sym_CARET] = ACTIONS(4335),
    [anon_sym_PIPE] = ACTIONS(4337),
    [anon_sym_AMP] = ACTIONS(4337),
    [anon_sym_LT_LT] = ACTIONS(4335),
    [anon_sym_GT_GT] = ACTIONS(4337),
    [anon_sym_GT_GT_GT] = ACTIONS(4335),
    [anon_sym_EQ_EQ] = ACTIONS(4335),
    [anon_sym_BANG_EQ] = ACTIONS(4335),
    [anon_sym_GT_EQ] = ACTIONS(4335),
    [anon_sym_LT_EQ] = ACTIONS(4335),
    [anon_sym_DOT] = ACTIONS(4337),
    [anon_sym_scoped] = ACTIONS(4273),
    [anon_sym_var] = ACTIONS(4273),
    [anon_sym_yield] = ACTIONS(4273),
    [anon_sym_switch] = ACTIONS(4337),
    [anon_sym_when] = ACTIONS(4273),
    [sym_discard] = ACTIONS(4295),
    [anon_sym_DOT_DOT] = ACTIONS(4335),
    [anon_sym_and] = ACTIONS(4337),
    [anon_sym_or] = ACTIONS(4337),
    [anon_sym_AMP_AMP] = ACTIONS(4335),
    [anon_sym_PIPE_PIPE] = ACTIONS(4335),
    [anon_sym_QMARK_QMARK] = ACTIONS(4335),
    [anon_sym_from] = ACTIONS(4273),
    [anon_sym_into] = ACTIONS(4273),
    [anon_sym_join] = ACTIONS(4273),
    [anon_sym_on] = ACTIONS(4273),
    [anon_sym_equals] = ACTIONS(4337),
    [anon_sym_let] = ACTIONS(4273),
    [anon_sym_orderby] = ACTIONS(4273),
    [anon_sym_ascending] = ACTIONS(4273),
    [anon_sym_descending] = ACTIONS(4273),
    [anon_sym_group] = ACTIONS(4273),
    [anon_sym_by] = ACTIONS(4273),
    [anon_sym_select] = ACTIONS(4273),
    [anon_sym_as] = ACTIONS(4337),
    [anon_sym_is] = ACTIONS(4337),
    [anon_sym_DASH_GT] = ACTIONS(4335),
    [anon_sym_with] = ACTIONS(4337),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3156] = {
    [sym__variable_designation] = STATE(4063),
    [sym_parenthesized_variable_designation] = STATE(4015),
    [sym_identifier] = STATE(4020),
    [sym__reserved_identifier] = STATE(3908),
    [sym_preproc_region] = STATE(3156),
    [sym_preproc_endregion] = STATE(3156),
    [sym_preproc_line] = STATE(3156),
    [sym_preproc_pragma] = STATE(3156),
    [sym_preproc_nullable] = STATE(3156),
    [sym_preproc_error] = STATE(3156),
    [sym_preproc_define] = STATE(3156),
    [sym_preproc_undef] = STATE(3156),
    [sym__identifier_token] = ACTIONS(4271),
    [anon_sym_alias] = ACTIONS(4273),
    [anon_sym_global] = ACTIONS(4273),
    [anon_sym_LBRACK] = ACTIONS(4373),
    [anon_sym_COLON] = ACTIONS(4373),
    [anon_sym_LPAREN] = ACTIONS(4373),
    [anon_sym_file] = ACTIONS(4273),
    [anon_sym_LT] = ACTIONS(4375),
    [anon_sym_GT] = ACTIONS(4375),
    [anon_sym_where] = ACTIONS(4273),
    [anon_sym_QMARK] = ACTIONS(4375),
    [anon_sym_notnull] = ACTIONS(4273),
    [anon_sym_unmanaged] = ACTIONS(4273),
    [anon_sym_BANG] = ACTIONS(4375),
    [anon_sym_PLUS_PLUS] = ACTIONS(4373),
    [anon_sym_DASH_DASH] = ACTIONS(4373),
    [anon_sym_PLUS] = ACTIONS(4375),
    [anon_sym_DASH] = ACTIONS(4375),
    [anon_sym_STAR] = ACTIONS(4373),
    [anon_sym_SLASH] = ACTIONS(4375),
    [anon_sym_PERCENT] = ACTIONS(4373),
    [anon_sym_CARET] = ACTIONS(4373),
    [anon_sym_PIPE] = ACTIONS(4375),
    [anon_sym_AMP] = ACTIONS(4375),
    [anon_sym_LT_LT] = ACTIONS(4373),
    [anon_sym_GT_GT] = ACTIONS(4375),
    [anon_sym_GT_GT_GT] = ACTIONS(4373),
    [anon_sym_EQ_EQ] = ACTIONS(4373),
    [anon_sym_BANG_EQ] = ACTIONS(4373),
    [anon_sym_GT_EQ] = ACTIONS(4373),
    [anon_sym_LT_EQ] = ACTIONS(4373),
    [anon_sym_DOT] = ACTIONS(4375),
    [anon_sym_scoped] = ACTIONS(4273),
    [anon_sym_EQ_GT] = ACTIONS(4373),
    [anon_sym_var] = ACTIONS(4273),
    [anon_sym_yield] = ACTIONS(4273),
    [anon_sym_switch] = ACTIONS(4375),
    [anon_sym_when] = ACTIONS(4375),
    [sym_discard] = ACTIONS(4281),
    [anon_sym_DOT_DOT] = ACTIONS(4373),
    [anon_sym_and] = ACTIONS(4375),
    [anon_sym_or] = ACTIONS(4375),
    [anon_sym_AMP_AMP] = ACTIONS(4373),
    [anon_sym_PIPE_PIPE] = ACTIONS(4373),
    [anon_sym_QMARK_QMARK] = ACTIONS(4373),
    [anon_sym_from] = ACTIONS(4273),
    [anon_sym_into] = ACTIONS(4375),
    [anon_sym_join] = ACTIONS(4273),
    [anon_sym_on] = ACTIONS(4273),
    [anon_sym_equals] = ACTIONS(4273),
    [anon_sym_let] = ACTIONS(4273),
    [anon_sym_orderby] = ACTIONS(4273),
    [anon_sym_ascending] = ACTIONS(4273),
    [anon_sym_descending] = ACTIONS(4273),
    [anon_sym_group] = ACTIONS(4273),
    [anon_sym_by] = ACTIONS(4273),
    [anon_sym_select] = ACTIONS(4273),
    [anon_sym_as] = ACTIONS(4375),
    [anon_sym_is] = ACTIONS(4375),
    [anon_sym_DASH_GT] = ACTIONS(4373),
    [anon_sym_with] = ACTIONS(4375),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3157] = {
    [sym_property_pattern_clause] = STATE(3418),
    [sym__variable_designation] = STATE(4057),
    [sym_parenthesized_variable_designation] = STATE(4015),
    [sym_identifier] = STATE(4020),
    [sym__reserved_identifier] = STATE(3908),
    [sym_preproc_region] = STATE(3157),
    [sym_preproc_endregion] = STATE(3157),
    [sym_preproc_line] = STATE(3157),
    [sym_preproc_pragma] = STATE(3157),
    [sym_preproc_nullable] = STATE(3157),
    [sym_preproc_error] = STATE(3157),
    [sym_preproc_define] = STATE(3157),
    [sym_preproc_undef] = STATE(3157),
    [sym__identifier_token] = ACTIONS(4271),
    [anon_sym_alias] = ACTIONS(4273),
    [anon_sym_global] = ACTIONS(4273),
    [anon_sym_LBRACK] = ACTIONS(4335),
    [anon_sym_LPAREN] = ACTIONS(4335),
    [anon_sym_LBRACE] = ACTIONS(4277),
    [anon_sym_file] = ACTIONS(4273),
    [anon_sym_LT] = ACTIONS(4337),
    [anon_sym_GT] = ACTIONS(4337),
    [anon_sym_where] = ACTIONS(4273),
    [anon_sym_QMARK] = ACTIONS(4337),
    [anon_sym_notnull] = ACTIONS(4273),
    [anon_sym_unmanaged] = ACTIONS(4273),
    [anon_sym_BANG] = ACTIONS(4337),
    [anon_sym_PLUS_PLUS] = ACTIONS(4335),
    [anon_sym_DASH_DASH] = ACTIONS(4335),
    [anon_sym_PLUS] = ACTIONS(4337),
    [anon_sym_DASH] = ACTIONS(4337),
    [anon_sym_STAR] = ACTIONS(4335),
    [anon_sym_SLASH] = ACTIONS(4337),
    [anon_sym_PERCENT] = ACTIONS(4335),
    [anon_sym_CARET] = ACTIONS(4335),
    [anon_sym_PIPE] = ACTIONS(4337),
    [anon_sym_AMP] = ACTIONS(4337),
    [anon_sym_LT_LT] = ACTIONS(4335),
    [anon_sym_GT_GT] = ACTIONS(4337),
    [anon_sym_GT_GT_GT] = ACTIONS(4335),
    [anon_sym_EQ_EQ] = ACTIONS(4335),
    [anon_sym_BANG_EQ] = ACTIONS(4335),
    [anon_sym_GT_EQ] = ACTIONS(4335),
    [anon_sym_LT_EQ] = ACTIONS(4335),
    [anon_sym_DOT] = ACTIONS(4337),
    [anon_sym_scoped] = ACTIONS(4273),
    [anon_sym_var] = ACTIONS(4273),
    [anon_sym_yield] = ACTIONS(4273),
    [anon_sym_switch] = ACTIONS(4337),
    [anon_sym_when] = ACTIONS(4273),
    [sym_discard] = ACTIONS(4281),
    [anon_sym_DOT_DOT] = ACTIONS(4335),
    [anon_sym_and] = ACTIONS(4337),
    [anon_sym_or] = ACTIONS(4337),
    [anon_sym_AMP_AMP] = ACTIONS(4335),
    [anon_sym_PIPE_PIPE] = ACTIONS(4335),
    [anon_sym_QMARK_QMARK] = ACTIONS(4335),
    [anon_sym_from] = ACTIONS(4273),
    [anon_sym_into] = ACTIONS(4337),
    [anon_sym_join] = ACTIONS(4273),
    [anon_sym_on] = ACTIONS(4273),
    [anon_sym_equals] = ACTIONS(4273),
    [anon_sym_let] = ACTIONS(4273),
    [anon_sym_orderby] = ACTIONS(4273),
    [anon_sym_ascending] = ACTIONS(4273),
    [anon_sym_descending] = ACTIONS(4273),
    [anon_sym_group] = ACTIONS(4273),
    [anon_sym_by] = ACTIONS(4337),
    [anon_sym_select] = ACTIONS(4273),
    [anon_sym_as] = ACTIONS(4337),
    [anon_sym_is] = ACTIONS(4337),
    [anon_sym_DASH_GT] = ACTIONS(4335),
    [anon_sym_with] = ACTIONS(4337),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3158] = {
    [sym_property_pattern_clause] = STATE(3216),
    [sym__variable_designation] = STATE(4124),
    [sym_parenthesized_variable_designation] = STATE(4274),
    [sym_identifier] = STATE(4269),
    [sym__reserved_identifier] = STATE(3908),
    [sym_preproc_region] = STATE(3158),
    [sym_preproc_endregion] = STATE(3158),
    [sym_preproc_line] = STATE(3158),
    [sym_preproc_pragma] = STATE(3158),
    [sym_preproc_nullable] = STATE(3158),
    [sym_preproc_error] = STATE(3158),
    [sym_preproc_define] = STATE(3158),
    [sym_preproc_undef] = STATE(3158),
    [sym__identifier_token] = ACTIONS(4271),
    [anon_sym_alias] = ACTIONS(4273),
    [anon_sym_global] = ACTIONS(4273),
    [anon_sym_LBRACK] = ACTIONS(4335),
    [anon_sym_LPAREN] = ACTIONS(4335),
    [anon_sym_LBRACE] = ACTIONS(4277),
    [anon_sym_file] = ACTIONS(4273),
    [anon_sym_LT] = ACTIONS(4337),
    [anon_sym_GT] = ACTIONS(4337),
    [anon_sym_where] = ACTIONS(4273),
    [anon_sym_QMARK] = ACTIONS(4337),
    [anon_sym_notnull] = ACTIONS(4273),
    [anon_sym_unmanaged] = ACTIONS(4273),
    [anon_sym_BANG] = ACTIONS(4337),
    [anon_sym_PLUS_PLUS] = ACTIONS(4335),
    [anon_sym_DASH_DASH] = ACTIONS(4335),
    [anon_sym_PLUS] = ACTIONS(4337),
    [anon_sym_DASH] = ACTIONS(4337),
    [anon_sym_STAR] = ACTIONS(4335),
    [anon_sym_SLASH] = ACTIONS(4337),
    [anon_sym_PERCENT] = ACTIONS(4335),
    [anon_sym_CARET] = ACTIONS(4335),
    [anon_sym_PIPE] = ACTIONS(4337),
    [anon_sym_AMP] = ACTIONS(4337),
    [anon_sym_LT_LT] = ACTIONS(4335),
    [anon_sym_GT_GT] = ACTIONS(4337),
    [anon_sym_GT_GT_GT] = ACTIONS(4335),
    [anon_sym_EQ_EQ] = ACTIONS(4335),
    [anon_sym_BANG_EQ] = ACTIONS(4335),
    [anon_sym_GT_EQ] = ACTIONS(4335),
    [anon_sym_LT_EQ] = ACTIONS(4335),
    [anon_sym_DOT] = ACTIONS(4337),
    [anon_sym_scoped] = ACTIONS(4273),
    [anon_sym_var] = ACTIONS(4273),
    [anon_sym_yield] = ACTIONS(4273),
    [anon_sym_switch] = ACTIONS(4337),
    [anon_sym_when] = ACTIONS(4273),
    [sym_discard] = ACTIONS(4295),
    [anon_sym_DOT_DOT] = ACTIONS(4335),
    [anon_sym_and] = ACTIONS(4337),
    [anon_sym_or] = ACTIONS(4337),
    [anon_sym_AMP_AMP] = ACTIONS(4335),
    [anon_sym_PIPE_PIPE] = ACTIONS(4335),
    [anon_sym_QMARK_QMARK] = ACTIONS(4335),
    [anon_sym_from] = ACTIONS(4273),
    [anon_sym_into] = ACTIONS(4273),
    [anon_sym_join] = ACTIONS(4273),
    [anon_sym_on] = ACTIONS(4273),
    [anon_sym_equals] = ACTIONS(4273),
    [anon_sym_let] = ACTIONS(4273),
    [anon_sym_orderby] = ACTIONS(4273),
    [anon_sym_ascending] = ACTIONS(4273),
    [anon_sym_descending] = ACTIONS(4273),
    [anon_sym_group] = ACTIONS(4273),
    [anon_sym_by] = ACTIONS(4337),
    [anon_sym_select] = ACTIONS(4273),
    [anon_sym_as] = ACTIONS(4337),
    [anon_sym_is] = ACTIONS(4337),
    [anon_sym_DASH_GT] = ACTIONS(4335),
    [anon_sym_with] = ACTIONS(4337),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3159] = {
    [sym__variable_designation] = STATE(3965),
    [sym_parenthesized_variable_designation] = STATE(4015),
    [sym_identifier] = STATE(4020),
    [sym__reserved_identifier] = STATE(3908),
    [sym_preproc_region] = STATE(3159),
    [sym_preproc_endregion] = STATE(3159),
    [sym_preproc_line] = STATE(3159),
    [sym_preproc_pragma] = STATE(3159),
    [sym_preproc_nullable] = STATE(3159),
    [sym_preproc_error] = STATE(3159),
    [sym_preproc_define] = STATE(3159),
    [sym_preproc_undef] = STATE(3159),
    [sym__identifier_token] = ACTIONS(4271),
    [anon_sym_alias] = ACTIONS(4273),
    [anon_sym_global] = ACTIONS(4273),
    [anon_sym_LBRACK] = ACTIONS(4335),
    [anon_sym_COLON] = ACTIONS(4335),
    [anon_sym_LPAREN] = ACTIONS(4335),
    [anon_sym_file] = ACTIONS(4273),
    [anon_sym_LT] = ACTIONS(4337),
    [anon_sym_GT] = ACTIONS(4337),
    [anon_sym_where] = ACTIONS(4273),
    [anon_sym_QMARK] = ACTIONS(4337),
    [anon_sym_notnull] = ACTIONS(4273),
    [anon_sym_unmanaged] = ACTIONS(4273),
    [anon_sym_BANG] = ACTIONS(4337),
    [anon_sym_PLUS_PLUS] = ACTIONS(4335),
    [anon_sym_DASH_DASH] = ACTIONS(4335),
    [anon_sym_PLUS] = ACTIONS(4337),
    [anon_sym_DASH] = ACTIONS(4337),
    [anon_sym_STAR] = ACTIONS(4335),
    [anon_sym_SLASH] = ACTIONS(4337),
    [anon_sym_PERCENT] = ACTIONS(4335),
    [anon_sym_CARET] = ACTIONS(4335),
    [anon_sym_PIPE] = ACTIONS(4337),
    [anon_sym_AMP] = ACTIONS(4337),
    [anon_sym_LT_LT] = ACTIONS(4335),
    [anon_sym_GT_GT] = ACTIONS(4337),
    [anon_sym_GT_GT_GT] = ACTIONS(4335),
    [anon_sym_EQ_EQ] = ACTIONS(4335),
    [anon_sym_BANG_EQ] = ACTIONS(4335),
    [anon_sym_GT_EQ] = ACTIONS(4335),
    [anon_sym_LT_EQ] = ACTIONS(4335),
    [anon_sym_DOT] = ACTIONS(4337),
    [anon_sym_scoped] = ACTIONS(4273),
    [anon_sym_EQ_GT] = ACTIONS(4335),
    [anon_sym_var] = ACTIONS(4273),
    [anon_sym_yield] = ACTIONS(4273),
    [anon_sym_switch] = ACTIONS(4337),
    [anon_sym_when] = ACTIONS(4337),
    [sym_discard] = ACTIONS(4281),
    [anon_sym_DOT_DOT] = ACTIONS(4335),
    [anon_sym_and] = ACTIONS(4337),
    [anon_sym_or] = ACTIONS(4337),
    [anon_sym_AMP_AMP] = ACTIONS(4335),
    [anon_sym_PIPE_PIPE] = ACTIONS(4335),
    [anon_sym_QMARK_QMARK] = ACTIONS(4335),
    [anon_sym_from] = ACTIONS(4273),
    [anon_sym_into] = ACTIONS(4337),
    [anon_sym_join] = ACTIONS(4273),
    [anon_sym_on] = ACTIONS(4273),
    [anon_sym_equals] = ACTIONS(4273),
    [anon_sym_let] = ACTIONS(4273),
    [anon_sym_orderby] = ACTIONS(4273),
    [anon_sym_ascending] = ACTIONS(4273),
    [anon_sym_descending] = ACTIONS(4273),
    [anon_sym_group] = ACTIONS(4273),
    [anon_sym_by] = ACTIONS(4273),
    [anon_sym_select] = ACTIONS(4273),
    [anon_sym_as] = ACTIONS(4337),
    [anon_sym_is] = ACTIONS(4337),
    [anon_sym_DASH_GT] = ACTIONS(4335),
    [anon_sym_with] = ACTIONS(4337),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3160] = {
    [sym_preproc_region] = STATE(3160),
    [sym_preproc_endregion] = STATE(3160),
    [sym_preproc_line] = STATE(3160),
    [sym_preproc_pragma] = STATE(3160),
    [sym_preproc_nullable] = STATE(3160),
    [sym_preproc_error] = STATE(3160),
    [sym_preproc_define] = STATE(3160),
    [sym_preproc_undef] = STATE(3160),
    [sym__identifier_token] = ACTIONS(4496),
    [anon_sym_alias] = ACTIONS(4496),
    [anon_sym_global] = ACTIONS(4496),
    [anon_sym_LBRACK] = ACTIONS(4498),
    [anon_sym_COLON] = ACTIONS(4498),
    [anon_sym_COMMA] = ACTIONS(4498),
    [anon_sym_LPAREN] = ACTIONS(4498),
    [anon_sym_LBRACE] = ACTIONS(4498),
    [anon_sym_file] = ACTIONS(4496),
    [anon_sym_LT] = ACTIONS(4496),
    [anon_sym_GT] = ACTIONS(4496),
    [anon_sym_where] = ACTIONS(4496),
    [anon_sym_QMARK] = ACTIONS(4496),
    [anon_sym_notnull] = ACTIONS(4496),
    [anon_sym_unmanaged] = ACTIONS(4496),
    [anon_sym_BANG] = ACTIONS(4496),
    [anon_sym_PLUS_PLUS] = ACTIONS(4498),
    [anon_sym_DASH_DASH] = ACTIONS(4498),
    [anon_sym_PLUS] = ACTIONS(4496),
    [anon_sym_DASH] = ACTIONS(4496),
    [anon_sym_STAR] = ACTIONS(4498),
    [anon_sym_SLASH] = ACTIONS(4496),
    [anon_sym_PERCENT] = ACTIONS(4498),
    [anon_sym_CARET] = ACTIONS(4498),
    [anon_sym_PIPE] = ACTIONS(4496),
    [anon_sym_AMP] = ACTIONS(4496),
    [anon_sym_LT_LT] = ACTIONS(4498),
    [anon_sym_GT_GT] = ACTIONS(4496),
    [anon_sym_GT_GT_GT] = ACTIONS(4498),
    [anon_sym_EQ_EQ] = ACTIONS(4498),
    [anon_sym_BANG_EQ] = ACTIONS(4498),
    [anon_sym_GT_EQ] = ACTIONS(4498),
    [anon_sym_LT_EQ] = ACTIONS(4498),
    [anon_sym_DOT] = ACTIONS(4496),
    [anon_sym_scoped] = ACTIONS(4496),
    [anon_sym_EQ_GT] = ACTIONS(4500),
    [anon_sym_var] = ACTIONS(4496),
    [anon_sym_yield] = ACTIONS(4496),
    [anon_sym_switch] = ACTIONS(4496),
    [anon_sym_when] = ACTIONS(4496),
    [sym_discard] = ACTIONS(4496),
    [anon_sym_DOT_DOT] = ACTIONS(4498),
    [anon_sym_and] = ACTIONS(4496),
    [anon_sym_or] = ACTIONS(4496),
    [anon_sym_AMP_AMP] = ACTIONS(4498),
    [anon_sym_PIPE_PIPE] = ACTIONS(4498),
    [anon_sym_QMARK_QMARK] = ACTIONS(4498),
    [anon_sym_from] = ACTIONS(4496),
    [anon_sym_into] = ACTIONS(4496),
    [anon_sym_join] = ACTIONS(4496),
    [anon_sym_on] = ACTIONS(4496),
    [anon_sym_equals] = ACTIONS(4496),
    [anon_sym_let] = ACTIONS(4496),
    [anon_sym_orderby] = ACTIONS(4496),
    [anon_sym_ascending] = ACTIONS(4496),
    [anon_sym_descending] = ACTIONS(4496),
    [anon_sym_group] = ACTIONS(4496),
    [anon_sym_by] = ACTIONS(4496),
    [anon_sym_select] = ACTIONS(4496),
    [anon_sym_as] = ACTIONS(4496),
    [anon_sym_is] = ACTIONS(4496),
    [anon_sym_DASH_GT] = ACTIONS(4498),
    [anon_sym_with] = ACTIONS(4496),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4498),
  },
  [3161] = {
    [sym_preproc_region] = STATE(3161),
    [sym_preproc_endregion] = STATE(3161),
    [sym_preproc_line] = STATE(3161),
    [sym_preproc_pragma] = STATE(3161),
    [sym_preproc_nullable] = STATE(3161),
    [sym_preproc_error] = STATE(3161),
    [sym_preproc_define] = STATE(3161),
    [sym_preproc_undef] = STATE(3161),
    [sym__identifier_token] = ACTIONS(4422),
    [anon_sym_alias] = ACTIONS(4422),
    [anon_sym_global] = ACTIONS(4422),
    [anon_sym_LBRACK] = ACTIONS(4547),
    [anon_sym_COLON] = ACTIONS(4424),
    [anon_sym_COMMA] = ACTIONS(4424),
    [anon_sym_LPAREN] = ACTIONS(4424),
    [anon_sym_RPAREN] = ACTIONS(4424),
    [anon_sym_LBRACE] = ACTIONS(4424),
    [anon_sym_RBRACE] = ACTIONS(4424),
    [anon_sym_file] = ACTIONS(4422),
    [anon_sym_LT] = ACTIONS(4422),
    [anon_sym_GT] = ACTIONS(4422),
    [anon_sym_where] = ACTIONS(4422),
    [anon_sym_QMARK] = ACTIONS(4550),
    [anon_sym_notnull] = ACTIONS(4422),
    [anon_sym_unmanaged] = ACTIONS(4422),
    [anon_sym_BANG] = ACTIONS(4422),
    [anon_sym_PLUS_PLUS] = ACTIONS(4424),
    [anon_sym_DASH_DASH] = ACTIONS(4424),
    [anon_sym_PLUS] = ACTIONS(4422),
    [anon_sym_DASH] = ACTIONS(4422),
    [anon_sym_STAR] = ACTIONS(4553),
    [anon_sym_SLASH] = ACTIONS(4422),
    [anon_sym_PERCENT] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4424),
    [anon_sym_PIPE] = ACTIONS(4422),
    [anon_sym_AMP] = ACTIONS(4422),
    [anon_sym_LT_LT] = ACTIONS(4424),
    [anon_sym_GT_GT] = ACTIONS(4422),
    [anon_sym_GT_GT_GT] = ACTIONS(4424),
    [anon_sym_EQ_EQ] = ACTIONS(4424),
    [anon_sym_BANG_EQ] = ACTIONS(4424),
    [anon_sym_GT_EQ] = ACTIONS(4424),
    [anon_sym_LT_EQ] = ACTIONS(4424),
    [anon_sym_DOT] = ACTIONS(4699),
    [anon_sym_scoped] = ACTIONS(4422),
    [anon_sym_var] = ACTIONS(4422),
    [anon_sym_yield] = ACTIONS(4422),
    [anon_sym_switch] = ACTIONS(4422),
    [anon_sym_when] = ACTIONS(4422),
    [sym_discard] = ACTIONS(4422),
    [anon_sym_DOT_DOT] = ACTIONS(4424),
    [anon_sym_and] = ACTIONS(4422),
    [anon_sym_or] = ACTIONS(4422),
    [anon_sym_AMP_AMP] = ACTIONS(4424),
    [anon_sym_PIPE_PIPE] = ACTIONS(4424),
    [anon_sym_QMARK_QMARK] = ACTIONS(4424),
    [anon_sym_from] = ACTIONS(4422),
    [anon_sym_into] = ACTIONS(4422),
    [anon_sym_join] = ACTIONS(4422),
    [anon_sym_on] = ACTIONS(4422),
    [anon_sym_equals] = ACTIONS(4422),
    [anon_sym_let] = ACTIONS(4422),
    [anon_sym_orderby] = ACTIONS(4422),
    [anon_sym_ascending] = ACTIONS(4422),
    [anon_sym_descending] = ACTIONS(4422),
    [anon_sym_group] = ACTIONS(4422),
    [anon_sym_by] = ACTIONS(4422),
    [anon_sym_select] = ACTIONS(4422),
    [anon_sym_as] = ACTIONS(4422),
    [anon_sym_is] = ACTIONS(4422),
    [anon_sym_DASH_GT] = ACTIONS(4558),
    [anon_sym_with] = ACTIONS(4422),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3162] = {
    [sym__variable_designation] = STATE(4582),
    [sym_parenthesized_variable_designation] = STATE(4614),
    [sym_identifier] = STATE(4624),
    [sym__reserved_identifier] = STATE(2914),
    [sym_preproc_region] = STATE(3162),
    [sym_preproc_endregion] = STATE(3162),
    [sym_preproc_line] = STATE(3162),
    [sym_preproc_pragma] = STATE(3162),
    [sym_preproc_nullable] = STATE(3162),
    [sym_preproc_error] = STATE(3162),
    [sym_preproc_define] = STATE(3162),
    [sym_preproc_undef] = STATE(3162),
    [sym__identifier_token] = ACTIONS(4490),
    [anon_sym_alias] = ACTIONS(4492),
    [anon_sym_global] = ACTIONS(4492),
    [anon_sym_LBRACK] = ACTIONS(4373),
    [anon_sym_COMMA] = ACTIONS(4373),
    [anon_sym_LPAREN] = ACTIONS(4373),
    [anon_sym_file] = ACTIONS(4492),
    [anon_sym_LT] = ACTIONS(4375),
    [anon_sym_GT] = ACTIONS(4375),
    [anon_sym_where] = ACTIONS(4375),
    [anon_sym_QMARK] = ACTIONS(4375),
    [anon_sym_notnull] = ACTIONS(4492),
    [anon_sym_unmanaged] = ACTIONS(4492),
    [anon_sym_BANG] = ACTIONS(4375),
    [anon_sym_PLUS_PLUS] = ACTIONS(4373),
    [anon_sym_DASH_DASH] = ACTIONS(4373),
    [anon_sym_PLUS] = ACTIONS(4375),
    [anon_sym_DASH] = ACTIONS(4375),
    [anon_sym_STAR] = ACTIONS(4373),
    [anon_sym_SLASH] = ACTIONS(4375),
    [anon_sym_PERCENT] = ACTIONS(4373),
    [anon_sym_CARET] = ACTIONS(4373),
    [anon_sym_PIPE] = ACTIONS(4375),
    [anon_sym_AMP] = ACTIONS(4375),
    [anon_sym_LT_LT] = ACTIONS(4373),
    [anon_sym_GT_GT] = ACTIONS(4375),
    [anon_sym_GT_GT_GT] = ACTIONS(4373),
    [anon_sym_EQ_EQ] = ACTIONS(4373),
    [anon_sym_BANG_EQ] = ACTIONS(4373),
    [anon_sym_GT_EQ] = ACTIONS(4373),
    [anon_sym_LT_EQ] = ACTIONS(4373),
    [anon_sym_DOT] = ACTIONS(4375),
    [anon_sym_scoped] = ACTIONS(4492),
    [anon_sym_var] = ACTIONS(4492),
    [anon_sym_yield] = ACTIONS(4492),
    [anon_sym_switch] = ACTIONS(4375),
    [anon_sym_when] = ACTIONS(4492),
    [sym_discard] = ACTIONS(4647),
    [anon_sym_DOT_DOT] = ACTIONS(4373),
    [anon_sym_and] = ACTIONS(4375),
    [anon_sym_or] = ACTIONS(4375),
    [anon_sym_AMP_AMP] = ACTIONS(4373),
    [anon_sym_PIPE_PIPE] = ACTIONS(4373),
    [anon_sym_QMARK_QMARK] = ACTIONS(4373),
    [anon_sym_from] = ACTIONS(4375),
    [anon_sym_into] = ACTIONS(4492),
    [anon_sym_join] = ACTIONS(4375),
    [anon_sym_on] = ACTIONS(4492),
    [anon_sym_equals] = ACTIONS(4492),
    [anon_sym_let] = ACTIONS(4375),
    [anon_sym_orderby] = ACTIONS(4375),
    [anon_sym_ascending] = ACTIONS(4375),
    [anon_sym_descending] = ACTIONS(4375),
    [anon_sym_group] = ACTIONS(4375),
    [anon_sym_by] = ACTIONS(4492),
    [anon_sym_select] = ACTIONS(4375),
    [anon_sym_as] = ACTIONS(4375),
    [anon_sym_is] = ACTIONS(4375),
    [anon_sym_DASH_GT] = ACTIONS(4373),
    [anon_sym_with] = ACTIONS(4375),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3163] = {
    [sym_preproc_region] = STATE(3163),
    [sym_preproc_endregion] = STATE(3163),
    [sym_preproc_line] = STATE(3163),
    [sym_preproc_pragma] = STATE(3163),
    [sym_preproc_nullable] = STATE(3163),
    [sym_preproc_error] = STATE(3163),
    [sym_preproc_define] = STATE(3163),
    [sym_preproc_undef] = STATE(3163),
    [sym__identifier_token] = ACTIONS(4056),
    [anon_sym_alias] = ACTIONS(4056),
    [anon_sym_global] = ACTIONS(4056),
    [anon_sym_LBRACK] = ACTIONS(4058),
    [anon_sym_COLON] = ACTIONS(4056),
    [anon_sym_COMMA] = ACTIONS(4058),
    [anon_sym_LPAREN] = ACTIONS(4058),
    [anon_sym_LBRACE] = ACTIONS(4058),
    [anon_sym_file] = ACTIONS(4056),
    [anon_sym_LT] = ACTIONS(4056),
    [anon_sym_GT] = ACTIONS(4056),
    [anon_sym_where] = ACTIONS(4056),
    [anon_sym_QMARK] = ACTIONS(4056),
    [anon_sym_notnull] = ACTIONS(4056),
    [anon_sym_unmanaged] = ACTIONS(4056),
    [anon_sym_BANG] = ACTIONS(4056),
    [anon_sym_PLUS_PLUS] = ACTIONS(4058),
    [anon_sym_DASH_DASH] = ACTIONS(4058),
    [anon_sym_PLUS] = ACTIONS(4056),
    [anon_sym_DASH] = ACTIONS(4056),
    [anon_sym_STAR] = ACTIONS(4058),
    [anon_sym_SLASH] = ACTIONS(4056),
    [anon_sym_PERCENT] = ACTIONS(4058),
    [anon_sym_CARET] = ACTIONS(4058),
    [anon_sym_PIPE] = ACTIONS(4056),
    [anon_sym_AMP] = ACTIONS(4056),
    [anon_sym_LT_LT] = ACTIONS(4058),
    [anon_sym_GT_GT] = ACTIONS(4056),
    [anon_sym_GT_GT_GT] = ACTIONS(4058),
    [anon_sym_EQ_EQ] = ACTIONS(4058),
    [anon_sym_BANG_EQ] = ACTIONS(4058),
    [anon_sym_GT_EQ] = ACTIONS(4058),
    [anon_sym_LT_EQ] = ACTIONS(4058),
    [anon_sym_DOT] = ACTIONS(4056),
    [anon_sym_scoped] = ACTIONS(4056),
    [anon_sym_COLON_COLON] = ACTIONS(4058),
    [anon_sym_var] = ACTIONS(4056),
    [anon_sym_yield] = ACTIONS(4056),
    [anon_sym_switch] = ACTIONS(4056),
    [anon_sym_when] = ACTIONS(4056),
    [sym_discard] = ACTIONS(4056),
    [anon_sym_DOT_DOT] = ACTIONS(4058),
    [anon_sym_and] = ACTIONS(4056),
    [anon_sym_or] = ACTIONS(4056),
    [anon_sym_AMP_AMP] = ACTIONS(4058),
    [anon_sym_PIPE_PIPE] = ACTIONS(4058),
    [anon_sym_QMARK_QMARK] = ACTIONS(4058),
    [anon_sym_from] = ACTIONS(4056),
    [anon_sym_into] = ACTIONS(4056),
    [anon_sym_join] = ACTIONS(4056),
    [anon_sym_on] = ACTIONS(4056),
    [anon_sym_equals] = ACTIONS(4056),
    [anon_sym_let] = ACTIONS(4056),
    [anon_sym_orderby] = ACTIONS(4056),
    [anon_sym_ascending] = ACTIONS(4056),
    [anon_sym_descending] = ACTIONS(4056),
    [anon_sym_group] = ACTIONS(4056),
    [anon_sym_by] = ACTIONS(4056),
    [anon_sym_select] = ACTIONS(4056),
    [anon_sym_as] = ACTIONS(4056),
    [anon_sym_is] = ACTIONS(4056),
    [anon_sym_DASH_GT] = ACTIONS(4058),
    [anon_sym_with] = ACTIONS(4056),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4058),
  },
  [3164] = {
    [sym_preproc_region] = STATE(3164),
    [sym_preproc_endregion] = STATE(3164),
    [sym_preproc_line] = STATE(3164),
    [sym_preproc_pragma] = STATE(3164),
    [sym_preproc_nullable] = STATE(3164),
    [sym_preproc_error] = STATE(3164),
    [sym_preproc_define] = STATE(3164),
    [sym_preproc_undef] = STATE(3164),
    [sym__identifier_token] = ACTIONS(4422),
    [anon_sym_alias] = ACTIONS(4422),
    [anon_sym_global] = ACTIONS(4422),
    [anon_sym_LBRACK] = ACTIONS(4547),
    [anon_sym_COLON] = ACTIONS(4424),
    [anon_sym_COMMA] = ACTIONS(4424),
    [anon_sym_LPAREN] = ACTIONS(4424),
    [anon_sym_RPAREN] = ACTIONS(4424),
    [anon_sym_LBRACE] = ACTIONS(4424),
    [anon_sym_RBRACE] = ACTIONS(4424),
    [anon_sym_file] = ACTIONS(4422),
    [anon_sym_LT] = ACTIONS(4422),
    [anon_sym_GT] = ACTIONS(4422),
    [anon_sym_where] = ACTIONS(4422),
    [anon_sym_QMARK] = ACTIONS(4550),
    [anon_sym_notnull] = ACTIONS(4422),
    [anon_sym_unmanaged] = ACTIONS(4422),
    [anon_sym_BANG] = ACTIONS(4422),
    [anon_sym_PLUS_PLUS] = ACTIONS(4424),
    [anon_sym_DASH_DASH] = ACTIONS(4424),
    [anon_sym_PLUS] = ACTIONS(4422),
    [anon_sym_DASH] = ACTIONS(4422),
    [anon_sym_STAR] = ACTIONS(4553),
    [anon_sym_SLASH] = ACTIONS(4422),
    [anon_sym_PERCENT] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4424),
    [anon_sym_PIPE] = ACTIONS(4422),
    [anon_sym_AMP] = ACTIONS(4422),
    [anon_sym_LT_LT] = ACTIONS(4424),
    [anon_sym_GT_GT] = ACTIONS(4422),
    [anon_sym_GT_GT_GT] = ACTIONS(4424),
    [anon_sym_EQ_EQ] = ACTIONS(4424),
    [anon_sym_BANG_EQ] = ACTIONS(4424),
    [anon_sym_GT_EQ] = ACTIONS(4424),
    [anon_sym_LT_EQ] = ACTIONS(4424),
    [anon_sym_DOT] = ACTIONS(4701),
    [anon_sym_scoped] = ACTIONS(4422),
    [anon_sym_var] = ACTIONS(4422),
    [anon_sym_yield] = ACTIONS(4422),
    [anon_sym_switch] = ACTIONS(4422),
    [anon_sym_when] = ACTIONS(4422),
    [sym_discard] = ACTIONS(4422),
    [anon_sym_DOT_DOT] = ACTIONS(4424),
    [anon_sym_and] = ACTIONS(4422),
    [anon_sym_or] = ACTIONS(4422),
    [anon_sym_AMP_AMP] = ACTIONS(4424),
    [anon_sym_PIPE_PIPE] = ACTIONS(4424),
    [anon_sym_QMARK_QMARK] = ACTIONS(4424),
    [anon_sym_from] = ACTIONS(4422),
    [anon_sym_into] = ACTIONS(4422),
    [anon_sym_join] = ACTIONS(4422),
    [anon_sym_on] = ACTIONS(4422),
    [anon_sym_equals] = ACTIONS(4422),
    [anon_sym_let] = ACTIONS(4422),
    [anon_sym_orderby] = ACTIONS(4422),
    [anon_sym_ascending] = ACTIONS(4422),
    [anon_sym_descending] = ACTIONS(4422),
    [anon_sym_group] = ACTIONS(4422),
    [anon_sym_by] = ACTIONS(4422),
    [anon_sym_select] = ACTIONS(4422),
    [anon_sym_as] = ACTIONS(4422),
    [anon_sym_is] = ACTIONS(4422),
    [anon_sym_DASH_GT] = ACTIONS(4562),
    [anon_sym_with] = ACTIONS(4422),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3165] = {
    [sym_preproc_region] = STATE(3165),
    [sym_preproc_endregion] = STATE(3165),
    [sym_preproc_line] = STATE(3165),
    [sym_preproc_pragma] = STATE(3165),
    [sym_preproc_nullable] = STATE(3165),
    [sym_preproc_error] = STATE(3165),
    [sym_preproc_define] = STATE(3165),
    [sym_preproc_undef] = STATE(3165),
    [anon_sym_SEMI] = ACTIONS(3719),
    [anon_sym_EQ] = ACTIONS(3721),
    [anon_sym_LBRACK] = ACTIONS(3719),
    [anon_sym_COLON] = ACTIONS(3719),
    [anon_sym_COMMA] = ACTIONS(3719),
    [anon_sym_RBRACK] = ACTIONS(3719),
    [anon_sym_LPAREN] = ACTIONS(3719),
    [anon_sym_RPAREN] = ACTIONS(3719),
    [anon_sym_RBRACE] = ACTIONS(3719),
    [anon_sym_LT] = ACTIONS(3721),
    [anon_sym_GT] = ACTIONS(3721),
    [anon_sym_in] = ACTIONS(3721),
    [anon_sym_QMARK] = ACTIONS(3721),
    [anon_sym_BANG] = ACTIONS(3721),
    [anon_sym_PLUS_PLUS] = ACTIONS(3719),
    [anon_sym_DASH_DASH] = ACTIONS(3719),
    [anon_sym_PLUS] = ACTIONS(3721),
    [anon_sym_DASH] = ACTIONS(3721),
    [anon_sym_STAR] = ACTIONS(3721),
    [anon_sym_SLASH] = ACTIONS(3721),
    [anon_sym_PERCENT] = ACTIONS(3721),
    [anon_sym_CARET] = ACTIONS(3721),
    [anon_sym_PIPE] = ACTIONS(3721),
    [anon_sym_AMP] = ACTIONS(3721),
    [anon_sym_LT_LT] = ACTIONS(3721),
    [anon_sym_GT_GT] = ACTIONS(3721),
    [anon_sym_GT_GT_GT] = ACTIONS(3721),
    [anon_sym_EQ_EQ] = ACTIONS(3719),
    [anon_sym_BANG_EQ] = ACTIONS(3719),
    [anon_sym_GT_EQ] = ACTIONS(3719),
    [anon_sym_LT_EQ] = ACTIONS(3719),
    [anon_sym_DOT] = ACTIONS(3721),
    [anon_sym_EQ_GT] = ACTIONS(3719),
    [anon_sym_switch] = ACTIONS(3719),
    [anon_sym_when] = ACTIONS(3719),
    [anon_sym_DOT_DOT] = ACTIONS(3719),
    [anon_sym_and] = ACTIONS(3719),
    [anon_sym_or] = ACTIONS(3719),
    [anon_sym_PLUS_EQ] = ACTIONS(3719),
    [anon_sym_DASH_EQ] = ACTIONS(3719),
    [anon_sym_STAR_EQ] = ACTIONS(3719),
    [anon_sym_SLASH_EQ] = ACTIONS(3719),
    [anon_sym_PERCENT_EQ] = ACTIONS(3719),
    [anon_sym_AMP_EQ] = ACTIONS(3719),
    [anon_sym_CARET_EQ] = ACTIONS(3719),
    [anon_sym_PIPE_EQ] = ACTIONS(3719),
    [anon_sym_LT_LT_EQ] = ACTIONS(3719),
    [anon_sym_GT_GT_EQ] = ACTIONS(3719),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3719),
    [anon_sym_AMP_AMP] = ACTIONS(3719),
    [anon_sym_PIPE_PIPE] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK] = ACTIONS(3721),
    [anon_sym_into] = ACTIONS(3719),
    [anon_sym_on] = ACTIONS(3719),
    [anon_sym_equals] = ACTIONS(3719),
    [anon_sym_by] = ACTIONS(3719),
    [anon_sym_as] = ACTIONS(3719),
    [anon_sym_is] = ACTIONS(3719),
    [anon_sym_DASH_GT] = ACTIONS(3719),
    [anon_sym_with] = ACTIONS(3719),
    [aux_sym_preproc_if_token3] = ACTIONS(3719),
    [aux_sym_preproc_else_token1] = ACTIONS(3719),
    [aux_sym_preproc_elif_token1] = ACTIONS(3719),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3166] = {
    [sym_preproc_region] = STATE(3166),
    [sym_preproc_endregion] = STATE(3166),
    [sym_preproc_line] = STATE(3166),
    [sym_preproc_pragma] = STATE(3166),
    [sym_preproc_nullable] = STATE(3166),
    [sym_preproc_error] = STATE(3166),
    [sym_preproc_define] = STATE(3166),
    [sym_preproc_undef] = STATE(3166),
    [anon_sym_SEMI] = ACTIONS(4062),
    [anon_sym_EQ] = ACTIONS(4060),
    [anon_sym_LBRACK] = ACTIONS(4062),
    [anon_sym_COLON] = ACTIONS(4062),
    [anon_sym_COMMA] = ACTIONS(4062),
    [anon_sym_RBRACK] = ACTIONS(4062),
    [anon_sym_LPAREN] = ACTIONS(4062),
    [anon_sym_RPAREN] = ACTIONS(4062),
    [anon_sym_RBRACE] = ACTIONS(4062),
    [anon_sym_LT] = ACTIONS(4060),
    [anon_sym_GT] = ACTIONS(4060),
    [anon_sym_in] = ACTIONS(4060),
    [anon_sym_QMARK] = ACTIONS(4060),
    [anon_sym_BANG] = ACTIONS(4060),
    [anon_sym_PLUS_PLUS] = ACTIONS(4062),
    [anon_sym_DASH_DASH] = ACTIONS(4062),
    [anon_sym_PLUS] = ACTIONS(4060),
    [anon_sym_DASH] = ACTIONS(4060),
    [anon_sym_STAR] = ACTIONS(4060),
    [anon_sym_SLASH] = ACTIONS(4060),
    [anon_sym_PERCENT] = ACTIONS(4060),
    [anon_sym_CARET] = ACTIONS(4060),
    [anon_sym_PIPE] = ACTIONS(4060),
    [anon_sym_AMP] = ACTIONS(4060),
    [anon_sym_LT_LT] = ACTIONS(4060),
    [anon_sym_GT_GT] = ACTIONS(4060),
    [anon_sym_GT_GT_GT] = ACTIONS(4060),
    [anon_sym_EQ_EQ] = ACTIONS(4062),
    [anon_sym_BANG_EQ] = ACTIONS(4062),
    [anon_sym_GT_EQ] = ACTIONS(4062),
    [anon_sym_LT_EQ] = ACTIONS(4062),
    [anon_sym_DOT] = ACTIONS(4060),
    [anon_sym_EQ_GT] = ACTIONS(4062),
    [anon_sym_switch] = ACTIONS(4062),
    [anon_sym_when] = ACTIONS(4062),
    [anon_sym_DOT_DOT] = ACTIONS(4062),
    [anon_sym_and] = ACTIONS(4062),
    [anon_sym_or] = ACTIONS(4062),
    [anon_sym_PLUS_EQ] = ACTIONS(4062),
    [anon_sym_DASH_EQ] = ACTIONS(4062),
    [anon_sym_STAR_EQ] = ACTIONS(4062),
    [anon_sym_SLASH_EQ] = ACTIONS(4062),
    [anon_sym_PERCENT_EQ] = ACTIONS(4062),
    [anon_sym_AMP_EQ] = ACTIONS(4062),
    [anon_sym_CARET_EQ] = ACTIONS(4062),
    [anon_sym_PIPE_EQ] = ACTIONS(4062),
    [anon_sym_LT_LT_EQ] = ACTIONS(4062),
    [anon_sym_GT_GT_EQ] = ACTIONS(4062),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4062),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4062),
    [anon_sym_AMP_AMP] = ACTIONS(4062),
    [anon_sym_PIPE_PIPE] = ACTIONS(4062),
    [anon_sym_QMARK_QMARK] = ACTIONS(4060),
    [anon_sym_into] = ACTIONS(4062),
    [anon_sym_on] = ACTIONS(4062),
    [anon_sym_equals] = ACTIONS(4062),
    [anon_sym_by] = ACTIONS(4062),
    [anon_sym_as] = ACTIONS(4062),
    [anon_sym_is] = ACTIONS(4062),
    [anon_sym_DASH_GT] = ACTIONS(4062),
    [anon_sym_with] = ACTIONS(4062),
    [aux_sym_preproc_if_token3] = ACTIONS(4062),
    [aux_sym_preproc_else_token1] = ACTIONS(4062),
    [aux_sym_preproc_elif_token1] = ACTIONS(4062),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3167] = {
    [sym_preproc_region] = STATE(3167),
    [sym_preproc_endregion] = STATE(3167),
    [sym_preproc_line] = STATE(3167),
    [sym_preproc_pragma] = STATE(3167),
    [sym_preproc_nullable] = STATE(3167),
    [sym_preproc_error] = STATE(3167),
    [sym_preproc_define] = STATE(3167),
    [sym_preproc_undef] = STATE(3167),
    [sym__identifier_token] = ACTIONS(4422),
    [anon_sym_alias] = ACTIONS(4422),
    [anon_sym_global] = ACTIONS(4422),
    [anon_sym_LBRACK] = ACTIONS(4547),
    [anon_sym_COLON] = ACTIONS(4424),
    [anon_sym_COMMA] = ACTIONS(4424),
    [anon_sym_LPAREN] = ACTIONS(4424),
    [anon_sym_RPAREN] = ACTIONS(4424),
    [anon_sym_LBRACE] = ACTIONS(4424),
    [anon_sym_RBRACE] = ACTIONS(4424),
    [anon_sym_file] = ACTIONS(4422),
    [anon_sym_LT] = ACTIONS(4422),
    [anon_sym_GT] = ACTIONS(4422),
    [anon_sym_where] = ACTIONS(4422),
    [anon_sym_QMARK] = ACTIONS(4550),
    [anon_sym_notnull] = ACTIONS(4422),
    [anon_sym_unmanaged] = ACTIONS(4422),
    [anon_sym_BANG] = ACTIONS(4422),
    [anon_sym_PLUS_PLUS] = ACTIONS(4424),
    [anon_sym_DASH_DASH] = ACTIONS(4424),
    [anon_sym_PLUS] = ACTIONS(4422),
    [anon_sym_DASH] = ACTIONS(4422),
    [anon_sym_STAR] = ACTIONS(4553),
    [anon_sym_SLASH] = ACTIONS(4422),
    [anon_sym_PERCENT] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4424),
    [anon_sym_PIPE] = ACTIONS(4422),
    [anon_sym_AMP] = ACTIONS(4422),
    [anon_sym_LT_LT] = ACTIONS(4424),
    [anon_sym_GT_GT] = ACTIONS(4422),
    [anon_sym_GT_GT_GT] = ACTIONS(4424),
    [anon_sym_EQ_EQ] = ACTIONS(4424),
    [anon_sym_BANG_EQ] = ACTIONS(4424),
    [anon_sym_GT_EQ] = ACTIONS(4424),
    [anon_sym_LT_EQ] = ACTIONS(4424),
    [anon_sym_DOT] = ACTIONS(4703),
    [anon_sym_scoped] = ACTIONS(4422),
    [anon_sym_var] = ACTIONS(4422),
    [anon_sym_yield] = ACTIONS(4422),
    [anon_sym_switch] = ACTIONS(4422),
    [anon_sym_when] = ACTIONS(4422),
    [sym_discard] = ACTIONS(4422),
    [anon_sym_DOT_DOT] = ACTIONS(4424),
    [anon_sym_and] = ACTIONS(4422),
    [anon_sym_or] = ACTIONS(4422),
    [anon_sym_AMP_AMP] = ACTIONS(4424),
    [anon_sym_PIPE_PIPE] = ACTIONS(4424),
    [anon_sym_QMARK_QMARK] = ACTIONS(4424),
    [anon_sym_from] = ACTIONS(4422),
    [anon_sym_into] = ACTIONS(4422),
    [anon_sym_join] = ACTIONS(4422),
    [anon_sym_on] = ACTIONS(4422),
    [anon_sym_equals] = ACTIONS(4422),
    [anon_sym_let] = ACTIONS(4422),
    [anon_sym_orderby] = ACTIONS(4422),
    [anon_sym_ascending] = ACTIONS(4422),
    [anon_sym_descending] = ACTIONS(4422),
    [anon_sym_group] = ACTIONS(4422),
    [anon_sym_by] = ACTIONS(4422),
    [anon_sym_select] = ACTIONS(4422),
    [anon_sym_as] = ACTIONS(4422),
    [anon_sym_is] = ACTIONS(4422),
    [anon_sym_DASH_GT] = ACTIONS(4424),
    [anon_sym_with] = ACTIONS(4422),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3168] = {
    [sym_preproc_region] = STATE(3168),
    [sym_preproc_endregion] = STATE(3168),
    [sym_preproc_line] = STATE(3168),
    [sym_preproc_pragma] = STATE(3168),
    [sym_preproc_nullable] = STATE(3168),
    [sym_preproc_error] = STATE(3168),
    [sym_preproc_define] = STATE(3168),
    [sym_preproc_undef] = STATE(3168),
    [sym__identifier_token] = ACTIONS(4027),
    [anon_sym_alias] = ACTIONS(4027),
    [anon_sym_global] = ACTIONS(4027),
    [anon_sym_LBRACK] = ACTIONS(4024),
    [anon_sym_COLON] = ACTIONS(4027),
    [anon_sym_COMMA] = ACTIONS(4024),
    [anon_sym_LPAREN] = ACTIONS(4024),
    [anon_sym_LBRACE] = ACTIONS(4024),
    [anon_sym_file] = ACTIONS(4027),
    [anon_sym_LT] = ACTIONS(4027),
    [anon_sym_GT] = ACTIONS(4027),
    [anon_sym_where] = ACTIONS(4027),
    [anon_sym_QMARK] = ACTIONS(4027),
    [anon_sym_notnull] = ACTIONS(4027),
    [anon_sym_unmanaged] = ACTIONS(4027),
    [anon_sym_BANG] = ACTIONS(4027),
    [anon_sym_PLUS_PLUS] = ACTIONS(4024),
    [anon_sym_DASH_DASH] = ACTIONS(4024),
    [anon_sym_PLUS] = ACTIONS(4027),
    [anon_sym_DASH] = ACTIONS(4027),
    [anon_sym_STAR] = ACTIONS(4024),
    [anon_sym_SLASH] = ACTIONS(4027),
    [anon_sym_PERCENT] = ACTIONS(4024),
    [anon_sym_CARET] = ACTIONS(4024),
    [anon_sym_PIPE] = ACTIONS(4027),
    [anon_sym_AMP] = ACTIONS(4027),
    [anon_sym_LT_LT] = ACTIONS(4024),
    [anon_sym_GT_GT] = ACTIONS(4027),
    [anon_sym_GT_GT_GT] = ACTIONS(4024),
    [anon_sym_EQ_EQ] = ACTIONS(4024),
    [anon_sym_BANG_EQ] = ACTIONS(4024),
    [anon_sym_GT_EQ] = ACTIONS(4024),
    [anon_sym_LT_EQ] = ACTIONS(4024),
    [anon_sym_DOT] = ACTIONS(4027),
    [anon_sym_scoped] = ACTIONS(4027),
    [anon_sym_COLON_COLON] = ACTIONS(3719),
    [anon_sym_var] = ACTIONS(4027),
    [anon_sym_yield] = ACTIONS(4027),
    [anon_sym_switch] = ACTIONS(4027),
    [anon_sym_when] = ACTIONS(4027),
    [sym_discard] = ACTIONS(4027),
    [anon_sym_DOT_DOT] = ACTIONS(4024),
    [anon_sym_and] = ACTIONS(4027),
    [anon_sym_or] = ACTIONS(4027),
    [anon_sym_AMP_AMP] = ACTIONS(4024),
    [anon_sym_PIPE_PIPE] = ACTIONS(4024),
    [anon_sym_QMARK_QMARK] = ACTIONS(4024),
    [anon_sym_from] = ACTIONS(4027),
    [anon_sym_into] = ACTIONS(4027),
    [anon_sym_join] = ACTIONS(4027),
    [anon_sym_on] = ACTIONS(4027),
    [anon_sym_equals] = ACTIONS(4027),
    [anon_sym_let] = ACTIONS(4027),
    [anon_sym_orderby] = ACTIONS(4027),
    [anon_sym_ascending] = ACTIONS(4027),
    [anon_sym_descending] = ACTIONS(4027),
    [anon_sym_group] = ACTIONS(4027),
    [anon_sym_by] = ACTIONS(4027),
    [anon_sym_select] = ACTIONS(4027),
    [anon_sym_as] = ACTIONS(4027),
    [anon_sym_is] = ACTIONS(4027),
    [anon_sym_DASH_GT] = ACTIONS(4024),
    [anon_sym_with] = ACTIONS(4027),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4024),
  },
  [3169] = {
    [sym__variable_designation] = STATE(4082),
    [sym_parenthesized_variable_designation] = STATE(4274),
    [sym_identifier] = STATE(4269),
    [sym__reserved_identifier] = STATE(3897),
    [sym_preproc_region] = STATE(3169),
    [sym_preproc_endregion] = STATE(3169),
    [sym_preproc_line] = STATE(3169),
    [sym_preproc_pragma] = STATE(3169),
    [sym_preproc_nullable] = STATE(3169),
    [sym_preproc_error] = STATE(3169),
    [sym_preproc_define] = STATE(3169),
    [sym_preproc_undef] = STATE(3169),
    [sym__identifier_token] = ACTIONS(4168),
    [anon_sym_alias] = ACTIONS(4170),
    [anon_sym_global] = ACTIONS(4170),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_LPAREN] = ACTIONS(4383),
    [anon_sym_file] = ACTIONS(4170),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_in] = ACTIONS(4385),
    [anon_sym_where] = ACTIONS(4170),
    [anon_sym_QMARK] = ACTIONS(4385),
    [anon_sym_notnull] = ACTIONS(4170),
    [anon_sym_unmanaged] = ACTIONS(4170),
    [anon_sym_BANG] = ACTIONS(4385),
    [anon_sym_PLUS_PLUS] = ACTIONS(4383),
    [anon_sym_DASH_DASH] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_DASH] = ACTIONS(4385),
    [anon_sym_STAR] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4385),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4385),
    [anon_sym_GT_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4383),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_scoped] = ACTIONS(4170),
    [anon_sym_var] = ACTIONS(4170),
    [anon_sym_yield] = ACTIONS(4170),
    [anon_sym_switch] = ACTIONS(4385),
    [anon_sym_when] = ACTIONS(4170),
    [sym_discard] = ACTIONS(4295),
    [anon_sym_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4385),
    [anon_sym_or] = ACTIONS(4385),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_QMARK_QMARK] = ACTIONS(4383),
    [anon_sym_from] = ACTIONS(4170),
    [anon_sym_into] = ACTIONS(4170),
    [anon_sym_join] = ACTIONS(4170),
    [anon_sym_on] = ACTIONS(4170),
    [anon_sym_equals] = ACTIONS(4170),
    [anon_sym_let] = ACTIONS(4170),
    [anon_sym_orderby] = ACTIONS(4170),
    [anon_sym_ascending] = ACTIONS(4170),
    [anon_sym_descending] = ACTIONS(4170),
    [anon_sym_group] = ACTIONS(4170),
    [anon_sym_by] = ACTIONS(4170),
    [anon_sym_select] = ACTIONS(4170),
    [anon_sym_as] = ACTIONS(4385),
    [anon_sym_is] = ACTIONS(4385),
    [anon_sym_DASH_GT] = ACTIONS(4383),
    [anon_sym_with] = ACTIONS(4385),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3170] = {
    [sym__variable_designation] = STATE(4692),
    [sym_parenthesized_variable_designation] = STATE(4614),
    [sym_identifier] = STATE(4624),
    [sym__reserved_identifier] = STATE(2914),
    [sym_preproc_region] = STATE(3170),
    [sym_preproc_endregion] = STATE(3170),
    [sym_preproc_line] = STATE(3170),
    [sym_preproc_pragma] = STATE(3170),
    [sym_preproc_nullable] = STATE(3170),
    [sym_preproc_error] = STATE(3170),
    [sym_preproc_define] = STATE(3170),
    [sym_preproc_undef] = STATE(3170),
    [sym__identifier_token] = ACTIONS(4490),
    [anon_sym_alias] = ACTIONS(4492),
    [anon_sym_global] = ACTIONS(4492),
    [anon_sym_LBRACK] = ACTIONS(4335),
    [anon_sym_COMMA] = ACTIONS(4335),
    [anon_sym_LPAREN] = ACTIONS(4335),
    [anon_sym_file] = ACTIONS(4492),
    [anon_sym_LT] = ACTIONS(4337),
    [anon_sym_GT] = ACTIONS(4337),
    [anon_sym_where] = ACTIONS(4337),
    [anon_sym_QMARK] = ACTIONS(4337),
    [anon_sym_notnull] = ACTIONS(4492),
    [anon_sym_unmanaged] = ACTIONS(4492),
    [anon_sym_BANG] = ACTIONS(4337),
    [anon_sym_PLUS_PLUS] = ACTIONS(4335),
    [anon_sym_DASH_DASH] = ACTIONS(4335),
    [anon_sym_PLUS] = ACTIONS(4337),
    [anon_sym_DASH] = ACTIONS(4337),
    [anon_sym_STAR] = ACTIONS(4335),
    [anon_sym_SLASH] = ACTIONS(4337),
    [anon_sym_PERCENT] = ACTIONS(4335),
    [anon_sym_CARET] = ACTIONS(4335),
    [anon_sym_PIPE] = ACTIONS(4337),
    [anon_sym_AMP] = ACTIONS(4337),
    [anon_sym_LT_LT] = ACTIONS(4335),
    [anon_sym_GT_GT] = ACTIONS(4337),
    [anon_sym_GT_GT_GT] = ACTIONS(4335),
    [anon_sym_EQ_EQ] = ACTIONS(4335),
    [anon_sym_BANG_EQ] = ACTIONS(4335),
    [anon_sym_GT_EQ] = ACTIONS(4335),
    [anon_sym_LT_EQ] = ACTIONS(4335),
    [anon_sym_DOT] = ACTIONS(4337),
    [anon_sym_scoped] = ACTIONS(4492),
    [anon_sym_var] = ACTIONS(4492),
    [anon_sym_yield] = ACTIONS(4492),
    [anon_sym_switch] = ACTIONS(4337),
    [anon_sym_when] = ACTIONS(4492),
    [sym_discard] = ACTIONS(4647),
    [anon_sym_DOT_DOT] = ACTIONS(4335),
    [anon_sym_and] = ACTIONS(4337),
    [anon_sym_or] = ACTIONS(4337),
    [anon_sym_AMP_AMP] = ACTIONS(4335),
    [anon_sym_PIPE_PIPE] = ACTIONS(4335),
    [anon_sym_QMARK_QMARK] = ACTIONS(4335),
    [anon_sym_from] = ACTIONS(4337),
    [anon_sym_into] = ACTIONS(4492),
    [anon_sym_join] = ACTIONS(4337),
    [anon_sym_on] = ACTIONS(4492),
    [anon_sym_equals] = ACTIONS(4492),
    [anon_sym_let] = ACTIONS(4337),
    [anon_sym_orderby] = ACTIONS(4337),
    [anon_sym_ascending] = ACTIONS(4337),
    [anon_sym_descending] = ACTIONS(4337),
    [anon_sym_group] = ACTIONS(4337),
    [anon_sym_by] = ACTIONS(4492),
    [anon_sym_select] = ACTIONS(4337),
    [anon_sym_as] = ACTIONS(4337),
    [anon_sym_is] = ACTIONS(4337),
    [anon_sym_DASH_GT] = ACTIONS(4335),
    [anon_sym_with] = ACTIONS(4337),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3171] = {
    [sym_preproc_region] = STATE(3171),
    [sym_preproc_endregion] = STATE(3171),
    [sym_preproc_line] = STATE(3171),
    [sym_preproc_pragma] = STATE(3171),
    [sym_preproc_nullable] = STATE(3171),
    [sym_preproc_error] = STATE(3171),
    [sym_preproc_define] = STATE(3171),
    [sym_preproc_undef] = STATE(3171),
    [sym__identifier_token] = ACTIONS(3721),
    [anon_sym_alias] = ACTIONS(3721),
    [anon_sym_global] = ACTIONS(3721),
    [anon_sym_LBRACK] = ACTIONS(3719),
    [anon_sym_COLON] = ACTIONS(3721),
    [anon_sym_COMMA] = ACTIONS(3719),
    [anon_sym_LPAREN] = ACTIONS(3719),
    [anon_sym_LBRACE] = ACTIONS(3719),
    [anon_sym_file] = ACTIONS(3721),
    [anon_sym_LT] = ACTIONS(3721),
    [anon_sym_GT] = ACTIONS(3721),
    [anon_sym_where] = ACTIONS(3721),
    [anon_sym_QMARK] = ACTIONS(3721),
    [anon_sym_notnull] = ACTIONS(3721),
    [anon_sym_unmanaged] = ACTIONS(3721),
    [anon_sym_BANG] = ACTIONS(3721),
    [anon_sym_PLUS_PLUS] = ACTIONS(3719),
    [anon_sym_DASH_DASH] = ACTIONS(3719),
    [anon_sym_PLUS] = ACTIONS(3721),
    [anon_sym_DASH] = ACTIONS(3721),
    [anon_sym_STAR] = ACTIONS(3719),
    [anon_sym_SLASH] = ACTIONS(3721),
    [anon_sym_PERCENT] = ACTIONS(3719),
    [anon_sym_CARET] = ACTIONS(3719),
    [anon_sym_PIPE] = ACTIONS(3721),
    [anon_sym_AMP] = ACTIONS(3721),
    [anon_sym_LT_LT] = ACTIONS(3719),
    [anon_sym_GT_GT] = ACTIONS(3721),
    [anon_sym_GT_GT_GT] = ACTIONS(3719),
    [anon_sym_EQ_EQ] = ACTIONS(3719),
    [anon_sym_BANG_EQ] = ACTIONS(3719),
    [anon_sym_GT_EQ] = ACTIONS(3719),
    [anon_sym_LT_EQ] = ACTIONS(3719),
    [anon_sym_DOT] = ACTIONS(3721),
    [anon_sym_scoped] = ACTIONS(3721),
    [anon_sym_COLON_COLON] = ACTIONS(3719),
    [anon_sym_var] = ACTIONS(3721),
    [anon_sym_yield] = ACTIONS(3721),
    [anon_sym_switch] = ACTIONS(3721),
    [anon_sym_when] = ACTIONS(3721),
    [sym_discard] = ACTIONS(3721),
    [anon_sym_DOT_DOT] = ACTIONS(3719),
    [anon_sym_and] = ACTIONS(3721),
    [anon_sym_or] = ACTIONS(3721),
    [anon_sym_AMP_AMP] = ACTIONS(3719),
    [anon_sym_PIPE_PIPE] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK] = ACTIONS(3719),
    [anon_sym_from] = ACTIONS(3721),
    [anon_sym_into] = ACTIONS(3721),
    [anon_sym_join] = ACTIONS(3721),
    [anon_sym_on] = ACTIONS(3721),
    [anon_sym_equals] = ACTIONS(3721),
    [anon_sym_let] = ACTIONS(3721),
    [anon_sym_orderby] = ACTIONS(3721),
    [anon_sym_ascending] = ACTIONS(3721),
    [anon_sym_descending] = ACTIONS(3721),
    [anon_sym_group] = ACTIONS(3721),
    [anon_sym_by] = ACTIONS(3721),
    [anon_sym_select] = ACTIONS(3721),
    [anon_sym_as] = ACTIONS(3721),
    [anon_sym_is] = ACTIONS(3721),
    [anon_sym_DASH_GT] = ACTIONS(3719),
    [anon_sym_with] = ACTIONS(3721),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(3719),
  },
  [3172] = {
    [sym_preproc_region] = STATE(3172),
    [sym_preproc_endregion] = STATE(3172),
    [sym_preproc_line] = STATE(3172),
    [sym_preproc_pragma] = STATE(3172),
    [sym_preproc_nullable] = STATE(3172),
    [sym_preproc_error] = STATE(3172),
    [sym_preproc_define] = STATE(3172),
    [sym_preproc_undef] = STATE(3172),
    [anon_sym_SEMI] = ACTIONS(4643),
    [anon_sym_EQ] = ACTIONS(4645),
    [anon_sym_LBRACK] = ACTIONS(4643),
    [anon_sym_COLON] = ACTIONS(4643),
    [anon_sym_COMMA] = ACTIONS(4643),
    [anon_sym_RBRACK] = ACTIONS(4643),
    [anon_sym_LPAREN] = ACTIONS(4643),
    [anon_sym_RPAREN] = ACTIONS(4643),
    [anon_sym_RBRACE] = ACTIONS(4643),
    [anon_sym_LT] = ACTIONS(4645),
    [anon_sym_GT] = ACTIONS(4645),
    [anon_sym_in] = ACTIONS(4645),
    [anon_sym_QMARK] = ACTIONS(4645),
    [anon_sym_BANG] = ACTIONS(4645),
    [anon_sym_PLUS_PLUS] = ACTIONS(4643),
    [anon_sym_DASH_DASH] = ACTIONS(4643),
    [anon_sym_PLUS] = ACTIONS(4645),
    [anon_sym_DASH] = ACTIONS(4645),
    [anon_sym_STAR] = ACTIONS(4645),
    [anon_sym_SLASH] = ACTIONS(4645),
    [anon_sym_PERCENT] = ACTIONS(4645),
    [anon_sym_CARET] = ACTIONS(4645),
    [anon_sym_PIPE] = ACTIONS(4645),
    [anon_sym_AMP] = ACTIONS(4645),
    [anon_sym_LT_LT] = ACTIONS(4645),
    [anon_sym_GT_GT] = ACTIONS(4645),
    [anon_sym_GT_GT_GT] = ACTIONS(4645),
    [anon_sym_EQ_EQ] = ACTIONS(4643),
    [anon_sym_BANG_EQ] = ACTIONS(4643),
    [anon_sym_GT_EQ] = ACTIONS(4643),
    [anon_sym_LT_EQ] = ACTIONS(4643),
    [anon_sym_DOT] = ACTIONS(4645),
    [anon_sym_EQ_GT] = ACTIONS(4643),
    [anon_sym_switch] = ACTIONS(4643),
    [anon_sym_when] = ACTIONS(4643),
    [anon_sym_DOT_DOT] = ACTIONS(4643),
    [anon_sym_and] = ACTIONS(4643),
    [anon_sym_or] = ACTIONS(4643),
    [anon_sym_PLUS_EQ] = ACTIONS(4643),
    [anon_sym_DASH_EQ] = ACTIONS(4643),
    [anon_sym_STAR_EQ] = ACTIONS(4643),
    [anon_sym_SLASH_EQ] = ACTIONS(4643),
    [anon_sym_PERCENT_EQ] = ACTIONS(4643),
    [anon_sym_AMP_EQ] = ACTIONS(4643),
    [anon_sym_CARET_EQ] = ACTIONS(4643),
    [anon_sym_PIPE_EQ] = ACTIONS(4643),
    [anon_sym_LT_LT_EQ] = ACTIONS(4643),
    [anon_sym_GT_GT_EQ] = ACTIONS(4643),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4643),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4643),
    [anon_sym_AMP_AMP] = ACTIONS(4643),
    [anon_sym_PIPE_PIPE] = ACTIONS(4643),
    [anon_sym_QMARK_QMARK] = ACTIONS(4645),
    [anon_sym_into] = ACTIONS(4643),
    [anon_sym_on] = ACTIONS(4643),
    [anon_sym_equals] = ACTIONS(4643),
    [anon_sym_by] = ACTIONS(4643),
    [anon_sym_as] = ACTIONS(4643),
    [anon_sym_is] = ACTIONS(4643),
    [anon_sym_DASH_GT] = ACTIONS(4643),
    [anon_sym_with] = ACTIONS(4643),
    [aux_sym_preproc_if_token3] = ACTIONS(4643),
    [aux_sym_preproc_else_token1] = ACTIONS(4643),
    [aux_sym_preproc_elif_token1] = ACTIONS(4643),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3173] = {
    [sym__variable_designation] = STATE(4113),
    [sym_parenthesized_variable_designation] = STATE(4274),
    [sym_identifier] = STATE(4269),
    [sym__reserved_identifier] = STATE(3897),
    [sym_preproc_region] = STATE(3173),
    [sym_preproc_endregion] = STATE(3173),
    [sym_preproc_line] = STATE(3173),
    [sym_preproc_pragma] = STATE(3173),
    [sym_preproc_nullable] = STATE(3173),
    [sym_preproc_error] = STATE(3173),
    [sym_preproc_define] = STATE(3173),
    [sym_preproc_undef] = STATE(3173),
    [sym__identifier_token] = ACTIONS(4168),
    [anon_sym_alias] = ACTIONS(4170),
    [anon_sym_global] = ACTIONS(4170),
    [anon_sym_LBRACK] = ACTIONS(4373),
    [anon_sym_LPAREN] = ACTIONS(4373),
    [anon_sym_file] = ACTIONS(4170),
    [anon_sym_LT] = ACTIONS(4375),
    [anon_sym_GT] = ACTIONS(4375),
    [anon_sym_in] = ACTIONS(4375),
    [anon_sym_where] = ACTIONS(4170),
    [anon_sym_QMARK] = ACTIONS(4375),
    [anon_sym_notnull] = ACTIONS(4170),
    [anon_sym_unmanaged] = ACTIONS(4170),
    [anon_sym_BANG] = ACTIONS(4375),
    [anon_sym_PLUS_PLUS] = ACTIONS(4373),
    [anon_sym_DASH_DASH] = ACTIONS(4373),
    [anon_sym_PLUS] = ACTIONS(4375),
    [anon_sym_DASH] = ACTIONS(4375),
    [anon_sym_STAR] = ACTIONS(4373),
    [anon_sym_SLASH] = ACTIONS(4375),
    [anon_sym_PERCENT] = ACTIONS(4373),
    [anon_sym_CARET] = ACTIONS(4373),
    [anon_sym_PIPE] = ACTIONS(4375),
    [anon_sym_AMP] = ACTIONS(4375),
    [anon_sym_LT_LT] = ACTIONS(4373),
    [anon_sym_GT_GT] = ACTIONS(4375),
    [anon_sym_GT_GT_GT] = ACTIONS(4373),
    [anon_sym_EQ_EQ] = ACTIONS(4373),
    [anon_sym_BANG_EQ] = ACTIONS(4373),
    [anon_sym_GT_EQ] = ACTIONS(4373),
    [anon_sym_LT_EQ] = ACTIONS(4373),
    [anon_sym_DOT] = ACTIONS(4375),
    [anon_sym_scoped] = ACTIONS(4170),
    [anon_sym_var] = ACTIONS(4170),
    [anon_sym_yield] = ACTIONS(4170),
    [anon_sym_switch] = ACTIONS(4375),
    [anon_sym_when] = ACTIONS(4170),
    [sym_discard] = ACTIONS(4295),
    [anon_sym_DOT_DOT] = ACTIONS(4373),
    [anon_sym_and] = ACTIONS(4375),
    [anon_sym_or] = ACTIONS(4375),
    [anon_sym_AMP_AMP] = ACTIONS(4373),
    [anon_sym_PIPE_PIPE] = ACTIONS(4373),
    [anon_sym_QMARK_QMARK] = ACTIONS(4373),
    [anon_sym_from] = ACTIONS(4170),
    [anon_sym_into] = ACTIONS(4170),
    [anon_sym_join] = ACTIONS(4170),
    [anon_sym_on] = ACTIONS(4170),
    [anon_sym_equals] = ACTIONS(4170),
    [anon_sym_let] = ACTIONS(4170),
    [anon_sym_orderby] = ACTIONS(4170),
    [anon_sym_ascending] = ACTIONS(4170),
    [anon_sym_descending] = ACTIONS(4170),
    [anon_sym_group] = ACTIONS(4170),
    [anon_sym_by] = ACTIONS(4170),
    [anon_sym_select] = ACTIONS(4170),
    [anon_sym_as] = ACTIONS(4375),
    [anon_sym_is] = ACTIONS(4375),
    [anon_sym_DASH_GT] = ACTIONS(4373),
    [anon_sym_with] = ACTIONS(4375),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3174] = {
    [sym_preproc_region] = STATE(3174),
    [sym_preproc_endregion] = STATE(3174),
    [sym_preproc_line] = STATE(3174),
    [sym_preproc_pragma] = STATE(3174),
    [sym_preproc_nullable] = STATE(3174),
    [sym_preproc_error] = STATE(3174),
    [sym_preproc_define] = STATE(3174),
    [sym_preproc_undef] = STATE(3174),
    [anon_sym_SEMI] = ACTIONS(4643),
    [anon_sym_EQ] = ACTIONS(4645),
    [anon_sym_LBRACK] = ACTIONS(4643),
    [anon_sym_COLON] = ACTIONS(4643),
    [anon_sym_COMMA] = ACTIONS(4643),
    [anon_sym_RBRACK] = ACTIONS(4643),
    [anon_sym_LPAREN] = ACTIONS(4643),
    [anon_sym_RPAREN] = ACTIONS(4643),
    [anon_sym_LBRACE] = ACTIONS(4643),
    [anon_sym_RBRACE] = ACTIONS(4643),
    [anon_sym_LT] = ACTIONS(4645),
    [anon_sym_GT] = ACTIONS(4645),
    [anon_sym_in] = ACTIONS(4643),
    [anon_sym_QMARK] = ACTIONS(4645),
    [anon_sym_BANG] = ACTIONS(4645),
    [anon_sym_PLUS_PLUS] = ACTIONS(4643),
    [anon_sym_DASH_DASH] = ACTIONS(4643),
    [anon_sym_PLUS] = ACTIONS(4645),
    [anon_sym_DASH] = ACTIONS(4645),
    [anon_sym_STAR] = ACTIONS(4645),
    [anon_sym_SLASH] = ACTIONS(4645),
    [anon_sym_PERCENT] = ACTIONS(4645),
    [anon_sym_CARET] = ACTIONS(4645),
    [anon_sym_PIPE] = ACTIONS(4645),
    [anon_sym_AMP] = ACTIONS(4645),
    [anon_sym_LT_LT] = ACTIONS(4645),
    [anon_sym_GT_GT] = ACTIONS(4645),
    [anon_sym_GT_GT_GT] = ACTIONS(4645),
    [anon_sym_EQ_EQ] = ACTIONS(4643),
    [anon_sym_BANG_EQ] = ACTIONS(4643),
    [anon_sym_GT_EQ] = ACTIONS(4643),
    [anon_sym_LT_EQ] = ACTIONS(4643),
    [anon_sym_DOT] = ACTIONS(4645),
    [anon_sym_EQ_GT] = ACTIONS(4643),
    [anon_sym_switch] = ACTIONS(4643),
    [anon_sym_when] = ACTIONS(4643),
    [anon_sym_DOT_DOT] = ACTIONS(4643),
    [anon_sym_and] = ACTIONS(4643),
    [anon_sym_or] = ACTIONS(4643),
    [anon_sym_PLUS_EQ] = ACTIONS(4643),
    [anon_sym_DASH_EQ] = ACTIONS(4643),
    [anon_sym_STAR_EQ] = ACTIONS(4643),
    [anon_sym_SLASH_EQ] = ACTIONS(4643),
    [anon_sym_PERCENT_EQ] = ACTIONS(4643),
    [anon_sym_AMP_EQ] = ACTIONS(4643),
    [anon_sym_CARET_EQ] = ACTIONS(4643),
    [anon_sym_PIPE_EQ] = ACTIONS(4643),
    [anon_sym_LT_LT_EQ] = ACTIONS(4643),
    [anon_sym_GT_GT_EQ] = ACTIONS(4643),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4643),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4643),
    [anon_sym_AMP_AMP] = ACTIONS(4643),
    [anon_sym_PIPE_PIPE] = ACTIONS(4643),
    [anon_sym_QMARK_QMARK] = ACTIONS(4645),
    [anon_sym_on] = ACTIONS(4643),
    [anon_sym_equals] = ACTIONS(4643),
    [anon_sym_by] = ACTIONS(4643),
    [anon_sym_as] = ACTIONS(4643),
    [anon_sym_is] = ACTIONS(4643),
    [anon_sym_DASH_GT] = ACTIONS(4643),
    [anon_sym_with] = ACTIONS(4643),
    [aux_sym_preproc_if_token3] = ACTIONS(4643),
    [aux_sym_preproc_else_token1] = ACTIONS(4643),
    [aux_sym_preproc_elif_token1] = ACTIONS(4643),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3175] = {
    [sym__variable_designation] = STATE(4123),
    [sym_parenthesized_variable_designation] = STATE(4274),
    [sym_identifier] = STATE(4269),
    [sym__reserved_identifier] = STATE(3897),
    [sym_preproc_region] = STATE(3175),
    [sym_preproc_endregion] = STATE(3175),
    [sym_preproc_line] = STATE(3175),
    [sym_preproc_pragma] = STATE(3175),
    [sym_preproc_nullable] = STATE(3175),
    [sym_preproc_error] = STATE(3175),
    [sym_preproc_define] = STATE(3175),
    [sym_preproc_undef] = STATE(3175),
    [sym__identifier_token] = ACTIONS(4168),
    [anon_sym_alias] = ACTIONS(4170),
    [anon_sym_global] = ACTIONS(4170),
    [anon_sym_LBRACK] = ACTIONS(4335),
    [anon_sym_LPAREN] = ACTIONS(4335),
    [anon_sym_file] = ACTIONS(4170),
    [anon_sym_LT] = ACTIONS(4337),
    [anon_sym_GT] = ACTIONS(4337),
    [anon_sym_in] = ACTIONS(4337),
    [anon_sym_where] = ACTIONS(4170),
    [anon_sym_QMARK] = ACTIONS(4337),
    [anon_sym_notnull] = ACTIONS(4170),
    [anon_sym_unmanaged] = ACTIONS(4170),
    [anon_sym_BANG] = ACTIONS(4337),
    [anon_sym_PLUS_PLUS] = ACTIONS(4335),
    [anon_sym_DASH_DASH] = ACTIONS(4335),
    [anon_sym_PLUS] = ACTIONS(4337),
    [anon_sym_DASH] = ACTIONS(4337),
    [anon_sym_STAR] = ACTIONS(4335),
    [anon_sym_SLASH] = ACTIONS(4337),
    [anon_sym_PERCENT] = ACTIONS(4335),
    [anon_sym_CARET] = ACTIONS(4335),
    [anon_sym_PIPE] = ACTIONS(4337),
    [anon_sym_AMP] = ACTIONS(4337),
    [anon_sym_LT_LT] = ACTIONS(4335),
    [anon_sym_GT_GT] = ACTIONS(4337),
    [anon_sym_GT_GT_GT] = ACTIONS(4335),
    [anon_sym_EQ_EQ] = ACTIONS(4335),
    [anon_sym_BANG_EQ] = ACTIONS(4335),
    [anon_sym_GT_EQ] = ACTIONS(4335),
    [anon_sym_LT_EQ] = ACTIONS(4335),
    [anon_sym_DOT] = ACTIONS(4337),
    [anon_sym_scoped] = ACTIONS(4170),
    [anon_sym_var] = ACTIONS(4170),
    [anon_sym_yield] = ACTIONS(4170),
    [anon_sym_switch] = ACTIONS(4337),
    [anon_sym_when] = ACTIONS(4170),
    [sym_discard] = ACTIONS(4295),
    [anon_sym_DOT_DOT] = ACTIONS(4335),
    [anon_sym_and] = ACTIONS(4337),
    [anon_sym_or] = ACTIONS(4337),
    [anon_sym_AMP_AMP] = ACTIONS(4335),
    [anon_sym_PIPE_PIPE] = ACTIONS(4335),
    [anon_sym_QMARK_QMARK] = ACTIONS(4335),
    [anon_sym_from] = ACTIONS(4170),
    [anon_sym_into] = ACTIONS(4170),
    [anon_sym_join] = ACTIONS(4170),
    [anon_sym_on] = ACTIONS(4170),
    [anon_sym_equals] = ACTIONS(4170),
    [anon_sym_let] = ACTIONS(4170),
    [anon_sym_orderby] = ACTIONS(4170),
    [anon_sym_ascending] = ACTIONS(4170),
    [anon_sym_descending] = ACTIONS(4170),
    [anon_sym_group] = ACTIONS(4170),
    [anon_sym_by] = ACTIONS(4170),
    [anon_sym_select] = ACTIONS(4170),
    [anon_sym_as] = ACTIONS(4337),
    [anon_sym_is] = ACTIONS(4337),
    [anon_sym_DASH_GT] = ACTIONS(4335),
    [anon_sym_with] = ACTIONS(4337),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3176] = {
    [sym_preproc_region] = STATE(3176),
    [sym_preproc_endregion] = STATE(3176),
    [sym_preproc_line] = STATE(3176),
    [sym_preproc_pragma] = STATE(3176),
    [sym_preproc_nullable] = STATE(3176),
    [sym_preproc_error] = STATE(3176),
    [sym_preproc_define] = STATE(3176),
    [sym_preproc_undef] = STATE(3176),
    [sym__identifier_token] = ACTIONS(4705),
    [anon_sym_extern] = ACTIONS(4705),
    [anon_sym_alias] = ACTIONS(4705),
    [anon_sym_global] = ACTIONS(4705),
    [anon_sym_using] = ACTIONS(4705),
    [anon_sym_unsafe] = ACTIONS(4705),
    [anon_sym_EQ] = ACTIONS(4707),
    [anon_sym_static] = ACTIONS(4705),
    [anon_sym_LBRACK] = ACTIONS(4709),
    [anon_sym_LPAREN] = ACTIONS(4709),
    [anon_sym_event] = ACTIONS(4705),
    [anon_sym_namespace] = ACTIONS(4705),
    [anon_sym_class] = ACTIONS(4705),
    [anon_sym_ref] = ACTIONS(4705),
    [anon_sym_struct] = ACTIONS(4705),
    [anon_sym_enum] = ACTIONS(4705),
    [anon_sym_RBRACE] = ACTIONS(4709),
    [anon_sym_interface] = ACTIONS(4705),
    [anon_sym_delegate] = ACTIONS(4705),
    [anon_sym_record] = ACTIONS(4705),
    [anon_sym_abstract] = ACTIONS(4705),
    [anon_sym_async] = ACTIONS(4705),
    [anon_sym_const] = ACTIONS(4705),
    [anon_sym_file] = ACTIONS(4705),
    [anon_sym_fixed] = ACTIONS(4705),
    [anon_sym_internal] = ACTIONS(4705),
    [anon_sym_new] = ACTIONS(4705),
    [anon_sym_override] = ACTIONS(4705),
    [anon_sym_partial] = ACTIONS(4705),
    [anon_sym_private] = ACTIONS(4705),
    [anon_sym_protected] = ACTIONS(4705),
    [anon_sym_public] = ACTIONS(4705),
    [anon_sym_readonly] = ACTIONS(4705),
    [anon_sym_required] = ACTIONS(4705),
    [anon_sym_sealed] = ACTIONS(4705),
    [anon_sym_virtual] = ACTIONS(4705),
    [anon_sym_volatile] = ACTIONS(4705),
    [anon_sym_where] = ACTIONS(4705),
    [anon_sym_notnull] = ACTIONS(4705),
    [anon_sym_unmanaged] = ACTIONS(4705),
    [anon_sym_TILDE] = ACTIONS(4709),
    [anon_sym_implicit] = ACTIONS(4705),
    [anon_sym_explicit] = ACTIONS(4705),
    [anon_sym_scoped] = ACTIONS(4705),
    [anon_sym_var] = ACTIONS(4705),
    [sym_predefined_type] = ACTIONS(4705),
    [anon_sym_yield] = ACTIONS(4705),
    [anon_sym_when] = ACTIONS(4705),
    [anon_sym_from] = ACTIONS(4705),
    [anon_sym_into] = ACTIONS(4705),
    [anon_sym_join] = ACTIONS(4705),
    [anon_sym_on] = ACTIONS(4705),
    [anon_sym_equals] = ACTIONS(4705),
    [anon_sym_let] = ACTIONS(4705),
    [anon_sym_orderby] = ACTIONS(4705),
    [anon_sym_ascending] = ACTIONS(4705),
    [anon_sym_descending] = ACTIONS(4705),
    [anon_sym_group] = ACTIONS(4705),
    [anon_sym_by] = ACTIONS(4705),
    [anon_sym_select] = ACTIONS(4705),
    [aux_sym_preproc_if_token1] = ACTIONS(4709),
    [aux_sym_preproc_if_token3] = ACTIONS(4709),
    [aux_sym_preproc_else_token1] = ACTIONS(4709),
    [aux_sym_preproc_elif_token1] = ACTIONS(4709),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3177] = {
    [sym__variable_designation] = STATE(4544),
    [sym_parenthesized_variable_designation] = STATE(4614),
    [sym_identifier] = STATE(4624),
    [sym__reserved_identifier] = STATE(2914),
    [sym_preproc_region] = STATE(3177),
    [sym_preproc_endregion] = STATE(3177),
    [sym_preproc_line] = STATE(3177),
    [sym_preproc_pragma] = STATE(3177),
    [sym_preproc_nullable] = STATE(3177),
    [sym_preproc_error] = STATE(3177),
    [sym_preproc_define] = STATE(3177),
    [sym_preproc_undef] = STATE(3177),
    [sym__identifier_token] = ACTIONS(4490),
    [anon_sym_alias] = ACTIONS(4492),
    [anon_sym_global] = ACTIONS(4492),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COMMA] = ACTIONS(4383),
    [anon_sym_LPAREN] = ACTIONS(4383),
    [anon_sym_file] = ACTIONS(4492),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_where] = ACTIONS(4385),
    [anon_sym_QMARK] = ACTIONS(4385),
    [anon_sym_notnull] = ACTIONS(4492),
    [anon_sym_unmanaged] = ACTIONS(4492),
    [anon_sym_BANG] = ACTIONS(4385),
    [anon_sym_PLUS_PLUS] = ACTIONS(4383),
    [anon_sym_DASH_DASH] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_DASH] = ACTIONS(4385),
    [anon_sym_STAR] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4385),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4385),
    [anon_sym_GT_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4383),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_scoped] = ACTIONS(4492),
    [anon_sym_var] = ACTIONS(4492),
    [anon_sym_yield] = ACTIONS(4492),
    [anon_sym_switch] = ACTIONS(4385),
    [anon_sym_when] = ACTIONS(4492),
    [sym_discard] = ACTIONS(4647),
    [anon_sym_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4385),
    [anon_sym_or] = ACTIONS(4385),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_QMARK_QMARK] = ACTIONS(4383),
    [anon_sym_from] = ACTIONS(4385),
    [anon_sym_into] = ACTIONS(4492),
    [anon_sym_join] = ACTIONS(4385),
    [anon_sym_on] = ACTIONS(4492),
    [anon_sym_equals] = ACTIONS(4492),
    [anon_sym_let] = ACTIONS(4385),
    [anon_sym_orderby] = ACTIONS(4385),
    [anon_sym_ascending] = ACTIONS(4385),
    [anon_sym_descending] = ACTIONS(4385),
    [anon_sym_group] = ACTIONS(4385),
    [anon_sym_by] = ACTIONS(4492),
    [anon_sym_select] = ACTIONS(4385),
    [anon_sym_as] = ACTIONS(4385),
    [anon_sym_is] = ACTIONS(4385),
    [anon_sym_DASH_GT] = ACTIONS(4383),
    [anon_sym_with] = ACTIONS(4385),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3178] = {
    [sym_preproc_region] = STATE(3178),
    [sym_preproc_endregion] = STATE(3178),
    [sym_preproc_line] = STATE(3178),
    [sym_preproc_pragma] = STATE(3178),
    [sym_preproc_nullable] = STATE(3178),
    [sym_preproc_error] = STATE(3178),
    [sym_preproc_define] = STATE(3178),
    [sym_preproc_undef] = STATE(3178),
    [sym__identifier_token] = ACTIONS(4422),
    [anon_sym_alias] = ACTIONS(4422),
    [anon_sym_global] = ACTIONS(4422),
    [anon_sym_LBRACK] = ACTIONS(4547),
    [anon_sym_COLON] = ACTIONS(4424),
    [anon_sym_COMMA] = ACTIONS(4424),
    [anon_sym_LPAREN] = ACTIONS(4424),
    [anon_sym_RPAREN] = ACTIONS(4424),
    [anon_sym_LBRACE] = ACTIONS(4424),
    [anon_sym_RBRACE] = ACTIONS(4424),
    [anon_sym_file] = ACTIONS(4422),
    [anon_sym_LT] = ACTIONS(4422),
    [anon_sym_GT] = ACTIONS(4422),
    [anon_sym_where] = ACTIONS(4422),
    [anon_sym_QMARK] = ACTIONS(4550),
    [anon_sym_notnull] = ACTIONS(4422),
    [anon_sym_unmanaged] = ACTIONS(4422),
    [anon_sym_BANG] = ACTIONS(4422),
    [anon_sym_PLUS_PLUS] = ACTIONS(4424),
    [anon_sym_DASH_DASH] = ACTIONS(4424),
    [anon_sym_PLUS] = ACTIONS(4422),
    [anon_sym_DASH] = ACTIONS(4422),
    [anon_sym_STAR] = ACTIONS(4553),
    [anon_sym_SLASH] = ACTIONS(4422),
    [anon_sym_PERCENT] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4424),
    [anon_sym_PIPE] = ACTIONS(4422),
    [anon_sym_AMP] = ACTIONS(4422),
    [anon_sym_LT_LT] = ACTIONS(4424),
    [anon_sym_GT_GT] = ACTIONS(4422),
    [anon_sym_GT_GT_GT] = ACTIONS(4424),
    [anon_sym_EQ_EQ] = ACTIONS(4424),
    [anon_sym_BANG_EQ] = ACTIONS(4424),
    [anon_sym_GT_EQ] = ACTIONS(4424),
    [anon_sym_LT_EQ] = ACTIONS(4424),
    [anon_sym_DOT] = ACTIONS(4711),
    [anon_sym_scoped] = ACTIONS(4422),
    [anon_sym_var] = ACTIONS(4422),
    [anon_sym_yield] = ACTIONS(4422),
    [anon_sym_switch] = ACTIONS(4422),
    [anon_sym_when] = ACTIONS(4422),
    [sym_discard] = ACTIONS(4422),
    [anon_sym_DOT_DOT] = ACTIONS(4424),
    [anon_sym_and] = ACTIONS(4422),
    [anon_sym_or] = ACTIONS(4422),
    [anon_sym_AMP_AMP] = ACTIONS(4424),
    [anon_sym_PIPE_PIPE] = ACTIONS(4424),
    [anon_sym_QMARK_QMARK] = ACTIONS(4424),
    [anon_sym_from] = ACTIONS(4422),
    [anon_sym_into] = ACTIONS(4422),
    [anon_sym_join] = ACTIONS(4422),
    [anon_sym_on] = ACTIONS(4422),
    [anon_sym_equals] = ACTIONS(4422),
    [anon_sym_let] = ACTIONS(4422),
    [anon_sym_orderby] = ACTIONS(4422),
    [anon_sym_ascending] = ACTIONS(4422),
    [anon_sym_descending] = ACTIONS(4422),
    [anon_sym_group] = ACTIONS(4422),
    [anon_sym_by] = ACTIONS(4422),
    [anon_sym_select] = ACTIONS(4422),
    [anon_sym_as] = ACTIONS(4422),
    [anon_sym_is] = ACTIONS(4422),
    [anon_sym_DASH_GT] = ACTIONS(4562),
    [anon_sym_with] = ACTIONS(4422),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3179] = {
    [sym__variable_designation] = STATE(4663),
    [sym_parenthesized_variable_designation] = STATE(4614),
    [sym_identifier] = STATE(4624),
    [sym__reserved_identifier] = STATE(2914),
    [sym_preproc_region] = STATE(3179),
    [sym_preproc_endregion] = STATE(3179),
    [sym_preproc_line] = STATE(3179),
    [sym_preproc_pragma] = STATE(3179),
    [sym_preproc_nullable] = STATE(3179),
    [sym_preproc_error] = STATE(3179),
    [sym_preproc_define] = STATE(3179),
    [sym_preproc_undef] = STATE(3179),
    [sym__identifier_token] = ACTIONS(4490),
    [anon_sym_alias] = ACTIONS(4492),
    [anon_sym_global] = ACTIONS(4492),
    [anon_sym_LBRACK] = ACTIONS(4329),
    [anon_sym_COMMA] = ACTIONS(4329),
    [anon_sym_LPAREN] = ACTIONS(4329),
    [anon_sym_file] = ACTIONS(4492),
    [anon_sym_LT] = ACTIONS(4331),
    [anon_sym_GT] = ACTIONS(4331),
    [anon_sym_where] = ACTIONS(4331),
    [anon_sym_QMARK] = ACTIONS(4331),
    [anon_sym_notnull] = ACTIONS(4492),
    [anon_sym_unmanaged] = ACTIONS(4492),
    [anon_sym_BANG] = ACTIONS(4331),
    [anon_sym_PLUS_PLUS] = ACTIONS(4329),
    [anon_sym_DASH_DASH] = ACTIONS(4329),
    [anon_sym_PLUS] = ACTIONS(4331),
    [anon_sym_DASH] = ACTIONS(4331),
    [anon_sym_STAR] = ACTIONS(4329),
    [anon_sym_SLASH] = ACTIONS(4331),
    [anon_sym_PERCENT] = ACTIONS(4329),
    [anon_sym_CARET] = ACTIONS(4329),
    [anon_sym_PIPE] = ACTIONS(4331),
    [anon_sym_AMP] = ACTIONS(4331),
    [anon_sym_LT_LT] = ACTIONS(4329),
    [anon_sym_GT_GT] = ACTIONS(4331),
    [anon_sym_GT_GT_GT] = ACTIONS(4329),
    [anon_sym_EQ_EQ] = ACTIONS(4329),
    [anon_sym_BANG_EQ] = ACTIONS(4329),
    [anon_sym_GT_EQ] = ACTIONS(4329),
    [anon_sym_LT_EQ] = ACTIONS(4329),
    [anon_sym_DOT] = ACTIONS(4331),
    [anon_sym_scoped] = ACTIONS(4492),
    [anon_sym_var] = ACTIONS(4492),
    [anon_sym_yield] = ACTIONS(4492),
    [anon_sym_switch] = ACTIONS(4331),
    [anon_sym_when] = ACTIONS(4492),
    [sym_discard] = ACTIONS(4647),
    [anon_sym_DOT_DOT] = ACTIONS(4329),
    [anon_sym_and] = ACTIONS(4331),
    [anon_sym_or] = ACTIONS(4331),
    [anon_sym_AMP_AMP] = ACTIONS(4329),
    [anon_sym_PIPE_PIPE] = ACTIONS(4329),
    [anon_sym_QMARK_QMARK] = ACTIONS(4329),
    [anon_sym_from] = ACTIONS(4331),
    [anon_sym_into] = ACTIONS(4492),
    [anon_sym_join] = ACTIONS(4331),
    [anon_sym_on] = ACTIONS(4492),
    [anon_sym_equals] = ACTIONS(4492),
    [anon_sym_let] = ACTIONS(4331),
    [anon_sym_orderby] = ACTIONS(4331),
    [anon_sym_ascending] = ACTIONS(4331),
    [anon_sym_descending] = ACTIONS(4331),
    [anon_sym_group] = ACTIONS(4331),
    [anon_sym_by] = ACTIONS(4492),
    [anon_sym_select] = ACTIONS(4331),
    [anon_sym_as] = ACTIONS(4331),
    [anon_sym_is] = ACTIONS(4331),
    [anon_sym_DASH_GT] = ACTIONS(4329),
    [anon_sym_with] = ACTIONS(4331),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3180] = {
    [sym_preproc_region] = STATE(3180),
    [sym_preproc_endregion] = STATE(3180),
    [sym_preproc_line] = STATE(3180),
    [sym_preproc_pragma] = STATE(3180),
    [sym_preproc_nullable] = STATE(3180),
    [sym_preproc_error] = STATE(3180),
    [sym_preproc_define] = STATE(3180),
    [sym_preproc_undef] = STATE(3180),
    [sym__identifier_token] = ACTIONS(4713),
    [anon_sym_extern] = ACTIONS(4713),
    [anon_sym_alias] = ACTIONS(4713),
    [anon_sym_global] = ACTIONS(4713),
    [anon_sym_using] = ACTIONS(4713),
    [anon_sym_unsafe] = ACTIONS(4713),
    [anon_sym_EQ] = ACTIONS(4715),
    [anon_sym_static] = ACTIONS(4713),
    [anon_sym_LBRACK] = ACTIONS(4715),
    [anon_sym_LPAREN] = ACTIONS(4715),
    [anon_sym_event] = ACTIONS(4713),
    [anon_sym_namespace] = ACTIONS(4713),
    [anon_sym_class] = ACTIONS(4713),
    [anon_sym_ref] = ACTIONS(4713),
    [anon_sym_struct] = ACTIONS(4713),
    [anon_sym_enum] = ACTIONS(4713),
    [anon_sym_RBRACE] = ACTIONS(4715),
    [anon_sym_interface] = ACTIONS(4713),
    [anon_sym_delegate] = ACTIONS(4713),
    [anon_sym_record] = ACTIONS(4713),
    [anon_sym_abstract] = ACTIONS(4713),
    [anon_sym_async] = ACTIONS(4713),
    [anon_sym_const] = ACTIONS(4713),
    [anon_sym_file] = ACTIONS(4713),
    [anon_sym_fixed] = ACTIONS(4713),
    [anon_sym_internal] = ACTIONS(4713),
    [anon_sym_new] = ACTIONS(4713),
    [anon_sym_override] = ACTIONS(4713),
    [anon_sym_partial] = ACTIONS(4713),
    [anon_sym_private] = ACTIONS(4713),
    [anon_sym_protected] = ACTIONS(4713),
    [anon_sym_public] = ACTIONS(4713),
    [anon_sym_readonly] = ACTIONS(4713),
    [anon_sym_required] = ACTIONS(4713),
    [anon_sym_sealed] = ACTIONS(4713),
    [anon_sym_virtual] = ACTIONS(4713),
    [anon_sym_volatile] = ACTIONS(4713),
    [anon_sym_where] = ACTIONS(4713),
    [anon_sym_notnull] = ACTIONS(4713),
    [anon_sym_unmanaged] = ACTIONS(4713),
    [anon_sym_TILDE] = ACTIONS(4715),
    [anon_sym_implicit] = ACTIONS(4713),
    [anon_sym_explicit] = ACTIONS(4713),
    [anon_sym_scoped] = ACTIONS(4713),
    [anon_sym_var] = ACTIONS(4713),
    [sym_predefined_type] = ACTIONS(4713),
    [anon_sym_yield] = ACTIONS(4713),
    [anon_sym_when] = ACTIONS(4713),
    [anon_sym_from] = ACTIONS(4713),
    [anon_sym_into] = ACTIONS(4713),
    [anon_sym_join] = ACTIONS(4713),
    [anon_sym_on] = ACTIONS(4713),
    [anon_sym_equals] = ACTIONS(4713),
    [anon_sym_let] = ACTIONS(4713),
    [anon_sym_orderby] = ACTIONS(4713),
    [anon_sym_ascending] = ACTIONS(4713),
    [anon_sym_descending] = ACTIONS(4713),
    [anon_sym_group] = ACTIONS(4713),
    [anon_sym_by] = ACTIONS(4713),
    [anon_sym_select] = ACTIONS(4713),
    [aux_sym_preproc_if_token1] = ACTIONS(4715),
    [aux_sym_preproc_if_token3] = ACTIONS(4715),
    [aux_sym_preproc_else_token1] = ACTIONS(4715),
    [aux_sym_preproc_elif_token1] = ACTIONS(4715),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3181] = {
    [sym_preproc_region] = STATE(3181),
    [sym_preproc_endregion] = STATE(3181),
    [sym_preproc_line] = STATE(3181),
    [sym_preproc_pragma] = STATE(3181),
    [sym_preproc_nullable] = STATE(3181),
    [sym_preproc_error] = STATE(3181),
    [sym_preproc_define] = STATE(3181),
    [sym_preproc_undef] = STATE(3181),
    [sym__identifier_token] = ACTIONS(4717),
    [anon_sym_extern] = ACTIONS(4717),
    [anon_sym_alias] = ACTIONS(4717),
    [anon_sym_global] = ACTIONS(4717),
    [anon_sym_using] = ACTIONS(4717),
    [anon_sym_unsafe] = ACTIONS(4717),
    [anon_sym_EQ] = ACTIONS(4719),
    [anon_sym_static] = ACTIONS(4717),
    [anon_sym_LBRACK] = ACTIONS(4721),
    [anon_sym_LPAREN] = ACTIONS(4721),
    [anon_sym_event] = ACTIONS(4717),
    [anon_sym_namespace] = ACTIONS(4717),
    [anon_sym_class] = ACTIONS(4717),
    [anon_sym_ref] = ACTIONS(4717),
    [anon_sym_struct] = ACTIONS(4717),
    [anon_sym_enum] = ACTIONS(4717),
    [anon_sym_RBRACE] = ACTIONS(4721),
    [anon_sym_interface] = ACTIONS(4717),
    [anon_sym_delegate] = ACTIONS(4717),
    [anon_sym_record] = ACTIONS(4717),
    [anon_sym_abstract] = ACTIONS(4717),
    [anon_sym_async] = ACTIONS(4717),
    [anon_sym_const] = ACTIONS(4717),
    [anon_sym_file] = ACTIONS(4717),
    [anon_sym_fixed] = ACTIONS(4717),
    [anon_sym_internal] = ACTIONS(4717),
    [anon_sym_new] = ACTIONS(4717),
    [anon_sym_override] = ACTIONS(4717),
    [anon_sym_partial] = ACTIONS(4717),
    [anon_sym_private] = ACTIONS(4717),
    [anon_sym_protected] = ACTIONS(4717),
    [anon_sym_public] = ACTIONS(4717),
    [anon_sym_readonly] = ACTIONS(4717),
    [anon_sym_required] = ACTIONS(4717),
    [anon_sym_sealed] = ACTIONS(4717),
    [anon_sym_virtual] = ACTIONS(4717),
    [anon_sym_volatile] = ACTIONS(4717),
    [anon_sym_where] = ACTIONS(4717),
    [anon_sym_notnull] = ACTIONS(4717),
    [anon_sym_unmanaged] = ACTIONS(4717),
    [anon_sym_TILDE] = ACTIONS(4721),
    [anon_sym_implicit] = ACTIONS(4717),
    [anon_sym_explicit] = ACTIONS(4717),
    [anon_sym_scoped] = ACTIONS(4717),
    [anon_sym_var] = ACTIONS(4717),
    [sym_predefined_type] = ACTIONS(4717),
    [anon_sym_yield] = ACTIONS(4717),
    [anon_sym_when] = ACTIONS(4717),
    [anon_sym_from] = ACTIONS(4717),
    [anon_sym_into] = ACTIONS(4717),
    [anon_sym_join] = ACTIONS(4717),
    [anon_sym_on] = ACTIONS(4717),
    [anon_sym_equals] = ACTIONS(4717),
    [anon_sym_let] = ACTIONS(4717),
    [anon_sym_orderby] = ACTIONS(4717),
    [anon_sym_ascending] = ACTIONS(4717),
    [anon_sym_descending] = ACTIONS(4717),
    [anon_sym_group] = ACTIONS(4717),
    [anon_sym_by] = ACTIONS(4717),
    [anon_sym_select] = ACTIONS(4717),
    [aux_sym_preproc_if_token1] = ACTIONS(4721),
    [aux_sym_preproc_if_token3] = ACTIONS(4721),
    [aux_sym_preproc_else_token1] = ACTIONS(4721),
    [aux_sym_preproc_elif_token1] = ACTIONS(4721),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3182] = {
    [sym__variable_designation] = STATE(4246),
    [sym_parenthesized_variable_designation] = STATE(4274),
    [sym_identifier] = STATE(4269),
    [sym__reserved_identifier] = STATE(3897),
    [sym_preproc_region] = STATE(3182),
    [sym_preproc_endregion] = STATE(3182),
    [sym_preproc_line] = STATE(3182),
    [sym_preproc_pragma] = STATE(3182),
    [sym_preproc_nullable] = STATE(3182),
    [sym_preproc_error] = STATE(3182),
    [sym_preproc_define] = STATE(3182),
    [sym_preproc_undef] = STATE(3182),
    [sym__identifier_token] = ACTIONS(4168),
    [anon_sym_alias] = ACTIONS(4170),
    [anon_sym_global] = ACTIONS(4170),
    [anon_sym_LBRACK] = ACTIONS(4329),
    [anon_sym_LPAREN] = ACTIONS(4329),
    [anon_sym_file] = ACTIONS(4170),
    [anon_sym_LT] = ACTIONS(4331),
    [anon_sym_GT] = ACTIONS(4331),
    [anon_sym_in] = ACTIONS(4331),
    [anon_sym_where] = ACTIONS(4170),
    [anon_sym_QMARK] = ACTIONS(4331),
    [anon_sym_notnull] = ACTIONS(4170),
    [anon_sym_unmanaged] = ACTIONS(4170),
    [anon_sym_BANG] = ACTIONS(4331),
    [anon_sym_PLUS_PLUS] = ACTIONS(4329),
    [anon_sym_DASH_DASH] = ACTIONS(4329),
    [anon_sym_PLUS] = ACTIONS(4331),
    [anon_sym_DASH] = ACTIONS(4331),
    [anon_sym_STAR] = ACTIONS(4329),
    [anon_sym_SLASH] = ACTIONS(4331),
    [anon_sym_PERCENT] = ACTIONS(4329),
    [anon_sym_CARET] = ACTIONS(4329),
    [anon_sym_PIPE] = ACTIONS(4331),
    [anon_sym_AMP] = ACTIONS(4331),
    [anon_sym_LT_LT] = ACTIONS(4329),
    [anon_sym_GT_GT] = ACTIONS(4331),
    [anon_sym_GT_GT_GT] = ACTIONS(4329),
    [anon_sym_EQ_EQ] = ACTIONS(4329),
    [anon_sym_BANG_EQ] = ACTIONS(4329),
    [anon_sym_GT_EQ] = ACTIONS(4329),
    [anon_sym_LT_EQ] = ACTIONS(4329),
    [anon_sym_DOT] = ACTIONS(4331),
    [anon_sym_scoped] = ACTIONS(4170),
    [anon_sym_var] = ACTIONS(4170),
    [anon_sym_yield] = ACTIONS(4170),
    [anon_sym_switch] = ACTIONS(4331),
    [anon_sym_when] = ACTIONS(4170),
    [sym_discard] = ACTIONS(4295),
    [anon_sym_DOT_DOT] = ACTIONS(4329),
    [anon_sym_and] = ACTIONS(4331),
    [anon_sym_or] = ACTIONS(4331),
    [anon_sym_AMP_AMP] = ACTIONS(4329),
    [anon_sym_PIPE_PIPE] = ACTIONS(4329),
    [anon_sym_QMARK_QMARK] = ACTIONS(4329),
    [anon_sym_from] = ACTIONS(4170),
    [anon_sym_into] = ACTIONS(4170),
    [anon_sym_join] = ACTIONS(4170),
    [anon_sym_on] = ACTIONS(4170),
    [anon_sym_equals] = ACTIONS(4170),
    [anon_sym_let] = ACTIONS(4170),
    [anon_sym_orderby] = ACTIONS(4170),
    [anon_sym_ascending] = ACTIONS(4170),
    [anon_sym_descending] = ACTIONS(4170),
    [anon_sym_group] = ACTIONS(4170),
    [anon_sym_by] = ACTIONS(4170),
    [anon_sym_select] = ACTIONS(4170),
    [anon_sym_as] = ACTIONS(4331),
    [anon_sym_is] = ACTIONS(4331),
    [anon_sym_DASH_GT] = ACTIONS(4329),
    [anon_sym_with] = ACTIONS(4331),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3183] = {
    [sym_preproc_region] = STATE(3183),
    [sym_preproc_endregion] = STATE(3183),
    [sym_preproc_line] = STATE(3183),
    [sym_preproc_pragma] = STATE(3183),
    [sym_preproc_nullable] = STATE(3183),
    [sym_preproc_error] = STATE(3183),
    [sym_preproc_define] = STATE(3183),
    [sym_preproc_undef] = STATE(3183),
    [anon_sym_SEMI] = ACTIONS(4133),
    [anon_sym_EQ] = ACTIONS(4118),
    [anon_sym_LBRACK] = ACTIONS(4133),
    [anon_sym_COLON] = ACTIONS(4133),
    [anon_sym_COMMA] = ACTIONS(4133),
    [anon_sym_RBRACK] = ACTIONS(4133),
    [anon_sym_LPAREN] = ACTIONS(4133),
    [anon_sym_RPAREN] = ACTIONS(4133),
    [anon_sym_RBRACE] = ACTIONS(4133),
    [anon_sym_LT] = ACTIONS(4118),
    [anon_sym_GT] = ACTIONS(4118),
    [anon_sym_in] = ACTIONS(4118),
    [anon_sym_QMARK] = ACTIONS(4118),
    [anon_sym_BANG] = ACTIONS(4118),
    [anon_sym_PLUS_PLUS] = ACTIONS(4133),
    [anon_sym_DASH_DASH] = ACTIONS(4133),
    [anon_sym_PLUS] = ACTIONS(4118),
    [anon_sym_DASH] = ACTIONS(4118),
    [anon_sym_STAR] = ACTIONS(4118),
    [anon_sym_SLASH] = ACTIONS(4118),
    [anon_sym_PERCENT] = ACTIONS(4118),
    [anon_sym_CARET] = ACTIONS(4118),
    [anon_sym_PIPE] = ACTIONS(4118),
    [anon_sym_AMP] = ACTIONS(4118),
    [anon_sym_LT_LT] = ACTIONS(4118),
    [anon_sym_GT_GT] = ACTIONS(4118),
    [anon_sym_GT_GT_GT] = ACTIONS(4118),
    [anon_sym_EQ_EQ] = ACTIONS(4133),
    [anon_sym_BANG_EQ] = ACTIONS(4133),
    [anon_sym_GT_EQ] = ACTIONS(4133),
    [anon_sym_LT_EQ] = ACTIONS(4133),
    [anon_sym_DOT] = ACTIONS(4118),
    [anon_sym_EQ_GT] = ACTIONS(4133),
    [anon_sym_switch] = ACTIONS(4133),
    [anon_sym_when] = ACTIONS(4133),
    [anon_sym_DOT_DOT] = ACTIONS(4133),
    [anon_sym_and] = ACTIONS(4133),
    [anon_sym_or] = ACTIONS(4133),
    [anon_sym_PLUS_EQ] = ACTIONS(4133),
    [anon_sym_DASH_EQ] = ACTIONS(4133),
    [anon_sym_STAR_EQ] = ACTIONS(4133),
    [anon_sym_SLASH_EQ] = ACTIONS(4133),
    [anon_sym_PERCENT_EQ] = ACTIONS(4133),
    [anon_sym_AMP_EQ] = ACTIONS(4133),
    [anon_sym_CARET_EQ] = ACTIONS(4133),
    [anon_sym_PIPE_EQ] = ACTIONS(4133),
    [anon_sym_LT_LT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4133),
    [anon_sym_AMP_AMP] = ACTIONS(4133),
    [anon_sym_PIPE_PIPE] = ACTIONS(4133),
    [anon_sym_QMARK_QMARK] = ACTIONS(4118),
    [anon_sym_into] = ACTIONS(4133),
    [anon_sym_on] = ACTIONS(4133),
    [anon_sym_equals] = ACTIONS(4133),
    [anon_sym_by] = ACTIONS(4133),
    [anon_sym_as] = ACTIONS(4133),
    [anon_sym_is] = ACTIONS(4133),
    [anon_sym_DASH_GT] = ACTIONS(4133),
    [anon_sym_with] = ACTIONS(4133),
    [aux_sym_preproc_if_token3] = ACTIONS(4133),
    [aux_sym_preproc_else_token1] = ACTIONS(4133),
    [aux_sym_preproc_elif_token1] = ACTIONS(4133),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3184] = {
    [sym_preproc_region] = STATE(3184),
    [sym_preproc_endregion] = STATE(3184),
    [sym_preproc_line] = STATE(3184),
    [sym_preproc_pragma] = STATE(3184),
    [sym_preproc_nullable] = STATE(3184),
    [sym_preproc_error] = STATE(3184),
    [sym_preproc_define] = STATE(3184),
    [sym_preproc_undef] = STATE(3184),
    [sym__identifier_token] = ACTIONS(4426),
    [anon_sym_alias] = ACTIONS(4426),
    [anon_sym_global] = ACTIONS(4426),
    [anon_sym_LBRACK] = ACTIONS(4428),
    [anon_sym_COLON] = ACTIONS(4428),
    [anon_sym_COMMA] = ACTIONS(4428),
    [anon_sym_LPAREN] = ACTIONS(4428),
    [anon_sym_RPAREN] = ACTIONS(4428),
    [anon_sym_LBRACE] = ACTIONS(4428),
    [anon_sym_RBRACE] = ACTIONS(4428),
    [anon_sym_file] = ACTIONS(4426),
    [anon_sym_LT] = ACTIONS(4426),
    [anon_sym_GT] = ACTIONS(4426),
    [anon_sym_where] = ACTIONS(4426),
    [anon_sym_QMARK] = ACTIONS(4426),
    [anon_sym_notnull] = ACTIONS(4426),
    [anon_sym_unmanaged] = ACTIONS(4426),
    [anon_sym_BANG] = ACTIONS(4426),
    [anon_sym_PLUS_PLUS] = ACTIONS(4428),
    [anon_sym_DASH_DASH] = ACTIONS(4428),
    [anon_sym_PLUS] = ACTIONS(4426),
    [anon_sym_DASH] = ACTIONS(4426),
    [anon_sym_STAR] = ACTIONS(4428),
    [anon_sym_SLASH] = ACTIONS(4426),
    [anon_sym_PERCENT] = ACTIONS(4428),
    [anon_sym_CARET] = ACTIONS(4428),
    [anon_sym_PIPE] = ACTIONS(4426),
    [anon_sym_AMP] = ACTIONS(4426),
    [anon_sym_LT_LT] = ACTIONS(4428),
    [anon_sym_GT_GT] = ACTIONS(4426),
    [anon_sym_GT_GT_GT] = ACTIONS(4428),
    [anon_sym_EQ_EQ] = ACTIONS(4428),
    [anon_sym_BANG_EQ] = ACTIONS(4428),
    [anon_sym_GT_EQ] = ACTIONS(4428),
    [anon_sym_LT_EQ] = ACTIONS(4428),
    [anon_sym_DOT] = ACTIONS(4703),
    [anon_sym_scoped] = ACTIONS(4426),
    [anon_sym_var] = ACTIONS(4426),
    [anon_sym_yield] = ACTIONS(4426),
    [anon_sym_switch] = ACTIONS(4426),
    [anon_sym_when] = ACTIONS(4426),
    [sym_discard] = ACTIONS(4426),
    [anon_sym_DOT_DOT] = ACTIONS(4428),
    [anon_sym_and] = ACTIONS(4426),
    [anon_sym_or] = ACTIONS(4426),
    [anon_sym_AMP_AMP] = ACTIONS(4428),
    [anon_sym_PIPE_PIPE] = ACTIONS(4428),
    [anon_sym_QMARK_QMARK] = ACTIONS(4428),
    [anon_sym_from] = ACTIONS(4426),
    [anon_sym_into] = ACTIONS(4426),
    [anon_sym_join] = ACTIONS(4426),
    [anon_sym_on] = ACTIONS(4426),
    [anon_sym_equals] = ACTIONS(4426),
    [anon_sym_let] = ACTIONS(4426),
    [anon_sym_orderby] = ACTIONS(4426),
    [anon_sym_ascending] = ACTIONS(4426),
    [anon_sym_descending] = ACTIONS(4426),
    [anon_sym_group] = ACTIONS(4426),
    [anon_sym_by] = ACTIONS(4426),
    [anon_sym_select] = ACTIONS(4426),
    [anon_sym_as] = ACTIONS(4426),
    [anon_sym_is] = ACTIONS(4426),
    [anon_sym_DASH_GT] = ACTIONS(4428),
    [anon_sym_with] = ACTIONS(4426),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3185] = {
    [sym_preproc_region] = STATE(3185),
    [sym_preproc_endregion] = STATE(3185),
    [sym_preproc_line] = STATE(3185),
    [sym_preproc_pragma] = STATE(3185),
    [sym_preproc_nullable] = STATE(3185),
    [sym_preproc_error] = STATE(3185),
    [sym_preproc_define] = STATE(3185),
    [sym_preproc_undef] = STATE(3185),
    [anon_sym_SEMI] = ACTIONS(4604),
    [anon_sym_EQ] = ACTIONS(4606),
    [anon_sym_LBRACK] = ACTIONS(4604),
    [anon_sym_COLON] = ACTIONS(4604),
    [anon_sym_COMMA] = ACTIONS(4604),
    [anon_sym_RBRACK] = ACTIONS(4604),
    [anon_sym_LPAREN] = ACTIONS(4604),
    [anon_sym_RPAREN] = ACTIONS(4604),
    [anon_sym_RBRACE] = ACTIONS(4604),
    [anon_sym_LT] = ACTIONS(4606),
    [anon_sym_GT] = ACTIONS(4606),
    [anon_sym_in] = ACTIONS(4606),
    [anon_sym_QMARK] = ACTIONS(4606),
    [anon_sym_BANG] = ACTIONS(4606),
    [anon_sym_PLUS_PLUS] = ACTIONS(4604),
    [anon_sym_DASH_DASH] = ACTIONS(4604),
    [anon_sym_PLUS] = ACTIONS(4606),
    [anon_sym_DASH] = ACTIONS(4606),
    [anon_sym_STAR] = ACTIONS(4606),
    [anon_sym_SLASH] = ACTIONS(4606),
    [anon_sym_PERCENT] = ACTIONS(4606),
    [anon_sym_CARET] = ACTIONS(4606),
    [anon_sym_PIPE] = ACTIONS(4606),
    [anon_sym_AMP] = ACTIONS(4606),
    [anon_sym_LT_LT] = ACTIONS(4606),
    [anon_sym_GT_GT] = ACTIONS(4606),
    [anon_sym_GT_GT_GT] = ACTIONS(4606),
    [anon_sym_EQ_EQ] = ACTIONS(4604),
    [anon_sym_BANG_EQ] = ACTIONS(4604),
    [anon_sym_GT_EQ] = ACTIONS(4604),
    [anon_sym_LT_EQ] = ACTIONS(4604),
    [anon_sym_DOT] = ACTIONS(4606),
    [anon_sym_EQ_GT] = ACTIONS(4604),
    [anon_sym_switch] = ACTIONS(4604),
    [anon_sym_when] = ACTIONS(4604),
    [anon_sym_DOT_DOT] = ACTIONS(4604),
    [anon_sym_and] = ACTIONS(4604),
    [anon_sym_or] = ACTIONS(4604),
    [anon_sym_PLUS_EQ] = ACTIONS(4604),
    [anon_sym_DASH_EQ] = ACTIONS(4604),
    [anon_sym_STAR_EQ] = ACTIONS(4604),
    [anon_sym_SLASH_EQ] = ACTIONS(4604),
    [anon_sym_PERCENT_EQ] = ACTIONS(4604),
    [anon_sym_AMP_EQ] = ACTIONS(4604),
    [anon_sym_CARET_EQ] = ACTIONS(4604),
    [anon_sym_PIPE_EQ] = ACTIONS(4604),
    [anon_sym_LT_LT_EQ] = ACTIONS(4604),
    [anon_sym_GT_GT_EQ] = ACTIONS(4604),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4604),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4604),
    [anon_sym_AMP_AMP] = ACTIONS(4604),
    [anon_sym_PIPE_PIPE] = ACTIONS(4604),
    [anon_sym_QMARK_QMARK] = ACTIONS(4606),
    [anon_sym_into] = ACTIONS(4604),
    [anon_sym_on] = ACTIONS(4604),
    [anon_sym_equals] = ACTIONS(4604),
    [anon_sym_by] = ACTIONS(4604),
    [anon_sym_as] = ACTIONS(4604),
    [anon_sym_is] = ACTIONS(4604),
    [anon_sym_DASH_GT] = ACTIONS(4604),
    [anon_sym_with] = ACTIONS(4604),
    [aux_sym_preproc_if_token3] = ACTIONS(4604),
    [aux_sym_preproc_else_token1] = ACTIONS(4604),
    [aux_sym_preproc_elif_token1] = ACTIONS(4604),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3186] = {
    [sym_preproc_region] = STATE(3186),
    [sym_preproc_endregion] = STATE(3186),
    [sym_preproc_line] = STATE(3186),
    [sym_preproc_pragma] = STATE(3186),
    [sym_preproc_nullable] = STATE(3186),
    [sym_preproc_error] = STATE(3186),
    [sym_preproc_define] = STATE(3186),
    [sym_preproc_undef] = STATE(3186),
    [anon_sym_SEMI] = ACTIONS(4639),
    [anon_sym_EQ] = ACTIONS(4625),
    [anon_sym_LBRACK] = ACTIONS(4639),
    [anon_sym_COLON] = ACTIONS(4623),
    [anon_sym_COMMA] = ACTIONS(4639),
    [anon_sym_RBRACK] = ACTIONS(4639),
    [anon_sym_LPAREN] = ACTIONS(4639),
    [anon_sym_RPAREN] = ACTIONS(4639),
    [anon_sym_RBRACE] = ACTIONS(4639),
    [anon_sym_LT] = ACTIONS(4641),
    [anon_sym_GT] = ACTIONS(4641),
    [anon_sym_in] = ACTIONS(4641),
    [anon_sym_QMARK] = ACTIONS(4641),
    [anon_sym_BANG] = ACTIONS(4641),
    [anon_sym_PLUS_PLUS] = ACTIONS(4639),
    [anon_sym_DASH_DASH] = ACTIONS(4639),
    [anon_sym_PLUS] = ACTIONS(4641),
    [anon_sym_DASH] = ACTIONS(4641),
    [anon_sym_STAR] = ACTIONS(4641),
    [anon_sym_SLASH] = ACTIONS(4641),
    [anon_sym_PERCENT] = ACTIONS(4641),
    [anon_sym_CARET] = ACTIONS(4641),
    [anon_sym_PIPE] = ACTIONS(4641),
    [anon_sym_AMP] = ACTIONS(4641),
    [anon_sym_LT_LT] = ACTIONS(4641),
    [anon_sym_GT_GT] = ACTIONS(4641),
    [anon_sym_GT_GT_GT] = ACTIONS(4641),
    [anon_sym_EQ_EQ] = ACTIONS(4639),
    [anon_sym_BANG_EQ] = ACTIONS(4639),
    [anon_sym_GT_EQ] = ACTIONS(4639),
    [anon_sym_LT_EQ] = ACTIONS(4639),
    [anon_sym_DOT] = ACTIONS(4641),
    [anon_sym_EQ_GT] = ACTIONS(4639),
    [anon_sym_switch] = ACTIONS(4639),
    [anon_sym_when] = ACTIONS(4639),
    [anon_sym_DOT_DOT] = ACTIONS(4639),
    [anon_sym_and] = ACTIONS(4639),
    [anon_sym_or] = ACTIONS(4639),
    [anon_sym_PLUS_EQ] = ACTIONS(4623),
    [anon_sym_DASH_EQ] = ACTIONS(4623),
    [anon_sym_STAR_EQ] = ACTIONS(4623),
    [anon_sym_SLASH_EQ] = ACTIONS(4623),
    [anon_sym_PERCENT_EQ] = ACTIONS(4623),
    [anon_sym_AMP_EQ] = ACTIONS(4623),
    [anon_sym_CARET_EQ] = ACTIONS(4623),
    [anon_sym_PIPE_EQ] = ACTIONS(4623),
    [anon_sym_LT_LT_EQ] = ACTIONS(4623),
    [anon_sym_GT_GT_EQ] = ACTIONS(4623),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4623),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4623),
    [anon_sym_AMP_AMP] = ACTIONS(4639),
    [anon_sym_PIPE_PIPE] = ACTIONS(4639),
    [anon_sym_QMARK_QMARK] = ACTIONS(4641),
    [anon_sym_into] = ACTIONS(4639),
    [anon_sym_on] = ACTIONS(4639),
    [anon_sym_equals] = ACTIONS(4639),
    [anon_sym_by] = ACTIONS(4639),
    [anon_sym_as] = ACTIONS(4639),
    [anon_sym_is] = ACTIONS(4639),
    [anon_sym_DASH_GT] = ACTIONS(4639),
    [anon_sym_with] = ACTIONS(4639),
    [aux_sym_preproc_if_token3] = ACTIONS(4639),
    [aux_sym_preproc_else_token1] = ACTIONS(4639),
    [aux_sym_preproc_elif_token1] = ACTIONS(4639),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3187] = {
    [sym_preproc_region] = STATE(3187),
    [sym_preproc_endregion] = STATE(3187),
    [sym_preproc_line] = STATE(3187),
    [sym_preproc_pragma] = STATE(3187),
    [sym_preproc_nullable] = STATE(3187),
    [sym_preproc_error] = STATE(3187),
    [sym_preproc_define] = STATE(3187),
    [sym_preproc_undef] = STATE(3187),
    [anon_sym_SEMI] = ACTIONS(4058),
    [anon_sym_EQ] = ACTIONS(4056),
    [anon_sym_LBRACK] = ACTIONS(4058),
    [anon_sym_COLON] = ACTIONS(4058),
    [anon_sym_COMMA] = ACTIONS(4058),
    [anon_sym_RBRACK] = ACTIONS(4058),
    [anon_sym_LPAREN] = ACTIONS(4058),
    [anon_sym_RPAREN] = ACTIONS(4058),
    [anon_sym_RBRACE] = ACTIONS(4058),
    [anon_sym_LT] = ACTIONS(4056),
    [anon_sym_GT] = ACTIONS(4056),
    [anon_sym_in] = ACTIONS(4056),
    [anon_sym_QMARK] = ACTIONS(4056),
    [anon_sym_BANG] = ACTIONS(4056),
    [anon_sym_PLUS_PLUS] = ACTIONS(4058),
    [anon_sym_DASH_DASH] = ACTIONS(4058),
    [anon_sym_PLUS] = ACTIONS(4056),
    [anon_sym_DASH] = ACTIONS(4056),
    [anon_sym_STAR] = ACTIONS(4056),
    [anon_sym_SLASH] = ACTIONS(4056),
    [anon_sym_PERCENT] = ACTIONS(4056),
    [anon_sym_CARET] = ACTIONS(4056),
    [anon_sym_PIPE] = ACTIONS(4056),
    [anon_sym_AMP] = ACTIONS(4056),
    [anon_sym_LT_LT] = ACTIONS(4056),
    [anon_sym_GT_GT] = ACTIONS(4056),
    [anon_sym_GT_GT_GT] = ACTIONS(4056),
    [anon_sym_EQ_EQ] = ACTIONS(4058),
    [anon_sym_BANG_EQ] = ACTIONS(4058),
    [anon_sym_GT_EQ] = ACTIONS(4058),
    [anon_sym_LT_EQ] = ACTIONS(4058),
    [anon_sym_DOT] = ACTIONS(4056),
    [anon_sym_EQ_GT] = ACTIONS(4058),
    [anon_sym_switch] = ACTIONS(4058),
    [anon_sym_when] = ACTIONS(4058),
    [anon_sym_DOT_DOT] = ACTIONS(4058),
    [anon_sym_and] = ACTIONS(4058),
    [anon_sym_or] = ACTIONS(4058),
    [anon_sym_PLUS_EQ] = ACTIONS(4058),
    [anon_sym_DASH_EQ] = ACTIONS(4058),
    [anon_sym_STAR_EQ] = ACTIONS(4058),
    [anon_sym_SLASH_EQ] = ACTIONS(4058),
    [anon_sym_PERCENT_EQ] = ACTIONS(4058),
    [anon_sym_AMP_EQ] = ACTIONS(4058),
    [anon_sym_CARET_EQ] = ACTIONS(4058),
    [anon_sym_PIPE_EQ] = ACTIONS(4058),
    [anon_sym_LT_LT_EQ] = ACTIONS(4058),
    [anon_sym_GT_GT_EQ] = ACTIONS(4058),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4058),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4058),
    [anon_sym_AMP_AMP] = ACTIONS(4058),
    [anon_sym_PIPE_PIPE] = ACTIONS(4058),
    [anon_sym_QMARK_QMARK] = ACTIONS(4056),
    [anon_sym_into] = ACTIONS(4058),
    [anon_sym_on] = ACTIONS(4058),
    [anon_sym_equals] = ACTIONS(4058),
    [anon_sym_by] = ACTIONS(4058),
    [anon_sym_as] = ACTIONS(4058),
    [anon_sym_is] = ACTIONS(4058),
    [anon_sym_DASH_GT] = ACTIONS(4058),
    [anon_sym_with] = ACTIONS(4058),
    [aux_sym_preproc_if_token3] = ACTIONS(4058),
    [aux_sym_preproc_else_token1] = ACTIONS(4058),
    [aux_sym_preproc_elif_token1] = ACTIONS(4058),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3188] = {
    [sym_preproc_region] = STATE(3188),
    [sym_preproc_endregion] = STATE(3188),
    [sym_preproc_line] = STATE(3188),
    [sym_preproc_pragma] = STATE(3188),
    [sym_preproc_nullable] = STATE(3188),
    [sym_preproc_error] = STATE(3188),
    [sym_preproc_define] = STATE(3188),
    [sym_preproc_undef] = STATE(3188),
    [sym__identifier_token] = ACTIONS(4723),
    [anon_sym_extern] = ACTIONS(4723),
    [anon_sym_alias] = ACTIONS(4723),
    [anon_sym_global] = ACTIONS(4723),
    [anon_sym_using] = ACTIONS(4723),
    [anon_sym_unsafe] = ACTIONS(4723),
    [anon_sym_EQ] = ACTIONS(4725),
    [anon_sym_static] = ACTIONS(4723),
    [anon_sym_LBRACK] = ACTIONS(4727),
    [anon_sym_LPAREN] = ACTIONS(4727),
    [anon_sym_event] = ACTIONS(4723),
    [anon_sym_namespace] = ACTIONS(4723),
    [anon_sym_class] = ACTIONS(4723),
    [anon_sym_ref] = ACTIONS(4723),
    [anon_sym_struct] = ACTIONS(4723),
    [anon_sym_enum] = ACTIONS(4723),
    [anon_sym_RBRACE] = ACTIONS(4727),
    [anon_sym_interface] = ACTIONS(4723),
    [anon_sym_delegate] = ACTIONS(4723),
    [anon_sym_record] = ACTIONS(4723),
    [anon_sym_abstract] = ACTIONS(4723),
    [anon_sym_async] = ACTIONS(4723),
    [anon_sym_const] = ACTIONS(4723),
    [anon_sym_file] = ACTIONS(4723),
    [anon_sym_fixed] = ACTIONS(4723),
    [anon_sym_internal] = ACTIONS(4723),
    [anon_sym_new] = ACTIONS(4723),
    [anon_sym_override] = ACTIONS(4723),
    [anon_sym_partial] = ACTIONS(4723),
    [anon_sym_private] = ACTIONS(4723),
    [anon_sym_protected] = ACTIONS(4723),
    [anon_sym_public] = ACTIONS(4723),
    [anon_sym_readonly] = ACTIONS(4723),
    [anon_sym_required] = ACTIONS(4723),
    [anon_sym_sealed] = ACTIONS(4723),
    [anon_sym_virtual] = ACTIONS(4723),
    [anon_sym_volatile] = ACTIONS(4723),
    [anon_sym_where] = ACTIONS(4723),
    [anon_sym_notnull] = ACTIONS(4723),
    [anon_sym_unmanaged] = ACTIONS(4723),
    [anon_sym_TILDE] = ACTIONS(4727),
    [anon_sym_implicit] = ACTIONS(4723),
    [anon_sym_explicit] = ACTIONS(4723),
    [anon_sym_scoped] = ACTIONS(4723),
    [anon_sym_var] = ACTIONS(4723),
    [sym_predefined_type] = ACTIONS(4723),
    [anon_sym_yield] = ACTIONS(4723),
    [anon_sym_when] = ACTIONS(4723),
    [anon_sym_from] = ACTIONS(4723),
    [anon_sym_into] = ACTIONS(4723),
    [anon_sym_join] = ACTIONS(4723),
    [anon_sym_on] = ACTIONS(4723),
    [anon_sym_equals] = ACTIONS(4723),
    [anon_sym_let] = ACTIONS(4723),
    [anon_sym_orderby] = ACTIONS(4723),
    [anon_sym_ascending] = ACTIONS(4723),
    [anon_sym_descending] = ACTIONS(4723),
    [anon_sym_group] = ACTIONS(4723),
    [anon_sym_by] = ACTIONS(4723),
    [anon_sym_select] = ACTIONS(4723),
    [aux_sym_preproc_if_token1] = ACTIONS(4727),
    [aux_sym_preproc_if_token3] = ACTIONS(4727),
    [aux_sym_preproc_else_token1] = ACTIONS(4727),
    [aux_sym_preproc_elif_token1] = ACTIONS(4727),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3189] = {
    [sym_preproc_region] = STATE(3189),
    [sym_preproc_endregion] = STATE(3189),
    [sym_preproc_line] = STATE(3189),
    [sym_preproc_pragma] = STATE(3189),
    [sym_preproc_nullable] = STATE(3189),
    [sym_preproc_error] = STATE(3189),
    [sym_preproc_define] = STATE(3189),
    [sym_preproc_undef] = STATE(3189),
    [anon_sym_SEMI] = ACTIONS(4623),
    [anon_sym_EQ] = ACTIONS(4625),
    [anon_sym_LBRACK] = ACTIONS(4623),
    [anon_sym_COLON] = ACTIONS(4623),
    [anon_sym_COMMA] = ACTIONS(4623),
    [anon_sym_RBRACK] = ACTIONS(4623),
    [anon_sym_LPAREN] = ACTIONS(4623),
    [anon_sym_RPAREN] = ACTIONS(4623),
    [anon_sym_RBRACE] = ACTIONS(4623),
    [anon_sym_LT] = ACTIONS(4625),
    [anon_sym_GT] = ACTIONS(4625),
    [anon_sym_in] = ACTIONS(4625),
    [anon_sym_QMARK] = ACTIONS(4625),
    [anon_sym_BANG] = ACTIONS(4625),
    [anon_sym_PLUS_PLUS] = ACTIONS(4623),
    [anon_sym_DASH_DASH] = ACTIONS(4623),
    [anon_sym_PLUS] = ACTIONS(4625),
    [anon_sym_DASH] = ACTIONS(4625),
    [anon_sym_STAR] = ACTIONS(4625),
    [anon_sym_SLASH] = ACTIONS(4625),
    [anon_sym_PERCENT] = ACTIONS(4625),
    [anon_sym_CARET] = ACTIONS(4625),
    [anon_sym_PIPE] = ACTIONS(4625),
    [anon_sym_AMP] = ACTIONS(4625),
    [anon_sym_LT_LT] = ACTIONS(4625),
    [anon_sym_GT_GT] = ACTIONS(4625),
    [anon_sym_GT_GT_GT] = ACTIONS(4625),
    [anon_sym_EQ_EQ] = ACTIONS(4623),
    [anon_sym_BANG_EQ] = ACTIONS(4623),
    [anon_sym_GT_EQ] = ACTIONS(4623),
    [anon_sym_LT_EQ] = ACTIONS(4623),
    [anon_sym_DOT] = ACTIONS(4625),
    [anon_sym_EQ_GT] = ACTIONS(4623),
    [anon_sym_switch] = ACTIONS(4623),
    [anon_sym_when] = ACTIONS(4623),
    [anon_sym_DOT_DOT] = ACTIONS(4623),
    [anon_sym_and] = ACTIONS(4623),
    [anon_sym_or] = ACTIONS(4623),
    [anon_sym_PLUS_EQ] = ACTIONS(4623),
    [anon_sym_DASH_EQ] = ACTIONS(4623),
    [anon_sym_STAR_EQ] = ACTIONS(4623),
    [anon_sym_SLASH_EQ] = ACTIONS(4623),
    [anon_sym_PERCENT_EQ] = ACTIONS(4623),
    [anon_sym_AMP_EQ] = ACTIONS(4623),
    [anon_sym_CARET_EQ] = ACTIONS(4623),
    [anon_sym_PIPE_EQ] = ACTIONS(4623),
    [anon_sym_LT_LT_EQ] = ACTIONS(4623),
    [anon_sym_GT_GT_EQ] = ACTIONS(4623),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4623),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4623),
    [anon_sym_AMP_AMP] = ACTIONS(4623),
    [anon_sym_PIPE_PIPE] = ACTIONS(4623),
    [anon_sym_QMARK_QMARK] = ACTIONS(4625),
    [anon_sym_into] = ACTIONS(4623),
    [anon_sym_on] = ACTIONS(4623),
    [anon_sym_equals] = ACTIONS(4623),
    [anon_sym_by] = ACTIONS(4623),
    [anon_sym_as] = ACTIONS(4623),
    [anon_sym_is] = ACTIONS(4623),
    [anon_sym_DASH_GT] = ACTIONS(4623),
    [anon_sym_with] = ACTIONS(4623),
    [aux_sym_preproc_if_token3] = ACTIONS(4623),
    [aux_sym_preproc_else_token1] = ACTIONS(4623),
    [aux_sym_preproc_elif_token1] = ACTIONS(4623),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3190] = {
    [sym_preproc_region] = STATE(3190),
    [sym_preproc_endregion] = STATE(3190),
    [sym_preproc_line] = STATE(3190),
    [sym_preproc_pragma] = STATE(3190),
    [sym_preproc_nullable] = STATE(3190),
    [sym_preproc_error] = STATE(3190),
    [sym_preproc_define] = STATE(3190),
    [sym_preproc_undef] = STATE(3190),
    [anon_sym_SEMI] = ACTIONS(4631),
    [anon_sym_EQ] = ACTIONS(4633),
    [anon_sym_LBRACK] = ACTIONS(4631),
    [anon_sym_COLON] = ACTIONS(4631),
    [anon_sym_COMMA] = ACTIONS(4631),
    [anon_sym_RBRACK] = ACTIONS(4631),
    [anon_sym_LPAREN] = ACTIONS(4631),
    [anon_sym_RPAREN] = ACTIONS(4631),
    [anon_sym_RBRACE] = ACTIONS(4631),
    [anon_sym_LT] = ACTIONS(4633),
    [anon_sym_GT] = ACTIONS(4633),
    [anon_sym_in] = ACTIONS(4633),
    [anon_sym_QMARK] = ACTIONS(4633),
    [anon_sym_BANG] = ACTIONS(4633),
    [anon_sym_PLUS_PLUS] = ACTIONS(4631),
    [anon_sym_DASH_DASH] = ACTIONS(4631),
    [anon_sym_PLUS] = ACTIONS(4633),
    [anon_sym_DASH] = ACTIONS(4633),
    [anon_sym_STAR] = ACTIONS(4633),
    [anon_sym_SLASH] = ACTIONS(4633),
    [anon_sym_PERCENT] = ACTIONS(4633),
    [anon_sym_CARET] = ACTIONS(4633),
    [anon_sym_PIPE] = ACTIONS(4633),
    [anon_sym_AMP] = ACTIONS(4633),
    [anon_sym_LT_LT] = ACTIONS(4633),
    [anon_sym_GT_GT] = ACTIONS(4633),
    [anon_sym_GT_GT_GT] = ACTIONS(4633),
    [anon_sym_EQ_EQ] = ACTIONS(4631),
    [anon_sym_BANG_EQ] = ACTIONS(4631),
    [anon_sym_GT_EQ] = ACTIONS(4631),
    [anon_sym_LT_EQ] = ACTIONS(4631),
    [anon_sym_DOT] = ACTIONS(4633),
    [anon_sym_EQ_GT] = ACTIONS(4631),
    [anon_sym_switch] = ACTIONS(4631),
    [anon_sym_when] = ACTIONS(4631),
    [anon_sym_DOT_DOT] = ACTIONS(4631),
    [anon_sym_and] = ACTIONS(4631),
    [anon_sym_or] = ACTIONS(4631),
    [anon_sym_PLUS_EQ] = ACTIONS(4631),
    [anon_sym_DASH_EQ] = ACTIONS(4631),
    [anon_sym_STAR_EQ] = ACTIONS(4631),
    [anon_sym_SLASH_EQ] = ACTIONS(4631),
    [anon_sym_PERCENT_EQ] = ACTIONS(4631),
    [anon_sym_AMP_EQ] = ACTIONS(4631),
    [anon_sym_CARET_EQ] = ACTIONS(4631),
    [anon_sym_PIPE_EQ] = ACTIONS(4631),
    [anon_sym_LT_LT_EQ] = ACTIONS(4631),
    [anon_sym_GT_GT_EQ] = ACTIONS(4631),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4631),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4631),
    [anon_sym_AMP_AMP] = ACTIONS(4631),
    [anon_sym_PIPE_PIPE] = ACTIONS(4631),
    [anon_sym_QMARK_QMARK] = ACTIONS(4633),
    [anon_sym_into] = ACTIONS(4631),
    [anon_sym_on] = ACTIONS(4631),
    [anon_sym_equals] = ACTIONS(4631),
    [anon_sym_by] = ACTIONS(4631),
    [anon_sym_as] = ACTIONS(4631),
    [anon_sym_is] = ACTIONS(4631),
    [anon_sym_DASH_GT] = ACTIONS(4631),
    [anon_sym_with] = ACTIONS(4631),
    [aux_sym_preproc_if_token3] = ACTIONS(4631),
    [aux_sym_preproc_else_token1] = ACTIONS(4631),
    [aux_sym_preproc_elif_token1] = ACTIONS(4631),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3191] = {
    [sym_preproc_region] = STATE(3191),
    [sym_preproc_endregion] = STATE(3191),
    [sym_preproc_line] = STATE(3191),
    [sym_preproc_pragma] = STATE(3191),
    [sym_preproc_nullable] = STATE(3191),
    [sym_preproc_error] = STATE(3191),
    [sym_preproc_define] = STATE(3191),
    [sym_preproc_undef] = STATE(3191),
    [anon_sym_SEMI] = ACTIONS(4588),
    [anon_sym_EQ] = ACTIONS(4590),
    [anon_sym_LBRACK] = ACTIONS(4588),
    [anon_sym_COLON] = ACTIONS(4588),
    [anon_sym_COMMA] = ACTIONS(4588),
    [anon_sym_RBRACK] = ACTIONS(4588),
    [anon_sym_LPAREN] = ACTIONS(4588),
    [anon_sym_RPAREN] = ACTIONS(4588),
    [anon_sym_RBRACE] = ACTIONS(4588),
    [anon_sym_LT] = ACTIONS(4590),
    [anon_sym_GT] = ACTIONS(4590),
    [anon_sym_in] = ACTIONS(4590),
    [anon_sym_QMARK] = ACTIONS(4590),
    [anon_sym_BANG] = ACTIONS(4590),
    [anon_sym_PLUS_PLUS] = ACTIONS(4588),
    [anon_sym_DASH_DASH] = ACTIONS(4588),
    [anon_sym_PLUS] = ACTIONS(4590),
    [anon_sym_DASH] = ACTIONS(4590),
    [anon_sym_STAR] = ACTIONS(4590),
    [anon_sym_SLASH] = ACTIONS(4590),
    [anon_sym_PERCENT] = ACTIONS(4590),
    [anon_sym_CARET] = ACTIONS(4590),
    [anon_sym_PIPE] = ACTIONS(4590),
    [anon_sym_AMP] = ACTIONS(4590),
    [anon_sym_LT_LT] = ACTIONS(4590),
    [anon_sym_GT_GT] = ACTIONS(4590),
    [anon_sym_GT_GT_GT] = ACTIONS(4590),
    [anon_sym_EQ_EQ] = ACTIONS(4588),
    [anon_sym_BANG_EQ] = ACTIONS(4588),
    [anon_sym_GT_EQ] = ACTIONS(4588),
    [anon_sym_LT_EQ] = ACTIONS(4588),
    [anon_sym_DOT] = ACTIONS(4590),
    [anon_sym_EQ_GT] = ACTIONS(4588),
    [anon_sym_switch] = ACTIONS(4588),
    [anon_sym_when] = ACTIONS(4588),
    [anon_sym_DOT_DOT] = ACTIONS(4588),
    [anon_sym_and] = ACTIONS(4588),
    [anon_sym_or] = ACTIONS(4588),
    [anon_sym_PLUS_EQ] = ACTIONS(4588),
    [anon_sym_DASH_EQ] = ACTIONS(4588),
    [anon_sym_STAR_EQ] = ACTIONS(4588),
    [anon_sym_SLASH_EQ] = ACTIONS(4588),
    [anon_sym_PERCENT_EQ] = ACTIONS(4588),
    [anon_sym_AMP_EQ] = ACTIONS(4588),
    [anon_sym_CARET_EQ] = ACTIONS(4588),
    [anon_sym_PIPE_EQ] = ACTIONS(4588),
    [anon_sym_LT_LT_EQ] = ACTIONS(4588),
    [anon_sym_GT_GT_EQ] = ACTIONS(4588),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4588),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4588),
    [anon_sym_AMP_AMP] = ACTIONS(4588),
    [anon_sym_PIPE_PIPE] = ACTIONS(4588),
    [anon_sym_QMARK_QMARK] = ACTIONS(4590),
    [anon_sym_into] = ACTIONS(4588),
    [anon_sym_on] = ACTIONS(4588),
    [anon_sym_equals] = ACTIONS(4588),
    [anon_sym_by] = ACTIONS(4588),
    [anon_sym_as] = ACTIONS(4588),
    [anon_sym_is] = ACTIONS(4588),
    [anon_sym_DASH_GT] = ACTIONS(4588),
    [anon_sym_with] = ACTIONS(4588),
    [aux_sym_preproc_if_token3] = ACTIONS(4588),
    [aux_sym_preproc_else_token1] = ACTIONS(4588),
    [aux_sym_preproc_elif_token1] = ACTIONS(4588),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3192] = {
    [sym__variable_designation] = STATE(4663),
    [sym_parenthesized_variable_designation] = STATE(4614),
    [sym_identifier] = STATE(4624),
    [sym__reserved_identifier] = STATE(2914),
    [sym_preproc_region] = STATE(3192),
    [sym_preproc_endregion] = STATE(3192),
    [sym_preproc_line] = STATE(3192),
    [sym_preproc_pragma] = STATE(3192),
    [sym_preproc_nullable] = STATE(3192),
    [sym_preproc_error] = STATE(3192),
    [sym_preproc_define] = STATE(3192),
    [sym_preproc_undef] = STATE(3192),
    [sym__identifier_token] = ACTIONS(4490),
    [anon_sym_alias] = ACTIONS(4492),
    [anon_sym_global] = ACTIONS(4492),
    [anon_sym_LBRACK] = ACTIONS(4329),
    [anon_sym_COMMA] = ACTIONS(4329),
    [anon_sym_LPAREN] = ACTIONS(4329),
    [anon_sym_file] = ACTIONS(4492),
    [anon_sym_LT] = ACTIONS(4331),
    [anon_sym_GT] = ACTIONS(4331),
    [anon_sym_where] = ACTIONS(4331),
    [anon_sym_QMARK] = ACTIONS(4331),
    [anon_sym_notnull] = ACTIONS(4492),
    [anon_sym_unmanaged] = ACTIONS(4492),
    [anon_sym_BANG] = ACTIONS(4331),
    [anon_sym_PLUS_PLUS] = ACTIONS(4329),
    [anon_sym_DASH_DASH] = ACTIONS(4329),
    [anon_sym_PLUS] = ACTIONS(4331),
    [anon_sym_DASH] = ACTIONS(4331),
    [anon_sym_STAR] = ACTIONS(4329),
    [anon_sym_SLASH] = ACTIONS(4331),
    [anon_sym_PERCENT] = ACTIONS(4329),
    [anon_sym_CARET] = ACTIONS(4329),
    [anon_sym_PIPE] = ACTIONS(4331),
    [anon_sym_AMP] = ACTIONS(4331),
    [anon_sym_LT_LT] = ACTIONS(4329),
    [anon_sym_GT_GT] = ACTIONS(4331),
    [anon_sym_GT_GT_GT] = ACTIONS(4329),
    [anon_sym_EQ_EQ] = ACTIONS(4329),
    [anon_sym_BANG_EQ] = ACTIONS(4329),
    [anon_sym_GT_EQ] = ACTIONS(4329),
    [anon_sym_LT_EQ] = ACTIONS(4329),
    [anon_sym_DOT] = ACTIONS(4331),
    [anon_sym_scoped] = ACTIONS(4492),
    [anon_sym_var] = ACTIONS(4492),
    [anon_sym_yield] = ACTIONS(4492),
    [anon_sym_switch] = ACTIONS(4331),
    [anon_sym_when] = ACTIONS(4492),
    [sym_discard] = ACTIONS(4647),
    [anon_sym_DOT_DOT] = ACTIONS(4329),
    [anon_sym_and] = ACTIONS(4331),
    [anon_sym_or] = ACTIONS(4331),
    [anon_sym_AMP_AMP] = ACTIONS(4329),
    [anon_sym_PIPE_PIPE] = ACTIONS(4329),
    [anon_sym_QMARK_QMARK] = ACTIONS(4329),
    [anon_sym_from] = ACTIONS(4331),
    [anon_sym_into] = ACTIONS(4331),
    [anon_sym_join] = ACTIONS(4331),
    [anon_sym_on] = ACTIONS(4492),
    [anon_sym_equals] = ACTIONS(4492),
    [anon_sym_let] = ACTIONS(4331),
    [anon_sym_orderby] = ACTIONS(4331),
    [anon_sym_ascending] = ACTIONS(4331),
    [anon_sym_descending] = ACTIONS(4331),
    [anon_sym_group] = ACTIONS(4331),
    [anon_sym_by] = ACTIONS(4492),
    [anon_sym_select] = ACTIONS(4331),
    [anon_sym_as] = ACTIONS(4331),
    [anon_sym_is] = ACTIONS(4331),
    [anon_sym_DASH_GT] = ACTIONS(4329),
    [anon_sym_with] = ACTIONS(4331),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3193] = {
    [sym_preproc_region] = STATE(3193),
    [sym_preproc_endregion] = STATE(3193),
    [sym_preproc_line] = STATE(3193),
    [sym_preproc_pragma] = STATE(3193),
    [sym_preproc_nullable] = STATE(3193),
    [sym_preproc_error] = STATE(3193),
    [sym_preproc_define] = STATE(3193),
    [sym_preproc_undef] = STATE(3193),
    [sym__identifier_token] = ACTIONS(4496),
    [anon_sym_alias] = ACTIONS(4496),
    [anon_sym_global] = ACTIONS(4496),
    [anon_sym_LBRACK] = ACTIONS(4498),
    [anon_sym_COLON] = ACTIONS(4498),
    [anon_sym_COMMA] = ACTIONS(4498),
    [anon_sym_LPAREN] = ACTIONS(4498),
    [anon_sym_LBRACE] = ACTIONS(4498),
    [anon_sym_file] = ACTIONS(4496),
    [anon_sym_LT] = ACTIONS(4496),
    [anon_sym_GT] = ACTIONS(4496),
    [anon_sym_where] = ACTIONS(4496),
    [anon_sym_QMARK] = ACTIONS(4496),
    [anon_sym_notnull] = ACTIONS(4496),
    [anon_sym_unmanaged] = ACTIONS(4496),
    [anon_sym_BANG] = ACTIONS(4496),
    [anon_sym_PLUS_PLUS] = ACTIONS(4498),
    [anon_sym_DASH_DASH] = ACTIONS(4498),
    [anon_sym_PLUS] = ACTIONS(4496),
    [anon_sym_DASH] = ACTIONS(4496),
    [anon_sym_STAR] = ACTIONS(4498),
    [anon_sym_SLASH] = ACTIONS(4496),
    [anon_sym_PERCENT] = ACTIONS(4498),
    [anon_sym_CARET] = ACTIONS(4498),
    [anon_sym_PIPE] = ACTIONS(4496),
    [anon_sym_AMP] = ACTIONS(4496),
    [anon_sym_LT_LT] = ACTIONS(4498),
    [anon_sym_GT_GT] = ACTIONS(4496),
    [anon_sym_GT_GT_GT] = ACTIONS(4498),
    [anon_sym_EQ_EQ] = ACTIONS(4498),
    [anon_sym_BANG_EQ] = ACTIONS(4498),
    [anon_sym_GT_EQ] = ACTIONS(4498),
    [anon_sym_LT_EQ] = ACTIONS(4498),
    [anon_sym_DOT] = ACTIONS(4496),
    [anon_sym_scoped] = ACTIONS(4496),
    [anon_sym_EQ_GT] = ACTIONS(4500),
    [anon_sym_var] = ACTIONS(4496),
    [anon_sym_yield] = ACTIONS(4496),
    [anon_sym_switch] = ACTIONS(4496),
    [anon_sym_when] = ACTIONS(4496),
    [sym_discard] = ACTIONS(4496),
    [anon_sym_DOT_DOT] = ACTIONS(4498),
    [anon_sym_and] = ACTIONS(4496),
    [anon_sym_or] = ACTIONS(4496),
    [anon_sym_AMP_AMP] = ACTIONS(4498),
    [anon_sym_PIPE_PIPE] = ACTIONS(4498),
    [anon_sym_QMARK_QMARK] = ACTIONS(4498),
    [anon_sym_from] = ACTIONS(4496),
    [anon_sym_into] = ACTIONS(4496),
    [anon_sym_join] = ACTIONS(4496),
    [anon_sym_on] = ACTIONS(4496),
    [anon_sym_equals] = ACTIONS(4496),
    [anon_sym_let] = ACTIONS(4496),
    [anon_sym_orderby] = ACTIONS(4496),
    [anon_sym_ascending] = ACTIONS(4496),
    [anon_sym_descending] = ACTIONS(4496),
    [anon_sym_group] = ACTIONS(4496),
    [anon_sym_by] = ACTIONS(4496),
    [anon_sym_select] = ACTIONS(4496),
    [anon_sym_as] = ACTIONS(4496),
    [anon_sym_is] = ACTIONS(4496),
    [anon_sym_DASH_GT] = ACTIONS(4498),
    [anon_sym_with] = ACTIONS(4496),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4498),
  },
  [3194] = {
    [sym__variable_designation] = STATE(4692),
    [sym_parenthesized_variable_designation] = STATE(4614),
    [sym_identifier] = STATE(4624),
    [sym__reserved_identifier] = STATE(2914),
    [sym_preproc_region] = STATE(3194),
    [sym_preproc_endregion] = STATE(3194),
    [sym_preproc_line] = STATE(3194),
    [sym_preproc_pragma] = STATE(3194),
    [sym_preproc_nullable] = STATE(3194),
    [sym_preproc_error] = STATE(3194),
    [sym_preproc_define] = STATE(3194),
    [sym_preproc_undef] = STATE(3194),
    [sym__identifier_token] = ACTIONS(4490),
    [anon_sym_alias] = ACTIONS(4492),
    [anon_sym_global] = ACTIONS(4492),
    [anon_sym_LBRACK] = ACTIONS(4335),
    [anon_sym_COMMA] = ACTIONS(4335),
    [anon_sym_LPAREN] = ACTIONS(4335),
    [anon_sym_file] = ACTIONS(4492),
    [anon_sym_LT] = ACTIONS(4337),
    [anon_sym_GT] = ACTIONS(4337),
    [anon_sym_where] = ACTIONS(4337),
    [anon_sym_QMARK] = ACTIONS(4337),
    [anon_sym_notnull] = ACTIONS(4492),
    [anon_sym_unmanaged] = ACTIONS(4492),
    [anon_sym_BANG] = ACTIONS(4337),
    [anon_sym_PLUS_PLUS] = ACTIONS(4335),
    [anon_sym_DASH_DASH] = ACTIONS(4335),
    [anon_sym_PLUS] = ACTIONS(4337),
    [anon_sym_DASH] = ACTIONS(4337),
    [anon_sym_STAR] = ACTIONS(4335),
    [anon_sym_SLASH] = ACTIONS(4337),
    [anon_sym_PERCENT] = ACTIONS(4335),
    [anon_sym_CARET] = ACTIONS(4335),
    [anon_sym_PIPE] = ACTIONS(4337),
    [anon_sym_AMP] = ACTIONS(4337),
    [anon_sym_LT_LT] = ACTIONS(4335),
    [anon_sym_GT_GT] = ACTIONS(4337),
    [anon_sym_GT_GT_GT] = ACTIONS(4335),
    [anon_sym_EQ_EQ] = ACTIONS(4335),
    [anon_sym_BANG_EQ] = ACTIONS(4335),
    [anon_sym_GT_EQ] = ACTIONS(4335),
    [anon_sym_LT_EQ] = ACTIONS(4335),
    [anon_sym_DOT] = ACTIONS(4337),
    [anon_sym_scoped] = ACTIONS(4492),
    [anon_sym_var] = ACTIONS(4492),
    [anon_sym_yield] = ACTIONS(4492),
    [anon_sym_switch] = ACTIONS(4337),
    [anon_sym_when] = ACTIONS(4492),
    [sym_discard] = ACTIONS(4647),
    [anon_sym_DOT_DOT] = ACTIONS(4335),
    [anon_sym_and] = ACTIONS(4337),
    [anon_sym_or] = ACTIONS(4337),
    [anon_sym_AMP_AMP] = ACTIONS(4335),
    [anon_sym_PIPE_PIPE] = ACTIONS(4335),
    [anon_sym_QMARK_QMARK] = ACTIONS(4335),
    [anon_sym_from] = ACTIONS(4337),
    [anon_sym_into] = ACTIONS(4337),
    [anon_sym_join] = ACTIONS(4337),
    [anon_sym_on] = ACTIONS(4492),
    [anon_sym_equals] = ACTIONS(4492),
    [anon_sym_let] = ACTIONS(4337),
    [anon_sym_orderby] = ACTIONS(4337),
    [anon_sym_ascending] = ACTIONS(4337),
    [anon_sym_descending] = ACTIONS(4337),
    [anon_sym_group] = ACTIONS(4337),
    [anon_sym_by] = ACTIONS(4492),
    [anon_sym_select] = ACTIONS(4337),
    [anon_sym_as] = ACTIONS(4337),
    [anon_sym_is] = ACTIONS(4337),
    [anon_sym_DASH_GT] = ACTIONS(4335),
    [anon_sym_with] = ACTIONS(4337),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3195] = {
    [sym_preproc_region] = STATE(3195),
    [sym_preproc_endregion] = STATE(3195),
    [sym_preproc_line] = STATE(3195),
    [sym_preproc_pragma] = STATE(3195),
    [sym_preproc_nullable] = STATE(3195),
    [sym_preproc_error] = STATE(3195),
    [sym_preproc_define] = STATE(3195),
    [sym_preproc_undef] = STATE(3195),
    [sym__identifier_token] = ACTIONS(4056),
    [anon_sym_alias] = ACTIONS(4056),
    [anon_sym_global] = ACTIONS(4056),
    [anon_sym_LBRACK] = ACTIONS(4058),
    [anon_sym_COLON] = ACTIONS(4058),
    [anon_sym_COMMA] = ACTIONS(4058),
    [anon_sym_LPAREN] = ACTIONS(4058),
    [anon_sym_RPAREN] = ACTIONS(4058),
    [anon_sym_LBRACE] = ACTIONS(4058),
    [anon_sym_RBRACE] = ACTIONS(4058),
    [anon_sym_file] = ACTIONS(4056),
    [anon_sym_LT] = ACTIONS(4056),
    [anon_sym_GT] = ACTIONS(4056),
    [anon_sym_where] = ACTIONS(4056),
    [anon_sym_QMARK] = ACTIONS(4056),
    [anon_sym_notnull] = ACTIONS(4056),
    [anon_sym_unmanaged] = ACTIONS(4056),
    [anon_sym_BANG] = ACTIONS(4056),
    [anon_sym_PLUS_PLUS] = ACTIONS(4058),
    [anon_sym_DASH_DASH] = ACTIONS(4058),
    [anon_sym_PLUS] = ACTIONS(4056),
    [anon_sym_DASH] = ACTIONS(4056),
    [anon_sym_STAR] = ACTIONS(4058),
    [anon_sym_SLASH] = ACTIONS(4056),
    [anon_sym_PERCENT] = ACTIONS(4058),
    [anon_sym_CARET] = ACTIONS(4058),
    [anon_sym_PIPE] = ACTIONS(4056),
    [anon_sym_AMP] = ACTIONS(4056),
    [anon_sym_LT_LT] = ACTIONS(4058),
    [anon_sym_GT_GT] = ACTIONS(4056),
    [anon_sym_GT_GT_GT] = ACTIONS(4058),
    [anon_sym_EQ_EQ] = ACTIONS(4058),
    [anon_sym_BANG_EQ] = ACTIONS(4058),
    [anon_sym_GT_EQ] = ACTIONS(4058),
    [anon_sym_LT_EQ] = ACTIONS(4058),
    [anon_sym_DOT] = ACTIONS(4056),
    [anon_sym_scoped] = ACTIONS(4056),
    [anon_sym_var] = ACTIONS(4056),
    [anon_sym_yield] = ACTIONS(4056),
    [anon_sym_switch] = ACTIONS(4056),
    [anon_sym_when] = ACTIONS(4056),
    [sym_discard] = ACTIONS(4056),
    [anon_sym_DOT_DOT] = ACTIONS(4058),
    [anon_sym_and] = ACTIONS(4056),
    [anon_sym_or] = ACTIONS(4056),
    [anon_sym_AMP_AMP] = ACTIONS(4058),
    [anon_sym_PIPE_PIPE] = ACTIONS(4058),
    [anon_sym_QMARK_QMARK] = ACTIONS(4058),
    [anon_sym_from] = ACTIONS(4056),
    [anon_sym_into] = ACTIONS(4056),
    [anon_sym_join] = ACTIONS(4056),
    [anon_sym_on] = ACTIONS(4056),
    [anon_sym_equals] = ACTIONS(4056),
    [anon_sym_let] = ACTIONS(4056),
    [anon_sym_orderby] = ACTIONS(4056),
    [anon_sym_ascending] = ACTIONS(4056),
    [anon_sym_descending] = ACTIONS(4056),
    [anon_sym_group] = ACTIONS(4056),
    [anon_sym_by] = ACTIONS(4056),
    [anon_sym_select] = ACTIONS(4056),
    [anon_sym_as] = ACTIONS(4056),
    [anon_sym_is] = ACTIONS(4056),
    [anon_sym_DASH_GT] = ACTIONS(4058),
    [anon_sym_with] = ACTIONS(4056),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3196] = {
    [sym__variable_designation] = STATE(4582),
    [sym_parenthesized_variable_designation] = STATE(4614),
    [sym_identifier] = STATE(4624),
    [sym__reserved_identifier] = STATE(2914),
    [sym_preproc_region] = STATE(3196),
    [sym_preproc_endregion] = STATE(3196),
    [sym_preproc_line] = STATE(3196),
    [sym_preproc_pragma] = STATE(3196),
    [sym_preproc_nullable] = STATE(3196),
    [sym_preproc_error] = STATE(3196),
    [sym_preproc_define] = STATE(3196),
    [sym_preproc_undef] = STATE(3196),
    [sym__identifier_token] = ACTIONS(4490),
    [anon_sym_alias] = ACTIONS(4492),
    [anon_sym_global] = ACTIONS(4492),
    [anon_sym_LBRACK] = ACTIONS(4373),
    [anon_sym_COMMA] = ACTIONS(4373),
    [anon_sym_LPAREN] = ACTIONS(4373),
    [anon_sym_file] = ACTIONS(4492),
    [anon_sym_LT] = ACTIONS(4375),
    [anon_sym_GT] = ACTIONS(4375),
    [anon_sym_where] = ACTIONS(4375),
    [anon_sym_QMARK] = ACTIONS(4375),
    [anon_sym_notnull] = ACTIONS(4492),
    [anon_sym_unmanaged] = ACTIONS(4492),
    [anon_sym_BANG] = ACTIONS(4375),
    [anon_sym_PLUS_PLUS] = ACTIONS(4373),
    [anon_sym_DASH_DASH] = ACTIONS(4373),
    [anon_sym_PLUS] = ACTIONS(4375),
    [anon_sym_DASH] = ACTIONS(4375),
    [anon_sym_STAR] = ACTIONS(4373),
    [anon_sym_SLASH] = ACTIONS(4375),
    [anon_sym_PERCENT] = ACTIONS(4373),
    [anon_sym_CARET] = ACTIONS(4373),
    [anon_sym_PIPE] = ACTIONS(4375),
    [anon_sym_AMP] = ACTIONS(4375),
    [anon_sym_LT_LT] = ACTIONS(4373),
    [anon_sym_GT_GT] = ACTIONS(4375),
    [anon_sym_GT_GT_GT] = ACTIONS(4373),
    [anon_sym_EQ_EQ] = ACTIONS(4373),
    [anon_sym_BANG_EQ] = ACTIONS(4373),
    [anon_sym_GT_EQ] = ACTIONS(4373),
    [anon_sym_LT_EQ] = ACTIONS(4373),
    [anon_sym_DOT] = ACTIONS(4375),
    [anon_sym_scoped] = ACTIONS(4492),
    [anon_sym_var] = ACTIONS(4492),
    [anon_sym_yield] = ACTIONS(4492),
    [anon_sym_switch] = ACTIONS(4375),
    [anon_sym_when] = ACTIONS(4492),
    [sym_discard] = ACTIONS(4647),
    [anon_sym_DOT_DOT] = ACTIONS(4373),
    [anon_sym_and] = ACTIONS(4375),
    [anon_sym_or] = ACTIONS(4375),
    [anon_sym_AMP_AMP] = ACTIONS(4373),
    [anon_sym_PIPE_PIPE] = ACTIONS(4373),
    [anon_sym_QMARK_QMARK] = ACTIONS(4373),
    [anon_sym_from] = ACTIONS(4375),
    [anon_sym_into] = ACTIONS(4375),
    [anon_sym_join] = ACTIONS(4375),
    [anon_sym_on] = ACTIONS(4492),
    [anon_sym_equals] = ACTIONS(4492),
    [anon_sym_let] = ACTIONS(4375),
    [anon_sym_orderby] = ACTIONS(4375),
    [anon_sym_ascending] = ACTIONS(4375),
    [anon_sym_descending] = ACTIONS(4375),
    [anon_sym_group] = ACTIONS(4375),
    [anon_sym_by] = ACTIONS(4492),
    [anon_sym_select] = ACTIONS(4375),
    [anon_sym_as] = ACTIONS(4375),
    [anon_sym_is] = ACTIONS(4375),
    [anon_sym_DASH_GT] = ACTIONS(4373),
    [anon_sym_with] = ACTIONS(4375),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3197] = {
    [sym_preproc_region] = STATE(3197),
    [sym_preproc_endregion] = STATE(3197),
    [sym_preproc_line] = STATE(3197),
    [sym_preproc_pragma] = STATE(3197),
    [sym_preproc_nullable] = STATE(3197),
    [sym_preproc_error] = STATE(3197),
    [sym_preproc_define] = STATE(3197),
    [sym_preproc_undef] = STATE(3197),
    [sym__identifier_token] = ACTIONS(3721),
    [anon_sym_alias] = ACTIONS(3721),
    [anon_sym_global] = ACTIONS(3721),
    [anon_sym_LBRACK] = ACTIONS(3719),
    [anon_sym_COLON] = ACTIONS(3719),
    [anon_sym_COMMA] = ACTIONS(3719),
    [anon_sym_LPAREN] = ACTIONS(3719),
    [anon_sym_RPAREN] = ACTIONS(3719),
    [anon_sym_LBRACE] = ACTIONS(3719),
    [anon_sym_RBRACE] = ACTIONS(3719),
    [anon_sym_file] = ACTIONS(3721),
    [anon_sym_LT] = ACTIONS(3721),
    [anon_sym_GT] = ACTIONS(3721),
    [anon_sym_where] = ACTIONS(3721),
    [anon_sym_QMARK] = ACTIONS(3721),
    [anon_sym_notnull] = ACTIONS(3721),
    [anon_sym_unmanaged] = ACTIONS(3721),
    [anon_sym_BANG] = ACTIONS(3721),
    [anon_sym_PLUS_PLUS] = ACTIONS(3719),
    [anon_sym_DASH_DASH] = ACTIONS(3719),
    [anon_sym_PLUS] = ACTIONS(3721),
    [anon_sym_DASH] = ACTIONS(3721),
    [anon_sym_STAR] = ACTIONS(3719),
    [anon_sym_SLASH] = ACTIONS(3721),
    [anon_sym_PERCENT] = ACTIONS(3719),
    [anon_sym_CARET] = ACTIONS(3719),
    [anon_sym_PIPE] = ACTIONS(3721),
    [anon_sym_AMP] = ACTIONS(3721),
    [anon_sym_LT_LT] = ACTIONS(3719),
    [anon_sym_GT_GT] = ACTIONS(3721),
    [anon_sym_GT_GT_GT] = ACTIONS(3719),
    [anon_sym_EQ_EQ] = ACTIONS(3719),
    [anon_sym_BANG_EQ] = ACTIONS(3719),
    [anon_sym_GT_EQ] = ACTIONS(3719),
    [anon_sym_LT_EQ] = ACTIONS(3719),
    [anon_sym_DOT] = ACTIONS(3721),
    [anon_sym_scoped] = ACTIONS(3721),
    [anon_sym_var] = ACTIONS(3721),
    [anon_sym_yield] = ACTIONS(3721),
    [anon_sym_switch] = ACTIONS(3721),
    [anon_sym_when] = ACTIONS(3721),
    [sym_discard] = ACTIONS(3721),
    [anon_sym_DOT_DOT] = ACTIONS(3719),
    [anon_sym_and] = ACTIONS(3721),
    [anon_sym_or] = ACTIONS(3721),
    [anon_sym_AMP_AMP] = ACTIONS(3719),
    [anon_sym_PIPE_PIPE] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK] = ACTIONS(3719),
    [anon_sym_from] = ACTIONS(3721),
    [anon_sym_into] = ACTIONS(3721),
    [anon_sym_join] = ACTIONS(3721),
    [anon_sym_on] = ACTIONS(3721),
    [anon_sym_equals] = ACTIONS(3721),
    [anon_sym_let] = ACTIONS(3721),
    [anon_sym_orderby] = ACTIONS(3721),
    [anon_sym_ascending] = ACTIONS(3721),
    [anon_sym_descending] = ACTIONS(3721),
    [anon_sym_group] = ACTIONS(3721),
    [anon_sym_by] = ACTIONS(3721),
    [anon_sym_select] = ACTIONS(3721),
    [anon_sym_as] = ACTIONS(3721),
    [anon_sym_is] = ACTIONS(3721),
    [anon_sym_DASH_GT] = ACTIONS(3719),
    [anon_sym_with] = ACTIONS(3721),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3198] = {
    [sym_preproc_region] = STATE(3198),
    [sym_preproc_endregion] = STATE(3198),
    [sym_preproc_line] = STATE(3198),
    [sym_preproc_pragma] = STATE(3198),
    [sym_preproc_nullable] = STATE(3198),
    [sym_preproc_error] = STATE(3198),
    [sym_preproc_define] = STATE(3198),
    [sym_preproc_undef] = STATE(3198),
    [sym__identifier_token] = ACTIONS(4729),
    [anon_sym_extern] = ACTIONS(4729),
    [anon_sym_alias] = ACTIONS(4729),
    [anon_sym_global] = ACTIONS(4729),
    [anon_sym_using] = ACTIONS(4729),
    [anon_sym_unsafe] = ACTIONS(4729),
    [anon_sym_EQ] = ACTIONS(4731),
    [anon_sym_static] = ACTIONS(4729),
    [anon_sym_LBRACK] = ACTIONS(4733),
    [anon_sym_LPAREN] = ACTIONS(4733),
    [anon_sym_event] = ACTIONS(4729),
    [anon_sym_namespace] = ACTIONS(4729),
    [anon_sym_class] = ACTIONS(4729),
    [anon_sym_ref] = ACTIONS(4729),
    [anon_sym_struct] = ACTIONS(4729),
    [anon_sym_enum] = ACTIONS(4729),
    [anon_sym_RBRACE] = ACTIONS(4733),
    [anon_sym_interface] = ACTIONS(4729),
    [anon_sym_delegate] = ACTIONS(4729),
    [anon_sym_record] = ACTIONS(4729),
    [anon_sym_abstract] = ACTIONS(4729),
    [anon_sym_async] = ACTIONS(4729),
    [anon_sym_const] = ACTIONS(4729),
    [anon_sym_file] = ACTIONS(4729),
    [anon_sym_fixed] = ACTIONS(4729),
    [anon_sym_internal] = ACTIONS(4729),
    [anon_sym_new] = ACTIONS(4729),
    [anon_sym_override] = ACTIONS(4729),
    [anon_sym_partial] = ACTIONS(4729),
    [anon_sym_private] = ACTIONS(4729),
    [anon_sym_protected] = ACTIONS(4729),
    [anon_sym_public] = ACTIONS(4729),
    [anon_sym_readonly] = ACTIONS(4729),
    [anon_sym_required] = ACTIONS(4729),
    [anon_sym_sealed] = ACTIONS(4729),
    [anon_sym_virtual] = ACTIONS(4729),
    [anon_sym_volatile] = ACTIONS(4729),
    [anon_sym_where] = ACTIONS(4729),
    [anon_sym_notnull] = ACTIONS(4729),
    [anon_sym_unmanaged] = ACTIONS(4729),
    [anon_sym_TILDE] = ACTIONS(4733),
    [anon_sym_implicit] = ACTIONS(4729),
    [anon_sym_explicit] = ACTIONS(4729),
    [anon_sym_scoped] = ACTIONS(4729),
    [anon_sym_var] = ACTIONS(4729),
    [sym_predefined_type] = ACTIONS(4729),
    [anon_sym_yield] = ACTIONS(4729),
    [anon_sym_when] = ACTIONS(4729),
    [anon_sym_from] = ACTIONS(4729),
    [anon_sym_into] = ACTIONS(4729),
    [anon_sym_join] = ACTIONS(4729),
    [anon_sym_on] = ACTIONS(4729),
    [anon_sym_equals] = ACTIONS(4729),
    [anon_sym_let] = ACTIONS(4729),
    [anon_sym_orderby] = ACTIONS(4729),
    [anon_sym_ascending] = ACTIONS(4729),
    [anon_sym_descending] = ACTIONS(4729),
    [anon_sym_group] = ACTIONS(4729),
    [anon_sym_by] = ACTIONS(4729),
    [anon_sym_select] = ACTIONS(4729),
    [aux_sym_preproc_if_token1] = ACTIONS(4733),
    [aux_sym_preproc_if_token3] = ACTIONS(4733),
    [aux_sym_preproc_else_token1] = ACTIONS(4733),
    [aux_sym_preproc_elif_token1] = ACTIONS(4733),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3199] = {
    [sym__variable_designation] = STATE(4544),
    [sym_parenthesized_variable_designation] = STATE(4614),
    [sym_identifier] = STATE(4624),
    [sym__reserved_identifier] = STATE(2914),
    [sym_preproc_region] = STATE(3199),
    [sym_preproc_endregion] = STATE(3199),
    [sym_preproc_line] = STATE(3199),
    [sym_preproc_pragma] = STATE(3199),
    [sym_preproc_nullable] = STATE(3199),
    [sym_preproc_error] = STATE(3199),
    [sym_preproc_define] = STATE(3199),
    [sym_preproc_undef] = STATE(3199),
    [sym__identifier_token] = ACTIONS(4490),
    [anon_sym_alias] = ACTIONS(4492),
    [anon_sym_global] = ACTIONS(4492),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_COMMA] = ACTIONS(4383),
    [anon_sym_LPAREN] = ACTIONS(4383),
    [anon_sym_file] = ACTIONS(4492),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_where] = ACTIONS(4385),
    [anon_sym_QMARK] = ACTIONS(4385),
    [anon_sym_notnull] = ACTIONS(4492),
    [anon_sym_unmanaged] = ACTIONS(4492),
    [anon_sym_BANG] = ACTIONS(4385),
    [anon_sym_PLUS_PLUS] = ACTIONS(4383),
    [anon_sym_DASH_DASH] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_DASH] = ACTIONS(4385),
    [anon_sym_STAR] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4385),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4385),
    [anon_sym_GT_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4383),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_scoped] = ACTIONS(4492),
    [anon_sym_var] = ACTIONS(4492),
    [anon_sym_yield] = ACTIONS(4492),
    [anon_sym_switch] = ACTIONS(4385),
    [anon_sym_when] = ACTIONS(4492),
    [sym_discard] = ACTIONS(4647),
    [anon_sym_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4385),
    [anon_sym_or] = ACTIONS(4385),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_QMARK_QMARK] = ACTIONS(4383),
    [anon_sym_from] = ACTIONS(4385),
    [anon_sym_into] = ACTIONS(4385),
    [anon_sym_join] = ACTIONS(4385),
    [anon_sym_on] = ACTIONS(4492),
    [anon_sym_equals] = ACTIONS(4492),
    [anon_sym_let] = ACTIONS(4385),
    [anon_sym_orderby] = ACTIONS(4385),
    [anon_sym_ascending] = ACTIONS(4385),
    [anon_sym_descending] = ACTIONS(4385),
    [anon_sym_group] = ACTIONS(4385),
    [anon_sym_by] = ACTIONS(4492),
    [anon_sym_select] = ACTIONS(4385),
    [anon_sym_as] = ACTIONS(4385),
    [anon_sym_is] = ACTIONS(4385),
    [anon_sym_DASH_GT] = ACTIONS(4383),
    [anon_sym_with] = ACTIONS(4385),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3200] = {
    [sym_preproc_region] = STATE(3200),
    [sym_preproc_endregion] = STATE(3200),
    [sym_preproc_line] = STATE(3200),
    [sym_preproc_pragma] = STATE(3200),
    [sym_preproc_nullable] = STATE(3200),
    [sym_preproc_error] = STATE(3200),
    [sym_preproc_define] = STATE(3200),
    [sym_preproc_undef] = STATE(3200),
    [sym__identifier_token] = ACTIONS(4735),
    [anon_sym_extern] = ACTIONS(4735),
    [anon_sym_alias] = ACTIONS(4735),
    [anon_sym_global] = ACTIONS(4735),
    [anon_sym_using] = ACTIONS(4735),
    [anon_sym_unsafe] = ACTIONS(4735),
    [anon_sym_EQ] = ACTIONS(4737),
    [anon_sym_static] = ACTIONS(4735),
    [anon_sym_LBRACK] = ACTIONS(4737),
    [anon_sym_LPAREN] = ACTIONS(4737),
    [anon_sym_event] = ACTIONS(4735),
    [anon_sym_namespace] = ACTIONS(4735),
    [anon_sym_class] = ACTIONS(4735),
    [anon_sym_ref] = ACTIONS(4735),
    [anon_sym_struct] = ACTIONS(4735),
    [anon_sym_enum] = ACTIONS(4735),
    [anon_sym_RBRACE] = ACTIONS(4737),
    [anon_sym_interface] = ACTIONS(4735),
    [anon_sym_delegate] = ACTIONS(4735),
    [anon_sym_record] = ACTIONS(4735),
    [anon_sym_abstract] = ACTIONS(4735),
    [anon_sym_async] = ACTIONS(4735),
    [anon_sym_const] = ACTIONS(4735),
    [anon_sym_file] = ACTIONS(4735),
    [anon_sym_fixed] = ACTIONS(4735),
    [anon_sym_internal] = ACTIONS(4735),
    [anon_sym_new] = ACTIONS(4735),
    [anon_sym_override] = ACTIONS(4735),
    [anon_sym_partial] = ACTIONS(4735),
    [anon_sym_private] = ACTIONS(4735),
    [anon_sym_protected] = ACTIONS(4735),
    [anon_sym_public] = ACTIONS(4735),
    [anon_sym_readonly] = ACTIONS(4735),
    [anon_sym_required] = ACTIONS(4735),
    [anon_sym_sealed] = ACTIONS(4735),
    [anon_sym_virtual] = ACTIONS(4735),
    [anon_sym_volatile] = ACTIONS(4735),
    [anon_sym_where] = ACTIONS(4735),
    [anon_sym_notnull] = ACTIONS(4735),
    [anon_sym_unmanaged] = ACTIONS(4735),
    [anon_sym_TILDE] = ACTIONS(4737),
    [anon_sym_implicit] = ACTIONS(4735),
    [anon_sym_explicit] = ACTIONS(4735),
    [anon_sym_scoped] = ACTIONS(4735),
    [anon_sym_var] = ACTIONS(4735),
    [sym_predefined_type] = ACTIONS(4735),
    [anon_sym_yield] = ACTIONS(4735),
    [anon_sym_when] = ACTIONS(4735),
    [anon_sym_from] = ACTIONS(4735),
    [anon_sym_into] = ACTIONS(4735),
    [anon_sym_join] = ACTIONS(4735),
    [anon_sym_on] = ACTIONS(4735),
    [anon_sym_equals] = ACTIONS(4735),
    [anon_sym_let] = ACTIONS(4735),
    [anon_sym_orderby] = ACTIONS(4735),
    [anon_sym_ascending] = ACTIONS(4735),
    [anon_sym_descending] = ACTIONS(4735),
    [anon_sym_group] = ACTIONS(4735),
    [anon_sym_by] = ACTIONS(4735),
    [anon_sym_select] = ACTIONS(4735),
    [aux_sym_preproc_if_token1] = ACTIONS(4737),
    [aux_sym_preproc_if_token3] = ACTIONS(4737),
    [aux_sym_preproc_else_token1] = ACTIONS(4737),
    [aux_sym_preproc_elif_token1] = ACTIONS(4737),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3201] = {
    [sym_preproc_region] = STATE(3201),
    [sym_preproc_endregion] = STATE(3201),
    [sym_preproc_line] = STATE(3201),
    [sym_preproc_pragma] = STATE(3201),
    [sym_preproc_nullable] = STATE(3201),
    [sym_preproc_error] = STATE(3201),
    [sym_preproc_define] = STATE(3201),
    [sym_preproc_undef] = STATE(3201),
    [anon_sym_SEMI] = ACTIONS(4111),
    [anon_sym_EQ] = ACTIONS(4104),
    [anon_sym_LBRACK] = ACTIONS(4111),
    [anon_sym_COLON] = ACTIONS(4111),
    [anon_sym_COMMA] = ACTIONS(4111),
    [anon_sym_RBRACK] = ACTIONS(4111),
    [anon_sym_LPAREN] = ACTIONS(4111),
    [anon_sym_RPAREN] = ACTIONS(4111),
    [anon_sym_RBRACE] = ACTIONS(4111),
    [anon_sym_LT] = ACTIONS(4104),
    [anon_sym_GT] = ACTIONS(4104),
    [anon_sym_in] = ACTIONS(4104),
    [anon_sym_QMARK] = ACTIONS(4104),
    [anon_sym_BANG] = ACTIONS(4104),
    [anon_sym_PLUS_PLUS] = ACTIONS(4111),
    [anon_sym_DASH_DASH] = ACTIONS(4111),
    [anon_sym_PLUS] = ACTIONS(4104),
    [anon_sym_DASH] = ACTIONS(4104),
    [anon_sym_STAR] = ACTIONS(4104),
    [anon_sym_SLASH] = ACTIONS(4104),
    [anon_sym_PERCENT] = ACTIONS(4104),
    [anon_sym_CARET] = ACTIONS(4104),
    [anon_sym_PIPE] = ACTIONS(4104),
    [anon_sym_AMP] = ACTIONS(4104),
    [anon_sym_LT_LT] = ACTIONS(4104),
    [anon_sym_GT_GT] = ACTIONS(4104),
    [anon_sym_GT_GT_GT] = ACTIONS(4104),
    [anon_sym_EQ_EQ] = ACTIONS(4111),
    [anon_sym_BANG_EQ] = ACTIONS(4111),
    [anon_sym_GT_EQ] = ACTIONS(4111),
    [anon_sym_LT_EQ] = ACTIONS(4111),
    [anon_sym_DOT] = ACTIONS(4104),
    [anon_sym_EQ_GT] = ACTIONS(4111),
    [anon_sym_switch] = ACTIONS(4111),
    [anon_sym_when] = ACTIONS(4111),
    [anon_sym_DOT_DOT] = ACTIONS(4111),
    [anon_sym_and] = ACTIONS(4111),
    [anon_sym_or] = ACTIONS(4111),
    [anon_sym_PLUS_EQ] = ACTIONS(4111),
    [anon_sym_DASH_EQ] = ACTIONS(4111),
    [anon_sym_STAR_EQ] = ACTIONS(4111),
    [anon_sym_SLASH_EQ] = ACTIONS(4111),
    [anon_sym_PERCENT_EQ] = ACTIONS(4111),
    [anon_sym_AMP_EQ] = ACTIONS(4111),
    [anon_sym_CARET_EQ] = ACTIONS(4111),
    [anon_sym_PIPE_EQ] = ACTIONS(4111),
    [anon_sym_LT_LT_EQ] = ACTIONS(4111),
    [anon_sym_GT_GT_EQ] = ACTIONS(4111),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4111),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4111),
    [anon_sym_AMP_AMP] = ACTIONS(4111),
    [anon_sym_PIPE_PIPE] = ACTIONS(4111),
    [anon_sym_QMARK_QMARK] = ACTIONS(4104),
    [anon_sym_into] = ACTIONS(4111),
    [anon_sym_on] = ACTIONS(4111),
    [anon_sym_equals] = ACTIONS(4111),
    [anon_sym_by] = ACTIONS(4111),
    [anon_sym_as] = ACTIONS(4111),
    [anon_sym_is] = ACTIONS(4111),
    [anon_sym_DASH_GT] = ACTIONS(4111),
    [anon_sym_with] = ACTIONS(4111),
    [aux_sym_preproc_if_token3] = ACTIONS(4111),
    [aux_sym_preproc_else_token1] = ACTIONS(4111),
    [aux_sym_preproc_elif_token1] = ACTIONS(4111),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3202] = {
    [sym_preproc_region] = STATE(3202),
    [sym_preproc_endregion] = STATE(3202),
    [sym_preproc_line] = STATE(3202),
    [sym_preproc_pragma] = STATE(3202),
    [sym_preproc_nullable] = STATE(3202),
    [sym_preproc_error] = STATE(3202),
    [sym_preproc_define] = STATE(3202),
    [sym_preproc_undef] = STATE(3202),
    [anon_sym_SEMI] = ACTIONS(4739),
    [anon_sym_EQ] = ACTIONS(4118),
    [anon_sym_LBRACK] = ACTIONS(4741),
    [anon_sym_COLON] = ACTIONS(4739),
    [anon_sym_COMMA] = ACTIONS(4739),
    [anon_sym_RBRACK] = ACTIONS(4739),
    [anon_sym_LPAREN] = ACTIONS(4741),
    [anon_sym_RPAREN] = ACTIONS(4739),
    [anon_sym_RBRACE] = ACTIONS(4739),
    [anon_sym_LT] = ACTIONS(4744),
    [anon_sym_GT] = ACTIONS(4744),
    [anon_sym_in] = ACTIONS(4747),
    [anon_sym_QMARK] = ACTIONS(4744),
    [anon_sym_BANG] = ACTIONS(4744),
    [anon_sym_PLUS_PLUS] = ACTIONS(4741),
    [anon_sym_DASH_DASH] = ACTIONS(4741),
    [anon_sym_PLUS] = ACTIONS(4744),
    [anon_sym_DASH] = ACTIONS(4744),
    [anon_sym_STAR] = ACTIONS(4744),
    [anon_sym_SLASH] = ACTIONS(4744),
    [anon_sym_PERCENT] = ACTIONS(4744),
    [anon_sym_CARET] = ACTIONS(4744),
    [anon_sym_PIPE] = ACTIONS(4744),
    [anon_sym_AMP] = ACTIONS(4744),
    [anon_sym_LT_LT] = ACTIONS(4744),
    [anon_sym_GT_GT] = ACTIONS(4744),
    [anon_sym_GT_GT_GT] = ACTIONS(4744),
    [anon_sym_EQ_EQ] = ACTIONS(4741),
    [anon_sym_BANG_EQ] = ACTIONS(4741),
    [anon_sym_GT_EQ] = ACTIONS(4741),
    [anon_sym_LT_EQ] = ACTIONS(4741),
    [anon_sym_DOT] = ACTIONS(4744),
    [anon_sym_EQ_GT] = ACTIONS(4739),
    [anon_sym_switch] = ACTIONS(4741),
    [anon_sym_when] = ACTIONS(4739),
    [anon_sym_DOT_DOT] = ACTIONS(4741),
    [anon_sym_and] = ACTIONS(4739),
    [anon_sym_or] = ACTIONS(4739),
    [anon_sym_PLUS_EQ] = ACTIONS(4133),
    [anon_sym_DASH_EQ] = ACTIONS(4133),
    [anon_sym_STAR_EQ] = ACTIONS(4133),
    [anon_sym_SLASH_EQ] = ACTIONS(4133),
    [anon_sym_PERCENT_EQ] = ACTIONS(4133),
    [anon_sym_AMP_EQ] = ACTIONS(4133),
    [anon_sym_CARET_EQ] = ACTIONS(4133),
    [anon_sym_PIPE_EQ] = ACTIONS(4133),
    [anon_sym_LT_LT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4133),
    [anon_sym_AMP_AMP] = ACTIONS(4741),
    [anon_sym_PIPE_PIPE] = ACTIONS(4741),
    [anon_sym_QMARK_QMARK] = ACTIONS(4744),
    [anon_sym_into] = ACTIONS(4739),
    [anon_sym_on] = ACTIONS(4739),
    [anon_sym_equals] = ACTIONS(4739),
    [anon_sym_by] = ACTIONS(4739),
    [anon_sym_as] = ACTIONS(4741),
    [anon_sym_is] = ACTIONS(4741),
    [anon_sym_DASH_GT] = ACTIONS(4741),
    [anon_sym_with] = ACTIONS(4741),
    [aux_sym_preproc_if_token3] = ACTIONS(4739),
    [aux_sym_preproc_else_token1] = ACTIONS(4739),
    [aux_sym_preproc_elif_token1] = ACTIONS(4739),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3203] = {
    [sym_type_argument_list] = STATE(3317),
    [sym_preproc_region] = STATE(3203),
    [sym_preproc_endregion] = STATE(3203),
    [sym_preproc_line] = STATE(3203),
    [sym_preproc_pragma] = STATE(3203),
    [sym_preproc_nullable] = STATE(3203),
    [sym_preproc_error] = STATE(3203),
    [sym_preproc_define] = STATE(3203),
    [sym_preproc_undef] = STATE(3203),
    [sym__identifier_token] = ACTIONS(4074),
    [anon_sym_alias] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4076),
    [anon_sym_COLON] = ACTIONS(4076),
    [anon_sym_COMMA] = ACTIONS(4076),
    [anon_sym_LPAREN] = ACTIONS(4076),
    [anon_sym_LBRACE] = ACTIONS(4076),
    [anon_sym_file] = ACTIONS(4074),
    [anon_sym_LT] = ACTIONS(4689),
    [anon_sym_GT] = ACTIONS(4074),
    [anon_sym_where] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(4074),
    [anon_sym_notnull] = ACTIONS(4074),
    [anon_sym_unmanaged] = ACTIONS(4074),
    [anon_sym_BANG] = ACTIONS(4074),
    [anon_sym_PLUS_PLUS] = ACTIONS(4076),
    [anon_sym_DASH_DASH] = ACTIONS(4076),
    [anon_sym_PLUS] = ACTIONS(4074),
    [anon_sym_DASH] = ACTIONS(4074),
    [anon_sym_STAR] = ACTIONS(4076),
    [anon_sym_SLASH] = ACTIONS(4074),
    [anon_sym_PERCENT] = ACTIONS(4076),
    [anon_sym_CARET] = ACTIONS(4076),
    [anon_sym_PIPE] = ACTIONS(4074),
    [anon_sym_AMP] = ACTIONS(4074),
    [anon_sym_LT_LT] = ACTIONS(4076),
    [anon_sym_GT_GT] = ACTIONS(4074),
    [anon_sym_GT_GT_GT] = ACTIONS(4076),
    [anon_sym_EQ_EQ] = ACTIONS(4076),
    [anon_sym_BANG_EQ] = ACTIONS(4076),
    [anon_sym_GT_EQ] = ACTIONS(4076),
    [anon_sym_LT_EQ] = ACTIONS(4076),
    [anon_sym_DOT] = ACTIONS(4074),
    [anon_sym_scoped] = ACTIONS(4074),
    [anon_sym_var] = ACTIONS(4074),
    [anon_sym_yield] = ACTIONS(4074),
    [anon_sym_switch] = ACTIONS(4074),
    [anon_sym_when] = ACTIONS(4074),
    [sym_discard] = ACTIONS(4074),
    [anon_sym_DOT_DOT] = ACTIONS(4076),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_AMP_AMP] = ACTIONS(4076),
    [anon_sym_PIPE_PIPE] = ACTIONS(4076),
    [anon_sym_QMARK_QMARK] = ACTIONS(4076),
    [anon_sym_from] = ACTIONS(4074),
    [anon_sym_into] = ACTIONS(4074),
    [anon_sym_join] = ACTIONS(4074),
    [anon_sym_on] = ACTIONS(4074),
    [anon_sym_equals] = ACTIONS(4074),
    [anon_sym_let] = ACTIONS(4074),
    [anon_sym_orderby] = ACTIONS(4074),
    [anon_sym_ascending] = ACTIONS(4074),
    [anon_sym_descending] = ACTIONS(4074),
    [anon_sym_group] = ACTIONS(4074),
    [anon_sym_by] = ACTIONS(4074),
    [anon_sym_select] = ACTIONS(4074),
    [anon_sym_as] = ACTIONS(4074),
    [anon_sym_is] = ACTIONS(4074),
    [anon_sym_DASH_GT] = ACTIONS(4076),
    [anon_sym_with] = ACTIONS(4074),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4076),
  },
  [3204] = {
    [sym_type_argument_list] = STATE(3353),
    [sym_preproc_region] = STATE(3204),
    [sym_preproc_endregion] = STATE(3204),
    [sym_preproc_line] = STATE(3204),
    [sym_preproc_pragma] = STATE(3204),
    [sym_preproc_nullable] = STATE(3204),
    [sym_preproc_error] = STATE(3204),
    [sym_preproc_define] = STATE(3204),
    [sym_preproc_undef] = STATE(3204),
    [anon_sym_SEMI] = ACTIONS(4076),
    [anon_sym_EQ] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4076),
    [anon_sym_COLON] = ACTIONS(4076),
    [anon_sym_COMMA] = ACTIONS(4076),
    [anon_sym_RBRACK] = ACTIONS(4076),
    [anon_sym_LPAREN] = ACTIONS(4076),
    [anon_sym_RPAREN] = ACTIONS(4076),
    [anon_sym_RBRACE] = ACTIONS(4076),
    [anon_sym_LT] = ACTIONS(4749),
    [anon_sym_GT] = ACTIONS(4074),
    [anon_sym_in] = ACTIONS(4076),
    [anon_sym_QMARK] = ACTIONS(4074),
    [anon_sym_BANG] = ACTIONS(4074),
    [anon_sym_PLUS_PLUS] = ACTIONS(4076),
    [anon_sym_DASH_DASH] = ACTIONS(4076),
    [anon_sym_PLUS] = ACTIONS(4074),
    [anon_sym_DASH] = ACTIONS(4074),
    [anon_sym_STAR] = ACTIONS(4074),
    [anon_sym_SLASH] = ACTIONS(4074),
    [anon_sym_PERCENT] = ACTIONS(4074),
    [anon_sym_CARET] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(4074),
    [anon_sym_AMP] = ACTIONS(4074),
    [anon_sym_LT_LT] = ACTIONS(4074),
    [anon_sym_GT_GT] = ACTIONS(4074),
    [anon_sym_GT_GT_GT] = ACTIONS(4074),
    [anon_sym_EQ_EQ] = ACTIONS(4076),
    [anon_sym_BANG_EQ] = ACTIONS(4076),
    [anon_sym_GT_EQ] = ACTIONS(4076),
    [anon_sym_LT_EQ] = ACTIONS(4076),
    [anon_sym_DOT] = ACTIONS(4074),
    [anon_sym_EQ_GT] = ACTIONS(4076),
    [anon_sym_switch] = ACTIONS(4076),
    [anon_sym_when] = ACTIONS(4076),
    [anon_sym_DOT_DOT] = ACTIONS(4076),
    [anon_sym_and] = ACTIONS(4076),
    [anon_sym_or] = ACTIONS(4076),
    [anon_sym_PLUS_EQ] = ACTIONS(4076),
    [anon_sym_DASH_EQ] = ACTIONS(4076),
    [anon_sym_STAR_EQ] = ACTIONS(4076),
    [anon_sym_SLASH_EQ] = ACTIONS(4076),
    [anon_sym_PERCENT_EQ] = ACTIONS(4076),
    [anon_sym_AMP_EQ] = ACTIONS(4076),
    [anon_sym_CARET_EQ] = ACTIONS(4076),
    [anon_sym_PIPE_EQ] = ACTIONS(4076),
    [anon_sym_LT_LT_EQ] = ACTIONS(4076),
    [anon_sym_GT_GT_EQ] = ACTIONS(4076),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4076),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4076),
    [anon_sym_AMP_AMP] = ACTIONS(4076),
    [anon_sym_PIPE_PIPE] = ACTIONS(4076),
    [anon_sym_QMARK_QMARK] = ACTIONS(4074),
    [anon_sym_on] = ACTIONS(4076),
    [anon_sym_equals] = ACTIONS(4076),
    [anon_sym_by] = ACTIONS(4076),
    [anon_sym_as] = ACTIONS(4076),
    [anon_sym_is] = ACTIONS(4076),
    [anon_sym_DASH_GT] = ACTIONS(4076),
    [anon_sym_with] = ACTIONS(4076),
    [aux_sym_preproc_if_token3] = ACTIONS(4076),
    [aux_sym_preproc_else_token1] = ACTIONS(4076),
    [aux_sym_preproc_elif_token1] = ACTIONS(4076),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3205] = {
    [sym_preproc_region] = STATE(3205),
    [sym_preproc_endregion] = STATE(3205),
    [sym_preproc_line] = STATE(3205),
    [sym_preproc_pragma] = STATE(3205),
    [sym_preproc_nullable] = STATE(3205),
    [sym_preproc_error] = STATE(3205),
    [sym_preproc_define] = STATE(3205),
    [sym_preproc_undef] = STATE(3205),
    [anon_sym_SEMI] = ACTIONS(4076),
    [anon_sym_EQ] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4076),
    [anon_sym_COLON] = ACTIONS(4076),
    [anon_sym_COMMA] = ACTIONS(4076),
    [anon_sym_RBRACK] = ACTIONS(4076),
    [anon_sym_LPAREN] = ACTIONS(4076),
    [anon_sym_RPAREN] = ACTIONS(4076),
    [anon_sym_RBRACE] = ACTIONS(4076),
    [anon_sym_LT] = ACTIONS(4074),
    [anon_sym_GT] = ACTIONS(4074),
    [anon_sym_in] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(4074),
    [anon_sym_BANG] = ACTIONS(4074),
    [anon_sym_PLUS_PLUS] = ACTIONS(4076),
    [anon_sym_DASH_DASH] = ACTIONS(4076),
    [anon_sym_PLUS] = ACTIONS(4074),
    [anon_sym_DASH] = ACTIONS(4074),
    [anon_sym_STAR] = ACTIONS(4074),
    [anon_sym_SLASH] = ACTIONS(4074),
    [anon_sym_PERCENT] = ACTIONS(4074),
    [anon_sym_CARET] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(4074),
    [anon_sym_AMP] = ACTIONS(4074),
    [anon_sym_LT_LT] = ACTIONS(4074),
    [anon_sym_GT_GT] = ACTIONS(4074),
    [anon_sym_GT_GT_GT] = ACTIONS(4074),
    [anon_sym_EQ_EQ] = ACTIONS(4076),
    [anon_sym_BANG_EQ] = ACTIONS(4076),
    [anon_sym_GT_EQ] = ACTIONS(4076),
    [anon_sym_LT_EQ] = ACTIONS(4076),
    [anon_sym_DOT] = ACTIONS(4074),
    [anon_sym_EQ_GT] = ACTIONS(4076),
    [anon_sym_switch] = ACTIONS(4076),
    [anon_sym_when] = ACTIONS(4076),
    [anon_sym_DOT_DOT] = ACTIONS(4076),
    [anon_sym_and] = ACTIONS(4076),
    [anon_sym_or] = ACTIONS(4076),
    [anon_sym_PLUS_EQ] = ACTIONS(4076),
    [anon_sym_DASH_EQ] = ACTIONS(4076),
    [anon_sym_STAR_EQ] = ACTIONS(4076),
    [anon_sym_SLASH_EQ] = ACTIONS(4076),
    [anon_sym_PERCENT_EQ] = ACTIONS(4076),
    [anon_sym_AMP_EQ] = ACTIONS(4076),
    [anon_sym_CARET_EQ] = ACTIONS(4076),
    [anon_sym_PIPE_EQ] = ACTIONS(4076),
    [anon_sym_LT_LT_EQ] = ACTIONS(4076),
    [anon_sym_GT_GT_EQ] = ACTIONS(4076),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4076),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4076),
    [anon_sym_AMP_AMP] = ACTIONS(4076),
    [anon_sym_PIPE_PIPE] = ACTIONS(4076),
    [anon_sym_QMARK_QMARK] = ACTIONS(4074),
    [anon_sym_into] = ACTIONS(4076),
    [anon_sym_on] = ACTIONS(4076),
    [anon_sym_equals] = ACTIONS(4076),
    [anon_sym_by] = ACTIONS(4076),
    [anon_sym_as] = ACTIONS(4076),
    [anon_sym_is] = ACTIONS(4076),
    [anon_sym_DASH_GT] = ACTIONS(4076),
    [anon_sym_with] = ACTIONS(4076),
    [aux_sym_preproc_if_token3] = ACTIONS(4076),
    [aux_sym_preproc_else_token1] = ACTIONS(4076),
    [aux_sym_preproc_elif_token1] = ACTIONS(4076),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3206] = {
    [sym_preproc_region] = STATE(3206),
    [sym_preproc_endregion] = STATE(3206),
    [sym_preproc_line] = STATE(3206),
    [sym_preproc_pragma] = STATE(3206),
    [sym_preproc_nullable] = STATE(3206),
    [sym_preproc_error] = STATE(3206),
    [sym_preproc_define] = STATE(3206),
    [sym_preproc_undef] = STATE(3206),
    [anon_sym_SEMI] = ACTIONS(4635),
    [anon_sym_EQ] = ACTIONS(4637),
    [anon_sym_LBRACK] = ACTIONS(4635),
    [anon_sym_COLON] = ACTIONS(4635),
    [anon_sym_COMMA] = ACTIONS(4635),
    [anon_sym_RBRACK] = ACTIONS(4635),
    [anon_sym_LPAREN] = ACTIONS(4635),
    [anon_sym_RPAREN] = ACTIONS(4635),
    [anon_sym_RBRACE] = ACTIONS(4635),
    [anon_sym_LT] = ACTIONS(4637),
    [anon_sym_GT] = ACTIONS(4637),
    [anon_sym_in] = ACTIONS(4637),
    [anon_sym_QMARK] = ACTIONS(4637),
    [anon_sym_BANG] = ACTIONS(4637),
    [anon_sym_PLUS_PLUS] = ACTIONS(4635),
    [anon_sym_DASH_DASH] = ACTIONS(4635),
    [anon_sym_PLUS] = ACTIONS(4637),
    [anon_sym_DASH] = ACTIONS(4637),
    [anon_sym_STAR] = ACTIONS(4637),
    [anon_sym_SLASH] = ACTIONS(4637),
    [anon_sym_PERCENT] = ACTIONS(4637),
    [anon_sym_CARET] = ACTIONS(4637),
    [anon_sym_PIPE] = ACTIONS(4637),
    [anon_sym_AMP] = ACTIONS(4637),
    [anon_sym_LT_LT] = ACTIONS(4637),
    [anon_sym_GT_GT] = ACTIONS(4637),
    [anon_sym_GT_GT_GT] = ACTIONS(4637),
    [anon_sym_EQ_EQ] = ACTIONS(4635),
    [anon_sym_BANG_EQ] = ACTIONS(4635),
    [anon_sym_GT_EQ] = ACTIONS(4635),
    [anon_sym_LT_EQ] = ACTIONS(4635),
    [anon_sym_DOT] = ACTIONS(4637),
    [anon_sym_EQ_GT] = ACTIONS(4635),
    [anon_sym_switch] = ACTIONS(4635),
    [anon_sym_when] = ACTIONS(4635),
    [anon_sym_DOT_DOT] = ACTIONS(4635),
    [anon_sym_and] = ACTIONS(4635),
    [anon_sym_or] = ACTIONS(4635),
    [anon_sym_PLUS_EQ] = ACTIONS(4635),
    [anon_sym_DASH_EQ] = ACTIONS(4635),
    [anon_sym_STAR_EQ] = ACTIONS(4635),
    [anon_sym_SLASH_EQ] = ACTIONS(4635),
    [anon_sym_PERCENT_EQ] = ACTIONS(4635),
    [anon_sym_AMP_EQ] = ACTIONS(4635),
    [anon_sym_CARET_EQ] = ACTIONS(4635),
    [anon_sym_PIPE_EQ] = ACTIONS(4635),
    [anon_sym_LT_LT_EQ] = ACTIONS(4635),
    [anon_sym_GT_GT_EQ] = ACTIONS(4635),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4635),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4635),
    [anon_sym_AMP_AMP] = ACTIONS(4635),
    [anon_sym_PIPE_PIPE] = ACTIONS(4635),
    [anon_sym_QMARK_QMARK] = ACTIONS(4637),
    [anon_sym_into] = ACTIONS(4635),
    [anon_sym_on] = ACTIONS(4635),
    [anon_sym_equals] = ACTIONS(4635),
    [anon_sym_by] = ACTIONS(4635),
    [anon_sym_as] = ACTIONS(4635),
    [anon_sym_is] = ACTIONS(4635),
    [anon_sym_DASH_GT] = ACTIONS(4635),
    [anon_sym_with] = ACTIONS(4635),
    [aux_sym_preproc_if_token3] = ACTIONS(4635),
    [aux_sym_preproc_else_token1] = ACTIONS(4635),
    [aux_sym_preproc_elif_token1] = ACTIONS(4635),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3207] = {
    [sym_preproc_region] = STATE(3207),
    [sym_preproc_endregion] = STATE(3207),
    [sym_preproc_line] = STATE(3207),
    [sym_preproc_pragma] = STATE(3207),
    [sym_preproc_nullable] = STATE(3207),
    [sym_preproc_error] = STATE(3207),
    [sym_preproc_define] = STATE(3207),
    [sym_preproc_undef] = STATE(3207),
    [anon_sym_SEMI] = ACTIONS(4068),
    [anon_sym_EQ] = ACTIONS(4066),
    [anon_sym_LBRACK] = ACTIONS(4068),
    [anon_sym_COLON] = ACTIONS(4068),
    [anon_sym_COMMA] = ACTIONS(4068),
    [anon_sym_RBRACK] = ACTIONS(4068),
    [anon_sym_LPAREN] = ACTIONS(4068),
    [anon_sym_RPAREN] = ACTIONS(4068),
    [anon_sym_RBRACE] = ACTIONS(4068),
    [anon_sym_LT] = ACTIONS(4066),
    [anon_sym_GT] = ACTIONS(4066),
    [anon_sym_in] = ACTIONS(4066),
    [anon_sym_QMARK] = ACTIONS(4066),
    [anon_sym_BANG] = ACTIONS(4066),
    [anon_sym_PLUS_PLUS] = ACTIONS(4068),
    [anon_sym_DASH_DASH] = ACTIONS(4068),
    [anon_sym_PLUS] = ACTIONS(4066),
    [anon_sym_DASH] = ACTIONS(4066),
    [anon_sym_STAR] = ACTIONS(4066),
    [anon_sym_SLASH] = ACTIONS(4066),
    [anon_sym_PERCENT] = ACTIONS(4066),
    [anon_sym_CARET] = ACTIONS(4066),
    [anon_sym_PIPE] = ACTIONS(4066),
    [anon_sym_AMP] = ACTIONS(4066),
    [anon_sym_LT_LT] = ACTIONS(4066),
    [anon_sym_GT_GT] = ACTIONS(4066),
    [anon_sym_GT_GT_GT] = ACTIONS(4066),
    [anon_sym_EQ_EQ] = ACTIONS(4068),
    [anon_sym_BANG_EQ] = ACTIONS(4068),
    [anon_sym_GT_EQ] = ACTIONS(4068),
    [anon_sym_LT_EQ] = ACTIONS(4068),
    [anon_sym_DOT] = ACTIONS(4066),
    [anon_sym_EQ_GT] = ACTIONS(4068),
    [anon_sym_switch] = ACTIONS(4068),
    [anon_sym_when] = ACTIONS(4068),
    [anon_sym_DOT_DOT] = ACTIONS(4068),
    [anon_sym_and] = ACTIONS(4068),
    [anon_sym_or] = ACTIONS(4068),
    [anon_sym_PLUS_EQ] = ACTIONS(4068),
    [anon_sym_DASH_EQ] = ACTIONS(4068),
    [anon_sym_STAR_EQ] = ACTIONS(4068),
    [anon_sym_SLASH_EQ] = ACTIONS(4068),
    [anon_sym_PERCENT_EQ] = ACTIONS(4068),
    [anon_sym_AMP_EQ] = ACTIONS(4068),
    [anon_sym_CARET_EQ] = ACTIONS(4068),
    [anon_sym_PIPE_EQ] = ACTIONS(4068),
    [anon_sym_LT_LT_EQ] = ACTIONS(4068),
    [anon_sym_GT_GT_EQ] = ACTIONS(4068),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4068),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4068),
    [anon_sym_AMP_AMP] = ACTIONS(4068),
    [anon_sym_PIPE_PIPE] = ACTIONS(4068),
    [anon_sym_QMARK_QMARK] = ACTIONS(4066),
    [anon_sym_into] = ACTIONS(4068),
    [anon_sym_on] = ACTIONS(4068),
    [anon_sym_equals] = ACTIONS(4068),
    [anon_sym_by] = ACTIONS(4068),
    [anon_sym_as] = ACTIONS(4068),
    [anon_sym_is] = ACTIONS(4068),
    [anon_sym_DASH_GT] = ACTIONS(4068),
    [anon_sym_with] = ACTIONS(4068),
    [aux_sym_preproc_if_token3] = ACTIONS(4068),
    [aux_sym_preproc_else_token1] = ACTIONS(4068),
    [aux_sym_preproc_elif_token1] = ACTIONS(4068),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3208] = {
    [sym_preproc_region] = STATE(3208),
    [sym_preproc_endregion] = STATE(3208),
    [sym_preproc_line] = STATE(3208),
    [sym_preproc_pragma] = STATE(3208),
    [sym_preproc_nullable] = STATE(3208),
    [sym_preproc_error] = STATE(3208),
    [sym_preproc_define] = STATE(3208),
    [sym_preproc_undef] = STATE(3208),
    [sym__identifier_token] = ACTIONS(4752),
    [anon_sym_extern] = ACTIONS(4752),
    [anon_sym_alias] = ACTIONS(4752),
    [anon_sym_global] = ACTIONS(4752),
    [anon_sym_using] = ACTIONS(4752),
    [anon_sym_unsafe] = ACTIONS(4752),
    [anon_sym_EQ] = ACTIONS(4754),
    [anon_sym_static] = ACTIONS(4752),
    [anon_sym_LBRACK] = ACTIONS(4756),
    [anon_sym_LPAREN] = ACTIONS(4756),
    [anon_sym_event] = ACTIONS(4752),
    [anon_sym_namespace] = ACTIONS(4752),
    [anon_sym_class] = ACTIONS(4752),
    [anon_sym_ref] = ACTIONS(4752),
    [anon_sym_struct] = ACTIONS(4752),
    [anon_sym_enum] = ACTIONS(4752),
    [anon_sym_RBRACE] = ACTIONS(4756),
    [anon_sym_interface] = ACTIONS(4752),
    [anon_sym_delegate] = ACTIONS(4752),
    [anon_sym_record] = ACTIONS(4752),
    [anon_sym_abstract] = ACTIONS(4752),
    [anon_sym_async] = ACTIONS(4752),
    [anon_sym_const] = ACTIONS(4752),
    [anon_sym_file] = ACTIONS(4752),
    [anon_sym_fixed] = ACTIONS(4752),
    [anon_sym_internal] = ACTIONS(4752),
    [anon_sym_new] = ACTIONS(4752),
    [anon_sym_override] = ACTIONS(4752),
    [anon_sym_partial] = ACTIONS(4752),
    [anon_sym_private] = ACTIONS(4752),
    [anon_sym_protected] = ACTIONS(4752),
    [anon_sym_public] = ACTIONS(4752),
    [anon_sym_readonly] = ACTIONS(4752),
    [anon_sym_required] = ACTIONS(4752),
    [anon_sym_sealed] = ACTIONS(4752),
    [anon_sym_virtual] = ACTIONS(4752),
    [anon_sym_volatile] = ACTIONS(4752),
    [anon_sym_where] = ACTIONS(4752),
    [anon_sym_notnull] = ACTIONS(4752),
    [anon_sym_unmanaged] = ACTIONS(4752),
    [anon_sym_TILDE] = ACTIONS(4756),
    [anon_sym_implicit] = ACTIONS(4752),
    [anon_sym_explicit] = ACTIONS(4752),
    [anon_sym_scoped] = ACTIONS(4752),
    [anon_sym_var] = ACTIONS(4752),
    [sym_predefined_type] = ACTIONS(4752),
    [anon_sym_yield] = ACTIONS(4752),
    [anon_sym_when] = ACTIONS(4752),
    [anon_sym_from] = ACTIONS(4752),
    [anon_sym_into] = ACTIONS(4752),
    [anon_sym_join] = ACTIONS(4752),
    [anon_sym_on] = ACTIONS(4752),
    [anon_sym_equals] = ACTIONS(4752),
    [anon_sym_let] = ACTIONS(4752),
    [anon_sym_orderby] = ACTIONS(4752),
    [anon_sym_ascending] = ACTIONS(4752),
    [anon_sym_descending] = ACTIONS(4752),
    [anon_sym_group] = ACTIONS(4752),
    [anon_sym_by] = ACTIONS(4752),
    [anon_sym_select] = ACTIONS(4752),
    [aux_sym_preproc_if_token1] = ACTIONS(4756),
    [aux_sym_preproc_if_token3] = ACTIONS(4756),
    [aux_sym_preproc_else_token1] = ACTIONS(4756),
    [aux_sym_preproc_elif_token1] = ACTIONS(4756),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3209] = {
    [sym_preproc_region] = STATE(3209),
    [sym_preproc_endregion] = STATE(3209),
    [sym_preproc_line] = STATE(3209),
    [sym_preproc_pragma] = STATE(3209),
    [sym_preproc_nullable] = STATE(3209),
    [sym_preproc_error] = STATE(3209),
    [sym_preproc_define] = STATE(3209),
    [sym_preproc_undef] = STATE(3209),
    [anon_sym_SEMI] = ACTIONS(4615),
    [anon_sym_EQ] = ACTIONS(4617),
    [anon_sym_LBRACK] = ACTIONS(4615),
    [anon_sym_COLON] = ACTIONS(4615),
    [anon_sym_COMMA] = ACTIONS(4615),
    [anon_sym_RBRACK] = ACTIONS(4615),
    [anon_sym_LPAREN] = ACTIONS(4615),
    [anon_sym_RPAREN] = ACTIONS(4615),
    [anon_sym_RBRACE] = ACTIONS(4615),
    [anon_sym_LT] = ACTIONS(4617),
    [anon_sym_GT] = ACTIONS(4617),
    [anon_sym_in] = ACTIONS(4617),
    [anon_sym_QMARK] = ACTIONS(4617),
    [anon_sym_BANG] = ACTIONS(4617),
    [anon_sym_PLUS_PLUS] = ACTIONS(4615),
    [anon_sym_DASH_DASH] = ACTIONS(4615),
    [anon_sym_PLUS] = ACTIONS(4617),
    [anon_sym_DASH] = ACTIONS(4617),
    [anon_sym_STAR] = ACTIONS(4617),
    [anon_sym_SLASH] = ACTIONS(4617),
    [anon_sym_PERCENT] = ACTIONS(4617),
    [anon_sym_CARET] = ACTIONS(4617),
    [anon_sym_PIPE] = ACTIONS(4617),
    [anon_sym_AMP] = ACTIONS(4617),
    [anon_sym_LT_LT] = ACTIONS(4617),
    [anon_sym_GT_GT] = ACTIONS(4617),
    [anon_sym_GT_GT_GT] = ACTIONS(4617),
    [anon_sym_EQ_EQ] = ACTIONS(4615),
    [anon_sym_BANG_EQ] = ACTIONS(4615),
    [anon_sym_GT_EQ] = ACTIONS(4615),
    [anon_sym_LT_EQ] = ACTIONS(4615),
    [anon_sym_DOT] = ACTIONS(4617),
    [anon_sym_EQ_GT] = ACTIONS(4615),
    [anon_sym_switch] = ACTIONS(4615),
    [anon_sym_when] = ACTIONS(4615),
    [anon_sym_DOT_DOT] = ACTIONS(4615),
    [anon_sym_and] = ACTIONS(4615),
    [anon_sym_or] = ACTIONS(4615),
    [anon_sym_PLUS_EQ] = ACTIONS(4615),
    [anon_sym_DASH_EQ] = ACTIONS(4615),
    [anon_sym_STAR_EQ] = ACTIONS(4615),
    [anon_sym_SLASH_EQ] = ACTIONS(4615),
    [anon_sym_PERCENT_EQ] = ACTIONS(4615),
    [anon_sym_AMP_EQ] = ACTIONS(4615),
    [anon_sym_CARET_EQ] = ACTIONS(4615),
    [anon_sym_PIPE_EQ] = ACTIONS(4615),
    [anon_sym_LT_LT_EQ] = ACTIONS(4615),
    [anon_sym_GT_GT_EQ] = ACTIONS(4615),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4615),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4615),
    [anon_sym_AMP_AMP] = ACTIONS(4615),
    [anon_sym_PIPE_PIPE] = ACTIONS(4615),
    [anon_sym_QMARK_QMARK] = ACTIONS(4617),
    [anon_sym_into] = ACTIONS(4615),
    [anon_sym_on] = ACTIONS(4615),
    [anon_sym_equals] = ACTIONS(4615),
    [anon_sym_by] = ACTIONS(4615),
    [anon_sym_as] = ACTIONS(4615),
    [anon_sym_is] = ACTIONS(4615),
    [anon_sym_DASH_GT] = ACTIONS(4615),
    [anon_sym_with] = ACTIONS(4615),
    [aux_sym_preproc_if_token3] = ACTIONS(4615),
    [aux_sym_preproc_else_token1] = ACTIONS(4615),
    [aux_sym_preproc_elif_token1] = ACTIONS(4615),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3210] = {
    [sym_preproc_region] = STATE(3210),
    [sym_preproc_endregion] = STATE(3210),
    [sym_preproc_line] = STATE(3210),
    [sym_preproc_pragma] = STATE(3210),
    [sym_preproc_nullable] = STATE(3210),
    [sym_preproc_error] = STATE(3210),
    [sym_preproc_define] = STATE(3210),
    [sym_preproc_undef] = STATE(3210),
    [anon_sym_SEMI] = ACTIONS(4087),
    [anon_sym_EQ] = ACTIONS(4085),
    [anon_sym_LBRACK] = ACTIONS(4087),
    [anon_sym_COLON] = ACTIONS(4087),
    [anon_sym_COMMA] = ACTIONS(4087),
    [anon_sym_RBRACK] = ACTIONS(4087),
    [anon_sym_LPAREN] = ACTIONS(4087),
    [anon_sym_RPAREN] = ACTIONS(4087),
    [anon_sym_RBRACE] = ACTIONS(4087),
    [anon_sym_LT] = ACTIONS(4085),
    [anon_sym_GT] = ACTIONS(4085),
    [anon_sym_in] = ACTIONS(4085),
    [anon_sym_QMARK] = ACTIONS(4085),
    [anon_sym_BANG] = ACTIONS(4085),
    [anon_sym_PLUS_PLUS] = ACTIONS(4087),
    [anon_sym_DASH_DASH] = ACTIONS(4087),
    [anon_sym_PLUS] = ACTIONS(4085),
    [anon_sym_DASH] = ACTIONS(4085),
    [anon_sym_STAR] = ACTIONS(4085),
    [anon_sym_SLASH] = ACTIONS(4085),
    [anon_sym_PERCENT] = ACTIONS(4085),
    [anon_sym_CARET] = ACTIONS(4085),
    [anon_sym_PIPE] = ACTIONS(4085),
    [anon_sym_AMP] = ACTIONS(4085),
    [anon_sym_LT_LT] = ACTIONS(4085),
    [anon_sym_GT_GT] = ACTIONS(4085),
    [anon_sym_GT_GT_GT] = ACTIONS(4085),
    [anon_sym_EQ_EQ] = ACTIONS(4087),
    [anon_sym_BANG_EQ] = ACTIONS(4087),
    [anon_sym_GT_EQ] = ACTIONS(4087),
    [anon_sym_LT_EQ] = ACTIONS(4087),
    [anon_sym_DOT] = ACTIONS(4085),
    [anon_sym_EQ_GT] = ACTIONS(4087),
    [anon_sym_switch] = ACTIONS(4087),
    [anon_sym_when] = ACTIONS(4087),
    [anon_sym_DOT_DOT] = ACTIONS(4087),
    [anon_sym_and] = ACTIONS(4087),
    [anon_sym_or] = ACTIONS(4087),
    [anon_sym_PLUS_EQ] = ACTIONS(4087),
    [anon_sym_DASH_EQ] = ACTIONS(4087),
    [anon_sym_STAR_EQ] = ACTIONS(4087),
    [anon_sym_SLASH_EQ] = ACTIONS(4087),
    [anon_sym_PERCENT_EQ] = ACTIONS(4087),
    [anon_sym_AMP_EQ] = ACTIONS(4087),
    [anon_sym_CARET_EQ] = ACTIONS(4087),
    [anon_sym_PIPE_EQ] = ACTIONS(4087),
    [anon_sym_LT_LT_EQ] = ACTIONS(4087),
    [anon_sym_GT_GT_EQ] = ACTIONS(4087),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4087),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4087),
    [anon_sym_AMP_AMP] = ACTIONS(4087),
    [anon_sym_PIPE_PIPE] = ACTIONS(4087),
    [anon_sym_QMARK_QMARK] = ACTIONS(4085),
    [anon_sym_into] = ACTIONS(4087),
    [anon_sym_on] = ACTIONS(4087),
    [anon_sym_equals] = ACTIONS(4087),
    [anon_sym_by] = ACTIONS(4087),
    [anon_sym_as] = ACTIONS(4087),
    [anon_sym_is] = ACTIONS(4087),
    [anon_sym_DASH_GT] = ACTIONS(4087),
    [anon_sym_with] = ACTIONS(4087),
    [aux_sym_preproc_if_token3] = ACTIONS(4087),
    [aux_sym_preproc_else_token1] = ACTIONS(4087),
    [aux_sym_preproc_elif_token1] = ACTIONS(4087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3211] = {
    [sym_preproc_region] = STATE(3211),
    [sym_preproc_endregion] = STATE(3211),
    [sym_preproc_line] = STATE(3211),
    [sym_preproc_pragma] = STATE(3211),
    [sym_preproc_nullable] = STATE(3211),
    [sym_preproc_error] = STATE(3211),
    [sym_preproc_define] = STATE(3211),
    [sym_preproc_undef] = STATE(3211),
    [sym__identifier_token] = ACTIONS(4758),
    [anon_sym_extern] = ACTIONS(4758),
    [anon_sym_alias] = ACTIONS(4758),
    [anon_sym_global] = ACTIONS(4758),
    [anon_sym_using] = ACTIONS(4758),
    [anon_sym_unsafe] = ACTIONS(4758),
    [anon_sym_EQ] = ACTIONS(4760),
    [anon_sym_static] = ACTIONS(4758),
    [anon_sym_LBRACK] = ACTIONS(4762),
    [anon_sym_LPAREN] = ACTIONS(4762),
    [anon_sym_event] = ACTIONS(4758),
    [anon_sym_namespace] = ACTIONS(4758),
    [anon_sym_class] = ACTIONS(4758),
    [anon_sym_ref] = ACTIONS(4758),
    [anon_sym_struct] = ACTIONS(4758),
    [anon_sym_enum] = ACTIONS(4758),
    [anon_sym_RBRACE] = ACTIONS(4762),
    [anon_sym_interface] = ACTIONS(4758),
    [anon_sym_delegate] = ACTIONS(4758),
    [anon_sym_record] = ACTIONS(4758),
    [anon_sym_abstract] = ACTIONS(4758),
    [anon_sym_async] = ACTIONS(4758),
    [anon_sym_const] = ACTIONS(4758),
    [anon_sym_file] = ACTIONS(4758),
    [anon_sym_fixed] = ACTIONS(4758),
    [anon_sym_internal] = ACTIONS(4758),
    [anon_sym_new] = ACTIONS(4758),
    [anon_sym_override] = ACTIONS(4758),
    [anon_sym_partial] = ACTIONS(4758),
    [anon_sym_private] = ACTIONS(4758),
    [anon_sym_protected] = ACTIONS(4758),
    [anon_sym_public] = ACTIONS(4758),
    [anon_sym_readonly] = ACTIONS(4758),
    [anon_sym_required] = ACTIONS(4758),
    [anon_sym_sealed] = ACTIONS(4758),
    [anon_sym_virtual] = ACTIONS(4758),
    [anon_sym_volatile] = ACTIONS(4758),
    [anon_sym_where] = ACTIONS(4758),
    [anon_sym_notnull] = ACTIONS(4758),
    [anon_sym_unmanaged] = ACTIONS(4758),
    [anon_sym_TILDE] = ACTIONS(4762),
    [anon_sym_implicit] = ACTIONS(4758),
    [anon_sym_explicit] = ACTIONS(4758),
    [anon_sym_scoped] = ACTIONS(4758),
    [anon_sym_var] = ACTIONS(4758),
    [sym_predefined_type] = ACTIONS(4758),
    [anon_sym_yield] = ACTIONS(4758),
    [anon_sym_when] = ACTIONS(4758),
    [anon_sym_from] = ACTIONS(4758),
    [anon_sym_into] = ACTIONS(4758),
    [anon_sym_join] = ACTIONS(4758),
    [anon_sym_on] = ACTIONS(4758),
    [anon_sym_equals] = ACTIONS(4758),
    [anon_sym_let] = ACTIONS(4758),
    [anon_sym_orderby] = ACTIONS(4758),
    [anon_sym_ascending] = ACTIONS(4758),
    [anon_sym_descending] = ACTIONS(4758),
    [anon_sym_group] = ACTIONS(4758),
    [anon_sym_by] = ACTIONS(4758),
    [anon_sym_select] = ACTIONS(4758),
    [aux_sym_preproc_if_token1] = ACTIONS(4762),
    [aux_sym_preproc_if_token3] = ACTIONS(4762),
    [aux_sym_preproc_else_token1] = ACTIONS(4762),
    [aux_sym_preproc_elif_token1] = ACTIONS(4762),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3212] = {
    [sym_preproc_region] = STATE(3212),
    [sym_preproc_endregion] = STATE(3212),
    [sym_preproc_line] = STATE(3212),
    [sym_preproc_pragma] = STATE(3212),
    [sym_preproc_nullable] = STATE(3212),
    [sym_preproc_error] = STATE(3212),
    [sym_preproc_define] = STATE(3212),
    [sym_preproc_undef] = STATE(3212),
    [anon_sym_SEMI] = ACTIONS(4072),
    [anon_sym_EQ] = ACTIONS(4070),
    [anon_sym_LBRACK] = ACTIONS(4072),
    [anon_sym_COLON] = ACTIONS(4072),
    [anon_sym_COMMA] = ACTIONS(4072),
    [anon_sym_RBRACK] = ACTIONS(4072),
    [anon_sym_LPAREN] = ACTIONS(4072),
    [anon_sym_RPAREN] = ACTIONS(4072),
    [anon_sym_RBRACE] = ACTIONS(4072),
    [anon_sym_LT] = ACTIONS(4070),
    [anon_sym_GT] = ACTIONS(4070),
    [anon_sym_in] = ACTIONS(4070),
    [anon_sym_QMARK] = ACTIONS(4070),
    [anon_sym_BANG] = ACTIONS(4070),
    [anon_sym_PLUS_PLUS] = ACTIONS(4072),
    [anon_sym_DASH_DASH] = ACTIONS(4072),
    [anon_sym_PLUS] = ACTIONS(4070),
    [anon_sym_DASH] = ACTIONS(4070),
    [anon_sym_STAR] = ACTIONS(4070),
    [anon_sym_SLASH] = ACTIONS(4070),
    [anon_sym_PERCENT] = ACTIONS(4070),
    [anon_sym_CARET] = ACTIONS(4070),
    [anon_sym_PIPE] = ACTIONS(4070),
    [anon_sym_AMP] = ACTIONS(4070),
    [anon_sym_LT_LT] = ACTIONS(4070),
    [anon_sym_GT_GT] = ACTIONS(4070),
    [anon_sym_GT_GT_GT] = ACTIONS(4070),
    [anon_sym_EQ_EQ] = ACTIONS(4072),
    [anon_sym_BANG_EQ] = ACTIONS(4072),
    [anon_sym_GT_EQ] = ACTIONS(4072),
    [anon_sym_LT_EQ] = ACTIONS(4072),
    [anon_sym_DOT] = ACTIONS(4070),
    [anon_sym_EQ_GT] = ACTIONS(4072),
    [anon_sym_switch] = ACTIONS(4072),
    [anon_sym_when] = ACTIONS(4072),
    [anon_sym_DOT_DOT] = ACTIONS(4072),
    [anon_sym_and] = ACTIONS(4072),
    [anon_sym_or] = ACTIONS(4072),
    [anon_sym_PLUS_EQ] = ACTIONS(4072),
    [anon_sym_DASH_EQ] = ACTIONS(4072),
    [anon_sym_STAR_EQ] = ACTIONS(4072),
    [anon_sym_SLASH_EQ] = ACTIONS(4072),
    [anon_sym_PERCENT_EQ] = ACTIONS(4072),
    [anon_sym_AMP_EQ] = ACTIONS(4072),
    [anon_sym_CARET_EQ] = ACTIONS(4072),
    [anon_sym_PIPE_EQ] = ACTIONS(4072),
    [anon_sym_LT_LT_EQ] = ACTIONS(4072),
    [anon_sym_GT_GT_EQ] = ACTIONS(4072),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4072),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4072),
    [anon_sym_AMP_AMP] = ACTIONS(4072),
    [anon_sym_PIPE_PIPE] = ACTIONS(4072),
    [anon_sym_QMARK_QMARK] = ACTIONS(4070),
    [anon_sym_into] = ACTIONS(4072),
    [anon_sym_on] = ACTIONS(4072),
    [anon_sym_equals] = ACTIONS(4072),
    [anon_sym_by] = ACTIONS(4072),
    [anon_sym_as] = ACTIONS(4072),
    [anon_sym_is] = ACTIONS(4072),
    [anon_sym_DASH_GT] = ACTIONS(4072),
    [anon_sym_with] = ACTIONS(4072),
    [aux_sym_preproc_if_token3] = ACTIONS(4072),
    [aux_sym_preproc_else_token1] = ACTIONS(4072),
    [aux_sym_preproc_elif_token1] = ACTIONS(4072),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3213] = {
    [sym_preproc_region] = STATE(3213),
    [sym_preproc_endregion] = STATE(3213),
    [sym_preproc_line] = STATE(3213),
    [sym_preproc_pragma] = STATE(3213),
    [sym_preproc_nullable] = STATE(3213),
    [sym_preproc_error] = STATE(3213),
    [sym_preproc_define] = STATE(3213),
    [sym_preproc_undef] = STATE(3213),
    [sym__identifier_token] = ACTIONS(3792),
    [anon_sym_extern] = ACTIONS(3792),
    [anon_sym_alias] = ACTIONS(3792),
    [anon_sym_global] = ACTIONS(3792),
    [anon_sym_using] = ACTIONS(3792),
    [anon_sym_unsafe] = ACTIONS(3792),
    [anon_sym_static] = ACTIONS(3792),
    [anon_sym_LBRACK] = ACTIONS(3794),
    [anon_sym_LPAREN] = ACTIONS(3794),
    [anon_sym_event] = ACTIONS(3792),
    [anon_sym_namespace] = ACTIONS(3792),
    [anon_sym_class] = ACTIONS(3792),
    [anon_sym_ref] = ACTIONS(3792),
    [anon_sym_struct] = ACTIONS(3792),
    [anon_sym_enum] = ACTIONS(3792),
    [anon_sym_RBRACE] = ACTIONS(3794),
    [anon_sym_interface] = ACTIONS(3792),
    [anon_sym_delegate] = ACTIONS(3792),
    [anon_sym_record] = ACTIONS(3792),
    [anon_sym_abstract] = ACTIONS(3792),
    [anon_sym_async] = ACTIONS(3792),
    [anon_sym_const] = ACTIONS(3792),
    [anon_sym_file] = ACTIONS(3792),
    [anon_sym_fixed] = ACTIONS(3792),
    [anon_sym_internal] = ACTIONS(3792),
    [anon_sym_new] = ACTIONS(3792),
    [anon_sym_override] = ACTIONS(3792),
    [anon_sym_partial] = ACTIONS(3792),
    [anon_sym_private] = ACTIONS(3792),
    [anon_sym_protected] = ACTIONS(3792),
    [anon_sym_public] = ACTIONS(3792),
    [anon_sym_readonly] = ACTIONS(3792),
    [anon_sym_required] = ACTIONS(3792),
    [anon_sym_sealed] = ACTIONS(3792),
    [anon_sym_virtual] = ACTIONS(3792),
    [anon_sym_volatile] = ACTIONS(3792),
    [anon_sym_where] = ACTIONS(3792),
    [anon_sym_notnull] = ACTIONS(3792),
    [anon_sym_unmanaged] = ACTIONS(3792),
    [anon_sym_TILDE] = ACTIONS(3794),
    [anon_sym_implicit] = ACTIONS(3792),
    [anon_sym_explicit] = ACTIONS(3792),
    [anon_sym_scoped] = ACTIONS(3792),
    [anon_sym_var] = ACTIONS(3792),
    [sym_predefined_type] = ACTIONS(3792),
    [anon_sym_yield] = ACTIONS(3792),
    [anon_sym_when] = ACTIONS(3792),
    [anon_sym_from] = ACTIONS(3792),
    [anon_sym_into] = ACTIONS(3792),
    [anon_sym_join] = ACTIONS(3792),
    [anon_sym_on] = ACTIONS(3792),
    [anon_sym_equals] = ACTIONS(3792),
    [anon_sym_let] = ACTIONS(3792),
    [anon_sym_orderby] = ACTIONS(3792),
    [anon_sym_ascending] = ACTIONS(3792),
    [anon_sym_descending] = ACTIONS(3792),
    [anon_sym_group] = ACTIONS(3792),
    [anon_sym_by] = ACTIONS(3792),
    [anon_sym_select] = ACTIONS(3792),
    [aux_sym_preproc_if_token1] = ACTIONS(3794),
    [aux_sym_preproc_if_token3] = ACTIONS(3794),
    [aux_sym_preproc_else_token1] = ACTIONS(3794),
    [aux_sym_preproc_elif_token1] = ACTIONS(3794),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3214] = {
    [sym_preproc_region] = STATE(3214),
    [sym_preproc_endregion] = STATE(3214),
    [sym_preproc_line] = STATE(3214),
    [sym_preproc_pragma] = STATE(3214),
    [sym_preproc_nullable] = STATE(3214),
    [sym_preproc_error] = STATE(3214),
    [sym_preproc_define] = STATE(3214),
    [sym_preproc_undef] = STATE(3214),
    [sym__identifier_token] = ACTIONS(3673),
    [anon_sym_extern] = ACTIONS(3673),
    [anon_sym_alias] = ACTIONS(3673),
    [anon_sym_global] = ACTIONS(3673),
    [anon_sym_using] = ACTIONS(3673),
    [anon_sym_unsafe] = ACTIONS(3673),
    [anon_sym_static] = ACTIONS(3673),
    [anon_sym_LBRACK] = ACTIONS(3675),
    [anon_sym_LPAREN] = ACTIONS(3675),
    [anon_sym_event] = ACTIONS(3673),
    [anon_sym_namespace] = ACTIONS(3673),
    [anon_sym_class] = ACTIONS(3673),
    [anon_sym_ref] = ACTIONS(3673),
    [anon_sym_struct] = ACTIONS(3673),
    [anon_sym_enum] = ACTIONS(3673),
    [anon_sym_RBRACE] = ACTIONS(3675),
    [anon_sym_interface] = ACTIONS(3673),
    [anon_sym_delegate] = ACTIONS(3673),
    [anon_sym_record] = ACTIONS(3673),
    [anon_sym_abstract] = ACTIONS(3673),
    [anon_sym_async] = ACTIONS(3673),
    [anon_sym_const] = ACTIONS(3673),
    [anon_sym_file] = ACTIONS(3673),
    [anon_sym_fixed] = ACTIONS(3673),
    [anon_sym_internal] = ACTIONS(3673),
    [anon_sym_new] = ACTIONS(3673),
    [anon_sym_override] = ACTIONS(3673),
    [anon_sym_partial] = ACTIONS(3673),
    [anon_sym_private] = ACTIONS(3673),
    [anon_sym_protected] = ACTIONS(3673),
    [anon_sym_public] = ACTIONS(3673),
    [anon_sym_readonly] = ACTIONS(3673),
    [anon_sym_required] = ACTIONS(3673),
    [anon_sym_sealed] = ACTIONS(3673),
    [anon_sym_virtual] = ACTIONS(3673),
    [anon_sym_volatile] = ACTIONS(3673),
    [anon_sym_where] = ACTIONS(3673),
    [anon_sym_notnull] = ACTIONS(3673),
    [anon_sym_unmanaged] = ACTIONS(3673),
    [anon_sym_TILDE] = ACTIONS(3675),
    [anon_sym_implicit] = ACTIONS(3673),
    [anon_sym_explicit] = ACTIONS(3673),
    [anon_sym_scoped] = ACTIONS(3673),
    [anon_sym_var] = ACTIONS(3673),
    [sym_predefined_type] = ACTIONS(3673),
    [anon_sym_yield] = ACTIONS(3673),
    [anon_sym_when] = ACTIONS(3673),
    [anon_sym_from] = ACTIONS(3673),
    [anon_sym_into] = ACTIONS(3673),
    [anon_sym_join] = ACTIONS(3673),
    [anon_sym_on] = ACTIONS(3673),
    [anon_sym_equals] = ACTIONS(3673),
    [anon_sym_let] = ACTIONS(3673),
    [anon_sym_orderby] = ACTIONS(3673),
    [anon_sym_ascending] = ACTIONS(3673),
    [anon_sym_descending] = ACTIONS(3673),
    [anon_sym_group] = ACTIONS(3673),
    [anon_sym_by] = ACTIONS(3673),
    [anon_sym_select] = ACTIONS(3673),
    [aux_sym_preproc_if_token1] = ACTIONS(3675),
    [aux_sym_preproc_if_token3] = ACTIONS(3675),
    [aux_sym_preproc_else_token1] = ACTIONS(3675),
    [aux_sym_preproc_elif_token1] = ACTIONS(3675),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3215] = {
    [sym__variable_designation] = STATE(4123),
    [sym_parenthesized_variable_designation] = STATE(4274),
    [sym_identifier] = STATE(4269),
    [sym__reserved_identifier] = STATE(3908),
    [sym_preproc_region] = STATE(3215),
    [sym_preproc_endregion] = STATE(3215),
    [sym_preproc_line] = STATE(3215),
    [sym_preproc_pragma] = STATE(3215),
    [sym_preproc_nullable] = STATE(3215),
    [sym_preproc_error] = STATE(3215),
    [sym_preproc_define] = STATE(3215),
    [sym_preproc_undef] = STATE(3215),
    [sym__identifier_token] = ACTIONS(4271),
    [anon_sym_alias] = ACTIONS(4273),
    [anon_sym_global] = ACTIONS(4273),
    [anon_sym_LBRACK] = ACTIONS(4335),
    [anon_sym_LPAREN] = ACTIONS(4335),
    [anon_sym_file] = ACTIONS(4273),
    [anon_sym_LT] = ACTIONS(4337),
    [anon_sym_GT] = ACTIONS(4337),
    [anon_sym_where] = ACTIONS(4273),
    [anon_sym_QMARK] = ACTIONS(4337),
    [anon_sym_notnull] = ACTIONS(4273),
    [anon_sym_unmanaged] = ACTIONS(4273),
    [anon_sym_BANG] = ACTIONS(4337),
    [anon_sym_PLUS_PLUS] = ACTIONS(4335),
    [anon_sym_DASH_DASH] = ACTIONS(4335),
    [anon_sym_PLUS] = ACTIONS(4337),
    [anon_sym_DASH] = ACTIONS(4337),
    [anon_sym_STAR] = ACTIONS(4335),
    [anon_sym_SLASH] = ACTIONS(4337),
    [anon_sym_PERCENT] = ACTIONS(4335),
    [anon_sym_CARET] = ACTIONS(4335),
    [anon_sym_PIPE] = ACTIONS(4337),
    [anon_sym_AMP] = ACTIONS(4337),
    [anon_sym_LT_LT] = ACTIONS(4335),
    [anon_sym_GT_GT] = ACTIONS(4337),
    [anon_sym_GT_GT_GT] = ACTIONS(4335),
    [anon_sym_EQ_EQ] = ACTIONS(4335),
    [anon_sym_BANG_EQ] = ACTIONS(4335),
    [anon_sym_GT_EQ] = ACTIONS(4335),
    [anon_sym_LT_EQ] = ACTIONS(4335),
    [anon_sym_DOT] = ACTIONS(4337),
    [anon_sym_scoped] = ACTIONS(4273),
    [anon_sym_var] = ACTIONS(4273),
    [anon_sym_yield] = ACTIONS(4273),
    [anon_sym_switch] = ACTIONS(4337),
    [anon_sym_when] = ACTIONS(4273),
    [sym_discard] = ACTIONS(4295),
    [anon_sym_DOT_DOT] = ACTIONS(4335),
    [anon_sym_and] = ACTIONS(4337),
    [anon_sym_or] = ACTIONS(4337),
    [anon_sym_AMP_AMP] = ACTIONS(4335),
    [anon_sym_PIPE_PIPE] = ACTIONS(4335),
    [anon_sym_QMARK_QMARK] = ACTIONS(4335),
    [anon_sym_from] = ACTIONS(4273),
    [anon_sym_into] = ACTIONS(4273),
    [anon_sym_join] = ACTIONS(4273),
    [anon_sym_on] = ACTIONS(4273),
    [anon_sym_equals] = ACTIONS(4273),
    [anon_sym_let] = ACTIONS(4273),
    [anon_sym_orderby] = ACTIONS(4273),
    [anon_sym_ascending] = ACTIONS(4273),
    [anon_sym_descending] = ACTIONS(4273),
    [anon_sym_group] = ACTIONS(4273),
    [anon_sym_by] = ACTIONS(4337),
    [anon_sym_select] = ACTIONS(4273),
    [anon_sym_as] = ACTIONS(4337),
    [anon_sym_is] = ACTIONS(4337),
    [anon_sym_DASH_GT] = ACTIONS(4335),
    [anon_sym_with] = ACTIONS(4337),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3216] = {
    [sym__variable_designation] = STATE(4082),
    [sym_parenthesized_variable_designation] = STATE(4274),
    [sym_identifier] = STATE(4269),
    [sym__reserved_identifier] = STATE(3908),
    [sym_preproc_region] = STATE(3216),
    [sym_preproc_endregion] = STATE(3216),
    [sym_preproc_line] = STATE(3216),
    [sym_preproc_pragma] = STATE(3216),
    [sym_preproc_nullable] = STATE(3216),
    [sym_preproc_error] = STATE(3216),
    [sym_preproc_define] = STATE(3216),
    [sym_preproc_undef] = STATE(3216),
    [sym__identifier_token] = ACTIONS(4271),
    [anon_sym_alias] = ACTIONS(4273),
    [anon_sym_global] = ACTIONS(4273),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_LPAREN] = ACTIONS(4383),
    [anon_sym_file] = ACTIONS(4273),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_where] = ACTIONS(4273),
    [anon_sym_QMARK] = ACTIONS(4385),
    [anon_sym_notnull] = ACTIONS(4273),
    [anon_sym_unmanaged] = ACTIONS(4273),
    [anon_sym_BANG] = ACTIONS(4385),
    [anon_sym_PLUS_PLUS] = ACTIONS(4383),
    [anon_sym_DASH_DASH] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_DASH] = ACTIONS(4385),
    [anon_sym_STAR] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4385),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4385),
    [anon_sym_GT_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4383),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_scoped] = ACTIONS(4273),
    [anon_sym_var] = ACTIONS(4273),
    [anon_sym_yield] = ACTIONS(4273),
    [anon_sym_switch] = ACTIONS(4385),
    [anon_sym_when] = ACTIONS(4273),
    [sym_discard] = ACTIONS(4295),
    [anon_sym_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4385),
    [anon_sym_or] = ACTIONS(4385),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_QMARK_QMARK] = ACTIONS(4383),
    [anon_sym_from] = ACTIONS(4273),
    [anon_sym_into] = ACTIONS(4273),
    [anon_sym_join] = ACTIONS(4273),
    [anon_sym_on] = ACTIONS(4273),
    [anon_sym_equals] = ACTIONS(4273),
    [anon_sym_let] = ACTIONS(4273),
    [anon_sym_orderby] = ACTIONS(4273),
    [anon_sym_ascending] = ACTIONS(4273),
    [anon_sym_descending] = ACTIONS(4273),
    [anon_sym_group] = ACTIONS(4273),
    [anon_sym_by] = ACTIONS(4385),
    [anon_sym_select] = ACTIONS(4273),
    [anon_sym_as] = ACTIONS(4385),
    [anon_sym_is] = ACTIONS(4385),
    [anon_sym_DASH_GT] = ACTIONS(4383),
    [anon_sym_with] = ACTIONS(4385),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3217] = {
    [sym_preproc_region] = STATE(3217),
    [sym_preproc_endregion] = STATE(3217),
    [sym_preproc_line] = STATE(3217),
    [sym_preproc_pragma] = STATE(3217),
    [sym_preproc_nullable] = STATE(3217),
    [sym_preproc_error] = STATE(3217),
    [sym_preproc_define] = STATE(3217),
    [sym_preproc_undef] = STATE(3217),
    [sym__identifier_token] = ACTIONS(4764),
    [anon_sym_extern] = ACTIONS(4764),
    [anon_sym_alias] = ACTIONS(4764),
    [anon_sym_global] = ACTIONS(4764),
    [anon_sym_using] = ACTIONS(4764),
    [anon_sym_unsafe] = ACTIONS(4764),
    [anon_sym_static] = ACTIONS(4764),
    [anon_sym_LBRACK] = ACTIONS(4766),
    [anon_sym_LPAREN] = ACTIONS(4766),
    [anon_sym_event] = ACTIONS(4764),
    [anon_sym_namespace] = ACTIONS(4764),
    [anon_sym_class] = ACTIONS(4764),
    [anon_sym_ref] = ACTIONS(4764),
    [anon_sym_struct] = ACTIONS(4764),
    [anon_sym_enum] = ACTIONS(4764),
    [anon_sym_RBRACE] = ACTIONS(4766),
    [anon_sym_interface] = ACTIONS(4764),
    [anon_sym_delegate] = ACTIONS(4764),
    [anon_sym_record] = ACTIONS(4764),
    [anon_sym_abstract] = ACTIONS(4764),
    [anon_sym_async] = ACTIONS(4764),
    [anon_sym_const] = ACTIONS(4764),
    [anon_sym_file] = ACTIONS(4764),
    [anon_sym_fixed] = ACTIONS(4764),
    [anon_sym_internal] = ACTIONS(4764),
    [anon_sym_new] = ACTIONS(4764),
    [anon_sym_override] = ACTIONS(4764),
    [anon_sym_partial] = ACTIONS(4764),
    [anon_sym_private] = ACTIONS(4764),
    [anon_sym_protected] = ACTIONS(4764),
    [anon_sym_public] = ACTIONS(4764),
    [anon_sym_readonly] = ACTIONS(4764),
    [anon_sym_required] = ACTIONS(4764),
    [anon_sym_sealed] = ACTIONS(4764),
    [anon_sym_virtual] = ACTIONS(4764),
    [anon_sym_volatile] = ACTIONS(4764),
    [anon_sym_where] = ACTIONS(4764),
    [anon_sym_notnull] = ACTIONS(4764),
    [anon_sym_unmanaged] = ACTIONS(4764),
    [anon_sym_TILDE] = ACTIONS(4766),
    [anon_sym_implicit] = ACTIONS(4764),
    [anon_sym_explicit] = ACTIONS(4764),
    [anon_sym_scoped] = ACTIONS(4764),
    [anon_sym_var] = ACTIONS(4764),
    [sym_predefined_type] = ACTIONS(4764),
    [anon_sym_yield] = ACTIONS(4764),
    [anon_sym_when] = ACTIONS(4764),
    [anon_sym_from] = ACTIONS(4764),
    [anon_sym_into] = ACTIONS(4764),
    [anon_sym_join] = ACTIONS(4764),
    [anon_sym_on] = ACTIONS(4764),
    [anon_sym_equals] = ACTIONS(4764),
    [anon_sym_let] = ACTIONS(4764),
    [anon_sym_orderby] = ACTIONS(4764),
    [anon_sym_ascending] = ACTIONS(4764),
    [anon_sym_descending] = ACTIONS(4764),
    [anon_sym_group] = ACTIONS(4764),
    [anon_sym_by] = ACTIONS(4764),
    [anon_sym_select] = ACTIONS(4764),
    [aux_sym_preproc_if_token1] = ACTIONS(4766),
    [aux_sym_preproc_if_token3] = ACTIONS(4766),
    [aux_sym_preproc_else_token1] = ACTIONS(4766),
    [aux_sym_preproc_elif_token1] = ACTIONS(4766),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3218] = {
    [sym_preproc_region] = STATE(3218),
    [sym_preproc_endregion] = STATE(3218),
    [sym_preproc_line] = STATE(3218),
    [sym_preproc_pragma] = STATE(3218),
    [sym_preproc_nullable] = STATE(3218),
    [sym_preproc_error] = STATE(3218),
    [sym_preproc_define] = STATE(3218),
    [sym_preproc_undef] = STATE(3218),
    [sym__identifier_token] = ACTIONS(3776),
    [anon_sym_extern] = ACTIONS(3776),
    [anon_sym_alias] = ACTIONS(3776),
    [anon_sym_global] = ACTIONS(3776),
    [anon_sym_using] = ACTIONS(3776),
    [anon_sym_unsafe] = ACTIONS(3776),
    [anon_sym_static] = ACTIONS(3776),
    [anon_sym_LBRACK] = ACTIONS(3778),
    [anon_sym_LPAREN] = ACTIONS(3778),
    [anon_sym_event] = ACTIONS(3776),
    [anon_sym_namespace] = ACTIONS(3776),
    [anon_sym_class] = ACTIONS(3776),
    [anon_sym_ref] = ACTIONS(3776),
    [anon_sym_struct] = ACTIONS(3776),
    [anon_sym_enum] = ACTIONS(3776),
    [anon_sym_RBRACE] = ACTIONS(3778),
    [anon_sym_interface] = ACTIONS(3776),
    [anon_sym_delegate] = ACTIONS(3776),
    [anon_sym_record] = ACTIONS(3776),
    [anon_sym_abstract] = ACTIONS(3776),
    [anon_sym_async] = ACTIONS(3776),
    [anon_sym_const] = ACTIONS(3776),
    [anon_sym_file] = ACTIONS(3776),
    [anon_sym_fixed] = ACTIONS(3776),
    [anon_sym_internal] = ACTIONS(3776),
    [anon_sym_new] = ACTIONS(3776),
    [anon_sym_override] = ACTIONS(3776),
    [anon_sym_partial] = ACTIONS(3776),
    [anon_sym_private] = ACTIONS(3776),
    [anon_sym_protected] = ACTIONS(3776),
    [anon_sym_public] = ACTIONS(3776),
    [anon_sym_readonly] = ACTIONS(3776),
    [anon_sym_required] = ACTIONS(3776),
    [anon_sym_sealed] = ACTIONS(3776),
    [anon_sym_virtual] = ACTIONS(3776),
    [anon_sym_volatile] = ACTIONS(3776),
    [anon_sym_where] = ACTIONS(3776),
    [anon_sym_notnull] = ACTIONS(3776),
    [anon_sym_unmanaged] = ACTIONS(3776),
    [anon_sym_TILDE] = ACTIONS(3778),
    [anon_sym_implicit] = ACTIONS(3776),
    [anon_sym_explicit] = ACTIONS(3776),
    [anon_sym_scoped] = ACTIONS(3776),
    [anon_sym_var] = ACTIONS(3776),
    [sym_predefined_type] = ACTIONS(3776),
    [anon_sym_yield] = ACTIONS(3776),
    [anon_sym_when] = ACTIONS(3776),
    [anon_sym_from] = ACTIONS(3776),
    [anon_sym_into] = ACTIONS(3776),
    [anon_sym_join] = ACTIONS(3776),
    [anon_sym_on] = ACTIONS(3776),
    [anon_sym_equals] = ACTIONS(3776),
    [anon_sym_let] = ACTIONS(3776),
    [anon_sym_orderby] = ACTIONS(3776),
    [anon_sym_ascending] = ACTIONS(3776),
    [anon_sym_descending] = ACTIONS(3776),
    [anon_sym_group] = ACTIONS(3776),
    [anon_sym_by] = ACTIONS(3776),
    [anon_sym_select] = ACTIONS(3776),
    [aux_sym_preproc_if_token1] = ACTIONS(3778),
    [aux_sym_preproc_if_token3] = ACTIONS(3778),
    [aux_sym_preproc_else_token1] = ACTIONS(3778),
    [aux_sym_preproc_elif_token1] = ACTIONS(3778),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3219] = {
    [sym_preproc_region] = STATE(3219),
    [sym_preproc_endregion] = STATE(3219),
    [sym_preproc_line] = STATE(3219),
    [sym_preproc_pragma] = STATE(3219),
    [sym_preproc_nullable] = STATE(3219),
    [sym_preproc_error] = STATE(3219),
    [sym_preproc_define] = STATE(3219),
    [sym_preproc_undef] = STATE(3219),
    [sym__identifier_token] = ACTIONS(4470),
    [anon_sym_alias] = ACTIONS(4470),
    [anon_sym_global] = ACTIONS(4470),
    [anon_sym_LBRACK] = ACTIONS(4472),
    [anon_sym_COLON] = ACTIONS(4472),
    [anon_sym_COMMA] = ACTIONS(4472),
    [anon_sym_LPAREN] = ACTIONS(4472),
    [anon_sym_LBRACE] = ACTIONS(4472),
    [anon_sym_file] = ACTIONS(4470),
    [anon_sym_LT] = ACTIONS(4470),
    [anon_sym_GT] = ACTIONS(4470),
    [anon_sym_where] = ACTIONS(4470),
    [anon_sym_QMARK] = ACTIONS(4470),
    [anon_sym_notnull] = ACTIONS(4470),
    [anon_sym_unmanaged] = ACTIONS(4470),
    [anon_sym_BANG] = ACTIONS(4470),
    [anon_sym_PLUS_PLUS] = ACTIONS(4472),
    [anon_sym_DASH_DASH] = ACTIONS(4472),
    [anon_sym_PLUS] = ACTIONS(4470),
    [anon_sym_DASH] = ACTIONS(4470),
    [anon_sym_STAR] = ACTIONS(4472),
    [anon_sym_SLASH] = ACTIONS(4470),
    [anon_sym_PERCENT] = ACTIONS(4472),
    [anon_sym_CARET] = ACTIONS(4472),
    [anon_sym_PIPE] = ACTIONS(4470),
    [anon_sym_AMP] = ACTIONS(4470),
    [anon_sym_LT_LT] = ACTIONS(4472),
    [anon_sym_GT_GT] = ACTIONS(4470),
    [anon_sym_GT_GT_GT] = ACTIONS(4472),
    [anon_sym_EQ_EQ] = ACTIONS(4472),
    [anon_sym_BANG_EQ] = ACTIONS(4472),
    [anon_sym_GT_EQ] = ACTIONS(4472),
    [anon_sym_LT_EQ] = ACTIONS(4472),
    [anon_sym_DOT] = ACTIONS(4470),
    [anon_sym_scoped] = ACTIONS(4470),
    [anon_sym_var] = ACTIONS(4470),
    [anon_sym_yield] = ACTIONS(4470),
    [anon_sym_switch] = ACTIONS(4470),
    [anon_sym_when] = ACTIONS(4470),
    [sym_discard] = ACTIONS(4470),
    [anon_sym_DOT_DOT] = ACTIONS(4472),
    [anon_sym_and] = ACTIONS(4470),
    [anon_sym_or] = ACTIONS(4470),
    [anon_sym_AMP_AMP] = ACTIONS(4472),
    [anon_sym_PIPE_PIPE] = ACTIONS(4472),
    [anon_sym_QMARK_QMARK] = ACTIONS(4472),
    [anon_sym_from] = ACTIONS(4470),
    [anon_sym_into] = ACTIONS(4470),
    [anon_sym_join] = ACTIONS(4470),
    [anon_sym_on] = ACTIONS(4470),
    [anon_sym_equals] = ACTIONS(4470),
    [anon_sym_let] = ACTIONS(4470),
    [anon_sym_orderby] = ACTIONS(4470),
    [anon_sym_ascending] = ACTIONS(4470),
    [anon_sym_descending] = ACTIONS(4470),
    [anon_sym_group] = ACTIONS(4470),
    [anon_sym_by] = ACTIONS(4470),
    [anon_sym_select] = ACTIONS(4470),
    [anon_sym_as] = ACTIONS(4470),
    [anon_sym_is] = ACTIONS(4470),
    [anon_sym_DASH_GT] = ACTIONS(4472),
    [anon_sym_with] = ACTIONS(4470),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4472),
  },
  [3220] = {
    [sym_preproc_region] = STATE(3220),
    [sym_preproc_endregion] = STATE(3220),
    [sym_preproc_line] = STATE(3220),
    [sym_preproc_pragma] = STATE(3220),
    [sym_preproc_nullable] = STATE(3220),
    [sym_preproc_error] = STATE(3220),
    [sym_preproc_define] = STATE(3220),
    [sym_preproc_undef] = STATE(3220),
    [sym__identifier_token] = ACTIONS(4768),
    [anon_sym_extern] = ACTIONS(4768),
    [anon_sym_alias] = ACTIONS(4768),
    [anon_sym_global] = ACTIONS(4768),
    [anon_sym_using] = ACTIONS(4768),
    [anon_sym_unsafe] = ACTIONS(4768),
    [anon_sym_static] = ACTIONS(4768),
    [anon_sym_LBRACK] = ACTIONS(4770),
    [anon_sym_LPAREN] = ACTIONS(4770),
    [anon_sym_event] = ACTIONS(4768),
    [anon_sym_namespace] = ACTIONS(4768),
    [anon_sym_class] = ACTIONS(4768),
    [anon_sym_ref] = ACTIONS(4768),
    [anon_sym_struct] = ACTIONS(4768),
    [anon_sym_enum] = ACTIONS(4768),
    [anon_sym_RBRACE] = ACTIONS(4770),
    [anon_sym_interface] = ACTIONS(4768),
    [anon_sym_delegate] = ACTIONS(4768),
    [anon_sym_record] = ACTIONS(4768),
    [anon_sym_abstract] = ACTIONS(4768),
    [anon_sym_async] = ACTIONS(4768),
    [anon_sym_const] = ACTIONS(4768),
    [anon_sym_file] = ACTIONS(4768),
    [anon_sym_fixed] = ACTIONS(4768),
    [anon_sym_internal] = ACTIONS(4768),
    [anon_sym_new] = ACTIONS(4768),
    [anon_sym_override] = ACTIONS(4768),
    [anon_sym_partial] = ACTIONS(4768),
    [anon_sym_private] = ACTIONS(4768),
    [anon_sym_protected] = ACTIONS(4768),
    [anon_sym_public] = ACTIONS(4768),
    [anon_sym_readonly] = ACTIONS(4768),
    [anon_sym_required] = ACTIONS(4768),
    [anon_sym_sealed] = ACTIONS(4768),
    [anon_sym_virtual] = ACTIONS(4768),
    [anon_sym_volatile] = ACTIONS(4768),
    [anon_sym_where] = ACTIONS(4768),
    [anon_sym_notnull] = ACTIONS(4768),
    [anon_sym_unmanaged] = ACTIONS(4768),
    [anon_sym_TILDE] = ACTIONS(4770),
    [anon_sym_implicit] = ACTIONS(4768),
    [anon_sym_explicit] = ACTIONS(4768),
    [anon_sym_scoped] = ACTIONS(4768),
    [anon_sym_var] = ACTIONS(4768),
    [sym_predefined_type] = ACTIONS(4768),
    [anon_sym_yield] = ACTIONS(4768),
    [anon_sym_when] = ACTIONS(4768),
    [anon_sym_from] = ACTIONS(4768),
    [anon_sym_into] = ACTIONS(4768),
    [anon_sym_join] = ACTIONS(4768),
    [anon_sym_on] = ACTIONS(4768),
    [anon_sym_equals] = ACTIONS(4768),
    [anon_sym_let] = ACTIONS(4768),
    [anon_sym_orderby] = ACTIONS(4768),
    [anon_sym_ascending] = ACTIONS(4768),
    [anon_sym_descending] = ACTIONS(4768),
    [anon_sym_group] = ACTIONS(4768),
    [anon_sym_by] = ACTIONS(4768),
    [anon_sym_select] = ACTIONS(4768),
    [aux_sym_preproc_if_token1] = ACTIONS(4770),
    [aux_sym_preproc_if_token3] = ACTIONS(4770),
    [aux_sym_preproc_else_token1] = ACTIONS(4770),
    [aux_sym_preproc_elif_token1] = ACTIONS(4770),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3221] = {
    [sym_preproc_region] = STATE(3221),
    [sym_preproc_endregion] = STATE(3221),
    [sym_preproc_line] = STATE(3221),
    [sym_preproc_pragma] = STATE(3221),
    [sym_preproc_nullable] = STATE(3221),
    [sym_preproc_error] = STATE(3221),
    [sym_preproc_define] = STATE(3221),
    [sym_preproc_undef] = STATE(3221),
    [sym__identifier_token] = ACTIONS(3764),
    [anon_sym_extern] = ACTIONS(3764),
    [anon_sym_alias] = ACTIONS(3764),
    [anon_sym_global] = ACTIONS(3764),
    [anon_sym_using] = ACTIONS(3764),
    [anon_sym_unsafe] = ACTIONS(3764),
    [anon_sym_static] = ACTIONS(3764),
    [anon_sym_LBRACK] = ACTIONS(3766),
    [anon_sym_LPAREN] = ACTIONS(3766),
    [anon_sym_event] = ACTIONS(3764),
    [anon_sym_namespace] = ACTIONS(3764),
    [anon_sym_class] = ACTIONS(3764),
    [anon_sym_ref] = ACTIONS(3764),
    [anon_sym_struct] = ACTIONS(3764),
    [anon_sym_enum] = ACTIONS(3764),
    [anon_sym_RBRACE] = ACTIONS(3766),
    [anon_sym_interface] = ACTIONS(3764),
    [anon_sym_delegate] = ACTIONS(3764),
    [anon_sym_record] = ACTIONS(3764),
    [anon_sym_abstract] = ACTIONS(3764),
    [anon_sym_async] = ACTIONS(3764),
    [anon_sym_const] = ACTIONS(3764),
    [anon_sym_file] = ACTIONS(3764),
    [anon_sym_fixed] = ACTIONS(3764),
    [anon_sym_internal] = ACTIONS(3764),
    [anon_sym_new] = ACTIONS(3764),
    [anon_sym_override] = ACTIONS(3764),
    [anon_sym_partial] = ACTIONS(3764),
    [anon_sym_private] = ACTIONS(3764),
    [anon_sym_protected] = ACTIONS(3764),
    [anon_sym_public] = ACTIONS(3764),
    [anon_sym_readonly] = ACTIONS(3764),
    [anon_sym_required] = ACTIONS(3764),
    [anon_sym_sealed] = ACTIONS(3764),
    [anon_sym_virtual] = ACTIONS(3764),
    [anon_sym_volatile] = ACTIONS(3764),
    [anon_sym_where] = ACTIONS(3764),
    [anon_sym_notnull] = ACTIONS(3764),
    [anon_sym_unmanaged] = ACTIONS(3764),
    [anon_sym_TILDE] = ACTIONS(3766),
    [anon_sym_implicit] = ACTIONS(3764),
    [anon_sym_explicit] = ACTIONS(3764),
    [anon_sym_scoped] = ACTIONS(3764),
    [anon_sym_var] = ACTIONS(3764),
    [sym_predefined_type] = ACTIONS(3764),
    [anon_sym_yield] = ACTIONS(3764),
    [anon_sym_when] = ACTIONS(3764),
    [anon_sym_from] = ACTIONS(3764),
    [anon_sym_into] = ACTIONS(3764),
    [anon_sym_join] = ACTIONS(3764),
    [anon_sym_on] = ACTIONS(3764),
    [anon_sym_equals] = ACTIONS(3764),
    [anon_sym_let] = ACTIONS(3764),
    [anon_sym_orderby] = ACTIONS(3764),
    [anon_sym_ascending] = ACTIONS(3764),
    [anon_sym_descending] = ACTIONS(3764),
    [anon_sym_group] = ACTIONS(3764),
    [anon_sym_by] = ACTIONS(3764),
    [anon_sym_select] = ACTIONS(3764),
    [aux_sym_preproc_if_token1] = ACTIONS(3766),
    [aux_sym_preproc_if_token3] = ACTIONS(3766),
    [aux_sym_preproc_else_token1] = ACTIONS(3766),
    [aux_sym_preproc_elif_token1] = ACTIONS(3766),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3222] = {
    [sym_preproc_region] = STATE(3222),
    [sym_preproc_endregion] = STATE(3222),
    [sym_preproc_line] = STATE(3222),
    [sym_preproc_pragma] = STATE(3222),
    [sym_preproc_nullable] = STATE(3222),
    [sym_preproc_error] = STATE(3222),
    [sym_preproc_define] = STATE(3222),
    [sym_preproc_undef] = STATE(3222),
    [sym__identifier_token] = ACTIONS(3768),
    [anon_sym_extern] = ACTIONS(3768),
    [anon_sym_alias] = ACTIONS(3768),
    [anon_sym_global] = ACTIONS(3768),
    [anon_sym_using] = ACTIONS(3768),
    [anon_sym_unsafe] = ACTIONS(3768),
    [anon_sym_static] = ACTIONS(3768),
    [anon_sym_LBRACK] = ACTIONS(3770),
    [anon_sym_LPAREN] = ACTIONS(3770),
    [anon_sym_event] = ACTIONS(3768),
    [anon_sym_namespace] = ACTIONS(3768),
    [anon_sym_class] = ACTIONS(3768),
    [anon_sym_ref] = ACTIONS(3768),
    [anon_sym_struct] = ACTIONS(3768),
    [anon_sym_enum] = ACTIONS(3768),
    [anon_sym_RBRACE] = ACTIONS(3770),
    [anon_sym_interface] = ACTIONS(3768),
    [anon_sym_delegate] = ACTIONS(3768),
    [anon_sym_record] = ACTIONS(3768),
    [anon_sym_abstract] = ACTIONS(3768),
    [anon_sym_async] = ACTIONS(3768),
    [anon_sym_const] = ACTIONS(3768),
    [anon_sym_file] = ACTIONS(3768),
    [anon_sym_fixed] = ACTIONS(3768),
    [anon_sym_internal] = ACTIONS(3768),
    [anon_sym_new] = ACTIONS(3768),
    [anon_sym_override] = ACTIONS(3768),
    [anon_sym_partial] = ACTIONS(3768),
    [anon_sym_private] = ACTIONS(3768),
    [anon_sym_protected] = ACTIONS(3768),
    [anon_sym_public] = ACTIONS(3768),
    [anon_sym_readonly] = ACTIONS(3768),
    [anon_sym_required] = ACTIONS(3768),
    [anon_sym_sealed] = ACTIONS(3768),
    [anon_sym_virtual] = ACTIONS(3768),
    [anon_sym_volatile] = ACTIONS(3768),
    [anon_sym_where] = ACTIONS(3768),
    [anon_sym_notnull] = ACTIONS(3768),
    [anon_sym_unmanaged] = ACTIONS(3768),
    [anon_sym_TILDE] = ACTIONS(3770),
    [anon_sym_implicit] = ACTIONS(3768),
    [anon_sym_explicit] = ACTIONS(3768),
    [anon_sym_scoped] = ACTIONS(3768),
    [anon_sym_var] = ACTIONS(3768),
    [sym_predefined_type] = ACTIONS(3768),
    [anon_sym_yield] = ACTIONS(3768),
    [anon_sym_when] = ACTIONS(3768),
    [anon_sym_from] = ACTIONS(3768),
    [anon_sym_into] = ACTIONS(3768),
    [anon_sym_join] = ACTIONS(3768),
    [anon_sym_on] = ACTIONS(3768),
    [anon_sym_equals] = ACTIONS(3768),
    [anon_sym_let] = ACTIONS(3768),
    [anon_sym_orderby] = ACTIONS(3768),
    [anon_sym_ascending] = ACTIONS(3768),
    [anon_sym_descending] = ACTIONS(3768),
    [anon_sym_group] = ACTIONS(3768),
    [anon_sym_by] = ACTIONS(3768),
    [anon_sym_select] = ACTIONS(3768),
    [aux_sym_preproc_if_token1] = ACTIONS(3770),
    [aux_sym_preproc_if_token3] = ACTIONS(3770),
    [aux_sym_preproc_else_token1] = ACTIONS(3770),
    [aux_sym_preproc_elif_token1] = ACTIONS(3770),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3223] = {
    [sym_preproc_region] = STATE(3223),
    [sym_preproc_endregion] = STATE(3223),
    [sym_preproc_line] = STATE(3223),
    [sym_preproc_pragma] = STATE(3223),
    [sym_preproc_nullable] = STATE(3223),
    [sym_preproc_error] = STATE(3223),
    [sym_preproc_define] = STATE(3223),
    [sym_preproc_undef] = STATE(3223),
    [sym__identifier_token] = ACTIONS(3804),
    [anon_sym_extern] = ACTIONS(3804),
    [anon_sym_alias] = ACTIONS(3804),
    [anon_sym_global] = ACTIONS(3804),
    [anon_sym_using] = ACTIONS(3804),
    [anon_sym_unsafe] = ACTIONS(3804),
    [anon_sym_static] = ACTIONS(3804),
    [anon_sym_LBRACK] = ACTIONS(3806),
    [anon_sym_LPAREN] = ACTIONS(3806),
    [anon_sym_event] = ACTIONS(3804),
    [anon_sym_namespace] = ACTIONS(3804),
    [anon_sym_class] = ACTIONS(3804),
    [anon_sym_ref] = ACTIONS(3804),
    [anon_sym_struct] = ACTIONS(3804),
    [anon_sym_enum] = ACTIONS(3804),
    [anon_sym_RBRACE] = ACTIONS(3806),
    [anon_sym_interface] = ACTIONS(3804),
    [anon_sym_delegate] = ACTIONS(3804),
    [anon_sym_record] = ACTIONS(3804),
    [anon_sym_abstract] = ACTIONS(3804),
    [anon_sym_async] = ACTIONS(3804),
    [anon_sym_const] = ACTIONS(3804),
    [anon_sym_file] = ACTIONS(3804),
    [anon_sym_fixed] = ACTIONS(3804),
    [anon_sym_internal] = ACTIONS(3804),
    [anon_sym_new] = ACTIONS(3804),
    [anon_sym_override] = ACTIONS(3804),
    [anon_sym_partial] = ACTIONS(3804),
    [anon_sym_private] = ACTIONS(3804),
    [anon_sym_protected] = ACTIONS(3804),
    [anon_sym_public] = ACTIONS(3804),
    [anon_sym_readonly] = ACTIONS(3804),
    [anon_sym_required] = ACTIONS(3804),
    [anon_sym_sealed] = ACTIONS(3804),
    [anon_sym_virtual] = ACTIONS(3804),
    [anon_sym_volatile] = ACTIONS(3804),
    [anon_sym_where] = ACTIONS(3804),
    [anon_sym_notnull] = ACTIONS(3804),
    [anon_sym_unmanaged] = ACTIONS(3804),
    [anon_sym_TILDE] = ACTIONS(3806),
    [anon_sym_implicit] = ACTIONS(3804),
    [anon_sym_explicit] = ACTIONS(3804),
    [anon_sym_scoped] = ACTIONS(3804),
    [anon_sym_var] = ACTIONS(3804),
    [sym_predefined_type] = ACTIONS(3804),
    [anon_sym_yield] = ACTIONS(3804),
    [anon_sym_when] = ACTIONS(3804),
    [anon_sym_from] = ACTIONS(3804),
    [anon_sym_into] = ACTIONS(3804),
    [anon_sym_join] = ACTIONS(3804),
    [anon_sym_on] = ACTIONS(3804),
    [anon_sym_equals] = ACTIONS(3804),
    [anon_sym_let] = ACTIONS(3804),
    [anon_sym_orderby] = ACTIONS(3804),
    [anon_sym_ascending] = ACTIONS(3804),
    [anon_sym_descending] = ACTIONS(3804),
    [anon_sym_group] = ACTIONS(3804),
    [anon_sym_by] = ACTIONS(3804),
    [anon_sym_select] = ACTIONS(3804),
    [aux_sym_preproc_if_token1] = ACTIONS(3806),
    [aux_sym_preproc_if_token3] = ACTIONS(3806),
    [aux_sym_preproc_else_token1] = ACTIONS(3806),
    [aux_sym_preproc_elif_token1] = ACTIONS(3806),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3224] = {
    [sym_preproc_region] = STATE(3224),
    [sym_preproc_endregion] = STATE(3224),
    [sym_preproc_line] = STATE(3224),
    [sym_preproc_pragma] = STATE(3224),
    [sym_preproc_nullable] = STATE(3224),
    [sym_preproc_error] = STATE(3224),
    [sym_preproc_define] = STATE(3224),
    [sym_preproc_undef] = STATE(3224),
    [sym__identifier_token] = ACTIONS(4772),
    [anon_sym_extern] = ACTIONS(4772),
    [anon_sym_alias] = ACTIONS(4772),
    [anon_sym_global] = ACTIONS(4772),
    [anon_sym_using] = ACTIONS(4772),
    [anon_sym_unsafe] = ACTIONS(4772),
    [anon_sym_static] = ACTIONS(4772),
    [anon_sym_LBRACK] = ACTIONS(4774),
    [anon_sym_LPAREN] = ACTIONS(4774),
    [anon_sym_event] = ACTIONS(4772),
    [anon_sym_namespace] = ACTIONS(4772),
    [anon_sym_class] = ACTIONS(4772),
    [anon_sym_ref] = ACTIONS(4772),
    [anon_sym_struct] = ACTIONS(4772),
    [anon_sym_enum] = ACTIONS(4772),
    [anon_sym_RBRACE] = ACTIONS(4774),
    [anon_sym_interface] = ACTIONS(4772),
    [anon_sym_delegate] = ACTIONS(4772),
    [anon_sym_record] = ACTIONS(4772),
    [anon_sym_abstract] = ACTIONS(4772),
    [anon_sym_async] = ACTIONS(4772),
    [anon_sym_const] = ACTIONS(4772),
    [anon_sym_file] = ACTIONS(4772),
    [anon_sym_fixed] = ACTIONS(4772),
    [anon_sym_internal] = ACTIONS(4772),
    [anon_sym_new] = ACTIONS(4772),
    [anon_sym_override] = ACTIONS(4772),
    [anon_sym_partial] = ACTIONS(4772),
    [anon_sym_private] = ACTIONS(4772),
    [anon_sym_protected] = ACTIONS(4772),
    [anon_sym_public] = ACTIONS(4772),
    [anon_sym_readonly] = ACTIONS(4772),
    [anon_sym_required] = ACTIONS(4772),
    [anon_sym_sealed] = ACTIONS(4772),
    [anon_sym_virtual] = ACTIONS(4772),
    [anon_sym_volatile] = ACTIONS(4772),
    [anon_sym_where] = ACTIONS(4772),
    [anon_sym_notnull] = ACTIONS(4772),
    [anon_sym_unmanaged] = ACTIONS(4772),
    [anon_sym_TILDE] = ACTIONS(4774),
    [anon_sym_implicit] = ACTIONS(4772),
    [anon_sym_explicit] = ACTIONS(4772),
    [anon_sym_scoped] = ACTIONS(4772),
    [anon_sym_var] = ACTIONS(4772),
    [sym_predefined_type] = ACTIONS(4772),
    [anon_sym_yield] = ACTIONS(4772),
    [anon_sym_when] = ACTIONS(4772),
    [anon_sym_from] = ACTIONS(4772),
    [anon_sym_into] = ACTIONS(4772),
    [anon_sym_join] = ACTIONS(4772),
    [anon_sym_on] = ACTIONS(4772),
    [anon_sym_equals] = ACTIONS(4772),
    [anon_sym_let] = ACTIONS(4772),
    [anon_sym_orderby] = ACTIONS(4772),
    [anon_sym_ascending] = ACTIONS(4772),
    [anon_sym_descending] = ACTIONS(4772),
    [anon_sym_group] = ACTIONS(4772),
    [anon_sym_by] = ACTIONS(4772),
    [anon_sym_select] = ACTIONS(4772),
    [aux_sym_preproc_if_token1] = ACTIONS(4774),
    [aux_sym_preproc_if_token3] = ACTIONS(4774),
    [aux_sym_preproc_else_token1] = ACTIONS(4774),
    [aux_sym_preproc_elif_token1] = ACTIONS(4774),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3225] = {
    [sym_preproc_region] = STATE(3225),
    [sym_preproc_endregion] = STATE(3225),
    [sym_preproc_line] = STATE(3225),
    [sym_preproc_pragma] = STATE(3225),
    [sym_preproc_nullable] = STATE(3225),
    [sym_preproc_error] = STATE(3225),
    [sym_preproc_define] = STATE(3225),
    [sym_preproc_undef] = STATE(3225),
    [sym__identifier_token] = ACTIONS(2921),
    [anon_sym_extern] = ACTIONS(2921),
    [anon_sym_alias] = ACTIONS(2921),
    [anon_sym_global] = ACTIONS(2921),
    [anon_sym_using] = ACTIONS(2921),
    [anon_sym_unsafe] = ACTIONS(2921),
    [anon_sym_static] = ACTIONS(2921),
    [anon_sym_LBRACK] = ACTIONS(2923),
    [anon_sym_LPAREN] = ACTIONS(2923),
    [anon_sym_event] = ACTIONS(2921),
    [anon_sym_namespace] = ACTIONS(2921),
    [anon_sym_class] = ACTIONS(2921),
    [anon_sym_ref] = ACTIONS(2921),
    [anon_sym_struct] = ACTIONS(2921),
    [anon_sym_enum] = ACTIONS(2921),
    [anon_sym_RBRACE] = ACTIONS(2923),
    [anon_sym_interface] = ACTIONS(2921),
    [anon_sym_delegate] = ACTIONS(2921),
    [anon_sym_record] = ACTIONS(2921),
    [anon_sym_abstract] = ACTIONS(2921),
    [anon_sym_async] = ACTIONS(2921),
    [anon_sym_const] = ACTIONS(2921),
    [anon_sym_file] = ACTIONS(2921),
    [anon_sym_fixed] = ACTIONS(2921),
    [anon_sym_internal] = ACTIONS(2921),
    [anon_sym_new] = ACTIONS(2921),
    [anon_sym_override] = ACTIONS(2921),
    [anon_sym_partial] = ACTIONS(2921),
    [anon_sym_private] = ACTIONS(2921),
    [anon_sym_protected] = ACTIONS(2921),
    [anon_sym_public] = ACTIONS(2921),
    [anon_sym_readonly] = ACTIONS(2921),
    [anon_sym_required] = ACTIONS(2921),
    [anon_sym_sealed] = ACTIONS(2921),
    [anon_sym_virtual] = ACTIONS(2921),
    [anon_sym_volatile] = ACTIONS(2921),
    [anon_sym_where] = ACTIONS(2921),
    [anon_sym_notnull] = ACTIONS(2921),
    [anon_sym_unmanaged] = ACTIONS(2921),
    [anon_sym_TILDE] = ACTIONS(2923),
    [anon_sym_implicit] = ACTIONS(2921),
    [anon_sym_explicit] = ACTIONS(2921),
    [anon_sym_scoped] = ACTIONS(2921),
    [anon_sym_var] = ACTIONS(2921),
    [sym_predefined_type] = ACTIONS(2921),
    [anon_sym_yield] = ACTIONS(2921),
    [anon_sym_when] = ACTIONS(2921),
    [anon_sym_from] = ACTIONS(2921),
    [anon_sym_into] = ACTIONS(2921),
    [anon_sym_join] = ACTIONS(2921),
    [anon_sym_on] = ACTIONS(2921),
    [anon_sym_equals] = ACTIONS(2921),
    [anon_sym_let] = ACTIONS(2921),
    [anon_sym_orderby] = ACTIONS(2921),
    [anon_sym_ascending] = ACTIONS(2921),
    [anon_sym_descending] = ACTIONS(2921),
    [anon_sym_group] = ACTIONS(2921),
    [anon_sym_by] = ACTIONS(2921),
    [anon_sym_select] = ACTIONS(2921),
    [aux_sym_preproc_if_token1] = ACTIONS(2923),
    [aux_sym_preproc_if_token3] = ACTIONS(2923),
    [aux_sym_preproc_else_token1] = ACTIONS(2923),
    [aux_sym_preproc_elif_token1] = ACTIONS(2923),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3226] = {
    [sym_preproc_region] = STATE(3226),
    [sym_preproc_endregion] = STATE(3226),
    [sym_preproc_line] = STATE(3226),
    [sym_preproc_pragma] = STATE(3226),
    [sym_preproc_nullable] = STATE(3226),
    [sym_preproc_error] = STATE(3226),
    [sym_preproc_define] = STATE(3226),
    [sym_preproc_undef] = STATE(3226),
    [sym__identifier_token] = ACTIONS(3461),
    [anon_sym_extern] = ACTIONS(3461),
    [anon_sym_alias] = ACTIONS(3461),
    [anon_sym_global] = ACTIONS(3461),
    [anon_sym_using] = ACTIONS(3461),
    [anon_sym_unsafe] = ACTIONS(3461),
    [anon_sym_static] = ACTIONS(3461),
    [anon_sym_LBRACK] = ACTIONS(3463),
    [anon_sym_LPAREN] = ACTIONS(3463),
    [anon_sym_event] = ACTIONS(3461),
    [anon_sym_namespace] = ACTIONS(3461),
    [anon_sym_class] = ACTIONS(3461),
    [anon_sym_ref] = ACTIONS(3461),
    [anon_sym_struct] = ACTIONS(3461),
    [anon_sym_enum] = ACTIONS(3461),
    [anon_sym_RBRACE] = ACTIONS(3463),
    [anon_sym_interface] = ACTIONS(3461),
    [anon_sym_delegate] = ACTIONS(3461),
    [anon_sym_record] = ACTIONS(3461),
    [anon_sym_abstract] = ACTIONS(3461),
    [anon_sym_async] = ACTIONS(3461),
    [anon_sym_const] = ACTIONS(3461),
    [anon_sym_file] = ACTIONS(3461),
    [anon_sym_fixed] = ACTIONS(3461),
    [anon_sym_internal] = ACTIONS(3461),
    [anon_sym_new] = ACTIONS(3461),
    [anon_sym_override] = ACTIONS(3461),
    [anon_sym_partial] = ACTIONS(3461),
    [anon_sym_private] = ACTIONS(3461),
    [anon_sym_protected] = ACTIONS(3461),
    [anon_sym_public] = ACTIONS(3461),
    [anon_sym_readonly] = ACTIONS(3461),
    [anon_sym_required] = ACTIONS(3461),
    [anon_sym_sealed] = ACTIONS(3461),
    [anon_sym_virtual] = ACTIONS(3461),
    [anon_sym_volatile] = ACTIONS(3461),
    [anon_sym_where] = ACTIONS(3461),
    [anon_sym_notnull] = ACTIONS(3461),
    [anon_sym_unmanaged] = ACTIONS(3461),
    [anon_sym_TILDE] = ACTIONS(3463),
    [anon_sym_implicit] = ACTIONS(3461),
    [anon_sym_explicit] = ACTIONS(3461),
    [anon_sym_scoped] = ACTIONS(3461),
    [anon_sym_var] = ACTIONS(3461),
    [sym_predefined_type] = ACTIONS(3461),
    [anon_sym_yield] = ACTIONS(3461),
    [anon_sym_when] = ACTIONS(3461),
    [anon_sym_from] = ACTIONS(3461),
    [anon_sym_into] = ACTIONS(3461),
    [anon_sym_join] = ACTIONS(3461),
    [anon_sym_on] = ACTIONS(3461),
    [anon_sym_equals] = ACTIONS(3461),
    [anon_sym_let] = ACTIONS(3461),
    [anon_sym_orderby] = ACTIONS(3461),
    [anon_sym_ascending] = ACTIONS(3461),
    [anon_sym_descending] = ACTIONS(3461),
    [anon_sym_group] = ACTIONS(3461),
    [anon_sym_by] = ACTIONS(3461),
    [anon_sym_select] = ACTIONS(3461),
    [aux_sym_preproc_if_token1] = ACTIONS(3463),
    [aux_sym_preproc_if_token3] = ACTIONS(3463),
    [aux_sym_preproc_else_token1] = ACTIONS(3463),
    [aux_sym_preproc_elif_token1] = ACTIONS(3463),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3227] = {
    [sym__variable_designation] = STATE(4246),
    [sym_parenthesized_variable_designation] = STATE(4274),
    [sym_identifier] = STATE(4269),
    [sym__reserved_identifier] = STATE(3908),
    [sym_preproc_region] = STATE(3227),
    [sym_preproc_endregion] = STATE(3227),
    [sym_preproc_line] = STATE(3227),
    [sym_preproc_pragma] = STATE(3227),
    [sym_preproc_nullable] = STATE(3227),
    [sym_preproc_error] = STATE(3227),
    [sym_preproc_define] = STATE(3227),
    [sym_preproc_undef] = STATE(3227),
    [sym__identifier_token] = ACTIONS(4271),
    [anon_sym_alias] = ACTIONS(4273),
    [anon_sym_global] = ACTIONS(4273),
    [anon_sym_LBRACK] = ACTIONS(4329),
    [anon_sym_LPAREN] = ACTIONS(4329),
    [anon_sym_file] = ACTIONS(4273),
    [anon_sym_LT] = ACTIONS(4331),
    [anon_sym_GT] = ACTIONS(4331),
    [anon_sym_where] = ACTIONS(4273),
    [anon_sym_QMARK] = ACTIONS(4331),
    [anon_sym_notnull] = ACTIONS(4273),
    [anon_sym_unmanaged] = ACTIONS(4273),
    [anon_sym_BANG] = ACTIONS(4331),
    [anon_sym_PLUS_PLUS] = ACTIONS(4329),
    [anon_sym_DASH_DASH] = ACTIONS(4329),
    [anon_sym_PLUS] = ACTIONS(4331),
    [anon_sym_DASH] = ACTIONS(4331),
    [anon_sym_STAR] = ACTIONS(4329),
    [anon_sym_SLASH] = ACTIONS(4331),
    [anon_sym_PERCENT] = ACTIONS(4329),
    [anon_sym_CARET] = ACTIONS(4329),
    [anon_sym_PIPE] = ACTIONS(4331),
    [anon_sym_AMP] = ACTIONS(4331),
    [anon_sym_LT_LT] = ACTIONS(4329),
    [anon_sym_GT_GT] = ACTIONS(4331),
    [anon_sym_GT_GT_GT] = ACTIONS(4329),
    [anon_sym_EQ_EQ] = ACTIONS(4329),
    [anon_sym_BANG_EQ] = ACTIONS(4329),
    [anon_sym_GT_EQ] = ACTIONS(4329),
    [anon_sym_LT_EQ] = ACTIONS(4329),
    [anon_sym_DOT] = ACTIONS(4331),
    [anon_sym_scoped] = ACTIONS(4273),
    [anon_sym_var] = ACTIONS(4273),
    [anon_sym_yield] = ACTIONS(4273),
    [anon_sym_switch] = ACTIONS(4331),
    [anon_sym_when] = ACTIONS(4273),
    [sym_discard] = ACTIONS(4295),
    [anon_sym_DOT_DOT] = ACTIONS(4329),
    [anon_sym_and] = ACTIONS(4331),
    [anon_sym_or] = ACTIONS(4331),
    [anon_sym_AMP_AMP] = ACTIONS(4329),
    [anon_sym_PIPE_PIPE] = ACTIONS(4329),
    [anon_sym_QMARK_QMARK] = ACTIONS(4329),
    [anon_sym_from] = ACTIONS(4273),
    [anon_sym_into] = ACTIONS(4273),
    [anon_sym_join] = ACTIONS(4273),
    [anon_sym_on] = ACTIONS(4273),
    [anon_sym_equals] = ACTIONS(4273),
    [anon_sym_let] = ACTIONS(4273),
    [anon_sym_orderby] = ACTIONS(4273),
    [anon_sym_ascending] = ACTIONS(4273),
    [anon_sym_descending] = ACTIONS(4273),
    [anon_sym_group] = ACTIONS(4273),
    [anon_sym_by] = ACTIONS(4331),
    [anon_sym_select] = ACTIONS(4273),
    [anon_sym_as] = ACTIONS(4331),
    [anon_sym_is] = ACTIONS(4331),
    [anon_sym_DASH_GT] = ACTIONS(4329),
    [anon_sym_with] = ACTIONS(4331),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3228] = {
    [sym_preproc_region] = STATE(3228),
    [sym_preproc_endregion] = STATE(3228),
    [sym_preproc_line] = STATE(3228),
    [sym_preproc_pragma] = STATE(3228),
    [sym_preproc_nullable] = STATE(3228),
    [sym_preproc_error] = STATE(3228),
    [sym_preproc_define] = STATE(3228),
    [sym_preproc_undef] = STATE(3228),
    [sym__identifier_token] = ACTIONS(4776),
    [anon_sym_extern] = ACTIONS(4776),
    [anon_sym_alias] = ACTIONS(4776),
    [anon_sym_global] = ACTIONS(4776),
    [anon_sym_using] = ACTIONS(4776),
    [anon_sym_unsafe] = ACTIONS(4776),
    [anon_sym_static] = ACTIONS(4776),
    [anon_sym_LBRACK] = ACTIONS(4778),
    [anon_sym_LPAREN] = ACTIONS(4778),
    [anon_sym_event] = ACTIONS(4776),
    [anon_sym_namespace] = ACTIONS(4776),
    [anon_sym_class] = ACTIONS(4776),
    [anon_sym_ref] = ACTIONS(4776),
    [anon_sym_struct] = ACTIONS(4776),
    [anon_sym_enum] = ACTIONS(4776),
    [anon_sym_RBRACE] = ACTIONS(4778),
    [anon_sym_interface] = ACTIONS(4776),
    [anon_sym_delegate] = ACTIONS(4776),
    [anon_sym_record] = ACTIONS(4776),
    [anon_sym_abstract] = ACTIONS(4776),
    [anon_sym_async] = ACTIONS(4776),
    [anon_sym_const] = ACTIONS(4776),
    [anon_sym_file] = ACTIONS(4776),
    [anon_sym_fixed] = ACTIONS(4776),
    [anon_sym_internal] = ACTIONS(4776),
    [anon_sym_new] = ACTIONS(4776),
    [anon_sym_override] = ACTIONS(4776),
    [anon_sym_partial] = ACTIONS(4776),
    [anon_sym_private] = ACTIONS(4776),
    [anon_sym_protected] = ACTIONS(4776),
    [anon_sym_public] = ACTIONS(4776),
    [anon_sym_readonly] = ACTIONS(4776),
    [anon_sym_required] = ACTIONS(4776),
    [anon_sym_sealed] = ACTIONS(4776),
    [anon_sym_virtual] = ACTIONS(4776),
    [anon_sym_volatile] = ACTIONS(4776),
    [anon_sym_where] = ACTIONS(4776),
    [anon_sym_notnull] = ACTIONS(4776),
    [anon_sym_unmanaged] = ACTIONS(4776),
    [anon_sym_TILDE] = ACTIONS(4778),
    [anon_sym_implicit] = ACTIONS(4776),
    [anon_sym_explicit] = ACTIONS(4776),
    [anon_sym_scoped] = ACTIONS(4776),
    [anon_sym_var] = ACTIONS(4776),
    [sym_predefined_type] = ACTIONS(4776),
    [anon_sym_yield] = ACTIONS(4776),
    [anon_sym_when] = ACTIONS(4776),
    [anon_sym_from] = ACTIONS(4776),
    [anon_sym_into] = ACTIONS(4776),
    [anon_sym_join] = ACTIONS(4776),
    [anon_sym_on] = ACTIONS(4776),
    [anon_sym_equals] = ACTIONS(4776),
    [anon_sym_let] = ACTIONS(4776),
    [anon_sym_orderby] = ACTIONS(4776),
    [anon_sym_ascending] = ACTIONS(4776),
    [anon_sym_descending] = ACTIONS(4776),
    [anon_sym_group] = ACTIONS(4776),
    [anon_sym_by] = ACTIONS(4776),
    [anon_sym_select] = ACTIONS(4776),
    [aux_sym_preproc_if_token1] = ACTIONS(4778),
    [aux_sym_preproc_if_token3] = ACTIONS(4778),
    [aux_sym_preproc_else_token1] = ACTIONS(4778),
    [aux_sym_preproc_elif_token1] = ACTIONS(4778),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3229] = {
    [sym_preproc_region] = STATE(3229),
    [sym_preproc_endregion] = STATE(3229),
    [sym_preproc_line] = STATE(3229),
    [sym_preproc_pragma] = STATE(3229),
    [sym_preproc_nullable] = STATE(3229),
    [sym_preproc_error] = STATE(3229),
    [sym_preproc_define] = STATE(3229),
    [sym_preproc_undef] = STATE(3229),
    [sym__identifier_token] = ACTIONS(3561),
    [anon_sym_extern] = ACTIONS(3561),
    [anon_sym_alias] = ACTIONS(3561),
    [anon_sym_global] = ACTIONS(3561),
    [anon_sym_using] = ACTIONS(3561),
    [anon_sym_unsafe] = ACTIONS(3561),
    [anon_sym_static] = ACTIONS(3561),
    [anon_sym_LBRACK] = ACTIONS(3563),
    [anon_sym_LPAREN] = ACTIONS(3563),
    [anon_sym_event] = ACTIONS(3561),
    [anon_sym_namespace] = ACTIONS(3561),
    [anon_sym_class] = ACTIONS(3561),
    [anon_sym_ref] = ACTIONS(3561),
    [anon_sym_struct] = ACTIONS(3561),
    [anon_sym_enum] = ACTIONS(3561),
    [anon_sym_RBRACE] = ACTIONS(3563),
    [anon_sym_interface] = ACTIONS(3561),
    [anon_sym_delegate] = ACTIONS(3561),
    [anon_sym_record] = ACTIONS(3561),
    [anon_sym_abstract] = ACTIONS(3561),
    [anon_sym_async] = ACTIONS(3561),
    [anon_sym_const] = ACTIONS(3561),
    [anon_sym_file] = ACTIONS(3561),
    [anon_sym_fixed] = ACTIONS(3561),
    [anon_sym_internal] = ACTIONS(3561),
    [anon_sym_new] = ACTIONS(3561),
    [anon_sym_override] = ACTIONS(3561),
    [anon_sym_partial] = ACTIONS(3561),
    [anon_sym_private] = ACTIONS(3561),
    [anon_sym_protected] = ACTIONS(3561),
    [anon_sym_public] = ACTIONS(3561),
    [anon_sym_readonly] = ACTIONS(3561),
    [anon_sym_required] = ACTIONS(3561),
    [anon_sym_sealed] = ACTIONS(3561),
    [anon_sym_virtual] = ACTIONS(3561),
    [anon_sym_volatile] = ACTIONS(3561),
    [anon_sym_where] = ACTIONS(3561),
    [anon_sym_notnull] = ACTIONS(3561),
    [anon_sym_unmanaged] = ACTIONS(3561),
    [anon_sym_TILDE] = ACTIONS(3563),
    [anon_sym_implicit] = ACTIONS(3561),
    [anon_sym_explicit] = ACTIONS(3561),
    [anon_sym_scoped] = ACTIONS(3561),
    [anon_sym_var] = ACTIONS(3561),
    [sym_predefined_type] = ACTIONS(3561),
    [anon_sym_yield] = ACTIONS(3561),
    [anon_sym_when] = ACTIONS(3561),
    [anon_sym_from] = ACTIONS(3561),
    [anon_sym_into] = ACTIONS(3561),
    [anon_sym_join] = ACTIONS(3561),
    [anon_sym_on] = ACTIONS(3561),
    [anon_sym_equals] = ACTIONS(3561),
    [anon_sym_let] = ACTIONS(3561),
    [anon_sym_orderby] = ACTIONS(3561),
    [anon_sym_ascending] = ACTIONS(3561),
    [anon_sym_descending] = ACTIONS(3561),
    [anon_sym_group] = ACTIONS(3561),
    [anon_sym_by] = ACTIONS(3561),
    [anon_sym_select] = ACTIONS(3561),
    [aux_sym_preproc_if_token1] = ACTIONS(3563),
    [aux_sym_preproc_if_token3] = ACTIONS(3563),
    [aux_sym_preproc_else_token1] = ACTIONS(3563),
    [aux_sym_preproc_elif_token1] = ACTIONS(3563),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3230] = {
    [sym_preproc_region] = STATE(3230),
    [sym_preproc_endregion] = STATE(3230),
    [sym_preproc_line] = STATE(3230),
    [sym_preproc_pragma] = STATE(3230),
    [sym_preproc_nullable] = STATE(3230),
    [sym_preproc_error] = STATE(3230),
    [sym_preproc_define] = STATE(3230),
    [sym_preproc_undef] = STATE(3230),
    [sym__identifier_token] = ACTIONS(2967),
    [anon_sym_extern] = ACTIONS(2967),
    [anon_sym_alias] = ACTIONS(2967),
    [anon_sym_global] = ACTIONS(2967),
    [anon_sym_using] = ACTIONS(2967),
    [anon_sym_unsafe] = ACTIONS(2967),
    [anon_sym_static] = ACTIONS(2967),
    [anon_sym_LBRACK] = ACTIONS(2969),
    [anon_sym_LPAREN] = ACTIONS(2969),
    [anon_sym_event] = ACTIONS(2967),
    [anon_sym_namespace] = ACTIONS(2967),
    [anon_sym_class] = ACTIONS(2967),
    [anon_sym_ref] = ACTIONS(2967),
    [anon_sym_struct] = ACTIONS(2967),
    [anon_sym_enum] = ACTIONS(2967),
    [anon_sym_RBRACE] = ACTIONS(2969),
    [anon_sym_interface] = ACTIONS(2967),
    [anon_sym_delegate] = ACTIONS(2967),
    [anon_sym_record] = ACTIONS(2967),
    [anon_sym_abstract] = ACTIONS(2967),
    [anon_sym_async] = ACTIONS(2967),
    [anon_sym_const] = ACTIONS(2967),
    [anon_sym_file] = ACTIONS(2967),
    [anon_sym_fixed] = ACTIONS(2967),
    [anon_sym_internal] = ACTIONS(2967),
    [anon_sym_new] = ACTIONS(2967),
    [anon_sym_override] = ACTIONS(2967),
    [anon_sym_partial] = ACTIONS(2967),
    [anon_sym_private] = ACTIONS(2967),
    [anon_sym_protected] = ACTIONS(2967),
    [anon_sym_public] = ACTIONS(2967),
    [anon_sym_readonly] = ACTIONS(2967),
    [anon_sym_required] = ACTIONS(2967),
    [anon_sym_sealed] = ACTIONS(2967),
    [anon_sym_virtual] = ACTIONS(2967),
    [anon_sym_volatile] = ACTIONS(2967),
    [anon_sym_where] = ACTIONS(2967),
    [anon_sym_notnull] = ACTIONS(2967),
    [anon_sym_unmanaged] = ACTIONS(2967),
    [anon_sym_TILDE] = ACTIONS(2969),
    [anon_sym_implicit] = ACTIONS(2967),
    [anon_sym_explicit] = ACTIONS(2967),
    [anon_sym_scoped] = ACTIONS(2967),
    [anon_sym_var] = ACTIONS(2967),
    [sym_predefined_type] = ACTIONS(2967),
    [anon_sym_yield] = ACTIONS(2967),
    [anon_sym_when] = ACTIONS(2967),
    [anon_sym_from] = ACTIONS(2967),
    [anon_sym_into] = ACTIONS(2967),
    [anon_sym_join] = ACTIONS(2967),
    [anon_sym_on] = ACTIONS(2967),
    [anon_sym_equals] = ACTIONS(2967),
    [anon_sym_let] = ACTIONS(2967),
    [anon_sym_orderby] = ACTIONS(2967),
    [anon_sym_ascending] = ACTIONS(2967),
    [anon_sym_descending] = ACTIONS(2967),
    [anon_sym_group] = ACTIONS(2967),
    [anon_sym_by] = ACTIONS(2967),
    [anon_sym_select] = ACTIONS(2967),
    [aux_sym_preproc_if_token1] = ACTIONS(2969),
    [aux_sym_preproc_if_token3] = ACTIONS(2969),
    [aux_sym_preproc_else_token1] = ACTIONS(2969),
    [aux_sym_preproc_elif_token1] = ACTIONS(2969),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3231] = {
    [sym_preproc_region] = STATE(3231),
    [sym_preproc_endregion] = STATE(3231),
    [sym_preproc_line] = STATE(3231),
    [sym_preproc_pragma] = STATE(3231),
    [sym_preproc_nullable] = STATE(3231),
    [sym_preproc_error] = STATE(3231),
    [sym_preproc_define] = STATE(3231),
    [sym_preproc_undef] = STATE(3231),
    [sym__identifier_token] = ACTIONS(3808),
    [anon_sym_extern] = ACTIONS(3808),
    [anon_sym_alias] = ACTIONS(3808),
    [anon_sym_global] = ACTIONS(3808),
    [anon_sym_using] = ACTIONS(3808),
    [anon_sym_unsafe] = ACTIONS(3808),
    [anon_sym_static] = ACTIONS(3808),
    [anon_sym_LBRACK] = ACTIONS(3810),
    [anon_sym_LPAREN] = ACTIONS(3810),
    [anon_sym_event] = ACTIONS(3808),
    [anon_sym_namespace] = ACTIONS(3808),
    [anon_sym_class] = ACTIONS(3808),
    [anon_sym_ref] = ACTIONS(3808),
    [anon_sym_struct] = ACTIONS(3808),
    [anon_sym_enum] = ACTIONS(3808),
    [anon_sym_RBRACE] = ACTIONS(3810),
    [anon_sym_interface] = ACTIONS(3808),
    [anon_sym_delegate] = ACTIONS(3808),
    [anon_sym_record] = ACTIONS(3808),
    [anon_sym_abstract] = ACTIONS(3808),
    [anon_sym_async] = ACTIONS(3808),
    [anon_sym_const] = ACTIONS(3808),
    [anon_sym_file] = ACTIONS(3808),
    [anon_sym_fixed] = ACTIONS(3808),
    [anon_sym_internal] = ACTIONS(3808),
    [anon_sym_new] = ACTIONS(3808),
    [anon_sym_override] = ACTIONS(3808),
    [anon_sym_partial] = ACTIONS(3808),
    [anon_sym_private] = ACTIONS(3808),
    [anon_sym_protected] = ACTIONS(3808),
    [anon_sym_public] = ACTIONS(3808),
    [anon_sym_readonly] = ACTIONS(3808),
    [anon_sym_required] = ACTIONS(3808),
    [anon_sym_sealed] = ACTIONS(3808),
    [anon_sym_virtual] = ACTIONS(3808),
    [anon_sym_volatile] = ACTIONS(3808),
    [anon_sym_where] = ACTIONS(3808),
    [anon_sym_notnull] = ACTIONS(3808),
    [anon_sym_unmanaged] = ACTIONS(3808),
    [anon_sym_TILDE] = ACTIONS(3810),
    [anon_sym_implicit] = ACTIONS(3808),
    [anon_sym_explicit] = ACTIONS(3808),
    [anon_sym_scoped] = ACTIONS(3808),
    [anon_sym_var] = ACTIONS(3808),
    [sym_predefined_type] = ACTIONS(3808),
    [anon_sym_yield] = ACTIONS(3808),
    [anon_sym_when] = ACTIONS(3808),
    [anon_sym_from] = ACTIONS(3808),
    [anon_sym_into] = ACTIONS(3808),
    [anon_sym_join] = ACTIONS(3808),
    [anon_sym_on] = ACTIONS(3808),
    [anon_sym_equals] = ACTIONS(3808),
    [anon_sym_let] = ACTIONS(3808),
    [anon_sym_orderby] = ACTIONS(3808),
    [anon_sym_ascending] = ACTIONS(3808),
    [anon_sym_descending] = ACTIONS(3808),
    [anon_sym_group] = ACTIONS(3808),
    [anon_sym_by] = ACTIONS(3808),
    [anon_sym_select] = ACTIONS(3808),
    [aux_sym_preproc_if_token1] = ACTIONS(3810),
    [aux_sym_preproc_if_token3] = ACTIONS(3810),
    [aux_sym_preproc_else_token1] = ACTIONS(3810),
    [aux_sym_preproc_elif_token1] = ACTIONS(3810),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3232] = {
    [sym_preproc_region] = STATE(3232),
    [sym_preproc_endregion] = STATE(3232),
    [sym_preproc_line] = STATE(3232),
    [sym_preproc_pragma] = STATE(3232),
    [sym_preproc_nullable] = STATE(3232),
    [sym_preproc_error] = STATE(3232),
    [sym_preproc_define] = STATE(3232),
    [sym_preproc_undef] = STATE(3232),
    [sym__identifier_token] = ACTIONS(4780),
    [anon_sym_extern] = ACTIONS(4780),
    [anon_sym_alias] = ACTIONS(4780),
    [anon_sym_global] = ACTIONS(4780),
    [anon_sym_using] = ACTIONS(4780),
    [anon_sym_unsafe] = ACTIONS(4780),
    [anon_sym_static] = ACTIONS(4780),
    [anon_sym_LBRACK] = ACTIONS(4782),
    [anon_sym_LPAREN] = ACTIONS(4782),
    [anon_sym_event] = ACTIONS(4780),
    [anon_sym_namespace] = ACTIONS(4780),
    [anon_sym_class] = ACTIONS(4780),
    [anon_sym_ref] = ACTIONS(4780),
    [anon_sym_struct] = ACTIONS(4780),
    [anon_sym_enum] = ACTIONS(4780),
    [anon_sym_RBRACE] = ACTIONS(4782),
    [anon_sym_interface] = ACTIONS(4780),
    [anon_sym_delegate] = ACTIONS(4780),
    [anon_sym_record] = ACTIONS(4780),
    [anon_sym_abstract] = ACTIONS(4780),
    [anon_sym_async] = ACTIONS(4780),
    [anon_sym_const] = ACTIONS(4780),
    [anon_sym_file] = ACTIONS(4780),
    [anon_sym_fixed] = ACTIONS(4780),
    [anon_sym_internal] = ACTIONS(4780),
    [anon_sym_new] = ACTIONS(4780),
    [anon_sym_override] = ACTIONS(4780),
    [anon_sym_partial] = ACTIONS(4780),
    [anon_sym_private] = ACTIONS(4780),
    [anon_sym_protected] = ACTIONS(4780),
    [anon_sym_public] = ACTIONS(4780),
    [anon_sym_readonly] = ACTIONS(4780),
    [anon_sym_required] = ACTIONS(4780),
    [anon_sym_sealed] = ACTIONS(4780),
    [anon_sym_virtual] = ACTIONS(4780),
    [anon_sym_volatile] = ACTIONS(4780),
    [anon_sym_where] = ACTIONS(4780),
    [anon_sym_notnull] = ACTIONS(4780),
    [anon_sym_unmanaged] = ACTIONS(4780),
    [anon_sym_TILDE] = ACTIONS(4782),
    [anon_sym_implicit] = ACTIONS(4780),
    [anon_sym_explicit] = ACTIONS(4780),
    [anon_sym_scoped] = ACTIONS(4780),
    [anon_sym_var] = ACTIONS(4780),
    [sym_predefined_type] = ACTIONS(4780),
    [anon_sym_yield] = ACTIONS(4780),
    [anon_sym_when] = ACTIONS(4780),
    [anon_sym_from] = ACTIONS(4780),
    [anon_sym_into] = ACTIONS(4780),
    [anon_sym_join] = ACTIONS(4780),
    [anon_sym_on] = ACTIONS(4780),
    [anon_sym_equals] = ACTIONS(4780),
    [anon_sym_let] = ACTIONS(4780),
    [anon_sym_orderby] = ACTIONS(4780),
    [anon_sym_ascending] = ACTIONS(4780),
    [anon_sym_descending] = ACTIONS(4780),
    [anon_sym_group] = ACTIONS(4780),
    [anon_sym_by] = ACTIONS(4780),
    [anon_sym_select] = ACTIONS(4780),
    [aux_sym_preproc_if_token1] = ACTIONS(4782),
    [aux_sym_preproc_if_token3] = ACTIONS(4782),
    [aux_sym_preproc_else_token1] = ACTIONS(4782),
    [aux_sym_preproc_elif_token1] = ACTIONS(4782),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3233] = {
    [sym_preproc_region] = STATE(3233),
    [sym_preproc_endregion] = STATE(3233),
    [sym_preproc_line] = STATE(3233),
    [sym_preproc_pragma] = STATE(3233),
    [sym_preproc_nullable] = STATE(3233),
    [sym_preproc_error] = STATE(3233),
    [sym_preproc_define] = STATE(3233),
    [sym_preproc_undef] = STATE(3233),
    [anon_sym_SEMI] = ACTIONS(4087),
    [anon_sym_EQ] = ACTIONS(4085),
    [anon_sym_LBRACK] = ACTIONS(4087),
    [anon_sym_COLON] = ACTIONS(4087),
    [anon_sym_COMMA] = ACTIONS(4087),
    [anon_sym_RBRACK] = ACTIONS(4087),
    [anon_sym_LPAREN] = ACTIONS(4087),
    [anon_sym_RPAREN] = ACTIONS(4087),
    [anon_sym_RBRACE] = ACTIONS(4087),
    [anon_sym_LT] = ACTIONS(4085),
    [anon_sym_GT] = ACTIONS(4085),
    [anon_sym_in] = ACTIONS(4087),
    [anon_sym_QMARK] = ACTIONS(4085),
    [anon_sym_BANG] = ACTIONS(4085),
    [anon_sym_PLUS_PLUS] = ACTIONS(4087),
    [anon_sym_DASH_DASH] = ACTIONS(4087),
    [anon_sym_PLUS] = ACTIONS(4085),
    [anon_sym_DASH] = ACTIONS(4085),
    [anon_sym_STAR] = ACTIONS(4085),
    [anon_sym_SLASH] = ACTIONS(4085),
    [anon_sym_PERCENT] = ACTIONS(4085),
    [anon_sym_CARET] = ACTIONS(4085),
    [anon_sym_PIPE] = ACTIONS(4085),
    [anon_sym_AMP] = ACTIONS(4085),
    [anon_sym_LT_LT] = ACTIONS(4085),
    [anon_sym_GT_GT] = ACTIONS(4085),
    [anon_sym_GT_GT_GT] = ACTIONS(4085),
    [anon_sym_EQ_EQ] = ACTIONS(4087),
    [anon_sym_BANG_EQ] = ACTIONS(4087),
    [anon_sym_GT_EQ] = ACTIONS(4087),
    [anon_sym_LT_EQ] = ACTIONS(4087),
    [anon_sym_DOT] = ACTIONS(4085),
    [anon_sym_EQ_GT] = ACTIONS(4087),
    [anon_sym_switch] = ACTIONS(4087),
    [anon_sym_when] = ACTIONS(4087),
    [anon_sym_DOT_DOT] = ACTIONS(4087),
    [anon_sym_and] = ACTIONS(4087),
    [anon_sym_or] = ACTIONS(4087),
    [anon_sym_PLUS_EQ] = ACTIONS(4087),
    [anon_sym_DASH_EQ] = ACTIONS(4087),
    [anon_sym_STAR_EQ] = ACTIONS(4087),
    [anon_sym_SLASH_EQ] = ACTIONS(4087),
    [anon_sym_PERCENT_EQ] = ACTIONS(4087),
    [anon_sym_AMP_EQ] = ACTIONS(4087),
    [anon_sym_CARET_EQ] = ACTIONS(4087),
    [anon_sym_PIPE_EQ] = ACTIONS(4087),
    [anon_sym_LT_LT_EQ] = ACTIONS(4087),
    [anon_sym_GT_GT_EQ] = ACTIONS(4087),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4087),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4087),
    [anon_sym_AMP_AMP] = ACTIONS(4087),
    [anon_sym_PIPE_PIPE] = ACTIONS(4087),
    [anon_sym_QMARK_QMARK] = ACTIONS(4085),
    [anon_sym_on] = ACTIONS(4087),
    [anon_sym_equals] = ACTIONS(4087),
    [anon_sym_by] = ACTIONS(4087),
    [anon_sym_as] = ACTIONS(4087),
    [anon_sym_is] = ACTIONS(4087),
    [anon_sym_DASH_GT] = ACTIONS(4087),
    [anon_sym_with] = ACTIONS(4087),
    [aux_sym_preproc_if_token3] = ACTIONS(4087),
    [aux_sym_preproc_else_token1] = ACTIONS(4087),
    [aux_sym_preproc_elif_token1] = ACTIONS(4087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3234] = {
    [sym_preproc_region] = STATE(3234),
    [sym_preproc_endregion] = STATE(3234),
    [sym_preproc_line] = STATE(3234),
    [sym_preproc_pragma] = STATE(3234),
    [sym_preproc_nullable] = STATE(3234),
    [sym_preproc_error] = STATE(3234),
    [sym_preproc_define] = STATE(3234),
    [sym_preproc_undef] = STATE(3234),
    [sym__identifier_token] = ACTIONS(4784),
    [anon_sym_extern] = ACTIONS(4784),
    [anon_sym_alias] = ACTIONS(4784),
    [anon_sym_global] = ACTIONS(4784),
    [anon_sym_using] = ACTIONS(4784),
    [anon_sym_unsafe] = ACTIONS(4784),
    [anon_sym_static] = ACTIONS(4784),
    [anon_sym_LBRACK] = ACTIONS(4786),
    [anon_sym_LPAREN] = ACTIONS(4786),
    [anon_sym_event] = ACTIONS(4784),
    [anon_sym_namespace] = ACTIONS(4784),
    [anon_sym_class] = ACTIONS(4784),
    [anon_sym_ref] = ACTIONS(4784),
    [anon_sym_struct] = ACTIONS(4784),
    [anon_sym_enum] = ACTIONS(4784),
    [anon_sym_RBRACE] = ACTIONS(4786),
    [anon_sym_interface] = ACTIONS(4784),
    [anon_sym_delegate] = ACTIONS(4784),
    [anon_sym_record] = ACTIONS(4784),
    [anon_sym_abstract] = ACTIONS(4784),
    [anon_sym_async] = ACTIONS(4784),
    [anon_sym_const] = ACTIONS(4784),
    [anon_sym_file] = ACTIONS(4784),
    [anon_sym_fixed] = ACTIONS(4784),
    [anon_sym_internal] = ACTIONS(4784),
    [anon_sym_new] = ACTIONS(4784),
    [anon_sym_override] = ACTIONS(4784),
    [anon_sym_partial] = ACTIONS(4784),
    [anon_sym_private] = ACTIONS(4784),
    [anon_sym_protected] = ACTIONS(4784),
    [anon_sym_public] = ACTIONS(4784),
    [anon_sym_readonly] = ACTIONS(4784),
    [anon_sym_required] = ACTIONS(4784),
    [anon_sym_sealed] = ACTIONS(4784),
    [anon_sym_virtual] = ACTIONS(4784),
    [anon_sym_volatile] = ACTIONS(4784),
    [anon_sym_where] = ACTIONS(4784),
    [anon_sym_notnull] = ACTIONS(4784),
    [anon_sym_unmanaged] = ACTIONS(4784),
    [anon_sym_TILDE] = ACTIONS(4786),
    [anon_sym_implicit] = ACTIONS(4784),
    [anon_sym_explicit] = ACTIONS(4784),
    [anon_sym_scoped] = ACTIONS(4784),
    [anon_sym_var] = ACTIONS(4784),
    [sym_predefined_type] = ACTIONS(4784),
    [anon_sym_yield] = ACTIONS(4784),
    [anon_sym_when] = ACTIONS(4784),
    [anon_sym_from] = ACTIONS(4784),
    [anon_sym_into] = ACTIONS(4784),
    [anon_sym_join] = ACTIONS(4784),
    [anon_sym_on] = ACTIONS(4784),
    [anon_sym_equals] = ACTIONS(4784),
    [anon_sym_let] = ACTIONS(4784),
    [anon_sym_orderby] = ACTIONS(4784),
    [anon_sym_ascending] = ACTIONS(4784),
    [anon_sym_descending] = ACTIONS(4784),
    [anon_sym_group] = ACTIONS(4784),
    [anon_sym_by] = ACTIONS(4784),
    [anon_sym_select] = ACTIONS(4784),
    [aux_sym_preproc_if_token1] = ACTIONS(4786),
    [aux_sym_preproc_if_token3] = ACTIONS(4786),
    [aux_sym_preproc_else_token1] = ACTIONS(4786),
    [aux_sym_preproc_elif_token1] = ACTIONS(4786),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3235] = {
    [sym_preproc_region] = STATE(3235),
    [sym_preproc_endregion] = STATE(3235),
    [sym_preproc_line] = STATE(3235),
    [sym_preproc_pragma] = STATE(3235),
    [sym_preproc_nullable] = STATE(3235),
    [sym_preproc_error] = STATE(3235),
    [sym_preproc_define] = STATE(3235),
    [sym_preproc_undef] = STATE(3235),
    [sym__identifier_token] = ACTIONS(3457),
    [anon_sym_extern] = ACTIONS(3457),
    [anon_sym_alias] = ACTIONS(3457),
    [anon_sym_global] = ACTIONS(3457),
    [anon_sym_using] = ACTIONS(3457),
    [anon_sym_unsafe] = ACTIONS(3457),
    [anon_sym_static] = ACTIONS(3457),
    [anon_sym_LBRACK] = ACTIONS(3459),
    [anon_sym_LPAREN] = ACTIONS(3459),
    [anon_sym_event] = ACTIONS(3457),
    [anon_sym_namespace] = ACTIONS(3457),
    [anon_sym_class] = ACTIONS(3457),
    [anon_sym_ref] = ACTIONS(3457),
    [anon_sym_struct] = ACTIONS(3457),
    [anon_sym_enum] = ACTIONS(3457),
    [anon_sym_RBRACE] = ACTIONS(3459),
    [anon_sym_interface] = ACTIONS(3457),
    [anon_sym_delegate] = ACTIONS(3457),
    [anon_sym_record] = ACTIONS(3457),
    [anon_sym_abstract] = ACTIONS(3457),
    [anon_sym_async] = ACTIONS(3457),
    [anon_sym_const] = ACTIONS(3457),
    [anon_sym_file] = ACTIONS(3457),
    [anon_sym_fixed] = ACTIONS(3457),
    [anon_sym_internal] = ACTIONS(3457),
    [anon_sym_new] = ACTIONS(3457),
    [anon_sym_override] = ACTIONS(3457),
    [anon_sym_partial] = ACTIONS(3457),
    [anon_sym_private] = ACTIONS(3457),
    [anon_sym_protected] = ACTIONS(3457),
    [anon_sym_public] = ACTIONS(3457),
    [anon_sym_readonly] = ACTIONS(3457),
    [anon_sym_required] = ACTIONS(3457),
    [anon_sym_sealed] = ACTIONS(3457),
    [anon_sym_virtual] = ACTIONS(3457),
    [anon_sym_volatile] = ACTIONS(3457),
    [anon_sym_where] = ACTIONS(3457),
    [anon_sym_notnull] = ACTIONS(3457),
    [anon_sym_unmanaged] = ACTIONS(3457),
    [anon_sym_TILDE] = ACTIONS(3459),
    [anon_sym_implicit] = ACTIONS(3457),
    [anon_sym_explicit] = ACTIONS(3457),
    [anon_sym_scoped] = ACTIONS(3457),
    [anon_sym_var] = ACTIONS(3457),
    [sym_predefined_type] = ACTIONS(3457),
    [anon_sym_yield] = ACTIONS(3457),
    [anon_sym_when] = ACTIONS(3457),
    [anon_sym_from] = ACTIONS(3457),
    [anon_sym_into] = ACTIONS(3457),
    [anon_sym_join] = ACTIONS(3457),
    [anon_sym_on] = ACTIONS(3457),
    [anon_sym_equals] = ACTIONS(3457),
    [anon_sym_let] = ACTIONS(3457),
    [anon_sym_orderby] = ACTIONS(3457),
    [anon_sym_ascending] = ACTIONS(3457),
    [anon_sym_descending] = ACTIONS(3457),
    [anon_sym_group] = ACTIONS(3457),
    [anon_sym_by] = ACTIONS(3457),
    [anon_sym_select] = ACTIONS(3457),
    [aux_sym_preproc_if_token1] = ACTIONS(3459),
    [aux_sym_preproc_if_token3] = ACTIONS(3459),
    [aux_sym_preproc_else_token1] = ACTIONS(3459),
    [aux_sym_preproc_elif_token1] = ACTIONS(3459),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3236] = {
    [sym_preproc_region] = STATE(3236),
    [sym_preproc_endregion] = STATE(3236),
    [sym_preproc_line] = STATE(3236),
    [sym_preproc_pragma] = STATE(3236),
    [sym_preproc_nullable] = STATE(3236),
    [sym_preproc_error] = STATE(3236),
    [sym_preproc_define] = STATE(3236),
    [sym_preproc_undef] = STATE(3236),
    [sym__identifier_token] = ACTIONS(3445),
    [anon_sym_extern] = ACTIONS(3445),
    [anon_sym_alias] = ACTIONS(3445),
    [anon_sym_global] = ACTIONS(3445),
    [anon_sym_using] = ACTIONS(3445),
    [anon_sym_unsafe] = ACTIONS(3445),
    [anon_sym_static] = ACTIONS(3445),
    [anon_sym_LBRACK] = ACTIONS(3447),
    [anon_sym_LPAREN] = ACTIONS(3447),
    [anon_sym_event] = ACTIONS(3445),
    [anon_sym_namespace] = ACTIONS(3445),
    [anon_sym_class] = ACTIONS(3445),
    [anon_sym_ref] = ACTIONS(3445),
    [anon_sym_struct] = ACTIONS(3445),
    [anon_sym_enum] = ACTIONS(3445),
    [anon_sym_RBRACE] = ACTIONS(3447),
    [anon_sym_interface] = ACTIONS(3445),
    [anon_sym_delegate] = ACTIONS(3445),
    [anon_sym_record] = ACTIONS(3445),
    [anon_sym_abstract] = ACTIONS(3445),
    [anon_sym_async] = ACTIONS(3445),
    [anon_sym_const] = ACTIONS(3445),
    [anon_sym_file] = ACTIONS(3445),
    [anon_sym_fixed] = ACTIONS(3445),
    [anon_sym_internal] = ACTIONS(3445),
    [anon_sym_new] = ACTIONS(3445),
    [anon_sym_override] = ACTIONS(3445),
    [anon_sym_partial] = ACTIONS(3445),
    [anon_sym_private] = ACTIONS(3445),
    [anon_sym_protected] = ACTIONS(3445),
    [anon_sym_public] = ACTIONS(3445),
    [anon_sym_readonly] = ACTIONS(3445),
    [anon_sym_required] = ACTIONS(3445),
    [anon_sym_sealed] = ACTIONS(3445),
    [anon_sym_virtual] = ACTIONS(3445),
    [anon_sym_volatile] = ACTIONS(3445),
    [anon_sym_where] = ACTIONS(3445),
    [anon_sym_notnull] = ACTIONS(3445),
    [anon_sym_unmanaged] = ACTIONS(3445),
    [anon_sym_TILDE] = ACTIONS(3447),
    [anon_sym_implicit] = ACTIONS(3445),
    [anon_sym_explicit] = ACTIONS(3445),
    [anon_sym_scoped] = ACTIONS(3445),
    [anon_sym_var] = ACTIONS(3445),
    [sym_predefined_type] = ACTIONS(3445),
    [anon_sym_yield] = ACTIONS(3445),
    [anon_sym_when] = ACTIONS(3445),
    [anon_sym_from] = ACTIONS(3445),
    [anon_sym_into] = ACTIONS(3445),
    [anon_sym_join] = ACTIONS(3445),
    [anon_sym_on] = ACTIONS(3445),
    [anon_sym_equals] = ACTIONS(3445),
    [anon_sym_let] = ACTIONS(3445),
    [anon_sym_orderby] = ACTIONS(3445),
    [anon_sym_ascending] = ACTIONS(3445),
    [anon_sym_descending] = ACTIONS(3445),
    [anon_sym_group] = ACTIONS(3445),
    [anon_sym_by] = ACTIONS(3445),
    [anon_sym_select] = ACTIONS(3445),
    [aux_sym_preproc_if_token1] = ACTIONS(3447),
    [aux_sym_preproc_if_token3] = ACTIONS(3447),
    [aux_sym_preproc_else_token1] = ACTIONS(3447),
    [aux_sym_preproc_elif_token1] = ACTIONS(3447),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3237] = {
    [sym_preproc_region] = STATE(3237),
    [sym_preproc_endregion] = STATE(3237),
    [sym_preproc_line] = STATE(3237),
    [sym_preproc_pragma] = STATE(3237),
    [sym_preproc_nullable] = STATE(3237),
    [sym_preproc_error] = STATE(3237),
    [sym_preproc_define] = STATE(3237),
    [sym_preproc_undef] = STATE(3237),
    [sym__identifier_token] = ACTIONS(4788),
    [anon_sym_extern] = ACTIONS(4788),
    [anon_sym_alias] = ACTIONS(4788),
    [anon_sym_global] = ACTIONS(4788),
    [anon_sym_using] = ACTIONS(4788),
    [anon_sym_unsafe] = ACTIONS(4788),
    [anon_sym_static] = ACTIONS(4788),
    [anon_sym_LBRACK] = ACTIONS(4790),
    [anon_sym_LPAREN] = ACTIONS(4790),
    [anon_sym_event] = ACTIONS(4788),
    [anon_sym_namespace] = ACTIONS(4788),
    [anon_sym_class] = ACTIONS(4788),
    [anon_sym_ref] = ACTIONS(4788),
    [anon_sym_struct] = ACTIONS(4788),
    [anon_sym_enum] = ACTIONS(4788),
    [anon_sym_RBRACE] = ACTIONS(4790),
    [anon_sym_interface] = ACTIONS(4788),
    [anon_sym_delegate] = ACTIONS(4788),
    [anon_sym_record] = ACTIONS(4788),
    [anon_sym_abstract] = ACTIONS(4788),
    [anon_sym_async] = ACTIONS(4788),
    [anon_sym_const] = ACTIONS(4788),
    [anon_sym_file] = ACTIONS(4788),
    [anon_sym_fixed] = ACTIONS(4788),
    [anon_sym_internal] = ACTIONS(4788),
    [anon_sym_new] = ACTIONS(4788),
    [anon_sym_override] = ACTIONS(4788),
    [anon_sym_partial] = ACTIONS(4788),
    [anon_sym_private] = ACTIONS(4788),
    [anon_sym_protected] = ACTIONS(4788),
    [anon_sym_public] = ACTIONS(4788),
    [anon_sym_readonly] = ACTIONS(4788),
    [anon_sym_required] = ACTIONS(4788),
    [anon_sym_sealed] = ACTIONS(4788),
    [anon_sym_virtual] = ACTIONS(4788),
    [anon_sym_volatile] = ACTIONS(4788),
    [anon_sym_where] = ACTIONS(4788),
    [anon_sym_notnull] = ACTIONS(4788),
    [anon_sym_unmanaged] = ACTIONS(4788),
    [anon_sym_TILDE] = ACTIONS(4790),
    [anon_sym_implicit] = ACTIONS(4788),
    [anon_sym_explicit] = ACTIONS(4788),
    [anon_sym_scoped] = ACTIONS(4788),
    [anon_sym_var] = ACTIONS(4788),
    [sym_predefined_type] = ACTIONS(4788),
    [anon_sym_yield] = ACTIONS(4788),
    [anon_sym_when] = ACTIONS(4788),
    [anon_sym_from] = ACTIONS(4788),
    [anon_sym_into] = ACTIONS(4788),
    [anon_sym_join] = ACTIONS(4788),
    [anon_sym_on] = ACTIONS(4788),
    [anon_sym_equals] = ACTIONS(4788),
    [anon_sym_let] = ACTIONS(4788),
    [anon_sym_orderby] = ACTIONS(4788),
    [anon_sym_ascending] = ACTIONS(4788),
    [anon_sym_descending] = ACTIONS(4788),
    [anon_sym_group] = ACTIONS(4788),
    [anon_sym_by] = ACTIONS(4788),
    [anon_sym_select] = ACTIONS(4788),
    [aux_sym_preproc_if_token1] = ACTIONS(4790),
    [aux_sym_preproc_if_token3] = ACTIONS(4790),
    [aux_sym_preproc_else_token1] = ACTIONS(4790),
    [aux_sym_preproc_elif_token1] = ACTIONS(4790),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3238] = {
    [sym_preproc_region] = STATE(3238),
    [sym_preproc_endregion] = STATE(3238),
    [sym_preproc_line] = STATE(3238),
    [sym_preproc_pragma] = STATE(3238),
    [sym_preproc_nullable] = STATE(3238),
    [sym_preproc_error] = STATE(3238),
    [sym_preproc_define] = STATE(3238),
    [sym_preproc_undef] = STATE(3238),
    [sym__identifier_token] = ACTIONS(4792),
    [anon_sym_extern] = ACTIONS(4792),
    [anon_sym_alias] = ACTIONS(4792),
    [anon_sym_global] = ACTIONS(4792),
    [anon_sym_using] = ACTIONS(4792),
    [anon_sym_unsafe] = ACTIONS(4792),
    [anon_sym_static] = ACTIONS(4792),
    [anon_sym_LBRACK] = ACTIONS(4794),
    [anon_sym_LPAREN] = ACTIONS(4794),
    [anon_sym_event] = ACTIONS(4792),
    [anon_sym_namespace] = ACTIONS(4792),
    [anon_sym_class] = ACTIONS(4792),
    [anon_sym_ref] = ACTIONS(4792),
    [anon_sym_struct] = ACTIONS(4792),
    [anon_sym_enum] = ACTIONS(4792),
    [anon_sym_RBRACE] = ACTIONS(4794),
    [anon_sym_interface] = ACTIONS(4792),
    [anon_sym_delegate] = ACTIONS(4792),
    [anon_sym_record] = ACTIONS(4792),
    [anon_sym_abstract] = ACTIONS(4792),
    [anon_sym_async] = ACTIONS(4792),
    [anon_sym_const] = ACTIONS(4792),
    [anon_sym_file] = ACTIONS(4792),
    [anon_sym_fixed] = ACTIONS(4792),
    [anon_sym_internal] = ACTIONS(4792),
    [anon_sym_new] = ACTIONS(4792),
    [anon_sym_override] = ACTIONS(4792),
    [anon_sym_partial] = ACTIONS(4792),
    [anon_sym_private] = ACTIONS(4792),
    [anon_sym_protected] = ACTIONS(4792),
    [anon_sym_public] = ACTIONS(4792),
    [anon_sym_readonly] = ACTIONS(4792),
    [anon_sym_required] = ACTIONS(4792),
    [anon_sym_sealed] = ACTIONS(4792),
    [anon_sym_virtual] = ACTIONS(4792),
    [anon_sym_volatile] = ACTIONS(4792),
    [anon_sym_where] = ACTIONS(4792),
    [anon_sym_notnull] = ACTIONS(4792),
    [anon_sym_unmanaged] = ACTIONS(4792),
    [anon_sym_TILDE] = ACTIONS(4794),
    [anon_sym_implicit] = ACTIONS(4792),
    [anon_sym_explicit] = ACTIONS(4792),
    [anon_sym_scoped] = ACTIONS(4792),
    [anon_sym_var] = ACTIONS(4792),
    [sym_predefined_type] = ACTIONS(4792),
    [anon_sym_yield] = ACTIONS(4792),
    [anon_sym_when] = ACTIONS(4792),
    [anon_sym_from] = ACTIONS(4792),
    [anon_sym_into] = ACTIONS(4792),
    [anon_sym_join] = ACTIONS(4792),
    [anon_sym_on] = ACTIONS(4792),
    [anon_sym_equals] = ACTIONS(4792),
    [anon_sym_let] = ACTIONS(4792),
    [anon_sym_orderby] = ACTIONS(4792),
    [anon_sym_ascending] = ACTIONS(4792),
    [anon_sym_descending] = ACTIONS(4792),
    [anon_sym_group] = ACTIONS(4792),
    [anon_sym_by] = ACTIONS(4792),
    [anon_sym_select] = ACTIONS(4792),
    [aux_sym_preproc_if_token1] = ACTIONS(4794),
    [aux_sym_preproc_if_token3] = ACTIONS(4794),
    [aux_sym_preproc_else_token1] = ACTIONS(4794),
    [aux_sym_preproc_elif_token1] = ACTIONS(4794),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3239] = {
    [sym__variable_designation] = STATE(4986),
    [sym_parenthesized_variable_designation] = STATE(4957),
    [sym_identifier] = STATE(4971),
    [sym__reserved_identifier] = STATE(3568),
    [sym_preproc_region] = STATE(3239),
    [sym_preproc_endregion] = STATE(3239),
    [sym_preproc_line] = STATE(3239),
    [sym_preproc_pragma] = STATE(3239),
    [sym_preproc_nullable] = STATE(3239),
    [sym_preproc_error] = STATE(3239),
    [sym_preproc_define] = STATE(3239),
    [sym_preproc_undef] = STATE(3239),
    [sym__identifier_token] = ACTIONS(4287),
    [anon_sym_alias] = ACTIONS(4289),
    [anon_sym_global] = ACTIONS(4289),
    [anon_sym_LBRACK] = ACTIONS(4329),
    [anon_sym_LPAREN] = ACTIONS(4329),
    [anon_sym_file] = ACTIONS(4289),
    [anon_sym_LT] = ACTIONS(4331),
    [anon_sym_GT] = ACTIONS(4331),
    [anon_sym_where] = ACTIONS(4331),
    [anon_sym_QMARK] = ACTIONS(4331),
    [anon_sym_notnull] = ACTIONS(4289),
    [anon_sym_unmanaged] = ACTIONS(4289),
    [anon_sym_BANG] = ACTIONS(4331),
    [anon_sym_PLUS_PLUS] = ACTIONS(4329),
    [anon_sym_DASH_DASH] = ACTIONS(4329),
    [anon_sym_PLUS] = ACTIONS(4331),
    [anon_sym_DASH] = ACTIONS(4331),
    [anon_sym_STAR] = ACTIONS(4329),
    [anon_sym_SLASH] = ACTIONS(4331),
    [anon_sym_PERCENT] = ACTIONS(4329),
    [anon_sym_CARET] = ACTIONS(4329),
    [anon_sym_PIPE] = ACTIONS(4331),
    [anon_sym_AMP] = ACTIONS(4331),
    [anon_sym_LT_LT] = ACTIONS(4329),
    [anon_sym_GT_GT] = ACTIONS(4331),
    [anon_sym_GT_GT_GT] = ACTIONS(4329),
    [anon_sym_EQ_EQ] = ACTIONS(4329),
    [anon_sym_BANG_EQ] = ACTIONS(4329),
    [anon_sym_GT_EQ] = ACTIONS(4329),
    [anon_sym_LT_EQ] = ACTIONS(4329),
    [anon_sym_DOT] = ACTIONS(4331),
    [anon_sym_scoped] = ACTIONS(4289),
    [anon_sym_var] = ACTIONS(4289),
    [anon_sym_yield] = ACTIONS(4289),
    [anon_sym_switch] = ACTIONS(4331),
    [anon_sym_when] = ACTIONS(4289),
    [sym_discard] = ACTIONS(4649),
    [anon_sym_DOT_DOT] = ACTIONS(4329),
    [anon_sym_and] = ACTIONS(4331),
    [anon_sym_or] = ACTIONS(4331),
    [anon_sym_AMP_AMP] = ACTIONS(4329),
    [anon_sym_PIPE_PIPE] = ACTIONS(4329),
    [anon_sym_QMARK_QMARK] = ACTIONS(4329),
    [anon_sym_from] = ACTIONS(4331),
    [anon_sym_into] = ACTIONS(4289),
    [anon_sym_join] = ACTIONS(4331),
    [anon_sym_on] = ACTIONS(4289),
    [anon_sym_equals] = ACTIONS(4289),
    [anon_sym_let] = ACTIONS(4331),
    [anon_sym_orderby] = ACTIONS(4331),
    [anon_sym_ascending] = ACTIONS(4289),
    [anon_sym_descending] = ACTIONS(4289),
    [anon_sym_group] = ACTIONS(4331),
    [anon_sym_by] = ACTIONS(4289),
    [anon_sym_select] = ACTIONS(4331),
    [anon_sym_as] = ACTIONS(4331),
    [anon_sym_is] = ACTIONS(4331),
    [anon_sym_DASH_GT] = ACTIONS(4329),
    [anon_sym_with] = ACTIONS(4331),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3240] = {
    [sym_preproc_region] = STATE(3240),
    [sym_preproc_endregion] = STATE(3240),
    [sym_preproc_line] = STATE(3240),
    [sym_preproc_pragma] = STATE(3240),
    [sym_preproc_nullable] = STATE(3240),
    [sym_preproc_error] = STATE(3240),
    [sym_preproc_define] = STATE(3240),
    [sym_preproc_undef] = STATE(3240),
    [sym__identifier_token] = ACTIONS(3832),
    [anon_sym_extern] = ACTIONS(3832),
    [anon_sym_alias] = ACTIONS(3832),
    [anon_sym_global] = ACTIONS(3832),
    [anon_sym_using] = ACTIONS(3832),
    [anon_sym_unsafe] = ACTIONS(3832),
    [anon_sym_static] = ACTIONS(3832),
    [anon_sym_LBRACK] = ACTIONS(3834),
    [anon_sym_LPAREN] = ACTIONS(3834),
    [anon_sym_event] = ACTIONS(3832),
    [anon_sym_namespace] = ACTIONS(3832),
    [anon_sym_class] = ACTIONS(3832),
    [anon_sym_ref] = ACTIONS(3832),
    [anon_sym_struct] = ACTIONS(3832),
    [anon_sym_enum] = ACTIONS(3832),
    [anon_sym_RBRACE] = ACTIONS(3834),
    [anon_sym_interface] = ACTIONS(3832),
    [anon_sym_delegate] = ACTIONS(3832),
    [anon_sym_record] = ACTIONS(3832),
    [anon_sym_abstract] = ACTIONS(3832),
    [anon_sym_async] = ACTIONS(3832),
    [anon_sym_const] = ACTIONS(3832),
    [anon_sym_file] = ACTIONS(3832),
    [anon_sym_fixed] = ACTIONS(3832),
    [anon_sym_internal] = ACTIONS(3832),
    [anon_sym_new] = ACTIONS(3832),
    [anon_sym_override] = ACTIONS(3832),
    [anon_sym_partial] = ACTIONS(3832),
    [anon_sym_private] = ACTIONS(3832),
    [anon_sym_protected] = ACTIONS(3832),
    [anon_sym_public] = ACTIONS(3832),
    [anon_sym_readonly] = ACTIONS(3832),
    [anon_sym_required] = ACTIONS(3832),
    [anon_sym_sealed] = ACTIONS(3832),
    [anon_sym_virtual] = ACTIONS(3832),
    [anon_sym_volatile] = ACTIONS(3832),
    [anon_sym_where] = ACTIONS(3832),
    [anon_sym_notnull] = ACTIONS(3832),
    [anon_sym_unmanaged] = ACTIONS(3832),
    [anon_sym_TILDE] = ACTIONS(3834),
    [anon_sym_implicit] = ACTIONS(3832),
    [anon_sym_explicit] = ACTIONS(3832),
    [anon_sym_scoped] = ACTIONS(3832),
    [anon_sym_var] = ACTIONS(3832),
    [sym_predefined_type] = ACTIONS(3832),
    [anon_sym_yield] = ACTIONS(3832),
    [anon_sym_when] = ACTIONS(3832),
    [anon_sym_from] = ACTIONS(3832),
    [anon_sym_into] = ACTIONS(3832),
    [anon_sym_join] = ACTIONS(3832),
    [anon_sym_on] = ACTIONS(3832),
    [anon_sym_equals] = ACTIONS(3832),
    [anon_sym_let] = ACTIONS(3832),
    [anon_sym_orderby] = ACTIONS(3832),
    [anon_sym_ascending] = ACTIONS(3832),
    [anon_sym_descending] = ACTIONS(3832),
    [anon_sym_group] = ACTIONS(3832),
    [anon_sym_by] = ACTIONS(3832),
    [anon_sym_select] = ACTIONS(3832),
    [aux_sym_preproc_if_token1] = ACTIONS(3834),
    [aux_sym_preproc_if_token3] = ACTIONS(3834),
    [aux_sym_preproc_else_token1] = ACTIONS(3834),
    [aux_sym_preproc_elif_token1] = ACTIONS(3834),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3241] = {
    [sym_preproc_region] = STATE(3241),
    [sym_preproc_endregion] = STATE(3241),
    [sym_preproc_line] = STATE(3241),
    [sym_preproc_pragma] = STATE(3241),
    [sym_preproc_nullable] = STATE(3241),
    [sym_preproc_error] = STATE(3241),
    [sym_preproc_define] = STATE(3241),
    [sym_preproc_undef] = STATE(3241),
    [sym__identifier_token] = ACTIONS(3836),
    [anon_sym_extern] = ACTIONS(3836),
    [anon_sym_alias] = ACTIONS(3836),
    [anon_sym_global] = ACTIONS(3836),
    [anon_sym_using] = ACTIONS(3836),
    [anon_sym_unsafe] = ACTIONS(3836),
    [anon_sym_static] = ACTIONS(3836),
    [anon_sym_LBRACK] = ACTIONS(3838),
    [anon_sym_LPAREN] = ACTIONS(3838),
    [anon_sym_event] = ACTIONS(3836),
    [anon_sym_namespace] = ACTIONS(3836),
    [anon_sym_class] = ACTIONS(3836),
    [anon_sym_ref] = ACTIONS(3836),
    [anon_sym_struct] = ACTIONS(3836),
    [anon_sym_enum] = ACTIONS(3836),
    [anon_sym_RBRACE] = ACTIONS(3838),
    [anon_sym_interface] = ACTIONS(3836),
    [anon_sym_delegate] = ACTIONS(3836),
    [anon_sym_record] = ACTIONS(3836),
    [anon_sym_abstract] = ACTIONS(3836),
    [anon_sym_async] = ACTIONS(3836),
    [anon_sym_const] = ACTIONS(3836),
    [anon_sym_file] = ACTIONS(3836),
    [anon_sym_fixed] = ACTIONS(3836),
    [anon_sym_internal] = ACTIONS(3836),
    [anon_sym_new] = ACTIONS(3836),
    [anon_sym_override] = ACTIONS(3836),
    [anon_sym_partial] = ACTIONS(3836),
    [anon_sym_private] = ACTIONS(3836),
    [anon_sym_protected] = ACTIONS(3836),
    [anon_sym_public] = ACTIONS(3836),
    [anon_sym_readonly] = ACTIONS(3836),
    [anon_sym_required] = ACTIONS(3836),
    [anon_sym_sealed] = ACTIONS(3836),
    [anon_sym_virtual] = ACTIONS(3836),
    [anon_sym_volatile] = ACTIONS(3836),
    [anon_sym_where] = ACTIONS(3836),
    [anon_sym_notnull] = ACTIONS(3836),
    [anon_sym_unmanaged] = ACTIONS(3836),
    [anon_sym_TILDE] = ACTIONS(3838),
    [anon_sym_implicit] = ACTIONS(3836),
    [anon_sym_explicit] = ACTIONS(3836),
    [anon_sym_scoped] = ACTIONS(3836),
    [anon_sym_var] = ACTIONS(3836),
    [sym_predefined_type] = ACTIONS(3836),
    [anon_sym_yield] = ACTIONS(3836),
    [anon_sym_when] = ACTIONS(3836),
    [anon_sym_from] = ACTIONS(3836),
    [anon_sym_into] = ACTIONS(3836),
    [anon_sym_join] = ACTIONS(3836),
    [anon_sym_on] = ACTIONS(3836),
    [anon_sym_equals] = ACTIONS(3836),
    [anon_sym_let] = ACTIONS(3836),
    [anon_sym_orderby] = ACTIONS(3836),
    [anon_sym_ascending] = ACTIONS(3836),
    [anon_sym_descending] = ACTIONS(3836),
    [anon_sym_group] = ACTIONS(3836),
    [anon_sym_by] = ACTIONS(3836),
    [anon_sym_select] = ACTIONS(3836),
    [aux_sym_preproc_if_token1] = ACTIONS(3838),
    [aux_sym_preproc_if_token3] = ACTIONS(3838),
    [aux_sym_preproc_else_token1] = ACTIONS(3838),
    [aux_sym_preproc_elif_token1] = ACTIONS(3838),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3242] = {
    [sym_preproc_region] = STATE(3242),
    [sym_preproc_endregion] = STATE(3242),
    [sym_preproc_line] = STATE(3242),
    [sym_preproc_pragma] = STATE(3242),
    [sym_preproc_nullable] = STATE(3242),
    [sym_preproc_error] = STATE(3242),
    [sym_preproc_define] = STATE(3242),
    [sym_preproc_undef] = STATE(3242),
    [sym__identifier_token] = ACTIONS(4796),
    [anon_sym_extern] = ACTIONS(4796),
    [anon_sym_alias] = ACTIONS(4796),
    [anon_sym_global] = ACTIONS(4796),
    [anon_sym_using] = ACTIONS(4796),
    [anon_sym_unsafe] = ACTIONS(4796),
    [anon_sym_static] = ACTIONS(4796),
    [anon_sym_LBRACK] = ACTIONS(4798),
    [anon_sym_LPAREN] = ACTIONS(4798),
    [anon_sym_event] = ACTIONS(4796),
    [anon_sym_namespace] = ACTIONS(4796),
    [anon_sym_class] = ACTIONS(4796),
    [anon_sym_ref] = ACTIONS(4796),
    [anon_sym_struct] = ACTIONS(4796),
    [anon_sym_enum] = ACTIONS(4796),
    [anon_sym_RBRACE] = ACTIONS(4798),
    [anon_sym_interface] = ACTIONS(4796),
    [anon_sym_delegate] = ACTIONS(4796),
    [anon_sym_record] = ACTIONS(4796),
    [anon_sym_abstract] = ACTIONS(4796),
    [anon_sym_async] = ACTIONS(4796),
    [anon_sym_const] = ACTIONS(4796),
    [anon_sym_file] = ACTIONS(4796),
    [anon_sym_fixed] = ACTIONS(4796),
    [anon_sym_internal] = ACTIONS(4796),
    [anon_sym_new] = ACTIONS(4796),
    [anon_sym_override] = ACTIONS(4796),
    [anon_sym_partial] = ACTIONS(4796),
    [anon_sym_private] = ACTIONS(4796),
    [anon_sym_protected] = ACTIONS(4796),
    [anon_sym_public] = ACTIONS(4796),
    [anon_sym_readonly] = ACTIONS(4796),
    [anon_sym_required] = ACTIONS(4796),
    [anon_sym_sealed] = ACTIONS(4796),
    [anon_sym_virtual] = ACTIONS(4796),
    [anon_sym_volatile] = ACTIONS(4796),
    [anon_sym_where] = ACTIONS(4796),
    [anon_sym_notnull] = ACTIONS(4796),
    [anon_sym_unmanaged] = ACTIONS(4796),
    [anon_sym_TILDE] = ACTIONS(4798),
    [anon_sym_implicit] = ACTIONS(4796),
    [anon_sym_explicit] = ACTIONS(4796),
    [anon_sym_scoped] = ACTIONS(4796),
    [anon_sym_var] = ACTIONS(4796),
    [sym_predefined_type] = ACTIONS(4796),
    [anon_sym_yield] = ACTIONS(4796),
    [anon_sym_when] = ACTIONS(4796),
    [anon_sym_from] = ACTIONS(4796),
    [anon_sym_into] = ACTIONS(4796),
    [anon_sym_join] = ACTIONS(4796),
    [anon_sym_on] = ACTIONS(4796),
    [anon_sym_equals] = ACTIONS(4796),
    [anon_sym_let] = ACTIONS(4796),
    [anon_sym_orderby] = ACTIONS(4796),
    [anon_sym_ascending] = ACTIONS(4796),
    [anon_sym_descending] = ACTIONS(4796),
    [anon_sym_group] = ACTIONS(4796),
    [anon_sym_by] = ACTIONS(4796),
    [anon_sym_select] = ACTIONS(4796),
    [aux_sym_preproc_if_token1] = ACTIONS(4798),
    [aux_sym_preproc_if_token3] = ACTIONS(4798),
    [aux_sym_preproc_else_token1] = ACTIONS(4798),
    [aux_sym_preproc_elif_token1] = ACTIONS(4798),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3243] = {
    [sym_preproc_region] = STATE(3243),
    [sym_preproc_endregion] = STATE(3243),
    [sym_preproc_line] = STATE(3243),
    [sym_preproc_pragma] = STATE(3243),
    [sym_preproc_nullable] = STATE(3243),
    [sym_preproc_error] = STATE(3243),
    [sym_preproc_define] = STATE(3243),
    [sym_preproc_undef] = STATE(3243),
    [sym__identifier_token] = ACTIONS(3441),
    [anon_sym_extern] = ACTIONS(3441),
    [anon_sym_alias] = ACTIONS(3441),
    [anon_sym_global] = ACTIONS(3441),
    [anon_sym_using] = ACTIONS(3441),
    [anon_sym_unsafe] = ACTIONS(3441),
    [anon_sym_static] = ACTIONS(3441),
    [anon_sym_LBRACK] = ACTIONS(3443),
    [anon_sym_LPAREN] = ACTIONS(3443),
    [anon_sym_event] = ACTIONS(3441),
    [anon_sym_namespace] = ACTIONS(3441),
    [anon_sym_class] = ACTIONS(3441),
    [anon_sym_ref] = ACTIONS(3441),
    [anon_sym_struct] = ACTIONS(3441),
    [anon_sym_enum] = ACTIONS(3441),
    [anon_sym_RBRACE] = ACTIONS(3443),
    [anon_sym_interface] = ACTIONS(3441),
    [anon_sym_delegate] = ACTIONS(3441),
    [anon_sym_record] = ACTIONS(3441),
    [anon_sym_abstract] = ACTIONS(3441),
    [anon_sym_async] = ACTIONS(3441),
    [anon_sym_const] = ACTIONS(3441),
    [anon_sym_file] = ACTIONS(3441),
    [anon_sym_fixed] = ACTIONS(3441),
    [anon_sym_internal] = ACTIONS(3441),
    [anon_sym_new] = ACTIONS(3441),
    [anon_sym_override] = ACTIONS(3441),
    [anon_sym_partial] = ACTIONS(3441),
    [anon_sym_private] = ACTIONS(3441),
    [anon_sym_protected] = ACTIONS(3441),
    [anon_sym_public] = ACTIONS(3441),
    [anon_sym_readonly] = ACTIONS(3441),
    [anon_sym_required] = ACTIONS(3441),
    [anon_sym_sealed] = ACTIONS(3441),
    [anon_sym_virtual] = ACTIONS(3441),
    [anon_sym_volatile] = ACTIONS(3441),
    [anon_sym_where] = ACTIONS(3441),
    [anon_sym_notnull] = ACTIONS(3441),
    [anon_sym_unmanaged] = ACTIONS(3441),
    [anon_sym_TILDE] = ACTIONS(3443),
    [anon_sym_implicit] = ACTIONS(3441),
    [anon_sym_explicit] = ACTIONS(3441),
    [anon_sym_scoped] = ACTIONS(3441),
    [anon_sym_var] = ACTIONS(3441),
    [sym_predefined_type] = ACTIONS(3441),
    [anon_sym_yield] = ACTIONS(3441),
    [anon_sym_when] = ACTIONS(3441),
    [anon_sym_from] = ACTIONS(3441),
    [anon_sym_into] = ACTIONS(3441),
    [anon_sym_join] = ACTIONS(3441),
    [anon_sym_on] = ACTIONS(3441),
    [anon_sym_equals] = ACTIONS(3441),
    [anon_sym_let] = ACTIONS(3441),
    [anon_sym_orderby] = ACTIONS(3441),
    [anon_sym_ascending] = ACTIONS(3441),
    [anon_sym_descending] = ACTIONS(3441),
    [anon_sym_group] = ACTIONS(3441),
    [anon_sym_by] = ACTIONS(3441),
    [anon_sym_select] = ACTIONS(3441),
    [aux_sym_preproc_if_token1] = ACTIONS(3443),
    [aux_sym_preproc_if_token3] = ACTIONS(3443),
    [aux_sym_preproc_else_token1] = ACTIONS(3443),
    [aux_sym_preproc_elif_token1] = ACTIONS(3443),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3244] = {
    [sym_preproc_region] = STATE(3244),
    [sym_preproc_endregion] = STATE(3244),
    [sym_preproc_line] = STATE(3244),
    [sym_preproc_pragma] = STATE(3244),
    [sym_preproc_nullable] = STATE(3244),
    [sym_preproc_error] = STATE(3244),
    [sym_preproc_define] = STATE(3244),
    [sym_preproc_undef] = STATE(3244),
    [sym__identifier_token] = ACTIONS(4800),
    [anon_sym_extern] = ACTIONS(4800),
    [anon_sym_alias] = ACTIONS(4800),
    [anon_sym_global] = ACTIONS(4800),
    [anon_sym_using] = ACTIONS(4800),
    [anon_sym_unsafe] = ACTIONS(4800),
    [anon_sym_static] = ACTIONS(4800),
    [anon_sym_LBRACK] = ACTIONS(4802),
    [anon_sym_LPAREN] = ACTIONS(4802),
    [anon_sym_event] = ACTIONS(4800),
    [anon_sym_namespace] = ACTIONS(4800),
    [anon_sym_class] = ACTIONS(4800),
    [anon_sym_ref] = ACTIONS(4800),
    [anon_sym_struct] = ACTIONS(4800),
    [anon_sym_enum] = ACTIONS(4800),
    [anon_sym_RBRACE] = ACTIONS(4802),
    [anon_sym_interface] = ACTIONS(4800),
    [anon_sym_delegate] = ACTIONS(4800),
    [anon_sym_record] = ACTIONS(4800),
    [anon_sym_abstract] = ACTIONS(4800),
    [anon_sym_async] = ACTIONS(4800),
    [anon_sym_const] = ACTIONS(4800),
    [anon_sym_file] = ACTIONS(4800),
    [anon_sym_fixed] = ACTIONS(4800),
    [anon_sym_internal] = ACTIONS(4800),
    [anon_sym_new] = ACTIONS(4800),
    [anon_sym_override] = ACTIONS(4800),
    [anon_sym_partial] = ACTIONS(4800),
    [anon_sym_private] = ACTIONS(4800),
    [anon_sym_protected] = ACTIONS(4800),
    [anon_sym_public] = ACTIONS(4800),
    [anon_sym_readonly] = ACTIONS(4800),
    [anon_sym_required] = ACTIONS(4800),
    [anon_sym_sealed] = ACTIONS(4800),
    [anon_sym_virtual] = ACTIONS(4800),
    [anon_sym_volatile] = ACTIONS(4800),
    [anon_sym_where] = ACTIONS(4800),
    [anon_sym_notnull] = ACTIONS(4800),
    [anon_sym_unmanaged] = ACTIONS(4800),
    [anon_sym_TILDE] = ACTIONS(4802),
    [anon_sym_implicit] = ACTIONS(4800),
    [anon_sym_explicit] = ACTIONS(4800),
    [anon_sym_scoped] = ACTIONS(4800),
    [anon_sym_var] = ACTIONS(4800),
    [sym_predefined_type] = ACTIONS(4800),
    [anon_sym_yield] = ACTIONS(4800),
    [anon_sym_when] = ACTIONS(4800),
    [anon_sym_from] = ACTIONS(4800),
    [anon_sym_into] = ACTIONS(4800),
    [anon_sym_join] = ACTIONS(4800),
    [anon_sym_on] = ACTIONS(4800),
    [anon_sym_equals] = ACTIONS(4800),
    [anon_sym_let] = ACTIONS(4800),
    [anon_sym_orderby] = ACTIONS(4800),
    [anon_sym_ascending] = ACTIONS(4800),
    [anon_sym_descending] = ACTIONS(4800),
    [anon_sym_group] = ACTIONS(4800),
    [anon_sym_by] = ACTIONS(4800),
    [anon_sym_select] = ACTIONS(4800),
    [aux_sym_preproc_if_token1] = ACTIONS(4802),
    [aux_sym_preproc_if_token3] = ACTIONS(4802),
    [aux_sym_preproc_else_token1] = ACTIONS(4802),
    [aux_sym_preproc_elif_token1] = ACTIONS(4802),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3245] = {
    [sym_preproc_region] = STATE(3245),
    [sym_preproc_endregion] = STATE(3245),
    [sym_preproc_line] = STATE(3245),
    [sym_preproc_pragma] = STATE(3245),
    [sym_preproc_nullable] = STATE(3245),
    [sym_preproc_error] = STATE(3245),
    [sym_preproc_define] = STATE(3245),
    [sym_preproc_undef] = STATE(3245),
    [sym__identifier_token] = ACTIONS(4804),
    [anon_sym_extern] = ACTIONS(4804),
    [anon_sym_alias] = ACTIONS(4804),
    [anon_sym_global] = ACTIONS(4804),
    [anon_sym_using] = ACTIONS(4804),
    [anon_sym_unsafe] = ACTIONS(4804),
    [anon_sym_static] = ACTIONS(4804),
    [anon_sym_LBRACK] = ACTIONS(4806),
    [anon_sym_LPAREN] = ACTIONS(4806),
    [anon_sym_event] = ACTIONS(4804),
    [anon_sym_namespace] = ACTIONS(4804),
    [anon_sym_class] = ACTIONS(4804),
    [anon_sym_ref] = ACTIONS(4804),
    [anon_sym_struct] = ACTIONS(4804),
    [anon_sym_enum] = ACTIONS(4804),
    [anon_sym_RBRACE] = ACTIONS(4806),
    [anon_sym_interface] = ACTIONS(4804),
    [anon_sym_delegate] = ACTIONS(4804),
    [anon_sym_record] = ACTIONS(4804),
    [anon_sym_abstract] = ACTIONS(4804),
    [anon_sym_async] = ACTIONS(4804),
    [anon_sym_const] = ACTIONS(4804),
    [anon_sym_file] = ACTIONS(4804),
    [anon_sym_fixed] = ACTIONS(4804),
    [anon_sym_internal] = ACTIONS(4804),
    [anon_sym_new] = ACTIONS(4804),
    [anon_sym_override] = ACTIONS(4804),
    [anon_sym_partial] = ACTIONS(4804),
    [anon_sym_private] = ACTIONS(4804),
    [anon_sym_protected] = ACTIONS(4804),
    [anon_sym_public] = ACTIONS(4804),
    [anon_sym_readonly] = ACTIONS(4804),
    [anon_sym_required] = ACTIONS(4804),
    [anon_sym_sealed] = ACTIONS(4804),
    [anon_sym_virtual] = ACTIONS(4804),
    [anon_sym_volatile] = ACTIONS(4804),
    [anon_sym_where] = ACTIONS(4804),
    [anon_sym_notnull] = ACTIONS(4804),
    [anon_sym_unmanaged] = ACTIONS(4804),
    [anon_sym_TILDE] = ACTIONS(4806),
    [anon_sym_implicit] = ACTIONS(4804),
    [anon_sym_explicit] = ACTIONS(4804),
    [anon_sym_scoped] = ACTIONS(4804),
    [anon_sym_var] = ACTIONS(4804),
    [sym_predefined_type] = ACTIONS(4804),
    [anon_sym_yield] = ACTIONS(4804),
    [anon_sym_when] = ACTIONS(4804),
    [anon_sym_from] = ACTIONS(4804),
    [anon_sym_into] = ACTIONS(4804),
    [anon_sym_join] = ACTIONS(4804),
    [anon_sym_on] = ACTIONS(4804),
    [anon_sym_equals] = ACTIONS(4804),
    [anon_sym_let] = ACTIONS(4804),
    [anon_sym_orderby] = ACTIONS(4804),
    [anon_sym_ascending] = ACTIONS(4804),
    [anon_sym_descending] = ACTIONS(4804),
    [anon_sym_group] = ACTIONS(4804),
    [anon_sym_by] = ACTIONS(4804),
    [anon_sym_select] = ACTIONS(4804),
    [aux_sym_preproc_if_token1] = ACTIONS(4806),
    [aux_sym_preproc_if_token3] = ACTIONS(4806),
    [aux_sym_preproc_else_token1] = ACTIONS(4806),
    [aux_sym_preproc_elif_token1] = ACTIONS(4806),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3246] = {
    [sym_preproc_region] = STATE(3246),
    [sym_preproc_endregion] = STATE(3246),
    [sym_preproc_line] = STATE(3246),
    [sym_preproc_pragma] = STATE(3246),
    [sym_preproc_nullable] = STATE(3246),
    [sym_preproc_error] = STATE(3246),
    [sym_preproc_define] = STATE(3246),
    [sym_preproc_undef] = STATE(3246),
    [sym__identifier_token] = ACTIONS(4808),
    [anon_sym_extern] = ACTIONS(4808),
    [anon_sym_alias] = ACTIONS(4808),
    [anon_sym_global] = ACTIONS(4808),
    [anon_sym_using] = ACTIONS(4808),
    [anon_sym_unsafe] = ACTIONS(4808),
    [anon_sym_static] = ACTIONS(4808),
    [anon_sym_LBRACK] = ACTIONS(4810),
    [anon_sym_LPAREN] = ACTIONS(4810),
    [anon_sym_event] = ACTIONS(4808),
    [anon_sym_namespace] = ACTIONS(4808),
    [anon_sym_class] = ACTIONS(4808),
    [anon_sym_ref] = ACTIONS(4808),
    [anon_sym_struct] = ACTIONS(4808),
    [anon_sym_enum] = ACTIONS(4808),
    [anon_sym_RBRACE] = ACTIONS(4810),
    [anon_sym_interface] = ACTIONS(4808),
    [anon_sym_delegate] = ACTIONS(4808),
    [anon_sym_record] = ACTIONS(4808),
    [anon_sym_abstract] = ACTIONS(4808),
    [anon_sym_async] = ACTIONS(4808),
    [anon_sym_const] = ACTIONS(4808),
    [anon_sym_file] = ACTIONS(4808),
    [anon_sym_fixed] = ACTIONS(4808),
    [anon_sym_internal] = ACTIONS(4808),
    [anon_sym_new] = ACTIONS(4808),
    [anon_sym_override] = ACTIONS(4808),
    [anon_sym_partial] = ACTIONS(4808),
    [anon_sym_private] = ACTIONS(4808),
    [anon_sym_protected] = ACTIONS(4808),
    [anon_sym_public] = ACTIONS(4808),
    [anon_sym_readonly] = ACTIONS(4808),
    [anon_sym_required] = ACTIONS(4808),
    [anon_sym_sealed] = ACTIONS(4808),
    [anon_sym_virtual] = ACTIONS(4808),
    [anon_sym_volatile] = ACTIONS(4808),
    [anon_sym_where] = ACTIONS(4808),
    [anon_sym_notnull] = ACTIONS(4808),
    [anon_sym_unmanaged] = ACTIONS(4808),
    [anon_sym_TILDE] = ACTIONS(4810),
    [anon_sym_implicit] = ACTIONS(4808),
    [anon_sym_explicit] = ACTIONS(4808),
    [anon_sym_scoped] = ACTIONS(4808),
    [anon_sym_var] = ACTIONS(4808),
    [sym_predefined_type] = ACTIONS(4808),
    [anon_sym_yield] = ACTIONS(4808),
    [anon_sym_when] = ACTIONS(4808),
    [anon_sym_from] = ACTIONS(4808),
    [anon_sym_into] = ACTIONS(4808),
    [anon_sym_join] = ACTIONS(4808),
    [anon_sym_on] = ACTIONS(4808),
    [anon_sym_equals] = ACTIONS(4808),
    [anon_sym_let] = ACTIONS(4808),
    [anon_sym_orderby] = ACTIONS(4808),
    [anon_sym_ascending] = ACTIONS(4808),
    [anon_sym_descending] = ACTIONS(4808),
    [anon_sym_group] = ACTIONS(4808),
    [anon_sym_by] = ACTIONS(4808),
    [anon_sym_select] = ACTIONS(4808),
    [aux_sym_preproc_if_token1] = ACTIONS(4810),
    [aux_sym_preproc_if_token3] = ACTIONS(4810),
    [aux_sym_preproc_else_token1] = ACTIONS(4810),
    [aux_sym_preproc_elif_token1] = ACTIONS(4810),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3247] = {
    [sym_preproc_region] = STATE(3247),
    [sym_preproc_endregion] = STATE(3247),
    [sym_preproc_line] = STATE(3247),
    [sym_preproc_pragma] = STATE(3247),
    [sym_preproc_nullable] = STATE(3247),
    [sym_preproc_error] = STATE(3247),
    [sym_preproc_define] = STATE(3247),
    [sym_preproc_undef] = STATE(3247),
    [sym__identifier_token] = ACTIONS(4812),
    [anon_sym_extern] = ACTIONS(4812),
    [anon_sym_alias] = ACTIONS(4812),
    [anon_sym_global] = ACTIONS(4812),
    [anon_sym_using] = ACTIONS(4812),
    [anon_sym_unsafe] = ACTIONS(4812),
    [anon_sym_static] = ACTIONS(4812),
    [anon_sym_LBRACK] = ACTIONS(4814),
    [anon_sym_LPAREN] = ACTIONS(4814),
    [anon_sym_event] = ACTIONS(4812),
    [anon_sym_namespace] = ACTIONS(4812),
    [anon_sym_class] = ACTIONS(4812),
    [anon_sym_ref] = ACTIONS(4812),
    [anon_sym_struct] = ACTIONS(4812),
    [anon_sym_enum] = ACTIONS(4812),
    [anon_sym_RBRACE] = ACTIONS(4814),
    [anon_sym_interface] = ACTIONS(4812),
    [anon_sym_delegate] = ACTIONS(4812),
    [anon_sym_record] = ACTIONS(4812),
    [anon_sym_abstract] = ACTIONS(4812),
    [anon_sym_async] = ACTIONS(4812),
    [anon_sym_const] = ACTIONS(4812),
    [anon_sym_file] = ACTIONS(4812),
    [anon_sym_fixed] = ACTIONS(4812),
    [anon_sym_internal] = ACTIONS(4812),
    [anon_sym_new] = ACTIONS(4812),
    [anon_sym_override] = ACTIONS(4812),
    [anon_sym_partial] = ACTIONS(4812),
    [anon_sym_private] = ACTIONS(4812),
    [anon_sym_protected] = ACTIONS(4812),
    [anon_sym_public] = ACTIONS(4812),
    [anon_sym_readonly] = ACTIONS(4812),
    [anon_sym_required] = ACTIONS(4812),
    [anon_sym_sealed] = ACTIONS(4812),
    [anon_sym_virtual] = ACTIONS(4812),
    [anon_sym_volatile] = ACTIONS(4812),
    [anon_sym_where] = ACTIONS(4812),
    [anon_sym_notnull] = ACTIONS(4812),
    [anon_sym_unmanaged] = ACTIONS(4812),
    [anon_sym_TILDE] = ACTIONS(4814),
    [anon_sym_implicit] = ACTIONS(4812),
    [anon_sym_explicit] = ACTIONS(4812),
    [anon_sym_scoped] = ACTIONS(4812),
    [anon_sym_var] = ACTIONS(4812),
    [sym_predefined_type] = ACTIONS(4812),
    [anon_sym_yield] = ACTIONS(4812),
    [anon_sym_when] = ACTIONS(4812),
    [anon_sym_from] = ACTIONS(4812),
    [anon_sym_into] = ACTIONS(4812),
    [anon_sym_join] = ACTIONS(4812),
    [anon_sym_on] = ACTIONS(4812),
    [anon_sym_equals] = ACTIONS(4812),
    [anon_sym_let] = ACTIONS(4812),
    [anon_sym_orderby] = ACTIONS(4812),
    [anon_sym_ascending] = ACTIONS(4812),
    [anon_sym_descending] = ACTIONS(4812),
    [anon_sym_group] = ACTIONS(4812),
    [anon_sym_by] = ACTIONS(4812),
    [anon_sym_select] = ACTIONS(4812),
    [aux_sym_preproc_if_token1] = ACTIONS(4814),
    [aux_sym_preproc_if_token3] = ACTIONS(4814),
    [aux_sym_preproc_else_token1] = ACTIONS(4814),
    [aux_sym_preproc_elif_token1] = ACTIONS(4814),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3248] = {
    [sym_preproc_region] = STATE(3248),
    [sym_preproc_endregion] = STATE(3248),
    [sym_preproc_line] = STATE(3248),
    [sym_preproc_pragma] = STATE(3248),
    [sym_preproc_nullable] = STATE(3248),
    [sym_preproc_error] = STATE(3248),
    [sym_preproc_define] = STATE(3248),
    [sym_preproc_undef] = STATE(3248),
    [sym__identifier_token] = ACTIONS(4816),
    [anon_sym_extern] = ACTIONS(4816),
    [anon_sym_alias] = ACTIONS(4816),
    [anon_sym_global] = ACTIONS(4816),
    [anon_sym_using] = ACTIONS(4816),
    [anon_sym_unsafe] = ACTIONS(4816),
    [anon_sym_static] = ACTIONS(4816),
    [anon_sym_LBRACK] = ACTIONS(4818),
    [anon_sym_LPAREN] = ACTIONS(4818),
    [anon_sym_event] = ACTIONS(4816),
    [anon_sym_namespace] = ACTIONS(4816),
    [anon_sym_class] = ACTIONS(4816),
    [anon_sym_ref] = ACTIONS(4816),
    [anon_sym_struct] = ACTIONS(4816),
    [anon_sym_enum] = ACTIONS(4816),
    [anon_sym_RBRACE] = ACTIONS(4818),
    [anon_sym_interface] = ACTIONS(4816),
    [anon_sym_delegate] = ACTIONS(4816),
    [anon_sym_record] = ACTIONS(4816),
    [anon_sym_abstract] = ACTIONS(4816),
    [anon_sym_async] = ACTIONS(4816),
    [anon_sym_const] = ACTIONS(4816),
    [anon_sym_file] = ACTIONS(4816),
    [anon_sym_fixed] = ACTIONS(4816),
    [anon_sym_internal] = ACTIONS(4816),
    [anon_sym_new] = ACTIONS(4816),
    [anon_sym_override] = ACTIONS(4816),
    [anon_sym_partial] = ACTIONS(4816),
    [anon_sym_private] = ACTIONS(4816),
    [anon_sym_protected] = ACTIONS(4816),
    [anon_sym_public] = ACTIONS(4816),
    [anon_sym_readonly] = ACTIONS(4816),
    [anon_sym_required] = ACTIONS(4816),
    [anon_sym_sealed] = ACTIONS(4816),
    [anon_sym_virtual] = ACTIONS(4816),
    [anon_sym_volatile] = ACTIONS(4816),
    [anon_sym_where] = ACTIONS(4816),
    [anon_sym_notnull] = ACTIONS(4816),
    [anon_sym_unmanaged] = ACTIONS(4816),
    [anon_sym_TILDE] = ACTIONS(4818),
    [anon_sym_implicit] = ACTIONS(4816),
    [anon_sym_explicit] = ACTIONS(4816),
    [anon_sym_scoped] = ACTIONS(4816),
    [anon_sym_var] = ACTIONS(4816),
    [sym_predefined_type] = ACTIONS(4816),
    [anon_sym_yield] = ACTIONS(4816),
    [anon_sym_when] = ACTIONS(4816),
    [anon_sym_from] = ACTIONS(4816),
    [anon_sym_into] = ACTIONS(4816),
    [anon_sym_join] = ACTIONS(4816),
    [anon_sym_on] = ACTIONS(4816),
    [anon_sym_equals] = ACTIONS(4816),
    [anon_sym_let] = ACTIONS(4816),
    [anon_sym_orderby] = ACTIONS(4816),
    [anon_sym_ascending] = ACTIONS(4816),
    [anon_sym_descending] = ACTIONS(4816),
    [anon_sym_group] = ACTIONS(4816),
    [anon_sym_by] = ACTIONS(4816),
    [anon_sym_select] = ACTIONS(4816),
    [aux_sym_preproc_if_token1] = ACTIONS(4818),
    [aux_sym_preproc_if_token3] = ACTIONS(4818),
    [aux_sym_preproc_else_token1] = ACTIONS(4818),
    [aux_sym_preproc_elif_token1] = ACTIONS(4818),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3249] = {
    [sym_preproc_region] = STATE(3249),
    [sym_preproc_endregion] = STATE(3249),
    [sym_preproc_line] = STATE(3249),
    [sym_preproc_pragma] = STATE(3249),
    [sym_preproc_nullable] = STATE(3249),
    [sym_preproc_error] = STATE(3249),
    [sym_preproc_define] = STATE(3249),
    [sym_preproc_undef] = STATE(3249),
    [sym__identifier_token] = ACTIONS(4820),
    [anon_sym_extern] = ACTIONS(4820),
    [anon_sym_alias] = ACTIONS(4820),
    [anon_sym_global] = ACTIONS(4820),
    [anon_sym_using] = ACTIONS(4820),
    [anon_sym_unsafe] = ACTIONS(4820),
    [anon_sym_static] = ACTIONS(4820),
    [anon_sym_LBRACK] = ACTIONS(4822),
    [anon_sym_LPAREN] = ACTIONS(4822),
    [anon_sym_event] = ACTIONS(4820),
    [anon_sym_namespace] = ACTIONS(4820),
    [anon_sym_class] = ACTIONS(4820),
    [anon_sym_ref] = ACTIONS(4820),
    [anon_sym_struct] = ACTIONS(4820),
    [anon_sym_enum] = ACTIONS(4820),
    [anon_sym_RBRACE] = ACTIONS(4822),
    [anon_sym_interface] = ACTIONS(4820),
    [anon_sym_delegate] = ACTIONS(4820),
    [anon_sym_record] = ACTIONS(4820),
    [anon_sym_abstract] = ACTIONS(4820),
    [anon_sym_async] = ACTIONS(4820),
    [anon_sym_const] = ACTIONS(4820),
    [anon_sym_file] = ACTIONS(4820),
    [anon_sym_fixed] = ACTIONS(4820),
    [anon_sym_internal] = ACTIONS(4820),
    [anon_sym_new] = ACTIONS(4820),
    [anon_sym_override] = ACTIONS(4820),
    [anon_sym_partial] = ACTIONS(4820),
    [anon_sym_private] = ACTIONS(4820),
    [anon_sym_protected] = ACTIONS(4820),
    [anon_sym_public] = ACTIONS(4820),
    [anon_sym_readonly] = ACTIONS(4820),
    [anon_sym_required] = ACTIONS(4820),
    [anon_sym_sealed] = ACTIONS(4820),
    [anon_sym_virtual] = ACTIONS(4820),
    [anon_sym_volatile] = ACTIONS(4820),
    [anon_sym_where] = ACTIONS(4820),
    [anon_sym_notnull] = ACTIONS(4820),
    [anon_sym_unmanaged] = ACTIONS(4820),
    [anon_sym_TILDE] = ACTIONS(4822),
    [anon_sym_implicit] = ACTIONS(4820),
    [anon_sym_explicit] = ACTIONS(4820),
    [anon_sym_scoped] = ACTIONS(4820),
    [anon_sym_var] = ACTIONS(4820),
    [sym_predefined_type] = ACTIONS(4820),
    [anon_sym_yield] = ACTIONS(4820),
    [anon_sym_when] = ACTIONS(4820),
    [anon_sym_from] = ACTIONS(4820),
    [anon_sym_into] = ACTIONS(4820),
    [anon_sym_join] = ACTIONS(4820),
    [anon_sym_on] = ACTIONS(4820),
    [anon_sym_equals] = ACTIONS(4820),
    [anon_sym_let] = ACTIONS(4820),
    [anon_sym_orderby] = ACTIONS(4820),
    [anon_sym_ascending] = ACTIONS(4820),
    [anon_sym_descending] = ACTIONS(4820),
    [anon_sym_group] = ACTIONS(4820),
    [anon_sym_by] = ACTIONS(4820),
    [anon_sym_select] = ACTIONS(4820),
    [aux_sym_preproc_if_token1] = ACTIONS(4822),
    [aux_sym_preproc_if_token3] = ACTIONS(4822),
    [aux_sym_preproc_else_token1] = ACTIONS(4822),
    [aux_sym_preproc_elif_token1] = ACTIONS(4822),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3250] = {
    [sym_preproc_region] = STATE(3250),
    [sym_preproc_endregion] = STATE(3250),
    [sym_preproc_line] = STATE(3250),
    [sym_preproc_pragma] = STATE(3250),
    [sym_preproc_nullable] = STATE(3250),
    [sym_preproc_error] = STATE(3250),
    [sym_preproc_define] = STATE(3250),
    [sym_preproc_undef] = STATE(3250),
    [sym__identifier_token] = ACTIONS(3840),
    [anon_sym_extern] = ACTIONS(3840),
    [anon_sym_alias] = ACTIONS(3840),
    [anon_sym_global] = ACTIONS(3840),
    [anon_sym_using] = ACTIONS(3840),
    [anon_sym_unsafe] = ACTIONS(3840),
    [anon_sym_static] = ACTIONS(3840),
    [anon_sym_LBRACK] = ACTIONS(3842),
    [anon_sym_LPAREN] = ACTIONS(3842),
    [anon_sym_event] = ACTIONS(3840),
    [anon_sym_namespace] = ACTIONS(3840),
    [anon_sym_class] = ACTIONS(3840),
    [anon_sym_ref] = ACTIONS(3840),
    [anon_sym_struct] = ACTIONS(3840),
    [anon_sym_enum] = ACTIONS(3840),
    [anon_sym_RBRACE] = ACTIONS(3842),
    [anon_sym_interface] = ACTIONS(3840),
    [anon_sym_delegate] = ACTIONS(3840),
    [anon_sym_record] = ACTIONS(3840),
    [anon_sym_abstract] = ACTIONS(3840),
    [anon_sym_async] = ACTIONS(3840),
    [anon_sym_const] = ACTIONS(3840),
    [anon_sym_file] = ACTIONS(3840),
    [anon_sym_fixed] = ACTIONS(3840),
    [anon_sym_internal] = ACTIONS(3840),
    [anon_sym_new] = ACTIONS(3840),
    [anon_sym_override] = ACTIONS(3840),
    [anon_sym_partial] = ACTIONS(3840),
    [anon_sym_private] = ACTIONS(3840),
    [anon_sym_protected] = ACTIONS(3840),
    [anon_sym_public] = ACTIONS(3840),
    [anon_sym_readonly] = ACTIONS(3840),
    [anon_sym_required] = ACTIONS(3840),
    [anon_sym_sealed] = ACTIONS(3840),
    [anon_sym_virtual] = ACTIONS(3840),
    [anon_sym_volatile] = ACTIONS(3840),
    [anon_sym_where] = ACTIONS(3840),
    [anon_sym_notnull] = ACTIONS(3840),
    [anon_sym_unmanaged] = ACTIONS(3840),
    [anon_sym_TILDE] = ACTIONS(3842),
    [anon_sym_implicit] = ACTIONS(3840),
    [anon_sym_explicit] = ACTIONS(3840),
    [anon_sym_scoped] = ACTIONS(3840),
    [anon_sym_var] = ACTIONS(3840),
    [sym_predefined_type] = ACTIONS(3840),
    [anon_sym_yield] = ACTIONS(3840),
    [anon_sym_when] = ACTIONS(3840),
    [anon_sym_from] = ACTIONS(3840),
    [anon_sym_into] = ACTIONS(3840),
    [anon_sym_join] = ACTIONS(3840),
    [anon_sym_on] = ACTIONS(3840),
    [anon_sym_equals] = ACTIONS(3840),
    [anon_sym_let] = ACTIONS(3840),
    [anon_sym_orderby] = ACTIONS(3840),
    [anon_sym_ascending] = ACTIONS(3840),
    [anon_sym_descending] = ACTIONS(3840),
    [anon_sym_group] = ACTIONS(3840),
    [anon_sym_by] = ACTIONS(3840),
    [anon_sym_select] = ACTIONS(3840),
    [aux_sym_preproc_if_token1] = ACTIONS(3842),
    [aux_sym_preproc_if_token3] = ACTIONS(3842),
    [aux_sym_preproc_else_token1] = ACTIONS(3842),
    [aux_sym_preproc_elif_token1] = ACTIONS(3842),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3251] = {
    [sym_preproc_region] = STATE(3251),
    [sym_preproc_endregion] = STATE(3251),
    [sym_preproc_line] = STATE(3251),
    [sym_preproc_pragma] = STATE(3251),
    [sym_preproc_nullable] = STATE(3251),
    [sym_preproc_error] = STATE(3251),
    [sym_preproc_define] = STATE(3251),
    [sym_preproc_undef] = STATE(3251),
    [sym__identifier_token] = ACTIONS(3844),
    [anon_sym_extern] = ACTIONS(3844),
    [anon_sym_alias] = ACTIONS(3844),
    [anon_sym_global] = ACTIONS(3844),
    [anon_sym_using] = ACTIONS(3844),
    [anon_sym_unsafe] = ACTIONS(3844),
    [anon_sym_static] = ACTIONS(3844),
    [anon_sym_LBRACK] = ACTIONS(3846),
    [anon_sym_LPAREN] = ACTIONS(3846),
    [anon_sym_event] = ACTIONS(3844),
    [anon_sym_namespace] = ACTIONS(3844),
    [anon_sym_class] = ACTIONS(3844),
    [anon_sym_ref] = ACTIONS(3844),
    [anon_sym_struct] = ACTIONS(3844),
    [anon_sym_enum] = ACTIONS(3844),
    [anon_sym_RBRACE] = ACTIONS(3846),
    [anon_sym_interface] = ACTIONS(3844),
    [anon_sym_delegate] = ACTIONS(3844),
    [anon_sym_record] = ACTIONS(3844),
    [anon_sym_abstract] = ACTIONS(3844),
    [anon_sym_async] = ACTIONS(3844),
    [anon_sym_const] = ACTIONS(3844),
    [anon_sym_file] = ACTIONS(3844),
    [anon_sym_fixed] = ACTIONS(3844),
    [anon_sym_internal] = ACTIONS(3844),
    [anon_sym_new] = ACTIONS(3844),
    [anon_sym_override] = ACTIONS(3844),
    [anon_sym_partial] = ACTIONS(3844),
    [anon_sym_private] = ACTIONS(3844),
    [anon_sym_protected] = ACTIONS(3844),
    [anon_sym_public] = ACTIONS(3844),
    [anon_sym_readonly] = ACTIONS(3844),
    [anon_sym_required] = ACTIONS(3844),
    [anon_sym_sealed] = ACTIONS(3844),
    [anon_sym_virtual] = ACTIONS(3844),
    [anon_sym_volatile] = ACTIONS(3844),
    [anon_sym_where] = ACTIONS(3844),
    [anon_sym_notnull] = ACTIONS(3844),
    [anon_sym_unmanaged] = ACTIONS(3844),
    [anon_sym_TILDE] = ACTIONS(3846),
    [anon_sym_implicit] = ACTIONS(3844),
    [anon_sym_explicit] = ACTIONS(3844),
    [anon_sym_scoped] = ACTIONS(3844),
    [anon_sym_var] = ACTIONS(3844),
    [sym_predefined_type] = ACTIONS(3844),
    [anon_sym_yield] = ACTIONS(3844),
    [anon_sym_when] = ACTIONS(3844),
    [anon_sym_from] = ACTIONS(3844),
    [anon_sym_into] = ACTIONS(3844),
    [anon_sym_join] = ACTIONS(3844),
    [anon_sym_on] = ACTIONS(3844),
    [anon_sym_equals] = ACTIONS(3844),
    [anon_sym_let] = ACTIONS(3844),
    [anon_sym_orderby] = ACTIONS(3844),
    [anon_sym_ascending] = ACTIONS(3844),
    [anon_sym_descending] = ACTIONS(3844),
    [anon_sym_group] = ACTIONS(3844),
    [anon_sym_by] = ACTIONS(3844),
    [anon_sym_select] = ACTIONS(3844),
    [aux_sym_preproc_if_token1] = ACTIONS(3846),
    [aux_sym_preproc_if_token3] = ACTIONS(3846),
    [aux_sym_preproc_else_token1] = ACTIONS(3846),
    [aux_sym_preproc_elif_token1] = ACTIONS(3846),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3252] = {
    [sym_preproc_region] = STATE(3252),
    [sym_preproc_endregion] = STATE(3252),
    [sym_preproc_line] = STATE(3252),
    [sym_preproc_pragma] = STATE(3252),
    [sym_preproc_nullable] = STATE(3252),
    [sym_preproc_error] = STATE(3252),
    [sym_preproc_define] = STATE(3252),
    [sym_preproc_undef] = STATE(3252),
    [sym__identifier_token] = ACTIONS(3848),
    [anon_sym_extern] = ACTIONS(3848),
    [anon_sym_alias] = ACTIONS(3848),
    [anon_sym_global] = ACTIONS(3848),
    [anon_sym_using] = ACTIONS(3848),
    [anon_sym_unsafe] = ACTIONS(3848),
    [anon_sym_static] = ACTIONS(3848),
    [anon_sym_LBRACK] = ACTIONS(3850),
    [anon_sym_LPAREN] = ACTIONS(3850),
    [anon_sym_event] = ACTIONS(3848),
    [anon_sym_namespace] = ACTIONS(3848),
    [anon_sym_class] = ACTIONS(3848),
    [anon_sym_ref] = ACTIONS(3848),
    [anon_sym_struct] = ACTIONS(3848),
    [anon_sym_enum] = ACTIONS(3848),
    [anon_sym_RBRACE] = ACTIONS(3850),
    [anon_sym_interface] = ACTIONS(3848),
    [anon_sym_delegate] = ACTIONS(3848),
    [anon_sym_record] = ACTIONS(3848),
    [anon_sym_abstract] = ACTIONS(3848),
    [anon_sym_async] = ACTIONS(3848),
    [anon_sym_const] = ACTIONS(3848),
    [anon_sym_file] = ACTIONS(3848),
    [anon_sym_fixed] = ACTIONS(3848),
    [anon_sym_internal] = ACTIONS(3848),
    [anon_sym_new] = ACTIONS(3848),
    [anon_sym_override] = ACTIONS(3848),
    [anon_sym_partial] = ACTIONS(3848),
    [anon_sym_private] = ACTIONS(3848),
    [anon_sym_protected] = ACTIONS(3848),
    [anon_sym_public] = ACTIONS(3848),
    [anon_sym_readonly] = ACTIONS(3848),
    [anon_sym_required] = ACTIONS(3848),
    [anon_sym_sealed] = ACTIONS(3848),
    [anon_sym_virtual] = ACTIONS(3848),
    [anon_sym_volatile] = ACTIONS(3848),
    [anon_sym_where] = ACTIONS(3848),
    [anon_sym_notnull] = ACTIONS(3848),
    [anon_sym_unmanaged] = ACTIONS(3848),
    [anon_sym_TILDE] = ACTIONS(3850),
    [anon_sym_implicit] = ACTIONS(3848),
    [anon_sym_explicit] = ACTIONS(3848),
    [anon_sym_scoped] = ACTIONS(3848),
    [anon_sym_var] = ACTIONS(3848),
    [sym_predefined_type] = ACTIONS(3848),
    [anon_sym_yield] = ACTIONS(3848),
    [anon_sym_when] = ACTIONS(3848),
    [anon_sym_from] = ACTIONS(3848),
    [anon_sym_into] = ACTIONS(3848),
    [anon_sym_join] = ACTIONS(3848),
    [anon_sym_on] = ACTIONS(3848),
    [anon_sym_equals] = ACTIONS(3848),
    [anon_sym_let] = ACTIONS(3848),
    [anon_sym_orderby] = ACTIONS(3848),
    [anon_sym_ascending] = ACTIONS(3848),
    [anon_sym_descending] = ACTIONS(3848),
    [anon_sym_group] = ACTIONS(3848),
    [anon_sym_by] = ACTIONS(3848),
    [anon_sym_select] = ACTIONS(3848),
    [aux_sym_preproc_if_token1] = ACTIONS(3850),
    [aux_sym_preproc_if_token3] = ACTIONS(3850),
    [aux_sym_preproc_else_token1] = ACTIONS(3850),
    [aux_sym_preproc_elif_token1] = ACTIONS(3850),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3253] = {
    [sym_preproc_region] = STATE(3253),
    [sym_preproc_endregion] = STATE(3253),
    [sym_preproc_line] = STATE(3253),
    [sym_preproc_pragma] = STATE(3253),
    [sym_preproc_nullable] = STATE(3253),
    [sym_preproc_error] = STATE(3253),
    [sym_preproc_define] = STATE(3253),
    [sym_preproc_undef] = STATE(3253),
    [sym__identifier_token] = ACTIONS(3852),
    [anon_sym_extern] = ACTIONS(3852),
    [anon_sym_alias] = ACTIONS(3852),
    [anon_sym_global] = ACTIONS(3852),
    [anon_sym_using] = ACTIONS(3852),
    [anon_sym_unsafe] = ACTIONS(3852),
    [anon_sym_static] = ACTIONS(3852),
    [anon_sym_LBRACK] = ACTIONS(3854),
    [anon_sym_LPAREN] = ACTIONS(3854),
    [anon_sym_event] = ACTIONS(3852),
    [anon_sym_namespace] = ACTIONS(3852),
    [anon_sym_class] = ACTIONS(3852),
    [anon_sym_ref] = ACTIONS(3852),
    [anon_sym_struct] = ACTIONS(3852),
    [anon_sym_enum] = ACTIONS(3852),
    [anon_sym_RBRACE] = ACTIONS(3854),
    [anon_sym_interface] = ACTIONS(3852),
    [anon_sym_delegate] = ACTIONS(3852),
    [anon_sym_record] = ACTIONS(3852),
    [anon_sym_abstract] = ACTIONS(3852),
    [anon_sym_async] = ACTIONS(3852),
    [anon_sym_const] = ACTIONS(3852),
    [anon_sym_file] = ACTIONS(3852),
    [anon_sym_fixed] = ACTIONS(3852),
    [anon_sym_internal] = ACTIONS(3852),
    [anon_sym_new] = ACTIONS(3852),
    [anon_sym_override] = ACTIONS(3852),
    [anon_sym_partial] = ACTIONS(3852),
    [anon_sym_private] = ACTIONS(3852),
    [anon_sym_protected] = ACTIONS(3852),
    [anon_sym_public] = ACTIONS(3852),
    [anon_sym_readonly] = ACTIONS(3852),
    [anon_sym_required] = ACTIONS(3852),
    [anon_sym_sealed] = ACTIONS(3852),
    [anon_sym_virtual] = ACTIONS(3852),
    [anon_sym_volatile] = ACTIONS(3852),
    [anon_sym_where] = ACTIONS(3852),
    [anon_sym_notnull] = ACTIONS(3852),
    [anon_sym_unmanaged] = ACTIONS(3852),
    [anon_sym_TILDE] = ACTIONS(3854),
    [anon_sym_implicit] = ACTIONS(3852),
    [anon_sym_explicit] = ACTIONS(3852),
    [anon_sym_scoped] = ACTIONS(3852),
    [anon_sym_var] = ACTIONS(3852),
    [sym_predefined_type] = ACTIONS(3852),
    [anon_sym_yield] = ACTIONS(3852),
    [anon_sym_when] = ACTIONS(3852),
    [anon_sym_from] = ACTIONS(3852),
    [anon_sym_into] = ACTIONS(3852),
    [anon_sym_join] = ACTIONS(3852),
    [anon_sym_on] = ACTIONS(3852),
    [anon_sym_equals] = ACTIONS(3852),
    [anon_sym_let] = ACTIONS(3852),
    [anon_sym_orderby] = ACTIONS(3852),
    [anon_sym_ascending] = ACTIONS(3852),
    [anon_sym_descending] = ACTIONS(3852),
    [anon_sym_group] = ACTIONS(3852),
    [anon_sym_by] = ACTIONS(3852),
    [anon_sym_select] = ACTIONS(3852),
    [aux_sym_preproc_if_token1] = ACTIONS(3854),
    [aux_sym_preproc_if_token3] = ACTIONS(3854),
    [aux_sym_preproc_else_token1] = ACTIONS(3854),
    [aux_sym_preproc_elif_token1] = ACTIONS(3854),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3254] = {
    [sym_preproc_region] = STATE(3254),
    [sym_preproc_endregion] = STATE(3254),
    [sym_preproc_line] = STATE(3254),
    [sym_preproc_pragma] = STATE(3254),
    [sym_preproc_nullable] = STATE(3254),
    [sym_preproc_error] = STATE(3254),
    [sym_preproc_define] = STATE(3254),
    [sym_preproc_undef] = STATE(3254),
    [sym__identifier_token] = ACTIONS(3417),
    [anon_sym_extern] = ACTIONS(3417),
    [anon_sym_alias] = ACTIONS(3417),
    [anon_sym_global] = ACTIONS(3417),
    [anon_sym_using] = ACTIONS(3417),
    [anon_sym_unsafe] = ACTIONS(3417),
    [anon_sym_static] = ACTIONS(3417),
    [anon_sym_LBRACK] = ACTIONS(3419),
    [anon_sym_LPAREN] = ACTIONS(3419),
    [anon_sym_event] = ACTIONS(3417),
    [anon_sym_namespace] = ACTIONS(3417),
    [anon_sym_class] = ACTIONS(3417),
    [anon_sym_ref] = ACTIONS(3417),
    [anon_sym_struct] = ACTIONS(3417),
    [anon_sym_enum] = ACTIONS(3417),
    [anon_sym_RBRACE] = ACTIONS(3419),
    [anon_sym_interface] = ACTIONS(3417),
    [anon_sym_delegate] = ACTIONS(3417),
    [anon_sym_record] = ACTIONS(3417),
    [anon_sym_abstract] = ACTIONS(3417),
    [anon_sym_async] = ACTIONS(3417),
    [anon_sym_const] = ACTIONS(3417),
    [anon_sym_file] = ACTIONS(3417),
    [anon_sym_fixed] = ACTIONS(3417),
    [anon_sym_internal] = ACTIONS(3417),
    [anon_sym_new] = ACTIONS(3417),
    [anon_sym_override] = ACTIONS(3417),
    [anon_sym_partial] = ACTIONS(3417),
    [anon_sym_private] = ACTIONS(3417),
    [anon_sym_protected] = ACTIONS(3417),
    [anon_sym_public] = ACTIONS(3417),
    [anon_sym_readonly] = ACTIONS(3417),
    [anon_sym_required] = ACTIONS(3417),
    [anon_sym_sealed] = ACTIONS(3417),
    [anon_sym_virtual] = ACTIONS(3417),
    [anon_sym_volatile] = ACTIONS(3417),
    [anon_sym_where] = ACTIONS(3417),
    [anon_sym_notnull] = ACTIONS(3417),
    [anon_sym_unmanaged] = ACTIONS(3417),
    [anon_sym_TILDE] = ACTIONS(3419),
    [anon_sym_implicit] = ACTIONS(3417),
    [anon_sym_explicit] = ACTIONS(3417),
    [anon_sym_scoped] = ACTIONS(3417),
    [anon_sym_var] = ACTIONS(3417),
    [sym_predefined_type] = ACTIONS(3417),
    [anon_sym_yield] = ACTIONS(3417),
    [anon_sym_when] = ACTIONS(3417),
    [anon_sym_from] = ACTIONS(3417),
    [anon_sym_into] = ACTIONS(3417),
    [anon_sym_join] = ACTIONS(3417),
    [anon_sym_on] = ACTIONS(3417),
    [anon_sym_equals] = ACTIONS(3417),
    [anon_sym_let] = ACTIONS(3417),
    [anon_sym_orderby] = ACTIONS(3417),
    [anon_sym_ascending] = ACTIONS(3417),
    [anon_sym_descending] = ACTIONS(3417),
    [anon_sym_group] = ACTIONS(3417),
    [anon_sym_by] = ACTIONS(3417),
    [anon_sym_select] = ACTIONS(3417),
    [aux_sym_preproc_if_token1] = ACTIONS(3419),
    [aux_sym_preproc_if_token3] = ACTIONS(3419),
    [aux_sym_preproc_else_token1] = ACTIONS(3419),
    [aux_sym_preproc_elif_token1] = ACTIONS(3419),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3255] = {
    [sym_preproc_region] = STATE(3255),
    [sym_preproc_endregion] = STATE(3255),
    [sym_preproc_line] = STATE(3255),
    [sym_preproc_pragma] = STATE(3255),
    [sym_preproc_nullable] = STATE(3255),
    [sym_preproc_error] = STATE(3255),
    [sym_preproc_define] = STATE(3255),
    [sym_preproc_undef] = STATE(3255),
    [sym__identifier_token] = ACTIONS(3760),
    [anon_sym_extern] = ACTIONS(3760),
    [anon_sym_alias] = ACTIONS(3760),
    [anon_sym_global] = ACTIONS(3760),
    [anon_sym_using] = ACTIONS(3760),
    [anon_sym_unsafe] = ACTIONS(3760),
    [anon_sym_static] = ACTIONS(3760),
    [anon_sym_LBRACK] = ACTIONS(3762),
    [anon_sym_LPAREN] = ACTIONS(3762),
    [anon_sym_event] = ACTIONS(3760),
    [anon_sym_namespace] = ACTIONS(3760),
    [anon_sym_class] = ACTIONS(3760),
    [anon_sym_ref] = ACTIONS(3760),
    [anon_sym_struct] = ACTIONS(3760),
    [anon_sym_enum] = ACTIONS(3760),
    [anon_sym_RBRACE] = ACTIONS(3762),
    [anon_sym_interface] = ACTIONS(3760),
    [anon_sym_delegate] = ACTIONS(3760),
    [anon_sym_record] = ACTIONS(3760),
    [anon_sym_abstract] = ACTIONS(3760),
    [anon_sym_async] = ACTIONS(3760),
    [anon_sym_const] = ACTIONS(3760),
    [anon_sym_file] = ACTIONS(3760),
    [anon_sym_fixed] = ACTIONS(3760),
    [anon_sym_internal] = ACTIONS(3760),
    [anon_sym_new] = ACTIONS(3760),
    [anon_sym_override] = ACTIONS(3760),
    [anon_sym_partial] = ACTIONS(3760),
    [anon_sym_private] = ACTIONS(3760),
    [anon_sym_protected] = ACTIONS(3760),
    [anon_sym_public] = ACTIONS(3760),
    [anon_sym_readonly] = ACTIONS(3760),
    [anon_sym_required] = ACTIONS(3760),
    [anon_sym_sealed] = ACTIONS(3760),
    [anon_sym_virtual] = ACTIONS(3760),
    [anon_sym_volatile] = ACTIONS(3760),
    [anon_sym_where] = ACTIONS(3760),
    [anon_sym_notnull] = ACTIONS(3760),
    [anon_sym_unmanaged] = ACTIONS(3760),
    [anon_sym_TILDE] = ACTIONS(3762),
    [anon_sym_implicit] = ACTIONS(3760),
    [anon_sym_explicit] = ACTIONS(3760),
    [anon_sym_scoped] = ACTIONS(3760),
    [anon_sym_var] = ACTIONS(3760),
    [sym_predefined_type] = ACTIONS(3760),
    [anon_sym_yield] = ACTIONS(3760),
    [anon_sym_when] = ACTIONS(3760),
    [anon_sym_from] = ACTIONS(3760),
    [anon_sym_into] = ACTIONS(3760),
    [anon_sym_join] = ACTIONS(3760),
    [anon_sym_on] = ACTIONS(3760),
    [anon_sym_equals] = ACTIONS(3760),
    [anon_sym_let] = ACTIONS(3760),
    [anon_sym_orderby] = ACTIONS(3760),
    [anon_sym_ascending] = ACTIONS(3760),
    [anon_sym_descending] = ACTIONS(3760),
    [anon_sym_group] = ACTIONS(3760),
    [anon_sym_by] = ACTIONS(3760),
    [anon_sym_select] = ACTIONS(3760),
    [aux_sym_preproc_if_token1] = ACTIONS(3762),
    [aux_sym_preproc_if_token3] = ACTIONS(3762),
    [aux_sym_preproc_else_token1] = ACTIONS(3762),
    [aux_sym_preproc_elif_token1] = ACTIONS(3762),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3256] = {
    [sym_preproc_region] = STATE(3256),
    [sym_preproc_endregion] = STATE(3256),
    [sym_preproc_line] = STATE(3256),
    [sym_preproc_pragma] = STATE(3256),
    [sym_preproc_nullable] = STATE(3256),
    [sym_preproc_error] = STATE(3256),
    [sym_preproc_define] = STATE(3256),
    [sym_preproc_undef] = STATE(3256),
    [sym__identifier_token] = ACTIONS(3437),
    [anon_sym_extern] = ACTIONS(3437),
    [anon_sym_alias] = ACTIONS(3437),
    [anon_sym_global] = ACTIONS(3437),
    [anon_sym_using] = ACTIONS(3437),
    [anon_sym_unsafe] = ACTIONS(3437),
    [anon_sym_static] = ACTIONS(3437),
    [anon_sym_LBRACK] = ACTIONS(3439),
    [anon_sym_LPAREN] = ACTIONS(3439),
    [anon_sym_event] = ACTIONS(3437),
    [anon_sym_namespace] = ACTIONS(3437),
    [anon_sym_class] = ACTIONS(3437),
    [anon_sym_ref] = ACTIONS(3437),
    [anon_sym_struct] = ACTIONS(3437),
    [anon_sym_enum] = ACTIONS(3437),
    [anon_sym_RBRACE] = ACTIONS(3439),
    [anon_sym_interface] = ACTIONS(3437),
    [anon_sym_delegate] = ACTIONS(3437),
    [anon_sym_record] = ACTIONS(3437),
    [anon_sym_abstract] = ACTIONS(3437),
    [anon_sym_async] = ACTIONS(3437),
    [anon_sym_const] = ACTIONS(3437),
    [anon_sym_file] = ACTIONS(3437),
    [anon_sym_fixed] = ACTIONS(3437),
    [anon_sym_internal] = ACTIONS(3437),
    [anon_sym_new] = ACTIONS(3437),
    [anon_sym_override] = ACTIONS(3437),
    [anon_sym_partial] = ACTIONS(3437),
    [anon_sym_private] = ACTIONS(3437),
    [anon_sym_protected] = ACTIONS(3437),
    [anon_sym_public] = ACTIONS(3437),
    [anon_sym_readonly] = ACTIONS(3437),
    [anon_sym_required] = ACTIONS(3437),
    [anon_sym_sealed] = ACTIONS(3437),
    [anon_sym_virtual] = ACTIONS(3437),
    [anon_sym_volatile] = ACTIONS(3437),
    [anon_sym_where] = ACTIONS(3437),
    [anon_sym_notnull] = ACTIONS(3437),
    [anon_sym_unmanaged] = ACTIONS(3437),
    [anon_sym_TILDE] = ACTIONS(3439),
    [anon_sym_implicit] = ACTIONS(3437),
    [anon_sym_explicit] = ACTIONS(3437),
    [anon_sym_scoped] = ACTIONS(3437),
    [anon_sym_var] = ACTIONS(3437),
    [sym_predefined_type] = ACTIONS(3437),
    [anon_sym_yield] = ACTIONS(3437),
    [anon_sym_when] = ACTIONS(3437),
    [anon_sym_from] = ACTIONS(3437),
    [anon_sym_into] = ACTIONS(3437),
    [anon_sym_join] = ACTIONS(3437),
    [anon_sym_on] = ACTIONS(3437),
    [anon_sym_equals] = ACTIONS(3437),
    [anon_sym_let] = ACTIONS(3437),
    [anon_sym_orderby] = ACTIONS(3437),
    [anon_sym_ascending] = ACTIONS(3437),
    [anon_sym_descending] = ACTIONS(3437),
    [anon_sym_group] = ACTIONS(3437),
    [anon_sym_by] = ACTIONS(3437),
    [anon_sym_select] = ACTIONS(3437),
    [aux_sym_preproc_if_token1] = ACTIONS(3439),
    [aux_sym_preproc_if_token3] = ACTIONS(3439),
    [aux_sym_preproc_else_token1] = ACTIONS(3439),
    [aux_sym_preproc_elif_token1] = ACTIONS(3439),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3257] = {
    [sym_preproc_region] = STATE(3257),
    [sym_preproc_endregion] = STATE(3257),
    [sym_preproc_line] = STATE(3257),
    [sym_preproc_pragma] = STATE(3257),
    [sym_preproc_nullable] = STATE(3257),
    [sym_preproc_error] = STATE(3257),
    [sym_preproc_define] = STATE(3257),
    [sym_preproc_undef] = STATE(3257),
    [anon_sym_SEMI] = ACTIONS(4639),
    [anon_sym_EQ] = ACTIONS(4625),
    [anon_sym_LBRACK] = ACTIONS(4639),
    [anon_sym_COLON] = ACTIONS(4623),
    [anon_sym_COMMA] = ACTIONS(4639),
    [anon_sym_RBRACK] = ACTIONS(4639),
    [anon_sym_LPAREN] = ACTIONS(4639),
    [anon_sym_RPAREN] = ACTIONS(4639),
    [anon_sym_RBRACE] = ACTIONS(4639),
    [anon_sym_LT] = ACTIONS(4641),
    [anon_sym_GT] = ACTIONS(4641),
    [anon_sym_in] = ACTIONS(4639),
    [anon_sym_QMARK] = ACTIONS(4641),
    [anon_sym_BANG] = ACTIONS(4641),
    [anon_sym_PLUS_PLUS] = ACTIONS(4639),
    [anon_sym_DASH_DASH] = ACTIONS(4639),
    [anon_sym_PLUS] = ACTIONS(4641),
    [anon_sym_DASH] = ACTIONS(4641),
    [anon_sym_STAR] = ACTIONS(4641),
    [anon_sym_SLASH] = ACTIONS(4641),
    [anon_sym_PERCENT] = ACTIONS(4641),
    [anon_sym_CARET] = ACTIONS(4641),
    [anon_sym_PIPE] = ACTIONS(4641),
    [anon_sym_AMP] = ACTIONS(4641),
    [anon_sym_LT_LT] = ACTIONS(4641),
    [anon_sym_GT_GT] = ACTIONS(4641),
    [anon_sym_GT_GT_GT] = ACTIONS(4641),
    [anon_sym_EQ_EQ] = ACTIONS(4639),
    [anon_sym_BANG_EQ] = ACTIONS(4639),
    [anon_sym_GT_EQ] = ACTIONS(4639),
    [anon_sym_LT_EQ] = ACTIONS(4639),
    [anon_sym_DOT] = ACTIONS(4641),
    [anon_sym_EQ_GT] = ACTIONS(4639),
    [anon_sym_switch] = ACTIONS(4639),
    [anon_sym_when] = ACTIONS(4639),
    [anon_sym_DOT_DOT] = ACTIONS(4639),
    [anon_sym_and] = ACTIONS(4639),
    [anon_sym_or] = ACTIONS(4639),
    [anon_sym_PLUS_EQ] = ACTIONS(4623),
    [anon_sym_DASH_EQ] = ACTIONS(4623),
    [anon_sym_STAR_EQ] = ACTIONS(4623),
    [anon_sym_SLASH_EQ] = ACTIONS(4623),
    [anon_sym_PERCENT_EQ] = ACTIONS(4623),
    [anon_sym_AMP_EQ] = ACTIONS(4623),
    [anon_sym_CARET_EQ] = ACTIONS(4623),
    [anon_sym_PIPE_EQ] = ACTIONS(4623),
    [anon_sym_LT_LT_EQ] = ACTIONS(4623),
    [anon_sym_GT_GT_EQ] = ACTIONS(4623),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4623),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4623),
    [anon_sym_AMP_AMP] = ACTIONS(4639),
    [anon_sym_PIPE_PIPE] = ACTIONS(4639),
    [anon_sym_QMARK_QMARK] = ACTIONS(4641),
    [anon_sym_on] = ACTIONS(4639),
    [anon_sym_equals] = ACTIONS(4639),
    [anon_sym_by] = ACTIONS(4639),
    [anon_sym_as] = ACTIONS(4639),
    [anon_sym_is] = ACTIONS(4639),
    [anon_sym_DASH_GT] = ACTIONS(4639),
    [anon_sym_with] = ACTIONS(4639),
    [aux_sym_preproc_if_token3] = ACTIONS(4639),
    [aux_sym_preproc_else_token1] = ACTIONS(4639),
    [aux_sym_preproc_elif_token1] = ACTIONS(4639),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3258] = {
    [sym_preproc_region] = STATE(3258),
    [sym_preproc_endregion] = STATE(3258),
    [sym_preproc_line] = STATE(3258),
    [sym_preproc_pragma] = STATE(3258),
    [sym_preproc_nullable] = STATE(3258),
    [sym_preproc_error] = STATE(3258),
    [sym_preproc_define] = STATE(3258),
    [sym_preproc_undef] = STATE(3258),
    [sym__identifier_token] = ACTIONS(4824),
    [anon_sym_extern] = ACTIONS(4824),
    [anon_sym_alias] = ACTIONS(4824),
    [anon_sym_global] = ACTIONS(4824),
    [anon_sym_using] = ACTIONS(4824),
    [anon_sym_unsafe] = ACTIONS(4824),
    [anon_sym_static] = ACTIONS(4824),
    [anon_sym_LBRACK] = ACTIONS(4826),
    [anon_sym_LPAREN] = ACTIONS(4826),
    [anon_sym_event] = ACTIONS(4824),
    [anon_sym_namespace] = ACTIONS(4824),
    [anon_sym_class] = ACTIONS(4824),
    [anon_sym_ref] = ACTIONS(4824),
    [anon_sym_struct] = ACTIONS(4824),
    [anon_sym_enum] = ACTIONS(4824),
    [anon_sym_RBRACE] = ACTIONS(4826),
    [anon_sym_interface] = ACTIONS(4824),
    [anon_sym_delegate] = ACTIONS(4824),
    [anon_sym_record] = ACTIONS(4824),
    [anon_sym_abstract] = ACTIONS(4824),
    [anon_sym_async] = ACTIONS(4824),
    [anon_sym_const] = ACTIONS(4824),
    [anon_sym_file] = ACTIONS(4824),
    [anon_sym_fixed] = ACTIONS(4824),
    [anon_sym_internal] = ACTIONS(4824),
    [anon_sym_new] = ACTIONS(4824),
    [anon_sym_override] = ACTIONS(4824),
    [anon_sym_partial] = ACTIONS(4824),
    [anon_sym_private] = ACTIONS(4824),
    [anon_sym_protected] = ACTIONS(4824),
    [anon_sym_public] = ACTIONS(4824),
    [anon_sym_readonly] = ACTIONS(4824),
    [anon_sym_required] = ACTIONS(4824),
    [anon_sym_sealed] = ACTIONS(4824),
    [anon_sym_virtual] = ACTIONS(4824),
    [anon_sym_volatile] = ACTIONS(4824),
    [anon_sym_where] = ACTIONS(4824),
    [anon_sym_notnull] = ACTIONS(4824),
    [anon_sym_unmanaged] = ACTIONS(4824),
    [anon_sym_TILDE] = ACTIONS(4826),
    [anon_sym_implicit] = ACTIONS(4824),
    [anon_sym_explicit] = ACTIONS(4824),
    [anon_sym_scoped] = ACTIONS(4824),
    [anon_sym_var] = ACTIONS(4824),
    [sym_predefined_type] = ACTIONS(4824),
    [anon_sym_yield] = ACTIONS(4824),
    [anon_sym_when] = ACTIONS(4824),
    [anon_sym_from] = ACTIONS(4824),
    [anon_sym_into] = ACTIONS(4824),
    [anon_sym_join] = ACTIONS(4824),
    [anon_sym_on] = ACTIONS(4824),
    [anon_sym_equals] = ACTIONS(4824),
    [anon_sym_let] = ACTIONS(4824),
    [anon_sym_orderby] = ACTIONS(4824),
    [anon_sym_ascending] = ACTIONS(4824),
    [anon_sym_descending] = ACTIONS(4824),
    [anon_sym_group] = ACTIONS(4824),
    [anon_sym_by] = ACTIONS(4824),
    [anon_sym_select] = ACTIONS(4824),
    [aux_sym_preproc_if_token1] = ACTIONS(4826),
    [aux_sym_preproc_if_token3] = ACTIONS(4826),
    [aux_sym_preproc_else_token1] = ACTIONS(4826),
    [aux_sym_preproc_elif_token1] = ACTIONS(4826),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3259] = {
    [sym_preproc_region] = STATE(3259),
    [sym_preproc_endregion] = STATE(3259),
    [sym_preproc_line] = STATE(3259),
    [sym_preproc_pragma] = STATE(3259),
    [sym_preproc_nullable] = STATE(3259),
    [sym_preproc_error] = STATE(3259),
    [sym_preproc_define] = STATE(3259),
    [sym_preproc_undef] = STATE(3259),
    [sym__identifier_token] = ACTIONS(3864),
    [anon_sym_extern] = ACTIONS(3864),
    [anon_sym_alias] = ACTIONS(3864),
    [anon_sym_global] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3864),
    [anon_sym_unsafe] = ACTIONS(3864),
    [anon_sym_static] = ACTIONS(3864),
    [anon_sym_LBRACK] = ACTIONS(3866),
    [anon_sym_LPAREN] = ACTIONS(3866),
    [anon_sym_event] = ACTIONS(3864),
    [anon_sym_namespace] = ACTIONS(3864),
    [anon_sym_class] = ACTIONS(3864),
    [anon_sym_ref] = ACTIONS(3864),
    [anon_sym_struct] = ACTIONS(3864),
    [anon_sym_enum] = ACTIONS(3864),
    [anon_sym_RBRACE] = ACTIONS(3866),
    [anon_sym_interface] = ACTIONS(3864),
    [anon_sym_delegate] = ACTIONS(3864),
    [anon_sym_record] = ACTIONS(3864),
    [anon_sym_abstract] = ACTIONS(3864),
    [anon_sym_async] = ACTIONS(3864),
    [anon_sym_const] = ACTIONS(3864),
    [anon_sym_file] = ACTIONS(3864),
    [anon_sym_fixed] = ACTIONS(3864),
    [anon_sym_internal] = ACTIONS(3864),
    [anon_sym_new] = ACTIONS(3864),
    [anon_sym_override] = ACTIONS(3864),
    [anon_sym_partial] = ACTIONS(3864),
    [anon_sym_private] = ACTIONS(3864),
    [anon_sym_protected] = ACTIONS(3864),
    [anon_sym_public] = ACTIONS(3864),
    [anon_sym_readonly] = ACTIONS(3864),
    [anon_sym_required] = ACTIONS(3864),
    [anon_sym_sealed] = ACTIONS(3864),
    [anon_sym_virtual] = ACTIONS(3864),
    [anon_sym_volatile] = ACTIONS(3864),
    [anon_sym_where] = ACTIONS(3864),
    [anon_sym_notnull] = ACTIONS(3864),
    [anon_sym_unmanaged] = ACTIONS(3864),
    [anon_sym_TILDE] = ACTIONS(3866),
    [anon_sym_implicit] = ACTIONS(3864),
    [anon_sym_explicit] = ACTIONS(3864),
    [anon_sym_scoped] = ACTIONS(3864),
    [anon_sym_var] = ACTIONS(3864),
    [sym_predefined_type] = ACTIONS(3864),
    [anon_sym_yield] = ACTIONS(3864),
    [anon_sym_when] = ACTIONS(3864),
    [anon_sym_from] = ACTIONS(3864),
    [anon_sym_into] = ACTIONS(3864),
    [anon_sym_join] = ACTIONS(3864),
    [anon_sym_on] = ACTIONS(3864),
    [anon_sym_equals] = ACTIONS(3864),
    [anon_sym_let] = ACTIONS(3864),
    [anon_sym_orderby] = ACTIONS(3864),
    [anon_sym_ascending] = ACTIONS(3864),
    [anon_sym_descending] = ACTIONS(3864),
    [anon_sym_group] = ACTIONS(3864),
    [anon_sym_by] = ACTIONS(3864),
    [anon_sym_select] = ACTIONS(3864),
    [aux_sym_preproc_if_token1] = ACTIONS(3866),
    [aux_sym_preproc_if_token3] = ACTIONS(3866),
    [aux_sym_preproc_else_token1] = ACTIONS(3866),
    [aux_sym_preproc_elif_token1] = ACTIONS(3866),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3260] = {
    [sym_preproc_region] = STATE(3260),
    [sym_preproc_endregion] = STATE(3260),
    [sym_preproc_line] = STATE(3260),
    [sym_preproc_pragma] = STATE(3260),
    [sym_preproc_nullable] = STATE(3260),
    [sym_preproc_error] = STATE(3260),
    [sym_preproc_define] = STATE(3260),
    [sym_preproc_undef] = STATE(3260),
    [sym__identifier_token] = ACTIONS(4828),
    [anon_sym_extern] = ACTIONS(4828),
    [anon_sym_alias] = ACTIONS(4828),
    [anon_sym_global] = ACTIONS(4828),
    [anon_sym_using] = ACTIONS(4828),
    [anon_sym_unsafe] = ACTIONS(4828),
    [anon_sym_static] = ACTIONS(4828),
    [anon_sym_LBRACK] = ACTIONS(4830),
    [anon_sym_LPAREN] = ACTIONS(4830),
    [anon_sym_event] = ACTIONS(4828),
    [anon_sym_namespace] = ACTIONS(4828),
    [anon_sym_class] = ACTIONS(4828),
    [anon_sym_ref] = ACTIONS(4828),
    [anon_sym_struct] = ACTIONS(4828),
    [anon_sym_enum] = ACTIONS(4828),
    [anon_sym_RBRACE] = ACTIONS(4830),
    [anon_sym_interface] = ACTIONS(4828),
    [anon_sym_delegate] = ACTIONS(4828),
    [anon_sym_record] = ACTIONS(4828),
    [anon_sym_abstract] = ACTIONS(4828),
    [anon_sym_async] = ACTIONS(4828),
    [anon_sym_const] = ACTIONS(4828),
    [anon_sym_file] = ACTIONS(4828),
    [anon_sym_fixed] = ACTIONS(4828),
    [anon_sym_internal] = ACTIONS(4828),
    [anon_sym_new] = ACTIONS(4828),
    [anon_sym_override] = ACTIONS(4828),
    [anon_sym_partial] = ACTIONS(4828),
    [anon_sym_private] = ACTIONS(4828),
    [anon_sym_protected] = ACTIONS(4828),
    [anon_sym_public] = ACTIONS(4828),
    [anon_sym_readonly] = ACTIONS(4828),
    [anon_sym_required] = ACTIONS(4828),
    [anon_sym_sealed] = ACTIONS(4828),
    [anon_sym_virtual] = ACTIONS(4828),
    [anon_sym_volatile] = ACTIONS(4828),
    [anon_sym_where] = ACTIONS(4828),
    [anon_sym_notnull] = ACTIONS(4828),
    [anon_sym_unmanaged] = ACTIONS(4828),
    [anon_sym_TILDE] = ACTIONS(4830),
    [anon_sym_implicit] = ACTIONS(4828),
    [anon_sym_explicit] = ACTIONS(4828),
    [anon_sym_scoped] = ACTIONS(4828),
    [anon_sym_var] = ACTIONS(4828),
    [sym_predefined_type] = ACTIONS(4828),
    [anon_sym_yield] = ACTIONS(4828),
    [anon_sym_when] = ACTIONS(4828),
    [anon_sym_from] = ACTIONS(4828),
    [anon_sym_into] = ACTIONS(4828),
    [anon_sym_join] = ACTIONS(4828),
    [anon_sym_on] = ACTIONS(4828),
    [anon_sym_equals] = ACTIONS(4828),
    [anon_sym_let] = ACTIONS(4828),
    [anon_sym_orderby] = ACTIONS(4828),
    [anon_sym_ascending] = ACTIONS(4828),
    [anon_sym_descending] = ACTIONS(4828),
    [anon_sym_group] = ACTIONS(4828),
    [anon_sym_by] = ACTIONS(4828),
    [anon_sym_select] = ACTIONS(4828),
    [aux_sym_preproc_if_token1] = ACTIONS(4830),
    [aux_sym_preproc_if_token3] = ACTIONS(4830),
    [aux_sym_preproc_else_token1] = ACTIONS(4830),
    [aux_sym_preproc_elif_token1] = ACTIONS(4830),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3261] = {
    [sym_preproc_region] = STATE(3261),
    [sym_preproc_endregion] = STATE(3261),
    [sym_preproc_line] = STATE(3261),
    [sym_preproc_pragma] = STATE(3261),
    [sym_preproc_nullable] = STATE(3261),
    [sym_preproc_error] = STATE(3261),
    [sym_preproc_define] = STATE(3261),
    [sym_preproc_undef] = STATE(3261),
    [sym__identifier_token] = ACTIONS(4832),
    [anon_sym_extern] = ACTIONS(4832),
    [anon_sym_alias] = ACTIONS(4832),
    [anon_sym_global] = ACTIONS(4832),
    [anon_sym_using] = ACTIONS(4832),
    [anon_sym_unsafe] = ACTIONS(4832),
    [anon_sym_static] = ACTIONS(4832),
    [anon_sym_LBRACK] = ACTIONS(4834),
    [anon_sym_LPAREN] = ACTIONS(4834),
    [anon_sym_event] = ACTIONS(4832),
    [anon_sym_namespace] = ACTIONS(4832),
    [anon_sym_class] = ACTIONS(4832),
    [anon_sym_ref] = ACTIONS(4832),
    [anon_sym_struct] = ACTIONS(4832),
    [anon_sym_enum] = ACTIONS(4832),
    [anon_sym_RBRACE] = ACTIONS(4834),
    [anon_sym_interface] = ACTIONS(4832),
    [anon_sym_delegate] = ACTIONS(4832),
    [anon_sym_record] = ACTIONS(4832),
    [anon_sym_abstract] = ACTIONS(4832),
    [anon_sym_async] = ACTIONS(4832),
    [anon_sym_const] = ACTIONS(4832),
    [anon_sym_file] = ACTIONS(4832),
    [anon_sym_fixed] = ACTIONS(4832),
    [anon_sym_internal] = ACTIONS(4832),
    [anon_sym_new] = ACTIONS(4832),
    [anon_sym_override] = ACTIONS(4832),
    [anon_sym_partial] = ACTIONS(4832),
    [anon_sym_private] = ACTIONS(4832),
    [anon_sym_protected] = ACTIONS(4832),
    [anon_sym_public] = ACTIONS(4832),
    [anon_sym_readonly] = ACTIONS(4832),
    [anon_sym_required] = ACTIONS(4832),
    [anon_sym_sealed] = ACTIONS(4832),
    [anon_sym_virtual] = ACTIONS(4832),
    [anon_sym_volatile] = ACTIONS(4832),
    [anon_sym_where] = ACTIONS(4832),
    [anon_sym_notnull] = ACTIONS(4832),
    [anon_sym_unmanaged] = ACTIONS(4832),
    [anon_sym_TILDE] = ACTIONS(4834),
    [anon_sym_implicit] = ACTIONS(4832),
    [anon_sym_explicit] = ACTIONS(4832),
    [anon_sym_scoped] = ACTIONS(4832),
    [anon_sym_var] = ACTIONS(4832),
    [sym_predefined_type] = ACTIONS(4832),
    [anon_sym_yield] = ACTIONS(4832),
    [anon_sym_when] = ACTIONS(4832),
    [anon_sym_from] = ACTIONS(4832),
    [anon_sym_into] = ACTIONS(4832),
    [anon_sym_join] = ACTIONS(4832),
    [anon_sym_on] = ACTIONS(4832),
    [anon_sym_equals] = ACTIONS(4832),
    [anon_sym_let] = ACTIONS(4832),
    [anon_sym_orderby] = ACTIONS(4832),
    [anon_sym_ascending] = ACTIONS(4832),
    [anon_sym_descending] = ACTIONS(4832),
    [anon_sym_group] = ACTIONS(4832),
    [anon_sym_by] = ACTIONS(4832),
    [anon_sym_select] = ACTIONS(4832),
    [aux_sym_preproc_if_token1] = ACTIONS(4834),
    [aux_sym_preproc_if_token3] = ACTIONS(4834),
    [aux_sym_preproc_else_token1] = ACTIONS(4834),
    [aux_sym_preproc_elif_token1] = ACTIONS(4834),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3262] = {
    [sym_preproc_region] = STATE(3262),
    [sym_preproc_endregion] = STATE(3262),
    [sym_preproc_line] = STATE(3262),
    [sym_preproc_pragma] = STATE(3262),
    [sym_preproc_nullable] = STATE(3262),
    [sym_preproc_error] = STATE(3262),
    [sym_preproc_define] = STATE(3262),
    [sym_preproc_undef] = STATE(3262),
    [sym__identifier_token] = ACTIONS(3429),
    [anon_sym_extern] = ACTIONS(3429),
    [anon_sym_alias] = ACTIONS(3429),
    [anon_sym_global] = ACTIONS(3429),
    [anon_sym_using] = ACTIONS(3429),
    [anon_sym_unsafe] = ACTIONS(3429),
    [anon_sym_static] = ACTIONS(3429),
    [anon_sym_LBRACK] = ACTIONS(3431),
    [anon_sym_LPAREN] = ACTIONS(3431),
    [anon_sym_event] = ACTIONS(3429),
    [anon_sym_namespace] = ACTIONS(3429),
    [anon_sym_class] = ACTIONS(3429),
    [anon_sym_ref] = ACTIONS(3429),
    [anon_sym_struct] = ACTIONS(3429),
    [anon_sym_enum] = ACTIONS(3429),
    [anon_sym_RBRACE] = ACTIONS(3431),
    [anon_sym_interface] = ACTIONS(3429),
    [anon_sym_delegate] = ACTIONS(3429),
    [anon_sym_record] = ACTIONS(3429),
    [anon_sym_abstract] = ACTIONS(3429),
    [anon_sym_async] = ACTIONS(3429),
    [anon_sym_const] = ACTIONS(3429),
    [anon_sym_file] = ACTIONS(3429),
    [anon_sym_fixed] = ACTIONS(3429),
    [anon_sym_internal] = ACTIONS(3429),
    [anon_sym_new] = ACTIONS(3429),
    [anon_sym_override] = ACTIONS(3429),
    [anon_sym_partial] = ACTIONS(3429),
    [anon_sym_private] = ACTIONS(3429),
    [anon_sym_protected] = ACTIONS(3429),
    [anon_sym_public] = ACTIONS(3429),
    [anon_sym_readonly] = ACTIONS(3429),
    [anon_sym_required] = ACTIONS(3429),
    [anon_sym_sealed] = ACTIONS(3429),
    [anon_sym_virtual] = ACTIONS(3429),
    [anon_sym_volatile] = ACTIONS(3429),
    [anon_sym_where] = ACTIONS(3429),
    [anon_sym_notnull] = ACTIONS(3429),
    [anon_sym_unmanaged] = ACTIONS(3429),
    [anon_sym_TILDE] = ACTIONS(3431),
    [anon_sym_implicit] = ACTIONS(3429),
    [anon_sym_explicit] = ACTIONS(3429),
    [anon_sym_scoped] = ACTIONS(3429),
    [anon_sym_var] = ACTIONS(3429),
    [sym_predefined_type] = ACTIONS(3429),
    [anon_sym_yield] = ACTIONS(3429),
    [anon_sym_when] = ACTIONS(3429),
    [anon_sym_from] = ACTIONS(3429),
    [anon_sym_into] = ACTIONS(3429),
    [anon_sym_join] = ACTIONS(3429),
    [anon_sym_on] = ACTIONS(3429),
    [anon_sym_equals] = ACTIONS(3429),
    [anon_sym_let] = ACTIONS(3429),
    [anon_sym_orderby] = ACTIONS(3429),
    [anon_sym_ascending] = ACTIONS(3429),
    [anon_sym_descending] = ACTIONS(3429),
    [anon_sym_group] = ACTIONS(3429),
    [anon_sym_by] = ACTIONS(3429),
    [anon_sym_select] = ACTIONS(3429),
    [aux_sym_preproc_if_token1] = ACTIONS(3431),
    [aux_sym_preproc_if_token3] = ACTIONS(3431),
    [aux_sym_preproc_else_token1] = ACTIONS(3431),
    [aux_sym_preproc_elif_token1] = ACTIONS(3431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3263] = {
    [sym_preproc_region] = STATE(3263),
    [sym_preproc_endregion] = STATE(3263),
    [sym_preproc_line] = STATE(3263),
    [sym_preproc_pragma] = STATE(3263),
    [sym_preproc_nullable] = STATE(3263),
    [sym_preproc_error] = STATE(3263),
    [sym_preproc_define] = STATE(3263),
    [sym_preproc_undef] = STATE(3263),
    [sym__identifier_token] = ACTIONS(3425),
    [anon_sym_extern] = ACTIONS(3425),
    [anon_sym_alias] = ACTIONS(3425),
    [anon_sym_global] = ACTIONS(3425),
    [anon_sym_using] = ACTIONS(3425),
    [anon_sym_unsafe] = ACTIONS(3425),
    [anon_sym_static] = ACTIONS(3425),
    [anon_sym_LBRACK] = ACTIONS(3427),
    [anon_sym_LPAREN] = ACTIONS(3427),
    [anon_sym_event] = ACTIONS(3425),
    [anon_sym_namespace] = ACTIONS(3425),
    [anon_sym_class] = ACTIONS(3425),
    [anon_sym_ref] = ACTIONS(3425),
    [anon_sym_struct] = ACTIONS(3425),
    [anon_sym_enum] = ACTIONS(3425),
    [anon_sym_RBRACE] = ACTIONS(3427),
    [anon_sym_interface] = ACTIONS(3425),
    [anon_sym_delegate] = ACTIONS(3425),
    [anon_sym_record] = ACTIONS(3425),
    [anon_sym_abstract] = ACTIONS(3425),
    [anon_sym_async] = ACTIONS(3425),
    [anon_sym_const] = ACTIONS(3425),
    [anon_sym_file] = ACTIONS(3425),
    [anon_sym_fixed] = ACTIONS(3425),
    [anon_sym_internal] = ACTIONS(3425),
    [anon_sym_new] = ACTIONS(3425),
    [anon_sym_override] = ACTIONS(3425),
    [anon_sym_partial] = ACTIONS(3425),
    [anon_sym_private] = ACTIONS(3425),
    [anon_sym_protected] = ACTIONS(3425),
    [anon_sym_public] = ACTIONS(3425),
    [anon_sym_readonly] = ACTIONS(3425),
    [anon_sym_required] = ACTIONS(3425),
    [anon_sym_sealed] = ACTIONS(3425),
    [anon_sym_virtual] = ACTIONS(3425),
    [anon_sym_volatile] = ACTIONS(3425),
    [anon_sym_where] = ACTIONS(3425),
    [anon_sym_notnull] = ACTIONS(3425),
    [anon_sym_unmanaged] = ACTIONS(3425),
    [anon_sym_TILDE] = ACTIONS(3427),
    [anon_sym_implicit] = ACTIONS(3425),
    [anon_sym_explicit] = ACTIONS(3425),
    [anon_sym_scoped] = ACTIONS(3425),
    [anon_sym_var] = ACTIONS(3425),
    [sym_predefined_type] = ACTIONS(3425),
    [anon_sym_yield] = ACTIONS(3425),
    [anon_sym_when] = ACTIONS(3425),
    [anon_sym_from] = ACTIONS(3425),
    [anon_sym_into] = ACTIONS(3425),
    [anon_sym_join] = ACTIONS(3425),
    [anon_sym_on] = ACTIONS(3425),
    [anon_sym_equals] = ACTIONS(3425),
    [anon_sym_let] = ACTIONS(3425),
    [anon_sym_orderby] = ACTIONS(3425),
    [anon_sym_ascending] = ACTIONS(3425),
    [anon_sym_descending] = ACTIONS(3425),
    [anon_sym_group] = ACTIONS(3425),
    [anon_sym_by] = ACTIONS(3425),
    [anon_sym_select] = ACTIONS(3425),
    [aux_sym_preproc_if_token1] = ACTIONS(3427),
    [aux_sym_preproc_if_token3] = ACTIONS(3427),
    [aux_sym_preproc_else_token1] = ACTIONS(3427),
    [aux_sym_preproc_elif_token1] = ACTIONS(3427),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3264] = {
    [sym_preproc_region] = STATE(3264),
    [sym_preproc_endregion] = STATE(3264),
    [sym_preproc_line] = STATE(3264),
    [sym_preproc_pragma] = STATE(3264),
    [sym_preproc_nullable] = STATE(3264),
    [sym_preproc_error] = STATE(3264),
    [sym_preproc_define] = STATE(3264),
    [sym_preproc_undef] = STATE(3264),
    [sym__identifier_token] = ACTIONS(3856),
    [anon_sym_extern] = ACTIONS(3856),
    [anon_sym_alias] = ACTIONS(3856),
    [anon_sym_global] = ACTIONS(3856),
    [anon_sym_using] = ACTIONS(3856),
    [anon_sym_unsafe] = ACTIONS(3856),
    [anon_sym_static] = ACTIONS(3856),
    [anon_sym_LBRACK] = ACTIONS(3858),
    [anon_sym_LPAREN] = ACTIONS(3858),
    [anon_sym_event] = ACTIONS(3856),
    [anon_sym_namespace] = ACTIONS(3856),
    [anon_sym_class] = ACTIONS(3856),
    [anon_sym_ref] = ACTIONS(3856),
    [anon_sym_struct] = ACTIONS(3856),
    [anon_sym_enum] = ACTIONS(3856),
    [anon_sym_RBRACE] = ACTIONS(3858),
    [anon_sym_interface] = ACTIONS(3856),
    [anon_sym_delegate] = ACTIONS(3856),
    [anon_sym_record] = ACTIONS(3856),
    [anon_sym_abstract] = ACTIONS(3856),
    [anon_sym_async] = ACTIONS(3856),
    [anon_sym_const] = ACTIONS(3856),
    [anon_sym_file] = ACTIONS(3856),
    [anon_sym_fixed] = ACTIONS(3856),
    [anon_sym_internal] = ACTIONS(3856),
    [anon_sym_new] = ACTIONS(3856),
    [anon_sym_override] = ACTIONS(3856),
    [anon_sym_partial] = ACTIONS(3856),
    [anon_sym_private] = ACTIONS(3856),
    [anon_sym_protected] = ACTIONS(3856),
    [anon_sym_public] = ACTIONS(3856),
    [anon_sym_readonly] = ACTIONS(3856),
    [anon_sym_required] = ACTIONS(3856),
    [anon_sym_sealed] = ACTIONS(3856),
    [anon_sym_virtual] = ACTIONS(3856),
    [anon_sym_volatile] = ACTIONS(3856),
    [anon_sym_where] = ACTIONS(3856),
    [anon_sym_notnull] = ACTIONS(3856),
    [anon_sym_unmanaged] = ACTIONS(3856),
    [anon_sym_TILDE] = ACTIONS(3858),
    [anon_sym_implicit] = ACTIONS(3856),
    [anon_sym_explicit] = ACTIONS(3856),
    [anon_sym_scoped] = ACTIONS(3856),
    [anon_sym_var] = ACTIONS(3856),
    [sym_predefined_type] = ACTIONS(3856),
    [anon_sym_yield] = ACTIONS(3856),
    [anon_sym_when] = ACTIONS(3856),
    [anon_sym_from] = ACTIONS(3856),
    [anon_sym_into] = ACTIONS(3856),
    [anon_sym_join] = ACTIONS(3856),
    [anon_sym_on] = ACTIONS(3856),
    [anon_sym_equals] = ACTIONS(3856),
    [anon_sym_let] = ACTIONS(3856),
    [anon_sym_orderby] = ACTIONS(3856),
    [anon_sym_ascending] = ACTIONS(3856),
    [anon_sym_descending] = ACTIONS(3856),
    [anon_sym_group] = ACTIONS(3856),
    [anon_sym_by] = ACTIONS(3856),
    [anon_sym_select] = ACTIONS(3856),
    [aux_sym_preproc_if_token1] = ACTIONS(3858),
    [aux_sym_preproc_if_token3] = ACTIONS(3858),
    [aux_sym_preproc_else_token1] = ACTIONS(3858),
    [aux_sym_preproc_elif_token1] = ACTIONS(3858),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3265] = {
    [sym_preproc_region] = STATE(3265),
    [sym_preproc_endregion] = STATE(3265),
    [sym_preproc_line] = STATE(3265),
    [sym_preproc_pragma] = STATE(3265),
    [sym_preproc_nullable] = STATE(3265),
    [sym_preproc_error] = STATE(3265),
    [sym_preproc_define] = STATE(3265),
    [sym_preproc_undef] = STATE(3265),
    [sym__identifier_token] = ACTIONS(4836),
    [anon_sym_extern] = ACTIONS(4836),
    [anon_sym_alias] = ACTIONS(4836),
    [anon_sym_global] = ACTIONS(4836),
    [anon_sym_using] = ACTIONS(4836),
    [anon_sym_unsafe] = ACTIONS(4836),
    [anon_sym_static] = ACTIONS(4836),
    [anon_sym_LBRACK] = ACTIONS(4838),
    [anon_sym_LPAREN] = ACTIONS(4838),
    [anon_sym_event] = ACTIONS(4836),
    [anon_sym_namespace] = ACTIONS(4836),
    [anon_sym_class] = ACTIONS(4836),
    [anon_sym_ref] = ACTIONS(4836),
    [anon_sym_struct] = ACTIONS(4836),
    [anon_sym_enum] = ACTIONS(4836),
    [anon_sym_RBRACE] = ACTIONS(4838),
    [anon_sym_interface] = ACTIONS(4836),
    [anon_sym_delegate] = ACTIONS(4836),
    [anon_sym_record] = ACTIONS(4836),
    [anon_sym_abstract] = ACTIONS(4836),
    [anon_sym_async] = ACTIONS(4836),
    [anon_sym_const] = ACTIONS(4836),
    [anon_sym_file] = ACTIONS(4836),
    [anon_sym_fixed] = ACTIONS(4836),
    [anon_sym_internal] = ACTIONS(4836),
    [anon_sym_new] = ACTIONS(4836),
    [anon_sym_override] = ACTIONS(4836),
    [anon_sym_partial] = ACTIONS(4836),
    [anon_sym_private] = ACTIONS(4836),
    [anon_sym_protected] = ACTIONS(4836),
    [anon_sym_public] = ACTIONS(4836),
    [anon_sym_readonly] = ACTIONS(4836),
    [anon_sym_required] = ACTIONS(4836),
    [anon_sym_sealed] = ACTIONS(4836),
    [anon_sym_virtual] = ACTIONS(4836),
    [anon_sym_volatile] = ACTIONS(4836),
    [anon_sym_where] = ACTIONS(4836),
    [anon_sym_notnull] = ACTIONS(4836),
    [anon_sym_unmanaged] = ACTIONS(4836),
    [anon_sym_TILDE] = ACTIONS(4838),
    [anon_sym_implicit] = ACTIONS(4836),
    [anon_sym_explicit] = ACTIONS(4836),
    [anon_sym_scoped] = ACTIONS(4836),
    [anon_sym_var] = ACTIONS(4836),
    [sym_predefined_type] = ACTIONS(4836),
    [anon_sym_yield] = ACTIONS(4836),
    [anon_sym_when] = ACTIONS(4836),
    [anon_sym_from] = ACTIONS(4836),
    [anon_sym_into] = ACTIONS(4836),
    [anon_sym_join] = ACTIONS(4836),
    [anon_sym_on] = ACTIONS(4836),
    [anon_sym_equals] = ACTIONS(4836),
    [anon_sym_let] = ACTIONS(4836),
    [anon_sym_orderby] = ACTIONS(4836),
    [anon_sym_ascending] = ACTIONS(4836),
    [anon_sym_descending] = ACTIONS(4836),
    [anon_sym_group] = ACTIONS(4836),
    [anon_sym_by] = ACTIONS(4836),
    [anon_sym_select] = ACTIONS(4836),
    [aux_sym_preproc_if_token1] = ACTIONS(4838),
    [aux_sym_preproc_if_token3] = ACTIONS(4838),
    [aux_sym_preproc_else_token1] = ACTIONS(4838),
    [aux_sym_preproc_elif_token1] = ACTIONS(4838),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3266] = {
    [sym_preproc_region] = STATE(3266),
    [sym_preproc_endregion] = STATE(3266),
    [sym_preproc_line] = STATE(3266),
    [sym_preproc_pragma] = STATE(3266),
    [sym_preproc_nullable] = STATE(3266),
    [sym_preproc_error] = STATE(3266),
    [sym_preproc_define] = STATE(3266),
    [sym_preproc_undef] = STATE(3266),
    [sym__identifier_token] = ACTIONS(4840),
    [anon_sym_extern] = ACTIONS(4840),
    [anon_sym_alias] = ACTIONS(4840),
    [anon_sym_global] = ACTIONS(4840),
    [anon_sym_using] = ACTIONS(4840),
    [anon_sym_unsafe] = ACTIONS(4840),
    [anon_sym_static] = ACTIONS(4840),
    [anon_sym_LBRACK] = ACTIONS(4842),
    [anon_sym_LPAREN] = ACTIONS(4842),
    [anon_sym_event] = ACTIONS(4840),
    [anon_sym_namespace] = ACTIONS(4840),
    [anon_sym_class] = ACTIONS(4840),
    [anon_sym_ref] = ACTIONS(4840),
    [anon_sym_struct] = ACTIONS(4840),
    [anon_sym_enum] = ACTIONS(4840),
    [anon_sym_RBRACE] = ACTIONS(4842),
    [anon_sym_interface] = ACTIONS(4840),
    [anon_sym_delegate] = ACTIONS(4840),
    [anon_sym_record] = ACTIONS(4840),
    [anon_sym_abstract] = ACTIONS(4840),
    [anon_sym_async] = ACTIONS(4840),
    [anon_sym_const] = ACTIONS(4840),
    [anon_sym_file] = ACTIONS(4840),
    [anon_sym_fixed] = ACTIONS(4840),
    [anon_sym_internal] = ACTIONS(4840),
    [anon_sym_new] = ACTIONS(4840),
    [anon_sym_override] = ACTIONS(4840),
    [anon_sym_partial] = ACTIONS(4840),
    [anon_sym_private] = ACTIONS(4840),
    [anon_sym_protected] = ACTIONS(4840),
    [anon_sym_public] = ACTIONS(4840),
    [anon_sym_readonly] = ACTIONS(4840),
    [anon_sym_required] = ACTIONS(4840),
    [anon_sym_sealed] = ACTIONS(4840),
    [anon_sym_virtual] = ACTIONS(4840),
    [anon_sym_volatile] = ACTIONS(4840),
    [anon_sym_where] = ACTIONS(4840),
    [anon_sym_notnull] = ACTIONS(4840),
    [anon_sym_unmanaged] = ACTIONS(4840),
    [anon_sym_TILDE] = ACTIONS(4842),
    [anon_sym_implicit] = ACTIONS(4840),
    [anon_sym_explicit] = ACTIONS(4840),
    [anon_sym_scoped] = ACTIONS(4840),
    [anon_sym_var] = ACTIONS(4840),
    [sym_predefined_type] = ACTIONS(4840),
    [anon_sym_yield] = ACTIONS(4840),
    [anon_sym_when] = ACTIONS(4840),
    [anon_sym_from] = ACTIONS(4840),
    [anon_sym_into] = ACTIONS(4840),
    [anon_sym_join] = ACTIONS(4840),
    [anon_sym_on] = ACTIONS(4840),
    [anon_sym_equals] = ACTIONS(4840),
    [anon_sym_let] = ACTIONS(4840),
    [anon_sym_orderby] = ACTIONS(4840),
    [anon_sym_ascending] = ACTIONS(4840),
    [anon_sym_descending] = ACTIONS(4840),
    [anon_sym_group] = ACTIONS(4840),
    [anon_sym_by] = ACTIONS(4840),
    [anon_sym_select] = ACTIONS(4840),
    [aux_sym_preproc_if_token1] = ACTIONS(4842),
    [aux_sym_preproc_if_token3] = ACTIONS(4842),
    [aux_sym_preproc_else_token1] = ACTIONS(4842),
    [aux_sym_preproc_elif_token1] = ACTIONS(4842),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3267] = {
    [sym_preproc_region] = STATE(3267),
    [sym_preproc_endregion] = STATE(3267),
    [sym_preproc_line] = STATE(3267),
    [sym_preproc_pragma] = STATE(3267),
    [sym_preproc_nullable] = STATE(3267),
    [sym_preproc_error] = STATE(3267),
    [sym_preproc_define] = STATE(3267),
    [sym_preproc_undef] = STATE(3267),
    [sym__identifier_token] = ACTIONS(4844),
    [anon_sym_extern] = ACTIONS(4844),
    [anon_sym_alias] = ACTIONS(4844),
    [anon_sym_global] = ACTIONS(4844),
    [anon_sym_using] = ACTIONS(4844),
    [anon_sym_unsafe] = ACTIONS(4844),
    [anon_sym_static] = ACTIONS(4844),
    [anon_sym_LBRACK] = ACTIONS(4846),
    [anon_sym_LPAREN] = ACTIONS(4846),
    [anon_sym_event] = ACTIONS(4844),
    [anon_sym_namespace] = ACTIONS(4844),
    [anon_sym_class] = ACTIONS(4844),
    [anon_sym_ref] = ACTIONS(4844),
    [anon_sym_struct] = ACTIONS(4844),
    [anon_sym_enum] = ACTIONS(4844),
    [anon_sym_RBRACE] = ACTIONS(4846),
    [anon_sym_interface] = ACTIONS(4844),
    [anon_sym_delegate] = ACTIONS(4844),
    [anon_sym_record] = ACTIONS(4844),
    [anon_sym_abstract] = ACTIONS(4844),
    [anon_sym_async] = ACTIONS(4844),
    [anon_sym_const] = ACTIONS(4844),
    [anon_sym_file] = ACTIONS(4844),
    [anon_sym_fixed] = ACTIONS(4844),
    [anon_sym_internal] = ACTIONS(4844),
    [anon_sym_new] = ACTIONS(4844),
    [anon_sym_override] = ACTIONS(4844),
    [anon_sym_partial] = ACTIONS(4844),
    [anon_sym_private] = ACTIONS(4844),
    [anon_sym_protected] = ACTIONS(4844),
    [anon_sym_public] = ACTIONS(4844),
    [anon_sym_readonly] = ACTIONS(4844),
    [anon_sym_required] = ACTIONS(4844),
    [anon_sym_sealed] = ACTIONS(4844),
    [anon_sym_virtual] = ACTIONS(4844),
    [anon_sym_volatile] = ACTIONS(4844),
    [anon_sym_where] = ACTIONS(4844),
    [anon_sym_notnull] = ACTIONS(4844),
    [anon_sym_unmanaged] = ACTIONS(4844),
    [anon_sym_TILDE] = ACTIONS(4846),
    [anon_sym_implicit] = ACTIONS(4844),
    [anon_sym_explicit] = ACTIONS(4844),
    [anon_sym_scoped] = ACTIONS(4844),
    [anon_sym_var] = ACTIONS(4844),
    [sym_predefined_type] = ACTIONS(4844),
    [anon_sym_yield] = ACTIONS(4844),
    [anon_sym_when] = ACTIONS(4844),
    [anon_sym_from] = ACTIONS(4844),
    [anon_sym_into] = ACTIONS(4844),
    [anon_sym_join] = ACTIONS(4844),
    [anon_sym_on] = ACTIONS(4844),
    [anon_sym_equals] = ACTIONS(4844),
    [anon_sym_let] = ACTIONS(4844),
    [anon_sym_orderby] = ACTIONS(4844),
    [anon_sym_ascending] = ACTIONS(4844),
    [anon_sym_descending] = ACTIONS(4844),
    [anon_sym_group] = ACTIONS(4844),
    [anon_sym_by] = ACTIONS(4844),
    [anon_sym_select] = ACTIONS(4844),
    [aux_sym_preproc_if_token1] = ACTIONS(4846),
    [aux_sym_preproc_if_token3] = ACTIONS(4846),
    [aux_sym_preproc_else_token1] = ACTIONS(4846),
    [aux_sym_preproc_elif_token1] = ACTIONS(4846),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3268] = {
    [sym__variable_designation] = STATE(5005),
    [sym_parenthesized_variable_designation] = STATE(4957),
    [sym_identifier] = STATE(4971),
    [sym__reserved_identifier] = STATE(3568),
    [sym_preproc_region] = STATE(3268),
    [sym_preproc_endregion] = STATE(3268),
    [sym_preproc_line] = STATE(3268),
    [sym_preproc_pragma] = STATE(3268),
    [sym_preproc_nullable] = STATE(3268),
    [sym_preproc_error] = STATE(3268),
    [sym_preproc_define] = STATE(3268),
    [sym_preproc_undef] = STATE(3268),
    [sym__identifier_token] = ACTIONS(4287),
    [anon_sym_alias] = ACTIONS(4289),
    [anon_sym_global] = ACTIONS(4289),
    [anon_sym_LBRACK] = ACTIONS(4335),
    [anon_sym_LPAREN] = ACTIONS(4335),
    [anon_sym_file] = ACTIONS(4289),
    [anon_sym_LT] = ACTIONS(4337),
    [anon_sym_GT] = ACTIONS(4337),
    [anon_sym_where] = ACTIONS(4337),
    [anon_sym_QMARK] = ACTIONS(4337),
    [anon_sym_notnull] = ACTIONS(4289),
    [anon_sym_unmanaged] = ACTIONS(4289),
    [anon_sym_BANG] = ACTIONS(4337),
    [anon_sym_PLUS_PLUS] = ACTIONS(4335),
    [anon_sym_DASH_DASH] = ACTIONS(4335),
    [anon_sym_PLUS] = ACTIONS(4337),
    [anon_sym_DASH] = ACTIONS(4337),
    [anon_sym_STAR] = ACTIONS(4335),
    [anon_sym_SLASH] = ACTIONS(4337),
    [anon_sym_PERCENT] = ACTIONS(4335),
    [anon_sym_CARET] = ACTIONS(4335),
    [anon_sym_PIPE] = ACTIONS(4337),
    [anon_sym_AMP] = ACTIONS(4337),
    [anon_sym_LT_LT] = ACTIONS(4335),
    [anon_sym_GT_GT] = ACTIONS(4337),
    [anon_sym_GT_GT_GT] = ACTIONS(4335),
    [anon_sym_EQ_EQ] = ACTIONS(4335),
    [anon_sym_BANG_EQ] = ACTIONS(4335),
    [anon_sym_GT_EQ] = ACTIONS(4335),
    [anon_sym_LT_EQ] = ACTIONS(4335),
    [anon_sym_DOT] = ACTIONS(4337),
    [anon_sym_scoped] = ACTIONS(4289),
    [anon_sym_var] = ACTIONS(4289),
    [anon_sym_yield] = ACTIONS(4289),
    [anon_sym_switch] = ACTIONS(4337),
    [anon_sym_when] = ACTIONS(4289),
    [sym_discard] = ACTIONS(4649),
    [anon_sym_DOT_DOT] = ACTIONS(4335),
    [anon_sym_and] = ACTIONS(4337),
    [anon_sym_or] = ACTIONS(4337),
    [anon_sym_AMP_AMP] = ACTIONS(4335),
    [anon_sym_PIPE_PIPE] = ACTIONS(4335),
    [anon_sym_QMARK_QMARK] = ACTIONS(4335),
    [anon_sym_from] = ACTIONS(4337),
    [anon_sym_into] = ACTIONS(4289),
    [anon_sym_join] = ACTIONS(4337),
    [anon_sym_on] = ACTIONS(4289),
    [anon_sym_equals] = ACTIONS(4289),
    [anon_sym_let] = ACTIONS(4337),
    [anon_sym_orderby] = ACTIONS(4337),
    [anon_sym_ascending] = ACTIONS(4289),
    [anon_sym_descending] = ACTIONS(4289),
    [anon_sym_group] = ACTIONS(4337),
    [anon_sym_by] = ACTIONS(4289),
    [anon_sym_select] = ACTIONS(4337),
    [anon_sym_as] = ACTIONS(4337),
    [anon_sym_is] = ACTIONS(4337),
    [anon_sym_DASH_GT] = ACTIONS(4335),
    [anon_sym_with] = ACTIONS(4337),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3269] = {
    [sym_preproc_region] = STATE(3269),
    [sym_preproc_endregion] = STATE(3269),
    [sym_preproc_line] = STATE(3269),
    [sym_preproc_pragma] = STATE(3269),
    [sym_preproc_nullable] = STATE(3269),
    [sym_preproc_error] = STATE(3269),
    [sym_preproc_define] = STATE(3269),
    [sym_preproc_undef] = STATE(3269),
    [sym__identifier_token] = ACTIONS(4848),
    [anon_sym_extern] = ACTIONS(4848),
    [anon_sym_alias] = ACTIONS(4848),
    [anon_sym_global] = ACTIONS(4848),
    [anon_sym_using] = ACTIONS(4848),
    [anon_sym_unsafe] = ACTIONS(4848),
    [anon_sym_static] = ACTIONS(4848),
    [anon_sym_LBRACK] = ACTIONS(4850),
    [anon_sym_LPAREN] = ACTIONS(4850),
    [anon_sym_event] = ACTIONS(4848),
    [anon_sym_namespace] = ACTIONS(4848),
    [anon_sym_class] = ACTIONS(4848),
    [anon_sym_ref] = ACTIONS(4848),
    [anon_sym_struct] = ACTIONS(4848),
    [anon_sym_enum] = ACTIONS(4848),
    [anon_sym_RBRACE] = ACTIONS(4850),
    [anon_sym_interface] = ACTIONS(4848),
    [anon_sym_delegate] = ACTIONS(4848),
    [anon_sym_record] = ACTIONS(4848),
    [anon_sym_abstract] = ACTIONS(4848),
    [anon_sym_async] = ACTIONS(4848),
    [anon_sym_const] = ACTIONS(4848),
    [anon_sym_file] = ACTIONS(4848),
    [anon_sym_fixed] = ACTIONS(4848),
    [anon_sym_internal] = ACTIONS(4848),
    [anon_sym_new] = ACTIONS(4848),
    [anon_sym_override] = ACTIONS(4848),
    [anon_sym_partial] = ACTIONS(4848),
    [anon_sym_private] = ACTIONS(4848),
    [anon_sym_protected] = ACTIONS(4848),
    [anon_sym_public] = ACTIONS(4848),
    [anon_sym_readonly] = ACTIONS(4848),
    [anon_sym_required] = ACTIONS(4848),
    [anon_sym_sealed] = ACTIONS(4848),
    [anon_sym_virtual] = ACTIONS(4848),
    [anon_sym_volatile] = ACTIONS(4848),
    [anon_sym_where] = ACTIONS(4848),
    [anon_sym_notnull] = ACTIONS(4848),
    [anon_sym_unmanaged] = ACTIONS(4848),
    [anon_sym_TILDE] = ACTIONS(4850),
    [anon_sym_implicit] = ACTIONS(4848),
    [anon_sym_explicit] = ACTIONS(4848),
    [anon_sym_scoped] = ACTIONS(4848),
    [anon_sym_var] = ACTIONS(4848),
    [sym_predefined_type] = ACTIONS(4848),
    [anon_sym_yield] = ACTIONS(4848),
    [anon_sym_when] = ACTIONS(4848),
    [anon_sym_from] = ACTIONS(4848),
    [anon_sym_into] = ACTIONS(4848),
    [anon_sym_join] = ACTIONS(4848),
    [anon_sym_on] = ACTIONS(4848),
    [anon_sym_equals] = ACTIONS(4848),
    [anon_sym_let] = ACTIONS(4848),
    [anon_sym_orderby] = ACTIONS(4848),
    [anon_sym_ascending] = ACTIONS(4848),
    [anon_sym_descending] = ACTIONS(4848),
    [anon_sym_group] = ACTIONS(4848),
    [anon_sym_by] = ACTIONS(4848),
    [anon_sym_select] = ACTIONS(4848),
    [aux_sym_preproc_if_token1] = ACTIONS(4850),
    [aux_sym_preproc_if_token3] = ACTIONS(4850),
    [aux_sym_preproc_else_token1] = ACTIONS(4850),
    [aux_sym_preproc_elif_token1] = ACTIONS(4850),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3270] = {
    [sym_preproc_region] = STATE(3270),
    [sym_preproc_endregion] = STATE(3270),
    [sym_preproc_line] = STATE(3270),
    [sym_preproc_pragma] = STATE(3270),
    [sym_preproc_nullable] = STATE(3270),
    [sym_preproc_error] = STATE(3270),
    [sym_preproc_define] = STATE(3270),
    [sym_preproc_undef] = STATE(3270),
    [sym__identifier_token] = ACTIONS(3581),
    [anon_sym_extern] = ACTIONS(3581),
    [anon_sym_alias] = ACTIONS(3581),
    [anon_sym_global] = ACTIONS(3581),
    [anon_sym_using] = ACTIONS(3581),
    [anon_sym_unsafe] = ACTIONS(3581),
    [anon_sym_static] = ACTIONS(3581),
    [anon_sym_LBRACK] = ACTIONS(3583),
    [anon_sym_LPAREN] = ACTIONS(3583),
    [anon_sym_event] = ACTIONS(3581),
    [anon_sym_namespace] = ACTIONS(3581),
    [anon_sym_class] = ACTIONS(3581),
    [anon_sym_ref] = ACTIONS(3581),
    [anon_sym_struct] = ACTIONS(3581),
    [anon_sym_enum] = ACTIONS(3581),
    [anon_sym_RBRACE] = ACTIONS(3583),
    [anon_sym_interface] = ACTIONS(3581),
    [anon_sym_delegate] = ACTIONS(3581),
    [anon_sym_record] = ACTIONS(3581),
    [anon_sym_abstract] = ACTIONS(3581),
    [anon_sym_async] = ACTIONS(3581),
    [anon_sym_const] = ACTIONS(3581),
    [anon_sym_file] = ACTIONS(3581),
    [anon_sym_fixed] = ACTIONS(3581),
    [anon_sym_internal] = ACTIONS(3581),
    [anon_sym_new] = ACTIONS(3581),
    [anon_sym_override] = ACTIONS(3581),
    [anon_sym_partial] = ACTIONS(3581),
    [anon_sym_private] = ACTIONS(3581),
    [anon_sym_protected] = ACTIONS(3581),
    [anon_sym_public] = ACTIONS(3581),
    [anon_sym_readonly] = ACTIONS(3581),
    [anon_sym_required] = ACTIONS(3581),
    [anon_sym_sealed] = ACTIONS(3581),
    [anon_sym_virtual] = ACTIONS(3581),
    [anon_sym_volatile] = ACTIONS(3581),
    [anon_sym_where] = ACTIONS(3581),
    [anon_sym_notnull] = ACTIONS(3581),
    [anon_sym_unmanaged] = ACTIONS(3581),
    [anon_sym_TILDE] = ACTIONS(3583),
    [anon_sym_implicit] = ACTIONS(3581),
    [anon_sym_explicit] = ACTIONS(3581),
    [anon_sym_scoped] = ACTIONS(3581),
    [anon_sym_var] = ACTIONS(3581),
    [sym_predefined_type] = ACTIONS(3581),
    [anon_sym_yield] = ACTIONS(3581),
    [anon_sym_when] = ACTIONS(3581),
    [anon_sym_from] = ACTIONS(3581),
    [anon_sym_into] = ACTIONS(3581),
    [anon_sym_join] = ACTIONS(3581),
    [anon_sym_on] = ACTIONS(3581),
    [anon_sym_equals] = ACTIONS(3581),
    [anon_sym_let] = ACTIONS(3581),
    [anon_sym_orderby] = ACTIONS(3581),
    [anon_sym_ascending] = ACTIONS(3581),
    [anon_sym_descending] = ACTIONS(3581),
    [anon_sym_group] = ACTIONS(3581),
    [anon_sym_by] = ACTIONS(3581),
    [anon_sym_select] = ACTIONS(3581),
    [aux_sym_preproc_if_token1] = ACTIONS(3583),
    [aux_sym_preproc_if_token3] = ACTIONS(3583),
    [aux_sym_preproc_else_token1] = ACTIONS(3583),
    [aux_sym_preproc_elif_token1] = ACTIONS(3583),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3271] = {
    [sym_preproc_region] = STATE(3271),
    [sym_preproc_endregion] = STATE(3271),
    [sym_preproc_line] = STATE(3271),
    [sym_preproc_pragma] = STATE(3271),
    [sym_preproc_nullable] = STATE(3271),
    [sym_preproc_error] = STATE(3271),
    [sym_preproc_define] = STATE(3271),
    [sym_preproc_undef] = STATE(3271),
    [sym__identifier_token] = ACTIONS(4852),
    [anon_sym_extern] = ACTIONS(4852),
    [anon_sym_alias] = ACTIONS(4852),
    [anon_sym_global] = ACTIONS(4852),
    [anon_sym_using] = ACTIONS(4852),
    [anon_sym_unsafe] = ACTIONS(4852),
    [anon_sym_static] = ACTIONS(4852),
    [anon_sym_LBRACK] = ACTIONS(4854),
    [anon_sym_LPAREN] = ACTIONS(4854),
    [anon_sym_event] = ACTIONS(4852),
    [anon_sym_namespace] = ACTIONS(4852),
    [anon_sym_class] = ACTIONS(4852),
    [anon_sym_ref] = ACTIONS(4852),
    [anon_sym_struct] = ACTIONS(4852),
    [anon_sym_enum] = ACTIONS(4852),
    [anon_sym_RBRACE] = ACTIONS(4854),
    [anon_sym_interface] = ACTIONS(4852),
    [anon_sym_delegate] = ACTIONS(4852),
    [anon_sym_record] = ACTIONS(4852),
    [anon_sym_abstract] = ACTIONS(4852),
    [anon_sym_async] = ACTIONS(4852),
    [anon_sym_const] = ACTIONS(4852),
    [anon_sym_file] = ACTIONS(4852),
    [anon_sym_fixed] = ACTIONS(4852),
    [anon_sym_internal] = ACTIONS(4852),
    [anon_sym_new] = ACTIONS(4852),
    [anon_sym_override] = ACTIONS(4852),
    [anon_sym_partial] = ACTIONS(4852),
    [anon_sym_private] = ACTIONS(4852),
    [anon_sym_protected] = ACTIONS(4852),
    [anon_sym_public] = ACTIONS(4852),
    [anon_sym_readonly] = ACTIONS(4852),
    [anon_sym_required] = ACTIONS(4852),
    [anon_sym_sealed] = ACTIONS(4852),
    [anon_sym_virtual] = ACTIONS(4852),
    [anon_sym_volatile] = ACTIONS(4852),
    [anon_sym_where] = ACTIONS(4852),
    [anon_sym_notnull] = ACTIONS(4852),
    [anon_sym_unmanaged] = ACTIONS(4852),
    [anon_sym_TILDE] = ACTIONS(4854),
    [anon_sym_implicit] = ACTIONS(4852),
    [anon_sym_explicit] = ACTIONS(4852),
    [anon_sym_scoped] = ACTIONS(4852),
    [anon_sym_var] = ACTIONS(4852),
    [sym_predefined_type] = ACTIONS(4852),
    [anon_sym_yield] = ACTIONS(4852),
    [anon_sym_when] = ACTIONS(4852),
    [anon_sym_from] = ACTIONS(4852),
    [anon_sym_into] = ACTIONS(4852),
    [anon_sym_join] = ACTIONS(4852),
    [anon_sym_on] = ACTIONS(4852),
    [anon_sym_equals] = ACTIONS(4852),
    [anon_sym_let] = ACTIONS(4852),
    [anon_sym_orderby] = ACTIONS(4852),
    [anon_sym_ascending] = ACTIONS(4852),
    [anon_sym_descending] = ACTIONS(4852),
    [anon_sym_group] = ACTIONS(4852),
    [anon_sym_by] = ACTIONS(4852),
    [anon_sym_select] = ACTIONS(4852),
    [aux_sym_preproc_if_token1] = ACTIONS(4854),
    [aux_sym_preproc_if_token3] = ACTIONS(4854),
    [aux_sym_preproc_else_token1] = ACTIONS(4854),
    [aux_sym_preproc_elif_token1] = ACTIONS(4854),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3272] = {
    [sym_preproc_region] = STATE(3272),
    [sym_preproc_endregion] = STATE(3272),
    [sym_preproc_line] = STATE(3272),
    [sym_preproc_pragma] = STATE(3272),
    [sym_preproc_nullable] = STATE(3272),
    [sym_preproc_error] = STATE(3272),
    [sym_preproc_define] = STATE(3272),
    [sym_preproc_undef] = STATE(3272),
    [sym__identifier_token] = ACTIONS(4856),
    [anon_sym_extern] = ACTIONS(4856),
    [anon_sym_alias] = ACTIONS(4856),
    [anon_sym_global] = ACTIONS(4856),
    [anon_sym_using] = ACTIONS(4856),
    [anon_sym_unsafe] = ACTIONS(4856),
    [anon_sym_static] = ACTIONS(4856),
    [anon_sym_LBRACK] = ACTIONS(4858),
    [anon_sym_LPAREN] = ACTIONS(4858),
    [anon_sym_event] = ACTIONS(4856),
    [anon_sym_namespace] = ACTIONS(4856),
    [anon_sym_class] = ACTIONS(4856),
    [anon_sym_ref] = ACTIONS(4856),
    [anon_sym_struct] = ACTIONS(4856),
    [anon_sym_enum] = ACTIONS(4856),
    [anon_sym_RBRACE] = ACTIONS(4858),
    [anon_sym_interface] = ACTIONS(4856),
    [anon_sym_delegate] = ACTIONS(4856),
    [anon_sym_record] = ACTIONS(4856),
    [anon_sym_abstract] = ACTIONS(4856),
    [anon_sym_async] = ACTIONS(4856),
    [anon_sym_const] = ACTIONS(4856),
    [anon_sym_file] = ACTIONS(4856),
    [anon_sym_fixed] = ACTIONS(4856),
    [anon_sym_internal] = ACTIONS(4856),
    [anon_sym_new] = ACTIONS(4856),
    [anon_sym_override] = ACTIONS(4856),
    [anon_sym_partial] = ACTIONS(4856),
    [anon_sym_private] = ACTIONS(4856),
    [anon_sym_protected] = ACTIONS(4856),
    [anon_sym_public] = ACTIONS(4856),
    [anon_sym_readonly] = ACTIONS(4856),
    [anon_sym_required] = ACTIONS(4856),
    [anon_sym_sealed] = ACTIONS(4856),
    [anon_sym_virtual] = ACTIONS(4856),
    [anon_sym_volatile] = ACTIONS(4856),
    [anon_sym_where] = ACTIONS(4856),
    [anon_sym_notnull] = ACTIONS(4856),
    [anon_sym_unmanaged] = ACTIONS(4856),
    [anon_sym_TILDE] = ACTIONS(4858),
    [anon_sym_implicit] = ACTIONS(4856),
    [anon_sym_explicit] = ACTIONS(4856),
    [anon_sym_scoped] = ACTIONS(4856),
    [anon_sym_var] = ACTIONS(4856),
    [sym_predefined_type] = ACTIONS(4856),
    [anon_sym_yield] = ACTIONS(4856),
    [anon_sym_when] = ACTIONS(4856),
    [anon_sym_from] = ACTIONS(4856),
    [anon_sym_into] = ACTIONS(4856),
    [anon_sym_join] = ACTIONS(4856),
    [anon_sym_on] = ACTIONS(4856),
    [anon_sym_equals] = ACTIONS(4856),
    [anon_sym_let] = ACTIONS(4856),
    [anon_sym_orderby] = ACTIONS(4856),
    [anon_sym_ascending] = ACTIONS(4856),
    [anon_sym_descending] = ACTIONS(4856),
    [anon_sym_group] = ACTIONS(4856),
    [anon_sym_by] = ACTIONS(4856),
    [anon_sym_select] = ACTIONS(4856),
    [aux_sym_preproc_if_token1] = ACTIONS(4858),
    [aux_sym_preproc_if_token3] = ACTIONS(4858),
    [aux_sym_preproc_else_token1] = ACTIONS(4858),
    [aux_sym_preproc_elif_token1] = ACTIONS(4858),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3273] = {
    [sym__variable_designation] = STATE(4979),
    [sym_parenthesized_variable_designation] = STATE(4957),
    [sym_identifier] = STATE(4971),
    [sym__reserved_identifier] = STATE(3568),
    [sym_preproc_region] = STATE(3273),
    [sym_preproc_endregion] = STATE(3273),
    [sym_preproc_line] = STATE(3273),
    [sym_preproc_pragma] = STATE(3273),
    [sym_preproc_nullable] = STATE(3273),
    [sym_preproc_error] = STATE(3273),
    [sym_preproc_define] = STATE(3273),
    [sym_preproc_undef] = STATE(3273),
    [sym__identifier_token] = ACTIONS(4287),
    [anon_sym_alias] = ACTIONS(4289),
    [anon_sym_global] = ACTIONS(4289),
    [anon_sym_LBRACK] = ACTIONS(4373),
    [anon_sym_LPAREN] = ACTIONS(4373),
    [anon_sym_file] = ACTIONS(4289),
    [anon_sym_LT] = ACTIONS(4375),
    [anon_sym_GT] = ACTIONS(4375),
    [anon_sym_where] = ACTIONS(4375),
    [anon_sym_QMARK] = ACTIONS(4375),
    [anon_sym_notnull] = ACTIONS(4289),
    [anon_sym_unmanaged] = ACTIONS(4289),
    [anon_sym_BANG] = ACTIONS(4375),
    [anon_sym_PLUS_PLUS] = ACTIONS(4373),
    [anon_sym_DASH_DASH] = ACTIONS(4373),
    [anon_sym_PLUS] = ACTIONS(4375),
    [anon_sym_DASH] = ACTIONS(4375),
    [anon_sym_STAR] = ACTIONS(4373),
    [anon_sym_SLASH] = ACTIONS(4375),
    [anon_sym_PERCENT] = ACTIONS(4373),
    [anon_sym_CARET] = ACTIONS(4373),
    [anon_sym_PIPE] = ACTIONS(4375),
    [anon_sym_AMP] = ACTIONS(4375),
    [anon_sym_LT_LT] = ACTIONS(4373),
    [anon_sym_GT_GT] = ACTIONS(4375),
    [anon_sym_GT_GT_GT] = ACTIONS(4373),
    [anon_sym_EQ_EQ] = ACTIONS(4373),
    [anon_sym_BANG_EQ] = ACTIONS(4373),
    [anon_sym_GT_EQ] = ACTIONS(4373),
    [anon_sym_LT_EQ] = ACTIONS(4373),
    [anon_sym_DOT] = ACTIONS(4375),
    [anon_sym_scoped] = ACTIONS(4289),
    [anon_sym_var] = ACTIONS(4289),
    [anon_sym_yield] = ACTIONS(4289),
    [anon_sym_switch] = ACTIONS(4375),
    [anon_sym_when] = ACTIONS(4289),
    [sym_discard] = ACTIONS(4649),
    [anon_sym_DOT_DOT] = ACTIONS(4373),
    [anon_sym_and] = ACTIONS(4375),
    [anon_sym_or] = ACTIONS(4375),
    [anon_sym_AMP_AMP] = ACTIONS(4373),
    [anon_sym_PIPE_PIPE] = ACTIONS(4373),
    [anon_sym_QMARK_QMARK] = ACTIONS(4373),
    [anon_sym_from] = ACTIONS(4375),
    [anon_sym_into] = ACTIONS(4289),
    [anon_sym_join] = ACTIONS(4375),
    [anon_sym_on] = ACTIONS(4289),
    [anon_sym_equals] = ACTIONS(4289),
    [anon_sym_let] = ACTIONS(4375),
    [anon_sym_orderby] = ACTIONS(4375),
    [anon_sym_ascending] = ACTIONS(4289),
    [anon_sym_descending] = ACTIONS(4289),
    [anon_sym_group] = ACTIONS(4375),
    [anon_sym_by] = ACTIONS(4289),
    [anon_sym_select] = ACTIONS(4375),
    [anon_sym_as] = ACTIONS(4375),
    [anon_sym_is] = ACTIONS(4375),
    [anon_sym_DASH_GT] = ACTIONS(4373),
    [anon_sym_with] = ACTIONS(4375),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3274] = {
    [sym_preproc_region] = STATE(3274),
    [sym_preproc_endregion] = STATE(3274),
    [sym_preproc_line] = STATE(3274),
    [sym_preproc_pragma] = STATE(3274),
    [sym_preproc_nullable] = STATE(3274),
    [sym_preproc_error] = STATE(3274),
    [sym_preproc_define] = STATE(3274),
    [sym_preproc_undef] = STATE(3274),
    [sym__identifier_token] = ACTIONS(4860),
    [anon_sym_extern] = ACTIONS(4860),
    [anon_sym_alias] = ACTIONS(4860),
    [anon_sym_global] = ACTIONS(4860),
    [anon_sym_using] = ACTIONS(4860),
    [anon_sym_unsafe] = ACTIONS(4860),
    [anon_sym_static] = ACTIONS(4860),
    [anon_sym_LBRACK] = ACTIONS(4862),
    [anon_sym_LPAREN] = ACTIONS(4862),
    [anon_sym_event] = ACTIONS(4860),
    [anon_sym_namespace] = ACTIONS(4860),
    [anon_sym_class] = ACTIONS(4860),
    [anon_sym_ref] = ACTIONS(4860),
    [anon_sym_struct] = ACTIONS(4860),
    [anon_sym_enum] = ACTIONS(4860),
    [anon_sym_RBRACE] = ACTIONS(4862),
    [anon_sym_interface] = ACTIONS(4860),
    [anon_sym_delegate] = ACTIONS(4860),
    [anon_sym_record] = ACTIONS(4860),
    [anon_sym_abstract] = ACTIONS(4860),
    [anon_sym_async] = ACTIONS(4860),
    [anon_sym_const] = ACTIONS(4860),
    [anon_sym_file] = ACTIONS(4860),
    [anon_sym_fixed] = ACTIONS(4860),
    [anon_sym_internal] = ACTIONS(4860),
    [anon_sym_new] = ACTIONS(4860),
    [anon_sym_override] = ACTIONS(4860),
    [anon_sym_partial] = ACTIONS(4860),
    [anon_sym_private] = ACTIONS(4860),
    [anon_sym_protected] = ACTIONS(4860),
    [anon_sym_public] = ACTIONS(4860),
    [anon_sym_readonly] = ACTIONS(4860),
    [anon_sym_required] = ACTIONS(4860),
    [anon_sym_sealed] = ACTIONS(4860),
    [anon_sym_virtual] = ACTIONS(4860),
    [anon_sym_volatile] = ACTIONS(4860),
    [anon_sym_where] = ACTIONS(4860),
    [anon_sym_notnull] = ACTIONS(4860),
    [anon_sym_unmanaged] = ACTIONS(4860),
    [anon_sym_TILDE] = ACTIONS(4862),
    [anon_sym_implicit] = ACTIONS(4860),
    [anon_sym_explicit] = ACTIONS(4860),
    [anon_sym_scoped] = ACTIONS(4860),
    [anon_sym_var] = ACTIONS(4860),
    [sym_predefined_type] = ACTIONS(4860),
    [anon_sym_yield] = ACTIONS(4860),
    [anon_sym_when] = ACTIONS(4860),
    [anon_sym_from] = ACTIONS(4860),
    [anon_sym_into] = ACTIONS(4860),
    [anon_sym_join] = ACTIONS(4860),
    [anon_sym_on] = ACTIONS(4860),
    [anon_sym_equals] = ACTIONS(4860),
    [anon_sym_let] = ACTIONS(4860),
    [anon_sym_orderby] = ACTIONS(4860),
    [anon_sym_ascending] = ACTIONS(4860),
    [anon_sym_descending] = ACTIONS(4860),
    [anon_sym_group] = ACTIONS(4860),
    [anon_sym_by] = ACTIONS(4860),
    [anon_sym_select] = ACTIONS(4860),
    [aux_sym_preproc_if_token1] = ACTIONS(4862),
    [aux_sym_preproc_if_token3] = ACTIONS(4862),
    [aux_sym_preproc_else_token1] = ACTIONS(4862),
    [aux_sym_preproc_elif_token1] = ACTIONS(4862),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3275] = {
    [sym_preproc_region] = STATE(3275),
    [sym_preproc_endregion] = STATE(3275),
    [sym_preproc_line] = STATE(3275),
    [sym_preproc_pragma] = STATE(3275),
    [sym_preproc_nullable] = STATE(3275),
    [sym_preproc_error] = STATE(3275),
    [sym_preproc_define] = STATE(3275),
    [sym_preproc_undef] = STATE(3275),
    [sym__identifier_token] = ACTIONS(4864),
    [anon_sym_extern] = ACTIONS(4864),
    [anon_sym_alias] = ACTIONS(4864),
    [anon_sym_global] = ACTIONS(4864),
    [anon_sym_using] = ACTIONS(4864),
    [anon_sym_unsafe] = ACTIONS(4864),
    [anon_sym_static] = ACTIONS(4864),
    [anon_sym_LBRACK] = ACTIONS(4866),
    [anon_sym_LPAREN] = ACTIONS(4866),
    [anon_sym_event] = ACTIONS(4864),
    [anon_sym_namespace] = ACTIONS(4864),
    [anon_sym_class] = ACTIONS(4864),
    [anon_sym_ref] = ACTIONS(4864),
    [anon_sym_struct] = ACTIONS(4864),
    [anon_sym_enum] = ACTIONS(4864),
    [anon_sym_RBRACE] = ACTIONS(4866),
    [anon_sym_interface] = ACTIONS(4864),
    [anon_sym_delegate] = ACTIONS(4864),
    [anon_sym_record] = ACTIONS(4864),
    [anon_sym_abstract] = ACTIONS(4864),
    [anon_sym_async] = ACTIONS(4864),
    [anon_sym_const] = ACTIONS(4864),
    [anon_sym_file] = ACTIONS(4864),
    [anon_sym_fixed] = ACTIONS(4864),
    [anon_sym_internal] = ACTIONS(4864),
    [anon_sym_new] = ACTIONS(4864),
    [anon_sym_override] = ACTIONS(4864),
    [anon_sym_partial] = ACTIONS(4864),
    [anon_sym_private] = ACTIONS(4864),
    [anon_sym_protected] = ACTIONS(4864),
    [anon_sym_public] = ACTIONS(4864),
    [anon_sym_readonly] = ACTIONS(4864),
    [anon_sym_required] = ACTIONS(4864),
    [anon_sym_sealed] = ACTIONS(4864),
    [anon_sym_virtual] = ACTIONS(4864),
    [anon_sym_volatile] = ACTIONS(4864),
    [anon_sym_where] = ACTIONS(4864),
    [anon_sym_notnull] = ACTIONS(4864),
    [anon_sym_unmanaged] = ACTIONS(4864),
    [anon_sym_TILDE] = ACTIONS(4866),
    [anon_sym_implicit] = ACTIONS(4864),
    [anon_sym_explicit] = ACTIONS(4864),
    [anon_sym_scoped] = ACTIONS(4864),
    [anon_sym_var] = ACTIONS(4864),
    [sym_predefined_type] = ACTIONS(4864),
    [anon_sym_yield] = ACTIONS(4864),
    [anon_sym_when] = ACTIONS(4864),
    [anon_sym_from] = ACTIONS(4864),
    [anon_sym_into] = ACTIONS(4864),
    [anon_sym_join] = ACTIONS(4864),
    [anon_sym_on] = ACTIONS(4864),
    [anon_sym_equals] = ACTIONS(4864),
    [anon_sym_let] = ACTIONS(4864),
    [anon_sym_orderby] = ACTIONS(4864),
    [anon_sym_ascending] = ACTIONS(4864),
    [anon_sym_descending] = ACTIONS(4864),
    [anon_sym_group] = ACTIONS(4864),
    [anon_sym_by] = ACTIONS(4864),
    [anon_sym_select] = ACTIONS(4864),
    [aux_sym_preproc_if_token1] = ACTIONS(4866),
    [aux_sym_preproc_if_token3] = ACTIONS(4866),
    [aux_sym_preproc_else_token1] = ACTIONS(4866),
    [aux_sym_preproc_elif_token1] = ACTIONS(4866),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3276] = {
    [sym_preproc_region] = STATE(3276),
    [sym_preproc_endregion] = STATE(3276),
    [sym_preproc_line] = STATE(3276),
    [sym_preproc_pragma] = STATE(3276),
    [sym_preproc_nullable] = STATE(3276),
    [sym_preproc_error] = STATE(3276),
    [sym_preproc_define] = STATE(3276),
    [sym_preproc_undef] = STATE(3276),
    [sym__identifier_token] = ACTIONS(3585),
    [anon_sym_extern] = ACTIONS(3585),
    [anon_sym_alias] = ACTIONS(3585),
    [anon_sym_global] = ACTIONS(3585),
    [anon_sym_using] = ACTIONS(3585),
    [anon_sym_unsafe] = ACTIONS(3585),
    [anon_sym_static] = ACTIONS(3585),
    [anon_sym_LBRACK] = ACTIONS(3587),
    [anon_sym_LPAREN] = ACTIONS(3587),
    [anon_sym_event] = ACTIONS(3585),
    [anon_sym_namespace] = ACTIONS(3585),
    [anon_sym_class] = ACTIONS(3585),
    [anon_sym_ref] = ACTIONS(3585),
    [anon_sym_struct] = ACTIONS(3585),
    [anon_sym_enum] = ACTIONS(3585),
    [anon_sym_RBRACE] = ACTIONS(3587),
    [anon_sym_interface] = ACTIONS(3585),
    [anon_sym_delegate] = ACTIONS(3585),
    [anon_sym_record] = ACTIONS(3585),
    [anon_sym_abstract] = ACTIONS(3585),
    [anon_sym_async] = ACTIONS(3585),
    [anon_sym_const] = ACTIONS(3585),
    [anon_sym_file] = ACTIONS(3585),
    [anon_sym_fixed] = ACTIONS(3585),
    [anon_sym_internal] = ACTIONS(3585),
    [anon_sym_new] = ACTIONS(3585),
    [anon_sym_override] = ACTIONS(3585),
    [anon_sym_partial] = ACTIONS(3585),
    [anon_sym_private] = ACTIONS(3585),
    [anon_sym_protected] = ACTIONS(3585),
    [anon_sym_public] = ACTIONS(3585),
    [anon_sym_readonly] = ACTIONS(3585),
    [anon_sym_required] = ACTIONS(3585),
    [anon_sym_sealed] = ACTIONS(3585),
    [anon_sym_virtual] = ACTIONS(3585),
    [anon_sym_volatile] = ACTIONS(3585),
    [anon_sym_where] = ACTIONS(3585),
    [anon_sym_notnull] = ACTIONS(3585),
    [anon_sym_unmanaged] = ACTIONS(3585),
    [anon_sym_TILDE] = ACTIONS(3587),
    [anon_sym_implicit] = ACTIONS(3585),
    [anon_sym_explicit] = ACTIONS(3585),
    [anon_sym_scoped] = ACTIONS(3585),
    [anon_sym_var] = ACTIONS(3585),
    [sym_predefined_type] = ACTIONS(3585),
    [anon_sym_yield] = ACTIONS(3585),
    [anon_sym_when] = ACTIONS(3585),
    [anon_sym_from] = ACTIONS(3585),
    [anon_sym_into] = ACTIONS(3585),
    [anon_sym_join] = ACTIONS(3585),
    [anon_sym_on] = ACTIONS(3585),
    [anon_sym_equals] = ACTIONS(3585),
    [anon_sym_let] = ACTIONS(3585),
    [anon_sym_orderby] = ACTIONS(3585),
    [anon_sym_ascending] = ACTIONS(3585),
    [anon_sym_descending] = ACTIONS(3585),
    [anon_sym_group] = ACTIONS(3585),
    [anon_sym_by] = ACTIONS(3585),
    [anon_sym_select] = ACTIONS(3585),
    [aux_sym_preproc_if_token1] = ACTIONS(3587),
    [aux_sym_preproc_if_token3] = ACTIONS(3587),
    [aux_sym_preproc_else_token1] = ACTIONS(3587),
    [aux_sym_preproc_elif_token1] = ACTIONS(3587),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3277] = {
    [sym_preproc_region] = STATE(3277),
    [sym_preproc_endregion] = STATE(3277),
    [sym_preproc_line] = STATE(3277),
    [sym_preproc_pragma] = STATE(3277),
    [sym_preproc_nullable] = STATE(3277),
    [sym_preproc_error] = STATE(3277),
    [sym_preproc_define] = STATE(3277),
    [sym_preproc_undef] = STATE(3277),
    [anon_sym_SEMI] = ACTIONS(4739),
    [anon_sym_EQ] = ACTIONS(4118),
    [anon_sym_LBRACK] = ACTIONS(4741),
    [anon_sym_COLON] = ACTIONS(4739),
    [anon_sym_COMMA] = ACTIONS(4739),
    [anon_sym_RBRACK] = ACTIONS(4739),
    [anon_sym_LPAREN] = ACTIONS(4741),
    [anon_sym_RPAREN] = ACTIONS(4739),
    [anon_sym_RBRACE] = ACTIONS(4739),
    [anon_sym_LT] = ACTIONS(4744),
    [anon_sym_GT] = ACTIONS(4744),
    [anon_sym_in] = ACTIONS(4739),
    [anon_sym_QMARK] = ACTIONS(4744),
    [anon_sym_BANG] = ACTIONS(4744),
    [anon_sym_PLUS_PLUS] = ACTIONS(4741),
    [anon_sym_DASH_DASH] = ACTIONS(4741),
    [anon_sym_PLUS] = ACTIONS(4744),
    [anon_sym_DASH] = ACTIONS(4744),
    [anon_sym_STAR] = ACTIONS(4744),
    [anon_sym_SLASH] = ACTIONS(4744),
    [anon_sym_PERCENT] = ACTIONS(4744),
    [anon_sym_CARET] = ACTIONS(4744),
    [anon_sym_PIPE] = ACTIONS(4744),
    [anon_sym_AMP] = ACTIONS(4744),
    [anon_sym_LT_LT] = ACTIONS(4744),
    [anon_sym_GT_GT] = ACTIONS(4744),
    [anon_sym_GT_GT_GT] = ACTIONS(4744),
    [anon_sym_EQ_EQ] = ACTIONS(4741),
    [anon_sym_BANG_EQ] = ACTIONS(4741),
    [anon_sym_GT_EQ] = ACTIONS(4741),
    [anon_sym_LT_EQ] = ACTIONS(4741),
    [anon_sym_DOT] = ACTIONS(4744),
    [anon_sym_EQ_GT] = ACTIONS(4739),
    [anon_sym_switch] = ACTIONS(4741),
    [anon_sym_when] = ACTIONS(4739),
    [anon_sym_DOT_DOT] = ACTIONS(4741),
    [anon_sym_and] = ACTIONS(4739),
    [anon_sym_or] = ACTIONS(4739),
    [anon_sym_PLUS_EQ] = ACTIONS(4133),
    [anon_sym_DASH_EQ] = ACTIONS(4133),
    [anon_sym_STAR_EQ] = ACTIONS(4133),
    [anon_sym_SLASH_EQ] = ACTIONS(4133),
    [anon_sym_PERCENT_EQ] = ACTIONS(4133),
    [anon_sym_AMP_EQ] = ACTIONS(4133),
    [anon_sym_CARET_EQ] = ACTIONS(4133),
    [anon_sym_PIPE_EQ] = ACTIONS(4133),
    [anon_sym_LT_LT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4133),
    [anon_sym_AMP_AMP] = ACTIONS(4741),
    [anon_sym_PIPE_PIPE] = ACTIONS(4741),
    [anon_sym_QMARK_QMARK] = ACTIONS(4744),
    [anon_sym_on] = ACTIONS(4739),
    [anon_sym_equals] = ACTIONS(4739),
    [anon_sym_by] = ACTIONS(4739),
    [anon_sym_as] = ACTIONS(4741),
    [anon_sym_is] = ACTIONS(4741),
    [anon_sym_DASH_GT] = ACTIONS(4741),
    [anon_sym_with] = ACTIONS(4741),
    [aux_sym_preproc_if_token3] = ACTIONS(4739),
    [aux_sym_preproc_else_token1] = ACTIONS(4739),
    [aux_sym_preproc_elif_token1] = ACTIONS(4739),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3278] = {
    [sym_preproc_region] = STATE(3278),
    [sym_preproc_endregion] = STATE(3278),
    [sym_preproc_line] = STATE(3278),
    [sym_preproc_pragma] = STATE(3278),
    [sym_preproc_nullable] = STATE(3278),
    [sym_preproc_error] = STATE(3278),
    [sym_preproc_define] = STATE(3278),
    [sym_preproc_undef] = STATE(3278),
    [sym__identifier_token] = ACTIONS(4868),
    [anon_sym_extern] = ACTIONS(4868),
    [anon_sym_alias] = ACTIONS(4868),
    [anon_sym_global] = ACTIONS(4868),
    [anon_sym_using] = ACTIONS(4868),
    [anon_sym_unsafe] = ACTIONS(4868),
    [anon_sym_static] = ACTIONS(4868),
    [anon_sym_LBRACK] = ACTIONS(4870),
    [anon_sym_LPAREN] = ACTIONS(4870),
    [anon_sym_event] = ACTIONS(4868),
    [anon_sym_namespace] = ACTIONS(4868),
    [anon_sym_class] = ACTIONS(4868),
    [anon_sym_ref] = ACTIONS(4868),
    [anon_sym_struct] = ACTIONS(4868),
    [anon_sym_enum] = ACTIONS(4868),
    [anon_sym_RBRACE] = ACTIONS(4870),
    [anon_sym_interface] = ACTIONS(4868),
    [anon_sym_delegate] = ACTIONS(4868),
    [anon_sym_record] = ACTIONS(4868),
    [anon_sym_abstract] = ACTIONS(4868),
    [anon_sym_async] = ACTIONS(4868),
    [anon_sym_const] = ACTIONS(4868),
    [anon_sym_file] = ACTIONS(4868),
    [anon_sym_fixed] = ACTIONS(4868),
    [anon_sym_internal] = ACTIONS(4868),
    [anon_sym_new] = ACTIONS(4868),
    [anon_sym_override] = ACTIONS(4868),
    [anon_sym_partial] = ACTIONS(4868),
    [anon_sym_private] = ACTIONS(4868),
    [anon_sym_protected] = ACTIONS(4868),
    [anon_sym_public] = ACTIONS(4868),
    [anon_sym_readonly] = ACTIONS(4868),
    [anon_sym_required] = ACTIONS(4868),
    [anon_sym_sealed] = ACTIONS(4868),
    [anon_sym_virtual] = ACTIONS(4868),
    [anon_sym_volatile] = ACTIONS(4868),
    [anon_sym_where] = ACTIONS(4868),
    [anon_sym_notnull] = ACTIONS(4868),
    [anon_sym_unmanaged] = ACTIONS(4868),
    [anon_sym_TILDE] = ACTIONS(4870),
    [anon_sym_implicit] = ACTIONS(4868),
    [anon_sym_explicit] = ACTIONS(4868),
    [anon_sym_scoped] = ACTIONS(4868),
    [anon_sym_var] = ACTIONS(4868),
    [sym_predefined_type] = ACTIONS(4868),
    [anon_sym_yield] = ACTIONS(4868),
    [anon_sym_when] = ACTIONS(4868),
    [anon_sym_from] = ACTIONS(4868),
    [anon_sym_into] = ACTIONS(4868),
    [anon_sym_join] = ACTIONS(4868),
    [anon_sym_on] = ACTIONS(4868),
    [anon_sym_equals] = ACTIONS(4868),
    [anon_sym_let] = ACTIONS(4868),
    [anon_sym_orderby] = ACTIONS(4868),
    [anon_sym_ascending] = ACTIONS(4868),
    [anon_sym_descending] = ACTIONS(4868),
    [anon_sym_group] = ACTIONS(4868),
    [anon_sym_by] = ACTIONS(4868),
    [anon_sym_select] = ACTIONS(4868),
    [aux_sym_preproc_if_token1] = ACTIONS(4870),
    [aux_sym_preproc_if_token3] = ACTIONS(4870),
    [aux_sym_preproc_else_token1] = ACTIONS(4870),
    [aux_sym_preproc_elif_token1] = ACTIONS(4870),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3279] = {
    [sym_preproc_region] = STATE(3279),
    [sym_preproc_endregion] = STATE(3279),
    [sym_preproc_line] = STATE(3279),
    [sym_preproc_pragma] = STATE(3279),
    [sym_preproc_nullable] = STATE(3279),
    [sym_preproc_error] = STATE(3279),
    [sym_preproc_define] = STATE(3279),
    [sym_preproc_undef] = STATE(3279),
    [anon_sym_SEMI] = ACTIONS(4072),
    [anon_sym_EQ] = ACTIONS(4070),
    [anon_sym_LBRACK] = ACTIONS(4072),
    [anon_sym_COLON] = ACTIONS(4072),
    [anon_sym_COMMA] = ACTIONS(4072),
    [anon_sym_RBRACK] = ACTIONS(4072),
    [anon_sym_LPAREN] = ACTIONS(4072),
    [anon_sym_RPAREN] = ACTIONS(4072),
    [anon_sym_RBRACE] = ACTIONS(4072),
    [anon_sym_LT] = ACTIONS(4070),
    [anon_sym_GT] = ACTIONS(4070),
    [anon_sym_in] = ACTIONS(4072),
    [anon_sym_QMARK] = ACTIONS(4070),
    [anon_sym_BANG] = ACTIONS(4070),
    [anon_sym_PLUS_PLUS] = ACTIONS(4072),
    [anon_sym_DASH_DASH] = ACTIONS(4072),
    [anon_sym_PLUS] = ACTIONS(4070),
    [anon_sym_DASH] = ACTIONS(4070),
    [anon_sym_STAR] = ACTIONS(4070),
    [anon_sym_SLASH] = ACTIONS(4070),
    [anon_sym_PERCENT] = ACTIONS(4070),
    [anon_sym_CARET] = ACTIONS(4070),
    [anon_sym_PIPE] = ACTIONS(4070),
    [anon_sym_AMP] = ACTIONS(4070),
    [anon_sym_LT_LT] = ACTIONS(4070),
    [anon_sym_GT_GT] = ACTIONS(4070),
    [anon_sym_GT_GT_GT] = ACTIONS(4070),
    [anon_sym_EQ_EQ] = ACTIONS(4072),
    [anon_sym_BANG_EQ] = ACTIONS(4072),
    [anon_sym_GT_EQ] = ACTIONS(4072),
    [anon_sym_LT_EQ] = ACTIONS(4072),
    [anon_sym_DOT] = ACTIONS(4070),
    [anon_sym_EQ_GT] = ACTIONS(4072),
    [anon_sym_switch] = ACTIONS(4072),
    [anon_sym_when] = ACTIONS(4072),
    [anon_sym_DOT_DOT] = ACTIONS(4072),
    [anon_sym_and] = ACTIONS(4072),
    [anon_sym_or] = ACTIONS(4072),
    [anon_sym_PLUS_EQ] = ACTIONS(4072),
    [anon_sym_DASH_EQ] = ACTIONS(4072),
    [anon_sym_STAR_EQ] = ACTIONS(4072),
    [anon_sym_SLASH_EQ] = ACTIONS(4072),
    [anon_sym_PERCENT_EQ] = ACTIONS(4072),
    [anon_sym_AMP_EQ] = ACTIONS(4072),
    [anon_sym_CARET_EQ] = ACTIONS(4072),
    [anon_sym_PIPE_EQ] = ACTIONS(4072),
    [anon_sym_LT_LT_EQ] = ACTIONS(4072),
    [anon_sym_GT_GT_EQ] = ACTIONS(4072),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4072),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4072),
    [anon_sym_AMP_AMP] = ACTIONS(4072),
    [anon_sym_PIPE_PIPE] = ACTIONS(4072),
    [anon_sym_QMARK_QMARK] = ACTIONS(4070),
    [anon_sym_on] = ACTIONS(4072),
    [anon_sym_equals] = ACTIONS(4072),
    [anon_sym_by] = ACTIONS(4072),
    [anon_sym_as] = ACTIONS(4072),
    [anon_sym_is] = ACTIONS(4072),
    [anon_sym_DASH_GT] = ACTIONS(4072),
    [anon_sym_with] = ACTIONS(4072),
    [aux_sym_preproc_if_token3] = ACTIONS(4072),
    [aux_sym_preproc_else_token1] = ACTIONS(4072),
    [aux_sym_preproc_elif_token1] = ACTIONS(4072),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3280] = {
    [sym_preproc_region] = STATE(3280),
    [sym_preproc_endregion] = STATE(3280),
    [sym_preproc_line] = STATE(3280),
    [sym_preproc_pragma] = STATE(3280),
    [sym_preproc_nullable] = STATE(3280),
    [sym_preproc_error] = STATE(3280),
    [sym_preproc_define] = STATE(3280),
    [sym_preproc_undef] = STATE(3280),
    [sym__identifier_token] = ACTIONS(4872),
    [anon_sym_extern] = ACTIONS(4872),
    [anon_sym_alias] = ACTIONS(4872),
    [anon_sym_global] = ACTIONS(4872),
    [anon_sym_using] = ACTIONS(4872),
    [anon_sym_unsafe] = ACTIONS(4872),
    [anon_sym_static] = ACTIONS(4872),
    [anon_sym_LBRACK] = ACTIONS(4874),
    [anon_sym_LPAREN] = ACTIONS(4874),
    [anon_sym_event] = ACTIONS(4872),
    [anon_sym_namespace] = ACTIONS(4872),
    [anon_sym_class] = ACTIONS(4872),
    [anon_sym_ref] = ACTIONS(4872),
    [anon_sym_struct] = ACTIONS(4872),
    [anon_sym_enum] = ACTIONS(4872),
    [anon_sym_RBRACE] = ACTIONS(4874),
    [anon_sym_interface] = ACTIONS(4872),
    [anon_sym_delegate] = ACTIONS(4872),
    [anon_sym_record] = ACTIONS(4872),
    [anon_sym_abstract] = ACTIONS(4872),
    [anon_sym_async] = ACTIONS(4872),
    [anon_sym_const] = ACTIONS(4872),
    [anon_sym_file] = ACTIONS(4872),
    [anon_sym_fixed] = ACTIONS(4872),
    [anon_sym_internal] = ACTIONS(4872),
    [anon_sym_new] = ACTIONS(4872),
    [anon_sym_override] = ACTIONS(4872),
    [anon_sym_partial] = ACTIONS(4872),
    [anon_sym_private] = ACTIONS(4872),
    [anon_sym_protected] = ACTIONS(4872),
    [anon_sym_public] = ACTIONS(4872),
    [anon_sym_readonly] = ACTIONS(4872),
    [anon_sym_required] = ACTIONS(4872),
    [anon_sym_sealed] = ACTIONS(4872),
    [anon_sym_virtual] = ACTIONS(4872),
    [anon_sym_volatile] = ACTIONS(4872),
    [anon_sym_where] = ACTIONS(4872),
    [anon_sym_notnull] = ACTIONS(4872),
    [anon_sym_unmanaged] = ACTIONS(4872),
    [anon_sym_TILDE] = ACTIONS(4874),
    [anon_sym_implicit] = ACTIONS(4872),
    [anon_sym_explicit] = ACTIONS(4872),
    [anon_sym_scoped] = ACTIONS(4872),
    [anon_sym_var] = ACTIONS(4872),
    [sym_predefined_type] = ACTIONS(4872),
    [anon_sym_yield] = ACTIONS(4872),
    [anon_sym_when] = ACTIONS(4872),
    [anon_sym_from] = ACTIONS(4872),
    [anon_sym_into] = ACTIONS(4872),
    [anon_sym_join] = ACTIONS(4872),
    [anon_sym_on] = ACTIONS(4872),
    [anon_sym_equals] = ACTIONS(4872),
    [anon_sym_let] = ACTIONS(4872),
    [anon_sym_orderby] = ACTIONS(4872),
    [anon_sym_ascending] = ACTIONS(4872),
    [anon_sym_descending] = ACTIONS(4872),
    [anon_sym_group] = ACTIONS(4872),
    [anon_sym_by] = ACTIONS(4872),
    [anon_sym_select] = ACTIONS(4872),
    [aux_sym_preproc_if_token1] = ACTIONS(4874),
    [aux_sym_preproc_if_token3] = ACTIONS(4874),
    [aux_sym_preproc_else_token1] = ACTIONS(4874),
    [aux_sym_preproc_elif_token1] = ACTIONS(4874),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3281] = {
    [sym_preproc_region] = STATE(3281),
    [sym_preproc_endregion] = STATE(3281),
    [sym_preproc_line] = STATE(3281),
    [sym_preproc_pragma] = STATE(3281),
    [sym_preproc_nullable] = STATE(3281),
    [sym_preproc_error] = STATE(3281),
    [sym_preproc_define] = STATE(3281),
    [sym_preproc_undef] = STATE(3281),
    [sym__identifier_token] = ACTIONS(4876),
    [anon_sym_extern] = ACTIONS(4876),
    [anon_sym_alias] = ACTIONS(4876),
    [anon_sym_global] = ACTIONS(4876),
    [anon_sym_using] = ACTIONS(4876),
    [anon_sym_unsafe] = ACTIONS(4876),
    [anon_sym_static] = ACTIONS(4876),
    [anon_sym_LBRACK] = ACTIONS(4878),
    [anon_sym_LPAREN] = ACTIONS(4878),
    [anon_sym_event] = ACTIONS(4876),
    [anon_sym_namespace] = ACTIONS(4876),
    [anon_sym_class] = ACTIONS(4876),
    [anon_sym_ref] = ACTIONS(4876),
    [anon_sym_struct] = ACTIONS(4876),
    [anon_sym_enum] = ACTIONS(4876),
    [anon_sym_RBRACE] = ACTIONS(4878),
    [anon_sym_interface] = ACTIONS(4876),
    [anon_sym_delegate] = ACTIONS(4876),
    [anon_sym_record] = ACTIONS(4876),
    [anon_sym_abstract] = ACTIONS(4876),
    [anon_sym_async] = ACTIONS(4876),
    [anon_sym_const] = ACTIONS(4876),
    [anon_sym_file] = ACTIONS(4876),
    [anon_sym_fixed] = ACTIONS(4876),
    [anon_sym_internal] = ACTIONS(4876),
    [anon_sym_new] = ACTIONS(4876),
    [anon_sym_override] = ACTIONS(4876),
    [anon_sym_partial] = ACTIONS(4876),
    [anon_sym_private] = ACTIONS(4876),
    [anon_sym_protected] = ACTIONS(4876),
    [anon_sym_public] = ACTIONS(4876),
    [anon_sym_readonly] = ACTIONS(4876),
    [anon_sym_required] = ACTIONS(4876),
    [anon_sym_sealed] = ACTIONS(4876),
    [anon_sym_virtual] = ACTIONS(4876),
    [anon_sym_volatile] = ACTIONS(4876),
    [anon_sym_where] = ACTIONS(4876),
    [anon_sym_notnull] = ACTIONS(4876),
    [anon_sym_unmanaged] = ACTIONS(4876),
    [anon_sym_TILDE] = ACTIONS(4878),
    [anon_sym_implicit] = ACTIONS(4876),
    [anon_sym_explicit] = ACTIONS(4876),
    [anon_sym_scoped] = ACTIONS(4876),
    [anon_sym_var] = ACTIONS(4876),
    [sym_predefined_type] = ACTIONS(4876),
    [anon_sym_yield] = ACTIONS(4876),
    [anon_sym_when] = ACTIONS(4876),
    [anon_sym_from] = ACTIONS(4876),
    [anon_sym_into] = ACTIONS(4876),
    [anon_sym_join] = ACTIONS(4876),
    [anon_sym_on] = ACTIONS(4876),
    [anon_sym_equals] = ACTIONS(4876),
    [anon_sym_let] = ACTIONS(4876),
    [anon_sym_orderby] = ACTIONS(4876),
    [anon_sym_ascending] = ACTIONS(4876),
    [anon_sym_descending] = ACTIONS(4876),
    [anon_sym_group] = ACTIONS(4876),
    [anon_sym_by] = ACTIONS(4876),
    [anon_sym_select] = ACTIONS(4876),
    [aux_sym_preproc_if_token1] = ACTIONS(4878),
    [aux_sym_preproc_if_token3] = ACTIONS(4878),
    [aux_sym_preproc_else_token1] = ACTIONS(4878),
    [aux_sym_preproc_elif_token1] = ACTIONS(4878),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3282] = {
    [sym_preproc_region] = STATE(3282),
    [sym_preproc_endregion] = STATE(3282),
    [sym_preproc_line] = STATE(3282),
    [sym_preproc_pragma] = STATE(3282),
    [sym_preproc_nullable] = STATE(3282),
    [sym_preproc_error] = STATE(3282),
    [sym_preproc_define] = STATE(3282),
    [sym_preproc_undef] = STATE(3282),
    [sym__identifier_token] = ACTIONS(4880),
    [anon_sym_extern] = ACTIONS(4880),
    [anon_sym_alias] = ACTIONS(4880),
    [anon_sym_global] = ACTIONS(4880),
    [anon_sym_using] = ACTIONS(4880),
    [anon_sym_unsafe] = ACTIONS(4880),
    [anon_sym_static] = ACTIONS(4880),
    [anon_sym_LBRACK] = ACTIONS(4882),
    [anon_sym_LPAREN] = ACTIONS(4882),
    [anon_sym_event] = ACTIONS(4880),
    [anon_sym_namespace] = ACTIONS(4880),
    [anon_sym_class] = ACTIONS(4880),
    [anon_sym_ref] = ACTIONS(4880),
    [anon_sym_struct] = ACTIONS(4880),
    [anon_sym_enum] = ACTIONS(4880),
    [anon_sym_RBRACE] = ACTIONS(4882),
    [anon_sym_interface] = ACTIONS(4880),
    [anon_sym_delegate] = ACTIONS(4880),
    [anon_sym_record] = ACTIONS(4880),
    [anon_sym_abstract] = ACTIONS(4880),
    [anon_sym_async] = ACTIONS(4880),
    [anon_sym_const] = ACTIONS(4880),
    [anon_sym_file] = ACTIONS(4880),
    [anon_sym_fixed] = ACTIONS(4880),
    [anon_sym_internal] = ACTIONS(4880),
    [anon_sym_new] = ACTIONS(4880),
    [anon_sym_override] = ACTIONS(4880),
    [anon_sym_partial] = ACTIONS(4880),
    [anon_sym_private] = ACTIONS(4880),
    [anon_sym_protected] = ACTIONS(4880),
    [anon_sym_public] = ACTIONS(4880),
    [anon_sym_readonly] = ACTIONS(4880),
    [anon_sym_required] = ACTIONS(4880),
    [anon_sym_sealed] = ACTIONS(4880),
    [anon_sym_virtual] = ACTIONS(4880),
    [anon_sym_volatile] = ACTIONS(4880),
    [anon_sym_where] = ACTIONS(4880),
    [anon_sym_notnull] = ACTIONS(4880),
    [anon_sym_unmanaged] = ACTIONS(4880),
    [anon_sym_TILDE] = ACTIONS(4882),
    [anon_sym_implicit] = ACTIONS(4880),
    [anon_sym_explicit] = ACTIONS(4880),
    [anon_sym_scoped] = ACTIONS(4880),
    [anon_sym_var] = ACTIONS(4880),
    [sym_predefined_type] = ACTIONS(4880),
    [anon_sym_yield] = ACTIONS(4880),
    [anon_sym_when] = ACTIONS(4880),
    [anon_sym_from] = ACTIONS(4880),
    [anon_sym_into] = ACTIONS(4880),
    [anon_sym_join] = ACTIONS(4880),
    [anon_sym_on] = ACTIONS(4880),
    [anon_sym_equals] = ACTIONS(4880),
    [anon_sym_let] = ACTIONS(4880),
    [anon_sym_orderby] = ACTIONS(4880),
    [anon_sym_ascending] = ACTIONS(4880),
    [anon_sym_descending] = ACTIONS(4880),
    [anon_sym_group] = ACTIONS(4880),
    [anon_sym_by] = ACTIONS(4880),
    [anon_sym_select] = ACTIONS(4880),
    [aux_sym_preproc_if_token1] = ACTIONS(4882),
    [aux_sym_preproc_if_token3] = ACTIONS(4882),
    [aux_sym_preproc_else_token1] = ACTIONS(4882),
    [aux_sym_preproc_elif_token1] = ACTIONS(4882),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3283] = {
    [sym_preproc_region] = STATE(3283),
    [sym_preproc_endregion] = STATE(3283),
    [sym_preproc_line] = STATE(3283),
    [sym_preproc_pragma] = STATE(3283),
    [sym_preproc_nullable] = STATE(3283),
    [sym_preproc_error] = STATE(3283),
    [sym_preproc_define] = STATE(3283),
    [sym_preproc_undef] = STATE(3283),
    [sym__identifier_token] = ACTIONS(3868),
    [anon_sym_extern] = ACTIONS(3868),
    [anon_sym_alias] = ACTIONS(3868),
    [anon_sym_global] = ACTIONS(3868),
    [anon_sym_using] = ACTIONS(3868),
    [anon_sym_unsafe] = ACTIONS(3868),
    [anon_sym_static] = ACTIONS(3868),
    [anon_sym_LBRACK] = ACTIONS(3870),
    [anon_sym_LPAREN] = ACTIONS(3870),
    [anon_sym_event] = ACTIONS(3868),
    [anon_sym_namespace] = ACTIONS(3868),
    [anon_sym_class] = ACTIONS(3868),
    [anon_sym_ref] = ACTIONS(3868),
    [anon_sym_struct] = ACTIONS(3868),
    [anon_sym_enum] = ACTIONS(3868),
    [anon_sym_RBRACE] = ACTIONS(3870),
    [anon_sym_interface] = ACTIONS(3868),
    [anon_sym_delegate] = ACTIONS(3868),
    [anon_sym_record] = ACTIONS(3868),
    [anon_sym_abstract] = ACTIONS(3868),
    [anon_sym_async] = ACTIONS(3868),
    [anon_sym_const] = ACTIONS(3868),
    [anon_sym_file] = ACTIONS(3868),
    [anon_sym_fixed] = ACTIONS(3868),
    [anon_sym_internal] = ACTIONS(3868),
    [anon_sym_new] = ACTIONS(3868),
    [anon_sym_override] = ACTIONS(3868),
    [anon_sym_partial] = ACTIONS(3868),
    [anon_sym_private] = ACTIONS(3868),
    [anon_sym_protected] = ACTIONS(3868),
    [anon_sym_public] = ACTIONS(3868),
    [anon_sym_readonly] = ACTIONS(3868),
    [anon_sym_required] = ACTIONS(3868),
    [anon_sym_sealed] = ACTIONS(3868),
    [anon_sym_virtual] = ACTIONS(3868),
    [anon_sym_volatile] = ACTIONS(3868),
    [anon_sym_where] = ACTIONS(3868),
    [anon_sym_notnull] = ACTIONS(3868),
    [anon_sym_unmanaged] = ACTIONS(3868),
    [anon_sym_TILDE] = ACTIONS(3870),
    [anon_sym_implicit] = ACTIONS(3868),
    [anon_sym_explicit] = ACTIONS(3868),
    [anon_sym_scoped] = ACTIONS(3868),
    [anon_sym_var] = ACTIONS(3868),
    [sym_predefined_type] = ACTIONS(3868),
    [anon_sym_yield] = ACTIONS(3868),
    [anon_sym_when] = ACTIONS(3868),
    [anon_sym_from] = ACTIONS(3868),
    [anon_sym_into] = ACTIONS(3868),
    [anon_sym_join] = ACTIONS(3868),
    [anon_sym_on] = ACTIONS(3868),
    [anon_sym_equals] = ACTIONS(3868),
    [anon_sym_let] = ACTIONS(3868),
    [anon_sym_orderby] = ACTIONS(3868),
    [anon_sym_ascending] = ACTIONS(3868),
    [anon_sym_descending] = ACTIONS(3868),
    [anon_sym_group] = ACTIONS(3868),
    [anon_sym_by] = ACTIONS(3868),
    [anon_sym_select] = ACTIONS(3868),
    [aux_sym_preproc_if_token1] = ACTIONS(3870),
    [aux_sym_preproc_if_token3] = ACTIONS(3870),
    [aux_sym_preproc_else_token1] = ACTIONS(3870),
    [aux_sym_preproc_elif_token1] = ACTIONS(3870),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3284] = {
    [sym_preproc_region] = STATE(3284),
    [sym_preproc_endregion] = STATE(3284),
    [sym_preproc_line] = STATE(3284),
    [sym_preproc_pragma] = STATE(3284),
    [sym_preproc_nullable] = STATE(3284),
    [sym_preproc_error] = STATE(3284),
    [sym_preproc_define] = STATE(3284),
    [sym_preproc_undef] = STATE(3284),
    [sym__identifier_token] = ACTIONS(4884),
    [anon_sym_extern] = ACTIONS(4884),
    [anon_sym_alias] = ACTIONS(4884),
    [anon_sym_global] = ACTIONS(4884),
    [anon_sym_using] = ACTIONS(4884),
    [anon_sym_unsafe] = ACTIONS(4884),
    [anon_sym_static] = ACTIONS(4884),
    [anon_sym_LBRACK] = ACTIONS(4886),
    [anon_sym_LPAREN] = ACTIONS(4886),
    [anon_sym_event] = ACTIONS(4884),
    [anon_sym_namespace] = ACTIONS(4884),
    [anon_sym_class] = ACTIONS(4884),
    [anon_sym_ref] = ACTIONS(4884),
    [anon_sym_struct] = ACTIONS(4884),
    [anon_sym_enum] = ACTIONS(4884),
    [anon_sym_RBRACE] = ACTIONS(4886),
    [anon_sym_interface] = ACTIONS(4884),
    [anon_sym_delegate] = ACTIONS(4884),
    [anon_sym_record] = ACTIONS(4884),
    [anon_sym_abstract] = ACTIONS(4884),
    [anon_sym_async] = ACTIONS(4884),
    [anon_sym_const] = ACTIONS(4884),
    [anon_sym_file] = ACTIONS(4884),
    [anon_sym_fixed] = ACTIONS(4884),
    [anon_sym_internal] = ACTIONS(4884),
    [anon_sym_new] = ACTIONS(4884),
    [anon_sym_override] = ACTIONS(4884),
    [anon_sym_partial] = ACTIONS(4884),
    [anon_sym_private] = ACTIONS(4884),
    [anon_sym_protected] = ACTIONS(4884),
    [anon_sym_public] = ACTIONS(4884),
    [anon_sym_readonly] = ACTIONS(4884),
    [anon_sym_required] = ACTIONS(4884),
    [anon_sym_sealed] = ACTIONS(4884),
    [anon_sym_virtual] = ACTIONS(4884),
    [anon_sym_volatile] = ACTIONS(4884),
    [anon_sym_where] = ACTIONS(4884),
    [anon_sym_notnull] = ACTIONS(4884),
    [anon_sym_unmanaged] = ACTIONS(4884),
    [anon_sym_TILDE] = ACTIONS(4886),
    [anon_sym_implicit] = ACTIONS(4884),
    [anon_sym_explicit] = ACTIONS(4884),
    [anon_sym_scoped] = ACTIONS(4884),
    [anon_sym_var] = ACTIONS(4884),
    [sym_predefined_type] = ACTIONS(4884),
    [anon_sym_yield] = ACTIONS(4884),
    [anon_sym_when] = ACTIONS(4884),
    [anon_sym_from] = ACTIONS(4884),
    [anon_sym_into] = ACTIONS(4884),
    [anon_sym_join] = ACTIONS(4884),
    [anon_sym_on] = ACTIONS(4884),
    [anon_sym_equals] = ACTIONS(4884),
    [anon_sym_let] = ACTIONS(4884),
    [anon_sym_orderby] = ACTIONS(4884),
    [anon_sym_ascending] = ACTIONS(4884),
    [anon_sym_descending] = ACTIONS(4884),
    [anon_sym_group] = ACTIONS(4884),
    [anon_sym_by] = ACTIONS(4884),
    [anon_sym_select] = ACTIONS(4884),
    [aux_sym_preproc_if_token1] = ACTIONS(4886),
    [aux_sym_preproc_if_token3] = ACTIONS(4886),
    [aux_sym_preproc_else_token1] = ACTIONS(4886),
    [aux_sym_preproc_elif_token1] = ACTIONS(4886),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3285] = {
    [sym_preproc_region] = STATE(3285),
    [sym_preproc_endregion] = STATE(3285),
    [sym_preproc_line] = STATE(3285),
    [sym_preproc_pragma] = STATE(3285),
    [sym_preproc_nullable] = STATE(3285),
    [sym_preproc_error] = STATE(3285),
    [sym_preproc_define] = STATE(3285),
    [sym_preproc_undef] = STATE(3285),
    [sym__identifier_token] = ACTIONS(3589),
    [anon_sym_extern] = ACTIONS(3589),
    [anon_sym_alias] = ACTIONS(3589),
    [anon_sym_global] = ACTIONS(3589),
    [anon_sym_using] = ACTIONS(3589),
    [anon_sym_unsafe] = ACTIONS(3589),
    [anon_sym_static] = ACTIONS(3589),
    [anon_sym_LBRACK] = ACTIONS(3591),
    [anon_sym_LPAREN] = ACTIONS(3591),
    [anon_sym_event] = ACTIONS(3589),
    [anon_sym_namespace] = ACTIONS(3589),
    [anon_sym_class] = ACTIONS(3589),
    [anon_sym_ref] = ACTIONS(3589),
    [anon_sym_struct] = ACTIONS(3589),
    [anon_sym_enum] = ACTIONS(3589),
    [anon_sym_RBRACE] = ACTIONS(3591),
    [anon_sym_interface] = ACTIONS(3589),
    [anon_sym_delegate] = ACTIONS(3589),
    [anon_sym_record] = ACTIONS(3589),
    [anon_sym_abstract] = ACTIONS(3589),
    [anon_sym_async] = ACTIONS(3589),
    [anon_sym_const] = ACTIONS(3589),
    [anon_sym_file] = ACTIONS(3589),
    [anon_sym_fixed] = ACTIONS(3589),
    [anon_sym_internal] = ACTIONS(3589),
    [anon_sym_new] = ACTIONS(3589),
    [anon_sym_override] = ACTIONS(3589),
    [anon_sym_partial] = ACTIONS(3589),
    [anon_sym_private] = ACTIONS(3589),
    [anon_sym_protected] = ACTIONS(3589),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_readonly] = ACTIONS(3589),
    [anon_sym_required] = ACTIONS(3589),
    [anon_sym_sealed] = ACTIONS(3589),
    [anon_sym_virtual] = ACTIONS(3589),
    [anon_sym_volatile] = ACTIONS(3589),
    [anon_sym_where] = ACTIONS(3589),
    [anon_sym_notnull] = ACTIONS(3589),
    [anon_sym_unmanaged] = ACTIONS(3589),
    [anon_sym_TILDE] = ACTIONS(3591),
    [anon_sym_implicit] = ACTIONS(3589),
    [anon_sym_explicit] = ACTIONS(3589),
    [anon_sym_scoped] = ACTIONS(3589),
    [anon_sym_var] = ACTIONS(3589),
    [sym_predefined_type] = ACTIONS(3589),
    [anon_sym_yield] = ACTIONS(3589),
    [anon_sym_when] = ACTIONS(3589),
    [anon_sym_from] = ACTIONS(3589),
    [anon_sym_into] = ACTIONS(3589),
    [anon_sym_join] = ACTIONS(3589),
    [anon_sym_on] = ACTIONS(3589),
    [anon_sym_equals] = ACTIONS(3589),
    [anon_sym_let] = ACTIONS(3589),
    [anon_sym_orderby] = ACTIONS(3589),
    [anon_sym_ascending] = ACTIONS(3589),
    [anon_sym_descending] = ACTIONS(3589),
    [anon_sym_group] = ACTIONS(3589),
    [anon_sym_by] = ACTIONS(3589),
    [anon_sym_select] = ACTIONS(3589),
    [aux_sym_preproc_if_token1] = ACTIONS(3591),
    [aux_sym_preproc_if_token3] = ACTIONS(3591),
    [aux_sym_preproc_else_token1] = ACTIONS(3591),
    [aux_sym_preproc_elif_token1] = ACTIONS(3591),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3286] = {
    [sym_preproc_region] = STATE(3286),
    [sym_preproc_endregion] = STATE(3286),
    [sym_preproc_line] = STATE(3286),
    [sym_preproc_pragma] = STATE(3286),
    [sym_preproc_nullable] = STATE(3286),
    [sym_preproc_error] = STATE(3286),
    [sym_preproc_define] = STATE(3286),
    [sym_preproc_undef] = STATE(3286),
    [sym__identifier_token] = ACTIONS(3872),
    [anon_sym_extern] = ACTIONS(3872),
    [anon_sym_alias] = ACTIONS(3872),
    [anon_sym_global] = ACTIONS(3872),
    [anon_sym_using] = ACTIONS(3872),
    [anon_sym_unsafe] = ACTIONS(3872),
    [anon_sym_static] = ACTIONS(3872),
    [anon_sym_LBRACK] = ACTIONS(3874),
    [anon_sym_LPAREN] = ACTIONS(3874),
    [anon_sym_event] = ACTIONS(3872),
    [anon_sym_namespace] = ACTIONS(3872),
    [anon_sym_class] = ACTIONS(3872),
    [anon_sym_ref] = ACTIONS(3872),
    [anon_sym_struct] = ACTIONS(3872),
    [anon_sym_enum] = ACTIONS(3872),
    [anon_sym_RBRACE] = ACTIONS(3874),
    [anon_sym_interface] = ACTIONS(3872),
    [anon_sym_delegate] = ACTIONS(3872),
    [anon_sym_record] = ACTIONS(3872),
    [anon_sym_abstract] = ACTIONS(3872),
    [anon_sym_async] = ACTIONS(3872),
    [anon_sym_const] = ACTIONS(3872),
    [anon_sym_file] = ACTIONS(3872),
    [anon_sym_fixed] = ACTIONS(3872),
    [anon_sym_internal] = ACTIONS(3872),
    [anon_sym_new] = ACTIONS(3872),
    [anon_sym_override] = ACTIONS(3872),
    [anon_sym_partial] = ACTIONS(3872),
    [anon_sym_private] = ACTIONS(3872),
    [anon_sym_protected] = ACTIONS(3872),
    [anon_sym_public] = ACTIONS(3872),
    [anon_sym_readonly] = ACTIONS(3872),
    [anon_sym_required] = ACTIONS(3872),
    [anon_sym_sealed] = ACTIONS(3872),
    [anon_sym_virtual] = ACTIONS(3872),
    [anon_sym_volatile] = ACTIONS(3872),
    [anon_sym_where] = ACTIONS(3872),
    [anon_sym_notnull] = ACTIONS(3872),
    [anon_sym_unmanaged] = ACTIONS(3872),
    [anon_sym_TILDE] = ACTIONS(3874),
    [anon_sym_implicit] = ACTIONS(3872),
    [anon_sym_explicit] = ACTIONS(3872),
    [anon_sym_scoped] = ACTIONS(3872),
    [anon_sym_var] = ACTIONS(3872),
    [sym_predefined_type] = ACTIONS(3872),
    [anon_sym_yield] = ACTIONS(3872),
    [anon_sym_when] = ACTIONS(3872),
    [anon_sym_from] = ACTIONS(3872),
    [anon_sym_into] = ACTIONS(3872),
    [anon_sym_join] = ACTIONS(3872),
    [anon_sym_on] = ACTIONS(3872),
    [anon_sym_equals] = ACTIONS(3872),
    [anon_sym_let] = ACTIONS(3872),
    [anon_sym_orderby] = ACTIONS(3872),
    [anon_sym_ascending] = ACTIONS(3872),
    [anon_sym_descending] = ACTIONS(3872),
    [anon_sym_group] = ACTIONS(3872),
    [anon_sym_by] = ACTIONS(3872),
    [anon_sym_select] = ACTIONS(3872),
    [aux_sym_preproc_if_token1] = ACTIONS(3874),
    [aux_sym_preproc_if_token3] = ACTIONS(3874),
    [aux_sym_preproc_else_token1] = ACTIONS(3874),
    [aux_sym_preproc_elif_token1] = ACTIONS(3874),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3287] = {
    [sym_preproc_region] = STATE(3287),
    [sym_preproc_endregion] = STATE(3287),
    [sym_preproc_line] = STATE(3287),
    [sym_preproc_pragma] = STATE(3287),
    [sym_preproc_nullable] = STATE(3287),
    [sym_preproc_error] = STATE(3287),
    [sym_preproc_define] = STATE(3287),
    [sym_preproc_undef] = STATE(3287),
    [sym__identifier_token] = ACTIONS(4888),
    [anon_sym_extern] = ACTIONS(4888),
    [anon_sym_alias] = ACTIONS(4888),
    [anon_sym_global] = ACTIONS(4888),
    [anon_sym_using] = ACTIONS(4888),
    [anon_sym_unsafe] = ACTIONS(4888),
    [anon_sym_static] = ACTIONS(4888),
    [anon_sym_LBRACK] = ACTIONS(4890),
    [anon_sym_LPAREN] = ACTIONS(4890),
    [anon_sym_event] = ACTIONS(4888),
    [anon_sym_namespace] = ACTIONS(4888),
    [anon_sym_class] = ACTIONS(4888),
    [anon_sym_ref] = ACTIONS(4888),
    [anon_sym_struct] = ACTIONS(4888),
    [anon_sym_enum] = ACTIONS(4888),
    [anon_sym_RBRACE] = ACTIONS(4890),
    [anon_sym_interface] = ACTIONS(4888),
    [anon_sym_delegate] = ACTIONS(4888),
    [anon_sym_record] = ACTIONS(4888),
    [anon_sym_abstract] = ACTIONS(4888),
    [anon_sym_async] = ACTIONS(4888),
    [anon_sym_const] = ACTIONS(4888),
    [anon_sym_file] = ACTIONS(4888),
    [anon_sym_fixed] = ACTIONS(4888),
    [anon_sym_internal] = ACTIONS(4888),
    [anon_sym_new] = ACTIONS(4888),
    [anon_sym_override] = ACTIONS(4888),
    [anon_sym_partial] = ACTIONS(4888),
    [anon_sym_private] = ACTIONS(4888),
    [anon_sym_protected] = ACTIONS(4888),
    [anon_sym_public] = ACTIONS(4888),
    [anon_sym_readonly] = ACTIONS(4888),
    [anon_sym_required] = ACTIONS(4888),
    [anon_sym_sealed] = ACTIONS(4888),
    [anon_sym_virtual] = ACTIONS(4888),
    [anon_sym_volatile] = ACTIONS(4888),
    [anon_sym_where] = ACTIONS(4888),
    [anon_sym_notnull] = ACTIONS(4888),
    [anon_sym_unmanaged] = ACTIONS(4888),
    [anon_sym_TILDE] = ACTIONS(4890),
    [anon_sym_implicit] = ACTIONS(4888),
    [anon_sym_explicit] = ACTIONS(4888),
    [anon_sym_scoped] = ACTIONS(4888),
    [anon_sym_var] = ACTIONS(4888),
    [sym_predefined_type] = ACTIONS(4888),
    [anon_sym_yield] = ACTIONS(4888),
    [anon_sym_when] = ACTIONS(4888),
    [anon_sym_from] = ACTIONS(4888),
    [anon_sym_into] = ACTIONS(4888),
    [anon_sym_join] = ACTIONS(4888),
    [anon_sym_on] = ACTIONS(4888),
    [anon_sym_equals] = ACTIONS(4888),
    [anon_sym_let] = ACTIONS(4888),
    [anon_sym_orderby] = ACTIONS(4888),
    [anon_sym_ascending] = ACTIONS(4888),
    [anon_sym_descending] = ACTIONS(4888),
    [anon_sym_group] = ACTIONS(4888),
    [anon_sym_by] = ACTIONS(4888),
    [anon_sym_select] = ACTIONS(4888),
    [aux_sym_preproc_if_token1] = ACTIONS(4890),
    [aux_sym_preproc_if_token3] = ACTIONS(4890),
    [aux_sym_preproc_else_token1] = ACTIONS(4890),
    [aux_sym_preproc_elif_token1] = ACTIONS(4890),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3288] = {
    [sym_preproc_region] = STATE(3288),
    [sym_preproc_endregion] = STATE(3288),
    [sym_preproc_line] = STATE(3288),
    [sym_preproc_pragma] = STATE(3288),
    [sym_preproc_nullable] = STATE(3288),
    [sym_preproc_error] = STATE(3288),
    [sym_preproc_define] = STATE(3288),
    [sym_preproc_undef] = STATE(3288),
    [sym__identifier_token] = ACTIONS(4892),
    [anon_sym_extern] = ACTIONS(4892),
    [anon_sym_alias] = ACTIONS(4892),
    [anon_sym_global] = ACTIONS(4892),
    [anon_sym_using] = ACTIONS(4892),
    [anon_sym_unsafe] = ACTIONS(4892),
    [anon_sym_static] = ACTIONS(4892),
    [anon_sym_LBRACK] = ACTIONS(4894),
    [anon_sym_LPAREN] = ACTIONS(4894),
    [anon_sym_event] = ACTIONS(4892),
    [anon_sym_namespace] = ACTIONS(4892),
    [anon_sym_class] = ACTIONS(4892),
    [anon_sym_ref] = ACTIONS(4892),
    [anon_sym_struct] = ACTIONS(4892),
    [anon_sym_enum] = ACTIONS(4892),
    [anon_sym_RBRACE] = ACTIONS(4894),
    [anon_sym_interface] = ACTIONS(4892),
    [anon_sym_delegate] = ACTIONS(4892),
    [anon_sym_record] = ACTIONS(4892),
    [anon_sym_abstract] = ACTIONS(4892),
    [anon_sym_async] = ACTIONS(4892),
    [anon_sym_const] = ACTIONS(4892),
    [anon_sym_file] = ACTIONS(4892),
    [anon_sym_fixed] = ACTIONS(4892),
    [anon_sym_internal] = ACTIONS(4892),
    [anon_sym_new] = ACTIONS(4892),
    [anon_sym_override] = ACTIONS(4892),
    [anon_sym_partial] = ACTIONS(4892),
    [anon_sym_private] = ACTIONS(4892),
    [anon_sym_protected] = ACTIONS(4892),
    [anon_sym_public] = ACTIONS(4892),
    [anon_sym_readonly] = ACTIONS(4892),
    [anon_sym_required] = ACTIONS(4892),
    [anon_sym_sealed] = ACTIONS(4892),
    [anon_sym_virtual] = ACTIONS(4892),
    [anon_sym_volatile] = ACTIONS(4892),
    [anon_sym_where] = ACTIONS(4892),
    [anon_sym_notnull] = ACTIONS(4892),
    [anon_sym_unmanaged] = ACTIONS(4892),
    [anon_sym_TILDE] = ACTIONS(4894),
    [anon_sym_implicit] = ACTIONS(4892),
    [anon_sym_explicit] = ACTIONS(4892),
    [anon_sym_scoped] = ACTIONS(4892),
    [anon_sym_var] = ACTIONS(4892),
    [sym_predefined_type] = ACTIONS(4892),
    [anon_sym_yield] = ACTIONS(4892),
    [anon_sym_when] = ACTIONS(4892),
    [anon_sym_from] = ACTIONS(4892),
    [anon_sym_into] = ACTIONS(4892),
    [anon_sym_join] = ACTIONS(4892),
    [anon_sym_on] = ACTIONS(4892),
    [anon_sym_equals] = ACTIONS(4892),
    [anon_sym_let] = ACTIONS(4892),
    [anon_sym_orderby] = ACTIONS(4892),
    [anon_sym_ascending] = ACTIONS(4892),
    [anon_sym_descending] = ACTIONS(4892),
    [anon_sym_group] = ACTIONS(4892),
    [anon_sym_by] = ACTIONS(4892),
    [anon_sym_select] = ACTIONS(4892),
    [aux_sym_preproc_if_token1] = ACTIONS(4894),
    [aux_sym_preproc_if_token3] = ACTIONS(4894),
    [aux_sym_preproc_else_token1] = ACTIONS(4894),
    [aux_sym_preproc_elif_token1] = ACTIONS(4894),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3289] = {
    [sym_preproc_region] = STATE(3289),
    [sym_preproc_endregion] = STATE(3289),
    [sym_preproc_line] = STATE(3289),
    [sym_preproc_pragma] = STATE(3289),
    [sym_preproc_nullable] = STATE(3289),
    [sym_preproc_error] = STATE(3289),
    [sym_preproc_define] = STATE(3289),
    [sym_preproc_undef] = STATE(3289),
    [sym__identifier_token] = ACTIONS(3597),
    [anon_sym_extern] = ACTIONS(3597),
    [anon_sym_alias] = ACTIONS(3597),
    [anon_sym_global] = ACTIONS(3597),
    [anon_sym_using] = ACTIONS(3597),
    [anon_sym_unsafe] = ACTIONS(3597),
    [anon_sym_static] = ACTIONS(3597),
    [anon_sym_LBRACK] = ACTIONS(3599),
    [anon_sym_LPAREN] = ACTIONS(3599),
    [anon_sym_event] = ACTIONS(3597),
    [anon_sym_namespace] = ACTIONS(3597),
    [anon_sym_class] = ACTIONS(3597),
    [anon_sym_ref] = ACTIONS(3597),
    [anon_sym_struct] = ACTIONS(3597),
    [anon_sym_enum] = ACTIONS(3597),
    [anon_sym_RBRACE] = ACTIONS(3599),
    [anon_sym_interface] = ACTIONS(3597),
    [anon_sym_delegate] = ACTIONS(3597),
    [anon_sym_record] = ACTIONS(3597),
    [anon_sym_abstract] = ACTIONS(3597),
    [anon_sym_async] = ACTIONS(3597),
    [anon_sym_const] = ACTIONS(3597),
    [anon_sym_file] = ACTIONS(3597),
    [anon_sym_fixed] = ACTIONS(3597),
    [anon_sym_internal] = ACTIONS(3597),
    [anon_sym_new] = ACTIONS(3597),
    [anon_sym_override] = ACTIONS(3597),
    [anon_sym_partial] = ACTIONS(3597),
    [anon_sym_private] = ACTIONS(3597),
    [anon_sym_protected] = ACTIONS(3597),
    [anon_sym_public] = ACTIONS(3597),
    [anon_sym_readonly] = ACTIONS(3597),
    [anon_sym_required] = ACTIONS(3597),
    [anon_sym_sealed] = ACTIONS(3597),
    [anon_sym_virtual] = ACTIONS(3597),
    [anon_sym_volatile] = ACTIONS(3597),
    [anon_sym_where] = ACTIONS(3597),
    [anon_sym_notnull] = ACTIONS(3597),
    [anon_sym_unmanaged] = ACTIONS(3597),
    [anon_sym_TILDE] = ACTIONS(3599),
    [anon_sym_implicit] = ACTIONS(3597),
    [anon_sym_explicit] = ACTIONS(3597),
    [anon_sym_scoped] = ACTIONS(3597),
    [anon_sym_var] = ACTIONS(3597),
    [sym_predefined_type] = ACTIONS(3597),
    [anon_sym_yield] = ACTIONS(3597),
    [anon_sym_when] = ACTIONS(3597),
    [anon_sym_from] = ACTIONS(3597),
    [anon_sym_into] = ACTIONS(3597),
    [anon_sym_join] = ACTIONS(3597),
    [anon_sym_on] = ACTIONS(3597),
    [anon_sym_equals] = ACTIONS(3597),
    [anon_sym_let] = ACTIONS(3597),
    [anon_sym_orderby] = ACTIONS(3597),
    [anon_sym_ascending] = ACTIONS(3597),
    [anon_sym_descending] = ACTIONS(3597),
    [anon_sym_group] = ACTIONS(3597),
    [anon_sym_by] = ACTIONS(3597),
    [anon_sym_select] = ACTIONS(3597),
    [aux_sym_preproc_if_token1] = ACTIONS(3599),
    [aux_sym_preproc_if_token3] = ACTIONS(3599),
    [aux_sym_preproc_else_token1] = ACTIONS(3599),
    [aux_sym_preproc_elif_token1] = ACTIONS(3599),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3290] = {
    [sym_preproc_region] = STATE(3290),
    [sym_preproc_endregion] = STATE(3290),
    [sym_preproc_line] = STATE(3290),
    [sym_preproc_pragma] = STATE(3290),
    [sym_preproc_nullable] = STATE(3290),
    [sym_preproc_error] = STATE(3290),
    [sym_preproc_define] = STATE(3290),
    [sym_preproc_undef] = STATE(3290),
    [sym__identifier_token] = ACTIONS(4406),
    [anon_sym_alias] = ACTIONS(4406),
    [anon_sym_global] = ACTIONS(4406),
    [anon_sym_LBRACK] = ACTIONS(4408),
    [anon_sym_COLON] = ACTIONS(4408),
    [anon_sym_COMMA] = ACTIONS(4408),
    [anon_sym_LPAREN] = ACTIONS(4408),
    [anon_sym_LBRACE] = ACTIONS(4408),
    [anon_sym_file] = ACTIONS(4406),
    [anon_sym_LT] = ACTIONS(4406),
    [anon_sym_GT] = ACTIONS(4406),
    [anon_sym_where] = ACTIONS(4406),
    [anon_sym_QMARK] = ACTIONS(4406),
    [anon_sym_notnull] = ACTIONS(4406),
    [anon_sym_unmanaged] = ACTIONS(4406),
    [anon_sym_BANG] = ACTIONS(4406),
    [anon_sym_PLUS_PLUS] = ACTIONS(4408),
    [anon_sym_DASH_DASH] = ACTIONS(4408),
    [anon_sym_PLUS] = ACTIONS(4406),
    [anon_sym_DASH] = ACTIONS(4406),
    [anon_sym_STAR] = ACTIONS(4408),
    [anon_sym_SLASH] = ACTIONS(4406),
    [anon_sym_PERCENT] = ACTIONS(4408),
    [anon_sym_CARET] = ACTIONS(4408),
    [anon_sym_PIPE] = ACTIONS(4406),
    [anon_sym_AMP] = ACTIONS(4406),
    [anon_sym_LT_LT] = ACTIONS(4408),
    [anon_sym_GT_GT] = ACTIONS(4406),
    [anon_sym_GT_GT_GT] = ACTIONS(4408),
    [anon_sym_EQ_EQ] = ACTIONS(4408),
    [anon_sym_BANG_EQ] = ACTIONS(4408),
    [anon_sym_GT_EQ] = ACTIONS(4408),
    [anon_sym_LT_EQ] = ACTIONS(4408),
    [anon_sym_DOT] = ACTIONS(4406),
    [anon_sym_scoped] = ACTIONS(4406),
    [anon_sym_var] = ACTIONS(4406),
    [anon_sym_yield] = ACTIONS(4406),
    [anon_sym_switch] = ACTIONS(4406),
    [anon_sym_when] = ACTIONS(4406),
    [sym_discard] = ACTIONS(4406),
    [anon_sym_DOT_DOT] = ACTIONS(4408),
    [anon_sym_and] = ACTIONS(4406),
    [anon_sym_or] = ACTIONS(4406),
    [anon_sym_AMP_AMP] = ACTIONS(4408),
    [anon_sym_PIPE_PIPE] = ACTIONS(4408),
    [anon_sym_QMARK_QMARK] = ACTIONS(4408),
    [anon_sym_from] = ACTIONS(4406),
    [anon_sym_into] = ACTIONS(4406),
    [anon_sym_join] = ACTIONS(4406),
    [anon_sym_on] = ACTIONS(4406),
    [anon_sym_equals] = ACTIONS(4406),
    [anon_sym_let] = ACTIONS(4406),
    [anon_sym_orderby] = ACTIONS(4406),
    [anon_sym_ascending] = ACTIONS(4406),
    [anon_sym_descending] = ACTIONS(4406),
    [anon_sym_group] = ACTIONS(4406),
    [anon_sym_by] = ACTIONS(4406),
    [anon_sym_select] = ACTIONS(4406),
    [anon_sym_as] = ACTIONS(4406),
    [anon_sym_is] = ACTIONS(4406),
    [anon_sym_DASH_GT] = ACTIONS(4408),
    [anon_sym_with] = ACTIONS(4406),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4408),
  },
  [3291] = {
    [sym_preproc_region] = STATE(3291),
    [sym_preproc_endregion] = STATE(3291),
    [sym_preproc_line] = STATE(3291),
    [sym_preproc_pragma] = STATE(3291),
    [sym_preproc_nullable] = STATE(3291),
    [sym_preproc_error] = STATE(3291),
    [sym_preproc_define] = STATE(3291),
    [sym_preproc_undef] = STATE(3291),
    [sym__identifier_token] = ACTIONS(3601),
    [anon_sym_extern] = ACTIONS(3601),
    [anon_sym_alias] = ACTIONS(3601),
    [anon_sym_global] = ACTIONS(3601),
    [anon_sym_using] = ACTIONS(3601),
    [anon_sym_unsafe] = ACTIONS(3601),
    [anon_sym_static] = ACTIONS(3601),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_LPAREN] = ACTIONS(3603),
    [anon_sym_event] = ACTIONS(3601),
    [anon_sym_namespace] = ACTIONS(3601),
    [anon_sym_class] = ACTIONS(3601),
    [anon_sym_ref] = ACTIONS(3601),
    [anon_sym_struct] = ACTIONS(3601),
    [anon_sym_enum] = ACTIONS(3601),
    [anon_sym_RBRACE] = ACTIONS(3603),
    [anon_sym_interface] = ACTIONS(3601),
    [anon_sym_delegate] = ACTIONS(3601),
    [anon_sym_record] = ACTIONS(3601),
    [anon_sym_abstract] = ACTIONS(3601),
    [anon_sym_async] = ACTIONS(3601),
    [anon_sym_const] = ACTIONS(3601),
    [anon_sym_file] = ACTIONS(3601),
    [anon_sym_fixed] = ACTIONS(3601),
    [anon_sym_internal] = ACTIONS(3601),
    [anon_sym_new] = ACTIONS(3601),
    [anon_sym_override] = ACTIONS(3601),
    [anon_sym_partial] = ACTIONS(3601),
    [anon_sym_private] = ACTIONS(3601),
    [anon_sym_protected] = ACTIONS(3601),
    [anon_sym_public] = ACTIONS(3601),
    [anon_sym_readonly] = ACTIONS(3601),
    [anon_sym_required] = ACTIONS(3601),
    [anon_sym_sealed] = ACTIONS(3601),
    [anon_sym_virtual] = ACTIONS(3601),
    [anon_sym_volatile] = ACTIONS(3601),
    [anon_sym_where] = ACTIONS(3601),
    [anon_sym_notnull] = ACTIONS(3601),
    [anon_sym_unmanaged] = ACTIONS(3601),
    [anon_sym_TILDE] = ACTIONS(3603),
    [anon_sym_implicit] = ACTIONS(3601),
    [anon_sym_explicit] = ACTIONS(3601),
    [anon_sym_scoped] = ACTIONS(3601),
    [anon_sym_var] = ACTIONS(3601),
    [sym_predefined_type] = ACTIONS(3601),
    [anon_sym_yield] = ACTIONS(3601),
    [anon_sym_when] = ACTIONS(3601),
    [anon_sym_from] = ACTIONS(3601),
    [anon_sym_into] = ACTIONS(3601),
    [anon_sym_join] = ACTIONS(3601),
    [anon_sym_on] = ACTIONS(3601),
    [anon_sym_equals] = ACTIONS(3601),
    [anon_sym_let] = ACTIONS(3601),
    [anon_sym_orderby] = ACTIONS(3601),
    [anon_sym_ascending] = ACTIONS(3601),
    [anon_sym_descending] = ACTIONS(3601),
    [anon_sym_group] = ACTIONS(3601),
    [anon_sym_by] = ACTIONS(3601),
    [anon_sym_select] = ACTIONS(3601),
    [aux_sym_preproc_if_token1] = ACTIONS(3603),
    [aux_sym_preproc_if_token3] = ACTIONS(3603),
    [aux_sym_preproc_else_token1] = ACTIONS(3603),
    [aux_sym_preproc_elif_token1] = ACTIONS(3603),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3292] = {
    [sym_preproc_region] = STATE(3292),
    [sym_preproc_endregion] = STATE(3292),
    [sym_preproc_line] = STATE(3292),
    [sym_preproc_pragma] = STATE(3292),
    [sym_preproc_nullable] = STATE(3292),
    [sym_preproc_error] = STATE(3292),
    [sym_preproc_define] = STATE(3292),
    [sym_preproc_undef] = STATE(3292),
    [sym__identifier_token] = ACTIONS(4896),
    [anon_sym_extern] = ACTIONS(4896),
    [anon_sym_alias] = ACTIONS(4896),
    [anon_sym_global] = ACTIONS(4896),
    [anon_sym_using] = ACTIONS(4896),
    [anon_sym_unsafe] = ACTIONS(4896),
    [anon_sym_static] = ACTIONS(4896),
    [anon_sym_LBRACK] = ACTIONS(4898),
    [anon_sym_LPAREN] = ACTIONS(4898),
    [anon_sym_event] = ACTIONS(4896),
    [anon_sym_namespace] = ACTIONS(4896),
    [anon_sym_class] = ACTIONS(4896),
    [anon_sym_ref] = ACTIONS(4896),
    [anon_sym_struct] = ACTIONS(4896),
    [anon_sym_enum] = ACTIONS(4896),
    [anon_sym_RBRACE] = ACTIONS(4898),
    [anon_sym_interface] = ACTIONS(4896),
    [anon_sym_delegate] = ACTIONS(4896),
    [anon_sym_record] = ACTIONS(4896),
    [anon_sym_abstract] = ACTIONS(4896),
    [anon_sym_async] = ACTIONS(4896),
    [anon_sym_const] = ACTIONS(4896),
    [anon_sym_file] = ACTIONS(4896),
    [anon_sym_fixed] = ACTIONS(4896),
    [anon_sym_internal] = ACTIONS(4896),
    [anon_sym_new] = ACTIONS(4896),
    [anon_sym_override] = ACTIONS(4896),
    [anon_sym_partial] = ACTIONS(4896),
    [anon_sym_private] = ACTIONS(4896),
    [anon_sym_protected] = ACTIONS(4896),
    [anon_sym_public] = ACTIONS(4896),
    [anon_sym_readonly] = ACTIONS(4896),
    [anon_sym_required] = ACTIONS(4896),
    [anon_sym_sealed] = ACTIONS(4896),
    [anon_sym_virtual] = ACTIONS(4896),
    [anon_sym_volatile] = ACTIONS(4896),
    [anon_sym_where] = ACTIONS(4896),
    [anon_sym_notnull] = ACTIONS(4896),
    [anon_sym_unmanaged] = ACTIONS(4896),
    [anon_sym_TILDE] = ACTIONS(4898),
    [anon_sym_implicit] = ACTIONS(4896),
    [anon_sym_explicit] = ACTIONS(4896),
    [anon_sym_scoped] = ACTIONS(4896),
    [anon_sym_var] = ACTIONS(4896),
    [sym_predefined_type] = ACTIONS(4896),
    [anon_sym_yield] = ACTIONS(4896),
    [anon_sym_when] = ACTIONS(4896),
    [anon_sym_from] = ACTIONS(4896),
    [anon_sym_into] = ACTIONS(4896),
    [anon_sym_join] = ACTIONS(4896),
    [anon_sym_on] = ACTIONS(4896),
    [anon_sym_equals] = ACTIONS(4896),
    [anon_sym_let] = ACTIONS(4896),
    [anon_sym_orderby] = ACTIONS(4896),
    [anon_sym_ascending] = ACTIONS(4896),
    [anon_sym_descending] = ACTIONS(4896),
    [anon_sym_group] = ACTIONS(4896),
    [anon_sym_by] = ACTIONS(4896),
    [anon_sym_select] = ACTIONS(4896),
    [aux_sym_preproc_if_token1] = ACTIONS(4898),
    [aux_sym_preproc_if_token3] = ACTIONS(4898),
    [aux_sym_preproc_else_token1] = ACTIONS(4898),
    [aux_sym_preproc_elif_token1] = ACTIONS(4898),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3293] = {
    [sym_preproc_region] = STATE(3293),
    [sym_preproc_endregion] = STATE(3293),
    [sym_preproc_line] = STATE(3293),
    [sym_preproc_pragma] = STATE(3293),
    [sym_preproc_nullable] = STATE(3293),
    [sym_preproc_error] = STATE(3293),
    [sym_preproc_define] = STATE(3293),
    [sym_preproc_undef] = STATE(3293),
    [sym__identifier_token] = ACTIONS(4900),
    [anon_sym_extern] = ACTIONS(4900),
    [anon_sym_alias] = ACTIONS(4900),
    [anon_sym_global] = ACTIONS(4900),
    [anon_sym_using] = ACTIONS(4900),
    [anon_sym_unsafe] = ACTIONS(4900),
    [anon_sym_static] = ACTIONS(4900),
    [anon_sym_LBRACK] = ACTIONS(4902),
    [anon_sym_LPAREN] = ACTIONS(4902),
    [anon_sym_event] = ACTIONS(4900),
    [anon_sym_namespace] = ACTIONS(4900),
    [anon_sym_class] = ACTIONS(4900),
    [anon_sym_ref] = ACTIONS(4900),
    [anon_sym_struct] = ACTIONS(4900),
    [anon_sym_enum] = ACTIONS(4900),
    [anon_sym_RBRACE] = ACTIONS(4902),
    [anon_sym_interface] = ACTIONS(4900),
    [anon_sym_delegate] = ACTIONS(4900),
    [anon_sym_record] = ACTIONS(4900),
    [anon_sym_abstract] = ACTIONS(4900),
    [anon_sym_async] = ACTIONS(4900),
    [anon_sym_const] = ACTIONS(4900),
    [anon_sym_file] = ACTIONS(4900),
    [anon_sym_fixed] = ACTIONS(4900),
    [anon_sym_internal] = ACTIONS(4900),
    [anon_sym_new] = ACTIONS(4900),
    [anon_sym_override] = ACTIONS(4900),
    [anon_sym_partial] = ACTIONS(4900),
    [anon_sym_private] = ACTIONS(4900),
    [anon_sym_protected] = ACTIONS(4900),
    [anon_sym_public] = ACTIONS(4900),
    [anon_sym_readonly] = ACTIONS(4900),
    [anon_sym_required] = ACTIONS(4900),
    [anon_sym_sealed] = ACTIONS(4900),
    [anon_sym_virtual] = ACTIONS(4900),
    [anon_sym_volatile] = ACTIONS(4900),
    [anon_sym_where] = ACTIONS(4900),
    [anon_sym_notnull] = ACTIONS(4900),
    [anon_sym_unmanaged] = ACTIONS(4900),
    [anon_sym_TILDE] = ACTIONS(4902),
    [anon_sym_implicit] = ACTIONS(4900),
    [anon_sym_explicit] = ACTIONS(4900),
    [anon_sym_scoped] = ACTIONS(4900),
    [anon_sym_var] = ACTIONS(4900),
    [sym_predefined_type] = ACTIONS(4900),
    [anon_sym_yield] = ACTIONS(4900),
    [anon_sym_when] = ACTIONS(4900),
    [anon_sym_from] = ACTIONS(4900),
    [anon_sym_into] = ACTIONS(4900),
    [anon_sym_join] = ACTIONS(4900),
    [anon_sym_on] = ACTIONS(4900),
    [anon_sym_equals] = ACTIONS(4900),
    [anon_sym_let] = ACTIONS(4900),
    [anon_sym_orderby] = ACTIONS(4900),
    [anon_sym_ascending] = ACTIONS(4900),
    [anon_sym_descending] = ACTIONS(4900),
    [anon_sym_group] = ACTIONS(4900),
    [anon_sym_by] = ACTIONS(4900),
    [anon_sym_select] = ACTIONS(4900),
    [aux_sym_preproc_if_token1] = ACTIONS(4902),
    [aux_sym_preproc_if_token3] = ACTIONS(4902),
    [aux_sym_preproc_else_token1] = ACTIONS(4902),
    [aux_sym_preproc_elif_token1] = ACTIONS(4902),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3294] = {
    [sym_preproc_region] = STATE(3294),
    [sym_preproc_endregion] = STATE(3294),
    [sym_preproc_line] = STATE(3294),
    [sym_preproc_pragma] = STATE(3294),
    [sym_preproc_nullable] = STATE(3294),
    [sym_preproc_error] = STATE(3294),
    [sym_preproc_define] = STATE(3294),
    [sym_preproc_undef] = STATE(3294),
    [sym__identifier_token] = ACTIONS(4904),
    [anon_sym_extern] = ACTIONS(4904),
    [anon_sym_alias] = ACTIONS(4904),
    [anon_sym_global] = ACTIONS(4904),
    [anon_sym_using] = ACTIONS(4904),
    [anon_sym_unsafe] = ACTIONS(4904),
    [anon_sym_static] = ACTIONS(4904),
    [anon_sym_LBRACK] = ACTIONS(4906),
    [anon_sym_LPAREN] = ACTIONS(4906),
    [anon_sym_event] = ACTIONS(4904),
    [anon_sym_namespace] = ACTIONS(4904),
    [anon_sym_class] = ACTIONS(4904),
    [anon_sym_ref] = ACTIONS(4904),
    [anon_sym_struct] = ACTIONS(4904),
    [anon_sym_enum] = ACTIONS(4904),
    [anon_sym_RBRACE] = ACTIONS(4906),
    [anon_sym_interface] = ACTIONS(4904),
    [anon_sym_delegate] = ACTIONS(4904),
    [anon_sym_record] = ACTIONS(4904),
    [anon_sym_abstract] = ACTIONS(4904),
    [anon_sym_async] = ACTIONS(4904),
    [anon_sym_const] = ACTIONS(4904),
    [anon_sym_file] = ACTIONS(4904),
    [anon_sym_fixed] = ACTIONS(4904),
    [anon_sym_internal] = ACTIONS(4904),
    [anon_sym_new] = ACTIONS(4904),
    [anon_sym_override] = ACTIONS(4904),
    [anon_sym_partial] = ACTIONS(4904),
    [anon_sym_private] = ACTIONS(4904),
    [anon_sym_protected] = ACTIONS(4904),
    [anon_sym_public] = ACTIONS(4904),
    [anon_sym_readonly] = ACTIONS(4904),
    [anon_sym_required] = ACTIONS(4904),
    [anon_sym_sealed] = ACTIONS(4904),
    [anon_sym_virtual] = ACTIONS(4904),
    [anon_sym_volatile] = ACTIONS(4904),
    [anon_sym_where] = ACTIONS(4904),
    [anon_sym_notnull] = ACTIONS(4904),
    [anon_sym_unmanaged] = ACTIONS(4904),
    [anon_sym_TILDE] = ACTIONS(4906),
    [anon_sym_implicit] = ACTIONS(4904),
    [anon_sym_explicit] = ACTIONS(4904),
    [anon_sym_scoped] = ACTIONS(4904),
    [anon_sym_var] = ACTIONS(4904),
    [sym_predefined_type] = ACTIONS(4904),
    [anon_sym_yield] = ACTIONS(4904),
    [anon_sym_when] = ACTIONS(4904),
    [anon_sym_from] = ACTIONS(4904),
    [anon_sym_into] = ACTIONS(4904),
    [anon_sym_join] = ACTIONS(4904),
    [anon_sym_on] = ACTIONS(4904),
    [anon_sym_equals] = ACTIONS(4904),
    [anon_sym_let] = ACTIONS(4904),
    [anon_sym_orderby] = ACTIONS(4904),
    [anon_sym_ascending] = ACTIONS(4904),
    [anon_sym_descending] = ACTIONS(4904),
    [anon_sym_group] = ACTIONS(4904),
    [anon_sym_by] = ACTIONS(4904),
    [anon_sym_select] = ACTIONS(4904),
    [aux_sym_preproc_if_token1] = ACTIONS(4906),
    [aux_sym_preproc_if_token3] = ACTIONS(4906),
    [aux_sym_preproc_else_token1] = ACTIONS(4906),
    [aux_sym_preproc_elif_token1] = ACTIONS(4906),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3295] = {
    [sym_preproc_region] = STATE(3295),
    [sym_preproc_endregion] = STATE(3295),
    [sym_preproc_line] = STATE(3295),
    [sym_preproc_pragma] = STATE(3295),
    [sym_preproc_nullable] = STATE(3295),
    [sym_preproc_error] = STATE(3295),
    [sym_preproc_define] = STATE(3295),
    [sym_preproc_undef] = STATE(3295),
    [sym__identifier_token] = ACTIONS(3876),
    [anon_sym_extern] = ACTIONS(3876),
    [anon_sym_alias] = ACTIONS(3876),
    [anon_sym_global] = ACTIONS(3876),
    [anon_sym_using] = ACTIONS(3876),
    [anon_sym_unsafe] = ACTIONS(3876),
    [anon_sym_static] = ACTIONS(3876),
    [anon_sym_LBRACK] = ACTIONS(3878),
    [anon_sym_LPAREN] = ACTIONS(3878),
    [anon_sym_event] = ACTIONS(3876),
    [anon_sym_namespace] = ACTIONS(3876),
    [anon_sym_class] = ACTIONS(3876),
    [anon_sym_ref] = ACTIONS(3876),
    [anon_sym_struct] = ACTIONS(3876),
    [anon_sym_enum] = ACTIONS(3876),
    [anon_sym_RBRACE] = ACTIONS(3878),
    [anon_sym_interface] = ACTIONS(3876),
    [anon_sym_delegate] = ACTIONS(3876),
    [anon_sym_record] = ACTIONS(3876),
    [anon_sym_abstract] = ACTIONS(3876),
    [anon_sym_async] = ACTIONS(3876),
    [anon_sym_const] = ACTIONS(3876),
    [anon_sym_file] = ACTIONS(3876),
    [anon_sym_fixed] = ACTIONS(3876),
    [anon_sym_internal] = ACTIONS(3876),
    [anon_sym_new] = ACTIONS(3876),
    [anon_sym_override] = ACTIONS(3876),
    [anon_sym_partial] = ACTIONS(3876),
    [anon_sym_private] = ACTIONS(3876),
    [anon_sym_protected] = ACTIONS(3876),
    [anon_sym_public] = ACTIONS(3876),
    [anon_sym_readonly] = ACTIONS(3876),
    [anon_sym_required] = ACTIONS(3876),
    [anon_sym_sealed] = ACTIONS(3876),
    [anon_sym_virtual] = ACTIONS(3876),
    [anon_sym_volatile] = ACTIONS(3876),
    [anon_sym_where] = ACTIONS(3876),
    [anon_sym_notnull] = ACTIONS(3876),
    [anon_sym_unmanaged] = ACTIONS(3876),
    [anon_sym_TILDE] = ACTIONS(3878),
    [anon_sym_implicit] = ACTIONS(3876),
    [anon_sym_explicit] = ACTIONS(3876),
    [anon_sym_scoped] = ACTIONS(3876),
    [anon_sym_var] = ACTIONS(3876),
    [sym_predefined_type] = ACTIONS(3876),
    [anon_sym_yield] = ACTIONS(3876),
    [anon_sym_when] = ACTIONS(3876),
    [anon_sym_from] = ACTIONS(3876),
    [anon_sym_into] = ACTIONS(3876),
    [anon_sym_join] = ACTIONS(3876),
    [anon_sym_on] = ACTIONS(3876),
    [anon_sym_equals] = ACTIONS(3876),
    [anon_sym_let] = ACTIONS(3876),
    [anon_sym_orderby] = ACTIONS(3876),
    [anon_sym_ascending] = ACTIONS(3876),
    [anon_sym_descending] = ACTIONS(3876),
    [anon_sym_group] = ACTIONS(3876),
    [anon_sym_by] = ACTIONS(3876),
    [anon_sym_select] = ACTIONS(3876),
    [aux_sym_preproc_if_token1] = ACTIONS(3878),
    [aux_sym_preproc_if_token3] = ACTIONS(3878),
    [aux_sym_preproc_else_token1] = ACTIONS(3878),
    [aux_sym_preproc_elif_token1] = ACTIONS(3878),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3296] = {
    [sym_preproc_region] = STATE(3296),
    [sym_preproc_endregion] = STATE(3296),
    [sym_preproc_line] = STATE(3296),
    [sym_preproc_pragma] = STATE(3296),
    [sym_preproc_nullable] = STATE(3296),
    [sym_preproc_error] = STATE(3296),
    [sym_preproc_define] = STATE(3296),
    [sym_preproc_undef] = STATE(3296),
    [sym__identifier_token] = ACTIONS(4908),
    [anon_sym_extern] = ACTIONS(4908),
    [anon_sym_alias] = ACTIONS(4908),
    [anon_sym_global] = ACTIONS(4908),
    [anon_sym_using] = ACTIONS(4908),
    [anon_sym_unsafe] = ACTIONS(4908),
    [anon_sym_static] = ACTIONS(4908),
    [anon_sym_LBRACK] = ACTIONS(4910),
    [anon_sym_LPAREN] = ACTIONS(4910),
    [anon_sym_event] = ACTIONS(4908),
    [anon_sym_namespace] = ACTIONS(4908),
    [anon_sym_class] = ACTIONS(4908),
    [anon_sym_ref] = ACTIONS(4908),
    [anon_sym_struct] = ACTIONS(4908),
    [anon_sym_enum] = ACTIONS(4908),
    [anon_sym_RBRACE] = ACTIONS(4910),
    [anon_sym_interface] = ACTIONS(4908),
    [anon_sym_delegate] = ACTIONS(4908),
    [anon_sym_record] = ACTIONS(4908),
    [anon_sym_abstract] = ACTIONS(4908),
    [anon_sym_async] = ACTIONS(4908),
    [anon_sym_const] = ACTIONS(4908),
    [anon_sym_file] = ACTIONS(4908),
    [anon_sym_fixed] = ACTIONS(4908),
    [anon_sym_internal] = ACTIONS(4908),
    [anon_sym_new] = ACTIONS(4908),
    [anon_sym_override] = ACTIONS(4908),
    [anon_sym_partial] = ACTIONS(4908),
    [anon_sym_private] = ACTIONS(4908),
    [anon_sym_protected] = ACTIONS(4908),
    [anon_sym_public] = ACTIONS(4908),
    [anon_sym_readonly] = ACTIONS(4908),
    [anon_sym_required] = ACTIONS(4908),
    [anon_sym_sealed] = ACTIONS(4908),
    [anon_sym_virtual] = ACTIONS(4908),
    [anon_sym_volatile] = ACTIONS(4908),
    [anon_sym_where] = ACTIONS(4908),
    [anon_sym_notnull] = ACTIONS(4908),
    [anon_sym_unmanaged] = ACTIONS(4908),
    [anon_sym_TILDE] = ACTIONS(4910),
    [anon_sym_implicit] = ACTIONS(4908),
    [anon_sym_explicit] = ACTIONS(4908),
    [anon_sym_scoped] = ACTIONS(4908),
    [anon_sym_var] = ACTIONS(4908),
    [sym_predefined_type] = ACTIONS(4908),
    [anon_sym_yield] = ACTIONS(4908),
    [anon_sym_when] = ACTIONS(4908),
    [anon_sym_from] = ACTIONS(4908),
    [anon_sym_into] = ACTIONS(4908),
    [anon_sym_join] = ACTIONS(4908),
    [anon_sym_on] = ACTIONS(4908),
    [anon_sym_equals] = ACTIONS(4908),
    [anon_sym_let] = ACTIONS(4908),
    [anon_sym_orderby] = ACTIONS(4908),
    [anon_sym_ascending] = ACTIONS(4908),
    [anon_sym_descending] = ACTIONS(4908),
    [anon_sym_group] = ACTIONS(4908),
    [anon_sym_by] = ACTIONS(4908),
    [anon_sym_select] = ACTIONS(4908),
    [aux_sym_preproc_if_token1] = ACTIONS(4910),
    [aux_sym_preproc_if_token3] = ACTIONS(4910),
    [aux_sym_preproc_else_token1] = ACTIONS(4910),
    [aux_sym_preproc_elif_token1] = ACTIONS(4910),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3297] = {
    [sym_preproc_region] = STATE(3297),
    [sym_preproc_endregion] = STATE(3297),
    [sym_preproc_line] = STATE(3297),
    [sym_preproc_pragma] = STATE(3297),
    [sym_preproc_nullable] = STATE(3297),
    [sym_preproc_error] = STATE(3297),
    [sym_preproc_define] = STATE(3297),
    [sym_preproc_undef] = STATE(3297),
    [sym__identifier_token] = ACTIONS(4912),
    [anon_sym_extern] = ACTIONS(4912),
    [anon_sym_alias] = ACTIONS(4912),
    [anon_sym_global] = ACTIONS(4912),
    [anon_sym_using] = ACTIONS(4912),
    [anon_sym_unsafe] = ACTIONS(4912),
    [anon_sym_static] = ACTIONS(4912),
    [anon_sym_LBRACK] = ACTIONS(4914),
    [anon_sym_LPAREN] = ACTIONS(4914),
    [anon_sym_event] = ACTIONS(4912),
    [anon_sym_namespace] = ACTIONS(4912),
    [anon_sym_class] = ACTIONS(4912),
    [anon_sym_ref] = ACTIONS(4912),
    [anon_sym_struct] = ACTIONS(4912),
    [anon_sym_enum] = ACTIONS(4912),
    [anon_sym_RBRACE] = ACTIONS(4914),
    [anon_sym_interface] = ACTIONS(4912),
    [anon_sym_delegate] = ACTIONS(4912),
    [anon_sym_record] = ACTIONS(4912),
    [anon_sym_abstract] = ACTIONS(4912),
    [anon_sym_async] = ACTIONS(4912),
    [anon_sym_const] = ACTIONS(4912),
    [anon_sym_file] = ACTIONS(4912),
    [anon_sym_fixed] = ACTIONS(4912),
    [anon_sym_internal] = ACTIONS(4912),
    [anon_sym_new] = ACTIONS(4912),
    [anon_sym_override] = ACTIONS(4912),
    [anon_sym_partial] = ACTIONS(4912),
    [anon_sym_private] = ACTIONS(4912),
    [anon_sym_protected] = ACTIONS(4912),
    [anon_sym_public] = ACTIONS(4912),
    [anon_sym_readonly] = ACTIONS(4912),
    [anon_sym_required] = ACTIONS(4912),
    [anon_sym_sealed] = ACTIONS(4912),
    [anon_sym_virtual] = ACTIONS(4912),
    [anon_sym_volatile] = ACTIONS(4912),
    [anon_sym_where] = ACTIONS(4912),
    [anon_sym_notnull] = ACTIONS(4912),
    [anon_sym_unmanaged] = ACTIONS(4912),
    [anon_sym_TILDE] = ACTIONS(4914),
    [anon_sym_implicit] = ACTIONS(4912),
    [anon_sym_explicit] = ACTIONS(4912),
    [anon_sym_scoped] = ACTIONS(4912),
    [anon_sym_var] = ACTIONS(4912),
    [sym_predefined_type] = ACTIONS(4912),
    [anon_sym_yield] = ACTIONS(4912),
    [anon_sym_when] = ACTIONS(4912),
    [anon_sym_from] = ACTIONS(4912),
    [anon_sym_into] = ACTIONS(4912),
    [anon_sym_join] = ACTIONS(4912),
    [anon_sym_on] = ACTIONS(4912),
    [anon_sym_equals] = ACTIONS(4912),
    [anon_sym_let] = ACTIONS(4912),
    [anon_sym_orderby] = ACTIONS(4912),
    [anon_sym_ascending] = ACTIONS(4912),
    [anon_sym_descending] = ACTIONS(4912),
    [anon_sym_group] = ACTIONS(4912),
    [anon_sym_by] = ACTIONS(4912),
    [anon_sym_select] = ACTIONS(4912),
    [aux_sym_preproc_if_token1] = ACTIONS(4914),
    [aux_sym_preproc_if_token3] = ACTIONS(4914),
    [aux_sym_preproc_else_token1] = ACTIONS(4914),
    [aux_sym_preproc_elif_token1] = ACTIONS(4914),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3298] = {
    [sym_preproc_region] = STATE(3298),
    [sym_preproc_endregion] = STATE(3298),
    [sym_preproc_line] = STATE(3298),
    [sym_preproc_pragma] = STATE(3298),
    [sym_preproc_nullable] = STATE(3298),
    [sym_preproc_error] = STATE(3298),
    [sym_preproc_define] = STATE(3298),
    [sym_preproc_undef] = STATE(3298),
    [sym__identifier_token] = ACTIONS(3880),
    [anon_sym_extern] = ACTIONS(3880),
    [anon_sym_alias] = ACTIONS(3880),
    [anon_sym_global] = ACTIONS(3880),
    [anon_sym_using] = ACTIONS(3880),
    [anon_sym_unsafe] = ACTIONS(3880),
    [anon_sym_static] = ACTIONS(3880),
    [anon_sym_LBRACK] = ACTIONS(3882),
    [anon_sym_LPAREN] = ACTIONS(3882),
    [anon_sym_event] = ACTIONS(3880),
    [anon_sym_namespace] = ACTIONS(3880),
    [anon_sym_class] = ACTIONS(3880),
    [anon_sym_ref] = ACTIONS(3880),
    [anon_sym_struct] = ACTIONS(3880),
    [anon_sym_enum] = ACTIONS(3880),
    [anon_sym_RBRACE] = ACTIONS(3882),
    [anon_sym_interface] = ACTIONS(3880),
    [anon_sym_delegate] = ACTIONS(3880),
    [anon_sym_record] = ACTIONS(3880),
    [anon_sym_abstract] = ACTIONS(3880),
    [anon_sym_async] = ACTIONS(3880),
    [anon_sym_const] = ACTIONS(3880),
    [anon_sym_file] = ACTIONS(3880),
    [anon_sym_fixed] = ACTIONS(3880),
    [anon_sym_internal] = ACTIONS(3880),
    [anon_sym_new] = ACTIONS(3880),
    [anon_sym_override] = ACTIONS(3880),
    [anon_sym_partial] = ACTIONS(3880),
    [anon_sym_private] = ACTIONS(3880),
    [anon_sym_protected] = ACTIONS(3880),
    [anon_sym_public] = ACTIONS(3880),
    [anon_sym_readonly] = ACTIONS(3880),
    [anon_sym_required] = ACTIONS(3880),
    [anon_sym_sealed] = ACTIONS(3880),
    [anon_sym_virtual] = ACTIONS(3880),
    [anon_sym_volatile] = ACTIONS(3880),
    [anon_sym_where] = ACTIONS(3880),
    [anon_sym_notnull] = ACTIONS(3880),
    [anon_sym_unmanaged] = ACTIONS(3880),
    [anon_sym_TILDE] = ACTIONS(3882),
    [anon_sym_implicit] = ACTIONS(3880),
    [anon_sym_explicit] = ACTIONS(3880),
    [anon_sym_scoped] = ACTIONS(3880),
    [anon_sym_var] = ACTIONS(3880),
    [sym_predefined_type] = ACTIONS(3880),
    [anon_sym_yield] = ACTIONS(3880),
    [anon_sym_when] = ACTIONS(3880),
    [anon_sym_from] = ACTIONS(3880),
    [anon_sym_into] = ACTIONS(3880),
    [anon_sym_join] = ACTIONS(3880),
    [anon_sym_on] = ACTIONS(3880),
    [anon_sym_equals] = ACTIONS(3880),
    [anon_sym_let] = ACTIONS(3880),
    [anon_sym_orderby] = ACTIONS(3880),
    [anon_sym_ascending] = ACTIONS(3880),
    [anon_sym_descending] = ACTIONS(3880),
    [anon_sym_group] = ACTIONS(3880),
    [anon_sym_by] = ACTIONS(3880),
    [anon_sym_select] = ACTIONS(3880),
    [aux_sym_preproc_if_token1] = ACTIONS(3882),
    [aux_sym_preproc_if_token3] = ACTIONS(3882),
    [aux_sym_preproc_else_token1] = ACTIONS(3882),
    [aux_sym_preproc_elif_token1] = ACTIONS(3882),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3299] = {
    [sym_preproc_region] = STATE(3299),
    [sym_preproc_endregion] = STATE(3299),
    [sym_preproc_line] = STATE(3299),
    [sym_preproc_pragma] = STATE(3299),
    [sym_preproc_nullable] = STATE(3299),
    [sym_preproc_error] = STATE(3299),
    [sym_preproc_define] = STATE(3299),
    [sym_preproc_undef] = STATE(3299),
    [sym__identifier_token] = ACTIONS(4916),
    [anon_sym_extern] = ACTIONS(4916),
    [anon_sym_alias] = ACTIONS(4916),
    [anon_sym_global] = ACTIONS(4916),
    [anon_sym_using] = ACTIONS(4916),
    [anon_sym_unsafe] = ACTIONS(4916),
    [anon_sym_static] = ACTIONS(4916),
    [anon_sym_LBRACK] = ACTIONS(4918),
    [anon_sym_LPAREN] = ACTIONS(4918),
    [anon_sym_event] = ACTIONS(4916),
    [anon_sym_namespace] = ACTIONS(4916),
    [anon_sym_class] = ACTIONS(4916),
    [anon_sym_ref] = ACTIONS(4916),
    [anon_sym_struct] = ACTIONS(4916),
    [anon_sym_enum] = ACTIONS(4916),
    [anon_sym_RBRACE] = ACTIONS(4918),
    [anon_sym_interface] = ACTIONS(4916),
    [anon_sym_delegate] = ACTIONS(4916),
    [anon_sym_record] = ACTIONS(4916),
    [anon_sym_abstract] = ACTIONS(4916),
    [anon_sym_async] = ACTIONS(4916),
    [anon_sym_const] = ACTIONS(4916),
    [anon_sym_file] = ACTIONS(4916),
    [anon_sym_fixed] = ACTIONS(4916),
    [anon_sym_internal] = ACTIONS(4916),
    [anon_sym_new] = ACTIONS(4916),
    [anon_sym_override] = ACTIONS(4916),
    [anon_sym_partial] = ACTIONS(4916),
    [anon_sym_private] = ACTIONS(4916),
    [anon_sym_protected] = ACTIONS(4916),
    [anon_sym_public] = ACTIONS(4916),
    [anon_sym_readonly] = ACTIONS(4916),
    [anon_sym_required] = ACTIONS(4916),
    [anon_sym_sealed] = ACTIONS(4916),
    [anon_sym_virtual] = ACTIONS(4916),
    [anon_sym_volatile] = ACTIONS(4916),
    [anon_sym_where] = ACTIONS(4916),
    [anon_sym_notnull] = ACTIONS(4916),
    [anon_sym_unmanaged] = ACTIONS(4916),
    [anon_sym_TILDE] = ACTIONS(4918),
    [anon_sym_implicit] = ACTIONS(4916),
    [anon_sym_explicit] = ACTIONS(4916),
    [anon_sym_scoped] = ACTIONS(4916),
    [anon_sym_var] = ACTIONS(4916),
    [sym_predefined_type] = ACTIONS(4916),
    [anon_sym_yield] = ACTIONS(4916),
    [anon_sym_when] = ACTIONS(4916),
    [anon_sym_from] = ACTIONS(4916),
    [anon_sym_into] = ACTIONS(4916),
    [anon_sym_join] = ACTIONS(4916),
    [anon_sym_on] = ACTIONS(4916),
    [anon_sym_equals] = ACTIONS(4916),
    [anon_sym_let] = ACTIONS(4916),
    [anon_sym_orderby] = ACTIONS(4916),
    [anon_sym_ascending] = ACTIONS(4916),
    [anon_sym_descending] = ACTIONS(4916),
    [anon_sym_group] = ACTIONS(4916),
    [anon_sym_by] = ACTIONS(4916),
    [anon_sym_select] = ACTIONS(4916),
    [aux_sym_preproc_if_token1] = ACTIONS(4918),
    [aux_sym_preproc_if_token3] = ACTIONS(4918),
    [aux_sym_preproc_else_token1] = ACTIONS(4918),
    [aux_sym_preproc_elif_token1] = ACTIONS(4918),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3300] = {
    [sym_preproc_region] = STATE(3300),
    [sym_preproc_endregion] = STATE(3300),
    [sym_preproc_line] = STATE(3300),
    [sym_preproc_pragma] = STATE(3300),
    [sym_preproc_nullable] = STATE(3300),
    [sym_preproc_error] = STATE(3300),
    [sym_preproc_define] = STATE(3300),
    [sym_preproc_undef] = STATE(3300),
    [sym__identifier_token] = ACTIONS(4920),
    [anon_sym_extern] = ACTIONS(4920),
    [anon_sym_alias] = ACTIONS(4920),
    [anon_sym_global] = ACTIONS(4920),
    [anon_sym_using] = ACTIONS(4920),
    [anon_sym_unsafe] = ACTIONS(4920),
    [anon_sym_static] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(4922),
    [anon_sym_LPAREN] = ACTIONS(4922),
    [anon_sym_event] = ACTIONS(4920),
    [anon_sym_namespace] = ACTIONS(4920),
    [anon_sym_class] = ACTIONS(4920),
    [anon_sym_ref] = ACTIONS(4920),
    [anon_sym_struct] = ACTIONS(4920),
    [anon_sym_enum] = ACTIONS(4920),
    [anon_sym_RBRACE] = ACTIONS(4922),
    [anon_sym_interface] = ACTIONS(4920),
    [anon_sym_delegate] = ACTIONS(4920),
    [anon_sym_record] = ACTIONS(4920),
    [anon_sym_abstract] = ACTIONS(4920),
    [anon_sym_async] = ACTIONS(4920),
    [anon_sym_const] = ACTIONS(4920),
    [anon_sym_file] = ACTIONS(4920),
    [anon_sym_fixed] = ACTIONS(4920),
    [anon_sym_internal] = ACTIONS(4920),
    [anon_sym_new] = ACTIONS(4920),
    [anon_sym_override] = ACTIONS(4920),
    [anon_sym_partial] = ACTIONS(4920),
    [anon_sym_private] = ACTIONS(4920),
    [anon_sym_protected] = ACTIONS(4920),
    [anon_sym_public] = ACTIONS(4920),
    [anon_sym_readonly] = ACTIONS(4920),
    [anon_sym_required] = ACTIONS(4920),
    [anon_sym_sealed] = ACTIONS(4920),
    [anon_sym_virtual] = ACTIONS(4920),
    [anon_sym_volatile] = ACTIONS(4920),
    [anon_sym_where] = ACTIONS(4920),
    [anon_sym_notnull] = ACTIONS(4920),
    [anon_sym_unmanaged] = ACTIONS(4920),
    [anon_sym_TILDE] = ACTIONS(4922),
    [anon_sym_implicit] = ACTIONS(4920),
    [anon_sym_explicit] = ACTIONS(4920),
    [anon_sym_scoped] = ACTIONS(4920),
    [anon_sym_var] = ACTIONS(4920),
    [sym_predefined_type] = ACTIONS(4920),
    [anon_sym_yield] = ACTIONS(4920),
    [anon_sym_when] = ACTIONS(4920),
    [anon_sym_from] = ACTIONS(4920),
    [anon_sym_into] = ACTIONS(4920),
    [anon_sym_join] = ACTIONS(4920),
    [anon_sym_on] = ACTIONS(4920),
    [anon_sym_equals] = ACTIONS(4920),
    [anon_sym_let] = ACTIONS(4920),
    [anon_sym_orderby] = ACTIONS(4920),
    [anon_sym_ascending] = ACTIONS(4920),
    [anon_sym_descending] = ACTIONS(4920),
    [anon_sym_group] = ACTIONS(4920),
    [anon_sym_by] = ACTIONS(4920),
    [anon_sym_select] = ACTIONS(4920),
    [aux_sym_preproc_if_token1] = ACTIONS(4922),
    [aux_sym_preproc_if_token3] = ACTIONS(4922),
    [aux_sym_preproc_else_token1] = ACTIONS(4922),
    [aux_sym_preproc_elif_token1] = ACTIONS(4922),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3301] = {
    [sym_preproc_region] = STATE(3301),
    [sym_preproc_endregion] = STATE(3301),
    [sym_preproc_line] = STATE(3301),
    [sym_preproc_pragma] = STATE(3301),
    [sym_preproc_nullable] = STATE(3301),
    [sym_preproc_error] = STATE(3301),
    [sym_preproc_define] = STATE(3301),
    [sym_preproc_undef] = STATE(3301),
    [sym__identifier_token] = ACTIONS(3541),
    [anon_sym_extern] = ACTIONS(3541),
    [anon_sym_alias] = ACTIONS(3541),
    [anon_sym_global] = ACTIONS(3541),
    [anon_sym_using] = ACTIONS(3541),
    [anon_sym_unsafe] = ACTIONS(3541),
    [anon_sym_static] = ACTIONS(3541),
    [anon_sym_LBRACK] = ACTIONS(3543),
    [anon_sym_LPAREN] = ACTIONS(3543),
    [anon_sym_event] = ACTIONS(3541),
    [anon_sym_namespace] = ACTIONS(3541),
    [anon_sym_class] = ACTIONS(3541),
    [anon_sym_ref] = ACTIONS(3541),
    [anon_sym_struct] = ACTIONS(3541),
    [anon_sym_enum] = ACTIONS(3541),
    [anon_sym_RBRACE] = ACTIONS(3543),
    [anon_sym_interface] = ACTIONS(3541),
    [anon_sym_delegate] = ACTIONS(3541),
    [anon_sym_record] = ACTIONS(3541),
    [anon_sym_abstract] = ACTIONS(3541),
    [anon_sym_async] = ACTIONS(3541),
    [anon_sym_const] = ACTIONS(3541),
    [anon_sym_file] = ACTIONS(3541),
    [anon_sym_fixed] = ACTIONS(3541),
    [anon_sym_internal] = ACTIONS(3541),
    [anon_sym_new] = ACTIONS(3541),
    [anon_sym_override] = ACTIONS(3541),
    [anon_sym_partial] = ACTIONS(3541),
    [anon_sym_private] = ACTIONS(3541),
    [anon_sym_protected] = ACTIONS(3541),
    [anon_sym_public] = ACTIONS(3541),
    [anon_sym_readonly] = ACTIONS(3541),
    [anon_sym_required] = ACTIONS(3541),
    [anon_sym_sealed] = ACTIONS(3541),
    [anon_sym_virtual] = ACTIONS(3541),
    [anon_sym_volatile] = ACTIONS(3541),
    [anon_sym_where] = ACTIONS(3541),
    [anon_sym_notnull] = ACTIONS(3541),
    [anon_sym_unmanaged] = ACTIONS(3541),
    [anon_sym_TILDE] = ACTIONS(3543),
    [anon_sym_implicit] = ACTIONS(3541),
    [anon_sym_explicit] = ACTIONS(3541),
    [anon_sym_scoped] = ACTIONS(3541),
    [anon_sym_var] = ACTIONS(3541),
    [sym_predefined_type] = ACTIONS(3541),
    [anon_sym_yield] = ACTIONS(3541),
    [anon_sym_when] = ACTIONS(3541),
    [anon_sym_from] = ACTIONS(3541),
    [anon_sym_into] = ACTIONS(3541),
    [anon_sym_join] = ACTIONS(3541),
    [anon_sym_on] = ACTIONS(3541),
    [anon_sym_equals] = ACTIONS(3541),
    [anon_sym_let] = ACTIONS(3541),
    [anon_sym_orderby] = ACTIONS(3541),
    [anon_sym_ascending] = ACTIONS(3541),
    [anon_sym_descending] = ACTIONS(3541),
    [anon_sym_group] = ACTIONS(3541),
    [anon_sym_by] = ACTIONS(3541),
    [anon_sym_select] = ACTIONS(3541),
    [aux_sym_preproc_if_token1] = ACTIONS(3543),
    [aux_sym_preproc_if_token3] = ACTIONS(3543),
    [aux_sym_preproc_else_token1] = ACTIONS(3543),
    [aux_sym_preproc_elif_token1] = ACTIONS(3543),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3302] = {
    [sym_preproc_region] = STATE(3302),
    [sym_preproc_endregion] = STATE(3302),
    [sym_preproc_line] = STATE(3302),
    [sym_preproc_pragma] = STATE(3302),
    [sym_preproc_nullable] = STATE(3302),
    [sym_preproc_error] = STATE(3302),
    [sym_preproc_define] = STATE(3302),
    [sym_preproc_undef] = STATE(3302),
    [sym__identifier_token] = ACTIONS(4924),
    [anon_sym_extern] = ACTIONS(4924),
    [anon_sym_alias] = ACTIONS(4924),
    [anon_sym_global] = ACTIONS(4924),
    [anon_sym_using] = ACTIONS(4924),
    [anon_sym_unsafe] = ACTIONS(4924),
    [anon_sym_static] = ACTIONS(4924),
    [anon_sym_LBRACK] = ACTIONS(4926),
    [anon_sym_LPAREN] = ACTIONS(4926),
    [anon_sym_event] = ACTIONS(4924),
    [anon_sym_namespace] = ACTIONS(4924),
    [anon_sym_class] = ACTIONS(4924),
    [anon_sym_ref] = ACTIONS(4924),
    [anon_sym_struct] = ACTIONS(4924),
    [anon_sym_enum] = ACTIONS(4924),
    [anon_sym_RBRACE] = ACTIONS(4926),
    [anon_sym_interface] = ACTIONS(4924),
    [anon_sym_delegate] = ACTIONS(4924),
    [anon_sym_record] = ACTIONS(4924),
    [anon_sym_abstract] = ACTIONS(4924),
    [anon_sym_async] = ACTIONS(4924),
    [anon_sym_const] = ACTIONS(4924),
    [anon_sym_file] = ACTIONS(4924),
    [anon_sym_fixed] = ACTIONS(4924),
    [anon_sym_internal] = ACTIONS(4924),
    [anon_sym_new] = ACTIONS(4924),
    [anon_sym_override] = ACTIONS(4924),
    [anon_sym_partial] = ACTIONS(4924),
    [anon_sym_private] = ACTIONS(4924),
    [anon_sym_protected] = ACTIONS(4924),
    [anon_sym_public] = ACTIONS(4924),
    [anon_sym_readonly] = ACTIONS(4924),
    [anon_sym_required] = ACTIONS(4924),
    [anon_sym_sealed] = ACTIONS(4924),
    [anon_sym_virtual] = ACTIONS(4924),
    [anon_sym_volatile] = ACTIONS(4924),
    [anon_sym_where] = ACTIONS(4924),
    [anon_sym_notnull] = ACTIONS(4924),
    [anon_sym_unmanaged] = ACTIONS(4924),
    [anon_sym_TILDE] = ACTIONS(4926),
    [anon_sym_implicit] = ACTIONS(4924),
    [anon_sym_explicit] = ACTIONS(4924),
    [anon_sym_scoped] = ACTIONS(4924),
    [anon_sym_var] = ACTIONS(4924),
    [sym_predefined_type] = ACTIONS(4924),
    [anon_sym_yield] = ACTIONS(4924),
    [anon_sym_when] = ACTIONS(4924),
    [anon_sym_from] = ACTIONS(4924),
    [anon_sym_into] = ACTIONS(4924),
    [anon_sym_join] = ACTIONS(4924),
    [anon_sym_on] = ACTIONS(4924),
    [anon_sym_equals] = ACTIONS(4924),
    [anon_sym_let] = ACTIONS(4924),
    [anon_sym_orderby] = ACTIONS(4924),
    [anon_sym_ascending] = ACTIONS(4924),
    [anon_sym_descending] = ACTIONS(4924),
    [anon_sym_group] = ACTIONS(4924),
    [anon_sym_by] = ACTIONS(4924),
    [anon_sym_select] = ACTIONS(4924),
    [aux_sym_preproc_if_token1] = ACTIONS(4926),
    [aux_sym_preproc_if_token3] = ACTIONS(4926),
    [aux_sym_preproc_else_token1] = ACTIONS(4926),
    [aux_sym_preproc_elif_token1] = ACTIONS(4926),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3303] = {
    [sym_preproc_region] = STATE(3303),
    [sym_preproc_endregion] = STATE(3303),
    [sym_preproc_line] = STATE(3303),
    [sym_preproc_pragma] = STATE(3303),
    [sym_preproc_nullable] = STATE(3303),
    [sym_preproc_error] = STATE(3303),
    [sym_preproc_define] = STATE(3303),
    [sym_preproc_undef] = STATE(3303),
    [sym__identifier_token] = ACTIONS(3545),
    [anon_sym_extern] = ACTIONS(3545),
    [anon_sym_alias] = ACTIONS(3545),
    [anon_sym_global] = ACTIONS(3545),
    [anon_sym_using] = ACTIONS(3545),
    [anon_sym_unsafe] = ACTIONS(3545),
    [anon_sym_static] = ACTIONS(3545),
    [anon_sym_LBRACK] = ACTIONS(3547),
    [anon_sym_LPAREN] = ACTIONS(3547),
    [anon_sym_event] = ACTIONS(3545),
    [anon_sym_namespace] = ACTIONS(3545),
    [anon_sym_class] = ACTIONS(3545),
    [anon_sym_ref] = ACTIONS(3545),
    [anon_sym_struct] = ACTIONS(3545),
    [anon_sym_enum] = ACTIONS(3545),
    [anon_sym_RBRACE] = ACTIONS(3547),
    [anon_sym_interface] = ACTIONS(3545),
    [anon_sym_delegate] = ACTIONS(3545),
    [anon_sym_record] = ACTIONS(3545),
    [anon_sym_abstract] = ACTIONS(3545),
    [anon_sym_async] = ACTIONS(3545),
    [anon_sym_const] = ACTIONS(3545),
    [anon_sym_file] = ACTIONS(3545),
    [anon_sym_fixed] = ACTIONS(3545),
    [anon_sym_internal] = ACTIONS(3545),
    [anon_sym_new] = ACTIONS(3545),
    [anon_sym_override] = ACTIONS(3545),
    [anon_sym_partial] = ACTIONS(3545),
    [anon_sym_private] = ACTIONS(3545),
    [anon_sym_protected] = ACTIONS(3545),
    [anon_sym_public] = ACTIONS(3545),
    [anon_sym_readonly] = ACTIONS(3545),
    [anon_sym_required] = ACTIONS(3545),
    [anon_sym_sealed] = ACTIONS(3545),
    [anon_sym_virtual] = ACTIONS(3545),
    [anon_sym_volatile] = ACTIONS(3545),
    [anon_sym_where] = ACTIONS(3545),
    [anon_sym_notnull] = ACTIONS(3545),
    [anon_sym_unmanaged] = ACTIONS(3545),
    [anon_sym_TILDE] = ACTIONS(3547),
    [anon_sym_implicit] = ACTIONS(3545),
    [anon_sym_explicit] = ACTIONS(3545),
    [anon_sym_scoped] = ACTIONS(3545),
    [anon_sym_var] = ACTIONS(3545),
    [sym_predefined_type] = ACTIONS(3545),
    [anon_sym_yield] = ACTIONS(3545),
    [anon_sym_when] = ACTIONS(3545),
    [anon_sym_from] = ACTIONS(3545),
    [anon_sym_into] = ACTIONS(3545),
    [anon_sym_join] = ACTIONS(3545),
    [anon_sym_on] = ACTIONS(3545),
    [anon_sym_equals] = ACTIONS(3545),
    [anon_sym_let] = ACTIONS(3545),
    [anon_sym_orderby] = ACTIONS(3545),
    [anon_sym_ascending] = ACTIONS(3545),
    [anon_sym_descending] = ACTIONS(3545),
    [anon_sym_group] = ACTIONS(3545),
    [anon_sym_by] = ACTIONS(3545),
    [anon_sym_select] = ACTIONS(3545),
    [aux_sym_preproc_if_token1] = ACTIONS(3547),
    [aux_sym_preproc_if_token3] = ACTIONS(3547),
    [aux_sym_preproc_else_token1] = ACTIONS(3547),
    [aux_sym_preproc_elif_token1] = ACTIONS(3547),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3304] = {
    [sym_preproc_region] = STATE(3304),
    [sym_preproc_endregion] = STATE(3304),
    [sym_preproc_line] = STATE(3304),
    [sym_preproc_pragma] = STATE(3304),
    [sym_preproc_nullable] = STATE(3304),
    [sym_preproc_error] = STATE(3304),
    [sym_preproc_define] = STATE(3304),
    [sym_preproc_undef] = STATE(3304),
    [sym__identifier_token] = ACTIONS(4928),
    [anon_sym_extern] = ACTIONS(4928),
    [anon_sym_alias] = ACTIONS(4928),
    [anon_sym_global] = ACTIONS(4928),
    [anon_sym_using] = ACTIONS(4928),
    [anon_sym_unsafe] = ACTIONS(4928),
    [anon_sym_static] = ACTIONS(4928),
    [anon_sym_LBRACK] = ACTIONS(4930),
    [anon_sym_LPAREN] = ACTIONS(4930),
    [anon_sym_event] = ACTIONS(4928),
    [anon_sym_namespace] = ACTIONS(4928),
    [anon_sym_class] = ACTIONS(4928),
    [anon_sym_ref] = ACTIONS(4928),
    [anon_sym_struct] = ACTIONS(4928),
    [anon_sym_enum] = ACTIONS(4928),
    [anon_sym_RBRACE] = ACTIONS(4930),
    [anon_sym_interface] = ACTIONS(4928),
    [anon_sym_delegate] = ACTIONS(4928),
    [anon_sym_record] = ACTIONS(4928),
    [anon_sym_abstract] = ACTIONS(4928),
    [anon_sym_async] = ACTIONS(4928),
    [anon_sym_const] = ACTIONS(4928),
    [anon_sym_file] = ACTIONS(4928),
    [anon_sym_fixed] = ACTIONS(4928),
    [anon_sym_internal] = ACTIONS(4928),
    [anon_sym_new] = ACTIONS(4928),
    [anon_sym_override] = ACTIONS(4928),
    [anon_sym_partial] = ACTIONS(4928),
    [anon_sym_private] = ACTIONS(4928),
    [anon_sym_protected] = ACTIONS(4928),
    [anon_sym_public] = ACTIONS(4928),
    [anon_sym_readonly] = ACTIONS(4928),
    [anon_sym_required] = ACTIONS(4928),
    [anon_sym_sealed] = ACTIONS(4928),
    [anon_sym_virtual] = ACTIONS(4928),
    [anon_sym_volatile] = ACTIONS(4928),
    [anon_sym_where] = ACTIONS(4928),
    [anon_sym_notnull] = ACTIONS(4928),
    [anon_sym_unmanaged] = ACTIONS(4928),
    [anon_sym_TILDE] = ACTIONS(4930),
    [anon_sym_implicit] = ACTIONS(4928),
    [anon_sym_explicit] = ACTIONS(4928),
    [anon_sym_scoped] = ACTIONS(4928),
    [anon_sym_var] = ACTIONS(4928),
    [sym_predefined_type] = ACTIONS(4928),
    [anon_sym_yield] = ACTIONS(4928),
    [anon_sym_when] = ACTIONS(4928),
    [anon_sym_from] = ACTIONS(4928),
    [anon_sym_into] = ACTIONS(4928),
    [anon_sym_join] = ACTIONS(4928),
    [anon_sym_on] = ACTIONS(4928),
    [anon_sym_equals] = ACTIONS(4928),
    [anon_sym_let] = ACTIONS(4928),
    [anon_sym_orderby] = ACTIONS(4928),
    [anon_sym_ascending] = ACTIONS(4928),
    [anon_sym_descending] = ACTIONS(4928),
    [anon_sym_group] = ACTIONS(4928),
    [anon_sym_by] = ACTIONS(4928),
    [anon_sym_select] = ACTIONS(4928),
    [aux_sym_preproc_if_token1] = ACTIONS(4930),
    [aux_sym_preproc_if_token3] = ACTIONS(4930),
    [aux_sym_preproc_else_token1] = ACTIONS(4930),
    [aux_sym_preproc_elif_token1] = ACTIONS(4930),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3305] = {
    [sym_preproc_region] = STATE(3305),
    [sym_preproc_endregion] = STATE(3305),
    [sym_preproc_line] = STATE(3305),
    [sym_preproc_pragma] = STATE(3305),
    [sym_preproc_nullable] = STATE(3305),
    [sym_preproc_error] = STATE(3305),
    [sym_preproc_define] = STATE(3305),
    [sym_preproc_undef] = STATE(3305),
    [sym__identifier_token] = ACTIONS(3549),
    [anon_sym_extern] = ACTIONS(3549),
    [anon_sym_alias] = ACTIONS(3549),
    [anon_sym_global] = ACTIONS(3549),
    [anon_sym_using] = ACTIONS(3549),
    [anon_sym_unsafe] = ACTIONS(3549),
    [anon_sym_static] = ACTIONS(3549),
    [anon_sym_LBRACK] = ACTIONS(3551),
    [anon_sym_LPAREN] = ACTIONS(3551),
    [anon_sym_event] = ACTIONS(3549),
    [anon_sym_namespace] = ACTIONS(3549),
    [anon_sym_class] = ACTIONS(3549),
    [anon_sym_ref] = ACTIONS(3549),
    [anon_sym_struct] = ACTIONS(3549),
    [anon_sym_enum] = ACTIONS(3549),
    [anon_sym_RBRACE] = ACTIONS(3551),
    [anon_sym_interface] = ACTIONS(3549),
    [anon_sym_delegate] = ACTIONS(3549),
    [anon_sym_record] = ACTIONS(3549),
    [anon_sym_abstract] = ACTIONS(3549),
    [anon_sym_async] = ACTIONS(3549),
    [anon_sym_const] = ACTIONS(3549),
    [anon_sym_file] = ACTIONS(3549),
    [anon_sym_fixed] = ACTIONS(3549),
    [anon_sym_internal] = ACTIONS(3549),
    [anon_sym_new] = ACTIONS(3549),
    [anon_sym_override] = ACTIONS(3549),
    [anon_sym_partial] = ACTIONS(3549),
    [anon_sym_private] = ACTIONS(3549),
    [anon_sym_protected] = ACTIONS(3549),
    [anon_sym_public] = ACTIONS(3549),
    [anon_sym_readonly] = ACTIONS(3549),
    [anon_sym_required] = ACTIONS(3549),
    [anon_sym_sealed] = ACTIONS(3549),
    [anon_sym_virtual] = ACTIONS(3549),
    [anon_sym_volatile] = ACTIONS(3549),
    [anon_sym_where] = ACTIONS(3549),
    [anon_sym_notnull] = ACTIONS(3549),
    [anon_sym_unmanaged] = ACTIONS(3549),
    [anon_sym_TILDE] = ACTIONS(3551),
    [anon_sym_implicit] = ACTIONS(3549),
    [anon_sym_explicit] = ACTIONS(3549),
    [anon_sym_scoped] = ACTIONS(3549),
    [anon_sym_var] = ACTIONS(3549),
    [sym_predefined_type] = ACTIONS(3549),
    [anon_sym_yield] = ACTIONS(3549),
    [anon_sym_when] = ACTIONS(3549),
    [anon_sym_from] = ACTIONS(3549),
    [anon_sym_into] = ACTIONS(3549),
    [anon_sym_join] = ACTIONS(3549),
    [anon_sym_on] = ACTIONS(3549),
    [anon_sym_equals] = ACTIONS(3549),
    [anon_sym_let] = ACTIONS(3549),
    [anon_sym_orderby] = ACTIONS(3549),
    [anon_sym_ascending] = ACTIONS(3549),
    [anon_sym_descending] = ACTIONS(3549),
    [anon_sym_group] = ACTIONS(3549),
    [anon_sym_by] = ACTIONS(3549),
    [anon_sym_select] = ACTIONS(3549),
    [aux_sym_preproc_if_token1] = ACTIONS(3551),
    [aux_sym_preproc_if_token3] = ACTIONS(3551),
    [aux_sym_preproc_else_token1] = ACTIONS(3551),
    [aux_sym_preproc_elif_token1] = ACTIONS(3551),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3306] = {
    [sym_preproc_region] = STATE(3306),
    [sym_preproc_endregion] = STATE(3306),
    [sym_preproc_line] = STATE(3306),
    [sym_preproc_pragma] = STATE(3306),
    [sym_preproc_nullable] = STATE(3306),
    [sym_preproc_error] = STATE(3306),
    [sym_preproc_define] = STATE(3306),
    [sym_preproc_undef] = STATE(3306),
    [sym__identifier_token] = ACTIONS(3553),
    [anon_sym_extern] = ACTIONS(3553),
    [anon_sym_alias] = ACTIONS(3553),
    [anon_sym_global] = ACTIONS(3553),
    [anon_sym_using] = ACTIONS(3553),
    [anon_sym_unsafe] = ACTIONS(3553),
    [anon_sym_static] = ACTIONS(3553),
    [anon_sym_LBRACK] = ACTIONS(3555),
    [anon_sym_LPAREN] = ACTIONS(3555),
    [anon_sym_event] = ACTIONS(3553),
    [anon_sym_namespace] = ACTIONS(3553),
    [anon_sym_class] = ACTIONS(3553),
    [anon_sym_ref] = ACTIONS(3553),
    [anon_sym_struct] = ACTIONS(3553),
    [anon_sym_enum] = ACTIONS(3553),
    [anon_sym_RBRACE] = ACTIONS(3555),
    [anon_sym_interface] = ACTIONS(3553),
    [anon_sym_delegate] = ACTIONS(3553),
    [anon_sym_record] = ACTIONS(3553),
    [anon_sym_abstract] = ACTIONS(3553),
    [anon_sym_async] = ACTIONS(3553),
    [anon_sym_const] = ACTIONS(3553),
    [anon_sym_file] = ACTIONS(3553),
    [anon_sym_fixed] = ACTIONS(3553),
    [anon_sym_internal] = ACTIONS(3553),
    [anon_sym_new] = ACTIONS(3553),
    [anon_sym_override] = ACTIONS(3553),
    [anon_sym_partial] = ACTIONS(3553),
    [anon_sym_private] = ACTIONS(3553),
    [anon_sym_protected] = ACTIONS(3553),
    [anon_sym_public] = ACTIONS(3553),
    [anon_sym_readonly] = ACTIONS(3553),
    [anon_sym_required] = ACTIONS(3553),
    [anon_sym_sealed] = ACTIONS(3553),
    [anon_sym_virtual] = ACTIONS(3553),
    [anon_sym_volatile] = ACTIONS(3553),
    [anon_sym_where] = ACTIONS(3553),
    [anon_sym_notnull] = ACTIONS(3553),
    [anon_sym_unmanaged] = ACTIONS(3553),
    [anon_sym_TILDE] = ACTIONS(3555),
    [anon_sym_implicit] = ACTIONS(3553),
    [anon_sym_explicit] = ACTIONS(3553),
    [anon_sym_scoped] = ACTIONS(3553),
    [anon_sym_var] = ACTIONS(3553),
    [sym_predefined_type] = ACTIONS(3553),
    [anon_sym_yield] = ACTIONS(3553),
    [anon_sym_when] = ACTIONS(3553),
    [anon_sym_from] = ACTIONS(3553),
    [anon_sym_into] = ACTIONS(3553),
    [anon_sym_join] = ACTIONS(3553),
    [anon_sym_on] = ACTIONS(3553),
    [anon_sym_equals] = ACTIONS(3553),
    [anon_sym_let] = ACTIONS(3553),
    [anon_sym_orderby] = ACTIONS(3553),
    [anon_sym_ascending] = ACTIONS(3553),
    [anon_sym_descending] = ACTIONS(3553),
    [anon_sym_group] = ACTIONS(3553),
    [anon_sym_by] = ACTIONS(3553),
    [anon_sym_select] = ACTIONS(3553),
    [aux_sym_preproc_if_token1] = ACTIONS(3555),
    [aux_sym_preproc_if_token3] = ACTIONS(3555),
    [aux_sym_preproc_else_token1] = ACTIONS(3555),
    [aux_sym_preproc_elif_token1] = ACTIONS(3555),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3307] = {
    [sym_preproc_region] = STATE(3307),
    [sym_preproc_endregion] = STATE(3307),
    [sym_preproc_line] = STATE(3307),
    [sym_preproc_pragma] = STATE(3307),
    [sym_preproc_nullable] = STATE(3307),
    [sym_preproc_error] = STATE(3307),
    [sym_preproc_define] = STATE(3307),
    [sym_preproc_undef] = STATE(3307),
    [sym__identifier_token] = ACTIONS(3557),
    [anon_sym_extern] = ACTIONS(3557),
    [anon_sym_alias] = ACTIONS(3557),
    [anon_sym_global] = ACTIONS(3557),
    [anon_sym_using] = ACTIONS(3557),
    [anon_sym_unsafe] = ACTIONS(3557),
    [anon_sym_static] = ACTIONS(3557),
    [anon_sym_LBRACK] = ACTIONS(3559),
    [anon_sym_LPAREN] = ACTIONS(3559),
    [anon_sym_event] = ACTIONS(3557),
    [anon_sym_namespace] = ACTIONS(3557),
    [anon_sym_class] = ACTIONS(3557),
    [anon_sym_ref] = ACTIONS(3557),
    [anon_sym_struct] = ACTIONS(3557),
    [anon_sym_enum] = ACTIONS(3557),
    [anon_sym_RBRACE] = ACTIONS(3559),
    [anon_sym_interface] = ACTIONS(3557),
    [anon_sym_delegate] = ACTIONS(3557),
    [anon_sym_record] = ACTIONS(3557),
    [anon_sym_abstract] = ACTIONS(3557),
    [anon_sym_async] = ACTIONS(3557),
    [anon_sym_const] = ACTIONS(3557),
    [anon_sym_file] = ACTIONS(3557),
    [anon_sym_fixed] = ACTIONS(3557),
    [anon_sym_internal] = ACTIONS(3557),
    [anon_sym_new] = ACTIONS(3557),
    [anon_sym_override] = ACTIONS(3557),
    [anon_sym_partial] = ACTIONS(3557),
    [anon_sym_private] = ACTIONS(3557),
    [anon_sym_protected] = ACTIONS(3557),
    [anon_sym_public] = ACTIONS(3557),
    [anon_sym_readonly] = ACTIONS(3557),
    [anon_sym_required] = ACTIONS(3557),
    [anon_sym_sealed] = ACTIONS(3557),
    [anon_sym_virtual] = ACTIONS(3557),
    [anon_sym_volatile] = ACTIONS(3557),
    [anon_sym_where] = ACTIONS(3557),
    [anon_sym_notnull] = ACTIONS(3557),
    [anon_sym_unmanaged] = ACTIONS(3557),
    [anon_sym_TILDE] = ACTIONS(3559),
    [anon_sym_implicit] = ACTIONS(3557),
    [anon_sym_explicit] = ACTIONS(3557),
    [anon_sym_scoped] = ACTIONS(3557),
    [anon_sym_var] = ACTIONS(3557),
    [sym_predefined_type] = ACTIONS(3557),
    [anon_sym_yield] = ACTIONS(3557),
    [anon_sym_when] = ACTIONS(3557),
    [anon_sym_from] = ACTIONS(3557),
    [anon_sym_into] = ACTIONS(3557),
    [anon_sym_join] = ACTIONS(3557),
    [anon_sym_on] = ACTIONS(3557),
    [anon_sym_equals] = ACTIONS(3557),
    [anon_sym_let] = ACTIONS(3557),
    [anon_sym_orderby] = ACTIONS(3557),
    [anon_sym_ascending] = ACTIONS(3557),
    [anon_sym_descending] = ACTIONS(3557),
    [anon_sym_group] = ACTIONS(3557),
    [anon_sym_by] = ACTIONS(3557),
    [anon_sym_select] = ACTIONS(3557),
    [aux_sym_preproc_if_token1] = ACTIONS(3559),
    [aux_sym_preproc_if_token3] = ACTIONS(3559),
    [aux_sym_preproc_else_token1] = ACTIONS(3559),
    [aux_sym_preproc_elif_token1] = ACTIONS(3559),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3308] = {
    [sym_preproc_region] = STATE(3308),
    [sym_preproc_endregion] = STATE(3308),
    [sym_preproc_line] = STATE(3308),
    [sym_preproc_pragma] = STATE(3308),
    [sym_preproc_nullable] = STATE(3308),
    [sym_preproc_error] = STATE(3308),
    [sym_preproc_define] = STATE(3308),
    [sym_preproc_undef] = STATE(3308),
    [sym__identifier_token] = ACTIONS(4422),
    [anon_sym_alias] = ACTIONS(4422),
    [anon_sym_global] = ACTIONS(4422),
    [anon_sym_LBRACK] = ACTIONS(4547),
    [anon_sym_COLON] = ACTIONS(4424),
    [anon_sym_COMMA] = ACTIONS(4424),
    [anon_sym_LPAREN] = ACTIONS(4424),
    [anon_sym_LBRACE] = ACTIONS(4424),
    [anon_sym_file] = ACTIONS(4422),
    [anon_sym_LT] = ACTIONS(4422),
    [anon_sym_GT] = ACTIONS(4422),
    [anon_sym_where] = ACTIONS(4422),
    [anon_sym_QMARK] = ACTIONS(4932),
    [anon_sym_notnull] = ACTIONS(4422),
    [anon_sym_unmanaged] = ACTIONS(4422),
    [anon_sym_BANG] = ACTIONS(4422),
    [anon_sym_PLUS_PLUS] = ACTIONS(4424),
    [anon_sym_DASH_DASH] = ACTIONS(4424),
    [anon_sym_PLUS] = ACTIONS(4422),
    [anon_sym_DASH] = ACTIONS(4422),
    [anon_sym_STAR] = ACTIONS(4553),
    [anon_sym_SLASH] = ACTIONS(4422),
    [anon_sym_PERCENT] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4424),
    [anon_sym_PIPE] = ACTIONS(4422),
    [anon_sym_AMP] = ACTIONS(4422),
    [anon_sym_LT_LT] = ACTIONS(4424),
    [anon_sym_GT_GT] = ACTIONS(4422),
    [anon_sym_GT_GT_GT] = ACTIONS(4424),
    [anon_sym_EQ_EQ] = ACTIONS(4424),
    [anon_sym_BANG_EQ] = ACTIONS(4424),
    [anon_sym_GT_EQ] = ACTIONS(4424),
    [anon_sym_LT_EQ] = ACTIONS(4424),
    [anon_sym_DOT] = ACTIONS(4560),
    [anon_sym_scoped] = ACTIONS(4422),
    [anon_sym_var] = ACTIONS(4422),
    [anon_sym_yield] = ACTIONS(4422),
    [anon_sym_switch] = ACTIONS(4422),
    [anon_sym_when] = ACTIONS(4422),
    [sym_discard] = ACTIONS(4422),
    [anon_sym_DOT_DOT] = ACTIONS(4424),
    [anon_sym_and] = ACTIONS(4422),
    [anon_sym_or] = ACTIONS(4422),
    [anon_sym_AMP_AMP] = ACTIONS(4424),
    [anon_sym_PIPE_PIPE] = ACTIONS(4424),
    [anon_sym_QMARK_QMARK] = ACTIONS(4424),
    [anon_sym_from] = ACTIONS(4422),
    [anon_sym_into] = ACTIONS(4422),
    [anon_sym_join] = ACTIONS(4422),
    [anon_sym_on] = ACTIONS(4422),
    [anon_sym_equals] = ACTIONS(4422),
    [anon_sym_let] = ACTIONS(4422),
    [anon_sym_orderby] = ACTIONS(4422),
    [anon_sym_ascending] = ACTIONS(4422),
    [anon_sym_descending] = ACTIONS(4422),
    [anon_sym_group] = ACTIONS(4422),
    [anon_sym_by] = ACTIONS(4422),
    [anon_sym_select] = ACTIONS(4422),
    [anon_sym_as] = ACTIONS(4422),
    [anon_sym_is] = ACTIONS(4422),
    [anon_sym_DASH_GT] = ACTIONS(4562),
    [anon_sym_with] = ACTIONS(4422),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4424),
  },
  [3309] = {
    [sym_preproc_region] = STATE(3309),
    [sym_preproc_endregion] = STATE(3309),
    [sym_preproc_line] = STATE(3309),
    [sym_preproc_pragma] = STATE(3309),
    [sym_preproc_nullable] = STATE(3309),
    [sym_preproc_error] = STATE(3309),
    [sym_preproc_define] = STATE(3309),
    [sym_preproc_undef] = STATE(3309),
    [sym__identifier_token] = ACTIONS(3884),
    [anon_sym_extern] = ACTIONS(3884),
    [anon_sym_alias] = ACTIONS(3884),
    [anon_sym_global] = ACTIONS(3884),
    [anon_sym_using] = ACTIONS(3884),
    [anon_sym_unsafe] = ACTIONS(3884),
    [anon_sym_static] = ACTIONS(3884),
    [anon_sym_LBRACK] = ACTIONS(3886),
    [anon_sym_LPAREN] = ACTIONS(3886),
    [anon_sym_event] = ACTIONS(3884),
    [anon_sym_namespace] = ACTIONS(3884),
    [anon_sym_class] = ACTIONS(3884),
    [anon_sym_ref] = ACTIONS(3884),
    [anon_sym_struct] = ACTIONS(3884),
    [anon_sym_enum] = ACTIONS(3884),
    [anon_sym_RBRACE] = ACTIONS(3886),
    [anon_sym_interface] = ACTIONS(3884),
    [anon_sym_delegate] = ACTIONS(3884),
    [anon_sym_record] = ACTIONS(3884),
    [anon_sym_abstract] = ACTIONS(3884),
    [anon_sym_async] = ACTIONS(3884),
    [anon_sym_const] = ACTIONS(3884),
    [anon_sym_file] = ACTIONS(3884),
    [anon_sym_fixed] = ACTIONS(3884),
    [anon_sym_internal] = ACTIONS(3884),
    [anon_sym_new] = ACTIONS(3884),
    [anon_sym_override] = ACTIONS(3884),
    [anon_sym_partial] = ACTIONS(3884),
    [anon_sym_private] = ACTIONS(3884),
    [anon_sym_protected] = ACTIONS(3884),
    [anon_sym_public] = ACTIONS(3884),
    [anon_sym_readonly] = ACTIONS(3884),
    [anon_sym_required] = ACTIONS(3884),
    [anon_sym_sealed] = ACTIONS(3884),
    [anon_sym_virtual] = ACTIONS(3884),
    [anon_sym_volatile] = ACTIONS(3884),
    [anon_sym_where] = ACTIONS(3884),
    [anon_sym_notnull] = ACTIONS(3884),
    [anon_sym_unmanaged] = ACTIONS(3884),
    [anon_sym_TILDE] = ACTIONS(3886),
    [anon_sym_implicit] = ACTIONS(3884),
    [anon_sym_explicit] = ACTIONS(3884),
    [anon_sym_scoped] = ACTIONS(3884),
    [anon_sym_var] = ACTIONS(3884),
    [sym_predefined_type] = ACTIONS(3884),
    [anon_sym_yield] = ACTIONS(3884),
    [anon_sym_when] = ACTIONS(3884),
    [anon_sym_from] = ACTIONS(3884),
    [anon_sym_into] = ACTIONS(3884),
    [anon_sym_join] = ACTIONS(3884),
    [anon_sym_on] = ACTIONS(3884),
    [anon_sym_equals] = ACTIONS(3884),
    [anon_sym_let] = ACTIONS(3884),
    [anon_sym_orderby] = ACTIONS(3884),
    [anon_sym_ascending] = ACTIONS(3884),
    [anon_sym_descending] = ACTIONS(3884),
    [anon_sym_group] = ACTIONS(3884),
    [anon_sym_by] = ACTIONS(3884),
    [anon_sym_select] = ACTIONS(3884),
    [aux_sym_preproc_if_token1] = ACTIONS(3886),
    [aux_sym_preproc_if_token3] = ACTIONS(3886),
    [aux_sym_preproc_else_token1] = ACTIONS(3886),
    [aux_sym_preproc_elif_token1] = ACTIONS(3886),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3310] = {
    [sym_preproc_region] = STATE(3310),
    [sym_preproc_endregion] = STATE(3310),
    [sym_preproc_line] = STATE(3310),
    [sym_preproc_pragma] = STATE(3310),
    [sym_preproc_nullable] = STATE(3310),
    [sym_preproc_error] = STATE(3310),
    [sym_preproc_define] = STATE(3310),
    [sym_preproc_undef] = STATE(3310),
    [sym__identifier_token] = ACTIONS(4935),
    [anon_sym_extern] = ACTIONS(4935),
    [anon_sym_alias] = ACTIONS(4935),
    [anon_sym_global] = ACTIONS(4935),
    [anon_sym_using] = ACTIONS(4935),
    [anon_sym_unsafe] = ACTIONS(4935),
    [anon_sym_static] = ACTIONS(4935),
    [anon_sym_LBRACK] = ACTIONS(4937),
    [anon_sym_LPAREN] = ACTIONS(4937),
    [anon_sym_event] = ACTIONS(4935),
    [anon_sym_namespace] = ACTIONS(4935),
    [anon_sym_class] = ACTIONS(4935),
    [anon_sym_ref] = ACTIONS(4935),
    [anon_sym_struct] = ACTIONS(4935),
    [anon_sym_enum] = ACTIONS(4935),
    [anon_sym_RBRACE] = ACTIONS(4937),
    [anon_sym_interface] = ACTIONS(4935),
    [anon_sym_delegate] = ACTIONS(4935),
    [anon_sym_record] = ACTIONS(4935),
    [anon_sym_abstract] = ACTIONS(4935),
    [anon_sym_async] = ACTIONS(4935),
    [anon_sym_const] = ACTIONS(4935),
    [anon_sym_file] = ACTIONS(4935),
    [anon_sym_fixed] = ACTIONS(4935),
    [anon_sym_internal] = ACTIONS(4935),
    [anon_sym_new] = ACTIONS(4935),
    [anon_sym_override] = ACTIONS(4935),
    [anon_sym_partial] = ACTIONS(4935),
    [anon_sym_private] = ACTIONS(4935),
    [anon_sym_protected] = ACTIONS(4935),
    [anon_sym_public] = ACTIONS(4935),
    [anon_sym_readonly] = ACTIONS(4935),
    [anon_sym_required] = ACTIONS(4935),
    [anon_sym_sealed] = ACTIONS(4935),
    [anon_sym_virtual] = ACTIONS(4935),
    [anon_sym_volatile] = ACTIONS(4935),
    [anon_sym_where] = ACTIONS(4935),
    [anon_sym_notnull] = ACTIONS(4935),
    [anon_sym_unmanaged] = ACTIONS(4935),
    [anon_sym_TILDE] = ACTIONS(4937),
    [anon_sym_implicit] = ACTIONS(4935),
    [anon_sym_explicit] = ACTIONS(4935),
    [anon_sym_scoped] = ACTIONS(4935),
    [anon_sym_var] = ACTIONS(4935),
    [sym_predefined_type] = ACTIONS(4935),
    [anon_sym_yield] = ACTIONS(4935),
    [anon_sym_when] = ACTIONS(4935),
    [anon_sym_from] = ACTIONS(4935),
    [anon_sym_into] = ACTIONS(4935),
    [anon_sym_join] = ACTIONS(4935),
    [anon_sym_on] = ACTIONS(4935),
    [anon_sym_equals] = ACTIONS(4935),
    [anon_sym_let] = ACTIONS(4935),
    [anon_sym_orderby] = ACTIONS(4935),
    [anon_sym_ascending] = ACTIONS(4935),
    [anon_sym_descending] = ACTIONS(4935),
    [anon_sym_group] = ACTIONS(4935),
    [anon_sym_by] = ACTIONS(4935),
    [anon_sym_select] = ACTIONS(4935),
    [aux_sym_preproc_if_token1] = ACTIONS(4937),
    [aux_sym_preproc_if_token3] = ACTIONS(4937),
    [aux_sym_preproc_else_token1] = ACTIONS(4937),
    [aux_sym_preproc_elif_token1] = ACTIONS(4937),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3311] = {
    [sym_preproc_region] = STATE(3311),
    [sym_preproc_endregion] = STATE(3311),
    [sym_preproc_line] = STATE(3311),
    [sym_preproc_pragma] = STATE(3311),
    [sym_preproc_nullable] = STATE(3311),
    [sym_preproc_error] = STATE(3311),
    [sym_preproc_define] = STATE(3311),
    [sym_preproc_undef] = STATE(3311),
    [sym__identifier_token] = ACTIONS(4939),
    [anon_sym_extern] = ACTIONS(4939),
    [anon_sym_alias] = ACTIONS(4939),
    [anon_sym_global] = ACTIONS(4939),
    [anon_sym_using] = ACTIONS(4939),
    [anon_sym_unsafe] = ACTIONS(4939),
    [anon_sym_static] = ACTIONS(4939),
    [anon_sym_LBRACK] = ACTIONS(4941),
    [anon_sym_LPAREN] = ACTIONS(4941),
    [anon_sym_event] = ACTIONS(4939),
    [anon_sym_namespace] = ACTIONS(4939),
    [anon_sym_class] = ACTIONS(4939),
    [anon_sym_ref] = ACTIONS(4939),
    [anon_sym_struct] = ACTIONS(4939),
    [anon_sym_enum] = ACTIONS(4939),
    [anon_sym_RBRACE] = ACTIONS(4941),
    [anon_sym_interface] = ACTIONS(4939),
    [anon_sym_delegate] = ACTIONS(4939),
    [anon_sym_record] = ACTIONS(4939),
    [anon_sym_abstract] = ACTIONS(4939),
    [anon_sym_async] = ACTIONS(4939),
    [anon_sym_const] = ACTIONS(4939),
    [anon_sym_file] = ACTIONS(4939),
    [anon_sym_fixed] = ACTIONS(4939),
    [anon_sym_internal] = ACTIONS(4939),
    [anon_sym_new] = ACTIONS(4939),
    [anon_sym_override] = ACTIONS(4939),
    [anon_sym_partial] = ACTIONS(4939),
    [anon_sym_private] = ACTIONS(4939),
    [anon_sym_protected] = ACTIONS(4939),
    [anon_sym_public] = ACTIONS(4939),
    [anon_sym_readonly] = ACTIONS(4939),
    [anon_sym_required] = ACTIONS(4939),
    [anon_sym_sealed] = ACTIONS(4939),
    [anon_sym_virtual] = ACTIONS(4939),
    [anon_sym_volatile] = ACTIONS(4939),
    [anon_sym_where] = ACTIONS(4939),
    [anon_sym_notnull] = ACTIONS(4939),
    [anon_sym_unmanaged] = ACTIONS(4939),
    [anon_sym_TILDE] = ACTIONS(4941),
    [anon_sym_implicit] = ACTIONS(4939),
    [anon_sym_explicit] = ACTIONS(4939),
    [anon_sym_scoped] = ACTIONS(4939),
    [anon_sym_var] = ACTIONS(4939),
    [sym_predefined_type] = ACTIONS(4939),
    [anon_sym_yield] = ACTIONS(4939),
    [anon_sym_when] = ACTIONS(4939),
    [anon_sym_from] = ACTIONS(4939),
    [anon_sym_into] = ACTIONS(4939),
    [anon_sym_join] = ACTIONS(4939),
    [anon_sym_on] = ACTIONS(4939),
    [anon_sym_equals] = ACTIONS(4939),
    [anon_sym_let] = ACTIONS(4939),
    [anon_sym_orderby] = ACTIONS(4939),
    [anon_sym_ascending] = ACTIONS(4939),
    [anon_sym_descending] = ACTIONS(4939),
    [anon_sym_group] = ACTIONS(4939),
    [anon_sym_by] = ACTIONS(4939),
    [anon_sym_select] = ACTIONS(4939),
    [aux_sym_preproc_if_token1] = ACTIONS(4941),
    [aux_sym_preproc_if_token3] = ACTIONS(4941),
    [aux_sym_preproc_else_token1] = ACTIONS(4941),
    [aux_sym_preproc_elif_token1] = ACTIONS(4941),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3312] = {
    [sym_preproc_region] = STATE(3312),
    [sym_preproc_endregion] = STATE(3312),
    [sym_preproc_line] = STATE(3312),
    [sym_preproc_pragma] = STATE(3312),
    [sym_preproc_nullable] = STATE(3312),
    [sym_preproc_error] = STATE(3312),
    [sym_preproc_define] = STATE(3312),
    [sym_preproc_undef] = STATE(3312),
    [sym__identifier_token] = ACTIONS(3565),
    [anon_sym_extern] = ACTIONS(3565),
    [anon_sym_alias] = ACTIONS(3565),
    [anon_sym_global] = ACTIONS(3565),
    [anon_sym_using] = ACTIONS(3565),
    [anon_sym_unsafe] = ACTIONS(3565),
    [anon_sym_static] = ACTIONS(3565),
    [anon_sym_LBRACK] = ACTIONS(3567),
    [anon_sym_LPAREN] = ACTIONS(3567),
    [anon_sym_event] = ACTIONS(3565),
    [anon_sym_namespace] = ACTIONS(3565),
    [anon_sym_class] = ACTIONS(3565),
    [anon_sym_ref] = ACTIONS(3565),
    [anon_sym_struct] = ACTIONS(3565),
    [anon_sym_enum] = ACTIONS(3565),
    [anon_sym_RBRACE] = ACTIONS(3567),
    [anon_sym_interface] = ACTIONS(3565),
    [anon_sym_delegate] = ACTIONS(3565),
    [anon_sym_record] = ACTIONS(3565),
    [anon_sym_abstract] = ACTIONS(3565),
    [anon_sym_async] = ACTIONS(3565),
    [anon_sym_const] = ACTIONS(3565),
    [anon_sym_file] = ACTIONS(3565),
    [anon_sym_fixed] = ACTIONS(3565),
    [anon_sym_internal] = ACTIONS(3565),
    [anon_sym_new] = ACTIONS(3565),
    [anon_sym_override] = ACTIONS(3565),
    [anon_sym_partial] = ACTIONS(3565),
    [anon_sym_private] = ACTIONS(3565),
    [anon_sym_protected] = ACTIONS(3565),
    [anon_sym_public] = ACTIONS(3565),
    [anon_sym_readonly] = ACTIONS(3565),
    [anon_sym_required] = ACTIONS(3565),
    [anon_sym_sealed] = ACTIONS(3565),
    [anon_sym_virtual] = ACTIONS(3565),
    [anon_sym_volatile] = ACTIONS(3565),
    [anon_sym_where] = ACTIONS(3565),
    [anon_sym_notnull] = ACTIONS(3565),
    [anon_sym_unmanaged] = ACTIONS(3565),
    [anon_sym_TILDE] = ACTIONS(3567),
    [anon_sym_implicit] = ACTIONS(3565),
    [anon_sym_explicit] = ACTIONS(3565),
    [anon_sym_scoped] = ACTIONS(3565),
    [anon_sym_var] = ACTIONS(3565),
    [sym_predefined_type] = ACTIONS(3565),
    [anon_sym_yield] = ACTIONS(3565),
    [anon_sym_when] = ACTIONS(3565),
    [anon_sym_from] = ACTIONS(3565),
    [anon_sym_into] = ACTIONS(3565),
    [anon_sym_join] = ACTIONS(3565),
    [anon_sym_on] = ACTIONS(3565),
    [anon_sym_equals] = ACTIONS(3565),
    [anon_sym_let] = ACTIONS(3565),
    [anon_sym_orderby] = ACTIONS(3565),
    [anon_sym_ascending] = ACTIONS(3565),
    [anon_sym_descending] = ACTIONS(3565),
    [anon_sym_group] = ACTIONS(3565),
    [anon_sym_by] = ACTIONS(3565),
    [anon_sym_select] = ACTIONS(3565),
    [aux_sym_preproc_if_token1] = ACTIONS(3567),
    [aux_sym_preproc_if_token3] = ACTIONS(3567),
    [aux_sym_preproc_else_token1] = ACTIONS(3567),
    [aux_sym_preproc_elif_token1] = ACTIONS(3567),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3313] = {
    [sym_preproc_region] = STATE(3313),
    [sym_preproc_endregion] = STATE(3313),
    [sym_preproc_line] = STATE(3313),
    [sym_preproc_pragma] = STATE(3313),
    [sym_preproc_nullable] = STATE(3313),
    [sym_preproc_error] = STATE(3313),
    [sym_preproc_define] = STATE(3313),
    [sym_preproc_undef] = STATE(3313),
    [sym__identifier_token] = ACTIONS(3573),
    [anon_sym_extern] = ACTIONS(3573),
    [anon_sym_alias] = ACTIONS(3573),
    [anon_sym_global] = ACTIONS(3573),
    [anon_sym_using] = ACTIONS(3573),
    [anon_sym_unsafe] = ACTIONS(3573),
    [anon_sym_static] = ACTIONS(3573),
    [anon_sym_LBRACK] = ACTIONS(3575),
    [anon_sym_LPAREN] = ACTIONS(3575),
    [anon_sym_event] = ACTIONS(3573),
    [anon_sym_namespace] = ACTIONS(3573),
    [anon_sym_class] = ACTIONS(3573),
    [anon_sym_ref] = ACTIONS(3573),
    [anon_sym_struct] = ACTIONS(3573),
    [anon_sym_enum] = ACTIONS(3573),
    [anon_sym_RBRACE] = ACTIONS(3575),
    [anon_sym_interface] = ACTIONS(3573),
    [anon_sym_delegate] = ACTIONS(3573),
    [anon_sym_record] = ACTIONS(3573),
    [anon_sym_abstract] = ACTIONS(3573),
    [anon_sym_async] = ACTIONS(3573),
    [anon_sym_const] = ACTIONS(3573),
    [anon_sym_file] = ACTIONS(3573),
    [anon_sym_fixed] = ACTIONS(3573),
    [anon_sym_internal] = ACTIONS(3573),
    [anon_sym_new] = ACTIONS(3573),
    [anon_sym_override] = ACTIONS(3573),
    [anon_sym_partial] = ACTIONS(3573),
    [anon_sym_private] = ACTIONS(3573),
    [anon_sym_protected] = ACTIONS(3573),
    [anon_sym_public] = ACTIONS(3573),
    [anon_sym_readonly] = ACTIONS(3573),
    [anon_sym_required] = ACTIONS(3573),
    [anon_sym_sealed] = ACTIONS(3573),
    [anon_sym_virtual] = ACTIONS(3573),
    [anon_sym_volatile] = ACTIONS(3573),
    [anon_sym_where] = ACTIONS(3573),
    [anon_sym_notnull] = ACTIONS(3573),
    [anon_sym_unmanaged] = ACTIONS(3573),
    [anon_sym_TILDE] = ACTIONS(3575),
    [anon_sym_implicit] = ACTIONS(3573),
    [anon_sym_explicit] = ACTIONS(3573),
    [anon_sym_scoped] = ACTIONS(3573),
    [anon_sym_var] = ACTIONS(3573),
    [sym_predefined_type] = ACTIONS(3573),
    [anon_sym_yield] = ACTIONS(3573),
    [anon_sym_when] = ACTIONS(3573),
    [anon_sym_from] = ACTIONS(3573),
    [anon_sym_into] = ACTIONS(3573),
    [anon_sym_join] = ACTIONS(3573),
    [anon_sym_on] = ACTIONS(3573),
    [anon_sym_equals] = ACTIONS(3573),
    [anon_sym_let] = ACTIONS(3573),
    [anon_sym_orderby] = ACTIONS(3573),
    [anon_sym_ascending] = ACTIONS(3573),
    [anon_sym_descending] = ACTIONS(3573),
    [anon_sym_group] = ACTIONS(3573),
    [anon_sym_by] = ACTIONS(3573),
    [anon_sym_select] = ACTIONS(3573),
    [aux_sym_preproc_if_token1] = ACTIONS(3575),
    [aux_sym_preproc_if_token3] = ACTIONS(3575),
    [aux_sym_preproc_else_token1] = ACTIONS(3575),
    [aux_sym_preproc_elif_token1] = ACTIONS(3575),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3314] = {
    [sym_preproc_region] = STATE(3314),
    [sym_preproc_endregion] = STATE(3314),
    [sym_preproc_line] = STATE(3314),
    [sym_preproc_pragma] = STATE(3314),
    [sym_preproc_nullable] = STATE(3314),
    [sym_preproc_error] = STATE(3314),
    [sym_preproc_define] = STATE(3314),
    [sym_preproc_undef] = STATE(3314),
    [sym__identifier_token] = ACTIONS(4074),
    [anon_sym_alias] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4076),
    [anon_sym_COLON] = ACTIONS(4076),
    [anon_sym_COMMA] = ACTIONS(4076),
    [anon_sym_LPAREN] = ACTIONS(4076),
    [anon_sym_LBRACE] = ACTIONS(4076),
    [anon_sym_file] = ACTIONS(4074),
    [anon_sym_LT] = ACTIONS(4074),
    [anon_sym_GT] = ACTIONS(4074),
    [anon_sym_where] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(4074),
    [anon_sym_notnull] = ACTIONS(4074),
    [anon_sym_unmanaged] = ACTIONS(4074),
    [anon_sym_BANG] = ACTIONS(4074),
    [anon_sym_PLUS_PLUS] = ACTIONS(4076),
    [anon_sym_DASH_DASH] = ACTIONS(4076),
    [anon_sym_PLUS] = ACTIONS(4074),
    [anon_sym_DASH] = ACTIONS(4074),
    [anon_sym_STAR] = ACTIONS(4076),
    [anon_sym_SLASH] = ACTIONS(4074),
    [anon_sym_PERCENT] = ACTIONS(4076),
    [anon_sym_CARET] = ACTIONS(4076),
    [anon_sym_PIPE] = ACTIONS(4074),
    [anon_sym_AMP] = ACTIONS(4074),
    [anon_sym_LT_LT] = ACTIONS(4076),
    [anon_sym_GT_GT] = ACTIONS(4074),
    [anon_sym_GT_GT_GT] = ACTIONS(4076),
    [anon_sym_EQ_EQ] = ACTIONS(4076),
    [anon_sym_BANG_EQ] = ACTIONS(4076),
    [anon_sym_GT_EQ] = ACTIONS(4076),
    [anon_sym_LT_EQ] = ACTIONS(4076),
    [anon_sym_DOT] = ACTIONS(4074),
    [anon_sym_scoped] = ACTIONS(4074),
    [anon_sym_var] = ACTIONS(4074),
    [anon_sym_yield] = ACTIONS(4074),
    [anon_sym_switch] = ACTIONS(4074),
    [anon_sym_when] = ACTIONS(4074),
    [sym_discard] = ACTIONS(4074),
    [anon_sym_DOT_DOT] = ACTIONS(4076),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_AMP_AMP] = ACTIONS(4076),
    [anon_sym_PIPE_PIPE] = ACTIONS(4076),
    [anon_sym_QMARK_QMARK] = ACTIONS(4076),
    [anon_sym_from] = ACTIONS(4074),
    [anon_sym_into] = ACTIONS(4074),
    [anon_sym_join] = ACTIONS(4074),
    [anon_sym_on] = ACTIONS(4074),
    [anon_sym_equals] = ACTIONS(4074),
    [anon_sym_let] = ACTIONS(4074),
    [anon_sym_orderby] = ACTIONS(4074),
    [anon_sym_ascending] = ACTIONS(4074),
    [anon_sym_descending] = ACTIONS(4074),
    [anon_sym_group] = ACTIONS(4074),
    [anon_sym_by] = ACTIONS(4074),
    [anon_sym_select] = ACTIONS(4074),
    [anon_sym_as] = ACTIONS(4074),
    [anon_sym_is] = ACTIONS(4074),
    [anon_sym_DASH_GT] = ACTIONS(4076),
    [anon_sym_with] = ACTIONS(4074),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4076),
  },
  [3315] = {
    [sym_preproc_region] = STATE(3315),
    [sym_preproc_endregion] = STATE(3315),
    [sym_preproc_line] = STATE(3315),
    [sym_preproc_pragma] = STATE(3315),
    [sym_preproc_nullable] = STATE(3315),
    [sym_preproc_error] = STATE(3315),
    [sym_preproc_define] = STATE(3315),
    [sym_preproc_undef] = STATE(3315),
    [sym__identifier_token] = ACTIONS(4943),
    [anon_sym_extern] = ACTIONS(4943),
    [anon_sym_alias] = ACTIONS(4943),
    [anon_sym_global] = ACTIONS(4943),
    [anon_sym_using] = ACTIONS(4943),
    [anon_sym_unsafe] = ACTIONS(4943),
    [anon_sym_static] = ACTIONS(4943),
    [anon_sym_LBRACK] = ACTIONS(4945),
    [anon_sym_LPAREN] = ACTIONS(4945),
    [anon_sym_event] = ACTIONS(4943),
    [anon_sym_namespace] = ACTIONS(4943),
    [anon_sym_class] = ACTIONS(4943),
    [anon_sym_ref] = ACTIONS(4943),
    [anon_sym_struct] = ACTIONS(4943),
    [anon_sym_enum] = ACTIONS(4943),
    [anon_sym_RBRACE] = ACTIONS(4945),
    [anon_sym_interface] = ACTIONS(4943),
    [anon_sym_delegate] = ACTIONS(4943),
    [anon_sym_record] = ACTIONS(4943),
    [anon_sym_abstract] = ACTIONS(4943),
    [anon_sym_async] = ACTIONS(4943),
    [anon_sym_const] = ACTIONS(4943),
    [anon_sym_file] = ACTIONS(4943),
    [anon_sym_fixed] = ACTIONS(4943),
    [anon_sym_internal] = ACTIONS(4943),
    [anon_sym_new] = ACTIONS(4943),
    [anon_sym_override] = ACTIONS(4943),
    [anon_sym_partial] = ACTIONS(4943),
    [anon_sym_private] = ACTIONS(4943),
    [anon_sym_protected] = ACTIONS(4943),
    [anon_sym_public] = ACTIONS(4943),
    [anon_sym_readonly] = ACTIONS(4943),
    [anon_sym_required] = ACTIONS(4943),
    [anon_sym_sealed] = ACTIONS(4943),
    [anon_sym_virtual] = ACTIONS(4943),
    [anon_sym_volatile] = ACTIONS(4943),
    [anon_sym_where] = ACTIONS(4943),
    [anon_sym_notnull] = ACTIONS(4943),
    [anon_sym_unmanaged] = ACTIONS(4943),
    [anon_sym_TILDE] = ACTIONS(4945),
    [anon_sym_implicit] = ACTIONS(4943),
    [anon_sym_explicit] = ACTIONS(4943),
    [anon_sym_scoped] = ACTIONS(4943),
    [anon_sym_var] = ACTIONS(4943),
    [sym_predefined_type] = ACTIONS(4943),
    [anon_sym_yield] = ACTIONS(4943),
    [anon_sym_when] = ACTIONS(4943),
    [anon_sym_from] = ACTIONS(4943),
    [anon_sym_into] = ACTIONS(4943),
    [anon_sym_join] = ACTIONS(4943),
    [anon_sym_on] = ACTIONS(4943),
    [anon_sym_equals] = ACTIONS(4943),
    [anon_sym_let] = ACTIONS(4943),
    [anon_sym_orderby] = ACTIONS(4943),
    [anon_sym_ascending] = ACTIONS(4943),
    [anon_sym_descending] = ACTIONS(4943),
    [anon_sym_group] = ACTIONS(4943),
    [anon_sym_by] = ACTIONS(4943),
    [anon_sym_select] = ACTIONS(4943),
    [aux_sym_preproc_if_token1] = ACTIONS(4945),
    [aux_sym_preproc_if_token3] = ACTIONS(4945),
    [aux_sym_preproc_else_token1] = ACTIONS(4945),
    [aux_sym_preproc_elif_token1] = ACTIONS(4945),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3316] = {
    [sym_preproc_region] = STATE(3316),
    [sym_preproc_endregion] = STATE(3316),
    [sym_preproc_line] = STATE(3316),
    [sym_preproc_pragma] = STATE(3316),
    [sym_preproc_nullable] = STATE(3316),
    [sym_preproc_error] = STATE(3316),
    [sym_preproc_define] = STATE(3316),
    [sym_preproc_undef] = STATE(3316),
    [sym__identifier_token] = ACTIONS(4947),
    [anon_sym_extern] = ACTIONS(4947),
    [anon_sym_alias] = ACTIONS(4947),
    [anon_sym_global] = ACTIONS(4947),
    [anon_sym_using] = ACTIONS(4947),
    [anon_sym_unsafe] = ACTIONS(4947),
    [anon_sym_static] = ACTIONS(4947),
    [anon_sym_LBRACK] = ACTIONS(4949),
    [anon_sym_LPAREN] = ACTIONS(4949),
    [anon_sym_event] = ACTIONS(4947),
    [anon_sym_namespace] = ACTIONS(4947),
    [anon_sym_class] = ACTIONS(4947),
    [anon_sym_ref] = ACTIONS(4947),
    [anon_sym_struct] = ACTIONS(4947),
    [anon_sym_enum] = ACTIONS(4947),
    [anon_sym_RBRACE] = ACTIONS(4949),
    [anon_sym_interface] = ACTIONS(4947),
    [anon_sym_delegate] = ACTIONS(4947),
    [anon_sym_record] = ACTIONS(4947),
    [anon_sym_abstract] = ACTIONS(4947),
    [anon_sym_async] = ACTIONS(4947),
    [anon_sym_const] = ACTIONS(4947),
    [anon_sym_file] = ACTIONS(4947),
    [anon_sym_fixed] = ACTIONS(4947),
    [anon_sym_internal] = ACTIONS(4947),
    [anon_sym_new] = ACTIONS(4947),
    [anon_sym_override] = ACTIONS(4947),
    [anon_sym_partial] = ACTIONS(4947),
    [anon_sym_private] = ACTIONS(4947),
    [anon_sym_protected] = ACTIONS(4947),
    [anon_sym_public] = ACTIONS(4947),
    [anon_sym_readonly] = ACTIONS(4947),
    [anon_sym_required] = ACTIONS(4947),
    [anon_sym_sealed] = ACTIONS(4947),
    [anon_sym_virtual] = ACTIONS(4947),
    [anon_sym_volatile] = ACTIONS(4947),
    [anon_sym_where] = ACTIONS(4947),
    [anon_sym_notnull] = ACTIONS(4947),
    [anon_sym_unmanaged] = ACTIONS(4947),
    [anon_sym_TILDE] = ACTIONS(4949),
    [anon_sym_implicit] = ACTIONS(4947),
    [anon_sym_explicit] = ACTIONS(4947),
    [anon_sym_scoped] = ACTIONS(4947),
    [anon_sym_var] = ACTIONS(4947),
    [sym_predefined_type] = ACTIONS(4947),
    [anon_sym_yield] = ACTIONS(4947),
    [anon_sym_when] = ACTIONS(4947),
    [anon_sym_from] = ACTIONS(4947),
    [anon_sym_into] = ACTIONS(4947),
    [anon_sym_join] = ACTIONS(4947),
    [anon_sym_on] = ACTIONS(4947),
    [anon_sym_equals] = ACTIONS(4947),
    [anon_sym_let] = ACTIONS(4947),
    [anon_sym_orderby] = ACTIONS(4947),
    [anon_sym_ascending] = ACTIONS(4947),
    [anon_sym_descending] = ACTIONS(4947),
    [anon_sym_group] = ACTIONS(4947),
    [anon_sym_by] = ACTIONS(4947),
    [anon_sym_select] = ACTIONS(4947),
    [aux_sym_preproc_if_token1] = ACTIONS(4949),
    [aux_sym_preproc_if_token3] = ACTIONS(4949),
    [aux_sym_preproc_else_token1] = ACTIONS(4949),
    [aux_sym_preproc_elif_token1] = ACTIONS(4949),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3317] = {
    [sym_preproc_region] = STATE(3317),
    [sym_preproc_endregion] = STATE(3317),
    [sym_preproc_line] = STATE(3317),
    [sym_preproc_pragma] = STATE(3317),
    [sym_preproc_nullable] = STATE(3317),
    [sym_preproc_error] = STATE(3317),
    [sym_preproc_define] = STATE(3317),
    [sym_preproc_undef] = STATE(3317),
    [sym__identifier_token] = ACTIONS(4066),
    [anon_sym_alias] = ACTIONS(4066),
    [anon_sym_global] = ACTIONS(4066),
    [anon_sym_LBRACK] = ACTIONS(4068),
    [anon_sym_COLON] = ACTIONS(4068),
    [anon_sym_COMMA] = ACTIONS(4068),
    [anon_sym_LPAREN] = ACTIONS(4068),
    [anon_sym_LBRACE] = ACTIONS(4068),
    [anon_sym_file] = ACTIONS(4066),
    [anon_sym_LT] = ACTIONS(4066),
    [anon_sym_GT] = ACTIONS(4066),
    [anon_sym_where] = ACTIONS(4066),
    [anon_sym_QMARK] = ACTIONS(4066),
    [anon_sym_notnull] = ACTIONS(4066),
    [anon_sym_unmanaged] = ACTIONS(4066),
    [anon_sym_BANG] = ACTIONS(4066),
    [anon_sym_PLUS_PLUS] = ACTIONS(4068),
    [anon_sym_DASH_DASH] = ACTIONS(4068),
    [anon_sym_PLUS] = ACTIONS(4066),
    [anon_sym_DASH] = ACTIONS(4066),
    [anon_sym_STAR] = ACTIONS(4068),
    [anon_sym_SLASH] = ACTIONS(4066),
    [anon_sym_PERCENT] = ACTIONS(4068),
    [anon_sym_CARET] = ACTIONS(4068),
    [anon_sym_PIPE] = ACTIONS(4066),
    [anon_sym_AMP] = ACTIONS(4066),
    [anon_sym_LT_LT] = ACTIONS(4068),
    [anon_sym_GT_GT] = ACTIONS(4066),
    [anon_sym_GT_GT_GT] = ACTIONS(4068),
    [anon_sym_EQ_EQ] = ACTIONS(4068),
    [anon_sym_BANG_EQ] = ACTIONS(4068),
    [anon_sym_GT_EQ] = ACTIONS(4068),
    [anon_sym_LT_EQ] = ACTIONS(4068),
    [anon_sym_DOT] = ACTIONS(4066),
    [anon_sym_scoped] = ACTIONS(4066),
    [anon_sym_var] = ACTIONS(4066),
    [anon_sym_yield] = ACTIONS(4066),
    [anon_sym_switch] = ACTIONS(4066),
    [anon_sym_when] = ACTIONS(4066),
    [sym_discard] = ACTIONS(4066),
    [anon_sym_DOT_DOT] = ACTIONS(4068),
    [anon_sym_and] = ACTIONS(4066),
    [anon_sym_or] = ACTIONS(4066),
    [anon_sym_AMP_AMP] = ACTIONS(4068),
    [anon_sym_PIPE_PIPE] = ACTIONS(4068),
    [anon_sym_QMARK_QMARK] = ACTIONS(4068),
    [anon_sym_from] = ACTIONS(4066),
    [anon_sym_into] = ACTIONS(4066),
    [anon_sym_join] = ACTIONS(4066),
    [anon_sym_on] = ACTIONS(4066),
    [anon_sym_equals] = ACTIONS(4066),
    [anon_sym_let] = ACTIONS(4066),
    [anon_sym_orderby] = ACTIONS(4066),
    [anon_sym_ascending] = ACTIONS(4066),
    [anon_sym_descending] = ACTIONS(4066),
    [anon_sym_group] = ACTIONS(4066),
    [anon_sym_by] = ACTIONS(4066),
    [anon_sym_select] = ACTIONS(4066),
    [anon_sym_as] = ACTIONS(4066),
    [anon_sym_is] = ACTIONS(4066),
    [anon_sym_DASH_GT] = ACTIONS(4068),
    [anon_sym_with] = ACTIONS(4066),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4068),
  },
  [3318] = {
    [sym_preproc_region] = STATE(3318),
    [sym_preproc_endregion] = STATE(3318),
    [sym_preproc_line] = STATE(3318),
    [sym_preproc_pragma] = STATE(3318),
    [sym_preproc_nullable] = STATE(3318),
    [sym_preproc_error] = STATE(3318),
    [sym_preproc_define] = STATE(3318),
    [sym_preproc_undef] = STATE(3318),
    [sym__identifier_token] = ACTIONS(3888),
    [anon_sym_extern] = ACTIONS(3888),
    [anon_sym_alias] = ACTIONS(3888),
    [anon_sym_global] = ACTIONS(3888),
    [anon_sym_using] = ACTIONS(3888),
    [anon_sym_unsafe] = ACTIONS(3888),
    [anon_sym_static] = ACTIONS(3888),
    [anon_sym_LBRACK] = ACTIONS(3890),
    [anon_sym_LPAREN] = ACTIONS(3890),
    [anon_sym_event] = ACTIONS(3888),
    [anon_sym_namespace] = ACTIONS(3888),
    [anon_sym_class] = ACTIONS(3888),
    [anon_sym_ref] = ACTIONS(3888),
    [anon_sym_struct] = ACTIONS(3888),
    [anon_sym_enum] = ACTIONS(3888),
    [anon_sym_RBRACE] = ACTIONS(3890),
    [anon_sym_interface] = ACTIONS(3888),
    [anon_sym_delegate] = ACTIONS(3888),
    [anon_sym_record] = ACTIONS(3888),
    [anon_sym_abstract] = ACTIONS(3888),
    [anon_sym_async] = ACTIONS(3888),
    [anon_sym_const] = ACTIONS(3888),
    [anon_sym_file] = ACTIONS(3888),
    [anon_sym_fixed] = ACTIONS(3888),
    [anon_sym_internal] = ACTIONS(3888),
    [anon_sym_new] = ACTIONS(3888),
    [anon_sym_override] = ACTIONS(3888),
    [anon_sym_partial] = ACTIONS(3888),
    [anon_sym_private] = ACTIONS(3888),
    [anon_sym_protected] = ACTIONS(3888),
    [anon_sym_public] = ACTIONS(3888),
    [anon_sym_readonly] = ACTIONS(3888),
    [anon_sym_required] = ACTIONS(3888),
    [anon_sym_sealed] = ACTIONS(3888),
    [anon_sym_virtual] = ACTIONS(3888),
    [anon_sym_volatile] = ACTIONS(3888),
    [anon_sym_where] = ACTIONS(3888),
    [anon_sym_notnull] = ACTIONS(3888),
    [anon_sym_unmanaged] = ACTIONS(3888),
    [anon_sym_TILDE] = ACTIONS(3890),
    [anon_sym_implicit] = ACTIONS(3888),
    [anon_sym_explicit] = ACTIONS(3888),
    [anon_sym_scoped] = ACTIONS(3888),
    [anon_sym_var] = ACTIONS(3888),
    [sym_predefined_type] = ACTIONS(3888),
    [anon_sym_yield] = ACTIONS(3888),
    [anon_sym_when] = ACTIONS(3888),
    [anon_sym_from] = ACTIONS(3888),
    [anon_sym_into] = ACTIONS(3888),
    [anon_sym_join] = ACTIONS(3888),
    [anon_sym_on] = ACTIONS(3888),
    [anon_sym_equals] = ACTIONS(3888),
    [anon_sym_let] = ACTIONS(3888),
    [anon_sym_orderby] = ACTIONS(3888),
    [anon_sym_ascending] = ACTIONS(3888),
    [anon_sym_descending] = ACTIONS(3888),
    [anon_sym_group] = ACTIONS(3888),
    [anon_sym_by] = ACTIONS(3888),
    [anon_sym_select] = ACTIONS(3888),
    [aux_sym_preproc_if_token1] = ACTIONS(3890),
    [aux_sym_preproc_if_token3] = ACTIONS(3890),
    [aux_sym_preproc_else_token1] = ACTIONS(3890),
    [aux_sym_preproc_elif_token1] = ACTIONS(3890),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3319] = {
    [sym_preproc_region] = STATE(3319),
    [sym_preproc_endregion] = STATE(3319),
    [sym_preproc_line] = STATE(3319),
    [sym_preproc_pragma] = STATE(3319),
    [sym_preproc_nullable] = STATE(3319),
    [sym_preproc_error] = STATE(3319),
    [sym_preproc_define] = STATE(3319),
    [sym_preproc_undef] = STATE(3319),
    [sym__identifier_token] = ACTIONS(4422),
    [anon_sym_alias] = ACTIONS(4422),
    [anon_sym_global] = ACTIONS(4422),
    [anon_sym_LBRACK] = ACTIONS(4547),
    [anon_sym_COLON] = ACTIONS(4424),
    [anon_sym_COMMA] = ACTIONS(4424),
    [anon_sym_LPAREN] = ACTIONS(4424),
    [anon_sym_LBRACE] = ACTIONS(4424),
    [anon_sym_file] = ACTIONS(4422),
    [anon_sym_LT] = ACTIONS(4422),
    [anon_sym_GT] = ACTIONS(4422),
    [anon_sym_where] = ACTIONS(4422),
    [anon_sym_QMARK] = ACTIONS(4932),
    [anon_sym_notnull] = ACTIONS(4422),
    [anon_sym_unmanaged] = ACTIONS(4422),
    [anon_sym_BANG] = ACTIONS(4422),
    [anon_sym_PLUS_PLUS] = ACTIONS(4424),
    [anon_sym_DASH_DASH] = ACTIONS(4424),
    [anon_sym_PLUS] = ACTIONS(4422),
    [anon_sym_DASH] = ACTIONS(4422),
    [anon_sym_STAR] = ACTIONS(4553),
    [anon_sym_SLASH] = ACTIONS(4422),
    [anon_sym_PERCENT] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4424),
    [anon_sym_PIPE] = ACTIONS(4422),
    [anon_sym_AMP] = ACTIONS(4422),
    [anon_sym_LT_LT] = ACTIONS(4424),
    [anon_sym_GT_GT] = ACTIONS(4422),
    [anon_sym_GT_GT_GT] = ACTIONS(4424),
    [anon_sym_EQ_EQ] = ACTIONS(4424),
    [anon_sym_BANG_EQ] = ACTIONS(4424),
    [anon_sym_GT_EQ] = ACTIONS(4424),
    [anon_sym_LT_EQ] = ACTIONS(4424),
    [anon_sym_DOT] = ACTIONS(4951),
    [anon_sym_scoped] = ACTIONS(4422),
    [anon_sym_var] = ACTIONS(4422),
    [anon_sym_yield] = ACTIONS(4422),
    [anon_sym_switch] = ACTIONS(4422),
    [anon_sym_when] = ACTIONS(4422),
    [sym_discard] = ACTIONS(4422),
    [anon_sym_DOT_DOT] = ACTIONS(4424),
    [anon_sym_and] = ACTIONS(4422),
    [anon_sym_or] = ACTIONS(4422),
    [anon_sym_AMP_AMP] = ACTIONS(4424),
    [anon_sym_PIPE_PIPE] = ACTIONS(4424),
    [anon_sym_QMARK_QMARK] = ACTIONS(4424),
    [anon_sym_from] = ACTIONS(4422),
    [anon_sym_into] = ACTIONS(4422),
    [anon_sym_join] = ACTIONS(4422),
    [anon_sym_on] = ACTIONS(4422),
    [anon_sym_equals] = ACTIONS(4422),
    [anon_sym_let] = ACTIONS(4422),
    [anon_sym_orderby] = ACTIONS(4422),
    [anon_sym_ascending] = ACTIONS(4422),
    [anon_sym_descending] = ACTIONS(4422),
    [anon_sym_group] = ACTIONS(4422),
    [anon_sym_by] = ACTIONS(4422),
    [anon_sym_select] = ACTIONS(4422),
    [anon_sym_as] = ACTIONS(4422),
    [anon_sym_is] = ACTIONS(4422),
    [anon_sym_DASH_GT] = ACTIONS(4953),
    [anon_sym_with] = ACTIONS(4422),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4424),
  },
  [3320] = {
    [sym__variable_designation] = STATE(4997),
    [sym_parenthesized_variable_designation] = STATE(4957),
    [sym_identifier] = STATE(4971),
    [sym__reserved_identifier] = STATE(3568),
    [sym_preproc_region] = STATE(3320),
    [sym_preproc_endregion] = STATE(3320),
    [sym_preproc_line] = STATE(3320),
    [sym_preproc_pragma] = STATE(3320),
    [sym_preproc_nullable] = STATE(3320),
    [sym_preproc_error] = STATE(3320),
    [sym_preproc_define] = STATE(3320),
    [sym_preproc_undef] = STATE(3320),
    [sym__identifier_token] = ACTIONS(4287),
    [anon_sym_alias] = ACTIONS(4289),
    [anon_sym_global] = ACTIONS(4289),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_LPAREN] = ACTIONS(4383),
    [anon_sym_file] = ACTIONS(4289),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_where] = ACTIONS(4385),
    [anon_sym_QMARK] = ACTIONS(4385),
    [anon_sym_notnull] = ACTIONS(4289),
    [anon_sym_unmanaged] = ACTIONS(4289),
    [anon_sym_BANG] = ACTIONS(4385),
    [anon_sym_PLUS_PLUS] = ACTIONS(4383),
    [anon_sym_DASH_DASH] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_DASH] = ACTIONS(4385),
    [anon_sym_STAR] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4385),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4385),
    [anon_sym_GT_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4383),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_scoped] = ACTIONS(4289),
    [anon_sym_var] = ACTIONS(4289),
    [anon_sym_yield] = ACTIONS(4289),
    [anon_sym_switch] = ACTIONS(4385),
    [anon_sym_when] = ACTIONS(4289),
    [sym_discard] = ACTIONS(4649),
    [anon_sym_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4385),
    [anon_sym_or] = ACTIONS(4385),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_QMARK_QMARK] = ACTIONS(4383),
    [anon_sym_from] = ACTIONS(4385),
    [anon_sym_into] = ACTIONS(4289),
    [anon_sym_join] = ACTIONS(4385),
    [anon_sym_on] = ACTIONS(4289),
    [anon_sym_equals] = ACTIONS(4289),
    [anon_sym_let] = ACTIONS(4385),
    [anon_sym_orderby] = ACTIONS(4385),
    [anon_sym_ascending] = ACTIONS(4289),
    [anon_sym_descending] = ACTIONS(4289),
    [anon_sym_group] = ACTIONS(4385),
    [anon_sym_by] = ACTIONS(4289),
    [anon_sym_select] = ACTIONS(4385),
    [anon_sym_as] = ACTIONS(4385),
    [anon_sym_is] = ACTIONS(4385),
    [anon_sym_DASH_GT] = ACTIONS(4383),
    [anon_sym_with] = ACTIONS(4385),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3321] = {
    [sym_preproc_region] = STATE(3321),
    [sym_preproc_endregion] = STATE(3321),
    [sym_preproc_line] = STATE(3321),
    [sym_preproc_pragma] = STATE(3321),
    [sym_preproc_nullable] = STATE(3321),
    [sym_preproc_error] = STATE(3321),
    [sym_preproc_define] = STATE(3321),
    [sym_preproc_undef] = STATE(3321),
    [sym__identifier_token] = ACTIONS(3892),
    [anon_sym_extern] = ACTIONS(3892),
    [anon_sym_alias] = ACTIONS(3892),
    [anon_sym_global] = ACTIONS(3892),
    [anon_sym_using] = ACTIONS(3892),
    [anon_sym_unsafe] = ACTIONS(3892),
    [anon_sym_static] = ACTIONS(3892),
    [anon_sym_LBRACK] = ACTIONS(3894),
    [anon_sym_LPAREN] = ACTIONS(3894),
    [anon_sym_event] = ACTIONS(3892),
    [anon_sym_namespace] = ACTIONS(3892),
    [anon_sym_class] = ACTIONS(3892),
    [anon_sym_ref] = ACTIONS(3892),
    [anon_sym_struct] = ACTIONS(3892),
    [anon_sym_enum] = ACTIONS(3892),
    [anon_sym_RBRACE] = ACTIONS(3894),
    [anon_sym_interface] = ACTIONS(3892),
    [anon_sym_delegate] = ACTIONS(3892),
    [anon_sym_record] = ACTIONS(3892),
    [anon_sym_abstract] = ACTIONS(3892),
    [anon_sym_async] = ACTIONS(3892),
    [anon_sym_const] = ACTIONS(3892),
    [anon_sym_file] = ACTIONS(3892),
    [anon_sym_fixed] = ACTIONS(3892),
    [anon_sym_internal] = ACTIONS(3892),
    [anon_sym_new] = ACTIONS(3892),
    [anon_sym_override] = ACTIONS(3892),
    [anon_sym_partial] = ACTIONS(3892),
    [anon_sym_private] = ACTIONS(3892),
    [anon_sym_protected] = ACTIONS(3892),
    [anon_sym_public] = ACTIONS(3892),
    [anon_sym_readonly] = ACTIONS(3892),
    [anon_sym_required] = ACTIONS(3892),
    [anon_sym_sealed] = ACTIONS(3892),
    [anon_sym_virtual] = ACTIONS(3892),
    [anon_sym_volatile] = ACTIONS(3892),
    [anon_sym_where] = ACTIONS(3892),
    [anon_sym_notnull] = ACTIONS(3892),
    [anon_sym_unmanaged] = ACTIONS(3892),
    [anon_sym_TILDE] = ACTIONS(3894),
    [anon_sym_implicit] = ACTIONS(3892),
    [anon_sym_explicit] = ACTIONS(3892),
    [anon_sym_scoped] = ACTIONS(3892),
    [anon_sym_var] = ACTIONS(3892),
    [sym_predefined_type] = ACTIONS(3892),
    [anon_sym_yield] = ACTIONS(3892),
    [anon_sym_when] = ACTIONS(3892),
    [anon_sym_from] = ACTIONS(3892),
    [anon_sym_into] = ACTIONS(3892),
    [anon_sym_join] = ACTIONS(3892),
    [anon_sym_on] = ACTIONS(3892),
    [anon_sym_equals] = ACTIONS(3892),
    [anon_sym_let] = ACTIONS(3892),
    [anon_sym_orderby] = ACTIONS(3892),
    [anon_sym_ascending] = ACTIONS(3892),
    [anon_sym_descending] = ACTIONS(3892),
    [anon_sym_group] = ACTIONS(3892),
    [anon_sym_by] = ACTIONS(3892),
    [anon_sym_select] = ACTIONS(3892),
    [aux_sym_preproc_if_token1] = ACTIONS(3894),
    [aux_sym_preproc_if_token3] = ACTIONS(3894),
    [aux_sym_preproc_else_token1] = ACTIONS(3894),
    [aux_sym_preproc_elif_token1] = ACTIONS(3894),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3322] = {
    [sym_preproc_region] = STATE(3322),
    [sym_preproc_endregion] = STATE(3322),
    [sym_preproc_line] = STATE(3322),
    [sym_preproc_pragma] = STATE(3322),
    [sym_preproc_nullable] = STATE(3322),
    [sym_preproc_error] = STATE(3322),
    [sym_preproc_define] = STATE(3322),
    [sym_preproc_undef] = STATE(3322),
    [sym__identifier_token] = ACTIONS(3896),
    [anon_sym_extern] = ACTIONS(3896),
    [anon_sym_alias] = ACTIONS(3896),
    [anon_sym_global] = ACTIONS(3896),
    [anon_sym_using] = ACTIONS(3896),
    [anon_sym_unsafe] = ACTIONS(3896),
    [anon_sym_static] = ACTIONS(3896),
    [anon_sym_LBRACK] = ACTIONS(3898),
    [anon_sym_LPAREN] = ACTIONS(3898),
    [anon_sym_event] = ACTIONS(3896),
    [anon_sym_namespace] = ACTIONS(3896),
    [anon_sym_class] = ACTIONS(3896),
    [anon_sym_ref] = ACTIONS(3896),
    [anon_sym_struct] = ACTIONS(3896),
    [anon_sym_enum] = ACTIONS(3896),
    [anon_sym_RBRACE] = ACTIONS(3898),
    [anon_sym_interface] = ACTIONS(3896),
    [anon_sym_delegate] = ACTIONS(3896),
    [anon_sym_record] = ACTIONS(3896),
    [anon_sym_abstract] = ACTIONS(3896),
    [anon_sym_async] = ACTIONS(3896),
    [anon_sym_const] = ACTIONS(3896),
    [anon_sym_file] = ACTIONS(3896),
    [anon_sym_fixed] = ACTIONS(3896),
    [anon_sym_internal] = ACTIONS(3896),
    [anon_sym_new] = ACTIONS(3896),
    [anon_sym_override] = ACTIONS(3896),
    [anon_sym_partial] = ACTIONS(3896),
    [anon_sym_private] = ACTIONS(3896),
    [anon_sym_protected] = ACTIONS(3896),
    [anon_sym_public] = ACTIONS(3896),
    [anon_sym_readonly] = ACTIONS(3896),
    [anon_sym_required] = ACTIONS(3896),
    [anon_sym_sealed] = ACTIONS(3896),
    [anon_sym_virtual] = ACTIONS(3896),
    [anon_sym_volatile] = ACTIONS(3896),
    [anon_sym_where] = ACTIONS(3896),
    [anon_sym_notnull] = ACTIONS(3896),
    [anon_sym_unmanaged] = ACTIONS(3896),
    [anon_sym_TILDE] = ACTIONS(3898),
    [anon_sym_implicit] = ACTIONS(3896),
    [anon_sym_explicit] = ACTIONS(3896),
    [anon_sym_scoped] = ACTIONS(3896),
    [anon_sym_var] = ACTIONS(3896),
    [sym_predefined_type] = ACTIONS(3896),
    [anon_sym_yield] = ACTIONS(3896),
    [anon_sym_when] = ACTIONS(3896),
    [anon_sym_from] = ACTIONS(3896),
    [anon_sym_into] = ACTIONS(3896),
    [anon_sym_join] = ACTIONS(3896),
    [anon_sym_on] = ACTIONS(3896),
    [anon_sym_equals] = ACTIONS(3896),
    [anon_sym_let] = ACTIONS(3896),
    [anon_sym_orderby] = ACTIONS(3896),
    [anon_sym_ascending] = ACTIONS(3896),
    [anon_sym_descending] = ACTIONS(3896),
    [anon_sym_group] = ACTIONS(3896),
    [anon_sym_by] = ACTIONS(3896),
    [anon_sym_select] = ACTIONS(3896),
    [aux_sym_preproc_if_token1] = ACTIONS(3898),
    [aux_sym_preproc_if_token3] = ACTIONS(3898),
    [aux_sym_preproc_else_token1] = ACTIONS(3898),
    [aux_sym_preproc_elif_token1] = ACTIONS(3898),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3323] = {
    [sym_preproc_region] = STATE(3323),
    [sym_preproc_endregion] = STATE(3323),
    [sym_preproc_line] = STATE(3323),
    [sym_preproc_pragma] = STATE(3323),
    [sym_preproc_nullable] = STATE(3323),
    [sym_preproc_error] = STATE(3323),
    [sym_preproc_define] = STATE(3323),
    [sym_preproc_undef] = STATE(3323),
    [sym__identifier_token] = ACTIONS(4955),
    [anon_sym_extern] = ACTIONS(4955),
    [anon_sym_alias] = ACTIONS(4955),
    [anon_sym_global] = ACTIONS(4955),
    [anon_sym_using] = ACTIONS(4955),
    [anon_sym_unsafe] = ACTIONS(4955),
    [anon_sym_static] = ACTIONS(4955),
    [anon_sym_LBRACK] = ACTIONS(4957),
    [anon_sym_LPAREN] = ACTIONS(4957),
    [anon_sym_event] = ACTIONS(4955),
    [anon_sym_namespace] = ACTIONS(4955),
    [anon_sym_class] = ACTIONS(4955),
    [anon_sym_ref] = ACTIONS(4955),
    [anon_sym_struct] = ACTIONS(4955),
    [anon_sym_enum] = ACTIONS(4955),
    [anon_sym_RBRACE] = ACTIONS(4957),
    [anon_sym_interface] = ACTIONS(4955),
    [anon_sym_delegate] = ACTIONS(4955),
    [anon_sym_record] = ACTIONS(4955),
    [anon_sym_abstract] = ACTIONS(4955),
    [anon_sym_async] = ACTIONS(4955),
    [anon_sym_const] = ACTIONS(4955),
    [anon_sym_file] = ACTIONS(4955),
    [anon_sym_fixed] = ACTIONS(4955),
    [anon_sym_internal] = ACTIONS(4955),
    [anon_sym_new] = ACTIONS(4955),
    [anon_sym_override] = ACTIONS(4955),
    [anon_sym_partial] = ACTIONS(4955),
    [anon_sym_private] = ACTIONS(4955),
    [anon_sym_protected] = ACTIONS(4955),
    [anon_sym_public] = ACTIONS(4955),
    [anon_sym_readonly] = ACTIONS(4955),
    [anon_sym_required] = ACTIONS(4955),
    [anon_sym_sealed] = ACTIONS(4955),
    [anon_sym_virtual] = ACTIONS(4955),
    [anon_sym_volatile] = ACTIONS(4955),
    [anon_sym_where] = ACTIONS(4955),
    [anon_sym_notnull] = ACTIONS(4955),
    [anon_sym_unmanaged] = ACTIONS(4955),
    [anon_sym_TILDE] = ACTIONS(4957),
    [anon_sym_implicit] = ACTIONS(4955),
    [anon_sym_explicit] = ACTIONS(4955),
    [anon_sym_scoped] = ACTIONS(4955),
    [anon_sym_var] = ACTIONS(4955),
    [sym_predefined_type] = ACTIONS(4955),
    [anon_sym_yield] = ACTIONS(4955),
    [anon_sym_when] = ACTIONS(4955),
    [anon_sym_from] = ACTIONS(4955),
    [anon_sym_into] = ACTIONS(4955),
    [anon_sym_join] = ACTIONS(4955),
    [anon_sym_on] = ACTIONS(4955),
    [anon_sym_equals] = ACTIONS(4955),
    [anon_sym_let] = ACTIONS(4955),
    [anon_sym_orderby] = ACTIONS(4955),
    [anon_sym_ascending] = ACTIONS(4955),
    [anon_sym_descending] = ACTIONS(4955),
    [anon_sym_group] = ACTIONS(4955),
    [anon_sym_by] = ACTIONS(4955),
    [anon_sym_select] = ACTIONS(4955),
    [aux_sym_preproc_if_token1] = ACTIONS(4957),
    [aux_sym_preproc_if_token3] = ACTIONS(4957),
    [aux_sym_preproc_else_token1] = ACTIONS(4957),
    [aux_sym_preproc_elif_token1] = ACTIONS(4957),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3324] = {
    [sym_preproc_region] = STATE(3324),
    [sym_preproc_endregion] = STATE(3324),
    [sym_preproc_line] = STATE(3324),
    [sym_preproc_pragma] = STATE(3324),
    [sym_preproc_nullable] = STATE(3324),
    [sym_preproc_error] = STATE(3324),
    [sym_preproc_define] = STATE(3324),
    [sym_preproc_undef] = STATE(3324),
    [sym__identifier_token] = ACTIONS(4959),
    [anon_sym_extern] = ACTIONS(4959),
    [anon_sym_alias] = ACTIONS(4959),
    [anon_sym_global] = ACTIONS(4959),
    [anon_sym_using] = ACTIONS(4959),
    [anon_sym_unsafe] = ACTIONS(4959),
    [anon_sym_static] = ACTIONS(4959),
    [anon_sym_LBRACK] = ACTIONS(4961),
    [anon_sym_LPAREN] = ACTIONS(4961),
    [anon_sym_event] = ACTIONS(4959),
    [anon_sym_namespace] = ACTIONS(4959),
    [anon_sym_class] = ACTIONS(4959),
    [anon_sym_ref] = ACTIONS(4959),
    [anon_sym_struct] = ACTIONS(4959),
    [anon_sym_enum] = ACTIONS(4959),
    [anon_sym_RBRACE] = ACTIONS(4961),
    [anon_sym_interface] = ACTIONS(4959),
    [anon_sym_delegate] = ACTIONS(4959),
    [anon_sym_record] = ACTIONS(4959),
    [anon_sym_abstract] = ACTIONS(4959),
    [anon_sym_async] = ACTIONS(4959),
    [anon_sym_const] = ACTIONS(4959),
    [anon_sym_file] = ACTIONS(4959),
    [anon_sym_fixed] = ACTIONS(4959),
    [anon_sym_internal] = ACTIONS(4959),
    [anon_sym_new] = ACTIONS(4959),
    [anon_sym_override] = ACTIONS(4959),
    [anon_sym_partial] = ACTIONS(4959),
    [anon_sym_private] = ACTIONS(4959),
    [anon_sym_protected] = ACTIONS(4959),
    [anon_sym_public] = ACTIONS(4959),
    [anon_sym_readonly] = ACTIONS(4959),
    [anon_sym_required] = ACTIONS(4959),
    [anon_sym_sealed] = ACTIONS(4959),
    [anon_sym_virtual] = ACTIONS(4959),
    [anon_sym_volatile] = ACTIONS(4959),
    [anon_sym_where] = ACTIONS(4959),
    [anon_sym_notnull] = ACTIONS(4959),
    [anon_sym_unmanaged] = ACTIONS(4959),
    [anon_sym_TILDE] = ACTIONS(4961),
    [anon_sym_implicit] = ACTIONS(4959),
    [anon_sym_explicit] = ACTIONS(4959),
    [anon_sym_scoped] = ACTIONS(4959),
    [anon_sym_var] = ACTIONS(4959),
    [sym_predefined_type] = ACTIONS(4959),
    [anon_sym_yield] = ACTIONS(4959),
    [anon_sym_when] = ACTIONS(4959),
    [anon_sym_from] = ACTIONS(4959),
    [anon_sym_into] = ACTIONS(4959),
    [anon_sym_join] = ACTIONS(4959),
    [anon_sym_on] = ACTIONS(4959),
    [anon_sym_equals] = ACTIONS(4959),
    [anon_sym_let] = ACTIONS(4959),
    [anon_sym_orderby] = ACTIONS(4959),
    [anon_sym_ascending] = ACTIONS(4959),
    [anon_sym_descending] = ACTIONS(4959),
    [anon_sym_group] = ACTIONS(4959),
    [anon_sym_by] = ACTIONS(4959),
    [anon_sym_select] = ACTIONS(4959),
    [aux_sym_preproc_if_token1] = ACTIONS(4961),
    [aux_sym_preproc_if_token3] = ACTIONS(4961),
    [aux_sym_preproc_else_token1] = ACTIONS(4961),
    [aux_sym_preproc_elif_token1] = ACTIONS(4961),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3325] = {
    [sym_preproc_region] = STATE(3325),
    [sym_preproc_endregion] = STATE(3325),
    [sym_preproc_line] = STATE(3325),
    [sym_preproc_pragma] = STATE(3325),
    [sym_preproc_nullable] = STATE(3325),
    [sym_preproc_error] = STATE(3325),
    [sym_preproc_define] = STATE(3325),
    [sym_preproc_undef] = STATE(3325),
    [sym__identifier_token] = ACTIONS(4963),
    [anon_sym_extern] = ACTIONS(4963),
    [anon_sym_alias] = ACTIONS(4963),
    [anon_sym_global] = ACTIONS(4963),
    [anon_sym_using] = ACTIONS(4963),
    [anon_sym_unsafe] = ACTIONS(4963),
    [anon_sym_static] = ACTIONS(4963),
    [anon_sym_LBRACK] = ACTIONS(4965),
    [anon_sym_LPAREN] = ACTIONS(4965),
    [anon_sym_event] = ACTIONS(4963),
    [anon_sym_namespace] = ACTIONS(4963),
    [anon_sym_class] = ACTIONS(4963),
    [anon_sym_ref] = ACTIONS(4963),
    [anon_sym_struct] = ACTIONS(4963),
    [anon_sym_enum] = ACTIONS(4963),
    [anon_sym_RBRACE] = ACTIONS(4965),
    [anon_sym_interface] = ACTIONS(4963),
    [anon_sym_delegate] = ACTIONS(4963),
    [anon_sym_record] = ACTIONS(4963),
    [anon_sym_abstract] = ACTIONS(4963),
    [anon_sym_async] = ACTIONS(4963),
    [anon_sym_const] = ACTIONS(4963),
    [anon_sym_file] = ACTIONS(4963),
    [anon_sym_fixed] = ACTIONS(4963),
    [anon_sym_internal] = ACTIONS(4963),
    [anon_sym_new] = ACTIONS(4963),
    [anon_sym_override] = ACTIONS(4963),
    [anon_sym_partial] = ACTIONS(4963),
    [anon_sym_private] = ACTIONS(4963),
    [anon_sym_protected] = ACTIONS(4963),
    [anon_sym_public] = ACTIONS(4963),
    [anon_sym_readonly] = ACTIONS(4963),
    [anon_sym_required] = ACTIONS(4963),
    [anon_sym_sealed] = ACTIONS(4963),
    [anon_sym_virtual] = ACTIONS(4963),
    [anon_sym_volatile] = ACTIONS(4963),
    [anon_sym_where] = ACTIONS(4963),
    [anon_sym_notnull] = ACTIONS(4963),
    [anon_sym_unmanaged] = ACTIONS(4963),
    [anon_sym_TILDE] = ACTIONS(4965),
    [anon_sym_implicit] = ACTIONS(4963),
    [anon_sym_explicit] = ACTIONS(4963),
    [anon_sym_scoped] = ACTIONS(4963),
    [anon_sym_var] = ACTIONS(4963),
    [sym_predefined_type] = ACTIONS(4963),
    [anon_sym_yield] = ACTIONS(4963),
    [anon_sym_when] = ACTIONS(4963),
    [anon_sym_from] = ACTIONS(4963),
    [anon_sym_into] = ACTIONS(4963),
    [anon_sym_join] = ACTIONS(4963),
    [anon_sym_on] = ACTIONS(4963),
    [anon_sym_equals] = ACTIONS(4963),
    [anon_sym_let] = ACTIONS(4963),
    [anon_sym_orderby] = ACTIONS(4963),
    [anon_sym_ascending] = ACTIONS(4963),
    [anon_sym_descending] = ACTIONS(4963),
    [anon_sym_group] = ACTIONS(4963),
    [anon_sym_by] = ACTIONS(4963),
    [anon_sym_select] = ACTIONS(4963),
    [aux_sym_preproc_if_token1] = ACTIONS(4965),
    [aux_sym_preproc_if_token3] = ACTIONS(4965),
    [aux_sym_preproc_else_token1] = ACTIONS(4965),
    [aux_sym_preproc_elif_token1] = ACTIONS(4965),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3326] = {
    [sym_preproc_region] = STATE(3326),
    [sym_preproc_endregion] = STATE(3326),
    [sym_preproc_line] = STATE(3326),
    [sym_preproc_pragma] = STATE(3326),
    [sym_preproc_nullable] = STATE(3326),
    [sym_preproc_error] = STATE(3326),
    [sym_preproc_define] = STATE(3326),
    [sym_preproc_undef] = STATE(3326),
    [sym__identifier_token] = ACTIONS(4967),
    [anon_sym_extern] = ACTIONS(4967),
    [anon_sym_alias] = ACTIONS(4967),
    [anon_sym_global] = ACTIONS(4967),
    [anon_sym_using] = ACTIONS(4967),
    [anon_sym_unsafe] = ACTIONS(4967),
    [anon_sym_static] = ACTIONS(4967),
    [anon_sym_LBRACK] = ACTIONS(4969),
    [anon_sym_LPAREN] = ACTIONS(4969),
    [anon_sym_event] = ACTIONS(4967),
    [anon_sym_namespace] = ACTIONS(4967),
    [anon_sym_class] = ACTIONS(4967),
    [anon_sym_ref] = ACTIONS(4967),
    [anon_sym_struct] = ACTIONS(4967),
    [anon_sym_enum] = ACTIONS(4967),
    [anon_sym_RBRACE] = ACTIONS(4969),
    [anon_sym_interface] = ACTIONS(4967),
    [anon_sym_delegate] = ACTIONS(4967),
    [anon_sym_record] = ACTIONS(4967),
    [anon_sym_abstract] = ACTIONS(4967),
    [anon_sym_async] = ACTIONS(4967),
    [anon_sym_const] = ACTIONS(4967),
    [anon_sym_file] = ACTIONS(4967),
    [anon_sym_fixed] = ACTIONS(4967),
    [anon_sym_internal] = ACTIONS(4967),
    [anon_sym_new] = ACTIONS(4967),
    [anon_sym_override] = ACTIONS(4967),
    [anon_sym_partial] = ACTIONS(4967),
    [anon_sym_private] = ACTIONS(4967),
    [anon_sym_protected] = ACTIONS(4967),
    [anon_sym_public] = ACTIONS(4967),
    [anon_sym_readonly] = ACTIONS(4967),
    [anon_sym_required] = ACTIONS(4967),
    [anon_sym_sealed] = ACTIONS(4967),
    [anon_sym_virtual] = ACTIONS(4967),
    [anon_sym_volatile] = ACTIONS(4967),
    [anon_sym_where] = ACTIONS(4967),
    [anon_sym_notnull] = ACTIONS(4967),
    [anon_sym_unmanaged] = ACTIONS(4967),
    [anon_sym_TILDE] = ACTIONS(4969),
    [anon_sym_implicit] = ACTIONS(4967),
    [anon_sym_explicit] = ACTIONS(4967),
    [anon_sym_scoped] = ACTIONS(4967),
    [anon_sym_var] = ACTIONS(4967),
    [sym_predefined_type] = ACTIONS(4967),
    [anon_sym_yield] = ACTIONS(4967),
    [anon_sym_when] = ACTIONS(4967),
    [anon_sym_from] = ACTIONS(4967),
    [anon_sym_into] = ACTIONS(4967),
    [anon_sym_join] = ACTIONS(4967),
    [anon_sym_on] = ACTIONS(4967),
    [anon_sym_equals] = ACTIONS(4967),
    [anon_sym_let] = ACTIONS(4967),
    [anon_sym_orderby] = ACTIONS(4967),
    [anon_sym_ascending] = ACTIONS(4967),
    [anon_sym_descending] = ACTIONS(4967),
    [anon_sym_group] = ACTIONS(4967),
    [anon_sym_by] = ACTIONS(4967),
    [anon_sym_select] = ACTIONS(4967),
    [aux_sym_preproc_if_token1] = ACTIONS(4969),
    [aux_sym_preproc_if_token3] = ACTIONS(4969),
    [aux_sym_preproc_else_token1] = ACTIONS(4969),
    [aux_sym_preproc_elif_token1] = ACTIONS(4969),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3327] = {
    [sym_preproc_region] = STATE(3327),
    [sym_preproc_endregion] = STATE(3327),
    [sym_preproc_line] = STATE(3327),
    [sym_preproc_pragma] = STATE(3327),
    [sym_preproc_nullable] = STATE(3327),
    [sym_preproc_error] = STATE(3327),
    [sym_preproc_define] = STATE(3327),
    [sym_preproc_undef] = STATE(3327),
    [sym__identifier_token] = ACTIONS(4971),
    [anon_sym_extern] = ACTIONS(4971),
    [anon_sym_alias] = ACTIONS(4971),
    [anon_sym_global] = ACTIONS(4971),
    [anon_sym_using] = ACTIONS(4971),
    [anon_sym_unsafe] = ACTIONS(4971),
    [anon_sym_static] = ACTIONS(4971),
    [anon_sym_LBRACK] = ACTIONS(4973),
    [anon_sym_LPAREN] = ACTIONS(4973),
    [anon_sym_event] = ACTIONS(4971),
    [anon_sym_namespace] = ACTIONS(4971),
    [anon_sym_class] = ACTIONS(4971),
    [anon_sym_ref] = ACTIONS(4971),
    [anon_sym_struct] = ACTIONS(4971),
    [anon_sym_enum] = ACTIONS(4971),
    [anon_sym_RBRACE] = ACTIONS(4973),
    [anon_sym_interface] = ACTIONS(4971),
    [anon_sym_delegate] = ACTIONS(4971),
    [anon_sym_record] = ACTIONS(4971),
    [anon_sym_abstract] = ACTIONS(4971),
    [anon_sym_async] = ACTIONS(4971),
    [anon_sym_const] = ACTIONS(4971),
    [anon_sym_file] = ACTIONS(4971),
    [anon_sym_fixed] = ACTIONS(4971),
    [anon_sym_internal] = ACTIONS(4971),
    [anon_sym_new] = ACTIONS(4971),
    [anon_sym_override] = ACTIONS(4971),
    [anon_sym_partial] = ACTIONS(4971),
    [anon_sym_private] = ACTIONS(4971),
    [anon_sym_protected] = ACTIONS(4971),
    [anon_sym_public] = ACTIONS(4971),
    [anon_sym_readonly] = ACTIONS(4971),
    [anon_sym_required] = ACTIONS(4971),
    [anon_sym_sealed] = ACTIONS(4971),
    [anon_sym_virtual] = ACTIONS(4971),
    [anon_sym_volatile] = ACTIONS(4971),
    [anon_sym_where] = ACTIONS(4971),
    [anon_sym_notnull] = ACTIONS(4971),
    [anon_sym_unmanaged] = ACTIONS(4971),
    [anon_sym_TILDE] = ACTIONS(4973),
    [anon_sym_implicit] = ACTIONS(4971),
    [anon_sym_explicit] = ACTIONS(4971),
    [anon_sym_scoped] = ACTIONS(4971),
    [anon_sym_var] = ACTIONS(4971),
    [sym_predefined_type] = ACTIONS(4971),
    [anon_sym_yield] = ACTIONS(4971),
    [anon_sym_when] = ACTIONS(4971),
    [anon_sym_from] = ACTIONS(4971),
    [anon_sym_into] = ACTIONS(4971),
    [anon_sym_join] = ACTIONS(4971),
    [anon_sym_on] = ACTIONS(4971),
    [anon_sym_equals] = ACTIONS(4971),
    [anon_sym_let] = ACTIONS(4971),
    [anon_sym_orderby] = ACTIONS(4971),
    [anon_sym_ascending] = ACTIONS(4971),
    [anon_sym_descending] = ACTIONS(4971),
    [anon_sym_group] = ACTIONS(4971),
    [anon_sym_by] = ACTIONS(4971),
    [anon_sym_select] = ACTIONS(4971),
    [aux_sym_preproc_if_token1] = ACTIONS(4973),
    [aux_sym_preproc_if_token3] = ACTIONS(4973),
    [aux_sym_preproc_else_token1] = ACTIONS(4973),
    [aux_sym_preproc_elif_token1] = ACTIONS(4973),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3328] = {
    [sym_preproc_region] = STATE(3328),
    [sym_preproc_endregion] = STATE(3328),
    [sym_preproc_line] = STATE(3328),
    [sym_preproc_pragma] = STATE(3328),
    [sym_preproc_nullable] = STATE(3328),
    [sym_preproc_error] = STATE(3328),
    [sym_preproc_define] = STATE(3328),
    [sym_preproc_undef] = STATE(3328),
    [sym__identifier_token] = ACTIONS(3900),
    [anon_sym_extern] = ACTIONS(3900),
    [anon_sym_alias] = ACTIONS(3900),
    [anon_sym_global] = ACTIONS(3900),
    [anon_sym_using] = ACTIONS(3900),
    [anon_sym_unsafe] = ACTIONS(3900),
    [anon_sym_static] = ACTIONS(3900),
    [anon_sym_LBRACK] = ACTIONS(3902),
    [anon_sym_LPAREN] = ACTIONS(3902),
    [anon_sym_event] = ACTIONS(3900),
    [anon_sym_namespace] = ACTIONS(3900),
    [anon_sym_class] = ACTIONS(3900),
    [anon_sym_ref] = ACTIONS(3900),
    [anon_sym_struct] = ACTIONS(3900),
    [anon_sym_enum] = ACTIONS(3900),
    [anon_sym_RBRACE] = ACTIONS(3902),
    [anon_sym_interface] = ACTIONS(3900),
    [anon_sym_delegate] = ACTIONS(3900),
    [anon_sym_record] = ACTIONS(3900),
    [anon_sym_abstract] = ACTIONS(3900),
    [anon_sym_async] = ACTIONS(3900),
    [anon_sym_const] = ACTIONS(3900),
    [anon_sym_file] = ACTIONS(3900),
    [anon_sym_fixed] = ACTIONS(3900),
    [anon_sym_internal] = ACTIONS(3900),
    [anon_sym_new] = ACTIONS(3900),
    [anon_sym_override] = ACTIONS(3900),
    [anon_sym_partial] = ACTIONS(3900),
    [anon_sym_private] = ACTIONS(3900),
    [anon_sym_protected] = ACTIONS(3900),
    [anon_sym_public] = ACTIONS(3900),
    [anon_sym_readonly] = ACTIONS(3900),
    [anon_sym_required] = ACTIONS(3900),
    [anon_sym_sealed] = ACTIONS(3900),
    [anon_sym_virtual] = ACTIONS(3900),
    [anon_sym_volatile] = ACTIONS(3900),
    [anon_sym_where] = ACTIONS(3900),
    [anon_sym_notnull] = ACTIONS(3900),
    [anon_sym_unmanaged] = ACTIONS(3900),
    [anon_sym_TILDE] = ACTIONS(3902),
    [anon_sym_implicit] = ACTIONS(3900),
    [anon_sym_explicit] = ACTIONS(3900),
    [anon_sym_scoped] = ACTIONS(3900),
    [anon_sym_var] = ACTIONS(3900),
    [sym_predefined_type] = ACTIONS(3900),
    [anon_sym_yield] = ACTIONS(3900),
    [anon_sym_when] = ACTIONS(3900),
    [anon_sym_from] = ACTIONS(3900),
    [anon_sym_into] = ACTIONS(3900),
    [anon_sym_join] = ACTIONS(3900),
    [anon_sym_on] = ACTIONS(3900),
    [anon_sym_equals] = ACTIONS(3900),
    [anon_sym_let] = ACTIONS(3900),
    [anon_sym_orderby] = ACTIONS(3900),
    [anon_sym_ascending] = ACTIONS(3900),
    [anon_sym_descending] = ACTIONS(3900),
    [anon_sym_group] = ACTIONS(3900),
    [anon_sym_by] = ACTIONS(3900),
    [anon_sym_select] = ACTIONS(3900),
    [aux_sym_preproc_if_token1] = ACTIONS(3902),
    [aux_sym_preproc_if_token3] = ACTIONS(3902),
    [aux_sym_preproc_else_token1] = ACTIONS(3902),
    [aux_sym_preproc_elif_token1] = ACTIONS(3902),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3329] = {
    [sym_preproc_region] = STATE(3329),
    [sym_preproc_endregion] = STATE(3329),
    [sym_preproc_line] = STATE(3329),
    [sym_preproc_pragma] = STATE(3329),
    [sym_preproc_nullable] = STATE(3329),
    [sym_preproc_error] = STATE(3329),
    [sym_preproc_define] = STATE(3329),
    [sym_preproc_undef] = STATE(3329),
    [anon_sym_SEMI] = ACTIONS(4062),
    [anon_sym_EQ] = ACTIONS(4060),
    [anon_sym_LBRACK] = ACTIONS(4062),
    [anon_sym_COLON] = ACTIONS(4062),
    [anon_sym_COMMA] = ACTIONS(4062),
    [anon_sym_RBRACK] = ACTIONS(4062),
    [anon_sym_LPAREN] = ACTIONS(4062),
    [anon_sym_RPAREN] = ACTIONS(4062),
    [anon_sym_RBRACE] = ACTIONS(4062),
    [anon_sym_LT] = ACTIONS(4060),
    [anon_sym_GT] = ACTIONS(4060),
    [anon_sym_in] = ACTIONS(4062),
    [anon_sym_QMARK] = ACTIONS(4060),
    [anon_sym_BANG] = ACTIONS(4060),
    [anon_sym_PLUS_PLUS] = ACTIONS(4062),
    [anon_sym_DASH_DASH] = ACTIONS(4062),
    [anon_sym_PLUS] = ACTIONS(4060),
    [anon_sym_DASH] = ACTIONS(4060),
    [anon_sym_STAR] = ACTIONS(4060),
    [anon_sym_SLASH] = ACTIONS(4060),
    [anon_sym_PERCENT] = ACTIONS(4060),
    [anon_sym_CARET] = ACTIONS(4060),
    [anon_sym_PIPE] = ACTIONS(4060),
    [anon_sym_AMP] = ACTIONS(4060),
    [anon_sym_LT_LT] = ACTIONS(4060),
    [anon_sym_GT_GT] = ACTIONS(4060),
    [anon_sym_GT_GT_GT] = ACTIONS(4060),
    [anon_sym_EQ_EQ] = ACTIONS(4062),
    [anon_sym_BANG_EQ] = ACTIONS(4062),
    [anon_sym_GT_EQ] = ACTIONS(4062),
    [anon_sym_LT_EQ] = ACTIONS(4062),
    [anon_sym_DOT] = ACTIONS(4060),
    [anon_sym_EQ_GT] = ACTIONS(4062),
    [anon_sym_switch] = ACTIONS(4062),
    [anon_sym_when] = ACTIONS(4062),
    [anon_sym_DOT_DOT] = ACTIONS(4062),
    [anon_sym_and] = ACTIONS(4062),
    [anon_sym_or] = ACTIONS(4062),
    [anon_sym_PLUS_EQ] = ACTIONS(4062),
    [anon_sym_DASH_EQ] = ACTIONS(4062),
    [anon_sym_STAR_EQ] = ACTIONS(4062),
    [anon_sym_SLASH_EQ] = ACTIONS(4062),
    [anon_sym_PERCENT_EQ] = ACTIONS(4062),
    [anon_sym_AMP_EQ] = ACTIONS(4062),
    [anon_sym_CARET_EQ] = ACTIONS(4062),
    [anon_sym_PIPE_EQ] = ACTIONS(4062),
    [anon_sym_LT_LT_EQ] = ACTIONS(4062),
    [anon_sym_GT_GT_EQ] = ACTIONS(4062),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4062),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4062),
    [anon_sym_AMP_AMP] = ACTIONS(4062),
    [anon_sym_PIPE_PIPE] = ACTIONS(4062),
    [anon_sym_QMARK_QMARK] = ACTIONS(4060),
    [anon_sym_on] = ACTIONS(4062),
    [anon_sym_equals] = ACTIONS(4062),
    [anon_sym_by] = ACTIONS(4062),
    [anon_sym_as] = ACTIONS(4062),
    [anon_sym_is] = ACTIONS(4062),
    [anon_sym_DASH_GT] = ACTIONS(4062),
    [anon_sym_with] = ACTIONS(4062),
    [aux_sym_preproc_if_token3] = ACTIONS(4062),
    [aux_sym_preproc_else_token1] = ACTIONS(4062),
    [aux_sym_preproc_elif_token1] = ACTIONS(4062),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3330] = {
    [sym_preproc_region] = STATE(3330),
    [sym_preproc_endregion] = STATE(3330),
    [sym_preproc_line] = STATE(3330),
    [sym_preproc_pragma] = STATE(3330),
    [sym_preproc_nullable] = STATE(3330),
    [sym_preproc_error] = STATE(3330),
    [sym_preproc_define] = STATE(3330),
    [sym_preproc_undef] = STATE(3330),
    [sym__identifier_token] = ACTIONS(4975),
    [anon_sym_extern] = ACTIONS(4975),
    [anon_sym_alias] = ACTIONS(4975),
    [anon_sym_global] = ACTIONS(4975),
    [anon_sym_using] = ACTIONS(4975),
    [anon_sym_unsafe] = ACTIONS(4975),
    [anon_sym_static] = ACTIONS(4975),
    [anon_sym_LBRACK] = ACTIONS(4977),
    [anon_sym_LPAREN] = ACTIONS(4977),
    [anon_sym_event] = ACTIONS(4975),
    [anon_sym_namespace] = ACTIONS(4975),
    [anon_sym_class] = ACTIONS(4975),
    [anon_sym_ref] = ACTIONS(4975),
    [anon_sym_struct] = ACTIONS(4975),
    [anon_sym_enum] = ACTIONS(4975),
    [anon_sym_RBRACE] = ACTIONS(4977),
    [anon_sym_interface] = ACTIONS(4975),
    [anon_sym_delegate] = ACTIONS(4975),
    [anon_sym_record] = ACTIONS(4975),
    [anon_sym_abstract] = ACTIONS(4975),
    [anon_sym_async] = ACTIONS(4975),
    [anon_sym_const] = ACTIONS(4975),
    [anon_sym_file] = ACTIONS(4975),
    [anon_sym_fixed] = ACTIONS(4975),
    [anon_sym_internal] = ACTIONS(4975),
    [anon_sym_new] = ACTIONS(4975),
    [anon_sym_override] = ACTIONS(4975),
    [anon_sym_partial] = ACTIONS(4975),
    [anon_sym_private] = ACTIONS(4975),
    [anon_sym_protected] = ACTIONS(4975),
    [anon_sym_public] = ACTIONS(4975),
    [anon_sym_readonly] = ACTIONS(4975),
    [anon_sym_required] = ACTIONS(4975),
    [anon_sym_sealed] = ACTIONS(4975),
    [anon_sym_virtual] = ACTIONS(4975),
    [anon_sym_volatile] = ACTIONS(4975),
    [anon_sym_where] = ACTIONS(4975),
    [anon_sym_notnull] = ACTIONS(4975),
    [anon_sym_unmanaged] = ACTIONS(4975),
    [anon_sym_TILDE] = ACTIONS(4977),
    [anon_sym_implicit] = ACTIONS(4975),
    [anon_sym_explicit] = ACTIONS(4975),
    [anon_sym_scoped] = ACTIONS(4975),
    [anon_sym_var] = ACTIONS(4975),
    [sym_predefined_type] = ACTIONS(4975),
    [anon_sym_yield] = ACTIONS(4975),
    [anon_sym_when] = ACTIONS(4975),
    [anon_sym_from] = ACTIONS(4975),
    [anon_sym_into] = ACTIONS(4975),
    [anon_sym_join] = ACTIONS(4975),
    [anon_sym_on] = ACTIONS(4975),
    [anon_sym_equals] = ACTIONS(4975),
    [anon_sym_let] = ACTIONS(4975),
    [anon_sym_orderby] = ACTIONS(4975),
    [anon_sym_ascending] = ACTIONS(4975),
    [anon_sym_descending] = ACTIONS(4975),
    [anon_sym_group] = ACTIONS(4975),
    [anon_sym_by] = ACTIONS(4975),
    [anon_sym_select] = ACTIONS(4975),
    [aux_sym_preproc_if_token1] = ACTIONS(4977),
    [aux_sym_preproc_if_token3] = ACTIONS(4977),
    [aux_sym_preproc_else_token1] = ACTIONS(4977),
    [aux_sym_preproc_elif_token1] = ACTIONS(4977),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3331] = {
    [sym_preproc_region] = STATE(3331),
    [sym_preproc_endregion] = STATE(3331),
    [sym_preproc_line] = STATE(3331),
    [sym_preproc_pragma] = STATE(3331),
    [sym_preproc_nullable] = STATE(3331),
    [sym_preproc_error] = STATE(3331),
    [sym_preproc_define] = STATE(3331),
    [sym_preproc_undef] = STATE(3331),
    [sym__identifier_token] = ACTIONS(4979),
    [anon_sym_extern] = ACTIONS(4979),
    [anon_sym_alias] = ACTIONS(4979),
    [anon_sym_global] = ACTIONS(4979),
    [anon_sym_using] = ACTIONS(4979),
    [anon_sym_unsafe] = ACTIONS(4979),
    [anon_sym_static] = ACTIONS(4979),
    [anon_sym_LBRACK] = ACTIONS(4981),
    [anon_sym_LPAREN] = ACTIONS(4981),
    [anon_sym_event] = ACTIONS(4979),
    [anon_sym_namespace] = ACTIONS(4979),
    [anon_sym_class] = ACTIONS(4979),
    [anon_sym_ref] = ACTIONS(4979),
    [anon_sym_struct] = ACTIONS(4979),
    [anon_sym_enum] = ACTIONS(4979),
    [anon_sym_RBRACE] = ACTIONS(4981),
    [anon_sym_interface] = ACTIONS(4979),
    [anon_sym_delegate] = ACTIONS(4979),
    [anon_sym_record] = ACTIONS(4979),
    [anon_sym_abstract] = ACTIONS(4979),
    [anon_sym_async] = ACTIONS(4979),
    [anon_sym_const] = ACTIONS(4979),
    [anon_sym_file] = ACTIONS(4979),
    [anon_sym_fixed] = ACTIONS(4979),
    [anon_sym_internal] = ACTIONS(4979),
    [anon_sym_new] = ACTIONS(4979),
    [anon_sym_override] = ACTIONS(4979),
    [anon_sym_partial] = ACTIONS(4979),
    [anon_sym_private] = ACTIONS(4979),
    [anon_sym_protected] = ACTIONS(4979),
    [anon_sym_public] = ACTIONS(4979),
    [anon_sym_readonly] = ACTIONS(4979),
    [anon_sym_required] = ACTIONS(4979),
    [anon_sym_sealed] = ACTIONS(4979),
    [anon_sym_virtual] = ACTIONS(4979),
    [anon_sym_volatile] = ACTIONS(4979),
    [anon_sym_where] = ACTIONS(4979),
    [anon_sym_notnull] = ACTIONS(4979),
    [anon_sym_unmanaged] = ACTIONS(4979),
    [anon_sym_TILDE] = ACTIONS(4981),
    [anon_sym_implicit] = ACTIONS(4979),
    [anon_sym_explicit] = ACTIONS(4979),
    [anon_sym_scoped] = ACTIONS(4979),
    [anon_sym_var] = ACTIONS(4979),
    [sym_predefined_type] = ACTIONS(4979),
    [anon_sym_yield] = ACTIONS(4979),
    [anon_sym_when] = ACTIONS(4979),
    [anon_sym_from] = ACTIONS(4979),
    [anon_sym_into] = ACTIONS(4979),
    [anon_sym_join] = ACTIONS(4979),
    [anon_sym_on] = ACTIONS(4979),
    [anon_sym_equals] = ACTIONS(4979),
    [anon_sym_let] = ACTIONS(4979),
    [anon_sym_orderby] = ACTIONS(4979),
    [anon_sym_ascending] = ACTIONS(4979),
    [anon_sym_descending] = ACTIONS(4979),
    [anon_sym_group] = ACTIONS(4979),
    [anon_sym_by] = ACTIONS(4979),
    [anon_sym_select] = ACTIONS(4979),
    [aux_sym_preproc_if_token1] = ACTIONS(4981),
    [aux_sym_preproc_if_token3] = ACTIONS(4981),
    [aux_sym_preproc_else_token1] = ACTIONS(4981),
    [aux_sym_preproc_elif_token1] = ACTIONS(4981),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3332] = {
    [sym_preproc_region] = STATE(3332),
    [sym_preproc_endregion] = STATE(3332),
    [sym_preproc_line] = STATE(3332),
    [sym_preproc_pragma] = STATE(3332),
    [sym_preproc_nullable] = STATE(3332),
    [sym_preproc_error] = STATE(3332),
    [sym_preproc_define] = STATE(3332),
    [sym_preproc_undef] = STATE(3332),
    [sym__identifier_token] = ACTIONS(3904),
    [anon_sym_extern] = ACTIONS(3904),
    [anon_sym_alias] = ACTIONS(3904),
    [anon_sym_global] = ACTIONS(3904),
    [anon_sym_using] = ACTIONS(3904),
    [anon_sym_unsafe] = ACTIONS(3904),
    [anon_sym_static] = ACTIONS(3904),
    [anon_sym_LBRACK] = ACTIONS(3906),
    [anon_sym_LPAREN] = ACTIONS(3906),
    [anon_sym_event] = ACTIONS(3904),
    [anon_sym_namespace] = ACTIONS(3904),
    [anon_sym_class] = ACTIONS(3904),
    [anon_sym_ref] = ACTIONS(3904),
    [anon_sym_struct] = ACTIONS(3904),
    [anon_sym_enum] = ACTIONS(3904),
    [anon_sym_RBRACE] = ACTIONS(3906),
    [anon_sym_interface] = ACTIONS(3904),
    [anon_sym_delegate] = ACTIONS(3904),
    [anon_sym_record] = ACTIONS(3904),
    [anon_sym_abstract] = ACTIONS(3904),
    [anon_sym_async] = ACTIONS(3904),
    [anon_sym_const] = ACTIONS(3904),
    [anon_sym_file] = ACTIONS(3904),
    [anon_sym_fixed] = ACTIONS(3904),
    [anon_sym_internal] = ACTIONS(3904),
    [anon_sym_new] = ACTIONS(3904),
    [anon_sym_override] = ACTIONS(3904),
    [anon_sym_partial] = ACTIONS(3904),
    [anon_sym_private] = ACTIONS(3904),
    [anon_sym_protected] = ACTIONS(3904),
    [anon_sym_public] = ACTIONS(3904),
    [anon_sym_readonly] = ACTIONS(3904),
    [anon_sym_required] = ACTIONS(3904),
    [anon_sym_sealed] = ACTIONS(3904),
    [anon_sym_virtual] = ACTIONS(3904),
    [anon_sym_volatile] = ACTIONS(3904),
    [anon_sym_where] = ACTIONS(3904),
    [anon_sym_notnull] = ACTIONS(3904),
    [anon_sym_unmanaged] = ACTIONS(3904),
    [anon_sym_TILDE] = ACTIONS(3906),
    [anon_sym_implicit] = ACTIONS(3904),
    [anon_sym_explicit] = ACTIONS(3904),
    [anon_sym_scoped] = ACTIONS(3904),
    [anon_sym_var] = ACTIONS(3904),
    [sym_predefined_type] = ACTIONS(3904),
    [anon_sym_yield] = ACTIONS(3904),
    [anon_sym_when] = ACTIONS(3904),
    [anon_sym_from] = ACTIONS(3904),
    [anon_sym_into] = ACTIONS(3904),
    [anon_sym_join] = ACTIONS(3904),
    [anon_sym_on] = ACTIONS(3904),
    [anon_sym_equals] = ACTIONS(3904),
    [anon_sym_let] = ACTIONS(3904),
    [anon_sym_orderby] = ACTIONS(3904),
    [anon_sym_ascending] = ACTIONS(3904),
    [anon_sym_descending] = ACTIONS(3904),
    [anon_sym_group] = ACTIONS(3904),
    [anon_sym_by] = ACTIONS(3904),
    [anon_sym_select] = ACTIONS(3904),
    [aux_sym_preproc_if_token1] = ACTIONS(3906),
    [aux_sym_preproc_if_token3] = ACTIONS(3906),
    [aux_sym_preproc_else_token1] = ACTIONS(3906),
    [aux_sym_preproc_elif_token1] = ACTIONS(3906),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3333] = {
    [sym_preproc_region] = STATE(3333),
    [sym_preproc_endregion] = STATE(3333),
    [sym_preproc_line] = STATE(3333),
    [sym_preproc_pragma] = STATE(3333),
    [sym_preproc_nullable] = STATE(3333),
    [sym_preproc_error] = STATE(3333),
    [sym_preproc_define] = STATE(3333),
    [sym_preproc_undef] = STATE(3333),
    [sym__identifier_token] = ACTIONS(4085),
    [anon_sym_alias] = ACTIONS(4085),
    [anon_sym_global] = ACTIONS(4085),
    [anon_sym_LBRACK] = ACTIONS(4087),
    [anon_sym_COLON] = ACTIONS(4087),
    [anon_sym_COMMA] = ACTIONS(4087),
    [anon_sym_LPAREN] = ACTIONS(4087),
    [anon_sym_LBRACE] = ACTIONS(4087),
    [anon_sym_file] = ACTIONS(4085),
    [anon_sym_LT] = ACTIONS(4085),
    [anon_sym_GT] = ACTIONS(4085),
    [anon_sym_where] = ACTIONS(4085),
    [anon_sym_QMARK] = ACTIONS(4085),
    [anon_sym_notnull] = ACTIONS(4085),
    [anon_sym_unmanaged] = ACTIONS(4085),
    [anon_sym_BANG] = ACTIONS(4085),
    [anon_sym_PLUS_PLUS] = ACTIONS(4087),
    [anon_sym_DASH_DASH] = ACTIONS(4087),
    [anon_sym_PLUS] = ACTIONS(4085),
    [anon_sym_DASH] = ACTIONS(4085),
    [anon_sym_STAR] = ACTIONS(4087),
    [anon_sym_SLASH] = ACTIONS(4085),
    [anon_sym_PERCENT] = ACTIONS(4087),
    [anon_sym_CARET] = ACTIONS(4087),
    [anon_sym_PIPE] = ACTIONS(4085),
    [anon_sym_AMP] = ACTIONS(4085),
    [anon_sym_LT_LT] = ACTIONS(4087),
    [anon_sym_GT_GT] = ACTIONS(4085),
    [anon_sym_GT_GT_GT] = ACTIONS(4087),
    [anon_sym_EQ_EQ] = ACTIONS(4087),
    [anon_sym_BANG_EQ] = ACTIONS(4087),
    [anon_sym_GT_EQ] = ACTIONS(4087),
    [anon_sym_LT_EQ] = ACTIONS(4087),
    [anon_sym_DOT] = ACTIONS(4085),
    [anon_sym_scoped] = ACTIONS(4085),
    [anon_sym_var] = ACTIONS(4085),
    [anon_sym_yield] = ACTIONS(4085),
    [anon_sym_switch] = ACTIONS(4085),
    [anon_sym_when] = ACTIONS(4085),
    [sym_discard] = ACTIONS(4085),
    [anon_sym_DOT_DOT] = ACTIONS(4087),
    [anon_sym_and] = ACTIONS(4085),
    [anon_sym_or] = ACTIONS(4085),
    [anon_sym_AMP_AMP] = ACTIONS(4087),
    [anon_sym_PIPE_PIPE] = ACTIONS(4087),
    [anon_sym_QMARK_QMARK] = ACTIONS(4087),
    [anon_sym_from] = ACTIONS(4085),
    [anon_sym_into] = ACTIONS(4085),
    [anon_sym_join] = ACTIONS(4085),
    [anon_sym_on] = ACTIONS(4085),
    [anon_sym_equals] = ACTIONS(4085),
    [anon_sym_let] = ACTIONS(4085),
    [anon_sym_orderby] = ACTIONS(4085),
    [anon_sym_ascending] = ACTIONS(4085),
    [anon_sym_descending] = ACTIONS(4085),
    [anon_sym_group] = ACTIONS(4085),
    [anon_sym_by] = ACTIONS(4085),
    [anon_sym_select] = ACTIONS(4085),
    [anon_sym_as] = ACTIONS(4085),
    [anon_sym_is] = ACTIONS(4085),
    [anon_sym_DASH_GT] = ACTIONS(4087),
    [anon_sym_with] = ACTIONS(4085),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4087),
  },
  [3334] = {
    [sym_preproc_region] = STATE(3334),
    [sym_preproc_endregion] = STATE(3334),
    [sym_preproc_line] = STATE(3334),
    [sym_preproc_pragma] = STATE(3334),
    [sym_preproc_nullable] = STATE(3334),
    [sym_preproc_error] = STATE(3334),
    [sym_preproc_define] = STATE(3334),
    [sym_preproc_undef] = STATE(3334),
    [sym__identifier_token] = ACTIONS(3744),
    [anon_sym_extern] = ACTIONS(3744),
    [anon_sym_alias] = ACTIONS(3744),
    [anon_sym_global] = ACTIONS(3744),
    [anon_sym_using] = ACTIONS(3744),
    [anon_sym_unsafe] = ACTIONS(3744),
    [anon_sym_static] = ACTIONS(3744),
    [anon_sym_LBRACK] = ACTIONS(3746),
    [anon_sym_LPAREN] = ACTIONS(3746),
    [anon_sym_event] = ACTIONS(3744),
    [anon_sym_namespace] = ACTIONS(3744),
    [anon_sym_class] = ACTIONS(3744),
    [anon_sym_ref] = ACTIONS(3744),
    [anon_sym_struct] = ACTIONS(3744),
    [anon_sym_enum] = ACTIONS(3744),
    [anon_sym_RBRACE] = ACTIONS(3746),
    [anon_sym_interface] = ACTIONS(3744),
    [anon_sym_delegate] = ACTIONS(3744),
    [anon_sym_record] = ACTIONS(3744),
    [anon_sym_abstract] = ACTIONS(3744),
    [anon_sym_async] = ACTIONS(3744),
    [anon_sym_const] = ACTIONS(3744),
    [anon_sym_file] = ACTIONS(3744),
    [anon_sym_fixed] = ACTIONS(3744),
    [anon_sym_internal] = ACTIONS(3744),
    [anon_sym_new] = ACTIONS(3744),
    [anon_sym_override] = ACTIONS(3744),
    [anon_sym_partial] = ACTIONS(3744),
    [anon_sym_private] = ACTIONS(3744),
    [anon_sym_protected] = ACTIONS(3744),
    [anon_sym_public] = ACTIONS(3744),
    [anon_sym_readonly] = ACTIONS(3744),
    [anon_sym_required] = ACTIONS(3744),
    [anon_sym_sealed] = ACTIONS(3744),
    [anon_sym_virtual] = ACTIONS(3744),
    [anon_sym_volatile] = ACTIONS(3744),
    [anon_sym_where] = ACTIONS(3744),
    [anon_sym_notnull] = ACTIONS(3744),
    [anon_sym_unmanaged] = ACTIONS(3744),
    [anon_sym_TILDE] = ACTIONS(3746),
    [anon_sym_implicit] = ACTIONS(3744),
    [anon_sym_explicit] = ACTIONS(3744),
    [anon_sym_scoped] = ACTIONS(3744),
    [anon_sym_var] = ACTIONS(3744),
    [sym_predefined_type] = ACTIONS(3744),
    [anon_sym_yield] = ACTIONS(3744),
    [anon_sym_when] = ACTIONS(3744),
    [anon_sym_from] = ACTIONS(3744),
    [anon_sym_into] = ACTIONS(3744),
    [anon_sym_join] = ACTIONS(3744),
    [anon_sym_on] = ACTIONS(3744),
    [anon_sym_equals] = ACTIONS(3744),
    [anon_sym_let] = ACTIONS(3744),
    [anon_sym_orderby] = ACTIONS(3744),
    [anon_sym_ascending] = ACTIONS(3744),
    [anon_sym_descending] = ACTIONS(3744),
    [anon_sym_group] = ACTIONS(3744),
    [anon_sym_by] = ACTIONS(3744),
    [anon_sym_select] = ACTIONS(3744),
    [aux_sym_preproc_if_token1] = ACTIONS(3746),
    [aux_sym_preproc_if_token3] = ACTIONS(3746),
    [aux_sym_preproc_else_token1] = ACTIONS(3746),
    [aux_sym_preproc_elif_token1] = ACTIONS(3746),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3335] = {
    [sym_preproc_region] = STATE(3335),
    [sym_preproc_endregion] = STATE(3335),
    [sym_preproc_line] = STATE(3335),
    [sym_preproc_pragma] = STATE(3335),
    [sym_preproc_nullable] = STATE(3335),
    [sym_preproc_error] = STATE(3335),
    [sym_preproc_define] = STATE(3335),
    [sym_preproc_undef] = STATE(3335),
    [sym__identifier_token] = ACTIONS(4983),
    [anon_sym_extern] = ACTIONS(4983),
    [anon_sym_alias] = ACTIONS(4983),
    [anon_sym_global] = ACTIONS(4983),
    [anon_sym_using] = ACTIONS(4983),
    [anon_sym_unsafe] = ACTIONS(4983),
    [anon_sym_static] = ACTIONS(4983),
    [anon_sym_LBRACK] = ACTIONS(4985),
    [anon_sym_LPAREN] = ACTIONS(4985),
    [anon_sym_event] = ACTIONS(4983),
    [anon_sym_namespace] = ACTIONS(4983),
    [anon_sym_class] = ACTIONS(4983),
    [anon_sym_ref] = ACTIONS(4983),
    [anon_sym_struct] = ACTIONS(4983),
    [anon_sym_enum] = ACTIONS(4983),
    [anon_sym_RBRACE] = ACTIONS(4985),
    [anon_sym_interface] = ACTIONS(4983),
    [anon_sym_delegate] = ACTIONS(4983),
    [anon_sym_record] = ACTIONS(4983),
    [anon_sym_abstract] = ACTIONS(4983),
    [anon_sym_async] = ACTIONS(4983),
    [anon_sym_const] = ACTIONS(4983),
    [anon_sym_file] = ACTIONS(4983),
    [anon_sym_fixed] = ACTIONS(4983),
    [anon_sym_internal] = ACTIONS(4983),
    [anon_sym_new] = ACTIONS(4983),
    [anon_sym_override] = ACTIONS(4983),
    [anon_sym_partial] = ACTIONS(4983),
    [anon_sym_private] = ACTIONS(4983),
    [anon_sym_protected] = ACTIONS(4983),
    [anon_sym_public] = ACTIONS(4983),
    [anon_sym_readonly] = ACTIONS(4983),
    [anon_sym_required] = ACTIONS(4983),
    [anon_sym_sealed] = ACTIONS(4983),
    [anon_sym_virtual] = ACTIONS(4983),
    [anon_sym_volatile] = ACTIONS(4983),
    [anon_sym_where] = ACTIONS(4983),
    [anon_sym_notnull] = ACTIONS(4983),
    [anon_sym_unmanaged] = ACTIONS(4983),
    [anon_sym_TILDE] = ACTIONS(4985),
    [anon_sym_implicit] = ACTIONS(4983),
    [anon_sym_explicit] = ACTIONS(4983),
    [anon_sym_scoped] = ACTIONS(4983),
    [anon_sym_var] = ACTIONS(4983),
    [sym_predefined_type] = ACTIONS(4983),
    [anon_sym_yield] = ACTIONS(4983),
    [anon_sym_when] = ACTIONS(4983),
    [anon_sym_from] = ACTIONS(4983),
    [anon_sym_into] = ACTIONS(4983),
    [anon_sym_join] = ACTIONS(4983),
    [anon_sym_on] = ACTIONS(4983),
    [anon_sym_equals] = ACTIONS(4983),
    [anon_sym_let] = ACTIONS(4983),
    [anon_sym_orderby] = ACTIONS(4983),
    [anon_sym_ascending] = ACTIONS(4983),
    [anon_sym_descending] = ACTIONS(4983),
    [anon_sym_group] = ACTIONS(4983),
    [anon_sym_by] = ACTIONS(4983),
    [anon_sym_select] = ACTIONS(4983),
    [aux_sym_preproc_if_token1] = ACTIONS(4985),
    [aux_sym_preproc_if_token3] = ACTIONS(4985),
    [aux_sym_preproc_else_token1] = ACTIONS(4985),
    [aux_sym_preproc_elif_token1] = ACTIONS(4985),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3336] = {
    [sym_preproc_region] = STATE(3336),
    [sym_preproc_endregion] = STATE(3336),
    [sym_preproc_line] = STATE(3336),
    [sym_preproc_pragma] = STATE(3336),
    [sym_preproc_nullable] = STATE(3336),
    [sym_preproc_error] = STATE(3336),
    [sym_preproc_define] = STATE(3336),
    [sym_preproc_undef] = STATE(3336),
    [sym__identifier_token] = ACTIONS(4070),
    [anon_sym_alias] = ACTIONS(4070),
    [anon_sym_global] = ACTIONS(4070),
    [anon_sym_LBRACK] = ACTIONS(4072),
    [anon_sym_COLON] = ACTIONS(4072),
    [anon_sym_COMMA] = ACTIONS(4072),
    [anon_sym_LPAREN] = ACTIONS(4072),
    [anon_sym_LBRACE] = ACTIONS(4072),
    [anon_sym_file] = ACTIONS(4070),
    [anon_sym_LT] = ACTIONS(4070),
    [anon_sym_GT] = ACTIONS(4070),
    [anon_sym_where] = ACTIONS(4070),
    [anon_sym_QMARK] = ACTIONS(4070),
    [anon_sym_notnull] = ACTIONS(4070),
    [anon_sym_unmanaged] = ACTIONS(4070),
    [anon_sym_BANG] = ACTIONS(4070),
    [anon_sym_PLUS_PLUS] = ACTIONS(4072),
    [anon_sym_DASH_DASH] = ACTIONS(4072),
    [anon_sym_PLUS] = ACTIONS(4070),
    [anon_sym_DASH] = ACTIONS(4070),
    [anon_sym_STAR] = ACTIONS(4072),
    [anon_sym_SLASH] = ACTIONS(4070),
    [anon_sym_PERCENT] = ACTIONS(4072),
    [anon_sym_CARET] = ACTIONS(4072),
    [anon_sym_PIPE] = ACTIONS(4070),
    [anon_sym_AMP] = ACTIONS(4070),
    [anon_sym_LT_LT] = ACTIONS(4072),
    [anon_sym_GT_GT] = ACTIONS(4070),
    [anon_sym_GT_GT_GT] = ACTIONS(4072),
    [anon_sym_EQ_EQ] = ACTIONS(4072),
    [anon_sym_BANG_EQ] = ACTIONS(4072),
    [anon_sym_GT_EQ] = ACTIONS(4072),
    [anon_sym_LT_EQ] = ACTIONS(4072),
    [anon_sym_DOT] = ACTIONS(4070),
    [anon_sym_scoped] = ACTIONS(4070),
    [anon_sym_var] = ACTIONS(4070),
    [anon_sym_yield] = ACTIONS(4070),
    [anon_sym_switch] = ACTIONS(4070),
    [anon_sym_when] = ACTIONS(4070),
    [sym_discard] = ACTIONS(4070),
    [anon_sym_DOT_DOT] = ACTIONS(4072),
    [anon_sym_and] = ACTIONS(4070),
    [anon_sym_or] = ACTIONS(4070),
    [anon_sym_AMP_AMP] = ACTIONS(4072),
    [anon_sym_PIPE_PIPE] = ACTIONS(4072),
    [anon_sym_QMARK_QMARK] = ACTIONS(4072),
    [anon_sym_from] = ACTIONS(4070),
    [anon_sym_into] = ACTIONS(4070),
    [anon_sym_join] = ACTIONS(4070),
    [anon_sym_on] = ACTIONS(4070),
    [anon_sym_equals] = ACTIONS(4070),
    [anon_sym_let] = ACTIONS(4070),
    [anon_sym_orderby] = ACTIONS(4070),
    [anon_sym_ascending] = ACTIONS(4070),
    [anon_sym_descending] = ACTIONS(4070),
    [anon_sym_group] = ACTIONS(4070),
    [anon_sym_by] = ACTIONS(4070),
    [anon_sym_select] = ACTIONS(4070),
    [anon_sym_as] = ACTIONS(4070),
    [anon_sym_is] = ACTIONS(4070),
    [anon_sym_DASH_GT] = ACTIONS(4072),
    [anon_sym_with] = ACTIONS(4070),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4072),
  },
  [3337] = {
    [sym_preproc_region] = STATE(3337),
    [sym_preproc_endregion] = STATE(3337),
    [sym_preproc_line] = STATE(3337),
    [sym_preproc_pragma] = STATE(3337),
    [sym_preproc_nullable] = STATE(3337),
    [sym_preproc_error] = STATE(3337),
    [sym_preproc_define] = STATE(3337),
    [sym_preproc_undef] = STATE(3337),
    [sym__identifier_token] = ACTIONS(4422),
    [anon_sym_alias] = ACTIONS(4422),
    [anon_sym_global] = ACTIONS(4422),
    [anon_sym_LBRACK] = ACTIONS(4547),
    [anon_sym_COLON] = ACTIONS(4424),
    [anon_sym_COMMA] = ACTIONS(4424),
    [anon_sym_LPAREN] = ACTIONS(4424),
    [anon_sym_LBRACE] = ACTIONS(4424),
    [anon_sym_file] = ACTIONS(4422),
    [anon_sym_LT] = ACTIONS(4422),
    [anon_sym_GT] = ACTIONS(4422),
    [anon_sym_where] = ACTIONS(4422),
    [anon_sym_QMARK] = ACTIONS(4932),
    [anon_sym_notnull] = ACTIONS(4422),
    [anon_sym_unmanaged] = ACTIONS(4422),
    [anon_sym_BANG] = ACTIONS(4422),
    [anon_sym_PLUS_PLUS] = ACTIONS(4424),
    [anon_sym_DASH_DASH] = ACTIONS(4424),
    [anon_sym_PLUS] = ACTIONS(4422),
    [anon_sym_DASH] = ACTIONS(4422),
    [anon_sym_STAR] = ACTIONS(4553),
    [anon_sym_SLASH] = ACTIONS(4422),
    [anon_sym_PERCENT] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4424),
    [anon_sym_PIPE] = ACTIONS(4422),
    [anon_sym_AMP] = ACTIONS(4422),
    [anon_sym_LT_LT] = ACTIONS(4424),
    [anon_sym_GT_GT] = ACTIONS(4422),
    [anon_sym_GT_GT_GT] = ACTIONS(4424),
    [anon_sym_EQ_EQ] = ACTIONS(4424),
    [anon_sym_BANG_EQ] = ACTIONS(4424),
    [anon_sym_GT_EQ] = ACTIONS(4424),
    [anon_sym_LT_EQ] = ACTIONS(4424),
    [anon_sym_DOT] = ACTIONS(4987),
    [anon_sym_scoped] = ACTIONS(4422),
    [anon_sym_var] = ACTIONS(4422),
    [anon_sym_yield] = ACTIONS(4422),
    [anon_sym_switch] = ACTIONS(4422),
    [anon_sym_when] = ACTIONS(4422),
    [sym_discard] = ACTIONS(4422),
    [anon_sym_DOT_DOT] = ACTIONS(4424),
    [anon_sym_and] = ACTIONS(4422),
    [anon_sym_or] = ACTIONS(4422),
    [anon_sym_AMP_AMP] = ACTIONS(4424),
    [anon_sym_PIPE_PIPE] = ACTIONS(4424),
    [anon_sym_QMARK_QMARK] = ACTIONS(4424),
    [anon_sym_from] = ACTIONS(4422),
    [anon_sym_into] = ACTIONS(4422),
    [anon_sym_join] = ACTIONS(4422),
    [anon_sym_on] = ACTIONS(4422),
    [anon_sym_equals] = ACTIONS(4422),
    [anon_sym_let] = ACTIONS(4422),
    [anon_sym_orderby] = ACTIONS(4422),
    [anon_sym_ascending] = ACTIONS(4422),
    [anon_sym_descending] = ACTIONS(4422),
    [anon_sym_group] = ACTIONS(4422),
    [anon_sym_by] = ACTIONS(4422),
    [anon_sym_select] = ACTIONS(4422),
    [anon_sym_as] = ACTIONS(4422),
    [anon_sym_is] = ACTIONS(4422),
    [anon_sym_DASH_GT] = ACTIONS(4562),
    [anon_sym_with] = ACTIONS(4422),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4424),
  },
  [3338] = {
    [sym_preproc_region] = STATE(3338),
    [sym_preproc_endregion] = STATE(3338),
    [sym_preproc_line] = STATE(3338),
    [sym_preproc_pragma] = STATE(3338),
    [sym_preproc_nullable] = STATE(3338),
    [sym_preproc_error] = STATE(3338),
    [sym_preproc_define] = STATE(3338),
    [sym_preproc_undef] = STATE(3338),
    [sym__identifier_token] = ACTIONS(3924),
    [anon_sym_extern] = ACTIONS(3924),
    [anon_sym_alias] = ACTIONS(3924),
    [anon_sym_global] = ACTIONS(3924),
    [anon_sym_using] = ACTIONS(3924),
    [anon_sym_unsafe] = ACTIONS(3924),
    [anon_sym_static] = ACTIONS(3924),
    [anon_sym_LBRACK] = ACTIONS(3926),
    [anon_sym_LPAREN] = ACTIONS(3926),
    [anon_sym_event] = ACTIONS(3924),
    [anon_sym_namespace] = ACTIONS(3924),
    [anon_sym_class] = ACTIONS(3924),
    [anon_sym_ref] = ACTIONS(3924),
    [anon_sym_struct] = ACTIONS(3924),
    [anon_sym_enum] = ACTIONS(3924),
    [anon_sym_RBRACE] = ACTIONS(3926),
    [anon_sym_interface] = ACTIONS(3924),
    [anon_sym_delegate] = ACTIONS(3924),
    [anon_sym_record] = ACTIONS(3924),
    [anon_sym_abstract] = ACTIONS(3924),
    [anon_sym_async] = ACTIONS(3924),
    [anon_sym_const] = ACTIONS(3924),
    [anon_sym_file] = ACTIONS(3924),
    [anon_sym_fixed] = ACTIONS(3924),
    [anon_sym_internal] = ACTIONS(3924),
    [anon_sym_new] = ACTIONS(3924),
    [anon_sym_override] = ACTIONS(3924),
    [anon_sym_partial] = ACTIONS(3924),
    [anon_sym_private] = ACTIONS(3924),
    [anon_sym_protected] = ACTIONS(3924),
    [anon_sym_public] = ACTIONS(3924),
    [anon_sym_readonly] = ACTIONS(3924),
    [anon_sym_required] = ACTIONS(3924),
    [anon_sym_sealed] = ACTIONS(3924),
    [anon_sym_virtual] = ACTIONS(3924),
    [anon_sym_volatile] = ACTIONS(3924),
    [anon_sym_where] = ACTIONS(3924),
    [anon_sym_notnull] = ACTIONS(3924),
    [anon_sym_unmanaged] = ACTIONS(3924),
    [anon_sym_TILDE] = ACTIONS(3926),
    [anon_sym_implicit] = ACTIONS(3924),
    [anon_sym_explicit] = ACTIONS(3924),
    [anon_sym_scoped] = ACTIONS(3924),
    [anon_sym_var] = ACTIONS(3924),
    [sym_predefined_type] = ACTIONS(3924),
    [anon_sym_yield] = ACTIONS(3924),
    [anon_sym_when] = ACTIONS(3924),
    [anon_sym_from] = ACTIONS(3924),
    [anon_sym_into] = ACTIONS(3924),
    [anon_sym_join] = ACTIONS(3924),
    [anon_sym_on] = ACTIONS(3924),
    [anon_sym_equals] = ACTIONS(3924),
    [anon_sym_let] = ACTIONS(3924),
    [anon_sym_orderby] = ACTIONS(3924),
    [anon_sym_ascending] = ACTIONS(3924),
    [anon_sym_descending] = ACTIONS(3924),
    [anon_sym_group] = ACTIONS(3924),
    [anon_sym_by] = ACTIONS(3924),
    [anon_sym_select] = ACTIONS(3924),
    [aux_sym_preproc_if_token1] = ACTIONS(3926),
    [aux_sym_preproc_if_token3] = ACTIONS(3926),
    [aux_sym_preproc_else_token1] = ACTIONS(3926),
    [aux_sym_preproc_elif_token1] = ACTIONS(3926),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3339] = {
    [sym_preproc_region] = STATE(3339),
    [sym_preproc_endregion] = STATE(3339),
    [sym_preproc_line] = STATE(3339),
    [sym_preproc_pragma] = STATE(3339),
    [sym_preproc_nullable] = STATE(3339),
    [sym_preproc_error] = STATE(3339),
    [sym_preproc_define] = STATE(3339),
    [sym_preproc_undef] = STATE(3339),
    [sym__identifier_token] = ACTIONS(3928),
    [anon_sym_extern] = ACTIONS(3928),
    [anon_sym_alias] = ACTIONS(3928),
    [anon_sym_global] = ACTIONS(3928),
    [anon_sym_using] = ACTIONS(3928),
    [anon_sym_unsafe] = ACTIONS(3928),
    [anon_sym_static] = ACTIONS(3928),
    [anon_sym_LBRACK] = ACTIONS(3930),
    [anon_sym_LPAREN] = ACTIONS(3930),
    [anon_sym_event] = ACTIONS(3928),
    [anon_sym_namespace] = ACTIONS(3928),
    [anon_sym_class] = ACTIONS(3928),
    [anon_sym_ref] = ACTIONS(3928),
    [anon_sym_struct] = ACTIONS(3928),
    [anon_sym_enum] = ACTIONS(3928),
    [anon_sym_RBRACE] = ACTIONS(3930),
    [anon_sym_interface] = ACTIONS(3928),
    [anon_sym_delegate] = ACTIONS(3928),
    [anon_sym_record] = ACTIONS(3928),
    [anon_sym_abstract] = ACTIONS(3928),
    [anon_sym_async] = ACTIONS(3928),
    [anon_sym_const] = ACTIONS(3928),
    [anon_sym_file] = ACTIONS(3928),
    [anon_sym_fixed] = ACTIONS(3928),
    [anon_sym_internal] = ACTIONS(3928),
    [anon_sym_new] = ACTIONS(3928),
    [anon_sym_override] = ACTIONS(3928),
    [anon_sym_partial] = ACTIONS(3928),
    [anon_sym_private] = ACTIONS(3928),
    [anon_sym_protected] = ACTIONS(3928),
    [anon_sym_public] = ACTIONS(3928),
    [anon_sym_readonly] = ACTIONS(3928),
    [anon_sym_required] = ACTIONS(3928),
    [anon_sym_sealed] = ACTIONS(3928),
    [anon_sym_virtual] = ACTIONS(3928),
    [anon_sym_volatile] = ACTIONS(3928),
    [anon_sym_where] = ACTIONS(3928),
    [anon_sym_notnull] = ACTIONS(3928),
    [anon_sym_unmanaged] = ACTIONS(3928),
    [anon_sym_TILDE] = ACTIONS(3930),
    [anon_sym_implicit] = ACTIONS(3928),
    [anon_sym_explicit] = ACTIONS(3928),
    [anon_sym_scoped] = ACTIONS(3928),
    [anon_sym_var] = ACTIONS(3928),
    [sym_predefined_type] = ACTIONS(3928),
    [anon_sym_yield] = ACTIONS(3928),
    [anon_sym_when] = ACTIONS(3928),
    [anon_sym_from] = ACTIONS(3928),
    [anon_sym_into] = ACTIONS(3928),
    [anon_sym_join] = ACTIONS(3928),
    [anon_sym_on] = ACTIONS(3928),
    [anon_sym_equals] = ACTIONS(3928),
    [anon_sym_let] = ACTIONS(3928),
    [anon_sym_orderby] = ACTIONS(3928),
    [anon_sym_ascending] = ACTIONS(3928),
    [anon_sym_descending] = ACTIONS(3928),
    [anon_sym_group] = ACTIONS(3928),
    [anon_sym_by] = ACTIONS(3928),
    [anon_sym_select] = ACTIONS(3928),
    [aux_sym_preproc_if_token1] = ACTIONS(3930),
    [aux_sym_preproc_if_token3] = ACTIONS(3930),
    [aux_sym_preproc_else_token1] = ACTIONS(3930),
    [aux_sym_preproc_elif_token1] = ACTIONS(3930),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3340] = {
    [sym_preproc_region] = STATE(3340),
    [sym_preproc_endregion] = STATE(3340),
    [sym_preproc_line] = STATE(3340),
    [sym_preproc_pragma] = STATE(3340),
    [sym_preproc_nullable] = STATE(3340),
    [sym_preproc_error] = STATE(3340),
    [sym_preproc_define] = STATE(3340),
    [sym_preproc_undef] = STATE(3340),
    [sym__identifier_token] = ACTIONS(4387),
    [anon_sym_alias] = ACTIONS(4387),
    [anon_sym_global] = ACTIONS(4387),
    [anon_sym_LBRACK] = ACTIONS(4389),
    [anon_sym_COLON] = ACTIONS(4389),
    [anon_sym_COMMA] = ACTIONS(4389),
    [anon_sym_LPAREN] = ACTIONS(4389),
    [anon_sym_LBRACE] = ACTIONS(4389),
    [anon_sym_file] = ACTIONS(4387),
    [anon_sym_LT] = ACTIONS(4387),
    [anon_sym_GT] = ACTIONS(4387),
    [anon_sym_where] = ACTIONS(4387),
    [anon_sym_QMARK] = ACTIONS(4387),
    [anon_sym_notnull] = ACTIONS(4387),
    [anon_sym_unmanaged] = ACTIONS(4387),
    [anon_sym_BANG] = ACTIONS(4387),
    [anon_sym_PLUS_PLUS] = ACTIONS(4389),
    [anon_sym_DASH_DASH] = ACTIONS(4389),
    [anon_sym_PLUS] = ACTIONS(4387),
    [anon_sym_DASH] = ACTIONS(4387),
    [anon_sym_STAR] = ACTIONS(4389),
    [anon_sym_SLASH] = ACTIONS(4387),
    [anon_sym_PERCENT] = ACTIONS(4389),
    [anon_sym_CARET] = ACTIONS(4389),
    [anon_sym_PIPE] = ACTIONS(4387),
    [anon_sym_AMP] = ACTIONS(4387),
    [anon_sym_LT_LT] = ACTIONS(4389),
    [anon_sym_GT_GT] = ACTIONS(4387),
    [anon_sym_GT_GT_GT] = ACTIONS(4389),
    [anon_sym_EQ_EQ] = ACTIONS(4389),
    [anon_sym_BANG_EQ] = ACTIONS(4389),
    [anon_sym_GT_EQ] = ACTIONS(4389),
    [anon_sym_LT_EQ] = ACTIONS(4389),
    [anon_sym_DOT] = ACTIONS(4387),
    [anon_sym_scoped] = ACTIONS(4387),
    [anon_sym_var] = ACTIONS(4387),
    [anon_sym_yield] = ACTIONS(4387),
    [anon_sym_switch] = ACTIONS(4387),
    [anon_sym_when] = ACTIONS(4387),
    [sym_discard] = ACTIONS(4387),
    [anon_sym_DOT_DOT] = ACTIONS(4389),
    [anon_sym_and] = ACTIONS(4387),
    [anon_sym_or] = ACTIONS(4387),
    [anon_sym_AMP_AMP] = ACTIONS(4389),
    [anon_sym_PIPE_PIPE] = ACTIONS(4389),
    [anon_sym_QMARK_QMARK] = ACTIONS(4389),
    [anon_sym_from] = ACTIONS(4387),
    [anon_sym_into] = ACTIONS(4387),
    [anon_sym_join] = ACTIONS(4387),
    [anon_sym_on] = ACTIONS(4387),
    [anon_sym_equals] = ACTIONS(4387),
    [anon_sym_let] = ACTIONS(4387),
    [anon_sym_orderby] = ACTIONS(4387),
    [anon_sym_ascending] = ACTIONS(4387),
    [anon_sym_descending] = ACTIONS(4387),
    [anon_sym_group] = ACTIONS(4387),
    [anon_sym_by] = ACTIONS(4387),
    [anon_sym_select] = ACTIONS(4387),
    [anon_sym_as] = ACTIONS(4387),
    [anon_sym_is] = ACTIONS(4387),
    [anon_sym_DASH_GT] = ACTIONS(4389),
    [anon_sym_with] = ACTIONS(4387),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4389),
  },
  [3341] = {
    [sym_preproc_region] = STATE(3341),
    [sym_preproc_endregion] = STATE(3341),
    [sym_preproc_line] = STATE(3341),
    [sym_preproc_pragma] = STATE(3341),
    [sym_preproc_nullable] = STATE(3341),
    [sym_preproc_error] = STATE(3341),
    [sym_preproc_define] = STATE(3341),
    [sym_preproc_undef] = STATE(3341),
    [sym__identifier_token] = ACTIONS(4060),
    [anon_sym_alias] = ACTIONS(4060),
    [anon_sym_global] = ACTIONS(4060),
    [anon_sym_LBRACK] = ACTIONS(4062),
    [anon_sym_COLON] = ACTIONS(4062),
    [anon_sym_COMMA] = ACTIONS(4062),
    [anon_sym_LPAREN] = ACTIONS(4062),
    [anon_sym_LBRACE] = ACTIONS(4062),
    [anon_sym_file] = ACTIONS(4060),
    [anon_sym_LT] = ACTIONS(4060),
    [anon_sym_GT] = ACTIONS(4060),
    [anon_sym_where] = ACTIONS(4060),
    [anon_sym_QMARK] = ACTIONS(4060),
    [anon_sym_notnull] = ACTIONS(4060),
    [anon_sym_unmanaged] = ACTIONS(4060),
    [anon_sym_BANG] = ACTIONS(4060),
    [anon_sym_PLUS_PLUS] = ACTIONS(4062),
    [anon_sym_DASH_DASH] = ACTIONS(4062),
    [anon_sym_PLUS] = ACTIONS(4060),
    [anon_sym_DASH] = ACTIONS(4060),
    [anon_sym_STAR] = ACTIONS(4062),
    [anon_sym_SLASH] = ACTIONS(4060),
    [anon_sym_PERCENT] = ACTIONS(4062),
    [anon_sym_CARET] = ACTIONS(4062),
    [anon_sym_PIPE] = ACTIONS(4060),
    [anon_sym_AMP] = ACTIONS(4060),
    [anon_sym_LT_LT] = ACTIONS(4062),
    [anon_sym_GT_GT] = ACTIONS(4060),
    [anon_sym_GT_GT_GT] = ACTIONS(4062),
    [anon_sym_EQ_EQ] = ACTIONS(4062),
    [anon_sym_BANG_EQ] = ACTIONS(4062),
    [anon_sym_GT_EQ] = ACTIONS(4062),
    [anon_sym_LT_EQ] = ACTIONS(4062),
    [anon_sym_DOT] = ACTIONS(4060),
    [anon_sym_scoped] = ACTIONS(4060),
    [anon_sym_var] = ACTIONS(4060),
    [anon_sym_yield] = ACTIONS(4060),
    [anon_sym_switch] = ACTIONS(4060),
    [anon_sym_when] = ACTIONS(4060),
    [sym_discard] = ACTIONS(4060),
    [anon_sym_DOT_DOT] = ACTIONS(4062),
    [anon_sym_and] = ACTIONS(4060),
    [anon_sym_or] = ACTIONS(4060),
    [anon_sym_AMP_AMP] = ACTIONS(4062),
    [anon_sym_PIPE_PIPE] = ACTIONS(4062),
    [anon_sym_QMARK_QMARK] = ACTIONS(4062),
    [anon_sym_from] = ACTIONS(4060),
    [anon_sym_into] = ACTIONS(4060),
    [anon_sym_join] = ACTIONS(4060),
    [anon_sym_on] = ACTIONS(4060),
    [anon_sym_equals] = ACTIONS(4060),
    [anon_sym_let] = ACTIONS(4060),
    [anon_sym_orderby] = ACTIONS(4060),
    [anon_sym_ascending] = ACTIONS(4060),
    [anon_sym_descending] = ACTIONS(4060),
    [anon_sym_group] = ACTIONS(4060),
    [anon_sym_by] = ACTIONS(4060),
    [anon_sym_select] = ACTIONS(4060),
    [anon_sym_as] = ACTIONS(4060),
    [anon_sym_is] = ACTIONS(4060),
    [anon_sym_DASH_GT] = ACTIONS(4062),
    [anon_sym_with] = ACTIONS(4060),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4062),
  },
  [3342] = {
    [sym_preproc_region] = STATE(3342),
    [sym_preproc_endregion] = STATE(3342),
    [sym_preproc_line] = STATE(3342),
    [sym_preproc_pragma] = STATE(3342),
    [sym_preproc_nullable] = STATE(3342),
    [sym_preproc_error] = STATE(3342),
    [sym_preproc_define] = STATE(3342),
    [sym_preproc_undef] = STATE(3342),
    [sym__identifier_token] = ACTIONS(4414),
    [anon_sym_alias] = ACTIONS(4414),
    [anon_sym_global] = ACTIONS(4414),
    [anon_sym_LBRACK] = ACTIONS(4416),
    [anon_sym_COLON] = ACTIONS(4416),
    [anon_sym_COMMA] = ACTIONS(4416),
    [anon_sym_LPAREN] = ACTIONS(4416),
    [anon_sym_LBRACE] = ACTIONS(4416),
    [anon_sym_file] = ACTIONS(4414),
    [anon_sym_LT] = ACTIONS(4414),
    [anon_sym_GT] = ACTIONS(4414),
    [anon_sym_where] = ACTIONS(4414),
    [anon_sym_QMARK] = ACTIONS(4414),
    [anon_sym_notnull] = ACTIONS(4414),
    [anon_sym_unmanaged] = ACTIONS(4414),
    [anon_sym_BANG] = ACTIONS(4414),
    [anon_sym_PLUS_PLUS] = ACTIONS(4416),
    [anon_sym_DASH_DASH] = ACTIONS(4416),
    [anon_sym_PLUS] = ACTIONS(4414),
    [anon_sym_DASH] = ACTIONS(4414),
    [anon_sym_STAR] = ACTIONS(4416),
    [anon_sym_SLASH] = ACTIONS(4414),
    [anon_sym_PERCENT] = ACTIONS(4416),
    [anon_sym_CARET] = ACTIONS(4416),
    [anon_sym_PIPE] = ACTIONS(4414),
    [anon_sym_AMP] = ACTIONS(4414),
    [anon_sym_LT_LT] = ACTIONS(4416),
    [anon_sym_GT_GT] = ACTIONS(4414),
    [anon_sym_GT_GT_GT] = ACTIONS(4416),
    [anon_sym_EQ_EQ] = ACTIONS(4416),
    [anon_sym_BANG_EQ] = ACTIONS(4416),
    [anon_sym_GT_EQ] = ACTIONS(4416),
    [anon_sym_LT_EQ] = ACTIONS(4416),
    [anon_sym_DOT] = ACTIONS(4414),
    [anon_sym_scoped] = ACTIONS(4414),
    [anon_sym_var] = ACTIONS(4414),
    [anon_sym_yield] = ACTIONS(4414),
    [anon_sym_switch] = ACTIONS(4414),
    [anon_sym_when] = ACTIONS(4414),
    [sym_discard] = ACTIONS(4414),
    [anon_sym_DOT_DOT] = ACTIONS(4416),
    [anon_sym_and] = ACTIONS(4414),
    [anon_sym_or] = ACTIONS(4414),
    [anon_sym_AMP_AMP] = ACTIONS(4416),
    [anon_sym_PIPE_PIPE] = ACTIONS(4416),
    [anon_sym_QMARK_QMARK] = ACTIONS(4416),
    [anon_sym_from] = ACTIONS(4414),
    [anon_sym_into] = ACTIONS(4414),
    [anon_sym_join] = ACTIONS(4414),
    [anon_sym_on] = ACTIONS(4414),
    [anon_sym_equals] = ACTIONS(4414),
    [anon_sym_let] = ACTIONS(4414),
    [anon_sym_orderby] = ACTIONS(4414),
    [anon_sym_ascending] = ACTIONS(4414),
    [anon_sym_descending] = ACTIONS(4414),
    [anon_sym_group] = ACTIONS(4414),
    [anon_sym_by] = ACTIONS(4414),
    [anon_sym_select] = ACTIONS(4414),
    [anon_sym_as] = ACTIONS(4414),
    [anon_sym_is] = ACTIONS(4414),
    [anon_sym_DASH_GT] = ACTIONS(4416),
    [anon_sym_with] = ACTIONS(4414),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4416),
  },
  [3343] = {
    [sym_preproc_region] = STATE(3343),
    [sym_preproc_endregion] = STATE(3343),
    [sym_preproc_line] = STATE(3343),
    [sym_preproc_pragma] = STATE(3343),
    [sym_preproc_nullable] = STATE(3343),
    [sym_preproc_error] = STATE(3343),
    [sym_preproc_define] = STATE(3343),
    [sym_preproc_undef] = STATE(3343),
    [sym__identifier_token] = ACTIONS(4989),
    [anon_sym_extern] = ACTIONS(4989),
    [anon_sym_alias] = ACTIONS(4989),
    [anon_sym_global] = ACTIONS(4989),
    [anon_sym_using] = ACTIONS(4989),
    [anon_sym_unsafe] = ACTIONS(4989),
    [anon_sym_static] = ACTIONS(4989),
    [anon_sym_LBRACK] = ACTIONS(4991),
    [anon_sym_LPAREN] = ACTIONS(4991),
    [anon_sym_event] = ACTIONS(4989),
    [anon_sym_namespace] = ACTIONS(4989),
    [anon_sym_class] = ACTIONS(4989),
    [anon_sym_ref] = ACTIONS(4989),
    [anon_sym_struct] = ACTIONS(4989),
    [anon_sym_enum] = ACTIONS(4989),
    [anon_sym_RBRACE] = ACTIONS(4991),
    [anon_sym_interface] = ACTIONS(4989),
    [anon_sym_delegate] = ACTIONS(4989),
    [anon_sym_record] = ACTIONS(4989),
    [anon_sym_abstract] = ACTIONS(4989),
    [anon_sym_async] = ACTIONS(4989),
    [anon_sym_const] = ACTIONS(4989),
    [anon_sym_file] = ACTIONS(4989),
    [anon_sym_fixed] = ACTIONS(4989),
    [anon_sym_internal] = ACTIONS(4989),
    [anon_sym_new] = ACTIONS(4989),
    [anon_sym_override] = ACTIONS(4989),
    [anon_sym_partial] = ACTIONS(4989),
    [anon_sym_private] = ACTIONS(4989),
    [anon_sym_protected] = ACTIONS(4989),
    [anon_sym_public] = ACTIONS(4989),
    [anon_sym_readonly] = ACTIONS(4989),
    [anon_sym_required] = ACTIONS(4989),
    [anon_sym_sealed] = ACTIONS(4989),
    [anon_sym_virtual] = ACTIONS(4989),
    [anon_sym_volatile] = ACTIONS(4989),
    [anon_sym_where] = ACTIONS(4989),
    [anon_sym_notnull] = ACTIONS(4989),
    [anon_sym_unmanaged] = ACTIONS(4989),
    [anon_sym_TILDE] = ACTIONS(4991),
    [anon_sym_implicit] = ACTIONS(4989),
    [anon_sym_explicit] = ACTIONS(4989),
    [anon_sym_scoped] = ACTIONS(4989),
    [anon_sym_var] = ACTIONS(4989),
    [sym_predefined_type] = ACTIONS(4989),
    [anon_sym_yield] = ACTIONS(4989),
    [anon_sym_when] = ACTIONS(4989),
    [anon_sym_from] = ACTIONS(4989),
    [anon_sym_into] = ACTIONS(4989),
    [anon_sym_join] = ACTIONS(4989),
    [anon_sym_on] = ACTIONS(4989),
    [anon_sym_equals] = ACTIONS(4989),
    [anon_sym_let] = ACTIONS(4989),
    [anon_sym_orderby] = ACTIONS(4989),
    [anon_sym_ascending] = ACTIONS(4989),
    [anon_sym_descending] = ACTIONS(4989),
    [anon_sym_group] = ACTIONS(4989),
    [anon_sym_by] = ACTIONS(4989),
    [anon_sym_select] = ACTIONS(4989),
    [aux_sym_preproc_if_token1] = ACTIONS(4991),
    [aux_sym_preproc_if_token3] = ACTIONS(4991),
    [aux_sym_preproc_else_token1] = ACTIONS(4991),
    [aux_sym_preproc_elif_token1] = ACTIONS(4991),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3344] = {
    [sym__variable_designation] = STATE(4986),
    [sym_parenthesized_variable_designation] = STATE(4957),
    [sym_identifier] = STATE(4971),
    [sym__reserved_identifier] = STATE(3558),
    [sym_preproc_region] = STATE(3344),
    [sym_preproc_endregion] = STATE(3344),
    [sym_preproc_line] = STATE(3344),
    [sym_preproc_pragma] = STATE(3344),
    [sym_preproc_nullable] = STATE(3344),
    [sym_preproc_error] = STATE(3344),
    [sym_preproc_define] = STATE(3344),
    [sym_preproc_undef] = STATE(3344),
    [sym__identifier_token] = ACTIONS(4225),
    [anon_sym_alias] = ACTIONS(4227),
    [anon_sym_global] = ACTIONS(4227),
    [anon_sym_LBRACK] = ACTIONS(4329),
    [anon_sym_LPAREN] = ACTIONS(4329),
    [anon_sym_file] = ACTIONS(4227),
    [anon_sym_LT] = ACTIONS(4331),
    [anon_sym_GT] = ACTIONS(4331),
    [anon_sym_where] = ACTIONS(4331),
    [anon_sym_QMARK] = ACTIONS(4331),
    [anon_sym_notnull] = ACTIONS(4227),
    [anon_sym_unmanaged] = ACTIONS(4227),
    [anon_sym_BANG] = ACTIONS(4331),
    [anon_sym_PLUS_PLUS] = ACTIONS(4329),
    [anon_sym_DASH_DASH] = ACTIONS(4329),
    [anon_sym_PLUS] = ACTIONS(4331),
    [anon_sym_DASH] = ACTIONS(4331),
    [anon_sym_STAR] = ACTIONS(4329),
    [anon_sym_SLASH] = ACTIONS(4331),
    [anon_sym_PERCENT] = ACTIONS(4329),
    [anon_sym_CARET] = ACTIONS(4329),
    [anon_sym_PIPE] = ACTIONS(4331),
    [anon_sym_AMP] = ACTIONS(4331),
    [anon_sym_LT_LT] = ACTIONS(4329),
    [anon_sym_GT_GT] = ACTIONS(4331),
    [anon_sym_GT_GT_GT] = ACTIONS(4329),
    [anon_sym_EQ_EQ] = ACTIONS(4329),
    [anon_sym_BANG_EQ] = ACTIONS(4329),
    [anon_sym_GT_EQ] = ACTIONS(4329),
    [anon_sym_LT_EQ] = ACTIONS(4329),
    [anon_sym_DOT] = ACTIONS(4331),
    [anon_sym_scoped] = ACTIONS(4227),
    [anon_sym_var] = ACTIONS(4227),
    [anon_sym_yield] = ACTIONS(4227),
    [anon_sym_switch] = ACTIONS(4331),
    [anon_sym_when] = ACTIONS(4227),
    [sym_discard] = ACTIONS(4649),
    [anon_sym_DOT_DOT] = ACTIONS(4329),
    [anon_sym_and] = ACTIONS(4331),
    [anon_sym_or] = ACTIONS(4331),
    [anon_sym_AMP_AMP] = ACTIONS(4329),
    [anon_sym_PIPE_PIPE] = ACTIONS(4329),
    [anon_sym_QMARK_QMARK] = ACTIONS(4329),
    [anon_sym_from] = ACTIONS(4331),
    [anon_sym_into] = ACTIONS(4331),
    [anon_sym_join] = ACTIONS(4331),
    [anon_sym_on] = ACTIONS(4227),
    [anon_sym_equals] = ACTIONS(4227),
    [anon_sym_let] = ACTIONS(4331),
    [anon_sym_orderby] = ACTIONS(4331),
    [anon_sym_ascending] = ACTIONS(4227),
    [anon_sym_descending] = ACTIONS(4227),
    [anon_sym_group] = ACTIONS(4331),
    [anon_sym_by] = ACTIONS(4227),
    [anon_sym_select] = ACTIONS(4331),
    [anon_sym_as] = ACTIONS(4331),
    [anon_sym_is] = ACTIONS(4331),
    [anon_sym_DASH_GT] = ACTIONS(4329),
    [anon_sym_with] = ACTIONS(4331),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3345] = {
    [sym_preproc_region] = STATE(3345),
    [sym_preproc_endregion] = STATE(3345),
    [sym_preproc_line] = STATE(3345),
    [sym_preproc_pragma] = STATE(3345),
    [sym_preproc_nullable] = STATE(3345),
    [sym_preproc_error] = STATE(3345),
    [sym_preproc_define] = STATE(3345),
    [sym_preproc_undef] = STATE(3345),
    [sym__identifier_token] = ACTIONS(3932),
    [anon_sym_extern] = ACTIONS(3932),
    [anon_sym_alias] = ACTIONS(3932),
    [anon_sym_global] = ACTIONS(3932),
    [anon_sym_using] = ACTIONS(3932),
    [anon_sym_unsafe] = ACTIONS(3932),
    [anon_sym_static] = ACTIONS(3932),
    [anon_sym_LBRACK] = ACTIONS(3934),
    [anon_sym_LPAREN] = ACTIONS(3934),
    [anon_sym_event] = ACTIONS(3932),
    [anon_sym_namespace] = ACTIONS(3932),
    [anon_sym_class] = ACTIONS(3932),
    [anon_sym_ref] = ACTIONS(3932),
    [anon_sym_struct] = ACTIONS(3932),
    [anon_sym_enum] = ACTIONS(3932),
    [anon_sym_RBRACE] = ACTIONS(3934),
    [anon_sym_interface] = ACTIONS(3932),
    [anon_sym_delegate] = ACTIONS(3932),
    [anon_sym_record] = ACTIONS(3932),
    [anon_sym_abstract] = ACTIONS(3932),
    [anon_sym_async] = ACTIONS(3932),
    [anon_sym_const] = ACTIONS(3932),
    [anon_sym_file] = ACTIONS(3932),
    [anon_sym_fixed] = ACTIONS(3932),
    [anon_sym_internal] = ACTIONS(3932),
    [anon_sym_new] = ACTIONS(3932),
    [anon_sym_override] = ACTIONS(3932),
    [anon_sym_partial] = ACTIONS(3932),
    [anon_sym_private] = ACTIONS(3932),
    [anon_sym_protected] = ACTIONS(3932),
    [anon_sym_public] = ACTIONS(3932),
    [anon_sym_readonly] = ACTIONS(3932),
    [anon_sym_required] = ACTIONS(3932),
    [anon_sym_sealed] = ACTIONS(3932),
    [anon_sym_virtual] = ACTIONS(3932),
    [anon_sym_volatile] = ACTIONS(3932),
    [anon_sym_where] = ACTIONS(3932),
    [anon_sym_notnull] = ACTIONS(3932),
    [anon_sym_unmanaged] = ACTIONS(3932),
    [anon_sym_TILDE] = ACTIONS(3934),
    [anon_sym_implicit] = ACTIONS(3932),
    [anon_sym_explicit] = ACTIONS(3932),
    [anon_sym_scoped] = ACTIONS(3932),
    [anon_sym_var] = ACTIONS(3932),
    [sym_predefined_type] = ACTIONS(3932),
    [anon_sym_yield] = ACTIONS(3932),
    [anon_sym_when] = ACTIONS(3932),
    [anon_sym_from] = ACTIONS(3932),
    [anon_sym_into] = ACTIONS(3932),
    [anon_sym_join] = ACTIONS(3932),
    [anon_sym_on] = ACTIONS(3932),
    [anon_sym_equals] = ACTIONS(3932),
    [anon_sym_let] = ACTIONS(3932),
    [anon_sym_orderby] = ACTIONS(3932),
    [anon_sym_ascending] = ACTIONS(3932),
    [anon_sym_descending] = ACTIONS(3932),
    [anon_sym_group] = ACTIONS(3932),
    [anon_sym_by] = ACTIONS(3932),
    [anon_sym_select] = ACTIONS(3932),
    [aux_sym_preproc_if_token1] = ACTIONS(3934),
    [aux_sym_preproc_if_token3] = ACTIONS(3934),
    [aux_sym_preproc_else_token1] = ACTIONS(3934),
    [aux_sym_preproc_elif_token1] = ACTIONS(3934),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3346] = {
    [sym__variable_designation] = STATE(5005),
    [sym_parenthesized_variable_designation] = STATE(4957),
    [sym_identifier] = STATE(4971),
    [sym__reserved_identifier] = STATE(3558),
    [sym_preproc_region] = STATE(3346),
    [sym_preproc_endregion] = STATE(3346),
    [sym_preproc_line] = STATE(3346),
    [sym_preproc_pragma] = STATE(3346),
    [sym_preproc_nullable] = STATE(3346),
    [sym_preproc_error] = STATE(3346),
    [sym_preproc_define] = STATE(3346),
    [sym_preproc_undef] = STATE(3346),
    [sym__identifier_token] = ACTIONS(4225),
    [anon_sym_alias] = ACTIONS(4227),
    [anon_sym_global] = ACTIONS(4227),
    [anon_sym_LBRACK] = ACTIONS(4335),
    [anon_sym_LPAREN] = ACTIONS(4335),
    [anon_sym_file] = ACTIONS(4227),
    [anon_sym_LT] = ACTIONS(4337),
    [anon_sym_GT] = ACTIONS(4337),
    [anon_sym_where] = ACTIONS(4337),
    [anon_sym_QMARK] = ACTIONS(4337),
    [anon_sym_notnull] = ACTIONS(4227),
    [anon_sym_unmanaged] = ACTIONS(4227),
    [anon_sym_BANG] = ACTIONS(4337),
    [anon_sym_PLUS_PLUS] = ACTIONS(4335),
    [anon_sym_DASH_DASH] = ACTIONS(4335),
    [anon_sym_PLUS] = ACTIONS(4337),
    [anon_sym_DASH] = ACTIONS(4337),
    [anon_sym_STAR] = ACTIONS(4335),
    [anon_sym_SLASH] = ACTIONS(4337),
    [anon_sym_PERCENT] = ACTIONS(4335),
    [anon_sym_CARET] = ACTIONS(4335),
    [anon_sym_PIPE] = ACTIONS(4337),
    [anon_sym_AMP] = ACTIONS(4337),
    [anon_sym_LT_LT] = ACTIONS(4335),
    [anon_sym_GT_GT] = ACTIONS(4337),
    [anon_sym_GT_GT_GT] = ACTIONS(4335),
    [anon_sym_EQ_EQ] = ACTIONS(4335),
    [anon_sym_BANG_EQ] = ACTIONS(4335),
    [anon_sym_GT_EQ] = ACTIONS(4335),
    [anon_sym_LT_EQ] = ACTIONS(4335),
    [anon_sym_DOT] = ACTIONS(4337),
    [anon_sym_scoped] = ACTIONS(4227),
    [anon_sym_var] = ACTIONS(4227),
    [anon_sym_yield] = ACTIONS(4227),
    [anon_sym_switch] = ACTIONS(4337),
    [anon_sym_when] = ACTIONS(4227),
    [sym_discard] = ACTIONS(4649),
    [anon_sym_DOT_DOT] = ACTIONS(4335),
    [anon_sym_and] = ACTIONS(4337),
    [anon_sym_or] = ACTIONS(4337),
    [anon_sym_AMP_AMP] = ACTIONS(4335),
    [anon_sym_PIPE_PIPE] = ACTIONS(4335),
    [anon_sym_QMARK_QMARK] = ACTIONS(4335),
    [anon_sym_from] = ACTIONS(4337),
    [anon_sym_into] = ACTIONS(4337),
    [anon_sym_join] = ACTIONS(4337),
    [anon_sym_on] = ACTIONS(4227),
    [anon_sym_equals] = ACTIONS(4227),
    [anon_sym_let] = ACTIONS(4337),
    [anon_sym_orderby] = ACTIONS(4337),
    [anon_sym_ascending] = ACTIONS(4227),
    [anon_sym_descending] = ACTIONS(4227),
    [anon_sym_group] = ACTIONS(4337),
    [anon_sym_by] = ACTIONS(4227),
    [anon_sym_select] = ACTIONS(4337),
    [anon_sym_as] = ACTIONS(4337),
    [anon_sym_is] = ACTIONS(4337),
    [anon_sym_DASH_GT] = ACTIONS(4335),
    [anon_sym_with] = ACTIONS(4337),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3347] = {
    [sym_preproc_region] = STATE(3347),
    [sym_preproc_endregion] = STATE(3347),
    [sym_preproc_line] = STATE(3347),
    [sym_preproc_pragma] = STATE(3347),
    [sym_preproc_nullable] = STATE(3347),
    [sym_preproc_error] = STATE(3347),
    [sym_preproc_define] = STATE(3347),
    [sym_preproc_undef] = STATE(3347),
    [sym__identifier_token] = ACTIONS(4993),
    [anon_sym_extern] = ACTIONS(4993),
    [anon_sym_alias] = ACTIONS(4993),
    [anon_sym_global] = ACTIONS(4993),
    [anon_sym_using] = ACTIONS(4993),
    [anon_sym_unsafe] = ACTIONS(4993),
    [anon_sym_static] = ACTIONS(4993),
    [anon_sym_LBRACK] = ACTIONS(4995),
    [anon_sym_LPAREN] = ACTIONS(4995),
    [anon_sym_event] = ACTIONS(4993),
    [anon_sym_namespace] = ACTIONS(4993),
    [anon_sym_class] = ACTIONS(4993),
    [anon_sym_ref] = ACTIONS(4993),
    [anon_sym_struct] = ACTIONS(4993),
    [anon_sym_enum] = ACTIONS(4993),
    [anon_sym_RBRACE] = ACTIONS(4995),
    [anon_sym_interface] = ACTIONS(4993),
    [anon_sym_delegate] = ACTIONS(4993),
    [anon_sym_record] = ACTIONS(4993),
    [anon_sym_abstract] = ACTIONS(4993),
    [anon_sym_async] = ACTIONS(4993),
    [anon_sym_const] = ACTIONS(4993),
    [anon_sym_file] = ACTIONS(4993),
    [anon_sym_fixed] = ACTIONS(4993),
    [anon_sym_internal] = ACTIONS(4993),
    [anon_sym_new] = ACTIONS(4993),
    [anon_sym_override] = ACTIONS(4993),
    [anon_sym_partial] = ACTIONS(4993),
    [anon_sym_private] = ACTIONS(4993),
    [anon_sym_protected] = ACTIONS(4993),
    [anon_sym_public] = ACTIONS(4993),
    [anon_sym_readonly] = ACTIONS(4993),
    [anon_sym_required] = ACTIONS(4993),
    [anon_sym_sealed] = ACTIONS(4993),
    [anon_sym_virtual] = ACTIONS(4993),
    [anon_sym_volatile] = ACTIONS(4993),
    [anon_sym_where] = ACTIONS(4993),
    [anon_sym_notnull] = ACTIONS(4993),
    [anon_sym_unmanaged] = ACTIONS(4993),
    [anon_sym_TILDE] = ACTIONS(4995),
    [anon_sym_implicit] = ACTIONS(4993),
    [anon_sym_explicit] = ACTIONS(4993),
    [anon_sym_scoped] = ACTIONS(4993),
    [anon_sym_var] = ACTIONS(4993),
    [sym_predefined_type] = ACTIONS(4993),
    [anon_sym_yield] = ACTIONS(4993),
    [anon_sym_when] = ACTIONS(4993),
    [anon_sym_from] = ACTIONS(4993),
    [anon_sym_into] = ACTIONS(4993),
    [anon_sym_join] = ACTIONS(4993),
    [anon_sym_on] = ACTIONS(4993),
    [anon_sym_equals] = ACTIONS(4993),
    [anon_sym_let] = ACTIONS(4993),
    [anon_sym_orderby] = ACTIONS(4993),
    [anon_sym_ascending] = ACTIONS(4993),
    [anon_sym_descending] = ACTIONS(4993),
    [anon_sym_group] = ACTIONS(4993),
    [anon_sym_by] = ACTIONS(4993),
    [anon_sym_select] = ACTIONS(4993),
    [aux_sym_preproc_if_token1] = ACTIONS(4995),
    [aux_sym_preproc_if_token3] = ACTIONS(4995),
    [aux_sym_preproc_else_token1] = ACTIONS(4995),
    [aux_sym_preproc_elif_token1] = ACTIONS(4995),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3348] = {
    [sym_preproc_region] = STATE(3348),
    [sym_preproc_endregion] = STATE(3348),
    [sym_preproc_line] = STATE(3348),
    [sym_preproc_pragma] = STATE(3348),
    [sym_preproc_nullable] = STATE(3348),
    [sym_preproc_error] = STATE(3348),
    [sym_preproc_define] = STATE(3348),
    [sym_preproc_undef] = STATE(3348),
    [sym__identifier_token] = ACTIONS(4347),
    [anon_sym_alias] = ACTIONS(4347),
    [anon_sym_global] = ACTIONS(4347),
    [anon_sym_LBRACK] = ACTIONS(4349),
    [anon_sym_COLON] = ACTIONS(4349),
    [anon_sym_COMMA] = ACTIONS(4349),
    [anon_sym_LPAREN] = ACTIONS(4349),
    [anon_sym_LBRACE] = ACTIONS(4349),
    [anon_sym_file] = ACTIONS(4347),
    [anon_sym_LT] = ACTIONS(4347),
    [anon_sym_GT] = ACTIONS(4347),
    [anon_sym_where] = ACTIONS(4347),
    [anon_sym_QMARK] = ACTIONS(4347),
    [anon_sym_notnull] = ACTIONS(4347),
    [anon_sym_unmanaged] = ACTIONS(4347),
    [anon_sym_BANG] = ACTIONS(4347),
    [anon_sym_PLUS_PLUS] = ACTIONS(4349),
    [anon_sym_DASH_DASH] = ACTIONS(4349),
    [anon_sym_PLUS] = ACTIONS(4347),
    [anon_sym_DASH] = ACTIONS(4347),
    [anon_sym_STAR] = ACTIONS(4349),
    [anon_sym_SLASH] = ACTIONS(4347),
    [anon_sym_PERCENT] = ACTIONS(4349),
    [anon_sym_CARET] = ACTIONS(4349),
    [anon_sym_PIPE] = ACTIONS(4347),
    [anon_sym_AMP] = ACTIONS(4347),
    [anon_sym_LT_LT] = ACTIONS(4349),
    [anon_sym_GT_GT] = ACTIONS(4347),
    [anon_sym_GT_GT_GT] = ACTIONS(4349),
    [anon_sym_EQ_EQ] = ACTIONS(4349),
    [anon_sym_BANG_EQ] = ACTIONS(4349),
    [anon_sym_GT_EQ] = ACTIONS(4349),
    [anon_sym_LT_EQ] = ACTIONS(4349),
    [anon_sym_DOT] = ACTIONS(4347),
    [anon_sym_scoped] = ACTIONS(4347),
    [anon_sym_var] = ACTIONS(4347),
    [anon_sym_yield] = ACTIONS(4347),
    [anon_sym_switch] = ACTIONS(4347),
    [anon_sym_when] = ACTIONS(4347),
    [sym_discard] = ACTIONS(4347),
    [anon_sym_DOT_DOT] = ACTIONS(4349),
    [anon_sym_and] = ACTIONS(4347),
    [anon_sym_or] = ACTIONS(4347),
    [anon_sym_AMP_AMP] = ACTIONS(4349),
    [anon_sym_PIPE_PIPE] = ACTIONS(4349),
    [anon_sym_QMARK_QMARK] = ACTIONS(4349),
    [anon_sym_from] = ACTIONS(4347),
    [anon_sym_into] = ACTIONS(4347),
    [anon_sym_join] = ACTIONS(4347),
    [anon_sym_on] = ACTIONS(4347),
    [anon_sym_equals] = ACTIONS(4347),
    [anon_sym_let] = ACTIONS(4347),
    [anon_sym_orderby] = ACTIONS(4347),
    [anon_sym_ascending] = ACTIONS(4347),
    [anon_sym_descending] = ACTIONS(4347),
    [anon_sym_group] = ACTIONS(4347),
    [anon_sym_by] = ACTIONS(4347),
    [anon_sym_select] = ACTIONS(4347),
    [anon_sym_as] = ACTIONS(4347),
    [anon_sym_is] = ACTIONS(4347),
    [anon_sym_DASH_GT] = ACTIONS(4349),
    [anon_sym_with] = ACTIONS(4347),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4349),
  },
  [3349] = {
    [sym__variable_designation] = STATE(4979),
    [sym_parenthesized_variable_designation] = STATE(4957),
    [sym_identifier] = STATE(4971),
    [sym__reserved_identifier] = STATE(3558),
    [sym_preproc_region] = STATE(3349),
    [sym_preproc_endregion] = STATE(3349),
    [sym_preproc_line] = STATE(3349),
    [sym_preproc_pragma] = STATE(3349),
    [sym_preproc_nullable] = STATE(3349),
    [sym_preproc_error] = STATE(3349),
    [sym_preproc_define] = STATE(3349),
    [sym_preproc_undef] = STATE(3349),
    [sym__identifier_token] = ACTIONS(4225),
    [anon_sym_alias] = ACTIONS(4227),
    [anon_sym_global] = ACTIONS(4227),
    [anon_sym_LBRACK] = ACTIONS(4373),
    [anon_sym_LPAREN] = ACTIONS(4373),
    [anon_sym_file] = ACTIONS(4227),
    [anon_sym_LT] = ACTIONS(4375),
    [anon_sym_GT] = ACTIONS(4375),
    [anon_sym_where] = ACTIONS(4375),
    [anon_sym_QMARK] = ACTIONS(4375),
    [anon_sym_notnull] = ACTIONS(4227),
    [anon_sym_unmanaged] = ACTIONS(4227),
    [anon_sym_BANG] = ACTIONS(4375),
    [anon_sym_PLUS_PLUS] = ACTIONS(4373),
    [anon_sym_DASH_DASH] = ACTIONS(4373),
    [anon_sym_PLUS] = ACTIONS(4375),
    [anon_sym_DASH] = ACTIONS(4375),
    [anon_sym_STAR] = ACTIONS(4373),
    [anon_sym_SLASH] = ACTIONS(4375),
    [anon_sym_PERCENT] = ACTIONS(4373),
    [anon_sym_CARET] = ACTIONS(4373),
    [anon_sym_PIPE] = ACTIONS(4375),
    [anon_sym_AMP] = ACTIONS(4375),
    [anon_sym_LT_LT] = ACTIONS(4373),
    [anon_sym_GT_GT] = ACTIONS(4375),
    [anon_sym_GT_GT_GT] = ACTIONS(4373),
    [anon_sym_EQ_EQ] = ACTIONS(4373),
    [anon_sym_BANG_EQ] = ACTIONS(4373),
    [anon_sym_GT_EQ] = ACTIONS(4373),
    [anon_sym_LT_EQ] = ACTIONS(4373),
    [anon_sym_DOT] = ACTIONS(4375),
    [anon_sym_scoped] = ACTIONS(4227),
    [anon_sym_var] = ACTIONS(4227),
    [anon_sym_yield] = ACTIONS(4227),
    [anon_sym_switch] = ACTIONS(4375),
    [anon_sym_when] = ACTIONS(4227),
    [sym_discard] = ACTIONS(4649),
    [anon_sym_DOT_DOT] = ACTIONS(4373),
    [anon_sym_and] = ACTIONS(4375),
    [anon_sym_or] = ACTIONS(4375),
    [anon_sym_AMP_AMP] = ACTIONS(4373),
    [anon_sym_PIPE_PIPE] = ACTIONS(4373),
    [anon_sym_QMARK_QMARK] = ACTIONS(4373),
    [anon_sym_from] = ACTIONS(4375),
    [anon_sym_into] = ACTIONS(4375),
    [anon_sym_join] = ACTIONS(4375),
    [anon_sym_on] = ACTIONS(4227),
    [anon_sym_equals] = ACTIONS(4227),
    [anon_sym_let] = ACTIONS(4375),
    [anon_sym_orderby] = ACTIONS(4375),
    [anon_sym_ascending] = ACTIONS(4227),
    [anon_sym_descending] = ACTIONS(4227),
    [anon_sym_group] = ACTIONS(4375),
    [anon_sym_by] = ACTIONS(4227),
    [anon_sym_select] = ACTIONS(4375),
    [anon_sym_as] = ACTIONS(4375),
    [anon_sym_is] = ACTIONS(4375),
    [anon_sym_DASH_GT] = ACTIONS(4373),
    [anon_sym_with] = ACTIONS(4375),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3350] = {
    [sym__variable_designation] = STATE(4997),
    [sym_parenthesized_variable_designation] = STATE(4957),
    [sym_identifier] = STATE(4971),
    [sym__reserved_identifier] = STATE(3558),
    [sym_preproc_region] = STATE(3350),
    [sym_preproc_endregion] = STATE(3350),
    [sym_preproc_line] = STATE(3350),
    [sym_preproc_pragma] = STATE(3350),
    [sym_preproc_nullable] = STATE(3350),
    [sym_preproc_error] = STATE(3350),
    [sym_preproc_define] = STATE(3350),
    [sym_preproc_undef] = STATE(3350),
    [sym__identifier_token] = ACTIONS(4225),
    [anon_sym_alias] = ACTIONS(4227),
    [anon_sym_global] = ACTIONS(4227),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_LPAREN] = ACTIONS(4383),
    [anon_sym_file] = ACTIONS(4227),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_where] = ACTIONS(4385),
    [anon_sym_QMARK] = ACTIONS(4385),
    [anon_sym_notnull] = ACTIONS(4227),
    [anon_sym_unmanaged] = ACTIONS(4227),
    [anon_sym_BANG] = ACTIONS(4385),
    [anon_sym_PLUS_PLUS] = ACTIONS(4383),
    [anon_sym_DASH_DASH] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_DASH] = ACTIONS(4385),
    [anon_sym_STAR] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4385),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4385),
    [anon_sym_GT_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4383),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_scoped] = ACTIONS(4227),
    [anon_sym_var] = ACTIONS(4227),
    [anon_sym_yield] = ACTIONS(4227),
    [anon_sym_switch] = ACTIONS(4385),
    [anon_sym_when] = ACTIONS(4227),
    [sym_discard] = ACTIONS(4649),
    [anon_sym_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4385),
    [anon_sym_or] = ACTIONS(4385),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_QMARK_QMARK] = ACTIONS(4383),
    [anon_sym_from] = ACTIONS(4385),
    [anon_sym_into] = ACTIONS(4385),
    [anon_sym_join] = ACTIONS(4385),
    [anon_sym_on] = ACTIONS(4227),
    [anon_sym_equals] = ACTIONS(4227),
    [anon_sym_let] = ACTIONS(4385),
    [anon_sym_orderby] = ACTIONS(4385),
    [anon_sym_ascending] = ACTIONS(4227),
    [anon_sym_descending] = ACTIONS(4227),
    [anon_sym_group] = ACTIONS(4385),
    [anon_sym_by] = ACTIONS(4227),
    [anon_sym_select] = ACTIONS(4385),
    [anon_sym_as] = ACTIONS(4385),
    [anon_sym_is] = ACTIONS(4385),
    [anon_sym_DASH_GT] = ACTIONS(4383),
    [anon_sym_with] = ACTIONS(4385),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3351] = {
    [sym_preproc_region] = STATE(3351),
    [sym_preproc_endregion] = STATE(3351),
    [sym_preproc_line] = STATE(3351),
    [sym_preproc_pragma] = STATE(3351),
    [sym_preproc_nullable] = STATE(3351),
    [sym_preproc_error] = STATE(3351),
    [sym_preproc_define] = STATE(3351),
    [sym_preproc_undef] = STATE(3351),
    [sym__identifier_token] = ACTIONS(4997),
    [anon_sym_extern] = ACTIONS(4997),
    [anon_sym_alias] = ACTIONS(4997),
    [anon_sym_global] = ACTIONS(4997),
    [anon_sym_using] = ACTIONS(4997),
    [anon_sym_unsafe] = ACTIONS(4997),
    [anon_sym_static] = ACTIONS(4997),
    [anon_sym_LBRACK] = ACTIONS(4999),
    [anon_sym_LPAREN] = ACTIONS(4999),
    [anon_sym_event] = ACTIONS(4997),
    [anon_sym_namespace] = ACTIONS(4997),
    [anon_sym_class] = ACTIONS(4997),
    [anon_sym_ref] = ACTIONS(4997),
    [anon_sym_struct] = ACTIONS(4997),
    [anon_sym_enum] = ACTIONS(4997),
    [anon_sym_RBRACE] = ACTIONS(4999),
    [anon_sym_interface] = ACTIONS(4997),
    [anon_sym_delegate] = ACTIONS(4997),
    [anon_sym_record] = ACTIONS(4997),
    [anon_sym_abstract] = ACTIONS(4997),
    [anon_sym_async] = ACTIONS(4997),
    [anon_sym_const] = ACTIONS(4997),
    [anon_sym_file] = ACTIONS(4997),
    [anon_sym_fixed] = ACTIONS(4997),
    [anon_sym_internal] = ACTIONS(4997),
    [anon_sym_new] = ACTIONS(4997),
    [anon_sym_override] = ACTIONS(4997),
    [anon_sym_partial] = ACTIONS(4997),
    [anon_sym_private] = ACTIONS(4997),
    [anon_sym_protected] = ACTIONS(4997),
    [anon_sym_public] = ACTIONS(4997),
    [anon_sym_readonly] = ACTIONS(4997),
    [anon_sym_required] = ACTIONS(4997),
    [anon_sym_sealed] = ACTIONS(4997),
    [anon_sym_virtual] = ACTIONS(4997),
    [anon_sym_volatile] = ACTIONS(4997),
    [anon_sym_where] = ACTIONS(4997),
    [anon_sym_notnull] = ACTIONS(4997),
    [anon_sym_unmanaged] = ACTIONS(4997),
    [anon_sym_TILDE] = ACTIONS(4999),
    [anon_sym_implicit] = ACTIONS(4997),
    [anon_sym_explicit] = ACTIONS(4997),
    [anon_sym_scoped] = ACTIONS(4997),
    [anon_sym_var] = ACTIONS(4997),
    [sym_predefined_type] = ACTIONS(4997),
    [anon_sym_yield] = ACTIONS(4997),
    [anon_sym_when] = ACTIONS(4997),
    [anon_sym_from] = ACTIONS(4997),
    [anon_sym_into] = ACTIONS(4997),
    [anon_sym_join] = ACTIONS(4997),
    [anon_sym_on] = ACTIONS(4997),
    [anon_sym_equals] = ACTIONS(4997),
    [anon_sym_let] = ACTIONS(4997),
    [anon_sym_orderby] = ACTIONS(4997),
    [anon_sym_ascending] = ACTIONS(4997),
    [anon_sym_descending] = ACTIONS(4997),
    [anon_sym_group] = ACTIONS(4997),
    [anon_sym_by] = ACTIONS(4997),
    [anon_sym_select] = ACTIONS(4997),
    [aux_sym_preproc_if_token1] = ACTIONS(4999),
    [aux_sym_preproc_if_token3] = ACTIONS(4999),
    [aux_sym_preproc_else_token1] = ACTIONS(4999),
    [aux_sym_preproc_elif_token1] = ACTIONS(4999),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3352] = {
    [sym_preproc_region] = STATE(3352),
    [sym_preproc_endregion] = STATE(3352),
    [sym_preproc_line] = STATE(3352),
    [sym_preproc_pragma] = STATE(3352),
    [sym_preproc_nullable] = STATE(3352),
    [sym_preproc_error] = STATE(3352),
    [sym_preproc_define] = STATE(3352),
    [sym_preproc_undef] = STATE(3352),
    [sym__identifier_token] = ACTIONS(5001),
    [anon_sym_extern] = ACTIONS(5001),
    [anon_sym_alias] = ACTIONS(5001),
    [anon_sym_global] = ACTIONS(5001),
    [anon_sym_using] = ACTIONS(5001),
    [anon_sym_unsafe] = ACTIONS(5001),
    [anon_sym_static] = ACTIONS(5001),
    [anon_sym_LBRACK] = ACTIONS(5003),
    [anon_sym_LPAREN] = ACTIONS(5003),
    [anon_sym_event] = ACTIONS(5001),
    [anon_sym_namespace] = ACTIONS(5001),
    [anon_sym_class] = ACTIONS(5001),
    [anon_sym_ref] = ACTIONS(5001),
    [anon_sym_struct] = ACTIONS(5001),
    [anon_sym_enum] = ACTIONS(5001),
    [anon_sym_RBRACE] = ACTIONS(5003),
    [anon_sym_interface] = ACTIONS(5001),
    [anon_sym_delegate] = ACTIONS(5001),
    [anon_sym_record] = ACTIONS(5001),
    [anon_sym_abstract] = ACTIONS(5001),
    [anon_sym_async] = ACTIONS(5001),
    [anon_sym_const] = ACTIONS(5001),
    [anon_sym_file] = ACTIONS(5001),
    [anon_sym_fixed] = ACTIONS(5001),
    [anon_sym_internal] = ACTIONS(5001),
    [anon_sym_new] = ACTIONS(5001),
    [anon_sym_override] = ACTIONS(5001),
    [anon_sym_partial] = ACTIONS(5001),
    [anon_sym_private] = ACTIONS(5001),
    [anon_sym_protected] = ACTIONS(5001),
    [anon_sym_public] = ACTIONS(5001),
    [anon_sym_readonly] = ACTIONS(5001),
    [anon_sym_required] = ACTIONS(5001),
    [anon_sym_sealed] = ACTIONS(5001),
    [anon_sym_virtual] = ACTIONS(5001),
    [anon_sym_volatile] = ACTIONS(5001),
    [anon_sym_where] = ACTIONS(5001),
    [anon_sym_notnull] = ACTIONS(5001),
    [anon_sym_unmanaged] = ACTIONS(5001),
    [anon_sym_TILDE] = ACTIONS(5003),
    [anon_sym_implicit] = ACTIONS(5001),
    [anon_sym_explicit] = ACTIONS(5001),
    [anon_sym_scoped] = ACTIONS(5001),
    [anon_sym_var] = ACTIONS(5001),
    [sym_predefined_type] = ACTIONS(5001),
    [anon_sym_yield] = ACTIONS(5001),
    [anon_sym_when] = ACTIONS(5001),
    [anon_sym_from] = ACTIONS(5001),
    [anon_sym_into] = ACTIONS(5001),
    [anon_sym_join] = ACTIONS(5001),
    [anon_sym_on] = ACTIONS(5001),
    [anon_sym_equals] = ACTIONS(5001),
    [anon_sym_let] = ACTIONS(5001),
    [anon_sym_orderby] = ACTIONS(5001),
    [anon_sym_ascending] = ACTIONS(5001),
    [anon_sym_descending] = ACTIONS(5001),
    [anon_sym_group] = ACTIONS(5001),
    [anon_sym_by] = ACTIONS(5001),
    [anon_sym_select] = ACTIONS(5001),
    [aux_sym_preproc_if_token1] = ACTIONS(5003),
    [aux_sym_preproc_if_token3] = ACTIONS(5003),
    [aux_sym_preproc_else_token1] = ACTIONS(5003),
    [aux_sym_preproc_elif_token1] = ACTIONS(5003),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3353] = {
    [sym_preproc_region] = STATE(3353),
    [sym_preproc_endregion] = STATE(3353),
    [sym_preproc_line] = STATE(3353),
    [sym_preproc_pragma] = STATE(3353),
    [sym_preproc_nullable] = STATE(3353),
    [sym_preproc_error] = STATE(3353),
    [sym_preproc_define] = STATE(3353),
    [sym_preproc_undef] = STATE(3353),
    [anon_sym_SEMI] = ACTIONS(4068),
    [anon_sym_EQ] = ACTIONS(4066),
    [anon_sym_LBRACK] = ACTIONS(4068),
    [anon_sym_COLON] = ACTIONS(4068),
    [anon_sym_COMMA] = ACTIONS(4068),
    [anon_sym_RBRACK] = ACTIONS(4068),
    [anon_sym_LPAREN] = ACTIONS(4068),
    [anon_sym_RPAREN] = ACTIONS(4068),
    [anon_sym_RBRACE] = ACTIONS(4068),
    [anon_sym_LT] = ACTIONS(4066),
    [anon_sym_GT] = ACTIONS(4066),
    [anon_sym_in] = ACTIONS(4068),
    [anon_sym_QMARK] = ACTIONS(4066),
    [anon_sym_BANG] = ACTIONS(4066),
    [anon_sym_PLUS_PLUS] = ACTIONS(4068),
    [anon_sym_DASH_DASH] = ACTIONS(4068),
    [anon_sym_PLUS] = ACTIONS(4066),
    [anon_sym_DASH] = ACTIONS(4066),
    [anon_sym_STAR] = ACTIONS(4066),
    [anon_sym_SLASH] = ACTIONS(4066),
    [anon_sym_PERCENT] = ACTIONS(4066),
    [anon_sym_CARET] = ACTIONS(4066),
    [anon_sym_PIPE] = ACTIONS(4066),
    [anon_sym_AMP] = ACTIONS(4066),
    [anon_sym_LT_LT] = ACTIONS(4066),
    [anon_sym_GT_GT] = ACTIONS(4066),
    [anon_sym_GT_GT_GT] = ACTIONS(4066),
    [anon_sym_EQ_EQ] = ACTIONS(4068),
    [anon_sym_BANG_EQ] = ACTIONS(4068),
    [anon_sym_GT_EQ] = ACTIONS(4068),
    [anon_sym_LT_EQ] = ACTIONS(4068),
    [anon_sym_DOT] = ACTIONS(4066),
    [anon_sym_EQ_GT] = ACTIONS(4068),
    [anon_sym_switch] = ACTIONS(4068),
    [anon_sym_when] = ACTIONS(4068),
    [anon_sym_DOT_DOT] = ACTIONS(4068),
    [anon_sym_and] = ACTIONS(4068),
    [anon_sym_or] = ACTIONS(4068),
    [anon_sym_PLUS_EQ] = ACTIONS(4068),
    [anon_sym_DASH_EQ] = ACTIONS(4068),
    [anon_sym_STAR_EQ] = ACTIONS(4068),
    [anon_sym_SLASH_EQ] = ACTIONS(4068),
    [anon_sym_PERCENT_EQ] = ACTIONS(4068),
    [anon_sym_AMP_EQ] = ACTIONS(4068),
    [anon_sym_CARET_EQ] = ACTIONS(4068),
    [anon_sym_PIPE_EQ] = ACTIONS(4068),
    [anon_sym_LT_LT_EQ] = ACTIONS(4068),
    [anon_sym_GT_GT_EQ] = ACTIONS(4068),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4068),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4068),
    [anon_sym_AMP_AMP] = ACTIONS(4068),
    [anon_sym_PIPE_PIPE] = ACTIONS(4068),
    [anon_sym_QMARK_QMARK] = ACTIONS(4066),
    [anon_sym_on] = ACTIONS(4068),
    [anon_sym_equals] = ACTIONS(4068),
    [anon_sym_by] = ACTIONS(4068),
    [anon_sym_as] = ACTIONS(4068),
    [anon_sym_is] = ACTIONS(4068),
    [anon_sym_DASH_GT] = ACTIONS(4068),
    [anon_sym_with] = ACTIONS(4068),
    [aux_sym_preproc_if_token3] = ACTIONS(4068),
    [aux_sym_preproc_else_token1] = ACTIONS(4068),
    [aux_sym_preproc_elif_token1] = ACTIONS(4068),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3354] = {
    [sym_preproc_region] = STATE(3354),
    [sym_preproc_endregion] = STATE(3354),
    [sym_preproc_line] = STATE(3354),
    [sym_preproc_pragma] = STATE(3354),
    [sym_preproc_nullable] = STATE(3354),
    [sym_preproc_error] = STATE(3354),
    [sym_preproc_define] = STATE(3354),
    [sym_preproc_undef] = STATE(3354),
    [sym__identifier_token] = ACTIONS(4474),
    [anon_sym_alias] = ACTIONS(4474),
    [anon_sym_global] = ACTIONS(4474),
    [anon_sym_LBRACK] = ACTIONS(4476),
    [anon_sym_COLON] = ACTIONS(4476),
    [anon_sym_COMMA] = ACTIONS(4476),
    [anon_sym_LPAREN] = ACTIONS(4476),
    [anon_sym_LBRACE] = ACTIONS(4476),
    [anon_sym_file] = ACTIONS(4474),
    [anon_sym_LT] = ACTIONS(4474),
    [anon_sym_GT] = ACTIONS(4474),
    [anon_sym_where] = ACTIONS(4474),
    [anon_sym_QMARK] = ACTIONS(4474),
    [anon_sym_notnull] = ACTIONS(4474),
    [anon_sym_unmanaged] = ACTIONS(4474),
    [anon_sym_BANG] = ACTIONS(4474),
    [anon_sym_PLUS_PLUS] = ACTIONS(4476),
    [anon_sym_DASH_DASH] = ACTIONS(4476),
    [anon_sym_PLUS] = ACTIONS(4474),
    [anon_sym_DASH] = ACTIONS(4474),
    [anon_sym_STAR] = ACTIONS(4476),
    [anon_sym_SLASH] = ACTIONS(4474),
    [anon_sym_PERCENT] = ACTIONS(4476),
    [anon_sym_CARET] = ACTIONS(4476),
    [anon_sym_PIPE] = ACTIONS(4474),
    [anon_sym_AMP] = ACTIONS(4474),
    [anon_sym_LT_LT] = ACTIONS(4476),
    [anon_sym_GT_GT] = ACTIONS(4474),
    [anon_sym_GT_GT_GT] = ACTIONS(4476),
    [anon_sym_EQ_EQ] = ACTIONS(4476),
    [anon_sym_BANG_EQ] = ACTIONS(4476),
    [anon_sym_GT_EQ] = ACTIONS(4476),
    [anon_sym_LT_EQ] = ACTIONS(4476),
    [anon_sym_DOT] = ACTIONS(4474),
    [anon_sym_scoped] = ACTIONS(4474),
    [anon_sym_var] = ACTIONS(4474),
    [anon_sym_yield] = ACTIONS(4474),
    [anon_sym_switch] = ACTIONS(4474),
    [anon_sym_when] = ACTIONS(4474),
    [sym_discard] = ACTIONS(4474),
    [anon_sym_DOT_DOT] = ACTIONS(4476),
    [anon_sym_and] = ACTIONS(4474),
    [anon_sym_or] = ACTIONS(4474),
    [anon_sym_AMP_AMP] = ACTIONS(4476),
    [anon_sym_PIPE_PIPE] = ACTIONS(4476),
    [anon_sym_QMARK_QMARK] = ACTIONS(4476),
    [anon_sym_from] = ACTIONS(4474),
    [anon_sym_into] = ACTIONS(4474),
    [anon_sym_join] = ACTIONS(4474),
    [anon_sym_on] = ACTIONS(4474),
    [anon_sym_equals] = ACTIONS(4474),
    [anon_sym_let] = ACTIONS(4474),
    [anon_sym_orderby] = ACTIONS(4474),
    [anon_sym_ascending] = ACTIONS(4474),
    [anon_sym_descending] = ACTIONS(4474),
    [anon_sym_group] = ACTIONS(4474),
    [anon_sym_by] = ACTIONS(4474),
    [anon_sym_select] = ACTIONS(4474),
    [anon_sym_as] = ACTIONS(4474),
    [anon_sym_is] = ACTIONS(4474),
    [anon_sym_DASH_GT] = ACTIONS(4476),
    [anon_sym_with] = ACTIONS(4474),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4476),
  },
  [3355] = {
    [sym_preproc_region] = STATE(3355),
    [sym_preproc_endregion] = STATE(3355),
    [sym_preproc_line] = STATE(3355),
    [sym_preproc_pragma] = STATE(3355),
    [sym_preproc_nullable] = STATE(3355),
    [sym_preproc_error] = STATE(3355),
    [sym_preproc_define] = STATE(3355),
    [sym_preproc_undef] = STATE(3355),
    [sym__identifier_token] = ACTIONS(5005),
    [anon_sym_extern] = ACTIONS(5005),
    [anon_sym_alias] = ACTIONS(5005),
    [anon_sym_global] = ACTIONS(5005),
    [anon_sym_using] = ACTIONS(5005),
    [anon_sym_unsafe] = ACTIONS(5005),
    [anon_sym_static] = ACTIONS(5005),
    [anon_sym_LBRACK] = ACTIONS(5007),
    [anon_sym_LPAREN] = ACTIONS(5007),
    [anon_sym_event] = ACTIONS(5005),
    [anon_sym_namespace] = ACTIONS(5005),
    [anon_sym_class] = ACTIONS(5005),
    [anon_sym_ref] = ACTIONS(5005),
    [anon_sym_struct] = ACTIONS(5005),
    [anon_sym_enum] = ACTIONS(5005),
    [anon_sym_RBRACE] = ACTIONS(5007),
    [anon_sym_interface] = ACTIONS(5005),
    [anon_sym_delegate] = ACTIONS(5005),
    [anon_sym_record] = ACTIONS(5005),
    [anon_sym_abstract] = ACTIONS(5005),
    [anon_sym_async] = ACTIONS(5005),
    [anon_sym_const] = ACTIONS(5005),
    [anon_sym_file] = ACTIONS(5005),
    [anon_sym_fixed] = ACTIONS(5005),
    [anon_sym_internal] = ACTIONS(5005),
    [anon_sym_new] = ACTIONS(5005),
    [anon_sym_override] = ACTIONS(5005),
    [anon_sym_partial] = ACTIONS(5005),
    [anon_sym_private] = ACTIONS(5005),
    [anon_sym_protected] = ACTIONS(5005),
    [anon_sym_public] = ACTIONS(5005),
    [anon_sym_readonly] = ACTIONS(5005),
    [anon_sym_required] = ACTIONS(5005),
    [anon_sym_sealed] = ACTIONS(5005),
    [anon_sym_virtual] = ACTIONS(5005),
    [anon_sym_volatile] = ACTIONS(5005),
    [anon_sym_where] = ACTIONS(5005),
    [anon_sym_notnull] = ACTIONS(5005),
    [anon_sym_unmanaged] = ACTIONS(5005),
    [anon_sym_TILDE] = ACTIONS(5007),
    [anon_sym_implicit] = ACTIONS(5005),
    [anon_sym_explicit] = ACTIONS(5005),
    [anon_sym_scoped] = ACTIONS(5005),
    [anon_sym_var] = ACTIONS(5005),
    [sym_predefined_type] = ACTIONS(5005),
    [anon_sym_yield] = ACTIONS(5005),
    [anon_sym_when] = ACTIONS(5005),
    [anon_sym_from] = ACTIONS(5005),
    [anon_sym_into] = ACTIONS(5005),
    [anon_sym_join] = ACTIONS(5005),
    [anon_sym_on] = ACTIONS(5005),
    [anon_sym_equals] = ACTIONS(5005),
    [anon_sym_let] = ACTIONS(5005),
    [anon_sym_orderby] = ACTIONS(5005),
    [anon_sym_ascending] = ACTIONS(5005),
    [anon_sym_descending] = ACTIONS(5005),
    [anon_sym_group] = ACTIONS(5005),
    [anon_sym_by] = ACTIONS(5005),
    [anon_sym_select] = ACTIONS(5005),
    [aux_sym_preproc_if_token1] = ACTIONS(5007),
    [aux_sym_preproc_if_token3] = ACTIONS(5007),
    [aux_sym_preproc_else_token1] = ACTIONS(5007),
    [aux_sym_preproc_elif_token1] = ACTIONS(5007),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3356] = {
    [sym_preproc_region] = STATE(3356),
    [sym_preproc_endregion] = STATE(3356),
    [sym_preproc_line] = STATE(3356),
    [sym_preproc_pragma] = STATE(3356),
    [sym_preproc_nullable] = STATE(3356),
    [sym_preproc_error] = STATE(3356),
    [sym_preproc_define] = STATE(3356),
    [sym_preproc_undef] = STATE(3356),
    [sym__identifier_token] = ACTIONS(5009),
    [anon_sym_extern] = ACTIONS(5009),
    [anon_sym_alias] = ACTIONS(5009),
    [anon_sym_global] = ACTIONS(5009),
    [anon_sym_using] = ACTIONS(5009),
    [anon_sym_unsafe] = ACTIONS(5009),
    [anon_sym_static] = ACTIONS(5009),
    [anon_sym_LBRACK] = ACTIONS(5011),
    [anon_sym_LPAREN] = ACTIONS(5011),
    [anon_sym_event] = ACTIONS(5009),
    [anon_sym_namespace] = ACTIONS(5009),
    [anon_sym_class] = ACTIONS(5009),
    [anon_sym_ref] = ACTIONS(5009),
    [anon_sym_struct] = ACTIONS(5009),
    [anon_sym_enum] = ACTIONS(5009),
    [anon_sym_RBRACE] = ACTIONS(5011),
    [anon_sym_interface] = ACTIONS(5009),
    [anon_sym_delegate] = ACTIONS(5009),
    [anon_sym_record] = ACTIONS(5009),
    [anon_sym_abstract] = ACTIONS(5009),
    [anon_sym_async] = ACTIONS(5009),
    [anon_sym_const] = ACTIONS(5009),
    [anon_sym_file] = ACTIONS(5009),
    [anon_sym_fixed] = ACTIONS(5009),
    [anon_sym_internal] = ACTIONS(5009),
    [anon_sym_new] = ACTIONS(5009),
    [anon_sym_override] = ACTIONS(5009),
    [anon_sym_partial] = ACTIONS(5009),
    [anon_sym_private] = ACTIONS(5009),
    [anon_sym_protected] = ACTIONS(5009),
    [anon_sym_public] = ACTIONS(5009),
    [anon_sym_readonly] = ACTIONS(5009),
    [anon_sym_required] = ACTIONS(5009),
    [anon_sym_sealed] = ACTIONS(5009),
    [anon_sym_virtual] = ACTIONS(5009),
    [anon_sym_volatile] = ACTIONS(5009),
    [anon_sym_where] = ACTIONS(5009),
    [anon_sym_notnull] = ACTIONS(5009),
    [anon_sym_unmanaged] = ACTIONS(5009),
    [anon_sym_TILDE] = ACTIONS(5011),
    [anon_sym_implicit] = ACTIONS(5009),
    [anon_sym_explicit] = ACTIONS(5009),
    [anon_sym_scoped] = ACTIONS(5009),
    [anon_sym_var] = ACTIONS(5009),
    [sym_predefined_type] = ACTIONS(5009),
    [anon_sym_yield] = ACTIONS(5009),
    [anon_sym_when] = ACTIONS(5009),
    [anon_sym_from] = ACTIONS(5009),
    [anon_sym_into] = ACTIONS(5009),
    [anon_sym_join] = ACTIONS(5009),
    [anon_sym_on] = ACTIONS(5009),
    [anon_sym_equals] = ACTIONS(5009),
    [anon_sym_let] = ACTIONS(5009),
    [anon_sym_orderby] = ACTIONS(5009),
    [anon_sym_ascending] = ACTIONS(5009),
    [anon_sym_descending] = ACTIONS(5009),
    [anon_sym_group] = ACTIONS(5009),
    [anon_sym_by] = ACTIONS(5009),
    [anon_sym_select] = ACTIONS(5009),
    [aux_sym_preproc_if_token1] = ACTIONS(5011),
    [aux_sym_preproc_if_token3] = ACTIONS(5011),
    [aux_sym_preproc_else_token1] = ACTIONS(5011),
    [aux_sym_preproc_elif_token1] = ACTIONS(5011),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3357] = {
    [sym_preproc_region] = STATE(3357),
    [sym_preproc_endregion] = STATE(3357),
    [sym_preproc_line] = STATE(3357),
    [sym_preproc_pragma] = STATE(3357),
    [sym_preproc_nullable] = STATE(3357),
    [sym_preproc_error] = STATE(3357),
    [sym_preproc_define] = STATE(3357),
    [sym_preproc_undef] = STATE(3357),
    [anon_sym_SEMI] = ACTIONS(4111),
    [anon_sym_EQ] = ACTIONS(4104),
    [anon_sym_LBRACK] = ACTIONS(4111),
    [anon_sym_COLON] = ACTIONS(4111),
    [anon_sym_COMMA] = ACTIONS(4111),
    [anon_sym_RBRACK] = ACTIONS(4111),
    [anon_sym_LPAREN] = ACTIONS(4111),
    [anon_sym_RPAREN] = ACTIONS(4111),
    [anon_sym_RBRACE] = ACTIONS(4111),
    [anon_sym_LT] = ACTIONS(4104),
    [anon_sym_GT] = ACTIONS(4104),
    [anon_sym_in] = ACTIONS(4111),
    [anon_sym_QMARK] = ACTIONS(4104),
    [anon_sym_BANG] = ACTIONS(4104),
    [anon_sym_PLUS_PLUS] = ACTIONS(4111),
    [anon_sym_DASH_DASH] = ACTIONS(4111),
    [anon_sym_PLUS] = ACTIONS(4104),
    [anon_sym_DASH] = ACTIONS(4104),
    [anon_sym_STAR] = ACTIONS(4104),
    [anon_sym_SLASH] = ACTIONS(4104),
    [anon_sym_PERCENT] = ACTIONS(4104),
    [anon_sym_CARET] = ACTIONS(4104),
    [anon_sym_PIPE] = ACTIONS(4104),
    [anon_sym_AMP] = ACTIONS(4104),
    [anon_sym_LT_LT] = ACTIONS(4104),
    [anon_sym_GT_GT] = ACTIONS(4104),
    [anon_sym_GT_GT_GT] = ACTIONS(4104),
    [anon_sym_EQ_EQ] = ACTIONS(4111),
    [anon_sym_BANG_EQ] = ACTIONS(4111),
    [anon_sym_GT_EQ] = ACTIONS(4111),
    [anon_sym_LT_EQ] = ACTIONS(4111),
    [anon_sym_DOT] = ACTIONS(4104),
    [anon_sym_EQ_GT] = ACTIONS(4111),
    [anon_sym_switch] = ACTIONS(4111),
    [anon_sym_when] = ACTIONS(4111),
    [anon_sym_DOT_DOT] = ACTIONS(4111),
    [anon_sym_and] = ACTIONS(4111),
    [anon_sym_or] = ACTIONS(4111),
    [anon_sym_PLUS_EQ] = ACTIONS(4111),
    [anon_sym_DASH_EQ] = ACTIONS(4111),
    [anon_sym_STAR_EQ] = ACTIONS(4111),
    [anon_sym_SLASH_EQ] = ACTIONS(4111),
    [anon_sym_PERCENT_EQ] = ACTIONS(4111),
    [anon_sym_AMP_EQ] = ACTIONS(4111),
    [anon_sym_CARET_EQ] = ACTIONS(4111),
    [anon_sym_PIPE_EQ] = ACTIONS(4111),
    [anon_sym_LT_LT_EQ] = ACTIONS(4111),
    [anon_sym_GT_GT_EQ] = ACTIONS(4111),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4111),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4111),
    [anon_sym_AMP_AMP] = ACTIONS(4111),
    [anon_sym_PIPE_PIPE] = ACTIONS(4111),
    [anon_sym_QMARK_QMARK] = ACTIONS(4104),
    [anon_sym_on] = ACTIONS(4111),
    [anon_sym_equals] = ACTIONS(4111),
    [anon_sym_by] = ACTIONS(4111),
    [anon_sym_as] = ACTIONS(4111),
    [anon_sym_is] = ACTIONS(4111),
    [anon_sym_DASH_GT] = ACTIONS(4111),
    [anon_sym_with] = ACTIONS(4111),
    [aux_sym_preproc_if_token3] = ACTIONS(4111),
    [aux_sym_preproc_else_token1] = ACTIONS(4111),
    [aux_sym_preproc_elif_token1] = ACTIONS(4111),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3358] = {
    [sym_preproc_region] = STATE(3358),
    [sym_preproc_endregion] = STATE(3358),
    [sym_preproc_line] = STATE(3358),
    [sym_preproc_pragma] = STATE(3358),
    [sym_preproc_nullable] = STATE(3358),
    [sym_preproc_error] = STATE(3358),
    [sym_preproc_define] = STATE(3358),
    [sym_preproc_undef] = STATE(3358),
    [sym__identifier_token] = ACTIONS(5013),
    [anon_sym_extern] = ACTIONS(5013),
    [anon_sym_alias] = ACTIONS(5013),
    [anon_sym_global] = ACTIONS(5013),
    [anon_sym_using] = ACTIONS(5013),
    [anon_sym_unsafe] = ACTIONS(5013),
    [anon_sym_static] = ACTIONS(5013),
    [anon_sym_LBRACK] = ACTIONS(5015),
    [anon_sym_LPAREN] = ACTIONS(5015),
    [anon_sym_event] = ACTIONS(5013),
    [anon_sym_namespace] = ACTIONS(5013),
    [anon_sym_class] = ACTIONS(5013),
    [anon_sym_ref] = ACTIONS(5013),
    [anon_sym_struct] = ACTIONS(5013),
    [anon_sym_enum] = ACTIONS(5013),
    [anon_sym_RBRACE] = ACTIONS(5015),
    [anon_sym_interface] = ACTIONS(5013),
    [anon_sym_delegate] = ACTIONS(5013),
    [anon_sym_record] = ACTIONS(5013),
    [anon_sym_abstract] = ACTIONS(5013),
    [anon_sym_async] = ACTIONS(5013),
    [anon_sym_const] = ACTIONS(5013),
    [anon_sym_file] = ACTIONS(5013),
    [anon_sym_fixed] = ACTIONS(5013),
    [anon_sym_internal] = ACTIONS(5013),
    [anon_sym_new] = ACTIONS(5013),
    [anon_sym_override] = ACTIONS(5013),
    [anon_sym_partial] = ACTIONS(5013),
    [anon_sym_private] = ACTIONS(5013),
    [anon_sym_protected] = ACTIONS(5013),
    [anon_sym_public] = ACTIONS(5013),
    [anon_sym_readonly] = ACTIONS(5013),
    [anon_sym_required] = ACTIONS(5013),
    [anon_sym_sealed] = ACTIONS(5013),
    [anon_sym_virtual] = ACTIONS(5013),
    [anon_sym_volatile] = ACTIONS(5013),
    [anon_sym_where] = ACTIONS(5013),
    [anon_sym_notnull] = ACTIONS(5013),
    [anon_sym_unmanaged] = ACTIONS(5013),
    [anon_sym_TILDE] = ACTIONS(5015),
    [anon_sym_implicit] = ACTIONS(5013),
    [anon_sym_explicit] = ACTIONS(5013),
    [anon_sym_scoped] = ACTIONS(5013),
    [anon_sym_var] = ACTIONS(5013),
    [sym_predefined_type] = ACTIONS(5013),
    [anon_sym_yield] = ACTIONS(5013),
    [anon_sym_when] = ACTIONS(5013),
    [anon_sym_from] = ACTIONS(5013),
    [anon_sym_into] = ACTIONS(5013),
    [anon_sym_join] = ACTIONS(5013),
    [anon_sym_on] = ACTIONS(5013),
    [anon_sym_equals] = ACTIONS(5013),
    [anon_sym_let] = ACTIONS(5013),
    [anon_sym_orderby] = ACTIONS(5013),
    [anon_sym_ascending] = ACTIONS(5013),
    [anon_sym_descending] = ACTIONS(5013),
    [anon_sym_group] = ACTIONS(5013),
    [anon_sym_by] = ACTIONS(5013),
    [anon_sym_select] = ACTIONS(5013),
    [aux_sym_preproc_if_token1] = ACTIONS(5015),
    [aux_sym_preproc_if_token3] = ACTIONS(5015),
    [aux_sym_preproc_else_token1] = ACTIONS(5015),
    [aux_sym_preproc_elif_token1] = ACTIONS(5015),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3359] = {
    [sym_preproc_region] = STATE(3359),
    [sym_preproc_endregion] = STATE(3359),
    [sym_preproc_line] = STATE(3359),
    [sym_preproc_pragma] = STATE(3359),
    [sym_preproc_nullable] = STATE(3359),
    [sym_preproc_error] = STATE(3359),
    [sym_preproc_define] = STATE(3359),
    [sym_preproc_undef] = STATE(3359),
    [sym__identifier_token] = ACTIONS(3936),
    [anon_sym_extern] = ACTIONS(3936),
    [anon_sym_alias] = ACTIONS(3936),
    [anon_sym_global] = ACTIONS(3936),
    [anon_sym_using] = ACTIONS(3936),
    [anon_sym_unsafe] = ACTIONS(3936),
    [anon_sym_static] = ACTIONS(3936),
    [anon_sym_LBRACK] = ACTIONS(3938),
    [anon_sym_LPAREN] = ACTIONS(3938),
    [anon_sym_event] = ACTIONS(3936),
    [anon_sym_namespace] = ACTIONS(3936),
    [anon_sym_class] = ACTIONS(3936),
    [anon_sym_ref] = ACTIONS(3936),
    [anon_sym_struct] = ACTIONS(3936),
    [anon_sym_enum] = ACTIONS(3936),
    [anon_sym_RBRACE] = ACTIONS(3938),
    [anon_sym_interface] = ACTIONS(3936),
    [anon_sym_delegate] = ACTIONS(3936),
    [anon_sym_record] = ACTIONS(3936),
    [anon_sym_abstract] = ACTIONS(3936),
    [anon_sym_async] = ACTIONS(3936),
    [anon_sym_const] = ACTIONS(3936),
    [anon_sym_file] = ACTIONS(3936),
    [anon_sym_fixed] = ACTIONS(3936),
    [anon_sym_internal] = ACTIONS(3936),
    [anon_sym_new] = ACTIONS(3936),
    [anon_sym_override] = ACTIONS(3936),
    [anon_sym_partial] = ACTIONS(3936),
    [anon_sym_private] = ACTIONS(3936),
    [anon_sym_protected] = ACTIONS(3936),
    [anon_sym_public] = ACTIONS(3936),
    [anon_sym_readonly] = ACTIONS(3936),
    [anon_sym_required] = ACTIONS(3936),
    [anon_sym_sealed] = ACTIONS(3936),
    [anon_sym_virtual] = ACTIONS(3936),
    [anon_sym_volatile] = ACTIONS(3936),
    [anon_sym_where] = ACTIONS(3936),
    [anon_sym_notnull] = ACTIONS(3936),
    [anon_sym_unmanaged] = ACTIONS(3936),
    [anon_sym_TILDE] = ACTIONS(3938),
    [anon_sym_implicit] = ACTIONS(3936),
    [anon_sym_explicit] = ACTIONS(3936),
    [anon_sym_scoped] = ACTIONS(3936),
    [anon_sym_var] = ACTIONS(3936),
    [sym_predefined_type] = ACTIONS(3936),
    [anon_sym_yield] = ACTIONS(3936),
    [anon_sym_when] = ACTIONS(3936),
    [anon_sym_from] = ACTIONS(3936),
    [anon_sym_into] = ACTIONS(3936),
    [anon_sym_join] = ACTIONS(3936),
    [anon_sym_on] = ACTIONS(3936),
    [anon_sym_equals] = ACTIONS(3936),
    [anon_sym_let] = ACTIONS(3936),
    [anon_sym_orderby] = ACTIONS(3936),
    [anon_sym_ascending] = ACTIONS(3936),
    [anon_sym_descending] = ACTIONS(3936),
    [anon_sym_group] = ACTIONS(3936),
    [anon_sym_by] = ACTIONS(3936),
    [anon_sym_select] = ACTIONS(3936),
    [aux_sym_preproc_if_token1] = ACTIONS(3938),
    [aux_sym_preproc_if_token3] = ACTIONS(3938),
    [aux_sym_preproc_else_token1] = ACTIONS(3938),
    [aux_sym_preproc_elif_token1] = ACTIONS(3938),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3360] = {
    [sym_preproc_region] = STATE(3360),
    [sym_preproc_endregion] = STATE(3360),
    [sym_preproc_line] = STATE(3360),
    [sym_preproc_pragma] = STATE(3360),
    [sym_preproc_nullable] = STATE(3360),
    [sym_preproc_error] = STATE(3360),
    [sym_preproc_define] = STATE(3360),
    [sym_preproc_undef] = STATE(3360),
    [sym__identifier_token] = ACTIONS(3940),
    [anon_sym_extern] = ACTIONS(3940),
    [anon_sym_alias] = ACTIONS(3940),
    [anon_sym_global] = ACTIONS(3940),
    [anon_sym_using] = ACTIONS(3940),
    [anon_sym_unsafe] = ACTIONS(3940),
    [anon_sym_static] = ACTIONS(3940),
    [anon_sym_LBRACK] = ACTIONS(3942),
    [anon_sym_LPAREN] = ACTIONS(3942),
    [anon_sym_event] = ACTIONS(3940),
    [anon_sym_namespace] = ACTIONS(3940),
    [anon_sym_class] = ACTIONS(3940),
    [anon_sym_ref] = ACTIONS(3940),
    [anon_sym_struct] = ACTIONS(3940),
    [anon_sym_enum] = ACTIONS(3940),
    [anon_sym_RBRACE] = ACTIONS(3942),
    [anon_sym_interface] = ACTIONS(3940),
    [anon_sym_delegate] = ACTIONS(3940),
    [anon_sym_record] = ACTIONS(3940),
    [anon_sym_abstract] = ACTIONS(3940),
    [anon_sym_async] = ACTIONS(3940),
    [anon_sym_const] = ACTIONS(3940),
    [anon_sym_file] = ACTIONS(3940),
    [anon_sym_fixed] = ACTIONS(3940),
    [anon_sym_internal] = ACTIONS(3940),
    [anon_sym_new] = ACTIONS(3940),
    [anon_sym_override] = ACTIONS(3940),
    [anon_sym_partial] = ACTIONS(3940),
    [anon_sym_private] = ACTIONS(3940),
    [anon_sym_protected] = ACTIONS(3940),
    [anon_sym_public] = ACTIONS(3940),
    [anon_sym_readonly] = ACTIONS(3940),
    [anon_sym_required] = ACTIONS(3940),
    [anon_sym_sealed] = ACTIONS(3940),
    [anon_sym_virtual] = ACTIONS(3940),
    [anon_sym_volatile] = ACTIONS(3940),
    [anon_sym_where] = ACTIONS(3940),
    [anon_sym_notnull] = ACTIONS(3940),
    [anon_sym_unmanaged] = ACTIONS(3940),
    [anon_sym_TILDE] = ACTIONS(3942),
    [anon_sym_implicit] = ACTIONS(3940),
    [anon_sym_explicit] = ACTIONS(3940),
    [anon_sym_scoped] = ACTIONS(3940),
    [anon_sym_var] = ACTIONS(3940),
    [sym_predefined_type] = ACTIONS(3940),
    [anon_sym_yield] = ACTIONS(3940),
    [anon_sym_when] = ACTIONS(3940),
    [anon_sym_from] = ACTIONS(3940),
    [anon_sym_into] = ACTIONS(3940),
    [anon_sym_join] = ACTIONS(3940),
    [anon_sym_on] = ACTIONS(3940),
    [anon_sym_equals] = ACTIONS(3940),
    [anon_sym_let] = ACTIONS(3940),
    [anon_sym_orderby] = ACTIONS(3940),
    [anon_sym_ascending] = ACTIONS(3940),
    [anon_sym_descending] = ACTIONS(3940),
    [anon_sym_group] = ACTIONS(3940),
    [anon_sym_by] = ACTIONS(3940),
    [anon_sym_select] = ACTIONS(3940),
    [aux_sym_preproc_if_token1] = ACTIONS(3942),
    [aux_sym_preproc_if_token3] = ACTIONS(3942),
    [aux_sym_preproc_else_token1] = ACTIONS(3942),
    [aux_sym_preproc_elif_token1] = ACTIONS(3942),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3361] = {
    [sym_preproc_region] = STATE(3361),
    [sym_preproc_endregion] = STATE(3361),
    [sym_preproc_line] = STATE(3361),
    [sym_preproc_pragma] = STATE(3361),
    [sym_preproc_nullable] = STATE(3361),
    [sym_preproc_error] = STATE(3361),
    [sym_preproc_define] = STATE(3361),
    [sym_preproc_undef] = STATE(3361),
    [sym__identifier_token] = ACTIONS(3920),
    [anon_sym_extern] = ACTIONS(3920),
    [anon_sym_alias] = ACTIONS(3920),
    [anon_sym_global] = ACTIONS(3920),
    [anon_sym_using] = ACTIONS(3920),
    [anon_sym_unsafe] = ACTIONS(3920),
    [anon_sym_static] = ACTIONS(3920),
    [anon_sym_LBRACK] = ACTIONS(3922),
    [anon_sym_LPAREN] = ACTIONS(3922),
    [anon_sym_event] = ACTIONS(3920),
    [anon_sym_namespace] = ACTIONS(3920),
    [anon_sym_class] = ACTIONS(3920),
    [anon_sym_ref] = ACTIONS(3920),
    [anon_sym_struct] = ACTIONS(3920),
    [anon_sym_enum] = ACTIONS(3920),
    [anon_sym_RBRACE] = ACTIONS(3922),
    [anon_sym_interface] = ACTIONS(3920),
    [anon_sym_delegate] = ACTIONS(3920),
    [anon_sym_record] = ACTIONS(3920),
    [anon_sym_abstract] = ACTIONS(3920),
    [anon_sym_async] = ACTIONS(3920),
    [anon_sym_const] = ACTIONS(3920),
    [anon_sym_file] = ACTIONS(3920),
    [anon_sym_fixed] = ACTIONS(3920),
    [anon_sym_internal] = ACTIONS(3920),
    [anon_sym_new] = ACTIONS(3920),
    [anon_sym_override] = ACTIONS(3920),
    [anon_sym_partial] = ACTIONS(3920),
    [anon_sym_private] = ACTIONS(3920),
    [anon_sym_protected] = ACTIONS(3920),
    [anon_sym_public] = ACTIONS(3920),
    [anon_sym_readonly] = ACTIONS(3920),
    [anon_sym_required] = ACTIONS(3920),
    [anon_sym_sealed] = ACTIONS(3920),
    [anon_sym_virtual] = ACTIONS(3920),
    [anon_sym_volatile] = ACTIONS(3920),
    [anon_sym_where] = ACTIONS(3920),
    [anon_sym_notnull] = ACTIONS(3920),
    [anon_sym_unmanaged] = ACTIONS(3920),
    [anon_sym_TILDE] = ACTIONS(3922),
    [anon_sym_implicit] = ACTIONS(3920),
    [anon_sym_explicit] = ACTIONS(3920),
    [anon_sym_scoped] = ACTIONS(3920),
    [anon_sym_var] = ACTIONS(3920),
    [sym_predefined_type] = ACTIONS(3920),
    [anon_sym_yield] = ACTIONS(3920),
    [anon_sym_when] = ACTIONS(3920),
    [anon_sym_from] = ACTIONS(3920),
    [anon_sym_into] = ACTIONS(3920),
    [anon_sym_join] = ACTIONS(3920),
    [anon_sym_on] = ACTIONS(3920),
    [anon_sym_equals] = ACTIONS(3920),
    [anon_sym_let] = ACTIONS(3920),
    [anon_sym_orderby] = ACTIONS(3920),
    [anon_sym_ascending] = ACTIONS(3920),
    [anon_sym_descending] = ACTIONS(3920),
    [anon_sym_group] = ACTIONS(3920),
    [anon_sym_by] = ACTIONS(3920),
    [anon_sym_select] = ACTIONS(3920),
    [aux_sym_preproc_if_token1] = ACTIONS(3922),
    [aux_sym_preproc_if_token3] = ACTIONS(3922),
    [aux_sym_preproc_else_token1] = ACTIONS(3922),
    [aux_sym_preproc_elif_token1] = ACTIONS(3922),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3362] = {
    [sym__variable_designation] = STATE(4246),
    [sym_parenthesized_variable_designation] = STATE(4274),
    [sym_identifier] = STATE(4269),
    [sym__reserved_identifier] = STATE(3908),
    [sym_preproc_region] = STATE(3362),
    [sym_preproc_endregion] = STATE(3362),
    [sym_preproc_line] = STATE(3362),
    [sym_preproc_pragma] = STATE(3362),
    [sym_preproc_nullable] = STATE(3362),
    [sym_preproc_error] = STATE(3362),
    [sym_preproc_define] = STATE(3362),
    [sym_preproc_undef] = STATE(3362),
    [sym__identifier_token] = ACTIONS(4271),
    [anon_sym_alias] = ACTIONS(4273),
    [anon_sym_global] = ACTIONS(4273),
    [anon_sym_LBRACK] = ACTIONS(4329),
    [anon_sym_LPAREN] = ACTIONS(4329),
    [anon_sym_file] = ACTIONS(4273),
    [anon_sym_LT] = ACTIONS(4331),
    [anon_sym_GT] = ACTIONS(4331),
    [anon_sym_where] = ACTIONS(4273),
    [anon_sym_QMARK] = ACTIONS(4331),
    [anon_sym_notnull] = ACTIONS(4273),
    [anon_sym_unmanaged] = ACTIONS(4273),
    [anon_sym_BANG] = ACTIONS(4331),
    [anon_sym_PLUS_PLUS] = ACTIONS(4329),
    [anon_sym_DASH_DASH] = ACTIONS(4329),
    [anon_sym_PLUS] = ACTIONS(4331),
    [anon_sym_DASH] = ACTIONS(4331),
    [anon_sym_STAR] = ACTIONS(4329),
    [anon_sym_SLASH] = ACTIONS(4331),
    [anon_sym_PERCENT] = ACTIONS(4329),
    [anon_sym_CARET] = ACTIONS(4329),
    [anon_sym_PIPE] = ACTIONS(4331),
    [anon_sym_AMP] = ACTIONS(4331),
    [anon_sym_LT_LT] = ACTIONS(4329),
    [anon_sym_GT_GT] = ACTIONS(4331),
    [anon_sym_GT_GT_GT] = ACTIONS(4329),
    [anon_sym_EQ_EQ] = ACTIONS(4329),
    [anon_sym_BANG_EQ] = ACTIONS(4329),
    [anon_sym_GT_EQ] = ACTIONS(4329),
    [anon_sym_LT_EQ] = ACTIONS(4329),
    [anon_sym_DOT] = ACTIONS(4331),
    [anon_sym_scoped] = ACTIONS(4273),
    [anon_sym_var] = ACTIONS(4273),
    [anon_sym_yield] = ACTIONS(4273),
    [anon_sym_switch] = ACTIONS(4331),
    [anon_sym_when] = ACTIONS(4273),
    [sym_discard] = ACTIONS(4295),
    [anon_sym_DOT_DOT] = ACTIONS(4329),
    [anon_sym_and] = ACTIONS(4331),
    [anon_sym_or] = ACTIONS(4331),
    [anon_sym_AMP_AMP] = ACTIONS(4329),
    [anon_sym_PIPE_PIPE] = ACTIONS(4329),
    [anon_sym_QMARK_QMARK] = ACTIONS(4329),
    [anon_sym_from] = ACTIONS(4273),
    [anon_sym_into] = ACTIONS(4273),
    [anon_sym_join] = ACTIONS(4273),
    [anon_sym_on] = ACTIONS(4273),
    [anon_sym_equals] = ACTIONS(4331),
    [anon_sym_let] = ACTIONS(4273),
    [anon_sym_orderby] = ACTIONS(4273),
    [anon_sym_ascending] = ACTIONS(4273),
    [anon_sym_descending] = ACTIONS(4273),
    [anon_sym_group] = ACTIONS(4273),
    [anon_sym_by] = ACTIONS(4273),
    [anon_sym_select] = ACTIONS(4273),
    [anon_sym_as] = ACTIONS(4331),
    [anon_sym_is] = ACTIONS(4331),
    [anon_sym_DASH_GT] = ACTIONS(4329),
    [anon_sym_with] = ACTIONS(4331),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3363] = {
    [sym__variable_designation] = STATE(4123),
    [sym_parenthesized_variable_designation] = STATE(4274),
    [sym_identifier] = STATE(4269),
    [sym__reserved_identifier] = STATE(3908),
    [sym_preproc_region] = STATE(3363),
    [sym_preproc_endregion] = STATE(3363),
    [sym_preproc_line] = STATE(3363),
    [sym_preproc_pragma] = STATE(3363),
    [sym_preproc_nullable] = STATE(3363),
    [sym_preproc_error] = STATE(3363),
    [sym_preproc_define] = STATE(3363),
    [sym_preproc_undef] = STATE(3363),
    [sym__identifier_token] = ACTIONS(4271),
    [anon_sym_alias] = ACTIONS(4273),
    [anon_sym_global] = ACTIONS(4273),
    [anon_sym_LBRACK] = ACTIONS(4335),
    [anon_sym_LPAREN] = ACTIONS(4335),
    [anon_sym_file] = ACTIONS(4273),
    [anon_sym_LT] = ACTIONS(4337),
    [anon_sym_GT] = ACTIONS(4337),
    [anon_sym_where] = ACTIONS(4273),
    [anon_sym_QMARK] = ACTIONS(4337),
    [anon_sym_notnull] = ACTIONS(4273),
    [anon_sym_unmanaged] = ACTIONS(4273),
    [anon_sym_BANG] = ACTIONS(4337),
    [anon_sym_PLUS_PLUS] = ACTIONS(4335),
    [anon_sym_DASH_DASH] = ACTIONS(4335),
    [anon_sym_PLUS] = ACTIONS(4337),
    [anon_sym_DASH] = ACTIONS(4337),
    [anon_sym_STAR] = ACTIONS(4335),
    [anon_sym_SLASH] = ACTIONS(4337),
    [anon_sym_PERCENT] = ACTIONS(4335),
    [anon_sym_CARET] = ACTIONS(4335),
    [anon_sym_PIPE] = ACTIONS(4337),
    [anon_sym_AMP] = ACTIONS(4337),
    [anon_sym_LT_LT] = ACTIONS(4335),
    [anon_sym_GT_GT] = ACTIONS(4337),
    [anon_sym_GT_GT_GT] = ACTIONS(4335),
    [anon_sym_EQ_EQ] = ACTIONS(4335),
    [anon_sym_BANG_EQ] = ACTIONS(4335),
    [anon_sym_GT_EQ] = ACTIONS(4335),
    [anon_sym_LT_EQ] = ACTIONS(4335),
    [anon_sym_DOT] = ACTIONS(4337),
    [anon_sym_scoped] = ACTIONS(4273),
    [anon_sym_var] = ACTIONS(4273),
    [anon_sym_yield] = ACTIONS(4273),
    [anon_sym_switch] = ACTIONS(4337),
    [anon_sym_when] = ACTIONS(4273),
    [sym_discard] = ACTIONS(4295),
    [anon_sym_DOT_DOT] = ACTIONS(4335),
    [anon_sym_and] = ACTIONS(4337),
    [anon_sym_or] = ACTIONS(4337),
    [anon_sym_AMP_AMP] = ACTIONS(4335),
    [anon_sym_PIPE_PIPE] = ACTIONS(4335),
    [anon_sym_QMARK_QMARK] = ACTIONS(4335),
    [anon_sym_from] = ACTIONS(4273),
    [anon_sym_into] = ACTIONS(4273),
    [anon_sym_join] = ACTIONS(4273),
    [anon_sym_on] = ACTIONS(4273),
    [anon_sym_equals] = ACTIONS(4337),
    [anon_sym_let] = ACTIONS(4273),
    [anon_sym_orderby] = ACTIONS(4273),
    [anon_sym_ascending] = ACTIONS(4273),
    [anon_sym_descending] = ACTIONS(4273),
    [anon_sym_group] = ACTIONS(4273),
    [anon_sym_by] = ACTIONS(4273),
    [anon_sym_select] = ACTIONS(4273),
    [anon_sym_as] = ACTIONS(4337),
    [anon_sym_is] = ACTIONS(4337),
    [anon_sym_DASH_GT] = ACTIONS(4335),
    [anon_sym_with] = ACTIONS(4337),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3364] = {
    [sym_preproc_region] = STATE(3364),
    [sym_preproc_endregion] = STATE(3364),
    [sym_preproc_line] = STATE(3364),
    [sym_preproc_pragma] = STATE(3364),
    [sym_preproc_nullable] = STATE(3364),
    [sym_preproc_error] = STATE(3364),
    [sym_preproc_define] = STATE(3364),
    [sym_preproc_undef] = STATE(3364),
    [sym__identifier_token] = ACTIONS(3645),
    [anon_sym_extern] = ACTIONS(3645),
    [anon_sym_alias] = ACTIONS(3645),
    [anon_sym_global] = ACTIONS(3645),
    [anon_sym_using] = ACTIONS(3645),
    [anon_sym_unsafe] = ACTIONS(3645),
    [anon_sym_static] = ACTIONS(3645),
    [anon_sym_LBRACK] = ACTIONS(3647),
    [anon_sym_LPAREN] = ACTIONS(3647),
    [anon_sym_event] = ACTIONS(3645),
    [anon_sym_namespace] = ACTIONS(3645),
    [anon_sym_class] = ACTIONS(3645),
    [anon_sym_ref] = ACTIONS(3645),
    [anon_sym_struct] = ACTIONS(3645),
    [anon_sym_enum] = ACTIONS(3645),
    [anon_sym_RBRACE] = ACTIONS(3647),
    [anon_sym_interface] = ACTIONS(3645),
    [anon_sym_delegate] = ACTIONS(3645),
    [anon_sym_record] = ACTIONS(3645),
    [anon_sym_abstract] = ACTIONS(3645),
    [anon_sym_async] = ACTIONS(3645),
    [anon_sym_const] = ACTIONS(3645),
    [anon_sym_file] = ACTIONS(3645),
    [anon_sym_fixed] = ACTIONS(3645),
    [anon_sym_internal] = ACTIONS(3645),
    [anon_sym_new] = ACTIONS(3645),
    [anon_sym_override] = ACTIONS(3645),
    [anon_sym_partial] = ACTIONS(3645),
    [anon_sym_private] = ACTIONS(3645),
    [anon_sym_protected] = ACTIONS(3645),
    [anon_sym_public] = ACTIONS(3645),
    [anon_sym_readonly] = ACTIONS(3645),
    [anon_sym_required] = ACTIONS(3645),
    [anon_sym_sealed] = ACTIONS(3645),
    [anon_sym_virtual] = ACTIONS(3645),
    [anon_sym_volatile] = ACTIONS(3645),
    [anon_sym_where] = ACTIONS(3645),
    [anon_sym_notnull] = ACTIONS(3645),
    [anon_sym_unmanaged] = ACTIONS(3645),
    [anon_sym_TILDE] = ACTIONS(3647),
    [anon_sym_implicit] = ACTIONS(3645),
    [anon_sym_explicit] = ACTIONS(3645),
    [anon_sym_scoped] = ACTIONS(3645),
    [anon_sym_var] = ACTIONS(3645),
    [sym_predefined_type] = ACTIONS(3645),
    [anon_sym_yield] = ACTIONS(3645),
    [anon_sym_when] = ACTIONS(3645),
    [anon_sym_from] = ACTIONS(3645),
    [anon_sym_into] = ACTIONS(3645),
    [anon_sym_join] = ACTIONS(3645),
    [anon_sym_on] = ACTIONS(3645),
    [anon_sym_equals] = ACTIONS(3645),
    [anon_sym_let] = ACTIONS(3645),
    [anon_sym_orderby] = ACTIONS(3645),
    [anon_sym_ascending] = ACTIONS(3645),
    [anon_sym_descending] = ACTIONS(3645),
    [anon_sym_group] = ACTIONS(3645),
    [anon_sym_by] = ACTIONS(3645),
    [anon_sym_select] = ACTIONS(3645),
    [aux_sym_preproc_if_token1] = ACTIONS(3647),
    [aux_sym_preproc_if_token3] = ACTIONS(3647),
    [aux_sym_preproc_else_token1] = ACTIONS(3647),
    [aux_sym_preproc_elif_token1] = ACTIONS(3647),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3365] = {
    [sym_preproc_region] = STATE(3365),
    [sym_preproc_endregion] = STATE(3365),
    [sym_preproc_line] = STATE(3365),
    [sym_preproc_pragma] = STATE(3365),
    [sym_preproc_nullable] = STATE(3365),
    [sym_preproc_error] = STATE(3365),
    [sym_preproc_define] = STATE(3365),
    [sym_preproc_undef] = STATE(3365),
    [sym__identifier_token] = ACTIONS(3916),
    [anon_sym_extern] = ACTIONS(3916),
    [anon_sym_alias] = ACTIONS(3916),
    [anon_sym_global] = ACTIONS(3916),
    [anon_sym_using] = ACTIONS(3916),
    [anon_sym_unsafe] = ACTIONS(3916),
    [anon_sym_static] = ACTIONS(3916),
    [anon_sym_LBRACK] = ACTIONS(3918),
    [anon_sym_LPAREN] = ACTIONS(3918),
    [anon_sym_event] = ACTIONS(3916),
    [anon_sym_namespace] = ACTIONS(3916),
    [anon_sym_class] = ACTIONS(3916),
    [anon_sym_ref] = ACTIONS(3916),
    [anon_sym_struct] = ACTIONS(3916),
    [anon_sym_enum] = ACTIONS(3916),
    [anon_sym_RBRACE] = ACTIONS(3918),
    [anon_sym_interface] = ACTIONS(3916),
    [anon_sym_delegate] = ACTIONS(3916),
    [anon_sym_record] = ACTIONS(3916),
    [anon_sym_abstract] = ACTIONS(3916),
    [anon_sym_async] = ACTIONS(3916),
    [anon_sym_const] = ACTIONS(3916),
    [anon_sym_file] = ACTIONS(3916),
    [anon_sym_fixed] = ACTIONS(3916),
    [anon_sym_internal] = ACTIONS(3916),
    [anon_sym_new] = ACTIONS(3916),
    [anon_sym_override] = ACTIONS(3916),
    [anon_sym_partial] = ACTIONS(3916),
    [anon_sym_private] = ACTIONS(3916),
    [anon_sym_protected] = ACTIONS(3916),
    [anon_sym_public] = ACTIONS(3916),
    [anon_sym_readonly] = ACTIONS(3916),
    [anon_sym_required] = ACTIONS(3916),
    [anon_sym_sealed] = ACTIONS(3916),
    [anon_sym_virtual] = ACTIONS(3916),
    [anon_sym_volatile] = ACTIONS(3916),
    [anon_sym_where] = ACTIONS(3916),
    [anon_sym_notnull] = ACTIONS(3916),
    [anon_sym_unmanaged] = ACTIONS(3916),
    [anon_sym_TILDE] = ACTIONS(3918),
    [anon_sym_implicit] = ACTIONS(3916),
    [anon_sym_explicit] = ACTIONS(3916),
    [anon_sym_scoped] = ACTIONS(3916),
    [anon_sym_var] = ACTIONS(3916),
    [sym_predefined_type] = ACTIONS(3916),
    [anon_sym_yield] = ACTIONS(3916),
    [anon_sym_when] = ACTIONS(3916),
    [anon_sym_from] = ACTIONS(3916),
    [anon_sym_into] = ACTIONS(3916),
    [anon_sym_join] = ACTIONS(3916),
    [anon_sym_on] = ACTIONS(3916),
    [anon_sym_equals] = ACTIONS(3916),
    [anon_sym_let] = ACTIONS(3916),
    [anon_sym_orderby] = ACTIONS(3916),
    [anon_sym_ascending] = ACTIONS(3916),
    [anon_sym_descending] = ACTIONS(3916),
    [anon_sym_group] = ACTIONS(3916),
    [anon_sym_by] = ACTIONS(3916),
    [anon_sym_select] = ACTIONS(3916),
    [aux_sym_preproc_if_token1] = ACTIONS(3918),
    [aux_sym_preproc_if_token3] = ACTIONS(3918),
    [aux_sym_preproc_else_token1] = ACTIONS(3918),
    [aux_sym_preproc_elif_token1] = ACTIONS(3918),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3366] = {
    [sym_preproc_region] = STATE(3366),
    [sym_preproc_endregion] = STATE(3366),
    [sym_preproc_line] = STATE(3366),
    [sym_preproc_pragma] = STATE(3366),
    [sym_preproc_nullable] = STATE(3366),
    [sym_preproc_error] = STATE(3366),
    [sym_preproc_define] = STATE(3366),
    [sym_preproc_undef] = STATE(3366),
    [sym__identifier_token] = ACTIONS(5017),
    [anon_sym_extern] = ACTIONS(5017),
    [anon_sym_alias] = ACTIONS(5017),
    [anon_sym_global] = ACTIONS(5017),
    [anon_sym_using] = ACTIONS(5017),
    [anon_sym_unsafe] = ACTIONS(5017),
    [anon_sym_static] = ACTIONS(5017),
    [anon_sym_LBRACK] = ACTIONS(5019),
    [anon_sym_LPAREN] = ACTIONS(5019),
    [anon_sym_event] = ACTIONS(5017),
    [anon_sym_namespace] = ACTIONS(5017),
    [anon_sym_class] = ACTIONS(5017),
    [anon_sym_ref] = ACTIONS(5017),
    [anon_sym_struct] = ACTIONS(5017),
    [anon_sym_enum] = ACTIONS(5017),
    [anon_sym_RBRACE] = ACTIONS(5019),
    [anon_sym_interface] = ACTIONS(5017),
    [anon_sym_delegate] = ACTIONS(5017),
    [anon_sym_record] = ACTIONS(5017),
    [anon_sym_abstract] = ACTIONS(5017),
    [anon_sym_async] = ACTIONS(5017),
    [anon_sym_const] = ACTIONS(5017),
    [anon_sym_file] = ACTIONS(5017),
    [anon_sym_fixed] = ACTIONS(5017),
    [anon_sym_internal] = ACTIONS(5017),
    [anon_sym_new] = ACTIONS(5017),
    [anon_sym_override] = ACTIONS(5017),
    [anon_sym_partial] = ACTIONS(5017),
    [anon_sym_private] = ACTIONS(5017),
    [anon_sym_protected] = ACTIONS(5017),
    [anon_sym_public] = ACTIONS(5017),
    [anon_sym_readonly] = ACTIONS(5017),
    [anon_sym_required] = ACTIONS(5017),
    [anon_sym_sealed] = ACTIONS(5017),
    [anon_sym_virtual] = ACTIONS(5017),
    [anon_sym_volatile] = ACTIONS(5017),
    [anon_sym_where] = ACTIONS(5017),
    [anon_sym_notnull] = ACTIONS(5017),
    [anon_sym_unmanaged] = ACTIONS(5017),
    [anon_sym_TILDE] = ACTIONS(5019),
    [anon_sym_implicit] = ACTIONS(5017),
    [anon_sym_explicit] = ACTIONS(5017),
    [anon_sym_scoped] = ACTIONS(5017),
    [anon_sym_var] = ACTIONS(5017),
    [sym_predefined_type] = ACTIONS(5017),
    [anon_sym_yield] = ACTIONS(5017),
    [anon_sym_when] = ACTIONS(5017),
    [anon_sym_from] = ACTIONS(5017),
    [anon_sym_into] = ACTIONS(5017),
    [anon_sym_join] = ACTIONS(5017),
    [anon_sym_on] = ACTIONS(5017),
    [anon_sym_equals] = ACTIONS(5017),
    [anon_sym_let] = ACTIONS(5017),
    [anon_sym_orderby] = ACTIONS(5017),
    [anon_sym_ascending] = ACTIONS(5017),
    [anon_sym_descending] = ACTIONS(5017),
    [anon_sym_group] = ACTIONS(5017),
    [anon_sym_by] = ACTIONS(5017),
    [anon_sym_select] = ACTIONS(5017),
    [aux_sym_preproc_if_token1] = ACTIONS(5019),
    [aux_sym_preproc_if_token3] = ACTIONS(5019),
    [aux_sym_preproc_else_token1] = ACTIONS(5019),
    [aux_sym_preproc_elif_token1] = ACTIONS(5019),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3367] = {
    [sym_preproc_region] = STATE(3367),
    [sym_preproc_endregion] = STATE(3367),
    [sym_preproc_line] = STATE(3367),
    [sym_preproc_pragma] = STATE(3367),
    [sym_preproc_nullable] = STATE(3367),
    [sym_preproc_error] = STATE(3367),
    [sym_preproc_define] = STATE(3367),
    [sym_preproc_undef] = STATE(3367),
    [sym__identifier_token] = ACTIONS(3912),
    [anon_sym_extern] = ACTIONS(3912),
    [anon_sym_alias] = ACTIONS(3912),
    [anon_sym_global] = ACTIONS(3912),
    [anon_sym_using] = ACTIONS(3912),
    [anon_sym_unsafe] = ACTIONS(3912),
    [anon_sym_static] = ACTIONS(3912),
    [anon_sym_LBRACK] = ACTIONS(3914),
    [anon_sym_LPAREN] = ACTIONS(3914),
    [anon_sym_event] = ACTIONS(3912),
    [anon_sym_namespace] = ACTIONS(3912),
    [anon_sym_class] = ACTIONS(3912),
    [anon_sym_ref] = ACTIONS(3912),
    [anon_sym_struct] = ACTIONS(3912),
    [anon_sym_enum] = ACTIONS(3912),
    [anon_sym_RBRACE] = ACTIONS(3914),
    [anon_sym_interface] = ACTIONS(3912),
    [anon_sym_delegate] = ACTIONS(3912),
    [anon_sym_record] = ACTIONS(3912),
    [anon_sym_abstract] = ACTIONS(3912),
    [anon_sym_async] = ACTIONS(3912),
    [anon_sym_const] = ACTIONS(3912),
    [anon_sym_file] = ACTIONS(3912),
    [anon_sym_fixed] = ACTIONS(3912),
    [anon_sym_internal] = ACTIONS(3912),
    [anon_sym_new] = ACTIONS(3912),
    [anon_sym_override] = ACTIONS(3912),
    [anon_sym_partial] = ACTIONS(3912),
    [anon_sym_private] = ACTIONS(3912),
    [anon_sym_protected] = ACTIONS(3912),
    [anon_sym_public] = ACTIONS(3912),
    [anon_sym_readonly] = ACTIONS(3912),
    [anon_sym_required] = ACTIONS(3912),
    [anon_sym_sealed] = ACTIONS(3912),
    [anon_sym_virtual] = ACTIONS(3912),
    [anon_sym_volatile] = ACTIONS(3912),
    [anon_sym_where] = ACTIONS(3912),
    [anon_sym_notnull] = ACTIONS(3912),
    [anon_sym_unmanaged] = ACTIONS(3912),
    [anon_sym_TILDE] = ACTIONS(3914),
    [anon_sym_implicit] = ACTIONS(3912),
    [anon_sym_explicit] = ACTIONS(3912),
    [anon_sym_scoped] = ACTIONS(3912),
    [anon_sym_var] = ACTIONS(3912),
    [sym_predefined_type] = ACTIONS(3912),
    [anon_sym_yield] = ACTIONS(3912),
    [anon_sym_when] = ACTIONS(3912),
    [anon_sym_from] = ACTIONS(3912),
    [anon_sym_into] = ACTIONS(3912),
    [anon_sym_join] = ACTIONS(3912),
    [anon_sym_on] = ACTIONS(3912),
    [anon_sym_equals] = ACTIONS(3912),
    [anon_sym_let] = ACTIONS(3912),
    [anon_sym_orderby] = ACTIONS(3912),
    [anon_sym_ascending] = ACTIONS(3912),
    [anon_sym_descending] = ACTIONS(3912),
    [anon_sym_group] = ACTIONS(3912),
    [anon_sym_by] = ACTIONS(3912),
    [anon_sym_select] = ACTIONS(3912),
    [aux_sym_preproc_if_token1] = ACTIONS(3914),
    [aux_sym_preproc_if_token3] = ACTIONS(3914),
    [aux_sym_preproc_else_token1] = ACTIONS(3914),
    [aux_sym_preproc_elif_token1] = ACTIONS(3914),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3368] = {
    [sym_preproc_region] = STATE(3368),
    [sym_preproc_endregion] = STATE(3368),
    [sym_preproc_line] = STATE(3368),
    [sym_preproc_pragma] = STATE(3368),
    [sym_preproc_nullable] = STATE(3368),
    [sym_preproc_error] = STATE(3368),
    [sym_preproc_define] = STATE(3368),
    [sym_preproc_undef] = STATE(3368),
    [sym__identifier_token] = ACTIONS(4402),
    [anon_sym_alias] = ACTIONS(4402),
    [anon_sym_global] = ACTIONS(4402),
    [anon_sym_LBRACK] = ACTIONS(4404),
    [anon_sym_COLON] = ACTIONS(4404),
    [anon_sym_COMMA] = ACTIONS(4404),
    [anon_sym_LPAREN] = ACTIONS(4404),
    [anon_sym_LBRACE] = ACTIONS(4404),
    [anon_sym_file] = ACTIONS(4402),
    [anon_sym_LT] = ACTIONS(4402),
    [anon_sym_GT] = ACTIONS(4402),
    [anon_sym_where] = ACTIONS(4402),
    [anon_sym_QMARK] = ACTIONS(4402),
    [anon_sym_notnull] = ACTIONS(4402),
    [anon_sym_unmanaged] = ACTIONS(4402),
    [anon_sym_BANG] = ACTIONS(4402),
    [anon_sym_PLUS_PLUS] = ACTIONS(4404),
    [anon_sym_DASH_DASH] = ACTIONS(4404),
    [anon_sym_PLUS] = ACTIONS(4402),
    [anon_sym_DASH] = ACTIONS(4402),
    [anon_sym_STAR] = ACTIONS(4404),
    [anon_sym_SLASH] = ACTIONS(4402),
    [anon_sym_PERCENT] = ACTIONS(4404),
    [anon_sym_CARET] = ACTIONS(4404),
    [anon_sym_PIPE] = ACTIONS(4402),
    [anon_sym_AMP] = ACTIONS(4402),
    [anon_sym_LT_LT] = ACTIONS(4404),
    [anon_sym_GT_GT] = ACTIONS(4402),
    [anon_sym_GT_GT_GT] = ACTIONS(4404),
    [anon_sym_EQ_EQ] = ACTIONS(4404),
    [anon_sym_BANG_EQ] = ACTIONS(4404),
    [anon_sym_GT_EQ] = ACTIONS(4404),
    [anon_sym_LT_EQ] = ACTIONS(4404),
    [anon_sym_DOT] = ACTIONS(4402),
    [anon_sym_scoped] = ACTIONS(4402),
    [anon_sym_var] = ACTIONS(4402),
    [anon_sym_yield] = ACTIONS(4402),
    [anon_sym_switch] = ACTIONS(4402),
    [anon_sym_when] = ACTIONS(4402),
    [sym_discard] = ACTIONS(4402),
    [anon_sym_DOT_DOT] = ACTIONS(4404),
    [anon_sym_and] = ACTIONS(4402),
    [anon_sym_or] = ACTIONS(4402),
    [anon_sym_AMP_AMP] = ACTIONS(4404),
    [anon_sym_PIPE_PIPE] = ACTIONS(4404),
    [anon_sym_QMARK_QMARK] = ACTIONS(4404),
    [anon_sym_from] = ACTIONS(4402),
    [anon_sym_into] = ACTIONS(4402),
    [anon_sym_join] = ACTIONS(4402),
    [anon_sym_on] = ACTIONS(4402),
    [anon_sym_equals] = ACTIONS(4402),
    [anon_sym_let] = ACTIONS(4402),
    [anon_sym_orderby] = ACTIONS(4402),
    [anon_sym_ascending] = ACTIONS(4402),
    [anon_sym_descending] = ACTIONS(4402),
    [anon_sym_group] = ACTIONS(4402),
    [anon_sym_by] = ACTIONS(4402),
    [anon_sym_select] = ACTIONS(4402),
    [anon_sym_as] = ACTIONS(4402),
    [anon_sym_is] = ACTIONS(4402),
    [anon_sym_DASH_GT] = ACTIONS(4404),
    [anon_sym_with] = ACTIONS(4402),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4404),
  },
  [3369] = {
    [sym__variable_designation] = STATE(4113),
    [sym_parenthesized_variable_designation] = STATE(4274),
    [sym_identifier] = STATE(4269),
    [sym__reserved_identifier] = STATE(3908),
    [sym_preproc_region] = STATE(3369),
    [sym_preproc_endregion] = STATE(3369),
    [sym_preproc_line] = STATE(3369),
    [sym_preproc_pragma] = STATE(3369),
    [sym_preproc_nullable] = STATE(3369),
    [sym_preproc_error] = STATE(3369),
    [sym_preproc_define] = STATE(3369),
    [sym_preproc_undef] = STATE(3369),
    [sym__identifier_token] = ACTIONS(4271),
    [anon_sym_alias] = ACTIONS(4273),
    [anon_sym_global] = ACTIONS(4273),
    [anon_sym_LBRACK] = ACTIONS(4373),
    [anon_sym_LPAREN] = ACTIONS(4373),
    [anon_sym_file] = ACTIONS(4273),
    [anon_sym_LT] = ACTIONS(4375),
    [anon_sym_GT] = ACTIONS(4375),
    [anon_sym_where] = ACTIONS(4273),
    [anon_sym_QMARK] = ACTIONS(4375),
    [anon_sym_notnull] = ACTIONS(4273),
    [anon_sym_unmanaged] = ACTIONS(4273),
    [anon_sym_BANG] = ACTIONS(4375),
    [anon_sym_PLUS_PLUS] = ACTIONS(4373),
    [anon_sym_DASH_DASH] = ACTIONS(4373),
    [anon_sym_PLUS] = ACTIONS(4375),
    [anon_sym_DASH] = ACTIONS(4375),
    [anon_sym_STAR] = ACTIONS(4373),
    [anon_sym_SLASH] = ACTIONS(4375),
    [anon_sym_PERCENT] = ACTIONS(4373),
    [anon_sym_CARET] = ACTIONS(4373),
    [anon_sym_PIPE] = ACTIONS(4375),
    [anon_sym_AMP] = ACTIONS(4375),
    [anon_sym_LT_LT] = ACTIONS(4373),
    [anon_sym_GT_GT] = ACTIONS(4375),
    [anon_sym_GT_GT_GT] = ACTIONS(4373),
    [anon_sym_EQ_EQ] = ACTIONS(4373),
    [anon_sym_BANG_EQ] = ACTIONS(4373),
    [anon_sym_GT_EQ] = ACTIONS(4373),
    [anon_sym_LT_EQ] = ACTIONS(4373),
    [anon_sym_DOT] = ACTIONS(4375),
    [anon_sym_scoped] = ACTIONS(4273),
    [anon_sym_var] = ACTIONS(4273),
    [anon_sym_yield] = ACTIONS(4273),
    [anon_sym_switch] = ACTIONS(4375),
    [anon_sym_when] = ACTIONS(4273),
    [sym_discard] = ACTIONS(4295),
    [anon_sym_DOT_DOT] = ACTIONS(4373),
    [anon_sym_and] = ACTIONS(4375),
    [anon_sym_or] = ACTIONS(4375),
    [anon_sym_AMP_AMP] = ACTIONS(4373),
    [anon_sym_PIPE_PIPE] = ACTIONS(4373),
    [anon_sym_QMARK_QMARK] = ACTIONS(4373),
    [anon_sym_from] = ACTIONS(4273),
    [anon_sym_into] = ACTIONS(4273),
    [anon_sym_join] = ACTIONS(4273),
    [anon_sym_on] = ACTIONS(4273),
    [anon_sym_equals] = ACTIONS(4375),
    [anon_sym_let] = ACTIONS(4273),
    [anon_sym_orderby] = ACTIONS(4273),
    [anon_sym_ascending] = ACTIONS(4273),
    [anon_sym_descending] = ACTIONS(4273),
    [anon_sym_group] = ACTIONS(4273),
    [anon_sym_by] = ACTIONS(4273),
    [anon_sym_select] = ACTIONS(4273),
    [anon_sym_as] = ACTIONS(4375),
    [anon_sym_is] = ACTIONS(4375),
    [anon_sym_DASH_GT] = ACTIONS(4373),
    [anon_sym_with] = ACTIONS(4375),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3370] = {
    [sym__variable_designation] = STATE(4082),
    [sym_parenthesized_variable_designation] = STATE(4274),
    [sym_identifier] = STATE(4269),
    [sym__reserved_identifier] = STATE(3908),
    [sym_preproc_region] = STATE(3370),
    [sym_preproc_endregion] = STATE(3370),
    [sym_preproc_line] = STATE(3370),
    [sym_preproc_pragma] = STATE(3370),
    [sym_preproc_nullable] = STATE(3370),
    [sym_preproc_error] = STATE(3370),
    [sym_preproc_define] = STATE(3370),
    [sym_preproc_undef] = STATE(3370),
    [sym__identifier_token] = ACTIONS(4271),
    [anon_sym_alias] = ACTIONS(4273),
    [anon_sym_global] = ACTIONS(4273),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_LPAREN] = ACTIONS(4383),
    [anon_sym_file] = ACTIONS(4273),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_where] = ACTIONS(4273),
    [anon_sym_QMARK] = ACTIONS(4385),
    [anon_sym_notnull] = ACTIONS(4273),
    [anon_sym_unmanaged] = ACTIONS(4273),
    [anon_sym_BANG] = ACTIONS(4385),
    [anon_sym_PLUS_PLUS] = ACTIONS(4383),
    [anon_sym_DASH_DASH] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_DASH] = ACTIONS(4385),
    [anon_sym_STAR] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4385),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4385),
    [anon_sym_GT_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4383),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_scoped] = ACTIONS(4273),
    [anon_sym_var] = ACTIONS(4273),
    [anon_sym_yield] = ACTIONS(4273),
    [anon_sym_switch] = ACTIONS(4385),
    [anon_sym_when] = ACTIONS(4273),
    [sym_discard] = ACTIONS(4295),
    [anon_sym_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4385),
    [anon_sym_or] = ACTIONS(4385),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_QMARK_QMARK] = ACTIONS(4383),
    [anon_sym_from] = ACTIONS(4273),
    [anon_sym_into] = ACTIONS(4273),
    [anon_sym_join] = ACTIONS(4273),
    [anon_sym_on] = ACTIONS(4273),
    [anon_sym_equals] = ACTIONS(4385),
    [anon_sym_let] = ACTIONS(4273),
    [anon_sym_orderby] = ACTIONS(4273),
    [anon_sym_ascending] = ACTIONS(4273),
    [anon_sym_descending] = ACTIONS(4273),
    [anon_sym_group] = ACTIONS(4273),
    [anon_sym_by] = ACTIONS(4273),
    [anon_sym_select] = ACTIONS(4273),
    [anon_sym_as] = ACTIONS(4385),
    [anon_sym_is] = ACTIONS(4385),
    [anon_sym_DASH_GT] = ACTIONS(4383),
    [anon_sym_with] = ACTIONS(4385),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3371] = {
    [sym_preproc_region] = STATE(3371),
    [sym_preproc_endregion] = STATE(3371),
    [sym_preproc_line] = STATE(3371),
    [sym_preproc_pragma] = STATE(3371),
    [sym_preproc_nullable] = STATE(3371),
    [sym_preproc_error] = STATE(3371),
    [sym_preproc_define] = STATE(3371),
    [sym_preproc_undef] = STATE(3371),
    [sym__identifier_token] = ACTIONS(4418),
    [anon_sym_alias] = ACTIONS(4418),
    [anon_sym_global] = ACTIONS(4418),
    [anon_sym_LBRACK] = ACTIONS(4420),
    [anon_sym_COLON] = ACTIONS(4420),
    [anon_sym_COMMA] = ACTIONS(4420),
    [anon_sym_LPAREN] = ACTIONS(4420),
    [anon_sym_LBRACE] = ACTIONS(4420),
    [anon_sym_file] = ACTIONS(4418),
    [anon_sym_LT] = ACTIONS(4418),
    [anon_sym_GT] = ACTIONS(4418),
    [anon_sym_where] = ACTIONS(4418),
    [anon_sym_QMARK] = ACTIONS(4418),
    [anon_sym_notnull] = ACTIONS(4418),
    [anon_sym_unmanaged] = ACTIONS(4418),
    [anon_sym_BANG] = ACTIONS(4418),
    [anon_sym_PLUS_PLUS] = ACTIONS(4420),
    [anon_sym_DASH_DASH] = ACTIONS(4420),
    [anon_sym_PLUS] = ACTIONS(4418),
    [anon_sym_DASH] = ACTIONS(4418),
    [anon_sym_STAR] = ACTIONS(4420),
    [anon_sym_SLASH] = ACTIONS(4418),
    [anon_sym_PERCENT] = ACTIONS(4420),
    [anon_sym_CARET] = ACTIONS(4420),
    [anon_sym_PIPE] = ACTIONS(4418),
    [anon_sym_AMP] = ACTIONS(4418),
    [anon_sym_LT_LT] = ACTIONS(4420),
    [anon_sym_GT_GT] = ACTIONS(4418),
    [anon_sym_GT_GT_GT] = ACTIONS(4420),
    [anon_sym_EQ_EQ] = ACTIONS(4420),
    [anon_sym_BANG_EQ] = ACTIONS(4420),
    [anon_sym_GT_EQ] = ACTIONS(4420),
    [anon_sym_LT_EQ] = ACTIONS(4420),
    [anon_sym_DOT] = ACTIONS(4418),
    [anon_sym_scoped] = ACTIONS(4418),
    [anon_sym_var] = ACTIONS(4418),
    [anon_sym_yield] = ACTIONS(4418),
    [anon_sym_switch] = ACTIONS(4418),
    [anon_sym_when] = ACTIONS(4418),
    [sym_discard] = ACTIONS(4418),
    [anon_sym_DOT_DOT] = ACTIONS(4420),
    [anon_sym_and] = ACTIONS(4418),
    [anon_sym_or] = ACTIONS(4418),
    [anon_sym_AMP_AMP] = ACTIONS(4420),
    [anon_sym_PIPE_PIPE] = ACTIONS(4420),
    [anon_sym_QMARK_QMARK] = ACTIONS(4420),
    [anon_sym_from] = ACTIONS(4418),
    [anon_sym_into] = ACTIONS(4418),
    [anon_sym_join] = ACTIONS(4418),
    [anon_sym_on] = ACTIONS(4418),
    [anon_sym_equals] = ACTIONS(4418),
    [anon_sym_let] = ACTIONS(4418),
    [anon_sym_orderby] = ACTIONS(4418),
    [anon_sym_ascending] = ACTIONS(4418),
    [anon_sym_descending] = ACTIONS(4418),
    [anon_sym_group] = ACTIONS(4418),
    [anon_sym_by] = ACTIONS(4418),
    [anon_sym_select] = ACTIONS(4418),
    [anon_sym_as] = ACTIONS(4418),
    [anon_sym_is] = ACTIONS(4418),
    [anon_sym_DASH_GT] = ACTIONS(4420),
    [anon_sym_with] = ACTIONS(4418),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4420),
  },
  [3372] = {
    [sym_preproc_region] = STATE(3372),
    [sym_preproc_endregion] = STATE(3372),
    [sym_preproc_line] = STATE(3372),
    [sym_preproc_pragma] = STATE(3372),
    [sym_preproc_nullable] = STATE(3372),
    [sym_preproc_error] = STATE(3372),
    [sym_preproc_define] = STATE(3372),
    [sym_preproc_undef] = STATE(3372),
    [sym__identifier_token] = ACTIONS(3908),
    [anon_sym_extern] = ACTIONS(3908),
    [anon_sym_alias] = ACTIONS(3908),
    [anon_sym_global] = ACTIONS(3908),
    [anon_sym_using] = ACTIONS(3908),
    [anon_sym_unsafe] = ACTIONS(3908),
    [anon_sym_static] = ACTIONS(3908),
    [anon_sym_LBRACK] = ACTIONS(3910),
    [anon_sym_LPAREN] = ACTIONS(3910),
    [anon_sym_event] = ACTIONS(3908),
    [anon_sym_namespace] = ACTIONS(3908),
    [anon_sym_class] = ACTIONS(3908),
    [anon_sym_ref] = ACTIONS(3908),
    [anon_sym_struct] = ACTIONS(3908),
    [anon_sym_enum] = ACTIONS(3908),
    [anon_sym_RBRACE] = ACTIONS(3910),
    [anon_sym_interface] = ACTIONS(3908),
    [anon_sym_delegate] = ACTIONS(3908),
    [anon_sym_record] = ACTIONS(3908),
    [anon_sym_abstract] = ACTIONS(3908),
    [anon_sym_async] = ACTIONS(3908),
    [anon_sym_const] = ACTIONS(3908),
    [anon_sym_file] = ACTIONS(3908),
    [anon_sym_fixed] = ACTIONS(3908),
    [anon_sym_internal] = ACTIONS(3908),
    [anon_sym_new] = ACTIONS(3908),
    [anon_sym_override] = ACTIONS(3908),
    [anon_sym_partial] = ACTIONS(3908),
    [anon_sym_private] = ACTIONS(3908),
    [anon_sym_protected] = ACTIONS(3908),
    [anon_sym_public] = ACTIONS(3908),
    [anon_sym_readonly] = ACTIONS(3908),
    [anon_sym_required] = ACTIONS(3908),
    [anon_sym_sealed] = ACTIONS(3908),
    [anon_sym_virtual] = ACTIONS(3908),
    [anon_sym_volatile] = ACTIONS(3908),
    [anon_sym_where] = ACTIONS(3908),
    [anon_sym_notnull] = ACTIONS(3908),
    [anon_sym_unmanaged] = ACTIONS(3908),
    [anon_sym_TILDE] = ACTIONS(3910),
    [anon_sym_implicit] = ACTIONS(3908),
    [anon_sym_explicit] = ACTIONS(3908),
    [anon_sym_scoped] = ACTIONS(3908),
    [anon_sym_var] = ACTIONS(3908),
    [sym_predefined_type] = ACTIONS(3908),
    [anon_sym_yield] = ACTIONS(3908),
    [anon_sym_when] = ACTIONS(3908),
    [anon_sym_from] = ACTIONS(3908),
    [anon_sym_into] = ACTIONS(3908),
    [anon_sym_join] = ACTIONS(3908),
    [anon_sym_on] = ACTIONS(3908),
    [anon_sym_equals] = ACTIONS(3908),
    [anon_sym_let] = ACTIONS(3908),
    [anon_sym_orderby] = ACTIONS(3908),
    [anon_sym_ascending] = ACTIONS(3908),
    [anon_sym_descending] = ACTIONS(3908),
    [anon_sym_group] = ACTIONS(3908),
    [anon_sym_by] = ACTIONS(3908),
    [anon_sym_select] = ACTIONS(3908),
    [aux_sym_preproc_if_token1] = ACTIONS(3910),
    [aux_sym_preproc_if_token3] = ACTIONS(3910),
    [aux_sym_preproc_else_token1] = ACTIONS(3910),
    [aux_sym_preproc_elif_token1] = ACTIONS(3910),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3373] = {
    [sym_preproc_region] = STATE(3373),
    [sym_preproc_endregion] = STATE(3373),
    [sym_preproc_line] = STATE(3373),
    [sym_preproc_pragma] = STATE(3373),
    [sym_preproc_nullable] = STATE(3373),
    [sym_preproc_error] = STATE(3373),
    [sym_preproc_define] = STATE(3373),
    [sym_preproc_undef] = STATE(3373),
    [sym__identifier_token] = ACTIONS(5021),
    [anon_sym_extern] = ACTIONS(5021),
    [anon_sym_alias] = ACTIONS(5021),
    [anon_sym_global] = ACTIONS(5021),
    [anon_sym_using] = ACTIONS(5021),
    [anon_sym_unsafe] = ACTIONS(5021),
    [anon_sym_static] = ACTIONS(5021),
    [anon_sym_LBRACK] = ACTIONS(5023),
    [anon_sym_LPAREN] = ACTIONS(5023),
    [anon_sym_event] = ACTIONS(5021),
    [anon_sym_namespace] = ACTIONS(5021),
    [anon_sym_class] = ACTIONS(5021),
    [anon_sym_ref] = ACTIONS(5021),
    [anon_sym_struct] = ACTIONS(5021),
    [anon_sym_enum] = ACTIONS(5021),
    [anon_sym_RBRACE] = ACTIONS(5023),
    [anon_sym_interface] = ACTIONS(5021),
    [anon_sym_delegate] = ACTIONS(5021),
    [anon_sym_record] = ACTIONS(5021),
    [anon_sym_abstract] = ACTIONS(5021),
    [anon_sym_async] = ACTIONS(5021),
    [anon_sym_const] = ACTIONS(5021),
    [anon_sym_file] = ACTIONS(5021),
    [anon_sym_fixed] = ACTIONS(5021),
    [anon_sym_internal] = ACTIONS(5021),
    [anon_sym_new] = ACTIONS(5021),
    [anon_sym_override] = ACTIONS(5021),
    [anon_sym_partial] = ACTIONS(5021),
    [anon_sym_private] = ACTIONS(5021),
    [anon_sym_protected] = ACTIONS(5021),
    [anon_sym_public] = ACTIONS(5021),
    [anon_sym_readonly] = ACTIONS(5021),
    [anon_sym_required] = ACTIONS(5021),
    [anon_sym_sealed] = ACTIONS(5021),
    [anon_sym_virtual] = ACTIONS(5021),
    [anon_sym_volatile] = ACTIONS(5021),
    [anon_sym_where] = ACTIONS(5021),
    [anon_sym_notnull] = ACTIONS(5021),
    [anon_sym_unmanaged] = ACTIONS(5021),
    [anon_sym_TILDE] = ACTIONS(5023),
    [anon_sym_implicit] = ACTIONS(5021),
    [anon_sym_explicit] = ACTIONS(5021),
    [anon_sym_scoped] = ACTIONS(5021),
    [anon_sym_var] = ACTIONS(5021),
    [sym_predefined_type] = ACTIONS(5021),
    [anon_sym_yield] = ACTIONS(5021),
    [anon_sym_when] = ACTIONS(5021),
    [anon_sym_from] = ACTIONS(5021),
    [anon_sym_into] = ACTIONS(5021),
    [anon_sym_join] = ACTIONS(5021),
    [anon_sym_on] = ACTIONS(5021),
    [anon_sym_equals] = ACTIONS(5021),
    [anon_sym_let] = ACTIONS(5021),
    [anon_sym_orderby] = ACTIONS(5021),
    [anon_sym_ascending] = ACTIONS(5021),
    [anon_sym_descending] = ACTIONS(5021),
    [anon_sym_group] = ACTIONS(5021),
    [anon_sym_by] = ACTIONS(5021),
    [anon_sym_select] = ACTIONS(5021),
    [aux_sym_preproc_if_token1] = ACTIONS(5023),
    [aux_sym_preproc_if_token3] = ACTIONS(5023),
    [aux_sym_preproc_else_token1] = ACTIONS(5023),
    [aux_sym_preproc_elif_token1] = ACTIONS(5023),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3374] = {
    [sym_preproc_region] = STATE(3374),
    [sym_preproc_endregion] = STATE(3374),
    [sym_preproc_line] = STATE(3374),
    [sym_preproc_pragma] = STATE(3374),
    [sym_preproc_nullable] = STATE(3374),
    [sym_preproc_error] = STATE(3374),
    [sym_preproc_define] = STATE(3374),
    [sym_preproc_undef] = STATE(3374),
    [sym__identifier_token] = ACTIONS(3649),
    [anon_sym_extern] = ACTIONS(3649),
    [anon_sym_alias] = ACTIONS(3649),
    [anon_sym_global] = ACTIONS(3649),
    [anon_sym_using] = ACTIONS(3649),
    [anon_sym_unsafe] = ACTIONS(3649),
    [anon_sym_static] = ACTIONS(3649),
    [anon_sym_LBRACK] = ACTIONS(3651),
    [anon_sym_LPAREN] = ACTIONS(3651),
    [anon_sym_event] = ACTIONS(3649),
    [anon_sym_namespace] = ACTIONS(3649),
    [anon_sym_class] = ACTIONS(3649),
    [anon_sym_ref] = ACTIONS(3649),
    [anon_sym_struct] = ACTIONS(3649),
    [anon_sym_enum] = ACTIONS(3649),
    [anon_sym_RBRACE] = ACTIONS(3651),
    [anon_sym_interface] = ACTIONS(3649),
    [anon_sym_delegate] = ACTIONS(3649),
    [anon_sym_record] = ACTIONS(3649),
    [anon_sym_abstract] = ACTIONS(3649),
    [anon_sym_async] = ACTIONS(3649),
    [anon_sym_const] = ACTIONS(3649),
    [anon_sym_file] = ACTIONS(3649),
    [anon_sym_fixed] = ACTIONS(3649),
    [anon_sym_internal] = ACTIONS(3649),
    [anon_sym_new] = ACTIONS(3649),
    [anon_sym_override] = ACTIONS(3649),
    [anon_sym_partial] = ACTIONS(3649),
    [anon_sym_private] = ACTIONS(3649),
    [anon_sym_protected] = ACTIONS(3649),
    [anon_sym_public] = ACTIONS(3649),
    [anon_sym_readonly] = ACTIONS(3649),
    [anon_sym_required] = ACTIONS(3649),
    [anon_sym_sealed] = ACTIONS(3649),
    [anon_sym_virtual] = ACTIONS(3649),
    [anon_sym_volatile] = ACTIONS(3649),
    [anon_sym_where] = ACTIONS(3649),
    [anon_sym_notnull] = ACTIONS(3649),
    [anon_sym_unmanaged] = ACTIONS(3649),
    [anon_sym_TILDE] = ACTIONS(3651),
    [anon_sym_implicit] = ACTIONS(3649),
    [anon_sym_explicit] = ACTIONS(3649),
    [anon_sym_scoped] = ACTIONS(3649),
    [anon_sym_var] = ACTIONS(3649),
    [sym_predefined_type] = ACTIONS(3649),
    [anon_sym_yield] = ACTIONS(3649),
    [anon_sym_when] = ACTIONS(3649),
    [anon_sym_from] = ACTIONS(3649),
    [anon_sym_into] = ACTIONS(3649),
    [anon_sym_join] = ACTIONS(3649),
    [anon_sym_on] = ACTIONS(3649),
    [anon_sym_equals] = ACTIONS(3649),
    [anon_sym_let] = ACTIONS(3649),
    [anon_sym_orderby] = ACTIONS(3649),
    [anon_sym_ascending] = ACTIONS(3649),
    [anon_sym_descending] = ACTIONS(3649),
    [anon_sym_group] = ACTIONS(3649),
    [anon_sym_by] = ACTIONS(3649),
    [anon_sym_select] = ACTIONS(3649),
    [aux_sym_preproc_if_token1] = ACTIONS(3651),
    [aux_sym_preproc_if_token3] = ACTIONS(3651),
    [aux_sym_preproc_else_token1] = ACTIONS(3651),
    [aux_sym_preproc_elif_token1] = ACTIONS(3651),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3375] = {
    [sym_preproc_region] = STATE(3375),
    [sym_preproc_endregion] = STATE(3375),
    [sym_preproc_line] = STATE(3375),
    [sym_preproc_pragma] = STATE(3375),
    [sym_preproc_nullable] = STATE(3375),
    [sym_preproc_error] = STATE(3375),
    [sym_preproc_define] = STATE(3375),
    [sym_preproc_undef] = STATE(3375),
    [sym__identifier_token] = ACTIONS(3653),
    [anon_sym_extern] = ACTIONS(3653),
    [anon_sym_alias] = ACTIONS(3653),
    [anon_sym_global] = ACTIONS(3653),
    [anon_sym_using] = ACTIONS(3653),
    [anon_sym_unsafe] = ACTIONS(3653),
    [anon_sym_static] = ACTIONS(3653),
    [anon_sym_LBRACK] = ACTIONS(3655),
    [anon_sym_LPAREN] = ACTIONS(3655),
    [anon_sym_event] = ACTIONS(3653),
    [anon_sym_namespace] = ACTIONS(3653),
    [anon_sym_class] = ACTIONS(3653),
    [anon_sym_ref] = ACTIONS(3653),
    [anon_sym_struct] = ACTIONS(3653),
    [anon_sym_enum] = ACTIONS(3653),
    [anon_sym_RBRACE] = ACTIONS(3655),
    [anon_sym_interface] = ACTIONS(3653),
    [anon_sym_delegate] = ACTIONS(3653),
    [anon_sym_record] = ACTIONS(3653),
    [anon_sym_abstract] = ACTIONS(3653),
    [anon_sym_async] = ACTIONS(3653),
    [anon_sym_const] = ACTIONS(3653),
    [anon_sym_file] = ACTIONS(3653),
    [anon_sym_fixed] = ACTIONS(3653),
    [anon_sym_internal] = ACTIONS(3653),
    [anon_sym_new] = ACTIONS(3653),
    [anon_sym_override] = ACTIONS(3653),
    [anon_sym_partial] = ACTIONS(3653),
    [anon_sym_private] = ACTIONS(3653),
    [anon_sym_protected] = ACTIONS(3653),
    [anon_sym_public] = ACTIONS(3653),
    [anon_sym_readonly] = ACTIONS(3653),
    [anon_sym_required] = ACTIONS(3653),
    [anon_sym_sealed] = ACTIONS(3653),
    [anon_sym_virtual] = ACTIONS(3653),
    [anon_sym_volatile] = ACTIONS(3653),
    [anon_sym_where] = ACTIONS(3653),
    [anon_sym_notnull] = ACTIONS(3653),
    [anon_sym_unmanaged] = ACTIONS(3653),
    [anon_sym_TILDE] = ACTIONS(3655),
    [anon_sym_implicit] = ACTIONS(3653),
    [anon_sym_explicit] = ACTIONS(3653),
    [anon_sym_scoped] = ACTIONS(3653),
    [anon_sym_var] = ACTIONS(3653),
    [sym_predefined_type] = ACTIONS(3653),
    [anon_sym_yield] = ACTIONS(3653),
    [anon_sym_when] = ACTIONS(3653),
    [anon_sym_from] = ACTIONS(3653),
    [anon_sym_into] = ACTIONS(3653),
    [anon_sym_join] = ACTIONS(3653),
    [anon_sym_on] = ACTIONS(3653),
    [anon_sym_equals] = ACTIONS(3653),
    [anon_sym_let] = ACTIONS(3653),
    [anon_sym_orderby] = ACTIONS(3653),
    [anon_sym_ascending] = ACTIONS(3653),
    [anon_sym_descending] = ACTIONS(3653),
    [anon_sym_group] = ACTIONS(3653),
    [anon_sym_by] = ACTIONS(3653),
    [anon_sym_select] = ACTIONS(3653),
    [aux_sym_preproc_if_token1] = ACTIONS(3655),
    [aux_sym_preproc_if_token3] = ACTIONS(3655),
    [aux_sym_preproc_else_token1] = ACTIONS(3655),
    [aux_sym_preproc_elif_token1] = ACTIONS(3655),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3376] = {
    [sym_preproc_region] = STATE(3376),
    [sym_preproc_endregion] = STATE(3376),
    [sym_preproc_line] = STATE(3376),
    [sym_preproc_pragma] = STATE(3376),
    [sym_preproc_nullable] = STATE(3376),
    [sym_preproc_error] = STATE(3376),
    [sym_preproc_define] = STATE(3376),
    [sym_preproc_undef] = STATE(3376),
    [sym__identifier_token] = ACTIONS(5025),
    [anon_sym_extern] = ACTIONS(5025),
    [anon_sym_alias] = ACTIONS(5025),
    [anon_sym_global] = ACTIONS(5025),
    [anon_sym_using] = ACTIONS(5025),
    [anon_sym_unsafe] = ACTIONS(5025),
    [anon_sym_static] = ACTIONS(5025),
    [anon_sym_LBRACK] = ACTIONS(5027),
    [anon_sym_LPAREN] = ACTIONS(5027),
    [anon_sym_event] = ACTIONS(5025),
    [anon_sym_namespace] = ACTIONS(5025),
    [anon_sym_class] = ACTIONS(5025),
    [anon_sym_ref] = ACTIONS(5025),
    [anon_sym_struct] = ACTIONS(5025),
    [anon_sym_enum] = ACTIONS(5025),
    [anon_sym_RBRACE] = ACTIONS(5027),
    [anon_sym_interface] = ACTIONS(5025),
    [anon_sym_delegate] = ACTIONS(5025),
    [anon_sym_record] = ACTIONS(5025),
    [anon_sym_abstract] = ACTIONS(5025),
    [anon_sym_async] = ACTIONS(5025),
    [anon_sym_const] = ACTIONS(5025),
    [anon_sym_file] = ACTIONS(5025),
    [anon_sym_fixed] = ACTIONS(5025),
    [anon_sym_internal] = ACTIONS(5025),
    [anon_sym_new] = ACTIONS(5025),
    [anon_sym_override] = ACTIONS(5025),
    [anon_sym_partial] = ACTIONS(5025),
    [anon_sym_private] = ACTIONS(5025),
    [anon_sym_protected] = ACTIONS(5025),
    [anon_sym_public] = ACTIONS(5025),
    [anon_sym_readonly] = ACTIONS(5025),
    [anon_sym_required] = ACTIONS(5025),
    [anon_sym_sealed] = ACTIONS(5025),
    [anon_sym_virtual] = ACTIONS(5025),
    [anon_sym_volatile] = ACTIONS(5025),
    [anon_sym_where] = ACTIONS(5025),
    [anon_sym_notnull] = ACTIONS(5025),
    [anon_sym_unmanaged] = ACTIONS(5025),
    [anon_sym_TILDE] = ACTIONS(5027),
    [anon_sym_implicit] = ACTIONS(5025),
    [anon_sym_explicit] = ACTIONS(5025),
    [anon_sym_scoped] = ACTIONS(5025),
    [anon_sym_var] = ACTIONS(5025),
    [sym_predefined_type] = ACTIONS(5025),
    [anon_sym_yield] = ACTIONS(5025),
    [anon_sym_when] = ACTIONS(5025),
    [anon_sym_from] = ACTIONS(5025),
    [anon_sym_into] = ACTIONS(5025),
    [anon_sym_join] = ACTIONS(5025),
    [anon_sym_on] = ACTIONS(5025),
    [anon_sym_equals] = ACTIONS(5025),
    [anon_sym_let] = ACTIONS(5025),
    [anon_sym_orderby] = ACTIONS(5025),
    [anon_sym_ascending] = ACTIONS(5025),
    [anon_sym_descending] = ACTIONS(5025),
    [anon_sym_group] = ACTIONS(5025),
    [anon_sym_by] = ACTIONS(5025),
    [anon_sym_select] = ACTIONS(5025),
    [aux_sym_preproc_if_token1] = ACTIONS(5027),
    [aux_sym_preproc_if_token3] = ACTIONS(5027),
    [aux_sym_preproc_else_token1] = ACTIONS(5027),
    [aux_sym_preproc_elif_token1] = ACTIONS(5027),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3377] = {
    [sym_preproc_region] = STATE(3377),
    [sym_preproc_endregion] = STATE(3377),
    [sym_preproc_line] = STATE(3377),
    [sym_preproc_pragma] = STATE(3377),
    [sym_preproc_nullable] = STATE(3377),
    [sym_preproc_error] = STATE(3377),
    [sym_preproc_define] = STATE(3377),
    [sym_preproc_undef] = STATE(3377),
    [sym__identifier_token] = ACTIONS(4432),
    [anon_sym_alias] = ACTIONS(4432),
    [anon_sym_global] = ACTIONS(4432),
    [anon_sym_LBRACK] = ACTIONS(4434),
    [anon_sym_COLON] = ACTIONS(4434),
    [anon_sym_COMMA] = ACTIONS(4434),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [anon_sym_LBRACE] = ACTIONS(4434),
    [anon_sym_file] = ACTIONS(4432),
    [anon_sym_LT] = ACTIONS(4432),
    [anon_sym_GT] = ACTIONS(4432),
    [anon_sym_where] = ACTIONS(4432),
    [anon_sym_QMARK] = ACTIONS(4432),
    [anon_sym_notnull] = ACTIONS(4432),
    [anon_sym_unmanaged] = ACTIONS(4432),
    [anon_sym_BANG] = ACTIONS(4432),
    [anon_sym_PLUS_PLUS] = ACTIONS(4434),
    [anon_sym_DASH_DASH] = ACTIONS(4434),
    [anon_sym_PLUS] = ACTIONS(4432),
    [anon_sym_DASH] = ACTIONS(4432),
    [anon_sym_STAR] = ACTIONS(4434),
    [anon_sym_SLASH] = ACTIONS(4432),
    [anon_sym_PERCENT] = ACTIONS(4434),
    [anon_sym_CARET] = ACTIONS(4434),
    [anon_sym_PIPE] = ACTIONS(4432),
    [anon_sym_AMP] = ACTIONS(4432),
    [anon_sym_LT_LT] = ACTIONS(4434),
    [anon_sym_GT_GT] = ACTIONS(4432),
    [anon_sym_GT_GT_GT] = ACTIONS(4434),
    [anon_sym_EQ_EQ] = ACTIONS(4434),
    [anon_sym_BANG_EQ] = ACTIONS(4434),
    [anon_sym_GT_EQ] = ACTIONS(4434),
    [anon_sym_LT_EQ] = ACTIONS(4434),
    [anon_sym_DOT] = ACTIONS(4432),
    [anon_sym_scoped] = ACTIONS(4432),
    [anon_sym_var] = ACTIONS(4432),
    [anon_sym_yield] = ACTIONS(4432),
    [anon_sym_switch] = ACTIONS(4432),
    [anon_sym_when] = ACTIONS(4432),
    [sym_discard] = ACTIONS(4432),
    [anon_sym_DOT_DOT] = ACTIONS(4434),
    [anon_sym_and] = ACTIONS(4432),
    [anon_sym_or] = ACTIONS(4432),
    [anon_sym_AMP_AMP] = ACTIONS(4434),
    [anon_sym_PIPE_PIPE] = ACTIONS(4434),
    [anon_sym_QMARK_QMARK] = ACTIONS(4434),
    [anon_sym_from] = ACTIONS(4432),
    [anon_sym_into] = ACTIONS(4432),
    [anon_sym_join] = ACTIONS(4432),
    [anon_sym_on] = ACTIONS(4432),
    [anon_sym_equals] = ACTIONS(4432),
    [anon_sym_let] = ACTIONS(4432),
    [anon_sym_orderby] = ACTIONS(4432),
    [anon_sym_ascending] = ACTIONS(4432),
    [anon_sym_descending] = ACTIONS(4432),
    [anon_sym_group] = ACTIONS(4432),
    [anon_sym_by] = ACTIONS(4432),
    [anon_sym_select] = ACTIONS(4432),
    [anon_sym_as] = ACTIONS(4432),
    [anon_sym_is] = ACTIONS(4432),
    [anon_sym_DASH_GT] = ACTIONS(4434),
    [anon_sym_with] = ACTIONS(4432),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4434),
  },
  [3378] = {
    [sym_preproc_region] = STATE(3378),
    [sym_preproc_endregion] = STATE(3378),
    [sym_preproc_line] = STATE(3378),
    [sym_preproc_pragma] = STATE(3378),
    [sym_preproc_nullable] = STATE(3378),
    [sym_preproc_error] = STATE(3378),
    [sym_preproc_define] = STATE(3378),
    [sym_preproc_undef] = STATE(3378),
    [sym__identifier_token] = ACTIONS(4436),
    [anon_sym_alias] = ACTIONS(4436),
    [anon_sym_global] = ACTIONS(4436),
    [anon_sym_LBRACK] = ACTIONS(4438),
    [anon_sym_COLON] = ACTIONS(4438),
    [anon_sym_COMMA] = ACTIONS(4438),
    [anon_sym_LPAREN] = ACTIONS(4438),
    [anon_sym_LBRACE] = ACTIONS(4438),
    [anon_sym_file] = ACTIONS(4436),
    [anon_sym_LT] = ACTIONS(4436),
    [anon_sym_GT] = ACTIONS(4436),
    [anon_sym_where] = ACTIONS(4436),
    [anon_sym_QMARK] = ACTIONS(4436),
    [anon_sym_notnull] = ACTIONS(4436),
    [anon_sym_unmanaged] = ACTIONS(4436),
    [anon_sym_BANG] = ACTIONS(4436),
    [anon_sym_PLUS_PLUS] = ACTIONS(4438),
    [anon_sym_DASH_DASH] = ACTIONS(4438),
    [anon_sym_PLUS] = ACTIONS(4436),
    [anon_sym_DASH] = ACTIONS(4436),
    [anon_sym_STAR] = ACTIONS(4438),
    [anon_sym_SLASH] = ACTIONS(4436),
    [anon_sym_PERCENT] = ACTIONS(4438),
    [anon_sym_CARET] = ACTIONS(4438),
    [anon_sym_PIPE] = ACTIONS(4436),
    [anon_sym_AMP] = ACTIONS(4436),
    [anon_sym_LT_LT] = ACTIONS(4438),
    [anon_sym_GT_GT] = ACTIONS(4436),
    [anon_sym_GT_GT_GT] = ACTIONS(4438),
    [anon_sym_EQ_EQ] = ACTIONS(4438),
    [anon_sym_BANG_EQ] = ACTIONS(4438),
    [anon_sym_GT_EQ] = ACTIONS(4438),
    [anon_sym_LT_EQ] = ACTIONS(4438),
    [anon_sym_DOT] = ACTIONS(4436),
    [anon_sym_scoped] = ACTIONS(4436),
    [anon_sym_var] = ACTIONS(4436),
    [anon_sym_yield] = ACTIONS(4436),
    [anon_sym_switch] = ACTIONS(4436),
    [anon_sym_when] = ACTIONS(4436),
    [sym_discard] = ACTIONS(4436),
    [anon_sym_DOT_DOT] = ACTIONS(4438),
    [anon_sym_and] = ACTIONS(4436),
    [anon_sym_or] = ACTIONS(4436),
    [anon_sym_AMP_AMP] = ACTIONS(4438),
    [anon_sym_PIPE_PIPE] = ACTIONS(4438),
    [anon_sym_QMARK_QMARK] = ACTIONS(4438),
    [anon_sym_from] = ACTIONS(4436),
    [anon_sym_into] = ACTIONS(4436),
    [anon_sym_join] = ACTIONS(4436),
    [anon_sym_on] = ACTIONS(4436),
    [anon_sym_equals] = ACTIONS(4436),
    [anon_sym_let] = ACTIONS(4436),
    [anon_sym_orderby] = ACTIONS(4436),
    [anon_sym_ascending] = ACTIONS(4436),
    [anon_sym_descending] = ACTIONS(4436),
    [anon_sym_group] = ACTIONS(4436),
    [anon_sym_by] = ACTIONS(4436),
    [anon_sym_select] = ACTIONS(4436),
    [anon_sym_as] = ACTIONS(4436),
    [anon_sym_is] = ACTIONS(4436),
    [anon_sym_DASH_GT] = ACTIONS(4438),
    [anon_sym_with] = ACTIONS(4436),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4438),
  },
  [3379] = {
    [sym_preproc_region] = STATE(3379),
    [sym_preproc_endregion] = STATE(3379),
    [sym_preproc_line] = STATE(3379),
    [sym_preproc_pragma] = STATE(3379),
    [sym_preproc_nullable] = STATE(3379),
    [sym_preproc_error] = STATE(3379),
    [sym_preproc_define] = STATE(3379),
    [sym_preproc_undef] = STATE(3379),
    [sym__identifier_token] = ACTIONS(4426),
    [anon_sym_alias] = ACTIONS(4426),
    [anon_sym_global] = ACTIONS(4426),
    [anon_sym_LBRACK] = ACTIONS(4428),
    [anon_sym_COLON] = ACTIONS(4428),
    [anon_sym_COMMA] = ACTIONS(4428),
    [anon_sym_LPAREN] = ACTIONS(4428),
    [anon_sym_LBRACE] = ACTIONS(4428),
    [anon_sym_file] = ACTIONS(4426),
    [anon_sym_LT] = ACTIONS(4426),
    [anon_sym_GT] = ACTIONS(4426),
    [anon_sym_where] = ACTIONS(4426),
    [anon_sym_QMARK] = ACTIONS(4426),
    [anon_sym_notnull] = ACTIONS(4426),
    [anon_sym_unmanaged] = ACTIONS(4426),
    [anon_sym_BANG] = ACTIONS(4426),
    [anon_sym_PLUS_PLUS] = ACTIONS(4428),
    [anon_sym_DASH_DASH] = ACTIONS(4428),
    [anon_sym_PLUS] = ACTIONS(4426),
    [anon_sym_DASH] = ACTIONS(4426),
    [anon_sym_STAR] = ACTIONS(4428),
    [anon_sym_SLASH] = ACTIONS(4426),
    [anon_sym_PERCENT] = ACTIONS(4428),
    [anon_sym_CARET] = ACTIONS(4428),
    [anon_sym_PIPE] = ACTIONS(4426),
    [anon_sym_AMP] = ACTIONS(4426),
    [anon_sym_LT_LT] = ACTIONS(4428),
    [anon_sym_GT_GT] = ACTIONS(4426),
    [anon_sym_GT_GT_GT] = ACTIONS(4428),
    [anon_sym_EQ_EQ] = ACTIONS(4428),
    [anon_sym_BANG_EQ] = ACTIONS(4428),
    [anon_sym_GT_EQ] = ACTIONS(4428),
    [anon_sym_LT_EQ] = ACTIONS(4428),
    [anon_sym_DOT] = ACTIONS(4426),
    [anon_sym_scoped] = ACTIONS(4426),
    [anon_sym_var] = ACTIONS(4426),
    [anon_sym_yield] = ACTIONS(4426),
    [anon_sym_switch] = ACTIONS(4426),
    [anon_sym_when] = ACTIONS(4426),
    [sym_discard] = ACTIONS(4426),
    [anon_sym_DOT_DOT] = ACTIONS(4428),
    [anon_sym_and] = ACTIONS(4426),
    [anon_sym_or] = ACTIONS(4426),
    [anon_sym_AMP_AMP] = ACTIONS(4428),
    [anon_sym_PIPE_PIPE] = ACTIONS(4428),
    [anon_sym_QMARK_QMARK] = ACTIONS(4428),
    [anon_sym_from] = ACTIONS(4426),
    [anon_sym_into] = ACTIONS(4426),
    [anon_sym_join] = ACTIONS(4426),
    [anon_sym_on] = ACTIONS(4426),
    [anon_sym_equals] = ACTIONS(4426),
    [anon_sym_let] = ACTIONS(4426),
    [anon_sym_orderby] = ACTIONS(4426),
    [anon_sym_ascending] = ACTIONS(4426),
    [anon_sym_descending] = ACTIONS(4426),
    [anon_sym_group] = ACTIONS(4426),
    [anon_sym_by] = ACTIONS(4426),
    [anon_sym_select] = ACTIONS(4426),
    [anon_sym_as] = ACTIONS(4426),
    [anon_sym_is] = ACTIONS(4426),
    [anon_sym_DASH_GT] = ACTIONS(4428),
    [anon_sym_with] = ACTIONS(4426),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4428),
  },
  [3380] = {
    [sym_preproc_region] = STATE(3380),
    [sym_preproc_endregion] = STATE(3380),
    [sym_preproc_line] = STATE(3380),
    [sym_preproc_pragma] = STATE(3380),
    [sym_preproc_nullable] = STATE(3380),
    [sym_preproc_error] = STATE(3380),
    [sym_preproc_define] = STATE(3380),
    [sym_preproc_undef] = STATE(3380),
    [sym__identifier_token] = ACTIONS(4426),
    [anon_sym_alias] = ACTIONS(4426),
    [anon_sym_global] = ACTIONS(4426),
    [anon_sym_LBRACK] = ACTIONS(4428),
    [anon_sym_COLON] = ACTIONS(4428),
    [anon_sym_COMMA] = ACTIONS(4428),
    [anon_sym_LPAREN] = ACTIONS(4428),
    [anon_sym_LBRACE] = ACTIONS(4428),
    [anon_sym_file] = ACTIONS(4426),
    [anon_sym_LT] = ACTIONS(4426),
    [anon_sym_GT] = ACTIONS(4426),
    [anon_sym_where] = ACTIONS(4426),
    [anon_sym_QMARK] = ACTIONS(4426),
    [anon_sym_notnull] = ACTIONS(4426),
    [anon_sym_unmanaged] = ACTIONS(4426),
    [anon_sym_BANG] = ACTIONS(4426),
    [anon_sym_PLUS_PLUS] = ACTIONS(4428),
    [anon_sym_DASH_DASH] = ACTIONS(4428),
    [anon_sym_PLUS] = ACTIONS(4426),
    [anon_sym_DASH] = ACTIONS(4426),
    [anon_sym_STAR] = ACTIONS(4428),
    [anon_sym_SLASH] = ACTIONS(4426),
    [anon_sym_PERCENT] = ACTIONS(4428),
    [anon_sym_CARET] = ACTIONS(4428),
    [anon_sym_PIPE] = ACTIONS(4426),
    [anon_sym_AMP] = ACTIONS(4426),
    [anon_sym_LT_LT] = ACTIONS(4428),
    [anon_sym_GT_GT] = ACTIONS(4426),
    [anon_sym_GT_GT_GT] = ACTIONS(4428),
    [anon_sym_EQ_EQ] = ACTIONS(4428),
    [anon_sym_BANG_EQ] = ACTIONS(4428),
    [anon_sym_GT_EQ] = ACTIONS(4428),
    [anon_sym_LT_EQ] = ACTIONS(4428),
    [anon_sym_DOT] = ACTIONS(5029),
    [anon_sym_scoped] = ACTIONS(4426),
    [anon_sym_var] = ACTIONS(4426),
    [anon_sym_yield] = ACTIONS(4426),
    [anon_sym_switch] = ACTIONS(4426),
    [anon_sym_when] = ACTIONS(4426),
    [sym_discard] = ACTIONS(4426),
    [anon_sym_DOT_DOT] = ACTIONS(4428),
    [anon_sym_and] = ACTIONS(4426),
    [anon_sym_or] = ACTIONS(4426),
    [anon_sym_AMP_AMP] = ACTIONS(4428),
    [anon_sym_PIPE_PIPE] = ACTIONS(4428),
    [anon_sym_QMARK_QMARK] = ACTIONS(4428),
    [anon_sym_from] = ACTIONS(4426),
    [anon_sym_into] = ACTIONS(4426),
    [anon_sym_join] = ACTIONS(4426),
    [anon_sym_on] = ACTIONS(4426),
    [anon_sym_equals] = ACTIONS(4426),
    [anon_sym_let] = ACTIONS(4426),
    [anon_sym_orderby] = ACTIONS(4426),
    [anon_sym_ascending] = ACTIONS(4426),
    [anon_sym_descending] = ACTIONS(4426),
    [anon_sym_group] = ACTIONS(4426),
    [anon_sym_by] = ACTIONS(4426),
    [anon_sym_select] = ACTIONS(4426),
    [anon_sym_as] = ACTIONS(4426),
    [anon_sym_is] = ACTIONS(4426),
    [anon_sym_DASH_GT] = ACTIONS(4428),
    [anon_sym_with] = ACTIONS(4426),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4428),
  },
  [3381] = {
    [sym_preproc_region] = STATE(3381),
    [sym_preproc_endregion] = STATE(3381),
    [sym_preproc_line] = STATE(3381),
    [sym_preproc_pragma] = STATE(3381),
    [sym_preproc_nullable] = STATE(3381),
    [sym_preproc_error] = STATE(3381),
    [sym_preproc_define] = STATE(3381),
    [sym_preproc_undef] = STATE(3381),
    [sym__identifier_token] = ACTIONS(5031),
    [anon_sym_extern] = ACTIONS(5031),
    [anon_sym_alias] = ACTIONS(5031),
    [anon_sym_global] = ACTIONS(5031),
    [anon_sym_using] = ACTIONS(5031),
    [anon_sym_unsafe] = ACTIONS(5031),
    [anon_sym_static] = ACTIONS(5031),
    [anon_sym_LBRACK] = ACTIONS(5033),
    [anon_sym_LPAREN] = ACTIONS(5033),
    [anon_sym_event] = ACTIONS(5031),
    [anon_sym_namespace] = ACTIONS(5031),
    [anon_sym_class] = ACTIONS(5031),
    [anon_sym_ref] = ACTIONS(5031),
    [anon_sym_struct] = ACTIONS(5031),
    [anon_sym_enum] = ACTIONS(5031),
    [anon_sym_RBRACE] = ACTIONS(5033),
    [anon_sym_interface] = ACTIONS(5031),
    [anon_sym_delegate] = ACTIONS(5031),
    [anon_sym_record] = ACTIONS(5031),
    [anon_sym_abstract] = ACTIONS(5031),
    [anon_sym_async] = ACTIONS(5031),
    [anon_sym_const] = ACTIONS(5031),
    [anon_sym_file] = ACTIONS(5031),
    [anon_sym_fixed] = ACTIONS(5031),
    [anon_sym_internal] = ACTIONS(5031),
    [anon_sym_new] = ACTIONS(5031),
    [anon_sym_override] = ACTIONS(5031),
    [anon_sym_partial] = ACTIONS(5031),
    [anon_sym_private] = ACTIONS(5031),
    [anon_sym_protected] = ACTIONS(5031),
    [anon_sym_public] = ACTIONS(5031),
    [anon_sym_readonly] = ACTIONS(5031),
    [anon_sym_required] = ACTIONS(5031),
    [anon_sym_sealed] = ACTIONS(5031),
    [anon_sym_virtual] = ACTIONS(5031),
    [anon_sym_volatile] = ACTIONS(5031),
    [anon_sym_where] = ACTIONS(5031),
    [anon_sym_notnull] = ACTIONS(5031),
    [anon_sym_unmanaged] = ACTIONS(5031),
    [anon_sym_TILDE] = ACTIONS(5033),
    [anon_sym_implicit] = ACTIONS(5031),
    [anon_sym_explicit] = ACTIONS(5031),
    [anon_sym_scoped] = ACTIONS(5031),
    [anon_sym_var] = ACTIONS(5031),
    [sym_predefined_type] = ACTIONS(5031),
    [anon_sym_yield] = ACTIONS(5031),
    [anon_sym_when] = ACTIONS(5031),
    [anon_sym_from] = ACTIONS(5031),
    [anon_sym_into] = ACTIONS(5031),
    [anon_sym_join] = ACTIONS(5031),
    [anon_sym_on] = ACTIONS(5031),
    [anon_sym_equals] = ACTIONS(5031),
    [anon_sym_let] = ACTIONS(5031),
    [anon_sym_orderby] = ACTIONS(5031),
    [anon_sym_ascending] = ACTIONS(5031),
    [anon_sym_descending] = ACTIONS(5031),
    [anon_sym_group] = ACTIONS(5031),
    [anon_sym_by] = ACTIONS(5031),
    [anon_sym_select] = ACTIONS(5031),
    [aux_sym_preproc_if_token1] = ACTIONS(5033),
    [aux_sym_preproc_if_token3] = ACTIONS(5033),
    [aux_sym_preproc_else_token1] = ACTIONS(5033),
    [aux_sym_preproc_elif_token1] = ACTIONS(5033),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3382] = {
    [sym_preproc_region] = STATE(3382),
    [sym_preproc_endregion] = STATE(3382),
    [sym_preproc_line] = STATE(3382),
    [sym_preproc_pragma] = STATE(3382),
    [sym_preproc_nullable] = STATE(3382),
    [sym_preproc_error] = STATE(3382),
    [sym_preproc_define] = STATE(3382),
    [sym_preproc_undef] = STATE(3382),
    [sym__identifier_token] = ACTIONS(5035),
    [anon_sym_extern] = ACTIONS(5035),
    [anon_sym_alias] = ACTIONS(5035),
    [anon_sym_global] = ACTIONS(5035),
    [anon_sym_using] = ACTIONS(5035),
    [anon_sym_unsafe] = ACTIONS(5035),
    [anon_sym_static] = ACTIONS(5035),
    [anon_sym_LBRACK] = ACTIONS(5037),
    [anon_sym_LPAREN] = ACTIONS(5037),
    [anon_sym_event] = ACTIONS(5035),
    [anon_sym_namespace] = ACTIONS(5035),
    [anon_sym_class] = ACTIONS(5035),
    [anon_sym_ref] = ACTIONS(5035),
    [anon_sym_struct] = ACTIONS(5035),
    [anon_sym_enum] = ACTIONS(5035),
    [anon_sym_RBRACE] = ACTIONS(5037),
    [anon_sym_interface] = ACTIONS(5035),
    [anon_sym_delegate] = ACTIONS(5035),
    [anon_sym_record] = ACTIONS(5035),
    [anon_sym_abstract] = ACTIONS(5035),
    [anon_sym_async] = ACTIONS(5035),
    [anon_sym_const] = ACTIONS(5035),
    [anon_sym_file] = ACTIONS(5035),
    [anon_sym_fixed] = ACTIONS(5035),
    [anon_sym_internal] = ACTIONS(5035),
    [anon_sym_new] = ACTIONS(5035),
    [anon_sym_override] = ACTIONS(5035),
    [anon_sym_partial] = ACTIONS(5035),
    [anon_sym_private] = ACTIONS(5035),
    [anon_sym_protected] = ACTIONS(5035),
    [anon_sym_public] = ACTIONS(5035),
    [anon_sym_readonly] = ACTIONS(5035),
    [anon_sym_required] = ACTIONS(5035),
    [anon_sym_sealed] = ACTIONS(5035),
    [anon_sym_virtual] = ACTIONS(5035),
    [anon_sym_volatile] = ACTIONS(5035),
    [anon_sym_where] = ACTIONS(5035),
    [anon_sym_notnull] = ACTIONS(5035),
    [anon_sym_unmanaged] = ACTIONS(5035),
    [anon_sym_TILDE] = ACTIONS(5037),
    [anon_sym_implicit] = ACTIONS(5035),
    [anon_sym_explicit] = ACTIONS(5035),
    [anon_sym_scoped] = ACTIONS(5035),
    [anon_sym_var] = ACTIONS(5035),
    [sym_predefined_type] = ACTIONS(5035),
    [anon_sym_yield] = ACTIONS(5035),
    [anon_sym_when] = ACTIONS(5035),
    [anon_sym_from] = ACTIONS(5035),
    [anon_sym_into] = ACTIONS(5035),
    [anon_sym_join] = ACTIONS(5035),
    [anon_sym_on] = ACTIONS(5035),
    [anon_sym_equals] = ACTIONS(5035),
    [anon_sym_let] = ACTIONS(5035),
    [anon_sym_orderby] = ACTIONS(5035),
    [anon_sym_ascending] = ACTIONS(5035),
    [anon_sym_descending] = ACTIONS(5035),
    [anon_sym_group] = ACTIONS(5035),
    [anon_sym_by] = ACTIONS(5035),
    [anon_sym_select] = ACTIONS(5035),
    [aux_sym_preproc_if_token1] = ACTIONS(5037),
    [aux_sym_preproc_if_token3] = ACTIONS(5037),
    [aux_sym_preproc_else_token1] = ACTIONS(5037),
    [aux_sym_preproc_elif_token1] = ACTIONS(5037),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3383] = {
    [sym_preproc_region] = STATE(3383),
    [sym_preproc_endregion] = STATE(3383),
    [sym_preproc_line] = STATE(3383),
    [sym_preproc_pragma] = STATE(3383),
    [sym_preproc_nullable] = STATE(3383),
    [sym_preproc_error] = STATE(3383),
    [sym_preproc_define] = STATE(3383),
    [sym_preproc_undef] = STATE(3383),
    [sym__identifier_token] = ACTIONS(5039),
    [anon_sym_extern] = ACTIONS(5039),
    [anon_sym_alias] = ACTIONS(5039),
    [anon_sym_global] = ACTIONS(5039),
    [anon_sym_using] = ACTIONS(5039),
    [anon_sym_unsafe] = ACTIONS(5039),
    [anon_sym_static] = ACTIONS(5039),
    [anon_sym_LBRACK] = ACTIONS(5041),
    [anon_sym_LPAREN] = ACTIONS(5041),
    [anon_sym_event] = ACTIONS(5039),
    [anon_sym_namespace] = ACTIONS(5039),
    [anon_sym_class] = ACTIONS(5039),
    [anon_sym_ref] = ACTIONS(5039),
    [anon_sym_struct] = ACTIONS(5039),
    [anon_sym_enum] = ACTIONS(5039),
    [anon_sym_RBRACE] = ACTIONS(5041),
    [anon_sym_interface] = ACTIONS(5039),
    [anon_sym_delegate] = ACTIONS(5039),
    [anon_sym_record] = ACTIONS(5039),
    [anon_sym_abstract] = ACTIONS(5039),
    [anon_sym_async] = ACTIONS(5039),
    [anon_sym_const] = ACTIONS(5039),
    [anon_sym_file] = ACTIONS(5039),
    [anon_sym_fixed] = ACTIONS(5039),
    [anon_sym_internal] = ACTIONS(5039),
    [anon_sym_new] = ACTIONS(5039),
    [anon_sym_override] = ACTIONS(5039),
    [anon_sym_partial] = ACTIONS(5039),
    [anon_sym_private] = ACTIONS(5039),
    [anon_sym_protected] = ACTIONS(5039),
    [anon_sym_public] = ACTIONS(5039),
    [anon_sym_readonly] = ACTIONS(5039),
    [anon_sym_required] = ACTIONS(5039),
    [anon_sym_sealed] = ACTIONS(5039),
    [anon_sym_virtual] = ACTIONS(5039),
    [anon_sym_volatile] = ACTIONS(5039),
    [anon_sym_where] = ACTIONS(5039),
    [anon_sym_notnull] = ACTIONS(5039),
    [anon_sym_unmanaged] = ACTIONS(5039),
    [anon_sym_TILDE] = ACTIONS(5041),
    [anon_sym_implicit] = ACTIONS(5039),
    [anon_sym_explicit] = ACTIONS(5039),
    [anon_sym_scoped] = ACTIONS(5039),
    [anon_sym_var] = ACTIONS(5039),
    [sym_predefined_type] = ACTIONS(5039),
    [anon_sym_yield] = ACTIONS(5039),
    [anon_sym_when] = ACTIONS(5039),
    [anon_sym_from] = ACTIONS(5039),
    [anon_sym_into] = ACTIONS(5039),
    [anon_sym_join] = ACTIONS(5039),
    [anon_sym_on] = ACTIONS(5039),
    [anon_sym_equals] = ACTIONS(5039),
    [anon_sym_let] = ACTIONS(5039),
    [anon_sym_orderby] = ACTIONS(5039),
    [anon_sym_ascending] = ACTIONS(5039),
    [anon_sym_descending] = ACTIONS(5039),
    [anon_sym_group] = ACTIONS(5039),
    [anon_sym_by] = ACTIONS(5039),
    [anon_sym_select] = ACTIONS(5039),
    [aux_sym_preproc_if_token1] = ACTIONS(5041),
    [aux_sym_preproc_if_token3] = ACTIONS(5041),
    [aux_sym_preproc_else_token1] = ACTIONS(5041),
    [aux_sym_preproc_elif_token1] = ACTIONS(5041),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3384] = {
    [sym_preproc_region] = STATE(3384),
    [sym_preproc_endregion] = STATE(3384),
    [sym_preproc_line] = STATE(3384),
    [sym_preproc_pragma] = STATE(3384),
    [sym_preproc_nullable] = STATE(3384),
    [sym_preproc_error] = STATE(3384),
    [sym_preproc_define] = STATE(3384),
    [sym_preproc_undef] = STATE(3384),
    [sym__identifier_token] = ACTIONS(5043),
    [anon_sym_extern] = ACTIONS(5043),
    [anon_sym_alias] = ACTIONS(5043),
    [anon_sym_global] = ACTIONS(5043),
    [anon_sym_using] = ACTIONS(5043),
    [anon_sym_unsafe] = ACTIONS(5043),
    [anon_sym_static] = ACTIONS(5043),
    [anon_sym_LBRACK] = ACTIONS(5045),
    [anon_sym_LPAREN] = ACTIONS(5045),
    [anon_sym_event] = ACTIONS(5043),
    [anon_sym_namespace] = ACTIONS(5043),
    [anon_sym_class] = ACTIONS(5043),
    [anon_sym_ref] = ACTIONS(5043),
    [anon_sym_struct] = ACTIONS(5043),
    [anon_sym_enum] = ACTIONS(5043),
    [anon_sym_RBRACE] = ACTIONS(5045),
    [anon_sym_interface] = ACTIONS(5043),
    [anon_sym_delegate] = ACTIONS(5043),
    [anon_sym_record] = ACTIONS(5043),
    [anon_sym_abstract] = ACTIONS(5043),
    [anon_sym_async] = ACTIONS(5043),
    [anon_sym_const] = ACTIONS(5043),
    [anon_sym_file] = ACTIONS(5043),
    [anon_sym_fixed] = ACTIONS(5043),
    [anon_sym_internal] = ACTIONS(5043),
    [anon_sym_new] = ACTIONS(5043),
    [anon_sym_override] = ACTIONS(5043),
    [anon_sym_partial] = ACTIONS(5043),
    [anon_sym_private] = ACTIONS(5043),
    [anon_sym_protected] = ACTIONS(5043),
    [anon_sym_public] = ACTIONS(5043),
    [anon_sym_readonly] = ACTIONS(5043),
    [anon_sym_required] = ACTIONS(5043),
    [anon_sym_sealed] = ACTIONS(5043),
    [anon_sym_virtual] = ACTIONS(5043),
    [anon_sym_volatile] = ACTIONS(5043),
    [anon_sym_where] = ACTIONS(5043),
    [anon_sym_notnull] = ACTIONS(5043),
    [anon_sym_unmanaged] = ACTIONS(5043),
    [anon_sym_TILDE] = ACTIONS(5045),
    [anon_sym_implicit] = ACTIONS(5043),
    [anon_sym_explicit] = ACTIONS(5043),
    [anon_sym_scoped] = ACTIONS(5043),
    [anon_sym_var] = ACTIONS(5043),
    [sym_predefined_type] = ACTIONS(5043),
    [anon_sym_yield] = ACTIONS(5043),
    [anon_sym_when] = ACTIONS(5043),
    [anon_sym_from] = ACTIONS(5043),
    [anon_sym_into] = ACTIONS(5043),
    [anon_sym_join] = ACTIONS(5043),
    [anon_sym_on] = ACTIONS(5043),
    [anon_sym_equals] = ACTIONS(5043),
    [anon_sym_let] = ACTIONS(5043),
    [anon_sym_orderby] = ACTIONS(5043),
    [anon_sym_ascending] = ACTIONS(5043),
    [anon_sym_descending] = ACTIONS(5043),
    [anon_sym_group] = ACTIONS(5043),
    [anon_sym_by] = ACTIONS(5043),
    [anon_sym_select] = ACTIONS(5043),
    [aux_sym_preproc_if_token1] = ACTIONS(5045),
    [aux_sym_preproc_if_token3] = ACTIONS(5045),
    [aux_sym_preproc_else_token1] = ACTIONS(5045),
    [aux_sym_preproc_elif_token1] = ACTIONS(5045),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3385] = {
    [sym_preproc_region] = STATE(3385),
    [sym_preproc_endregion] = STATE(3385),
    [sym_preproc_line] = STATE(3385),
    [sym_preproc_pragma] = STATE(3385),
    [sym_preproc_nullable] = STATE(3385),
    [sym_preproc_error] = STATE(3385),
    [sym_preproc_define] = STATE(3385),
    [sym_preproc_undef] = STATE(3385),
    [sym__identifier_token] = ACTIONS(5047),
    [anon_sym_extern] = ACTIONS(5047),
    [anon_sym_alias] = ACTIONS(5047),
    [anon_sym_global] = ACTIONS(5047),
    [anon_sym_using] = ACTIONS(5047),
    [anon_sym_unsafe] = ACTIONS(5047),
    [anon_sym_static] = ACTIONS(5047),
    [anon_sym_LBRACK] = ACTIONS(5049),
    [anon_sym_LPAREN] = ACTIONS(5049),
    [anon_sym_event] = ACTIONS(5047),
    [anon_sym_namespace] = ACTIONS(5047),
    [anon_sym_class] = ACTIONS(5047),
    [anon_sym_ref] = ACTIONS(5047),
    [anon_sym_struct] = ACTIONS(5047),
    [anon_sym_enum] = ACTIONS(5047),
    [anon_sym_RBRACE] = ACTIONS(5049),
    [anon_sym_interface] = ACTIONS(5047),
    [anon_sym_delegate] = ACTIONS(5047),
    [anon_sym_record] = ACTIONS(5047),
    [anon_sym_abstract] = ACTIONS(5047),
    [anon_sym_async] = ACTIONS(5047),
    [anon_sym_const] = ACTIONS(5047),
    [anon_sym_file] = ACTIONS(5047),
    [anon_sym_fixed] = ACTIONS(5047),
    [anon_sym_internal] = ACTIONS(5047),
    [anon_sym_new] = ACTIONS(5047),
    [anon_sym_override] = ACTIONS(5047),
    [anon_sym_partial] = ACTIONS(5047),
    [anon_sym_private] = ACTIONS(5047),
    [anon_sym_protected] = ACTIONS(5047),
    [anon_sym_public] = ACTIONS(5047),
    [anon_sym_readonly] = ACTIONS(5047),
    [anon_sym_required] = ACTIONS(5047),
    [anon_sym_sealed] = ACTIONS(5047),
    [anon_sym_virtual] = ACTIONS(5047),
    [anon_sym_volatile] = ACTIONS(5047),
    [anon_sym_where] = ACTIONS(5047),
    [anon_sym_notnull] = ACTIONS(5047),
    [anon_sym_unmanaged] = ACTIONS(5047),
    [anon_sym_TILDE] = ACTIONS(5049),
    [anon_sym_implicit] = ACTIONS(5047),
    [anon_sym_explicit] = ACTIONS(5047),
    [anon_sym_scoped] = ACTIONS(5047),
    [anon_sym_var] = ACTIONS(5047),
    [sym_predefined_type] = ACTIONS(5047),
    [anon_sym_yield] = ACTIONS(5047),
    [anon_sym_when] = ACTIONS(5047),
    [anon_sym_from] = ACTIONS(5047),
    [anon_sym_into] = ACTIONS(5047),
    [anon_sym_join] = ACTIONS(5047),
    [anon_sym_on] = ACTIONS(5047),
    [anon_sym_equals] = ACTIONS(5047),
    [anon_sym_let] = ACTIONS(5047),
    [anon_sym_orderby] = ACTIONS(5047),
    [anon_sym_ascending] = ACTIONS(5047),
    [anon_sym_descending] = ACTIONS(5047),
    [anon_sym_group] = ACTIONS(5047),
    [anon_sym_by] = ACTIONS(5047),
    [anon_sym_select] = ACTIONS(5047),
    [aux_sym_preproc_if_token1] = ACTIONS(5049),
    [aux_sym_preproc_if_token3] = ACTIONS(5049),
    [aux_sym_preproc_else_token1] = ACTIONS(5049),
    [aux_sym_preproc_elif_token1] = ACTIONS(5049),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3386] = {
    [sym__variable_designation] = STATE(4246),
    [sym_parenthesized_variable_designation] = STATE(4274),
    [sym_identifier] = STATE(4269),
    [sym__reserved_identifier] = STATE(3908),
    [sym_preproc_region] = STATE(3386),
    [sym_preproc_endregion] = STATE(3386),
    [sym_preproc_line] = STATE(3386),
    [sym_preproc_pragma] = STATE(3386),
    [sym_preproc_nullable] = STATE(3386),
    [sym_preproc_error] = STATE(3386),
    [sym_preproc_define] = STATE(3386),
    [sym_preproc_undef] = STATE(3386),
    [sym__identifier_token] = ACTIONS(4271),
    [anon_sym_alias] = ACTIONS(4273),
    [anon_sym_global] = ACTIONS(4273),
    [anon_sym_LBRACK] = ACTIONS(4329),
    [anon_sym_LPAREN] = ACTIONS(4329),
    [anon_sym_file] = ACTIONS(4273),
    [anon_sym_LT] = ACTIONS(4331),
    [anon_sym_GT] = ACTIONS(4331),
    [anon_sym_where] = ACTIONS(4273),
    [anon_sym_QMARK] = ACTIONS(4331),
    [anon_sym_notnull] = ACTIONS(4273),
    [anon_sym_unmanaged] = ACTIONS(4273),
    [anon_sym_BANG] = ACTIONS(4331),
    [anon_sym_PLUS_PLUS] = ACTIONS(4329),
    [anon_sym_DASH_DASH] = ACTIONS(4329),
    [anon_sym_PLUS] = ACTIONS(4331),
    [anon_sym_DASH] = ACTIONS(4331),
    [anon_sym_STAR] = ACTIONS(4329),
    [anon_sym_SLASH] = ACTIONS(4331),
    [anon_sym_PERCENT] = ACTIONS(4329),
    [anon_sym_CARET] = ACTIONS(4329),
    [anon_sym_PIPE] = ACTIONS(4331),
    [anon_sym_AMP] = ACTIONS(4331),
    [anon_sym_LT_LT] = ACTIONS(4329),
    [anon_sym_GT_GT] = ACTIONS(4331),
    [anon_sym_GT_GT_GT] = ACTIONS(4329),
    [anon_sym_EQ_EQ] = ACTIONS(4329),
    [anon_sym_BANG_EQ] = ACTIONS(4329),
    [anon_sym_GT_EQ] = ACTIONS(4329),
    [anon_sym_LT_EQ] = ACTIONS(4329),
    [anon_sym_DOT] = ACTIONS(4331),
    [anon_sym_scoped] = ACTIONS(4273),
    [anon_sym_var] = ACTIONS(4273),
    [anon_sym_yield] = ACTIONS(4273),
    [anon_sym_switch] = ACTIONS(4331),
    [anon_sym_when] = ACTIONS(4273),
    [sym_discard] = ACTIONS(4295),
    [anon_sym_DOT_DOT] = ACTIONS(4329),
    [anon_sym_and] = ACTIONS(4331),
    [anon_sym_or] = ACTIONS(4331),
    [anon_sym_AMP_AMP] = ACTIONS(4329),
    [anon_sym_PIPE_PIPE] = ACTIONS(4329),
    [anon_sym_QMARK_QMARK] = ACTIONS(4329),
    [anon_sym_from] = ACTIONS(4273),
    [anon_sym_into] = ACTIONS(4273),
    [anon_sym_join] = ACTIONS(4273),
    [anon_sym_on] = ACTIONS(4331),
    [anon_sym_equals] = ACTIONS(4273),
    [anon_sym_let] = ACTIONS(4273),
    [anon_sym_orderby] = ACTIONS(4273),
    [anon_sym_ascending] = ACTIONS(4273),
    [anon_sym_descending] = ACTIONS(4273),
    [anon_sym_group] = ACTIONS(4273),
    [anon_sym_by] = ACTIONS(4273),
    [anon_sym_select] = ACTIONS(4273),
    [anon_sym_as] = ACTIONS(4331),
    [anon_sym_is] = ACTIONS(4331),
    [anon_sym_DASH_GT] = ACTIONS(4329),
    [anon_sym_with] = ACTIONS(4331),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3387] = {
    [sym_preproc_region] = STATE(3387),
    [sym_preproc_endregion] = STATE(3387),
    [sym_preproc_line] = STATE(3387),
    [sym_preproc_pragma] = STATE(3387),
    [sym_preproc_nullable] = STATE(3387),
    [sym_preproc_error] = STATE(3387),
    [sym_preproc_define] = STATE(3387),
    [sym_preproc_undef] = STATE(3387),
    [sym__identifier_token] = ACTIONS(5051),
    [anon_sym_extern] = ACTIONS(5051),
    [anon_sym_alias] = ACTIONS(5051),
    [anon_sym_global] = ACTIONS(5051),
    [anon_sym_using] = ACTIONS(5051),
    [anon_sym_unsafe] = ACTIONS(5051),
    [anon_sym_static] = ACTIONS(5051),
    [anon_sym_LBRACK] = ACTIONS(5053),
    [anon_sym_LPAREN] = ACTIONS(5053),
    [anon_sym_event] = ACTIONS(5051),
    [anon_sym_namespace] = ACTIONS(5051),
    [anon_sym_class] = ACTIONS(5051),
    [anon_sym_ref] = ACTIONS(5051),
    [anon_sym_struct] = ACTIONS(5051),
    [anon_sym_enum] = ACTIONS(5051),
    [anon_sym_RBRACE] = ACTIONS(5053),
    [anon_sym_interface] = ACTIONS(5051),
    [anon_sym_delegate] = ACTIONS(5051),
    [anon_sym_record] = ACTIONS(5051),
    [anon_sym_abstract] = ACTIONS(5051),
    [anon_sym_async] = ACTIONS(5051),
    [anon_sym_const] = ACTIONS(5051),
    [anon_sym_file] = ACTIONS(5051),
    [anon_sym_fixed] = ACTIONS(5051),
    [anon_sym_internal] = ACTIONS(5051),
    [anon_sym_new] = ACTIONS(5051),
    [anon_sym_override] = ACTIONS(5051),
    [anon_sym_partial] = ACTIONS(5051),
    [anon_sym_private] = ACTIONS(5051),
    [anon_sym_protected] = ACTIONS(5051),
    [anon_sym_public] = ACTIONS(5051),
    [anon_sym_readonly] = ACTIONS(5051),
    [anon_sym_required] = ACTIONS(5051),
    [anon_sym_sealed] = ACTIONS(5051),
    [anon_sym_virtual] = ACTIONS(5051),
    [anon_sym_volatile] = ACTIONS(5051),
    [anon_sym_where] = ACTIONS(5051),
    [anon_sym_notnull] = ACTIONS(5051),
    [anon_sym_unmanaged] = ACTIONS(5051),
    [anon_sym_TILDE] = ACTIONS(5053),
    [anon_sym_implicit] = ACTIONS(5051),
    [anon_sym_explicit] = ACTIONS(5051),
    [anon_sym_scoped] = ACTIONS(5051),
    [anon_sym_var] = ACTIONS(5051),
    [sym_predefined_type] = ACTIONS(5051),
    [anon_sym_yield] = ACTIONS(5051),
    [anon_sym_when] = ACTIONS(5051),
    [anon_sym_from] = ACTIONS(5051),
    [anon_sym_into] = ACTIONS(5051),
    [anon_sym_join] = ACTIONS(5051),
    [anon_sym_on] = ACTIONS(5051),
    [anon_sym_equals] = ACTIONS(5051),
    [anon_sym_let] = ACTIONS(5051),
    [anon_sym_orderby] = ACTIONS(5051),
    [anon_sym_ascending] = ACTIONS(5051),
    [anon_sym_descending] = ACTIONS(5051),
    [anon_sym_group] = ACTIONS(5051),
    [anon_sym_by] = ACTIONS(5051),
    [anon_sym_select] = ACTIONS(5051),
    [aux_sym_preproc_if_token1] = ACTIONS(5053),
    [aux_sym_preproc_if_token3] = ACTIONS(5053),
    [aux_sym_preproc_else_token1] = ACTIONS(5053),
    [aux_sym_preproc_elif_token1] = ACTIONS(5053),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3388] = {
    [sym_preproc_region] = STATE(3388),
    [sym_preproc_endregion] = STATE(3388),
    [sym_preproc_line] = STATE(3388),
    [sym_preproc_pragma] = STATE(3388),
    [sym_preproc_nullable] = STATE(3388),
    [sym_preproc_error] = STATE(3388),
    [sym_preproc_define] = STATE(3388),
    [sym_preproc_undef] = STATE(3388),
    [sym__identifier_token] = ACTIONS(5055),
    [anon_sym_extern] = ACTIONS(5055),
    [anon_sym_alias] = ACTIONS(5055),
    [anon_sym_global] = ACTIONS(5055),
    [anon_sym_using] = ACTIONS(5055),
    [anon_sym_unsafe] = ACTIONS(5055),
    [anon_sym_static] = ACTIONS(5055),
    [anon_sym_LBRACK] = ACTIONS(5057),
    [anon_sym_LPAREN] = ACTIONS(5057),
    [anon_sym_event] = ACTIONS(5055),
    [anon_sym_namespace] = ACTIONS(5055),
    [anon_sym_class] = ACTIONS(5055),
    [anon_sym_ref] = ACTIONS(5055),
    [anon_sym_struct] = ACTIONS(5055),
    [anon_sym_enum] = ACTIONS(5055),
    [anon_sym_RBRACE] = ACTIONS(5057),
    [anon_sym_interface] = ACTIONS(5055),
    [anon_sym_delegate] = ACTIONS(5055),
    [anon_sym_record] = ACTIONS(5055),
    [anon_sym_abstract] = ACTIONS(5055),
    [anon_sym_async] = ACTIONS(5055),
    [anon_sym_const] = ACTIONS(5055),
    [anon_sym_file] = ACTIONS(5055),
    [anon_sym_fixed] = ACTIONS(5055),
    [anon_sym_internal] = ACTIONS(5055),
    [anon_sym_new] = ACTIONS(5055),
    [anon_sym_override] = ACTIONS(5055),
    [anon_sym_partial] = ACTIONS(5055),
    [anon_sym_private] = ACTIONS(5055),
    [anon_sym_protected] = ACTIONS(5055),
    [anon_sym_public] = ACTIONS(5055),
    [anon_sym_readonly] = ACTIONS(5055),
    [anon_sym_required] = ACTIONS(5055),
    [anon_sym_sealed] = ACTIONS(5055),
    [anon_sym_virtual] = ACTIONS(5055),
    [anon_sym_volatile] = ACTIONS(5055),
    [anon_sym_where] = ACTIONS(5055),
    [anon_sym_notnull] = ACTIONS(5055),
    [anon_sym_unmanaged] = ACTIONS(5055),
    [anon_sym_TILDE] = ACTIONS(5057),
    [anon_sym_implicit] = ACTIONS(5055),
    [anon_sym_explicit] = ACTIONS(5055),
    [anon_sym_scoped] = ACTIONS(5055),
    [anon_sym_var] = ACTIONS(5055),
    [sym_predefined_type] = ACTIONS(5055),
    [anon_sym_yield] = ACTIONS(5055),
    [anon_sym_when] = ACTIONS(5055),
    [anon_sym_from] = ACTIONS(5055),
    [anon_sym_into] = ACTIONS(5055),
    [anon_sym_join] = ACTIONS(5055),
    [anon_sym_on] = ACTIONS(5055),
    [anon_sym_equals] = ACTIONS(5055),
    [anon_sym_let] = ACTIONS(5055),
    [anon_sym_orderby] = ACTIONS(5055),
    [anon_sym_ascending] = ACTIONS(5055),
    [anon_sym_descending] = ACTIONS(5055),
    [anon_sym_group] = ACTIONS(5055),
    [anon_sym_by] = ACTIONS(5055),
    [anon_sym_select] = ACTIONS(5055),
    [aux_sym_preproc_if_token1] = ACTIONS(5057),
    [aux_sym_preproc_if_token3] = ACTIONS(5057),
    [aux_sym_preproc_else_token1] = ACTIONS(5057),
    [aux_sym_preproc_elif_token1] = ACTIONS(5057),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3389] = {
    [sym__variable_designation] = STATE(4123),
    [sym_parenthesized_variable_designation] = STATE(4274),
    [sym_identifier] = STATE(4269),
    [sym__reserved_identifier] = STATE(3908),
    [sym_preproc_region] = STATE(3389),
    [sym_preproc_endregion] = STATE(3389),
    [sym_preproc_line] = STATE(3389),
    [sym_preproc_pragma] = STATE(3389),
    [sym_preproc_nullable] = STATE(3389),
    [sym_preproc_error] = STATE(3389),
    [sym_preproc_define] = STATE(3389),
    [sym_preproc_undef] = STATE(3389),
    [sym__identifier_token] = ACTIONS(4271),
    [anon_sym_alias] = ACTIONS(4273),
    [anon_sym_global] = ACTIONS(4273),
    [anon_sym_LBRACK] = ACTIONS(4335),
    [anon_sym_LPAREN] = ACTIONS(4335),
    [anon_sym_file] = ACTIONS(4273),
    [anon_sym_LT] = ACTIONS(4337),
    [anon_sym_GT] = ACTIONS(4337),
    [anon_sym_where] = ACTIONS(4273),
    [anon_sym_QMARK] = ACTIONS(4337),
    [anon_sym_notnull] = ACTIONS(4273),
    [anon_sym_unmanaged] = ACTIONS(4273),
    [anon_sym_BANG] = ACTIONS(4337),
    [anon_sym_PLUS_PLUS] = ACTIONS(4335),
    [anon_sym_DASH_DASH] = ACTIONS(4335),
    [anon_sym_PLUS] = ACTIONS(4337),
    [anon_sym_DASH] = ACTIONS(4337),
    [anon_sym_STAR] = ACTIONS(4335),
    [anon_sym_SLASH] = ACTIONS(4337),
    [anon_sym_PERCENT] = ACTIONS(4335),
    [anon_sym_CARET] = ACTIONS(4335),
    [anon_sym_PIPE] = ACTIONS(4337),
    [anon_sym_AMP] = ACTIONS(4337),
    [anon_sym_LT_LT] = ACTIONS(4335),
    [anon_sym_GT_GT] = ACTIONS(4337),
    [anon_sym_GT_GT_GT] = ACTIONS(4335),
    [anon_sym_EQ_EQ] = ACTIONS(4335),
    [anon_sym_BANG_EQ] = ACTIONS(4335),
    [anon_sym_GT_EQ] = ACTIONS(4335),
    [anon_sym_LT_EQ] = ACTIONS(4335),
    [anon_sym_DOT] = ACTIONS(4337),
    [anon_sym_scoped] = ACTIONS(4273),
    [anon_sym_var] = ACTIONS(4273),
    [anon_sym_yield] = ACTIONS(4273),
    [anon_sym_switch] = ACTIONS(4337),
    [anon_sym_when] = ACTIONS(4273),
    [sym_discard] = ACTIONS(4295),
    [anon_sym_DOT_DOT] = ACTIONS(4335),
    [anon_sym_and] = ACTIONS(4337),
    [anon_sym_or] = ACTIONS(4337),
    [anon_sym_AMP_AMP] = ACTIONS(4335),
    [anon_sym_PIPE_PIPE] = ACTIONS(4335),
    [anon_sym_QMARK_QMARK] = ACTIONS(4335),
    [anon_sym_from] = ACTIONS(4273),
    [anon_sym_into] = ACTIONS(4273),
    [anon_sym_join] = ACTIONS(4273),
    [anon_sym_on] = ACTIONS(4337),
    [anon_sym_equals] = ACTIONS(4273),
    [anon_sym_let] = ACTIONS(4273),
    [anon_sym_orderby] = ACTIONS(4273),
    [anon_sym_ascending] = ACTIONS(4273),
    [anon_sym_descending] = ACTIONS(4273),
    [anon_sym_group] = ACTIONS(4273),
    [anon_sym_by] = ACTIONS(4273),
    [anon_sym_select] = ACTIONS(4273),
    [anon_sym_as] = ACTIONS(4337),
    [anon_sym_is] = ACTIONS(4337),
    [anon_sym_DASH_GT] = ACTIONS(4335),
    [anon_sym_with] = ACTIONS(4337),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3390] = {
    [sym__variable_designation] = STATE(4113),
    [sym_parenthesized_variable_designation] = STATE(4274),
    [sym_identifier] = STATE(4269),
    [sym__reserved_identifier] = STATE(3908),
    [sym_preproc_region] = STATE(3390),
    [sym_preproc_endregion] = STATE(3390),
    [sym_preproc_line] = STATE(3390),
    [sym_preproc_pragma] = STATE(3390),
    [sym_preproc_nullable] = STATE(3390),
    [sym_preproc_error] = STATE(3390),
    [sym_preproc_define] = STATE(3390),
    [sym_preproc_undef] = STATE(3390),
    [sym__identifier_token] = ACTIONS(4271),
    [anon_sym_alias] = ACTIONS(4273),
    [anon_sym_global] = ACTIONS(4273),
    [anon_sym_LBRACK] = ACTIONS(4373),
    [anon_sym_LPAREN] = ACTIONS(4373),
    [anon_sym_file] = ACTIONS(4273),
    [anon_sym_LT] = ACTIONS(4375),
    [anon_sym_GT] = ACTIONS(4375),
    [anon_sym_where] = ACTIONS(4273),
    [anon_sym_QMARK] = ACTIONS(4375),
    [anon_sym_notnull] = ACTIONS(4273),
    [anon_sym_unmanaged] = ACTIONS(4273),
    [anon_sym_BANG] = ACTIONS(4375),
    [anon_sym_PLUS_PLUS] = ACTIONS(4373),
    [anon_sym_DASH_DASH] = ACTIONS(4373),
    [anon_sym_PLUS] = ACTIONS(4375),
    [anon_sym_DASH] = ACTIONS(4375),
    [anon_sym_STAR] = ACTIONS(4373),
    [anon_sym_SLASH] = ACTIONS(4375),
    [anon_sym_PERCENT] = ACTIONS(4373),
    [anon_sym_CARET] = ACTIONS(4373),
    [anon_sym_PIPE] = ACTIONS(4375),
    [anon_sym_AMP] = ACTIONS(4375),
    [anon_sym_LT_LT] = ACTIONS(4373),
    [anon_sym_GT_GT] = ACTIONS(4375),
    [anon_sym_GT_GT_GT] = ACTIONS(4373),
    [anon_sym_EQ_EQ] = ACTIONS(4373),
    [anon_sym_BANG_EQ] = ACTIONS(4373),
    [anon_sym_GT_EQ] = ACTIONS(4373),
    [anon_sym_LT_EQ] = ACTIONS(4373),
    [anon_sym_DOT] = ACTIONS(4375),
    [anon_sym_scoped] = ACTIONS(4273),
    [anon_sym_var] = ACTIONS(4273),
    [anon_sym_yield] = ACTIONS(4273),
    [anon_sym_switch] = ACTIONS(4375),
    [anon_sym_when] = ACTIONS(4273),
    [sym_discard] = ACTIONS(4295),
    [anon_sym_DOT_DOT] = ACTIONS(4373),
    [anon_sym_and] = ACTIONS(4375),
    [anon_sym_or] = ACTIONS(4375),
    [anon_sym_AMP_AMP] = ACTIONS(4373),
    [anon_sym_PIPE_PIPE] = ACTIONS(4373),
    [anon_sym_QMARK_QMARK] = ACTIONS(4373),
    [anon_sym_from] = ACTIONS(4273),
    [anon_sym_into] = ACTIONS(4273),
    [anon_sym_join] = ACTIONS(4273),
    [anon_sym_on] = ACTIONS(4375),
    [anon_sym_equals] = ACTIONS(4273),
    [anon_sym_let] = ACTIONS(4273),
    [anon_sym_orderby] = ACTIONS(4273),
    [anon_sym_ascending] = ACTIONS(4273),
    [anon_sym_descending] = ACTIONS(4273),
    [anon_sym_group] = ACTIONS(4273),
    [anon_sym_by] = ACTIONS(4273),
    [anon_sym_select] = ACTIONS(4273),
    [anon_sym_as] = ACTIONS(4375),
    [anon_sym_is] = ACTIONS(4375),
    [anon_sym_DASH_GT] = ACTIONS(4373),
    [anon_sym_with] = ACTIONS(4375),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3391] = {
    [sym__variable_designation] = STATE(4082),
    [sym_parenthesized_variable_designation] = STATE(4274),
    [sym_identifier] = STATE(4269),
    [sym__reserved_identifier] = STATE(3908),
    [sym_preproc_region] = STATE(3391),
    [sym_preproc_endregion] = STATE(3391),
    [sym_preproc_line] = STATE(3391),
    [sym_preproc_pragma] = STATE(3391),
    [sym_preproc_nullable] = STATE(3391),
    [sym_preproc_error] = STATE(3391),
    [sym_preproc_define] = STATE(3391),
    [sym_preproc_undef] = STATE(3391),
    [sym__identifier_token] = ACTIONS(4271),
    [anon_sym_alias] = ACTIONS(4273),
    [anon_sym_global] = ACTIONS(4273),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_LPAREN] = ACTIONS(4383),
    [anon_sym_file] = ACTIONS(4273),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_where] = ACTIONS(4273),
    [anon_sym_QMARK] = ACTIONS(4385),
    [anon_sym_notnull] = ACTIONS(4273),
    [anon_sym_unmanaged] = ACTIONS(4273),
    [anon_sym_BANG] = ACTIONS(4385),
    [anon_sym_PLUS_PLUS] = ACTIONS(4383),
    [anon_sym_DASH_DASH] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_DASH] = ACTIONS(4385),
    [anon_sym_STAR] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4385),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4385),
    [anon_sym_GT_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4383),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_scoped] = ACTIONS(4273),
    [anon_sym_var] = ACTIONS(4273),
    [anon_sym_yield] = ACTIONS(4273),
    [anon_sym_switch] = ACTIONS(4385),
    [anon_sym_when] = ACTIONS(4273),
    [sym_discard] = ACTIONS(4295),
    [anon_sym_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4385),
    [anon_sym_or] = ACTIONS(4385),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_QMARK_QMARK] = ACTIONS(4383),
    [anon_sym_from] = ACTIONS(4273),
    [anon_sym_into] = ACTIONS(4273),
    [anon_sym_join] = ACTIONS(4273),
    [anon_sym_on] = ACTIONS(4385),
    [anon_sym_equals] = ACTIONS(4273),
    [anon_sym_let] = ACTIONS(4273),
    [anon_sym_orderby] = ACTIONS(4273),
    [anon_sym_ascending] = ACTIONS(4273),
    [anon_sym_descending] = ACTIONS(4273),
    [anon_sym_group] = ACTIONS(4273),
    [anon_sym_by] = ACTIONS(4273),
    [anon_sym_select] = ACTIONS(4273),
    [anon_sym_as] = ACTIONS(4385),
    [anon_sym_is] = ACTIONS(4385),
    [anon_sym_DASH_GT] = ACTIONS(4383),
    [anon_sym_with] = ACTIONS(4385),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3392] = {
    [sym_preproc_region] = STATE(3392),
    [sym_preproc_endregion] = STATE(3392),
    [sym_preproc_line] = STATE(3392),
    [sym_preproc_pragma] = STATE(3392),
    [sym_preproc_nullable] = STATE(3392),
    [sym_preproc_error] = STATE(3392),
    [sym_preproc_define] = STATE(3392),
    [sym_preproc_undef] = STATE(3392),
    [sym__identifier_token] = ACTIONS(3721),
    [anon_sym_alias] = ACTIONS(3721),
    [anon_sym_global] = ACTIONS(3721),
    [anon_sym_LBRACK] = ACTIONS(3719),
    [anon_sym_COLON] = ACTIONS(3719),
    [anon_sym_COMMA] = ACTIONS(3719),
    [anon_sym_LPAREN] = ACTIONS(3719),
    [anon_sym_LBRACE] = ACTIONS(3719),
    [anon_sym_file] = ACTIONS(3721),
    [anon_sym_LT] = ACTIONS(3721),
    [anon_sym_GT] = ACTIONS(3721),
    [anon_sym_where] = ACTIONS(3721),
    [anon_sym_QMARK] = ACTIONS(3721),
    [anon_sym_notnull] = ACTIONS(3721),
    [anon_sym_unmanaged] = ACTIONS(3721),
    [anon_sym_BANG] = ACTIONS(3721),
    [anon_sym_PLUS_PLUS] = ACTIONS(3719),
    [anon_sym_DASH_DASH] = ACTIONS(3719),
    [anon_sym_PLUS] = ACTIONS(3721),
    [anon_sym_DASH] = ACTIONS(3721),
    [anon_sym_STAR] = ACTIONS(3719),
    [anon_sym_SLASH] = ACTIONS(3721),
    [anon_sym_PERCENT] = ACTIONS(3719),
    [anon_sym_CARET] = ACTIONS(3719),
    [anon_sym_PIPE] = ACTIONS(3721),
    [anon_sym_AMP] = ACTIONS(3721),
    [anon_sym_LT_LT] = ACTIONS(3719),
    [anon_sym_GT_GT] = ACTIONS(3721),
    [anon_sym_GT_GT_GT] = ACTIONS(3719),
    [anon_sym_EQ_EQ] = ACTIONS(3719),
    [anon_sym_BANG_EQ] = ACTIONS(3719),
    [anon_sym_GT_EQ] = ACTIONS(3719),
    [anon_sym_LT_EQ] = ACTIONS(3719),
    [anon_sym_DOT] = ACTIONS(3721),
    [anon_sym_scoped] = ACTIONS(3721),
    [anon_sym_var] = ACTIONS(3721),
    [anon_sym_yield] = ACTIONS(3721),
    [anon_sym_switch] = ACTIONS(3721),
    [anon_sym_when] = ACTIONS(3721),
    [sym_discard] = ACTIONS(3721),
    [anon_sym_DOT_DOT] = ACTIONS(3719),
    [anon_sym_and] = ACTIONS(3721),
    [anon_sym_or] = ACTIONS(3721),
    [anon_sym_AMP_AMP] = ACTIONS(3719),
    [anon_sym_PIPE_PIPE] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK] = ACTIONS(3719),
    [anon_sym_from] = ACTIONS(3721),
    [anon_sym_into] = ACTIONS(3721),
    [anon_sym_join] = ACTIONS(3721),
    [anon_sym_on] = ACTIONS(3721),
    [anon_sym_equals] = ACTIONS(3721),
    [anon_sym_let] = ACTIONS(3721),
    [anon_sym_orderby] = ACTIONS(3721),
    [anon_sym_ascending] = ACTIONS(3721),
    [anon_sym_descending] = ACTIONS(3721),
    [anon_sym_group] = ACTIONS(3721),
    [anon_sym_by] = ACTIONS(3721),
    [anon_sym_select] = ACTIONS(3721),
    [anon_sym_as] = ACTIONS(3721),
    [anon_sym_is] = ACTIONS(3721),
    [anon_sym_DASH_GT] = ACTIONS(3719),
    [anon_sym_with] = ACTIONS(3721),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(3719),
  },
  [3393] = {
    [sym_preproc_region] = STATE(3393),
    [sym_preproc_endregion] = STATE(3393),
    [sym_preproc_line] = STATE(3393),
    [sym_preproc_pragma] = STATE(3393),
    [sym_preproc_nullable] = STATE(3393),
    [sym_preproc_error] = STATE(3393),
    [sym_preproc_define] = STATE(3393),
    [sym_preproc_undef] = STATE(3393),
    [sym__identifier_token] = ACTIONS(3828),
    [anon_sym_extern] = ACTIONS(3828),
    [anon_sym_alias] = ACTIONS(3828),
    [anon_sym_global] = ACTIONS(3828),
    [anon_sym_using] = ACTIONS(3828),
    [anon_sym_unsafe] = ACTIONS(3828),
    [anon_sym_static] = ACTIONS(3828),
    [anon_sym_LBRACK] = ACTIONS(3830),
    [anon_sym_LPAREN] = ACTIONS(3830),
    [anon_sym_event] = ACTIONS(3828),
    [anon_sym_namespace] = ACTIONS(3828),
    [anon_sym_class] = ACTIONS(3828),
    [anon_sym_ref] = ACTIONS(3828),
    [anon_sym_struct] = ACTIONS(3828),
    [anon_sym_enum] = ACTIONS(3828),
    [anon_sym_RBRACE] = ACTIONS(3830),
    [anon_sym_interface] = ACTIONS(3828),
    [anon_sym_delegate] = ACTIONS(3828),
    [anon_sym_record] = ACTIONS(3828),
    [anon_sym_abstract] = ACTIONS(3828),
    [anon_sym_async] = ACTIONS(3828),
    [anon_sym_const] = ACTIONS(3828),
    [anon_sym_file] = ACTIONS(3828),
    [anon_sym_fixed] = ACTIONS(3828),
    [anon_sym_internal] = ACTIONS(3828),
    [anon_sym_new] = ACTIONS(3828),
    [anon_sym_override] = ACTIONS(3828),
    [anon_sym_partial] = ACTIONS(3828),
    [anon_sym_private] = ACTIONS(3828),
    [anon_sym_protected] = ACTIONS(3828),
    [anon_sym_public] = ACTIONS(3828),
    [anon_sym_readonly] = ACTIONS(3828),
    [anon_sym_required] = ACTIONS(3828),
    [anon_sym_sealed] = ACTIONS(3828),
    [anon_sym_virtual] = ACTIONS(3828),
    [anon_sym_volatile] = ACTIONS(3828),
    [anon_sym_where] = ACTIONS(3828),
    [anon_sym_notnull] = ACTIONS(3828),
    [anon_sym_unmanaged] = ACTIONS(3828),
    [anon_sym_TILDE] = ACTIONS(3830),
    [anon_sym_implicit] = ACTIONS(3828),
    [anon_sym_explicit] = ACTIONS(3828),
    [anon_sym_scoped] = ACTIONS(3828),
    [anon_sym_var] = ACTIONS(3828),
    [sym_predefined_type] = ACTIONS(3828),
    [anon_sym_yield] = ACTIONS(3828),
    [anon_sym_when] = ACTIONS(3828),
    [anon_sym_from] = ACTIONS(3828),
    [anon_sym_into] = ACTIONS(3828),
    [anon_sym_join] = ACTIONS(3828),
    [anon_sym_on] = ACTIONS(3828),
    [anon_sym_equals] = ACTIONS(3828),
    [anon_sym_let] = ACTIONS(3828),
    [anon_sym_orderby] = ACTIONS(3828),
    [anon_sym_ascending] = ACTIONS(3828),
    [anon_sym_descending] = ACTIONS(3828),
    [anon_sym_group] = ACTIONS(3828),
    [anon_sym_by] = ACTIONS(3828),
    [anon_sym_select] = ACTIONS(3828),
    [aux_sym_preproc_if_token1] = ACTIONS(3830),
    [aux_sym_preproc_if_token3] = ACTIONS(3830),
    [aux_sym_preproc_else_token1] = ACTIONS(3830),
    [aux_sym_preproc_elif_token1] = ACTIONS(3830),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3394] = {
    [sym_preproc_region] = STATE(3394),
    [sym_preproc_endregion] = STATE(3394),
    [sym_preproc_line] = STATE(3394),
    [sym_preproc_pragma] = STATE(3394),
    [sym_preproc_nullable] = STATE(3394),
    [sym_preproc_error] = STATE(3394),
    [sym_preproc_define] = STATE(3394),
    [sym_preproc_undef] = STATE(3394),
    [sym__identifier_token] = ACTIONS(3657),
    [anon_sym_extern] = ACTIONS(3657),
    [anon_sym_alias] = ACTIONS(3657),
    [anon_sym_global] = ACTIONS(3657),
    [anon_sym_using] = ACTIONS(3657),
    [anon_sym_unsafe] = ACTIONS(3657),
    [anon_sym_static] = ACTIONS(3657),
    [anon_sym_LBRACK] = ACTIONS(3659),
    [anon_sym_LPAREN] = ACTIONS(3659),
    [anon_sym_event] = ACTIONS(3657),
    [anon_sym_namespace] = ACTIONS(3657),
    [anon_sym_class] = ACTIONS(3657),
    [anon_sym_ref] = ACTIONS(3657),
    [anon_sym_struct] = ACTIONS(3657),
    [anon_sym_enum] = ACTIONS(3657),
    [anon_sym_RBRACE] = ACTIONS(3659),
    [anon_sym_interface] = ACTIONS(3657),
    [anon_sym_delegate] = ACTIONS(3657),
    [anon_sym_record] = ACTIONS(3657),
    [anon_sym_abstract] = ACTIONS(3657),
    [anon_sym_async] = ACTIONS(3657),
    [anon_sym_const] = ACTIONS(3657),
    [anon_sym_file] = ACTIONS(3657),
    [anon_sym_fixed] = ACTIONS(3657),
    [anon_sym_internal] = ACTIONS(3657),
    [anon_sym_new] = ACTIONS(3657),
    [anon_sym_override] = ACTIONS(3657),
    [anon_sym_partial] = ACTIONS(3657),
    [anon_sym_private] = ACTIONS(3657),
    [anon_sym_protected] = ACTIONS(3657),
    [anon_sym_public] = ACTIONS(3657),
    [anon_sym_readonly] = ACTIONS(3657),
    [anon_sym_required] = ACTIONS(3657),
    [anon_sym_sealed] = ACTIONS(3657),
    [anon_sym_virtual] = ACTIONS(3657),
    [anon_sym_volatile] = ACTIONS(3657),
    [anon_sym_where] = ACTIONS(3657),
    [anon_sym_notnull] = ACTIONS(3657),
    [anon_sym_unmanaged] = ACTIONS(3657),
    [anon_sym_TILDE] = ACTIONS(3659),
    [anon_sym_implicit] = ACTIONS(3657),
    [anon_sym_explicit] = ACTIONS(3657),
    [anon_sym_scoped] = ACTIONS(3657),
    [anon_sym_var] = ACTIONS(3657),
    [sym_predefined_type] = ACTIONS(3657),
    [anon_sym_yield] = ACTIONS(3657),
    [anon_sym_when] = ACTIONS(3657),
    [anon_sym_from] = ACTIONS(3657),
    [anon_sym_into] = ACTIONS(3657),
    [anon_sym_join] = ACTIONS(3657),
    [anon_sym_on] = ACTIONS(3657),
    [anon_sym_equals] = ACTIONS(3657),
    [anon_sym_let] = ACTIONS(3657),
    [anon_sym_orderby] = ACTIONS(3657),
    [anon_sym_ascending] = ACTIONS(3657),
    [anon_sym_descending] = ACTIONS(3657),
    [anon_sym_group] = ACTIONS(3657),
    [anon_sym_by] = ACTIONS(3657),
    [anon_sym_select] = ACTIONS(3657),
    [aux_sym_preproc_if_token1] = ACTIONS(3659),
    [aux_sym_preproc_if_token3] = ACTIONS(3659),
    [aux_sym_preproc_else_token1] = ACTIONS(3659),
    [aux_sym_preproc_elif_token1] = ACTIONS(3659),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3395] = {
    [sym_preproc_region] = STATE(3395),
    [sym_preproc_endregion] = STATE(3395),
    [sym_preproc_line] = STATE(3395),
    [sym_preproc_pragma] = STATE(3395),
    [sym_preproc_nullable] = STATE(3395),
    [sym_preproc_error] = STATE(3395),
    [sym_preproc_define] = STATE(3395),
    [sym_preproc_undef] = STATE(3395),
    [sym__identifier_token] = ACTIONS(3820),
    [anon_sym_extern] = ACTIONS(3820),
    [anon_sym_alias] = ACTIONS(3820),
    [anon_sym_global] = ACTIONS(3820),
    [anon_sym_using] = ACTIONS(3820),
    [anon_sym_unsafe] = ACTIONS(3820),
    [anon_sym_static] = ACTIONS(3820),
    [anon_sym_LBRACK] = ACTIONS(3822),
    [anon_sym_LPAREN] = ACTIONS(3822),
    [anon_sym_event] = ACTIONS(3820),
    [anon_sym_namespace] = ACTIONS(3820),
    [anon_sym_class] = ACTIONS(3820),
    [anon_sym_ref] = ACTIONS(3820),
    [anon_sym_struct] = ACTIONS(3820),
    [anon_sym_enum] = ACTIONS(3820),
    [anon_sym_RBRACE] = ACTIONS(3822),
    [anon_sym_interface] = ACTIONS(3820),
    [anon_sym_delegate] = ACTIONS(3820),
    [anon_sym_record] = ACTIONS(3820),
    [anon_sym_abstract] = ACTIONS(3820),
    [anon_sym_async] = ACTIONS(3820),
    [anon_sym_const] = ACTIONS(3820),
    [anon_sym_file] = ACTIONS(3820),
    [anon_sym_fixed] = ACTIONS(3820),
    [anon_sym_internal] = ACTIONS(3820),
    [anon_sym_new] = ACTIONS(3820),
    [anon_sym_override] = ACTIONS(3820),
    [anon_sym_partial] = ACTIONS(3820),
    [anon_sym_private] = ACTIONS(3820),
    [anon_sym_protected] = ACTIONS(3820),
    [anon_sym_public] = ACTIONS(3820),
    [anon_sym_readonly] = ACTIONS(3820),
    [anon_sym_required] = ACTIONS(3820),
    [anon_sym_sealed] = ACTIONS(3820),
    [anon_sym_virtual] = ACTIONS(3820),
    [anon_sym_volatile] = ACTIONS(3820),
    [anon_sym_where] = ACTIONS(3820),
    [anon_sym_notnull] = ACTIONS(3820),
    [anon_sym_unmanaged] = ACTIONS(3820),
    [anon_sym_TILDE] = ACTIONS(3822),
    [anon_sym_implicit] = ACTIONS(3820),
    [anon_sym_explicit] = ACTIONS(3820),
    [anon_sym_scoped] = ACTIONS(3820),
    [anon_sym_var] = ACTIONS(3820),
    [sym_predefined_type] = ACTIONS(3820),
    [anon_sym_yield] = ACTIONS(3820),
    [anon_sym_when] = ACTIONS(3820),
    [anon_sym_from] = ACTIONS(3820),
    [anon_sym_into] = ACTIONS(3820),
    [anon_sym_join] = ACTIONS(3820),
    [anon_sym_on] = ACTIONS(3820),
    [anon_sym_equals] = ACTIONS(3820),
    [anon_sym_let] = ACTIONS(3820),
    [anon_sym_orderby] = ACTIONS(3820),
    [anon_sym_ascending] = ACTIONS(3820),
    [anon_sym_descending] = ACTIONS(3820),
    [anon_sym_group] = ACTIONS(3820),
    [anon_sym_by] = ACTIONS(3820),
    [anon_sym_select] = ACTIONS(3820),
    [aux_sym_preproc_if_token1] = ACTIONS(3822),
    [aux_sym_preproc_if_token3] = ACTIONS(3822),
    [aux_sym_preproc_else_token1] = ACTIONS(3822),
    [aux_sym_preproc_elif_token1] = ACTIONS(3822),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3396] = {
    [sym_preproc_region] = STATE(3396),
    [sym_preproc_endregion] = STATE(3396),
    [sym_preproc_line] = STATE(3396),
    [sym_preproc_pragma] = STATE(3396),
    [sym_preproc_nullable] = STATE(3396),
    [sym_preproc_error] = STATE(3396),
    [sym_preproc_define] = STATE(3396),
    [sym_preproc_undef] = STATE(3396),
    [sym__identifier_token] = ACTIONS(4564),
    [anon_sym_alias] = ACTIONS(4564),
    [anon_sym_global] = ACTIONS(4564),
    [anon_sym_LBRACK] = ACTIONS(4566),
    [anon_sym_COLON] = ACTIONS(4566),
    [anon_sym_COMMA] = ACTIONS(4566),
    [anon_sym_LPAREN] = ACTIONS(4566),
    [anon_sym_LBRACE] = ACTIONS(4566),
    [anon_sym_file] = ACTIONS(4564),
    [anon_sym_LT] = ACTIONS(4564),
    [anon_sym_GT] = ACTIONS(4564),
    [anon_sym_where] = ACTIONS(4564),
    [anon_sym_QMARK] = ACTIONS(4564),
    [anon_sym_notnull] = ACTIONS(4564),
    [anon_sym_unmanaged] = ACTIONS(4564),
    [anon_sym_BANG] = ACTIONS(4564),
    [anon_sym_PLUS_PLUS] = ACTIONS(4566),
    [anon_sym_DASH_DASH] = ACTIONS(4566),
    [anon_sym_PLUS] = ACTIONS(4564),
    [anon_sym_DASH] = ACTIONS(4564),
    [anon_sym_STAR] = ACTIONS(4566),
    [anon_sym_SLASH] = ACTIONS(4564),
    [anon_sym_PERCENT] = ACTIONS(4566),
    [anon_sym_CARET] = ACTIONS(4566),
    [anon_sym_PIPE] = ACTIONS(4564),
    [anon_sym_AMP] = ACTIONS(4564),
    [anon_sym_LT_LT] = ACTIONS(4566),
    [anon_sym_GT_GT] = ACTIONS(4564),
    [anon_sym_GT_GT_GT] = ACTIONS(4566),
    [anon_sym_EQ_EQ] = ACTIONS(4566),
    [anon_sym_BANG_EQ] = ACTIONS(4566),
    [anon_sym_GT_EQ] = ACTIONS(4566),
    [anon_sym_LT_EQ] = ACTIONS(4566),
    [anon_sym_DOT] = ACTIONS(4564),
    [anon_sym_scoped] = ACTIONS(4564),
    [anon_sym_var] = ACTIONS(4564),
    [anon_sym_yield] = ACTIONS(4564),
    [anon_sym_switch] = ACTIONS(4564),
    [anon_sym_when] = ACTIONS(4564),
    [sym_discard] = ACTIONS(4564),
    [anon_sym_DOT_DOT] = ACTIONS(4566),
    [anon_sym_and] = ACTIONS(4564),
    [anon_sym_or] = ACTIONS(4564),
    [anon_sym_AMP_AMP] = ACTIONS(4566),
    [anon_sym_PIPE_PIPE] = ACTIONS(4566),
    [anon_sym_QMARK_QMARK] = ACTIONS(4566),
    [anon_sym_from] = ACTIONS(4564),
    [anon_sym_into] = ACTIONS(4564),
    [anon_sym_join] = ACTIONS(4564),
    [anon_sym_on] = ACTIONS(4564),
    [anon_sym_equals] = ACTIONS(4564),
    [anon_sym_let] = ACTIONS(4564),
    [anon_sym_orderby] = ACTIONS(4564),
    [anon_sym_ascending] = ACTIONS(4564),
    [anon_sym_descending] = ACTIONS(4564),
    [anon_sym_group] = ACTIONS(4564),
    [anon_sym_by] = ACTIONS(4564),
    [anon_sym_select] = ACTIONS(4564),
    [anon_sym_as] = ACTIONS(4564),
    [anon_sym_is] = ACTIONS(4564),
    [anon_sym_DASH_GT] = ACTIONS(4566),
    [anon_sym_with] = ACTIONS(4564),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4566),
  },
  [3397] = {
    [sym_preproc_region] = STATE(3397),
    [sym_preproc_endregion] = STATE(3397),
    [sym_preproc_line] = STATE(3397),
    [sym_preproc_pragma] = STATE(3397),
    [sym_preproc_nullable] = STATE(3397),
    [sym_preproc_error] = STATE(3397),
    [sym_preproc_define] = STATE(3397),
    [sym_preproc_undef] = STATE(3397),
    [sym__identifier_token] = ACTIONS(4056),
    [anon_sym_alias] = ACTIONS(4056),
    [anon_sym_global] = ACTIONS(4056),
    [anon_sym_LBRACK] = ACTIONS(4058),
    [anon_sym_COLON] = ACTIONS(4058),
    [anon_sym_COMMA] = ACTIONS(4058),
    [anon_sym_LPAREN] = ACTIONS(4058),
    [anon_sym_LBRACE] = ACTIONS(4058),
    [anon_sym_file] = ACTIONS(4056),
    [anon_sym_LT] = ACTIONS(4056),
    [anon_sym_GT] = ACTIONS(4056),
    [anon_sym_where] = ACTIONS(4056),
    [anon_sym_QMARK] = ACTIONS(4056),
    [anon_sym_notnull] = ACTIONS(4056),
    [anon_sym_unmanaged] = ACTIONS(4056),
    [anon_sym_BANG] = ACTIONS(4056),
    [anon_sym_PLUS_PLUS] = ACTIONS(4058),
    [anon_sym_DASH_DASH] = ACTIONS(4058),
    [anon_sym_PLUS] = ACTIONS(4056),
    [anon_sym_DASH] = ACTIONS(4056),
    [anon_sym_STAR] = ACTIONS(4058),
    [anon_sym_SLASH] = ACTIONS(4056),
    [anon_sym_PERCENT] = ACTIONS(4058),
    [anon_sym_CARET] = ACTIONS(4058),
    [anon_sym_PIPE] = ACTIONS(4056),
    [anon_sym_AMP] = ACTIONS(4056),
    [anon_sym_LT_LT] = ACTIONS(4058),
    [anon_sym_GT_GT] = ACTIONS(4056),
    [anon_sym_GT_GT_GT] = ACTIONS(4058),
    [anon_sym_EQ_EQ] = ACTIONS(4058),
    [anon_sym_BANG_EQ] = ACTIONS(4058),
    [anon_sym_GT_EQ] = ACTIONS(4058),
    [anon_sym_LT_EQ] = ACTIONS(4058),
    [anon_sym_DOT] = ACTIONS(4056),
    [anon_sym_scoped] = ACTIONS(4056),
    [anon_sym_var] = ACTIONS(4056),
    [anon_sym_yield] = ACTIONS(4056),
    [anon_sym_switch] = ACTIONS(4056),
    [anon_sym_when] = ACTIONS(4056),
    [sym_discard] = ACTIONS(4056),
    [anon_sym_DOT_DOT] = ACTIONS(4058),
    [anon_sym_and] = ACTIONS(4056),
    [anon_sym_or] = ACTIONS(4056),
    [anon_sym_AMP_AMP] = ACTIONS(4058),
    [anon_sym_PIPE_PIPE] = ACTIONS(4058),
    [anon_sym_QMARK_QMARK] = ACTIONS(4058),
    [anon_sym_from] = ACTIONS(4056),
    [anon_sym_into] = ACTIONS(4056),
    [anon_sym_join] = ACTIONS(4056),
    [anon_sym_on] = ACTIONS(4056),
    [anon_sym_equals] = ACTIONS(4056),
    [anon_sym_let] = ACTIONS(4056),
    [anon_sym_orderby] = ACTIONS(4056),
    [anon_sym_ascending] = ACTIONS(4056),
    [anon_sym_descending] = ACTIONS(4056),
    [anon_sym_group] = ACTIONS(4056),
    [anon_sym_by] = ACTIONS(4056),
    [anon_sym_select] = ACTIONS(4056),
    [anon_sym_as] = ACTIONS(4056),
    [anon_sym_is] = ACTIONS(4056),
    [anon_sym_DASH_GT] = ACTIONS(4058),
    [anon_sym_with] = ACTIONS(4056),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4058),
  },
  [3398] = {
    [sym_preproc_region] = STATE(3398),
    [sym_preproc_endregion] = STATE(3398),
    [sym_preproc_line] = STATE(3398),
    [sym_preproc_pragma] = STATE(3398),
    [sym_preproc_nullable] = STATE(3398),
    [sym_preproc_error] = STATE(3398),
    [sym_preproc_define] = STATE(3398),
    [sym_preproc_undef] = STATE(3398),
    [sym__identifier_token] = ACTIONS(3669),
    [anon_sym_extern] = ACTIONS(3669),
    [anon_sym_alias] = ACTIONS(3669),
    [anon_sym_global] = ACTIONS(3669),
    [anon_sym_using] = ACTIONS(3669),
    [anon_sym_unsafe] = ACTIONS(3669),
    [anon_sym_static] = ACTIONS(3669),
    [anon_sym_LBRACK] = ACTIONS(3671),
    [anon_sym_LPAREN] = ACTIONS(3671),
    [anon_sym_event] = ACTIONS(3669),
    [anon_sym_namespace] = ACTIONS(3669),
    [anon_sym_class] = ACTIONS(3669),
    [anon_sym_ref] = ACTIONS(3669),
    [anon_sym_struct] = ACTIONS(3669),
    [anon_sym_enum] = ACTIONS(3669),
    [anon_sym_RBRACE] = ACTIONS(3671),
    [anon_sym_interface] = ACTIONS(3669),
    [anon_sym_delegate] = ACTIONS(3669),
    [anon_sym_record] = ACTIONS(3669),
    [anon_sym_abstract] = ACTIONS(3669),
    [anon_sym_async] = ACTIONS(3669),
    [anon_sym_const] = ACTIONS(3669),
    [anon_sym_file] = ACTIONS(3669),
    [anon_sym_fixed] = ACTIONS(3669),
    [anon_sym_internal] = ACTIONS(3669),
    [anon_sym_new] = ACTIONS(3669),
    [anon_sym_override] = ACTIONS(3669),
    [anon_sym_partial] = ACTIONS(3669),
    [anon_sym_private] = ACTIONS(3669),
    [anon_sym_protected] = ACTIONS(3669),
    [anon_sym_public] = ACTIONS(3669),
    [anon_sym_readonly] = ACTIONS(3669),
    [anon_sym_required] = ACTIONS(3669),
    [anon_sym_sealed] = ACTIONS(3669),
    [anon_sym_virtual] = ACTIONS(3669),
    [anon_sym_volatile] = ACTIONS(3669),
    [anon_sym_where] = ACTIONS(3669),
    [anon_sym_notnull] = ACTIONS(3669),
    [anon_sym_unmanaged] = ACTIONS(3669),
    [anon_sym_TILDE] = ACTIONS(3671),
    [anon_sym_implicit] = ACTIONS(3669),
    [anon_sym_explicit] = ACTIONS(3669),
    [anon_sym_scoped] = ACTIONS(3669),
    [anon_sym_var] = ACTIONS(3669),
    [sym_predefined_type] = ACTIONS(3669),
    [anon_sym_yield] = ACTIONS(3669),
    [anon_sym_when] = ACTIONS(3669),
    [anon_sym_from] = ACTIONS(3669),
    [anon_sym_into] = ACTIONS(3669),
    [anon_sym_join] = ACTIONS(3669),
    [anon_sym_on] = ACTIONS(3669),
    [anon_sym_equals] = ACTIONS(3669),
    [anon_sym_let] = ACTIONS(3669),
    [anon_sym_orderby] = ACTIONS(3669),
    [anon_sym_ascending] = ACTIONS(3669),
    [anon_sym_descending] = ACTIONS(3669),
    [anon_sym_group] = ACTIONS(3669),
    [anon_sym_by] = ACTIONS(3669),
    [anon_sym_select] = ACTIONS(3669),
    [aux_sym_preproc_if_token1] = ACTIONS(3671),
    [aux_sym_preproc_if_token3] = ACTIONS(3671),
    [aux_sym_preproc_else_token1] = ACTIONS(3671),
    [aux_sym_preproc_elif_token1] = ACTIONS(3671),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3399] = {
    [sym_preproc_region] = STATE(3399),
    [sym_preproc_endregion] = STATE(3399),
    [sym_preproc_line] = STATE(3399),
    [sym_preproc_pragma] = STATE(3399),
    [sym_preproc_nullable] = STATE(3399),
    [sym_preproc_error] = STATE(3399),
    [sym_preproc_define] = STATE(3399),
    [sym_preproc_undef] = STATE(3399),
    [sym__identifier_token] = ACTIONS(3756),
    [anon_sym_extern] = ACTIONS(3756),
    [anon_sym_alias] = ACTIONS(3756),
    [anon_sym_global] = ACTIONS(3756),
    [anon_sym_using] = ACTIONS(3756),
    [anon_sym_unsafe] = ACTIONS(3756),
    [anon_sym_static] = ACTIONS(3756),
    [anon_sym_LBRACK] = ACTIONS(3758),
    [anon_sym_LPAREN] = ACTIONS(3758),
    [anon_sym_event] = ACTIONS(3756),
    [anon_sym_namespace] = ACTIONS(3756),
    [anon_sym_class] = ACTIONS(3756),
    [anon_sym_ref] = ACTIONS(3756),
    [anon_sym_struct] = ACTIONS(3756),
    [anon_sym_enum] = ACTIONS(3756),
    [anon_sym_RBRACE] = ACTIONS(3758),
    [anon_sym_interface] = ACTIONS(3756),
    [anon_sym_delegate] = ACTIONS(3756),
    [anon_sym_record] = ACTIONS(3756),
    [anon_sym_abstract] = ACTIONS(3756),
    [anon_sym_async] = ACTIONS(3756),
    [anon_sym_const] = ACTIONS(3756),
    [anon_sym_file] = ACTIONS(3756),
    [anon_sym_fixed] = ACTIONS(3756),
    [anon_sym_internal] = ACTIONS(3756),
    [anon_sym_new] = ACTIONS(3756),
    [anon_sym_override] = ACTIONS(3756),
    [anon_sym_partial] = ACTIONS(3756),
    [anon_sym_private] = ACTIONS(3756),
    [anon_sym_protected] = ACTIONS(3756),
    [anon_sym_public] = ACTIONS(3756),
    [anon_sym_readonly] = ACTIONS(3756),
    [anon_sym_required] = ACTIONS(3756),
    [anon_sym_sealed] = ACTIONS(3756),
    [anon_sym_virtual] = ACTIONS(3756),
    [anon_sym_volatile] = ACTIONS(3756),
    [anon_sym_where] = ACTIONS(3756),
    [anon_sym_notnull] = ACTIONS(3756),
    [anon_sym_unmanaged] = ACTIONS(3756),
    [anon_sym_TILDE] = ACTIONS(3758),
    [anon_sym_implicit] = ACTIONS(3756),
    [anon_sym_explicit] = ACTIONS(3756),
    [anon_sym_scoped] = ACTIONS(3756),
    [anon_sym_var] = ACTIONS(3756),
    [sym_predefined_type] = ACTIONS(3756),
    [anon_sym_yield] = ACTIONS(3756),
    [anon_sym_when] = ACTIONS(3756),
    [anon_sym_from] = ACTIONS(3756),
    [anon_sym_into] = ACTIONS(3756),
    [anon_sym_join] = ACTIONS(3756),
    [anon_sym_on] = ACTIONS(3756),
    [anon_sym_equals] = ACTIONS(3756),
    [anon_sym_let] = ACTIONS(3756),
    [anon_sym_orderby] = ACTIONS(3756),
    [anon_sym_ascending] = ACTIONS(3756),
    [anon_sym_descending] = ACTIONS(3756),
    [anon_sym_group] = ACTIONS(3756),
    [anon_sym_by] = ACTIONS(3756),
    [anon_sym_select] = ACTIONS(3756),
    [aux_sym_preproc_if_token1] = ACTIONS(3758),
    [aux_sym_preproc_if_token3] = ACTIONS(3758),
    [aux_sym_preproc_else_token1] = ACTIONS(3758),
    [aux_sym_preproc_elif_token1] = ACTIONS(3758),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3400] = {
    [sym_preproc_region] = STATE(3400),
    [sym_preproc_endregion] = STATE(3400),
    [sym_preproc_line] = STATE(3400),
    [sym_preproc_pragma] = STATE(3400),
    [sym_preproc_nullable] = STATE(3400),
    [sym_preproc_error] = STATE(3400),
    [sym_preproc_define] = STATE(3400),
    [sym_preproc_undef] = STATE(3400),
    [sym__identifier_token] = ACTIONS(3681),
    [anon_sym_extern] = ACTIONS(3681),
    [anon_sym_alias] = ACTIONS(3681),
    [anon_sym_global] = ACTIONS(3681),
    [anon_sym_using] = ACTIONS(3681),
    [anon_sym_unsafe] = ACTIONS(3681),
    [anon_sym_static] = ACTIONS(3681),
    [anon_sym_LBRACK] = ACTIONS(3683),
    [anon_sym_LPAREN] = ACTIONS(3683),
    [anon_sym_event] = ACTIONS(3681),
    [anon_sym_namespace] = ACTIONS(3681),
    [anon_sym_class] = ACTIONS(3681),
    [anon_sym_ref] = ACTIONS(3681),
    [anon_sym_struct] = ACTIONS(3681),
    [anon_sym_enum] = ACTIONS(3681),
    [anon_sym_RBRACE] = ACTIONS(3683),
    [anon_sym_interface] = ACTIONS(3681),
    [anon_sym_delegate] = ACTIONS(3681),
    [anon_sym_record] = ACTIONS(3681),
    [anon_sym_abstract] = ACTIONS(3681),
    [anon_sym_async] = ACTIONS(3681),
    [anon_sym_const] = ACTIONS(3681),
    [anon_sym_file] = ACTIONS(3681),
    [anon_sym_fixed] = ACTIONS(3681),
    [anon_sym_internal] = ACTIONS(3681),
    [anon_sym_new] = ACTIONS(3681),
    [anon_sym_override] = ACTIONS(3681),
    [anon_sym_partial] = ACTIONS(3681),
    [anon_sym_private] = ACTIONS(3681),
    [anon_sym_protected] = ACTIONS(3681),
    [anon_sym_public] = ACTIONS(3681),
    [anon_sym_readonly] = ACTIONS(3681),
    [anon_sym_required] = ACTIONS(3681),
    [anon_sym_sealed] = ACTIONS(3681),
    [anon_sym_virtual] = ACTIONS(3681),
    [anon_sym_volatile] = ACTIONS(3681),
    [anon_sym_where] = ACTIONS(3681),
    [anon_sym_notnull] = ACTIONS(3681),
    [anon_sym_unmanaged] = ACTIONS(3681),
    [anon_sym_TILDE] = ACTIONS(3683),
    [anon_sym_implicit] = ACTIONS(3681),
    [anon_sym_explicit] = ACTIONS(3681),
    [anon_sym_scoped] = ACTIONS(3681),
    [anon_sym_var] = ACTIONS(3681),
    [sym_predefined_type] = ACTIONS(3681),
    [anon_sym_yield] = ACTIONS(3681),
    [anon_sym_when] = ACTIONS(3681),
    [anon_sym_from] = ACTIONS(3681),
    [anon_sym_into] = ACTIONS(3681),
    [anon_sym_join] = ACTIONS(3681),
    [anon_sym_on] = ACTIONS(3681),
    [anon_sym_equals] = ACTIONS(3681),
    [anon_sym_let] = ACTIONS(3681),
    [anon_sym_orderby] = ACTIONS(3681),
    [anon_sym_ascending] = ACTIONS(3681),
    [anon_sym_descending] = ACTIONS(3681),
    [anon_sym_group] = ACTIONS(3681),
    [anon_sym_by] = ACTIONS(3681),
    [anon_sym_select] = ACTIONS(3681),
    [aux_sym_preproc_if_token1] = ACTIONS(3683),
    [aux_sym_preproc_if_token3] = ACTIONS(3683),
    [aux_sym_preproc_else_token1] = ACTIONS(3683),
    [aux_sym_preproc_elif_token1] = ACTIONS(3683),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3401] = {
    [sym_preproc_region] = STATE(3401),
    [sym_preproc_endregion] = STATE(3401),
    [sym_preproc_line] = STATE(3401),
    [sym_preproc_pragma] = STATE(3401),
    [sym_preproc_nullable] = STATE(3401),
    [sym_preproc_error] = STATE(3401),
    [sym_preproc_define] = STATE(3401),
    [sym_preproc_undef] = STATE(3401),
    [sym__identifier_token] = ACTIONS(5059),
    [anon_sym_extern] = ACTIONS(5059),
    [anon_sym_alias] = ACTIONS(5059),
    [anon_sym_global] = ACTIONS(5059),
    [anon_sym_using] = ACTIONS(5059),
    [anon_sym_unsafe] = ACTIONS(5059),
    [anon_sym_static] = ACTIONS(5059),
    [anon_sym_LBRACK] = ACTIONS(5061),
    [anon_sym_LPAREN] = ACTIONS(5061),
    [anon_sym_event] = ACTIONS(5059),
    [anon_sym_namespace] = ACTIONS(5059),
    [anon_sym_class] = ACTIONS(5059),
    [anon_sym_ref] = ACTIONS(5059),
    [anon_sym_struct] = ACTIONS(5059),
    [anon_sym_enum] = ACTIONS(5059),
    [anon_sym_RBRACE] = ACTIONS(5061),
    [anon_sym_interface] = ACTIONS(5059),
    [anon_sym_delegate] = ACTIONS(5059),
    [anon_sym_record] = ACTIONS(5059),
    [anon_sym_abstract] = ACTIONS(5059),
    [anon_sym_async] = ACTIONS(5059),
    [anon_sym_const] = ACTIONS(5059),
    [anon_sym_file] = ACTIONS(5059),
    [anon_sym_fixed] = ACTIONS(5059),
    [anon_sym_internal] = ACTIONS(5059),
    [anon_sym_new] = ACTIONS(5059),
    [anon_sym_override] = ACTIONS(5059),
    [anon_sym_partial] = ACTIONS(5059),
    [anon_sym_private] = ACTIONS(5059),
    [anon_sym_protected] = ACTIONS(5059),
    [anon_sym_public] = ACTIONS(5059),
    [anon_sym_readonly] = ACTIONS(5059),
    [anon_sym_required] = ACTIONS(5059),
    [anon_sym_sealed] = ACTIONS(5059),
    [anon_sym_virtual] = ACTIONS(5059),
    [anon_sym_volatile] = ACTIONS(5059),
    [anon_sym_where] = ACTIONS(5059),
    [anon_sym_notnull] = ACTIONS(5059),
    [anon_sym_unmanaged] = ACTIONS(5059),
    [anon_sym_TILDE] = ACTIONS(5061),
    [anon_sym_implicit] = ACTIONS(5059),
    [anon_sym_explicit] = ACTIONS(5059),
    [anon_sym_scoped] = ACTIONS(5059),
    [anon_sym_var] = ACTIONS(5059),
    [sym_predefined_type] = ACTIONS(5059),
    [anon_sym_yield] = ACTIONS(5059),
    [anon_sym_when] = ACTIONS(5059),
    [anon_sym_from] = ACTIONS(5059),
    [anon_sym_into] = ACTIONS(5059),
    [anon_sym_join] = ACTIONS(5059),
    [anon_sym_on] = ACTIONS(5059),
    [anon_sym_equals] = ACTIONS(5059),
    [anon_sym_let] = ACTIONS(5059),
    [anon_sym_orderby] = ACTIONS(5059),
    [anon_sym_ascending] = ACTIONS(5059),
    [anon_sym_descending] = ACTIONS(5059),
    [anon_sym_group] = ACTIONS(5059),
    [anon_sym_by] = ACTIONS(5059),
    [anon_sym_select] = ACTIONS(5059),
    [aux_sym_preproc_if_token1] = ACTIONS(5061),
    [aux_sym_preproc_if_token3] = ACTIONS(5061),
    [aux_sym_preproc_else_token1] = ACTIONS(5061),
    [aux_sym_preproc_elif_token1] = ACTIONS(5061),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3402] = {
    [sym_preproc_region] = STATE(3402),
    [sym_preproc_endregion] = STATE(3402),
    [sym_preproc_line] = STATE(3402),
    [sym_preproc_pragma] = STATE(3402),
    [sym_preproc_nullable] = STATE(3402),
    [sym_preproc_error] = STATE(3402),
    [sym_preproc_define] = STATE(3402),
    [sym_preproc_undef] = STATE(3402),
    [sym__identifier_token] = ACTIONS(3816),
    [anon_sym_extern] = ACTIONS(3816),
    [anon_sym_alias] = ACTIONS(3816),
    [anon_sym_global] = ACTIONS(3816),
    [anon_sym_using] = ACTIONS(3816),
    [anon_sym_unsafe] = ACTIONS(3816),
    [anon_sym_static] = ACTIONS(3816),
    [anon_sym_LBRACK] = ACTIONS(3818),
    [anon_sym_LPAREN] = ACTIONS(3818),
    [anon_sym_event] = ACTIONS(3816),
    [anon_sym_namespace] = ACTIONS(3816),
    [anon_sym_class] = ACTIONS(3816),
    [anon_sym_ref] = ACTIONS(3816),
    [anon_sym_struct] = ACTIONS(3816),
    [anon_sym_enum] = ACTIONS(3816),
    [anon_sym_RBRACE] = ACTIONS(3818),
    [anon_sym_interface] = ACTIONS(3816),
    [anon_sym_delegate] = ACTIONS(3816),
    [anon_sym_record] = ACTIONS(3816),
    [anon_sym_abstract] = ACTIONS(3816),
    [anon_sym_async] = ACTIONS(3816),
    [anon_sym_const] = ACTIONS(3816),
    [anon_sym_file] = ACTIONS(3816),
    [anon_sym_fixed] = ACTIONS(3816),
    [anon_sym_internal] = ACTIONS(3816),
    [anon_sym_new] = ACTIONS(3816),
    [anon_sym_override] = ACTIONS(3816),
    [anon_sym_partial] = ACTIONS(3816),
    [anon_sym_private] = ACTIONS(3816),
    [anon_sym_protected] = ACTIONS(3816),
    [anon_sym_public] = ACTIONS(3816),
    [anon_sym_readonly] = ACTIONS(3816),
    [anon_sym_required] = ACTIONS(3816),
    [anon_sym_sealed] = ACTIONS(3816),
    [anon_sym_virtual] = ACTIONS(3816),
    [anon_sym_volatile] = ACTIONS(3816),
    [anon_sym_where] = ACTIONS(3816),
    [anon_sym_notnull] = ACTIONS(3816),
    [anon_sym_unmanaged] = ACTIONS(3816),
    [anon_sym_TILDE] = ACTIONS(3818),
    [anon_sym_implicit] = ACTIONS(3816),
    [anon_sym_explicit] = ACTIONS(3816),
    [anon_sym_scoped] = ACTIONS(3816),
    [anon_sym_var] = ACTIONS(3816),
    [sym_predefined_type] = ACTIONS(3816),
    [anon_sym_yield] = ACTIONS(3816),
    [anon_sym_when] = ACTIONS(3816),
    [anon_sym_from] = ACTIONS(3816),
    [anon_sym_into] = ACTIONS(3816),
    [anon_sym_join] = ACTIONS(3816),
    [anon_sym_on] = ACTIONS(3816),
    [anon_sym_equals] = ACTIONS(3816),
    [anon_sym_let] = ACTIONS(3816),
    [anon_sym_orderby] = ACTIONS(3816),
    [anon_sym_ascending] = ACTIONS(3816),
    [anon_sym_descending] = ACTIONS(3816),
    [anon_sym_group] = ACTIONS(3816),
    [anon_sym_by] = ACTIONS(3816),
    [anon_sym_select] = ACTIONS(3816),
    [aux_sym_preproc_if_token1] = ACTIONS(3818),
    [aux_sym_preproc_if_token3] = ACTIONS(3818),
    [aux_sym_preproc_else_token1] = ACTIONS(3818),
    [aux_sym_preproc_elif_token1] = ACTIONS(3818),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3403] = {
    [sym_preproc_region] = STATE(3403),
    [sym_preproc_endregion] = STATE(3403),
    [sym_preproc_line] = STATE(3403),
    [sym_preproc_pragma] = STATE(3403),
    [sym_preproc_nullable] = STATE(3403),
    [sym_preproc_error] = STATE(3403),
    [sym_preproc_define] = STATE(3403),
    [sym_preproc_undef] = STATE(3403),
    [sym__identifier_token] = ACTIONS(4422),
    [anon_sym_alias] = ACTIONS(4422),
    [anon_sym_global] = ACTIONS(4422),
    [anon_sym_LBRACK] = ACTIONS(4424),
    [anon_sym_COLON] = ACTIONS(4424),
    [anon_sym_COMMA] = ACTIONS(4424),
    [anon_sym_LPAREN] = ACTIONS(4424),
    [anon_sym_LBRACE] = ACTIONS(4424),
    [anon_sym_file] = ACTIONS(4422),
    [anon_sym_LT] = ACTIONS(4422),
    [anon_sym_GT] = ACTIONS(4422),
    [anon_sym_where] = ACTIONS(4422),
    [anon_sym_QMARK] = ACTIONS(4422),
    [anon_sym_notnull] = ACTIONS(4422),
    [anon_sym_unmanaged] = ACTIONS(4422),
    [anon_sym_BANG] = ACTIONS(4422),
    [anon_sym_PLUS_PLUS] = ACTIONS(4424),
    [anon_sym_DASH_DASH] = ACTIONS(4424),
    [anon_sym_PLUS] = ACTIONS(4422),
    [anon_sym_DASH] = ACTIONS(4422),
    [anon_sym_STAR] = ACTIONS(4424),
    [anon_sym_SLASH] = ACTIONS(4422),
    [anon_sym_PERCENT] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4424),
    [anon_sym_PIPE] = ACTIONS(4422),
    [anon_sym_AMP] = ACTIONS(4422),
    [anon_sym_LT_LT] = ACTIONS(4424),
    [anon_sym_GT_GT] = ACTIONS(4422),
    [anon_sym_GT_GT_GT] = ACTIONS(4424),
    [anon_sym_EQ_EQ] = ACTIONS(4424),
    [anon_sym_BANG_EQ] = ACTIONS(4424),
    [anon_sym_GT_EQ] = ACTIONS(4424),
    [anon_sym_LT_EQ] = ACTIONS(4424),
    [anon_sym_DOT] = ACTIONS(4422),
    [anon_sym_scoped] = ACTIONS(4422),
    [anon_sym_var] = ACTIONS(4422),
    [anon_sym_yield] = ACTIONS(4422),
    [anon_sym_switch] = ACTIONS(4422),
    [anon_sym_when] = ACTIONS(4422),
    [sym_discard] = ACTIONS(4422),
    [anon_sym_DOT_DOT] = ACTIONS(4424),
    [anon_sym_and] = ACTIONS(4422),
    [anon_sym_or] = ACTIONS(4422),
    [anon_sym_AMP_AMP] = ACTIONS(4424),
    [anon_sym_PIPE_PIPE] = ACTIONS(4424),
    [anon_sym_QMARK_QMARK] = ACTIONS(4424),
    [anon_sym_from] = ACTIONS(4422),
    [anon_sym_into] = ACTIONS(4422),
    [anon_sym_join] = ACTIONS(4422),
    [anon_sym_on] = ACTIONS(4422),
    [anon_sym_equals] = ACTIONS(4422),
    [anon_sym_let] = ACTIONS(4422),
    [anon_sym_orderby] = ACTIONS(4422),
    [anon_sym_ascending] = ACTIONS(4422),
    [anon_sym_descending] = ACTIONS(4422),
    [anon_sym_group] = ACTIONS(4422),
    [anon_sym_by] = ACTIONS(4422),
    [anon_sym_select] = ACTIONS(4422),
    [anon_sym_as] = ACTIONS(4422),
    [anon_sym_is] = ACTIONS(4422),
    [anon_sym_DASH_GT] = ACTIONS(4424),
    [anon_sym_with] = ACTIONS(4422),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4424),
  },
  [3404] = {
    [sym_preproc_region] = STATE(3404),
    [sym_preproc_endregion] = STATE(3404),
    [sym_preproc_line] = STATE(3404),
    [sym_preproc_pragma] = STATE(3404),
    [sym_preproc_nullable] = STATE(3404),
    [sym_preproc_error] = STATE(3404),
    [sym_preproc_define] = STATE(3404),
    [sym_preproc_undef] = STATE(3404),
    [anon_sym_SEMI] = ACTIONS(4076),
    [anon_sym_EQ] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4076),
    [anon_sym_COLON] = ACTIONS(4076),
    [anon_sym_COMMA] = ACTIONS(4076),
    [anon_sym_RBRACK] = ACTIONS(4076),
    [anon_sym_LPAREN] = ACTIONS(4076),
    [anon_sym_RPAREN] = ACTIONS(4076),
    [anon_sym_RBRACE] = ACTIONS(4076),
    [anon_sym_LT] = ACTIONS(4074),
    [anon_sym_GT] = ACTIONS(4074),
    [anon_sym_in] = ACTIONS(4076),
    [anon_sym_QMARK] = ACTIONS(4074),
    [anon_sym_BANG] = ACTIONS(4074),
    [anon_sym_PLUS_PLUS] = ACTIONS(4076),
    [anon_sym_DASH_DASH] = ACTIONS(4076),
    [anon_sym_PLUS] = ACTIONS(4074),
    [anon_sym_DASH] = ACTIONS(4074),
    [anon_sym_STAR] = ACTIONS(4074),
    [anon_sym_SLASH] = ACTIONS(4074),
    [anon_sym_PERCENT] = ACTIONS(4074),
    [anon_sym_CARET] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(4074),
    [anon_sym_AMP] = ACTIONS(4074),
    [anon_sym_LT_LT] = ACTIONS(4074),
    [anon_sym_GT_GT] = ACTIONS(4074),
    [anon_sym_GT_GT_GT] = ACTIONS(4074),
    [anon_sym_EQ_EQ] = ACTIONS(4076),
    [anon_sym_BANG_EQ] = ACTIONS(4076),
    [anon_sym_GT_EQ] = ACTIONS(4076),
    [anon_sym_LT_EQ] = ACTIONS(4076),
    [anon_sym_DOT] = ACTIONS(4074),
    [anon_sym_EQ_GT] = ACTIONS(4076),
    [anon_sym_switch] = ACTIONS(4076),
    [anon_sym_when] = ACTIONS(4076),
    [anon_sym_DOT_DOT] = ACTIONS(4076),
    [anon_sym_and] = ACTIONS(4076),
    [anon_sym_or] = ACTIONS(4076),
    [anon_sym_PLUS_EQ] = ACTIONS(4076),
    [anon_sym_DASH_EQ] = ACTIONS(4076),
    [anon_sym_STAR_EQ] = ACTIONS(4076),
    [anon_sym_SLASH_EQ] = ACTIONS(4076),
    [anon_sym_PERCENT_EQ] = ACTIONS(4076),
    [anon_sym_AMP_EQ] = ACTIONS(4076),
    [anon_sym_CARET_EQ] = ACTIONS(4076),
    [anon_sym_PIPE_EQ] = ACTIONS(4076),
    [anon_sym_LT_LT_EQ] = ACTIONS(4076),
    [anon_sym_GT_GT_EQ] = ACTIONS(4076),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4076),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4076),
    [anon_sym_AMP_AMP] = ACTIONS(4076),
    [anon_sym_PIPE_PIPE] = ACTIONS(4076),
    [anon_sym_QMARK_QMARK] = ACTIONS(4074),
    [anon_sym_on] = ACTIONS(4076),
    [anon_sym_equals] = ACTIONS(4076),
    [anon_sym_by] = ACTIONS(4076),
    [anon_sym_as] = ACTIONS(4076),
    [anon_sym_is] = ACTIONS(4076),
    [anon_sym_DASH_GT] = ACTIONS(4076),
    [anon_sym_with] = ACTIONS(4076),
    [aux_sym_preproc_if_token3] = ACTIONS(4076),
    [aux_sym_preproc_else_token1] = ACTIONS(4076),
    [aux_sym_preproc_elif_token1] = ACTIONS(4076),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3405] = {
    [sym__variable_designation] = STATE(4025),
    [sym_parenthesized_variable_designation] = STATE(4015),
    [sym_identifier] = STATE(4020),
    [sym__reserved_identifier] = STATE(3908),
    [sym_preproc_region] = STATE(3405),
    [sym_preproc_endregion] = STATE(3405),
    [sym_preproc_line] = STATE(3405),
    [sym_preproc_pragma] = STATE(3405),
    [sym_preproc_nullable] = STATE(3405),
    [sym_preproc_error] = STATE(3405),
    [sym_preproc_define] = STATE(3405),
    [sym_preproc_undef] = STATE(3405),
    [sym__identifier_token] = ACTIONS(4271),
    [anon_sym_alias] = ACTIONS(4273),
    [anon_sym_global] = ACTIONS(4273),
    [anon_sym_LBRACK] = ACTIONS(4329),
    [anon_sym_LPAREN] = ACTIONS(4329),
    [anon_sym_file] = ACTIONS(4273),
    [anon_sym_LT] = ACTIONS(4331),
    [anon_sym_GT] = ACTIONS(4331),
    [anon_sym_where] = ACTIONS(4273),
    [anon_sym_QMARK] = ACTIONS(4331),
    [anon_sym_notnull] = ACTIONS(4273),
    [anon_sym_unmanaged] = ACTIONS(4273),
    [anon_sym_BANG] = ACTIONS(4331),
    [anon_sym_PLUS_PLUS] = ACTIONS(4329),
    [anon_sym_DASH_DASH] = ACTIONS(4329),
    [anon_sym_PLUS] = ACTIONS(4331),
    [anon_sym_DASH] = ACTIONS(4331),
    [anon_sym_STAR] = ACTIONS(4329),
    [anon_sym_SLASH] = ACTIONS(4331),
    [anon_sym_PERCENT] = ACTIONS(4329),
    [anon_sym_CARET] = ACTIONS(4329),
    [anon_sym_PIPE] = ACTIONS(4331),
    [anon_sym_AMP] = ACTIONS(4331),
    [anon_sym_LT_LT] = ACTIONS(4329),
    [anon_sym_GT_GT] = ACTIONS(4331),
    [anon_sym_GT_GT_GT] = ACTIONS(4329),
    [anon_sym_EQ_EQ] = ACTIONS(4329),
    [anon_sym_BANG_EQ] = ACTIONS(4329),
    [anon_sym_GT_EQ] = ACTIONS(4329),
    [anon_sym_LT_EQ] = ACTIONS(4329),
    [anon_sym_DOT] = ACTIONS(4331),
    [anon_sym_scoped] = ACTIONS(4273),
    [anon_sym_var] = ACTIONS(4273),
    [anon_sym_yield] = ACTIONS(4273),
    [anon_sym_switch] = ACTIONS(4331),
    [anon_sym_when] = ACTIONS(4273),
    [sym_discard] = ACTIONS(4281),
    [anon_sym_DOT_DOT] = ACTIONS(4329),
    [anon_sym_and] = ACTIONS(4331),
    [anon_sym_or] = ACTIONS(4331),
    [anon_sym_AMP_AMP] = ACTIONS(4329),
    [anon_sym_PIPE_PIPE] = ACTIONS(4329),
    [anon_sym_QMARK_QMARK] = ACTIONS(4329),
    [anon_sym_from] = ACTIONS(4273),
    [anon_sym_into] = ACTIONS(4331),
    [anon_sym_join] = ACTIONS(4273),
    [anon_sym_on] = ACTIONS(4273),
    [anon_sym_equals] = ACTIONS(4273),
    [anon_sym_let] = ACTIONS(4273),
    [anon_sym_orderby] = ACTIONS(4273),
    [anon_sym_ascending] = ACTIONS(4273),
    [anon_sym_descending] = ACTIONS(4273),
    [anon_sym_group] = ACTIONS(4273),
    [anon_sym_by] = ACTIONS(4331),
    [anon_sym_select] = ACTIONS(4273),
    [anon_sym_as] = ACTIONS(4331),
    [anon_sym_is] = ACTIONS(4331),
    [anon_sym_DASH_GT] = ACTIONS(4329),
    [anon_sym_with] = ACTIONS(4331),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3406] = {
    [sym_preproc_region] = STATE(3406),
    [sym_preproc_endregion] = STATE(3406),
    [sym_preproc_line] = STATE(3406),
    [sym_preproc_pragma] = STATE(3406),
    [sym_preproc_nullable] = STATE(3406),
    [sym_preproc_error] = STATE(3406),
    [sym_preproc_define] = STATE(3406),
    [sym_preproc_undef] = STATE(3406),
    [sym__identifier_token] = ACTIONS(3697),
    [anon_sym_extern] = ACTIONS(3697),
    [anon_sym_alias] = ACTIONS(3697),
    [anon_sym_global] = ACTIONS(3697),
    [anon_sym_using] = ACTIONS(3697),
    [anon_sym_unsafe] = ACTIONS(3697),
    [anon_sym_static] = ACTIONS(3697),
    [anon_sym_LBRACK] = ACTIONS(3699),
    [anon_sym_LPAREN] = ACTIONS(3699),
    [anon_sym_event] = ACTIONS(3697),
    [anon_sym_namespace] = ACTIONS(3697),
    [anon_sym_class] = ACTIONS(3697),
    [anon_sym_ref] = ACTIONS(3697),
    [anon_sym_struct] = ACTIONS(3697),
    [anon_sym_enum] = ACTIONS(3697),
    [anon_sym_RBRACE] = ACTIONS(3699),
    [anon_sym_interface] = ACTIONS(3697),
    [anon_sym_delegate] = ACTIONS(3697),
    [anon_sym_record] = ACTIONS(3697),
    [anon_sym_abstract] = ACTIONS(3697),
    [anon_sym_async] = ACTIONS(3697),
    [anon_sym_const] = ACTIONS(3697),
    [anon_sym_file] = ACTIONS(3697),
    [anon_sym_fixed] = ACTIONS(3697),
    [anon_sym_internal] = ACTIONS(3697),
    [anon_sym_new] = ACTIONS(3697),
    [anon_sym_override] = ACTIONS(3697),
    [anon_sym_partial] = ACTIONS(3697),
    [anon_sym_private] = ACTIONS(3697),
    [anon_sym_protected] = ACTIONS(3697),
    [anon_sym_public] = ACTIONS(3697),
    [anon_sym_readonly] = ACTIONS(3697),
    [anon_sym_required] = ACTIONS(3697),
    [anon_sym_sealed] = ACTIONS(3697),
    [anon_sym_virtual] = ACTIONS(3697),
    [anon_sym_volatile] = ACTIONS(3697),
    [anon_sym_where] = ACTIONS(3697),
    [anon_sym_notnull] = ACTIONS(3697),
    [anon_sym_unmanaged] = ACTIONS(3697),
    [anon_sym_TILDE] = ACTIONS(3699),
    [anon_sym_implicit] = ACTIONS(3697),
    [anon_sym_explicit] = ACTIONS(3697),
    [anon_sym_scoped] = ACTIONS(3697),
    [anon_sym_var] = ACTIONS(3697),
    [sym_predefined_type] = ACTIONS(3697),
    [anon_sym_yield] = ACTIONS(3697),
    [anon_sym_when] = ACTIONS(3697),
    [anon_sym_from] = ACTIONS(3697),
    [anon_sym_into] = ACTIONS(3697),
    [anon_sym_join] = ACTIONS(3697),
    [anon_sym_on] = ACTIONS(3697),
    [anon_sym_equals] = ACTIONS(3697),
    [anon_sym_let] = ACTIONS(3697),
    [anon_sym_orderby] = ACTIONS(3697),
    [anon_sym_ascending] = ACTIONS(3697),
    [anon_sym_descending] = ACTIONS(3697),
    [anon_sym_group] = ACTIONS(3697),
    [anon_sym_by] = ACTIONS(3697),
    [anon_sym_select] = ACTIONS(3697),
    [aux_sym_preproc_if_token1] = ACTIONS(3699),
    [aux_sym_preproc_if_token3] = ACTIONS(3699),
    [aux_sym_preproc_else_token1] = ACTIONS(3699),
    [aux_sym_preproc_elif_token1] = ACTIONS(3699),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3407] = {
    [sym_preproc_region] = STATE(3407),
    [sym_preproc_endregion] = STATE(3407),
    [sym_preproc_line] = STATE(3407),
    [sym_preproc_pragma] = STATE(3407),
    [sym_preproc_nullable] = STATE(3407),
    [sym_preproc_error] = STATE(3407),
    [sym_preproc_define] = STATE(3407),
    [sym_preproc_undef] = STATE(3407),
    [sym__identifier_token] = ACTIONS(5063),
    [anon_sym_extern] = ACTIONS(5063),
    [anon_sym_alias] = ACTIONS(5063),
    [anon_sym_global] = ACTIONS(5063),
    [anon_sym_using] = ACTIONS(5063),
    [anon_sym_unsafe] = ACTIONS(5063),
    [anon_sym_static] = ACTIONS(5063),
    [anon_sym_LBRACK] = ACTIONS(5065),
    [anon_sym_LPAREN] = ACTIONS(5065),
    [anon_sym_event] = ACTIONS(5063),
    [anon_sym_namespace] = ACTIONS(5063),
    [anon_sym_class] = ACTIONS(5063),
    [anon_sym_ref] = ACTIONS(5063),
    [anon_sym_struct] = ACTIONS(5063),
    [anon_sym_enum] = ACTIONS(5063),
    [anon_sym_RBRACE] = ACTIONS(5065),
    [anon_sym_interface] = ACTIONS(5063),
    [anon_sym_delegate] = ACTIONS(5063),
    [anon_sym_record] = ACTIONS(5063),
    [anon_sym_abstract] = ACTIONS(5063),
    [anon_sym_async] = ACTIONS(5063),
    [anon_sym_const] = ACTIONS(5063),
    [anon_sym_file] = ACTIONS(5063),
    [anon_sym_fixed] = ACTIONS(5063),
    [anon_sym_internal] = ACTIONS(5063),
    [anon_sym_new] = ACTIONS(5063),
    [anon_sym_override] = ACTIONS(5063),
    [anon_sym_partial] = ACTIONS(5063),
    [anon_sym_private] = ACTIONS(5063),
    [anon_sym_protected] = ACTIONS(5063),
    [anon_sym_public] = ACTIONS(5063),
    [anon_sym_readonly] = ACTIONS(5063),
    [anon_sym_required] = ACTIONS(5063),
    [anon_sym_sealed] = ACTIONS(5063),
    [anon_sym_virtual] = ACTIONS(5063),
    [anon_sym_volatile] = ACTIONS(5063),
    [anon_sym_where] = ACTIONS(5063),
    [anon_sym_notnull] = ACTIONS(5063),
    [anon_sym_unmanaged] = ACTIONS(5063),
    [anon_sym_TILDE] = ACTIONS(5065),
    [anon_sym_implicit] = ACTIONS(5063),
    [anon_sym_explicit] = ACTIONS(5063),
    [anon_sym_scoped] = ACTIONS(5063),
    [anon_sym_var] = ACTIONS(5063),
    [sym_predefined_type] = ACTIONS(5063),
    [anon_sym_yield] = ACTIONS(5063),
    [anon_sym_when] = ACTIONS(5063),
    [anon_sym_from] = ACTIONS(5063),
    [anon_sym_into] = ACTIONS(5063),
    [anon_sym_join] = ACTIONS(5063),
    [anon_sym_on] = ACTIONS(5063),
    [anon_sym_equals] = ACTIONS(5063),
    [anon_sym_let] = ACTIONS(5063),
    [anon_sym_orderby] = ACTIONS(5063),
    [anon_sym_ascending] = ACTIONS(5063),
    [anon_sym_descending] = ACTIONS(5063),
    [anon_sym_group] = ACTIONS(5063),
    [anon_sym_by] = ACTIONS(5063),
    [anon_sym_select] = ACTIONS(5063),
    [aux_sym_preproc_if_token1] = ACTIONS(5065),
    [aux_sym_preproc_if_token3] = ACTIONS(5065),
    [aux_sym_preproc_else_token1] = ACTIONS(5065),
    [aux_sym_preproc_elif_token1] = ACTIONS(5065),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3408] = {
    [sym_preproc_region] = STATE(3408),
    [sym_preproc_endregion] = STATE(3408),
    [sym_preproc_line] = STATE(3408),
    [sym_preproc_pragma] = STATE(3408),
    [sym_preproc_nullable] = STATE(3408),
    [sym_preproc_error] = STATE(3408),
    [sym_preproc_define] = STATE(3408),
    [sym_preproc_undef] = STATE(3408),
    [sym__identifier_token] = ACTIONS(3701),
    [anon_sym_extern] = ACTIONS(3701),
    [anon_sym_alias] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3701),
    [anon_sym_using] = ACTIONS(3701),
    [anon_sym_unsafe] = ACTIONS(3701),
    [anon_sym_static] = ACTIONS(3701),
    [anon_sym_LBRACK] = ACTIONS(3703),
    [anon_sym_LPAREN] = ACTIONS(3703),
    [anon_sym_event] = ACTIONS(3701),
    [anon_sym_namespace] = ACTIONS(3701),
    [anon_sym_class] = ACTIONS(3701),
    [anon_sym_ref] = ACTIONS(3701),
    [anon_sym_struct] = ACTIONS(3701),
    [anon_sym_enum] = ACTIONS(3701),
    [anon_sym_RBRACE] = ACTIONS(3703),
    [anon_sym_interface] = ACTIONS(3701),
    [anon_sym_delegate] = ACTIONS(3701),
    [anon_sym_record] = ACTIONS(3701),
    [anon_sym_abstract] = ACTIONS(3701),
    [anon_sym_async] = ACTIONS(3701),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_file] = ACTIONS(3701),
    [anon_sym_fixed] = ACTIONS(3701),
    [anon_sym_internal] = ACTIONS(3701),
    [anon_sym_new] = ACTIONS(3701),
    [anon_sym_override] = ACTIONS(3701),
    [anon_sym_partial] = ACTIONS(3701),
    [anon_sym_private] = ACTIONS(3701),
    [anon_sym_protected] = ACTIONS(3701),
    [anon_sym_public] = ACTIONS(3701),
    [anon_sym_readonly] = ACTIONS(3701),
    [anon_sym_required] = ACTIONS(3701),
    [anon_sym_sealed] = ACTIONS(3701),
    [anon_sym_virtual] = ACTIONS(3701),
    [anon_sym_volatile] = ACTIONS(3701),
    [anon_sym_where] = ACTIONS(3701),
    [anon_sym_notnull] = ACTIONS(3701),
    [anon_sym_unmanaged] = ACTIONS(3701),
    [anon_sym_TILDE] = ACTIONS(3703),
    [anon_sym_implicit] = ACTIONS(3701),
    [anon_sym_explicit] = ACTIONS(3701),
    [anon_sym_scoped] = ACTIONS(3701),
    [anon_sym_var] = ACTIONS(3701),
    [sym_predefined_type] = ACTIONS(3701),
    [anon_sym_yield] = ACTIONS(3701),
    [anon_sym_when] = ACTIONS(3701),
    [anon_sym_from] = ACTIONS(3701),
    [anon_sym_into] = ACTIONS(3701),
    [anon_sym_join] = ACTIONS(3701),
    [anon_sym_on] = ACTIONS(3701),
    [anon_sym_equals] = ACTIONS(3701),
    [anon_sym_let] = ACTIONS(3701),
    [anon_sym_orderby] = ACTIONS(3701),
    [anon_sym_ascending] = ACTIONS(3701),
    [anon_sym_descending] = ACTIONS(3701),
    [anon_sym_group] = ACTIONS(3701),
    [anon_sym_by] = ACTIONS(3701),
    [anon_sym_select] = ACTIONS(3701),
    [aux_sym_preproc_if_token1] = ACTIONS(3703),
    [aux_sym_preproc_if_token3] = ACTIONS(3703),
    [aux_sym_preproc_else_token1] = ACTIONS(3703),
    [aux_sym_preproc_elif_token1] = ACTIONS(3703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3409] = {
    [sym__variable_designation] = STATE(3965),
    [sym_parenthesized_variable_designation] = STATE(4015),
    [sym_identifier] = STATE(4020),
    [sym__reserved_identifier] = STATE(3908),
    [sym_preproc_region] = STATE(3409),
    [sym_preproc_endregion] = STATE(3409),
    [sym_preproc_line] = STATE(3409),
    [sym_preproc_pragma] = STATE(3409),
    [sym_preproc_nullable] = STATE(3409),
    [sym_preproc_error] = STATE(3409),
    [sym_preproc_define] = STATE(3409),
    [sym_preproc_undef] = STATE(3409),
    [sym__identifier_token] = ACTIONS(4271),
    [anon_sym_alias] = ACTIONS(4273),
    [anon_sym_global] = ACTIONS(4273),
    [anon_sym_LBRACK] = ACTIONS(4335),
    [anon_sym_LPAREN] = ACTIONS(4335),
    [anon_sym_file] = ACTIONS(4273),
    [anon_sym_LT] = ACTIONS(4337),
    [anon_sym_GT] = ACTIONS(4337),
    [anon_sym_where] = ACTIONS(4273),
    [anon_sym_QMARK] = ACTIONS(4337),
    [anon_sym_notnull] = ACTIONS(4273),
    [anon_sym_unmanaged] = ACTIONS(4273),
    [anon_sym_BANG] = ACTIONS(4337),
    [anon_sym_PLUS_PLUS] = ACTIONS(4335),
    [anon_sym_DASH_DASH] = ACTIONS(4335),
    [anon_sym_PLUS] = ACTIONS(4337),
    [anon_sym_DASH] = ACTIONS(4337),
    [anon_sym_STAR] = ACTIONS(4335),
    [anon_sym_SLASH] = ACTIONS(4337),
    [anon_sym_PERCENT] = ACTIONS(4335),
    [anon_sym_CARET] = ACTIONS(4335),
    [anon_sym_PIPE] = ACTIONS(4337),
    [anon_sym_AMP] = ACTIONS(4337),
    [anon_sym_LT_LT] = ACTIONS(4335),
    [anon_sym_GT_GT] = ACTIONS(4337),
    [anon_sym_GT_GT_GT] = ACTIONS(4335),
    [anon_sym_EQ_EQ] = ACTIONS(4335),
    [anon_sym_BANG_EQ] = ACTIONS(4335),
    [anon_sym_GT_EQ] = ACTIONS(4335),
    [anon_sym_LT_EQ] = ACTIONS(4335),
    [anon_sym_DOT] = ACTIONS(4337),
    [anon_sym_scoped] = ACTIONS(4273),
    [anon_sym_var] = ACTIONS(4273),
    [anon_sym_yield] = ACTIONS(4273),
    [anon_sym_switch] = ACTIONS(4337),
    [anon_sym_when] = ACTIONS(4273),
    [sym_discard] = ACTIONS(4281),
    [anon_sym_DOT_DOT] = ACTIONS(4335),
    [anon_sym_and] = ACTIONS(4337),
    [anon_sym_or] = ACTIONS(4337),
    [anon_sym_AMP_AMP] = ACTIONS(4335),
    [anon_sym_PIPE_PIPE] = ACTIONS(4335),
    [anon_sym_QMARK_QMARK] = ACTIONS(4335),
    [anon_sym_from] = ACTIONS(4273),
    [anon_sym_into] = ACTIONS(4337),
    [anon_sym_join] = ACTIONS(4273),
    [anon_sym_on] = ACTIONS(4273),
    [anon_sym_equals] = ACTIONS(4273),
    [anon_sym_let] = ACTIONS(4273),
    [anon_sym_orderby] = ACTIONS(4273),
    [anon_sym_ascending] = ACTIONS(4273),
    [anon_sym_descending] = ACTIONS(4273),
    [anon_sym_group] = ACTIONS(4273),
    [anon_sym_by] = ACTIONS(4337),
    [anon_sym_select] = ACTIONS(4273),
    [anon_sym_as] = ACTIONS(4337),
    [anon_sym_is] = ACTIONS(4337),
    [anon_sym_DASH_GT] = ACTIONS(4335),
    [anon_sym_with] = ACTIONS(4337),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3410] = {
    [sym__variable_designation] = STATE(4063),
    [sym_parenthesized_variable_designation] = STATE(4015),
    [sym_identifier] = STATE(4020),
    [sym__reserved_identifier] = STATE(3908),
    [sym_preproc_region] = STATE(3410),
    [sym_preproc_endregion] = STATE(3410),
    [sym_preproc_line] = STATE(3410),
    [sym_preproc_pragma] = STATE(3410),
    [sym_preproc_nullable] = STATE(3410),
    [sym_preproc_error] = STATE(3410),
    [sym_preproc_define] = STATE(3410),
    [sym_preproc_undef] = STATE(3410),
    [sym__identifier_token] = ACTIONS(4271),
    [anon_sym_alias] = ACTIONS(4273),
    [anon_sym_global] = ACTIONS(4273),
    [anon_sym_LBRACK] = ACTIONS(4373),
    [anon_sym_LPAREN] = ACTIONS(4373),
    [anon_sym_file] = ACTIONS(4273),
    [anon_sym_LT] = ACTIONS(4375),
    [anon_sym_GT] = ACTIONS(4375),
    [anon_sym_where] = ACTIONS(4273),
    [anon_sym_QMARK] = ACTIONS(4375),
    [anon_sym_notnull] = ACTIONS(4273),
    [anon_sym_unmanaged] = ACTIONS(4273),
    [anon_sym_BANG] = ACTIONS(4375),
    [anon_sym_PLUS_PLUS] = ACTIONS(4373),
    [anon_sym_DASH_DASH] = ACTIONS(4373),
    [anon_sym_PLUS] = ACTIONS(4375),
    [anon_sym_DASH] = ACTIONS(4375),
    [anon_sym_STAR] = ACTIONS(4373),
    [anon_sym_SLASH] = ACTIONS(4375),
    [anon_sym_PERCENT] = ACTIONS(4373),
    [anon_sym_CARET] = ACTIONS(4373),
    [anon_sym_PIPE] = ACTIONS(4375),
    [anon_sym_AMP] = ACTIONS(4375),
    [anon_sym_LT_LT] = ACTIONS(4373),
    [anon_sym_GT_GT] = ACTIONS(4375),
    [anon_sym_GT_GT_GT] = ACTIONS(4373),
    [anon_sym_EQ_EQ] = ACTIONS(4373),
    [anon_sym_BANG_EQ] = ACTIONS(4373),
    [anon_sym_GT_EQ] = ACTIONS(4373),
    [anon_sym_LT_EQ] = ACTIONS(4373),
    [anon_sym_DOT] = ACTIONS(4375),
    [anon_sym_scoped] = ACTIONS(4273),
    [anon_sym_var] = ACTIONS(4273),
    [anon_sym_yield] = ACTIONS(4273),
    [anon_sym_switch] = ACTIONS(4375),
    [anon_sym_when] = ACTIONS(4273),
    [sym_discard] = ACTIONS(4281),
    [anon_sym_DOT_DOT] = ACTIONS(4373),
    [anon_sym_and] = ACTIONS(4375),
    [anon_sym_or] = ACTIONS(4375),
    [anon_sym_AMP_AMP] = ACTIONS(4373),
    [anon_sym_PIPE_PIPE] = ACTIONS(4373),
    [anon_sym_QMARK_QMARK] = ACTIONS(4373),
    [anon_sym_from] = ACTIONS(4273),
    [anon_sym_into] = ACTIONS(4375),
    [anon_sym_join] = ACTIONS(4273),
    [anon_sym_on] = ACTIONS(4273),
    [anon_sym_equals] = ACTIONS(4273),
    [anon_sym_let] = ACTIONS(4273),
    [anon_sym_orderby] = ACTIONS(4273),
    [anon_sym_ascending] = ACTIONS(4273),
    [anon_sym_descending] = ACTIONS(4273),
    [anon_sym_group] = ACTIONS(4273),
    [anon_sym_by] = ACTIONS(4375),
    [anon_sym_select] = ACTIONS(4273),
    [anon_sym_as] = ACTIONS(4375),
    [anon_sym_is] = ACTIONS(4375),
    [anon_sym_DASH_GT] = ACTIONS(4373),
    [anon_sym_with] = ACTIONS(4375),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3411] = {
    [sym_preproc_region] = STATE(3411),
    [sym_preproc_endregion] = STATE(3411),
    [sym_preproc_line] = STATE(3411),
    [sym_preproc_pragma] = STATE(3411),
    [sym_preproc_nullable] = STATE(3411),
    [sym_preproc_error] = STATE(3411),
    [sym_preproc_define] = STATE(3411),
    [sym_preproc_undef] = STATE(3411),
    [sym__identifier_token] = ACTIONS(4422),
    [anon_sym_alias] = ACTIONS(4422),
    [anon_sym_global] = ACTIONS(4422),
    [anon_sym_LBRACK] = ACTIONS(4547),
    [anon_sym_COLON] = ACTIONS(4424),
    [anon_sym_COMMA] = ACTIONS(4424),
    [anon_sym_LPAREN] = ACTIONS(4424),
    [anon_sym_LBRACE] = ACTIONS(4424),
    [anon_sym_file] = ACTIONS(4422),
    [anon_sym_LT] = ACTIONS(4422),
    [anon_sym_GT] = ACTIONS(4422),
    [anon_sym_where] = ACTIONS(4422),
    [anon_sym_QMARK] = ACTIONS(4932),
    [anon_sym_notnull] = ACTIONS(4422),
    [anon_sym_unmanaged] = ACTIONS(4422),
    [anon_sym_BANG] = ACTIONS(4422),
    [anon_sym_PLUS_PLUS] = ACTIONS(4424),
    [anon_sym_DASH_DASH] = ACTIONS(4424),
    [anon_sym_PLUS] = ACTIONS(4422),
    [anon_sym_DASH] = ACTIONS(4422),
    [anon_sym_STAR] = ACTIONS(4553),
    [anon_sym_SLASH] = ACTIONS(4422),
    [anon_sym_PERCENT] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4424),
    [anon_sym_PIPE] = ACTIONS(4422),
    [anon_sym_AMP] = ACTIONS(4422),
    [anon_sym_LT_LT] = ACTIONS(4424),
    [anon_sym_GT_GT] = ACTIONS(4422),
    [anon_sym_GT_GT_GT] = ACTIONS(4424),
    [anon_sym_EQ_EQ] = ACTIONS(4424),
    [anon_sym_BANG_EQ] = ACTIONS(4424),
    [anon_sym_GT_EQ] = ACTIONS(4424),
    [anon_sym_LT_EQ] = ACTIONS(4424),
    [anon_sym_DOT] = ACTIONS(5067),
    [anon_sym_scoped] = ACTIONS(4422),
    [anon_sym_var] = ACTIONS(4422),
    [anon_sym_yield] = ACTIONS(4422),
    [anon_sym_switch] = ACTIONS(4422),
    [anon_sym_when] = ACTIONS(4422),
    [sym_discard] = ACTIONS(4422),
    [anon_sym_DOT_DOT] = ACTIONS(4424),
    [anon_sym_and] = ACTIONS(4422),
    [anon_sym_or] = ACTIONS(4422),
    [anon_sym_AMP_AMP] = ACTIONS(4424),
    [anon_sym_PIPE_PIPE] = ACTIONS(4424),
    [anon_sym_QMARK_QMARK] = ACTIONS(4424),
    [anon_sym_from] = ACTIONS(4422),
    [anon_sym_into] = ACTIONS(4422),
    [anon_sym_join] = ACTIONS(4422),
    [anon_sym_on] = ACTIONS(4422),
    [anon_sym_equals] = ACTIONS(4422),
    [anon_sym_let] = ACTIONS(4422),
    [anon_sym_orderby] = ACTIONS(4422),
    [anon_sym_ascending] = ACTIONS(4422),
    [anon_sym_descending] = ACTIONS(4422),
    [anon_sym_group] = ACTIONS(4422),
    [anon_sym_by] = ACTIONS(4422),
    [anon_sym_select] = ACTIONS(4422),
    [anon_sym_as] = ACTIONS(4422),
    [anon_sym_is] = ACTIONS(4422),
    [anon_sym_DASH_GT] = ACTIONS(4953),
    [anon_sym_with] = ACTIONS(4422),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4424),
  },
  [3412] = {
    [sym_preproc_region] = STATE(3412),
    [sym_preproc_endregion] = STATE(3412),
    [sym_preproc_line] = STATE(3412),
    [sym_preproc_pragma] = STATE(3412),
    [sym_preproc_nullable] = STATE(3412),
    [sym_preproc_error] = STATE(3412),
    [sym_preproc_define] = STATE(3412),
    [sym_preproc_undef] = STATE(3412),
    [sym__identifier_token] = ACTIONS(5069),
    [anon_sym_extern] = ACTIONS(5069),
    [anon_sym_alias] = ACTIONS(5069),
    [anon_sym_global] = ACTIONS(5069),
    [anon_sym_using] = ACTIONS(5069),
    [anon_sym_unsafe] = ACTIONS(5069),
    [anon_sym_static] = ACTIONS(5069),
    [anon_sym_LBRACK] = ACTIONS(5071),
    [anon_sym_LPAREN] = ACTIONS(5071),
    [anon_sym_event] = ACTIONS(5069),
    [anon_sym_namespace] = ACTIONS(5069),
    [anon_sym_class] = ACTIONS(5069),
    [anon_sym_ref] = ACTIONS(5069),
    [anon_sym_struct] = ACTIONS(5069),
    [anon_sym_enum] = ACTIONS(5069),
    [anon_sym_RBRACE] = ACTIONS(5071),
    [anon_sym_interface] = ACTIONS(5069),
    [anon_sym_delegate] = ACTIONS(5069),
    [anon_sym_record] = ACTIONS(5069),
    [anon_sym_abstract] = ACTIONS(5069),
    [anon_sym_async] = ACTIONS(5069),
    [anon_sym_const] = ACTIONS(5069),
    [anon_sym_file] = ACTIONS(5069),
    [anon_sym_fixed] = ACTIONS(5069),
    [anon_sym_internal] = ACTIONS(5069),
    [anon_sym_new] = ACTIONS(5069),
    [anon_sym_override] = ACTIONS(5069),
    [anon_sym_partial] = ACTIONS(5069),
    [anon_sym_private] = ACTIONS(5069),
    [anon_sym_protected] = ACTIONS(5069),
    [anon_sym_public] = ACTIONS(5069),
    [anon_sym_readonly] = ACTIONS(5069),
    [anon_sym_required] = ACTIONS(5069),
    [anon_sym_sealed] = ACTIONS(5069),
    [anon_sym_virtual] = ACTIONS(5069),
    [anon_sym_volatile] = ACTIONS(5069),
    [anon_sym_where] = ACTIONS(5069),
    [anon_sym_notnull] = ACTIONS(5069),
    [anon_sym_unmanaged] = ACTIONS(5069),
    [anon_sym_TILDE] = ACTIONS(5071),
    [anon_sym_implicit] = ACTIONS(5069),
    [anon_sym_explicit] = ACTIONS(5069),
    [anon_sym_scoped] = ACTIONS(5069),
    [anon_sym_var] = ACTIONS(5069),
    [sym_predefined_type] = ACTIONS(5069),
    [anon_sym_yield] = ACTIONS(5069),
    [anon_sym_when] = ACTIONS(5069),
    [anon_sym_from] = ACTIONS(5069),
    [anon_sym_into] = ACTIONS(5069),
    [anon_sym_join] = ACTIONS(5069),
    [anon_sym_on] = ACTIONS(5069),
    [anon_sym_equals] = ACTIONS(5069),
    [anon_sym_let] = ACTIONS(5069),
    [anon_sym_orderby] = ACTIONS(5069),
    [anon_sym_ascending] = ACTIONS(5069),
    [anon_sym_descending] = ACTIONS(5069),
    [anon_sym_group] = ACTIONS(5069),
    [anon_sym_by] = ACTIONS(5069),
    [anon_sym_select] = ACTIONS(5069),
    [aux_sym_preproc_if_token1] = ACTIONS(5071),
    [aux_sym_preproc_if_token3] = ACTIONS(5071),
    [aux_sym_preproc_else_token1] = ACTIONS(5071),
    [aux_sym_preproc_elif_token1] = ACTIONS(5071),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3413] = {
    [sym_preproc_region] = STATE(3413),
    [sym_preproc_endregion] = STATE(3413),
    [sym_preproc_line] = STATE(3413),
    [sym_preproc_pragma] = STATE(3413),
    [sym_preproc_nullable] = STATE(3413),
    [sym_preproc_error] = STATE(3413),
    [sym_preproc_define] = STATE(3413),
    [sym_preproc_undef] = STATE(3413),
    [sym__identifier_token] = ACTIONS(5073),
    [anon_sym_extern] = ACTIONS(5073),
    [anon_sym_alias] = ACTIONS(5073),
    [anon_sym_global] = ACTIONS(5073),
    [anon_sym_using] = ACTIONS(5073),
    [anon_sym_unsafe] = ACTIONS(5073),
    [anon_sym_static] = ACTIONS(5073),
    [anon_sym_LBRACK] = ACTIONS(5075),
    [anon_sym_LPAREN] = ACTIONS(5075),
    [anon_sym_event] = ACTIONS(5073),
    [anon_sym_namespace] = ACTIONS(5073),
    [anon_sym_class] = ACTIONS(5073),
    [anon_sym_ref] = ACTIONS(5073),
    [anon_sym_struct] = ACTIONS(5073),
    [anon_sym_enum] = ACTIONS(5073),
    [anon_sym_RBRACE] = ACTIONS(5075),
    [anon_sym_interface] = ACTIONS(5073),
    [anon_sym_delegate] = ACTIONS(5073),
    [anon_sym_record] = ACTIONS(5073),
    [anon_sym_abstract] = ACTIONS(5073),
    [anon_sym_async] = ACTIONS(5073),
    [anon_sym_const] = ACTIONS(5073),
    [anon_sym_file] = ACTIONS(5073),
    [anon_sym_fixed] = ACTIONS(5073),
    [anon_sym_internal] = ACTIONS(5073),
    [anon_sym_new] = ACTIONS(5073),
    [anon_sym_override] = ACTIONS(5073),
    [anon_sym_partial] = ACTIONS(5073),
    [anon_sym_private] = ACTIONS(5073),
    [anon_sym_protected] = ACTIONS(5073),
    [anon_sym_public] = ACTIONS(5073),
    [anon_sym_readonly] = ACTIONS(5073),
    [anon_sym_required] = ACTIONS(5073),
    [anon_sym_sealed] = ACTIONS(5073),
    [anon_sym_virtual] = ACTIONS(5073),
    [anon_sym_volatile] = ACTIONS(5073),
    [anon_sym_where] = ACTIONS(5073),
    [anon_sym_notnull] = ACTIONS(5073),
    [anon_sym_unmanaged] = ACTIONS(5073),
    [anon_sym_TILDE] = ACTIONS(5075),
    [anon_sym_implicit] = ACTIONS(5073),
    [anon_sym_explicit] = ACTIONS(5073),
    [anon_sym_scoped] = ACTIONS(5073),
    [anon_sym_var] = ACTIONS(5073),
    [sym_predefined_type] = ACTIONS(5073),
    [anon_sym_yield] = ACTIONS(5073),
    [anon_sym_when] = ACTIONS(5073),
    [anon_sym_from] = ACTIONS(5073),
    [anon_sym_into] = ACTIONS(5073),
    [anon_sym_join] = ACTIONS(5073),
    [anon_sym_on] = ACTIONS(5073),
    [anon_sym_equals] = ACTIONS(5073),
    [anon_sym_let] = ACTIONS(5073),
    [anon_sym_orderby] = ACTIONS(5073),
    [anon_sym_ascending] = ACTIONS(5073),
    [anon_sym_descending] = ACTIONS(5073),
    [anon_sym_group] = ACTIONS(5073),
    [anon_sym_by] = ACTIONS(5073),
    [anon_sym_select] = ACTIONS(5073),
    [aux_sym_preproc_if_token1] = ACTIONS(5075),
    [aux_sym_preproc_if_token3] = ACTIONS(5075),
    [aux_sym_preproc_else_token1] = ACTIONS(5075),
    [aux_sym_preproc_elif_token1] = ACTIONS(5075),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3414] = {
    [sym_preproc_region] = STATE(3414),
    [sym_preproc_endregion] = STATE(3414),
    [sym_preproc_line] = STATE(3414),
    [sym_preproc_pragma] = STATE(3414),
    [sym_preproc_nullable] = STATE(3414),
    [sym_preproc_error] = STATE(3414),
    [sym_preproc_define] = STATE(3414),
    [sym_preproc_undef] = STATE(3414),
    [sym__identifier_token] = ACTIONS(3973),
    [anon_sym_extern] = ACTIONS(3976),
    [anon_sym_alias] = ACTIONS(3973),
    [anon_sym_global] = ACTIONS(3973),
    [anon_sym_unsafe] = ACTIONS(3976),
    [anon_sym_static] = ACTIONS(3976),
    [anon_sym_LBRACK] = ACTIONS(3719),
    [anon_sym_LPAREN] = ACTIONS(3978),
    [anon_sym_event] = ACTIONS(3976),
    [anon_sym_class] = ACTIONS(3976),
    [anon_sym_ref] = ACTIONS(3976),
    [anon_sym_struct] = ACTIONS(3976),
    [anon_sym_enum] = ACTIONS(3976),
    [anon_sym_interface] = ACTIONS(3976),
    [anon_sym_delegate] = ACTIONS(3976),
    [anon_sym_record] = ACTIONS(3976),
    [anon_sym_abstract] = ACTIONS(3976),
    [anon_sym_async] = ACTIONS(3976),
    [anon_sym_const] = ACTIONS(3976),
    [anon_sym_file] = ACTIONS(3973),
    [anon_sym_fixed] = ACTIONS(3976),
    [anon_sym_internal] = ACTIONS(3976),
    [anon_sym_new] = ACTIONS(3976),
    [anon_sym_override] = ACTIONS(3976),
    [anon_sym_partial] = ACTIONS(3976),
    [anon_sym_private] = ACTIONS(3976),
    [anon_sym_protected] = ACTIONS(3976),
    [anon_sym_public] = ACTIONS(3976),
    [anon_sym_readonly] = ACTIONS(3976),
    [anon_sym_required] = ACTIONS(3976),
    [anon_sym_sealed] = ACTIONS(3976),
    [anon_sym_virtual] = ACTIONS(3976),
    [anon_sym_volatile] = ACTIONS(3976),
    [anon_sym_LT] = ACTIONS(3719),
    [anon_sym_where] = ACTIONS(3973),
    [anon_sym_QMARK] = ACTIONS(3719),
    [anon_sym_notnull] = ACTIONS(3973),
    [anon_sym_unmanaged] = ACTIONS(3973),
    [anon_sym_operator] = ACTIONS(3721),
    [anon_sym_STAR] = ACTIONS(3719),
    [anon_sym_implicit] = ACTIONS(3976),
    [anon_sym_explicit] = ACTIONS(3976),
    [anon_sym_this] = ACTIONS(3721),
    [anon_sym_DOT] = ACTIONS(3719),
    [anon_sym_scoped] = ACTIONS(3973),
    [anon_sym_EQ_GT] = ACTIONS(3719),
    [anon_sym_COLON_COLON] = ACTIONS(3719),
    [anon_sym_var] = ACTIONS(3973),
    [sym_predefined_type] = ACTIONS(3976),
    [anon_sym_yield] = ACTIONS(3973),
    [anon_sym_when] = ACTIONS(3973),
    [anon_sym_from] = ACTIONS(3973),
    [anon_sym_into] = ACTIONS(3973),
    [anon_sym_join] = ACTIONS(3973),
    [anon_sym_on] = ACTIONS(3973),
    [anon_sym_equals] = ACTIONS(3973),
    [anon_sym_let] = ACTIONS(3973),
    [anon_sym_orderby] = ACTIONS(3973),
    [anon_sym_ascending] = ACTIONS(3973),
    [anon_sym_descending] = ACTIONS(3973),
    [anon_sym_group] = ACTIONS(3973),
    [anon_sym_by] = ACTIONS(3973),
    [anon_sym_select] = ACTIONS(3973),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3415] = {
    [sym_preproc_region] = STATE(3415),
    [sym_preproc_endregion] = STATE(3415),
    [sym_preproc_line] = STATE(3415),
    [sym_preproc_pragma] = STATE(3415),
    [sym_preproc_nullable] = STATE(3415),
    [sym_preproc_error] = STATE(3415),
    [sym_preproc_define] = STATE(3415),
    [sym_preproc_undef] = STATE(3415),
    [sym__identifier_token] = ACTIONS(3705),
    [anon_sym_extern] = ACTIONS(3705),
    [anon_sym_alias] = ACTIONS(3705),
    [anon_sym_global] = ACTIONS(3705),
    [anon_sym_using] = ACTIONS(3705),
    [anon_sym_unsafe] = ACTIONS(3705),
    [anon_sym_static] = ACTIONS(3705),
    [anon_sym_LBRACK] = ACTIONS(3707),
    [anon_sym_LPAREN] = ACTIONS(3707),
    [anon_sym_event] = ACTIONS(3705),
    [anon_sym_namespace] = ACTIONS(3705),
    [anon_sym_class] = ACTIONS(3705),
    [anon_sym_ref] = ACTIONS(3705),
    [anon_sym_struct] = ACTIONS(3705),
    [anon_sym_enum] = ACTIONS(3705),
    [anon_sym_RBRACE] = ACTIONS(3707),
    [anon_sym_interface] = ACTIONS(3705),
    [anon_sym_delegate] = ACTIONS(3705),
    [anon_sym_record] = ACTIONS(3705),
    [anon_sym_abstract] = ACTIONS(3705),
    [anon_sym_async] = ACTIONS(3705),
    [anon_sym_const] = ACTIONS(3705),
    [anon_sym_file] = ACTIONS(3705),
    [anon_sym_fixed] = ACTIONS(3705),
    [anon_sym_internal] = ACTIONS(3705),
    [anon_sym_new] = ACTIONS(3705),
    [anon_sym_override] = ACTIONS(3705),
    [anon_sym_partial] = ACTIONS(3705),
    [anon_sym_private] = ACTIONS(3705),
    [anon_sym_protected] = ACTIONS(3705),
    [anon_sym_public] = ACTIONS(3705),
    [anon_sym_readonly] = ACTIONS(3705),
    [anon_sym_required] = ACTIONS(3705),
    [anon_sym_sealed] = ACTIONS(3705),
    [anon_sym_virtual] = ACTIONS(3705),
    [anon_sym_volatile] = ACTIONS(3705),
    [anon_sym_where] = ACTIONS(3705),
    [anon_sym_notnull] = ACTIONS(3705),
    [anon_sym_unmanaged] = ACTIONS(3705),
    [anon_sym_TILDE] = ACTIONS(3707),
    [anon_sym_implicit] = ACTIONS(3705),
    [anon_sym_explicit] = ACTIONS(3705),
    [anon_sym_scoped] = ACTIONS(3705),
    [anon_sym_var] = ACTIONS(3705),
    [sym_predefined_type] = ACTIONS(3705),
    [anon_sym_yield] = ACTIONS(3705),
    [anon_sym_when] = ACTIONS(3705),
    [anon_sym_from] = ACTIONS(3705),
    [anon_sym_into] = ACTIONS(3705),
    [anon_sym_join] = ACTIONS(3705),
    [anon_sym_on] = ACTIONS(3705),
    [anon_sym_equals] = ACTIONS(3705),
    [anon_sym_let] = ACTIONS(3705),
    [anon_sym_orderby] = ACTIONS(3705),
    [anon_sym_ascending] = ACTIONS(3705),
    [anon_sym_descending] = ACTIONS(3705),
    [anon_sym_group] = ACTIONS(3705),
    [anon_sym_by] = ACTIONS(3705),
    [anon_sym_select] = ACTIONS(3705),
    [aux_sym_preproc_if_token1] = ACTIONS(3707),
    [aux_sym_preproc_if_token3] = ACTIONS(3707),
    [aux_sym_preproc_else_token1] = ACTIONS(3707),
    [aux_sym_preproc_elif_token1] = ACTIONS(3707),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3416] = {
    [sym_preproc_region] = STATE(3416),
    [sym_preproc_endregion] = STATE(3416),
    [sym_preproc_line] = STATE(3416),
    [sym_preproc_pragma] = STATE(3416),
    [sym_preproc_nullable] = STATE(3416),
    [sym_preproc_error] = STATE(3416),
    [sym_preproc_define] = STATE(3416),
    [sym_preproc_undef] = STATE(3416),
    [sym__identifier_token] = ACTIONS(3812),
    [anon_sym_extern] = ACTIONS(3812),
    [anon_sym_alias] = ACTIONS(3812),
    [anon_sym_global] = ACTIONS(3812),
    [anon_sym_using] = ACTIONS(3812),
    [anon_sym_unsafe] = ACTIONS(3812),
    [anon_sym_static] = ACTIONS(3812),
    [anon_sym_LBRACK] = ACTIONS(3814),
    [anon_sym_LPAREN] = ACTIONS(3814),
    [anon_sym_event] = ACTIONS(3812),
    [anon_sym_namespace] = ACTIONS(3812),
    [anon_sym_class] = ACTIONS(3812),
    [anon_sym_ref] = ACTIONS(3812),
    [anon_sym_struct] = ACTIONS(3812),
    [anon_sym_enum] = ACTIONS(3812),
    [anon_sym_RBRACE] = ACTIONS(3814),
    [anon_sym_interface] = ACTIONS(3812),
    [anon_sym_delegate] = ACTIONS(3812),
    [anon_sym_record] = ACTIONS(3812),
    [anon_sym_abstract] = ACTIONS(3812),
    [anon_sym_async] = ACTIONS(3812),
    [anon_sym_const] = ACTIONS(3812),
    [anon_sym_file] = ACTIONS(3812),
    [anon_sym_fixed] = ACTIONS(3812),
    [anon_sym_internal] = ACTIONS(3812),
    [anon_sym_new] = ACTIONS(3812),
    [anon_sym_override] = ACTIONS(3812),
    [anon_sym_partial] = ACTIONS(3812),
    [anon_sym_private] = ACTIONS(3812),
    [anon_sym_protected] = ACTIONS(3812),
    [anon_sym_public] = ACTIONS(3812),
    [anon_sym_readonly] = ACTIONS(3812),
    [anon_sym_required] = ACTIONS(3812),
    [anon_sym_sealed] = ACTIONS(3812),
    [anon_sym_virtual] = ACTIONS(3812),
    [anon_sym_volatile] = ACTIONS(3812),
    [anon_sym_where] = ACTIONS(3812),
    [anon_sym_notnull] = ACTIONS(3812),
    [anon_sym_unmanaged] = ACTIONS(3812),
    [anon_sym_TILDE] = ACTIONS(3814),
    [anon_sym_implicit] = ACTIONS(3812),
    [anon_sym_explicit] = ACTIONS(3812),
    [anon_sym_scoped] = ACTIONS(3812),
    [anon_sym_var] = ACTIONS(3812),
    [sym_predefined_type] = ACTIONS(3812),
    [anon_sym_yield] = ACTIONS(3812),
    [anon_sym_when] = ACTIONS(3812),
    [anon_sym_from] = ACTIONS(3812),
    [anon_sym_into] = ACTIONS(3812),
    [anon_sym_join] = ACTIONS(3812),
    [anon_sym_on] = ACTIONS(3812),
    [anon_sym_equals] = ACTIONS(3812),
    [anon_sym_let] = ACTIONS(3812),
    [anon_sym_orderby] = ACTIONS(3812),
    [anon_sym_ascending] = ACTIONS(3812),
    [anon_sym_descending] = ACTIONS(3812),
    [anon_sym_group] = ACTIONS(3812),
    [anon_sym_by] = ACTIONS(3812),
    [anon_sym_select] = ACTIONS(3812),
    [aux_sym_preproc_if_token1] = ACTIONS(3814),
    [aux_sym_preproc_if_token3] = ACTIONS(3814),
    [aux_sym_preproc_else_token1] = ACTIONS(3814),
    [aux_sym_preproc_elif_token1] = ACTIONS(3814),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3417] = {
    [sym_preproc_region] = STATE(3417),
    [sym_preproc_endregion] = STATE(3417),
    [sym_preproc_line] = STATE(3417),
    [sym_preproc_pragma] = STATE(3417),
    [sym_preproc_nullable] = STATE(3417),
    [sym_preproc_error] = STATE(3417),
    [sym_preproc_define] = STATE(3417),
    [sym_preproc_undef] = STATE(3417),
    [sym__identifier_token] = ACTIONS(3800),
    [anon_sym_extern] = ACTIONS(3800),
    [anon_sym_alias] = ACTIONS(3800),
    [anon_sym_global] = ACTIONS(3800),
    [anon_sym_using] = ACTIONS(3800),
    [anon_sym_unsafe] = ACTIONS(3800),
    [anon_sym_static] = ACTIONS(3800),
    [anon_sym_LBRACK] = ACTIONS(3802),
    [anon_sym_LPAREN] = ACTIONS(3802),
    [anon_sym_event] = ACTIONS(3800),
    [anon_sym_namespace] = ACTIONS(3800),
    [anon_sym_class] = ACTIONS(3800),
    [anon_sym_ref] = ACTIONS(3800),
    [anon_sym_struct] = ACTIONS(3800),
    [anon_sym_enum] = ACTIONS(3800),
    [anon_sym_RBRACE] = ACTIONS(3802),
    [anon_sym_interface] = ACTIONS(3800),
    [anon_sym_delegate] = ACTIONS(3800),
    [anon_sym_record] = ACTIONS(3800),
    [anon_sym_abstract] = ACTIONS(3800),
    [anon_sym_async] = ACTIONS(3800),
    [anon_sym_const] = ACTIONS(3800),
    [anon_sym_file] = ACTIONS(3800),
    [anon_sym_fixed] = ACTIONS(3800),
    [anon_sym_internal] = ACTIONS(3800),
    [anon_sym_new] = ACTIONS(3800),
    [anon_sym_override] = ACTIONS(3800),
    [anon_sym_partial] = ACTIONS(3800),
    [anon_sym_private] = ACTIONS(3800),
    [anon_sym_protected] = ACTIONS(3800),
    [anon_sym_public] = ACTIONS(3800),
    [anon_sym_readonly] = ACTIONS(3800),
    [anon_sym_required] = ACTIONS(3800),
    [anon_sym_sealed] = ACTIONS(3800),
    [anon_sym_virtual] = ACTIONS(3800),
    [anon_sym_volatile] = ACTIONS(3800),
    [anon_sym_where] = ACTIONS(3800),
    [anon_sym_notnull] = ACTIONS(3800),
    [anon_sym_unmanaged] = ACTIONS(3800),
    [anon_sym_TILDE] = ACTIONS(3802),
    [anon_sym_implicit] = ACTIONS(3800),
    [anon_sym_explicit] = ACTIONS(3800),
    [anon_sym_scoped] = ACTIONS(3800),
    [anon_sym_var] = ACTIONS(3800),
    [sym_predefined_type] = ACTIONS(3800),
    [anon_sym_yield] = ACTIONS(3800),
    [anon_sym_when] = ACTIONS(3800),
    [anon_sym_from] = ACTIONS(3800),
    [anon_sym_into] = ACTIONS(3800),
    [anon_sym_join] = ACTIONS(3800),
    [anon_sym_on] = ACTIONS(3800),
    [anon_sym_equals] = ACTIONS(3800),
    [anon_sym_let] = ACTIONS(3800),
    [anon_sym_orderby] = ACTIONS(3800),
    [anon_sym_ascending] = ACTIONS(3800),
    [anon_sym_descending] = ACTIONS(3800),
    [anon_sym_group] = ACTIONS(3800),
    [anon_sym_by] = ACTIONS(3800),
    [anon_sym_select] = ACTIONS(3800),
    [aux_sym_preproc_if_token1] = ACTIONS(3802),
    [aux_sym_preproc_if_token3] = ACTIONS(3802),
    [aux_sym_preproc_else_token1] = ACTIONS(3802),
    [aux_sym_preproc_elif_token1] = ACTIONS(3802),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3418] = {
    [sym__variable_designation] = STATE(4035),
    [sym_parenthesized_variable_designation] = STATE(4015),
    [sym_identifier] = STATE(4020),
    [sym__reserved_identifier] = STATE(3908),
    [sym_preproc_region] = STATE(3418),
    [sym_preproc_endregion] = STATE(3418),
    [sym_preproc_line] = STATE(3418),
    [sym_preproc_pragma] = STATE(3418),
    [sym_preproc_nullable] = STATE(3418),
    [sym_preproc_error] = STATE(3418),
    [sym_preproc_define] = STATE(3418),
    [sym_preproc_undef] = STATE(3418),
    [sym__identifier_token] = ACTIONS(4271),
    [anon_sym_alias] = ACTIONS(4273),
    [anon_sym_global] = ACTIONS(4273),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_LPAREN] = ACTIONS(4383),
    [anon_sym_file] = ACTIONS(4273),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_where] = ACTIONS(4273),
    [anon_sym_QMARK] = ACTIONS(4385),
    [anon_sym_notnull] = ACTIONS(4273),
    [anon_sym_unmanaged] = ACTIONS(4273),
    [anon_sym_BANG] = ACTIONS(4385),
    [anon_sym_PLUS_PLUS] = ACTIONS(4383),
    [anon_sym_DASH_DASH] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_DASH] = ACTIONS(4385),
    [anon_sym_STAR] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4385),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4385),
    [anon_sym_GT_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4383),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_scoped] = ACTIONS(4273),
    [anon_sym_var] = ACTIONS(4273),
    [anon_sym_yield] = ACTIONS(4273),
    [anon_sym_switch] = ACTIONS(4385),
    [anon_sym_when] = ACTIONS(4273),
    [sym_discard] = ACTIONS(4281),
    [anon_sym_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4385),
    [anon_sym_or] = ACTIONS(4385),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_QMARK_QMARK] = ACTIONS(4383),
    [anon_sym_from] = ACTIONS(4273),
    [anon_sym_into] = ACTIONS(4385),
    [anon_sym_join] = ACTIONS(4273),
    [anon_sym_on] = ACTIONS(4273),
    [anon_sym_equals] = ACTIONS(4273),
    [anon_sym_let] = ACTIONS(4273),
    [anon_sym_orderby] = ACTIONS(4273),
    [anon_sym_ascending] = ACTIONS(4273),
    [anon_sym_descending] = ACTIONS(4273),
    [anon_sym_group] = ACTIONS(4273),
    [anon_sym_by] = ACTIONS(4385),
    [anon_sym_select] = ACTIONS(4273),
    [anon_sym_as] = ACTIONS(4385),
    [anon_sym_is] = ACTIONS(4385),
    [anon_sym_DASH_GT] = ACTIONS(4383),
    [anon_sym_with] = ACTIONS(4385),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3419] = {
    [sym_preproc_region] = STATE(3419),
    [sym_preproc_endregion] = STATE(3419),
    [sym_preproc_line] = STATE(3419),
    [sym_preproc_pragma] = STATE(3419),
    [sym_preproc_nullable] = STATE(3419),
    [sym_preproc_error] = STATE(3419),
    [sym_preproc_define] = STATE(3419),
    [sym_preproc_undef] = STATE(3419),
    [sym__identifier_token] = ACTIONS(4502),
    [anon_sym_alias] = ACTIONS(4502),
    [anon_sym_global] = ACTIONS(4502),
    [anon_sym_LBRACK] = ACTIONS(4504),
    [anon_sym_COLON] = ACTIONS(4504),
    [anon_sym_COMMA] = ACTIONS(4504),
    [anon_sym_LPAREN] = ACTIONS(4504),
    [anon_sym_LBRACE] = ACTIONS(4504),
    [anon_sym_file] = ACTIONS(4502),
    [anon_sym_LT] = ACTIONS(4502),
    [anon_sym_GT] = ACTIONS(4502),
    [anon_sym_where] = ACTIONS(4502),
    [anon_sym_QMARK] = ACTIONS(4502),
    [anon_sym_notnull] = ACTIONS(4502),
    [anon_sym_unmanaged] = ACTIONS(4502),
    [anon_sym_BANG] = ACTIONS(4502),
    [anon_sym_PLUS_PLUS] = ACTIONS(4504),
    [anon_sym_DASH_DASH] = ACTIONS(4504),
    [anon_sym_PLUS] = ACTIONS(4502),
    [anon_sym_DASH] = ACTIONS(4502),
    [anon_sym_STAR] = ACTIONS(4504),
    [anon_sym_SLASH] = ACTIONS(4502),
    [anon_sym_PERCENT] = ACTIONS(4504),
    [anon_sym_CARET] = ACTIONS(4504),
    [anon_sym_PIPE] = ACTIONS(4502),
    [anon_sym_AMP] = ACTIONS(4502),
    [anon_sym_LT_LT] = ACTIONS(4504),
    [anon_sym_GT_GT] = ACTIONS(4502),
    [anon_sym_GT_GT_GT] = ACTIONS(4504),
    [anon_sym_EQ_EQ] = ACTIONS(4504),
    [anon_sym_BANG_EQ] = ACTIONS(4504),
    [anon_sym_GT_EQ] = ACTIONS(4504),
    [anon_sym_LT_EQ] = ACTIONS(4504),
    [anon_sym_DOT] = ACTIONS(4502),
    [anon_sym_scoped] = ACTIONS(4502),
    [anon_sym_var] = ACTIONS(4502),
    [anon_sym_yield] = ACTIONS(4502),
    [anon_sym_switch] = ACTIONS(4502),
    [anon_sym_when] = ACTIONS(4502),
    [sym_discard] = ACTIONS(4502),
    [anon_sym_DOT_DOT] = ACTIONS(4504),
    [anon_sym_and] = ACTIONS(4502),
    [anon_sym_or] = ACTIONS(4502),
    [anon_sym_AMP_AMP] = ACTIONS(4504),
    [anon_sym_PIPE_PIPE] = ACTIONS(4504),
    [anon_sym_QMARK_QMARK] = ACTIONS(4504),
    [anon_sym_from] = ACTIONS(4502),
    [anon_sym_into] = ACTIONS(4502),
    [anon_sym_join] = ACTIONS(4502),
    [anon_sym_on] = ACTIONS(4502),
    [anon_sym_equals] = ACTIONS(4502),
    [anon_sym_let] = ACTIONS(4502),
    [anon_sym_orderby] = ACTIONS(4502),
    [anon_sym_ascending] = ACTIONS(4502),
    [anon_sym_descending] = ACTIONS(4502),
    [anon_sym_group] = ACTIONS(4502),
    [anon_sym_by] = ACTIONS(4502),
    [anon_sym_select] = ACTIONS(4502),
    [anon_sym_as] = ACTIONS(4502),
    [anon_sym_is] = ACTIONS(4502),
    [anon_sym_DASH_GT] = ACTIONS(4504),
    [anon_sym_with] = ACTIONS(4502),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4504),
  },
  [3420] = {
    [sym_preproc_region] = STATE(3420),
    [sym_preproc_endregion] = STATE(3420),
    [sym_preproc_line] = STATE(3420),
    [sym_preproc_pragma] = STATE(3420),
    [sym_preproc_nullable] = STATE(3420),
    [sym_preproc_error] = STATE(3420),
    [sym_preproc_define] = STATE(3420),
    [sym_preproc_undef] = STATE(3420),
    [anon_sym_SEMI] = ACTIONS(4133),
    [anon_sym_EQ] = ACTIONS(4118),
    [anon_sym_LBRACK] = ACTIONS(4133),
    [anon_sym_COLON] = ACTIONS(4133),
    [anon_sym_COMMA] = ACTIONS(4133),
    [anon_sym_RBRACK] = ACTIONS(4133),
    [anon_sym_LPAREN] = ACTIONS(4133),
    [anon_sym_RPAREN] = ACTIONS(4133),
    [anon_sym_RBRACE] = ACTIONS(4133),
    [anon_sym_LT] = ACTIONS(4118),
    [anon_sym_GT] = ACTIONS(4118),
    [anon_sym_in] = ACTIONS(4133),
    [anon_sym_QMARK] = ACTIONS(4118),
    [anon_sym_BANG] = ACTIONS(4118),
    [anon_sym_PLUS_PLUS] = ACTIONS(4133),
    [anon_sym_DASH_DASH] = ACTIONS(4133),
    [anon_sym_PLUS] = ACTIONS(4118),
    [anon_sym_DASH] = ACTIONS(4118),
    [anon_sym_STAR] = ACTIONS(4118),
    [anon_sym_SLASH] = ACTIONS(4118),
    [anon_sym_PERCENT] = ACTIONS(4118),
    [anon_sym_CARET] = ACTIONS(4118),
    [anon_sym_PIPE] = ACTIONS(4118),
    [anon_sym_AMP] = ACTIONS(4118),
    [anon_sym_LT_LT] = ACTIONS(4118),
    [anon_sym_GT_GT] = ACTIONS(4118),
    [anon_sym_GT_GT_GT] = ACTIONS(4118),
    [anon_sym_EQ_EQ] = ACTIONS(4133),
    [anon_sym_BANG_EQ] = ACTIONS(4133),
    [anon_sym_GT_EQ] = ACTIONS(4133),
    [anon_sym_LT_EQ] = ACTIONS(4133),
    [anon_sym_DOT] = ACTIONS(4118),
    [anon_sym_EQ_GT] = ACTIONS(4133),
    [anon_sym_switch] = ACTIONS(4133),
    [anon_sym_when] = ACTIONS(4133),
    [anon_sym_DOT_DOT] = ACTIONS(4133),
    [anon_sym_and] = ACTIONS(4133),
    [anon_sym_or] = ACTIONS(4133),
    [anon_sym_PLUS_EQ] = ACTIONS(4133),
    [anon_sym_DASH_EQ] = ACTIONS(4133),
    [anon_sym_STAR_EQ] = ACTIONS(4133),
    [anon_sym_SLASH_EQ] = ACTIONS(4133),
    [anon_sym_PERCENT_EQ] = ACTIONS(4133),
    [anon_sym_AMP_EQ] = ACTIONS(4133),
    [anon_sym_CARET_EQ] = ACTIONS(4133),
    [anon_sym_PIPE_EQ] = ACTIONS(4133),
    [anon_sym_LT_LT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4133),
    [anon_sym_AMP_AMP] = ACTIONS(4133),
    [anon_sym_PIPE_PIPE] = ACTIONS(4133),
    [anon_sym_QMARK_QMARK] = ACTIONS(4118),
    [anon_sym_on] = ACTIONS(4133),
    [anon_sym_equals] = ACTIONS(4133),
    [anon_sym_by] = ACTIONS(4133),
    [anon_sym_as] = ACTIONS(4133),
    [anon_sym_is] = ACTIONS(4133),
    [anon_sym_DASH_GT] = ACTIONS(4133),
    [anon_sym_with] = ACTIONS(4133),
    [aux_sym_preproc_if_token3] = ACTIONS(4133),
    [aux_sym_preproc_else_token1] = ACTIONS(4133),
    [aux_sym_preproc_elif_token1] = ACTIONS(4133),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3421] = {
    [sym_preproc_region] = STATE(3421),
    [sym_preproc_endregion] = STATE(3421),
    [sym_preproc_line] = STATE(3421),
    [sym_preproc_pragma] = STATE(3421),
    [sym_preproc_nullable] = STATE(3421),
    [sym_preproc_error] = STATE(3421),
    [sym_preproc_define] = STATE(3421),
    [sym_preproc_undef] = STATE(3421),
    [anon_sym_SEMI] = ACTIONS(4631),
    [anon_sym_EQ] = ACTIONS(4633),
    [anon_sym_LBRACK] = ACTIONS(4631),
    [anon_sym_COLON] = ACTIONS(4631),
    [anon_sym_COMMA] = ACTIONS(4631),
    [anon_sym_RBRACK] = ACTIONS(4631),
    [anon_sym_LPAREN] = ACTIONS(4631),
    [anon_sym_RPAREN] = ACTIONS(4631),
    [anon_sym_RBRACE] = ACTIONS(4631),
    [anon_sym_LT] = ACTIONS(4633),
    [anon_sym_GT] = ACTIONS(4633),
    [anon_sym_in] = ACTIONS(4631),
    [anon_sym_QMARK] = ACTIONS(4633),
    [anon_sym_BANG] = ACTIONS(4633),
    [anon_sym_PLUS_PLUS] = ACTIONS(4631),
    [anon_sym_DASH_DASH] = ACTIONS(4631),
    [anon_sym_PLUS] = ACTIONS(4633),
    [anon_sym_DASH] = ACTIONS(4633),
    [anon_sym_STAR] = ACTIONS(4633),
    [anon_sym_SLASH] = ACTIONS(4633),
    [anon_sym_PERCENT] = ACTIONS(4633),
    [anon_sym_CARET] = ACTIONS(4633),
    [anon_sym_PIPE] = ACTIONS(4633),
    [anon_sym_AMP] = ACTIONS(4633),
    [anon_sym_LT_LT] = ACTIONS(4633),
    [anon_sym_GT_GT] = ACTIONS(4633),
    [anon_sym_GT_GT_GT] = ACTIONS(4633),
    [anon_sym_EQ_EQ] = ACTIONS(4631),
    [anon_sym_BANG_EQ] = ACTIONS(4631),
    [anon_sym_GT_EQ] = ACTIONS(4631),
    [anon_sym_LT_EQ] = ACTIONS(4631),
    [anon_sym_DOT] = ACTIONS(4633),
    [anon_sym_EQ_GT] = ACTIONS(4631),
    [anon_sym_switch] = ACTIONS(4631),
    [anon_sym_when] = ACTIONS(4631),
    [anon_sym_DOT_DOT] = ACTIONS(4631),
    [anon_sym_and] = ACTIONS(4631),
    [anon_sym_or] = ACTIONS(4631),
    [anon_sym_PLUS_EQ] = ACTIONS(4631),
    [anon_sym_DASH_EQ] = ACTIONS(4631),
    [anon_sym_STAR_EQ] = ACTIONS(4631),
    [anon_sym_SLASH_EQ] = ACTIONS(4631),
    [anon_sym_PERCENT_EQ] = ACTIONS(4631),
    [anon_sym_AMP_EQ] = ACTIONS(4631),
    [anon_sym_CARET_EQ] = ACTIONS(4631),
    [anon_sym_PIPE_EQ] = ACTIONS(4631),
    [anon_sym_LT_LT_EQ] = ACTIONS(4631),
    [anon_sym_GT_GT_EQ] = ACTIONS(4631),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4631),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4631),
    [anon_sym_AMP_AMP] = ACTIONS(4631),
    [anon_sym_PIPE_PIPE] = ACTIONS(4631),
    [anon_sym_QMARK_QMARK] = ACTIONS(4633),
    [anon_sym_on] = ACTIONS(4631),
    [anon_sym_equals] = ACTIONS(4631),
    [anon_sym_by] = ACTIONS(4631),
    [anon_sym_as] = ACTIONS(4631),
    [anon_sym_is] = ACTIONS(4631),
    [anon_sym_DASH_GT] = ACTIONS(4631),
    [anon_sym_with] = ACTIONS(4631),
    [aux_sym_preproc_if_token3] = ACTIONS(4631),
    [aux_sym_preproc_else_token1] = ACTIONS(4631),
    [aux_sym_preproc_elif_token1] = ACTIONS(4631),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3422] = {
    [sym_preproc_region] = STATE(3422),
    [sym_preproc_endregion] = STATE(3422),
    [sym_preproc_line] = STATE(3422),
    [sym_preproc_pragma] = STATE(3422),
    [sym_preproc_nullable] = STATE(3422),
    [sym_preproc_error] = STATE(3422),
    [sym_preproc_define] = STATE(3422),
    [sym_preproc_undef] = STATE(3422),
    [sym__identifier_token] = ACTIONS(5077),
    [anon_sym_extern] = ACTIONS(5077),
    [anon_sym_alias] = ACTIONS(5077),
    [anon_sym_global] = ACTIONS(5077),
    [anon_sym_using] = ACTIONS(5077),
    [anon_sym_unsafe] = ACTIONS(5077),
    [anon_sym_static] = ACTIONS(5077),
    [anon_sym_LBRACK] = ACTIONS(5079),
    [anon_sym_LPAREN] = ACTIONS(5079),
    [anon_sym_event] = ACTIONS(5077),
    [anon_sym_namespace] = ACTIONS(5077),
    [anon_sym_class] = ACTIONS(5077),
    [anon_sym_ref] = ACTIONS(5077),
    [anon_sym_struct] = ACTIONS(5077),
    [anon_sym_enum] = ACTIONS(5077),
    [anon_sym_RBRACE] = ACTIONS(5079),
    [anon_sym_interface] = ACTIONS(5077),
    [anon_sym_delegate] = ACTIONS(5077),
    [anon_sym_record] = ACTIONS(5077),
    [anon_sym_abstract] = ACTIONS(5077),
    [anon_sym_async] = ACTIONS(5077),
    [anon_sym_const] = ACTIONS(5077),
    [anon_sym_file] = ACTIONS(5077),
    [anon_sym_fixed] = ACTIONS(5077),
    [anon_sym_internal] = ACTIONS(5077),
    [anon_sym_new] = ACTIONS(5077),
    [anon_sym_override] = ACTIONS(5077),
    [anon_sym_partial] = ACTIONS(5077),
    [anon_sym_private] = ACTIONS(5077),
    [anon_sym_protected] = ACTIONS(5077),
    [anon_sym_public] = ACTIONS(5077),
    [anon_sym_readonly] = ACTIONS(5077),
    [anon_sym_required] = ACTIONS(5077),
    [anon_sym_sealed] = ACTIONS(5077),
    [anon_sym_virtual] = ACTIONS(5077),
    [anon_sym_volatile] = ACTIONS(5077),
    [anon_sym_where] = ACTIONS(5077),
    [anon_sym_notnull] = ACTIONS(5077),
    [anon_sym_unmanaged] = ACTIONS(5077),
    [anon_sym_TILDE] = ACTIONS(5079),
    [anon_sym_implicit] = ACTIONS(5077),
    [anon_sym_explicit] = ACTIONS(5077),
    [anon_sym_scoped] = ACTIONS(5077),
    [anon_sym_var] = ACTIONS(5077),
    [sym_predefined_type] = ACTIONS(5077),
    [anon_sym_yield] = ACTIONS(5077),
    [anon_sym_when] = ACTIONS(5077),
    [anon_sym_from] = ACTIONS(5077),
    [anon_sym_into] = ACTIONS(5077),
    [anon_sym_join] = ACTIONS(5077),
    [anon_sym_on] = ACTIONS(5077),
    [anon_sym_equals] = ACTIONS(5077),
    [anon_sym_let] = ACTIONS(5077),
    [anon_sym_orderby] = ACTIONS(5077),
    [anon_sym_ascending] = ACTIONS(5077),
    [anon_sym_descending] = ACTIONS(5077),
    [anon_sym_group] = ACTIONS(5077),
    [anon_sym_by] = ACTIONS(5077),
    [anon_sym_select] = ACTIONS(5077),
    [aux_sym_preproc_if_token1] = ACTIONS(5079),
    [aux_sym_preproc_if_token3] = ACTIONS(5079),
    [aux_sym_preproc_else_token1] = ACTIONS(5079),
    [aux_sym_preproc_elif_token1] = ACTIONS(5079),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3423] = {
    [sym_preproc_region] = STATE(3423),
    [sym_preproc_endregion] = STATE(3423),
    [sym_preproc_line] = STATE(3423),
    [sym_preproc_pragma] = STATE(3423),
    [sym_preproc_nullable] = STATE(3423),
    [sym_preproc_error] = STATE(3423),
    [sym_preproc_define] = STATE(3423),
    [sym_preproc_undef] = STATE(3423),
    [sym__identifier_token] = ACTIONS(3796),
    [anon_sym_extern] = ACTIONS(3796),
    [anon_sym_alias] = ACTIONS(3796),
    [anon_sym_global] = ACTIONS(3796),
    [anon_sym_using] = ACTIONS(3796),
    [anon_sym_unsafe] = ACTIONS(3796),
    [anon_sym_static] = ACTIONS(3796),
    [anon_sym_LBRACK] = ACTIONS(3798),
    [anon_sym_LPAREN] = ACTIONS(3798),
    [anon_sym_event] = ACTIONS(3796),
    [anon_sym_namespace] = ACTIONS(3796),
    [anon_sym_class] = ACTIONS(3796),
    [anon_sym_ref] = ACTIONS(3796),
    [anon_sym_struct] = ACTIONS(3796),
    [anon_sym_enum] = ACTIONS(3796),
    [anon_sym_RBRACE] = ACTIONS(3798),
    [anon_sym_interface] = ACTIONS(3796),
    [anon_sym_delegate] = ACTIONS(3796),
    [anon_sym_record] = ACTIONS(3796),
    [anon_sym_abstract] = ACTIONS(3796),
    [anon_sym_async] = ACTIONS(3796),
    [anon_sym_const] = ACTIONS(3796),
    [anon_sym_file] = ACTIONS(3796),
    [anon_sym_fixed] = ACTIONS(3796),
    [anon_sym_internal] = ACTIONS(3796),
    [anon_sym_new] = ACTIONS(3796),
    [anon_sym_override] = ACTIONS(3796),
    [anon_sym_partial] = ACTIONS(3796),
    [anon_sym_private] = ACTIONS(3796),
    [anon_sym_protected] = ACTIONS(3796),
    [anon_sym_public] = ACTIONS(3796),
    [anon_sym_readonly] = ACTIONS(3796),
    [anon_sym_required] = ACTIONS(3796),
    [anon_sym_sealed] = ACTIONS(3796),
    [anon_sym_virtual] = ACTIONS(3796),
    [anon_sym_volatile] = ACTIONS(3796),
    [anon_sym_where] = ACTIONS(3796),
    [anon_sym_notnull] = ACTIONS(3796),
    [anon_sym_unmanaged] = ACTIONS(3796),
    [anon_sym_TILDE] = ACTIONS(3798),
    [anon_sym_implicit] = ACTIONS(3796),
    [anon_sym_explicit] = ACTIONS(3796),
    [anon_sym_scoped] = ACTIONS(3796),
    [anon_sym_var] = ACTIONS(3796),
    [sym_predefined_type] = ACTIONS(3796),
    [anon_sym_yield] = ACTIONS(3796),
    [anon_sym_when] = ACTIONS(3796),
    [anon_sym_from] = ACTIONS(3796),
    [anon_sym_into] = ACTIONS(3796),
    [anon_sym_join] = ACTIONS(3796),
    [anon_sym_on] = ACTIONS(3796),
    [anon_sym_equals] = ACTIONS(3796),
    [anon_sym_let] = ACTIONS(3796),
    [anon_sym_orderby] = ACTIONS(3796),
    [anon_sym_ascending] = ACTIONS(3796),
    [anon_sym_descending] = ACTIONS(3796),
    [anon_sym_group] = ACTIONS(3796),
    [anon_sym_by] = ACTIONS(3796),
    [anon_sym_select] = ACTIONS(3796),
    [aux_sym_preproc_if_token1] = ACTIONS(3798),
    [aux_sym_preproc_if_token3] = ACTIONS(3798),
    [aux_sym_preproc_else_token1] = ACTIONS(3798),
    [aux_sym_preproc_elif_token1] = ACTIONS(3798),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3424] = {
    [sym_preproc_region] = STATE(3424),
    [sym_preproc_endregion] = STATE(3424),
    [sym_preproc_line] = STATE(3424),
    [sym_preproc_pragma] = STATE(3424),
    [sym_preproc_nullable] = STATE(3424),
    [sym_preproc_error] = STATE(3424),
    [sym_preproc_define] = STATE(3424),
    [sym_preproc_undef] = STATE(3424),
    [sym__identifier_token] = ACTIONS(3784),
    [anon_sym_extern] = ACTIONS(3784),
    [anon_sym_alias] = ACTIONS(3784),
    [anon_sym_global] = ACTIONS(3784),
    [anon_sym_using] = ACTIONS(3784),
    [anon_sym_unsafe] = ACTIONS(3784),
    [anon_sym_static] = ACTIONS(3784),
    [anon_sym_LBRACK] = ACTIONS(3786),
    [anon_sym_LPAREN] = ACTIONS(3786),
    [anon_sym_event] = ACTIONS(3784),
    [anon_sym_namespace] = ACTIONS(3784),
    [anon_sym_class] = ACTIONS(3784),
    [anon_sym_ref] = ACTIONS(3784),
    [anon_sym_struct] = ACTIONS(3784),
    [anon_sym_enum] = ACTIONS(3784),
    [anon_sym_RBRACE] = ACTIONS(3786),
    [anon_sym_interface] = ACTIONS(3784),
    [anon_sym_delegate] = ACTIONS(3784),
    [anon_sym_record] = ACTIONS(3784),
    [anon_sym_abstract] = ACTIONS(3784),
    [anon_sym_async] = ACTIONS(3784),
    [anon_sym_const] = ACTIONS(3784),
    [anon_sym_file] = ACTIONS(3784),
    [anon_sym_fixed] = ACTIONS(3784),
    [anon_sym_internal] = ACTIONS(3784),
    [anon_sym_new] = ACTIONS(3784),
    [anon_sym_override] = ACTIONS(3784),
    [anon_sym_partial] = ACTIONS(3784),
    [anon_sym_private] = ACTIONS(3784),
    [anon_sym_protected] = ACTIONS(3784),
    [anon_sym_public] = ACTIONS(3784),
    [anon_sym_readonly] = ACTIONS(3784),
    [anon_sym_required] = ACTIONS(3784),
    [anon_sym_sealed] = ACTIONS(3784),
    [anon_sym_virtual] = ACTIONS(3784),
    [anon_sym_volatile] = ACTIONS(3784),
    [anon_sym_where] = ACTIONS(3784),
    [anon_sym_notnull] = ACTIONS(3784),
    [anon_sym_unmanaged] = ACTIONS(3784),
    [anon_sym_TILDE] = ACTIONS(3786),
    [anon_sym_implicit] = ACTIONS(3784),
    [anon_sym_explicit] = ACTIONS(3784),
    [anon_sym_scoped] = ACTIONS(3784),
    [anon_sym_var] = ACTIONS(3784),
    [sym_predefined_type] = ACTIONS(3784),
    [anon_sym_yield] = ACTIONS(3784),
    [anon_sym_when] = ACTIONS(3784),
    [anon_sym_from] = ACTIONS(3784),
    [anon_sym_into] = ACTIONS(3784),
    [anon_sym_join] = ACTIONS(3784),
    [anon_sym_on] = ACTIONS(3784),
    [anon_sym_equals] = ACTIONS(3784),
    [anon_sym_let] = ACTIONS(3784),
    [anon_sym_orderby] = ACTIONS(3784),
    [anon_sym_ascending] = ACTIONS(3784),
    [anon_sym_descending] = ACTIONS(3784),
    [anon_sym_group] = ACTIONS(3784),
    [anon_sym_by] = ACTIONS(3784),
    [anon_sym_select] = ACTIONS(3784),
    [aux_sym_preproc_if_token1] = ACTIONS(3786),
    [aux_sym_preproc_if_token3] = ACTIONS(3786),
    [aux_sym_preproc_else_token1] = ACTIONS(3786),
    [aux_sym_preproc_elif_token1] = ACTIONS(3786),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3425] = {
    [sym_preproc_region] = STATE(3425),
    [sym_preproc_endregion] = STATE(3425),
    [sym_preproc_line] = STATE(3425),
    [sym_preproc_pragma] = STATE(3425),
    [sym_preproc_nullable] = STATE(3425),
    [sym_preproc_error] = STATE(3425),
    [sym_preproc_define] = STATE(3425),
    [sym_preproc_undef] = STATE(3425),
    [sym__identifier_token] = ACTIONS(3780),
    [anon_sym_extern] = ACTIONS(3780),
    [anon_sym_alias] = ACTIONS(3780),
    [anon_sym_global] = ACTIONS(3780),
    [anon_sym_using] = ACTIONS(3780),
    [anon_sym_unsafe] = ACTIONS(3780),
    [anon_sym_static] = ACTIONS(3780),
    [anon_sym_LBRACK] = ACTIONS(3782),
    [anon_sym_LPAREN] = ACTIONS(3782),
    [anon_sym_event] = ACTIONS(3780),
    [anon_sym_namespace] = ACTIONS(3780),
    [anon_sym_class] = ACTIONS(3780),
    [anon_sym_ref] = ACTIONS(3780),
    [anon_sym_struct] = ACTIONS(3780),
    [anon_sym_enum] = ACTIONS(3780),
    [anon_sym_RBRACE] = ACTIONS(3782),
    [anon_sym_interface] = ACTIONS(3780),
    [anon_sym_delegate] = ACTIONS(3780),
    [anon_sym_record] = ACTIONS(3780),
    [anon_sym_abstract] = ACTIONS(3780),
    [anon_sym_async] = ACTIONS(3780),
    [anon_sym_const] = ACTIONS(3780),
    [anon_sym_file] = ACTIONS(3780),
    [anon_sym_fixed] = ACTIONS(3780),
    [anon_sym_internal] = ACTIONS(3780),
    [anon_sym_new] = ACTIONS(3780),
    [anon_sym_override] = ACTIONS(3780),
    [anon_sym_partial] = ACTIONS(3780),
    [anon_sym_private] = ACTIONS(3780),
    [anon_sym_protected] = ACTIONS(3780),
    [anon_sym_public] = ACTIONS(3780),
    [anon_sym_readonly] = ACTIONS(3780),
    [anon_sym_required] = ACTIONS(3780),
    [anon_sym_sealed] = ACTIONS(3780),
    [anon_sym_virtual] = ACTIONS(3780),
    [anon_sym_volatile] = ACTIONS(3780),
    [anon_sym_where] = ACTIONS(3780),
    [anon_sym_notnull] = ACTIONS(3780),
    [anon_sym_unmanaged] = ACTIONS(3780),
    [anon_sym_TILDE] = ACTIONS(3782),
    [anon_sym_implicit] = ACTIONS(3780),
    [anon_sym_explicit] = ACTIONS(3780),
    [anon_sym_scoped] = ACTIONS(3780),
    [anon_sym_var] = ACTIONS(3780),
    [sym_predefined_type] = ACTIONS(3780),
    [anon_sym_yield] = ACTIONS(3780),
    [anon_sym_when] = ACTIONS(3780),
    [anon_sym_from] = ACTIONS(3780),
    [anon_sym_into] = ACTIONS(3780),
    [anon_sym_join] = ACTIONS(3780),
    [anon_sym_on] = ACTIONS(3780),
    [anon_sym_equals] = ACTIONS(3780),
    [anon_sym_let] = ACTIONS(3780),
    [anon_sym_orderby] = ACTIONS(3780),
    [anon_sym_ascending] = ACTIONS(3780),
    [anon_sym_descending] = ACTIONS(3780),
    [anon_sym_group] = ACTIONS(3780),
    [anon_sym_by] = ACTIONS(3780),
    [anon_sym_select] = ACTIONS(3780),
    [aux_sym_preproc_if_token1] = ACTIONS(3782),
    [aux_sym_preproc_if_token3] = ACTIONS(3782),
    [aux_sym_preproc_else_token1] = ACTIONS(3782),
    [aux_sym_preproc_elif_token1] = ACTIONS(3782),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3426] = {
    [sym_preproc_region] = STATE(3426),
    [sym_preproc_endregion] = STATE(3426),
    [sym_preproc_line] = STATE(3426),
    [sym_preproc_pragma] = STATE(3426),
    [sym_preproc_nullable] = STATE(3426),
    [sym_preproc_error] = STATE(3426),
    [sym_preproc_define] = STATE(3426),
    [sym_preproc_undef] = STATE(3426),
    [sym__identifier_token] = ACTIONS(3772),
    [anon_sym_extern] = ACTIONS(3772),
    [anon_sym_alias] = ACTIONS(3772),
    [anon_sym_global] = ACTIONS(3772),
    [anon_sym_using] = ACTIONS(3772),
    [anon_sym_unsafe] = ACTIONS(3772),
    [anon_sym_static] = ACTIONS(3772),
    [anon_sym_LBRACK] = ACTIONS(3774),
    [anon_sym_LPAREN] = ACTIONS(3774),
    [anon_sym_event] = ACTIONS(3772),
    [anon_sym_namespace] = ACTIONS(3772),
    [anon_sym_class] = ACTIONS(3772),
    [anon_sym_ref] = ACTIONS(3772),
    [anon_sym_struct] = ACTIONS(3772),
    [anon_sym_enum] = ACTIONS(3772),
    [anon_sym_RBRACE] = ACTIONS(3774),
    [anon_sym_interface] = ACTIONS(3772),
    [anon_sym_delegate] = ACTIONS(3772),
    [anon_sym_record] = ACTIONS(3772),
    [anon_sym_abstract] = ACTIONS(3772),
    [anon_sym_async] = ACTIONS(3772),
    [anon_sym_const] = ACTIONS(3772),
    [anon_sym_file] = ACTIONS(3772),
    [anon_sym_fixed] = ACTIONS(3772),
    [anon_sym_internal] = ACTIONS(3772),
    [anon_sym_new] = ACTIONS(3772),
    [anon_sym_override] = ACTIONS(3772),
    [anon_sym_partial] = ACTIONS(3772),
    [anon_sym_private] = ACTIONS(3772),
    [anon_sym_protected] = ACTIONS(3772),
    [anon_sym_public] = ACTIONS(3772),
    [anon_sym_readonly] = ACTIONS(3772),
    [anon_sym_required] = ACTIONS(3772),
    [anon_sym_sealed] = ACTIONS(3772),
    [anon_sym_virtual] = ACTIONS(3772),
    [anon_sym_volatile] = ACTIONS(3772),
    [anon_sym_where] = ACTIONS(3772),
    [anon_sym_notnull] = ACTIONS(3772),
    [anon_sym_unmanaged] = ACTIONS(3772),
    [anon_sym_TILDE] = ACTIONS(3774),
    [anon_sym_implicit] = ACTIONS(3772),
    [anon_sym_explicit] = ACTIONS(3772),
    [anon_sym_scoped] = ACTIONS(3772),
    [anon_sym_var] = ACTIONS(3772),
    [sym_predefined_type] = ACTIONS(3772),
    [anon_sym_yield] = ACTIONS(3772),
    [anon_sym_when] = ACTIONS(3772),
    [anon_sym_from] = ACTIONS(3772),
    [anon_sym_into] = ACTIONS(3772),
    [anon_sym_join] = ACTIONS(3772),
    [anon_sym_on] = ACTIONS(3772),
    [anon_sym_equals] = ACTIONS(3772),
    [anon_sym_let] = ACTIONS(3772),
    [anon_sym_orderby] = ACTIONS(3772),
    [anon_sym_ascending] = ACTIONS(3772),
    [anon_sym_descending] = ACTIONS(3772),
    [anon_sym_group] = ACTIONS(3772),
    [anon_sym_by] = ACTIONS(3772),
    [anon_sym_select] = ACTIONS(3772),
    [aux_sym_preproc_if_token1] = ACTIONS(3774),
    [aux_sym_preproc_if_token3] = ACTIONS(3774),
    [aux_sym_preproc_else_token1] = ACTIONS(3774),
    [aux_sym_preproc_elif_token1] = ACTIONS(3774),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3427] = {
    [sym_preproc_region] = STATE(3427),
    [sym_preproc_endregion] = STATE(3427),
    [sym_preproc_line] = STATE(3427),
    [sym_preproc_pragma] = STATE(3427),
    [sym_preproc_nullable] = STATE(3427),
    [sym_preproc_error] = STATE(3427),
    [sym_preproc_define] = STATE(3427),
    [sym_preproc_undef] = STATE(3427),
    [sym__identifier_token] = ACTIONS(5081),
    [anon_sym_extern] = ACTIONS(5081),
    [anon_sym_alias] = ACTIONS(5081),
    [anon_sym_global] = ACTIONS(5081),
    [anon_sym_using] = ACTIONS(5081),
    [anon_sym_unsafe] = ACTIONS(5081),
    [anon_sym_static] = ACTIONS(5081),
    [anon_sym_LBRACK] = ACTIONS(5083),
    [anon_sym_LPAREN] = ACTIONS(5083),
    [anon_sym_event] = ACTIONS(5081),
    [anon_sym_namespace] = ACTIONS(5081),
    [anon_sym_class] = ACTIONS(5081),
    [anon_sym_ref] = ACTIONS(5081),
    [anon_sym_struct] = ACTIONS(5081),
    [anon_sym_enum] = ACTIONS(5081),
    [anon_sym_RBRACE] = ACTIONS(5083),
    [anon_sym_interface] = ACTIONS(5081),
    [anon_sym_delegate] = ACTIONS(5081),
    [anon_sym_record] = ACTIONS(5081),
    [anon_sym_abstract] = ACTIONS(5081),
    [anon_sym_async] = ACTIONS(5081),
    [anon_sym_const] = ACTIONS(5081),
    [anon_sym_file] = ACTIONS(5081),
    [anon_sym_fixed] = ACTIONS(5081),
    [anon_sym_internal] = ACTIONS(5081),
    [anon_sym_new] = ACTIONS(5081),
    [anon_sym_override] = ACTIONS(5081),
    [anon_sym_partial] = ACTIONS(5081),
    [anon_sym_private] = ACTIONS(5081),
    [anon_sym_protected] = ACTIONS(5081),
    [anon_sym_public] = ACTIONS(5081),
    [anon_sym_readonly] = ACTIONS(5081),
    [anon_sym_required] = ACTIONS(5081),
    [anon_sym_sealed] = ACTIONS(5081),
    [anon_sym_virtual] = ACTIONS(5081),
    [anon_sym_volatile] = ACTIONS(5081),
    [anon_sym_where] = ACTIONS(5081),
    [anon_sym_notnull] = ACTIONS(5081),
    [anon_sym_unmanaged] = ACTIONS(5081),
    [anon_sym_TILDE] = ACTIONS(5083),
    [anon_sym_implicit] = ACTIONS(5081),
    [anon_sym_explicit] = ACTIONS(5081),
    [anon_sym_scoped] = ACTIONS(5081),
    [anon_sym_var] = ACTIONS(5081),
    [sym_predefined_type] = ACTIONS(5081),
    [anon_sym_yield] = ACTIONS(5081),
    [anon_sym_when] = ACTIONS(5081),
    [anon_sym_from] = ACTIONS(5081),
    [anon_sym_into] = ACTIONS(5081),
    [anon_sym_join] = ACTIONS(5081),
    [anon_sym_on] = ACTIONS(5081),
    [anon_sym_equals] = ACTIONS(5081),
    [anon_sym_let] = ACTIONS(5081),
    [anon_sym_orderby] = ACTIONS(5081),
    [anon_sym_ascending] = ACTIONS(5081),
    [anon_sym_descending] = ACTIONS(5081),
    [anon_sym_group] = ACTIONS(5081),
    [anon_sym_by] = ACTIONS(5081),
    [anon_sym_select] = ACTIONS(5081),
    [aux_sym_preproc_if_token1] = ACTIONS(5083),
    [aux_sym_preproc_if_token3] = ACTIONS(5083),
    [aux_sym_preproc_else_token1] = ACTIONS(5083),
    [aux_sym_preproc_elif_token1] = ACTIONS(5083),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3428] = {
    [sym_preproc_region] = STATE(3428),
    [sym_preproc_endregion] = STATE(3428),
    [sym_preproc_line] = STATE(3428),
    [sym_preproc_pragma] = STATE(3428),
    [sym_preproc_nullable] = STATE(3428),
    [sym_preproc_error] = STATE(3428),
    [sym_preproc_define] = STATE(3428),
    [sym_preproc_undef] = STATE(3428),
    [anon_sym_SEMI] = ACTIONS(4623),
    [anon_sym_EQ] = ACTIONS(4625),
    [anon_sym_LBRACK] = ACTIONS(4623),
    [anon_sym_COLON] = ACTIONS(4623),
    [anon_sym_COMMA] = ACTIONS(4623),
    [anon_sym_RBRACK] = ACTIONS(4623),
    [anon_sym_LPAREN] = ACTIONS(4623),
    [anon_sym_RPAREN] = ACTIONS(4623),
    [anon_sym_RBRACE] = ACTIONS(4623),
    [anon_sym_LT] = ACTIONS(4625),
    [anon_sym_GT] = ACTIONS(4625),
    [anon_sym_in] = ACTIONS(4623),
    [anon_sym_QMARK] = ACTIONS(4625),
    [anon_sym_BANG] = ACTIONS(4625),
    [anon_sym_PLUS_PLUS] = ACTIONS(4623),
    [anon_sym_DASH_DASH] = ACTIONS(4623),
    [anon_sym_PLUS] = ACTIONS(4625),
    [anon_sym_DASH] = ACTIONS(4625),
    [anon_sym_STAR] = ACTIONS(4625),
    [anon_sym_SLASH] = ACTIONS(4625),
    [anon_sym_PERCENT] = ACTIONS(4625),
    [anon_sym_CARET] = ACTIONS(4625),
    [anon_sym_PIPE] = ACTIONS(4625),
    [anon_sym_AMP] = ACTIONS(4625),
    [anon_sym_LT_LT] = ACTIONS(4625),
    [anon_sym_GT_GT] = ACTIONS(4625),
    [anon_sym_GT_GT_GT] = ACTIONS(4625),
    [anon_sym_EQ_EQ] = ACTIONS(4623),
    [anon_sym_BANG_EQ] = ACTIONS(4623),
    [anon_sym_GT_EQ] = ACTIONS(4623),
    [anon_sym_LT_EQ] = ACTIONS(4623),
    [anon_sym_DOT] = ACTIONS(4625),
    [anon_sym_EQ_GT] = ACTIONS(4623),
    [anon_sym_switch] = ACTIONS(4623),
    [anon_sym_when] = ACTIONS(4623),
    [anon_sym_DOT_DOT] = ACTIONS(4623),
    [anon_sym_and] = ACTIONS(4623),
    [anon_sym_or] = ACTIONS(4623),
    [anon_sym_PLUS_EQ] = ACTIONS(4623),
    [anon_sym_DASH_EQ] = ACTIONS(4623),
    [anon_sym_STAR_EQ] = ACTIONS(4623),
    [anon_sym_SLASH_EQ] = ACTIONS(4623),
    [anon_sym_PERCENT_EQ] = ACTIONS(4623),
    [anon_sym_AMP_EQ] = ACTIONS(4623),
    [anon_sym_CARET_EQ] = ACTIONS(4623),
    [anon_sym_PIPE_EQ] = ACTIONS(4623),
    [anon_sym_LT_LT_EQ] = ACTIONS(4623),
    [anon_sym_GT_GT_EQ] = ACTIONS(4623),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4623),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4623),
    [anon_sym_AMP_AMP] = ACTIONS(4623),
    [anon_sym_PIPE_PIPE] = ACTIONS(4623),
    [anon_sym_QMARK_QMARK] = ACTIONS(4625),
    [anon_sym_on] = ACTIONS(4623),
    [anon_sym_equals] = ACTIONS(4623),
    [anon_sym_by] = ACTIONS(4623),
    [anon_sym_as] = ACTIONS(4623),
    [anon_sym_is] = ACTIONS(4623),
    [anon_sym_DASH_GT] = ACTIONS(4623),
    [anon_sym_with] = ACTIONS(4623),
    [aux_sym_preproc_if_token3] = ACTIONS(4623),
    [aux_sym_preproc_else_token1] = ACTIONS(4623),
    [aux_sym_preproc_elif_token1] = ACTIONS(4623),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3429] = {
    [sym_preproc_region] = STATE(3429),
    [sym_preproc_endregion] = STATE(3429),
    [sym_preproc_line] = STATE(3429),
    [sym_preproc_pragma] = STATE(3429),
    [sym_preproc_nullable] = STATE(3429),
    [sym_preproc_error] = STATE(3429),
    [sym_preproc_define] = STATE(3429),
    [sym_preproc_undef] = STATE(3429),
    [sym__identifier_token] = ACTIONS(4422),
    [anon_sym_alias] = ACTIONS(4422),
    [anon_sym_global] = ACTIONS(4422),
    [anon_sym_LBRACK] = ACTIONS(4547),
    [anon_sym_COLON] = ACTIONS(4424),
    [anon_sym_COMMA] = ACTIONS(4424),
    [anon_sym_LPAREN] = ACTIONS(4424),
    [anon_sym_LBRACE] = ACTIONS(4424),
    [anon_sym_file] = ACTIONS(4422),
    [anon_sym_LT] = ACTIONS(4422),
    [anon_sym_GT] = ACTIONS(4422),
    [anon_sym_where] = ACTIONS(4422),
    [anon_sym_QMARK] = ACTIONS(4932),
    [anon_sym_notnull] = ACTIONS(4422),
    [anon_sym_unmanaged] = ACTIONS(4422),
    [anon_sym_BANG] = ACTIONS(4422),
    [anon_sym_PLUS_PLUS] = ACTIONS(4424),
    [anon_sym_DASH_DASH] = ACTIONS(4424),
    [anon_sym_PLUS] = ACTIONS(4422),
    [anon_sym_DASH] = ACTIONS(4422),
    [anon_sym_STAR] = ACTIONS(4553),
    [anon_sym_SLASH] = ACTIONS(4422),
    [anon_sym_PERCENT] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4424),
    [anon_sym_PIPE] = ACTIONS(4422),
    [anon_sym_AMP] = ACTIONS(4422),
    [anon_sym_LT_LT] = ACTIONS(4424),
    [anon_sym_GT_GT] = ACTIONS(4422),
    [anon_sym_GT_GT_GT] = ACTIONS(4424),
    [anon_sym_EQ_EQ] = ACTIONS(4424),
    [anon_sym_BANG_EQ] = ACTIONS(4424),
    [anon_sym_GT_EQ] = ACTIONS(4424),
    [anon_sym_LT_EQ] = ACTIONS(4424),
    [anon_sym_DOT] = ACTIONS(5085),
    [anon_sym_scoped] = ACTIONS(4422),
    [anon_sym_var] = ACTIONS(4422),
    [anon_sym_yield] = ACTIONS(4422),
    [anon_sym_switch] = ACTIONS(4422),
    [anon_sym_when] = ACTIONS(4422),
    [sym_discard] = ACTIONS(4422),
    [anon_sym_DOT_DOT] = ACTIONS(4424),
    [anon_sym_and] = ACTIONS(4422),
    [anon_sym_or] = ACTIONS(4422),
    [anon_sym_AMP_AMP] = ACTIONS(4424),
    [anon_sym_PIPE_PIPE] = ACTIONS(4424),
    [anon_sym_QMARK_QMARK] = ACTIONS(4424),
    [anon_sym_from] = ACTIONS(4422),
    [anon_sym_into] = ACTIONS(4422),
    [anon_sym_join] = ACTIONS(4422),
    [anon_sym_on] = ACTIONS(4422),
    [anon_sym_equals] = ACTIONS(4422),
    [anon_sym_let] = ACTIONS(4422),
    [anon_sym_orderby] = ACTIONS(4422),
    [anon_sym_ascending] = ACTIONS(4422),
    [anon_sym_descending] = ACTIONS(4422),
    [anon_sym_group] = ACTIONS(4422),
    [anon_sym_by] = ACTIONS(4422),
    [anon_sym_select] = ACTIONS(4422),
    [anon_sym_as] = ACTIONS(4422),
    [anon_sym_is] = ACTIONS(4422),
    [anon_sym_DASH_GT] = ACTIONS(4953),
    [anon_sym_with] = ACTIONS(4422),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4424),
  },
  [3430] = {
    [sym_preproc_region] = STATE(3430),
    [sym_preproc_endregion] = STATE(3430),
    [sym_preproc_line] = STATE(3430),
    [sym_preproc_pragma] = STATE(3430),
    [sym_preproc_nullable] = STATE(3430),
    [sym_preproc_error] = STATE(3430),
    [sym_preproc_define] = STATE(3430),
    [sym_preproc_undef] = STATE(3430),
    [sym__identifier_token] = ACTIONS(4113),
    [anon_sym_alias] = ACTIONS(4113),
    [anon_sym_global] = ACTIONS(4113),
    [anon_sym_LBRACK] = ACTIONS(4124),
    [anon_sym_COLON] = ACTIONS(4124),
    [anon_sym_COMMA] = ACTIONS(4124),
    [anon_sym_LPAREN] = ACTIONS(4124),
    [anon_sym_LBRACE] = ACTIONS(4124),
    [anon_sym_file] = ACTIONS(4113),
    [anon_sym_LT] = ACTIONS(4113),
    [anon_sym_GT] = ACTIONS(4113),
    [anon_sym_where] = ACTIONS(4113),
    [anon_sym_QMARK] = ACTIONS(4113),
    [anon_sym_notnull] = ACTIONS(4113),
    [anon_sym_unmanaged] = ACTIONS(4113),
    [anon_sym_BANG] = ACTIONS(4113),
    [anon_sym_PLUS_PLUS] = ACTIONS(4124),
    [anon_sym_DASH_DASH] = ACTIONS(4124),
    [anon_sym_PLUS] = ACTIONS(4113),
    [anon_sym_DASH] = ACTIONS(4113),
    [anon_sym_STAR] = ACTIONS(4124),
    [anon_sym_SLASH] = ACTIONS(4113),
    [anon_sym_PERCENT] = ACTIONS(4124),
    [anon_sym_CARET] = ACTIONS(4124),
    [anon_sym_PIPE] = ACTIONS(4113),
    [anon_sym_AMP] = ACTIONS(4113),
    [anon_sym_LT_LT] = ACTIONS(4124),
    [anon_sym_GT_GT] = ACTIONS(4113),
    [anon_sym_GT_GT_GT] = ACTIONS(4124),
    [anon_sym_EQ_EQ] = ACTIONS(4124),
    [anon_sym_BANG_EQ] = ACTIONS(4124),
    [anon_sym_GT_EQ] = ACTIONS(4124),
    [anon_sym_LT_EQ] = ACTIONS(4124),
    [anon_sym_DOT] = ACTIONS(4113),
    [anon_sym_scoped] = ACTIONS(4113),
    [anon_sym_var] = ACTIONS(4113),
    [anon_sym_yield] = ACTIONS(4113),
    [anon_sym_switch] = ACTIONS(4113),
    [anon_sym_when] = ACTIONS(4113),
    [sym_discard] = ACTIONS(4113),
    [anon_sym_DOT_DOT] = ACTIONS(4124),
    [anon_sym_and] = ACTIONS(4113),
    [anon_sym_or] = ACTIONS(4113),
    [anon_sym_AMP_AMP] = ACTIONS(4124),
    [anon_sym_PIPE_PIPE] = ACTIONS(4124),
    [anon_sym_QMARK_QMARK] = ACTIONS(4124),
    [anon_sym_from] = ACTIONS(4113),
    [anon_sym_into] = ACTIONS(4113),
    [anon_sym_join] = ACTIONS(4113),
    [anon_sym_on] = ACTIONS(4113),
    [anon_sym_equals] = ACTIONS(4113),
    [anon_sym_let] = ACTIONS(4113),
    [anon_sym_orderby] = ACTIONS(4113),
    [anon_sym_ascending] = ACTIONS(4113),
    [anon_sym_descending] = ACTIONS(4113),
    [anon_sym_group] = ACTIONS(4113),
    [anon_sym_by] = ACTIONS(4113),
    [anon_sym_select] = ACTIONS(4113),
    [anon_sym_as] = ACTIONS(4113),
    [anon_sym_is] = ACTIONS(4113),
    [anon_sym_DASH_GT] = ACTIONS(4124),
    [anon_sym_with] = ACTIONS(4113),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4124),
  },
  [3431] = {
    [sym_preproc_region] = STATE(3431),
    [sym_preproc_endregion] = STATE(3431),
    [sym_preproc_line] = STATE(3431),
    [sym_preproc_pragma] = STATE(3431),
    [sym_preproc_nullable] = STATE(3431),
    [sym_preproc_error] = STATE(3431),
    [sym_preproc_define] = STATE(3431),
    [sym_preproc_undef] = STATE(3431),
    [sym__identifier_token] = ACTIONS(3752),
    [anon_sym_extern] = ACTIONS(3752),
    [anon_sym_alias] = ACTIONS(3752),
    [anon_sym_global] = ACTIONS(3752),
    [anon_sym_using] = ACTIONS(3752),
    [anon_sym_unsafe] = ACTIONS(3752),
    [anon_sym_static] = ACTIONS(3752),
    [anon_sym_LBRACK] = ACTIONS(3754),
    [anon_sym_LPAREN] = ACTIONS(3754),
    [anon_sym_event] = ACTIONS(3752),
    [anon_sym_namespace] = ACTIONS(3752),
    [anon_sym_class] = ACTIONS(3752),
    [anon_sym_ref] = ACTIONS(3752),
    [anon_sym_struct] = ACTIONS(3752),
    [anon_sym_enum] = ACTIONS(3752),
    [anon_sym_RBRACE] = ACTIONS(3754),
    [anon_sym_interface] = ACTIONS(3752),
    [anon_sym_delegate] = ACTIONS(3752),
    [anon_sym_record] = ACTIONS(3752),
    [anon_sym_abstract] = ACTIONS(3752),
    [anon_sym_async] = ACTIONS(3752),
    [anon_sym_const] = ACTIONS(3752),
    [anon_sym_file] = ACTIONS(3752),
    [anon_sym_fixed] = ACTIONS(3752),
    [anon_sym_internal] = ACTIONS(3752),
    [anon_sym_new] = ACTIONS(3752),
    [anon_sym_override] = ACTIONS(3752),
    [anon_sym_partial] = ACTIONS(3752),
    [anon_sym_private] = ACTIONS(3752),
    [anon_sym_protected] = ACTIONS(3752),
    [anon_sym_public] = ACTIONS(3752),
    [anon_sym_readonly] = ACTIONS(3752),
    [anon_sym_required] = ACTIONS(3752),
    [anon_sym_sealed] = ACTIONS(3752),
    [anon_sym_virtual] = ACTIONS(3752),
    [anon_sym_volatile] = ACTIONS(3752),
    [anon_sym_where] = ACTIONS(3752),
    [anon_sym_notnull] = ACTIONS(3752),
    [anon_sym_unmanaged] = ACTIONS(3752),
    [anon_sym_TILDE] = ACTIONS(3754),
    [anon_sym_implicit] = ACTIONS(3752),
    [anon_sym_explicit] = ACTIONS(3752),
    [anon_sym_scoped] = ACTIONS(3752),
    [anon_sym_var] = ACTIONS(3752),
    [sym_predefined_type] = ACTIONS(3752),
    [anon_sym_yield] = ACTIONS(3752),
    [anon_sym_when] = ACTIONS(3752),
    [anon_sym_from] = ACTIONS(3752),
    [anon_sym_into] = ACTIONS(3752),
    [anon_sym_join] = ACTIONS(3752),
    [anon_sym_on] = ACTIONS(3752),
    [anon_sym_equals] = ACTIONS(3752),
    [anon_sym_let] = ACTIONS(3752),
    [anon_sym_orderby] = ACTIONS(3752),
    [anon_sym_ascending] = ACTIONS(3752),
    [anon_sym_descending] = ACTIONS(3752),
    [anon_sym_group] = ACTIONS(3752),
    [anon_sym_by] = ACTIONS(3752),
    [anon_sym_select] = ACTIONS(3752),
    [aux_sym_preproc_if_token1] = ACTIONS(3754),
    [aux_sym_preproc_if_token3] = ACTIONS(3754),
    [aux_sym_preproc_else_token1] = ACTIONS(3754),
    [aux_sym_preproc_elif_token1] = ACTIONS(3754),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3432] = {
    [sym_preproc_region] = STATE(3432),
    [sym_preproc_endregion] = STATE(3432),
    [sym_preproc_line] = STATE(3432),
    [sym_preproc_pragma] = STATE(3432),
    [sym_preproc_nullable] = STATE(3432),
    [sym_preproc_error] = STATE(3432),
    [sym_preproc_define] = STATE(3432),
    [sym_preproc_undef] = STATE(3432),
    [sym__identifier_token] = ACTIONS(3709),
    [anon_sym_extern] = ACTIONS(3709),
    [anon_sym_alias] = ACTIONS(3709),
    [anon_sym_global] = ACTIONS(3709),
    [anon_sym_using] = ACTIONS(3709),
    [anon_sym_unsafe] = ACTIONS(3709),
    [anon_sym_static] = ACTIONS(3709),
    [anon_sym_LBRACK] = ACTIONS(3711),
    [anon_sym_LPAREN] = ACTIONS(3711),
    [anon_sym_event] = ACTIONS(3709),
    [anon_sym_namespace] = ACTIONS(3709),
    [anon_sym_class] = ACTIONS(3709),
    [anon_sym_ref] = ACTIONS(3709),
    [anon_sym_struct] = ACTIONS(3709),
    [anon_sym_enum] = ACTIONS(3709),
    [anon_sym_RBRACE] = ACTIONS(3711),
    [anon_sym_interface] = ACTIONS(3709),
    [anon_sym_delegate] = ACTIONS(3709),
    [anon_sym_record] = ACTIONS(3709),
    [anon_sym_abstract] = ACTIONS(3709),
    [anon_sym_async] = ACTIONS(3709),
    [anon_sym_const] = ACTIONS(3709),
    [anon_sym_file] = ACTIONS(3709),
    [anon_sym_fixed] = ACTIONS(3709),
    [anon_sym_internal] = ACTIONS(3709),
    [anon_sym_new] = ACTIONS(3709),
    [anon_sym_override] = ACTIONS(3709),
    [anon_sym_partial] = ACTIONS(3709),
    [anon_sym_private] = ACTIONS(3709),
    [anon_sym_protected] = ACTIONS(3709),
    [anon_sym_public] = ACTIONS(3709),
    [anon_sym_readonly] = ACTIONS(3709),
    [anon_sym_required] = ACTIONS(3709),
    [anon_sym_sealed] = ACTIONS(3709),
    [anon_sym_virtual] = ACTIONS(3709),
    [anon_sym_volatile] = ACTIONS(3709),
    [anon_sym_where] = ACTIONS(3709),
    [anon_sym_notnull] = ACTIONS(3709),
    [anon_sym_unmanaged] = ACTIONS(3709),
    [anon_sym_TILDE] = ACTIONS(3711),
    [anon_sym_implicit] = ACTIONS(3709),
    [anon_sym_explicit] = ACTIONS(3709),
    [anon_sym_scoped] = ACTIONS(3709),
    [anon_sym_var] = ACTIONS(3709),
    [sym_predefined_type] = ACTIONS(3709),
    [anon_sym_yield] = ACTIONS(3709),
    [anon_sym_when] = ACTIONS(3709),
    [anon_sym_from] = ACTIONS(3709),
    [anon_sym_into] = ACTIONS(3709),
    [anon_sym_join] = ACTIONS(3709),
    [anon_sym_on] = ACTIONS(3709),
    [anon_sym_equals] = ACTIONS(3709),
    [anon_sym_let] = ACTIONS(3709),
    [anon_sym_orderby] = ACTIONS(3709),
    [anon_sym_ascending] = ACTIONS(3709),
    [anon_sym_descending] = ACTIONS(3709),
    [anon_sym_group] = ACTIONS(3709),
    [anon_sym_by] = ACTIONS(3709),
    [anon_sym_select] = ACTIONS(3709),
    [aux_sym_preproc_if_token1] = ACTIONS(3711),
    [aux_sym_preproc_if_token3] = ACTIONS(3711),
    [aux_sym_preproc_else_token1] = ACTIONS(3711),
    [aux_sym_preproc_elif_token1] = ACTIONS(3711),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3433] = {
    [sym_preproc_region] = STATE(3433),
    [sym_preproc_endregion] = STATE(3433),
    [sym_preproc_line] = STATE(3433),
    [sym_preproc_pragma] = STATE(3433),
    [sym_preproc_nullable] = STATE(3433),
    [sym_preproc_error] = STATE(3433),
    [sym_preproc_define] = STATE(3433),
    [sym_preproc_undef] = STATE(3433),
    [sym__identifier_token] = ACTIONS(3693),
    [anon_sym_extern] = ACTIONS(3693),
    [anon_sym_alias] = ACTIONS(3693),
    [anon_sym_global] = ACTIONS(3693),
    [anon_sym_using] = ACTIONS(3693),
    [anon_sym_unsafe] = ACTIONS(3693),
    [anon_sym_static] = ACTIONS(3693),
    [anon_sym_LBRACK] = ACTIONS(3695),
    [anon_sym_LPAREN] = ACTIONS(3695),
    [anon_sym_event] = ACTIONS(3693),
    [anon_sym_namespace] = ACTIONS(3693),
    [anon_sym_class] = ACTIONS(3693),
    [anon_sym_ref] = ACTIONS(3693),
    [anon_sym_struct] = ACTIONS(3693),
    [anon_sym_enum] = ACTIONS(3693),
    [anon_sym_RBRACE] = ACTIONS(3695),
    [anon_sym_interface] = ACTIONS(3693),
    [anon_sym_delegate] = ACTIONS(3693),
    [anon_sym_record] = ACTIONS(3693),
    [anon_sym_abstract] = ACTIONS(3693),
    [anon_sym_async] = ACTIONS(3693),
    [anon_sym_const] = ACTIONS(3693),
    [anon_sym_file] = ACTIONS(3693),
    [anon_sym_fixed] = ACTIONS(3693),
    [anon_sym_internal] = ACTIONS(3693),
    [anon_sym_new] = ACTIONS(3693),
    [anon_sym_override] = ACTIONS(3693),
    [anon_sym_partial] = ACTIONS(3693),
    [anon_sym_private] = ACTIONS(3693),
    [anon_sym_protected] = ACTIONS(3693),
    [anon_sym_public] = ACTIONS(3693),
    [anon_sym_readonly] = ACTIONS(3693),
    [anon_sym_required] = ACTIONS(3693),
    [anon_sym_sealed] = ACTIONS(3693),
    [anon_sym_virtual] = ACTIONS(3693),
    [anon_sym_volatile] = ACTIONS(3693),
    [anon_sym_where] = ACTIONS(3693),
    [anon_sym_notnull] = ACTIONS(3693),
    [anon_sym_unmanaged] = ACTIONS(3693),
    [anon_sym_TILDE] = ACTIONS(3695),
    [anon_sym_implicit] = ACTIONS(3693),
    [anon_sym_explicit] = ACTIONS(3693),
    [anon_sym_scoped] = ACTIONS(3693),
    [anon_sym_var] = ACTIONS(3693),
    [sym_predefined_type] = ACTIONS(3693),
    [anon_sym_yield] = ACTIONS(3693),
    [anon_sym_when] = ACTIONS(3693),
    [anon_sym_from] = ACTIONS(3693),
    [anon_sym_into] = ACTIONS(3693),
    [anon_sym_join] = ACTIONS(3693),
    [anon_sym_on] = ACTIONS(3693),
    [anon_sym_equals] = ACTIONS(3693),
    [anon_sym_let] = ACTIONS(3693),
    [anon_sym_orderby] = ACTIONS(3693),
    [anon_sym_ascending] = ACTIONS(3693),
    [anon_sym_descending] = ACTIONS(3693),
    [anon_sym_group] = ACTIONS(3693),
    [anon_sym_by] = ACTIONS(3693),
    [anon_sym_select] = ACTIONS(3693),
    [aux_sym_preproc_if_token1] = ACTIONS(3695),
    [aux_sym_preproc_if_token3] = ACTIONS(3695),
    [aux_sym_preproc_else_token1] = ACTIONS(3695),
    [aux_sym_preproc_elif_token1] = ACTIONS(3695),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3434] = {
    [sym_preproc_region] = STATE(3434),
    [sym_preproc_endregion] = STATE(3434),
    [sym_preproc_line] = STATE(3434),
    [sym_preproc_pragma] = STATE(3434),
    [sym_preproc_nullable] = STATE(3434),
    [sym_preproc_error] = STATE(3434),
    [sym_preproc_define] = STATE(3434),
    [sym_preproc_undef] = STATE(3434),
    [sym__identifier_token] = ACTIONS(4422),
    [anon_sym_alias] = ACTIONS(4422),
    [anon_sym_global] = ACTIONS(4422),
    [anon_sym_LBRACK] = ACTIONS(4547),
    [anon_sym_COLON] = ACTIONS(4424),
    [anon_sym_COMMA] = ACTIONS(4424),
    [anon_sym_LPAREN] = ACTIONS(4424),
    [anon_sym_LBRACE] = ACTIONS(4424),
    [anon_sym_file] = ACTIONS(4422),
    [anon_sym_LT] = ACTIONS(4422),
    [anon_sym_GT] = ACTIONS(4422),
    [anon_sym_where] = ACTIONS(4422),
    [anon_sym_QMARK] = ACTIONS(4932),
    [anon_sym_notnull] = ACTIONS(4422),
    [anon_sym_unmanaged] = ACTIONS(4422),
    [anon_sym_BANG] = ACTIONS(4422),
    [anon_sym_PLUS_PLUS] = ACTIONS(4424),
    [anon_sym_DASH_DASH] = ACTIONS(4424),
    [anon_sym_PLUS] = ACTIONS(4422),
    [anon_sym_DASH] = ACTIONS(4422),
    [anon_sym_STAR] = ACTIONS(4424),
    [anon_sym_SLASH] = ACTIONS(4422),
    [anon_sym_PERCENT] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4424),
    [anon_sym_PIPE] = ACTIONS(4422),
    [anon_sym_AMP] = ACTIONS(4422),
    [anon_sym_LT_LT] = ACTIONS(4424),
    [anon_sym_GT_GT] = ACTIONS(4422),
    [anon_sym_GT_GT_GT] = ACTIONS(4424),
    [anon_sym_EQ_EQ] = ACTIONS(4424),
    [anon_sym_BANG_EQ] = ACTIONS(4424),
    [anon_sym_GT_EQ] = ACTIONS(4424),
    [anon_sym_LT_EQ] = ACTIONS(4424),
    [anon_sym_DOT] = ACTIONS(4422),
    [anon_sym_scoped] = ACTIONS(4422),
    [anon_sym_var] = ACTIONS(4422),
    [anon_sym_yield] = ACTIONS(4422),
    [anon_sym_switch] = ACTIONS(4422),
    [anon_sym_when] = ACTIONS(4422),
    [sym_discard] = ACTIONS(4422),
    [anon_sym_DOT_DOT] = ACTIONS(4424),
    [anon_sym_and] = ACTIONS(4422),
    [anon_sym_or] = ACTIONS(4422),
    [anon_sym_AMP_AMP] = ACTIONS(4424),
    [anon_sym_PIPE_PIPE] = ACTIONS(4424),
    [anon_sym_QMARK_QMARK] = ACTIONS(4424),
    [anon_sym_from] = ACTIONS(4422),
    [anon_sym_into] = ACTIONS(4422),
    [anon_sym_join] = ACTIONS(4422),
    [anon_sym_on] = ACTIONS(4422),
    [anon_sym_equals] = ACTIONS(4422),
    [anon_sym_let] = ACTIONS(4422),
    [anon_sym_orderby] = ACTIONS(4422),
    [anon_sym_ascending] = ACTIONS(4422),
    [anon_sym_descending] = ACTIONS(4422),
    [anon_sym_group] = ACTIONS(4422),
    [anon_sym_by] = ACTIONS(4422),
    [anon_sym_select] = ACTIONS(4422),
    [anon_sym_as] = ACTIONS(4422),
    [anon_sym_is] = ACTIONS(4422),
    [anon_sym_DASH_GT] = ACTIONS(4424),
    [anon_sym_with] = ACTIONS(4422),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4424),
  },
  [3435] = {
    [sym_preproc_region] = STATE(3435),
    [sym_preproc_endregion] = STATE(3435),
    [sym_preproc_line] = STATE(3435),
    [sym_preproc_pragma] = STATE(3435),
    [sym_preproc_nullable] = STATE(3435),
    [sym_preproc_error] = STATE(3435),
    [sym_preproc_define] = STATE(3435),
    [sym_preproc_undef] = STATE(3435),
    [sym__identifier_token] = ACTIONS(4422),
    [anon_sym_alias] = ACTIONS(4422),
    [anon_sym_global] = ACTIONS(4422),
    [anon_sym_LBRACK] = ACTIONS(4547),
    [anon_sym_COLON] = ACTIONS(4424),
    [anon_sym_COMMA] = ACTIONS(4424),
    [anon_sym_LPAREN] = ACTIONS(4424),
    [anon_sym_LBRACE] = ACTIONS(4424),
    [anon_sym_file] = ACTIONS(4422),
    [anon_sym_LT] = ACTIONS(4422),
    [anon_sym_GT] = ACTIONS(4422),
    [anon_sym_where] = ACTIONS(4422),
    [anon_sym_QMARK] = ACTIONS(4422),
    [anon_sym_notnull] = ACTIONS(4422),
    [anon_sym_unmanaged] = ACTIONS(4422),
    [anon_sym_BANG] = ACTIONS(4422),
    [anon_sym_PLUS_PLUS] = ACTIONS(4424),
    [anon_sym_DASH_DASH] = ACTIONS(4424),
    [anon_sym_PLUS] = ACTIONS(4422),
    [anon_sym_DASH] = ACTIONS(4422),
    [anon_sym_STAR] = ACTIONS(4553),
    [anon_sym_SLASH] = ACTIONS(4422),
    [anon_sym_PERCENT] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4424),
    [anon_sym_PIPE] = ACTIONS(4422),
    [anon_sym_AMP] = ACTIONS(4422),
    [anon_sym_LT_LT] = ACTIONS(4424),
    [anon_sym_GT_GT] = ACTIONS(4422),
    [anon_sym_GT_GT_GT] = ACTIONS(4424),
    [anon_sym_EQ_EQ] = ACTIONS(4424),
    [anon_sym_BANG_EQ] = ACTIONS(4424),
    [anon_sym_GT_EQ] = ACTIONS(4424),
    [anon_sym_LT_EQ] = ACTIONS(4424),
    [anon_sym_DOT] = ACTIONS(4422),
    [anon_sym_scoped] = ACTIONS(4422),
    [anon_sym_var] = ACTIONS(4422),
    [anon_sym_yield] = ACTIONS(4422),
    [anon_sym_switch] = ACTIONS(4422),
    [anon_sym_when] = ACTIONS(4422),
    [sym_discard] = ACTIONS(4422),
    [anon_sym_DOT_DOT] = ACTIONS(4424),
    [anon_sym_and] = ACTIONS(4422),
    [anon_sym_or] = ACTIONS(4422),
    [anon_sym_AMP_AMP] = ACTIONS(4424),
    [anon_sym_PIPE_PIPE] = ACTIONS(4424),
    [anon_sym_QMARK_QMARK] = ACTIONS(4424),
    [anon_sym_from] = ACTIONS(4422),
    [anon_sym_into] = ACTIONS(4422),
    [anon_sym_join] = ACTIONS(4422),
    [anon_sym_on] = ACTIONS(4422),
    [anon_sym_equals] = ACTIONS(4422),
    [anon_sym_let] = ACTIONS(4422),
    [anon_sym_orderby] = ACTIONS(4422),
    [anon_sym_ascending] = ACTIONS(4422),
    [anon_sym_descending] = ACTIONS(4422),
    [anon_sym_group] = ACTIONS(4422),
    [anon_sym_by] = ACTIONS(4422),
    [anon_sym_select] = ACTIONS(4422),
    [anon_sym_as] = ACTIONS(4422),
    [anon_sym_is] = ACTIONS(4422),
    [anon_sym_DASH_GT] = ACTIONS(4424),
    [anon_sym_with] = ACTIONS(4422),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4424),
  },
  [3436] = {
    [sym_preproc_region] = STATE(3436),
    [sym_preproc_endregion] = STATE(3436),
    [sym_preproc_line] = STATE(3436),
    [sym_preproc_pragma] = STATE(3436),
    [sym_preproc_nullable] = STATE(3436),
    [sym_preproc_error] = STATE(3436),
    [sym_preproc_define] = STATE(3436),
    [sym_preproc_undef] = STATE(3436),
    [sym__identifier_token] = ACTIONS(4422),
    [anon_sym_alias] = ACTIONS(4422),
    [anon_sym_global] = ACTIONS(4422),
    [anon_sym_LBRACK] = ACTIONS(4547),
    [anon_sym_COLON] = ACTIONS(4424),
    [anon_sym_COMMA] = ACTIONS(4424),
    [anon_sym_LPAREN] = ACTIONS(4424),
    [anon_sym_LBRACE] = ACTIONS(4424),
    [anon_sym_file] = ACTIONS(4422),
    [anon_sym_LT] = ACTIONS(4422),
    [anon_sym_GT] = ACTIONS(4422),
    [anon_sym_where] = ACTIONS(4422),
    [anon_sym_QMARK] = ACTIONS(4932),
    [anon_sym_notnull] = ACTIONS(4422),
    [anon_sym_unmanaged] = ACTIONS(4422),
    [anon_sym_BANG] = ACTIONS(4422),
    [anon_sym_PLUS_PLUS] = ACTIONS(4424),
    [anon_sym_DASH_DASH] = ACTIONS(4424),
    [anon_sym_PLUS] = ACTIONS(4422),
    [anon_sym_DASH] = ACTIONS(4422),
    [anon_sym_STAR] = ACTIONS(4553),
    [anon_sym_SLASH] = ACTIONS(4422),
    [anon_sym_PERCENT] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4424),
    [anon_sym_PIPE] = ACTIONS(4422),
    [anon_sym_AMP] = ACTIONS(4422),
    [anon_sym_LT_LT] = ACTIONS(4424),
    [anon_sym_GT_GT] = ACTIONS(4422),
    [anon_sym_GT_GT_GT] = ACTIONS(4424),
    [anon_sym_EQ_EQ] = ACTIONS(4424),
    [anon_sym_BANG_EQ] = ACTIONS(4424),
    [anon_sym_GT_EQ] = ACTIONS(4424),
    [anon_sym_LT_EQ] = ACTIONS(4424),
    [anon_sym_DOT] = ACTIONS(4422),
    [anon_sym_scoped] = ACTIONS(4422),
    [anon_sym_var] = ACTIONS(4422),
    [anon_sym_yield] = ACTIONS(4422),
    [anon_sym_switch] = ACTIONS(4422),
    [anon_sym_when] = ACTIONS(4422),
    [sym_discard] = ACTIONS(4422),
    [anon_sym_DOT_DOT] = ACTIONS(4424),
    [anon_sym_and] = ACTIONS(4422),
    [anon_sym_or] = ACTIONS(4422),
    [anon_sym_AMP_AMP] = ACTIONS(4424),
    [anon_sym_PIPE_PIPE] = ACTIONS(4424),
    [anon_sym_QMARK_QMARK] = ACTIONS(4424),
    [anon_sym_from] = ACTIONS(4422),
    [anon_sym_into] = ACTIONS(4422),
    [anon_sym_join] = ACTIONS(4422),
    [anon_sym_on] = ACTIONS(4422),
    [anon_sym_equals] = ACTIONS(4422),
    [anon_sym_let] = ACTIONS(4422),
    [anon_sym_orderby] = ACTIONS(4422),
    [anon_sym_ascending] = ACTIONS(4422),
    [anon_sym_descending] = ACTIONS(4422),
    [anon_sym_group] = ACTIONS(4422),
    [anon_sym_by] = ACTIONS(4422),
    [anon_sym_select] = ACTIONS(4422),
    [anon_sym_as] = ACTIONS(4422),
    [anon_sym_is] = ACTIONS(4422),
    [anon_sym_DASH_GT] = ACTIONS(4424),
    [anon_sym_with] = ACTIONS(4422),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4424),
  },
  [3437] = {
    [sym_preproc_region] = STATE(3437),
    [sym_preproc_endregion] = STATE(3437),
    [sym_preproc_line] = STATE(3437),
    [sym_preproc_pragma] = STATE(3437),
    [sym_preproc_nullable] = STATE(3437),
    [sym_preproc_error] = STATE(3437),
    [sym_preproc_define] = STATE(3437),
    [sym_preproc_undef] = STATE(3437),
    [sym__identifier_token] = ACTIONS(3689),
    [anon_sym_extern] = ACTIONS(3689),
    [anon_sym_alias] = ACTIONS(3689),
    [anon_sym_global] = ACTIONS(3689),
    [anon_sym_using] = ACTIONS(3689),
    [anon_sym_unsafe] = ACTIONS(3689),
    [anon_sym_static] = ACTIONS(3689),
    [anon_sym_LBRACK] = ACTIONS(3691),
    [anon_sym_LPAREN] = ACTIONS(3691),
    [anon_sym_event] = ACTIONS(3689),
    [anon_sym_namespace] = ACTIONS(3689),
    [anon_sym_class] = ACTIONS(3689),
    [anon_sym_ref] = ACTIONS(3689),
    [anon_sym_struct] = ACTIONS(3689),
    [anon_sym_enum] = ACTIONS(3689),
    [anon_sym_RBRACE] = ACTIONS(3691),
    [anon_sym_interface] = ACTIONS(3689),
    [anon_sym_delegate] = ACTIONS(3689),
    [anon_sym_record] = ACTIONS(3689),
    [anon_sym_abstract] = ACTIONS(3689),
    [anon_sym_async] = ACTIONS(3689),
    [anon_sym_const] = ACTIONS(3689),
    [anon_sym_file] = ACTIONS(3689),
    [anon_sym_fixed] = ACTIONS(3689),
    [anon_sym_internal] = ACTIONS(3689),
    [anon_sym_new] = ACTIONS(3689),
    [anon_sym_override] = ACTIONS(3689),
    [anon_sym_partial] = ACTIONS(3689),
    [anon_sym_private] = ACTIONS(3689),
    [anon_sym_protected] = ACTIONS(3689),
    [anon_sym_public] = ACTIONS(3689),
    [anon_sym_readonly] = ACTIONS(3689),
    [anon_sym_required] = ACTIONS(3689),
    [anon_sym_sealed] = ACTIONS(3689),
    [anon_sym_virtual] = ACTIONS(3689),
    [anon_sym_volatile] = ACTIONS(3689),
    [anon_sym_where] = ACTIONS(3689),
    [anon_sym_notnull] = ACTIONS(3689),
    [anon_sym_unmanaged] = ACTIONS(3689),
    [anon_sym_TILDE] = ACTIONS(3691),
    [anon_sym_implicit] = ACTIONS(3689),
    [anon_sym_explicit] = ACTIONS(3689),
    [anon_sym_scoped] = ACTIONS(3689),
    [anon_sym_var] = ACTIONS(3689),
    [sym_predefined_type] = ACTIONS(3689),
    [anon_sym_yield] = ACTIONS(3689),
    [anon_sym_when] = ACTIONS(3689),
    [anon_sym_from] = ACTIONS(3689),
    [anon_sym_into] = ACTIONS(3689),
    [anon_sym_join] = ACTIONS(3689),
    [anon_sym_on] = ACTIONS(3689),
    [anon_sym_equals] = ACTIONS(3689),
    [anon_sym_let] = ACTIONS(3689),
    [anon_sym_orderby] = ACTIONS(3689),
    [anon_sym_ascending] = ACTIONS(3689),
    [anon_sym_descending] = ACTIONS(3689),
    [anon_sym_group] = ACTIONS(3689),
    [anon_sym_by] = ACTIONS(3689),
    [anon_sym_select] = ACTIONS(3689),
    [aux_sym_preproc_if_token1] = ACTIONS(3691),
    [aux_sym_preproc_if_token3] = ACTIONS(3691),
    [aux_sym_preproc_else_token1] = ACTIONS(3691),
    [aux_sym_preproc_elif_token1] = ACTIONS(3691),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3438] = {
    [sym_preproc_region] = STATE(3438),
    [sym_preproc_endregion] = STATE(3438),
    [sym_preproc_line] = STATE(3438),
    [sym_preproc_pragma] = STATE(3438),
    [sym_preproc_nullable] = STATE(3438),
    [sym_preproc_error] = STATE(3438),
    [sym_preproc_define] = STATE(3438),
    [sym_preproc_undef] = STATE(3438),
    [sym__identifier_token] = ACTIONS(3685),
    [anon_sym_extern] = ACTIONS(3685),
    [anon_sym_alias] = ACTIONS(3685),
    [anon_sym_global] = ACTIONS(3685),
    [anon_sym_using] = ACTIONS(3685),
    [anon_sym_unsafe] = ACTIONS(3685),
    [anon_sym_static] = ACTIONS(3685),
    [anon_sym_LBRACK] = ACTIONS(3687),
    [anon_sym_LPAREN] = ACTIONS(3687),
    [anon_sym_event] = ACTIONS(3685),
    [anon_sym_namespace] = ACTIONS(3685),
    [anon_sym_class] = ACTIONS(3685),
    [anon_sym_ref] = ACTIONS(3685),
    [anon_sym_struct] = ACTIONS(3685),
    [anon_sym_enum] = ACTIONS(3685),
    [anon_sym_RBRACE] = ACTIONS(3687),
    [anon_sym_interface] = ACTIONS(3685),
    [anon_sym_delegate] = ACTIONS(3685),
    [anon_sym_record] = ACTIONS(3685),
    [anon_sym_abstract] = ACTIONS(3685),
    [anon_sym_async] = ACTIONS(3685),
    [anon_sym_const] = ACTIONS(3685),
    [anon_sym_file] = ACTIONS(3685),
    [anon_sym_fixed] = ACTIONS(3685),
    [anon_sym_internal] = ACTIONS(3685),
    [anon_sym_new] = ACTIONS(3685),
    [anon_sym_override] = ACTIONS(3685),
    [anon_sym_partial] = ACTIONS(3685),
    [anon_sym_private] = ACTIONS(3685),
    [anon_sym_protected] = ACTIONS(3685),
    [anon_sym_public] = ACTIONS(3685),
    [anon_sym_readonly] = ACTIONS(3685),
    [anon_sym_required] = ACTIONS(3685),
    [anon_sym_sealed] = ACTIONS(3685),
    [anon_sym_virtual] = ACTIONS(3685),
    [anon_sym_volatile] = ACTIONS(3685),
    [anon_sym_where] = ACTIONS(3685),
    [anon_sym_notnull] = ACTIONS(3685),
    [anon_sym_unmanaged] = ACTIONS(3685),
    [anon_sym_TILDE] = ACTIONS(3687),
    [anon_sym_implicit] = ACTIONS(3685),
    [anon_sym_explicit] = ACTIONS(3685),
    [anon_sym_scoped] = ACTIONS(3685),
    [anon_sym_var] = ACTIONS(3685),
    [sym_predefined_type] = ACTIONS(3685),
    [anon_sym_yield] = ACTIONS(3685),
    [anon_sym_when] = ACTIONS(3685),
    [anon_sym_from] = ACTIONS(3685),
    [anon_sym_into] = ACTIONS(3685),
    [anon_sym_join] = ACTIONS(3685),
    [anon_sym_on] = ACTIONS(3685),
    [anon_sym_equals] = ACTIONS(3685),
    [anon_sym_let] = ACTIONS(3685),
    [anon_sym_orderby] = ACTIONS(3685),
    [anon_sym_ascending] = ACTIONS(3685),
    [anon_sym_descending] = ACTIONS(3685),
    [anon_sym_group] = ACTIONS(3685),
    [anon_sym_by] = ACTIONS(3685),
    [anon_sym_select] = ACTIONS(3685),
    [aux_sym_preproc_if_token1] = ACTIONS(3687),
    [aux_sym_preproc_if_token3] = ACTIONS(3687),
    [aux_sym_preproc_else_token1] = ACTIONS(3687),
    [aux_sym_preproc_elif_token1] = ACTIONS(3687),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3439] = {
    [sym_preproc_region] = STATE(3439),
    [sym_preproc_endregion] = STATE(3439),
    [sym_preproc_line] = STATE(3439),
    [sym_preproc_pragma] = STATE(3439),
    [sym_preproc_nullable] = STATE(3439),
    [sym_preproc_error] = STATE(3439),
    [sym_preproc_define] = STATE(3439),
    [sym_preproc_undef] = STATE(3439),
    [sym__identifier_token] = ACTIONS(3677),
    [anon_sym_extern] = ACTIONS(3677),
    [anon_sym_alias] = ACTIONS(3677),
    [anon_sym_global] = ACTIONS(3677),
    [anon_sym_using] = ACTIONS(3677),
    [anon_sym_unsafe] = ACTIONS(3677),
    [anon_sym_static] = ACTIONS(3677),
    [anon_sym_LBRACK] = ACTIONS(3679),
    [anon_sym_LPAREN] = ACTIONS(3679),
    [anon_sym_event] = ACTIONS(3677),
    [anon_sym_namespace] = ACTIONS(3677),
    [anon_sym_class] = ACTIONS(3677),
    [anon_sym_ref] = ACTIONS(3677),
    [anon_sym_struct] = ACTIONS(3677),
    [anon_sym_enum] = ACTIONS(3677),
    [anon_sym_RBRACE] = ACTIONS(3679),
    [anon_sym_interface] = ACTIONS(3677),
    [anon_sym_delegate] = ACTIONS(3677),
    [anon_sym_record] = ACTIONS(3677),
    [anon_sym_abstract] = ACTIONS(3677),
    [anon_sym_async] = ACTIONS(3677),
    [anon_sym_const] = ACTIONS(3677),
    [anon_sym_file] = ACTIONS(3677),
    [anon_sym_fixed] = ACTIONS(3677),
    [anon_sym_internal] = ACTIONS(3677),
    [anon_sym_new] = ACTIONS(3677),
    [anon_sym_override] = ACTIONS(3677),
    [anon_sym_partial] = ACTIONS(3677),
    [anon_sym_private] = ACTIONS(3677),
    [anon_sym_protected] = ACTIONS(3677),
    [anon_sym_public] = ACTIONS(3677),
    [anon_sym_readonly] = ACTIONS(3677),
    [anon_sym_required] = ACTIONS(3677),
    [anon_sym_sealed] = ACTIONS(3677),
    [anon_sym_virtual] = ACTIONS(3677),
    [anon_sym_volatile] = ACTIONS(3677),
    [anon_sym_where] = ACTIONS(3677),
    [anon_sym_notnull] = ACTIONS(3677),
    [anon_sym_unmanaged] = ACTIONS(3677),
    [anon_sym_TILDE] = ACTIONS(3679),
    [anon_sym_implicit] = ACTIONS(3677),
    [anon_sym_explicit] = ACTIONS(3677),
    [anon_sym_scoped] = ACTIONS(3677),
    [anon_sym_var] = ACTIONS(3677),
    [sym_predefined_type] = ACTIONS(3677),
    [anon_sym_yield] = ACTIONS(3677),
    [anon_sym_when] = ACTIONS(3677),
    [anon_sym_from] = ACTIONS(3677),
    [anon_sym_into] = ACTIONS(3677),
    [anon_sym_join] = ACTIONS(3677),
    [anon_sym_on] = ACTIONS(3677),
    [anon_sym_equals] = ACTIONS(3677),
    [anon_sym_let] = ACTIONS(3677),
    [anon_sym_orderby] = ACTIONS(3677),
    [anon_sym_ascending] = ACTIONS(3677),
    [anon_sym_descending] = ACTIONS(3677),
    [anon_sym_group] = ACTIONS(3677),
    [anon_sym_by] = ACTIONS(3677),
    [anon_sym_select] = ACTIONS(3677),
    [aux_sym_preproc_if_token1] = ACTIONS(3679),
    [aux_sym_preproc_if_token3] = ACTIONS(3679),
    [aux_sym_preproc_else_token1] = ACTIONS(3679),
    [aux_sym_preproc_elif_token1] = ACTIONS(3679),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3440] = {
    [sym_preproc_region] = STATE(3440),
    [sym_preproc_endregion] = STATE(3440),
    [sym_preproc_line] = STATE(3440),
    [sym_preproc_pragma] = STATE(3440),
    [sym_preproc_nullable] = STATE(3440),
    [sym_preproc_error] = STATE(3440),
    [sym_preproc_define] = STATE(3440),
    [sym_preproc_undef] = STATE(3440),
    [sym__identifier_token] = ACTIONS(3421),
    [anon_sym_extern] = ACTIONS(3421),
    [anon_sym_alias] = ACTIONS(3421),
    [anon_sym_global] = ACTIONS(3421),
    [anon_sym_using] = ACTIONS(3421),
    [anon_sym_unsafe] = ACTIONS(3421),
    [anon_sym_static] = ACTIONS(3421),
    [anon_sym_LBRACK] = ACTIONS(3423),
    [anon_sym_LPAREN] = ACTIONS(3423),
    [anon_sym_event] = ACTIONS(3421),
    [anon_sym_namespace] = ACTIONS(3421),
    [anon_sym_class] = ACTIONS(3421),
    [anon_sym_ref] = ACTIONS(3421),
    [anon_sym_struct] = ACTIONS(3421),
    [anon_sym_enum] = ACTIONS(3421),
    [anon_sym_RBRACE] = ACTIONS(3423),
    [anon_sym_interface] = ACTIONS(3421),
    [anon_sym_delegate] = ACTIONS(3421),
    [anon_sym_record] = ACTIONS(3421),
    [anon_sym_abstract] = ACTIONS(3421),
    [anon_sym_async] = ACTIONS(3421),
    [anon_sym_const] = ACTIONS(3421),
    [anon_sym_file] = ACTIONS(3421),
    [anon_sym_fixed] = ACTIONS(3421),
    [anon_sym_internal] = ACTIONS(3421),
    [anon_sym_new] = ACTIONS(3421),
    [anon_sym_override] = ACTIONS(3421),
    [anon_sym_partial] = ACTIONS(3421),
    [anon_sym_private] = ACTIONS(3421),
    [anon_sym_protected] = ACTIONS(3421),
    [anon_sym_public] = ACTIONS(3421),
    [anon_sym_readonly] = ACTIONS(3421),
    [anon_sym_required] = ACTIONS(3421),
    [anon_sym_sealed] = ACTIONS(3421),
    [anon_sym_virtual] = ACTIONS(3421),
    [anon_sym_volatile] = ACTIONS(3421),
    [anon_sym_where] = ACTIONS(3421),
    [anon_sym_notnull] = ACTIONS(3421),
    [anon_sym_unmanaged] = ACTIONS(3421),
    [anon_sym_TILDE] = ACTIONS(3423),
    [anon_sym_implicit] = ACTIONS(3421),
    [anon_sym_explicit] = ACTIONS(3421),
    [anon_sym_scoped] = ACTIONS(3421),
    [anon_sym_var] = ACTIONS(3421),
    [sym_predefined_type] = ACTIONS(3421),
    [anon_sym_yield] = ACTIONS(3421),
    [anon_sym_when] = ACTIONS(3421),
    [anon_sym_from] = ACTIONS(3421),
    [anon_sym_into] = ACTIONS(3421),
    [anon_sym_join] = ACTIONS(3421),
    [anon_sym_on] = ACTIONS(3421),
    [anon_sym_equals] = ACTIONS(3421),
    [anon_sym_let] = ACTIONS(3421),
    [anon_sym_orderby] = ACTIONS(3421),
    [anon_sym_ascending] = ACTIONS(3421),
    [anon_sym_descending] = ACTIONS(3421),
    [anon_sym_group] = ACTIONS(3421),
    [anon_sym_by] = ACTIONS(3421),
    [anon_sym_select] = ACTIONS(3421),
    [aux_sym_preproc_if_token1] = ACTIONS(3423),
    [aux_sym_preproc_if_token3] = ACTIONS(3423),
    [aux_sym_preproc_else_token1] = ACTIONS(3423),
    [aux_sym_preproc_elif_token1] = ACTIONS(3423),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3441] = {
    [sym_preproc_region] = STATE(3441),
    [sym_preproc_endregion] = STATE(3441),
    [sym_preproc_line] = STATE(3441),
    [sym_preproc_pragma] = STATE(3441),
    [sym_preproc_nullable] = STATE(3441),
    [sym_preproc_error] = STATE(3441),
    [sym_preproc_define] = STATE(3441),
    [sym_preproc_undef] = STATE(3441),
    [sym__identifier_token] = ACTIONS(5087),
    [anon_sym_extern] = ACTIONS(5087),
    [anon_sym_alias] = ACTIONS(5087),
    [anon_sym_global] = ACTIONS(5087),
    [anon_sym_using] = ACTIONS(5087),
    [anon_sym_unsafe] = ACTIONS(5087),
    [anon_sym_static] = ACTIONS(5087),
    [anon_sym_LBRACK] = ACTIONS(5089),
    [anon_sym_LPAREN] = ACTIONS(5089),
    [anon_sym_event] = ACTIONS(5087),
    [anon_sym_namespace] = ACTIONS(5087),
    [anon_sym_class] = ACTIONS(5087),
    [anon_sym_ref] = ACTIONS(5087),
    [anon_sym_struct] = ACTIONS(5087),
    [anon_sym_enum] = ACTIONS(5087),
    [anon_sym_RBRACE] = ACTIONS(5089),
    [anon_sym_interface] = ACTIONS(5087),
    [anon_sym_delegate] = ACTIONS(5087),
    [anon_sym_record] = ACTIONS(5087),
    [anon_sym_abstract] = ACTIONS(5087),
    [anon_sym_async] = ACTIONS(5087),
    [anon_sym_const] = ACTIONS(5087),
    [anon_sym_file] = ACTIONS(5087),
    [anon_sym_fixed] = ACTIONS(5087),
    [anon_sym_internal] = ACTIONS(5087),
    [anon_sym_new] = ACTIONS(5087),
    [anon_sym_override] = ACTIONS(5087),
    [anon_sym_partial] = ACTIONS(5087),
    [anon_sym_private] = ACTIONS(5087),
    [anon_sym_protected] = ACTIONS(5087),
    [anon_sym_public] = ACTIONS(5087),
    [anon_sym_readonly] = ACTIONS(5087),
    [anon_sym_required] = ACTIONS(5087),
    [anon_sym_sealed] = ACTIONS(5087),
    [anon_sym_virtual] = ACTIONS(5087),
    [anon_sym_volatile] = ACTIONS(5087),
    [anon_sym_where] = ACTIONS(5087),
    [anon_sym_notnull] = ACTIONS(5087),
    [anon_sym_unmanaged] = ACTIONS(5087),
    [anon_sym_TILDE] = ACTIONS(5089),
    [anon_sym_implicit] = ACTIONS(5087),
    [anon_sym_explicit] = ACTIONS(5087),
    [anon_sym_scoped] = ACTIONS(5087),
    [anon_sym_var] = ACTIONS(5087),
    [sym_predefined_type] = ACTIONS(5087),
    [anon_sym_yield] = ACTIONS(5087),
    [anon_sym_when] = ACTIONS(5087),
    [anon_sym_from] = ACTIONS(5087),
    [anon_sym_into] = ACTIONS(5087),
    [anon_sym_join] = ACTIONS(5087),
    [anon_sym_on] = ACTIONS(5087),
    [anon_sym_equals] = ACTIONS(5087),
    [anon_sym_let] = ACTIONS(5087),
    [anon_sym_orderby] = ACTIONS(5087),
    [anon_sym_ascending] = ACTIONS(5087),
    [anon_sym_descending] = ACTIONS(5087),
    [anon_sym_group] = ACTIONS(5087),
    [anon_sym_by] = ACTIONS(5087),
    [anon_sym_select] = ACTIONS(5087),
    [aux_sym_preproc_if_token1] = ACTIONS(5089),
    [aux_sym_preproc_if_token3] = ACTIONS(5089),
    [aux_sym_preproc_else_token1] = ACTIONS(5089),
    [aux_sym_preproc_elif_token1] = ACTIONS(5089),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3442] = {
    [sym_preproc_region] = STATE(3442),
    [sym_preproc_endregion] = STATE(3442),
    [sym_preproc_line] = STATE(3442),
    [sym_preproc_pragma] = STATE(3442),
    [sym_preproc_nullable] = STATE(3442),
    [sym_preproc_error] = STATE(3442),
    [sym_preproc_define] = STATE(3442),
    [sym_preproc_undef] = STATE(3442),
    [sym__identifier_token] = ACTIONS(3665),
    [anon_sym_extern] = ACTIONS(3665),
    [anon_sym_alias] = ACTIONS(3665),
    [anon_sym_global] = ACTIONS(3665),
    [anon_sym_using] = ACTIONS(3665),
    [anon_sym_unsafe] = ACTIONS(3665),
    [anon_sym_static] = ACTIONS(3665),
    [anon_sym_LBRACK] = ACTIONS(3667),
    [anon_sym_LPAREN] = ACTIONS(3667),
    [anon_sym_event] = ACTIONS(3665),
    [anon_sym_namespace] = ACTIONS(3665),
    [anon_sym_class] = ACTIONS(3665),
    [anon_sym_ref] = ACTIONS(3665),
    [anon_sym_struct] = ACTIONS(3665),
    [anon_sym_enum] = ACTIONS(3665),
    [anon_sym_RBRACE] = ACTIONS(3667),
    [anon_sym_interface] = ACTIONS(3665),
    [anon_sym_delegate] = ACTIONS(3665),
    [anon_sym_record] = ACTIONS(3665),
    [anon_sym_abstract] = ACTIONS(3665),
    [anon_sym_async] = ACTIONS(3665),
    [anon_sym_const] = ACTIONS(3665),
    [anon_sym_file] = ACTIONS(3665),
    [anon_sym_fixed] = ACTIONS(3665),
    [anon_sym_internal] = ACTIONS(3665),
    [anon_sym_new] = ACTIONS(3665),
    [anon_sym_override] = ACTIONS(3665),
    [anon_sym_partial] = ACTIONS(3665),
    [anon_sym_private] = ACTIONS(3665),
    [anon_sym_protected] = ACTIONS(3665),
    [anon_sym_public] = ACTIONS(3665),
    [anon_sym_readonly] = ACTIONS(3665),
    [anon_sym_required] = ACTIONS(3665),
    [anon_sym_sealed] = ACTIONS(3665),
    [anon_sym_virtual] = ACTIONS(3665),
    [anon_sym_volatile] = ACTIONS(3665),
    [anon_sym_where] = ACTIONS(3665),
    [anon_sym_notnull] = ACTIONS(3665),
    [anon_sym_unmanaged] = ACTIONS(3665),
    [anon_sym_TILDE] = ACTIONS(3667),
    [anon_sym_implicit] = ACTIONS(3665),
    [anon_sym_explicit] = ACTIONS(3665),
    [anon_sym_scoped] = ACTIONS(3665),
    [anon_sym_var] = ACTIONS(3665),
    [sym_predefined_type] = ACTIONS(3665),
    [anon_sym_yield] = ACTIONS(3665),
    [anon_sym_when] = ACTIONS(3665),
    [anon_sym_from] = ACTIONS(3665),
    [anon_sym_into] = ACTIONS(3665),
    [anon_sym_join] = ACTIONS(3665),
    [anon_sym_on] = ACTIONS(3665),
    [anon_sym_equals] = ACTIONS(3665),
    [anon_sym_let] = ACTIONS(3665),
    [anon_sym_orderby] = ACTIONS(3665),
    [anon_sym_ascending] = ACTIONS(3665),
    [anon_sym_descending] = ACTIONS(3665),
    [anon_sym_group] = ACTIONS(3665),
    [anon_sym_by] = ACTIONS(3665),
    [anon_sym_select] = ACTIONS(3665),
    [aux_sym_preproc_if_token1] = ACTIONS(3667),
    [aux_sym_preproc_if_token3] = ACTIONS(3667),
    [aux_sym_preproc_else_token1] = ACTIONS(3667),
    [aux_sym_preproc_elif_token1] = ACTIONS(3667),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3443] = {
    [sym_preproc_region] = STATE(3443),
    [sym_preproc_endregion] = STATE(3443),
    [sym_preproc_line] = STATE(3443),
    [sym_preproc_pragma] = STATE(3443),
    [sym_preproc_nullable] = STATE(3443),
    [sym_preproc_error] = STATE(3443),
    [sym_preproc_define] = STATE(3443),
    [sym_preproc_undef] = STATE(3443),
    [sym__identifier_token] = ACTIONS(3661),
    [anon_sym_extern] = ACTIONS(3661),
    [anon_sym_alias] = ACTIONS(3661),
    [anon_sym_global] = ACTIONS(3661),
    [anon_sym_using] = ACTIONS(3661),
    [anon_sym_unsafe] = ACTIONS(3661),
    [anon_sym_static] = ACTIONS(3661),
    [anon_sym_LBRACK] = ACTIONS(3663),
    [anon_sym_LPAREN] = ACTIONS(3663),
    [anon_sym_event] = ACTIONS(3661),
    [anon_sym_namespace] = ACTIONS(3661),
    [anon_sym_class] = ACTIONS(3661),
    [anon_sym_ref] = ACTIONS(3661),
    [anon_sym_struct] = ACTIONS(3661),
    [anon_sym_enum] = ACTIONS(3661),
    [anon_sym_RBRACE] = ACTIONS(3663),
    [anon_sym_interface] = ACTIONS(3661),
    [anon_sym_delegate] = ACTIONS(3661),
    [anon_sym_record] = ACTIONS(3661),
    [anon_sym_abstract] = ACTIONS(3661),
    [anon_sym_async] = ACTIONS(3661),
    [anon_sym_const] = ACTIONS(3661),
    [anon_sym_file] = ACTIONS(3661),
    [anon_sym_fixed] = ACTIONS(3661),
    [anon_sym_internal] = ACTIONS(3661),
    [anon_sym_new] = ACTIONS(3661),
    [anon_sym_override] = ACTIONS(3661),
    [anon_sym_partial] = ACTIONS(3661),
    [anon_sym_private] = ACTIONS(3661),
    [anon_sym_protected] = ACTIONS(3661),
    [anon_sym_public] = ACTIONS(3661),
    [anon_sym_readonly] = ACTIONS(3661),
    [anon_sym_required] = ACTIONS(3661),
    [anon_sym_sealed] = ACTIONS(3661),
    [anon_sym_virtual] = ACTIONS(3661),
    [anon_sym_volatile] = ACTIONS(3661),
    [anon_sym_where] = ACTIONS(3661),
    [anon_sym_notnull] = ACTIONS(3661),
    [anon_sym_unmanaged] = ACTIONS(3661),
    [anon_sym_TILDE] = ACTIONS(3663),
    [anon_sym_implicit] = ACTIONS(3661),
    [anon_sym_explicit] = ACTIONS(3661),
    [anon_sym_scoped] = ACTIONS(3661),
    [anon_sym_var] = ACTIONS(3661),
    [sym_predefined_type] = ACTIONS(3661),
    [anon_sym_yield] = ACTIONS(3661),
    [anon_sym_when] = ACTIONS(3661),
    [anon_sym_from] = ACTIONS(3661),
    [anon_sym_into] = ACTIONS(3661),
    [anon_sym_join] = ACTIONS(3661),
    [anon_sym_on] = ACTIONS(3661),
    [anon_sym_equals] = ACTIONS(3661),
    [anon_sym_let] = ACTIONS(3661),
    [anon_sym_orderby] = ACTIONS(3661),
    [anon_sym_ascending] = ACTIONS(3661),
    [anon_sym_descending] = ACTIONS(3661),
    [anon_sym_group] = ACTIONS(3661),
    [anon_sym_by] = ACTIONS(3661),
    [anon_sym_select] = ACTIONS(3661),
    [aux_sym_preproc_if_token1] = ACTIONS(3663),
    [aux_sym_preproc_if_token3] = ACTIONS(3663),
    [aux_sym_preproc_else_token1] = ACTIONS(3663),
    [aux_sym_preproc_elif_token1] = ACTIONS(3663),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3444] = {
    [sym_preproc_region] = STATE(3444),
    [sym_preproc_endregion] = STATE(3444),
    [sym_preproc_line] = STATE(3444),
    [sym_preproc_pragma] = STATE(3444),
    [sym_preproc_nullable] = STATE(3444),
    [sym_preproc_error] = STATE(3444),
    [sym_preproc_define] = STATE(3444),
    [sym_preproc_undef] = STATE(3444),
    [sym__identifier_token] = ACTIONS(3641),
    [anon_sym_extern] = ACTIONS(3641),
    [anon_sym_alias] = ACTIONS(3641),
    [anon_sym_global] = ACTIONS(3641),
    [anon_sym_using] = ACTIONS(3641),
    [anon_sym_unsafe] = ACTIONS(3641),
    [anon_sym_static] = ACTIONS(3641),
    [anon_sym_LBRACK] = ACTIONS(3643),
    [anon_sym_LPAREN] = ACTIONS(3643),
    [anon_sym_event] = ACTIONS(3641),
    [anon_sym_namespace] = ACTIONS(3641),
    [anon_sym_class] = ACTIONS(3641),
    [anon_sym_ref] = ACTIONS(3641),
    [anon_sym_struct] = ACTIONS(3641),
    [anon_sym_enum] = ACTIONS(3641),
    [anon_sym_RBRACE] = ACTIONS(3643),
    [anon_sym_interface] = ACTIONS(3641),
    [anon_sym_delegate] = ACTIONS(3641),
    [anon_sym_record] = ACTIONS(3641),
    [anon_sym_abstract] = ACTIONS(3641),
    [anon_sym_async] = ACTIONS(3641),
    [anon_sym_const] = ACTIONS(3641),
    [anon_sym_file] = ACTIONS(3641),
    [anon_sym_fixed] = ACTIONS(3641),
    [anon_sym_internal] = ACTIONS(3641),
    [anon_sym_new] = ACTIONS(3641),
    [anon_sym_override] = ACTIONS(3641),
    [anon_sym_partial] = ACTIONS(3641),
    [anon_sym_private] = ACTIONS(3641),
    [anon_sym_protected] = ACTIONS(3641),
    [anon_sym_public] = ACTIONS(3641),
    [anon_sym_readonly] = ACTIONS(3641),
    [anon_sym_required] = ACTIONS(3641),
    [anon_sym_sealed] = ACTIONS(3641),
    [anon_sym_virtual] = ACTIONS(3641),
    [anon_sym_volatile] = ACTIONS(3641),
    [anon_sym_where] = ACTIONS(3641),
    [anon_sym_notnull] = ACTIONS(3641),
    [anon_sym_unmanaged] = ACTIONS(3641),
    [anon_sym_TILDE] = ACTIONS(3643),
    [anon_sym_implicit] = ACTIONS(3641),
    [anon_sym_explicit] = ACTIONS(3641),
    [anon_sym_scoped] = ACTIONS(3641),
    [anon_sym_var] = ACTIONS(3641),
    [sym_predefined_type] = ACTIONS(3641),
    [anon_sym_yield] = ACTIONS(3641),
    [anon_sym_when] = ACTIONS(3641),
    [anon_sym_from] = ACTIONS(3641),
    [anon_sym_into] = ACTIONS(3641),
    [anon_sym_join] = ACTIONS(3641),
    [anon_sym_on] = ACTIONS(3641),
    [anon_sym_equals] = ACTIONS(3641),
    [anon_sym_let] = ACTIONS(3641),
    [anon_sym_orderby] = ACTIONS(3641),
    [anon_sym_ascending] = ACTIONS(3641),
    [anon_sym_descending] = ACTIONS(3641),
    [anon_sym_group] = ACTIONS(3641),
    [anon_sym_by] = ACTIONS(3641),
    [anon_sym_select] = ACTIONS(3641),
    [aux_sym_preproc_if_token1] = ACTIONS(3643),
    [aux_sym_preproc_if_token3] = ACTIONS(3643),
    [aux_sym_preproc_else_token1] = ACTIONS(3643),
    [aux_sym_preproc_elif_token1] = ACTIONS(3643),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3445] = {
    [sym_preproc_region] = STATE(3445),
    [sym_preproc_endregion] = STATE(3445),
    [sym_preproc_line] = STATE(3445),
    [sym_preproc_pragma] = STATE(3445),
    [sym_preproc_nullable] = STATE(3445),
    [sym_preproc_error] = STATE(3445),
    [sym_preproc_define] = STATE(3445),
    [sym_preproc_undef] = STATE(3445),
    [sym__identifier_token] = ACTIONS(4099),
    [anon_sym_alias] = ACTIONS(4099),
    [anon_sym_global] = ACTIONS(4099),
    [anon_sym_LBRACK] = ACTIONS(4106),
    [anon_sym_COLON] = ACTIONS(4106),
    [anon_sym_COMMA] = ACTIONS(4106),
    [anon_sym_LPAREN] = ACTIONS(4106),
    [anon_sym_LBRACE] = ACTIONS(4106),
    [anon_sym_file] = ACTIONS(4099),
    [anon_sym_LT] = ACTIONS(4099),
    [anon_sym_GT] = ACTIONS(4099),
    [anon_sym_where] = ACTIONS(4099),
    [anon_sym_QMARK] = ACTIONS(4099),
    [anon_sym_notnull] = ACTIONS(4099),
    [anon_sym_unmanaged] = ACTIONS(4099),
    [anon_sym_BANG] = ACTIONS(4099),
    [anon_sym_PLUS_PLUS] = ACTIONS(4106),
    [anon_sym_DASH_DASH] = ACTIONS(4106),
    [anon_sym_PLUS] = ACTIONS(4099),
    [anon_sym_DASH] = ACTIONS(4099),
    [anon_sym_STAR] = ACTIONS(4106),
    [anon_sym_SLASH] = ACTIONS(4099),
    [anon_sym_PERCENT] = ACTIONS(4106),
    [anon_sym_CARET] = ACTIONS(4106),
    [anon_sym_PIPE] = ACTIONS(4099),
    [anon_sym_AMP] = ACTIONS(4099),
    [anon_sym_LT_LT] = ACTIONS(4106),
    [anon_sym_GT_GT] = ACTIONS(4099),
    [anon_sym_GT_GT_GT] = ACTIONS(4106),
    [anon_sym_EQ_EQ] = ACTIONS(4106),
    [anon_sym_BANG_EQ] = ACTIONS(4106),
    [anon_sym_GT_EQ] = ACTIONS(4106),
    [anon_sym_LT_EQ] = ACTIONS(4106),
    [anon_sym_DOT] = ACTIONS(4099),
    [anon_sym_scoped] = ACTIONS(4099),
    [anon_sym_var] = ACTIONS(4099),
    [anon_sym_yield] = ACTIONS(4099),
    [anon_sym_switch] = ACTIONS(4099),
    [anon_sym_when] = ACTIONS(4099),
    [sym_discard] = ACTIONS(4099),
    [anon_sym_DOT_DOT] = ACTIONS(4106),
    [anon_sym_and] = ACTIONS(4099),
    [anon_sym_or] = ACTIONS(4099),
    [anon_sym_AMP_AMP] = ACTIONS(4106),
    [anon_sym_PIPE_PIPE] = ACTIONS(4106),
    [anon_sym_QMARK_QMARK] = ACTIONS(4106),
    [anon_sym_from] = ACTIONS(4099),
    [anon_sym_into] = ACTIONS(4099),
    [anon_sym_join] = ACTIONS(4099),
    [anon_sym_on] = ACTIONS(4099),
    [anon_sym_equals] = ACTIONS(4099),
    [anon_sym_let] = ACTIONS(4099),
    [anon_sym_orderby] = ACTIONS(4099),
    [anon_sym_ascending] = ACTIONS(4099),
    [anon_sym_descending] = ACTIONS(4099),
    [anon_sym_group] = ACTIONS(4099),
    [anon_sym_by] = ACTIONS(4099),
    [anon_sym_select] = ACTIONS(4099),
    [anon_sym_as] = ACTIONS(4099),
    [anon_sym_is] = ACTIONS(4099),
    [anon_sym_DASH_GT] = ACTIONS(4106),
    [anon_sym_with] = ACTIONS(4099),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4106),
  },
  [3446] = {
    [sym_preproc_region] = STATE(3446),
    [sym_preproc_endregion] = STATE(3446),
    [sym_preproc_line] = STATE(3446),
    [sym_preproc_pragma] = STATE(3446),
    [sym_preproc_nullable] = STATE(3446),
    [sym_preproc_error] = STATE(3446),
    [sym_preproc_define] = STATE(3446),
    [sym_preproc_undef] = STATE(3446),
    [sym__identifier_token] = ACTIONS(5091),
    [anon_sym_extern] = ACTIONS(5091),
    [anon_sym_alias] = ACTIONS(5091),
    [anon_sym_global] = ACTIONS(5091),
    [anon_sym_using] = ACTIONS(5091),
    [anon_sym_unsafe] = ACTIONS(5091),
    [anon_sym_static] = ACTIONS(5091),
    [anon_sym_LBRACK] = ACTIONS(5093),
    [anon_sym_LPAREN] = ACTIONS(5093),
    [anon_sym_event] = ACTIONS(5091),
    [anon_sym_namespace] = ACTIONS(5091),
    [anon_sym_class] = ACTIONS(5091),
    [anon_sym_ref] = ACTIONS(5091),
    [anon_sym_struct] = ACTIONS(5091),
    [anon_sym_enum] = ACTIONS(5091),
    [anon_sym_RBRACE] = ACTIONS(5093),
    [anon_sym_interface] = ACTIONS(5091),
    [anon_sym_delegate] = ACTIONS(5091),
    [anon_sym_record] = ACTIONS(5091),
    [anon_sym_abstract] = ACTIONS(5091),
    [anon_sym_async] = ACTIONS(5091),
    [anon_sym_const] = ACTIONS(5091),
    [anon_sym_file] = ACTIONS(5091),
    [anon_sym_fixed] = ACTIONS(5091),
    [anon_sym_internal] = ACTIONS(5091),
    [anon_sym_new] = ACTIONS(5091),
    [anon_sym_override] = ACTIONS(5091),
    [anon_sym_partial] = ACTIONS(5091),
    [anon_sym_private] = ACTIONS(5091),
    [anon_sym_protected] = ACTIONS(5091),
    [anon_sym_public] = ACTIONS(5091),
    [anon_sym_readonly] = ACTIONS(5091),
    [anon_sym_required] = ACTIONS(5091),
    [anon_sym_sealed] = ACTIONS(5091),
    [anon_sym_virtual] = ACTIONS(5091),
    [anon_sym_volatile] = ACTIONS(5091),
    [anon_sym_where] = ACTIONS(5091),
    [anon_sym_notnull] = ACTIONS(5091),
    [anon_sym_unmanaged] = ACTIONS(5091),
    [anon_sym_TILDE] = ACTIONS(5093),
    [anon_sym_implicit] = ACTIONS(5091),
    [anon_sym_explicit] = ACTIONS(5091),
    [anon_sym_scoped] = ACTIONS(5091),
    [anon_sym_var] = ACTIONS(5091),
    [sym_predefined_type] = ACTIONS(5091),
    [anon_sym_yield] = ACTIONS(5091),
    [anon_sym_when] = ACTIONS(5091),
    [anon_sym_from] = ACTIONS(5091),
    [anon_sym_into] = ACTIONS(5091),
    [anon_sym_join] = ACTIONS(5091),
    [anon_sym_on] = ACTIONS(5091),
    [anon_sym_equals] = ACTIONS(5091),
    [anon_sym_let] = ACTIONS(5091),
    [anon_sym_orderby] = ACTIONS(5091),
    [anon_sym_ascending] = ACTIONS(5091),
    [anon_sym_descending] = ACTIONS(5091),
    [anon_sym_group] = ACTIONS(5091),
    [anon_sym_by] = ACTIONS(5091),
    [anon_sym_select] = ACTIONS(5091),
    [aux_sym_preproc_if_token1] = ACTIONS(5093),
    [aux_sym_preproc_if_token3] = ACTIONS(5093),
    [aux_sym_preproc_else_token1] = ACTIONS(5093),
    [aux_sym_preproc_elif_token1] = ACTIONS(5093),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3447] = {
    [sym_preproc_region] = STATE(3447),
    [sym_preproc_endregion] = STATE(3447),
    [sym_preproc_line] = STATE(3447),
    [sym_preproc_pragma] = STATE(3447),
    [sym_preproc_nullable] = STATE(3447),
    [sym_preproc_error] = STATE(3447),
    [sym_preproc_define] = STATE(3447),
    [sym_preproc_undef] = STATE(3447),
    [sym__identifier_token] = ACTIONS(5095),
    [anon_sym_extern] = ACTIONS(5095),
    [anon_sym_alias] = ACTIONS(5095),
    [anon_sym_global] = ACTIONS(5095),
    [anon_sym_using] = ACTIONS(5095),
    [anon_sym_unsafe] = ACTIONS(5095),
    [anon_sym_static] = ACTIONS(5095),
    [anon_sym_LBRACK] = ACTIONS(5097),
    [anon_sym_LPAREN] = ACTIONS(5097),
    [anon_sym_event] = ACTIONS(5095),
    [anon_sym_namespace] = ACTIONS(5095),
    [anon_sym_class] = ACTIONS(5095),
    [anon_sym_ref] = ACTIONS(5095),
    [anon_sym_struct] = ACTIONS(5095),
    [anon_sym_enum] = ACTIONS(5095),
    [anon_sym_RBRACE] = ACTIONS(5097),
    [anon_sym_interface] = ACTIONS(5095),
    [anon_sym_delegate] = ACTIONS(5095),
    [anon_sym_record] = ACTIONS(5095),
    [anon_sym_abstract] = ACTIONS(5095),
    [anon_sym_async] = ACTIONS(5095),
    [anon_sym_const] = ACTIONS(5095),
    [anon_sym_file] = ACTIONS(5095),
    [anon_sym_fixed] = ACTIONS(5095),
    [anon_sym_internal] = ACTIONS(5095),
    [anon_sym_new] = ACTIONS(5095),
    [anon_sym_override] = ACTIONS(5095),
    [anon_sym_partial] = ACTIONS(5095),
    [anon_sym_private] = ACTIONS(5095),
    [anon_sym_protected] = ACTIONS(5095),
    [anon_sym_public] = ACTIONS(5095),
    [anon_sym_readonly] = ACTIONS(5095),
    [anon_sym_required] = ACTIONS(5095),
    [anon_sym_sealed] = ACTIONS(5095),
    [anon_sym_virtual] = ACTIONS(5095),
    [anon_sym_volatile] = ACTIONS(5095),
    [anon_sym_where] = ACTIONS(5095),
    [anon_sym_notnull] = ACTIONS(5095),
    [anon_sym_unmanaged] = ACTIONS(5095),
    [anon_sym_TILDE] = ACTIONS(5097),
    [anon_sym_implicit] = ACTIONS(5095),
    [anon_sym_explicit] = ACTIONS(5095),
    [anon_sym_scoped] = ACTIONS(5095),
    [anon_sym_var] = ACTIONS(5095),
    [sym_predefined_type] = ACTIONS(5095),
    [anon_sym_yield] = ACTIONS(5095),
    [anon_sym_when] = ACTIONS(5095),
    [anon_sym_from] = ACTIONS(5095),
    [anon_sym_into] = ACTIONS(5095),
    [anon_sym_join] = ACTIONS(5095),
    [anon_sym_on] = ACTIONS(5095),
    [anon_sym_equals] = ACTIONS(5095),
    [anon_sym_let] = ACTIONS(5095),
    [anon_sym_orderby] = ACTIONS(5095),
    [anon_sym_ascending] = ACTIONS(5095),
    [anon_sym_descending] = ACTIONS(5095),
    [anon_sym_group] = ACTIONS(5095),
    [anon_sym_by] = ACTIONS(5095),
    [anon_sym_select] = ACTIONS(5095),
    [aux_sym_preproc_if_token1] = ACTIONS(5097),
    [aux_sym_preproc_if_token3] = ACTIONS(5097),
    [aux_sym_preproc_else_token1] = ACTIONS(5097),
    [aux_sym_preproc_elif_token1] = ACTIONS(5097),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3448] = {
    [sym_preproc_region] = STATE(3448),
    [sym_preproc_endregion] = STATE(3448),
    [sym_preproc_line] = STATE(3448),
    [sym_preproc_pragma] = STATE(3448),
    [sym_preproc_nullable] = STATE(3448),
    [sym_preproc_error] = STATE(3448),
    [sym_preproc_define] = STATE(3448),
    [sym_preproc_undef] = STATE(3448),
    [sym__identifier_token] = ACTIONS(3637),
    [anon_sym_extern] = ACTIONS(3637),
    [anon_sym_alias] = ACTIONS(3637),
    [anon_sym_global] = ACTIONS(3637),
    [anon_sym_using] = ACTIONS(3637),
    [anon_sym_unsafe] = ACTIONS(3637),
    [anon_sym_static] = ACTIONS(3637),
    [anon_sym_LBRACK] = ACTIONS(3639),
    [anon_sym_LPAREN] = ACTIONS(3639),
    [anon_sym_event] = ACTIONS(3637),
    [anon_sym_namespace] = ACTIONS(3637),
    [anon_sym_class] = ACTIONS(3637),
    [anon_sym_ref] = ACTIONS(3637),
    [anon_sym_struct] = ACTIONS(3637),
    [anon_sym_enum] = ACTIONS(3637),
    [anon_sym_RBRACE] = ACTIONS(3639),
    [anon_sym_interface] = ACTIONS(3637),
    [anon_sym_delegate] = ACTIONS(3637),
    [anon_sym_record] = ACTIONS(3637),
    [anon_sym_abstract] = ACTIONS(3637),
    [anon_sym_async] = ACTIONS(3637),
    [anon_sym_const] = ACTIONS(3637),
    [anon_sym_file] = ACTIONS(3637),
    [anon_sym_fixed] = ACTIONS(3637),
    [anon_sym_internal] = ACTIONS(3637),
    [anon_sym_new] = ACTIONS(3637),
    [anon_sym_override] = ACTIONS(3637),
    [anon_sym_partial] = ACTIONS(3637),
    [anon_sym_private] = ACTIONS(3637),
    [anon_sym_protected] = ACTIONS(3637),
    [anon_sym_public] = ACTIONS(3637),
    [anon_sym_readonly] = ACTIONS(3637),
    [anon_sym_required] = ACTIONS(3637),
    [anon_sym_sealed] = ACTIONS(3637),
    [anon_sym_virtual] = ACTIONS(3637),
    [anon_sym_volatile] = ACTIONS(3637),
    [anon_sym_where] = ACTIONS(3637),
    [anon_sym_notnull] = ACTIONS(3637),
    [anon_sym_unmanaged] = ACTIONS(3637),
    [anon_sym_TILDE] = ACTIONS(3639),
    [anon_sym_implicit] = ACTIONS(3637),
    [anon_sym_explicit] = ACTIONS(3637),
    [anon_sym_scoped] = ACTIONS(3637),
    [anon_sym_var] = ACTIONS(3637),
    [sym_predefined_type] = ACTIONS(3637),
    [anon_sym_yield] = ACTIONS(3637),
    [anon_sym_when] = ACTIONS(3637),
    [anon_sym_from] = ACTIONS(3637),
    [anon_sym_into] = ACTIONS(3637),
    [anon_sym_join] = ACTIONS(3637),
    [anon_sym_on] = ACTIONS(3637),
    [anon_sym_equals] = ACTIONS(3637),
    [anon_sym_let] = ACTIONS(3637),
    [anon_sym_orderby] = ACTIONS(3637),
    [anon_sym_ascending] = ACTIONS(3637),
    [anon_sym_descending] = ACTIONS(3637),
    [anon_sym_group] = ACTIONS(3637),
    [anon_sym_by] = ACTIONS(3637),
    [anon_sym_select] = ACTIONS(3637),
    [aux_sym_preproc_if_token1] = ACTIONS(3639),
    [aux_sym_preproc_if_token3] = ACTIONS(3639),
    [aux_sym_preproc_else_token1] = ACTIONS(3639),
    [aux_sym_preproc_elif_token1] = ACTIONS(3639),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3449] = {
    [sym_preproc_region] = STATE(3449),
    [sym_preproc_endregion] = STATE(3449),
    [sym_preproc_line] = STATE(3449),
    [sym_preproc_pragma] = STATE(3449),
    [sym_preproc_nullable] = STATE(3449),
    [sym_preproc_error] = STATE(3449),
    [sym_preproc_define] = STATE(3449),
    [sym_preproc_undef] = STATE(3449),
    [sym__identifier_token] = ACTIONS(5099),
    [anon_sym_extern] = ACTIONS(5099),
    [anon_sym_alias] = ACTIONS(5099),
    [anon_sym_global] = ACTIONS(5099),
    [anon_sym_using] = ACTIONS(5099),
    [anon_sym_unsafe] = ACTIONS(5099),
    [anon_sym_static] = ACTIONS(5099),
    [anon_sym_LBRACK] = ACTIONS(5101),
    [anon_sym_LPAREN] = ACTIONS(5101),
    [anon_sym_event] = ACTIONS(5099),
    [anon_sym_namespace] = ACTIONS(5099),
    [anon_sym_class] = ACTIONS(5099),
    [anon_sym_ref] = ACTIONS(5099),
    [anon_sym_struct] = ACTIONS(5099),
    [anon_sym_enum] = ACTIONS(5099),
    [anon_sym_RBRACE] = ACTIONS(5101),
    [anon_sym_interface] = ACTIONS(5099),
    [anon_sym_delegate] = ACTIONS(5099),
    [anon_sym_record] = ACTIONS(5099),
    [anon_sym_abstract] = ACTIONS(5099),
    [anon_sym_async] = ACTIONS(5099),
    [anon_sym_const] = ACTIONS(5099),
    [anon_sym_file] = ACTIONS(5099),
    [anon_sym_fixed] = ACTIONS(5099),
    [anon_sym_internal] = ACTIONS(5099),
    [anon_sym_new] = ACTIONS(5099),
    [anon_sym_override] = ACTIONS(5099),
    [anon_sym_partial] = ACTIONS(5099),
    [anon_sym_private] = ACTIONS(5099),
    [anon_sym_protected] = ACTIONS(5099),
    [anon_sym_public] = ACTIONS(5099),
    [anon_sym_readonly] = ACTIONS(5099),
    [anon_sym_required] = ACTIONS(5099),
    [anon_sym_sealed] = ACTIONS(5099),
    [anon_sym_virtual] = ACTIONS(5099),
    [anon_sym_volatile] = ACTIONS(5099),
    [anon_sym_where] = ACTIONS(5099),
    [anon_sym_notnull] = ACTIONS(5099),
    [anon_sym_unmanaged] = ACTIONS(5099),
    [anon_sym_TILDE] = ACTIONS(5101),
    [anon_sym_implicit] = ACTIONS(5099),
    [anon_sym_explicit] = ACTIONS(5099),
    [anon_sym_scoped] = ACTIONS(5099),
    [anon_sym_var] = ACTIONS(5099),
    [sym_predefined_type] = ACTIONS(5099),
    [anon_sym_yield] = ACTIONS(5099),
    [anon_sym_when] = ACTIONS(5099),
    [anon_sym_from] = ACTIONS(5099),
    [anon_sym_into] = ACTIONS(5099),
    [anon_sym_join] = ACTIONS(5099),
    [anon_sym_on] = ACTIONS(5099),
    [anon_sym_equals] = ACTIONS(5099),
    [anon_sym_let] = ACTIONS(5099),
    [anon_sym_orderby] = ACTIONS(5099),
    [anon_sym_ascending] = ACTIONS(5099),
    [anon_sym_descending] = ACTIONS(5099),
    [anon_sym_group] = ACTIONS(5099),
    [anon_sym_by] = ACTIONS(5099),
    [anon_sym_select] = ACTIONS(5099),
    [aux_sym_preproc_if_token1] = ACTIONS(5101),
    [aux_sym_preproc_if_token3] = ACTIONS(5101),
    [aux_sym_preproc_else_token1] = ACTIONS(5101),
    [aux_sym_preproc_elif_token1] = ACTIONS(5101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3450] = {
    [sym_preproc_region] = STATE(3450),
    [sym_preproc_endregion] = STATE(3450),
    [sym_preproc_line] = STATE(3450),
    [sym_preproc_pragma] = STATE(3450),
    [sym_preproc_nullable] = STATE(3450),
    [sym_preproc_error] = STATE(3450),
    [sym_preproc_define] = STATE(3450),
    [sym_preproc_undef] = STATE(3450),
    [sym__identifier_token] = ACTIONS(4422),
    [anon_sym_alias] = ACTIONS(4422),
    [anon_sym_global] = ACTIONS(4422),
    [anon_sym_LBRACK] = ACTIONS(4547),
    [anon_sym_COLON] = ACTIONS(4424),
    [anon_sym_COMMA] = ACTIONS(4424),
    [anon_sym_LPAREN] = ACTIONS(4424),
    [anon_sym_LBRACE] = ACTIONS(4424),
    [anon_sym_file] = ACTIONS(4422),
    [anon_sym_LT] = ACTIONS(4422),
    [anon_sym_GT] = ACTIONS(4422),
    [anon_sym_where] = ACTIONS(4422),
    [anon_sym_QMARK] = ACTIONS(4932),
    [anon_sym_notnull] = ACTIONS(4422),
    [anon_sym_unmanaged] = ACTIONS(4422),
    [anon_sym_BANG] = ACTIONS(4422),
    [anon_sym_PLUS_PLUS] = ACTIONS(4424),
    [anon_sym_DASH_DASH] = ACTIONS(4424),
    [anon_sym_PLUS] = ACTIONS(4422),
    [anon_sym_DASH] = ACTIONS(4422),
    [anon_sym_STAR] = ACTIONS(4553),
    [anon_sym_SLASH] = ACTIONS(4422),
    [anon_sym_PERCENT] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4424),
    [anon_sym_PIPE] = ACTIONS(4422),
    [anon_sym_AMP] = ACTIONS(4422),
    [anon_sym_LT_LT] = ACTIONS(4424),
    [anon_sym_GT_GT] = ACTIONS(4422),
    [anon_sym_GT_GT_GT] = ACTIONS(4424),
    [anon_sym_EQ_EQ] = ACTIONS(4424),
    [anon_sym_BANG_EQ] = ACTIONS(4424),
    [anon_sym_GT_EQ] = ACTIONS(4424),
    [anon_sym_LT_EQ] = ACTIONS(4424),
    [anon_sym_DOT] = ACTIONS(5029),
    [anon_sym_scoped] = ACTIONS(4422),
    [anon_sym_var] = ACTIONS(4422),
    [anon_sym_yield] = ACTIONS(4422),
    [anon_sym_switch] = ACTIONS(4422),
    [anon_sym_when] = ACTIONS(4422),
    [sym_discard] = ACTIONS(4422),
    [anon_sym_DOT_DOT] = ACTIONS(4424),
    [anon_sym_and] = ACTIONS(4422),
    [anon_sym_or] = ACTIONS(4422),
    [anon_sym_AMP_AMP] = ACTIONS(4424),
    [anon_sym_PIPE_PIPE] = ACTIONS(4424),
    [anon_sym_QMARK_QMARK] = ACTIONS(4424),
    [anon_sym_from] = ACTIONS(4422),
    [anon_sym_into] = ACTIONS(4422),
    [anon_sym_join] = ACTIONS(4422),
    [anon_sym_on] = ACTIONS(4422),
    [anon_sym_equals] = ACTIONS(4422),
    [anon_sym_let] = ACTIONS(4422),
    [anon_sym_orderby] = ACTIONS(4422),
    [anon_sym_ascending] = ACTIONS(4422),
    [anon_sym_descending] = ACTIONS(4422),
    [anon_sym_group] = ACTIONS(4422),
    [anon_sym_by] = ACTIONS(4422),
    [anon_sym_select] = ACTIONS(4422),
    [anon_sym_as] = ACTIONS(4422),
    [anon_sym_is] = ACTIONS(4422),
    [anon_sym_DASH_GT] = ACTIONS(4424),
    [anon_sym_with] = ACTIONS(4422),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4424),
  },
  [3451] = {
    [sym__variable_designation] = STATE(4035),
    [sym_parenthesized_variable_designation] = STATE(4015),
    [sym_identifier] = STATE(4020),
    [sym__reserved_identifier] = STATE(3908),
    [sym_preproc_region] = STATE(3451),
    [sym_preproc_endregion] = STATE(3451),
    [sym_preproc_line] = STATE(3451),
    [sym_preproc_pragma] = STATE(3451),
    [sym_preproc_nullable] = STATE(3451),
    [sym_preproc_error] = STATE(3451),
    [sym_preproc_define] = STATE(3451),
    [sym_preproc_undef] = STATE(3451),
    [sym__identifier_token] = ACTIONS(4271),
    [anon_sym_alias] = ACTIONS(4273),
    [anon_sym_global] = ACTIONS(4273),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_LPAREN] = ACTIONS(4383),
    [anon_sym_file] = ACTIONS(4273),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_where] = ACTIONS(4273),
    [anon_sym_QMARK] = ACTIONS(4385),
    [anon_sym_notnull] = ACTIONS(4273),
    [anon_sym_unmanaged] = ACTIONS(4273),
    [anon_sym_BANG] = ACTIONS(4385),
    [anon_sym_PLUS_PLUS] = ACTIONS(4383),
    [anon_sym_DASH_DASH] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_DASH] = ACTIONS(4385),
    [anon_sym_STAR] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4385),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4385),
    [anon_sym_GT_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4383),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_scoped] = ACTIONS(4273),
    [anon_sym_var] = ACTIONS(4273),
    [anon_sym_yield] = ACTIONS(4273),
    [anon_sym_switch] = ACTIONS(4385),
    [anon_sym_when] = ACTIONS(4273),
    [sym_discard] = ACTIONS(4281),
    [anon_sym_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4385),
    [anon_sym_or] = ACTIONS(4385),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_QMARK_QMARK] = ACTIONS(4383),
    [anon_sym_from] = ACTIONS(4273),
    [anon_sym_into] = ACTIONS(4385),
    [anon_sym_join] = ACTIONS(4273),
    [anon_sym_on] = ACTIONS(4385),
    [anon_sym_equals] = ACTIONS(4273),
    [anon_sym_let] = ACTIONS(4273),
    [anon_sym_orderby] = ACTIONS(4273),
    [anon_sym_ascending] = ACTIONS(4273),
    [anon_sym_descending] = ACTIONS(4273),
    [anon_sym_group] = ACTIONS(4273),
    [anon_sym_by] = ACTIONS(4273),
    [anon_sym_select] = ACTIONS(4273),
    [anon_sym_as] = ACTIONS(4385),
    [anon_sym_is] = ACTIONS(4385),
    [anon_sym_DASH_GT] = ACTIONS(4383),
    [anon_sym_with] = ACTIONS(4385),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3452] = {
    [sym__variable_designation] = STATE(4063),
    [sym_parenthesized_variable_designation] = STATE(4015),
    [sym_identifier] = STATE(4020),
    [sym__reserved_identifier] = STATE(3908),
    [sym_preproc_region] = STATE(3452),
    [sym_preproc_endregion] = STATE(3452),
    [sym_preproc_line] = STATE(3452),
    [sym_preproc_pragma] = STATE(3452),
    [sym_preproc_nullable] = STATE(3452),
    [sym_preproc_error] = STATE(3452),
    [sym_preproc_define] = STATE(3452),
    [sym_preproc_undef] = STATE(3452),
    [sym__identifier_token] = ACTIONS(4271),
    [anon_sym_alias] = ACTIONS(4273),
    [anon_sym_global] = ACTIONS(4273),
    [anon_sym_LBRACK] = ACTIONS(4373),
    [anon_sym_LPAREN] = ACTIONS(4373),
    [anon_sym_file] = ACTIONS(4273),
    [anon_sym_LT] = ACTIONS(4375),
    [anon_sym_GT] = ACTIONS(4375),
    [anon_sym_where] = ACTIONS(4273),
    [anon_sym_QMARK] = ACTIONS(4375),
    [anon_sym_notnull] = ACTIONS(4273),
    [anon_sym_unmanaged] = ACTIONS(4273),
    [anon_sym_BANG] = ACTIONS(4375),
    [anon_sym_PLUS_PLUS] = ACTIONS(4373),
    [anon_sym_DASH_DASH] = ACTIONS(4373),
    [anon_sym_PLUS] = ACTIONS(4375),
    [anon_sym_DASH] = ACTIONS(4375),
    [anon_sym_STAR] = ACTIONS(4373),
    [anon_sym_SLASH] = ACTIONS(4375),
    [anon_sym_PERCENT] = ACTIONS(4373),
    [anon_sym_CARET] = ACTIONS(4373),
    [anon_sym_PIPE] = ACTIONS(4375),
    [anon_sym_AMP] = ACTIONS(4375),
    [anon_sym_LT_LT] = ACTIONS(4373),
    [anon_sym_GT_GT] = ACTIONS(4375),
    [anon_sym_GT_GT_GT] = ACTIONS(4373),
    [anon_sym_EQ_EQ] = ACTIONS(4373),
    [anon_sym_BANG_EQ] = ACTIONS(4373),
    [anon_sym_GT_EQ] = ACTIONS(4373),
    [anon_sym_LT_EQ] = ACTIONS(4373),
    [anon_sym_DOT] = ACTIONS(4375),
    [anon_sym_scoped] = ACTIONS(4273),
    [anon_sym_var] = ACTIONS(4273),
    [anon_sym_yield] = ACTIONS(4273),
    [anon_sym_switch] = ACTIONS(4375),
    [anon_sym_when] = ACTIONS(4273),
    [sym_discard] = ACTIONS(4281),
    [anon_sym_DOT_DOT] = ACTIONS(4373),
    [anon_sym_and] = ACTIONS(4375),
    [anon_sym_or] = ACTIONS(4375),
    [anon_sym_AMP_AMP] = ACTIONS(4373),
    [anon_sym_PIPE_PIPE] = ACTIONS(4373),
    [anon_sym_QMARK_QMARK] = ACTIONS(4373),
    [anon_sym_from] = ACTIONS(4273),
    [anon_sym_into] = ACTIONS(4375),
    [anon_sym_join] = ACTIONS(4273),
    [anon_sym_on] = ACTIONS(4375),
    [anon_sym_equals] = ACTIONS(4273),
    [anon_sym_let] = ACTIONS(4273),
    [anon_sym_orderby] = ACTIONS(4273),
    [anon_sym_ascending] = ACTIONS(4273),
    [anon_sym_descending] = ACTIONS(4273),
    [anon_sym_group] = ACTIONS(4273),
    [anon_sym_by] = ACTIONS(4273),
    [anon_sym_select] = ACTIONS(4273),
    [anon_sym_as] = ACTIONS(4375),
    [anon_sym_is] = ACTIONS(4375),
    [anon_sym_DASH_GT] = ACTIONS(4373),
    [anon_sym_with] = ACTIONS(4375),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3453] = {
    [sym_preproc_region] = STATE(3453),
    [sym_preproc_endregion] = STATE(3453),
    [sym_preproc_line] = STATE(3453),
    [sym_preproc_pragma] = STATE(3453),
    [sym_preproc_nullable] = STATE(3453),
    [sym_preproc_error] = STATE(3453),
    [sym_preproc_define] = STATE(3453),
    [sym_preproc_undef] = STATE(3453),
    [sym__identifier_token] = ACTIONS(5103),
    [anon_sym_extern] = ACTIONS(5103),
    [anon_sym_alias] = ACTIONS(5103),
    [anon_sym_global] = ACTIONS(5103),
    [anon_sym_using] = ACTIONS(5103),
    [anon_sym_unsafe] = ACTIONS(5103),
    [anon_sym_static] = ACTIONS(5103),
    [anon_sym_LBRACK] = ACTIONS(5105),
    [anon_sym_LPAREN] = ACTIONS(5105),
    [anon_sym_event] = ACTIONS(5103),
    [anon_sym_namespace] = ACTIONS(5103),
    [anon_sym_class] = ACTIONS(5103),
    [anon_sym_ref] = ACTIONS(5103),
    [anon_sym_struct] = ACTIONS(5103),
    [anon_sym_enum] = ACTIONS(5103),
    [anon_sym_RBRACE] = ACTIONS(5105),
    [anon_sym_interface] = ACTIONS(5103),
    [anon_sym_delegate] = ACTIONS(5103),
    [anon_sym_record] = ACTIONS(5103),
    [anon_sym_abstract] = ACTIONS(5103),
    [anon_sym_async] = ACTIONS(5103),
    [anon_sym_const] = ACTIONS(5103),
    [anon_sym_file] = ACTIONS(5103),
    [anon_sym_fixed] = ACTIONS(5103),
    [anon_sym_internal] = ACTIONS(5103),
    [anon_sym_new] = ACTIONS(5103),
    [anon_sym_override] = ACTIONS(5103),
    [anon_sym_partial] = ACTIONS(5103),
    [anon_sym_private] = ACTIONS(5103),
    [anon_sym_protected] = ACTIONS(5103),
    [anon_sym_public] = ACTIONS(5103),
    [anon_sym_readonly] = ACTIONS(5103),
    [anon_sym_required] = ACTIONS(5103),
    [anon_sym_sealed] = ACTIONS(5103),
    [anon_sym_virtual] = ACTIONS(5103),
    [anon_sym_volatile] = ACTIONS(5103),
    [anon_sym_where] = ACTIONS(5103),
    [anon_sym_notnull] = ACTIONS(5103),
    [anon_sym_unmanaged] = ACTIONS(5103),
    [anon_sym_TILDE] = ACTIONS(5105),
    [anon_sym_implicit] = ACTIONS(5103),
    [anon_sym_explicit] = ACTIONS(5103),
    [anon_sym_scoped] = ACTIONS(5103),
    [anon_sym_var] = ACTIONS(5103),
    [sym_predefined_type] = ACTIONS(5103),
    [anon_sym_yield] = ACTIONS(5103),
    [anon_sym_when] = ACTIONS(5103),
    [anon_sym_from] = ACTIONS(5103),
    [anon_sym_into] = ACTIONS(5103),
    [anon_sym_join] = ACTIONS(5103),
    [anon_sym_on] = ACTIONS(5103),
    [anon_sym_equals] = ACTIONS(5103),
    [anon_sym_let] = ACTIONS(5103),
    [anon_sym_orderby] = ACTIONS(5103),
    [anon_sym_ascending] = ACTIONS(5103),
    [anon_sym_descending] = ACTIONS(5103),
    [anon_sym_group] = ACTIONS(5103),
    [anon_sym_by] = ACTIONS(5103),
    [anon_sym_select] = ACTIONS(5103),
    [aux_sym_preproc_if_token1] = ACTIONS(5105),
    [aux_sym_preproc_if_token3] = ACTIONS(5105),
    [aux_sym_preproc_else_token1] = ACTIONS(5105),
    [aux_sym_preproc_elif_token1] = ACTIONS(5105),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3454] = {
    [sym__variable_designation] = STATE(3965),
    [sym_parenthesized_variable_designation] = STATE(4015),
    [sym_identifier] = STATE(4020),
    [sym__reserved_identifier] = STATE(3908),
    [sym_preproc_region] = STATE(3454),
    [sym_preproc_endregion] = STATE(3454),
    [sym_preproc_line] = STATE(3454),
    [sym_preproc_pragma] = STATE(3454),
    [sym_preproc_nullable] = STATE(3454),
    [sym_preproc_error] = STATE(3454),
    [sym_preproc_define] = STATE(3454),
    [sym_preproc_undef] = STATE(3454),
    [sym__identifier_token] = ACTIONS(4271),
    [anon_sym_alias] = ACTIONS(4273),
    [anon_sym_global] = ACTIONS(4273),
    [anon_sym_LBRACK] = ACTIONS(4335),
    [anon_sym_LPAREN] = ACTIONS(4335),
    [anon_sym_file] = ACTIONS(4273),
    [anon_sym_LT] = ACTIONS(4337),
    [anon_sym_GT] = ACTIONS(4337),
    [anon_sym_where] = ACTIONS(4273),
    [anon_sym_QMARK] = ACTIONS(4337),
    [anon_sym_notnull] = ACTIONS(4273),
    [anon_sym_unmanaged] = ACTIONS(4273),
    [anon_sym_BANG] = ACTIONS(4337),
    [anon_sym_PLUS_PLUS] = ACTIONS(4335),
    [anon_sym_DASH_DASH] = ACTIONS(4335),
    [anon_sym_PLUS] = ACTIONS(4337),
    [anon_sym_DASH] = ACTIONS(4337),
    [anon_sym_STAR] = ACTIONS(4335),
    [anon_sym_SLASH] = ACTIONS(4337),
    [anon_sym_PERCENT] = ACTIONS(4335),
    [anon_sym_CARET] = ACTIONS(4335),
    [anon_sym_PIPE] = ACTIONS(4337),
    [anon_sym_AMP] = ACTIONS(4337),
    [anon_sym_LT_LT] = ACTIONS(4335),
    [anon_sym_GT_GT] = ACTIONS(4337),
    [anon_sym_GT_GT_GT] = ACTIONS(4335),
    [anon_sym_EQ_EQ] = ACTIONS(4335),
    [anon_sym_BANG_EQ] = ACTIONS(4335),
    [anon_sym_GT_EQ] = ACTIONS(4335),
    [anon_sym_LT_EQ] = ACTIONS(4335),
    [anon_sym_DOT] = ACTIONS(4337),
    [anon_sym_scoped] = ACTIONS(4273),
    [anon_sym_var] = ACTIONS(4273),
    [anon_sym_yield] = ACTIONS(4273),
    [anon_sym_switch] = ACTIONS(4337),
    [anon_sym_when] = ACTIONS(4273),
    [sym_discard] = ACTIONS(4281),
    [anon_sym_DOT_DOT] = ACTIONS(4335),
    [anon_sym_and] = ACTIONS(4337),
    [anon_sym_or] = ACTIONS(4337),
    [anon_sym_AMP_AMP] = ACTIONS(4335),
    [anon_sym_PIPE_PIPE] = ACTIONS(4335),
    [anon_sym_QMARK_QMARK] = ACTIONS(4335),
    [anon_sym_from] = ACTIONS(4273),
    [anon_sym_into] = ACTIONS(4337),
    [anon_sym_join] = ACTIONS(4273),
    [anon_sym_on] = ACTIONS(4337),
    [anon_sym_equals] = ACTIONS(4273),
    [anon_sym_let] = ACTIONS(4273),
    [anon_sym_orderby] = ACTIONS(4273),
    [anon_sym_ascending] = ACTIONS(4273),
    [anon_sym_descending] = ACTIONS(4273),
    [anon_sym_group] = ACTIONS(4273),
    [anon_sym_by] = ACTIONS(4273),
    [anon_sym_select] = ACTIONS(4273),
    [anon_sym_as] = ACTIONS(4337),
    [anon_sym_is] = ACTIONS(4337),
    [anon_sym_DASH_GT] = ACTIONS(4335),
    [anon_sym_with] = ACTIONS(4337),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3455] = {
    [sym_preproc_region] = STATE(3455),
    [sym_preproc_endregion] = STATE(3455),
    [sym_preproc_line] = STATE(3455),
    [sym_preproc_pragma] = STATE(3455),
    [sym_preproc_nullable] = STATE(3455),
    [sym_preproc_error] = STATE(3455),
    [sym_preproc_define] = STATE(3455),
    [sym_preproc_undef] = STATE(3455),
    [anon_sym_SEMI] = ACTIONS(4588),
    [anon_sym_EQ] = ACTIONS(4590),
    [anon_sym_LBRACK] = ACTIONS(4588),
    [anon_sym_COLON] = ACTIONS(4588),
    [anon_sym_COMMA] = ACTIONS(4588),
    [anon_sym_RBRACK] = ACTIONS(4588),
    [anon_sym_LPAREN] = ACTIONS(4588),
    [anon_sym_RPAREN] = ACTIONS(4588),
    [anon_sym_RBRACE] = ACTIONS(4588),
    [anon_sym_LT] = ACTIONS(4590),
    [anon_sym_GT] = ACTIONS(4590),
    [anon_sym_in] = ACTIONS(4588),
    [anon_sym_QMARK] = ACTIONS(4590),
    [anon_sym_BANG] = ACTIONS(4590),
    [anon_sym_PLUS_PLUS] = ACTIONS(4588),
    [anon_sym_DASH_DASH] = ACTIONS(4588),
    [anon_sym_PLUS] = ACTIONS(4590),
    [anon_sym_DASH] = ACTIONS(4590),
    [anon_sym_STAR] = ACTIONS(4590),
    [anon_sym_SLASH] = ACTIONS(4590),
    [anon_sym_PERCENT] = ACTIONS(4590),
    [anon_sym_CARET] = ACTIONS(4590),
    [anon_sym_PIPE] = ACTIONS(4590),
    [anon_sym_AMP] = ACTIONS(4590),
    [anon_sym_LT_LT] = ACTIONS(4590),
    [anon_sym_GT_GT] = ACTIONS(4590),
    [anon_sym_GT_GT_GT] = ACTIONS(4590),
    [anon_sym_EQ_EQ] = ACTIONS(4588),
    [anon_sym_BANG_EQ] = ACTIONS(4588),
    [anon_sym_GT_EQ] = ACTIONS(4588),
    [anon_sym_LT_EQ] = ACTIONS(4588),
    [anon_sym_DOT] = ACTIONS(4590),
    [anon_sym_EQ_GT] = ACTIONS(4588),
    [anon_sym_switch] = ACTIONS(4588),
    [anon_sym_when] = ACTIONS(4588),
    [anon_sym_DOT_DOT] = ACTIONS(4588),
    [anon_sym_and] = ACTIONS(4588),
    [anon_sym_or] = ACTIONS(4588),
    [anon_sym_PLUS_EQ] = ACTIONS(4588),
    [anon_sym_DASH_EQ] = ACTIONS(4588),
    [anon_sym_STAR_EQ] = ACTIONS(4588),
    [anon_sym_SLASH_EQ] = ACTIONS(4588),
    [anon_sym_PERCENT_EQ] = ACTIONS(4588),
    [anon_sym_AMP_EQ] = ACTIONS(4588),
    [anon_sym_CARET_EQ] = ACTIONS(4588),
    [anon_sym_PIPE_EQ] = ACTIONS(4588),
    [anon_sym_LT_LT_EQ] = ACTIONS(4588),
    [anon_sym_GT_GT_EQ] = ACTIONS(4588),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4588),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4588),
    [anon_sym_AMP_AMP] = ACTIONS(4588),
    [anon_sym_PIPE_PIPE] = ACTIONS(4588),
    [anon_sym_QMARK_QMARK] = ACTIONS(4590),
    [anon_sym_on] = ACTIONS(4588),
    [anon_sym_equals] = ACTIONS(4588),
    [anon_sym_by] = ACTIONS(4588),
    [anon_sym_as] = ACTIONS(4588),
    [anon_sym_is] = ACTIONS(4588),
    [anon_sym_DASH_GT] = ACTIONS(4588),
    [anon_sym_with] = ACTIONS(4588),
    [aux_sym_preproc_if_token3] = ACTIONS(4588),
    [aux_sym_preproc_else_token1] = ACTIONS(4588),
    [aux_sym_preproc_elif_token1] = ACTIONS(4588),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3456] = {
    [sym_preproc_region] = STATE(3456),
    [sym_preproc_endregion] = STATE(3456),
    [sym_preproc_line] = STATE(3456),
    [sym_preproc_pragma] = STATE(3456),
    [sym_preproc_nullable] = STATE(3456),
    [sym_preproc_error] = STATE(3456),
    [sym_preproc_define] = STATE(3456),
    [sym_preproc_undef] = STATE(3456),
    [sym__identifier_token] = ACTIONS(5107),
    [anon_sym_extern] = ACTIONS(5107),
    [anon_sym_alias] = ACTIONS(5107),
    [anon_sym_global] = ACTIONS(5107),
    [anon_sym_using] = ACTIONS(5107),
    [anon_sym_unsafe] = ACTIONS(5107),
    [anon_sym_static] = ACTIONS(5107),
    [anon_sym_LBRACK] = ACTIONS(5109),
    [anon_sym_LPAREN] = ACTIONS(5109),
    [anon_sym_event] = ACTIONS(5107),
    [anon_sym_namespace] = ACTIONS(5107),
    [anon_sym_class] = ACTIONS(5107),
    [anon_sym_ref] = ACTIONS(5107),
    [anon_sym_struct] = ACTIONS(5107),
    [anon_sym_enum] = ACTIONS(5107),
    [anon_sym_RBRACE] = ACTIONS(5109),
    [anon_sym_interface] = ACTIONS(5107),
    [anon_sym_delegate] = ACTIONS(5107),
    [anon_sym_record] = ACTIONS(5107),
    [anon_sym_abstract] = ACTIONS(5107),
    [anon_sym_async] = ACTIONS(5107),
    [anon_sym_const] = ACTIONS(5107),
    [anon_sym_file] = ACTIONS(5107),
    [anon_sym_fixed] = ACTIONS(5107),
    [anon_sym_internal] = ACTIONS(5107),
    [anon_sym_new] = ACTIONS(5107),
    [anon_sym_override] = ACTIONS(5107),
    [anon_sym_partial] = ACTIONS(5107),
    [anon_sym_private] = ACTIONS(5107),
    [anon_sym_protected] = ACTIONS(5107),
    [anon_sym_public] = ACTIONS(5107),
    [anon_sym_readonly] = ACTIONS(5107),
    [anon_sym_required] = ACTIONS(5107),
    [anon_sym_sealed] = ACTIONS(5107),
    [anon_sym_virtual] = ACTIONS(5107),
    [anon_sym_volatile] = ACTIONS(5107),
    [anon_sym_where] = ACTIONS(5107),
    [anon_sym_notnull] = ACTIONS(5107),
    [anon_sym_unmanaged] = ACTIONS(5107),
    [anon_sym_TILDE] = ACTIONS(5109),
    [anon_sym_implicit] = ACTIONS(5107),
    [anon_sym_explicit] = ACTIONS(5107),
    [anon_sym_scoped] = ACTIONS(5107),
    [anon_sym_var] = ACTIONS(5107),
    [sym_predefined_type] = ACTIONS(5107),
    [anon_sym_yield] = ACTIONS(5107),
    [anon_sym_when] = ACTIONS(5107),
    [anon_sym_from] = ACTIONS(5107),
    [anon_sym_into] = ACTIONS(5107),
    [anon_sym_join] = ACTIONS(5107),
    [anon_sym_on] = ACTIONS(5107),
    [anon_sym_equals] = ACTIONS(5107),
    [anon_sym_let] = ACTIONS(5107),
    [anon_sym_orderby] = ACTIONS(5107),
    [anon_sym_ascending] = ACTIONS(5107),
    [anon_sym_descending] = ACTIONS(5107),
    [anon_sym_group] = ACTIONS(5107),
    [anon_sym_by] = ACTIONS(5107),
    [anon_sym_select] = ACTIONS(5107),
    [aux_sym_preproc_if_token1] = ACTIONS(5109),
    [aux_sym_preproc_if_token3] = ACTIONS(5109),
    [aux_sym_preproc_else_token1] = ACTIONS(5109),
    [aux_sym_preproc_elif_token1] = ACTIONS(5109),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3457] = {
    [sym_preproc_region] = STATE(3457),
    [sym_preproc_endregion] = STATE(3457),
    [sym_preproc_line] = STATE(3457),
    [sym_preproc_pragma] = STATE(3457),
    [sym_preproc_nullable] = STATE(3457),
    [sym_preproc_error] = STATE(3457),
    [sym_preproc_define] = STATE(3457),
    [sym_preproc_undef] = STATE(3457),
    [sym__identifier_token] = ACTIONS(4525),
    [anon_sym_alias] = ACTIONS(4525),
    [anon_sym_global] = ACTIONS(4525),
    [anon_sym_LBRACK] = ACTIONS(4527),
    [anon_sym_COLON] = ACTIONS(4527),
    [anon_sym_COMMA] = ACTIONS(4527),
    [anon_sym_LPAREN] = ACTIONS(4527),
    [anon_sym_LBRACE] = ACTIONS(4527),
    [anon_sym_file] = ACTIONS(4525),
    [anon_sym_LT] = ACTIONS(4525),
    [anon_sym_GT] = ACTIONS(4525),
    [anon_sym_where] = ACTIONS(4525),
    [anon_sym_QMARK] = ACTIONS(4525),
    [anon_sym_notnull] = ACTIONS(4525),
    [anon_sym_unmanaged] = ACTIONS(4525),
    [anon_sym_BANG] = ACTIONS(4525),
    [anon_sym_PLUS_PLUS] = ACTIONS(4527),
    [anon_sym_DASH_DASH] = ACTIONS(4527),
    [anon_sym_PLUS] = ACTIONS(4525),
    [anon_sym_DASH] = ACTIONS(4525),
    [anon_sym_STAR] = ACTIONS(4527),
    [anon_sym_SLASH] = ACTIONS(4525),
    [anon_sym_PERCENT] = ACTIONS(4527),
    [anon_sym_CARET] = ACTIONS(4527),
    [anon_sym_PIPE] = ACTIONS(4525),
    [anon_sym_AMP] = ACTIONS(4525),
    [anon_sym_LT_LT] = ACTIONS(4527),
    [anon_sym_GT_GT] = ACTIONS(4525),
    [anon_sym_GT_GT_GT] = ACTIONS(4527),
    [anon_sym_EQ_EQ] = ACTIONS(4527),
    [anon_sym_BANG_EQ] = ACTIONS(4527),
    [anon_sym_GT_EQ] = ACTIONS(4527),
    [anon_sym_LT_EQ] = ACTIONS(4527),
    [anon_sym_DOT] = ACTIONS(4525),
    [anon_sym_scoped] = ACTIONS(4525),
    [anon_sym_var] = ACTIONS(4525),
    [anon_sym_yield] = ACTIONS(4525),
    [anon_sym_switch] = ACTIONS(4525),
    [anon_sym_when] = ACTIONS(4525),
    [sym_discard] = ACTIONS(4525),
    [anon_sym_DOT_DOT] = ACTIONS(4527),
    [anon_sym_and] = ACTIONS(4525),
    [anon_sym_or] = ACTIONS(4525),
    [anon_sym_AMP_AMP] = ACTIONS(4527),
    [anon_sym_PIPE_PIPE] = ACTIONS(4527),
    [anon_sym_QMARK_QMARK] = ACTIONS(4527),
    [anon_sym_from] = ACTIONS(4525),
    [anon_sym_into] = ACTIONS(4525),
    [anon_sym_join] = ACTIONS(4525),
    [anon_sym_on] = ACTIONS(4525),
    [anon_sym_equals] = ACTIONS(4525),
    [anon_sym_let] = ACTIONS(4525),
    [anon_sym_orderby] = ACTIONS(4525),
    [anon_sym_ascending] = ACTIONS(4525),
    [anon_sym_descending] = ACTIONS(4525),
    [anon_sym_group] = ACTIONS(4525),
    [anon_sym_by] = ACTIONS(4525),
    [anon_sym_select] = ACTIONS(4525),
    [anon_sym_as] = ACTIONS(4525),
    [anon_sym_is] = ACTIONS(4525),
    [anon_sym_DASH_GT] = ACTIONS(4527),
    [anon_sym_with] = ACTIONS(4525),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4527),
  },
  [3458] = {
    [sym_preproc_region] = STATE(3458),
    [sym_preproc_endregion] = STATE(3458),
    [sym_preproc_line] = STATE(3458),
    [sym_preproc_pragma] = STATE(3458),
    [sym_preproc_nullable] = STATE(3458),
    [sym_preproc_error] = STATE(3458),
    [sym_preproc_define] = STATE(3458),
    [sym_preproc_undef] = STATE(3458),
    [sym__identifier_token] = ACTIONS(5111),
    [anon_sym_extern] = ACTIONS(5111),
    [anon_sym_alias] = ACTIONS(5111),
    [anon_sym_global] = ACTIONS(5111),
    [anon_sym_using] = ACTIONS(5111),
    [anon_sym_unsafe] = ACTIONS(5111),
    [anon_sym_static] = ACTIONS(5111),
    [anon_sym_LBRACK] = ACTIONS(5113),
    [anon_sym_LPAREN] = ACTIONS(5113),
    [anon_sym_event] = ACTIONS(5111),
    [anon_sym_namespace] = ACTIONS(5111),
    [anon_sym_class] = ACTIONS(5111),
    [anon_sym_ref] = ACTIONS(5111),
    [anon_sym_struct] = ACTIONS(5111),
    [anon_sym_enum] = ACTIONS(5111),
    [anon_sym_RBRACE] = ACTIONS(5113),
    [anon_sym_interface] = ACTIONS(5111),
    [anon_sym_delegate] = ACTIONS(5111),
    [anon_sym_record] = ACTIONS(5111),
    [anon_sym_abstract] = ACTIONS(5111),
    [anon_sym_async] = ACTIONS(5111),
    [anon_sym_const] = ACTIONS(5111),
    [anon_sym_file] = ACTIONS(5111),
    [anon_sym_fixed] = ACTIONS(5111),
    [anon_sym_internal] = ACTIONS(5111),
    [anon_sym_new] = ACTIONS(5111),
    [anon_sym_override] = ACTIONS(5111),
    [anon_sym_partial] = ACTIONS(5111),
    [anon_sym_private] = ACTIONS(5111),
    [anon_sym_protected] = ACTIONS(5111),
    [anon_sym_public] = ACTIONS(5111),
    [anon_sym_readonly] = ACTIONS(5111),
    [anon_sym_required] = ACTIONS(5111),
    [anon_sym_sealed] = ACTIONS(5111),
    [anon_sym_virtual] = ACTIONS(5111),
    [anon_sym_volatile] = ACTIONS(5111),
    [anon_sym_where] = ACTIONS(5111),
    [anon_sym_notnull] = ACTIONS(5111),
    [anon_sym_unmanaged] = ACTIONS(5111),
    [anon_sym_TILDE] = ACTIONS(5113),
    [anon_sym_implicit] = ACTIONS(5111),
    [anon_sym_explicit] = ACTIONS(5111),
    [anon_sym_scoped] = ACTIONS(5111),
    [anon_sym_var] = ACTIONS(5111),
    [sym_predefined_type] = ACTIONS(5111),
    [anon_sym_yield] = ACTIONS(5111),
    [anon_sym_when] = ACTIONS(5111),
    [anon_sym_from] = ACTIONS(5111),
    [anon_sym_into] = ACTIONS(5111),
    [anon_sym_join] = ACTIONS(5111),
    [anon_sym_on] = ACTIONS(5111),
    [anon_sym_equals] = ACTIONS(5111),
    [anon_sym_let] = ACTIONS(5111),
    [anon_sym_orderby] = ACTIONS(5111),
    [anon_sym_ascending] = ACTIONS(5111),
    [anon_sym_descending] = ACTIONS(5111),
    [anon_sym_group] = ACTIONS(5111),
    [anon_sym_by] = ACTIONS(5111),
    [anon_sym_select] = ACTIONS(5111),
    [aux_sym_preproc_if_token1] = ACTIONS(5113),
    [aux_sym_preproc_if_token3] = ACTIONS(5113),
    [aux_sym_preproc_else_token1] = ACTIONS(5113),
    [aux_sym_preproc_elif_token1] = ACTIONS(5113),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3459] = {
    [sym_preproc_region] = STATE(3459),
    [sym_preproc_endregion] = STATE(3459),
    [sym_preproc_line] = STATE(3459),
    [sym_preproc_pragma] = STATE(3459),
    [sym_preproc_nullable] = STATE(3459),
    [sym_preproc_error] = STATE(3459),
    [sym_preproc_define] = STATE(3459),
    [sym_preproc_undef] = STATE(3459),
    [sym__identifier_token] = ACTIONS(5115),
    [anon_sym_extern] = ACTIONS(5115),
    [anon_sym_alias] = ACTIONS(5115),
    [anon_sym_global] = ACTIONS(5115),
    [anon_sym_using] = ACTIONS(5115),
    [anon_sym_unsafe] = ACTIONS(5115),
    [anon_sym_static] = ACTIONS(5115),
    [anon_sym_LBRACK] = ACTIONS(5117),
    [anon_sym_LPAREN] = ACTIONS(5117),
    [anon_sym_event] = ACTIONS(5115),
    [anon_sym_namespace] = ACTIONS(5115),
    [anon_sym_class] = ACTIONS(5115),
    [anon_sym_ref] = ACTIONS(5115),
    [anon_sym_struct] = ACTIONS(5115),
    [anon_sym_enum] = ACTIONS(5115),
    [anon_sym_RBRACE] = ACTIONS(5117),
    [anon_sym_interface] = ACTIONS(5115),
    [anon_sym_delegate] = ACTIONS(5115),
    [anon_sym_record] = ACTIONS(5115),
    [anon_sym_abstract] = ACTIONS(5115),
    [anon_sym_async] = ACTIONS(5115),
    [anon_sym_const] = ACTIONS(5115),
    [anon_sym_file] = ACTIONS(5115),
    [anon_sym_fixed] = ACTIONS(5115),
    [anon_sym_internal] = ACTIONS(5115),
    [anon_sym_new] = ACTIONS(5115),
    [anon_sym_override] = ACTIONS(5115),
    [anon_sym_partial] = ACTIONS(5115),
    [anon_sym_private] = ACTIONS(5115),
    [anon_sym_protected] = ACTIONS(5115),
    [anon_sym_public] = ACTIONS(5115),
    [anon_sym_readonly] = ACTIONS(5115),
    [anon_sym_required] = ACTIONS(5115),
    [anon_sym_sealed] = ACTIONS(5115),
    [anon_sym_virtual] = ACTIONS(5115),
    [anon_sym_volatile] = ACTIONS(5115),
    [anon_sym_where] = ACTIONS(5115),
    [anon_sym_notnull] = ACTIONS(5115),
    [anon_sym_unmanaged] = ACTIONS(5115),
    [anon_sym_TILDE] = ACTIONS(5117),
    [anon_sym_implicit] = ACTIONS(5115),
    [anon_sym_explicit] = ACTIONS(5115),
    [anon_sym_scoped] = ACTIONS(5115),
    [anon_sym_var] = ACTIONS(5115),
    [sym_predefined_type] = ACTIONS(5115),
    [anon_sym_yield] = ACTIONS(5115),
    [anon_sym_when] = ACTIONS(5115),
    [anon_sym_from] = ACTIONS(5115),
    [anon_sym_into] = ACTIONS(5115),
    [anon_sym_join] = ACTIONS(5115),
    [anon_sym_on] = ACTIONS(5115),
    [anon_sym_equals] = ACTIONS(5115),
    [anon_sym_let] = ACTIONS(5115),
    [anon_sym_orderby] = ACTIONS(5115),
    [anon_sym_ascending] = ACTIONS(5115),
    [anon_sym_descending] = ACTIONS(5115),
    [anon_sym_group] = ACTIONS(5115),
    [anon_sym_by] = ACTIONS(5115),
    [anon_sym_select] = ACTIONS(5115),
    [aux_sym_preproc_if_token1] = ACTIONS(5117),
    [aux_sym_preproc_if_token3] = ACTIONS(5117),
    [aux_sym_preproc_else_token1] = ACTIONS(5117),
    [aux_sym_preproc_elif_token1] = ACTIONS(5117),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3460] = {
    [sym_preproc_region] = STATE(3460),
    [sym_preproc_endregion] = STATE(3460),
    [sym_preproc_line] = STATE(3460),
    [sym_preproc_pragma] = STATE(3460),
    [sym_preproc_nullable] = STATE(3460),
    [sym_preproc_error] = STATE(3460),
    [sym_preproc_define] = STATE(3460),
    [sym_preproc_undef] = STATE(3460),
    [sym__identifier_token] = ACTIONS(3633),
    [anon_sym_extern] = ACTIONS(3633),
    [anon_sym_alias] = ACTIONS(3633),
    [anon_sym_global] = ACTIONS(3633),
    [anon_sym_using] = ACTIONS(3633),
    [anon_sym_unsafe] = ACTIONS(3633),
    [anon_sym_static] = ACTIONS(3633),
    [anon_sym_LBRACK] = ACTIONS(3635),
    [anon_sym_LPAREN] = ACTIONS(3635),
    [anon_sym_event] = ACTIONS(3633),
    [anon_sym_namespace] = ACTIONS(3633),
    [anon_sym_class] = ACTIONS(3633),
    [anon_sym_ref] = ACTIONS(3633),
    [anon_sym_struct] = ACTIONS(3633),
    [anon_sym_enum] = ACTIONS(3633),
    [anon_sym_RBRACE] = ACTIONS(3635),
    [anon_sym_interface] = ACTIONS(3633),
    [anon_sym_delegate] = ACTIONS(3633),
    [anon_sym_record] = ACTIONS(3633),
    [anon_sym_abstract] = ACTIONS(3633),
    [anon_sym_async] = ACTIONS(3633),
    [anon_sym_const] = ACTIONS(3633),
    [anon_sym_file] = ACTIONS(3633),
    [anon_sym_fixed] = ACTIONS(3633),
    [anon_sym_internal] = ACTIONS(3633),
    [anon_sym_new] = ACTIONS(3633),
    [anon_sym_override] = ACTIONS(3633),
    [anon_sym_partial] = ACTIONS(3633),
    [anon_sym_private] = ACTIONS(3633),
    [anon_sym_protected] = ACTIONS(3633),
    [anon_sym_public] = ACTIONS(3633),
    [anon_sym_readonly] = ACTIONS(3633),
    [anon_sym_required] = ACTIONS(3633),
    [anon_sym_sealed] = ACTIONS(3633),
    [anon_sym_virtual] = ACTIONS(3633),
    [anon_sym_volatile] = ACTIONS(3633),
    [anon_sym_where] = ACTIONS(3633),
    [anon_sym_notnull] = ACTIONS(3633),
    [anon_sym_unmanaged] = ACTIONS(3633),
    [anon_sym_TILDE] = ACTIONS(3635),
    [anon_sym_implicit] = ACTIONS(3633),
    [anon_sym_explicit] = ACTIONS(3633),
    [anon_sym_scoped] = ACTIONS(3633),
    [anon_sym_var] = ACTIONS(3633),
    [sym_predefined_type] = ACTIONS(3633),
    [anon_sym_yield] = ACTIONS(3633),
    [anon_sym_when] = ACTIONS(3633),
    [anon_sym_from] = ACTIONS(3633),
    [anon_sym_into] = ACTIONS(3633),
    [anon_sym_join] = ACTIONS(3633),
    [anon_sym_on] = ACTIONS(3633),
    [anon_sym_equals] = ACTIONS(3633),
    [anon_sym_let] = ACTIONS(3633),
    [anon_sym_orderby] = ACTIONS(3633),
    [anon_sym_ascending] = ACTIONS(3633),
    [anon_sym_descending] = ACTIONS(3633),
    [anon_sym_group] = ACTIONS(3633),
    [anon_sym_by] = ACTIONS(3633),
    [anon_sym_select] = ACTIONS(3633),
    [aux_sym_preproc_if_token1] = ACTIONS(3635),
    [aux_sym_preproc_if_token3] = ACTIONS(3635),
    [aux_sym_preproc_else_token1] = ACTIONS(3635),
    [aux_sym_preproc_elif_token1] = ACTIONS(3635),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3461] = {
    [sym_preproc_region] = STATE(3461),
    [sym_preproc_endregion] = STATE(3461),
    [sym_preproc_line] = STATE(3461),
    [sym_preproc_pragma] = STATE(3461),
    [sym_preproc_nullable] = STATE(3461),
    [sym_preproc_error] = STATE(3461),
    [sym_preproc_define] = STATE(3461),
    [sym_preproc_undef] = STATE(3461),
    [sym__identifier_token] = ACTIONS(5119),
    [anon_sym_extern] = ACTIONS(5119),
    [anon_sym_alias] = ACTIONS(5119),
    [anon_sym_global] = ACTIONS(5119),
    [anon_sym_using] = ACTIONS(5119),
    [anon_sym_unsafe] = ACTIONS(5119),
    [anon_sym_static] = ACTIONS(5119),
    [anon_sym_LBRACK] = ACTIONS(5121),
    [anon_sym_LPAREN] = ACTIONS(5121),
    [anon_sym_event] = ACTIONS(5119),
    [anon_sym_namespace] = ACTIONS(5119),
    [anon_sym_class] = ACTIONS(5119),
    [anon_sym_ref] = ACTIONS(5119),
    [anon_sym_struct] = ACTIONS(5119),
    [anon_sym_enum] = ACTIONS(5119),
    [anon_sym_RBRACE] = ACTIONS(5121),
    [anon_sym_interface] = ACTIONS(5119),
    [anon_sym_delegate] = ACTIONS(5119),
    [anon_sym_record] = ACTIONS(5119),
    [anon_sym_abstract] = ACTIONS(5119),
    [anon_sym_async] = ACTIONS(5119),
    [anon_sym_const] = ACTIONS(5119),
    [anon_sym_file] = ACTIONS(5119),
    [anon_sym_fixed] = ACTIONS(5119),
    [anon_sym_internal] = ACTIONS(5119),
    [anon_sym_new] = ACTIONS(5119),
    [anon_sym_override] = ACTIONS(5119),
    [anon_sym_partial] = ACTIONS(5119),
    [anon_sym_private] = ACTIONS(5119),
    [anon_sym_protected] = ACTIONS(5119),
    [anon_sym_public] = ACTIONS(5119),
    [anon_sym_readonly] = ACTIONS(5119),
    [anon_sym_required] = ACTIONS(5119),
    [anon_sym_sealed] = ACTIONS(5119),
    [anon_sym_virtual] = ACTIONS(5119),
    [anon_sym_volatile] = ACTIONS(5119),
    [anon_sym_where] = ACTIONS(5119),
    [anon_sym_notnull] = ACTIONS(5119),
    [anon_sym_unmanaged] = ACTIONS(5119),
    [anon_sym_TILDE] = ACTIONS(5121),
    [anon_sym_implicit] = ACTIONS(5119),
    [anon_sym_explicit] = ACTIONS(5119),
    [anon_sym_scoped] = ACTIONS(5119),
    [anon_sym_var] = ACTIONS(5119),
    [sym_predefined_type] = ACTIONS(5119),
    [anon_sym_yield] = ACTIONS(5119),
    [anon_sym_when] = ACTIONS(5119),
    [anon_sym_from] = ACTIONS(5119),
    [anon_sym_into] = ACTIONS(5119),
    [anon_sym_join] = ACTIONS(5119),
    [anon_sym_on] = ACTIONS(5119),
    [anon_sym_equals] = ACTIONS(5119),
    [anon_sym_let] = ACTIONS(5119),
    [anon_sym_orderby] = ACTIONS(5119),
    [anon_sym_ascending] = ACTIONS(5119),
    [anon_sym_descending] = ACTIONS(5119),
    [anon_sym_group] = ACTIONS(5119),
    [anon_sym_by] = ACTIONS(5119),
    [anon_sym_select] = ACTIONS(5119),
    [aux_sym_preproc_if_token1] = ACTIONS(5121),
    [aux_sym_preproc_if_token3] = ACTIONS(5121),
    [aux_sym_preproc_else_token1] = ACTIONS(5121),
    [aux_sym_preproc_elif_token1] = ACTIONS(5121),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3462] = {
    [sym_preproc_region] = STATE(3462),
    [sym_preproc_endregion] = STATE(3462),
    [sym_preproc_line] = STATE(3462),
    [sym_preproc_pragma] = STATE(3462),
    [sym_preproc_nullable] = STATE(3462),
    [sym_preproc_error] = STATE(3462),
    [sym_preproc_define] = STATE(3462),
    [sym_preproc_undef] = STATE(3462),
    [sym__identifier_token] = ACTIONS(3736),
    [anon_sym_extern] = ACTIONS(3736),
    [anon_sym_alias] = ACTIONS(3736),
    [anon_sym_global] = ACTIONS(3736),
    [anon_sym_using] = ACTIONS(3736),
    [anon_sym_unsafe] = ACTIONS(3736),
    [anon_sym_static] = ACTIONS(3736),
    [anon_sym_LBRACK] = ACTIONS(3738),
    [anon_sym_LPAREN] = ACTIONS(3738),
    [anon_sym_event] = ACTIONS(3736),
    [anon_sym_namespace] = ACTIONS(3736),
    [anon_sym_class] = ACTIONS(3736),
    [anon_sym_ref] = ACTIONS(3736),
    [anon_sym_struct] = ACTIONS(3736),
    [anon_sym_enum] = ACTIONS(3736),
    [anon_sym_RBRACE] = ACTIONS(3738),
    [anon_sym_interface] = ACTIONS(3736),
    [anon_sym_delegate] = ACTIONS(3736),
    [anon_sym_record] = ACTIONS(3736),
    [anon_sym_abstract] = ACTIONS(3736),
    [anon_sym_async] = ACTIONS(3736),
    [anon_sym_const] = ACTIONS(3736),
    [anon_sym_file] = ACTIONS(3736),
    [anon_sym_fixed] = ACTIONS(3736),
    [anon_sym_internal] = ACTIONS(3736),
    [anon_sym_new] = ACTIONS(3736),
    [anon_sym_override] = ACTIONS(3736),
    [anon_sym_partial] = ACTIONS(3736),
    [anon_sym_private] = ACTIONS(3736),
    [anon_sym_protected] = ACTIONS(3736),
    [anon_sym_public] = ACTIONS(3736),
    [anon_sym_readonly] = ACTIONS(3736),
    [anon_sym_required] = ACTIONS(3736),
    [anon_sym_sealed] = ACTIONS(3736),
    [anon_sym_virtual] = ACTIONS(3736),
    [anon_sym_volatile] = ACTIONS(3736),
    [anon_sym_where] = ACTIONS(3736),
    [anon_sym_notnull] = ACTIONS(3736),
    [anon_sym_unmanaged] = ACTIONS(3736),
    [anon_sym_TILDE] = ACTIONS(3738),
    [anon_sym_implicit] = ACTIONS(3736),
    [anon_sym_explicit] = ACTIONS(3736),
    [anon_sym_scoped] = ACTIONS(3736),
    [anon_sym_var] = ACTIONS(3736),
    [sym_predefined_type] = ACTIONS(3736),
    [anon_sym_yield] = ACTIONS(3736),
    [anon_sym_when] = ACTIONS(3736),
    [anon_sym_from] = ACTIONS(3736),
    [anon_sym_into] = ACTIONS(3736),
    [anon_sym_join] = ACTIONS(3736),
    [anon_sym_on] = ACTIONS(3736),
    [anon_sym_equals] = ACTIONS(3736),
    [anon_sym_let] = ACTIONS(3736),
    [anon_sym_orderby] = ACTIONS(3736),
    [anon_sym_ascending] = ACTIONS(3736),
    [anon_sym_descending] = ACTIONS(3736),
    [anon_sym_group] = ACTIONS(3736),
    [anon_sym_by] = ACTIONS(3736),
    [anon_sym_select] = ACTIONS(3736),
    [aux_sym_preproc_if_token1] = ACTIONS(3738),
    [aux_sym_preproc_if_token3] = ACTIONS(3738),
    [aux_sym_preproc_else_token1] = ACTIONS(3738),
    [aux_sym_preproc_elif_token1] = ACTIONS(3738),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3463] = {
    [sym_preproc_region] = STATE(3463),
    [sym_preproc_endregion] = STATE(3463),
    [sym_preproc_line] = STATE(3463),
    [sym_preproc_pragma] = STATE(3463),
    [sym_preproc_nullable] = STATE(3463),
    [sym_preproc_error] = STATE(3463),
    [sym_preproc_define] = STATE(3463),
    [sym_preproc_undef] = STATE(3463),
    [sym__identifier_token] = ACTIONS(3629),
    [anon_sym_extern] = ACTIONS(3629),
    [anon_sym_alias] = ACTIONS(3629),
    [anon_sym_global] = ACTIONS(3629),
    [anon_sym_using] = ACTIONS(3629),
    [anon_sym_unsafe] = ACTIONS(3629),
    [anon_sym_static] = ACTIONS(3629),
    [anon_sym_LBRACK] = ACTIONS(3631),
    [anon_sym_LPAREN] = ACTIONS(3631),
    [anon_sym_event] = ACTIONS(3629),
    [anon_sym_namespace] = ACTIONS(3629),
    [anon_sym_class] = ACTIONS(3629),
    [anon_sym_ref] = ACTIONS(3629),
    [anon_sym_struct] = ACTIONS(3629),
    [anon_sym_enum] = ACTIONS(3629),
    [anon_sym_RBRACE] = ACTIONS(3631),
    [anon_sym_interface] = ACTIONS(3629),
    [anon_sym_delegate] = ACTIONS(3629),
    [anon_sym_record] = ACTIONS(3629),
    [anon_sym_abstract] = ACTIONS(3629),
    [anon_sym_async] = ACTIONS(3629),
    [anon_sym_const] = ACTIONS(3629),
    [anon_sym_file] = ACTIONS(3629),
    [anon_sym_fixed] = ACTIONS(3629),
    [anon_sym_internal] = ACTIONS(3629),
    [anon_sym_new] = ACTIONS(3629),
    [anon_sym_override] = ACTIONS(3629),
    [anon_sym_partial] = ACTIONS(3629),
    [anon_sym_private] = ACTIONS(3629),
    [anon_sym_protected] = ACTIONS(3629),
    [anon_sym_public] = ACTIONS(3629),
    [anon_sym_readonly] = ACTIONS(3629),
    [anon_sym_required] = ACTIONS(3629),
    [anon_sym_sealed] = ACTIONS(3629),
    [anon_sym_virtual] = ACTIONS(3629),
    [anon_sym_volatile] = ACTIONS(3629),
    [anon_sym_where] = ACTIONS(3629),
    [anon_sym_notnull] = ACTIONS(3629),
    [anon_sym_unmanaged] = ACTIONS(3629),
    [anon_sym_TILDE] = ACTIONS(3631),
    [anon_sym_implicit] = ACTIONS(3629),
    [anon_sym_explicit] = ACTIONS(3629),
    [anon_sym_scoped] = ACTIONS(3629),
    [anon_sym_var] = ACTIONS(3629),
    [sym_predefined_type] = ACTIONS(3629),
    [anon_sym_yield] = ACTIONS(3629),
    [anon_sym_when] = ACTIONS(3629),
    [anon_sym_from] = ACTIONS(3629),
    [anon_sym_into] = ACTIONS(3629),
    [anon_sym_join] = ACTIONS(3629),
    [anon_sym_on] = ACTIONS(3629),
    [anon_sym_equals] = ACTIONS(3629),
    [anon_sym_let] = ACTIONS(3629),
    [anon_sym_orderby] = ACTIONS(3629),
    [anon_sym_ascending] = ACTIONS(3629),
    [anon_sym_descending] = ACTIONS(3629),
    [anon_sym_group] = ACTIONS(3629),
    [anon_sym_by] = ACTIONS(3629),
    [anon_sym_select] = ACTIONS(3629),
    [aux_sym_preproc_if_token1] = ACTIONS(3631),
    [aux_sym_preproc_if_token3] = ACTIONS(3631),
    [aux_sym_preproc_else_token1] = ACTIONS(3631),
    [aux_sym_preproc_elif_token1] = ACTIONS(3631),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3464] = {
    [sym_preproc_region] = STATE(3464),
    [sym_preproc_endregion] = STATE(3464),
    [sym_preproc_line] = STATE(3464),
    [sym_preproc_pragma] = STATE(3464),
    [sym_preproc_nullable] = STATE(3464),
    [sym_preproc_error] = STATE(3464),
    [sym_preproc_define] = STATE(3464),
    [sym_preproc_undef] = STATE(3464),
    [sym__identifier_token] = ACTIONS(4478),
    [anon_sym_alias] = ACTIONS(4478),
    [anon_sym_global] = ACTIONS(4478),
    [anon_sym_LBRACK] = ACTIONS(4480),
    [anon_sym_COLON] = ACTIONS(4480),
    [anon_sym_COMMA] = ACTIONS(4480),
    [anon_sym_LPAREN] = ACTIONS(4480),
    [anon_sym_LBRACE] = ACTIONS(4480),
    [anon_sym_file] = ACTIONS(4478),
    [anon_sym_LT] = ACTIONS(4478),
    [anon_sym_GT] = ACTIONS(4478),
    [anon_sym_where] = ACTIONS(4478),
    [anon_sym_QMARK] = ACTIONS(4478),
    [anon_sym_notnull] = ACTIONS(4478),
    [anon_sym_unmanaged] = ACTIONS(4478),
    [anon_sym_BANG] = ACTIONS(4478),
    [anon_sym_PLUS_PLUS] = ACTIONS(4480),
    [anon_sym_DASH_DASH] = ACTIONS(4480),
    [anon_sym_PLUS] = ACTIONS(4478),
    [anon_sym_DASH] = ACTIONS(4478),
    [anon_sym_STAR] = ACTIONS(4480),
    [anon_sym_SLASH] = ACTIONS(4478),
    [anon_sym_PERCENT] = ACTIONS(4480),
    [anon_sym_CARET] = ACTIONS(4480),
    [anon_sym_PIPE] = ACTIONS(4478),
    [anon_sym_AMP] = ACTIONS(4478),
    [anon_sym_LT_LT] = ACTIONS(4480),
    [anon_sym_GT_GT] = ACTIONS(4478),
    [anon_sym_GT_GT_GT] = ACTIONS(4480),
    [anon_sym_EQ_EQ] = ACTIONS(4480),
    [anon_sym_BANG_EQ] = ACTIONS(4480),
    [anon_sym_GT_EQ] = ACTIONS(4480),
    [anon_sym_LT_EQ] = ACTIONS(4480),
    [anon_sym_DOT] = ACTIONS(4478),
    [anon_sym_scoped] = ACTIONS(4478),
    [anon_sym_var] = ACTIONS(4478),
    [anon_sym_yield] = ACTIONS(4478),
    [anon_sym_switch] = ACTIONS(4478),
    [anon_sym_when] = ACTIONS(4478),
    [sym_discard] = ACTIONS(4478),
    [anon_sym_DOT_DOT] = ACTIONS(4480),
    [anon_sym_and] = ACTIONS(4478),
    [anon_sym_or] = ACTIONS(4478),
    [anon_sym_AMP_AMP] = ACTIONS(4480),
    [anon_sym_PIPE_PIPE] = ACTIONS(4480),
    [anon_sym_QMARK_QMARK] = ACTIONS(4480),
    [anon_sym_from] = ACTIONS(4478),
    [anon_sym_into] = ACTIONS(4478),
    [anon_sym_join] = ACTIONS(4478),
    [anon_sym_on] = ACTIONS(4478),
    [anon_sym_equals] = ACTIONS(4478),
    [anon_sym_let] = ACTIONS(4478),
    [anon_sym_orderby] = ACTIONS(4478),
    [anon_sym_ascending] = ACTIONS(4478),
    [anon_sym_descending] = ACTIONS(4478),
    [anon_sym_group] = ACTIONS(4478),
    [anon_sym_by] = ACTIONS(4478),
    [anon_sym_select] = ACTIONS(4478),
    [anon_sym_as] = ACTIONS(4478),
    [anon_sym_is] = ACTIONS(4478),
    [anon_sym_DASH_GT] = ACTIONS(4480),
    [anon_sym_with] = ACTIONS(4478),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4480),
  },
  [3465] = {
    [sym_preproc_region] = STATE(3465),
    [sym_preproc_endregion] = STATE(3465),
    [sym_preproc_line] = STATE(3465),
    [sym_preproc_pragma] = STATE(3465),
    [sym_preproc_nullable] = STATE(3465),
    [sym_preproc_error] = STATE(3465),
    [sym_preproc_define] = STATE(3465),
    [sym_preproc_undef] = STATE(3465),
    [sym__identifier_token] = ACTIONS(5123),
    [anon_sym_extern] = ACTIONS(5123),
    [anon_sym_alias] = ACTIONS(5123),
    [anon_sym_global] = ACTIONS(5123),
    [anon_sym_using] = ACTIONS(5123),
    [anon_sym_unsafe] = ACTIONS(5123),
    [anon_sym_static] = ACTIONS(5123),
    [anon_sym_LBRACK] = ACTIONS(5125),
    [anon_sym_LPAREN] = ACTIONS(5125),
    [anon_sym_event] = ACTIONS(5123),
    [anon_sym_namespace] = ACTIONS(5123),
    [anon_sym_class] = ACTIONS(5123),
    [anon_sym_ref] = ACTIONS(5123),
    [anon_sym_struct] = ACTIONS(5123),
    [anon_sym_enum] = ACTIONS(5123),
    [anon_sym_RBRACE] = ACTIONS(5125),
    [anon_sym_interface] = ACTIONS(5123),
    [anon_sym_delegate] = ACTIONS(5123),
    [anon_sym_record] = ACTIONS(5123),
    [anon_sym_abstract] = ACTIONS(5123),
    [anon_sym_async] = ACTIONS(5123),
    [anon_sym_const] = ACTIONS(5123),
    [anon_sym_file] = ACTIONS(5123),
    [anon_sym_fixed] = ACTIONS(5123),
    [anon_sym_internal] = ACTIONS(5123),
    [anon_sym_new] = ACTIONS(5123),
    [anon_sym_override] = ACTIONS(5123),
    [anon_sym_partial] = ACTIONS(5123),
    [anon_sym_private] = ACTIONS(5123),
    [anon_sym_protected] = ACTIONS(5123),
    [anon_sym_public] = ACTIONS(5123),
    [anon_sym_readonly] = ACTIONS(5123),
    [anon_sym_required] = ACTIONS(5123),
    [anon_sym_sealed] = ACTIONS(5123),
    [anon_sym_virtual] = ACTIONS(5123),
    [anon_sym_volatile] = ACTIONS(5123),
    [anon_sym_where] = ACTIONS(5123),
    [anon_sym_notnull] = ACTIONS(5123),
    [anon_sym_unmanaged] = ACTIONS(5123),
    [anon_sym_TILDE] = ACTIONS(5125),
    [anon_sym_implicit] = ACTIONS(5123),
    [anon_sym_explicit] = ACTIONS(5123),
    [anon_sym_scoped] = ACTIONS(5123),
    [anon_sym_var] = ACTIONS(5123),
    [sym_predefined_type] = ACTIONS(5123),
    [anon_sym_yield] = ACTIONS(5123),
    [anon_sym_when] = ACTIONS(5123),
    [anon_sym_from] = ACTIONS(5123),
    [anon_sym_into] = ACTIONS(5123),
    [anon_sym_join] = ACTIONS(5123),
    [anon_sym_on] = ACTIONS(5123),
    [anon_sym_equals] = ACTIONS(5123),
    [anon_sym_let] = ACTIONS(5123),
    [anon_sym_orderby] = ACTIONS(5123),
    [anon_sym_ascending] = ACTIONS(5123),
    [anon_sym_descending] = ACTIONS(5123),
    [anon_sym_group] = ACTIONS(5123),
    [anon_sym_by] = ACTIONS(5123),
    [anon_sym_select] = ACTIONS(5123),
    [aux_sym_preproc_if_token1] = ACTIONS(5125),
    [aux_sym_preproc_if_token3] = ACTIONS(5125),
    [aux_sym_preproc_else_token1] = ACTIONS(5125),
    [aux_sym_preproc_elif_token1] = ACTIONS(5125),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3466] = {
    [sym__variable_designation] = STATE(4025),
    [sym_parenthesized_variable_designation] = STATE(4015),
    [sym_identifier] = STATE(4020),
    [sym__reserved_identifier] = STATE(3908),
    [sym_preproc_region] = STATE(3466),
    [sym_preproc_endregion] = STATE(3466),
    [sym_preproc_line] = STATE(3466),
    [sym_preproc_pragma] = STATE(3466),
    [sym_preproc_nullable] = STATE(3466),
    [sym_preproc_error] = STATE(3466),
    [sym_preproc_define] = STATE(3466),
    [sym_preproc_undef] = STATE(3466),
    [sym__identifier_token] = ACTIONS(4271),
    [anon_sym_alias] = ACTIONS(4273),
    [anon_sym_global] = ACTIONS(4273),
    [anon_sym_LBRACK] = ACTIONS(4329),
    [anon_sym_LPAREN] = ACTIONS(4329),
    [anon_sym_file] = ACTIONS(4273),
    [anon_sym_LT] = ACTIONS(4331),
    [anon_sym_GT] = ACTIONS(4331),
    [anon_sym_where] = ACTIONS(4273),
    [anon_sym_QMARK] = ACTIONS(4331),
    [anon_sym_notnull] = ACTIONS(4273),
    [anon_sym_unmanaged] = ACTIONS(4273),
    [anon_sym_BANG] = ACTIONS(4331),
    [anon_sym_PLUS_PLUS] = ACTIONS(4329),
    [anon_sym_DASH_DASH] = ACTIONS(4329),
    [anon_sym_PLUS] = ACTIONS(4331),
    [anon_sym_DASH] = ACTIONS(4331),
    [anon_sym_STAR] = ACTIONS(4329),
    [anon_sym_SLASH] = ACTIONS(4331),
    [anon_sym_PERCENT] = ACTIONS(4329),
    [anon_sym_CARET] = ACTIONS(4329),
    [anon_sym_PIPE] = ACTIONS(4331),
    [anon_sym_AMP] = ACTIONS(4331),
    [anon_sym_LT_LT] = ACTIONS(4329),
    [anon_sym_GT_GT] = ACTIONS(4331),
    [anon_sym_GT_GT_GT] = ACTIONS(4329),
    [anon_sym_EQ_EQ] = ACTIONS(4329),
    [anon_sym_BANG_EQ] = ACTIONS(4329),
    [anon_sym_GT_EQ] = ACTIONS(4329),
    [anon_sym_LT_EQ] = ACTIONS(4329),
    [anon_sym_DOT] = ACTIONS(4331),
    [anon_sym_scoped] = ACTIONS(4273),
    [anon_sym_var] = ACTIONS(4273),
    [anon_sym_yield] = ACTIONS(4273),
    [anon_sym_switch] = ACTIONS(4331),
    [anon_sym_when] = ACTIONS(4273),
    [sym_discard] = ACTIONS(4281),
    [anon_sym_DOT_DOT] = ACTIONS(4329),
    [anon_sym_and] = ACTIONS(4331),
    [anon_sym_or] = ACTIONS(4331),
    [anon_sym_AMP_AMP] = ACTIONS(4329),
    [anon_sym_PIPE_PIPE] = ACTIONS(4329),
    [anon_sym_QMARK_QMARK] = ACTIONS(4329),
    [anon_sym_from] = ACTIONS(4273),
    [anon_sym_into] = ACTIONS(4331),
    [anon_sym_join] = ACTIONS(4273),
    [anon_sym_on] = ACTIONS(4331),
    [anon_sym_equals] = ACTIONS(4273),
    [anon_sym_let] = ACTIONS(4273),
    [anon_sym_orderby] = ACTIONS(4273),
    [anon_sym_ascending] = ACTIONS(4273),
    [anon_sym_descending] = ACTIONS(4273),
    [anon_sym_group] = ACTIONS(4273),
    [anon_sym_by] = ACTIONS(4273),
    [anon_sym_select] = ACTIONS(4273),
    [anon_sym_as] = ACTIONS(4331),
    [anon_sym_is] = ACTIONS(4331),
    [anon_sym_DASH_GT] = ACTIONS(4329),
    [anon_sym_with] = ACTIONS(4331),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3467] = {
    [sym_preproc_region] = STATE(3467),
    [sym_preproc_endregion] = STATE(3467),
    [sym_preproc_line] = STATE(3467),
    [sym_preproc_pragma] = STATE(3467),
    [sym_preproc_nullable] = STATE(3467),
    [sym_preproc_error] = STATE(3467),
    [sym_preproc_define] = STATE(3467),
    [sym_preproc_undef] = STATE(3467),
    [sym__identifier_token] = ACTIONS(3625),
    [anon_sym_extern] = ACTIONS(3625),
    [anon_sym_alias] = ACTIONS(3625),
    [anon_sym_global] = ACTIONS(3625),
    [anon_sym_using] = ACTIONS(3625),
    [anon_sym_unsafe] = ACTIONS(3625),
    [anon_sym_static] = ACTIONS(3625),
    [anon_sym_LBRACK] = ACTIONS(3627),
    [anon_sym_LPAREN] = ACTIONS(3627),
    [anon_sym_event] = ACTIONS(3625),
    [anon_sym_namespace] = ACTIONS(3625),
    [anon_sym_class] = ACTIONS(3625),
    [anon_sym_ref] = ACTIONS(3625),
    [anon_sym_struct] = ACTIONS(3625),
    [anon_sym_enum] = ACTIONS(3625),
    [anon_sym_RBRACE] = ACTIONS(3627),
    [anon_sym_interface] = ACTIONS(3625),
    [anon_sym_delegate] = ACTIONS(3625),
    [anon_sym_record] = ACTIONS(3625),
    [anon_sym_abstract] = ACTIONS(3625),
    [anon_sym_async] = ACTIONS(3625),
    [anon_sym_const] = ACTIONS(3625),
    [anon_sym_file] = ACTIONS(3625),
    [anon_sym_fixed] = ACTIONS(3625),
    [anon_sym_internal] = ACTIONS(3625),
    [anon_sym_new] = ACTIONS(3625),
    [anon_sym_override] = ACTIONS(3625),
    [anon_sym_partial] = ACTIONS(3625),
    [anon_sym_private] = ACTIONS(3625),
    [anon_sym_protected] = ACTIONS(3625),
    [anon_sym_public] = ACTIONS(3625),
    [anon_sym_readonly] = ACTIONS(3625),
    [anon_sym_required] = ACTIONS(3625),
    [anon_sym_sealed] = ACTIONS(3625),
    [anon_sym_virtual] = ACTIONS(3625),
    [anon_sym_volatile] = ACTIONS(3625),
    [anon_sym_where] = ACTIONS(3625),
    [anon_sym_notnull] = ACTIONS(3625),
    [anon_sym_unmanaged] = ACTIONS(3625),
    [anon_sym_TILDE] = ACTIONS(3627),
    [anon_sym_implicit] = ACTIONS(3625),
    [anon_sym_explicit] = ACTIONS(3625),
    [anon_sym_scoped] = ACTIONS(3625),
    [anon_sym_var] = ACTIONS(3625),
    [sym_predefined_type] = ACTIONS(3625),
    [anon_sym_yield] = ACTIONS(3625),
    [anon_sym_when] = ACTIONS(3625),
    [anon_sym_from] = ACTIONS(3625),
    [anon_sym_into] = ACTIONS(3625),
    [anon_sym_join] = ACTIONS(3625),
    [anon_sym_on] = ACTIONS(3625),
    [anon_sym_equals] = ACTIONS(3625),
    [anon_sym_let] = ACTIONS(3625),
    [anon_sym_orderby] = ACTIONS(3625),
    [anon_sym_ascending] = ACTIONS(3625),
    [anon_sym_descending] = ACTIONS(3625),
    [anon_sym_group] = ACTIONS(3625),
    [anon_sym_by] = ACTIONS(3625),
    [anon_sym_select] = ACTIONS(3625),
    [aux_sym_preproc_if_token1] = ACTIONS(3627),
    [aux_sym_preproc_if_token3] = ACTIONS(3627),
    [aux_sym_preproc_else_token1] = ACTIONS(3627),
    [aux_sym_preproc_elif_token1] = ACTIONS(3627),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3468] = {
    [sym_preproc_region] = STATE(3468),
    [sym_preproc_endregion] = STATE(3468),
    [sym_preproc_line] = STATE(3468),
    [sym_preproc_pragma] = STATE(3468),
    [sym_preproc_nullable] = STATE(3468),
    [sym_preproc_error] = STATE(3468),
    [sym_preproc_define] = STATE(3468),
    [sym_preproc_undef] = STATE(3468),
    [sym__identifier_token] = ACTIONS(5127),
    [anon_sym_extern] = ACTIONS(5127),
    [anon_sym_alias] = ACTIONS(5127),
    [anon_sym_global] = ACTIONS(5127),
    [anon_sym_using] = ACTIONS(5127),
    [anon_sym_unsafe] = ACTIONS(5127),
    [anon_sym_static] = ACTIONS(5127),
    [anon_sym_LBRACK] = ACTIONS(5129),
    [anon_sym_LPAREN] = ACTIONS(5129),
    [anon_sym_event] = ACTIONS(5127),
    [anon_sym_namespace] = ACTIONS(5127),
    [anon_sym_class] = ACTIONS(5127),
    [anon_sym_ref] = ACTIONS(5127),
    [anon_sym_struct] = ACTIONS(5127),
    [anon_sym_enum] = ACTIONS(5127),
    [anon_sym_RBRACE] = ACTIONS(5129),
    [anon_sym_interface] = ACTIONS(5127),
    [anon_sym_delegate] = ACTIONS(5127),
    [anon_sym_record] = ACTIONS(5127),
    [anon_sym_abstract] = ACTIONS(5127),
    [anon_sym_async] = ACTIONS(5127),
    [anon_sym_const] = ACTIONS(5127),
    [anon_sym_file] = ACTIONS(5127),
    [anon_sym_fixed] = ACTIONS(5127),
    [anon_sym_internal] = ACTIONS(5127),
    [anon_sym_new] = ACTIONS(5127),
    [anon_sym_override] = ACTIONS(5127),
    [anon_sym_partial] = ACTIONS(5127),
    [anon_sym_private] = ACTIONS(5127),
    [anon_sym_protected] = ACTIONS(5127),
    [anon_sym_public] = ACTIONS(5127),
    [anon_sym_readonly] = ACTIONS(5127),
    [anon_sym_required] = ACTIONS(5127),
    [anon_sym_sealed] = ACTIONS(5127),
    [anon_sym_virtual] = ACTIONS(5127),
    [anon_sym_volatile] = ACTIONS(5127),
    [anon_sym_where] = ACTIONS(5127),
    [anon_sym_notnull] = ACTIONS(5127),
    [anon_sym_unmanaged] = ACTIONS(5127),
    [anon_sym_TILDE] = ACTIONS(5129),
    [anon_sym_implicit] = ACTIONS(5127),
    [anon_sym_explicit] = ACTIONS(5127),
    [anon_sym_scoped] = ACTIONS(5127),
    [anon_sym_var] = ACTIONS(5127),
    [sym_predefined_type] = ACTIONS(5127),
    [anon_sym_yield] = ACTIONS(5127),
    [anon_sym_when] = ACTIONS(5127),
    [anon_sym_from] = ACTIONS(5127),
    [anon_sym_into] = ACTIONS(5127),
    [anon_sym_join] = ACTIONS(5127),
    [anon_sym_on] = ACTIONS(5127),
    [anon_sym_equals] = ACTIONS(5127),
    [anon_sym_let] = ACTIONS(5127),
    [anon_sym_orderby] = ACTIONS(5127),
    [anon_sym_ascending] = ACTIONS(5127),
    [anon_sym_descending] = ACTIONS(5127),
    [anon_sym_group] = ACTIONS(5127),
    [anon_sym_by] = ACTIONS(5127),
    [anon_sym_select] = ACTIONS(5127),
    [aux_sym_preproc_if_token1] = ACTIONS(5129),
    [aux_sym_preproc_if_token3] = ACTIONS(5129),
    [aux_sym_preproc_else_token1] = ACTIONS(5129),
    [aux_sym_preproc_elif_token1] = ACTIONS(5129),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3469] = {
    [sym_preproc_region] = STATE(3469),
    [sym_preproc_endregion] = STATE(3469),
    [sym_preproc_line] = STATE(3469),
    [sym_preproc_pragma] = STATE(3469),
    [sym_preproc_nullable] = STATE(3469),
    [sym_preproc_error] = STATE(3469),
    [sym_preproc_define] = STATE(3469),
    [sym_preproc_undef] = STATE(3469),
    [sym__identifier_token] = ACTIONS(3621),
    [anon_sym_extern] = ACTIONS(3621),
    [anon_sym_alias] = ACTIONS(3621),
    [anon_sym_global] = ACTIONS(3621),
    [anon_sym_using] = ACTIONS(3621),
    [anon_sym_unsafe] = ACTIONS(3621),
    [anon_sym_static] = ACTIONS(3621),
    [anon_sym_LBRACK] = ACTIONS(3623),
    [anon_sym_LPAREN] = ACTIONS(3623),
    [anon_sym_event] = ACTIONS(3621),
    [anon_sym_namespace] = ACTIONS(3621),
    [anon_sym_class] = ACTIONS(3621),
    [anon_sym_ref] = ACTIONS(3621),
    [anon_sym_struct] = ACTIONS(3621),
    [anon_sym_enum] = ACTIONS(3621),
    [anon_sym_RBRACE] = ACTIONS(3623),
    [anon_sym_interface] = ACTIONS(3621),
    [anon_sym_delegate] = ACTIONS(3621),
    [anon_sym_record] = ACTIONS(3621),
    [anon_sym_abstract] = ACTIONS(3621),
    [anon_sym_async] = ACTIONS(3621),
    [anon_sym_const] = ACTIONS(3621),
    [anon_sym_file] = ACTIONS(3621),
    [anon_sym_fixed] = ACTIONS(3621),
    [anon_sym_internal] = ACTIONS(3621),
    [anon_sym_new] = ACTIONS(3621),
    [anon_sym_override] = ACTIONS(3621),
    [anon_sym_partial] = ACTIONS(3621),
    [anon_sym_private] = ACTIONS(3621),
    [anon_sym_protected] = ACTIONS(3621),
    [anon_sym_public] = ACTIONS(3621),
    [anon_sym_readonly] = ACTIONS(3621),
    [anon_sym_required] = ACTIONS(3621),
    [anon_sym_sealed] = ACTIONS(3621),
    [anon_sym_virtual] = ACTIONS(3621),
    [anon_sym_volatile] = ACTIONS(3621),
    [anon_sym_where] = ACTIONS(3621),
    [anon_sym_notnull] = ACTIONS(3621),
    [anon_sym_unmanaged] = ACTIONS(3621),
    [anon_sym_TILDE] = ACTIONS(3623),
    [anon_sym_implicit] = ACTIONS(3621),
    [anon_sym_explicit] = ACTIONS(3621),
    [anon_sym_scoped] = ACTIONS(3621),
    [anon_sym_var] = ACTIONS(3621),
    [sym_predefined_type] = ACTIONS(3621),
    [anon_sym_yield] = ACTIONS(3621),
    [anon_sym_when] = ACTIONS(3621),
    [anon_sym_from] = ACTIONS(3621),
    [anon_sym_into] = ACTIONS(3621),
    [anon_sym_join] = ACTIONS(3621),
    [anon_sym_on] = ACTIONS(3621),
    [anon_sym_equals] = ACTIONS(3621),
    [anon_sym_let] = ACTIONS(3621),
    [anon_sym_orderby] = ACTIONS(3621),
    [anon_sym_ascending] = ACTIONS(3621),
    [anon_sym_descending] = ACTIONS(3621),
    [anon_sym_group] = ACTIONS(3621),
    [anon_sym_by] = ACTIONS(3621),
    [anon_sym_select] = ACTIONS(3621),
    [aux_sym_preproc_if_token1] = ACTIONS(3623),
    [aux_sym_preproc_if_token3] = ACTIONS(3623),
    [aux_sym_preproc_else_token1] = ACTIONS(3623),
    [aux_sym_preproc_elif_token1] = ACTIONS(3623),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3470] = {
    [sym_preproc_region] = STATE(3470),
    [sym_preproc_endregion] = STATE(3470),
    [sym_preproc_line] = STATE(3470),
    [sym_preproc_pragma] = STATE(3470),
    [sym_preproc_nullable] = STATE(3470),
    [sym_preproc_error] = STATE(3470),
    [sym_preproc_define] = STATE(3470),
    [sym_preproc_undef] = STATE(3470),
    [sym__identifier_token] = ACTIONS(3617),
    [anon_sym_extern] = ACTIONS(3617),
    [anon_sym_alias] = ACTIONS(3617),
    [anon_sym_global] = ACTIONS(3617),
    [anon_sym_using] = ACTIONS(3617),
    [anon_sym_unsafe] = ACTIONS(3617),
    [anon_sym_static] = ACTIONS(3617),
    [anon_sym_LBRACK] = ACTIONS(3619),
    [anon_sym_LPAREN] = ACTIONS(3619),
    [anon_sym_event] = ACTIONS(3617),
    [anon_sym_namespace] = ACTIONS(3617),
    [anon_sym_class] = ACTIONS(3617),
    [anon_sym_ref] = ACTIONS(3617),
    [anon_sym_struct] = ACTIONS(3617),
    [anon_sym_enum] = ACTIONS(3617),
    [anon_sym_RBRACE] = ACTIONS(3619),
    [anon_sym_interface] = ACTIONS(3617),
    [anon_sym_delegate] = ACTIONS(3617),
    [anon_sym_record] = ACTIONS(3617),
    [anon_sym_abstract] = ACTIONS(3617),
    [anon_sym_async] = ACTIONS(3617),
    [anon_sym_const] = ACTIONS(3617),
    [anon_sym_file] = ACTIONS(3617),
    [anon_sym_fixed] = ACTIONS(3617),
    [anon_sym_internal] = ACTIONS(3617),
    [anon_sym_new] = ACTIONS(3617),
    [anon_sym_override] = ACTIONS(3617),
    [anon_sym_partial] = ACTIONS(3617),
    [anon_sym_private] = ACTIONS(3617),
    [anon_sym_protected] = ACTIONS(3617),
    [anon_sym_public] = ACTIONS(3617),
    [anon_sym_readonly] = ACTIONS(3617),
    [anon_sym_required] = ACTIONS(3617),
    [anon_sym_sealed] = ACTIONS(3617),
    [anon_sym_virtual] = ACTIONS(3617),
    [anon_sym_volatile] = ACTIONS(3617),
    [anon_sym_where] = ACTIONS(3617),
    [anon_sym_notnull] = ACTIONS(3617),
    [anon_sym_unmanaged] = ACTIONS(3617),
    [anon_sym_TILDE] = ACTIONS(3619),
    [anon_sym_implicit] = ACTIONS(3617),
    [anon_sym_explicit] = ACTIONS(3617),
    [anon_sym_scoped] = ACTIONS(3617),
    [anon_sym_var] = ACTIONS(3617),
    [sym_predefined_type] = ACTIONS(3617),
    [anon_sym_yield] = ACTIONS(3617),
    [anon_sym_when] = ACTIONS(3617),
    [anon_sym_from] = ACTIONS(3617),
    [anon_sym_into] = ACTIONS(3617),
    [anon_sym_join] = ACTIONS(3617),
    [anon_sym_on] = ACTIONS(3617),
    [anon_sym_equals] = ACTIONS(3617),
    [anon_sym_let] = ACTIONS(3617),
    [anon_sym_orderby] = ACTIONS(3617),
    [anon_sym_ascending] = ACTIONS(3617),
    [anon_sym_descending] = ACTIONS(3617),
    [anon_sym_group] = ACTIONS(3617),
    [anon_sym_by] = ACTIONS(3617),
    [anon_sym_select] = ACTIONS(3617),
    [aux_sym_preproc_if_token1] = ACTIONS(3619),
    [aux_sym_preproc_if_token3] = ACTIONS(3619),
    [aux_sym_preproc_else_token1] = ACTIONS(3619),
    [aux_sym_preproc_elif_token1] = ACTIONS(3619),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3471] = {
    [sym_preproc_region] = STATE(3471),
    [sym_preproc_endregion] = STATE(3471),
    [sym_preproc_line] = STATE(3471),
    [sym_preproc_pragma] = STATE(3471),
    [sym_preproc_nullable] = STATE(3471),
    [sym_preproc_error] = STATE(3471),
    [sym_preproc_define] = STATE(3471),
    [sym_preproc_undef] = STATE(3471),
    [sym__identifier_token] = ACTIONS(3613),
    [anon_sym_extern] = ACTIONS(3613),
    [anon_sym_alias] = ACTIONS(3613),
    [anon_sym_global] = ACTIONS(3613),
    [anon_sym_using] = ACTIONS(3613),
    [anon_sym_unsafe] = ACTIONS(3613),
    [anon_sym_static] = ACTIONS(3613),
    [anon_sym_LBRACK] = ACTIONS(3615),
    [anon_sym_LPAREN] = ACTIONS(3615),
    [anon_sym_event] = ACTIONS(3613),
    [anon_sym_namespace] = ACTIONS(3613),
    [anon_sym_class] = ACTIONS(3613),
    [anon_sym_ref] = ACTIONS(3613),
    [anon_sym_struct] = ACTIONS(3613),
    [anon_sym_enum] = ACTIONS(3613),
    [anon_sym_RBRACE] = ACTIONS(3615),
    [anon_sym_interface] = ACTIONS(3613),
    [anon_sym_delegate] = ACTIONS(3613),
    [anon_sym_record] = ACTIONS(3613),
    [anon_sym_abstract] = ACTIONS(3613),
    [anon_sym_async] = ACTIONS(3613),
    [anon_sym_const] = ACTIONS(3613),
    [anon_sym_file] = ACTIONS(3613),
    [anon_sym_fixed] = ACTIONS(3613),
    [anon_sym_internal] = ACTIONS(3613),
    [anon_sym_new] = ACTIONS(3613),
    [anon_sym_override] = ACTIONS(3613),
    [anon_sym_partial] = ACTIONS(3613),
    [anon_sym_private] = ACTIONS(3613),
    [anon_sym_protected] = ACTIONS(3613),
    [anon_sym_public] = ACTIONS(3613),
    [anon_sym_readonly] = ACTIONS(3613),
    [anon_sym_required] = ACTIONS(3613),
    [anon_sym_sealed] = ACTIONS(3613),
    [anon_sym_virtual] = ACTIONS(3613),
    [anon_sym_volatile] = ACTIONS(3613),
    [anon_sym_where] = ACTIONS(3613),
    [anon_sym_notnull] = ACTIONS(3613),
    [anon_sym_unmanaged] = ACTIONS(3613),
    [anon_sym_TILDE] = ACTIONS(3615),
    [anon_sym_implicit] = ACTIONS(3613),
    [anon_sym_explicit] = ACTIONS(3613),
    [anon_sym_scoped] = ACTIONS(3613),
    [anon_sym_var] = ACTIONS(3613),
    [sym_predefined_type] = ACTIONS(3613),
    [anon_sym_yield] = ACTIONS(3613),
    [anon_sym_when] = ACTIONS(3613),
    [anon_sym_from] = ACTIONS(3613),
    [anon_sym_into] = ACTIONS(3613),
    [anon_sym_join] = ACTIONS(3613),
    [anon_sym_on] = ACTIONS(3613),
    [anon_sym_equals] = ACTIONS(3613),
    [anon_sym_let] = ACTIONS(3613),
    [anon_sym_orderby] = ACTIONS(3613),
    [anon_sym_ascending] = ACTIONS(3613),
    [anon_sym_descending] = ACTIONS(3613),
    [anon_sym_group] = ACTIONS(3613),
    [anon_sym_by] = ACTIONS(3613),
    [anon_sym_select] = ACTIONS(3613),
    [aux_sym_preproc_if_token1] = ACTIONS(3615),
    [aux_sym_preproc_if_token3] = ACTIONS(3615),
    [aux_sym_preproc_else_token1] = ACTIONS(3615),
    [aux_sym_preproc_elif_token1] = ACTIONS(3615),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3472] = {
    [sym_preproc_region] = STATE(3472),
    [sym_preproc_endregion] = STATE(3472),
    [sym_preproc_line] = STATE(3472),
    [sym_preproc_pragma] = STATE(3472),
    [sym_preproc_nullable] = STATE(3472),
    [sym_preproc_error] = STATE(3472),
    [sym_preproc_define] = STATE(3472),
    [sym_preproc_undef] = STATE(3472),
    [sym__identifier_token] = ACTIONS(5131),
    [anon_sym_extern] = ACTIONS(5131),
    [anon_sym_alias] = ACTIONS(5131),
    [anon_sym_global] = ACTIONS(5131),
    [anon_sym_using] = ACTIONS(5131),
    [anon_sym_unsafe] = ACTIONS(5131),
    [anon_sym_static] = ACTIONS(5131),
    [anon_sym_LBRACK] = ACTIONS(5133),
    [anon_sym_LPAREN] = ACTIONS(5133),
    [anon_sym_event] = ACTIONS(5131),
    [anon_sym_namespace] = ACTIONS(5131),
    [anon_sym_class] = ACTIONS(5131),
    [anon_sym_ref] = ACTIONS(5131),
    [anon_sym_struct] = ACTIONS(5131),
    [anon_sym_enum] = ACTIONS(5131),
    [anon_sym_RBRACE] = ACTIONS(5133),
    [anon_sym_interface] = ACTIONS(5131),
    [anon_sym_delegate] = ACTIONS(5131),
    [anon_sym_record] = ACTIONS(5131),
    [anon_sym_abstract] = ACTIONS(5131),
    [anon_sym_async] = ACTIONS(5131),
    [anon_sym_const] = ACTIONS(5131),
    [anon_sym_file] = ACTIONS(5131),
    [anon_sym_fixed] = ACTIONS(5131),
    [anon_sym_internal] = ACTIONS(5131),
    [anon_sym_new] = ACTIONS(5131),
    [anon_sym_override] = ACTIONS(5131),
    [anon_sym_partial] = ACTIONS(5131),
    [anon_sym_private] = ACTIONS(5131),
    [anon_sym_protected] = ACTIONS(5131),
    [anon_sym_public] = ACTIONS(5131),
    [anon_sym_readonly] = ACTIONS(5131),
    [anon_sym_required] = ACTIONS(5131),
    [anon_sym_sealed] = ACTIONS(5131),
    [anon_sym_virtual] = ACTIONS(5131),
    [anon_sym_volatile] = ACTIONS(5131),
    [anon_sym_where] = ACTIONS(5131),
    [anon_sym_notnull] = ACTIONS(5131),
    [anon_sym_unmanaged] = ACTIONS(5131),
    [anon_sym_TILDE] = ACTIONS(5133),
    [anon_sym_implicit] = ACTIONS(5131),
    [anon_sym_explicit] = ACTIONS(5131),
    [anon_sym_scoped] = ACTIONS(5131),
    [anon_sym_var] = ACTIONS(5131),
    [sym_predefined_type] = ACTIONS(5131),
    [anon_sym_yield] = ACTIONS(5131),
    [anon_sym_when] = ACTIONS(5131),
    [anon_sym_from] = ACTIONS(5131),
    [anon_sym_into] = ACTIONS(5131),
    [anon_sym_join] = ACTIONS(5131),
    [anon_sym_on] = ACTIONS(5131),
    [anon_sym_equals] = ACTIONS(5131),
    [anon_sym_let] = ACTIONS(5131),
    [anon_sym_orderby] = ACTIONS(5131),
    [anon_sym_ascending] = ACTIONS(5131),
    [anon_sym_descending] = ACTIONS(5131),
    [anon_sym_group] = ACTIONS(5131),
    [anon_sym_by] = ACTIONS(5131),
    [anon_sym_select] = ACTIONS(5131),
    [aux_sym_preproc_if_token1] = ACTIONS(5133),
    [aux_sym_preproc_if_token3] = ACTIONS(5133),
    [aux_sym_preproc_else_token1] = ACTIONS(5133),
    [aux_sym_preproc_elif_token1] = ACTIONS(5133),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3473] = {
    [sym_preproc_region] = STATE(3473),
    [sym_preproc_endregion] = STATE(3473),
    [sym_preproc_line] = STATE(3473),
    [sym_preproc_pragma] = STATE(3473),
    [sym_preproc_nullable] = STATE(3473),
    [sym_preproc_error] = STATE(3473),
    [sym_preproc_define] = STATE(3473),
    [sym_preproc_undef] = STATE(3473),
    [sym__identifier_token] = ACTIONS(5135),
    [anon_sym_extern] = ACTIONS(5135),
    [anon_sym_alias] = ACTIONS(5135),
    [anon_sym_global] = ACTIONS(5135),
    [anon_sym_using] = ACTIONS(5135),
    [anon_sym_unsafe] = ACTIONS(5135),
    [anon_sym_static] = ACTIONS(5135),
    [anon_sym_LBRACK] = ACTIONS(5137),
    [anon_sym_LPAREN] = ACTIONS(5137),
    [anon_sym_event] = ACTIONS(5135),
    [anon_sym_namespace] = ACTIONS(5135),
    [anon_sym_class] = ACTIONS(5135),
    [anon_sym_ref] = ACTIONS(5135),
    [anon_sym_struct] = ACTIONS(5135),
    [anon_sym_enum] = ACTIONS(5135),
    [anon_sym_RBRACE] = ACTIONS(5137),
    [anon_sym_interface] = ACTIONS(5135),
    [anon_sym_delegate] = ACTIONS(5135),
    [anon_sym_record] = ACTIONS(5135),
    [anon_sym_abstract] = ACTIONS(5135),
    [anon_sym_async] = ACTIONS(5135),
    [anon_sym_const] = ACTIONS(5135),
    [anon_sym_file] = ACTIONS(5135),
    [anon_sym_fixed] = ACTIONS(5135),
    [anon_sym_internal] = ACTIONS(5135),
    [anon_sym_new] = ACTIONS(5135),
    [anon_sym_override] = ACTIONS(5135),
    [anon_sym_partial] = ACTIONS(5135),
    [anon_sym_private] = ACTIONS(5135),
    [anon_sym_protected] = ACTIONS(5135),
    [anon_sym_public] = ACTIONS(5135),
    [anon_sym_readonly] = ACTIONS(5135),
    [anon_sym_required] = ACTIONS(5135),
    [anon_sym_sealed] = ACTIONS(5135),
    [anon_sym_virtual] = ACTIONS(5135),
    [anon_sym_volatile] = ACTIONS(5135),
    [anon_sym_where] = ACTIONS(5135),
    [anon_sym_notnull] = ACTIONS(5135),
    [anon_sym_unmanaged] = ACTIONS(5135),
    [anon_sym_TILDE] = ACTIONS(5137),
    [anon_sym_implicit] = ACTIONS(5135),
    [anon_sym_explicit] = ACTIONS(5135),
    [anon_sym_scoped] = ACTIONS(5135),
    [anon_sym_var] = ACTIONS(5135),
    [sym_predefined_type] = ACTIONS(5135),
    [anon_sym_yield] = ACTIONS(5135),
    [anon_sym_when] = ACTIONS(5135),
    [anon_sym_from] = ACTIONS(5135),
    [anon_sym_into] = ACTIONS(5135),
    [anon_sym_join] = ACTIONS(5135),
    [anon_sym_on] = ACTIONS(5135),
    [anon_sym_equals] = ACTIONS(5135),
    [anon_sym_let] = ACTIONS(5135),
    [anon_sym_orderby] = ACTIONS(5135),
    [anon_sym_ascending] = ACTIONS(5135),
    [anon_sym_descending] = ACTIONS(5135),
    [anon_sym_group] = ACTIONS(5135),
    [anon_sym_by] = ACTIONS(5135),
    [anon_sym_select] = ACTIONS(5135),
    [aux_sym_preproc_if_token1] = ACTIONS(5137),
    [aux_sym_preproc_if_token3] = ACTIONS(5137),
    [aux_sym_preproc_else_token1] = ACTIONS(5137),
    [aux_sym_preproc_elif_token1] = ACTIONS(5137),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3474] = {
    [sym_preproc_region] = STATE(3474),
    [sym_preproc_endregion] = STATE(3474),
    [sym_preproc_line] = STATE(3474),
    [sym_preproc_pragma] = STATE(3474),
    [sym_preproc_nullable] = STATE(3474),
    [sym_preproc_error] = STATE(3474),
    [sym_preproc_define] = STATE(3474),
    [sym_preproc_undef] = STATE(3474),
    [sym__identifier_token] = ACTIONS(5139),
    [anon_sym_extern] = ACTIONS(5139),
    [anon_sym_alias] = ACTIONS(5139),
    [anon_sym_global] = ACTIONS(5139),
    [anon_sym_using] = ACTIONS(5139),
    [anon_sym_unsafe] = ACTIONS(5139),
    [anon_sym_static] = ACTIONS(5139),
    [anon_sym_LBRACK] = ACTIONS(5141),
    [anon_sym_LPAREN] = ACTIONS(5141),
    [anon_sym_event] = ACTIONS(5139),
    [anon_sym_namespace] = ACTIONS(5139),
    [anon_sym_class] = ACTIONS(5139),
    [anon_sym_ref] = ACTIONS(5139),
    [anon_sym_struct] = ACTIONS(5139),
    [anon_sym_enum] = ACTIONS(5139),
    [anon_sym_RBRACE] = ACTIONS(5141),
    [anon_sym_interface] = ACTIONS(5139),
    [anon_sym_delegate] = ACTIONS(5139),
    [anon_sym_record] = ACTIONS(5139),
    [anon_sym_abstract] = ACTIONS(5139),
    [anon_sym_async] = ACTIONS(5139),
    [anon_sym_const] = ACTIONS(5139),
    [anon_sym_file] = ACTIONS(5139),
    [anon_sym_fixed] = ACTIONS(5139),
    [anon_sym_internal] = ACTIONS(5139),
    [anon_sym_new] = ACTIONS(5139),
    [anon_sym_override] = ACTIONS(5139),
    [anon_sym_partial] = ACTIONS(5139),
    [anon_sym_private] = ACTIONS(5139),
    [anon_sym_protected] = ACTIONS(5139),
    [anon_sym_public] = ACTIONS(5139),
    [anon_sym_readonly] = ACTIONS(5139),
    [anon_sym_required] = ACTIONS(5139),
    [anon_sym_sealed] = ACTIONS(5139),
    [anon_sym_virtual] = ACTIONS(5139),
    [anon_sym_volatile] = ACTIONS(5139),
    [anon_sym_where] = ACTIONS(5139),
    [anon_sym_notnull] = ACTIONS(5139),
    [anon_sym_unmanaged] = ACTIONS(5139),
    [anon_sym_TILDE] = ACTIONS(5141),
    [anon_sym_implicit] = ACTIONS(5139),
    [anon_sym_explicit] = ACTIONS(5139),
    [anon_sym_scoped] = ACTIONS(5139),
    [anon_sym_var] = ACTIONS(5139),
    [sym_predefined_type] = ACTIONS(5139),
    [anon_sym_yield] = ACTIONS(5139),
    [anon_sym_when] = ACTIONS(5139),
    [anon_sym_from] = ACTIONS(5139),
    [anon_sym_into] = ACTIONS(5139),
    [anon_sym_join] = ACTIONS(5139),
    [anon_sym_on] = ACTIONS(5139),
    [anon_sym_equals] = ACTIONS(5139),
    [anon_sym_let] = ACTIONS(5139),
    [anon_sym_orderby] = ACTIONS(5139),
    [anon_sym_ascending] = ACTIONS(5139),
    [anon_sym_descending] = ACTIONS(5139),
    [anon_sym_group] = ACTIONS(5139),
    [anon_sym_by] = ACTIONS(5139),
    [anon_sym_select] = ACTIONS(5139),
    [aux_sym_preproc_if_token1] = ACTIONS(5141),
    [aux_sym_preproc_if_token3] = ACTIONS(5141),
    [aux_sym_preproc_else_token1] = ACTIONS(5141),
    [aux_sym_preproc_elif_token1] = ACTIONS(5141),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3475] = {
    [sym_preproc_region] = STATE(3475),
    [sym_preproc_endregion] = STATE(3475),
    [sym_preproc_line] = STATE(3475),
    [sym_preproc_pragma] = STATE(3475),
    [sym_preproc_nullable] = STATE(3475),
    [sym_preproc_error] = STATE(3475),
    [sym_preproc_define] = STATE(3475),
    [sym_preproc_undef] = STATE(3475),
    [sym__identifier_token] = ACTIONS(3593),
    [anon_sym_extern] = ACTIONS(3593),
    [anon_sym_alias] = ACTIONS(3593),
    [anon_sym_global] = ACTIONS(3593),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_unsafe] = ACTIONS(3593),
    [anon_sym_static] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(3595),
    [anon_sym_LPAREN] = ACTIONS(3595),
    [anon_sym_event] = ACTIONS(3593),
    [anon_sym_namespace] = ACTIONS(3593),
    [anon_sym_class] = ACTIONS(3593),
    [anon_sym_ref] = ACTIONS(3593),
    [anon_sym_struct] = ACTIONS(3593),
    [anon_sym_enum] = ACTIONS(3593),
    [anon_sym_RBRACE] = ACTIONS(3595),
    [anon_sym_interface] = ACTIONS(3593),
    [anon_sym_delegate] = ACTIONS(3593),
    [anon_sym_record] = ACTIONS(3593),
    [anon_sym_abstract] = ACTIONS(3593),
    [anon_sym_async] = ACTIONS(3593),
    [anon_sym_const] = ACTIONS(3593),
    [anon_sym_file] = ACTIONS(3593),
    [anon_sym_fixed] = ACTIONS(3593),
    [anon_sym_internal] = ACTIONS(3593),
    [anon_sym_new] = ACTIONS(3593),
    [anon_sym_override] = ACTIONS(3593),
    [anon_sym_partial] = ACTIONS(3593),
    [anon_sym_private] = ACTIONS(3593),
    [anon_sym_protected] = ACTIONS(3593),
    [anon_sym_public] = ACTIONS(3593),
    [anon_sym_readonly] = ACTIONS(3593),
    [anon_sym_required] = ACTIONS(3593),
    [anon_sym_sealed] = ACTIONS(3593),
    [anon_sym_virtual] = ACTIONS(3593),
    [anon_sym_volatile] = ACTIONS(3593),
    [anon_sym_where] = ACTIONS(3593),
    [anon_sym_notnull] = ACTIONS(3593),
    [anon_sym_unmanaged] = ACTIONS(3593),
    [anon_sym_TILDE] = ACTIONS(3595),
    [anon_sym_implicit] = ACTIONS(3593),
    [anon_sym_explicit] = ACTIONS(3593),
    [anon_sym_scoped] = ACTIONS(3593),
    [anon_sym_var] = ACTIONS(3593),
    [sym_predefined_type] = ACTIONS(3593),
    [anon_sym_yield] = ACTIONS(3593),
    [anon_sym_when] = ACTIONS(3593),
    [anon_sym_from] = ACTIONS(3593),
    [anon_sym_into] = ACTIONS(3593),
    [anon_sym_join] = ACTIONS(3593),
    [anon_sym_on] = ACTIONS(3593),
    [anon_sym_equals] = ACTIONS(3593),
    [anon_sym_let] = ACTIONS(3593),
    [anon_sym_orderby] = ACTIONS(3593),
    [anon_sym_ascending] = ACTIONS(3593),
    [anon_sym_descending] = ACTIONS(3593),
    [anon_sym_group] = ACTIONS(3593),
    [anon_sym_by] = ACTIONS(3593),
    [anon_sym_select] = ACTIONS(3593),
    [aux_sym_preproc_if_token1] = ACTIONS(3595),
    [aux_sym_preproc_if_token3] = ACTIONS(3595),
    [aux_sym_preproc_else_token1] = ACTIONS(3595),
    [aux_sym_preproc_elif_token1] = ACTIONS(3595),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3476] = {
    [sym_preproc_region] = STATE(3476),
    [sym_preproc_endregion] = STATE(3476),
    [sym_preproc_line] = STATE(3476),
    [sym_preproc_pragma] = STATE(3476),
    [sym_preproc_nullable] = STATE(3476),
    [sym_preproc_error] = STATE(3476),
    [sym_preproc_define] = STATE(3476),
    [sym_preproc_undef] = STATE(3476),
    [sym__identifier_token] = ACTIONS(3577),
    [anon_sym_extern] = ACTIONS(3577),
    [anon_sym_alias] = ACTIONS(3577),
    [anon_sym_global] = ACTIONS(3577),
    [anon_sym_using] = ACTIONS(3577),
    [anon_sym_unsafe] = ACTIONS(3577),
    [anon_sym_static] = ACTIONS(3577),
    [anon_sym_LBRACK] = ACTIONS(3579),
    [anon_sym_LPAREN] = ACTIONS(3579),
    [anon_sym_event] = ACTIONS(3577),
    [anon_sym_namespace] = ACTIONS(3577),
    [anon_sym_class] = ACTIONS(3577),
    [anon_sym_ref] = ACTIONS(3577),
    [anon_sym_struct] = ACTIONS(3577),
    [anon_sym_enum] = ACTIONS(3577),
    [anon_sym_RBRACE] = ACTIONS(3579),
    [anon_sym_interface] = ACTIONS(3577),
    [anon_sym_delegate] = ACTIONS(3577),
    [anon_sym_record] = ACTIONS(3577),
    [anon_sym_abstract] = ACTIONS(3577),
    [anon_sym_async] = ACTIONS(3577),
    [anon_sym_const] = ACTIONS(3577),
    [anon_sym_file] = ACTIONS(3577),
    [anon_sym_fixed] = ACTIONS(3577),
    [anon_sym_internal] = ACTIONS(3577),
    [anon_sym_new] = ACTIONS(3577),
    [anon_sym_override] = ACTIONS(3577),
    [anon_sym_partial] = ACTIONS(3577),
    [anon_sym_private] = ACTIONS(3577),
    [anon_sym_protected] = ACTIONS(3577),
    [anon_sym_public] = ACTIONS(3577),
    [anon_sym_readonly] = ACTIONS(3577),
    [anon_sym_required] = ACTIONS(3577),
    [anon_sym_sealed] = ACTIONS(3577),
    [anon_sym_virtual] = ACTIONS(3577),
    [anon_sym_volatile] = ACTIONS(3577),
    [anon_sym_where] = ACTIONS(3577),
    [anon_sym_notnull] = ACTIONS(3577),
    [anon_sym_unmanaged] = ACTIONS(3577),
    [anon_sym_TILDE] = ACTIONS(3579),
    [anon_sym_implicit] = ACTIONS(3577),
    [anon_sym_explicit] = ACTIONS(3577),
    [anon_sym_scoped] = ACTIONS(3577),
    [anon_sym_var] = ACTIONS(3577),
    [sym_predefined_type] = ACTIONS(3577),
    [anon_sym_yield] = ACTIONS(3577),
    [anon_sym_when] = ACTIONS(3577),
    [anon_sym_from] = ACTIONS(3577),
    [anon_sym_into] = ACTIONS(3577),
    [anon_sym_join] = ACTIONS(3577),
    [anon_sym_on] = ACTIONS(3577),
    [anon_sym_equals] = ACTIONS(3577),
    [anon_sym_let] = ACTIONS(3577),
    [anon_sym_orderby] = ACTIONS(3577),
    [anon_sym_ascending] = ACTIONS(3577),
    [anon_sym_descending] = ACTIONS(3577),
    [anon_sym_group] = ACTIONS(3577),
    [anon_sym_by] = ACTIONS(3577),
    [anon_sym_select] = ACTIONS(3577),
    [aux_sym_preproc_if_token1] = ACTIONS(3579),
    [aux_sym_preproc_if_token3] = ACTIONS(3579),
    [aux_sym_preproc_else_token1] = ACTIONS(3579),
    [aux_sym_preproc_elif_token1] = ACTIONS(3579),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3477] = {
    [sym_preproc_region] = STATE(3477),
    [sym_preproc_endregion] = STATE(3477),
    [sym_preproc_line] = STATE(3477),
    [sym_preproc_pragma] = STATE(3477),
    [sym_preproc_nullable] = STATE(3477),
    [sym_preproc_error] = STATE(3477),
    [sym_preproc_define] = STATE(3477),
    [sym_preproc_undef] = STATE(3477),
    [sym__identifier_token] = ACTIONS(3740),
    [anon_sym_extern] = ACTIONS(3740),
    [anon_sym_alias] = ACTIONS(3740),
    [anon_sym_global] = ACTIONS(3740),
    [anon_sym_using] = ACTIONS(3740),
    [anon_sym_unsafe] = ACTIONS(3740),
    [anon_sym_static] = ACTIONS(3740),
    [anon_sym_LBRACK] = ACTIONS(3742),
    [anon_sym_LPAREN] = ACTIONS(3742),
    [anon_sym_event] = ACTIONS(3740),
    [anon_sym_namespace] = ACTIONS(3740),
    [anon_sym_class] = ACTIONS(3740),
    [anon_sym_ref] = ACTIONS(3740),
    [anon_sym_struct] = ACTIONS(3740),
    [anon_sym_enum] = ACTIONS(3740),
    [anon_sym_RBRACE] = ACTIONS(3742),
    [anon_sym_interface] = ACTIONS(3740),
    [anon_sym_delegate] = ACTIONS(3740),
    [anon_sym_record] = ACTIONS(3740),
    [anon_sym_abstract] = ACTIONS(3740),
    [anon_sym_async] = ACTIONS(3740),
    [anon_sym_const] = ACTIONS(3740),
    [anon_sym_file] = ACTIONS(3740),
    [anon_sym_fixed] = ACTIONS(3740),
    [anon_sym_internal] = ACTIONS(3740),
    [anon_sym_new] = ACTIONS(3740),
    [anon_sym_override] = ACTIONS(3740),
    [anon_sym_partial] = ACTIONS(3740),
    [anon_sym_private] = ACTIONS(3740),
    [anon_sym_protected] = ACTIONS(3740),
    [anon_sym_public] = ACTIONS(3740),
    [anon_sym_readonly] = ACTIONS(3740),
    [anon_sym_required] = ACTIONS(3740),
    [anon_sym_sealed] = ACTIONS(3740),
    [anon_sym_virtual] = ACTIONS(3740),
    [anon_sym_volatile] = ACTIONS(3740),
    [anon_sym_where] = ACTIONS(3740),
    [anon_sym_notnull] = ACTIONS(3740),
    [anon_sym_unmanaged] = ACTIONS(3740),
    [anon_sym_TILDE] = ACTIONS(3742),
    [anon_sym_implicit] = ACTIONS(3740),
    [anon_sym_explicit] = ACTIONS(3740),
    [anon_sym_scoped] = ACTIONS(3740),
    [anon_sym_var] = ACTIONS(3740),
    [sym_predefined_type] = ACTIONS(3740),
    [anon_sym_yield] = ACTIONS(3740),
    [anon_sym_when] = ACTIONS(3740),
    [anon_sym_from] = ACTIONS(3740),
    [anon_sym_into] = ACTIONS(3740),
    [anon_sym_join] = ACTIONS(3740),
    [anon_sym_on] = ACTIONS(3740),
    [anon_sym_equals] = ACTIONS(3740),
    [anon_sym_let] = ACTIONS(3740),
    [anon_sym_orderby] = ACTIONS(3740),
    [anon_sym_ascending] = ACTIONS(3740),
    [anon_sym_descending] = ACTIONS(3740),
    [anon_sym_group] = ACTIONS(3740),
    [anon_sym_by] = ACTIONS(3740),
    [anon_sym_select] = ACTIONS(3740),
    [aux_sym_preproc_if_token1] = ACTIONS(3742),
    [aux_sym_preproc_if_token3] = ACTIONS(3742),
    [aux_sym_preproc_else_token1] = ACTIONS(3742),
    [aux_sym_preproc_elif_token1] = ACTIONS(3742),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3478] = {
    [sym_preproc_region] = STATE(3478),
    [sym_preproc_endregion] = STATE(3478),
    [sym_preproc_line] = STATE(3478),
    [sym_preproc_pragma] = STATE(3478),
    [sym_preproc_nullable] = STATE(3478),
    [sym_preproc_error] = STATE(3478),
    [sym_preproc_define] = STATE(3478),
    [sym_preproc_undef] = STATE(3478),
    [sym__identifier_token] = ACTIONS(3569),
    [anon_sym_extern] = ACTIONS(3569),
    [anon_sym_alias] = ACTIONS(3569),
    [anon_sym_global] = ACTIONS(3569),
    [anon_sym_using] = ACTIONS(3569),
    [anon_sym_unsafe] = ACTIONS(3569),
    [anon_sym_static] = ACTIONS(3569),
    [anon_sym_LBRACK] = ACTIONS(3571),
    [anon_sym_LPAREN] = ACTIONS(3571),
    [anon_sym_event] = ACTIONS(3569),
    [anon_sym_namespace] = ACTIONS(3569),
    [anon_sym_class] = ACTIONS(3569),
    [anon_sym_ref] = ACTIONS(3569),
    [anon_sym_struct] = ACTIONS(3569),
    [anon_sym_enum] = ACTIONS(3569),
    [anon_sym_RBRACE] = ACTIONS(3571),
    [anon_sym_interface] = ACTIONS(3569),
    [anon_sym_delegate] = ACTIONS(3569),
    [anon_sym_record] = ACTIONS(3569),
    [anon_sym_abstract] = ACTIONS(3569),
    [anon_sym_async] = ACTIONS(3569),
    [anon_sym_const] = ACTIONS(3569),
    [anon_sym_file] = ACTIONS(3569),
    [anon_sym_fixed] = ACTIONS(3569),
    [anon_sym_internal] = ACTIONS(3569),
    [anon_sym_new] = ACTIONS(3569),
    [anon_sym_override] = ACTIONS(3569),
    [anon_sym_partial] = ACTIONS(3569),
    [anon_sym_private] = ACTIONS(3569),
    [anon_sym_protected] = ACTIONS(3569),
    [anon_sym_public] = ACTIONS(3569),
    [anon_sym_readonly] = ACTIONS(3569),
    [anon_sym_required] = ACTIONS(3569),
    [anon_sym_sealed] = ACTIONS(3569),
    [anon_sym_virtual] = ACTIONS(3569),
    [anon_sym_volatile] = ACTIONS(3569),
    [anon_sym_where] = ACTIONS(3569),
    [anon_sym_notnull] = ACTIONS(3569),
    [anon_sym_unmanaged] = ACTIONS(3569),
    [anon_sym_TILDE] = ACTIONS(3571),
    [anon_sym_implicit] = ACTIONS(3569),
    [anon_sym_explicit] = ACTIONS(3569),
    [anon_sym_scoped] = ACTIONS(3569),
    [anon_sym_var] = ACTIONS(3569),
    [sym_predefined_type] = ACTIONS(3569),
    [anon_sym_yield] = ACTIONS(3569),
    [anon_sym_when] = ACTIONS(3569),
    [anon_sym_from] = ACTIONS(3569),
    [anon_sym_into] = ACTIONS(3569),
    [anon_sym_join] = ACTIONS(3569),
    [anon_sym_on] = ACTIONS(3569),
    [anon_sym_equals] = ACTIONS(3569),
    [anon_sym_let] = ACTIONS(3569),
    [anon_sym_orderby] = ACTIONS(3569),
    [anon_sym_ascending] = ACTIONS(3569),
    [anon_sym_descending] = ACTIONS(3569),
    [anon_sym_group] = ACTIONS(3569),
    [anon_sym_by] = ACTIONS(3569),
    [anon_sym_select] = ACTIONS(3569),
    [aux_sym_preproc_if_token1] = ACTIONS(3571),
    [aux_sym_preproc_if_token3] = ACTIONS(3571),
    [aux_sym_preproc_else_token1] = ACTIONS(3571),
    [aux_sym_preproc_elif_token1] = ACTIONS(3571),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3479] = {
    [sym_preproc_region] = STATE(3479),
    [sym_preproc_endregion] = STATE(3479),
    [sym_preproc_line] = STATE(3479),
    [sym_preproc_pragma] = STATE(3479),
    [sym_preproc_nullable] = STATE(3479),
    [sym_preproc_error] = STATE(3479),
    [sym_preproc_define] = STATE(3479),
    [sym_preproc_undef] = STATE(3479),
    [sym__identifier_token] = ACTIONS(3537),
    [anon_sym_extern] = ACTIONS(3537),
    [anon_sym_alias] = ACTIONS(3537),
    [anon_sym_global] = ACTIONS(3537),
    [anon_sym_using] = ACTIONS(3537),
    [anon_sym_unsafe] = ACTIONS(3537),
    [anon_sym_static] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(3539),
    [anon_sym_LPAREN] = ACTIONS(3539),
    [anon_sym_event] = ACTIONS(3537),
    [anon_sym_namespace] = ACTIONS(3537),
    [anon_sym_class] = ACTIONS(3537),
    [anon_sym_ref] = ACTIONS(3537),
    [anon_sym_struct] = ACTIONS(3537),
    [anon_sym_enum] = ACTIONS(3537),
    [anon_sym_RBRACE] = ACTIONS(3539),
    [anon_sym_interface] = ACTIONS(3537),
    [anon_sym_delegate] = ACTIONS(3537),
    [anon_sym_record] = ACTIONS(3537),
    [anon_sym_abstract] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(3537),
    [anon_sym_const] = ACTIONS(3537),
    [anon_sym_file] = ACTIONS(3537),
    [anon_sym_fixed] = ACTIONS(3537),
    [anon_sym_internal] = ACTIONS(3537),
    [anon_sym_new] = ACTIONS(3537),
    [anon_sym_override] = ACTIONS(3537),
    [anon_sym_partial] = ACTIONS(3537),
    [anon_sym_private] = ACTIONS(3537),
    [anon_sym_protected] = ACTIONS(3537),
    [anon_sym_public] = ACTIONS(3537),
    [anon_sym_readonly] = ACTIONS(3537),
    [anon_sym_required] = ACTIONS(3537),
    [anon_sym_sealed] = ACTIONS(3537),
    [anon_sym_virtual] = ACTIONS(3537),
    [anon_sym_volatile] = ACTIONS(3537),
    [anon_sym_where] = ACTIONS(3537),
    [anon_sym_notnull] = ACTIONS(3537),
    [anon_sym_unmanaged] = ACTIONS(3537),
    [anon_sym_TILDE] = ACTIONS(3539),
    [anon_sym_implicit] = ACTIONS(3537),
    [anon_sym_explicit] = ACTIONS(3537),
    [anon_sym_scoped] = ACTIONS(3537),
    [anon_sym_var] = ACTIONS(3537),
    [sym_predefined_type] = ACTIONS(3537),
    [anon_sym_yield] = ACTIONS(3537),
    [anon_sym_when] = ACTIONS(3537),
    [anon_sym_from] = ACTIONS(3537),
    [anon_sym_into] = ACTIONS(3537),
    [anon_sym_join] = ACTIONS(3537),
    [anon_sym_on] = ACTIONS(3537),
    [anon_sym_equals] = ACTIONS(3537),
    [anon_sym_let] = ACTIONS(3537),
    [anon_sym_orderby] = ACTIONS(3537),
    [anon_sym_ascending] = ACTIONS(3537),
    [anon_sym_descending] = ACTIONS(3537),
    [anon_sym_group] = ACTIONS(3537),
    [anon_sym_by] = ACTIONS(3537),
    [anon_sym_select] = ACTIONS(3537),
    [aux_sym_preproc_if_token1] = ACTIONS(3539),
    [aux_sym_preproc_if_token3] = ACTIONS(3539),
    [aux_sym_preproc_else_token1] = ACTIONS(3539),
    [aux_sym_preproc_elif_token1] = ACTIONS(3539),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3480] = {
    [sym__variable_designation] = STATE(4035),
    [sym_parenthesized_variable_designation] = STATE(4015),
    [sym_identifier] = STATE(4020),
    [sym__reserved_identifier] = STATE(3908),
    [sym_preproc_region] = STATE(3480),
    [sym_preproc_endregion] = STATE(3480),
    [sym_preproc_line] = STATE(3480),
    [sym_preproc_pragma] = STATE(3480),
    [sym_preproc_nullable] = STATE(3480),
    [sym_preproc_error] = STATE(3480),
    [sym_preproc_define] = STATE(3480),
    [sym_preproc_undef] = STATE(3480),
    [sym__identifier_token] = ACTIONS(4271),
    [anon_sym_alias] = ACTIONS(4273),
    [anon_sym_global] = ACTIONS(4273),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_LPAREN] = ACTIONS(4383),
    [anon_sym_file] = ACTIONS(4273),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_where] = ACTIONS(4273),
    [anon_sym_QMARK] = ACTIONS(4385),
    [anon_sym_notnull] = ACTIONS(4273),
    [anon_sym_unmanaged] = ACTIONS(4273),
    [anon_sym_BANG] = ACTIONS(4385),
    [anon_sym_PLUS_PLUS] = ACTIONS(4383),
    [anon_sym_DASH_DASH] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4385),
    [anon_sym_DASH] = ACTIONS(4385),
    [anon_sym_STAR] = ACTIONS(4383),
    [anon_sym_SLASH] = ACTIONS(4385),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_AMP] = ACTIONS(4385),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_GT_GT] = ACTIONS(4385),
    [anon_sym_GT_GT_GT] = ACTIONS(4383),
    [anon_sym_EQ_EQ] = ACTIONS(4383),
    [anon_sym_BANG_EQ] = ACTIONS(4383),
    [anon_sym_GT_EQ] = ACTIONS(4383),
    [anon_sym_LT_EQ] = ACTIONS(4383),
    [anon_sym_DOT] = ACTIONS(4385),
    [anon_sym_scoped] = ACTIONS(4273),
    [anon_sym_var] = ACTIONS(4273),
    [anon_sym_yield] = ACTIONS(4273),
    [anon_sym_switch] = ACTIONS(4385),
    [anon_sym_when] = ACTIONS(4273),
    [sym_discard] = ACTIONS(4281),
    [anon_sym_DOT_DOT] = ACTIONS(4383),
    [anon_sym_and] = ACTIONS(4385),
    [anon_sym_or] = ACTIONS(4385),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_QMARK_QMARK] = ACTIONS(4383),
    [anon_sym_from] = ACTIONS(4273),
    [anon_sym_into] = ACTIONS(4385),
    [anon_sym_join] = ACTIONS(4273),
    [anon_sym_on] = ACTIONS(4273),
    [anon_sym_equals] = ACTIONS(4385),
    [anon_sym_let] = ACTIONS(4273),
    [anon_sym_orderby] = ACTIONS(4273),
    [anon_sym_ascending] = ACTIONS(4273),
    [anon_sym_descending] = ACTIONS(4273),
    [anon_sym_group] = ACTIONS(4273),
    [anon_sym_by] = ACTIONS(4273),
    [anon_sym_select] = ACTIONS(4273),
    [anon_sym_as] = ACTIONS(4385),
    [anon_sym_is] = ACTIONS(4385),
    [anon_sym_DASH_GT] = ACTIONS(4383),
    [anon_sym_with] = ACTIONS(4385),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3481] = {
    [sym_preproc_region] = STATE(3481),
    [sym_preproc_endregion] = STATE(3481),
    [sym_preproc_line] = STATE(3481),
    [sym_preproc_pragma] = STATE(3481),
    [sym_preproc_nullable] = STATE(3481),
    [sym_preproc_error] = STATE(3481),
    [sym_preproc_define] = STATE(3481),
    [sym_preproc_undef] = STATE(3481),
    [anon_sym_SEMI] = ACTIONS(4635),
    [anon_sym_EQ] = ACTIONS(4637),
    [anon_sym_LBRACK] = ACTIONS(4635),
    [anon_sym_COLON] = ACTIONS(4635),
    [anon_sym_COMMA] = ACTIONS(4635),
    [anon_sym_RBRACK] = ACTIONS(4635),
    [anon_sym_LPAREN] = ACTIONS(4635),
    [anon_sym_RPAREN] = ACTIONS(4635),
    [anon_sym_RBRACE] = ACTIONS(4635),
    [anon_sym_LT] = ACTIONS(4637),
    [anon_sym_GT] = ACTIONS(4637),
    [anon_sym_in] = ACTIONS(4635),
    [anon_sym_QMARK] = ACTIONS(4637),
    [anon_sym_BANG] = ACTIONS(4637),
    [anon_sym_PLUS_PLUS] = ACTIONS(4635),
    [anon_sym_DASH_DASH] = ACTIONS(4635),
    [anon_sym_PLUS] = ACTIONS(4637),
    [anon_sym_DASH] = ACTIONS(4637),
    [anon_sym_STAR] = ACTIONS(4637),
    [anon_sym_SLASH] = ACTIONS(4637),
    [anon_sym_PERCENT] = ACTIONS(4637),
    [anon_sym_CARET] = ACTIONS(4637),
    [anon_sym_PIPE] = ACTIONS(4637),
    [anon_sym_AMP] = ACTIONS(4637),
    [anon_sym_LT_LT] = ACTIONS(4637),
    [anon_sym_GT_GT] = ACTIONS(4637),
    [anon_sym_GT_GT_GT] = ACTIONS(4637),
    [anon_sym_EQ_EQ] = ACTIONS(4635),
    [anon_sym_BANG_EQ] = ACTIONS(4635),
    [anon_sym_GT_EQ] = ACTIONS(4635),
    [anon_sym_LT_EQ] = ACTIONS(4635),
    [anon_sym_DOT] = ACTIONS(4637),
    [anon_sym_EQ_GT] = ACTIONS(4635),
    [anon_sym_switch] = ACTIONS(4635),
    [anon_sym_when] = ACTIONS(4635),
    [anon_sym_DOT_DOT] = ACTIONS(4635),
    [anon_sym_and] = ACTIONS(4635),
    [anon_sym_or] = ACTIONS(4635),
    [anon_sym_PLUS_EQ] = ACTIONS(4635),
    [anon_sym_DASH_EQ] = ACTIONS(4635),
    [anon_sym_STAR_EQ] = ACTIONS(4635),
    [anon_sym_SLASH_EQ] = ACTIONS(4635),
    [anon_sym_PERCENT_EQ] = ACTIONS(4635),
    [anon_sym_AMP_EQ] = ACTIONS(4635),
    [anon_sym_CARET_EQ] = ACTIONS(4635),
    [anon_sym_PIPE_EQ] = ACTIONS(4635),
    [anon_sym_LT_LT_EQ] = ACTIONS(4635),
    [anon_sym_GT_GT_EQ] = ACTIONS(4635),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4635),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4635),
    [anon_sym_AMP_AMP] = ACTIONS(4635),
    [anon_sym_PIPE_PIPE] = ACTIONS(4635),
    [anon_sym_QMARK_QMARK] = ACTIONS(4637),
    [anon_sym_on] = ACTIONS(4635),
    [anon_sym_equals] = ACTIONS(4635),
    [anon_sym_by] = ACTIONS(4635),
    [anon_sym_as] = ACTIONS(4635),
    [anon_sym_is] = ACTIONS(4635),
    [anon_sym_DASH_GT] = ACTIONS(4635),
    [anon_sym_with] = ACTIONS(4635),
    [aux_sym_preproc_if_token3] = ACTIONS(4635),
    [aux_sym_preproc_else_token1] = ACTIONS(4635),
    [aux_sym_preproc_elif_token1] = ACTIONS(4635),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3482] = {
    [sym_preproc_region] = STATE(3482),
    [sym_preproc_endregion] = STATE(3482),
    [sym_preproc_line] = STATE(3482),
    [sym_preproc_pragma] = STATE(3482),
    [sym_preproc_nullable] = STATE(3482),
    [sym_preproc_error] = STATE(3482),
    [sym_preproc_define] = STATE(3482),
    [sym_preproc_undef] = STATE(3482),
    [sym__identifier_token] = ACTIONS(5143),
    [anon_sym_extern] = ACTIONS(5143),
    [anon_sym_alias] = ACTIONS(5143),
    [anon_sym_global] = ACTIONS(5143),
    [anon_sym_using] = ACTIONS(5143),
    [anon_sym_unsafe] = ACTIONS(5143),
    [anon_sym_static] = ACTIONS(5143),
    [anon_sym_LBRACK] = ACTIONS(5145),
    [anon_sym_LPAREN] = ACTIONS(5145),
    [anon_sym_event] = ACTIONS(5143),
    [anon_sym_namespace] = ACTIONS(5143),
    [anon_sym_class] = ACTIONS(5143),
    [anon_sym_ref] = ACTIONS(5143),
    [anon_sym_struct] = ACTIONS(5143),
    [anon_sym_enum] = ACTIONS(5143),
    [anon_sym_RBRACE] = ACTIONS(5145),
    [anon_sym_interface] = ACTIONS(5143),
    [anon_sym_delegate] = ACTIONS(5143),
    [anon_sym_record] = ACTIONS(5143),
    [anon_sym_abstract] = ACTIONS(5143),
    [anon_sym_async] = ACTIONS(5143),
    [anon_sym_const] = ACTIONS(5143),
    [anon_sym_file] = ACTIONS(5143),
    [anon_sym_fixed] = ACTIONS(5143),
    [anon_sym_internal] = ACTIONS(5143),
    [anon_sym_new] = ACTIONS(5143),
    [anon_sym_override] = ACTIONS(5143),
    [anon_sym_partial] = ACTIONS(5143),
    [anon_sym_private] = ACTIONS(5143),
    [anon_sym_protected] = ACTIONS(5143),
    [anon_sym_public] = ACTIONS(5143),
    [anon_sym_readonly] = ACTIONS(5143),
    [anon_sym_required] = ACTIONS(5143),
    [anon_sym_sealed] = ACTIONS(5143),
    [anon_sym_virtual] = ACTIONS(5143),
    [anon_sym_volatile] = ACTIONS(5143),
    [anon_sym_where] = ACTIONS(5143),
    [anon_sym_notnull] = ACTIONS(5143),
    [anon_sym_unmanaged] = ACTIONS(5143),
    [anon_sym_TILDE] = ACTIONS(5145),
    [anon_sym_implicit] = ACTIONS(5143),
    [anon_sym_explicit] = ACTIONS(5143),
    [anon_sym_scoped] = ACTIONS(5143),
    [anon_sym_var] = ACTIONS(5143),
    [sym_predefined_type] = ACTIONS(5143),
    [anon_sym_yield] = ACTIONS(5143),
    [anon_sym_when] = ACTIONS(5143),
    [anon_sym_from] = ACTIONS(5143),
    [anon_sym_into] = ACTIONS(5143),
    [anon_sym_join] = ACTIONS(5143),
    [anon_sym_on] = ACTIONS(5143),
    [anon_sym_equals] = ACTIONS(5143),
    [anon_sym_let] = ACTIONS(5143),
    [anon_sym_orderby] = ACTIONS(5143),
    [anon_sym_ascending] = ACTIONS(5143),
    [anon_sym_descending] = ACTIONS(5143),
    [anon_sym_group] = ACTIONS(5143),
    [anon_sym_by] = ACTIONS(5143),
    [anon_sym_select] = ACTIONS(5143),
    [aux_sym_preproc_if_token1] = ACTIONS(5145),
    [aux_sym_preproc_if_token3] = ACTIONS(5145),
    [aux_sym_preproc_else_token1] = ACTIONS(5145),
    [aux_sym_preproc_elif_token1] = ACTIONS(5145),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3483] = {
    [sym__variable_designation] = STATE(4063),
    [sym_parenthesized_variable_designation] = STATE(4015),
    [sym_identifier] = STATE(4020),
    [sym__reserved_identifier] = STATE(3908),
    [sym_preproc_region] = STATE(3483),
    [sym_preproc_endregion] = STATE(3483),
    [sym_preproc_line] = STATE(3483),
    [sym_preproc_pragma] = STATE(3483),
    [sym_preproc_nullable] = STATE(3483),
    [sym_preproc_error] = STATE(3483),
    [sym_preproc_define] = STATE(3483),
    [sym_preproc_undef] = STATE(3483),
    [sym__identifier_token] = ACTIONS(4271),
    [anon_sym_alias] = ACTIONS(4273),
    [anon_sym_global] = ACTIONS(4273),
    [anon_sym_LBRACK] = ACTIONS(4373),
    [anon_sym_LPAREN] = ACTIONS(4373),
    [anon_sym_file] = ACTIONS(4273),
    [anon_sym_LT] = ACTIONS(4375),
    [anon_sym_GT] = ACTIONS(4375),
    [anon_sym_where] = ACTIONS(4273),
    [anon_sym_QMARK] = ACTIONS(4375),
    [anon_sym_notnull] = ACTIONS(4273),
    [anon_sym_unmanaged] = ACTIONS(4273),
    [anon_sym_BANG] = ACTIONS(4375),
    [anon_sym_PLUS_PLUS] = ACTIONS(4373),
    [anon_sym_DASH_DASH] = ACTIONS(4373),
    [anon_sym_PLUS] = ACTIONS(4375),
    [anon_sym_DASH] = ACTIONS(4375),
    [anon_sym_STAR] = ACTIONS(4373),
    [anon_sym_SLASH] = ACTIONS(4375),
    [anon_sym_PERCENT] = ACTIONS(4373),
    [anon_sym_CARET] = ACTIONS(4373),
    [anon_sym_PIPE] = ACTIONS(4375),
    [anon_sym_AMP] = ACTIONS(4375),
    [anon_sym_LT_LT] = ACTIONS(4373),
    [anon_sym_GT_GT] = ACTIONS(4375),
    [anon_sym_GT_GT_GT] = ACTIONS(4373),
    [anon_sym_EQ_EQ] = ACTIONS(4373),
    [anon_sym_BANG_EQ] = ACTIONS(4373),
    [anon_sym_GT_EQ] = ACTIONS(4373),
    [anon_sym_LT_EQ] = ACTIONS(4373),
    [anon_sym_DOT] = ACTIONS(4375),
    [anon_sym_scoped] = ACTIONS(4273),
    [anon_sym_var] = ACTIONS(4273),
    [anon_sym_yield] = ACTIONS(4273),
    [anon_sym_switch] = ACTIONS(4375),
    [anon_sym_when] = ACTIONS(4273),
    [sym_discard] = ACTIONS(4281),
    [anon_sym_DOT_DOT] = ACTIONS(4373),
    [anon_sym_and] = ACTIONS(4375),
    [anon_sym_or] = ACTIONS(4375),
    [anon_sym_AMP_AMP] = ACTIONS(4373),
    [anon_sym_PIPE_PIPE] = ACTIONS(4373),
    [anon_sym_QMARK_QMARK] = ACTIONS(4373),
    [anon_sym_from] = ACTIONS(4273),
    [anon_sym_into] = ACTIONS(4375),
    [anon_sym_join] = ACTIONS(4273),
    [anon_sym_on] = ACTIONS(4273),
    [anon_sym_equals] = ACTIONS(4375),
    [anon_sym_let] = ACTIONS(4273),
    [anon_sym_orderby] = ACTIONS(4273),
    [anon_sym_ascending] = ACTIONS(4273),
    [anon_sym_descending] = ACTIONS(4273),
    [anon_sym_group] = ACTIONS(4273),
    [anon_sym_by] = ACTIONS(4273),
    [anon_sym_select] = ACTIONS(4273),
    [anon_sym_as] = ACTIONS(4375),
    [anon_sym_is] = ACTIONS(4375),
    [anon_sym_DASH_GT] = ACTIONS(4373),
    [anon_sym_with] = ACTIONS(4375),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3484] = {
    [sym__variable_designation] = STATE(3965),
    [sym_parenthesized_variable_designation] = STATE(4015),
    [sym_identifier] = STATE(4020),
    [sym__reserved_identifier] = STATE(3908),
    [sym_preproc_region] = STATE(3484),
    [sym_preproc_endregion] = STATE(3484),
    [sym_preproc_line] = STATE(3484),
    [sym_preproc_pragma] = STATE(3484),
    [sym_preproc_nullable] = STATE(3484),
    [sym_preproc_error] = STATE(3484),
    [sym_preproc_define] = STATE(3484),
    [sym_preproc_undef] = STATE(3484),
    [sym__identifier_token] = ACTIONS(4271),
    [anon_sym_alias] = ACTIONS(4273),
    [anon_sym_global] = ACTIONS(4273),
    [anon_sym_LBRACK] = ACTIONS(4335),
    [anon_sym_LPAREN] = ACTIONS(4335),
    [anon_sym_file] = ACTIONS(4273),
    [anon_sym_LT] = ACTIONS(4337),
    [anon_sym_GT] = ACTIONS(4337),
    [anon_sym_where] = ACTIONS(4273),
    [anon_sym_QMARK] = ACTIONS(4337),
    [anon_sym_notnull] = ACTIONS(4273),
    [anon_sym_unmanaged] = ACTIONS(4273),
    [anon_sym_BANG] = ACTIONS(4337),
    [anon_sym_PLUS_PLUS] = ACTIONS(4335),
    [anon_sym_DASH_DASH] = ACTIONS(4335),
    [anon_sym_PLUS] = ACTIONS(4337),
    [anon_sym_DASH] = ACTIONS(4337),
    [anon_sym_STAR] = ACTIONS(4335),
    [anon_sym_SLASH] = ACTIONS(4337),
    [anon_sym_PERCENT] = ACTIONS(4335),
    [anon_sym_CARET] = ACTIONS(4335),
    [anon_sym_PIPE] = ACTIONS(4337),
    [anon_sym_AMP] = ACTIONS(4337),
    [anon_sym_LT_LT] = ACTIONS(4335),
    [anon_sym_GT_GT] = ACTIONS(4337),
    [anon_sym_GT_GT_GT] = ACTIONS(4335),
    [anon_sym_EQ_EQ] = ACTIONS(4335),
    [anon_sym_BANG_EQ] = ACTIONS(4335),
    [anon_sym_GT_EQ] = ACTIONS(4335),
    [anon_sym_LT_EQ] = ACTIONS(4335),
    [anon_sym_DOT] = ACTIONS(4337),
    [anon_sym_scoped] = ACTIONS(4273),
    [anon_sym_var] = ACTIONS(4273),
    [anon_sym_yield] = ACTIONS(4273),
    [anon_sym_switch] = ACTIONS(4337),
    [anon_sym_when] = ACTIONS(4273),
    [sym_discard] = ACTIONS(4281),
    [anon_sym_DOT_DOT] = ACTIONS(4335),
    [anon_sym_and] = ACTIONS(4337),
    [anon_sym_or] = ACTIONS(4337),
    [anon_sym_AMP_AMP] = ACTIONS(4335),
    [anon_sym_PIPE_PIPE] = ACTIONS(4335),
    [anon_sym_QMARK_QMARK] = ACTIONS(4335),
    [anon_sym_from] = ACTIONS(4273),
    [anon_sym_into] = ACTIONS(4337),
    [anon_sym_join] = ACTIONS(4273),
    [anon_sym_on] = ACTIONS(4273),
    [anon_sym_equals] = ACTIONS(4337),
    [anon_sym_let] = ACTIONS(4273),
    [anon_sym_orderby] = ACTIONS(4273),
    [anon_sym_ascending] = ACTIONS(4273),
    [anon_sym_descending] = ACTIONS(4273),
    [anon_sym_group] = ACTIONS(4273),
    [anon_sym_by] = ACTIONS(4273),
    [anon_sym_select] = ACTIONS(4273),
    [anon_sym_as] = ACTIONS(4337),
    [anon_sym_is] = ACTIONS(4337),
    [anon_sym_DASH_GT] = ACTIONS(4335),
    [anon_sym_with] = ACTIONS(4337),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3485] = {
    [sym_preproc_region] = STATE(3485),
    [sym_preproc_endregion] = STATE(3485),
    [sym_preproc_line] = STATE(3485),
    [sym_preproc_pragma] = STATE(3485),
    [sym_preproc_nullable] = STATE(3485),
    [sym_preproc_error] = STATE(3485),
    [sym_preproc_define] = STATE(3485),
    [sym_preproc_undef] = STATE(3485),
    [sym__identifier_token] = ACTIONS(3533),
    [anon_sym_extern] = ACTIONS(3533),
    [anon_sym_alias] = ACTIONS(3533),
    [anon_sym_global] = ACTIONS(3533),
    [anon_sym_using] = ACTIONS(3533),
    [anon_sym_unsafe] = ACTIONS(3533),
    [anon_sym_static] = ACTIONS(3533),
    [anon_sym_LBRACK] = ACTIONS(3535),
    [anon_sym_LPAREN] = ACTIONS(3535),
    [anon_sym_event] = ACTIONS(3533),
    [anon_sym_namespace] = ACTIONS(3533),
    [anon_sym_class] = ACTIONS(3533),
    [anon_sym_ref] = ACTIONS(3533),
    [anon_sym_struct] = ACTIONS(3533),
    [anon_sym_enum] = ACTIONS(3533),
    [anon_sym_RBRACE] = ACTIONS(3535),
    [anon_sym_interface] = ACTIONS(3533),
    [anon_sym_delegate] = ACTIONS(3533),
    [anon_sym_record] = ACTIONS(3533),
    [anon_sym_abstract] = ACTIONS(3533),
    [anon_sym_async] = ACTIONS(3533),
    [anon_sym_const] = ACTIONS(3533),
    [anon_sym_file] = ACTIONS(3533),
    [anon_sym_fixed] = ACTIONS(3533),
    [anon_sym_internal] = ACTIONS(3533),
    [anon_sym_new] = ACTIONS(3533),
    [anon_sym_override] = ACTIONS(3533),
    [anon_sym_partial] = ACTIONS(3533),
    [anon_sym_private] = ACTIONS(3533),
    [anon_sym_protected] = ACTIONS(3533),
    [anon_sym_public] = ACTIONS(3533),
    [anon_sym_readonly] = ACTIONS(3533),
    [anon_sym_required] = ACTIONS(3533),
    [anon_sym_sealed] = ACTIONS(3533),
    [anon_sym_virtual] = ACTIONS(3533),
    [anon_sym_volatile] = ACTIONS(3533),
    [anon_sym_where] = ACTIONS(3533),
    [anon_sym_notnull] = ACTIONS(3533),
    [anon_sym_unmanaged] = ACTIONS(3533),
    [anon_sym_TILDE] = ACTIONS(3535),
    [anon_sym_implicit] = ACTIONS(3533),
    [anon_sym_explicit] = ACTIONS(3533),
    [anon_sym_scoped] = ACTIONS(3533),
    [anon_sym_var] = ACTIONS(3533),
    [sym_predefined_type] = ACTIONS(3533),
    [anon_sym_yield] = ACTIONS(3533),
    [anon_sym_when] = ACTIONS(3533),
    [anon_sym_from] = ACTIONS(3533),
    [anon_sym_into] = ACTIONS(3533),
    [anon_sym_join] = ACTIONS(3533),
    [anon_sym_on] = ACTIONS(3533),
    [anon_sym_equals] = ACTIONS(3533),
    [anon_sym_let] = ACTIONS(3533),
    [anon_sym_orderby] = ACTIONS(3533),
    [anon_sym_ascending] = ACTIONS(3533),
    [anon_sym_descending] = ACTIONS(3533),
    [anon_sym_group] = ACTIONS(3533),
    [anon_sym_by] = ACTIONS(3533),
    [anon_sym_select] = ACTIONS(3533),
    [aux_sym_preproc_if_token1] = ACTIONS(3535),
    [aux_sym_preproc_if_token3] = ACTIONS(3535),
    [aux_sym_preproc_else_token1] = ACTIONS(3535),
    [aux_sym_preproc_elif_token1] = ACTIONS(3535),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3486] = {
    [sym_preproc_region] = STATE(3486),
    [sym_preproc_endregion] = STATE(3486),
    [sym_preproc_line] = STATE(3486),
    [sym_preproc_pragma] = STATE(3486),
    [sym_preproc_nullable] = STATE(3486),
    [sym_preproc_error] = STATE(3486),
    [sym_preproc_define] = STATE(3486),
    [sym_preproc_undef] = STATE(3486),
    [sym__identifier_token] = ACTIONS(3529),
    [anon_sym_extern] = ACTIONS(3529),
    [anon_sym_alias] = ACTIONS(3529),
    [anon_sym_global] = ACTIONS(3529),
    [anon_sym_using] = ACTIONS(3529),
    [anon_sym_unsafe] = ACTIONS(3529),
    [anon_sym_static] = ACTIONS(3529),
    [anon_sym_LBRACK] = ACTIONS(3531),
    [anon_sym_LPAREN] = ACTIONS(3531),
    [anon_sym_event] = ACTIONS(3529),
    [anon_sym_namespace] = ACTIONS(3529),
    [anon_sym_class] = ACTIONS(3529),
    [anon_sym_ref] = ACTIONS(3529),
    [anon_sym_struct] = ACTIONS(3529),
    [anon_sym_enum] = ACTIONS(3529),
    [anon_sym_RBRACE] = ACTIONS(3531),
    [anon_sym_interface] = ACTIONS(3529),
    [anon_sym_delegate] = ACTIONS(3529),
    [anon_sym_record] = ACTIONS(3529),
    [anon_sym_abstract] = ACTIONS(3529),
    [anon_sym_async] = ACTIONS(3529),
    [anon_sym_const] = ACTIONS(3529),
    [anon_sym_file] = ACTIONS(3529),
    [anon_sym_fixed] = ACTIONS(3529),
    [anon_sym_internal] = ACTIONS(3529),
    [anon_sym_new] = ACTIONS(3529),
    [anon_sym_override] = ACTIONS(3529),
    [anon_sym_partial] = ACTIONS(3529),
    [anon_sym_private] = ACTIONS(3529),
    [anon_sym_protected] = ACTIONS(3529),
    [anon_sym_public] = ACTIONS(3529),
    [anon_sym_readonly] = ACTIONS(3529),
    [anon_sym_required] = ACTIONS(3529),
    [anon_sym_sealed] = ACTIONS(3529),
    [anon_sym_virtual] = ACTIONS(3529),
    [anon_sym_volatile] = ACTIONS(3529),
    [anon_sym_where] = ACTIONS(3529),
    [anon_sym_notnull] = ACTIONS(3529),
    [anon_sym_unmanaged] = ACTIONS(3529),
    [anon_sym_TILDE] = ACTIONS(3531),
    [anon_sym_implicit] = ACTIONS(3529),
    [anon_sym_explicit] = ACTIONS(3529),
    [anon_sym_scoped] = ACTIONS(3529),
    [anon_sym_var] = ACTIONS(3529),
    [sym_predefined_type] = ACTIONS(3529),
    [anon_sym_yield] = ACTIONS(3529),
    [anon_sym_when] = ACTIONS(3529),
    [anon_sym_from] = ACTIONS(3529),
    [anon_sym_into] = ACTIONS(3529),
    [anon_sym_join] = ACTIONS(3529),
    [anon_sym_on] = ACTIONS(3529),
    [anon_sym_equals] = ACTIONS(3529),
    [anon_sym_let] = ACTIONS(3529),
    [anon_sym_orderby] = ACTIONS(3529),
    [anon_sym_ascending] = ACTIONS(3529),
    [anon_sym_descending] = ACTIONS(3529),
    [anon_sym_group] = ACTIONS(3529),
    [anon_sym_by] = ACTIONS(3529),
    [anon_sym_select] = ACTIONS(3529),
    [aux_sym_preproc_if_token1] = ACTIONS(3531),
    [aux_sym_preproc_if_token3] = ACTIONS(3531),
    [aux_sym_preproc_else_token1] = ACTIONS(3531),
    [aux_sym_preproc_elif_token1] = ACTIONS(3531),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3487] = {
    [sym__variable_designation] = STATE(4025),
    [sym_parenthesized_variable_designation] = STATE(4015),
    [sym_identifier] = STATE(4020),
    [sym__reserved_identifier] = STATE(3908),
    [sym_preproc_region] = STATE(3487),
    [sym_preproc_endregion] = STATE(3487),
    [sym_preproc_line] = STATE(3487),
    [sym_preproc_pragma] = STATE(3487),
    [sym_preproc_nullable] = STATE(3487),
    [sym_preproc_error] = STATE(3487),
    [sym_preproc_define] = STATE(3487),
    [sym_preproc_undef] = STATE(3487),
    [sym__identifier_token] = ACTIONS(4271),
    [anon_sym_alias] = ACTIONS(4273),
    [anon_sym_global] = ACTIONS(4273),
    [anon_sym_LBRACK] = ACTIONS(4329),
    [anon_sym_LPAREN] = ACTIONS(4329),
    [anon_sym_file] = ACTIONS(4273),
    [anon_sym_LT] = ACTIONS(4331),
    [anon_sym_GT] = ACTIONS(4331),
    [anon_sym_where] = ACTIONS(4273),
    [anon_sym_QMARK] = ACTIONS(4331),
    [anon_sym_notnull] = ACTIONS(4273),
    [anon_sym_unmanaged] = ACTIONS(4273),
    [anon_sym_BANG] = ACTIONS(4331),
    [anon_sym_PLUS_PLUS] = ACTIONS(4329),
    [anon_sym_DASH_DASH] = ACTIONS(4329),
    [anon_sym_PLUS] = ACTIONS(4331),
    [anon_sym_DASH] = ACTIONS(4331),
    [anon_sym_STAR] = ACTIONS(4329),
    [anon_sym_SLASH] = ACTIONS(4331),
    [anon_sym_PERCENT] = ACTIONS(4329),
    [anon_sym_CARET] = ACTIONS(4329),
    [anon_sym_PIPE] = ACTIONS(4331),
    [anon_sym_AMP] = ACTIONS(4331),
    [anon_sym_LT_LT] = ACTIONS(4329),
    [anon_sym_GT_GT] = ACTIONS(4331),
    [anon_sym_GT_GT_GT] = ACTIONS(4329),
    [anon_sym_EQ_EQ] = ACTIONS(4329),
    [anon_sym_BANG_EQ] = ACTIONS(4329),
    [anon_sym_GT_EQ] = ACTIONS(4329),
    [anon_sym_LT_EQ] = ACTIONS(4329),
    [anon_sym_DOT] = ACTIONS(4331),
    [anon_sym_scoped] = ACTIONS(4273),
    [anon_sym_var] = ACTIONS(4273),
    [anon_sym_yield] = ACTIONS(4273),
    [anon_sym_switch] = ACTIONS(4331),
    [anon_sym_when] = ACTIONS(4273),
    [sym_discard] = ACTIONS(4281),
    [anon_sym_DOT_DOT] = ACTIONS(4329),
    [anon_sym_and] = ACTIONS(4331),
    [anon_sym_or] = ACTIONS(4331),
    [anon_sym_AMP_AMP] = ACTIONS(4329),
    [anon_sym_PIPE_PIPE] = ACTIONS(4329),
    [anon_sym_QMARK_QMARK] = ACTIONS(4329),
    [anon_sym_from] = ACTIONS(4273),
    [anon_sym_into] = ACTIONS(4331),
    [anon_sym_join] = ACTIONS(4273),
    [anon_sym_on] = ACTIONS(4273),
    [anon_sym_equals] = ACTIONS(4331),
    [anon_sym_let] = ACTIONS(4273),
    [anon_sym_orderby] = ACTIONS(4273),
    [anon_sym_ascending] = ACTIONS(4273),
    [anon_sym_descending] = ACTIONS(4273),
    [anon_sym_group] = ACTIONS(4273),
    [anon_sym_by] = ACTIONS(4273),
    [anon_sym_select] = ACTIONS(4273),
    [anon_sym_as] = ACTIONS(4331),
    [anon_sym_is] = ACTIONS(4331),
    [anon_sym_DASH_GT] = ACTIONS(4329),
    [anon_sym_with] = ACTIONS(4331),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3488] = {
    [sym_preproc_region] = STATE(3488),
    [sym_preproc_endregion] = STATE(3488),
    [sym_preproc_line] = STATE(3488),
    [sym_preproc_pragma] = STATE(3488),
    [sym_preproc_nullable] = STATE(3488),
    [sym_preproc_error] = STATE(3488),
    [sym_preproc_define] = STATE(3488),
    [sym_preproc_undef] = STATE(3488),
    [sym__identifier_token] = ACTIONS(3525),
    [anon_sym_extern] = ACTIONS(3525),
    [anon_sym_alias] = ACTIONS(3525),
    [anon_sym_global] = ACTIONS(3525),
    [anon_sym_using] = ACTIONS(3525),
    [anon_sym_unsafe] = ACTIONS(3525),
    [anon_sym_static] = ACTIONS(3525),
    [anon_sym_LBRACK] = ACTIONS(3527),
    [anon_sym_LPAREN] = ACTIONS(3527),
    [anon_sym_event] = ACTIONS(3525),
    [anon_sym_namespace] = ACTIONS(3525),
    [anon_sym_class] = ACTIONS(3525),
    [anon_sym_ref] = ACTIONS(3525),
    [anon_sym_struct] = ACTIONS(3525),
    [anon_sym_enum] = ACTIONS(3525),
    [anon_sym_RBRACE] = ACTIONS(3527),
    [anon_sym_interface] = ACTIONS(3525),
    [anon_sym_delegate] = ACTIONS(3525),
    [anon_sym_record] = ACTIONS(3525),
    [anon_sym_abstract] = ACTIONS(3525),
    [anon_sym_async] = ACTIONS(3525),
    [anon_sym_const] = ACTIONS(3525),
    [anon_sym_file] = ACTIONS(3525),
    [anon_sym_fixed] = ACTIONS(3525),
    [anon_sym_internal] = ACTIONS(3525),
    [anon_sym_new] = ACTIONS(3525),
    [anon_sym_override] = ACTIONS(3525),
    [anon_sym_partial] = ACTIONS(3525),
    [anon_sym_private] = ACTIONS(3525),
    [anon_sym_protected] = ACTIONS(3525),
    [anon_sym_public] = ACTIONS(3525),
    [anon_sym_readonly] = ACTIONS(3525),
    [anon_sym_required] = ACTIONS(3525),
    [anon_sym_sealed] = ACTIONS(3525),
    [anon_sym_virtual] = ACTIONS(3525),
    [anon_sym_volatile] = ACTIONS(3525),
    [anon_sym_where] = ACTIONS(3525),
    [anon_sym_notnull] = ACTIONS(3525),
    [anon_sym_unmanaged] = ACTIONS(3525),
    [anon_sym_TILDE] = ACTIONS(3527),
    [anon_sym_implicit] = ACTIONS(3525),
    [anon_sym_explicit] = ACTIONS(3525),
    [anon_sym_scoped] = ACTIONS(3525),
    [anon_sym_var] = ACTIONS(3525),
    [sym_predefined_type] = ACTIONS(3525),
    [anon_sym_yield] = ACTIONS(3525),
    [anon_sym_when] = ACTIONS(3525),
    [anon_sym_from] = ACTIONS(3525),
    [anon_sym_into] = ACTIONS(3525),
    [anon_sym_join] = ACTIONS(3525),
    [anon_sym_on] = ACTIONS(3525),
    [anon_sym_equals] = ACTIONS(3525),
    [anon_sym_let] = ACTIONS(3525),
    [anon_sym_orderby] = ACTIONS(3525),
    [anon_sym_ascending] = ACTIONS(3525),
    [anon_sym_descending] = ACTIONS(3525),
    [anon_sym_group] = ACTIONS(3525),
    [anon_sym_by] = ACTIONS(3525),
    [anon_sym_select] = ACTIONS(3525),
    [aux_sym_preproc_if_token1] = ACTIONS(3527),
    [aux_sym_preproc_if_token3] = ACTIONS(3527),
    [aux_sym_preproc_else_token1] = ACTIONS(3527),
    [aux_sym_preproc_elif_token1] = ACTIONS(3527),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3489] = {
    [sym_preproc_region] = STATE(3489),
    [sym_preproc_endregion] = STATE(3489),
    [sym_preproc_line] = STATE(3489),
    [sym_preproc_pragma] = STATE(3489),
    [sym_preproc_nullable] = STATE(3489),
    [sym_preproc_error] = STATE(3489),
    [sym_preproc_define] = STATE(3489),
    [sym_preproc_undef] = STATE(3489),
    [sym__identifier_token] = ACTIONS(3517),
    [anon_sym_extern] = ACTIONS(3517),
    [anon_sym_alias] = ACTIONS(3517),
    [anon_sym_global] = ACTIONS(3517),
    [anon_sym_using] = ACTIONS(3517),
    [anon_sym_unsafe] = ACTIONS(3517),
    [anon_sym_static] = ACTIONS(3517),
    [anon_sym_LBRACK] = ACTIONS(3519),
    [anon_sym_LPAREN] = ACTIONS(3519),
    [anon_sym_event] = ACTIONS(3517),
    [anon_sym_namespace] = ACTIONS(3517),
    [anon_sym_class] = ACTIONS(3517),
    [anon_sym_ref] = ACTIONS(3517),
    [anon_sym_struct] = ACTIONS(3517),
    [anon_sym_enum] = ACTIONS(3517),
    [anon_sym_RBRACE] = ACTIONS(3519),
    [anon_sym_interface] = ACTIONS(3517),
    [anon_sym_delegate] = ACTIONS(3517),
    [anon_sym_record] = ACTIONS(3517),
    [anon_sym_abstract] = ACTIONS(3517),
    [anon_sym_async] = ACTIONS(3517),
    [anon_sym_const] = ACTIONS(3517),
    [anon_sym_file] = ACTIONS(3517),
    [anon_sym_fixed] = ACTIONS(3517),
    [anon_sym_internal] = ACTIONS(3517),
    [anon_sym_new] = ACTIONS(3517),
    [anon_sym_override] = ACTIONS(3517),
    [anon_sym_partial] = ACTIONS(3517),
    [anon_sym_private] = ACTIONS(3517),
    [anon_sym_protected] = ACTIONS(3517),
    [anon_sym_public] = ACTIONS(3517),
    [anon_sym_readonly] = ACTIONS(3517),
    [anon_sym_required] = ACTIONS(3517),
    [anon_sym_sealed] = ACTIONS(3517),
    [anon_sym_virtual] = ACTIONS(3517),
    [anon_sym_volatile] = ACTIONS(3517),
    [anon_sym_where] = ACTIONS(3517),
    [anon_sym_notnull] = ACTIONS(3517),
    [anon_sym_unmanaged] = ACTIONS(3517),
    [anon_sym_TILDE] = ACTIONS(3519),
    [anon_sym_implicit] = ACTIONS(3517),
    [anon_sym_explicit] = ACTIONS(3517),
    [anon_sym_scoped] = ACTIONS(3517),
    [anon_sym_var] = ACTIONS(3517),
    [sym_predefined_type] = ACTIONS(3517),
    [anon_sym_yield] = ACTIONS(3517),
    [anon_sym_when] = ACTIONS(3517),
    [anon_sym_from] = ACTIONS(3517),
    [anon_sym_into] = ACTIONS(3517),
    [anon_sym_join] = ACTIONS(3517),
    [anon_sym_on] = ACTIONS(3517),
    [anon_sym_equals] = ACTIONS(3517),
    [anon_sym_let] = ACTIONS(3517),
    [anon_sym_orderby] = ACTIONS(3517),
    [anon_sym_ascending] = ACTIONS(3517),
    [anon_sym_descending] = ACTIONS(3517),
    [anon_sym_group] = ACTIONS(3517),
    [anon_sym_by] = ACTIONS(3517),
    [anon_sym_select] = ACTIONS(3517),
    [aux_sym_preproc_if_token1] = ACTIONS(3519),
    [aux_sym_preproc_if_token3] = ACTIONS(3519),
    [aux_sym_preproc_else_token1] = ACTIONS(3519),
    [aux_sym_preproc_elif_token1] = ACTIONS(3519),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3490] = {
    [sym_preproc_region] = STATE(3490),
    [sym_preproc_endregion] = STATE(3490),
    [sym_preproc_line] = STATE(3490),
    [sym_preproc_pragma] = STATE(3490),
    [sym_preproc_nullable] = STATE(3490),
    [sym_preproc_error] = STATE(3490),
    [sym_preproc_define] = STATE(3490),
    [sym_preproc_undef] = STATE(3490),
    [sym__identifier_token] = ACTIONS(3505),
    [anon_sym_extern] = ACTIONS(3505),
    [anon_sym_alias] = ACTIONS(3505),
    [anon_sym_global] = ACTIONS(3505),
    [anon_sym_using] = ACTIONS(3505),
    [anon_sym_unsafe] = ACTIONS(3505),
    [anon_sym_static] = ACTIONS(3505),
    [anon_sym_LBRACK] = ACTIONS(3507),
    [anon_sym_LPAREN] = ACTIONS(3507),
    [anon_sym_event] = ACTIONS(3505),
    [anon_sym_namespace] = ACTIONS(3505),
    [anon_sym_class] = ACTIONS(3505),
    [anon_sym_ref] = ACTIONS(3505),
    [anon_sym_struct] = ACTIONS(3505),
    [anon_sym_enum] = ACTIONS(3505),
    [anon_sym_RBRACE] = ACTIONS(3507),
    [anon_sym_interface] = ACTIONS(3505),
    [anon_sym_delegate] = ACTIONS(3505),
    [anon_sym_record] = ACTIONS(3505),
    [anon_sym_abstract] = ACTIONS(3505),
    [anon_sym_async] = ACTIONS(3505),
    [anon_sym_const] = ACTIONS(3505),
    [anon_sym_file] = ACTIONS(3505),
    [anon_sym_fixed] = ACTIONS(3505),
    [anon_sym_internal] = ACTIONS(3505),
    [anon_sym_new] = ACTIONS(3505),
    [anon_sym_override] = ACTIONS(3505),
    [anon_sym_partial] = ACTIONS(3505),
    [anon_sym_private] = ACTIONS(3505),
    [anon_sym_protected] = ACTIONS(3505),
    [anon_sym_public] = ACTIONS(3505),
    [anon_sym_readonly] = ACTIONS(3505),
    [anon_sym_required] = ACTIONS(3505),
    [anon_sym_sealed] = ACTIONS(3505),
    [anon_sym_virtual] = ACTIONS(3505),
    [anon_sym_volatile] = ACTIONS(3505),
    [anon_sym_where] = ACTIONS(3505),
    [anon_sym_notnull] = ACTIONS(3505),
    [anon_sym_unmanaged] = ACTIONS(3505),
    [anon_sym_TILDE] = ACTIONS(3507),
    [anon_sym_implicit] = ACTIONS(3505),
    [anon_sym_explicit] = ACTIONS(3505),
    [anon_sym_scoped] = ACTIONS(3505),
    [anon_sym_var] = ACTIONS(3505),
    [sym_predefined_type] = ACTIONS(3505),
    [anon_sym_yield] = ACTIONS(3505),
    [anon_sym_when] = ACTIONS(3505),
    [anon_sym_from] = ACTIONS(3505),
    [anon_sym_into] = ACTIONS(3505),
    [anon_sym_join] = ACTIONS(3505),
    [anon_sym_on] = ACTIONS(3505),
    [anon_sym_equals] = ACTIONS(3505),
    [anon_sym_let] = ACTIONS(3505),
    [anon_sym_orderby] = ACTIONS(3505),
    [anon_sym_ascending] = ACTIONS(3505),
    [anon_sym_descending] = ACTIONS(3505),
    [anon_sym_group] = ACTIONS(3505),
    [anon_sym_by] = ACTIONS(3505),
    [anon_sym_select] = ACTIONS(3505),
    [aux_sym_preproc_if_token1] = ACTIONS(3507),
    [aux_sym_preproc_if_token3] = ACTIONS(3507),
    [aux_sym_preproc_else_token1] = ACTIONS(3507),
    [aux_sym_preproc_elif_token1] = ACTIONS(3507),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3491] = {
    [sym_preproc_region] = STATE(3491),
    [sym_preproc_endregion] = STATE(3491),
    [sym_preproc_line] = STATE(3491),
    [sym_preproc_pragma] = STATE(3491),
    [sym_preproc_nullable] = STATE(3491),
    [sym_preproc_error] = STATE(3491),
    [sym_preproc_define] = STATE(3491),
    [sym_preproc_undef] = STATE(3491),
    [sym__identifier_token] = ACTIONS(3493),
    [anon_sym_extern] = ACTIONS(3493),
    [anon_sym_alias] = ACTIONS(3493),
    [anon_sym_global] = ACTIONS(3493),
    [anon_sym_using] = ACTIONS(3493),
    [anon_sym_unsafe] = ACTIONS(3493),
    [anon_sym_static] = ACTIONS(3493),
    [anon_sym_LBRACK] = ACTIONS(3495),
    [anon_sym_LPAREN] = ACTIONS(3495),
    [anon_sym_event] = ACTIONS(3493),
    [anon_sym_namespace] = ACTIONS(3493),
    [anon_sym_class] = ACTIONS(3493),
    [anon_sym_ref] = ACTIONS(3493),
    [anon_sym_struct] = ACTIONS(3493),
    [anon_sym_enum] = ACTIONS(3493),
    [anon_sym_RBRACE] = ACTIONS(3495),
    [anon_sym_interface] = ACTIONS(3493),
    [anon_sym_delegate] = ACTIONS(3493),
    [anon_sym_record] = ACTIONS(3493),
    [anon_sym_abstract] = ACTIONS(3493),
    [anon_sym_async] = ACTIONS(3493),
    [anon_sym_const] = ACTIONS(3493),
    [anon_sym_file] = ACTIONS(3493),
    [anon_sym_fixed] = ACTIONS(3493),
    [anon_sym_internal] = ACTIONS(3493),
    [anon_sym_new] = ACTIONS(3493),
    [anon_sym_override] = ACTIONS(3493),
    [anon_sym_partial] = ACTIONS(3493),
    [anon_sym_private] = ACTIONS(3493),
    [anon_sym_protected] = ACTIONS(3493),
    [anon_sym_public] = ACTIONS(3493),
    [anon_sym_readonly] = ACTIONS(3493),
    [anon_sym_required] = ACTIONS(3493),
    [anon_sym_sealed] = ACTIONS(3493),
    [anon_sym_virtual] = ACTIONS(3493),
    [anon_sym_volatile] = ACTIONS(3493),
    [anon_sym_where] = ACTIONS(3493),
    [anon_sym_notnull] = ACTIONS(3493),
    [anon_sym_unmanaged] = ACTIONS(3493),
    [anon_sym_TILDE] = ACTIONS(3495),
    [anon_sym_implicit] = ACTIONS(3493),
    [anon_sym_explicit] = ACTIONS(3493),
    [anon_sym_scoped] = ACTIONS(3493),
    [anon_sym_var] = ACTIONS(3493),
    [sym_predefined_type] = ACTIONS(3493),
    [anon_sym_yield] = ACTIONS(3493),
    [anon_sym_when] = ACTIONS(3493),
    [anon_sym_from] = ACTIONS(3493),
    [anon_sym_into] = ACTIONS(3493),
    [anon_sym_join] = ACTIONS(3493),
    [anon_sym_on] = ACTIONS(3493),
    [anon_sym_equals] = ACTIONS(3493),
    [anon_sym_let] = ACTIONS(3493),
    [anon_sym_orderby] = ACTIONS(3493),
    [anon_sym_ascending] = ACTIONS(3493),
    [anon_sym_descending] = ACTIONS(3493),
    [anon_sym_group] = ACTIONS(3493),
    [anon_sym_by] = ACTIONS(3493),
    [anon_sym_select] = ACTIONS(3493),
    [aux_sym_preproc_if_token1] = ACTIONS(3495),
    [aux_sym_preproc_if_token3] = ACTIONS(3495),
    [aux_sym_preproc_else_token1] = ACTIONS(3495),
    [aux_sym_preproc_elif_token1] = ACTIONS(3495),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3492] = {
    [sym_preproc_region] = STATE(3492),
    [sym_preproc_endregion] = STATE(3492),
    [sym_preproc_line] = STATE(3492),
    [sym_preproc_pragma] = STATE(3492),
    [sym_preproc_nullable] = STATE(3492),
    [sym_preproc_error] = STATE(3492),
    [sym_preproc_define] = STATE(3492),
    [sym_preproc_undef] = STATE(3492),
    [sym__identifier_token] = ACTIONS(3513),
    [anon_sym_extern] = ACTIONS(3513),
    [anon_sym_alias] = ACTIONS(3513),
    [anon_sym_global] = ACTIONS(3513),
    [anon_sym_using] = ACTIONS(3513),
    [anon_sym_unsafe] = ACTIONS(3513),
    [anon_sym_static] = ACTIONS(3513),
    [anon_sym_LBRACK] = ACTIONS(3515),
    [anon_sym_LPAREN] = ACTIONS(3515),
    [anon_sym_event] = ACTIONS(3513),
    [anon_sym_namespace] = ACTIONS(3513),
    [anon_sym_class] = ACTIONS(3513),
    [anon_sym_ref] = ACTIONS(3513),
    [anon_sym_struct] = ACTIONS(3513),
    [anon_sym_enum] = ACTIONS(3513),
    [anon_sym_RBRACE] = ACTIONS(3515),
    [anon_sym_interface] = ACTIONS(3513),
    [anon_sym_delegate] = ACTIONS(3513),
    [anon_sym_record] = ACTIONS(3513),
    [anon_sym_abstract] = ACTIONS(3513),
    [anon_sym_async] = ACTIONS(3513),
    [anon_sym_const] = ACTIONS(3513),
    [anon_sym_file] = ACTIONS(3513),
    [anon_sym_fixed] = ACTIONS(3513),
    [anon_sym_internal] = ACTIONS(3513),
    [anon_sym_new] = ACTIONS(3513),
    [anon_sym_override] = ACTIONS(3513),
    [anon_sym_partial] = ACTIONS(3513),
    [anon_sym_private] = ACTIONS(3513),
    [anon_sym_protected] = ACTIONS(3513),
    [anon_sym_public] = ACTIONS(3513),
    [anon_sym_readonly] = ACTIONS(3513),
    [anon_sym_required] = ACTIONS(3513),
    [anon_sym_sealed] = ACTIONS(3513),
    [anon_sym_virtual] = ACTIONS(3513),
    [anon_sym_volatile] = ACTIONS(3513),
    [anon_sym_where] = ACTIONS(3513),
    [anon_sym_notnull] = ACTIONS(3513),
    [anon_sym_unmanaged] = ACTIONS(3513),
    [anon_sym_TILDE] = ACTIONS(3515),
    [anon_sym_implicit] = ACTIONS(3513),
    [anon_sym_explicit] = ACTIONS(3513),
    [anon_sym_scoped] = ACTIONS(3513),
    [anon_sym_var] = ACTIONS(3513),
    [sym_predefined_type] = ACTIONS(3513),
    [anon_sym_yield] = ACTIONS(3513),
    [anon_sym_when] = ACTIONS(3513),
    [anon_sym_from] = ACTIONS(3513),
    [anon_sym_into] = ACTIONS(3513),
    [anon_sym_join] = ACTIONS(3513),
    [anon_sym_on] = ACTIONS(3513),
    [anon_sym_equals] = ACTIONS(3513),
    [anon_sym_let] = ACTIONS(3513),
    [anon_sym_orderby] = ACTIONS(3513),
    [anon_sym_ascending] = ACTIONS(3513),
    [anon_sym_descending] = ACTIONS(3513),
    [anon_sym_group] = ACTIONS(3513),
    [anon_sym_by] = ACTIONS(3513),
    [anon_sym_select] = ACTIONS(3513),
    [aux_sym_preproc_if_token1] = ACTIONS(3515),
    [aux_sym_preproc_if_token3] = ACTIONS(3515),
    [aux_sym_preproc_else_token1] = ACTIONS(3515),
    [aux_sym_preproc_elif_token1] = ACTIONS(3515),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3493] = {
    [sym_preproc_region] = STATE(3493),
    [sym_preproc_endregion] = STATE(3493),
    [sym_preproc_line] = STATE(3493),
    [sym_preproc_pragma] = STATE(3493),
    [sym_preproc_nullable] = STATE(3493),
    [sym_preproc_error] = STATE(3493),
    [sym_preproc_define] = STATE(3493),
    [sym_preproc_undef] = STATE(3493),
    [anon_sym_SEMI] = ACTIONS(4615),
    [anon_sym_EQ] = ACTIONS(4617),
    [anon_sym_LBRACK] = ACTIONS(4615),
    [anon_sym_COLON] = ACTIONS(4615),
    [anon_sym_COMMA] = ACTIONS(4615),
    [anon_sym_RBRACK] = ACTIONS(4615),
    [anon_sym_LPAREN] = ACTIONS(4615),
    [anon_sym_RPAREN] = ACTIONS(4615),
    [anon_sym_RBRACE] = ACTIONS(4615),
    [anon_sym_LT] = ACTIONS(4617),
    [anon_sym_GT] = ACTIONS(4617),
    [anon_sym_in] = ACTIONS(4615),
    [anon_sym_QMARK] = ACTIONS(4617),
    [anon_sym_BANG] = ACTIONS(4617),
    [anon_sym_PLUS_PLUS] = ACTIONS(4615),
    [anon_sym_DASH_DASH] = ACTIONS(4615),
    [anon_sym_PLUS] = ACTIONS(4617),
    [anon_sym_DASH] = ACTIONS(4617),
    [anon_sym_STAR] = ACTIONS(4617),
    [anon_sym_SLASH] = ACTIONS(4617),
    [anon_sym_PERCENT] = ACTIONS(4617),
    [anon_sym_CARET] = ACTIONS(4617),
    [anon_sym_PIPE] = ACTIONS(4617),
    [anon_sym_AMP] = ACTIONS(4617),
    [anon_sym_LT_LT] = ACTIONS(4617),
    [anon_sym_GT_GT] = ACTIONS(4617),
    [anon_sym_GT_GT_GT] = ACTIONS(4617),
    [anon_sym_EQ_EQ] = ACTIONS(4615),
    [anon_sym_BANG_EQ] = ACTIONS(4615),
    [anon_sym_GT_EQ] = ACTIONS(4615),
    [anon_sym_LT_EQ] = ACTIONS(4615),
    [anon_sym_DOT] = ACTIONS(4617),
    [anon_sym_EQ_GT] = ACTIONS(4615),
    [anon_sym_switch] = ACTIONS(4615),
    [anon_sym_when] = ACTIONS(4615),
    [anon_sym_DOT_DOT] = ACTIONS(4615),
    [anon_sym_and] = ACTIONS(4615),
    [anon_sym_or] = ACTIONS(4615),
    [anon_sym_PLUS_EQ] = ACTIONS(4615),
    [anon_sym_DASH_EQ] = ACTIONS(4615),
    [anon_sym_STAR_EQ] = ACTIONS(4615),
    [anon_sym_SLASH_EQ] = ACTIONS(4615),
    [anon_sym_PERCENT_EQ] = ACTIONS(4615),
    [anon_sym_AMP_EQ] = ACTIONS(4615),
    [anon_sym_CARET_EQ] = ACTIONS(4615),
    [anon_sym_PIPE_EQ] = ACTIONS(4615),
    [anon_sym_LT_LT_EQ] = ACTIONS(4615),
    [anon_sym_GT_GT_EQ] = ACTIONS(4615),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4615),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4615),
    [anon_sym_AMP_AMP] = ACTIONS(4615),
    [anon_sym_PIPE_PIPE] = ACTIONS(4615),
    [anon_sym_QMARK_QMARK] = ACTIONS(4617),
    [anon_sym_on] = ACTIONS(4615),
    [anon_sym_equals] = ACTIONS(4615),
    [anon_sym_by] = ACTIONS(4615),
    [anon_sym_as] = ACTIONS(4615),
    [anon_sym_is] = ACTIONS(4615),
    [anon_sym_DASH_GT] = ACTIONS(4615),
    [anon_sym_with] = ACTIONS(4615),
    [aux_sym_preproc_if_token3] = ACTIONS(4615),
    [aux_sym_preproc_else_token1] = ACTIONS(4615),
    [aux_sym_preproc_elif_token1] = ACTIONS(4615),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3494] = {
    [sym_preproc_region] = STATE(3494),
    [sym_preproc_endregion] = STATE(3494),
    [sym_preproc_line] = STATE(3494),
    [sym_preproc_pragma] = STATE(3494),
    [sym_preproc_nullable] = STATE(3494),
    [sym_preproc_error] = STATE(3494),
    [sym_preproc_define] = STATE(3494),
    [sym_preproc_undef] = STATE(3494),
    [sym__identifier_token] = ACTIONS(3860),
    [anon_sym_extern] = ACTIONS(3860),
    [anon_sym_alias] = ACTIONS(3860),
    [anon_sym_global] = ACTIONS(3860),
    [anon_sym_using] = ACTIONS(3860),
    [anon_sym_unsafe] = ACTIONS(3860),
    [anon_sym_static] = ACTIONS(3860),
    [anon_sym_LBRACK] = ACTIONS(3862),
    [anon_sym_LPAREN] = ACTIONS(3862),
    [anon_sym_event] = ACTIONS(3860),
    [anon_sym_namespace] = ACTIONS(3860),
    [anon_sym_class] = ACTIONS(3860),
    [anon_sym_ref] = ACTIONS(3860),
    [anon_sym_struct] = ACTIONS(3860),
    [anon_sym_enum] = ACTIONS(3860),
    [anon_sym_RBRACE] = ACTIONS(3862),
    [anon_sym_interface] = ACTIONS(3860),
    [anon_sym_delegate] = ACTIONS(3860),
    [anon_sym_record] = ACTIONS(3860),
    [anon_sym_abstract] = ACTIONS(3860),
    [anon_sym_async] = ACTIONS(3860),
    [anon_sym_const] = ACTIONS(3860),
    [anon_sym_file] = ACTIONS(3860),
    [anon_sym_fixed] = ACTIONS(3860),
    [anon_sym_internal] = ACTIONS(3860),
    [anon_sym_new] = ACTIONS(3860),
    [anon_sym_override] = ACTIONS(3860),
    [anon_sym_partial] = ACTIONS(3860),
    [anon_sym_private] = ACTIONS(3860),
    [anon_sym_protected] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3860),
    [anon_sym_readonly] = ACTIONS(3860),
    [anon_sym_required] = ACTIONS(3860),
    [anon_sym_sealed] = ACTIONS(3860),
    [anon_sym_virtual] = ACTIONS(3860),
    [anon_sym_volatile] = ACTIONS(3860),
    [anon_sym_where] = ACTIONS(3860),
    [anon_sym_notnull] = ACTIONS(3860),
    [anon_sym_unmanaged] = ACTIONS(3860),
    [anon_sym_TILDE] = ACTIONS(3862),
    [anon_sym_implicit] = ACTIONS(3860),
    [anon_sym_explicit] = ACTIONS(3860),
    [anon_sym_scoped] = ACTIONS(3860),
    [anon_sym_var] = ACTIONS(3860),
    [sym_predefined_type] = ACTIONS(3860),
    [anon_sym_yield] = ACTIONS(3860),
    [anon_sym_when] = ACTIONS(3860),
    [anon_sym_from] = ACTIONS(3860),
    [anon_sym_into] = ACTIONS(3860),
    [anon_sym_join] = ACTIONS(3860),
    [anon_sym_on] = ACTIONS(3860),
    [anon_sym_equals] = ACTIONS(3860),
    [anon_sym_let] = ACTIONS(3860),
    [anon_sym_orderby] = ACTIONS(3860),
    [anon_sym_ascending] = ACTIONS(3860),
    [anon_sym_descending] = ACTIONS(3860),
    [anon_sym_group] = ACTIONS(3860),
    [anon_sym_by] = ACTIONS(3860),
    [anon_sym_select] = ACTIONS(3860),
    [aux_sym_preproc_if_token1] = ACTIONS(3862),
    [aux_sym_preproc_if_token3] = ACTIONS(3862),
    [aux_sym_preproc_else_token1] = ACTIONS(3862),
    [aux_sym_preproc_elif_token1] = ACTIONS(3862),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3495] = {
    [sym_preproc_region] = STATE(3495),
    [sym_preproc_endregion] = STATE(3495),
    [sym_preproc_line] = STATE(3495),
    [sym_preproc_pragma] = STATE(3495),
    [sym_preproc_nullable] = STATE(3495),
    [sym_preproc_error] = STATE(3495),
    [sym_preproc_define] = STATE(3495),
    [sym_preproc_undef] = STATE(3495),
    [sym__identifier_token] = ACTIONS(3453),
    [anon_sym_extern] = ACTIONS(3453),
    [anon_sym_alias] = ACTIONS(3453),
    [anon_sym_global] = ACTIONS(3453),
    [anon_sym_using] = ACTIONS(3453),
    [anon_sym_unsafe] = ACTIONS(3453),
    [anon_sym_static] = ACTIONS(3453),
    [anon_sym_LBRACK] = ACTIONS(3455),
    [anon_sym_LPAREN] = ACTIONS(3455),
    [anon_sym_event] = ACTIONS(3453),
    [anon_sym_namespace] = ACTIONS(3453),
    [anon_sym_class] = ACTIONS(3453),
    [anon_sym_ref] = ACTIONS(3453),
    [anon_sym_struct] = ACTIONS(3453),
    [anon_sym_enum] = ACTIONS(3453),
    [anon_sym_RBRACE] = ACTIONS(3455),
    [anon_sym_interface] = ACTIONS(3453),
    [anon_sym_delegate] = ACTIONS(3453),
    [anon_sym_record] = ACTIONS(3453),
    [anon_sym_abstract] = ACTIONS(3453),
    [anon_sym_async] = ACTIONS(3453),
    [anon_sym_const] = ACTIONS(3453),
    [anon_sym_file] = ACTIONS(3453),
    [anon_sym_fixed] = ACTIONS(3453),
    [anon_sym_internal] = ACTIONS(3453),
    [anon_sym_new] = ACTIONS(3453),
    [anon_sym_override] = ACTIONS(3453),
    [anon_sym_partial] = ACTIONS(3453),
    [anon_sym_private] = ACTIONS(3453),
    [anon_sym_protected] = ACTIONS(3453),
    [anon_sym_public] = ACTIONS(3453),
    [anon_sym_readonly] = ACTIONS(3453),
    [anon_sym_required] = ACTIONS(3453),
    [anon_sym_sealed] = ACTIONS(3453),
    [anon_sym_virtual] = ACTIONS(3453),
    [anon_sym_volatile] = ACTIONS(3453),
    [anon_sym_where] = ACTIONS(3453),
    [anon_sym_notnull] = ACTIONS(3453),
    [anon_sym_unmanaged] = ACTIONS(3453),
    [anon_sym_TILDE] = ACTIONS(3455),
    [anon_sym_implicit] = ACTIONS(3453),
    [anon_sym_explicit] = ACTIONS(3453),
    [anon_sym_scoped] = ACTIONS(3453),
    [anon_sym_var] = ACTIONS(3453),
    [sym_predefined_type] = ACTIONS(3453),
    [anon_sym_yield] = ACTIONS(3453),
    [anon_sym_when] = ACTIONS(3453),
    [anon_sym_from] = ACTIONS(3453),
    [anon_sym_into] = ACTIONS(3453),
    [anon_sym_join] = ACTIONS(3453),
    [anon_sym_on] = ACTIONS(3453),
    [anon_sym_equals] = ACTIONS(3453),
    [anon_sym_let] = ACTIONS(3453),
    [anon_sym_orderby] = ACTIONS(3453),
    [anon_sym_ascending] = ACTIONS(3453),
    [anon_sym_descending] = ACTIONS(3453),
    [anon_sym_group] = ACTIONS(3453),
    [anon_sym_by] = ACTIONS(3453),
    [anon_sym_select] = ACTIONS(3453),
    [aux_sym_preproc_if_token1] = ACTIONS(3455),
    [aux_sym_preproc_if_token3] = ACTIONS(3455),
    [aux_sym_preproc_else_token1] = ACTIONS(3455),
    [aux_sym_preproc_elif_token1] = ACTIONS(3455),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3496] = {
    [sym_preproc_region] = STATE(3496),
    [sym_preproc_endregion] = STATE(3496),
    [sym_preproc_line] = STATE(3496),
    [sym_preproc_pragma] = STATE(3496),
    [sym_preproc_nullable] = STATE(3496),
    [sym_preproc_error] = STATE(3496),
    [sym_preproc_define] = STATE(3496),
    [sym_preproc_undef] = STATE(3496),
    [anon_sym_SEMI] = ACTIONS(4604),
    [anon_sym_EQ] = ACTIONS(4606),
    [anon_sym_LBRACK] = ACTIONS(4604),
    [anon_sym_COLON] = ACTIONS(4604),
    [anon_sym_COMMA] = ACTIONS(4604),
    [anon_sym_RBRACK] = ACTIONS(4604),
    [anon_sym_LPAREN] = ACTIONS(4604),
    [anon_sym_RPAREN] = ACTIONS(4604),
    [anon_sym_RBRACE] = ACTIONS(4604),
    [anon_sym_LT] = ACTIONS(4606),
    [anon_sym_GT] = ACTIONS(4606),
    [anon_sym_in] = ACTIONS(4604),
    [anon_sym_QMARK] = ACTIONS(4606),
    [anon_sym_BANG] = ACTIONS(4606),
    [anon_sym_PLUS_PLUS] = ACTIONS(4604),
    [anon_sym_DASH_DASH] = ACTIONS(4604),
    [anon_sym_PLUS] = ACTIONS(4606),
    [anon_sym_DASH] = ACTIONS(4606),
    [anon_sym_STAR] = ACTIONS(4606),
    [anon_sym_SLASH] = ACTIONS(4606),
    [anon_sym_PERCENT] = ACTIONS(4606),
    [anon_sym_CARET] = ACTIONS(4606),
    [anon_sym_PIPE] = ACTIONS(4606),
    [anon_sym_AMP] = ACTIONS(4606),
    [anon_sym_LT_LT] = ACTIONS(4606),
    [anon_sym_GT_GT] = ACTIONS(4606),
    [anon_sym_GT_GT_GT] = ACTIONS(4606),
    [anon_sym_EQ_EQ] = ACTIONS(4604),
    [anon_sym_BANG_EQ] = ACTIONS(4604),
    [anon_sym_GT_EQ] = ACTIONS(4604),
    [anon_sym_LT_EQ] = ACTIONS(4604),
    [anon_sym_DOT] = ACTIONS(4606),
    [anon_sym_EQ_GT] = ACTIONS(4604),
    [anon_sym_switch] = ACTIONS(4604),
    [anon_sym_when] = ACTIONS(4604),
    [anon_sym_DOT_DOT] = ACTIONS(4604),
    [anon_sym_and] = ACTIONS(4604),
    [anon_sym_or] = ACTIONS(4604),
    [anon_sym_PLUS_EQ] = ACTIONS(4604),
    [anon_sym_DASH_EQ] = ACTIONS(4604),
    [anon_sym_STAR_EQ] = ACTIONS(4604),
    [anon_sym_SLASH_EQ] = ACTIONS(4604),
    [anon_sym_PERCENT_EQ] = ACTIONS(4604),
    [anon_sym_AMP_EQ] = ACTIONS(4604),
    [anon_sym_CARET_EQ] = ACTIONS(4604),
    [anon_sym_PIPE_EQ] = ACTIONS(4604),
    [anon_sym_LT_LT_EQ] = ACTIONS(4604),
    [anon_sym_GT_GT_EQ] = ACTIONS(4604),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4604),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4604),
    [anon_sym_AMP_AMP] = ACTIONS(4604),
    [anon_sym_PIPE_PIPE] = ACTIONS(4604),
    [anon_sym_QMARK_QMARK] = ACTIONS(4606),
    [anon_sym_on] = ACTIONS(4604),
    [anon_sym_equals] = ACTIONS(4604),
    [anon_sym_by] = ACTIONS(4604),
    [anon_sym_as] = ACTIONS(4604),
    [anon_sym_is] = ACTIONS(4604),
    [anon_sym_DASH_GT] = ACTIONS(4604),
    [anon_sym_with] = ACTIONS(4604),
    [aux_sym_preproc_if_token3] = ACTIONS(4604),
    [aux_sym_preproc_else_token1] = ACTIONS(4604),
    [aux_sym_preproc_elif_token1] = ACTIONS(4604),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3497] = {
    [sym_preproc_region] = STATE(3497),
    [sym_preproc_endregion] = STATE(3497),
    [sym_preproc_line] = STATE(3497),
    [sym_preproc_pragma] = STATE(3497),
    [sym_preproc_nullable] = STATE(3497),
    [sym_preproc_error] = STATE(3497),
    [sym_preproc_define] = STATE(3497),
    [sym_preproc_undef] = STATE(3497),
    [sym__identifier_token] = ACTIONS(3509),
    [anon_sym_extern] = ACTIONS(3509),
    [anon_sym_alias] = ACTIONS(3509),
    [anon_sym_global] = ACTIONS(3509),
    [anon_sym_using] = ACTIONS(3509),
    [anon_sym_unsafe] = ACTIONS(3509),
    [anon_sym_static] = ACTIONS(3509),
    [anon_sym_LBRACK] = ACTIONS(3511),
    [anon_sym_LPAREN] = ACTIONS(3511),
    [anon_sym_event] = ACTIONS(3509),
    [anon_sym_namespace] = ACTIONS(3509),
    [anon_sym_class] = ACTIONS(3509),
    [anon_sym_ref] = ACTIONS(3509),
    [anon_sym_struct] = ACTIONS(3509),
    [anon_sym_enum] = ACTIONS(3509),
    [anon_sym_RBRACE] = ACTIONS(3511),
    [anon_sym_interface] = ACTIONS(3509),
    [anon_sym_delegate] = ACTIONS(3509),
    [anon_sym_record] = ACTIONS(3509),
    [anon_sym_abstract] = ACTIONS(3509),
    [anon_sym_async] = ACTIONS(3509),
    [anon_sym_const] = ACTIONS(3509),
    [anon_sym_file] = ACTIONS(3509),
    [anon_sym_fixed] = ACTIONS(3509),
    [anon_sym_internal] = ACTIONS(3509),
    [anon_sym_new] = ACTIONS(3509),
    [anon_sym_override] = ACTIONS(3509),
    [anon_sym_partial] = ACTIONS(3509),
    [anon_sym_private] = ACTIONS(3509),
    [anon_sym_protected] = ACTIONS(3509),
    [anon_sym_public] = ACTIONS(3509),
    [anon_sym_readonly] = ACTIONS(3509),
    [anon_sym_required] = ACTIONS(3509),
    [anon_sym_sealed] = ACTIONS(3509),
    [anon_sym_virtual] = ACTIONS(3509),
    [anon_sym_volatile] = ACTIONS(3509),
    [anon_sym_where] = ACTIONS(3509),
    [anon_sym_notnull] = ACTIONS(3509),
    [anon_sym_unmanaged] = ACTIONS(3509),
    [anon_sym_TILDE] = ACTIONS(3511),
    [anon_sym_implicit] = ACTIONS(3509),
    [anon_sym_explicit] = ACTIONS(3509),
    [anon_sym_scoped] = ACTIONS(3509),
    [anon_sym_var] = ACTIONS(3509),
    [sym_predefined_type] = ACTIONS(3509),
    [anon_sym_yield] = ACTIONS(3509),
    [anon_sym_when] = ACTIONS(3509),
    [anon_sym_from] = ACTIONS(3509),
    [anon_sym_into] = ACTIONS(3509),
    [anon_sym_join] = ACTIONS(3509),
    [anon_sym_on] = ACTIONS(3509),
    [anon_sym_equals] = ACTIONS(3509),
    [anon_sym_let] = ACTIONS(3509),
    [anon_sym_orderby] = ACTIONS(3509),
    [anon_sym_ascending] = ACTIONS(3509),
    [anon_sym_descending] = ACTIONS(3509),
    [anon_sym_group] = ACTIONS(3509),
    [anon_sym_by] = ACTIONS(3509),
    [anon_sym_select] = ACTIONS(3509),
    [aux_sym_preproc_if_token1] = ACTIONS(3511),
    [aux_sym_preproc_if_token3] = ACTIONS(3511),
    [aux_sym_preproc_else_token1] = ACTIONS(3511),
    [aux_sym_preproc_elif_token1] = ACTIONS(3511),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3498] = {
    [sym_preproc_region] = STATE(3498),
    [sym_preproc_endregion] = STATE(3498),
    [sym_preproc_line] = STATE(3498),
    [sym_preproc_pragma] = STATE(3498),
    [sym_preproc_nullable] = STATE(3498),
    [sym_preproc_error] = STATE(3498),
    [sym_preproc_define] = STATE(3498),
    [sym_preproc_undef] = STATE(3498),
    [sym__identifier_token] = ACTIONS(3449),
    [anon_sym_extern] = ACTIONS(3449),
    [anon_sym_alias] = ACTIONS(3449),
    [anon_sym_global] = ACTIONS(3449),
    [anon_sym_using] = ACTIONS(3449),
    [anon_sym_unsafe] = ACTIONS(3449),
    [anon_sym_static] = ACTIONS(3449),
    [anon_sym_LBRACK] = ACTIONS(3451),
    [anon_sym_LPAREN] = ACTIONS(3451),
    [anon_sym_event] = ACTIONS(3449),
    [anon_sym_namespace] = ACTIONS(3449),
    [anon_sym_class] = ACTIONS(3449),
    [anon_sym_ref] = ACTIONS(3449),
    [anon_sym_struct] = ACTIONS(3449),
    [anon_sym_enum] = ACTIONS(3449),
    [anon_sym_RBRACE] = ACTIONS(3451),
    [anon_sym_interface] = ACTIONS(3449),
    [anon_sym_delegate] = ACTIONS(3449),
    [anon_sym_record] = ACTIONS(3449),
    [anon_sym_abstract] = ACTIONS(3449),
    [anon_sym_async] = ACTIONS(3449),
    [anon_sym_const] = ACTIONS(3449),
    [anon_sym_file] = ACTIONS(3449),
    [anon_sym_fixed] = ACTIONS(3449),
    [anon_sym_internal] = ACTIONS(3449),
    [anon_sym_new] = ACTIONS(3449),
    [anon_sym_override] = ACTIONS(3449),
    [anon_sym_partial] = ACTIONS(3449),
    [anon_sym_private] = ACTIONS(3449),
    [anon_sym_protected] = ACTIONS(3449),
    [anon_sym_public] = ACTIONS(3449),
    [anon_sym_readonly] = ACTIONS(3449),
    [anon_sym_required] = ACTIONS(3449),
    [anon_sym_sealed] = ACTIONS(3449),
    [anon_sym_virtual] = ACTIONS(3449),
    [anon_sym_volatile] = ACTIONS(3449),
    [anon_sym_where] = ACTIONS(3449),
    [anon_sym_notnull] = ACTIONS(3449),
    [anon_sym_unmanaged] = ACTIONS(3449),
    [anon_sym_TILDE] = ACTIONS(3451),
    [anon_sym_implicit] = ACTIONS(3449),
    [anon_sym_explicit] = ACTIONS(3449),
    [anon_sym_scoped] = ACTIONS(3449),
    [anon_sym_var] = ACTIONS(3449),
    [sym_predefined_type] = ACTIONS(3449),
    [anon_sym_yield] = ACTIONS(3449),
    [anon_sym_when] = ACTIONS(3449),
    [anon_sym_from] = ACTIONS(3449),
    [anon_sym_into] = ACTIONS(3449),
    [anon_sym_join] = ACTIONS(3449),
    [anon_sym_on] = ACTIONS(3449),
    [anon_sym_equals] = ACTIONS(3449),
    [anon_sym_let] = ACTIONS(3449),
    [anon_sym_orderby] = ACTIONS(3449),
    [anon_sym_ascending] = ACTIONS(3449),
    [anon_sym_descending] = ACTIONS(3449),
    [anon_sym_group] = ACTIONS(3449),
    [anon_sym_by] = ACTIONS(3449),
    [anon_sym_select] = ACTIONS(3449),
    [aux_sym_preproc_if_token1] = ACTIONS(3451),
    [aux_sym_preproc_if_token3] = ACTIONS(3451),
    [aux_sym_preproc_else_token1] = ACTIONS(3451),
    [aux_sym_preproc_elif_token1] = ACTIONS(3451),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3499] = {
    [sym_preproc_region] = STATE(3499),
    [sym_preproc_endregion] = STATE(3499),
    [sym_preproc_line] = STATE(3499),
    [sym_preproc_pragma] = STATE(3499),
    [sym_preproc_nullable] = STATE(3499),
    [sym_preproc_error] = STATE(3499),
    [sym_preproc_define] = STATE(3499),
    [sym_preproc_undef] = STATE(3499),
    [sym__identifier_token] = ACTIONS(5147),
    [anon_sym_extern] = ACTIONS(5147),
    [anon_sym_alias] = ACTIONS(5147),
    [anon_sym_global] = ACTIONS(5147),
    [anon_sym_using] = ACTIONS(5147),
    [anon_sym_unsafe] = ACTIONS(5147),
    [anon_sym_static] = ACTIONS(5147),
    [anon_sym_LBRACK] = ACTIONS(5149),
    [anon_sym_LPAREN] = ACTIONS(5149),
    [anon_sym_event] = ACTIONS(5147),
    [anon_sym_namespace] = ACTIONS(5147),
    [anon_sym_class] = ACTIONS(5147),
    [anon_sym_ref] = ACTIONS(5147),
    [anon_sym_struct] = ACTIONS(5147),
    [anon_sym_enum] = ACTIONS(5147),
    [anon_sym_RBRACE] = ACTIONS(5149),
    [anon_sym_interface] = ACTIONS(5147),
    [anon_sym_delegate] = ACTIONS(5147),
    [anon_sym_record] = ACTIONS(5147),
    [anon_sym_abstract] = ACTIONS(5147),
    [anon_sym_async] = ACTIONS(5147),
    [anon_sym_const] = ACTIONS(5147),
    [anon_sym_file] = ACTIONS(5147),
    [anon_sym_fixed] = ACTIONS(5147),
    [anon_sym_internal] = ACTIONS(5147),
    [anon_sym_new] = ACTIONS(5147),
    [anon_sym_override] = ACTIONS(5147),
    [anon_sym_partial] = ACTIONS(5147),
    [anon_sym_private] = ACTIONS(5147),
    [anon_sym_protected] = ACTIONS(5147),
    [anon_sym_public] = ACTIONS(5147),
    [anon_sym_readonly] = ACTIONS(5147),
    [anon_sym_required] = ACTIONS(5147),
    [anon_sym_sealed] = ACTIONS(5147),
    [anon_sym_virtual] = ACTIONS(5147),
    [anon_sym_volatile] = ACTIONS(5147),
    [anon_sym_where] = ACTIONS(5147),
    [anon_sym_notnull] = ACTIONS(5147),
    [anon_sym_unmanaged] = ACTIONS(5147),
    [anon_sym_TILDE] = ACTIONS(5149),
    [anon_sym_implicit] = ACTIONS(5147),
    [anon_sym_explicit] = ACTIONS(5147),
    [anon_sym_scoped] = ACTIONS(5147),
    [anon_sym_var] = ACTIONS(5147),
    [sym_predefined_type] = ACTIONS(5147),
    [anon_sym_yield] = ACTIONS(5147),
    [anon_sym_when] = ACTIONS(5147),
    [anon_sym_from] = ACTIONS(5147),
    [anon_sym_into] = ACTIONS(5147),
    [anon_sym_join] = ACTIONS(5147),
    [anon_sym_on] = ACTIONS(5147),
    [anon_sym_equals] = ACTIONS(5147),
    [anon_sym_let] = ACTIONS(5147),
    [anon_sym_orderby] = ACTIONS(5147),
    [anon_sym_ascending] = ACTIONS(5147),
    [anon_sym_descending] = ACTIONS(5147),
    [anon_sym_group] = ACTIONS(5147),
    [anon_sym_by] = ACTIONS(5147),
    [anon_sym_select] = ACTIONS(5147),
    [aux_sym_preproc_if_token1] = ACTIONS(5149),
    [aux_sym_preproc_if_token3] = ACTIONS(5149),
    [aux_sym_preproc_else_token1] = ACTIONS(5149),
    [aux_sym_preproc_elif_token1] = ACTIONS(5149),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3500] = {
    [sym_preproc_region] = STATE(3500),
    [sym_preproc_endregion] = STATE(3500),
    [sym_preproc_line] = STATE(3500),
    [sym_preproc_pragma] = STATE(3500),
    [sym_preproc_nullable] = STATE(3500),
    [sym_preproc_error] = STATE(3500),
    [sym_preproc_define] = STATE(3500),
    [sym_preproc_undef] = STATE(3500),
    [sym__identifier_token] = ACTIONS(3433),
    [anon_sym_extern] = ACTIONS(3433),
    [anon_sym_alias] = ACTIONS(3433),
    [anon_sym_global] = ACTIONS(3433),
    [anon_sym_using] = ACTIONS(3433),
    [anon_sym_unsafe] = ACTIONS(3433),
    [anon_sym_static] = ACTIONS(3433),
    [anon_sym_LBRACK] = ACTIONS(3435),
    [anon_sym_LPAREN] = ACTIONS(3435),
    [anon_sym_event] = ACTIONS(3433),
    [anon_sym_namespace] = ACTIONS(3433),
    [anon_sym_class] = ACTIONS(3433),
    [anon_sym_ref] = ACTIONS(3433),
    [anon_sym_struct] = ACTIONS(3433),
    [anon_sym_enum] = ACTIONS(3433),
    [anon_sym_RBRACE] = ACTIONS(3435),
    [anon_sym_interface] = ACTIONS(3433),
    [anon_sym_delegate] = ACTIONS(3433),
    [anon_sym_record] = ACTIONS(3433),
    [anon_sym_abstract] = ACTIONS(3433),
    [anon_sym_async] = ACTIONS(3433),
    [anon_sym_const] = ACTIONS(3433),
    [anon_sym_file] = ACTIONS(3433),
    [anon_sym_fixed] = ACTIONS(3433),
    [anon_sym_internal] = ACTIONS(3433),
    [anon_sym_new] = ACTIONS(3433),
    [anon_sym_override] = ACTIONS(3433),
    [anon_sym_partial] = ACTIONS(3433),
    [anon_sym_private] = ACTIONS(3433),
    [anon_sym_protected] = ACTIONS(3433),
    [anon_sym_public] = ACTIONS(3433),
    [anon_sym_readonly] = ACTIONS(3433),
    [anon_sym_required] = ACTIONS(3433),
    [anon_sym_sealed] = ACTIONS(3433),
    [anon_sym_virtual] = ACTIONS(3433),
    [anon_sym_volatile] = ACTIONS(3433),
    [anon_sym_where] = ACTIONS(3433),
    [anon_sym_notnull] = ACTIONS(3433),
    [anon_sym_unmanaged] = ACTIONS(3433),
    [anon_sym_TILDE] = ACTIONS(3435),
    [anon_sym_implicit] = ACTIONS(3433),
    [anon_sym_explicit] = ACTIONS(3433),
    [anon_sym_scoped] = ACTIONS(3433),
    [anon_sym_var] = ACTIONS(3433),
    [sym_predefined_type] = ACTIONS(3433),
    [anon_sym_yield] = ACTIONS(3433),
    [anon_sym_when] = ACTIONS(3433),
    [anon_sym_from] = ACTIONS(3433),
    [anon_sym_into] = ACTIONS(3433),
    [anon_sym_join] = ACTIONS(3433),
    [anon_sym_on] = ACTIONS(3433),
    [anon_sym_equals] = ACTIONS(3433),
    [anon_sym_let] = ACTIONS(3433),
    [anon_sym_orderby] = ACTIONS(3433),
    [anon_sym_ascending] = ACTIONS(3433),
    [anon_sym_descending] = ACTIONS(3433),
    [anon_sym_group] = ACTIONS(3433),
    [anon_sym_by] = ACTIONS(3433),
    [anon_sym_select] = ACTIONS(3433),
    [aux_sym_preproc_if_token1] = ACTIONS(3435),
    [aux_sym_preproc_if_token3] = ACTIONS(3435),
    [aux_sym_preproc_else_token1] = ACTIONS(3435),
    [aux_sym_preproc_elif_token1] = ACTIONS(3435),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3501] = {
    [sym__variable_designation] = STATE(4113),
    [sym_parenthesized_variable_designation] = STATE(4274),
    [sym_identifier] = STATE(4269),
    [sym__reserved_identifier] = STATE(3908),
    [sym_preproc_region] = STATE(3501),
    [sym_preproc_endregion] = STATE(3501),
    [sym_preproc_line] = STATE(3501),
    [sym_preproc_pragma] = STATE(3501),
    [sym_preproc_nullable] = STATE(3501),
    [sym_preproc_error] = STATE(3501),
    [sym_preproc_define] = STATE(3501),
    [sym_preproc_undef] = STATE(3501),
    [sym__identifier_token] = ACTIONS(4271),
    [anon_sym_alias] = ACTIONS(4273),
    [anon_sym_global] = ACTIONS(4273),
    [anon_sym_LBRACK] = ACTIONS(4373),
    [anon_sym_LPAREN] = ACTIONS(4373),
    [anon_sym_file] = ACTIONS(4273),
    [anon_sym_LT] = ACTIONS(4375),
    [anon_sym_GT] = ACTIONS(4375),
    [anon_sym_where] = ACTIONS(4273),
    [anon_sym_QMARK] = ACTIONS(4375),
    [anon_sym_notnull] = ACTIONS(4273),
    [anon_sym_unmanaged] = ACTIONS(4273),
    [anon_sym_BANG] = ACTIONS(4375),
    [anon_sym_PLUS_PLUS] = ACTIONS(4373),
    [anon_sym_DASH_DASH] = ACTIONS(4373),
    [anon_sym_PLUS] = ACTIONS(4375),
    [anon_sym_DASH] = ACTIONS(4375),
    [anon_sym_STAR] = ACTIONS(4373),
    [anon_sym_SLASH] = ACTIONS(4375),
    [anon_sym_PERCENT] = ACTIONS(4373),
    [anon_sym_CARET] = ACTIONS(4373),
    [anon_sym_PIPE] = ACTIONS(4375),
    [anon_sym_AMP] = ACTIONS(4375),
    [anon_sym_LT_LT] = ACTIONS(4373),
    [anon_sym_GT_GT] = ACTIONS(4375),
    [anon_sym_GT_GT_GT] = ACTIONS(4373),
    [anon_sym_EQ_EQ] = ACTIONS(4373),
    [anon_sym_BANG_EQ] = ACTIONS(4373),
    [anon_sym_GT_EQ] = ACTIONS(4373),
    [anon_sym_LT_EQ] = ACTIONS(4373),
    [anon_sym_DOT] = ACTIONS(4375),
    [anon_sym_scoped] = ACTIONS(4273),
    [anon_sym_var] = ACTIONS(4273),
    [anon_sym_yield] = ACTIONS(4273),
    [anon_sym_switch] = ACTIONS(4375),
    [anon_sym_when] = ACTIONS(4273),
    [sym_discard] = ACTIONS(4295),
    [anon_sym_DOT_DOT] = ACTIONS(4373),
    [anon_sym_and] = ACTIONS(4375),
    [anon_sym_or] = ACTIONS(4375),
    [anon_sym_AMP_AMP] = ACTIONS(4373),
    [anon_sym_PIPE_PIPE] = ACTIONS(4373),
    [anon_sym_QMARK_QMARK] = ACTIONS(4373),
    [anon_sym_from] = ACTIONS(4273),
    [anon_sym_into] = ACTIONS(4273),
    [anon_sym_join] = ACTIONS(4273),
    [anon_sym_on] = ACTIONS(4273),
    [anon_sym_equals] = ACTIONS(4273),
    [anon_sym_let] = ACTIONS(4273),
    [anon_sym_orderby] = ACTIONS(4273),
    [anon_sym_ascending] = ACTIONS(4273),
    [anon_sym_descending] = ACTIONS(4273),
    [anon_sym_group] = ACTIONS(4273),
    [anon_sym_by] = ACTIONS(4375),
    [anon_sym_select] = ACTIONS(4273),
    [anon_sym_as] = ACTIONS(4375),
    [anon_sym_is] = ACTIONS(4375),
    [anon_sym_DASH_GT] = ACTIONS(4373),
    [anon_sym_with] = ACTIONS(4375),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3502] = {
    [sym_preproc_region] = STATE(3502),
    [sym_preproc_endregion] = STATE(3502),
    [sym_preproc_line] = STATE(3502),
    [sym_preproc_pragma] = STATE(3502),
    [sym_preproc_nullable] = STATE(3502),
    [sym_preproc_error] = STATE(3502),
    [sym_preproc_define] = STATE(3502),
    [sym_preproc_undef] = STATE(3502),
    [sym__identifier_token] = ACTIONS(3465),
    [anon_sym_extern] = ACTIONS(3465),
    [anon_sym_alias] = ACTIONS(3465),
    [anon_sym_global] = ACTIONS(3465),
    [anon_sym_using] = ACTIONS(3465),
    [anon_sym_unsafe] = ACTIONS(3465),
    [anon_sym_static] = ACTIONS(3465),
    [anon_sym_LBRACK] = ACTIONS(3467),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_event] = ACTIONS(3465),
    [anon_sym_namespace] = ACTIONS(3465),
    [anon_sym_class] = ACTIONS(3465),
    [anon_sym_ref] = ACTIONS(3465),
    [anon_sym_struct] = ACTIONS(3465),
    [anon_sym_enum] = ACTIONS(3465),
    [anon_sym_RBRACE] = ACTIONS(3467),
    [anon_sym_interface] = ACTIONS(3465),
    [anon_sym_delegate] = ACTIONS(3465),
    [anon_sym_record] = ACTIONS(3465),
    [anon_sym_abstract] = ACTIONS(3465),
    [anon_sym_async] = ACTIONS(3465),
    [anon_sym_const] = ACTIONS(3465),
    [anon_sym_file] = ACTIONS(3465),
    [anon_sym_fixed] = ACTIONS(3465),
    [anon_sym_internal] = ACTIONS(3465),
    [anon_sym_new] = ACTIONS(3465),
    [anon_sym_override] = ACTIONS(3465),
    [anon_sym_partial] = ACTIONS(3465),
    [anon_sym_private] = ACTIONS(3465),
    [anon_sym_protected] = ACTIONS(3465),
    [anon_sym_public] = ACTIONS(3465),
    [anon_sym_readonly] = ACTIONS(3465),
    [anon_sym_required] = ACTIONS(3465),
    [anon_sym_sealed] = ACTIONS(3465),
    [anon_sym_virtual] = ACTIONS(3465),
    [anon_sym_volatile] = ACTIONS(3465),
    [anon_sym_where] = ACTIONS(3465),
    [anon_sym_notnull] = ACTIONS(3465),
    [anon_sym_unmanaged] = ACTIONS(3465),
    [anon_sym_TILDE] = ACTIONS(3467),
    [anon_sym_implicit] = ACTIONS(3465),
    [anon_sym_explicit] = ACTIONS(3465),
    [anon_sym_scoped] = ACTIONS(3465),
    [anon_sym_var] = ACTIONS(3465),
    [sym_predefined_type] = ACTIONS(3465),
    [anon_sym_yield] = ACTIONS(3465),
    [anon_sym_when] = ACTIONS(3465),
    [anon_sym_from] = ACTIONS(3465),
    [anon_sym_into] = ACTIONS(3465),
    [anon_sym_join] = ACTIONS(3465),
    [anon_sym_on] = ACTIONS(3465),
    [anon_sym_equals] = ACTIONS(3465),
    [anon_sym_let] = ACTIONS(3465),
    [anon_sym_orderby] = ACTIONS(3465),
    [anon_sym_ascending] = ACTIONS(3465),
    [anon_sym_descending] = ACTIONS(3465),
    [anon_sym_group] = ACTIONS(3465),
    [anon_sym_by] = ACTIONS(3465),
    [anon_sym_select] = ACTIONS(3465),
    [aux_sym_preproc_if_token1] = ACTIONS(3467),
    [aux_sym_preproc_if_token3] = ACTIONS(3467),
    [aux_sym_preproc_else_token1] = ACTIONS(3467),
    [aux_sym_preproc_elif_token1] = ACTIONS(3467),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3503] = {
    [sym_preproc_region] = STATE(3503),
    [sym_preproc_endregion] = STATE(3503),
    [sym_preproc_line] = STATE(3503),
    [sym_preproc_pragma] = STATE(3503),
    [sym_preproc_nullable] = STATE(3503),
    [sym_preproc_error] = STATE(3503),
    [sym_preproc_define] = STATE(3503),
    [sym_preproc_undef] = STATE(3503),
    [sym__identifier_token] = ACTIONS(3469),
    [anon_sym_extern] = ACTIONS(3469),
    [anon_sym_alias] = ACTIONS(3469),
    [anon_sym_global] = ACTIONS(3469),
    [anon_sym_using] = ACTIONS(3469),
    [anon_sym_unsafe] = ACTIONS(3469),
    [anon_sym_static] = ACTIONS(3469),
    [anon_sym_LBRACK] = ACTIONS(3471),
    [anon_sym_LPAREN] = ACTIONS(3471),
    [anon_sym_event] = ACTIONS(3469),
    [anon_sym_namespace] = ACTIONS(3469),
    [anon_sym_class] = ACTIONS(3469),
    [anon_sym_ref] = ACTIONS(3469),
    [anon_sym_struct] = ACTIONS(3469),
    [anon_sym_enum] = ACTIONS(3469),
    [anon_sym_RBRACE] = ACTIONS(3471),
    [anon_sym_interface] = ACTIONS(3469),
    [anon_sym_delegate] = ACTIONS(3469),
    [anon_sym_record] = ACTIONS(3469),
    [anon_sym_abstract] = ACTIONS(3469),
    [anon_sym_async] = ACTIONS(3469),
    [anon_sym_const] = ACTIONS(3469),
    [anon_sym_file] = ACTIONS(3469),
    [anon_sym_fixed] = ACTIONS(3469),
    [anon_sym_internal] = ACTIONS(3469),
    [anon_sym_new] = ACTIONS(3469),
    [anon_sym_override] = ACTIONS(3469),
    [anon_sym_partial] = ACTIONS(3469),
    [anon_sym_private] = ACTIONS(3469),
    [anon_sym_protected] = ACTIONS(3469),
    [anon_sym_public] = ACTIONS(3469),
    [anon_sym_readonly] = ACTIONS(3469),
    [anon_sym_required] = ACTIONS(3469),
    [anon_sym_sealed] = ACTIONS(3469),
    [anon_sym_virtual] = ACTIONS(3469),
    [anon_sym_volatile] = ACTIONS(3469),
    [anon_sym_where] = ACTIONS(3469),
    [anon_sym_notnull] = ACTIONS(3469),
    [anon_sym_unmanaged] = ACTIONS(3469),
    [anon_sym_TILDE] = ACTIONS(3471),
    [anon_sym_implicit] = ACTIONS(3469),
    [anon_sym_explicit] = ACTIONS(3469),
    [anon_sym_scoped] = ACTIONS(3469),
    [anon_sym_var] = ACTIONS(3469),
    [sym_predefined_type] = ACTIONS(3469),
    [anon_sym_yield] = ACTIONS(3469),
    [anon_sym_when] = ACTIONS(3469),
    [anon_sym_from] = ACTIONS(3469),
    [anon_sym_into] = ACTIONS(3469),
    [anon_sym_join] = ACTIONS(3469),
    [anon_sym_on] = ACTIONS(3469),
    [anon_sym_equals] = ACTIONS(3469),
    [anon_sym_let] = ACTIONS(3469),
    [anon_sym_orderby] = ACTIONS(3469),
    [anon_sym_ascending] = ACTIONS(3469),
    [anon_sym_descending] = ACTIONS(3469),
    [anon_sym_group] = ACTIONS(3469),
    [anon_sym_by] = ACTIONS(3469),
    [anon_sym_select] = ACTIONS(3469),
    [aux_sym_preproc_if_token1] = ACTIONS(3471),
    [aux_sym_preproc_if_token3] = ACTIONS(3471),
    [aux_sym_preproc_else_token1] = ACTIONS(3471),
    [aux_sym_preproc_elif_token1] = ACTIONS(3471),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3504] = {
    [sym_preproc_region] = STATE(3504),
    [sym_preproc_endregion] = STATE(3504),
    [sym_preproc_line] = STATE(3504),
    [sym_preproc_pragma] = STATE(3504),
    [sym_preproc_nullable] = STATE(3504),
    [sym_preproc_error] = STATE(3504),
    [sym_preproc_define] = STATE(3504),
    [sym_preproc_undef] = STATE(3504),
    [sym__identifier_token] = ACTIONS(3473),
    [anon_sym_extern] = ACTIONS(3473),
    [anon_sym_alias] = ACTIONS(3473),
    [anon_sym_global] = ACTIONS(3473),
    [anon_sym_using] = ACTIONS(3473),
    [anon_sym_unsafe] = ACTIONS(3473),
    [anon_sym_static] = ACTIONS(3473),
    [anon_sym_LBRACK] = ACTIONS(3475),
    [anon_sym_LPAREN] = ACTIONS(3475),
    [anon_sym_event] = ACTIONS(3473),
    [anon_sym_namespace] = ACTIONS(3473),
    [anon_sym_class] = ACTIONS(3473),
    [anon_sym_ref] = ACTIONS(3473),
    [anon_sym_struct] = ACTIONS(3473),
    [anon_sym_enum] = ACTIONS(3473),
    [anon_sym_RBRACE] = ACTIONS(3475),
    [anon_sym_interface] = ACTIONS(3473),
    [anon_sym_delegate] = ACTIONS(3473),
    [anon_sym_record] = ACTIONS(3473),
    [anon_sym_abstract] = ACTIONS(3473),
    [anon_sym_async] = ACTIONS(3473),
    [anon_sym_const] = ACTIONS(3473),
    [anon_sym_file] = ACTIONS(3473),
    [anon_sym_fixed] = ACTIONS(3473),
    [anon_sym_internal] = ACTIONS(3473),
    [anon_sym_new] = ACTIONS(3473),
    [anon_sym_override] = ACTIONS(3473),
    [anon_sym_partial] = ACTIONS(3473),
    [anon_sym_private] = ACTIONS(3473),
    [anon_sym_protected] = ACTIONS(3473),
    [anon_sym_public] = ACTIONS(3473),
    [anon_sym_readonly] = ACTIONS(3473),
    [anon_sym_required] = ACTIONS(3473),
    [anon_sym_sealed] = ACTIONS(3473),
    [anon_sym_virtual] = ACTIONS(3473),
    [anon_sym_volatile] = ACTIONS(3473),
    [anon_sym_where] = ACTIONS(3473),
    [anon_sym_notnull] = ACTIONS(3473),
    [anon_sym_unmanaged] = ACTIONS(3473),
    [anon_sym_TILDE] = ACTIONS(3475),
    [anon_sym_implicit] = ACTIONS(3473),
    [anon_sym_explicit] = ACTIONS(3473),
    [anon_sym_scoped] = ACTIONS(3473),
    [anon_sym_var] = ACTIONS(3473),
    [sym_predefined_type] = ACTIONS(3473),
    [anon_sym_yield] = ACTIONS(3473),
    [anon_sym_when] = ACTIONS(3473),
    [anon_sym_from] = ACTIONS(3473),
    [anon_sym_into] = ACTIONS(3473),
    [anon_sym_join] = ACTIONS(3473),
    [anon_sym_on] = ACTIONS(3473),
    [anon_sym_equals] = ACTIONS(3473),
    [anon_sym_let] = ACTIONS(3473),
    [anon_sym_orderby] = ACTIONS(3473),
    [anon_sym_ascending] = ACTIONS(3473),
    [anon_sym_descending] = ACTIONS(3473),
    [anon_sym_group] = ACTIONS(3473),
    [anon_sym_by] = ACTIONS(3473),
    [anon_sym_select] = ACTIONS(3473),
    [aux_sym_preproc_if_token1] = ACTIONS(3475),
    [aux_sym_preproc_if_token3] = ACTIONS(3475),
    [aux_sym_preproc_else_token1] = ACTIONS(3475),
    [aux_sym_preproc_elif_token1] = ACTIONS(3475),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3505] = {
    [sym_preproc_region] = STATE(3505),
    [sym_preproc_endregion] = STATE(3505),
    [sym_preproc_line] = STATE(3505),
    [sym_preproc_pragma] = STATE(3505),
    [sym_preproc_nullable] = STATE(3505),
    [sym_preproc_error] = STATE(3505),
    [sym_preproc_define] = STATE(3505),
    [sym_preproc_undef] = STATE(3505),
    [sym__identifier_token] = ACTIONS(3477),
    [anon_sym_extern] = ACTIONS(3477),
    [anon_sym_alias] = ACTIONS(3477),
    [anon_sym_global] = ACTIONS(3477),
    [anon_sym_using] = ACTIONS(3477),
    [anon_sym_unsafe] = ACTIONS(3477),
    [anon_sym_static] = ACTIONS(3477),
    [anon_sym_LBRACK] = ACTIONS(3479),
    [anon_sym_LPAREN] = ACTIONS(3479),
    [anon_sym_event] = ACTIONS(3477),
    [anon_sym_namespace] = ACTIONS(3477),
    [anon_sym_class] = ACTIONS(3477),
    [anon_sym_ref] = ACTIONS(3477),
    [anon_sym_struct] = ACTIONS(3477),
    [anon_sym_enum] = ACTIONS(3477),
    [anon_sym_RBRACE] = ACTIONS(3479),
    [anon_sym_interface] = ACTIONS(3477),
    [anon_sym_delegate] = ACTIONS(3477),
    [anon_sym_record] = ACTIONS(3477),
    [anon_sym_abstract] = ACTIONS(3477),
    [anon_sym_async] = ACTIONS(3477),
    [anon_sym_const] = ACTIONS(3477),
    [anon_sym_file] = ACTIONS(3477),
    [anon_sym_fixed] = ACTIONS(3477),
    [anon_sym_internal] = ACTIONS(3477),
    [anon_sym_new] = ACTIONS(3477),
    [anon_sym_override] = ACTIONS(3477),
    [anon_sym_partial] = ACTIONS(3477),
    [anon_sym_private] = ACTIONS(3477),
    [anon_sym_protected] = ACTIONS(3477),
    [anon_sym_public] = ACTIONS(3477),
    [anon_sym_readonly] = ACTIONS(3477),
    [anon_sym_required] = ACTIONS(3477),
    [anon_sym_sealed] = ACTIONS(3477),
    [anon_sym_virtual] = ACTIONS(3477),
    [anon_sym_volatile] = ACTIONS(3477),
    [anon_sym_where] = ACTIONS(3477),
    [anon_sym_notnull] = ACTIONS(3477),
    [anon_sym_unmanaged] = ACTIONS(3477),
    [anon_sym_TILDE] = ACTIONS(3479),
    [anon_sym_implicit] = ACTIONS(3477),
    [anon_sym_explicit] = ACTIONS(3477),
    [anon_sym_scoped] = ACTIONS(3477),
    [anon_sym_var] = ACTIONS(3477),
    [sym_predefined_type] = ACTIONS(3477),
    [anon_sym_yield] = ACTIONS(3477),
    [anon_sym_when] = ACTIONS(3477),
    [anon_sym_from] = ACTIONS(3477),
    [anon_sym_into] = ACTIONS(3477),
    [anon_sym_join] = ACTIONS(3477),
    [anon_sym_on] = ACTIONS(3477),
    [anon_sym_equals] = ACTIONS(3477),
    [anon_sym_let] = ACTIONS(3477),
    [anon_sym_orderby] = ACTIONS(3477),
    [anon_sym_ascending] = ACTIONS(3477),
    [anon_sym_descending] = ACTIONS(3477),
    [anon_sym_group] = ACTIONS(3477),
    [anon_sym_by] = ACTIONS(3477),
    [anon_sym_select] = ACTIONS(3477),
    [aux_sym_preproc_if_token1] = ACTIONS(3479),
    [aux_sym_preproc_if_token3] = ACTIONS(3479),
    [aux_sym_preproc_else_token1] = ACTIONS(3479),
    [aux_sym_preproc_elif_token1] = ACTIONS(3479),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3506] = {
    [sym_preproc_region] = STATE(3506),
    [sym_preproc_endregion] = STATE(3506),
    [sym_preproc_line] = STATE(3506),
    [sym_preproc_pragma] = STATE(3506),
    [sym_preproc_nullable] = STATE(3506),
    [sym_preproc_error] = STATE(3506),
    [sym_preproc_define] = STATE(3506),
    [sym_preproc_undef] = STATE(3506),
    [sym__identifier_token] = ACTIONS(3481),
    [anon_sym_extern] = ACTIONS(3481),
    [anon_sym_alias] = ACTIONS(3481),
    [anon_sym_global] = ACTIONS(3481),
    [anon_sym_using] = ACTIONS(3481),
    [anon_sym_unsafe] = ACTIONS(3481),
    [anon_sym_static] = ACTIONS(3481),
    [anon_sym_LBRACK] = ACTIONS(3483),
    [anon_sym_LPAREN] = ACTIONS(3483),
    [anon_sym_event] = ACTIONS(3481),
    [anon_sym_namespace] = ACTIONS(3481),
    [anon_sym_class] = ACTIONS(3481),
    [anon_sym_ref] = ACTIONS(3481),
    [anon_sym_struct] = ACTIONS(3481),
    [anon_sym_enum] = ACTIONS(3481),
    [anon_sym_RBRACE] = ACTIONS(3483),
    [anon_sym_interface] = ACTIONS(3481),
    [anon_sym_delegate] = ACTIONS(3481),
    [anon_sym_record] = ACTIONS(3481),
    [anon_sym_abstract] = ACTIONS(3481),
    [anon_sym_async] = ACTIONS(3481),
    [anon_sym_const] = ACTIONS(3481),
    [anon_sym_file] = ACTIONS(3481),
    [anon_sym_fixed] = ACTIONS(3481),
    [anon_sym_internal] = ACTIONS(3481),
    [anon_sym_new] = ACTIONS(3481),
    [anon_sym_override] = ACTIONS(3481),
    [anon_sym_partial] = ACTIONS(3481),
    [anon_sym_private] = ACTIONS(3481),
    [anon_sym_protected] = ACTIONS(3481),
    [anon_sym_public] = ACTIONS(3481),
    [anon_sym_readonly] = ACTIONS(3481),
    [anon_sym_required] = ACTIONS(3481),
    [anon_sym_sealed] = ACTIONS(3481),
    [anon_sym_virtual] = ACTIONS(3481),
    [anon_sym_volatile] = ACTIONS(3481),
    [anon_sym_where] = ACTIONS(3481),
    [anon_sym_notnull] = ACTIONS(3481),
    [anon_sym_unmanaged] = ACTIONS(3481),
    [anon_sym_TILDE] = ACTIONS(3483),
    [anon_sym_implicit] = ACTIONS(3481),
    [anon_sym_explicit] = ACTIONS(3481),
    [anon_sym_scoped] = ACTIONS(3481),
    [anon_sym_var] = ACTIONS(3481),
    [sym_predefined_type] = ACTIONS(3481),
    [anon_sym_yield] = ACTIONS(3481),
    [anon_sym_when] = ACTIONS(3481),
    [anon_sym_from] = ACTIONS(3481),
    [anon_sym_into] = ACTIONS(3481),
    [anon_sym_join] = ACTIONS(3481),
    [anon_sym_on] = ACTIONS(3481),
    [anon_sym_equals] = ACTIONS(3481),
    [anon_sym_let] = ACTIONS(3481),
    [anon_sym_orderby] = ACTIONS(3481),
    [anon_sym_ascending] = ACTIONS(3481),
    [anon_sym_descending] = ACTIONS(3481),
    [anon_sym_group] = ACTIONS(3481),
    [anon_sym_by] = ACTIONS(3481),
    [anon_sym_select] = ACTIONS(3481),
    [aux_sym_preproc_if_token1] = ACTIONS(3483),
    [aux_sym_preproc_if_token3] = ACTIONS(3483),
    [aux_sym_preproc_else_token1] = ACTIONS(3483),
    [aux_sym_preproc_elif_token1] = ACTIONS(3483),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3507] = {
    [sym_preproc_region] = STATE(3507),
    [sym_preproc_endregion] = STATE(3507),
    [sym_preproc_line] = STATE(3507),
    [sym_preproc_pragma] = STATE(3507),
    [sym_preproc_nullable] = STATE(3507),
    [sym_preproc_error] = STATE(3507),
    [sym_preproc_define] = STATE(3507),
    [sym_preproc_undef] = STATE(3507),
    [sym__identifier_token] = ACTIONS(3497),
    [anon_sym_extern] = ACTIONS(3497),
    [anon_sym_alias] = ACTIONS(3497),
    [anon_sym_global] = ACTIONS(3497),
    [anon_sym_using] = ACTIONS(3497),
    [anon_sym_unsafe] = ACTIONS(3497),
    [anon_sym_static] = ACTIONS(3497),
    [anon_sym_LBRACK] = ACTIONS(3499),
    [anon_sym_LPAREN] = ACTIONS(3499),
    [anon_sym_event] = ACTIONS(3497),
    [anon_sym_namespace] = ACTIONS(3497),
    [anon_sym_class] = ACTIONS(3497),
    [anon_sym_ref] = ACTIONS(3497),
    [anon_sym_struct] = ACTIONS(3497),
    [anon_sym_enum] = ACTIONS(3497),
    [anon_sym_RBRACE] = ACTIONS(3499),
    [anon_sym_interface] = ACTIONS(3497),
    [anon_sym_delegate] = ACTIONS(3497),
    [anon_sym_record] = ACTIONS(3497),
    [anon_sym_abstract] = ACTIONS(3497),
    [anon_sym_async] = ACTIONS(3497),
    [anon_sym_const] = ACTIONS(3497),
    [anon_sym_file] = ACTIONS(3497),
    [anon_sym_fixed] = ACTIONS(3497),
    [anon_sym_internal] = ACTIONS(3497),
    [anon_sym_new] = ACTIONS(3497),
    [anon_sym_override] = ACTIONS(3497),
    [anon_sym_partial] = ACTIONS(3497),
    [anon_sym_private] = ACTIONS(3497),
    [anon_sym_protected] = ACTIONS(3497),
    [anon_sym_public] = ACTIONS(3497),
    [anon_sym_readonly] = ACTIONS(3497),
    [anon_sym_required] = ACTIONS(3497),
    [anon_sym_sealed] = ACTIONS(3497),
    [anon_sym_virtual] = ACTIONS(3497),
    [anon_sym_volatile] = ACTIONS(3497),
    [anon_sym_where] = ACTIONS(3497),
    [anon_sym_notnull] = ACTIONS(3497),
    [anon_sym_unmanaged] = ACTIONS(3497),
    [anon_sym_TILDE] = ACTIONS(3499),
    [anon_sym_implicit] = ACTIONS(3497),
    [anon_sym_explicit] = ACTIONS(3497),
    [anon_sym_scoped] = ACTIONS(3497),
    [anon_sym_var] = ACTIONS(3497),
    [sym_predefined_type] = ACTIONS(3497),
    [anon_sym_yield] = ACTIONS(3497),
    [anon_sym_when] = ACTIONS(3497),
    [anon_sym_from] = ACTIONS(3497),
    [anon_sym_into] = ACTIONS(3497),
    [anon_sym_join] = ACTIONS(3497),
    [anon_sym_on] = ACTIONS(3497),
    [anon_sym_equals] = ACTIONS(3497),
    [anon_sym_let] = ACTIONS(3497),
    [anon_sym_orderby] = ACTIONS(3497),
    [anon_sym_ascending] = ACTIONS(3497),
    [anon_sym_descending] = ACTIONS(3497),
    [anon_sym_group] = ACTIONS(3497),
    [anon_sym_by] = ACTIONS(3497),
    [anon_sym_select] = ACTIONS(3497),
    [aux_sym_preproc_if_token1] = ACTIONS(3499),
    [aux_sym_preproc_if_token3] = ACTIONS(3499),
    [aux_sym_preproc_else_token1] = ACTIONS(3499),
    [aux_sym_preproc_elif_token1] = ACTIONS(3499),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3508] = {
    [sym_preproc_region] = STATE(3508),
    [sym_preproc_endregion] = STATE(3508),
    [sym_preproc_line] = STATE(3508),
    [sym_preproc_pragma] = STATE(3508),
    [sym_preproc_nullable] = STATE(3508),
    [sym_preproc_error] = STATE(3508),
    [sym_preproc_define] = STATE(3508),
    [sym_preproc_undef] = STATE(3508),
    [sym__identifier_token] = ACTIONS(5151),
    [anon_sym_extern] = ACTIONS(5151),
    [anon_sym_alias] = ACTIONS(5151),
    [anon_sym_global] = ACTIONS(5151),
    [anon_sym_using] = ACTIONS(5151),
    [anon_sym_unsafe] = ACTIONS(5151),
    [anon_sym_static] = ACTIONS(5151),
    [anon_sym_LBRACK] = ACTIONS(5153),
    [anon_sym_LPAREN] = ACTIONS(5153),
    [anon_sym_event] = ACTIONS(5151),
    [anon_sym_namespace] = ACTIONS(5151),
    [anon_sym_class] = ACTIONS(5151),
    [anon_sym_ref] = ACTIONS(5151),
    [anon_sym_struct] = ACTIONS(5151),
    [anon_sym_enum] = ACTIONS(5151),
    [anon_sym_RBRACE] = ACTIONS(5153),
    [anon_sym_interface] = ACTIONS(5151),
    [anon_sym_delegate] = ACTIONS(5151),
    [anon_sym_record] = ACTIONS(5151),
    [anon_sym_abstract] = ACTIONS(5151),
    [anon_sym_async] = ACTIONS(5151),
    [anon_sym_const] = ACTIONS(5151),
    [anon_sym_file] = ACTIONS(5151),
    [anon_sym_fixed] = ACTIONS(5151),
    [anon_sym_internal] = ACTIONS(5151),
    [anon_sym_new] = ACTIONS(5151),
    [anon_sym_override] = ACTIONS(5151),
    [anon_sym_partial] = ACTIONS(5151),
    [anon_sym_private] = ACTIONS(5151),
    [anon_sym_protected] = ACTIONS(5151),
    [anon_sym_public] = ACTIONS(5151),
    [anon_sym_readonly] = ACTIONS(5151),
    [anon_sym_required] = ACTIONS(5151),
    [anon_sym_sealed] = ACTIONS(5151),
    [anon_sym_virtual] = ACTIONS(5151),
    [anon_sym_volatile] = ACTIONS(5151),
    [anon_sym_where] = ACTIONS(5151),
    [anon_sym_notnull] = ACTIONS(5151),
    [anon_sym_unmanaged] = ACTIONS(5151),
    [anon_sym_TILDE] = ACTIONS(5153),
    [anon_sym_implicit] = ACTIONS(5151),
    [anon_sym_explicit] = ACTIONS(5151),
    [anon_sym_scoped] = ACTIONS(5151),
    [anon_sym_var] = ACTIONS(5151),
    [sym_predefined_type] = ACTIONS(5151),
    [anon_sym_yield] = ACTIONS(5151),
    [anon_sym_when] = ACTIONS(5151),
    [anon_sym_from] = ACTIONS(5151),
    [anon_sym_into] = ACTIONS(5151),
    [anon_sym_join] = ACTIONS(5151),
    [anon_sym_on] = ACTIONS(5151),
    [anon_sym_equals] = ACTIONS(5151),
    [anon_sym_let] = ACTIONS(5151),
    [anon_sym_orderby] = ACTIONS(5151),
    [anon_sym_ascending] = ACTIONS(5151),
    [anon_sym_descending] = ACTIONS(5151),
    [anon_sym_group] = ACTIONS(5151),
    [anon_sym_by] = ACTIONS(5151),
    [anon_sym_select] = ACTIONS(5151),
    [aux_sym_preproc_if_token1] = ACTIONS(5153),
    [aux_sym_preproc_if_token3] = ACTIONS(5153),
    [aux_sym_preproc_else_token1] = ACTIONS(5153),
    [aux_sym_preproc_elif_token1] = ACTIONS(5153),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3509] = {
    [sym_preproc_region] = STATE(3509),
    [sym_preproc_endregion] = STATE(3509),
    [sym_preproc_line] = STATE(3509),
    [sym_preproc_pragma] = STATE(3509),
    [sym_preproc_nullable] = STATE(3509),
    [sym_preproc_error] = STATE(3509),
    [sym_preproc_define] = STATE(3509),
    [sym_preproc_undef] = STATE(3509),
    [sym__identifier_token] = ACTIONS(3489),
    [anon_sym_extern] = ACTIONS(3489),
    [anon_sym_alias] = ACTIONS(3489),
    [anon_sym_global] = ACTIONS(3489),
    [anon_sym_using] = ACTIONS(3489),
    [anon_sym_unsafe] = ACTIONS(3489),
    [anon_sym_static] = ACTIONS(3489),
    [anon_sym_LBRACK] = ACTIONS(3491),
    [anon_sym_LPAREN] = ACTIONS(3491),
    [anon_sym_event] = ACTIONS(3489),
    [anon_sym_namespace] = ACTIONS(3489),
    [anon_sym_class] = ACTIONS(3489),
    [anon_sym_ref] = ACTIONS(3489),
    [anon_sym_struct] = ACTIONS(3489),
    [anon_sym_enum] = ACTIONS(3489),
    [anon_sym_RBRACE] = ACTIONS(3491),
    [anon_sym_interface] = ACTIONS(3489),
    [anon_sym_delegate] = ACTIONS(3489),
    [anon_sym_record] = ACTIONS(3489),
    [anon_sym_abstract] = ACTIONS(3489),
    [anon_sym_async] = ACTIONS(3489),
    [anon_sym_const] = ACTIONS(3489),
    [anon_sym_file] = ACTIONS(3489),
    [anon_sym_fixed] = ACTIONS(3489),
    [anon_sym_internal] = ACTIONS(3489),
    [anon_sym_new] = ACTIONS(3489),
    [anon_sym_override] = ACTIONS(3489),
    [anon_sym_partial] = ACTIONS(3489),
    [anon_sym_private] = ACTIONS(3489),
    [anon_sym_protected] = ACTIONS(3489),
    [anon_sym_public] = ACTIONS(3489),
    [anon_sym_readonly] = ACTIONS(3489),
    [anon_sym_required] = ACTIONS(3489),
    [anon_sym_sealed] = ACTIONS(3489),
    [anon_sym_virtual] = ACTIONS(3489),
    [anon_sym_volatile] = ACTIONS(3489),
    [anon_sym_where] = ACTIONS(3489),
    [anon_sym_notnull] = ACTIONS(3489),
    [anon_sym_unmanaged] = ACTIONS(3489),
    [anon_sym_TILDE] = ACTIONS(3491),
    [anon_sym_implicit] = ACTIONS(3489),
    [anon_sym_explicit] = ACTIONS(3489),
    [anon_sym_scoped] = ACTIONS(3489),
    [anon_sym_var] = ACTIONS(3489),
    [sym_predefined_type] = ACTIONS(3489),
    [anon_sym_yield] = ACTIONS(3489),
    [anon_sym_when] = ACTIONS(3489),
    [anon_sym_from] = ACTIONS(3489),
    [anon_sym_into] = ACTIONS(3489),
    [anon_sym_join] = ACTIONS(3489),
    [anon_sym_on] = ACTIONS(3489),
    [anon_sym_equals] = ACTIONS(3489),
    [anon_sym_let] = ACTIONS(3489),
    [anon_sym_orderby] = ACTIONS(3489),
    [anon_sym_ascending] = ACTIONS(3489),
    [anon_sym_descending] = ACTIONS(3489),
    [anon_sym_group] = ACTIONS(3489),
    [anon_sym_by] = ACTIONS(3489),
    [anon_sym_select] = ACTIONS(3489),
    [aux_sym_preproc_if_token1] = ACTIONS(3491),
    [aux_sym_preproc_if_token3] = ACTIONS(3491),
    [aux_sym_preproc_else_token1] = ACTIONS(3491),
    [aux_sym_preproc_elif_token1] = ACTIONS(3491),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3510] = {
    [sym_preproc_region] = STATE(3510),
    [sym_preproc_endregion] = STATE(3510),
    [sym_preproc_line] = STATE(3510),
    [sym_preproc_pragma] = STATE(3510),
    [sym_preproc_nullable] = STATE(3510),
    [sym_preproc_error] = STATE(3510),
    [sym_preproc_define] = STATE(3510),
    [sym_preproc_undef] = STATE(3510),
    [sym__identifier_token] = ACTIONS(5155),
    [anon_sym_extern] = ACTIONS(5155),
    [anon_sym_alias] = ACTIONS(5155),
    [anon_sym_global] = ACTIONS(5155),
    [anon_sym_using] = ACTIONS(5155),
    [anon_sym_unsafe] = ACTIONS(5155),
    [anon_sym_static] = ACTIONS(5155),
    [anon_sym_LBRACK] = ACTIONS(5157),
    [anon_sym_LPAREN] = ACTIONS(5157),
    [anon_sym_event] = ACTIONS(5155),
    [anon_sym_namespace] = ACTIONS(5155),
    [anon_sym_class] = ACTIONS(5155),
    [anon_sym_ref] = ACTIONS(5155),
    [anon_sym_struct] = ACTIONS(5155),
    [anon_sym_enum] = ACTIONS(5155),
    [anon_sym_RBRACE] = ACTIONS(5157),
    [anon_sym_interface] = ACTIONS(5155),
    [anon_sym_delegate] = ACTIONS(5155),
    [anon_sym_record] = ACTIONS(5155),
    [anon_sym_abstract] = ACTIONS(5155),
    [anon_sym_async] = ACTIONS(5155),
    [anon_sym_const] = ACTIONS(5155),
    [anon_sym_file] = ACTIONS(5155),
    [anon_sym_fixed] = ACTIONS(5155),
    [anon_sym_internal] = ACTIONS(5155),
    [anon_sym_new] = ACTIONS(5155),
    [anon_sym_override] = ACTIONS(5155),
    [anon_sym_partial] = ACTIONS(5155),
    [anon_sym_private] = ACTIONS(5155),
    [anon_sym_protected] = ACTIONS(5155),
    [anon_sym_public] = ACTIONS(5155),
    [anon_sym_readonly] = ACTIONS(5155),
    [anon_sym_required] = ACTIONS(5155),
    [anon_sym_sealed] = ACTIONS(5155),
    [anon_sym_virtual] = ACTIONS(5155),
    [anon_sym_volatile] = ACTIONS(5155),
    [anon_sym_where] = ACTIONS(5155),
    [anon_sym_notnull] = ACTIONS(5155),
    [anon_sym_unmanaged] = ACTIONS(5155),
    [anon_sym_TILDE] = ACTIONS(5157),
    [anon_sym_implicit] = ACTIONS(5155),
    [anon_sym_explicit] = ACTIONS(5155),
    [anon_sym_scoped] = ACTIONS(5155),
    [anon_sym_var] = ACTIONS(5155),
    [sym_predefined_type] = ACTIONS(5155),
    [anon_sym_yield] = ACTIONS(5155),
    [anon_sym_when] = ACTIONS(5155),
    [anon_sym_from] = ACTIONS(5155),
    [anon_sym_into] = ACTIONS(5155),
    [anon_sym_join] = ACTIONS(5155),
    [anon_sym_on] = ACTIONS(5155),
    [anon_sym_equals] = ACTIONS(5155),
    [anon_sym_let] = ACTIONS(5155),
    [anon_sym_orderby] = ACTIONS(5155),
    [anon_sym_ascending] = ACTIONS(5155),
    [anon_sym_descending] = ACTIONS(5155),
    [anon_sym_group] = ACTIONS(5155),
    [anon_sym_by] = ACTIONS(5155),
    [anon_sym_select] = ACTIONS(5155),
    [aux_sym_preproc_if_token1] = ACTIONS(5157),
    [aux_sym_preproc_if_token3] = ACTIONS(5157),
    [aux_sym_preproc_else_token1] = ACTIONS(5157),
    [aux_sym_preproc_elif_token1] = ACTIONS(5157),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3511] = {
    [sym_preproc_region] = STATE(3511),
    [sym_preproc_endregion] = STATE(3511),
    [sym_preproc_line] = STATE(3511),
    [sym_preproc_pragma] = STATE(3511),
    [sym_preproc_nullable] = STATE(3511),
    [sym_preproc_error] = STATE(3511),
    [sym_preproc_define] = STATE(3511),
    [sym_preproc_undef] = STATE(3511),
    [sym__identifier_token] = ACTIONS(3485),
    [anon_sym_extern] = ACTIONS(3485),
    [anon_sym_alias] = ACTIONS(3485),
    [anon_sym_global] = ACTIONS(3485),
    [anon_sym_using] = ACTIONS(3485),
    [anon_sym_unsafe] = ACTIONS(3485),
    [anon_sym_static] = ACTIONS(3485),
    [anon_sym_LBRACK] = ACTIONS(3487),
    [anon_sym_LPAREN] = ACTIONS(3487),
    [anon_sym_event] = ACTIONS(3485),
    [anon_sym_namespace] = ACTIONS(3485),
    [anon_sym_class] = ACTIONS(3485),
    [anon_sym_ref] = ACTIONS(3485),
    [anon_sym_struct] = ACTIONS(3485),
    [anon_sym_enum] = ACTIONS(3485),
    [anon_sym_RBRACE] = ACTIONS(3487),
    [anon_sym_interface] = ACTIONS(3485),
    [anon_sym_delegate] = ACTIONS(3485),
    [anon_sym_record] = ACTIONS(3485),
    [anon_sym_abstract] = ACTIONS(3485),
    [anon_sym_async] = ACTIONS(3485),
    [anon_sym_const] = ACTIONS(3485),
    [anon_sym_file] = ACTIONS(3485),
    [anon_sym_fixed] = ACTIONS(3485),
    [anon_sym_internal] = ACTIONS(3485),
    [anon_sym_new] = ACTIONS(3485),
    [anon_sym_override] = ACTIONS(3485),
    [anon_sym_partial] = ACTIONS(3485),
    [anon_sym_private] = ACTIONS(3485),
    [anon_sym_protected] = ACTIONS(3485),
    [anon_sym_public] = ACTIONS(3485),
    [anon_sym_readonly] = ACTIONS(3485),
    [anon_sym_required] = ACTIONS(3485),
    [anon_sym_sealed] = ACTIONS(3485),
    [anon_sym_virtual] = ACTIONS(3485),
    [anon_sym_volatile] = ACTIONS(3485),
    [anon_sym_where] = ACTIONS(3485),
    [anon_sym_notnull] = ACTIONS(3485),
    [anon_sym_unmanaged] = ACTIONS(3485),
    [anon_sym_TILDE] = ACTIONS(3487),
    [anon_sym_implicit] = ACTIONS(3485),
    [anon_sym_explicit] = ACTIONS(3485),
    [anon_sym_scoped] = ACTIONS(3485),
    [anon_sym_var] = ACTIONS(3485),
    [sym_predefined_type] = ACTIONS(3485),
    [anon_sym_yield] = ACTIONS(3485),
    [anon_sym_when] = ACTIONS(3485),
    [anon_sym_from] = ACTIONS(3485),
    [anon_sym_into] = ACTIONS(3485),
    [anon_sym_join] = ACTIONS(3485),
    [anon_sym_on] = ACTIONS(3485),
    [anon_sym_equals] = ACTIONS(3485),
    [anon_sym_let] = ACTIONS(3485),
    [anon_sym_orderby] = ACTIONS(3485),
    [anon_sym_ascending] = ACTIONS(3485),
    [anon_sym_descending] = ACTIONS(3485),
    [anon_sym_group] = ACTIONS(3485),
    [anon_sym_by] = ACTIONS(3485),
    [anon_sym_select] = ACTIONS(3485),
    [aux_sym_preproc_if_token1] = ACTIONS(3487),
    [aux_sym_preproc_if_token3] = ACTIONS(3487),
    [aux_sym_preproc_else_token1] = ACTIONS(3487),
    [aux_sym_preproc_elif_token1] = ACTIONS(3487),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3512] = {
    [sym_preproc_region] = STATE(3512),
    [sym_preproc_endregion] = STATE(3512),
    [sym_preproc_line] = STATE(3512),
    [sym_preproc_pragma] = STATE(3512),
    [sym_preproc_nullable] = STATE(3512),
    [sym_preproc_error] = STATE(3512),
    [sym_preproc_define] = STATE(3512),
    [sym_preproc_undef] = STATE(3512),
    [sym__identifier_token] = ACTIONS(4568),
    [anon_sym_alias] = ACTIONS(4568),
    [anon_sym_global] = ACTIONS(4568),
    [anon_sym_LBRACK] = ACTIONS(4570),
    [anon_sym_COLON] = ACTIONS(4570),
    [anon_sym_COMMA] = ACTIONS(4570),
    [anon_sym_LPAREN] = ACTIONS(4570),
    [anon_sym_LBRACE] = ACTIONS(4570),
    [anon_sym_file] = ACTIONS(4568),
    [anon_sym_LT] = ACTIONS(4568),
    [anon_sym_GT] = ACTIONS(4568),
    [anon_sym_where] = ACTIONS(4568),
    [anon_sym_QMARK] = ACTIONS(4568),
    [anon_sym_notnull] = ACTIONS(4568),
    [anon_sym_unmanaged] = ACTIONS(4568),
    [anon_sym_BANG] = ACTIONS(4568),
    [anon_sym_PLUS_PLUS] = ACTIONS(4570),
    [anon_sym_DASH_DASH] = ACTIONS(4570),
    [anon_sym_PLUS] = ACTIONS(4568),
    [anon_sym_DASH] = ACTIONS(4568),
    [anon_sym_STAR] = ACTIONS(4570),
    [anon_sym_SLASH] = ACTIONS(4568),
    [anon_sym_PERCENT] = ACTIONS(4570),
    [anon_sym_CARET] = ACTIONS(4570),
    [anon_sym_PIPE] = ACTIONS(4568),
    [anon_sym_AMP] = ACTIONS(4568),
    [anon_sym_LT_LT] = ACTIONS(4570),
    [anon_sym_GT_GT] = ACTIONS(4568),
    [anon_sym_GT_GT_GT] = ACTIONS(4570),
    [anon_sym_EQ_EQ] = ACTIONS(4570),
    [anon_sym_BANG_EQ] = ACTIONS(4570),
    [anon_sym_GT_EQ] = ACTIONS(4570),
    [anon_sym_LT_EQ] = ACTIONS(4570),
    [anon_sym_DOT] = ACTIONS(4568),
    [anon_sym_scoped] = ACTIONS(4568),
    [anon_sym_var] = ACTIONS(4568),
    [anon_sym_yield] = ACTIONS(4568),
    [anon_sym_switch] = ACTIONS(4568),
    [anon_sym_when] = ACTIONS(4568),
    [sym_discard] = ACTIONS(4568),
    [anon_sym_DOT_DOT] = ACTIONS(4570),
    [anon_sym_and] = ACTIONS(4568),
    [anon_sym_or] = ACTIONS(4568),
    [anon_sym_AMP_AMP] = ACTIONS(4570),
    [anon_sym_PIPE_PIPE] = ACTIONS(4570),
    [anon_sym_QMARK_QMARK] = ACTIONS(4570),
    [anon_sym_from] = ACTIONS(4568),
    [anon_sym_into] = ACTIONS(4568),
    [anon_sym_join] = ACTIONS(4568),
    [anon_sym_on] = ACTIONS(4568),
    [anon_sym_equals] = ACTIONS(4568),
    [anon_sym_let] = ACTIONS(4568),
    [anon_sym_orderby] = ACTIONS(4568),
    [anon_sym_ascending] = ACTIONS(4568),
    [anon_sym_descending] = ACTIONS(4568),
    [anon_sym_group] = ACTIONS(4568),
    [anon_sym_by] = ACTIONS(4568),
    [anon_sym_select] = ACTIONS(4568),
    [anon_sym_as] = ACTIONS(4568),
    [anon_sym_is] = ACTIONS(4568),
    [anon_sym_DASH_GT] = ACTIONS(4570),
    [anon_sym_with] = ACTIONS(4568),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4570),
  },
  [3513] = {
    [sym_preproc_region] = STATE(3513),
    [sym_preproc_endregion] = STATE(3513),
    [sym_preproc_line] = STATE(3513),
    [sym_preproc_pragma] = STATE(3513),
    [sym_preproc_nullable] = STATE(3513),
    [sym_preproc_error] = STATE(3513),
    [sym_preproc_define] = STATE(3513),
    [sym_preproc_undef] = STATE(3513),
    [sym__identifier_token] = ACTIONS(4594),
    [anon_sym_alias] = ACTIONS(4594),
    [anon_sym_global] = ACTIONS(4594),
    [anon_sym_LBRACK] = ACTIONS(4596),
    [anon_sym_COLON] = ACTIONS(4596),
    [anon_sym_COMMA] = ACTIONS(4596),
    [anon_sym_LPAREN] = ACTIONS(4596),
    [anon_sym_file] = ACTIONS(4594),
    [anon_sym_LT] = ACTIONS(4594),
    [anon_sym_GT] = ACTIONS(4594),
    [anon_sym_where] = ACTIONS(4594),
    [anon_sym_QMARK] = ACTIONS(4594),
    [anon_sym_notnull] = ACTIONS(4594),
    [anon_sym_unmanaged] = ACTIONS(4594),
    [anon_sym_BANG] = ACTIONS(4594),
    [anon_sym_PLUS_PLUS] = ACTIONS(4596),
    [anon_sym_DASH_DASH] = ACTIONS(4596),
    [anon_sym_PLUS] = ACTIONS(4594),
    [anon_sym_DASH] = ACTIONS(4594),
    [anon_sym_STAR] = ACTIONS(4596),
    [anon_sym_SLASH] = ACTIONS(4594),
    [anon_sym_PERCENT] = ACTIONS(4596),
    [anon_sym_CARET] = ACTIONS(4596),
    [anon_sym_PIPE] = ACTIONS(4594),
    [anon_sym_AMP] = ACTIONS(4594),
    [anon_sym_LT_LT] = ACTIONS(4596),
    [anon_sym_GT_GT] = ACTIONS(4594),
    [anon_sym_GT_GT_GT] = ACTIONS(4596),
    [anon_sym_EQ_EQ] = ACTIONS(4596),
    [anon_sym_BANG_EQ] = ACTIONS(4596),
    [anon_sym_GT_EQ] = ACTIONS(4596),
    [anon_sym_LT_EQ] = ACTIONS(4596),
    [anon_sym_DOT] = ACTIONS(4594),
    [anon_sym_scoped] = ACTIONS(4594),
    [anon_sym_var] = ACTIONS(4594),
    [anon_sym_yield] = ACTIONS(4594),
    [anon_sym_switch] = ACTIONS(4594),
    [anon_sym_when] = ACTIONS(4594),
    [sym_discard] = ACTIONS(4594),
    [anon_sym_DOT_DOT] = ACTIONS(4596),
    [anon_sym_and] = ACTIONS(4594),
    [anon_sym_or] = ACTIONS(4594),
    [anon_sym_AMP_AMP] = ACTIONS(4596),
    [anon_sym_PIPE_PIPE] = ACTIONS(4596),
    [anon_sym_QMARK_QMARK] = ACTIONS(4596),
    [anon_sym_from] = ACTIONS(4594),
    [anon_sym_into] = ACTIONS(4594),
    [anon_sym_join] = ACTIONS(4594),
    [anon_sym_on] = ACTIONS(4594),
    [anon_sym_equals] = ACTIONS(4594),
    [anon_sym_let] = ACTIONS(4594),
    [anon_sym_orderby] = ACTIONS(4594),
    [anon_sym_ascending] = ACTIONS(4594),
    [anon_sym_descending] = ACTIONS(4594),
    [anon_sym_group] = ACTIONS(4594),
    [anon_sym_by] = ACTIONS(4594),
    [anon_sym_select] = ACTIONS(4594),
    [anon_sym_as] = ACTIONS(4594),
    [anon_sym_is] = ACTIONS(4594),
    [anon_sym_DASH_GT] = ACTIONS(4596),
    [anon_sym_with] = ACTIONS(4594),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4596),
  },
  [3514] = {
    [sym_preproc_region] = STATE(3514),
    [sym_preproc_endregion] = STATE(3514),
    [sym_preproc_line] = STATE(3514),
    [sym_preproc_pragma] = STATE(3514),
    [sym_preproc_nullable] = STATE(3514),
    [sym_preproc_error] = STATE(3514),
    [sym_preproc_define] = STATE(3514),
    [sym_preproc_undef] = STATE(3514),
    [sym__identifier_token] = ACTIONS(4576),
    [anon_sym_alias] = ACTIONS(4576),
    [anon_sym_global] = ACTIONS(4576),
    [anon_sym_LBRACK] = ACTIONS(4578),
    [anon_sym_COLON] = ACTIONS(4578),
    [anon_sym_COMMA] = ACTIONS(4578),
    [anon_sym_LPAREN] = ACTIONS(4578),
    [anon_sym_file] = ACTIONS(4576),
    [anon_sym_LT] = ACTIONS(4576),
    [anon_sym_GT] = ACTIONS(4576),
    [anon_sym_where] = ACTIONS(4576),
    [anon_sym_QMARK] = ACTIONS(4576),
    [anon_sym_notnull] = ACTIONS(4576),
    [anon_sym_unmanaged] = ACTIONS(4576),
    [anon_sym_BANG] = ACTIONS(4576),
    [anon_sym_PLUS_PLUS] = ACTIONS(4578),
    [anon_sym_DASH_DASH] = ACTIONS(4578),
    [anon_sym_PLUS] = ACTIONS(4576),
    [anon_sym_DASH] = ACTIONS(4576),
    [anon_sym_STAR] = ACTIONS(4578),
    [anon_sym_SLASH] = ACTIONS(4576),
    [anon_sym_PERCENT] = ACTIONS(4578),
    [anon_sym_CARET] = ACTIONS(4578),
    [anon_sym_PIPE] = ACTIONS(4576),
    [anon_sym_AMP] = ACTIONS(4576),
    [anon_sym_LT_LT] = ACTIONS(4578),
    [anon_sym_GT_GT] = ACTIONS(4576),
    [anon_sym_GT_GT_GT] = ACTIONS(4578),
    [anon_sym_EQ_EQ] = ACTIONS(4578),
    [anon_sym_BANG_EQ] = ACTIONS(4578),
    [anon_sym_GT_EQ] = ACTIONS(4578),
    [anon_sym_LT_EQ] = ACTIONS(4578),
    [anon_sym_DOT] = ACTIONS(4576),
    [anon_sym_scoped] = ACTIONS(4576),
    [anon_sym_var] = ACTIONS(4576),
    [anon_sym_yield] = ACTIONS(4576),
    [anon_sym_switch] = ACTIONS(4576),
    [anon_sym_when] = ACTIONS(4576),
    [sym_discard] = ACTIONS(4576),
    [anon_sym_DOT_DOT] = ACTIONS(4578),
    [anon_sym_and] = ACTIONS(4576),
    [anon_sym_or] = ACTIONS(4576),
    [anon_sym_AMP_AMP] = ACTIONS(4578),
    [anon_sym_PIPE_PIPE] = ACTIONS(4578),
    [anon_sym_QMARK_QMARK] = ACTIONS(4578),
    [anon_sym_from] = ACTIONS(4576),
    [anon_sym_into] = ACTIONS(4576),
    [anon_sym_join] = ACTIONS(4576),
    [anon_sym_on] = ACTIONS(4576),
    [anon_sym_equals] = ACTIONS(4576),
    [anon_sym_let] = ACTIONS(4576),
    [anon_sym_orderby] = ACTIONS(4576),
    [anon_sym_ascending] = ACTIONS(4576),
    [anon_sym_descending] = ACTIONS(4576),
    [anon_sym_group] = ACTIONS(4576),
    [anon_sym_by] = ACTIONS(4576),
    [anon_sym_select] = ACTIONS(4576),
    [anon_sym_as] = ACTIONS(4576),
    [anon_sym_is] = ACTIONS(4576),
    [anon_sym_DASH_GT] = ACTIONS(4578),
    [anon_sym_with] = ACTIONS(4576),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4578),
  },
  [3515] = {
    [sym_preproc_region] = STATE(3515),
    [sym_preproc_endregion] = STATE(3515),
    [sym_preproc_line] = STATE(3515),
    [sym_preproc_pragma] = STATE(3515),
    [sym_preproc_nullable] = STATE(3515),
    [sym_preproc_error] = STATE(3515),
    [sym_preproc_define] = STATE(3515),
    [sym_preproc_undef] = STATE(3515),
    [sym__identifier_token] = ACTIONS(4580),
    [anon_sym_alias] = ACTIONS(4580),
    [anon_sym_global] = ACTIONS(4580),
    [anon_sym_LBRACK] = ACTIONS(4582),
    [anon_sym_COLON] = ACTIONS(4582),
    [anon_sym_COMMA] = ACTIONS(4582),
    [anon_sym_LPAREN] = ACTIONS(4582),
    [anon_sym_file] = ACTIONS(4580),
    [anon_sym_LT] = ACTIONS(4580),
    [anon_sym_GT] = ACTIONS(4580),
    [anon_sym_where] = ACTIONS(4580),
    [anon_sym_QMARK] = ACTIONS(4580),
    [anon_sym_notnull] = ACTIONS(4580),
    [anon_sym_unmanaged] = ACTIONS(4580),
    [anon_sym_BANG] = ACTIONS(4580),
    [anon_sym_PLUS_PLUS] = ACTIONS(4582),
    [anon_sym_DASH_DASH] = ACTIONS(4582),
    [anon_sym_PLUS] = ACTIONS(4580),
    [anon_sym_DASH] = ACTIONS(4580),
    [anon_sym_STAR] = ACTIONS(4582),
    [anon_sym_SLASH] = ACTIONS(4580),
    [anon_sym_PERCENT] = ACTIONS(4582),
    [anon_sym_CARET] = ACTIONS(4582),
    [anon_sym_PIPE] = ACTIONS(4580),
    [anon_sym_AMP] = ACTIONS(4580),
    [anon_sym_LT_LT] = ACTIONS(4582),
    [anon_sym_GT_GT] = ACTIONS(4580),
    [anon_sym_GT_GT_GT] = ACTIONS(4582),
    [anon_sym_EQ_EQ] = ACTIONS(4582),
    [anon_sym_BANG_EQ] = ACTIONS(4582),
    [anon_sym_GT_EQ] = ACTIONS(4582),
    [anon_sym_LT_EQ] = ACTIONS(4582),
    [anon_sym_DOT] = ACTIONS(4580),
    [anon_sym_scoped] = ACTIONS(4580),
    [anon_sym_var] = ACTIONS(4580),
    [anon_sym_yield] = ACTIONS(4580),
    [anon_sym_switch] = ACTIONS(4580),
    [anon_sym_when] = ACTIONS(4580),
    [sym_discard] = ACTIONS(4580),
    [anon_sym_DOT_DOT] = ACTIONS(4582),
    [anon_sym_and] = ACTIONS(4580),
    [anon_sym_or] = ACTIONS(4580),
    [anon_sym_AMP_AMP] = ACTIONS(4582),
    [anon_sym_PIPE_PIPE] = ACTIONS(4582),
    [anon_sym_QMARK_QMARK] = ACTIONS(4582),
    [anon_sym_from] = ACTIONS(4580),
    [anon_sym_into] = ACTIONS(4580),
    [anon_sym_join] = ACTIONS(4580),
    [anon_sym_on] = ACTIONS(4580),
    [anon_sym_equals] = ACTIONS(4580),
    [anon_sym_let] = ACTIONS(4580),
    [anon_sym_orderby] = ACTIONS(4580),
    [anon_sym_ascending] = ACTIONS(4580),
    [anon_sym_descending] = ACTIONS(4580),
    [anon_sym_group] = ACTIONS(4580),
    [anon_sym_by] = ACTIONS(4580),
    [anon_sym_select] = ACTIONS(4580),
    [anon_sym_as] = ACTIONS(4580),
    [anon_sym_is] = ACTIONS(4580),
    [anon_sym_DASH_GT] = ACTIONS(4582),
    [anon_sym_with] = ACTIONS(4580),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4582),
  },
  [3516] = {
    [sym_preproc_region] = STATE(3516),
    [sym_preproc_endregion] = STATE(3516),
    [sym_preproc_line] = STATE(3516),
    [sym_preproc_pragma] = STATE(3516),
    [sym_preproc_nullable] = STATE(3516),
    [sym_preproc_error] = STATE(3516),
    [sym_preproc_define] = STATE(3516),
    [sym_preproc_undef] = STATE(3516),
    [sym__identifier_token] = ACTIONS(4627),
    [anon_sym_alias] = ACTIONS(4627),
    [anon_sym_global] = ACTIONS(4627),
    [anon_sym_LBRACK] = ACTIONS(4629),
    [anon_sym_COLON] = ACTIONS(4629),
    [anon_sym_COMMA] = ACTIONS(4629),
    [anon_sym_LPAREN] = ACTIONS(4629),
    [anon_sym_file] = ACTIONS(4627),
    [anon_sym_LT] = ACTIONS(4627),
    [anon_sym_GT] = ACTIONS(4627),
    [anon_sym_where] = ACTIONS(4627),
    [anon_sym_QMARK] = ACTIONS(4627),
    [anon_sym_notnull] = ACTIONS(4627),
    [anon_sym_unmanaged] = ACTIONS(4627),
    [anon_sym_BANG] = ACTIONS(4627),
    [anon_sym_PLUS_PLUS] = ACTIONS(4629),
    [anon_sym_DASH_DASH] = ACTIONS(4629),
    [anon_sym_PLUS] = ACTIONS(4627),
    [anon_sym_DASH] = ACTIONS(4627),
    [anon_sym_STAR] = ACTIONS(4629),
    [anon_sym_SLASH] = ACTIONS(4627),
    [anon_sym_PERCENT] = ACTIONS(4629),
    [anon_sym_CARET] = ACTIONS(4629),
    [anon_sym_PIPE] = ACTIONS(4627),
    [anon_sym_AMP] = ACTIONS(4627),
    [anon_sym_LT_LT] = ACTIONS(4629),
    [anon_sym_GT_GT] = ACTIONS(4627),
    [anon_sym_GT_GT_GT] = ACTIONS(4629),
    [anon_sym_EQ_EQ] = ACTIONS(4629),
    [anon_sym_BANG_EQ] = ACTIONS(4629),
    [anon_sym_GT_EQ] = ACTIONS(4629),
    [anon_sym_LT_EQ] = ACTIONS(4629),
    [anon_sym_DOT] = ACTIONS(4627),
    [anon_sym_scoped] = ACTIONS(4627),
    [anon_sym_var] = ACTIONS(4627),
    [anon_sym_yield] = ACTIONS(4627),
    [anon_sym_switch] = ACTIONS(4627),
    [anon_sym_when] = ACTIONS(4627),
    [sym_discard] = ACTIONS(4627),
    [anon_sym_DOT_DOT] = ACTIONS(4629),
    [anon_sym_and] = ACTIONS(4627),
    [anon_sym_or] = ACTIONS(4627),
    [anon_sym_AMP_AMP] = ACTIONS(4629),
    [anon_sym_PIPE_PIPE] = ACTIONS(4629),
    [anon_sym_QMARK_QMARK] = ACTIONS(4629),
    [anon_sym_from] = ACTIONS(4627),
    [anon_sym_into] = ACTIONS(4627),
    [anon_sym_join] = ACTIONS(4627),
    [anon_sym_on] = ACTIONS(4627),
    [anon_sym_equals] = ACTIONS(4627),
    [anon_sym_let] = ACTIONS(4627),
    [anon_sym_orderby] = ACTIONS(4627),
    [anon_sym_ascending] = ACTIONS(4627),
    [anon_sym_descending] = ACTIONS(4627),
    [anon_sym_group] = ACTIONS(4627),
    [anon_sym_by] = ACTIONS(4627),
    [anon_sym_select] = ACTIONS(4627),
    [anon_sym_as] = ACTIONS(4627),
    [anon_sym_is] = ACTIONS(4627),
    [anon_sym_DASH_GT] = ACTIONS(4629),
    [anon_sym_with] = ACTIONS(4627),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4629),
  },
  [3517] = {
    [sym_preproc_region] = STATE(3517),
    [sym_preproc_endregion] = STATE(3517),
    [sym_preproc_line] = STATE(3517),
    [sym_preproc_pragma] = STATE(3517),
    [sym_preproc_nullable] = STATE(3517),
    [sym_preproc_error] = STATE(3517),
    [sym_preproc_define] = STATE(3517),
    [sym_preproc_undef] = STATE(3517),
    [sym__identifier_token] = ACTIONS(4580),
    [anon_sym_alias] = ACTIONS(4580),
    [anon_sym_global] = ACTIONS(4580),
    [anon_sym_LBRACK] = ACTIONS(4582),
    [anon_sym_COLON] = ACTIONS(4582),
    [anon_sym_COMMA] = ACTIONS(4582),
    [anon_sym_LPAREN] = ACTIONS(4582),
    [anon_sym_file] = ACTIONS(4580),
    [anon_sym_LT] = ACTIONS(4580),
    [anon_sym_GT] = ACTIONS(4580),
    [anon_sym_where] = ACTIONS(4580),
    [anon_sym_QMARK] = ACTIONS(4580),
    [anon_sym_notnull] = ACTIONS(4580),
    [anon_sym_unmanaged] = ACTIONS(4580),
    [anon_sym_BANG] = ACTIONS(4580),
    [anon_sym_PLUS_PLUS] = ACTIONS(4582),
    [anon_sym_DASH_DASH] = ACTIONS(4582),
    [anon_sym_PLUS] = ACTIONS(4580),
    [anon_sym_DASH] = ACTIONS(4580),
    [anon_sym_STAR] = ACTIONS(4582),
    [anon_sym_SLASH] = ACTIONS(4580),
    [anon_sym_PERCENT] = ACTIONS(4582),
    [anon_sym_CARET] = ACTIONS(4582),
    [anon_sym_PIPE] = ACTIONS(4580),
    [anon_sym_AMP] = ACTIONS(4580),
    [anon_sym_LT_LT] = ACTIONS(4582),
    [anon_sym_GT_GT] = ACTIONS(4580),
    [anon_sym_GT_GT_GT] = ACTIONS(4582),
    [anon_sym_EQ_EQ] = ACTIONS(4582),
    [anon_sym_BANG_EQ] = ACTIONS(4582),
    [anon_sym_GT_EQ] = ACTIONS(4582),
    [anon_sym_LT_EQ] = ACTIONS(4582),
    [anon_sym_DOT] = ACTIONS(4580),
    [anon_sym_scoped] = ACTIONS(4580),
    [anon_sym_var] = ACTIONS(4580),
    [anon_sym_yield] = ACTIONS(4580),
    [anon_sym_switch] = ACTIONS(4580),
    [anon_sym_when] = ACTIONS(4580),
    [sym_discard] = ACTIONS(4580),
    [anon_sym_DOT_DOT] = ACTIONS(4582),
    [anon_sym_and] = ACTIONS(4580),
    [anon_sym_or] = ACTIONS(4580),
    [anon_sym_AMP_AMP] = ACTIONS(4582),
    [anon_sym_PIPE_PIPE] = ACTIONS(4582),
    [anon_sym_QMARK_QMARK] = ACTIONS(4582),
    [anon_sym_from] = ACTIONS(4580),
    [anon_sym_into] = ACTIONS(4580),
    [anon_sym_join] = ACTIONS(4580),
    [anon_sym_on] = ACTIONS(4580),
    [anon_sym_equals] = ACTIONS(4580),
    [anon_sym_let] = ACTIONS(4580),
    [anon_sym_orderby] = ACTIONS(4580),
    [anon_sym_ascending] = ACTIONS(4580),
    [anon_sym_descending] = ACTIONS(4580),
    [anon_sym_group] = ACTIONS(4580),
    [anon_sym_by] = ACTIONS(4580),
    [anon_sym_select] = ACTIONS(4580),
    [anon_sym_as] = ACTIONS(4580),
    [anon_sym_is] = ACTIONS(4580),
    [anon_sym_DASH_GT] = ACTIONS(4582),
    [anon_sym_with] = ACTIONS(4580),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4582),
  },
  [3518] = {
    [sym_preproc_region] = STATE(3518),
    [sym_preproc_endregion] = STATE(3518),
    [sym_preproc_line] = STATE(3518),
    [sym_preproc_pragma] = STATE(3518),
    [sym_preproc_nullable] = STATE(3518),
    [sym_preproc_error] = STATE(3518),
    [sym_preproc_define] = STATE(3518),
    [sym_preproc_undef] = STATE(3518),
    [sym__identifier_token] = ACTIONS(4576),
    [anon_sym_alias] = ACTIONS(4576),
    [anon_sym_global] = ACTIONS(4576),
    [anon_sym_LBRACK] = ACTIONS(4578),
    [anon_sym_COLON] = ACTIONS(4578),
    [anon_sym_COMMA] = ACTIONS(4578),
    [anon_sym_LPAREN] = ACTIONS(4578),
    [anon_sym_file] = ACTIONS(4576),
    [anon_sym_LT] = ACTIONS(4576),
    [anon_sym_GT] = ACTIONS(4576),
    [anon_sym_where] = ACTIONS(4576),
    [anon_sym_QMARK] = ACTIONS(4576),
    [anon_sym_notnull] = ACTIONS(4576),
    [anon_sym_unmanaged] = ACTIONS(4576),
    [anon_sym_BANG] = ACTIONS(4576),
    [anon_sym_PLUS_PLUS] = ACTIONS(4578),
    [anon_sym_DASH_DASH] = ACTIONS(4578),
    [anon_sym_PLUS] = ACTIONS(4576),
    [anon_sym_DASH] = ACTIONS(4576),
    [anon_sym_STAR] = ACTIONS(4578),
    [anon_sym_SLASH] = ACTIONS(4576),
    [anon_sym_PERCENT] = ACTIONS(4578),
    [anon_sym_CARET] = ACTIONS(4578),
    [anon_sym_PIPE] = ACTIONS(4576),
    [anon_sym_AMP] = ACTIONS(4576),
    [anon_sym_LT_LT] = ACTIONS(4578),
    [anon_sym_GT_GT] = ACTIONS(4576),
    [anon_sym_GT_GT_GT] = ACTIONS(4578),
    [anon_sym_EQ_EQ] = ACTIONS(4578),
    [anon_sym_BANG_EQ] = ACTIONS(4578),
    [anon_sym_GT_EQ] = ACTIONS(4578),
    [anon_sym_LT_EQ] = ACTIONS(4578),
    [anon_sym_DOT] = ACTIONS(4576),
    [anon_sym_scoped] = ACTIONS(4576),
    [anon_sym_var] = ACTIONS(4576),
    [anon_sym_yield] = ACTIONS(4576),
    [anon_sym_switch] = ACTIONS(4576),
    [anon_sym_when] = ACTIONS(4576),
    [sym_discard] = ACTIONS(4576),
    [anon_sym_DOT_DOT] = ACTIONS(4578),
    [anon_sym_and] = ACTIONS(4576),
    [anon_sym_or] = ACTIONS(4576),
    [anon_sym_AMP_AMP] = ACTIONS(4578),
    [anon_sym_PIPE_PIPE] = ACTIONS(4578),
    [anon_sym_QMARK_QMARK] = ACTIONS(4578),
    [anon_sym_from] = ACTIONS(4576),
    [anon_sym_into] = ACTIONS(4576),
    [anon_sym_join] = ACTIONS(4576),
    [anon_sym_on] = ACTIONS(4576),
    [anon_sym_equals] = ACTIONS(4576),
    [anon_sym_let] = ACTIONS(4576),
    [anon_sym_orderby] = ACTIONS(4576),
    [anon_sym_ascending] = ACTIONS(4576),
    [anon_sym_descending] = ACTIONS(4576),
    [anon_sym_group] = ACTIONS(4576),
    [anon_sym_by] = ACTIONS(4576),
    [anon_sym_select] = ACTIONS(4576),
    [anon_sym_as] = ACTIONS(4576),
    [anon_sym_is] = ACTIONS(4576),
    [anon_sym_DASH_GT] = ACTIONS(4578),
    [anon_sym_with] = ACTIONS(4576),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4578),
  },
  [3519] = {
    [sym_preproc_region] = STATE(3519),
    [sym_preproc_endregion] = STATE(3519),
    [sym_preproc_line] = STATE(3519),
    [sym_preproc_pragma] = STATE(3519),
    [sym_preproc_nullable] = STATE(3519),
    [sym_preproc_error] = STATE(3519),
    [sym_preproc_define] = STATE(3519),
    [sym_preproc_undef] = STATE(3519),
    [sym__identifier_token] = ACTIONS(4422),
    [anon_sym_alias] = ACTIONS(4422),
    [anon_sym_global] = ACTIONS(4422),
    [anon_sym_LBRACK] = ACTIONS(4547),
    [anon_sym_COLON] = ACTIONS(4424),
    [anon_sym_LPAREN] = ACTIONS(4424),
    [anon_sym_LBRACE] = ACTIONS(4424),
    [anon_sym_file] = ACTIONS(4422),
    [anon_sym_LT] = ACTIONS(4422),
    [anon_sym_GT] = ACTIONS(4422),
    [anon_sym_where] = ACTIONS(4422),
    [anon_sym_QMARK] = ACTIONS(4550),
    [anon_sym_notnull] = ACTIONS(4422),
    [anon_sym_unmanaged] = ACTIONS(4422),
    [anon_sym_BANG] = ACTIONS(4422),
    [anon_sym_PLUS_PLUS] = ACTIONS(4424),
    [anon_sym_DASH_DASH] = ACTIONS(4424),
    [anon_sym_PLUS] = ACTIONS(4422),
    [anon_sym_DASH] = ACTIONS(4422),
    [anon_sym_STAR] = ACTIONS(4553),
    [anon_sym_SLASH] = ACTIONS(4422),
    [anon_sym_PERCENT] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4424),
    [anon_sym_PIPE] = ACTIONS(4422),
    [anon_sym_AMP] = ACTIONS(4422),
    [anon_sym_LT_LT] = ACTIONS(4424),
    [anon_sym_GT_GT] = ACTIONS(4422),
    [anon_sym_GT_GT_GT] = ACTIONS(4424),
    [anon_sym_EQ_EQ] = ACTIONS(4424),
    [anon_sym_BANG_EQ] = ACTIONS(4424),
    [anon_sym_GT_EQ] = ACTIONS(4424),
    [anon_sym_LT_EQ] = ACTIONS(4424),
    [anon_sym_DOT] = ACTIONS(5159),
    [anon_sym_scoped] = ACTIONS(4422),
    [anon_sym_var] = ACTIONS(4422),
    [anon_sym_yield] = ACTIONS(4422),
    [anon_sym_switch] = ACTIONS(4422),
    [anon_sym_when] = ACTIONS(4422),
    [sym_discard] = ACTIONS(4422),
    [anon_sym_DOT_DOT] = ACTIONS(4424),
    [anon_sym_and] = ACTIONS(4422),
    [anon_sym_or] = ACTIONS(4422),
    [anon_sym_AMP_AMP] = ACTIONS(4424),
    [anon_sym_PIPE_PIPE] = ACTIONS(4424),
    [anon_sym_QMARK_QMARK] = ACTIONS(4424),
    [anon_sym_from] = ACTIONS(4422),
    [anon_sym_into] = ACTIONS(4422),
    [anon_sym_join] = ACTIONS(4422),
    [anon_sym_on] = ACTIONS(4422),
    [anon_sym_equals] = ACTIONS(4422),
    [anon_sym_let] = ACTIONS(4422),
    [anon_sym_orderby] = ACTIONS(4422),
    [anon_sym_ascending] = ACTIONS(4422),
    [anon_sym_descending] = ACTIONS(4422),
    [anon_sym_group] = ACTIONS(4422),
    [anon_sym_by] = ACTIONS(4422),
    [anon_sym_select] = ACTIONS(4422),
    [anon_sym_as] = ACTIONS(4422),
    [anon_sym_is] = ACTIONS(4422),
    [anon_sym_DASH_GT] = ACTIONS(4558),
    [anon_sym_with] = ACTIONS(4422),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3520] = {
    [sym_preproc_region] = STATE(3520),
    [sym_preproc_endregion] = STATE(3520),
    [sym_preproc_line] = STATE(3520),
    [sym_preproc_pragma] = STATE(3520),
    [sym_preproc_nullable] = STATE(3520),
    [sym_preproc_error] = STATE(3520),
    [sym_preproc_define] = STATE(3520),
    [sym_preproc_undef] = STATE(3520),
    [sym__identifier_token] = ACTIONS(4422),
    [anon_sym_alias] = ACTIONS(4422),
    [anon_sym_global] = ACTIONS(4422),
    [anon_sym_LBRACK] = ACTIONS(4547),
    [anon_sym_COLON] = ACTIONS(4424),
    [anon_sym_LPAREN] = ACTIONS(4424),
    [anon_sym_LBRACE] = ACTIONS(4424),
    [anon_sym_file] = ACTIONS(4422),
    [anon_sym_LT] = ACTIONS(4422),
    [anon_sym_GT] = ACTIONS(4422),
    [anon_sym_where] = ACTIONS(4422),
    [anon_sym_QMARK] = ACTIONS(4550),
    [anon_sym_notnull] = ACTIONS(4422),
    [anon_sym_unmanaged] = ACTIONS(4422),
    [anon_sym_BANG] = ACTIONS(4422),
    [anon_sym_PLUS_PLUS] = ACTIONS(4424),
    [anon_sym_DASH_DASH] = ACTIONS(4424),
    [anon_sym_PLUS] = ACTIONS(4422),
    [anon_sym_DASH] = ACTIONS(4422),
    [anon_sym_STAR] = ACTIONS(4553),
    [anon_sym_SLASH] = ACTIONS(4422),
    [anon_sym_PERCENT] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4424),
    [anon_sym_PIPE] = ACTIONS(4422),
    [anon_sym_AMP] = ACTIONS(4422),
    [anon_sym_LT_LT] = ACTIONS(4424),
    [anon_sym_GT_GT] = ACTIONS(4422),
    [anon_sym_GT_GT_GT] = ACTIONS(4424),
    [anon_sym_EQ_EQ] = ACTIONS(4424),
    [anon_sym_BANG_EQ] = ACTIONS(4424),
    [anon_sym_GT_EQ] = ACTIONS(4424),
    [anon_sym_LT_EQ] = ACTIONS(4424),
    [anon_sym_DOT] = ACTIONS(5161),
    [anon_sym_scoped] = ACTIONS(4422),
    [anon_sym_var] = ACTIONS(4422),
    [anon_sym_yield] = ACTIONS(4422),
    [anon_sym_switch] = ACTIONS(4422),
    [anon_sym_when] = ACTIONS(4422),
    [sym_discard] = ACTIONS(4422),
    [anon_sym_DOT_DOT] = ACTIONS(4424),
    [anon_sym_and] = ACTIONS(4422),
    [anon_sym_or] = ACTIONS(4422),
    [anon_sym_AMP_AMP] = ACTIONS(4424),
    [anon_sym_PIPE_PIPE] = ACTIONS(4424),
    [anon_sym_QMARK_QMARK] = ACTIONS(4424),
    [anon_sym_from] = ACTIONS(4422),
    [anon_sym_into] = ACTIONS(4422),
    [anon_sym_join] = ACTIONS(4422),
    [anon_sym_on] = ACTIONS(4422),
    [anon_sym_equals] = ACTIONS(4422),
    [anon_sym_let] = ACTIONS(4422),
    [anon_sym_orderby] = ACTIONS(4422),
    [anon_sym_ascending] = ACTIONS(4422),
    [anon_sym_descending] = ACTIONS(4422),
    [anon_sym_group] = ACTIONS(4422),
    [anon_sym_by] = ACTIONS(4422),
    [anon_sym_select] = ACTIONS(4422),
    [anon_sym_as] = ACTIONS(4422),
    [anon_sym_is] = ACTIONS(4422),
    [anon_sym_DASH_GT] = ACTIONS(4562),
    [anon_sym_with] = ACTIONS(4422),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3521] = {
    [sym_preproc_region] = STATE(3521),
    [sym_preproc_endregion] = STATE(3521),
    [sym_preproc_line] = STATE(3521),
    [sym_preproc_pragma] = STATE(3521),
    [sym_preproc_nullable] = STATE(3521),
    [sym_preproc_error] = STATE(3521),
    [sym_preproc_define] = STATE(3521),
    [sym_preproc_undef] = STATE(3521),
    [sym__identifier_token] = ACTIONS(4422),
    [anon_sym_alias] = ACTIONS(4422),
    [anon_sym_global] = ACTIONS(4422),
    [anon_sym_LBRACK] = ACTIONS(4547),
    [anon_sym_LPAREN] = ACTIONS(4424),
    [anon_sym_LBRACE] = ACTIONS(4424),
    [anon_sym_file] = ACTIONS(4422),
    [anon_sym_LT] = ACTIONS(4422),
    [anon_sym_GT] = ACTIONS(4422),
    [anon_sym_where] = ACTIONS(4422),
    [anon_sym_QMARK] = ACTIONS(4550),
    [anon_sym_notnull] = ACTIONS(4422),
    [anon_sym_unmanaged] = ACTIONS(4422),
    [anon_sym_BANG] = ACTIONS(4422),
    [anon_sym_PLUS_PLUS] = ACTIONS(4424),
    [anon_sym_DASH_DASH] = ACTIONS(4424),
    [anon_sym_PLUS] = ACTIONS(4422),
    [anon_sym_DASH] = ACTIONS(4422),
    [anon_sym_STAR] = ACTIONS(4553),
    [anon_sym_SLASH] = ACTIONS(4422),
    [anon_sym_PERCENT] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4424),
    [anon_sym_PIPE] = ACTIONS(4422),
    [anon_sym_AMP] = ACTIONS(4422),
    [anon_sym_LT_LT] = ACTIONS(4424),
    [anon_sym_GT_GT] = ACTIONS(4422),
    [anon_sym_GT_GT_GT] = ACTIONS(4424),
    [anon_sym_EQ_EQ] = ACTIONS(4424),
    [anon_sym_BANG_EQ] = ACTIONS(4424),
    [anon_sym_GT_EQ] = ACTIONS(4424),
    [anon_sym_LT_EQ] = ACTIONS(4424),
    [anon_sym_DOT] = ACTIONS(5163),
    [anon_sym_scoped] = ACTIONS(4422),
    [anon_sym_EQ_GT] = ACTIONS(4424),
    [anon_sym_var] = ACTIONS(4422),
    [anon_sym_yield] = ACTIONS(4422),
    [anon_sym_switch] = ACTIONS(4422),
    [anon_sym_when] = ACTIONS(4422),
    [sym_discard] = ACTIONS(4422),
    [anon_sym_DOT_DOT] = ACTIONS(4424),
    [anon_sym_and] = ACTIONS(4422),
    [anon_sym_or] = ACTIONS(4422),
    [anon_sym_AMP_AMP] = ACTIONS(4424),
    [anon_sym_PIPE_PIPE] = ACTIONS(4424),
    [anon_sym_QMARK_QMARK] = ACTIONS(4424),
    [anon_sym_from] = ACTIONS(4422),
    [anon_sym_into] = ACTIONS(4422),
    [anon_sym_join] = ACTIONS(4422),
    [anon_sym_on] = ACTIONS(4422),
    [anon_sym_equals] = ACTIONS(4422),
    [anon_sym_let] = ACTIONS(4422),
    [anon_sym_orderby] = ACTIONS(4422),
    [anon_sym_ascending] = ACTIONS(4422),
    [anon_sym_descending] = ACTIONS(4422),
    [anon_sym_group] = ACTIONS(4422),
    [anon_sym_by] = ACTIONS(4422),
    [anon_sym_select] = ACTIONS(4422),
    [anon_sym_as] = ACTIONS(4422),
    [anon_sym_is] = ACTIONS(4422),
    [anon_sym_DASH_GT] = ACTIONS(4558),
    [anon_sym_with] = ACTIONS(4422),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3522] = {
    [sym_preproc_region] = STATE(3522),
    [sym_preproc_endregion] = STATE(3522),
    [sym_preproc_line] = STATE(3522),
    [sym_preproc_pragma] = STATE(3522),
    [sym_preproc_nullable] = STATE(3522),
    [sym_preproc_error] = STATE(3522),
    [sym_preproc_define] = STATE(3522),
    [sym_preproc_undef] = STATE(3522),
    [sym__identifier_token] = ACTIONS(4422),
    [anon_sym_alias] = ACTIONS(4422),
    [anon_sym_global] = ACTIONS(4422),
    [anon_sym_LBRACK] = ACTIONS(4547),
    [anon_sym_COMMA] = ACTIONS(4424),
    [anon_sym_LPAREN] = ACTIONS(4424),
    [anon_sym_LBRACE] = ACTIONS(4424),
    [anon_sym_file] = ACTIONS(4422),
    [anon_sym_LT] = ACTIONS(4422),
    [anon_sym_GT] = ACTIONS(4422),
    [anon_sym_where] = ACTIONS(4422),
    [anon_sym_QMARK] = ACTIONS(4550),
    [anon_sym_notnull] = ACTIONS(4422),
    [anon_sym_unmanaged] = ACTIONS(4422),
    [anon_sym_BANG] = ACTIONS(4422),
    [anon_sym_PLUS_PLUS] = ACTIONS(4424),
    [anon_sym_DASH_DASH] = ACTIONS(4424),
    [anon_sym_PLUS] = ACTIONS(4422),
    [anon_sym_DASH] = ACTIONS(4422),
    [anon_sym_STAR] = ACTIONS(4553),
    [anon_sym_SLASH] = ACTIONS(4422),
    [anon_sym_PERCENT] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4424),
    [anon_sym_PIPE] = ACTIONS(4422),
    [anon_sym_AMP] = ACTIONS(4422),
    [anon_sym_LT_LT] = ACTIONS(4424),
    [anon_sym_GT_GT] = ACTIONS(4422),
    [anon_sym_GT_GT_GT] = ACTIONS(4424),
    [anon_sym_EQ_EQ] = ACTIONS(4424),
    [anon_sym_BANG_EQ] = ACTIONS(4424),
    [anon_sym_GT_EQ] = ACTIONS(4424),
    [anon_sym_LT_EQ] = ACTIONS(4424),
    [anon_sym_DOT] = ACTIONS(5165),
    [anon_sym_scoped] = ACTIONS(4422),
    [anon_sym_var] = ACTIONS(4422),
    [anon_sym_yield] = ACTIONS(4422),
    [anon_sym_switch] = ACTIONS(4422),
    [anon_sym_when] = ACTIONS(4422),
    [sym_discard] = ACTIONS(4422),
    [anon_sym_DOT_DOT] = ACTIONS(4424),
    [anon_sym_and] = ACTIONS(4422),
    [anon_sym_or] = ACTIONS(4422),
    [anon_sym_AMP_AMP] = ACTIONS(4424),
    [anon_sym_PIPE_PIPE] = ACTIONS(4424),
    [anon_sym_QMARK_QMARK] = ACTIONS(4424),
    [anon_sym_from] = ACTIONS(4422),
    [anon_sym_into] = ACTIONS(4422),
    [anon_sym_join] = ACTIONS(4422),
    [anon_sym_on] = ACTIONS(4422),
    [anon_sym_equals] = ACTIONS(4422),
    [anon_sym_let] = ACTIONS(4422),
    [anon_sym_orderby] = ACTIONS(4422),
    [anon_sym_ascending] = ACTIONS(4422),
    [anon_sym_descending] = ACTIONS(4422),
    [anon_sym_group] = ACTIONS(4422),
    [anon_sym_by] = ACTIONS(4422),
    [anon_sym_select] = ACTIONS(4422),
    [anon_sym_as] = ACTIONS(4422),
    [anon_sym_is] = ACTIONS(4422),
    [anon_sym_DASH_GT] = ACTIONS(5167),
    [anon_sym_with] = ACTIONS(4422),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3523] = {
    [sym_preproc_region] = STATE(3523),
    [sym_preproc_endregion] = STATE(3523),
    [sym_preproc_line] = STATE(3523),
    [sym_preproc_pragma] = STATE(3523),
    [sym_preproc_nullable] = STATE(3523),
    [sym_preproc_error] = STATE(3523),
    [sym_preproc_define] = STATE(3523),
    [sym_preproc_undef] = STATE(3523),
    [sym__identifier_token] = ACTIONS(4422),
    [anon_sym_alias] = ACTIONS(4422),
    [anon_sym_global] = ACTIONS(4422),
    [anon_sym_LBRACK] = ACTIONS(4547),
    [anon_sym_LPAREN] = ACTIONS(4424),
    [anon_sym_LBRACE] = ACTIONS(4424),
    [anon_sym_file] = ACTIONS(4422),
    [anon_sym_LT] = ACTIONS(4422),
    [anon_sym_GT] = ACTIONS(4422),
    [anon_sym_where] = ACTIONS(4422),
    [anon_sym_QMARK] = ACTIONS(4550),
    [anon_sym_notnull] = ACTIONS(4422),
    [anon_sym_unmanaged] = ACTIONS(4422),
    [anon_sym_BANG] = ACTIONS(4422),
    [anon_sym_PLUS_PLUS] = ACTIONS(4424),
    [anon_sym_DASH_DASH] = ACTIONS(4424),
    [anon_sym_PLUS] = ACTIONS(4422),
    [anon_sym_DASH] = ACTIONS(4422),
    [anon_sym_STAR] = ACTIONS(4553),
    [anon_sym_SLASH] = ACTIONS(4422),
    [anon_sym_PERCENT] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4424),
    [anon_sym_PIPE] = ACTIONS(4422),
    [anon_sym_AMP] = ACTIONS(4422),
    [anon_sym_LT_LT] = ACTIONS(4424),
    [anon_sym_GT_GT] = ACTIONS(4422),
    [anon_sym_GT_GT_GT] = ACTIONS(4424),
    [anon_sym_EQ_EQ] = ACTIONS(4424),
    [anon_sym_BANG_EQ] = ACTIONS(4424),
    [anon_sym_GT_EQ] = ACTIONS(4424),
    [anon_sym_LT_EQ] = ACTIONS(4424),
    [anon_sym_DOT] = ACTIONS(5169),
    [anon_sym_scoped] = ACTIONS(4422),
    [anon_sym_EQ_GT] = ACTIONS(4424),
    [anon_sym_var] = ACTIONS(4422),
    [anon_sym_yield] = ACTIONS(4422),
    [anon_sym_switch] = ACTIONS(4422),
    [anon_sym_when] = ACTIONS(4422),
    [sym_discard] = ACTIONS(4422),
    [anon_sym_DOT_DOT] = ACTIONS(4424),
    [anon_sym_and] = ACTIONS(4422),
    [anon_sym_or] = ACTIONS(4422),
    [anon_sym_AMP_AMP] = ACTIONS(4424),
    [anon_sym_PIPE_PIPE] = ACTIONS(4424),
    [anon_sym_QMARK_QMARK] = ACTIONS(4424),
    [anon_sym_from] = ACTIONS(4422),
    [anon_sym_into] = ACTIONS(4422),
    [anon_sym_join] = ACTIONS(4422),
    [anon_sym_on] = ACTIONS(4422),
    [anon_sym_equals] = ACTIONS(4422),
    [anon_sym_let] = ACTIONS(4422),
    [anon_sym_orderby] = ACTIONS(4422),
    [anon_sym_ascending] = ACTIONS(4422),
    [anon_sym_descending] = ACTIONS(4422),
    [anon_sym_group] = ACTIONS(4422),
    [anon_sym_by] = ACTIONS(4422),
    [anon_sym_select] = ACTIONS(4422),
    [anon_sym_as] = ACTIONS(4422),
    [anon_sym_is] = ACTIONS(4422),
    [anon_sym_DASH_GT] = ACTIONS(4562),
    [anon_sym_with] = ACTIONS(4422),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3524] = {
    [sym_preproc_region] = STATE(3524),
    [sym_preproc_endregion] = STATE(3524),
    [sym_preproc_line] = STATE(3524),
    [sym_preproc_pragma] = STATE(3524),
    [sym_preproc_nullable] = STATE(3524),
    [sym_preproc_error] = STATE(3524),
    [sym_preproc_define] = STATE(3524),
    [sym_preproc_undef] = STATE(3524),
    [sym__identifier_token] = ACTIONS(4422),
    [anon_sym_alias] = ACTIONS(4422),
    [anon_sym_global] = ACTIONS(4422),
    [anon_sym_LBRACK] = ACTIONS(4547),
    [anon_sym_COMMA] = ACTIONS(4424),
    [anon_sym_LPAREN] = ACTIONS(4424),
    [anon_sym_LBRACE] = ACTIONS(4424),
    [anon_sym_file] = ACTIONS(4422),
    [anon_sym_LT] = ACTIONS(4422),
    [anon_sym_GT] = ACTIONS(4422),
    [anon_sym_where] = ACTIONS(4422),
    [anon_sym_QMARK] = ACTIONS(4550),
    [anon_sym_notnull] = ACTIONS(4422),
    [anon_sym_unmanaged] = ACTIONS(4422),
    [anon_sym_BANG] = ACTIONS(4422),
    [anon_sym_PLUS_PLUS] = ACTIONS(4424),
    [anon_sym_DASH_DASH] = ACTIONS(4424),
    [anon_sym_PLUS] = ACTIONS(4422),
    [anon_sym_DASH] = ACTIONS(4422),
    [anon_sym_STAR] = ACTIONS(4553),
    [anon_sym_SLASH] = ACTIONS(4422),
    [anon_sym_PERCENT] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4424),
    [anon_sym_PIPE] = ACTIONS(4422),
    [anon_sym_AMP] = ACTIONS(4422),
    [anon_sym_LT_LT] = ACTIONS(4424),
    [anon_sym_GT_GT] = ACTIONS(4422),
    [anon_sym_GT_GT_GT] = ACTIONS(4424),
    [anon_sym_EQ_EQ] = ACTIONS(4424),
    [anon_sym_BANG_EQ] = ACTIONS(4424),
    [anon_sym_GT_EQ] = ACTIONS(4424),
    [anon_sym_LT_EQ] = ACTIONS(4424),
    [anon_sym_DOT] = ACTIONS(5171),
    [anon_sym_scoped] = ACTIONS(4422),
    [anon_sym_var] = ACTIONS(4422),
    [anon_sym_yield] = ACTIONS(4422),
    [anon_sym_switch] = ACTIONS(4422),
    [anon_sym_when] = ACTIONS(4422),
    [sym_discard] = ACTIONS(4422),
    [anon_sym_DOT_DOT] = ACTIONS(4424),
    [anon_sym_and] = ACTIONS(4422),
    [anon_sym_or] = ACTIONS(4422),
    [anon_sym_AMP_AMP] = ACTIONS(4424),
    [anon_sym_PIPE_PIPE] = ACTIONS(4424),
    [anon_sym_QMARK_QMARK] = ACTIONS(4424),
    [anon_sym_from] = ACTIONS(4422),
    [anon_sym_into] = ACTIONS(4422),
    [anon_sym_join] = ACTIONS(4422),
    [anon_sym_on] = ACTIONS(4422),
    [anon_sym_equals] = ACTIONS(4422),
    [anon_sym_let] = ACTIONS(4422),
    [anon_sym_orderby] = ACTIONS(4422),
    [anon_sym_ascending] = ACTIONS(4422),
    [anon_sym_descending] = ACTIONS(4422),
    [anon_sym_group] = ACTIONS(4422),
    [anon_sym_by] = ACTIONS(4422),
    [anon_sym_select] = ACTIONS(4422),
    [anon_sym_as] = ACTIONS(4422),
    [anon_sym_is] = ACTIONS(4422),
    [anon_sym_DASH_GT] = ACTIONS(5167),
    [anon_sym_with] = ACTIONS(4422),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3525] = {
    [sym_preproc_region] = STATE(3525),
    [sym_preproc_endregion] = STATE(3525),
    [sym_preproc_line] = STATE(3525),
    [sym_preproc_pragma] = STATE(3525),
    [sym_preproc_nullable] = STATE(3525),
    [sym_preproc_error] = STATE(3525),
    [sym_preproc_define] = STATE(3525),
    [sym_preproc_undef] = STATE(3525),
    [sym__identifier_token] = ACTIONS(4422),
    [anon_sym_alias] = ACTIONS(4422),
    [anon_sym_global] = ACTIONS(4422),
    [anon_sym_LBRACK] = ACTIONS(4547),
    [anon_sym_COMMA] = ACTIONS(4424),
    [anon_sym_LPAREN] = ACTIONS(4424),
    [anon_sym_LBRACE] = ACTIONS(4424),
    [anon_sym_file] = ACTIONS(4422),
    [anon_sym_LT] = ACTIONS(4422),
    [anon_sym_GT] = ACTIONS(4422),
    [anon_sym_where] = ACTIONS(4422),
    [anon_sym_QMARK] = ACTIONS(4550),
    [anon_sym_notnull] = ACTIONS(4422),
    [anon_sym_unmanaged] = ACTIONS(4422),
    [anon_sym_BANG] = ACTIONS(4422),
    [anon_sym_PLUS_PLUS] = ACTIONS(4424),
    [anon_sym_DASH_DASH] = ACTIONS(4424),
    [anon_sym_PLUS] = ACTIONS(4422),
    [anon_sym_DASH] = ACTIONS(4422),
    [anon_sym_STAR] = ACTIONS(4553),
    [anon_sym_SLASH] = ACTIONS(4422),
    [anon_sym_PERCENT] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4424),
    [anon_sym_PIPE] = ACTIONS(4422),
    [anon_sym_AMP] = ACTIONS(4422),
    [anon_sym_LT_LT] = ACTIONS(4424),
    [anon_sym_GT_GT] = ACTIONS(4422),
    [anon_sym_GT_GT_GT] = ACTIONS(4424),
    [anon_sym_EQ_EQ] = ACTIONS(4424),
    [anon_sym_BANG_EQ] = ACTIONS(4424),
    [anon_sym_GT_EQ] = ACTIONS(4424),
    [anon_sym_LT_EQ] = ACTIONS(4424),
    [anon_sym_DOT] = ACTIONS(5173),
    [anon_sym_scoped] = ACTIONS(4422),
    [anon_sym_var] = ACTIONS(4422),
    [anon_sym_yield] = ACTIONS(4422),
    [anon_sym_switch] = ACTIONS(4422),
    [anon_sym_when] = ACTIONS(4422),
    [sym_discard] = ACTIONS(4422),
    [anon_sym_DOT_DOT] = ACTIONS(4424),
    [anon_sym_and] = ACTIONS(4422),
    [anon_sym_or] = ACTIONS(4422),
    [anon_sym_AMP_AMP] = ACTIONS(4424),
    [anon_sym_PIPE_PIPE] = ACTIONS(4424),
    [anon_sym_QMARK_QMARK] = ACTIONS(4424),
    [anon_sym_from] = ACTIONS(4422),
    [anon_sym_into] = ACTIONS(4422),
    [anon_sym_join] = ACTIONS(4422),
    [anon_sym_on] = ACTIONS(4422),
    [anon_sym_equals] = ACTIONS(4422),
    [anon_sym_let] = ACTIONS(4422),
    [anon_sym_orderby] = ACTIONS(4422),
    [anon_sym_ascending] = ACTIONS(4422),
    [anon_sym_descending] = ACTIONS(4422),
    [anon_sym_group] = ACTIONS(4422),
    [anon_sym_by] = ACTIONS(4422),
    [anon_sym_select] = ACTIONS(4422),
    [anon_sym_as] = ACTIONS(4422),
    [anon_sym_is] = ACTIONS(4422),
    [anon_sym_DASH_GT] = ACTIONS(5167),
    [anon_sym_with] = ACTIONS(4422),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3526] = {
    [sym_preproc_region] = STATE(3526),
    [sym_preproc_endregion] = STATE(3526),
    [sym_preproc_line] = STATE(3526),
    [sym_preproc_pragma] = STATE(3526),
    [sym_preproc_nullable] = STATE(3526),
    [sym_preproc_error] = STATE(3526),
    [sym_preproc_define] = STATE(3526),
    [sym_preproc_undef] = STATE(3526),
    [sym__identifier_token] = ACTIONS(4496),
    [anon_sym_alias] = ACTIONS(4496),
    [anon_sym_global] = ACTIONS(4496),
    [anon_sym_LBRACK] = ACTIONS(4498),
    [anon_sym_LPAREN] = ACTIONS(4498),
    [anon_sym_LBRACE] = ACTIONS(4498),
    [anon_sym_file] = ACTIONS(4496),
    [anon_sym_LT] = ACTIONS(4496),
    [anon_sym_GT] = ACTIONS(4496),
    [anon_sym_where] = ACTIONS(4496),
    [anon_sym_QMARK] = ACTIONS(4496),
    [anon_sym_notnull] = ACTIONS(4496),
    [anon_sym_unmanaged] = ACTIONS(4496),
    [anon_sym_BANG] = ACTIONS(4496),
    [anon_sym_PLUS_PLUS] = ACTIONS(4498),
    [anon_sym_DASH_DASH] = ACTIONS(4498),
    [anon_sym_PLUS] = ACTIONS(4496),
    [anon_sym_DASH] = ACTIONS(4496),
    [anon_sym_STAR] = ACTIONS(4498),
    [anon_sym_SLASH] = ACTIONS(4496),
    [anon_sym_PERCENT] = ACTIONS(4498),
    [anon_sym_CARET] = ACTIONS(4498),
    [anon_sym_PIPE] = ACTIONS(4496),
    [anon_sym_AMP] = ACTIONS(4496),
    [anon_sym_LT_LT] = ACTIONS(4498),
    [anon_sym_GT_GT] = ACTIONS(4496),
    [anon_sym_GT_GT_GT] = ACTIONS(4498),
    [anon_sym_EQ_EQ] = ACTIONS(4498),
    [anon_sym_BANG_EQ] = ACTIONS(4498),
    [anon_sym_GT_EQ] = ACTIONS(4498),
    [anon_sym_LT_EQ] = ACTIONS(4498),
    [anon_sym_DOT] = ACTIONS(4496),
    [anon_sym_scoped] = ACTIONS(4496),
    [anon_sym_EQ_GT] = ACTIONS(4498),
    [anon_sym_var] = ACTIONS(4496),
    [anon_sym_yield] = ACTIONS(4496),
    [anon_sym_switch] = ACTIONS(4496),
    [anon_sym_when] = ACTIONS(4496),
    [sym_discard] = ACTIONS(4496),
    [anon_sym_DOT_DOT] = ACTIONS(4498),
    [anon_sym_and] = ACTIONS(4496),
    [anon_sym_or] = ACTIONS(4496),
    [anon_sym_AMP_AMP] = ACTIONS(4498),
    [anon_sym_PIPE_PIPE] = ACTIONS(4498),
    [anon_sym_QMARK_QMARK] = ACTIONS(4498),
    [anon_sym_from] = ACTIONS(4496),
    [anon_sym_into] = ACTIONS(4496),
    [anon_sym_join] = ACTIONS(4496),
    [anon_sym_on] = ACTIONS(4496),
    [anon_sym_equals] = ACTIONS(4496),
    [anon_sym_let] = ACTIONS(4496),
    [anon_sym_orderby] = ACTIONS(4496),
    [anon_sym_ascending] = ACTIONS(4496),
    [anon_sym_descending] = ACTIONS(4496),
    [anon_sym_group] = ACTIONS(4496),
    [anon_sym_by] = ACTIONS(4496),
    [anon_sym_select] = ACTIONS(4496),
    [anon_sym_as] = ACTIONS(4496),
    [anon_sym_is] = ACTIONS(4496),
    [anon_sym_DASH_GT] = ACTIONS(4498),
    [anon_sym_with] = ACTIONS(4496),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3527] = {
    [sym_preproc_region] = STATE(3527),
    [sym_preproc_endregion] = STATE(3527),
    [sym_preproc_line] = STATE(3527),
    [sym_preproc_pragma] = STATE(3527),
    [sym_preproc_nullable] = STATE(3527),
    [sym_preproc_error] = STATE(3527),
    [sym_preproc_define] = STATE(3527),
    [sym_preproc_undef] = STATE(3527),
    [sym__identifier_token] = ACTIONS(4496),
    [anon_sym_alias] = ACTIONS(4496),
    [anon_sym_global] = ACTIONS(4496),
    [anon_sym_LBRACK] = ACTIONS(4498),
    [anon_sym_LPAREN] = ACTIONS(4498),
    [anon_sym_LBRACE] = ACTIONS(4498),
    [anon_sym_file] = ACTIONS(4496),
    [anon_sym_LT] = ACTIONS(4496),
    [anon_sym_GT] = ACTIONS(4496),
    [anon_sym_where] = ACTIONS(4496),
    [anon_sym_QMARK] = ACTIONS(4496),
    [anon_sym_notnull] = ACTIONS(4496),
    [anon_sym_unmanaged] = ACTIONS(4496),
    [anon_sym_BANG] = ACTIONS(4496),
    [anon_sym_PLUS_PLUS] = ACTIONS(4498),
    [anon_sym_DASH_DASH] = ACTIONS(4498),
    [anon_sym_PLUS] = ACTIONS(4496),
    [anon_sym_DASH] = ACTIONS(4496),
    [anon_sym_STAR] = ACTIONS(4498),
    [anon_sym_SLASH] = ACTIONS(4496),
    [anon_sym_PERCENT] = ACTIONS(4498),
    [anon_sym_CARET] = ACTIONS(4498),
    [anon_sym_PIPE] = ACTIONS(4496),
    [anon_sym_AMP] = ACTIONS(4496),
    [anon_sym_LT_LT] = ACTIONS(4498),
    [anon_sym_GT_GT] = ACTIONS(4496),
    [anon_sym_GT_GT_GT] = ACTIONS(4498),
    [anon_sym_EQ_EQ] = ACTIONS(4498),
    [anon_sym_BANG_EQ] = ACTIONS(4498),
    [anon_sym_GT_EQ] = ACTIONS(4498),
    [anon_sym_LT_EQ] = ACTIONS(4498),
    [anon_sym_DOT] = ACTIONS(4496),
    [anon_sym_scoped] = ACTIONS(4496),
    [anon_sym_EQ_GT] = ACTIONS(4498),
    [anon_sym_var] = ACTIONS(4496),
    [anon_sym_yield] = ACTIONS(4496),
    [anon_sym_switch] = ACTIONS(4496),
    [anon_sym_when] = ACTIONS(4496),
    [sym_discard] = ACTIONS(4496),
    [anon_sym_DOT_DOT] = ACTIONS(4498),
    [anon_sym_and] = ACTIONS(4496),
    [anon_sym_or] = ACTIONS(4496),
    [anon_sym_AMP_AMP] = ACTIONS(4498),
    [anon_sym_PIPE_PIPE] = ACTIONS(4498),
    [anon_sym_QMARK_QMARK] = ACTIONS(4498),
    [anon_sym_from] = ACTIONS(4496),
    [anon_sym_into] = ACTIONS(4496),
    [anon_sym_join] = ACTIONS(4496),
    [anon_sym_on] = ACTIONS(4496),
    [anon_sym_equals] = ACTIONS(4496),
    [anon_sym_let] = ACTIONS(4496),
    [anon_sym_orderby] = ACTIONS(4496),
    [anon_sym_ascending] = ACTIONS(4496),
    [anon_sym_descending] = ACTIONS(4496),
    [anon_sym_group] = ACTIONS(4496),
    [anon_sym_by] = ACTIONS(4496),
    [anon_sym_select] = ACTIONS(4496),
    [anon_sym_as] = ACTIONS(4496),
    [anon_sym_is] = ACTIONS(4496),
    [anon_sym_DASH_GT] = ACTIONS(4498),
    [anon_sym_with] = ACTIONS(4496),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3528] = {
    [sym_preproc_region] = STATE(3528),
    [sym_preproc_endregion] = STATE(3528),
    [sym_preproc_line] = STATE(3528),
    [sym_preproc_pragma] = STATE(3528),
    [sym_preproc_nullable] = STATE(3528),
    [sym_preproc_error] = STATE(3528),
    [sym_preproc_define] = STATE(3528),
    [sym_preproc_undef] = STATE(3528),
    [anon_sym_SEMI] = ACTIONS(2923),
    [anon_sym_LBRACK] = ACTIONS(2923),
    [anon_sym_COLON] = ACTIONS(2923),
    [anon_sym_COMMA] = ACTIONS(2923),
    [anon_sym_RBRACK] = ACTIONS(2923),
    [anon_sym_LPAREN] = ACTIONS(2923),
    [anon_sym_RPAREN] = ACTIONS(2923),
    [anon_sym_RBRACE] = ACTIONS(2923),
    [anon_sym_LT] = ACTIONS(2921),
    [anon_sym_GT] = ACTIONS(2921),
    [anon_sym_in] = ACTIONS(2923),
    [anon_sym_where] = ACTIONS(2923),
    [anon_sym_QMARK] = ACTIONS(2921),
    [anon_sym_BANG] = ACTIONS(2921),
    [anon_sym_PLUS_PLUS] = ACTIONS(2923),
    [anon_sym_DASH_DASH] = ACTIONS(2923),
    [anon_sym_PLUS] = ACTIONS(2921),
    [anon_sym_DASH] = ACTIONS(2921),
    [anon_sym_STAR] = ACTIONS(2923),
    [anon_sym_SLASH] = ACTIONS(2921),
    [anon_sym_PERCENT] = ACTIONS(2923),
    [anon_sym_CARET] = ACTIONS(2923),
    [anon_sym_PIPE] = ACTIONS(2921),
    [anon_sym_AMP] = ACTIONS(2921),
    [anon_sym_LT_LT] = ACTIONS(2923),
    [anon_sym_GT_GT] = ACTIONS(2921),
    [anon_sym_GT_GT_GT] = ACTIONS(2923),
    [anon_sym_EQ_EQ] = ACTIONS(2923),
    [anon_sym_BANG_EQ] = ACTIONS(2923),
    [anon_sym_GT_EQ] = ACTIONS(2923),
    [anon_sym_LT_EQ] = ACTIONS(2923),
    [anon_sym_DOT] = ACTIONS(2921),
    [anon_sym_EQ_GT] = ACTIONS(2923),
    [anon_sym_while] = ACTIONS(2923),
    [anon_sym_switch] = ACTIONS(2923),
    [anon_sym_catch] = ACTIONS(2923),
    [anon_sym_finally] = ACTIONS(2923),
    [anon_sym_else] = ACTIONS(2923),
    [anon_sym_DOT_DOT] = ACTIONS(2923),
    [anon_sym_and] = ACTIONS(2923),
    [anon_sym_or] = ACTIONS(2921),
    [anon_sym_AMP_AMP] = ACTIONS(2923),
    [anon_sym_PIPE_PIPE] = ACTIONS(2923),
    [anon_sym_QMARK_QMARK] = ACTIONS(2923),
    [anon_sym_from] = ACTIONS(2923),
    [anon_sym_join] = ACTIONS(2923),
    [anon_sym_on] = ACTIONS(2923),
    [anon_sym_equals] = ACTIONS(2923),
    [anon_sym_let] = ACTIONS(2923),
    [anon_sym_orderby] = ACTIONS(2923),
    [anon_sym_group] = ACTIONS(2923),
    [anon_sym_by] = ACTIONS(2923),
    [anon_sym_select] = ACTIONS(2923),
    [anon_sym_as] = ACTIONS(2923),
    [anon_sym_is] = ACTIONS(2923),
    [anon_sym_DASH_GT] = ACTIONS(2923),
    [anon_sym_with] = ACTIONS(2923),
    [aux_sym_preproc_if_token3] = ACTIONS(2923),
    [aux_sym_preproc_else_token1] = ACTIONS(2923),
    [aux_sym_preproc_elif_token1] = ACTIONS(2923),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3529] = {
    [sym_preproc_region] = STATE(3529),
    [sym_preproc_endregion] = STATE(3529),
    [sym_preproc_line] = STATE(3529),
    [sym_preproc_pragma] = STATE(3529),
    [sym_preproc_nullable] = STATE(3529),
    [sym_preproc_error] = STATE(3529),
    [sym_preproc_define] = STATE(3529),
    [sym_preproc_undef] = STATE(3529),
    [anon_sym_EQ] = ACTIONS(4617),
    [anon_sym_LBRACK] = ACTIONS(4615),
    [anon_sym_COLON] = ACTIONS(4615),
    [anon_sym_COMMA] = ACTIONS(4615),
    [anon_sym_LPAREN] = ACTIONS(4615),
    [anon_sym_LT] = ACTIONS(4617),
    [anon_sym_GT] = ACTIONS(4617),
    [anon_sym_where] = ACTIONS(4615),
    [anon_sym_QMARK] = ACTIONS(4617),
    [anon_sym_BANG] = ACTIONS(4617),
    [anon_sym_PLUS_PLUS] = ACTIONS(4615),
    [anon_sym_DASH_DASH] = ACTIONS(4615),
    [anon_sym_PLUS] = ACTIONS(4617),
    [anon_sym_DASH] = ACTIONS(4617),
    [anon_sym_STAR] = ACTIONS(4617),
    [anon_sym_SLASH] = ACTIONS(4617),
    [anon_sym_PERCENT] = ACTIONS(4617),
    [anon_sym_CARET] = ACTIONS(4617),
    [anon_sym_PIPE] = ACTIONS(4617),
    [anon_sym_AMP] = ACTIONS(4617),
    [anon_sym_LT_LT] = ACTIONS(4617),
    [anon_sym_GT_GT] = ACTIONS(4617),
    [anon_sym_GT_GT_GT] = ACTIONS(4617),
    [anon_sym_EQ_EQ] = ACTIONS(4615),
    [anon_sym_BANG_EQ] = ACTIONS(4615),
    [anon_sym_GT_EQ] = ACTIONS(4615),
    [anon_sym_LT_EQ] = ACTIONS(4615),
    [anon_sym_DOT] = ACTIONS(4617),
    [anon_sym_switch] = ACTIONS(4615),
    [anon_sym_DOT_DOT] = ACTIONS(4615),
    [anon_sym_and] = ACTIONS(4615),
    [anon_sym_or] = ACTIONS(4617),
    [anon_sym_PLUS_EQ] = ACTIONS(4615),
    [anon_sym_DASH_EQ] = ACTIONS(4615),
    [anon_sym_STAR_EQ] = ACTIONS(4615),
    [anon_sym_SLASH_EQ] = ACTIONS(4615),
    [anon_sym_PERCENT_EQ] = ACTIONS(4615),
    [anon_sym_AMP_EQ] = ACTIONS(4615),
    [anon_sym_CARET_EQ] = ACTIONS(4615),
    [anon_sym_PIPE_EQ] = ACTIONS(4615),
    [anon_sym_LT_LT_EQ] = ACTIONS(4615),
    [anon_sym_GT_GT_EQ] = ACTIONS(4615),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4615),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4615),
    [anon_sym_AMP_AMP] = ACTIONS(4615),
    [anon_sym_PIPE_PIPE] = ACTIONS(4615),
    [anon_sym_QMARK_QMARK] = ACTIONS(4617),
    [anon_sym_from] = ACTIONS(4615),
    [anon_sym_into] = ACTIONS(4615),
    [anon_sym_join] = ACTIONS(4615),
    [anon_sym_let] = ACTIONS(4615),
    [anon_sym_orderby] = ACTIONS(4615),
    [anon_sym_ascending] = ACTIONS(4615),
    [anon_sym_descending] = ACTIONS(4615),
    [anon_sym_group] = ACTIONS(4615),
    [anon_sym_select] = ACTIONS(4615),
    [anon_sym_as] = ACTIONS(4617),
    [anon_sym_is] = ACTIONS(4615),
    [anon_sym_DASH_GT] = ACTIONS(4615),
    [anon_sym_with] = ACTIONS(4615),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3530] = {
    [sym_preproc_region] = STATE(3530),
    [sym_preproc_endregion] = STATE(3530),
    [sym_preproc_line] = STATE(3530),
    [sym_preproc_pragma] = STATE(3530),
    [sym_preproc_nullable] = STATE(3530),
    [sym_preproc_error] = STATE(3530),
    [sym_preproc_define] = STATE(3530),
    [sym_preproc_undef] = STATE(3530),
    [anon_sym_SEMI] = ACTIONS(2969),
    [anon_sym_LBRACK] = ACTIONS(2969),
    [anon_sym_COLON] = ACTIONS(2969),
    [anon_sym_COMMA] = ACTIONS(2969),
    [anon_sym_RBRACK] = ACTIONS(2969),
    [anon_sym_LPAREN] = ACTIONS(2969),
    [anon_sym_RPAREN] = ACTIONS(2969),
    [anon_sym_RBRACE] = ACTIONS(2969),
    [anon_sym_LT] = ACTIONS(2967),
    [anon_sym_GT] = ACTIONS(2967),
    [anon_sym_in] = ACTIONS(2969),
    [anon_sym_where] = ACTIONS(2969),
    [anon_sym_QMARK] = ACTIONS(2967),
    [anon_sym_BANG] = ACTIONS(2967),
    [anon_sym_PLUS_PLUS] = ACTIONS(2969),
    [anon_sym_DASH_DASH] = ACTIONS(2969),
    [anon_sym_PLUS] = ACTIONS(2967),
    [anon_sym_DASH] = ACTIONS(2967),
    [anon_sym_STAR] = ACTIONS(2969),
    [anon_sym_SLASH] = ACTIONS(2967),
    [anon_sym_PERCENT] = ACTIONS(2969),
    [anon_sym_CARET] = ACTIONS(2969),
    [anon_sym_PIPE] = ACTIONS(2967),
    [anon_sym_AMP] = ACTIONS(2967),
    [anon_sym_LT_LT] = ACTIONS(2969),
    [anon_sym_GT_GT] = ACTIONS(2967),
    [anon_sym_GT_GT_GT] = ACTIONS(2969),
    [anon_sym_EQ_EQ] = ACTIONS(2969),
    [anon_sym_BANG_EQ] = ACTIONS(2969),
    [anon_sym_GT_EQ] = ACTIONS(2969),
    [anon_sym_LT_EQ] = ACTIONS(2969),
    [anon_sym_DOT] = ACTIONS(2967),
    [anon_sym_EQ_GT] = ACTIONS(2969),
    [anon_sym_while] = ACTIONS(2969),
    [anon_sym_switch] = ACTIONS(2969),
    [anon_sym_catch] = ACTIONS(2969),
    [anon_sym_finally] = ACTIONS(2969),
    [anon_sym_else] = ACTIONS(2969),
    [anon_sym_DOT_DOT] = ACTIONS(2969),
    [anon_sym_and] = ACTIONS(2969),
    [anon_sym_or] = ACTIONS(2967),
    [anon_sym_AMP_AMP] = ACTIONS(2969),
    [anon_sym_PIPE_PIPE] = ACTIONS(2969),
    [anon_sym_QMARK_QMARK] = ACTIONS(2969),
    [anon_sym_from] = ACTIONS(2969),
    [anon_sym_join] = ACTIONS(2969),
    [anon_sym_on] = ACTIONS(2969),
    [anon_sym_equals] = ACTIONS(2969),
    [anon_sym_let] = ACTIONS(2969),
    [anon_sym_orderby] = ACTIONS(2969),
    [anon_sym_group] = ACTIONS(2969),
    [anon_sym_by] = ACTIONS(2969),
    [anon_sym_select] = ACTIONS(2969),
    [anon_sym_as] = ACTIONS(2969),
    [anon_sym_is] = ACTIONS(2969),
    [anon_sym_DASH_GT] = ACTIONS(2969),
    [anon_sym_with] = ACTIONS(2969),
    [aux_sym_preproc_if_token3] = ACTIONS(2969),
    [aux_sym_preproc_else_token1] = ACTIONS(2969),
    [aux_sym_preproc_elif_token1] = ACTIONS(2969),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3531] = {
    [sym_preproc_region] = STATE(3531),
    [sym_preproc_endregion] = STATE(3531),
    [sym_preproc_line] = STATE(3531),
    [sym_preproc_pragma] = STATE(3531),
    [sym_preproc_nullable] = STATE(3531),
    [sym_preproc_error] = STATE(3531),
    [sym_preproc_define] = STATE(3531),
    [sym_preproc_undef] = STATE(3531),
    [sym__identifier_token] = ACTIONS(4422),
    [anon_sym_alias] = ACTIONS(4422),
    [anon_sym_global] = ACTIONS(4422),
    [anon_sym_LBRACK] = ACTIONS(4547),
    [anon_sym_LPAREN] = ACTIONS(4424),
    [anon_sym_LBRACE] = ACTIONS(4424),
    [anon_sym_file] = ACTIONS(4422),
    [anon_sym_LT] = ACTIONS(4422),
    [anon_sym_GT] = ACTIONS(4422),
    [anon_sym_where] = ACTIONS(4422),
    [anon_sym_QMARK] = ACTIONS(4550),
    [anon_sym_notnull] = ACTIONS(4422),
    [anon_sym_unmanaged] = ACTIONS(4422),
    [anon_sym_BANG] = ACTIONS(4422),
    [anon_sym_PLUS_PLUS] = ACTIONS(4424),
    [anon_sym_DASH_DASH] = ACTIONS(4424),
    [anon_sym_PLUS] = ACTIONS(4422),
    [anon_sym_DASH] = ACTIONS(4422),
    [anon_sym_STAR] = ACTIONS(4553),
    [anon_sym_SLASH] = ACTIONS(4422),
    [anon_sym_PERCENT] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4424),
    [anon_sym_PIPE] = ACTIONS(4422),
    [anon_sym_AMP] = ACTIONS(4422),
    [anon_sym_LT_LT] = ACTIONS(4424),
    [anon_sym_GT_GT] = ACTIONS(4422),
    [anon_sym_GT_GT_GT] = ACTIONS(4424),
    [anon_sym_EQ_EQ] = ACTIONS(4424),
    [anon_sym_BANG_EQ] = ACTIONS(4424),
    [anon_sym_GT_EQ] = ACTIONS(4424),
    [anon_sym_LT_EQ] = ACTIONS(4424),
    [anon_sym_DOT] = ACTIONS(5175),
    [anon_sym_scoped] = ACTIONS(4422),
    [anon_sym_var] = ACTIONS(4422),
    [anon_sym_yield] = ACTIONS(4422),
    [anon_sym_switch] = ACTIONS(4422),
    [anon_sym_when] = ACTIONS(4422),
    [sym_discard] = ACTIONS(4422),
    [anon_sym_DOT_DOT] = ACTIONS(4424),
    [anon_sym_and] = ACTIONS(4422),
    [anon_sym_or] = ACTIONS(4422),
    [anon_sym_AMP_AMP] = ACTIONS(4424),
    [anon_sym_PIPE_PIPE] = ACTIONS(4424),
    [anon_sym_QMARK_QMARK] = ACTIONS(4424),
    [anon_sym_from] = ACTIONS(4422),
    [anon_sym_into] = ACTIONS(4422),
    [anon_sym_join] = ACTIONS(4422),
    [anon_sym_on] = ACTIONS(4422),
    [anon_sym_equals] = ACTIONS(4422),
    [anon_sym_let] = ACTIONS(4422),
    [anon_sym_orderby] = ACTIONS(4422),
    [anon_sym_ascending] = ACTIONS(4422),
    [anon_sym_descending] = ACTIONS(4422),
    [anon_sym_group] = ACTIONS(4422),
    [anon_sym_by] = ACTIONS(4422),
    [anon_sym_select] = ACTIONS(4422),
    [anon_sym_as] = ACTIONS(4422),
    [anon_sym_is] = ACTIONS(4422),
    [anon_sym_DASH_GT] = ACTIONS(5177),
    [anon_sym_with] = ACTIONS(4422),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3532] = {
    [sym_preproc_region] = STATE(3532),
    [sym_preproc_endregion] = STATE(3532),
    [sym_preproc_line] = STATE(3532),
    [sym_preproc_pragma] = STATE(3532),
    [sym_preproc_nullable] = STATE(3532),
    [sym_preproc_error] = STATE(3532),
    [sym_preproc_define] = STATE(3532),
    [sym_preproc_undef] = STATE(3532),
    [sym__identifier_token] = ACTIONS(4422),
    [anon_sym_alias] = ACTIONS(4422),
    [anon_sym_global] = ACTIONS(4422),
    [anon_sym_LBRACK] = ACTIONS(4547),
    [anon_sym_LPAREN] = ACTIONS(4424),
    [anon_sym_LBRACE] = ACTIONS(4424),
    [anon_sym_file] = ACTIONS(4422),
    [anon_sym_LT] = ACTIONS(4422),
    [anon_sym_GT] = ACTIONS(4422),
    [anon_sym_where] = ACTIONS(4422),
    [anon_sym_QMARK] = ACTIONS(4550),
    [anon_sym_notnull] = ACTIONS(4422),
    [anon_sym_unmanaged] = ACTIONS(4422),
    [anon_sym_BANG] = ACTIONS(4422),
    [anon_sym_PLUS_PLUS] = ACTIONS(4424),
    [anon_sym_DASH_DASH] = ACTIONS(4424),
    [anon_sym_PLUS] = ACTIONS(4422),
    [anon_sym_DASH] = ACTIONS(4422),
    [anon_sym_STAR] = ACTIONS(4553),
    [anon_sym_SLASH] = ACTIONS(4422),
    [anon_sym_PERCENT] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4424),
    [anon_sym_PIPE] = ACTIONS(4422),
    [anon_sym_AMP] = ACTIONS(4422),
    [anon_sym_LT_LT] = ACTIONS(4424),
    [anon_sym_GT_GT] = ACTIONS(4422),
    [anon_sym_GT_GT_GT] = ACTIONS(4424),
    [anon_sym_EQ_EQ] = ACTIONS(4424),
    [anon_sym_BANG_EQ] = ACTIONS(4424),
    [anon_sym_GT_EQ] = ACTIONS(4424),
    [anon_sym_LT_EQ] = ACTIONS(4424),
    [anon_sym_DOT] = ACTIONS(5179),
    [anon_sym_scoped] = ACTIONS(4422),
    [anon_sym_var] = ACTIONS(4422),
    [anon_sym_yield] = ACTIONS(4422),
    [anon_sym_switch] = ACTIONS(4422),
    [anon_sym_when] = ACTIONS(4422),
    [sym_discard] = ACTIONS(4422),
    [anon_sym_DOT_DOT] = ACTIONS(4424),
    [anon_sym_and] = ACTIONS(4422),
    [anon_sym_or] = ACTIONS(4422),
    [anon_sym_AMP_AMP] = ACTIONS(4424),
    [anon_sym_PIPE_PIPE] = ACTIONS(4424),
    [anon_sym_QMARK_QMARK] = ACTIONS(4424),
    [anon_sym_from] = ACTIONS(4422),
    [anon_sym_into] = ACTIONS(4422),
    [anon_sym_join] = ACTIONS(4422),
    [anon_sym_on] = ACTIONS(4422),
    [anon_sym_equals] = ACTIONS(4422),
    [anon_sym_let] = ACTIONS(4422),
    [anon_sym_orderby] = ACTIONS(4422),
    [anon_sym_ascending] = ACTIONS(4422),
    [anon_sym_descending] = ACTIONS(4422),
    [anon_sym_group] = ACTIONS(4422),
    [anon_sym_by] = ACTIONS(4422),
    [anon_sym_select] = ACTIONS(4422),
    [anon_sym_as] = ACTIONS(4422),
    [anon_sym_is] = ACTIONS(4422),
    [anon_sym_DASH_GT] = ACTIONS(4562),
    [anon_sym_with] = ACTIONS(4422),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3533] = {
    [sym_preproc_region] = STATE(3533),
    [sym_preproc_endregion] = STATE(3533),
    [sym_preproc_line] = STATE(3533),
    [sym_preproc_pragma] = STATE(3533),
    [sym_preproc_nullable] = STATE(3533),
    [sym_preproc_error] = STATE(3533),
    [sym_preproc_define] = STATE(3533),
    [sym_preproc_undef] = STATE(3533),
    [sym__identifier_token] = ACTIONS(4422),
    [anon_sym_alias] = ACTIONS(4422),
    [anon_sym_global] = ACTIONS(4422),
    [anon_sym_LBRACK] = ACTIONS(4547),
    [anon_sym_LPAREN] = ACTIONS(4424),
    [anon_sym_LBRACE] = ACTIONS(4424),
    [anon_sym_file] = ACTIONS(4422),
    [anon_sym_LT] = ACTIONS(4422),
    [anon_sym_GT] = ACTIONS(4422),
    [anon_sym_where] = ACTIONS(4422),
    [anon_sym_QMARK] = ACTIONS(4550),
    [anon_sym_notnull] = ACTIONS(4422),
    [anon_sym_unmanaged] = ACTIONS(4422),
    [anon_sym_BANG] = ACTIONS(4422),
    [anon_sym_PLUS_PLUS] = ACTIONS(4424),
    [anon_sym_DASH_DASH] = ACTIONS(4424),
    [anon_sym_PLUS] = ACTIONS(4422),
    [anon_sym_DASH] = ACTIONS(4422),
    [anon_sym_STAR] = ACTIONS(4553),
    [anon_sym_SLASH] = ACTIONS(4422),
    [anon_sym_PERCENT] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4424),
    [anon_sym_PIPE] = ACTIONS(4422),
    [anon_sym_AMP] = ACTIONS(4422),
    [anon_sym_LT_LT] = ACTIONS(4424),
    [anon_sym_GT_GT] = ACTIONS(4422),
    [anon_sym_GT_GT_GT] = ACTIONS(4424),
    [anon_sym_EQ_EQ] = ACTIONS(4424),
    [anon_sym_BANG_EQ] = ACTIONS(4424),
    [anon_sym_GT_EQ] = ACTIONS(4424),
    [anon_sym_LT_EQ] = ACTIONS(4424),
    [anon_sym_DOT] = ACTIONS(5181),
    [anon_sym_scoped] = ACTIONS(4422),
    [anon_sym_var] = ACTIONS(4422),
    [anon_sym_yield] = ACTIONS(4422),
    [anon_sym_switch] = ACTIONS(4422),
    [anon_sym_when] = ACTIONS(4422),
    [sym_discard] = ACTIONS(4422),
    [anon_sym_DOT_DOT] = ACTIONS(4424),
    [anon_sym_and] = ACTIONS(4422),
    [anon_sym_or] = ACTIONS(4422),
    [anon_sym_AMP_AMP] = ACTIONS(4424),
    [anon_sym_PIPE_PIPE] = ACTIONS(4424),
    [anon_sym_QMARK_QMARK] = ACTIONS(4424),
    [anon_sym_from] = ACTIONS(4422),
    [anon_sym_into] = ACTIONS(4422),
    [anon_sym_join] = ACTIONS(4422),
    [anon_sym_on] = ACTIONS(4422),
    [anon_sym_equals] = ACTIONS(4422),
    [anon_sym_let] = ACTIONS(4422),
    [anon_sym_orderby] = ACTIONS(4422),
    [anon_sym_ascending] = ACTIONS(4422),
    [anon_sym_descending] = ACTIONS(4422),
    [anon_sym_group] = ACTIONS(4422),
    [anon_sym_by] = ACTIONS(4422),
    [anon_sym_select] = ACTIONS(4422),
    [anon_sym_as] = ACTIONS(4422),
    [anon_sym_is] = ACTIONS(4422),
    [anon_sym_DASH_GT] = ACTIONS(4558),
    [anon_sym_with] = ACTIONS(4422),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3534] = {
    [sym_preproc_region] = STATE(3534),
    [sym_preproc_endregion] = STATE(3534),
    [sym_preproc_line] = STATE(3534),
    [sym_preproc_pragma] = STATE(3534),
    [sym_preproc_nullable] = STATE(3534),
    [sym_preproc_error] = STATE(3534),
    [sym_preproc_define] = STATE(3534),
    [sym_preproc_undef] = STATE(3534),
    [sym__identifier_token] = ACTIONS(4422),
    [anon_sym_alias] = ACTIONS(4422),
    [anon_sym_global] = ACTIONS(4422),
    [anon_sym_LBRACK] = ACTIONS(4547),
    [anon_sym_LPAREN] = ACTIONS(4424),
    [anon_sym_LBRACE] = ACTIONS(4424),
    [anon_sym_file] = ACTIONS(4422),
    [anon_sym_LT] = ACTIONS(4422),
    [anon_sym_GT] = ACTIONS(4422),
    [anon_sym_where] = ACTIONS(4422),
    [anon_sym_QMARK] = ACTIONS(4550),
    [anon_sym_notnull] = ACTIONS(4422),
    [anon_sym_unmanaged] = ACTIONS(4422),
    [anon_sym_BANG] = ACTIONS(4422),
    [anon_sym_PLUS_PLUS] = ACTIONS(4424),
    [anon_sym_DASH_DASH] = ACTIONS(4424),
    [anon_sym_PLUS] = ACTIONS(4422),
    [anon_sym_DASH] = ACTIONS(4422),
    [anon_sym_STAR] = ACTIONS(4553),
    [anon_sym_SLASH] = ACTIONS(4422),
    [anon_sym_PERCENT] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4424),
    [anon_sym_PIPE] = ACTIONS(4422),
    [anon_sym_AMP] = ACTIONS(4422),
    [anon_sym_LT_LT] = ACTIONS(4424),
    [anon_sym_GT_GT] = ACTIONS(4422),
    [anon_sym_GT_GT_GT] = ACTIONS(4424),
    [anon_sym_EQ_EQ] = ACTIONS(4424),
    [anon_sym_BANG_EQ] = ACTIONS(4424),
    [anon_sym_GT_EQ] = ACTIONS(4424),
    [anon_sym_LT_EQ] = ACTIONS(4424),
    [anon_sym_DOT] = ACTIONS(5183),
    [anon_sym_scoped] = ACTIONS(4422),
    [anon_sym_var] = ACTIONS(4422),
    [anon_sym_yield] = ACTIONS(4422),
    [anon_sym_switch] = ACTIONS(4422),
    [anon_sym_when] = ACTIONS(4422),
    [sym_discard] = ACTIONS(4422),
    [anon_sym_DOT_DOT] = ACTIONS(4424),
    [anon_sym_and] = ACTIONS(4422),
    [anon_sym_or] = ACTIONS(4422),
    [anon_sym_AMP_AMP] = ACTIONS(4424),
    [anon_sym_PIPE_PIPE] = ACTIONS(4424),
    [anon_sym_QMARK_QMARK] = ACTIONS(4424),
    [anon_sym_from] = ACTIONS(4422),
    [anon_sym_into] = ACTIONS(4422),
    [anon_sym_join] = ACTIONS(4422),
    [anon_sym_on] = ACTIONS(4422),
    [anon_sym_equals] = ACTIONS(4422),
    [anon_sym_let] = ACTIONS(4422),
    [anon_sym_orderby] = ACTIONS(4422),
    [anon_sym_ascending] = ACTIONS(4422),
    [anon_sym_descending] = ACTIONS(4422),
    [anon_sym_group] = ACTIONS(4422),
    [anon_sym_by] = ACTIONS(4422),
    [anon_sym_select] = ACTIONS(4422),
    [anon_sym_as] = ACTIONS(4422),
    [anon_sym_is] = ACTIONS(4422),
    [anon_sym_DASH_GT] = ACTIONS(4558),
    [anon_sym_with] = ACTIONS(4422),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3535] = {
    [sym_argument_list] = STATE(3546),
    [sym_initializer_expression] = STATE(3679),
    [sym_preproc_region] = STATE(3535),
    [sym_preproc_endregion] = STATE(3535),
    [sym_preproc_line] = STATE(3535),
    [sym_preproc_pragma] = STATE(3535),
    [sym_preproc_nullable] = STATE(3535),
    [sym_preproc_error] = STATE(3535),
    [sym_preproc_define] = STATE(3535),
    [sym_preproc_undef] = STATE(3535),
    [anon_sym_SEMI] = ACTIONS(5185),
    [anon_sym_LBRACK] = ACTIONS(5185),
    [anon_sym_COLON] = ACTIONS(5185),
    [anon_sym_COMMA] = ACTIONS(5185),
    [anon_sym_RBRACK] = ACTIONS(5185),
    [anon_sym_LPAREN] = ACTIONS(5187),
    [anon_sym_RPAREN] = ACTIONS(5185),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_RBRACE] = ACTIONS(5185),
    [anon_sym_LT] = ACTIONS(5189),
    [anon_sym_GT] = ACTIONS(5189),
    [anon_sym_in] = ACTIONS(5189),
    [anon_sym_where] = ACTIONS(5185),
    [anon_sym_QMARK] = ACTIONS(5189),
    [anon_sym_BANG] = ACTIONS(5189),
    [anon_sym_PLUS_PLUS] = ACTIONS(5185),
    [anon_sym_DASH_DASH] = ACTIONS(5185),
    [anon_sym_PLUS] = ACTIONS(5189),
    [anon_sym_DASH] = ACTIONS(5189),
    [anon_sym_STAR] = ACTIONS(5185),
    [anon_sym_SLASH] = ACTIONS(5189),
    [anon_sym_PERCENT] = ACTIONS(5185),
    [anon_sym_CARET] = ACTIONS(5185),
    [anon_sym_PIPE] = ACTIONS(5189),
    [anon_sym_AMP] = ACTIONS(5189),
    [anon_sym_LT_LT] = ACTIONS(5185),
    [anon_sym_GT_GT] = ACTIONS(5189),
    [anon_sym_GT_GT_GT] = ACTIONS(5185),
    [anon_sym_EQ_EQ] = ACTIONS(5185),
    [anon_sym_BANG_EQ] = ACTIONS(5185),
    [anon_sym_GT_EQ] = ACTIONS(5185),
    [anon_sym_LT_EQ] = ACTIONS(5185),
    [anon_sym_DOT] = ACTIONS(5189),
    [anon_sym_EQ_GT] = ACTIONS(5185),
    [anon_sym_switch] = ACTIONS(5185),
    [anon_sym_DOT_DOT] = ACTIONS(5185),
    [anon_sym_and] = ACTIONS(5185),
    [anon_sym_or] = ACTIONS(5189),
    [anon_sym_AMP_AMP] = ACTIONS(5185),
    [anon_sym_PIPE_PIPE] = ACTIONS(5185),
    [anon_sym_QMARK_QMARK] = ACTIONS(5185),
    [anon_sym_from] = ACTIONS(5185),
    [anon_sym_into] = ACTIONS(5185),
    [anon_sym_join] = ACTIONS(5185),
    [anon_sym_on] = ACTIONS(5185),
    [anon_sym_equals] = ACTIONS(5185),
    [anon_sym_let] = ACTIONS(5185),
    [anon_sym_orderby] = ACTIONS(5185),
    [anon_sym_group] = ACTIONS(5185),
    [anon_sym_by] = ACTIONS(5185),
    [anon_sym_select] = ACTIONS(5185),
    [anon_sym_as] = ACTIONS(5185),
    [anon_sym_is] = ACTIONS(5185),
    [anon_sym_DASH_GT] = ACTIONS(5185),
    [anon_sym_with] = ACTIONS(5185),
    [aux_sym_preproc_if_token3] = ACTIONS(5185),
    [aux_sym_preproc_else_token1] = ACTIONS(5185),
    [aux_sym_preproc_elif_token1] = ACTIONS(5185),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3536] = {
    [sym_preproc_region] = STATE(3536),
    [sym_preproc_endregion] = STATE(3536),
    [sym_preproc_line] = STATE(3536),
    [sym_preproc_pragma] = STATE(3536),
    [sym_preproc_nullable] = STATE(3536),
    [sym_preproc_error] = STATE(3536),
    [sym_preproc_define] = STATE(3536),
    [sym_preproc_undef] = STATE(3536),
    [sym__identifier_token] = ACTIONS(4422),
    [anon_sym_alias] = ACTIONS(4422),
    [anon_sym_global] = ACTIONS(4422),
    [anon_sym_LBRACK] = ACTIONS(4547),
    [anon_sym_LPAREN] = ACTIONS(4424),
    [anon_sym_LBRACE] = ACTIONS(4424),
    [anon_sym_file] = ACTIONS(4422),
    [anon_sym_LT] = ACTIONS(4422),
    [anon_sym_GT] = ACTIONS(4422),
    [anon_sym_where] = ACTIONS(4422),
    [anon_sym_QMARK] = ACTIONS(4550),
    [anon_sym_notnull] = ACTIONS(4422),
    [anon_sym_unmanaged] = ACTIONS(4422),
    [anon_sym_BANG] = ACTIONS(4422),
    [anon_sym_PLUS_PLUS] = ACTIONS(4424),
    [anon_sym_DASH_DASH] = ACTIONS(4424),
    [anon_sym_PLUS] = ACTIONS(4422),
    [anon_sym_DASH] = ACTIONS(4422),
    [anon_sym_STAR] = ACTIONS(4553),
    [anon_sym_SLASH] = ACTIONS(4422),
    [anon_sym_PERCENT] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4424),
    [anon_sym_PIPE] = ACTIONS(4422),
    [anon_sym_AMP] = ACTIONS(4422),
    [anon_sym_LT_LT] = ACTIONS(4424),
    [anon_sym_GT_GT] = ACTIONS(4422),
    [anon_sym_GT_GT_GT] = ACTIONS(4424),
    [anon_sym_EQ_EQ] = ACTIONS(4424),
    [anon_sym_BANG_EQ] = ACTIONS(4424),
    [anon_sym_GT_EQ] = ACTIONS(4424),
    [anon_sym_LT_EQ] = ACTIONS(4424),
    [anon_sym_DOT] = ACTIONS(5191),
    [anon_sym_scoped] = ACTIONS(4422),
    [anon_sym_var] = ACTIONS(4422),
    [anon_sym_yield] = ACTIONS(4422),
    [anon_sym_switch] = ACTIONS(4422),
    [anon_sym_when] = ACTIONS(4422),
    [sym_discard] = ACTIONS(4422),
    [anon_sym_DOT_DOT] = ACTIONS(4424),
    [anon_sym_and] = ACTIONS(4422),
    [anon_sym_or] = ACTIONS(4422),
    [anon_sym_AMP_AMP] = ACTIONS(4424),
    [anon_sym_PIPE_PIPE] = ACTIONS(4424),
    [anon_sym_QMARK_QMARK] = ACTIONS(4424),
    [anon_sym_from] = ACTIONS(4422),
    [anon_sym_into] = ACTIONS(4422),
    [anon_sym_join] = ACTIONS(4422),
    [anon_sym_on] = ACTIONS(4422),
    [anon_sym_equals] = ACTIONS(4422),
    [anon_sym_let] = ACTIONS(4422),
    [anon_sym_orderby] = ACTIONS(4422),
    [anon_sym_ascending] = ACTIONS(4422),
    [anon_sym_descending] = ACTIONS(4422),
    [anon_sym_group] = ACTIONS(4422),
    [anon_sym_by] = ACTIONS(4422),
    [anon_sym_select] = ACTIONS(4422),
    [anon_sym_as] = ACTIONS(4422),
    [anon_sym_is] = ACTIONS(4422),
    [anon_sym_DASH_GT] = ACTIONS(4562),
    [anon_sym_with] = ACTIONS(4422),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3537] = {
    [sym_preproc_region] = STATE(3537),
    [sym_preproc_endregion] = STATE(3537),
    [sym_preproc_line] = STATE(3537),
    [sym_preproc_pragma] = STATE(3537),
    [sym_preproc_nullable] = STATE(3537),
    [sym_preproc_error] = STATE(3537),
    [sym_preproc_define] = STATE(3537),
    [sym_preproc_undef] = STATE(3537),
    [sym__identifier_token] = ACTIONS(4422),
    [anon_sym_alias] = ACTIONS(4422),
    [anon_sym_global] = ACTIONS(4422),
    [anon_sym_LBRACK] = ACTIONS(4547),
    [anon_sym_LPAREN] = ACTIONS(4424),
    [anon_sym_LBRACE] = ACTIONS(4424),
    [anon_sym_file] = ACTIONS(4422),
    [anon_sym_LT] = ACTIONS(4422),
    [anon_sym_GT] = ACTIONS(4422),
    [anon_sym_where] = ACTIONS(4422),
    [anon_sym_QMARK] = ACTIONS(4550),
    [anon_sym_notnull] = ACTIONS(4422),
    [anon_sym_unmanaged] = ACTIONS(4422),
    [anon_sym_BANG] = ACTIONS(4422),
    [anon_sym_PLUS_PLUS] = ACTIONS(4424),
    [anon_sym_DASH_DASH] = ACTIONS(4424),
    [anon_sym_PLUS] = ACTIONS(4422),
    [anon_sym_DASH] = ACTIONS(4422),
    [anon_sym_STAR] = ACTIONS(4553),
    [anon_sym_SLASH] = ACTIONS(4422),
    [anon_sym_PERCENT] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4424),
    [anon_sym_PIPE] = ACTIONS(4422),
    [anon_sym_AMP] = ACTIONS(4422),
    [anon_sym_LT_LT] = ACTIONS(4424),
    [anon_sym_GT_GT] = ACTIONS(4422),
    [anon_sym_GT_GT_GT] = ACTIONS(4424),
    [anon_sym_EQ_EQ] = ACTIONS(4424),
    [anon_sym_BANG_EQ] = ACTIONS(4424),
    [anon_sym_GT_EQ] = ACTIONS(4424),
    [anon_sym_LT_EQ] = ACTIONS(4424),
    [anon_sym_DOT] = ACTIONS(5193),
    [anon_sym_scoped] = ACTIONS(4422),
    [anon_sym_var] = ACTIONS(4422),
    [anon_sym_yield] = ACTIONS(4422),
    [anon_sym_switch] = ACTIONS(4422),
    [anon_sym_when] = ACTIONS(4422),
    [sym_discard] = ACTIONS(4422),
    [anon_sym_DOT_DOT] = ACTIONS(4424),
    [anon_sym_and] = ACTIONS(4422),
    [anon_sym_or] = ACTIONS(4422),
    [anon_sym_AMP_AMP] = ACTIONS(4424),
    [anon_sym_PIPE_PIPE] = ACTIONS(4424),
    [anon_sym_QMARK_QMARK] = ACTIONS(4424),
    [anon_sym_from] = ACTIONS(4422),
    [anon_sym_into] = ACTIONS(4422),
    [anon_sym_join] = ACTIONS(4422),
    [anon_sym_on] = ACTIONS(4422),
    [anon_sym_equals] = ACTIONS(4422),
    [anon_sym_let] = ACTIONS(4422),
    [anon_sym_orderby] = ACTIONS(4422),
    [anon_sym_ascending] = ACTIONS(4422),
    [anon_sym_descending] = ACTIONS(4422),
    [anon_sym_group] = ACTIONS(4422),
    [anon_sym_by] = ACTIONS(4422),
    [anon_sym_select] = ACTIONS(4422),
    [anon_sym_as] = ACTIONS(4422),
    [anon_sym_is] = ACTIONS(4422),
    [anon_sym_DASH_GT] = ACTIONS(5177),
    [anon_sym_with] = ACTIONS(4422),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3538] = {
    [sym_preproc_region] = STATE(3538),
    [sym_preproc_endregion] = STATE(3538),
    [sym_preproc_line] = STATE(3538),
    [sym_preproc_pragma] = STATE(3538),
    [sym_preproc_nullable] = STATE(3538),
    [sym_preproc_error] = STATE(3538),
    [sym_preproc_define] = STATE(3538),
    [sym_preproc_undef] = STATE(3538),
    [sym__identifier_token] = ACTIONS(4422),
    [anon_sym_alias] = ACTIONS(4422),
    [anon_sym_global] = ACTIONS(4422),
    [anon_sym_LBRACK] = ACTIONS(4547),
    [anon_sym_LPAREN] = ACTIONS(4424),
    [anon_sym_LBRACE] = ACTIONS(4424),
    [anon_sym_file] = ACTIONS(4422),
    [anon_sym_LT] = ACTIONS(4422),
    [anon_sym_GT] = ACTIONS(4422),
    [anon_sym_where] = ACTIONS(4422),
    [anon_sym_QMARK] = ACTIONS(4550),
    [anon_sym_notnull] = ACTIONS(4422),
    [anon_sym_unmanaged] = ACTIONS(4422),
    [anon_sym_BANG] = ACTIONS(4422),
    [anon_sym_PLUS_PLUS] = ACTIONS(4424),
    [anon_sym_DASH_DASH] = ACTIONS(4424),
    [anon_sym_PLUS] = ACTIONS(4422),
    [anon_sym_DASH] = ACTIONS(4422),
    [anon_sym_STAR] = ACTIONS(4553),
    [anon_sym_SLASH] = ACTIONS(4422),
    [anon_sym_PERCENT] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4424),
    [anon_sym_PIPE] = ACTIONS(4422),
    [anon_sym_AMP] = ACTIONS(4422),
    [anon_sym_LT_LT] = ACTIONS(4424),
    [anon_sym_GT_GT] = ACTIONS(4422),
    [anon_sym_GT_GT_GT] = ACTIONS(4424),
    [anon_sym_EQ_EQ] = ACTIONS(4424),
    [anon_sym_BANG_EQ] = ACTIONS(4424),
    [anon_sym_GT_EQ] = ACTIONS(4424),
    [anon_sym_LT_EQ] = ACTIONS(4424),
    [anon_sym_DOT] = ACTIONS(5195),
    [anon_sym_scoped] = ACTIONS(4422),
    [anon_sym_var] = ACTIONS(4422),
    [anon_sym_yield] = ACTIONS(4422),
    [anon_sym_switch] = ACTIONS(4422),
    [anon_sym_when] = ACTIONS(4422),
    [sym_discard] = ACTIONS(4422),
    [anon_sym_DOT_DOT] = ACTIONS(4424),
    [anon_sym_and] = ACTIONS(4422),
    [anon_sym_or] = ACTIONS(4422),
    [anon_sym_AMP_AMP] = ACTIONS(4424),
    [anon_sym_PIPE_PIPE] = ACTIONS(4424),
    [anon_sym_QMARK_QMARK] = ACTIONS(4424),
    [anon_sym_from] = ACTIONS(4422),
    [anon_sym_into] = ACTIONS(4422),
    [anon_sym_join] = ACTIONS(4422),
    [anon_sym_on] = ACTIONS(4422),
    [anon_sym_equals] = ACTIONS(4422),
    [anon_sym_let] = ACTIONS(4422),
    [anon_sym_orderby] = ACTIONS(4422),
    [anon_sym_ascending] = ACTIONS(4422),
    [anon_sym_descending] = ACTIONS(4422),
    [anon_sym_group] = ACTIONS(4422),
    [anon_sym_by] = ACTIONS(4422),
    [anon_sym_select] = ACTIONS(4422),
    [anon_sym_as] = ACTIONS(4422),
    [anon_sym_is] = ACTIONS(4422),
    [anon_sym_DASH_GT] = ACTIONS(4562),
    [anon_sym_with] = ACTIONS(4422),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3539] = {
    [sym_preproc_region] = STATE(3539),
    [sym_preproc_endregion] = STATE(3539),
    [sym_preproc_line] = STATE(3539),
    [sym_preproc_pragma] = STATE(3539),
    [sym_preproc_nullable] = STATE(3539),
    [sym_preproc_error] = STATE(3539),
    [sym_preproc_define] = STATE(3539),
    [sym_preproc_undef] = STATE(3539),
    [anon_sym_EQ] = ACTIONS(4633),
    [anon_sym_LBRACK] = ACTIONS(4631),
    [anon_sym_COLON] = ACTIONS(4631),
    [anon_sym_COMMA] = ACTIONS(4631),
    [anon_sym_LPAREN] = ACTIONS(4631),
    [anon_sym_LT] = ACTIONS(4633),
    [anon_sym_GT] = ACTIONS(4633),
    [anon_sym_where] = ACTIONS(4631),
    [anon_sym_QMARK] = ACTIONS(4633),
    [anon_sym_BANG] = ACTIONS(4633),
    [anon_sym_PLUS_PLUS] = ACTIONS(4631),
    [anon_sym_DASH_DASH] = ACTIONS(4631),
    [anon_sym_PLUS] = ACTIONS(4633),
    [anon_sym_DASH] = ACTIONS(4633),
    [anon_sym_STAR] = ACTIONS(4633),
    [anon_sym_SLASH] = ACTIONS(4633),
    [anon_sym_PERCENT] = ACTIONS(4633),
    [anon_sym_CARET] = ACTIONS(4633),
    [anon_sym_PIPE] = ACTIONS(4633),
    [anon_sym_AMP] = ACTIONS(4633),
    [anon_sym_LT_LT] = ACTIONS(4633),
    [anon_sym_GT_GT] = ACTIONS(4633),
    [anon_sym_GT_GT_GT] = ACTIONS(4633),
    [anon_sym_EQ_EQ] = ACTIONS(4631),
    [anon_sym_BANG_EQ] = ACTIONS(4631),
    [anon_sym_GT_EQ] = ACTIONS(4631),
    [anon_sym_LT_EQ] = ACTIONS(4631),
    [anon_sym_DOT] = ACTIONS(4633),
    [anon_sym_switch] = ACTIONS(4631),
    [anon_sym_DOT_DOT] = ACTIONS(4631),
    [anon_sym_and] = ACTIONS(4631),
    [anon_sym_or] = ACTIONS(4633),
    [anon_sym_PLUS_EQ] = ACTIONS(4631),
    [anon_sym_DASH_EQ] = ACTIONS(4631),
    [anon_sym_STAR_EQ] = ACTIONS(4631),
    [anon_sym_SLASH_EQ] = ACTIONS(4631),
    [anon_sym_PERCENT_EQ] = ACTIONS(4631),
    [anon_sym_AMP_EQ] = ACTIONS(4631),
    [anon_sym_CARET_EQ] = ACTIONS(4631),
    [anon_sym_PIPE_EQ] = ACTIONS(4631),
    [anon_sym_LT_LT_EQ] = ACTIONS(4631),
    [anon_sym_GT_GT_EQ] = ACTIONS(4631),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4631),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4631),
    [anon_sym_AMP_AMP] = ACTIONS(4631),
    [anon_sym_PIPE_PIPE] = ACTIONS(4631),
    [anon_sym_QMARK_QMARK] = ACTIONS(4633),
    [anon_sym_from] = ACTIONS(4631),
    [anon_sym_into] = ACTIONS(4631),
    [anon_sym_join] = ACTIONS(4631),
    [anon_sym_let] = ACTIONS(4631),
    [anon_sym_orderby] = ACTIONS(4631),
    [anon_sym_ascending] = ACTIONS(4631),
    [anon_sym_descending] = ACTIONS(4631),
    [anon_sym_group] = ACTIONS(4631),
    [anon_sym_select] = ACTIONS(4631),
    [anon_sym_as] = ACTIONS(4633),
    [anon_sym_is] = ACTIONS(4631),
    [anon_sym_DASH_GT] = ACTIONS(4631),
    [anon_sym_with] = ACTIONS(4631),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3540] = {
    [sym_preproc_region] = STATE(3540),
    [sym_preproc_endregion] = STATE(3540),
    [sym_preproc_line] = STATE(3540),
    [sym_preproc_pragma] = STATE(3540),
    [sym_preproc_nullable] = STATE(3540),
    [sym_preproc_error] = STATE(3540),
    [sym_preproc_define] = STATE(3540),
    [sym_preproc_undef] = STATE(3540),
    [sym__identifier_token] = ACTIONS(4422),
    [anon_sym_alias] = ACTIONS(4422),
    [anon_sym_global] = ACTIONS(4422),
    [anon_sym_LBRACK] = ACTIONS(4547),
    [anon_sym_LPAREN] = ACTIONS(4424),
    [anon_sym_LBRACE] = ACTIONS(4424),
    [anon_sym_file] = ACTIONS(4422),
    [anon_sym_LT] = ACTIONS(4422),
    [anon_sym_GT] = ACTIONS(4422),
    [anon_sym_where] = ACTIONS(4422),
    [anon_sym_QMARK] = ACTIONS(4550),
    [anon_sym_notnull] = ACTIONS(4422),
    [anon_sym_unmanaged] = ACTIONS(4422),
    [anon_sym_BANG] = ACTIONS(4422),
    [anon_sym_PLUS_PLUS] = ACTIONS(4424),
    [anon_sym_DASH_DASH] = ACTIONS(4424),
    [anon_sym_PLUS] = ACTIONS(4422),
    [anon_sym_DASH] = ACTIONS(4422),
    [anon_sym_STAR] = ACTIONS(4553),
    [anon_sym_SLASH] = ACTIONS(4422),
    [anon_sym_PERCENT] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4424),
    [anon_sym_PIPE] = ACTIONS(4422),
    [anon_sym_AMP] = ACTIONS(4422),
    [anon_sym_LT_LT] = ACTIONS(4424),
    [anon_sym_GT_GT] = ACTIONS(4422),
    [anon_sym_GT_GT_GT] = ACTIONS(4424),
    [anon_sym_EQ_EQ] = ACTIONS(4424),
    [anon_sym_BANG_EQ] = ACTIONS(4424),
    [anon_sym_GT_EQ] = ACTIONS(4424),
    [anon_sym_LT_EQ] = ACTIONS(4424),
    [anon_sym_DOT] = ACTIONS(5197),
    [anon_sym_scoped] = ACTIONS(4422),
    [anon_sym_var] = ACTIONS(4422),
    [anon_sym_yield] = ACTIONS(4422),
    [anon_sym_switch] = ACTIONS(4422),
    [anon_sym_when] = ACTIONS(4422),
    [sym_discard] = ACTIONS(4422),
    [anon_sym_DOT_DOT] = ACTIONS(4424),
    [anon_sym_and] = ACTIONS(4422),
    [anon_sym_or] = ACTIONS(4422),
    [anon_sym_AMP_AMP] = ACTIONS(4424),
    [anon_sym_PIPE_PIPE] = ACTIONS(4424),
    [anon_sym_QMARK_QMARK] = ACTIONS(4424),
    [anon_sym_from] = ACTIONS(4422),
    [anon_sym_into] = ACTIONS(4422),
    [anon_sym_join] = ACTIONS(4422),
    [anon_sym_on] = ACTIONS(4422),
    [anon_sym_equals] = ACTIONS(4422),
    [anon_sym_let] = ACTIONS(4422),
    [anon_sym_orderby] = ACTIONS(4422),
    [anon_sym_ascending] = ACTIONS(4422),
    [anon_sym_descending] = ACTIONS(4422),
    [anon_sym_group] = ACTIONS(4422),
    [anon_sym_by] = ACTIONS(4422),
    [anon_sym_select] = ACTIONS(4422),
    [anon_sym_as] = ACTIONS(4422),
    [anon_sym_is] = ACTIONS(4422),
    [anon_sym_DASH_GT] = ACTIONS(4558),
    [anon_sym_with] = ACTIONS(4422),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3541] = {
    [sym_preproc_region] = STATE(3541),
    [sym_preproc_endregion] = STATE(3541),
    [sym_preproc_line] = STATE(3541),
    [sym_preproc_pragma] = STATE(3541),
    [sym_preproc_nullable] = STATE(3541),
    [sym_preproc_error] = STATE(3541),
    [sym_preproc_define] = STATE(3541),
    [sym_preproc_undef] = STATE(3541),
    [sym__identifier_token] = ACTIONS(4422),
    [anon_sym_alias] = ACTIONS(4422),
    [anon_sym_global] = ACTIONS(4422),
    [anon_sym_LBRACK] = ACTIONS(4547),
    [anon_sym_LPAREN] = ACTIONS(4424),
    [anon_sym_LBRACE] = ACTIONS(4424),
    [anon_sym_file] = ACTIONS(4422),
    [anon_sym_LT] = ACTIONS(4422),
    [anon_sym_GT] = ACTIONS(4422),
    [anon_sym_where] = ACTIONS(4422),
    [anon_sym_QMARK] = ACTIONS(4550),
    [anon_sym_notnull] = ACTIONS(4422),
    [anon_sym_unmanaged] = ACTIONS(4422),
    [anon_sym_BANG] = ACTIONS(4422),
    [anon_sym_PLUS_PLUS] = ACTIONS(4424),
    [anon_sym_DASH_DASH] = ACTIONS(4424),
    [anon_sym_PLUS] = ACTIONS(4422),
    [anon_sym_DASH] = ACTIONS(4422),
    [anon_sym_STAR] = ACTIONS(4553),
    [anon_sym_SLASH] = ACTIONS(4422),
    [anon_sym_PERCENT] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4424),
    [anon_sym_PIPE] = ACTIONS(4422),
    [anon_sym_AMP] = ACTIONS(4422),
    [anon_sym_LT_LT] = ACTIONS(4424),
    [anon_sym_GT_GT] = ACTIONS(4422),
    [anon_sym_GT_GT_GT] = ACTIONS(4424),
    [anon_sym_EQ_EQ] = ACTIONS(4424),
    [anon_sym_BANG_EQ] = ACTIONS(4424),
    [anon_sym_GT_EQ] = ACTIONS(4424),
    [anon_sym_LT_EQ] = ACTIONS(4424),
    [anon_sym_DOT] = ACTIONS(5199),
    [anon_sym_scoped] = ACTIONS(4422),
    [anon_sym_var] = ACTIONS(4422),
    [anon_sym_yield] = ACTIONS(4422),
    [anon_sym_switch] = ACTIONS(4422),
    [anon_sym_when] = ACTIONS(4422),
    [sym_discard] = ACTIONS(4422),
    [anon_sym_DOT_DOT] = ACTIONS(4424),
    [anon_sym_and] = ACTIONS(4422),
    [anon_sym_or] = ACTIONS(4422),
    [anon_sym_AMP_AMP] = ACTIONS(4424),
    [anon_sym_PIPE_PIPE] = ACTIONS(4424),
    [anon_sym_QMARK_QMARK] = ACTIONS(4424),
    [anon_sym_from] = ACTIONS(4422),
    [anon_sym_into] = ACTIONS(4422),
    [anon_sym_join] = ACTIONS(4422),
    [anon_sym_on] = ACTIONS(4422),
    [anon_sym_equals] = ACTIONS(4422),
    [anon_sym_let] = ACTIONS(4422),
    [anon_sym_orderby] = ACTIONS(4422),
    [anon_sym_ascending] = ACTIONS(4422),
    [anon_sym_descending] = ACTIONS(4422),
    [anon_sym_group] = ACTIONS(4422),
    [anon_sym_by] = ACTIONS(4422),
    [anon_sym_select] = ACTIONS(4422),
    [anon_sym_as] = ACTIONS(4422),
    [anon_sym_is] = ACTIONS(4422),
    [anon_sym_DASH_GT] = ACTIONS(5177),
    [anon_sym_with] = ACTIONS(4422),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3542] = {
    [sym_preproc_region] = STATE(3542),
    [sym_preproc_endregion] = STATE(3542),
    [sym_preproc_line] = STATE(3542),
    [sym_preproc_pragma] = STATE(3542),
    [sym_preproc_nullable] = STATE(3542),
    [sym_preproc_error] = STATE(3542),
    [sym_preproc_define] = STATE(3542),
    [sym_preproc_undef] = STATE(3542),
    [sym__identifier_token] = ACTIONS(4580),
    [anon_sym_alias] = ACTIONS(4580),
    [anon_sym_global] = ACTIONS(4580),
    [anon_sym_LBRACK] = ACTIONS(2927),
    [anon_sym_COLON] = ACTIONS(4582),
    [anon_sym_LPAREN] = ACTIONS(4582),
    [anon_sym_file] = ACTIONS(4580),
    [anon_sym_LT] = ACTIONS(2925),
    [anon_sym_GT] = ACTIONS(2925),
    [anon_sym_where] = ACTIONS(4580),
    [anon_sym_QMARK] = ACTIONS(2925),
    [anon_sym_notnull] = ACTIONS(4580),
    [anon_sym_unmanaged] = ACTIONS(4580),
    [anon_sym_BANG] = ACTIONS(2925),
    [anon_sym_PLUS_PLUS] = ACTIONS(2927),
    [anon_sym_DASH_DASH] = ACTIONS(2927),
    [anon_sym_PLUS] = ACTIONS(2925),
    [anon_sym_DASH] = ACTIONS(2925),
    [anon_sym_STAR] = ACTIONS(2927),
    [anon_sym_SLASH] = ACTIONS(2925),
    [anon_sym_PERCENT] = ACTIONS(2927),
    [anon_sym_CARET] = ACTIONS(2927),
    [anon_sym_PIPE] = ACTIONS(2925),
    [anon_sym_AMP] = ACTIONS(2925),
    [anon_sym_LT_LT] = ACTIONS(2927),
    [anon_sym_GT_GT] = ACTIONS(2925),
    [anon_sym_GT_GT_GT] = ACTIONS(2927),
    [anon_sym_EQ_EQ] = ACTIONS(2927),
    [anon_sym_BANG_EQ] = ACTIONS(2927),
    [anon_sym_GT_EQ] = ACTIONS(2927),
    [anon_sym_LT_EQ] = ACTIONS(2927),
    [anon_sym_DOT] = ACTIONS(2925),
    [anon_sym_scoped] = ACTIONS(4580),
    [anon_sym_var] = ACTIONS(4580),
    [anon_sym_yield] = ACTIONS(4580),
    [anon_sym_switch] = ACTIONS(2925),
    [anon_sym_when] = ACTIONS(4580),
    [sym_discard] = ACTIONS(4580),
    [anon_sym_DOT_DOT] = ACTIONS(2927),
    [anon_sym_and] = ACTIONS(4580),
    [anon_sym_or] = ACTIONS(4580),
    [anon_sym_AMP_AMP] = ACTIONS(2927),
    [anon_sym_PIPE_PIPE] = ACTIONS(2927),
    [anon_sym_QMARK_QMARK] = ACTIONS(2927),
    [anon_sym_from] = ACTIONS(4580),
    [anon_sym_into] = ACTIONS(4580),
    [anon_sym_join] = ACTIONS(4580),
    [anon_sym_on] = ACTIONS(4580),
    [anon_sym_equals] = ACTIONS(4580),
    [anon_sym_let] = ACTIONS(4580),
    [anon_sym_orderby] = ACTIONS(4580),
    [anon_sym_ascending] = ACTIONS(4580),
    [anon_sym_descending] = ACTIONS(4580),
    [anon_sym_group] = ACTIONS(4580),
    [anon_sym_by] = ACTIONS(4580),
    [anon_sym_select] = ACTIONS(4580),
    [anon_sym_as] = ACTIONS(2925),
    [anon_sym_is] = ACTIONS(2925),
    [anon_sym_DASH_GT] = ACTIONS(2927),
    [anon_sym_with] = ACTIONS(2925),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3543] = {
    [sym_preproc_region] = STATE(3543),
    [sym_preproc_endregion] = STATE(3543),
    [sym_preproc_line] = STATE(3543),
    [sym_preproc_pragma] = STATE(3543),
    [sym_preproc_nullable] = STATE(3543),
    [sym_preproc_error] = STATE(3543),
    [sym_preproc_define] = STATE(3543),
    [sym_preproc_undef] = STATE(3543),
    [sym__identifier_token] = ACTIONS(4576),
    [anon_sym_alias] = ACTIONS(4576),
    [anon_sym_global] = ACTIONS(4576),
    [anon_sym_LBRACK] = ACTIONS(4695),
    [anon_sym_COLON] = ACTIONS(4578),
    [anon_sym_LPAREN] = ACTIONS(4578),
    [anon_sym_file] = ACTIONS(4576),
    [anon_sym_LT] = ACTIONS(4697),
    [anon_sym_GT] = ACTIONS(4697),
    [anon_sym_where] = ACTIONS(4576),
    [anon_sym_QMARK] = ACTIONS(4697),
    [anon_sym_notnull] = ACTIONS(4576),
    [anon_sym_unmanaged] = ACTIONS(4576),
    [anon_sym_BANG] = ACTIONS(4697),
    [anon_sym_PLUS_PLUS] = ACTIONS(4695),
    [anon_sym_DASH_DASH] = ACTIONS(4695),
    [anon_sym_PLUS] = ACTIONS(4697),
    [anon_sym_DASH] = ACTIONS(4697),
    [anon_sym_STAR] = ACTIONS(4695),
    [anon_sym_SLASH] = ACTIONS(4697),
    [anon_sym_PERCENT] = ACTIONS(4695),
    [anon_sym_CARET] = ACTIONS(4695),
    [anon_sym_PIPE] = ACTIONS(4697),
    [anon_sym_AMP] = ACTIONS(4697),
    [anon_sym_LT_LT] = ACTIONS(4695),
    [anon_sym_GT_GT] = ACTIONS(4697),
    [anon_sym_GT_GT_GT] = ACTIONS(4695),
    [anon_sym_EQ_EQ] = ACTIONS(4695),
    [anon_sym_BANG_EQ] = ACTIONS(4695),
    [anon_sym_GT_EQ] = ACTIONS(4695),
    [anon_sym_LT_EQ] = ACTIONS(4695),
    [anon_sym_DOT] = ACTIONS(4697),
    [anon_sym_scoped] = ACTIONS(4576),
    [anon_sym_var] = ACTIONS(4576),
    [anon_sym_yield] = ACTIONS(4576),
    [anon_sym_switch] = ACTIONS(4697),
    [anon_sym_when] = ACTIONS(4576),
    [sym_discard] = ACTIONS(4576),
    [anon_sym_DOT_DOT] = ACTIONS(4695),
    [anon_sym_and] = ACTIONS(4576),
    [anon_sym_or] = ACTIONS(4576),
    [anon_sym_AMP_AMP] = ACTIONS(4695),
    [anon_sym_PIPE_PIPE] = ACTIONS(4695),
    [anon_sym_QMARK_QMARK] = ACTIONS(4695),
    [anon_sym_from] = ACTIONS(4576),
    [anon_sym_into] = ACTIONS(4576),
    [anon_sym_join] = ACTIONS(4576),
    [anon_sym_on] = ACTIONS(4576),
    [anon_sym_equals] = ACTIONS(4576),
    [anon_sym_let] = ACTIONS(4576),
    [anon_sym_orderby] = ACTIONS(4576),
    [anon_sym_ascending] = ACTIONS(4576),
    [anon_sym_descending] = ACTIONS(4576),
    [anon_sym_group] = ACTIONS(4576),
    [anon_sym_by] = ACTIONS(4576),
    [anon_sym_select] = ACTIONS(4576),
    [anon_sym_as] = ACTIONS(4697),
    [anon_sym_is] = ACTIONS(4697),
    [anon_sym_DASH_GT] = ACTIONS(4695),
    [anon_sym_with] = ACTIONS(4697),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3544] = {
    [sym_preproc_region] = STATE(3544),
    [sym_preproc_endregion] = STATE(3544),
    [sym_preproc_line] = STATE(3544),
    [sym_preproc_pragma] = STATE(3544),
    [sym_preproc_nullable] = STATE(3544),
    [sym_preproc_error] = STATE(3544),
    [sym_preproc_define] = STATE(3544),
    [sym_preproc_undef] = STATE(3544),
    [anon_sym_EQ] = ACTIONS(4625),
    [anon_sym_LBRACK] = ACTIONS(4639),
    [anon_sym_COLON] = ACTIONS(4623),
    [anon_sym_COMMA] = ACTIONS(4639),
    [anon_sym_LPAREN] = ACTIONS(4639),
    [anon_sym_LT] = ACTIONS(4641),
    [anon_sym_GT] = ACTIONS(4641),
    [anon_sym_where] = ACTIONS(4639),
    [anon_sym_QMARK] = ACTIONS(4641),
    [anon_sym_BANG] = ACTIONS(4641),
    [anon_sym_PLUS_PLUS] = ACTIONS(4639),
    [anon_sym_DASH_DASH] = ACTIONS(4639),
    [anon_sym_PLUS] = ACTIONS(4641),
    [anon_sym_DASH] = ACTIONS(4641),
    [anon_sym_STAR] = ACTIONS(4641),
    [anon_sym_SLASH] = ACTIONS(4641),
    [anon_sym_PERCENT] = ACTIONS(4641),
    [anon_sym_CARET] = ACTIONS(4641),
    [anon_sym_PIPE] = ACTIONS(4641),
    [anon_sym_AMP] = ACTIONS(4641),
    [anon_sym_LT_LT] = ACTIONS(4641),
    [anon_sym_GT_GT] = ACTIONS(4641),
    [anon_sym_GT_GT_GT] = ACTIONS(4641),
    [anon_sym_EQ_EQ] = ACTIONS(4639),
    [anon_sym_BANG_EQ] = ACTIONS(4639),
    [anon_sym_GT_EQ] = ACTIONS(4639),
    [anon_sym_LT_EQ] = ACTIONS(4639),
    [anon_sym_DOT] = ACTIONS(4641),
    [anon_sym_switch] = ACTIONS(4639),
    [anon_sym_DOT_DOT] = ACTIONS(4639),
    [anon_sym_and] = ACTIONS(4639),
    [anon_sym_or] = ACTIONS(4641),
    [anon_sym_PLUS_EQ] = ACTIONS(4623),
    [anon_sym_DASH_EQ] = ACTIONS(4623),
    [anon_sym_STAR_EQ] = ACTIONS(4623),
    [anon_sym_SLASH_EQ] = ACTIONS(4623),
    [anon_sym_PERCENT_EQ] = ACTIONS(4623),
    [anon_sym_AMP_EQ] = ACTIONS(4623),
    [anon_sym_CARET_EQ] = ACTIONS(4623),
    [anon_sym_PIPE_EQ] = ACTIONS(4623),
    [anon_sym_LT_LT_EQ] = ACTIONS(4623),
    [anon_sym_GT_GT_EQ] = ACTIONS(4623),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4623),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4623),
    [anon_sym_AMP_AMP] = ACTIONS(4639),
    [anon_sym_PIPE_PIPE] = ACTIONS(4639),
    [anon_sym_QMARK_QMARK] = ACTIONS(4641),
    [anon_sym_from] = ACTIONS(4639),
    [anon_sym_into] = ACTIONS(4639),
    [anon_sym_join] = ACTIONS(4639),
    [anon_sym_let] = ACTIONS(4639),
    [anon_sym_orderby] = ACTIONS(4639),
    [anon_sym_ascending] = ACTIONS(4639),
    [anon_sym_descending] = ACTIONS(4639),
    [anon_sym_group] = ACTIONS(4639),
    [anon_sym_select] = ACTIONS(4639),
    [anon_sym_as] = ACTIONS(4641),
    [anon_sym_is] = ACTIONS(4639),
    [anon_sym_DASH_GT] = ACTIONS(4639),
    [anon_sym_with] = ACTIONS(4639),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3545] = {
    [sym_initializer_expression] = STATE(3672),
    [sym_preproc_region] = STATE(3545),
    [sym_preproc_endregion] = STATE(3545),
    [sym_preproc_line] = STATE(3545),
    [sym_preproc_pragma] = STATE(3545),
    [sym_preproc_nullable] = STATE(3545),
    [sym_preproc_error] = STATE(3545),
    [sym_preproc_define] = STATE(3545),
    [sym_preproc_undef] = STATE(3545),
    [anon_sym_SEMI] = ACTIONS(5201),
    [anon_sym_LBRACK] = ACTIONS(5201),
    [anon_sym_COLON] = ACTIONS(5201),
    [anon_sym_COMMA] = ACTIONS(5201),
    [anon_sym_RBRACK] = ACTIONS(5201),
    [anon_sym_LPAREN] = ACTIONS(5201),
    [anon_sym_RPAREN] = ACTIONS(5201),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_RBRACE] = ACTIONS(5201),
    [anon_sym_LT] = ACTIONS(5203),
    [anon_sym_GT] = ACTIONS(5203),
    [anon_sym_in] = ACTIONS(5203),
    [anon_sym_where] = ACTIONS(5201),
    [anon_sym_QMARK] = ACTIONS(5203),
    [anon_sym_BANG] = ACTIONS(5203),
    [anon_sym_PLUS_PLUS] = ACTIONS(5201),
    [anon_sym_DASH_DASH] = ACTIONS(5201),
    [anon_sym_PLUS] = ACTIONS(5203),
    [anon_sym_DASH] = ACTIONS(5203),
    [anon_sym_STAR] = ACTIONS(5201),
    [anon_sym_SLASH] = ACTIONS(5203),
    [anon_sym_PERCENT] = ACTIONS(5201),
    [anon_sym_CARET] = ACTIONS(5201),
    [anon_sym_PIPE] = ACTIONS(5203),
    [anon_sym_AMP] = ACTIONS(5203),
    [anon_sym_LT_LT] = ACTIONS(5201),
    [anon_sym_GT_GT] = ACTIONS(5203),
    [anon_sym_GT_GT_GT] = ACTIONS(5201),
    [anon_sym_EQ_EQ] = ACTIONS(5201),
    [anon_sym_BANG_EQ] = ACTIONS(5201),
    [anon_sym_GT_EQ] = ACTIONS(5201),
    [anon_sym_LT_EQ] = ACTIONS(5201),
    [anon_sym_DOT] = ACTIONS(5203),
    [anon_sym_EQ_GT] = ACTIONS(5201),
    [anon_sym_switch] = ACTIONS(5201),
    [anon_sym_DOT_DOT] = ACTIONS(5201),
    [anon_sym_and] = ACTIONS(5201),
    [anon_sym_or] = ACTIONS(5203),
    [anon_sym_AMP_AMP] = ACTIONS(5201),
    [anon_sym_PIPE_PIPE] = ACTIONS(5201),
    [anon_sym_QMARK_QMARK] = ACTIONS(5201),
    [anon_sym_from] = ACTIONS(5201),
    [anon_sym_into] = ACTIONS(5201),
    [anon_sym_join] = ACTIONS(5201),
    [anon_sym_on] = ACTIONS(5201),
    [anon_sym_equals] = ACTIONS(5201),
    [anon_sym_let] = ACTIONS(5201),
    [anon_sym_orderby] = ACTIONS(5201),
    [anon_sym_group] = ACTIONS(5201),
    [anon_sym_by] = ACTIONS(5201),
    [anon_sym_select] = ACTIONS(5201),
    [anon_sym_as] = ACTIONS(5201),
    [anon_sym_is] = ACTIONS(5201),
    [anon_sym_DASH_GT] = ACTIONS(5201),
    [anon_sym_with] = ACTIONS(5201),
    [aux_sym_preproc_if_token3] = ACTIONS(5201),
    [aux_sym_preproc_else_token1] = ACTIONS(5201),
    [aux_sym_preproc_elif_token1] = ACTIONS(5201),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3546] = {
    [sym_initializer_expression] = STATE(3655),
    [sym_preproc_region] = STATE(3546),
    [sym_preproc_endregion] = STATE(3546),
    [sym_preproc_line] = STATE(3546),
    [sym_preproc_pragma] = STATE(3546),
    [sym_preproc_nullable] = STATE(3546),
    [sym_preproc_error] = STATE(3546),
    [sym_preproc_define] = STATE(3546),
    [sym_preproc_undef] = STATE(3546),
    [anon_sym_SEMI] = ACTIONS(5205),
    [anon_sym_LBRACK] = ACTIONS(5205),
    [anon_sym_COLON] = ACTIONS(5205),
    [anon_sym_COMMA] = ACTIONS(5205),
    [anon_sym_RBRACK] = ACTIONS(5205),
    [anon_sym_LPAREN] = ACTIONS(5205),
    [anon_sym_RPAREN] = ACTIONS(5205),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_RBRACE] = ACTIONS(5205),
    [anon_sym_LT] = ACTIONS(5207),
    [anon_sym_GT] = ACTIONS(5207),
    [anon_sym_in] = ACTIONS(5207),
    [anon_sym_where] = ACTIONS(5205),
    [anon_sym_QMARK] = ACTIONS(5207),
    [anon_sym_BANG] = ACTIONS(5207),
    [anon_sym_PLUS_PLUS] = ACTIONS(5205),
    [anon_sym_DASH_DASH] = ACTIONS(5205),
    [anon_sym_PLUS] = ACTIONS(5207),
    [anon_sym_DASH] = ACTIONS(5207),
    [anon_sym_STAR] = ACTIONS(5205),
    [anon_sym_SLASH] = ACTIONS(5207),
    [anon_sym_PERCENT] = ACTIONS(5205),
    [anon_sym_CARET] = ACTIONS(5205),
    [anon_sym_PIPE] = ACTIONS(5207),
    [anon_sym_AMP] = ACTIONS(5207),
    [anon_sym_LT_LT] = ACTIONS(5205),
    [anon_sym_GT_GT] = ACTIONS(5207),
    [anon_sym_GT_GT_GT] = ACTIONS(5205),
    [anon_sym_EQ_EQ] = ACTIONS(5205),
    [anon_sym_BANG_EQ] = ACTIONS(5205),
    [anon_sym_GT_EQ] = ACTIONS(5205),
    [anon_sym_LT_EQ] = ACTIONS(5205),
    [anon_sym_DOT] = ACTIONS(5207),
    [anon_sym_EQ_GT] = ACTIONS(5205),
    [anon_sym_switch] = ACTIONS(5205),
    [anon_sym_DOT_DOT] = ACTIONS(5205),
    [anon_sym_and] = ACTIONS(5205),
    [anon_sym_or] = ACTIONS(5207),
    [anon_sym_AMP_AMP] = ACTIONS(5205),
    [anon_sym_PIPE_PIPE] = ACTIONS(5205),
    [anon_sym_QMARK_QMARK] = ACTIONS(5205),
    [anon_sym_from] = ACTIONS(5205),
    [anon_sym_into] = ACTIONS(5205),
    [anon_sym_join] = ACTIONS(5205),
    [anon_sym_on] = ACTIONS(5205),
    [anon_sym_equals] = ACTIONS(5205),
    [anon_sym_let] = ACTIONS(5205),
    [anon_sym_orderby] = ACTIONS(5205),
    [anon_sym_group] = ACTIONS(5205),
    [anon_sym_by] = ACTIONS(5205),
    [anon_sym_select] = ACTIONS(5205),
    [anon_sym_as] = ACTIONS(5205),
    [anon_sym_is] = ACTIONS(5205),
    [anon_sym_DASH_GT] = ACTIONS(5205),
    [anon_sym_with] = ACTIONS(5205),
    [aux_sym_preproc_if_token3] = ACTIONS(5205),
    [aux_sym_preproc_else_token1] = ACTIONS(5205),
    [aux_sym_preproc_elif_token1] = ACTIONS(5205),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3547] = {
    [sym_type_argument_list] = STATE(3605),
    [sym_preproc_region] = STATE(3547),
    [sym_preproc_endregion] = STATE(3547),
    [sym_preproc_line] = STATE(3547),
    [sym_preproc_pragma] = STATE(3547),
    [sym_preproc_nullable] = STATE(3547),
    [sym_preproc_error] = STATE(3547),
    [sym_preproc_define] = STATE(3547),
    [sym_preproc_undef] = STATE(3547),
    [anon_sym_SEMI] = ACTIONS(4076),
    [anon_sym_LBRACK] = ACTIONS(4076),
    [anon_sym_COLON] = ACTIONS(4076),
    [anon_sym_COMMA] = ACTIONS(4076),
    [anon_sym_RBRACK] = ACTIONS(4076),
    [anon_sym_LPAREN] = ACTIONS(4076),
    [anon_sym_RPAREN] = ACTIONS(4076),
    [anon_sym_LBRACE] = ACTIONS(4076),
    [anon_sym_RBRACE] = ACTIONS(4076),
    [anon_sym_LT] = ACTIONS(5209),
    [anon_sym_GT] = ACTIONS(4074),
    [anon_sym_in] = ACTIONS(4074),
    [anon_sym_where] = ACTIONS(4076),
    [anon_sym_QMARK] = ACTIONS(4074),
    [anon_sym_BANG] = ACTIONS(4074),
    [anon_sym_PLUS_PLUS] = ACTIONS(4076),
    [anon_sym_DASH_DASH] = ACTIONS(4076),
    [anon_sym_PLUS] = ACTIONS(4074),
    [anon_sym_DASH] = ACTIONS(4074),
    [anon_sym_STAR] = ACTIONS(4076),
    [anon_sym_SLASH] = ACTIONS(4074),
    [anon_sym_PERCENT] = ACTIONS(4076),
    [anon_sym_CARET] = ACTIONS(4076),
    [anon_sym_PIPE] = ACTIONS(4074),
    [anon_sym_AMP] = ACTIONS(4074),
    [anon_sym_LT_LT] = ACTIONS(4076),
    [anon_sym_GT_GT] = ACTIONS(4074),
    [anon_sym_GT_GT_GT] = ACTIONS(4076),
    [anon_sym_EQ_EQ] = ACTIONS(4076),
    [anon_sym_BANG_EQ] = ACTIONS(4076),
    [anon_sym_GT_EQ] = ACTIONS(4076),
    [anon_sym_LT_EQ] = ACTIONS(4076),
    [anon_sym_DOT] = ACTIONS(4074),
    [anon_sym_EQ_GT] = ACTIONS(4076),
    [anon_sym_switch] = ACTIONS(4076),
    [anon_sym_DOT_DOT] = ACTIONS(4076),
    [anon_sym_and] = ACTIONS(4076),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_AMP_AMP] = ACTIONS(4076),
    [anon_sym_PIPE_PIPE] = ACTIONS(4076),
    [anon_sym_QMARK_QMARK] = ACTIONS(4076),
    [anon_sym_from] = ACTIONS(4076),
    [anon_sym_into] = ACTIONS(4076),
    [anon_sym_join] = ACTIONS(4076),
    [anon_sym_on] = ACTIONS(4076),
    [anon_sym_equals] = ACTIONS(4076),
    [anon_sym_let] = ACTIONS(4076),
    [anon_sym_orderby] = ACTIONS(4076),
    [anon_sym_group] = ACTIONS(4076),
    [anon_sym_by] = ACTIONS(4076),
    [anon_sym_select] = ACTIONS(4076),
    [anon_sym_as] = ACTIONS(4076),
    [anon_sym_is] = ACTIONS(4076),
    [anon_sym_DASH_GT] = ACTIONS(4076),
    [anon_sym_with] = ACTIONS(4076),
    [aux_sym_preproc_if_token3] = ACTIONS(4076),
    [aux_sym_preproc_else_token1] = ACTIONS(4076),
    [aux_sym_preproc_elif_token1] = ACTIONS(4076),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3548] = {
    [sym_preproc_region] = STATE(3548),
    [sym_preproc_endregion] = STATE(3548),
    [sym_preproc_line] = STATE(3548),
    [sym_preproc_pragma] = STATE(3548),
    [sym_preproc_nullable] = STATE(3548),
    [sym_preproc_error] = STATE(3548),
    [sym_preproc_define] = STATE(3548),
    [sym_preproc_undef] = STATE(3548),
    [anon_sym_EQ] = ACTIONS(4118),
    [anon_sym_LBRACK] = ACTIONS(4741),
    [anon_sym_COMMA] = ACTIONS(4739),
    [anon_sym_LPAREN] = ACTIONS(4741),
    [anon_sym_LT] = ACTIONS(4744),
    [anon_sym_GT] = ACTIONS(4744),
    [anon_sym_where] = ACTIONS(4739),
    [anon_sym_QMARK] = ACTIONS(4744),
    [anon_sym_BANG] = ACTIONS(4744),
    [anon_sym_PLUS_PLUS] = ACTIONS(4741),
    [anon_sym_DASH_DASH] = ACTIONS(4741),
    [anon_sym_PLUS] = ACTIONS(4744),
    [anon_sym_DASH] = ACTIONS(4744),
    [anon_sym_STAR] = ACTIONS(4744),
    [anon_sym_SLASH] = ACTIONS(4744),
    [anon_sym_PERCENT] = ACTIONS(4744),
    [anon_sym_CARET] = ACTIONS(4744),
    [anon_sym_PIPE] = ACTIONS(4744),
    [anon_sym_AMP] = ACTIONS(4744),
    [anon_sym_LT_LT] = ACTIONS(4744),
    [anon_sym_GT_GT] = ACTIONS(4744),
    [anon_sym_GT_GT_GT] = ACTIONS(4744),
    [anon_sym_EQ_EQ] = ACTIONS(4741),
    [anon_sym_BANG_EQ] = ACTIONS(4741),
    [anon_sym_GT_EQ] = ACTIONS(4741),
    [anon_sym_LT_EQ] = ACTIONS(4741),
    [anon_sym_DOT] = ACTIONS(4744),
    [anon_sym_switch] = ACTIONS(4741),
    [anon_sym_DOT_DOT] = ACTIONS(4741),
    [anon_sym_and] = ACTIONS(4739),
    [anon_sym_or] = ACTIONS(4747),
    [anon_sym_PLUS_EQ] = ACTIONS(4133),
    [anon_sym_DASH_EQ] = ACTIONS(4133),
    [anon_sym_STAR_EQ] = ACTIONS(4133),
    [anon_sym_SLASH_EQ] = ACTIONS(4133),
    [anon_sym_PERCENT_EQ] = ACTIONS(4133),
    [anon_sym_AMP_EQ] = ACTIONS(4133),
    [anon_sym_CARET_EQ] = ACTIONS(4133),
    [anon_sym_PIPE_EQ] = ACTIONS(4133),
    [anon_sym_LT_LT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4133),
    [anon_sym_AMP_AMP] = ACTIONS(4741),
    [anon_sym_PIPE_PIPE] = ACTIONS(4741),
    [anon_sym_QMARK_QMARK] = ACTIONS(4744),
    [anon_sym_from] = ACTIONS(4739),
    [anon_sym_into] = ACTIONS(4739),
    [anon_sym_join] = ACTIONS(4739),
    [anon_sym_let] = ACTIONS(4739),
    [anon_sym_orderby] = ACTIONS(4739),
    [anon_sym_ascending] = ACTIONS(4739),
    [anon_sym_descending] = ACTIONS(4739),
    [anon_sym_group] = ACTIONS(4739),
    [anon_sym_select] = ACTIONS(4739),
    [anon_sym_as] = ACTIONS(4744),
    [anon_sym_is] = ACTIONS(4741),
    [anon_sym_DASH_GT] = ACTIONS(4741),
    [anon_sym_with] = ACTIONS(4741),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3549] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter] = STATE(8382),
    [sym__parameter_array] = STATE(8390),
    [sym_tuple_pattern] = STATE(8536),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7337),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_identifier] = STATE(6728),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(3549),
    [sym_preproc_endregion] = STATE(3549),
    [sym_preproc_line] = STATE(3549),
    [sym_preproc_pragma] = STATE(3549),
    [sym_preproc_nullable] = STATE(3549),
    [sym_preproc_error] = STATE(3549),
    [sym_preproc_define] = STATE(3549),
    [sym_preproc_undef] = STATE(3549),
    [aux_sym_class_declaration_repeat1] = STATE(3784),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4143),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_LBRACK] = ACTIONS(5212),
    [anon_sym_LPAREN] = ACTIONS(5214),
    [anon_sym_RPAREN] = ACTIONS(2561),
    [anon_sym_ref] = ACTIONS(5216),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_readonly] = ACTIONS(1093),
    [anon_sym_in] = ACTIONS(1093),
    [anon_sym_out] = ACTIONS(1093),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_this] = ACTIONS(1093),
    [anon_sym_scoped] = ACTIONS(5218),
    [anon_sym_params] = ACTIONS(1107),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [sym_discard] = ACTIONS(5220),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3550] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7045),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9034),
    [sym_identifier] = STATE(6700),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(3550),
    [sym_preproc_endregion] = STATE(3550),
    [sym_preproc_line] = STATE(3550),
    [sym_preproc_pragma] = STATE(3550),
    [sym_preproc_nullable] = STATE(3550),
    [sym_preproc_error] = STATE(3550),
    [sym_preproc_define] = STATE(3550),
    [sym_preproc_undef] = STATE(3550),
    [aux_sym_class_declaration_repeat1] = STATE(6230),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4206),
    [aux_sym_lambda_expression_repeat1] = STATE(4226),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(5212),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(5216),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_readonly] = ACTIONS(1093),
    [anon_sym_in] = ACTIONS(1093),
    [anon_sym_out] = ACTIONS(1093),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_this] = ACTIONS(1093),
    [anon_sym_scoped] = ACTIONS(5222),
    [anon_sym_params] = ACTIONS(5224),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3551] = {
    [sym_preproc_region] = STATE(3551),
    [sym_preproc_endregion] = STATE(3551),
    [sym_preproc_line] = STATE(3551),
    [sym_preproc_pragma] = STATE(3551),
    [sym_preproc_nullable] = STATE(3551),
    [sym_preproc_error] = STATE(3551),
    [sym_preproc_define] = STATE(3551),
    [sym_preproc_undef] = STATE(3551),
    [anon_sym_EQ] = ACTIONS(4637),
    [anon_sym_LBRACK] = ACTIONS(4635),
    [anon_sym_COMMA] = ACTIONS(4635),
    [anon_sym_LPAREN] = ACTIONS(4635),
    [anon_sym_LT] = ACTIONS(4637),
    [anon_sym_GT] = ACTIONS(4637),
    [anon_sym_where] = ACTIONS(4635),
    [anon_sym_QMARK] = ACTIONS(4637),
    [anon_sym_BANG] = ACTIONS(4637),
    [anon_sym_PLUS_PLUS] = ACTIONS(4635),
    [anon_sym_DASH_DASH] = ACTIONS(4635),
    [anon_sym_PLUS] = ACTIONS(4637),
    [anon_sym_DASH] = ACTIONS(4637),
    [anon_sym_STAR] = ACTIONS(4637),
    [anon_sym_SLASH] = ACTIONS(4637),
    [anon_sym_PERCENT] = ACTIONS(4637),
    [anon_sym_CARET] = ACTIONS(4637),
    [anon_sym_PIPE] = ACTIONS(4637),
    [anon_sym_AMP] = ACTIONS(4637),
    [anon_sym_LT_LT] = ACTIONS(4637),
    [anon_sym_GT_GT] = ACTIONS(4637),
    [anon_sym_GT_GT_GT] = ACTIONS(4637),
    [anon_sym_EQ_EQ] = ACTIONS(4635),
    [anon_sym_BANG_EQ] = ACTIONS(4635),
    [anon_sym_GT_EQ] = ACTIONS(4635),
    [anon_sym_LT_EQ] = ACTIONS(4635),
    [anon_sym_DOT] = ACTIONS(4637),
    [anon_sym_switch] = ACTIONS(4635),
    [anon_sym_DOT_DOT] = ACTIONS(4635),
    [anon_sym_and] = ACTIONS(4635),
    [anon_sym_or] = ACTIONS(4637),
    [anon_sym_PLUS_EQ] = ACTIONS(4635),
    [anon_sym_DASH_EQ] = ACTIONS(4635),
    [anon_sym_STAR_EQ] = ACTIONS(4635),
    [anon_sym_SLASH_EQ] = ACTIONS(4635),
    [anon_sym_PERCENT_EQ] = ACTIONS(4635),
    [anon_sym_AMP_EQ] = ACTIONS(4635),
    [anon_sym_CARET_EQ] = ACTIONS(4635),
    [anon_sym_PIPE_EQ] = ACTIONS(4635),
    [anon_sym_LT_LT_EQ] = ACTIONS(4635),
    [anon_sym_GT_GT_EQ] = ACTIONS(4635),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4635),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4635),
    [anon_sym_AMP_AMP] = ACTIONS(4635),
    [anon_sym_PIPE_PIPE] = ACTIONS(4635),
    [anon_sym_QMARK_QMARK] = ACTIONS(4637),
    [anon_sym_from] = ACTIONS(4635),
    [anon_sym_into] = ACTIONS(4635),
    [anon_sym_join] = ACTIONS(4635),
    [anon_sym_let] = ACTIONS(4635),
    [anon_sym_orderby] = ACTIONS(4635),
    [anon_sym_ascending] = ACTIONS(4635),
    [anon_sym_descending] = ACTIONS(4635),
    [anon_sym_group] = ACTIONS(4635),
    [anon_sym_select] = ACTIONS(4635),
    [anon_sym_as] = ACTIONS(4637),
    [anon_sym_is] = ACTIONS(4635),
    [anon_sym_DASH_GT] = ACTIONS(4635),
    [anon_sym_with] = ACTIONS(4635),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3552] = {
    [sym_preproc_region] = STATE(3552),
    [sym_preproc_endregion] = STATE(3552),
    [sym_preproc_line] = STATE(3552),
    [sym_preproc_pragma] = STATE(3552),
    [sym_preproc_nullable] = STATE(3552),
    [sym_preproc_error] = STATE(3552),
    [sym_preproc_define] = STATE(3552),
    [sym_preproc_undef] = STATE(3552),
    [anon_sym_EQ] = ACTIONS(4104),
    [anon_sym_LBRACK] = ACTIONS(4111),
    [anon_sym_COMMA] = ACTIONS(4111),
    [anon_sym_LPAREN] = ACTIONS(4111),
    [anon_sym_LT] = ACTIONS(4104),
    [anon_sym_GT] = ACTIONS(4104),
    [anon_sym_where] = ACTIONS(4111),
    [anon_sym_QMARK] = ACTIONS(4104),
    [anon_sym_BANG] = ACTIONS(4104),
    [anon_sym_PLUS_PLUS] = ACTIONS(4111),
    [anon_sym_DASH_DASH] = ACTIONS(4111),
    [anon_sym_PLUS] = ACTIONS(4104),
    [anon_sym_DASH] = ACTIONS(4104),
    [anon_sym_STAR] = ACTIONS(4104),
    [anon_sym_SLASH] = ACTIONS(4104),
    [anon_sym_PERCENT] = ACTIONS(4104),
    [anon_sym_CARET] = ACTIONS(4104),
    [anon_sym_PIPE] = ACTIONS(4104),
    [anon_sym_AMP] = ACTIONS(4104),
    [anon_sym_LT_LT] = ACTIONS(4104),
    [anon_sym_GT_GT] = ACTIONS(4104),
    [anon_sym_GT_GT_GT] = ACTIONS(4104),
    [anon_sym_EQ_EQ] = ACTIONS(4111),
    [anon_sym_BANG_EQ] = ACTIONS(4111),
    [anon_sym_GT_EQ] = ACTIONS(4111),
    [anon_sym_LT_EQ] = ACTIONS(4111),
    [anon_sym_DOT] = ACTIONS(4104),
    [anon_sym_switch] = ACTIONS(4111),
    [anon_sym_DOT_DOT] = ACTIONS(4111),
    [anon_sym_and] = ACTIONS(4111),
    [anon_sym_or] = ACTIONS(4104),
    [anon_sym_PLUS_EQ] = ACTIONS(4111),
    [anon_sym_DASH_EQ] = ACTIONS(4111),
    [anon_sym_STAR_EQ] = ACTIONS(4111),
    [anon_sym_SLASH_EQ] = ACTIONS(4111),
    [anon_sym_PERCENT_EQ] = ACTIONS(4111),
    [anon_sym_AMP_EQ] = ACTIONS(4111),
    [anon_sym_CARET_EQ] = ACTIONS(4111),
    [anon_sym_PIPE_EQ] = ACTIONS(4111),
    [anon_sym_LT_LT_EQ] = ACTIONS(4111),
    [anon_sym_GT_GT_EQ] = ACTIONS(4111),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4111),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4111),
    [anon_sym_AMP_AMP] = ACTIONS(4111),
    [anon_sym_PIPE_PIPE] = ACTIONS(4111),
    [anon_sym_QMARK_QMARK] = ACTIONS(4104),
    [anon_sym_from] = ACTIONS(4111),
    [anon_sym_into] = ACTIONS(4111),
    [anon_sym_join] = ACTIONS(4111),
    [anon_sym_let] = ACTIONS(4111),
    [anon_sym_orderby] = ACTIONS(4111),
    [anon_sym_ascending] = ACTIONS(4111),
    [anon_sym_descending] = ACTIONS(4111),
    [anon_sym_group] = ACTIONS(4111),
    [anon_sym_select] = ACTIONS(4111),
    [anon_sym_as] = ACTIONS(4104),
    [anon_sym_is] = ACTIONS(4111),
    [anon_sym_DASH_GT] = ACTIONS(4111),
    [anon_sym_with] = ACTIONS(4111),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3553] = {
    [sym_initializer_expression] = STATE(3613),
    [sym_preproc_region] = STATE(3553),
    [sym_preproc_endregion] = STATE(3553),
    [sym_preproc_line] = STATE(3553),
    [sym_preproc_pragma] = STATE(3553),
    [sym_preproc_nullable] = STATE(3553),
    [sym_preproc_error] = STATE(3553),
    [sym_preproc_define] = STATE(3553),
    [sym_preproc_undef] = STATE(3553),
    [anon_sym_SEMI] = ACTIONS(5226),
    [anon_sym_LBRACK] = ACTIONS(5228),
    [anon_sym_COLON] = ACTIONS(5226),
    [anon_sym_COMMA] = ACTIONS(5226),
    [anon_sym_RBRACK] = ACTIONS(5226),
    [anon_sym_LPAREN] = ACTIONS(5226),
    [anon_sym_RPAREN] = ACTIONS(5226),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_RBRACE] = ACTIONS(5226),
    [anon_sym_LT] = ACTIONS(5231),
    [anon_sym_GT] = ACTIONS(5231),
    [anon_sym_in] = ACTIONS(5231),
    [anon_sym_where] = ACTIONS(5226),
    [anon_sym_QMARK] = ACTIONS(5231),
    [anon_sym_BANG] = ACTIONS(5231),
    [anon_sym_PLUS_PLUS] = ACTIONS(5226),
    [anon_sym_DASH_DASH] = ACTIONS(5226),
    [anon_sym_PLUS] = ACTIONS(5231),
    [anon_sym_DASH] = ACTIONS(5231),
    [anon_sym_STAR] = ACTIONS(5226),
    [anon_sym_SLASH] = ACTIONS(5231),
    [anon_sym_PERCENT] = ACTIONS(5226),
    [anon_sym_CARET] = ACTIONS(5226),
    [anon_sym_PIPE] = ACTIONS(5231),
    [anon_sym_AMP] = ACTIONS(5231),
    [anon_sym_LT_LT] = ACTIONS(5226),
    [anon_sym_GT_GT] = ACTIONS(5231),
    [anon_sym_GT_GT_GT] = ACTIONS(5226),
    [anon_sym_EQ_EQ] = ACTIONS(5226),
    [anon_sym_BANG_EQ] = ACTIONS(5226),
    [anon_sym_GT_EQ] = ACTIONS(5226),
    [anon_sym_LT_EQ] = ACTIONS(5226),
    [anon_sym_DOT] = ACTIONS(5231),
    [anon_sym_EQ_GT] = ACTIONS(5226),
    [anon_sym_switch] = ACTIONS(5226),
    [anon_sym_DOT_DOT] = ACTIONS(5226),
    [anon_sym_and] = ACTIONS(5226),
    [anon_sym_or] = ACTIONS(5231),
    [anon_sym_AMP_AMP] = ACTIONS(5226),
    [anon_sym_PIPE_PIPE] = ACTIONS(5226),
    [anon_sym_QMARK_QMARK] = ACTIONS(5226),
    [anon_sym_from] = ACTIONS(5226),
    [anon_sym_into] = ACTIONS(5226),
    [anon_sym_join] = ACTIONS(5226),
    [anon_sym_on] = ACTIONS(5226),
    [anon_sym_equals] = ACTIONS(5226),
    [anon_sym_let] = ACTIONS(5226),
    [anon_sym_orderby] = ACTIONS(5226),
    [anon_sym_group] = ACTIONS(5226),
    [anon_sym_by] = ACTIONS(5226),
    [anon_sym_select] = ACTIONS(5226),
    [anon_sym_as] = ACTIONS(5226),
    [anon_sym_is] = ACTIONS(5226),
    [anon_sym_DASH_GT] = ACTIONS(5226),
    [anon_sym_with] = ACTIONS(5226),
    [aux_sym_preproc_if_token3] = ACTIONS(5226),
    [aux_sym_preproc_else_token1] = ACTIONS(5226),
    [aux_sym_preproc_elif_token1] = ACTIONS(5226),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3554] = {
    [sym_preproc_region] = STATE(3554),
    [sym_preproc_endregion] = STATE(3554),
    [sym_preproc_line] = STATE(3554),
    [sym_preproc_pragma] = STATE(3554),
    [sym_preproc_nullable] = STATE(3554),
    [sym_preproc_error] = STATE(3554),
    [sym_preproc_define] = STATE(3554),
    [sym_preproc_undef] = STATE(3554),
    [anon_sym_EQ] = ACTIONS(4645),
    [anon_sym_LBRACK] = ACTIONS(4643),
    [anon_sym_COMMA] = ACTIONS(4643),
    [anon_sym_LPAREN] = ACTIONS(4643),
    [anon_sym_LT] = ACTIONS(4645),
    [anon_sym_GT] = ACTIONS(4645),
    [anon_sym_where] = ACTIONS(4643),
    [anon_sym_QMARK] = ACTIONS(4645),
    [anon_sym_BANG] = ACTIONS(4645),
    [anon_sym_PLUS_PLUS] = ACTIONS(4643),
    [anon_sym_DASH_DASH] = ACTIONS(4643),
    [anon_sym_PLUS] = ACTIONS(4645),
    [anon_sym_DASH] = ACTIONS(4645),
    [anon_sym_STAR] = ACTIONS(4645),
    [anon_sym_SLASH] = ACTIONS(4645),
    [anon_sym_PERCENT] = ACTIONS(4645),
    [anon_sym_CARET] = ACTIONS(4645),
    [anon_sym_PIPE] = ACTIONS(4645),
    [anon_sym_AMP] = ACTIONS(4645),
    [anon_sym_LT_LT] = ACTIONS(4645),
    [anon_sym_GT_GT] = ACTIONS(4645),
    [anon_sym_GT_GT_GT] = ACTIONS(4645),
    [anon_sym_EQ_EQ] = ACTIONS(4643),
    [anon_sym_BANG_EQ] = ACTIONS(4643),
    [anon_sym_GT_EQ] = ACTIONS(4643),
    [anon_sym_LT_EQ] = ACTIONS(4643),
    [anon_sym_DOT] = ACTIONS(4645),
    [anon_sym_switch] = ACTIONS(4643),
    [anon_sym_DOT_DOT] = ACTIONS(4643),
    [anon_sym_and] = ACTIONS(4643),
    [anon_sym_or] = ACTIONS(4645),
    [anon_sym_PLUS_EQ] = ACTIONS(4643),
    [anon_sym_DASH_EQ] = ACTIONS(4643),
    [anon_sym_STAR_EQ] = ACTIONS(4643),
    [anon_sym_SLASH_EQ] = ACTIONS(4643),
    [anon_sym_PERCENT_EQ] = ACTIONS(4643),
    [anon_sym_AMP_EQ] = ACTIONS(4643),
    [anon_sym_CARET_EQ] = ACTIONS(4643),
    [anon_sym_PIPE_EQ] = ACTIONS(4643),
    [anon_sym_LT_LT_EQ] = ACTIONS(4643),
    [anon_sym_GT_GT_EQ] = ACTIONS(4643),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4643),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4643),
    [anon_sym_AMP_AMP] = ACTIONS(4643),
    [anon_sym_PIPE_PIPE] = ACTIONS(4643),
    [anon_sym_QMARK_QMARK] = ACTIONS(4645),
    [anon_sym_from] = ACTIONS(4643),
    [anon_sym_into] = ACTIONS(4643),
    [anon_sym_join] = ACTIONS(4643),
    [anon_sym_let] = ACTIONS(4643),
    [anon_sym_orderby] = ACTIONS(4643),
    [anon_sym_ascending] = ACTIONS(4643),
    [anon_sym_descending] = ACTIONS(4643),
    [anon_sym_group] = ACTIONS(4643),
    [anon_sym_select] = ACTIONS(4643),
    [anon_sym_as] = ACTIONS(4645),
    [anon_sym_is] = ACTIONS(4643),
    [anon_sym_DASH_GT] = ACTIONS(4643),
    [anon_sym_with] = ACTIONS(4643),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3555] = {
    [sym_preproc_region] = STATE(3555),
    [sym_preproc_endregion] = STATE(3555),
    [sym_preproc_line] = STATE(3555),
    [sym_preproc_pragma] = STATE(3555),
    [sym_preproc_nullable] = STATE(3555),
    [sym_preproc_error] = STATE(3555),
    [sym_preproc_define] = STATE(3555),
    [sym_preproc_undef] = STATE(3555),
    [anon_sym_SEMI] = ACTIONS(3719),
    [anon_sym_LBRACK] = ACTIONS(3719),
    [anon_sym_COLON] = ACTIONS(3721),
    [anon_sym_COMMA] = ACTIONS(3719),
    [anon_sym_RBRACK] = ACTIONS(3719),
    [anon_sym_LPAREN] = ACTIONS(3719),
    [anon_sym_RPAREN] = ACTIONS(3719),
    [anon_sym_LBRACE] = ACTIONS(3719),
    [anon_sym_RBRACE] = ACTIONS(3719),
    [anon_sym_LT] = ACTIONS(3721),
    [anon_sym_GT] = ACTIONS(3721),
    [anon_sym_in] = ACTIONS(3721),
    [anon_sym_where] = ACTIONS(3719),
    [anon_sym_QMARK] = ACTIONS(3721),
    [anon_sym_BANG] = ACTIONS(3721),
    [anon_sym_PLUS_PLUS] = ACTIONS(3719),
    [anon_sym_DASH_DASH] = ACTIONS(3719),
    [anon_sym_PLUS] = ACTIONS(3721),
    [anon_sym_DASH] = ACTIONS(3721),
    [anon_sym_STAR] = ACTIONS(3719),
    [anon_sym_SLASH] = ACTIONS(3721),
    [anon_sym_PERCENT] = ACTIONS(3719),
    [anon_sym_CARET] = ACTIONS(3719),
    [anon_sym_PIPE] = ACTIONS(3721),
    [anon_sym_AMP] = ACTIONS(3721),
    [anon_sym_LT_LT] = ACTIONS(3719),
    [anon_sym_GT_GT] = ACTIONS(3721),
    [anon_sym_GT_GT_GT] = ACTIONS(3719),
    [anon_sym_EQ_EQ] = ACTIONS(3719),
    [anon_sym_BANG_EQ] = ACTIONS(3719),
    [anon_sym_GT_EQ] = ACTIONS(3719),
    [anon_sym_LT_EQ] = ACTIONS(3719),
    [anon_sym_DOT] = ACTIONS(3721),
    [anon_sym_EQ_GT] = ACTIONS(3719),
    [anon_sym_COLON_COLON] = ACTIONS(3719),
    [anon_sym_switch] = ACTIONS(3719),
    [anon_sym_DOT_DOT] = ACTIONS(3719),
    [anon_sym_and] = ACTIONS(3719),
    [anon_sym_or] = ACTIONS(3721),
    [anon_sym_AMP_AMP] = ACTIONS(3719),
    [anon_sym_PIPE_PIPE] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK] = ACTIONS(3719),
    [anon_sym_from] = ACTIONS(3719),
    [anon_sym_into] = ACTIONS(3719),
    [anon_sym_join] = ACTIONS(3719),
    [anon_sym_on] = ACTIONS(3719),
    [anon_sym_equals] = ACTIONS(3719),
    [anon_sym_let] = ACTIONS(3719),
    [anon_sym_orderby] = ACTIONS(3719),
    [anon_sym_group] = ACTIONS(3719),
    [anon_sym_by] = ACTIONS(3719),
    [anon_sym_select] = ACTIONS(3719),
    [anon_sym_as] = ACTIONS(3719),
    [anon_sym_is] = ACTIONS(3719),
    [anon_sym_DASH_GT] = ACTIONS(3719),
    [anon_sym_with] = ACTIONS(3719),
    [aux_sym_preproc_if_token3] = ACTIONS(3719),
    [aux_sym_preproc_else_token1] = ACTIONS(3719),
    [aux_sym_preproc_elif_token1] = ACTIONS(3719),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3556] = {
    [sym_argument_list] = STATE(3614),
    [sym_bracketed_argument_list] = STATE(3009),
    [sym_preproc_region] = STATE(3556),
    [sym_preproc_endregion] = STATE(3556),
    [sym_preproc_line] = STATE(3556),
    [sym_preproc_pragma] = STATE(3556),
    [sym_preproc_nullable] = STATE(3556),
    [sym_preproc_error] = STATE(3556),
    [sym_preproc_define] = STATE(3556),
    [sym_preproc_undef] = STATE(3556),
    [anon_sym_SEMI] = ACTIONS(5233),
    [anon_sym_LBRACK] = ACTIONS(5235),
    [anon_sym_COLON] = ACTIONS(5233),
    [anon_sym_COMMA] = ACTIONS(5233),
    [anon_sym_RBRACK] = ACTIONS(5233),
    [anon_sym_LPAREN] = ACTIONS(5187),
    [anon_sym_RPAREN] = ACTIONS(5233),
    [anon_sym_RBRACE] = ACTIONS(5233),
    [anon_sym_LT] = ACTIONS(5237),
    [anon_sym_GT] = ACTIONS(5237),
    [anon_sym_in] = ACTIONS(5237),
    [anon_sym_where] = ACTIONS(5233),
    [anon_sym_QMARK] = ACTIONS(5237),
    [anon_sym_BANG] = ACTIONS(5239),
    [anon_sym_PLUS_PLUS] = ACTIONS(5241),
    [anon_sym_DASH_DASH] = ACTIONS(5241),
    [anon_sym_PLUS] = ACTIONS(5237),
    [anon_sym_DASH] = ACTIONS(5237),
    [anon_sym_STAR] = ACTIONS(5233),
    [anon_sym_SLASH] = ACTIONS(5237),
    [anon_sym_PERCENT] = ACTIONS(5233),
    [anon_sym_CARET] = ACTIONS(5233),
    [anon_sym_PIPE] = ACTIONS(5237),
    [anon_sym_AMP] = ACTIONS(5237),
    [anon_sym_LT_LT] = ACTIONS(5233),
    [anon_sym_GT_GT] = ACTIONS(5237),
    [anon_sym_GT_GT_GT] = ACTIONS(5233),
    [anon_sym_EQ_EQ] = ACTIONS(5233),
    [anon_sym_BANG_EQ] = ACTIONS(5233),
    [anon_sym_GT_EQ] = ACTIONS(5233),
    [anon_sym_LT_EQ] = ACTIONS(5233),
    [anon_sym_DOT] = ACTIONS(5193),
    [anon_sym_EQ_GT] = ACTIONS(5233),
    [anon_sym_switch] = ACTIONS(5233),
    [anon_sym_DOT_DOT] = ACTIONS(5233),
    [anon_sym_and] = ACTIONS(5233),
    [anon_sym_or] = ACTIONS(5237),
    [anon_sym_AMP_AMP] = ACTIONS(5233),
    [anon_sym_PIPE_PIPE] = ACTIONS(5233),
    [anon_sym_QMARK_QMARK] = ACTIONS(5233),
    [anon_sym_from] = ACTIONS(5233),
    [anon_sym_into] = ACTIONS(5233),
    [anon_sym_join] = ACTIONS(5233),
    [anon_sym_on] = ACTIONS(5233),
    [anon_sym_equals] = ACTIONS(5233),
    [anon_sym_let] = ACTIONS(5233),
    [anon_sym_orderby] = ACTIONS(5233),
    [anon_sym_group] = ACTIONS(5233),
    [anon_sym_by] = ACTIONS(5233),
    [anon_sym_select] = ACTIONS(5233),
    [anon_sym_as] = ACTIONS(5233),
    [anon_sym_is] = ACTIONS(5233),
    [anon_sym_DASH_GT] = ACTIONS(5177),
    [anon_sym_with] = ACTIONS(5233),
    [aux_sym_preproc_if_token3] = ACTIONS(5233),
    [aux_sym_preproc_else_token1] = ACTIONS(5233),
    [aux_sym_preproc_elif_token1] = ACTIONS(5233),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3557] = {
    [sym_argument_list] = STATE(3614),
    [sym_bracketed_argument_list] = STATE(3009),
    [sym_preproc_region] = STATE(3557),
    [sym_preproc_endregion] = STATE(3557),
    [sym_preproc_line] = STATE(3557),
    [sym_preproc_pragma] = STATE(3557),
    [sym_preproc_nullable] = STATE(3557),
    [sym_preproc_error] = STATE(3557),
    [sym_preproc_define] = STATE(3557),
    [sym_preproc_undef] = STATE(3557),
    [anon_sym_SEMI] = ACTIONS(5243),
    [anon_sym_LBRACK] = ACTIONS(5235),
    [anon_sym_COLON] = ACTIONS(5243),
    [anon_sym_COMMA] = ACTIONS(5243),
    [anon_sym_RBRACK] = ACTIONS(5243),
    [anon_sym_LPAREN] = ACTIONS(5187),
    [anon_sym_RPAREN] = ACTIONS(5243),
    [anon_sym_RBRACE] = ACTIONS(5243),
    [anon_sym_LT] = ACTIONS(5245),
    [anon_sym_GT] = ACTIONS(5245),
    [anon_sym_in] = ACTIONS(5245),
    [anon_sym_where] = ACTIONS(5243),
    [anon_sym_QMARK] = ACTIONS(5245),
    [anon_sym_BANG] = ACTIONS(5239),
    [anon_sym_PLUS_PLUS] = ACTIONS(5241),
    [anon_sym_DASH_DASH] = ACTIONS(5241),
    [anon_sym_PLUS] = ACTIONS(5245),
    [anon_sym_DASH] = ACTIONS(5245),
    [anon_sym_STAR] = ACTIONS(5243),
    [anon_sym_SLASH] = ACTIONS(5245),
    [anon_sym_PERCENT] = ACTIONS(5243),
    [anon_sym_CARET] = ACTIONS(5243),
    [anon_sym_PIPE] = ACTIONS(5245),
    [anon_sym_AMP] = ACTIONS(5245),
    [anon_sym_LT_LT] = ACTIONS(5243),
    [anon_sym_GT_GT] = ACTIONS(5245),
    [anon_sym_GT_GT_GT] = ACTIONS(5243),
    [anon_sym_EQ_EQ] = ACTIONS(5243),
    [anon_sym_BANG_EQ] = ACTIONS(5243),
    [anon_sym_GT_EQ] = ACTIONS(5243),
    [anon_sym_LT_EQ] = ACTIONS(5243),
    [anon_sym_DOT] = ACTIONS(5193),
    [anon_sym_EQ_GT] = ACTIONS(5243),
    [anon_sym_switch] = ACTIONS(5243),
    [anon_sym_DOT_DOT] = ACTIONS(5243),
    [anon_sym_and] = ACTIONS(5243),
    [anon_sym_or] = ACTIONS(5245),
    [anon_sym_AMP_AMP] = ACTIONS(5243),
    [anon_sym_PIPE_PIPE] = ACTIONS(5243),
    [anon_sym_QMARK_QMARK] = ACTIONS(5243),
    [anon_sym_from] = ACTIONS(5243),
    [anon_sym_into] = ACTIONS(5243),
    [anon_sym_join] = ACTIONS(5243),
    [anon_sym_on] = ACTIONS(5243),
    [anon_sym_equals] = ACTIONS(5243),
    [anon_sym_let] = ACTIONS(5243),
    [anon_sym_orderby] = ACTIONS(5243),
    [anon_sym_group] = ACTIONS(5243),
    [anon_sym_by] = ACTIONS(5243),
    [anon_sym_select] = ACTIONS(5243),
    [anon_sym_as] = ACTIONS(5243),
    [anon_sym_is] = ACTIONS(5243),
    [anon_sym_DASH_GT] = ACTIONS(5177),
    [anon_sym_with] = ACTIONS(5243),
    [aux_sym_preproc_if_token3] = ACTIONS(5243),
    [aux_sym_preproc_else_token1] = ACTIONS(5243),
    [aux_sym_preproc_elif_token1] = ACTIONS(5243),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3558] = {
    [sym_preproc_region] = STATE(3558),
    [sym_preproc_endregion] = STATE(3558),
    [sym_preproc_line] = STATE(3558),
    [sym_preproc_pragma] = STATE(3558),
    [sym_preproc_nullable] = STATE(3558),
    [sym_preproc_error] = STATE(3558),
    [sym_preproc_define] = STATE(3558),
    [sym_preproc_undef] = STATE(3558),
    [anon_sym_SEMI] = ACTIONS(4058),
    [anon_sym_LBRACK] = ACTIONS(4058),
    [anon_sym_COLON] = ACTIONS(4056),
    [anon_sym_COMMA] = ACTIONS(4058),
    [anon_sym_RBRACK] = ACTIONS(4058),
    [anon_sym_LPAREN] = ACTIONS(4058),
    [anon_sym_RPAREN] = ACTIONS(4058),
    [anon_sym_LBRACE] = ACTIONS(4058),
    [anon_sym_RBRACE] = ACTIONS(4058),
    [anon_sym_LT] = ACTIONS(4056),
    [anon_sym_GT] = ACTIONS(4056),
    [anon_sym_in] = ACTIONS(4056),
    [anon_sym_where] = ACTIONS(4058),
    [anon_sym_QMARK] = ACTIONS(4056),
    [anon_sym_BANG] = ACTIONS(4056),
    [anon_sym_PLUS_PLUS] = ACTIONS(4058),
    [anon_sym_DASH_DASH] = ACTIONS(4058),
    [anon_sym_PLUS] = ACTIONS(4056),
    [anon_sym_DASH] = ACTIONS(4056),
    [anon_sym_STAR] = ACTIONS(4058),
    [anon_sym_SLASH] = ACTIONS(4056),
    [anon_sym_PERCENT] = ACTIONS(4058),
    [anon_sym_CARET] = ACTIONS(4058),
    [anon_sym_PIPE] = ACTIONS(4056),
    [anon_sym_AMP] = ACTIONS(4056),
    [anon_sym_LT_LT] = ACTIONS(4058),
    [anon_sym_GT_GT] = ACTIONS(4056),
    [anon_sym_GT_GT_GT] = ACTIONS(4058),
    [anon_sym_EQ_EQ] = ACTIONS(4058),
    [anon_sym_BANG_EQ] = ACTIONS(4058),
    [anon_sym_GT_EQ] = ACTIONS(4058),
    [anon_sym_LT_EQ] = ACTIONS(4058),
    [anon_sym_DOT] = ACTIONS(4056),
    [anon_sym_EQ_GT] = ACTIONS(4058),
    [anon_sym_COLON_COLON] = ACTIONS(4058),
    [anon_sym_switch] = ACTIONS(4058),
    [anon_sym_DOT_DOT] = ACTIONS(4058),
    [anon_sym_and] = ACTIONS(4058),
    [anon_sym_or] = ACTIONS(4056),
    [anon_sym_AMP_AMP] = ACTIONS(4058),
    [anon_sym_PIPE_PIPE] = ACTIONS(4058),
    [anon_sym_QMARK_QMARK] = ACTIONS(4058),
    [anon_sym_from] = ACTIONS(4058),
    [anon_sym_into] = ACTIONS(4058),
    [anon_sym_join] = ACTIONS(4058),
    [anon_sym_on] = ACTIONS(4058),
    [anon_sym_equals] = ACTIONS(4058),
    [anon_sym_let] = ACTIONS(4058),
    [anon_sym_orderby] = ACTIONS(4058),
    [anon_sym_group] = ACTIONS(4058),
    [anon_sym_by] = ACTIONS(4058),
    [anon_sym_select] = ACTIONS(4058),
    [anon_sym_as] = ACTIONS(4058),
    [anon_sym_is] = ACTIONS(4058),
    [anon_sym_DASH_GT] = ACTIONS(4058),
    [anon_sym_with] = ACTIONS(4058),
    [aux_sym_preproc_if_token3] = ACTIONS(4058),
    [aux_sym_preproc_else_token1] = ACTIONS(4058),
    [aux_sym_preproc_elif_token1] = ACTIONS(4058),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3559] = {
    [sym_preproc_region] = STATE(3559),
    [sym_preproc_endregion] = STATE(3559),
    [sym_preproc_line] = STATE(3559),
    [sym_preproc_pragma] = STATE(3559),
    [sym_preproc_nullable] = STATE(3559),
    [sym_preproc_error] = STATE(3559),
    [sym_preproc_define] = STATE(3559),
    [sym_preproc_undef] = STATE(3559),
    [anon_sym_EQ] = ACTIONS(4625),
    [anon_sym_LBRACK] = ACTIONS(4623),
    [anon_sym_COMMA] = ACTIONS(4623),
    [anon_sym_LPAREN] = ACTIONS(4623),
    [anon_sym_LT] = ACTIONS(4625),
    [anon_sym_GT] = ACTIONS(4625),
    [anon_sym_where] = ACTIONS(4623),
    [anon_sym_QMARK] = ACTIONS(4625),
    [anon_sym_BANG] = ACTIONS(4625),
    [anon_sym_PLUS_PLUS] = ACTIONS(4623),
    [anon_sym_DASH_DASH] = ACTIONS(4623),
    [anon_sym_PLUS] = ACTIONS(4625),
    [anon_sym_DASH] = ACTIONS(4625),
    [anon_sym_STAR] = ACTIONS(4625),
    [anon_sym_SLASH] = ACTIONS(4625),
    [anon_sym_PERCENT] = ACTIONS(4625),
    [anon_sym_CARET] = ACTIONS(4625),
    [anon_sym_PIPE] = ACTIONS(4625),
    [anon_sym_AMP] = ACTIONS(4625),
    [anon_sym_LT_LT] = ACTIONS(4625),
    [anon_sym_GT_GT] = ACTIONS(4625),
    [anon_sym_GT_GT_GT] = ACTIONS(4625),
    [anon_sym_EQ_EQ] = ACTIONS(4623),
    [anon_sym_BANG_EQ] = ACTIONS(4623),
    [anon_sym_GT_EQ] = ACTIONS(4623),
    [anon_sym_LT_EQ] = ACTIONS(4623),
    [anon_sym_DOT] = ACTIONS(4625),
    [anon_sym_switch] = ACTIONS(4623),
    [anon_sym_DOT_DOT] = ACTIONS(4623),
    [anon_sym_and] = ACTIONS(4623),
    [anon_sym_or] = ACTIONS(4625),
    [anon_sym_PLUS_EQ] = ACTIONS(4623),
    [anon_sym_DASH_EQ] = ACTIONS(4623),
    [anon_sym_STAR_EQ] = ACTIONS(4623),
    [anon_sym_SLASH_EQ] = ACTIONS(4623),
    [anon_sym_PERCENT_EQ] = ACTIONS(4623),
    [anon_sym_AMP_EQ] = ACTIONS(4623),
    [anon_sym_CARET_EQ] = ACTIONS(4623),
    [anon_sym_PIPE_EQ] = ACTIONS(4623),
    [anon_sym_LT_LT_EQ] = ACTIONS(4623),
    [anon_sym_GT_GT_EQ] = ACTIONS(4623),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4623),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4623),
    [anon_sym_AMP_AMP] = ACTIONS(4623),
    [anon_sym_PIPE_PIPE] = ACTIONS(4623),
    [anon_sym_QMARK_QMARK] = ACTIONS(4625),
    [anon_sym_from] = ACTIONS(4623),
    [anon_sym_into] = ACTIONS(4623),
    [anon_sym_join] = ACTIONS(4623),
    [anon_sym_let] = ACTIONS(4623),
    [anon_sym_orderby] = ACTIONS(4623),
    [anon_sym_ascending] = ACTIONS(4623),
    [anon_sym_descending] = ACTIONS(4623),
    [anon_sym_group] = ACTIONS(4623),
    [anon_sym_select] = ACTIONS(4623),
    [anon_sym_as] = ACTIONS(4625),
    [anon_sym_is] = ACTIONS(4623),
    [anon_sym_DASH_GT] = ACTIONS(4623),
    [anon_sym_with] = ACTIONS(4623),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3560] = {
    [sym_preproc_region] = STATE(3560),
    [sym_preproc_endregion] = STATE(3560),
    [sym_preproc_line] = STATE(3560),
    [sym_preproc_pragma] = STATE(3560),
    [sym_preproc_nullable] = STATE(3560),
    [sym_preproc_error] = STATE(3560),
    [sym_preproc_define] = STATE(3560),
    [sym_preproc_undef] = STATE(3560),
    [anon_sym_EQ] = ACTIONS(4118),
    [anon_sym_LBRACK] = ACTIONS(4133),
    [anon_sym_COMMA] = ACTIONS(4133),
    [anon_sym_LPAREN] = ACTIONS(4133),
    [anon_sym_LT] = ACTIONS(4118),
    [anon_sym_GT] = ACTIONS(4118),
    [anon_sym_where] = ACTIONS(4133),
    [anon_sym_QMARK] = ACTIONS(4118),
    [anon_sym_BANG] = ACTIONS(4118),
    [anon_sym_PLUS_PLUS] = ACTIONS(4133),
    [anon_sym_DASH_DASH] = ACTIONS(4133),
    [anon_sym_PLUS] = ACTIONS(4118),
    [anon_sym_DASH] = ACTIONS(4118),
    [anon_sym_STAR] = ACTIONS(4118),
    [anon_sym_SLASH] = ACTIONS(4118),
    [anon_sym_PERCENT] = ACTIONS(4118),
    [anon_sym_CARET] = ACTIONS(4118),
    [anon_sym_PIPE] = ACTIONS(4118),
    [anon_sym_AMP] = ACTIONS(4118),
    [anon_sym_LT_LT] = ACTIONS(4118),
    [anon_sym_GT_GT] = ACTIONS(4118),
    [anon_sym_GT_GT_GT] = ACTIONS(4118),
    [anon_sym_EQ_EQ] = ACTIONS(4133),
    [anon_sym_BANG_EQ] = ACTIONS(4133),
    [anon_sym_GT_EQ] = ACTIONS(4133),
    [anon_sym_LT_EQ] = ACTIONS(4133),
    [anon_sym_DOT] = ACTIONS(4118),
    [anon_sym_switch] = ACTIONS(4133),
    [anon_sym_DOT_DOT] = ACTIONS(4133),
    [anon_sym_and] = ACTIONS(4133),
    [anon_sym_or] = ACTIONS(4118),
    [anon_sym_PLUS_EQ] = ACTIONS(4133),
    [anon_sym_DASH_EQ] = ACTIONS(4133),
    [anon_sym_STAR_EQ] = ACTIONS(4133),
    [anon_sym_SLASH_EQ] = ACTIONS(4133),
    [anon_sym_PERCENT_EQ] = ACTIONS(4133),
    [anon_sym_AMP_EQ] = ACTIONS(4133),
    [anon_sym_CARET_EQ] = ACTIONS(4133),
    [anon_sym_PIPE_EQ] = ACTIONS(4133),
    [anon_sym_LT_LT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4133),
    [anon_sym_AMP_AMP] = ACTIONS(4133),
    [anon_sym_PIPE_PIPE] = ACTIONS(4133),
    [anon_sym_QMARK_QMARK] = ACTIONS(4118),
    [anon_sym_from] = ACTIONS(4133),
    [anon_sym_into] = ACTIONS(4133),
    [anon_sym_join] = ACTIONS(4133),
    [anon_sym_let] = ACTIONS(4133),
    [anon_sym_orderby] = ACTIONS(4133),
    [anon_sym_ascending] = ACTIONS(4133),
    [anon_sym_descending] = ACTIONS(4133),
    [anon_sym_group] = ACTIONS(4133),
    [anon_sym_select] = ACTIONS(4133),
    [anon_sym_as] = ACTIONS(4118),
    [anon_sym_is] = ACTIONS(4133),
    [anon_sym_DASH_GT] = ACTIONS(4133),
    [anon_sym_with] = ACTIONS(4133),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3561] = {
    [sym_preproc_region] = STATE(3561),
    [sym_preproc_endregion] = STATE(3561),
    [sym_preproc_line] = STATE(3561),
    [sym_preproc_pragma] = STATE(3561),
    [sym_preproc_nullable] = STATE(3561),
    [sym_preproc_error] = STATE(3561),
    [sym_preproc_define] = STATE(3561),
    [sym_preproc_undef] = STATE(3561),
    [anon_sym_EQ] = ACTIONS(5247),
    [anon_sym_LBRACK] = ACTIONS(5249),
    [anon_sym_COMMA] = ACTIONS(5249),
    [anon_sym_LPAREN] = ACTIONS(5249),
    [anon_sym_LT] = ACTIONS(5251),
    [anon_sym_GT] = ACTIONS(5251),
    [anon_sym_where] = ACTIONS(5249),
    [anon_sym_QMARK] = ACTIONS(5251),
    [anon_sym_BANG] = ACTIONS(5251),
    [anon_sym_PLUS_PLUS] = ACTIONS(5249),
    [anon_sym_DASH_DASH] = ACTIONS(5249),
    [anon_sym_PLUS] = ACTIONS(5251),
    [anon_sym_DASH] = ACTIONS(5251),
    [anon_sym_STAR] = ACTIONS(5251),
    [anon_sym_SLASH] = ACTIONS(5251),
    [anon_sym_PERCENT] = ACTIONS(5251),
    [anon_sym_CARET] = ACTIONS(5251),
    [anon_sym_PIPE] = ACTIONS(5251),
    [anon_sym_AMP] = ACTIONS(5251),
    [anon_sym_LT_LT] = ACTIONS(5251),
    [anon_sym_GT_GT] = ACTIONS(5251),
    [anon_sym_GT_GT_GT] = ACTIONS(5251),
    [anon_sym_EQ_EQ] = ACTIONS(5249),
    [anon_sym_BANG_EQ] = ACTIONS(5249),
    [anon_sym_GT_EQ] = ACTIONS(5249),
    [anon_sym_LT_EQ] = ACTIONS(5249),
    [anon_sym_DOT] = ACTIONS(5251),
    [anon_sym_switch] = ACTIONS(5249),
    [anon_sym_DOT_DOT] = ACTIONS(5249),
    [anon_sym_and] = ACTIONS(5249),
    [anon_sym_or] = ACTIONS(5251),
    [anon_sym_PLUS_EQ] = ACTIONS(5253),
    [anon_sym_DASH_EQ] = ACTIONS(5253),
    [anon_sym_STAR_EQ] = ACTIONS(5253),
    [anon_sym_SLASH_EQ] = ACTIONS(5253),
    [anon_sym_PERCENT_EQ] = ACTIONS(5253),
    [anon_sym_AMP_EQ] = ACTIONS(5253),
    [anon_sym_CARET_EQ] = ACTIONS(5253),
    [anon_sym_PIPE_EQ] = ACTIONS(5253),
    [anon_sym_LT_LT_EQ] = ACTIONS(5253),
    [anon_sym_GT_GT_EQ] = ACTIONS(5253),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5253),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(5253),
    [anon_sym_AMP_AMP] = ACTIONS(5249),
    [anon_sym_PIPE_PIPE] = ACTIONS(5249),
    [anon_sym_QMARK_QMARK] = ACTIONS(5251),
    [anon_sym_from] = ACTIONS(5249),
    [anon_sym_into] = ACTIONS(5249),
    [anon_sym_join] = ACTIONS(5249),
    [anon_sym_let] = ACTIONS(5249),
    [anon_sym_orderby] = ACTIONS(5249),
    [anon_sym_ascending] = ACTIONS(5249),
    [anon_sym_descending] = ACTIONS(5249),
    [anon_sym_group] = ACTIONS(5249),
    [anon_sym_select] = ACTIONS(5249),
    [anon_sym_as] = ACTIONS(5251),
    [anon_sym_is] = ACTIONS(5249),
    [anon_sym_DASH_GT] = ACTIONS(5249),
    [anon_sym_with] = ACTIONS(5249),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3562] = {
    [sym_preproc_region] = STATE(3562),
    [sym_preproc_endregion] = STATE(3562),
    [sym_preproc_line] = STATE(3562),
    [sym_preproc_pragma] = STATE(3562),
    [sym_preproc_nullable] = STATE(3562),
    [sym_preproc_error] = STATE(3562),
    [sym_preproc_define] = STATE(3562),
    [sym_preproc_undef] = STATE(3562),
    [anon_sym_EQ] = ACTIONS(4590),
    [anon_sym_LBRACK] = ACTIONS(4588),
    [anon_sym_COMMA] = ACTIONS(4588),
    [anon_sym_LPAREN] = ACTIONS(4588),
    [anon_sym_LT] = ACTIONS(4590),
    [anon_sym_GT] = ACTIONS(4590),
    [anon_sym_where] = ACTIONS(4588),
    [anon_sym_QMARK] = ACTIONS(4590),
    [anon_sym_BANG] = ACTIONS(4590),
    [anon_sym_PLUS_PLUS] = ACTIONS(4588),
    [anon_sym_DASH_DASH] = ACTIONS(4588),
    [anon_sym_PLUS] = ACTIONS(4590),
    [anon_sym_DASH] = ACTIONS(4590),
    [anon_sym_STAR] = ACTIONS(4590),
    [anon_sym_SLASH] = ACTIONS(4590),
    [anon_sym_PERCENT] = ACTIONS(4590),
    [anon_sym_CARET] = ACTIONS(4590),
    [anon_sym_PIPE] = ACTIONS(4590),
    [anon_sym_AMP] = ACTIONS(4590),
    [anon_sym_LT_LT] = ACTIONS(4590),
    [anon_sym_GT_GT] = ACTIONS(4590),
    [anon_sym_GT_GT_GT] = ACTIONS(4590),
    [anon_sym_EQ_EQ] = ACTIONS(4588),
    [anon_sym_BANG_EQ] = ACTIONS(4588),
    [anon_sym_GT_EQ] = ACTIONS(4588),
    [anon_sym_LT_EQ] = ACTIONS(4588),
    [anon_sym_DOT] = ACTIONS(4590),
    [anon_sym_switch] = ACTIONS(4588),
    [anon_sym_DOT_DOT] = ACTIONS(4588),
    [anon_sym_and] = ACTIONS(4588),
    [anon_sym_or] = ACTIONS(4590),
    [anon_sym_PLUS_EQ] = ACTIONS(4588),
    [anon_sym_DASH_EQ] = ACTIONS(4588),
    [anon_sym_STAR_EQ] = ACTIONS(4588),
    [anon_sym_SLASH_EQ] = ACTIONS(4588),
    [anon_sym_PERCENT_EQ] = ACTIONS(4588),
    [anon_sym_AMP_EQ] = ACTIONS(4588),
    [anon_sym_CARET_EQ] = ACTIONS(4588),
    [anon_sym_PIPE_EQ] = ACTIONS(4588),
    [anon_sym_LT_LT_EQ] = ACTIONS(4588),
    [anon_sym_GT_GT_EQ] = ACTIONS(4588),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4588),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4588),
    [anon_sym_AMP_AMP] = ACTIONS(4588),
    [anon_sym_PIPE_PIPE] = ACTIONS(4588),
    [anon_sym_QMARK_QMARK] = ACTIONS(4590),
    [anon_sym_from] = ACTIONS(4588),
    [anon_sym_into] = ACTIONS(4588),
    [anon_sym_join] = ACTIONS(4588),
    [anon_sym_let] = ACTIONS(4588),
    [anon_sym_orderby] = ACTIONS(4588),
    [anon_sym_ascending] = ACTIONS(4588),
    [anon_sym_descending] = ACTIONS(4588),
    [anon_sym_group] = ACTIONS(4588),
    [anon_sym_select] = ACTIONS(4588),
    [anon_sym_as] = ACTIONS(4590),
    [anon_sym_is] = ACTIONS(4588),
    [anon_sym_DASH_GT] = ACTIONS(4588),
    [anon_sym_with] = ACTIONS(4588),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3563] = {
    [sym_preproc_region] = STATE(3563),
    [sym_preproc_endregion] = STATE(3563),
    [sym_preproc_line] = STATE(3563),
    [sym_preproc_pragma] = STATE(3563),
    [sym_preproc_nullable] = STATE(3563),
    [sym_preproc_error] = STATE(3563),
    [sym_preproc_define] = STATE(3563),
    [sym_preproc_undef] = STATE(3563),
    [anon_sym_EQ] = ACTIONS(4606),
    [anon_sym_LBRACK] = ACTIONS(4604),
    [anon_sym_COMMA] = ACTIONS(4604),
    [anon_sym_LPAREN] = ACTIONS(4604),
    [anon_sym_LT] = ACTIONS(4606),
    [anon_sym_GT] = ACTIONS(4606),
    [anon_sym_where] = ACTIONS(4604),
    [anon_sym_QMARK] = ACTIONS(4606),
    [anon_sym_BANG] = ACTIONS(4606),
    [anon_sym_PLUS_PLUS] = ACTIONS(4604),
    [anon_sym_DASH_DASH] = ACTIONS(4604),
    [anon_sym_PLUS] = ACTIONS(4606),
    [anon_sym_DASH] = ACTIONS(4606),
    [anon_sym_STAR] = ACTIONS(4606),
    [anon_sym_SLASH] = ACTIONS(4606),
    [anon_sym_PERCENT] = ACTIONS(4606),
    [anon_sym_CARET] = ACTIONS(4606),
    [anon_sym_PIPE] = ACTIONS(4606),
    [anon_sym_AMP] = ACTIONS(4606),
    [anon_sym_LT_LT] = ACTIONS(4606),
    [anon_sym_GT_GT] = ACTIONS(4606),
    [anon_sym_GT_GT_GT] = ACTIONS(4606),
    [anon_sym_EQ_EQ] = ACTIONS(4604),
    [anon_sym_BANG_EQ] = ACTIONS(4604),
    [anon_sym_GT_EQ] = ACTIONS(4604),
    [anon_sym_LT_EQ] = ACTIONS(4604),
    [anon_sym_DOT] = ACTIONS(4606),
    [anon_sym_switch] = ACTIONS(4604),
    [anon_sym_DOT_DOT] = ACTIONS(4604),
    [anon_sym_and] = ACTIONS(4604),
    [anon_sym_or] = ACTIONS(4606),
    [anon_sym_PLUS_EQ] = ACTIONS(4604),
    [anon_sym_DASH_EQ] = ACTIONS(4604),
    [anon_sym_STAR_EQ] = ACTIONS(4604),
    [anon_sym_SLASH_EQ] = ACTIONS(4604),
    [anon_sym_PERCENT_EQ] = ACTIONS(4604),
    [anon_sym_AMP_EQ] = ACTIONS(4604),
    [anon_sym_CARET_EQ] = ACTIONS(4604),
    [anon_sym_PIPE_EQ] = ACTIONS(4604),
    [anon_sym_LT_LT_EQ] = ACTIONS(4604),
    [anon_sym_GT_GT_EQ] = ACTIONS(4604),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4604),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4604),
    [anon_sym_AMP_AMP] = ACTIONS(4604),
    [anon_sym_PIPE_PIPE] = ACTIONS(4604),
    [anon_sym_QMARK_QMARK] = ACTIONS(4606),
    [anon_sym_from] = ACTIONS(4604),
    [anon_sym_into] = ACTIONS(4604),
    [anon_sym_join] = ACTIONS(4604),
    [anon_sym_let] = ACTIONS(4604),
    [anon_sym_orderby] = ACTIONS(4604),
    [anon_sym_ascending] = ACTIONS(4604),
    [anon_sym_descending] = ACTIONS(4604),
    [anon_sym_group] = ACTIONS(4604),
    [anon_sym_select] = ACTIONS(4604),
    [anon_sym_as] = ACTIONS(4606),
    [anon_sym_is] = ACTIONS(4604),
    [anon_sym_DASH_GT] = ACTIONS(4604),
    [anon_sym_with] = ACTIONS(4604),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3564] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7090),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9081),
    [sym_identifier] = STATE(6700),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(3564),
    [sym_preproc_endregion] = STATE(3564),
    [sym_preproc_line] = STATE(3564),
    [sym_preproc_pragma] = STATE(3564),
    [sym_preproc_nullable] = STATE(3564),
    [sym_preproc_error] = STATE(3564),
    [sym_preproc_define] = STATE(3564),
    [sym_preproc_undef] = STATE(3564),
    [aux_sym_class_declaration_repeat1] = STATE(6230),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4206),
    [aux_sym_lambda_expression_repeat1] = STATE(4158),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(5212),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(5216),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_readonly] = ACTIONS(1093),
    [anon_sym_in] = ACTIONS(1093),
    [anon_sym_out] = ACTIONS(1093),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_this] = ACTIONS(1093),
    [anon_sym_scoped] = ACTIONS(5222),
    [anon_sym_params] = ACTIONS(5224),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3565] = {
    [sym_argument_list] = STATE(3614),
    [sym_bracketed_argument_list] = STATE(3009),
    [sym_preproc_region] = STATE(3565),
    [sym_preproc_endregion] = STATE(3565),
    [sym_preproc_line] = STATE(3565),
    [sym_preproc_pragma] = STATE(3565),
    [sym_preproc_nullable] = STATE(3565),
    [sym_preproc_error] = STATE(3565),
    [sym_preproc_define] = STATE(3565),
    [sym_preproc_undef] = STATE(3565),
    [anon_sym_SEMI] = ACTIONS(5255),
    [anon_sym_LBRACK] = ACTIONS(5235),
    [anon_sym_COLON] = ACTIONS(5255),
    [anon_sym_COMMA] = ACTIONS(5255),
    [anon_sym_RBRACK] = ACTIONS(5255),
    [anon_sym_LPAREN] = ACTIONS(5187),
    [anon_sym_RPAREN] = ACTIONS(5255),
    [anon_sym_RBRACE] = ACTIONS(5255),
    [anon_sym_LT] = ACTIONS(5257),
    [anon_sym_GT] = ACTIONS(5257),
    [anon_sym_in] = ACTIONS(5257),
    [anon_sym_where] = ACTIONS(5255),
    [anon_sym_QMARK] = ACTIONS(5257),
    [anon_sym_BANG] = ACTIONS(5239),
    [anon_sym_PLUS_PLUS] = ACTIONS(5241),
    [anon_sym_DASH_DASH] = ACTIONS(5241),
    [anon_sym_PLUS] = ACTIONS(5257),
    [anon_sym_DASH] = ACTIONS(5257),
    [anon_sym_STAR] = ACTIONS(5255),
    [anon_sym_SLASH] = ACTIONS(5257),
    [anon_sym_PERCENT] = ACTIONS(5255),
    [anon_sym_CARET] = ACTIONS(5255),
    [anon_sym_PIPE] = ACTIONS(5257),
    [anon_sym_AMP] = ACTIONS(5257),
    [anon_sym_LT_LT] = ACTIONS(5255),
    [anon_sym_GT_GT] = ACTIONS(5257),
    [anon_sym_GT_GT_GT] = ACTIONS(5255),
    [anon_sym_EQ_EQ] = ACTIONS(5255),
    [anon_sym_BANG_EQ] = ACTIONS(5255),
    [anon_sym_GT_EQ] = ACTIONS(5255),
    [anon_sym_LT_EQ] = ACTIONS(5255),
    [anon_sym_DOT] = ACTIONS(5193),
    [anon_sym_EQ_GT] = ACTIONS(5255),
    [anon_sym_switch] = ACTIONS(5255),
    [anon_sym_DOT_DOT] = ACTIONS(5255),
    [anon_sym_and] = ACTIONS(5255),
    [anon_sym_or] = ACTIONS(5257),
    [anon_sym_AMP_AMP] = ACTIONS(5255),
    [anon_sym_PIPE_PIPE] = ACTIONS(5255),
    [anon_sym_QMARK_QMARK] = ACTIONS(5255),
    [anon_sym_from] = ACTIONS(5255),
    [anon_sym_into] = ACTIONS(5255),
    [anon_sym_join] = ACTIONS(5255),
    [anon_sym_on] = ACTIONS(5255),
    [anon_sym_equals] = ACTIONS(5255),
    [anon_sym_let] = ACTIONS(5255),
    [anon_sym_orderby] = ACTIONS(5255),
    [anon_sym_group] = ACTIONS(5255),
    [anon_sym_by] = ACTIONS(5255),
    [anon_sym_select] = ACTIONS(5255),
    [anon_sym_as] = ACTIONS(5255),
    [anon_sym_is] = ACTIONS(5255),
    [anon_sym_DASH_GT] = ACTIONS(5177),
    [anon_sym_with] = ACTIONS(5255),
    [aux_sym_preproc_if_token3] = ACTIONS(5255),
    [aux_sym_preproc_else_token1] = ACTIONS(5255),
    [aux_sym_preproc_elif_token1] = ACTIONS(5255),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3566] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(6997),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9311),
    [sym_identifier] = STATE(6700),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(3566),
    [sym_preproc_endregion] = STATE(3566),
    [sym_preproc_line] = STATE(3566),
    [sym_preproc_pragma] = STATE(3566),
    [sym_preproc_nullable] = STATE(3566),
    [sym_preproc_error] = STATE(3566),
    [sym_preproc_define] = STATE(3566),
    [sym_preproc_undef] = STATE(3566),
    [aux_sym_class_declaration_repeat1] = STATE(6230),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4206),
    [aux_sym_lambda_expression_repeat1] = STATE(4109),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(5212),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(5216),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_readonly] = ACTIONS(1093),
    [anon_sym_in] = ACTIONS(1093),
    [anon_sym_out] = ACTIONS(1093),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_this] = ACTIONS(1093),
    [anon_sym_scoped] = ACTIONS(5222),
    [anon_sym_params] = ACTIONS(5224),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3567] = {
    [sym_preproc_region] = STATE(3567),
    [sym_preproc_endregion] = STATE(3567),
    [sym_preproc_line] = STATE(3567),
    [sym_preproc_pragma] = STATE(3567),
    [sym_preproc_nullable] = STATE(3567),
    [sym_preproc_error] = STATE(3567),
    [sym_preproc_define] = STATE(3567),
    [sym_preproc_undef] = STATE(3567),
    [anon_sym_SEMI] = ACTIONS(4024),
    [anon_sym_LBRACK] = ACTIONS(4024),
    [anon_sym_COLON] = ACTIONS(4027),
    [anon_sym_COMMA] = ACTIONS(4024),
    [anon_sym_RBRACK] = ACTIONS(4024),
    [anon_sym_LPAREN] = ACTIONS(4024),
    [anon_sym_RPAREN] = ACTIONS(4024),
    [anon_sym_LBRACE] = ACTIONS(4024),
    [anon_sym_RBRACE] = ACTIONS(4024),
    [anon_sym_LT] = ACTIONS(4027),
    [anon_sym_GT] = ACTIONS(4027),
    [anon_sym_in] = ACTIONS(4027),
    [anon_sym_where] = ACTIONS(4024),
    [anon_sym_QMARK] = ACTIONS(4027),
    [anon_sym_BANG] = ACTIONS(4027),
    [anon_sym_PLUS_PLUS] = ACTIONS(4024),
    [anon_sym_DASH_DASH] = ACTIONS(4024),
    [anon_sym_PLUS] = ACTIONS(4027),
    [anon_sym_DASH] = ACTIONS(4027),
    [anon_sym_STAR] = ACTIONS(4024),
    [anon_sym_SLASH] = ACTIONS(4027),
    [anon_sym_PERCENT] = ACTIONS(4024),
    [anon_sym_CARET] = ACTIONS(4024),
    [anon_sym_PIPE] = ACTIONS(4027),
    [anon_sym_AMP] = ACTIONS(4027),
    [anon_sym_LT_LT] = ACTIONS(4024),
    [anon_sym_GT_GT] = ACTIONS(4027),
    [anon_sym_GT_GT_GT] = ACTIONS(4024),
    [anon_sym_EQ_EQ] = ACTIONS(4024),
    [anon_sym_BANG_EQ] = ACTIONS(4024),
    [anon_sym_GT_EQ] = ACTIONS(4024),
    [anon_sym_LT_EQ] = ACTIONS(4024),
    [anon_sym_DOT] = ACTIONS(4027),
    [anon_sym_EQ_GT] = ACTIONS(4024),
    [anon_sym_COLON_COLON] = ACTIONS(3719),
    [anon_sym_switch] = ACTIONS(4024),
    [anon_sym_DOT_DOT] = ACTIONS(4024),
    [anon_sym_and] = ACTIONS(4024),
    [anon_sym_or] = ACTIONS(4027),
    [anon_sym_AMP_AMP] = ACTIONS(4024),
    [anon_sym_PIPE_PIPE] = ACTIONS(4024),
    [anon_sym_QMARK_QMARK] = ACTIONS(4024),
    [anon_sym_from] = ACTIONS(4024),
    [anon_sym_into] = ACTIONS(4024),
    [anon_sym_join] = ACTIONS(4024),
    [anon_sym_on] = ACTIONS(4024),
    [anon_sym_equals] = ACTIONS(4024),
    [anon_sym_let] = ACTIONS(4024),
    [anon_sym_orderby] = ACTIONS(4024),
    [anon_sym_group] = ACTIONS(4024),
    [anon_sym_by] = ACTIONS(4024),
    [anon_sym_select] = ACTIONS(4024),
    [anon_sym_as] = ACTIONS(4024),
    [anon_sym_is] = ACTIONS(4024),
    [anon_sym_DASH_GT] = ACTIONS(4024),
    [anon_sym_with] = ACTIONS(4024),
    [aux_sym_preproc_if_token3] = ACTIONS(4024),
    [aux_sym_preproc_else_token1] = ACTIONS(4024),
    [aux_sym_preproc_elif_token1] = ACTIONS(4024),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3568] = {
    [sym_preproc_region] = STATE(3568),
    [sym_preproc_endregion] = STATE(3568),
    [sym_preproc_line] = STATE(3568),
    [sym_preproc_pragma] = STATE(3568),
    [sym_preproc_nullable] = STATE(3568),
    [sym_preproc_error] = STATE(3568),
    [sym_preproc_define] = STATE(3568),
    [sym_preproc_undef] = STATE(3568),
    [anon_sym_SEMI] = ACTIONS(4058),
    [anon_sym_LBRACK] = ACTIONS(4058),
    [anon_sym_COLON] = ACTIONS(4056),
    [anon_sym_COMMA] = ACTIONS(4058),
    [anon_sym_RBRACK] = ACTIONS(4058),
    [anon_sym_LPAREN] = ACTIONS(4058),
    [anon_sym_RPAREN] = ACTIONS(4058),
    [anon_sym_LBRACE] = ACTIONS(4058),
    [anon_sym_RBRACE] = ACTIONS(4058),
    [anon_sym_LT] = ACTIONS(4056),
    [anon_sym_GT] = ACTIONS(4056),
    [anon_sym_in] = ACTIONS(4058),
    [anon_sym_where] = ACTIONS(4058),
    [anon_sym_QMARK] = ACTIONS(4056),
    [anon_sym_BANG] = ACTIONS(4056),
    [anon_sym_PLUS_PLUS] = ACTIONS(4058),
    [anon_sym_DASH_DASH] = ACTIONS(4058),
    [anon_sym_PLUS] = ACTIONS(4056),
    [anon_sym_DASH] = ACTIONS(4056),
    [anon_sym_STAR] = ACTIONS(4058),
    [anon_sym_SLASH] = ACTIONS(4056),
    [anon_sym_PERCENT] = ACTIONS(4058),
    [anon_sym_CARET] = ACTIONS(4058),
    [anon_sym_PIPE] = ACTIONS(4056),
    [anon_sym_AMP] = ACTIONS(4056),
    [anon_sym_LT_LT] = ACTIONS(4058),
    [anon_sym_GT_GT] = ACTIONS(4056),
    [anon_sym_GT_GT_GT] = ACTIONS(4058),
    [anon_sym_EQ_EQ] = ACTIONS(4058),
    [anon_sym_BANG_EQ] = ACTIONS(4058),
    [anon_sym_GT_EQ] = ACTIONS(4058),
    [anon_sym_LT_EQ] = ACTIONS(4058),
    [anon_sym_DOT] = ACTIONS(4056),
    [anon_sym_EQ_GT] = ACTIONS(4058),
    [anon_sym_COLON_COLON] = ACTIONS(4058),
    [anon_sym_switch] = ACTIONS(4058),
    [anon_sym_DOT_DOT] = ACTIONS(4058),
    [anon_sym_and] = ACTIONS(4058),
    [anon_sym_or] = ACTIONS(4056),
    [anon_sym_AMP_AMP] = ACTIONS(4058),
    [anon_sym_PIPE_PIPE] = ACTIONS(4058),
    [anon_sym_QMARK_QMARK] = ACTIONS(4058),
    [anon_sym_from] = ACTIONS(4058),
    [anon_sym_join] = ACTIONS(4058),
    [anon_sym_on] = ACTIONS(4058),
    [anon_sym_equals] = ACTIONS(4058),
    [anon_sym_let] = ACTIONS(4058),
    [anon_sym_orderby] = ACTIONS(4058),
    [anon_sym_group] = ACTIONS(4058),
    [anon_sym_by] = ACTIONS(4058),
    [anon_sym_select] = ACTIONS(4058),
    [anon_sym_as] = ACTIONS(4058),
    [anon_sym_is] = ACTIONS(4058),
    [anon_sym_DASH_GT] = ACTIONS(4058),
    [anon_sym_with] = ACTIONS(4058),
    [aux_sym_preproc_if_token3] = ACTIONS(4058),
    [aux_sym_preproc_else_token1] = ACTIONS(4058),
    [aux_sym_preproc_elif_token1] = ACTIONS(4058),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3569] = {
    [sym_preproc_region] = STATE(3569),
    [sym_preproc_endregion] = STATE(3569),
    [sym_preproc_line] = STATE(3569),
    [sym_preproc_pragma] = STATE(3569),
    [sym_preproc_nullable] = STATE(3569),
    [sym_preproc_error] = STATE(3569),
    [sym_preproc_define] = STATE(3569),
    [sym_preproc_undef] = STATE(3569),
    [anon_sym_SEMI] = ACTIONS(4424),
    [anon_sym_LBRACK] = ACTIONS(4424),
    [anon_sym_COLON] = ACTIONS(4424),
    [anon_sym_COMMA] = ACTIONS(4424),
    [anon_sym_RBRACK] = ACTIONS(4424),
    [anon_sym_LPAREN] = ACTIONS(4424),
    [anon_sym_RPAREN] = ACTIONS(4424),
    [anon_sym_LBRACE] = ACTIONS(4424),
    [anon_sym_RBRACE] = ACTIONS(4424),
    [anon_sym_LT] = ACTIONS(4422),
    [anon_sym_GT] = ACTIONS(4422),
    [anon_sym_in] = ACTIONS(4422),
    [anon_sym_where] = ACTIONS(4424),
    [anon_sym_QMARK] = ACTIONS(4422),
    [anon_sym_BANG] = ACTIONS(4422),
    [anon_sym_PLUS_PLUS] = ACTIONS(4424),
    [anon_sym_DASH_DASH] = ACTIONS(4424),
    [anon_sym_PLUS] = ACTIONS(4422),
    [anon_sym_DASH] = ACTIONS(4422),
    [anon_sym_STAR] = ACTIONS(4424),
    [anon_sym_SLASH] = ACTIONS(4422),
    [anon_sym_PERCENT] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4424),
    [anon_sym_PIPE] = ACTIONS(4422),
    [anon_sym_AMP] = ACTIONS(4422),
    [anon_sym_LT_LT] = ACTIONS(4424),
    [anon_sym_GT_GT] = ACTIONS(4422),
    [anon_sym_GT_GT_GT] = ACTIONS(4424),
    [anon_sym_EQ_EQ] = ACTIONS(4424),
    [anon_sym_BANG_EQ] = ACTIONS(4424),
    [anon_sym_GT_EQ] = ACTIONS(4424),
    [anon_sym_LT_EQ] = ACTIONS(4424),
    [anon_sym_DOT] = ACTIONS(4422),
    [anon_sym_EQ_GT] = ACTIONS(4424),
    [anon_sym_switch] = ACTIONS(4424),
    [anon_sym_DOT_DOT] = ACTIONS(4424),
    [anon_sym_and] = ACTIONS(4424),
    [anon_sym_or] = ACTIONS(4422),
    [anon_sym_AMP_AMP] = ACTIONS(4424),
    [anon_sym_PIPE_PIPE] = ACTIONS(4424),
    [anon_sym_QMARK_QMARK] = ACTIONS(4424),
    [anon_sym_from] = ACTIONS(4424),
    [anon_sym_into] = ACTIONS(4424),
    [anon_sym_join] = ACTIONS(4424),
    [anon_sym_on] = ACTIONS(4424),
    [anon_sym_equals] = ACTIONS(4424),
    [anon_sym_let] = ACTIONS(4424),
    [anon_sym_orderby] = ACTIONS(4424),
    [anon_sym_group] = ACTIONS(4424),
    [anon_sym_by] = ACTIONS(4424),
    [anon_sym_select] = ACTIONS(4424),
    [anon_sym_as] = ACTIONS(4424),
    [anon_sym_is] = ACTIONS(4424),
    [anon_sym_DASH_GT] = ACTIONS(4424),
    [anon_sym_with] = ACTIONS(4424),
    [aux_sym_preproc_if_token3] = ACTIONS(4424),
    [aux_sym_preproc_else_token1] = ACTIONS(4424),
    [aux_sym_preproc_elif_token1] = ACTIONS(4424),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3570] = {
    [sym_type_argument_list] = STATE(3657),
    [sym_preproc_region] = STATE(3570),
    [sym_preproc_endregion] = STATE(3570),
    [sym_preproc_line] = STATE(3570),
    [sym_preproc_pragma] = STATE(3570),
    [sym_preproc_nullable] = STATE(3570),
    [sym_preproc_error] = STATE(3570),
    [sym_preproc_define] = STATE(3570),
    [sym_preproc_undef] = STATE(3570),
    [anon_sym_SEMI] = ACTIONS(4076),
    [anon_sym_LBRACK] = ACTIONS(4076),
    [anon_sym_COLON] = ACTIONS(4076),
    [anon_sym_COMMA] = ACTIONS(4076),
    [anon_sym_RBRACK] = ACTIONS(4076),
    [anon_sym_LPAREN] = ACTIONS(4076),
    [anon_sym_RPAREN] = ACTIONS(4076),
    [anon_sym_LBRACE] = ACTIONS(4076),
    [anon_sym_RBRACE] = ACTIONS(4076),
    [anon_sym_LT] = ACTIONS(5259),
    [anon_sym_GT] = ACTIONS(4074),
    [anon_sym_in] = ACTIONS(4076),
    [anon_sym_where] = ACTIONS(4076),
    [anon_sym_QMARK] = ACTIONS(4074),
    [anon_sym_BANG] = ACTIONS(4074),
    [anon_sym_PLUS_PLUS] = ACTIONS(4076),
    [anon_sym_DASH_DASH] = ACTIONS(4076),
    [anon_sym_PLUS] = ACTIONS(4074),
    [anon_sym_DASH] = ACTIONS(4074),
    [anon_sym_STAR] = ACTIONS(4076),
    [anon_sym_SLASH] = ACTIONS(4074),
    [anon_sym_PERCENT] = ACTIONS(4076),
    [anon_sym_CARET] = ACTIONS(4076),
    [anon_sym_PIPE] = ACTIONS(4074),
    [anon_sym_AMP] = ACTIONS(4074),
    [anon_sym_LT_LT] = ACTIONS(4076),
    [anon_sym_GT_GT] = ACTIONS(4074),
    [anon_sym_GT_GT_GT] = ACTIONS(4076),
    [anon_sym_EQ_EQ] = ACTIONS(4076),
    [anon_sym_BANG_EQ] = ACTIONS(4076),
    [anon_sym_GT_EQ] = ACTIONS(4076),
    [anon_sym_LT_EQ] = ACTIONS(4076),
    [anon_sym_DOT] = ACTIONS(4074),
    [anon_sym_EQ_GT] = ACTIONS(4076),
    [anon_sym_switch] = ACTIONS(4076),
    [anon_sym_DOT_DOT] = ACTIONS(4076),
    [anon_sym_and] = ACTIONS(4076),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_AMP_AMP] = ACTIONS(4076),
    [anon_sym_PIPE_PIPE] = ACTIONS(4076),
    [anon_sym_QMARK_QMARK] = ACTIONS(4076),
    [anon_sym_from] = ACTIONS(4076),
    [anon_sym_join] = ACTIONS(4076),
    [anon_sym_on] = ACTIONS(4076),
    [anon_sym_equals] = ACTIONS(4076),
    [anon_sym_let] = ACTIONS(4076),
    [anon_sym_orderby] = ACTIONS(4076),
    [anon_sym_group] = ACTIONS(4076),
    [anon_sym_by] = ACTIONS(4076),
    [anon_sym_select] = ACTIONS(4076),
    [anon_sym_as] = ACTIONS(4076),
    [anon_sym_is] = ACTIONS(4076),
    [anon_sym_DASH_GT] = ACTIONS(4076),
    [anon_sym_with] = ACTIONS(4076),
    [aux_sym_preproc_if_token3] = ACTIONS(4076),
    [aux_sym_preproc_else_token1] = ACTIONS(4076),
    [aux_sym_preproc_elif_token1] = ACTIONS(4076),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3571] = {
    [sym_preproc_region] = STATE(3571),
    [sym_preproc_endregion] = STATE(3571),
    [sym_preproc_line] = STATE(3571),
    [sym_preproc_pragma] = STATE(3571),
    [sym_preproc_nullable] = STATE(3571),
    [sym_preproc_error] = STATE(3571),
    [sym_preproc_define] = STATE(3571),
    [sym_preproc_undef] = STATE(3571),
    [anon_sym_SEMI] = ACTIONS(4434),
    [anon_sym_LBRACK] = ACTIONS(4434),
    [anon_sym_COLON] = ACTIONS(4434),
    [anon_sym_COMMA] = ACTIONS(4434),
    [anon_sym_RBRACK] = ACTIONS(4434),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [anon_sym_RPAREN] = ACTIONS(4434),
    [anon_sym_LBRACE] = ACTIONS(4434),
    [anon_sym_RBRACE] = ACTIONS(4434),
    [anon_sym_LT] = ACTIONS(4432),
    [anon_sym_GT] = ACTIONS(4432),
    [anon_sym_in] = ACTIONS(4432),
    [anon_sym_where] = ACTIONS(4434),
    [anon_sym_QMARK] = ACTIONS(4432),
    [anon_sym_BANG] = ACTIONS(4432),
    [anon_sym_PLUS_PLUS] = ACTIONS(4434),
    [anon_sym_DASH_DASH] = ACTIONS(4434),
    [anon_sym_PLUS] = ACTIONS(4432),
    [anon_sym_DASH] = ACTIONS(4432),
    [anon_sym_STAR] = ACTIONS(4434),
    [anon_sym_SLASH] = ACTIONS(4432),
    [anon_sym_PERCENT] = ACTIONS(4434),
    [anon_sym_CARET] = ACTIONS(4434),
    [anon_sym_PIPE] = ACTIONS(4432),
    [anon_sym_AMP] = ACTIONS(4432),
    [anon_sym_LT_LT] = ACTIONS(4434),
    [anon_sym_GT_GT] = ACTIONS(4432),
    [anon_sym_GT_GT_GT] = ACTIONS(4434),
    [anon_sym_EQ_EQ] = ACTIONS(4434),
    [anon_sym_BANG_EQ] = ACTIONS(4434),
    [anon_sym_GT_EQ] = ACTIONS(4434),
    [anon_sym_LT_EQ] = ACTIONS(4434),
    [anon_sym_DOT] = ACTIONS(4432),
    [anon_sym_EQ_GT] = ACTIONS(4434),
    [anon_sym_switch] = ACTIONS(4434),
    [anon_sym_DOT_DOT] = ACTIONS(4434),
    [anon_sym_and] = ACTIONS(4434),
    [anon_sym_or] = ACTIONS(4432),
    [anon_sym_AMP_AMP] = ACTIONS(4434),
    [anon_sym_PIPE_PIPE] = ACTIONS(4434),
    [anon_sym_QMARK_QMARK] = ACTIONS(4434),
    [anon_sym_from] = ACTIONS(4434),
    [anon_sym_into] = ACTIONS(4434),
    [anon_sym_join] = ACTIONS(4434),
    [anon_sym_on] = ACTIONS(4434),
    [anon_sym_equals] = ACTIONS(4434),
    [anon_sym_let] = ACTIONS(4434),
    [anon_sym_orderby] = ACTIONS(4434),
    [anon_sym_group] = ACTIONS(4434),
    [anon_sym_by] = ACTIONS(4434),
    [anon_sym_select] = ACTIONS(4434),
    [anon_sym_as] = ACTIONS(4434),
    [anon_sym_is] = ACTIONS(4434),
    [anon_sym_DASH_GT] = ACTIONS(4434),
    [anon_sym_with] = ACTIONS(4434),
    [aux_sym_preproc_if_token3] = ACTIONS(4434),
    [aux_sym_preproc_else_token1] = ACTIONS(4434),
    [aux_sym_preproc_elif_token1] = ACTIONS(4434),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3572] = {
    [sym_initializer_expression] = STATE(3748),
    [sym_preproc_region] = STATE(3572),
    [sym_preproc_endregion] = STATE(3572),
    [sym_preproc_line] = STATE(3572),
    [sym_preproc_pragma] = STATE(3572),
    [sym_preproc_nullable] = STATE(3572),
    [sym_preproc_error] = STATE(3572),
    [sym_preproc_define] = STATE(3572),
    [sym_preproc_undef] = STATE(3572),
    [anon_sym_SEMI] = ACTIONS(5201),
    [anon_sym_LBRACK] = ACTIONS(5201),
    [anon_sym_COLON] = ACTIONS(5201),
    [anon_sym_COMMA] = ACTIONS(5201),
    [anon_sym_RBRACK] = ACTIONS(5201),
    [anon_sym_LPAREN] = ACTIONS(5201),
    [anon_sym_RPAREN] = ACTIONS(5201),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_RBRACE] = ACTIONS(5201),
    [anon_sym_LT] = ACTIONS(5203),
    [anon_sym_GT] = ACTIONS(5203),
    [anon_sym_in] = ACTIONS(5201),
    [anon_sym_where] = ACTIONS(5201),
    [anon_sym_QMARK] = ACTIONS(5203),
    [anon_sym_BANG] = ACTIONS(5203),
    [anon_sym_PLUS_PLUS] = ACTIONS(5201),
    [anon_sym_DASH_DASH] = ACTIONS(5201),
    [anon_sym_PLUS] = ACTIONS(5203),
    [anon_sym_DASH] = ACTIONS(5203),
    [anon_sym_STAR] = ACTIONS(5201),
    [anon_sym_SLASH] = ACTIONS(5203),
    [anon_sym_PERCENT] = ACTIONS(5201),
    [anon_sym_CARET] = ACTIONS(5201),
    [anon_sym_PIPE] = ACTIONS(5203),
    [anon_sym_AMP] = ACTIONS(5203),
    [anon_sym_LT_LT] = ACTIONS(5201),
    [anon_sym_GT_GT] = ACTIONS(5203),
    [anon_sym_GT_GT_GT] = ACTIONS(5201),
    [anon_sym_EQ_EQ] = ACTIONS(5201),
    [anon_sym_BANG_EQ] = ACTIONS(5201),
    [anon_sym_GT_EQ] = ACTIONS(5201),
    [anon_sym_LT_EQ] = ACTIONS(5201),
    [anon_sym_DOT] = ACTIONS(5203),
    [anon_sym_EQ_GT] = ACTIONS(5201),
    [anon_sym_switch] = ACTIONS(5201),
    [anon_sym_DOT_DOT] = ACTIONS(5201),
    [anon_sym_and] = ACTIONS(5201),
    [anon_sym_or] = ACTIONS(5203),
    [anon_sym_AMP_AMP] = ACTIONS(5201),
    [anon_sym_PIPE_PIPE] = ACTIONS(5201),
    [anon_sym_QMARK_QMARK] = ACTIONS(5201),
    [anon_sym_from] = ACTIONS(5201),
    [anon_sym_join] = ACTIONS(5201),
    [anon_sym_on] = ACTIONS(5201),
    [anon_sym_equals] = ACTIONS(5201),
    [anon_sym_let] = ACTIONS(5201),
    [anon_sym_orderby] = ACTIONS(5201),
    [anon_sym_group] = ACTIONS(5201),
    [anon_sym_by] = ACTIONS(5201),
    [anon_sym_select] = ACTIONS(5201),
    [anon_sym_as] = ACTIONS(5201),
    [anon_sym_is] = ACTIONS(5201),
    [anon_sym_DASH_GT] = ACTIONS(5201),
    [anon_sym_with] = ACTIONS(5201),
    [aux_sym_preproc_if_token3] = ACTIONS(5201),
    [aux_sym_preproc_else_token1] = ACTIONS(5201),
    [aux_sym_preproc_elif_token1] = ACTIONS(5201),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3573] = {
    [sym_preproc_region] = STATE(3573),
    [sym_preproc_endregion] = STATE(3573),
    [sym_preproc_line] = STATE(3573),
    [sym_preproc_pragma] = STATE(3573),
    [sym_preproc_nullable] = STATE(3573),
    [sym_preproc_error] = STATE(3573),
    [sym_preproc_define] = STATE(3573),
    [sym_preproc_undef] = STATE(3573),
    [anon_sym_SEMI] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4438),
    [anon_sym_COLON] = ACTIONS(4438),
    [anon_sym_COMMA] = ACTIONS(4438),
    [anon_sym_RBRACK] = ACTIONS(4438),
    [anon_sym_LPAREN] = ACTIONS(4438),
    [anon_sym_RPAREN] = ACTIONS(4438),
    [anon_sym_LBRACE] = ACTIONS(4438),
    [anon_sym_RBRACE] = ACTIONS(4438),
    [anon_sym_LT] = ACTIONS(4436),
    [anon_sym_GT] = ACTIONS(4436),
    [anon_sym_in] = ACTIONS(4436),
    [anon_sym_where] = ACTIONS(4438),
    [anon_sym_QMARK] = ACTIONS(4436),
    [anon_sym_BANG] = ACTIONS(4436),
    [anon_sym_PLUS_PLUS] = ACTIONS(4438),
    [anon_sym_DASH_DASH] = ACTIONS(4438),
    [anon_sym_PLUS] = ACTIONS(4436),
    [anon_sym_DASH] = ACTIONS(4436),
    [anon_sym_STAR] = ACTIONS(4438),
    [anon_sym_SLASH] = ACTIONS(4436),
    [anon_sym_PERCENT] = ACTIONS(4438),
    [anon_sym_CARET] = ACTIONS(4438),
    [anon_sym_PIPE] = ACTIONS(4436),
    [anon_sym_AMP] = ACTIONS(4436),
    [anon_sym_LT_LT] = ACTIONS(4438),
    [anon_sym_GT_GT] = ACTIONS(4436),
    [anon_sym_GT_GT_GT] = ACTIONS(4438),
    [anon_sym_EQ_EQ] = ACTIONS(4438),
    [anon_sym_BANG_EQ] = ACTIONS(4438),
    [anon_sym_GT_EQ] = ACTIONS(4438),
    [anon_sym_LT_EQ] = ACTIONS(4438),
    [anon_sym_DOT] = ACTIONS(4436),
    [anon_sym_EQ_GT] = ACTIONS(4438),
    [anon_sym_switch] = ACTIONS(4438),
    [anon_sym_DOT_DOT] = ACTIONS(4438),
    [anon_sym_and] = ACTIONS(4438),
    [anon_sym_or] = ACTIONS(4436),
    [anon_sym_AMP_AMP] = ACTIONS(4438),
    [anon_sym_PIPE_PIPE] = ACTIONS(4438),
    [anon_sym_QMARK_QMARK] = ACTIONS(4438),
    [anon_sym_from] = ACTIONS(4438),
    [anon_sym_into] = ACTIONS(4438),
    [anon_sym_join] = ACTIONS(4438),
    [anon_sym_on] = ACTIONS(4438),
    [anon_sym_equals] = ACTIONS(4438),
    [anon_sym_let] = ACTIONS(4438),
    [anon_sym_orderby] = ACTIONS(4438),
    [anon_sym_group] = ACTIONS(4438),
    [anon_sym_by] = ACTIONS(4438),
    [anon_sym_select] = ACTIONS(4438),
    [anon_sym_as] = ACTIONS(4438),
    [anon_sym_is] = ACTIONS(4438),
    [anon_sym_DASH_GT] = ACTIONS(4438),
    [anon_sym_with] = ACTIONS(4438),
    [aux_sym_preproc_if_token3] = ACTIONS(4438),
    [aux_sym_preproc_else_token1] = ACTIONS(4438),
    [aux_sym_preproc_elif_token1] = ACTIONS(4438),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3574] = {
    [sym_preproc_region] = STATE(3574),
    [sym_preproc_endregion] = STATE(3574),
    [sym_preproc_line] = STATE(3574),
    [sym_preproc_pragma] = STATE(3574),
    [sym_preproc_nullable] = STATE(3574),
    [sym_preproc_error] = STATE(3574),
    [sym_preproc_define] = STATE(3574),
    [sym_preproc_undef] = STATE(3574),
    [anon_sym_SEMI] = ACTIONS(4428),
    [anon_sym_LBRACK] = ACTIONS(4428),
    [anon_sym_COLON] = ACTIONS(4428),
    [anon_sym_COMMA] = ACTIONS(4428),
    [anon_sym_RBRACK] = ACTIONS(4428),
    [anon_sym_LPAREN] = ACTIONS(4428),
    [anon_sym_RPAREN] = ACTIONS(4428),
    [anon_sym_LBRACE] = ACTIONS(4428),
    [anon_sym_RBRACE] = ACTIONS(4428),
    [anon_sym_LT] = ACTIONS(4426),
    [anon_sym_GT] = ACTIONS(4426),
    [anon_sym_in] = ACTIONS(4426),
    [anon_sym_where] = ACTIONS(4428),
    [anon_sym_QMARK] = ACTIONS(4426),
    [anon_sym_BANG] = ACTIONS(4426),
    [anon_sym_PLUS_PLUS] = ACTIONS(4428),
    [anon_sym_DASH_DASH] = ACTIONS(4428),
    [anon_sym_PLUS] = ACTIONS(4426),
    [anon_sym_DASH] = ACTIONS(4426),
    [anon_sym_STAR] = ACTIONS(4428),
    [anon_sym_SLASH] = ACTIONS(4426),
    [anon_sym_PERCENT] = ACTIONS(4428),
    [anon_sym_CARET] = ACTIONS(4428),
    [anon_sym_PIPE] = ACTIONS(4426),
    [anon_sym_AMP] = ACTIONS(4426),
    [anon_sym_LT_LT] = ACTIONS(4428),
    [anon_sym_GT_GT] = ACTIONS(4426),
    [anon_sym_GT_GT_GT] = ACTIONS(4428),
    [anon_sym_EQ_EQ] = ACTIONS(4428),
    [anon_sym_BANG_EQ] = ACTIONS(4428),
    [anon_sym_GT_EQ] = ACTIONS(4428),
    [anon_sym_LT_EQ] = ACTIONS(4428),
    [anon_sym_DOT] = ACTIONS(4426),
    [anon_sym_EQ_GT] = ACTIONS(4428),
    [anon_sym_switch] = ACTIONS(4428),
    [anon_sym_DOT_DOT] = ACTIONS(4428),
    [anon_sym_and] = ACTIONS(4428),
    [anon_sym_or] = ACTIONS(4426),
    [anon_sym_AMP_AMP] = ACTIONS(4428),
    [anon_sym_PIPE_PIPE] = ACTIONS(4428),
    [anon_sym_QMARK_QMARK] = ACTIONS(4428),
    [anon_sym_from] = ACTIONS(4428),
    [anon_sym_into] = ACTIONS(4428),
    [anon_sym_join] = ACTIONS(4428),
    [anon_sym_on] = ACTIONS(4428),
    [anon_sym_equals] = ACTIONS(4428),
    [anon_sym_let] = ACTIONS(4428),
    [anon_sym_orderby] = ACTIONS(4428),
    [anon_sym_group] = ACTIONS(4428),
    [anon_sym_by] = ACTIONS(4428),
    [anon_sym_select] = ACTIONS(4428),
    [anon_sym_as] = ACTIONS(4428),
    [anon_sym_is] = ACTIONS(4428),
    [anon_sym_DASH_GT] = ACTIONS(4428),
    [anon_sym_with] = ACTIONS(4428),
    [aux_sym_preproc_if_token3] = ACTIONS(4428),
    [aux_sym_preproc_else_token1] = ACTIONS(4428),
    [aux_sym_preproc_elif_token1] = ACTIONS(4428),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3575] = {
    [sym_preproc_region] = STATE(3575),
    [sym_preproc_endregion] = STATE(3575),
    [sym_preproc_line] = STATE(3575),
    [sym_preproc_pragma] = STATE(3575),
    [sym_preproc_nullable] = STATE(3575),
    [sym_preproc_error] = STATE(3575),
    [sym_preproc_define] = STATE(3575),
    [sym_preproc_undef] = STATE(3575),
    [anon_sym_SEMI] = ACTIONS(4527),
    [anon_sym_LBRACK] = ACTIONS(4527),
    [anon_sym_COLON] = ACTIONS(4527),
    [anon_sym_COMMA] = ACTIONS(4527),
    [anon_sym_RBRACK] = ACTIONS(4527),
    [anon_sym_LPAREN] = ACTIONS(4527),
    [anon_sym_RPAREN] = ACTIONS(4527),
    [anon_sym_LBRACE] = ACTIONS(4527),
    [anon_sym_RBRACE] = ACTIONS(4527),
    [anon_sym_LT] = ACTIONS(4525),
    [anon_sym_GT] = ACTIONS(4525),
    [anon_sym_in] = ACTIONS(4525),
    [anon_sym_where] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4525),
    [anon_sym_BANG] = ACTIONS(4525),
    [anon_sym_PLUS_PLUS] = ACTIONS(4527),
    [anon_sym_DASH_DASH] = ACTIONS(4527),
    [anon_sym_PLUS] = ACTIONS(4525),
    [anon_sym_DASH] = ACTIONS(4525),
    [anon_sym_STAR] = ACTIONS(4527),
    [anon_sym_SLASH] = ACTIONS(4525),
    [anon_sym_PERCENT] = ACTIONS(4527),
    [anon_sym_CARET] = ACTIONS(4527),
    [anon_sym_PIPE] = ACTIONS(4525),
    [anon_sym_AMP] = ACTIONS(4525),
    [anon_sym_LT_LT] = ACTIONS(4527),
    [anon_sym_GT_GT] = ACTIONS(4525),
    [anon_sym_GT_GT_GT] = ACTIONS(4527),
    [anon_sym_EQ_EQ] = ACTIONS(4527),
    [anon_sym_BANG_EQ] = ACTIONS(4527),
    [anon_sym_GT_EQ] = ACTIONS(4527),
    [anon_sym_LT_EQ] = ACTIONS(4527),
    [anon_sym_DOT] = ACTIONS(4525),
    [anon_sym_EQ_GT] = ACTIONS(4527),
    [anon_sym_switch] = ACTIONS(4527),
    [anon_sym_DOT_DOT] = ACTIONS(4527),
    [anon_sym_and] = ACTIONS(4527),
    [anon_sym_or] = ACTIONS(4525),
    [anon_sym_AMP_AMP] = ACTIONS(4527),
    [anon_sym_PIPE_PIPE] = ACTIONS(4527),
    [anon_sym_QMARK_QMARK] = ACTIONS(4527),
    [anon_sym_from] = ACTIONS(4527),
    [anon_sym_into] = ACTIONS(4527),
    [anon_sym_join] = ACTIONS(4527),
    [anon_sym_on] = ACTIONS(4527),
    [anon_sym_equals] = ACTIONS(4527),
    [anon_sym_let] = ACTIONS(4527),
    [anon_sym_orderby] = ACTIONS(4527),
    [anon_sym_group] = ACTIONS(4527),
    [anon_sym_by] = ACTIONS(4527),
    [anon_sym_select] = ACTIONS(4527),
    [anon_sym_as] = ACTIONS(4527),
    [anon_sym_is] = ACTIONS(4527),
    [anon_sym_DASH_GT] = ACTIONS(4527),
    [anon_sym_with] = ACTIONS(4527),
    [aux_sym_preproc_if_token3] = ACTIONS(4527),
    [aux_sym_preproc_else_token1] = ACTIONS(4527),
    [aux_sym_preproc_elif_token1] = ACTIONS(4527),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3576] = {
    [sym_preproc_region] = STATE(3576),
    [sym_preproc_endregion] = STATE(3576),
    [sym_preproc_line] = STATE(3576),
    [sym_preproc_pragma] = STATE(3576),
    [sym_preproc_nullable] = STATE(3576),
    [sym_preproc_error] = STATE(3576),
    [sym_preproc_define] = STATE(3576),
    [sym_preproc_undef] = STATE(3576),
    [anon_sym_SEMI] = ACTIONS(5262),
    [anon_sym_LBRACK] = ACTIONS(5262),
    [anon_sym_COLON] = ACTIONS(5262),
    [anon_sym_COMMA] = ACTIONS(5262),
    [anon_sym_RBRACK] = ACTIONS(5262),
    [anon_sym_LPAREN] = ACTIONS(5262),
    [anon_sym_RPAREN] = ACTIONS(5262),
    [anon_sym_LBRACE] = ACTIONS(5262),
    [anon_sym_RBRACE] = ACTIONS(5262),
    [anon_sym_LT] = ACTIONS(5264),
    [anon_sym_GT] = ACTIONS(5264),
    [anon_sym_in] = ACTIONS(5264),
    [anon_sym_where] = ACTIONS(5262),
    [anon_sym_QMARK] = ACTIONS(5264),
    [anon_sym_BANG] = ACTIONS(5264),
    [anon_sym_PLUS_PLUS] = ACTIONS(5262),
    [anon_sym_DASH_DASH] = ACTIONS(5262),
    [anon_sym_PLUS] = ACTIONS(5264),
    [anon_sym_DASH] = ACTIONS(5264),
    [anon_sym_STAR] = ACTIONS(5262),
    [anon_sym_SLASH] = ACTIONS(5264),
    [anon_sym_PERCENT] = ACTIONS(5262),
    [anon_sym_CARET] = ACTIONS(5262),
    [anon_sym_PIPE] = ACTIONS(5264),
    [anon_sym_AMP] = ACTIONS(5264),
    [anon_sym_LT_LT] = ACTIONS(5262),
    [anon_sym_GT_GT] = ACTIONS(5264),
    [anon_sym_GT_GT_GT] = ACTIONS(5262),
    [anon_sym_EQ_EQ] = ACTIONS(5262),
    [anon_sym_BANG_EQ] = ACTIONS(5262),
    [anon_sym_GT_EQ] = ACTIONS(5262),
    [anon_sym_LT_EQ] = ACTIONS(5262),
    [anon_sym_DOT] = ACTIONS(5264),
    [anon_sym_EQ_GT] = ACTIONS(5262),
    [anon_sym_switch] = ACTIONS(5262),
    [anon_sym_DOT_DOT] = ACTIONS(5262),
    [anon_sym_and] = ACTIONS(5262),
    [anon_sym_or] = ACTIONS(5264),
    [anon_sym_AMP_AMP] = ACTIONS(5262),
    [anon_sym_PIPE_PIPE] = ACTIONS(5262),
    [anon_sym_QMARK_QMARK] = ACTIONS(5262),
    [anon_sym_from] = ACTIONS(5262),
    [anon_sym_into] = ACTIONS(5262),
    [anon_sym_join] = ACTIONS(5262),
    [anon_sym_on] = ACTIONS(5262),
    [anon_sym_equals] = ACTIONS(5262),
    [anon_sym_let] = ACTIONS(5262),
    [anon_sym_orderby] = ACTIONS(5262),
    [anon_sym_group] = ACTIONS(5262),
    [anon_sym_by] = ACTIONS(5262),
    [anon_sym_select] = ACTIONS(5262),
    [anon_sym_as] = ACTIONS(5262),
    [anon_sym_is] = ACTIONS(5262),
    [anon_sym_DASH_GT] = ACTIONS(5262),
    [anon_sym_with] = ACTIONS(5262),
    [aux_sym_preproc_if_token3] = ACTIONS(5262),
    [aux_sym_preproc_else_token1] = ACTIONS(5262),
    [aux_sym_preproc_elif_token1] = ACTIONS(5262),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3577] = {
    [sym_preproc_region] = STATE(3577),
    [sym_preproc_endregion] = STATE(3577),
    [sym_preproc_line] = STATE(3577),
    [sym_preproc_pragma] = STATE(3577),
    [sym_preproc_nullable] = STATE(3577),
    [sym_preproc_error] = STATE(3577),
    [sym_preproc_define] = STATE(3577),
    [sym_preproc_undef] = STATE(3577),
    [anon_sym_SEMI] = ACTIONS(4106),
    [anon_sym_LBRACK] = ACTIONS(4106),
    [anon_sym_COLON] = ACTIONS(4106),
    [anon_sym_COMMA] = ACTIONS(4106),
    [anon_sym_RBRACK] = ACTIONS(4106),
    [anon_sym_LPAREN] = ACTIONS(4106),
    [anon_sym_RPAREN] = ACTIONS(4106),
    [anon_sym_LBRACE] = ACTIONS(4106),
    [anon_sym_RBRACE] = ACTIONS(4106),
    [anon_sym_LT] = ACTIONS(4099),
    [anon_sym_GT] = ACTIONS(4099),
    [anon_sym_in] = ACTIONS(4099),
    [anon_sym_where] = ACTIONS(4106),
    [anon_sym_QMARK] = ACTIONS(4099),
    [anon_sym_BANG] = ACTIONS(4099),
    [anon_sym_PLUS_PLUS] = ACTIONS(4106),
    [anon_sym_DASH_DASH] = ACTIONS(4106),
    [anon_sym_PLUS] = ACTIONS(4099),
    [anon_sym_DASH] = ACTIONS(4099),
    [anon_sym_STAR] = ACTIONS(4106),
    [anon_sym_SLASH] = ACTIONS(4099),
    [anon_sym_PERCENT] = ACTIONS(4106),
    [anon_sym_CARET] = ACTIONS(4106),
    [anon_sym_PIPE] = ACTIONS(4099),
    [anon_sym_AMP] = ACTIONS(4099),
    [anon_sym_LT_LT] = ACTIONS(4106),
    [anon_sym_GT_GT] = ACTIONS(4099),
    [anon_sym_GT_GT_GT] = ACTIONS(4106),
    [anon_sym_EQ_EQ] = ACTIONS(4106),
    [anon_sym_BANG_EQ] = ACTIONS(4106),
    [anon_sym_GT_EQ] = ACTIONS(4106),
    [anon_sym_LT_EQ] = ACTIONS(4106),
    [anon_sym_DOT] = ACTIONS(4099),
    [anon_sym_EQ_GT] = ACTIONS(4106),
    [anon_sym_switch] = ACTIONS(4106),
    [anon_sym_DOT_DOT] = ACTIONS(4106),
    [anon_sym_and] = ACTIONS(4106),
    [anon_sym_or] = ACTIONS(4099),
    [anon_sym_AMP_AMP] = ACTIONS(4106),
    [anon_sym_PIPE_PIPE] = ACTIONS(4106),
    [anon_sym_QMARK_QMARK] = ACTIONS(4106),
    [anon_sym_from] = ACTIONS(4106),
    [anon_sym_into] = ACTIONS(4106),
    [anon_sym_join] = ACTIONS(4106),
    [anon_sym_on] = ACTIONS(4106),
    [anon_sym_equals] = ACTIONS(4106),
    [anon_sym_let] = ACTIONS(4106),
    [anon_sym_orderby] = ACTIONS(4106),
    [anon_sym_group] = ACTIONS(4106),
    [anon_sym_by] = ACTIONS(4106),
    [anon_sym_select] = ACTIONS(4106),
    [anon_sym_as] = ACTIONS(4106),
    [anon_sym_is] = ACTIONS(4106),
    [anon_sym_DASH_GT] = ACTIONS(4106),
    [anon_sym_with] = ACTIONS(4106),
    [aux_sym_preproc_if_token3] = ACTIONS(4106),
    [aux_sym_preproc_else_token1] = ACTIONS(4106),
    [aux_sym_preproc_elif_token1] = ACTIONS(4106),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3578] = {
    [sym_preproc_region] = STATE(3578),
    [sym_preproc_endregion] = STATE(3578),
    [sym_preproc_line] = STATE(3578),
    [sym_preproc_pragma] = STATE(3578),
    [sym_preproc_nullable] = STATE(3578),
    [sym_preproc_error] = STATE(3578),
    [sym_preproc_define] = STATE(3578),
    [sym_preproc_undef] = STATE(3578),
    [anon_sym_SEMI] = ACTIONS(4504),
    [anon_sym_LBRACK] = ACTIONS(4504),
    [anon_sym_COLON] = ACTIONS(4504),
    [anon_sym_COMMA] = ACTIONS(4504),
    [anon_sym_RBRACK] = ACTIONS(4504),
    [anon_sym_LPAREN] = ACTIONS(4504),
    [anon_sym_RPAREN] = ACTIONS(4504),
    [anon_sym_LBRACE] = ACTIONS(4504),
    [anon_sym_RBRACE] = ACTIONS(4504),
    [anon_sym_LT] = ACTIONS(4502),
    [anon_sym_GT] = ACTIONS(4502),
    [anon_sym_in] = ACTIONS(4502),
    [anon_sym_where] = ACTIONS(4504),
    [anon_sym_QMARK] = ACTIONS(4502),
    [anon_sym_BANG] = ACTIONS(4502),
    [anon_sym_PLUS_PLUS] = ACTIONS(4504),
    [anon_sym_DASH_DASH] = ACTIONS(4504),
    [anon_sym_PLUS] = ACTIONS(4502),
    [anon_sym_DASH] = ACTIONS(4502),
    [anon_sym_STAR] = ACTIONS(4504),
    [anon_sym_SLASH] = ACTIONS(4502),
    [anon_sym_PERCENT] = ACTIONS(4504),
    [anon_sym_CARET] = ACTIONS(4504),
    [anon_sym_PIPE] = ACTIONS(4502),
    [anon_sym_AMP] = ACTIONS(4502),
    [anon_sym_LT_LT] = ACTIONS(4504),
    [anon_sym_GT_GT] = ACTIONS(4502),
    [anon_sym_GT_GT_GT] = ACTIONS(4504),
    [anon_sym_EQ_EQ] = ACTIONS(4504),
    [anon_sym_BANG_EQ] = ACTIONS(4504),
    [anon_sym_GT_EQ] = ACTIONS(4504),
    [anon_sym_LT_EQ] = ACTIONS(4504),
    [anon_sym_DOT] = ACTIONS(4502),
    [anon_sym_EQ_GT] = ACTIONS(4504),
    [anon_sym_switch] = ACTIONS(4504),
    [anon_sym_DOT_DOT] = ACTIONS(4504),
    [anon_sym_and] = ACTIONS(4504),
    [anon_sym_or] = ACTIONS(4502),
    [anon_sym_AMP_AMP] = ACTIONS(4504),
    [anon_sym_PIPE_PIPE] = ACTIONS(4504),
    [anon_sym_QMARK_QMARK] = ACTIONS(4504),
    [anon_sym_from] = ACTIONS(4504),
    [anon_sym_into] = ACTIONS(4504),
    [anon_sym_join] = ACTIONS(4504),
    [anon_sym_on] = ACTIONS(4504),
    [anon_sym_equals] = ACTIONS(4504),
    [anon_sym_let] = ACTIONS(4504),
    [anon_sym_orderby] = ACTIONS(4504),
    [anon_sym_group] = ACTIONS(4504),
    [anon_sym_by] = ACTIONS(4504),
    [anon_sym_select] = ACTIONS(4504),
    [anon_sym_as] = ACTIONS(4504),
    [anon_sym_is] = ACTIONS(4504),
    [anon_sym_DASH_GT] = ACTIONS(4504),
    [anon_sym_with] = ACTIONS(4504),
    [aux_sym_preproc_if_token3] = ACTIONS(4504),
    [aux_sym_preproc_else_token1] = ACTIONS(4504),
    [aux_sym_preproc_elif_token1] = ACTIONS(4504),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3579] = {
    [sym_preproc_region] = STATE(3579),
    [sym_preproc_endregion] = STATE(3579),
    [sym_preproc_line] = STATE(3579),
    [sym_preproc_pragma] = STATE(3579),
    [sym_preproc_nullable] = STATE(3579),
    [sym_preproc_error] = STATE(3579),
    [sym_preproc_define] = STATE(3579),
    [sym_preproc_undef] = STATE(3579),
    [anon_sym_SEMI] = ACTIONS(4024),
    [anon_sym_LBRACK] = ACTIONS(4024),
    [anon_sym_COLON] = ACTIONS(4027),
    [anon_sym_COMMA] = ACTIONS(4024),
    [anon_sym_RBRACK] = ACTIONS(4024),
    [anon_sym_LPAREN] = ACTIONS(4024),
    [anon_sym_RPAREN] = ACTIONS(4024),
    [anon_sym_LBRACE] = ACTIONS(4024),
    [anon_sym_RBRACE] = ACTIONS(4024),
    [anon_sym_LT] = ACTIONS(4027),
    [anon_sym_GT] = ACTIONS(4027),
    [anon_sym_in] = ACTIONS(4024),
    [anon_sym_where] = ACTIONS(4024),
    [anon_sym_QMARK] = ACTIONS(4027),
    [anon_sym_BANG] = ACTIONS(4027),
    [anon_sym_PLUS_PLUS] = ACTIONS(4024),
    [anon_sym_DASH_DASH] = ACTIONS(4024),
    [anon_sym_PLUS] = ACTIONS(4027),
    [anon_sym_DASH] = ACTIONS(4027),
    [anon_sym_STAR] = ACTIONS(4024),
    [anon_sym_SLASH] = ACTIONS(4027),
    [anon_sym_PERCENT] = ACTIONS(4024),
    [anon_sym_CARET] = ACTIONS(4024),
    [anon_sym_PIPE] = ACTIONS(4027),
    [anon_sym_AMP] = ACTIONS(4027),
    [anon_sym_LT_LT] = ACTIONS(4024),
    [anon_sym_GT_GT] = ACTIONS(4027),
    [anon_sym_GT_GT_GT] = ACTIONS(4024),
    [anon_sym_EQ_EQ] = ACTIONS(4024),
    [anon_sym_BANG_EQ] = ACTIONS(4024),
    [anon_sym_GT_EQ] = ACTIONS(4024),
    [anon_sym_LT_EQ] = ACTIONS(4024),
    [anon_sym_DOT] = ACTIONS(4027),
    [anon_sym_EQ_GT] = ACTIONS(4024),
    [anon_sym_COLON_COLON] = ACTIONS(3719),
    [anon_sym_switch] = ACTIONS(4024),
    [anon_sym_DOT_DOT] = ACTIONS(4024),
    [anon_sym_and] = ACTIONS(4024),
    [anon_sym_or] = ACTIONS(4027),
    [anon_sym_AMP_AMP] = ACTIONS(4024),
    [anon_sym_PIPE_PIPE] = ACTIONS(4024),
    [anon_sym_QMARK_QMARK] = ACTIONS(4024),
    [anon_sym_from] = ACTIONS(4024),
    [anon_sym_join] = ACTIONS(4024),
    [anon_sym_on] = ACTIONS(4024),
    [anon_sym_equals] = ACTIONS(4024),
    [anon_sym_let] = ACTIONS(4024),
    [anon_sym_orderby] = ACTIONS(4024),
    [anon_sym_group] = ACTIONS(4024),
    [anon_sym_by] = ACTIONS(4024),
    [anon_sym_select] = ACTIONS(4024),
    [anon_sym_as] = ACTIONS(4024),
    [anon_sym_is] = ACTIONS(4024),
    [anon_sym_DASH_GT] = ACTIONS(4024),
    [anon_sym_with] = ACTIONS(4024),
    [aux_sym_preproc_if_token3] = ACTIONS(4024),
    [aux_sym_preproc_else_token1] = ACTIONS(4024),
    [aux_sym_preproc_elif_token1] = ACTIONS(4024),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3580] = {
    [sym_preproc_region] = STATE(3580),
    [sym_preproc_endregion] = STATE(3580),
    [sym_preproc_line] = STATE(3580),
    [sym_preproc_pragma] = STATE(3580),
    [sym_preproc_nullable] = STATE(3580),
    [sym_preproc_error] = STATE(3580),
    [sym_preproc_define] = STATE(3580),
    [sym_preproc_undef] = STATE(3580),
    [anon_sym_SEMI] = ACTIONS(4420),
    [anon_sym_LBRACK] = ACTIONS(4420),
    [anon_sym_COLON] = ACTIONS(4420),
    [anon_sym_COMMA] = ACTIONS(4420),
    [anon_sym_RBRACK] = ACTIONS(4420),
    [anon_sym_LPAREN] = ACTIONS(4420),
    [anon_sym_RPAREN] = ACTIONS(4420),
    [anon_sym_LBRACE] = ACTIONS(4420),
    [anon_sym_RBRACE] = ACTIONS(4420),
    [anon_sym_LT] = ACTIONS(4418),
    [anon_sym_GT] = ACTIONS(4418),
    [anon_sym_in] = ACTIONS(4418),
    [anon_sym_where] = ACTIONS(4420),
    [anon_sym_QMARK] = ACTIONS(4418),
    [anon_sym_BANG] = ACTIONS(4418),
    [anon_sym_PLUS_PLUS] = ACTIONS(4420),
    [anon_sym_DASH_DASH] = ACTIONS(4420),
    [anon_sym_PLUS] = ACTIONS(4418),
    [anon_sym_DASH] = ACTIONS(4418),
    [anon_sym_STAR] = ACTIONS(4420),
    [anon_sym_SLASH] = ACTIONS(4418),
    [anon_sym_PERCENT] = ACTIONS(4420),
    [anon_sym_CARET] = ACTIONS(4420),
    [anon_sym_PIPE] = ACTIONS(4418),
    [anon_sym_AMP] = ACTIONS(4418),
    [anon_sym_LT_LT] = ACTIONS(4420),
    [anon_sym_GT_GT] = ACTIONS(4418),
    [anon_sym_GT_GT_GT] = ACTIONS(4420),
    [anon_sym_EQ_EQ] = ACTIONS(4420),
    [anon_sym_BANG_EQ] = ACTIONS(4420),
    [anon_sym_GT_EQ] = ACTIONS(4420),
    [anon_sym_LT_EQ] = ACTIONS(4420),
    [anon_sym_DOT] = ACTIONS(4418),
    [anon_sym_EQ_GT] = ACTIONS(4420),
    [anon_sym_switch] = ACTIONS(4420),
    [anon_sym_DOT_DOT] = ACTIONS(4420),
    [anon_sym_and] = ACTIONS(4420),
    [anon_sym_or] = ACTIONS(4418),
    [anon_sym_AMP_AMP] = ACTIONS(4420),
    [anon_sym_PIPE_PIPE] = ACTIONS(4420),
    [anon_sym_QMARK_QMARK] = ACTIONS(4420),
    [anon_sym_from] = ACTIONS(4420),
    [anon_sym_into] = ACTIONS(4420),
    [anon_sym_join] = ACTIONS(4420),
    [anon_sym_on] = ACTIONS(4420),
    [anon_sym_equals] = ACTIONS(4420),
    [anon_sym_let] = ACTIONS(4420),
    [anon_sym_orderby] = ACTIONS(4420),
    [anon_sym_group] = ACTIONS(4420),
    [anon_sym_by] = ACTIONS(4420),
    [anon_sym_select] = ACTIONS(4420),
    [anon_sym_as] = ACTIONS(4420),
    [anon_sym_is] = ACTIONS(4420),
    [anon_sym_DASH_GT] = ACTIONS(4420),
    [anon_sym_with] = ACTIONS(4420),
    [aux_sym_preproc_if_token3] = ACTIONS(4420),
    [aux_sym_preproc_else_token1] = ACTIONS(4420),
    [aux_sym_preproc_elif_token1] = ACTIONS(4420),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3581] = {
    [sym_preproc_region] = STATE(3581),
    [sym_preproc_endregion] = STATE(3581),
    [sym_preproc_line] = STATE(3581),
    [sym_preproc_pragma] = STATE(3581),
    [sym_preproc_nullable] = STATE(3581),
    [sym_preproc_error] = STATE(3581),
    [sym_preproc_define] = STATE(3581),
    [sym_preproc_undef] = STATE(3581),
    [anon_sym_SEMI] = ACTIONS(5266),
    [anon_sym_LBRACK] = ACTIONS(5266),
    [anon_sym_COLON] = ACTIONS(5266),
    [anon_sym_COMMA] = ACTIONS(5266),
    [anon_sym_RBRACK] = ACTIONS(5266),
    [anon_sym_LPAREN] = ACTIONS(5266),
    [anon_sym_RPAREN] = ACTIONS(5266),
    [anon_sym_LBRACE] = ACTIONS(5266),
    [anon_sym_RBRACE] = ACTIONS(5266),
    [anon_sym_LT] = ACTIONS(5268),
    [anon_sym_GT] = ACTIONS(5268),
    [anon_sym_in] = ACTIONS(5268),
    [anon_sym_where] = ACTIONS(5266),
    [anon_sym_QMARK] = ACTIONS(5268),
    [anon_sym_BANG] = ACTIONS(5268),
    [anon_sym_PLUS_PLUS] = ACTIONS(5266),
    [anon_sym_DASH_DASH] = ACTIONS(5266),
    [anon_sym_PLUS] = ACTIONS(5268),
    [anon_sym_DASH] = ACTIONS(5268),
    [anon_sym_STAR] = ACTIONS(5266),
    [anon_sym_SLASH] = ACTIONS(5268),
    [anon_sym_PERCENT] = ACTIONS(5266),
    [anon_sym_CARET] = ACTIONS(5266),
    [anon_sym_PIPE] = ACTIONS(5268),
    [anon_sym_AMP] = ACTIONS(5268),
    [anon_sym_LT_LT] = ACTIONS(5266),
    [anon_sym_GT_GT] = ACTIONS(5268),
    [anon_sym_GT_GT_GT] = ACTIONS(5266),
    [anon_sym_EQ_EQ] = ACTIONS(5266),
    [anon_sym_BANG_EQ] = ACTIONS(5266),
    [anon_sym_GT_EQ] = ACTIONS(5266),
    [anon_sym_LT_EQ] = ACTIONS(5266),
    [anon_sym_DOT] = ACTIONS(5268),
    [anon_sym_EQ_GT] = ACTIONS(5266),
    [anon_sym_switch] = ACTIONS(5266),
    [anon_sym_DOT_DOT] = ACTIONS(5266),
    [anon_sym_and] = ACTIONS(5266),
    [anon_sym_or] = ACTIONS(5268),
    [anon_sym_AMP_AMP] = ACTIONS(5266),
    [anon_sym_PIPE_PIPE] = ACTIONS(5266),
    [anon_sym_QMARK_QMARK] = ACTIONS(5266),
    [anon_sym_from] = ACTIONS(5266),
    [anon_sym_into] = ACTIONS(5266),
    [anon_sym_join] = ACTIONS(5266),
    [anon_sym_on] = ACTIONS(5266),
    [anon_sym_equals] = ACTIONS(5266),
    [anon_sym_let] = ACTIONS(5266),
    [anon_sym_orderby] = ACTIONS(5266),
    [anon_sym_group] = ACTIONS(5266),
    [anon_sym_by] = ACTIONS(5266),
    [anon_sym_select] = ACTIONS(5266),
    [anon_sym_as] = ACTIONS(5266),
    [anon_sym_is] = ACTIONS(5266),
    [anon_sym_DASH_GT] = ACTIONS(5266),
    [anon_sym_with] = ACTIONS(5266),
    [aux_sym_preproc_if_token3] = ACTIONS(5266),
    [aux_sym_preproc_else_token1] = ACTIONS(5266),
    [aux_sym_preproc_elif_token1] = ACTIONS(5266),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3582] = {
    [sym_preproc_region] = STATE(3582),
    [sym_preproc_endregion] = STATE(3582),
    [sym_preproc_line] = STATE(3582),
    [sym_preproc_pragma] = STATE(3582),
    [sym_preproc_nullable] = STATE(3582),
    [sym_preproc_error] = STATE(3582),
    [sym_preproc_define] = STATE(3582),
    [sym_preproc_undef] = STATE(3582),
    [anon_sym_SEMI] = ACTIONS(5249),
    [anon_sym_EQ] = ACTIONS(5270),
    [anon_sym_LBRACK] = ACTIONS(5249),
    [anon_sym_COMMA] = ACTIONS(5249),
    [anon_sym_RBRACK] = ACTIONS(5249),
    [anon_sym_LPAREN] = ACTIONS(5249),
    [anon_sym_RPAREN] = ACTIONS(5249),
    [anon_sym_RBRACE] = ACTIONS(5249),
    [anon_sym_LT] = ACTIONS(5251),
    [anon_sym_GT] = ACTIONS(5251),
    [anon_sym_in] = ACTIONS(5251),
    [anon_sym_QMARK] = ACTIONS(5251),
    [anon_sym_BANG] = ACTIONS(5251),
    [anon_sym_PLUS_PLUS] = ACTIONS(5249),
    [anon_sym_DASH_DASH] = ACTIONS(5249),
    [anon_sym_PLUS] = ACTIONS(5251),
    [anon_sym_DASH] = ACTIONS(5251),
    [anon_sym_STAR] = ACTIONS(5251),
    [anon_sym_SLASH] = ACTIONS(5251),
    [anon_sym_PERCENT] = ACTIONS(5251),
    [anon_sym_CARET] = ACTIONS(5251),
    [anon_sym_PIPE] = ACTIONS(5251),
    [anon_sym_AMP] = ACTIONS(5251),
    [anon_sym_LT_LT] = ACTIONS(5251),
    [anon_sym_GT_GT] = ACTIONS(5251),
    [anon_sym_GT_GT_GT] = ACTIONS(5251),
    [anon_sym_EQ_EQ] = ACTIONS(5249),
    [anon_sym_BANG_EQ] = ACTIONS(5249),
    [anon_sym_GT_EQ] = ACTIONS(5249),
    [anon_sym_LT_EQ] = ACTIONS(5249),
    [anon_sym_DOT] = ACTIONS(5251),
    [anon_sym_switch] = ACTIONS(5249),
    [anon_sym_DOT_DOT] = ACTIONS(5249),
    [anon_sym_and] = ACTIONS(5249),
    [anon_sym_or] = ACTIONS(5249),
    [anon_sym_PLUS_EQ] = ACTIONS(5272),
    [anon_sym_DASH_EQ] = ACTIONS(5272),
    [anon_sym_STAR_EQ] = ACTIONS(5272),
    [anon_sym_SLASH_EQ] = ACTIONS(5272),
    [anon_sym_PERCENT_EQ] = ACTIONS(5272),
    [anon_sym_AMP_EQ] = ACTIONS(5272),
    [anon_sym_CARET_EQ] = ACTIONS(5272),
    [anon_sym_PIPE_EQ] = ACTIONS(5272),
    [anon_sym_LT_LT_EQ] = ACTIONS(5272),
    [anon_sym_GT_GT_EQ] = ACTIONS(5272),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5272),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(5272),
    [anon_sym_AMP_AMP] = ACTIONS(5249),
    [anon_sym_PIPE_PIPE] = ACTIONS(5249),
    [anon_sym_QMARK_QMARK] = ACTIONS(5251),
    [anon_sym_into] = ACTIONS(5249),
    [anon_sym_as] = ACTIONS(5249),
    [anon_sym_is] = ACTIONS(5249),
    [anon_sym_DASH_GT] = ACTIONS(5249),
    [anon_sym_with] = ACTIONS(5249),
    [aux_sym_preproc_if_token3] = ACTIONS(5249),
    [aux_sym_preproc_else_token1] = ACTIONS(5249),
    [aux_sym_preproc_elif_token1] = ACTIONS(5249),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3583] = {
    [sym_preproc_region] = STATE(3583),
    [sym_preproc_endregion] = STATE(3583),
    [sym_preproc_line] = STATE(3583),
    [sym_preproc_pragma] = STATE(3583),
    [sym_preproc_nullable] = STATE(3583),
    [sym_preproc_error] = STATE(3583),
    [sym_preproc_define] = STATE(3583),
    [sym_preproc_undef] = STATE(3583),
    [anon_sym_SEMI] = ACTIONS(4424),
    [anon_sym_LBRACK] = ACTIONS(4547),
    [anon_sym_COLON] = ACTIONS(4424),
    [anon_sym_COMMA] = ACTIONS(4424),
    [anon_sym_RBRACK] = ACTIONS(4424),
    [anon_sym_LPAREN] = ACTIONS(4424),
    [anon_sym_RPAREN] = ACTIONS(4424),
    [anon_sym_LBRACE] = ACTIONS(4424),
    [anon_sym_RBRACE] = ACTIONS(4424),
    [anon_sym_LT] = ACTIONS(4422),
    [anon_sym_GT] = ACTIONS(4422),
    [anon_sym_in] = ACTIONS(4422),
    [anon_sym_where] = ACTIONS(4424),
    [anon_sym_QMARK] = ACTIONS(5274),
    [anon_sym_BANG] = ACTIONS(4422),
    [anon_sym_PLUS_PLUS] = ACTIONS(4424),
    [anon_sym_DASH_DASH] = ACTIONS(4424),
    [anon_sym_PLUS] = ACTIONS(4422),
    [anon_sym_DASH] = ACTIONS(4422),
    [anon_sym_STAR] = ACTIONS(4553),
    [anon_sym_SLASH] = ACTIONS(4422),
    [anon_sym_PERCENT] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4424),
    [anon_sym_PIPE] = ACTIONS(4422),
    [anon_sym_AMP] = ACTIONS(4422),
    [anon_sym_LT_LT] = ACTIONS(4424),
    [anon_sym_GT_GT] = ACTIONS(4422),
    [anon_sym_GT_GT_GT] = ACTIONS(4424),
    [anon_sym_EQ_EQ] = ACTIONS(4424),
    [anon_sym_BANG_EQ] = ACTIONS(4424),
    [anon_sym_GT_EQ] = ACTIONS(4424),
    [anon_sym_LT_EQ] = ACTIONS(4424),
    [anon_sym_DOT] = ACTIONS(4422),
    [anon_sym_EQ_GT] = ACTIONS(4424),
    [anon_sym_switch] = ACTIONS(4424),
    [anon_sym_DOT_DOT] = ACTIONS(4424),
    [anon_sym_and] = ACTIONS(4424),
    [anon_sym_or] = ACTIONS(4422),
    [anon_sym_AMP_AMP] = ACTIONS(4424),
    [anon_sym_PIPE_PIPE] = ACTIONS(4424),
    [anon_sym_QMARK_QMARK] = ACTIONS(4424),
    [anon_sym_from] = ACTIONS(4424),
    [anon_sym_into] = ACTIONS(4424),
    [anon_sym_join] = ACTIONS(4424),
    [anon_sym_on] = ACTIONS(4424),
    [anon_sym_equals] = ACTIONS(4424),
    [anon_sym_let] = ACTIONS(4424),
    [anon_sym_orderby] = ACTIONS(4424),
    [anon_sym_group] = ACTIONS(4424),
    [anon_sym_by] = ACTIONS(4424),
    [anon_sym_select] = ACTIONS(4424),
    [anon_sym_as] = ACTIONS(4424),
    [anon_sym_is] = ACTIONS(4424),
    [anon_sym_DASH_GT] = ACTIONS(4424),
    [anon_sym_with] = ACTIONS(4424),
    [aux_sym_preproc_if_token3] = ACTIONS(4424),
    [aux_sym_preproc_else_token1] = ACTIONS(4424),
    [aux_sym_preproc_elif_token1] = ACTIONS(4424),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3584] = {
    [sym_attribute_list] = STATE(3753),
    [sym_preproc_region] = STATE(3584),
    [sym_preproc_endregion] = STATE(3584),
    [sym_preproc_line] = STATE(3584),
    [sym_preproc_pragma] = STATE(3584),
    [sym_preproc_nullable] = STATE(3584),
    [sym_preproc_error] = STATE(3584),
    [sym_preproc_define] = STATE(3584),
    [sym_preproc_undef] = STATE(3584),
    [aux_sym_class_declaration_repeat1] = STATE(3584),
    [sym__identifier_token] = ACTIONS(5277),
    [anon_sym_extern] = ACTIONS(5277),
    [anon_sym_alias] = ACTIONS(5277),
    [anon_sym_global] = ACTIONS(5277),
    [anon_sym_unsafe] = ACTIONS(5277),
    [anon_sym_static] = ACTIONS(5277),
    [anon_sym_LBRACK] = ACTIONS(5279),
    [anon_sym_LPAREN] = ACTIONS(5282),
    [anon_sym_event] = ACTIONS(5277),
    [anon_sym_class] = ACTIONS(5277),
    [anon_sym_ref] = ACTIONS(5277),
    [anon_sym_struct] = ACTIONS(5277),
    [anon_sym_enum] = ACTIONS(5277),
    [anon_sym_interface] = ACTIONS(5277),
    [anon_sym_delegate] = ACTIONS(5277),
    [anon_sym_record] = ACTIONS(5277),
    [anon_sym_abstract] = ACTIONS(5277),
    [anon_sym_async] = ACTIONS(5277),
    [anon_sym_const] = ACTIONS(5277),
    [anon_sym_file] = ACTIONS(5277),
    [anon_sym_fixed] = ACTIONS(5277),
    [anon_sym_internal] = ACTIONS(5277),
    [anon_sym_new] = ACTIONS(5277),
    [anon_sym_override] = ACTIONS(5277),
    [anon_sym_partial] = ACTIONS(5277),
    [anon_sym_private] = ACTIONS(5277),
    [anon_sym_protected] = ACTIONS(5277),
    [anon_sym_public] = ACTIONS(5277),
    [anon_sym_readonly] = ACTIONS(5277),
    [anon_sym_required] = ACTIONS(5277),
    [anon_sym_sealed] = ACTIONS(5277),
    [anon_sym_virtual] = ACTIONS(5277),
    [anon_sym_volatile] = ACTIONS(5277),
    [anon_sym_where] = ACTIONS(5277),
    [anon_sym_notnull] = ACTIONS(5277),
    [anon_sym_unmanaged] = ACTIONS(5277),
    [anon_sym_TILDE] = ACTIONS(5282),
    [anon_sym_implicit] = ACTIONS(5277),
    [anon_sym_explicit] = ACTIONS(5277),
    [anon_sym_scoped] = ACTIONS(5277),
    [anon_sym_var] = ACTIONS(5277),
    [sym_predefined_type] = ACTIONS(5277),
    [anon_sym_yield] = ACTIONS(5277),
    [anon_sym_when] = ACTIONS(5277),
    [anon_sym_from] = ACTIONS(5277),
    [anon_sym_into] = ACTIONS(5277),
    [anon_sym_join] = ACTIONS(5277),
    [anon_sym_on] = ACTIONS(5277),
    [anon_sym_equals] = ACTIONS(5277),
    [anon_sym_let] = ACTIONS(5277),
    [anon_sym_orderby] = ACTIONS(5277),
    [anon_sym_ascending] = ACTIONS(5277),
    [anon_sym_descending] = ACTIONS(5277),
    [anon_sym_group] = ACTIONS(5277),
    [anon_sym_by] = ACTIONS(5277),
    [anon_sym_select] = ACTIONS(5277),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3585] = {
    [sym_preproc_region] = STATE(3585),
    [sym_preproc_endregion] = STATE(3585),
    [sym_preproc_line] = STATE(3585),
    [sym_preproc_pragma] = STATE(3585),
    [sym_preproc_nullable] = STATE(3585),
    [sym_preproc_error] = STATE(3585),
    [sym_preproc_define] = STATE(3585),
    [sym_preproc_undef] = STATE(3585),
    [anon_sym_SEMI] = ACTIONS(4424),
    [anon_sym_LBRACK] = ACTIONS(4547),
    [anon_sym_COLON] = ACTIONS(4424),
    [anon_sym_COMMA] = ACTIONS(4424),
    [anon_sym_RBRACK] = ACTIONS(4424),
    [anon_sym_LPAREN] = ACTIONS(4424),
    [anon_sym_RPAREN] = ACTIONS(4424),
    [anon_sym_LBRACE] = ACTIONS(4424),
    [anon_sym_RBRACE] = ACTIONS(4424),
    [anon_sym_LT] = ACTIONS(4422),
    [anon_sym_GT] = ACTIONS(4422),
    [anon_sym_in] = ACTIONS(4422),
    [anon_sym_where] = ACTIONS(4424),
    [anon_sym_QMARK] = ACTIONS(4422),
    [anon_sym_BANG] = ACTIONS(4422),
    [anon_sym_PLUS_PLUS] = ACTIONS(4424),
    [anon_sym_DASH_DASH] = ACTIONS(4424),
    [anon_sym_PLUS] = ACTIONS(4422),
    [anon_sym_DASH] = ACTIONS(4422),
    [anon_sym_STAR] = ACTIONS(4553),
    [anon_sym_SLASH] = ACTIONS(4422),
    [anon_sym_PERCENT] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4424),
    [anon_sym_PIPE] = ACTIONS(4422),
    [anon_sym_AMP] = ACTIONS(4422),
    [anon_sym_LT_LT] = ACTIONS(4424),
    [anon_sym_GT_GT] = ACTIONS(4422),
    [anon_sym_GT_GT_GT] = ACTIONS(4424),
    [anon_sym_EQ_EQ] = ACTIONS(4424),
    [anon_sym_BANG_EQ] = ACTIONS(4424),
    [anon_sym_GT_EQ] = ACTIONS(4424),
    [anon_sym_LT_EQ] = ACTIONS(4424),
    [anon_sym_DOT] = ACTIONS(4422),
    [anon_sym_EQ_GT] = ACTIONS(4424),
    [anon_sym_switch] = ACTIONS(4424),
    [anon_sym_DOT_DOT] = ACTIONS(4424),
    [anon_sym_and] = ACTIONS(4424),
    [anon_sym_or] = ACTIONS(4422),
    [anon_sym_AMP_AMP] = ACTIONS(4424),
    [anon_sym_PIPE_PIPE] = ACTIONS(4424),
    [anon_sym_QMARK_QMARK] = ACTIONS(4424),
    [anon_sym_from] = ACTIONS(4424),
    [anon_sym_into] = ACTIONS(4424),
    [anon_sym_join] = ACTIONS(4424),
    [anon_sym_on] = ACTIONS(4424),
    [anon_sym_equals] = ACTIONS(4424),
    [anon_sym_let] = ACTIONS(4424),
    [anon_sym_orderby] = ACTIONS(4424),
    [anon_sym_group] = ACTIONS(4424),
    [anon_sym_by] = ACTIONS(4424),
    [anon_sym_select] = ACTIONS(4424),
    [anon_sym_as] = ACTIONS(4424),
    [anon_sym_is] = ACTIONS(4424),
    [anon_sym_DASH_GT] = ACTIONS(4424),
    [anon_sym_with] = ACTIONS(4424),
    [aux_sym_preproc_if_token3] = ACTIONS(4424),
    [aux_sym_preproc_else_token1] = ACTIONS(4424),
    [aux_sym_preproc_elif_token1] = ACTIONS(4424),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3586] = {
    [sym_preproc_region] = STATE(3586),
    [sym_preproc_endregion] = STATE(3586),
    [sym_preproc_line] = STATE(3586),
    [sym_preproc_pragma] = STATE(3586),
    [sym_preproc_nullable] = STATE(3586),
    [sym_preproc_error] = STATE(3586),
    [sym_preproc_define] = STATE(3586),
    [sym_preproc_undef] = STATE(3586),
    [anon_sym_SEMI] = ACTIONS(4087),
    [anon_sym_LBRACK] = ACTIONS(4087),
    [anon_sym_COLON] = ACTIONS(4087),
    [anon_sym_COMMA] = ACTIONS(4087),
    [anon_sym_RBRACK] = ACTIONS(4087),
    [anon_sym_LPAREN] = ACTIONS(4087),
    [anon_sym_RPAREN] = ACTIONS(4087),
    [anon_sym_LBRACE] = ACTIONS(4087),
    [anon_sym_RBRACE] = ACTIONS(4087),
    [anon_sym_LT] = ACTIONS(4085),
    [anon_sym_GT] = ACTIONS(4085),
    [anon_sym_in] = ACTIONS(4085),
    [anon_sym_where] = ACTIONS(4087),
    [anon_sym_QMARK] = ACTIONS(4085),
    [anon_sym_BANG] = ACTIONS(4085),
    [anon_sym_PLUS_PLUS] = ACTIONS(4087),
    [anon_sym_DASH_DASH] = ACTIONS(4087),
    [anon_sym_PLUS] = ACTIONS(4085),
    [anon_sym_DASH] = ACTIONS(4085),
    [anon_sym_STAR] = ACTIONS(4087),
    [anon_sym_SLASH] = ACTIONS(4085),
    [anon_sym_PERCENT] = ACTIONS(4087),
    [anon_sym_CARET] = ACTIONS(4087),
    [anon_sym_PIPE] = ACTIONS(4085),
    [anon_sym_AMP] = ACTIONS(4085),
    [anon_sym_LT_LT] = ACTIONS(4087),
    [anon_sym_GT_GT] = ACTIONS(4085),
    [anon_sym_GT_GT_GT] = ACTIONS(4087),
    [anon_sym_EQ_EQ] = ACTIONS(4087),
    [anon_sym_BANG_EQ] = ACTIONS(4087),
    [anon_sym_GT_EQ] = ACTIONS(4087),
    [anon_sym_LT_EQ] = ACTIONS(4087),
    [anon_sym_DOT] = ACTIONS(4085),
    [anon_sym_EQ_GT] = ACTIONS(4087),
    [anon_sym_switch] = ACTIONS(4087),
    [anon_sym_DOT_DOT] = ACTIONS(4087),
    [anon_sym_and] = ACTIONS(4087),
    [anon_sym_or] = ACTIONS(4085),
    [anon_sym_AMP_AMP] = ACTIONS(4087),
    [anon_sym_PIPE_PIPE] = ACTIONS(4087),
    [anon_sym_QMARK_QMARK] = ACTIONS(4087),
    [anon_sym_from] = ACTIONS(4087),
    [anon_sym_into] = ACTIONS(4087),
    [anon_sym_join] = ACTIONS(4087),
    [anon_sym_on] = ACTIONS(4087),
    [anon_sym_equals] = ACTIONS(4087),
    [anon_sym_let] = ACTIONS(4087),
    [anon_sym_orderby] = ACTIONS(4087),
    [anon_sym_group] = ACTIONS(4087),
    [anon_sym_by] = ACTIONS(4087),
    [anon_sym_select] = ACTIONS(4087),
    [anon_sym_as] = ACTIONS(4087),
    [anon_sym_is] = ACTIONS(4087),
    [anon_sym_DASH_GT] = ACTIONS(4087),
    [anon_sym_with] = ACTIONS(4087),
    [aux_sym_preproc_if_token3] = ACTIONS(4087),
    [aux_sym_preproc_else_token1] = ACTIONS(4087),
    [aux_sym_preproc_elif_token1] = ACTIONS(4087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3587] = {
    [sym_preproc_region] = STATE(3587),
    [sym_preproc_endregion] = STATE(3587),
    [sym_preproc_line] = STATE(3587),
    [sym_preproc_pragma] = STATE(3587),
    [sym_preproc_nullable] = STATE(3587),
    [sym_preproc_error] = STATE(3587),
    [sym_preproc_define] = STATE(3587),
    [sym_preproc_undef] = STATE(3587),
    [anon_sym_SEMI] = ACTIONS(4424),
    [anon_sym_LBRACK] = ACTIONS(4547),
    [anon_sym_COLON] = ACTIONS(4424),
    [anon_sym_COMMA] = ACTIONS(4424),
    [anon_sym_RBRACK] = ACTIONS(4424),
    [anon_sym_LPAREN] = ACTIONS(4424),
    [anon_sym_RPAREN] = ACTIONS(4424),
    [anon_sym_LBRACE] = ACTIONS(4424),
    [anon_sym_RBRACE] = ACTIONS(4424),
    [anon_sym_LT] = ACTIONS(4422),
    [anon_sym_GT] = ACTIONS(4422),
    [anon_sym_in] = ACTIONS(4422),
    [anon_sym_where] = ACTIONS(4424),
    [anon_sym_QMARK] = ACTIONS(5274),
    [anon_sym_BANG] = ACTIONS(4422),
    [anon_sym_PLUS_PLUS] = ACTIONS(4424),
    [anon_sym_DASH_DASH] = ACTIONS(4424),
    [anon_sym_PLUS] = ACTIONS(4422),
    [anon_sym_DASH] = ACTIONS(4422),
    [anon_sym_STAR] = ACTIONS(4424),
    [anon_sym_SLASH] = ACTIONS(4422),
    [anon_sym_PERCENT] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4424),
    [anon_sym_PIPE] = ACTIONS(4422),
    [anon_sym_AMP] = ACTIONS(4422),
    [anon_sym_LT_LT] = ACTIONS(4424),
    [anon_sym_GT_GT] = ACTIONS(4422),
    [anon_sym_GT_GT_GT] = ACTIONS(4424),
    [anon_sym_EQ_EQ] = ACTIONS(4424),
    [anon_sym_BANG_EQ] = ACTIONS(4424),
    [anon_sym_GT_EQ] = ACTIONS(4424),
    [anon_sym_LT_EQ] = ACTIONS(4424),
    [anon_sym_DOT] = ACTIONS(4422),
    [anon_sym_EQ_GT] = ACTIONS(4424),
    [anon_sym_switch] = ACTIONS(4424),
    [anon_sym_DOT_DOT] = ACTIONS(4424),
    [anon_sym_and] = ACTIONS(4424),
    [anon_sym_or] = ACTIONS(4422),
    [anon_sym_AMP_AMP] = ACTIONS(4424),
    [anon_sym_PIPE_PIPE] = ACTIONS(4424),
    [anon_sym_QMARK_QMARK] = ACTIONS(4424),
    [anon_sym_from] = ACTIONS(4424),
    [anon_sym_into] = ACTIONS(4424),
    [anon_sym_join] = ACTIONS(4424),
    [anon_sym_on] = ACTIONS(4424),
    [anon_sym_equals] = ACTIONS(4424),
    [anon_sym_let] = ACTIONS(4424),
    [anon_sym_orderby] = ACTIONS(4424),
    [anon_sym_group] = ACTIONS(4424),
    [anon_sym_by] = ACTIONS(4424),
    [anon_sym_select] = ACTIONS(4424),
    [anon_sym_as] = ACTIONS(4424),
    [anon_sym_is] = ACTIONS(4424),
    [anon_sym_DASH_GT] = ACTIONS(4424),
    [anon_sym_with] = ACTIONS(4424),
    [aux_sym_preproc_if_token3] = ACTIONS(4424),
    [aux_sym_preproc_else_token1] = ACTIONS(4424),
    [aux_sym_preproc_elif_token1] = ACTIONS(4424),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3588] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter] = STATE(8382),
    [sym__parameter_array] = STATE(8390),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7259),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_tuple_element] = STATE(8846),
    [sym_identifier] = STATE(6736),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(3588),
    [sym_preproc_endregion] = STATE(3588),
    [sym_preproc_line] = STATE(3588),
    [sym_preproc_pragma] = STATE(3588),
    [sym_preproc_nullable] = STATE(3588),
    [sym_preproc_error] = STATE(3588),
    [sym_preproc_define] = STATE(3588),
    [sym_preproc_undef] = STATE(3588),
    [aux_sym_class_declaration_repeat1] = STATE(3784),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4143),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_LBRACK] = ACTIONS(5212),
    [anon_sym_LPAREN] = ACTIONS(2995),
    [anon_sym_RPAREN] = ACTIONS(2561),
    [anon_sym_ref] = ACTIONS(5216),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_readonly] = ACTIONS(1093),
    [anon_sym_in] = ACTIONS(1093),
    [anon_sym_out] = ACTIONS(1093),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_this] = ACTIONS(1093),
    [anon_sym_scoped] = ACTIONS(5218),
    [anon_sym_params] = ACTIONS(1107),
    [anon_sym_var] = ACTIONS(5284),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3589] = {
    [sym_preproc_region] = STATE(3589),
    [sym_preproc_endregion] = STATE(3589),
    [sym_preproc_line] = STATE(3589),
    [sym_preproc_pragma] = STATE(3589),
    [sym_preproc_nullable] = STATE(3589),
    [sym_preproc_error] = STATE(3589),
    [sym_preproc_define] = STATE(3589),
    [sym_preproc_undef] = STATE(3589),
    [anon_sym_SEMI] = ACTIONS(4480),
    [anon_sym_LBRACK] = ACTIONS(4480),
    [anon_sym_COLON] = ACTIONS(4480),
    [anon_sym_COMMA] = ACTIONS(4480),
    [anon_sym_RBRACK] = ACTIONS(4480),
    [anon_sym_LPAREN] = ACTIONS(4480),
    [anon_sym_RPAREN] = ACTIONS(4480),
    [anon_sym_LBRACE] = ACTIONS(4480),
    [anon_sym_RBRACE] = ACTIONS(4480),
    [anon_sym_LT] = ACTIONS(4478),
    [anon_sym_GT] = ACTIONS(4478),
    [anon_sym_in] = ACTIONS(4478),
    [anon_sym_where] = ACTIONS(4480),
    [anon_sym_QMARK] = ACTIONS(4478),
    [anon_sym_BANG] = ACTIONS(4478),
    [anon_sym_PLUS_PLUS] = ACTIONS(4480),
    [anon_sym_DASH_DASH] = ACTIONS(4480),
    [anon_sym_PLUS] = ACTIONS(4478),
    [anon_sym_DASH] = ACTIONS(4478),
    [anon_sym_STAR] = ACTIONS(4480),
    [anon_sym_SLASH] = ACTIONS(4478),
    [anon_sym_PERCENT] = ACTIONS(4480),
    [anon_sym_CARET] = ACTIONS(4480),
    [anon_sym_PIPE] = ACTIONS(4478),
    [anon_sym_AMP] = ACTIONS(4478),
    [anon_sym_LT_LT] = ACTIONS(4480),
    [anon_sym_GT_GT] = ACTIONS(4478),
    [anon_sym_GT_GT_GT] = ACTIONS(4480),
    [anon_sym_EQ_EQ] = ACTIONS(4480),
    [anon_sym_BANG_EQ] = ACTIONS(4480),
    [anon_sym_GT_EQ] = ACTIONS(4480),
    [anon_sym_LT_EQ] = ACTIONS(4480),
    [anon_sym_DOT] = ACTIONS(4478),
    [anon_sym_EQ_GT] = ACTIONS(4480),
    [anon_sym_switch] = ACTIONS(4480),
    [anon_sym_DOT_DOT] = ACTIONS(4480),
    [anon_sym_and] = ACTIONS(4480),
    [anon_sym_or] = ACTIONS(4478),
    [anon_sym_AMP_AMP] = ACTIONS(4480),
    [anon_sym_PIPE_PIPE] = ACTIONS(4480),
    [anon_sym_QMARK_QMARK] = ACTIONS(4480),
    [anon_sym_from] = ACTIONS(4480),
    [anon_sym_into] = ACTIONS(4480),
    [anon_sym_join] = ACTIONS(4480),
    [anon_sym_on] = ACTIONS(4480),
    [anon_sym_equals] = ACTIONS(4480),
    [anon_sym_let] = ACTIONS(4480),
    [anon_sym_orderby] = ACTIONS(4480),
    [anon_sym_group] = ACTIONS(4480),
    [anon_sym_by] = ACTIONS(4480),
    [anon_sym_select] = ACTIONS(4480),
    [anon_sym_as] = ACTIONS(4480),
    [anon_sym_is] = ACTIONS(4480),
    [anon_sym_DASH_GT] = ACTIONS(4480),
    [anon_sym_with] = ACTIONS(4480),
    [aux_sym_preproc_if_token3] = ACTIONS(4480),
    [aux_sym_preproc_else_token1] = ACTIONS(4480),
    [aux_sym_preproc_elif_token1] = ACTIONS(4480),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3590] = {
    [sym_type_argument_list] = STATE(3657),
    [sym_preproc_region] = STATE(3590),
    [sym_preproc_endregion] = STATE(3590),
    [sym_preproc_line] = STATE(3590),
    [sym_preproc_pragma] = STATE(3590),
    [sym_preproc_nullable] = STATE(3590),
    [sym_preproc_error] = STATE(3590),
    [sym_preproc_define] = STATE(3590),
    [sym_preproc_undef] = STATE(3590),
    [anon_sym_SEMI] = ACTIONS(4076),
    [anon_sym_LBRACK] = ACTIONS(4076),
    [anon_sym_COMMA] = ACTIONS(4076),
    [anon_sym_RBRACK] = ACTIONS(4076),
    [anon_sym_LPAREN] = ACTIONS(4076),
    [anon_sym_RPAREN] = ACTIONS(4076),
    [anon_sym_LBRACE] = ACTIONS(4076),
    [anon_sym_RBRACE] = ACTIONS(4076),
    [anon_sym_LT] = ACTIONS(5259),
    [anon_sym_GT] = ACTIONS(4074),
    [anon_sym_in] = ACTIONS(4076),
    [anon_sym_where] = ACTIONS(4076),
    [anon_sym_QMARK] = ACTIONS(4074),
    [anon_sym_BANG] = ACTIONS(4074),
    [anon_sym_PLUS_PLUS] = ACTIONS(4076),
    [anon_sym_DASH_DASH] = ACTIONS(4076),
    [anon_sym_PLUS] = ACTIONS(4074),
    [anon_sym_DASH] = ACTIONS(4074),
    [anon_sym_STAR] = ACTIONS(4076),
    [anon_sym_SLASH] = ACTIONS(4074),
    [anon_sym_PERCENT] = ACTIONS(4076),
    [anon_sym_CARET] = ACTIONS(4076),
    [anon_sym_PIPE] = ACTIONS(4074),
    [anon_sym_AMP] = ACTIONS(4074),
    [anon_sym_LT_LT] = ACTIONS(4076),
    [anon_sym_GT_GT] = ACTIONS(4074),
    [anon_sym_GT_GT_GT] = ACTIONS(4076),
    [anon_sym_EQ_EQ] = ACTIONS(4076),
    [anon_sym_BANG_EQ] = ACTIONS(4076),
    [anon_sym_GT_EQ] = ACTIONS(4076),
    [anon_sym_LT_EQ] = ACTIONS(4076),
    [anon_sym_DOT] = ACTIONS(4074),
    [anon_sym_EQ_GT] = ACTIONS(4076),
    [anon_sym_COLON_COLON] = ACTIONS(5286),
    [anon_sym_switch] = ACTIONS(4076),
    [anon_sym_DOT_DOT] = ACTIONS(4076),
    [anon_sym_and] = ACTIONS(4076),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_AMP_AMP] = ACTIONS(4076),
    [anon_sym_PIPE_PIPE] = ACTIONS(4076),
    [anon_sym_QMARK_QMARK] = ACTIONS(4076),
    [anon_sym_from] = ACTIONS(4076),
    [anon_sym_join] = ACTIONS(4076),
    [anon_sym_on] = ACTIONS(4076),
    [anon_sym_equals] = ACTIONS(4076),
    [anon_sym_let] = ACTIONS(4076),
    [anon_sym_orderby] = ACTIONS(4076),
    [anon_sym_group] = ACTIONS(4076),
    [anon_sym_by] = ACTIONS(4076),
    [anon_sym_select] = ACTIONS(4076),
    [anon_sym_as] = ACTIONS(4076),
    [anon_sym_is] = ACTIONS(4076),
    [anon_sym_DASH_GT] = ACTIONS(4076),
    [anon_sym_with] = ACTIONS(4076),
    [aux_sym_preproc_if_token3] = ACTIONS(4076),
    [aux_sym_preproc_else_token1] = ACTIONS(4076),
    [aux_sym_preproc_elif_token1] = ACTIONS(4076),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3591] = {
    [sym_preproc_region] = STATE(3591),
    [sym_preproc_endregion] = STATE(3591),
    [sym_preproc_line] = STATE(3591),
    [sym_preproc_pragma] = STATE(3591),
    [sym_preproc_nullable] = STATE(3591),
    [sym_preproc_error] = STATE(3591),
    [sym_preproc_define] = STATE(3591),
    [sym_preproc_undef] = STATE(3591),
    [anon_sym_SEMI] = ACTIONS(3719),
    [anon_sym_LBRACK] = ACTIONS(3719),
    [anon_sym_COLON] = ACTIONS(3721),
    [anon_sym_COMMA] = ACTIONS(3719),
    [anon_sym_RBRACK] = ACTIONS(3719),
    [anon_sym_LPAREN] = ACTIONS(3719),
    [anon_sym_RPAREN] = ACTIONS(3719),
    [anon_sym_LBRACE] = ACTIONS(3719),
    [anon_sym_RBRACE] = ACTIONS(3719),
    [anon_sym_LT] = ACTIONS(3721),
    [anon_sym_GT] = ACTIONS(3721),
    [anon_sym_in] = ACTIONS(3719),
    [anon_sym_where] = ACTIONS(3719),
    [anon_sym_QMARK] = ACTIONS(3721),
    [anon_sym_BANG] = ACTIONS(3721),
    [anon_sym_PLUS_PLUS] = ACTIONS(3719),
    [anon_sym_DASH_DASH] = ACTIONS(3719),
    [anon_sym_PLUS] = ACTIONS(3721),
    [anon_sym_DASH] = ACTIONS(3721),
    [anon_sym_STAR] = ACTIONS(3719),
    [anon_sym_SLASH] = ACTIONS(3721),
    [anon_sym_PERCENT] = ACTIONS(3719),
    [anon_sym_CARET] = ACTIONS(3719),
    [anon_sym_PIPE] = ACTIONS(3721),
    [anon_sym_AMP] = ACTIONS(3721),
    [anon_sym_LT_LT] = ACTIONS(3719),
    [anon_sym_GT_GT] = ACTIONS(3721),
    [anon_sym_GT_GT_GT] = ACTIONS(3719),
    [anon_sym_EQ_EQ] = ACTIONS(3719),
    [anon_sym_BANG_EQ] = ACTIONS(3719),
    [anon_sym_GT_EQ] = ACTIONS(3719),
    [anon_sym_LT_EQ] = ACTIONS(3719),
    [anon_sym_DOT] = ACTIONS(3721),
    [anon_sym_EQ_GT] = ACTIONS(3719),
    [anon_sym_COLON_COLON] = ACTIONS(3719),
    [anon_sym_switch] = ACTIONS(3719),
    [anon_sym_DOT_DOT] = ACTIONS(3719),
    [anon_sym_and] = ACTIONS(3719),
    [anon_sym_or] = ACTIONS(3721),
    [anon_sym_AMP_AMP] = ACTIONS(3719),
    [anon_sym_PIPE_PIPE] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK] = ACTIONS(3719),
    [anon_sym_from] = ACTIONS(3719),
    [anon_sym_join] = ACTIONS(3719),
    [anon_sym_on] = ACTIONS(3719),
    [anon_sym_equals] = ACTIONS(3719),
    [anon_sym_let] = ACTIONS(3719),
    [anon_sym_orderby] = ACTIONS(3719),
    [anon_sym_group] = ACTIONS(3719),
    [anon_sym_by] = ACTIONS(3719),
    [anon_sym_select] = ACTIONS(3719),
    [anon_sym_as] = ACTIONS(3719),
    [anon_sym_is] = ACTIONS(3719),
    [anon_sym_DASH_GT] = ACTIONS(3719),
    [anon_sym_with] = ACTIONS(3719),
    [aux_sym_preproc_if_token3] = ACTIONS(3719),
    [aux_sym_preproc_else_token1] = ACTIONS(3719),
    [aux_sym_preproc_elif_token1] = ACTIONS(3719),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3592] = {
    [sym_preproc_region] = STATE(3592),
    [sym_preproc_endregion] = STATE(3592),
    [sym_preproc_line] = STATE(3592),
    [sym_preproc_pragma] = STATE(3592),
    [sym_preproc_nullable] = STATE(3592),
    [sym_preproc_error] = STATE(3592),
    [sym_preproc_define] = STATE(3592),
    [sym_preproc_undef] = STATE(3592),
    [anon_sym_SEMI] = ACTIONS(4124),
    [anon_sym_LBRACK] = ACTIONS(4124),
    [anon_sym_COLON] = ACTIONS(4124),
    [anon_sym_COMMA] = ACTIONS(4124),
    [anon_sym_RBRACK] = ACTIONS(4124),
    [anon_sym_LPAREN] = ACTIONS(4124),
    [anon_sym_RPAREN] = ACTIONS(4124),
    [anon_sym_LBRACE] = ACTIONS(4124),
    [anon_sym_RBRACE] = ACTIONS(4124),
    [anon_sym_LT] = ACTIONS(4113),
    [anon_sym_GT] = ACTIONS(4113),
    [anon_sym_in] = ACTIONS(4113),
    [anon_sym_where] = ACTIONS(4124),
    [anon_sym_QMARK] = ACTIONS(4113),
    [anon_sym_BANG] = ACTIONS(4113),
    [anon_sym_PLUS_PLUS] = ACTIONS(4124),
    [anon_sym_DASH_DASH] = ACTIONS(4124),
    [anon_sym_PLUS] = ACTIONS(4113),
    [anon_sym_DASH] = ACTIONS(4113),
    [anon_sym_STAR] = ACTIONS(4124),
    [anon_sym_SLASH] = ACTIONS(4113),
    [anon_sym_PERCENT] = ACTIONS(4124),
    [anon_sym_CARET] = ACTIONS(4124),
    [anon_sym_PIPE] = ACTIONS(4113),
    [anon_sym_AMP] = ACTIONS(4113),
    [anon_sym_LT_LT] = ACTIONS(4124),
    [anon_sym_GT_GT] = ACTIONS(4113),
    [anon_sym_GT_GT_GT] = ACTIONS(4124),
    [anon_sym_EQ_EQ] = ACTIONS(4124),
    [anon_sym_BANG_EQ] = ACTIONS(4124),
    [anon_sym_GT_EQ] = ACTIONS(4124),
    [anon_sym_LT_EQ] = ACTIONS(4124),
    [anon_sym_DOT] = ACTIONS(4113),
    [anon_sym_EQ_GT] = ACTIONS(4124),
    [anon_sym_switch] = ACTIONS(4124),
    [anon_sym_DOT_DOT] = ACTIONS(4124),
    [anon_sym_and] = ACTIONS(4124),
    [anon_sym_or] = ACTIONS(4113),
    [anon_sym_AMP_AMP] = ACTIONS(4124),
    [anon_sym_PIPE_PIPE] = ACTIONS(4124),
    [anon_sym_QMARK_QMARK] = ACTIONS(4124),
    [anon_sym_from] = ACTIONS(4124),
    [anon_sym_into] = ACTIONS(4124),
    [anon_sym_join] = ACTIONS(4124),
    [anon_sym_on] = ACTIONS(4124),
    [anon_sym_equals] = ACTIONS(4124),
    [anon_sym_let] = ACTIONS(4124),
    [anon_sym_orderby] = ACTIONS(4124),
    [anon_sym_group] = ACTIONS(4124),
    [anon_sym_by] = ACTIONS(4124),
    [anon_sym_select] = ACTIONS(4124),
    [anon_sym_as] = ACTIONS(4124),
    [anon_sym_is] = ACTIONS(4124),
    [anon_sym_DASH_GT] = ACTIONS(4124),
    [anon_sym_with] = ACTIONS(4124),
    [aux_sym_preproc_if_token3] = ACTIONS(4124),
    [aux_sym_preproc_else_token1] = ACTIONS(4124),
    [aux_sym_preproc_elif_token1] = ACTIONS(4124),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3593] = {
    [sym_preproc_region] = STATE(3593),
    [sym_preproc_endregion] = STATE(3593),
    [sym_preproc_line] = STATE(3593),
    [sym_preproc_pragma] = STATE(3593),
    [sym_preproc_nullable] = STATE(3593),
    [sym_preproc_error] = STATE(3593),
    [sym_preproc_define] = STATE(3593),
    [sym_preproc_undef] = STATE(3593),
    [anon_sym_SEMI] = ACTIONS(4349),
    [anon_sym_LBRACK] = ACTIONS(4349),
    [anon_sym_COLON] = ACTIONS(4349),
    [anon_sym_COMMA] = ACTIONS(4349),
    [anon_sym_RBRACK] = ACTIONS(4349),
    [anon_sym_LPAREN] = ACTIONS(4349),
    [anon_sym_RPAREN] = ACTIONS(4349),
    [anon_sym_LBRACE] = ACTIONS(4349),
    [anon_sym_RBRACE] = ACTIONS(4349),
    [anon_sym_LT] = ACTIONS(4347),
    [anon_sym_GT] = ACTIONS(4347),
    [anon_sym_in] = ACTIONS(4347),
    [anon_sym_where] = ACTIONS(4349),
    [anon_sym_QMARK] = ACTIONS(4347),
    [anon_sym_BANG] = ACTIONS(4347),
    [anon_sym_PLUS_PLUS] = ACTIONS(4349),
    [anon_sym_DASH_DASH] = ACTIONS(4349),
    [anon_sym_PLUS] = ACTIONS(4347),
    [anon_sym_DASH] = ACTIONS(4347),
    [anon_sym_STAR] = ACTIONS(4349),
    [anon_sym_SLASH] = ACTIONS(4347),
    [anon_sym_PERCENT] = ACTIONS(4349),
    [anon_sym_CARET] = ACTIONS(4349),
    [anon_sym_PIPE] = ACTIONS(4347),
    [anon_sym_AMP] = ACTIONS(4347),
    [anon_sym_LT_LT] = ACTIONS(4349),
    [anon_sym_GT_GT] = ACTIONS(4347),
    [anon_sym_GT_GT_GT] = ACTIONS(4349),
    [anon_sym_EQ_EQ] = ACTIONS(4349),
    [anon_sym_BANG_EQ] = ACTIONS(4349),
    [anon_sym_GT_EQ] = ACTIONS(4349),
    [anon_sym_LT_EQ] = ACTIONS(4349),
    [anon_sym_DOT] = ACTIONS(4347),
    [anon_sym_EQ_GT] = ACTIONS(4349),
    [anon_sym_switch] = ACTIONS(4349),
    [anon_sym_DOT_DOT] = ACTIONS(4349),
    [anon_sym_and] = ACTIONS(4349),
    [anon_sym_or] = ACTIONS(4347),
    [anon_sym_AMP_AMP] = ACTIONS(4349),
    [anon_sym_PIPE_PIPE] = ACTIONS(4349),
    [anon_sym_QMARK_QMARK] = ACTIONS(4349),
    [anon_sym_from] = ACTIONS(4349),
    [anon_sym_into] = ACTIONS(4349),
    [anon_sym_join] = ACTIONS(4349),
    [anon_sym_on] = ACTIONS(4349),
    [anon_sym_equals] = ACTIONS(4349),
    [anon_sym_let] = ACTIONS(4349),
    [anon_sym_orderby] = ACTIONS(4349),
    [anon_sym_group] = ACTIONS(4349),
    [anon_sym_by] = ACTIONS(4349),
    [anon_sym_select] = ACTIONS(4349),
    [anon_sym_as] = ACTIONS(4349),
    [anon_sym_is] = ACTIONS(4349),
    [anon_sym_DASH_GT] = ACTIONS(4349),
    [anon_sym_with] = ACTIONS(4349),
    [aux_sym_preproc_if_token3] = ACTIONS(4349),
    [aux_sym_preproc_else_token1] = ACTIONS(4349),
    [aux_sym_preproc_elif_token1] = ACTIONS(4349),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3594] = {
    [sym_preproc_region] = STATE(3594),
    [sym_preproc_endregion] = STATE(3594),
    [sym_preproc_line] = STATE(3594),
    [sym_preproc_pragma] = STATE(3594),
    [sym_preproc_nullable] = STATE(3594),
    [sym_preproc_error] = STATE(3594),
    [sym_preproc_define] = STATE(3594),
    [sym_preproc_undef] = STATE(3594),
    [anon_sym_SEMI] = ACTIONS(5288),
    [anon_sym_LBRACK] = ACTIONS(5288),
    [anon_sym_COLON] = ACTIONS(5288),
    [anon_sym_COMMA] = ACTIONS(5288),
    [anon_sym_RBRACK] = ACTIONS(5288),
    [anon_sym_LPAREN] = ACTIONS(5288),
    [anon_sym_RPAREN] = ACTIONS(5288),
    [anon_sym_LBRACE] = ACTIONS(5288),
    [anon_sym_RBRACE] = ACTIONS(5288),
    [anon_sym_LT] = ACTIONS(5290),
    [anon_sym_GT] = ACTIONS(5290),
    [anon_sym_in] = ACTIONS(5290),
    [anon_sym_where] = ACTIONS(5288),
    [anon_sym_QMARK] = ACTIONS(5290),
    [anon_sym_BANG] = ACTIONS(5290),
    [anon_sym_PLUS_PLUS] = ACTIONS(5288),
    [anon_sym_DASH_DASH] = ACTIONS(5288),
    [anon_sym_PLUS] = ACTIONS(5290),
    [anon_sym_DASH] = ACTIONS(5290),
    [anon_sym_STAR] = ACTIONS(5288),
    [anon_sym_SLASH] = ACTIONS(5290),
    [anon_sym_PERCENT] = ACTIONS(5288),
    [anon_sym_CARET] = ACTIONS(5288),
    [anon_sym_PIPE] = ACTIONS(5290),
    [anon_sym_AMP] = ACTIONS(5290),
    [anon_sym_LT_LT] = ACTIONS(5288),
    [anon_sym_GT_GT] = ACTIONS(5290),
    [anon_sym_GT_GT_GT] = ACTIONS(5288),
    [anon_sym_EQ_EQ] = ACTIONS(5288),
    [anon_sym_BANG_EQ] = ACTIONS(5288),
    [anon_sym_GT_EQ] = ACTIONS(5288),
    [anon_sym_LT_EQ] = ACTIONS(5288),
    [anon_sym_DOT] = ACTIONS(5290),
    [anon_sym_EQ_GT] = ACTIONS(5288),
    [anon_sym_switch] = ACTIONS(5288),
    [anon_sym_DOT_DOT] = ACTIONS(5288),
    [anon_sym_and] = ACTIONS(5288),
    [anon_sym_or] = ACTIONS(5290),
    [anon_sym_AMP_AMP] = ACTIONS(5288),
    [anon_sym_PIPE_PIPE] = ACTIONS(5288),
    [anon_sym_QMARK_QMARK] = ACTIONS(5288),
    [anon_sym_from] = ACTIONS(5288),
    [anon_sym_into] = ACTIONS(5288),
    [anon_sym_join] = ACTIONS(5288),
    [anon_sym_on] = ACTIONS(5288),
    [anon_sym_equals] = ACTIONS(5288),
    [anon_sym_let] = ACTIONS(5288),
    [anon_sym_orderby] = ACTIONS(5288),
    [anon_sym_group] = ACTIONS(5288),
    [anon_sym_by] = ACTIONS(5288),
    [anon_sym_select] = ACTIONS(5288),
    [anon_sym_as] = ACTIONS(5288),
    [anon_sym_is] = ACTIONS(5288),
    [anon_sym_DASH_GT] = ACTIONS(5288),
    [anon_sym_with] = ACTIONS(5288),
    [aux_sym_preproc_if_token3] = ACTIONS(5288),
    [aux_sym_preproc_else_token1] = ACTIONS(5288),
    [aux_sym_preproc_elif_token1] = ACTIONS(5288),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3595] = {
    [sym_preproc_region] = STATE(3595),
    [sym_preproc_endregion] = STATE(3595),
    [sym_preproc_line] = STATE(3595),
    [sym_preproc_pragma] = STATE(3595),
    [sym_preproc_nullable] = STATE(3595),
    [sym_preproc_error] = STATE(3595),
    [sym_preproc_define] = STATE(3595),
    [sym_preproc_undef] = STATE(3595),
    [anon_sym_SEMI] = ACTIONS(4404),
    [anon_sym_LBRACK] = ACTIONS(4404),
    [anon_sym_COLON] = ACTIONS(4404),
    [anon_sym_COMMA] = ACTIONS(4404),
    [anon_sym_RBRACK] = ACTIONS(4404),
    [anon_sym_LPAREN] = ACTIONS(4404),
    [anon_sym_RPAREN] = ACTIONS(4404),
    [anon_sym_LBRACE] = ACTIONS(4404),
    [anon_sym_RBRACE] = ACTIONS(4404),
    [anon_sym_LT] = ACTIONS(4402),
    [anon_sym_GT] = ACTIONS(4402),
    [anon_sym_in] = ACTIONS(4402),
    [anon_sym_where] = ACTIONS(4404),
    [anon_sym_QMARK] = ACTIONS(4402),
    [anon_sym_BANG] = ACTIONS(4402),
    [anon_sym_PLUS_PLUS] = ACTIONS(4404),
    [anon_sym_DASH_DASH] = ACTIONS(4404),
    [anon_sym_PLUS] = ACTIONS(4402),
    [anon_sym_DASH] = ACTIONS(4402),
    [anon_sym_STAR] = ACTIONS(4404),
    [anon_sym_SLASH] = ACTIONS(4402),
    [anon_sym_PERCENT] = ACTIONS(4404),
    [anon_sym_CARET] = ACTIONS(4404),
    [anon_sym_PIPE] = ACTIONS(4402),
    [anon_sym_AMP] = ACTIONS(4402),
    [anon_sym_LT_LT] = ACTIONS(4404),
    [anon_sym_GT_GT] = ACTIONS(4402),
    [anon_sym_GT_GT_GT] = ACTIONS(4404),
    [anon_sym_EQ_EQ] = ACTIONS(4404),
    [anon_sym_BANG_EQ] = ACTIONS(4404),
    [anon_sym_GT_EQ] = ACTIONS(4404),
    [anon_sym_LT_EQ] = ACTIONS(4404),
    [anon_sym_DOT] = ACTIONS(4402),
    [anon_sym_EQ_GT] = ACTIONS(4404),
    [anon_sym_switch] = ACTIONS(4404),
    [anon_sym_DOT_DOT] = ACTIONS(4404),
    [anon_sym_and] = ACTIONS(4404),
    [anon_sym_or] = ACTIONS(4402),
    [anon_sym_AMP_AMP] = ACTIONS(4404),
    [anon_sym_PIPE_PIPE] = ACTIONS(4404),
    [anon_sym_QMARK_QMARK] = ACTIONS(4404),
    [anon_sym_from] = ACTIONS(4404),
    [anon_sym_into] = ACTIONS(4404),
    [anon_sym_join] = ACTIONS(4404),
    [anon_sym_on] = ACTIONS(4404),
    [anon_sym_equals] = ACTIONS(4404),
    [anon_sym_let] = ACTIONS(4404),
    [anon_sym_orderby] = ACTIONS(4404),
    [anon_sym_group] = ACTIONS(4404),
    [anon_sym_by] = ACTIONS(4404),
    [anon_sym_select] = ACTIONS(4404),
    [anon_sym_as] = ACTIONS(4404),
    [anon_sym_is] = ACTIONS(4404),
    [anon_sym_DASH_GT] = ACTIONS(4404),
    [anon_sym_with] = ACTIONS(4404),
    [aux_sym_preproc_if_token3] = ACTIONS(4404),
    [aux_sym_preproc_else_token1] = ACTIONS(4404),
    [aux_sym_preproc_elif_token1] = ACTIONS(4404),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3596] = {
    [sym_preproc_region] = STATE(3596),
    [sym_preproc_endregion] = STATE(3596),
    [sym_preproc_line] = STATE(3596),
    [sym_preproc_pragma] = STATE(3596),
    [sym_preproc_nullable] = STATE(3596),
    [sym_preproc_error] = STATE(3596),
    [sym_preproc_define] = STATE(3596),
    [sym_preproc_undef] = STATE(3596),
    [anon_sym_SEMI] = ACTIONS(4408),
    [anon_sym_LBRACK] = ACTIONS(4408),
    [anon_sym_COLON] = ACTIONS(4408),
    [anon_sym_COMMA] = ACTIONS(4408),
    [anon_sym_RBRACK] = ACTIONS(4408),
    [anon_sym_LPAREN] = ACTIONS(4408),
    [anon_sym_RPAREN] = ACTIONS(4408),
    [anon_sym_LBRACE] = ACTIONS(4408),
    [anon_sym_RBRACE] = ACTIONS(4408),
    [anon_sym_LT] = ACTIONS(4406),
    [anon_sym_GT] = ACTIONS(4406),
    [anon_sym_in] = ACTIONS(4406),
    [anon_sym_where] = ACTIONS(4408),
    [anon_sym_QMARK] = ACTIONS(4406),
    [anon_sym_BANG] = ACTIONS(4406),
    [anon_sym_PLUS_PLUS] = ACTIONS(4408),
    [anon_sym_DASH_DASH] = ACTIONS(4408),
    [anon_sym_PLUS] = ACTIONS(4406),
    [anon_sym_DASH] = ACTIONS(4406),
    [anon_sym_STAR] = ACTIONS(4408),
    [anon_sym_SLASH] = ACTIONS(4406),
    [anon_sym_PERCENT] = ACTIONS(4408),
    [anon_sym_CARET] = ACTIONS(4408),
    [anon_sym_PIPE] = ACTIONS(4406),
    [anon_sym_AMP] = ACTIONS(4406),
    [anon_sym_LT_LT] = ACTIONS(4408),
    [anon_sym_GT_GT] = ACTIONS(4406),
    [anon_sym_GT_GT_GT] = ACTIONS(4408),
    [anon_sym_EQ_EQ] = ACTIONS(4408),
    [anon_sym_BANG_EQ] = ACTIONS(4408),
    [anon_sym_GT_EQ] = ACTIONS(4408),
    [anon_sym_LT_EQ] = ACTIONS(4408),
    [anon_sym_DOT] = ACTIONS(4406),
    [anon_sym_EQ_GT] = ACTIONS(4408),
    [anon_sym_switch] = ACTIONS(4408),
    [anon_sym_DOT_DOT] = ACTIONS(4408),
    [anon_sym_and] = ACTIONS(4408),
    [anon_sym_or] = ACTIONS(4406),
    [anon_sym_AMP_AMP] = ACTIONS(4408),
    [anon_sym_PIPE_PIPE] = ACTIONS(4408),
    [anon_sym_QMARK_QMARK] = ACTIONS(4408),
    [anon_sym_from] = ACTIONS(4408),
    [anon_sym_into] = ACTIONS(4408),
    [anon_sym_join] = ACTIONS(4408),
    [anon_sym_on] = ACTIONS(4408),
    [anon_sym_equals] = ACTIONS(4408),
    [anon_sym_let] = ACTIONS(4408),
    [anon_sym_orderby] = ACTIONS(4408),
    [anon_sym_group] = ACTIONS(4408),
    [anon_sym_by] = ACTIONS(4408),
    [anon_sym_select] = ACTIONS(4408),
    [anon_sym_as] = ACTIONS(4408),
    [anon_sym_is] = ACTIONS(4408),
    [anon_sym_DASH_GT] = ACTIONS(4408),
    [anon_sym_with] = ACTIONS(4408),
    [aux_sym_preproc_if_token3] = ACTIONS(4408),
    [aux_sym_preproc_else_token1] = ACTIONS(4408),
    [aux_sym_preproc_elif_token1] = ACTIONS(4408),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3597] = {
    [sym_initializer_expression] = STATE(3713),
    [sym_preproc_region] = STATE(3597),
    [sym_preproc_endregion] = STATE(3597),
    [sym_preproc_line] = STATE(3597),
    [sym_preproc_pragma] = STATE(3597),
    [sym_preproc_nullable] = STATE(3597),
    [sym_preproc_error] = STATE(3597),
    [sym_preproc_define] = STATE(3597),
    [sym_preproc_undef] = STATE(3597),
    [anon_sym_SEMI] = ACTIONS(5205),
    [anon_sym_LBRACK] = ACTIONS(5205),
    [anon_sym_COLON] = ACTIONS(5205),
    [anon_sym_COMMA] = ACTIONS(5205),
    [anon_sym_RBRACK] = ACTIONS(5205),
    [anon_sym_LPAREN] = ACTIONS(5205),
    [anon_sym_RPAREN] = ACTIONS(5205),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_RBRACE] = ACTIONS(5205),
    [anon_sym_LT] = ACTIONS(5207),
    [anon_sym_GT] = ACTIONS(5207),
    [anon_sym_in] = ACTIONS(5205),
    [anon_sym_where] = ACTIONS(5205),
    [anon_sym_QMARK] = ACTIONS(5207),
    [anon_sym_BANG] = ACTIONS(5207),
    [anon_sym_PLUS_PLUS] = ACTIONS(5205),
    [anon_sym_DASH_DASH] = ACTIONS(5205),
    [anon_sym_PLUS] = ACTIONS(5207),
    [anon_sym_DASH] = ACTIONS(5207),
    [anon_sym_STAR] = ACTIONS(5205),
    [anon_sym_SLASH] = ACTIONS(5207),
    [anon_sym_PERCENT] = ACTIONS(5205),
    [anon_sym_CARET] = ACTIONS(5205),
    [anon_sym_PIPE] = ACTIONS(5207),
    [anon_sym_AMP] = ACTIONS(5207),
    [anon_sym_LT_LT] = ACTIONS(5205),
    [anon_sym_GT_GT] = ACTIONS(5207),
    [anon_sym_GT_GT_GT] = ACTIONS(5205),
    [anon_sym_EQ_EQ] = ACTIONS(5205),
    [anon_sym_BANG_EQ] = ACTIONS(5205),
    [anon_sym_GT_EQ] = ACTIONS(5205),
    [anon_sym_LT_EQ] = ACTIONS(5205),
    [anon_sym_DOT] = ACTIONS(5207),
    [anon_sym_EQ_GT] = ACTIONS(5205),
    [anon_sym_switch] = ACTIONS(5205),
    [anon_sym_DOT_DOT] = ACTIONS(5205),
    [anon_sym_and] = ACTIONS(5205),
    [anon_sym_or] = ACTIONS(5207),
    [anon_sym_AMP_AMP] = ACTIONS(5205),
    [anon_sym_PIPE_PIPE] = ACTIONS(5205),
    [anon_sym_QMARK_QMARK] = ACTIONS(5205),
    [anon_sym_from] = ACTIONS(5205),
    [anon_sym_join] = ACTIONS(5205),
    [anon_sym_on] = ACTIONS(5205),
    [anon_sym_equals] = ACTIONS(5205),
    [anon_sym_let] = ACTIONS(5205),
    [anon_sym_orderby] = ACTIONS(5205),
    [anon_sym_group] = ACTIONS(5205),
    [anon_sym_by] = ACTIONS(5205),
    [anon_sym_select] = ACTIONS(5205),
    [anon_sym_as] = ACTIONS(5205),
    [anon_sym_is] = ACTIONS(5205),
    [anon_sym_DASH_GT] = ACTIONS(5205),
    [anon_sym_with] = ACTIONS(5205),
    [aux_sym_preproc_if_token3] = ACTIONS(5205),
    [aux_sym_preproc_else_token1] = ACTIONS(5205),
    [aux_sym_preproc_elif_token1] = ACTIONS(5205),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3598] = {
    [sym_preproc_region] = STATE(3598),
    [sym_preproc_endregion] = STATE(3598),
    [sym_preproc_line] = STATE(3598),
    [sym_preproc_pragma] = STATE(3598),
    [sym_preproc_nullable] = STATE(3598),
    [sym_preproc_error] = STATE(3598),
    [sym_preproc_define] = STATE(3598),
    [sym_preproc_undef] = STATE(3598),
    [anon_sym_SEMI] = ACTIONS(4416),
    [anon_sym_LBRACK] = ACTIONS(4416),
    [anon_sym_COLON] = ACTIONS(4416),
    [anon_sym_COMMA] = ACTIONS(4416),
    [anon_sym_RBRACK] = ACTIONS(4416),
    [anon_sym_LPAREN] = ACTIONS(4416),
    [anon_sym_RPAREN] = ACTIONS(4416),
    [anon_sym_LBRACE] = ACTIONS(4416),
    [anon_sym_RBRACE] = ACTIONS(4416),
    [anon_sym_LT] = ACTIONS(4414),
    [anon_sym_GT] = ACTIONS(4414),
    [anon_sym_in] = ACTIONS(4414),
    [anon_sym_where] = ACTIONS(4416),
    [anon_sym_QMARK] = ACTIONS(4414),
    [anon_sym_BANG] = ACTIONS(4414),
    [anon_sym_PLUS_PLUS] = ACTIONS(4416),
    [anon_sym_DASH_DASH] = ACTIONS(4416),
    [anon_sym_PLUS] = ACTIONS(4414),
    [anon_sym_DASH] = ACTIONS(4414),
    [anon_sym_STAR] = ACTIONS(4416),
    [anon_sym_SLASH] = ACTIONS(4414),
    [anon_sym_PERCENT] = ACTIONS(4416),
    [anon_sym_CARET] = ACTIONS(4416),
    [anon_sym_PIPE] = ACTIONS(4414),
    [anon_sym_AMP] = ACTIONS(4414),
    [anon_sym_LT_LT] = ACTIONS(4416),
    [anon_sym_GT_GT] = ACTIONS(4414),
    [anon_sym_GT_GT_GT] = ACTIONS(4416),
    [anon_sym_EQ_EQ] = ACTIONS(4416),
    [anon_sym_BANG_EQ] = ACTIONS(4416),
    [anon_sym_GT_EQ] = ACTIONS(4416),
    [anon_sym_LT_EQ] = ACTIONS(4416),
    [anon_sym_DOT] = ACTIONS(4414),
    [anon_sym_EQ_GT] = ACTIONS(4416),
    [anon_sym_switch] = ACTIONS(4416),
    [anon_sym_DOT_DOT] = ACTIONS(4416),
    [anon_sym_and] = ACTIONS(4416),
    [anon_sym_or] = ACTIONS(4414),
    [anon_sym_AMP_AMP] = ACTIONS(4416),
    [anon_sym_PIPE_PIPE] = ACTIONS(4416),
    [anon_sym_QMARK_QMARK] = ACTIONS(4416),
    [anon_sym_from] = ACTIONS(4416),
    [anon_sym_into] = ACTIONS(4416),
    [anon_sym_join] = ACTIONS(4416),
    [anon_sym_on] = ACTIONS(4416),
    [anon_sym_equals] = ACTIONS(4416),
    [anon_sym_let] = ACTIONS(4416),
    [anon_sym_orderby] = ACTIONS(4416),
    [anon_sym_group] = ACTIONS(4416),
    [anon_sym_by] = ACTIONS(4416),
    [anon_sym_select] = ACTIONS(4416),
    [anon_sym_as] = ACTIONS(4416),
    [anon_sym_is] = ACTIONS(4416),
    [anon_sym_DASH_GT] = ACTIONS(4416),
    [anon_sym_with] = ACTIONS(4416),
    [aux_sym_preproc_if_token3] = ACTIONS(4416),
    [aux_sym_preproc_else_token1] = ACTIONS(4416),
    [aux_sym_preproc_elif_token1] = ACTIONS(4416),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3599] = {
    [sym_preproc_region] = STATE(3599),
    [sym_preproc_endregion] = STATE(3599),
    [sym_preproc_line] = STATE(3599),
    [sym_preproc_pragma] = STATE(3599),
    [sym_preproc_nullable] = STATE(3599),
    [sym_preproc_error] = STATE(3599),
    [sym_preproc_define] = STATE(3599),
    [sym_preproc_undef] = STATE(3599),
    [anon_sym_SEMI] = ACTIONS(5292),
    [anon_sym_LBRACK] = ACTIONS(5292),
    [anon_sym_COLON] = ACTIONS(5292),
    [anon_sym_COMMA] = ACTIONS(5292),
    [anon_sym_RBRACK] = ACTIONS(5292),
    [anon_sym_LPAREN] = ACTIONS(5292),
    [anon_sym_RPAREN] = ACTIONS(5292),
    [anon_sym_RBRACE] = ACTIONS(5292),
    [anon_sym_LT] = ACTIONS(5294),
    [anon_sym_GT] = ACTIONS(5294),
    [anon_sym_in] = ACTIONS(5294),
    [anon_sym_where] = ACTIONS(5292),
    [anon_sym_QMARK] = ACTIONS(5294),
    [anon_sym_BANG] = ACTIONS(5294),
    [anon_sym_PLUS_PLUS] = ACTIONS(5292),
    [anon_sym_DASH_DASH] = ACTIONS(5292),
    [anon_sym_PLUS] = ACTIONS(5294),
    [anon_sym_DASH] = ACTIONS(5294),
    [anon_sym_STAR] = ACTIONS(5292),
    [anon_sym_SLASH] = ACTIONS(5294),
    [anon_sym_PERCENT] = ACTIONS(5292),
    [anon_sym_CARET] = ACTIONS(5292),
    [anon_sym_PIPE] = ACTIONS(5294),
    [anon_sym_AMP] = ACTIONS(5294),
    [anon_sym_LT_LT] = ACTIONS(5292),
    [anon_sym_GT_GT] = ACTIONS(5294),
    [anon_sym_GT_GT_GT] = ACTIONS(5292),
    [anon_sym_EQ_EQ] = ACTIONS(5292),
    [anon_sym_BANG_EQ] = ACTIONS(5292),
    [anon_sym_GT_EQ] = ACTIONS(5292),
    [anon_sym_LT_EQ] = ACTIONS(5292),
    [anon_sym_DOT] = ACTIONS(5294),
    [anon_sym_EQ_GT] = ACTIONS(5292),
    [anon_sym_switch] = ACTIONS(5292),
    [anon_sym_DOT_DOT] = ACTIONS(5292),
    [anon_sym_and] = ACTIONS(5292),
    [anon_sym_or] = ACTIONS(5294),
    [anon_sym_AMP_AMP] = ACTIONS(5292),
    [anon_sym_PIPE_PIPE] = ACTIONS(5292),
    [anon_sym_QMARK_QMARK] = ACTIONS(5292),
    [anon_sym_from] = ACTIONS(5292),
    [anon_sym_into] = ACTIONS(5292),
    [anon_sym_join] = ACTIONS(5292),
    [anon_sym_on] = ACTIONS(5292),
    [anon_sym_equals] = ACTIONS(5292),
    [anon_sym_let] = ACTIONS(5292),
    [anon_sym_orderby] = ACTIONS(5292),
    [anon_sym_group] = ACTIONS(5292),
    [anon_sym_by] = ACTIONS(5292),
    [anon_sym_select] = ACTIONS(5292),
    [anon_sym_as] = ACTIONS(5292),
    [anon_sym_is] = ACTIONS(5292),
    [anon_sym_DASH_GT] = ACTIONS(5292),
    [anon_sym_with] = ACTIONS(5292),
    [sym_string_literal_encoding] = ACTIONS(5296),
    [aux_sym_preproc_if_token3] = ACTIONS(5292),
    [aux_sym_preproc_else_token1] = ACTIONS(5292),
    [aux_sym_preproc_elif_token1] = ACTIONS(5292),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3600] = {
    [sym_preproc_region] = STATE(3600),
    [sym_preproc_endregion] = STATE(3600),
    [sym_preproc_line] = STATE(3600),
    [sym_preproc_pragma] = STATE(3600),
    [sym_preproc_nullable] = STATE(3600),
    [sym_preproc_error] = STATE(3600),
    [sym_preproc_define] = STATE(3600),
    [sym_preproc_undef] = STATE(3600),
    [anon_sym_SEMI] = ACTIONS(4566),
    [anon_sym_LBRACK] = ACTIONS(4566),
    [anon_sym_COLON] = ACTIONS(4566),
    [anon_sym_COMMA] = ACTIONS(4566),
    [anon_sym_RBRACK] = ACTIONS(4566),
    [anon_sym_LPAREN] = ACTIONS(4566),
    [anon_sym_RPAREN] = ACTIONS(4566),
    [anon_sym_LBRACE] = ACTIONS(4566),
    [anon_sym_RBRACE] = ACTIONS(4566),
    [anon_sym_LT] = ACTIONS(4564),
    [anon_sym_GT] = ACTIONS(4564),
    [anon_sym_in] = ACTIONS(4564),
    [anon_sym_where] = ACTIONS(4566),
    [anon_sym_QMARK] = ACTIONS(4564),
    [anon_sym_BANG] = ACTIONS(4564),
    [anon_sym_PLUS_PLUS] = ACTIONS(4566),
    [anon_sym_DASH_DASH] = ACTIONS(4566),
    [anon_sym_PLUS] = ACTIONS(4564),
    [anon_sym_DASH] = ACTIONS(4564),
    [anon_sym_STAR] = ACTIONS(4566),
    [anon_sym_SLASH] = ACTIONS(4564),
    [anon_sym_PERCENT] = ACTIONS(4566),
    [anon_sym_CARET] = ACTIONS(4566),
    [anon_sym_PIPE] = ACTIONS(4564),
    [anon_sym_AMP] = ACTIONS(4564),
    [anon_sym_LT_LT] = ACTIONS(4566),
    [anon_sym_GT_GT] = ACTIONS(4564),
    [anon_sym_GT_GT_GT] = ACTIONS(4566),
    [anon_sym_EQ_EQ] = ACTIONS(4566),
    [anon_sym_BANG_EQ] = ACTIONS(4566),
    [anon_sym_GT_EQ] = ACTIONS(4566),
    [anon_sym_LT_EQ] = ACTIONS(4566),
    [anon_sym_DOT] = ACTIONS(4564),
    [anon_sym_EQ_GT] = ACTIONS(4566),
    [anon_sym_switch] = ACTIONS(4566),
    [anon_sym_DOT_DOT] = ACTIONS(4566),
    [anon_sym_and] = ACTIONS(4566),
    [anon_sym_or] = ACTIONS(4564),
    [anon_sym_AMP_AMP] = ACTIONS(4566),
    [anon_sym_PIPE_PIPE] = ACTIONS(4566),
    [anon_sym_QMARK_QMARK] = ACTIONS(4566),
    [anon_sym_from] = ACTIONS(4566),
    [anon_sym_into] = ACTIONS(4566),
    [anon_sym_join] = ACTIONS(4566),
    [anon_sym_on] = ACTIONS(4566),
    [anon_sym_equals] = ACTIONS(4566),
    [anon_sym_let] = ACTIONS(4566),
    [anon_sym_orderby] = ACTIONS(4566),
    [anon_sym_group] = ACTIONS(4566),
    [anon_sym_by] = ACTIONS(4566),
    [anon_sym_select] = ACTIONS(4566),
    [anon_sym_as] = ACTIONS(4566),
    [anon_sym_is] = ACTIONS(4566),
    [anon_sym_DASH_GT] = ACTIONS(4566),
    [anon_sym_with] = ACTIONS(4566),
    [aux_sym_preproc_if_token3] = ACTIONS(4566),
    [aux_sym_preproc_else_token1] = ACTIONS(4566),
    [aux_sym_preproc_elif_token1] = ACTIONS(4566),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3601] = {
    [sym_initializer_expression] = STATE(3719),
    [sym_preproc_region] = STATE(3601),
    [sym_preproc_endregion] = STATE(3601),
    [sym_preproc_line] = STATE(3601),
    [sym_preproc_pragma] = STATE(3601),
    [sym_preproc_nullable] = STATE(3601),
    [sym_preproc_error] = STATE(3601),
    [sym_preproc_define] = STATE(3601),
    [sym_preproc_undef] = STATE(3601),
    [anon_sym_SEMI] = ACTIONS(4424),
    [anon_sym_LBRACK] = ACTIONS(5298),
    [anon_sym_COLON] = ACTIONS(5302),
    [anon_sym_COMMA] = ACTIONS(5302),
    [anon_sym_RBRACK] = ACTIONS(5302),
    [anon_sym_LPAREN] = ACTIONS(5302),
    [anon_sym_RPAREN] = ACTIONS(5302),
    [anon_sym_LBRACE] = ACTIONS(5305),
    [anon_sym_RBRACE] = ACTIONS(5302),
    [anon_sym_LT] = ACTIONS(5308),
    [anon_sym_GT] = ACTIONS(5308),
    [anon_sym_in] = ACTIONS(5302),
    [anon_sym_where] = ACTIONS(5302),
    [anon_sym_QMARK] = ACTIONS(5311),
    [anon_sym_BANG] = ACTIONS(5308),
    [anon_sym_PLUS_PLUS] = ACTIONS(5302),
    [anon_sym_DASH_DASH] = ACTIONS(5302),
    [anon_sym_PLUS] = ACTIONS(5308),
    [anon_sym_DASH] = ACTIONS(5308),
    [anon_sym_STAR] = ACTIONS(5302),
    [anon_sym_SLASH] = ACTIONS(5308),
    [anon_sym_PERCENT] = ACTIONS(5302),
    [anon_sym_CARET] = ACTIONS(5302),
    [anon_sym_PIPE] = ACTIONS(5308),
    [anon_sym_AMP] = ACTIONS(5308),
    [anon_sym_LT_LT] = ACTIONS(5302),
    [anon_sym_GT_GT] = ACTIONS(5308),
    [anon_sym_GT_GT_GT] = ACTIONS(5302),
    [anon_sym_EQ_EQ] = ACTIONS(5302),
    [anon_sym_BANG_EQ] = ACTIONS(5302),
    [anon_sym_GT_EQ] = ACTIONS(5302),
    [anon_sym_LT_EQ] = ACTIONS(5302),
    [anon_sym_DOT] = ACTIONS(5308),
    [anon_sym_EQ_GT] = ACTIONS(5302),
    [anon_sym_switch] = ACTIONS(5302),
    [anon_sym_DOT_DOT] = ACTIONS(5302),
    [anon_sym_and] = ACTIONS(5302),
    [anon_sym_or] = ACTIONS(5308),
    [anon_sym_AMP_AMP] = ACTIONS(5302),
    [anon_sym_PIPE_PIPE] = ACTIONS(5302),
    [anon_sym_QMARK_QMARK] = ACTIONS(5302),
    [anon_sym_from] = ACTIONS(5302),
    [anon_sym_join] = ACTIONS(5302),
    [anon_sym_on] = ACTIONS(5302),
    [anon_sym_equals] = ACTIONS(5302),
    [anon_sym_let] = ACTIONS(5302),
    [anon_sym_orderby] = ACTIONS(5302),
    [anon_sym_group] = ACTIONS(5302),
    [anon_sym_by] = ACTIONS(5302),
    [anon_sym_select] = ACTIONS(5302),
    [anon_sym_as] = ACTIONS(5302),
    [anon_sym_is] = ACTIONS(5302),
    [anon_sym_DASH_GT] = ACTIONS(5302),
    [anon_sym_with] = ACTIONS(5302),
    [aux_sym_preproc_if_token3] = ACTIONS(5302),
    [aux_sym_preproc_else_token1] = ACTIONS(5302),
    [aux_sym_preproc_elif_token1] = ACTIONS(5302),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3602] = {
    [sym_preproc_region] = STATE(3602),
    [sym_preproc_endregion] = STATE(3602),
    [sym_preproc_line] = STATE(3602),
    [sym_preproc_pragma] = STATE(3602),
    [sym_preproc_nullable] = STATE(3602),
    [sym_preproc_error] = STATE(3602),
    [sym_preproc_define] = STATE(3602),
    [sym_preproc_undef] = STATE(3602),
    [anon_sym_SEMI] = ACTIONS(4062),
    [anon_sym_LBRACK] = ACTIONS(4062),
    [anon_sym_COLON] = ACTIONS(4062),
    [anon_sym_COMMA] = ACTIONS(4062),
    [anon_sym_RBRACK] = ACTIONS(4062),
    [anon_sym_LPAREN] = ACTIONS(4062),
    [anon_sym_RPAREN] = ACTIONS(4062),
    [anon_sym_LBRACE] = ACTIONS(4062),
    [anon_sym_RBRACE] = ACTIONS(4062),
    [anon_sym_LT] = ACTIONS(4060),
    [anon_sym_GT] = ACTIONS(4060),
    [anon_sym_in] = ACTIONS(4060),
    [anon_sym_where] = ACTIONS(4062),
    [anon_sym_QMARK] = ACTIONS(4060),
    [anon_sym_BANG] = ACTIONS(4060),
    [anon_sym_PLUS_PLUS] = ACTIONS(4062),
    [anon_sym_DASH_DASH] = ACTIONS(4062),
    [anon_sym_PLUS] = ACTIONS(4060),
    [anon_sym_DASH] = ACTIONS(4060),
    [anon_sym_STAR] = ACTIONS(4062),
    [anon_sym_SLASH] = ACTIONS(4060),
    [anon_sym_PERCENT] = ACTIONS(4062),
    [anon_sym_CARET] = ACTIONS(4062),
    [anon_sym_PIPE] = ACTIONS(4060),
    [anon_sym_AMP] = ACTIONS(4060),
    [anon_sym_LT_LT] = ACTIONS(4062),
    [anon_sym_GT_GT] = ACTIONS(4060),
    [anon_sym_GT_GT_GT] = ACTIONS(4062),
    [anon_sym_EQ_EQ] = ACTIONS(4062),
    [anon_sym_BANG_EQ] = ACTIONS(4062),
    [anon_sym_GT_EQ] = ACTIONS(4062),
    [anon_sym_LT_EQ] = ACTIONS(4062),
    [anon_sym_DOT] = ACTIONS(4060),
    [anon_sym_EQ_GT] = ACTIONS(4062),
    [anon_sym_switch] = ACTIONS(4062),
    [anon_sym_DOT_DOT] = ACTIONS(4062),
    [anon_sym_and] = ACTIONS(4062),
    [anon_sym_or] = ACTIONS(4060),
    [anon_sym_AMP_AMP] = ACTIONS(4062),
    [anon_sym_PIPE_PIPE] = ACTIONS(4062),
    [anon_sym_QMARK_QMARK] = ACTIONS(4062),
    [anon_sym_from] = ACTIONS(4062),
    [anon_sym_into] = ACTIONS(4062),
    [anon_sym_join] = ACTIONS(4062),
    [anon_sym_on] = ACTIONS(4062),
    [anon_sym_equals] = ACTIONS(4062),
    [anon_sym_let] = ACTIONS(4062),
    [anon_sym_orderby] = ACTIONS(4062),
    [anon_sym_group] = ACTIONS(4062),
    [anon_sym_by] = ACTIONS(4062),
    [anon_sym_select] = ACTIONS(4062),
    [anon_sym_as] = ACTIONS(4062),
    [anon_sym_is] = ACTIONS(4062),
    [anon_sym_DASH_GT] = ACTIONS(4062),
    [anon_sym_with] = ACTIONS(4062),
    [aux_sym_preproc_if_token3] = ACTIONS(4062),
    [aux_sym_preproc_else_token1] = ACTIONS(4062),
    [aux_sym_preproc_elif_token1] = ACTIONS(4062),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3603] = {
    [sym_preproc_region] = STATE(3603),
    [sym_preproc_endregion] = STATE(3603),
    [sym_preproc_line] = STATE(3603),
    [sym_preproc_pragma] = STATE(3603),
    [sym_preproc_nullable] = STATE(3603),
    [sym_preproc_error] = STATE(3603),
    [sym_preproc_define] = STATE(3603),
    [sym_preproc_undef] = STATE(3603),
    [anon_sym_SEMI] = ACTIONS(4389),
    [anon_sym_LBRACK] = ACTIONS(4389),
    [anon_sym_COLON] = ACTIONS(4389),
    [anon_sym_COMMA] = ACTIONS(4389),
    [anon_sym_RBRACK] = ACTIONS(4389),
    [anon_sym_LPAREN] = ACTIONS(4389),
    [anon_sym_RPAREN] = ACTIONS(4389),
    [anon_sym_LBRACE] = ACTIONS(4389),
    [anon_sym_RBRACE] = ACTIONS(4389),
    [anon_sym_LT] = ACTIONS(4387),
    [anon_sym_GT] = ACTIONS(4387),
    [anon_sym_in] = ACTIONS(4387),
    [anon_sym_where] = ACTIONS(4389),
    [anon_sym_QMARK] = ACTIONS(4387),
    [anon_sym_BANG] = ACTIONS(4387),
    [anon_sym_PLUS_PLUS] = ACTIONS(4389),
    [anon_sym_DASH_DASH] = ACTIONS(4389),
    [anon_sym_PLUS] = ACTIONS(4387),
    [anon_sym_DASH] = ACTIONS(4387),
    [anon_sym_STAR] = ACTIONS(4389),
    [anon_sym_SLASH] = ACTIONS(4387),
    [anon_sym_PERCENT] = ACTIONS(4389),
    [anon_sym_CARET] = ACTIONS(4389),
    [anon_sym_PIPE] = ACTIONS(4387),
    [anon_sym_AMP] = ACTIONS(4387),
    [anon_sym_LT_LT] = ACTIONS(4389),
    [anon_sym_GT_GT] = ACTIONS(4387),
    [anon_sym_GT_GT_GT] = ACTIONS(4389),
    [anon_sym_EQ_EQ] = ACTIONS(4389),
    [anon_sym_BANG_EQ] = ACTIONS(4389),
    [anon_sym_GT_EQ] = ACTIONS(4389),
    [anon_sym_LT_EQ] = ACTIONS(4389),
    [anon_sym_DOT] = ACTIONS(4387),
    [anon_sym_EQ_GT] = ACTIONS(4389),
    [anon_sym_switch] = ACTIONS(4389),
    [anon_sym_DOT_DOT] = ACTIONS(4389),
    [anon_sym_and] = ACTIONS(4389),
    [anon_sym_or] = ACTIONS(4387),
    [anon_sym_AMP_AMP] = ACTIONS(4389),
    [anon_sym_PIPE_PIPE] = ACTIONS(4389),
    [anon_sym_QMARK_QMARK] = ACTIONS(4389),
    [anon_sym_from] = ACTIONS(4389),
    [anon_sym_into] = ACTIONS(4389),
    [anon_sym_join] = ACTIONS(4389),
    [anon_sym_on] = ACTIONS(4389),
    [anon_sym_equals] = ACTIONS(4389),
    [anon_sym_let] = ACTIONS(4389),
    [anon_sym_orderby] = ACTIONS(4389),
    [anon_sym_group] = ACTIONS(4389),
    [anon_sym_by] = ACTIONS(4389),
    [anon_sym_select] = ACTIONS(4389),
    [anon_sym_as] = ACTIONS(4389),
    [anon_sym_is] = ACTIONS(4389),
    [anon_sym_DASH_GT] = ACTIONS(4389),
    [anon_sym_with] = ACTIONS(4389),
    [aux_sym_preproc_if_token3] = ACTIONS(4389),
    [aux_sym_preproc_else_token1] = ACTIONS(4389),
    [aux_sym_preproc_elif_token1] = ACTIONS(4389),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3604] = {
    [sym_preproc_region] = STATE(3604),
    [sym_preproc_endregion] = STATE(3604),
    [sym_preproc_line] = STATE(3604),
    [sym_preproc_pragma] = STATE(3604),
    [sym_preproc_nullable] = STATE(3604),
    [sym_preproc_error] = STATE(3604),
    [sym_preproc_define] = STATE(3604),
    [sym_preproc_undef] = STATE(3604),
    [anon_sym_SEMI] = ACTIONS(4072),
    [anon_sym_LBRACK] = ACTIONS(4072),
    [anon_sym_COLON] = ACTIONS(4072),
    [anon_sym_COMMA] = ACTIONS(4072),
    [anon_sym_RBRACK] = ACTIONS(4072),
    [anon_sym_LPAREN] = ACTIONS(4072),
    [anon_sym_RPAREN] = ACTIONS(4072),
    [anon_sym_LBRACE] = ACTIONS(4072),
    [anon_sym_RBRACE] = ACTIONS(4072),
    [anon_sym_LT] = ACTIONS(4070),
    [anon_sym_GT] = ACTIONS(4070),
    [anon_sym_in] = ACTIONS(4070),
    [anon_sym_where] = ACTIONS(4072),
    [anon_sym_QMARK] = ACTIONS(4070),
    [anon_sym_BANG] = ACTIONS(4070),
    [anon_sym_PLUS_PLUS] = ACTIONS(4072),
    [anon_sym_DASH_DASH] = ACTIONS(4072),
    [anon_sym_PLUS] = ACTIONS(4070),
    [anon_sym_DASH] = ACTIONS(4070),
    [anon_sym_STAR] = ACTIONS(4072),
    [anon_sym_SLASH] = ACTIONS(4070),
    [anon_sym_PERCENT] = ACTIONS(4072),
    [anon_sym_CARET] = ACTIONS(4072),
    [anon_sym_PIPE] = ACTIONS(4070),
    [anon_sym_AMP] = ACTIONS(4070),
    [anon_sym_LT_LT] = ACTIONS(4072),
    [anon_sym_GT_GT] = ACTIONS(4070),
    [anon_sym_GT_GT_GT] = ACTIONS(4072),
    [anon_sym_EQ_EQ] = ACTIONS(4072),
    [anon_sym_BANG_EQ] = ACTIONS(4072),
    [anon_sym_GT_EQ] = ACTIONS(4072),
    [anon_sym_LT_EQ] = ACTIONS(4072),
    [anon_sym_DOT] = ACTIONS(4070),
    [anon_sym_EQ_GT] = ACTIONS(4072),
    [anon_sym_switch] = ACTIONS(4072),
    [anon_sym_DOT_DOT] = ACTIONS(4072),
    [anon_sym_and] = ACTIONS(4072),
    [anon_sym_or] = ACTIONS(4070),
    [anon_sym_AMP_AMP] = ACTIONS(4072),
    [anon_sym_PIPE_PIPE] = ACTIONS(4072),
    [anon_sym_QMARK_QMARK] = ACTIONS(4072),
    [anon_sym_from] = ACTIONS(4072),
    [anon_sym_into] = ACTIONS(4072),
    [anon_sym_join] = ACTIONS(4072),
    [anon_sym_on] = ACTIONS(4072),
    [anon_sym_equals] = ACTIONS(4072),
    [anon_sym_let] = ACTIONS(4072),
    [anon_sym_orderby] = ACTIONS(4072),
    [anon_sym_group] = ACTIONS(4072),
    [anon_sym_by] = ACTIONS(4072),
    [anon_sym_select] = ACTIONS(4072),
    [anon_sym_as] = ACTIONS(4072),
    [anon_sym_is] = ACTIONS(4072),
    [anon_sym_DASH_GT] = ACTIONS(4072),
    [anon_sym_with] = ACTIONS(4072),
    [aux_sym_preproc_if_token3] = ACTIONS(4072),
    [aux_sym_preproc_else_token1] = ACTIONS(4072),
    [aux_sym_preproc_elif_token1] = ACTIONS(4072),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3605] = {
    [sym_preproc_region] = STATE(3605),
    [sym_preproc_endregion] = STATE(3605),
    [sym_preproc_line] = STATE(3605),
    [sym_preproc_pragma] = STATE(3605),
    [sym_preproc_nullable] = STATE(3605),
    [sym_preproc_error] = STATE(3605),
    [sym_preproc_define] = STATE(3605),
    [sym_preproc_undef] = STATE(3605),
    [anon_sym_SEMI] = ACTIONS(4068),
    [anon_sym_LBRACK] = ACTIONS(4068),
    [anon_sym_COLON] = ACTIONS(4068),
    [anon_sym_COMMA] = ACTIONS(4068),
    [anon_sym_RBRACK] = ACTIONS(4068),
    [anon_sym_LPAREN] = ACTIONS(4068),
    [anon_sym_RPAREN] = ACTIONS(4068),
    [anon_sym_LBRACE] = ACTIONS(4068),
    [anon_sym_RBRACE] = ACTIONS(4068),
    [anon_sym_LT] = ACTIONS(4066),
    [anon_sym_GT] = ACTIONS(4066),
    [anon_sym_in] = ACTIONS(4066),
    [anon_sym_where] = ACTIONS(4068),
    [anon_sym_QMARK] = ACTIONS(4066),
    [anon_sym_BANG] = ACTIONS(4066),
    [anon_sym_PLUS_PLUS] = ACTIONS(4068),
    [anon_sym_DASH_DASH] = ACTIONS(4068),
    [anon_sym_PLUS] = ACTIONS(4066),
    [anon_sym_DASH] = ACTIONS(4066),
    [anon_sym_STAR] = ACTIONS(4068),
    [anon_sym_SLASH] = ACTIONS(4066),
    [anon_sym_PERCENT] = ACTIONS(4068),
    [anon_sym_CARET] = ACTIONS(4068),
    [anon_sym_PIPE] = ACTIONS(4066),
    [anon_sym_AMP] = ACTIONS(4066),
    [anon_sym_LT_LT] = ACTIONS(4068),
    [anon_sym_GT_GT] = ACTIONS(4066),
    [anon_sym_GT_GT_GT] = ACTIONS(4068),
    [anon_sym_EQ_EQ] = ACTIONS(4068),
    [anon_sym_BANG_EQ] = ACTIONS(4068),
    [anon_sym_GT_EQ] = ACTIONS(4068),
    [anon_sym_LT_EQ] = ACTIONS(4068),
    [anon_sym_DOT] = ACTIONS(4066),
    [anon_sym_EQ_GT] = ACTIONS(4068),
    [anon_sym_switch] = ACTIONS(4068),
    [anon_sym_DOT_DOT] = ACTIONS(4068),
    [anon_sym_and] = ACTIONS(4068),
    [anon_sym_or] = ACTIONS(4066),
    [anon_sym_AMP_AMP] = ACTIONS(4068),
    [anon_sym_PIPE_PIPE] = ACTIONS(4068),
    [anon_sym_QMARK_QMARK] = ACTIONS(4068),
    [anon_sym_from] = ACTIONS(4068),
    [anon_sym_into] = ACTIONS(4068),
    [anon_sym_join] = ACTIONS(4068),
    [anon_sym_on] = ACTIONS(4068),
    [anon_sym_equals] = ACTIONS(4068),
    [anon_sym_let] = ACTIONS(4068),
    [anon_sym_orderby] = ACTIONS(4068),
    [anon_sym_group] = ACTIONS(4068),
    [anon_sym_by] = ACTIONS(4068),
    [anon_sym_select] = ACTIONS(4068),
    [anon_sym_as] = ACTIONS(4068),
    [anon_sym_is] = ACTIONS(4068),
    [anon_sym_DASH_GT] = ACTIONS(4068),
    [anon_sym_with] = ACTIONS(4068),
    [aux_sym_preproc_if_token3] = ACTIONS(4068),
    [aux_sym_preproc_else_token1] = ACTIONS(4068),
    [aux_sym_preproc_elif_token1] = ACTIONS(4068),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3606] = {
    [sym_initializer_expression] = STATE(3764),
    [sym_preproc_region] = STATE(3606),
    [sym_preproc_endregion] = STATE(3606),
    [sym_preproc_line] = STATE(3606),
    [sym_preproc_pragma] = STATE(3606),
    [sym_preproc_nullable] = STATE(3606),
    [sym_preproc_error] = STATE(3606),
    [sym_preproc_define] = STATE(3606),
    [sym_preproc_undef] = STATE(3606),
    [anon_sym_SEMI] = ACTIONS(5226),
    [anon_sym_LBRACK] = ACTIONS(5228),
    [anon_sym_COLON] = ACTIONS(5226),
    [anon_sym_COMMA] = ACTIONS(5226),
    [anon_sym_RBRACK] = ACTIONS(5226),
    [anon_sym_LPAREN] = ACTIONS(5226),
    [anon_sym_RPAREN] = ACTIONS(5226),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_RBRACE] = ACTIONS(5226),
    [anon_sym_LT] = ACTIONS(5231),
    [anon_sym_GT] = ACTIONS(5231),
    [anon_sym_in] = ACTIONS(5226),
    [anon_sym_where] = ACTIONS(5226),
    [anon_sym_QMARK] = ACTIONS(5231),
    [anon_sym_BANG] = ACTIONS(5231),
    [anon_sym_PLUS_PLUS] = ACTIONS(5226),
    [anon_sym_DASH_DASH] = ACTIONS(5226),
    [anon_sym_PLUS] = ACTIONS(5231),
    [anon_sym_DASH] = ACTIONS(5231),
    [anon_sym_STAR] = ACTIONS(5226),
    [anon_sym_SLASH] = ACTIONS(5231),
    [anon_sym_PERCENT] = ACTIONS(5226),
    [anon_sym_CARET] = ACTIONS(5226),
    [anon_sym_PIPE] = ACTIONS(5231),
    [anon_sym_AMP] = ACTIONS(5231),
    [anon_sym_LT_LT] = ACTIONS(5226),
    [anon_sym_GT_GT] = ACTIONS(5231),
    [anon_sym_GT_GT_GT] = ACTIONS(5226),
    [anon_sym_EQ_EQ] = ACTIONS(5226),
    [anon_sym_BANG_EQ] = ACTIONS(5226),
    [anon_sym_GT_EQ] = ACTIONS(5226),
    [anon_sym_LT_EQ] = ACTIONS(5226),
    [anon_sym_DOT] = ACTIONS(5231),
    [anon_sym_EQ_GT] = ACTIONS(5226),
    [anon_sym_switch] = ACTIONS(5226),
    [anon_sym_DOT_DOT] = ACTIONS(5226),
    [anon_sym_and] = ACTIONS(5226),
    [anon_sym_or] = ACTIONS(5231),
    [anon_sym_AMP_AMP] = ACTIONS(5226),
    [anon_sym_PIPE_PIPE] = ACTIONS(5226),
    [anon_sym_QMARK_QMARK] = ACTIONS(5226),
    [anon_sym_from] = ACTIONS(5226),
    [anon_sym_join] = ACTIONS(5226),
    [anon_sym_on] = ACTIONS(5226),
    [anon_sym_equals] = ACTIONS(5226),
    [anon_sym_let] = ACTIONS(5226),
    [anon_sym_orderby] = ACTIONS(5226),
    [anon_sym_group] = ACTIONS(5226),
    [anon_sym_by] = ACTIONS(5226),
    [anon_sym_select] = ACTIONS(5226),
    [anon_sym_as] = ACTIONS(5226),
    [anon_sym_is] = ACTIONS(5226),
    [anon_sym_DASH_GT] = ACTIONS(5226),
    [anon_sym_with] = ACTIONS(5226),
    [aux_sym_preproc_if_token3] = ACTIONS(5226),
    [aux_sym_preproc_else_token1] = ACTIONS(5226),
    [aux_sym_preproc_elif_token1] = ACTIONS(5226),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3607] = {
    [sym_preproc_region] = STATE(3607),
    [sym_preproc_endregion] = STATE(3607),
    [sym_preproc_line] = STATE(3607),
    [sym_preproc_pragma] = STATE(3607),
    [sym_preproc_nullable] = STATE(3607),
    [sym_preproc_error] = STATE(3607),
    [sym_preproc_define] = STATE(3607),
    [sym_preproc_undef] = STATE(3607),
    [anon_sym_EQ] = ACTIONS(5315),
    [anon_sym_LBRACK] = ACTIONS(5249),
    [anon_sym_COMMA] = ACTIONS(5249),
    [anon_sym_LPAREN] = ACTIONS(5249),
    [anon_sym_LT] = ACTIONS(5251),
    [anon_sym_GT] = ACTIONS(5251),
    [anon_sym_where] = ACTIONS(5249),
    [anon_sym_QMARK] = ACTIONS(5251),
    [anon_sym_BANG] = ACTIONS(5251),
    [anon_sym_PLUS_PLUS] = ACTIONS(5249),
    [anon_sym_DASH_DASH] = ACTIONS(5249),
    [anon_sym_PLUS] = ACTIONS(5251),
    [anon_sym_DASH] = ACTIONS(5251),
    [anon_sym_STAR] = ACTIONS(5251),
    [anon_sym_SLASH] = ACTIONS(5251),
    [anon_sym_PERCENT] = ACTIONS(5251),
    [anon_sym_CARET] = ACTIONS(5251),
    [anon_sym_PIPE] = ACTIONS(5251),
    [anon_sym_AMP] = ACTIONS(5251),
    [anon_sym_LT_LT] = ACTIONS(5251),
    [anon_sym_GT_GT] = ACTIONS(5251),
    [anon_sym_GT_GT_GT] = ACTIONS(5251),
    [anon_sym_EQ_EQ] = ACTIONS(5249),
    [anon_sym_BANG_EQ] = ACTIONS(5249),
    [anon_sym_GT_EQ] = ACTIONS(5249),
    [anon_sym_LT_EQ] = ACTIONS(5249),
    [anon_sym_DOT] = ACTIONS(5251),
    [anon_sym_switch] = ACTIONS(5249),
    [anon_sym_DOT_DOT] = ACTIONS(5249),
    [anon_sym_and] = ACTIONS(5249),
    [anon_sym_or] = ACTIONS(5251),
    [anon_sym_PLUS_EQ] = ACTIONS(5317),
    [anon_sym_DASH_EQ] = ACTIONS(5317),
    [anon_sym_STAR_EQ] = ACTIONS(5317),
    [anon_sym_SLASH_EQ] = ACTIONS(5317),
    [anon_sym_PERCENT_EQ] = ACTIONS(5317),
    [anon_sym_AMP_EQ] = ACTIONS(5317),
    [anon_sym_CARET_EQ] = ACTIONS(5317),
    [anon_sym_PIPE_EQ] = ACTIONS(5317),
    [anon_sym_LT_LT_EQ] = ACTIONS(5317),
    [anon_sym_GT_GT_EQ] = ACTIONS(5317),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5317),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(5317),
    [anon_sym_AMP_AMP] = ACTIONS(5249),
    [anon_sym_PIPE_PIPE] = ACTIONS(5249),
    [anon_sym_QMARK_QMARK] = ACTIONS(5251),
    [anon_sym_from] = ACTIONS(5249),
    [anon_sym_join] = ACTIONS(5249),
    [anon_sym_let] = ACTIONS(5249),
    [anon_sym_orderby] = ACTIONS(5249),
    [anon_sym_ascending] = ACTIONS(5249),
    [anon_sym_descending] = ACTIONS(5249),
    [anon_sym_group] = ACTIONS(5249),
    [anon_sym_select] = ACTIONS(5249),
    [anon_sym_as] = ACTIONS(5251),
    [anon_sym_is] = ACTIONS(5249),
    [anon_sym_DASH_GT] = ACTIONS(5249),
    [anon_sym_with] = ACTIONS(5249),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3608] = {
    [sym_preproc_region] = STATE(3608),
    [sym_preproc_endregion] = STATE(3608),
    [sym_preproc_line] = STATE(3608),
    [sym_preproc_pragma] = STATE(3608),
    [sym_preproc_nullable] = STATE(3608),
    [sym_preproc_error] = STATE(3608),
    [sym_preproc_define] = STATE(3608),
    [sym_preproc_undef] = STATE(3608),
    [anon_sym_SEMI] = ACTIONS(4076),
    [anon_sym_LBRACK] = ACTIONS(4076),
    [anon_sym_COLON] = ACTIONS(4076),
    [anon_sym_COMMA] = ACTIONS(4076),
    [anon_sym_RBRACK] = ACTIONS(4076),
    [anon_sym_LPAREN] = ACTIONS(4076),
    [anon_sym_RPAREN] = ACTIONS(4076),
    [anon_sym_LBRACE] = ACTIONS(4076),
    [anon_sym_RBRACE] = ACTIONS(4076),
    [anon_sym_LT] = ACTIONS(4074),
    [anon_sym_GT] = ACTIONS(4074),
    [anon_sym_in] = ACTIONS(4074),
    [anon_sym_where] = ACTIONS(4076),
    [anon_sym_QMARK] = ACTIONS(4074),
    [anon_sym_BANG] = ACTIONS(4074),
    [anon_sym_PLUS_PLUS] = ACTIONS(4076),
    [anon_sym_DASH_DASH] = ACTIONS(4076),
    [anon_sym_PLUS] = ACTIONS(4074),
    [anon_sym_DASH] = ACTIONS(4074),
    [anon_sym_STAR] = ACTIONS(4076),
    [anon_sym_SLASH] = ACTIONS(4074),
    [anon_sym_PERCENT] = ACTIONS(4076),
    [anon_sym_CARET] = ACTIONS(4076),
    [anon_sym_PIPE] = ACTIONS(4074),
    [anon_sym_AMP] = ACTIONS(4074),
    [anon_sym_LT_LT] = ACTIONS(4076),
    [anon_sym_GT_GT] = ACTIONS(4074),
    [anon_sym_GT_GT_GT] = ACTIONS(4076),
    [anon_sym_EQ_EQ] = ACTIONS(4076),
    [anon_sym_BANG_EQ] = ACTIONS(4076),
    [anon_sym_GT_EQ] = ACTIONS(4076),
    [anon_sym_LT_EQ] = ACTIONS(4076),
    [anon_sym_DOT] = ACTIONS(4074),
    [anon_sym_EQ_GT] = ACTIONS(4076),
    [anon_sym_switch] = ACTIONS(4076),
    [anon_sym_DOT_DOT] = ACTIONS(4076),
    [anon_sym_and] = ACTIONS(4076),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_AMP_AMP] = ACTIONS(4076),
    [anon_sym_PIPE_PIPE] = ACTIONS(4076),
    [anon_sym_QMARK_QMARK] = ACTIONS(4076),
    [anon_sym_from] = ACTIONS(4076),
    [anon_sym_into] = ACTIONS(4076),
    [anon_sym_join] = ACTIONS(4076),
    [anon_sym_on] = ACTIONS(4076),
    [anon_sym_equals] = ACTIONS(4076),
    [anon_sym_let] = ACTIONS(4076),
    [anon_sym_orderby] = ACTIONS(4076),
    [anon_sym_group] = ACTIONS(4076),
    [anon_sym_by] = ACTIONS(4076),
    [anon_sym_select] = ACTIONS(4076),
    [anon_sym_as] = ACTIONS(4076),
    [anon_sym_is] = ACTIONS(4076),
    [anon_sym_DASH_GT] = ACTIONS(4076),
    [anon_sym_with] = ACTIONS(4076),
    [aux_sym_preproc_if_token3] = ACTIONS(4076),
    [aux_sym_preproc_else_token1] = ACTIONS(4076),
    [aux_sym_preproc_elif_token1] = ACTIONS(4076),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3609] = {
    [sym_preproc_region] = STATE(3609),
    [sym_preproc_endregion] = STATE(3609),
    [sym_preproc_line] = STATE(3609),
    [sym_preproc_pragma] = STATE(3609),
    [sym_preproc_nullable] = STATE(3609),
    [sym_preproc_error] = STATE(3609),
    [sym_preproc_define] = STATE(3609),
    [sym_preproc_undef] = STATE(3609),
    [anon_sym_SEMI] = ACTIONS(5319),
    [anon_sym_LBRACK] = ACTIONS(5319),
    [anon_sym_COLON] = ACTIONS(5319),
    [anon_sym_COMMA] = ACTIONS(5319),
    [anon_sym_RBRACK] = ACTIONS(5319),
    [anon_sym_LPAREN] = ACTIONS(5319),
    [anon_sym_RPAREN] = ACTIONS(5319),
    [anon_sym_RBRACE] = ACTIONS(5319),
    [anon_sym_LT] = ACTIONS(5321),
    [anon_sym_GT] = ACTIONS(5321),
    [anon_sym_in] = ACTIONS(5321),
    [anon_sym_where] = ACTIONS(5319),
    [anon_sym_QMARK] = ACTIONS(5321),
    [anon_sym_BANG] = ACTIONS(5321),
    [anon_sym_PLUS_PLUS] = ACTIONS(5319),
    [anon_sym_DASH_DASH] = ACTIONS(5319),
    [anon_sym_PLUS] = ACTIONS(5321),
    [anon_sym_DASH] = ACTIONS(5321),
    [anon_sym_STAR] = ACTIONS(5319),
    [anon_sym_SLASH] = ACTIONS(5321),
    [anon_sym_PERCENT] = ACTIONS(5319),
    [anon_sym_CARET] = ACTIONS(5319),
    [anon_sym_PIPE] = ACTIONS(5321),
    [anon_sym_AMP] = ACTIONS(5321),
    [anon_sym_LT_LT] = ACTIONS(5319),
    [anon_sym_GT_GT] = ACTIONS(5321),
    [anon_sym_GT_GT_GT] = ACTIONS(5319),
    [anon_sym_EQ_EQ] = ACTIONS(5319),
    [anon_sym_BANG_EQ] = ACTIONS(5319),
    [anon_sym_GT_EQ] = ACTIONS(5319),
    [anon_sym_LT_EQ] = ACTIONS(5319),
    [anon_sym_DOT] = ACTIONS(5321),
    [anon_sym_EQ_GT] = ACTIONS(5319),
    [anon_sym_switch] = ACTIONS(5319),
    [anon_sym_DOT_DOT] = ACTIONS(5319),
    [anon_sym_and] = ACTIONS(5319),
    [anon_sym_or] = ACTIONS(5321),
    [anon_sym_AMP_AMP] = ACTIONS(5319),
    [anon_sym_PIPE_PIPE] = ACTIONS(5319),
    [anon_sym_QMARK_QMARK] = ACTIONS(5319),
    [anon_sym_from] = ACTIONS(5319),
    [anon_sym_into] = ACTIONS(5319),
    [anon_sym_join] = ACTIONS(5319),
    [anon_sym_on] = ACTIONS(5319),
    [anon_sym_equals] = ACTIONS(5319),
    [anon_sym_let] = ACTIONS(5319),
    [anon_sym_orderby] = ACTIONS(5319),
    [anon_sym_group] = ACTIONS(5319),
    [anon_sym_by] = ACTIONS(5319),
    [anon_sym_select] = ACTIONS(5319),
    [anon_sym_as] = ACTIONS(5319),
    [anon_sym_is] = ACTIONS(5319),
    [anon_sym_DASH_GT] = ACTIONS(5319),
    [anon_sym_with] = ACTIONS(5319),
    [sym_string_literal_encoding] = ACTIONS(5323),
    [aux_sym_preproc_if_token3] = ACTIONS(5319),
    [aux_sym_preproc_else_token1] = ACTIONS(5319),
    [aux_sym_preproc_elif_token1] = ACTIONS(5319),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3610] = {
    [sym_preproc_region] = STATE(3610),
    [sym_preproc_endregion] = STATE(3610),
    [sym_preproc_line] = STATE(3610),
    [sym_preproc_pragma] = STATE(3610),
    [sym_preproc_nullable] = STATE(3610),
    [sym_preproc_error] = STATE(3610),
    [sym_preproc_define] = STATE(3610),
    [sym_preproc_undef] = STATE(3610),
    [anon_sym_SEMI] = ACTIONS(4570),
    [anon_sym_LBRACK] = ACTIONS(4570),
    [anon_sym_COLON] = ACTIONS(4570),
    [anon_sym_COMMA] = ACTIONS(4570),
    [anon_sym_RBRACK] = ACTIONS(4570),
    [anon_sym_LPAREN] = ACTIONS(4570),
    [anon_sym_RPAREN] = ACTIONS(4570),
    [anon_sym_LBRACE] = ACTIONS(4570),
    [anon_sym_RBRACE] = ACTIONS(4570),
    [anon_sym_LT] = ACTIONS(4568),
    [anon_sym_GT] = ACTIONS(4568),
    [anon_sym_in] = ACTIONS(4568),
    [anon_sym_where] = ACTIONS(4570),
    [anon_sym_QMARK] = ACTIONS(4568),
    [anon_sym_BANG] = ACTIONS(4568),
    [anon_sym_PLUS_PLUS] = ACTIONS(4570),
    [anon_sym_DASH_DASH] = ACTIONS(4570),
    [anon_sym_PLUS] = ACTIONS(4568),
    [anon_sym_DASH] = ACTIONS(4568),
    [anon_sym_STAR] = ACTIONS(4570),
    [anon_sym_SLASH] = ACTIONS(4568),
    [anon_sym_PERCENT] = ACTIONS(4570),
    [anon_sym_CARET] = ACTIONS(4570),
    [anon_sym_PIPE] = ACTIONS(4568),
    [anon_sym_AMP] = ACTIONS(4568),
    [anon_sym_LT_LT] = ACTIONS(4570),
    [anon_sym_GT_GT] = ACTIONS(4568),
    [anon_sym_GT_GT_GT] = ACTIONS(4570),
    [anon_sym_EQ_EQ] = ACTIONS(4570),
    [anon_sym_BANG_EQ] = ACTIONS(4570),
    [anon_sym_GT_EQ] = ACTIONS(4570),
    [anon_sym_LT_EQ] = ACTIONS(4570),
    [anon_sym_DOT] = ACTIONS(4568),
    [anon_sym_EQ_GT] = ACTIONS(4570),
    [anon_sym_switch] = ACTIONS(4570),
    [anon_sym_DOT_DOT] = ACTIONS(4570),
    [anon_sym_and] = ACTIONS(4570),
    [anon_sym_or] = ACTIONS(4568),
    [anon_sym_AMP_AMP] = ACTIONS(4570),
    [anon_sym_PIPE_PIPE] = ACTIONS(4570),
    [anon_sym_QMARK_QMARK] = ACTIONS(4570),
    [anon_sym_from] = ACTIONS(4570),
    [anon_sym_into] = ACTIONS(4570),
    [anon_sym_join] = ACTIONS(4570),
    [anon_sym_on] = ACTIONS(4570),
    [anon_sym_equals] = ACTIONS(4570),
    [anon_sym_let] = ACTIONS(4570),
    [anon_sym_orderby] = ACTIONS(4570),
    [anon_sym_group] = ACTIONS(4570),
    [anon_sym_by] = ACTIONS(4570),
    [anon_sym_select] = ACTIONS(4570),
    [anon_sym_as] = ACTIONS(4570),
    [anon_sym_is] = ACTIONS(4570),
    [anon_sym_DASH_GT] = ACTIONS(4570),
    [anon_sym_with] = ACTIONS(4570),
    [aux_sym_preproc_if_token3] = ACTIONS(4570),
    [aux_sym_preproc_else_token1] = ACTIONS(4570),
    [aux_sym_preproc_elif_token1] = ACTIONS(4570),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3611] = {
    [sym_preproc_region] = STATE(3611),
    [sym_preproc_endregion] = STATE(3611),
    [sym_preproc_line] = STATE(3611),
    [sym_preproc_pragma] = STATE(3611),
    [sym_preproc_nullable] = STATE(3611),
    [sym_preproc_error] = STATE(3611),
    [sym_preproc_define] = STATE(3611),
    [sym_preproc_undef] = STATE(3611),
    [anon_sym_SEMI] = ACTIONS(4476),
    [anon_sym_LBRACK] = ACTIONS(4476),
    [anon_sym_COLON] = ACTIONS(4476),
    [anon_sym_COMMA] = ACTIONS(4476),
    [anon_sym_RBRACK] = ACTIONS(4476),
    [anon_sym_LPAREN] = ACTIONS(4476),
    [anon_sym_RPAREN] = ACTIONS(4476),
    [anon_sym_LBRACE] = ACTIONS(4476),
    [anon_sym_RBRACE] = ACTIONS(4476),
    [anon_sym_LT] = ACTIONS(4474),
    [anon_sym_GT] = ACTIONS(4474),
    [anon_sym_in] = ACTIONS(4474),
    [anon_sym_where] = ACTIONS(4476),
    [anon_sym_QMARK] = ACTIONS(4474),
    [anon_sym_BANG] = ACTIONS(4474),
    [anon_sym_PLUS_PLUS] = ACTIONS(4476),
    [anon_sym_DASH_DASH] = ACTIONS(4476),
    [anon_sym_PLUS] = ACTIONS(4474),
    [anon_sym_DASH] = ACTIONS(4474),
    [anon_sym_STAR] = ACTIONS(4476),
    [anon_sym_SLASH] = ACTIONS(4474),
    [anon_sym_PERCENT] = ACTIONS(4476),
    [anon_sym_CARET] = ACTIONS(4476),
    [anon_sym_PIPE] = ACTIONS(4474),
    [anon_sym_AMP] = ACTIONS(4474),
    [anon_sym_LT_LT] = ACTIONS(4476),
    [anon_sym_GT_GT] = ACTIONS(4474),
    [anon_sym_GT_GT_GT] = ACTIONS(4476),
    [anon_sym_EQ_EQ] = ACTIONS(4476),
    [anon_sym_BANG_EQ] = ACTIONS(4476),
    [anon_sym_GT_EQ] = ACTIONS(4476),
    [anon_sym_LT_EQ] = ACTIONS(4476),
    [anon_sym_DOT] = ACTIONS(4474),
    [anon_sym_EQ_GT] = ACTIONS(4476),
    [anon_sym_switch] = ACTIONS(4476),
    [anon_sym_DOT_DOT] = ACTIONS(4476),
    [anon_sym_and] = ACTIONS(4476),
    [anon_sym_or] = ACTIONS(4474),
    [anon_sym_AMP_AMP] = ACTIONS(4476),
    [anon_sym_PIPE_PIPE] = ACTIONS(4476),
    [anon_sym_QMARK_QMARK] = ACTIONS(4476),
    [anon_sym_from] = ACTIONS(4476),
    [anon_sym_into] = ACTIONS(4476),
    [anon_sym_join] = ACTIONS(4476),
    [anon_sym_on] = ACTIONS(4476),
    [anon_sym_equals] = ACTIONS(4476),
    [anon_sym_let] = ACTIONS(4476),
    [anon_sym_orderby] = ACTIONS(4476),
    [anon_sym_group] = ACTIONS(4476),
    [anon_sym_by] = ACTIONS(4476),
    [anon_sym_select] = ACTIONS(4476),
    [anon_sym_as] = ACTIONS(4476),
    [anon_sym_is] = ACTIONS(4476),
    [anon_sym_DASH_GT] = ACTIONS(4476),
    [anon_sym_with] = ACTIONS(4476),
    [aux_sym_preproc_if_token3] = ACTIONS(4476),
    [aux_sym_preproc_else_token1] = ACTIONS(4476),
    [aux_sym_preproc_elif_token1] = ACTIONS(4476),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3612] = {
    [sym_preproc_region] = STATE(3612),
    [sym_preproc_endregion] = STATE(3612),
    [sym_preproc_line] = STATE(3612),
    [sym_preproc_pragma] = STATE(3612),
    [sym_preproc_nullable] = STATE(3612),
    [sym_preproc_error] = STATE(3612),
    [sym_preproc_define] = STATE(3612),
    [sym_preproc_undef] = STATE(3612),
    [anon_sym_SEMI] = ACTIONS(5325),
    [anon_sym_LBRACK] = ACTIONS(5325),
    [anon_sym_COLON] = ACTIONS(5325),
    [anon_sym_COMMA] = ACTIONS(5325),
    [anon_sym_RBRACK] = ACTIONS(5325),
    [anon_sym_LPAREN] = ACTIONS(5325),
    [anon_sym_RPAREN] = ACTIONS(5325),
    [anon_sym_RBRACE] = ACTIONS(5325),
    [anon_sym_LT] = ACTIONS(5327),
    [anon_sym_GT] = ACTIONS(5327),
    [anon_sym_in] = ACTIONS(5327),
    [anon_sym_where] = ACTIONS(5325),
    [anon_sym_QMARK] = ACTIONS(5327),
    [anon_sym_BANG] = ACTIONS(5327),
    [anon_sym_PLUS_PLUS] = ACTIONS(5325),
    [anon_sym_DASH_DASH] = ACTIONS(5325),
    [anon_sym_PLUS] = ACTIONS(5327),
    [anon_sym_DASH] = ACTIONS(5327),
    [anon_sym_STAR] = ACTIONS(5325),
    [anon_sym_SLASH] = ACTIONS(5327),
    [anon_sym_PERCENT] = ACTIONS(5325),
    [anon_sym_CARET] = ACTIONS(5325),
    [anon_sym_PIPE] = ACTIONS(5327),
    [anon_sym_AMP] = ACTIONS(5327),
    [anon_sym_LT_LT] = ACTIONS(5325),
    [anon_sym_GT_GT] = ACTIONS(5327),
    [anon_sym_GT_GT_GT] = ACTIONS(5325),
    [anon_sym_EQ_EQ] = ACTIONS(5325),
    [anon_sym_BANG_EQ] = ACTIONS(5325),
    [anon_sym_GT_EQ] = ACTIONS(5325),
    [anon_sym_LT_EQ] = ACTIONS(5325),
    [anon_sym_DOT] = ACTIONS(5327),
    [anon_sym_EQ_GT] = ACTIONS(5325),
    [anon_sym_switch] = ACTIONS(5325),
    [anon_sym_DOT_DOT] = ACTIONS(5325),
    [anon_sym_and] = ACTIONS(5325),
    [anon_sym_or] = ACTIONS(5327),
    [anon_sym_AMP_AMP] = ACTIONS(5325),
    [anon_sym_PIPE_PIPE] = ACTIONS(5325),
    [anon_sym_QMARK_QMARK] = ACTIONS(5325),
    [anon_sym_from] = ACTIONS(5325),
    [anon_sym_into] = ACTIONS(5325),
    [anon_sym_join] = ACTIONS(5325),
    [anon_sym_on] = ACTIONS(5325),
    [anon_sym_equals] = ACTIONS(5325),
    [anon_sym_let] = ACTIONS(5325),
    [anon_sym_orderby] = ACTIONS(5325),
    [anon_sym_group] = ACTIONS(5325),
    [anon_sym_by] = ACTIONS(5325),
    [anon_sym_select] = ACTIONS(5325),
    [anon_sym_as] = ACTIONS(5325),
    [anon_sym_is] = ACTIONS(5325),
    [anon_sym_DASH_GT] = ACTIONS(5325),
    [anon_sym_with] = ACTIONS(5325),
    [aux_sym_preproc_if_token3] = ACTIONS(5325),
    [aux_sym_preproc_else_token1] = ACTIONS(5325),
    [aux_sym_preproc_elif_token1] = ACTIONS(5325),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3613] = {
    [sym_preproc_region] = STATE(3613),
    [sym_preproc_endregion] = STATE(3613),
    [sym_preproc_line] = STATE(3613),
    [sym_preproc_pragma] = STATE(3613),
    [sym_preproc_nullable] = STATE(3613),
    [sym_preproc_error] = STATE(3613),
    [sym_preproc_define] = STATE(3613),
    [sym_preproc_undef] = STATE(3613),
    [anon_sym_SEMI] = ACTIONS(5329),
    [anon_sym_LBRACK] = ACTIONS(5329),
    [anon_sym_COLON] = ACTIONS(5329),
    [anon_sym_COMMA] = ACTIONS(5329),
    [anon_sym_RBRACK] = ACTIONS(5329),
    [anon_sym_LPAREN] = ACTIONS(5329),
    [anon_sym_RPAREN] = ACTIONS(5329),
    [anon_sym_RBRACE] = ACTIONS(5329),
    [anon_sym_LT] = ACTIONS(5331),
    [anon_sym_GT] = ACTIONS(5331),
    [anon_sym_in] = ACTIONS(5331),
    [anon_sym_where] = ACTIONS(5329),
    [anon_sym_QMARK] = ACTIONS(5331),
    [anon_sym_BANG] = ACTIONS(5331),
    [anon_sym_PLUS_PLUS] = ACTIONS(5329),
    [anon_sym_DASH_DASH] = ACTIONS(5329),
    [anon_sym_PLUS] = ACTIONS(5331),
    [anon_sym_DASH] = ACTIONS(5331),
    [anon_sym_STAR] = ACTIONS(5329),
    [anon_sym_SLASH] = ACTIONS(5331),
    [anon_sym_PERCENT] = ACTIONS(5329),
    [anon_sym_CARET] = ACTIONS(5329),
    [anon_sym_PIPE] = ACTIONS(5331),
    [anon_sym_AMP] = ACTIONS(5331),
    [anon_sym_LT_LT] = ACTIONS(5329),
    [anon_sym_GT_GT] = ACTIONS(5331),
    [anon_sym_GT_GT_GT] = ACTIONS(5329),
    [anon_sym_EQ_EQ] = ACTIONS(5329),
    [anon_sym_BANG_EQ] = ACTIONS(5329),
    [anon_sym_GT_EQ] = ACTIONS(5329),
    [anon_sym_LT_EQ] = ACTIONS(5329),
    [anon_sym_DOT] = ACTIONS(5331),
    [anon_sym_EQ_GT] = ACTIONS(5329),
    [anon_sym_switch] = ACTIONS(5329),
    [anon_sym_DOT_DOT] = ACTIONS(5329),
    [anon_sym_and] = ACTIONS(5329),
    [anon_sym_or] = ACTIONS(5331),
    [anon_sym_AMP_AMP] = ACTIONS(5329),
    [anon_sym_PIPE_PIPE] = ACTIONS(5329),
    [anon_sym_QMARK_QMARK] = ACTIONS(5329),
    [anon_sym_from] = ACTIONS(5329),
    [anon_sym_into] = ACTIONS(5329),
    [anon_sym_join] = ACTIONS(5329),
    [anon_sym_on] = ACTIONS(5329),
    [anon_sym_equals] = ACTIONS(5329),
    [anon_sym_let] = ACTIONS(5329),
    [anon_sym_orderby] = ACTIONS(5329),
    [anon_sym_group] = ACTIONS(5329),
    [anon_sym_by] = ACTIONS(5329),
    [anon_sym_select] = ACTIONS(5329),
    [anon_sym_as] = ACTIONS(5329),
    [anon_sym_is] = ACTIONS(5329),
    [anon_sym_DASH_GT] = ACTIONS(5329),
    [anon_sym_with] = ACTIONS(5329),
    [aux_sym_preproc_if_token3] = ACTIONS(5329),
    [aux_sym_preproc_else_token1] = ACTIONS(5329),
    [aux_sym_preproc_elif_token1] = ACTIONS(5329),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3614] = {
    [sym_preproc_region] = STATE(3614),
    [sym_preproc_endregion] = STATE(3614),
    [sym_preproc_line] = STATE(3614),
    [sym_preproc_pragma] = STATE(3614),
    [sym_preproc_nullable] = STATE(3614),
    [sym_preproc_error] = STATE(3614),
    [sym_preproc_define] = STATE(3614),
    [sym_preproc_undef] = STATE(3614),
    [anon_sym_SEMI] = ACTIONS(5333),
    [anon_sym_LBRACK] = ACTIONS(5333),
    [anon_sym_COLON] = ACTIONS(5333),
    [anon_sym_COMMA] = ACTIONS(5333),
    [anon_sym_RBRACK] = ACTIONS(5333),
    [anon_sym_LPAREN] = ACTIONS(5333),
    [anon_sym_RPAREN] = ACTIONS(5333),
    [anon_sym_RBRACE] = ACTIONS(5333),
    [anon_sym_LT] = ACTIONS(5335),
    [anon_sym_GT] = ACTIONS(5335),
    [anon_sym_in] = ACTIONS(5335),
    [anon_sym_where] = ACTIONS(5333),
    [anon_sym_QMARK] = ACTIONS(5335),
    [anon_sym_BANG] = ACTIONS(5335),
    [anon_sym_PLUS_PLUS] = ACTIONS(5333),
    [anon_sym_DASH_DASH] = ACTIONS(5333),
    [anon_sym_PLUS] = ACTIONS(5335),
    [anon_sym_DASH] = ACTIONS(5335),
    [anon_sym_STAR] = ACTIONS(5333),
    [anon_sym_SLASH] = ACTIONS(5335),
    [anon_sym_PERCENT] = ACTIONS(5333),
    [anon_sym_CARET] = ACTIONS(5333),
    [anon_sym_PIPE] = ACTIONS(5335),
    [anon_sym_AMP] = ACTIONS(5335),
    [anon_sym_LT_LT] = ACTIONS(5333),
    [anon_sym_GT_GT] = ACTIONS(5335),
    [anon_sym_GT_GT_GT] = ACTIONS(5333),
    [anon_sym_EQ_EQ] = ACTIONS(5333),
    [anon_sym_BANG_EQ] = ACTIONS(5333),
    [anon_sym_GT_EQ] = ACTIONS(5333),
    [anon_sym_LT_EQ] = ACTIONS(5333),
    [anon_sym_DOT] = ACTIONS(5335),
    [anon_sym_EQ_GT] = ACTIONS(5333),
    [anon_sym_switch] = ACTIONS(5333),
    [anon_sym_DOT_DOT] = ACTIONS(5333),
    [anon_sym_and] = ACTIONS(5333),
    [anon_sym_or] = ACTIONS(5335),
    [anon_sym_AMP_AMP] = ACTIONS(5333),
    [anon_sym_PIPE_PIPE] = ACTIONS(5333),
    [anon_sym_QMARK_QMARK] = ACTIONS(5333),
    [anon_sym_from] = ACTIONS(5333),
    [anon_sym_into] = ACTIONS(5333),
    [anon_sym_join] = ACTIONS(5333),
    [anon_sym_on] = ACTIONS(5333),
    [anon_sym_equals] = ACTIONS(5333),
    [anon_sym_let] = ACTIONS(5333),
    [anon_sym_orderby] = ACTIONS(5333),
    [anon_sym_group] = ACTIONS(5333),
    [anon_sym_by] = ACTIONS(5333),
    [anon_sym_select] = ACTIONS(5333),
    [anon_sym_as] = ACTIONS(5333),
    [anon_sym_is] = ACTIONS(5333),
    [anon_sym_DASH_GT] = ACTIONS(5333),
    [anon_sym_with] = ACTIONS(5333),
    [aux_sym_preproc_if_token3] = ACTIONS(5333),
    [aux_sym_preproc_else_token1] = ACTIONS(5333),
    [aux_sym_preproc_elif_token1] = ACTIONS(5333),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3615] = {
    [sym_preproc_region] = STATE(3615),
    [sym_preproc_endregion] = STATE(3615),
    [sym_preproc_line] = STATE(3615),
    [sym_preproc_pragma] = STATE(3615),
    [sym_preproc_nullable] = STATE(3615),
    [sym_preproc_error] = STATE(3615),
    [sym_preproc_define] = STATE(3615),
    [sym_preproc_undef] = STATE(3615),
    [anon_sym_SEMI] = ACTIONS(5337),
    [anon_sym_LBRACK] = ACTIONS(5337),
    [anon_sym_COLON] = ACTIONS(5337),
    [anon_sym_COMMA] = ACTIONS(5337),
    [anon_sym_RBRACK] = ACTIONS(5337),
    [anon_sym_LPAREN] = ACTIONS(5337),
    [anon_sym_RPAREN] = ACTIONS(5337),
    [anon_sym_RBRACE] = ACTIONS(5337),
    [anon_sym_LT] = ACTIONS(5339),
    [anon_sym_GT] = ACTIONS(5339),
    [anon_sym_in] = ACTIONS(5339),
    [anon_sym_where] = ACTIONS(5337),
    [anon_sym_QMARK] = ACTIONS(5339),
    [anon_sym_BANG] = ACTIONS(5339),
    [anon_sym_PLUS_PLUS] = ACTIONS(5337),
    [anon_sym_DASH_DASH] = ACTIONS(5337),
    [anon_sym_PLUS] = ACTIONS(5339),
    [anon_sym_DASH] = ACTIONS(5339),
    [anon_sym_STAR] = ACTIONS(5337),
    [anon_sym_SLASH] = ACTIONS(5339),
    [anon_sym_PERCENT] = ACTIONS(5337),
    [anon_sym_CARET] = ACTIONS(5337),
    [anon_sym_PIPE] = ACTIONS(5339),
    [anon_sym_AMP] = ACTIONS(5339),
    [anon_sym_LT_LT] = ACTIONS(5337),
    [anon_sym_GT_GT] = ACTIONS(5339),
    [anon_sym_GT_GT_GT] = ACTIONS(5337),
    [anon_sym_EQ_EQ] = ACTIONS(5337),
    [anon_sym_BANG_EQ] = ACTIONS(5337),
    [anon_sym_GT_EQ] = ACTIONS(5337),
    [anon_sym_LT_EQ] = ACTIONS(5337),
    [anon_sym_DOT] = ACTIONS(5339),
    [anon_sym_EQ_GT] = ACTIONS(5337),
    [anon_sym_switch] = ACTIONS(5337),
    [anon_sym_DOT_DOT] = ACTIONS(5337),
    [anon_sym_and] = ACTIONS(5337),
    [anon_sym_or] = ACTIONS(5339),
    [anon_sym_AMP_AMP] = ACTIONS(5337),
    [anon_sym_PIPE_PIPE] = ACTIONS(5337),
    [anon_sym_QMARK_QMARK] = ACTIONS(5337),
    [anon_sym_from] = ACTIONS(5337),
    [anon_sym_into] = ACTIONS(5337),
    [anon_sym_join] = ACTIONS(5337),
    [anon_sym_on] = ACTIONS(5337),
    [anon_sym_equals] = ACTIONS(5337),
    [anon_sym_let] = ACTIONS(5337),
    [anon_sym_orderby] = ACTIONS(5337),
    [anon_sym_group] = ACTIONS(5337),
    [anon_sym_by] = ACTIONS(5337),
    [anon_sym_select] = ACTIONS(5337),
    [anon_sym_as] = ACTIONS(5337),
    [anon_sym_is] = ACTIONS(5337),
    [anon_sym_DASH_GT] = ACTIONS(5337),
    [anon_sym_with] = ACTIONS(5337),
    [aux_sym_preproc_if_token3] = ACTIONS(5337),
    [aux_sym_preproc_else_token1] = ACTIONS(5337),
    [aux_sym_preproc_elif_token1] = ACTIONS(5337),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3616] = {
    [sym_preproc_region] = STATE(3616),
    [sym_preproc_endregion] = STATE(3616),
    [sym_preproc_line] = STATE(3616),
    [sym_preproc_pragma] = STATE(3616),
    [sym_preproc_nullable] = STATE(3616),
    [sym_preproc_error] = STATE(3616),
    [sym_preproc_define] = STATE(3616),
    [sym_preproc_undef] = STATE(3616),
    [anon_sym_SEMI] = ACTIONS(5341),
    [anon_sym_LBRACK] = ACTIONS(5341),
    [anon_sym_COLON] = ACTIONS(5341),
    [anon_sym_COMMA] = ACTIONS(5341),
    [anon_sym_RBRACK] = ACTIONS(5341),
    [anon_sym_LPAREN] = ACTIONS(5341),
    [anon_sym_RPAREN] = ACTIONS(5341),
    [anon_sym_RBRACE] = ACTIONS(5341),
    [anon_sym_LT] = ACTIONS(5343),
    [anon_sym_GT] = ACTIONS(5343),
    [anon_sym_in] = ACTIONS(5343),
    [anon_sym_where] = ACTIONS(5341),
    [anon_sym_QMARK] = ACTIONS(5343),
    [anon_sym_BANG] = ACTIONS(5343),
    [anon_sym_PLUS_PLUS] = ACTIONS(5341),
    [anon_sym_DASH_DASH] = ACTIONS(5341),
    [anon_sym_PLUS] = ACTIONS(5343),
    [anon_sym_DASH] = ACTIONS(5343),
    [anon_sym_STAR] = ACTIONS(5341),
    [anon_sym_SLASH] = ACTIONS(5343),
    [anon_sym_PERCENT] = ACTIONS(5341),
    [anon_sym_CARET] = ACTIONS(5341),
    [anon_sym_PIPE] = ACTIONS(5343),
    [anon_sym_AMP] = ACTIONS(5343),
    [anon_sym_LT_LT] = ACTIONS(5341),
    [anon_sym_GT_GT] = ACTIONS(5343),
    [anon_sym_GT_GT_GT] = ACTIONS(5341),
    [anon_sym_EQ_EQ] = ACTIONS(5341),
    [anon_sym_BANG_EQ] = ACTIONS(5341),
    [anon_sym_GT_EQ] = ACTIONS(5341),
    [anon_sym_LT_EQ] = ACTIONS(5341),
    [anon_sym_DOT] = ACTIONS(5343),
    [anon_sym_EQ_GT] = ACTIONS(5341),
    [anon_sym_switch] = ACTIONS(5341),
    [anon_sym_DOT_DOT] = ACTIONS(5341),
    [anon_sym_and] = ACTIONS(5341),
    [anon_sym_or] = ACTIONS(5343),
    [anon_sym_AMP_AMP] = ACTIONS(5341),
    [anon_sym_PIPE_PIPE] = ACTIONS(5341),
    [anon_sym_QMARK_QMARK] = ACTIONS(5341),
    [anon_sym_from] = ACTIONS(5341),
    [anon_sym_into] = ACTIONS(5341),
    [anon_sym_join] = ACTIONS(5341),
    [anon_sym_on] = ACTIONS(5341),
    [anon_sym_equals] = ACTIONS(5341),
    [anon_sym_let] = ACTIONS(5341),
    [anon_sym_orderby] = ACTIONS(5341),
    [anon_sym_group] = ACTIONS(5341),
    [anon_sym_by] = ACTIONS(5341),
    [anon_sym_select] = ACTIONS(5341),
    [anon_sym_as] = ACTIONS(5341),
    [anon_sym_is] = ACTIONS(5341),
    [anon_sym_DASH_GT] = ACTIONS(5341),
    [anon_sym_with] = ACTIONS(5341),
    [aux_sym_preproc_if_token3] = ACTIONS(5341),
    [aux_sym_preproc_else_token1] = ACTIONS(5341),
    [aux_sym_preproc_elif_token1] = ACTIONS(5341),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3617] = {
    [sym_preproc_region] = STATE(3617),
    [sym_preproc_endregion] = STATE(3617),
    [sym_preproc_line] = STATE(3617),
    [sym_preproc_pragma] = STATE(3617),
    [sym_preproc_nullable] = STATE(3617),
    [sym_preproc_error] = STATE(3617),
    [sym_preproc_define] = STATE(3617),
    [sym_preproc_undef] = STATE(3617),
    [anon_sym_SEMI] = ACTIONS(5345),
    [anon_sym_LBRACK] = ACTIONS(5345),
    [anon_sym_COLON] = ACTIONS(5345),
    [anon_sym_COMMA] = ACTIONS(5345),
    [anon_sym_RBRACK] = ACTIONS(5345),
    [anon_sym_LPAREN] = ACTIONS(5345),
    [anon_sym_RPAREN] = ACTIONS(5345),
    [anon_sym_RBRACE] = ACTIONS(5345),
    [anon_sym_LT] = ACTIONS(5347),
    [anon_sym_GT] = ACTIONS(5347),
    [anon_sym_in] = ACTIONS(5347),
    [anon_sym_where] = ACTIONS(5345),
    [anon_sym_QMARK] = ACTIONS(5347),
    [anon_sym_BANG] = ACTIONS(5347),
    [anon_sym_PLUS_PLUS] = ACTIONS(5345),
    [anon_sym_DASH_DASH] = ACTIONS(5345),
    [anon_sym_PLUS] = ACTIONS(5347),
    [anon_sym_DASH] = ACTIONS(5347),
    [anon_sym_STAR] = ACTIONS(5345),
    [anon_sym_SLASH] = ACTIONS(5347),
    [anon_sym_PERCENT] = ACTIONS(5345),
    [anon_sym_CARET] = ACTIONS(5345),
    [anon_sym_PIPE] = ACTIONS(5347),
    [anon_sym_AMP] = ACTIONS(5347),
    [anon_sym_LT_LT] = ACTIONS(5345),
    [anon_sym_GT_GT] = ACTIONS(5347),
    [anon_sym_GT_GT_GT] = ACTIONS(5345),
    [anon_sym_EQ_EQ] = ACTIONS(5345),
    [anon_sym_BANG_EQ] = ACTIONS(5345),
    [anon_sym_GT_EQ] = ACTIONS(5345),
    [anon_sym_LT_EQ] = ACTIONS(5345),
    [anon_sym_DOT] = ACTIONS(5347),
    [anon_sym_EQ_GT] = ACTIONS(5345),
    [anon_sym_switch] = ACTIONS(5345),
    [anon_sym_DOT_DOT] = ACTIONS(5345),
    [anon_sym_and] = ACTIONS(5345),
    [anon_sym_or] = ACTIONS(5347),
    [anon_sym_AMP_AMP] = ACTIONS(5345),
    [anon_sym_PIPE_PIPE] = ACTIONS(5345),
    [anon_sym_QMARK_QMARK] = ACTIONS(5345),
    [anon_sym_from] = ACTIONS(5345),
    [anon_sym_into] = ACTIONS(5345),
    [anon_sym_join] = ACTIONS(5345),
    [anon_sym_on] = ACTIONS(5345),
    [anon_sym_equals] = ACTIONS(5345),
    [anon_sym_let] = ACTIONS(5345),
    [anon_sym_orderby] = ACTIONS(5345),
    [anon_sym_group] = ACTIONS(5345),
    [anon_sym_by] = ACTIONS(5345),
    [anon_sym_select] = ACTIONS(5345),
    [anon_sym_as] = ACTIONS(5345),
    [anon_sym_is] = ACTIONS(5345),
    [anon_sym_DASH_GT] = ACTIONS(5345),
    [anon_sym_with] = ACTIONS(5345),
    [aux_sym_preproc_if_token3] = ACTIONS(5345),
    [aux_sym_preproc_else_token1] = ACTIONS(5345),
    [aux_sym_preproc_elif_token1] = ACTIONS(5345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3618] = {
    [sym_preproc_region] = STATE(3618),
    [sym_preproc_endregion] = STATE(3618),
    [sym_preproc_line] = STATE(3618),
    [sym_preproc_pragma] = STATE(3618),
    [sym_preproc_nullable] = STATE(3618),
    [sym_preproc_error] = STATE(3618),
    [sym_preproc_define] = STATE(3618),
    [sym_preproc_undef] = STATE(3618),
    [anon_sym_SEMI] = ACTIONS(4424),
    [anon_sym_LBRACK] = ACTIONS(4547),
    [anon_sym_COLON] = ACTIONS(4424),
    [anon_sym_COMMA] = ACTIONS(4424),
    [anon_sym_RBRACK] = ACTIONS(4424),
    [anon_sym_LPAREN] = ACTIONS(4424),
    [anon_sym_RPAREN] = ACTIONS(4424),
    [anon_sym_LBRACE] = ACTIONS(4424),
    [anon_sym_RBRACE] = ACTIONS(4424),
    [anon_sym_LT] = ACTIONS(4422),
    [anon_sym_GT] = ACTIONS(4422),
    [anon_sym_in] = ACTIONS(4424),
    [anon_sym_where] = ACTIONS(4424),
    [anon_sym_QMARK] = ACTIONS(4422),
    [anon_sym_BANG] = ACTIONS(4422),
    [anon_sym_PLUS_PLUS] = ACTIONS(4424),
    [anon_sym_DASH_DASH] = ACTIONS(4424),
    [anon_sym_PLUS] = ACTIONS(4422),
    [anon_sym_DASH] = ACTIONS(4422),
    [anon_sym_STAR] = ACTIONS(4553),
    [anon_sym_SLASH] = ACTIONS(4422),
    [anon_sym_PERCENT] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4424),
    [anon_sym_PIPE] = ACTIONS(4422),
    [anon_sym_AMP] = ACTIONS(4422),
    [anon_sym_LT_LT] = ACTIONS(4424),
    [anon_sym_GT_GT] = ACTIONS(4422),
    [anon_sym_GT_GT_GT] = ACTIONS(4424),
    [anon_sym_EQ_EQ] = ACTIONS(4424),
    [anon_sym_BANG_EQ] = ACTIONS(4424),
    [anon_sym_GT_EQ] = ACTIONS(4424),
    [anon_sym_LT_EQ] = ACTIONS(4424),
    [anon_sym_DOT] = ACTIONS(4422),
    [anon_sym_EQ_GT] = ACTIONS(4424),
    [anon_sym_switch] = ACTIONS(4424),
    [anon_sym_DOT_DOT] = ACTIONS(4424),
    [anon_sym_and] = ACTIONS(4424),
    [anon_sym_or] = ACTIONS(4422),
    [anon_sym_AMP_AMP] = ACTIONS(4424),
    [anon_sym_PIPE_PIPE] = ACTIONS(4424),
    [anon_sym_QMARK_QMARK] = ACTIONS(4424),
    [anon_sym_from] = ACTIONS(4424),
    [anon_sym_join] = ACTIONS(4424),
    [anon_sym_on] = ACTIONS(4424),
    [anon_sym_equals] = ACTIONS(4424),
    [anon_sym_let] = ACTIONS(4424),
    [anon_sym_orderby] = ACTIONS(4424),
    [anon_sym_group] = ACTIONS(4424),
    [anon_sym_by] = ACTIONS(4424),
    [anon_sym_select] = ACTIONS(4424),
    [anon_sym_as] = ACTIONS(4424),
    [anon_sym_is] = ACTIONS(4424),
    [anon_sym_DASH_GT] = ACTIONS(4424),
    [anon_sym_with] = ACTIONS(4424),
    [aux_sym_preproc_if_token3] = ACTIONS(4424),
    [aux_sym_preproc_else_token1] = ACTIONS(4424),
    [aux_sym_preproc_elif_token1] = ACTIONS(4424),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3619] = {
    [sym_preproc_region] = STATE(3619),
    [sym_preproc_endregion] = STATE(3619),
    [sym_preproc_line] = STATE(3619),
    [sym_preproc_pragma] = STATE(3619),
    [sym_preproc_nullable] = STATE(3619),
    [sym_preproc_error] = STATE(3619),
    [sym_preproc_define] = STATE(3619),
    [sym_preproc_undef] = STATE(3619),
    [anon_sym_SEMI] = ACTIONS(5319),
    [anon_sym_LBRACK] = ACTIONS(5319),
    [anon_sym_COLON] = ACTIONS(5319),
    [anon_sym_COMMA] = ACTIONS(5319),
    [anon_sym_RBRACK] = ACTIONS(5319),
    [anon_sym_LPAREN] = ACTIONS(5319),
    [anon_sym_RPAREN] = ACTIONS(5319),
    [anon_sym_RBRACE] = ACTIONS(5319),
    [anon_sym_LT] = ACTIONS(5321),
    [anon_sym_GT] = ACTIONS(5321),
    [anon_sym_in] = ACTIONS(5321),
    [anon_sym_where] = ACTIONS(5319),
    [anon_sym_QMARK] = ACTIONS(5321),
    [anon_sym_BANG] = ACTIONS(5321),
    [anon_sym_PLUS_PLUS] = ACTIONS(5319),
    [anon_sym_DASH_DASH] = ACTIONS(5319),
    [anon_sym_PLUS] = ACTIONS(5321),
    [anon_sym_DASH] = ACTIONS(5321),
    [anon_sym_STAR] = ACTIONS(5319),
    [anon_sym_SLASH] = ACTIONS(5321),
    [anon_sym_PERCENT] = ACTIONS(5319),
    [anon_sym_CARET] = ACTIONS(5319),
    [anon_sym_PIPE] = ACTIONS(5321),
    [anon_sym_AMP] = ACTIONS(5321),
    [anon_sym_LT_LT] = ACTIONS(5319),
    [anon_sym_GT_GT] = ACTIONS(5321),
    [anon_sym_GT_GT_GT] = ACTIONS(5319),
    [anon_sym_EQ_EQ] = ACTIONS(5319),
    [anon_sym_BANG_EQ] = ACTIONS(5319),
    [anon_sym_GT_EQ] = ACTIONS(5319),
    [anon_sym_LT_EQ] = ACTIONS(5319),
    [anon_sym_DOT] = ACTIONS(5321),
    [anon_sym_EQ_GT] = ACTIONS(5319),
    [anon_sym_switch] = ACTIONS(5319),
    [anon_sym_DOT_DOT] = ACTIONS(5319),
    [anon_sym_and] = ACTIONS(5319),
    [anon_sym_or] = ACTIONS(5321),
    [anon_sym_AMP_AMP] = ACTIONS(5319),
    [anon_sym_PIPE_PIPE] = ACTIONS(5319),
    [anon_sym_QMARK_QMARK] = ACTIONS(5319),
    [anon_sym_from] = ACTIONS(5319),
    [anon_sym_into] = ACTIONS(5319),
    [anon_sym_join] = ACTIONS(5319),
    [anon_sym_on] = ACTIONS(5319),
    [anon_sym_equals] = ACTIONS(5319),
    [anon_sym_let] = ACTIONS(5319),
    [anon_sym_orderby] = ACTIONS(5319),
    [anon_sym_group] = ACTIONS(5319),
    [anon_sym_by] = ACTIONS(5319),
    [anon_sym_select] = ACTIONS(5319),
    [anon_sym_as] = ACTIONS(5319),
    [anon_sym_is] = ACTIONS(5319),
    [anon_sym_DASH_GT] = ACTIONS(5319),
    [anon_sym_with] = ACTIONS(5319),
    [aux_sym_preproc_if_token3] = ACTIONS(5319),
    [aux_sym_preproc_else_token1] = ACTIONS(5319),
    [aux_sym_preproc_elif_token1] = ACTIONS(5319),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3620] = {
    [sym_preproc_region] = STATE(3620),
    [sym_preproc_endregion] = STATE(3620),
    [sym_preproc_line] = STATE(3620),
    [sym_preproc_pragma] = STATE(3620),
    [sym_preproc_nullable] = STATE(3620),
    [sym_preproc_error] = STATE(3620),
    [sym_preproc_define] = STATE(3620),
    [sym_preproc_undef] = STATE(3620),
    [anon_sym_SEMI] = ACTIONS(5349),
    [anon_sym_LBRACK] = ACTIONS(5349),
    [anon_sym_COLON] = ACTIONS(5349),
    [anon_sym_COMMA] = ACTIONS(5349),
    [anon_sym_RBRACK] = ACTIONS(5349),
    [anon_sym_LPAREN] = ACTIONS(5349),
    [anon_sym_RPAREN] = ACTIONS(5349),
    [anon_sym_RBRACE] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_in] = ACTIONS(5351),
    [anon_sym_where] = ACTIONS(5349),
    [anon_sym_QMARK] = ACTIONS(5351),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS_PLUS] = ACTIONS(5349),
    [anon_sym_DASH_DASH] = ACTIONS(5349),
    [anon_sym_PLUS] = ACTIONS(5351),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_STAR] = ACTIONS(5349),
    [anon_sym_SLASH] = ACTIONS(5351),
    [anon_sym_PERCENT] = ACTIONS(5349),
    [anon_sym_CARET] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_LT_LT] = ACTIONS(5349),
    [anon_sym_GT_GT] = ACTIONS(5351),
    [anon_sym_GT_GT_GT] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_DOT] = ACTIONS(5351),
    [anon_sym_EQ_GT] = ACTIONS(5349),
    [anon_sym_switch] = ACTIONS(5349),
    [anon_sym_DOT_DOT] = ACTIONS(5349),
    [anon_sym_and] = ACTIONS(5349),
    [anon_sym_or] = ACTIONS(5351),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_QMARK_QMARK] = ACTIONS(5349),
    [anon_sym_from] = ACTIONS(5349),
    [anon_sym_into] = ACTIONS(5349),
    [anon_sym_join] = ACTIONS(5349),
    [anon_sym_on] = ACTIONS(5349),
    [anon_sym_equals] = ACTIONS(5349),
    [anon_sym_let] = ACTIONS(5349),
    [anon_sym_orderby] = ACTIONS(5349),
    [anon_sym_group] = ACTIONS(5349),
    [anon_sym_by] = ACTIONS(5349),
    [anon_sym_select] = ACTIONS(5349),
    [anon_sym_as] = ACTIONS(5349),
    [anon_sym_is] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5349),
    [anon_sym_with] = ACTIONS(5349),
    [aux_sym_preproc_if_token3] = ACTIONS(5349),
    [aux_sym_preproc_else_token1] = ACTIONS(5349),
    [aux_sym_preproc_elif_token1] = ACTIONS(5349),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3621] = {
    [sym_preproc_region] = STATE(3621),
    [sym_preproc_endregion] = STATE(3621),
    [sym_preproc_line] = STATE(3621),
    [sym_preproc_pragma] = STATE(3621),
    [sym_preproc_nullable] = STATE(3621),
    [sym_preproc_error] = STATE(3621),
    [sym_preproc_define] = STATE(3621),
    [sym_preproc_undef] = STATE(3621),
    [anon_sym_SEMI] = ACTIONS(5353),
    [anon_sym_LBRACK] = ACTIONS(5353),
    [anon_sym_COLON] = ACTIONS(5353),
    [anon_sym_COMMA] = ACTIONS(5353),
    [anon_sym_RBRACK] = ACTIONS(5353),
    [anon_sym_LPAREN] = ACTIONS(5353),
    [anon_sym_RPAREN] = ACTIONS(5353),
    [anon_sym_RBRACE] = ACTIONS(5353),
    [anon_sym_LT] = ACTIONS(5355),
    [anon_sym_GT] = ACTIONS(5355),
    [anon_sym_in] = ACTIONS(5355),
    [anon_sym_where] = ACTIONS(5353),
    [anon_sym_QMARK] = ACTIONS(5355),
    [anon_sym_BANG] = ACTIONS(5355),
    [anon_sym_PLUS_PLUS] = ACTIONS(5353),
    [anon_sym_DASH_DASH] = ACTIONS(5353),
    [anon_sym_PLUS] = ACTIONS(5355),
    [anon_sym_DASH] = ACTIONS(5355),
    [anon_sym_STAR] = ACTIONS(5353),
    [anon_sym_SLASH] = ACTIONS(5355),
    [anon_sym_PERCENT] = ACTIONS(5353),
    [anon_sym_CARET] = ACTIONS(5353),
    [anon_sym_PIPE] = ACTIONS(5355),
    [anon_sym_AMP] = ACTIONS(5355),
    [anon_sym_LT_LT] = ACTIONS(5353),
    [anon_sym_GT_GT] = ACTIONS(5355),
    [anon_sym_GT_GT_GT] = ACTIONS(5353),
    [anon_sym_EQ_EQ] = ACTIONS(5353),
    [anon_sym_BANG_EQ] = ACTIONS(5353),
    [anon_sym_GT_EQ] = ACTIONS(5353),
    [anon_sym_LT_EQ] = ACTIONS(5353),
    [anon_sym_DOT] = ACTIONS(5355),
    [anon_sym_EQ_GT] = ACTIONS(5353),
    [anon_sym_switch] = ACTIONS(5353),
    [anon_sym_DOT_DOT] = ACTIONS(5353),
    [anon_sym_and] = ACTIONS(5353),
    [anon_sym_or] = ACTIONS(5355),
    [anon_sym_AMP_AMP] = ACTIONS(5353),
    [anon_sym_PIPE_PIPE] = ACTIONS(5353),
    [anon_sym_QMARK_QMARK] = ACTIONS(5353),
    [anon_sym_from] = ACTIONS(5353),
    [anon_sym_into] = ACTIONS(5353),
    [anon_sym_join] = ACTIONS(5353),
    [anon_sym_on] = ACTIONS(5353),
    [anon_sym_equals] = ACTIONS(5353),
    [anon_sym_let] = ACTIONS(5353),
    [anon_sym_orderby] = ACTIONS(5353),
    [anon_sym_group] = ACTIONS(5353),
    [anon_sym_by] = ACTIONS(5353),
    [anon_sym_select] = ACTIONS(5353),
    [anon_sym_as] = ACTIONS(5353),
    [anon_sym_is] = ACTIONS(5353),
    [anon_sym_DASH_GT] = ACTIONS(5353),
    [anon_sym_with] = ACTIONS(5353),
    [aux_sym_preproc_if_token3] = ACTIONS(5353),
    [aux_sym_preproc_else_token1] = ACTIONS(5353),
    [aux_sym_preproc_elif_token1] = ACTIONS(5353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3622] = {
    [sym_preproc_region] = STATE(3622),
    [sym_preproc_endregion] = STATE(3622),
    [sym_preproc_line] = STATE(3622),
    [sym_preproc_pragma] = STATE(3622),
    [sym_preproc_nullable] = STATE(3622),
    [sym_preproc_error] = STATE(3622),
    [sym_preproc_define] = STATE(3622),
    [sym_preproc_undef] = STATE(3622),
    [anon_sym_SEMI] = ACTIONS(5357),
    [anon_sym_LBRACK] = ACTIONS(5357),
    [anon_sym_COLON] = ACTIONS(5357),
    [anon_sym_COMMA] = ACTIONS(5357),
    [anon_sym_RBRACK] = ACTIONS(5357),
    [anon_sym_LPAREN] = ACTIONS(5357),
    [anon_sym_RPAREN] = ACTIONS(5357),
    [anon_sym_RBRACE] = ACTIONS(5357),
    [anon_sym_LT] = ACTIONS(5359),
    [anon_sym_GT] = ACTIONS(5359),
    [anon_sym_in] = ACTIONS(5359),
    [anon_sym_where] = ACTIONS(5357),
    [anon_sym_QMARK] = ACTIONS(5359),
    [anon_sym_BANG] = ACTIONS(5359),
    [anon_sym_PLUS_PLUS] = ACTIONS(5357),
    [anon_sym_DASH_DASH] = ACTIONS(5357),
    [anon_sym_PLUS] = ACTIONS(5359),
    [anon_sym_DASH] = ACTIONS(5359),
    [anon_sym_STAR] = ACTIONS(5357),
    [anon_sym_SLASH] = ACTIONS(5359),
    [anon_sym_PERCENT] = ACTIONS(5357),
    [anon_sym_CARET] = ACTIONS(5357),
    [anon_sym_PIPE] = ACTIONS(5359),
    [anon_sym_AMP] = ACTIONS(5359),
    [anon_sym_LT_LT] = ACTIONS(5357),
    [anon_sym_GT_GT] = ACTIONS(5359),
    [anon_sym_GT_GT_GT] = ACTIONS(5357),
    [anon_sym_EQ_EQ] = ACTIONS(5357),
    [anon_sym_BANG_EQ] = ACTIONS(5357),
    [anon_sym_GT_EQ] = ACTIONS(5357),
    [anon_sym_LT_EQ] = ACTIONS(5357),
    [anon_sym_DOT] = ACTIONS(5359),
    [anon_sym_EQ_GT] = ACTIONS(5357),
    [anon_sym_switch] = ACTIONS(5357),
    [anon_sym_DOT_DOT] = ACTIONS(5357),
    [anon_sym_and] = ACTIONS(5357),
    [anon_sym_or] = ACTIONS(5359),
    [anon_sym_AMP_AMP] = ACTIONS(5357),
    [anon_sym_PIPE_PIPE] = ACTIONS(5357),
    [anon_sym_QMARK_QMARK] = ACTIONS(5357),
    [anon_sym_from] = ACTIONS(5357),
    [anon_sym_into] = ACTIONS(5357),
    [anon_sym_join] = ACTIONS(5357),
    [anon_sym_on] = ACTIONS(5357),
    [anon_sym_equals] = ACTIONS(5357),
    [anon_sym_let] = ACTIONS(5357),
    [anon_sym_orderby] = ACTIONS(5357),
    [anon_sym_group] = ACTIONS(5357),
    [anon_sym_by] = ACTIONS(5357),
    [anon_sym_select] = ACTIONS(5357),
    [anon_sym_as] = ACTIONS(5357),
    [anon_sym_is] = ACTIONS(5357),
    [anon_sym_DASH_GT] = ACTIONS(5357),
    [anon_sym_with] = ACTIONS(5357),
    [aux_sym_preproc_if_token3] = ACTIONS(5357),
    [aux_sym_preproc_else_token1] = ACTIONS(5357),
    [aux_sym_preproc_elif_token1] = ACTIONS(5357),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3623] = {
    [sym_preproc_region] = STATE(3623),
    [sym_preproc_endregion] = STATE(3623),
    [sym_preproc_line] = STATE(3623),
    [sym_preproc_pragma] = STATE(3623),
    [sym_preproc_nullable] = STATE(3623),
    [sym_preproc_error] = STATE(3623),
    [sym_preproc_define] = STATE(3623),
    [sym_preproc_undef] = STATE(3623),
    [anon_sym_SEMI] = ACTIONS(5361),
    [anon_sym_LBRACK] = ACTIONS(5361),
    [anon_sym_COLON] = ACTIONS(5361),
    [anon_sym_COMMA] = ACTIONS(5361),
    [anon_sym_RBRACK] = ACTIONS(5361),
    [anon_sym_LPAREN] = ACTIONS(5361),
    [anon_sym_RPAREN] = ACTIONS(5361),
    [anon_sym_RBRACE] = ACTIONS(5361),
    [anon_sym_LT] = ACTIONS(5363),
    [anon_sym_GT] = ACTIONS(5363),
    [anon_sym_in] = ACTIONS(5363),
    [anon_sym_where] = ACTIONS(5361),
    [anon_sym_QMARK] = ACTIONS(5363),
    [anon_sym_BANG] = ACTIONS(5363),
    [anon_sym_PLUS_PLUS] = ACTIONS(5361),
    [anon_sym_DASH_DASH] = ACTIONS(5361),
    [anon_sym_PLUS] = ACTIONS(5363),
    [anon_sym_DASH] = ACTIONS(5363),
    [anon_sym_STAR] = ACTIONS(5361),
    [anon_sym_SLASH] = ACTIONS(5363),
    [anon_sym_PERCENT] = ACTIONS(5361),
    [anon_sym_CARET] = ACTIONS(5361),
    [anon_sym_PIPE] = ACTIONS(5363),
    [anon_sym_AMP] = ACTIONS(5363),
    [anon_sym_LT_LT] = ACTIONS(5361),
    [anon_sym_GT_GT] = ACTIONS(5363),
    [anon_sym_GT_GT_GT] = ACTIONS(5361),
    [anon_sym_EQ_EQ] = ACTIONS(5361),
    [anon_sym_BANG_EQ] = ACTIONS(5361),
    [anon_sym_GT_EQ] = ACTIONS(5361),
    [anon_sym_LT_EQ] = ACTIONS(5361),
    [anon_sym_DOT] = ACTIONS(5363),
    [anon_sym_EQ_GT] = ACTIONS(5361),
    [anon_sym_switch] = ACTIONS(5361),
    [anon_sym_DOT_DOT] = ACTIONS(5361),
    [anon_sym_and] = ACTIONS(5361),
    [anon_sym_or] = ACTIONS(5363),
    [anon_sym_AMP_AMP] = ACTIONS(5361),
    [anon_sym_PIPE_PIPE] = ACTIONS(5361),
    [anon_sym_QMARK_QMARK] = ACTIONS(5361),
    [anon_sym_from] = ACTIONS(5361),
    [anon_sym_into] = ACTIONS(5361),
    [anon_sym_join] = ACTIONS(5361),
    [anon_sym_on] = ACTIONS(5361),
    [anon_sym_equals] = ACTIONS(5361),
    [anon_sym_let] = ACTIONS(5361),
    [anon_sym_orderby] = ACTIONS(5361),
    [anon_sym_group] = ACTIONS(5361),
    [anon_sym_by] = ACTIONS(5361),
    [anon_sym_select] = ACTIONS(5361),
    [anon_sym_as] = ACTIONS(5361),
    [anon_sym_is] = ACTIONS(5361),
    [anon_sym_DASH_GT] = ACTIONS(5361),
    [anon_sym_with] = ACTIONS(5361),
    [aux_sym_preproc_if_token3] = ACTIONS(5361),
    [aux_sym_preproc_else_token1] = ACTIONS(5361),
    [aux_sym_preproc_elif_token1] = ACTIONS(5361),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3624] = {
    [sym_preproc_region] = STATE(3624),
    [sym_preproc_endregion] = STATE(3624),
    [sym_preproc_line] = STATE(3624),
    [sym_preproc_pragma] = STATE(3624),
    [sym_preproc_nullable] = STATE(3624),
    [sym_preproc_error] = STATE(3624),
    [sym_preproc_define] = STATE(3624),
    [sym_preproc_undef] = STATE(3624),
    [anon_sym_SEMI] = ACTIONS(5365),
    [anon_sym_LBRACK] = ACTIONS(5365),
    [anon_sym_COLON] = ACTIONS(5365),
    [anon_sym_COMMA] = ACTIONS(5365),
    [anon_sym_RBRACK] = ACTIONS(5365),
    [anon_sym_LPAREN] = ACTIONS(5365),
    [anon_sym_RPAREN] = ACTIONS(5365),
    [anon_sym_RBRACE] = ACTIONS(5365),
    [anon_sym_LT] = ACTIONS(5367),
    [anon_sym_GT] = ACTIONS(5367),
    [anon_sym_in] = ACTIONS(5367),
    [anon_sym_where] = ACTIONS(5365),
    [anon_sym_QMARK] = ACTIONS(5367),
    [anon_sym_BANG] = ACTIONS(5367),
    [anon_sym_PLUS_PLUS] = ACTIONS(5365),
    [anon_sym_DASH_DASH] = ACTIONS(5365),
    [anon_sym_PLUS] = ACTIONS(5367),
    [anon_sym_DASH] = ACTIONS(5367),
    [anon_sym_STAR] = ACTIONS(5365),
    [anon_sym_SLASH] = ACTIONS(5367),
    [anon_sym_PERCENT] = ACTIONS(5365),
    [anon_sym_CARET] = ACTIONS(5365),
    [anon_sym_PIPE] = ACTIONS(5367),
    [anon_sym_AMP] = ACTIONS(5367),
    [anon_sym_LT_LT] = ACTIONS(5365),
    [anon_sym_GT_GT] = ACTIONS(5367),
    [anon_sym_GT_GT_GT] = ACTIONS(5365),
    [anon_sym_EQ_EQ] = ACTIONS(5365),
    [anon_sym_BANG_EQ] = ACTIONS(5365),
    [anon_sym_GT_EQ] = ACTIONS(5365),
    [anon_sym_LT_EQ] = ACTIONS(5365),
    [anon_sym_DOT] = ACTIONS(5367),
    [anon_sym_EQ_GT] = ACTIONS(5365),
    [anon_sym_switch] = ACTIONS(5365),
    [anon_sym_DOT_DOT] = ACTIONS(5365),
    [anon_sym_and] = ACTIONS(5365),
    [anon_sym_or] = ACTIONS(5367),
    [anon_sym_AMP_AMP] = ACTIONS(5365),
    [anon_sym_PIPE_PIPE] = ACTIONS(5365),
    [anon_sym_QMARK_QMARK] = ACTIONS(5365),
    [anon_sym_from] = ACTIONS(5365),
    [anon_sym_into] = ACTIONS(5365),
    [anon_sym_join] = ACTIONS(5365),
    [anon_sym_on] = ACTIONS(5365),
    [anon_sym_equals] = ACTIONS(5365),
    [anon_sym_let] = ACTIONS(5365),
    [anon_sym_orderby] = ACTIONS(5365),
    [anon_sym_group] = ACTIONS(5365),
    [anon_sym_by] = ACTIONS(5365),
    [anon_sym_select] = ACTIONS(5365),
    [anon_sym_as] = ACTIONS(5365),
    [anon_sym_is] = ACTIONS(5365),
    [anon_sym_DASH_GT] = ACTIONS(5365),
    [anon_sym_with] = ACTIONS(5365),
    [aux_sym_preproc_if_token3] = ACTIONS(5365),
    [aux_sym_preproc_else_token1] = ACTIONS(5365),
    [aux_sym_preproc_elif_token1] = ACTIONS(5365),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3625] = {
    [sym_preproc_region] = STATE(3625),
    [sym_preproc_endregion] = STATE(3625),
    [sym_preproc_line] = STATE(3625),
    [sym_preproc_pragma] = STATE(3625),
    [sym_preproc_nullable] = STATE(3625),
    [sym_preproc_error] = STATE(3625),
    [sym_preproc_define] = STATE(3625),
    [sym_preproc_undef] = STATE(3625),
    [anon_sym_SEMI] = ACTIONS(2927),
    [anon_sym_LBRACK] = ACTIONS(2927),
    [anon_sym_COLON] = ACTIONS(2927),
    [anon_sym_COMMA] = ACTIONS(2927),
    [anon_sym_RBRACK] = ACTIONS(2927),
    [anon_sym_LPAREN] = ACTIONS(2927),
    [anon_sym_RPAREN] = ACTIONS(2927),
    [anon_sym_RBRACE] = ACTIONS(2927),
    [anon_sym_LT] = ACTIONS(2925),
    [anon_sym_GT] = ACTIONS(2925),
    [anon_sym_in] = ACTIONS(2925),
    [anon_sym_where] = ACTIONS(2927),
    [anon_sym_QMARK] = ACTIONS(2925),
    [anon_sym_BANG] = ACTIONS(2925),
    [anon_sym_PLUS_PLUS] = ACTIONS(2927),
    [anon_sym_DASH_DASH] = ACTIONS(2927),
    [anon_sym_PLUS] = ACTIONS(2925),
    [anon_sym_DASH] = ACTIONS(2925),
    [anon_sym_STAR] = ACTIONS(2927),
    [anon_sym_SLASH] = ACTIONS(2925),
    [anon_sym_PERCENT] = ACTIONS(2927),
    [anon_sym_CARET] = ACTIONS(2927),
    [anon_sym_PIPE] = ACTIONS(2925),
    [anon_sym_AMP] = ACTIONS(2925),
    [anon_sym_LT_LT] = ACTIONS(2927),
    [anon_sym_GT_GT] = ACTIONS(2925),
    [anon_sym_GT_GT_GT] = ACTIONS(2927),
    [anon_sym_EQ_EQ] = ACTIONS(2927),
    [anon_sym_BANG_EQ] = ACTIONS(2927),
    [anon_sym_GT_EQ] = ACTIONS(2927),
    [anon_sym_LT_EQ] = ACTIONS(2927),
    [anon_sym_DOT] = ACTIONS(2925),
    [anon_sym_EQ_GT] = ACTIONS(2927),
    [anon_sym_switch] = ACTIONS(2927),
    [anon_sym_DOT_DOT] = ACTIONS(2927),
    [anon_sym_and] = ACTIONS(2927),
    [anon_sym_or] = ACTIONS(2925),
    [anon_sym_AMP_AMP] = ACTIONS(2927),
    [anon_sym_PIPE_PIPE] = ACTIONS(2927),
    [anon_sym_QMARK_QMARK] = ACTIONS(2927),
    [anon_sym_from] = ACTIONS(2927),
    [anon_sym_into] = ACTIONS(2927),
    [anon_sym_join] = ACTIONS(2927),
    [anon_sym_on] = ACTIONS(2927),
    [anon_sym_equals] = ACTIONS(2927),
    [anon_sym_let] = ACTIONS(2927),
    [anon_sym_orderby] = ACTIONS(2927),
    [anon_sym_group] = ACTIONS(2927),
    [anon_sym_by] = ACTIONS(2927),
    [anon_sym_select] = ACTIONS(2927),
    [anon_sym_as] = ACTIONS(2927),
    [anon_sym_is] = ACTIONS(2927),
    [anon_sym_DASH_GT] = ACTIONS(2927),
    [anon_sym_with] = ACTIONS(2927),
    [aux_sym_preproc_if_token3] = ACTIONS(2927),
    [aux_sym_preproc_else_token1] = ACTIONS(2927),
    [aux_sym_preproc_elif_token1] = ACTIONS(2927),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3626] = {
    [sym_preproc_region] = STATE(3626),
    [sym_preproc_endregion] = STATE(3626),
    [sym_preproc_line] = STATE(3626),
    [sym_preproc_pragma] = STATE(3626),
    [sym_preproc_nullable] = STATE(3626),
    [sym_preproc_error] = STATE(3626),
    [sym_preproc_define] = STATE(3626),
    [sym_preproc_undef] = STATE(3626),
    [anon_sym_SEMI] = ACTIONS(5369),
    [anon_sym_LBRACK] = ACTIONS(5369),
    [anon_sym_COLON] = ACTIONS(5369),
    [anon_sym_COMMA] = ACTIONS(5369),
    [anon_sym_RBRACK] = ACTIONS(5369),
    [anon_sym_LPAREN] = ACTIONS(5369),
    [anon_sym_RPAREN] = ACTIONS(5369),
    [anon_sym_RBRACE] = ACTIONS(5369),
    [anon_sym_LT] = ACTIONS(5371),
    [anon_sym_GT] = ACTIONS(5371),
    [anon_sym_in] = ACTIONS(5371),
    [anon_sym_where] = ACTIONS(5369),
    [anon_sym_QMARK] = ACTIONS(5371),
    [anon_sym_BANG] = ACTIONS(5371),
    [anon_sym_PLUS_PLUS] = ACTIONS(5369),
    [anon_sym_DASH_DASH] = ACTIONS(5369),
    [anon_sym_PLUS] = ACTIONS(5371),
    [anon_sym_DASH] = ACTIONS(5371),
    [anon_sym_STAR] = ACTIONS(5369),
    [anon_sym_SLASH] = ACTIONS(5371),
    [anon_sym_PERCENT] = ACTIONS(5369),
    [anon_sym_CARET] = ACTIONS(5369),
    [anon_sym_PIPE] = ACTIONS(5371),
    [anon_sym_AMP] = ACTIONS(5371),
    [anon_sym_LT_LT] = ACTIONS(5369),
    [anon_sym_GT_GT] = ACTIONS(5371),
    [anon_sym_GT_GT_GT] = ACTIONS(5369),
    [anon_sym_EQ_EQ] = ACTIONS(5369),
    [anon_sym_BANG_EQ] = ACTIONS(5369),
    [anon_sym_GT_EQ] = ACTIONS(5369),
    [anon_sym_LT_EQ] = ACTIONS(5369),
    [anon_sym_DOT] = ACTIONS(5371),
    [anon_sym_EQ_GT] = ACTIONS(5369),
    [anon_sym_switch] = ACTIONS(5369),
    [anon_sym_DOT_DOT] = ACTIONS(5369),
    [anon_sym_and] = ACTIONS(5369),
    [anon_sym_or] = ACTIONS(5371),
    [anon_sym_AMP_AMP] = ACTIONS(5369),
    [anon_sym_PIPE_PIPE] = ACTIONS(5369),
    [anon_sym_QMARK_QMARK] = ACTIONS(5369),
    [anon_sym_from] = ACTIONS(5369),
    [anon_sym_into] = ACTIONS(5369),
    [anon_sym_join] = ACTIONS(5369),
    [anon_sym_on] = ACTIONS(5369),
    [anon_sym_equals] = ACTIONS(5369),
    [anon_sym_let] = ACTIONS(5369),
    [anon_sym_orderby] = ACTIONS(5369),
    [anon_sym_group] = ACTIONS(5369),
    [anon_sym_by] = ACTIONS(5369),
    [anon_sym_select] = ACTIONS(5369),
    [anon_sym_as] = ACTIONS(5369),
    [anon_sym_is] = ACTIONS(5369),
    [anon_sym_DASH_GT] = ACTIONS(5369),
    [anon_sym_with] = ACTIONS(5369),
    [aux_sym_preproc_if_token3] = ACTIONS(5369),
    [aux_sym_preproc_else_token1] = ACTIONS(5369),
    [aux_sym_preproc_elif_token1] = ACTIONS(5369),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3627] = {
    [sym_preproc_region] = STATE(3627),
    [sym_preproc_endregion] = STATE(3627),
    [sym_preproc_line] = STATE(3627),
    [sym_preproc_pragma] = STATE(3627),
    [sym_preproc_nullable] = STATE(3627),
    [sym_preproc_error] = STATE(3627),
    [sym_preproc_define] = STATE(3627),
    [sym_preproc_undef] = STATE(3627),
    [anon_sym_SEMI] = ACTIONS(5373),
    [anon_sym_LBRACK] = ACTIONS(5373),
    [anon_sym_COLON] = ACTIONS(5373),
    [anon_sym_COMMA] = ACTIONS(5373),
    [anon_sym_RBRACK] = ACTIONS(5373),
    [anon_sym_LPAREN] = ACTIONS(5373),
    [anon_sym_RPAREN] = ACTIONS(5373),
    [anon_sym_RBRACE] = ACTIONS(5373),
    [anon_sym_LT] = ACTIONS(5375),
    [anon_sym_GT] = ACTIONS(5375),
    [anon_sym_in] = ACTIONS(5375),
    [anon_sym_where] = ACTIONS(5373),
    [anon_sym_QMARK] = ACTIONS(5375),
    [anon_sym_BANG] = ACTIONS(5375),
    [anon_sym_PLUS_PLUS] = ACTIONS(5373),
    [anon_sym_DASH_DASH] = ACTIONS(5373),
    [anon_sym_PLUS] = ACTIONS(5375),
    [anon_sym_DASH] = ACTIONS(5375),
    [anon_sym_STAR] = ACTIONS(5373),
    [anon_sym_SLASH] = ACTIONS(5375),
    [anon_sym_PERCENT] = ACTIONS(5373),
    [anon_sym_CARET] = ACTIONS(5373),
    [anon_sym_PIPE] = ACTIONS(5375),
    [anon_sym_AMP] = ACTIONS(5375),
    [anon_sym_LT_LT] = ACTIONS(5373),
    [anon_sym_GT_GT] = ACTIONS(5375),
    [anon_sym_GT_GT_GT] = ACTIONS(5373),
    [anon_sym_EQ_EQ] = ACTIONS(5373),
    [anon_sym_BANG_EQ] = ACTIONS(5373),
    [anon_sym_GT_EQ] = ACTIONS(5373),
    [anon_sym_LT_EQ] = ACTIONS(5373),
    [anon_sym_DOT] = ACTIONS(5375),
    [anon_sym_EQ_GT] = ACTIONS(5373),
    [anon_sym_switch] = ACTIONS(5373),
    [anon_sym_DOT_DOT] = ACTIONS(5373),
    [anon_sym_and] = ACTIONS(5373),
    [anon_sym_or] = ACTIONS(5375),
    [anon_sym_AMP_AMP] = ACTIONS(5373),
    [anon_sym_PIPE_PIPE] = ACTIONS(5373),
    [anon_sym_QMARK_QMARK] = ACTIONS(5373),
    [anon_sym_from] = ACTIONS(5373),
    [anon_sym_into] = ACTIONS(5373),
    [anon_sym_join] = ACTIONS(5373),
    [anon_sym_on] = ACTIONS(5373),
    [anon_sym_equals] = ACTIONS(5373),
    [anon_sym_let] = ACTIONS(5373),
    [anon_sym_orderby] = ACTIONS(5373),
    [anon_sym_group] = ACTIONS(5373),
    [anon_sym_by] = ACTIONS(5373),
    [anon_sym_select] = ACTIONS(5373),
    [anon_sym_as] = ACTIONS(5373),
    [anon_sym_is] = ACTIONS(5373),
    [anon_sym_DASH_GT] = ACTIONS(5373),
    [anon_sym_with] = ACTIONS(5373),
    [aux_sym_preproc_if_token3] = ACTIONS(5373),
    [aux_sym_preproc_else_token1] = ACTIONS(5373),
    [aux_sym_preproc_elif_token1] = ACTIONS(5373),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3628] = {
    [sym_preproc_region] = STATE(3628),
    [sym_preproc_endregion] = STATE(3628),
    [sym_preproc_line] = STATE(3628),
    [sym_preproc_pragma] = STATE(3628),
    [sym_preproc_nullable] = STATE(3628),
    [sym_preproc_error] = STATE(3628),
    [sym_preproc_define] = STATE(3628),
    [sym_preproc_undef] = STATE(3628),
    [anon_sym_SEMI] = ACTIONS(5377),
    [anon_sym_LBRACK] = ACTIONS(5377),
    [anon_sym_COLON] = ACTIONS(5377),
    [anon_sym_COMMA] = ACTIONS(5377),
    [anon_sym_RBRACK] = ACTIONS(5377),
    [anon_sym_LPAREN] = ACTIONS(5377),
    [anon_sym_RPAREN] = ACTIONS(5377),
    [anon_sym_RBRACE] = ACTIONS(5377),
    [anon_sym_LT] = ACTIONS(5379),
    [anon_sym_GT] = ACTIONS(5379),
    [anon_sym_in] = ACTIONS(5379),
    [anon_sym_where] = ACTIONS(5377),
    [anon_sym_QMARK] = ACTIONS(5379),
    [anon_sym_BANG] = ACTIONS(5379),
    [anon_sym_PLUS_PLUS] = ACTIONS(5377),
    [anon_sym_DASH_DASH] = ACTIONS(5377),
    [anon_sym_PLUS] = ACTIONS(5379),
    [anon_sym_DASH] = ACTIONS(5379),
    [anon_sym_STAR] = ACTIONS(5377),
    [anon_sym_SLASH] = ACTIONS(5379),
    [anon_sym_PERCENT] = ACTIONS(5377),
    [anon_sym_CARET] = ACTIONS(5377),
    [anon_sym_PIPE] = ACTIONS(5379),
    [anon_sym_AMP] = ACTIONS(5379),
    [anon_sym_LT_LT] = ACTIONS(5377),
    [anon_sym_GT_GT] = ACTIONS(5379),
    [anon_sym_GT_GT_GT] = ACTIONS(5377),
    [anon_sym_EQ_EQ] = ACTIONS(5377),
    [anon_sym_BANG_EQ] = ACTIONS(5377),
    [anon_sym_GT_EQ] = ACTIONS(5377),
    [anon_sym_LT_EQ] = ACTIONS(5377),
    [anon_sym_DOT] = ACTIONS(5379),
    [anon_sym_EQ_GT] = ACTIONS(5377),
    [anon_sym_switch] = ACTIONS(5377),
    [anon_sym_DOT_DOT] = ACTIONS(5377),
    [anon_sym_and] = ACTIONS(5377),
    [anon_sym_or] = ACTIONS(5379),
    [anon_sym_AMP_AMP] = ACTIONS(5377),
    [anon_sym_PIPE_PIPE] = ACTIONS(5377),
    [anon_sym_QMARK_QMARK] = ACTIONS(5377),
    [anon_sym_from] = ACTIONS(5377),
    [anon_sym_into] = ACTIONS(5377),
    [anon_sym_join] = ACTIONS(5377),
    [anon_sym_on] = ACTIONS(5377),
    [anon_sym_equals] = ACTIONS(5377),
    [anon_sym_let] = ACTIONS(5377),
    [anon_sym_orderby] = ACTIONS(5377),
    [anon_sym_group] = ACTIONS(5377),
    [anon_sym_by] = ACTIONS(5377),
    [anon_sym_select] = ACTIONS(5377),
    [anon_sym_as] = ACTIONS(5377),
    [anon_sym_is] = ACTIONS(5377),
    [anon_sym_DASH_GT] = ACTIONS(5377),
    [anon_sym_with] = ACTIONS(5377),
    [aux_sym_preproc_if_token3] = ACTIONS(5377),
    [aux_sym_preproc_else_token1] = ACTIONS(5377),
    [aux_sym_preproc_elif_token1] = ACTIONS(5377),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3629] = {
    [sym_preproc_region] = STATE(3629),
    [sym_preproc_endregion] = STATE(3629),
    [sym_preproc_line] = STATE(3629),
    [sym_preproc_pragma] = STATE(3629),
    [sym_preproc_nullable] = STATE(3629),
    [sym_preproc_error] = STATE(3629),
    [sym_preproc_define] = STATE(3629),
    [sym_preproc_undef] = STATE(3629),
    [anon_sym_SEMI] = ACTIONS(4570),
    [anon_sym_LBRACK] = ACTIONS(4570),
    [anon_sym_COLON] = ACTIONS(4570),
    [anon_sym_COMMA] = ACTIONS(4570),
    [anon_sym_RBRACK] = ACTIONS(4570),
    [anon_sym_LPAREN] = ACTIONS(4570),
    [anon_sym_RPAREN] = ACTIONS(4570),
    [anon_sym_LBRACE] = ACTIONS(4570),
    [anon_sym_RBRACE] = ACTIONS(4570),
    [anon_sym_LT] = ACTIONS(4568),
    [anon_sym_GT] = ACTIONS(4568),
    [anon_sym_in] = ACTIONS(4570),
    [anon_sym_where] = ACTIONS(4570),
    [anon_sym_QMARK] = ACTIONS(4568),
    [anon_sym_BANG] = ACTIONS(4568),
    [anon_sym_PLUS_PLUS] = ACTIONS(4570),
    [anon_sym_DASH_DASH] = ACTIONS(4570),
    [anon_sym_PLUS] = ACTIONS(4568),
    [anon_sym_DASH] = ACTIONS(4568),
    [anon_sym_STAR] = ACTIONS(4570),
    [anon_sym_SLASH] = ACTIONS(4568),
    [anon_sym_PERCENT] = ACTIONS(4570),
    [anon_sym_CARET] = ACTIONS(4570),
    [anon_sym_PIPE] = ACTIONS(4568),
    [anon_sym_AMP] = ACTIONS(4568),
    [anon_sym_LT_LT] = ACTIONS(4570),
    [anon_sym_GT_GT] = ACTIONS(4568),
    [anon_sym_GT_GT_GT] = ACTIONS(4570),
    [anon_sym_EQ_EQ] = ACTIONS(4570),
    [anon_sym_BANG_EQ] = ACTIONS(4570),
    [anon_sym_GT_EQ] = ACTIONS(4570),
    [anon_sym_LT_EQ] = ACTIONS(4570),
    [anon_sym_DOT] = ACTIONS(4568),
    [anon_sym_EQ_GT] = ACTIONS(4570),
    [anon_sym_switch] = ACTIONS(4570),
    [anon_sym_DOT_DOT] = ACTIONS(4570),
    [anon_sym_and] = ACTIONS(4570),
    [anon_sym_or] = ACTIONS(4568),
    [anon_sym_AMP_AMP] = ACTIONS(4570),
    [anon_sym_PIPE_PIPE] = ACTIONS(4570),
    [anon_sym_QMARK_QMARK] = ACTIONS(4570),
    [anon_sym_from] = ACTIONS(4570),
    [anon_sym_join] = ACTIONS(4570),
    [anon_sym_on] = ACTIONS(4570),
    [anon_sym_equals] = ACTIONS(4570),
    [anon_sym_let] = ACTIONS(4570),
    [anon_sym_orderby] = ACTIONS(4570),
    [anon_sym_group] = ACTIONS(4570),
    [anon_sym_by] = ACTIONS(4570),
    [anon_sym_select] = ACTIONS(4570),
    [anon_sym_as] = ACTIONS(4570),
    [anon_sym_is] = ACTIONS(4570),
    [anon_sym_DASH_GT] = ACTIONS(4570),
    [anon_sym_with] = ACTIONS(4570),
    [aux_sym_preproc_if_token3] = ACTIONS(4570),
    [aux_sym_preproc_else_token1] = ACTIONS(4570),
    [aux_sym_preproc_elif_token1] = ACTIONS(4570),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3630] = {
    [sym_preproc_region] = STATE(3630),
    [sym_preproc_endregion] = STATE(3630),
    [sym_preproc_line] = STATE(3630),
    [sym_preproc_pragma] = STATE(3630),
    [sym_preproc_nullable] = STATE(3630),
    [sym_preproc_error] = STATE(3630),
    [sym_preproc_define] = STATE(3630),
    [sym_preproc_undef] = STATE(3630),
    [anon_sym_SEMI] = ACTIONS(5381),
    [anon_sym_LBRACK] = ACTIONS(5381),
    [anon_sym_COLON] = ACTIONS(5381),
    [anon_sym_COMMA] = ACTIONS(5381),
    [anon_sym_RBRACK] = ACTIONS(5381),
    [anon_sym_LPAREN] = ACTIONS(5381),
    [anon_sym_RPAREN] = ACTIONS(5381),
    [anon_sym_RBRACE] = ACTIONS(5381),
    [anon_sym_LT] = ACTIONS(5383),
    [anon_sym_GT] = ACTIONS(5383),
    [anon_sym_in] = ACTIONS(5383),
    [anon_sym_where] = ACTIONS(5381),
    [anon_sym_QMARK] = ACTIONS(5383),
    [anon_sym_BANG] = ACTIONS(5383),
    [anon_sym_PLUS_PLUS] = ACTIONS(5381),
    [anon_sym_DASH_DASH] = ACTIONS(5381),
    [anon_sym_PLUS] = ACTIONS(5383),
    [anon_sym_DASH] = ACTIONS(5383),
    [anon_sym_STAR] = ACTIONS(5381),
    [anon_sym_SLASH] = ACTIONS(5383),
    [anon_sym_PERCENT] = ACTIONS(5381),
    [anon_sym_CARET] = ACTIONS(5381),
    [anon_sym_PIPE] = ACTIONS(5383),
    [anon_sym_AMP] = ACTIONS(5383),
    [anon_sym_LT_LT] = ACTIONS(5381),
    [anon_sym_GT_GT] = ACTIONS(5383),
    [anon_sym_GT_GT_GT] = ACTIONS(5381),
    [anon_sym_EQ_EQ] = ACTIONS(5381),
    [anon_sym_BANG_EQ] = ACTIONS(5381),
    [anon_sym_GT_EQ] = ACTIONS(5381),
    [anon_sym_LT_EQ] = ACTIONS(5381),
    [anon_sym_DOT] = ACTIONS(5383),
    [anon_sym_EQ_GT] = ACTIONS(5381),
    [anon_sym_switch] = ACTIONS(5381),
    [anon_sym_DOT_DOT] = ACTIONS(5381),
    [anon_sym_and] = ACTIONS(5381),
    [anon_sym_or] = ACTIONS(5383),
    [anon_sym_AMP_AMP] = ACTIONS(5381),
    [anon_sym_PIPE_PIPE] = ACTIONS(5381),
    [anon_sym_QMARK_QMARK] = ACTIONS(5381),
    [anon_sym_from] = ACTIONS(5381),
    [anon_sym_into] = ACTIONS(5381),
    [anon_sym_join] = ACTIONS(5381),
    [anon_sym_on] = ACTIONS(5381),
    [anon_sym_equals] = ACTIONS(5381),
    [anon_sym_let] = ACTIONS(5381),
    [anon_sym_orderby] = ACTIONS(5381),
    [anon_sym_group] = ACTIONS(5381),
    [anon_sym_by] = ACTIONS(5381),
    [anon_sym_select] = ACTIONS(5381),
    [anon_sym_as] = ACTIONS(5381),
    [anon_sym_is] = ACTIONS(5381),
    [anon_sym_DASH_GT] = ACTIONS(5381),
    [anon_sym_with] = ACTIONS(5381),
    [aux_sym_preproc_if_token3] = ACTIONS(5381),
    [aux_sym_preproc_else_token1] = ACTIONS(5381),
    [aux_sym_preproc_elif_token1] = ACTIONS(5381),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3631] = {
    [sym_preproc_region] = STATE(3631),
    [sym_preproc_endregion] = STATE(3631),
    [sym_preproc_line] = STATE(3631),
    [sym_preproc_pragma] = STATE(3631),
    [sym_preproc_nullable] = STATE(3631),
    [sym_preproc_error] = STATE(3631),
    [sym_preproc_define] = STATE(3631),
    [sym_preproc_undef] = STATE(3631),
    [anon_sym_SEMI] = ACTIONS(4072),
    [anon_sym_LBRACK] = ACTIONS(4072),
    [anon_sym_COLON] = ACTIONS(4072),
    [anon_sym_COMMA] = ACTIONS(4072),
    [anon_sym_RBRACK] = ACTIONS(4072),
    [anon_sym_LPAREN] = ACTIONS(4072),
    [anon_sym_RPAREN] = ACTIONS(4072),
    [anon_sym_LBRACE] = ACTIONS(4072),
    [anon_sym_RBRACE] = ACTIONS(4072),
    [anon_sym_LT] = ACTIONS(4070),
    [anon_sym_GT] = ACTIONS(4070),
    [anon_sym_in] = ACTIONS(4072),
    [anon_sym_where] = ACTIONS(4072),
    [anon_sym_QMARK] = ACTIONS(4070),
    [anon_sym_BANG] = ACTIONS(4070),
    [anon_sym_PLUS_PLUS] = ACTIONS(4072),
    [anon_sym_DASH_DASH] = ACTIONS(4072),
    [anon_sym_PLUS] = ACTIONS(4070),
    [anon_sym_DASH] = ACTIONS(4070),
    [anon_sym_STAR] = ACTIONS(4072),
    [anon_sym_SLASH] = ACTIONS(4070),
    [anon_sym_PERCENT] = ACTIONS(4072),
    [anon_sym_CARET] = ACTIONS(4072),
    [anon_sym_PIPE] = ACTIONS(4070),
    [anon_sym_AMP] = ACTIONS(4070),
    [anon_sym_LT_LT] = ACTIONS(4072),
    [anon_sym_GT_GT] = ACTIONS(4070),
    [anon_sym_GT_GT_GT] = ACTIONS(4072),
    [anon_sym_EQ_EQ] = ACTIONS(4072),
    [anon_sym_BANG_EQ] = ACTIONS(4072),
    [anon_sym_GT_EQ] = ACTIONS(4072),
    [anon_sym_LT_EQ] = ACTIONS(4072),
    [anon_sym_DOT] = ACTIONS(4070),
    [anon_sym_EQ_GT] = ACTIONS(4072),
    [anon_sym_switch] = ACTIONS(4072),
    [anon_sym_DOT_DOT] = ACTIONS(4072),
    [anon_sym_and] = ACTIONS(4072),
    [anon_sym_or] = ACTIONS(4070),
    [anon_sym_AMP_AMP] = ACTIONS(4072),
    [anon_sym_PIPE_PIPE] = ACTIONS(4072),
    [anon_sym_QMARK_QMARK] = ACTIONS(4072),
    [anon_sym_from] = ACTIONS(4072),
    [anon_sym_join] = ACTIONS(4072),
    [anon_sym_on] = ACTIONS(4072),
    [anon_sym_equals] = ACTIONS(4072),
    [anon_sym_let] = ACTIONS(4072),
    [anon_sym_orderby] = ACTIONS(4072),
    [anon_sym_group] = ACTIONS(4072),
    [anon_sym_by] = ACTIONS(4072),
    [anon_sym_select] = ACTIONS(4072),
    [anon_sym_as] = ACTIONS(4072),
    [anon_sym_is] = ACTIONS(4072),
    [anon_sym_DASH_GT] = ACTIONS(4072),
    [anon_sym_with] = ACTIONS(4072),
    [aux_sym_preproc_if_token3] = ACTIONS(4072),
    [aux_sym_preproc_else_token1] = ACTIONS(4072),
    [aux_sym_preproc_elif_token1] = ACTIONS(4072),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3632] = {
    [sym_preproc_region] = STATE(3632),
    [sym_preproc_endregion] = STATE(3632),
    [sym_preproc_line] = STATE(3632),
    [sym_preproc_pragma] = STATE(3632),
    [sym_preproc_nullable] = STATE(3632),
    [sym_preproc_error] = STATE(3632),
    [sym_preproc_define] = STATE(3632),
    [sym_preproc_undef] = STATE(3632),
    [anon_sym_SEMI] = ACTIONS(5385),
    [anon_sym_LBRACK] = ACTIONS(5385),
    [anon_sym_COLON] = ACTIONS(5385),
    [anon_sym_COMMA] = ACTIONS(5385),
    [anon_sym_RBRACK] = ACTIONS(5385),
    [anon_sym_LPAREN] = ACTIONS(5385),
    [anon_sym_RPAREN] = ACTIONS(5385),
    [anon_sym_RBRACE] = ACTIONS(5385),
    [anon_sym_LT] = ACTIONS(5387),
    [anon_sym_GT] = ACTIONS(5387),
    [anon_sym_in] = ACTIONS(5387),
    [anon_sym_where] = ACTIONS(5385),
    [anon_sym_QMARK] = ACTIONS(5387),
    [anon_sym_BANG] = ACTIONS(5387),
    [anon_sym_PLUS_PLUS] = ACTIONS(5385),
    [anon_sym_DASH_DASH] = ACTIONS(5385),
    [anon_sym_PLUS] = ACTIONS(5387),
    [anon_sym_DASH] = ACTIONS(5387),
    [anon_sym_STAR] = ACTIONS(5385),
    [anon_sym_SLASH] = ACTIONS(5387),
    [anon_sym_PERCENT] = ACTIONS(5385),
    [anon_sym_CARET] = ACTIONS(5385),
    [anon_sym_PIPE] = ACTIONS(5387),
    [anon_sym_AMP] = ACTIONS(5387),
    [anon_sym_LT_LT] = ACTIONS(5385),
    [anon_sym_GT_GT] = ACTIONS(5387),
    [anon_sym_GT_GT_GT] = ACTIONS(5385),
    [anon_sym_EQ_EQ] = ACTIONS(5385),
    [anon_sym_BANG_EQ] = ACTIONS(5385),
    [anon_sym_GT_EQ] = ACTIONS(5385),
    [anon_sym_LT_EQ] = ACTIONS(5385),
    [anon_sym_DOT] = ACTIONS(5387),
    [anon_sym_EQ_GT] = ACTIONS(5385),
    [anon_sym_switch] = ACTIONS(5385),
    [anon_sym_DOT_DOT] = ACTIONS(5385),
    [anon_sym_and] = ACTIONS(5385),
    [anon_sym_or] = ACTIONS(5387),
    [anon_sym_AMP_AMP] = ACTIONS(5385),
    [anon_sym_PIPE_PIPE] = ACTIONS(5385),
    [anon_sym_QMARK_QMARK] = ACTIONS(5385),
    [anon_sym_from] = ACTIONS(5385),
    [anon_sym_into] = ACTIONS(5385),
    [anon_sym_join] = ACTIONS(5385),
    [anon_sym_on] = ACTIONS(5385),
    [anon_sym_equals] = ACTIONS(5385),
    [anon_sym_let] = ACTIONS(5385),
    [anon_sym_orderby] = ACTIONS(5385),
    [anon_sym_group] = ACTIONS(5385),
    [anon_sym_by] = ACTIONS(5385),
    [anon_sym_select] = ACTIONS(5385),
    [anon_sym_as] = ACTIONS(5385),
    [anon_sym_is] = ACTIONS(5385),
    [anon_sym_DASH_GT] = ACTIONS(5385),
    [anon_sym_with] = ACTIONS(5385),
    [aux_sym_preproc_if_token3] = ACTIONS(5385),
    [aux_sym_preproc_else_token1] = ACTIONS(5385),
    [aux_sym_preproc_elif_token1] = ACTIONS(5385),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3633] = {
    [sym_preproc_region] = STATE(3633),
    [sym_preproc_endregion] = STATE(3633),
    [sym_preproc_line] = STATE(3633),
    [sym_preproc_pragma] = STATE(3633),
    [sym_preproc_nullable] = STATE(3633),
    [sym_preproc_error] = STATE(3633),
    [sym_preproc_define] = STATE(3633),
    [sym_preproc_undef] = STATE(3633),
    [anon_sym_SEMI] = ACTIONS(4424),
    [anon_sym_LBRACK] = ACTIONS(4547),
    [anon_sym_COLON] = ACTIONS(4424),
    [anon_sym_COMMA] = ACTIONS(4424),
    [anon_sym_RBRACK] = ACTIONS(4424),
    [anon_sym_LPAREN] = ACTIONS(4424),
    [anon_sym_RPAREN] = ACTIONS(4424),
    [anon_sym_LBRACE] = ACTIONS(4424),
    [anon_sym_RBRACE] = ACTIONS(4424),
    [anon_sym_LT] = ACTIONS(4422),
    [anon_sym_GT] = ACTIONS(4422),
    [anon_sym_in] = ACTIONS(4424),
    [anon_sym_where] = ACTIONS(4424),
    [anon_sym_QMARK] = ACTIONS(5389),
    [anon_sym_BANG] = ACTIONS(4422),
    [anon_sym_PLUS_PLUS] = ACTIONS(4424),
    [anon_sym_DASH_DASH] = ACTIONS(4424),
    [anon_sym_PLUS] = ACTIONS(4422),
    [anon_sym_DASH] = ACTIONS(4422),
    [anon_sym_STAR] = ACTIONS(4553),
    [anon_sym_SLASH] = ACTIONS(4422),
    [anon_sym_PERCENT] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4424),
    [anon_sym_PIPE] = ACTIONS(4422),
    [anon_sym_AMP] = ACTIONS(4422),
    [anon_sym_LT_LT] = ACTIONS(4424),
    [anon_sym_GT_GT] = ACTIONS(4422),
    [anon_sym_GT_GT_GT] = ACTIONS(4424),
    [anon_sym_EQ_EQ] = ACTIONS(4424),
    [anon_sym_BANG_EQ] = ACTIONS(4424),
    [anon_sym_GT_EQ] = ACTIONS(4424),
    [anon_sym_LT_EQ] = ACTIONS(4424),
    [anon_sym_DOT] = ACTIONS(4422),
    [anon_sym_EQ_GT] = ACTIONS(4424),
    [anon_sym_switch] = ACTIONS(4424),
    [anon_sym_DOT_DOT] = ACTIONS(4424),
    [anon_sym_and] = ACTIONS(4424),
    [anon_sym_or] = ACTIONS(4422),
    [anon_sym_AMP_AMP] = ACTIONS(4424),
    [anon_sym_PIPE_PIPE] = ACTIONS(4424),
    [anon_sym_QMARK_QMARK] = ACTIONS(4424),
    [anon_sym_from] = ACTIONS(4424),
    [anon_sym_join] = ACTIONS(4424),
    [anon_sym_on] = ACTIONS(4424),
    [anon_sym_equals] = ACTIONS(4424),
    [anon_sym_let] = ACTIONS(4424),
    [anon_sym_orderby] = ACTIONS(4424),
    [anon_sym_group] = ACTIONS(4424),
    [anon_sym_by] = ACTIONS(4424),
    [anon_sym_select] = ACTIONS(4424),
    [anon_sym_as] = ACTIONS(4424),
    [anon_sym_is] = ACTIONS(4424),
    [anon_sym_DASH_GT] = ACTIONS(4424),
    [anon_sym_with] = ACTIONS(4424),
    [aux_sym_preproc_if_token3] = ACTIONS(4424),
    [aux_sym_preproc_else_token1] = ACTIONS(4424),
    [aux_sym_preproc_elif_token1] = ACTIONS(4424),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3634] = {
    [sym_preproc_region] = STATE(3634),
    [sym_preproc_endregion] = STATE(3634),
    [sym_preproc_line] = STATE(3634),
    [sym_preproc_pragma] = STATE(3634),
    [sym_preproc_nullable] = STATE(3634),
    [sym_preproc_error] = STATE(3634),
    [sym_preproc_define] = STATE(3634),
    [sym_preproc_undef] = STATE(3634),
    [anon_sym_SEMI] = ACTIONS(4695),
    [anon_sym_LBRACK] = ACTIONS(4695),
    [anon_sym_COLON] = ACTIONS(4695),
    [anon_sym_COMMA] = ACTIONS(4695),
    [anon_sym_RBRACK] = ACTIONS(4695),
    [anon_sym_LPAREN] = ACTIONS(4695),
    [anon_sym_RPAREN] = ACTIONS(4695),
    [anon_sym_RBRACE] = ACTIONS(4695),
    [anon_sym_LT] = ACTIONS(4697),
    [anon_sym_GT] = ACTIONS(4697),
    [anon_sym_in] = ACTIONS(4697),
    [anon_sym_where] = ACTIONS(4695),
    [anon_sym_QMARK] = ACTIONS(4697),
    [anon_sym_BANG] = ACTIONS(4697),
    [anon_sym_PLUS_PLUS] = ACTIONS(4695),
    [anon_sym_DASH_DASH] = ACTIONS(4695),
    [anon_sym_PLUS] = ACTIONS(4697),
    [anon_sym_DASH] = ACTIONS(4697),
    [anon_sym_STAR] = ACTIONS(4695),
    [anon_sym_SLASH] = ACTIONS(4697),
    [anon_sym_PERCENT] = ACTIONS(4695),
    [anon_sym_CARET] = ACTIONS(4695),
    [anon_sym_PIPE] = ACTIONS(4697),
    [anon_sym_AMP] = ACTIONS(4697),
    [anon_sym_LT_LT] = ACTIONS(4695),
    [anon_sym_GT_GT] = ACTIONS(4697),
    [anon_sym_GT_GT_GT] = ACTIONS(4695),
    [anon_sym_EQ_EQ] = ACTIONS(4695),
    [anon_sym_BANG_EQ] = ACTIONS(4695),
    [anon_sym_GT_EQ] = ACTIONS(4695),
    [anon_sym_LT_EQ] = ACTIONS(4695),
    [anon_sym_DOT] = ACTIONS(4697),
    [anon_sym_EQ_GT] = ACTIONS(4695),
    [anon_sym_switch] = ACTIONS(4695),
    [anon_sym_DOT_DOT] = ACTIONS(4695),
    [anon_sym_and] = ACTIONS(4695),
    [anon_sym_or] = ACTIONS(4697),
    [anon_sym_AMP_AMP] = ACTIONS(4695),
    [anon_sym_PIPE_PIPE] = ACTIONS(4695),
    [anon_sym_QMARK_QMARK] = ACTIONS(4695),
    [anon_sym_from] = ACTIONS(4695),
    [anon_sym_into] = ACTIONS(4695),
    [anon_sym_join] = ACTIONS(4695),
    [anon_sym_on] = ACTIONS(4695),
    [anon_sym_equals] = ACTIONS(4695),
    [anon_sym_let] = ACTIONS(4695),
    [anon_sym_orderby] = ACTIONS(4695),
    [anon_sym_group] = ACTIONS(4695),
    [anon_sym_by] = ACTIONS(4695),
    [anon_sym_select] = ACTIONS(4695),
    [anon_sym_as] = ACTIONS(4695),
    [anon_sym_is] = ACTIONS(4695),
    [anon_sym_DASH_GT] = ACTIONS(4695),
    [anon_sym_with] = ACTIONS(4695),
    [aux_sym_preproc_if_token3] = ACTIONS(4695),
    [aux_sym_preproc_else_token1] = ACTIONS(4695),
    [aux_sym_preproc_elif_token1] = ACTIONS(4695),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3635] = {
    [sym_preproc_region] = STATE(3635),
    [sym_preproc_endregion] = STATE(3635),
    [sym_preproc_line] = STATE(3635),
    [sym_preproc_pragma] = STATE(3635),
    [sym_preproc_nullable] = STATE(3635),
    [sym_preproc_error] = STATE(3635),
    [sym_preproc_define] = STATE(3635),
    [sym_preproc_undef] = STATE(3635),
    [anon_sym_SEMI] = ACTIONS(4124),
    [anon_sym_LBRACK] = ACTIONS(4124),
    [anon_sym_COLON] = ACTIONS(4124),
    [anon_sym_COMMA] = ACTIONS(4124),
    [anon_sym_RBRACK] = ACTIONS(4124),
    [anon_sym_LPAREN] = ACTIONS(4124),
    [anon_sym_RPAREN] = ACTIONS(4124),
    [anon_sym_LBRACE] = ACTIONS(4124),
    [anon_sym_RBRACE] = ACTIONS(4124),
    [anon_sym_LT] = ACTIONS(4113),
    [anon_sym_GT] = ACTIONS(4113),
    [anon_sym_in] = ACTIONS(4124),
    [anon_sym_where] = ACTIONS(4124),
    [anon_sym_QMARK] = ACTIONS(4113),
    [anon_sym_BANG] = ACTIONS(4113),
    [anon_sym_PLUS_PLUS] = ACTIONS(4124),
    [anon_sym_DASH_DASH] = ACTIONS(4124),
    [anon_sym_PLUS] = ACTIONS(4113),
    [anon_sym_DASH] = ACTIONS(4113),
    [anon_sym_STAR] = ACTIONS(4124),
    [anon_sym_SLASH] = ACTIONS(4113),
    [anon_sym_PERCENT] = ACTIONS(4124),
    [anon_sym_CARET] = ACTIONS(4124),
    [anon_sym_PIPE] = ACTIONS(4113),
    [anon_sym_AMP] = ACTIONS(4113),
    [anon_sym_LT_LT] = ACTIONS(4124),
    [anon_sym_GT_GT] = ACTIONS(4113),
    [anon_sym_GT_GT_GT] = ACTIONS(4124),
    [anon_sym_EQ_EQ] = ACTIONS(4124),
    [anon_sym_BANG_EQ] = ACTIONS(4124),
    [anon_sym_GT_EQ] = ACTIONS(4124),
    [anon_sym_LT_EQ] = ACTIONS(4124),
    [anon_sym_DOT] = ACTIONS(4113),
    [anon_sym_EQ_GT] = ACTIONS(4124),
    [anon_sym_switch] = ACTIONS(4124),
    [anon_sym_DOT_DOT] = ACTIONS(4124),
    [anon_sym_and] = ACTIONS(4124),
    [anon_sym_or] = ACTIONS(4113),
    [anon_sym_AMP_AMP] = ACTIONS(4124),
    [anon_sym_PIPE_PIPE] = ACTIONS(4124),
    [anon_sym_QMARK_QMARK] = ACTIONS(4124),
    [anon_sym_from] = ACTIONS(4124),
    [anon_sym_join] = ACTIONS(4124),
    [anon_sym_on] = ACTIONS(4124),
    [anon_sym_equals] = ACTIONS(4124),
    [anon_sym_let] = ACTIONS(4124),
    [anon_sym_orderby] = ACTIONS(4124),
    [anon_sym_group] = ACTIONS(4124),
    [anon_sym_by] = ACTIONS(4124),
    [anon_sym_select] = ACTIONS(4124),
    [anon_sym_as] = ACTIONS(4124),
    [anon_sym_is] = ACTIONS(4124),
    [anon_sym_DASH_GT] = ACTIONS(4124),
    [anon_sym_with] = ACTIONS(4124),
    [aux_sym_preproc_if_token3] = ACTIONS(4124),
    [aux_sym_preproc_else_token1] = ACTIONS(4124),
    [aux_sym_preproc_elif_token1] = ACTIONS(4124),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3636] = {
    [sym_preproc_region] = STATE(3636),
    [sym_preproc_endregion] = STATE(3636),
    [sym_preproc_line] = STATE(3636),
    [sym_preproc_pragma] = STATE(3636),
    [sym_preproc_nullable] = STATE(3636),
    [sym_preproc_error] = STATE(3636),
    [sym_preproc_define] = STATE(3636),
    [sym_preproc_undef] = STATE(3636),
    [anon_sym_SEMI] = ACTIONS(4428),
    [anon_sym_LBRACK] = ACTIONS(4428),
    [anon_sym_COLON] = ACTIONS(4428),
    [anon_sym_COMMA] = ACTIONS(4428),
    [anon_sym_RBRACK] = ACTIONS(4428),
    [anon_sym_LPAREN] = ACTIONS(4428),
    [anon_sym_RPAREN] = ACTIONS(4428),
    [anon_sym_LBRACE] = ACTIONS(4428),
    [anon_sym_RBRACE] = ACTIONS(4428),
    [anon_sym_LT] = ACTIONS(4426),
    [anon_sym_GT] = ACTIONS(4426),
    [anon_sym_in] = ACTIONS(4428),
    [anon_sym_where] = ACTIONS(4428),
    [anon_sym_QMARK] = ACTIONS(4426),
    [anon_sym_BANG] = ACTIONS(4426),
    [anon_sym_PLUS_PLUS] = ACTIONS(4428),
    [anon_sym_DASH_DASH] = ACTIONS(4428),
    [anon_sym_PLUS] = ACTIONS(4426),
    [anon_sym_DASH] = ACTIONS(4426),
    [anon_sym_STAR] = ACTIONS(4428),
    [anon_sym_SLASH] = ACTIONS(4426),
    [anon_sym_PERCENT] = ACTIONS(4428),
    [anon_sym_CARET] = ACTIONS(4428),
    [anon_sym_PIPE] = ACTIONS(4426),
    [anon_sym_AMP] = ACTIONS(4426),
    [anon_sym_LT_LT] = ACTIONS(4428),
    [anon_sym_GT_GT] = ACTIONS(4426),
    [anon_sym_GT_GT_GT] = ACTIONS(4428),
    [anon_sym_EQ_EQ] = ACTIONS(4428),
    [anon_sym_BANG_EQ] = ACTIONS(4428),
    [anon_sym_GT_EQ] = ACTIONS(4428),
    [anon_sym_LT_EQ] = ACTIONS(4428),
    [anon_sym_DOT] = ACTIONS(4426),
    [anon_sym_EQ_GT] = ACTIONS(4428),
    [anon_sym_switch] = ACTIONS(4428),
    [anon_sym_DOT_DOT] = ACTIONS(4428),
    [anon_sym_and] = ACTIONS(4428),
    [anon_sym_or] = ACTIONS(4426),
    [anon_sym_AMP_AMP] = ACTIONS(4428),
    [anon_sym_PIPE_PIPE] = ACTIONS(4428),
    [anon_sym_QMARK_QMARK] = ACTIONS(4428),
    [anon_sym_from] = ACTIONS(4428),
    [anon_sym_join] = ACTIONS(4428),
    [anon_sym_on] = ACTIONS(4428),
    [anon_sym_equals] = ACTIONS(4428),
    [anon_sym_let] = ACTIONS(4428),
    [anon_sym_orderby] = ACTIONS(4428),
    [anon_sym_group] = ACTIONS(4428),
    [anon_sym_by] = ACTIONS(4428),
    [anon_sym_select] = ACTIONS(4428),
    [anon_sym_as] = ACTIONS(4428),
    [anon_sym_is] = ACTIONS(4428),
    [anon_sym_DASH_GT] = ACTIONS(4428),
    [anon_sym_with] = ACTIONS(4428),
    [aux_sym_preproc_if_token3] = ACTIONS(4428),
    [aux_sym_preproc_else_token1] = ACTIONS(4428),
    [aux_sym_preproc_elif_token1] = ACTIONS(4428),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3637] = {
    [sym_preproc_region] = STATE(3637),
    [sym_preproc_endregion] = STATE(3637),
    [sym_preproc_line] = STATE(3637),
    [sym_preproc_pragma] = STATE(3637),
    [sym_preproc_nullable] = STATE(3637),
    [sym_preproc_error] = STATE(3637),
    [sym_preproc_define] = STATE(3637),
    [sym_preproc_undef] = STATE(3637),
    [anon_sym_SEMI] = ACTIONS(5392),
    [anon_sym_LBRACK] = ACTIONS(5392),
    [anon_sym_COLON] = ACTIONS(5392),
    [anon_sym_COMMA] = ACTIONS(5392),
    [anon_sym_RBRACK] = ACTIONS(5392),
    [anon_sym_LPAREN] = ACTIONS(5392),
    [anon_sym_RPAREN] = ACTIONS(5392),
    [anon_sym_RBRACE] = ACTIONS(5392),
    [anon_sym_LT] = ACTIONS(5394),
    [anon_sym_GT] = ACTIONS(5394),
    [anon_sym_in] = ACTIONS(5394),
    [anon_sym_where] = ACTIONS(5392),
    [anon_sym_QMARK] = ACTIONS(5394),
    [anon_sym_BANG] = ACTIONS(5394),
    [anon_sym_PLUS_PLUS] = ACTIONS(5392),
    [anon_sym_DASH_DASH] = ACTIONS(5392),
    [anon_sym_PLUS] = ACTIONS(5394),
    [anon_sym_DASH] = ACTIONS(5394),
    [anon_sym_STAR] = ACTIONS(5392),
    [anon_sym_SLASH] = ACTIONS(5394),
    [anon_sym_PERCENT] = ACTIONS(5392),
    [anon_sym_CARET] = ACTIONS(5392),
    [anon_sym_PIPE] = ACTIONS(5394),
    [anon_sym_AMP] = ACTIONS(5394),
    [anon_sym_LT_LT] = ACTIONS(5392),
    [anon_sym_GT_GT] = ACTIONS(5394),
    [anon_sym_GT_GT_GT] = ACTIONS(5392),
    [anon_sym_EQ_EQ] = ACTIONS(5392),
    [anon_sym_BANG_EQ] = ACTIONS(5392),
    [anon_sym_GT_EQ] = ACTIONS(5392),
    [anon_sym_LT_EQ] = ACTIONS(5392),
    [anon_sym_DOT] = ACTIONS(5394),
    [anon_sym_EQ_GT] = ACTIONS(5392),
    [anon_sym_switch] = ACTIONS(5392),
    [anon_sym_DOT_DOT] = ACTIONS(5392),
    [anon_sym_and] = ACTIONS(5392),
    [anon_sym_or] = ACTIONS(5394),
    [anon_sym_AMP_AMP] = ACTIONS(5392),
    [anon_sym_PIPE_PIPE] = ACTIONS(5392),
    [anon_sym_QMARK_QMARK] = ACTIONS(5392),
    [anon_sym_from] = ACTIONS(5392),
    [anon_sym_into] = ACTIONS(5392),
    [anon_sym_join] = ACTIONS(5392),
    [anon_sym_on] = ACTIONS(5392),
    [anon_sym_equals] = ACTIONS(5392),
    [anon_sym_let] = ACTIONS(5392),
    [anon_sym_orderby] = ACTIONS(5392),
    [anon_sym_group] = ACTIONS(5392),
    [anon_sym_by] = ACTIONS(5392),
    [anon_sym_select] = ACTIONS(5392),
    [anon_sym_as] = ACTIONS(5392),
    [anon_sym_is] = ACTIONS(5392),
    [anon_sym_DASH_GT] = ACTIONS(5392),
    [anon_sym_with] = ACTIONS(5392),
    [aux_sym_preproc_if_token3] = ACTIONS(5392),
    [aux_sym_preproc_else_token1] = ACTIONS(5392),
    [aux_sym_preproc_elif_token1] = ACTIONS(5392),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3638] = {
    [sym_preproc_region] = STATE(3638),
    [sym_preproc_endregion] = STATE(3638),
    [sym_preproc_line] = STATE(3638),
    [sym_preproc_pragma] = STATE(3638),
    [sym_preproc_nullable] = STATE(3638),
    [sym_preproc_error] = STATE(3638),
    [sym_preproc_define] = STATE(3638),
    [sym_preproc_undef] = STATE(3638),
    [anon_sym_SEMI] = ACTIONS(5396),
    [anon_sym_LBRACK] = ACTIONS(5396),
    [anon_sym_COLON] = ACTIONS(5396),
    [anon_sym_COMMA] = ACTIONS(5396),
    [anon_sym_RBRACK] = ACTIONS(5396),
    [anon_sym_LPAREN] = ACTIONS(5396),
    [anon_sym_RPAREN] = ACTIONS(5396),
    [anon_sym_RBRACE] = ACTIONS(5396),
    [anon_sym_LT] = ACTIONS(5398),
    [anon_sym_GT] = ACTIONS(5398),
    [anon_sym_in] = ACTIONS(5398),
    [anon_sym_where] = ACTIONS(5396),
    [anon_sym_QMARK] = ACTIONS(5398),
    [anon_sym_BANG] = ACTIONS(5398),
    [anon_sym_PLUS_PLUS] = ACTIONS(5396),
    [anon_sym_DASH_DASH] = ACTIONS(5396),
    [anon_sym_PLUS] = ACTIONS(5398),
    [anon_sym_DASH] = ACTIONS(5398),
    [anon_sym_STAR] = ACTIONS(5396),
    [anon_sym_SLASH] = ACTIONS(5398),
    [anon_sym_PERCENT] = ACTIONS(5396),
    [anon_sym_CARET] = ACTIONS(5396),
    [anon_sym_PIPE] = ACTIONS(5398),
    [anon_sym_AMP] = ACTIONS(5398),
    [anon_sym_LT_LT] = ACTIONS(5396),
    [anon_sym_GT_GT] = ACTIONS(5398),
    [anon_sym_GT_GT_GT] = ACTIONS(5396),
    [anon_sym_EQ_EQ] = ACTIONS(5396),
    [anon_sym_BANG_EQ] = ACTIONS(5396),
    [anon_sym_GT_EQ] = ACTIONS(5396),
    [anon_sym_LT_EQ] = ACTIONS(5396),
    [anon_sym_DOT] = ACTIONS(5398),
    [anon_sym_EQ_GT] = ACTIONS(5396),
    [anon_sym_switch] = ACTIONS(5396),
    [anon_sym_DOT_DOT] = ACTIONS(5396),
    [anon_sym_and] = ACTIONS(5396),
    [anon_sym_or] = ACTIONS(5398),
    [anon_sym_AMP_AMP] = ACTIONS(5396),
    [anon_sym_PIPE_PIPE] = ACTIONS(5396),
    [anon_sym_QMARK_QMARK] = ACTIONS(5396),
    [anon_sym_from] = ACTIONS(5396),
    [anon_sym_into] = ACTIONS(5396),
    [anon_sym_join] = ACTIONS(5396),
    [anon_sym_on] = ACTIONS(5396),
    [anon_sym_equals] = ACTIONS(5396),
    [anon_sym_let] = ACTIONS(5396),
    [anon_sym_orderby] = ACTIONS(5396),
    [anon_sym_group] = ACTIONS(5396),
    [anon_sym_by] = ACTIONS(5396),
    [anon_sym_select] = ACTIONS(5396),
    [anon_sym_as] = ACTIONS(5396),
    [anon_sym_is] = ACTIONS(5396),
    [anon_sym_DASH_GT] = ACTIONS(5396),
    [anon_sym_with] = ACTIONS(5396),
    [aux_sym_preproc_if_token3] = ACTIONS(5396),
    [aux_sym_preproc_else_token1] = ACTIONS(5396),
    [aux_sym_preproc_elif_token1] = ACTIONS(5396),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3639] = {
    [sym_preproc_region] = STATE(3639),
    [sym_preproc_endregion] = STATE(3639),
    [sym_preproc_line] = STATE(3639),
    [sym_preproc_pragma] = STATE(3639),
    [sym_preproc_nullable] = STATE(3639),
    [sym_preproc_error] = STATE(3639),
    [sym_preproc_define] = STATE(3639),
    [sym_preproc_undef] = STATE(3639),
    [anon_sym_SEMI] = ACTIONS(5400),
    [anon_sym_LBRACK] = ACTIONS(5400),
    [anon_sym_COLON] = ACTIONS(5400),
    [anon_sym_COMMA] = ACTIONS(5400),
    [anon_sym_RBRACK] = ACTIONS(5400),
    [anon_sym_LPAREN] = ACTIONS(5400),
    [anon_sym_RPAREN] = ACTIONS(5400),
    [anon_sym_RBRACE] = ACTIONS(5400),
    [anon_sym_LT] = ACTIONS(5402),
    [anon_sym_GT] = ACTIONS(5402),
    [anon_sym_in] = ACTIONS(5402),
    [anon_sym_where] = ACTIONS(5400),
    [anon_sym_QMARK] = ACTIONS(5402),
    [anon_sym_BANG] = ACTIONS(5402),
    [anon_sym_PLUS_PLUS] = ACTIONS(5400),
    [anon_sym_DASH_DASH] = ACTIONS(5400),
    [anon_sym_PLUS] = ACTIONS(5402),
    [anon_sym_DASH] = ACTIONS(5402),
    [anon_sym_STAR] = ACTIONS(5400),
    [anon_sym_SLASH] = ACTIONS(5402),
    [anon_sym_PERCENT] = ACTIONS(5400),
    [anon_sym_CARET] = ACTIONS(5400),
    [anon_sym_PIPE] = ACTIONS(5402),
    [anon_sym_AMP] = ACTIONS(5402),
    [anon_sym_LT_LT] = ACTIONS(5400),
    [anon_sym_GT_GT] = ACTIONS(5402),
    [anon_sym_GT_GT_GT] = ACTIONS(5400),
    [anon_sym_EQ_EQ] = ACTIONS(5400),
    [anon_sym_BANG_EQ] = ACTIONS(5400),
    [anon_sym_GT_EQ] = ACTIONS(5400),
    [anon_sym_LT_EQ] = ACTIONS(5400),
    [anon_sym_DOT] = ACTIONS(5402),
    [anon_sym_EQ_GT] = ACTIONS(5400),
    [anon_sym_switch] = ACTIONS(5400),
    [anon_sym_DOT_DOT] = ACTIONS(5400),
    [anon_sym_and] = ACTIONS(5400),
    [anon_sym_or] = ACTIONS(5402),
    [anon_sym_AMP_AMP] = ACTIONS(5400),
    [anon_sym_PIPE_PIPE] = ACTIONS(5400),
    [anon_sym_QMARK_QMARK] = ACTIONS(5400),
    [anon_sym_from] = ACTIONS(5400),
    [anon_sym_into] = ACTIONS(5400),
    [anon_sym_join] = ACTIONS(5400),
    [anon_sym_on] = ACTIONS(5400),
    [anon_sym_equals] = ACTIONS(5400),
    [anon_sym_let] = ACTIONS(5400),
    [anon_sym_orderby] = ACTIONS(5400),
    [anon_sym_group] = ACTIONS(5400),
    [anon_sym_by] = ACTIONS(5400),
    [anon_sym_select] = ACTIONS(5400),
    [anon_sym_as] = ACTIONS(5400),
    [anon_sym_is] = ACTIONS(5400),
    [anon_sym_DASH_GT] = ACTIONS(5400),
    [anon_sym_with] = ACTIONS(5400),
    [aux_sym_preproc_if_token3] = ACTIONS(5400),
    [aux_sym_preproc_else_token1] = ACTIONS(5400),
    [aux_sym_preproc_elif_token1] = ACTIONS(5400),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3640] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter] = STATE(8382),
    [sym__parameter_array] = STATE(8390),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7337),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_identifier] = STATE(6729),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(3640),
    [sym_preproc_endregion] = STATE(3640),
    [sym_preproc_line] = STATE(3640),
    [sym_preproc_pragma] = STATE(3640),
    [sym_preproc_nullable] = STATE(3640),
    [sym_preproc_error] = STATE(3640),
    [sym_preproc_define] = STATE(3640),
    [sym_preproc_undef] = STATE(3640),
    [aux_sym_class_declaration_repeat1] = STATE(3784),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4143),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_LBRACK] = ACTIONS(5212),
    [anon_sym_LPAREN] = ACTIONS(2995),
    [anon_sym_RPAREN] = ACTIONS(2561),
    [anon_sym_ref] = ACTIONS(5216),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_readonly] = ACTIONS(1093),
    [anon_sym_in] = ACTIONS(1093),
    [anon_sym_out] = ACTIONS(1093),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_this] = ACTIONS(1093),
    [anon_sym_scoped] = ACTIONS(5218),
    [anon_sym_params] = ACTIONS(1107),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3641] = {
    [sym_preproc_region] = STATE(3641),
    [sym_preproc_endregion] = STATE(3641),
    [sym_preproc_line] = STATE(3641),
    [sym_preproc_pragma] = STATE(3641),
    [sym_preproc_nullable] = STATE(3641),
    [sym_preproc_error] = STATE(3641),
    [sym_preproc_define] = STATE(3641),
    [sym_preproc_undef] = STATE(3641),
    [anon_sym_SEMI] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4438),
    [anon_sym_COLON] = ACTIONS(4438),
    [anon_sym_COMMA] = ACTIONS(4438),
    [anon_sym_RBRACK] = ACTIONS(4438),
    [anon_sym_LPAREN] = ACTIONS(4438),
    [anon_sym_RPAREN] = ACTIONS(4438),
    [anon_sym_LBRACE] = ACTIONS(4438),
    [anon_sym_RBRACE] = ACTIONS(4438),
    [anon_sym_LT] = ACTIONS(4436),
    [anon_sym_GT] = ACTIONS(4436),
    [anon_sym_in] = ACTIONS(4438),
    [anon_sym_where] = ACTIONS(4438),
    [anon_sym_QMARK] = ACTIONS(4436),
    [anon_sym_BANG] = ACTIONS(4436),
    [anon_sym_PLUS_PLUS] = ACTIONS(4438),
    [anon_sym_DASH_DASH] = ACTIONS(4438),
    [anon_sym_PLUS] = ACTIONS(4436),
    [anon_sym_DASH] = ACTIONS(4436),
    [anon_sym_STAR] = ACTIONS(4438),
    [anon_sym_SLASH] = ACTIONS(4436),
    [anon_sym_PERCENT] = ACTIONS(4438),
    [anon_sym_CARET] = ACTIONS(4438),
    [anon_sym_PIPE] = ACTIONS(4436),
    [anon_sym_AMP] = ACTIONS(4436),
    [anon_sym_LT_LT] = ACTIONS(4438),
    [anon_sym_GT_GT] = ACTIONS(4436),
    [anon_sym_GT_GT_GT] = ACTIONS(4438),
    [anon_sym_EQ_EQ] = ACTIONS(4438),
    [anon_sym_BANG_EQ] = ACTIONS(4438),
    [anon_sym_GT_EQ] = ACTIONS(4438),
    [anon_sym_LT_EQ] = ACTIONS(4438),
    [anon_sym_DOT] = ACTIONS(4436),
    [anon_sym_EQ_GT] = ACTIONS(4438),
    [anon_sym_switch] = ACTIONS(4438),
    [anon_sym_DOT_DOT] = ACTIONS(4438),
    [anon_sym_and] = ACTIONS(4438),
    [anon_sym_or] = ACTIONS(4436),
    [anon_sym_AMP_AMP] = ACTIONS(4438),
    [anon_sym_PIPE_PIPE] = ACTIONS(4438),
    [anon_sym_QMARK_QMARK] = ACTIONS(4438),
    [anon_sym_from] = ACTIONS(4438),
    [anon_sym_join] = ACTIONS(4438),
    [anon_sym_on] = ACTIONS(4438),
    [anon_sym_equals] = ACTIONS(4438),
    [anon_sym_let] = ACTIONS(4438),
    [anon_sym_orderby] = ACTIONS(4438),
    [anon_sym_group] = ACTIONS(4438),
    [anon_sym_by] = ACTIONS(4438),
    [anon_sym_select] = ACTIONS(4438),
    [anon_sym_as] = ACTIONS(4438),
    [anon_sym_is] = ACTIONS(4438),
    [anon_sym_DASH_GT] = ACTIONS(4438),
    [anon_sym_with] = ACTIONS(4438),
    [aux_sym_preproc_if_token3] = ACTIONS(4438),
    [aux_sym_preproc_else_token1] = ACTIONS(4438),
    [aux_sym_preproc_elif_token1] = ACTIONS(4438),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3642] = {
    [sym_preproc_region] = STATE(3642),
    [sym_preproc_endregion] = STATE(3642),
    [sym_preproc_line] = STATE(3642),
    [sym_preproc_pragma] = STATE(3642),
    [sym_preproc_nullable] = STATE(3642),
    [sym_preproc_error] = STATE(3642),
    [sym_preproc_define] = STATE(3642),
    [sym_preproc_undef] = STATE(3642),
    [anon_sym_SEMI] = ACTIONS(2969),
    [anon_sym_LBRACK] = ACTIONS(2969),
    [anon_sym_COLON] = ACTIONS(2969),
    [anon_sym_COMMA] = ACTIONS(2969),
    [anon_sym_RBRACK] = ACTIONS(2969),
    [anon_sym_LPAREN] = ACTIONS(2969),
    [anon_sym_RPAREN] = ACTIONS(2969),
    [anon_sym_RBRACE] = ACTIONS(2969),
    [anon_sym_LT] = ACTIONS(2967),
    [anon_sym_GT] = ACTIONS(2967),
    [anon_sym_in] = ACTIONS(2967),
    [anon_sym_where] = ACTIONS(2969),
    [anon_sym_QMARK] = ACTIONS(2967),
    [anon_sym_BANG] = ACTIONS(2967),
    [anon_sym_PLUS_PLUS] = ACTIONS(2969),
    [anon_sym_DASH_DASH] = ACTIONS(2969),
    [anon_sym_PLUS] = ACTIONS(2967),
    [anon_sym_DASH] = ACTIONS(2967),
    [anon_sym_STAR] = ACTIONS(2969),
    [anon_sym_SLASH] = ACTIONS(2967),
    [anon_sym_PERCENT] = ACTIONS(2969),
    [anon_sym_CARET] = ACTIONS(2969),
    [anon_sym_PIPE] = ACTIONS(2967),
    [anon_sym_AMP] = ACTIONS(2967),
    [anon_sym_LT_LT] = ACTIONS(2969),
    [anon_sym_GT_GT] = ACTIONS(2967),
    [anon_sym_GT_GT_GT] = ACTIONS(2969),
    [anon_sym_EQ_EQ] = ACTIONS(2969),
    [anon_sym_BANG_EQ] = ACTIONS(2969),
    [anon_sym_GT_EQ] = ACTIONS(2969),
    [anon_sym_LT_EQ] = ACTIONS(2969),
    [anon_sym_DOT] = ACTIONS(2967),
    [anon_sym_EQ_GT] = ACTIONS(2969),
    [anon_sym_switch] = ACTIONS(2969),
    [anon_sym_DOT_DOT] = ACTIONS(2969),
    [anon_sym_and] = ACTIONS(2969),
    [anon_sym_or] = ACTIONS(2967),
    [anon_sym_AMP_AMP] = ACTIONS(2969),
    [anon_sym_PIPE_PIPE] = ACTIONS(2969),
    [anon_sym_QMARK_QMARK] = ACTIONS(2969),
    [anon_sym_from] = ACTIONS(2969),
    [anon_sym_into] = ACTIONS(2969),
    [anon_sym_join] = ACTIONS(2969),
    [anon_sym_on] = ACTIONS(2969),
    [anon_sym_equals] = ACTIONS(2969),
    [anon_sym_let] = ACTIONS(2969),
    [anon_sym_orderby] = ACTIONS(2969),
    [anon_sym_group] = ACTIONS(2969),
    [anon_sym_by] = ACTIONS(2969),
    [anon_sym_select] = ACTIONS(2969),
    [anon_sym_as] = ACTIONS(2969),
    [anon_sym_is] = ACTIONS(2969),
    [anon_sym_DASH_GT] = ACTIONS(2969),
    [anon_sym_with] = ACTIONS(2969),
    [aux_sym_preproc_if_token3] = ACTIONS(2969),
    [aux_sym_preproc_else_token1] = ACTIONS(2969),
    [aux_sym_preproc_elif_token1] = ACTIONS(2969),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3643] = {
    [sym_preproc_region] = STATE(3643),
    [sym_preproc_endregion] = STATE(3643),
    [sym_preproc_line] = STATE(3643),
    [sym_preproc_pragma] = STATE(3643),
    [sym_preproc_nullable] = STATE(3643),
    [sym_preproc_error] = STATE(3643),
    [sym_preproc_define] = STATE(3643),
    [sym_preproc_undef] = STATE(3643),
    [anon_sym_SEMI] = ACTIONS(4434),
    [anon_sym_LBRACK] = ACTIONS(4434),
    [anon_sym_COLON] = ACTIONS(4434),
    [anon_sym_COMMA] = ACTIONS(4434),
    [anon_sym_RBRACK] = ACTIONS(4434),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [anon_sym_RPAREN] = ACTIONS(4434),
    [anon_sym_LBRACE] = ACTIONS(4434),
    [anon_sym_RBRACE] = ACTIONS(4434),
    [anon_sym_LT] = ACTIONS(4432),
    [anon_sym_GT] = ACTIONS(4432),
    [anon_sym_in] = ACTIONS(4434),
    [anon_sym_where] = ACTIONS(4434),
    [anon_sym_QMARK] = ACTIONS(4432),
    [anon_sym_BANG] = ACTIONS(4432),
    [anon_sym_PLUS_PLUS] = ACTIONS(4434),
    [anon_sym_DASH_DASH] = ACTIONS(4434),
    [anon_sym_PLUS] = ACTIONS(4432),
    [anon_sym_DASH] = ACTIONS(4432),
    [anon_sym_STAR] = ACTIONS(4434),
    [anon_sym_SLASH] = ACTIONS(4432),
    [anon_sym_PERCENT] = ACTIONS(4434),
    [anon_sym_CARET] = ACTIONS(4434),
    [anon_sym_PIPE] = ACTIONS(4432),
    [anon_sym_AMP] = ACTIONS(4432),
    [anon_sym_LT_LT] = ACTIONS(4434),
    [anon_sym_GT_GT] = ACTIONS(4432),
    [anon_sym_GT_GT_GT] = ACTIONS(4434),
    [anon_sym_EQ_EQ] = ACTIONS(4434),
    [anon_sym_BANG_EQ] = ACTIONS(4434),
    [anon_sym_GT_EQ] = ACTIONS(4434),
    [anon_sym_LT_EQ] = ACTIONS(4434),
    [anon_sym_DOT] = ACTIONS(4432),
    [anon_sym_EQ_GT] = ACTIONS(4434),
    [anon_sym_switch] = ACTIONS(4434),
    [anon_sym_DOT_DOT] = ACTIONS(4434),
    [anon_sym_and] = ACTIONS(4434),
    [anon_sym_or] = ACTIONS(4432),
    [anon_sym_AMP_AMP] = ACTIONS(4434),
    [anon_sym_PIPE_PIPE] = ACTIONS(4434),
    [anon_sym_QMARK_QMARK] = ACTIONS(4434),
    [anon_sym_from] = ACTIONS(4434),
    [anon_sym_join] = ACTIONS(4434),
    [anon_sym_on] = ACTIONS(4434),
    [anon_sym_equals] = ACTIONS(4434),
    [anon_sym_let] = ACTIONS(4434),
    [anon_sym_orderby] = ACTIONS(4434),
    [anon_sym_group] = ACTIONS(4434),
    [anon_sym_by] = ACTIONS(4434),
    [anon_sym_select] = ACTIONS(4434),
    [anon_sym_as] = ACTIONS(4434),
    [anon_sym_is] = ACTIONS(4434),
    [anon_sym_DASH_GT] = ACTIONS(4434),
    [anon_sym_with] = ACTIONS(4434),
    [aux_sym_preproc_if_token3] = ACTIONS(4434),
    [aux_sym_preproc_else_token1] = ACTIONS(4434),
    [aux_sym_preproc_elif_token1] = ACTIONS(4434),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3644] = {
    [sym_preproc_region] = STATE(3644),
    [sym_preproc_endregion] = STATE(3644),
    [sym_preproc_line] = STATE(3644),
    [sym_preproc_pragma] = STATE(3644),
    [sym_preproc_nullable] = STATE(3644),
    [sym_preproc_error] = STATE(3644),
    [sym_preproc_define] = STATE(3644),
    [sym_preproc_undef] = STATE(3644),
    [anon_sym_SEMI] = ACTIONS(2923),
    [anon_sym_LBRACK] = ACTIONS(2923),
    [anon_sym_COLON] = ACTIONS(2923),
    [anon_sym_COMMA] = ACTIONS(2923),
    [anon_sym_RBRACK] = ACTIONS(2923),
    [anon_sym_LPAREN] = ACTIONS(2923),
    [anon_sym_RPAREN] = ACTIONS(2923),
    [anon_sym_RBRACE] = ACTIONS(2923),
    [anon_sym_LT] = ACTIONS(2921),
    [anon_sym_GT] = ACTIONS(2921),
    [anon_sym_in] = ACTIONS(2921),
    [anon_sym_where] = ACTIONS(2923),
    [anon_sym_QMARK] = ACTIONS(2921),
    [anon_sym_BANG] = ACTIONS(2921),
    [anon_sym_PLUS_PLUS] = ACTIONS(2923),
    [anon_sym_DASH_DASH] = ACTIONS(2923),
    [anon_sym_PLUS] = ACTIONS(2921),
    [anon_sym_DASH] = ACTIONS(2921),
    [anon_sym_STAR] = ACTIONS(2923),
    [anon_sym_SLASH] = ACTIONS(2921),
    [anon_sym_PERCENT] = ACTIONS(2923),
    [anon_sym_CARET] = ACTIONS(2923),
    [anon_sym_PIPE] = ACTIONS(2921),
    [anon_sym_AMP] = ACTIONS(2921),
    [anon_sym_LT_LT] = ACTIONS(2923),
    [anon_sym_GT_GT] = ACTIONS(2921),
    [anon_sym_GT_GT_GT] = ACTIONS(2923),
    [anon_sym_EQ_EQ] = ACTIONS(2923),
    [anon_sym_BANG_EQ] = ACTIONS(2923),
    [anon_sym_GT_EQ] = ACTIONS(2923),
    [anon_sym_LT_EQ] = ACTIONS(2923),
    [anon_sym_DOT] = ACTIONS(2921),
    [anon_sym_EQ_GT] = ACTIONS(2923),
    [anon_sym_switch] = ACTIONS(2923),
    [anon_sym_DOT_DOT] = ACTIONS(2923),
    [anon_sym_and] = ACTIONS(2923),
    [anon_sym_or] = ACTIONS(2921),
    [anon_sym_AMP_AMP] = ACTIONS(2923),
    [anon_sym_PIPE_PIPE] = ACTIONS(2923),
    [anon_sym_QMARK_QMARK] = ACTIONS(2923),
    [anon_sym_from] = ACTIONS(2923),
    [anon_sym_into] = ACTIONS(2923),
    [anon_sym_join] = ACTIONS(2923),
    [anon_sym_on] = ACTIONS(2923),
    [anon_sym_equals] = ACTIONS(2923),
    [anon_sym_let] = ACTIONS(2923),
    [anon_sym_orderby] = ACTIONS(2923),
    [anon_sym_group] = ACTIONS(2923),
    [anon_sym_by] = ACTIONS(2923),
    [anon_sym_select] = ACTIONS(2923),
    [anon_sym_as] = ACTIONS(2923),
    [anon_sym_is] = ACTIONS(2923),
    [anon_sym_DASH_GT] = ACTIONS(2923),
    [anon_sym_with] = ACTIONS(2923),
    [aux_sym_preproc_if_token3] = ACTIONS(2923),
    [aux_sym_preproc_else_token1] = ACTIONS(2923),
    [aux_sym_preproc_elif_token1] = ACTIONS(2923),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3645] = {
    [sym_preproc_region] = STATE(3645),
    [sym_preproc_endregion] = STATE(3645),
    [sym_preproc_line] = STATE(3645),
    [sym_preproc_pragma] = STATE(3645),
    [sym_preproc_nullable] = STATE(3645),
    [sym_preproc_error] = STATE(3645),
    [sym_preproc_define] = STATE(3645),
    [sym_preproc_undef] = STATE(3645),
    [anon_sym_SEMI] = ACTIONS(5404),
    [anon_sym_LBRACK] = ACTIONS(5404),
    [anon_sym_COLON] = ACTIONS(5404),
    [anon_sym_COMMA] = ACTIONS(5404),
    [anon_sym_RBRACK] = ACTIONS(5404),
    [anon_sym_LPAREN] = ACTIONS(5404),
    [anon_sym_RPAREN] = ACTIONS(5404),
    [anon_sym_RBRACE] = ACTIONS(5404),
    [anon_sym_LT] = ACTIONS(5406),
    [anon_sym_GT] = ACTIONS(5406),
    [anon_sym_in] = ACTIONS(5406),
    [anon_sym_where] = ACTIONS(5404),
    [anon_sym_QMARK] = ACTIONS(5406),
    [anon_sym_BANG] = ACTIONS(5406),
    [anon_sym_PLUS_PLUS] = ACTIONS(5404),
    [anon_sym_DASH_DASH] = ACTIONS(5404),
    [anon_sym_PLUS] = ACTIONS(5406),
    [anon_sym_DASH] = ACTIONS(5406),
    [anon_sym_STAR] = ACTIONS(5404),
    [anon_sym_SLASH] = ACTIONS(5406),
    [anon_sym_PERCENT] = ACTIONS(5404),
    [anon_sym_CARET] = ACTIONS(5404),
    [anon_sym_PIPE] = ACTIONS(5406),
    [anon_sym_AMP] = ACTIONS(5406),
    [anon_sym_LT_LT] = ACTIONS(5404),
    [anon_sym_GT_GT] = ACTIONS(5406),
    [anon_sym_GT_GT_GT] = ACTIONS(5404),
    [anon_sym_EQ_EQ] = ACTIONS(5404),
    [anon_sym_BANG_EQ] = ACTIONS(5404),
    [anon_sym_GT_EQ] = ACTIONS(5404),
    [anon_sym_LT_EQ] = ACTIONS(5404),
    [anon_sym_DOT] = ACTIONS(5406),
    [anon_sym_EQ_GT] = ACTIONS(5404),
    [anon_sym_switch] = ACTIONS(5404),
    [anon_sym_DOT_DOT] = ACTIONS(5404),
    [anon_sym_and] = ACTIONS(5404),
    [anon_sym_or] = ACTIONS(5406),
    [anon_sym_AMP_AMP] = ACTIONS(5404),
    [anon_sym_PIPE_PIPE] = ACTIONS(5404),
    [anon_sym_QMARK_QMARK] = ACTIONS(5404),
    [anon_sym_from] = ACTIONS(5404),
    [anon_sym_into] = ACTIONS(5404),
    [anon_sym_join] = ACTIONS(5404),
    [anon_sym_on] = ACTIONS(5404),
    [anon_sym_equals] = ACTIONS(5404),
    [anon_sym_let] = ACTIONS(5404),
    [anon_sym_orderby] = ACTIONS(5404),
    [anon_sym_group] = ACTIONS(5404),
    [anon_sym_by] = ACTIONS(5404),
    [anon_sym_select] = ACTIONS(5404),
    [anon_sym_as] = ACTIONS(5404),
    [anon_sym_is] = ACTIONS(5404),
    [anon_sym_DASH_GT] = ACTIONS(5404),
    [anon_sym_with] = ACTIONS(5404),
    [aux_sym_preproc_if_token3] = ACTIONS(5404),
    [aux_sym_preproc_else_token1] = ACTIONS(5404),
    [aux_sym_preproc_elif_token1] = ACTIONS(5404),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3646] = {
    [sym_preproc_region] = STATE(3646),
    [sym_preproc_endregion] = STATE(3646),
    [sym_preproc_line] = STATE(3646),
    [sym_preproc_pragma] = STATE(3646),
    [sym_preproc_nullable] = STATE(3646),
    [sym_preproc_error] = STATE(3646),
    [sym_preproc_define] = STATE(3646),
    [sym_preproc_undef] = STATE(3646),
    [anon_sym_SEMI] = ACTIONS(5408),
    [anon_sym_LBRACK] = ACTIONS(5408),
    [anon_sym_COLON] = ACTIONS(5408),
    [anon_sym_COMMA] = ACTIONS(5408),
    [anon_sym_RBRACK] = ACTIONS(5408),
    [anon_sym_LPAREN] = ACTIONS(5408),
    [anon_sym_RPAREN] = ACTIONS(5408),
    [anon_sym_RBRACE] = ACTIONS(5408),
    [anon_sym_LT] = ACTIONS(5410),
    [anon_sym_GT] = ACTIONS(5410),
    [anon_sym_in] = ACTIONS(5410),
    [anon_sym_where] = ACTIONS(5408),
    [anon_sym_QMARK] = ACTIONS(5410),
    [anon_sym_BANG] = ACTIONS(5410),
    [anon_sym_PLUS_PLUS] = ACTIONS(5408),
    [anon_sym_DASH_DASH] = ACTIONS(5408),
    [anon_sym_PLUS] = ACTIONS(5410),
    [anon_sym_DASH] = ACTIONS(5410),
    [anon_sym_STAR] = ACTIONS(5408),
    [anon_sym_SLASH] = ACTIONS(5410),
    [anon_sym_PERCENT] = ACTIONS(5408),
    [anon_sym_CARET] = ACTIONS(5408),
    [anon_sym_PIPE] = ACTIONS(5410),
    [anon_sym_AMP] = ACTIONS(5410),
    [anon_sym_LT_LT] = ACTIONS(5408),
    [anon_sym_GT_GT] = ACTIONS(5410),
    [anon_sym_GT_GT_GT] = ACTIONS(5408),
    [anon_sym_EQ_EQ] = ACTIONS(5408),
    [anon_sym_BANG_EQ] = ACTIONS(5408),
    [anon_sym_GT_EQ] = ACTIONS(5408),
    [anon_sym_LT_EQ] = ACTIONS(5408),
    [anon_sym_DOT] = ACTIONS(5410),
    [anon_sym_EQ_GT] = ACTIONS(5408),
    [anon_sym_switch] = ACTIONS(5408),
    [anon_sym_DOT_DOT] = ACTIONS(5408),
    [anon_sym_and] = ACTIONS(5408),
    [anon_sym_or] = ACTIONS(5410),
    [anon_sym_AMP_AMP] = ACTIONS(5408),
    [anon_sym_PIPE_PIPE] = ACTIONS(5408),
    [anon_sym_QMARK_QMARK] = ACTIONS(5408),
    [anon_sym_from] = ACTIONS(5408),
    [anon_sym_into] = ACTIONS(5408),
    [anon_sym_join] = ACTIONS(5408),
    [anon_sym_on] = ACTIONS(5408),
    [anon_sym_equals] = ACTIONS(5408),
    [anon_sym_let] = ACTIONS(5408),
    [anon_sym_orderby] = ACTIONS(5408),
    [anon_sym_group] = ACTIONS(5408),
    [anon_sym_by] = ACTIONS(5408),
    [anon_sym_select] = ACTIONS(5408),
    [anon_sym_as] = ACTIONS(5408),
    [anon_sym_is] = ACTIONS(5408),
    [anon_sym_DASH_GT] = ACTIONS(5408),
    [anon_sym_with] = ACTIONS(5408),
    [aux_sym_preproc_if_token3] = ACTIONS(5408),
    [aux_sym_preproc_else_token1] = ACTIONS(5408),
    [aux_sym_preproc_elif_token1] = ACTIONS(5408),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3647] = {
    [sym_preproc_region] = STATE(3647),
    [sym_preproc_endregion] = STATE(3647),
    [sym_preproc_line] = STATE(3647),
    [sym_preproc_pragma] = STATE(3647),
    [sym_preproc_nullable] = STATE(3647),
    [sym_preproc_error] = STATE(3647),
    [sym_preproc_define] = STATE(3647),
    [sym_preproc_undef] = STATE(3647),
    [anon_sym_SEMI] = ACTIONS(5412),
    [anon_sym_LBRACK] = ACTIONS(5412),
    [anon_sym_COLON] = ACTIONS(5412),
    [anon_sym_COMMA] = ACTIONS(5412),
    [anon_sym_RBRACK] = ACTIONS(5412),
    [anon_sym_LPAREN] = ACTIONS(5412),
    [anon_sym_RPAREN] = ACTIONS(5412),
    [anon_sym_RBRACE] = ACTIONS(5412),
    [anon_sym_LT] = ACTIONS(5414),
    [anon_sym_GT] = ACTIONS(5414),
    [anon_sym_in] = ACTIONS(5414),
    [anon_sym_where] = ACTIONS(5412),
    [anon_sym_QMARK] = ACTIONS(5414),
    [anon_sym_BANG] = ACTIONS(5414),
    [anon_sym_PLUS_PLUS] = ACTIONS(5412),
    [anon_sym_DASH_DASH] = ACTIONS(5412),
    [anon_sym_PLUS] = ACTIONS(5414),
    [anon_sym_DASH] = ACTIONS(5414),
    [anon_sym_STAR] = ACTIONS(5412),
    [anon_sym_SLASH] = ACTIONS(5414),
    [anon_sym_PERCENT] = ACTIONS(5412),
    [anon_sym_CARET] = ACTIONS(5412),
    [anon_sym_PIPE] = ACTIONS(5414),
    [anon_sym_AMP] = ACTIONS(5414),
    [anon_sym_LT_LT] = ACTIONS(5412),
    [anon_sym_GT_GT] = ACTIONS(5414),
    [anon_sym_GT_GT_GT] = ACTIONS(5412),
    [anon_sym_EQ_EQ] = ACTIONS(5412),
    [anon_sym_BANG_EQ] = ACTIONS(5412),
    [anon_sym_GT_EQ] = ACTIONS(5412),
    [anon_sym_LT_EQ] = ACTIONS(5412),
    [anon_sym_DOT] = ACTIONS(5414),
    [anon_sym_EQ_GT] = ACTIONS(5412),
    [anon_sym_switch] = ACTIONS(5412),
    [anon_sym_DOT_DOT] = ACTIONS(5412),
    [anon_sym_and] = ACTIONS(5412),
    [anon_sym_or] = ACTIONS(5414),
    [anon_sym_AMP_AMP] = ACTIONS(5412),
    [anon_sym_PIPE_PIPE] = ACTIONS(5412),
    [anon_sym_QMARK_QMARK] = ACTIONS(5412),
    [anon_sym_from] = ACTIONS(5412),
    [anon_sym_into] = ACTIONS(5412),
    [anon_sym_join] = ACTIONS(5412),
    [anon_sym_on] = ACTIONS(5412),
    [anon_sym_equals] = ACTIONS(5412),
    [anon_sym_let] = ACTIONS(5412),
    [anon_sym_orderby] = ACTIONS(5412),
    [anon_sym_group] = ACTIONS(5412),
    [anon_sym_by] = ACTIONS(5412),
    [anon_sym_select] = ACTIONS(5412),
    [anon_sym_as] = ACTIONS(5412),
    [anon_sym_is] = ACTIONS(5412),
    [anon_sym_DASH_GT] = ACTIONS(5412),
    [anon_sym_with] = ACTIONS(5412),
    [aux_sym_preproc_if_token3] = ACTIONS(5412),
    [aux_sym_preproc_else_token1] = ACTIONS(5412),
    [aux_sym_preproc_elif_token1] = ACTIONS(5412),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3648] = {
    [sym_preproc_region] = STATE(3648),
    [sym_preproc_endregion] = STATE(3648),
    [sym_preproc_line] = STATE(3648),
    [sym_preproc_pragma] = STATE(3648),
    [sym_preproc_nullable] = STATE(3648),
    [sym_preproc_error] = STATE(3648),
    [sym_preproc_define] = STATE(3648),
    [sym_preproc_undef] = STATE(3648),
    [anon_sym_SEMI] = ACTIONS(4527),
    [anon_sym_LBRACK] = ACTIONS(4527),
    [anon_sym_COLON] = ACTIONS(4527),
    [anon_sym_COMMA] = ACTIONS(4527),
    [anon_sym_RBRACK] = ACTIONS(4527),
    [anon_sym_LPAREN] = ACTIONS(4527),
    [anon_sym_RPAREN] = ACTIONS(4527),
    [anon_sym_LBRACE] = ACTIONS(4527),
    [anon_sym_RBRACE] = ACTIONS(4527),
    [anon_sym_LT] = ACTIONS(4525),
    [anon_sym_GT] = ACTIONS(4525),
    [anon_sym_in] = ACTIONS(4527),
    [anon_sym_where] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4525),
    [anon_sym_BANG] = ACTIONS(4525),
    [anon_sym_PLUS_PLUS] = ACTIONS(4527),
    [anon_sym_DASH_DASH] = ACTIONS(4527),
    [anon_sym_PLUS] = ACTIONS(4525),
    [anon_sym_DASH] = ACTIONS(4525),
    [anon_sym_STAR] = ACTIONS(4527),
    [anon_sym_SLASH] = ACTIONS(4525),
    [anon_sym_PERCENT] = ACTIONS(4527),
    [anon_sym_CARET] = ACTIONS(4527),
    [anon_sym_PIPE] = ACTIONS(4525),
    [anon_sym_AMP] = ACTIONS(4525),
    [anon_sym_LT_LT] = ACTIONS(4527),
    [anon_sym_GT_GT] = ACTIONS(4525),
    [anon_sym_GT_GT_GT] = ACTIONS(4527),
    [anon_sym_EQ_EQ] = ACTIONS(4527),
    [anon_sym_BANG_EQ] = ACTIONS(4527),
    [anon_sym_GT_EQ] = ACTIONS(4527),
    [anon_sym_LT_EQ] = ACTIONS(4527),
    [anon_sym_DOT] = ACTIONS(4525),
    [anon_sym_EQ_GT] = ACTIONS(4527),
    [anon_sym_switch] = ACTIONS(4527),
    [anon_sym_DOT_DOT] = ACTIONS(4527),
    [anon_sym_and] = ACTIONS(4527),
    [anon_sym_or] = ACTIONS(4525),
    [anon_sym_AMP_AMP] = ACTIONS(4527),
    [anon_sym_PIPE_PIPE] = ACTIONS(4527),
    [anon_sym_QMARK_QMARK] = ACTIONS(4527),
    [anon_sym_from] = ACTIONS(4527),
    [anon_sym_join] = ACTIONS(4527),
    [anon_sym_on] = ACTIONS(4527),
    [anon_sym_equals] = ACTIONS(4527),
    [anon_sym_let] = ACTIONS(4527),
    [anon_sym_orderby] = ACTIONS(4527),
    [anon_sym_group] = ACTIONS(4527),
    [anon_sym_by] = ACTIONS(4527),
    [anon_sym_select] = ACTIONS(4527),
    [anon_sym_as] = ACTIONS(4527),
    [anon_sym_is] = ACTIONS(4527),
    [anon_sym_DASH_GT] = ACTIONS(4527),
    [anon_sym_with] = ACTIONS(4527),
    [aux_sym_preproc_if_token3] = ACTIONS(4527),
    [aux_sym_preproc_else_token1] = ACTIONS(4527),
    [aux_sym_preproc_elif_token1] = ACTIONS(4527),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3649] = {
    [sym_preproc_region] = STATE(3649),
    [sym_preproc_endregion] = STATE(3649),
    [sym_preproc_line] = STATE(3649),
    [sym_preproc_pragma] = STATE(3649),
    [sym_preproc_nullable] = STATE(3649),
    [sym_preproc_error] = STATE(3649),
    [sym_preproc_define] = STATE(3649),
    [sym_preproc_undef] = STATE(3649),
    [anon_sym_SEMI] = ACTIONS(5416),
    [anon_sym_LBRACK] = ACTIONS(5416),
    [anon_sym_COLON] = ACTIONS(5416),
    [anon_sym_COMMA] = ACTIONS(5416),
    [anon_sym_RBRACK] = ACTIONS(5416),
    [anon_sym_LPAREN] = ACTIONS(5416),
    [anon_sym_RPAREN] = ACTIONS(5416),
    [anon_sym_RBRACE] = ACTIONS(5416),
    [anon_sym_LT] = ACTIONS(5418),
    [anon_sym_GT] = ACTIONS(5418),
    [anon_sym_in] = ACTIONS(5418),
    [anon_sym_where] = ACTIONS(5416),
    [anon_sym_QMARK] = ACTIONS(5418),
    [anon_sym_BANG] = ACTIONS(5418),
    [anon_sym_PLUS_PLUS] = ACTIONS(5416),
    [anon_sym_DASH_DASH] = ACTIONS(5416),
    [anon_sym_PLUS] = ACTIONS(5418),
    [anon_sym_DASH] = ACTIONS(5418),
    [anon_sym_STAR] = ACTIONS(5416),
    [anon_sym_SLASH] = ACTIONS(5418),
    [anon_sym_PERCENT] = ACTIONS(5416),
    [anon_sym_CARET] = ACTIONS(5416),
    [anon_sym_PIPE] = ACTIONS(5418),
    [anon_sym_AMP] = ACTIONS(5418),
    [anon_sym_LT_LT] = ACTIONS(5416),
    [anon_sym_GT_GT] = ACTIONS(5418),
    [anon_sym_GT_GT_GT] = ACTIONS(5416),
    [anon_sym_EQ_EQ] = ACTIONS(5416),
    [anon_sym_BANG_EQ] = ACTIONS(5416),
    [anon_sym_GT_EQ] = ACTIONS(5416),
    [anon_sym_LT_EQ] = ACTIONS(5416),
    [anon_sym_DOT] = ACTIONS(5418),
    [anon_sym_EQ_GT] = ACTIONS(5416),
    [anon_sym_switch] = ACTIONS(5416),
    [anon_sym_DOT_DOT] = ACTIONS(5416),
    [anon_sym_and] = ACTIONS(5416),
    [anon_sym_or] = ACTIONS(5418),
    [anon_sym_AMP_AMP] = ACTIONS(5416),
    [anon_sym_PIPE_PIPE] = ACTIONS(5416),
    [anon_sym_QMARK_QMARK] = ACTIONS(5416),
    [anon_sym_from] = ACTIONS(5416),
    [anon_sym_into] = ACTIONS(5416),
    [anon_sym_join] = ACTIONS(5416),
    [anon_sym_on] = ACTIONS(5416),
    [anon_sym_equals] = ACTIONS(5416),
    [anon_sym_let] = ACTIONS(5416),
    [anon_sym_orderby] = ACTIONS(5416),
    [anon_sym_group] = ACTIONS(5416),
    [anon_sym_by] = ACTIONS(5416),
    [anon_sym_select] = ACTIONS(5416),
    [anon_sym_as] = ACTIONS(5416),
    [anon_sym_is] = ACTIONS(5416),
    [anon_sym_DASH_GT] = ACTIONS(5416),
    [anon_sym_with] = ACTIONS(5416),
    [aux_sym_preproc_if_token3] = ACTIONS(5416),
    [aux_sym_preproc_else_token1] = ACTIONS(5416),
    [aux_sym_preproc_elif_token1] = ACTIONS(5416),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3650] = {
    [sym_preproc_region] = STATE(3650),
    [sym_preproc_endregion] = STATE(3650),
    [sym_preproc_line] = STATE(3650),
    [sym_preproc_pragma] = STATE(3650),
    [sym_preproc_nullable] = STATE(3650),
    [sym_preproc_error] = STATE(3650),
    [sym_preproc_define] = STATE(3650),
    [sym_preproc_undef] = STATE(3650),
    [anon_sym_SEMI] = ACTIONS(5420),
    [anon_sym_LBRACK] = ACTIONS(5420),
    [anon_sym_COLON] = ACTIONS(5420),
    [anon_sym_COMMA] = ACTIONS(5420),
    [anon_sym_RBRACK] = ACTIONS(5420),
    [anon_sym_LPAREN] = ACTIONS(5420),
    [anon_sym_RPAREN] = ACTIONS(5420),
    [anon_sym_RBRACE] = ACTIONS(5420),
    [anon_sym_LT] = ACTIONS(5422),
    [anon_sym_GT] = ACTIONS(5422),
    [anon_sym_in] = ACTIONS(5422),
    [anon_sym_where] = ACTIONS(5420),
    [anon_sym_QMARK] = ACTIONS(5422),
    [anon_sym_BANG] = ACTIONS(5422),
    [anon_sym_PLUS_PLUS] = ACTIONS(5420),
    [anon_sym_DASH_DASH] = ACTIONS(5420),
    [anon_sym_PLUS] = ACTIONS(5422),
    [anon_sym_DASH] = ACTIONS(5422),
    [anon_sym_STAR] = ACTIONS(5420),
    [anon_sym_SLASH] = ACTIONS(5422),
    [anon_sym_PERCENT] = ACTIONS(5420),
    [anon_sym_CARET] = ACTIONS(5420),
    [anon_sym_PIPE] = ACTIONS(5422),
    [anon_sym_AMP] = ACTIONS(5422),
    [anon_sym_LT_LT] = ACTIONS(5420),
    [anon_sym_GT_GT] = ACTIONS(5422),
    [anon_sym_GT_GT_GT] = ACTIONS(5420),
    [anon_sym_EQ_EQ] = ACTIONS(5420),
    [anon_sym_BANG_EQ] = ACTIONS(5420),
    [anon_sym_GT_EQ] = ACTIONS(5420),
    [anon_sym_LT_EQ] = ACTIONS(5420),
    [anon_sym_DOT] = ACTIONS(5422),
    [anon_sym_EQ_GT] = ACTIONS(5420),
    [anon_sym_switch] = ACTIONS(5420),
    [anon_sym_DOT_DOT] = ACTIONS(5420),
    [anon_sym_and] = ACTIONS(5420),
    [anon_sym_or] = ACTIONS(5422),
    [anon_sym_AMP_AMP] = ACTIONS(5420),
    [anon_sym_PIPE_PIPE] = ACTIONS(5420),
    [anon_sym_QMARK_QMARK] = ACTIONS(5420),
    [anon_sym_from] = ACTIONS(5420),
    [anon_sym_into] = ACTIONS(5420),
    [anon_sym_join] = ACTIONS(5420),
    [anon_sym_on] = ACTIONS(5420),
    [anon_sym_equals] = ACTIONS(5420),
    [anon_sym_let] = ACTIONS(5420),
    [anon_sym_orderby] = ACTIONS(5420),
    [anon_sym_group] = ACTIONS(5420),
    [anon_sym_by] = ACTIONS(5420),
    [anon_sym_select] = ACTIONS(5420),
    [anon_sym_as] = ACTIONS(5420),
    [anon_sym_is] = ACTIONS(5420),
    [anon_sym_DASH_GT] = ACTIONS(5420),
    [anon_sym_with] = ACTIONS(5420),
    [aux_sym_preproc_if_token3] = ACTIONS(5420),
    [aux_sym_preproc_else_token1] = ACTIONS(5420),
    [aux_sym_preproc_elif_token1] = ACTIONS(5420),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3651] = {
    [sym_preproc_region] = STATE(3651),
    [sym_preproc_endregion] = STATE(3651),
    [sym_preproc_line] = STATE(3651),
    [sym_preproc_pragma] = STATE(3651),
    [sym_preproc_nullable] = STATE(3651),
    [sym_preproc_error] = STATE(3651),
    [sym_preproc_define] = STATE(3651),
    [sym_preproc_undef] = STATE(3651),
    [anon_sym_SEMI] = ACTIONS(5424),
    [anon_sym_LBRACK] = ACTIONS(5424),
    [anon_sym_COLON] = ACTIONS(5424),
    [anon_sym_COMMA] = ACTIONS(5424),
    [anon_sym_RBRACK] = ACTIONS(5424),
    [anon_sym_LPAREN] = ACTIONS(5424),
    [anon_sym_RPAREN] = ACTIONS(5424),
    [anon_sym_RBRACE] = ACTIONS(5424),
    [anon_sym_LT] = ACTIONS(5426),
    [anon_sym_GT] = ACTIONS(5426),
    [anon_sym_in] = ACTIONS(5426),
    [anon_sym_where] = ACTIONS(5424),
    [anon_sym_QMARK] = ACTIONS(5426),
    [anon_sym_BANG] = ACTIONS(5426),
    [anon_sym_PLUS_PLUS] = ACTIONS(5424),
    [anon_sym_DASH_DASH] = ACTIONS(5424),
    [anon_sym_PLUS] = ACTIONS(5426),
    [anon_sym_DASH] = ACTIONS(5426),
    [anon_sym_STAR] = ACTIONS(5424),
    [anon_sym_SLASH] = ACTIONS(5426),
    [anon_sym_PERCENT] = ACTIONS(5424),
    [anon_sym_CARET] = ACTIONS(5424),
    [anon_sym_PIPE] = ACTIONS(5426),
    [anon_sym_AMP] = ACTIONS(5426),
    [anon_sym_LT_LT] = ACTIONS(5424),
    [anon_sym_GT_GT] = ACTIONS(5426),
    [anon_sym_GT_GT_GT] = ACTIONS(5424),
    [anon_sym_EQ_EQ] = ACTIONS(5424),
    [anon_sym_BANG_EQ] = ACTIONS(5424),
    [anon_sym_GT_EQ] = ACTIONS(5424),
    [anon_sym_LT_EQ] = ACTIONS(5424),
    [anon_sym_DOT] = ACTIONS(5426),
    [anon_sym_EQ_GT] = ACTIONS(5424),
    [anon_sym_switch] = ACTIONS(5424),
    [anon_sym_DOT_DOT] = ACTIONS(5424),
    [anon_sym_and] = ACTIONS(5424),
    [anon_sym_or] = ACTIONS(5426),
    [anon_sym_AMP_AMP] = ACTIONS(5424),
    [anon_sym_PIPE_PIPE] = ACTIONS(5424),
    [anon_sym_QMARK_QMARK] = ACTIONS(5424),
    [anon_sym_from] = ACTIONS(5424),
    [anon_sym_into] = ACTIONS(5424),
    [anon_sym_join] = ACTIONS(5424),
    [anon_sym_on] = ACTIONS(5424),
    [anon_sym_equals] = ACTIONS(5424),
    [anon_sym_let] = ACTIONS(5424),
    [anon_sym_orderby] = ACTIONS(5424),
    [anon_sym_group] = ACTIONS(5424),
    [anon_sym_by] = ACTIONS(5424),
    [anon_sym_select] = ACTIONS(5424),
    [anon_sym_as] = ACTIONS(5424),
    [anon_sym_is] = ACTIONS(5424),
    [anon_sym_DASH_GT] = ACTIONS(5424),
    [anon_sym_with] = ACTIONS(5424),
    [aux_sym_preproc_if_token3] = ACTIONS(5424),
    [aux_sym_preproc_else_token1] = ACTIONS(5424),
    [aux_sym_preproc_elif_token1] = ACTIONS(5424),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3652] = {
    [sym_preproc_region] = STATE(3652),
    [sym_preproc_endregion] = STATE(3652),
    [sym_preproc_line] = STATE(3652),
    [sym_preproc_pragma] = STATE(3652),
    [sym_preproc_nullable] = STATE(3652),
    [sym_preproc_error] = STATE(3652),
    [sym_preproc_define] = STATE(3652),
    [sym_preproc_undef] = STATE(3652),
    [anon_sym_SEMI] = ACTIONS(4404),
    [anon_sym_LBRACK] = ACTIONS(4404),
    [anon_sym_COLON] = ACTIONS(4404),
    [anon_sym_COMMA] = ACTIONS(4404),
    [anon_sym_RBRACK] = ACTIONS(4404),
    [anon_sym_LPAREN] = ACTIONS(4404),
    [anon_sym_RPAREN] = ACTIONS(4404),
    [anon_sym_LBRACE] = ACTIONS(4404),
    [anon_sym_RBRACE] = ACTIONS(4404),
    [anon_sym_LT] = ACTIONS(4402),
    [anon_sym_GT] = ACTIONS(4402),
    [anon_sym_in] = ACTIONS(4404),
    [anon_sym_where] = ACTIONS(4404),
    [anon_sym_QMARK] = ACTIONS(4402),
    [anon_sym_BANG] = ACTIONS(4402),
    [anon_sym_PLUS_PLUS] = ACTIONS(4404),
    [anon_sym_DASH_DASH] = ACTIONS(4404),
    [anon_sym_PLUS] = ACTIONS(4402),
    [anon_sym_DASH] = ACTIONS(4402),
    [anon_sym_STAR] = ACTIONS(4404),
    [anon_sym_SLASH] = ACTIONS(4402),
    [anon_sym_PERCENT] = ACTIONS(4404),
    [anon_sym_CARET] = ACTIONS(4404),
    [anon_sym_PIPE] = ACTIONS(4402),
    [anon_sym_AMP] = ACTIONS(4402),
    [anon_sym_LT_LT] = ACTIONS(4404),
    [anon_sym_GT_GT] = ACTIONS(4402),
    [anon_sym_GT_GT_GT] = ACTIONS(4404),
    [anon_sym_EQ_EQ] = ACTIONS(4404),
    [anon_sym_BANG_EQ] = ACTIONS(4404),
    [anon_sym_GT_EQ] = ACTIONS(4404),
    [anon_sym_LT_EQ] = ACTIONS(4404),
    [anon_sym_DOT] = ACTIONS(4402),
    [anon_sym_EQ_GT] = ACTIONS(4404),
    [anon_sym_switch] = ACTIONS(4404),
    [anon_sym_DOT_DOT] = ACTIONS(4404),
    [anon_sym_and] = ACTIONS(4404),
    [anon_sym_or] = ACTIONS(4402),
    [anon_sym_AMP_AMP] = ACTIONS(4404),
    [anon_sym_PIPE_PIPE] = ACTIONS(4404),
    [anon_sym_QMARK_QMARK] = ACTIONS(4404),
    [anon_sym_from] = ACTIONS(4404),
    [anon_sym_join] = ACTIONS(4404),
    [anon_sym_on] = ACTIONS(4404),
    [anon_sym_equals] = ACTIONS(4404),
    [anon_sym_let] = ACTIONS(4404),
    [anon_sym_orderby] = ACTIONS(4404),
    [anon_sym_group] = ACTIONS(4404),
    [anon_sym_by] = ACTIONS(4404),
    [anon_sym_select] = ACTIONS(4404),
    [anon_sym_as] = ACTIONS(4404),
    [anon_sym_is] = ACTIONS(4404),
    [anon_sym_DASH_GT] = ACTIONS(4404),
    [anon_sym_with] = ACTIONS(4404),
    [aux_sym_preproc_if_token3] = ACTIONS(4404),
    [aux_sym_preproc_else_token1] = ACTIONS(4404),
    [aux_sym_preproc_elif_token1] = ACTIONS(4404),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3653] = {
    [sym_preproc_region] = STATE(3653),
    [sym_preproc_endregion] = STATE(3653),
    [sym_preproc_line] = STATE(3653),
    [sym_preproc_pragma] = STATE(3653),
    [sym_preproc_nullable] = STATE(3653),
    [sym_preproc_error] = STATE(3653),
    [sym_preproc_define] = STATE(3653),
    [sym_preproc_undef] = STATE(3653),
    [anon_sym_SEMI] = ACTIONS(4106),
    [anon_sym_LBRACK] = ACTIONS(4106),
    [anon_sym_COLON] = ACTIONS(4106),
    [anon_sym_COMMA] = ACTIONS(4106),
    [anon_sym_RBRACK] = ACTIONS(4106),
    [anon_sym_LPAREN] = ACTIONS(4106),
    [anon_sym_RPAREN] = ACTIONS(4106),
    [anon_sym_LBRACE] = ACTIONS(4106),
    [anon_sym_RBRACE] = ACTIONS(4106),
    [anon_sym_LT] = ACTIONS(4099),
    [anon_sym_GT] = ACTIONS(4099),
    [anon_sym_in] = ACTIONS(4106),
    [anon_sym_where] = ACTIONS(4106),
    [anon_sym_QMARK] = ACTIONS(4099),
    [anon_sym_BANG] = ACTIONS(4099),
    [anon_sym_PLUS_PLUS] = ACTIONS(4106),
    [anon_sym_DASH_DASH] = ACTIONS(4106),
    [anon_sym_PLUS] = ACTIONS(4099),
    [anon_sym_DASH] = ACTIONS(4099),
    [anon_sym_STAR] = ACTIONS(4106),
    [anon_sym_SLASH] = ACTIONS(4099),
    [anon_sym_PERCENT] = ACTIONS(4106),
    [anon_sym_CARET] = ACTIONS(4106),
    [anon_sym_PIPE] = ACTIONS(4099),
    [anon_sym_AMP] = ACTIONS(4099),
    [anon_sym_LT_LT] = ACTIONS(4106),
    [anon_sym_GT_GT] = ACTIONS(4099),
    [anon_sym_GT_GT_GT] = ACTIONS(4106),
    [anon_sym_EQ_EQ] = ACTIONS(4106),
    [anon_sym_BANG_EQ] = ACTIONS(4106),
    [anon_sym_GT_EQ] = ACTIONS(4106),
    [anon_sym_LT_EQ] = ACTIONS(4106),
    [anon_sym_DOT] = ACTIONS(4099),
    [anon_sym_EQ_GT] = ACTIONS(4106),
    [anon_sym_switch] = ACTIONS(4106),
    [anon_sym_DOT_DOT] = ACTIONS(4106),
    [anon_sym_and] = ACTIONS(4106),
    [anon_sym_or] = ACTIONS(4099),
    [anon_sym_AMP_AMP] = ACTIONS(4106),
    [anon_sym_PIPE_PIPE] = ACTIONS(4106),
    [anon_sym_QMARK_QMARK] = ACTIONS(4106),
    [anon_sym_from] = ACTIONS(4106),
    [anon_sym_join] = ACTIONS(4106),
    [anon_sym_on] = ACTIONS(4106),
    [anon_sym_equals] = ACTIONS(4106),
    [anon_sym_let] = ACTIONS(4106),
    [anon_sym_orderby] = ACTIONS(4106),
    [anon_sym_group] = ACTIONS(4106),
    [anon_sym_by] = ACTIONS(4106),
    [anon_sym_select] = ACTIONS(4106),
    [anon_sym_as] = ACTIONS(4106),
    [anon_sym_is] = ACTIONS(4106),
    [anon_sym_DASH_GT] = ACTIONS(4106),
    [anon_sym_with] = ACTIONS(4106),
    [aux_sym_preproc_if_token3] = ACTIONS(4106),
    [aux_sym_preproc_else_token1] = ACTIONS(4106),
    [aux_sym_preproc_elif_token1] = ACTIONS(4106),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3654] = {
    [sym_preproc_region] = STATE(3654),
    [sym_preproc_endregion] = STATE(3654),
    [sym_preproc_line] = STATE(3654),
    [sym_preproc_pragma] = STATE(3654),
    [sym_preproc_nullable] = STATE(3654),
    [sym_preproc_error] = STATE(3654),
    [sym_preproc_define] = STATE(3654),
    [sym_preproc_undef] = STATE(3654),
    [anon_sym_SEMI] = ACTIONS(5428),
    [anon_sym_LBRACK] = ACTIONS(5428),
    [anon_sym_COLON] = ACTIONS(5428),
    [anon_sym_COMMA] = ACTIONS(5428),
    [anon_sym_RBRACK] = ACTIONS(5428),
    [anon_sym_LPAREN] = ACTIONS(5428),
    [anon_sym_RPAREN] = ACTIONS(5428),
    [anon_sym_RBRACE] = ACTIONS(5428),
    [anon_sym_LT] = ACTIONS(5430),
    [anon_sym_GT] = ACTIONS(5430),
    [anon_sym_in] = ACTIONS(5430),
    [anon_sym_where] = ACTIONS(5428),
    [anon_sym_QMARK] = ACTIONS(5430),
    [anon_sym_BANG] = ACTIONS(5430),
    [anon_sym_PLUS_PLUS] = ACTIONS(5428),
    [anon_sym_DASH_DASH] = ACTIONS(5428),
    [anon_sym_PLUS] = ACTIONS(5430),
    [anon_sym_DASH] = ACTIONS(5430),
    [anon_sym_STAR] = ACTIONS(5428),
    [anon_sym_SLASH] = ACTIONS(5430),
    [anon_sym_PERCENT] = ACTIONS(5428),
    [anon_sym_CARET] = ACTIONS(5428),
    [anon_sym_PIPE] = ACTIONS(5430),
    [anon_sym_AMP] = ACTIONS(5430),
    [anon_sym_LT_LT] = ACTIONS(5428),
    [anon_sym_GT_GT] = ACTIONS(5430),
    [anon_sym_GT_GT_GT] = ACTIONS(5428),
    [anon_sym_EQ_EQ] = ACTIONS(5428),
    [anon_sym_BANG_EQ] = ACTIONS(5428),
    [anon_sym_GT_EQ] = ACTIONS(5428),
    [anon_sym_LT_EQ] = ACTIONS(5428),
    [anon_sym_DOT] = ACTIONS(5430),
    [anon_sym_EQ_GT] = ACTIONS(5428),
    [anon_sym_switch] = ACTIONS(5428),
    [anon_sym_DOT_DOT] = ACTIONS(5428),
    [anon_sym_and] = ACTIONS(5428),
    [anon_sym_or] = ACTIONS(5430),
    [anon_sym_AMP_AMP] = ACTIONS(5428),
    [anon_sym_PIPE_PIPE] = ACTIONS(5428),
    [anon_sym_QMARK_QMARK] = ACTIONS(5428),
    [anon_sym_from] = ACTIONS(5428),
    [anon_sym_into] = ACTIONS(5428),
    [anon_sym_join] = ACTIONS(5428),
    [anon_sym_on] = ACTIONS(5428),
    [anon_sym_equals] = ACTIONS(5428),
    [anon_sym_let] = ACTIONS(5428),
    [anon_sym_orderby] = ACTIONS(5428),
    [anon_sym_group] = ACTIONS(5428),
    [anon_sym_by] = ACTIONS(5428),
    [anon_sym_select] = ACTIONS(5428),
    [anon_sym_as] = ACTIONS(5428),
    [anon_sym_is] = ACTIONS(5428),
    [anon_sym_DASH_GT] = ACTIONS(5428),
    [anon_sym_with] = ACTIONS(5428),
    [aux_sym_preproc_if_token3] = ACTIONS(5428),
    [aux_sym_preproc_else_token1] = ACTIONS(5428),
    [aux_sym_preproc_elif_token1] = ACTIONS(5428),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3655] = {
    [sym_preproc_region] = STATE(3655),
    [sym_preproc_endregion] = STATE(3655),
    [sym_preproc_line] = STATE(3655),
    [sym_preproc_pragma] = STATE(3655),
    [sym_preproc_nullable] = STATE(3655),
    [sym_preproc_error] = STATE(3655),
    [sym_preproc_define] = STATE(3655),
    [sym_preproc_undef] = STATE(3655),
    [anon_sym_SEMI] = ACTIONS(5432),
    [anon_sym_LBRACK] = ACTIONS(5432),
    [anon_sym_COLON] = ACTIONS(5432),
    [anon_sym_COMMA] = ACTIONS(5432),
    [anon_sym_RBRACK] = ACTIONS(5432),
    [anon_sym_LPAREN] = ACTIONS(5432),
    [anon_sym_RPAREN] = ACTIONS(5432),
    [anon_sym_RBRACE] = ACTIONS(5432),
    [anon_sym_LT] = ACTIONS(5434),
    [anon_sym_GT] = ACTIONS(5434),
    [anon_sym_in] = ACTIONS(5434),
    [anon_sym_where] = ACTIONS(5432),
    [anon_sym_QMARK] = ACTIONS(5434),
    [anon_sym_BANG] = ACTIONS(5434),
    [anon_sym_PLUS_PLUS] = ACTIONS(5432),
    [anon_sym_DASH_DASH] = ACTIONS(5432),
    [anon_sym_PLUS] = ACTIONS(5434),
    [anon_sym_DASH] = ACTIONS(5434),
    [anon_sym_STAR] = ACTIONS(5432),
    [anon_sym_SLASH] = ACTIONS(5434),
    [anon_sym_PERCENT] = ACTIONS(5432),
    [anon_sym_CARET] = ACTIONS(5432),
    [anon_sym_PIPE] = ACTIONS(5434),
    [anon_sym_AMP] = ACTIONS(5434),
    [anon_sym_LT_LT] = ACTIONS(5432),
    [anon_sym_GT_GT] = ACTIONS(5434),
    [anon_sym_GT_GT_GT] = ACTIONS(5432),
    [anon_sym_EQ_EQ] = ACTIONS(5432),
    [anon_sym_BANG_EQ] = ACTIONS(5432),
    [anon_sym_GT_EQ] = ACTIONS(5432),
    [anon_sym_LT_EQ] = ACTIONS(5432),
    [anon_sym_DOT] = ACTIONS(5434),
    [anon_sym_EQ_GT] = ACTIONS(5432),
    [anon_sym_switch] = ACTIONS(5432),
    [anon_sym_DOT_DOT] = ACTIONS(5432),
    [anon_sym_and] = ACTIONS(5432),
    [anon_sym_or] = ACTIONS(5434),
    [anon_sym_AMP_AMP] = ACTIONS(5432),
    [anon_sym_PIPE_PIPE] = ACTIONS(5432),
    [anon_sym_QMARK_QMARK] = ACTIONS(5432),
    [anon_sym_from] = ACTIONS(5432),
    [anon_sym_into] = ACTIONS(5432),
    [anon_sym_join] = ACTIONS(5432),
    [anon_sym_on] = ACTIONS(5432),
    [anon_sym_equals] = ACTIONS(5432),
    [anon_sym_let] = ACTIONS(5432),
    [anon_sym_orderby] = ACTIONS(5432),
    [anon_sym_group] = ACTIONS(5432),
    [anon_sym_by] = ACTIONS(5432),
    [anon_sym_select] = ACTIONS(5432),
    [anon_sym_as] = ACTIONS(5432),
    [anon_sym_is] = ACTIONS(5432),
    [anon_sym_DASH_GT] = ACTIONS(5432),
    [anon_sym_with] = ACTIONS(5432),
    [aux_sym_preproc_if_token3] = ACTIONS(5432),
    [aux_sym_preproc_else_token1] = ACTIONS(5432),
    [aux_sym_preproc_elif_token1] = ACTIONS(5432),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3656] = {
    [sym_preproc_region] = STATE(3656),
    [sym_preproc_endregion] = STATE(3656),
    [sym_preproc_line] = STATE(3656),
    [sym_preproc_pragma] = STATE(3656),
    [sym_preproc_nullable] = STATE(3656),
    [sym_preproc_error] = STATE(3656),
    [sym_preproc_define] = STATE(3656),
    [sym_preproc_undef] = STATE(3656),
    [anon_sym_SEMI] = ACTIONS(5436),
    [anon_sym_LBRACK] = ACTIONS(5436),
    [anon_sym_COLON] = ACTIONS(5436),
    [anon_sym_COMMA] = ACTIONS(5436),
    [anon_sym_RBRACK] = ACTIONS(5436),
    [anon_sym_LPAREN] = ACTIONS(5436),
    [anon_sym_RPAREN] = ACTIONS(5436),
    [anon_sym_RBRACE] = ACTIONS(5436),
    [anon_sym_LT] = ACTIONS(5438),
    [anon_sym_GT] = ACTIONS(5438),
    [anon_sym_in] = ACTIONS(5438),
    [anon_sym_where] = ACTIONS(5436),
    [anon_sym_QMARK] = ACTIONS(5438),
    [anon_sym_BANG] = ACTIONS(5438),
    [anon_sym_PLUS_PLUS] = ACTIONS(5436),
    [anon_sym_DASH_DASH] = ACTIONS(5436),
    [anon_sym_PLUS] = ACTIONS(5438),
    [anon_sym_DASH] = ACTIONS(5438),
    [anon_sym_STAR] = ACTIONS(5436),
    [anon_sym_SLASH] = ACTIONS(5438),
    [anon_sym_PERCENT] = ACTIONS(5436),
    [anon_sym_CARET] = ACTIONS(5436),
    [anon_sym_PIPE] = ACTIONS(5438),
    [anon_sym_AMP] = ACTIONS(5438),
    [anon_sym_LT_LT] = ACTIONS(5436),
    [anon_sym_GT_GT] = ACTIONS(5438),
    [anon_sym_GT_GT_GT] = ACTIONS(5436),
    [anon_sym_EQ_EQ] = ACTIONS(5436),
    [anon_sym_BANG_EQ] = ACTIONS(5436),
    [anon_sym_GT_EQ] = ACTIONS(5436),
    [anon_sym_LT_EQ] = ACTIONS(5436),
    [anon_sym_DOT] = ACTIONS(5438),
    [anon_sym_EQ_GT] = ACTIONS(5436),
    [anon_sym_switch] = ACTIONS(5436),
    [anon_sym_DOT_DOT] = ACTIONS(5436),
    [anon_sym_and] = ACTIONS(5436),
    [anon_sym_or] = ACTIONS(5438),
    [anon_sym_AMP_AMP] = ACTIONS(5436),
    [anon_sym_PIPE_PIPE] = ACTIONS(5436),
    [anon_sym_QMARK_QMARK] = ACTIONS(5436),
    [anon_sym_from] = ACTIONS(5436),
    [anon_sym_into] = ACTIONS(5436),
    [anon_sym_join] = ACTIONS(5436),
    [anon_sym_on] = ACTIONS(5436),
    [anon_sym_equals] = ACTIONS(5436),
    [anon_sym_let] = ACTIONS(5436),
    [anon_sym_orderby] = ACTIONS(5436),
    [anon_sym_group] = ACTIONS(5436),
    [anon_sym_by] = ACTIONS(5436),
    [anon_sym_select] = ACTIONS(5436),
    [anon_sym_as] = ACTIONS(5436),
    [anon_sym_is] = ACTIONS(5436),
    [anon_sym_DASH_GT] = ACTIONS(5436),
    [anon_sym_with] = ACTIONS(5436),
    [aux_sym_preproc_if_token3] = ACTIONS(5436),
    [aux_sym_preproc_else_token1] = ACTIONS(5436),
    [aux_sym_preproc_elif_token1] = ACTIONS(5436),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3657] = {
    [sym_preproc_region] = STATE(3657),
    [sym_preproc_endregion] = STATE(3657),
    [sym_preproc_line] = STATE(3657),
    [sym_preproc_pragma] = STATE(3657),
    [sym_preproc_nullable] = STATE(3657),
    [sym_preproc_error] = STATE(3657),
    [sym_preproc_define] = STATE(3657),
    [sym_preproc_undef] = STATE(3657),
    [anon_sym_SEMI] = ACTIONS(4068),
    [anon_sym_LBRACK] = ACTIONS(4068),
    [anon_sym_COLON] = ACTIONS(4068),
    [anon_sym_COMMA] = ACTIONS(4068),
    [anon_sym_RBRACK] = ACTIONS(4068),
    [anon_sym_LPAREN] = ACTIONS(4068),
    [anon_sym_RPAREN] = ACTIONS(4068),
    [anon_sym_LBRACE] = ACTIONS(4068),
    [anon_sym_RBRACE] = ACTIONS(4068),
    [anon_sym_LT] = ACTIONS(4066),
    [anon_sym_GT] = ACTIONS(4066),
    [anon_sym_in] = ACTIONS(4068),
    [anon_sym_where] = ACTIONS(4068),
    [anon_sym_QMARK] = ACTIONS(4066),
    [anon_sym_BANG] = ACTIONS(4066),
    [anon_sym_PLUS_PLUS] = ACTIONS(4068),
    [anon_sym_DASH_DASH] = ACTIONS(4068),
    [anon_sym_PLUS] = ACTIONS(4066),
    [anon_sym_DASH] = ACTIONS(4066),
    [anon_sym_STAR] = ACTIONS(4068),
    [anon_sym_SLASH] = ACTIONS(4066),
    [anon_sym_PERCENT] = ACTIONS(4068),
    [anon_sym_CARET] = ACTIONS(4068),
    [anon_sym_PIPE] = ACTIONS(4066),
    [anon_sym_AMP] = ACTIONS(4066),
    [anon_sym_LT_LT] = ACTIONS(4068),
    [anon_sym_GT_GT] = ACTIONS(4066),
    [anon_sym_GT_GT_GT] = ACTIONS(4068),
    [anon_sym_EQ_EQ] = ACTIONS(4068),
    [anon_sym_BANG_EQ] = ACTIONS(4068),
    [anon_sym_GT_EQ] = ACTIONS(4068),
    [anon_sym_LT_EQ] = ACTIONS(4068),
    [anon_sym_DOT] = ACTIONS(4066),
    [anon_sym_EQ_GT] = ACTIONS(4068),
    [anon_sym_switch] = ACTIONS(4068),
    [anon_sym_DOT_DOT] = ACTIONS(4068),
    [anon_sym_and] = ACTIONS(4068),
    [anon_sym_or] = ACTIONS(4066),
    [anon_sym_AMP_AMP] = ACTIONS(4068),
    [anon_sym_PIPE_PIPE] = ACTIONS(4068),
    [anon_sym_QMARK_QMARK] = ACTIONS(4068),
    [anon_sym_from] = ACTIONS(4068),
    [anon_sym_join] = ACTIONS(4068),
    [anon_sym_on] = ACTIONS(4068),
    [anon_sym_equals] = ACTIONS(4068),
    [anon_sym_let] = ACTIONS(4068),
    [anon_sym_orderby] = ACTIONS(4068),
    [anon_sym_group] = ACTIONS(4068),
    [anon_sym_by] = ACTIONS(4068),
    [anon_sym_select] = ACTIONS(4068),
    [anon_sym_as] = ACTIONS(4068),
    [anon_sym_is] = ACTIONS(4068),
    [anon_sym_DASH_GT] = ACTIONS(4068),
    [anon_sym_with] = ACTIONS(4068),
    [aux_sym_preproc_if_token3] = ACTIONS(4068),
    [aux_sym_preproc_else_token1] = ACTIONS(4068),
    [aux_sym_preproc_elif_token1] = ACTIONS(4068),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3658] = {
    [sym_preproc_region] = STATE(3658),
    [sym_preproc_endregion] = STATE(3658),
    [sym_preproc_line] = STATE(3658),
    [sym_preproc_pragma] = STATE(3658),
    [sym_preproc_nullable] = STATE(3658),
    [sym_preproc_error] = STATE(3658),
    [sym_preproc_define] = STATE(3658),
    [sym_preproc_undef] = STATE(3658),
    [anon_sym_SEMI] = ACTIONS(4504),
    [anon_sym_LBRACK] = ACTIONS(4504),
    [anon_sym_COLON] = ACTIONS(4504),
    [anon_sym_COMMA] = ACTIONS(4504),
    [anon_sym_RBRACK] = ACTIONS(4504),
    [anon_sym_LPAREN] = ACTIONS(4504),
    [anon_sym_RPAREN] = ACTIONS(4504),
    [anon_sym_LBRACE] = ACTIONS(4504),
    [anon_sym_RBRACE] = ACTIONS(4504),
    [anon_sym_LT] = ACTIONS(4502),
    [anon_sym_GT] = ACTIONS(4502),
    [anon_sym_in] = ACTIONS(4504),
    [anon_sym_where] = ACTIONS(4504),
    [anon_sym_QMARK] = ACTIONS(4502),
    [anon_sym_BANG] = ACTIONS(4502),
    [anon_sym_PLUS_PLUS] = ACTIONS(4504),
    [anon_sym_DASH_DASH] = ACTIONS(4504),
    [anon_sym_PLUS] = ACTIONS(4502),
    [anon_sym_DASH] = ACTIONS(4502),
    [anon_sym_STAR] = ACTIONS(4504),
    [anon_sym_SLASH] = ACTIONS(4502),
    [anon_sym_PERCENT] = ACTIONS(4504),
    [anon_sym_CARET] = ACTIONS(4504),
    [anon_sym_PIPE] = ACTIONS(4502),
    [anon_sym_AMP] = ACTIONS(4502),
    [anon_sym_LT_LT] = ACTIONS(4504),
    [anon_sym_GT_GT] = ACTIONS(4502),
    [anon_sym_GT_GT_GT] = ACTIONS(4504),
    [anon_sym_EQ_EQ] = ACTIONS(4504),
    [anon_sym_BANG_EQ] = ACTIONS(4504),
    [anon_sym_GT_EQ] = ACTIONS(4504),
    [anon_sym_LT_EQ] = ACTIONS(4504),
    [anon_sym_DOT] = ACTIONS(4502),
    [anon_sym_EQ_GT] = ACTIONS(4504),
    [anon_sym_switch] = ACTIONS(4504),
    [anon_sym_DOT_DOT] = ACTIONS(4504),
    [anon_sym_and] = ACTIONS(4504),
    [anon_sym_or] = ACTIONS(4502),
    [anon_sym_AMP_AMP] = ACTIONS(4504),
    [anon_sym_PIPE_PIPE] = ACTIONS(4504),
    [anon_sym_QMARK_QMARK] = ACTIONS(4504),
    [anon_sym_from] = ACTIONS(4504),
    [anon_sym_join] = ACTIONS(4504),
    [anon_sym_on] = ACTIONS(4504),
    [anon_sym_equals] = ACTIONS(4504),
    [anon_sym_let] = ACTIONS(4504),
    [anon_sym_orderby] = ACTIONS(4504),
    [anon_sym_group] = ACTIONS(4504),
    [anon_sym_by] = ACTIONS(4504),
    [anon_sym_select] = ACTIONS(4504),
    [anon_sym_as] = ACTIONS(4504),
    [anon_sym_is] = ACTIONS(4504),
    [anon_sym_DASH_GT] = ACTIONS(4504),
    [anon_sym_with] = ACTIONS(4504),
    [aux_sym_preproc_if_token3] = ACTIONS(4504),
    [aux_sym_preproc_else_token1] = ACTIONS(4504),
    [aux_sym_preproc_elif_token1] = ACTIONS(4504),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3659] = {
    [sym_preproc_region] = STATE(3659),
    [sym_preproc_endregion] = STATE(3659),
    [sym_preproc_line] = STATE(3659),
    [sym_preproc_pragma] = STATE(3659),
    [sym_preproc_nullable] = STATE(3659),
    [sym_preproc_error] = STATE(3659),
    [sym_preproc_define] = STATE(3659),
    [sym_preproc_undef] = STATE(3659),
    [anon_sym_SEMI] = ACTIONS(5440),
    [anon_sym_LBRACK] = ACTIONS(5440),
    [anon_sym_COLON] = ACTIONS(5440),
    [anon_sym_COMMA] = ACTIONS(5440),
    [anon_sym_RBRACK] = ACTIONS(5440),
    [anon_sym_LPAREN] = ACTIONS(5440),
    [anon_sym_RPAREN] = ACTIONS(5440),
    [anon_sym_RBRACE] = ACTIONS(5440),
    [anon_sym_LT] = ACTIONS(5442),
    [anon_sym_GT] = ACTIONS(5442),
    [anon_sym_in] = ACTIONS(5442),
    [anon_sym_where] = ACTIONS(5440),
    [anon_sym_QMARK] = ACTIONS(5442),
    [anon_sym_BANG] = ACTIONS(5442),
    [anon_sym_PLUS_PLUS] = ACTIONS(5440),
    [anon_sym_DASH_DASH] = ACTIONS(5440),
    [anon_sym_PLUS] = ACTIONS(5442),
    [anon_sym_DASH] = ACTIONS(5442),
    [anon_sym_STAR] = ACTIONS(5440),
    [anon_sym_SLASH] = ACTIONS(5442),
    [anon_sym_PERCENT] = ACTIONS(5440),
    [anon_sym_CARET] = ACTIONS(5440),
    [anon_sym_PIPE] = ACTIONS(5442),
    [anon_sym_AMP] = ACTIONS(5442),
    [anon_sym_LT_LT] = ACTIONS(5440),
    [anon_sym_GT_GT] = ACTIONS(5442),
    [anon_sym_GT_GT_GT] = ACTIONS(5440),
    [anon_sym_EQ_EQ] = ACTIONS(5440),
    [anon_sym_BANG_EQ] = ACTIONS(5440),
    [anon_sym_GT_EQ] = ACTIONS(5440),
    [anon_sym_LT_EQ] = ACTIONS(5440),
    [anon_sym_DOT] = ACTIONS(5442),
    [anon_sym_EQ_GT] = ACTIONS(5440),
    [anon_sym_switch] = ACTIONS(5440),
    [anon_sym_DOT_DOT] = ACTIONS(5440),
    [anon_sym_and] = ACTIONS(5440),
    [anon_sym_or] = ACTIONS(5442),
    [anon_sym_AMP_AMP] = ACTIONS(5440),
    [anon_sym_PIPE_PIPE] = ACTIONS(5440),
    [anon_sym_QMARK_QMARK] = ACTIONS(5440),
    [anon_sym_from] = ACTIONS(5440),
    [anon_sym_into] = ACTIONS(5440),
    [anon_sym_join] = ACTIONS(5440),
    [anon_sym_on] = ACTIONS(5440),
    [anon_sym_equals] = ACTIONS(5440),
    [anon_sym_let] = ACTIONS(5440),
    [anon_sym_orderby] = ACTIONS(5440),
    [anon_sym_group] = ACTIONS(5440),
    [anon_sym_by] = ACTIONS(5440),
    [anon_sym_select] = ACTIONS(5440),
    [anon_sym_as] = ACTIONS(5440),
    [anon_sym_is] = ACTIONS(5440),
    [anon_sym_DASH_GT] = ACTIONS(5440),
    [anon_sym_with] = ACTIONS(5440),
    [aux_sym_preproc_if_token3] = ACTIONS(5440),
    [aux_sym_preproc_else_token1] = ACTIONS(5440),
    [aux_sym_preproc_elif_token1] = ACTIONS(5440),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3660] = {
    [sym_preproc_region] = STATE(3660),
    [sym_preproc_endregion] = STATE(3660),
    [sym_preproc_line] = STATE(3660),
    [sym_preproc_pragma] = STATE(3660),
    [sym_preproc_nullable] = STATE(3660),
    [sym_preproc_error] = STATE(3660),
    [sym_preproc_define] = STATE(3660),
    [sym_preproc_undef] = STATE(3660),
    [anon_sym_SEMI] = ACTIONS(5444),
    [anon_sym_LBRACK] = ACTIONS(5444),
    [anon_sym_COLON] = ACTIONS(5444),
    [anon_sym_COMMA] = ACTIONS(5444),
    [anon_sym_RBRACK] = ACTIONS(5444),
    [anon_sym_LPAREN] = ACTIONS(5444),
    [anon_sym_RPAREN] = ACTIONS(5444),
    [anon_sym_RBRACE] = ACTIONS(5444),
    [anon_sym_LT] = ACTIONS(5446),
    [anon_sym_GT] = ACTIONS(5446),
    [anon_sym_in] = ACTIONS(5446),
    [anon_sym_where] = ACTIONS(5444),
    [anon_sym_QMARK] = ACTIONS(5446),
    [anon_sym_BANG] = ACTIONS(5446),
    [anon_sym_PLUS_PLUS] = ACTIONS(5444),
    [anon_sym_DASH_DASH] = ACTIONS(5444),
    [anon_sym_PLUS] = ACTIONS(5446),
    [anon_sym_DASH] = ACTIONS(5446),
    [anon_sym_STAR] = ACTIONS(5444),
    [anon_sym_SLASH] = ACTIONS(5446),
    [anon_sym_PERCENT] = ACTIONS(5444),
    [anon_sym_CARET] = ACTIONS(5444),
    [anon_sym_PIPE] = ACTIONS(5446),
    [anon_sym_AMP] = ACTIONS(5446),
    [anon_sym_LT_LT] = ACTIONS(5444),
    [anon_sym_GT_GT] = ACTIONS(5446),
    [anon_sym_GT_GT_GT] = ACTIONS(5444),
    [anon_sym_EQ_EQ] = ACTIONS(5444),
    [anon_sym_BANG_EQ] = ACTIONS(5444),
    [anon_sym_GT_EQ] = ACTIONS(5444),
    [anon_sym_LT_EQ] = ACTIONS(5444),
    [anon_sym_DOT] = ACTIONS(5446),
    [anon_sym_EQ_GT] = ACTIONS(5444),
    [anon_sym_switch] = ACTIONS(5444),
    [anon_sym_DOT_DOT] = ACTIONS(5444),
    [anon_sym_and] = ACTIONS(5444),
    [anon_sym_or] = ACTIONS(5446),
    [anon_sym_AMP_AMP] = ACTIONS(5444),
    [anon_sym_PIPE_PIPE] = ACTIONS(5444),
    [anon_sym_QMARK_QMARK] = ACTIONS(5444),
    [anon_sym_from] = ACTIONS(5444),
    [anon_sym_into] = ACTIONS(5444),
    [anon_sym_join] = ACTIONS(5444),
    [anon_sym_on] = ACTIONS(5444),
    [anon_sym_equals] = ACTIONS(5444),
    [anon_sym_let] = ACTIONS(5444),
    [anon_sym_orderby] = ACTIONS(5444),
    [anon_sym_group] = ACTIONS(5444),
    [anon_sym_by] = ACTIONS(5444),
    [anon_sym_select] = ACTIONS(5444),
    [anon_sym_as] = ACTIONS(5444),
    [anon_sym_is] = ACTIONS(5444),
    [anon_sym_DASH_GT] = ACTIONS(5444),
    [anon_sym_with] = ACTIONS(5444),
    [aux_sym_preproc_if_token3] = ACTIONS(5444),
    [aux_sym_preproc_else_token1] = ACTIONS(5444),
    [aux_sym_preproc_elif_token1] = ACTIONS(5444),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3661] = {
    [sym_preproc_region] = STATE(3661),
    [sym_preproc_endregion] = STATE(3661),
    [sym_preproc_line] = STATE(3661),
    [sym_preproc_pragma] = STATE(3661),
    [sym_preproc_nullable] = STATE(3661),
    [sym_preproc_error] = STATE(3661),
    [sym_preproc_define] = STATE(3661),
    [sym_preproc_undef] = STATE(3661),
    [anon_sym_SEMI] = ACTIONS(4424),
    [anon_sym_LBRACK] = ACTIONS(4547),
    [anon_sym_COLON] = ACTIONS(4424),
    [anon_sym_COMMA] = ACTIONS(4424),
    [anon_sym_RBRACK] = ACTIONS(4424),
    [anon_sym_LPAREN] = ACTIONS(4424),
    [anon_sym_RPAREN] = ACTIONS(4424),
    [anon_sym_LBRACE] = ACTIONS(4424),
    [anon_sym_RBRACE] = ACTIONS(4424),
    [anon_sym_LT] = ACTIONS(4422),
    [anon_sym_GT] = ACTIONS(4422),
    [anon_sym_in] = ACTIONS(4424),
    [anon_sym_where] = ACTIONS(4424),
    [anon_sym_QMARK] = ACTIONS(5389),
    [anon_sym_BANG] = ACTIONS(4422),
    [anon_sym_PLUS_PLUS] = ACTIONS(4424),
    [anon_sym_DASH_DASH] = ACTIONS(4424),
    [anon_sym_PLUS] = ACTIONS(4422),
    [anon_sym_DASH] = ACTIONS(4422),
    [anon_sym_STAR] = ACTIONS(4424),
    [anon_sym_SLASH] = ACTIONS(4422),
    [anon_sym_PERCENT] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4424),
    [anon_sym_PIPE] = ACTIONS(4422),
    [anon_sym_AMP] = ACTIONS(4422),
    [anon_sym_LT_LT] = ACTIONS(4424),
    [anon_sym_GT_GT] = ACTIONS(4422),
    [anon_sym_GT_GT_GT] = ACTIONS(4424),
    [anon_sym_EQ_EQ] = ACTIONS(4424),
    [anon_sym_BANG_EQ] = ACTIONS(4424),
    [anon_sym_GT_EQ] = ACTIONS(4424),
    [anon_sym_LT_EQ] = ACTIONS(4424),
    [anon_sym_DOT] = ACTIONS(4422),
    [anon_sym_EQ_GT] = ACTIONS(4424),
    [anon_sym_switch] = ACTIONS(4424),
    [anon_sym_DOT_DOT] = ACTIONS(4424),
    [anon_sym_and] = ACTIONS(4424),
    [anon_sym_or] = ACTIONS(4422),
    [anon_sym_AMP_AMP] = ACTIONS(4424),
    [anon_sym_PIPE_PIPE] = ACTIONS(4424),
    [anon_sym_QMARK_QMARK] = ACTIONS(4424),
    [anon_sym_from] = ACTIONS(4424),
    [anon_sym_join] = ACTIONS(4424),
    [anon_sym_on] = ACTIONS(4424),
    [anon_sym_equals] = ACTIONS(4424),
    [anon_sym_let] = ACTIONS(4424),
    [anon_sym_orderby] = ACTIONS(4424),
    [anon_sym_group] = ACTIONS(4424),
    [anon_sym_by] = ACTIONS(4424),
    [anon_sym_select] = ACTIONS(4424),
    [anon_sym_as] = ACTIONS(4424),
    [anon_sym_is] = ACTIONS(4424),
    [anon_sym_DASH_GT] = ACTIONS(4424),
    [anon_sym_with] = ACTIONS(4424),
    [aux_sym_preproc_if_token3] = ACTIONS(4424),
    [aux_sym_preproc_else_token1] = ACTIONS(4424),
    [aux_sym_preproc_elif_token1] = ACTIONS(4424),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3662] = {
    [sym_preproc_region] = STATE(3662),
    [sym_preproc_endregion] = STATE(3662),
    [sym_preproc_line] = STATE(3662),
    [sym_preproc_pragma] = STATE(3662),
    [sym_preproc_nullable] = STATE(3662),
    [sym_preproc_error] = STATE(3662),
    [sym_preproc_define] = STATE(3662),
    [sym_preproc_undef] = STATE(3662),
    [anon_sym_SEMI] = ACTIONS(4480),
    [anon_sym_LBRACK] = ACTIONS(4480),
    [anon_sym_COLON] = ACTIONS(4480),
    [anon_sym_COMMA] = ACTIONS(4480),
    [anon_sym_RBRACK] = ACTIONS(4480),
    [anon_sym_LPAREN] = ACTIONS(4480),
    [anon_sym_RPAREN] = ACTIONS(4480),
    [anon_sym_LBRACE] = ACTIONS(4480),
    [anon_sym_RBRACE] = ACTIONS(4480),
    [anon_sym_LT] = ACTIONS(4478),
    [anon_sym_GT] = ACTIONS(4478),
    [anon_sym_in] = ACTIONS(4480),
    [anon_sym_where] = ACTIONS(4480),
    [anon_sym_QMARK] = ACTIONS(4478),
    [anon_sym_BANG] = ACTIONS(4478),
    [anon_sym_PLUS_PLUS] = ACTIONS(4480),
    [anon_sym_DASH_DASH] = ACTIONS(4480),
    [anon_sym_PLUS] = ACTIONS(4478),
    [anon_sym_DASH] = ACTIONS(4478),
    [anon_sym_STAR] = ACTIONS(4480),
    [anon_sym_SLASH] = ACTIONS(4478),
    [anon_sym_PERCENT] = ACTIONS(4480),
    [anon_sym_CARET] = ACTIONS(4480),
    [anon_sym_PIPE] = ACTIONS(4478),
    [anon_sym_AMP] = ACTIONS(4478),
    [anon_sym_LT_LT] = ACTIONS(4480),
    [anon_sym_GT_GT] = ACTIONS(4478),
    [anon_sym_GT_GT_GT] = ACTIONS(4480),
    [anon_sym_EQ_EQ] = ACTIONS(4480),
    [anon_sym_BANG_EQ] = ACTIONS(4480),
    [anon_sym_GT_EQ] = ACTIONS(4480),
    [anon_sym_LT_EQ] = ACTIONS(4480),
    [anon_sym_DOT] = ACTIONS(4478),
    [anon_sym_EQ_GT] = ACTIONS(4480),
    [anon_sym_switch] = ACTIONS(4480),
    [anon_sym_DOT_DOT] = ACTIONS(4480),
    [anon_sym_and] = ACTIONS(4480),
    [anon_sym_or] = ACTIONS(4478),
    [anon_sym_AMP_AMP] = ACTIONS(4480),
    [anon_sym_PIPE_PIPE] = ACTIONS(4480),
    [anon_sym_QMARK_QMARK] = ACTIONS(4480),
    [anon_sym_from] = ACTIONS(4480),
    [anon_sym_join] = ACTIONS(4480),
    [anon_sym_on] = ACTIONS(4480),
    [anon_sym_equals] = ACTIONS(4480),
    [anon_sym_let] = ACTIONS(4480),
    [anon_sym_orderby] = ACTIONS(4480),
    [anon_sym_group] = ACTIONS(4480),
    [anon_sym_by] = ACTIONS(4480),
    [anon_sym_select] = ACTIONS(4480),
    [anon_sym_as] = ACTIONS(4480),
    [anon_sym_is] = ACTIONS(4480),
    [anon_sym_DASH_GT] = ACTIONS(4480),
    [anon_sym_with] = ACTIONS(4480),
    [aux_sym_preproc_if_token3] = ACTIONS(4480),
    [aux_sym_preproc_else_token1] = ACTIONS(4480),
    [aux_sym_preproc_elif_token1] = ACTIONS(4480),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3663] = {
    [sym_preproc_region] = STATE(3663),
    [sym_preproc_endregion] = STATE(3663),
    [sym_preproc_line] = STATE(3663),
    [sym_preproc_pragma] = STATE(3663),
    [sym_preproc_nullable] = STATE(3663),
    [sym_preproc_error] = STATE(3663),
    [sym_preproc_define] = STATE(3663),
    [sym_preproc_undef] = STATE(3663),
    [anon_sym_SEMI] = ACTIONS(4416),
    [anon_sym_LBRACK] = ACTIONS(4416),
    [anon_sym_COLON] = ACTIONS(4416),
    [anon_sym_COMMA] = ACTIONS(4416),
    [anon_sym_RBRACK] = ACTIONS(4416),
    [anon_sym_LPAREN] = ACTIONS(4416),
    [anon_sym_RPAREN] = ACTIONS(4416),
    [anon_sym_LBRACE] = ACTIONS(4416),
    [anon_sym_RBRACE] = ACTIONS(4416),
    [anon_sym_LT] = ACTIONS(4414),
    [anon_sym_GT] = ACTIONS(4414),
    [anon_sym_in] = ACTIONS(4416),
    [anon_sym_where] = ACTIONS(4416),
    [anon_sym_QMARK] = ACTIONS(4414),
    [anon_sym_BANG] = ACTIONS(4414),
    [anon_sym_PLUS_PLUS] = ACTIONS(4416),
    [anon_sym_DASH_DASH] = ACTIONS(4416),
    [anon_sym_PLUS] = ACTIONS(4414),
    [anon_sym_DASH] = ACTIONS(4414),
    [anon_sym_STAR] = ACTIONS(4416),
    [anon_sym_SLASH] = ACTIONS(4414),
    [anon_sym_PERCENT] = ACTIONS(4416),
    [anon_sym_CARET] = ACTIONS(4416),
    [anon_sym_PIPE] = ACTIONS(4414),
    [anon_sym_AMP] = ACTIONS(4414),
    [anon_sym_LT_LT] = ACTIONS(4416),
    [anon_sym_GT_GT] = ACTIONS(4414),
    [anon_sym_GT_GT_GT] = ACTIONS(4416),
    [anon_sym_EQ_EQ] = ACTIONS(4416),
    [anon_sym_BANG_EQ] = ACTIONS(4416),
    [anon_sym_GT_EQ] = ACTIONS(4416),
    [anon_sym_LT_EQ] = ACTIONS(4416),
    [anon_sym_DOT] = ACTIONS(4414),
    [anon_sym_EQ_GT] = ACTIONS(4416),
    [anon_sym_switch] = ACTIONS(4416),
    [anon_sym_DOT_DOT] = ACTIONS(4416),
    [anon_sym_and] = ACTIONS(4416),
    [anon_sym_or] = ACTIONS(4414),
    [anon_sym_AMP_AMP] = ACTIONS(4416),
    [anon_sym_PIPE_PIPE] = ACTIONS(4416),
    [anon_sym_QMARK_QMARK] = ACTIONS(4416),
    [anon_sym_from] = ACTIONS(4416),
    [anon_sym_join] = ACTIONS(4416),
    [anon_sym_on] = ACTIONS(4416),
    [anon_sym_equals] = ACTIONS(4416),
    [anon_sym_let] = ACTIONS(4416),
    [anon_sym_orderby] = ACTIONS(4416),
    [anon_sym_group] = ACTIONS(4416),
    [anon_sym_by] = ACTIONS(4416),
    [anon_sym_select] = ACTIONS(4416),
    [anon_sym_as] = ACTIONS(4416),
    [anon_sym_is] = ACTIONS(4416),
    [anon_sym_DASH_GT] = ACTIONS(4416),
    [anon_sym_with] = ACTIONS(4416),
    [aux_sym_preproc_if_token3] = ACTIONS(4416),
    [aux_sym_preproc_else_token1] = ACTIONS(4416),
    [aux_sym_preproc_elif_token1] = ACTIONS(4416),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3664] = {
    [sym_preproc_region] = STATE(3664),
    [sym_preproc_endregion] = STATE(3664),
    [sym_preproc_line] = STATE(3664),
    [sym_preproc_pragma] = STATE(3664),
    [sym_preproc_nullable] = STATE(3664),
    [sym_preproc_error] = STATE(3664),
    [sym_preproc_define] = STATE(3664),
    [sym_preproc_undef] = STATE(3664),
    [anon_sym_SEMI] = ACTIONS(1963),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_COLON] = ACTIONS(1963),
    [anon_sym_COMMA] = ACTIONS(1963),
    [anon_sym_RBRACK] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1963),
    [anon_sym_RPAREN] = ACTIONS(1963),
    [anon_sym_RBRACE] = ACTIONS(1963),
    [anon_sym_LT] = ACTIONS(1965),
    [anon_sym_GT] = ACTIONS(1965),
    [anon_sym_in] = ACTIONS(1965),
    [anon_sym_where] = ACTIONS(1963),
    [anon_sym_QMARK] = ACTIONS(1965),
    [anon_sym_BANG] = ACTIONS(1965),
    [anon_sym_PLUS_PLUS] = ACTIONS(1963),
    [anon_sym_DASH_DASH] = ACTIONS(1963),
    [anon_sym_PLUS] = ACTIONS(1965),
    [anon_sym_DASH] = ACTIONS(1965),
    [anon_sym_STAR] = ACTIONS(1963),
    [anon_sym_SLASH] = ACTIONS(1965),
    [anon_sym_PERCENT] = ACTIONS(1963),
    [anon_sym_CARET] = ACTIONS(1963),
    [anon_sym_PIPE] = ACTIONS(1965),
    [anon_sym_AMP] = ACTIONS(1965),
    [anon_sym_LT_LT] = ACTIONS(1963),
    [anon_sym_GT_GT] = ACTIONS(1965),
    [anon_sym_GT_GT_GT] = ACTIONS(1963),
    [anon_sym_EQ_EQ] = ACTIONS(1963),
    [anon_sym_BANG_EQ] = ACTIONS(1963),
    [anon_sym_GT_EQ] = ACTIONS(1963),
    [anon_sym_LT_EQ] = ACTIONS(1963),
    [anon_sym_DOT] = ACTIONS(1965),
    [anon_sym_EQ_GT] = ACTIONS(1963),
    [anon_sym_switch] = ACTIONS(1963),
    [anon_sym_DOT_DOT] = ACTIONS(1963),
    [anon_sym_and] = ACTIONS(1963),
    [anon_sym_or] = ACTIONS(1965),
    [anon_sym_AMP_AMP] = ACTIONS(1963),
    [anon_sym_PIPE_PIPE] = ACTIONS(1963),
    [anon_sym_QMARK_QMARK] = ACTIONS(1963),
    [anon_sym_from] = ACTIONS(1963),
    [anon_sym_into] = ACTIONS(1963),
    [anon_sym_join] = ACTIONS(1963),
    [anon_sym_on] = ACTIONS(1963),
    [anon_sym_equals] = ACTIONS(1963),
    [anon_sym_let] = ACTIONS(1963),
    [anon_sym_orderby] = ACTIONS(1963),
    [anon_sym_group] = ACTIONS(1963),
    [anon_sym_by] = ACTIONS(1963),
    [anon_sym_select] = ACTIONS(1963),
    [anon_sym_as] = ACTIONS(1963),
    [anon_sym_is] = ACTIONS(1963),
    [anon_sym_DASH_GT] = ACTIONS(1963),
    [anon_sym_with] = ACTIONS(1963),
    [aux_sym_preproc_if_token3] = ACTIONS(1963),
    [aux_sym_preproc_else_token1] = ACTIONS(1963),
    [aux_sym_preproc_elif_token1] = ACTIONS(1963),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3665] = {
    [sym_preproc_region] = STATE(3665),
    [sym_preproc_endregion] = STATE(3665),
    [sym_preproc_line] = STATE(3665),
    [sym_preproc_pragma] = STATE(3665),
    [sym_preproc_nullable] = STATE(3665),
    [sym_preproc_error] = STATE(3665),
    [sym_preproc_define] = STATE(3665),
    [sym_preproc_undef] = STATE(3665),
    [anon_sym_SEMI] = ACTIONS(5448),
    [anon_sym_LBRACK] = ACTIONS(5448),
    [anon_sym_COLON] = ACTIONS(5448),
    [anon_sym_COMMA] = ACTIONS(5448),
    [anon_sym_RBRACK] = ACTIONS(5448),
    [anon_sym_LPAREN] = ACTIONS(5448),
    [anon_sym_RPAREN] = ACTIONS(5448),
    [anon_sym_RBRACE] = ACTIONS(5448),
    [anon_sym_LT] = ACTIONS(5450),
    [anon_sym_GT] = ACTIONS(5450),
    [anon_sym_in] = ACTIONS(5450),
    [anon_sym_where] = ACTIONS(5448),
    [anon_sym_QMARK] = ACTIONS(5450),
    [anon_sym_BANG] = ACTIONS(5450),
    [anon_sym_PLUS_PLUS] = ACTIONS(5448),
    [anon_sym_DASH_DASH] = ACTIONS(5448),
    [anon_sym_PLUS] = ACTIONS(5450),
    [anon_sym_DASH] = ACTIONS(5450),
    [anon_sym_STAR] = ACTIONS(5448),
    [anon_sym_SLASH] = ACTIONS(5450),
    [anon_sym_PERCENT] = ACTIONS(5448),
    [anon_sym_CARET] = ACTIONS(5448),
    [anon_sym_PIPE] = ACTIONS(5450),
    [anon_sym_AMP] = ACTIONS(5450),
    [anon_sym_LT_LT] = ACTIONS(5448),
    [anon_sym_GT_GT] = ACTIONS(5450),
    [anon_sym_GT_GT_GT] = ACTIONS(5448),
    [anon_sym_EQ_EQ] = ACTIONS(5448),
    [anon_sym_BANG_EQ] = ACTIONS(5448),
    [anon_sym_GT_EQ] = ACTIONS(5448),
    [anon_sym_LT_EQ] = ACTIONS(5448),
    [anon_sym_DOT] = ACTIONS(5450),
    [anon_sym_EQ_GT] = ACTIONS(5448),
    [anon_sym_switch] = ACTIONS(5448),
    [anon_sym_DOT_DOT] = ACTIONS(5448),
    [anon_sym_and] = ACTIONS(5448),
    [anon_sym_or] = ACTIONS(5450),
    [anon_sym_AMP_AMP] = ACTIONS(5448),
    [anon_sym_PIPE_PIPE] = ACTIONS(5448),
    [anon_sym_QMARK_QMARK] = ACTIONS(5448),
    [anon_sym_from] = ACTIONS(5448),
    [anon_sym_into] = ACTIONS(5448),
    [anon_sym_join] = ACTIONS(5448),
    [anon_sym_on] = ACTIONS(5448),
    [anon_sym_equals] = ACTIONS(5448),
    [anon_sym_let] = ACTIONS(5448),
    [anon_sym_orderby] = ACTIONS(5448),
    [anon_sym_group] = ACTIONS(5448),
    [anon_sym_by] = ACTIONS(5448),
    [anon_sym_select] = ACTIONS(5448),
    [anon_sym_as] = ACTIONS(5448),
    [anon_sym_is] = ACTIONS(5448),
    [anon_sym_DASH_GT] = ACTIONS(5448),
    [anon_sym_with] = ACTIONS(5448),
    [aux_sym_preproc_if_token3] = ACTIONS(5448),
    [aux_sym_preproc_else_token1] = ACTIONS(5448),
    [aux_sym_preproc_elif_token1] = ACTIONS(5448),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3666] = {
    [sym_preproc_region] = STATE(3666),
    [sym_preproc_endregion] = STATE(3666),
    [sym_preproc_line] = STATE(3666),
    [sym_preproc_pragma] = STATE(3666),
    [sym_preproc_nullable] = STATE(3666),
    [sym_preproc_error] = STATE(3666),
    [sym_preproc_define] = STATE(3666),
    [sym_preproc_undef] = STATE(3666),
    [anon_sym_SEMI] = ACTIONS(4420),
    [anon_sym_LBRACK] = ACTIONS(4420),
    [anon_sym_COLON] = ACTIONS(4420),
    [anon_sym_COMMA] = ACTIONS(4420),
    [anon_sym_RBRACK] = ACTIONS(4420),
    [anon_sym_LPAREN] = ACTIONS(4420),
    [anon_sym_RPAREN] = ACTIONS(4420),
    [anon_sym_LBRACE] = ACTIONS(4420),
    [anon_sym_RBRACE] = ACTIONS(4420),
    [anon_sym_LT] = ACTIONS(4418),
    [anon_sym_GT] = ACTIONS(4418),
    [anon_sym_in] = ACTIONS(4420),
    [anon_sym_where] = ACTIONS(4420),
    [anon_sym_QMARK] = ACTIONS(4418),
    [anon_sym_BANG] = ACTIONS(4418),
    [anon_sym_PLUS_PLUS] = ACTIONS(4420),
    [anon_sym_DASH_DASH] = ACTIONS(4420),
    [anon_sym_PLUS] = ACTIONS(4418),
    [anon_sym_DASH] = ACTIONS(4418),
    [anon_sym_STAR] = ACTIONS(4420),
    [anon_sym_SLASH] = ACTIONS(4418),
    [anon_sym_PERCENT] = ACTIONS(4420),
    [anon_sym_CARET] = ACTIONS(4420),
    [anon_sym_PIPE] = ACTIONS(4418),
    [anon_sym_AMP] = ACTIONS(4418),
    [anon_sym_LT_LT] = ACTIONS(4420),
    [anon_sym_GT_GT] = ACTIONS(4418),
    [anon_sym_GT_GT_GT] = ACTIONS(4420),
    [anon_sym_EQ_EQ] = ACTIONS(4420),
    [anon_sym_BANG_EQ] = ACTIONS(4420),
    [anon_sym_GT_EQ] = ACTIONS(4420),
    [anon_sym_LT_EQ] = ACTIONS(4420),
    [anon_sym_DOT] = ACTIONS(4418),
    [anon_sym_EQ_GT] = ACTIONS(4420),
    [anon_sym_switch] = ACTIONS(4420),
    [anon_sym_DOT_DOT] = ACTIONS(4420),
    [anon_sym_and] = ACTIONS(4420),
    [anon_sym_or] = ACTIONS(4418),
    [anon_sym_AMP_AMP] = ACTIONS(4420),
    [anon_sym_PIPE_PIPE] = ACTIONS(4420),
    [anon_sym_QMARK_QMARK] = ACTIONS(4420),
    [anon_sym_from] = ACTIONS(4420),
    [anon_sym_join] = ACTIONS(4420),
    [anon_sym_on] = ACTIONS(4420),
    [anon_sym_equals] = ACTIONS(4420),
    [anon_sym_let] = ACTIONS(4420),
    [anon_sym_orderby] = ACTIONS(4420),
    [anon_sym_group] = ACTIONS(4420),
    [anon_sym_by] = ACTIONS(4420),
    [anon_sym_select] = ACTIONS(4420),
    [anon_sym_as] = ACTIONS(4420),
    [anon_sym_is] = ACTIONS(4420),
    [anon_sym_DASH_GT] = ACTIONS(4420),
    [anon_sym_with] = ACTIONS(4420),
    [aux_sym_preproc_if_token3] = ACTIONS(4420),
    [aux_sym_preproc_else_token1] = ACTIONS(4420),
    [aux_sym_preproc_elif_token1] = ACTIONS(4420),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3667] = {
    [sym_preproc_region] = STATE(3667),
    [sym_preproc_endregion] = STATE(3667),
    [sym_preproc_line] = STATE(3667),
    [sym_preproc_pragma] = STATE(3667),
    [sym_preproc_nullable] = STATE(3667),
    [sym_preproc_error] = STATE(3667),
    [sym_preproc_define] = STATE(3667),
    [sym_preproc_undef] = STATE(3667),
    [anon_sym_SEMI] = ACTIONS(5452),
    [anon_sym_LBRACK] = ACTIONS(5452),
    [anon_sym_COLON] = ACTIONS(5452),
    [anon_sym_COMMA] = ACTIONS(5452),
    [anon_sym_RBRACK] = ACTIONS(5452),
    [anon_sym_LPAREN] = ACTIONS(5452),
    [anon_sym_RPAREN] = ACTIONS(5452),
    [anon_sym_RBRACE] = ACTIONS(5452),
    [anon_sym_LT] = ACTIONS(5454),
    [anon_sym_GT] = ACTIONS(5454),
    [anon_sym_in] = ACTIONS(5454),
    [anon_sym_where] = ACTIONS(5452),
    [anon_sym_QMARK] = ACTIONS(5454),
    [anon_sym_BANG] = ACTIONS(5454),
    [anon_sym_PLUS_PLUS] = ACTIONS(5452),
    [anon_sym_DASH_DASH] = ACTIONS(5452),
    [anon_sym_PLUS] = ACTIONS(5454),
    [anon_sym_DASH] = ACTIONS(5454),
    [anon_sym_STAR] = ACTIONS(5452),
    [anon_sym_SLASH] = ACTIONS(5454),
    [anon_sym_PERCENT] = ACTIONS(5452),
    [anon_sym_CARET] = ACTIONS(5452),
    [anon_sym_PIPE] = ACTIONS(5454),
    [anon_sym_AMP] = ACTIONS(5454),
    [anon_sym_LT_LT] = ACTIONS(5452),
    [anon_sym_GT_GT] = ACTIONS(5454),
    [anon_sym_GT_GT_GT] = ACTIONS(5452),
    [anon_sym_EQ_EQ] = ACTIONS(5452),
    [anon_sym_BANG_EQ] = ACTIONS(5452),
    [anon_sym_GT_EQ] = ACTIONS(5452),
    [anon_sym_LT_EQ] = ACTIONS(5452),
    [anon_sym_DOT] = ACTIONS(5454),
    [anon_sym_EQ_GT] = ACTIONS(5452),
    [anon_sym_switch] = ACTIONS(5452),
    [anon_sym_DOT_DOT] = ACTIONS(5452),
    [anon_sym_and] = ACTIONS(5452),
    [anon_sym_or] = ACTIONS(5454),
    [anon_sym_AMP_AMP] = ACTIONS(5452),
    [anon_sym_PIPE_PIPE] = ACTIONS(5452),
    [anon_sym_QMARK_QMARK] = ACTIONS(5452),
    [anon_sym_from] = ACTIONS(5452),
    [anon_sym_into] = ACTIONS(5452),
    [anon_sym_join] = ACTIONS(5452),
    [anon_sym_on] = ACTIONS(5452),
    [anon_sym_equals] = ACTIONS(5452),
    [anon_sym_let] = ACTIONS(5452),
    [anon_sym_orderby] = ACTIONS(5452),
    [anon_sym_group] = ACTIONS(5452),
    [anon_sym_by] = ACTIONS(5452),
    [anon_sym_select] = ACTIONS(5452),
    [anon_sym_as] = ACTIONS(5452),
    [anon_sym_is] = ACTIONS(5452),
    [anon_sym_DASH_GT] = ACTIONS(5452),
    [anon_sym_with] = ACTIONS(5452),
    [aux_sym_preproc_if_token3] = ACTIONS(5452),
    [aux_sym_preproc_else_token1] = ACTIONS(5452),
    [aux_sym_preproc_elif_token1] = ACTIONS(5452),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3668] = {
    [sym_preproc_region] = STATE(3668),
    [sym_preproc_endregion] = STATE(3668),
    [sym_preproc_line] = STATE(3668),
    [sym_preproc_pragma] = STATE(3668),
    [sym_preproc_nullable] = STATE(3668),
    [sym_preproc_error] = STATE(3668),
    [sym_preproc_define] = STATE(3668),
    [sym_preproc_undef] = STATE(3668),
    [anon_sym_SEMI] = ACTIONS(4062),
    [anon_sym_LBRACK] = ACTIONS(4062),
    [anon_sym_COLON] = ACTIONS(4062),
    [anon_sym_COMMA] = ACTIONS(4062),
    [anon_sym_RBRACK] = ACTIONS(4062),
    [anon_sym_LPAREN] = ACTIONS(4062),
    [anon_sym_RPAREN] = ACTIONS(4062),
    [anon_sym_LBRACE] = ACTIONS(4062),
    [anon_sym_RBRACE] = ACTIONS(4062),
    [anon_sym_LT] = ACTIONS(4060),
    [anon_sym_GT] = ACTIONS(4060),
    [anon_sym_in] = ACTIONS(4062),
    [anon_sym_where] = ACTIONS(4062),
    [anon_sym_QMARK] = ACTIONS(4060),
    [anon_sym_BANG] = ACTIONS(4060),
    [anon_sym_PLUS_PLUS] = ACTIONS(4062),
    [anon_sym_DASH_DASH] = ACTIONS(4062),
    [anon_sym_PLUS] = ACTIONS(4060),
    [anon_sym_DASH] = ACTIONS(4060),
    [anon_sym_STAR] = ACTIONS(4062),
    [anon_sym_SLASH] = ACTIONS(4060),
    [anon_sym_PERCENT] = ACTIONS(4062),
    [anon_sym_CARET] = ACTIONS(4062),
    [anon_sym_PIPE] = ACTIONS(4060),
    [anon_sym_AMP] = ACTIONS(4060),
    [anon_sym_LT_LT] = ACTIONS(4062),
    [anon_sym_GT_GT] = ACTIONS(4060),
    [anon_sym_GT_GT_GT] = ACTIONS(4062),
    [anon_sym_EQ_EQ] = ACTIONS(4062),
    [anon_sym_BANG_EQ] = ACTIONS(4062),
    [anon_sym_GT_EQ] = ACTIONS(4062),
    [anon_sym_LT_EQ] = ACTIONS(4062),
    [anon_sym_DOT] = ACTIONS(4060),
    [anon_sym_EQ_GT] = ACTIONS(4062),
    [anon_sym_switch] = ACTIONS(4062),
    [anon_sym_DOT_DOT] = ACTIONS(4062),
    [anon_sym_and] = ACTIONS(4062),
    [anon_sym_or] = ACTIONS(4060),
    [anon_sym_AMP_AMP] = ACTIONS(4062),
    [anon_sym_PIPE_PIPE] = ACTIONS(4062),
    [anon_sym_QMARK_QMARK] = ACTIONS(4062),
    [anon_sym_from] = ACTIONS(4062),
    [anon_sym_join] = ACTIONS(4062),
    [anon_sym_on] = ACTIONS(4062),
    [anon_sym_equals] = ACTIONS(4062),
    [anon_sym_let] = ACTIONS(4062),
    [anon_sym_orderby] = ACTIONS(4062),
    [anon_sym_group] = ACTIONS(4062),
    [anon_sym_by] = ACTIONS(4062),
    [anon_sym_select] = ACTIONS(4062),
    [anon_sym_as] = ACTIONS(4062),
    [anon_sym_is] = ACTIONS(4062),
    [anon_sym_DASH_GT] = ACTIONS(4062),
    [anon_sym_with] = ACTIONS(4062),
    [aux_sym_preproc_if_token3] = ACTIONS(4062),
    [aux_sym_preproc_else_token1] = ACTIONS(4062),
    [aux_sym_preproc_elif_token1] = ACTIONS(4062),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3669] = {
    [sym_attribute_list] = STATE(4349),
    [sym_modifier] = STATE(4458),
    [sym_accessor_declaration] = STATE(4307),
    [sym_identifier] = STATE(7807),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_region] = STATE(3669),
    [sym_preproc_endregion] = STATE(3669),
    [sym_preproc_line] = STATE(3669),
    [sym_preproc_pragma] = STATE(3669),
    [sym_preproc_nullable] = STATE(3669),
    [sym_preproc_error] = STATE(3669),
    [sym_preproc_define] = STATE(3669),
    [sym_preproc_undef] = STATE(3669),
    [aux_sym_class_declaration_repeat1] = STATE(3785),
    [aux_sym_class_declaration_repeat2] = STATE(4011),
    [aux_sym_accessor_list_repeat1] = STATE(3690),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(5456),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_unsafe] = ACTIONS(5456),
    [anon_sym_static] = ACTIONS(5456),
    [anon_sym_LBRACK] = ACTIONS(5458),
    [anon_sym_RBRACE] = ACTIONS(5460),
    [anon_sym_abstract] = ACTIONS(5456),
    [anon_sym_async] = ACTIONS(5456),
    [anon_sym_const] = ACTIONS(5456),
    [anon_sym_file] = ACTIONS(5462),
    [anon_sym_fixed] = ACTIONS(5456),
    [anon_sym_internal] = ACTIONS(5456),
    [anon_sym_new] = ACTIONS(5456),
    [anon_sym_override] = ACTIONS(5456),
    [anon_sym_partial] = ACTIONS(5456),
    [anon_sym_private] = ACTIONS(5456),
    [anon_sym_protected] = ACTIONS(5456),
    [anon_sym_public] = ACTIONS(5456),
    [anon_sym_readonly] = ACTIONS(5456),
    [anon_sym_required] = ACTIONS(5456),
    [anon_sym_sealed] = ACTIONS(5456),
    [anon_sym_virtual] = ACTIONS(5456),
    [anon_sym_volatile] = ACTIONS(5456),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_get] = ACTIONS(5464),
    [anon_sym_set] = ACTIONS(5464),
    [anon_sym_add] = ACTIONS(5464),
    [anon_sym_remove] = ACTIONS(5464),
    [anon_sym_init] = ACTIONS(5464),
    [anon_sym_scoped] = ACTIONS(27),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_from] = ACTIONS(27),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3670] = {
    [sym_preproc_region] = STATE(3670),
    [sym_preproc_endregion] = STATE(3670),
    [sym_preproc_line] = STATE(3670),
    [sym_preproc_pragma] = STATE(3670),
    [sym_preproc_nullable] = STATE(3670),
    [sym_preproc_error] = STATE(3670),
    [sym_preproc_define] = STATE(3670),
    [sym_preproc_undef] = STATE(3670),
    [anon_sym_SEMI] = ACTIONS(5466),
    [anon_sym_LBRACK] = ACTIONS(5466),
    [anon_sym_COLON] = ACTIONS(5466),
    [anon_sym_COMMA] = ACTIONS(5466),
    [anon_sym_RBRACK] = ACTIONS(5466),
    [anon_sym_LPAREN] = ACTIONS(5466),
    [anon_sym_RPAREN] = ACTIONS(5466),
    [anon_sym_RBRACE] = ACTIONS(5466),
    [anon_sym_LT] = ACTIONS(5468),
    [anon_sym_GT] = ACTIONS(5468),
    [anon_sym_in] = ACTIONS(5468),
    [anon_sym_where] = ACTIONS(5466),
    [anon_sym_QMARK] = ACTIONS(5468),
    [anon_sym_BANG] = ACTIONS(5468),
    [anon_sym_PLUS_PLUS] = ACTIONS(5466),
    [anon_sym_DASH_DASH] = ACTIONS(5466),
    [anon_sym_PLUS] = ACTIONS(5468),
    [anon_sym_DASH] = ACTIONS(5468),
    [anon_sym_STAR] = ACTIONS(5466),
    [anon_sym_SLASH] = ACTIONS(5468),
    [anon_sym_PERCENT] = ACTIONS(5466),
    [anon_sym_CARET] = ACTIONS(5466),
    [anon_sym_PIPE] = ACTIONS(5468),
    [anon_sym_AMP] = ACTIONS(5468),
    [anon_sym_LT_LT] = ACTIONS(5466),
    [anon_sym_GT_GT] = ACTIONS(5468),
    [anon_sym_GT_GT_GT] = ACTIONS(5466),
    [anon_sym_EQ_EQ] = ACTIONS(5466),
    [anon_sym_BANG_EQ] = ACTIONS(5466),
    [anon_sym_GT_EQ] = ACTIONS(5466),
    [anon_sym_LT_EQ] = ACTIONS(5466),
    [anon_sym_DOT] = ACTIONS(5468),
    [anon_sym_EQ_GT] = ACTIONS(5466),
    [anon_sym_switch] = ACTIONS(5466),
    [anon_sym_DOT_DOT] = ACTIONS(5466),
    [anon_sym_and] = ACTIONS(5466),
    [anon_sym_or] = ACTIONS(5468),
    [anon_sym_AMP_AMP] = ACTIONS(5466),
    [anon_sym_PIPE_PIPE] = ACTIONS(5466),
    [anon_sym_QMARK_QMARK] = ACTIONS(5466),
    [anon_sym_from] = ACTIONS(5466),
    [anon_sym_into] = ACTIONS(5466),
    [anon_sym_join] = ACTIONS(5466),
    [anon_sym_on] = ACTIONS(5466),
    [anon_sym_equals] = ACTIONS(5466),
    [anon_sym_let] = ACTIONS(5466),
    [anon_sym_orderby] = ACTIONS(5466),
    [anon_sym_group] = ACTIONS(5466),
    [anon_sym_by] = ACTIONS(5466),
    [anon_sym_select] = ACTIONS(5466),
    [anon_sym_as] = ACTIONS(5466),
    [anon_sym_is] = ACTIONS(5466),
    [anon_sym_DASH_GT] = ACTIONS(5466),
    [anon_sym_with] = ACTIONS(5466),
    [aux_sym_preproc_if_token3] = ACTIONS(5466),
    [aux_sym_preproc_else_token1] = ACTIONS(5466),
    [aux_sym_preproc_elif_token1] = ACTIONS(5466),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3671] = {
    [sym_preproc_region] = STATE(3671),
    [sym_preproc_endregion] = STATE(3671),
    [sym_preproc_line] = STATE(3671),
    [sym_preproc_pragma] = STATE(3671),
    [sym_preproc_nullable] = STATE(3671),
    [sym_preproc_error] = STATE(3671),
    [sym_preproc_define] = STATE(3671),
    [sym_preproc_undef] = STATE(3671),
    [anon_sym_SEMI] = ACTIONS(5470),
    [anon_sym_LBRACK] = ACTIONS(5470),
    [anon_sym_COLON] = ACTIONS(5470),
    [anon_sym_COMMA] = ACTIONS(5470),
    [anon_sym_RBRACK] = ACTIONS(5470),
    [anon_sym_LPAREN] = ACTIONS(5470),
    [anon_sym_RPAREN] = ACTIONS(5470),
    [anon_sym_RBRACE] = ACTIONS(5470),
    [anon_sym_LT] = ACTIONS(5472),
    [anon_sym_GT] = ACTIONS(5472),
    [anon_sym_in] = ACTIONS(5472),
    [anon_sym_where] = ACTIONS(5470),
    [anon_sym_QMARK] = ACTIONS(5472),
    [anon_sym_BANG] = ACTIONS(5472),
    [anon_sym_PLUS_PLUS] = ACTIONS(5470),
    [anon_sym_DASH_DASH] = ACTIONS(5470),
    [anon_sym_PLUS] = ACTIONS(5472),
    [anon_sym_DASH] = ACTIONS(5472),
    [anon_sym_STAR] = ACTIONS(5470),
    [anon_sym_SLASH] = ACTIONS(5472),
    [anon_sym_PERCENT] = ACTIONS(5470),
    [anon_sym_CARET] = ACTIONS(5470),
    [anon_sym_PIPE] = ACTIONS(5472),
    [anon_sym_AMP] = ACTIONS(5472),
    [anon_sym_LT_LT] = ACTIONS(5470),
    [anon_sym_GT_GT] = ACTIONS(5472),
    [anon_sym_GT_GT_GT] = ACTIONS(5470),
    [anon_sym_EQ_EQ] = ACTIONS(5470),
    [anon_sym_BANG_EQ] = ACTIONS(5470),
    [anon_sym_GT_EQ] = ACTIONS(5470),
    [anon_sym_LT_EQ] = ACTIONS(5470),
    [anon_sym_DOT] = ACTIONS(5472),
    [anon_sym_EQ_GT] = ACTIONS(5470),
    [anon_sym_switch] = ACTIONS(5470),
    [anon_sym_DOT_DOT] = ACTIONS(5470),
    [anon_sym_and] = ACTIONS(5470),
    [anon_sym_or] = ACTIONS(5472),
    [anon_sym_AMP_AMP] = ACTIONS(5470),
    [anon_sym_PIPE_PIPE] = ACTIONS(5470),
    [anon_sym_QMARK_QMARK] = ACTIONS(5470),
    [anon_sym_from] = ACTIONS(5470),
    [anon_sym_into] = ACTIONS(5470),
    [anon_sym_join] = ACTIONS(5470),
    [anon_sym_on] = ACTIONS(5470),
    [anon_sym_equals] = ACTIONS(5470),
    [anon_sym_let] = ACTIONS(5470),
    [anon_sym_orderby] = ACTIONS(5470),
    [anon_sym_group] = ACTIONS(5470),
    [anon_sym_by] = ACTIONS(5470),
    [anon_sym_select] = ACTIONS(5470),
    [anon_sym_as] = ACTIONS(5470),
    [anon_sym_is] = ACTIONS(5470),
    [anon_sym_DASH_GT] = ACTIONS(5470),
    [anon_sym_with] = ACTIONS(5470),
    [aux_sym_preproc_if_token3] = ACTIONS(5470),
    [aux_sym_preproc_else_token1] = ACTIONS(5470),
    [aux_sym_preproc_elif_token1] = ACTIONS(5470),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3672] = {
    [sym_preproc_region] = STATE(3672),
    [sym_preproc_endregion] = STATE(3672),
    [sym_preproc_line] = STATE(3672),
    [sym_preproc_pragma] = STATE(3672),
    [sym_preproc_nullable] = STATE(3672),
    [sym_preproc_error] = STATE(3672),
    [sym_preproc_define] = STATE(3672),
    [sym_preproc_undef] = STATE(3672),
    [anon_sym_SEMI] = ACTIONS(5474),
    [anon_sym_LBRACK] = ACTIONS(5474),
    [anon_sym_COLON] = ACTIONS(5474),
    [anon_sym_COMMA] = ACTIONS(5474),
    [anon_sym_RBRACK] = ACTIONS(5474),
    [anon_sym_LPAREN] = ACTIONS(5474),
    [anon_sym_RPAREN] = ACTIONS(5474),
    [anon_sym_RBRACE] = ACTIONS(5474),
    [anon_sym_LT] = ACTIONS(5476),
    [anon_sym_GT] = ACTIONS(5476),
    [anon_sym_in] = ACTIONS(5476),
    [anon_sym_where] = ACTIONS(5474),
    [anon_sym_QMARK] = ACTIONS(5476),
    [anon_sym_BANG] = ACTIONS(5476),
    [anon_sym_PLUS_PLUS] = ACTIONS(5474),
    [anon_sym_DASH_DASH] = ACTIONS(5474),
    [anon_sym_PLUS] = ACTIONS(5476),
    [anon_sym_DASH] = ACTIONS(5476),
    [anon_sym_STAR] = ACTIONS(5474),
    [anon_sym_SLASH] = ACTIONS(5476),
    [anon_sym_PERCENT] = ACTIONS(5474),
    [anon_sym_CARET] = ACTIONS(5474),
    [anon_sym_PIPE] = ACTIONS(5476),
    [anon_sym_AMP] = ACTIONS(5476),
    [anon_sym_LT_LT] = ACTIONS(5474),
    [anon_sym_GT_GT] = ACTIONS(5476),
    [anon_sym_GT_GT_GT] = ACTIONS(5474),
    [anon_sym_EQ_EQ] = ACTIONS(5474),
    [anon_sym_BANG_EQ] = ACTIONS(5474),
    [anon_sym_GT_EQ] = ACTIONS(5474),
    [anon_sym_LT_EQ] = ACTIONS(5474),
    [anon_sym_DOT] = ACTIONS(5476),
    [anon_sym_EQ_GT] = ACTIONS(5474),
    [anon_sym_switch] = ACTIONS(5474),
    [anon_sym_DOT_DOT] = ACTIONS(5474),
    [anon_sym_and] = ACTIONS(5474),
    [anon_sym_or] = ACTIONS(5476),
    [anon_sym_AMP_AMP] = ACTIONS(5474),
    [anon_sym_PIPE_PIPE] = ACTIONS(5474),
    [anon_sym_QMARK_QMARK] = ACTIONS(5474),
    [anon_sym_from] = ACTIONS(5474),
    [anon_sym_into] = ACTIONS(5474),
    [anon_sym_join] = ACTIONS(5474),
    [anon_sym_on] = ACTIONS(5474),
    [anon_sym_equals] = ACTIONS(5474),
    [anon_sym_let] = ACTIONS(5474),
    [anon_sym_orderby] = ACTIONS(5474),
    [anon_sym_group] = ACTIONS(5474),
    [anon_sym_by] = ACTIONS(5474),
    [anon_sym_select] = ACTIONS(5474),
    [anon_sym_as] = ACTIONS(5474),
    [anon_sym_is] = ACTIONS(5474),
    [anon_sym_DASH_GT] = ACTIONS(5474),
    [anon_sym_with] = ACTIONS(5474),
    [aux_sym_preproc_if_token3] = ACTIONS(5474),
    [aux_sym_preproc_else_token1] = ACTIONS(5474),
    [aux_sym_preproc_elif_token1] = ACTIONS(5474),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3673] = {
    [sym_preproc_region] = STATE(3673),
    [sym_preproc_endregion] = STATE(3673),
    [sym_preproc_line] = STATE(3673),
    [sym_preproc_pragma] = STATE(3673),
    [sym_preproc_nullable] = STATE(3673),
    [sym_preproc_error] = STATE(3673),
    [sym_preproc_define] = STATE(3673),
    [sym_preproc_undef] = STATE(3673),
    [anon_sym_SEMI] = ACTIONS(5478),
    [anon_sym_LBRACK] = ACTIONS(5478),
    [anon_sym_COLON] = ACTIONS(5478),
    [anon_sym_COMMA] = ACTIONS(5478),
    [anon_sym_RBRACK] = ACTIONS(5478),
    [anon_sym_LPAREN] = ACTIONS(5478),
    [anon_sym_RPAREN] = ACTIONS(5478),
    [anon_sym_RBRACE] = ACTIONS(5478),
    [anon_sym_LT] = ACTIONS(5480),
    [anon_sym_GT] = ACTIONS(5480),
    [anon_sym_in] = ACTIONS(5480),
    [anon_sym_where] = ACTIONS(5478),
    [anon_sym_QMARK] = ACTIONS(5480),
    [anon_sym_BANG] = ACTIONS(5480),
    [anon_sym_PLUS_PLUS] = ACTIONS(5478),
    [anon_sym_DASH_DASH] = ACTIONS(5478),
    [anon_sym_PLUS] = ACTIONS(5480),
    [anon_sym_DASH] = ACTIONS(5480),
    [anon_sym_STAR] = ACTIONS(5478),
    [anon_sym_SLASH] = ACTIONS(5480),
    [anon_sym_PERCENT] = ACTIONS(5478),
    [anon_sym_CARET] = ACTIONS(5478),
    [anon_sym_PIPE] = ACTIONS(5480),
    [anon_sym_AMP] = ACTIONS(5480),
    [anon_sym_LT_LT] = ACTIONS(5478),
    [anon_sym_GT_GT] = ACTIONS(5480),
    [anon_sym_GT_GT_GT] = ACTIONS(5478),
    [anon_sym_EQ_EQ] = ACTIONS(5478),
    [anon_sym_BANG_EQ] = ACTIONS(5478),
    [anon_sym_GT_EQ] = ACTIONS(5478),
    [anon_sym_LT_EQ] = ACTIONS(5478),
    [anon_sym_DOT] = ACTIONS(5480),
    [anon_sym_EQ_GT] = ACTIONS(5478),
    [anon_sym_switch] = ACTIONS(5478),
    [anon_sym_DOT_DOT] = ACTIONS(5478),
    [anon_sym_and] = ACTIONS(5478),
    [anon_sym_or] = ACTIONS(5480),
    [anon_sym_AMP_AMP] = ACTIONS(5478),
    [anon_sym_PIPE_PIPE] = ACTIONS(5478),
    [anon_sym_QMARK_QMARK] = ACTIONS(5478),
    [anon_sym_from] = ACTIONS(5478),
    [anon_sym_into] = ACTIONS(5478),
    [anon_sym_join] = ACTIONS(5478),
    [anon_sym_on] = ACTIONS(5478),
    [anon_sym_equals] = ACTIONS(5478),
    [anon_sym_let] = ACTIONS(5478),
    [anon_sym_orderby] = ACTIONS(5478),
    [anon_sym_group] = ACTIONS(5478),
    [anon_sym_by] = ACTIONS(5478),
    [anon_sym_select] = ACTIONS(5478),
    [anon_sym_as] = ACTIONS(5478),
    [anon_sym_is] = ACTIONS(5478),
    [anon_sym_DASH_GT] = ACTIONS(5478),
    [anon_sym_with] = ACTIONS(5478),
    [aux_sym_preproc_if_token3] = ACTIONS(5478),
    [aux_sym_preproc_else_token1] = ACTIONS(5478),
    [aux_sym_preproc_elif_token1] = ACTIONS(5478),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3674] = {
    [sym_preproc_region] = STATE(3674),
    [sym_preproc_endregion] = STATE(3674),
    [sym_preproc_line] = STATE(3674),
    [sym_preproc_pragma] = STATE(3674),
    [sym_preproc_nullable] = STATE(3674),
    [sym_preproc_error] = STATE(3674),
    [sym_preproc_define] = STATE(3674),
    [sym_preproc_undef] = STATE(3674),
    [anon_sym_SEMI] = ACTIONS(5482),
    [anon_sym_LBRACK] = ACTIONS(5482),
    [anon_sym_COLON] = ACTIONS(5482),
    [anon_sym_COMMA] = ACTIONS(5482),
    [anon_sym_RBRACK] = ACTIONS(5482),
    [anon_sym_LPAREN] = ACTIONS(5482),
    [anon_sym_RPAREN] = ACTIONS(5482),
    [anon_sym_RBRACE] = ACTIONS(5482),
    [anon_sym_LT] = ACTIONS(5484),
    [anon_sym_GT] = ACTIONS(5484),
    [anon_sym_in] = ACTIONS(5484),
    [anon_sym_where] = ACTIONS(5482),
    [anon_sym_QMARK] = ACTIONS(5484),
    [anon_sym_BANG] = ACTIONS(5484),
    [anon_sym_PLUS_PLUS] = ACTIONS(5482),
    [anon_sym_DASH_DASH] = ACTIONS(5482),
    [anon_sym_PLUS] = ACTIONS(5484),
    [anon_sym_DASH] = ACTIONS(5484),
    [anon_sym_STAR] = ACTIONS(5482),
    [anon_sym_SLASH] = ACTIONS(5484),
    [anon_sym_PERCENT] = ACTIONS(5482),
    [anon_sym_CARET] = ACTIONS(5482),
    [anon_sym_PIPE] = ACTIONS(5484),
    [anon_sym_AMP] = ACTIONS(5484),
    [anon_sym_LT_LT] = ACTIONS(5482),
    [anon_sym_GT_GT] = ACTIONS(5484),
    [anon_sym_GT_GT_GT] = ACTIONS(5482),
    [anon_sym_EQ_EQ] = ACTIONS(5482),
    [anon_sym_BANG_EQ] = ACTIONS(5482),
    [anon_sym_GT_EQ] = ACTIONS(5482),
    [anon_sym_LT_EQ] = ACTIONS(5482),
    [anon_sym_DOT] = ACTIONS(5484),
    [anon_sym_EQ_GT] = ACTIONS(5482),
    [anon_sym_switch] = ACTIONS(5482),
    [anon_sym_DOT_DOT] = ACTIONS(5482),
    [anon_sym_and] = ACTIONS(5482),
    [anon_sym_or] = ACTIONS(5484),
    [anon_sym_AMP_AMP] = ACTIONS(5482),
    [anon_sym_PIPE_PIPE] = ACTIONS(5482),
    [anon_sym_QMARK_QMARK] = ACTIONS(5482),
    [anon_sym_from] = ACTIONS(5482),
    [anon_sym_into] = ACTIONS(5482),
    [anon_sym_join] = ACTIONS(5482),
    [anon_sym_on] = ACTIONS(5482),
    [anon_sym_equals] = ACTIONS(5482),
    [anon_sym_let] = ACTIONS(5482),
    [anon_sym_orderby] = ACTIONS(5482),
    [anon_sym_group] = ACTIONS(5482),
    [anon_sym_by] = ACTIONS(5482),
    [anon_sym_select] = ACTIONS(5482),
    [anon_sym_as] = ACTIONS(5482),
    [anon_sym_is] = ACTIONS(5482),
    [anon_sym_DASH_GT] = ACTIONS(5482),
    [anon_sym_with] = ACTIONS(5482),
    [aux_sym_preproc_if_token3] = ACTIONS(5482),
    [aux_sym_preproc_else_token1] = ACTIONS(5482),
    [aux_sym_preproc_elif_token1] = ACTIONS(5482),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3675] = {
    [sym_preproc_region] = STATE(3675),
    [sym_preproc_endregion] = STATE(3675),
    [sym_preproc_line] = STATE(3675),
    [sym_preproc_pragma] = STATE(3675),
    [sym_preproc_nullable] = STATE(3675),
    [sym_preproc_error] = STATE(3675),
    [sym_preproc_define] = STATE(3675),
    [sym_preproc_undef] = STATE(3675),
    [anon_sym_SEMI] = ACTIONS(5486),
    [anon_sym_LBRACK] = ACTIONS(5486),
    [anon_sym_COLON] = ACTIONS(5486),
    [anon_sym_COMMA] = ACTIONS(5486),
    [anon_sym_RBRACK] = ACTIONS(5486),
    [anon_sym_LPAREN] = ACTIONS(5486),
    [anon_sym_RPAREN] = ACTIONS(5486),
    [anon_sym_RBRACE] = ACTIONS(5486),
    [anon_sym_LT] = ACTIONS(5488),
    [anon_sym_GT] = ACTIONS(5488),
    [anon_sym_in] = ACTIONS(5488),
    [anon_sym_where] = ACTIONS(5486),
    [anon_sym_QMARK] = ACTIONS(5488),
    [anon_sym_BANG] = ACTIONS(5488),
    [anon_sym_PLUS_PLUS] = ACTIONS(5486),
    [anon_sym_DASH_DASH] = ACTIONS(5486),
    [anon_sym_PLUS] = ACTIONS(5488),
    [anon_sym_DASH] = ACTIONS(5488),
    [anon_sym_STAR] = ACTIONS(5486),
    [anon_sym_SLASH] = ACTIONS(5488),
    [anon_sym_PERCENT] = ACTIONS(5486),
    [anon_sym_CARET] = ACTIONS(5486),
    [anon_sym_PIPE] = ACTIONS(5488),
    [anon_sym_AMP] = ACTIONS(5488),
    [anon_sym_LT_LT] = ACTIONS(5486),
    [anon_sym_GT_GT] = ACTIONS(5488),
    [anon_sym_GT_GT_GT] = ACTIONS(5486),
    [anon_sym_EQ_EQ] = ACTIONS(5486),
    [anon_sym_BANG_EQ] = ACTIONS(5486),
    [anon_sym_GT_EQ] = ACTIONS(5486),
    [anon_sym_LT_EQ] = ACTIONS(5486),
    [anon_sym_DOT] = ACTIONS(5488),
    [anon_sym_EQ_GT] = ACTIONS(5486),
    [anon_sym_switch] = ACTIONS(5486),
    [anon_sym_DOT_DOT] = ACTIONS(5486),
    [anon_sym_and] = ACTIONS(5486),
    [anon_sym_or] = ACTIONS(5488),
    [anon_sym_AMP_AMP] = ACTIONS(5486),
    [anon_sym_PIPE_PIPE] = ACTIONS(5486),
    [anon_sym_QMARK_QMARK] = ACTIONS(5486),
    [anon_sym_from] = ACTIONS(5486),
    [anon_sym_into] = ACTIONS(5486),
    [anon_sym_join] = ACTIONS(5486),
    [anon_sym_on] = ACTIONS(5486),
    [anon_sym_equals] = ACTIONS(5486),
    [anon_sym_let] = ACTIONS(5486),
    [anon_sym_orderby] = ACTIONS(5486),
    [anon_sym_group] = ACTIONS(5486),
    [anon_sym_by] = ACTIONS(5486),
    [anon_sym_select] = ACTIONS(5486),
    [anon_sym_as] = ACTIONS(5486),
    [anon_sym_is] = ACTIONS(5486),
    [anon_sym_DASH_GT] = ACTIONS(5486),
    [anon_sym_with] = ACTIONS(5486),
    [aux_sym_preproc_if_token3] = ACTIONS(5486),
    [aux_sym_preproc_else_token1] = ACTIONS(5486),
    [aux_sym_preproc_elif_token1] = ACTIONS(5486),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3676] = {
    [sym_preproc_region] = STATE(3676),
    [sym_preproc_endregion] = STATE(3676),
    [sym_preproc_line] = STATE(3676),
    [sym_preproc_pragma] = STATE(3676),
    [sym_preproc_nullable] = STATE(3676),
    [sym_preproc_error] = STATE(3676),
    [sym_preproc_define] = STATE(3676),
    [sym_preproc_undef] = STATE(3676),
    [anon_sym_SEMI] = ACTIONS(4476),
    [anon_sym_LBRACK] = ACTIONS(4476),
    [anon_sym_COLON] = ACTIONS(4476),
    [anon_sym_COMMA] = ACTIONS(4476),
    [anon_sym_RBRACK] = ACTIONS(4476),
    [anon_sym_LPAREN] = ACTIONS(4476),
    [anon_sym_RPAREN] = ACTIONS(4476),
    [anon_sym_LBRACE] = ACTIONS(4476),
    [anon_sym_RBRACE] = ACTIONS(4476),
    [anon_sym_LT] = ACTIONS(4474),
    [anon_sym_GT] = ACTIONS(4474),
    [anon_sym_in] = ACTIONS(4476),
    [anon_sym_where] = ACTIONS(4476),
    [anon_sym_QMARK] = ACTIONS(4474),
    [anon_sym_BANG] = ACTIONS(4474),
    [anon_sym_PLUS_PLUS] = ACTIONS(4476),
    [anon_sym_DASH_DASH] = ACTIONS(4476),
    [anon_sym_PLUS] = ACTIONS(4474),
    [anon_sym_DASH] = ACTIONS(4474),
    [anon_sym_STAR] = ACTIONS(4476),
    [anon_sym_SLASH] = ACTIONS(4474),
    [anon_sym_PERCENT] = ACTIONS(4476),
    [anon_sym_CARET] = ACTIONS(4476),
    [anon_sym_PIPE] = ACTIONS(4474),
    [anon_sym_AMP] = ACTIONS(4474),
    [anon_sym_LT_LT] = ACTIONS(4476),
    [anon_sym_GT_GT] = ACTIONS(4474),
    [anon_sym_GT_GT_GT] = ACTIONS(4476),
    [anon_sym_EQ_EQ] = ACTIONS(4476),
    [anon_sym_BANG_EQ] = ACTIONS(4476),
    [anon_sym_GT_EQ] = ACTIONS(4476),
    [anon_sym_LT_EQ] = ACTIONS(4476),
    [anon_sym_DOT] = ACTIONS(4474),
    [anon_sym_EQ_GT] = ACTIONS(4476),
    [anon_sym_switch] = ACTIONS(4476),
    [anon_sym_DOT_DOT] = ACTIONS(4476),
    [anon_sym_and] = ACTIONS(4476),
    [anon_sym_or] = ACTIONS(4474),
    [anon_sym_AMP_AMP] = ACTIONS(4476),
    [anon_sym_PIPE_PIPE] = ACTIONS(4476),
    [anon_sym_QMARK_QMARK] = ACTIONS(4476),
    [anon_sym_from] = ACTIONS(4476),
    [anon_sym_join] = ACTIONS(4476),
    [anon_sym_on] = ACTIONS(4476),
    [anon_sym_equals] = ACTIONS(4476),
    [anon_sym_let] = ACTIONS(4476),
    [anon_sym_orderby] = ACTIONS(4476),
    [anon_sym_group] = ACTIONS(4476),
    [anon_sym_by] = ACTIONS(4476),
    [anon_sym_select] = ACTIONS(4476),
    [anon_sym_as] = ACTIONS(4476),
    [anon_sym_is] = ACTIONS(4476),
    [anon_sym_DASH_GT] = ACTIONS(4476),
    [anon_sym_with] = ACTIONS(4476),
    [aux_sym_preproc_if_token3] = ACTIONS(4476),
    [aux_sym_preproc_else_token1] = ACTIONS(4476),
    [aux_sym_preproc_elif_token1] = ACTIONS(4476),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3677] = {
    [sym_preproc_region] = STATE(3677),
    [sym_preproc_endregion] = STATE(3677),
    [sym_preproc_line] = STATE(3677),
    [sym_preproc_pragma] = STATE(3677),
    [sym_preproc_nullable] = STATE(3677),
    [sym_preproc_error] = STATE(3677),
    [sym_preproc_define] = STATE(3677),
    [sym_preproc_undef] = STATE(3677),
    [anon_sym_SEMI] = ACTIONS(5490),
    [anon_sym_LBRACK] = ACTIONS(5490),
    [anon_sym_COLON] = ACTIONS(5490),
    [anon_sym_COMMA] = ACTIONS(5490),
    [anon_sym_RBRACK] = ACTIONS(5490),
    [anon_sym_LPAREN] = ACTIONS(5490),
    [anon_sym_RPAREN] = ACTIONS(5490),
    [anon_sym_RBRACE] = ACTIONS(5490),
    [anon_sym_LT] = ACTIONS(5492),
    [anon_sym_GT] = ACTIONS(5492),
    [anon_sym_in] = ACTIONS(5492),
    [anon_sym_where] = ACTIONS(5490),
    [anon_sym_QMARK] = ACTIONS(5492),
    [anon_sym_BANG] = ACTIONS(5492),
    [anon_sym_PLUS_PLUS] = ACTIONS(5490),
    [anon_sym_DASH_DASH] = ACTIONS(5490),
    [anon_sym_PLUS] = ACTIONS(5492),
    [anon_sym_DASH] = ACTIONS(5492),
    [anon_sym_STAR] = ACTIONS(5490),
    [anon_sym_SLASH] = ACTIONS(5492),
    [anon_sym_PERCENT] = ACTIONS(5490),
    [anon_sym_CARET] = ACTIONS(5490),
    [anon_sym_PIPE] = ACTIONS(5492),
    [anon_sym_AMP] = ACTIONS(5492),
    [anon_sym_LT_LT] = ACTIONS(5490),
    [anon_sym_GT_GT] = ACTIONS(5492),
    [anon_sym_GT_GT_GT] = ACTIONS(5490),
    [anon_sym_EQ_EQ] = ACTIONS(5490),
    [anon_sym_BANG_EQ] = ACTIONS(5490),
    [anon_sym_GT_EQ] = ACTIONS(5490),
    [anon_sym_LT_EQ] = ACTIONS(5490),
    [anon_sym_DOT] = ACTIONS(5492),
    [anon_sym_EQ_GT] = ACTIONS(5490),
    [anon_sym_switch] = ACTIONS(5490),
    [anon_sym_DOT_DOT] = ACTIONS(5490),
    [anon_sym_and] = ACTIONS(5490),
    [anon_sym_or] = ACTIONS(5492),
    [anon_sym_AMP_AMP] = ACTIONS(5490),
    [anon_sym_PIPE_PIPE] = ACTIONS(5490),
    [anon_sym_QMARK_QMARK] = ACTIONS(5490),
    [anon_sym_from] = ACTIONS(5490),
    [anon_sym_into] = ACTIONS(5490),
    [anon_sym_join] = ACTIONS(5490),
    [anon_sym_on] = ACTIONS(5490),
    [anon_sym_equals] = ACTIONS(5490),
    [anon_sym_let] = ACTIONS(5490),
    [anon_sym_orderby] = ACTIONS(5490),
    [anon_sym_group] = ACTIONS(5490),
    [anon_sym_by] = ACTIONS(5490),
    [anon_sym_select] = ACTIONS(5490),
    [anon_sym_as] = ACTIONS(5490),
    [anon_sym_is] = ACTIONS(5490),
    [anon_sym_DASH_GT] = ACTIONS(5490),
    [anon_sym_with] = ACTIONS(5490),
    [aux_sym_preproc_if_token3] = ACTIONS(5490),
    [aux_sym_preproc_else_token1] = ACTIONS(5490),
    [aux_sym_preproc_elif_token1] = ACTIONS(5490),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3678] = {
    [sym_preproc_region] = STATE(3678),
    [sym_preproc_endregion] = STATE(3678),
    [sym_preproc_line] = STATE(3678),
    [sym_preproc_pragma] = STATE(3678),
    [sym_preproc_nullable] = STATE(3678),
    [sym_preproc_error] = STATE(3678),
    [sym_preproc_define] = STATE(3678),
    [sym_preproc_undef] = STATE(3678),
    [anon_sym_SEMI] = ACTIONS(5494),
    [anon_sym_LBRACK] = ACTIONS(5494),
    [anon_sym_COLON] = ACTIONS(5494),
    [anon_sym_COMMA] = ACTIONS(5494),
    [anon_sym_RBRACK] = ACTIONS(5494),
    [anon_sym_LPAREN] = ACTIONS(5494),
    [anon_sym_RPAREN] = ACTIONS(5494),
    [anon_sym_RBRACE] = ACTIONS(5494),
    [anon_sym_LT] = ACTIONS(5496),
    [anon_sym_GT] = ACTIONS(5496),
    [anon_sym_in] = ACTIONS(5496),
    [anon_sym_where] = ACTIONS(5494),
    [anon_sym_QMARK] = ACTIONS(5496),
    [anon_sym_BANG] = ACTIONS(5496),
    [anon_sym_PLUS_PLUS] = ACTIONS(5494),
    [anon_sym_DASH_DASH] = ACTIONS(5494),
    [anon_sym_PLUS] = ACTIONS(5496),
    [anon_sym_DASH] = ACTIONS(5496),
    [anon_sym_STAR] = ACTIONS(5494),
    [anon_sym_SLASH] = ACTIONS(5496),
    [anon_sym_PERCENT] = ACTIONS(5494),
    [anon_sym_CARET] = ACTIONS(5494),
    [anon_sym_PIPE] = ACTIONS(5496),
    [anon_sym_AMP] = ACTIONS(5496),
    [anon_sym_LT_LT] = ACTIONS(5494),
    [anon_sym_GT_GT] = ACTIONS(5496),
    [anon_sym_GT_GT_GT] = ACTIONS(5494),
    [anon_sym_EQ_EQ] = ACTIONS(5494),
    [anon_sym_BANG_EQ] = ACTIONS(5494),
    [anon_sym_GT_EQ] = ACTIONS(5494),
    [anon_sym_LT_EQ] = ACTIONS(5494),
    [anon_sym_DOT] = ACTIONS(5496),
    [anon_sym_EQ_GT] = ACTIONS(5494),
    [anon_sym_switch] = ACTIONS(5494),
    [anon_sym_DOT_DOT] = ACTIONS(5494),
    [anon_sym_and] = ACTIONS(5494),
    [anon_sym_or] = ACTIONS(5496),
    [anon_sym_AMP_AMP] = ACTIONS(5494),
    [anon_sym_PIPE_PIPE] = ACTIONS(5494),
    [anon_sym_QMARK_QMARK] = ACTIONS(5494),
    [anon_sym_from] = ACTIONS(5494),
    [anon_sym_into] = ACTIONS(5494),
    [anon_sym_join] = ACTIONS(5494),
    [anon_sym_on] = ACTIONS(5494),
    [anon_sym_equals] = ACTIONS(5494),
    [anon_sym_let] = ACTIONS(5494),
    [anon_sym_orderby] = ACTIONS(5494),
    [anon_sym_group] = ACTIONS(5494),
    [anon_sym_by] = ACTIONS(5494),
    [anon_sym_select] = ACTIONS(5494),
    [anon_sym_as] = ACTIONS(5494),
    [anon_sym_is] = ACTIONS(5494),
    [anon_sym_DASH_GT] = ACTIONS(5494),
    [anon_sym_with] = ACTIONS(5494),
    [aux_sym_preproc_if_token3] = ACTIONS(5494),
    [aux_sym_preproc_else_token1] = ACTIONS(5494),
    [aux_sym_preproc_elif_token1] = ACTIONS(5494),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3679] = {
    [sym_preproc_region] = STATE(3679),
    [sym_preproc_endregion] = STATE(3679),
    [sym_preproc_line] = STATE(3679),
    [sym_preproc_pragma] = STATE(3679),
    [sym_preproc_nullable] = STATE(3679),
    [sym_preproc_error] = STATE(3679),
    [sym_preproc_define] = STATE(3679),
    [sym_preproc_undef] = STATE(3679),
    [anon_sym_SEMI] = ACTIONS(5498),
    [anon_sym_LBRACK] = ACTIONS(5498),
    [anon_sym_COLON] = ACTIONS(5498),
    [anon_sym_COMMA] = ACTIONS(5498),
    [anon_sym_RBRACK] = ACTIONS(5498),
    [anon_sym_LPAREN] = ACTIONS(5498),
    [anon_sym_RPAREN] = ACTIONS(5498),
    [anon_sym_RBRACE] = ACTIONS(5498),
    [anon_sym_LT] = ACTIONS(5500),
    [anon_sym_GT] = ACTIONS(5500),
    [anon_sym_in] = ACTIONS(5500),
    [anon_sym_where] = ACTIONS(5498),
    [anon_sym_QMARK] = ACTIONS(5500),
    [anon_sym_BANG] = ACTIONS(5500),
    [anon_sym_PLUS_PLUS] = ACTIONS(5498),
    [anon_sym_DASH_DASH] = ACTIONS(5498),
    [anon_sym_PLUS] = ACTIONS(5500),
    [anon_sym_DASH] = ACTIONS(5500),
    [anon_sym_STAR] = ACTIONS(5498),
    [anon_sym_SLASH] = ACTIONS(5500),
    [anon_sym_PERCENT] = ACTIONS(5498),
    [anon_sym_CARET] = ACTIONS(5498),
    [anon_sym_PIPE] = ACTIONS(5500),
    [anon_sym_AMP] = ACTIONS(5500),
    [anon_sym_LT_LT] = ACTIONS(5498),
    [anon_sym_GT_GT] = ACTIONS(5500),
    [anon_sym_GT_GT_GT] = ACTIONS(5498),
    [anon_sym_EQ_EQ] = ACTIONS(5498),
    [anon_sym_BANG_EQ] = ACTIONS(5498),
    [anon_sym_GT_EQ] = ACTIONS(5498),
    [anon_sym_LT_EQ] = ACTIONS(5498),
    [anon_sym_DOT] = ACTIONS(5500),
    [anon_sym_EQ_GT] = ACTIONS(5498),
    [anon_sym_switch] = ACTIONS(5498),
    [anon_sym_DOT_DOT] = ACTIONS(5498),
    [anon_sym_and] = ACTIONS(5498),
    [anon_sym_or] = ACTIONS(5500),
    [anon_sym_AMP_AMP] = ACTIONS(5498),
    [anon_sym_PIPE_PIPE] = ACTIONS(5498),
    [anon_sym_QMARK_QMARK] = ACTIONS(5498),
    [anon_sym_from] = ACTIONS(5498),
    [anon_sym_into] = ACTIONS(5498),
    [anon_sym_join] = ACTIONS(5498),
    [anon_sym_on] = ACTIONS(5498),
    [anon_sym_equals] = ACTIONS(5498),
    [anon_sym_let] = ACTIONS(5498),
    [anon_sym_orderby] = ACTIONS(5498),
    [anon_sym_group] = ACTIONS(5498),
    [anon_sym_by] = ACTIONS(5498),
    [anon_sym_select] = ACTIONS(5498),
    [anon_sym_as] = ACTIONS(5498),
    [anon_sym_is] = ACTIONS(5498),
    [anon_sym_DASH_GT] = ACTIONS(5498),
    [anon_sym_with] = ACTIONS(5498),
    [aux_sym_preproc_if_token3] = ACTIONS(5498),
    [aux_sym_preproc_else_token1] = ACTIONS(5498),
    [aux_sym_preproc_elif_token1] = ACTIONS(5498),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3680] = {
    [sym_preproc_region] = STATE(3680),
    [sym_preproc_endregion] = STATE(3680),
    [sym_preproc_line] = STATE(3680),
    [sym_preproc_pragma] = STATE(3680),
    [sym_preproc_nullable] = STATE(3680),
    [sym_preproc_error] = STATE(3680),
    [sym_preproc_define] = STATE(3680),
    [sym_preproc_undef] = STATE(3680),
    [anon_sym_SEMI] = ACTIONS(5502),
    [anon_sym_LBRACK] = ACTIONS(5502),
    [anon_sym_COLON] = ACTIONS(5502),
    [anon_sym_COMMA] = ACTIONS(5502),
    [anon_sym_RBRACK] = ACTIONS(5502),
    [anon_sym_LPAREN] = ACTIONS(5502),
    [anon_sym_RPAREN] = ACTIONS(5502),
    [anon_sym_RBRACE] = ACTIONS(5502),
    [anon_sym_LT] = ACTIONS(5504),
    [anon_sym_GT] = ACTIONS(5504),
    [anon_sym_in] = ACTIONS(5504),
    [anon_sym_where] = ACTIONS(5502),
    [anon_sym_QMARK] = ACTIONS(5504),
    [anon_sym_BANG] = ACTIONS(5504),
    [anon_sym_PLUS_PLUS] = ACTIONS(5502),
    [anon_sym_DASH_DASH] = ACTIONS(5502),
    [anon_sym_PLUS] = ACTIONS(5504),
    [anon_sym_DASH] = ACTIONS(5504),
    [anon_sym_STAR] = ACTIONS(5502),
    [anon_sym_SLASH] = ACTIONS(5504),
    [anon_sym_PERCENT] = ACTIONS(5502),
    [anon_sym_CARET] = ACTIONS(5502),
    [anon_sym_PIPE] = ACTIONS(5504),
    [anon_sym_AMP] = ACTIONS(5504),
    [anon_sym_LT_LT] = ACTIONS(5502),
    [anon_sym_GT_GT] = ACTIONS(5504),
    [anon_sym_GT_GT_GT] = ACTIONS(5502),
    [anon_sym_EQ_EQ] = ACTIONS(5502),
    [anon_sym_BANG_EQ] = ACTIONS(5502),
    [anon_sym_GT_EQ] = ACTIONS(5502),
    [anon_sym_LT_EQ] = ACTIONS(5502),
    [anon_sym_DOT] = ACTIONS(5504),
    [anon_sym_EQ_GT] = ACTIONS(5502),
    [anon_sym_switch] = ACTIONS(5502),
    [anon_sym_DOT_DOT] = ACTIONS(5502),
    [anon_sym_and] = ACTIONS(5502),
    [anon_sym_or] = ACTIONS(5504),
    [anon_sym_AMP_AMP] = ACTIONS(5502),
    [anon_sym_PIPE_PIPE] = ACTIONS(5502),
    [anon_sym_QMARK_QMARK] = ACTIONS(5502),
    [anon_sym_from] = ACTIONS(5502),
    [anon_sym_into] = ACTIONS(5502),
    [anon_sym_join] = ACTIONS(5502),
    [anon_sym_on] = ACTIONS(5502),
    [anon_sym_equals] = ACTIONS(5502),
    [anon_sym_let] = ACTIONS(5502),
    [anon_sym_orderby] = ACTIONS(5502),
    [anon_sym_group] = ACTIONS(5502),
    [anon_sym_by] = ACTIONS(5502),
    [anon_sym_select] = ACTIONS(5502),
    [anon_sym_as] = ACTIONS(5502),
    [anon_sym_is] = ACTIONS(5502),
    [anon_sym_DASH_GT] = ACTIONS(5502),
    [anon_sym_with] = ACTIONS(5502),
    [aux_sym_preproc_if_token3] = ACTIONS(5502),
    [aux_sym_preproc_else_token1] = ACTIONS(5502),
    [aux_sym_preproc_elif_token1] = ACTIONS(5502),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3681] = {
    [sym_preproc_region] = STATE(3681),
    [sym_preproc_endregion] = STATE(3681),
    [sym_preproc_line] = STATE(3681),
    [sym_preproc_pragma] = STATE(3681),
    [sym_preproc_nullable] = STATE(3681),
    [sym_preproc_error] = STATE(3681),
    [sym_preproc_define] = STATE(3681),
    [sym_preproc_undef] = STATE(3681),
    [anon_sym_SEMI] = ACTIONS(5506),
    [anon_sym_LBRACK] = ACTIONS(5506),
    [anon_sym_COLON] = ACTIONS(5506),
    [anon_sym_COMMA] = ACTIONS(5506),
    [anon_sym_RBRACK] = ACTIONS(5506),
    [anon_sym_LPAREN] = ACTIONS(5506),
    [anon_sym_RPAREN] = ACTIONS(5506),
    [anon_sym_RBRACE] = ACTIONS(5506),
    [anon_sym_LT] = ACTIONS(5508),
    [anon_sym_GT] = ACTIONS(5508),
    [anon_sym_in] = ACTIONS(5508),
    [anon_sym_where] = ACTIONS(5506),
    [anon_sym_QMARK] = ACTIONS(5508),
    [anon_sym_BANG] = ACTIONS(5508),
    [anon_sym_PLUS_PLUS] = ACTIONS(5506),
    [anon_sym_DASH_DASH] = ACTIONS(5506),
    [anon_sym_PLUS] = ACTIONS(5508),
    [anon_sym_DASH] = ACTIONS(5508),
    [anon_sym_STAR] = ACTIONS(5506),
    [anon_sym_SLASH] = ACTIONS(5508),
    [anon_sym_PERCENT] = ACTIONS(5506),
    [anon_sym_CARET] = ACTIONS(5506),
    [anon_sym_PIPE] = ACTIONS(5508),
    [anon_sym_AMP] = ACTIONS(5508),
    [anon_sym_LT_LT] = ACTIONS(5506),
    [anon_sym_GT_GT] = ACTIONS(5508),
    [anon_sym_GT_GT_GT] = ACTIONS(5506),
    [anon_sym_EQ_EQ] = ACTIONS(5506),
    [anon_sym_BANG_EQ] = ACTIONS(5506),
    [anon_sym_GT_EQ] = ACTIONS(5506),
    [anon_sym_LT_EQ] = ACTIONS(5506),
    [anon_sym_DOT] = ACTIONS(5508),
    [anon_sym_EQ_GT] = ACTIONS(5506),
    [anon_sym_switch] = ACTIONS(5506),
    [anon_sym_DOT_DOT] = ACTIONS(5506),
    [anon_sym_and] = ACTIONS(5506),
    [anon_sym_or] = ACTIONS(5508),
    [anon_sym_AMP_AMP] = ACTIONS(5506),
    [anon_sym_PIPE_PIPE] = ACTIONS(5506),
    [anon_sym_QMARK_QMARK] = ACTIONS(5506),
    [anon_sym_from] = ACTIONS(5506),
    [anon_sym_into] = ACTIONS(5506),
    [anon_sym_join] = ACTIONS(5506),
    [anon_sym_on] = ACTIONS(5506),
    [anon_sym_equals] = ACTIONS(5506),
    [anon_sym_let] = ACTIONS(5506),
    [anon_sym_orderby] = ACTIONS(5506),
    [anon_sym_group] = ACTIONS(5506),
    [anon_sym_by] = ACTIONS(5506),
    [anon_sym_select] = ACTIONS(5506),
    [anon_sym_as] = ACTIONS(5506),
    [anon_sym_is] = ACTIONS(5506),
    [anon_sym_DASH_GT] = ACTIONS(5506),
    [anon_sym_with] = ACTIONS(5506),
    [aux_sym_preproc_if_token3] = ACTIONS(5506),
    [aux_sym_preproc_else_token1] = ACTIONS(5506),
    [aux_sym_preproc_elif_token1] = ACTIONS(5506),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3682] = {
    [sym_preproc_region] = STATE(3682),
    [sym_preproc_endregion] = STATE(3682),
    [sym_preproc_line] = STATE(3682),
    [sym_preproc_pragma] = STATE(3682),
    [sym_preproc_nullable] = STATE(3682),
    [sym_preproc_error] = STATE(3682),
    [sym_preproc_define] = STATE(3682),
    [sym_preproc_undef] = STATE(3682),
    [anon_sym_SEMI] = ACTIONS(5249),
    [anon_sym_LBRACK] = ACTIONS(5249),
    [anon_sym_COLON] = ACTIONS(5249),
    [anon_sym_COMMA] = ACTIONS(5249),
    [anon_sym_RBRACK] = ACTIONS(5249),
    [anon_sym_LPAREN] = ACTIONS(5249),
    [anon_sym_RPAREN] = ACTIONS(5249),
    [anon_sym_RBRACE] = ACTIONS(5249),
    [anon_sym_LT] = ACTIONS(5251),
    [anon_sym_GT] = ACTIONS(5251),
    [anon_sym_in] = ACTIONS(5251),
    [anon_sym_where] = ACTIONS(5249),
    [anon_sym_QMARK] = ACTIONS(5251),
    [anon_sym_BANG] = ACTIONS(5251),
    [anon_sym_PLUS_PLUS] = ACTIONS(5249),
    [anon_sym_DASH_DASH] = ACTIONS(5249),
    [anon_sym_PLUS] = ACTIONS(5251),
    [anon_sym_DASH] = ACTIONS(5251),
    [anon_sym_STAR] = ACTIONS(5249),
    [anon_sym_SLASH] = ACTIONS(5251),
    [anon_sym_PERCENT] = ACTIONS(5249),
    [anon_sym_CARET] = ACTIONS(5249),
    [anon_sym_PIPE] = ACTIONS(5251),
    [anon_sym_AMP] = ACTIONS(5251),
    [anon_sym_LT_LT] = ACTIONS(5249),
    [anon_sym_GT_GT] = ACTIONS(5251),
    [anon_sym_GT_GT_GT] = ACTIONS(5249),
    [anon_sym_EQ_EQ] = ACTIONS(5249),
    [anon_sym_BANG_EQ] = ACTIONS(5249),
    [anon_sym_GT_EQ] = ACTIONS(5249),
    [anon_sym_LT_EQ] = ACTIONS(5249),
    [anon_sym_DOT] = ACTIONS(5251),
    [anon_sym_EQ_GT] = ACTIONS(5249),
    [anon_sym_switch] = ACTIONS(5249),
    [anon_sym_DOT_DOT] = ACTIONS(5249),
    [anon_sym_and] = ACTIONS(5249),
    [anon_sym_or] = ACTIONS(5251),
    [anon_sym_AMP_AMP] = ACTIONS(5249),
    [anon_sym_PIPE_PIPE] = ACTIONS(5249),
    [anon_sym_QMARK_QMARK] = ACTIONS(5249),
    [anon_sym_from] = ACTIONS(5249),
    [anon_sym_into] = ACTIONS(5249),
    [anon_sym_join] = ACTIONS(5249),
    [anon_sym_on] = ACTIONS(5249),
    [anon_sym_equals] = ACTIONS(5249),
    [anon_sym_let] = ACTIONS(5249),
    [anon_sym_orderby] = ACTIONS(5249),
    [anon_sym_group] = ACTIONS(5249),
    [anon_sym_by] = ACTIONS(5249),
    [anon_sym_select] = ACTIONS(5249),
    [anon_sym_as] = ACTIONS(5249),
    [anon_sym_is] = ACTIONS(5249),
    [anon_sym_DASH_GT] = ACTIONS(5249),
    [anon_sym_with] = ACTIONS(5249),
    [aux_sym_preproc_if_token3] = ACTIONS(5249),
    [aux_sym_preproc_else_token1] = ACTIONS(5249),
    [aux_sym_preproc_elif_token1] = ACTIONS(5249),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3683] = {
    [sym_preproc_region] = STATE(3683),
    [sym_preproc_endregion] = STATE(3683),
    [sym_preproc_line] = STATE(3683),
    [sym_preproc_pragma] = STATE(3683),
    [sym_preproc_nullable] = STATE(3683),
    [sym_preproc_error] = STATE(3683),
    [sym_preproc_define] = STATE(3683),
    [sym_preproc_undef] = STATE(3683),
    [anon_sym_SEMI] = ACTIONS(5510),
    [anon_sym_LBRACK] = ACTIONS(5510),
    [anon_sym_COLON] = ACTIONS(5510),
    [anon_sym_COMMA] = ACTIONS(5510),
    [anon_sym_RBRACK] = ACTIONS(5510),
    [anon_sym_LPAREN] = ACTIONS(5510),
    [anon_sym_RPAREN] = ACTIONS(5510),
    [anon_sym_RBRACE] = ACTIONS(5510),
    [anon_sym_LT] = ACTIONS(5512),
    [anon_sym_GT] = ACTIONS(5512),
    [anon_sym_in] = ACTIONS(5512),
    [anon_sym_where] = ACTIONS(5510),
    [anon_sym_QMARK] = ACTIONS(5512),
    [anon_sym_BANG] = ACTIONS(5512),
    [anon_sym_PLUS_PLUS] = ACTIONS(5510),
    [anon_sym_DASH_DASH] = ACTIONS(5510),
    [anon_sym_PLUS] = ACTIONS(5512),
    [anon_sym_DASH] = ACTIONS(5512),
    [anon_sym_STAR] = ACTIONS(5510),
    [anon_sym_SLASH] = ACTIONS(5512),
    [anon_sym_PERCENT] = ACTIONS(5510),
    [anon_sym_CARET] = ACTIONS(5510),
    [anon_sym_PIPE] = ACTIONS(5512),
    [anon_sym_AMP] = ACTIONS(5512),
    [anon_sym_LT_LT] = ACTIONS(5510),
    [anon_sym_GT_GT] = ACTIONS(5512),
    [anon_sym_GT_GT_GT] = ACTIONS(5510),
    [anon_sym_EQ_EQ] = ACTIONS(5510),
    [anon_sym_BANG_EQ] = ACTIONS(5510),
    [anon_sym_GT_EQ] = ACTIONS(5510),
    [anon_sym_LT_EQ] = ACTIONS(5510),
    [anon_sym_DOT] = ACTIONS(5512),
    [anon_sym_EQ_GT] = ACTIONS(5510),
    [anon_sym_switch] = ACTIONS(5510),
    [anon_sym_DOT_DOT] = ACTIONS(5510),
    [anon_sym_and] = ACTIONS(5510),
    [anon_sym_or] = ACTIONS(5512),
    [anon_sym_AMP_AMP] = ACTIONS(5510),
    [anon_sym_PIPE_PIPE] = ACTIONS(5510),
    [anon_sym_QMARK_QMARK] = ACTIONS(5510),
    [anon_sym_from] = ACTIONS(5510),
    [anon_sym_into] = ACTIONS(5510),
    [anon_sym_join] = ACTIONS(5510),
    [anon_sym_on] = ACTIONS(5510),
    [anon_sym_equals] = ACTIONS(5510),
    [anon_sym_let] = ACTIONS(5510),
    [anon_sym_orderby] = ACTIONS(5510),
    [anon_sym_group] = ACTIONS(5510),
    [anon_sym_by] = ACTIONS(5510),
    [anon_sym_select] = ACTIONS(5510),
    [anon_sym_as] = ACTIONS(5510),
    [anon_sym_is] = ACTIONS(5510),
    [anon_sym_DASH_GT] = ACTIONS(5510),
    [anon_sym_with] = ACTIONS(5510),
    [aux_sym_preproc_if_token3] = ACTIONS(5510),
    [aux_sym_preproc_else_token1] = ACTIONS(5510),
    [aux_sym_preproc_elif_token1] = ACTIONS(5510),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3684] = {
    [sym_preproc_region] = STATE(3684),
    [sym_preproc_endregion] = STATE(3684),
    [sym_preproc_line] = STATE(3684),
    [sym_preproc_pragma] = STATE(3684),
    [sym_preproc_nullable] = STATE(3684),
    [sym_preproc_error] = STATE(3684),
    [sym_preproc_define] = STATE(3684),
    [sym_preproc_undef] = STATE(3684),
    [anon_sym_SEMI] = ACTIONS(5514),
    [anon_sym_LBRACK] = ACTIONS(5514),
    [anon_sym_COLON] = ACTIONS(5514),
    [anon_sym_COMMA] = ACTIONS(5514),
    [anon_sym_RBRACK] = ACTIONS(5514),
    [anon_sym_LPAREN] = ACTIONS(5514),
    [anon_sym_RPAREN] = ACTIONS(5514),
    [anon_sym_RBRACE] = ACTIONS(5514),
    [anon_sym_LT] = ACTIONS(5516),
    [anon_sym_GT] = ACTIONS(5516),
    [anon_sym_in] = ACTIONS(5516),
    [anon_sym_where] = ACTIONS(5514),
    [anon_sym_QMARK] = ACTIONS(5516),
    [anon_sym_BANG] = ACTIONS(5516),
    [anon_sym_PLUS_PLUS] = ACTIONS(5514),
    [anon_sym_DASH_DASH] = ACTIONS(5514),
    [anon_sym_PLUS] = ACTIONS(5516),
    [anon_sym_DASH] = ACTIONS(5516),
    [anon_sym_STAR] = ACTIONS(5514),
    [anon_sym_SLASH] = ACTIONS(5516),
    [anon_sym_PERCENT] = ACTIONS(5514),
    [anon_sym_CARET] = ACTIONS(5514),
    [anon_sym_PIPE] = ACTIONS(5516),
    [anon_sym_AMP] = ACTIONS(5516),
    [anon_sym_LT_LT] = ACTIONS(5514),
    [anon_sym_GT_GT] = ACTIONS(5516),
    [anon_sym_GT_GT_GT] = ACTIONS(5514),
    [anon_sym_EQ_EQ] = ACTIONS(5514),
    [anon_sym_BANG_EQ] = ACTIONS(5514),
    [anon_sym_GT_EQ] = ACTIONS(5514),
    [anon_sym_LT_EQ] = ACTIONS(5514),
    [anon_sym_DOT] = ACTIONS(5516),
    [anon_sym_EQ_GT] = ACTIONS(5514),
    [anon_sym_switch] = ACTIONS(5514),
    [anon_sym_DOT_DOT] = ACTIONS(5514),
    [anon_sym_and] = ACTIONS(5514),
    [anon_sym_or] = ACTIONS(5516),
    [anon_sym_AMP_AMP] = ACTIONS(5514),
    [anon_sym_PIPE_PIPE] = ACTIONS(5514),
    [anon_sym_QMARK_QMARK] = ACTIONS(5514),
    [anon_sym_from] = ACTIONS(5514),
    [anon_sym_into] = ACTIONS(5514),
    [anon_sym_join] = ACTIONS(5514),
    [anon_sym_on] = ACTIONS(5514),
    [anon_sym_equals] = ACTIONS(5514),
    [anon_sym_let] = ACTIONS(5514),
    [anon_sym_orderby] = ACTIONS(5514),
    [anon_sym_group] = ACTIONS(5514),
    [anon_sym_by] = ACTIONS(5514),
    [anon_sym_select] = ACTIONS(5514),
    [anon_sym_as] = ACTIONS(5514),
    [anon_sym_is] = ACTIONS(5514),
    [anon_sym_DASH_GT] = ACTIONS(5514),
    [anon_sym_with] = ACTIONS(5514),
    [aux_sym_preproc_if_token3] = ACTIONS(5514),
    [aux_sym_preproc_else_token1] = ACTIONS(5514),
    [aux_sym_preproc_elif_token1] = ACTIONS(5514),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3685] = {
    [sym_preproc_region] = STATE(3685),
    [sym_preproc_endregion] = STATE(3685),
    [sym_preproc_line] = STATE(3685),
    [sym_preproc_pragma] = STATE(3685),
    [sym_preproc_nullable] = STATE(3685),
    [sym_preproc_error] = STATE(3685),
    [sym_preproc_define] = STATE(3685),
    [sym_preproc_undef] = STATE(3685),
    [anon_sym_SEMI] = ACTIONS(5518),
    [anon_sym_LBRACK] = ACTIONS(5518),
    [anon_sym_COLON] = ACTIONS(5518),
    [anon_sym_COMMA] = ACTIONS(5518),
    [anon_sym_RBRACK] = ACTIONS(5518),
    [anon_sym_LPAREN] = ACTIONS(5518),
    [anon_sym_RPAREN] = ACTIONS(5518),
    [anon_sym_RBRACE] = ACTIONS(5518),
    [anon_sym_LT] = ACTIONS(5520),
    [anon_sym_GT] = ACTIONS(5520),
    [anon_sym_in] = ACTIONS(5520),
    [anon_sym_where] = ACTIONS(5518),
    [anon_sym_QMARK] = ACTIONS(5520),
    [anon_sym_BANG] = ACTIONS(5520),
    [anon_sym_PLUS_PLUS] = ACTIONS(5518),
    [anon_sym_DASH_DASH] = ACTIONS(5518),
    [anon_sym_PLUS] = ACTIONS(5520),
    [anon_sym_DASH] = ACTIONS(5520),
    [anon_sym_STAR] = ACTIONS(5518),
    [anon_sym_SLASH] = ACTIONS(5520),
    [anon_sym_PERCENT] = ACTIONS(5518),
    [anon_sym_CARET] = ACTIONS(5518),
    [anon_sym_PIPE] = ACTIONS(5520),
    [anon_sym_AMP] = ACTIONS(5520),
    [anon_sym_LT_LT] = ACTIONS(5518),
    [anon_sym_GT_GT] = ACTIONS(5520),
    [anon_sym_GT_GT_GT] = ACTIONS(5518),
    [anon_sym_EQ_EQ] = ACTIONS(5518),
    [anon_sym_BANG_EQ] = ACTIONS(5518),
    [anon_sym_GT_EQ] = ACTIONS(5518),
    [anon_sym_LT_EQ] = ACTIONS(5518),
    [anon_sym_DOT] = ACTIONS(5520),
    [anon_sym_EQ_GT] = ACTIONS(5518),
    [anon_sym_switch] = ACTIONS(5518),
    [anon_sym_DOT_DOT] = ACTIONS(5518),
    [anon_sym_and] = ACTIONS(5518),
    [anon_sym_or] = ACTIONS(5520),
    [anon_sym_AMP_AMP] = ACTIONS(5518),
    [anon_sym_PIPE_PIPE] = ACTIONS(5518),
    [anon_sym_QMARK_QMARK] = ACTIONS(5518),
    [anon_sym_from] = ACTIONS(5518),
    [anon_sym_into] = ACTIONS(5518),
    [anon_sym_join] = ACTIONS(5518),
    [anon_sym_on] = ACTIONS(5518),
    [anon_sym_equals] = ACTIONS(5518),
    [anon_sym_let] = ACTIONS(5518),
    [anon_sym_orderby] = ACTIONS(5518),
    [anon_sym_group] = ACTIONS(5518),
    [anon_sym_by] = ACTIONS(5518),
    [anon_sym_select] = ACTIONS(5518),
    [anon_sym_as] = ACTIONS(5518),
    [anon_sym_is] = ACTIONS(5518),
    [anon_sym_DASH_GT] = ACTIONS(5518),
    [anon_sym_with] = ACTIONS(5518),
    [aux_sym_preproc_if_token3] = ACTIONS(5518),
    [aux_sym_preproc_else_token1] = ACTIONS(5518),
    [aux_sym_preproc_elif_token1] = ACTIONS(5518),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3686] = {
    [sym_preproc_region] = STATE(3686),
    [sym_preproc_endregion] = STATE(3686),
    [sym_preproc_line] = STATE(3686),
    [sym_preproc_pragma] = STATE(3686),
    [sym_preproc_nullable] = STATE(3686),
    [sym_preproc_error] = STATE(3686),
    [sym_preproc_define] = STATE(3686),
    [sym_preproc_undef] = STATE(3686),
    [anon_sym_SEMI] = ACTIONS(5522),
    [anon_sym_LBRACK] = ACTIONS(5522),
    [anon_sym_COLON] = ACTIONS(5522),
    [anon_sym_COMMA] = ACTIONS(5522),
    [anon_sym_RBRACK] = ACTIONS(5522),
    [anon_sym_LPAREN] = ACTIONS(5522),
    [anon_sym_RPAREN] = ACTIONS(5522),
    [anon_sym_RBRACE] = ACTIONS(5522),
    [anon_sym_LT] = ACTIONS(5524),
    [anon_sym_GT] = ACTIONS(5524),
    [anon_sym_in] = ACTIONS(5524),
    [anon_sym_where] = ACTIONS(5522),
    [anon_sym_QMARK] = ACTIONS(5524),
    [anon_sym_BANG] = ACTIONS(5524),
    [anon_sym_PLUS_PLUS] = ACTIONS(5522),
    [anon_sym_DASH_DASH] = ACTIONS(5522),
    [anon_sym_PLUS] = ACTIONS(5524),
    [anon_sym_DASH] = ACTIONS(5524),
    [anon_sym_STAR] = ACTIONS(5522),
    [anon_sym_SLASH] = ACTIONS(5524),
    [anon_sym_PERCENT] = ACTIONS(5522),
    [anon_sym_CARET] = ACTIONS(5522),
    [anon_sym_PIPE] = ACTIONS(5524),
    [anon_sym_AMP] = ACTIONS(5524),
    [anon_sym_LT_LT] = ACTIONS(5522),
    [anon_sym_GT_GT] = ACTIONS(5524),
    [anon_sym_GT_GT_GT] = ACTIONS(5522),
    [anon_sym_EQ_EQ] = ACTIONS(5522),
    [anon_sym_BANG_EQ] = ACTIONS(5522),
    [anon_sym_GT_EQ] = ACTIONS(5522),
    [anon_sym_LT_EQ] = ACTIONS(5522),
    [anon_sym_DOT] = ACTIONS(5524),
    [anon_sym_EQ_GT] = ACTIONS(5522),
    [anon_sym_switch] = ACTIONS(5522),
    [anon_sym_DOT_DOT] = ACTIONS(5522),
    [anon_sym_and] = ACTIONS(5522),
    [anon_sym_or] = ACTIONS(5524),
    [anon_sym_AMP_AMP] = ACTIONS(5522),
    [anon_sym_PIPE_PIPE] = ACTIONS(5522),
    [anon_sym_QMARK_QMARK] = ACTIONS(5522),
    [anon_sym_from] = ACTIONS(5522),
    [anon_sym_into] = ACTIONS(5522),
    [anon_sym_join] = ACTIONS(5522),
    [anon_sym_on] = ACTIONS(5522),
    [anon_sym_equals] = ACTIONS(5522),
    [anon_sym_let] = ACTIONS(5522),
    [anon_sym_orderby] = ACTIONS(5522),
    [anon_sym_group] = ACTIONS(5522),
    [anon_sym_by] = ACTIONS(5522),
    [anon_sym_select] = ACTIONS(5522),
    [anon_sym_as] = ACTIONS(5522),
    [anon_sym_is] = ACTIONS(5522),
    [anon_sym_DASH_GT] = ACTIONS(5522),
    [anon_sym_with] = ACTIONS(5522),
    [aux_sym_preproc_if_token3] = ACTIONS(5522),
    [aux_sym_preproc_else_token1] = ACTIONS(5522),
    [aux_sym_preproc_elif_token1] = ACTIONS(5522),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3687] = {
    [sym_preproc_region] = STATE(3687),
    [sym_preproc_endregion] = STATE(3687),
    [sym_preproc_line] = STATE(3687),
    [sym_preproc_pragma] = STATE(3687),
    [sym_preproc_nullable] = STATE(3687),
    [sym_preproc_error] = STATE(3687),
    [sym_preproc_define] = STATE(3687),
    [sym_preproc_undef] = STATE(3687),
    [anon_sym_SEMI] = ACTIONS(4087),
    [anon_sym_LBRACK] = ACTIONS(4087),
    [anon_sym_COLON] = ACTIONS(4087),
    [anon_sym_COMMA] = ACTIONS(4087),
    [anon_sym_RBRACK] = ACTIONS(4087),
    [anon_sym_LPAREN] = ACTIONS(4087),
    [anon_sym_RPAREN] = ACTIONS(4087),
    [anon_sym_LBRACE] = ACTIONS(4087),
    [anon_sym_RBRACE] = ACTIONS(4087),
    [anon_sym_LT] = ACTIONS(4085),
    [anon_sym_GT] = ACTIONS(4085),
    [anon_sym_in] = ACTIONS(4087),
    [anon_sym_where] = ACTIONS(4087),
    [anon_sym_QMARK] = ACTIONS(4085),
    [anon_sym_BANG] = ACTIONS(4085),
    [anon_sym_PLUS_PLUS] = ACTIONS(4087),
    [anon_sym_DASH_DASH] = ACTIONS(4087),
    [anon_sym_PLUS] = ACTIONS(4085),
    [anon_sym_DASH] = ACTIONS(4085),
    [anon_sym_STAR] = ACTIONS(4087),
    [anon_sym_SLASH] = ACTIONS(4085),
    [anon_sym_PERCENT] = ACTIONS(4087),
    [anon_sym_CARET] = ACTIONS(4087),
    [anon_sym_PIPE] = ACTIONS(4085),
    [anon_sym_AMP] = ACTIONS(4085),
    [anon_sym_LT_LT] = ACTIONS(4087),
    [anon_sym_GT_GT] = ACTIONS(4085),
    [anon_sym_GT_GT_GT] = ACTIONS(4087),
    [anon_sym_EQ_EQ] = ACTIONS(4087),
    [anon_sym_BANG_EQ] = ACTIONS(4087),
    [anon_sym_GT_EQ] = ACTIONS(4087),
    [anon_sym_LT_EQ] = ACTIONS(4087),
    [anon_sym_DOT] = ACTIONS(4085),
    [anon_sym_EQ_GT] = ACTIONS(4087),
    [anon_sym_switch] = ACTIONS(4087),
    [anon_sym_DOT_DOT] = ACTIONS(4087),
    [anon_sym_and] = ACTIONS(4087),
    [anon_sym_or] = ACTIONS(4085),
    [anon_sym_AMP_AMP] = ACTIONS(4087),
    [anon_sym_PIPE_PIPE] = ACTIONS(4087),
    [anon_sym_QMARK_QMARK] = ACTIONS(4087),
    [anon_sym_from] = ACTIONS(4087),
    [anon_sym_join] = ACTIONS(4087),
    [anon_sym_on] = ACTIONS(4087),
    [anon_sym_equals] = ACTIONS(4087),
    [anon_sym_let] = ACTIONS(4087),
    [anon_sym_orderby] = ACTIONS(4087),
    [anon_sym_group] = ACTIONS(4087),
    [anon_sym_by] = ACTIONS(4087),
    [anon_sym_select] = ACTIONS(4087),
    [anon_sym_as] = ACTIONS(4087),
    [anon_sym_is] = ACTIONS(4087),
    [anon_sym_DASH_GT] = ACTIONS(4087),
    [anon_sym_with] = ACTIONS(4087),
    [aux_sym_preproc_if_token3] = ACTIONS(4087),
    [aux_sym_preproc_else_token1] = ACTIONS(4087),
    [aux_sym_preproc_elif_token1] = ACTIONS(4087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3688] = {
    [sym_preproc_region] = STATE(3688),
    [sym_preproc_endregion] = STATE(3688),
    [sym_preproc_line] = STATE(3688),
    [sym_preproc_pragma] = STATE(3688),
    [sym_preproc_nullable] = STATE(3688),
    [sym_preproc_error] = STATE(3688),
    [sym_preproc_define] = STATE(3688),
    [sym_preproc_undef] = STATE(3688),
    [anon_sym_SEMI] = ACTIONS(5526),
    [anon_sym_LBRACK] = ACTIONS(5526),
    [anon_sym_COLON] = ACTIONS(5526),
    [anon_sym_COMMA] = ACTIONS(5526),
    [anon_sym_RBRACK] = ACTIONS(5526),
    [anon_sym_LPAREN] = ACTIONS(5526),
    [anon_sym_RPAREN] = ACTIONS(5526),
    [anon_sym_RBRACE] = ACTIONS(5526),
    [anon_sym_LT] = ACTIONS(5528),
    [anon_sym_GT] = ACTIONS(5528),
    [anon_sym_in] = ACTIONS(5528),
    [anon_sym_where] = ACTIONS(5526),
    [anon_sym_QMARK] = ACTIONS(5528),
    [anon_sym_BANG] = ACTIONS(5528),
    [anon_sym_PLUS_PLUS] = ACTIONS(5526),
    [anon_sym_DASH_DASH] = ACTIONS(5526),
    [anon_sym_PLUS] = ACTIONS(5528),
    [anon_sym_DASH] = ACTIONS(5528),
    [anon_sym_STAR] = ACTIONS(5526),
    [anon_sym_SLASH] = ACTIONS(5528),
    [anon_sym_PERCENT] = ACTIONS(5526),
    [anon_sym_CARET] = ACTIONS(5526),
    [anon_sym_PIPE] = ACTIONS(5528),
    [anon_sym_AMP] = ACTIONS(5528),
    [anon_sym_LT_LT] = ACTIONS(5526),
    [anon_sym_GT_GT] = ACTIONS(5528),
    [anon_sym_GT_GT_GT] = ACTIONS(5526),
    [anon_sym_EQ_EQ] = ACTIONS(5526),
    [anon_sym_BANG_EQ] = ACTIONS(5526),
    [anon_sym_GT_EQ] = ACTIONS(5526),
    [anon_sym_LT_EQ] = ACTIONS(5526),
    [anon_sym_DOT] = ACTIONS(5528),
    [anon_sym_EQ_GT] = ACTIONS(5526),
    [anon_sym_switch] = ACTIONS(5526),
    [anon_sym_DOT_DOT] = ACTIONS(5526),
    [anon_sym_and] = ACTIONS(5526),
    [anon_sym_or] = ACTIONS(5528),
    [anon_sym_AMP_AMP] = ACTIONS(5526),
    [anon_sym_PIPE_PIPE] = ACTIONS(5526),
    [anon_sym_QMARK_QMARK] = ACTIONS(5526),
    [anon_sym_from] = ACTIONS(5526),
    [anon_sym_into] = ACTIONS(5526),
    [anon_sym_join] = ACTIONS(5526),
    [anon_sym_on] = ACTIONS(5526),
    [anon_sym_equals] = ACTIONS(5526),
    [anon_sym_let] = ACTIONS(5526),
    [anon_sym_orderby] = ACTIONS(5526),
    [anon_sym_group] = ACTIONS(5526),
    [anon_sym_by] = ACTIONS(5526),
    [anon_sym_select] = ACTIONS(5526),
    [anon_sym_as] = ACTIONS(5526),
    [anon_sym_is] = ACTIONS(5526),
    [anon_sym_DASH_GT] = ACTIONS(5526),
    [anon_sym_with] = ACTIONS(5526),
    [aux_sym_preproc_if_token3] = ACTIONS(5526),
    [aux_sym_preproc_else_token1] = ACTIONS(5526),
    [aux_sym_preproc_elif_token1] = ACTIONS(5526),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3689] = {
    [sym_attribute_list] = STATE(4349),
    [sym_modifier] = STATE(4458),
    [sym_accessor_declaration] = STATE(4307),
    [sym_identifier] = STATE(7807),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_region] = STATE(3689),
    [sym_preproc_endregion] = STATE(3689),
    [sym_preproc_line] = STATE(3689),
    [sym_preproc_pragma] = STATE(3689),
    [sym_preproc_nullable] = STATE(3689),
    [sym_preproc_error] = STATE(3689),
    [sym_preproc_define] = STATE(3689),
    [sym_preproc_undef] = STATE(3689),
    [aux_sym_class_declaration_repeat1] = STATE(3785),
    [aux_sym_class_declaration_repeat2] = STATE(4011),
    [aux_sym_accessor_list_repeat1] = STATE(3689),
    [sym__identifier_token] = ACTIONS(5530),
    [anon_sym_extern] = ACTIONS(5533),
    [anon_sym_alias] = ACTIONS(5536),
    [anon_sym_global] = ACTIONS(5536),
    [anon_sym_unsafe] = ACTIONS(5533),
    [anon_sym_static] = ACTIONS(5533),
    [anon_sym_LBRACK] = ACTIONS(5539),
    [anon_sym_RBRACE] = ACTIONS(5542),
    [anon_sym_abstract] = ACTIONS(5533),
    [anon_sym_async] = ACTIONS(5533),
    [anon_sym_const] = ACTIONS(5533),
    [anon_sym_file] = ACTIONS(5544),
    [anon_sym_fixed] = ACTIONS(5533),
    [anon_sym_internal] = ACTIONS(5533),
    [anon_sym_new] = ACTIONS(5533),
    [anon_sym_override] = ACTIONS(5533),
    [anon_sym_partial] = ACTIONS(5533),
    [anon_sym_private] = ACTIONS(5533),
    [anon_sym_protected] = ACTIONS(5533),
    [anon_sym_public] = ACTIONS(5533),
    [anon_sym_readonly] = ACTIONS(5533),
    [anon_sym_required] = ACTIONS(5533),
    [anon_sym_sealed] = ACTIONS(5533),
    [anon_sym_virtual] = ACTIONS(5533),
    [anon_sym_volatile] = ACTIONS(5533),
    [anon_sym_where] = ACTIONS(5536),
    [anon_sym_notnull] = ACTIONS(5536),
    [anon_sym_unmanaged] = ACTIONS(5536),
    [anon_sym_get] = ACTIONS(5547),
    [anon_sym_set] = ACTIONS(5547),
    [anon_sym_add] = ACTIONS(5547),
    [anon_sym_remove] = ACTIONS(5547),
    [anon_sym_init] = ACTIONS(5547),
    [anon_sym_scoped] = ACTIONS(5536),
    [anon_sym_var] = ACTIONS(5536),
    [anon_sym_yield] = ACTIONS(5536),
    [anon_sym_when] = ACTIONS(5536),
    [anon_sym_from] = ACTIONS(5536),
    [anon_sym_into] = ACTIONS(5536),
    [anon_sym_join] = ACTIONS(5536),
    [anon_sym_on] = ACTIONS(5536),
    [anon_sym_equals] = ACTIONS(5536),
    [anon_sym_let] = ACTIONS(5536),
    [anon_sym_orderby] = ACTIONS(5536),
    [anon_sym_ascending] = ACTIONS(5536),
    [anon_sym_descending] = ACTIONS(5536),
    [anon_sym_group] = ACTIONS(5536),
    [anon_sym_by] = ACTIONS(5536),
    [anon_sym_select] = ACTIONS(5536),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3690] = {
    [sym_attribute_list] = STATE(4349),
    [sym_modifier] = STATE(4458),
    [sym_accessor_declaration] = STATE(4307),
    [sym_identifier] = STATE(7807),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_region] = STATE(3690),
    [sym_preproc_endregion] = STATE(3690),
    [sym_preproc_line] = STATE(3690),
    [sym_preproc_pragma] = STATE(3690),
    [sym_preproc_nullable] = STATE(3690),
    [sym_preproc_error] = STATE(3690),
    [sym_preproc_define] = STATE(3690),
    [sym_preproc_undef] = STATE(3690),
    [aux_sym_class_declaration_repeat1] = STATE(3785),
    [aux_sym_class_declaration_repeat2] = STATE(4011),
    [aux_sym_accessor_list_repeat1] = STATE(3689),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(5456),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_unsafe] = ACTIONS(5456),
    [anon_sym_static] = ACTIONS(5456),
    [anon_sym_LBRACK] = ACTIONS(5458),
    [anon_sym_RBRACE] = ACTIONS(5550),
    [anon_sym_abstract] = ACTIONS(5456),
    [anon_sym_async] = ACTIONS(5456),
    [anon_sym_const] = ACTIONS(5456),
    [anon_sym_file] = ACTIONS(5462),
    [anon_sym_fixed] = ACTIONS(5456),
    [anon_sym_internal] = ACTIONS(5456),
    [anon_sym_new] = ACTIONS(5456),
    [anon_sym_override] = ACTIONS(5456),
    [anon_sym_partial] = ACTIONS(5456),
    [anon_sym_private] = ACTIONS(5456),
    [anon_sym_protected] = ACTIONS(5456),
    [anon_sym_public] = ACTIONS(5456),
    [anon_sym_readonly] = ACTIONS(5456),
    [anon_sym_required] = ACTIONS(5456),
    [anon_sym_sealed] = ACTIONS(5456),
    [anon_sym_virtual] = ACTIONS(5456),
    [anon_sym_volatile] = ACTIONS(5456),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_get] = ACTIONS(5464),
    [anon_sym_set] = ACTIONS(5464),
    [anon_sym_add] = ACTIONS(5464),
    [anon_sym_remove] = ACTIONS(5464),
    [anon_sym_init] = ACTIONS(5464),
    [anon_sym_scoped] = ACTIONS(27),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_from] = ACTIONS(27),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3691] = {
    [sym_preproc_region] = STATE(3691),
    [sym_preproc_endregion] = STATE(3691),
    [sym_preproc_line] = STATE(3691),
    [sym_preproc_pragma] = STATE(3691),
    [sym_preproc_nullable] = STATE(3691),
    [sym_preproc_error] = STATE(3691),
    [sym_preproc_define] = STATE(3691),
    [sym_preproc_undef] = STATE(3691),
    [anon_sym_EQ] = ACTIONS(5552),
    [anon_sym_LBRACK] = ACTIONS(5249),
    [anon_sym_COMMA] = ACTIONS(5249),
    [anon_sym_LPAREN] = ACTIONS(5249),
    [anon_sym_LT] = ACTIONS(5251),
    [anon_sym_GT] = ACTIONS(5251),
    [anon_sym_where] = ACTIONS(5249),
    [anon_sym_QMARK] = ACTIONS(5251),
    [anon_sym_BANG] = ACTIONS(5251),
    [anon_sym_PLUS_PLUS] = ACTIONS(5249),
    [anon_sym_DASH_DASH] = ACTIONS(5249),
    [anon_sym_PLUS] = ACTIONS(5251),
    [anon_sym_DASH] = ACTIONS(5251),
    [anon_sym_STAR] = ACTIONS(5251),
    [anon_sym_SLASH] = ACTIONS(5251),
    [anon_sym_PERCENT] = ACTIONS(5251),
    [anon_sym_CARET] = ACTIONS(5251),
    [anon_sym_PIPE] = ACTIONS(5251),
    [anon_sym_AMP] = ACTIONS(5251),
    [anon_sym_LT_LT] = ACTIONS(5251),
    [anon_sym_GT_GT] = ACTIONS(5251),
    [anon_sym_GT_GT_GT] = ACTIONS(5251),
    [anon_sym_EQ_EQ] = ACTIONS(5249),
    [anon_sym_BANG_EQ] = ACTIONS(5249),
    [anon_sym_GT_EQ] = ACTIONS(5249),
    [anon_sym_LT_EQ] = ACTIONS(5249),
    [anon_sym_DOT] = ACTIONS(5251),
    [anon_sym_switch] = ACTIONS(5249),
    [anon_sym_DOT_DOT] = ACTIONS(5249),
    [anon_sym_PLUS_EQ] = ACTIONS(5554),
    [anon_sym_DASH_EQ] = ACTIONS(5554),
    [anon_sym_STAR_EQ] = ACTIONS(5554),
    [anon_sym_SLASH_EQ] = ACTIONS(5554),
    [anon_sym_PERCENT_EQ] = ACTIONS(5554),
    [anon_sym_AMP_EQ] = ACTIONS(5554),
    [anon_sym_CARET_EQ] = ACTIONS(5554),
    [anon_sym_PIPE_EQ] = ACTIONS(5554),
    [anon_sym_LT_LT_EQ] = ACTIONS(5554),
    [anon_sym_GT_GT_EQ] = ACTIONS(5554),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5554),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(5554),
    [anon_sym_AMP_AMP] = ACTIONS(5249),
    [anon_sym_PIPE_PIPE] = ACTIONS(5249),
    [anon_sym_QMARK_QMARK] = ACTIONS(5251),
    [anon_sym_from] = ACTIONS(5249),
    [anon_sym_into] = ACTIONS(5249),
    [anon_sym_join] = ACTIONS(5249),
    [anon_sym_let] = ACTIONS(5249),
    [anon_sym_orderby] = ACTIONS(5249),
    [anon_sym_ascending] = ACTIONS(5249),
    [anon_sym_descending] = ACTIONS(5249),
    [anon_sym_group] = ACTIONS(5249),
    [anon_sym_select] = ACTIONS(5249),
    [anon_sym_as] = ACTIONS(5251),
    [anon_sym_is] = ACTIONS(5249),
    [anon_sym_DASH_GT] = ACTIONS(5249),
    [anon_sym_with] = ACTIONS(5249),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3692] = {
    [sym_preproc_region] = STATE(3692),
    [sym_preproc_endregion] = STATE(3692),
    [sym_preproc_line] = STATE(3692),
    [sym_preproc_pragma] = STATE(3692),
    [sym_preproc_nullable] = STATE(3692),
    [sym_preproc_error] = STATE(3692),
    [sym_preproc_define] = STATE(3692),
    [sym_preproc_undef] = STATE(3692),
    [anon_sym_SEMI] = ACTIONS(5556),
    [anon_sym_LBRACK] = ACTIONS(5556),
    [anon_sym_COLON] = ACTIONS(5556),
    [anon_sym_COMMA] = ACTIONS(5556),
    [anon_sym_RBRACK] = ACTIONS(5556),
    [anon_sym_LPAREN] = ACTIONS(5556),
    [anon_sym_RPAREN] = ACTIONS(5556),
    [anon_sym_RBRACE] = ACTIONS(5556),
    [anon_sym_LT] = ACTIONS(5558),
    [anon_sym_GT] = ACTIONS(5558),
    [anon_sym_in] = ACTIONS(5558),
    [anon_sym_where] = ACTIONS(5556),
    [anon_sym_QMARK] = ACTIONS(5558),
    [anon_sym_BANG] = ACTIONS(5558),
    [anon_sym_PLUS_PLUS] = ACTIONS(5556),
    [anon_sym_DASH_DASH] = ACTIONS(5556),
    [anon_sym_PLUS] = ACTIONS(5558),
    [anon_sym_DASH] = ACTIONS(5558),
    [anon_sym_STAR] = ACTIONS(5556),
    [anon_sym_SLASH] = ACTIONS(5558),
    [anon_sym_PERCENT] = ACTIONS(5556),
    [anon_sym_CARET] = ACTIONS(5556),
    [anon_sym_PIPE] = ACTIONS(5558),
    [anon_sym_AMP] = ACTIONS(5558),
    [anon_sym_LT_LT] = ACTIONS(5556),
    [anon_sym_GT_GT] = ACTIONS(5558),
    [anon_sym_GT_GT_GT] = ACTIONS(5556),
    [anon_sym_EQ_EQ] = ACTIONS(5556),
    [anon_sym_BANG_EQ] = ACTIONS(5556),
    [anon_sym_GT_EQ] = ACTIONS(5556),
    [anon_sym_LT_EQ] = ACTIONS(5556),
    [anon_sym_DOT] = ACTIONS(5558),
    [anon_sym_EQ_GT] = ACTIONS(5556),
    [anon_sym_switch] = ACTIONS(5556),
    [anon_sym_DOT_DOT] = ACTIONS(5556),
    [anon_sym_and] = ACTIONS(5556),
    [anon_sym_or] = ACTIONS(5558),
    [anon_sym_AMP_AMP] = ACTIONS(5556),
    [anon_sym_PIPE_PIPE] = ACTIONS(5556),
    [anon_sym_QMARK_QMARK] = ACTIONS(5556),
    [anon_sym_from] = ACTIONS(5556),
    [anon_sym_into] = ACTIONS(5556),
    [anon_sym_join] = ACTIONS(5556),
    [anon_sym_on] = ACTIONS(5556),
    [anon_sym_equals] = ACTIONS(5556),
    [anon_sym_let] = ACTIONS(5556),
    [anon_sym_orderby] = ACTIONS(5556),
    [anon_sym_group] = ACTIONS(5556),
    [anon_sym_by] = ACTIONS(5556),
    [anon_sym_select] = ACTIONS(5556),
    [anon_sym_as] = ACTIONS(5556),
    [anon_sym_is] = ACTIONS(5556),
    [anon_sym_DASH_GT] = ACTIONS(5556),
    [anon_sym_with] = ACTIONS(5556),
    [aux_sym_preproc_if_token3] = ACTIONS(5556),
    [aux_sym_preproc_else_token1] = ACTIONS(5556),
    [aux_sym_preproc_elif_token1] = ACTIONS(5556),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3693] = {
    [sym_preproc_region] = STATE(3693),
    [sym_preproc_endregion] = STATE(3693),
    [sym_preproc_line] = STATE(3693),
    [sym_preproc_pragma] = STATE(3693),
    [sym_preproc_nullable] = STATE(3693),
    [sym_preproc_error] = STATE(3693),
    [sym_preproc_define] = STATE(3693),
    [sym_preproc_undef] = STATE(3693),
    [anon_sym_SEMI] = ACTIONS(5560),
    [anon_sym_LBRACK] = ACTIONS(5560),
    [anon_sym_COLON] = ACTIONS(5560),
    [anon_sym_COMMA] = ACTIONS(5560),
    [anon_sym_RBRACK] = ACTIONS(5560),
    [anon_sym_LPAREN] = ACTIONS(5560),
    [anon_sym_RPAREN] = ACTIONS(5560),
    [anon_sym_RBRACE] = ACTIONS(5560),
    [anon_sym_LT] = ACTIONS(5562),
    [anon_sym_GT] = ACTIONS(5562),
    [anon_sym_in] = ACTIONS(5562),
    [anon_sym_where] = ACTIONS(5560),
    [anon_sym_QMARK] = ACTIONS(5562),
    [anon_sym_BANG] = ACTIONS(5562),
    [anon_sym_PLUS_PLUS] = ACTIONS(5560),
    [anon_sym_DASH_DASH] = ACTIONS(5560),
    [anon_sym_PLUS] = ACTIONS(5562),
    [anon_sym_DASH] = ACTIONS(5562),
    [anon_sym_STAR] = ACTIONS(5560),
    [anon_sym_SLASH] = ACTIONS(5562),
    [anon_sym_PERCENT] = ACTIONS(5560),
    [anon_sym_CARET] = ACTIONS(5560),
    [anon_sym_PIPE] = ACTIONS(5562),
    [anon_sym_AMP] = ACTIONS(5562),
    [anon_sym_LT_LT] = ACTIONS(5560),
    [anon_sym_GT_GT] = ACTIONS(5562),
    [anon_sym_GT_GT_GT] = ACTIONS(5560),
    [anon_sym_EQ_EQ] = ACTIONS(5560),
    [anon_sym_BANG_EQ] = ACTIONS(5560),
    [anon_sym_GT_EQ] = ACTIONS(5560),
    [anon_sym_LT_EQ] = ACTIONS(5560),
    [anon_sym_DOT] = ACTIONS(5562),
    [anon_sym_EQ_GT] = ACTIONS(5560),
    [anon_sym_switch] = ACTIONS(5560),
    [anon_sym_DOT_DOT] = ACTIONS(5560),
    [anon_sym_and] = ACTIONS(5560),
    [anon_sym_or] = ACTIONS(5562),
    [anon_sym_AMP_AMP] = ACTIONS(5560),
    [anon_sym_PIPE_PIPE] = ACTIONS(5560),
    [anon_sym_QMARK_QMARK] = ACTIONS(5560),
    [anon_sym_from] = ACTIONS(5560),
    [anon_sym_into] = ACTIONS(5560),
    [anon_sym_join] = ACTIONS(5560),
    [anon_sym_on] = ACTIONS(5560),
    [anon_sym_equals] = ACTIONS(5560),
    [anon_sym_let] = ACTIONS(5560),
    [anon_sym_orderby] = ACTIONS(5560),
    [anon_sym_group] = ACTIONS(5560),
    [anon_sym_by] = ACTIONS(5560),
    [anon_sym_select] = ACTIONS(5560),
    [anon_sym_as] = ACTIONS(5560),
    [anon_sym_is] = ACTIONS(5560),
    [anon_sym_DASH_GT] = ACTIONS(5560),
    [anon_sym_with] = ACTIONS(5560),
    [aux_sym_preproc_if_token3] = ACTIONS(5560),
    [aux_sym_preproc_else_token1] = ACTIONS(5560),
    [aux_sym_preproc_elif_token1] = ACTIONS(5560),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3694] = {
    [sym_preproc_region] = STATE(3694),
    [sym_preproc_endregion] = STATE(3694),
    [sym_preproc_line] = STATE(3694),
    [sym_preproc_pragma] = STATE(3694),
    [sym_preproc_nullable] = STATE(3694),
    [sym_preproc_error] = STATE(3694),
    [sym_preproc_define] = STATE(3694),
    [sym_preproc_undef] = STATE(3694),
    [anon_sym_SEMI] = ACTIONS(4566),
    [anon_sym_LBRACK] = ACTIONS(4566),
    [anon_sym_COLON] = ACTIONS(4566),
    [anon_sym_COMMA] = ACTIONS(4566),
    [anon_sym_RBRACK] = ACTIONS(4566),
    [anon_sym_LPAREN] = ACTIONS(4566),
    [anon_sym_RPAREN] = ACTIONS(4566),
    [anon_sym_LBRACE] = ACTIONS(4566),
    [anon_sym_RBRACE] = ACTIONS(4566),
    [anon_sym_LT] = ACTIONS(4564),
    [anon_sym_GT] = ACTIONS(4564),
    [anon_sym_in] = ACTIONS(4566),
    [anon_sym_where] = ACTIONS(4566),
    [anon_sym_QMARK] = ACTIONS(4564),
    [anon_sym_BANG] = ACTIONS(4564),
    [anon_sym_PLUS_PLUS] = ACTIONS(4566),
    [anon_sym_DASH_DASH] = ACTIONS(4566),
    [anon_sym_PLUS] = ACTIONS(4564),
    [anon_sym_DASH] = ACTIONS(4564),
    [anon_sym_STAR] = ACTIONS(4566),
    [anon_sym_SLASH] = ACTIONS(4564),
    [anon_sym_PERCENT] = ACTIONS(4566),
    [anon_sym_CARET] = ACTIONS(4566),
    [anon_sym_PIPE] = ACTIONS(4564),
    [anon_sym_AMP] = ACTIONS(4564),
    [anon_sym_LT_LT] = ACTIONS(4566),
    [anon_sym_GT_GT] = ACTIONS(4564),
    [anon_sym_GT_GT_GT] = ACTIONS(4566),
    [anon_sym_EQ_EQ] = ACTIONS(4566),
    [anon_sym_BANG_EQ] = ACTIONS(4566),
    [anon_sym_GT_EQ] = ACTIONS(4566),
    [anon_sym_LT_EQ] = ACTIONS(4566),
    [anon_sym_DOT] = ACTIONS(4564),
    [anon_sym_EQ_GT] = ACTIONS(4566),
    [anon_sym_switch] = ACTIONS(4566),
    [anon_sym_DOT_DOT] = ACTIONS(4566),
    [anon_sym_and] = ACTIONS(4566),
    [anon_sym_or] = ACTIONS(4564),
    [anon_sym_AMP_AMP] = ACTIONS(4566),
    [anon_sym_PIPE_PIPE] = ACTIONS(4566),
    [anon_sym_QMARK_QMARK] = ACTIONS(4566),
    [anon_sym_from] = ACTIONS(4566),
    [anon_sym_join] = ACTIONS(4566),
    [anon_sym_on] = ACTIONS(4566),
    [anon_sym_equals] = ACTIONS(4566),
    [anon_sym_let] = ACTIONS(4566),
    [anon_sym_orderby] = ACTIONS(4566),
    [anon_sym_group] = ACTIONS(4566),
    [anon_sym_by] = ACTIONS(4566),
    [anon_sym_select] = ACTIONS(4566),
    [anon_sym_as] = ACTIONS(4566),
    [anon_sym_is] = ACTIONS(4566),
    [anon_sym_DASH_GT] = ACTIONS(4566),
    [anon_sym_with] = ACTIONS(4566),
    [aux_sym_preproc_if_token3] = ACTIONS(4566),
    [aux_sym_preproc_else_token1] = ACTIONS(4566),
    [aux_sym_preproc_elif_token1] = ACTIONS(4566),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3695] = {
    [sym_preproc_region] = STATE(3695),
    [sym_preproc_endregion] = STATE(3695),
    [sym_preproc_line] = STATE(3695),
    [sym_preproc_pragma] = STATE(3695),
    [sym_preproc_nullable] = STATE(3695),
    [sym_preproc_error] = STATE(3695),
    [sym_preproc_define] = STATE(3695),
    [sym_preproc_undef] = STATE(3695),
    [anon_sym_SEMI] = ACTIONS(1943),
    [anon_sym_LBRACK] = ACTIONS(1943),
    [anon_sym_COLON] = ACTIONS(1943),
    [anon_sym_COMMA] = ACTIONS(1943),
    [anon_sym_RBRACK] = ACTIONS(1943),
    [anon_sym_LPAREN] = ACTIONS(5564),
    [anon_sym_RPAREN] = ACTIONS(1943),
    [anon_sym_RBRACE] = ACTIONS(1943),
    [anon_sym_LT] = ACTIONS(1941),
    [anon_sym_GT] = ACTIONS(1941),
    [anon_sym_in] = ACTIONS(1941),
    [anon_sym_where] = ACTIONS(1943),
    [anon_sym_QMARK] = ACTIONS(1941),
    [anon_sym_BANG] = ACTIONS(1941),
    [anon_sym_PLUS_PLUS] = ACTIONS(1943),
    [anon_sym_DASH_DASH] = ACTIONS(1943),
    [anon_sym_PLUS] = ACTIONS(1941),
    [anon_sym_DASH] = ACTIONS(1941),
    [anon_sym_STAR] = ACTIONS(1943),
    [anon_sym_SLASH] = ACTIONS(1941),
    [anon_sym_PERCENT] = ACTIONS(1943),
    [anon_sym_CARET] = ACTIONS(1943),
    [anon_sym_PIPE] = ACTIONS(1941),
    [anon_sym_AMP] = ACTIONS(1941),
    [anon_sym_LT_LT] = ACTIONS(1943),
    [anon_sym_GT_GT] = ACTIONS(1941),
    [anon_sym_GT_GT_GT] = ACTIONS(1943),
    [anon_sym_EQ_EQ] = ACTIONS(1943),
    [anon_sym_BANG_EQ] = ACTIONS(1943),
    [anon_sym_GT_EQ] = ACTIONS(1943),
    [anon_sym_LT_EQ] = ACTIONS(1943),
    [anon_sym_DOT] = ACTIONS(1941),
    [anon_sym_EQ_GT] = ACTIONS(1943),
    [anon_sym_switch] = ACTIONS(1943),
    [anon_sym_DOT_DOT] = ACTIONS(1943),
    [anon_sym_and] = ACTIONS(1943),
    [anon_sym_or] = ACTIONS(1941),
    [anon_sym_AMP_AMP] = ACTIONS(1943),
    [anon_sym_PIPE_PIPE] = ACTIONS(1943),
    [anon_sym_QMARK_QMARK] = ACTIONS(1943),
    [anon_sym_from] = ACTIONS(1943),
    [anon_sym_into] = ACTIONS(1943),
    [anon_sym_join] = ACTIONS(1943),
    [anon_sym_on] = ACTIONS(1943),
    [anon_sym_equals] = ACTIONS(1943),
    [anon_sym_let] = ACTIONS(1943),
    [anon_sym_orderby] = ACTIONS(1943),
    [anon_sym_group] = ACTIONS(1943),
    [anon_sym_by] = ACTIONS(1943),
    [anon_sym_select] = ACTIONS(1943),
    [anon_sym_as] = ACTIONS(1943),
    [anon_sym_is] = ACTIONS(1943),
    [anon_sym_DASH_GT] = ACTIONS(1943),
    [anon_sym_with] = ACTIONS(1943),
    [aux_sym_preproc_if_token3] = ACTIONS(1943),
    [aux_sym_preproc_else_token1] = ACTIONS(1943),
    [aux_sym_preproc_elif_token1] = ACTIONS(1943),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3696] = {
    [sym_preproc_region] = STATE(3696),
    [sym_preproc_endregion] = STATE(3696),
    [sym_preproc_line] = STATE(3696),
    [sym_preproc_pragma] = STATE(3696),
    [sym_preproc_nullable] = STATE(3696),
    [sym_preproc_error] = STATE(3696),
    [sym_preproc_define] = STATE(3696),
    [sym_preproc_undef] = STATE(3696),
    [sym__identifier_token] = ACTIONS(3973),
    [anon_sym_extern] = ACTIONS(3976),
    [anon_sym_alias] = ACTIONS(3973),
    [anon_sym_global] = ACTIONS(3973),
    [anon_sym_unsafe] = ACTIONS(3976),
    [anon_sym_static] = ACTIONS(3976),
    [anon_sym_LBRACK] = ACTIONS(3719),
    [anon_sym_LPAREN] = ACTIONS(5566),
    [anon_sym_class] = ACTIONS(3976),
    [anon_sym_ref] = ACTIONS(3976),
    [anon_sym_struct] = ACTIONS(3976),
    [anon_sym_enum] = ACTIONS(3976),
    [anon_sym_interface] = ACTIONS(3976),
    [anon_sym_delegate] = ACTIONS(3976),
    [anon_sym_record] = ACTIONS(3976),
    [anon_sym_abstract] = ACTIONS(3976),
    [anon_sym_async] = ACTIONS(3976),
    [anon_sym_const] = ACTIONS(3976),
    [anon_sym_file] = ACTIONS(3973),
    [anon_sym_fixed] = ACTIONS(3976),
    [anon_sym_internal] = ACTIONS(3976),
    [anon_sym_new] = ACTIONS(3976),
    [anon_sym_override] = ACTIONS(3976),
    [anon_sym_partial] = ACTIONS(3976),
    [anon_sym_private] = ACTIONS(3976),
    [anon_sym_protected] = ACTIONS(3976),
    [anon_sym_public] = ACTIONS(3976),
    [anon_sym_readonly] = ACTIONS(3976),
    [anon_sym_required] = ACTIONS(3976),
    [anon_sym_sealed] = ACTIONS(3976),
    [anon_sym_virtual] = ACTIONS(3976),
    [anon_sym_volatile] = ACTIONS(3976),
    [anon_sym_LT] = ACTIONS(3719),
    [anon_sym_where] = ACTIONS(3973),
    [anon_sym_QMARK] = ACTIONS(3719),
    [anon_sym_notnull] = ACTIONS(3973),
    [anon_sym_unmanaged] = ACTIONS(3973),
    [anon_sym_STAR] = ACTIONS(3719),
    [anon_sym_DOT] = ACTIONS(3719),
    [anon_sym_scoped] = ACTIONS(3973),
    [anon_sym_COLON_COLON] = ACTIONS(3719),
    [anon_sym_var] = ACTIONS(3973),
    [sym_predefined_type] = ACTIONS(3976),
    [anon_sym_yield] = ACTIONS(3973),
    [anon_sym_when] = ACTIONS(3973),
    [anon_sym_from] = ACTIONS(3973),
    [anon_sym_into] = ACTIONS(3973),
    [anon_sym_join] = ACTIONS(3973),
    [anon_sym_on] = ACTIONS(3973),
    [anon_sym_equals] = ACTIONS(3973),
    [anon_sym_let] = ACTIONS(3973),
    [anon_sym_orderby] = ACTIONS(3973),
    [anon_sym_ascending] = ACTIONS(3973),
    [anon_sym_descending] = ACTIONS(3973),
    [anon_sym_group] = ACTIONS(3973),
    [anon_sym_by] = ACTIONS(3973),
    [anon_sym_select] = ACTIONS(3973),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3697] = {
    [sym_preproc_region] = STATE(3697),
    [sym_preproc_endregion] = STATE(3697),
    [sym_preproc_line] = STATE(3697),
    [sym_preproc_pragma] = STATE(3697),
    [sym_preproc_nullable] = STATE(3697),
    [sym_preproc_error] = STATE(3697),
    [sym_preproc_define] = STATE(3697),
    [sym_preproc_undef] = STATE(3697),
    [anon_sym_SEMI] = ACTIONS(5568),
    [anon_sym_LBRACK] = ACTIONS(5568),
    [anon_sym_COLON] = ACTIONS(5568),
    [anon_sym_COMMA] = ACTIONS(5568),
    [anon_sym_RBRACK] = ACTIONS(5568),
    [anon_sym_LPAREN] = ACTIONS(5568),
    [anon_sym_RPAREN] = ACTIONS(5568),
    [anon_sym_RBRACE] = ACTIONS(5568),
    [anon_sym_LT] = ACTIONS(5570),
    [anon_sym_GT] = ACTIONS(5570),
    [anon_sym_in] = ACTIONS(5570),
    [anon_sym_where] = ACTIONS(5568),
    [anon_sym_QMARK] = ACTIONS(5570),
    [anon_sym_BANG] = ACTIONS(5570),
    [anon_sym_PLUS_PLUS] = ACTIONS(5568),
    [anon_sym_DASH_DASH] = ACTIONS(5568),
    [anon_sym_PLUS] = ACTIONS(5570),
    [anon_sym_DASH] = ACTIONS(5570),
    [anon_sym_STAR] = ACTIONS(5568),
    [anon_sym_SLASH] = ACTIONS(5570),
    [anon_sym_PERCENT] = ACTIONS(5568),
    [anon_sym_CARET] = ACTIONS(5568),
    [anon_sym_PIPE] = ACTIONS(5570),
    [anon_sym_AMP] = ACTIONS(5570),
    [anon_sym_LT_LT] = ACTIONS(5568),
    [anon_sym_GT_GT] = ACTIONS(5570),
    [anon_sym_GT_GT_GT] = ACTIONS(5568),
    [anon_sym_EQ_EQ] = ACTIONS(5568),
    [anon_sym_BANG_EQ] = ACTIONS(5568),
    [anon_sym_GT_EQ] = ACTIONS(5568),
    [anon_sym_LT_EQ] = ACTIONS(5568),
    [anon_sym_DOT] = ACTIONS(5570),
    [anon_sym_EQ_GT] = ACTIONS(5568),
    [anon_sym_switch] = ACTIONS(5568),
    [anon_sym_DOT_DOT] = ACTIONS(5568),
    [anon_sym_and] = ACTIONS(5568),
    [anon_sym_or] = ACTIONS(5570),
    [anon_sym_AMP_AMP] = ACTIONS(5568),
    [anon_sym_PIPE_PIPE] = ACTIONS(5568),
    [anon_sym_QMARK_QMARK] = ACTIONS(5568),
    [anon_sym_from] = ACTIONS(5568),
    [anon_sym_into] = ACTIONS(5568),
    [anon_sym_join] = ACTIONS(5568),
    [anon_sym_on] = ACTIONS(5568),
    [anon_sym_equals] = ACTIONS(5568),
    [anon_sym_let] = ACTIONS(5568),
    [anon_sym_orderby] = ACTIONS(5568),
    [anon_sym_group] = ACTIONS(5568),
    [anon_sym_by] = ACTIONS(5568),
    [anon_sym_select] = ACTIONS(5568),
    [anon_sym_as] = ACTIONS(5568),
    [anon_sym_is] = ACTIONS(5568),
    [anon_sym_DASH_GT] = ACTIONS(5568),
    [anon_sym_with] = ACTIONS(5568),
    [aux_sym_preproc_if_token3] = ACTIONS(5568),
    [aux_sym_preproc_else_token1] = ACTIONS(5568),
    [aux_sym_preproc_elif_token1] = ACTIONS(5568),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3698] = {
    [sym_preproc_region] = STATE(3698),
    [sym_preproc_endregion] = STATE(3698),
    [sym_preproc_line] = STATE(3698),
    [sym_preproc_pragma] = STATE(3698),
    [sym_preproc_nullable] = STATE(3698),
    [sym_preproc_error] = STATE(3698),
    [sym_preproc_define] = STATE(3698),
    [sym_preproc_undef] = STATE(3698),
    [anon_sym_SEMI] = ACTIONS(4408),
    [anon_sym_LBRACK] = ACTIONS(4408),
    [anon_sym_COLON] = ACTIONS(4408),
    [anon_sym_COMMA] = ACTIONS(4408),
    [anon_sym_RBRACK] = ACTIONS(4408),
    [anon_sym_LPAREN] = ACTIONS(4408),
    [anon_sym_RPAREN] = ACTIONS(4408),
    [anon_sym_LBRACE] = ACTIONS(4408),
    [anon_sym_RBRACE] = ACTIONS(4408),
    [anon_sym_LT] = ACTIONS(4406),
    [anon_sym_GT] = ACTIONS(4406),
    [anon_sym_in] = ACTIONS(4408),
    [anon_sym_where] = ACTIONS(4408),
    [anon_sym_QMARK] = ACTIONS(4406),
    [anon_sym_BANG] = ACTIONS(4406),
    [anon_sym_PLUS_PLUS] = ACTIONS(4408),
    [anon_sym_DASH_DASH] = ACTIONS(4408),
    [anon_sym_PLUS] = ACTIONS(4406),
    [anon_sym_DASH] = ACTIONS(4406),
    [anon_sym_STAR] = ACTIONS(4408),
    [anon_sym_SLASH] = ACTIONS(4406),
    [anon_sym_PERCENT] = ACTIONS(4408),
    [anon_sym_CARET] = ACTIONS(4408),
    [anon_sym_PIPE] = ACTIONS(4406),
    [anon_sym_AMP] = ACTIONS(4406),
    [anon_sym_LT_LT] = ACTIONS(4408),
    [anon_sym_GT_GT] = ACTIONS(4406),
    [anon_sym_GT_GT_GT] = ACTIONS(4408),
    [anon_sym_EQ_EQ] = ACTIONS(4408),
    [anon_sym_BANG_EQ] = ACTIONS(4408),
    [anon_sym_GT_EQ] = ACTIONS(4408),
    [anon_sym_LT_EQ] = ACTIONS(4408),
    [anon_sym_DOT] = ACTIONS(4406),
    [anon_sym_EQ_GT] = ACTIONS(4408),
    [anon_sym_switch] = ACTIONS(4408),
    [anon_sym_DOT_DOT] = ACTIONS(4408),
    [anon_sym_and] = ACTIONS(4408),
    [anon_sym_or] = ACTIONS(4406),
    [anon_sym_AMP_AMP] = ACTIONS(4408),
    [anon_sym_PIPE_PIPE] = ACTIONS(4408),
    [anon_sym_QMARK_QMARK] = ACTIONS(4408),
    [anon_sym_from] = ACTIONS(4408),
    [anon_sym_join] = ACTIONS(4408),
    [anon_sym_on] = ACTIONS(4408),
    [anon_sym_equals] = ACTIONS(4408),
    [anon_sym_let] = ACTIONS(4408),
    [anon_sym_orderby] = ACTIONS(4408),
    [anon_sym_group] = ACTIONS(4408),
    [anon_sym_by] = ACTIONS(4408),
    [anon_sym_select] = ACTIONS(4408),
    [anon_sym_as] = ACTIONS(4408),
    [anon_sym_is] = ACTIONS(4408),
    [anon_sym_DASH_GT] = ACTIONS(4408),
    [anon_sym_with] = ACTIONS(4408),
    [aux_sym_preproc_if_token3] = ACTIONS(4408),
    [aux_sym_preproc_else_token1] = ACTIONS(4408),
    [aux_sym_preproc_elif_token1] = ACTIONS(4408),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3699] = {
    [sym_preproc_region] = STATE(3699),
    [sym_preproc_endregion] = STATE(3699),
    [sym_preproc_line] = STATE(3699),
    [sym_preproc_pragma] = STATE(3699),
    [sym_preproc_nullable] = STATE(3699),
    [sym_preproc_error] = STATE(3699),
    [sym_preproc_define] = STATE(3699),
    [sym_preproc_undef] = STATE(3699),
    [anon_sym_SEMI] = ACTIONS(4389),
    [anon_sym_LBRACK] = ACTIONS(4389),
    [anon_sym_COLON] = ACTIONS(4389),
    [anon_sym_COMMA] = ACTIONS(4389),
    [anon_sym_RBRACK] = ACTIONS(4389),
    [anon_sym_LPAREN] = ACTIONS(4389),
    [anon_sym_RPAREN] = ACTIONS(4389),
    [anon_sym_LBRACE] = ACTIONS(4389),
    [anon_sym_RBRACE] = ACTIONS(4389),
    [anon_sym_LT] = ACTIONS(4387),
    [anon_sym_GT] = ACTIONS(4387),
    [anon_sym_in] = ACTIONS(4389),
    [anon_sym_where] = ACTIONS(4389),
    [anon_sym_QMARK] = ACTIONS(4387),
    [anon_sym_BANG] = ACTIONS(4387),
    [anon_sym_PLUS_PLUS] = ACTIONS(4389),
    [anon_sym_DASH_DASH] = ACTIONS(4389),
    [anon_sym_PLUS] = ACTIONS(4387),
    [anon_sym_DASH] = ACTIONS(4387),
    [anon_sym_STAR] = ACTIONS(4389),
    [anon_sym_SLASH] = ACTIONS(4387),
    [anon_sym_PERCENT] = ACTIONS(4389),
    [anon_sym_CARET] = ACTIONS(4389),
    [anon_sym_PIPE] = ACTIONS(4387),
    [anon_sym_AMP] = ACTIONS(4387),
    [anon_sym_LT_LT] = ACTIONS(4389),
    [anon_sym_GT_GT] = ACTIONS(4387),
    [anon_sym_GT_GT_GT] = ACTIONS(4389),
    [anon_sym_EQ_EQ] = ACTIONS(4389),
    [anon_sym_BANG_EQ] = ACTIONS(4389),
    [anon_sym_GT_EQ] = ACTIONS(4389),
    [anon_sym_LT_EQ] = ACTIONS(4389),
    [anon_sym_DOT] = ACTIONS(4387),
    [anon_sym_EQ_GT] = ACTIONS(4389),
    [anon_sym_switch] = ACTIONS(4389),
    [anon_sym_DOT_DOT] = ACTIONS(4389),
    [anon_sym_and] = ACTIONS(4389),
    [anon_sym_or] = ACTIONS(4387),
    [anon_sym_AMP_AMP] = ACTIONS(4389),
    [anon_sym_PIPE_PIPE] = ACTIONS(4389),
    [anon_sym_QMARK_QMARK] = ACTIONS(4389),
    [anon_sym_from] = ACTIONS(4389),
    [anon_sym_join] = ACTIONS(4389),
    [anon_sym_on] = ACTIONS(4389),
    [anon_sym_equals] = ACTIONS(4389),
    [anon_sym_let] = ACTIONS(4389),
    [anon_sym_orderby] = ACTIONS(4389),
    [anon_sym_group] = ACTIONS(4389),
    [anon_sym_by] = ACTIONS(4389),
    [anon_sym_select] = ACTIONS(4389),
    [anon_sym_as] = ACTIONS(4389),
    [anon_sym_is] = ACTIONS(4389),
    [anon_sym_DASH_GT] = ACTIONS(4389),
    [anon_sym_with] = ACTIONS(4389),
    [aux_sym_preproc_if_token3] = ACTIONS(4389),
    [aux_sym_preproc_else_token1] = ACTIONS(4389),
    [aux_sym_preproc_elif_token1] = ACTIONS(4389),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3700] = {
    [sym_preproc_region] = STATE(3700),
    [sym_preproc_endregion] = STATE(3700),
    [sym_preproc_line] = STATE(3700),
    [sym_preproc_pragma] = STATE(3700),
    [sym_preproc_nullable] = STATE(3700),
    [sym_preproc_error] = STATE(3700),
    [sym_preproc_define] = STATE(3700),
    [sym_preproc_undef] = STATE(3700),
    [anon_sym_SEMI] = ACTIONS(4349),
    [anon_sym_LBRACK] = ACTIONS(4349),
    [anon_sym_COLON] = ACTIONS(4349),
    [anon_sym_COMMA] = ACTIONS(4349),
    [anon_sym_RBRACK] = ACTIONS(4349),
    [anon_sym_LPAREN] = ACTIONS(4349),
    [anon_sym_RPAREN] = ACTIONS(4349),
    [anon_sym_LBRACE] = ACTIONS(4349),
    [anon_sym_RBRACE] = ACTIONS(4349),
    [anon_sym_LT] = ACTIONS(4347),
    [anon_sym_GT] = ACTIONS(4347),
    [anon_sym_in] = ACTIONS(4349),
    [anon_sym_where] = ACTIONS(4349),
    [anon_sym_QMARK] = ACTIONS(4347),
    [anon_sym_BANG] = ACTIONS(4347),
    [anon_sym_PLUS_PLUS] = ACTIONS(4349),
    [anon_sym_DASH_DASH] = ACTIONS(4349),
    [anon_sym_PLUS] = ACTIONS(4347),
    [anon_sym_DASH] = ACTIONS(4347),
    [anon_sym_STAR] = ACTIONS(4349),
    [anon_sym_SLASH] = ACTIONS(4347),
    [anon_sym_PERCENT] = ACTIONS(4349),
    [anon_sym_CARET] = ACTIONS(4349),
    [anon_sym_PIPE] = ACTIONS(4347),
    [anon_sym_AMP] = ACTIONS(4347),
    [anon_sym_LT_LT] = ACTIONS(4349),
    [anon_sym_GT_GT] = ACTIONS(4347),
    [anon_sym_GT_GT_GT] = ACTIONS(4349),
    [anon_sym_EQ_EQ] = ACTIONS(4349),
    [anon_sym_BANG_EQ] = ACTIONS(4349),
    [anon_sym_GT_EQ] = ACTIONS(4349),
    [anon_sym_LT_EQ] = ACTIONS(4349),
    [anon_sym_DOT] = ACTIONS(4347),
    [anon_sym_EQ_GT] = ACTIONS(4349),
    [anon_sym_switch] = ACTIONS(4349),
    [anon_sym_DOT_DOT] = ACTIONS(4349),
    [anon_sym_and] = ACTIONS(4349),
    [anon_sym_or] = ACTIONS(4347),
    [anon_sym_AMP_AMP] = ACTIONS(4349),
    [anon_sym_PIPE_PIPE] = ACTIONS(4349),
    [anon_sym_QMARK_QMARK] = ACTIONS(4349),
    [anon_sym_from] = ACTIONS(4349),
    [anon_sym_join] = ACTIONS(4349),
    [anon_sym_on] = ACTIONS(4349),
    [anon_sym_equals] = ACTIONS(4349),
    [anon_sym_let] = ACTIONS(4349),
    [anon_sym_orderby] = ACTIONS(4349),
    [anon_sym_group] = ACTIONS(4349),
    [anon_sym_by] = ACTIONS(4349),
    [anon_sym_select] = ACTIONS(4349),
    [anon_sym_as] = ACTIONS(4349),
    [anon_sym_is] = ACTIONS(4349),
    [anon_sym_DASH_GT] = ACTIONS(4349),
    [anon_sym_with] = ACTIONS(4349),
    [aux_sym_preproc_if_token3] = ACTIONS(4349),
    [aux_sym_preproc_else_token1] = ACTIONS(4349),
    [aux_sym_preproc_elif_token1] = ACTIONS(4349),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3701] = {
    [sym_preproc_region] = STATE(3701),
    [sym_preproc_endregion] = STATE(3701),
    [sym_preproc_line] = STATE(3701),
    [sym_preproc_pragma] = STATE(3701),
    [sym_preproc_nullable] = STATE(3701),
    [sym_preproc_error] = STATE(3701),
    [sym_preproc_define] = STATE(3701),
    [sym_preproc_undef] = STATE(3701),
    [anon_sym_SEMI] = ACTIONS(5572),
    [anon_sym_LBRACK] = ACTIONS(5572),
    [anon_sym_COLON] = ACTIONS(5572),
    [anon_sym_COMMA] = ACTIONS(5572),
    [anon_sym_RBRACK] = ACTIONS(5572),
    [anon_sym_LPAREN] = ACTIONS(5572),
    [anon_sym_RPAREN] = ACTIONS(5572),
    [anon_sym_RBRACE] = ACTIONS(5572),
    [anon_sym_LT] = ACTIONS(5574),
    [anon_sym_GT] = ACTIONS(5574),
    [anon_sym_in] = ACTIONS(5574),
    [anon_sym_where] = ACTIONS(5572),
    [anon_sym_QMARK] = ACTIONS(5574),
    [anon_sym_BANG] = ACTIONS(5574),
    [anon_sym_PLUS_PLUS] = ACTIONS(5572),
    [anon_sym_DASH_DASH] = ACTIONS(5572),
    [anon_sym_PLUS] = ACTIONS(5574),
    [anon_sym_DASH] = ACTIONS(5574),
    [anon_sym_STAR] = ACTIONS(5572),
    [anon_sym_SLASH] = ACTIONS(5574),
    [anon_sym_PERCENT] = ACTIONS(5572),
    [anon_sym_CARET] = ACTIONS(5572),
    [anon_sym_PIPE] = ACTIONS(5574),
    [anon_sym_AMP] = ACTIONS(5574),
    [anon_sym_LT_LT] = ACTIONS(5572),
    [anon_sym_GT_GT] = ACTIONS(5574),
    [anon_sym_GT_GT_GT] = ACTIONS(5572),
    [anon_sym_EQ_EQ] = ACTIONS(5572),
    [anon_sym_BANG_EQ] = ACTIONS(5572),
    [anon_sym_GT_EQ] = ACTIONS(5572),
    [anon_sym_LT_EQ] = ACTIONS(5572),
    [anon_sym_DOT] = ACTIONS(5574),
    [anon_sym_EQ_GT] = ACTIONS(5572),
    [anon_sym_switch] = ACTIONS(5572),
    [anon_sym_DOT_DOT] = ACTIONS(5572),
    [anon_sym_and] = ACTIONS(5572),
    [anon_sym_or] = ACTIONS(5574),
    [anon_sym_AMP_AMP] = ACTIONS(5572),
    [anon_sym_PIPE_PIPE] = ACTIONS(5572),
    [anon_sym_QMARK_QMARK] = ACTIONS(5572),
    [anon_sym_from] = ACTIONS(5572),
    [anon_sym_into] = ACTIONS(5572),
    [anon_sym_join] = ACTIONS(5572),
    [anon_sym_on] = ACTIONS(5572),
    [anon_sym_equals] = ACTIONS(5572),
    [anon_sym_let] = ACTIONS(5572),
    [anon_sym_orderby] = ACTIONS(5572),
    [anon_sym_group] = ACTIONS(5572),
    [anon_sym_by] = ACTIONS(5572),
    [anon_sym_select] = ACTIONS(5572),
    [anon_sym_as] = ACTIONS(5572),
    [anon_sym_is] = ACTIONS(5572),
    [anon_sym_DASH_GT] = ACTIONS(5572),
    [anon_sym_with] = ACTIONS(5572),
    [aux_sym_preproc_if_token3] = ACTIONS(5572),
    [aux_sym_preproc_else_token1] = ACTIONS(5572),
    [aux_sym_preproc_elif_token1] = ACTIONS(5572),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3702] = {
    [sym_preproc_region] = STATE(3702),
    [sym_preproc_endregion] = STATE(3702),
    [sym_preproc_line] = STATE(3702),
    [sym_preproc_pragma] = STATE(3702),
    [sym_preproc_nullable] = STATE(3702),
    [sym_preproc_error] = STATE(3702),
    [sym_preproc_define] = STATE(3702),
    [sym_preproc_undef] = STATE(3702),
    [anon_sym_SEMI] = ACTIONS(5576),
    [anon_sym_LBRACK] = ACTIONS(5576),
    [anon_sym_COLON] = ACTIONS(5576),
    [anon_sym_COMMA] = ACTIONS(5576),
    [anon_sym_RBRACK] = ACTIONS(5576),
    [anon_sym_LPAREN] = ACTIONS(5576),
    [anon_sym_RPAREN] = ACTIONS(5576),
    [anon_sym_RBRACE] = ACTIONS(5576),
    [anon_sym_LT] = ACTIONS(5578),
    [anon_sym_GT] = ACTIONS(5578),
    [anon_sym_in] = ACTIONS(5578),
    [anon_sym_where] = ACTIONS(5576),
    [anon_sym_QMARK] = ACTIONS(5578),
    [anon_sym_BANG] = ACTIONS(5578),
    [anon_sym_PLUS_PLUS] = ACTIONS(5576),
    [anon_sym_DASH_DASH] = ACTIONS(5576),
    [anon_sym_PLUS] = ACTIONS(5578),
    [anon_sym_DASH] = ACTIONS(5578),
    [anon_sym_STAR] = ACTIONS(5576),
    [anon_sym_SLASH] = ACTIONS(5578),
    [anon_sym_PERCENT] = ACTIONS(5576),
    [anon_sym_CARET] = ACTIONS(5576),
    [anon_sym_PIPE] = ACTIONS(5578),
    [anon_sym_AMP] = ACTIONS(5578),
    [anon_sym_LT_LT] = ACTIONS(5576),
    [anon_sym_GT_GT] = ACTIONS(5578),
    [anon_sym_GT_GT_GT] = ACTIONS(5576),
    [anon_sym_EQ_EQ] = ACTIONS(5576),
    [anon_sym_BANG_EQ] = ACTIONS(5576),
    [anon_sym_GT_EQ] = ACTIONS(5576),
    [anon_sym_LT_EQ] = ACTIONS(5576),
    [anon_sym_DOT] = ACTIONS(5578),
    [anon_sym_EQ_GT] = ACTIONS(5576),
    [anon_sym_switch] = ACTIONS(5576),
    [anon_sym_DOT_DOT] = ACTIONS(5576),
    [anon_sym_and] = ACTIONS(5576),
    [anon_sym_or] = ACTIONS(5578),
    [anon_sym_AMP_AMP] = ACTIONS(5576),
    [anon_sym_PIPE_PIPE] = ACTIONS(5576),
    [anon_sym_QMARK_QMARK] = ACTIONS(5576),
    [anon_sym_from] = ACTIONS(5576),
    [anon_sym_into] = ACTIONS(5576),
    [anon_sym_join] = ACTIONS(5576),
    [anon_sym_on] = ACTIONS(5576),
    [anon_sym_equals] = ACTIONS(5576),
    [anon_sym_let] = ACTIONS(5576),
    [anon_sym_orderby] = ACTIONS(5576),
    [anon_sym_group] = ACTIONS(5576),
    [anon_sym_by] = ACTIONS(5576),
    [anon_sym_select] = ACTIONS(5576),
    [anon_sym_as] = ACTIONS(5576),
    [anon_sym_is] = ACTIONS(5576),
    [anon_sym_DASH_GT] = ACTIONS(5576),
    [anon_sym_with] = ACTIONS(5576),
    [aux_sym_preproc_if_token3] = ACTIONS(5576),
    [aux_sym_preproc_else_token1] = ACTIONS(5576),
    [aux_sym_preproc_elif_token1] = ACTIONS(5576),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3703] = {
    [sym_preproc_region] = STATE(3703),
    [sym_preproc_endregion] = STATE(3703),
    [sym_preproc_line] = STATE(3703),
    [sym_preproc_pragma] = STATE(3703),
    [sym_preproc_nullable] = STATE(3703),
    [sym_preproc_error] = STATE(3703),
    [sym_preproc_define] = STATE(3703),
    [sym_preproc_undef] = STATE(3703),
    [anon_sym_SEMI] = ACTIONS(2923),
    [anon_sym_LBRACK] = ACTIONS(2923),
    [anon_sym_COLON] = ACTIONS(2923),
    [anon_sym_COMMA] = ACTIONS(2923),
    [anon_sym_RBRACK] = ACTIONS(2923),
    [anon_sym_LPAREN] = ACTIONS(2923),
    [anon_sym_RPAREN] = ACTIONS(2923),
    [anon_sym_RBRACE] = ACTIONS(2923),
    [anon_sym_LT] = ACTIONS(2921),
    [anon_sym_GT] = ACTIONS(2921),
    [anon_sym_in] = ACTIONS(2921),
    [anon_sym_where] = ACTIONS(2923),
    [anon_sym_QMARK] = ACTIONS(2921),
    [anon_sym_BANG] = ACTIONS(2921),
    [anon_sym_PLUS_PLUS] = ACTIONS(2923),
    [anon_sym_DASH_DASH] = ACTIONS(2923),
    [anon_sym_PLUS] = ACTIONS(2921),
    [anon_sym_DASH] = ACTIONS(2921),
    [anon_sym_STAR] = ACTIONS(2923),
    [anon_sym_SLASH] = ACTIONS(2921),
    [anon_sym_PERCENT] = ACTIONS(2923),
    [anon_sym_CARET] = ACTIONS(2923),
    [anon_sym_PIPE] = ACTIONS(2921),
    [anon_sym_AMP] = ACTIONS(2921),
    [anon_sym_LT_LT] = ACTIONS(2923),
    [anon_sym_GT_GT] = ACTIONS(2921),
    [anon_sym_GT_GT_GT] = ACTIONS(2923),
    [anon_sym_EQ_EQ] = ACTIONS(2923),
    [anon_sym_BANG_EQ] = ACTIONS(2923),
    [anon_sym_GT_EQ] = ACTIONS(2923),
    [anon_sym_LT_EQ] = ACTIONS(2923),
    [anon_sym_DOT] = ACTIONS(2921),
    [anon_sym_EQ_GT] = ACTIONS(2923),
    [anon_sym_switch] = ACTIONS(2923),
    [anon_sym_DOT_DOT] = ACTIONS(2923),
    [anon_sym_and] = ACTIONS(2923),
    [anon_sym_or] = ACTIONS(2921),
    [anon_sym_AMP_AMP] = ACTIONS(2923),
    [anon_sym_PIPE_PIPE] = ACTIONS(2923),
    [anon_sym_QMARK_QMARK] = ACTIONS(2923),
    [anon_sym_from] = ACTIONS(2923),
    [anon_sym_into] = ACTIONS(2923),
    [anon_sym_join] = ACTIONS(2923),
    [anon_sym_on] = ACTIONS(2923),
    [anon_sym_equals] = ACTIONS(2923),
    [anon_sym_let] = ACTIONS(2923),
    [anon_sym_orderby] = ACTIONS(2923),
    [anon_sym_group] = ACTIONS(2923),
    [anon_sym_by] = ACTIONS(2923),
    [anon_sym_select] = ACTIONS(2923),
    [anon_sym_as] = ACTIONS(2923),
    [anon_sym_is] = ACTIONS(2923),
    [anon_sym_DASH_GT] = ACTIONS(2923),
    [anon_sym_with] = ACTIONS(2923),
    [aux_sym_preproc_if_token3] = ACTIONS(2923),
    [aux_sym_preproc_else_token1] = ACTIONS(2923),
    [aux_sym_preproc_elif_token1] = ACTIONS(2923),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3704] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter] = STATE(8654),
    [sym__parameter_array] = STATE(8624),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7337),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_identifier] = STATE(6729),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(3704),
    [sym_preproc_endregion] = STATE(3704),
    [sym_preproc_line] = STATE(3704),
    [sym_preproc_pragma] = STATE(3704),
    [sym_preproc_nullable] = STATE(3704),
    [sym_preproc_error] = STATE(3704),
    [sym_preproc_define] = STATE(3704),
    [sym_preproc_undef] = STATE(3704),
    [aux_sym_class_declaration_repeat1] = STATE(3784),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4143),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_LBRACK] = ACTIONS(5212),
    [anon_sym_RBRACK] = ACTIONS(5580),
    [anon_sym_LPAREN] = ACTIONS(2995),
    [anon_sym_ref] = ACTIONS(5216),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_readonly] = ACTIONS(1093),
    [anon_sym_in] = ACTIONS(1093),
    [anon_sym_out] = ACTIONS(1093),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_this] = ACTIONS(1093),
    [anon_sym_scoped] = ACTIONS(5218),
    [anon_sym_params] = ACTIONS(1107),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3705] = {
    [sym_preproc_region] = STATE(3705),
    [sym_preproc_endregion] = STATE(3705),
    [sym_preproc_line] = STATE(3705),
    [sym_preproc_pragma] = STATE(3705),
    [sym_preproc_nullable] = STATE(3705),
    [sym_preproc_error] = STATE(3705),
    [sym_preproc_define] = STATE(3705),
    [sym_preproc_undef] = STATE(3705),
    [anon_sym_SEMI] = ACTIONS(5582),
    [anon_sym_LBRACK] = ACTIONS(5582),
    [anon_sym_COLON] = ACTIONS(5582),
    [anon_sym_COMMA] = ACTIONS(5582),
    [anon_sym_RBRACK] = ACTIONS(5582),
    [anon_sym_LPAREN] = ACTIONS(5582),
    [anon_sym_RPAREN] = ACTIONS(5582),
    [anon_sym_RBRACE] = ACTIONS(5582),
    [anon_sym_LT] = ACTIONS(5584),
    [anon_sym_GT] = ACTIONS(5584),
    [anon_sym_in] = ACTIONS(5584),
    [anon_sym_where] = ACTIONS(5582),
    [anon_sym_QMARK] = ACTIONS(5584),
    [anon_sym_BANG] = ACTIONS(5584),
    [anon_sym_PLUS_PLUS] = ACTIONS(5582),
    [anon_sym_DASH_DASH] = ACTIONS(5582),
    [anon_sym_PLUS] = ACTIONS(5584),
    [anon_sym_DASH] = ACTIONS(5584),
    [anon_sym_STAR] = ACTIONS(5582),
    [anon_sym_SLASH] = ACTIONS(5584),
    [anon_sym_PERCENT] = ACTIONS(5582),
    [anon_sym_CARET] = ACTIONS(5582),
    [anon_sym_PIPE] = ACTIONS(5584),
    [anon_sym_AMP] = ACTIONS(5584),
    [anon_sym_LT_LT] = ACTIONS(5582),
    [anon_sym_GT_GT] = ACTIONS(5584),
    [anon_sym_GT_GT_GT] = ACTIONS(5582),
    [anon_sym_EQ_EQ] = ACTIONS(5582),
    [anon_sym_BANG_EQ] = ACTIONS(5582),
    [anon_sym_GT_EQ] = ACTIONS(5582),
    [anon_sym_LT_EQ] = ACTIONS(5582),
    [anon_sym_DOT] = ACTIONS(5584),
    [anon_sym_EQ_GT] = ACTIONS(5582),
    [anon_sym_switch] = ACTIONS(5582),
    [anon_sym_DOT_DOT] = ACTIONS(5582),
    [anon_sym_and] = ACTIONS(5582),
    [anon_sym_or] = ACTIONS(5584),
    [anon_sym_AMP_AMP] = ACTIONS(5582),
    [anon_sym_PIPE_PIPE] = ACTIONS(5582),
    [anon_sym_QMARK_QMARK] = ACTIONS(5582),
    [anon_sym_from] = ACTIONS(5582),
    [anon_sym_into] = ACTIONS(5582),
    [anon_sym_join] = ACTIONS(5582),
    [anon_sym_on] = ACTIONS(5582),
    [anon_sym_equals] = ACTIONS(5582),
    [anon_sym_let] = ACTIONS(5582),
    [anon_sym_orderby] = ACTIONS(5582),
    [anon_sym_group] = ACTIONS(5582),
    [anon_sym_by] = ACTIONS(5582),
    [anon_sym_select] = ACTIONS(5582),
    [anon_sym_as] = ACTIONS(5582),
    [anon_sym_is] = ACTIONS(5582),
    [anon_sym_DASH_GT] = ACTIONS(5582),
    [anon_sym_with] = ACTIONS(5582),
    [aux_sym_preproc_if_token3] = ACTIONS(5582),
    [aux_sym_preproc_else_token1] = ACTIONS(5582),
    [aux_sym_preproc_elif_token1] = ACTIONS(5582),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3706] = {
    [sym_preproc_region] = STATE(3706),
    [sym_preproc_endregion] = STATE(3706),
    [sym_preproc_line] = STATE(3706),
    [sym_preproc_pragma] = STATE(3706),
    [sym_preproc_nullable] = STATE(3706),
    [sym_preproc_error] = STATE(3706),
    [sym_preproc_define] = STATE(3706),
    [sym_preproc_undef] = STATE(3706),
    [anon_sym_SEMI] = ACTIONS(4424),
    [anon_sym_LBRACK] = ACTIONS(4424),
    [anon_sym_COLON] = ACTIONS(4424),
    [anon_sym_COMMA] = ACTIONS(4424),
    [anon_sym_RBRACK] = ACTIONS(4424),
    [anon_sym_LPAREN] = ACTIONS(4424),
    [anon_sym_RPAREN] = ACTIONS(4424),
    [anon_sym_LBRACE] = ACTIONS(4424),
    [anon_sym_RBRACE] = ACTIONS(4424),
    [anon_sym_LT] = ACTIONS(4422),
    [anon_sym_GT] = ACTIONS(4422),
    [anon_sym_in] = ACTIONS(4424),
    [anon_sym_where] = ACTIONS(4424),
    [anon_sym_QMARK] = ACTIONS(4422),
    [anon_sym_BANG] = ACTIONS(4422),
    [anon_sym_PLUS_PLUS] = ACTIONS(4424),
    [anon_sym_DASH_DASH] = ACTIONS(4424),
    [anon_sym_PLUS] = ACTIONS(4422),
    [anon_sym_DASH] = ACTIONS(4422),
    [anon_sym_STAR] = ACTIONS(4424),
    [anon_sym_SLASH] = ACTIONS(4422),
    [anon_sym_PERCENT] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4424),
    [anon_sym_PIPE] = ACTIONS(4422),
    [anon_sym_AMP] = ACTIONS(4422),
    [anon_sym_LT_LT] = ACTIONS(4424),
    [anon_sym_GT_GT] = ACTIONS(4422),
    [anon_sym_GT_GT_GT] = ACTIONS(4424),
    [anon_sym_EQ_EQ] = ACTIONS(4424),
    [anon_sym_BANG_EQ] = ACTIONS(4424),
    [anon_sym_GT_EQ] = ACTIONS(4424),
    [anon_sym_LT_EQ] = ACTIONS(4424),
    [anon_sym_DOT] = ACTIONS(4422),
    [anon_sym_EQ_GT] = ACTIONS(4424),
    [anon_sym_switch] = ACTIONS(4424),
    [anon_sym_DOT_DOT] = ACTIONS(4424),
    [anon_sym_and] = ACTIONS(4424),
    [anon_sym_or] = ACTIONS(4422),
    [anon_sym_AMP_AMP] = ACTIONS(4424),
    [anon_sym_PIPE_PIPE] = ACTIONS(4424),
    [anon_sym_QMARK_QMARK] = ACTIONS(4424),
    [anon_sym_from] = ACTIONS(4424),
    [anon_sym_join] = ACTIONS(4424),
    [anon_sym_on] = ACTIONS(4424),
    [anon_sym_equals] = ACTIONS(4424),
    [anon_sym_let] = ACTIONS(4424),
    [anon_sym_orderby] = ACTIONS(4424),
    [anon_sym_group] = ACTIONS(4424),
    [anon_sym_by] = ACTIONS(4424),
    [anon_sym_select] = ACTIONS(4424),
    [anon_sym_as] = ACTIONS(4424),
    [anon_sym_is] = ACTIONS(4424),
    [anon_sym_DASH_GT] = ACTIONS(4424),
    [anon_sym_with] = ACTIONS(4424),
    [aux_sym_preproc_if_token3] = ACTIONS(4424),
    [aux_sym_preproc_else_token1] = ACTIONS(4424),
    [aux_sym_preproc_elif_token1] = ACTIONS(4424),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3707] = {
    [sym_preproc_region] = STATE(3707),
    [sym_preproc_endregion] = STATE(3707),
    [sym_preproc_line] = STATE(3707),
    [sym_preproc_pragma] = STATE(3707),
    [sym_preproc_nullable] = STATE(3707),
    [sym_preproc_error] = STATE(3707),
    [sym_preproc_define] = STATE(3707),
    [sym_preproc_undef] = STATE(3707),
    [anon_sym_SEMI] = ACTIONS(5586),
    [anon_sym_LBRACK] = ACTIONS(5586),
    [anon_sym_COLON] = ACTIONS(5586),
    [anon_sym_COMMA] = ACTIONS(5586),
    [anon_sym_RBRACK] = ACTIONS(5586),
    [anon_sym_LPAREN] = ACTIONS(5586),
    [anon_sym_RPAREN] = ACTIONS(5586),
    [anon_sym_RBRACE] = ACTIONS(5586),
    [anon_sym_LT] = ACTIONS(5588),
    [anon_sym_GT] = ACTIONS(5588),
    [anon_sym_in] = ACTIONS(5588),
    [anon_sym_where] = ACTIONS(5586),
    [anon_sym_QMARK] = ACTIONS(5588),
    [anon_sym_BANG] = ACTIONS(5588),
    [anon_sym_PLUS_PLUS] = ACTIONS(5586),
    [anon_sym_DASH_DASH] = ACTIONS(5586),
    [anon_sym_PLUS] = ACTIONS(5588),
    [anon_sym_DASH] = ACTIONS(5588),
    [anon_sym_STAR] = ACTIONS(5586),
    [anon_sym_SLASH] = ACTIONS(5588),
    [anon_sym_PERCENT] = ACTIONS(5586),
    [anon_sym_CARET] = ACTIONS(5586),
    [anon_sym_PIPE] = ACTIONS(5588),
    [anon_sym_AMP] = ACTIONS(5588),
    [anon_sym_LT_LT] = ACTIONS(5586),
    [anon_sym_GT_GT] = ACTIONS(5588),
    [anon_sym_GT_GT_GT] = ACTIONS(5586),
    [anon_sym_EQ_EQ] = ACTIONS(5586),
    [anon_sym_BANG_EQ] = ACTIONS(5586),
    [anon_sym_GT_EQ] = ACTIONS(5586),
    [anon_sym_LT_EQ] = ACTIONS(5586),
    [anon_sym_DOT] = ACTIONS(5588),
    [anon_sym_EQ_GT] = ACTIONS(5586),
    [anon_sym_switch] = ACTIONS(5586),
    [anon_sym_DOT_DOT] = ACTIONS(5586),
    [anon_sym_and] = ACTIONS(5586),
    [anon_sym_or] = ACTIONS(5588),
    [anon_sym_AMP_AMP] = ACTIONS(5586),
    [anon_sym_PIPE_PIPE] = ACTIONS(5586),
    [anon_sym_QMARK_QMARK] = ACTIONS(5586),
    [anon_sym_from] = ACTIONS(5586),
    [anon_sym_into] = ACTIONS(5586),
    [anon_sym_join] = ACTIONS(5586),
    [anon_sym_on] = ACTIONS(5586),
    [anon_sym_equals] = ACTIONS(5586),
    [anon_sym_let] = ACTIONS(5586),
    [anon_sym_orderby] = ACTIONS(5586),
    [anon_sym_group] = ACTIONS(5586),
    [anon_sym_by] = ACTIONS(5586),
    [anon_sym_select] = ACTIONS(5586),
    [anon_sym_as] = ACTIONS(5586),
    [anon_sym_is] = ACTIONS(5586),
    [anon_sym_DASH_GT] = ACTIONS(5586),
    [anon_sym_with] = ACTIONS(5586),
    [aux_sym_preproc_if_token3] = ACTIONS(5586),
    [aux_sym_preproc_else_token1] = ACTIONS(5586),
    [aux_sym_preproc_elif_token1] = ACTIONS(5586),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3708] = {
    [sym_preproc_region] = STATE(3708),
    [sym_preproc_endregion] = STATE(3708),
    [sym_preproc_line] = STATE(3708),
    [sym_preproc_pragma] = STATE(3708),
    [sym_preproc_nullable] = STATE(3708),
    [sym_preproc_error] = STATE(3708),
    [sym_preproc_define] = STATE(3708),
    [sym_preproc_undef] = STATE(3708),
    [anon_sym_SEMI] = ACTIONS(4076),
    [anon_sym_LBRACK] = ACTIONS(4076),
    [anon_sym_COLON] = ACTIONS(4076),
    [anon_sym_COMMA] = ACTIONS(4076),
    [anon_sym_RBRACK] = ACTIONS(4076),
    [anon_sym_LPAREN] = ACTIONS(4076),
    [anon_sym_RPAREN] = ACTIONS(4076),
    [anon_sym_LBRACE] = ACTIONS(4076),
    [anon_sym_RBRACE] = ACTIONS(4076),
    [anon_sym_LT] = ACTIONS(4074),
    [anon_sym_GT] = ACTIONS(4074),
    [anon_sym_in] = ACTIONS(4076),
    [anon_sym_where] = ACTIONS(4076),
    [anon_sym_QMARK] = ACTIONS(4074),
    [anon_sym_BANG] = ACTIONS(4074),
    [anon_sym_PLUS_PLUS] = ACTIONS(4076),
    [anon_sym_DASH_DASH] = ACTIONS(4076),
    [anon_sym_PLUS] = ACTIONS(4074),
    [anon_sym_DASH] = ACTIONS(4074),
    [anon_sym_STAR] = ACTIONS(4076),
    [anon_sym_SLASH] = ACTIONS(4074),
    [anon_sym_PERCENT] = ACTIONS(4076),
    [anon_sym_CARET] = ACTIONS(4076),
    [anon_sym_PIPE] = ACTIONS(4074),
    [anon_sym_AMP] = ACTIONS(4074),
    [anon_sym_LT_LT] = ACTIONS(4076),
    [anon_sym_GT_GT] = ACTIONS(4074),
    [anon_sym_GT_GT_GT] = ACTIONS(4076),
    [anon_sym_EQ_EQ] = ACTIONS(4076),
    [anon_sym_BANG_EQ] = ACTIONS(4076),
    [anon_sym_GT_EQ] = ACTIONS(4076),
    [anon_sym_LT_EQ] = ACTIONS(4076),
    [anon_sym_DOT] = ACTIONS(4074),
    [anon_sym_EQ_GT] = ACTIONS(4076),
    [anon_sym_switch] = ACTIONS(4076),
    [anon_sym_DOT_DOT] = ACTIONS(4076),
    [anon_sym_and] = ACTIONS(4076),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_AMP_AMP] = ACTIONS(4076),
    [anon_sym_PIPE_PIPE] = ACTIONS(4076),
    [anon_sym_QMARK_QMARK] = ACTIONS(4076),
    [anon_sym_from] = ACTIONS(4076),
    [anon_sym_join] = ACTIONS(4076),
    [anon_sym_on] = ACTIONS(4076),
    [anon_sym_equals] = ACTIONS(4076),
    [anon_sym_let] = ACTIONS(4076),
    [anon_sym_orderby] = ACTIONS(4076),
    [anon_sym_group] = ACTIONS(4076),
    [anon_sym_by] = ACTIONS(4076),
    [anon_sym_select] = ACTIONS(4076),
    [anon_sym_as] = ACTIONS(4076),
    [anon_sym_is] = ACTIONS(4076),
    [anon_sym_DASH_GT] = ACTIONS(4076),
    [anon_sym_with] = ACTIONS(4076),
    [aux_sym_preproc_if_token3] = ACTIONS(4076),
    [aux_sym_preproc_else_token1] = ACTIONS(4076),
    [aux_sym_preproc_elif_token1] = ACTIONS(4076),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3709] = {
    [sym_preproc_region] = STATE(3709),
    [sym_preproc_endregion] = STATE(3709),
    [sym_preproc_line] = STATE(3709),
    [sym_preproc_pragma] = STATE(3709),
    [sym_preproc_nullable] = STATE(3709),
    [sym_preproc_error] = STATE(3709),
    [sym_preproc_define] = STATE(3709),
    [sym_preproc_undef] = STATE(3709),
    [anon_sym_SEMI] = ACTIONS(2935),
    [anon_sym_LBRACK] = ACTIONS(2935),
    [anon_sym_COLON] = ACTIONS(2935),
    [anon_sym_COMMA] = ACTIONS(2935),
    [anon_sym_RBRACK] = ACTIONS(2935),
    [anon_sym_LPAREN] = ACTIONS(2935),
    [anon_sym_RPAREN] = ACTIONS(2935),
    [anon_sym_RBRACE] = ACTIONS(2935),
    [anon_sym_LT] = ACTIONS(2933),
    [anon_sym_GT] = ACTIONS(2933),
    [anon_sym_in] = ACTIONS(2933),
    [anon_sym_where] = ACTIONS(2935),
    [anon_sym_QMARK] = ACTIONS(2933),
    [anon_sym_BANG] = ACTIONS(2933),
    [anon_sym_PLUS_PLUS] = ACTIONS(2935),
    [anon_sym_DASH_DASH] = ACTIONS(2935),
    [anon_sym_PLUS] = ACTIONS(2933),
    [anon_sym_DASH] = ACTIONS(2933),
    [anon_sym_STAR] = ACTIONS(2935),
    [anon_sym_SLASH] = ACTIONS(2933),
    [anon_sym_PERCENT] = ACTIONS(2935),
    [anon_sym_CARET] = ACTIONS(2935),
    [anon_sym_PIPE] = ACTIONS(2933),
    [anon_sym_AMP] = ACTIONS(2933),
    [anon_sym_LT_LT] = ACTIONS(2935),
    [anon_sym_GT_GT] = ACTIONS(2933),
    [anon_sym_GT_GT_GT] = ACTIONS(2935),
    [anon_sym_EQ_EQ] = ACTIONS(2935),
    [anon_sym_BANG_EQ] = ACTIONS(2935),
    [anon_sym_GT_EQ] = ACTIONS(2935),
    [anon_sym_LT_EQ] = ACTIONS(2935),
    [anon_sym_DOT] = ACTIONS(2933),
    [anon_sym_EQ_GT] = ACTIONS(2935),
    [anon_sym_switch] = ACTIONS(2935),
    [anon_sym_DOT_DOT] = ACTIONS(2935),
    [anon_sym_and] = ACTIONS(2935),
    [anon_sym_or] = ACTIONS(2933),
    [anon_sym_AMP_AMP] = ACTIONS(2935),
    [anon_sym_PIPE_PIPE] = ACTIONS(2935),
    [anon_sym_QMARK_QMARK] = ACTIONS(2935),
    [anon_sym_from] = ACTIONS(2935),
    [anon_sym_into] = ACTIONS(2935),
    [anon_sym_join] = ACTIONS(2935),
    [anon_sym_on] = ACTIONS(2935),
    [anon_sym_equals] = ACTIONS(2935),
    [anon_sym_let] = ACTIONS(2935),
    [anon_sym_orderby] = ACTIONS(2935),
    [anon_sym_group] = ACTIONS(2935),
    [anon_sym_by] = ACTIONS(2935),
    [anon_sym_select] = ACTIONS(2935),
    [anon_sym_as] = ACTIONS(2935),
    [anon_sym_is] = ACTIONS(2935),
    [anon_sym_DASH_GT] = ACTIONS(2935),
    [anon_sym_with] = ACTIONS(2935),
    [aux_sym_preproc_if_token3] = ACTIONS(2935),
    [aux_sym_preproc_else_token1] = ACTIONS(2935),
    [aux_sym_preproc_elif_token1] = ACTIONS(2935),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3710] = {
    [sym_preproc_region] = STATE(3710),
    [sym_preproc_endregion] = STATE(3710),
    [sym_preproc_line] = STATE(3710),
    [sym_preproc_pragma] = STATE(3710),
    [sym_preproc_nullable] = STATE(3710),
    [sym_preproc_error] = STATE(3710),
    [sym_preproc_define] = STATE(3710),
    [sym_preproc_undef] = STATE(3710),
    [anon_sym_SEMI] = ACTIONS(5590),
    [anon_sym_LBRACK] = ACTIONS(5590),
    [anon_sym_COLON] = ACTIONS(5590),
    [anon_sym_COMMA] = ACTIONS(5590),
    [anon_sym_RBRACK] = ACTIONS(5590),
    [anon_sym_LPAREN] = ACTIONS(5590),
    [anon_sym_RPAREN] = ACTIONS(5590),
    [anon_sym_RBRACE] = ACTIONS(5590),
    [anon_sym_LT] = ACTIONS(5592),
    [anon_sym_GT] = ACTIONS(5592),
    [anon_sym_in] = ACTIONS(5592),
    [anon_sym_where] = ACTIONS(5590),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_BANG] = ACTIONS(5592),
    [anon_sym_PLUS_PLUS] = ACTIONS(5590),
    [anon_sym_DASH_DASH] = ACTIONS(5590),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_DASH] = ACTIONS(5592),
    [anon_sym_STAR] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [anon_sym_PERCENT] = ACTIONS(5590),
    [anon_sym_CARET] = ACTIONS(5590),
    [anon_sym_PIPE] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5590),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_GT_GT_GT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_BANG_EQ] = ACTIONS(5590),
    [anon_sym_GT_EQ] = ACTIONS(5590),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_DOT] = ACTIONS(5592),
    [anon_sym_EQ_GT] = ACTIONS(5590),
    [anon_sym_switch] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5590),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_AMP_AMP] = ACTIONS(5590),
    [anon_sym_PIPE_PIPE] = ACTIONS(5590),
    [anon_sym_QMARK_QMARK] = ACTIONS(5590),
    [anon_sym_from] = ACTIONS(5590),
    [anon_sym_into] = ACTIONS(5590),
    [anon_sym_join] = ACTIONS(5590),
    [anon_sym_on] = ACTIONS(5590),
    [anon_sym_equals] = ACTIONS(5590),
    [anon_sym_let] = ACTIONS(5590),
    [anon_sym_orderby] = ACTIONS(5590),
    [anon_sym_group] = ACTIONS(5590),
    [anon_sym_by] = ACTIONS(5590),
    [anon_sym_select] = ACTIONS(5590),
    [anon_sym_as] = ACTIONS(5590),
    [anon_sym_is] = ACTIONS(5590),
    [anon_sym_DASH_GT] = ACTIONS(5590),
    [anon_sym_with] = ACTIONS(5590),
    [aux_sym_preproc_if_token3] = ACTIONS(5590),
    [aux_sym_preproc_else_token1] = ACTIONS(5590),
    [aux_sym_preproc_elif_token1] = ACTIONS(5590),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3711] = {
    [sym_preproc_region] = STATE(3711),
    [sym_preproc_endregion] = STATE(3711),
    [sym_preproc_line] = STATE(3711),
    [sym_preproc_pragma] = STATE(3711),
    [sym_preproc_nullable] = STATE(3711),
    [sym_preproc_error] = STATE(3711),
    [sym_preproc_define] = STATE(3711),
    [sym_preproc_undef] = STATE(3711),
    [anon_sym_SEMI] = ACTIONS(5594),
    [anon_sym_LBRACK] = ACTIONS(5594),
    [anon_sym_COLON] = ACTIONS(5594),
    [anon_sym_COMMA] = ACTIONS(5594),
    [anon_sym_RBRACK] = ACTIONS(5594),
    [anon_sym_LPAREN] = ACTIONS(5594),
    [anon_sym_RPAREN] = ACTIONS(5594),
    [anon_sym_RBRACE] = ACTIONS(5594),
    [anon_sym_LT] = ACTIONS(5596),
    [anon_sym_GT] = ACTIONS(5596),
    [anon_sym_in] = ACTIONS(5596),
    [anon_sym_where] = ACTIONS(5594),
    [anon_sym_QMARK] = ACTIONS(5596),
    [anon_sym_BANG] = ACTIONS(5596),
    [anon_sym_PLUS_PLUS] = ACTIONS(5594),
    [anon_sym_DASH_DASH] = ACTIONS(5594),
    [anon_sym_PLUS] = ACTIONS(5596),
    [anon_sym_DASH] = ACTIONS(5596),
    [anon_sym_STAR] = ACTIONS(5594),
    [anon_sym_SLASH] = ACTIONS(5596),
    [anon_sym_PERCENT] = ACTIONS(5594),
    [anon_sym_CARET] = ACTIONS(5594),
    [anon_sym_PIPE] = ACTIONS(5596),
    [anon_sym_AMP] = ACTIONS(5596),
    [anon_sym_LT_LT] = ACTIONS(5594),
    [anon_sym_GT_GT] = ACTIONS(5596),
    [anon_sym_GT_GT_GT] = ACTIONS(5594),
    [anon_sym_EQ_EQ] = ACTIONS(5594),
    [anon_sym_BANG_EQ] = ACTIONS(5594),
    [anon_sym_GT_EQ] = ACTIONS(5594),
    [anon_sym_LT_EQ] = ACTIONS(5594),
    [anon_sym_DOT] = ACTIONS(5596),
    [anon_sym_EQ_GT] = ACTIONS(5594),
    [anon_sym_switch] = ACTIONS(5594),
    [anon_sym_DOT_DOT] = ACTIONS(5594),
    [anon_sym_and] = ACTIONS(5594),
    [anon_sym_or] = ACTIONS(5596),
    [anon_sym_AMP_AMP] = ACTIONS(5594),
    [anon_sym_PIPE_PIPE] = ACTIONS(5594),
    [anon_sym_QMARK_QMARK] = ACTIONS(5594),
    [anon_sym_from] = ACTIONS(5594),
    [anon_sym_into] = ACTIONS(5594),
    [anon_sym_join] = ACTIONS(5594),
    [anon_sym_on] = ACTIONS(5594),
    [anon_sym_equals] = ACTIONS(5594),
    [anon_sym_let] = ACTIONS(5594),
    [anon_sym_orderby] = ACTIONS(5594),
    [anon_sym_group] = ACTIONS(5594),
    [anon_sym_by] = ACTIONS(5594),
    [anon_sym_select] = ACTIONS(5594),
    [anon_sym_as] = ACTIONS(5594),
    [anon_sym_is] = ACTIONS(5594),
    [anon_sym_DASH_GT] = ACTIONS(5594),
    [anon_sym_with] = ACTIONS(5594),
    [aux_sym_preproc_if_token3] = ACTIONS(5594),
    [aux_sym_preproc_else_token1] = ACTIONS(5594),
    [aux_sym_preproc_elif_token1] = ACTIONS(5594),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3712] = {
    [sym_preproc_region] = STATE(3712),
    [sym_preproc_endregion] = STATE(3712),
    [sym_preproc_line] = STATE(3712),
    [sym_preproc_pragma] = STATE(3712),
    [sym_preproc_nullable] = STATE(3712),
    [sym_preproc_error] = STATE(3712),
    [sym_preproc_define] = STATE(3712),
    [sym_preproc_undef] = STATE(3712),
    [anon_sym_SEMI] = ACTIONS(5598),
    [anon_sym_LBRACK] = ACTIONS(5598),
    [anon_sym_COLON] = ACTIONS(5598),
    [anon_sym_COMMA] = ACTIONS(5598),
    [anon_sym_RBRACK] = ACTIONS(5598),
    [anon_sym_LPAREN] = ACTIONS(5598),
    [anon_sym_RPAREN] = ACTIONS(5598),
    [anon_sym_RBRACE] = ACTIONS(5598),
    [anon_sym_LT] = ACTIONS(5600),
    [anon_sym_GT] = ACTIONS(5600),
    [anon_sym_in] = ACTIONS(5600),
    [anon_sym_where] = ACTIONS(5598),
    [anon_sym_QMARK] = ACTIONS(5600),
    [anon_sym_BANG] = ACTIONS(5600),
    [anon_sym_PLUS_PLUS] = ACTIONS(5598),
    [anon_sym_DASH_DASH] = ACTIONS(5598),
    [anon_sym_PLUS] = ACTIONS(5600),
    [anon_sym_DASH] = ACTIONS(5600),
    [anon_sym_STAR] = ACTIONS(5598),
    [anon_sym_SLASH] = ACTIONS(5600),
    [anon_sym_PERCENT] = ACTIONS(5598),
    [anon_sym_CARET] = ACTIONS(5598),
    [anon_sym_PIPE] = ACTIONS(5600),
    [anon_sym_AMP] = ACTIONS(5600),
    [anon_sym_LT_LT] = ACTIONS(5598),
    [anon_sym_GT_GT] = ACTIONS(5600),
    [anon_sym_GT_GT_GT] = ACTIONS(5598),
    [anon_sym_EQ_EQ] = ACTIONS(5598),
    [anon_sym_BANG_EQ] = ACTIONS(5598),
    [anon_sym_GT_EQ] = ACTIONS(5598),
    [anon_sym_LT_EQ] = ACTIONS(5598),
    [anon_sym_DOT] = ACTIONS(5600),
    [anon_sym_EQ_GT] = ACTIONS(5598),
    [anon_sym_switch] = ACTIONS(5598),
    [anon_sym_DOT_DOT] = ACTIONS(5598),
    [anon_sym_and] = ACTIONS(5598),
    [anon_sym_or] = ACTIONS(5600),
    [anon_sym_AMP_AMP] = ACTIONS(5598),
    [anon_sym_PIPE_PIPE] = ACTIONS(5598),
    [anon_sym_QMARK_QMARK] = ACTIONS(5598),
    [anon_sym_from] = ACTIONS(5598),
    [anon_sym_into] = ACTIONS(5598),
    [anon_sym_join] = ACTIONS(5598),
    [anon_sym_on] = ACTIONS(5598),
    [anon_sym_equals] = ACTIONS(5598),
    [anon_sym_let] = ACTIONS(5598),
    [anon_sym_orderby] = ACTIONS(5598),
    [anon_sym_group] = ACTIONS(5598),
    [anon_sym_by] = ACTIONS(5598),
    [anon_sym_select] = ACTIONS(5598),
    [anon_sym_as] = ACTIONS(5598),
    [anon_sym_is] = ACTIONS(5598),
    [anon_sym_DASH_GT] = ACTIONS(5598),
    [anon_sym_with] = ACTIONS(5598),
    [aux_sym_preproc_if_token3] = ACTIONS(5598),
    [aux_sym_preproc_else_token1] = ACTIONS(5598),
    [aux_sym_preproc_elif_token1] = ACTIONS(5598),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3713] = {
    [sym_preproc_region] = STATE(3713),
    [sym_preproc_endregion] = STATE(3713),
    [sym_preproc_line] = STATE(3713),
    [sym_preproc_pragma] = STATE(3713),
    [sym_preproc_nullable] = STATE(3713),
    [sym_preproc_error] = STATE(3713),
    [sym_preproc_define] = STATE(3713),
    [sym_preproc_undef] = STATE(3713),
    [anon_sym_SEMI] = ACTIONS(5432),
    [anon_sym_LBRACK] = ACTIONS(5432),
    [anon_sym_COLON] = ACTIONS(5432),
    [anon_sym_COMMA] = ACTIONS(5432),
    [anon_sym_RBRACK] = ACTIONS(5432),
    [anon_sym_LPAREN] = ACTIONS(5432),
    [anon_sym_RPAREN] = ACTIONS(5432),
    [anon_sym_RBRACE] = ACTIONS(5432),
    [anon_sym_LT] = ACTIONS(5434),
    [anon_sym_GT] = ACTIONS(5434),
    [anon_sym_in] = ACTIONS(5432),
    [anon_sym_where] = ACTIONS(5432),
    [anon_sym_QMARK] = ACTIONS(5434),
    [anon_sym_BANG] = ACTIONS(5434),
    [anon_sym_PLUS_PLUS] = ACTIONS(5432),
    [anon_sym_DASH_DASH] = ACTIONS(5432),
    [anon_sym_PLUS] = ACTIONS(5434),
    [anon_sym_DASH] = ACTIONS(5434),
    [anon_sym_STAR] = ACTIONS(5432),
    [anon_sym_SLASH] = ACTIONS(5434),
    [anon_sym_PERCENT] = ACTIONS(5432),
    [anon_sym_CARET] = ACTIONS(5432),
    [anon_sym_PIPE] = ACTIONS(5434),
    [anon_sym_AMP] = ACTIONS(5434),
    [anon_sym_LT_LT] = ACTIONS(5432),
    [anon_sym_GT_GT] = ACTIONS(5434),
    [anon_sym_GT_GT_GT] = ACTIONS(5432),
    [anon_sym_EQ_EQ] = ACTIONS(5432),
    [anon_sym_BANG_EQ] = ACTIONS(5432),
    [anon_sym_GT_EQ] = ACTIONS(5432),
    [anon_sym_LT_EQ] = ACTIONS(5432),
    [anon_sym_DOT] = ACTIONS(5434),
    [anon_sym_EQ_GT] = ACTIONS(5432),
    [anon_sym_switch] = ACTIONS(5432),
    [anon_sym_DOT_DOT] = ACTIONS(5432),
    [anon_sym_and] = ACTIONS(5432),
    [anon_sym_or] = ACTIONS(5434),
    [anon_sym_AMP_AMP] = ACTIONS(5432),
    [anon_sym_PIPE_PIPE] = ACTIONS(5432),
    [anon_sym_QMARK_QMARK] = ACTIONS(5432),
    [anon_sym_from] = ACTIONS(5432),
    [anon_sym_join] = ACTIONS(5432),
    [anon_sym_on] = ACTIONS(5432),
    [anon_sym_equals] = ACTIONS(5432),
    [anon_sym_let] = ACTIONS(5432),
    [anon_sym_orderby] = ACTIONS(5432),
    [anon_sym_group] = ACTIONS(5432),
    [anon_sym_by] = ACTIONS(5432),
    [anon_sym_select] = ACTIONS(5432),
    [anon_sym_as] = ACTIONS(5432),
    [anon_sym_is] = ACTIONS(5432),
    [anon_sym_DASH_GT] = ACTIONS(5432),
    [anon_sym_with] = ACTIONS(5432),
    [aux_sym_preproc_if_token3] = ACTIONS(5432),
    [aux_sym_preproc_else_token1] = ACTIONS(5432),
    [aux_sym_preproc_elif_token1] = ACTIONS(5432),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3714] = {
    [sym_preproc_region] = STATE(3714),
    [sym_preproc_endregion] = STATE(3714),
    [sym_preproc_line] = STATE(3714),
    [sym_preproc_pragma] = STATE(3714),
    [sym_preproc_nullable] = STATE(3714),
    [sym_preproc_error] = STATE(3714),
    [sym_preproc_define] = STATE(3714),
    [sym_preproc_undef] = STATE(3714),
    [anon_sym_SEMI] = ACTIONS(5436),
    [anon_sym_LBRACK] = ACTIONS(5436),
    [anon_sym_COLON] = ACTIONS(5436),
    [anon_sym_COMMA] = ACTIONS(5436),
    [anon_sym_RBRACK] = ACTIONS(5436),
    [anon_sym_LPAREN] = ACTIONS(5436),
    [anon_sym_RPAREN] = ACTIONS(5436),
    [anon_sym_RBRACE] = ACTIONS(5436),
    [anon_sym_LT] = ACTIONS(5438),
    [anon_sym_GT] = ACTIONS(5438),
    [anon_sym_in] = ACTIONS(5436),
    [anon_sym_where] = ACTIONS(5436),
    [anon_sym_QMARK] = ACTIONS(5438),
    [anon_sym_BANG] = ACTIONS(5438),
    [anon_sym_PLUS_PLUS] = ACTIONS(5436),
    [anon_sym_DASH_DASH] = ACTIONS(5436),
    [anon_sym_PLUS] = ACTIONS(5438),
    [anon_sym_DASH] = ACTIONS(5438),
    [anon_sym_STAR] = ACTIONS(5436),
    [anon_sym_SLASH] = ACTIONS(5438),
    [anon_sym_PERCENT] = ACTIONS(5436),
    [anon_sym_CARET] = ACTIONS(5436),
    [anon_sym_PIPE] = ACTIONS(5438),
    [anon_sym_AMP] = ACTIONS(5438),
    [anon_sym_LT_LT] = ACTIONS(5436),
    [anon_sym_GT_GT] = ACTIONS(5438),
    [anon_sym_GT_GT_GT] = ACTIONS(5436),
    [anon_sym_EQ_EQ] = ACTIONS(5436),
    [anon_sym_BANG_EQ] = ACTIONS(5436),
    [anon_sym_GT_EQ] = ACTIONS(5436),
    [anon_sym_LT_EQ] = ACTIONS(5436),
    [anon_sym_DOT] = ACTIONS(5438),
    [anon_sym_EQ_GT] = ACTIONS(5436),
    [anon_sym_switch] = ACTIONS(5436),
    [anon_sym_DOT_DOT] = ACTIONS(5436),
    [anon_sym_and] = ACTIONS(5436),
    [anon_sym_or] = ACTIONS(5438),
    [anon_sym_AMP_AMP] = ACTIONS(5436),
    [anon_sym_PIPE_PIPE] = ACTIONS(5436),
    [anon_sym_QMARK_QMARK] = ACTIONS(5436),
    [anon_sym_from] = ACTIONS(5436),
    [anon_sym_join] = ACTIONS(5436),
    [anon_sym_on] = ACTIONS(5436),
    [anon_sym_equals] = ACTIONS(5436),
    [anon_sym_let] = ACTIONS(5436),
    [anon_sym_orderby] = ACTIONS(5436),
    [anon_sym_group] = ACTIONS(5436),
    [anon_sym_by] = ACTIONS(5436),
    [anon_sym_select] = ACTIONS(5436),
    [anon_sym_as] = ACTIONS(5436),
    [anon_sym_is] = ACTIONS(5436),
    [anon_sym_DASH_GT] = ACTIONS(5436),
    [anon_sym_with] = ACTIONS(5436),
    [aux_sym_preproc_if_token3] = ACTIONS(5436),
    [aux_sym_preproc_else_token1] = ACTIONS(5436),
    [aux_sym_preproc_elif_token1] = ACTIONS(5436),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3715] = {
    [sym_preproc_region] = STATE(3715),
    [sym_preproc_endregion] = STATE(3715),
    [sym_preproc_line] = STATE(3715),
    [sym_preproc_pragma] = STATE(3715),
    [sym_preproc_nullable] = STATE(3715),
    [sym_preproc_error] = STATE(3715),
    [sym_preproc_define] = STATE(3715),
    [sym_preproc_undef] = STATE(3715),
    [anon_sym_SEMI] = ACTIONS(5514),
    [anon_sym_LBRACK] = ACTIONS(5514),
    [anon_sym_COLON] = ACTIONS(5514),
    [anon_sym_COMMA] = ACTIONS(5514),
    [anon_sym_RBRACK] = ACTIONS(5514),
    [anon_sym_LPAREN] = ACTIONS(5514),
    [anon_sym_RPAREN] = ACTIONS(5514),
    [anon_sym_RBRACE] = ACTIONS(5514),
    [anon_sym_LT] = ACTIONS(5516),
    [anon_sym_GT] = ACTIONS(5516),
    [anon_sym_in] = ACTIONS(5514),
    [anon_sym_where] = ACTIONS(5514),
    [anon_sym_QMARK] = ACTIONS(5516),
    [anon_sym_BANG] = ACTIONS(5516),
    [anon_sym_PLUS_PLUS] = ACTIONS(5514),
    [anon_sym_DASH_DASH] = ACTIONS(5514),
    [anon_sym_PLUS] = ACTIONS(5516),
    [anon_sym_DASH] = ACTIONS(5516),
    [anon_sym_STAR] = ACTIONS(5514),
    [anon_sym_SLASH] = ACTIONS(5516),
    [anon_sym_PERCENT] = ACTIONS(5514),
    [anon_sym_CARET] = ACTIONS(5514),
    [anon_sym_PIPE] = ACTIONS(5516),
    [anon_sym_AMP] = ACTIONS(5516),
    [anon_sym_LT_LT] = ACTIONS(5514),
    [anon_sym_GT_GT] = ACTIONS(5516),
    [anon_sym_GT_GT_GT] = ACTIONS(5514),
    [anon_sym_EQ_EQ] = ACTIONS(5514),
    [anon_sym_BANG_EQ] = ACTIONS(5514),
    [anon_sym_GT_EQ] = ACTIONS(5514),
    [anon_sym_LT_EQ] = ACTIONS(5514),
    [anon_sym_DOT] = ACTIONS(5516),
    [anon_sym_EQ_GT] = ACTIONS(5514),
    [anon_sym_switch] = ACTIONS(5514),
    [anon_sym_DOT_DOT] = ACTIONS(5514),
    [anon_sym_and] = ACTIONS(5514),
    [anon_sym_or] = ACTIONS(5516),
    [anon_sym_AMP_AMP] = ACTIONS(5514),
    [anon_sym_PIPE_PIPE] = ACTIONS(5514),
    [anon_sym_QMARK_QMARK] = ACTIONS(5514),
    [anon_sym_from] = ACTIONS(5514),
    [anon_sym_join] = ACTIONS(5514),
    [anon_sym_on] = ACTIONS(5514),
    [anon_sym_equals] = ACTIONS(5514),
    [anon_sym_let] = ACTIONS(5514),
    [anon_sym_orderby] = ACTIONS(5514),
    [anon_sym_group] = ACTIONS(5514),
    [anon_sym_by] = ACTIONS(5514),
    [anon_sym_select] = ACTIONS(5514),
    [anon_sym_as] = ACTIONS(5514),
    [anon_sym_is] = ACTIONS(5514),
    [anon_sym_DASH_GT] = ACTIONS(5514),
    [anon_sym_with] = ACTIONS(5514),
    [aux_sym_preproc_if_token3] = ACTIONS(5514),
    [aux_sym_preproc_else_token1] = ACTIONS(5514),
    [aux_sym_preproc_elif_token1] = ACTIONS(5514),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3716] = {
    [sym_preproc_region] = STATE(3716),
    [sym_preproc_endregion] = STATE(3716),
    [sym_preproc_line] = STATE(3716),
    [sym_preproc_pragma] = STATE(3716),
    [sym_preproc_nullable] = STATE(3716),
    [sym_preproc_error] = STATE(3716),
    [sym_preproc_define] = STATE(3716),
    [sym_preproc_undef] = STATE(3716),
    [anon_sym_SEMI] = ACTIONS(5506),
    [anon_sym_LBRACK] = ACTIONS(5506),
    [anon_sym_COLON] = ACTIONS(5506),
    [anon_sym_COMMA] = ACTIONS(5506),
    [anon_sym_RBRACK] = ACTIONS(5506),
    [anon_sym_LPAREN] = ACTIONS(5506),
    [anon_sym_RPAREN] = ACTIONS(5506),
    [anon_sym_RBRACE] = ACTIONS(5506),
    [anon_sym_LT] = ACTIONS(5508),
    [anon_sym_GT] = ACTIONS(5508),
    [anon_sym_in] = ACTIONS(5506),
    [anon_sym_where] = ACTIONS(5506),
    [anon_sym_QMARK] = ACTIONS(5508),
    [anon_sym_BANG] = ACTIONS(5508),
    [anon_sym_PLUS_PLUS] = ACTIONS(5506),
    [anon_sym_DASH_DASH] = ACTIONS(5506),
    [anon_sym_PLUS] = ACTIONS(5508),
    [anon_sym_DASH] = ACTIONS(5508),
    [anon_sym_STAR] = ACTIONS(5506),
    [anon_sym_SLASH] = ACTIONS(5508),
    [anon_sym_PERCENT] = ACTIONS(5506),
    [anon_sym_CARET] = ACTIONS(5506),
    [anon_sym_PIPE] = ACTIONS(5508),
    [anon_sym_AMP] = ACTIONS(5508),
    [anon_sym_LT_LT] = ACTIONS(5506),
    [anon_sym_GT_GT] = ACTIONS(5508),
    [anon_sym_GT_GT_GT] = ACTIONS(5506),
    [anon_sym_EQ_EQ] = ACTIONS(5506),
    [anon_sym_BANG_EQ] = ACTIONS(5506),
    [anon_sym_GT_EQ] = ACTIONS(5506),
    [anon_sym_LT_EQ] = ACTIONS(5506),
    [anon_sym_DOT] = ACTIONS(5508),
    [anon_sym_EQ_GT] = ACTIONS(5506),
    [anon_sym_switch] = ACTIONS(5506),
    [anon_sym_DOT_DOT] = ACTIONS(5506),
    [anon_sym_and] = ACTIONS(5506),
    [anon_sym_or] = ACTIONS(5508),
    [anon_sym_AMP_AMP] = ACTIONS(5506),
    [anon_sym_PIPE_PIPE] = ACTIONS(5506),
    [anon_sym_QMARK_QMARK] = ACTIONS(5506),
    [anon_sym_from] = ACTIONS(5506),
    [anon_sym_join] = ACTIONS(5506),
    [anon_sym_on] = ACTIONS(5506),
    [anon_sym_equals] = ACTIONS(5506),
    [anon_sym_let] = ACTIONS(5506),
    [anon_sym_orderby] = ACTIONS(5506),
    [anon_sym_group] = ACTIONS(5506),
    [anon_sym_by] = ACTIONS(5506),
    [anon_sym_select] = ACTIONS(5506),
    [anon_sym_as] = ACTIONS(5506),
    [anon_sym_is] = ACTIONS(5506),
    [anon_sym_DASH_GT] = ACTIONS(5506),
    [anon_sym_with] = ACTIONS(5506),
    [aux_sym_preproc_if_token3] = ACTIONS(5506),
    [aux_sym_preproc_else_token1] = ACTIONS(5506),
    [aux_sym_preproc_elif_token1] = ACTIONS(5506),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3717] = {
    [sym_preproc_region] = STATE(3717),
    [sym_preproc_endregion] = STATE(3717),
    [sym_preproc_line] = STATE(3717),
    [sym_preproc_pragma] = STATE(3717),
    [sym_preproc_nullable] = STATE(3717),
    [sym_preproc_error] = STATE(3717),
    [sym_preproc_define] = STATE(3717),
    [sym_preproc_undef] = STATE(3717),
    [anon_sym_SEMI] = ACTIONS(5325),
    [anon_sym_LBRACK] = ACTIONS(5325),
    [anon_sym_COLON] = ACTIONS(5325),
    [anon_sym_COMMA] = ACTIONS(5325),
    [anon_sym_RBRACK] = ACTIONS(5325),
    [anon_sym_LPAREN] = ACTIONS(5325),
    [anon_sym_RPAREN] = ACTIONS(5325),
    [anon_sym_RBRACE] = ACTIONS(5325),
    [anon_sym_LT] = ACTIONS(5327),
    [anon_sym_GT] = ACTIONS(5327),
    [anon_sym_in] = ACTIONS(5325),
    [anon_sym_where] = ACTIONS(5325),
    [anon_sym_QMARK] = ACTIONS(5327),
    [anon_sym_BANG] = ACTIONS(5327),
    [anon_sym_PLUS_PLUS] = ACTIONS(5325),
    [anon_sym_DASH_DASH] = ACTIONS(5325),
    [anon_sym_PLUS] = ACTIONS(5327),
    [anon_sym_DASH] = ACTIONS(5327),
    [anon_sym_STAR] = ACTIONS(5325),
    [anon_sym_SLASH] = ACTIONS(5327),
    [anon_sym_PERCENT] = ACTIONS(5325),
    [anon_sym_CARET] = ACTIONS(5325),
    [anon_sym_PIPE] = ACTIONS(5327),
    [anon_sym_AMP] = ACTIONS(5327),
    [anon_sym_LT_LT] = ACTIONS(5325),
    [anon_sym_GT_GT] = ACTIONS(5327),
    [anon_sym_GT_GT_GT] = ACTIONS(5325),
    [anon_sym_EQ_EQ] = ACTIONS(5325),
    [anon_sym_BANG_EQ] = ACTIONS(5325),
    [anon_sym_GT_EQ] = ACTIONS(5325),
    [anon_sym_LT_EQ] = ACTIONS(5325),
    [anon_sym_DOT] = ACTIONS(5327),
    [anon_sym_EQ_GT] = ACTIONS(5325),
    [anon_sym_switch] = ACTIONS(5325),
    [anon_sym_DOT_DOT] = ACTIONS(5325),
    [anon_sym_and] = ACTIONS(5325),
    [anon_sym_or] = ACTIONS(5327),
    [anon_sym_AMP_AMP] = ACTIONS(5325),
    [anon_sym_PIPE_PIPE] = ACTIONS(5325),
    [anon_sym_QMARK_QMARK] = ACTIONS(5325),
    [anon_sym_from] = ACTIONS(5325),
    [anon_sym_join] = ACTIONS(5325),
    [anon_sym_on] = ACTIONS(5325),
    [anon_sym_equals] = ACTIONS(5325),
    [anon_sym_let] = ACTIONS(5325),
    [anon_sym_orderby] = ACTIONS(5325),
    [anon_sym_group] = ACTIONS(5325),
    [anon_sym_by] = ACTIONS(5325),
    [anon_sym_select] = ACTIONS(5325),
    [anon_sym_as] = ACTIONS(5325),
    [anon_sym_is] = ACTIONS(5325),
    [anon_sym_DASH_GT] = ACTIONS(5325),
    [anon_sym_with] = ACTIONS(5325),
    [aux_sym_preproc_if_token3] = ACTIONS(5325),
    [aux_sym_preproc_else_token1] = ACTIONS(5325),
    [aux_sym_preproc_elif_token1] = ACTIONS(5325),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3718] = {
    [sym_preproc_region] = STATE(3718),
    [sym_preproc_endregion] = STATE(3718),
    [sym_preproc_line] = STATE(3718),
    [sym_preproc_pragma] = STATE(3718),
    [sym_preproc_nullable] = STATE(3718),
    [sym_preproc_error] = STATE(3718),
    [sym_preproc_define] = STATE(3718),
    [sym_preproc_undef] = STATE(3718),
    [anon_sym_SEMI] = ACTIONS(5498),
    [anon_sym_LBRACK] = ACTIONS(5498),
    [anon_sym_COLON] = ACTIONS(5498),
    [anon_sym_COMMA] = ACTIONS(5498),
    [anon_sym_RBRACK] = ACTIONS(5498),
    [anon_sym_LPAREN] = ACTIONS(5498),
    [anon_sym_RPAREN] = ACTIONS(5498),
    [anon_sym_RBRACE] = ACTIONS(5498),
    [anon_sym_LT] = ACTIONS(5500),
    [anon_sym_GT] = ACTIONS(5500),
    [anon_sym_in] = ACTIONS(5498),
    [anon_sym_where] = ACTIONS(5498),
    [anon_sym_QMARK] = ACTIONS(5500),
    [anon_sym_BANG] = ACTIONS(5500),
    [anon_sym_PLUS_PLUS] = ACTIONS(5498),
    [anon_sym_DASH_DASH] = ACTIONS(5498),
    [anon_sym_PLUS] = ACTIONS(5500),
    [anon_sym_DASH] = ACTIONS(5500),
    [anon_sym_STAR] = ACTIONS(5498),
    [anon_sym_SLASH] = ACTIONS(5500),
    [anon_sym_PERCENT] = ACTIONS(5498),
    [anon_sym_CARET] = ACTIONS(5498),
    [anon_sym_PIPE] = ACTIONS(5500),
    [anon_sym_AMP] = ACTIONS(5500),
    [anon_sym_LT_LT] = ACTIONS(5498),
    [anon_sym_GT_GT] = ACTIONS(5500),
    [anon_sym_GT_GT_GT] = ACTIONS(5498),
    [anon_sym_EQ_EQ] = ACTIONS(5498),
    [anon_sym_BANG_EQ] = ACTIONS(5498),
    [anon_sym_GT_EQ] = ACTIONS(5498),
    [anon_sym_LT_EQ] = ACTIONS(5498),
    [anon_sym_DOT] = ACTIONS(5500),
    [anon_sym_EQ_GT] = ACTIONS(5498),
    [anon_sym_switch] = ACTIONS(5498),
    [anon_sym_DOT_DOT] = ACTIONS(5498),
    [anon_sym_and] = ACTIONS(5498),
    [anon_sym_or] = ACTIONS(5500),
    [anon_sym_AMP_AMP] = ACTIONS(5498),
    [anon_sym_PIPE_PIPE] = ACTIONS(5498),
    [anon_sym_QMARK_QMARK] = ACTIONS(5498),
    [anon_sym_from] = ACTIONS(5498),
    [anon_sym_join] = ACTIONS(5498),
    [anon_sym_on] = ACTIONS(5498),
    [anon_sym_equals] = ACTIONS(5498),
    [anon_sym_let] = ACTIONS(5498),
    [anon_sym_orderby] = ACTIONS(5498),
    [anon_sym_group] = ACTIONS(5498),
    [anon_sym_by] = ACTIONS(5498),
    [anon_sym_select] = ACTIONS(5498),
    [anon_sym_as] = ACTIONS(5498),
    [anon_sym_is] = ACTIONS(5498),
    [anon_sym_DASH_GT] = ACTIONS(5498),
    [anon_sym_with] = ACTIONS(5498),
    [aux_sym_preproc_if_token3] = ACTIONS(5498),
    [aux_sym_preproc_else_token1] = ACTIONS(5498),
    [aux_sym_preproc_elif_token1] = ACTIONS(5498),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3719] = {
    [sym_preproc_region] = STATE(3719),
    [sym_preproc_endregion] = STATE(3719),
    [sym_preproc_line] = STATE(3719),
    [sym_preproc_pragma] = STATE(3719),
    [sym_preproc_nullable] = STATE(3719),
    [sym_preproc_error] = STATE(3719),
    [sym_preproc_define] = STATE(3719),
    [sym_preproc_undef] = STATE(3719),
    [anon_sym_SEMI] = ACTIONS(5518),
    [anon_sym_LBRACK] = ACTIONS(5518),
    [anon_sym_COLON] = ACTIONS(5518),
    [anon_sym_COMMA] = ACTIONS(5518),
    [anon_sym_RBRACK] = ACTIONS(5518),
    [anon_sym_LPAREN] = ACTIONS(5518),
    [anon_sym_RPAREN] = ACTIONS(5518),
    [anon_sym_RBRACE] = ACTIONS(5518),
    [anon_sym_LT] = ACTIONS(5520),
    [anon_sym_GT] = ACTIONS(5520),
    [anon_sym_in] = ACTIONS(5518),
    [anon_sym_where] = ACTIONS(5518),
    [anon_sym_QMARK] = ACTIONS(5520),
    [anon_sym_BANG] = ACTIONS(5520),
    [anon_sym_PLUS_PLUS] = ACTIONS(5518),
    [anon_sym_DASH_DASH] = ACTIONS(5518),
    [anon_sym_PLUS] = ACTIONS(5520),
    [anon_sym_DASH] = ACTIONS(5520),
    [anon_sym_STAR] = ACTIONS(5518),
    [anon_sym_SLASH] = ACTIONS(5520),
    [anon_sym_PERCENT] = ACTIONS(5518),
    [anon_sym_CARET] = ACTIONS(5518),
    [anon_sym_PIPE] = ACTIONS(5520),
    [anon_sym_AMP] = ACTIONS(5520),
    [anon_sym_LT_LT] = ACTIONS(5518),
    [anon_sym_GT_GT] = ACTIONS(5520),
    [anon_sym_GT_GT_GT] = ACTIONS(5518),
    [anon_sym_EQ_EQ] = ACTIONS(5518),
    [anon_sym_BANG_EQ] = ACTIONS(5518),
    [anon_sym_GT_EQ] = ACTIONS(5518),
    [anon_sym_LT_EQ] = ACTIONS(5518),
    [anon_sym_DOT] = ACTIONS(5520),
    [anon_sym_EQ_GT] = ACTIONS(5518),
    [anon_sym_switch] = ACTIONS(5518),
    [anon_sym_DOT_DOT] = ACTIONS(5518),
    [anon_sym_and] = ACTIONS(5518),
    [anon_sym_or] = ACTIONS(5520),
    [anon_sym_AMP_AMP] = ACTIONS(5518),
    [anon_sym_PIPE_PIPE] = ACTIONS(5518),
    [anon_sym_QMARK_QMARK] = ACTIONS(5518),
    [anon_sym_from] = ACTIONS(5518),
    [anon_sym_join] = ACTIONS(5518),
    [anon_sym_on] = ACTIONS(5518),
    [anon_sym_equals] = ACTIONS(5518),
    [anon_sym_let] = ACTIONS(5518),
    [anon_sym_orderby] = ACTIONS(5518),
    [anon_sym_group] = ACTIONS(5518),
    [anon_sym_by] = ACTIONS(5518),
    [anon_sym_select] = ACTIONS(5518),
    [anon_sym_as] = ACTIONS(5518),
    [anon_sym_is] = ACTIONS(5518),
    [anon_sym_DASH_GT] = ACTIONS(5518),
    [anon_sym_with] = ACTIONS(5518),
    [aux_sym_preproc_if_token3] = ACTIONS(5518),
    [aux_sym_preproc_else_token1] = ACTIONS(5518),
    [aux_sym_preproc_elif_token1] = ACTIONS(5518),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3720] = {
    [sym_preproc_region] = STATE(3720),
    [sym_preproc_endregion] = STATE(3720),
    [sym_preproc_line] = STATE(3720),
    [sym_preproc_pragma] = STATE(3720),
    [sym_preproc_nullable] = STATE(3720),
    [sym_preproc_error] = STATE(3720),
    [sym_preproc_define] = STATE(3720),
    [sym_preproc_undef] = STATE(3720),
    [anon_sym_SEMI] = ACTIONS(5424),
    [anon_sym_LBRACK] = ACTIONS(5424),
    [anon_sym_COLON] = ACTIONS(5424),
    [anon_sym_COMMA] = ACTIONS(5424),
    [anon_sym_RBRACK] = ACTIONS(5424),
    [anon_sym_LPAREN] = ACTIONS(5424),
    [anon_sym_RPAREN] = ACTIONS(5424),
    [anon_sym_RBRACE] = ACTIONS(5424),
    [anon_sym_LT] = ACTIONS(5426),
    [anon_sym_GT] = ACTIONS(5426),
    [anon_sym_in] = ACTIONS(5424),
    [anon_sym_where] = ACTIONS(5424),
    [anon_sym_QMARK] = ACTIONS(5426),
    [anon_sym_BANG] = ACTIONS(5426),
    [anon_sym_PLUS_PLUS] = ACTIONS(5424),
    [anon_sym_DASH_DASH] = ACTIONS(5424),
    [anon_sym_PLUS] = ACTIONS(5426),
    [anon_sym_DASH] = ACTIONS(5426),
    [anon_sym_STAR] = ACTIONS(5424),
    [anon_sym_SLASH] = ACTIONS(5426),
    [anon_sym_PERCENT] = ACTIONS(5424),
    [anon_sym_CARET] = ACTIONS(5424),
    [anon_sym_PIPE] = ACTIONS(5426),
    [anon_sym_AMP] = ACTIONS(5426),
    [anon_sym_LT_LT] = ACTIONS(5424),
    [anon_sym_GT_GT] = ACTIONS(5426),
    [anon_sym_GT_GT_GT] = ACTIONS(5424),
    [anon_sym_EQ_EQ] = ACTIONS(5424),
    [anon_sym_BANG_EQ] = ACTIONS(5424),
    [anon_sym_GT_EQ] = ACTIONS(5424),
    [anon_sym_LT_EQ] = ACTIONS(5424),
    [anon_sym_DOT] = ACTIONS(5426),
    [anon_sym_EQ_GT] = ACTIONS(5424),
    [anon_sym_switch] = ACTIONS(5424),
    [anon_sym_DOT_DOT] = ACTIONS(5424),
    [anon_sym_and] = ACTIONS(5424),
    [anon_sym_or] = ACTIONS(5426),
    [anon_sym_AMP_AMP] = ACTIONS(5424),
    [anon_sym_PIPE_PIPE] = ACTIONS(5424),
    [anon_sym_QMARK_QMARK] = ACTIONS(5424),
    [anon_sym_from] = ACTIONS(5424),
    [anon_sym_join] = ACTIONS(5424),
    [anon_sym_on] = ACTIONS(5424),
    [anon_sym_equals] = ACTIONS(5424),
    [anon_sym_let] = ACTIONS(5424),
    [anon_sym_orderby] = ACTIONS(5424),
    [anon_sym_group] = ACTIONS(5424),
    [anon_sym_by] = ACTIONS(5424),
    [anon_sym_select] = ACTIONS(5424),
    [anon_sym_as] = ACTIONS(5424),
    [anon_sym_is] = ACTIONS(5424),
    [anon_sym_DASH_GT] = ACTIONS(5424),
    [anon_sym_with] = ACTIONS(5424),
    [aux_sym_preproc_if_token3] = ACTIONS(5424),
    [aux_sym_preproc_else_token1] = ACTIONS(5424),
    [aux_sym_preproc_elif_token1] = ACTIONS(5424),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3721] = {
    [sym_preproc_region] = STATE(3721),
    [sym_preproc_endregion] = STATE(3721),
    [sym_preproc_line] = STATE(3721),
    [sym_preproc_pragma] = STATE(3721),
    [sym_preproc_nullable] = STATE(3721),
    [sym_preproc_error] = STATE(3721),
    [sym_preproc_define] = STATE(3721),
    [sym_preproc_undef] = STATE(3721),
    [anon_sym_SEMI] = ACTIONS(5400),
    [anon_sym_LBRACK] = ACTIONS(5400),
    [anon_sym_COLON] = ACTIONS(5400),
    [anon_sym_COMMA] = ACTIONS(5400),
    [anon_sym_RBRACK] = ACTIONS(5400),
    [anon_sym_LPAREN] = ACTIONS(5400),
    [anon_sym_RPAREN] = ACTIONS(5400),
    [anon_sym_RBRACE] = ACTIONS(5400),
    [anon_sym_LT] = ACTIONS(5402),
    [anon_sym_GT] = ACTIONS(5402),
    [anon_sym_in] = ACTIONS(5400),
    [anon_sym_where] = ACTIONS(5400),
    [anon_sym_QMARK] = ACTIONS(5402),
    [anon_sym_BANG] = ACTIONS(5402),
    [anon_sym_PLUS_PLUS] = ACTIONS(5400),
    [anon_sym_DASH_DASH] = ACTIONS(5400),
    [anon_sym_PLUS] = ACTIONS(5402),
    [anon_sym_DASH] = ACTIONS(5402),
    [anon_sym_STAR] = ACTIONS(5400),
    [anon_sym_SLASH] = ACTIONS(5402),
    [anon_sym_PERCENT] = ACTIONS(5400),
    [anon_sym_CARET] = ACTIONS(5400),
    [anon_sym_PIPE] = ACTIONS(5402),
    [anon_sym_AMP] = ACTIONS(5402),
    [anon_sym_LT_LT] = ACTIONS(5400),
    [anon_sym_GT_GT] = ACTIONS(5402),
    [anon_sym_GT_GT_GT] = ACTIONS(5400),
    [anon_sym_EQ_EQ] = ACTIONS(5400),
    [anon_sym_BANG_EQ] = ACTIONS(5400),
    [anon_sym_GT_EQ] = ACTIONS(5400),
    [anon_sym_LT_EQ] = ACTIONS(5400),
    [anon_sym_DOT] = ACTIONS(5402),
    [anon_sym_EQ_GT] = ACTIONS(5400),
    [anon_sym_switch] = ACTIONS(5400),
    [anon_sym_DOT_DOT] = ACTIONS(5400),
    [anon_sym_and] = ACTIONS(5400),
    [anon_sym_or] = ACTIONS(5402),
    [anon_sym_AMP_AMP] = ACTIONS(5400),
    [anon_sym_PIPE_PIPE] = ACTIONS(5400),
    [anon_sym_QMARK_QMARK] = ACTIONS(5400),
    [anon_sym_from] = ACTIONS(5400),
    [anon_sym_join] = ACTIONS(5400),
    [anon_sym_on] = ACTIONS(5400),
    [anon_sym_equals] = ACTIONS(5400),
    [anon_sym_let] = ACTIONS(5400),
    [anon_sym_orderby] = ACTIONS(5400),
    [anon_sym_group] = ACTIONS(5400),
    [anon_sym_by] = ACTIONS(5400),
    [anon_sym_select] = ACTIONS(5400),
    [anon_sym_as] = ACTIONS(5400),
    [anon_sym_is] = ACTIONS(5400),
    [anon_sym_DASH_GT] = ACTIONS(5400),
    [anon_sym_with] = ACTIONS(5400),
    [aux_sym_preproc_if_token3] = ACTIONS(5400),
    [aux_sym_preproc_else_token1] = ACTIONS(5400),
    [aux_sym_preproc_elif_token1] = ACTIONS(5400),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3722] = {
    [sym_preproc_region] = STATE(3722),
    [sym_preproc_endregion] = STATE(3722),
    [sym_preproc_line] = STATE(3722),
    [sym_preproc_pragma] = STATE(3722),
    [sym_preproc_nullable] = STATE(3722),
    [sym_preproc_error] = STATE(3722),
    [sym_preproc_define] = STATE(3722),
    [sym_preproc_undef] = STATE(3722),
    [anon_sym_SEMI] = ACTIONS(5586),
    [anon_sym_LBRACK] = ACTIONS(5586),
    [anon_sym_COLON] = ACTIONS(5586),
    [anon_sym_COMMA] = ACTIONS(5586),
    [anon_sym_RBRACK] = ACTIONS(5586),
    [anon_sym_LPAREN] = ACTIONS(5586),
    [anon_sym_RPAREN] = ACTIONS(5586),
    [anon_sym_RBRACE] = ACTIONS(5586),
    [anon_sym_LT] = ACTIONS(5588),
    [anon_sym_GT] = ACTIONS(5588),
    [anon_sym_in] = ACTIONS(5586),
    [anon_sym_where] = ACTIONS(5586),
    [anon_sym_QMARK] = ACTIONS(5588),
    [anon_sym_BANG] = ACTIONS(5588),
    [anon_sym_PLUS_PLUS] = ACTIONS(5586),
    [anon_sym_DASH_DASH] = ACTIONS(5586),
    [anon_sym_PLUS] = ACTIONS(5588),
    [anon_sym_DASH] = ACTIONS(5588),
    [anon_sym_STAR] = ACTIONS(5586),
    [anon_sym_SLASH] = ACTIONS(5588),
    [anon_sym_PERCENT] = ACTIONS(5586),
    [anon_sym_CARET] = ACTIONS(5586),
    [anon_sym_PIPE] = ACTIONS(5588),
    [anon_sym_AMP] = ACTIONS(5588),
    [anon_sym_LT_LT] = ACTIONS(5586),
    [anon_sym_GT_GT] = ACTIONS(5588),
    [anon_sym_GT_GT_GT] = ACTIONS(5586),
    [anon_sym_EQ_EQ] = ACTIONS(5586),
    [anon_sym_BANG_EQ] = ACTIONS(5586),
    [anon_sym_GT_EQ] = ACTIONS(5586),
    [anon_sym_LT_EQ] = ACTIONS(5586),
    [anon_sym_DOT] = ACTIONS(5588),
    [anon_sym_EQ_GT] = ACTIONS(5586),
    [anon_sym_switch] = ACTIONS(5586),
    [anon_sym_DOT_DOT] = ACTIONS(5586),
    [anon_sym_and] = ACTIONS(5586),
    [anon_sym_or] = ACTIONS(5588),
    [anon_sym_AMP_AMP] = ACTIONS(5586),
    [anon_sym_PIPE_PIPE] = ACTIONS(5586),
    [anon_sym_QMARK_QMARK] = ACTIONS(5586),
    [anon_sym_from] = ACTIONS(5586),
    [anon_sym_join] = ACTIONS(5586),
    [anon_sym_on] = ACTIONS(5586),
    [anon_sym_equals] = ACTIONS(5586),
    [anon_sym_let] = ACTIONS(5586),
    [anon_sym_orderby] = ACTIONS(5586),
    [anon_sym_group] = ACTIONS(5586),
    [anon_sym_by] = ACTIONS(5586),
    [anon_sym_select] = ACTIONS(5586),
    [anon_sym_as] = ACTIONS(5586),
    [anon_sym_is] = ACTIONS(5586),
    [anon_sym_DASH_GT] = ACTIONS(5586),
    [anon_sym_with] = ACTIONS(5586),
    [aux_sym_preproc_if_token3] = ACTIONS(5586),
    [aux_sym_preproc_else_token1] = ACTIONS(5586),
    [aux_sym_preproc_elif_token1] = ACTIONS(5586),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3723] = {
    [sym_preproc_region] = STATE(3723),
    [sym_preproc_endregion] = STATE(3723),
    [sym_preproc_line] = STATE(3723),
    [sym_preproc_pragma] = STATE(3723),
    [sym_preproc_nullable] = STATE(3723),
    [sym_preproc_error] = STATE(3723),
    [sym_preproc_define] = STATE(3723),
    [sym_preproc_undef] = STATE(3723),
    [anon_sym_SEMI] = ACTIONS(5494),
    [anon_sym_LBRACK] = ACTIONS(5494),
    [anon_sym_COLON] = ACTIONS(5494),
    [anon_sym_COMMA] = ACTIONS(5494),
    [anon_sym_RBRACK] = ACTIONS(5494),
    [anon_sym_LPAREN] = ACTIONS(5494),
    [anon_sym_RPAREN] = ACTIONS(5494),
    [anon_sym_RBRACE] = ACTIONS(5494),
    [anon_sym_LT] = ACTIONS(5496),
    [anon_sym_GT] = ACTIONS(5496),
    [anon_sym_in] = ACTIONS(5494),
    [anon_sym_where] = ACTIONS(5494),
    [anon_sym_QMARK] = ACTIONS(5496),
    [anon_sym_BANG] = ACTIONS(5496),
    [anon_sym_PLUS_PLUS] = ACTIONS(5494),
    [anon_sym_DASH_DASH] = ACTIONS(5494),
    [anon_sym_PLUS] = ACTIONS(5496),
    [anon_sym_DASH] = ACTIONS(5496),
    [anon_sym_STAR] = ACTIONS(5494),
    [anon_sym_SLASH] = ACTIONS(5496),
    [anon_sym_PERCENT] = ACTIONS(5494),
    [anon_sym_CARET] = ACTIONS(5494),
    [anon_sym_PIPE] = ACTIONS(5496),
    [anon_sym_AMP] = ACTIONS(5496),
    [anon_sym_LT_LT] = ACTIONS(5494),
    [anon_sym_GT_GT] = ACTIONS(5496),
    [anon_sym_GT_GT_GT] = ACTIONS(5494),
    [anon_sym_EQ_EQ] = ACTIONS(5494),
    [anon_sym_BANG_EQ] = ACTIONS(5494),
    [anon_sym_GT_EQ] = ACTIONS(5494),
    [anon_sym_LT_EQ] = ACTIONS(5494),
    [anon_sym_DOT] = ACTIONS(5496),
    [anon_sym_EQ_GT] = ACTIONS(5494),
    [anon_sym_switch] = ACTIONS(5494),
    [anon_sym_DOT_DOT] = ACTIONS(5494),
    [anon_sym_and] = ACTIONS(5494),
    [anon_sym_or] = ACTIONS(5496),
    [anon_sym_AMP_AMP] = ACTIONS(5494),
    [anon_sym_PIPE_PIPE] = ACTIONS(5494),
    [anon_sym_QMARK_QMARK] = ACTIONS(5494),
    [anon_sym_from] = ACTIONS(5494),
    [anon_sym_join] = ACTIONS(5494),
    [anon_sym_on] = ACTIONS(5494),
    [anon_sym_equals] = ACTIONS(5494),
    [anon_sym_let] = ACTIONS(5494),
    [anon_sym_orderby] = ACTIONS(5494),
    [anon_sym_group] = ACTIONS(5494),
    [anon_sym_by] = ACTIONS(5494),
    [anon_sym_select] = ACTIONS(5494),
    [anon_sym_as] = ACTIONS(5494),
    [anon_sym_is] = ACTIONS(5494),
    [anon_sym_DASH_GT] = ACTIONS(5494),
    [anon_sym_with] = ACTIONS(5494),
    [aux_sym_preproc_if_token3] = ACTIONS(5494),
    [aux_sym_preproc_else_token1] = ACTIONS(5494),
    [aux_sym_preproc_elif_token1] = ACTIONS(5494),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3724] = {
    [sym_preproc_region] = STATE(3724),
    [sym_preproc_endregion] = STATE(3724),
    [sym_preproc_line] = STATE(3724),
    [sym_preproc_pragma] = STATE(3724),
    [sym_preproc_nullable] = STATE(3724),
    [sym_preproc_error] = STATE(3724),
    [sym_preproc_define] = STATE(3724),
    [sym_preproc_undef] = STATE(3724),
    [anon_sym_SEMI] = ACTIONS(5594),
    [anon_sym_LBRACK] = ACTIONS(5594),
    [anon_sym_COLON] = ACTIONS(5594),
    [anon_sym_COMMA] = ACTIONS(5594),
    [anon_sym_RBRACK] = ACTIONS(5594),
    [anon_sym_LPAREN] = ACTIONS(5594),
    [anon_sym_RPAREN] = ACTIONS(5594),
    [anon_sym_RBRACE] = ACTIONS(5594),
    [anon_sym_LT] = ACTIONS(5596),
    [anon_sym_GT] = ACTIONS(5596),
    [anon_sym_in] = ACTIONS(5594),
    [anon_sym_where] = ACTIONS(5594),
    [anon_sym_QMARK] = ACTIONS(5596),
    [anon_sym_BANG] = ACTIONS(5596),
    [anon_sym_PLUS_PLUS] = ACTIONS(5594),
    [anon_sym_DASH_DASH] = ACTIONS(5594),
    [anon_sym_PLUS] = ACTIONS(5596),
    [anon_sym_DASH] = ACTIONS(5596),
    [anon_sym_STAR] = ACTIONS(5594),
    [anon_sym_SLASH] = ACTIONS(5596),
    [anon_sym_PERCENT] = ACTIONS(5594),
    [anon_sym_CARET] = ACTIONS(5594),
    [anon_sym_PIPE] = ACTIONS(5596),
    [anon_sym_AMP] = ACTIONS(5596),
    [anon_sym_LT_LT] = ACTIONS(5594),
    [anon_sym_GT_GT] = ACTIONS(5596),
    [anon_sym_GT_GT_GT] = ACTIONS(5594),
    [anon_sym_EQ_EQ] = ACTIONS(5594),
    [anon_sym_BANG_EQ] = ACTIONS(5594),
    [anon_sym_GT_EQ] = ACTIONS(5594),
    [anon_sym_LT_EQ] = ACTIONS(5594),
    [anon_sym_DOT] = ACTIONS(5596),
    [anon_sym_EQ_GT] = ACTIONS(5594),
    [anon_sym_switch] = ACTIONS(5594),
    [anon_sym_DOT_DOT] = ACTIONS(5594),
    [anon_sym_and] = ACTIONS(5594),
    [anon_sym_or] = ACTIONS(5596),
    [anon_sym_AMP_AMP] = ACTIONS(5594),
    [anon_sym_PIPE_PIPE] = ACTIONS(5594),
    [anon_sym_QMARK_QMARK] = ACTIONS(5594),
    [anon_sym_from] = ACTIONS(5594),
    [anon_sym_join] = ACTIONS(5594),
    [anon_sym_on] = ACTIONS(5594),
    [anon_sym_equals] = ACTIONS(5594),
    [anon_sym_let] = ACTIONS(5594),
    [anon_sym_orderby] = ACTIONS(5594),
    [anon_sym_group] = ACTIONS(5594),
    [anon_sym_by] = ACTIONS(5594),
    [anon_sym_select] = ACTIONS(5594),
    [anon_sym_as] = ACTIONS(5594),
    [anon_sym_is] = ACTIONS(5594),
    [anon_sym_DASH_GT] = ACTIONS(5594),
    [anon_sym_with] = ACTIONS(5594),
    [aux_sym_preproc_if_token3] = ACTIONS(5594),
    [aux_sym_preproc_else_token1] = ACTIONS(5594),
    [aux_sym_preproc_elif_token1] = ACTIONS(5594),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3725] = {
    [sym_preproc_region] = STATE(3725),
    [sym_preproc_endregion] = STATE(3725),
    [sym_preproc_line] = STATE(3725),
    [sym_preproc_pragma] = STATE(3725),
    [sym_preproc_nullable] = STATE(3725),
    [sym_preproc_error] = STATE(3725),
    [sym_preproc_define] = STATE(3725),
    [sym_preproc_undef] = STATE(3725),
    [anon_sym_SEMI] = ACTIONS(5428),
    [anon_sym_LBRACK] = ACTIONS(5428),
    [anon_sym_COLON] = ACTIONS(5428),
    [anon_sym_COMMA] = ACTIONS(5428),
    [anon_sym_RBRACK] = ACTIONS(5428),
    [anon_sym_LPAREN] = ACTIONS(5428),
    [anon_sym_RPAREN] = ACTIONS(5428),
    [anon_sym_RBRACE] = ACTIONS(5428),
    [anon_sym_LT] = ACTIONS(5430),
    [anon_sym_GT] = ACTIONS(5430),
    [anon_sym_in] = ACTIONS(5428),
    [anon_sym_where] = ACTIONS(5428),
    [anon_sym_QMARK] = ACTIONS(5430),
    [anon_sym_BANG] = ACTIONS(5430),
    [anon_sym_PLUS_PLUS] = ACTIONS(5428),
    [anon_sym_DASH_DASH] = ACTIONS(5428),
    [anon_sym_PLUS] = ACTIONS(5430),
    [anon_sym_DASH] = ACTIONS(5430),
    [anon_sym_STAR] = ACTIONS(5428),
    [anon_sym_SLASH] = ACTIONS(5430),
    [anon_sym_PERCENT] = ACTIONS(5428),
    [anon_sym_CARET] = ACTIONS(5428),
    [anon_sym_PIPE] = ACTIONS(5430),
    [anon_sym_AMP] = ACTIONS(5430),
    [anon_sym_LT_LT] = ACTIONS(5428),
    [anon_sym_GT_GT] = ACTIONS(5430),
    [anon_sym_GT_GT_GT] = ACTIONS(5428),
    [anon_sym_EQ_EQ] = ACTIONS(5428),
    [anon_sym_BANG_EQ] = ACTIONS(5428),
    [anon_sym_GT_EQ] = ACTIONS(5428),
    [anon_sym_LT_EQ] = ACTIONS(5428),
    [anon_sym_DOT] = ACTIONS(5430),
    [anon_sym_EQ_GT] = ACTIONS(5428),
    [anon_sym_switch] = ACTIONS(5428),
    [anon_sym_DOT_DOT] = ACTIONS(5428),
    [anon_sym_and] = ACTIONS(5428),
    [anon_sym_or] = ACTIONS(5430),
    [anon_sym_AMP_AMP] = ACTIONS(5428),
    [anon_sym_PIPE_PIPE] = ACTIONS(5428),
    [anon_sym_QMARK_QMARK] = ACTIONS(5428),
    [anon_sym_from] = ACTIONS(5428),
    [anon_sym_join] = ACTIONS(5428),
    [anon_sym_on] = ACTIONS(5428),
    [anon_sym_equals] = ACTIONS(5428),
    [anon_sym_let] = ACTIONS(5428),
    [anon_sym_orderby] = ACTIONS(5428),
    [anon_sym_group] = ACTIONS(5428),
    [anon_sym_by] = ACTIONS(5428),
    [anon_sym_select] = ACTIONS(5428),
    [anon_sym_as] = ACTIONS(5428),
    [anon_sym_is] = ACTIONS(5428),
    [anon_sym_DASH_GT] = ACTIONS(5428),
    [anon_sym_with] = ACTIONS(5428),
    [aux_sym_preproc_if_token3] = ACTIONS(5428),
    [aux_sym_preproc_else_token1] = ACTIONS(5428),
    [aux_sym_preproc_elif_token1] = ACTIONS(5428),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3726] = {
    [sym_preproc_region] = STATE(3726),
    [sym_preproc_endregion] = STATE(3726),
    [sym_preproc_line] = STATE(3726),
    [sym_preproc_pragma] = STATE(3726),
    [sym_preproc_nullable] = STATE(3726),
    [sym_preproc_error] = STATE(3726),
    [sym_preproc_define] = STATE(3726),
    [sym_preproc_undef] = STATE(3726),
    [anon_sym_SEMI] = ACTIONS(5420),
    [anon_sym_LBRACK] = ACTIONS(5420),
    [anon_sym_COLON] = ACTIONS(5420),
    [anon_sym_COMMA] = ACTIONS(5420),
    [anon_sym_RBRACK] = ACTIONS(5420),
    [anon_sym_LPAREN] = ACTIONS(5420),
    [anon_sym_RPAREN] = ACTIONS(5420),
    [anon_sym_RBRACE] = ACTIONS(5420),
    [anon_sym_LT] = ACTIONS(5422),
    [anon_sym_GT] = ACTIONS(5422),
    [anon_sym_in] = ACTIONS(5420),
    [anon_sym_where] = ACTIONS(5420),
    [anon_sym_QMARK] = ACTIONS(5422),
    [anon_sym_BANG] = ACTIONS(5422),
    [anon_sym_PLUS_PLUS] = ACTIONS(5420),
    [anon_sym_DASH_DASH] = ACTIONS(5420),
    [anon_sym_PLUS] = ACTIONS(5422),
    [anon_sym_DASH] = ACTIONS(5422),
    [anon_sym_STAR] = ACTIONS(5420),
    [anon_sym_SLASH] = ACTIONS(5422),
    [anon_sym_PERCENT] = ACTIONS(5420),
    [anon_sym_CARET] = ACTIONS(5420),
    [anon_sym_PIPE] = ACTIONS(5422),
    [anon_sym_AMP] = ACTIONS(5422),
    [anon_sym_LT_LT] = ACTIONS(5420),
    [anon_sym_GT_GT] = ACTIONS(5422),
    [anon_sym_GT_GT_GT] = ACTIONS(5420),
    [anon_sym_EQ_EQ] = ACTIONS(5420),
    [anon_sym_BANG_EQ] = ACTIONS(5420),
    [anon_sym_GT_EQ] = ACTIONS(5420),
    [anon_sym_LT_EQ] = ACTIONS(5420),
    [anon_sym_DOT] = ACTIONS(5422),
    [anon_sym_EQ_GT] = ACTIONS(5420),
    [anon_sym_switch] = ACTIONS(5420),
    [anon_sym_DOT_DOT] = ACTIONS(5420),
    [anon_sym_and] = ACTIONS(5420),
    [anon_sym_or] = ACTIONS(5422),
    [anon_sym_AMP_AMP] = ACTIONS(5420),
    [anon_sym_PIPE_PIPE] = ACTIONS(5420),
    [anon_sym_QMARK_QMARK] = ACTIONS(5420),
    [anon_sym_from] = ACTIONS(5420),
    [anon_sym_join] = ACTIONS(5420),
    [anon_sym_on] = ACTIONS(5420),
    [anon_sym_equals] = ACTIONS(5420),
    [anon_sym_let] = ACTIONS(5420),
    [anon_sym_orderby] = ACTIONS(5420),
    [anon_sym_group] = ACTIONS(5420),
    [anon_sym_by] = ACTIONS(5420),
    [anon_sym_select] = ACTIONS(5420),
    [anon_sym_as] = ACTIONS(5420),
    [anon_sym_is] = ACTIONS(5420),
    [anon_sym_DASH_GT] = ACTIONS(5420),
    [anon_sym_with] = ACTIONS(5420),
    [aux_sym_preproc_if_token3] = ACTIONS(5420),
    [aux_sym_preproc_else_token1] = ACTIONS(5420),
    [aux_sym_preproc_elif_token1] = ACTIONS(5420),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3727] = {
    [sym_preproc_region] = STATE(3727),
    [sym_preproc_endregion] = STATE(3727),
    [sym_preproc_line] = STATE(3727),
    [sym_preproc_pragma] = STATE(3727),
    [sym_preproc_nullable] = STATE(3727),
    [sym_preproc_error] = STATE(3727),
    [sym_preproc_define] = STATE(3727),
    [sym_preproc_undef] = STATE(3727),
    [anon_sym_SEMI] = ACTIONS(5404),
    [anon_sym_LBRACK] = ACTIONS(5404),
    [anon_sym_COLON] = ACTIONS(5404),
    [anon_sym_COMMA] = ACTIONS(5404),
    [anon_sym_RBRACK] = ACTIONS(5404),
    [anon_sym_LPAREN] = ACTIONS(5404),
    [anon_sym_RPAREN] = ACTIONS(5404),
    [anon_sym_RBRACE] = ACTIONS(5404),
    [anon_sym_LT] = ACTIONS(5406),
    [anon_sym_GT] = ACTIONS(5406),
    [anon_sym_in] = ACTIONS(5404),
    [anon_sym_where] = ACTIONS(5404),
    [anon_sym_QMARK] = ACTIONS(5406),
    [anon_sym_BANG] = ACTIONS(5406),
    [anon_sym_PLUS_PLUS] = ACTIONS(5404),
    [anon_sym_DASH_DASH] = ACTIONS(5404),
    [anon_sym_PLUS] = ACTIONS(5406),
    [anon_sym_DASH] = ACTIONS(5406),
    [anon_sym_STAR] = ACTIONS(5404),
    [anon_sym_SLASH] = ACTIONS(5406),
    [anon_sym_PERCENT] = ACTIONS(5404),
    [anon_sym_CARET] = ACTIONS(5404),
    [anon_sym_PIPE] = ACTIONS(5406),
    [anon_sym_AMP] = ACTIONS(5406),
    [anon_sym_LT_LT] = ACTIONS(5404),
    [anon_sym_GT_GT] = ACTIONS(5406),
    [anon_sym_GT_GT_GT] = ACTIONS(5404),
    [anon_sym_EQ_EQ] = ACTIONS(5404),
    [anon_sym_BANG_EQ] = ACTIONS(5404),
    [anon_sym_GT_EQ] = ACTIONS(5404),
    [anon_sym_LT_EQ] = ACTIONS(5404),
    [anon_sym_DOT] = ACTIONS(5406),
    [anon_sym_EQ_GT] = ACTIONS(5404),
    [anon_sym_switch] = ACTIONS(5404),
    [anon_sym_DOT_DOT] = ACTIONS(5404),
    [anon_sym_and] = ACTIONS(5404),
    [anon_sym_or] = ACTIONS(5406),
    [anon_sym_AMP_AMP] = ACTIONS(5404),
    [anon_sym_PIPE_PIPE] = ACTIONS(5404),
    [anon_sym_QMARK_QMARK] = ACTIONS(5404),
    [anon_sym_from] = ACTIONS(5404),
    [anon_sym_join] = ACTIONS(5404),
    [anon_sym_on] = ACTIONS(5404),
    [anon_sym_equals] = ACTIONS(5404),
    [anon_sym_let] = ACTIONS(5404),
    [anon_sym_orderby] = ACTIONS(5404),
    [anon_sym_group] = ACTIONS(5404),
    [anon_sym_by] = ACTIONS(5404),
    [anon_sym_select] = ACTIONS(5404),
    [anon_sym_as] = ACTIONS(5404),
    [anon_sym_is] = ACTIONS(5404),
    [anon_sym_DASH_GT] = ACTIONS(5404),
    [anon_sym_with] = ACTIONS(5404),
    [aux_sym_preproc_if_token3] = ACTIONS(5404),
    [aux_sym_preproc_else_token1] = ACTIONS(5404),
    [aux_sym_preproc_elif_token1] = ACTIONS(5404),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3728] = {
    [sym_preproc_region] = STATE(3728),
    [sym_preproc_endregion] = STATE(3728),
    [sym_preproc_line] = STATE(3728),
    [sym_preproc_pragma] = STATE(3728),
    [sym_preproc_nullable] = STATE(3728),
    [sym_preproc_error] = STATE(3728),
    [sym_preproc_define] = STATE(3728),
    [sym_preproc_undef] = STATE(3728),
    [anon_sym_SEMI] = ACTIONS(4695),
    [anon_sym_LBRACK] = ACTIONS(4695),
    [anon_sym_COLON] = ACTIONS(4695),
    [anon_sym_COMMA] = ACTIONS(4695),
    [anon_sym_RBRACK] = ACTIONS(4695),
    [anon_sym_LPAREN] = ACTIONS(4695),
    [anon_sym_RPAREN] = ACTIONS(4695),
    [anon_sym_RBRACE] = ACTIONS(4695),
    [anon_sym_LT] = ACTIONS(4697),
    [anon_sym_GT] = ACTIONS(4697),
    [anon_sym_in] = ACTIONS(4695),
    [anon_sym_where] = ACTIONS(4695),
    [anon_sym_QMARK] = ACTIONS(4697),
    [anon_sym_BANG] = ACTIONS(4697),
    [anon_sym_PLUS_PLUS] = ACTIONS(4695),
    [anon_sym_DASH_DASH] = ACTIONS(4695),
    [anon_sym_PLUS] = ACTIONS(4697),
    [anon_sym_DASH] = ACTIONS(4697),
    [anon_sym_STAR] = ACTIONS(4695),
    [anon_sym_SLASH] = ACTIONS(4697),
    [anon_sym_PERCENT] = ACTIONS(4695),
    [anon_sym_CARET] = ACTIONS(4695),
    [anon_sym_PIPE] = ACTIONS(4697),
    [anon_sym_AMP] = ACTIONS(4697),
    [anon_sym_LT_LT] = ACTIONS(4695),
    [anon_sym_GT_GT] = ACTIONS(4697),
    [anon_sym_GT_GT_GT] = ACTIONS(4695),
    [anon_sym_EQ_EQ] = ACTIONS(4695),
    [anon_sym_BANG_EQ] = ACTIONS(4695),
    [anon_sym_GT_EQ] = ACTIONS(4695),
    [anon_sym_LT_EQ] = ACTIONS(4695),
    [anon_sym_DOT] = ACTIONS(4697),
    [anon_sym_EQ_GT] = ACTIONS(4695),
    [anon_sym_switch] = ACTIONS(4695),
    [anon_sym_DOT_DOT] = ACTIONS(4695),
    [anon_sym_and] = ACTIONS(4695),
    [anon_sym_or] = ACTIONS(4697),
    [anon_sym_AMP_AMP] = ACTIONS(4695),
    [anon_sym_PIPE_PIPE] = ACTIONS(4695),
    [anon_sym_QMARK_QMARK] = ACTIONS(4695),
    [anon_sym_from] = ACTIONS(4695),
    [anon_sym_join] = ACTIONS(4695),
    [anon_sym_on] = ACTIONS(4695),
    [anon_sym_equals] = ACTIONS(4695),
    [anon_sym_let] = ACTIONS(4695),
    [anon_sym_orderby] = ACTIONS(4695),
    [anon_sym_group] = ACTIONS(4695),
    [anon_sym_by] = ACTIONS(4695),
    [anon_sym_select] = ACTIONS(4695),
    [anon_sym_as] = ACTIONS(4695),
    [anon_sym_is] = ACTIONS(4695),
    [anon_sym_DASH_GT] = ACTIONS(4695),
    [anon_sym_with] = ACTIONS(4695),
    [aux_sym_preproc_if_token3] = ACTIONS(4695),
    [aux_sym_preproc_else_token1] = ACTIONS(4695),
    [aux_sym_preproc_elif_token1] = ACTIONS(4695),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3729] = {
    [sym_preproc_region] = STATE(3729),
    [sym_preproc_endregion] = STATE(3729),
    [sym_preproc_line] = STATE(3729),
    [sym_preproc_pragma] = STATE(3729),
    [sym_preproc_nullable] = STATE(3729),
    [sym_preproc_error] = STATE(3729),
    [sym_preproc_define] = STATE(3729),
    [sym_preproc_undef] = STATE(3729),
    [anon_sym_SEMI] = ACTIONS(5444),
    [anon_sym_LBRACK] = ACTIONS(5444),
    [anon_sym_COLON] = ACTIONS(5444),
    [anon_sym_COMMA] = ACTIONS(5444),
    [anon_sym_RBRACK] = ACTIONS(5444),
    [anon_sym_LPAREN] = ACTIONS(5444),
    [anon_sym_RPAREN] = ACTIONS(5444),
    [anon_sym_RBRACE] = ACTIONS(5444),
    [anon_sym_LT] = ACTIONS(5446),
    [anon_sym_GT] = ACTIONS(5446),
    [anon_sym_in] = ACTIONS(5444),
    [anon_sym_where] = ACTIONS(5444),
    [anon_sym_QMARK] = ACTIONS(5446),
    [anon_sym_BANG] = ACTIONS(5446),
    [anon_sym_PLUS_PLUS] = ACTIONS(5444),
    [anon_sym_DASH_DASH] = ACTIONS(5444),
    [anon_sym_PLUS] = ACTIONS(5446),
    [anon_sym_DASH] = ACTIONS(5446),
    [anon_sym_STAR] = ACTIONS(5444),
    [anon_sym_SLASH] = ACTIONS(5446),
    [anon_sym_PERCENT] = ACTIONS(5444),
    [anon_sym_CARET] = ACTIONS(5444),
    [anon_sym_PIPE] = ACTIONS(5446),
    [anon_sym_AMP] = ACTIONS(5446),
    [anon_sym_LT_LT] = ACTIONS(5444),
    [anon_sym_GT_GT] = ACTIONS(5446),
    [anon_sym_GT_GT_GT] = ACTIONS(5444),
    [anon_sym_EQ_EQ] = ACTIONS(5444),
    [anon_sym_BANG_EQ] = ACTIONS(5444),
    [anon_sym_GT_EQ] = ACTIONS(5444),
    [anon_sym_LT_EQ] = ACTIONS(5444),
    [anon_sym_DOT] = ACTIONS(5446),
    [anon_sym_EQ_GT] = ACTIONS(5444),
    [anon_sym_switch] = ACTIONS(5444),
    [anon_sym_DOT_DOT] = ACTIONS(5444),
    [anon_sym_and] = ACTIONS(5444),
    [anon_sym_or] = ACTIONS(5446),
    [anon_sym_AMP_AMP] = ACTIONS(5444),
    [anon_sym_PIPE_PIPE] = ACTIONS(5444),
    [anon_sym_QMARK_QMARK] = ACTIONS(5444),
    [anon_sym_from] = ACTIONS(5444),
    [anon_sym_join] = ACTIONS(5444),
    [anon_sym_on] = ACTIONS(5444),
    [anon_sym_equals] = ACTIONS(5444),
    [anon_sym_let] = ACTIONS(5444),
    [anon_sym_orderby] = ACTIONS(5444),
    [anon_sym_group] = ACTIONS(5444),
    [anon_sym_by] = ACTIONS(5444),
    [anon_sym_select] = ACTIONS(5444),
    [anon_sym_as] = ACTIONS(5444),
    [anon_sym_is] = ACTIONS(5444),
    [anon_sym_DASH_GT] = ACTIONS(5444),
    [anon_sym_with] = ACTIONS(5444),
    [aux_sym_preproc_if_token3] = ACTIONS(5444),
    [aux_sym_preproc_else_token1] = ACTIONS(5444),
    [aux_sym_preproc_elif_token1] = ACTIONS(5444),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3730] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter] = STATE(8613),
    [sym__parameter_array] = STATE(8612),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7337),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_identifier] = STATE(6729),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(3730),
    [sym_preproc_endregion] = STATE(3730),
    [sym_preproc_line] = STATE(3730),
    [sym_preproc_pragma] = STATE(3730),
    [sym_preproc_nullable] = STATE(3730),
    [sym_preproc_error] = STATE(3730),
    [sym_preproc_define] = STATE(3730),
    [sym_preproc_undef] = STATE(3730),
    [aux_sym_class_declaration_repeat1] = STATE(3784),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4143),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_LBRACK] = ACTIONS(5212),
    [anon_sym_LPAREN] = ACTIONS(2995),
    [anon_sym_ref] = ACTIONS(5216),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_readonly] = ACTIONS(1093),
    [anon_sym_in] = ACTIONS(1093),
    [anon_sym_out] = ACTIONS(1093),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_this] = ACTIONS(1093),
    [anon_sym_scoped] = ACTIONS(5218),
    [anon_sym_params] = ACTIONS(1107),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3731] = {
    [sym_preproc_region] = STATE(3731),
    [sym_preproc_endregion] = STATE(3731),
    [sym_preproc_line] = STATE(3731),
    [sym_preproc_pragma] = STATE(3731),
    [sym_preproc_nullable] = STATE(3731),
    [sym_preproc_error] = STATE(3731),
    [sym_preproc_define] = STATE(3731),
    [sym_preproc_undef] = STATE(3731),
    [anon_sym_SEMI] = ACTIONS(5598),
    [anon_sym_LBRACK] = ACTIONS(5598),
    [anon_sym_COLON] = ACTIONS(5598),
    [anon_sym_COMMA] = ACTIONS(5598),
    [anon_sym_RBRACK] = ACTIONS(5598),
    [anon_sym_LPAREN] = ACTIONS(5598),
    [anon_sym_RPAREN] = ACTIONS(5598),
    [anon_sym_RBRACE] = ACTIONS(5598),
    [anon_sym_LT] = ACTIONS(5600),
    [anon_sym_GT] = ACTIONS(5600),
    [anon_sym_in] = ACTIONS(5598),
    [anon_sym_where] = ACTIONS(5598),
    [anon_sym_QMARK] = ACTIONS(5600),
    [anon_sym_BANG] = ACTIONS(5600),
    [anon_sym_PLUS_PLUS] = ACTIONS(5598),
    [anon_sym_DASH_DASH] = ACTIONS(5598),
    [anon_sym_PLUS] = ACTIONS(5600),
    [anon_sym_DASH] = ACTIONS(5600),
    [anon_sym_STAR] = ACTIONS(5598),
    [anon_sym_SLASH] = ACTIONS(5600),
    [anon_sym_PERCENT] = ACTIONS(5598),
    [anon_sym_CARET] = ACTIONS(5598),
    [anon_sym_PIPE] = ACTIONS(5600),
    [anon_sym_AMP] = ACTIONS(5600),
    [anon_sym_LT_LT] = ACTIONS(5598),
    [anon_sym_GT_GT] = ACTIONS(5600),
    [anon_sym_GT_GT_GT] = ACTIONS(5598),
    [anon_sym_EQ_EQ] = ACTIONS(5598),
    [anon_sym_BANG_EQ] = ACTIONS(5598),
    [anon_sym_GT_EQ] = ACTIONS(5598),
    [anon_sym_LT_EQ] = ACTIONS(5598),
    [anon_sym_DOT] = ACTIONS(5600),
    [anon_sym_EQ_GT] = ACTIONS(5598),
    [anon_sym_switch] = ACTIONS(5598),
    [anon_sym_DOT_DOT] = ACTIONS(5598),
    [anon_sym_and] = ACTIONS(5598),
    [anon_sym_or] = ACTIONS(5600),
    [anon_sym_AMP_AMP] = ACTIONS(5598),
    [anon_sym_PIPE_PIPE] = ACTIONS(5598),
    [anon_sym_QMARK_QMARK] = ACTIONS(5598),
    [anon_sym_from] = ACTIONS(5598),
    [anon_sym_join] = ACTIONS(5598),
    [anon_sym_on] = ACTIONS(5598),
    [anon_sym_equals] = ACTIONS(5598),
    [anon_sym_let] = ACTIONS(5598),
    [anon_sym_orderby] = ACTIONS(5598),
    [anon_sym_group] = ACTIONS(5598),
    [anon_sym_by] = ACTIONS(5598),
    [anon_sym_select] = ACTIONS(5598),
    [anon_sym_as] = ACTIONS(5598),
    [anon_sym_is] = ACTIONS(5598),
    [anon_sym_DASH_GT] = ACTIONS(5598),
    [anon_sym_with] = ACTIONS(5598),
    [aux_sym_preproc_if_token3] = ACTIONS(5598),
    [aux_sym_preproc_else_token1] = ACTIONS(5598),
    [aux_sym_preproc_elif_token1] = ACTIONS(5598),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3732] = {
    [sym_preproc_region] = STATE(3732),
    [sym_preproc_endregion] = STATE(3732),
    [sym_preproc_line] = STATE(3732),
    [sym_preproc_pragma] = STATE(3732),
    [sym_preproc_nullable] = STATE(3732),
    [sym_preproc_error] = STATE(3732),
    [sym_preproc_define] = STATE(3732),
    [sym_preproc_undef] = STATE(3732),
    [anon_sym_SEMI] = ACTIONS(5412),
    [anon_sym_LBRACK] = ACTIONS(5412),
    [anon_sym_COLON] = ACTIONS(5412),
    [anon_sym_COMMA] = ACTIONS(5412),
    [anon_sym_RBRACK] = ACTIONS(5412),
    [anon_sym_LPAREN] = ACTIONS(5412),
    [anon_sym_RPAREN] = ACTIONS(5412),
    [anon_sym_RBRACE] = ACTIONS(5412),
    [anon_sym_LT] = ACTIONS(5414),
    [anon_sym_GT] = ACTIONS(5414),
    [anon_sym_in] = ACTIONS(5412),
    [anon_sym_where] = ACTIONS(5412),
    [anon_sym_QMARK] = ACTIONS(5414),
    [anon_sym_BANG] = ACTIONS(5414),
    [anon_sym_PLUS_PLUS] = ACTIONS(5412),
    [anon_sym_DASH_DASH] = ACTIONS(5412),
    [anon_sym_PLUS] = ACTIONS(5414),
    [anon_sym_DASH] = ACTIONS(5414),
    [anon_sym_STAR] = ACTIONS(5412),
    [anon_sym_SLASH] = ACTIONS(5414),
    [anon_sym_PERCENT] = ACTIONS(5412),
    [anon_sym_CARET] = ACTIONS(5412),
    [anon_sym_PIPE] = ACTIONS(5414),
    [anon_sym_AMP] = ACTIONS(5414),
    [anon_sym_LT_LT] = ACTIONS(5412),
    [anon_sym_GT_GT] = ACTIONS(5414),
    [anon_sym_GT_GT_GT] = ACTIONS(5412),
    [anon_sym_EQ_EQ] = ACTIONS(5412),
    [anon_sym_BANG_EQ] = ACTIONS(5412),
    [anon_sym_GT_EQ] = ACTIONS(5412),
    [anon_sym_LT_EQ] = ACTIONS(5412),
    [anon_sym_DOT] = ACTIONS(5414),
    [anon_sym_EQ_GT] = ACTIONS(5412),
    [anon_sym_switch] = ACTIONS(5412),
    [anon_sym_DOT_DOT] = ACTIONS(5412),
    [anon_sym_and] = ACTIONS(5412),
    [anon_sym_or] = ACTIONS(5414),
    [anon_sym_AMP_AMP] = ACTIONS(5412),
    [anon_sym_PIPE_PIPE] = ACTIONS(5412),
    [anon_sym_QMARK_QMARK] = ACTIONS(5412),
    [anon_sym_from] = ACTIONS(5412),
    [anon_sym_join] = ACTIONS(5412),
    [anon_sym_on] = ACTIONS(5412),
    [anon_sym_equals] = ACTIONS(5412),
    [anon_sym_let] = ACTIONS(5412),
    [anon_sym_orderby] = ACTIONS(5412),
    [anon_sym_group] = ACTIONS(5412),
    [anon_sym_by] = ACTIONS(5412),
    [anon_sym_select] = ACTIONS(5412),
    [anon_sym_as] = ACTIONS(5412),
    [anon_sym_is] = ACTIONS(5412),
    [anon_sym_DASH_GT] = ACTIONS(5412),
    [anon_sym_with] = ACTIONS(5412),
    [aux_sym_preproc_if_token3] = ACTIONS(5412),
    [aux_sym_preproc_else_token1] = ACTIONS(5412),
    [aux_sym_preproc_elif_token1] = ACTIONS(5412),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3733] = {
    [sym_preproc_region] = STATE(3733),
    [sym_preproc_endregion] = STATE(3733),
    [sym_preproc_line] = STATE(3733),
    [sym_preproc_pragma] = STATE(3733),
    [sym_preproc_nullable] = STATE(3733),
    [sym_preproc_error] = STATE(3733),
    [sym_preproc_define] = STATE(3733),
    [sym_preproc_undef] = STATE(3733),
    [anon_sym_SEMI] = ACTIONS(5486),
    [anon_sym_LBRACK] = ACTIONS(5486),
    [anon_sym_COLON] = ACTIONS(5486),
    [anon_sym_COMMA] = ACTIONS(5486),
    [anon_sym_RBRACK] = ACTIONS(5486),
    [anon_sym_LPAREN] = ACTIONS(5486),
    [anon_sym_RPAREN] = ACTIONS(5486),
    [anon_sym_RBRACE] = ACTIONS(5486),
    [anon_sym_LT] = ACTIONS(5488),
    [anon_sym_GT] = ACTIONS(5488),
    [anon_sym_in] = ACTIONS(5486),
    [anon_sym_where] = ACTIONS(5486),
    [anon_sym_QMARK] = ACTIONS(5488),
    [anon_sym_BANG] = ACTIONS(5488),
    [anon_sym_PLUS_PLUS] = ACTIONS(5486),
    [anon_sym_DASH_DASH] = ACTIONS(5486),
    [anon_sym_PLUS] = ACTIONS(5488),
    [anon_sym_DASH] = ACTIONS(5488),
    [anon_sym_STAR] = ACTIONS(5486),
    [anon_sym_SLASH] = ACTIONS(5488),
    [anon_sym_PERCENT] = ACTIONS(5486),
    [anon_sym_CARET] = ACTIONS(5486),
    [anon_sym_PIPE] = ACTIONS(5488),
    [anon_sym_AMP] = ACTIONS(5488),
    [anon_sym_LT_LT] = ACTIONS(5486),
    [anon_sym_GT_GT] = ACTIONS(5488),
    [anon_sym_GT_GT_GT] = ACTIONS(5486),
    [anon_sym_EQ_EQ] = ACTIONS(5486),
    [anon_sym_BANG_EQ] = ACTIONS(5486),
    [anon_sym_GT_EQ] = ACTIONS(5486),
    [anon_sym_LT_EQ] = ACTIONS(5486),
    [anon_sym_DOT] = ACTIONS(5488),
    [anon_sym_EQ_GT] = ACTIONS(5486),
    [anon_sym_switch] = ACTIONS(5486),
    [anon_sym_DOT_DOT] = ACTIONS(5486),
    [anon_sym_and] = ACTIONS(5486),
    [anon_sym_or] = ACTIONS(5488),
    [anon_sym_AMP_AMP] = ACTIONS(5486),
    [anon_sym_PIPE_PIPE] = ACTIONS(5486),
    [anon_sym_QMARK_QMARK] = ACTIONS(5486),
    [anon_sym_from] = ACTIONS(5486),
    [anon_sym_join] = ACTIONS(5486),
    [anon_sym_on] = ACTIONS(5486),
    [anon_sym_equals] = ACTIONS(5486),
    [anon_sym_let] = ACTIONS(5486),
    [anon_sym_orderby] = ACTIONS(5486),
    [anon_sym_group] = ACTIONS(5486),
    [anon_sym_by] = ACTIONS(5486),
    [anon_sym_select] = ACTIONS(5486),
    [anon_sym_as] = ACTIONS(5486),
    [anon_sym_is] = ACTIONS(5486),
    [anon_sym_DASH_GT] = ACTIONS(5486),
    [anon_sym_with] = ACTIONS(5486),
    [aux_sym_preproc_if_token3] = ACTIONS(5486),
    [aux_sym_preproc_else_token1] = ACTIONS(5486),
    [aux_sym_preproc_elif_token1] = ACTIONS(5486),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3734] = {
    [sym_preproc_region] = STATE(3734),
    [sym_preproc_endregion] = STATE(3734),
    [sym_preproc_line] = STATE(3734),
    [sym_preproc_pragma] = STATE(3734),
    [sym_preproc_nullable] = STATE(3734),
    [sym_preproc_error] = STATE(3734),
    [sym_preproc_define] = STATE(3734),
    [sym_preproc_undef] = STATE(3734),
    [anon_sym_SEMI] = ACTIONS(5408),
    [anon_sym_LBRACK] = ACTIONS(5408),
    [anon_sym_COLON] = ACTIONS(5408),
    [anon_sym_COMMA] = ACTIONS(5408),
    [anon_sym_RBRACK] = ACTIONS(5408),
    [anon_sym_LPAREN] = ACTIONS(5408),
    [anon_sym_RPAREN] = ACTIONS(5408),
    [anon_sym_RBRACE] = ACTIONS(5408),
    [anon_sym_LT] = ACTIONS(5410),
    [anon_sym_GT] = ACTIONS(5410),
    [anon_sym_in] = ACTIONS(5408),
    [anon_sym_where] = ACTIONS(5408),
    [anon_sym_QMARK] = ACTIONS(5410),
    [anon_sym_BANG] = ACTIONS(5410),
    [anon_sym_PLUS_PLUS] = ACTIONS(5408),
    [anon_sym_DASH_DASH] = ACTIONS(5408),
    [anon_sym_PLUS] = ACTIONS(5410),
    [anon_sym_DASH] = ACTIONS(5410),
    [anon_sym_STAR] = ACTIONS(5408),
    [anon_sym_SLASH] = ACTIONS(5410),
    [anon_sym_PERCENT] = ACTIONS(5408),
    [anon_sym_CARET] = ACTIONS(5408),
    [anon_sym_PIPE] = ACTIONS(5410),
    [anon_sym_AMP] = ACTIONS(5410),
    [anon_sym_LT_LT] = ACTIONS(5408),
    [anon_sym_GT_GT] = ACTIONS(5410),
    [anon_sym_GT_GT_GT] = ACTIONS(5408),
    [anon_sym_EQ_EQ] = ACTIONS(5408),
    [anon_sym_BANG_EQ] = ACTIONS(5408),
    [anon_sym_GT_EQ] = ACTIONS(5408),
    [anon_sym_LT_EQ] = ACTIONS(5408),
    [anon_sym_DOT] = ACTIONS(5410),
    [anon_sym_EQ_GT] = ACTIONS(5408),
    [anon_sym_switch] = ACTIONS(5408),
    [anon_sym_DOT_DOT] = ACTIONS(5408),
    [anon_sym_and] = ACTIONS(5408),
    [anon_sym_or] = ACTIONS(5410),
    [anon_sym_AMP_AMP] = ACTIONS(5408),
    [anon_sym_PIPE_PIPE] = ACTIONS(5408),
    [anon_sym_QMARK_QMARK] = ACTIONS(5408),
    [anon_sym_from] = ACTIONS(5408),
    [anon_sym_join] = ACTIONS(5408),
    [anon_sym_on] = ACTIONS(5408),
    [anon_sym_equals] = ACTIONS(5408),
    [anon_sym_let] = ACTIONS(5408),
    [anon_sym_orderby] = ACTIONS(5408),
    [anon_sym_group] = ACTIONS(5408),
    [anon_sym_by] = ACTIONS(5408),
    [anon_sym_select] = ACTIONS(5408),
    [anon_sym_as] = ACTIONS(5408),
    [anon_sym_is] = ACTIONS(5408),
    [anon_sym_DASH_GT] = ACTIONS(5408),
    [anon_sym_with] = ACTIONS(5408),
    [aux_sym_preproc_if_token3] = ACTIONS(5408),
    [aux_sym_preproc_else_token1] = ACTIONS(5408),
    [aux_sym_preproc_elif_token1] = ACTIONS(5408),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3735] = {
    [sym_preproc_region] = STATE(3735),
    [sym_preproc_endregion] = STATE(3735),
    [sym_preproc_line] = STATE(3735),
    [sym_preproc_pragma] = STATE(3735),
    [sym_preproc_nullable] = STATE(3735),
    [sym_preproc_error] = STATE(3735),
    [sym_preproc_define] = STATE(3735),
    [sym_preproc_undef] = STATE(3735),
    [anon_sym_EQ] = ACTIONS(5602),
    [anon_sym_LBRACK] = ACTIONS(5249),
    [anon_sym_LPAREN] = ACTIONS(5249),
    [anon_sym_LT] = ACTIONS(5251),
    [anon_sym_GT] = ACTIONS(5251),
    [anon_sym_where] = ACTIONS(5249),
    [anon_sym_QMARK] = ACTIONS(5251),
    [anon_sym_BANG] = ACTIONS(5251),
    [anon_sym_PLUS_PLUS] = ACTIONS(5249),
    [anon_sym_DASH_DASH] = ACTIONS(5249),
    [anon_sym_PLUS] = ACTIONS(5251),
    [anon_sym_DASH] = ACTIONS(5251),
    [anon_sym_STAR] = ACTIONS(5251),
    [anon_sym_SLASH] = ACTIONS(5251),
    [anon_sym_PERCENT] = ACTIONS(5251),
    [anon_sym_CARET] = ACTIONS(5251),
    [anon_sym_PIPE] = ACTIONS(5251),
    [anon_sym_AMP] = ACTIONS(5251),
    [anon_sym_LT_LT] = ACTIONS(5251),
    [anon_sym_GT_GT] = ACTIONS(5251),
    [anon_sym_GT_GT_GT] = ACTIONS(5251),
    [anon_sym_EQ_EQ] = ACTIONS(5249),
    [anon_sym_BANG_EQ] = ACTIONS(5249),
    [anon_sym_GT_EQ] = ACTIONS(5249),
    [anon_sym_LT_EQ] = ACTIONS(5249),
    [anon_sym_DOT] = ACTIONS(5251),
    [anon_sym_switch] = ACTIONS(5249),
    [anon_sym_DOT_DOT] = ACTIONS(5249),
    [anon_sym_and] = ACTIONS(5249),
    [anon_sym_or] = ACTIONS(5251),
    [anon_sym_PLUS_EQ] = ACTIONS(5604),
    [anon_sym_DASH_EQ] = ACTIONS(5604),
    [anon_sym_STAR_EQ] = ACTIONS(5604),
    [anon_sym_SLASH_EQ] = ACTIONS(5604),
    [anon_sym_PERCENT_EQ] = ACTIONS(5604),
    [anon_sym_AMP_EQ] = ACTIONS(5604),
    [anon_sym_CARET_EQ] = ACTIONS(5604),
    [anon_sym_PIPE_EQ] = ACTIONS(5604),
    [anon_sym_LT_LT_EQ] = ACTIONS(5604),
    [anon_sym_GT_GT_EQ] = ACTIONS(5604),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5604),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(5604),
    [anon_sym_AMP_AMP] = ACTIONS(5249),
    [anon_sym_PIPE_PIPE] = ACTIONS(5249),
    [anon_sym_QMARK_QMARK] = ACTIONS(5251),
    [anon_sym_from] = ACTIONS(5249),
    [anon_sym_into] = ACTIONS(5249),
    [anon_sym_join] = ACTIONS(5249),
    [anon_sym_let] = ACTIONS(5249),
    [anon_sym_orderby] = ACTIONS(5249),
    [anon_sym_group] = ACTIONS(5249),
    [anon_sym_select] = ACTIONS(5249),
    [anon_sym_as] = ACTIONS(5249),
    [anon_sym_is] = ACTIONS(5249),
    [anon_sym_DASH_GT] = ACTIONS(5249),
    [anon_sym_with] = ACTIONS(5249),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3736] = {
    [sym_preproc_region] = STATE(3736),
    [sym_preproc_endregion] = STATE(3736),
    [sym_preproc_line] = STATE(3736),
    [sym_preproc_pragma] = STATE(3736),
    [sym_preproc_nullable] = STATE(3736),
    [sym_preproc_error] = STATE(3736),
    [sym_preproc_define] = STATE(3736),
    [sym_preproc_undef] = STATE(3736),
    [anon_sym_SEMI] = ACTIONS(5249),
    [anon_sym_EQ] = ACTIONS(5606),
    [anon_sym_LBRACK] = ACTIONS(5249),
    [anon_sym_COMMA] = ACTIONS(5249),
    [anon_sym_RBRACK] = ACTIONS(5249),
    [anon_sym_LPAREN] = ACTIONS(5249),
    [anon_sym_RPAREN] = ACTIONS(5249),
    [anon_sym_RBRACE] = ACTIONS(5249),
    [anon_sym_LT] = ACTIONS(5251),
    [anon_sym_GT] = ACTIONS(5251),
    [anon_sym_in] = ACTIONS(5251),
    [anon_sym_QMARK] = ACTIONS(5251),
    [anon_sym_BANG] = ACTIONS(5251),
    [anon_sym_PLUS_PLUS] = ACTIONS(5249),
    [anon_sym_DASH_DASH] = ACTIONS(5249),
    [anon_sym_PLUS] = ACTIONS(5251),
    [anon_sym_DASH] = ACTIONS(5251),
    [anon_sym_STAR] = ACTIONS(5251),
    [anon_sym_SLASH] = ACTIONS(5251),
    [anon_sym_PERCENT] = ACTIONS(5251),
    [anon_sym_CARET] = ACTIONS(5251),
    [anon_sym_PIPE] = ACTIONS(5251),
    [anon_sym_AMP] = ACTIONS(5251),
    [anon_sym_LT_LT] = ACTIONS(5251),
    [anon_sym_GT_GT] = ACTIONS(5251),
    [anon_sym_GT_GT_GT] = ACTIONS(5251),
    [anon_sym_EQ_EQ] = ACTIONS(5249),
    [anon_sym_BANG_EQ] = ACTIONS(5249),
    [anon_sym_GT_EQ] = ACTIONS(5249),
    [anon_sym_LT_EQ] = ACTIONS(5249),
    [anon_sym_DOT] = ACTIONS(5251),
    [anon_sym_switch] = ACTIONS(5249),
    [anon_sym_DOT_DOT] = ACTIONS(5249),
    [anon_sym_PLUS_EQ] = ACTIONS(5608),
    [anon_sym_DASH_EQ] = ACTIONS(5608),
    [anon_sym_STAR_EQ] = ACTIONS(5608),
    [anon_sym_SLASH_EQ] = ACTIONS(5608),
    [anon_sym_PERCENT_EQ] = ACTIONS(5608),
    [anon_sym_AMP_EQ] = ACTIONS(5608),
    [anon_sym_CARET_EQ] = ACTIONS(5608),
    [anon_sym_PIPE_EQ] = ACTIONS(5608),
    [anon_sym_LT_LT_EQ] = ACTIONS(5608),
    [anon_sym_GT_GT_EQ] = ACTIONS(5608),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5608),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(5608),
    [anon_sym_AMP_AMP] = ACTIONS(5249),
    [anon_sym_PIPE_PIPE] = ACTIONS(5249),
    [anon_sym_QMARK_QMARK] = ACTIONS(5251),
    [anon_sym_into] = ACTIONS(5249),
    [anon_sym_as] = ACTIONS(5249),
    [anon_sym_is] = ACTIONS(5249),
    [anon_sym_DASH_GT] = ACTIONS(5249),
    [anon_sym_with] = ACTIONS(5249),
    [aux_sym_preproc_if_token3] = ACTIONS(5249),
    [aux_sym_preproc_else_token1] = ACTIONS(5249),
    [aux_sym_preproc_elif_token1] = ACTIONS(5249),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3737] = {
    [sym_preproc_region] = STATE(3737),
    [sym_preproc_endregion] = STATE(3737),
    [sym_preproc_line] = STATE(3737),
    [sym_preproc_pragma] = STATE(3737),
    [sym_preproc_nullable] = STATE(3737),
    [sym_preproc_error] = STATE(3737),
    [sym_preproc_define] = STATE(3737),
    [sym_preproc_undef] = STATE(3737),
    [anon_sym_SEMI] = ACTIONS(2935),
    [anon_sym_LBRACK] = ACTIONS(2935),
    [anon_sym_COLON] = ACTIONS(2935),
    [anon_sym_COMMA] = ACTIONS(2935),
    [anon_sym_RBRACK] = ACTIONS(2935),
    [anon_sym_LPAREN] = ACTIONS(2935),
    [anon_sym_RPAREN] = ACTIONS(2935),
    [anon_sym_RBRACE] = ACTIONS(2935),
    [anon_sym_LT] = ACTIONS(2933),
    [anon_sym_GT] = ACTIONS(2933),
    [anon_sym_in] = ACTIONS(2935),
    [anon_sym_where] = ACTIONS(2935),
    [anon_sym_QMARK] = ACTIONS(2933),
    [anon_sym_BANG] = ACTIONS(2933),
    [anon_sym_PLUS_PLUS] = ACTIONS(2935),
    [anon_sym_DASH_DASH] = ACTIONS(2935),
    [anon_sym_PLUS] = ACTIONS(2933),
    [anon_sym_DASH] = ACTIONS(2933),
    [anon_sym_STAR] = ACTIONS(2935),
    [anon_sym_SLASH] = ACTIONS(2933),
    [anon_sym_PERCENT] = ACTIONS(2935),
    [anon_sym_CARET] = ACTIONS(2935),
    [anon_sym_PIPE] = ACTIONS(2933),
    [anon_sym_AMP] = ACTIONS(2933),
    [anon_sym_LT_LT] = ACTIONS(2935),
    [anon_sym_GT_GT] = ACTIONS(2933),
    [anon_sym_GT_GT_GT] = ACTIONS(2935),
    [anon_sym_EQ_EQ] = ACTIONS(2935),
    [anon_sym_BANG_EQ] = ACTIONS(2935),
    [anon_sym_GT_EQ] = ACTIONS(2935),
    [anon_sym_LT_EQ] = ACTIONS(2935),
    [anon_sym_DOT] = ACTIONS(2933),
    [anon_sym_EQ_GT] = ACTIONS(2935),
    [anon_sym_switch] = ACTIONS(2935),
    [anon_sym_DOT_DOT] = ACTIONS(2935),
    [anon_sym_and] = ACTIONS(2935),
    [anon_sym_or] = ACTIONS(2933),
    [anon_sym_AMP_AMP] = ACTIONS(2935),
    [anon_sym_PIPE_PIPE] = ACTIONS(2935),
    [anon_sym_QMARK_QMARK] = ACTIONS(2935),
    [anon_sym_from] = ACTIONS(2935),
    [anon_sym_join] = ACTIONS(2935),
    [anon_sym_on] = ACTIONS(2935),
    [anon_sym_equals] = ACTIONS(2935),
    [anon_sym_let] = ACTIONS(2935),
    [anon_sym_orderby] = ACTIONS(2935),
    [anon_sym_group] = ACTIONS(2935),
    [anon_sym_by] = ACTIONS(2935),
    [anon_sym_select] = ACTIONS(2935),
    [anon_sym_as] = ACTIONS(2935),
    [anon_sym_is] = ACTIONS(2935),
    [anon_sym_DASH_GT] = ACTIONS(2935),
    [anon_sym_with] = ACTIONS(2935),
    [aux_sym_preproc_if_token3] = ACTIONS(2935),
    [aux_sym_preproc_else_token1] = ACTIONS(2935),
    [aux_sym_preproc_elif_token1] = ACTIONS(2935),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3738] = {
    [sym_preproc_region] = STATE(3738),
    [sym_preproc_endregion] = STATE(3738),
    [sym_preproc_line] = STATE(3738),
    [sym_preproc_pragma] = STATE(3738),
    [sym_preproc_nullable] = STATE(3738),
    [sym_preproc_error] = STATE(3738),
    [sym_preproc_define] = STATE(3738),
    [sym_preproc_undef] = STATE(3738),
    [anon_sym_SEMI] = ACTIONS(5396),
    [anon_sym_LBRACK] = ACTIONS(5396),
    [anon_sym_COLON] = ACTIONS(5396),
    [anon_sym_COMMA] = ACTIONS(5396),
    [anon_sym_RBRACK] = ACTIONS(5396),
    [anon_sym_LPAREN] = ACTIONS(5396),
    [anon_sym_RPAREN] = ACTIONS(5396),
    [anon_sym_RBRACE] = ACTIONS(5396),
    [anon_sym_LT] = ACTIONS(5398),
    [anon_sym_GT] = ACTIONS(5398),
    [anon_sym_in] = ACTIONS(5396),
    [anon_sym_where] = ACTIONS(5396),
    [anon_sym_QMARK] = ACTIONS(5398),
    [anon_sym_BANG] = ACTIONS(5398),
    [anon_sym_PLUS_PLUS] = ACTIONS(5396),
    [anon_sym_DASH_DASH] = ACTIONS(5396),
    [anon_sym_PLUS] = ACTIONS(5398),
    [anon_sym_DASH] = ACTIONS(5398),
    [anon_sym_STAR] = ACTIONS(5396),
    [anon_sym_SLASH] = ACTIONS(5398),
    [anon_sym_PERCENT] = ACTIONS(5396),
    [anon_sym_CARET] = ACTIONS(5396),
    [anon_sym_PIPE] = ACTIONS(5398),
    [anon_sym_AMP] = ACTIONS(5398),
    [anon_sym_LT_LT] = ACTIONS(5396),
    [anon_sym_GT_GT] = ACTIONS(5398),
    [anon_sym_GT_GT_GT] = ACTIONS(5396),
    [anon_sym_EQ_EQ] = ACTIONS(5396),
    [anon_sym_BANG_EQ] = ACTIONS(5396),
    [anon_sym_GT_EQ] = ACTIONS(5396),
    [anon_sym_LT_EQ] = ACTIONS(5396),
    [anon_sym_DOT] = ACTIONS(5398),
    [anon_sym_EQ_GT] = ACTIONS(5396),
    [anon_sym_switch] = ACTIONS(5396),
    [anon_sym_DOT_DOT] = ACTIONS(5396),
    [anon_sym_and] = ACTIONS(5396),
    [anon_sym_or] = ACTIONS(5398),
    [anon_sym_AMP_AMP] = ACTIONS(5396),
    [anon_sym_PIPE_PIPE] = ACTIONS(5396),
    [anon_sym_QMARK_QMARK] = ACTIONS(5396),
    [anon_sym_from] = ACTIONS(5396),
    [anon_sym_join] = ACTIONS(5396),
    [anon_sym_on] = ACTIONS(5396),
    [anon_sym_equals] = ACTIONS(5396),
    [anon_sym_let] = ACTIONS(5396),
    [anon_sym_orderby] = ACTIONS(5396),
    [anon_sym_group] = ACTIONS(5396),
    [anon_sym_by] = ACTIONS(5396),
    [anon_sym_select] = ACTIONS(5396),
    [anon_sym_as] = ACTIONS(5396),
    [anon_sym_is] = ACTIONS(5396),
    [anon_sym_DASH_GT] = ACTIONS(5396),
    [anon_sym_with] = ACTIONS(5396),
    [aux_sym_preproc_if_token3] = ACTIONS(5396),
    [aux_sym_preproc_else_token1] = ACTIONS(5396),
    [aux_sym_preproc_elif_token1] = ACTIONS(5396),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3739] = {
    [sym_preproc_region] = STATE(3739),
    [sym_preproc_endregion] = STATE(3739),
    [sym_preproc_line] = STATE(3739),
    [sym_preproc_pragma] = STATE(3739),
    [sym_preproc_nullable] = STATE(3739),
    [sym_preproc_error] = STATE(3739),
    [sym_preproc_define] = STATE(3739),
    [sym_preproc_undef] = STATE(3739),
    [sym__identifier_token] = ACTIONS(5610),
    [anon_sym_extern] = ACTIONS(5610),
    [anon_sym_alias] = ACTIONS(5610),
    [anon_sym_global] = ACTIONS(5610),
    [anon_sym_unsafe] = ACTIONS(5610),
    [anon_sym_static] = ACTIONS(5610),
    [anon_sym_LBRACK] = ACTIONS(5612),
    [anon_sym_LPAREN] = ACTIONS(5612),
    [anon_sym_event] = ACTIONS(5610),
    [anon_sym_class] = ACTIONS(5610),
    [anon_sym_ref] = ACTIONS(5610),
    [anon_sym_struct] = ACTIONS(5610),
    [anon_sym_enum] = ACTIONS(5610),
    [anon_sym_interface] = ACTIONS(5610),
    [anon_sym_delegate] = ACTIONS(5610),
    [anon_sym_record] = ACTIONS(5610),
    [anon_sym_abstract] = ACTIONS(5610),
    [anon_sym_async] = ACTIONS(5610),
    [anon_sym_const] = ACTIONS(5610),
    [anon_sym_file] = ACTIONS(5610),
    [anon_sym_fixed] = ACTIONS(5610),
    [anon_sym_internal] = ACTIONS(5610),
    [anon_sym_new] = ACTIONS(5610),
    [anon_sym_override] = ACTIONS(5610),
    [anon_sym_partial] = ACTIONS(5610),
    [anon_sym_private] = ACTIONS(5610),
    [anon_sym_protected] = ACTIONS(5610),
    [anon_sym_public] = ACTIONS(5610),
    [anon_sym_readonly] = ACTIONS(5610),
    [anon_sym_required] = ACTIONS(5610),
    [anon_sym_sealed] = ACTIONS(5610),
    [anon_sym_virtual] = ACTIONS(5610),
    [anon_sym_volatile] = ACTIONS(5610),
    [anon_sym_where] = ACTIONS(5610),
    [anon_sym_notnull] = ACTIONS(5610),
    [anon_sym_unmanaged] = ACTIONS(5610),
    [anon_sym_TILDE] = ACTIONS(5612),
    [anon_sym_implicit] = ACTIONS(5610),
    [anon_sym_explicit] = ACTIONS(5610),
    [anon_sym_scoped] = ACTIONS(5610),
    [anon_sym_var] = ACTIONS(5610),
    [sym_predefined_type] = ACTIONS(5610),
    [anon_sym_yield] = ACTIONS(5610),
    [anon_sym_when] = ACTIONS(5610),
    [anon_sym_from] = ACTIONS(5610),
    [anon_sym_into] = ACTIONS(5610),
    [anon_sym_join] = ACTIONS(5610),
    [anon_sym_on] = ACTIONS(5610),
    [anon_sym_equals] = ACTIONS(5610),
    [anon_sym_let] = ACTIONS(5610),
    [anon_sym_orderby] = ACTIONS(5610),
    [anon_sym_ascending] = ACTIONS(5610),
    [anon_sym_descending] = ACTIONS(5610),
    [anon_sym_group] = ACTIONS(5610),
    [anon_sym_by] = ACTIONS(5610),
    [anon_sym_select] = ACTIONS(5610),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3740] = {
    [sym_preproc_region] = STATE(3740),
    [sym_preproc_endregion] = STATE(3740),
    [sym_preproc_line] = STATE(3740),
    [sym_preproc_pragma] = STATE(3740),
    [sym_preproc_nullable] = STATE(3740),
    [sym_preproc_error] = STATE(3740),
    [sym_preproc_define] = STATE(3740),
    [sym_preproc_undef] = STATE(3740),
    [anon_sym_SEMI] = ACTIONS(5576),
    [anon_sym_LBRACK] = ACTIONS(5576),
    [anon_sym_COLON] = ACTIONS(5576),
    [anon_sym_COMMA] = ACTIONS(5576),
    [anon_sym_RBRACK] = ACTIONS(5576),
    [anon_sym_LPAREN] = ACTIONS(5576),
    [anon_sym_RPAREN] = ACTIONS(5576),
    [anon_sym_RBRACE] = ACTIONS(5576),
    [anon_sym_LT] = ACTIONS(5578),
    [anon_sym_GT] = ACTIONS(5578),
    [anon_sym_in] = ACTIONS(5576),
    [anon_sym_where] = ACTIONS(5576),
    [anon_sym_QMARK] = ACTIONS(5578),
    [anon_sym_BANG] = ACTIONS(5578),
    [anon_sym_PLUS_PLUS] = ACTIONS(5576),
    [anon_sym_DASH_DASH] = ACTIONS(5576),
    [anon_sym_PLUS] = ACTIONS(5578),
    [anon_sym_DASH] = ACTIONS(5578),
    [anon_sym_STAR] = ACTIONS(5576),
    [anon_sym_SLASH] = ACTIONS(5578),
    [anon_sym_PERCENT] = ACTIONS(5576),
    [anon_sym_CARET] = ACTIONS(5576),
    [anon_sym_PIPE] = ACTIONS(5578),
    [anon_sym_AMP] = ACTIONS(5578),
    [anon_sym_LT_LT] = ACTIONS(5576),
    [anon_sym_GT_GT] = ACTIONS(5578),
    [anon_sym_GT_GT_GT] = ACTIONS(5576),
    [anon_sym_EQ_EQ] = ACTIONS(5576),
    [anon_sym_BANG_EQ] = ACTIONS(5576),
    [anon_sym_GT_EQ] = ACTIONS(5576),
    [anon_sym_LT_EQ] = ACTIONS(5576),
    [anon_sym_DOT] = ACTIONS(5578),
    [anon_sym_EQ_GT] = ACTIONS(5576),
    [anon_sym_switch] = ACTIONS(5576),
    [anon_sym_DOT_DOT] = ACTIONS(5576),
    [anon_sym_and] = ACTIONS(5576),
    [anon_sym_or] = ACTIONS(5578),
    [anon_sym_AMP_AMP] = ACTIONS(5576),
    [anon_sym_PIPE_PIPE] = ACTIONS(5576),
    [anon_sym_QMARK_QMARK] = ACTIONS(5576),
    [anon_sym_from] = ACTIONS(5576),
    [anon_sym_join] = ACTIONS(5576),
    [anon_sym_on] = ACTIONS(5576),
    [anon_sym_equals] = ACTIONS(5576),
    [anon_sym_let] = ACTIONS(5576),
    [anon_sym_orderby] = ACTIONS(5576),
    [anon_sym_group] = ACTIONS(5576),
    [anon_sym_by] = ACTIONS(5576),
    [anon_sym_select] = ACTIONS(5576),
    [anon_sym_as] = ACTIONS(5576),
    [anon_sym_is] = ACTIONS(5576),
    [anon_sym_DASH_GT] = ACTIONS(5576),
    [anon_sym_with] = ACTIONS(5576),
    [aux_sym_preproc_if_token3] = ACTIONS(5576),
    [aux_sym_preproc_else_token1] = ACTIONS(5576),
    [aux_sym_preproc_elif_token1] = ACTIONS(5576),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3741] = {
    [sym_preproc_region] = STATE(3741),
    [sym_preproc_endregion] = STATE(3741),
    [sym_preproc_line] = STATE(3741),
    [sym_preproc_pragma] = STATE(3741),
    [sym_preproc_nullable] = STATE(3741),
    [sym_preproc_error] = STATE(3741),
    [sym_preproc_define] = STATE(3741),
    [sym_preproc_undef] = STATE(3741),
    [anon_sym_SEMI] = ACTIONS(5392),
    [anon_sym_LBRACK] = ACTIONS(5392),
    [anon_sym_COLON] = ACTIONS(5392),
    [anon_sym_COMMA] = ACTIONS(5392),
    [anon_sym_RBRACK] = ACTIONS(5392),
    [anon_sym_LPAREN] = ACTIONS(5392),
    [anon_sym_RPAREN] = ACTIONS(5392),
    [anon_sym_RBRACE] = ACTIONS(5392),
    [anon_sym_LT] = ACTIONS(5394),
    [anon_sym_GT] = ACTIONS(5394),
    [anon_sym_in] = ACTIONS(5392),
    [anon_sym_where] = ACTIONS(5392),
    [anon_sym_QMARK] = ACTIONS(5394),
    [anon_sym_BANG] = ACTIONS(5394),
    [anon_sym_PLUS_PLUS] = ACTIONS(5392),
    [anon_sym_DASH_DASH] = ACTIONS(5392),
    [anon_sym_PLUS] = ACTIONS(5394),
    [anon_sym_DASH] = ACTIONS(5394),
    [anon_sym_STAR] = ACTIONS(5392),
    [anon_sym_SLASH] = ACTIONS(5394),
    [anon_sym_PERCENT] = ACTIONS(5392),
    [anon_sym_CARET] = ACTIONS(5392),
    [anon_sym_PIPE] = ACTIONS(5394),
    [anon_sym_AMP] = ACTIONS(5394),
    [anon_sym_LT_LT] = ACTIONS(5392),
    [anon_sym_GT_GT] = ACTIONS(5394),
    [anon_sym_GT_GT_GT] = ACTIONS(5392),
    [anon_sym_EQ_EQ] = ACTIONS(5392),
    [anon_sym_BANG_EQ] = ACTIONS(5392),
    [anon_sym_GT_EQ] = ACTIONS(5392),
    [anon_sym_LT_EQ] = ACTIONS(5392),
    [anon_sym_DOT] = ACTIONS(5394),
    [anon_sym_EQ_GT] = ACTIONS(5392),
    [anon_sym_switch] = ACTIONS(5392),
    [anon_sym_DOT_DOT] = ACTIONS(5392),
    [anon_sym_and] = ACTIONS(5392),
    [anon_sym_or] = ACTIONS(5394),
    [anon_sym_AMP_AMP] = ACTIONS(5392),
    [anon_sym_PIPE_PIPE] = ACTIONS(5392),
    [anon_sym_QMARK_QMARK] = ACTIONS(5392),
    [anon_sym_from] = ACTIONS(5392),
    [anon_sym_join] = ACTIONS(5392),
    [anon_sym_on] = ACTIONS(5392),
    [anon_sym_equals] = ACTIONS(5392),
    [anon_sym_let] = ACTIONS(5392),
    [anon_sym_orderby] = ACTIONS(5392),
    [anon_sym_group] = ACTIONS(5392),
    [anon_sym_by] = ACTIONS(5392),
    [anon_sym_select] = ACTIONS(5392),
    [anon_sym_as] = ACTIONS(5392),
    [anon_sym_is] = ACTIONS(5392),
    [anon_sym_DASH_GT] = ACTIONS(5392),
    [anon_sym_with] = ACTIONS(5392),
    [aux_sym_preproc_if_token3] = ACTIONS(5392),
    [aux_sym_preproc_else_token1] = ACTIONS(5392),
    [aux_sym_preproc_elif_token1] = ACTIONS(5392),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3742] = {
    [sym_preproc_region] = STATE(3742),
    [sym_preproc_endregion] = STATE(3742),
    [sym_preproc_line] = STATE(3742),
    [sym_preproc_pragma] = STATE(3742),
    [sym_preproc_nullable] = STATE(3742),
    [sym_preproc_error] = STATE(3742),
    [sym_preproc_define] = STATE(3742),
    [sym_preproc_undef] = STATE(3742),
    [anon_sym_SEMI] = ACTIONS(5381),
    [anon_sym_LBRACK] = ACTIONS(5381),
    [anon_sym_COLON] = ACTIONS(5381),
    [anon_sym_COMMA] = ACTIONS(5381),
    [anon_sym_RBRACK] = ACTIONS(5381),
    [anon_sym_LPAREN] = ACTIONS(5381),
    [anon_sym_RPAREN] = ACTIONS(5381),
    [anon_sym_RBRACE] = ACTIONS(5381),
    [anon_sym_LT] = ACTIONS(5383),
    [anon_sym_GT] = ACTIONS(5383),
    [anon_sym_in] = ACTIONS(5381),
    [anon_sym_where] = ACTIONS(5381),
    [anon_sym_QMARK] = ACTIONS(5383),
    [anon_sym_BANG] = ACTIONS(5383),
    [anon_sym_PLUS_PLUS] = ACTIONS(5381),
    [anon_sym_DASH_DASH] = ACTIONS(5381),
    [anon_sym_PLUS] = ACTIONS(5383),
    [anon_sym_DASH] = ACTIONS(5383),
    [anon_sym_STAR] = ACTIONS(5381),
    [anon_sym_SLASH] = ACTIONS(5383),
    [anon_sym_PERCENT] = ACTIONS(5381),
    [anon_sym_CARET] = ACTIONS(5381),
    [anon_sym_PIPE] = ACTIONS(5383),
    [anon_sym_AMP] = ACTIONS(5383),
    [anon_sym_LT_LT] = ACTIONS(5381),
    [anon_sym_GT_GT] = ACTIONS(5383),
    [anon_sym_GT_GT_GT] = ACTIONS(5381),
    [anon_sym_EQ_EQ] = ACTIONS(5381),
    [anon_sym_BANG_EQ] = ACTIONS(5381),
    [anon_sym_GT_EQ] = ACTIONS(5381),
    [anon_sym_LT_EQ] = ACTIONS(5381),
    [anon_sym_DOT] = ACTIONS(5383),
    [anon_sym_EQ_GT] = ACTIONS(5381),
    [anon_sym_switch] = ACTIONS(5381),
    [anon_sym_DOT_DOT] = ACTIONS(5381),
    [anon_sym_and] = ACTIONS(5381),
    [anon_sym_or] = ACTIONS(5383),
    [anon_sym_AMP_AMP] = ACTIONS(5381),
    [anon_sym_PIPE_PIPE] = ACTIONS(5381),
    [anon_sym_QMARK_QMARK] = ACTIONS(5381),
    [anon_sym_from] = ACTIONS(5381),
    [anon_sym_join] = ACTIONS(5381),
    [anon_sym_on] = ACTIONS(5381),
    [anon_sym_equals] = ACTIONS(5381),
    [anon_sym_let] = ACTIONS(5381),
    [anon_sym_orderby] = ACTIONS(5381),
    [anon_sym_group] = ACTIONS(5381),
    [anon_sym_by] = ACTIONS(5381),
    [anon_sym_select] = ACTIONS(5381),
    [anon_sym_as] = ACTIONS(5381),
    [anon_sym_is] = ACTIONS(5381),
    [anon_sym_DASH_GT] = ACTIONS(5381),
    [anon_sym_with] = ACTIONS(5381),
    [aux_sym_preproc_if_token3] = ACTIONS(5381),
    [aux_sym_preproc_else_token1] = ACTIONS(5381),
    [aux_sym_preproc_elif_token1] = ACTIONS(5381),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3743] = {
    [sym_preproc_region] = STATE(3743),
    [sym_preproc_endregion] = STATE(3743),
    [sym_preproc_line] = STATE(3743),
    [sym_preproc_pragma] = STATE(3743),
    [sym_preproc_nullable] = STATE(3743),
    [sym_preproc_error] = STATE(3743),
    [sym_preproc_define] = STATE(3743),
    [sym_preproc_undef] = STATE(3743),
    [anon_sym_SEMI] = ACTIONS(2923),
    [anon_sym_LBRACK] = ACTIONS(2923),
    [anon_sym_COLON] = ACTIONS(2923),
    [anon_sym_COMMA] = ACTIONS(2923),
    [anon_sym_RBRACK] = ACTIONS(2923),
    [anon_sym_LPAREN] = ACTIONS(2923),
    [anon_sym_RPAREN] = ACTIONS(2923),
    [anon_sym_RBRACE] = ACTIONS(2923),
    [anon_sym_LT] = ACTIONS(2921),
    [anon_sym_GT] = ACTIONS(2921),
    [anon_sym_in] = ACTIONS(2923),
    [anon_sym_where] = ACTIONS(2923),
    [anon_sym_QMARK] = ACTIONS(2921),
    [anon_sym_BANG] = ACTIONS(2921),
    [anon_sym_PLUS_PLUS] = ACTIONS(2923),
    [anon_sym_DASH_DASH] = ACTIONS(2923),
    [anon_sym_PLUS] = ACTIONS(2921),
    [anon_sym_DASH] = ACTIONS(2921),
    [anon_sym_STAR] = ACTIONS(2923),
    [anon_sym_SLASH] = ACTIONS(2921),
    [anon_sym_PERCENT] = ACTIONS(2923),
    [anon_sym_CARET] = ACTIONS(2923),
    [anon_sym_PIPE] = ACTIONS(2921),
    [anon_sym_AMP] = ACTIONS(2921),
    [anon_sym_LT_LT] = ACTIONS(2923),
    [anon_sym_GT_GT] = ACTIONS(2921),
    [anon_sym_GT_GT_GT] = ACTIONS(2923),
    [anon_sym_EQ_EQ] = ACTIONS(2923),
    [anon_sym_BANG_EQ] = ACTIONS(2923),
    [anon_sym_GT_EQ] = ACTIONS(2923),
    [anon_sym_LT_EQ] = ACTIONS(2923),
    [anon_sym_DOT] = ACTIONS(2921),
    [anon_sym_EQ_GT] = ACTIONS(2923),
    [anon_sym_switch] = ACTIONS(2923),
    [anon_sym_DOT_DOT] = ACTIONS(2923),
    [anon_sym_and] = ACTIONS(2923),
    [anon_sym_or] = ACTIONS(2921),
    [anon_sym_AMP_AMP] = ACTIONS(2923),
    [anon_sym_PIPE_PIPE] = ACTIONS(2923),
    [anon_sym_QMARK_QMARK] = ACTIONS(2923),
    [anon_sym_from] = ACTIONS(2923),
    [anon_sym_join] = ACTIONS(2923),
    [anon_sym_on] = ACTIONS(2923),
    [anon_sym_equals] = ACTIONS(2923),
    [anon_sym_let] = ACTIONS(2923),
    [anon_sym_orderby] = ACTIONS(2923),
    [anon_sym_group] = ACTIONS(2923),
    [anon_sym_by] = ACTIONS(2923),
    [anon_sym_select] = ACTIONS(2923),
    [anon_sym_as] = ACTIONS(2923),
    [anon_sym_is] = ACTIONS(2923),
    [anon_sym_DASH_GT] = ACTIONS(2923),
    [anon_sym_with] = ACTIONS(2923),
    [aux_sym_preproc_if_token3] = ACTIONS(2923),
    [aux_sym_preproc_else_token1] = ACTIONS(2923),
    [aux_sym_preproc_elif_token1] = ACTIONS(2923),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3744] = {
    [sym_preproc_region] = STATE(3744),
    [sym_preproc_endregion] = STATE(3744),
    [sym_preproc_line] = STATE(3744),
    [sym_preproc_pragma] = STATE(3744),
    [sym_preproc_nullable] = STATE(3744),
    [sym_preproc_error] = STATE(3744),
    [sym_preproc_define] = STATE(3744),
    [sym_preproc_undef] = STATE(3744),
    [anon_sym_EQ] = ACTIONS(4118),
    [anon_sym_LBRACK] = ACTIONS(4741),
    [anon_sym_LPAREN] = ACTIONS(4741),
    [anon_sym_LT] = ACTIONS(4744),
    [anon_sym_GT] = ACTIONS(4744),
    [anon_sym_where] = ACTIONS(4739),
    [anon_sym_QMARK] = ACTIONS(4744),
    [anon_sym_BANG] = ACTIONS(4744),
    [anon_sym_PLUS_PLUS] = ACTIONS(4741),
    [anon_sym_DASH_DASH] = ACTIONS(4741),
    [anon_sym_PLUS] = ACTIONS(4744),
    [anon_sym_DASH] = ACTIONS(4744),
    [anon_sym_STAR] = ACTIONS(4744),
    [anon_sym_SLASH] = ACTIONS(4744),
    [anon_sym_PERCENT] = ACTIONS(4744),
    [anon_sym_CARET] = ACTIONS(4744),
    [anon_sym_PIPE] = ACTIONS(4744),
    [anon_sym_AMP] = ACTIONS(4744),
    [anon_sym_LT_LT] = ACTIONS(4744),
    [anon_sym_GT_GT] = ACTIONS(4744),
    [anon_sym_GT_GT_GT] = ACTIONS(4744),
    [anon_sym_EQ_EQ] = ACTIONS(4741),
    [anon_sym_BANG_EQ] = ACTIONS(4741),
    [anon_sym_GT_EQ] = ACTIONS(4741),
    [anon_sym_LT_EQ] = ACTIONS(4741),
    [anon_sym_DOT] = ACTIONS(4744),
    [anon_sym_switch] = ACTIONS(4741),
    [anon_sym_DOT_DOT] = ACTIONS(4741),
    [anon_sym_and] = ACTIONS(4739),
    [anon_sym_or] = ACTIONS(4747),
    [anon_sym_PLUS_EQ] = ACTIONS(4133),
    [anon_sym_DASH_EQ] = ACTIONS(4133),
    [anon_sym_STAR_EQ] = ACTIONS(4133),
    [anon_sym_SLASH_EQ] = ACTIONS(4133),
    [anon_sym_PERCENT_EQ] = ACTIONS(4133),
    [anon_sym_AMP_EQ] = ACTIONS(4133),
    [anon_sym_CARET_EQ] = ACTIONS(4133),
    [anon_sym_PIPE_EQ] = ACTIONS(4133),
    [anon_sym_LT_LT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4133),
    [anon_sym_AMP_AMP] = ACTIONS(4741),
    [anon_sym_PIPE_PIPE] = ACTIONS(4741),
    [anon_sym_QMARK_QMARK] = ACTIONS(4744),
    [anon_sym_from] = ACTIONS(4739),
    [anon_sym_into] = ACTIONS(4739),
    [anon_sym_join] = ACTIONS(4739),
    [anon_sym_let] = ACTIONS(4739),
    [anon_sym_orderby] = ACTIONS(4739),
    [anon_sym_group] = ACTIONS(4739),
    [anon_sym_select] = ACTIONS(4739),
    [anon_sym_as] = ACTIONS(4741),
    [anon_sym_is] = ACTIONS(4741),
    [anon_sym_DASH_GT] = ACTIONS(4741),
    [anon_sym_with] = ACTIONS(4741),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3745] = {
    [sym_preproc_region] = STATE(3745),
    [sym_preproc_endregion] = STATE(3745),
    [sym_preproc_line] = STATE(3745),
    [sym_preproc_pragma] = STATE(3745),
    [sym_preproc_nullable] = STATE(3745),
    [sym_preproc_error] = STATE(3745),
    [sym_preproc_define] = STATE(3745),
    [sym_preproc_undef] = STATE(3745),
    [anon_sym_SEMI] = ACTIONS(5452),
    [anon_sym_LBRACK] = ACTIONS(5452),
    [anon_sym_COLON] = ACTIONS(5452),
    [anon_sym_COMMA] = ACTIONS(5452),
    [anon_sym_RBRACK] = ACTIONS(5452),
    [anon_sym_LPAREN] = ACTIONS(5452),
    [anon_sym_RPAREN] = ACTIONS(5452),
    [anon_sym_RBRACE] = ACTIONS(5452),
    [anon_sym_LT] = ACTIONS(5454),
    [anon_sym_GT] = ACTIONS(5454),
    [anon_sym_in] = ACTIONS(5452),
    [anon_sym_where] = ACTIONS(5452),
    [anon_sym_QMARK] = ACTIONS(5454),
    [anon_sym_BANG] = ACTIONS(5454),
    [anon_sym_PLUS_PLUS] = ACTIONS(5452),
    [anon_sym_DASH_DASH] = ACTIONS(5452),
    [anon_sym_PLUS] = ACTIONS(5454),
    [anon_sym_DASH] = ACTIONS(5454),
    [anon_sym_STAR] = ACTIONS(5452),
    [anon_sym_SLASH] = ACTIONS(5454),
    [anon_sym_PERCENT] = ACTIONS(5452),
    [anon_sym_CARET] = ACTIONS(5452),
    [anon_sym_PIPE] = ACTIONS(5454),
    [anon_sym_AMP] = ACTIONS(5454),
    [anon_sym_LT_LT] = ACTIONS(5452),
    [anon_sym_GT_GT] = ACTIONS(5454),
    [anon_sym_GT_GT_GT] = ACTIONS(5452),
    [anon_sym_EQ_EQ] = ACTIONS(5452),
    [anon_sym_BANG_EQ] = ACTIONS(5452),
    [anon_sym_GT_EQ] = ACTIONS(5452),
    [anon_sym_LT_EQ] = ACTIONS(5452),
    [anon_sym_DOT] = ACTIONS(5454),
    [anon_sym_EQ_GT] = ACTIONS(5452),
    [anon_sym_switch] = ACTIONS(5452),
    [anon_sym_DOT_DOT] = ACTIONS(5452),
    [anon_sym_and] = ACTIONS(5452),
    [anon_sym_or] = ACTIONS(5454),
    [anon_sym_AMP_AMP] = ACTIONS(5452),
    [anon_sym_PIPE_PIPE] = ACTIONS(5452),
    [anon_sym_QMARK_QMARK] = ACTIONS(5452),
    [anon_sym_from] = ACTIONS(5452),
    [anon_sym_join] = ACTIONS(5452),
    [anon_sym_on] = ACTIONS(5452),
    [anon_sym_equals] = ACTIONS(5452),
    [anon_sym_let] = ACTIONS(5452),
    [anon_sym_orderby] = ACTIONS(5452),
    [anon_sym_group] = ACTIONS(5452),
    [anon_sym_by] = ACTIONS(5452),
    [anon_sym_select] = ACTIONS(5452),
    [anon_sym_as] = ACTIONS(5452),
    [anon_sym_is] = ACTIONS(5452),
    [anon_sym_DASH_GT] = ACTIONS(5452),
    [anon_sym_with] = ACTIONS(5452),
    [aux_sym_preproc_if_token3] = ACTIONS(5452),
    [aux_sym_preproc_else_token1] = ACTIONS(5452),
    [aux_sym_preproc_elif_token1] = ACTIONS(5452),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3746] = {
    [sym_preproc_region] = STATE(3746),
    [sym_preproc_endregion] = STATE(3746),
    [sym_preproc_line] = STATE(3746),
    [sym_preproc_pragma] = STATE(3746),
    [sym_preproc_nullable] = STATE(3746),
    [sym_preproc_error] = STATE(3746),
    [sym_preproc_define] = STATE(3746),
    [sym_preproc_undef] = STATE(3746),
    [sym__identifier_token] = ACTIONS(5614),
    [anon_sym_extern] = ACTIONS(5614),
    [anon_sym_alias] = ACTIONS(5614),
    [anon_sym_global] = ACTIONS(5614),
    [anon_sym_unsafe] = ACTIONS(5614),
    [anon_sym_static] = ACTIONS(5614),
    [anon_sym_LBRACK] = ACTIONS(5616),
    [anon_sym_LPAREN] = ACTIONS(5616),
    [anon_sym_event] = ACTIONS(5614),
    [anon_sym_class] = ACTIONS(5614),
    [anon_sym_ref] = ACTIONS(5614),
    [anon_sym_struct] = ACTIONS(5614),
    [anon_sym_enum] = ACTIONS(5614),
    [anon_sym_interface] = ACTIONS(5614),
    [anon_sym_delegate] = ACTIONS(5614),
    [anon_sym_record] = ACTIONS(5614),
    [anon_sym_abstract] = ACTIONS(5614),
    [anon_sym_async] = ACTIONS(5614),
    [anon_sym_const] = ACTIONS(5614),
    [anon_sym_file] = ACTIONS(5614),
    [anon_sym_fixed] = ACTIONS(5614),
    [anon_sym_internal] = ACTIONS(5614),
    [anon_sym_new] = ACTIONS(5614),
    [anon_sym_override] = ACTIONS(5614),
    [anon_sym_partial] = ACTIONS(5614),
    [anon_sym_private] = ACTIONS(5614),
    [anon_sym_protected] = ACTIONS(5614),
    [anon_sym_public] = ACTIONS(5614),
    [anon_sym_readonly] = ACTIONS(5614),
    [anon_sym_required] = ACTIONS(5614),
    [anon_sym_sealed] = ACTIONS(5614),
    [anon_sym_virtual] = ACTIONS(5614),
    [anon_sym_volatile] = ACTIONS(5614),
    [anon_sym_where] = ACTIONS(5614),
    [anon_sym_notnull] = ACTIONS(5614),
    [anon_sym_unmanaged] = ACTIONS(5614),
    [anon_sym_TILDE] = ACTIONS(5616),
    [anon_sym_implicit] = ACTIONS(5614),
    [anon_sym_explicit] = ACTIONS(5614),
    [anon_sym_scoped] = ACTIONS(5614),
    [anon_sym_var] = ACTIONS(5614),
    [sym_predefined_type] = ACTIONS(5614),
    [anon_sym_yield] = ACTIONS(5614),
    [anon_sym_when] = ACTIONS(5614),
    [anon_sym_from] = ACTIONS(5614),
    [anon_sym_into] = ACTIONS(5614),
    [anon_sym_join] = ACTIONS(5614),
    [anon_sym_on] = ACTIONS(5614),
    [anon_sym_equals] = ACTIONS(5614),
    [anon_sym_let] = ACTIONS(5614),
    [anon_sym_orderby] = ACTIONS(5614),
    [anon_sym_ascending] = ACTIONS(5614),
    [anon_sym_descending] = ACTIONS(5614),
    [anon_sym_group] = ACTIONS(5614),
    [anon_sym_by] = ACTIONS(5614),
    [anon_sym_select] = ACTIONS(5614),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3747] = {
    [sym_preproc_region] = STATE(3747),
    [sym_preproc_endregion] = STATE(3747),
    [sym_preproc_line] = STATE(3747),
    [sym_preproc_pragma] = STATE(3747),
    [sym_preproc_nullable] = STATE(3747),
    [sym_preproc_error] = STATE(3747),
    [sym_preproc_define] = STATE(3747),
    [sym_preproc_undef] = STATE(3747),
    [anon_sym_SEMI] = ACTIONS(5470),
    [anon_sym_LBRACK] = ACTIONS(5470),
    [anon_sym_COLON] = ACTIONS(5470),
    [anon_sym_COMMA] = ACTIONS(5470),
    [anon_sym_RBRACK] = ACTIONS(5470),
    [anon_sym_LPAREN] = ACTIONS(5470),
    [anon_sym_RPAREN] = ACTIONS(5470),
    [anon_sym_RBRACE] = ACTIONS(5470),
    [anon_sym_LT] = ACTIONS(5472),
    [anon_sym_GT] = ACTIONS(5472),
    [anon_sym_in] = ACTIONS(5470),
    [anon_sym_where] = ACTIONS(5470),
    [anon_sym_QMARK] = ACTIONS(5472),
    [anon_sym_BANG] = ACTIONS(5472),
    [anon_sym_PLUS_PLUS] = ACTIONS(5470),
    [anon_sym_DASH_DASH] = ACTIONS(5470),
    [anon_sym_PLUS] = ACTIONS(5472),
    [anon_sym_DASH] = ACTIONS(5472),
    [anon_sym_STAR] = ACTIONS(5470),
    [anon_sym_SLASH] = ACTIONS(5472),
    [anon_sym_PERCENT] = ACTIONS(5470),
    [anon_sym_CARET] = ACTIONS(5470),
    [anon_sym_PIPE] = ACTIONS(5472),
    [anon_sym_AMP] = ACTIONS(5472),
    [anon_sym_LT_LT] = ACTIONS(5470),
    [anon_sym_GT_GT] = ACTIONS(5472),
    [anon_sym_GT_GT_GT] = ACTIONS(5470),
    [anon_sym_EQ_EQ] = ACTIONS(5470),
    [anon_sym_BANG_EQ] = ACTIONS(5470),
    [anon_sym_GT_EQ] = ACTIONS(5470),
    [anon_sym_LT_EQ] = ACTIONS(5470),
    [anon_sym_DOT] = ACTIONS(5472),
    [anon_sym_EQ_GT] = ACTIONS(5470),
    [anon_sym_switch] = ACTIONS(5470),
    [anon_sym_DOT_DOT] = ACTIONS(5470),
    [anon_sym_and] = ACTIONS(5470),
    [anon_sym_or] = ACTIONS(5472),
    [anon_sym_AMP_AMP] = ACTIONS(5470),
    [anon_sym_PIPE_PIPE] = ACTIONS(5470),
    [anon_sym_QMARK_QMARK] = ACTIONS(5470),
    [anon_sym_from] = ACTIONS(5470),
    [anon_sym_join] = ACTIONS(5470),
    [anon_sym_on] = ACTIONS(5470),
    [anon_sym_equals] = ACTIONS(5470),
    [anon_sym_let] = ACTIONS(5470),
    [anon_sym_orderby] = ACTIONS(5470),
    [anon_sym_group] = ACTIONS(5470),
    [anon_sym_by] = ACTIONS(5470),
    [anon_sym_select] = ACTIONS(5470),
    [anon_sym_as] = ACTIONS(5470),
    [anon_sym_is] = ACTIONS(5470),
    [anon_sym_DASH_GT] = ACTIONS(5470),
    [anon_sym_with] = ACTIONS(5470),
    [aux_sym_preproc_if_token3] = ACTIONS(5470),
    [aux_sym_preproc_else_token1] = ACTIONS(5470),
    [aux_sym_preproc_elif_token1] = ACTIONS(5470),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3748] = {
    [sym_preproc_region] = STATE(3748),
    [sym_preproc_endregion] = STATE(3748),
    [sym_preproc_line] = STATE(3748),
    [sym_preproc_pragma] = STATE(3748),
    [sym_preproc_nullable] = STATE(3748),
    [sym_preproc_error] = STATE(3748),
    [sym_preproc_define] = STATE(3748),
    [sym_preproc_undef] = STATE(3748),
    [anon_sym_SEMI] = ACTIONS(5474),
    [anon_sym_LBRACK] = ACTIONS(5474),
    [anon_sym_COLON] = ACTIONS(5474),
    [anon_sym_COMMA] = ACTIONS(5474),
    [anon_sym_RBRACK] = ACTIONS(5474),
    [anon_sym_LPAREN] = ACTIONS(5474),
    [anon_sym_RPAREN] = ACTIONS(5474),
    [anon_sym_RBRACE] = ACTIONS(5474),
    [anon_sym_LT] = ACTIONS(5476),
    [anon_sym_GT] = ACTIONS(5476),
    [anon_sym_in] = ACTIONS(5474),
    [anon_sym_where] = ACTIONS(5474),
    [anon_sym_QMARK] = ACTIONS(5476),
    [anon_sym_BANG] = ACTIONS(5476),
    [anon_sym_PLUS_PLUS] = ACTIONS(5474),
    [anon_sym_DASH_DASH] = ACTIONS(5474),
    [anon_sym_PLUS] = ACTIONS(5476),
    [anon_sym_DASH] = ACTIONS(5476),
    [anon_sym_STAR] = ACTIONS(5474),
    [anon_sym_SLASH] = ACTIONS(5476),
    [anon_sym_PERCENT] = ACTIONS(5474),
    [anon_sym_CARET] = ACTIONS(5474),
    [anon_sym_PIPE] = ACTIONS(5476),
    [anon_sym_AMP] = ACTIONS(5476),
    [anon_sym_LT_LT] = ACTIONS(5474),
    [anon_sym_GT_GT] = ACTIONS(5476),
    [anon_sym_GT_GT_GT] = ACTIONS(5474),
    [anon_sym_EQ_EQ] = ACTIONS(5474),
    [anon_sym_BANG_EQ] = ACTIONS(5474),
    [anon_sym_GT_EQ] = ACTIONS(5474),
    [anon_sym_LT_EQ] = ACTIONS(5474),
    [anon_sym_DOT] = ACTIONS(5476),
    [anon_sym_EQ_GT] = ACTIONS(5474),
    [anon_sym_switch] = ACTIONS(5474),
    [anon_sym_DOT_DOT] = ACTIONS(5474),
    [anon_sym_and] = ACTIONS(5474),
    [anon_sym_or] = ACTIONS(5476),
    [anon_sym_AMP_AMP] = ACTIONS(5474),
    [anon_sym_PIPE_PIPE] = ACTIONS(5474),
    [anon_sym_QMARK_QMARK] = ACTIONS(5474),
    [anon_sym_from] = ACTIONS(5474),
    [anon_sym_join] = ACTIONS(5474),
    [anon_sym_on] = ACTIONS(5474),
    [anon_sym_equals] = ACTIONS(5474),
    [anon_sym_let] = ACTIONS(5474),
    [anon_sym_orderby] = ACTIONS(5474),
    [anon_sym_group] = ACTIONS(5474),
    [anon_sym_by] = ACTIONS(5474),
    [anon_sym_select] = ACTIONS(5474),
    [anon_sym_as] = ACTIONS(5474),
    [anon_sym_is] = ACTIONS(5474),
    [anon_sym_DASH_GT] = ACTIONS(5474),
    [anon_sym_with] = ACTIONS(5474),
    [aux_sym_preproc_if_token3] = ACTIONS(5474),
    [aux_sym_preproc_else_token1] = ACTIONS(5474),
    [aux_sym_preproc_elif_token1] = ACTIONS(5474),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3749] = {
    [sym_preproc_region] = STATE(3749),
    [sym_preproc_endregion] = STATE(3749),
    [sym_preproc_line] = STATE(3749),
    [sym_preproc_pragma] = STATE(3749),
    [sym_preproc_nullable] = STATE(3749),
    [sym_preproc_error] = STATE(3749),
    [sym_preproc_define] = STATE(3749),
    [sym_preproc_undef] = STATE(3749),
    [anon_sym_SEMI] = ACTIONS(5582),
    [anon_sym_LBRACK] = ACTIONS(5582),
    [anon_sym_COLON] = ACTIONS(5582),
    [anon_sym_COMMA] = ACTIONS(5582),
    [anon_sym_RBRACK] = ACTIONS(5582),
    [anon_sym_LPAREN] = ACTIONS(5582),
    [anon_sym_RPAREN] = ACTIONS(5582),
    [anon_sym_RBRACE] = ACTIONS(5582),
    [anon_sym_LT] = ACTIONS(5584),
    [anon_sym_GT] = ACTIONS(5584),
    [anon_sym_in] = ACTIONS(5582),
    [anon_sym_where] = ACTIONS(5582),
    [anon_sym_QMARK] = ACTIONS(5584),
    [anon_sym_BANG] = ACTIONS(5584),
    [anon_sym_PLUS_PLUS] = ACTIONS(5582),
    [anon_sym_DASH_DASH] = ACTIONS(5582),
    [anon_sym_PLUS] = ACTIONS(5584),
    [anon_sym_DASH] = ACTIONS(5584),
    [anon_sym_STAR] = ACTIONS(5582),
    [anon_sym_SLASH] = ACTIONS(5584),
    [anon_sym_PERCENT] = ACTIONS(5582),
    [anon_sym_CARET] = ACTIONS(5582),
    [anon_sym_PIPE] = ACTIONS(5584),
    [anon_sym_AMP] = ACTIONS(5584),
    [anon_sym_LT_LT] = ACTIONS(5582),
    [anon_sym_GT_GT] = ACTIONS(5584),
    [anon_sym_GT_GT_GT] = ACTIONS(5582),
    [anon_sym_EQ_EQ] = ACTIONS(5582),
    [anon_sym_BANG_EQ] = ACTIONS(5582),
    [anon_sym_GT_EQ] = ACTIONS(5582),
    [anon_sym_LT_EQ] = ACTIONS(5582),
    [anon_sym_DOT] = ACTIONS(5584),
    [anon_sym_EQ_GT] = ACTIONS(5582),
    [anon_sym_switch] = ACTIONS(5582),
    [anon_sym_DOT_DOT] = ACTIONS(5582),
    [anon_sym_and] = ACTIONS(5582),
    [anon_sym_or] = ACTIONS(5584),
    [anon_sym_AMP_AMP] = ACTIONS(5582),
    [anon_sym_PIPE_PIPE] = ACTIONS(5582),
    [anon_sym_QMARK_QMARK] = ACTIONS(5582),
    [anon_sym_from] = ACTIONS(5582),
    [anon_sym_join] = ACTIONS(5582),
    [anon_sym_on] = ACTIONS(5582),
    [anon_sym_equals] = ACTIONS(5582),
    [anon_sym_let] = ACTIONS(5582),
    [anon_sym_orderby] = ACTIONS(5582),
    [anon_sym_group] = ACTIONS(5582),
    [anon_sym_by] = ACTIONS(5582),
    [anon_sym_select] = ACTIONS(5582),
    [anon_sym_as] = ACTIONS(5582),
    [anon_sym_is] = ACTIONS(5582),
    [anon_sym_DASH_GT] = ACTIONS(5582),
    [anon_sym_with] = ACTIONS(5582),
    [aux_sym_preproc_if_token3] = ACTIONS(5582),
    [aux_sym_preproc_else_token1] = ACTIONS(5582),
    [aux_sym_preproc_elif_token1] = ACTIONS(5582),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3750] = {
    [sym_preproc_region] = STATE(3750),
    [sym_preproc_endregion] = STATE(3750),
    [sym_preproc_line] = STATE(3750),
    [sym_preproc_pragma] = STATE(3750),
    [sym_preproc_nullable] = STATE(3750),
    [sym_preproc_error] = STATE(3750),
    [sym_preproc_define] = STATE(3750),
    [sym_preproc_undef] = STATE(3750),
    [anon_sym_EQ] = ACTIONS(5618),
    [anon_sym_LBRACK] = ACTIONS(5249),
    [anon_sym_COMMA] = ACTIONS(5249),
    [anon_sym_LPAREN] = ACTIONS(5249),
    [anon_sym_LT] = ACTIONS(5251),
    [anon_sym_GT] = ACTIONS(5251),
    [anon_sym_where] = ACTIONS(5249),
    [anon_sym_QMARK] = ACTIONS(5251),
    [anon_sym_BANG] = ACTIONS(5251),
    [anon_sym_PLUS_PLUS] = ACTIONS(5249),
    [anon_sym_DASH_DASH] = ACTIONS(5249),
    [anon_sym_PLUS] = ACTIONS(5251),
    [anon_sym_DASH] = ACTIONS(5251),
    [anon_sym_STAR] = ACTIONS(5251),
    [anon_sym_SLASH] = ACTIONS(5251),
    [anon_sym_PERCENT] = ACTIONS(5251),
    [anon_sym_CARET] = ACTIONS(5251),
    [anon_sym_PIPE] = ACTIONS(5251),
    [anon_sym_AMP] = ACTIONS(5251),
    [anon_sym_LT_LT] = ACTIONS(5251),
    [anon_sym_GT_GT] = ACTIONS(5251),
    [anon_sym_GT_GT_GT] = ACTIONS(5251),
    [anon_sym_EQ_EQ] = ACTIONS(5249),
    [anon_sym_BANG_EQ] = ACTIONS(5249),
    [anon_sym_GT_EQ] = ACTIONS(5249),
    [anon_sym_LT_EQ] = ACTIONS(5249),
    [anon_sym_DOT] = ACTIONS(5251),
    [anon_sym_switch] = ACTIONS(5249),
    [anon_sym_DOT_DOT] = ACTIONS(5249),
    [anon_sym_PLUS_EQ] = ACTIONS(5620),
    [anon_sym_DASH_EQ] = ACTIONS(5620),
    [anon_sym_STAR_EQ] = ACTIONS(5620),
    [anon_sym_SLASH_EQ] = ACTIONS(5620),
    [anon_sym_PERCENT_EQ] = ACTIONS(5620),
    [anon_sym_AMP_EQ] = ACTIONS(5620),
    [anon_sym_CARET_EQ] = ACTIONS(5620),
    [anon_sym_PIPE_EQ] = ACTIONS(5620),
    [anon_sym_LT_LT_EQ] = ACTIONS(5620),
    [anon_sym_GT_GT_EQ] = ACTIONS(5620),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5620),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(5620),
    [anon_sym_AMP_AMP] = ACTIONS(5249),
    [anon_sym_PIPE_PIPE] = ACTIONS(5249),
    [anon_sym_QMARK_QMARK] = ACTIONS(5251),
    [anon_sym_from] = ACTIONS(5249),
    [anon_sym_join] = ACTIONS(5249),
    [anon_sym_let] = ACTIONS(5249),
    [anon_sym_orderby] = ACTIONS(5249),
    [anon_sym_ascending] = ACTIONS(5249),
    [anon_sym_descending] = ACTIONS(5249),
    [anon_sym_group] = ACTIONS(5249),
    [anon_sym_select] = ACTIONS(5249),
    [anon_sym_as] = ACTIONS(5251),
    [anon_sym_is] = ACTIONS(5249),
    [anon_sym_DASH_GT] = ACTIONS(5249),
    [anon_sym_with] = ACTIONS(5249),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3751] = {
    [sym_preproc_region] = STATE(3751),
    [sym_preproc_endregion] = STATE(3751),
    [sym_preproc_line] = STATE(3751),
    [sym_preproc_pragma] = STATE(3751),
    [sym_preproc_nullable] = STATE(3751),
    [sym_preproc_error] = STATE(3751),
    [sym_preproc_define] = STATE(3751),
    [sym_preproc_undef] = STATE(3751),
    [anon_sym_SEMI] = ACTIONS(5337),
    [anon_sym_LBRACK] = ACTIONS(5337),
    [anon_sym_COLON] = ACTIONS(5337),
    [anon_sym_COMMA] = ACTIONS(5337),
    [anon_sym_RBRACK] = ACTIONS(5337),
    [anon_sym_LPAREN] = ACTIONS(5337),
    [anon_sym_RPAREN] = ACTIONS(5337),
    [anon_sym_RBRACE] = ACTIONS(5337),
    [anon_sym_LT] = ACTIONS(5339),
    [anon_sym_GT] = ACTIONS(5339),
    [anon_sym_in] = ACTIONS(5337),
    [anon_sym_where] = ACTIONS(5337),
    [anon_sym_QMARK] = ACTIONS(5339),
    [anon_sym_BANG] = ACTIONS(5339),
    [anon_sym_PLUS_PLUS] = ACTIONS(5337),
    [anon_sym_DASH_DASH] = ACTIONS(5337),
    [anon_sym_PLUS] = ACTIONS(5339),
    [anon_sym_DASH] = ACTIONS(5339),
    [anon_sym_STAR] = ACTIONS(5337),
    [anon_sym_SLASH] = ACTIONS(5339),
    [anon_sym_PERCENT] = ACTIONS(5337),
    [anon_sym_CARET] = ACTIONS(5337),
    [anon_sym_PIPE] = ACTIONS(5339),
    [anon_sym_AMP] = ACTIONS(5339),
    [anon_sym_LT_LT] = ACTIONS(5337),
    [anon_sym_GT_GT] = ACTIONS(5339),
    [anon_sym_GT_GT_GT] = ACTIONS(5337),
    [anon_sym_EQ_EQ] = ACTIONS(5337),
    [anon_sym_BANG_EQ] = ACTIONS(5337),
    [anon_sym_GT_EQ] = ACTIONS(5337),
    [anon_sym_LT_EQ] = ACTIONS(5337),
    [anon_sym_DOT] = ACTIONS(5339),
    [anon_sym_EQ_GT] = ACTIONS(5337),
    [anon_sym_switch] = ACTIONS(5337),
    [anon_sym_DOT_DOT] = ACTIONS(5337),
    [anon_sym_and] = ACTIONS(5337),
    [anon_sym_or] = ACTIONS(5339),
    [anon_sym_AMP_AMP] = ACTIONS(5337),
    [anon_sym_PIPE_PIPE] = ACTIONS(5337),
    [anon_sym_QMARK_QMARK] = ACTIONS(5337),
    [anon_sym_from] = ACTIONS(5337),
    [anon_sym_join] = ACTIONS(5337),
    [anon_sym_on] = ACTIONS(5337),
    [anon_sym_equals] = ACTIONS(5337),
    [anon_sym_let] = ACTIONS(5337),
    [anon_sym_orderby] = ACTIONS(5337),
    [anon_sym_group] = ACTIONS(5337),
    [anon_sym_by] = ACTIONS(5337),
    [anon_sym_select] = ACTIONS(5337),
    [anon_sym_as] = ACTIONS(5337),
    [anon_sym_is] = ACTIONS(5337),
    [anon_sym_DASH_GT] = ACTIONS(5337),
    [anon_sym_with] = ACTIONS(5337),
    [aux_sym_preproc_if_token3] = ACTIONS(5337),
    [aux_sym_preproc_else_token1] = ACTIONS(5337),
    [aux_sym_preproc_elif_token1] = ACTIONS(5337),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3752] = {
    [sym_preproc_region] = STATE(3752),
    [sym_preproc_endregion] = STATE(3752),
    [sym_preproc_line] = STATE(3752),
    [sym_preproc_pragma] = STATE(3752),
    [sym_preproc_nullable] = STATE(3752),
    [sym_preproc_error] = STATE(3752),
    [sym_preproc_define] = STATE(3752),
    [sym_preproc_undef] = STATE(3752),
    [anon_sym_SEMI] = ACTIONS(5361),
    [anon_sym_LBRACK] = ACTIONS(5361),
    [anon_sym_COLON] = ACTIONS(5361),
    [anon_sym_COMMA] = ACTIONS(5361),
    [anon_sym_RBRACK] = ACTIONS(5361),
    [anon_sym_LPAREN] = ACTIONS(5361),
    [anon_sym_RPAREN] = ACTIONS(5361),
    [anon_sym_RBRACE] = ACTIONS(5361),
    [anon_sym_LT] = ACTIONS(5363),
    [anon_sym_GT] = ACTIONS(5363),
    [anon_sym_in] = ACTIONS(5361),
    [anon_sym_where] = ACTIONS(5361),
    [anon_sym_QMARK] = ACTIONS(5363),
    [anon_sym_BANG] = ACTIONS(5363),
    [anon_sym_PLUS_PLUS] = ACTIONS(5361),
    [anon_sym_DASH_DASH] = ACTIONS(5361),
    [anon_sym_PLUS] = ACTIONS(5363),
    [anon_sym_DASH] = ACTIONS(5363),
    [anon_sym_STAR] = ACTIONS(5361),
    [anon_sym_SLASH] = ACTIONS(5363),
    [anon_sym_PERCENT] = ACTIONS(5361),
    [anon_sym_CARET] = ACTIONS(5361),
    [anon_sym_PIPE] = ACTIONS(5363),
    [anon_sym_AMP] = ACTIONS(5363),
    [anon_sym_LT_LT] = ACTIONS(5361),
    [anon_sym_GT_GT] = ACTIONS(5363),
    [anon_sym_GT_GT_GT] = ACTIONS(5361),
    [anon_sym_EQ_EQ] = ACTIONS(5361),
    [anon_sym_BANG_EQ] = ACTIONS(5361),
    [anon_sym_GT_EQ] = ACTIONS(5361),
    [anon_sym_LT_EQ] = ACTIONS(5361),
    [anon_sym_DOT] = ACTIONS(5363),
    [anon_sym_EQ_GT] = ACTIONS(5361),
    [anon_sym_switch] = ACTIONS(5361),
    [anon_sym_DOT_DOT] = ACTIONS(5361),
    [anon_sym_and] = ACTIONS(5361),
    [anon_sym_or] = ACTIONS(5363),
    [anon_sym_AMP_AMP] = ACTIONS(5361),
    [anon_sym_PIPE_PIPE] = ACTIONS(5361),
    [anon_sym_QMARK_QMARK] = ACTIONS(5361),
    [anon_sym_from] = ACTIONS(5361),
    [anon_sym_join] = ACTIONS(5361),
    [anon_sym_on] = ACTIONS(5361),
    [anon_sym_equals] = ACTIONS(5361),
    [anon_sym_let] = ACTIONS(5361),
    [anon_sym_orderby] = ACTIONS(5361),
    [anon_sym_group] = ACTIONS(5361),
    [anon_sym_by] = ACTIONS(5361),
    [anon_sym_select] = ACTIONS(5361),
    [anon_sym_as] = ACTIONS(5361),
    [anon_sym_is] = ACTIONS(5361),
    [anon_sym_DASH_GT] = ACTIONS(5361),
    [anon_sym_with] = ACTIONS(5361),
    [aux_sym_preproc_if_token3] = ACTIONS(5361),
    [aux_sym_preproc_else_token1] = ACTIONS(5361),
    [aux_sym_preproc_elif_token1] = ACTIONS(5361),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3753] = {
    [sym_preproc_region] = STATE(3753),
    [sym_preproc_endregion] = STATE(3753),
    [sym_preproc_line] = STATE(3753),
    [sym_preproc_pragma] = STATE(3753),
    [sym_preproc_nullable] = STATE(3753),
    [sym_preproc_error] = STATE(3753),
    [sym_preproc_define] = STATE(3753),
    [sym_preproc_undef] = STATE(3753),
    [sym__identifier_token] = ACTIONS(5622),
    [anon_sym_extern] = ACTIONS(5622),
    [anon_sym_alias] = ACTIONS(5622),
    [anon_sym_global] = ACTIONS(5622),
    [anon_sym_unsafe] = ACTIONS(5622),
    [anon_sym_static] = ACTIONS(5622),
    [anon_sym_LBRACK] = ACTIONS(5624),
    [anon_sym_LPAREN] = ACTIONS(5624),
    [anon_sym_event] = ACTIONS(5622),
    [anon_sym_class] = ACTIONS(5622),
    [anon_sym_ref] = ACTIONS(5622),
    [anon_sym_struct] = ACTIONS(5622),
    [anon_sym_enum] = ACTIONS(5622),
    [anon_sym_interface] = ACTIONS(5622),
    [anon_sym_delegate] = ACTIONS(5622),
    [anon_sym_record] = ACTIONS(5622),
    [anon_sym_abstract] = ACTIONS(5622),
    [anon_sym_async] = ACTIONS(5622),
    [anon_sym_const] = ACTIONS(5622),
    [anon_sym_file] = ACTIONS(5622),
    [anon_sym_fixed] = ACTIONS(5622),
    [anon_sym_internal] = ACTIONS(5622),
    [anon_sym_new] = ACTIONS(5622),
    [anon_sym_override] = ACTIONS(5622),
    [anon_sym_partial] = ACTIONS(5622),
    [anon_sym_private] = ACTIONS(5622),
    [anon_sym_protected] = ACTIONS(5622),
    [anon_sym_public] = ACTIONS(5622),
    [anon_sym_readonly] = ACTIONS(5622),
    [anon_sym_required] = ACTIONS(5622),
    [anon_sym_sealed] = ACTIONS(5622),
    [anon_sym_virtual] = ACTIONS(5622),
    [anon_sym_volatile] = ACTIONS(5622),
    [anon_sym_where] = ACTIONS(5622),
    [anon_sym_notnull] = ACTIONS(5622),
    [anon_sym_unmanaged] = ACTIONS(5622),
    [anon_sym_TILDE] = ACTIONS(5624),
    [anon_sym_implicit] = ACTIONS(5622),
    [anon_sym_explicit] = ACTIONS(5622),
    [anon_sym_scoped] = ACTIONS(5622),
    [anon_sym_var] = ACTIONS(5622),
    [sym_predefined_type] = ACTIONS(5622),
    [anon_sym_yield] = ACTIONS(5622),
    [anon_sym_when] = ACTIONS(5622),
    [anon_sym_from] = ACTIONS(5622),
    [anon_sym_into] = ACTIONS(5622),
    [anon_sym_join] = ACTIONS(5622),
    [anon_sym_on] = ACTIONS(5622),
    [anon_sym_equals] = ACTIONS(5622),
    [anon_sym_let] = ACTIONS(5622),
    [anon_sym_orderby] = ACTIONS(5622),
    [anon_sym_ascending] = ACTIONS(5622),
    [anon_sym_descending] = ACTIONS(5622),
    [anon_sym_group] = ACTIONS(5622),
    [anon_sym_by] = ACTIONS(5622),
    [anon_sym_select] = ACTIONS(5622),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3754] = {
    [sym_preproc_region] = STATE(3754),
    [sym_preproc_endregion] = STATE(3754),
    [sym_preproc_line] = STATE(3754),
    [sym_preproc_pragma] = STATE(3754),
    [sym_preproc_nullable] = STATE(3754),
    [sym_preproc_error] = STATE(3754),
    [sym_preproc_define] = STATE(3754),
    [sym_preproc_undef] = STATE(3754),
    [anon_sym_SEMI] = ACTIONS(5357),
    [anon_sym_LBRACK] = ACTIONS(5357),
    [anon_sym_COLON] = ACTIONS(5357),
    [anon_sym_COMMA] = ACTIONS(5357),
    [anon_sym_RBRACK] = ACTIONS(5357),
    [anon_sym_LPAREN] = ACTIONS(5357),
    [anon_sym_RPAREN] = ACTIONS(5357),
    [anon_sym_RBRACE] = ACTIONS(5357),
    [anon_sym_LT] = ACTIONS(5359),
    [anon_sym_GT] = ACTIONS(5359),
    [anon_sym_in] = ACTIONS(5357),
    [anon_sym_where] = ACTIONS(5357),
    [anon_sym_QMARK] = ACTIONS(5359),
    [anon_sym_BANG] = ACTIONS(5359),
    [anon_sym_PLUS_PLUS] = ACTIONS(5357),
    [anon_sym_DASH_DASH] = ACTIONS(5357),
    [anon_sym_PLUS] = ACTIONS(5359),
    [anon_sym_DASH] = ACTIONS(5359),
    [anon_sym_STAR] = ACTIONS(5357),
    [anon_sym_SLASH] = ACTIONS(5359),
    [anon_sym_PERCENT] = ACTIONS(5357),
    [anon_sym_CARET] = ACTIONS(5357),
    [anon_sym_PIPE] = ACTIONS(5359),
    [anon_sym_AMP] = ACTIONS(5359),
    [anon_sym_LT_LT] = ACTIONS(5357),
    [anon_sym_GT_GT] = ACTIONS(5359),
    [anon_sym_GT_GT_GT] = ACTIONS(5357),
    [anon_sym_EQ_EQ] = ACTIONS(5357),
    [anon_sym_BANG_EQ] = ACTIONS(5357),
    [anon_sym_GT_EQ] = ACTIONS(5357),
    [anon_sym_LT_EQ] = ACTIONS(5357),
    [anon_sym_DOT] = ACTIONS(5359),
    [anon_sym_EQ_GT] = ACTIONS(5357),
    [anon_sym_switch] = ACTIONS(5357),
    [anon_sym_DOT_DOT] = ACTIONS(5357),
    [anon_sym_and] = ACTIONS(5357),
    [anon_sym_or] = ACTIONS(5359),
    [anon_sym_AMP_AMP] = ACTIONS(5357),
    [anon_sym_PIPE_PIPE] = ACTIONS(5357),
    [anon_sym_QMARK_QMARK] = ACTIONS(5357),
    [anon_sym_from] = ACTIONS(5357),
    [anon_sym_join] = ACTIONS(5357),
    [anon_sym_on] = ACTIONS(5357),
    [anon_sym_equals] = ACTIONS(5357),
    [anon_sym_let] = ACTIONS(5357),
    [anon_sym_orderby] = ACTIONS(5357),
    [anon_sym_group] = ACTIONS(5357),
    [anon_sym_by] = ACTIONS(5357),
    [anon_sym_select] = ACTIONS(5357),
    [anon_sym_as] = ACTIONS(5357),
    [anon_sym_is] = ACTIONS(5357),
    [anon_sym_DASH_GT] = ACTIONS(5357),
    [anon_sym_with] = ACTIONS(5357),
    [aux_sym_preproc_if_token3] = ACTIONS(5357),
    [aux_sym_preproc_else_token1] = ACTIONS(5357),
    [aux_sym_preproc_elif_token1] = ACTIONS(5357),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3755] = {
    [sym_preproc_region] = STATE(3755),
    [sym_preproc_endregion] = STATE(3755),
    [sym_preproc_line] = STATE(3755),
    [sym_preproc_pragma] = STATE(3755),
    [sym_preproc_nullable] = STATE(3755),
    [sym_preproc_error] = STATE(3755),
    [sym_preproc_define] = STATE(3755),
    [sym_preproc_undef] = STATE(3755),
    [anon_sym_SEMI] = ACTIONS(5590),
    [anon_sym_LBRACK] = ACTIONS(5590),
    [anon_sym_COLON] = ACTIONS(5590),
    [anon_sym_COMMA] = ACTIONS(5590),
    [anon_sym_RBRACK] = ACTIONS(5590),
    [anon_sym_LPAREN] = ACTIONS(5590),
    [anon_sym_RPAREN] = ACTIONS(5590),
    [anon_sym_RBRACE] = ACTIONS(5590),
    [anon_sym_LT] = ACTIONS(5592),
    [anon_sym_GT] = ACTIONS(5592),
    [anon_sym_in] = ACTIONS(5590),
    [anon_sym_where] = ACTIONS(5590),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_BANG] = ACTIONS(5592),
    [anon_sym_PLUS_PLUS] = ACTIONS(5590),
    [anon_sym_DASH_DASH] = ACTIONS(5590),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_DASH] = ACTIONS(5592),
    [anon_sym_STAR] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [anon_sym_PERCENT] = ACTIONS(5590),
    [anon_sym_CARET] = ACTIONS(5590),
    [anon_sym_PIPE] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5590),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_GT_GT_GT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_BANG_EQ] = ACTIONS(5590),
    [anon_sym_GT_EQ] = ACTIONS(5590),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_DOT] = ACTIONS(5592),
    [anon_sym_EQ_GT] = ACTIONS(5590),
    [anon_sym_switch] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5590),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_AMP_AMP] = ACTIONS(5590),
    [anon_sym_PIPE_PIPE] = ACTIONS(5590),
    [anon_sym_QMARK_QMARK] = ACTIONS(5590),
    [anon_sym_from] = ACTIONS(5590),
    [anon_sym_join] = ACTIONS(5590),
    [anon_sym_on] = ACTIONS(5590),
    [anon_sym_equals] = ACTIONS(5590),
    [anon_sym_let] = ACTIONS(5590),
    [anon_sym_orderby] = ACTIONS(5590),
    [anon_sym_group] = ACTIONS(5590),
    [anon_sym_by] = ACTIONS(5590),
    [anon_sym_select] = ACTIONS(5590),
    [anon_sym_as] = ACTIONS(5590),
    [anon_sym_is] = ACTIONS(5590),
    [anon_sym_DASH_GT] = ACTIONS(5590),
    [anon_sym_with] = ACTIONS(5590),
    [aux_sym_preproc_if_token3] = ACTIONS(5590),
    [aux_sym_preproc_else_token1] = ACTIONS(5590),
    [aux_sym_preproc_elif_token1] = ACTIONS(5590),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3756] = {
    [sym_preproc_region] = STATE(3756),
    [sym_preproc_endregion] = STATE(3756),
    [sym_preproc_line] = STATE(3756),
    [sym_preproc_pragma] = STATE(3756),
    [sym_preproc_nullable] = STATE(3756),
    [sym_preproc_error] = STATE(3756),
    [sym_preproc_define] = STATE(3756),
    [sym_preproc_undef] = STATE(3756),
    [anon_sym_SEMI] = ACTIONS(5341),
    [anon_sym_LBRACK] = ACTIONS(5341),
    [anon_sym_COLON] = ACTIONS(5341),
    [anon_sym_COMMA] = ACTIONS(5341),
    [anon_sym_RBRACK] = ACTIONS(5341),
    [anon_sym_LPAREN] = ACTIONS(5341),
    [anon_sym_RPAREN] = ACTIONS(5341),
    [anon_sym_RBRACE] = ACTIONS(5341),
    [anon_sym_LT] = ACTIONS(5343),
    [anon_sym_GT] = ACTIONS(5343),
    [anon_sym_in] = ACTIONS(5341),
    [anon_sym_where] = ACTIONS(5341),
    [anon_sym_QMARK] = ACTIONS(5343),
    [anon_sym_BANG] = ACTIONS(5343),
    [anon_sym_PLUS_PLUS] = ACTIONS(5341),
    [anon_sym_DASH_DASH] = ACTIONS(5341),
    [anon_sym_PLUS] = ACTIONS(5343),
    [anon_sym_DASH] = ACTIONS(5343),
    [anon_sym_STAR] = ACTIONS(5341),
    [anon_sym_SLASH] = ACTIONS(5343),
    [anon_sym_PERCENT] = ACTIONS(5341),
    [anon_sym_CARET] = ACTIONS(5341),
    [anon_sym_PIPE] = ACTIONS(5343),
    [anon_sym_AMP] = ACTIONS(5343),
    [anon_sym_LT_LT] = ACTIONS(5341),
    [anon_sym_GT_GT] = ACTIONS(5343),
    [anon_sym_GT_GT_GT] = ACTIONS(5341),
    [anon_sym_EQ_EQ] = ACTIONS(5341),
    [anon_sym_BANG_EQ] = ACTIONS(5341),
    [anon_sym_GT_EQ] = ACTIONS(5341),
    [anon_sym_LT_EQ] = ACTIONS(5341),
    [anon_sym_DOT] = ACTIONS(5343),
    [anon_sym_EQ_GT] = ACTIONS(5341),
    [anon_sym_switch] = ACTIONS(5341),
    [anon_sym_DOT_DOT] = ACTIONS(5341),
    [anon_sym_and] = ACTIONS(5341),
    [anon_sym_or] = ACTIONS(5343),
    [anon_sym_AMP_AMP] = ACTIONS(5341),
    [anon_sym_PIPE_PIPE] = ACTIONS(5341),
    [anon_sym_QMARK_QMARK] = ACTIONS(5341),
    [anon_sym_from] = ACTIONS(5341),
    [anon_sym_join] = ACTIONS(5341),
    [anon_sym_on] = ACTIONS(5341),
    [anon_sym_equals] = ACTIONS(5341),
    [anon_sym_let] = ACTIONS(5341),
    [anon_sym_orderby] = ACTIONS(5341),
    [anon_sym_group] = ACTIONS(5341),
    [anon_sym_by] = ACTIONS(5341),
    [anon_sym_select] = ACTIONS(5341),
    [anon_sym_as] = ACTIONS(5341),
    [anon_sym_is] = ACTIONS(5341),
    [anon_sym_DASH_GT] = ACTIONS(5341),
    [anon_sym_with] = ACTIONS(5341),
    [aux_sym_preproc_if_token3] = ACTIONS(5341),
    [aux_sym_preproc_else_token1] = ACTIONS(5341),
    [aux_sym_preproc_elif_token1] = ACTIONS(5341),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3757] = {
    [sym_modifier] = STATE(3780),
    [sym_preproc_region] = STATE(3757),
    [sym_preproc_endregion] = STATE(3757),
    [sym_preproc_line] = STATE(3757),
    [sym_preproc_pragma] = STATE(3757),
    [sym_preproc_nullable] = STATE(3757),
    [sym_preproc_error] = STATE(3757),
    [sym_preproc_define] = STATE(3757),
    [sym_preproc_undef] = STATE(3757),
    [aux_sym_class_declaration_repeat2] = STATE(3757),
    [sym__identifier_token] = ACTIONS(5626),
    [anon_sym_extern] = ACTIONS(5628),
    [anon_sym_alias] = ACTIONS(5626),
    [anon_sym_global] = ACTIONS(5626),
    [anon_sym_unsafe] = ACTIONS(5628),
    [anon_sym_static] = ACTIONS(5628),
    [anon_sym_LPAREN] = ACTIONS(5631),
    [anon_sym_event] = ACTIONS(5626),
    [anon_sym_class] = ACTIONS(5626),
    [anon_sym_ref] = ACTIONS(5626),
    [anon_sym_struct] = ACTIONS(5626),
    [anon_sym_enum] = ACTIONS(5626),
    [anon_sym_interface] = ACTIONS(5626),
    [anon_sym_delegate] = ACTIONS(5626),
    [anon_sym_record] = ACTIONS(5626),
    [anon_sym_abstract] = ACTIONS(5628),
    [anon_sym_async] = ACTIONS(5628),
    [anon_sym_const] = ACTIONS(5628),
    [anon_sym_file] = ACTIONS(5628),
    [anon_sym_fixed] = ACTIONS(5628),
    [anon_sym_internal] = ACTIONS(5628),
    [anon_sym_new] = ACTIONS(5628),
    [anon_sym_override] = ACTIONS(5628),
    [anon_sym_partial] = ACTIONS(5628),
    [anon_sym_private] = ACTIONS(5628),
    [anon_sym_protected] = ACTIONS(5628),
    [anon_sym_public] = ACTIONS(5628),
    [anon_sym_readonly] = ACTIONS(5628),
    [anon_sym_required] = ACTIONS(5628),
    [anon_sym_sealed] = ACTIONS(5628),
    [anon_sym_virtual] = ACTIONS(5628),
    [anon_sym_volatile] = ACTIONS(5628),
    [anon_sym_where] = ACTIONS(5626),
    [anon_sym_notnull] = ACTIONS(5626),
    [anon_sym_unmanaged] = ACTIONS(5626),
    [anon_sym_implicit] = ACTIONS(5626),
    [anon_sym_explicit] = ACTIONS(5626),
    [anon_sym_scoped] = ACTIONS(5626),
    [anon_sym_var] = ACTIONS(5626),
    [sym_predefined_type] = ACTIONS(5626),
    [anon_sym_yield] = ACTIONS(5626),
    [anon_sym_when] = ACTIONS(5626),
    [anon_sym_from] = ACTIONS(5626),
    [anon_sym_into] = ACTIONS(5626),
    [anon_sym_join] = ACTIONS(5626),
    [anon_sym_on] = ACTIONS(5626),
    [anon_sym_equals] = ACTIONS(5626),
    [anon_sym_let] = ACTIONS(5626),
    [anon_sym_orderby] = ACTIONS(5626),
    [anon_sym_ascending] = ACTIONS(5626),
    [anon_sym_descending] = ACTIONS(5626),
    [anon_sym_group] = ACTIONS(5626),
    [anon_sym_by] = ACTIONS(5626),
    [anon_sym_select] = ACTIONS(5626),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3758] = {
    [sym_preproc_region] = STATE(3758),
    [sym_preproc_endregion] = STATE(3758),
    [sym_preproc_line] = STATE(3758),
    [sym_preproc_pragma] = STATE(3758),
    [sym_preproc_nullable] = STATE(3758),
    [sym_preproc_error] = STATE(3758),
    [sym_preproc_define] = STATE(3758),
    [sym_preproc_undef] = STATE(3758),
    [sym__identifier_token] = ACTIONS(5633),
    [anon_sym_extern] = ACTIONS(5633),
    [anon_sym_alias] = ACTIONS(5633),
    [anon_sym_global] = ACTIONS(5633),
    [anon_sym_unsafe] = ACTIONS(5633),
    [anon_sym_static] = ACTIONS(5633),
    [anon_sym_LBRACK] = ACTIONS(5635),
    [anon_sym_LPAREN] = ACTIONS(5635),
    [anon_sym_event] = ACTIONS(5633),
    [anon_sym_class] = ACTIONS(5633),
    [anon_sym_ref] = ACTIONS(5633),
    [anon_sym_struct] = ACTIONS(5633),
    [anon_sym_enum] = ACTIONS(5633),
    [anon_sym_interface] = ACTIONS(5633),
    [anon_sym_delegate] = ACTIONS(5633),
    [anon_sym_record] = ACTIONS(5633),
    [anon_sym_abstract] = ACTIONS(5633),
    [anon_sym_async] = ACTIONS(5633),
    [anon_sym_const] = ACTIONS(5633),
    [anon_sym_file] = ACTIONS(5633),
    [anon_sym_fixed] = ACTIONS(5633),
    [anon_sym_internal] = ACTIONS(5633),
    [anon_sym_new] = ACTIONS(5633),
    [anon_sym_override] = ACTIONS(5633),
    [anon_sym_partial] = ACTIONS(5633),
    [anon_sym_private] = ACTIONS(5633),
    [anon_sym_protected] = ACTIONS(5633),
    [anon_sym_public] = ACTIONS(5633),
    [anon_sym_readonly] = ACTIONS(5633),
    [anon_sym_required] = ACTIONS(5633),
    [anon_sym_sealed] = ACTIONS(5633),
    [anon_sym_virtual] = ACTIONS(5633),
    [anon_sym_volatile] = ACTIONS(5633),
    [anon_sym_where] = ACTIONS(5633),
    [anon_sym_notnull] = ACTIONS(5633),
    [anon_sym_unmanaged] = ACTIONS(5633),
    [anon_sym_TILDE] = ACTIONS(5635),
    [anon_sym_implicit] = ACTIONS(5633),
    [anon_sym_explicit] = ACTIONS(5633),
    [anon_sym_scoped] = ACTIONS(5633),
    [anon_sym_var] = ACTIONS(5633),
    [sym_predefined_type] = ACTIONS(5633),
    [anon_sym_yield] = ACTIONS(5633),
    [anon_sym_when] = ACTIONS(5633),
    [anon_sym_from] = ACTIONS(5633),
    [anon_sym_into] = ACTIONS(5633),
    [anon_sym_join] = ACTIONS(5633),
    [anon_sym_on] = ACTIONS(5633),
    [anon_sym_equals] = ACTIONS(5633),
    [anon_sym_let] = ACTIONS(5633),
    [anon_sym_orderby] = ACTIONS(5633),
    [anon_sym_ascending] = ACTIONS(5633),
    [anon_sym_descending] = ACTIONS(5633),
    [anon_sym_group] = ACTIONS(5633),
    [anon_sym_by] = ACTIONS(5633),
    [anon_sym_select] = ACTIONS(5633),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3759] = {
    [sym_preproc_region] = STATE(3759),
    [sym_preproc_endregion] = STATE(3759),
    [sym_preproc_line] = STATE(3759),
    [sym_preproc_pragma] = STATE(3759),
    [sym_preproc_nullable] = STATE(3759),
    [sym_preproc_error] = STATE(3759),
    [sym_preproc_define] = STATE(3759),
    [sym_preproc_undef] = STATE(3759),
    [anon_sym_SEMI] = ACTIONS(5448),
    [anon_sym_LBRACK] = ACTIONS(5448),
    [anon_sym_COLON] = ACTIONS(5448),
    [anon_sym_COMMA] = ACTIONS(5448),
    [anon_sym_RBRACK] = ACTIONS(5448),
    [anon_sym_LPAREN] = ACTIONS(5448),
    [anon_sym_RPAREN] = ACTIONS(5448),
    [anon_sym_RBRACE] = ACTIONS(5448),
    [anon_sym_LT] = ACTIONS(5450),
    [anon_sym_GT] = ACTIONS(5450),
    [anon_sym_in] = ACTIONS(5448),
    [anon_sym_where] = ACTIONS(5448),
    [anon_sym_QMARK] = ACTIONS(5450),
    [anon_sym_BANG] = ACTIONS(5450),
    [anon_sym_PLUS_PLUS] = ACTIONS(5448),
    [anon_sym_DASH_DASH] = ACTIONS(5448),
    [anon_sym_PLUS] = ACTIONS(5450),
    [anon_sym_DASH] = ACTIONS(5450),
    [anon_sym_STAR] = ACTIONS(5448),
    [anon_sym_SLASH] = ACTIONS(5450),
    [anon_sym_PERCENT] = ACTIONS(5448),
    [anon_sym_CARET] = ACTIONS(5448),
    [anon_sym_PIPE] = ACTIONS(5450),
    [anon_sym_AMP] = ACTIONS(5450),
    [anon_sym_LT_LT] = ACTIONS(5448),
    [anon_sym_GT_GT] = ACTIONS(5450),
    [anon_sym_GT_GT_GT] = ACTIONS(5448),
    [anon_sym_EQ_EQ] = ACTIONS(5448),
    [anon_sym_BANG_EQ] = ACTIONS(5448),
    [anon_sym_GT_EQ] = ACTIONS(5448),
    [anon_sym_LT_EQ] = ACTIONS(5448),
    [anon_sym_DOT] = ACTIONS(5450),
    [anon_sym_EQ_GT] = ACTIONS(5448),
    [anon_sym_switch] = ACTIONS(5448),
    [anon_sym_DOT_DOT] = ACTIONS(5448),
    [anon_sym_and] = ACTIONS(5448),
    [anon_sym_or] = ACTIONS(5450),
    [anon_sym_AMP_AMP] = ACTIONS(5448),
    [anon_sym_PIPE_PIPE] = ACTIONS(5448),
    [anon_sym_QMARK_QMARK] = ACTIONS(5448),
    [anon_sym_from] = ACTIONS(5448),
    [anon_sym_join] = ACTIONS(5448),
    [anon_sym_on] = ACTIONS(5448),
    [anon_sym_equals] = ACTIONS(5448),
    [anon_sym_let] = ACTIONS(5448),
    [anon_sym_orderby] = ACTIONS(5448),
    [anon_sym_group] = ACTIONS(5448),
    [anon_sym_by] = ACTIONS(5448),
    [anon_sym_select] = ACTIONS(5448),
    [anon_sym_as] = ACTIONS(5448),
    [anon_sym_is] = ACTIONS(5448),
    [anon_sym_DASH_GT] = ACTIONS(5448),
    [anon_sym_with] = ACTIONS(5448),
    [aux_sym_preproc_if_token3] = ACTIONS(5448),
    [aux_sym_preproc_else_token1] = ACTIONS(5448),
    [aux_sym_preproc_elif_token1] = ACTIONS(5448),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3760] = {
    [sym_preproc_region] = STATE(3760),
    [sym_preproc_endregion] = STATE(3760),
    [sym_preproc_line] = STATE(3760),
    [sym_preproc_pragma] = STATE(3760),
    [sym_preproc_nullable] = STATE(3760),
    [sym_preproc_error] = STATE(3760),
    [sym_preproc_define] = STATE(3760),
    [sym_preproc_undef] = STATE(3760),
    [anon_sym_SEMI] = ACTIONS(5349),
    [anon_sym_LBRACK] = ACTIONS(5349),
    [anon_sym_COLON] = ACTIONS(5349),
    [anon_sym_COMMA] = ACTIONS(5349),
    [anon_sym_RBRACK] = ACTIONS(5349),
    [anon_sym_LPAREN] = ACTIONS(5349),
    [anon_sym_RPAREN] = ACTIONS(5349),
    [anon_sym_RBRACE] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_in] = ACTIONS(5349),
    [anon_sym_where] = ACTIONS(5349),
    [anon_sym_QMARK] = ACTIONS(5351),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS_PLUS] = ACTIONS(5349),
    [anon_sym_DASH_DASH] = ACTIONS(5349),
    [anon_sym_PLUS] = ACTIONS(5351),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_STAR] = ACTIONS(5349),
    [anon_sym_SLASH] = ACTIONS(5351),
    [anon_sym_PERCENT] = ACTIONS(5349),
    [anon_sym_CARET] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_LT_LT] = ACTIONS(5349),
    [anon_sym_GT_GT] = ACTIONS(5351),
    [anon_sym_GT_GT_GT] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_DOT] = ACTIONS(5351),
    [anon_sym_EQ_GT] = ACTIONS(5349),
    [anon_sym_switch] = ACTIONS(5349),
    [anon_sym_DOT_DOT] = ACTIONS(5349),
    [anon_sym_and] = ACTIONS(5349),
    [anon_sym_or] = ACTIONS(5351),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_QMARK_QMARK] = ACTIONS(5349),
    [anon_sym_from] = ACTIONS(5349),
    [anon_sym_join] = ACTIONS(5349),
    [anon_sym_on] = ACTIONS(5349),
    [anon_sym_equals] = ACTIONS(5349),
    [anon_sym_let] = ACTIONS(5349),
    [anon_sym_orderby] = ACTIONS(5349),
    [anon_sym_group] = ACTIONS(5349),
    [anon_sym_by] = ACTIONS(5349),
    [anon_sym_select] = ACTIONS(5349),
    [anon_sym_as] = ACTIONS(5349),
    [anon_sym_is] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5349),
    [anon_sym_with] = ACTIONS(5349),
    [aux_sym_preproc_if_token3] = ACTIONS(5349),
    [aux_sym_preproc_else_token1] = ACTIONS(5349),
    [aux_sym_preproc_elif_token1] = ACTIONS(5349),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3761] = {
    [sym_preproc_region] = STATE(3761),
    [sym_preproc_endregion] = STATE(3761),
    [sym_preproc_line] = STATE(3761),
    [sym_preproc_pragma] = STATE(3761),
    [sym_preproc_nullable] = STATE(3761),
    [sym_preproc_error] = STATE(3761),
    [sym_preproc_define] = STATE(3761),
    [sym_preproc_undef] = STATE(3761),
    [anon_sym_SEMI] = ACTIONS(5353),
    [anon_sym_LBRACK] = ACTIONS(5353),
    [anon_sym_COLON] = ACTIONS(5353),
    [anon_sym_COMMA] = ACTIONS(5353),
    [anon_sym_RBRACK] = ACTIONS(5353),
    [anon_sym_LPAREN] = ACTIONS(5353),
    [anon_sym_RPAREN] = ACTIONS(5353),
    [anon_sym_RBRACE] = ACTIONS(5353),
    [anon_sym_LT] = ACTIONS(5355),
    [anon_sym_GT] = ACTIONS(5355),
    [anon_sym_in] = ACTIONS(5353),
    [anon_sym_where] = ACTIONS(5353),
    [anon_sym_QMARK] = ACTIONS(5355),
    [anon_sym_BANG] = ACTIONS(5355),
    [anon_sym_PLUS_PLUS] = ACTIONS(5353),
    [anon_sym_DASH_DASH] = ACTIONS(5353),
    [anon_sym_PLUS] = ACTIONS(5355),
    [anon_sym_DASH] = ACTIONS(5355),
    [anon_sym_STAR] = ACTIONS(5353),
    [anon_sym_SLASH] = ACTIONS(5355),
    [anon_sym_PERCENT] = ACTIONS(5353),
    [anon_sym_CARET] = ACTIONS(5353),
    [anon_sym_PIPE] = ACTIONS(5355),
    [anon_sym_AMP] = ACTIONS(5355),
    [anon_sym_LT_LT] = ACTIONS(5353),
    [anon_sym_GT_GT] = ACTIONS(5355),
    [anon_sym_GT_GT_GT] = ACTIONS(5353),
    [anon_sym_EQ_EQ] = ACTIONS(5353),
    [anon_sym_BANG_EQ] = ACTIONS(5353),
    [anon_sym_GT_EQ] = ACTIONS(5353),
    [anon_sym_LT_EQ] = ACTIONS(5353),
    [anon_sym_DOT] = ACTIONS(5355),
    [anon_sym_EQ_GT] = ACTIONS(5353),
    [anon_sym_switch] = ACTIONS(5353),
    [anon_sym_DOT_DOT] = ACTIONS(5353),
    [anon_sym_and] = ACTIONS(5353),
    [anon_sym_or] = ACTIONS(5355),
    [anon_sym_AMP_AMP] = ACTIONS(5353),
    [anon_sym_PIPE_PIPE] = ACTIONS(5353),
    [anon_sym_QMARK_QMARK] = ACTIONS(5353),
    [anon_sym_from] = ACTIONS(5353),
    [anon_sym_join] = ACTIONS(5353),
    [anon_sym_on] = ACTIONS(5353),
    [anon_sym_equals] = ACTIONS(5353),
    [anon_sym_let] = ACTIONS(5353),
    [anon_sym_orderby] = ACTIONS(5353),
    [anon_sym_group] = ACTIONS(5353),
    [anon_sym_by] = ACTIONS(5353),
    [anon_sym_select] = ACTIONS(5353),
    [anon_sym_as] = ACTIONS(5353),
    [anon_sym_is] = ACTIONS(5353),
    [anon_sym_DASH_GT] = ACTIONS(5353),
    [anon_sym_with] = ACTIONS(5353),
    [aux_sym_preproc_if_token3] = ACTIONS(5353),
    [aux_sym_preproc_else_token1] = ACTIONS(5353),
    [aux_sym_preproc_elif_token1] = ACTIONS(5353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3762] = {
    [sym_preproc_region] = STATE(3762),
    [sym_preproc_endregion] = STATE(3762),
    [sym_preproc_line] = STATE(3762),
    [sym_preproc_pragma] = STATE(3762),
    [sym_preproc_nullable] = STATE(3762),
    [sym_preproc_error] = STATE(3762),
    [sym_preproc_define] = STATE(3762),
    [sym_preproc_undef] = STATE(3762),
    [anon_sym_SEMI] = ACTIONS(5526),
    [anon_sym_LBRACK] = ACTIONS(5526),
    [anon_sym_COLON] = ACTIONS(5526),
    [anon_sym_COMMA] = ACTIONS(5526),
    [anon_sym_RBRACK] = ACTIONS(5526),
    [anon_sym_LPAREN] = ACTIONS(5526),
    [anon_sym_RPAREN] = ACTIONS(5526),
    [anon_sym_RBRACE] = ACTIONS(5526),
    [anon_sym_LT] = ACTIONS(5528),
    [anon_sym_GT] = ACTIONS(5528),
    [anon_sym_in] = ACTIONS(5526),
    [anon_sym_where] = ACTIONS(5526),
    [anon_sym_QMARK] = ACTIONS(5528),
    [anon_sym_BANG] = ACTIONS(5528),
    [anon_sym_PLUS_PLUS] = ACTIONS(5526),
    [anon_sym_DASH_DASH] = ACTIONS(5526),
    [anon_sym_PLUS] = ACTIONS(5528),
    [anon_sym_DASH] = ACTIONS(5528),
    [anon_sym_STAR] = ACTIONS(5526),
    [anon_sym_SLASH] = ACTIONS(5528),
    [anon_sym_PERCENT] = ACTIONS(5526),
    [anon_sym_CARET] = ACTIONS(5526),
    [anon_sym_PIPE] = ACTIONS(5528),
    [anon_sym_AMP] = ACTIONS(5528),
    [anon_sym_LT_LT] = ACTIONS(5526),
    [anon_sym_GT_GT] = ACTIONS(5528),
    [anon_sym_GT_GT_GT] = ACTIONS(5526),
    [anon_sym_EQ_EQ] = ACTIONS(5526),
    [anon_sym_BANG_EQ] = ACTIONS(5526),
    [anon_sym_GT_EQ] = ACTIONS(5526),
    [anon_sym_LT_EQ] = ACTIONS(5526),
    [anon_sym_DOT] = ACTIONS(5528),
    [anon_sym_EQ_GT] = ACTIONS(5526),
    [anon_sym_switch] = ACTIONS(5526),
    [anon_sym_DOT_DOT] = ACTIONS(5526),
    [anon_sym_and] = ACTIONS(5526),
    [anon_sym_or] = ACTIONS(5528),
    [anon_sym_AMP_AMP] = ACTIONS(5526),
    [anon_sym_PIPE_PIPE] = ACTIONS(5526),
    [anon_sym_QMARK_QMARK] = ACTIONS(5526),
    [anon_sym_from] = ACTIONS(5526),
    [anon_sym_join] = ACTIONS(5526),
    [anon_sym_on] = ACTIONS(5526),
    [anon_sym_equals] = ACTIONS(5526),
    [anon_sym_let] = ACTIONS(5526),
    [anon_sym_orderby] = ACTIONS(5526),
    [anon_sym_group] = ACTIONS(5526),
    [anon_sym_by] = ACTIONS(5526),
    [anon_sym_select] = ACTIONS(5526),
    [anon_sym_as] = ACTIONS(5526),
    [anon_sym_is] = ACTIONS(5526),
    [anon_sym_DASH_GT] = ACTIONS(5526),
    [anon_sym_with] = ACTIONS(5526),
    [aux_sym_preproc_if_token3] = ACTIONS(5526),
    [aux_sym_preproc_else_token1] = ACTIONS(5526),
    [aux_sym_preproc_elif_token1] = ACTIONS(5526),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3763] = {
    [sym_preproc_region] = STATE(3763),
    [sym_preproc_endregion] = STATE(3763),
    [sym_preproc_line] = STATE(3763),
    [sym_preproc_pragma] = STATE(3763),
    [sym_preproc_nullable] = STATE(3763),
    [sym_preproc_error] = STATE(3763),
    [sym_preproc_define] = STATE(3763),
    [sym_preproc_undef] = STATE(3763),
    [anon_sym_SEMI] = ACTIONS(5522),
    [anon_sym_LBRACK] = ACTIONS(5522),
    [anon_sym_COLON] = ACTIONS(5522),
    [anon_sym_COMMA] = ACTIONS(5522),
    [anon_sym_RBRACK] = ACTIONS(5522),
    [anon_sym_LPAREN] = ACTIONS(5522),
    [anon_sym_RPAREN] = ACTIONS(5522),
    [anon_sym_RBRACE] = ACTIONS(5522),
    [anon_sym_LT] = ACTIONS(5524),
    [anon_sym_GT] = ACTIONS(5524),
    [anon_sym_in] = ACTIONS(5522),
    [anon_sym_where] = ACTIONS(5522),
    [anon_sym_QMARK] = ACTIONS(5524),
    [anon_sym_BANG] = ACTIONS(5524),
    [anon_sym_PLUS_PLUS] = ACTIONS(5522),
    [anon_sym_DASH_DASH] = ACTIONS(5522),
    [anon_sym_PLUS] = ACTIONS(5524),
    [anon_sym_DASH] = ACTIONS(5524),
    [anon_sym_STAR] = ACTIONS(5522),
    [anon_sym_SLASH] = ACTIONS(5524),
    [anon_sym_PERCENT] = ACTIONS(5522),
    [anon_sym_CARET] = ACTIONS(5522),
    [anon_sym_PIPE] = ACTIONS(5524),
    [anon_sym_AMP] = ACTIONS(5524),
    [anon_sym_LT_LT] = ACTIONS(5522),
    [anon_sym_GT_GT] = ACTIONS(5524),
    [anon_sym_GT_GT_GT] = ACTIONS(5522),
    [anon_sym_EQ_EQ] = ACTIONS(5522),
    [anon_sym_BANG_EQ] = ACTIONS(5522),
    [anon_sym_GT_EQ] = ACTIONS(5522),
    [anon_sym_LT_EQ] = ACTIONS(5522),
    [anon_sym_DOT] = ACTIONS(5524),
    [anon_sym_EQ_GT] = ACTIONS(5522),
    [anon_sym_switch] = ACTIONS(5522),
    [anon_sym_DOT_DOT] = ACTIONS(5522),
    [anon_sym_and] = ACTIONS(5522),
    [anon_sym_or] = ACTIONS(5524),
    [anon_sym_AMP_AMP] = ACTIONS(5522),
    [anon_sym_PIPE_PIPE] = ACTIONS(5522),
    [anon_sym_QMARK_QMARK] = ACTIONS(5522),
    [anon_sym_from] = ACTIONS(5522),
    [anon_sym_join] = ACTIONS(5522),
    [anon_sym_on] = ACTIONS(5522),
    [anon_sym_equals] = ACTIONS(5522),
    [anon_sym_let] = ACTIONS(5522),
    [anon_sym_orderby] = ACTIONS(5522),
    [anon_sym_group] = ACTIONS(5522),
    [anon_sym_by] = ACTIONS(5522),
    [anon_sym_select] = ACTIONS(5522),
    [anon_sym_as] = ACTIONS(5522),
    [anon_sym_is] = ACTIONS(5522),
    [anon_sym_DASH_GT] = ACTIONS(5522),
    [anon_sym_with] = ACTIONS(5522),
    [aux_sym_preproc_if_token3] = ACTIONS(5522),
    [aux_sym_preproc_else_token1] = ACTIONS(5522),
    [aux_sym_preproc_elif_token1] = ACTIONS(5522),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3764] = {
    [sym_preproc_region] = STATE(3764),
    [sym_preproc_endregion] = STATE(3764),
    [sym_preproc_line] = STATE(3764),
    [sym_preproc_pragma] = STATE(3764),
    [sym_preproc_nullable] = STATE(3764),
    [sym_preproc_error] = STATE(3764),
    [sym_preproc_define] = STATE(3764),
    [sym_preproc_undef] = STATE(3764),
    [anon_sym_SEMI] = ACTIONS(5329),
    [anon_sym_LBRACK] = ACTIONS(5329),
    [anon_sym_COLON] = ACTIONS(5329),
    [anon_sym_COMMA] = ACTIONS(5329),
    [anon_sym_RBRACK] = ACTIONS(5329),
    [anon_sym_LPAREN] = ACTIONS(5329),
    [anon_sym_RPAREN] = ACTIONS(5329),
    [anon_sym_RBRACE] = ACTIONS(5329),
    [anon_sym_LT] = ACTIONS(5331),
    [anon_sym_GT] = ACTIONS(5331),
    [anon_sym_in] = ACTIONS(5329),
    [anon_sym_where] = ACTIONS(5329),
    [anon_sym_QMARK] = ACTIONS(5331),
    [anon_sym_BANG] = ACTIONS(5331),
    [anon_sym_PLUS_PLUS] = ACTIONS(5329),
    [anon_sym_DASH_DASH] = ACTIONS(5329),
    [anon_sym_PLUS] = ACTIONS(5331),
    [anon_sym_DASH] = ACTIONS(5331),
    [anon_sym_STAR] = ACTIONS(5329),
    [anon_sym_SLASH] = ACTIONS(5331),
    [anon_sym_PERCENT] = ACTIONS(5329),
    [anon_sym_CARET] = ACTIONS(5329),
    [anon_sym_PIPE] = ACTIONS(5331),
    [anon_sym_AMP] = ACTIONS(5331),
    [anon_sym_LT_LT] = ACTIONS(5329),
    [anon_sym_GT_GT] = ACTIONS(5331),
    [anon_sym_GT_GT_GT] = ACTIONS(5329),
    [anon_sym_EQ_EQ] = ACTIONS(5329),
    [anon_sym_BANG_EQ] = ACTIONS(5329),
    [anon_sym_GT_EQ] = ACTIONS(5329),
    [anon_sym_LT_EQ] = ACTIONS(5329),
    [anon_sym_DOT] = ACTIONS(5331),
    [anon_sym_EQ_GT] = ACTIONS(5329),
    [anon_sym_switch] = ACTIONS(5329),
    [anon_sym_DOT_DOT] = ACTIONS(5329),
    [anon_sym_and] = ACTIONS(5329),
    [anon_sym_or] = ACTIONS(5331),
    [anon_sym_AMP_AMP] = ACTIONS(5329),
    [anon_sym_PIPE_PIPE] = ACTIONS(5329),
    [anon_sym_QMARK_QMARK] = ACTIONS(5329),
    [anon_sym_from] = ACTIONS(5329),
    [anon_sym_join] = ACTIONS(5329),
    [anon_sym_on] = ACTIONS(5329),
    [anon_sym_equals] = ACTIONS(5329),
    [anon_sym_let] = ACTIONS(5329),
    [anon_sym_orderby] = ACTIONS(5329),
    [anon_sym_group] = ACTIONS(5329),
    [anon_sym_by] = ACTIONS(5329),
    [anon_sym_select] = ACTIONS(5329),
    [anon_sym_as] = ACTIONS(5329),
    [anon_sym_is] = ACTIONS(5329),
    [anon_sym_DASH_GT] = ACTIONS(5329),
    [anon_sym_with] = ACTIONS(5329),
    [aux_sym_preproc_if_token3] = ACTIONS(5329),
    [aux_sym_preproc_else_token1] = ACTIONS(5329),
    [aux_sym_preproc_elif_token1] = ACTIONS(5329),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3765] = {
    [sym_preproc_region] = STATE(3765),
    [sym_preproc_endregion] = STATE(3765),
    [sym_preproc_line] = STATE(3765),
    [sym_preproc_pragma] = STATE(3765),
    [sym_preproc_nullable] = STATE(3765),
    [sym_preproc_error] = STATE(3765),
    [sym_preproc_define] = STATE(3765),
    [sym_preproc_undef] = STATE(3765),
    [anon_sym_SEMI] = ACTIONS(5249),
    [anon_sym_LBRACK] = ACTIONS(5249),
    [anon_sym_COLON] = ACTIONS(5249),
    [anon_sym_COMMA] = ACTIONS(5249),
    [anon_sym_RBRACK] = ACTIONS(5249),
    [anon_sym_LPAREN] = ACTIONS(5249),
    [anon_sym_RPAREN] = ACTIONS(5249),
    [anon_sym_RBRACE] = ACTIONS(5249),
    [anon_sym_LT] = ACTIONS(5251),
    [anon_sym_GT] = ACTIONS(5251),
    [anon_sym_in] = ACTIONS(5249),
    [anon_sym_where] = ACTIONS(5249),
    [anon_sym_QMARK] = ACTIONS(5251),
    [anon_sym_BANG] = ACTIONS(5251),
    [anon_sym_PLUS_PLUS] = ACTIONS(5249),
    [anon_sym_DASH_DASH] = ACTIONS(5249),
    [anon_sym_PLUS] = ACTIONS(5251),
    [anon_sym_DASH] = ACTIONS(5251),
    [anon_sym_STAR] = ACTIONS(5249),
    [anon_sym_SLASH] = ACTIONS(5251),
    [anon_sym_PERCENT] = ACTIONS(5249),
    [anon_sym_CARET] = ACTIONS(5249),
    [anon_sym_PIPE] = ACTIONS(5251),
    [anon_sym_AMP] = ACTIONS(5251),
    [anon_sym_LT_LT] = ACTIONS(5249),
    [anon_sym_GT_GT] = ACTIONS(5251),
    [anon_sym_GT_GT_GT] = ACTIONS(5249),
    [anon_sym_EQ_EQ] = ACTIONS(5249),
    [anon_sym_BANG_EQ] = ACTIONS(5249),
    [anon_sym_GT_EQ] = ACTIONS(5249),
    [anon_sym_LT_EQ] = ACTIONS(5249),
    [anon_sym_DOT] = ACTIONS(5251),
    [anon_sym_EQ_GT] = ACTIONS(5249),
    [anon_sym_switch] = ACTIONS(5249),
    [anon_sym_DOT_DOT] = ACTIONS(5249),
    [anon_sym_and] = ACTIONS(5249),
    [anon_sym_or] = ACTIONS(5251),
    [anon_sym_AMP_AMP] = ACTIONS(5249),
    [anon_sym_PIPE_PIPE] = ACTIONS(5249),
    [anon_sym_QMARK_QMARK] = ACTIONS(5249),
    [anon_sym_from] = ACTIONS(5249),
    [anon_sym_join] = ACTIONS(5249),
    [anon_sym_on] = ACTIONS(5249),
    [anon_sym_equals] = ACTIONS(5249),
    [anon_sym_let] = ACTIONS(5249),
    [anon_sym_orderby] = ACTIONS(5249),
    [anon_sym_group] = ACTIONS(5249),
    [anon_sym_by] = ACTIONS(5249),
    [anon_sym_select] = ACTIONS(5249),
    [anon_sym_as] = ACTIONS(5249),
    [anon_sym_is] = ACTIONS(5249),
    [anon_sym_DASH_GT] = ACTIONS(5249),
    [anon_sym_with] = ACTIONS(5249),
    [aux_sym_preproc_if_token3] = ACTIONS(5249),
    [aux_sym_preproc_else_token1] = ACTIONS(5249),
    [aux_sym_preproc_elif_token1] = ACTIONS(5249),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3766] = {
    [sym_preproc_region] = STATE(3766),
    [sym_preproc_endregion] = STATE(3766),
    [sym_preproc_line] = STATE(3766),
    [sym_preproc_pragma] = STATE(3766),
    [sym_preproc_nullable] = STATE(3766),
    [sym_preproc_error] = STATE(3766),
    [sym_preproc_define] = STATE(3766),
    [sym_preproc_undef] = STATE(3766),
    [sym__identifier_token] = ACTIONS(5637),
    [anon_sym_extern] = ACTIONS(5637),
    [anon_sym_alias] = ACTIONS(5637),
    [anon_sym_global] = ACTIONS(5637),
    [anon_sym_unsafe] = ACTIONS(5637),
    [anon_sym_static] = ACTIONS(5637),
    [anon_sym_LBRACK] = ACTIONS(5639),
    [anon_sym_LPAREN] = ACTIONS(5639),
    [anon_sym_event] = ACTIONS(5637),
    [anon_sym_class] = ACTIONS(5637),
    [anon_sym_ref] = ACTIONS(5637),
    [anon_sym_struct] = ACTIONS(5637),
    [anon_sym_enum] = ACTIONS(5637),
    [anon_sym_interface] = ACTIONS(5637),
    [anon_sym_delegate] = ACTIONS(5637),
    [anon_sym_record] = ACTIONS(5637),
    [anon_sym_abstract] = ACTIONS(5637),
    [anon_sym_async] = ACTIONS(5637),
    [anon_sym_const] = ACTIONS(5637),
    [anon_sym_file] = ACTIONS(5637),
    [anon_sym_fixed] = ACTIONS(5637),
    [anon_sym_internal] = ACTIONS(5637),
    [anon_sym_new] = ACTIONS(5637),
    [anon_sym_override] = ACTIONS(5637),
    [anon_sym_partial] = ACTIONS(5637),
    [anon_sym_private] = ACTIONS(5637),
    [anon_sym_protected] = ACTIONS(5637),
    [anon_sym_public] = ACTIONS(5637),
    [anon_sym_readonly] = ACTIONS(5637),
    [anon_sym_required] = ACTIONS(5637),
    [anon_sym_sealed] = ACTIONS(5637),
    [anon_sym_virtual] = ACTIONS(5637),
    [anon_sym_volatile] = ACTIONS(5637),
    [anon_sym_where] = ACTIONS(5637),
    [anon_sym_notnull] = ACTIONS(5637),
    [anon_sym_unmanaged] = ACTIONS(5637),
    [anon_sym_TILDE] = ACTIONS(5639),
    [anon_sym_implicit] = ACTIONS(5637),
    [anon_sym_explicit] = ACTIONS(5637),
    [anon_sym_scoped] = ACTIONS(5637),
    [anon_sym_var] = ACTIONS(5637),
    [sym_predefined_type] = ACTIONS(5637),
    [anon_sym_yield] = ACTIONS(5637),
    [anon_sym_when] = ACTIONS(5637),
    [anon_sym_from] = ACTIONS(5637),
    [anon_sym_into] = ACTIONS(5637),
    [anon_sym_join] = ACTIONS(5637),
    [anon_sym_on] = ACTIONS(5637),
    [anon_sym_equals] = ACTIONS(5637),
    [anon_sym_let] = ACTIONS(5637),
    [anon_sym_orderby] = ACTIONS(5637),
    [anon_sym_ascending] = ACTIONS(5637),
    [anon_sym_descending] = ACTIONS(5637),
    [anon_sym_group] = ACTIONS(5637),
    [anon_sym_by] = ACTIONS(5637),
    [anon_sym_select] = ACTIONS(5637),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3767] = {
    [sym_preproc_region] = STATE(3767),
    [sym_preproc_endregion] = STATE(3767),
    [sym_preproc_line] = STATE(3767),
    [sym_preproc_pragma] = STATE(3767),
    [sym_preproc_nullable] = STATE(3767),
    [sym_preproc_error] = STATE(3767),
    [sym_preproc_define] = STATE(3767),
    [sym_preproc_undef] = STATE(3767),
    [anon_sym_SEMI] = ACTIONS(5385),
    [anon_sym_LBRACK] = ACTIONS(5385),
    [anon_sym_COLON] = ACTIONS(5385),
    [anon_sym_COMMA] = ACTIONS(5385),
    [anon_sym_RBRACK] = ACTIONS(5385),
    [anon_sym_LPAREN] = ACTIONS(5385),
    [anon_sym_RPAREN] = ACTIONS(5385),
    [anon_sym_RBRACE] = ACTIONS(5385),
    [anon_sym_LT] = ACTIONS(5387),
    [anon_sym_GT] = ACTIONS(5387),
    [anon_sym_in] = ACTIONS(5385),
    [anon_sym_where] = ACTIONS(5385),
    [anon_sym_QMARK] = ACTIONS(5387),
    [anon_sym_BANG] = ACTIONS(5387),
    [anon_sym_PLUS_PLUS] = ACTIONS(5385),
    [anon_sym_DASH_DASH] = ACTIONS(5385),
    [anon_sym_PLUS] = ACTIONS(5387),
    [anon_sym_DASH] = ACTIONS(5387),
    [anon_sym_STAR] = ACTIONS(5385),
    [anon_sym_SLASH] = ACTIONS(5387),
    [anon_sym_PERCENT] = ACTIONS(5385),
    [anon_sym_CARET] = ACTIONS(5385),
    [anon_sym_PIPE] = ACTIONS(5387),
    [anon_sym_AMP] = ACTIONS(5387),
    [anon_sym_LT_LT] = ACTIONS(5385),
    [anon_sym_GT_GT] = ACTIONS(5387),
    [anon_sym_GT_GT_GT] = ACTIONS(5385),
    [anon_sym_EQ_EQ] = ACTIONS(5385),
    [anon_sym_BANG_EQ] = ACTIONS(5385),
    [anon_sym_GT_EQ] = ACTIONS(5385),
    [anon_sym_LT_EQ] = ACTIONS(5385),
    [anon_sym_DOT] = ACTIONS(5387),
    [anon_sym_EQ_GT] = ACTIONS(5385),
    [anon_sym_switch] = ACTIONS(5385),
    [anon_sym_DOT_DOT] = ACTIONS(5385),
    [anon_sym_and] = ACTIONS(5385),
    [anon_sym_or] = ACTIONS(5387),
    [anon_sym_AMP_AMP] = ACTIONS(5385),
    [anon_sym_PIPE_PIPE] = ACTIONS(5385),
    [anon_sym_QMARK_QMARK] = ACTIONS(5385),
    [anon_sym_from] = ACTIONS(5385),
    [anon_sym_join] = ACTIONS(5385),
    [anon_sym_on] = ACTIONS(5385),
    [anon_sym_equals] = ACTIONS(5385),
    [anon_sym_let] = ACTIONS(5385),
    [anon_sym_orderby] = ACTIONS(5385),
    [anon_sym_group] = ACTIONS(5385),
    [anon_sym_by] = ACTIONS(5385),
    [anon_sym_select] = ACTIONS(5385),
    [anon_sym_as] = ACTIONS(5385),
    [anon_sym_is] = ACTIONS(5385),
    [anon_sym_DASH_GT] = ACTIONS(5385),
    [anon_sym_with] = ACTIONS(5385),
    [aux_sym_preproc_if_token3] = ACTIONS(5385),
    [aux_sym_preproc_else_token1] = ACTIONS(5385),
    [aux_sym_preproc_elif_token1] = ACTIONS(5385),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3768] = {
    [sym_preproc_region] = STATE(3768),
    [sym_preproc_endregion] = STATE(3768),
    [sym_preproc_line] = STATE(3768),
    [sym_preproc_pragma] = STATE(3768),
    [sym_preproc_nullable] = STATE(3768),
    [sym_preproc_error] = STATE(3768),
    [sym_preproc_define] = STATE(3768),
    [sym_preproc_undef] = STATE(3768),
    [anon_sym_SEMI] = ACTIONS(4428),
    [anon_sym_LBRACK] = ACTIONS(4428),
    [anon_sym_COMMA] = ACTIONS(4428),
    [anon_sym_RBRACK] = ACTIONS(4428),
    [anon_sym_LPAREN] = ACTIONS(4428),
    [anon_sym_RPAREN] = ACTIONS(4428),
    [anon_sym_LBRACE] = ACTIONS(4428),
    [anon_sym_RBRACE] = ACTIONS(4428),
    [anon_sym_LT] = ACTIONS(4426),
    [anon_sym_GT] = ACTIONS(4426),
    [anon_sym_in] = ACTIONS(4428),
    [anon_sym_where] = ACTIONS(4428),
    [anon_sym_QMARK] = ACTIONS(4426),
    [anon_sym_BANG] = ACTIONS(4426),
    [anon_sym_PLUS_PLUS] = ACTIONS(4428),
    [anon_sym_DASH_DASH] = ACTIONS(4428),
    [anon_sym_PLUS] = ACTIONS(4426),
    [anon_sym_DASH] = ACTIONS(4426),
    [anon_sym_STAR] = ACTIONS(4428),
    [anon_sym_SLASH] = ACTIONS(4426),
    [anon_sym_PERCENT] = ACTIONS(4428),
    [anon_sym_CARET] = ACTIONS(4428),
    [anon_sym_PIPE] = ACTIONS(4426),
    [anon_sym_AMP] = ACTIONS(4426),
    [anon_sym_LT_LT] = ACTIONS(4428),
    [anon_sym_GT_GT] = ACTIONS(4426),
    [anon_sym_GT_GT_GT] = ACTIONS(4428),
    [anon_sym_EQ_EQ] = ACTIONS(4428),
    [anon_sym_BANG_EQ] = ACTIONS(4428),
    [anon_sym_GT_EQ] = ACTIONS(4428),
    [anon_sym_LT_EQ] = ACTIONS(4428),
    [anon_sym_DOT] = ACTIONS(5641),
    [anon_sym_EQ_GT] = ACTIONS(4428),
    [anon_sym_switch] = ACTIONS(4428),
    [anon_sym_DOT_DOT] = ACTIONS(4428),
    [anon_sym_and] = ACTIONS(4428),
    [anon_sym_or] = ACTIONS(4426),
    [anon_sym_AMP_AMP] = ACTIONS(4428),
    [anon_sym_PIPE_PIPE] = ACTIONS(4428),
    [anon_sym_QMARK_QMARK] = ACTIONS(4428),
    [anon_sym_from] = ACTIONS(4428),
    [anon_sym_join] = ACTIONS(4428),
    [anon_sym_on] = ACTIONS(4428),
    [anon_sym_equals] = ACTIONS(4428),
    [anon_sym_let] = ACTIONS(4428),
    [anon_sym_orderby] = ACTIONS(4428),
    [anon_sym_group] = ACTIONS(4428),
    [anon_sym_by] = ACTIONS(4428),
    [anon_sym_select] = ACTIONS(4428),
    [anon_sym_as] = ACTIONS(4428),
    [anon_sym_is] = ACTIONS(4428),
    [anon_sym_DASH_GT] = ACTIONS(4428),
    [anon_sym_with] = ACTIONS(4428),
    [aux_sym_preproc_if_token3] = ACTIONS(4428),
    [aux_sym_preproc_else_token1] = ACTIONS(4428),
    [aux_sym_preproc_elif_token1] = ACTIONS(4428),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3769] = {
    [sym_preproc_region] = STATE(3769),
    [sym_preproc_endregion] = STATE(3769),
    [sym_preproc_line] = STATE(3769),
    [sym_preproc_pragma] = STATE(3769),
    [sym_preproc_nullable] = STATE(3769),
    [sym_preproc_error] = STATE(3769),
    [sym_preproc_define] = STATE(3769),
    [sym_preproc_undef] = STATE(3769),
    [anon_sym_SEMI] = ACTIONS(5510),
    [anon_sym_LBRACK] = ACTIONS(5510),
    [anon_sym_COLON] = ACTIONS(5510),
    [anon_sym_COMMA] = ACTIONS(5510),
    [anon_sym_RBRACK] = ACTIONS(5510),
    [anon_sym_LPAREN] = ACTIONS(5510),
    [anon_sym_RPAREN] = ACTIONS(5510),
    [anon_sym_RBRACE] = ACTIONS(5510),
    [anon_sym_LT] = ACTIONS(5512),
    [anon_sym_GT] = ACTIONS(5512),
    [anon_sym_in] = ACTIONS(5510),
    [anon_sym_where] = ACTIONS(5510),
    [anon_sym_QMARK] = ACTIONS(5512),
    [anon_sym_BANG] = ACTIONS(5512),
    [anon_sym_PLUS_PLUS] = ACTIONS(5510),
    [anon_sym_DASH_DASH] = ACTIONS(5510),
    [anon_sym_PLUS] = ACTIONS(5512),
    [anon_sym_DASH] = ACTIONS(5512),
    [anon_sym_STAR] = ACTIONS(5510),
    [anon_sym_SLASH] = ACTIONS(5512),
    [anon_sym_PERCENT] = ACTIONS(5510),
    [anon_sym_CARET] = ACTIONS(5510),
    [anon_sym_PIPE] = ACTIONS(5512),
    [anon_sym_AMP] = ACTIONS(5512),
    [anon_sym_LT_LT] = ACTIONS(5510),
    [anon_sym_GT_GT] = ACTIONS(5512),
    [anon_sym_GT_GT_GT] = ACTIONS(5510),
    [anon_sym_EQ_EQ] = ACTIONS(5510),
    [anon_sym_BANG_EQ] = ACTIONS(5510),
    [anon_sym_GT_EQ] = ACTIONS(5510),
    [anon_sym_LT_EQ] = ACTIONS(5510),
    [anon_sym_DOT] = ACTIONS(5512),
    [anon_sym_EQ_GT] = ACTIONS(5510),
    [anon_sym_switch] = ACTIONS(5510),
    [anon_sym_DOT_DOT] = ACTIONS(5510),
    [anon_sym_and] = ACTIONS(5510),
    [anon_sym_or] = ACTIONS(5512),
    [anon_sym_AMP_AMP] = ACTIONS(5510),
    [anon_sym_PIPE_PIPE] = ACTIONS(5510),
    [anon_sym_QMARK_QMARK] = ACTIONS(5510),
    [anon_sym_from] = ACTIONS(5510),
    [anon_sym_join] = ACTIONS(5510),
    [anon_sym_on] = ACTIONS(5510),
    [anon_sym_equals] = ACTIONS(5510),
    [anon_sym_let] = ACTIONS(5510),
    [anon_sym_orderby] = ACTIONS(5510),
    [anon_sym_group] = ACTIONS(5510),
    [anon_sym_by] = ACTIONS(5510),
    [anon_sym_select] = ACTIONS(5510),
    [anon_sym_as] = ACTIONS(5510),
    [anon_sym_is] = ACTIONS(5510),
    [anon_sym_DASH_GT] = ACTIONS(5510),
    [anon_sym_with] = ACTIONS(5510),
    [aux_sym_preproc_if_token3] = ACTIONS(5510),
    [aux_sym_preproc_else_token1] = ACTIONS(5510),
    [aux_sym_preproc_elif_token1] = ACTIONS(5510),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3770] = {
    [sym_preproc_region] = STATE(3770),
    [sym_preproc_endregion] = STATE(3770),
    [sym_preproc_line] = STATE(3770),
    [sym_preproc_pragma] = STATE(3770),
    [sym_preproc_nullable] = STATE(3770),
    [sym_preproc_error] = STATE(3770),
    [sym_preproc_define] = STATE(3770),
    [sym_preproc_undef] = STATE(3770),
    [anon_sym_SEMI] = ACTIONS(4424),
    [anon_sym_LBRACK] = ACTIONS(4547),
    [anon_sym_COMMA] = ACTIONS(4424),
    [anon_sym_RBRACK] = ACTIONS(4424),
    [anon_sym_LPAREN] = ACTIONS(4424),
    [anon_sym_RPAREN] = ACTIONS(4424),
    [anon_sym_LBRACE] = ACTIONS(4424),
    [anon_sym_RBRACE] = ACTIONS(4424),
    [anon_sym_LT] = ACTIONS(4422),
    [anon_sym_GT] = ACTIONS(4422),
    [anon_sym_in] = ACTIONS(4424),
    [anon_sym_where] = ACTIONS(4424),
    [anon_sym_QMARK] = ACTIONS(5389),
    [anon_sym_BANG] = ACTIONS(4422),
    [anon_sym_PLUS_PLUS] = ACTIONS(4424),
    [anon_sym_DASH_DASH] = ACTIONS(4424),
    [anon_sym_PLUS] = ACTIONS(4422),
    [anon_sym_DASH] = ACTIONS(4422),
    [anon_sym_STAR] = ACTIONS(4553),
    [anon_sym_SLASH] = ACTIONS(4422),
    [anon_sym_PERCENT] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4424),
    [anon_sym_PIPE] = ACTIONS(4422),
    [anon_sym_AMP] = ACTIONS(4422),
    [anon_sym_LT_LT] = ACTIONS(4424),
    [anon_sym_GT_GT] = ACTIONS(4422),
    [anon_sym_GT_GT_GT] = ACTIONS(4424),
    [anon_sym_EQ_EQ] = ACTIONS(4424),
    [anon_sym_BANG_EQ] = ACTIONS(4424),
    [anon_sym_GT_EQ] = ACTIONS(4424),
    [anon_sym_LT_EQ] = ACTIONS(4424),
    [anon_sym_DOT] = ACTIONS(5641),
    [anon_sym_EQ_GT] = ACTIONS(4424),
    [anon_sym_switch] = ACTIONS(4424),
    [anon_sym_DOT_DOT] = ACTIONS(4424),
    [anon_sym_and] = ACTIONS(4424),
    [anon_sym_or] = ACTIONS(4422),
    [anon_sym_AMP_AMP] = ACTIONS(4424),
    [anon_sym_PIPE_PIPE] = ACTIONS(4424),
    [anon_sym_QMARK_QMARK] = ACTIONS(4424),
    [anon_sym_from] = ACTIONS(4424),
    [anon_sym_join] = ACTIONS(4424),
    [anon_sym_on] = ACTIONS(4424),
    [anon_sym_equals] = ACTIONS(4424),
    [anon_sym_let] = ACTIONS(4424),
    [anon_sym_orderby] = ACTIONS(4424),
    [anon_sym_group] = ACTIONS(4424),
    [anon_sym_by] = ACTIONS(4424),
    [anon_sym_select] = ACTIONS(4424),
    [anon_sym_as] = ACTIONS(4424),
    [anon_sym_is] = ACTIONS(4424),
    [anon_sym_DASH_GT] = ACTIONS(4424),
    [anon_sym_with] = ACTIONS(4424),
    [aux_sym_preproc_if_token3] = ACTIONS(4424),
    [aux_sym_preproc_else_token1] = ACTIONS(4424),
    [aux_sym_preproc_elif_token1] = ACTIONS(4424),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3771] = {
    [sym_preproc_region] = STATE(3771),
    [sym_preproc_endregion] = STATE(3771),
    [sym_preproc_line] = STATE(3771),
    [sym_preproc_pragma] = STATE(3771),
    [sym_preproc_nullable] = STATE(3771),
    [sym_preproc_error] = STATE(3771),
    [sym_preproc_define] = STATE(3771),
    [sym_preproc_undef] = STATE(3771),
    [anon_sym_SEMI] = ACTIONS(5502),
    [anon_sym_LBRACK] = ACTIONS(5502),
    [anon_sym_COLON] = ACTIONS(5502),
    [anon_sym_COMMA] = ACTIONS(5502),
    [anon_sym_RBRACK] = ACTIONS(5502),
    [anon_sym_LPAREN] = ACTIONS(5502),
    [anon_sym_RPAREN] = ACTIONS(5502),
    [anon_sym_RBRACE] = ACTIONS(5502),
    [anon_sym_LT] = ACTIONS(5504),
    [anon_sym_GT] = ACTIONS(5504),
    [anon_sym_in] = ACTIONS(5502),
    [anon_sym_where] = ACTIONS(5502),
    [anon_sym_QMARK] = ACTIONS(5504),
    [anon_sym_BANG] = ACTIONS(5504),
    [anon_sym_PLUS_PLUS] = ACTIONS(5502),
    [anon_sym_DASH_DASH] = ACTIONS(5502),
    [anon_sym_PLUS] = ACTIONS(5504),
    [anon_sym_DASH] = ACTIONS(5504),
    [anon_sym_STAR] = ACTIONS(5502),
    [anon_sym_SLASH] = ACTIONS(5504),
    [anon_sym_PERCENT] = ACTIONS(5502),
    [anon_sym_CARET] = ACTIONS(5502),
    [anon_sym_PIPE] = ACTIONS(5504),
    [anon_sym_AMP] = ACTIONS(5504),
    [anon_sym_LT_LT] = ACTIONS(5502),
    [anon_sym_GT_GT] = ACTIONS(5504),
    [anon_sym_GT_GT_GT] = ACTIONS(5502),
    [anon_sym_EQ_EQ] = ACTIONS(5502),
    [anon_sym_BANG_EQ] = ACTIONS(5502),
    [anon_sym_GT_EQ] = ACTIONS(5502),
    [anon_sym_LT_EQ] = ACTIONS(5502),
    [anon_sym_DOT] = ACTIONS(5504),
    [anon_sym_EQ_GT] = ACTIONS(5502),
    [anon_sym_switch] = ACTIONS(5502),
    [anon_sym_DOT_DOT] = ACTIONS(5502),
    [anon_sym_and] = ACTIONS(5502),
    [anon_sym_or] = ACTIONS(5504),
    [anon_sym_AMP_AMP] = ACTIONS(5502),
    [anon_sym_PIPE_PIPE] = ACTIONS(5502),
    [anon_sym_QMARK_QMARK] = ACTIONS(5502),
    [anon_sym_from] = ACTIONS(5502),
    [anon_sym_join] = ACTIONS(5502),
    [anon_sym_on] = ACTIONS(5502),
    [anon_sym_equals] = ACTIONS(5502),
    [anon_sym_let] = ACTIONS(5502),
    [anon_sym_orderby] = ACTIONS(5502),
    [anon_sym_group] = ACTIONS(5502),
    [anon_sym_by] = ACTIONS(5502),
    [anon_sym_select] = ACTIONS(5502),
    [anon_sym_as] = ACTIONS(5502),
    [anon_sym_is] = ACTIONS(5502),
    [anon_sym_DASH_GT] = ACTIONS(5502),
    [anon_sym_with] = ACTIONS(5502),
    [aux_sym_preproc_if_token3] = ACTIONS(5502),
    [aux_sym_preproc_else_token1] = ACTIONS(5502),
    [aux_sym_preproc_elif_token1] = ACTIONS(5502),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3772] = {
    [sym_preproc_region] = STATE(3772),
    [sym_preproc_endregion] = STATE(3772),
    [sym_preproc_line] = STATE(3772),
    [sym_preproc_pragma] = STATE(3772),
    [sym_preproc_nullable] = STATE(3772),
    [sym_preproc_error] = STATE(3772),
    [sym_preproc_define] = STATE(3772),
    [sym_preproc_undef] = STATE(3772),
    [anon_sym_SEMI] = ACTIONS(2927),
    [anon_sym_LBRACK] = ACTIONS(2927),
    [anon_sym_COLON] = ACTIONS(2927),
    [anon_sym_COMMA] = ACTIONS(2927),
    [anon_sym_RBRACK] = ACTIONS(2927),
    [anon_sym_LPAREN] = ACTIONS(2927),
    [anon_sym_RPAREN] = ACTIONS(2927),
    [anon_sym_RBRACE] = ACTIONS(2927),
    [anon_sym_LT] = ACTIONS(2925),
    [anon_sym_GT] = ACTIONS(2925),
    [anon_sym_in] = ACTIONS(2927),
    [anon_sym_where] = ACTIONS(2927),
    [anon_sym_QMARK] = ACTIONS(2925),
    [anon_sym_BANG] = ACTIONS(2925),
    [anon_sym_PLUS_PLUS] = ACTIONS(2927),
    [anon_sym_DASH_DASH] = ACTIONS(2927),
    [anon_sym_PLUS] = ACTIONS(2925),
    [anon_sym_DASH] = ACTIONS(2925),
    [anon_sym_STAR] = ACTIONS(2927),
    [anon_sym_SLASH] = ACTIONS(2925),
    [anon_sym_PERCENT] = ACTIONS(2927),
    [anon_sym_CARET] = ACTIONS(2927),
    [anon_sym_PIPE] = ACTIONS(2925),
    [anon_sym_AMP] = ACTIONS(2925),
    [anon_sym_LT_LT] = ACTIONS(2927),
    [anon_sym_GT_GT] = ACTIONS(2925),
    [anon_sym_GT_GT_GT] = ACTIONS(2927),
    [anon_sym_EQ_EQ] = ACTIONS(2927),
    [anon_sym_BANG_EQ] = ACTIONS(2927),
    [anon_sym_GT_EQ] = ACTIONS(2927),
    [anon_sym_LT_EQ] = ACTIONS(2927),
    [anon_sym_DOT] = ACTIONS(2925),
    [anon_sym_EQ_GT] = ACTIONS(2927),
    [anon_sym_switch] = ACTIONS(2927),
    [anon_sym_DOT_DOT] = ACTIONS(2927),
    [anon_sym_and] = ACTIONS(2927),
    [anon_sym_or] = ACTIONS(2925),
    [anon_sym_AMP_AMP] = ACTIONS(2927),
    [anon_sym_PIPE_PIPE] = ACTIONS(2927),
    [anon_sym_QMARK_QMARK] = ACTIONS(2927),
    [anon_sym_from] = ACTIONS(2927),
    [anon_sym_join] = ACTIONS(2927),
    [anon_sym_on] = ACTIONS(2927),
    [anon_sym_equals] = ACTIONS(2927),
    [anon_sym_let] = ACTIONS(2927),
    [anon_sym_orderby] = ACTIONS(2927),
    [anon_sym_group] = ACTIONS(2927),
    [anon_sym_by] = ACTIONS(2927),
    [anon_sym_select] = ACTIONS(2927),
    [anon_sym_as] = ACTIONS(2927),
    [anon_sym_is] = ACTIONS(2927),
    [anon_sym_DASH_GT] = ACTIONS(2927),
    [anon_sym_with] = ACTIONS(2927),
    [aux_sym_preproc_if_token3] = ACTIONS(2927),
    [aux_sym_preproc_else_token1] = ACTIONS(2927),
    [aux_sym_preproc_elif_token1] = ACTIONS(2927),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3773] = {
    [sym_preproc_region] = STATE(3773),
    [sym_preproc_endregion] = STATE(3773),
    [sym_preproc_line] = STATE(3773),
    [sym_preproc_pragma] = STATE(3773),
    [sym_preproc_nullable] = STATE(3773),
    [sym_preproc_error] = STATE(3773),
    [sym_preproc_define] = STATE(3773),
    [sym_preproc_undef] = STATE(3773),
    [anon_sym_SEMI] = ACTIONS(5490),
    [anon_sym_LBRACK] = ACTIONS(5490),
    [anon_sym_COLON] = ACTIONS(5490),
    [anon_sym_COMMA] = ACTIONS(5490),
    [anon_sym_RBRACK] = ACTIONS(5490),
    [anon_sym_LPAREN] = ACTIONS(5490),
    [anon_sym_RPAREN] = ACTIONS(5490),
    [anon_sym_RBRACE] = ACTIONS(5490),
    [anon_sym_LT] = ACTIONS(5492),
    [anon_sym_GT] = ACTIONS(5492),
    [anon_sym_in] = ACTIONS(5490),
    [anon_sym_where] = ACTIONS(5490),
    [anon_sym_QMARK] = ACTIONS(5492),
    [anon_sym_BANG] = ACTIONS(5492),
    [anon_sym_PLUS_PLUS] = ACTIONS(5490),
    [anon_sym_DASH_DASH] = ACTIONS(5490),
    [anon_sym_PLUS] = ACTIONS(5492),
    [anon_sym_DASH] = ACTIONS(5492),
    [anon_sym_STAR] = ACTIONS(5490),
    [anon_sym_SLASH] = ACTIONS(5492),
    [anon_sym_PERCENT] = ACTIONS(5490),
    [anon_sym_CARET] = ACTIONS(5490),
    [anon_sym_PIPE] = ACTIONS(5492),
    [anon_sym_AMP] = ACTIONS(5492),
    [anon_sym_LT_LT] = ACTIONS(5490),
    [anon_sym_GT_GT] = ACTIONS(5492),
    [anon_sym_GT_GT_GT] = ACTIONS(5490),
    [anon_sym_EQ_EQ] = ACTIONS(5490),
    [anon_sym_BANG_EQ] = ACTIONS(5490),
    [anon_sym_GT_EQ] = ACTIONS(5490),
    [anon_sym_LT_EQ] = ACTIONS(5490),
    [anon_sym_DOT] = ACTIONS(5492),
    [anon_sym_EQ_GT] = ACTIONS(5490),
    [anon_sym_switch] = ACTIONS(5490),
    [anon_sym_DOT_DOT] = ACTIONS(5490),
    [anon_sym_and] = ACTIONS(5490),
    [anon_sym_or] = ACTIONS(5492),
    [anon_sym_AMP_AMP] = ACTIONS(5490),
    [anon_sym_PIPE_PIPE] = ACTIONS(5490),
    [anon_sym_QMARK_QMARK] = ACTIONS(5490),
    [anon_sym_from] = ACTIONS(5490),
    [anon_sym_join] = ACTIONS(5490),
    [anon_sym_on] = ACTIONS(5490),
    [anon_sym_equals] = ACTIONS(5490),
    [anon_sym_let] = ACTIONS(5490),
    [anon_sym_orderby] = ACTIONS(5490),
    [anon_sym_group] = ACTIONS(5490),
    [anon_sym_by] = ACTIONS(5490),
    [anon_sym_select] = ACTIONS(5490),
    [anon_sym_as] = ACTIONS(5490),
    [anon_sym_is] = ACTIONS(5490),
    [anon_sym_DASH_GT] = ACTIONS(5490),
    [anon_sym_with] = ACTIONS(5490),
    [aux_sym_preproc_if_token3] = ACTIONS(5490),
    [aux_sym_preproc_else_token1] = ACTIONS(5490),
    [aux_sym_preproc_elif_token1] = ACTIONS(5490),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3774] = {
    [sym_preproc_region] = STATE(3774),
    [sym_preproc_endregion] = STATE(3774),
    [sym_preproc_line] = STATE(3774),
    [sym_preproc_pragma] = STATE(3774),
    [sym_preproc_nullable] = STATE(3774),
    [sym_preproc_error] = STATE(3774),
    [sym_preproc_define] = STATE(3774),
    [sym_preproc_undef] = STATE(3774),
    [anon_sym_SEMI] = ACTIONS(5478),
    [anon_sym_LBRACK] = ACTIONS(5478),
    [anon_sym_COLON] = ACTIONS(5478),
    [anon_sym_COMMA] = ACTIONS(5478),
    [anon_sym_RBRACK] = ACTIONS(5478),
    [anon_sym_LPAREN] = ACTIONS(5478),
    [anon_sym_RPAREN] = ACTIONS(5478),
    [anon_sym_RBRACE] = ACTIONS(5478),
    [anon_sym_LT] = ACTIONS(5480),
    [anon_sym_GT] = ACTIONS(5480),
    [anon_sym_in] = ACTIONS(5478),
    [anon_sym_where] = ACTIONS(5478),
    [anon_sym_QMARK] = ACTIONS(5480),
    [anon_sym_BANG] = ACTIONS(5480),
    [anon_sym_PLUS_PLUS] = ACTIONS(5478),
    [anon_sym_DASH_DASH] = ACTIONS(5478),
    [anon_sym_PLUS] = ACTIONS(5480),
    [anon_sym_DASH] = ACTIONS(5480),
    [anon_sym_STAR] = ACTIONS(5478),
    [anon_sym_SLASH] = ACTIONS(5480),
    [anon_sym_PERCENT] = ACTIONS(5478),
    [anon_sym_CARET] = ACTIONS(5478),
    [anon_sym_PIPE] = ACTIONS(5480),
    [anon_sym_AMP] = ACTIONS(5480),
    [anon_sym_LT_LT] = ACTIONS(5478),
    [anon_sym_GT_GT] = ACTIONS(5480),
    [anon_sym_GT_GT_GT] = ACTIONS(5478),
    [anon_sym_EQ_EQ] = ACTIONS(5478),
    [anon_sym_BANG_EQ] = ACTIONS(5478),
    [anon_sym_GT_EQ] = ACTIONS(5478),
    [anon_sym_LT_EQ] = ACTIONS(5478),
    [anon_sym_DOT] = ACTIONS(5480),
    [anon_sym_EQ_GT] = ACTIONS(5478),
    [anon_sym_switch] = ACTIONS(5478),
    [anon_sym_DOT_DOT] = ACTIONS(5478),
    [anon_sym_and] = ACTIONS(5478),
    [anon_sym_or] = ACTIONS(5480),
    [anon_sym_AMP_AMP] = ACTIONS(5478),
    [anon_sym_PIPE_PIPE] = ACTIONS(5478),
    [anon_sym_QMARK_QMARK] = ACTIONS(5478),
    [anon_sym_from] = ACTIONS(5478),
    [anon_sym_join] = ACTIONS(5478),
    [anon_sym_on] = ACTIONS(5478),
    [anon_sym_equals] = ACTIONS(5478),
    [anon_sym_let] = ACTIONS(5478),
    [anon_sym_orderby] = ACTIONS(5478),
    [anon_sym_group] = ACTIONS(5478),
    [anon_sym_by] = ACTIONS(5478),
    [anon_sym_select] = ACTIONS(5478),
    [anon_sym_as] = ACTIONS(5478),
    [anon_sym_is] = ACTIONS(5478),
    [anon_sym_DASH_GT] = ACTIONS(5478),
    [anon_sym_with] = ACTIONS(5478),
    [aux_sym_preproc_if_token3] = ACTIONS(5478),
    [aux_sym_preproc_else_token1] = ACTIONS(5478),
    [aux_sym_preproc_elif_token1] = ACTIONS(5478),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3775] = {
    [sym_preproc_region] = STATE(3775),
    [sym_preproc_endregion] = STATE(3775),
    [sym_preproc_line] = STATE(3775),
    [sym_preproc_pragma] = STATE(3775),
    [sym_preproc_nullable] = STATE(3775),
    [sym_preproc_error] = STATE(3775),
    [sym_preproc_define] = STATE(3775),
    [sym_preproc_undef] = STATE(3775),
    [anon_sym_EQ] = ACTIONS(4118),
    [anon_sym_LBRACK] = ACTIONS(4133),
    [anon_sym_COLON] = ACTIONS(4133),
    [anon_sym_COMMA] = ACTIONS(4741),
    [anon_sym_RBRACK] = ACTIONS(4741),
    [anon_sym_LPAREN] = ACTIONS(4133),
    [anon_sym_RPAREN] = ACTIONS(4741),
    [anon_sym_RBRACE] = ACTIONS(4741),
    [anon_sym_LT] = ACTIONS(4118),
    [anon_sym_GT] = ACTIONS(4118),
    [anon_sym_QMARK] = ACTIONS(4118),
    [anon_sym_BANG] = ACTIONS(4118),
    [anon_sym_PLUS_PLUS] = ACTIONS(4133),
    [anon_sym_DASH_DASH] = ACTIONS(4133),
    [anon_sym_PLUS] = ACTIONS(4118),
    [anon_sym_DASH] = ACTIONS(4118),
    [anon_sym_STAR] = ACTIONS(4118),
    [anon_sym_SLASH] = ACTIONS(4118),
    [anon_sym_PERCENT] = ACTIONS(4118),
    [anon_sym_CARET] = ACTIONS(4118),
    [anon_sym_PIPE] = ACTIONS(4118),
    [anon_sym_AMP] = ACTIONS(4118),
    [anon_sym_LT_LT] = ACTIONS(4118),
    [anon_sym_GT_GT] = ACTIONS(4118),
    [anon_sym_GT_GT_GT] = ACTIONS(4118),
    [anon_sym_EQ_EQ] = ACTIONS(4133),
    [anon_sym_BANG_EQ] = ACTIONS(4133),
    [anon_sym_GT_EQ] = ACTIONS(4133),
    [anon_sym_LT_EQ] = ACTIONS(4133),
    [anon_sym_DOT] = ACTIONS(4118),
    [anon_sym_EQ_GT] = ACTIONS(4739),
    [anon_sym_switch] = ACTIONS(4133),
    [anon_sym_when] = ACTIONS(4739),
    [anon_sym_DOT_DOT] = ACTIONS(4133),
    [anon_sym_and] = ACTIONS(4739),
    [anon_sym_or] = ACTIONS(4739),
    [anon_sym_PLUS_EQ] = ACTIONS(4133),
    [anon_sym_DASH_EQ] = ACTIONS(4133),
    [anon_sym_STAR_EQ] = ACTIONS(4133),
    [anon_sym_SLASH_EQ] = ACTIONS(4133),
    [anon_sym_PERCENT_EQ] = ACTIONS(4133),
    [anon_sym_AMP_EQ] = ACTIONS(4133),
    [anon_sym_CARET_EQ] = ACTIONS(4133),
    [anon_sym_PIPE_EQ] = ACTIONS(4133),
    [anon_sym_LT_LT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4133),
    [anon_sym_AMP_AMP] = ACTIONS(4133),
    [anon_sym_PIPE_PIPE] = ACTIONS(4133),
    [anon_sym_QMARK_QMARK] = ACTIONS(4118),
    [anon_sym_as] = ACTIONS(4133),
    [anon_sym_is] = ACTIONS(4133),
    [anon_sym_DASH_GT] = ACTIONS(4133),
    [anon_sym_with] = ACTIONS(4133),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3776] = {
    [sym_preproc_region] = STATE(3776),
    [sym_preproc_endregion] = STATE(3776),
    [sym_preproc_line] = STATE(3776),
    [sym_preproc_pragma] = STATE(3776),
    [sym_preproc_nullable] = STATE(3776),
    [sym_preproc_error] = STATE(3776),
    [sym_preproc_define] = STATE(3776),
    [sym_preproc_undef] = STATE(3776),
    [sym__identifier_token] = ACTIONS(3973),
    [anon_sym_extern] = ACTIONS(3976),
    [anon_sym_alias] = ACTIONS(3973),
    [anon_sym_SEMI] = ACTIONS(3719),
    [anon_sym_global] = ACTIONS(3973),
    [anon_sym_unsafe] = ACTIONS(3976),
    [anon_sym_EQ] = ACTIONS(3721),
    [anon_sym_static] = ACTIONS(3976),
    [anon_sym_LBRACK] = ACTIONS(3719),
    [anon_sym_LPAREN] = ACTIONS(3978),
    [anon_sym_ref] = ACTIONS(3976),
    [anon_sym_delegate] = ACTIONS(3976),
    [anon_sym_abstract] = ACTIONS(3976),
    [anon_sym_async] = ACTIONS(3976),
    [anon_sym_const] = ACTIONS(3976),
    [anon_sym_file] = ACTIONS(3973),
    [anon_sym_fixed] = ACTIONS(3976),
    [anon_sym_internal] = ACTIONS(3976),
    [anon_sym_new] = ACTIONS(3976),
    [anon_sym_override] = ACTIONS(3976),
    [anon_sym_partial] = ACTIONS(3976),
    [anon_sym_private] = ACTIONS(3976),
    [anon_sym_protected] = ACTIONS(3976),
    [anon_sym_public] = ACTIONS(3976),
    [anon_sym_readonly] = ACTIONS(3976),
    [anon_sym_required] = ACTIONS(3976),
    [anon_sym_sealed] = ACTIONS(3976),
    [anon_sym_virtual] = ACTIONS(3976),
    [anon_sym_volatile] = ACTIONS(3976),
    [anon_sym_LT] = ACTIONS(3719),
    [anon_sym_where] = ACTIONS(3973),
    [anon_sym_QMARK] = ACTIONS(3719),
    [anon_sym_notnull] = ACTIONS(3973),
    [anon_sym_unmanaged] = ACTIONS(3973),
    [anon_sym_STAR] = ACTIONS(3719),
    [anon_sym_DOT] = ACTIONS(3719),
    [anon_sym_scoped] = ACTIONS(3973),
    [anon_sym_EQ_GT] = ACTIONS(3719),
    [anon_sym_COLON_COLON] = ACTIONS(3719),
    [anon_sym_var] = ACTIONS(3973),
    [sym_predefined_type] = ACTIONS(3976),
    [anon_sym_yield] = ACTIONS(3973),
    [anon_sym_when] = ACTIONS(3973),
    [anon_sym_from] = ACTIONS(3973),
    [anon_sym_into] = ACTIONS(3973),
    [anon_sym_join] = ACTIONS(3973),
    [anon_sym_on] = ACTIONS(3973),
    [anon_sym_equals] = ACTIONS(3973),
    [anon_sym_let] = ACTIONS(3973),
    [anon_sym_orderby] = ACTIONS(3973),
    [anon_sym_ascending] = ACTIONS(3973),
    [anon_sym_descending] = ACTIONS(3973),
    [anon_sym_group] = ACTIONS(3973),
    [anon_sym_by] = ACTIONS(3973),
    [anon_sym_select] = ACTIONS(3973),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3777] = {
    [sym_preproc_region] = STATE(3777),
    [sym_preproc_endregion] = STATE(3777),
    [sym_preproc_line] = STATE(3777),
    [sym_preproc_pragma] = STATE(3777),
    [sym_preproc_nullable] = STATE(3777),
    [sym_preproc_error] = STATE(3777),
    [sym_preproc_define] = STATE(3777),
    [sym_preproc_undef] = STATE(3777),
    [anon_sym_EQ] = ACTIONS(5643),
    [anon_sym_LBRACK] = ACTIONS(5249),
    [anon_sym_LPAREN] = ACTIONS(5249),
    [anon_sym_LT] = ACTIONS(5251),
    [anon_sym_GT] = ACTIONS(5251),
    [anon_sym_where] = ACTIONS(5249),
    [anon_sym_QMARK] = ACTIONS(5251),
    [anon_sym_BANG] = ACTIONS(5251),
    [anon_sym_PLUS_PLUS] = ACTIONS(5249),
    [anon_sym_DASH_DASH] = ACTIONS(5249),
    [anon_sym_PLUS] = ACTIONS(5251),
    [anon_sym_DASH] = ACTIONS(5251),
    [anon_sym_STAR] = ACTIONS(5251),
    [anon_sym_SLASH] = ACTIONS(5251),
    [anon_sym_PERCENT] = ACTIONS(5251),
    [anon_sym_CARET] = ACTIONS(5251),
    [anon_sym_PIPE] = ACTIONS(5251),
    [anon_sym_AMP] = ACTIONS(5251),
    [anon_sym_LT_LT] = ACTIONS(5251),
    [anon_sym_GT_GT] = ACTIONS(5251),
    [anon_sym_GT_GT_GT] = ACTIONS(5251),
    [anon_sym_EQ_EQ] = ACTIONS(5249),
    [anon_sym_BANG_EQ] = ACTIONS(5249),
    [anon_sym_GT_EQ] = ACTIONS(5249),
    [anon_sym_LT_EQ] = ACTIONS(5249),
    [anon_sym_DOT] = ACTIONS(5251),
    [anon_sym_switch] = ACTIONS(5249),
    [anon_sym_DOT_DOT] = ACTIONS(5249),
    [anon_sym_and] = ACTIONS(5249),
    [anon_sym_or] = ACTIONS(5251),
    [anon_sym_PLUS_EQ] = ACTIONS(5645),
    [anon_sym_DASH_EQ] = ACTIONS(5645),
    [anon_sym_STAR_EQ] = ACTIONS(5645),
    [anon_sym_SLASH_EQ] = ACTIONS(5645),
    [anon_sym_PERCENT_EQ] = ACTIONS(5645),
    [anon_sym_AMP_EQ] = ACTIONS(5645),
    [anon_sym_CARET_EQ] = ACTIONS(5645),
    [anon_sym_PIPE_EQ] = ACTIONS(5645),
    [anon_sym_LT_LT_EQ] = ACTIONS(5645),
    [anon_sym_GT_GT_EQ] = ACTIONS(5645),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5645),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(5645),
    [anon_sym_AMP_AMP] = ACTIONS(5249),
    [anon_sym_PIPE_PIPE] = ACTIONS(5249),
    [anon_sym_QMARK_QMARK] = ACTIONS(5251),
    [anon_sym_from] = ACTIONS(5249),
    [anon_sym_join] = ACTIONS(5249),
    [anon_sym_let] = ACTIONS(5249),
    [anon_sym_orderby] = ACTIONS(5249),
    [anon_sym_group] = ACTIONS(5249),
    [anon_sym_select] = ACTIONS(5249),
    [anon_sym_as] = ACTIONS(5249),
    [anon_sym_is] = ACTIONS(5249),
    [anon_sym_DASH_GT] = ACTIONS(5249),
    [anon_sym_with] = ACTIONS(5249),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3778] = {
    [sym_preproc_region] = STATE(3778),
    [sym_preproc_endregion] = STATE(3778),
    [sym_preproc_line] = STATE(3778),
    [sym_preproc_pragma] = STATE(3778),
    [sym_preproc_nullable] = STATE(3778),
    [sym_preproc_error] = STATE(3778),
    [sym_preproc_define] = STATE(3778),
    [sym_preproc_undef] = STATE(3778),
    [sym__identifier_token] = ACTIONS(3976),
    [anon_sym_extern] = ACTIONS(3976),
    [anon_sym_alias] = ACTIONS(3976),
    [anon_sym_global] = ACTIONS(3976),
    [anon_sym_unsafe] = ACTIONS(3976),
    [anon_sym_static] = ACTIONS(3976),
    [anon_sym_LPAREN] = ACTIONS(5566),
    [anon_sym_event] = ACTIONS(3976),
    [anon_sym_class] = ACTIONS(3976),
    [anon_sym_ref] = ACTIONS(3976),
    [anon_sym_struct] = ACTIONS(3976),
    [anon_sym_enum] = ACTIONS(3976),
    [anon_sym_interface] = ACTIONS(3976),
    [anon_sym_delegate] = ACTIONS(3976),
    [anon_sym_record] = ACTIONS(3976),
    [anon_sym_abstract] = ACTIONS(3976),
    [anon_sym_async] = ACTIONS(3976),
    [anon_sym_const] = ACTIONS(3976),
    [anon_sym_file] = ACTIONS(3976),
    [anon_sym_fixed] = ACTIONS(3976),
    [anon_sym_internal] = ACTIONS(3976),
    [anon_sym_new] = ACTIONS(3976),
    [anon_sym_override] = ACTIONS(3976),
    [anon_sym_partial] = ACTIONS(3976),
    [anon_sym_private] = ACTIONS(3976),
    [anon_sym_protected] = ACTIONS(3976),
    [anon_sym_public] = ACTIONS(3976),
    [anon_sym_readonly] = ACTIONS(3976),
    [anon_sym_required] = ACTIONS(3976),
    [anon_sym_sealed] = ACTIONS(3976),
    [anon_sym_virtual] = ACTIONS(3976),
    [anon_sym_volatile] = ACTIONS(3976),
    [anon_sym_where] = ACTIONS(3976),
    [anon_sym_notnull] = ACTIONS(3976),
    [anon_sym_unmanaged] = ACTIONS(3976),
    [anon_sym_TILDE] = ACTIONS(5647),
    [anon_sym_implicit] = ACTIONS(3976),
    [anon_sym_explicit] = ACTIONS(3976),
    [anon_sym_scoped] = ACTIONS(3976),
    [anon_sym_var] = ACTIONS(3976),
    [sym_predefined_type] = ACTIONS(3976),
    [anon_sym_yield] = ACTIONS(3976),
    [anon_sym_when] = ACTIONS(3976),
    [anon_sym_from] = ACTIONS(3976),
    [anon_sym_into] = ACTIONS(3976),
    [anon_sym_join] = ACTIONS(3976),
    [anon_sym_on] = ACTIONS(3976),
    [anon_sym_equals] = ACTIONS(3976),
    [anon_sym_let] = ACTIONS(3976),
    [anon_sym_orderby] = ACTIONS(3976),
    [anon_sym_ascending] = ACTIONS(3976),
    [anon_sym_descending] = ACTIONS(3976),
    [anon_sym_group] = ACTIONS(3976),
    [anon_sym_by] = ACTIONS(3976),
    [anon_sym_select] = ACTIONS(3976),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3779] = {
    [sym_preproc_region] = STATE(3779),
    [sym_preproc_endregion] = STATE(3779),
    [sym_preproc_line] = STATE(3779),
    [sym_preproc_pragma] = STATE(3779),
    [sym_preproc_nullable] = STATE(3779),
    [sym_preproc_error] = STATE(3779),
    [sym_preproc_define] = STATE(3779),
    [sym_preproc_undef] = STATE(3779),
    [sym__identifier_token] = ACTIONS(3976),
    [anon_sym_extern] = ACTIONS(3976),
    [anon_sym_alias] = ACTIONS(3976),
    [anon_sym_global] = ACTIONS(3976),
    [anon_sym_unsafe] = ACTIONS(3976),
    [anon_sym_static] = ACTIONS(3976),
    [anon_sym_LPAREN] = ACTIONS(5566),
    [anon_sym_event] = ACTIONS(3976),
    [anon_sym_class] = ACTIONS(3976),
    [anon_sym_ref] = ACTIONS(3976),
    [anon_sym_struct] = ACTIONS(3976),
    [anon_sym_enum] = ACTIONS(3976),
    [anon_sym_interface] = ACTIONS(3976),
    [anon_sym_delegate] = ACTIONS(3976),
    [anon_sym_record] = ACTIONS(3976),
    [anon_sym_abstract] = ACTIONS(3976),
    [anon_sym_async] = ACTIONS(3976),
    [anon_sym_const] = ACTIONS(3976),
    [anon_sym_file] = ACTIONS(3976),
    [anon_sym_fixed] = ACTIONS(3976),
    [anon_sym_internal] = ACTIONS(3976),
    [anon_sym_new] = ACTIONS(3976),
    [anon_sym_override] = ACTIONS(3976),
    [anon_sym_partial] = ACTIONS(3976),
    [anon_sym_private] = ACTIONS(3976),
    [anon_sym_protected] = ACTIONS(3976),
    [anon_sym_public] = ACTIONS(3976),
    [anon_sym_readonly] = ACTIONS(3976),
    [anon_sym_required] = ACTIONS(3976),
    [anon_sym_sealed] = ACTIONS(3976),
    [anon_sym_virtual] = ACTIONS(3976),
    [anon_sym_volatile] = ACTIONS(3976),
    [anon_sym_where] = ACTIONS(3976),
    [anon_sym_notnull] = ACTIONS(3976),
    [anon_sym_unmanaged] = ACTIONS(3976),
    [anon_sym_TILDE] = ACTIONS(4267),
    [anon_sym_implicit] = ACTIONS(3976),
    [anon_sym_explicit] = ACTIONS(3976),
    [anon_sym_scoped] = ACTIONS(3976),
    [anon_sym_var] = ACTIONS(3976),
    [sym_predefined_type] = ACTIONS(3976),
    [anon_sym_yield] = ACTIONS(3976),
    [anon_sym_when] = ACTIONS(3976),
    [anon_sym_from] = ACTIONS(3976),
    [anon_sym_into] = ACTIONS(3976),
    [anon_sym_join] = ACTIONS(3976),
    [anon_sym_on] = ACTIONS(3976),
    [anon_sym_equals] = ACTIONS(3976),
    [anon_sym_let] = ACTIONS(3976),
    [anon_sym_orderby] = ACTIONS(3976),
    [anon_sym_ascending] = ACTIONS(3976),
    [anon_sym_descending] = ACTIONS(3976),
    [anon_sym_group] = ACTIONS(3976),
    [anon_sym_by] = ACTIONS(3976),
    [anon_sym_select] = ACTIONS(3976),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3780] = {
    [sym_preproc_region] = STATE(3780),
    [sym_preproc_endregion] = STATE(3780),
    [sym_preproc_line] = STATE(3780),
    [sym_preproc_pragma] = STATE(3780),
    [sym_preproc_nullable] = STATE(3780),
    [sym_preproc_error] = STATE(3780),
    [sym_preproc_define] = STATE(3780),
    [sym_preproc_undef] = STATE(3780),
    [sym__identifier_token] = ACTIONS(5649),
    [anon_sym_extern] = ACTIONS(5649),
    [anon_sym_alias] = ACTIONS(5649),
    [anon_sym_global] = ACTIONS(5649),
    [anon_sym_unsafe] = ACTIONS(5649),
    [anon_sym_static] = ACTIONS(5649),
    [anon_sym_LPAREN] = ACTIONS(5651),
    [anon_sym_event] = ACTIONS(5649),
    [anon_sym_class] = ACTIONS(5649),
    [anon_sym_ref] = ACTIONS(5649),
    [anon_sym_struct] = ACTIONS(5649),
    [anon_sym_enum] = ACTIONS(5649),
    [anon_sym_interface] = ACTIONS(5649),
    [anon_sym_delegate] = ACTIONS(5649),
    [anon_sym_record] = ACTIONS(5649),
    [anon_sym_abstract] = ACTIONS(5649),
    [anon_sym_async] = ACTIONS(5649),
    [anon_sym_const] = ACTIONS(5649),
    [anon_sym_file] = ACTIONS(5649),
    [anon_sym_fixed] = ACTIONS(5649),
    [anon_sym_internal] = ACTIONS(5649),
    [anon_sym_new] = ACTIONS(5649),
    [anon_sym_override] = ACTIONS(5649),
    [anon_sym_partial] = ACTIONS(5649),
    [anon_sym_private] = ACTIONS(5649),
    [anon_sym_protected] = ACTIONS(5649),
    [anon_sym_public] = ACTIONS(5649),
    [anon_sym_readonly] = ACTIONS(5649),
    [anon_sym_required] = ACTIONS(5649),
    [anon_sym_sealed] = ACTIONS(5649),
    [anon_sym_virtual] = ACTIONS(5649),
    [anon_sym_volatile] = ACTIONS(5649),
    [anon_sym_where] = ACTIONS(5649),
    [anon_sym_notnull] = ACTIONS(5649),
    [anon_sym_unmanaged] = ACTIONS(5649),
    [anon_sym_implicit] = ACTIONS(5649),
    [anon_sym_explicit] = ACTIONS(5649),
    [anon_sym_scoped] = ACTIONS(5649),
    [anon_sym_var] = ACTIONS(5649),
    [sym_predefined_type] = ACTIONS(5649),
    [anon_sym_yield] = ACTIONS(5649),
    [anon_sym_when] = ACTIONS(5649),
    [anon_sym_from] = ACTIONS(5649),
    [anon_sym_into] = ACTIONS(5649),
    [anon_sym_join] = ACTIONS(5649),
    [anon_sym_on] = ACTIONS(5649),
    [anon_sym_equals] = ACTIONS(5649),
    [anon_sym_let] = ACTIONS(5649),
    [anon_sym_orderby] = ACTIONS(5649),
    [anon_sym_ascending] = ACTIONS(5649),
    [anon_sym_descending] = ACTIONS(5649),
    [anon_sym_group] = ACTIONS(5649),
    [anon_sym_by] = ACTIONS(5649),
    [anon_sym_select] = ACTIONS(5649),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3781] = {
    [sym_attribute_list] = STATE(7261),
    [sym_type_parameter] = STATE(8588),
    [sym__name] = STATE(7762),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(8590),
    [sym_implicit_type] = STATE(8704),
    [sym_array_type] = STATE(8215),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9650),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(8704),
    [sym_scoped_type] = STATE(8704),
    [sym_tuple_type] = STATE(8180),
    [sym_identifier] = STATE(7569),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(3781),
    [sym_preproc_endregion] = STATE(3781),
    [sym_preproc_line] = STATE(3781),
    [sym_preproc_pragma] = STATE(3781),
    [sym_preproc_nullable] = STATE(3781),
    [sym_preproc_error] = STATE(3781),
    [sym_preproc_define] = STATE(3781),
    [sym_preproc_undef] = STATE(3781),
    [aux_sym_class_declaration_repeat1] = STATE(6855),
    [aux_sym_type_argument_list_repeat1] = STATE(8591),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_LBRACK] = ACTIONS(5653),
    [anon_sym_COMMA] = ACTIONS(5655),
    [anon_sym_LPAREN] = ACTIONS(2995),
    [anon_sym_ref] = ACTIONS(5657),
    [anon_sym_delegate] = ACTIONS(5659),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_GT] = ACTIONS(5661),
    [anon_sym_in] = ACTIONS(5663),
    [anon_sym_out] = ACTIONS(5663),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(5665),
    [anon_sym_var] = ACTIONS(5284),
    [sym_predefined_type] = ACTIONS(5667),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3782] = {
    [sym_argument_list] = STATE(3790),
    [sym_initializer_expression] = STATE(3939),
    [sym_preproc_region] = STATE(3782),
    [sym_preproc_endregion] = STATE(3782),
    [sym_preproc_line] = STATE(3782),
    [sym_preproc_pragma] = STATE(3782),
    [sym_preproc_nullable] = STATE(3782),
    [sym_preproc_error] = STATE(3782),
    [sym_preproc_define] = STATE(3782),
    [sym_preproc_undef] = STATE(3782),
    [anon_sym_SEMI] = ACTIONS(5185),
    [anon_sym_LBRACK] = ACTIONS(5185),
    [anon_sym_COLON] = ACTIONS(5185),
    [anon_sym_COMMA] = ACTIONS(5185),
    [anon_sym_RBRACK] = ACTIONS(5185),
    [anon_sym_LPAREN] = ACTIONS(5669),
    [anon_sym_RPAREN] = ACTIONS(5185),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_RBRACE] = ACTIONS(5185),
    [anon_sym_LT] = ACTIONS(5189),
    [anon_sym_GT] = ACTIONS(5189),
    [anon_sym_in] = ACTIONS(5189),
    [anon_sym_QMARK] = ACTIONS(5189),
    [anon_sym_BANG] = ACTIONS(5189),
    [anon_sym_PLUS_PLUS] = ACTIONS(5185),
    [anon_sym_DASH_DASH] = ACTIONS(5185),
    [anon_sym_PLUS] = ACTIONS(5189),
    [anon_sym_DASH] = ACTIONS(5189),
    [anon_sym_STAR] = ACTIONS(5185),
    [anon_sym_SLASH] = ACTIONS(5189),
    [anon_sym_PERCENT] = ACTIONS(5185),
    [anon_sym_CARET] = ACTIONS(5185),
    [anon_sym_PIPE] = ACTIONS(5189),
    [anon_sym_AMP] = ACTIONS(5189),
    [anon_sym_LT_LT] = ACTIONS(5185),
    [anon_sym_GT_GT] = ACTIONS(5189),
    [anon_sym_GT_GT_GT] = ACTIONS(5185),
    [anon_sym_EQ_EQ] = ACTIONS(5185),
    [anon_sym_BANG_EQ] = ACTIONS(5185),
    [anon_sym_GT_EQ] = ACTIONS(5185),
    [anon_sym_LT_EQ] = ACTIONS(5185),
    [anon_sym_DOT] = ACTIONS(5189),
    [anon_sym_EQ_GT] = ACTIONS(5185),
    [anon_sym_switch] = ACTIONS(5185),
    [anon_sym_when] = ACTIONS(5185),
    [anon_sym_DOT_DOT] = ACTIONS(5185),
    [anon_sym_and] = ACTIONS(5185),
    [anon_sym_or] = ACTIONS(5185),
    [anon_sym_AMP_AMP] = ACTIONS(5185),
    [anon_sym_PIPE_PIPE] = ACTIONS(5185),
    [anon_sym_QMARK_QMARK] = ACTIONS(5185),
    [anon_sym_into] = ACTIONS(5185),
    [anon_sym_on] = ACTIONS(5185),
    [anon_sym_equals] = ACTIONS(5185),
    [anon_sym_by] = ACTIONS(5185),
    [anon_sym_as] = ACTIONS(5185),
    [anon_sym_is] = ACTIONS(5185),
    [anon_sym_DASH_GT] = ACTIONS(5185),
    [anon_sym_with] = ACTIONS(5185),
    [aux_sym_preproc_if_token3] = ACTIONS(5185),
    [aux_sym_preproc_else_token1] = ACTIONS(5185),
    [aux_sym_preproc_elif_token1] = ACTIONS(5185),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3783] = {
    [sym_preproc_region] = STATE(3783),
    [sym_preproc_endregion] = STATE(3783),
    [sym_preproc_line] = STATE(3783),
    [sym_preproc_pragma] = STATE(3783),
    [sym_preproc_nullable] = STATE(3783),
    [sym_preproc_error] = STATE(3783),
    [sym_preproc_define] = STATE(3783),
    [sym_preproc_undef] = STATE(3783),
    [anon_sym_EQ] = ACTIONS(4625),
    [anon_sym_LBRACK] = ACTIONS(4639),
    [anon_sym_COLON] = ACTIONS(4639),
    [anon_sym_COMMA] = ACTIONS(4639),
    [anon_sym_LPAREN] = ACTIONS(4639),
    [anon_sym_RPAREN] = ACTIONS(4639),
    [anon_sym_RBRACE] = ACTIONS(4639),
    [anon_sym_LT] = ACTIONS(4641),
    [anon_sym_GT] = ACTIONS(4641),
    [anon_sym_QMARK] = ACTIONS(4641),
    [anon_sym_BANG] = ACTIONS(4641),
    [anon_sym_PLUS_PLUS] = ACTIONS(4639),
    [anon_sym_DASH_DASH] = ACTIONS(4639),
    [anon_sym_PLUS] = ACTIONS(4641),
    [anon_sym_DASH] = ACTIONS(4641),
    [anon_sym_STAR] = ACTIONS(4641),
    [anon_sym_SLASH] = ACTIONS(4641),
    [anon_sym_PERCENT] = ACTIONS(4641),
    [anon_sym_CARET] = ACTIONS(4641),
    [anon_sym_PIPE] = ACTIONS(4641),
    [anon_sym_AMP] = ACTIONS(4641),
    [anon_sym_LT_LT] = ACTIONS(4641),
    [anon_sym_GT_GT] = ACTIONS(4641),
    [anon_sym_GT_GT_GT] = ACTIONS(4641),
    [anon_sym_EQ_EQ] = ACTIONS(4639),
    [anon_sym_BANG_EQ] = ACTIONS(4639),
    [anon_sym_GT_EQ] = ACTIONS(4639),
    [anon_sym_LT_EQ] = ACTIONS(4639),
    [anon_sym_DOT] = ACTIONS(4641),
    [anon_sym_switch] = ACTIONS(4639),
    [anon_sym_when] = ACTIONS(4639),
    [anon_sym_DOT_DOT] = ACTIONS(4639),
    [anon_sym_and] = ACTIONS(4639),
    [anon_sym_or] = ACTIONS(4639),
    [anon_sym_PLUS_EQ] = ACTIONS(4623),
    [anon_sym_DASH_EQ] = ACTIONS(4623),
    [anon_sym_STAR_EQ] = ACTIONS(4623),
    [anon_sym_SLASH_EQ] = ACTIONS(4623),
    [anon_sym_PERCENT_EQ] = ACTIONS(4623),
    [anon_sym_AMP_EQ] = ACTIONS(4623),
    [anon_sym_CARET_EQ] = ACTIONS(4623),
    [anon_sym_PIPE_EQ] = ACTIONS(4623),
    [anon_sym_LT_LT_EQ] = ACTIONS(4623),
    [anon_sym_GT_GT_EQ] = ACTIONS(4623),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4623),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4623),
    [anon_sym_AMP_AMP] = ACTIONS(4639),
    [anon_sym_PIPE_PIPE] = ACTIONS(4639),
    [anon_sym_QMARK_QMARK] = ACTIONS(4641),
    [anon_sym_into] = ACTIONS(4639),
    [anon_sym_as] = ACTIONS(4639),
    [anon_sym_is] = ACTIONS(4639),
    [anon_sym_DASH_GT] = ACTIONS(4639),
    [anon_sym_with] = ACTIONS(4639),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3784] = {
    [sym_attribute_list] = STATE(6703),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7265),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_identifier] = STATE(6714),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(3784),
    [sym_preproc_endregion] = STATE(3784),
    [sym_preproc_line] = STATE(3784),
    [sym_preproc_pragma] = STATE(3784),
    [sym_preproc_nullable] = STATE(3784),
    [sym_preproc_error] = STATE(3784),
    [sym_preproc_define] = STATE(3784),
    [sym_preproc_undef] = STATE(3784),
    [aux_sym_class_declaration_repeat1] = STATE(6230),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4206),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_LBRACK] = ACTIONS(5212),
    [anon_sym_LPAREN] = ACTIONS(2995),
    [anon_sym_ref] = ACTIONS(5216),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_readonly] = ACTIONS(1093),
    [anon_sym_in] = ACTIONS(1093),
    [anon_sym_out] = ACTIONS(1093),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_this] = ACTIONS(1093),
    [anon_sym_scoped] = ACTIONS(5218),
    [anon_sym_params] = ACTIONS(5224),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3785] = {
    [sym_attribute_list] = STATE(4349),
    [sym_modifier] = STATE(4458),
    [sym_identifier] = STATE(7822),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_region] = STATE(3785),
    [sym_preproc_endregion] = STATE(3785),
    [sym_preproc_line] = STATE(3785),
    [sym_preproc_pragma] = STATE(3785),
    [sym_preproc_nullable] = STATE(3785),
    [sym_preproc_error] = STATE(3785),
    [sym_preproc_define] = STATE(3785),
    [sym_preproc_undef] = STATE(3785),
    [aux_sym_class_declaration_repeat1] = STATE(4219),
    [aux_sym_class_declaration_repeat2] = STATE(3979),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(5456),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_unsafe] = ACTIONS(5456),
    [anon_sym_static] = ACTIONS(5456),
    [anon_sym_LBRACK] = ACTIONS(5458),
    [anon_sym_abstract] = ACTIONS(5456),
    [anon_sym_async] = ACTIONS(5456),
    [anon_sym_const] = ACTIONS(5456),
    [anon_sym_file] = ACTIONS(5462),
    [anon_sym_fixed] = ACTIONS(5456),
    [anon_sym_internal] = ACTIONS(5456),
    [anon_sym_new] = ACTIONS(5456),
    [anon_sym_override] = ACTIONS(5456),
    [anon_sym_partial] = ACTIONS(5456),
    [anon_sym_private] = ACTIONS(5456),
    [anon_sym_protected] = ACTIONS(5456),
    [anon_sym_public] = ACTIONS(5456),
    [anon_sym_readonly] = ACTIONS(5456),
    [anon_sym_required] = ACTIONS(5456),
    [anon_sym_sealed] = ACTIONS(5456),
    [anon_sym_virtual] = ACTIONS(5456),
    [anon_sym_volatile] = ACTIONS(5456),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_get] = ACTIONS(5671),
    [anon_sym_set] = ACTIONS(5671),
    [anon_sym_add] = ACTIONS(5671),
    [anon_sym_remove] = ACTIONS(5671),
    [anon_sym_init] = ACTIONS(5671),
    [anon_sym_scoped] = ACTIONS(27),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_from] = ACTIONS(27),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3786] = {
    [sym_preproc_region] = STATE(3786),
    [sym_preproc_endregion] = STATE(3786),
    [sym_preproc_line] = STATE(3786),
    [sym_preproc_pragma] = STATE(3786),
    [sym_preproc_nullable] = STATE(3786),
    [sym_preproc_error] = STATE(3786),
    [sym_preproc_define] = STATE(3786),
    [sym_preproc_undef] = STATE(3786),
    [anon_sym_EQ] = ACTIONS(5673),
    [anon_sym_LBRACK] = ACTIONS(5249),
    [anon_sym_LPAREN] = ACTIONS(5249),
    [anon_sym_LT] = ACTIONS(5251),
    [anon_sym_GT] = ACTIONS(5251),
    [anon_sym_where] = ACTIONS(5249),
    [anon_sym_QMARK] = ACTIONS(5251),
    [anon_sym_BANG] = ACTIONS(5251),
    [anon_sym_PLUS_PLUS] = ACTIONS(5249),
    [anon_sym_DASH_DASH] = ACTIONS(5249),
    [anon_sym_PLUS] = ACTIONS(5251),
    [anon_sym_DASH] = ACTIONS(5251),
    [anon_sym_STAR] = ACTIONS(5251),
    [anon_sym_SLASH] = ACTIONS(5251),
    [anon_sym_PERCENT] = ACTIONS(5251),
    [anon_sym_CARET] = ACTIONS(5251),
    [anon_sym_PIPE] = ACTIONS(5251),
    [anon_sym_AMP] = ACTIONS(5251),
    [anon_sym_LT_LT] = ACTIONS(5251),
    [anon_sym_GT_GT] = ACTIONS(5251),
    [anon_sym_GT_GT_GT] = ACTIONS(5251),
    [anon_sym_EQ_EQ] = ACTIONS(5249),
    [anon_sym_BANG_EQ] = ACTIONS(5249),
    [anon_sym_GT_EQ] = ACTIONS(5249),
    [anon_sym_LT_EQ] = ACTIONS(5249),
    [anon_sym_DOT] = ACTIONS(5251),
    [anon_sym_switch] = ACTIONS(5249),
    [anon_sym_DOT_DOT] = ACTIONS(5249),
    [anon_sym_PLUS_EQ] = ACTIONS(5675),
    [anon_sym_DASH_EQ] = ACTIONS(5675),
    [anon_sym_STAR_EQ] = ACTIONS(5675),
    [anon_sym_SLASH_EQ] = ACTIONS(5675),
    [anon_sym_PERCENT_EQ] = ACTIONS(5675),
    [anon_sym_AMP_EQ] = ACTIONS(5675),
    [anon_sym_CARET_EQ] = ACTIONS(5675),
    [anon_sym_PIPE_EQ] = ACTIONS(5675),
    [anon_sym_LT_LT_EQ] = ACTIONS(5675),
    [anon_sym_GT_GT_EQ] = ACTIONS(5675),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5675),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(5675),
    [anon_sym_AMP_AMP] = ACTIONS(5249),
    [anon_sym_PIPE_PIPE] = ACTIONS(5249),
    [anon_sym_QMARK_QMARK] = ACTIONS(5251),
    [anon_sym_from] = ACTIONS(5249),
    [anon_sym_into] = ACTIONS(5249),
    [anon_sym_join] = ACTIONS(5249),
    [anon_sym_let] = ACTIONS(5249),
    [anon_sym_orderby] = ACTIONS(5249),
    [anon_sym_group] = ACTIONS(5249),
    [anon_sym_select] = ACTIONS(5249),
    [anon_sym_as] = ACTIONS(5249),
    [anon_sym_is] = ACTIONS(5249),
    [anon_sym_DASH_GT] = ACTIONS(5249),
    [anon_sym_with] = ACTIONS(5249),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3787] = {
    [sym_type_argument_list] = STATE(3877),
    [sym_preproc_region] = STATE(3787),
    [sym_preproc_endregion] = STATE(3787),
    [sym_preproc_line] = STATE(3787),
    [sym_preproc_pragma] = STATE(3787),
    [sym_preproc_nullable] = STATE(3787),
    [sym_preproc_error] = STATE(3787),
    [sym_preproc_define] = STATE(3787),
    [sym_preproc_undef] = STATE(3787),
    [anon_sym_SEMI] = ACTIONS(4076),
    [anon_sym_LBRACK] = ACTIONS(4076),
    [anon_sym_COLON] = ACTIONS(4074),
    [anon_sym_COMMA] = ACTIONS(4076),
    [anon_sym_RBRACK] = ACTIONS(4076),
    [anon_sym_LPAREN] = ACTIONS(4076),
    [anon_sym_RPAREN] = ACTIONS(4076),
    [anon_sym_LBRACE] = ACTIONS(4076),
    [anon_sym_RBRACE] = ACTIONS(4076),
    [anon_sym_LT] = ACTIONS(5677),
    [anon_sym_GT] = ACTIONS(4074),
    [anon_sym_in] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(4074),
    [anon_sym_BANG] = ACTIONS(4074),
    [anon_sym_PLUS_PLUS] = ACTIONS(4076),
    [anon_sym_DASH_DASH] = ACTIONS(4076),
    [anon_sym_PLUS] = ACTIONS(4074),
    [anon_sym_DASH] = ACTIONS(4074),
    [anon_sym_STAR] = ACTIONS(4076),
    [anon_sym_SLASH] = ACTIONS(4074),
    [anon_sym_PERCENT] = ACTIONS(4076),
    [anon_sym_CARET] = ACTIONS(4076),
    [anon_sym_PIPE] = ACTIONS(4074),
    [anon_sym_AMP] = ACTIONS(4074),
    [anon_sym_LT_LT] = ACTIONS(4076),
    [anon_sym_GT_GT] = ACTIONS(4074),
    [anon_sym_GT_GT_GT] = ACTIONS(4076),
    [anon_sym_EQ_EQ] = ACTIONS(4076),
    [anon_sym_BANG_EQ] = ACTIONS(4076),
    [anon_sym_GT_EQ] = ACTIONS(4076),
    [anon_sym_LT_EQ] = ACTIONS(4076),
    [anon_sym_DOT] = ACTIONS(4074),
    [anon_sym_EQ_GT] = ACTIONS(4076),
    [anon_sym_COLON_COLON] = ACTIONS(5680),
    [anon_sym_switch] = ACTIONS(4076),
    [anon_sym_when] = ACTIONS(4076),
    [anon_sym_DOT_DOT] = ACTIONS(4076),
    [anon_sym_and] = ACTIONS(4076),
    [anon_sym_or] = ACTIONS(4076),
    [anon_sym_AMP_AMP] = ACTIONS(4076),
    [anon_sym_PIPE_PIPE] = ACTIONS(4076),
    [anon_sym_QMARK_QMARK] = ACTIONS(4076),
    [anon_sym_into] = ACTIONS(4076),
    [anon_sym_on] = ACTIONS(4076),
    [anon_sym_equals] = ACTIONS(4076),
    [anon_sym_by] = ACTIONS(4076),
    [anon_sym_as] = ACTIONS(4076),
    [anon_sym_is] = ACTIONS(4076),
    [anon_sym_DASH_GT] = ACTIONS(4076),
    [anon_sym_with] = ACTIONS(4076),
    [aux_sym_preproc_if_token3] = ACTIONS(4076),
    [aux_sym_preproc_else_token1] = ACTIONS(4076),
    [aux_sym_preproc_elif_token1] = ACTIONS(4076),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3788] = {
    [sym_preproc_region] = STATE(3788),
    [sym_preproc_endregion] = STATE(3788),
    [sym_preproc_line] = STATE(3788),
    [sym_preproc_pragma] = STATE(3788),
    [sym_preproc_nullable] = STATE(3788),
    [sym_preproc_error] = STATE(3788),
    [sym_preproc_define] = STATE(3788),
    [sym_preproc_undef] = STATE(3788),
    [sym__identifier_token] = ACTIONS(3976),
    [anon_sym_extern] = ACTIONS(3976),
    [anon_sym_alias] = ACTIONS(3976),
    [anon_sym_global] = ACTIONS(3976),
    [anon_sym_unsafe] = ACTIONS(3976),
    [anon_sym_static] = ACTIONS(3976),
    [anon_sym_LPAREN] = ACTIONS(5566),
    [anon_sym_event] = ACTIONS(3976),
    [anon_sym_class] = ACTIONS(3976),
    [anon_sym_ref] = ACTIONS(3976),
    [anon_sym_struct] = ACTIONS(3976),
    [anon_sym_enum] = ACTIONS(3976),
    [anon_sym_interface] = ACTIONS(3976),
    [anon_sym_delegate] = ACTIONS(3976),
    [anon_sym_record] = ACTIONS(3976),
    [anon_sym_abstract] = ACTIONS(3976),
    [anon_sym_async] = ACTIONS(3976),
    [anon_sym_const] = ACTIONS(3976),
    [anon_sym_file] = ACTIONS(3976),
    [anon_sym_fixed] = ACTIONS(3976),
    [anon_sym_internal] = ACTIONS(3976),
    [anon_sym_new] = ACTIONS(3976),
    [anon_sym_override] = ACTIONS(3976),
    [anon_sym_partial] = ACTIONS(3976),
    [anon_sym_private] = ACTIONS(3976),
    [anon_sym_protected] = ACTIONS(3976),
    [anon_sym_public] = ACTIONS(3976),
    [anon_sym_readonly] = ACTIONS(3976),
    [anon_sym_required] = ACTIONS(3976),
    [anon_sym_sealed] = ACTIONS(3976),
    [anon_sym_virtual] = ACTIONS(3976),
    [anon_sym_volatile] = ACTIONS(3976),
    [anon_sym_where] = ACTIONS(3976),
    [anon_sym_notnull] = ACTIONS(3976),
    [anon_sym_unmanaged] = ACTIONS(3976),
    [anon_sym_implicit] = ACTIONS(3976),
    [anon_sym_explicit] = ACTIONS(3976),
    [anon_sym_scoped] = ACTIONS(3976),
    [anon_sym_var] = ACTIONS(3976),
    [sym_predefined_type] = ACTIONS(3976),
    [anon_sym_yield] = ACTIONS(3976),
    [anon_sym_when] = ACTIONS(3976),
    [anon_sym_from] = ACTIONS(3976),
    [anon_sym_into] = ACTIONS(3976),
    [anon_sym_join] = ACTIONS(3976),
    [anon_sym_on] = ACTIONS(3976),
    [anon_sym_equals] = ACTIONS(3976),
    [anon_sym_let] = ACTIONS(3976),
    [anon_sym_orderby] = ACTIONS(3976),
    [anon_sym_ascending] = ACTIONS(3976),
    [anon_sym_descending] = ACTIONS(3976),
    [anon_sym_group] = ACTIONS(3976),
    [anon_sym_by] = ACTIONS(3976),
    [anon_sym_select] = ACTIONS(3976),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3789] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7011),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9268),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(3789),
    [sym_preproc_endregion] = STATE(3789),
    [sym_preproc_line] = STATE(3789),
    [sym_preproc_pragma] = STATE(3789),
    [sym_preproc_nullable] = STATE(3789),
    [sym_preproc_error] = STATE(3789),
    [sym_preproc_define] = STATE(3789),
    [sym_preproc_undef] = STATE(3789),
    [aux_sym_class_declaration_repeat1] = STATE(6230),
    [aux_sym_lambda_expression_repeat1] = STATE(4084),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(5212),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3790] = {
    [sym_initializer_expression] = STATE(4060),
    [sym_preproc_region] = STATE(3790),
    [sym_preproc_endregion] = STATE(3790),
    [sym_preproc_line] = STATE(3790),
    [sym_preproc_pragma] = STATE(3790),
    [sym_preproc_nullable] = STATE(3790),
    [sym_preproc_error] = STATE(3790),
    [sym_preproc_define] = STATE(3790),
    [sym_preproc_undef] = STATE(3790),
    [anon_sym_SEMI] = ACTIONS(5205),
    [anon_sym_LBRACK] = ACTIONS(5205),
    [anon_sym_COLON] = ACTIONS(5205),
    [anon_sym_COMMA] = ACTIONS(5205),
    [anon_sym_RBRACK] = ACTIONS(5205),
    [anon_sym_LPAREN] = ACTIONS(5205),
    [anon_sym_RPAREN] = ACTIONS(5205),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_RBRACE] = ACTIONS(5205),
    [anon_sym_LT] = ACTIONS(5207),
    [anon_sym_GT] = ACTIONS(5207),
    [anon_sym_in] = ACTIONS(5207),
    [anon_sym_QMARK] = ACTIONS(5207),
    [anon_sym_BANG] = ACTIONS(5207),
    [anon_sym_PLUS_PLUS] = ACTIONS(5205),
    [anon_sym_DASH_DASH] = ACTIONS(5205),
    [anon_sym_PLUS] = ACTIONS(5207),
    [anon_sym_DASH] = ACTIONS(5207),
    [anon_sym_STAR] = ACTIONS(5205),
    [anon_sym_SLASH] = ACTIONS(5207),
    [anon_sym_PERCENT] = ACTIONS(5205),
    [anon_sym_CARET] = ACTIONS(5205),
    [anon_sym_PIPE] = ACTIONS(5207),
    [anon_sym_AMP] = ACTIONS(5207),
    [anon_sym_LT_LT] = ACTIONS(5205),
    [anon_sym_GT_GT] = ACTIONS(5207),
    [anon_sym_GT_GT_GT] = ACTIONS(5205),
    [anon_sym_EQ_EQ] = ACTIONS(5205),
    [anon_sym_BANG_EQ] = ACTIONS(5205),
    [anon_sym_GT_EQ] = ACTIONS(5205),
    [anon_sym_LT_EQ] = ACTIONS(5205),
    [anon_sym_DOT] = ACTIONS(5207),
    [anon_sym_EQ_GT] = ACTIONS(5205),
    [anon_sym_switch] = ACTIONS(5205),
    [anon_sym_when] = ACTIONS(5205),
    [anon_sym_DOT_DOT] = ACTIONS(5205),
    [anon_sym_and] = ACTIONS(5205),
    [anon_sym_or] = ACTIONS(5205),
    [anon_sym_AMP_AMP] = ACTIONS(5205),
    [anon_sym_PIPE_PIPE] = ACTIONS(5205),
    [anon_sym_QMARK_QMARK] = ACTIONS(5205),
    [anon_sym_into] = ACTIONS(5205),
    [anon_sym_on] = ACTIONS(5205),
    [anon_sym_equals] = ACTIONS(5205),
    [anon_sym_by] = ACTIONS(5205),
    [anon_sym_as] = ACTIONS(5205),
    [anon_sym_is] = ACTIONS(5205),
    [anon_sym_DASH_GT] = ACTIONS(5205),
    [anon_sym_with] = ACTIONS(5205),
    [aux_sym_preproc_if_token3] = ACTIONS(5205),
    [aux_sym_preproc_else_token1] = ACTIONS(5205),
    [aux_sym_preproc_elif_token1] = ACTIONS(5205),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3791] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(6955),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9714),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(3791),
    [sym_preproc_endregion] = STATE(3791),
    [sym_preproc_line] = STATE(3791),
    [sym_preproc_pragma] = STATE(3791),
    [sym_preproc_nullable] = STATE(3791),
    [sym_preproc_error] = STATE(3791),
    [sym_preproc_define] = STATE(3791),
    [sym_preproc_undef] = STATE(3791),
    [aux_sym_class_declaration_repeat1] = STATE(6230),
    [aux_sym_lambda_expression_repeat1] = STATE(4078),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(5212),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3792] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(6924),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9573),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(3792),
    [sym_preproc_endregion] = STATE(3792),
    [sym_preproc_line] = STATE(3792),
    [sym_preproc_pragma] = STATE(3792),
    [sym_preproc_nullable] = STATE(3792),
    [sym_preproc_error] = STATE(3792),
    [sym_preproc_define] = STATE(3792),
    [sym_preproc_undef] = STATE(3792),
    [aux_sym_class_declaration_repeat1] = STATE(6230),
    [aux_sym_lambda_expression_repeat1] = STATE(4068),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(5212),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3793] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(6982),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9399),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(3793),
    [sym_preproc_endregion] = STATE(3793),
    [sym_preproc_line] = STATE(3793),
    [sym_preproc_pragma] = STATE(3793),
    [sym_preproc_nullable] = STATE(3793),
    [sym_preproc_error] = STATE(3793),
    [sym_preproc_define] = STATE(3793),
    [sym_preproc_undef] = STATE(3793),
    [aux_sym_class_declaration_repeat1] = STATE(6230),
    [aux_sym_lambda_expression_repeat1] = STATE(4080),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(5212),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3794] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(6990),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9164),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(3794),
    [sym_preproc_endregion] = STATE(3794),
    [sym_preproc_line] = STATE(3794),
    [sym_preproc_pragma] = STATE(3794),
    [sym_preproc_nullable] = STATE(3794),
    [sym_preproc_error] = STATE(3794),
    [sym_preproc_define] = STATE(3794),
    [sym_preproc_undef] = STATE(3794),
    [aux_sym_class_declaration_repeat1] = STATE(6230),
    [aux_sym_lambda_expression_repeat1] = STATE(4096),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(5212),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3795] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(6935),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9158),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(3795),
    [sym_preproc_endregion] = STATE(3795),
    [sym_preproc_line] = STATE(3795),
    [sym_preproc_pragma] = STATE(3795),
    [sym_preproc_nullable] = STATE(3795),
    [sym_preproc_error] = STATE(3795),
    [sym_preproc_define] = STATE(3795),
    [sym_preproc_undef] = STATE(3795),
    [aux_sym_class_declaration_repeat1] = STATE(6230),
    [aux_sym_lambda_expression_repeat1] = STATE(4153),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(5212),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3796] = {
    [sym_preproc_region] = STATE(3796),
    [sym_preproc_endregion] = STATE(3796),
    [sym_preproc_line] = STATE(3796),
    [sym_preproc_pragma] = STATE(3796),
    [sym_preproc_nullable] = STATE(3796),
    [sym_preproc_error] = STATE(3796),
    [sym_preproc_define] = STATE(3796),
    [sym_preproc_undef] = STATE(3796),
    [anon_sym_EQ] = ACTIONS(5682),
    [anon_sym_LBRACK] = ACTIONS(5249),
    [anon_sym_LPAREN] = ACTIONS(5249),
    [anon_sym_LT] = ACTIONS(5251),
    [anon_sym_GT] = ACTIONS(5251),
    [anon_sym_where] = ACTIONS(5249),
    [anon_sym_QMARK] = ACTIONS(5251),
    [anon_sym_BANG] = ACTIONS(5251),
    [anon_sym_PLUS_PLUS] = ACTIONS(5249),
    [anon_sym_DASH_DASH] = ACTIONS(5249),
    [anon_sym_PLUS] = ACTIONS(5251),
    [anon_sym_DASH] = ACTIONS(5251),
    [anon_sym_STAR] = ACTIONS(5251),
    [anon_sym_SLASH] = ACTIONS(5251),
    [anon_sym_PERCENT] = ACTIONS(5251),
    [anon_sym_CARET] = ACTIONS(5251),
    [anon_sym_PIPE] = ACTIONS(5251),
    [anon_sym_AMP] = ACTIONS(5251),
    [anon_sym_LT_LT] = ACTIONS(5251),
    [anon_sym_GT_GT] = ACTIONS(5251),
    [anon_sym_GT_GT_GT] = ACTIONS(5251),
    [anon_sym_EQ_EQ] = ACTIONS(5249),
    [anon_sym_BANG_EQ] = ACTIONS(5249),
    [anon_sym_GT_EQ] = ACTIONS(5249),
    [anon_sym_LT_EQ] = ACTIONS(5249),
    [anon_sym_DOT] = ACTIONS(5251),
    [anon_sym_switch] = ACTIONS(5249),
    [anon_sym_DOT_DOT] = ACTIONS(5249),
    [anon_sym_PLUS_EQ] = ACTIONS(5684),
    [anon_sym_DASH_EQ] = ACTIONS(5684),
    [anon_sym_STAR_EQ] = ACTIONS(5684),
    [anon_sym_SLASH_EQ] = ACTIONS(5684),
    [anon_sym_PERCENT_EQ] = ACTIONS(5684),
    [anon_sym_AMP_EQ] = ACTIONS(5684),
    [anon_sym_CARET_EQ] = ACTIONS(5684),
    [anon_sym_PIPE_EQ] = ACTIONS(5684),
    [anon_sym_LT_LT_EQ] = ACTIONS(5684),
    [anon_sym_GT_GT_EQ] = ACTIONS(5684),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5684),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(5684),
    [anon_sym_AMP_AMP] = ACTIONS(5249),
    [anon_sym_PIPE_PIPE] = ACTIONS(5249),
    [anon_sym_QMARK_QMARK] = ACTIONS(5251),
    [anon_sym_from] = ACTIONS(5249),
    [anon_sym_join] = ACTIONS(5249),
    [anon_sym_let] = ACTIONS(5249),
    [anon_sym_orderby] = ACTIONS(5249),
    [anon_sym_group] = ACTIONS(5249),
    [anon_sym_select] = ACTIONS(5249),
    [anon_sym_as] = ACTIONS(5249),
    [anon_sym_is] = ACTIONS(5249),
    [anon_sym_DASH_GT] = ACTIONS(5249),
    [anon_sym_with] = ACTIONS(5249),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3797] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(6976),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9251),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(3797),
    [sym_preproc_endregion] = STATE(3797),
    [sym_preproc_line] = STATE(3797),
    [sym_preproc_pragma] = STATE(3797),
    [sym_preproc_nullable] = STATE(3797),
    [sym_preproc_error] = STATE(3797),
    [sym_preproc_define] = STATE(3797),
    [sym_preproc_undef] = STATE(3797),
    [aux_sym_class_declaration_repeat1] = STATE(6230),
    [aux_sym_lambda_expression_repeat1] = STATE(4087),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(5212),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3798] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(6945),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9151),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(3798),
    [sym_preproc_endregion] = STATE(3798),
    [sym_preproc_line] = STATE(3798),
    [sym_preproc_pragma] = STATE(3798),
    [sym_preproc_nullable] = STATE(3798),
    [sym_preproc_error] = STATE(3798),
    [sym_preproc_define] = STATE(3798),
    [sym_preproc_undef] = STATE(3798),
    [aux_sym_class_declaration_repeat1] = STATE(6230),
    [aux_sym_lambda_expression_repeat1] = STATE(4167),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(5212),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3799] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7038),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9283),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(3799),
    [sym_preproc_endregion] = STATE(3799),
    [sym_preproc_line] = STATE(3799),
    [sym_preproc_pragma] = STATE(3799),
    [sym_preproc_nullable] = STATE(3799),
    [sym_preproc_error] = STATE(3799),
    [sym_preproc_define] = STATE(3799),
    [sym_preproc_undef] = STATE(3799),
    [aux_sym_class_declaration_repeat1] = STATE(6230),
    [aux_sym_lambda_expression_repeat1] = STATE(4077),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(5212),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3800] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(6998),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9238),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(3800),
    [sym_preproc_endregion] = STATE(3800),
    [sym_preproc_line] = STATE(3800),
    [sym_preproc_pragma] = STATE(3800),
    [sym_preproc_nullable] = STATE(3800),
    [sym_preproc_error] = STATE(3800),
    [sym_preproc_define] = STATE(3800),
    [sym_preproc_undef] = STATE(3800),
    [aux_sym_class_declaration_repeat1] = STATE(6230),
    [aux_sym_lambda_expression_repeat1] = STATE(4099),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(5212),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3801] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(6949),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9311),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(3801),
    [sym_preproc_endregion] = STATE(3801),
    [sym_preproc_line] = STATE(3801),
    [sym_preproc_pragma] = STATE(3801),
    [sym_preproc_nullable] = STATE(3801),
    [sym_preproc_error] = STATE(3801),
    [sym_preproc_define] = STATE(3801),
    [sym_preproc_undef] = STATE(3801),
    [aux_sym_class_declaration_repeat1] = STATE(6230),
    [aux_sym_lambda_expression_repeat1] = STATE(4109),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(5212),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3802] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7084),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9913),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(3802),
    [sym_preproc_endregion] = STATE(3802),
    [sym_preproc_line] = STATE(3802),
    [sym_preproc_pragma] = STATE(3802),
    [sym_preproc_nullable] = STATE(3802),
    [sym_preproc_error] = STATE(3802),
    [sym_preproc_define] = STATE(3802),
    [sym_preproc_undef] = STATE(3802),
    [aux_sym_class_declaration_repeat1] = STATE(6230),
    [aux_sym_lambda_expression_repeat1] = STATE(4102),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(5212),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3803] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7014),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9229),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(3803),
    [sym_preproc_endregion] = STATE(3803),
    [sym_preproc_line] = STATE(3803),
    [sym_preproc_pragma] = STATE(3803),
    [sym_preproc_nullable] = STATE(3803),
    [sym_preproc_error] = STATE(3803),
    [sym_preproc_define] = STATE(3803),
    [sym_preproc_undef] = STATE(3803),
    [aux_sym_class_declaration_repeat1] = STATE(6230),
    [aux_sym_lambda_expression_repeat1] = STATE(4126),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(5212),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3804] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7110),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9295),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(3804),
    [sym_preproc_endregion] = STATE(3804),
    [sym_preproc_line] = STATE(3804),
    [sym_preproc_pragma] = STATE(3804),
    [sym_preproc_nullable] = STATE(3804),
    [sym_preproc_error] = STATE(3804),
    [sym_preproc_define] = STATE(3804),
    [sym_preproc_undef] = STATE(3804),
    [aux_sym_class_declaration_repeat1] = STATE(6230),
    [aux_sym_lambda_expression_repeat1] = STATE(4111),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(5212),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3805] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7029),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9307),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(3805),
    [sym_preproc_endregion] = STATE(3805),
    [sym_preproc_line] = STATE(3805),
    [sym_preproc_pragma] = STATE(3805),
    [sym_preproc_nullable] = STATE(3805),
    [sym_preproc_error] = STATE(3805),
    [sym_preproc_define] = STATE(3805),
    [sym_preproc_undef] = STATE(3805),
    [aux_sym_class_declaration_repeat1] = STATE(6230),
    [aux_sym_lambda_expression_repeat1] = STATE(4115),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(5212),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3806] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7054),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9081),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(3806),
    [sym_preproc_endregion] = STATE(3806),
    [sym_preproc_line] = STATE(3806),
    [sym_preproc_pragma] = STATE(3806),
    [sym_preproc_nullable] = STATE(3806),
    [sym_preproc_error] = STATE(3806),
    [sym_preproc_define] = STATE(3806),
    [sym_preproc_undef] = STATE(3806),
    [aux_sym_class_declaration_repeat1] = STATE(6230),
    [aux_sym_lambda_expression_repeat1] = STATE(4158),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(5212),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3807] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(6979),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9324),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(3807),
    [sym_preproc_endregion] = STATE(3807),
    [sym_preproc_line] = STATE(3807),
    [sym_preproc_pragma] = STATE(3807),
    [sym_preproc_nullable] = STATE(3807),
    [sym_preproc_error] = STATE(3807),
    [sym_preproc_define] = STATE(3807),
    [sym_preproc_undef] = STATE(3807),
    [aux_sym_class_declaration_repeat1] = STATE(6230),
    [aux_sym_lambda_expression_repeat1] = STATE(4127),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(5212),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3808] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7034),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9218),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(3808),
    [sym_preproc_endregion] = STATE(3808),
    [sym_preproc_line] = STATE(3808),
    [sym_preproc_pragma] = STATE(3808),
    [sym_preproc_nullable] = STATE(3808),
    [sym_preproc_error] = STATE(3808),
    [sym_preproc_define] = STATE(3808),
    [sym_preproc_undef] = STATE(3808),
    [aux_sym_class_declaration_repeat1] = STATE(6230),
    [aux_sym_lambda_expression_repeat1] = STATE(4137),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(5212),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3809] = {
    [sym__name] = STATE(8674),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_identifier] = STATE(5368),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_region] = STATE(3809),
    [sym_preproc_endregion] = STATE(3809),
    [sym_preproc_line] = STATE(3809),
    [sym_preproc_pragma] = STATE(3809),
    [sym_preproc_nullable] = STATE(3809),
    [sym_preproc_error] = STATE(3809),
    [sym_preproc_define] = STATE(3809),
    [sym_preproc_undef] = STATE(3809),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(3976),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_unsafe] = ACTIONS(5686),
    [anon_sym_static] = ACTIONS(3976),
    [anon_sym_LPAREN] = ACTIONS(5566),
    [anon_sym_ref] = ACTIONS(3976),
    [anon_sym_delegate] = ACTIONS(3976),
    [anon_sym_abstract] = ACTIONS(3976),
    [anon_sym_async] = ACTIONS(3976),
    [anon_sym_const] = ACTIONS(3976),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_fixed] = ACTIONS(3976),
    [anon_sym_internal] = ACTIONS(3976),
    [anon_sym_new] = ACTIONS(3976),
    [anon_sym_override] = ACTIONS(3976),
    [anon_sym_partial] = ACTIONS(3976),
    [anon_sym_private] = ACTIONS(3976),
    [anon_sym_protected] = ACTIONS(3976),
    [anon_sym_public] = ACTIONS(3976),
    [anon_sym_readonly] = ACTIONS(3976),
    [anon_sym_required] = ACTIONS(3976),
    [anon_sym_sealed] = ACTIONS(3976),
    [anon_sym_virtual] = ACTIONS(3976),
    [anon_sym_volatile] = ACTIONS(3976),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_scoped] = ACTIONS(27),
    [anon_sym_var] = ACTIONS(27),
    [sym_predefined_type] = ACTIONS(3976),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_from] = ACTIONS(27),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3810] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7093),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9342),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(3810),
    [sym_preproc_endregion] = STATE(3810),
    [sym_preproc_line] = STATE(3810),
    [sym_preproc_pragma] = STATE(3810),
    [sym_preproc_nullable] = STATE(3810),
    [sym_preproc_error] = STATE(3810),
    [sym_preproc_define] = STATE(3810),
    [sym_preproc_undef] = STATE(3810),
    [aux_sym_class_declaration_repeat1] = STATE(6230),
    [aux_sym_lambda_expression_repeat1] = STATE(4133),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(5212),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3811] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7013),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9357),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(3811),
    [sym_preproc_endregion] = STATE(3811),
    [sym_preproc_line] = STATE(3811),
    [sym_preproc_pragma] = STATE(3811),
    [sym_preproc_nullable] = STATE(3811),
    [sym_preproc_error] = STATE(3811),
    [sym_preproc_define] = STATE(3811),
    [sym_preproc_undef] = STATE(3811),
    [aux_sym_class_declaration_repeat1] = STATE(6230),
    [aux_sym_lambda_expression_repeat1] = STATE(4148),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(5212),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3812] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7057),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9207),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(3812),
    [sym_preproc_endregion] = STATE(3812),
    [sym_preproc_line] = STATE(3812),
    [sym_preproc_pragma] = STATE(3812),
    [sym_preproc_nullable] = STATE(3812),
    [sym_preproc_error] = STATE(3812),
    [sym_preproc_define] = STATE(3812),
    [sym_preproc_undef] = STATE(3812),
    [aux_sym_class_declaration_repeat1] = STATE(6230),
    [aux_sym_lambda_expression_repeat1] = STATE(4150),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(5212),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3813] = {
    [sym__name] = STATE(8674),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_identifier] = STATE(7779),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_region] = STATE(3813),
    [sym_preproc_endregion] = STATE(3813),
    [sym_preproc_line] = STATE(3813),
    [sym_preproc_pragma] = STATE(3813),
    [sym_preproc_nullable] = STATE(3813),
    [sym_preproc_error] = STATE(3813),
    [sym_preproc_define] = STATE(3813),
    [sym_preproc_undef] = STATE(3813),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(3976),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_unsafe] = ACTIONS(3976),
    [anon_sym_static] = ACTIONS(3976),
    [anon_sym_LPAREN] = ACTIONS(5566),
    [anon_sym_ref] = ACTIONS(3976),
    [anon_sym_delegate] = ACTIONS(3976),
    [anon_sym_abstract] = ACTIONS(3976),
    [anon_sym_async] = ACTIONS(3976),
    [anon_sym_const] = ACTIONS(3976),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_fixed] = ACTIONS(3976),
    [anon_sym_internal] = ACTIONS(3976),
    [anon_sym_new] = ACTIONS(3976),
    [anon_sym_override] = ACTIONS(3976),
    [anon_sym_partial] = ACTIONS(3976),
    [anon_sym_private] = ACTIONS(3976),
    [anon_sym_protected] = ACTIONS(3976),
    [anon_sym_public] = ACTIONS(3976),
    [anon_sym_readonly] = ACTIONS(3976),
    [anon_sym_required] = ACTIONS(3976),
    [anon_sym_sealed] = ACTIONS(3976),
    [anon_sym_virtual] = ACTIONS(3976),
    [anon_sym_volatile] = ACTIONS(3976),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_scoped] = ACTIONS(27),
    [anon_sym_var] = ACTIONS(27),
    [sym_predefined_type] = ACTIONS(3976),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_from] = ACTIONS(27),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3814] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7003),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9141),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(3814),
    [sym_preproc_endregion] = STATE(3814),
    [sym_preproc_line] = STATE(3814),
    [sym_preproc_pragma] = STATE(3814),
    [sym_preproc_nullable] = STATE(3814),
    [sym_preproc_error] = STATE(3814),
    [sym_preproc_define] = STATE(3814),
    [sym_preproc_undef] = STATE(3814),
    [aux_sym_class_declaration_repeat1] = STATE(6230),
    [aux_sym_lambda_expression_repeat1] = STATE(4184),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(5212),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3815] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(6939),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9259),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(3815),
    [sym_preproc_endregion] = STATE(3815),
    [sym_preproc_line] = STATE(3815),
    [sym_preproc_pragma] = STATE(3815),
    [sym_preproc_nullable] = STATE(3815),
    [sym_preproc_error] = STATE(3815),
    [sym_preproc_define] = STATE(3815),
    [sym_preproc_undef] = STATE(3815),
    [aux_sym_class_declaration_repeat1] = STATE(6230),
    [aux_sym_lambda_expression_repeat1] = STATE(4074),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(5212),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3816] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7078),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9173),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(3816),
    [sym_preproc_endregion] = STATE(3816),
    [sym_preproc_line] = STATE(3816),
    [sym_preproc_pragma] = STATE(3816),
    [sym_preproc_nullable] = STATE(3816),
    [sym_preproc_error] = STATE(3816),
    [sym_preproc_define] = STATE(3816),
    [sym_preproc_undef] = STATE(3816),
    [aux_sym_class_declaration_repeat1] = STATE(6230),
    [aux_sym_lambda_expression_repeat1] = STATE(4221),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(5212),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3817] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7077),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9200),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(3817),
    [sym_preproc_endregion] = STATE(3817),
    [sym_preproc_line] = STATE(3817),
    [sym_preproc_pragma] = STATE(3817),
    [sym_preproc_nullable] = STATE(3817),
    [sym_preproc_error] = STATE(3817),
    [sym_preproc_define] = STATE(3817),
    [sym_preproc_undef] = STATE(3817),
    [aux_sym_class_declaration_repeat1] = STATE(6230),
    [aux_sym_lambda_expression_repeat1] = STATE(4157),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(5212),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3818] = {
    [sym_initializer_expression] = STATE(3940),
    [sym_preproc_region] = STATE(3818),
    [sym_preproc_endregion] = STATE(3818),
    [sym_preproc_line] = STATE(3818),
    [sym_preproc_pragma] = STATE(3818),
    [sym_preproc_nullable] = STATE(3818),
    [sym_preproc_error] = STATE(3818),
    [sym_preproc_define] = STATE(3818),
    [sym_preproc_undef] = STATE(3818),
    [anon_sym_SEMI] = ACTIONS(5201),
    [anon_sym_LBRACK] = ACTIONS(5201),
    [anon_sym_COLON] = ACTIONS(5201),
    [anon_sym_COMMA] = ACTIONS(5201),
    [anon_sym_RBRACK] = ACTIONS(5201),
    [anon_sym_LPAREN] = ACTIONS(5201),
    [anon_sym_RPAREN] = ACTIONS(5201),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_RBRACE] = ACTIONS(5201),
    [anon_sym_LT] = ACTIONS(5203),
    [anon_sym_GT] = ACTIONS(5203),
    [anon_sym_in] = ACTIONS(5203),
    [anon_sym_QMARK] = ACTIONS(5203),
    [anon_sym_BANG] = ACTIONS(5203),
    [anon_sym_PLUS_PLUS] = ACTIONS(5201),
    [anon_sym_DASH_DASH] = ACTIONS(5201),
    [anon_sym_PLUS] = ACTIONS(5203),
    [anon_sym_DASH] = ACTIONS(5203),
    [anon_sym_STAR] = ACTIONS(5201),
    [anon_sym_SLASH] = ACTIONS(5203),
    [anon_sym_PERCENT] = ACTIONS(5201),
    [anon_sym_CARET] = ACTIONS(5201),
    [anon_sym_PIPE] = ACTIONS(5203),
    [anon_sym_AMP] = ACTIONS(5203),
    [anon_sym_LT_LT] = ACTIONS(5201),
    [anon_sym_GT_GT] = ACTIONS(5203),
    [anon_sym_GT_GT_GT] = ACTIONS(5201),
    [anon_sym_EQ_EQ] = ACTIONS(5201),
    [anon_sym_BANG_EQ] = ACTIONS(5201),
    [anon_sym_GT_EQ] = ACTIONS(5201),
    [anon_sym_LT_EQ] = ACTIONS(5201),
    [anon_sym_DOT] = ACTIONS(5203),
    [anon_sym_EQ_GT] = ACTIONS(5201),
    [anon_sym_switch] = ACTIONS(5201),
    [anon_sym_when] = ACTIONS(5201),
    [anon_sym_DOT_DOT] = ACTIONS(5201),
    [anon_sym_and] = ACTIONS(5201),
    [anon_sym_or] = ACTIONS(5201),
    [anon_sym_AMP_AMP] = ACTIONS(5201),
    [anon_sym_PIPE_PIPE] = ACTIONS(5201),
    [anon_sym_QMARK_QMARK] = ACTIONS(5201),
    [anon_sym_into] = ACTIONS(5201),
    [anon_sym_on] = ACTIONS(5201),
    [anon_sym_equals] = ACTIONS(5201),
    [anon_sym_by] = ACTIONS(5201),
    [anon_sym_as] = ACTIONS(5201),
    [anon_sym_is] = ACTIONS(5201),
    [anon_sym_DASH_GT] = ACTIONS(5201),
    [anon_sym_with] = ACTIONS(5201),
    [aux_sym_preproc_if_token3] = ACTIONS(5201),
    [aux_sym_preproc_else_token1] = ACTIONS(5201),
    [aux_sym_preproc_elif_token1] = ACTIONS(5201),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3819] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7088),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9193),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(3819),
    [sym_preproc_endregion] = STATE(3819),
    [sym_preproc_line] = STATE(3819),
    [sym_preproc_pragma] = STATE(3819),
    [sym_preproc_nullable] = STATE(3819),
    [sym_preproc_error] = STATE(3819),
    [sym_preproc_define] = STATE(3819),
    [sym_preproc_undef] = STATE(3819),
    [aux_sym_class_declaration_repeat1] = STATE(6230),
    [aux_sym_lambda_expression_repeat1] = STATE(4166),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(5212),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3820] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7086),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9395),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(3820),
    [sym_preproc_endregion] = STATE(3820),
    [sym_preproc_line] = STATE(3820),
    [sym_preproc_pragma] = STATE(3820),
    [sym_preproc_nullable] = STATE(3820),
    [sym_preproc_error] = STATE(3820),
    [sym_preproc_define] = STATE(3820),
    [sym_preproc_undef] = STATE(3820),
    [aux_sym_class_declaration_repeat1] = STATE(6230),
    [aux_sym_lambda_expression_repeat1] = STATE(4155),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(5212),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3821] = {
    [sym_type_argument_list] = STATE(3877),
    [sym_preproc_region] = STATE(3821),
    [sym_preproc_endregion] = STATE(3821),
    [sym_preproc_line] = STATE(3821),
    [sym_preproc_pragma] = STATE(3821),
    [sym_preproc_nullable] = STATE(3821),
    [sym_preproc_error] = STATE(3821),
    [sym_preproc_define] = STATE(3821),
    [sym_preproc_undef] = STATE(3821),
    [anon_sym_SEMI] = ACTIONS(4076),
    [anon_sym_LBRACK] = ACTIONS(4076),
    [anon_sym_COLON] = ACTIONS(4076),
    [anon_sym_COMMA] = ACTIONS(4076),
    [anon_sym_RBRACK] = ACTIONS(4076),
    [anon_sym_LPAREN] = ACTIONS(4076),
    [anon_sym_RPAREN] = ACTIONS(4076),
    [anon_sym_LBRACE] = ACTIONS(4076),
    [anon_sym_RBRACE] = ACTIONS(4076),
    [anon_sym_LT] = ACTIONS(5677),
    [anon_sym_GT] = ACTIONS(4074),
    [anon_sym_in] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(4074),
    [anon_sym_BANG] = ACTIONS(4074),
    [anon_sym_PLUS_PLUS] = ACTIONS(4076),
    [anon_sym_DASH_DASH] = ACTIONS(4076),
    [anon_sym_PLUS] = ACTIONS(4074),
    [anon_sym_DASH] = ACTIONS(4074),
    [anon_sym_STAR] = ACTIONS(4076),
    [anon_sym_SLASH] = ACTIONS(4074),
    [anon_sym_PERCENT] = ACTIONS(4076),
    [anon_sym_CARET] = ACTIONS(4076),
    [anon_sym_PIPE] = ACTIONS(4074),
    [anon_sym_AMP] = ACTIONS(4074),
    [anon_sym_LT_LT] = ACTIONS(4076),
    [anon_sym_GT_GT] = ACTIONS(4074),
    [anon_sym_GT_GT_GT] = ACTIONS(4076),
    [anon_sym_EQ_EQ] = ACTIONS(4076),
    [anon_sym_BANG_EQ] = ACTIONS(4076),
    [anon_sym_GT_EQ] = ACTIONS(4076),
    [anon_sym_LT_EQ] = ACTIONS(4076),
    [anon_sym_DOT] = ACTIONS(4074),
    [anon_sym_EQ_GT] = ACTIONS(4076),
    [anon_sym_switch] = ACTIONS(4076),
    [anon_sym_when] = ACTIONS(4076),
    [anon_sym_DOT_DOT] = ACTIONS(4076),
    [anon_sym_and] = ACTIONS(4076),
    [anon_sym_or] = ACTIONS(4076),
    [anon_sym_AMP_AMP] = ACTIONS(4076),
    [anon_sym_PIPE_PIPE] = ACTIONS(4076),
    [anon_sym_QMARK_QMARK] = ACTIONS(4076),
    [anon_sym_into] = ACTIONS(4076),
    [anon_sym_on] = ACTIONS(4076),
    [anon_sym_equals] = ACTIONS(4076),
    [anon_sym_by] = ACTIONS(4076),
    [anon_sym_as] = ACTIONS(4076),
    [anon_sym_is] = ACTIONS(4076),
    [anon_sym_DASH_GT] = ACTIONS(4076),
    [anon_sym_with] = ACTIONS(4076),
    [aux_sym_preproc_if_token3] = ACTIONS(4076),
    [aux_sym_preproc_else_token1] = ACTIONS(4076),
    [aux_sym_preproc_elif_token1] = ACTIONS(4076),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3822] = {
    [sym_argument_list] = STATE(3942),
    [sym_bracketed_argument_list] = STATE(3206),
    [sym_preproc_region] = STATE(3822),
    [sym_preproc_endregion] = STATE(3822),
    [sym_preproc_line] = STATE(3822),
    [sym_preproc_pragma] = STATE(3822),
    [sym_preproc_nullable] = STATE(3822),
    [sym_preproc_error] = STATE(3822),
    [sym_preproc_define] = STATE(3822),
    [sym_preproc_undef] = STATE(3822),
    [anon_sym_SEMI] = ACTIONS(5233),
    [anon_sym_LBRACK] = ACTIONS(5688),
    [anon_sym_COLON] = ACTIONS(5233),
    [anon_sym_COMMA] = ACTIONS(5233),
    [anon_sym_RBRACK] = ACTIONS(5233),
    [anon_sym_LPAREN] = ACTIONS(5669),
    [anon_sym_RPAREN] = ACTIONS(5233),
    [anon_sym_RBRACE] = ACTIONS(5233),
    [anon_sym_LT] = ACTIONS(5237),
    [anon_sym_GT] = ACTIONS(5237),
    [anon_sym_in] = ACTIONS(5237),
    [anon_sym_QMARK] = ACTIONS(5237),
    [anon_sym_BANG] = ACTIONS(5690),
    [anon_sym_PLUS_PLUS] = ACTIONS(5692),
    [anon_sym_DASH_DASH] = ACTIONS(5692),
    [anon_sym_PLUS] = ACTIONS(5237),
    [anon_sym_DASH] = ACTIONS(5237),
    [anon_sym_STAR] = ACTIONS(5233),
    [anon_sym_SLASH] = ACTIONS(5237),
    [anon_sym_PERCENT] = ACTIONS(5233),
    [anon_sym_CARET] = ACTIONS(5233),
    [anon_sym_PIPE] = ACTIONS(5237),
    [anon_sym_AMP] = ACTIONS(5237),
    [anon_sym_LT_LT] = ACTIONS(5233),
    [anon_sym_GT_GT] = ACTIONS(5237),
    [anon_sym_GT_GT_GT] = ACTIONS(5233),
    [anon_sym_EQ_EQ] = ACTIONS(5233),
    [anon_sym_BANG_EQ] = ACTIONS(5233),
    [anon_sym_GT_EQ] = ACTIONS(5233),
    [anon_sym_LT_EQ] = ACTIONS(5233),
    [anon_sym_DOT] = ACTIONS(4556),
    [anon_sym_EQ_GT] = ACTIONS(5233),
    [anon_sym_switch] = ACTIONS(5233),
    [anon_sym_when] = ACTIONS(5233),
    [anon_sym_DOT_DOT] = ACTIONS(5233),
    [anon_sym_and] = ACTIONS(5233),
    [anon_sym_or] = ACTIONS(5233),
    [anon_sym_AMP_AMP] = ACTIONS(5233),
    [anon_sym_PIPE_PIPE] = ACTIONS(5233),
    [anon_sym_QMARK_QMARK] = ACTIONS(5233),
    [anon_sym_into] = ACTIONS(5233),
    [anon_sym_on] = ACTIONS(5233),
    [anon_sym_equals] = ACTIONS(5233),
    [anon_sym_by] = ACTIONS(5233),
    [anon_sym_as] = ACTIONS(5233),
    [anon_sym_is] = ACTIONS(5233),
    [anon_sym_DASH_GT] = ACTIONS(4558),
    [anon_sym_with] = ACTIONS(5233),
    [aux_sym_preproc_if_token3] = ACTIONS(5233),
    [aux_sym_preproc_else_token1] = ACTIONS(5233),
    [aux_sym_preproc_elif_token1] = ACTIONS(5233),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3823] = {
    [sym_initializer_expression] = STATE(3938),
    [sym_preproc_region] = STATE(3823),
    [sym_preproc_endregion] = STATE(3823),
    [sym_preproc_line] = STATE(3823),
    [sym_preproc_pragma] = STATE(3823),
    [sym_preproc_nullable] = STATE(3823),
    [sym_preproc_error] = STATE(3823),
    [sym_preproc_define] = STATE(3823),
    [sym_preproc_undef] = STATE(3823),
    [anon_sym_SEMI] = ACTIONS(5302),
    [anon_sym_LBRACK] = ACTIONS(5298),
    [anon_sym_COLON] = ACTIONS(5302),
    [anon_sym_COMMA] = ACTIONS(5302),
    [anon_sym_RBRACK] = ACTIONS(5302),
    [anon_sym_LPAREN] = ACTIONS(5302),
    [anon_sym_RPAREN] = ACTIONS(5302),
    [anon_sym_LBRACE] = ACTIONS(5694),
    [anon_sym_RBRACE] = ACTIONS(5302),
    [anon_sym_LT] = ACTIONS(5308),
    [anon_sym_GT] = ACTIONS(5308),
    [anon_sym_in] = ACTIONS(5308),
    [anon_sym_QMARK] = ACTIONS(5697),
    [anon_sym_BANG] = ACTIONS(5308),
    [anon_sym_PLUS_PLUS] = ACTIONS(5302),
    [anon_sym_DASH_DASH] = ACTIONS(5302),
    [anon_sym_PLUS] = ACTIONS(5308),
    [anon_sym_DASH] = ACTIONS(5308),
    [anon_sym_STAR] = ACTIONS(5302),
    [anon_sym_SLASH] = ACTIONS(5308),
    [anon_sym_PERCENT] = ACTIONS(5302),
    [anon_sym_CARET] = ACTIONS(5302),
    [anon_sym_PIPE] = ACTIONS(5308),
    [anon_sym_AMP] = ACTIONS(5308),
    [anon_sym_LT_LT] = ACTIONS(5302),
    [anon_sym_GT_GT] = ACTIONS(5308),
    [anon_sym_GT_GT_GT] = ACTIONS(5302),
    [anon_sym_EQ_EQ] = ACTIONS(5302),
    [anon_sym_BANG_EQ] = ACTIONS(5302),
    [anon_sym_GT_EQ] = ACTIONS(5302),
    [anon_sym_LT_EQ] = ACTIONS(5302),
    [anon_sym_DOT] = ACTIONS(5308),
    [anon_sym_EQ_GT] = ACTIONS(5302),
    [anon_sym_switch] = ACTIONS(5302),
    [anon_sym_when] = ACTIONS(5302),
    [anon_sym_DOT_DOT] = ACTIONS(5302),
    [anon_sym_and] = ACTIONS(5302),
    [anon_sym_or] = ACTIONS(5302),
    [anon_sym_AMP_AMP] = ACTIONS(5302),
    [anon_sym_PIPE_PIPE] = ACTIONS(5302),
    [anon_sym_QMARK_QMARK] = ACTIONS(5302),
    [anon_sym_into] = ACTIONS(5302),
    [anon_sym_on] = ACTIONS(5302),
    [anon_sym_equals] = ACTIONS(5302),
    [anon_sym_by] = ACTIONS(5302),
    [anon_sym_as] = ACTIONS(5302),
    [anon_sym_is] = ACTIONS(5302),
    [anon_sym_DASH_GT] = ACTIONS(5302),
    [anon_sym_with] = ACTIONS(5302),
    [aux_sym_preproc_if_token3] = ACTIONS(5302),
    [aux_sym_preproc_else_token1] = ACTIONS(5302),
    [aux_sym_preproc_elif_token1] = ACTIONS(5302),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3824] = {
    [sym_initializer_expression] = STATE(3966),
    [sym_preproc_region] = STATE(3824),
    [sym_preproc_endregion] = STATE(3824),
    [sym_preproc_line] = STATE(3824),
    [sym_preproc_pragma] = STATE(3824),
    [sym_preproc_nullable] = STATE(3824),
    [sym_preproc_error] = STATE(3824),
    [sym_preproc_define] = STATE(3824),
    [sym_preproc_undef] = STATE(3824),
    [anon_sym_SEMI] = ACTIONS(5226),
    [anon_sym_LBRACK] = ACTIONS(5228),
    [anon_sym_COLON] = ACTIONS(5226),
    [anon_sym_COMMA] = ACTIONS(5226),
    [anon_sym_RBRACK] = ACTIONS(5226),
    [anon_sym_LPAREN] = ACTIONS(5226),
    [anon_sym_RPAREN] = ACTIONS(5226),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_RBRACE] = ACTIONS(5226),
    [anon_sym_LT] = ACTIONS(5231),
    [anon_sym_GT] = ACTIONS(5231),
    [anon_sym_in] = ACTIONS(5231),
    [anon_sym_QMARK] = ACTIONS(5231),
    [anon_sym_BANG] = ACTIONS(5231),
    [anon_sym_PLUS_PLUS] = ACTIONS(5226),
    [anon_sym_DASH_DASH] = ACTIONS(5226),
    [anon_sym_PLUS] = ACTIONS(5231),
    [anon_sym_DASH] = ACTIONS(5231),
    [anon_sym_STAR] = ACTIONS(5226),
    [anon_sym_SLASH] = ACTIONS(5231),
    [anon_sym_PERCENT] = ACTIONS(5226),
    [anon_sym_CARET] = ACTIONS(5226),
    [anon_sym_PIPE] = ACTIONS(5231),
    [anon_sym_AMP] = ACTIONS(5231),
    [anon_sym_LT_LT] = ACTIONS(5226),
    [anon_sym_GT_GT] = ACTIONS(5231),
    [anon_sym_GT_GT_GT] = ACTIONS(5226),
    [anon_sym_EQ_EQ] = ACTIONS(5226),
    [anon_sym_BANG_EQ] = ACTIONS(5226),
    [anon_sym_GT_EQ] = ACTIONS(5226),
    [anon_sym_LT_EQ] = ACTIONS(5226),
    [anon_sym_DOT] = ACTIONS(5231),
    [anon_sym_EQ_GT] = ACTIONS(5226),
    [anon_sym_switch] = ACTIONS(5226),
    [anon_sym_when] = ACTIONS(5226),
    [anon_sym_DOT_DOT] = ACTIONS(5226),
    [anon_sym_and] = ACTIONS(5226),
    [anon_sym_or] = ACTIONS(5226),
    [anon_sym_AMP_AMP] = ACTIONS(5226),
    [anon_sym_PIPE_PIPE] = ACTIONS(5226),
    [anon_sym_QMARK_QMARK] = ACTIONS(5226),
    [anon_sym_into] = ACTIONS(5226),
    [anon_sym_on] = ACTIONS(5226),
    [anon_sym_equals] = ACTIONS(5226),
    [anon_sym_by] = ACTIONS(5226),
    [anon_sym_as] = ACTIONS(5226),
    [anon_sym_is] = ACTIONS(5226),
    [anon_sym_DASH_GT] = ACTIONS(5226),
    [anon_sym_with] = ACTIONS(5226),
    [aux_sym_preproc_if_token3] = ACTIONS(5226),
    [aux_sym_preproc_else_token1] = ACTIONS(5226),
    [aux_sym_preproc_elif_token1] = ACTIONS(5226),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3825] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7116),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9452),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(3825),
    [sym_preproc_endregion] = STATE(3825),
    [sym_preproc_line] = STATE(3825),
    [sym_preproc_pragma] = STATE(3825),
    [sym_preproc_nullable] = STATE(3825),
    [sym_preproc_error] = STATE(3825),
    [sym_preproc_define] = STATE(3825),
    [sym_preproc_undef] = STATE(3825),
    [aux_sym_class_declaration_repeat1] = STATE(6230),
    [aux_sym_lambda_expression_repeat1] = STATE(4175),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(5212),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3826] = {
    [sym_argument_list] = STATE(3942),
    [sym_bracketed_argument_list] = STATE(3206),
    [sym_preproc_region] = STATE(3826),
    [sym_preproc_endregion] = STATE(3826),
    [sym_preproc_line] = STATE(3826),
    [sym_preproc_pragma] = STATE(3826),
    [sym_preproc_nullable] = STATE(3826),
    [sym_preproc_error] = STATE(3826),
    [sym_preproc_define] = STATE(3826),
    [sym_preproc_undef] = STATE(3826),
    [anon_sym_SEMI] = ACTIONS(5255),
    [anon_sym_LBRACK] = ACTIONS(5688),
    [anon_sym_COLON] = ACTIONS(5255),
    [anon_sym_COMMA] = ACTIONS(5255),
    [anon_sym_RBRACK] = ACTIONS(5255),
    [anon_sym_LPAREN] = ACTIONS(5669),
    [anon_sym_RPAREN] = ACTIONS(5255),
    [anon_sym_RBRACE] = ACTIONS(5255),
    [anon_sym_LT] = ACTIONS(5257),
    [anon_sym_GT] = ACTIONS(5257),
    [anon_sym_in] = ACTIONS(5257),
    [anon_sym_QMARK] = ACTIONS(5257),
    [anon_sym_BANG] = ACTIONS(5690),
    [anon_sym_PLUS_PLUS] = ACTIONS(5692),
    [anon_sym_DASH_DASH] = ACTIONS(5692),
    [anon_sym_PLUS] = ACTIONS(5257),
    [anon_sym_DASH] = ACTIONS(5257),
    [anon_sym_STAR] = ACTIONS(5255),
    [anon_sym_SLASH] = ACTIONS(5257),
    [anon_sym_PERCENT] = ACTIONS(5255),
    [anon_sym_CARET] = ACTIONS(5255),
    [anon_sym_PIPE] = ACTIONS(5257),
    [anon_sym_AMP] = ACTIONS(5257),
    [anon_sym_LT_LT] = ACTIONS(5255),
    [anon_sym_GT_GT] = ACTIONS(5257),
    [anon_sym_GT_GT_GT] = ACTIONS(5255),
    [anon_sym_EQ_EQ] = ACTIONS(5255),
    [anon_sym_BANG_EQ] = ACTIONS(5255),
    [anon_sym_GT_EQ] = ACTIONS(5255),
    [anon_sym_LT_EQ] = ACTIONS(5255),
    [anon_sym_DOT] = ACTIONS(4556),
    [anon_sym_EQ_GT] = ACTIONS(5255),
    [anon_sym_switch] = ACTIONS(5255),
    [anon_sym_when] = ACTIONS(5255),
    [anon_sym_DOT_DOT] = ACTIONS(5255),
    [anon_sym_and] = ACTIONS(5255),
    [anon_sym_or] = ACTIONS(5255),
    [anon_sym_AMP_AMP] = ACTIONS(5255),
    [anon_sym_PIPE_PIPE] = ACTIONS(5255),
    [anon_sym_QMARK_QMARK] = ACTIONS(5255),
    [anon_sym_into] = ACTIONS(5255),
    [anon_sym_on] = ACTIONS(5255),
    [anon_sym_equals] = ACTIONS(5255),
    [anon_sym_by] = ACTIONS(5255),
    [anon_sym_as] = ACTIONS(5255),
    [anon_sym_is] = ACTIONS(5255),
    [anon_sym_DASH_GT] = ACTIONS(4558),
    [anon_sym_with] = ACTIONS(5255),
    [aux_sym_preproc_if_token3] = ACTIONS(5255),
    [aux_sym_preproc_else_token1] = ACTIONS(5255),
    [aux_sym_preproc_elif_token1] = ACTIONS(5255),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3827] = {
    [sym__name] = STATE(8845),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_identifier] = STATE(7752),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_region] = STATE(3827),
    [sym_preproc_endregion] = STATE(3827),
    [sym_preproc_line] = STATE(3827),
    [sym_preproc_pragma] = STATE(3827),
    [sym_preproc_nullable] = STATE(3827),
    [sym_preproc_error] = STATE(3827),
    [sym_preproc_define] = STATE(3827),
    [sym_preproc_undef] = STATE(3827),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(3976),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_unsafe] = ACTIONS(3976),
    [anon_sym_static] = ACTIONS(3976),
    [anon_sym_LPAREN] = ACTIONS(5566),
    [anon_sym_ref] = ACTIONS(3976),
    [anon_sym_delegate] = ACTIONS(3976),
    [anon_sym_abstract] = ACTIONS(3976),
    [anon_sym_async] = ACTIONS(3976),
    [anon_sym_const] = ACTIONS(3976),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_fixed] = ACTIONS(3976),
    [anon_sym_internal] = ACTIONS(3976),
    [anon_sym_new] = ACTIONS(3976),
    [anon_sym_override] = ACTIONS(3976),
    [anon_sym_partial] = ACTIONS(3976),
    [anon_sym_private] = ACTIONS(3976),
    [anon_sym_protected] = ACTIONS(3976),
    [anon_sym_public] = ACTIONS(3976),
    [anon_sym_readonly] = ACTIONS(3976),
    [anon_sym_required] = ACTIONS(3976),
    [anon_sym_sealed] = ACTIONS(3976),
    [anon_sym_virtual] = ACTIONS(3976),
    [anon_sym_volatile] = ACTIONS(3976),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_scoped] = ACTIONS(27),
    [anon_sym_var] = ACTIONS(27),
    [sym_predefined_type] = ACTIONS(3976),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_from] = ACTIONS(27),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3828] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7117),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9182),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(3828),
    [sym_preproc_endregion] = STATE(3828),
    [sym_preproc_line] = STATE(3828),
    [sym_preproc_pragma] = STATE(3828),
    [sym_preproc_nullable] = STATE(3828),
    [sym_preproc_error] = STATE(3828),
    [sym_preproc_define] = STATE(3828),
    [sym_preproc_undef] = STATE(3828),
    [aux_sym_class_declaration_repeat1] = STATE(6230),
    [aux_sym_lambda_expression_repeat1] = STATE(4197),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(5212),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3829] = {
    [sym_preproc_region] = STATE(3829),
    [sym_preproc_endregion] = STATE(3829),
    [sym_preproc_line] = STATE(3829),
    [sym_preproc_pragma] = STATE(3829),
    [sym_preproc_nullable] = STATE(3829),
    [sym_preproc_error] = STATE(3829),
    [sym_preproc_define] = STATE(3829),
    [sym_preproc_undef] = STATE(3829),
    [anon_sym_EQ] = ACTIONS(5701),
    [anon_sym_LBRACK] = ACTIONS(5249),
    [anon_sym_COLON] = ACTIONS(5249),
    [anon_sym_COMMA] = ACTIONS(5249),
    [anon_sym_LPAREN] = ACTIONS(5249),
    [anon_sym_RPAREN] = ACTIONS(5249),
    [anon_sym_RBRACE] = ACTIONS(5249),
    [anon_sym_LT] = ACTIONS(5251),
    [anon_sym_GT] = ACTIONS(5251),
    [anon_sym_QMARK] = ACTIONS(5251),
    [anon_sym_BANG] = ACTIONS(5251),
    [anon_sym_PLUS_PLUS] = ACTIONS(5249),
    [anon_sym_DASH_DASH] = ACTIONS(5249),
    [anon_sym_PLUS] = ACTIONS(5251),
    [anon_sym_DASH] = ACTIONS(5251),
    [anon_sym_STAR] = ACTIONS(5251),
    [anon_sym_SLASH] = ACTIONS(5251),
    [anon_sym_PERCENT] = ACTIONS(5251),
    [anon_sym_CARET] = ACTIONS(5251),
    [anon_sym_PIPE] = ACTIONS(5251),
    [anon_sym_AMP] = ACTIONS(5251),
    [anon_sym_LT_LT] = ACTIONS(5251),
    [anon_sym_GT_GT] = ACTIONS(5251),
    [anon_sym_GT_GT_GT] = ACTIONS(5251),
    [anon_sym_EQ_EQ] = ACTIONS(5249),
    [anon_sym_BANG_EQ] = ACTIONS(5249),
    [anon_sym_GT_EQ] = ACTIONS(5249),
    [anon_sym_LT_EQ] = ACTIONS(5249),
    [anon_sym_DOT] = ACTIONS(5251),
    [anon_sym_switch] = ACTIONS(5249),
    [anon_sym_DOT_DOT] = ACTIONS(5249),
    [anon_sym_and] = ACTIONS(5249),
    [anon_sym_or] = ACTIONS(5249),
    [anon_sym_PLUS_EQ] = ACTIONS(5703),
    [anon_sym_DASH_EQ] = ACTIONS(5703),
    [anon_sym_STAR_EQ] = ACTIONS(5703),
    [anon_sym_SLASH_EQ] = ACTIONS(5703),
    [anon_sym_PERCENT_EQ] = ACTIONS(5703),
    [anon_sym_AMP_EQ] = ACTIONS(5703),
    [anon_sym_CARET_EQ] = ACTIONS(5703),
    [anon_sym_PIPE_EQ] = ACTIONS(5703),
    [anon_sym_LT_LT_EQ] = ACTIONS(5703),
    [anon_sym_GT_GT_EQ] = ACTIONS(5703),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5703),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(5703),
    [anon_sym_AMP_AMP] = ACTIONS(5249),
    [anon_sym_PIPE_PIPE] = ACTIONS(5249),
    [anon_sym_QMARK_QMARK] = ACTIONS(5251),
    [anon_sym_into] = ACTIONS(5249),
    [anon_sym_as] = ACTIONS(5249),
    [anon_sym_is] = ACTIONS(5249),
    [anon_sym_DASH_GT] = ACTIONS(5249),
    [anon_sym_with] = ACTIONS(5249),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3830] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7018),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(8989),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(3830),
    [sym_preproc_endregion] = STATE(3830),
    [sym_preproc_line] = STATE(3830),
    [sym_preproc_pragma] = STATE(3830),
    [sym_preproc_nullable] = STATE(3830),
    [sym_preproc_error] = STATE(3830),
    [sym_preproc_define] = STATE(3830),
    [sym_preproc_undef] = STATE(3830),
    [aux_sym_class_declaration_repeat1] = STATE(6230),
    [aux_sym_lambda_expression_repeat1] = STATE(4196),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(5212),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3831] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7113),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9905),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(3831),
    [sym_preproc_endregion] = STATE(3831),
    [sym_preproc_line] = STATE(3831),
    [sym_preproc_pragma] = STATE(3831),
    [sym_preproc_nullable] = STATE(3831),
    [sym_preproc_error] = STATE(3831),
    [sym_preproc_define] = STATE(3831),
    [sym_preproc_undef] = STATE(3831),
    [aux_sym_class_declaration_repeat1] = STATE(6230),
    [aux_sym_lambda_expression_repeat1] = STATE(4240),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(5212),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3832] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7032),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9519),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(3832),
    [sym_preproc_endregion] = STATE(3832),
    [sym_preproc_line] = STATE(3832),
    [sym_preproc_pragma] = STATE(3832),
    [sym_preproc_nullable] = STATE(3832),
    [sym_preproc_error] = STATE(3832),
    [sym_preproc_define] = STATE(3832),
    [sym_preproc_undef] = STATE(3832),
    [aux_sym_class_declaration_repeat1] = STATE(6230),
    [aux_sym_lambda_expression_repeat1] = STATE(4198),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(5212),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3833] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9801),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(3833),
    [sym_preproc_endregion] = STATE(3833),
    [sym_preproc_line] = STATE(3833),
    [sym_preproc_pragma] = STATE(3833),
    [sym_preproc_nullable] = STATE(3833),
    [sym_preproc_error] = STATE(3833),
    [sym_preproc_define] = STATE(3833),
    [sym_preproc_undef] = STATE(3833),
    [aux_sym_class_declaration_repeat1] = STATE(6230),
    [aux_sym_lambda_expression_repeat1] = STATE(4262),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(5212),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3834] = {
    [sym__name] = STATE(8845),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_identifier] = STATE(5368),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_region] = STATE(3834),
    [sym_preproc_endregion] = STATE(3834),
    [sym_preproc_line] = STATE(3834),
    [sym_preproc_pragma] = STATE(3834),
    [sym_preproc_nullable] = STATE(3834),
    [sym_preproc_error] = STATE(3834),
    [sym_preproc_define] = STATE(3834),
    [sym_preproc_undef] = STATE(3834),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(3976),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_unsafe] = ACTIONS(5705),
    [anon_sym_static] = ACTIONS(3976),
    [anon_sym_LPAREN] = ACTIONS(5566),
    [anon_sym_ref] = ACTIONS(3976),
    [anon_sym_delegate] = ACTIONS(3976),
    [anon_sym_abstract] = ACTIONS(3976),
    [anon_sym_async] = ACTIONS(3976),
    [anon_sym_const] = ACTIONS(3976),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_fixed] = ACTIONS(3976),
    [anon_sym_internal] = ACTIONS(3976),
    [anon_sym_new] = ACTIONS(3976),
    [anon_sym_override] = ACTIONS(3976),
    [anon_sym_partial] = ACTIONS(3976),
    [anon_sym_private] = ACTIONS(3976),
    [anon_sym_protected] = ACTIONS(3976),
    [anon_sym_public] = ACTIONS(3976),
    [anon_sym_readonly] = ACTIONS(3976),
    [anon_sym_required] = ACTIONS(3976),
    [anon_sym_sealed] = ACTIONS(3976),
    [anon_sym_virtual] = ACTIONS(3976),
    [anon_sym_volatile] = ACTIONS(3976),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_scoped] = ACTIONS(27),
    [anon_sym_var] = ACTIONS(27),
    [sym_predefined_type] = ACTIONS(3976),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_from] = ACTIONS(27),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3835] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7120),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9682),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(3835),
    [sym_preproc_endregion] = STATE(3835),
    [sym_preproc_line] = STATE(3835),
    [sym_preproc_pragma] = STATE(3835),
    [sym_preproc_nullable] = STATE(3835),
    [sym_preproc_error] = STATE(3835),
    [sym_preproc_define] = STATE(3835),
    [sym_preproc_undef] = STATE(3835),
    [aux_sym_class_declaration_repeat1] = STATE(6230),
    [aux_sym_lambda_expression_repeat1] = STATE(4237),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(5212),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3836] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7101),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9548),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(3836),
    [sym_preproc_endregion] = STATE(3836),
    [sym_preproc_line] = STATE(3836),
    [sym_preproc_pragma] = STATE(3836),
    [sym_preproc_nullable] = STATE(3836),
    [sym_preproc_error] = STATE(3836),
    [sym_preproc_define] = STATE(3836),
    [sym_preproc_undef] = STATE(3836),
    [aux_sym_class_declaration_repeat1] = STATE(6230),
    [aux_sym_lambda_expression_repeat1] = STATE(4190),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(5212),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3837] = {
    [sym_block] = STATE(2439),
    [sym_preproc_region] = STATE(3837),
    [sym_preproc_endregion] = STATE(3837),
    [sym_preproc_line] = STATE(3837),
    [sym_preproc_pragma] = STATE(3837),
    [sym_preproc_nullable] = STATE(3837),
    [sym_preproc_error] = STATE(3837),
    [sym_preproc_define] = STATE(3837),
    [sym_preproc_undef] = STATE(3837),
    [sym__identifier_token] = ACTIONS(3976),
    [anon_sym_extern] = ACTIONS(3976),
    [anon_sym_alias] = ACTIONS(3976),
    [anon_sym_global] = ACTIONS(3976),
    [anon_sym_unsafe] = ACTIONS(3976),
    [anon_sym_static] = ACTIONS(3976),
    [anon_sym_LPAREN] = ACTIONS(5566),
    [anon_sym_class] = ACTIONS(3976),
    [anon_sym_ref] = ACTIONS(3976),
    [anon_sym_struct] = ACTIONS(3976),
    [anon_sym_enum] = ACTIONS(3976),
    [anon_sym_LBRACE] = ACTIONS(5707),
    [anon_sym_interface] = ACTIONS(3976),
    [anon_sym_delegate] = ACTIONS(3976),
    [anon_sym_record] = ACTIONS(3976),
    [anon_sym_abstract] = ACTIONS(3976),
    [anon_sym_async] = ACTIONS(3976),
    [anon_sym_const] = ACTIONS(3976),
    [anon_sym_file] = ACTIONS(3976),
    [anon_sym_fixed] = ACTIONS(3976),
    [anon_sym_internal] = ACTIONS(3976),
    [anon_sym_new] = ACTIONS(3976),
    [anon_sym_override] = ACTIONS(3976),
    [anon_sym_partial] = ACTIONS(3976),
    [anon_sym_private] = ACTIONS(3976),
    [anon_sym_protected] = ACTIONS(3976),
    [anon_sym_public] = ACTIONS(3976),
    [anon_sym_readonly] = ACTIONS(3976),
    [anon_sym_required] = ACTIONS(3976),
    [anon_sym_sealed] = ACTIONS(3976),
    [anon_sym_virtual] = ACTIONS(3976),
    [anon_sym_volatile] = ACTIONS(3976),
    [anon_sym_where] = ACTIONS(3976),
    [anon_sym_notnull] = ACTIONS(3976),
    [anon_sym_unmanaged] = ACTIONS(3976),
    [anon_sym_scoped] = ACTIONS(3976),
    [anon_sym_var] = ACTIONS(3976),
    [sym_predefined_type] = ACTIONS(3976),
    [anon_sym_yield] = ACTIONS(3976),
    [anon_sym_when] = ACTIONS(3976),
    [anon_sym_from] = ACTIONS(3976),
    [anon_sym_into] = ACTIONS(3976),
    [anon_sym_join] = ACTIONS(3976),
    [anon_sym_on] = ACTIONS(3976),
    [anon_sym_equals] = ACTIONS(3976),
    [anon_sym_let] = ACTIONS(3976),
    [anon_sym_orderby] = ACTIONS(3976),
    [anon_sym_ascending] = ACTIONS(3976),
    [anon_sym_descending] = ACTIONS(3976),
    [anon_sym_group] = ACTIONS(3976),
    [anon_sym_by] = ACTIONS(3976),
    [anon_sym_select] = ACTIONS(3976),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3838] = {
    [sym_preproc_region] = STATE(3838),
    [sym_preproc_endregion] = STATE(3838),
    [sym_preproc_line] = STATE(3838),
    [sym_preproc_pragma] = STATE(3838),
    [sym_preproc_nullable] = STATE(3838),
    [sym_preproc_error] = STATE(3838),
    [sym_preproc_define] = STATE(3838),
    [sym_preproc_undef] = STATE(3838),
    [anon_sym_SEMI] = ACTIONS(4058),
    [anon_sym_LBRACK] = ACTIONS(4058),
    [anon_sym_COLON] = ACTIONS(4056),
    [anon_sym_COMMA] = ACTIONS(4058),
    [anon_sym_RBRACK] = ACTIONS(4058),
    [anon_sym_LPAREN] = ACTIONS(4058),
    [anon_sym_RPAREN] = ACTIONS(4058),
    [anon_sym_LBRACE] = ACTIONS(4058),
    [anon_sym_RBRACE] = ACTIONS(4058),
    [anon_sym_LT] = ACTIONS(4056),
    [anon_sym_GT] = ACTIONS(4056),
    [anon_sym_in] = ACTIONS(4056),
    [anon_sym_QMARK] = ACTIONS(4056),
    [anon_sym_BANG] = ACTIONS(4056),
    [anon_sym_PLUS_PLUS] = ACTIONS(4058),
    [anon_sym_DASH_DASH] = ACTIONS(4058),
    [anon_sym_PLUS] = ACTIONS(4056),
    [anon_sym_DASH] = ACTIONS(4056),
    [anon_sym_STAR] = ACTIONS(4058),
    [anon_sym_SLASH] = ACTIONS(4056),
    [anon_sym_PERCENT] = ACTIONS(4058),
    [anon_sym_CARET] = ACTIONS(4058),
    [anon_sym_PIPE] = ACTIONS(4056),
    [anon_sym_AMP] = ACTIONS(4056),
    [anon_sym_LT_LT] = ACTIONS(4058),
    [anon_sym_GT_GT] = ACTIONS(4056),
    [anon_sym_GT_GT_GT] = ACTIONS(4058),
    [anon_sym_EQ_EQ] = ACTIONS(4058),
    [anon_sym_BANG_EQ] = ACTIONS(4058),
    [anon_sym_GT_EQ] = ACTIONS(4058),
    [anon_sym_LT_EQ] = ACTIONS(4058),
    [anon_sym_DOT] = ACTIONS(4056),
    [anon_sym_EQ_GT] = ACTIONS(4058),
    [anon_sym_COLON_COLON] = ACTIONS(4058),
    [anon_sym_switch] = ACTIONS(4058),
    [anon_sym_when] = ACTIONS(4058),
    [anon_sym_DOT_DOT] = ACTIONS(4058),
    [anon_sym_and] = ACTIONS(4058),
    [anon_sym_or] = ACTIONS(4058),
    [anon_sym_AMP_AMP] = ACTIONS(4058),
    [anon_sym_PIPE_PIPE] = ACTIONS(4058),
    [anon_sym_QMARK_QMARK] = ACTIONS(4058),
    [anon_sym_into] = ACTIONS(4058),
    [anon_sym_on] = ACTIONS(4058),
    [anon_sym_equals] = ACTIONS(4058),
    [anon_sym_by] = ACTIONS(4058),
    [anon_sym_as] = ACTIONS(4058),
    [anon_sym_is] = ACTIONS(4058),
    [anon_sym_DASH_GT] = ACTIONS(4058),
    [anon_sym_with] = ACTIONS(4058),
    [aux_sym_preproc_if_token3] = ACTIONS(4058),
    [aux_sym_preproc_else_token1] = ACTIONS(4058),
    [aux_sym_preproc_elif_token1] = ACTIONS(4058),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3839] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7041),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9290),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(3839),
    [sym_preproc_endregion] = STATE(3839),
    [sym_preproc_line] = STATE(3839),
    [sym_preproc_pragma] = STATE(3839),
    [sym_preproc_nullable] = STATE(3839),
    [sym_preproc_error] = STATE(3839),
    [sym_preproc_define] = STATE(3839),
    [sym_preproc_undef] = STATE(3839),
    [aux_sym_class_declaration_repeat1] = STATE(6230),
    [aux_sym_lambda_expression_repeat1] = STATE(4303),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(5212),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3840] = {
    [sym_block] = STATE(2231),
    [sym_preproc_region] = STATE(3840),
    [sym_preproc_endregion] = STATE(3840),
    [sym_preproc_line] = STATE(3840),
    [sym_preproc_pragma] = STATE(3840),
    [sym_preproc_nullable] = STATE(3840),
    [sym_preproc_error] = STATE(3840),
    [sym_preproc_define] = STATE(3840),
    [sym_preproc_undef] = STATE(3840),
    [sym__identifier_token] = ACTIONS(3976),
    [anon_sym_extern] = ACTIONS(3976),
    [anon_sym_alias] = ACTIONS(3976),
    [anon_sym_global] = ACTIONS(3976),
    [anon_sym_unsafe] = ACTIONS(3976),
    [anon_sym_static] = ACTIONS(3976),
    [anon_sym_LPAREN] = ACTIONS(5566),
    [anon_sym_class] = ACTIONS(3976),
    [anon_sym_ref] = ACTIONS(3976),
    [anon_sym_struct] = ACTIONS(3976),
    [anon_sym_enum] = ACTIONS(3976),
    [anon_sym_LBRACE] = ACTIONS(5709),
    [anon_sym_interface] = ACTIONS(3976),
    [anon_sym_delegate] = ACTIONS(3976),
    [anon_sym_record] = ACTIONS(3976),
    [anon_sym_abstract] = ACTIONS(3976),
    [anon_sym_async] = ACTIONS(3976),
    [anon_sym_const] = ACTIONS(3976),
    [anon_sym_file] = ACTIONS(3976),
    [anon_sym_fixed] = ACTIONS(3976),
    [anon_sym_internal] = ACTIONS(3976),
    [anon_sym_new] = ACTIONS(3976),
    [anon_sym_override] = ACTIONS(3976),
    [anon_sym_partial] = ACTIONS(3976),
    [anon_sym_private] = ACTIONS(3976),
    [anon_sym_protected] = ACTIONS(3976),
    [anon_sym_public] = ACTIONS(3976),
    [anon_sym_readonly] = ACTIONS(3976),
    [anon_sym_required] = ACTIONS(3976),
    [anon_sym_sealed] = ACTIONS(3976),
    [anon_sym_virtual] = ACTIONS(3976),
    [anon_sym_volatile] = ACTIONS(3976),
    [anon_sym_where] = ACTIONS(3976),
    [anon_sym_notnull] = ACTIONS(3976),
    [anon_sym_unmanaged] = ACTIONS(3976),
    [anon_sym_scoped] = ACTIONS(3976),
    [anon_sym_var] = ACTIONS(3976),
    [sym_predefined_type] = ACTIONS(3976),
    [anon_sym_yield] = ACTIONS(3976),
    [anon_sym_when] = ACTIONS(3976),
    [anon_sym_from] = ACTIONS(3976),
    [anon_sym_into] = ACTIONS(3976),
    [anon_sym_join] = ACTIONS(3976),
    [anon_sym_on] = ACTIONS(3976),
    [anon_sym_equals] = ACTIONS(3976),
    [anon_sym_let] = ACTIONS(3976),
    [anon_sym_orderby] = ACTIONS(3976),
    [anon_sym_ascending] = ACTIONS(3976),
    [anon_sym_descending] = ACTIONS(3976),
    [anon_sym_group] = ACTIONS(3976),
    [anon_sym_by] = ACTIONS(3976),
    [anon_sym_select] = ACTIONS(3976),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3841] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7021),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9910),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(3841),
    [sym_preproc_endregion] = STATE(3841),
    [sym_preproc_line] = STATE(3841),
    [sym_preproc_pragma] = STATE(3841),
    [sym_preproc_nullable] = STATE(3841),
    [sym_preproc_error] = STATE(3841),
    [sym_preproc_define] = STATE(3841),
    [sym_preproc_undef] = STATE(3841),
    [aux_sym_class_declaration_repeat1] = STATE(6230),
    [aux_sym_lambda_expression_repeat1] = STATE(4238),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(5212),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3842] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7017),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9735),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(3842),
    [sym_preproc_endregion] = STATE(3842),
    [sym_preproc_line] = STATE(3842),
    [sym_preproc_pragma] = STATE(3842),
    [sym_preproc_nullable] = STATE(3842),
    [sym_preproc_error] = STATE(3842),
    [sym_preproc_define] = STATE(3842),
    [sym_preproc_undef] = STATE(3842),
    [aux_sym_class_declaration_repeat1] = STATE(6230),
    [aux_sym_lambda_expression_repeat1] = STATE(4278),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(5212),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3843] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7118),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9781),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(3843),
    [sym_preproc_endregion] = STATE(3843),
    [sym_preproc_line] = STATE(3843),
    [sym_preproc_pragma] = STATE(3843),
    [sym_preproc_nullable] = STATE(3843),
    [sym_preproc_error] = STATE(3843),
    [sym_preproc_define] = STATE(3843),
    [sym_preproc_undef] = STATE(3843),
    [aux_sym_class_declaration_repeat1] = STATE(6230),
    [aux_sym_lambda_expression_repeat1] = STATE(4292),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(5212),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3844] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7128),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9593),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(3844),
    [sym_preproc_endregion] = STATE(3844),
    [sym_preproc_line] = STATE(3844),
    [sym_preproc_pragma] = STATE(3844),
    [sym_preproc_nullable] = STATE(3844),
    [sym_preproc_error] = STATE(3844),
    [sym_preproc_define] = STATE(3844),
    [sym_preproc_undef] = STATE(3844),
    [aux_sym_class_declaration_repeat1] = STATE(6230),
    [aux_sym_lambda_expression_repeat1] = STATE(4281),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(5212),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3845] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(6934),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9883),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(3845),
    [sym_preproc_endregion] = STATE(3845),
    [sym_preproc_line] = STATE(3845),
    [sym_preproc_pragma] = STATE(3845),
    [sym_preproc_nullable] = STATE(3845),
    [sym_preproc_error] = STATE(3845),
    [sym_preproc_define] = STATE(3845),
    [sym_preproc_undef] = STATE(3845),
    [aux_sym_class_declaration_repeat1] = STATE(6230),
    [aux_sym_lambda_expression_repeat1] = STATE(4185),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(5212),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3846] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7007),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9545),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(3846),
    [sym_preproc_endregion] = STATE(3846),
    [sym_preproc_line] = STATE(3846),
    [sym_preproc_pragma] = STATE(3846),
    [sym_preproc_nullable] = STATE(3846),
    [sym_preproc_error] = STATE(3846),
    [sym_preproc_define] = STATE(3846),
    [sym_preproc_undef] = STATE(3846),
    [aux_sym_class_declaration_repeat1] = STATE(6230),
    [aux_sym_lambda_expression_repeat1] = STATE(4147),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(5212),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3847] = {
    [sym_argument_list] = STATE(3868),
    [sym_initializer_expression] = STATE(4205),
    [sym_preproc_region] = STATE(3847),
    [sym_preproc_endregion] = STATE(3847),
    [sym_preproc_line] = STATE(3847),
    [sym_preproc_pragma] = STATE(3847),
    [sym_preproc_nullable] = STATE(3847),
    [sym_preproc_error] = STATE(3847),
    [sym_preproc_define] = STATE(3847),
    [sym_preproc_undef] = STATE(3847),
    [anon_sym_SEMI] = ACTIONS(5185),
    [anon_sym_LBRACK] = ACTIONS(5185),
    [anon_sym_COLON] = ACTIONS(5185),
    [anon_sym_COMMA] = ACTIONS(5185),
    [anon_sym_RBRACK] = ACTIONS(5185),
    [anon_sym_LPAREN] = ACTIONS(5711),
    [anon_sym_RPAREN] = ACTIONS(5185),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_RBRACE] = ACTIONS(5185),
    [anon_sym_LT] = ACTIONS(5189),
    [anon_sym_GT] = ACTIONS(5189),
    [anon_sym_in] = ACTIONS(5185),
    [anon_sym_QMARK] = ACTIONS(5189),
    [anon_sym_BANG] = ACTIONS(5189),
    [anon_sym_PLUS_PLUS] = ACTIONS(5185),
    [anon_sym_DASH_DASH] = ACTIONS(5185),
    [anon_sym_PLUS] = ACTIONS(5189),
    [anon_sym_DASH] = ACTIONS(5189),
    [anon_sym_STAR] = ACTIONS(5185),
    [anon_sym_SLASH] = ACTIONS(5189),
    [anon_sym_PERCENT] = ACTIONS(5185),
    [anon_sym_CARET] = ACTIONS(5185),
    [anon_sym_PIPE] = ACTIONS(5189),
    [anon_sym_AMP] = ACTIONS(5189),
    [anon_sym_LT_LT] = ACTIONS(5185),
    [anon_sym_GT_GT] = ACTIONS(5189),
    [anon_sym_GT_GT_GT] = ACTIONS(5185),
    [anon_sym_EQ_EQ] = ACTIONS(5185),
    [anon_sym_BANG_EQ] = ACTIONS(5185),
    [anon_sym_GT_EQ] = ACTIONS(5185),
    [anon_sym_LT_EQ] = ACTIONS(5185),
    [anon_sym_DOT] = ACTIONS(5189),
    [anon_sym_EQ_GT] = ACTIONS(5185),
    [anon_sym_switch] = ACTIONS(5185),
    [anon_sym_when] = ACTIONS(5185),
    [anon_sym_DOT_DOT] = ACTIONS(5185),
    [anon_sym_and] = ACTIONS(5185),
    [anon_sym_or] = ACTIONS(5185),
    [anon_sym_AMP_AMP] = ACTIONS(5185),
    [anon_sym_PIPE_PIPE] = ACTIONS(5185),
    [anon_sym_QMARK_QMARK] = ACTIONS(5185),
    [anon_sym_on] = ACTIONS(5185),
    [anon_sym_equals] = ACTIONS(5185),
    [anon_sym_by] = ACTIONS(5185),
    [anon_sym_as] = ACTIONS(5185),
    [anon_sym_is] = ACTIONS(5185),
    [anon_sym_DASH_GT] = ACTIONS(5185),
    [anon_sym_with] = ACTIONS(5185),
    [aux_sym_preproc_if_token3] = ACTIONS(5185),
    [aux_sym_preproc_else_token1] = ACTIONS(5185),
    [aux_sym_preproc_elif_token1] = ACTIONS(5185),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3848] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7037),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9492),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(3848),
    [sym_preproc_endregion] = STATE(3848),
    [sym_preproc_line] = STATE(3848),
    [sym_preproc_pragma] = STATE(3848),
    [sym_preproc_nullable] = STATE(3848),
    [sym_preproc_error] = STATE(3848),
    [sym_preproc_define] = STATE(3848),
    [sym_preproc_undef] = STATE(3848),
    [aux_sym_class_declaration_repeat1] = STATE(6230),
    [aux_sym_lambda_expression_repeat1] = STATE(4276),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(5212),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3849] = {
    [sym_argument_list] = STATE(3942),
    [sym_bracketed_argument_list] = STATE(3206),
    [sym_preproc_region] = STATE(3849),
    [sym_preproc_endregion] = STATE(3849),
    [sym_preproc_line] = STATE(3849),
    [sym_preproc_pragma] = STATE(3849),
    [sym_preproc_nullable] = STATE(3849),
    [sym_preproc_error] = STATE(3849),
    [sym_preproc_define] = STATE(3849),
    [sym_preproc_undef] = STATE(3849),
    [anon_sym_SEMI] = ACTIONS(5243),
    [anon_sym_LBRACK] = ACTIONS(5688),
    [anon_sym_COLON] = ACTIONS(5243),
    [anon_sym_COMMA] = ACTIONS(5243),
    [anon_sym_RBRACK] = ACTIONS(5243),
    [anon_sym_LPAREN] = ACTIONS(5669),
    [anon_sym_RPAREN] = ACTIONS(5243),
    [anon_sym_RBRACE] = ACTIONS(5243),
    [anon_sym_LT] = ACTIONS(5245),
    [anon_sym_GT] = ACTIONS(5245),
    [anon_sym_in] = ACTIONS(5245),
    [anon_sym_QMARK] = ACTIONS(5245),
    [anon_sym_BANG] = ACTIONS(5690),
    [anon_sym_PLUS_PLUS] = ACTIONS(5692),
    [anon_sym_DASH_DASH] = ACTIONS(5692),
    [anon_sym_PLUS] = ACTIONS(5245),
    [anon_sym_DASH] = ACTIONS(5245),
    [anon_sym_STAR] = ACTIONS(5243),
    [anon_sym_SLASH] = ACTIONS(5245),
    [anon_sym_PERCENT] = ACTIONS(5243),
    [anon_sym_CARET] = ACTIONS(5243),
    [anon_sym_PIPE] = ACTIONS(5245),
    [anon_sym_AMP] = ACTIONS(5245),
    [anon_sym_LT_LT] = ACTIONS(5243),
    [anon_sym_GT_GT] = ACTIONS(5245),
    [anon_sym_GT_GT_GT] = ACTIONS(5243),
    [anon_sym_EQ_EQ] = ACTIONS(5243),
    [anon_sym_BANG_EQ] = ACTIONS(5243),
    [anon_sym_GT_EQ] = ACTIONS(5243),
    [anon_sym_LT_EQ] = ACTIONS(5243),
    [anon_sym_DOT] = ACTIONS(4556),
    [anon_sym_EQ_GT] = ACTIONS(5243),
    [anon_sym_switch] = ACTIONS(5243),
    [anon_sym_when] = ACTIONS(5243),
    [anon_sym_DOT_DOT] = ACTIONS(5243),
    [anon_sym_and] = ACTIONS(5243),
    [anon_sym_or] = ACTIONS(5243),
    [anon_sym_AMP_AMP] = ACTIONS(5243),
    [anon_sym_PIPE_PIPE] = ACTIONS(5243),
    [anon_sym_QMARK_QMARK] = ACTIONS(5243),
    [anon_sym_into] = ACTIONS(5243),
    [anon_sym_on] = ACTIONS(5243),
    [anon_sym_equals] = ACTIONS(5243),
    [anon_sym_by] = ACTIONS(5243),
    [anon_sym_as] = ACTIONS(5243),
    [anon_sym_is] = ACTIONS(5243),
    [anon_sym_DASH_GT] = ACTIONS(4558),
    [anon_sym_with] = ACTIONS(5243),
    [aux_sym_preproc_if_token3] = ACTIONS(5243),
    [aux_sym_preproc_else_token1] = ACTIONS(5243),
    [aux_sym_preproc_elif_token1] = ACTIONS(5243),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3850] = {
    [sym_preproc_region] = STATE(3850),
    [sym_preproc_endregion] = STATE(3850),
    [sym_preproc_line] = STATE(3850),
    [sym_preproc_pragma] = STATE(3850),
    [sym_preproc_nullable] = STATE(3850),
    [sym_preproc_error] = STATE(3850),
    [sym_preproc_define] = STATE(3850),
    [sym_preproc_undef] = STATE(3850),
    [anon_sym_SEMI] = ACTIONS(3719),
    [anon_sym_LBRACK] = ACTIONS(3719),
    [anon_sym_COLON] = ACTIONS(3721),
    [anon_sym_COMMA] = ACTIONS(3719),
    [anon_sym_RBRACK] = ACTIONS(3719),
    [anon_sym_LPAREN] = ACTIONS(3719),
    [anon_sym_RPAREN] = ACTIONS(3719),
    [anon_sym_LBRACE] = ACTIONS(3719),
    [anon_sym_RBRACE] = ACTIONS(3719),
    [anon_sym_LT] = ACTIONS(3721),
    [anon_sym_GT] = ACTIONS(3721),
    [anon_sym_in] = ACTIONS(3721),
    [anon_sym_QMARK] = ACTIONS(3721),
    [anon_sym_BANG] = ACTIONS(3721),
    [anon_sym_PLUS_PLUS] = ACTIONS(3719),
    [anon_sym_DASH_DASH] = ACTIONS(3719),
    [anon_sym_PLUS] = ACTIONS(3721),
    [anon_sym_DASH] = ACTIONS(3721),
    [anon_sym_STAR] = ACTIONS(3719),
    [anon_sym_SLASH] = ACTIONS(3721),
    [anon_sym_PERCENT] = ACTIONS(3719),
    [anon_sym_CARET] = ACTIONS(3719),
    [anon_sym_PIPE] = ACTIONS(3721),
    [anon_sym_AMP] = ACTIONS(3721),
    [anon_sym_LT_LT] = ACTIONS(3719),
    [anon_sym_GT_GT] = ACTIONS(3721),
    [anon_sym_GT_GT_GT] = ACTIONS(3719),
    [anon_sym_EQ_EQ] = ACTIONS(3719),
    [anon_sym_BANG_EQ] = ACTIONS(3719),
    [anon_sym_GT_EQ] = ACTIONS(3719),
    [anon_sym_LT_EQ] = ACTIONS(3719),
    [anon_sym_DOT] = ACTIONS(3721),
    [anon_sym_EQ_GT] = ACTIONS(3719),
    [anon_sym_COLON_COLON] = ACTIONS(3719),
    [anon_sym_switch] = ACTIONS(3719),
    [anon_sym_when] = ACTIONS(3719),
    [anon_sym_DOT_DOT] = ACTIONS(3719),
    [anon_sym_and] = ACTIONS(3719),
    [anon_sym_or] = ACTIONS(3719),
    [anon_sym_AMP_AMP] = ACTIONS(3719),
    [anon_sym_PIPE_PIPE] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK] = ACTIONS(3719),
    [anon_sym_into] = ACTIONS(3719),
    [anon_sym_on] = ACTIONS(3719),
    [anon_sym_equals] = ACTIONS(3719),
    [anon_sym_by] = ACTIONS(3719),
    [anon_sym_as] = ACTIONS(3719),
    [anon_sym_is] = ACTIONS(3719),
    [anon_sym_DASH_GT] = ACTIONS(3719),
    [anon_sym_with] = ACTIONS(3719),
    [aux_sym_preproc_if_token3] = ACTIONS(3719),
    [aux_sym_preproc_else_token1] = ACTIONS(3719),
    [aux_sym_preproc_elif_token1] = ACTIONS(3719),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3851] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(6928),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9612),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(3851),
    [sym_preproc_endregion] = STATE(3851),
    [sym_preproc_line] = STATE(3851),
    [sym_preproc_pragma] = STATE(3851),
    [sym_preproc_nullable] = STATE(3851),
    [sym_preproc_error] = STATE(3851),
    [sym_preproc_define] = STATE(3851),
    [sym_preproc_undef] = STATE(3851),
    [aux_sym_class_declaration_repeat1] = STATE(6230),
    [aux_sym_lambda_expression_repeat1] = STATE(4232),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(5212),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3852] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7112),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9034),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(3852),
    [sym_preproc_endregion] = STATE(3852),
    [sym_preproc_line] = STATE(3852),
    [sym_preproc_pragma] = STATE(3852),
    [sym_preproc_nullable] = STATE(3852),
    [sym_preproc_error] = STATE(3852),
    [sym_preproc_define] = STATE(3852),
    [sym_preproc_undef] = STATE(3852),
    [aux_sym_class_declaration_repeat1] = STATE(6230),
    [aux_sym_lambda_expression_repeat1] = STATE(4226),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(5212),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3853] = {
    [sym_type_argument_list] = STATE(3909),
    [sym_preproc_region] = STATE(3853),
    [sym_preproc_endregion] = STATE(3853),
    [sym_preproc_line] = STATE(3853),
    [sym_preproc_pragma] = STATE(3853),
    [sym_preproc_nullable] = STATE(3853),
    [sym_preproc_error] = STATE(3853),
    [sym_preproc_define] = STATE(3853),
    [sym_preproc_undef] = STATE(3853),
    [anon_sym_EQ] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4076),
    [anon_sym_COLON] = ACTIONS(4076),
    [anon_sym_COMMA] = ACTIONS(4076),
    [anon_sym_LPAREN] = ACTIONS(4076),
    [anon_sym_LT] = ACTIONS(5713),
    [anon_sym_GT] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(4074),
    [anon_sym_BANG] = ACTIONS(4074),
    [anon_sym_PLUS_PLUS] = ACTIONS(4076),
    [anon_sym_DASH_DASH] = ACTIONS(4076),
    [anon_sym_PLUS] = ACTIONS(4074),
    [anon_sym_DASH] = ACTIONS(4074),
    [anon_sym_STAR] = ACTIONS(4074),
    [anon_sym_SLASH] = ACTIONS(4074),
    [anon_sym_PERCENT] = ACTIONS(4074),
    [anon_sym_CARET] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(4074),
    [anon_sym_AMP] = ACTIONS(4074),
    [anon_sym_LT_LT] = ACTIONS(4074),
    [anon_sym_GT_GT] = ACTIONS(4074),
    [anon_sym_GT_GT_GT] = ACTIONS(4074),
    [anon_sym_EQ_EQ] = ACTIONS(4076),
    [anon_sym_BANG_EQ] = ACTIONS(4076),
    [anon_sym_GT_EQ] = ACTIONS(4076),
    [anon_sym_LT_EQ] = ACTIONS(4076),
    [anon_sym_DOT] = ACTIONS(4074),
    [anon_sym_switch] = ACTIONS(4076),
    [anon_sym_DOT_DOT] = ACTIONS(4076),
    [anon_sym_and] = ACTIONS(4076),
    [anon_sym_or] = ACTIONS(4076),
    [anon_sym_PLUS_EQ] = ACTIONS(4076),
    [anon_sym_DASH_EQ] = ACTIONS(4076),
    [anon_sym_STAR_EQ] = ACTIONS(4076),
    [anon_sym_SLASH_EQ] = ACTIONS(4076),
    [anon_sym_PERCENT_EQ] = ACTIONS(4076),
    [anon_sym_AMP_EQ] = ACTIONS(4076),
    [anon_sym_CARET_EQ] = ACTIONS(4076),
    [anon_sym_PIPE_EQ] = ACTIONS(4076),
    [anon_sym_LT_LT_EQ] = ACTIONS(4076),
    [anon_sym_GT_GT_EQ] = ACTIONS(4076),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4076),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4076),
    [anon_sym_AMP_AMP] = ACTIONS(4076),
    [anon_sym_PIPE_PIPE] = ACTIONS(4076),
    [anon_sym_QMARK_QMARK] = ACTIONS(4074),
    [anon_sym_into] = ACTIONS(4076),
    [anon_sym_as] = ACTIONS(4076),
    [anon_sym_is] = ACTIONS(4076),
    [anon_sym_DASH_GT] = ACTIONS(4076),
    [anon_sym_with] = ACTIONS(4076),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4076),
  },
  [3854] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7036),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9074),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(3854),
    [sym_preproc_endregion] = STATE(3854),
    [sym_preproc_line] = STATE(3854),
    [sym_preproc_pragma] = STATE(3854),
    [sym_preproc_nullable] = STATE(3854),
    [sym_preproc_error] = STATE(3854),
    [sym_preproc_define] = STATE(3854),
    [sym_preproc_undef] = STATE(3854),
    [aux_sym_class_declaration_repeat1] = STATE(6230),
    [aux_sym_lambda_expression_repeat1] = STATE(4233),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(5212),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3855] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7019),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9139),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(3855),
    [sym_preproc_endregion] = STATE(3855),
    [sym_preproc_line] = STATE(3855),
    [sym_preproc_pragma] = STATE(3855),
    [sym_preproc_nullable] = STATE(3855),
    [sym_preproc_error] = STATE(3855),
    [sym_preproc_define] = STATE(3855),
    [sym_preproc_undef] = STATE(3855),
    [aux_sym_class_declaration_repeat1] = STATE(6230),
    [aux_sym_lambda_expression_repeat1] = STATE(4253),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(5212),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3856] = {
    [sym_preproc_region] = STATE(3856),
    [sym_preproc_endregion] = STATE(3856),
    [sym_preproc_line] = STATE(3856),
    [sym_preproc_pragma] = STATE(3856),
    [sym_preproc_nullable] = STATE(3856),
    [sym_preproc_error] = STATE(3856),
    [sym_preproc_define] = STATE(3856),
    [sym_preproc_undef] = STATE(3856),
    [anon_sym_EQ] = ACTIONS(4118),
    [anon_sym_LBRACK] = ACTIONS(4133),
    [anon_sym_COLON] = ACTIONS(4133),
    [anon_sym_COMMA] = ACTIONS(4739),
    [anon_sym_RBRACK] = ACTIONS(4739),
    [anon_sym_LPAREN] = ACTIONS(4133),
    [anon_sym_RPAREN] = ACTIONS(4739),
    [anon_sym_RBRACE] = ACTIONS(4739),
    [anon_sym_LT] = ACTIONS(4118),
    [anon_sym_GT] = ACTIONS(4118),
    [anon_sym_QMARK] = ACTIONS(4118),
    [anon_sym_BANG] = ACTIONS(4118),
    [anon_sym_PLUS_PLUS] = ACTIONS(4133),
    [anon_sym_DASH_DASH] = ACTIONS(4133),
    [anon_sym_PLUS] = ACTIONS(4118),
    [anon_sym_DASH] = ACTIONS(4118),
    [anon_sym_STAR] = ACTIONS(4118),
    [anon_sym_SLASH] = ACTIONS(4118),
    [anon_sym_PERCENT] = ACTIONS(4118),
    [anon_sym_CARET] = ACTIONS(4118),
    [anon_sym_PIPE] = ACTIONS(4118),
    [anon_sym_AMP] = ACTIONS(4118),
    [anon_sym_LT_LT] = ACTIONS(4118),
    [anon_sym_GT_GT] = ACTIONS(4118),
    [anon_sym_GT_GT_GT] = ACTIONS(4118),
    [anon_sym_EQ_EQ] = ACTIONS(4133),
    [anon_sym_BANG_EQ] = ACTIONS(4133),
    [anon_sym_GT_EQ] = ACTIONS(4133),
    [anon_sym_LT_EQ] = ACTIONS(4133),
    [anon_sym_DOT] = ACTIONS(4118),
    [anon_sym_switch] = ACTIONS(4133),
    [anon_sym_DOT_DOT] = ACTIONS(4133),
    [anon_sym_and] = ACTIONS(4739),
    [anon_sym_or] = ACTIONS(4739),
    [anon_sym_PLUS_EQ] = ACTIONS(4133),
    [anon_sym_DASH_EQ] = ACTIONS(4133),
    [anon_sym_STAR_EQ] = ACTIONS(4133),
    [anon_sym_SLASH_EQ] = ACTIONS(4133),
    [anon_sym_PERCENT_EQ] = ACTIONS(4133),
    [anon_sym_AMP_EQ] = ACTIONS(4133),
    [anon_sym_CARET_EQ] = ACTIONS(4133),
    [anon_sym_PIPE_EQ] = ACTIONS(4133),
    [anon_sym_LT_LT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4133),
    [anon_sym_AMP_AMP] = ACTIONS(4133),
    [anon_sym_PIPE_PIPE] = ACTIONS(4133),
    [anon_sym_QMARK_QMARK] = ACTIONS(4118),
    [anon_sym_as] = ACTIONS(4133),
    [anon_sym_is] = ACTIONS(4133),
    [anon_sym_DASH_GT] = ACTIONS(4133),
    [anon_sym_with] = ACTIONS(4133),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3857] = {
    [sym_attribute_list] = STATE(6703),
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(6923),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9111),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(3857),
    [sym_preproc_endregion] = STATE(3857),
    [sym_preproc_line] = STATE(3857),
    [sym_preproc_pragma] = STATE(3857),
    [sym_preproc_nullable] = STATE(3857),
    [sym_preproc_error] = STATE(3857),
    [sym_preproc_define] = STATE(3857),
    [sym_preproc_undef] = STATE(3857),
    [aux_sym_class_declaration_repeat1] = STATE(6230),
    [aux_sym_lambda_expression_repeat1] = STATE(4243),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(5212),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3858] = {
    [sym_preproc_region] = STATE(3858),
    [sym_preproc_endregion] = STATE(3858),
    [sym_preproc_line] = STATE(3858),
    [sym_preproc_pragma] = STATE(3858),
    [sym_preproc_nullable] = STATE(3858),
    [sym_preproc_error] = STATE(3858),
    [sym_preproc_define] = STATE(3858),
    [sym_preproc_undef] = STATE(3858),
    [anon_sym_SEMI] = ACTIONS(5249),
    [anon_sym_EQ] = ACTIONS(5716),
    [anon_sym_LBRACK] = ACTIONS(5249),
    [anon_sym_COMMA] = ACTIONS(5249),
    [anon_sym_RBRACK] = ACTIONS(5249),
    [anon_sym_LPAREN] = ACTIONS(5249),
    [anon_sym_RPAREN] = ACTIONS(5249),
    [anon_sym_RBRACE] = ACTIONS(5249),
    [anon_sym_LT] = ACTIONS(5251),
    [anon_sym_GT] = ACTIONS(5251),
    [anon_sym_QMARK] = ACTIONS(5251),
    [anon_sym_BANG] = ACTIONS(5251),
    [anon_sym_PLUS_PLUS] = ACTIONS(5249),
    [anon_sym_DASH_DASH] = ACTIONS(5249),
    [anon_sym_PLUS] = ACTIONS(5251),
    [anon_sym_DASH] = ACTIONS(5251),
    [anon_sym_STAR] = ACTIONS(5251),
    [anon_sym_SLASH] = ACTIONS(5251),
    [anon_sym_PERCENT] = ACTIONS(5251),
    [anon_sym_CARET] = ACTIONS(5251),
    [anon_sym_PIPE] = ACTIONS(5251),
    [anon_sym_AMP] = ACTIONS(5251),
    [anon_sym_LT_LT] = ACTIONS(5251),
    [anon_sym_GT_GT] = ACTIONS(5251),
    [anon_sym_GT_GT_GT] = ACTIONS(5251),
    [anon_sym_EQ_EQ] = ACTIONS(5249),
    [anon_sym_BANG_EQ] = ACTIONS(5249),
    [anon_sym_GT_EQ] = ACTIONS(5249),
    [anon_sym_LT_EQ] = ACTIONS(5249),
    [anon_sym_DOT] = ACTIONS(5251),
    [anon_sym_switch] = ACTIONS(5249),
    [anon_sym_DOT_DOT] = ACTIONS(5249),
    [anon_sym_and] = ACTIONS(5249),
    [anon_sym_or] = ACTIONS(5249),
    [anon_sym_PLUS_EQ] = ACTIONS(5718),
    [anon_sym_DASH_EQ] = ACTIONS(5718),
    [anon_sym_STAR_EQ] = ACTIONS(5718),
    [anon_sym_SLASH_EQ] = ACTIONS(5718),
    [anon_sym_PERCENT_EQ] = ACTIONS(5718),
    [anon_sym_AMP_EQ] = ACTIONS(5718),
    [anon_sym_CARET_EQ] = ACTIONS(5718),
    [anon_sym_PIPE_EQ] = ACTIONS(5718),
    [anon_sym_LT_LT_EQ] = ACTIONS(5718),
    [anon_sym_GT_GT_EQ] = ACTIONS(5718),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5718),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(5718),
    [anon_sym_AMP_AMP] = ACTIONS(5249),
    [anon_sym_PIPE_PIPE] = ACTIONS(5249),
    [anon_sym_QMARK_QMARK] = ACTIONS(5251),
    [anon_sym_as] = ACTIONS(5249),
    [anon_sym_is] = ACTIONS(5249),
    [anon_sym_DASH_GT] = ACTIONS(5249),
    [anon_sym_with] = ACTIONS(5249),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3859] = {
    [sym_preproc_region] = STATE(3859),
    [sym_preproc_endregion] = STATE(3859),
    [sym_preproc_line] = STATE(3859),
    [sym_preproc_pragma] = STATE(3859),
    [sym_preproc_nullable] = STATE(3859),
    [sym_preproc_error] = STATE(3859),
    [sym_preproc_define] = STATE(3859),
    [sym_preproc_undef] = STATE(3859),
    [anon_sym_SEMI] = ACTIONS(4024),
    [anon_sym_LBRACK] = ACTIONS(4024),
    [anon_sym_COLON] = ACTIONS(4027),
    [anon_sym_COMMA] = ACTIONS(4024),
    [anon_sym_RBRACK] = ACTIONS(4024),
    [anon_sym_LPAREN] = ACTIONS(4024),
    [anon_sym_RPAREN] = ACTIONS(4024),
    [anon_sym_LBRACE] = ACTIONS(4024),
    [anon_sym_RBRACE] = ACTIONS(4024),
    [anon_sym_LT] = ACTIONS(4027),
    [anon_sym_GT] = ACTIONS(4027),
    [anon_sym_in] = ACTIONS(4027),
    [anon_sym_QMARK] = ACTIONS(4027),
    [anon_sym_BANG] = ACTIONS(4027),
    [anon_sym_PLUS_PLUS] = ACTIONS(4024),
    [anon_sym_DASH_DASH] = ACTIONS(4024),
    [anon_sym_PLUS] = ACTIONS(4027),
    [anon_sym_DASH] = ACTIONS(4027),
    [anon_sym_STAR] = ACTIONS(4024),
    [anon_sym_SLASH] = ACTIONS(4027),
    [anon_sym_PERCENT] = ACTIONS(4024),
    [anon_sym_CARET] = ACTIONS(4024),
    [anon_sym_PIPE] = ACTIONS(4027),
    [anon_sym_AMP] = ACTIONS(4027),
    [anon_sym_LT_LT] = ACTIONS(4024),
    [anon_sym_GT_GT] = ACTIONS(4027),
    [anon_sym_GT_GT_GT] = ACTIONS(4024),
    [anon_sym_EQ_EQ] = ACTIONS(4024),
    [anon_sym_BANG_EQ] = ACTIONS(4024),
    [anon_sym_GT_EQ] = ACTIONS(4024),
    [anon_sym_LT_EQ] = ACTIONS(4024),
    [anon_sym_DOT] = ACTIONS(4027),
    [anon_sym_EQ_GT] = ACTIONS(4024),
    [anon_sym_COLON_COLON] = ACTIONS(3719),
    [anon_sym_switch] = ACTIONS(4024),
    [anon_sym_when] = ACTIONS(4024),
    [anon_sym_DOT_DOT] = ACTIONS(4024),
    [anon_sym_and] = ACTIONS(4024),
    [anon_sym_or] = ACTIONS(4024),
    [anon_sym_AMP_AMP] = ACTIONS(4024),
    [anon_sym_PIPE_PIPE] = ACTIONS(4024),
    [anon_sym_QMARK_QMARK] = ACTIONS(4024),
    [anon_sym_into] = ACTIONS(4024),
    [anon_sym_on] = ACTIONS(4024),
    [anon_sym_equals] = ACTIONS(4024),
    [anon_sym_by] = ACTIONS(4024),
    [anon_sym_as] = ACTIONS(4024),
    [anon_sym_is] = ACTIONS(4024),
    [anon_sym_DASH_GT] = ACTIONS(4024),
    [anon_sym_with] = ACTIONS(4024),
    [aux_sym_preproc_if_token3] = ACTIONS(4024),
    [aux_sym_preproc_else_token1] = ACTIONS(4024),
    [aux_sym_preproc_elif_token1] = ACTIONS(4024),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3860] = {
    [sym_preproc_region] = STATE(3860),
    [sym_preproc_endregion] = STATE(3860),
    [sym_preproc_line] = STATE(3860),
    [sym_preproc_pragma] = STATE(3860),
    [sym_preproc_nullable] = STATE(3860),
    [sym_preproc_error] = STATE(3860),
    [sym_preproc_define] = STATE(3860),
    [sym_preproc_undef] = STATE(3860),
    [anon_sym_SEMI] = ACTIONS(4476),
    [anon_sym_LBRACK] = ACTIONS(4476),
    [anon_sym_COLON] = ACTIONS(4476),
    [anon_sym_COMMA] = ACTIONS(4476),
    [anon_sym_RBRACK] = ACTIONS(4476),
    [anon_sym_LPAREN] = ACTIONS(4476),
    [anon_sym_RPAREN] = ACTIONS(4476),
    [anon_sym_LBRACE] = ACTIONS(4476),
    [anon_sym_RBRACE] = ACTIONS(4476),
    [anon_sym_LT] = ACTIONS(4474),
    [anon_sym_GT] = ACTIONS(4474),
    [anon_sym_in] = ACTIONS(4474),
    [anon_sym_QMARK] = ACTIONS(4474),
    [anon_sym_BANG] = ACTIONS(4474),
    [anon_sym_PLUS_PLUS] = ACTIONS(4476),
    [anon_sym_DASH_DASH] = ACTIONS(4476),
    [anon_sym_PLUS] = ACTIONS(4474),
    [anon_sym_DASH] = ACTIONS(4474),
    [anon_sym_STAR] = ACTIONS(4476),
    [anon_sym_SLASH] = ACTIONS(4474),
    [anon_sym_PERCENT] = ACTIONS(4476),
    [anon_sym_CARET] = ACTIONS(4476),
    [anon_sym_PIPE] = ACTIONS(4474),
    [anon_sym_AMP] = ACTIONS(4474),
    [anon_sym_LT_LT] = ACTIONS(4476),
    [anon_sym_GT_GT] = ACTIONS(4474),
    [anon_sym_GT_GT_GT] = ACTIONS(4476),
    [anon_sym_EQ_EQ] = ACTIONS(4476),
    [anon_sym_BANG_EQ] = ACTIONS(4476),
    [anon_sym_GT_EQ] = ACTIONS(4476),
    [anon_sym_LT_EQ] = ACTIONS(4476),
    [anon_sym_DOT] = ACTIONS(4474),
    [anon_sym_EQ_GT] = ACTIONS(4476),
    [anon_sym_switch] = ACTIONS(4476),
    [anon_sym_when] = ACTIONS(4476),
    [anon_sym_DOT_DOT] = ACTIONS(4476),
    [anon_sym_and] = ACTIONS(4476),
    [anon_sym_or] = ACTIONS(4476),
    [anon_sym_AMP_AMP] = ACTIONS(4476),
    [anon_sym_PIPE_PIPE] = ACTIONS(4476),
    [anon_sym_QMARK_QMARK] = ACTIONS(4476),
    [anon_sym_into] = ACTIONS(4476),
    [anon_sym_on] = ACTIONS(4476),
    [anon_sym_equals] = ACTIONS(4476),
    [anon_sym_by] = ACTIONS(4476),
    [anon_sym_as] = ACTIONS(4476),
    [anon_sym_is] = ACTIONS(4476),
    [anon_sym_DASH_GT] = ACTIONS(4476),
    [anon_sym_with] = ACTIONS(4476),
    [aux_sym_preproc_if_token3] = ACTIONS(4476),
    [aux_sym_preproc_else_token1] = ACTIONS(4476),
    [aux_sym_preproc_elif_token1] = ACTIONS(4476),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3861] = {
    [sym_preproc_region] = STATE(3861),
    [sym_preproc_endregion] = STATE(3861),
    [sym_preproc_line] = STATE(3861),
    [sym_preproc_pragma] = STATE(3861),
    [sym_preproc_nullable] = STATE(3861),
    [sym_preproc_error] = STATE(3861),
    [sym_preproc_define] = STATE(3861),
    [sym_preproc_undef] = STATE(3861),
    [anon_sym_SEMI] = ACTIONS(4420),
    [anon_sym_LBRACK] = ACTIONS(4420),
    [anon_sym_COLON] = ACTIONS(4420),
    [anon_sym_COMMA] = ACTIONS(4420),
    [anon_sym_RBRACK] = ACTIONS(4420),
    [anon_sym_LPAREN] = ACTIONS(4420),
    [anon_sym_RPAREN] = ACTIONS(4420),
    [anon_sym_LBRACE] = ACTIONS(4420),
    [anon_sym_RBRACE] = ACTIONS(4420),
    [anon_sym_LT] = ACTIONS(4418),
    [anon_sym_GT] = ACTIONS(4418),
    [anon_sym_in] = ACTIONS(4418),
    [anon_sym_QMARK] = ACTIONS(4418),
    [anon_sym_BANG] = ACTIONS(4418),
    [anon_sym_PLUS_PLUS] = ACTIONS(4420),
    [anon_sym_DASH_DASH] = ACTIONS(4420),
    [anon_sym_PLUS] = ACTIONS(4418),
    [anon_sym_DASH] = ACTIONS(4418),
    [anon_sym_STAR] = ACTIONS(4420),
    [anon_sym_SLASH] = ACTIONS(4418),
    [anon_sym_PERCENT] = ACTIONS(4420),
    [anon_sym_CARET] = ACTIONS(4420),
    [anon_sym_PIPE] = ACTIONS(4418),
    [anon_sym_AMP] = ACTIONS(4418),
    [anon_sym_LT_LT] = ACTIONS(4420),
    [anon_sym_GT_GT] = ACTIONS(4418),
    [anon_sym_GT_GT_GT] = ACTIONS(4420),
    [anon_sym_EQ_EQ] = ACTIONS(4420),
    [anon_sym_BANG_EQ] = ACTIONS(4420),
    [anon_sym_GT_EQ] = ACTIONS(4420),
    [anon_sym_LT_EQ] = ACTIONS(4420),
    [anon_sym_DOT] = ACTIONS(4418),
    [anon_sym_EQ_GT] = ACTIONS(4420),
    [anon_sym_switch] = ACTIONS(4420),
    [anon_sym_when] = ACTIONS(4420),
    [anon_sym_DOT_DOT] = ACTIONS(4420),
    [anon_sym_and] = ACTIONS(4420),
    [anon_sym_or] = ACTIONS(4420),
    [anon_sym_AMP_AMP] = ACTIONS(4420),
    [anon_sym_PIPE_PIPE] = ACTIONS(4420),
    [anon_sym_QMARK_QMARK] = ACTIONS(4420),
    [anon_sym_into] = ACTIONS(4420),
    [anon_sym_on] = ACTIONS(4420),
    [anon_sym_equals] = ACTIONS(4420),
    [anon_sym_by] = ACTIONS(4420),
    [anon_sym_as] = ACTIONS(4420),
    [anon_sym_is] = ACTIONS(4420),
    [anon_sym_DASH_GT] = ACTIONS(4420),
    [anon_sym_with] = ACTIONS(4420),
    [aux_sym_preproc_if_token3] = ACTIONS(4420),
    [aux_sym_preproc_else_token1] = ACTIONS(4420),
    [aux_sym_preproc_elif_token1] = ACTIONS(4420),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3862] = {
    [sym_preproc_region] = STATE(3862),
    [sym_preproc_endregion] = STATE(3862),
    [sym_preproc_line] = STATE(3862),
    [sym_preproc_pragma] = STATE(3862),
    [sym_preproc_nullable] = STATE(3862),
    [sym_preproc_error] = STATE(3862),
    [sym_preproc_define] = STATE(3862),
    [sym_preproc_undef] = STATE(3862),
    [anon_sym_EQ] = ACTIONS(4104),
    [anon_sym_LBRACK] = ACTIONS(4111),
    [anon_sym_COLON] = ACTIONS(4111),
    [anon_sym_COMMA] = ACTIONS(4111),
    [anon_sym_LPAREN] = ACTIONS(4111),
    [anon_sym_LT] = ACTIONS(4104),
    [anon_sym_GT] = ACTIONS(4104),
    [anon_sym_QMARK] = ACTIONS(4104),
    [anon_sym_BANG] = ACTIONS(4104),
    [anon_sym_PLUS_PLUS] = ACTIONS(4111),
    [anon_sym_DASH_DASH] = ACTIONS(4111),
    [anon_sym_PLUS] = ACTIONS(4104),
    [anon_sym_DASH] = ACTIONS(4104),
    [anon_sym_STAR] = ACTIONS(4104),
    [anon_sym_SLASH] = ACTIONS(4104),
    [anon_sym_PERCENT] = ACTIONS(4104),
    [anon_sym_CARET] = ACTIONS(4104),
    [anon_sym_PIPE] = ACTIONS(4104),
    [anon_sym_AMP] = ACTIONS(4104),
    [anon_sym_LT_LT] = ACTIONS(4104),
    [anon_sym_GT_GT] = ACTIONS(4104),
    [anon_sym_GT_GT_GT] = ACTIONS(4104),
    [anon_sym_EQ_EQ] = ACTIONS(4111),
    [anon_sym_BANG_EQ] = ACTIONS(4111),
    [anon_sym_GT_EQ] = ACTIONS(4111),
    [anon_sym_LT_EQ] = ACTIONS(4111),
    [anon_sym_DOT] = ACTIONS(4104),
    [anon_sym_switch] = ACTIONS(4111),
    [anon_sym_DOT_DOT] = ACTIONS(4111),
    [anon_sym_and] = ACTIONS(4111),
    [anon_sym_or] = ACTIONS(4111),
    [anon_sym_PLUS_EQ] = ACTIONS(4111),
    [anon_sym_DASH_EQ] = ACTIONS(4111),
    [anon_sym_STAR_EQ] = ACTIONS(4111),
    [anon_sym_SLASH_EQ] = ACTIONS(4111),
    [anon_sym_PERCENT_EQ] = ACTIONS(4111),
    [anon_sym_AMP_EQ] = ACTIONS(4111),
    [anon_sym_CARET_EQ] = ACTIONS(4111),
    [anon_sym_PIPE_EQ] = ACTIONS(4111),
    [anon_sym_LT_LT_EQ] = ACTIONS(4111),
    [anon_sym_GT_GT_EQ] = ACTIONS(4111),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4111),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4111),
    [anon_sym_AMP_AMP] = ACTIONS(4111),
    [anon_sym_PIPE_PIPE] = ACTIONS(4111),
    [anon_sym_QMARK_QMARK] = ACTIONS(4104),
    [anon_sym_into] = ACTIONS(4111),
    [anon_sym_as] = ACTIONS(4111),
    [anon_sym_is] = ACTIONS(4111),
    [anon_sym_DASH_GT] = ACTIONS(4111),
    [anon_sym_with] = ACTIONS(4111),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4111),
  },
  [3863] = {
    [sym_preproc_region] = STATE(3863),
    [sym_preproc_endregion] = STATE(3863),
    [sym_preproc_line] = STATE(3863),
    [sym_preproc_pragma] = STATE(3863),
    [sym_preproc_nullable] = STATE(3863),
    [sym_preproc_error] = STATE(3863),
    [sym_preproc_define] = STATE(3863),
    [sym_preproc_undef] = STATE(3863),
    [anon_sym_EQ] = ACTIONS(5720),
    [anon_sym_LBRACK] = ACTIONS(5249),
    [anon_sym_COLON] = ACTIONS(5249),
    [anon_sym_COMMA] = ACTIONS(5249),
    [anon_sym_LPAREN] = ACTIONS(5249),
    [anon_sym_RPAREN] = ACTIONS(5249),
    [anon_sym_RBRACE] = ACTIONS(5249),
    [anon_sym_LT] = ACTIONS(5251),
    [anon_sym_GT] = ACTIONS(5251),
    [anon_sym_QMARK] = ACTIONS(5251),
    [anon_sym_BANG] = ACTIONS(5251),
    [anon_sym_PLUS_PLUS] = ACTIONS(5249),
    [anon_sym_DASH_DASH] = ACTIONS(5249),
    [anon_sym_PLUS] = ACTIONS(5251),
    [anon_sym_DASH] = ACTIONS(5251),
    [anon_sym_STAR] = ACTIONS(5251),
    [anon_sym_SLASH] = ACTIONS(5251),
    [anon_sym_PERCENT] = ACTIONS(5251),
    [anon_sym_CARET] = ACTIONS(5251),
    [anon_sym_PIPE] = ACTIONS(5251),
    [anon_sym_AMP] = ACTIONS(5251),
    [anon_sym_LT_LT] = ACTIONS(5251),
    [anon_sym_GT_GT] = ACTIONS(5251),
    [anon_sym_GT_GT_GT] = ACTIONS(5251),
    [anon_sym_EQ_EQ] = ACTIONS(5249),
    [anon_sym_BANG_EQ] = ACTIONS(5249),
    [anon_sym_GT_EQ] = ACTIONS(5249),
    [anon_sym_LT_EQ] = ACTIONS(5249),
    [anon_sym_DOT] = ACTIONS(5251),
    [anon_sym_switch] = ACTIONS(5249),
    [anon_sym_DOT_DOT] = ACTIONS(5249),
    [anon_sym_and] = ACTIONS(5249),
    [anon_sym_or] = ACTIONS(5249),
    [anon_sym_PLUS_EQ] = ACTIONS(5722),
    [anon_sym_DASH_EQ] = ACTIONS(5722),
    [anon_sym_STAR_EQ] = ACTIONS(5722),
    [anon_sym_SLASH_EQ] = ACTIONS(5722),
    [anon_sym_PERCENT_EQ] = ACTIONS(5722),
    [anon_sym_AMP_EQ] = ACTIONS(5722),
    [anon_sym_CARET_EQ] = ACTIONS(5722),
    [anon_sym_PIPE_EQ] = ACTIONS(5722),
    [anon_sym_LT_LT_EQ] = ACTIONS(5722),
    [anon_sym_GT_GT_EQ] = ACTIONS(5722),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5722),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(5722),
    [anon_sym_AMP_AMP] = ACTIONS(5249),
    [anon_sym_PIPE_PIPE] = ACTIONS(5249),
    [anon_sym_QMARK_QMARK] = ACTIONS(5251),
    [anon_sym_as] = ACTIONS(5249),
    [anon_sym_is] = ACTIONS(5249),
    [anon_sym_DASH_GT] = ACTIONS(5249),
    [anon_sym_with] = ACTIONS(5249),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3864] = {
    [sym_preproc_region] = STATE(3864),
    [sym_preproc_endregion] = STATE(3864),
    [sym_preproc_line] = STATE(3864),
    [sym_preproc_pragma] = STATE(3864),
    [sym_preproc_nullable] = STATE(3864),
    [sym_preproc_error] = STATE(3864),
    [sym_preproc_define] = STATE(3864),
    [sym_preproc_undef] = STATE(3864),
    [anon_sym_EQ] = ACTIONS(4606),
    [anon_sym_LBRACK] = ACTIONS(4604),
    [anon_sym_COLON] = ACTIONS(4604),
    [anon_sym_COMMA] = ACTIONS(4604),
    [anon_sym_LPAREN] = ACTIONS(4604),
    [anon_sym_LT] = ACTIONS(4606),
    [anon_sym_GT] = ACTIONS(4606),
    [anon_sym_QMARK] = ACTIONS(4606),
    [anon_sym_BANG] = ACTIONS(4606),
    [anon_sym_PLUS_PLUS] = ACTIONS(4604),
    [anon_sym_DASH_DASH] = ACTIONS(4604),
    [anon_sym_PLUS] = ACTIONS(4606),
    [anon_sym_DASH] = ACTIONS(4606),
    [anon_sym_STAR] = ACTIONS(4606),
    [anon_sym_SLASH] = ACTIONS(4606),
    [anon_sym_PERCENT] = ACTIONS(4606),
    [anon_sym_CARET] = ACTIONS(4606),
    [anon_sym_PIPE] = ACTIONS(4606),
    [anon_sym_AMP] = ACTIONS(4606),
    [anon_sym_LT_LT] = ACTIONS(4606),
    [anon_sym_GT_GT] = ACTIONS(4606),
    [anon_sym_GT_GT_GT] = ACTIONS(4606),
    [anon_sym_EQ_EQ] = ACTIONS(4604),
    [anon_sym_BANG_EQ] = ACTIONS(4604),
    [anon_sym_GT_EQ] = ACTIONS(4604),
    [anon_sym_LT_EQ] = ACTIONS(4604),
    [anon_sym_DOT] = ACTIONS(4606),
    [anon_sym_switch] = ACTIONS(4604),
    [anon_sym_DOT_DOT] = ACTIONS(4604),
    [anon_sym_and] = ACTIONS(4604),
    [anon_sym_or] = ACTIONS(4604),
    [anon_sym_PLUS_EQ] = ACTIONS(4604),
    [anon_sym_DASH_EQ] = ACTIONS(4604),
    [anon_sym_STAR_EQ] = ACTIONS(4604),
    [anon_sym_SLASH_EQ] = ACTIONS(4604),
    [anon_sym_PERCENT_EQ] = ACTIONS(4604),
    [anon_sym_AMP_EQ] = ACTIONS(4604),
    [anon_sym_CARET_EQ] = ACTIONS(4604),
    [anon_sym_PIPE_EQ] = ACTIONS(4604),
    [anon_sym_LT_LT_EQ] = ACTIONS(4604),
    [anon_sym_GT_GT_EQ] = ACTIONS(4604),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4604),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4604),
    [anon_sym_AMP_AMP] = ACTIONS(4604),
    [anon_sym_PIPE_PIPE] = ACTIONS(4604),
    [anon_sym_QMARK_QMARK] = ACTIONS(4606),
    [anon_sym_into] = ACTIONS(4604),
    [anon_sym_as] = ACTIONS(4604),
    [anon_sym_is] = ACTIONS(4604),
    [anon_sym_DASH_GT] = ACTIONS(4604),
    [anon_sym_with] = ACTIONS(4604),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4604),
  },
  [3865] = {
    [sym_preproc_region] = STATE(3865),
    [sym_preproc_endregion] = STATE(3865),
    [sym_preproc_line] = STATE(3865),
    [sym_preproc_pragma] = STATE(3865),
    [sym_preproc_nullable] = STATE(3865),
    [sym_preproc_error] = STATE(3865),
    [sym_preproc_define] = STATE(3865),
    [sym_preproc_undef] = STATE(3865),
    [anon_sym_SEMI] = ACTIONS(5288),
    [anon_sym_LBRACK] = ACTIONS(5288),
    [anon_sym_COLON] = ACTIONS(5288),
    [anon_sym_COMMA] = ACTIONS(5288),
    [anon_sym_RBRACK] = ACTIONS(5288),
    [anon_sym_LPAREN] = ACTIONS(5288),
    [anon_sym_RPAREN] = ACTIONS(5288),
    [anon_sym_LBRACE] = ACTIONS(5288),
    [anon_sym_RBRACE] = ACTIONS(5288),
    [anon_sym_LT] = ACTIONS(5290),
    [anon_sym_GT] = ACTIONS(5290),
    [anon_sym_in] = ACTIONS(5290),
    [anon_sym_QMARK] = ACTIONS(5290),
    [anon_sym_BANG] = ACTIONS(5290),
    [anon_sym_PLUS_PLUS] = ACTIONS(5288),
    [anon_sym_DASH_DASH] = ACTIONS(5288),
    [anon_sym_PLUS] = ACTIONS(5290),
    [anon_sym_DASH] = ACTIONS(5290),
    [anon_sym_STAR] = ACTIONS(5288),
    [anon_sym_SLASH] = ACTIONS(5290),
    [anon_sym_PERCENT] = ACTIONS(5288),
    [anon_sym_CARET] = ACTIONS(5288),
    [anon_sym_PIPE] = ACTIONS(5290),
    [anon_sym_AMP] = ACTIONS(5290),
    [anon_sym_LT_LT] = ACTIONS(5288),
    [anon_sym_GT_GT] = ACTIONS(5290),
    [anon_sym_GT_GT_GT] = ACTIONS(5288),
    [anon_sym_EQ_EQ] = ACTIONS(5288),
    [anon_sym_BANG_EQ] = ACTIONS(5288),
    [anon_sym_GT_EQ] = ACTIONS(5288),
    [anon_sym_LT_EQ] = ACTIONS(5288),
    [anon_sym_DOT] = ACTIONS(5290),
    [anon_sym_EQ_GT] = ACTIONS(5288),
    [anon_sym_switch] = ACTIONS(5288),
    [anon_sym_when] = ACTIONS(5288),
    [anon_sym_DOT_DOT] = ACTIONS(5288),
    [anon_sym_and] = ACTIONS(5288),
    [anon_sym_or] = ACTIONS(5288),
    [anon_sym_AMP_AMP] = ACTIONS(5288),
    [anon_sym_PIPE_PIPE] = ACTIONS(5288),
    [anon_sym_QMARK_QMARK] = ACTIONS(5288),
    [anon_sym_into] = ACTIONS(5288),
    [anon_sym_on] = ACTIONS(5288),
    [anon_sym_equals] = ACTIONS(5288),
    [anon_sym_by] = ACTIONS(5288),
    [anon_sym_as] = ACTIONS(5288),
    [anon_sym_is] = ACTIONS(5288),
    [anon_sym_DASH_GT] = ACTIONS(5288),
    [anon_sym_with] = ACTIONS(5288),
    [aux_sym_preproc_if_token3] = ACTIONS(5288),
    [aux_sym_preproc_else_token1] = ACTIONS(5288),
    [aux_sym_preproc_elif_token1] = ACTIONS(5288),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3866] = {
    [sym_preproc_region] = STATE(3866),
    [sym_preproc_endregion] = STATE(3866),
    [sym_preproc_line] = STATE(3866),
    [sym_preproc_pragma] = STATE(3866),
    [sym_preproc_nullable] = STATE(3866),
    [sym_preproc_error] = STATE(3866),
    [sym_preproc_define] = STATE(3866),
    [sym_preproc_undef] = STATE(3866),
    [anon_sym_SEMI] = ACTIONS(5249),
    [anon_sym_EQ] = ACTIONS(5724),
    [anon_sym_LBRACK] = ACTIONS(5249),
    [anon_sym_LPAREN] = ACTIONS(5249),
    [anon_sym_LT] = ACTIONS(5251),
    [anon_sym_GT] = ACTIONS(5251),
    [anon_sym_QMARK] = ACTIONS(5251),
    [anon_sym_BANG] = ACTIONS(5251),
    [anon_sym_PLUS_PLUS] = ACTIONS(5249),
    [anon_sym_DASH_DASH] = ACTIONS(5249),
    [anon_sym_PLUS] = ACTIONS(5251),
    [anon_sym_DASH] = ACTIONS(5251),
    [anon_sym_STAR] = ACTIONS(5251),
    [anon_sym_SLASH] = ACTIONS(5251),
    [anon_sym_PERCENT] = ACTIONS(5251),
    [anon_sym_CARET] = ACTIONS(5251),
    [anon_sym_PIPE] = ACTIONS(5251),
    [anon_sym_AMP] = ACTIONS(5251),
    [anon_sym_LT_LT] = ACTIONS(5251),
    [anon_sym_GT_GT] = ACTIONS(5251),
    [anon_sym_GT_GT_GT] = ACTIONS(5251),
    [anon_sym_EQ_EQ] = ACTIONS(5249),
    [anon_sym_BANG_EQ] = ACTIONS(5249),
    [anon_sym_GT_EQ] = ACTIONS(5249),
    [anon_sym_LT_EQ] = ACTIONS(5249),
    [anon_sym_DOT] = ACTIONS(5251),
    [anon_sym_switch] = ACTIONS(5249),
    [anon_sym_DOT_DOT] = ACTIONS(5249),
    [anon_sym_and] = ACTIONS(5249),
    [anon_sym_or] = ACTIONS(5249),
    [anon_sym_PLUS_EQ] = ACTIONS(5726),
    [anon_sym_DASH_EQ] = ACTIONS(5726),
    [anon_sym_STAR_EQ] = ACTIONS(5726),
    [anon_sym_SLASH_EQ] = ACTIONS(5726),
    [anon_sym_PERCENT_EQ] = ACTIONS(5726),
    [anon_sym_AMP_EQ] = ACTIONS(5726),
    [anon_sym_CARET_EQ] = ACTIONS(5726),
    [anon_sym_PIPE_EQ] = ACTIONS(5726),
    [anon_sym_LT_LT_EQ] = ACTIONS(5726),
    [anon_sym_GT_GT_EQ] = ACTIONS(5726),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5726),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(5726),
    [anon_sym_AMP_AMP] = ACTIONS(5249),
    [anon_sym_PIPE_PIPE] = ACTIONS(5249),
    [anon_sym_QMARK_QMARK] = ACTIONS(5251),
    [anon_sym_as] = ACTIONS(5249),
    [anon_sym_is] = ACTIONS(5249),
    [anon_sym_DASH_GT] = ACTIONS(5249),
    [anon_sym_with] = ACTIONS(5249),
    [aux_sym_preproc_if_token3] = ACTIONS(5249),
    [aux_sym_preproc_else_token1] = ACTIONS(5249),
    [aux_sym_preproc_elif_token1] = ACTIONS(5249),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3867] = {
    [sym_preproc_region] = STATE(3867),
    [sym_preproc_endregion] = STATE(3867),
    [sym_preproc_line] = STATE(3867),
    [sym_preproc_pragma] = STATE(3867),
    [sym_preproc_nullable] = STATE(3867),
    [sym_preproc_error] = STATE(3867),
    [sym_preproc_define] = STATE(3867),
    [sym_preproc_undef] = STATE(3867),
    [anon_sym_EQ] = ACTIONS(4617),
    [anon_sym_LBRACK] = ACTIONS(4615),
    [anon_sym_COLON] = ACTIONS(4615),
    [anon_sym_COMMA] = ACTIONS(4615),
    [anon_sym_LPAREN] = ACTIONS(4615),
    [anon_sym_LT] = ACTIONS(4617),
    [anon_sym_GT] = ACTIONS(4617),
    [anon_sym_QMARK] = ACTIONS(4617),
    [anon_sym_BANG] = ACTIONS(4617),
    [anon_sym_PLUS_PLUS] = ACTIONS(4615),
    [anon_sym_DASH_DASH] = ACTIONS(4615),
    [anon_sym_PLUS] = ACTIONS(4617),
    [anon_sym_DASH] = ACTIONS(4617),
    [anon_sym_STAR] = ACTIONS(4617),
    [anon_sym_SLASH] = ACTIONS(4617),
    [anon_sym_PERCENT] = ACTIONS(4617),
    [anon_sym_CARET] = ACTIONS(4617),
    [anon_sym_PIPE] = ACTIONS(4617),
    [anon_sym_AMP] = ACTIONS(4617),
    [anon_sym_LT_LT] = ACTIONS(4617),
    [anon_sym_GT_GT] = ACTIONS(4617),
    [anon_sym_GT_GT_GT] = ACTIONS(4617),
    [anon_sym_EQ_EQ] = ACTIONS(4615),
    [anon_sym_BANG_EQ] = ACTIONS(4615),
    [anon_sym_GT_EQ] = ACTIONS(4615),
    [anon_sym_LT_EQ] = ACTIONS(4615),
    [anon_sym_DOT] = ACTIONS(4617),
    [anon_sym_switch] = ACTIONS(4615),
    [anon_sym_DOT_DOT] = ACTIONS(4615),
    [anon_sym_and] = ACTIONS(4615),
    [anon_sym_or] = ACTIONS(4615),
    [anon_sym_PLUS_EQ] = ACTIONS(4615),
    [anon_sym_DASH_EQ] = ACTIONS(4615),
    [anon_sym_STAR_EQ] = ACTIONS(4615),
    [anon_sym_SLASH_EQ] = ACTIONS(4615),
    [anon_sym_PERCENT_EQ] = ACTIONS(4615),
    [anon_sym_AMP_EQ] = ACTIONS(4615),
    [anon_sym_CARET_EQ] = ACTIONS(4615),
    [anon_sym_PIPE_EQ] = ACTIONS(4615),
    [anon_sym_LT_LT_EQ] = ACTIONS(4615),
    [anon_sym_GT_GT_EQ] = ACTIONS(4615),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4615),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4615),
    [anon_sym_AMP_AMP] = ACTIONS(4615),
    [anon_sym_PIPE_PIPE] = ACTIONS(4615),
    [anon_sym_QMARK_QMARK] = ACTIONS(4617),
    [anon_sym_into] = ACTIONS(4615),
    [anon_sym_as] = ACTIONS(4615),
    [anon_sym_is] = ACTIONS(4615),
    [anon_sym_DASH_GT] = ACTIONS(4615),
    [anon_sym_with] = ACTIONS(4615),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4615),
  },
  [3868] = {
    [sym_initializer_expression] = STATE(4173),
    [sym_preproc_region] = STATE(3868),
    [sym_preproc_endregion] = STATE(3868),
    [sym_preproc_line] = STATE(3868),
    [sym_preproc_pragma] = STATE(3868),
    [sym_preproc_nullable] = STATE(3868),
    [sym_preproc_error] = STATE(3868),
    [sym_preproc_define] = STATE(3868),
    [sym_preproc_undef] = STATE(3868),
    [anon_sym_SEMI] = ACTIONS(5205),
    [anon_sym_LBRACK] = ACTIONS(5205),
    [anon_sym_COLON] = ACTIONS(5205),
    [anon_sym_COMMA] = ACTIONS(5205),
    [anon_sym_RBRACK] = ACTIONS(5205),
    [anon_sym_LPAREN] = ACTIONS(5205),
    [anon_sym_RPAREN] = ACTIONS(5205),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_RBRACE] = ACTIONS(5205),
    [anon_sym_LT] = ACTIONS(5207),
    [anon_sym_GT] = ACTIONS(5207),
    [anon_sym_in] = ACTIONS(5205),
    [anon_sym_QMARK] = ACTIONS(5207),
    [anon_sym_BANG] = ACTIONS(5207),
    [anon_sym_PLUS_PLUS] = ACTIONS(5205),
    [anon_sym_DASH_DASH] = ACTIONS(5205),
    [anon_sym_PLUS] = ACTIONS(5207),
    [anon_sym_DASH] = ACTIONS(5207),
    [anon_sym_STAR] = ACTIONS(5205),
    [anon_sym_SLASH] = ACTIONS(5207),
    [anon_sym_PERCENT] = ACTIONS(5205),
    [anon_sym_CARET] = ACTIONS(5205),
    [anon_sym_PIPE] = ACTIONS(5207),
    [anon_sym_AMP] = ACTIONS(5207),
    [anon_sym_LT_LT] = ACTIONS(5205),
    [anon_sym_GT_GT] = ACTIONS(5207),
    [anon_sym_GT_GT_GT] = ACTIONS(5205),
    [anon_sym_EQ_EQ] = ACTIONS(5205),
    [anon_sym_BANG_EQ] = ACTIONS(5205),
    [anon_sym_GT_EQ] = ACTIONS(5205),
    [anon_sym_LT_EQ] = ACTIONS(5205),
    [anon_sym_DOT] = ACTIONS(5207),
    [anon_sym_EQ_GT] = ACTIONS(5205),
    [anon_sym_switch] = ACTIONS(5205),
    [anon_sym_when] = ACTIONS(5205),
    [anon_sym_DOT_DOT] = ACTIONS(5205),
    [anon_sym_and] = ACTIONS(5205),
    [anon_sym_or] = ACTIONS(5205),
    [anon_sym_AMP_AMP] = ACTIONS(5205),
    [anon_sym_PIPE_PIPE] = ACTIONS(5205),
    [anon_sym_QMARK_QMARK] = ACTIONS(5205),
    [anon_sym_on] = ACTIONS(5205),
    [anon_sym_equals] = ACTIONS(5205),
    [anon_sym_by] = ACTIONS(5205),
    [anon_sym_as] = ACTIONS(5205),
    [anon_sym_is] = ACTIONS(5205),
    [anon_sym_DASH_GT] = ACTIONS(5205),
    [anon_sym_with] = ACTIONS(5205),
    [aux_sym_preproc_if_token3] = ACTIONS(5205),
    [aux_sym_preproc_else_token1] = ACTIONS(5205),
    [aux_sym_preproc_elif_token1] = ACTIONS(5205),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3869] = {
    [sym_type_argument_list] = STATE(4046),
    [sym_preproc_region] = STATE(3869),
    [sym_preproc_endregion] = STATE(3869),
    [sym_preproc_line] = STATE(3869),
    [sym_preproc_pragma] = STATE(3869),
    [sym_preproc_nullable] = STATE(3869),
    [sym_preproc_error] = STATE(3869),
    [sym_preproc_define] = STATE(3869),
    [sym_preproc_undef] = STATE(3869),
    [anon_sym_SEMI] = ACTIONS(4076),
    [anon_sym_LBRACK] = ACTIONS(4076),
    [anon_sym_COLON] = ACTIONS(4076),
    [anon_sym_COMMA] = ACTIONS(4076),
    [anon_sym_RBRACK] = ACTIONS(4076),
    [anon_sym_LPAREN] = ACTIONS(4076),
    [anon_sym_RPAREN] = ACTIONS(4076),
    [anon_sym_LBRACE] = ACTIONS(4076),
    [anon_sym_RBRACE] = ACTIONS(4076),
    [anon_sym_LT] = ACTIONS(5728),
    [anon_sym_GT] = ACTIONS(4074),
    [anon_sym_in] = ACTIONS(4076),
    [anon_sym_QMARK] = ACTIONS(4074),
    [anon_sym_BANG] = ACTIONS(4074),
    [anon_sym_PLUS_PLUS] = ACTIONS(4076),
    [anon_sym_DASH_DASH] = ACTIONS(4076),
    [anon_sym_PLUS] = ACTIONS(4074),
    [anon_sym_DASH] = ACTIONS(4074),
    [anon_sym_STAR] = ACTIONS(4076),
    [anon_sym_SLASH] = ACTIONS(4074),
    [anon_sym_PERCENT] = ACTIONS(4076),
    [anon_sym_CARET] = ACTIONS(4076),
    [anon_sym_PIPE] = ACTIONS(4074),
    [anon_sym_AMP] = ACTIONS(4074),
    [anon_sym_LT_LT] = ACTIONS(4076),
    [anon_sym_GT_GT] = ACTIONS(4074),
    [anon_sym_GT_GT_GT] = ACTIONS(4076),
    [anon_sym_EQ_EQ] = ACTIONS(4076),
    [anon_sym_BANG_EQ] = ACTIONS(4076),
    [anon_sym_GT_EQ] = ACTIONS(4076),
    [anon_sym_LT_EQ] = ACTIONS(4076),
    [anon_sym_DOT] = ACTIONS(4074),
    [anon_sym_EQ_GT] = ACTIONS(4076),
    [anon_sym_switch] = ACTIONS(4076),
    [anon_sym_when] = ACTIONS(4076),
    [anon_sym_DOT_DOT] = ACTIONS(4076),
    [anon_sym_and] = ACTIONS(4076),
    [anon_sym_or] = ACTIONS(4076),
    [anon_sym_AMP_AMP] = ACTIONS(4076),
    [anon_sym_PIPE_PIPE] = ACTIONS(4076),
    [anon_sym_QMARK_QMARK] = ACTIONS(4076),
    [anon_sym_on] = ACTIONS(4076),
    [anon_sym_equals] = ACTIONS(4076),
    [anon_sym_by] = ACTIONS(4076),
    [anon_sym_as] = ACTIONS(4076),
    [anon_sym_is] = ACTIONS(4076),
    [anon_sym_DASH_GT] = ACTIONS(4076),
    [anon_sym_with] = ACTIONS(4076),
    [aux_sym_preproc_if_token3] = ACTIONS(4076),
    [aux_sym_preproc_else_token1] = ACTIONS(4076),
    [aux_sym_preproc_elif_token1] = ACTIONS(4076),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3870] = {
    [sym_preproc_region] = STATE(3870),
    [sym_preproc_endregion] = STATE(3870),
    [sym_preproc_line] = STATE(3870),
    [sym_preproc_pragma] = STATE(3870),
    [sym_preproc_nullable] = STATE(3870),
    [sym_preproc_error] = STATE(3870),
    [sym_preproc_define] = STATE(3870),
    [sym_preproc_undef] = STATE(3870),
    [anon_sym_EQ] = ACTIONS(4637),
    [anon_sym_LBRACK] = ACTIONS(4635),
    [anon_sym_COLON] = ACTIONS(4635),
    [anon_sym_COMMA] = ACTIONS(4635),
    [anon_sym_LPAREN] = ACTIONS(4635),
    [anon_sym_LT] = ACTIONS(4637),
    [anon_sym_GT] = ACTIONS(4637),
    [anon_sym_QMARK] = ACTIONS(4637),
    [anon_sym_BANG] = ACTIONS(4637),
    [anon_sym_PLUS_PLUS] = ACTIONS(4635),
    [anon_sym_DASH_DASH] = ACTIONS(4635),
    [anon_sym_PLUS] = ACTIONS(4637),
    [anon_sym_DASH] = ACTIONS(4637),
    [anon_sym_STAR] = ACTIONS(4637),
    [anon_sym_SLASH] = ACTIONS(4637),
    [anon_sym_PERCENT] = ACTIONS(4637),
    [anon_sym_CARET] = ACTIONS(4637),
    [anon_sym_PIPE] = ACTIONS(4637),
    [anon_sym_AMP] = ACTIONS(4637),
    [anon_sym_LT_LT] = ACTIONS(4637),
    [anon_sym_GT_GT] = ACTIONS(4637),
    [anon_sym_GT_GT_GT] = ACTIONS(4637),
    [anon_sym_EQ_EQ] = ACTIONS(4635),
    [anon_sym_BANG_EQ] = ACTIONS(4635),
    [anon_sym_GT_EQ] = ACTIONS(4635),
    [anon_sym_LT_EQ] = ACTIONS(4635),
    [anon_sym_DOT] = ACTIONS(4637),
    [anon_sym_switch] = ACTIONS(4635),
    [anon_sym_DOT_DOT] = ACTIONS(4635),
    [anon_sym_and] = ACTIONS(4635),
    [anon_sym_or] = ACTIONS(4635),
    [anon_sym_PLUS_EQ] = ACTIONS(4635),
    [anon_sym_DASH_EQ] = ACTIONS(4635),
    [anon_sym_STAR_EQ] = ACTIONS(4635),
    [anon_sym_SLASH_EQ] = ACTIONS(4635),
    [anon_sym_PERCENT_EQ] = ACTIONS(4635),
    [anon_sym_AMP_EQ] = ACTIONS(4635),
    [anon_sym_CARET_EQ] = ACTIONS(4635),
    [anon_sym_PIPE_EQ] = ACTIONS(4635),
    [anon_sym_LT_LT_EQ] = ACTIONS(4635),
    [anon_sym_GT_GT_EQ] = ACTIONS(4635),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4635),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4635),
    [anon_sym_AMP_AMP] = ACTIONS(4635),
    [anon_sym_PIPE_PIPE] = ACTIONS(4635),
    [anon_sym_QMARK_QMARK] = ACTIONS(4637),
    [anon_sym_into] = ACTIONS(4635),
    [anon_sym_as] = ACTIONS(4635),
    [anon_sym_is] = ACTIONS(4635),
    [anon_sym_DASH_GT] = ACTIONS(4635),
    [anon_sym_with] = ACTIONS(4635),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4635),
  },
  [3871] = {
    [sym_preproc_region] = STATE(3871),
    [sym_preproc_endregion] = STATE(3871),
    [sym_preproc_line] = STATE(3871),
    [sym_preproc_pragma] = STATE(3871),
    [sym_preproc_nullable] = STATE(3871),
    [sym_preproc_error] = STATE(3871),
    [sym_preproc_define] = STATE(3871),
    [sym_preproc_undef] = STATE(3871),
    [sym__identifier_token] = ACTIONS(3973),
    [anon_sym_extern] = ACTIONS(3976),
    [anon_sym_alias] = ACTIONS(3973),
    [anon_sym_global] = ACTIONS(3973),
    [anon_sym_unsafe] = ACTIONS(3976),
    [anon_sym_static] = ACTIONS(3976),
    [anon_sym_LBRACK] = ACTIONS(3719),
    [anon_sym_LPAREN] = ACTIONS(5566),
    [anon_sym_ref] = ACTIONS(3976),
    [anon_sym_delegate] = ACTIONS(3976),
    [anon_sym_abstract] = ACTIONS(3976),
    [anon_sym_async] = ACTIONS(3976),
    [anon_sym_const] = ACTIONS(3976),
    [anon_sym_file] = ACTIONS(3973),
    [anon_sym_fixed] = ACTIONS(3976),
    [anon_sym_internal] = ACTIONS(3976),
    [anon_sym_new] = ACTIONS(3976),
    [anon_sym_override] = ACTIONS(3976),
    [anon_sym_partial] = ACTIONS(3976),
    [anon_sym_private] = ACTIONS(3976),
    [anon_sym_protected] = ACTIONS(3976),
    [anon_sym_public] = ACTIONS(3976),
    [anon_sym_readonly] = ACTIONS(3976),
    [anon_sym_required] = ACTIONS(3976),
    [anon_sym_sealed] = ACTIONS(3976),
    [anon_sym_virtual] = ACTIONS(3976),
    [anon_sym_volatile] = ACTIONS(3976),
    [anon_sym_LT] = ACTIONS(3719),
    [anon_sym_where] = ACTIONS(3973),
    [anon_sym_QMARK] = ACTIONS(3719),
    [anon_sym_notnull] = ACTIONS(3973),
    [anon_sym_unmanaged] = ACTIONS(3973),
    [anon_sym_STAR] = ACTIONS(3719),
    [anon_sym_DOT] = ACTIONS(3719),
    [anon_sym_scoped] = ACTIONS(3973),
    [anon_sym_COLON_COLON] = ACTIONS(3719),
    [anon_sym_var] = ACTIONS(3973),
    [sym_predefined_type] = ACTIONS(3976),
    [anon_sym_yield] = ACTIONS(3973),
    [anon_sym_when] = ACTIONS(3973),
    [anon_sym_from] = ACTIONS(3973),
    [anon_sym_into] = ACTIONS(3973),
    [anon_sym_join] = ACTIONS(3973),
    [anon_sym_on] = ACTIONS(3973),
    [anon_sym_equals] = ACTIONS(3973),
    [anon_sym_let] = ACTIONS(3973),
    [anon_sym_orderby] = ACTIONS(3973),
    [anon_sym_ascending] = ACTIONS(3973),
    [anon_sym_descending] = ACTIONS(3973),
    [anon_sym_group] = ACTIONS(3973),
    [anon_sym_by] = ACTIONS(3973),
    [anon_sym_select] = ACTIONS(3973),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3872] = {
    [sym_preproc_region] = STATE(3872),
    [sym_preproc_endregion] = STATE(3872),
    [sym_preproc_line] = STATE(3872),
    [sym_preproc_pragma] = STATE(3872),
    [sym_preproc_nullable] = STATE(3872),
    [sym_preproc_error] = STATE(3872),
    [sym_preproc_define] = STATE(3872),
    [sym_preproc_undef] = STATE(3872),
    [anon_sym_EQ] = ACTIONS(4625),
    [anon_sym_LBRACK] = ACTIONS(4639),
    [anon_sym_COLON] = ACTIONS(4639),
    [anon_sym_COMMA] = ACTIONS(4639),
    [anon_sym_LPAREN] = ACTIONS(4639),
    [anon_sym_LT] = ACTIONS(4641),
    [anon_sym_GT] = ACTIONS(4641),
    [anon_sym_QMARK] = ACTIONS(4641),
    [anon_sym_BANG] = ACTIONS(4641),
    [anon_sym_PLUS_PLUS] = ACTIONS(4639),
    [anon_sym_DASH_DASH] = ACTIONS(4639),
    [anon_sym_PLUS] = ACTIONS(4641),
    [anon_sym_DASH] = ACTIONS(4641),
    [anon_sym_STAR] = ACTIONS(4641),
    [anon_sym_SLASH] = ACTIONS(4641),
    [anon_sym_PERCENT] = ACTIONS(4641),
    [anon_sym_CARET] = ACTIONS(4641),
    [anon_sym_PIPE] = ACTIONS(4641),
    [anon_sym_AMP] = ACTIONS(4641),
    [anon_sym_LT_LT] = ACTIONS(4641),
    [anon_sym_GT_GT] = ACTIONS(4641),
    [anon_sym_GT_GT_GT] = ACTIONS(4641),
    [anon_sym_EQ_EQ] = ACTIONS(4639),
    [anon_sym_BANG_EQ] = ACTIONS(4639),
    [anon_sym_GT_EQ] = ACTIONS(4639),
    [anon_sym_LT_EQ] = ACTIONS(4639),
    [anon_sym_DOT] = ACTIONS(4641),
    [anon_sym_switch] = ACTIONS(4639),
    [anon_sym_DOT_DOT] = ACTIONS(4639),
    [anon_sym_and] = ACTIONS(4639),
    [anon_sym_or] = ACTIONS(4639),
    [anon_sym_PLUS_EQ] = ACTIONS(4623),
    [anon_sym_DASH_EQ] = ACTIONS(4623),
    [anon_sym_STAR_EQ] = ACTIONS(4623),
    [anon_sym_SLASH_EQ] = ACTIONS(4623),
    [anon_sym_PERCENT_EQ] = ACTIONS(4623),
    [anon_sym_AMP_EQ] = ACTIONS(4623),
    [anon_sym_CARET_EQ] = ACTIONS(4623),
    [anon_sym_PIPE_EQ] = ACTIONS(4623),
    [anon_sym_LT_LT_EQ] = ACTIONS(4623),
    [anon_sym_GT_GT_EQ] = ACTIONS(4623),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4623),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4623),
    [anon_sym_AMP_AMP] = ACTIONS(4639),
    [anon_sym_PIPE_PIPE] = ACTIONS(4639),
    [anon_sym_QMARK_QMARK] = ACTIONS(4641),
    [anon_sym_into] = ACTIONS(4639),
    [anon_sym_as] = ACTIONS(4639),
    [anon_sym_is] = ACTIONS(4639),
    [anon_sym_DASH_GT] = ACTIONS(4639),
    [anon_sym_with] = ACTIONS(4639),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4639),
  },
  [3873] = {
    [sym_preproc_region] = STATE(3873),
    [sym_preproc_endregion] = STATE(3873),
    [sym_preproc_line] = STATE(3873),
    [sym_preproc_pragma] = STATE(3873),
    [sym_preproc_nullable] = STATE(3873),
    [sym_preproc_error] = STATE(3873),
    [sym_preproc_define] = STATE(3873),
    [sym_preproc_undef] = STATE(3873),
    [anon_sym_EQ] = ACTIONS(4056),
    [anon_sym_LBRACK] = ACTIONS(4058),
    [anon_sym_COLON] = ACTIONS(4058),
    [anon_sym_COMMA] = ACTIONS(4058),
    [anon_sym_LPAREN] = ACTIONS(4058),
    [anon_sym_LT] = ACTIONS(4056),
    [anon_sym_GT] = ACTIONS(4056),
    [anon_sym_QMARK] = ACTIONS(4056),
    [anon_sym_BANG] = ACTIONS(4056),
    [anon_sym_PLUS_PLUS] = ACTIONS(4058),
    [anon_sym_DASH_DASH] = ACTIONS(4058),
    [anon_sym_PLUS] = ACTIONS(4056),
    [anon_sym_DASH] = ACTIONS(4056),
    [anon_sym_STAR] = ACTIONS(4056),
    [anon_sym_SLASH] = ACTIONS(4056),
    [anon_sym_PERCENT] = ACTIONS(4056),
    [anon_sym_CARET] = ACTIONS(4056),
    [anon_sym_PIPE] = ACTIONS(4056),
    [anon_sym_AMP] = ACTIONS(4056),
    [anon_sym_LT_LT] = ACTIONS(4056),
    [anon_sym_GT_GT] = ACTIONS(4056),
    [anon_sym_GT_GT_GT] = ACTIONS(4056),
    [anon_sym_EQ_EQ] = ACTIONS(4058),
    [anon_sym_BANG_EQ] = ACTIONS(4058),
    [anon_sym_GT_EQ] = ACTIONS(4058),
    [anon_sym_LT_EQ] = ACTIONS(4058),
    [anon_sym_DOT] = ACTIONS(4056),
    [anon_sym_switch] = ACTIONS(4058),
    [anon_sym_DOT_DOT] = ACTIONS(4058),
    [anon_sym_and] = ACTIONS(4058),
    [anon_sym_or] = ACTIONS(4058),
    [anon_sym_PLUS_EQ] = ACTIONS(4058),
    [anon_sym_DASH_EQ] = ACTIONS(4058),
    [anon_sym_STAR_EQ] = ACTIONS(4058),
    [anon_sym_SLASH_EQ] = ACTIONS(4058),
    [anon_sym_PERCENT_EQ] = ACTIONS(4058),
    [anon_sym_AMP_EQ] = ACTIONS(4058),
    [anon_sym_CARET_EQ] = ACTIONS(4058),
    [anon_sym_PIPE_EQ] = ACTIONS(4058),
    [anon_sym_LT_LT_EQ] = ACTIONS(4058),
    [anon_sym_GT_GT_EQ] = ACTIONS(4058),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4058),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4058),
    [anon_sym_AMP_AMP] = ACTIONS(4058),
    [anon_sym_PIPE_PIPE] = ACTIONS(4058),
    [anon_sym_QMARK_QMARK] = ACTIONS(4056),
    [anon_sym_into] = ACTIONS(4058),
    [anon_sym_as] = ACTIONS(4058),
    [anon_sym_is] = ACTIONS(4058),
    [anon_sym_DASH_GT] = ACTIONS(4058),
    [anon_sym_with] = ACTIONS(4058),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4058),
  },
  [3874] = {
    [sym_preproc_region] = STATE(3874),
    [sym_preproc_endregion] = STATE(3874),
    [sym_preproc_line] = STATE(3874),
    [sym_preproc_pragma] = STATE(3874),
    [sym_preproc_nullable] = STATE(3874),
    [sym_preproc_error] = STATE(3874),
    [sym_preproc_define] = STATE(3874),
    [sym_preproc_undef] = STATE(3874),
    [anon_sym_SEMI] = ACTIONS(4076),
    [anon_sym_LBRACK] = ACTIONS(4076),
    [anon_sym_COLON] = ACTIONS(4076),
    [anon_sym_COMMA] = ACTIONS(4076),
    [anon_sym_RBRACK] = ACTIONS(4076),
    [anon_sym_LPAREN] = ACTIONS(4076),
    [anon_sym_RPAREN] = ACTIONS(4076),
    [anon_sym_LBRACE] = ACTIONS(4076),
    [anon_sym_RBRACE] = ACTIONS(4076),
    [anon_sym_LT] = ACTIONS(4074),
    [anon_sym_GT] = ACTIONS(4074),
    [anon_sym_in] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(4074),
    [anon_sym_BANG] = ACTIONS(4074),
    [anon_sym_PLUS_PLUS] = ACTIONS(4076),
    [anon_sym_DASH_DASH] = ACTIONS(4076),
    [anon_sym_PLUS] = ACTIONS(4074),
    [anon_sym_DASH] = ACTIONS(4074),
    [anon_sym_STAR] = ACTIONS(4076),
    [anon_sym_SLASH] = ACTIONS(4074),
    [anon_sym_PERCENT] = ACTIONS(4076),
    [anon_sym_CARET] = ACTIONS(4076),
    [anon_sym_PIPE] = ACTIONS(4074),
    [anon_sym_AMP] = ACTIONS(4074),
    [anon_sym_LT_LT] = ACTIONS(4076),
    [anon_sym_GT_GT] = ACTIONS(4074),
    [anon_sym_GT_GT_GT] = ACTIONS(4076),
    [anon_sym_EQ_EQ] = ACTIONS(4076),
    [anon_sym_BANG_EQ] = ACTIONS(4076),
    [anon_sym_GT_EQ] = ACTIONS(4076),
    [anon_sym_LT_EQ] = ACTIONS(4076),
    [anon_sym_DOT] = ACTIONS(4074),
    [anon_sym_EQ_GT] = ACTIONS(4076),
    [anon_sym_switch] = ACTIONS(4076),
    [anon_sym_when] = ACTIONS(4076),
    [anon_sym_DOT_DOT] = ACTIONS(4076),
    [anon_sym_and] = ACTIONS(4076),
    [anon_sym_or] = ACTIONS(4076),
    [anon_sym_AMP_AMP] = ACTIONS(4076),
    [anon_sym_PIPE_PIPE] = ACTIONS(4076),
    [anon_sym_QMARK_QMARK] = ACTIONS(4076),
    [anon_sym_into] = ACTIONS(4076),
    [anon_sym_on] = ACTIONS(4076),
    [anon_sym_equals] = ACTIONS(4076),
    [anon_sym_by] = ACTIONS(4076),
    [anon_sym_as] = ACTIONS(4076),
    [anon_sym_is] = ACTIONS(4076),
    [anon_sym_DASH_GT] = ACTIONS(4076),
    [anon_sym_with] = ACTIONS(4076),
    [aux_sym_preproc_if_token3] = ACTIONS(4076),
    [aux_sym_preproc_else_token1] = ACTIONS(4076),
    [aux_sym_preproc_elif_token1] = ACTIONS(4076),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3875] = {
    [sym_preproc_region] = STATE(3875),
    [sym_preproc_endregion] = STATE(3875),
    [sym_preproc_line] = STATE(3875),
    [sym_preproc_pragma] = STATE(3875),
    [sym_preproc_nullable] = STATE(3875),
    [sym_preproc_error] = STATE(3875),
    [sym_preproc_define] = STATE(3875),
    [sym_preproc_undef] = STATE(3875),
    [anon_sym_EQ] = ACTIONS(3721),
    [anon_sym_LBRACK] = ACTIONS(3719),
    [anon_sym_COLON] = ACTIONS(3719),
    [anon_sym_COMMA] = ACTIONS(3719),
    [anon_sym_LPAREN] = ACTIONS(3719),
    [anon_sym_LT] = ACTIONS(3721),
    [anon_sym_GT] = ACTIONS(3721),
    [anon_sym_QMARK] = ACTIONS(3721),
    [anon_sym_BANG] = ACTIONS(3721),
    [anon_sym_PLUS_PLUS] = ACTIONS(3719),
    [anon_sym_DASH_DASH] = ACTIONS(3719),
    [anon_sym_PLUS] = ACTIONS(3721),
    [anon_sym_DASH] = ACTIONS(3721),
    [anon_sym_STAR] = ACTIONS(3721),
    [anon_sym_SLASH] = ACTIONS(3721),
    [anon_sym_PERCENT] = ACTIONS(3721),
    [anon_sym_CARET] = ACTIONS(3721),
    [anon_sym_PIPE] = ACTIONS(3721),
    [anon_sym_AMP] = ACTIONS(3721),
    [anon_sym_LT_LT] = ACTIONS(3721),
    [anon_sym_GT_GT] = ACTIONS(3721),
    [anon_sym_GT_GT_GT] = ACTIONS(3721),
    [anon_sym_EQ_EQ] = ACTIONS(3719),
    [anon_sym_BANG_EQ] = ACTIONS(3719),
    [anon_sym_GT_EQ] = ACTIONS(3719),
    [anon_sym_LT_EQ] = ACTIONS(3719),
    [anon_sym_DOT] = ACTIONS(3721),
    [anon_sym_switch] = ACTIONS(3719),
    [anon_sym_DOT_DOT] = ACTIONS(3719),
    [anon_sym_and] = ACTIONS(3719),
    [anon_sym_or] = ACTIONS(3719),
    [anon_sym_PLUS_EQ] = ACTIONS(3719),
    [anon_sym_DASH_EQ] = ACTIONS(3719),
    [anon_sym_STAR_EQ] = ACTIONS(3719),
    [anon_sym_SLASH_EQ] = ACTIONS(3719),
    [anon_sym_PERCENT_EQ] = ACTIONS(3719),
    [anon_sym_AMP_EQ] = ACTIONS(3719),
    [anon_sym_CARET_EQ] = ACTIONS(3719),
    [anon_sym_PIPE_EQ] = ACTIONS(3719),
    [anon_sym_LT_LT_EQ] = ACTIONS(3719),
    [anon_sym_GT_GT_EQ] = ACTIONS(3719),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3719),
    [anon_sym_AMP_AMP] = ACTIONS(3719),
    [anon_sym_PIPE_PIPE] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK] = ACTIONS(3721),
    [anon_sym_into] = ACTIONS(3719),
    [anon_sym_as] = ACTIONS(3719),
    [anon_sym_is] = ACTIONS(3719),
    [anon_sym_DASH_GT] = ACTIONS(3719),
    [anon_sym_with] = ACTIONS(3719),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(3719),
  },
  [3876] = {
    [sym_preproc_region] = STATE(3876),
    [sym_preproc_endregion] = STATE(3876),
    [sym_preproc_line] = STATE(3876),
    [sym_preproc_pragma] = STATE(3876),
    [sym_preproc_nullable] = STATE(3876),
    [sym_preproc_error] = STATE(3876),
    [sym_preproc_define] = STATE(3876),
    [sym_preproc_undef] = STATE(3876),
    [anon_sym_SEMI] = ACTIONS(4404),
    [anon_sym_LBRACK] = ACTIONS(4404),
    [anon_sym_COLON] = ACTIONS(4404),
    [anon_sym_COMMA] = ACTIONS(4404),
    [anon_sym_RBRACK] = ACTIONS(4404),
    [anon_sym_LPAREN] = ACTIONS(4404),
    [anon_sym_RPAREN] = ACTIONS(4404),
    [anon_sym_LBRACE] = ACTIONS(4404),
    [anon_sym_RBRACE] = ACTIONS(4404),
    [anon_sym_LT] = ACTIONS(4402),
    [anon_sym_GT] = ACTIONS(4402),
    [anon_sym_in] = ACTIONS(4402),
    [anon_sym_QMARK] = ACTIONS(4402),
    [anon_sym_BANG] = ACTIONS(4402),
    [anon_sym_PLUS_PLUS] = ACTIONS(4404),
    [anon_sym_DASH_DASH] = ACTIONS(4404),
    [anon_sym_PLUS] = ACTIONS(4402),
    [anon_sym_DASH] = ACTIONS(4402),
    [anon_sym_STAR] = ACTIONS(4404),
    [anon_sym_SLASH] = ACTIONS(4402),
    [anon_sym_PERCENT] = ACTIONS(4404),
    [anon_sym_CARET] = ACTIONS(4404),
    [anon_sym_PIPE] = ACTIONS(4402),
    [anon_sym_AMP] = ACTIONS(4402),
    [anon_sym_LT_LT] = ACTIONS(4404),
    [anon_sym_GT_GT] = ACTIONS(4402),
    [anon_sym_GT_GT_GT] = ACTIONS(4404),
    [anon_sym_EQ_EQ] = ACTIONS(4404),
    [anon_sym_BANG_EQ] = ACTIONS(4404),
    [anon_sym_GT_EQ] = ACTIONS(4404),
    [anon_sym_LT_EQ] = ACTIONS(4404),
    [anon_sym_DOT] = ACTIONS(4402),
    [anon_sym_EQ_GT] = ACTIONS(4404),
    [anon_sym_switch] = ACTIONS(4404),
    [anon_sym_when] = ACTIONS(4404),
    [anon_sym_DOT_DOT] = ACTIONS(4404),
    [anon_sym_and] = ACTIONS(4404),
    [anon_sym_or] = ACTIONS(4404),
    [anon_sym_AMP_AMP] = ACTIONS(4404),
    [anon_sym_PIPE_PIPE] = ACTIONS(4404),
    [anon_sym_QMARK_QMARK] = ACTIONS(4404),
    [anon_sym_into] = ACTIONS(4404),
    [anon_sym_on] = ACTIONS(4404),
    [anon_sym_equals] = ACTIONS(4404),
    [anon_sym_by] = ACTIONS(4404),
    [anon_sym_as] = ACTIONS(4404),
    [anon_sym_is] = ACTIONS(4404),
    [anon_sym_DASH_GT] = ACTIONS(4404),
    [anon_sym_with] = ACTIONS(4404),
    [aux_sym_preproc_if_token3] = ACTIONS(4404),
    [aux_sym_preproc_else_token1] = ACTIONS(4404),
    [aux_sym_preproc_elif_token1] = ACTIONS(4404),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3877] = {
    [sym_preproc_region] = STATE(3877),
    [sym_preproc_endregion] = STATE(3877),
    [sym_preproc_line] = STATE(3877),
    [sym_preproc_pragma] = STATE(3877),
    [sym_preproc_nullable] = STATE(3877),
    [sym_preproc_error] = STATE(3877),
    [sym_preproc_define] = STATE(3877),
    [sym_preproc_undef] = STATE(3877),
    [anon_sym_SEMI] = ACTIONS(4068),
    [anon_sym_LBRACK] = ACTIONS(4068),
    [anon_sym_COLON] = ACTIONS(4068),
    [anon_sym_COMMA] = ACTIONS(4068),
    [anon_sym_RBRACK] = ACTIONS(4068),
    [anon_sym_LPAREN] = ACTIONS(4068),
    [anon_sym_RPAREN] = ACTIONS(4068),
    [anon_sym_LBRACE] = ACTIONS(4068),
    [anon_sym_RBRACE] = ACTIONS(4068),
    [anon_sym_LT] = ACTIONS(4066),
    [anon_sym_GT] = ACTIONS(4066),
    [anon_sym_in] = ACTIONS(4066),
    [anon_sym_QMARK] = ACTIONS(4066),
    [anon_sym_BANG] = ACTIONS(4066),
    [anon_sym_PLUS_PLUS] = ACTIONS(4068),
    [anon_sym_DASH_DASH] = ACTIONS(4068),
    [anon_sym_PLUS] = ACTIONS(4066),
    [anon_sym_DASH] = ACTIONS(4066),
    [anon_sym_STAR] = ACTIONS(4068),
    [anon_sym_SLASH] = ACTIONS(4066),
    [anon_sym_PERCENT] = ACTIONS(4068),
    [anon_sym_CARET] = ACTIONS(4068),
    [anon_sym_PIPE] = ACTIONS(4066),
    [anon_sym_AMP] = ACTIONS(4066),
    [anon_sym_LT_LT] = ACTIONS(4068),
    [anon_sym_GT_GT] = ACTIONS(4066),
    [anon_sym_GT_GT_GT] = ACTIONS(4068),
    [anon_sym_EQ_EQ] = ACTIONS(4068),
    [anon_sym_BANG_EQ] = ACTIONS(4068),
    [anon_sym_GT_EQ] = ACTIONS(4068),
    [anon_sym_LT_EQ] = ACTIONS(4068),
    [anon_sym_DOT] = ACTIONS(4066),
    [anon_sym_EQ_GT] = ACTIONS(4068),
    [anon_sym_switch] = ACTIONS(4068),
    [anon_sym_when] = ACTIONS(4068),
    [anon_sym_DOT_DOT] = ACTIONS(4068),
    [anon_sym_and] = ACTIONS(4068),
    [anon_sym_or] = ACTIONS(4068),
    [anon_sym_AMP_AMP] = ACTIONS(4068),
    [anon_sym_PIPE_PIPE] = ACTIONS(4068),
    [anon_sym_QMARK_QMARK] = ACTIONS(4068),
    [anon_sym_into] = ACTIONS(4068),
    [anon_sym_on] = ACTIONS(4068),
    [anon_sym_equals] = ACTIONS(4068),
    [anon_sym_by] = ACTIONS(4068),
    [anon_sym_as] = ACTIONS(4068),
    [anon_sym_is] = ACTIONS(4068),
    [anon_sym_DASH_GT] = ACTIONS(4068),
    [anon_sym_with] = ACTIONS(4068),
    [aux_sym_preproc_if_token3] = ACTIONS(4068),
    [aux_sym_preproc_else_token1] = ACTIONS(4068),
    [aux_sym_preproc_elif_token1] = ACTIONS(4068),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3878] = {
    [sym_preproc_region] = STATE(3878),
    [sym_preproc_endregion] = STATE(3878),
    [sym_preproc_line] = STATE(3878),
    [sym_preproc_pragma] = STATE(3878),
    [sym_preproc_nullable] = STATE(3878),
    [sym_preproc_error] = STATE(3878),
    [sym_preproc_define] = STATE(3878),
    [sym_preproc_undef] = STATE(3878),
    [anon_sym_SEMI] = ACTIONS(4389),
    [anon_sym_LBRACK] = ACTIONS(4389),
    [anon_sym_COLON] = ACTIONS(4389),
    [anon_sym_COMMA] = ACTIONS(4389),
    [anon_sym_RBRACK] = ACTIONS(4389),
    [anon_sym_LPAREN] = ACTIONS(4389),
    [anon_sym_RPAREN] = ACTIONS(4389),
    [anon_sym_LBRACE] = ACTIONS(4389),
    [anon_sym_RBRACE] = ACTIONS(4389),
    [anon_sym_LT] = ACTIONS(4387),
    [anon_sym_GT] = ACTIONS(4387),
    [anon_sym_in] = ACTIONS(4387),
    [anon_sym_QMARK] = ACTIONS(4387),
    [anon_sym_BANG] = ACTIONS(4387),
    [anon_sym_PLUS_PLUS] = ACTIONS(4389),
    [anon_sym_DASH_DASH] = ACTIONS(4389),
    [anon_sym_PLUS] = ACTIONS(4387),
    [anon_sym_DASH] = ACTIONS(4387),
    [anon_sym_STAR] = ACTIONS(4389),
    [anon_sym_SLASH] = ACTIONS(4387),
    [anon_sym_PERCENT] = ACTIONS(4389),
    [anon_sym_CARET] = ACTIONS(4389),
    [anon_sym_PIPE] = ACTIONS(4387),
    [anon_sym_AMP] = ACTIONS(4387),
    [anon_sym_LT_LT] = ACTIONS(4389),
    [anon_sym_GT_GT] = ACTIONS(4387),
    [anon_sym_GT_GT_GT] = ACTIONS(4389),
    [anon_sym_EQ_EQ] = ACTIONS(4389),
    [anon_sym_BANG_EQ] = ACTIONS(4389),
    [anon_sym_GT_EQ] = ACTIONS(4389),
    [anon_sym_LT_EQ] = ACTIONS(4389),
    [anon_sym_DOT] = ACTIONS(4387),
    [anon_sym_EQ_GT] = ACTIONS(4389),
    [anon_sym_switch] = ACTIONS(4389),
    [anon_sym_when] = ACTIONS(4389),
    [anon_sym_DOT_DOT] = ACTIONS(4389),
    [anon_sym_and] = ACTIONS(4389),
    [anon_sym_or] = ACTIONS(4389),
    [anon_sym_AMP_AMP] = ACTIONS(4389),
    [anon_sym_PIPE_PIPE] = ACTIONS(4389),
    [anon_sym_QMARK_QMARK] = ACTIONS(4389),
    [anon_sym_into] = ACTIONS(4389),
    [anon_sym_on] = ACTIONS(4389),
    [anon_sym_equals] = ACTIONS(4389),
    [anon_sym_by] = ACTIONS(4389),
    [anon_sym_as] = ACTIONS(4389),
    [anon_sym_is] = ACTIONS(4389),
    [anon_sym_DASH_GT] = ACTIONS(4389),
    [anon_sym_with] = ACTIONS(4389),
    [aux_sym_preproc_if_token3] = ACTIONS(4389),
    [aux_sym_preproc_else_token1] = ACTIONS(4389),
    [aux_sym_preproc_elif_token1] = ACTIONS(4389),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3879] = {
    [sym_preproc_region] = STATE(3879),
    [sym_preproc_endregion] = STATE(3879),
    [sym_preproc_line] = STATE(3879),
    [sym_preproc_pragma] = STATE(3879),
    [sym_preproc_nullable] = STATE(3879),
    [sym_preproc_error] = STATE(3879),
    [sym_preproc_define] = STATE(3879),
    [sym_preproc_undef] = STATE(3879),
    [anon_sym_EQ] = ACTIONS(4060),
    [anon_sym_LBRACK] = ACTIONS(4062),
    [anon_sym_COLON] = ACTIONS(4062),
    [anon_sym_COMMA] = ACTIONS(4062),
    [anon_sym_LPAREN] = ACTIONS(4062),
    [anon_sym_LT] = ACTIONS(4060),
    [anon_sym_GT] = ACTIONS(4060),
    [anon_sym_QMARK] = ACTIONS(4060),
    [anon_sym_BANG] = ACTIONS(4060),
    [anon_sym_PLUS_PLUS] = ACTIONS(4062),
    [anon_sym_DASH_DASH] = ACTIONS(4062),
    [anon_sym_PLUS] = ACTIONS(4060),
    [anon_sym_DASH] = ACTIONS(4060),
    [anon_sym_STAR] = ACTIONS(4060),
    [anon_sym_SLASH] = ACTIONS(4060),
    [anon_sym_PERCENT] = ACTIONS(4060),
    [anon_sym_CARET] = ACTIONS(4060),
    [anon_sym_PIPE] = ACTIONS(4060),
    [anon_sym_AMP] = ACTIONS(4060),
    [anon_sym_LT_LT] = ACTIONS(4060),
    [anon_sym_GT_GT] = ACTIONS(4060),
    [anon_sym_GT_GT_GT] = ACTIONS(4060),
    [anon_sym_EQ_EQ] = ACTIONS(4062),
    [anon_sym_BANG_EQ] = ACTIONS(4062),
    [anon_sym_GT_EQ] = ACTIONS(4062),
    [anon_sym_LT_EQ] = ACTIONS(4062),
    [anon_sym_DOT] = ACTIONS(4060),
    [anon_sym_switch] = ACTIONS(4062),
    [anon_sym_DOT_DOT] = ACTIONS(4062),
    [anon_sym_and] = ACTIONS(4062),
    [anon_sym_or] = ACTIONS(4062),
    [anon_sym_PLUS_EQ] = ACTIONS(4062),
    [anon_sym_DASH_EQ] = ACTIONS(4062),
    [anon_sym_STAR_EQ] = ACTIONS(4062),
    [anon_sym_SLASH_EQ] = ACTIONS(4062),
    [anon_sym_PERCENT_EQ] = ACTIONS(4062),
    [anon_sym_AMP_EQ] = ACTIONS(4062),
    [anon_sym_CARET_EQ] = ACTIONS(4062),
    [anon_sym_PIPE_EQ] = ACTIONS(4062),
    [anon_sym_LT_LT_EQ] = ACTIONS(4062),
    [anon_sym_GT_GT_EQ] = ACTIONS(4062),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4062),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4062),
    [anon_sym_AMP_AMP] = ACTIONS(4062),
    [anon_sym_PIPE_PIPE] = ACTIONS(4062),
    [anon_sym_QMARK_QMARK] = ACTIONS(4060),
    [anon_sym_into] = ACTIONS(4062),
    [anon_sym_as] = ACTIONS(4062),
    [anon_sym_is] = ACTIONS(4062),
    [anon_sym_DASH_GT] = ACTIONS(4062),
    [anon_sym_with] = ACTIONS(4062),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4062),
  },
  [3880] = {
    [sym_preproc_region] = STATE(3880),
    [sym_preproc_endregion] = STATE(3880),
    [sym_preproc_line] = STATE(3880),
    [sym_preproc_pragma] = STATE(3880),
    [sym_preproc_nullable] = STATE(3880),
    [sym_preproc_error] = STATE(3880),
    [sym_preproc_define] = STATE(3880),
    [sym_preproc_undef] = STATE(3880),
    [anon_sym_SEMI] = ACTIONS(4087),
    [anon_sym_LBRACK] = ACTIONS(4087),
    [anon_sym_COLON] = ACTIONS(4087),
    [anon_sym_COMMA] = ACTIONS(4087),
    [anon_sym_RBRACK] = ACTIONS(4087),
    [anon_sym_LPAREN] = ACTIONS(4087),
    [anon_sym_RPAREN] = ACTIONS(4087),
    [anon_sym_LBRACE] = ACTIONS(4087),
    [anon_sym_RBRACE] = ACTIONS(4087),
    [anon_sym_LT] = ACTIONS(4085),
    [anon_sym_GT] = ACTIONS(4085),
    [anon_sym_in] = ACTIONS(4085),
    [anon_sym_QMARK] = ACTIONS(4085),
    [anon_sym_BANG] = ACTIONS(4085),
    [anon_sym_PLUS_PLUS] = ACTIONS(4087),
    [anon_sym_DASH_DASH] = ACTIONS(4087),
    [anon_sym_PLUS] = ACTIONS(4085),
    [anon_sym_DASH] = ACTIONS(4085),
    [anon_sym_STAR] = ACTIONS(4087),
    [anon_sym_SLASH] = ACTIONS(4085),
    [anon_sym_PERCENT] = ACTIONS(4087),
    [anon_sym_CARET] = ACTIONS(4087),
    [anon_sym_PIPE] = ACTIONS(4085),
    [anon_sym_AMP] = ACTIONS(4085),
    [anon_sym_LT_LT] = ACTIONS(4087),
    [anon_sym_GT_GT] = ACTIONS(4085),
    [anon_sym_GT_GT_GT] = ACTIONS(4087),
    [anon_sym_EQ_EQ] = ACTIONS(4087),
    [anon_sym_BANG_EQ] = ACTIONS(4087),
    [anon_sym_GT_EQ] = ACTIONS(4087),
    [anon_sym_LT_EQ] = ACTIONS(4087),
    [anon_sym_DOT] = ACTIONS(4085),
    [anon_sym_EQ_GT] = ACTIONS(4087),
    [anon_sym_switch] = ACTIONS(4087),
    [anon_sym_when] = ACTIONS(4087),
    [anon_sym_DOT_DOT] = ACTIONS(4087),
    [anon_sym_and] = ACTIONS(4087),
    [anon_sym_or] = ACTIONS(4087),
    [anon_sym_AMP_AMP] = ACTIONS(4087),
    [anon_sym_PIPE_PIPE] = ACTIONS(4087),
    [anon_sym_QMARK_QMARK] = ACTIONS(4087),
    [anon_sym_into] = ACTIONS(4087),
    [anon_sym_on] = ACTIONS(4087),
    [anon_sym_equals] = ACTIONS(4087),
    [anon_sym_by] = ACTIONS(4087),
    [anon_sym_as] = ACTIONS(4087),
    [anon_sym_is] = ACTIONS(4087),
    [anon_sym_DASH_GT] = ACTIONS(4087),
    [anon_sym_with] = ACTIONS(4087),
    [aux_sym_preproc_if_token3] = ACTIONS(4087),
    [aux_sym_preproc_else_token1] = ACTIONS(4087),
    [aux_sym_preproc_elif_token1] = ACTIONS(4087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3881] = {
    [sym_preproc_region] = STATE(3881),
    [sym_preproc_endregion] = STATE(3881),
    [sym_preproc_line] = STATE(3881),
    [sym_preproc_pragma] = STATE(3881),
    [sym_preproc_nullable] = STATE(3881),
    [sym_preproc_error] = STATE(3881),
    [sym_preproc_define] = STATE(3881),
    [sym_preproc_undef] = STATE(3881),
    [anon_sym_SEMI] = ACTIONS(4408),
    [anon_sym_LBRACK] = ACTIONS(4408),
    [anon_sym_COLON] = ACTIONS(4408),
    [anon_sym_COMMA] = ACTIONS(4408),
    [anon_sym_RBRACK] = ACTIONS(4408),
    [anon_sym_LPAREN] = ACTIONS(4408),
    [anon_sym_RPAREN] = ACTIONS(4408),
    [anon_sym_LBRACE] = ACTIONS(4408),
    [anon_sym_RBRACE] = ACTIONS(4408),
    [anon_sym_LT] = ACTIONS(4406),
    [anon_sym_GT] = ACTIONS(4406),
    [anon_sym_in] = ACTIONS(4406),
    [anon_sym_QMARK] = ACTIONS(4406),
    [anon_sym_BANG] = ACTIONS(4406),
    [anon_sym_PLUS_PLUS] = ACTIONS(4408),
    [anon_sym_DASH_DASH] = ACTIONS(4408),
    [anon_sym_PLUS] = ACTIONS(4406),
    [anon_sym_DASH] = ACTIONS(4406),
    [anon_sym_STAR] = ACTIONS(4408),
    [anon_sym_SLASH] = ACTIONS(4406),
    [anon_sym_PERCENT] = ACTIONS(4408),
    [anon_sym_CARET] = ACTIONS(4408),
    [anon_sym_PIPE] = ACTIONS(4406),
    [anon_sym_AMP] = ACTIONS(4406),
    [anon_sym_LT_LT] = ACTIONS(4408),
    [anon_sym_GT_GT] = ACTIONS(4406),
    [anon_sym_GT_GT_GT] = ACTIONS(4408),
    [anon_sym_EQ_EQ] = ACTIONS(4408),
    [anon_sym_BANG_EQ] = ACTIONS(4408),
    [anon_sym_GT_EQ] = ACTIONS(4408),
    [anon_sym_LT_EQ] = ACTIONS(4408),
    [anon_sym_DOT] = ACTIONS(4406),
    [anon_sym_EQ_GT] = ACTIONS(4408),
    [anon_sym_switch] = ACTIONS(4408),
    [anon_sym_when] = ACTIONS(4408),
    [anon_sym_DOT_DOT] = ACTIONS(4408),
    [anon_sym_and] = ACTIONS(4408),
    [anon_sym_or] = ACTIONS(4408),
    [anon_sym_AMP_AMP] = ACTIONS(4408),
    [anon_sym_PIPE_PIPE] = ACTIONS(4408),
    [anon_sym_QMARK_QMARK] = ACTIONS(4408),
    [anon_sym_into] = ACTIONS(4408),
    [anon_sym_on] = ACTIONS(4408),
    [anon_sym_equals] = ACTIONS(4408),
    [anon_sym_by] = ACTIONS(4408),
    [anon_sym_as] = ACTIONS(4408),
    [anon_sym_is] = ACTIONS(4408),
    [anon_sym_DASH_GT] = ACTIONS(4408),
    [anon_sym_with] = ACTIONS(4408),
    [aux_sym_preproc_if_token3] = ACTIONS(4408),
    [aux_sym_preproc_else_token1] = ACTIONS(4408),
    [aux_sym_preproc_elif_token1] = ACTIONS(4408),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3882] = {
    [sym_preproc_region] = STATE(3882),
    [sym_preproc_endregion] = STATE(3882),
    [sym_preproc_line] = STATE(3882),
    [sym_preproc_pragma] = STATE(3882),
    [sym_preproc_nullable] = STATE(3882),
    [sym_preproc_error] = STATE(3882),
    [sym_preproc_define] = STATE(3882),
    [sym_preproc_undef] = STATE(3882),
    [anon_sym_SEMI] = ACTIONS(5292),
    [anon_sym_LBRACK] = ACTIONS(5292),
    [anon_sym_COLON] = ACTIONS(5292),
    [anon_sym_COMMA] = ACTIONS(5292),
    [anon_sym_RBRACK] = ACTIONS(5292),
    [anon_sym_LPAREN] = ACTIONS(5292),
    [anon_sym_RPAREN] = ACTIONS(5292),
    [anon_sym_RBRACE] = ACTIONS(5292),
    [anon_sym_LT] = ACTIONS(5294),
    [anon_sym_GT] = ACTIONS(5294),
    [anon_sym_in] = ACTIONS(5292),
    [anon_sym_QMARK] = ACTIONS(5294),
    [anon_sym_BANG] = ACTIONS(5294),
    [anon_sym_PLUS_PLUS] = ACTIONS(5292),
    [anon_sym_DASH_DASH] = ACTIONS(5292),
    [anon_sym_PLUS] = ACTIONS(5294),
    [anon_sym_DASH] = ACTIONS(5294),
    [anon_sym_STAR] = ACTIONS(5292),
    [anon_sym_SLASH] = ACTIONS(5294),
    [anon_sym_PERCENT] = ACTIONS(5292),
    [anon_sym_CARET] = ACTIONS(5292),
    [anon_sym_PIPE] = ACTIONS(5294),
    [anon_sym_AMP] = ACTIONS(5294),
    [anon_sym_LT_LT] = ACTIONS(5292),
    [anon_sym_GT_GT] = ACTIONS(5294),
    [anon_sym_GT_GT_GT] = ACTIONS(5292),
    [anon_sym_EQ_EQ] = ACTIONS(5292),
    [anon_sym_BANG_EQ] = ACTIONS(5292),
    [anon_sym_GT_EQ] = ACTIONS(5292),
    [anon_sym_LT_EQ] = ACTIONS(5292),
    [anon_sym_DOT] = ACTIONS(5294),
    [anon_sym_EQ_GT] = ACTIONS(5292),
    [anon_sym_switch] = ACTIONS(5292),
    [anon_sym_when] = ACTIONS(5292),
    [anon_sym_DOT_DOT] = ACTIONS(5292),
    [anon_sym_and] = ACTIONS(5292),
    [anon_sym_or] = ACTIONS(5292),
    [anon_sym_AMP_AMP] = ACTIONS(5292),
    [anon_sym_PIPE_PIPE] = ACTIONS(5292),
    [anon_sym_QMARK_QMARK] = ACTIONS(5292),
    [anon_sym_on] = ACTIONS(5292),
    [anon_sym_equals] = ACTIONS(5292),
    [anon_sym_by] = ACTIONS(5292),
    [anon_sym_as] = ACTIONS(5292),
    [anon_sym_is] = ACTIONS(5292),
    [anon_sym_DQUOTE] = ACTIONS(5292),
    [anon_sym_DASH_GT] = ACTIONS(5292),
    [anon_sym_with] = ACTIONS(5292),
    [sym_string_literal_encoding] = ACTIONS(5731),
    [aux_sym_preproc_if_token3] = ACTIONS(5292),
    [aux_sym_preproc_else_token1] = ACTIONS(5292),
    [aux_sym_preproc_elif_token1] = ACTIONS(5292),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3883] = {
    [sym_preproc_region] = STATE(3883),
    [sym_preproc_endregion] = STATE(3883),
    [sym_preproc_line] = STATE(3883),
    [sym_preproc_pragma] = STATE(3883),
    [sym_preproc_nullable] = STATE(3883),
    [sym_preproc_error] = STATE(3883),
    [sym_preproc_define] = STATE(3883),
    [sym_preproc_undef] = STATE(3883),
    [anon_sym_SEMI] = ACTIONS(5319),
    [anon_sym_LBRACK] = ACTIONS(5319),
    [anon_sym_COLON] = ACTIONS(5319),
    [anon_sym_COMMA] = ACTIONS(5319),
    [anon_sym_RBRACK] = ACTIONS(5319),
    [anon_sym_LPAREN] = ACTIONS(5319),
    [anon_sym_RPAREN] = ACTIONS(5319),
    [anon_sym_RBRACE] = ACTIONS(5319),
    [anon_sym_LT] = ACTIONS(5321),
    [anon_sym_GT] = ACTIONS(5321),
    [anon_sym_in] = ACTIONS(5319),
    [anon_sym_QMARK] = ACTIONS(5321),
    [anon_sym_BANG] = ACTIONS(5321),
    [anon_sym_PLUS_PLUS] = ACTIONS(5319),
    [anon_sym_DASH_DASH] = ACTIONS(5319),
    [anon_sym_PLUS] = ACTIONS(5321),
    [anon_sym_DASH] = ACTIONS(5321),
    [anon_sym_STAR] = ACTIONS(5319),
    [anon_sym_SLASH] = ACTIONS(5321),
    [anon_sym_PERCENT] = ACTIONS(5319),
    [anon_sym_CARET] = ACTIONS(5319),
    [anon_sym_PIPE] = ACTIONS(5321),
    [anon_sym_AMP] = ACTIONS(5321),
    [anon_sym_LT_LT] = ACTIONS(5319),
    [anon_sym_GT_GT] = ACTIONS(5321),
    [anon_sym_GT_GT_GT] = ACTIONS(5319),
    [anon_sym_EQ_EQ] = ACTIONS(5319),
    [anon_sym_BANG_EQ] = ACTIONS(5319),
    [anon_sym_GT_EQ] = ACTIONS(5319),
    [anon_sym_LT_EQ] = ACTIONS(5319),
    [anon_sym_DOT] = ACTIONS(5321),
    [anon_sym_EQ_GT] = ACTIONS(5319),
    [anon_sym_switch] = ACTIONS(5319),
    [anon_sym_when] = ACTIONS(5319),
    [anon_sym_DOT_DOT] = ACTIONS(5319),
    [anon_sym_and] = ACTIONS(5319),
    [anon_sym_or] = ACTIONS(5319),
    [anon_sym_AMP_AMP] = ACTIONS(5319),
    [anon_sym_PIPE_PIPE] = ACTIONS(5319),
    [anon_sym_QMARK_QMARK] = ACTIONS(5319),
    [anon_sym_on] = ACTIONS(5319),
    [anon_sym_equals] = ACTIONS(5319),
    [anon_sym_by] = ACTIONS(5319),
    [anon_sym_as] = ACTIONS(5319),
    [anon_sym_is] = ACTIONS(5319),
    [anon_sym_DQUOTE] = ACTIONS(5319),
    [anon_sym_DASH_GT] = ACTIONS(5319),
    [anon_sym_with] = ACTIONS(5319),
    [sym_string_literal_encoding] = ACTIONS(5733),
    [aux_sym_preproc_if_token3] = ACTIONS(5319),
    [aux_sym_preproc_else_token1] = ACTIONS(5319),
    [aux_sym_preproc_elif_token1] = ACTIONS(5319),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3884] = {
    [sym_preproc_region] = STATE(3884),
    [sym_preproc_endregion] = STATE(3884),
    [sym_preproc_line] = STATE(3884),
    [sym_preproc_pragma] = STATE(3884),
    [sym_preproc_nullable] = STATE(3884),
    [sym_preproc_error] = STATE(3884),
    [sym_preproc_define] = STATE(3884),
    [sym_preproc_undef] = STATE(3884),
    [anon_sym_EQ] = ACTIONS(4070),
    [anon_sym_LBRACK] = ACTIONS(4072),
    [anon_sym_COLON] = ACTIONS(4072),
    [anon_sym_COMMA] = ACTIONS(4072),
    [anon_sym_LPAREN] = ACTIONS(4072),
    [anon_sym_LT] = ACTIONS(4070),
    [anon_sym_GT] = ACTIONS(4070),
    [anon_sym_QMARK] = ACTIONS(4070),
    [anon_sym_BANG] = ACTIONS(4070),
    [anon_sym_PLUS_PLUS] = ACTIONS(4072),
    [anon_sym_DASH_DASH] = ACTIONS(4072),
    [anon_sym_PLUS] = ACTIONS(4070),
    [anon_sym_DASH] = ACTIONS(4070),
    [anon_sym_STAR] = ACTIONS(4070),
    [anon_sym_SLASH] = ACTIONS(4070),
    [anon_sym_PERCENT] = ACTIONS(4070),
    [anon_sym_CARET] = ACTIONS(4070),
    [anon_sym_PIPE] = ACTIONS(4070),
    [anon_sym_AMP] = ACTIONS(4070),
    [anon_sym_LT_LT] = ACTIONS(4070),
    [anon_sym_GT_GT] = ACTIONS(4070),
    [anon_sym_GT_GT_GT] = ACTIONS(4070),
    [anon_sym_EQ_EQ] = ACTIONS(4072),
    [anon_sym_BANG_EQ] = ACTIONS(4072),
    [anon_sym_GT_EQ] = ACTIONS(4072),
    [anon_sym_LT_EQ] = ACTIONS(4072),
    [anon_sym_DOT] = ACTIONS(4070),
    [anon_sym_switch] = ACTIONS(4072),
    [anon_sym_DOT_DOT] = ACTIONS(4072),
    [anon_sym_and] = ACTIONS(4072),
    [anon_sym_or] = ACTIONS(4072),
    [anon_sym_PLUS_EQ] = ACTIONS(4072),
    [anon_sym_DASH_EQ] = ACTIONS(4072),
    [anon_sym_STAR_EQ] = ACTIONS(4072),
    [anon_sym_SLASH_EQ] = ACTIONS(4072),
    [anon_sym_PERCENT_EQ] = ACTIONS(4072),
    [anon_sym_AMP_EQ] = ACTIONS(4072),
    [anon_sym_CARET_EQ] = ACTIONS(4072),
    [anon_sym_PIPE_EQ] = ACTIONS(4072),
    [anon_sym_LT_LT_EQ] = ACTIONS(4072),
    [anon_sym_GT_GT_EQ] = ACTIONS(4072),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4072),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4072),
    [anon_sym_AMP_AMP] = ACTIONS(4072),
    [anon_sym_PIPE_PIPE] = ACTIONS(4072),
    [anon_sym_QMARK_QMARK] = ACTIONS(4070),
    [anon_sym_into] = ACTIONS(4072),
    [anon_sym_as] = ACTIONS(4072),
    [anon_sym_is] = ACTIONS(4072),
    [anon_sym_DASH_GT] = ACTIONS(4072),
    [anon_sym_with] = ACTIONS(4072),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4072),
  },
  [3885] = {
    [sym_preproc_region] = STATE(3885),
    [sym_preproc_endregion] = STATE(3885),
    [sym_preproc_line] = STATE(3885),
    [sym_preproc_pragma] = STATE(3885),
    [sym_preproc_nullable] = STATE(3885),
    [sym_preproc_error] = STATE(3885),
    [sym_preproc_define] = STATE(3885),
    [sym_preproc_undef] = STATE(3885),
    [anon_sym_SEMI] = ACTIONS(4072),
    [anon_sym_LBRACK] = ACTIONS(4072),
    [anon_sym_COLON] = ACTIONS(4072),
    [anon_sym_COMMA] = ACTIONS(4072),
    [anon_sym_RBRACK] = ACTIONS(4072),
    [anon_sym_LPAREN] = ACTIONS(4072),
    [anon_sym_RPAREN] = ACTIONS(4072),
    [anon_sym_LBRACE] = ACTIONS(4072),
    [anon_sym_RBRACE] = ACTIONS(4072),
    [anon_sym_LT] = ACTIONS(4070),
    [anon_sym_GT] = ACTIONS(4070),
    [anon_sym_in] = ACTIONS(4070),
    [anon_sym_QMARK] = ACTIONS(4070),
    [anon_sym_BANG] = ACTIONS(4070),
    [anon_sym_PLUS_PLUS] = ACTIONS(4072),
    [anon_sym_DASH_DASH] = ACTIONS(4072),
    [anon_sym_PLUS] = ACTIONS(4070),
    [anon_sym_DASH] = ACTIONS(4070),
    [anon_sym_STAR] = ACTIONS(4072),
    [anon_sym_SLASH] = ACTIONS(4070),
    [anon_sym_PERCENT] = ACTIONS(4072),
    [anon_sym_CARET] = ACTIONS(4072),
    [anon_sym_PIPE] = ACTIONS(4070),
    [anon_sym_AMP] = ACTIONS(4070),
    [anon_sym_LT_LT] = ACTIONS(4072),
    [anon_sym_GT_GT] = ACTIONS(4070),
    [anon_sym_GT_GT_GT] = ACTIONS(4072),
    [anon_sym_EQ_EQ] = ACTIONS(4072),
    [anon_sym_BANG_EQ] = ACTIONS(4072),
    [anon_sym_GT_EQ] = ACTIONS(4072),
    [anon_sym_LT_EQ] = ACTIONS(4072),
    [anon_sym_DOT] = ACTIONS(4070),
    [anon_sym_EQ_GT] = ACTIONS(4072),
    [anon_sym_switch] = ACTIONS(4072),
    [anon_sym_when] = ACTIONS(4072),
    [anon_sym_DOT_DOT] = ACTIONS(4072),
    [anon_sym_and] = ACTIONS(4072),
    [anon_sym_or] = ACTIONS(4072),
    [anon_sym_AMP_AMP] = ACTIONS(4072),
    [anon_sym_PIPE_PIPE] = ACTIONS(4072),
    [anon_sym_QMARK_QMARK] = ACTIONS(4072),
    [anon_sym_into] = ACTIONS(4072),
    [anon_sym_on] = ACTIONS(4072),
    [anon_sym_equals] = ACTIONS(4072),
    [anon_sym_by] = ACTIONS(4072),
    [anon_sym_as] = ACTIONS(4072),
    [anon_sym_is] = ACTIONS(4072),
    [anon_sym_DASH_GT] = ACTIONS(4072),
    [anon_sym_with] = ACTIONS(4072),
    [aux_sym_preproc_if_token3] = ACTIONS(4072),
    [aux_sym_preproc_else_token1] = ACTIONS(4072),
    [aux_sym_preproc_elif_token1] = ACTIONS(4072),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3886] = {
    [sym_preproc_region] = STATE(3886),
    [sym_preproc_endregion] = STATE(3886),
    [sym_preproc_line] = STATE(3886),
    [sym_preproc_pragma] = STATE(3886),
    [sym_preproc_nullable] = STATE(3886),
    [sym_preproc_error] = STATE(3886),
    [sym_preproc_define] = STATE(3886),
    [sym_preproc_undef] = STATE(3886),
    [anon_sym_EQ] = ACTIONS(4590),
    [anon_sym_LBRACK] = ACTIONS(4588),
    [anon_sym_COLON] = ACTIONS(4588),
    [anon_sym_COMMA] = ACTIONS(4588),
    [anon_sym_LPAREN] = ACTIONS(4588),
    [anon_sym_LT] = ACTIONS(4590),
    [anon_sym_GT] = ACTIONS(4590),
    [anon_sym_QMARK] = ACTIONS(4590),
    [anon_sym_BANG] = ACTIONS(4590),
    [anon_sym_PLUS_PLUS] = ACTIONS(4588),
    [anon_sym_DASH_DASH] = ACTIONS(4588),
    [anon_sym_PLUS] = ACTIONS(4590),
    [anon_sym_DASH] = ACTIONS(4590),
    [anon_sym_STAR] = ACTIONS(4590),
    [anon_sym_SLASH] = ACTIONS(4590),
    [anon_sym_PERCENT] = ACTIONS(4590),
    [anon_sym_CARET] = ACTIONS(4590),
    [anon_sym_PIPE] = ACTIONS(4590),
    [anon_sym_AMP] = ACTIONS(4590),
    [anon_sym_LT_LT] = ACTIONS(4590),
    [anon_sym_GT_GT] = ACTIONS(4590),
    [anon_sym_GT_GT_GT] = ACTIONS(4590),
    [anon_sym_EQ_EQ] = ACTIONS(4588),
    [anon_sym_BANG_EQ] = ACTIONS(4588),
    [anon_sym_GT_EQ] = ACTIONS(4588),
    [anon_sym_LT_EQ] = ACTIONS(4588),
    [anon_sym_DOT] = ACTIONS(4590),
    [anon_sym_switch] = ACTIONS(4588),
    [anon_sym_DOT_DOT] = ACTIONS(4588),
    [anon_sym_and] = ACTIONS(4588),
    [anon_sym_or] = ACTIONS(4588),
    [anon_sym_PLUS_EQ] = ACTIONS(4588),
    [anon_sym_DASH_EQ] = ACTIONS(4588),
    [anon_sym_STAR_EQ] = ACTIONS(4588),
    [anon_sym_SLASH_EQ] = ACTIONS(4588),
    [anon_sym_PERCENT_EQ] = ACTIONS(4588),
    [anon_sym_AMP_EQ] = ACTIONS(4588),
    [anon_sym_CARET_EQ] = ACTIONS(4588),
    [anon_sym_PIPE_EQ] = ACTIONS(4588),
    [anon_sym_LT_LT_EQ] = ACTIONS(4588),
    [anon_sym_GT_GT_EQ] = ACTIONS(4588),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4588),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4588),
    [anon_sym_AMP_AMP] = ACTIONS(4588),
    [anon_sym_PIPE_PIPE] = ACTIONS(4588),
    [anon_sym_QMARK_QMARK] = ACTIONS(4590),
    [anon_sym_into] = ACTIONS(4588),
    [anon_sym_as] = ACTIONS(4588),
    [anon_sym_is] = ACTIONS(4588),
    [anon_sym_DASH_GT] = ACTIONS(4588),
    [anon_sym_with] = ACTIONS(4588),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4588),
  },
  [3887] = {
    [sym_preproc_region] = STATE(3887),
    [sym_preproc_endregion] = STATE(3887),
    [sym_preproc_line] = STATE(3887),
    [sym_preproc_pragma] = STATE(3887),
    [sym_preproc_nullable] = STATE(3887),
    [sym_preproc_error] = STATE(3887),
    [sym_preproc_define] = STATE(3887),
    [sym_preproc_undef] = STATE(3887),
    [anon_sym_SEMI] = ACTIONS(4566),
    [anon_sym_LBRACK] = ACTIONS(4566),
    [anon_sym_COLON] = ACTIONS(4566),
    [anon_sym_COMMA] = ACTIONS(4566),
    [anon_sym_RBRACK] = ACTIONS(4566),
    [anon_sym_LPAREN] = ACTIONS(4566),
    [anon_sym_RPAREN] = ACTIONS(4566),
    [anon_sym_LBRACE] = ACTIONS(4566),
    [anon_sym_RBRACE] = ACTIONS(4566),
    [anon_sym_LT] = ACTIONS(4564),
    [anon_sym_GT] = ACTIONS(4564),
    [anon_sym_in] = ACTIONS(4564),
    [anon_sym_QMARK] = ACTIONS(4564),
    [anon_sym_BANG] = ACTIONS(4564),
    [anon_sym_PLUS_PLUS] = ACTIONS(4566),
    [anon_sym_DASH_DASH] = ACTIONS(4566),
    [anon_sym_PLUS] = ACTIONS(4564),
    [anon_sym_DASH] = ACTIONS(4564),
    [anon_sym_STAR] = ACTIONS(4566),
    [anon_sym_SLASH] = ACTIONS(4564),
    [anon_sym_PERCENT] = ACTIONS(4566),
    [anon_sym_CARET] = ACTIONS(4566),
    [anon_sym_PIPE] = ACTIONS(4564),
    [anon_sym_AMP] = ACTIONS(4564),
    [anon_sym_LT_LT] = ACTIONS(4566),
    [anon_sym_GT_GT] = ACTIONS(4564),
    [anon_sym_GT_GT_GT] = ACTIONS(4566),
    [anon_sym_EQ_EQ] = ACTIONS(4566),
    [anon_sym_BANG_EQ] = ACTIONS(4566),
    [anon_sym_GT_EQ] = ACTIONS(4566),
    [anon_sym_LT_EQ] = ACTIONS(4566),
    [anon_sym_DOT] = ACTIONS(4564),
    [anon_sym_EQ_GT] = ACTIONS(4566),
    [anon_sym_switch] = ACTIONS(4566),
    [anon_sym_when] = ACTIONS(4566),
    [anon_sym_DOT_DOT] = ACTIONS(4566),
    [anon_sym_and] = ACTIONS(4566),
    [anon_sym_or] = ACTIONS(4566),
    [anon_sym_AMP_AMP] = ACTIONS(4566),
    [anon_sym_PIPE_PIPE] = ACTIONS(4566),
    [anon_sym_QMARK_QMARK] = ACTIONS(4566),
    [anon_sym_into] = ACTIONS(4566),
    [anon_sym_on] = ACTIONS(4566),
    [anon_sym_equals] = ACTIONS(4566),
    [anon_sym_by] = ACTIONS(4566),
    [anon_sym_as] = ACTIONS(4566),
    [anon_sym_is] = ACTIONS(4566),
    [anon_sym_DASH_GT] = ACTIONS(4566),
    [anon_sym_with] = ACTIONS(4566),
    [aux_sym_preproc_if_token3] = ACTIONS(4566),
    [aux_sym_preproc_else_token1] = ACTIONS(4566),
    [aux_sym_preproc_elif_token1] = ACTIONS(4566),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3888] = {
    [sym_preproc_region] = STATE(3888),
    [sym_preproc_endregion] = STATE(3888),
    [sym_preproc_line] = STATE(3888),
    [sym_preproc_pragma] = STATE(3888),
    [sym_preproc_nullable] = STATE(3888),
    [sym_preproc_error] = STATE(3888),
    [sym_preproc_define] = STATE(3888),
    [sym_preproc_undef] = STATE(3888),
    [anon_sym_SEMI] = ACTIONS(4504),
    [anon_sym_LBRACK] = ACTIONS(4504),
    [anon_sym_COLON] = ACTIONS(4504),
    [anon_sym_COMMA] = ACTIONS(4504),
    [anon_sym_RBRACK] = ACTIONS(4504),
    [anon_sym_LPAREN] = ACTIONS(4504),
    [anon_sym_RPAREN] = ACTIONS(4504),
    [anon_sym_LBRACE] = ACTIONS(4504),
    [anon_sym_RBRACE] = ACTIONS(4504),
    [anon_sym_LT] = ACTIONS(4502),
    [anon_sym_GT] = ACTIONS(4502),
    [anon_sym_in] = ACTIONS(4502),
    [anon_sym_QMARK] = ACTIONS(4502),
    [anon_sym_BANG] = ACTIONS(4502),
    [anon_sym_PLUS_PLUS] = ACTIONS(4504),
    [anon_sym_DASH_DASH] = ACTIONS(4504),
    [anon_sym_PLUS] = ACTIONS(4502),
    [anon_sym_DASH] = ACTIONS(4502),
    [anon_sym_STAR] = ACTIONS(4504),
    [anon_sym_SLASH] = ACTIONS(4502),
    [anon_sym_PERCENT] = ACTIONS(4504),
    [anon_sym_CARET] = ACTIONS(4504),
    [anon_sym_PIPE] = ACTIONS(4502),
    [anon_sym_AMP] = ACTIONS(4502),
    [anon_sym_LT_LT] = ACTIONS(4504),
    [anon_sym_GT_GT] = ACTIONS(4502),
    [anon_sym_GT_GT_GT] = ACTIONS(4504),
    [anon_sym_EQ_EQ] = ACTIONS(4504),
    [anon_sym_BANG_EQ] = ACTIONS(4504),
    [anon_sym_GT_EQ] = ACTIONS(4504),
    [anon_sym_LT_EQ] = ACTIONS(4504),
    [anon_sym_DOT] = ACTIONS(4502),
    [anon_sym_EQ_GT] = ACTIONS(4504),
    [anon_sym_switch] = ACTIONS(4504),
    [anon_sym_when] = ACTIONS(4504),
    [anon_sym_DOT_DOT] = ACTIONS(4504),
    [anon_sym_and] = ACTIONS(4504),
    [anon_sym_or] = ACTIONS(4504),
    [anon_sym_AMP_AMP] = ACTIONS(4504),
    [anon_sym_PIPE_PIPE] = ACTIONS(4504),
    [anon_sym_QMARK_QMARK] = ACTIONS(4504),
    [anon_sym_into] = ACTIONS(4504),
    [anon_sym_on] = ACTIONS(4504),
    [anon_sym_equals] = ACTIONS(4504),
    [anon_sym_by] = ACTIONS(4504),
    [anon_sym_as] = ACTIONS(4504),
    [anon_sym_is] = ACTIONS(4504),
    [anon_sym_DASH_GT] = ACTIONS(4504),
    [anon_sym_with] = ACTIONS(4504),
    [aux_sym_preproc_if_token3] = ACTIONS(4504),
    [aux_sym_preproc_else_token1] = ACTIONS(4504),
    [aux_sym_preproc_elif_token1] = ACTIONS(4504),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3889] = {
    [sym_preproc_region] = STATE(3889),
    [sym_preproc_endregion] = STATE(3889),
    [sym_preproc_line] = STATE(3889),
    [sym_preproc_pragma] = STATE(3889),
    [sym_preproc_nullable] = STATE(3889),
    [sym_preproc_error] = STATE(3889),
    [sym_preproc_define] = STATE(3889),
    [sym_preproc_undef] = STATE(3889),
    [anon_sym_SEMI] = ACTIONS(4106),
    [anon_sym_LBRACK] = ACTIONS(4106),
    [anon_sym_COLON] = ACTIONS(4106),
    [anon_sym_COMMA] = ACTIONS(4106),
    [anon_sym_RBRACK] = ACTIONS(4106),
    [anon_sym_LPAREN] = ACTIONS(4106),
    [anon_sym_RPAREN] = ACTIONS(4106),
    [anon_sym_LBRACE] = ACTIONS(4106),
    [anon_sym_RBRACE] = ACTIONS(4106),
    [anon_sym_LT] = ACTIONS(4099),
    [anon_sym_GT] = ACTIONS(4099),
    [anon_sym_in] = ACTIONS(4099),
    [anon_sym_QMARK] = ACTIONS(4099),
    [anon_sym_BANG] = ACTIONS(4099),
    [anon_sym_PLUS_PLUS] = ACTIONS(4106),
    [anon_sym_DASH_DASH] = ACTIONS(4106),
    [anon_sym_PLUS] = ACTIONS(4099),
    [anon_sym_DASH] = ACTIONS(4099),
    [anon_sym_STAR] = ACTIONS(4106),
    [anon_sym_SLASH] = ACTIONS(4099),
    [anon_sym_PERCENT] = ACTIONS(4106),
    [anon_sym_CARET] = ACTIONS(4106),
    [anon_sym_PIPE] = ACTIONS(4099),
    [anon_sym_AMP] = ACTIONS(4099),
    [anon_sym_LT_LT] = ACTIONS(4106),
    [anon_sym_GT_GT] = ACTIONS(4099),
    [anon_sym_GT_GT_GT] = ACTIONS(4106),
    [anon_sym_EQ_EQ] = ACTIONS(4106),
    [anon_sym_BANG_EQ] = ACTIONS(4106),
    [anon_sym_GT_EQ] = ACTIONS(4106),
    [anon_sym_LT_EQ] = ACTIONS(4106),
    [anon_sym_DOT] = ACTIONS(4099),
    [anon_sym_EQ_GT] = ACTIONS(4106),
    [anon_sym_switch] = ACTIONS(4106),
    [anon_sym_when] = ACTIONS(4106),
    [anon_sym_DOT_DOT] = ACTIONS(4106),
    [anon_sym_and] = ACTIONS(4106),
    [anon_sym_or] = ACTIONS(4106),
    [anon_sym_AMP_AMP] = ACTIONS(4106),
    [anon_sym_PIPE_PIPE] = ACTIONS(4106),
    [anon_sym_QMARK_QMARK] = ACTIONS(4106),
    [anon_sym_into] = ACTIONS(4106),
    [anon_sym_on] = ACTIONS(4106),
    [anon_sym_equals] = ACTIONS(4106),
    [anon_sym_by] = ACTIONS(4106),
    [anon_sym_as] = ACTIONS(4106),
    [anon_sym_is] = ACTIONS(4106),
    [anon_sym_DASH_GT] = ACTIONS(4106),
    [anon_sym_with] = ACTIONS(4106),
    [aux_sym_preproc_if_token3] = ACTIONS(4106),
    [aux_sym_preproc_else_token1] = ACTIONS(4106),
    [aux_sym_preproc_elif_token1] = ACTIONS(4106),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3890] = {
    [sym_preproc_region] = STATE(3890),
    [sym_preproc_endregion] = STATE(3890),
    [sym_preproc_line] = STATE(3890),
    [sym_preproc_pragma] = STATE(3890),
    [sym_preproc_nullable] = STATE(3890),
    [sym_preproc_error] = STATE(3890),
    [sym_preproc_define] = STATE(3890),
    [sym_preproc_undef] = STATE(3890),
    [anon_sym_SEMI] = ACTIONS(4527),
    [anon_sym_LBRACK] = ACTIONS(4527),
    [anon_sym_COLON] = ACTIONS(4527),
    [anon_sym_COMMA] = ACTIONS(4527),
    [anon_sym_RBRACK] = ACTIONS(4527),
    [anon_sym_LPAREN] = ACTIONS(4527),
    [anon_sym_RPAREN] = ACTIONS(4527),
    [anon_sym_LBRACE] = ACTIONS(4527),
    [anon_sym_RBRACE] = ACTIONS(4527),
    [anon_sym_LT] = ACTIONS(4525),
    [anon_sym_GT] = ACTIONS(4525),
    [anon_sym_in] = ACTIONS(4525),
    [anon_sym_QMARK] = ACTIONS(4525),
    [anon_sym_BANG] = ACTIONS(4525),
    [anon_sym_PLUS_PLUS] = ACTIONS(4527),
    [anon_sym_DASH_DASH] = ACTIONS(4527),
    [anon_sym_PLUS] = ACTIONS(4525),
    [anon_sym_DASH] = ACTIONS(4525),
    [anon_sym_STAR] = ACTIONS(4527),
    [anon_sym_SLASH] = ACTIONS(4525),
    [anon_sym_PERCENT] = ACTIONS(4527),
    [anon_sym_CARET] = ACTIONS(4527),
    [anon_sym_PIPE] = ACTIONS(4525),
    [anon_sym_AMP] = ACTIONS(4525),
    [anon_sym_LT_LT] = ACTIONS(4527),
    [anon_sym_GT_GT] = ACTIONS(4525),
    [anon_sym_GT_GT_GT] = ACTIONS(4527),
    [anon_sym_EQ_EQ] = ACTIONS(4527),
    [anon_sym_BANG_EQ] = ACTIONS(4527),
    [anon_sym_GT_EQ] = ACTIONS(4527),
    [anon_sym_LT_EQ] = ACTIONS(4527),
    [anon_sym_DOT] = ACTIONS(4525),
    [anon_sym_EQ_GT] = ACTIONS(4527),
    [anon_sym_switch] = ACTIONS(4527),
    [anon_sym_when] = ACTIONS(4527),
    [anon_sym_DOT_DOT] = ACTIONS(4527),
    [anon_sym_and] = ACTIONS(4527),
    [anon_sym_or] = ACTIONS(4527),
    [anon_sym_AMP_AMP] = ACTIONS(4527),
    [anon_sym_PIPE_PIPE] = ACTIONS(4527),
    [anon_sym_QMARK_QMARK] = ACTIONS(4527),
    [anon_sym_into] = ACTIONS(4527),
    [anon_sym_on] = ACTIONS(4527),
    [anon_sym_equals] = ACTIONS(4527),
    [anon_sym_by] = ACTIONS(4527),
    [anon_sym_as] = ACTIONS(4527),
    [anon_sym_is] = ACTIONS(4527),
    [anon_sym_DASH_GT] = ACTIONS(4527),
    [anon_sym_with] = ACTIONS(4527),
    [aux_sym_preproc_if_token3] = ACTIONS(4527),
    [aux_sym_preproc_else_token1] = ACTIONS(4527),
    [aux_sym_preproc_elif_token1] = ACTIONS(4527),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3891] = {
    [sym_type_argument_list] = STATE(4046),
    [sym_preproc_region] = STATE(3891),
    [sym_preproc_endregion] = STATE(3891),
    [sym_preproc_line] = STATE(3891),
    [sym_preproc_pragma] = STATE(3891),
    [sym_preproc_nullable] = STATE(3891),
    [sym_preproc_error] = STATE(3891),
    [sym_preproc_define] = STATE(3891),
    [sym_preproc_undef] = STATE(3891),
    [anon_sym_SEMI] = ACTIONS(4076),
    [anon_sym_LBRACK] = ACTIONS(4076),
    [anon_sym_COLON] = ACTIONS(4074),
    [anon_sym_COMMA] = ACTIONS(4076),
    [anon_sym_RBRACK] = ACTIONS(4076),
    [anon_sym_LPAREN] = ACTIONS(4076),
    [anon_sym_RPAREN] = ACTIONS(4076),
    [anon_sym_LBRACE] = ACTIONS(4076),
    [anon_sym_RBRACE] = ACTIONS(4076),
    [anon_sym_LT] = ACTIONS(5728),
    [anon_sym_GT] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(4074),
    [anon_sym_BANG] = ACTIONS(4074),
    [anon_sym_PLUS_PLUS] = ACTIONS(4076),
    [anon_sym_DASH_DASH] = ACTIONS(4076),
    [anon_sym_PLUS] = ACTIONS(4074),
    [anon_sym_DASH] = ACTIONS(4074),
    [anon_sym_STAR] = ACTIONS(4076),
    [anon_sym_SLASH] = ACTIONS(4074),
    [anon_sym_PERCENT] = ACTIONS(4076),
    [anon_sym_CARET] = ACTIONS(4076),
    [anon_sym_PIPE] = ACTIONS(4074),
    [anon_sym_AMP] = ACTIONS(4074),
    [anon_sym_LT_LT] = ACTIONS(4076),
    [anon_sym_GT_GT] = ACTIONS(4074),
    [anon_sym_GT_GT_GT] = ACTIONS(4076),
    [anon_sym_EQ_EQ] = ACTIONS(4076),
    [anon_sym_BANG_EQ] = ACTIONS(4076),
    [anon_sym_GT_EQ] = ACTIONS(4076),
    [anon_sym_LT_EQ] = ACTIONS(4076),
    [anon_sym_DOT] = ACTIONS(4074),
    [anon_sym_EQ_GT] = ACTIONS(4076),
    [anon_sym_COLON_COLON] = ACTIONS(5735),
    [anon_sym_switch] = ACTIONS(4076),
    [anon_sym_when] = ACTIONS(4076),
    [anon_sym_DOT_DOT] = ACTIONS(4076),
    [anon_sym_and] = ACTIONS(4076),
    [anon_sym_or] = ACTIONS(4076),
    [anon_sym_AMP_AMP] = ACTIONS(4076),
    [anon_sym_PIPE_PIPE] = ACTIONS(4076),
    [anon_sym_QMARK_QMARK] = ACTIONS(4076),
    [anon_sym_on] = ACTIONS(4076),
    [anon_sym_equals] = ACTIONS(4076),
    [anon_sym_by] = ACTIONS(4076),
    [anon_sym_as] = ACTIONS(4076),
    [anon_sym_is] = ACTIONS(4076),
    [anon_sym_DASH_GT] = ACTIONS(4076),
    [anon_sym_with] = ACTIONS(4076),
    [aux_sym_preproc_if_token3] = ACTIONS(4076),
    [aux_sym_preproc_else_token1] = ACTIONS(4076),
    [aux_sym_preproc_elif_token1] = ACTIONS(4076),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3892] = {
    [sym_preproc_region] = STATE(3892),
    [sym_preproc_endregion] = STATE(3892),
    [sym_preproc_line] = STATE(3892),
    [sym_preproc_pragma] = STATE(3892),
    [sym_preproc_nullable] = STATE(3892),
    [sym_preproc_error] = STATE(3892),
    [sym_preproc_define] = STATE(3892),
    [sym_preproc_undef] = STATE(3892),
    [anon_sym_SEMI] = ACTIONS(5262),
    [anon_sym_LBRACK] = ACTIONS(5262),
    [anon_sym_COLON] = ACTIONS(5262),
    [anon_sym_COMMA] = ACTIONS(5262),
    [anon_sym_RBRACK] = ACTIONS(5262),
    [anon_sym_LPAREN] = ACTIONS(5262),
    [anon_sym_RPAREN] = ACTIONS(5262),
    [anon_sym_LBRACE] = ACTIONS(5262),
    [anon_sym_RBRACE] = ACTIONS(5262),
    [anon_sym_LT] = ACTIONS(5264),
    [anon_sym_GT] = ACTIONS(5264),
    [anon_sym_in] = ACTIONS(5262),
    [anon_sym_where] = ACTIONS(5262),
    [anon_sym_QMARK] = ACTIONS(5264),
    [anon_sym_BANG] = ACTIONS(5264),
    [anon_sym_PLUS_PLUS] = ACTIONS(5262),
    [anon_sym_DASH_DASH] = ACTIONS(5262),
    [anon_sym_PLUS] = ACTIONS(5264),
    [anon_sym_DASH] = ACTIONS(5264),
    [anon_sym_STAR] = ACTIONS(5262),
    [anon_sym_SLASH] = ACTIONS(5264),
    [anon_sym_PERCENT] = ACTIONS(5262),
    [anon_sym_CARET] = ACTIONS(5262),
    [anon_sym_PIPE] = ACTIONS(5264),
    [anon_sym_AMP] = ACTIONS(5264),
    [anon_sym_LT_LT] = ACTIONS(5262),
    [anon_sym_GT_GT] = ACTIONS(5264),
    [anon_sym_GT_GT_GT] = ACTIONS(5262),
    [anon_sym_EQ_EQ] = ACTIONS(5262),
    [anon_sym_BANG_EQ] = ACTIONS(5262),
    [anon_sym_GT_EQ] = ACTIONS(5262),
    [anon_sym_LT_EQ] = ACTIONS(5262),
    [anon_sym_DOT] = ACTIONS(5264),
    [anon_sym_EQ_GT] = ACTIONS(5262),
    [anon_sym_switch] = ACTIONS(5262),
    [anon_sym_when] = ACTIONS(5262),
    [anon_sym_DOT_DOT] = ACTIONS(5262),
    [anon_sym_and] = ACTIONS(5262),
    [anon_sym_or] = ACTIONS(5262),
    [anon_sym_AMP_AMP] = ACTIONS(5262),
    [anon_sym_PIPE_PIPE] = ACTIONS(5262),
    [anon_sym_QMARK_QMARK] = ACTIONS(5262),
    [anon_sym_on] = ACTIONS(5262),
    [anon_sym_equals] = ACTIONS(5262),
    [anon_sym_by] = ACTIONS(5262),
    [anon_sym_as] = ACTIONS(5262),
    [anon_sym_is] = ACTIONS(5262),
    [anon_sym_DASH_GT] = ACTIONS(5262),
    [anon_sym_with] = ACTIONS(5262),
    [aux_sym_preproc_if_token3] = ACTIONS(5262),
    [aux_sym_preproc_else_token1] = ACTIONS(5262),
    [aux_sym_preproc_elif_token1] = ACTIONS(5262),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3893] = {
    [sym_preproc_region] = STATE(3893),
    [sym_preproc_endregion] = STATE(3893),
    [sym_preproc_line] = STATE(3893),
    [sym_preproc_pragma] = STATE(3893),
    [sym_preproc_nullable] = STATE(3893),
    [sym_preproc_error] = STATE(3893),
    [sym_preproc_define] = STATE(3893),
    [sym_preproc_undef] = STATE(3893),
    [anon_sym_SEMI] = ACTIONS(5266),
    [anon_sym_LBRACK] = ACTIONS(5266),
    [anon_sym_COLON] = ACTIONS(5266),
    [anon_sym_COMMA] = ACTIONS(5266),
    [anon_sym_RBRACK] = ACTIONS(5266),
    [anon_sym_LPAREN] = ACTIONS(5266),
    [anon_sym_RPAREN] = ACTIONS(5266),
    [anon_sym_LBRACE] = ACTIONS(5266),
    [anon_sym_RBRACE] = ACTIONS(5266),
    [anon_sym_LT] = ACTIONS(5268),
    [anon_sym_GT] = ACTIONS(5268),
    [anon_sym_in] = ACTIONS(5266),
    [anon_sym_where] = ACTIONS(5266),
    [anon_sym_QMARK] = ACTIONS(5268),
    [anon_sym_BANG] = ACTIONS(5268),
    [anon_sym_PLUS_PLUS] = ACTIONS(5266),
    [anon_sym_DASH_DASH] = ACTIONS(5266),
    [anon_sym_PLUS] = ACTIONS(5268),
    [anon_sym_DASH] = ACTIONS(5268),
    [anon_sym_STAR] = ACTIONS(5266),
    [anon_sym_SLASH] = ACTIONS(5268),
    [anon_sym_PERCENT] = ACTIONS(5266),
    [anon_sym_CARET] = ACTIONS(5266),
    [anon_sym_PIPE] = ACTIONS(5268),
    [anon_sym_AMP] = ACTIONS(5268),
    [anon_sym_LT_LT] = ACTIONS(5266),
    [anon_sym_GT_GT] = ACTIONS(5268),
    [anon_sym_GT_GT_GT] = ACTIONS(5266),
    [anon_sym_EQ_EQ] = ACTIONS(5266),
    [anon_sym_BANG_EQ] = ACTIONS(5266),
    [anon_sym_GT_EQ] = ACTIONS(5266),
    [anon_sym_LT_EQ] = ACTIONS(5266),
    [anon_sym_DOT] = ACTIONS(5268),
    [anon_sym_EQ_GT] = ACTIONS(5266),
    [anon_sym_switch] = ACTIONS(5266),
    [anon_sym_when] = ACTIONS(5266),
    [anon_sym_DOT_DOT] = ACTIONS(5266),
    [anon_sym_and] = ACTIONS(5266),
    [anon_sym_or] = ACTIONS(5266),
    [anon_sym_AMP_AMP] = ACTIONS(5266),
    [anon_sym_PIPE_PIPE] = ACTIONS(5266),
    [anon_sym_QMARK_QMARK] = ACTIONS(5266),
    [anon_sym_on] = ACTIONS(5266),
    [anon_sym_equals] = ACTIONS(5266),
    [anon_sym_by] = ACTIONS(5266),
    [anon_sym_as] = ACTIONS(5266),
    [anon_sym_is] = ACTIONS(5266),
    [anon_sym_DASH_GT] = ACTIONS(5266),
    [anon_sym_with] = ACTIONS(5266),
    [aux_sym_preproc_if_token3] = ACTIONS(5266),
    [aux_sym_preproc_else_token1] = ACTIONS(5266),
    [aux_sym_preproc_elif_token1] = ACTIONS(5266),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3894] = {
    [sym_preproc_region] = STATE(3894),
    [sym_preproc_endregion] = STATE(3894),
    [sym_preproc_line] = STATE(3894),
    [sym_preproc_pragma] = STATE(3894),
    [sym_preproc_nullable] = STATE(3894),
    [sym_preproc_error] = STATE(3894),
    [sym_preproc_define] = STATE(3894),
    [sym_preproc_undef] = STATE(3894),
    [anon_sym_EQ] = ACTIONS(4085),
    [anon_sym_LBRACK] = ACTIONS(4087),
    [anon_sym_COLON] = ACTIONS(4087),
    [anon_sym_COMMA] = ACTIONS(4087),
    [anon_sym_LPAREN] = ACTIONS(4087),
    [anon_sym_LT] = ACTIONS(4085),
    [anon_sym_GT] = ACTIONS(4085),
    [anon_sym_QMARK] = ACTIONS(4085),
    [anon_sym_BANG] = ACTIONS(4085),
    [anon_sym_PLUS_PLUS] = ACTIONS(4087),
    [anon_sym_DASH_DASH] = ACTIONS(4087),
    [anon_sym_PLUS] = ACTIONS(4085),
    [anon_sym_DASH] = ACTIONS(4085),
    [anon_sym_STAR] = ACTIONS(4085),
    [anon_sym_SLASH] = ACTIONS(4085),
    [anon_sym_PERCENT] = ACTIONS(4085),
    [anon_sym_CARET] = ACTIONS(4085),
    [anon_sym_PIPE] = ACTIONS(4085),
    [anon_sym_AMP] = ACTIONS(4085),
    [anon_sym_LT_LT] = ACTIONS(4085),
    [anon_sym_GT_GT] = ACTIONS(4085),
    [anon_sym_GT_GT_GT] = ACTIONS(4085),
    [anon_sym_EQ_EQ] = ACTIONS(4087),
    [anon_sym_BANG_EQ] = ACTIONS(4087),
    [anon_sym_GT_EQ] = ACTIONS(4087),
    [anon_sym_LT_EQ] = ACTIONS(4087),
    [anon_sym_DOT] = ACTIONS(4085),
    [anon_sym_switch] = ACTIONS(4087),
    [anon_sym_DOT_DOT] = ACTIONS(4087),
    [anon_sym_and] = ACTIONS(4087),
    [anon_sym_or] = ACTIONS(4087),
    [anon_sym_PLUS_EQ] = ACTIONS(4087),
    [anon_sym_DASH_EQ] = ACTIONS(4087),
    [anon_sym_STAR_EQ] = ACTIONS(4087),
    [anon_sym_SLASH_EQ] = ACTIONS(4087),
    [anon_sym_PERCENT_EQ] = ACTIONS(4087),
    [anon_sym_AMP_EQ] = ACTIONS(4087),
    [anon_sym_CARET_EQ] = ACTIONS(4087),
    [anon_sym_PIPE_EQ] = ACTIONS(4087),
    [anon_sym_LT_LT_EQ] = ACTIONS(4087),
    [anon_sym_GT_GT_EQ] = ACTIONS(4087),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4087),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4087),
    [anon_sym_AMP_AMP] = ACTIONS(4087),
    [anon_sym_PIPE_PIPE] = ACTIONS(4087),
    [anon_sym_QMARK_QMARK] = ACTIONS(4085),
    [anon_sym_into] = ACTIONS(4087),
    [anon_sym_as] = ACTIONS(4087),
    [anon_sym_is] = ACTIONS(4087),
    [anon_sym_DASH_GT] = ACTIONS(4087),
    [anon_sym_with] = ACTIONS(4087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4087),
  },
  [3895] = {
    [sym_preproc_region] = STATE(3895),
    [sym_preproc_endregion] = STATE(3895),
    [sym_preproc_line] = STATE(3895),
    [sym_preproc_pragma] = STATE(3895),
    [sym_preproc_nullable] = STATE(3895),
    [sym_preproc_error] = STATE(3895),
    [sym_preproc_define] = STATE(3895),
    [sym_preproc_undef] = STATE(3895),
    [anon_sym_SEMI] = ACTIONS(4062),
    [anon_sym_LBRACK] = ACTIONS(4062),
    [anon_sym_COLON] = ACTIONS(4062),
    [anon_sym_COMMA] = ACTIONS(4062),
    [anon_sym_RBRACK] = ACTIONS(4062),
    [anon_sym_LPAREN] = ACTIONS(4062),
    [anon_sym_RPAREN] = ACTIONS(4062),
    [anon_sym_LBRACE] = ACTIONS(4062),
    [anon_sym_RBRACE] = ACTIONS(4062),
    [anon_sym_LT] = ACTIONS(4060),
    [anon_sym_GT] = ACTIONS(4060),
    [anon_sym_in] = ACTIONS(4060),
    [anon_sym_QMARK] = ACTIONS(4060),
    [anon_sym_BANG] = ACTIONS(4060),
    [anon_sym_PLUS_PLUS] = ACTIONS(4062),
    [anon_sym_DASH_DASH] = ACTIONS(4062),
    [anon_sym_PLUS] = ACTIONS(4060),
    [anon_sym_DASH] = ACTIONS(4060),
    [anon_sym_STAR] = ACTIONS(4062),
    [anon_sym_SLASH] = ACTIONS(4060),
    [anon_sym_PERCENT] = ACTIONS(4062),
    [anon_sym_CARET] = ACTIONS(4062),
    [anon_sym_PIPE] = ACTIONS(4060),
    [anon_sym_AMP] = ACTIONS(4060),
    [anon_sym_LT_LT] = ACTIONS(4062),
    [anon_sym_GT_GT] = ACTIONS(4060),
    [anon_sym_GT_GT_GT] = ACTIONS(4062),
    [anon_sym_EQ_EQ] = ACTIONS(4062),
    [anon_sym_BANG_EQ] = ACTIONS(4062),
    [anon_sym_GT_EQ] = ACTIONS(4062),
    [anon_sym_LT_EQ] = ACTIONS(4062),
    [anon_sym_DOT] = ACTIONS(4060),
    [anon_sym_EQ_GT] = ACTIONS(4062),
    [anon_sym_switch] = ACTIONS(4062),
    [anon_sym_when] = ACTIONS(4062),
    [anon_sym_DOT_DOT] = ACTIONS(4062),
    [anon_sym_and] = ACTIONS(4062),
    [anon_sym_or] = ACTIONS(4062),
    [anon_sym_AMP_AMP] = ACTIONS(4062),
    [anon_sym_PIPE_PIPE] = ACTIONS(4062),
    [anon_sym_QMARK_QMARK] = ACTIONS(4062),
    [anon_sym_into] = ACTIONS(4062),
    [anon_sym_on] = ACTIONS(4062),
    [anon_sym_equals] = ACTIONS(4062),
    [anon_sym_by] = ACTIONS(4062),
    [anon_sym_as] = ACTIONS(4062),
    [anon_sym_is] = ACTIONS(4062),
    [anon_sym_DASH_GT] = ACTIONS(4062),
    [anon_sym_with] = ACTIONS(4062),
    [aux_sym_preproc_if_token3] = ACTIONS(4062),
    [aux_sym_preproc_else_token1] = ACTIONS(4062),
    [aux_sym_preproc_elif_token1] = ACTIONS(4062),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3896] = {
    [sym_preproc_region] = STATE(3896),
    [sym_preproc_endregion] = STATE(3896),
    [sym_preproc_line] = STATE(3896),
    [sym_preproc_pragma] = STATE(3896),
    [sym_preproc_nullable] = STATE(3896),
    [sym_preproc_error] = STATE(3896),
    [sym_preproc_define] = STATE(3896),
    [sym_preproc_undef] = STATE(3896),
    [anon_sym_SEMI] = ACTIONS(5292),
    [anon_sym_LBRACK] = ACTIONS(5292),
    [anon_sym_COLON] = ACTIONS(5292),
    [anon_sym_COMMA] = ACTIONS(5292),
    [anon_sym_RBRACK] = ACTIONS(5292),
    [anon_sym_LPAREN] = ACTIONS(5292),
    [anon_sym_RPAREN] = ACTIONS(5292),
    [anon_sym_RBRACE] = ACTIONS(5292),
    [anon_sym_LT] = ACTIONS(5294),
    [anon_sym_GT] = ACTIONS(5294),
    [anon_sym_in] = ACTIONS(5294),
    [anon_sym_QMARK] = ACTIONS(5294),
    [anon_sym_BANG] = ACTIONS(5294),
    [anon_sym_PLUS_PLUS] = ACTIONS(5292),
    [anon_sym_DASH_DASH] = ACTIONS(5292),
    [anon_sym_PLUS] = ACTIONS(5294),
    [anon_sym_DASH] = ACTIONS(5294),
    [anon_sym_STAR] = ACTIONS(5292),
    [anon_sym_SLASH] = ACTIONS(5294),
    [anon_sym_PERCENT] = ACTIONS(5292),
    [anon_sym_CARET] = ACTIONS(5292),
    [anon_sym_PIPE] = ACTIONS(5294),
    [anon_sym_AMP] = ACTIONS(5294),
    [anon_sym_LT_LT] = ACTIONS(5292),
    [anon_sym_GT_GT] = ACTIONS(5294),
    [anon_sym_GT_GT_GT] = ACTIONS(5292),
    [anon_sym_EQ_EQ] = ACTIONS(5292),
    [anon_sym_BANG_EQ] = ACTIONS(5292),
    [anon_sym_GT_EQ] = ACTIONS(5292),
    [anon_sym_LT_EQ] = ACTIONS(5292),
    [anon_sym_DOT] = ACTIONS(5294),
    [anon_sym_EQ_GT] = ACTIONS(5292),
    [anon_sym_switch] = ACTIONS(5292),
    [anon_sym_when] = ACTIONS(5292),
    [anon_sym_DOT_DOT] = ACTIONS(5292),
    [anon_sym_and] = ACTIONS(5292),
    [anon_sym_or] = ACTIONS(5292),
    [anon_sym_AMP_AMP] = ACTIONS(5292),
    [anon_sym_PIPE_PIPE] = ACTIONS(5292),
    [anon_sym_QMARK_QMARK] = ACTIONS(5292),
    [anon_sym_into] = ACTIONS(5292),
    [anon_sym_on] = ACTIONS(5292),
    [anon_sym_equals] = ACTIONS(5292),
    [anon_sym_by] = ACTIONS(5292),
    [anon_sym_as] = ACTIONS(5292),
    [anon_sym_is] = ACTIONS(5292),
    [anon_sym_DASH_GT] = ACTIONS(5292),
    [anon_sym_with] = ACTIONS(5292),
    [sym_string_literal_encoding] = ACTIONS(5737),
    [aux_sym_preproc_if_token3] = ACTIONS(5292),
    [aux_sym_preproc_else_token1] = ACTIONS(5292),
    [aux_sym_preproc_elif_token1] = ACTIONS(5292),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3897] = {
    [sym_preproc_region] = STATE(3897),
    [sym_preproc_endregion] = STATE(3897),
    [sym_preproc_line] = STATE(3897),
    [sym_preproc_pragma] = STATE(3897),
    [sym_preproc_nullable] = STATE(3897),
    [sym_preproc_error] = STATE(3897),
    [sym_preproc_define] = STATE(3897),
    [sym_preproc_undef] = STATE(3897),
    [anon_sym_SEMI] = ACTIONS(4058),
    [anon_sym_LBRACK] = ACTIONS(4058),
    [anon_sym_COLON] = ACTIONS(4056),
    [anon_sym_COMMA] = ACTIONS(4058),
    [anon_sym_RBRACK] = ACTIONS(4058),
    [anon_sym_LPAREN] = ACTIONS(4058),
    [anon_sym_RPAREN] = ACTIONS(4058),
    [anon_sym_LBRACE] = ACTIONS(4058),
    [anon_sym_RBRACE] = ACTIONS(4058),
    [anon_sym_LT] = ACTIONS(4056),
    [anon_sym_GT] = ACTIONS(4056),
    [anon_sym_in] = ACTIONS(4058),
    [anon_sym_QMARK] = ACTIONS(4056),
    [anon_sym_BANG] = ACTIONS(4056),
    [anon_sym_PLUS_PLUS] = ACTIONS(4058),
    [anon_sym_DASH_DASH] = ACTIONS(4058),
    [anon_sym_PLUS] = ACTIONS(4056),
    [anon_sym_DASH] = ACTIONS(4056),
    [anon_sym_STAR] = ACTIONS(4058),
    [anon_sym_SLASH] = ACTIONS(4056),
    [anon_sym_PERCENT] = ACTIONS(4058),
    [anon_sym_CARET] = ACTIONS(4058),
    [anon_sym_PIPE] = ACTIONS(4056),
    [anon_sym_AMP] = ACTIONS(4056),
    [anon_sym_LT_LT] = ACTIONS(4058),
    [anon_sym_GT_GT] = ACTIONS(4056),
    [anon_sym_GT_GT_GT] = ACTIONS(4058),
    [anon_sym_EQ_EQ] = ACTIONS(4058),
    [anon_sym_BANG_EQ] = ACTIONS(4058),
    [anon_sym_GT_EQ] = ACTIONS(4058),
    [anon_sym_LT_EQ] = ACTIONS(4058),
    [anon_sym_DOT] = ACTIONS(4056),
    [anon_sym_EQ_GT] = ACTIONS(4058),
    [anon_sym_COLON_COLON] = ACTIONS(4058),
    [anon_sym_switch] = ACTIONS(4058),
    [anon_sym_when] = ACTIONS(4058),
    [anon_sym_DOT_DOT] = ACTIONS(4058),
    [anon_sym_and] = ACTIONS(4058),
    [anon_sym_or] = ACTIONS(4058),
    [anon_sym_AMP_AMP] = ACTIONS(4058),
    [anon_sym_PIPE_PIPE] = ACTIONS(4058),
    [anon_sym_QMARK_QMARK] = ACTIONS(4058),
    [anon_sym_on] = ACTIONS(4058),
    [anon_sym_equals] = ACTIONS(4058),
    [anon_sym_by] = ACTIONS(4058),
    [anon_sym_as] = ACTIONS(4058),
    [anon_sym_is] = ACTIONS(4058),
    [anon_sym_DASH_GT] = ACTIONS(4058),
    [anon_sym_with] = ACTIONS(4058),
    [aux_sym_preproc_if_token3] = ACTIONS(4058),
    [aux_sym_preproc_else_token1] = ACTIONS(4058),
    [aux_sym_preproc_elif_token1] = ACTIONS(4058),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3898] = {
    [sym_preproc_region] = STATE(3898),
    [sym_preproc_endregion] = STATE(3898),
    [sym_preproc_line] = STATE(3898),
    [sym_preproc_pragma] = STATE(3898),
    [sym_preproc_nullable] = STATE(3898),
    [sym_preproc_error] = STATE(3898),
    [sym_preproc_define] = STATE(3898),
    [sym_preproc_undef] = STATE(3898),
    [anon_sym_SEMI] = ACTIONS(3719),
    [anon_sym_LBRACK] = ACTIONS(3719),
    [anon_sym_COLON] = ACTIONS(3721),
    [anon_sym_COMMA] = ACTIONS(3719),
    [anon_sym_RBRACK] = ACTIONS(3719),
    [anon_sym_LPAREN] = ACTIONS(3719),
    [anon_sym_RPAREN] = ACTIONS(3719),
    [anon_sym_LBRACE] = ACTIONS(3719),
    [anon_sym_RBRACE] = ACTIONS(3719),
    [anon_sym_LT] = ACTIONS(3721),
    [anon_sym_GT] = ACTIONS(3721),
    [anon_sym_in] = ACTIONS(3719),
    [anon_sym_QMARK] = ACTIONS(3721),
    [anon_sym_BANG] = ACTIONS(3721),
    [anon_sym_PLUS_PLUS] = ACTIONS(3719),
    [anon_sym_DASH_DASH] = ACTIONS(3719),
    [anon_sym_PLUS] = ACTIONS(3721),
    [anon_sym_DASH] = ACTIONS(3721),
    [anon_sym_STAR] = ACTIONS(3719),
    [anon_sym_SLASH] = ACTIONS(3721),
    [anon_sym_PERCENT] = ACTIONS(3719),
    [anon_sym_CARET] = ACTIONS(3719),
    [anon_sym_PIPE] = ACTIONS(3721),
    [anon_sym_AMP] = ACTIONS(3721),
    [anon_sym_LT_LT] = ACTIONS(3719),
    [anon_sym_GT_GT] = ACTIONS(3721),
    [anon_sym_GT_GT_GT] = ACTIONS(3719),
    [anon_sym_EQ_EQ] = ACTIONS(3719),
    [anon_sym_BANG_EQ] = ACTIONS(3719),
    [anon_sym_GT_EQ] = ACTIONS(3719),
    [anon_sym_LT_EQ] = ACTIONS(3719),
    [anon_sym_DOT] = ACTIONS(3721),
    [anon_sym_EQ_GT] = ACTIONS(3719),
    [anon_sym_COLON_COLON] = ACTIONS(3719),
    [anon_sym_switch] = ACTIONS(3719),
    [anon_sym_when] = ACTIONS(3719),
    [anon_sym_DOT_DOT] = ACTIONS(3719),
    [anon_sym_and] = ACTIONS(3719),
    [anon_sym_or] = ACTIONS(3719),
    [anon_sym_AMP_AMP] = ACTIONS(3719),
    [anon_sym_PIPE_PIPE] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK] = ACTIONS(3719),
    [anon_sym_on] = ACTIONS(3719),
    [anon_sym_equals] = ACTIONS(3719),
    [anon_sym_by] = ACTIONS(3719),
    [anon_sym_as] = ACTIONS(3719),
    [anon_sym_is] = ACTIONS(3719),
    [anon_sym_DASH_GT] = ACTIONS(3719),
    [anon_sym_with] = ACTIONS(3719),
    [aux_sym_preproc_if_token3] = ACTIONS(3719),
    [aux_sym_preproc_else_token1] = ACTIONS(3719),
    [aux_sym_preproc_elif_token1] = ACTIONS(3719),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3899] = {
    [sym_preproc_region] = STATE(3899),
    [sym_preproc_endregion] = STATE(3899),
    [sym_preproc_line] = STATE(3899),
    [sym_preproc_pragma] = STATE(3899),
    [sym_preproc_nullable] = STATE(3899),
    [sym_preproc_error] = STATE(3899),
    [sym_preproc_define] = STATE(3899),
    [sym_preproc_undef] = STATE(3899),
    [anon_sym_EQ] = ACTIONS(5739),
    [anon_sym_LBRACK] = ACTIONS(5249),
    [anon_sym_COLON] = ACTIONS(5249),
    [anon_sym_COMMA] = ACTIONS(5249),
    [anon_sym_LPAREN] = ACTIONS(5249),
    [anon_sym_LT] = ACTIONS(5251),
    [anon_sym_GT] = ACTIONS(5251),
    [anon_sym_QMARK] = ACTIONS(5251),
    [anon_sym_BANG] = ACTIONS(5251),
    [anon_sym_PLUS_PLUS] = ACTIONS(5249),
    [anon_sym_DASH_DASH] = ACTIONS(5249),
    [anon_sym_PLUS] = ACTIONS(5251),
    [anon_sym_DASH] = ACTIONS(5251),
    [anon_sym_STAR] = ACTIONS(5251),
    [anon_sym_SLASH] = ACTIONS(5251),
    [anon_sym_PERCENT] = ACTIONS(5251),
    [anon_sym_CARET] = ACTIONS(5251),
    [anon_sym_PIPE] = ACTIONS(5251),
    [anon_sym_AMP] = ACTIONS(5251),
    [anon_sym_LT_LT] = ACTIONS(5251),
    [anon_sym_GT_GT] = ACTIONS(5251),
    [anon_sym_GT_GT_GT] = ACTIONS(5251),
    [anon_sym_EQ_EQ] = ACTIONS(5249),
    [anon_sym_BANG_EQ] = ACTIONS(5249),
    [anon_sym_GT_EQ] = ACTIONS(5249),
    [anon_sym_LT_EQ] = ACTIONS(5249),
    [anon_sym_DOT] = ACTIONS(5251),
    [anon_sym_switch] = ACTIONS(5249),
    [anon_sym_DOT_DOT] = ACTIONS(5249),
    [anon_sym_and] = ACTIONS(5249),
    [anon_sym_or] = ACTIONS(5249),
    [anon_sym_PLUS_EQ] = ACTIONS(5741),
    [anon_sym_DASH_EQ] = ACTIONS(5741),
    [anon_sym_STAR_EQ] = ACTIONS(5741),
    [anon_sym_SLASH_EQ] = ACTIONS(5741),
    [anon_sym_PERCENT_EQ] = ACTIONS(5741),
    [anon_sym_AMP_EQ] = ACTIONS(5741),
    [anon_sym_CARET_EQ] = ACTIONS(5741),
    [anon_sym_PIPE_EQ] = ACTIONS(5741),
    [anon_sym_LT_LT_EQ] = ACTIONS(5741),
    [anon_sym_GT_GT_EQ] = ACTIONS(5741),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5741),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(5741),
    [anon_sym_AMP_AMP] = ACTIONS(5249),
    [anon_sym_PIPE_PIPE] = ACTIONS(5249),
    [anon_sym_QMARK_QMARK] = ACTIONS(5251),
    [anon_sym_into] = ACTIONS(5249),
    [anon_sym_as] = ACTIONS(5249),
    [anon_sym_is] = ACTIONS(5249),
    [anon_sym_DASH_GT] = ACTIONS(5249),
    [anon_sym_with] = ACTIONS(5249),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(5249),
  },
  [3900] = {
    [sym_initializer_expression] = STATE(4207),
    [sym_preproc_region] = STATE(3900),
    [sym_preproc_endregion] = STATE(3900),
    [sym_preproc_line] = STATE(3900),
    [sym_preproc_pragma] = STATE(3900),
    [sym_preproc_nullable] = STATE(3900),
    [sym_preproc_error] = STATE(3900),
    [sym_preproc_define] = STATE(3900),
    [sym_preproc_undef] = STATE(3900),
    [anon_sym_SEMI] = ACTIONS(5201),
    [anon_sym_LBRACK] = ACTIONS(5201),
    [anon_sym_COLON] = ACTIONS(5201),
    [anon_sym_COMMA] = ACTIONS(5201),
    [anon_sym_RBRACK] = ACTIONS(5201),
    [anon_sym_LPAREN] = ACTIONS(5201),
    [anon_sym_RPAREN] = ACTIONS(5201),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_RBRACE] = ACTIONS(5201),
    [anon_sym_LT] = ACTIONS(5203),
    [anon_sym_GT] = ACTIONS(5203),
    [anon_sym_in] = ACTIONS(5201),
    [anon_sym_QMARK] = ACTIONS(5203),
    [anon_sym_BANG] = ACTIONS(5203),
    [anon_sym_PLUS_PLUS] = ACTIONS(5201),
    [anon_sym_DASH_DASH] = ACTIONS(5201),
    [anon_sym_PLUS] = ACTIONS(5203),
    [anon_sym_DASH] = ACTIONS(5203),
    [anon_sym_STAR] = ACTIONS(5201),
    [anon_sym_SLASH] = ACTIONS(5203),
    [anon_sym_PERCENT] = ACTIONS(5201),
    [anon_sym_CARET] = ACTIONS(5201),
    [anon_sym_PIPE] = ACTIONS(5203),
    [anon_sym_AMP] = ACTIONS(5203),
    [anon_sym_LT_LT] = ACTIONS(5201),
    [anon_sym_GT_GT] = ACTIONS(5203),
    [anon_sym_GT_GT_GT] = ACTIONS(5201),
    [anon_sym_EQ_EQ] = ACTIONS(5201),
    [anon_sym_BANG_EQ] = ACTIONS(5201),
    [anon_sym_GT_EQ] = ACTIONS(5201),
    [anon_sym_LT_EQ] = ACTIONS(5201),
    [anon_sym_DOT] = ACTIONS(5203),
    [anon_sym_EQ_GT] = ACTIONS(5201),
    [anon_sym_switch] = ACTIONS(5201),
    [anon_sym_when] = ACTIONS(5201),
    [anon_sym_DOT_DOT] = ACTIONS(5201),
    [anon_sym_and] = ACTIONS(5201),
    [anon_sym_or] = ACTIONS(5201),
    [anon_sym_AMP_AMP] = ACTIONS(5201),
    [anon_sym_PIPE_PIPE] = ACTIONS(5201),
    [anon_sym_QMARK_QMARK] = ACTIONS(5201),
    [anon_sym_on] = ACTIONS(5201),
    [anon_sym_equals] = ACTIONS(5201),
    [anon_sym_by] = ACTIONS(5201),
    [anon_sym_as] = ACTIONS(5201),
    [anon_sym_is] = ACTIONS(5201),
    [anon_sym_DASH_GT] = ACTIONS(5201),
    [anon_sym_with] = ACTIONS(5201),
    [aux_sym_preproc_if_token3] = ACTIONS(5201),
    [aux_sym_preproc_else_token1] = ACTIONS(5201),
    [aux_sym_preproc_elif_token1] = ACTIONS(5201),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3901] = {
    [sym_argument_list] = STATE(4235),
    [sym_bracketed_argument_list] = STATE(3481),
    [sym_preproc_region] = STATE(3901),
    [sym_preproc_endregion] = STATE(3901),
    [sym_preproc_line] = STATE(3901),
    [sym_preproc_pragma] = STATE(3901),
    [sym_preproc_nullable] = STATE(3901),
    [sym_preproc_error] = STATE(3901),
    [sym_preproc_define] = STATE(3901),
    [sym_preproc_undef] = STATE(3901),
    [anon_sym_SEMI] = ACTIONS(5233),
    [anon_sym_LBRACK] = ACTIONS(5743),
    [anon_sym_COLON] = ACTIONS(5233),
    [anon_sym_COMMA] = ACTIONS(5233),
    [anon_sym_RBRACK] = ACTIONS(5233),
    [anon_sym_LPAREN] = ACTIONS(5711),
    [anon_sym_RPAREN] = ACTIONS(5233),
    [anon_sym_RBRACE] = ACTIONS(5233),
    [anon_sym_LT] = ACTIONS(5237),
    [anon_sym_GT] = ACTIONS(5237),
    [anon_sym_in] = ACTIONS(5233),
    [anon_sym_QMARK] = ACTIONS(5237),
    [anon_sym_BANG] = ACTIONS(5745),
    [anon_sym_PLUS_PLUS] = ACTIONS(5747),
    [anon_sym_DASH_DASH] = ACTIONS(5747),
    [anon_sym_PLUS] = ACTIONS(5237),
    [anon_sym_DASH] = ACTIONS(5237),
    [anon_sym_STAR] = ACTIONS(5233),
    [anon_sym_SLASH] = ACTIONS(5237),
    [anon_sym_PERCENT] = ACTIONS(5233),
    [anon_sym_CARET] = ACTIONS(5233),
    [anon_sym_PIPE] = ACTIONS(5237),
    [anon_sym_AMP] = ACTIONS(5237),
    [anon_sym_LT_LT] = ACTIONS(5233),
    [anon_sym_GT_GT] = ACTIONS(5237),
    [anon_sym_GT_GT_GT] = ACTIONS(5233),
    [anon_sym_EQ_EQ] = ACTIONS(5233),
    [anon_sym_BANG_EQ] = ACTIONS(5233),
    [anon_sym_GT_EQ] = ACTIONS(5233),
    [anon_sym_LT_EQ] = ACTIONS(5233),
    [anon_sym_DOT] = ACTIONS(4560),
    [anon_sym_EQ_GT] = ACTIONS(5233),
    [anon_sym_switch] = ACTIONS(5233),
    [anon_sym_when] = ACTIONS(5233),
    [anon_sym_DOT_DOT] = ACTIONS(5233),
    [anon_sym_and] = ACTIONS(5233),
    [anon_sym_or] = ACTIONS(5233),
    [anon_sym_AMP_AMP] = ACTIONS(5233),
    [anon_sym_PIPE_PIPE] = ACTIONS(5233),
    [anon_sym_QMARK_QMARK] = ACTIONS(5233),
    [anon_sym_on] = ACTIONS(5233),
    [anon_sym_equals] = ACTIONS(5233),
    [anon_sym_by] = ACTIONS(5233),
    [anon_sym_as] = ACTIONS(5233),
    [anon_sym_is] = ACTIONS(5233),
    [anon_sym_DASH_GT] = ACTIONS(4562),
    [anon_sym_with] = ACTIONS(5233),
    [aux_sym_preproc_if_token3] = ACTIONS(5233),
    [aux_sym_preproc_else_token1] = ACTIONS(5233),
    [aux_sym_preproc_elif_token1] = ACTIONS(5233),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3902] = {
    [sym_argument_list] = STATE(4235),
    [sym_bracketed_argument_list] = STATE(3481),
    [sym_preproc_region] = STATE(3902),
    [sym_preproc_endregion] = STATE(3902),
    [sym_preproc_line] = STATE(3902),
    [sym_preproc_pragma] = STATE(3902),
    [sym_preproc_nullable] = STATE(3902),
    [sym_preproc_error] = STATE(3902),
    [sym_preproc_define] = STATE(3902),
    [sym_preproc_undef] = STATE(3902),
    [anon_sym_SEMI] = ACTIONS(5243),
    [anon_sym_LBRACK] = ACTIONS(5743),
    [anon_sym_COLON] = ACTIONS(5243),
    [anon_sym_COMMA] = ACTIONS(5243),
    [anon_sym_RBRACK] = ACTIONS(5243),
    [anon_sym_LPAREN] = ACTIONS(5711),
    [anon_sym_RPAREN] = ACTIONS(5243),
    [anon_sym_RBRACE] = ACTIONS(5243),
    [anon_sym_LT] = ACTIONS(5245),
    [anon_sym_GT] = ACTIONS(5245),
    [anon_sym_in] = ACTIONS(5243),
    [anon_sym_QMARK] = ACTIONS(5245),
    [anon_sym_BANG] = ACTIONS(5745),
    [anon_sym_PLUS_PLUS] = ACTIONS(5747),
    [anon_sym_DASH_DASH] = ACTIONS(5747),
    [anon_sym_PLUS] = ACTIONS(5245),
    [anon_sym_DASH] = ACTIONS(5245),
    [anon_sym_STAR] = ACTIONS(5243),
    [anon_sym_SLASH] = ACTIONS(5245),
    [anon_sym_PERCENT] = ACTIONS(5243),
    [anon_sym_CARET] = ACTIONS(5243),
    [anon_sym_PIPE] = ACTIONS(5245),
    [anon_sym_AMP] = ACTIONS(5245),
    [anon_sym_LT_LT] = ACTIONS(5243),
    [anon_sym_GT_GT] = ACTIONS(5245),
    [anon_sym_GT_GT_GT] = ACTIONS(5243),
    [anon_sym_EQ_EQ] = ACTIONS(5243),
    [anon_sym_BANG_EQ] = ACTIONS(5243),
    [anon_sym_GT_EQ] = ACTIONS(5243),
    [anon_sym_LT_EQ] = ACTIONS(5243),
    [anon_sym_DOT] = ACTIONS(4560),
    [anon_sym_EQ_GT] = ACTIONS(5243),
    [anon_sym_switch] = ACTIONS(5243),
    [anon_sym_when] = ACTIONS(5243),
    [anon_sym_DOT_DOT] = ACTIONS(5243),
    [anon_sym_and] = ACTIONS(5243),
    [anon_sym_or] = ACTIONS(5243),
    [anon_sym_AMP_AMP] = ACTIONS(5243),
    [anon_sym_PIPE_PIPE] = ACTIONS(5243),
    [anon_sym_QMARK_QMARK] = ACTIONS(5243),
    [anon_sym_on] = ACTIONS(5243),
    [anon_sym_equals] = ACTIONS(5243),
    [anon_sym_by] = ACTIONS(5243),
    [anon_sym_as] = ACTIONS(5243),
    [anon_sym_is] = ACTIONS(5243),
    [anon_sym_DASH_GT] = ACTIONS(4562),
    [anon_sym_with] = ACTIONS(5243),
    [aux_sym_preproc_if_token3] = ACTIONS(5243),
    [aux_sym_preproc_else_token1] = ACTIONS(5243),
    [aux_sym_preproc_elif_token1] = ACTIONS(5243),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3903] = {
    [sym_initializer_expression] = STATE(4203),
    [sym_preproc_region] = STATE(3903),
    [sym_preproc_endregion] = STATE(3903),
    [sym_preproc_line] = STATE(3903),
    [sym_preproc_pragma] = STATE(3903),
    [sym_preproc_nullable] = STATE(3903),
    [sym_preproc_error] = STATE(3903),
    [sym_preproc_define] = STATE(3903),
    [sym_preproc_undef] = STATE(3903),
    [anon_sym_SEMI] = ACTIONS(5226),
    [anon_sym_LBRACK] = ACTIONS(5228),
    [anon_sym_COLON] = ACTIONS(5226),
    [anon_sym_COMMA] = ACTIONS(5226),
    [anon_sym_RBRACK] = ACTIONS(5226),
    [anon_sym_LPAREN] = ACTIONS(5226),
    [anon_sym_RPAREN] = ACTIONS(5226),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_RBRACE] = ACTIONS(5226),
    [anon_sym_LT] = ACTIONS(5231),
    [anon_sym_GT] = ACTIONS(5231),
    [anon_sym_in] = ACTIONS(5226),
    [anon_sym_QMARK] = ACTIONS(5231),
    [anon_sym_BANG] = ACTIONS(5231),
    [anon_sym_PLUS_PLUS] = ACTIONS(5226),
    [anon_sym_DASH_DASH] = ACTIONS(5226),
    [anon_sym_PLUS] = ACTIONS(5231),
    [anon_sym_DASH] = ACTIONS(5231),
    [anon_sym_STAR] = ACTIONS(5226),
    [anon_sym_SLASH] = ACTIONS(5231),
    [anon_sym_PERCENT] = ACTIONS(5226),
    [anon_sym_CARET] = ACTIONS(5226),
    [anon_sym_PIPE] = ACTIONS(5231),
    [anon_sym_AMP] = ACTIONS(5231),
    [anon_sym_LT_LT] = ACTIONS(5226),
    [anon_sym_GT_GT] = ACTIONS(5231),
    [anon_sym_GT_GT_GT] = ACTIONS(5226),
    [anon_sym_EQ_EQ] = ACTIONS(5226),
    [anon_sym_BANG_EQ] = ACTIONS(5226),
    [anon_sym_GT_EQ] = ACTIONS(5226),
    [anon_sym_LT_EQ] = ACTIONS(5226),
    [anon_sym_DOT] = ACTIONS(5231),
    [anon_sym_EQ_GT] = ACTIONS(5226),
    [anon_sym_switch] = ACTIONS(5226),
    [anon_sym_when] = ACTIONS(5226),
    [anon_sym_DOT_DOT] = ACTIONS(5226),
    [anon_sym_and] = ACTIONS(5226),
    [anon_sym_or] = ACTIONS(5226),
    [anon_sym_AMP_AMP] = ACTIONS(5226),
    [anon_sym_PIPE_PIPE] = ACTIONS(5226),
    [anon_sym_QMARK_QMARK] = ACTIONS(5226),
    [anon_sym_on] = ACTIONS(5226),
    [anon_sym_equals] = ACTIONS(5226),
    [anon_sym_by] = ACTIONS(5226),
    [anon_sym_as] = ACTIONS(5226),
    [anon_sym_is] = ACTIONS(5226),
    [anon_sym_DASH_GT] = ACTIONS(5226),
    [anon_sym_with] = ACTIONS(5226),
    [aux_sym_preproc_if_token3] = ACTIONS(5226),
    [aux_sym_preproc_else_token1] = ACTIONS(5226),
    [aux_sym_preproc_elif_token1] = ACTIONS(5226),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3904] = {
    [sym_preproc_region] = STATE(3904),
    [sym_preproc_endregion] = STATE(3904),
    [sym_preproc_line] = STATE(3904),
    [sym_preproc_pragma] = STATE(3904),
    [sym_preproc_nullable] = STATE(3904),
    [sym_preproc_error] = STATE(3904),
    [sym_preproc_define] = STATE(3904),
    [sym_preproc_undef] = STATE(3904),
    [anon_sym_SEMI] = ACTIONS(5266),
    [anon_sym_LBRACK] = ACTIONS(5266),
    [anon_sym_COLON] = ACTIONS(5266),
    [anon_sym_COMMA] = ACTIONS(5266),
    [anon_sym_RBRACK] = ACTIONS(5266),
    [anon_sym_LPAREN] = ACTIONS(5266),
    [anon_sym_RPAREN] = ACTIONS(5266),
    [anon_sym_LBRACE] = ACTIONS(5266),
    [anon_sym_RBRACE] = ACTIONS(5266),
    [anon_sym_LT] = ACTIONS(5268),
    [anon_sym_GT] = ACTIONS(5268),
    [anon_sym_in] = ACTIONS(5268),
    [anon_sym_QMARK] = ACTIONS(5268),
    [anon_sym_BANG] = ACTIONS(5268),
    [anon_sym_PLUS_PLUS] = ACTIONS(5266),
    [anon_sym_DASH_DASH] = ACTIONS(5266),
    [anon_sym_PLUS] = ACTIONS(5268),
    [anon_sym_DASH] = ACTIONS(5268),
    [anon_sym_STAR] = ACTIONS(5266),
    [anon_sym_SLASH] = ACTIONS(5268),
    [anon_sym_PERCENT] = ACTIONS(5266),
    [anon_sym_CARET] = ACTIONS(5266),
    [anon_sym_PIPE] = ACTIONS(5268),
    [anon_sym_AMP] = ACTIONS(5268),
    [anon_sym_LT_LT] = ACTIONS(5266),
    [anon_sym_GT_GT] = ACTIONS(5268),
    [anon_sym_GT_GT_GT] = ACTIONS(5266),
    [anon_sym_EQ_EQ] = ACTIONS(5266),
    [anon_sym_BANG_EQ] = ACTIONS(5266),
    [anon_sym_GT_EQ] = ACTIONS(5266),
    [anon_sym_LT_EQ] = ACTIONS(5266),
    [anon_sym_DOT] = ACTIONS(5268),
    [anon_sym_EQ_GT] = ACTIONS(5266),
    [anon_sym_switch] = ACTIONS(5266),
    [anon_sym_when] = ACTIONS(5266),
    [anon_sym_DOT_DOT] = ACTIONS(5266),
    [anon_sym_and] = ACTIONS(5266),
    [anon_sym_or] = ACTIONS(5266),
    [anon_sym_AMP_AMP] = ACTIONS(5266),
    [anon_sym_PIPE_PIPE] = ACTIONS(5266),
    [anon_sym_QMARK_QMARK] = ACTIONS(5266),
    [anon_sym_into] = ACTIONS(5266),
    [anon_sym_on] = ACTIONS(5266),
    [anon_sym_equals] = ACTIONS(5266),
    [anon_sym_by] = ACTIONS(5266),
    [anon_sym_as] = ACTIONS(5266),
    [anon_sym_is] = ACTIONS(5266),
    [anon_sym_DASH_GT] = ACTIONS(5266),
    [anon_sym_with] = ACTIONS(5266),
    [aux_sym_preproc_if_token3] = ACTIONS(5266),
    [aux_sym_preproc_else_token1] = ACTIONS(5266),
    [aux_sym_preproc_elif_token1] = ACTIONS(5266),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3905] = {
    [sym_preproc_region] = STATE(3905),
    [sym_preproc_endregion] = STATE(3905),
    [sym_preproc_line] = STATE(3905),
    [sym_preproc_pragma] = STATE(3905),
    [sym_preproc_nullable] = STATE(3905),
    [sym_preproc_error] = STATE(3905),
    [sym_preproc_define] = STATE(3905),
    [sym_preproc_undef] = STATE(3905),
    [anon_sym_SEMI] = ACTIONS(3719),
    [anon_sym_LBRACK] = ACTIONS(3719),
    [anon_sym_COLON] = ACTIONS(3719),
    [anon_sym_COMMA] = ACTIONS(3719),
    [anon_sym_RBRACK] = ACTIONS(3719),
    [anon_sym_LPAREN] = ACTIONS(3719),
    [anon_sym_RPAREN] = ACTIONS(3719),
    [anon_sym_LBRACE] = ACTIONS(3719),
    [anon_sym_RBRACE] = ACTIONS(3719),
    [anon_sym_LT] = ACTIONS(3721),
    [anon_sym_GT] = ACTIONS(3721),
    [anon_sym_in] = ACTIONS(3721),
    [anon_sym_QMARK] = ACTIONS(3721),
    [anon_sym_BANG] = ACTIONS(3721),
    [anon_sym_PLUS_PLUS] = ACTIONS(3719),
    [anon_sym_DASH_DASH] = ACTIONS(3719),
    [anon_sym_PLUS] = ACTIONS(3721),
    [anon_sym_DASH] = ACTIONS(3721),
    [anon_sym_STAR] = ACTIONS(3719),
    [anon_sym_SLASH] = ACTIONS(3721),
    [anon_sym_PERCENT] = ACTIONS(3719),
    [anon_sym_CARET] = ACTIONS(3719),
    [anon_sym_PIPE] = ACTIONS(3721),
    [anon_sym_AMP] = ACTIONS(3721),
    [anon_sym_LT_LT] = ACTIONS(3719),
    [anon_sym_GT_GT] = ACTIONS(3721),
    [anon_sym_GT_GT_GT] = ACTIONS(3719),
    [anon_sym_EQ_EQ] = ACTIONS(3719),
    [anon_sym_BANG_EQ] = ACTIONS(3719),
    [anon_sym_GT_EQ] = ACTIONS(3719),
    [anon_sym_LT_EQ] = ACTIONS(3719),
    [anon_sym_DOT] = ACTIONS(3721),
    [anon_sym_EQ_GT] = ACTIONS(3719),
    [anon_sym_switch] = ACTIONS(3719),
    [anon_sym_when] = ACTIONS(3719),
    [anon_sym_DOT_DOT] = ACTIONS(3719),
    [anon_sym_and] = ACTIONS(3719),
    [anon_sym_or] = ACTIONS(3719),
    [anon_sym_AMP_AMP] = ACTIONS(3719),
    [anon_sym_PIPE_PIPE] = ACTIONS(3719),
    [anon_sym_QMARK_QMARK] = ACTIONS(3719),
    [anon_sym_into] = ACTIONS(3719),
    [anon_sym_on] = ACTIONS(3719),
    [anon_sym_equals] = ACTIONS(3719),
    [anon_sym_by] = ACTIONS(3719),
    [anon_sym_as] = ACTIONS(3719),
    [anon_sym_is] = ACTIONS(3719),
    [anon_sym_DASH_GT] = ACTIONS(3719),
    [anon_sym_with] = ACTIONS(3719),
    [aux_sym_preproc_if_token3] = ACTIONS(3719),
    [aux_sym_preproc_else_token1] = ACTIONS(3719),
    [aux_sym_preproc_elif_token1] = ACTIONS(3719),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3906] = {
    [sym_preproc_region] = STATE(3906),
    [sym_preproc_endregion] = STATE(3906),
    [sym_preproc_line] = STATE(3906),
    [sym_preproc_pragma] = STATE(3906),
    [sym_preproc_nullable] = STATE(3906),
    [sym_preproc_error] = STATE(3906),
    [sym_preproc_define] = STATE(3906),
    [sym_preproc_undef] = STATE(3906),
    [anon_sym_SEMI] = ACTIONS(5319),
    [anon_sym_LBRACK] = ACTIONS(5319),
    [anon_sym_COLON] = ACTIONS(5319),
    [anon_sym_COMMA] = ACTIONS(5319),
    [anon_sym_RBRACK] = ACTIONS(5319),
    [anon_sym_LPAREN] = ACTIONS(5319),
    [anon_sym_RPAREN] = ACTIONS(5319),
    [anon_sym_RBRACE] = ACTIONS(5319),
    [anon_sym_LT] = ACTIONS(5321),
    [anon_sym_GT] = ACTIONS(5321),
    [anon_sym_in] = ACTIONS(5321),
    [anon_sym_QMARK] = ACTIONS(5321),
    [anon_sym_BANG] = ACTIONS(5321),
    [anon_sym_PLUS_PLUS] = ACTIONS(5319),
    [anon_sym_DASH_DASH] = ACTIONS(5319),
    [anon_sym_PLUS] = ACTIONS(5321),
    [anon_sym_DASH] = ACTIONS(5321),
    [anon_sym_STAR] = ACTIONS(5319),
    [anon_sym_SLASH] = ACTIONS(5321),
    [anon_sym_PERCENT] = ACTIONS(5319),
    [anon_sym_CARET] = ACTIONS(5319),
    [anon_sym_PIPE] = ACTIONS(5321),
    [anon_sym_AMP] = ACTIONS(5321),
    [anon_sym_LT_LT] = ACTIONS(5319),
    [anon_sym_GT_GT] = ACTIONS(5321),
    [anon_sym_GT_GT_GT] = ACTIONS(5319),
    [anon_sym_EQ_EQ] = ACTIONS(5319),
    [anon_sym_BANG_EQ] = ACTIONS(5319),
    [anon_sym_GT_EQ] = ACTIONS(5319),
    [anon_sym_LT_EQ] = ACTIONS(5319),
    [anon_sym_DOT] = ACTIONS(5321),
    [anon_sym_EQ_GT] = ACTIONS(5319),
    [anon_sym_switch] = ACTIONS(5319),
    [anon_sym_when] = ACTIONS(5319),
    [anon_sym_DOT_DOT] = ACTIONS(5319),
    [anon_sym_and] = ACTIONS(5319),
    [anon_sym_or] = ACTIONS(5319),
    [anon_sym_AMP_AMP] = ACTIONS(5319),
    [anon_sym_PIPE_PIPE] = ACTIONS(5319),
    [anon_sym_QMARK_QMARK] = ACTIONS(5319),
    [anon_sym_into] = ACTIONS(5319),
    [anon_sym_on] = ACTIONS(5319),
    [anon_sym_equals] = ACTIONS(5319),
    [anon_sym_by] = ACTIONS(5319),
    [anon_sym_as] = ACTIONS(5319),
    [anon_sym_is] = ACTIONS(5319),
    [anon_sym_DASH_GT] = ACTIONS(5319),
    [anon_sym_with] = ACTIONS(5319),
    [sym_string_literal_encoding] = ACTIONS(5749),
    [aux_sym_preproc_if_token3] = ACTIONS(5319),
    [aux_sym_preproc_else_token1] = ACTIONS(5319),
    [aux_sym_preproc_elif_token1] = ACTIONS(5319),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3907] = {
    [sym_preproc_region] = STATE(3907),
    [sym_preproc_endregion] = STATE(3907),
    [sym_preproc_line] = STATE(3907),
    [sym_preproc_pragma] = STATE(3907),
    [sym_preproc_nullable] = STATE(3907),
    [sym_preproc_error] = STATE(3907),
    [sym_preproc_define] = STATE(3907),
    [sym_preproc_undef] = STATE(3907),
    [anon_sym_SEMI] = ACTIONS(4570),
    [anon_sym_LBRACK] = ACTIONS(4570),
    [anon_sym_COLON] = ACTIONS(4570),
    [anon_sym_COMMA] = ACTIONS(4570),
    [anon_sym_RBRACK] = ACTIONS(4570),
    [anon_sym_LPAREN] = ACTIONS(4570),
    [anon_sym_RPAREN] = ACTIONS(4570),
    [anon_sym_LBRACE] = ACTIONS(4570),
    [anon_sym_RBRACE] = ACTIONS(4570),
    [anon_sym_LT] = ACTIONS(4568),
    [anon_sym_GT] = ACTIONS(4568),
    [anon_sym_in] = ACTIONS(4568),
    [anon_sym_QMARK] = ACTIONS(4568),
    [anon_sym_BANG] = ACTIONS(4568),
    [anon_sym_PLUS_PLUS] = ACTIONS(4570),
    [anon_sym_DASH_DASH] = ACTIONS(4570),
    [anon_sym_PLUS] = ACTIONS(4568),
    [anon_sym_DASH] = ACTIONS(4568),
    [anon_sym_STAR] = ACTIONS(4570),
    [anon_sym_SLASH] = ACTIONS(4568),
    [anon_sym_PERCENT] = ACTIONS(4570),
    [anon_sym_CARET] = ACTIONS(4570),
    [anon_sym_PIPE] = ACTIONS(4568),
    [anon_sym_AMP] = ACTIONS(4568),
    [anon_sym_LT_LT] = ACTIONS(4570),
    [anon_sym_GT_GT] = ACTIONS(4568),
    [anon_sym_GT_GT_GT] = ACTIONS(4570),
    [anon_sym_EQ_EQ] = ACTIONS(4570),
    [anon_sym_BANG_EQ] = ACTIONS(4570),
    [anon_sym_GT_EQ] = ACTIONS(4570),
    [anon_sym_LT_EQ] = ACTIONS(4570),
    [anon_sym_DOT] = ACTIONS(4568),
    [anon_sym_EQ_GT] = ACTIONS(4570),
    [anon_sym_switch] = ACTIONS(4570),
    [anon_sym_when] = ACTIONS(4570),
    [anon_sym_DOT_DOT] = ACTIONS(4570),
    [anon_sym_and] = ACTIONS(4570),
    [anon_sym_or] = ACTIONS(4570),
    [anon_sym_AMP_AMP] = ACTIONS(4570),
    [anon_sym_PIPE_PIPE] = ACTIONS(4570),
    [anon_sym_QMARK_QMARK] = ACTIONS(4570),
    [anon_sym_into] = ACTIONS(4570),
    [anon_sym_on] = ACTIONS(4570),
    [anon_sym_equals] = ACTIONS(4570),
    [anon_sym_by] = ACTIONS(4570),
    [anon_sym_as] = ACTIONS(4570),
    [anon_sym_is] = ACTIONS(4570),
    [anon_sym_DASH_GT] = ACTIONS(4570),
    [anon_sym_with] = ACTIONS(4570),
    [aux_sym_preproc_if_token3] = ACTIONS(4570),
    [aux_sym_preproc_else_token1] = ACTIONS(4570),
    [aux_sym_preproc_elif_token1] = ACTIONS(4570),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3908] = {
    [sym_preproc_region] = STATE(3908),
    [sym_preproc_endregion] = STATE(3908),
    [sym_preproc_line] = STATE(3908),
    [sym_preproc_pragma] = STATE(3908),
    [sym_preproc_nullable] = STATE(3908),
    [sym_preproc_error] = STATE(3908),
    [sym_preproc_define] = STATE(3908),
    [sym_preproc_undef] = STATE(3908),
    [anon_sym_SEMI] = ACTIONS(4058),
    [anon_sym_LBRACK] = ACTIONS(4058),
    [anon_sym_COLON] = ACTIONS(4058),
    [anon_sym_COMMA] = ACTIONS(4058),
    [anon_sym_RBRACK] = ACTIONS(4058),
    [anon_sym_LPAREN] = ACTIONS(4058),
    [anon_sym_RPAREN] = ACTIONS(4058),
    [anon_sym_LBRACE] = ACTIONS(4058),
    [anon_sym_RBRACE] = ACTIONS(4058),
    [anon_sym_LT] = ACTIONS(4056),
    [anon_sym_GT] = ACTIONS(4056),
    [anon_sym_in] = ACTIONS(4056),
    [anon_sym_QMARK] = ACTIONS(4056),
    [anon_sym_BANG] = ACTIONS(4056),
    [anon_sym_PLUS_PLUS] = ACTIONS(4058),
    [anon_sym_DASH_DASH] = ACTIONS(4058),
    [anon_sym_PLUS] = ACTIONS(4056),
    [anon_sym_DASH] = ACTIONS(4056),
    [anon_sym_STAR] = ACTIONS(4058),
    [anon_sym_SLASH] = ACTIONS(4056),
    [anon_sym_PERCENT] = ACTIONS(4058),
    [anon_sym_CARET] = ACTIONS(4058),
    [anon_sym_PIPE] = ACTIONS(4056),
    [anon_sym_AMP] = ACTIONS(4056),
    [anon_sym_LT_LT] = ACTIONS(4058),
    [anon_sym_GT_GT] = ACTIONS(4056),
    [anon_sym_GT_GT_GT] = ACTIONS(4058),
    [anon_sym_EQ_EQ] = ACTIONS(4058),
    [anon_sym_BANG_EQ] = ACTIONS(4058),
    [anon_sym_GT_EQ] = ACTIONS(4058),
    [anon_sym_LT_EQ] = ACTIONS(4058),
    [anon_sym_DOT] = ACTIONS(4056),
    [anon_sym_EQ_GT] = ACTIONS(4058),
    [anon_sym_switch] = ACTIONS(4058),
    [anon_sym_when] = ACTIONS(4058),
    [anon_sym_DOT_DOT] = ACTIONS(4058),
    [anon_sym_and] = ACTIONS(4058),
    [anon_sym_or] = ACTIONS(4058),
    [anon_sym_AMP_AMP] = ACTIONS(4058),
    [anon_sym_PIPE_PIPE] = ACTIONS(4058),
    [anon_sym_QMARK_QMARK] = ACTIONS(4058),
    [anon_sym_into] = ACTIONS(4058),
    [anon_sym_on] = ACTIONS(4058),
    [anon_sym_equals] = ACTIONS(4058),
    [anon_sym_by] = ACTIONS(4058),
    [anon_sym_as] = ACTIONS(4058),
    [anon_sym_is] = ACTIONS(4058),
    [anon_sym_DASH_GT] = ACTIONS(4058),
    [anon_sym_with] = ACTIONS(4058),
    [aux_sym_preproc_if_token3] = ACTIONS(4058),
    [aux_sym_preproc_else_token1] = ACTIONS(4058),
    [aux_sym_preproc_elif_token1] = ACTIONS(4058),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3909] = {
    [sym_preproc_region] = STATE(3909),
    [sym_preproc_endregion] = STATE(3909),
    [sym_preproc_line] = STATE(3909),
    [sym_preproc_pragma] = STATE(3909),
    [sym_preproc_nullable] = STATE(3909),
    [sym_preproc_error] = STATE(3909),
    [sym_preproc_define] = STATE(3909),
    [sym_preproc_undef] = STATE(3909),
    [anon_sym_EQ] = ACTIONS(4066),
    [anon_sym_LBRACK] = ACTIONS(4068),
    [anon_sym_COLON] = ACTIONS(4068),
    [anon_sym_COMMA] = ACTIONS(4068),
    [anon_sym_LPAREN] = ACTIONS(4068),
    [anon_sym_LT] = ACTIONS(4066),
    [anon_sym_GT] = ACTIONS(4066),
    [anon_sym_QMARK] = ACTIONS(4066),
    [anon_sym_BANG] = ACTIONS(4066),
    [anon_sym_PLUS_PLUS] = ACTIONS(4068),
    [anon_sym_DASH_DASH] = ACTIONS(4068),
    [anon_sym_PLUS] = ACTIONS(4066),
    [anon_sym_DASH] = ACTIONS(4066),
    [anon_sym_STAR] = ACTIONS(4066),
    [anon_sym_SLASH] = ACTIONS(4066),
    [anon_sym_PERCENT] = ACTIONS(4066),
    [anon_sym_CARET] = ACTIONS(4066),
    [anon_sym_PIPE] = ACTIONS(4066),
    [anon_sym_AMP] = ACTIONS(4066),
    [anon_sym_LT_LT] = ACTIONS(4066),
    [anon_sym_GT_GT] = ACTIONS(4066),
    [anon_sym_GT_GT_GT] = ACTIONS(4066),
    [anon_sym_EQ_EQ] = ACTIONS(4068),
    [anon_sym_BANG_EQ] = ACTIONS(4068),
    [anon_sym_GT_EQ] = ACTIONS(4068),
    [anon_sym_LT_EQ] = ACTIONS(4068),
    [anon_sym_DOT] = ACTIONS(4066),
    [anon_sym_switch] = ACTIONS(4068),
    [anon_sym_DOT_DOT] = ACTIONS(4068),
    [anon_sym_and] = ACTIONS(4068),
    [anon_sym_or] = ACTIONS(4068),
    [anon_sym_PLUS_EQ] = ACTIONS(4068),
    [anon_sym_DASH_EQ] = ACTIONS(4068),
    [anon_sym_STAR_EQ] = ACTIONS(4068),
    [anon_sym_SLASH_EQ] = ACTIONS(4068),
    [anon_sym_PERCENT_EQ] = ACTIONS(4068),
    [anon_sym_AMP_EQ] = ACTIONS(4068),
    [anon_sym_CARET_EQ] = ACTIONS(4068),
    [anon_sym_PIPE_EQ] = ACTIONS(4068),
    [anon_sym_LT_LT_EQ] = ACTIONS(4068),
    [anon_sym_GT_GT_EQ] = ACTIONS(4068),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4068),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4068),
    [anon_sym_AMP_AMP] = ACTIONS(4068),
    [anon_sym_PIPE_PIPE] = ACTIONS(4068),
    [anon_sym_QMARK_QMARK] = ACTIONS(4066),
    [anon_sym_into] = ACTIONS(4068),
    [anon_sym_as] = ACTIONS(4068),
    [anon_sym_is] = ACTIONS(4068),
    [anon_sym_DASH_GT] = ACTIONS(4068),
    [anon_sym_with] = ACTIONS(4068),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4068),
  },
  [3910] = {
    [sym_preproc_region] = STATE(3910),
    [sym_preproc_endregion] = STATE(3910),
    [sym_preproc_line] = STATE(3910),
    [sym_preproc_pragma] = STATE(3910),
    [sym_preproc_nullable] = STATE(3910),
    [sym_preproc_error] = STATE(3910),
    [sym_preproc_define] = STATE(3910),
    [sym_preproc_undef] = STATE(3910),
    [anon_sym_SEMI] = ACTIONS(5288),
    [anon_sym_LBRACK] = ACTIONS(5288),
    [anon_sym_COLON] = ACTIONS(5288),
    [anon_sym_COMMA] = ACTIONS(5288),
    [anon_sym_RBRACK] = ACTIONS(5288),
    [anon_sym_LPAREN] = ACTIONS(5288),
    [anon_sym_RPAREN] = ACTIONS(5288),
    [anon_sym_LBRACE] = ACTIONS(5288),
    [anon_sym_RBRACE] = ACTIONS(5288),
    [anon_sym_LT] = ACTIONS(5290),
    [anon_sym_GT] = ACTIONS(5290),
    [anon_sym_in] = ACTIONS(5288),
    [anon_sym_where] = ACTIONS(5288),
    [anon_sym_QMARK] = ACTIONS(5290),
    [anon_sym_BANG] = ACTIONS(5290),
    [anon_sym_PLUS_PLUS] = ACTIONS(5288),
    [anon_sym_DASH_DASH] = ACTIONS(5288),
    [anon_sym_PLUS] = ACTIONS(5290),
    [anon_sym_DASH] = ACTIONS(5290),
    [anon_sym_STAR] = ACTIONS(5288),
    [anon_sym_SLASH] = ACTIONS(5290),
    [anon_sym_PERCENT] = ACTIONS(5288),
    [anon_sym_CARET] = ACTIONS(5288),
    [anon_sym_PIPE] = ACTIONS(5290),
    [anon_sym_AMP] = ACTIONS(5290),
    [anon_sym_LT_LT] = ACTIONS(5288),
    [anon_sym_GT_GT] = ACTIONS(5290),
    [anon_sym_GT_GT_GT] = ACTIONS(5288),
    [anon_sym_EQ_EQ] = ACTIONS(5288),
    [anon_sym_BANG_EQ] = ACTIONS(5288),
    [anon_sym_GT_EQ] = ACTIONS(5288),
    [anon_sym_LT_EQ] = ACTIONS(5288),
    [anon_sym_DOT] = ACTIONS(5290),
    [anon_sym_EQ_GT] = ACTIONS(5288),
    [anon_sym_switch] = ACTIONS(5288),
    [anon_sym_when] = ACTIONS(5288),
    [anon_sym_DOT_DOT] = ACTIONS(5288),
    [anon_sym_and] = ACTIONS(5288),
    [anon_sym_or] = ACTIONS(5288),
    [anon_sym_AMP_AMP] = ACTIONS(5288),
    [anon_sym_PIPE_PIPE] = ACTIONS(5288),
    [anon_sym_QMARK_QMARK] = ACTIONS(5288),
    [anon_sym_on] = ACTIONS(5288),
    [anon_sym_equals] = ACTIONS(5288),
    [anon_sym_by] = ACTIONS(5288),
    [anon_sym_as] = ACTIONS(5288),
    [anon_sym_is] = ACTIONS(5288),
    [anon_sym_DASH_GT] = ACTIONS(5288),
    [anon_sym_with] = ACTIONS(5288),
    [aux_sym_preproc_if_token3] = ACTIONS(5288),
    [aux_sym_preproc_else_token1] = ACTIONS(5288),
    [aux_sym_preproc_elif_token1] = ACTIONS(5288),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3911] = {
    [sym_preproc_region] = STATE(3911),
    [sym_preproc_endregion] = STATE(3911),
    [sym_preproc_line] = STATE(3911),
    [sym_preproc_pragma] = STATE(3911),
    [sym_preproc_nullable] = STATE(3911),
    [sym_preproc_error] = STATE(3911),
    [sym_preproc_define] = STATE(3911),
    [sym_preproc_undef] = STATE(3911),
    [anon_sym_EQ] = ACTIONS(4118),
    [anon_sym_LBRACK] = ACTIONS(4133),
    [anon_sym_COLON] = ACTIONS(4133),
    [anon_sym_COMMA] = ACTIONS(4133),
    [anon_sym_LPAREN] = ACTIONS(4133),
    [anon_sym_LT] = ACTIONS(4118),
    [anon_sym_GT] = ACTIONS(4118),
    [anon_sym_QMARK] = ACTIONS(4118),
    [anon_sym_BANG] = ACTIONS(4118),
    [anon_sym_PLUS_PLUS] = ACTIONS(4133),
    [anon_sym_DASH_DASH] = ACTIONS(4133),
    [anon_sym_PLUS] = ACTIONS(4118),
    [anon_sym_DASH] = ACTIONS(4118),
    [anon_sym_STAR] = ACTIONS(4118),
    [anon_sym_SLASH] = ACTIONS(4118),
    [anon_sym_PERCENT] = ACTIONS(4118),
    [anon_sym_CARET] = ACTIONS(4118),
    [anon_sym_PIPE] = ACTIONS(4118),
    [anon_sym_AMP] = ACTIONS(4118),
    [anon_sym_LT_LT] = ACTIONS(4118),
    [anon_sym_GT_GT] = ACTIONS(4118),
    [anon_sym_GT_GT_GT] = ACTIONS(4118),
    [anon_sym_EQ_EQ] = ACTIONS(4133),
    [anon_sym_BANG_EQ] = ACTIONS(4133),
    [anon_sym_GT_EQ] = ACTIONS(4133),
    [anon_sym_LT_EQ] = ACTIONS(4133),
    [anon_sym_DOT] = ACTIONS(4118),
    [anon_sym_switch] = ACTIONS(4133),
    [anon_sym_DOT_DOT] = ACTIONS(4133),
    [anon_sym_and] = ACTIONS(4133),
    [anon_sym_or] = ACTIONS(4133),
    [anon_sym_PLUS_EQ] = ACTIONS(4133),
    [anon_sym_DASH_EQ] = ACTIONS(4133),
    [anon_sym_STAR_EQ] = ACTIONS(4133),
    [anon_sym_SLASH_EQ] = ACTIONS(4133),
    [anon_sym_PERCENT_EQ] = ACTIONS(4133),
    [anon_sym_AMP_EQ] = ACTIONS(4133),
    [anon_sym_CARET_EQ] = ACTIONS(4133),
    [anon_sym_PIPE_EQ] = ACTIONS(4133),
    [anon_sym_LT_LT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4133),
    [anon_sym_AMP_AMP] = ACTIONS(4133),
    [anon_sym_PIPE_PIPE] = ACTIONS(4133),
    [anon_sym_QMARK_QMARK] = ACTIONS(4118),
    [anon_sym_into] = ACTIONS(4133),
    [anon_sym_as] = ACTIONS(4133),
    [anon_sym_is] = ACTIONS(4133),
    [anon_sym_DASH_GT] = ACTIONS(4133),
    [anon_sym_with] = ACTIONS(4133),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4133),
  },
  [3912] = {
    [sym_preproc_region] = STATE(3912),
    [sym_preproc_endregion] = STATE(3912),
    [sym_preproc_line] = STATE(3912),
    [sym_preproc_pragma] = STATE(3912),
    [sym_preproc_nullable] = STATE(3912),
    [sym_preproc_error] = STATE(3912),
    [sym_preproc_define] = STATE(3912),
    [sym_preproc_undef] = STATE(3912),
    [anon_sym_SEMI] = ACTIONS(4124),
    [anon_sym_LBRACK] = ACTIONS(4124),
    [anon_sym_COLON] = ACTIONS(4124),
    [anon_sym_COMMA] = ACTIONS(4124),
    [anon_sym_RBRACK] = ACTIONS(4124),
    [anon_sym_LPAREN] = ACTIONS(4124),
    [anon_sym_RPAREN] = ACTIONS(4124),
    [anon_sym_LBRACE] = ACTIONS(4124),
    [anon_sym_RBRACE] = ACTIONS(4124),
    [anon_sym_LT] = ACTIONS(4113),
    [anon_sym_GT] = ACTIONS(4113),
    [anon_sym_in] = ACTIONS(4113),
    [anon_sym_QMARK] = ACTIONS(4113),
    [anon_sym_BANG] = ACTIONS(4113),
    [anon_sym_PLUS_PLUS] = ACTIONS(4124),
    [anon_sym_DASH_DASH] = ACTIONS(4124),
    [anon_sym_PLUS] = ACTIONS(4113),
    [anon_sym_DASH] = ACTIONS(4113),
    [anon_sym_STAR] = ACTIONS(4124),
    [anon_sym_SLASH] = ACTIONS(4113),
    [anon_sym_PERCENT] = ACTIONS(4124),
    [anon_sym_CARET] = ACTIONS(4124),
    [anon_sym_PIPE] = ACTIONS(4113),
    [anon_sym_AMP] = ACTIONS(4113),
    [anon_sym_LT_LT] = ACTIONS(4124),
    [anon_sym_GT_GT] = ACTIONS(4113),
    [anon_sym_GT_GT_GT] = ACTIONS(4124),
    [anon_sym_EQ_EQ] = ACTIONS(4124),
    [anon_sym_BANG_EQ] = ACTIONS(4124),
    [anon_sym_GT_EQ] = ACTIONS(4124),
    [anon_sym_LT_EQ] = ACTIONS(4124),
    [anon_sym_DOT] = ACTIONS(4113),
    [anon_sym_EQ_GT] = ACTIONS(4124),
    [anon_sym_switch] = ACTIONS(4124),
    [anon_sym_when] = ACTIONS(4124),
    [anon_sym_DOT_DOT] = ACTIONS(4124),
    [anon_sym_and] = ACTIONS(4124),
    [anon_sym_or] = ACTIONS(4124),
    [anon_sym_AMP_AMP] = ACTIONS(4124),
    [anon_sym_PIPE_PIPE] = ACTIONS(4124),
    [anon_sym_QMARK_QMARK] = ACTIONS(4124),
    [anon_sym_into] = ACTIONS(4124),
    [anon_sym_on] = ACTIONS(4124),
    [anon_sym_equals] = ACTIONS(4124),
    [anon_sym_by] = ACTIONS(4124),
    [anon_sym_as] = ACTIONS(4124),
    [anon_sym_is] = ACTIONS(4124),
    [anon_sym_DASH_GT] = ACTIONS(4124),
    [anon_sym_with] = ACTIONS(4124),
    [aux_sym_preproc_if_token3] = ACTIONS(4124),
    [aux_sym_preproc_else_token1] = ACTIONS(4124),
    [aux_sym_preproc_elif_token1] = ACTIONS(4124),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3913] = {
    [sym_preproc_region] = STATE(3913),
    [sym_preproc_endregion] = STATE(3913),
    [sym_preproc_line] = STATE(3913),
    [sym_preproc_pragma] = STATE(3913),
    [sym_preproc_nullable] = STATE(3913),
    [sym_preproc_error] = STATE(3913),
    [sym_preproc_define] = STATE(3913),
    [sym_preproc_undef] = STATE(3913),
    [anon_sym_EQ] = ACTIONS(4118),
    [anon_sym_LBRACK] = ACTIONS(4741),
    [anon_sym_COLON] = ACTIONS(4739),
    [anon_sym_COMMA] = ACTIONS(4739),
    [anon_sym_LPAREN] = ACTIONS(4741),
    [anon_sym_LT] = ACTIONS(4744),
    [anon_sym_GT] = ACTIONS(4744),
    [anon_sym_QMARK] = ACTIONS(4744),
    [anon_sym_BANG] = ACTIONS(4744),
    [anon_sym_PLUS_PLUS] = ACTIONS(4741),
    [anon_sym_DASH_DASH] = ACTIONS(4741),
    [anon_sym_PLUS] = ACTIONS(4744),
    [anon_sym_DASH] = ACTIONS(4744),
    [anon_sym_STAR] = ACTIONS(4744),
    [anon_sym_SLASH] = ACTIONS(4744),
    [anon_sym_PERCENT] = ACTIONS(4744),
    [anon_sym_CARET] = ACTIONS(4744),
    [anon_sym_PIPE] = ACTIONS(4744),
    [anon_sym_AMP] = ACTIONS(4744),
    [anon_sym_LT_LT] = ACTIONS(4744),
    [anon_sym_GT_GT] = ACTIONS(4744),
    [anon_sym_GT_GT_GT] = ACTIONS(4744),
    [anon_sym_EQ_EQ] = ACTIONS(4741),
    [anon_sym_BANG_EQ] = ACTIONS(4741),
    [anon_sym_GT_EQ] = ACTIONS(4741),
    [anon_sym_LT_EQ] = ACTIONS(4741),
    [anon_sym_DOT] = ACTIONS(4744),
    [anon_sym_switch] = ACTIONS(4741),
    [anon_sym_DOT_DOT] = ACTIONS(4741),
    [anon_sym_and] = ACTIONS(4739),
    [anon_sym_or] = ACTIONS(4739),
    [anon_sym_PLUS_EQ] = ACTIONS(4133),
    [anon_sym_DASH_EQ] = ACTIONS(4133),
    [anon_sym_STAR_EQ] = ACTIONS(4133),
    [anon_sym_SLASH_EQ] = ACTIONS(4133),
    [anon_sym_PERCENT_EQ] = ACTIONS(4133),
    [anon_sym_AMP_EQ] = ACTIONS(4133),
    [anon_sym_CARET_EQ] = ACTIONS(4133),
    [anon_sym_PIPE_EQ] = ACTIONS(4133),
    [anon_sym_LT_LT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4133),
    [anon_sym_AMP_AMP] = ACTIONS(4741),
    [anon_sym_PIPE_PIPE] = ACTIONS(4741),
    [anon_sym_QMARK_QMARK] = ACTIONS(4744),
    [anon_sym_into] = ACTIONS(4739),
    [anon_sym_as] = ACTIONS(4741),
    [anon_sym_is] = ACTIONS(4741),
    [anon_sym_DASH_GT] = ACTIONS(4741),
    [anon_sym_with] = ACTIONS(4741),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4739),
  },
  [3914] = {
    [sym_preproc_region] = STATE(3914),
    [sym_preproc_endregion] = STATE(3914),
    [sym_preproc_line] = STATE(3914),
    [sym_preproc_pragma] = STATE(3914),
    [sym_preproc_nullable] = STATE(3914),
    [sym_preproc_error] = STATE(3914),
    [sym_preproc_define] = STATE(3914),
    [sym_preproc_undef] = STATE(3914),
    [anon_sym_EQ] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4076),
    [anon_sym_COLON] = ACTIONS(4076),
    [anon_sym_COMMA] = ACTIONS(4076),
    [anon_sym_LPAREN] = ACTIONS(4076),
    [anon_sym_LT] = ACTIONS(4074),
    [anon_sym_GT] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(4074),
    [anon_sym_BANG] = ACTIONS(4074),
    [anon_sym_PLUS_PLUS] = ACTIONS(4076),
    [anon_sym_DASH_DASH] = ACTIONS(4076),
    [anon_sym_PLUS] = ACTIONS(4074),
    [anon_sym_DASH] = ACTIONS(4074),
    [anon_sym_STAR] = ACTIONS(4074),
    [anon_sym_SLASH] = ACTIONS(4074),
    [anon_sym_PERCENT] = ACTIONS(4074),
    [anon_sym_CARET] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(4074),
    [anon_sym_AMP] = ACTIONS(4074),
    [anon_sym_LT_LT] = ACTIONS(4074),
    [anon_sym_GT_GT] = ACTIONS(4074),
    [anon_sym_GT_GT_GT] = ACTIONS(4074),
    [anon_sym_EQ_EQ] = ACTIONS(4076),
    [anon_sym_BANG_EQ] = ACTIONS(4076),
    [anon_sym_GT_EQ] = ACTIONS(4076),
    [anon_sym_LT_EQ] = ACTIONS(4076),
    [anon_sym_DOT] = ACTIONS(4074),
    [anon_sym_switch] = ACTIONS(4076),
    [anon_sym_DOT_DOT] = ACTIONS(4076),
    [anon_sym_and] = ACTIONS(4076),
    [anon_sym_or] = ACTIONS(4076),
    [anon_sym_PLUS_EQ] = ACTIONS(4076),
    [anon_sym_DASH_EQ] = ACTIONS(4076),
    [anon_sym_STAR_EQ] = ACTIONS(4076),
    [anon_sym_SLASH_EQ] = ACTIONS(4076),
    [anon_sym_PERCENT_EQ] = ACTIONS(4076),
    [anon_sym_AMP_EQ] = ACTIONS(4076),
    [anon_sym_CARET_EQ] = ACTIONS(4076),
    [anon_sym_PIPE_EQ] = ACTIONS(4076),
    [anon_sym_LT_LT_EQ] = ACTIONS(4076),
    [anon_sym_GT_GT_EQ] = ACTIONS(4076),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4076),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4076),
    [anon_sym_AMP_AMP] = ACTIONS(4076),
    [anon_sym_PIPE_PIPE] = ACTIONS(4076),
    [anon_sym_QMARK_QMARK] = ACTIONS(4074),
    [anon_sym_into] = ACTIONS(4076),
    [anon_sym_as] = ACTIONS(4076),
    [anon_sym_is] = ACTIONS(4076),
    [anon_sym_DASH_GT] = ACTIONS(4076),
    [anon_sym_with] = ACTIONS(4076),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4076),
  },
  [3915] = {
    [sym_preproc_region] = STATE(3915),
    [sym_preproc_endregion] = STATE(3915),
    [sym_preproc_line] = STATE(3915),
    [sym_preproc_pragma] = STATE(3915),
    [sym_preproc_nullable] = STATE(3915),
    [sym_preproc_error] = STATE(3915),
    [sym_preproc_define] = STATE(3915),
    [sym_preproc_undef] = STATE(3915),
    [anon_sym_SEMI] = ACTIONS(4424),
    [anon_sym_LBRACK] = ACTIONS(4424),
    [anon_sym_COLON] = ACTIONS(4424),
    [anon_sym_COMMA] = ACTIONS(4424),
    [anon_sym_RBRACK] = ACTIONS(4424),
    [anon_sym_LPAREN] = ACTIONS(4424),
    [anon_sym_RPAREN] = ACTIONS(4424),
    [anon_sym_LBRACE] = ACTIONS(4424),
    [anon_sym_RBRACE] = ACTIONS(4424),
    [anon_sym_LT] = ACTIONS(4422),
    [anon_sym_GT] = ACTIONS(4422),
    [anon_sym_in] = ACTIONS(4422),
    [anon_sym_QMARK] = ACTIONS(4422),
    [anon_sym_BANG] = ACTIONS(4422),
    [anon_sym_PLUS_PLUS] = ACTIONS(4424),
    [anon_sym_DASH_DASH] = ACTIONS(4424),
    [anon_sym_PLUS] = ACTIONS(4422),
    [anon_sym_DASH] = ACTIONS(4422),
    [anon_sym_STAR] = ACTIONS(4424),
    [anon_sym_SLASH] = ACTIONS(4422),
    [anon_sym_PERCENT] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4424),
    [anon_sym_PIPE] = ACTIONS(4422),
    [anon_sym_AMP] = ACTIONS(4422),
    [anon_sym_LT_LT] = ACTIONS(4424),
    [anon_sym_GT_GT] = ACTIONS(4422),
    [anon_sym_GT_GT_GT] = ACTIONS(4424),
    [anon_sym_EQ_EQ] = ACTIONS(4424),
    [anon_sym_BANG_EQ] = ACTIONS(4424),
    [anon_sym_GT_EQ] = ACTIONS(4424),
    [anon_sym_LT_EQ] = ACTIONS(4424),
    [anon_sym_DOT] = ACTIONS(4422),
    [anon_sym_EQ_GT] = ACTIONS(4424),
    [anon_sym_switch] = ACTIONS(4424),
    [anon_sym_when] = ACTIONS(4424),
    [anon_sym_DOT_DOT] = ACTIONS(4424),
    [anon_sym_and] = ACTIONS(4424),
    [anon_sym_or] = ACTIONS(4424),
    [anon_sym_AMP_AMP] = ACTIONS(4424),
    [anon_sym_PIPE_PIPE] = ACTIONS(4424),
    [anon_sym_QMARK_QMARK] = ACTIONS(4424),
    [anon_sym_into] = ACTIONS(4424),
    [anon_sym_on] = ACTIONS(4424),
    [anon_sym_equals] = ACTIONS(4424),
    [anon_sym_by] = ACTIONS(4424),
    [anon_sym_as] = ACTIONS(4424),
    [anon_sym_is] = ACTIONS(4424),
    [anon_sym_DASH_GT] = ACTIONS(4424),
    [anon_sym_with] = ACTIONS(4424),
    [aux_sym_preproc_if_token3] = ACTIONS(4424),
    [aux_sym_preproc_else_token1] = ACTIONS(4424),
    [aux_sym_preproc_elif_token1] = ACTIONS(4424),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3916] = {
    [sym_preproc_region] = STATE(3916),
    [sym_preproc_endregion] = STATE(3916),
    [sym_preproc_line] = STATE(3916),
    [sym_preproc_pragma] = STATE(3916),
    [sym_preproc_nullable] = STATE(3916),
    [sym_preproc_error] = STATE(3916),
    [sym_preproc_define] = STATE(3916),
    [sym_preproc_undef] = STATE(3916),
    [anon_sym_SEMI] = ACTIONS(4424),
    [anon_sym_LBRACK] = ACTIONS(4547),
    [anon_sym_COLON] = ACTIONS(4424),
    [anon_sym_COMMA] = ACTIONS(4424),
    [anon_sym_RBRACK] = ACTIONS(4424),
    [anon_sym_LPAREN] = ACTIONS(4424),
    [anon_sym_RPAREN] = ACTIONS(4424),
    [anon_sym_LBRACE] = ACTIONS(4424),
    [anon_sym_RBRACE] = ACTIONS(4424),
    [anon_sym_LT] = ACTIONS(4422),
    [anon_sym_GT] = ACTIONS(4422),
    [anon_sym_in] = ACTIONS(4422),
    [anon_sym_QMARK] = ACTIONS(5751),
    [anon_sym_BANG] = ACTIONS(4422),
    [anon_sym_PLUS_PLUS] = ACTIONS(4424),
    [anon_sym_DASH_DASH] = ACTIONS(4424),
    [anon_sym_PLUS] = ACTIONS(4422),
    [anon_sym_DASH] = ACTIONS(4422),
    [anon_sym_STAR] = ACTIONS(4424),
    [anon_sym_SLASH] = ACTIONS(4422),
    [anon_sym_PERCENT] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4424),
    [anon_sym_PIPE] = ACTIONS(4422),
    [anon_sym_AMP] = ACTIONS(4422),
    [anon_sym_LT_LT] = ACTIONS(4424),
    [anon_sym_GT_GT] = ACTIONS(4422),
    [anon_sym_GT_GT_GT] = ACTIONS(4424),
    [anon_sym_EQ_EQ] = ACTIONS(4424),
    [anon_sym_BANG_EQ] = ACTIONS(4424),
    [anon_sym_GT_EQ] = ACTIONS(4424),
    [anon_sym_LT_EQ] = ACTIONS(4424),
    [anon_sym_DOT] = ACTIONS(4422),
    [anon_sym_EQ_GT] = ACTIONS(4424),
    [anon_sym_switch] = ACTIONS(4424),
    [anon_sym_when] = ACTIONS(4424),
    [anon_sym_DOT_DOT] = ACTIONS(4424),
    [anon_sym_and] = ACTIONS(4424),
    [anon_sym_or] = ACTIONS(4424),
    [anon_sym_AMP_AMP] = ACTIONS(4424),
    [anon_sym_PIPE_PIPE] = ACTIONS(4424),
    [anon_sym_QMARK_QMARK] = ACTIONS(4424),
    [anon_sym_into] = ACTIONS(4424),
    [anon_sym_on] = ACTIONS(4424),
    [anon_sym_equals] = ACTIONS(4424),
    [anon_sym_by] = ACTIONS(4424),
    [anon_sym_as] = ACTIONS(4424),
    [anon_sym_is] = ACTIONS(4424),
    [anon_sym_DASH_GT] = ACTIONS(4424),
    [anon_sym_with] = ACTIONS(4424),
    [aux_sym_preproc_if_token3] = ACTIONS(4424),
    [aux_sym_preproc_else_token1] = ACTIONS(4424),
    [aux_sym_preproc_elif_token1] = ACTIONS(4424),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3917] = {
    [sym_preproc_region] = STATE(3917),
    [sym_preproc_endregion] = STATE(3917),
    [sym_preproc_line] = STATE(3917),
    [sym_preproc_pragma] = STATE(3917),
    [sym_preproc_nullable] = STATE(3917),
    [sym_preproc_error] = STATE(3917),
    [sym_preproc_define] = STATE(3917),
    [sym_preproc_undef] = STATE(3917),
    [anon_sym_SEMI] = ACTIONS(4424),
    [anon_sym_LBRACK] = ACTIONS(4547),
    [anon_sym_COLON] = ACTIONS(4424),
    [anon_sym_COMMA] = ACTIONS(4424),
    [anon_sym_RBRACK] = ACTIONS(4424),
    [anon_sym_LPAREN] = ACTIONS(4424),
    [anon_sym_RPAREN] = ACTIONS(4424),
    [anon_sym_LBRACE] = ACTIONS(4424),
    [anon_sym_RBRACE] = ACTIONS(4424),
    [anon_sym_LT] = ACTIONS(4422),
    [anon_sym_GT] = ACTIONS(4422),
    [anon_sym_in] = ACTIONS(4422),
    [anon_sym_QMARK] = ACTIONS(4422),
    [anon_sym_BANG] = ACTIONS(4422),
    [anon_sym_PLUS_PLUS] = ACTIONS(4424),
    [anon_sym_DASH_DASH] = ACTIONS(4424),
    [anon_sym_PLUS] = ACTIONS(4422),
    [anon_sym_DASH] = ACTIONS(4422),
    [anon_sym_STAR] = ACTIONS(4553),
    [anon_sym_SLASH] = ACTIONS(4422),
    [anon_sym_PERCENT] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4424),
    [anon_sym_PIPE] = ACTIONS(4422),
    [anon_sym_AMP] = ACTIONS(4422),
    [anon_sym_LT_LT] = ACTIONS(4424),
    [anon_sym_GT_GT] = ACTIONS(4422),
    [anon_sym_GT_GT_GT] = ACTIONS(4424),
    [anon_sym_EQ_EQ] = ACTIONS(4424),
    [anon_sym_BANG_EQ] = ACTIONS(4424),
    [anon_sym_GT_EQ] = ACTIONS(4424),
    [anon_sym_LT_EQ] = ACTIONS(4424),
    [anon_sym_DOT] = ACTIONS(4422),
    [anon_sym_EQ_GT] = ACTIONS(4424),
    [anon_sym_switch] = ACTIONS(4424),
    [anon_sym_when] = ACTIONS(4424),
    [anon_sym_DOT_DOT] = ACTIONS(4424),
    [anon_sym_and] = ACTIONS(4424),
    [anon_sym_or] = ACTIONS(4424),
    [anon_sym_AMP_AMP] = ACTIONS(4424),
    [anon_sym_PIPE_PIPE] = ACTIONS(4424),
    [anon_sym_QMARK_QMARK] = ACTIONS(4424),
    [anon_sym_into] = ACTIONS(4424),
    [anon_sym_on] = ACTIONS(4424),
    [anon_sym_equals] = ACTIONS(4424),
    [anon_sym_by] = ACTIONS(4424),
    [anon_sym_as] = ACTIONS(4424),
    [anon_sym_is] = ACTIONS(4424),
    [anon_sym_DASH_GT] = ACTIONS(4424),
    [anon_sym_with] = ACTIONS(4424),
    [aux_sym_preproc_if_token3] = ACTIONS(4424),
    [aux_sym_preproc_else_token1] = ACTIONS(4424),
    [aux_sym_preproc_elif_token1] = ACTIONS(4424),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3918] = {
    [sym_preproc_region] = STATE(3918),
    [sym_preproc_endregion] = STATE(3918),
    [sym_preproc_line] = STATE(3918),
    [sym_preproc_pragma] = STATE(3918),
    [sym_preproc_nullable] = STATE(3918),
    [sym_preproc_error] = STATE(3918),
    [sym_preproc_define] = STATE(3918),
    [sym_preproc_undef] = STATE(3918),
    [anon_sym_SEMI] = ACTIONS(4424),
    [anon_sym_LBRACK] = ACTIONS(4547),
    [anon_sym_COLON] = ACTIONS(4424),
    [anon_sym_COMMA] = ACTIONS(4424),
    [anon_sym_RBRACK] = ACTIONS(4424),
    [anon_sym_LPAREN] = ACTIONS(4424),
    [anon_sym_RPAREN] = ACTIONS(4424),
    [anon_sym_LBRACE] = ACTIONS(4424),
    [anon_sym_RBRACE] = ACTIONS(4424),
    [anon_sym_LT] = ACTIONS(4422),
    [anon_sym_GT] = ACTIONS(4422),
    [anon_sym_in] = ACTIONS(4422),
    [anon_sym_QMARK] = ACTIONS(5751),
    [anon_sym_BANG] = ACTIONS(4422),
    [anon_sym_PLUS_PLUS] = ACTIONS(4424),
    [anon_sym_DASH_DASH] = ACTIONS(4424),
    [anon_sym_PLUS] = ACTIONS(4422),
    [anon_sym_DASH] = ACTIONS(4422),
    [anon_sym_STAR] = ACTIONS(4553),
    [anon_sym_SLASH] = ACTIONS(4422),
    [anon_sym_PERCENT] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4424),
    [anon_sym_PIPE] = ACTIONS(4422),
    [anon_sym_AMP] = ACTIONS(4422),
    [anon_sym_LT_LT] = ACTIONS(4424),
    [anon_sym_GT_GT] = ACTIONS(4422),
    [anon_sym_GT_GT_GT] = ACTIONS(4424),
    [anon_sym_EQ_EQ] = ACTIONS(4424),
    [anon_sym_BANG_EQ] = ACTIONS(4424),
    [anon_sym_GT_EQ] = ACTIONS(4424),
    [anon_sym_LT_EQ] = ACTIONS(4424),
    [anon_sym_DOT] = ACTIONS(4422),
    [anon_sym_EQ_GT] = ACTIONS(4424),
    [anon_sym_switch] = ACTIONS(4424),
    [anon_sym_when] = ACTIONS(4424),
    [anon_sym_DOT_DOT] = ACTIONS(4424),
    [anon_sym_and] = ACTIONS(4424),
    [anon_sym_or] = ACTIONS(4424),
    [anon_sym_AMP_AMP] = ACTIONS(4424),
    [anon_sym_PIPE_PIPE] = ACTIONS(4424),
    [anon_sym_QMARK_QMARK] = ACTIONS(4424),
    [anon_sym_into] = ACTIONS(4424),
    [anon_sym_on] = ACTIONS(4424),
    [anon_sym_equals] = ACTIONS(4424),
    [anon_sym_by] = ACTIONS(4424),
    [anon_sym_as] = ACTIONS(4424),
    [anon_sym_is] = ACTIONS(4424),
    [anon_sym_DASH_GT] = ACTIONS(4424),
    [anon_sym_with] = ACTIONS(4424),
    [aux_sym_preproc_if_token3] = ACTIONS(4424),
    [aux_sym_preproc_else_token1] = ACTIONS(4424),
    [aux_sym_preproc_elif_token1] = ACTIONS(4424),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3919] = {
    [sym_preproc_region] = STATE(3919),
    [sym_preproc_endregion] = STATE(3919),
    [sym_preproc_line] = STATE(3919),
    [sym_preproc_pragma] = STATE(3919),
    [sym_preproc_nullable] = STATE(3919),
    [sym_preproc_error] = STATE(3919),
    [sym_preproc_define] = STATE(3919),
    [sym_preproc_undef] = STATE(3919),
    [anon_sym_SEMI] = ACTIONS(4349),
    [anon_sym_LBRACK] = ACTIONS(4349),
    [anon_sym_COLON] = ACTIONS(4349),
    [anon_sym_COMMA] = ACTIONS(4349),
    [anon_sym_RBRACK] = ACTIONS(4349),
    [anon_sym_LPAREN] = ACTIONS(4349),
    [anon_sym_RPAREN] = ACTIONS(4349),
    [anon_sym_LBRACE] = ACTIONS(4349),
    [anon_sym_RBRACE] = ACTIONS(4349),
    [anon_sym_LT] = ACTIONS(4347),
    [anon_sym_GT] = ACTIONS(4347),
    [anon_sym_in] = ACTIONS(4347),
    [anon_sym_QMARK] = ACTIONS(4347),
    [anon_sym_BANG] = ACTIONS(4347),
    [anon_sym_PLUS_PLUS] = ACTIONS(4349),
    [anon_sym_DASH_DASH] = ACTIONS(4349),
    [anon_sym_PLUS] = ACTIONS(4347),
    [anon_sym_DASH] = ACTIONS(4347),
    [anon_sym_STAR] = ACTIONS(4349),
    [anon_sym_SLASH] = ACTIONS(4347),
    [anon_sym_PERCENT] = ACTIONS(4349),
    [anon_sym_CARET] = ACTIONS(4349),
    [anon_sym_PIPE] = ACTIONS(4347),
    [anon_sym_AMP] = ACTIONS(4347),
    [anon_sym_LT_LT] = ACTIONS(4349),
    [anon_sym_GT_GT] = ACTIONS(4347),
    [anon_sym_GT_GT_GT] = ACTIONS(4349),
    [anon_sym_EQ_EQ] = ACTIONS(4349),
    [anon_sym_BANG_EQ] = ACTIONS(4349),
    [anon_sym_GT_EQ] = ACTIONS(4349),
    [anon_sym_LT_EQ] = ACTIONS(4349),
    [anon_sym_DOT] = ACTIONS(4347),
    [anon_sym_EQ_GT] = ACTIONS(4349),
    [anon_sym_switch] = ACTIONS(4349),
    [anon_sym_when] = ACTIONS(4349),
    [anon_sym_DOT_DOT] = ACTIONS(4349),
    [anon_sym_and] = ACTIONS(4349),
    [anon_sym_or] = ACTIONS(4349),
    [anon_sym_AMP_AMP] = ACTIONS(4349),
    [anon_sym_PIPE_PIPE] = ACTIONS(4349),
    [anon_sym_QMARK_QMARK] = ACTIONS(4349),
    [anon_sym_into] = ACTIONS(4349),
    [anon_sym_on] = ACTIONS(4349),
    [anon_sym_equals] = ACTIONS(4349),
    [anon_sym_by] = ACTIONS(4349),
    [anon_sym_as] = ACTIONS(4349),
    [anon_sym_is] = ACTIONS(4349),
    [anon_sym_DASH_GT] = ACTIONS(4349),
    [anon_sym_with] = ACTIONS(4349),
    [aux_sym_preproc_if_token3] = ACTIONS(4349),
    [aux_sym_preproc_else_token1] = ACTIONS(4349),
    [aux_sym_preproc_elif_token1] = ACTIONS(4349),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3920] = {
    [sym_preproc_region] = STATE(3920),
    [sym_preproc_endregion] = STATE(3920),
    [sym_preproc_line] = STATE(3920),
    [sym_preproc_pragma] = STATE(3920),
    [sym_preproc_nullable] = STATE(3920),
    [sym_preproc_error] = STATE(3920),
    [sym_preproc_define] = STATE(3920),
    [sym_preproc_undef] = STATE(3920),
    [anon_sym_EQ] = ACTIONS(4645),
    [anon_sym_LBRACK] = ACTIONS(4643),
    [anon_sym_COLON] = ACTIONS(4643),
    [anon_sym_COMMA] = ACTIONS(4643),
    [anon_sym_LPAREN] = ACTIONS(4643),
    [anon_sym_LT] = ACTIONS(4645),
    [anon_sym_GT] = ACTIONS(4645),
    [anon_sym_QMARK] = ACTIONS(4645),
    [anon_sym_BANG] = ACTIONS(4645),
    [anon_sym_PLUS_PLUS] = ACTIONS(4643),
    [anon_sym_DASH_DASH] = ACTIONS(4643),
    [anon_sym_PLUS] = ACTIONS(4645),
    [anon_sym_DASH] = ACTIONS(4645),
    [anon_sym_STAR] = ACTIONS(4645),
    [anon_sym_SLASH] = ACTIONS(4645),
    [anon_sym_PERCENT] = ACTIONS(4645),
    [anon_sym_CARET] = ACTIONS(4645),
    [anon_sym_PIPE] = ACTIONS(4645),
    [anon_sym_AMP] = ACTIONS(4645),
    [anon_sym_LT_LT] = ACTIONS(4645),
    [anon_sym_GT_GT] = ACTIONS(4645),
    [anon_sym_GT_GT_GT] = ACTIONS(4645),
    [anon_sym_EQ_EQ] = ACTIONS(4643),
    [anon_sym_BANG_EQ] = ACTIONS(4643),
    [anon_sym_GT_EQ] = ACTIONS(4643),
    [anon_sym_LT_EQ] = ACTIONS(4643),
    [anon_sym_DOT] = ACTIONS(4645),
    [anon_sym_switch] = ACTIONS(4643),
    [anon_sym_DOT_DOT] = ACTIONS(4643),
    [anon_sym_and] = ACTIONS(4643),
    [anon_sym_or] = ACTIONS(4643),
    [anon_sym_PLUS_EQ] = ACTIONS(4643),
    [anon_sym_DASH_EQ] = ACTIONS(4643),
    [anon_sym_STAR_EQ] = ACTIONS(4643),
    [anon_sym_SLASH_EQ] = ACTIONS(4643),
    [anon_sym_PERCENT_EQ] = ACTIONS(4643),
    [anon_sym_AMP_EQ] = ACTIONS(4643),
    [anon_sym_CARET_EQ] = ACTIONS(4643),
    [anon_sym_PIPE_EQ] = ACTIONS(4643),
    [anon_sym_LT_LT_EQ] = ACTIONS(4643),
    [anon_sym_GT_GT_EQ] = ACTIONS(4643),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4643),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4643),
    [anon_sym_AMP_AMP] = ACTIONS(4643),
    [anon_sym_PIPE_PIPE] = ACTIONS(4643),
    [anon_sym_QMARK_QMARK] = ACTIONS(4645),
    [anon_sym_into] = ACTIONS(4643),
    [anon_sym_as] = ACTIONS(4643),
    [anon_sym_is] = ACTIONS(4643),
    [anon_sym_DASH_GT] = ACTIONS(4643),
    [anon_sym_with] = ACTIONS(4643),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4643),
  },
  [3921] = {
    [sym_preproc_region] = STATE(3921),
    [sym_preproc_endregion] = STATE(3921),
    [sym_preproc_line] = STATE(3921),
    [sym_preproc_pragma] = STATE(3921),
    [sym_preproc_nullable] = STATE(3921),
    [sym_preproc_error] = STATE(3921),
    [sym_preproc_define] = STATE(3921),
    [sym_preproc_undef] = STATE(3921),
    [anon_sym_EQ] = ACTIONS(4625),
    [anon_sym_LBRACK] = ACTIONS(4623),
    [anon_sym_COLON] = ACTIONS(4623),
    [anon_sym_COMMA] = ACTIONS(4623),
    [anon_sym_LPAREN] = ACTIONS(4623),
    [anon_sym_LT] = ACTIONS(4625),
    [anon_sym_GT] = ACTIONS(4625),
    [anon_sym_QMARK] = ACTIONS(4625),
    [anon_sym_BANG] = ACTIONS(4625),
    [anon_sym_PLUS_PLUS] = ACTIONS(4623),
    [anon_sym_DASH_DASH] = ACTIONS(4623),
    [anon_sym_PLUS] = ACTIONS(4625),
    [anon_sym_DASH] = ACTIONS(4625),
    [anon_sym_STAR] = ACTIONS(4625),
    [anon_sym_SLASH] = ACTIONS(4625),
    [anon_sym_PERCENT] = ACTIONS(4625),
    [anon_sym_CARET] = ACTIONS(4625),
    [anon_sym_PIPE] = ACTIONS(4625),
    [anon_sym_AMP] = ACTIONS(4625),
    [anon_sym_LT_LT] = ACTIONS(4625),
    [anon_sym_GT_GT] = ACTIONS(4625),
    [anon_sym_GT_GT_GT] = ACTIONS(4625),
    [anon_sym_EQ_EQ] = ACTIONS(4623),
    [anon_sym_BANG_EQ] = ACTIONS(4623),
    [anon_sym_GT_EQ] = ACTIONS(4623),
    [anon_sym_LT_EQ] = ACTIONS(4623),
    [anon_sym_DOT] = ACTIONS(4625),
    [anon_sym_switch] = ACTIONS(4623),
    [anon_sym_DOT_DOT] = ACTIONS(4623),
    [anon_sym_and] = ACTIONS(4623),
    [anon_sym_or] = ACTIONS(4623),
    [anon_sym_PLUS_EQ] = ACTIONS(4623),
    [anon_sym_DASH_EQ] = ACTIONS(4623),
    [anon_sym_STAR_EQ] = ACTIONS(4623),
    [anon_sym_SLASH_EQ] = ACTIONS(4623),
    [anon_sym_PERCENT_EQ] = ACTIONS(4623),
    [anon_sym_AMP_EQ] = ACTIONS(4623),
    [anon_sym_CARET_EQ] = ACTIONS(4623),
    [anon_sym_PIPE_EQ] = ACTIONS(4623),
    [anon_sym_LT_LT_EQ] = ACTIONS(4623),
    [anon_sym_GT_GT_EQ] = ACTIONS(4623),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4623),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4623),
    [anon_sym_AMP_AMP] = ACTIONS(4623),
    [anon_sym_PIPE_PIPE] = ACTIONS(4623),
    [anon_sym_QMARK_QMARK] = ACTIONS(4625),
    [anon_sym_into] = ACTIONS(4623),
    [anon_sym_as] = ACTIONS(4623),
    [anon_sym_is] = ACTIONS(4623),
    [anon_sym_DASH_GT] = ACTIONS(4623),
    [anon_sym_with] = ACTIONS(4623),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4623),
  },
  [3922] = {
    [sym_argument_list] = STATE(4235),
    [sym_bracketed_argument_list] = STATE(3481),
    [sym_preproc_region] = STATE(3922),
    [sym_preproc_endregion] = STATE(3922),
    [sym_preproc_line] = STATE(3922),
    [sym_preproc_pragma] = STATE(3922),
    [sym_preproc_nullable] = STATE(3922),
    [sym_preproc_error] = STATE(3922),
    [sym_preproc_define] = STATE(3922),
    [sym_preproc_undef] = STATE(3922),
    [anon_sym_SEMI] = ACTIONS(5255),
    [anon_sym_LBRACK] = ACTIONS(5743),
    [anon_sym_COLON] = ACTIONS(5255),
    [anon_sym_COMMA] = ACTIONS(5255),
    [anon_sym_RBRACK] = ACTIONS(5255),
    [anon_sym_LPAREN] = ACTIONS(5711),
    [anon_sym_RPAREN] = ACTIONS(5255),
    [anon_sym_RBRACE] = ACTIONS(5255),
    [anon_sym_LT] = ACTIONS(5257),
    [anon_sym_GT] = ACTIONS(5257),
    [anon_sym_in] = ACTIONS(5255),
    [anon_sym_QMARK] = ACTIONS(5257),
    [anon_sym_BANG] = ACTIONS(5745),
    [anon_sym_PLUS_PLUS] = ACTIONS(5747),
    [anon_sym_DASH_DASH] = ACTIONS(5747),
    [anon_sym_PLUS] = ACTIONS(5257),
    [anon_sym_DASH] = ACTIONS(5257),
    [anon_sym_STAR] = ACTIONS(5255),
    [anon_sym_SLASH] = ACTIONS(5257),
    [anon_sym_PERCENT] = ACTIONS(5255),
    [anon_sym_CARET] = ACTIONS(5255),
    [anon_sym_PIPE] = ACTIONS(5257),
    [anon_sym_AMP] = ACTIONS(5257),
    [anon_sym_LT_LT] = ACTIONS(5255),
    [anon_sym_GT_GT] = ACTIONS(5257),
    [anon_sym_GT_GT_GT] = ACTIONS(5255),
    [anon_sym_EQ_EQ] = ACTIONS(5255),
    [anon_sym_BANG_EQ] = ACTIONS(5255),
    [anon_sym_GT_EQ] = ACTIONS(5255),
    [anon_sym_LT_EQ] = ACTIONS(5255),
    [anon_sym_DOT] = ACTIONS(4560),
    [anon_sym_EQ_GT] = ACTIONS(5255),
    [anon_sym_switch] = ACTIONS(5255),
    [anon_sym_when] = ACTIONS(5255),
    [anon_sym_DOT_DOT] = ACTIONS(5255),
    [anon_sym_and] = ACTIONS(5255),
    [anon_sym_or] = ACTIONS(5255),
    [anon_sym_AMP_AMP] = ACTIONS(5255),
    [anon_sym_PIPE_PIPE] = ACTIONS(5255),
    [anon_sym_QMARK_QMARK] = ACTIONS(5255),
    [anon_sym_on] = ACTIONS(5255),
    [anon_sym_equals] = ACTIONS(5255),
    [anon_sym_by] = ACTIONS(5255),
    [anon_sym_as] = ACTIONS(5255),
    [anon_sym_is] = ACTIONS(5255),
    [anon_sym_DASH_GT] = ACTIONS(4562),
    [anon_sym_with] = ACTIONS(5255),
    [aux_sym_preproc_if_token3] = ACTIONS(5255),
    [aux_sym_preproc_else_token1] = ACTIONS(5255),
    [aux_sym_preproc_elif_token1] = ACTIONS(5255),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3923] = {
    [sym_preproc_region] = STATE(3923),
    [sym_preproc_endregion] = STATE(3923),
    [sym_preproc_line] = STATE(3923),
    [sym_preproc_pragma] = STATE(3923),
    [sym_preproc_nullable] = STATE(3923),
    [sym_preproc_error] = STATE(3923),
    [sym_preproc_define] = STATE(3923),
    [sym_preproc_undef] = STATE(3923),
    [anon_sym_SEMI] = ACTIONS(4416),
    [anon_sym_LBRACK] = ACTIONS(4416),
    [anon_sym_COLON] = ACTIONS(4416),
    [anon_sym_COMMA] = ACTIONS(4416),
    [anon_sym_RBRACK] = ACTIONS(4416),
    [anon_sym_LPAREN] = ACTIONS(4416),
    [anon_sym_RPAREN] = ACTIONS(4416),
    [anon_sym_LBRACE] = ACTIONS(4416),
    [anon_sym_RBRACE] = ACTIONS(4416),
    [anon_sym_LT] = ACTIONS(4414),
    [anon_sym_GT] = ACTIONS(4414),
    [anon_sym_in] = ACTIONS(4414),
    [anon_sym_QMARK] = ACTIONS(4414),
    [anon_sym_BANG] = ACTIONS(4414),
    [anon_sym_PLUS_PLUS] = ACTIONS(4416),
    [anon_sym_DASH_DASH] = ACTIONS(4416),
    [anon_sym_PLUS] = ACTIONS(4414),
    [anon_sym_DASH] = ACTIONS(4414),
    [anon_sym_STAR] = ACTIONS(4416),
    [anon_sym_SLASH] = ACTIONS(4414),
    [anon_sym_PERCENT] = ACTIONS(4416),
    [anon_sym_CARET] = ACTIONS(4416),
    [anon_sym_PIPE] = ACTIONS(4414),
    [anon_sym_AMP] = ACTIONS(4414),
    [anon_sym_LT_LT] = ACTIONS(4416),
    [anon_sym_GT_GT] = ACTIONS(4414),
    [anon_sym_GT_GT_GT] = ACTIONS(4416),
    [anon_sym_EQ_EQ] = ACTIONS(4416),
    [anon_sym_BANG_EQ] = ACTIONS(4416),
    [anon_sym_GT_EQ] = ACTIONS(4416),
    [anon_sym_LT_EQ] = ACTIONS(4416),
    [anon_sym_DOT] = ACTIONS(4414),
    [anon_sym_EQ_GT] = ACTIONS(4416),
    [anon_sym_switch] = ACTIONS(4416),
    [anon_sym_when] = ACTIONS(4416),
    [anon_sym_DOT_DOT] = ACTIONS(4416),
    [anon_sym_and] = ACTIONS(4416),
    [anon_sym_or] = ACTIONS(4416),
    [anon_sym_AMP_AMP] = ACTIONS(4416),
    [anon_sym_PIPE_PIPE] = ACTIONS(4416),
    [anon_sym_QMARK_QMARK] = ACTIONS(4416),
    [anon_sym_into] = ACTIONS(4416),
    [anon_sym_on] = ACTIONS(4416),
    [anon_sym_equals] = ACTIONS(4416),
    [anon_sym_by] = ACTIONS(4416),
    [anon_sym_as] = ACTIONS(4416),
    [anon_sym_is] = ACTIONS(4416),
    [anon_sym_DASH_GT] = ACTIONS(4416),
    [anon_sym_with] = ACTIONS(4416),
    [aux_sym_preproc_if_token3] = ACTIONS(4416),
    [aux_sym_preproc_else_token1] = ACTIONS(4416),
    [aux_sym_preproc_elif_token1] = ACTIONS(4416),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3924] = {
    [sym_preproc_region] = STATE(3924),
    [sym_preproc_endregion] = STATE(3924),
    [sym_preproc_line] = STATE(3924),
    [sym_preproc_pragma] = STATE(3924),
    [sym_preproc_nullable] = STATE(3924),
    [sym_preproc_error] = STATE(3924),
    [sym_preproc_define] = STATE(3924),
    [sym_preproc_undef] = STATE(3924),
    [anon_sym_EQ] = ACTIONS(4633),
    [anon_sym_LBRACK] = ACTIONS(4631),
    [anon_sym_COLON] = ACTIONS(4631),
    [anon_sym_COMMA] = ACTIONS(4631),
    [anon_sym_LPAREN] = ACTIONS(4631),
    [anon_sym_LT] = ACTIONS(4633),
    [anon_sym_GT] = ACTIONS(4633),
    [anon_sym_QMARK] = ACTIONS(4633),
    [anon_sym_BANG] = ACTIONS(4633),
    [anon_sym_PLUS_PLUS] = ACTIONS(4631),
    [anon_sym_DASH_DASH] = ACTIONS(4631),
    [anon_sym_PLUS] = ACTIONS(4633),
    [anon_sym_DASH] = ACTIONS(4633),
    [anon_sym_STAR] = ACTIONS(4633),
    [anon_sym_SLASH] = ACTIONS(4633),
    [anon_sym_PERCENT] = ACTIONS(4633),
    [anon_sym_CARET] = ACTIONS(4633),
    [anon_sym_PIPE] = ACTIONS(4633),
    [anon_sym_AMP] = ACTIONS(4633),
    [anon_sym_LT_LT] = ACTIONS(4633),
    [anon_sym_GT_GT] = ACTIONS(4633),
    [anon_sym_GT_GT_GT] = ACTIONS(4633),
    [anon_sym_EQ_EQ] = ACTIONS(4631),
    [anon_sym_BANG_EQ] = ACTIONS(4631),
    [anon_sym_GT_EQ] = ACTIONS(4631),
    [anon_sym_LT_EQ] = ACTIONS(4631),
    [anon_sym_DOT] = ACTIONS(4633),
    [anon_sym_switch] = ACTIONS(4631),
    [anon_sym_DOT_DOT] = ACTIONS(4631),
    [anon_sym_and] = ACTIONS(4631),
    [anon_sym_or] = ACTIONS(4631),
    [anon_sym_PLUS_EQ] = ACTIONS(4631),
    [anon_sym_DASH_EQ] = ACTIONS(4631),
    [anon_sym_STAR_EQ] = ACTIONS(4631),
    [anon_sym_SLASH_EQ] = ACTIONS(4631),
    [anon_sym_PERCENT_EQ] = ACTIONS(4631),
    [anon_sym_AMP_EQ] = ACTIONS(4631),
    [anon_sym_CARET_EQ] = ACTIONS(4631),
    [anon_sym_PIPE_EQ] = ACTIONS(4631),
    [anon_sym_LT_LT_EQ] = ACTIONS(4631),
    [anon_sym_GT_GT_EQ] = ACTIONS(4631),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4631),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4631),
    [anon_sym_AMP_AMP] = ACTIONS(4631),
    [anon_sym_PIPE_PIPE] = ACTIONS(4631),
    [anon_sym_QMARK_QMARK] = ACTIONS(4633),
    [anon_sym_into] = ACTIONS(4631),
    [anon_sym_as] = ACTIONS(4631),
    [anon_sym_is] = ACTIONS(4631),
    [anon_sym_DASH_GT] = ACTIONS(4631),
    [anon_sym_with] = ACTIONS(4631),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4631),
  },
  [3925] = {
    [sym_preproc_region] = STATE(3925),
    [sym_preproc_endregion] = STATE(3925),
    [sym_preproc_line] = STATE(3925),
    [sym_preproc_pragma] = STATE(3925),
    [sym_preproc_nullable] = STATE(3925),
    [sym_preproc_error] = STATE(3925),
    [sym_preproc_define] = STATE(3925),
    [sym_preproc_undef] = STATE(3925),
    [anon_sym_SEMI] = ACTIONS(4424),
    [anon_sym_LBRACK] = ACTIONS(4547),
    [anon_sym_COLON] = ACTIONS(4424),
    [anon_sym_COMMA] = ACTIONS(4424),
    [anon_sym_RBRACK] = ACTIONS(4424),
    [anon_sym_LPAREN] = ACTIONS(4424),
    [anon_sym_RPAREN] = ACTIONS(4424),
    [anon_sym_LBRACE] = ACTIONS(4424),
    [anon_sym_RBRACE] = ACTIONS(4424),
    [anon_sym_LT] = ACTIONS(4422),
    [anon_sym_GT] = ACTIONS(4422),
    [anon_sym_in] = ACTIONS(4422),
    [anon_sym_QMARK] = ACTIONS(5751),
    [anon_sym_BANG] = ACTIONS(4422),
    [anon_sym_PLUS_PLUS] = ACTIONS(4424),
    [anon_sym_DASH_DASH] = ACTIONS(4424),
    [anon_sym_PLUS] = ACTIONS(4422),
    [anon_sym_DASH] = ACTIONS(4422),
    [anon_sym_STAR] = ACTIONS(4553),
    [anon_sym_SLASH] = ACTIONS(4422),
    [anon_sym_PERCENT] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4424),
    [anon_sym_PIPE] = ACTIONS(4422),
    [anon_sym_AMP] = ACTIONS(4422),
    [anon_sym_LT_LT] = ACTIONS(4424),
    [anon_sym_GT_GT] = ACTIONS(4422),
    [anon_sym_GT_GT_GT] = ACTIONS(4424),
    [anon_sym_EQ_EQ] = ACTIONS(4424),
    [anon_sym_BANG_EQ] = ACTIONS(4424),
    [anon_sym_GT_EQ] = ACTIONS(4424),
    [anon_sym_LT_EQ] = ACTIONS(4424),
    [anon_sym_DOT] = ACTIONS(5754),
    [anon_sym_EQ_GT] = ACTIONS(4424),
    [anon_sym_switch] = ACTIONS(4424),
    [anon_sym_when] = ACTIONS(4424),
    [anon_sym_DOT_DOT] = ACTIONS(4424),
    [anon_sym_and] = ACTIONS(4424),
    [anon_sym_or] = ACTIONS(4424),
    [anon_sym_AMP_AMP] = ACTIONS(4424),
    [anon_sym_PIPE_PIPE] = ACTIONS(4424),
    [anon_sym_QMARK_QMARK] = ACTIONS(4424),
    [anon_sym_into] = ACTIONS(4424),
    [anon_sym_on] = ACTIONS(4424),
    [anon_sym_equals] = ACTIONS(4424),
    [anon_sym_by] = ACTIONS(4424),
    [anon_sym_as] = ACTIONS(4424),
    [anon_sym_is] = ACTIONS(4424),
    [anon_sym_DASH_GT] = ACTIONS(4424),
    [anon_sym_with] = ACTIONS(4424),
    [aux_sym_preproc_if_token3] = ACTIONS(4424),
    [aux_sym_preproc_else_token1] = ACTIONS(4424),
    [aux_sym_preproc_elif_token1] = ACTIONS(4424),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3926] = {
    [sym_preproc_region] = STATE(3926),
    [sym_preproc_endregion] = STATE(3926),
    [sym_preproc_line] = STATE(3926),
    [sym_preproc_pragma] = STATE(3926),
    [sym_preproc_nullable] = STATE(3926),
    [sym_preproc_error] = STATE(3926),
    [sym_preproc_define] = STATE(3926),
    [sym_preproc_undef] = STATE(3926),
    [anon_sym_SEMI] = ACTIONS(4428),
    [anon_sym_LBRACK] = ACTIONS(4428),
    [anon_sym_COLON] = ACTIONS(4428),
    [anon_sym_COMMA] = ACTIONS(4428),
    [anon_sym_RBRACK] = ACTIONS(4428),
    [anon_sym_LPAREN] = ACTIONS(4428),
    [anon_sym_RPAREN] = ACTIONS(4428),
    [anon_sym_LBRACE] = ACTIONS(4428),
    [anon_sym_RBRACE] = ACTIONS(4428),
    [anon_sym_LT] = ACTIONS(4426),
    [anon_sym_GT] = ACTIONS(4426),
    [anon_sym_in] = ACTIONS(4426),
    [anon_sym_QMARK] = ACTIONS(4426),
    [anon_sym_BANG] = ACTIONS(4426),
    [anon_sym_PLUS_PLUS] = ACTIONS(4428),
    [anon_sym_DASH_DASH] = ACTIONS(4428),
    [anon_sym_PLUS] = ACTIONS(4426),
    [anon_sym_DASH] = ACTIONS(4426),
    [anon_sym_STAR] = ACTIONS(4428),
    [anon_sym_SLASH] = ACTIONS(4426),
    [anon_sym_PERCENT] = ACTIONS(4428),
    [anon_sym_CARET] = ACTIONS(4428),
    [anon_sym_PIPE] = ACTIONS(4426),
    [anon_sym_AMP] = ACTIONS(4426),
    [anon_sym_LT_LT] = ACTIONS(4428),
    [anon_sym_GT_GT] = ACTIONS(4426),
    [anon_sym_GT_GT_GT] = ACTIONS(4428),
    [anon_sym_EQ_EQ] = ACTIONS(4428),
    [anon_sym_BANG_EQ] = ACTIONS(4428),
    [anon_sym_GT_EQ] = ACTIONS(4428),
    [anon_sym_LT_EQ] = ACTIONS(4428),
    [anon_sym_DOT] = ACTIONS(5754),
    [anon_sym_EQ_GT] = ACTIONS(4428),
    [anon_sym_switch] = ACTIONS(4428),
    [anon_sym_when] = ACTIONS(4428),
    [anon_sym_DOT_DOT] = ACTIONS(4428),
    [anon_sym_and] = ACTIONS(4428),
    [anon_sym_or] = ACTIONS(4428),
    [anon_sym_AMP_AMP] = ACTIONS(4428),
    [anon_sym_PIPE_PIPE] = ACTIONS(4428),
    [anon_sym_QMARK_QMARK] = ACTIONS(4428),
    [anon_sym_into] = ACTIONS(4428),
    [anon_sym_on] = ACTIONS(4428),
    [anon_sym_equals] = ACTIONS(4428),
    [anon_sym_by] = ACTIONS(4428),
    [anon_sym_as] = ACTIONS(4428),
    [anon_sym_is] = ACTIONS(4428),
    [anon_sym_DASH_GT] = ACTIONS(4428),
    [anon_sym_with] = ACTIONS(4428),
    [aux_sym_preproc_if_token3] = ACTIONS(4428),
    [aux_sym_preproc_else_token1] = ACTIONS(4428),
    [aux_sym_preproc_elif_token1] = ACTIONS(4428),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3927] = {
    [sym_preproc_region] = STATE(3927),
    [sym_preproc_endregion] = STATE(3927),
    [sym_preproc_line] = STATE(3927),
    [sym_preproc_pragma] = STATE(3927),
    [sym_preproc_nullable] = STATE(3927),
    [sym_preproc_error] = STATE(3927),
    [sym_preproc_define] = STATE(3927),
    [sym_preproc_undef] = STATE(3927),
    [anon_sym_SEMI] = ACTIONS(4428),
    [anon_sym_LBRACK] = ACTIONS(4428),
    [anon_sym_COLON] = ACTIONS(4428),
    [anon_sym_COMMA] = ACTIONS(4428),
    [anon_sym_RBRACK] = ACTIONS(4428),
    [anon_sym_LPAREN] = ACTIONS(4428),
    [anon_sym_RPAREN] = ACTIONS(4428),
    [anon_sym_LBRACE] = ACTIONS(4428),
    [anon_sym_RBRACE] = ACTIONS(4428),
    [anon_sym_LT] = ACTIONS(4426),
    [anon_sym_GT] = ACTIONS(4426),
    [anon_sym_in] = ACTIONS(4426),
    [anon_sym_QMARK] = ACTIONS(4426),
    [anon_sym_BANG] = ACTIONS(4426),
    [anon_sym_PLUS_PLUS] = ACTIONS(4428),
    [anon_sym_DASH_DASH] = ACTIONS(4428),
    [anon_sym_PLUS] = ACTIONS(4426),
    [anon_sym_DASH] = ACTIONS(4426),
    [anon_sym_STAR] = ACTIONS(4428),
    [anon_sym_SLASH] = ACTIONS(4426),
    [anon_sym_PERCENT] = ACTIONS(4428),
    [anon_sym_CARET] = ACTIONS(4428),
    [anon_sym_PIPE] = ACTIONS(4426),
    [anon_sym_AMP] = ACTIONS(4426),
    [anon_sym_LT_LT] = ACTIONS(4428),
    [anon_sym_GT_GT] = ACTIONS(4426),
    [anon_sym_GT_GT_GT] = ACTIONS(4428),
    [anon_sym_EQ_EQ] = ACTIONS(4428),
    [anon_sym_BANG_EQ] = ACTIONS(4428),
    [anon_sym_GT_EQ] = ACTIONS(4428),
    [anon_sym_LT_EQ] = ACTIONS(4428),
    [anon_sym_DOT] = ACTIONS(4426),
    [anon_sym_EQ_GT] = ACTIONS(4428),
    [anon_sym_switch] = ACTIONS(4428),
    [anon_sym_when] = ACTIONS(4428),
    [anon_sym_DOT_DOT] = ACTIONS(4428),
    [anon_sym_and] = ACTIONS(4428),
    [anon_sym_or] = ACTIONS(4428),
    [anon_sym_AMP_AMP] = ACTIONS(4428),
    [anon_sym_PIPE_PIPE] = ACTIONS(4428),
    [anon_sym_QMARK_QMARK] = ACTIONS(4428),
    [anon_sym_into] = ACTIONS(4428),
    [anon_sym_on] = ACTIONS(4428),
    [anon_sym_equals] = ACTIONS(4428),
    [anon_sym_by] = ACTIONS(4428),
    [anon_sym_as] = ACTIONS(4428),
    [anon_sym_is] = ACTIONS(4428),
    [anon_sym_DASH_GT] = ACTIONS(4428),
    [anon_sym_with] = ACTIONS(4428),
    [aux_sym_preproc_if_token3] = ACTIONS(4428),
    [aux_sym_preproc_else_token1] = ACTIONS(4428),
    [aux_sym_preproc_elif_token1] = ACTIONS(4428),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3928] = {
    [sym_preproc_region] = STATE(3928),
    [sym_preproc_endregion] = STATE(3928),
    [sym_preproc_line] = STATE(3928),
    [sym_preproc_pragma] = STATE(3928),
    [sym_preproc_nullable] = STATE(3928),
    [sym_preproc_error] = STATE(3928),
    [sym_preproc_define] = STATE(3928),
    [sym_preproc_undef] = STATE(3928),
    [anon_sym_SEMI] = ACTIONS(4024),
    [anon_sym_LBRACK] = ACTIONS(4024),
    [anon_sym_COLON] = ACTIONS(4027),
    [anon_sym_COMMA] = ACTIONS(4024),
    [anon_sym_RBRACK] = ACTIONS(4024),
    [anon_sym_LPAREN] = ACTIONS(4024),
    [anon_sym_RPAREN] = ACTIONS(4024),
    [anon_sym_LBRACE] = ACTIONS(4024),
    [anon_sym_RBRACE] = ACTIONS(4024),
    [anon_sym_LT] = ACTIONS(4027),
    [anon_sym_GT] = ACTIONS(4027),
    [anon_sym_in] = ACTIONS(4024),
    [anon_sym_QMARK] = ACTIONS(4027),
    [anon_sym_BANG] = ACTIONS(4027),
    [anon_sym_PLUS_PLUS] = ACTIONS(4024),
    [anon_sym_DASH_DASH] = ACTIONS(4024),
    [anon_sym_PLUS] = ACTIONS(4027),
    [anon_sym_DASH] = ACTIONS(4027),
    [anon_sym_STAR] = ACTIONS(4024),
    [anon_sym_SLASH] = ACTIONS(4027),
    [anon_sym_PERCENT] = ACTIONS(4024),
    [anon_sym_CARET] = ACTIONS(4024),
    [anon_sym_PIPE] = ACTIONS(4027),
    [anon_sym_AMP] = ACTIONS(4027),
    [anon_sym_LT_LT] = ACTIONS(4024),
    [anon_sym_GT_GT] = ACTIONS(4027),
    [anon_sym_GT_GT_GT] = ACTIONS(4024),
    [anon_sym_EQ_EQ] = ACTIONS(4024),
    [anon_sym_BANG_EQ] = ACTIONS(4024),
    [anon_sym_GT_EQ] = ACTIONS(4024),
    [anon_sym_LT_EQ] = ACTIONS(4024),
    [anon_sym_DOT] = ACTIONS(4027),
    [anon_sym_EQ_GT] = ACTIONS(4024),
    [anon_sym_COLON_COLON] = ACTIONS(3719),
    [anon_sym_switch] = ACTIONS(4024),
    [anon_sym_when] = ACTIONS(4024),
    [anon_sym_DOT_DOT] = ACTIONS(4024),
    [anon_sym_and] = ACTIONS(4024),
    [anon_sym_or] = ACTIONS(4024),
    [anon_sym_AMP_AMP] = ACTIONS(4024),
    [anon_sym_PIPE_PIPE] = ACTIONS(4024),
    [anon_sym_QMARK_QMARK] = ACTIONS(4024),
    [anon_sym_on] = ACTIONS(4024),
    [anon_sym_equals] = ACTIONS(4024),
    [anon_sym_by] = ACTIONS(4024),
    [anon_sym_as] = ACTIONS(4024),
    [anon_sym_is] = ACTIONS(4024),
    [anon_sym_DASH_GT] = ACTIONS(4024),
    [anon_sym_with] = ACTIONS(4024),
    [aux_sym_preproc_if_token3] = ACTIONS(4024),
    [aux_sym_preproc_else_token1] = ACTIONS(4024),
    [aux_sym_preproc_elif_token1] = ACTIONS(4024),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3929] = {
    [sym_preproc_region] = STATE(3929),
    [sym_preproc_endregion] = STATE(3929),
    [sym_preproc_line] = STATE(3929),
    [sym_preproc_pragma] = STATE(3929),
    [sym_preproc_nullable] = STATE(3929),
    [sym_preproc_error] = STATE(3929),
    [sym_preproc_define] = STATE(3929),
    [sym_preproc_undef] = STATE(3929),
    [anon_sym_SEMI] = ACTIONS(5262),
    [anon_sym_LBRACK] = ACTIONS(5262),
    [anon_sym_COLON] = ACTIONS(5262),
    [anon_sym_COMMA] = ACTIONS(5262),
    [anon_sym_RBRACK] = ACTIONS(5262),
    [anon_sym_LPAREN] = ACTIONS(5262),
    [anon_sym_RPAREN] = ACTIONS(5262),
    [anon_sym_LBRACE] = ACTIONS(5262),
    [anon_sym_RBRACE] = ACTIONS(5262),
    [anon_sym_LT] = ACTIONS(5264),
    [anon_sym_GT] = ACTIONS(5264),
    [anon_sym_in] = ACTIONS(5264),
    [anon_sym_QMARK] = ACTIONS(5264),
    [anon_sym_BANG] = ACTIONS(5264),
    [anon_sym_PLUS_PLUS] = ACTIONS(5262),
    [anon_sym_DASH_DASH] = ACTIONS(5262),
    [anon_sym_PLUS] = ACTIONS(5264),
    [anon_sym_DASH] = ACTIONS(5264),
    [anon_sym_STAR] = ACTIONS(5262),
    [anon_sym_SLASH] = ACTIONS(5264),
    [anon_sym_PERCENT] = ACTIONS(5262),
    [anon_sym_CARET] = ACTIONS(5262),
    [anon_sym_PIPE] = ACTIONS(5264),
    [anon_sym_AMP] = ACTIONS(5264),
    [anon_sym_LT_LT] = ACTIONS(5262),
    [anon_sym_GT_GT] = ACTIONS(5264),
    [anon_sym_GT_GT_GT] = ACTIONS(5262),
    [anon_sym_EQ_EQ] = ACTIONS(5262),
    [anon_sym_BANG_EQ] = ACTIONS(5262),
    [anon_sym_GT_EQ] = ACTIONS(5262),
    [anon_sym_LT_EQ] = ACTIONS(5262),
    [anon_sym_DOT] = ACTIONS(5264),
    [anon_sym_EQ_GT] = ACTIONS(5262),
    [anon_sym_switch] = ACTIONS(5262),
    [anon_sym_when] = ACTIONS(5262),
    [anon_sym_DOT_DOT] = ACTIONS(5262),
    [anon_sym_and] = ACTIONS(5262),
    [anon_sym_or] = ACTIONS(5262),
    [anon_sym_AMP_AMP] = ACTIONS(5262),
    [anon_sym_PIPE_PIPE] = ACTIONS(5262),
    [anon_sym_QMARK_QMARK] = ACTIONS(5262),
    [anon_sym_into] = ACTIONS(5262),
    [anon_sym_on] = ACTIONS(5262),
    [anon_sym_equals] = ACTIONS(5262),
    [anon_sym_by] = ACTIONS(5262),
    [anon_sym_as] = ACTIONS(5262),
    [anon_sym_is] = ACTIONS(5262),
    [anon_sym_DASH_GT] = ACTIONS(5262),
    [anon_sym_with] = ACTIONS(5262),
    [aux_sym_preproc_if_token3] = ACTIONS(5262),
    [aux_sym_preproc_else_token1] = ACTIONS(5262),
    [aux_sym_preproc_elif_token1] = ACTIONS(5262),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3930] = {
    [sym_preproc_region] = STATE(3930),
    [sym_preproc_endregion] = STATE(3930),
    [sym_preproc_line] = STATE(3930),
    [sym_preproc_pragma] = STATE(3930),
    [sym_preproc_nullable] = STATE(3930),
    [sym_preproc_error] = STATE(3930),
    [sym_preproc_define] = STATE(3930),
    [sym_preproc_undef] = STATE(3930),
    [anon_sym_SEMI] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4438),
    [anon_sym_COLON] = ACTIONS(4438),
    [anon_sym_COMMA] = ACTIONS(4438),
    [anon_sym_RBRACK] = ACTIONS(4438),
    [anon_sym_LPAREN] = ACTIONS(4438),
    [anon_sym_RPAREN] = ACTIONS(4438),
    [anon_sym_LBRACE] = ACTIONS(4438),
    [anon_sym_RBRACE] = ACTIONS(4438),
    [anon_sym_LT] = ACTIONS(4436),
    [anon_sym_GT] = ACTIONS(4436),
    [anon_sym_in] = ACTIONS(4436),
    [anon_sym_QMARK] = ACTIONS(4436),
    [anon_sym_BANG] = ACTIONS(4436),
    [anon_sym_PLUS_PLUS] = ACTIONS(4438),
    [anon_sym_DASH_DASH] = ACTIONS(4438),
    [anon_sym_PLUS] = ACTIONS(4436),
    [anon_sym_DASH] = ACTIONS(4436),
    [anon_sym_STAR] = ACTIONS(4438),
    [anon_sym_SLASH] = ACTIONS(4436),
    [anon_sym_PERCENT] = ACTIONS(4438),
    [anon_sym_CARET] = ACTIONS(4438),
    [anon_sym_PIPE] = ACTIONS(4436),
    [anon_sym_AMP] = ACTIONS(4436),
    [anon_sym_LT_LT] = ACTIONS(4438),
    [anon_sym_GT_GT] = ACTIONS(4436),
    [anon_sym_GT_GT_GT] = ACTIONS(4438),
    [anon_sym_EQ_EQ] = ACTIONS(4438),
    [anon_sym_BANG_EQ] = ACTIONS(4438),
    [anon_sym_GT_EQ] = ACTIONS(4438),
    [anon_sym_LT_EQ] = ACTIONS(4438),
    [anon_sym_DOT] = ACTIONS(4436),
    [anon_sym_EQ_GT] = ACTIONS(4438),
    [anon_sym_switch] = ACTIONS(4438),
    [anon_sym_when] = ACTIONS(4438),
    [anon_sym_DOT_DOT] = ACTIONS(4438),
    [anon_sym_and] = ACTIONS(4438),
    [anon_sym_or] = ACTIONS(4438),
    [anon_sym_AMP_AMP] = ACTIONS(4438),
    [anon_sym_PIPE_PIPE] = ACTIONS(4438),
    [anon_sym_QMARK_QMARK] = ACTIONS(4438),
    [anon_sym_into] = ACTIONS(4438),
    [anon_sym_on] = ACTIONS(4438),
    [anon_sym_equals] = ACTIONS(4438),
    [anon_sym_by] = ACTIONS(4438),
    [anon_sym_as] = ACTIONS(4438),
    [anon_sym_is] = ACTIONS(4438),
    [anon_sym_DASH_GT] = ACTIONS(4438),
    [anon_sym_with] = ACTIONS(4438),
    [aux_sym_preproc_if_token3] = ACTIONS(4438),
    [aux_sym_preproc_else_token1] = ACTIONS(4438),
    [aux_sym_preproc_elif_token1] = ACTIONS(4438),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3931] = {
    [sym_preproc_region] = STATE(3931),
    [sym_preproc_endregion] = STATE(3931),
    [sym_preproc_line] = STATE(3931),
    [sym_preproc_pragma] = STATE(3931),
    [sym_preproc_nullable] = STATE(3931),
    [sym_preproc_error] = STATE(3931),
    [sym_preproc_define] = STATE(3931),
    [sym_preproc_undef] = STATE(3931),
    [anon_sym_SEMI] = ACTIONS(4434),
    [anon_sym_LBRACK] = ACTIONS(4434),
    [anon_sym_COLON] = ACTIONS(4434),
    [anon_sym_COMMA] = ACTIONS(4434),
    [anon_sym_RBRACK] = ACTIONS(4434),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [anon_sym_RPAREN] = ACTIONS(4434),
    [anon_sym_LBRACE] = ACTIONS(4434),
    [anon_sym_RBRACE] = ACTIONS(4434),
    [anon_sym_LT] = ACTIONS(4432),
    [anon_sym_GT] = ACTIONS(4432),
    [anon_sym_in] = ACTIONS(4432),
    [anon_sym_QMARK] = ACTIONS(4432),
    [anon_sym_BANG] = ACTIONS(4432),
    [anon_sym_PLUS_PLUS] = ACTIONS(4434),
    [anon_sym_DASH_DASH] = ACTIONS(4434),
    [anon_sym_PLUS] = ACTIONS(4432),
    [anon_sym_DASH] = ACTIONS(4432),
    [anon_sym_STAR] = ACTIONS(4434),
    [anon_sym_SLASH] = ACTIONS(4432),
    [anon_sym_PERCENT] = ACTIONS(4434),
    [anon_sym_CARET] = ACTIONS(4434),
    [anon_sym_PIPE] = ACTIONS(4432),
    [anon_sym_AMP] = ACTIONS(4432),
    [anon_sym_LT_LT] = ACTIONS(4434),
    [anon_sym_GT_GT] = ACTIONS(4432),
    [anon_sym_GT_GT_GT] = ACTIONS(4434),
    [anon_sym_EQ_EQ] = ACTIONS(4434),
    [anon_sym_BANG_EQ] = ACTIONS(4434),
    [anon_sym_GT_EQ] = ACTIONS(4434),
    [anon_sym_LT_EQ] = ACTIONS(4434),
    [anon_sym_DOT] = ACTIONS(4432),
    [anon_sym_EQ_GT] = ACTIONS(4434),
    [anon_sym_switch] = ACTIONS(4434),
    [anon_sym_when] = ACTIONS(4434),
    [anon_sym_DOT_DOT] = ACTIONS(4434),
    [anon_sym_and] = ACTIONS(4434),
    [anon_sym_or] = ACTIONS(4434),
    [anon_sym_AMP_AMP] = ACTIONS(4434),
    [anon_sym_PIPE_PIPE] = ACTIONS(4434),
    [anon_sym_QMARK_QMARK] = ACTIONS(4434),
    [anon_sym_into] = ACTIONS(4434),
    [anon_sym_on] = ACTIONS(4434),
    [anon_sym_equals] = ACTIONS(4434),
    [anon_sym_by] = ACTIONS(4434),
    [anon_sym_as] = ACTIONS(4434),
    [anon_sym_is] = ACTIONS(4434),
    [anon_sym_DASH_GT] = ACTIONS(4434),
    [anon_sym_with] = ACTIONS(4434),
    [aux_sym_preproc_if_token3] = ACTIONS(4434),
    [aux_sym_preproc_else_token1] = ACTIONS(4434),
    [aux_sym_preproc_elif_token1] = ACTIONS(4434),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3932] = {
    [sym_preproc_region] = STATE(3932),
    [sym_preproc_endregion] = STATE(3932),
    [sym_preproc_line] = STATE(3932),
    [sym_preproc_pragma] = STATE(3932),
    [sym_preproc_nullable] = STATE(3932),
    [sym_preproc_error] = STATE(3932),
    [sym_preproc_define] = STATE(3932),
    [sym_preproc_undef] = STATE(3932),
    [anon_sym_SEMI] = ACTIONS(4480),
    [anon_sym_LBRACK] = ACTIONS(4480),
    [anon_sym_COLON] = ACTIONS(4480),
    [anon_sym_COMMA] = ACTIONS(4480),
    [anon_sym_RBRACK] = ACTIONS(4480),
    [anon_sym_LPAREN] = ACTIONS(4480),
    [anon_sym_RPAREN] = ACTIONS(4480),
    [anon_sym_LBRACE] = ACTIONS(4480),
    [anon_sym_RBRACE] = ACTIONS(4480),
    [anon_sym_LT] = ACTIONS(4478),
    [anon_sym_GT] = ACTIONS(4478),
    [anon_sym_in] = ACTIONS(4478),
    [anon_sym_QMARK] = ACTIONS(4478),
    [anon_sym_BANG] = ACTIONS(4478),
    [anon_sym_PLUS_PLUS] = ACTIONS(4480),
    [anon_sym_DASH_DASH] = ACTIONS(4480),
    [anon_sym_PLUS] = ACTIONS(4478),
    [anon_sym_DASH] = ACTIONS(4478),
    [anon_sym_STAR] = ACTIONS(4480),
    [anon_sym_SLASH] = ACTIONS(4478),
    [anon_sym_PERCENT] = ACTIONS(4480),
    [anon_sym_CARET] = ACTIONS(4480),
    [anon_sym_PIPE] = ACTIONS(4478),
    [anon_sym_AMP] = ACTIONS(4478),
    [anon_sym_LT_LT] = ACTIONS(4480),
    [anon_sym_GT_GT] = ACTIONS(4478),
    [anon_sym_GT_GT_GT] = ACTIONS(4480),
    [anon_sym_EQ_EQ] = ACTIONS(4480),
    [anon_sym_BANG_EQ] = ACTIONS(4480),
    [anon_sym_GT_EQ] = ACTIONS(4480),
    [anon_sym_LT_EQ] = ACTIONS(4480),
    [anon_sym_DOT] = ACTIONS(4478),
    [anon_sym_EQ_GT] = ACTIONS(4480),
    [anon_sym_switch] = ACTIONS(4480),
    [anon_sym_when] = ACTIONS(4480),
    [anon_sym_DOT_DOT] = ACTIONS(4480),
    [anon_sym_and] = ACTIONS(4480),
    [anon_sym_or] = ACTIONS(4480),
    [anon_sym_AMP_AMP] = ACTIONS(4480),
    [anon_sym_PIPE_PIPE] = ACTIONS(4480),
    [anon_sym_QMARK_QMARK] = ACTIONS(4480),
    [anon_sym_into] = ACTIONS(4480),
    [anon_sym_on] = ACTIONS(4480),
    [anon_sym_equals] = ACTIONS(4480),
    [anon_sym_by] = ACTIONS(4480),
    [anon_sym_as] = ACTIONS(4480),
    [anon_sym_is] = ACTIONS(4480),
    [anon_sym_DASH_GT] = ACTIONS(4480),
    [anon_sym_with] = ACTIONS(4480),
    [aux_sym_preproc_if_token3] = ACTIONS(4480),
    [aux_sym_preproc_else_token1] = ACTIONS(4480),
    [aux_sym_preproc_elif_token1] = ACTIONS(4480),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3933] = {
    [sym_preproc_region] = STATE(3933),
    [sym_preproc_endregion] = STATE(3933),
    [sym_preproc_line] = STATE(3933),
    [sym_preproc_pragma] = STATE(3933),
    [sym_preproc_nullable] = STATE(3933),
    [sym_preproc_error] = STATE(3933),
    [sym_preproc_define] = STATE(3933),
    [sym_preproc_undef] = STATE(3933),
    [anon_sym_SEMI] = ACTIONS(5319),
    [anon_sym_LBRACK] = ACTIONS(5319),
    [anon_sym_COLON] = ACTIONS(5319),
    [anon_sym_COMMA] = ACTIONS(5319),
    [anon_sym_RBRACK] = ACTIONS(5319),
    [anon_sym_LPAREN] = ACTIONS(5319),
    [anon_sym_RPAREN] = ACTIONS(5319),
    [anon_sym_RBRACE] = ACTIONS(5319),
    [anon_sym_LT] = ACTIONS(5321),
    [anon_sym_GT] = ACTIONS(5321),
    [anon_sym_in] = ACTIONS(5319),
    [anon_sym_QMARK] = ACTIONS(5321),
    [anon_sym_BANG] = ACTIONS(5321),
    [anon_sym_PLUS_PLUS] = ACTIONS(5319),
    [anon_sym_DASH_DASH] = ACTIONS(5319),
    [anon_sym_PLUS] = ACTIONS(5321),
    [anon_sym_DASH] = ACTIONS(5321),
    [anon_sym_STAR] = ACTIONS(5319),
    [anon_sym_SLASH] = ACTIONS(5321),
    [anon_sym_PERCENT] = ACTIONS(5319),
    [anon_sym_CARET] = ACTIONS(5319),
    [anon_sym_PIPE] = ACTIONS(5321),
    [anon_sym_AMP] = ACTIONS(5321),
    [anon_sym_LT_LT] = ACTIONS(5319),
    [anon_sym_GT_GT] = ACTIONS(5321),
    [anon_sym_GT_GT_GT] = ACTIONS(5319),
    [anon_sym_EQ_EQ] = ACTIONS(5319),
    [anon_sym_BANG_EQ] = ACTIONS(5319),
    [anon_sym_GT_EQ] = ACTIONS(5319),
    [anon_sym_LT_EQ] = ACTIONS(5319),
    [anon_sym_DOT] = ACTIONS(5321),
    [anon_sym_EQ_GT] = ACTIONS(5319),
    [anon_sym_switch] = ACTIONS(5319),
    [anon_sym_when] = ACTIONS(5319),
    [anon_sym_DOT_DOT] = ACTIONS(5319),
    [anon_sym_and] = ACTIONS(5319),
    [anon_sym_or] = ACTIONS(5319),
    [anon_sym_AMP_AMP] = ACTIONS(5319),
    [anon_sym_PIPE_PIPE] = ACTIONS(5319),
    [anon_sym_QMARK_QMARK] = ACTIONS(5319),
    [anon_sym_on] = ACTIONS(5319),
    [anon_sym_equals] = ACTIONS(5319),
    [anon_sym_by] = ACTIONS(5319),
    [anon_sym_as] = ACTIONS(5319),
    [anon_sym_is] = ACTIONS(5319),
    [anon_sym_DQUOTE] = ACTIONS(5319),
    [anon_sym_DASH_GT] = ACTIONS(5319),
    [anon_sym_with] = ACTIONS(5319),
    [aux_sym_preproc_if_token3] = ACTIONS(5319),
    [aux_sym_preproc_else_token1] = ACTIONS(5319),
    [aux_sym_preproc_elif_token1] = ACTIONS(5319),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3934] = {
    [sym_preproc_region] = STATE(3934),
    [sym_preproc_endregion] = STATE(3934),
    [sym_preproc_line] = STATE(3934),
    [sym_preproc_pragma] = STATE(3934),
    [sym_preproc_nullable] = STATE(3934),
    [sym_preproc_error] = STATE(3934),
    [sym_preproc_define] = STATE(3934),
    [sym_preproc_undef] = STATE(3934),
    [anon_sym_SEMI] = ACTIONS(5385),
    [anon_sym_LBRACK] = ACTIONS(5385),
    [anon_sym_COLON] = ACTIONS(5385),
    [anon_sym_COMMA] = ACTIONS(5385),
    [anon_sym_RBRACK] = ACTIONS(5385),
    [anon_sym_LPAREN] = ACTIONS(5385),
    [anon_sym_RPAREN] = ACTIONS(5385),
    [anon_sym_RBRACE] = ACTIONS(5385),
    [anon_sym_LT] = ACTIONS(5387),
    [anon_sym_GT] = ACTIONS(5387),
    [anon_sym_in] = ACTIONS(5387),
    [anon_sym_QMARK] = ACTIONS(5387),
    [anon_sym_BANG] = ACTIONS(5387),
    [anon_sym_PLUS_PLUS] = ACTIONS(5385),
    [anon_sym_DASH_DASH] = ACTIONS(5385),
    [anon_sym_PLUS] = ACTIONS(5387),
    [anon_sym_DASH] = ACTIONS(5387),
    [anon_sym_STAR] = ACTIONS(5385),
    [anon_sym_SLASH] = ACTIONS(5387),
    [anon_sym_PERCENT] = ACTIONS(5385),
    [anon_sym_CARET] = ACTIONS(5385),
    [anon_sym_PIPE] = ACTIONS(5387),
    [anon_sym_AMP] = ACTIONS(5387),
    [anon_sym_LT_LT] = ACTIONS(5385),
    [anon_sym_GT_GT] = ACTIONS(5387),
    [anon_sym_GT_GT_GT] = ACTIONS(5385),
    [anon_sym_EQ_EQ] = ACTIONS(5385),
    [anon_sym_BANG_EQ] = ACTIONS(5385),
    [anon_sym_GT_EQ] = ACTIONS(5385),
    [anon_sym_LT_EQ] = ACTIONS(5385),
    [anon_sym_DOT] = ACTIONS(5387),
    [anon_sym_EQ_GT] = ACTIONS(5385),
    [anon_sym_switch] = ACTIONS(5385),
    [anon_sym_when] = ACTIONS(5385),
    [anon_sym_DOT_DOT] = ACTIONS(5385),
    [anon_sym_and] = ACTIONS(5385),
    [anon_sym_or] = ACTIONS(5385),
    [anon_sym_AMP_AMP] = ACTIONS(5385),
    [anon_sym_PIPE_PIPE] = ACTIONS(5385),
    [anon_sym_QMARK_QMARK] = ACTIONS(5385),
    [anon_sym_into] = ACTIONS(5385),
    [anon_sym_on] = ACTIONS(5385),
    [anon_sym_equals] = ACTIONS(5385),
    [anon_sym_by] = ACTIONS(5385),
    [anon_sym_as] = ACTIONS(5385),
    [anon_sym_is] = ACTIONS(5385),
    [anon_sym_DASH_GT] = ACTIONS(5385),
    [anon_sym_with] = ACTIONS(5385),
    [aux_sym_preproc_if_token3] = ACTIONS(5385),
    [aux_sym_preproc_else_token1] = ACTIONS(5385),
    [aux_sym_preproc_elif_token1] = ACTIONS(5385),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3935] = {
    [sym_preproc_region] = STATE(3935),
    [sym_preproc_endregion] = STATE(3935),
    [sym_preproc_line] = STATE(3935),
    [sym_preproc_pragma] = STATE(3935),
    [sym_preproc_nullable] = STATE(3935),
    [sym_preproc_error] = STATE(3935),
    [sym_preproc_define] = STATE(3935),
    [sym_preproc_undef] = STATE(3935),
    [anon_sym_SEMI] = ACTIONS(5319),
    [anon_sym_LBRACK] = ACTIONS(5319),
    [anon_sym_COLON] = ACTIONS(5319),
    [anon_sym_COMMA] = ACTIONS(5319),
    [anon_sym_RBRACK] = ACTIONS(5319),
    [anon_sym_LPAREN] = ACTIONS(5319),
    [anon_sym_RPAREN] = ACTIONS(5319),
    [anon_sym_RBRACE] = ACTIONS(5319),
    [anon_sym_LT] = ACTIONS(5321),
    [anon_sym_GT] = ACTIONS(5321),
    [anon_sym_in] = ACTIONS(5321),
    [anon_sym_QMARK] = ACTIONS(5321),
    [anon_sym_BANG] = ACTIONS(5321),
    [anon_sym_PLUS_PLUS] = ACTIONS(5319),
    [anon_sym_DASH_DASH] = ACTIONS(5319),
    [anon_sym_PLUS] = ACTIONS(5321),
    [anon_sym_DASH] = ACTIONS(5321),
    [anon_sym_STAR] = ACTIONS(5319),
    [anon_sym_SLASH] = ACTIONS(5321),
    [anon_sym_PERCENT] = ACTIONS(5319),
    [anon_sym_CARET] = ACTIONS(5319),
    [anon_sym_PIPE] = ACTIONS(5321),
    [anon_sym_AMP] = ACTIONS(5321),
    [anon_sym_LT_LT] = ACTIONS(5319),
    [anon_sym_GT_GT] = ACTIONS(5321),
    [anon_sym_GT_GT_GT] = ACTIONS(5319),
    [anon_sym_EQ_EQ] = ACTIONS(5319),
    [anon_sym_BANG_EQ] = ACTIONS(5319),
    [anon_sym_GT_EQ] = ACTIONS(5319),
    [anon_sym_LT_EQ] = ACTIONS(5319),
    [anon_sym_DOT] = ACTIONS(5321),
    [anon_sym_EQ_GT] = ACTIONS(5319),
    [anon_sym_switch] = ACTIONS(5319),
    [anon_sym_when] = ACTIONS(5319),
    [anon_sym_DOT_DOT] = ACTIONS(5319),
    [anon_sym_and] = ACTIONS(5319),
    [anon_sym_or] = ACTIONS(5319),
    [anon_sym_AMP_AMP] = ACTIONS(5319),
    [anon_sym_PIPE_PIPE] = ACTIONS(5319),
    [anon_sym_QMARK_QMARK] = ACTIONS(5319),
    [anon_sym_into] = ACTIONS(5319),
    [anon_sym_on] = ACTIONS(5319),
    [anon_sym_equals] = ACTIONS(5319),
    [anon_sym_by] = ACTIONS(5319),
    [anon_sym_as] = ACTIONS(5319),
    [anon_sym_is] = ACTIONS(5319),
    [anon_sym_DASH_GT] = ACTIONS(5319),
    [anon_sym_with] = ACTIONS(5319),
    [aux_sym_preproc_if_token3] = ACTIONS(5319),
    [aux_sym_preproc_else_token1] = ACTIONS(5319),
    [aux_sym_preproc_elif_token1] = ACTIONS(5319),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3936] = {
    [sym_preproc_region] = STATE(3936),
    [sym_preproc_endregion] = STATE(3936),
    [sym_preproc_line] = STATE(3936),
    [sym_preproc_pragma] = STATE(3936),
    [sym_preproc_nullable] = STATE(3936),
    [sym_preproc_error] = STATE(3936),
    [sym_preproc_define] = STATE(3936),
    [sym_preproc_undef] = STATE(3936),
    [anon_sym_SEMI] = ACTIONS(4566),
    [anon_sym_LBRACK] = ACTIONS(4566),
    [anon_sym_COLON] = ACTIONS(4566),
    [anon_sym_COMMA] = ACTIONS(4566),
    [anon_sym_RBRACK] = ACTIONS(4566),
    [anon_sym_LPAREN] = ACTIONS(4566),
    [anon_sym_RPAREN] = ACTIONS(4566),
    [anon_sym_LBRACE] = ACTIONS(4566),
    [anon_sym_RBRACE] = ACTIONS(4566),
    [anon_sym_LT] = ACTIONS(4564),
    [anon_sym_GT] = ACTIONS(4564),
    [anon_sym_in] = ACTIONS(4566),
    [anon_sym_QMARK] = ACTIONS(4564),
    [anon_sym_BANG] = ACTIONS(4564),
    [anon_sym_PLUS_PLUS] = ACTIONS(4566),
    [anon_sym_DASH_DASH] = ACTIONS(4566),
    [anon_sym_PLUS] = ACTIONS(4564),
    [anon_sym_DASH] = ACTIONS(4564),
    [anon_sym_STAR] = ACTIONS(4566),
    [anon_sym_SLASH] = ACTIONS(4564),
    [anon_sym_PERCENT] = ACTIONS(4566),
    [anon_sym_CARET] = ACTIONS(4566),
    [anon_sym_PIPE] = ACTIONS(4564),
    [anon_sym_AMP] = ACTIONS(4564),
    [anon_sym_LT_LT] = ACTIONS(4566),
    [anon_sym_GT_GT] = ACTIONS(4564),
    [anon_sym_GT_GT_GT] = ACTIONS(4566),
    [anon_sym_EQ_EQ] = ACTIONS(4566),
    [anon_sym_BANG_EQ] = ACTIONS(4566),
    [anon_sym_GT_EQ] = ACTIONS(4566),
    [anon_sym_LT_EQ] = ACTIONS(4566),
    [anon_sym_DOT] = ACTIONS(4564),
    [anon_sym_EQ_GT] = ACTIONS(4566),
    [anon_sym_switch] = ACTIONS(4566),
    [anon_sym_when] = ACTIONS(4566),
    [anon_sym_DOT_DOT] = ACTIONS(4566),
    [anon_sym_and] = ACTIONS(4566),
    [anon_sym_or] = ACTIONS(4566),
    [anon_sym_AMP_AMP] = ACTIONS(4566),
    [anon_sym_PIPE_PIPE] = ACTIONS(4566),
    [anon_sym_QMARK_QMARK] = ACTIONS(4566),
    [anon_sym_on] = ACTIONS(4566),
    [anon_sym_equals] = ACTIONS(4566),
    [anon_sym_by] = ACTIONS(4566),
    [anon_sym_as] = ACTIONS(4566),
    [anon_sym_is] = ACTIONS(4566),
    [anon_sym_DASH_GT] = ACTIONS(4566),
    [anon_sym_with] = ACTIONS(4566),
    [aux_sym_preproc_if_token3] = ACTIONS(4566),
    [aux_sym_preproc_else_token1] = ACTIONS(4566),
    [aux_sym_preproc_elif_token1] = ACTIONS(4566),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3937] = {
    [sym_preproc_region] = STATE(3937),
    [sym_preproc_endregion] = STATE(3937),
    [sym_preproc_line] = STATE(3937),
    [sym_preproc_pragma] = STATE(3937),
    [sym_preproc_nullable] = STATE(3937),
    [sym_preproc_error] = STATE(3937),
    [sym_preproc_define] = STATE(3937),
    [sym_preproc_undef] = STATE(3937),
    [anon_sym_SEMI] = ACTIONS(4424),
    [anon_sym_LBRACK] = ACTIONS(4547),
    [anon_sym_COLON] = ACTIONS(4424),
    [anon_sym_COMMA] = ACTIONS(4424),
    [anon_sym_RBRACK] = ACTIONS(4424),
    [anon_sym_LPAREN] = ACTIONS(4424),
    [anon_sym_RPAREN] = ACTIONS(4424),
    [anon_sym_LBRACE] = ACTIONS(4424),
    [anon_sym_RBRACE] = ACTIONS(4424),
    [anon_sym_LT] = ACTIONS(4422),
    [anon_sym_GT] = ACTIONS(4422),
    [anon_sym_in] = ACTIONS(4424),
    [anon_sym_QMARK] = ACTIONS(4422),
    [anon_sym_BANG] = ACTIONS(4422),
    [anon_sym_PLUS_PLUS] = ACTIONS(4424),
    [anon_sym_DASH_DASH] = ACTIONS(4424),
    [anon_sym_PLUS] = ACTIONS(4422),
    [anon_sym_DASH] = ACTIONS(4422),
    [anon_sym_STAR] = ACTIONS(4553),
    [anon_sym_SLASH] = ACTIONS(4422),
    [anon_sym_PERCENT] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4424),
    [anon_sym_PIPE] = ACTIONS(4422),
    [anon_sym_AMP] = ACTIONS(4422),
    [anon_sym_LT_LT] = ACTIONS(4424),
    [anon_sym_GT_GT] = ACTIONS(4422),
    [anon_sym_GT_GT_GT] = ACTIONS(4424),
    [anon_sym_EQ_EQ] = ACTIONS(4424),
    [anon_sym_BANG_EQ] = ACTIONS(4424),
    [anon_sym_GT_EQ] = ACTIONS(4424),
    [anon_sym_LT_EQ] = ACTIONS(4424),
    [anon_sym_DOT] = ACTIONS(4422),
    [anon_sym_EQ_GT] = ACTIONS(4424),
    [anon_sym_switch] = ACTIONS(4424),
    [anon_sym_when] = ACTIONS(4424),
    [anon_sym_DOT_DOT] = ACTIONS(4424),
    [anon_sym_and] = ACTIONS(4424),
    [anon_sym_or] = ACTIONS(4424),
    [anon_sym_AMP_AMP] = ACTIONS(4424),
    [anon_sym_PIPE_PIPE] = ACTIONS(4424),
    [anon_sym_QMARK_QMARK] = ACTIONS(4424),
    [anon_sym_on] = ACTIONS(4424),
    [anon_sym_equals] = ACTIONS(4424),
    [anon_sym_by] = ACTIONS(4424),
    [anon_sym_as] = ACTIONS(4424),
    [anon_sym_is] = ACTIONS(4424),
    [anon_sym_DASH_GT] = ACTIONS(4424),
    [anon_sym_with] = ACTIONS(4424),
    [aux_sym_preproc_if_token3] = ACTIONS(4424),
    [aux_sym_preproc_else_token1] = ACTIONS(4424),
    [aux_sym_preproc_elif_token1] = ACTIONS(4424),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3938] = {
    [sym_preproc_region] = STATE(3938),
    [sym_preproc_endregion] = STATE(3938),
    [sym_preproc_line] = STATE(3938),
    [sym_preproc_pragma] = STATE(3938),
    [sym_preproc_nullable] = STATE(3938),
    [sym_preproc_error] = STATE(3938),
    [sym_preproc_define] = STATE(3938),
    [sym_preproc_undef] = STATE(3938),
    [anon_sym_SEMI] = ACTIONS(5518),
    [anon_sym_LBRACK] = ACTIONS(5518),
    [anon_sym_COLON] = ACTIONS(5518),
    [anon_sym_COMMA] = ACTIONS(5518),
    [anon_sym_RBRACK] = ACTIONS(5518),
    [anon_sym_LPAREN] = ACTIONS(5518),
    [anon_sym_RPAREN] = ACTIONS(5518),
    [anon_sym_RBRACE] = ACTIONS(5518),
    [anon_sym_LT] = ACTIONS(5520),
    [anon_sym_GT] = ACTIONS(5520),
    [anon_sym_in] = ACTIONS(5520),
    [anon_sym_QMARK] = ACTIONS(5520),
    [anon_sym_BANG] = ACTIONS(5520),
    [anon_sym_PLUS_PLUS] = ACTIONS(5518),
    [anon_sym_DASH_DASH] = ACTIONS(5518),
    [anon_sym_PLUS] = ACTIONS(5520),
    [anon_sym_DASH] = ACTIONS(5520),
    [anon_sym_STAR] = ACTIONS(5518),
    [anon_sym_SLASH] = ACTIONS(5520),
    [anon_sym_PERCENT] = ACTIONS(5518),
    [anon_sym_CARET] = ACTIONS(5518),
    [anon_sym_PIPE] = ACTIONS(5520),
    [anon_sym_AMP] = ACTIONS(5520),
    [anon_sym_LT_LT] = ACTIONS(5518),
    [anon_sym_GT_GT] = ACTIONS(5520),
    [anon_sym_GT_GT_GT] = ACTIONS(5518),
    [anon_sym_EQ_EQ] = ACTIONS(5518),
    [anon_sym_BANG_EQ] = ACTIONS(5518),
    [anon_sym_GT_EQ] = ACTIONS(5518),
    [anon_sym_LT_EQ] = ACTIONS(5518),
    [anon_sym_DOT] = ACTIONS(5520),
    [anon_sym_EQ_GT] = ACTIONS(5518),
    [anon_sym_switch] = ACTIONS(5518),
    [anon_sym_when] = ACTIONS(5518),
    [anon_sym_DOT_DOT] = ACTIONS(5518),
    [anon_sym_and] = ACTIONS(5518),
    [anon_sym_or] = ACTIONS(5518),
    [anon_sym_AMP_AMP] = ACTIONS(5518),
    [anon_sym_PIPE_PIPE] = ACTIONS(5518),
    [anon_sym_QMARK_QMARK] = ACTIONS(5518),
    [anon_sym_into] = ACTIONS(5518),
    [anon_sym_on] = ACTIONS(5518),
    [anon_sym_equals] = ACTIONS(5518),
    [anon_sym_by] = ACTIONS(5518),
    [anon_sym_as] = ACTIONS(5518),
    [anon_sym_is] = ACTIONS(5518),
    [anon_sym_DASH_GT] = ACTIONS(5518),
    [anon_sym_with] = ACTIONS(5518),
    [aux_sym_preproc_if_token3] = ACTIONS(5518),
    [aux_sym_preproc_else_token1] = ACTIONS(5518),
    [aux_sym_preproc_elif_token1] = ACTIONS(5518),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3939] = {
    [sym_preproc_region] = STATE(3939),
    [sym_preproc_endregion] = STATE(3939),
    [sym_preproc_line] = STATE(3939),
    [sym_preproc_pragma] = STATE(3939),
    [sym_preproc_nullable] = STATE(3939),
    [sym_preproc_error] = STATE(3939),
    [sym_preproc_define] = STATE(3939),
    [sym_preproc_undef] = STATE(3939),
    [anon_sym_SEMI] = ACTIONS(5498),
    [anon_sym_LBRACK] = ACTIONS(5498),
    [anon_sym_COLON] = ACTIONS(5498),
    [anon_sym_COMMA] = ACTIONS(5498),
    [anon_sym_RBRACK] = ACTIONS(5498),
    [anon_sym_LPAREN] = ACTIONS(5498),
    [anon_sym_RPAREN] = ACTIONS(5498),
    [anon_sym_RBRACE] = ACTIONS(5498),
    [anon_sym_LT] = ACTIONS(5500),
    [anon_sym_GT] = ACTIONS(5500),
    [anon_sym_in] = ACTIONS(5500),
    [anon_sym_QMARK] = ACTIONS(5500),
    [anon_sym_BANG] = ACTIONS(5500),
    [anon_sym_PLUS_PLUS] = ACTIONS(5498),
    [anon_sym_DASH_DASH] = ACTIONS(5498),
    [anon_sym_PLUS] = ACTIONS(5500),
    [anon_sym_DASH] = ACTIONS(5500),
    [anon_sym_STAR] = ACTIONS(5498),
    [anon_sym_SLASH] = ACTIONS(5500),
    [anon_sym_PERCENT] = ACTIONS(5498),
    [anon_sym_CARET] = ACTIONS(5498),
    [anon_sym_PIPE] = ACTIONS(5500),
    [anon_sym_AMP] = ACTIONS(5500),
    [anon_sym_LT_LT] = ACTIONS(5498),
    [anon_sym_GT_GT] = ACTIONS(5500),
    [anon_sym_GT_GT_GT] = ACTIONS(5498),
    [anon_sym_EQ_EQ] = ACTIONS(5498),
    [anon_sym_BANG_EQ] = ACTIONS(5498),
    [anon_sym_GT_EQ] = ACTIONS(5498),
    [anon_sym_LT_EQ] = ACTIONS(5498),
    [anon_sym_DOT] = ACTIONS(5500),
    [anon_sym_EQ_GT] = ACTIONS(5498),
    [anon_sym_switch] = ACTIONS(5498),
    [anon_sym_when] = ACTIONS(5498),
    [anon_sym_DOT_DOT] = ACTIONS(5498),
    [anon_sym_and] = ACTIONS(5498),
    [anon_sym_or] = ACTIONS(5498),
    [anon_sym_AMP_AMP] = ACTIONS(5498),
    [anon_sym_PIPE_PIPE] = ACTIONS(5498),
    [anon_sym_QMARK_QMARK] = ACTIONS(5498),
    [anon_sym_into] = ACTIONS(5498),
    [anon_sym_on] = ACTIONS(5498),
    [anon_sym_equals] = ACTIONS(5498),
    [anon_sym_by] = ACTIONS(5498),
    [anon_sym_as] = ACTIONS(5498),
    [anon_sym_is] = ACTIONS(5498),
    [anon_sym_DASH_GT] = ACTIONS(5498),
    [anon_sym_with] = ACTIONS(5498),
    [aux_sym_preproc_if_token3] = ACTIONS(5498),
    [aux_sym_preproc_else_token1] = ACTIONS(5498),
    [aux_sym_preproc_elif_token1] = ACTIONS(5498),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3940] = {
    [sym_preproc_region] = STATE(3940),
    [sym_preproc_endregion] = STATE(3940),
    [sym_preproc_line] = STATE(3940),
    [sym_preproc_pragma] = STATE(3940),
    [sym_preproc_nullable] = STATE(3940),
    [sym_preproc_error] = STATE(3940),
    [sym_preproc_define] = STATE(3940),
    [sym_preproc_undef] = STATE(3940),
    [anon_sym_SEMI] = ACTIONS(5474),
    [anon_sym_LBRACK] = ACTIONS(5474),
    [anon_sym_COLON] = ACTIONS(5474),
    [anon_sym_COMMA] = ACTIONS(5474),
    [anon_sym_RBRACK] = ACTIONS(5474),
    [anon_sym_LPAREN] = ACTIONS(5474),
    [anon_sym_RPAREN] = ACTIONS(5474),
    [anon_sym_RBRACE] = ACTIONS(5474),
    [anon_sym_LT] = ACTIONS(5476),
    [anon_sym_GT] = ACTIONS(5476),
    [anon_sym_in] = ACTIONS(5476),
    [anon_sym_QMARK] = ACTIONS(5476),
    [anon_sym_BANG] = ACTIONS(5476),
    [anon_sym_PLUS_PLUS] = ACTIONS(5474),
    [anon_sym_DASH_DASH] = ACTIONS(5474),
    [anon_sym_PLUS] = ACTIONS(5476),
    [anon_sym_DASH] = ACTIONS(5476),
    [anon_sym_STAR] = ACTIONS(5474),
    [anon_sym_SLASH] = ACTIONS(5476),
    [anon_sym_PERCENT] = ACTIONS(5474),
    [anon_sym_CARET] = ACTIONS(5474),
    [anon_sym_PIPE] = ACTIONS(5476),
    [anon_sym_AMP] = ACTIONS(5476),
    [anon_sym_LT_LT] = ACTIONS(5474),
    [anon_sym_GT_GT] = ACTIONS(5476),
    [anon_sym_GT_GT_GT] = ACTIONS(5474),
    [anon_sym_EQ_EQ] = ACTIONS(5474),
    [anon_sym_BANG_EQ] = ACTIONS(5474),
    [anon_sym_GT_EQ] = ACTIONS(5474),
    [anon_sym_LT_EQ] = ACTIONS(5474),
    [anon_sym_DOT] = ACTIONS(5476),
    [anon_sym_EQ_GT] = ACTIONS(5474),
    [anon_sym_switch] = ACTIONS(5474),
    [anon_sym_when] = ACTIONS(5474),
    [anon_sym_DOT_DOT] = ACTIONS(5474),
    [anon_sym_and] = ACTIONS(5474),
    [anon_sym_or] = ACTIONS(5474),
    [anon_sym_AMP_AMP] = ACTIONS(5474),
    [anon_sym_PIPE_PIPE] = ACTIONS(5474),
    [anon_sym_QMARK_QMARK] = ACTIONS(5474),
    [anon_sym_into] = ACTIONS(5474),
    [anon_sym_on] = ACTIONS(5474),
    [anon_sym_equals] = ACTIONS(5474),
    [anon_sym_by] = ACTIONS(5474),
    [anon_sym_as] = ACTIONS(5474),
    [anon_sym_is] = ACTIONS(5474),
    [anon_sym_DASH_GT] = ACTIONS(5474),
    [anon_sym_with] = ACTIONS(5474),
    [aux_sym_preproc_if_token3] = ACTIONS(5474),
    [aux_sym_preproc_else_token1] = ACTIONS(5474),
    [aux_sym_preproc_elif_token1] = ACTIONS(5474),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3941] = {
    [sym_preproc_region] = STATE(3941),
    [sym_preproc_endregion] = STATE(3941),
    [sym_preproc_line] = STATE(3941),
    [sym_preproc_pragma] = STATE(3941),
    [sym_preproc_nullable] = STATE(3941),
    [sym_preproc_error] = STATE(3941),
    [sym_preproc_define] = STATE(3941),
    [sym_preproc_undef] = STATE(3941),
    [anon_sym_SEMI] = ACTIONS(5470),
    [anon_sym_LBRACK] = ACTIONS(5470),
    [anon_sym_COLON] = ACTIONS(5470),
    [anon_sym_COMMA] = ACTIONS(5470),
    [anon_sym_RBRACK] = ACTIONS(5470),
    [anon_sym_LPAREN] = ACTIONS(5470),
    [anon_sym_RPAREN] = ACTIONS(5470),
    [anon_sym_RBRACE] = ACTIONS(5470),
    [anon_sym_LT] = ACTIONS(5472),
    [anon_sym_GT] = ACTIONS(5472),
    [anon_sym_in] = ACTIONS(5472),
    [anon_sym_QMARK] = ACTIONS(5472),
    [anon_sym_BANG] = ACTIONS(5472),
    [anon_sym_PLUS_PLUS] = ACTIONS(5470),
    [anon_sym_DASH_DASH] = ACTIONS(5470),
    [anon_sym_PLUS] = ACTIONS(5472),
    [anon_sym_DASH] = ACTIONS(5472),
    [anon_sym_STAR] = ACTIONS(5470),
    [anon_sym_SLASH] = ACTIONS(5472),
    [anon_sym_PERCENT] = ACTIONS(5470),
    [anon_sym_CARET] = ACTIONS(5470),
    [anon_sym_PIPE] = ACTIONS(5472),
    [anon_sym_AMP] = ACTIONS(5472),
    [anon_sym_LT_LT] = ACTIONS(5470),
    [anon_sym_GT_GT] = ACTIONS(5472),
    [anon_sym_GT_GT_GT] = ACTIONS(5470),
    [anon_sym_EQ_EQ] = ACTIONS(5470),
    [anon_sym_BANG_EQ] = ACTIONS(5470),
    [anon_sym_GT_EQ] = ACTIONS(5470),
    [anon_sym_LT_EQ] = ACTIONS(5470),
    [anon_sym_DOT] = ACTIONS(5472),
    [anon_sym_EQ_GT] = ACTIONS(5470),
    [anon_sym_switch] = ACTIONS(5470),
    [anon_sym_when] = ACTIONS(5470),
    [anon_sym_DOT_DOT] = ACTIONS(5470),
    [anon_sym_and] = ACTIONS(5470),
    [anon_sym_or] = ACTIONS(5470),
    [anon_sym_AMP_AMP] = ACTIONS(5470),
    [anon_sym_PIPE_PIPE] = ACTIONS(5470),
    [anon_sym_QMARK_QMARK] = ACTIONS(5470),
    [anon_sym_into] = ACTIONS(5470),
    [anon_sym_on] = ACTIONS(5470),
    [anon_sym_equals] = ACTIONS(5470),
    [anon_sym_by] = ACTIONS(5470),
    [anon_sym_as] = ACTIONS(5470),
    [anon_sym_is] = ACTIONS(5470),
    [anon_sym_DASH_GT] = ACTIONS(5470),
    [anon_sym_with] = ACTIONS(5470),
    [aux_sym_preproc_if_token3] = ACTIONS(5470),
    [aux_sym_preproc_else_token1] = ACTIONS(5470),
    [aux_sym_preproc_elif_token1] = ACTIONS(5470),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3942] = {
    [sym_preproc_region] = STATE(3942),
    [sym_preproc_endregion] = STATE(3942),
    [sym_preproc_line] = STATE(3942),
    [sym_preproc_pragma] = STATE(3942),
    [sym_preproc_nullable] = STATE(3942),
    [sym_preproc_error] = STATE(3942),
    [sym_preproc_define] = STATE(3942),
    [sym_preproc_undef] = STATE(3942),
    [anon_sym_SEMI] = ACTIONS(5333),
    [anon_sym_LBRACK] = ACTIONS(5333),
    [anon_sym_COLON] = ACTIONS(5333),
    [anon_sym_COMMA] = ACTIONS(5333),
    [anon_sym_RBRACK] = ACTIONS(5333),
    [anon_sym_LPAREN] = ACTIONS(5333),
    [anon_sym_RPAREN] = ACTIONS(5333),
    [anon_sym_RBRACE] = ACTIONS(5333),
    [anon_sym_LT] = ACTIONS(5335),
    [anon_sym_GT] = ACTIONS(5335),
    [anon_sym_in] = ACTIONS(5335),
    [anon_sym_QMARK] = ACTIONS(5335),
    [anon_sym_BANG] = ACTIONS(5335),
    [anon_sym_PLUS_PLUS] = ACTIONS(5333),
    [anon_sym_DASH_DASH] = ACTIONS(5333),
    [anon_sym_PLUS] = ACTIONS(5335),
    [anon_sym_DASH] = ACTIONS(5335),
    [anon_sym_STAR] = ACTIONS(5333),
    [anon_sym_SLASH] = ACTIONS(5335),
    [anon_sym_PERCENT] = ACTIONS(5333),
    [anon_sym_CARET] = ACTIONS(5333),
    [anon_sym_PIPE] = ACTIONS(5335),
    [anon_sym_AMP] = ACTIONS(5335),
    [anon_sym_LT_LT] = ACTIONS(5333),
    [anon_sym_GT_GT] = ACTIONS(5335),
    [anon_sym_GT_GT_GT] = ACTIONS(5333),
    [anon_sym_EQ_EQ] = ACTIONS(5333),
    [anon_sym_BANG_EQ] = ACTIONS(5333),
    [anon_sym_GT_EQ] = ACTIONS(5333),
    [anon_sym_LT_EQ] = ACTIONS(5333),
    [anon_sym_DOT] = ACTIONS(5335),
    [anon_sym_EQ_GT] = ACTIONS(5333),
    [anon_sym_switch] = ACTIONS(5333),
    [anon_sym_when] = ACTIONS(5333),
    [anon_sym_DOT_DOT] = ACTIONS(5333),
    [anon_sym_and] = ACTIONS(5333),
    [anon_sym_or] = ACTIONS(5333),
    [anon_sym_AMP_AMP] = ACTIONS(5333),
    [anon_sym_PIPE_PIPE] = ACTIONS(5333),
    [anon_sym_QMARK_QMARK] = ACTIONS(5333),
    [anon_sym_into] = ACTIONS(5333),
    [anon_sym_on] = ACTIONS(5333),
    [anon_sym_equals] = ACTIONS(5333),
    [anon_sym_by] = ACTIONS(5333),
    [anon_sym_as] = ACTIONS(5333),
    [anon_sym_is] = ACTIONS(5333),
    [anon_sym_DASH_GT] = ACTIONS(5333),
    [anon_sym_with] = ACTIONS(5333),
    [aux_sym_preproc_if_token3] = ACTIONS(5333),
    [aux_sym_preproc_else_token1] = ACTIONS(5333),
    [aux_sym_preproc_elif_token1] = ACTIONS(5333),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3943] = {
    [sym_preproc_region] = STATE(3943),
    [sym_preproc_endregion] = STATE(3943),
    [sym_preproc_line] = STATE(3943),
    [sym_preproc_pragma] = STATE(3943),
    [sym_preproc_nullable] = STATE(3943),
    [sym_preproc_error] = STATE(3943),
    [sym_preproc_define] = STATE(3943),
    [sym_preproc_undef] = STATE(3943),
    [anon_sym_SEMI] = ACTIONS(5365),
    [anon_sym_LBRACK] = ACTIONS(5365),
    [anon_sym_COLON] = ACTIONS(5365),
    [anon_sym_COMMA] = ACTIONS(5365),
    [anon_sym_RBRACK] = ACTIONS(5365),
    [anon_sym_LPAREN] = ACTIONS(5365),
    [anon_sym_RPAREN] = ACTIONS(5365),
    [anon_sym_RBRACE] = ACTIONS(5365),
    [anon_sym_LT] = ACTIONS(5367),
    [anon_sym_GT] = ACTIONS(5367),
    [anon_sym_in] = ACTIONS(5367),
    [anon_sym_QMARK] = ACTIONS(5367),
    [anon_sym_BANG] = ACTIONS(5367),
    [anon_sym_PLUS_PLUS] = ACTIONS(5365),
    [anon_sym_DASH_DASH] = ACTIONS(5365),
    [anon_sym_PLUS] = ACTIONS(5367),
    [anon_sym_DASH] = ACTIONS(5367),
    [anon_sym_STAR] = ACTIONS(5365),
    [anon_sym_SLASH] = ACTIONS(5367),
    [anon_sym_PERCENT] = ACTIONS(5365),
    [anon_sym_CARET] = ACTIONS(5365),
    [anon_sym_PIPE] = ACTIONS(5367),
    [anon_sym_AMP] = ACTIONS(5367),
    [anon_sym_LT_LT] = ACTIONS(5365),
    [anon_sym_GT_GT] = ACTIONS(5367),
    [anon_sym_GT_GT_GT] = ACTIONS(5365),
    [anon_sym_EQ_EQ] = ACTIONS(5365),
    [anon_sym_BANG_EQ] = ACTIONS(5365),
    [anon_sym_GT_EQ] = ACTIONS(5365),
    [anon_sym_LT_EQ] = ACTIONS(5365),
    [anon_sym_DOT] = ACTIONS(5367),
    [anon_sym_EQ_GT] = ACTIONS(5365),
    [anon_sym_switch] = ACTIONS(5365),
    [anon_sym_when] = ACTIONS(5365),
    [anon_sym_DOT_DOT] = ACTIONS(5365),
    [anon_sym_and] = ACTIONS(5365),
    [anon_sym_or] = ACTIONS(5365),
    [anon_sym_AMP_AMP] = ACTIONS(5365),
    [anon_sym_PIPE_PIPE] = ACTIONS(5365),
    [anon_sym_QMARK_QMARK] = ACTIONS(5365),
    [anon_sym_into] = ACTIONS(5365),
    [anon_sym_on] = ACTIONS(5365),
    [anon_sym_equals] = ACTIONS(5365),
    [anon_sym_by] = ACTIONS(5365),
    [anon_sym_as] = ACTIONS(5365),
    [anon_sym_is] = ACTIONS(5365),
    [anon_sym_DASH_GT] = ACTIONS(5365),
    [anon_sym_with] = ACTIONS(5365),
    [aux_sym_preproc_if_token3] = ACTIONS(5365),
    [aux_sym_preproc_else_token1] = ACTIONS(5365),
    [aux_sym_preproc_elif_token1] = ACTIONS(5365),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3944] = {
    [sym_preproc_region] = STATE(3944),
    [sym_preproc_endregion] = STATE(3944),
    [sym_preproc_line] = STATE(3944),
    [sym_preproc_pragma] = STATE(3944),
    [sym_preproc_nullable] = STATE(3944),
    [sym_preproc_error] = STATE(3944),
    [sym_preproc_define] = STATE(3944),
    [sym_preproc_undef] = STATE(3944),
    [anon_sym_SEMI] = ACTIONS(5392),
    [anon_sym_LBRACK] = ACTIONS(5392),
    [anon_sym_COLON] = ACTIONS(5392),
    [anon_sym_COMMA] = ACTIONS(5392),
    [anon_sym_RBRACK] = ACTIONS(5392),
    [anon_sym_LPAREN] = ACTIONS(5392),
    [anon_sym_RPAREN] = ACTIONS(5392),
    [anon_sym_RBRACE] = ACTIONS(5392),
    [anon_sym_LT] = ACTIONS(5394),
    [anon_sym_GT] = ACTIONS(5394),
    [anon_sym_in] = ACTIONS(5394),
    [anon_sym_QMARK] = ACTIONS(5394),
    [anon_sym_BANG] = ACTIONS(5394),
    [anon_sym_PLUS_PLUS] = ACTIONS(5392),
    [anon_sym_DASH_DASH] = ACTIONS(5392),
    [anon_sym_PLUS] = ACTIONS(5394),
    [anon_sym_DASH] = ACTIONS(5394),
    [anon_sym_STAR] = ACTIONS(5392),
    [anon_sym_SLASH] = ACTIONS(5394),
    [anon_sym_PERCENT] = ACTIONS(5392),
    [anon_sym_CARET] = ACTIONS(5392),
    [anon_sym_PIPE] = ACTIONS(5394),
    [anon_sym_AMP] = ACTIONS(5394),
    [anon_sym_LT_LT] = ACTIONS(5392),
    [anon_sym_GT_GT] = ACTIONS(5394),
    [anon_sym_GT_GT_GT] = ACTIONS(5392),
    [anon_sym_EQ_EQ] = ACTIONS(5392),
    [anon_sym_BANG_EQ] = ACTIONS(5392),
    [anon_sym_GT_EQ] = ACTIONS(5392),
    [anon_sym_LT_EQ] = ACTIONS(5392),
    [anon_sym_DOT] = ACTIONS(5394),
    [anon_sym_EQ_GT] = ACTIONS(5392),
    [anon_sym_switch] = ACTIONS(5392),
    [anon_sym_when] = ACTIONS(5392),
    [anon_sym_DOT_DOT] = ACTIONS(5392),
    [anon_sym_and] = ACTIONS(5392),
    [anon_sym_or] = ACTIONS(5392),
    [anon_sym_AMP_AMP] = ACTIONS(5392),
    [anon_sym_PIPE_PIPE] = ACTIONS(5392),
    [anon_sym_QMARK_QMARK] = ACTIONS(5392),
    [anon_sym_into] = ACTIONS(5392),
    [anon_sym_on] = ACTIONS(5392),
    [anon_sym_equals] = ACTIONS(5392),
    [anon_sym_by] = ACTIONS(5392),
    [anon_sym_as] = ACTIONS(5392),
    [anon_sym_is] = ACTIONS(5392),
    [anon_sym_DASH_GT] = ACTIONS(5392),
    [anon_sym_with] = ACTIONS(5392),
    [aux_sym_preproc_if_token3] = ACTIONS(5392),
    [aux_sym_preproc_else_token1] = ACTIONS(5392),
    [aux_sym_preproc_elif_token1] = ACTIONS(5392),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3945] = {
    [sym_preproc_region] = STATE(3945),
    [sym_preproc_endregion] = STATE(3945),
    [sym_preproc_line] = STATE(3945),
    [sym_preproc_pragma] = STATE(3945),
    [sym_preproc_nullable] = STATE(3945),
    [sym_preproc_error] = STATE(3945),
    [sym_preproc_define] = STATE(3945),
    [sym_preproc_undef] = STATE(3945),
    [anon_sym_SEMI] = ACTIONS(4408),
    [anon_sym_LBRACK] = ACTIONS(4408),
    [anon_sym_COLON] = ACTIONS(4408),
    [anon_sym_COMMA] = ACTIONS(4408),
    [anon_sym_RBRACK] = ACTIONS(4408),
    [anon_sym_LPAREN] = ACTIONS(4408),
    [anon_sym_RPAREN] = ACTIONS(4408),
    [anon_sym_LBRACE] = ACTIONS(4408),
    [anon_sym_RBRACE] = ACTIONS(4408),
    [anon_sym_LT] = ACTIONS(4406),
    [anon_sym_GT] = ACTIONS(4406),
    [anon_sym_in] = ACTIONS(4408),
    [anon_sym_QMARK] = ACTIONS(4406),
    [anon_sym_BANG] = ACTIONS(4406),
    [anon_sym_PLUS_PLUS] = ACTIONS(4408),
    [anon_sym_DASH_DASH] = ACTIONS(4408),
    [anon_sym_PLUS] = ACTIONS(4406),
    [anon_sym_DASH] = ACTIONS(4406),
    [anon_sym_STAR] = ACTIONS(4408),
    [anon_sym_SLASH] = ACTIONS(4406),
    [anon_sym_PERCENT] = ACTIONS(4408),
    [anon_sym_CARET] = ACTIONS(4408),
    [anon_sym_PIPE] = ACTIONS(4406),
    [anon_sym_AMP] = ACTIONS(4406),
    [anon_sym_LT_LT] = ACTIONS(4408),
    [anon_sym_GT_GT] = ACTIONS(4406),
    [anon_sym_GT_GT_GT] = ACTIONS(4408),
    [anon_sym_EQ_EQ] = ACTIONS(4408),
    [anon_sym_BANG_EQ] = ACTIONS(4408),
    [anon_sym_GT_EQ] = ACTIONS(4408),
    [anon_sym_LT_EQ] = ACTIONS(4408),
    [anon_sym_DOT] = ACTIONS(4406),
    [anon_sym_EQ_GT] = ACTIONS(4408),
    [anon_sym_switch] = ACTIONS(4408),
    [anon_sym_when] = ACTIONS(4408),
    [anon_sym_DOT_DOT] = ACTIONS(4408),
    [anon_sym_and] = ACTIONS(4408),
    [anon_sym_or] = ACTIONS(4408),
    [anon_sym_AMP_AMP] = ACTIONS(4408),
    [anon_sym_PIPE_PIPE] = ACTIONS(4408),
    [anon_sym_QMARK_QMARK] = ACTIONS(4408),
    [anon_sym_on] = ACTIONS(4408),
    [anon_sym_equals] = ACTIONS(4408),
    [anon_sym_by] = ACTIONS(4408),
    [anon_sym_as] = ACTIONS(4408),
    [anon_sym_is] = ACTIONS(4408),
    [anon_sym_DASH_GT] = ACTIONS(4408),
    [anon_sym_with] = ACTIONS(4408),
    [aux_sym_preproc_if_token3] = ACTIONS(4408),
    [aux_sym_preproc_else_token1] = ACTIONS(4408),
    [aux_sym_preproc_elif_token1] = ACTIONS(4408),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3946] = {
    [sym_preproc_region] = STATE(3946),
    [sym_preproc_endregion] = STATE(3946),
    [sym_preproc_line] = STATE(3946),
    [sym_preproc_pragma] = STATE(3946),
    [sym_preproc_nullable] = STATE(3946),
    [sym_preproc_error] = STATE(3946),
    [sym_preproc_define] = STATE(3946),
    [sym_preproc_undef] = STATE(3946),
    [anon_sym_SEMI] = ACTIONS(4476),
    [anon_sym_LBRACK] = ACTIONS(4476),
    [anon_sym_COLON] = ACTIONS(4476),
    [anon_sym_COMMA] = ACTIONS(4476),
    [anon_sym_RBRACK] = ACTIONS(4476),
    [anon_sym_LPAREN] = ACTIONS(4476),
    [anon_sym_RPAREN] = ACTIONS(4476),
    [anon_sym_LBRACE] = ACTIONS(4476),
    [anon_sym_RBRACE] = ACTIONS(4476),
    [anon_sym_LT] = ACTIONS(4474),
    [anon_sym_GT] = ACTIONS(4474),
    [anon_sym_in] = ACTIONS(4476),
    [anon_sym_QMARK] = ACTIONS(4474),
    [anon_sym_BANG] = ACTIONS(4474),
    [anon_sym_PLUS_PLUS] = ACTIONS(4476),
    [anon_sym_DASH_DASH] = ACTIONS(4476),
    [anon_sym_PLUS] = ACTIONS(4474),
    [anon_sym_DASH] = ACTIONS(4474),
    [anon_sym_STAR] = ACTIONS(4476),
    [anon_sym_SLASH] = ACTIONS(4474),
    [anon_sym_PERCENT] = ACTIONS(4476),
    [anon_sym_CARET] = ACTIONS(4476),
    [anon_sym_PIPE] = ACTIONS(4474),
    [anon_sym_AMP] = ACTIONS(4474),
    [anon_sym_LT_LT] = ACTIONS(4476),
    [anon_sym_GT_GT] = ACTIONS(4474),
    [anon_sym_GT_GT_GT] = ACTIONS(4476),
    [anon_sym_EQ_EQ] = ACTIONS(4476),
    [anon_sym_BANG_EQ] = ACTIONS(4476),
    [anon_sym_GT_EQ] = ACTIONS(4476),
    [anon_sym_LT_EQ] = ACTIONS(4476),
    [anon_sym_DOT] = ACTIONS(4474),
    [anon_sym_EQ_GT] = ACTIONS(4476),
    [anon_sym_switch] = ACTIONS(4476),
    [anon_sym_when] = ACTIONS(4476),
    [anon_sym_DOT_DOT] = ACTIONS(4476),
    [anon_sym_and] = ACTIONS(4476),
    [anon_sym_or] = ACTIONS(4476),
    [anon_sym_AMP_AMP] = ACTIONS(4476),
    [anon_sym_PIPE_PIPE] = ACTIONS(4476),
    [anon_sym_QMARK_QMARK] = ACTIONS(4476),
    [anon_sym_on] = ACTIONS(4476),
    [anon_sym_equals] = ACTIONS(4476),
    [anon_sym_by] = ACTIONS(4476),
    [anon_sym_as] = ACTIONS(4476),
    [anon_sym_is] = ACTIONS(4476),
    [anon_sym_DASH_GT] = ACTIONS(4476),
    [anon_sym_with] = ACTIONS(4476),
    [aux_sym_preproc_if_token3] = ACTIONS(4476),
    [aux_sym_preproc_else_token1] = ACTIONS(4476),
    [aux_sym_preproc_elif_token1] = ACTIONS(4476),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3947] = {
    [sym_preproc_region] = STATE(3947),
    [sym_preproc_endregion] = STATE(3947),
    [sym_preproc_line] = STATE(3947),
    [sym_preproc_pragma] = STATE(3947),
    [sym_preproc_nullable] = STATE(3947),
    [sym_preproc_error] = STATE(3947),
    [sym_preproc_define] = STATE(3947),
    [sym_preproc_undef] = STATE(3947),
    [anon_sym_SEMI] = ACTIONS(4695),
    [anon_sym_LBRACK] = ACTIONS(4695),
    [anon_sym_COLON] = ACTIONS(4695),
    [anon_sym_COMMA] = ACTIONS(4695),
    [anon_sym_RBRACK] = ACTIONS(4695),
    [anon_sym_LPAREN] = ACTIONS(4695),
    [anon_sym_RPAREN] = ACTIONS(4695),
    [anon_sym_RBRACE] = ACTIONS(4695),
    [anon_sym_LT] = ACTIONS(4697),
    [anon_sym_GT] = ACTIONS(4697),
    [anon_sym_in] = ACTIONS(4697),
    [anon_sym_QMARK] = ACTIONS(4697),
    [anon_sym_BANG] = ACTIONS(4697),
    [anon_sym_PLUS_PLUS] = ACTIONS(4695),
    [anon_sym_DASH_DASH] = ACTIONS(4695),
    [anon_sym_PLUS] = ACTIONS(4697),
    [anon_sym_DASH] = ACTIONS(4697),
    [anon_sym_STAR] = ACTIONS(4695),
    [anon_sym_SLASH] = ACTIONS(4697),
    [anon_sym_PERCENT] = ACTIONS(4695),
    [anon_sym_CARET] = ACTIONS(4695),
    [anon_sym_PIPE] = ACTIONS(4697),
    [anon_sym_AMP] = ACTIONS(4697),
    [anon_sym_LT_LT] = ACTIONS(4695),
    [anon_sym_GT_GT] = ACTIONS(4697),
    [anon_sym_GT_GT_GT] = ACTIONS(4695),
    [anon_sym_EQ_EQ] = ACTIONS(4695),
    [anon_sym_BANG_EQ] = ACTIONS(4695),
    [anon_sym_GT_EQ] = ACTIONS(4695),
    [anon_sym_LT_EQ] = ACTIONS(4695),
    [anon_sym_DOT] = ACTIONS(4697),
    [anon_sym_EQ_GT] = ACTIONS(4695),
    [anon_sym_switch] = ACTIONS(4695),
    [anon_sym_when] = ACTIONS(4695),
    [anon_sym_DOT_DOT] = ACTIONS(4695),
    [anon_sym_and] = ACTIONS(4695),
    [anon_sym_or] = ACTIONS(4695),
    [anon_sym_AMP_AMP] = ACTIONS(4695),
    [anon_sym_PIPE_PIPE] = ACTIONS(4695),
    [anon_sym_QMARK_QMARK] = ACTIONS(4695),
    [anon_sym_into] = ACTIONS(4695),
    [anon_sym_on] = ACTIONS(4695),
    [anon_sym_equals] = ACTIONS(4695),
    [anon_sym_by] = ACTIONS(4695),
    [anon_sym_as] = ACTIONS(4695),
    [anon_sym_is] = ACTIONS(4695),
    [anon_sym_DASH_GT] = ACTIONS(4695),
    [anon_sym_with] = ACTIONS(4695),
    [aux_sym_preproc_if_token3] = ACTIONS(4695),
    [aux_sym_preproc_else_token1] = ACTIONS(4695),
    [aux_sym_preproc_elif_token1] = ACTIONS(4695),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3948] = {
    [sym_preproc_region] = STATE(3948),
    [sym_preproc_endregion] = STATE(3948),
    [sym_preproc_line] = STATE(3948),
    [sym_preproc_pragma] = STATE(3948),
    [sym_preproc_nullable] = STATE(3948),
    [sym_preproc_error] = STATE(3948),
    [sym_preproc_define] = STATE(3948),
    [sym_preproc_undef] = STATE(3948),
    [sym__identifier_token] = ACTIONS(3976),
    [anon_sym_extern] = ACTIONS(3976),
    [anon_sym_alias] = ACTIONS(3976),
    [anon_sym_global] = ACTIONS(3976),
    [anon_sym_unsafe] = ACTIONS(3976),
    [anon_sym_static] = ACTIONS(3976),
    [anon_sym_LPAREN] = ACTIONS(5756),
    [anon_sym_class] = ACTIONS(3976),
    [anon_sym_ref] = ACTIONS(3976),
    [anon_sym_struct] = ACTIONS(3976),
    [anon_sym_enum] = ACTIONS(3976),
    [anon_sym_interface] = ACTIONS(3976),
    [anon_sym_delegate] = ACTIONS(3976),
    [anon_sym_record] = ACTIONS(3976),
    [anon_sym_abstract] = ACTIONS(3976),
    [anon_sym_async] = ACTIONS(3976),
    [anon_sym_const] = ACTIONS(3976),
    [anon_sym_file] = ACTIONS(3976),
    [anon_sym_fixed] = ACTIONS(3976),
    [anon_sym_internal] = ACTIONS(3976),
    [anon_sym_new] = ACTIONS(3976),
    [anon_sym_override] = ACTIONS(3976),
    [anon_sym_partial] = ACTIONS(3976),
    [anon_sym_private] = ACTIONS(3976),
    [anon_sym_protected] = ACTIONS(3976),
    [anon_sym_public] = ACTIONS(3976),
    [anon_sym_readonly] = ACTIONS(3976),
    [anon_sym_required] = ACTIONS(3976),
    [anon_sym_sealed] = ACTIONS(3976),
    [anon_sym_virtual] = ACTIONS(3976),
    [anon_sym_volatile] = ACTIONS(3976),
    [anon_sym_where] = ACTIONS(3976),
    [anon_sym_notnull] = ACTIONS(3976),
    [anon_sym_unmanaged] = ACTIONS(3976),
    [anon_sym_scoped] = ACTIONS(3976),
    [anon_sym_var] = ACTIONS(3976),
    [sym_predefined_type] = ACTIONS(3976),
    [anon_sym_yield] = ACTIONS(3976),
    [anon_sym_when] = ACTIONS(3976),
    [anon_sym_from] = ACTIONS(3976),
    [anon_sym_into] = ACTIONS(3976),
    [anon_sym_join] = ACTIONS(3976),
    [anon_sym_on] = ACTIONS(3976),
    [anon_sym_equals] = ACTIONS(3976),
    [anon_sym_let] = ACTIONS(3976),
    [anon_sym_orderby] = ACTIONS(3976),
    [anon_sym_ascending] = ACTIONS(3976),
    [anon_sym_descending] = ACTIONS(3976),
    [anon_sym_group] = ACTIONS(3976),
    [anon_sym_by] = ACTIONS(3976),
    [anon_sym_select] = ACTIONS(3976),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3949] = {
    [sym_preproc_region] = STATE(3949),
    [sym_preproc_endregion] = STATE(3949),
    [sym_preproc_line] = STATE(3949),
    [sym_preproc_pragma] = STATE(3949),
    [sym_preproc_nullable] = STATE(3949),
    [sym_preproc_error] = STATE(3949),
    [sym_preproc_define] = STATE(3949),
    [sym_preproc_undef] = STATE(3949),
    [anon_sym_SEMI] = ACTIONS(5377),
    [anon_sym_LBRACK] = ACTIONS(5377),
    [anon_sym_COLON] = ACTIONS(5377),
    [anon_sym_COMMA] = ACTIONS(5377),
    [anon_sym_RBRACK] = ACTIONS(5377),
    [anon_sym_LPAREN] = ACTIONS(5377),
    [anon_sym_RPAREN] = ACTIONS(5377),
    [anon_sym_RBRACE] = ACTIONS(5377),
    [anon_sym_LT] = ACTIONS(5379),
    [anon_sym_GT] = ACTIONS(5379),
    [anon_sym_in] = ACTIONS(5379),
    [anon_sym_QMARK] = ACTIONS(5379),
    [anon_sym_BANG] = ACTIONS(5379),
    [anon_sym_PLUS_PLUS] = ACTIONS(5377),
    [anon_sym_DASH_DASH] = ACTIONS(5377),
    [anon_sym_PLUS] = ACTIONS(5379),
    [anon_sym_DASH] = ACTIONS(5379),
    [anon_sym_STAR] = ACTIONS(5377),
    [anon_sym_SLASH] = ACTIONS(5379),
    [anon_sym_PERCENT] = ACTIONS(5377),
    [anon_sym_CARET] = ACTIONS(5377),
    [anon_sym_PIPE] = ACTIONS(5379),
    [anon_sym_AMP] = ACTIONS(5379),
    [anon_sym_LT_LT] = ACTIONS(5377),
    [anon_sym_GT_GT] = ACTIONS(5379),
    [anon_sym_GT_GT_GT] = ACTIONS(5377),
    [anon_sym_EQ_EQ] = ACTIONS(5377),
    [anon_sym_BANG_EQ] = ACTIONS(5377),
    [anon_sym_GT_EQ] = ACTIONS(5377),
    [anon_sym_LT_EQ] = ACTIONS(5377),
    [anon_sym_DOT] = ACTIONS(5379),
    [anon_sym_EQ_GT] = ACTIONS(5377),
    [anon_sym_switch] = ACTIONS(5377),
    [anon_sym_when] = ACTIONS(5377),
    [anon_sym_DOT_DOT] = ACTIONS(5377),
    [anon_sym_and] = ACTIONS(5377),
    [anon_sym_or] = ACTIONS(5377),
    [anon_sym_AMP_AMP] = ACTIONS(5377),
    [anon_sym_PIPE_PIPE] = ACTIONS(5377),
    [anon_sym_QMARK_QMARK] = ACTIONS(5377),
    [anon_sym_into] = ACTIONS(5377),
    [anon_sym_on] = ACTIONS(5377),
    [anon_sym_equals] = ACTIONS(5377),
    [anon_sym_by] = ACTIONS(5377),
    [anon_sym_as] = ACTIONS(5377),
    [anon_sym_is] = ACTIONS(5377),
    [anon_sym_DASH_GT] = ACTIONS(5377),
    [anon_sym_with] = ACTIONS(5377),
    [aux_sym_preproc_if_token3] = ACTIONS(5377),
    [aux_sym_preproc_else_token1] = ACTIONS(5377),
    [aux_sym_preproc_elif_token1] = ACTIONS(5377),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3950] = {
    [sym_preproc_region] = STATE(3950),
    [sym_preproc_endregion] = STATE(3950),
    [sym_preproc_line] = STATE(3950),
    [sym_preproc_pragma] = STATE(3950),
    [sym_preproc_nullable] = STATE(3950),
    [sym_preproc_error] = STATE(3950),
    [sym_preproc_define] = STATE(3950),
    [sym_preproc_undef] = STATE(3950),
    [anon_sym_SEMI] = ACTIONS(4424),
    [anon_sym_LBRACK] = ACTIONS(4547),
    [anon_sym_COLON] = ACTIONS(4424),
    [anon_sym_COMMA] = ACTIONS(4424),
    [anon_sym_RBRACK] = ACTIONS(4424),
    [anon_sym_LPAREN] = ACTIONS(4424),
    [anon_sym_RPAREN] = ACTIONS(4424),
    [anon_sym_LBRACE] = ACTIONS(4424),
    [anon_sym_RBRACE] = ACTIONS(4424),
    [anon_sym_LT] = ACTIONS(4422),
    [anon_sym_GT] = ACTIONS(4422),
    [anon_sym_in] = ACTIONS(4424),
    [anon_sym_QMARK] = ACTIONS(5758),
    [anon_sym_BANG] = ACTIONS(4422),
    [anon_sym_PLUS_PLUS] = ACTIONS(4424),
    [anon_sym_DASH_DASH] = ACTIONS(4424),
    [anon_sym_PLUS] = ACTIONS(4422),
    [anon_sym_DASH] = ACTIONS(4422),
    [anon_sym_STAR] = ACTIONS(4424),
    [anon_sym_SLASH] = ACTIONS(4422),
    [anon_sym_PERCENT] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4424),
    [anon_sym_PIPE] = ACTIONS(4422),
    [anon_sym_AMP] = ACTIONS(4422),
    [anon_sym_LT_LT] = ACTIONS(4424),
    [anon_sym_GT_GT] = ACTIONS(4422),
    [anon_sym_GT_GT_GT] = ACTIONS(4424),
    [anon_sym_EQ_EQ] = ACTIONS(4424),
    [anon_sym_BANG_EQ] = ACTIONS(4424),
    [anon_sym_GT_EQ] = ACTIONS(4424),
    [anon_sym_LT_EQ] = ACTIONS(4424),
    [anon_sym_DOT] = ACTIONS(4422),
    [anon_sym_EQ_GT] = ACTIONS(4424),
    [anon_sym_switch] = ACTIONS(4424),
    [anon_sym_when] = ACTIONS(4424),
    [anon_sym_DOT_DOT] = ACTIONS(4424),
    [anon_sym_and] = ACTIONS(4424),
    [anon_sym_or] = ACTIONS(4424),
    [anon_sym_AMP_AMP] = ACTIONS(4424),
    [anon_sym_PIPE_PIPE] = ACTIONS(4424),
    [anon_sym_QMARK_QMARK] = ACTIONS(4424),
    [anon_sym_on] = ACTIONS(4424),
    [anon_sym_equals] = ACTIONS(4424),
    [anon_sym_by] = ACTIONS(4424),
    [anon_sym_as] = ACTIONS(4424),
    [anon_sym_is] = ACTIONS(4424),
    [anon_sym_DASH_GT] = ACTIONS(4424),
    [anon_sym_with] = ACTIONS(4424),
    [aux_sym_preproc_if_token3] = ACTIONS(4424),
    [aux_sym_preproc_else_token1] = ACTIONS(4424),
    [aux_sym_preproc_elif_token1] = ACTIONS(4424),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3951] = {
    [sym_preproc_region] = STATE(3951),
    [sym_preproc_endregion] = STATE(3951),
    [sym_preproc_line] = STATE(3951),
    [sym_preproc_pragma] = STATE(3951),
    [sym_preproc_nullable] = STATE(3951),
    [sym_preproc_error] = STATE(3951),
    [sym_preproc_define] = STATE(3951),
    [sym_preproc_undef] = STATE(3951),
    [anon_sym_SEMI] = ACTIONS(4389),
    [anon_sym_LBRACK] = ACTIONS(4389),
    [anon_sym_COLON] = ACTIONS(4389),
    [anon_sym_COMMA] = ACTIONS(4389),
    [anon_sym_RBRACK] = ACTIONS(4389),
    [anon_sym_LPAREN] = ACTIONS(4389),
    [anon_sym_RPAREN] = ACTIONS(4389),
    [anon_sym_LBRACE] = ACTIONS(4389),
    [anon_sym_RBRACE] = ACTIONS(4389),
    [anon_sym_LT] = ACTIONS(4387),
    [anon_sym_GT] = ACTIONS(4387),
    [anon_sym_in] = ACTIONS(4389),
    [anon_sym_QMARK] = ACTIONS(4387),
    [anon_sym_BANG] = ACTIONS(4387),
    [anon_sym_PLUS_PLUS] = ACTIONS(4389),
    [anon_sym_DASH_DASH] = ACTIONS(4389),
    [anon_sym_PLUS] = ACTIONS(4387),
    [anon_sym_DASH] = ACTIONS(4387),
    [anon_sym_STAR] = ACTIONS(4389),
    [anon_sym_SLASH] = ACTIONS(4387),
    [anon_sym_PERCENT] = ACTIONS(4389),
    [anon_sym_CARET] = ACTIONS(4389),
    [anon_sym_PIPE] = ACTIONS(4387),
    [anon_sym_AMP] = ACTIONS(4387),
    [anon_sym_LT_LT] = ACTIONS(4389),
    [anon_sym_GT_GT] = ACTIONS(4387),
    [anon_sym_GT_GT_GT] = ACTIONS(4389),
    [anon_sym_EQ_EQ] = ACTIONS(4389),
    [anon_sym_BANG_EQ] = ACTIONS(4389),
    [anon_sym_GT_EQ] = ACTIONS(4389),
    [anon_sym_LT_EQ] = ACTIONS(4389),
    [anon_sym_DOT] = ACTIONS(4387),
    [anon_sym_EQ_GT] = ACTIONS(4389),
    [anon_sym_switch] = ACTIONS(4389),
    [anon_sym_when] = ACTIONS(4389),
    [anon_sym_DOT_DOT] = ACTIONS(4389),
    [anon_sym_and] = ACTIONS(4389),
    [anon_sym_or] = ACTIONS(4389),
    [anon_sym_AMP_AMP] = ACTIONS(4389),
    [anon_sym_PIPE_PIPE] = ACTIONS(4389),
    [anon_sym_QMARK_QMARK] = ACTIONS(4389),
    [anon_sym_on] = ACTIONS(4389),
    [anon_sym_equals] = ACTIONS(4389),
    [anon_sym_by] = ACTIONS(4389),
    [anon_sym_as] = ACTIONS(4389),
    [anon_sym_is] = ACTIONS(4389),
    [anon_sym_DASH_GT] = ACTIONS(4389),
    [anon_sym_with] = ACTIONS(4389),
    [aux_sym_preproc_if_token3] = ACTIONS(4389),
    [aux_sym_preproc_else_token1] = ACTIONS(4389),
    [aux_sym_preproc_elif_token1] = ACTIONS(4389),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3952] = {
    [sym_preproc_region] = STATE(3952),
    [sym_preproc_endregion] = STATE(3952),
    [sym_preproc_line] = STATE(3952),
    [sym_preproc_pragma] = STATE(3952),
    [sym_preproc_nullable] = STATE(3952),
    [sym_preproc_error] = STATE(3952),
    [sym_preproc_define] = STATE(3952),
    [sym_preproc_undef] = STATE(3952),
    [anon_sym_SEMI] = ACTIONS(5761),
    [anon_sym_LBRACK] = ACTIONS(5761),
    [anon_sym_COLON] = ACTIONS(5761),
    [anon_sym_COMMA] = ACTIONS(5761),
    [anon_sym_RBRACK] = ACTIONS(5761),
    [anon_sym_LPAREN] = ACTIONS(5761),
    [anon_sym_RPAREN] = ACTIONS(5761),
    [anon_sym_RBRACE] = ACTIONS(5761),
    [anon_sym_LT] = ACTIONS(5763),
    [anon_sym_GT] = ACTIONS(5763),
    [anon_sym_in] = ACTIONS(5763),
    [anon_sym_QMARK] = ACTIONS(5763),
    [anon_sym_BANG] = ACTIONS(5763),
    [anon_sym_PLUS_PLUS] = ACTIONS(5761),
    [anon_sym_DASH_DASH] = ACTIONS(5761),
    [anon_sym_PLUS] = ACTIONS(5763),
    [anon_sym_DASH] = ACTIONS(5763),
    [anon_sym_STAR] = ACTIONS(5761),
    [anon_sym_SLASH] = ACTIONS(5763),
    [anon_sym_PERCENT] = ACTIONS(5761),
    [anon_sym_CARET] = ACTIONS(5761),
    [anon_sym_PIPE] = ACTIONS(5763),
    [anon_sym_AMP] = ACTIONS(5763),
    [anon_sym_LT_LT] = ACTIONS(5761),
    [anon_sym_GT_GT] = ACTIONS(5763),
    [anon_sym_GT_GT_GT] = ACTIONS(5761),
    [anon_sym_EQ_EQ] = ACTIONS(5761),
    [anon_sym_BANG_EQ] = ACTIONS(5761),
    [anon_sym_GT_EQ] = ACTIONS(5761),
    [anon_sym_LT_EQ] = ACTIONS(5761),
    [anon_sym_DOT] = ACTIONS(5763),
    [anon_sym_EQ_GT] = ACTIONS(5761),
    [anon_sym_switch] = ACTIONS(5761),
    [anon_sym_when] = ACTIONS(5761),
    [anon_sym_DOT_DOT] = ACTIONS(5761),
    [anon_sym_and] = ACTIONS(5761),
    [anon_sym_or] = ACTIONS(5761),
    [anon_sym_AMP_AMP] = ACTIONS(5761),
    [anon_sym_PIPE_PIPE] = ACTIONS(5761),
    [anon_sym_QMARK_QMARK] = ACTIONS(5761),
    [anon_sym_into] = ACTIONS(5761),
    [anon_sym_on] = ACTIONS(5761),
    [anon_sym_equals] = ACTIONS(5761),
    [anon_sym_by] = ACTIONS(5761),
    [anon_sym_as] = ACTIONS(5761),
    [anon_sym_is] = ACTIONS(5761),
    [anon_sym_DASH_GT] = ACTIONS(5761),
    [anon_sym_with] = ACTIONS(5761),
    [aux_sym_preproc_if_token3] = ACTIONS(5761),
    [aux_sym_preproc_else_token1] = ACTIONS(5761),
    [aux_sym_preproc_elif_token1] = ACTIONS(5761),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3953] = {
    [sym_preproc_region] = STATE(3953),
    [sym_preproc_endregion] = STATE(3953),
    [sym_preproc_line] = STATE(3953),
    [sym_preproc_pragma] = STATE(3953),
    [sym_preproc_nullable] = STATE(3953),
    [sym_preproc_error] = STATE(3953),
    [sym_preproc_define] = STATE(3953),
    [sym_preproc_undef] = STATE(3953),
    [anon_sym_SEMI] = ACTIONS(4404),
    [anon_sym_LBRACK] = ACTIONS(4404),
    [anon_sym_COLON] = ACTIONS(4404),
    [anon_sym_COMMA] = ACTIONS(4404),
    [anon_sym_RBRACK] = ACTIONS(4404),
    [anon_sym_LPAREN] = ACTIONS(4404),
    [anon_sym_RPAREN] = ACTIONS(4404),
    [anon_sym_LBRACE] = ACTIONS(4404),
    [anon_sym_RBRACE] = ACTIONS(4404),
    [anon_sym_LT] = ACTIONS(4402),
    [anon_sym_GT] = ACTIONS(4402),
    [anon_sym_in] = ACTIONS(4404),
    [anon_sym_QMARK] = ACTIONS(4402),
    [anon_sym_BANG] = ACTIONS(4402),
    [anon_sym_PLUS_PLUS] = ACTIONS(4404),
    [anon_sym_DASH_DASH] = ACTIONS(4404),
    [anon_sym_PLUS] = ACTIONS(4402),
    [anon_sym_DASH] = ACTIONS(4402),
    [anon_sym_STAR] = ACTIONS(4404),
    [anon_sym_SLASH] = ACTIONS(4402),
    [anon_sym_PERCENT] = ACTIONS(4404),
    [anon_sym_CARET] = ACTIONS(4404),
    [anon_sym_PIPE] = ACTIONS(4402),
    [anon_sym_AMP] = ACTIONS(4402),
    [anon_sym_LT_LT] = ACTIONS(4404),
    [anon_sym_GT_GT] = ACTIONS(4402),
    [anon_sym_GT_GT_GT] = ACTIONS(4404),
    [anon_sym_EQ_EQ] = ACTIONS(4404),
    [anon_sym_BANG_EQ] = ACTIONS(4404),
    [anon_sym_GT_EQ] = ACTIONS(4404),
    [anon_sym_LT_EQ] = ACTIONS(4404),
    [anon_sym_DOT] = ACTIONS(4402),
    [anon_sym_EQ_GT] = ACTIONS(4404),
    [anon_sym_switch] = ACTIONS(4404),
    [anon_sym_when] = ACTIONS(4404),
    [anon_sym_DOT_DOT] = ACTIONS(4404),
    [anon_sym_and] = ACTIONS(4404),
    [anon_sym_or] = ACTIONS(4404),
    [anon_sym_AMP_AMP] = ACTIONS(4404),
    [anon_sym_PIPE_PIPE] = ACTIONS(4404),
    [anon_sym_QMARK_QMARK] = ACTIONS(4404),
    [anon_sym_on] = ACTIONS(4404),
    [anon_sym_equals] = ACTIONS(4404),
    [anon_sym_by] = ACTIONS(4404),
    [anon_sym_as] = ACTIONS(4404),
    [anon_sym_is] = ACTIONS(4404),
    [anon_sym_DASH_GT] = ACTIONS(4404),
    [anon_sym_with] = ACTIONS(4404),
    [aux_sym_preproc_if_token3] = ACTIONS(4404),
    [aux_sym_preproc_else_token1] = ACTIONS(4404),
    [aux_sym_preproc_elif_token1] = ACTIONS(4404),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3954] = {
    [sym_preproc_region] = STATE(3954),
    [sym_preproc_endregion] = STATE(3954),
    [sym_preproc_line] = STATE(3954),
    [sym_preproc_pragma] = STATE(3954),
    [sym_preproc_nullable] = STATE(3954),
    [sym_preproc_error] = STATE(3954),
    [sym_preproc_define] = STATE(3954),
    [sym_preproc_undef] = STATE(3954),
    [anon_sym_SEMI] = ACTIONS(4424),
    [anon_sym_LBRACK] = ACTIONS(4424),
    [anon_sym_COLON] = ACTIONS(4424),
    [anon_sym_COMMA] = ACTIONS(4424),
    [anon_sym_RBRACK] = ACTIONS(4424),
    [anon_sym_LPAREN] = ACTIONS(4424),
    [anon_sym_RPAREN] = ACTIONS(4424),
    [anon_sym_LBRACE] = ACTIONS(4424),
    [anon_sym_RBRACE] = ACTIONS(4424),
    [anon_sym_LT] = ACTIONS(4422),
    [anon_sym_GT] = ACTIONS(4422),
    [anon_sym_in] = ACTIONS(4424),
    [anon_sym_QMARK] = ACTIONS(4422),
    [anon_sym_BANG] = ACTIONS(4422),
    [anon_sym_PLUS_PLUS] = ACTIONS(4424),
    [anon_sym_DASH_DASH] = ACTIONS(4424),
    [anon_sym_PLUS] = ACTIONS(4422),
    [anon_sym_DASH] = ACTIONS(4422),
    [anon_sym_STAR] = ACTIONS(4424),
    [anon_sym_SLASH] = ACTIONS(4422),
    [anon_sym_PERCENT] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4424),
    [anon_sym_PIPE] = ACTIONS(4422),
    [anon_sym_AMP] = ACTIONS(4422),
    [anon_sym_LT_LT] = ACTIONS(4424),
    [anon_sym_GT_GT] = ACTIONS(4422),
    [anon_sym_GT_GT_GT] = ACTIONS(4424),
    [anon_sym_EQ_EQ] = ACTIONS(4424),
    [anon_sym_BANG_EQ] = ACTIONS(4424),
    [anon_sym_GT_EQ] = ACTIONS(4424),
    [anon_sym_LT_EQ] = ACTIONS(4424),
    [anon_sym_DOT] = ACTIONS(4422),
    [anon_sym_EQ_GT] = ACTIONS(4424),
    [anon_sym_switch] = ACTIONS(4424),
    [anon_sym_when] = ACTIONS(4424),
    [anon_sym_DOT_DOT] = ACTIONS(4424),
    [anon_sym_and] = ACTIONS(4424),
    [anon_sym_or] = ACTIONS(4424),
    [anon_sym_AMP_AMP] = ACTIONS(4424),
    [anon_sym_PIPE_PIPE] = ACTIONS(4424),
    [anon_sym_QMARK_QMARK] = ACTIONS(4424),
    [anon_sym_on] = ACTIONS(4424),
    [anon_sym_equals] = ACTIONS(4424),
    [anon_sym_by] = ACTIONS(4424),
    [anon_sym_as] = ACTIONS(4424),
    [anon_sym_is] = ACTIONS(4424),
    [anon_sym_DASH_GT] = ACTIONS(4424),
    [anon_sym_with] = ACTIONS(4424),
    [aux_sym_preproc_if_token3] = ACTIONS(4424),
    [aux_sym_preproc_else_token1] = ACTIONS(4424),
    [aux_sym_preproc_elif_token1] = ACTIONS(4424),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3955] = {
    [sym_preproc_region] = STATE(3955),
    [sym_preproc_endregion] = STATE(3955),
    [sym_preproc_line] = STATE(3955),
    [sym_preproc_pragma] = STATE(3955),
    [sym_preproc_nullable] = STATE(3955),
    [sym_preproc_error] = STATE(3955),
    [sym_preproc_define] = STATE(3955),
    [sym_preproc_undef] = STATE(3955),
    [anon_sym_SEMI] = ACTIONS(4124),
    [anon_sym_LBRACK] = ACTIONS(4124),
    [anon_sym_COLON] = ACTIONS(4124),
    [anon_sym_COMMA] = ACTIONS(4124),
    [anon_sym_RBRACK] = ACTIONS(4124),
    [anon_sym_LPAREN] = ACTIONS(4124),
    [anon_sym_RPAREN] = ACTIONS(4124),
    [anon_sym_LBRACE] = ACTIONS(4124),
    [anon_sym_RBRACE] = ACTIONS(4124),
    [anon_sym_LT] = ACTIONS(4113),
    [anon_sym_GT] = ACTIONS(4113),
    [anon_sym_in] = ACTIONS(4124),
    [anon_sym_QMARK] = ACTIONS(4113),
    [anon_sym_BANG] = ACTIONS(4113),
    [anon_sym_PLUS_PLUS] = ACTIONS(4124),
    [anon_sym_DASH_DASH] = ACTIONS(4124),
    [anon_sym_PLUS] = ACTIONS(4113),
    [anon_sym_DASH] = ACTIONS(4113),
    [anon_sym_STAR] = ACTIONS(4124),
    [anon_sym_SLASH] = ACTIONS(4113),
    [anon_sym_PERCENT] = ACTIONS(4124),
    [anon_sym_CARET] = ACTIONS(4124),
    [anon_sym_PIPE] = ACTIONS(4113),
    [anon_sym_AMP] = ACTIONS(4113),
    [anon_sym_LT_LT] = ACTIONS(4124),
    [anon_sym_GT_GT] = ACTIONS(4113),
    [anon_sym_GT_GT_GT] = ACTIONS(4124),
    [anon_sym_EQ_EQ] = ACTIONS(4124),
    [anon_sym_BANG_EQ] = ACTIONS(4124),
    [anon_sym_GT_EQ] = ACTIONS(4124),
    [anon_sym_LT_EQ] = ACTIONS(4124),
    [anon_sym_DOT] = ACTIONS(4113),
    [anon_sym_EQ_GT] = ACTIONS(4124),
    [anon_sym_switch] = ACTIONS(4124),
    [anon_sym_when] = ACTIONS(4124),
    [anon_sym_DOT_DOT] = ACTIONS(4124),
    [anon_sym_and] = ACTIONS(4124),
    [anon_sym_or] = ACTIONS(4124),
    [anon_sym_AMP_AMP] = ACTIONS(4124),
    [anon_sym_PIPE_PIPE] = ACTIONS(4124),
    [anon_sym_QMARK_QMARK] = ACTIONS(4124),
    [anon_sym_on] = ACTIONS(4124),
    [anon_sym_equals] = ACTIONS(4124),
    [anon_sym_by] = ACTIONS(4124),
    [anon_sym_as] = ACTIONS(4124),
    [anon_sym_is] = ACTIONS(4124),
    [anon_sym_DASH_GT] = ACTIONS(4124),
    [anon_sym_with] = ACTIONS(4124),
    [aux_sym_preproc_if_token3] = ACTIONS(4124),
    [aux_sym_preproc_else_token1] = ACTIONS(4124),
    [aux_sym_preproc_elif_token1] = ACTIONS(4124),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3956] = {
    [sym_preproc_region] = STATE(3956),
    [sym_preproc_endregion] = STATE(3956),
    [sym_preproc_line] = STATE(3956),
    [sym_preproc_pragma] = STATE(3956),
    [sym_preproc_nullable] = STATE(3956),
    [sym_preproc_error] = STATE(3956),
    [sym_preproc_define] = STATE(3956),
    [sym_preproc_undef] = STATE(3956),
    [anon_sym_SEMI] = ACTIONS(2927),
    [anon_sym_LBRACK] = ACTIONS(2927),
    [anon_sym_COLON] = ACTIONS(2927),
    [anon_sym_COMMA] = ACTIONS(2927),
    [anon_sym_RBRACK] = ACTIONS(2927),
    [anon_sym_LPAREN] = ACTIONS(2927),
    [anon_sym_RPAREN] = ACTIONS(2927),
    [anon_sym_RBRACE] = ACTIONS(2927),
    [anon_sym_LT] = ACTIONS(2925),
    [anon_sym_GT] = ACTIONS(2925),
    [anon_sym_in] = ACTIONS(2925),
    [anon_sym_QMARK] = ACTIONS(2925),
    [anon_sym_BANG] = ACTIONS(2925),
    [anon_sym_PLUS_PLUS] = ACTIONS(2927),
    [anon_sym_DASH_DASH] = ACTIONS(2927),
    [anon_sym_PLUS] = ACTIONS(2925),
    [anon_sym_DASH] = ACTIONS(2925),
    [anon_sym_STAR] = ACTIONS(2927),
    [anon_sym_SLASH] = ACTIONS(2925),
    [anon_sym_PERCENT] = ACTIONS(2927),
    [anon_sym_CARET] = ACTIONS(2927),
    [anon_sym_PIPE] = ACTIONS(2925),
    [anon_sym_AMP] = ACTIONS(2925),
    [anon_sym_LT_LT] = ACTIONS(2927),
    [anon_sym_GT_GT] = ACTIONS(2925),
    [anon_sym_GT_GT_GT] = ACTIONS(2927),
    [anon_sym_EQ_EQ] = ACTIONS(2927),
    [anon_sym_BANG_EQ] = ACTIONS(2927),
    [anon_sym_GT_EQ] = ACTIONS(2927),
    [anon_sym_LT_EQ] = ACTIONS(2927),
    [anon_sym_DOT] = ACTIONS(2925),
    [anon_sym_EQ_GT] = ACTIONS(2927),
    [anon_sym_switch] = ACTIONS(2927),
    [anon_sym_when] = ACTIONS(2927),
    [anon_sym_DOT_DOT] = ACTIONS(2927),
    [anon_sym_and] = ACTIONS(2927),
    [anon_sym_or] = ACTIONS(2927),
    [anon_sym_AMP_AMP] = ACTIONS(2927),
    [anon_sym_PIPE_PIPE] = ACTIONS(2927),
    [anon_sym_QMARK_QMARK] = ACTIONS(2927),
    [anon_sym_into] = ACTIONS(2927),
    [anon_sym_on] = ACTIONS(2927),
    [anon_sym_equals] = ACTIONS(2927),
    [anon_sym_by] = ACTIONS(2927),
    [anon_sym_as] = ACTIONS(2927),
    [anon_sym_is] = ACTIONS(2927),
    [anon_sym_DASH_GT] = ACTIONS(2927),
    [anon_sym_with] = ACTIONS(2927),
    [aux_sym_preproc_if_token3] = ACTIONS(2927),
    [aux_sym_preproc_else_token1] = ACTIONS(2927),
    [aux_sym_preproc_elif_token1] = ACTIONS(2927),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3957] = {
    [sym_preproc_region] = STATE(3957),
    [sym_preproc_endregion] = STATE(3957),
    [sym_preproc_line] = STATE(3957),
    [sym_preproc_pragma] = STATE(3957),
    [sym_preproc_nullable] = STATE(3957),
    [sym_preproc_error] = STATE(3957),
    [sym_preproc_define] = STATE(3957),
    [sym_preproc_undef] = STATE(3957),
    [anon_sym_SEMI] = ACTIONS(5502),
    [anon_sym_LBRACK] = ACTIONS(5502),
    [anon_sym_COLON] = ACTIONS(5502),
    [anon_sym_COMMA] = ACTIONS(5502),
    [anon_sym_RBRACK] = ACTIONS(5502),
    [anon_sym_LPAREN] = ACTIONS(5502),
    [anon_sym_RPAREN] = ACTIONS(5502),
    [anon_sym_RBRACE] = ACTIONS(5502),
    [anon_sym_LT] = ACTIONS(5504),
    [anon_sym_GT] = ACTIONS(5504),
    [anon_sym_in] = ACTIONS(5504),
    [anon_sym_QMARK] = ACTIONS(5504),
    [anon_sym_BANG] = ACTIONS(5504),
    [anon_sym_PLUS_PLUS] = ACTIONS(5502),
    [anon_sym_DASH_DASH] = ACTIONS(5502),
    [anon_sym_PLUS] = ACTIONS(5504),
    [anon_sym_DASH] = ACTIONS(5504),
    [anon_sym_STAR] = ACTIONS(5502),
    [anon_sym_SLASH] = ACTIONS(5504),
    [anon_sym_PERCENT] = ACTIONS(5502),
    [anon_sym_CARET] = ACTIONS(5502),
    [anon_sym_PIPE] = ACTIONS(5504),
    [anon_sym_AMP] = ACTIONS(5504),
    [anon_sym_LT_LT] = ACTIONS(5502),
    [anon_sym_GT_GT] = ACTIONS(5504),
    [anon_sym_GT_GT_GT] = ACTIONS(5502),
    [anon_sym_EQ_EQ] = ACTIONS(5502),
    [anon_sym_BANG_EQ] = ACTIONS(5502),
    [anon_sym_GT_EQ] = ACTIONS(5502),
    [anon_sym_LT_EQ] = ACTIONS(5502),
    [anon_sym_DOT] = ACTIONS(5504),
    [anon_sym_EQ_GT] = ACTIONS(5502),
    [anon_sym_switch] = ACTIONS(5502),
    [anon_sym_when] = ACTIONS(5502),
    [anon_sym_DOT_DOT] = ACTIONS(5502),
    [anon_sym_and] = ACTIONS(5502),
    [anon_sym_or] = ACTIONS(5502),
    [anon_sym_AMP_AMP] = ACTIONS(5502),
    [anon_sym_PIPE_PIPE] = ACTIONS(5502),
    [anon_sym_QMARK_QMARK] = ACTIONS(5502),
    [anon_sym_into] = ACTIONS(5502),
    [anon_sym_on] = ACTIONS(5502),
    [anon_sym_equals] = ACTIONS(5502),
    [anon_sym_by] = ACTIONS(5502),
    [anon_sym_as] = ACTIONS(5502),
    [anon_sym_is] = ACTIONS(5502),
    [anon_sym_DASH_GT] = ACTIONS(5502),
    [anon_sym_with] = ACTIONS(5502),
    [aux_sym_preproc_if_token3] = ACTIONS(5502),
    [aux_sym_preproc_else_token1] = ACTIONS(5502),
    [aux_sym_preproc_elif_token1] = ACTIONS(5502),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3958] = {
    [sym_preproc_region] = STATE(3958),
    [sym_preproc_endregion] = STATE(3958),
    [sym_preproc_line] = STATE(3958),
    [sym_preproc_pragma] = STATE(3958),
    [sym_preproc_nullable] = STATE(3958),
    [sym_preproc_error] = STATE(3958),
    [sym_preproc_define] = STATE(3958),
    [sym_preproc_undef] = STATE(3958),
    [sym__identifier_token] = ACTIONS(3976),
    [anon_sym_extern] = ACTIONS(3976),
    [anon_sym_alias] = ACTIONS(5765),
    [anon_sym_global] = ACTIONS(3976),
    [anon_sym_unsafe] = ACTIONS(3976),
    [anon_sym_static] = ACTIONS(3976),
    [anon_sym_LPAREN] = ACTIONS(5566),
    [anon_sym_class] = ACTIONS(3976),
    [anon_sym_ref] = ACTIONS(3976),
    [anon_sym_struct] = ACTIONS(3976),
    [anon_sym_enum] = ACTIONS(3976),
    [anon_sym_interface] = ACTIONS(3976),
    [anon_sym_delegate] = ACTIONS(3976),
    [anon_sym_record] = ACTIONS(3976),
    [anon_sym_abstract] = ACTIONS(3976),
    [anon_sym_async] = ACTIONS(3976),
    [anon_sym_const] = ACTIONS(3976),
    [anon_sym_file] = ACTIONS(3976),
    [anon_sym_fixed] = ACTIONS(3976),
    [anon_sym_internal] = ACTIONS(3976),
    [anon_sym_new] = ACTIONS(3976),
    [anon_sym_override] = ACTIONS(3976),
    [anon_sym_partial] = ACTIONS(3976),
    [anon_sym_private] = ACTIONS(3976),
    [anon_sym_protected] = ACTIONS(3976),
    [anon_sym_public] = ACTIONS(3976),
    [anon_sym_readonly] = ACTIONS(3976),
    [anon_sym_required] = ACTIONS(3976),
    [anon_sym_sealed] = ACTIONS(3976),
    [anon_sym_virtual] = ACTIONS(3976),
    [anon_sym_volatile] = ACTIONS(3976),
    [anon_sym_where] = ACTIONS(3976),
    [anon_sym_notnull] = ACTIONS(3976),
    [anon_sym_unmanaged] = ACTIONS(3976),
    [anon_sym_scoped] = ACTIONS(3976),
    [anon_sym_var] = ACTIONS(3976),
    [sym_predefined_type] = ACTIONS(3976),
    [anon_sym_yield] = ACTIONS(3976),
    [anon_sym_when] = ACTIONS(3976),
    [anon_sym_from] = ACTIONS(3976),
    [anon_sym_into] = ACTIONS(3976),
    [anon_sym_join] = ACTIONS(3976),
    [anon_sym_on] = ACTIONS(3976),
    [anon_sym_equals] = ACTIONS(3976),
    [anon_sym_let] = ACTIONS(3976),
    [anon_sym_orderby] = ACTIONS(3976),
    [anon_sym_ascending] = ACTIONS(3976),
    [anon_sym_descending] = ACTIONS(3976),
    [anon_sym_group] = ACTIONS(3976),
    [anon_sym_by] = ACTIONS(3976),
    [anon_sym_select] = ACTIONS(3976),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3959] = {
    [sym_preproc_region] = STATE(3959),
    [sym_preproc_endregion] = STATE(3959),
    [sym_preproc_line] = STATE(3959),
    [sym_preproc_pragma] = STATE(3959),
    [sym_preproc_nullable] = STATE(3959),
    [sym_preproc_error] = STATE(3959),
    [sym_preproc_define] = STATE(3959),
    [sym_preproc_undef] = STATE(3959),
    [anon_sym_SEMI] = ACTIONS(5341),
    [anon_sym_LBRACK] = ACTIONS(5341),
    [anon_sym_COLON] = ACTIONS(5341),
    [anon_sym_COMMA] = ACTIONS(5341),
    [anon_sym_RBRACK] = ACTIONS(5341),
    [anon_sym_LPAREN] = ACTIONS(5341),
    [anon_sym_RPAREN] = ACTIONS(5341),
    [anon_sym_RBRACE] = ACTIONS(5341),
    [anon_sym_LT] = ACTIONS(5343),
    [anon_sym_GT] = ACTIONS(5343),
    [anon_sym_in] = ACTIONS(5343),
    [anon_sym_QMARK] = ACTIONS(5343),
    [anon_sym_BANG] = ACTIONS(5343),
    [anon_sym_PLUS_PLUS] = ACTIONS(5341),
    [anon_sym_DASH_DASH] = ACTIONS(5341),
    [anon_sym_PLUS] = ACTIONS(5343),
    [anon_sym_DASH] = ACTIONS(5343),
    [anon_sym_STAR] = ACTIONS(5341),
    [anon_sym_SLASH] = ACTIONS(5343),
    [anon_sym_PERCENT] = ACTIONS(5341),
    [anon_sym_CARET] = ACTIONS(5341),
    [anon_sym_PIPE] = ACTIONS(5343),
    [anon_sym_AMP] = ACTIONS(5343),
    [anon_sym_LT_LT] = ACTIONS(5341),
    [anon_sym_GT_GT] = ACTIONS(5343),
    [anon_sym_GT_GT_GT] = ACTIONS(5341),
    [anon_sym_EQ_EQ] = ACTIONS(5341),
    [anon_sym_BANG_EQ] = ACTIONS(5341),
    [anon_sym_GT_EQ] = ACTIONS(5341),
    [anon_sym_LT_EQ] = ACTIONS(5341),
    [anon_sym_DOT] = ACTIONS(5343),
    [anon_sym_EQ_GT] = ACTIONS(5341),
    [anon_sym_switch] = ACTIONS(5341),
    [anon_sym_when] = ACTIONS(5341),
    [anon_sym_DOT_DOT] = ACTIONS(5341),
    [anon_sym_and] = ACTIONS(5341),
    [anon_sym_or] = ACTIONS(5341),
    [anon_sym_AMP_AMP] = ACTIONS(5341),
    [anon_sym_PIPE_PIPE] = ACTIONS(5341),
    [anon_sym_QMARK_QMARK] = ACTIONS(5341),
    [anon_sym_into] = ACTIONS(5341),
    [anon_sym_on] = ACTIONS(5341),
    [anon_sym_equals] = ACTIONS(5341),
    [anon_sym_by] = ACTIONS(5341),
    [anon_sym_as] = ACTIONS(5341),
    [anon_sym_is] = ACTIONS(5341),
    [anon_sym_DASH_GT] = ACTIONS(5341),
    [anon_sym_with] = ACTIONS(5341),
    [aux_sym_preproc_if_token3] = ACTIONS(5341),
    [aux_sym_preproc_else_token1] = ACTIONS(5341),
    [aux_sym_preproc_elif_token1] = ACTIONS(5341),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3960] = {
    [sym_preproc_region] = STATE(3960),
    [sym_preproc_endregion] = STATE(3960),
    [sym_preproc_line] = STATE(3960),
    [sym_preproc_pragma] = STATE(3960),
    [sym_preproc_nullable] = STATE(3960),
    [sym_preproc_error] = STATE(3960),
    [sym_preproc_define] = STATE(3960),
    [sym_preproc_undef] = STATE(3960),
    [anon_sym_SEMI] = ACTIONS(5373),
    [anon_sym_LBRACK] = ACTIONS(5373),
    [anon_sym_COLON] = ACTIONS(5373),
    [anon_sym_COMMA] = ACTIONS(5373),
    [anon_sym_RBRACK] = ACTIONS(5373),
    [anon_sym_LPAREN] = ACTIONS(5373),
    [anon_sym_RPAREN] = ACTIONS(5373),
    [anon_sym_RBRACE] = ACTIONS(5373),
    [anon_sym_LT] = ACTIONS(5375),
    [anon_sym_GT] = ACTIONS(5375),
    [anon_sym_in] = ACTIONS(5375),
    [anon_sym_QMARK] = ACTIONS(5375),
    [anon_sym_BANG] = ACTIONS(5375),
    [anon_sym_PLUS_PLUS] = ACTIONS(5373),
    [anon_sym_DASH_DASH] = ACTIONS(5373),
    [anon_sym_PLUS] = ACTIONS(5375),
    [anon_sym_DASH] = ACTIONS(5375),
    [anon_sym_STAR] = ACTIONS(5373),
    [anon_sym_SLASH] = ACTIONS(5375),
    [anon_sym_PERCENT] = ACTIONS(5373),
    [anon_sym_CARET] = ACTIONS(5373),
    [anon_sym_PIPE] = ACTIONS(5375),
    [anon_sym_AMP] = ACTIONS(5375),
    [anon_sym_LT_LT] = ACTIONS(5373),
    [anon_sym_GT_GT] = ACTIONS(5375),
    [anon_sym_GT_GT_GT] = ACTIONS(5373),
    [anon_sym_EQ_EQ] = ACTIONS(5373),
    [anon_sym_BANG_EQ] = ACTIONS(5373),
    [anon_sym_GT_EQ] = ACTIONS(5373),
    [anon_sym_LT_EQ] = ACTIONS(5373),
    [anon_sym_DOT] = ACTIONS(5375),
    [anon_sym_EQ_GT] = ACTIONS(5373),
    [anon_sym_switch] = ACTIONS(5373),
    [anon_sym_when] = ACTIONS(5373),
    [anon_sym_DOT_DOT] = ACTIONS(5373),
    [anon_sym_and] = ACTIONS(5373),
    [anon_sym_or] = ACTIONS(5373),
    [anon_sym_AMP_AMP] = ACTIONS(5373),
    [anon_sym_PIPE_PIPE] = ACTIONS(5373),
    [anon_sym_QMARK_QMARK] = ACTIONS(5373),
    [anon_sym_into] = ACTIONS(5373),
    [anon_sym_on] = ACTIONS(5373),
    [anon_sym_equals] = ACTIONS(5373),
    [anon_sym_by] = ACTIONS(5373),
    [anon_sym_as] = ACTIONS(5373),
    [anon_sym_is] = ACTIONS(5373),
    [anon_sym_DASH_GT] = ACTIONS(5373),
    [anon_sym_with] = ACTIONS(5373),
    [aux_sym_preproc_if_token3] = ACTIONS(5373),
    [aux_sym_preproc_else_token1] = ACTIONS(5373),
    [aux_sym_preproc_elif_token1] = ACTIONS(5373),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3961] = {
    [sym_preproc_region] = STATE(3961),
    [sym_preproc_endregion] = STATE(3961),
    [sym_preproc_line] = STATE(3961),
    [sym_preproc_pragma] = STATE(3961),
    [sym_preproc_nullable] = STATE(3961),
    [sym_preproc_error] = STATE(3961),
    [sym_preproc_define] = STATE(3961),
    [sym_preproc_undef] = STATE(3961),
    [anon_sym_SEMI] = ACTIONS(5436),
    [anon_sym_LBRACK] = ACTIONS(5436),
    [anon_sym_COLON] = ACTIONS(5436),
    [anon_sym_COMMA] = ACTIONS(5436),
    [anon_sym_RBRACK] = ACTIONS(5436),
    [anon_sym_LPAREN] = ACTIONS(5436),
    [anon_sym_RPAREN] = ACTIONS(5436),
    [anon_sym_RBRACE] = ACTIONS(5436),
    [anon_sym_LT] = ACTIONS(5438),
    [anon_sym_GT] = ACTIONS(5438),
    [anon_sym_in] = ACTIONS(5438),
    [anon_sym_QMARK] = ACTIONS(5438),
    [anon_sym_BANG] = ACTIONS(5438),
    [anon_sym_PLUS_PLUS] = ACTIONS(5436),
    [anon_sym_DASH_DASH] = ACTIONS(5436),
    [anon_sym_PLUS] = ACTIONS(5438),
    [anon_sym_DASH] = ACTIONS(5438),
    [anon_sym_STAR] = ACTIONS(5436),
    [anon_sym_SLASH] = ACTIONS(5438),
    [anon_sym_PERCENT] = ACTIONS(5436),
    [anon_sym_CARET] = ACTIONS(5436),
    [anon_sym_PIPE] = ACTIONS(5438),
    [anon_sym_AMP] = ACTIONS(5438),
    [anon_sym_LT_LT] = ACTIONS(5436),
    [anon_sym_GT_GT] = ACTIONS(5438),
    [anon_sym_GT_GT_GT] = ACTIONS(5436),
    [anon_sym_EQ_EQ] = ACTIONS(5436),
    [anon_sym_BANG_EQ] = ACTIONS(5436),
    [anon_sym_GT_EQ] = ACTIONS(5436),
    [anon_sym_LT_EQ] = ACTIONS(5436),
    [anon_sym_DOT] = ACTIONS(5438),
    [anon_sym_EQ_GT] = ACTIONS(5436),
    [anon_sym_switch] = ACTIONS(5436),
    [anon_sym_when] = ACTIONS(5436),
    [anon_sym_DOT_DOT] = ACTIONS(5436),
    [anon_sym_and] = ACTIONS(5436),
    [anon_sym_or] = ACTIONS(5436),
    [anon_sym_AMP_AMP] = ACTIONS(5436),
    [anon_sym_PIPE_PIPE] = ACTIONS(5436),
    [anon_sym_QMARK_QMARK] = ACTIONS(5436),
    [anon_sym_into] = ACTIONS(5436),
    [anon_sym_on] = ACTIONS(5436),
    [anon_sym_equals] = ACTIONS(5436),
    [anon_sym_by] = ACTIONS(5436),
    [anon_sym_as] = ACTIONS(5436),
    [anon_sym_is] = ACTIONS(5436),
    [anon_sym_DASH_GT] = ACTIONS(5436),
    [anon_sym_with] = ACTIONS(5436),
    [aux_sym_preproc_if_token3] = ACTIONS(5436),
    [aux_sym_preproc_else_token1] = ACTIONS(5436),
    [aux_sym_preproc_elif_token1] = ACTIONS(5436),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3962] = {
    [sym_preproc_region] = STATE(3962),
    [sym_preproc_endregion] = STATE(3962),
    [sym_preproc_line] = STATE(3962),
    [sym_preproc_pragma] = STATE(3962),
    [sym_preproc_nullable] = STATE(3962),
    [sym_preproc_error] = STATE(3962),
    [sym_preproc_define] = STATE(3962),
    [sym_preproc_undef] = STATE(3962),
    [anon_sym_SEMI] = ACTIONS(4424),
    [anon_sym_LBRACK] = ACTIONS(4547),
    [anon_sym_COLON] = ACTIONS(4424),
    [anon_sym_COMMA] = ACTIONS(4424),
    [anon_sym_RBRACK] = ACTIONS(4424),
    [anon_sym_LPAREN] = ACTIONS(4424),
    [anon_sym_RPAREN] = ACTIONS(4424),
    [anon_sym_LBRACE] = ACTIONS(4424),
    [anon_sym_RBRACE] = ACTIONS(4424),
    [anon_sym_LT] = ACTIONS(4422),
    [anon_sym_GT] = ACTIONS(4422),
    [anon_sym_in] = ACTIONS(4424),
    [anon_sym_QMARK] = ACTIONS(5758),
    [anon_sym_BANG] = ACTIONS(4422),
    [anon_sym_PLUS_PLUS] = ACTIONS(4424),
    [anon_sym_DASH_DASH] = ACTIONS(4424),
    [anon_sym_PLUS] = ACTIONS(4422),
    [anon_sym_DASH] = ACTIONS(4422),
    [anon_sym_STAR] = ACTIONS(4553),
    [anon_sym_SLASH] = ACTIONS(4422),
    [anon_sym_PERCENT] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4424),
    [anon_sym_PIPE] = ACTIONS(4422),
    [anon_sym_AMP] = ACTIONS(4422),
    [anon_sym_LT_LT] = ACTIONS(4424),
    [anon_sym_GT_GT] = ACTIONS(4422),
    [anon_sym_GT_GT_GT] = ACTIONS(4424),
    [anon_sym_EQ_EQ] = ACTIONS(4424),
    [anon_sym_BANG_EQ] = ACTIONS(4424),
    [anon_sym_GT_EQ] = ACTIONS(4424),
    [anon_sym_LT_EQ] = ACTIONS(4424),
    [anon_sym_DOT] = ACTIONS(4422),
    [anon_sym_EQ_GT] = ACTIONS(4424),
    [anon_sym_switch] = ACTIONS(4424),
    [anon_sym_when] = ACTIONS(4424),
    [anon_sym_DOT_DOT] = ACTIONS(4424),
    [anon_sym_and] = ACTIONS(4424),
    [anon_sym_or] = ACTIONS(4424),
    [anon_sym_AMP_AMP] = ACTIONS(4424),
    [anon_sym_PIPE_PIPE] = ACTIONS(4424),
    [anon_sym_QMARK_QMARK] = ACTIONS(4424),
    [anon_sym_on] = ACTIONS(4424),
    [anon_sym_equals] = ACTIONS(4424),
    [anon_sym_by] = ACTIONS(4424),
    [anon_sym_as] = ACTIONS(4424),
    [anon_sym_is] = ACTIONS(4424),
    [anon_sym_DASH_GT] = ACTIONS(4424),
    [anon_sym_with] = ACTIONS(4424),
    [aux_sym_preproc_if_token3] = ACTIONS(4424),
    [aux_sym_preproc_else_token1] = ACTIONS(4424),
    [aux_sym_preproc_elif_token1] = ACTIONS(4424),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3963] = {
    [sym_preproc_region] = STATE(3963),
    [sym_preproc_endregion] = STATE(3963),
    [sym_preproc_line] = STATE(3963),
    [sym_preproc_pragma] = STATE(3963),
    [sym_preproc_nullable] = STATE(3963),
    [sym_preproc_error] = STATE(3963),
    [sym_preproc_define] = STATE(3963),
    [sym_preproc_undef] = STATE(3963),
    [anon_sym_SEMI] = ACTIONS(4106),
    [anon_sym_LBRACK] = ACTIONS(4106),
    [anon_sym_COLON] = ACTIONS(4106),
    [anon_sym_COMMA] = ACTIONS(4106),
    [anon_sym_RBRACK] = ACTIONS(4106),
    [anon_sym_LPAREN] = ACTIONS(4106),
    [anon_sym_RPAREN] = ACTIONS(4106),
    [anon_sym_LBRACE] = ACTIONS(4106),
    [anon_sym_RBRACE] = ACTIONS(4106),
    [anon_sym_LT] = ACTIONS(4099),
    [anon_sym_GT] = ACTIONS(4099),
    [anon_sym_in] = ACTIONS(4106),
    [anon_sym_QMARK] = ACTIONS(4099),
    [anon_sym_BANG] = ACTIONS(4099),
    [anon_sym_PLUS_PLUS] = ACTIONS(4106),
    [anon_sym_DASH_DASH] = ACTIONS(4106),
    [anon_sym_PLUS] = ACTIONS(4099),
    [anon_sym_DASH] = ACTIONS(4099),
    [anon_sym_STAR] = ACTIONS(4106),
    [anon_sym_SLASH] = ACTIONS(4099),
    [anon_sym_PERCENT] = ACTIONS(4106),
    [anon_sym_CARET] = ACTIONS(4106),
    [anon_sym_PIPE] = ACTIONS(4099),
    [anon_sym_AMP] = ACTIONS(4099),
    [anon_sym_LT_LT] = ACTIONS(4106),
    [anon_sym_GT_GT] = ACTIONS(4099),
    [anon_sym_GT_GT_GT] = ACTIONS(4106),
    [anon_sym_EQ_EQ] = ACTIONS(4106),
    [anon_sym_BANG_EQ] = ACTIONS(4106),
    [anon_sym_GT_EQ] = ACTIONS(4106),
    [anon_sym_LT_EQ] = ACTIONS(4106),
    [anon_sym_DOT] = ACTIONS(4099),
    [anon_sym_EQ_GT] = ACTIONS(4106),
    [anon_sym_switch] = ACTIONS(4106),
    [anon_sym_when] = ACTIONS(4106),
    [anon_sym_DOT_DOT] = ACTIONS(4106),
    [anon_sym_and] = ACTIONS(4106),
    [anon_sym_or] = ACTIONS(4106),
    [anon_sym_AMP_AMP] = ACTIONS(4106),
    [anon_sym_PIPE_PIPE] = ACTIONS(4106),
    [anon_sym_QMARK_QMARK] = ACTIONS(4106),
    [anon_sym_on] = ACTIONS(4106),
    [anon_sym_equals] = ACTIONS(4106),
    [anon_sym_by] = ACTIONS(4106),
    [anon_sym_as] = ACTIONS(4106),
    [anon_sym_is] = ACTIONS(4106),
    [anon_sym_DASH_GT] = ACTIONS(4106),
    [anon_sym_with] = ACTIONS(4106),
    [aux_sym_preproc_if_token3] = ACTIONS(4106),
    [aux_sym_preproc_else_token1] = ACTIONS(4106),
    [aux_sym_preproc_elif_token1] = ACTIONS(4106),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3964] = {
    [sym_preproc_region] = STATE(3964),
    [sym_preproc_endregion] = STATE(3964),
    [sym_preproc_line] = STATE(3964),
    [sym_preproc_pragma] = STATE(3964),
    [sym_preproc_nullable] = STATE(3964),
    [sym_preproc_error] = STATE(3964),
    [sym_preproc_define] = STATE(3964),
    [sym_preproc_undef] = STATE(3964),
    [anon_sym_SEMI] = ACTIONS(4527),
    [anon_sym_LBRACK] = ACTIONS(4527),
    [anon_sym_COLON] = ACTIONS(4527),
    [anon_sym_COMMA] = ACTIONS(4527),
    [anon_sym_RBRACK] = ACTIONS(4527),
    [anon_sym_LPAREN] = ACTIONS(4527),
    [anon_sym_RPAREN] = ACTIONS(4527),
    [anon_sym_LBRACE] = ACTIONS(4527),
    [anon_sym_RBRACE] = ACTIONS(4527),
    [anon_sym_LT] = ACTIONS(4525),
    [anon_sym_GT] = ACTIONS(4525),
    [anon_sym_in] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4525),
    [anon_sym_BANG] = ACTIONS(4525),
    [anon_sym_PLUS_PLUS] = ACTIONS(4527),
    [anon_sym_DASH_DASH] = ACTIONS(4527),
    [anon_sym_PLUS] = ACTIONS(4525),
    [anon_sym_DASH] = ACTIONS(4525),
    [anon_sym_STAR] = ACTIONS(4527),
    [anon_sym_SLASH] = ACTIONS(4525),
    [anon_sym_PERCENT] = ACTIONS(4527),
    [anon_sym_CARET] = ACTIONS(4527),
    [anon_sym_PIPE] = ACTIONS(4525),
    [anon_sym_AMP] = ACTIONS(4525),
    [anon_sym_LT_LT] = ACTIONS(4527),
    [anon_sym_GT_GT] = ACTIONS(4525),
    [anon_sym_GT_GT_GT] = ACTIONS(4527),
    [anon_sym_EQ_EQ] = ACTIONS(4527),
    [anon_sym_BANG_EQ] = ACTIONS(4527),
    [anon_sym_GT_EQ] = ACTIONS(4527),
    [anon_sym_LT_EQ] = ACTIONS(4527),
    [anon_sym_DOT] = ACTIONS(4525),
    [anon_sym_EQ_GT] = ACTIONS(4527),
    [anon_sym_switch] = ACTIONS(4527),
    [anon_sym_when] = ACTIONS(4527),
    [anon_sym_DOT_DOT] = ACTIONS(4527),
    [anon_sym_and] = ACTIONS(4527),
    [anon_sym_or] = ACTIONS(4527),
    [anon_sym_AMP_AMP] = ACTIONS(4527),
    [anon_sym_PIPE_PIPE] = ACTIONS(4527),
    [anon_sym_QMARK_QMARK] = ACTIONS(4527),
    [anon_sym_on] = ACTIONS(4527),
    [anon_sym_equals] = ACTIONS(4527),
    [anon_sym_by] = ACTIONS(4527),
    [anon_sym_as] = ACTIONS(4527),
    [anon_sym_is] = ACTIONS(4527),
    [anon_sym_DASH_GT] = ACTIONS(4527),
    [anon_sym_with] = ACTIONS(4527),
    [aux_sym_preproc_if_token3] = ACTIONS(4527),
    [aux_sym_preproc_else_token1] = ACTIONS(4527),
    [aux_sym_preproc_elif_token1] = ACTIONS(4527),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3965] = {
    [sym_preproc_region] = STATE(3965),
    [sym_preproc_endregion] = STATE(3965),
    [sym_preproc_line] = STATE(3965),
    [sym_preproc_pragma] = STATE(3965),
    [sym_preproc_nullable] = STATE(3965),
    [sym_preproc_error] = STATE(3965),
    [sym_preproc_define] = STATE(3965),
    [sym_preproc_undef] = STATE(3965),
    [anon_sym_SEMI] = ACTIONS(5767),
    [anon_sym_LBRACK] = ACTIONS(5767),
    [anon_sym_COLON] = ACTIONS(5767),
    [anon_sym_COMMA] = ACTIONS(5767),
    [anon_sym_RBRACK] = ACTIONS(5767),
    [anon_sym_LPAREN] = ACTIONS(5767),
    [anon_sym_RPAREN] = ACTIONS(5767),
    [anon_sym_RBRACE] = ACTIONS(5767),
    [anon_sym_LT] = ACTIONS(5769),
    [anon_sym_GT] = ACTIONS(5769),
    [anon_sym_in] = ACTIONS(5769),
    [anon_sym_QMARK] = ACTIONS(5769),
    [anon_sym_BANG] = ACTIONS(5769),
    [anon_sym_PLUS_PLUS] = ACTIONS(5767),
    [anon_sym_DASH_DASH] = ACTIONS(5767),
    [anon_sym_PLUS] = ACTIONS(5769),
    [anon_sym_DASH] = ACTIONS(5769),
    [anon_sym_STAR] = ACTIONS(5767),
    [anon_sym_SLASH] = ACTIONS(5769),
    [anon_sym_PERCENT] = ACTIONS(5767),
    [anon_sym_CARET] = ACTIONS(5767),
    [anon_sym_PIPE] = ACTIONS(5769),
    [anon_sym_AMP] = ACTIONS(5769),
    [anon_sym_LT_LT] = ACTIONS(5767),
    [anon_sym_GT_GT] = ACTIONS(5769),
    [anon_sym_GT_GT_GT] = ACTIONS(5767),
    [anon_sym_EQ_EQ] = ACTIONS(5767),
    [anon_sym_BANG_EQ] = ACTIONS(5767),
    [anon_sym_GT_EQ] = ACTIONS(5767),
    [anon_sym_LT_EQ] = ACTIONS(5767),
    [anon_sym_DOT] = ACTIONS(5769),
    [anon_sym_EQ_GT] = ACTIONS(5767),
    [anon_sym_switch] = ACTIONS(5767),
    [anon_sym_when] = ACTIONS(5767),
    [anon_sym_DOT_DOT] = ACTIONS(5767),
    [anon_sym_and] = ACTIONS(5767),
    [anon_sym_or] = ACTIONS(5767),
    [anon_sym_AMP_AMP] = ACTIONS(5767),
    [anon_sym_PIPE_PIPE] = ACTIONS(5767),
    [anon_sym_QMARK_QMARK] = ACTIONS(5767),
    [anon_sym_into] = ACTIONS(5767),
    [anon_sym_on] = ACTIONS(5767),
    [anon_sym_equals] = ACTIONS(5767),
    [anon_sym_by] = ACTIONS(5767),
    [anon_sym_as] = ACTIONS(5767),
    [anon_sym_is] = ACTIONS(5767),
    [anon_sym_DASH_GT] = ACTIONS(5767),
    [anon_sym_with] = ACTIONS(5767),
    [aux_sym_preproc_if_token3] = ACTIONS(5767),
    [aux_sym_preproc_else_token1] = ACTIONS(5767),
    [aux_sym_preproc_elif_token1] = ACTIONS(5767),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3966] = {
    [sym_preproc_region] = STATE(3966),
    [sym_preproc_endregion] = STATE(3966),
    [sym_preproc_line] = STATE(3966),
    [sym_preproc_pragma] = STATE(3966),
    [sym_preproc_nullable] = STATE(3966),
    [sym_preproc_error] = STATE(3966),
    [sym_preproc_define] = STATE(3966),
    [sym_preproc_undef] = STATE(3966),
    [anon_sym_SEMI] = ACTIONS(5329),
    [anon_sym_LBRACK] = ACTIONS(5329),
    [anon_sym_COLON] = ACTIONS(5329),
    [anon_sym_COMMA] = ACTIONS(5329),
    [anon_sym_RBRACK] = ACTIONS(5329),
    [anon_sym_LPAREN] = ACTIONS(5329),
    [anon_sym_RPAREN] = ACTIONS(5329),
    [anon_sym_RBRACE] = ACTIONS(5329),
    [anon_sym_LT] = ACTIONS(5331),
    [anon_sym_GT] = ACTIONS(5331),
    [anon_sym_in] = ACTIONS(5331),
    [anon_sym_QMARK] = ACTIONS(5331),
    [anon_sym_BANG] = ACTIONS(5331),
    [anon_sym_PLUS_PLUS] = ACTIONS(5329),
    [anon_sym_DASH_DASH] = ACTIONS(5329),
    [anon_sym_PLUS] = ACTIONS(5331),
    [anon_sym_DASH] = ACTIONS(5331),
    [anon_sym_STAR] = ACTIONS(5329),
    [anon_sym_SLASH] = ACTIONS(5331),
    [anon_sym_PERCENT] = ACTIONS(5329),
    [anon_sym_CARET] = ACTIONS(5329),
    [anon_sym_PIPE] = ACTIONS(5331),
    [anon_sym_AMP] = ACTIONS(5331),
    [anon_sym_LT_LT] = ACTIONS(5329),
    [anon_sym_GT_GT] = ACTIONS(5331),
    [anon_sym_GT_GT_GT] = ACTIONS(5329),
    [anon_sym_EQ_EQ] = ACTIONS(5329),
    [anon_sym_BANG_EQ] = ACTIONS(5329),
    [anon_sym_GT_EQ] = ACTIONS(5329),
    [anon_sym_LT_EQ] = ACTIONS(5329),
    [anon_sym_DOT] = ACTIONS(5331),
    [anon_sym_EQ_GT] = ACTIONS(5329),
    [anon_sym_switch] = ACTIONS(5329),
    [anon_sym_when] = ACTIONS(5329),
    [anon_sym_DOT_DOT] = ACTIONS(5329),
    [anon_sym_and] = ACTIONS(5329),
    [anon_sym_or] = ACTIONS(5329),
    [anon_sym_AMP_AMP] = ACTIONS(5329),
    [anon_sym_PIPE_PIPE] = ACTIONS(5329),
    [anon_sym_QMARK_QMARK] = ACTIONS(5329),
    [anon_sym_into] = ACTIONS(5329),
    [anon_sym_on] = ACTIONS(5329),
    [anon_sym_equals] = ACTIONS(5329),
    [anon_sym_by] = ACTIONS(5329),
    [anon_sym_as] = ACTIONS(5329),
    [anon_sym_is] = ACTIONS(5329),
    [anon_sym_DASH_GT] = ACTIONS(5329),
    [anon_sym_with] = ACTIONS(5329),
    [aux_sym_preproc_if_token3] = ACTIONS(5329),
    [aux_sym_preproc_else_token1] = ACTIONS(5329),
    [aux_sym_preproc_elif_token1] = ACTIONS(5329),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3967] = {
    [sym_preproc_region] = STATE(3967),
    [sym_preproc_endregion] = STATE(3967),
    [sym_preproc_line] = STATE(3967),
    [sym_preproc_pragma] = STATE(3967),
    [sym_preproc_nullable] = STATE(3967),
    [sym_preproc_error] = STATE(3967),
    [sym_preproc_define] = STATE(3967),
    [sym_preproc_undef] = STATE(3967),
    [anon_sym_SEMI] = ACTIONS(5556),
    [anon_sym_LBRACK] = ACTIONS(5556),
    [anon_sym_COLON] = ACTIONS(5556),
    [anon_sym_COMMA] = ACTIONS(5556),
    [anon_sym_RBRACK] = ACTIONS(5556),
    [anon_sym_LPAREN] = ACTIONS(5556),
    [anon_sym_RPAREN] = ACTIONS(5556),
    [anon_sym_RBRACE] = ACTIONS(5556),
    [anon_sym_LT] = ACTIONS(5558),
    [anon_sym_GT] = ACTIONS(5558),
    [anon_sym_in] = ACTIONS(5558),
    [anon_sym_QMARK] = ACTIONS(5558),
    [anon_sym_BANG] = ACTIONS(5558),
    [anon_sym_PLUS_PLUS] = ACTIONS(5556),
    [anon_sym_DASH_DASH] = ACTIONS(5556),
    [anon_sym_PLUS] = ACTIONS(5558),
    [anon_sym_DASH] = ACTIONS(5558),
    [anon_sym_STAR] = ACTIONS(5556),
    [anon_sym_SLASH] = ACTIONS(5558),
    [anon_sym_PERCENT] = ACTIONS(5556),
    [anon_sym_CARET] = ACTIONS(5556),
    [anon_sym_PIPE] = ACTIONS(5558),
    [anon_sym_AMP] = ACTIONS(5558),
    [anon_sym_LT_LT] = ACTIONS(5556),
    [anon_sym_GT_GT] = ACTIONS(5558),
    [anon_sym_GT_GT_GT] = ACTIONS(5556),
    [anon_sym_EQ_EQ] = ACTIONS(5556),
    [anon_sym_BANG_EQ] = ACTIONS(5556),
    [anon_sym_GT_EQ] = ACTIONS(5556),
    [anon_sym_LT_EQ] = ACTIONS(5556),
    [anon_sym_DOT] = ACTIONS(5558),
    [anon_sym_EQ_GT] = ACTIONS(5556),
    [anon_sym_switch] = ACTIONS(5556),
    [anon_sym_when] = ACTIONS(5556),
    [anon_sym_DOT_DOT] = ACTIONS(5556),
    [anon_sym_and] = ACTIONS(5556),
    [anon_sym_or] = ACTIONS(5556),
    [anon_sym_AMP_AMP] = ACTIONS(5556),
    [anon_sym_PIPE_PIPE] = ACTIONS(5556),
    [anon_sym_QMARK_QMARK] = ACTIONS(5556),
    [anon_sym_into] = ACTIONS(5556),
    [anon_sym_on] = ACTIONS(5556),
    [anon_sym_equals] = ACTIONS(5556),
    [anon_sym_by] = ACTIONS(5556),
    [anon_sym_as] = ACTIONS(5556),
    [anon_sym_is] = ACTIONS(5556),
    [anon_sym_DASH_GT] = ACTIONS(5556),
    [anon_sym_with] = ACTIONS(5556),
    [aux_sym_preproc_if_token3] = ACTIONS(5556),
    [aux_sym_preproc_else_token1] = ACTIONS(5556),
    [aux_sym_preproc_elif_token1] = ACTIONS(5556),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3968] = {
    [sym_preproc_region] = STATE(3968),
    [sym_preproc_endregion] = STATE(3968),
    [sym_preproc_line] = STATE(3968),
    [sym_preproc_pragma] = STATE(3968),
    [sym_preproc_nullable] = STATE(3968),
    [sym_preproc_error] = STATE(3968),
    [sym_preproc_define] = STATE(3968),
    [sym_preproc_undef] = STATE(3968),
    [anon_sym_SEMI] = ACTIONS(5572),
    [anon_sym_LBRACK] = ACTIONS(5572),
    [anon_sym_COLON] = ACTIONS(5572),
    [anon_sym_COMMA] = ACTIONS(5572),
    [anon_sym_RBRACK] = ACTIONS(5572),
    [anon_sym_LPAREN] = ACTIONS(5572),
    [anon_sym_RPAREN] = ACTIONS(5572),
    [anon_sym_RBRACE] = ACTIONS(5572),
    [anon_sym_LT] = ACTIONS(5574),
    [anon_sym_GT] = ACTIONS(5574),
    [anon_sym_in] = ACTIONS(5574),
    [anon_sym_QMARK] = ACTIONS(5574),
    [anon_sym_BANG] = ACTIONS(5574),
    [anon_sym_PLUS_PLUS] = ACTIONS(5572),
    [anon_sym_DASH_DASH] = ACTIONS(5572),
    [anon_sym_PLUS] = ACTIONS(5574),
    [anon_sym_DASH] = ACTIONS(5574),
    [anon_sym_STAR] = ACTIONS(5572),
    [anon_sym_SLASH] = ACTIONS(5574),
    [anon_sym_PERCENT] = ACTIONS(5572),
    [anon_sym_CARET] = ACTIONS(5572),
    [anon_sym_PIPE] = ACTIONS(5574),
    [anon_sym_AMP] = ACTIONS(5574),
    [anon_sym_LT_LT] = ACTIONS(5572),
    [anon_sym_GT_GT] = ACTIONS(5574),
    [anon_sym_GT_GT_GT] = ACTIONS(5572),
    [anon_sym_EQ_EQ] = ACTIONS(5572),
    [anon_sym_BANG_EQ] = ACTIONS(5572),
    [anon_sym_GT_EQ] = ACTIONS(5572),
    [anon_sym_LT_EQ] = ACTIONS(5572),
    [anon_sym_DOT] = ACTIONS(5574),
    [anon_sym_EQ_GT] = ACTIONS(5572),
    [anon_sym_switch] = ACTIONS(5572),
    [anon_sym_when] = ACTIONS(5572),
    [anon_sym_DOT_DOT] = ACTIONS(5572),
    [anon_sym_and] = ACTIONS(5572),
    [anon_sym_or] = ACTIONS(5572),
    [anon_sym_AMP_AMP] = ACTIONS(5572),
    [anon_sym_PIPE_PIPE] = ACTIONS(5572),
    [anon_sym_QMARK_QMARK] = ACTIONS(5572),
    [anon_sym_into] = ACTIONS(5572),
    [anon_sym_on] = ACTIONS(5572),
    [anon_sym_equals] = ACTIONS(5572),
    [anon_sym_by] = ACTIONS(5572),
    [anon_sym_as] = ACTIONS(5572),
    [anon_sym_is] = ACTIONS(5572),
    [anon_sym_DASH_GT] = ACTIONS(5572),
    [anon_sym_with] = ACTIONS(5572),
    [aux_sym_preproc_if_token3] = ACTIONS(5572),
    [aux_sym_preproc_else_token1] = ACTIONS(5572),
    [aux_sym_preproc_elif_token1] = ACTIONS(5572),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3969] = {
    [sym_preproc_region] = STATE(3969),
    [sym_preproc_endregion] = STATE(3969),
    [sym_preproc_line] = STATE(3969),
    [sym_preproc_pragma] = STATE(3969),
    [sym_preproc_nullable] = STATE(3969),
    [sym_preproc_error] = STATE(3969),
    [sym_preproc_define] = STATE(3969),
    [sym_preproc_undef] = STATE(3969),
    [anon_sym_SEMI] = ACTIONS(5345),
    [anon_sym_LBRACK] = ACTIONS(5345),
    [anon_sym_COLON] = ACTIONS(5345),
    [anon_sym_COMMA] = ACTIONS(5345),
    [anon_sym_RBRACK] = ACTIONS(5345),
    [anon_sym_LPAREN] = ACTIONS(5345),
    [anon_sym_RPAREN] = ACTIONS(5345),
    [anon_sym_RBRACE] = ACTIONS(5345),
    [anon_sym_LT] = ACTIONS(5347),
    [anon_sym_GT] = ACTIONS(5347),
    [anon_sym_in] = ACTIONS(5347),
    [anon_sym_QMARK] = ACTIONS(5347),
    [anon_sym_BANG] = ACTIONS(5347),
    [anon_sym_PLUS_PLUS] = ACTIONS(5345),
    [anon_sym_DASH_DASH] = ACTIONS(5345),
    [anon_sym_PLUS] = ACTIONS(5347),
    [anon_sym_DASH] = ACTIONS(5347),
    [anon_sym_STAR] = ACTIONS(5345),
    [anon_sym_SLASH] = ACTIONS(5347),
    [anon_sym_PERCENT] = ACTIONS(5345),
    [anon_sym_CARET] = ACTIONS(5345),
    [anon_sym_PIPE] = ACTIONS(5347),
    [anon_sym_AMP] = ACTIONS(5347),
    [anon_sym_LT_LT] = ACTIONS(5345),
    [anon_sym_GT_GT] = ACTIONS(5347),
    [anon_sym_GT_GT_GT] = ACTIONS(5345),
    [anon_sym_EQ_EQ] = ACTIONS(5345),
    [anon_sym_BANG_EQ] = ACTIONS(5345),
    [anon_sym_GT_EQ] = ACTIONS(5345),
    [anon_sym_LT_EQ] = ACTIONS(5345),
    [anon_sym_DOT] = ACTIONS(5347),
    [anon_sym_EQ_GT] = ACTIONS(5345),
    [anon_sym_switch] = ACTIONS(5345),
    [anon_sym_when] = ACTIONS(5345),
    [anon_sym_DOT_DOT] = ACTIONS(5345),
    [anon_sym_and] = ACTIONS(5345),
    [anon_sym_or] = ACTIONS(5345),
    [anon_sym_AMP_AMP] = ACTIONS(5345),
    [anon_sym_PIPE_PIPE] = ACTIONS(5345),
    [anon_sym_QMARK_QMARK] = ACTIONS(5345),
    [anon_sym_into] = ACTIONS(5345),
    [anon_sym_on] = ACTIONS(5345),
    [anon_sym_equals] = ACTIONS(5345),
    [anon_sym_by] = ACTIONS(5345),
    [anon_sym_as] = ACTIONS(5345),
    [anon_sym_is] = ACTIONS(5345),
    [anon_sym_DASH_GT] = ACTIONS(5345),
    [anon_sym_with] = ACTIONS(5345),
    [aux_sym_preproc_if_token3] = ACTIONS(5345),
    [aux_sym_preproc_else_token1] = ACTIONS(5345),
    [aux_sym_preproc_elif_token1] = ACTIONS(5345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3970] = {
    [sym_preproc_region] = STATE(3970),
    [sym_preproc_endregion] = STATE(3970),
    [sym_preproc_line] = STATE(3970),
    [sym_preproc_pragma] = STATE(3970),
    [sym_preproc_nullable] = STATE(3970),
    [sym_preproc_error] = STATE(3970),
    [sym_preproc_define] = STATE(3970),
    [sym_preproc_undef] = STATE(3970),
    [anon_sym_SEMI] = ACTIONS(1963),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_COLON] = ACTIONS(1963),
    [anon_sym_COMMA] = ACTIONS(1963),
    [anon_sym_RBRACK] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1963),
    [anon_sym_RPAREN] = ACTIONS(1963),
    [anon_sym_RBRACE] = ACTIONS(1963),
    [anon_sym_LT] = ACTIONS(1965),
    [anon_sym_GT] = ACTIONS(1965),
    [anon_sym_in] = ACTIONS(1965),
    [anon_sym_QMARK] = ACTIONS(1965),
    [anon_sym_BANG] = ACTIONS(1965),
    [anon_sym_PLUS_PLUS] = ACTIONS(1963),
    [anon_sym_DASH_DASH] = ACTIONS(1963),
    [anon_sym_PLUS] = ACTIONS(1965),
    [anon_sym_DASH] = ACTIONS(1965),
    [anon_sym_STAR] = ACTIONS(1963),
    [anon_sym_SLASH] = ACTIONS(1965),
    [anon_sym_PERCENT] = ACTIONS(1963),
    [anon_sym_CARET] = ACTIONS(1963),
    [anon_sym_PIPE] = ACTIONS(1965),
    [anon_sym_AMP] = ACTIONS(1965),
    [anon_sym_LT_LT] = ACTIONS(1963),
    [anon_sym_GT_GT] = ACTIONS(1965),
    [anon_sym_GT_GT_GT] = ACTIONS(1963),
    [anon_sym_EQ_EQ] = ACTIONS(1963),
    [anon_sym_BANG_EQ] = ACTIONS(1963),
    [anon_sym_GT_EQ] = ACTIONS(1963),
    [anon_sym_LT_EQ] = ACTIONS(1963),
    [anon_sym_DOT] = ACTIONS(1965),
    [anon_sym_EQ_GT] = ACTIONS(1963),
    [anon_sym_switch] = ACTIONS(1963),
    [anon_sym_when] = ACTIONS(1963),
    [anon_sym_DOT_DOT] = ACTIONS(1963),
    [anon_sym_and] = ACTIONS(1963),
    [anon_sym_or] = ACTIONS(1963),
    [anon_sym_AMP_AMP] = ACTIONS(1963),
    [anon_sym_PIPE_PIPE] = ACTIONS(1963),
    [anon_sym_QMARK_QMARK] = ACTIONS(1963),
    [anon_sym_into] = ACTIONS(1963),
    [anon_sym_on] = ACTIONS(1963),
    [anon_sym_equals] = ACTIONS(1963),
    [anon_sym_by] = ACTIONS(1963),
    [anon_sym_as] = ACTIONS(1963),
    [anon_sym_is] = ACTIONS(1963),
    [anon_sym_DASH_GT] = ACTIONS(1963),
    [anon_sym_with] = ACTIONS(1963),
    [aux_sym_preproc_if_token3] = ACTIONS(1963),
    [aux_sym_preproc_else_token1] = ACTIONS(1963),
    [aux_sym_preproc_elif_token1] = ACTIONS(1963),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3971] = {
    [sym_preproc_region] = STATE(3971),
    [sym_preproc_endregion] = STATE(3971),
    [sym_preproc_line] = STATE(3971),
    [sym_preproc_pragma] = STATE(3971),
    [sym_preproc_nullable] = STATE(3971),
    [sym_preproc_error] = STATE(3971),
    [sym_preproc_define] = STATE(3971),
    [sym_preproc_undef] = STATE(3971),
    [anon_sym_SEMI] = ACTIONS(5466),
    [anon_sym_LBRACK] = ACTIONS(5466),
    [anon_sym_COLON] = ACTIONS(5466),
    [anon_sym_COMMA] = ACTIONS(5466),
    [anon_sym_RBRACK] = ACTIONS(5466),
    [anon_sym_LPAREN] = ACTIONS(5466),
    [anon_sym_RPAREN] = ACTIONS(5466),
    [anon_sym_RBRACE] = ACTIONS(5466),
    [anon_sym_LT] = ACTIONS(5468),
    [anon_sym_GT] = ACTIONS(5468),
    [anon_sym_in] = ACTIONS(5468),
    [anon_sym_QMARK] = ACTIONS(5468),
    [anon_sym_BANG] = ACTIONS(5468),
    [anon_sym_PLUS_PLUS] = ACTIONS(5466),
    [anon_sym_DASH_DASH] = ACTIONS(5466),
    [anon_sym_PLUS] = ACTIONS(5468),
    [anon_sym_DASH] = ACTIONS(5468),
    [anon_sym_STAR] = ACTIONS(5466),
    [anon_sym_SLASH] = ACTIONS(5468),
    [anon_sym_PERCENT] = ACTIONS(5466),
    [anon_sym_CARET] = ACTIONS(5466),
    [anon_sym_PIPE] = ACTIONS(5468),
    [anon_sym_AMP] = ACTIONS(5468),
    [anon_sym_LT_LT] = ACTIONS(5466),
    [anon_sym_GT_GT] = ACTIONS(5468),
    [anon_sym_GT_GT_GT] = ACTIONS(5466),
    [anon_sym_EQ_EQ] = ACTIONS(5466),
    [anon_sym_BANG_EQ] = ACTIONS(5466),
    [anon_sym_GT_EQ] = ACTIONS(5466),
    [anon_sym_LT_EQ] = ACTIONS(5466),
    [anon_sym_DOT] = ACTIONS(5468),
    [anon_sym_EQ_GT] = ACTIONS(5466),
    [anon_sym_switch] = ACTIONS(5466),
    [anon_sym_when] = ACTIONS(5466),
    [anon_sym_DOT_DOT] = ACTIONS(5466),
    [anon_sym_and] = ACTIONS(5466),
    [anon_sym_or] = ACTIONS(5466),
    [anon_sym_AMP_AMP] = ACTIONS(5466),
    [anon_sym_PIPE_PIPE] = ACTIONS(5466),
    [anon_sym_QMARK_QMARK] = ACTIONS(5466),
    [anon_sym_into] = ACTIONS(5466),
    [anon_sym_on] = ACTIONS(5466),
    [anon_sym_equals] = ACTIONS(5466),
    [anon_sym_by] = ACTIONS(5466),
    [anon_sym_as] = ACTIONS(5466),
    [anon_sym_is] = ACTIONS(5466),
    [anon_sym_DASH_GT] = ACTIONS(5466),
    [anon_sym_with] = ACTIONS(5466),
    [aux_sym_preproc_if_token3] = ACTIONS(5466),
    [aux_sym_preproc_else_token1] = ACTIONS(5466),
    [aux_sym_preproc_elif_token1] = ACTIONS(5466),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3972] = {
    [sym_preproc_region] = STATE(3972),
    [sym_preproc_endregion] = STATE(3972),
    [sym_preproc_line] = STATE(3972),
    [sym_preproc_pragma] = STATE(3972),
    [sym_preproc_nullable] = STATE(3972),
    [sym_preproc_error] = STATE(3972),
    [sym_preproc_define] = STATE(3972),
    [sym_preproc_undef] = STATE(3972),
    [anon_sym_SEMI] = ACTIONS(5444),
    [anon_sym_LBRACK] = ACTIONS(5444),
    [anon_sym_COLON] = ACTIONS(5444),
    [anon_sym_COMMA] = ACTIONS(5444),
    [anon_sym_RBRACK] = ACTIONS(5444),
    [anon_sym_LPAREN] = ACTIONS(5444),
    [anon_sym_RPAREN] = ACTIONS(5444),
    [anon_sym_RBRACE] = ACTIONS(5444),
    [anon_sym_LT] = ACTIONS(5446),
    [anon_sym_GT] = ACTIONS(5446),
    [anon_sym_in] = ACTIONS(5446),
    [anon_sym_QMARK] = ACTIONS(5446),
    [anon_sym_BANG] = ACTIONS(5446),
    [anon_sym_PLUS_PLUS] = ACTIONS(5444),
    [anon_sym_DASH_DASH] = ACTIONS(5444),
    [anon_sym_PLUS] = ACTIONS(5446),
    [anon_sym_DASH] = ACTIONS(5446),
    [anon_sym_STAR] = ACTIONS(5444),
    [anon_sym_SLASH] = ACTIONS(5446),
    [anon_sym_PERCENT] = ACTIONS(5444),
    [anon_sym_CARET] = ACTIONS(5444),
    [anon_sym_PIPE] = ACTIONS(5446),
    [anon_sym_AMP] = ACTIONS(5446),
    [anon_sym_LT_LT] = ACTIONS(5444),
    [anon_sym_GT_GT] = ACTIONS(5446),
    [anon_sym_GT_GT_GT] = ACTIONS(5444),
    [anon_sym_EQ_EQ] = ACTIONS(5444),
    [anon_sym_BANG_EQ] = ACTIONS(5444),
    [anon_sym_GT_EQ] = ACTIONS(5444),
    [anon_sym_LT_EQ] = ACTIONS(5444),
    [anon_sym_DOT] = ACTIONS(5446),
    [anon_sym_EQ_GT] = ACTIONS(5444),
    [anon_sym_switch] = ACTIONS(5444),
    [anon_sym_when] = ACTIONS(5444),
    [anon_sym_DOT_DOT] = ACTIONS(5444),
    [anon_sym_and] = ACTIONS(5444),
    [anon_sym_or] = ACTIONS(5444),
    [anon_sym_AMP_AMP] = ACTIONS(5444),
    [anon_sym_PIPE_PIPE] = ACTIONS(5444),
    [anon_sym_QMARK_QMARK] = ACTIONS(5444),
    [anon_sym_into] = ACTIONS(5444),
    [anon_sym_on] = ACTIONS(5444),
    [anon_sym_equals] = ACTIONS(5444),
    [anon_sym_by] = ACTIONS(5444),
    [anon_sym_as] = ACTIONS(5444),
    [anon_sym_is] = ACTIONS(5444),
    [anon_sym_DASH_GT] = ACTIONS(5444),
    [anon_sym_with] = ACTIONS(5444),
    [aux_sym_preproc_if_token3] = ACTIONS(5444),
    [aux_sym_preproc_else_token1] = ACTIONS(5444),
    [aux_sym_preproc_elif_token1] = ACTIONS(5444),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3973] = {
    [sym_preproc_region] = STATE(3973),
    [sym_preproc_endregion] = STATE(3973),
    [sym_preproc_line] = STATE(3973),
    [sym_preproc_pragma] = STATE(3973),
    [sym_preproc_nullable] = STATE(3973),
    [sym_preproc_error] = STATE(3973),
    [sym_preproc_define] = STATE(3973),
    [sym_preproc_undef] = STATE(3973),
    [anon_sym_SEMI] = ACTIONS(5506),
    [anon_sym_LBRACK] = ACTIONS(5506),
    [anon_sym_COLON] = ACTIONS(5506),
    [anon_sym_COMMA] = ACTIONS(5506),
    [anon_sym_RBRACK] = ACTIONS(5506),
    [anon_sym_LPAREN] = ACTIONS(5506),
    [anon_sym_RPAREN] = ACTIONS(5506),
    [anon_sym_RBRACE] = ACTIONS(5506),
    [anon_sym_LT] = ACTIONS(5508),
    [anon_sym_GT] = ACTIONS(5508),
    [anon_sym_in] = ACTIONS(5508),
    [anon_sym_QMARK] = ACTIONS(5508),
    [anon_sym_BANG] = ACTIONS(5508),
    [anon_sym_PLUS_PLUS] = ACTIONS(5506),
    [anon_sym_DASH_DASH] = ACTIONS(5506),
    [anon_sym_PLUS] = ACTIONS(5508),
    [anon_sym_DASH] = ACTIONS(5508),
    [anon_sym_STAR] = ACTIONS(5506),
    [anon_sym_SLASH] = ACTIONS(5508),
    [anon_sym_PERCENT] = ACTIONS(5506),
    [anon_sym_CARET] = ACTIONS(5506),
    [anon_sym_PIPE] = ACTIONS(5508),
    [anon_sym_AMP] = ACTIONS(5508),
    [anon_sym_LT_LT] = ACTIONS(5506),
    [anon_sym_GT_GT] = ACTIONS(5508),
    [anon_sym_GT_GT_GT] = ACTIONS(5506),
    [anon_sym_EQ_EQ] = ACTIONS(5506),
    [anon_sym_BANG_EQ] = ACTIONS(5506),
    [anon_sym_GT_EQ] = ACTIONS(5506),
    [anon_sym_LT_EQ] = ACTIONS(5506),
    [anon_sym_DOT] = ACTIONS(5508),
    [anon_sym_EQ_GT] = ACTIONS(5506),
    [anon_sym_switch] = ACTIONS(5506),
    [anon_sym_when] = ACTIONS(5506),
    [anon_sym_DOT_DOT] = ACTIONS(5506),
    [anon_sym_and] = ACTIONS(5506),
    [anon_sym_or] = ACTIONS(5506),
    [anon_sym_AMP_AMP] = ACTIONS(5506),
    [anon_sym_PIPE_PIPE] = ACTIONS(5506),
    [anon_sym_QMARK_QMARK] = ACTIONS(5506),
    [anon_sym_into] = ACTIONS(5506),
    [anon_sym_on] = ACTIONS(5506),
    [anon_sym_equals] = ACTIONS(5506),
    [anon_sym_by] = ACTIONS(5506),
    [anon_sym_as] = ACTIONS(5506),
    [anon_sym_is] = ACTIONS(5506),
    [anon_sym_DASH_GT] = ACTIONS(5506),
    [anon_sym_with] = ACTIONS(5506),
    [aux_sym_preproc_if_token3] = ACTIONS(5506),
    [aux_sym_preproc_else_token1] = ACTIONS(5506),
    [aux_sym_preproc_elif_token1] = ACTIONS(5506),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3974] = {
    [sym_preproc_region] = STATE(3974),
    [sym_preproc_endregion] = STATE(3974),
    [sym_preproc_line] = STATE(3974),
    [sym_preproc_pragma] = STATE(3974),
    [sym_preproc_nullable] = STATE(3974),
    [sym_preproc_error] = STATE(3974),
    [sym_preproc_define] = STATE(3974),
    [sym_preproc_undef] = STATE(3974),
    [anon_sym_SEMI] = ACTIONS(5452),
    [anon_sym_LBRACK] = ACTIONS(5452),
    [anon_sym_COLON] = ACTIONS(5452),
    [anon_sym_COMMA] = ACTIONS(5452),
    [anon_sym_RBRACK] = ACTIONS(5452),
    [anon_sym_LPAREN] = ACTIONS(5452),
    [anon_sym_RPAREN] = ACTIONS(5452),
    [anon_sym_RBRACE] = ACTIONS(5452),
    [anon_sym_LT] = ACTIONS(5454),
    [anon_sym_GT] = ACTIONS(5454),
    [anon_sym_in] = ACTIONS(5454),
    [anon_sym_QMARK] = ACTIONS(5454),
    [anon_sym_BANG] = ACTIONS(5454),
    [anon_sym_PLUS_PLUS] = ACTIONS(5452),
    [anon_sym_DASH_DASH] = ACTIONS(5452),
    [anon_sym_PLUS] = ACTIONS(5454),
    [anon_sym_DASH] = ACTIONS(5454),
    [anon_sym_STAR] = ACTIONS(5452),
    [anon_sym_SLASH] = ACTIONS(5454),
    [anon_sym_PERCENT] = ACTIONS(5452),
    [anon_sym_CARET] = ACTIONS(5452),
    [anon_sym_PIPE] = ACTIONS(5454),
    [anon_sym_AMP] = ACTIONS(5454),
    [anon_sym_LT_LT] = ACTIONS(5452),
    [anon_sym_GT_GT] = ACTIONS(5454),
    [anon_sym_GT_GT_GT] = ACTIONS(5452),
    [anon_sym_EQ_EQ] = ACTIONS(5452),
    [anon_sym_BANG_EQ] = ACTIONS(5452),
    [anon_sym_GT_EQ] = ACTIONS(5452),
    [anon_sym_LT_EQ] = ACTIONS(5452),
    [anon_sym_DOT] = ACTIONS(5454),
    [anon_sym_EQ_GT] = ACTIONS(5452),
    [anon_sym_switch] = ACTIONS(5452),
    [anon_sym_when] = ACTIONS(5452),
    [anon_sym_DOT_DOT] = ACTIONS(5452),
    [anon_sym_and] = ACTIONS(5452),
    [anon_sym_or] = ACTIONS(5452),
    [anon_sym_AMP_AMP] = ACTIONS(5452),
    [anon_sym_PIPE_PIPE] = ACTIONS(5452),
    [anon_sym_QMARK_QMARK] = ACTIONS(5452),
    [anon_sym_into] = ACTIONS(5452),
    [anon_sym_on] = ACTIONS(5452),
    [anon_sym_equals] = ACTIONS(5452),
    [anon_sym_by] = ACTIONS(5452),
    [anon_sym_as] = ACTIONS(5452),
    [anon_sym_is] = ACTIONS(5452),
    [anon_sym_DASH_GT] = ACTIONS(5452),
    [anon_sym_with] = ACTIONS(5452),
    [aux_sym_preproc_if_token3] = ACTIONS(5452),
    [aux_sym_preproc_else_token1] = ACTIONS(5452),
    [aux_sym_preproc_elif_token1] = ACTIONS(5452),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3975] = {
    [sym_preproc_region] = STATE(3975),
    [sym_preproc_endregion] = STATE(3975),
    [sym_preproc_line] = STATE(3975),
    [sym_preproc_pragma] = STATE(3975),
    [sym_preproc_nullable] = STATE(3975),
    [sym_preproc_error] = STATE(3975),
    [sym_preproc_define] = STATE(3975),
    [sym_preproc_undef] = STATE(3975),
    [anon_sym_SEMI] = ACTIONS(5482),
    [anon_sym_LBRACK] = ACTIONS(5482),
    [anon_sym_COLON] = ACTIONS(5482),
    [anon_sym_COMMA] = ACTIONS(5482),
    [anon_sym_RBRACK] = ACTIONS(5482),
    [anon_sym_LPAREN] = ACTIONS(5482),
    [anon_sym_RPAREN] = ACTIONS(5482),
    [anon_sym_RBRACE] = ACTIONS(5482),
    [anon_sym_LT] = ACTIONS(5484),
    [anon_sym_GT] = ACTIONS(5484),
    [anon_sym_in] = ACTIONS(5484),
    [anon_sym_QMARK] = ACTIONS(5484),
    [anon_sym_BANG] = ACTIONS(5484),
    [anon_sym_PLUS_PLUS] = ACTIONS(5482),
    [anon_sym_DASH_DASH] = ACTIONS(5482),
    [anon_sym_PLUS] = ACTIONS(5484),
    [anon_sym_DASH] = ACTIONS(5484),
    [anon_sym_STAR] = ACTIONS(5482),
    [anon_sym_SLASH] = ACTIONS(5484),
    [anon_sym_PERCENT] = ACTIONS(5482),
    [anon_sym_CARET] = ACTIONS(5482),
    [anon_sym_PIPE] = ACTIONS(5484),
    [anon_sym_AMP] = ACTIONS(5484),
    [anon_sym_LT_LT] = ACTIONS(5482),
    [anon_sym_GT_GT] = ACTIONS(5484),
    [anon_sym_GT_GT_GT] = ACTIONS(5482),
    [anon_sym_EQ_EQ] = ACTIONS(5482),
    [anon_sym_BANG_EQ] = ACTIONS(5482),
    [anon_sym_GT_EQ] = ACTIONS(5482),
    [anon_sym_LT_EQ] = ACTIONS(5482),
    [anon_sym_DOT] = ACTIONS(5484),
    [anon_sym_EQ_GT] = ACTIONS(5482),
    [anon_sym_switch] = ACTIONS(5482),
    [anon_sym_when] = ACTIONS(5482),
    [anon_sym_DOT_DOT] = ACTIONS(5482),
    [anon_sym_and] = ACTIONS(5482),
    [anon_sym_or] = ACTIONS(5482),
    [anon_sym_AMP_AMP] = ACTIONS(5482),
    [anon_sym_PIPE_PIPE] = ACTIONS(5482),
    [anon_sym_QMARK_QMARK] = ACTIONS(5482),
    [anon_sym_into] = ACTIONS(5482),
    [anon_sym_on] = ACTIONS(5482),
    [anon_sym_equals] = ACTIONS(5482),
    [anon_sym_by] = ACTIONS(5482),
    [anon_sym_as] = ACTIONS(5482),
    [anon_sym_is] = ACTIONS(5482),
    [anon_sym_DASH_GT] = ACTIONS(5482),
    [anon_sym_with] = ACTIONS(5482),
    [aux_sym_preproc_if_token3] = ACTIONS(5482),
    [aux_sym_preproc_else_token1] = ACTIONS(5482),
    [aux_sym_preproc_elif_token1] = ACTIONS(5482),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3976] = {
    [sym_preproc_region] = STATE(3976),
    [sym_preproc_endregion] = STATE(3976),
    [sym_preproc_line] = STATE(3976),
    [sym_preproc_pragma] = STATE(3976),
    [sym_preproc_nullable] = STATE(3976),
    [sym_preproc_error] = STATE(3976),
    [sym_preproc_define] = STATE(3976),
    [sym_preproc_undef] = STATE(3976),
    [anon_sym_SEMI] = ACTIONS(5594),
    [anon_sym_LBRACK] = ACTIONS(5594),
    [anon_sym_COLON] = ACTIONS(5594),
    [anon_sym_COMMA] = ACTIONS(5594),
    [anon_sym_RBRACK] = ACTIONS(5594),
    [anon_sym_LPAREN] = ACTIONS(5594),
    [anon_sym_RPAREN] = ACTIONS(5594),
    [anon_sym_RBRACE] = ACTIONS(5594),
    [anon_sym_LT] = ACTIONS(5596),
    [anon_sym_GT] = ACTIONS(5596),
    [anon_sym_in] = ACTIONS(5596),
    [anon_sym_QMARK] = ACTIONS(5596),
    [anon_sym_BANG] = ACTIONS(5596),
    [anon_sym_PLUS_PLUS] = ACTIONS(5594),
    [anon_sym_DASH_DASH] = ACTIONS(5594),
    [anon_sym_PLUS] = ACTIONS(5596),
    [anon_sym_DASH] = ACTIONS(5596),
    [anon_sym_STAR] = ACTIONS(5594),
    [anon_sym_SLASH] = ACTIONS(5596),
    [anon_sym_PERCENT] = ACTIONS(5594),
    [anon_sym_CARET] = ACTIONS(5594),
    [anon_sym_PIPE] = ACTIONS(5596),
    [anon_sym_AMP] = ACTIONS(5596),
    [anon_sym_LT_LT] = ACTIONS(5594),
    [anon_sym_GT_GT] = ACTIONS(5596),
    [anon_sym_GT_GT_GT] = ACTIONS(5594),
    [anon_sym_EQ_EQ] = ACTIONS(5594),
    [anon_sym_BANG_EQ] = ACTIONS(5594),
    [anon_sym_GT_EQ] = ACTIONS(5594),
    [anon_sym_LT_EQ] = ACTIONS(5594),
    [anon_sym_DOT] = ACTIONS(5596),
    [anon_sym_EQ_GT] = ACTIONS(5594),
    [anon_sym_switch] = ACTIONS(5594),
    [anon_sym_when] = ACTIONS(5594),
    [anon_sym_DOT_DOT] = ACTIONS(5594),
    [anon_sym_and] = ACTIONS(5594),
    [anon_sym_or] = ACTIONS(5594),
    [anon_sym_AMP_AMP] = ACTIONS(5594),
    [anon_sym_PIPE_PIPE] = ACTIONS(5594),
    [anon_sym_QMARK_QMARK] = ACTIONS(5594),
    [anon_sym_into] = ACTIONS(5594),
    [anon_sym_on] = ACTIONS(5594),
    [anon_sym_equals] = ACTIONS(5594),
    [anon_sym_by] = ACTIONS(5594),
    [anon_sym_as] = ACTIONS(5594),
    [anon_sym_is] = ACTIONS(5594),
    [anon_sym_DASH_GT] = ACTIONS(5594),
    [anon_sym_with] = ACTIONS(5594),
    [aux_sym_preproc_if_token3] = ACTIONS(5594),
    [aux_sym_preproc_else_token1] = ACTIONS(5594),
    [aux_sym_preproc_elif_token1] = ACTIONS(5594),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3977] = {
    [sym_preproc_region] = STATE(3977),
    [sym_preproc_endregion] = STATE(3977),
    [sym_preproc_line] = STATE(3977),
    [sym_preproc_pragma] = STATE(3977),
    [sym_preproc_nullable] = STATE(3977),
    [sym_preproc_error] = STATE(3977),
    [sym_preproc_define] = STATE(3977),
    [sym_preproc_undef] = STATE(3977),
    [anon_sym_SEMI] = ACTIONS(5337),
    [anon_sym_LBRACK] = ACTIONS(5337),
    [anon_sym_COLON] = ACTIONS(5337),
    [anon_sym_COMMA] = ACTIONS(5337),
    [anon_sym_RBRACK] = ACTIONS(5337),
    [anon_sym_LPAREN] = ACTIONS(5337),
    [anon_sym_RPAREN] = ACTIONS(5337),
    [anon_sym_RBRACE] = ACTIONS(5337),
    [anon_sym_LT] = ACTIONS(5339),
    [anon_sym_GT] = ACTIONS(5339),
    [anon_sym_in] = ACTIONS(5339),
    [anon_sym_QMARK] = ACTIONS(5339),
    [anon_sym_BANG] = ACTIONS(5339),
    [anon_sym_PLUS_PLUS] = ACTIONS(5337),
    [anon_sym_DASH_DASH] = ACTIONS(5337),
    [anon_sym_PLUS] = ACTIONS(5339),
    [anon_sym_DASH] = ACTIONS(5339),
    [anon_sym_STAR] = ACTIONS(5337),
    [anon_sym_SLASH] = ACTIONS(5339),
    [anon_sym_PERCENT] = ACTIONS(5337),
    [anon_sym_CARET] = ACTIONS(5337),
    [anon_sym_PIPE] = ACTIONS(5339),
    [anon_sym_AMP] = ACTIONS(5339),
    [anon_sym_LT_LT] = ACTIONS(5337),
    [anon_sym_GT_GT] = ACTIONS(5339),
    [anon_sym_GT_GT_GT] = ACTIONS(5337),
    [anon_sym_EQ_EQ] = ACTIONS(5337),
    [anon_sym_BANG_EQ] = ACTIONS(5337),
    [anon_sym_GT_EQ] = ACTIONS(5337),
    [anon_sym_LT_EQ] = ACTIONS(5337),
    [anon_sym_DOT] = ACTIONS(5339),
    [anon_sym_EQ_GT] = ACTIONS(5337),
    [anon_sym_switch] = ACTIONS(5337),
    [anon_sym_when] = ACTIONS(5337),
    [anon_sym_DOT_DOT] = ACTIONS(5337),
    [anon_sym_and] = ACTIONS(5337),
    [anon_sym_or] = ACTIONS(5337),
    [anon_sym_AMP_AMP] = ACTIONS(5337),
    [anon_sym_PIPE_PIPE] = ACTIONS(5337),
    [anon_sym_QMARK_QMARK] = ACTIONS(5337),
    [anon_sym_into] = ACTIONS(5337),
    [anon_sym_on] = ACTIONS(5337),
    [anon_sym_equals] = ACTIONS(5337),
    [anon_sym_by] = ACTIONS(5337),
    [anon_sym_as] = ACTIONS(5337),
    [anon_sym_is] = ACTIONS(5337),
    [anon_sym_DASH_GT] = ACTIONS(5337),
    [anon_sym_with] = ACTIONS(5337),
    [aux_sym_preproc_if_token3] = ACTIONS(5337),
    [aux_sym_preproc_else_token1] = ACTIONS(5337),
    [aux_sym_preproc_elif_token1] = ACTIONS(5337),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3978] = {
    [sym_preproc_region] = STATE(3978),
    [sym_preproc_endregion] = STATE(3978),
    [sym_preproc_line] = STATE(3978),
    [sym_preproc_pragma] = STATE(3978),
    [sym_preproc_nullable] = STATE(3978),
    [sym_preproc_error] = STATE(3978),
    [sym_preproc_define] = STATE(3978),
    [sym_preproc_undef] = STATE(3978),
    [anon_sym_SEMI] = ACTIONS(5349),
    [anon_sym_LBRACK] = ACTIONS(5349),
    [anon_sym_COLON] = ACTIONS(5349),
    [anon_sym_COMMA] = ACTIONS(5349),
    [anon_sym_RBRACK] = ACTIONS(5349),
    [anon_sym_LPAREN] = ACTIONS(5349),
    [anon_sym_RPAREN] = ACTIONS(5349),
    [anon_sym_RBRACE] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_in] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5351),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS_PLUS] = ACTIONS(5349),
    [anon_sym_DASH_DASH] = ACTIONS(5349),
    [anon_sym_PLUS] = ACTIONS(5351),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_STAR] = ACTIONS(5349),
    [anon_sym_SLASH] = ACTIONS(5351),
    [anon_sym_PERCENT] = ACTIONS(5349),
    [anon_sym_CARET] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_LT_LT] = ACTIONS(5349),
    [anon_sym_GT_GT] = ACTIONS(5351),
    [anon_sym_GT_GT_GT] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_DOT] = ACTIONS(5351),
    [anon_sym_EQ_GT] = ACTIONS(5349),
    [anon_sym_switch] = ACTIONS(5349),
    [anon_sym_when] = ACTIONS(5349),
    [anon_sym_DOT_DOT] = ACTIONS(5349),
    [anon_sym_and] = ACTIONS(5349),
    [anon_sym_or] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_QMARK_QMARK] = ACTIONS(5349),
    [anon_sym_into] = ACTIONS(5349),
    [anon_sym_on] = ACTIONS(5349),
    [anon_sym_equals] = ACTIONS(5349),
    [anon_sym_by] = ACTIONS(5349),
    [anon_sym_as] = ACTIONS(5349),
    [anon_sym_is] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5349),
    [anon_sym_with] = ACTIONS(5349),
    [aux_sym_preproc_if_token3] = ACTIONS(5349),
    [aux_sym_preproc_else_token1] = ACTIONS(5349),
    [aux_sym_preproc_elif_token1] = ACTIONS(5349),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3979] = {
    [sym_modifier] = STATE(4458),
    [sym_identifier] = STATE(7908),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_region] = STATE(3979),
    [sym_preproc_endregion] = STATE(3979),
    [sym_preproc_line] = STATE(3979),
    [sym_preproc_pragma] = STATE(3979),
    [sym_preproc_nullable] = STATE(3979),
    [sym_preproc_error] = STATE(3979),
    [sym_preproc_define] = STATE(3979),
    [sym_preproc_undef] = STATE(3979),
    [aux_sym_class_declaration_repeat2] = STATE(4334),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(5456),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_unsafe] = ACTIONS(5456),
    [anon_sym_static] = ACTIONS(5456),
    [anon_sym_abstract] = ACTIONS(5456),
    [anon_sym_async] = ACTIONS(5456),
    [anon_sym_const] = ACTIONS(5456),
    [anon_sym_file] = ACTIONS(5462),
    [anon_sym_fixed] = ACTIONS(5456),
    [anon_sym_internal] = ACTIONS(5456),
    [anon_sym_new] = ACTIONS(5456),
    [anon_sym_override] = ACTIONS(5456),
    [anon_sym_partial] = ACTIONS(5456),
    [anon_sym_private] = ACTIONS(5456),
    [anon_sym_protected] = ACTIONS(5456),
    [anon_sym_public] = ACTIONS(5456),
    [anon_sym_readonly] = ACTIONS(5456),
    [anon_sym_required] = ACTIONS(5456),
    [anon_sym_sealed] = ACTIONS(5456),
    [anon_sym_virtual] = ACTIONS(5456),
    [anon_sym_volatile] = ACTIONS(5456),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_get] = ACTIONS(5771),
    [anon_sym_set] = ACTIONS(5771),
    [anon_sym_add] = ACTIONS(5771),
    [anon_sym_remove] = ACTIONS(5771),
    [anon_sym_init] = ACTIONS(5771),
    [anon_sym_scoped] = ACTIONS(27),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_from] = ACTIONS(27),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3980] = {
    [sym_preproc_region] = STATE(3980),
    [sym_preproc_endregion] = STATE(3980),
    [sym_preproc_line] = STATE(3980),
    [sym_preproc_pragma] = STATE(3980),
    [sym_preproc_nullable] = STATE(3980),
    [sym_preproc_error] = STATE(3980),
    [sym_preproc_define] = STATE(3980),
    [sym_preproc_undef] = STATE(3980),
    [anon_sym_SEMI] = ACTIONS(5353),
    [anon_sym_LBRACK] = ACTIONS(5353),
    [anon_sym_COLON] = ACTIONS(5353),
    [anon_sym_COMMA] = ACTIONS(5353),
    [anon_sym_RBRACK] = ACTIONS(5353),
    [anon_sym_LPAREN] = ACTIONS(5353),
    [anon_sym_RPAREN] = ACTIONS(5353),
    [anon_sym_RBRACE] = ACTIONS(5353),
    [anon_sym_LT] = ACTIONS(5355),
    [anon_sym_GT] = ACTIONS(5355),
    [anon_sym_in] = ACTIONS(5355),
    [anon_sym_QMARK] = ACTIONS(5355),
    [anon_sym_BANG] = ACTIONS(5355),
    [anon_sym_PLUS_PLUS] = ACTIONS(5353),
    [anon_sym_DASH_DASH] = ACTIONS(5353),
    [anon_sym_PLUS] = ACTIONS(5355),
    [anon_sym_DASH] = ACTIONS(5355),
    [anon_sym_STAR] = ACTIONS(5353),
    [anon_sym_SLASH] = ACTIONS(5355),
    [anon_sym_PERCENT] = ACTIONS(5353),
    [anon_sym_CARET] = ACTIONS(5353),
    [anon_sym_PIPE] = ACTIONS(5355),
    [anon_sym_AMP] = ACTIONS(5355),
    [anon_sym_LT_LT] = ACTIONS(5353),
    [anon_sym_GT_GT] = ACTIONS(5355),
    [anon_sym_GT_GT_GT] = ACTIONS(5353),
    [anon_sym_EQ_EQ] = ACTIONS(5353),
    [anon_sym_BANG_EQ] = ACTIONS(5353),
    [anon_sym_GT_EQ] = ACTIONS(5353),
    [anon_sym_LT_EQ] = ACTIONS(5353),
    [anon_sym_DOT] = ACTIONS(5355),
    [anon_sym_EQ_GT] = ACTIONS(5353),
    [anon_sym_switch] = ACTIONS(5353),
    [anon_sym_when] = ACTIONS(5353),
    [anon_sym_DOT_DOT] = ACTIONS(5353),
    [anon_sym_and] = ACTIONS(5353),
    [anon_sym_or] = ACTIONS(5353),
    [anon_sym_AMP_AMP] = ACTIONS(5353),
    [anon_sym_PIPE_PIPE] = ACTIONS(5353),
    [anon_sym_QMARK_QMARK] = ACTIONS(5353),
    [anon_sym_into] = ACTIONS(5353),
    [anon_sym_on] = ACTIONS(5353),
    [anon_sym_equals] = ACTIONS(5353),
    [anon_sym_by] = ACTIONS(5353),
    [anon_sym_as] = ACTIONS(5353),
    [anon_sym_is] = ACTIONS(5353),
    [anon_sym_DASH_GT] = ACTIONS(5353),
    [anon_sym_with] = ACTIONS(5353),
    [aux_sym_preproc_if_token3] = ACTIONS(5353),
    [aux_sym_preproc_else_token1] = ACTIONS(5353),
    [aux_sym_preproc_elif_token1] = ACTIONS(5353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3981] = {
    [sym_preproc_region] = STATE(3981),
    [sym_preproc_endregion] = STATE(3981),
    [sym_preproc_line] = STATE(3981),
    [sym_preproc_pragma] = STATE(3981),
    [sym_preproc_nullable] = STATE(3981),
    [sym_preproc_error] = STATE(3981),
    [sym_preproc_define] = STATE(3981),
    [sym_preproc_undef] = STATE(3981),
    [anon_sym_SEMI] = ACTIONS(5357),
    [anon_sym_LBRACK] = ACTIONS(5357),
    [anon_sym_COLON] = ACTIONS(5357),
    [anon_sym_COMMA] = ACTIONS(5357),
    [anon_sym_RBRACK] = ACTIONS(5357),
    [anon_sym_LPAREN] = ACTIONS(5357),
    [anon_sym_RPAREN] = ACTIONS(5357),
    [anon_sym_RBRACE] = ACTIONS(5357),
    [anon_sym_LT] = ACTIONS(5359),
    [anon_sym_GT] = ACTIONS(5359),
    [anon_sym_in] = ACTIONS(5359),
    [anon_sym_QMARK] = ACTIONS(5359),
    [anon_sym_BANG] = ACTIONS(5359),
    [anon_sym_PLUS_PLUS] = ACTIONS(5357),
    [anon_sym_DASH_DASH] = ACTIONS(5357),
    [anon_sym_PLUS] = ACTIONS(5359),
    [anon_sym_DASH] = ACTIONS(5359),
    [anon_sym_STAR] = ACTIONS(5357),
    [anon_sym_SLASH] = ACTIONS(5359),
    [anon_sym_PERCENT] = ACTIONS(5357),
    [anon_sym_CARET] = ACTIONS(5357),
    [anon_sym_PIPE] = ACTIONS(5359),
    [anon_sym_AMP] = ACTIONS(5359),
    [anon_sym_LT_LT] = ACTIONS(5357),
    [anon_sym_GT_GT] = ACTIONS(5359),
    [anon_sym_GT_GT_GT] = ACTIONS(5357),
    [anon_sym_EQ_EQ] = ACTIONS(5357),
    [anon_sym_BANG_EQ] = ACTIONS(5357),
    [anon_sym_GT_EQ] = ACTIONS(5357),
    [anon_sym_LT_EQ] = ACTIONS(5357),
    [anon_sym_DOT] = ACTIONS(5359),
    [anon_sym_EQ_GT] = ACTIONS(5357),
    [anon_sym_switch] = ACTIONS(5357),
    [anon_sym_when] = ACTIONS(5357),
    [anon_sym_DOT_DOT] = ACTIONS(5357),
    [anon_sym_and] = ACTIONS(5357),
    [anon_sym_or] = ACTIONS(5357),
    [anon_sym_AMP_AMP] = ACTIONS(5357),
    [anon_sym_PIPE_PIPE] = ACTIONS(5357),
    [anon_sym_QMARK_QMARK] = ACTIONS(5357),
    [anon_sym_into] = ACTIONS(5357),
    [anon_sym_on] = ACTIONS(5357),
    [anon_sym_equals] = ACTIONS(5357),
    [anon_sym_by] = ACTIONS(5357),
    [anon_sym_as] = ACTIONS(5357),
    [anon_sym_is] = ACTIONS(5357),
    [anon_sym_DASH_GT] = ACTIONS(5357),
    [anon_sym_with] = ACTIONS(5357),
    [aux_sym_preproc_if_token3] = ACTIONS(5357),
    [aux_sym_preproc_else_token1] = ACTIONS(5357),
    [aux_sym_preproc_elif_token1] = ACTIONS(5357),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3982] = {
    [sym_preproc_region] = STATE(3982),
    [sym_preproc_endregion] = STATE(3982),
    [sym_preproc_line] = STATE(3982),
    [sym_preproc_pragma] = STATE(3982),
    [sym_preproc_nullable] = STATE(3982),
    [sym_preproc_error] = STATE(3982),
    [sym_preproc_define] = STATE(3982),
    [sym_preproc_undef] = STATE(3982),
    [anon_sym_SEMI] = ACTIONS(5560),
    [anon_sym_LBRACK] = ACTIONS(5560),
    [anon_sym_COLON] = ACTIONS(5560),
    [anon_sym_COMMA] = ACTIONS(5560),
    [anon_sym_RBRACK] = ACTIONS(5560),
    [anon_sym_LPAREN] = ACTIONS(5560),
    [anon_sym_RPAREN] = ACTIONS(5560),
    [anon_sym_RBRACE] = ACTIONS(5560),
    [anon_sym_LT] = ACTIONS(5562),
    [anon_sym_GT] = ACTIONS(5562),
    [anon_sym_in] = ACTIONS(5562),
    [anon_sym_QMARK] = ACTIONS(5562),
    [anon_sym_BANG] = ACTIONS(5562),
    [anon_sym_PLUS_PLUS] = ACTIONS(5560),
    [anon_sym_DASH_DASH] = ACTIONS(5560),
    [anon_sym_PLUS] = ACTIONS(5562),
    [anon_sym_DASH] = ACTIONS(5562),
    [anon_sym_STAR] = ACTIONS(5560),
    [anon_sym_SLASH] = ACTIONS(5562),
    [anon_sym_PERCENT] = ACTIONS(5560),
    [anon_sym_CARET] = ACTIONS(5560),
    [anon_sym_PIPE] = ACTIONS(5562),
    [anon_sym_AMP] = ACTIONS(5562),
    [anon_sym_LT_LT] = ACTIONS(5560),
    [anon_sym_GT_GT] = ACTIONS(5562),
    [anon_sym_GT_GT_GT] = ACTIONS(5560),
    [anon_sym_EQ_EQ] = ACTIONS(5560),
    [anon_sym_BANG_EQ] = ACTIONS(5560),
    [anon_sym_GT_EQ] = ACTIONS(5560),
    [anon_sym_LT_EQ] = ACTIONS(5560),
    [anon_sym_DOT] = ACTIONS(5562),
    [anon_sym_EQ_GT] = ACTIONS(5560),
    [anon_sym_switch] = ACTIONS(5560),
    [anon_sym_when] = ACTIONS(5560),
    [anon_sym_DOT_DOT] = ACTIONS(5560),
    [anon_sym_and] = ACTIONS(5560),
    [anon_sym_or] = ACTIONS(5560),
    [anon_sym_AMP_AMP] = ACTIONS(5560),
    [anon_sym_PIPE_PIPE] = ACTIONS(5560),
    [anon_sym_QMARK_QMARK] = ACTIONS(5560),
    [anon_sym_into] = ACTIONS(5560),
    [anon_sym_on] = ACTIONS(5560),
    [anon_sym_equals] = ACTIONS(5560),
    [anon_sym_by] = ACTIONS(5560),
    [anon_sym_as] = ACTIONS(5560),
    [anon_sym_is] = ACTIONS(5560),
    [anon_sym_DASH_GT] = ACTIONS(5560),
    [anon_sym_with] = ACTIONS(5560),
    [aux_sym_preproc_if_token3] = ACTIONS(5560),
    [aux_sym_preproc_else_token1] = ACTIONS(5560),
    [aux_sym_preproc_elif_token1] = ACTIONS(5560),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3983] = {
    [sym_preproc_region] = STATE(3983),
    [sym_preproc_endregion] = STATE(3983),
    [sym_preproc_line] = STATE(3983),
    [sym_preproc_pragma] = STATE(3983),
    [sym_preproc_nullable] = STATE(3983),
    [sym_preproc_error] = STATE(3983),
    [sym_preproc_define] = STATE(3983),
    [sym_preproc_undef] = STATE(3983),
    [sym__identifier_token] = ACTIONS(3976),
    [anon_sym_extern] = ACTIONS(3976),
    [anon_sym_alias] = ACTIONS(3976),
    [anon_sym_global] = ACTIONS(3976),
    [anon_sym_unsafe] = ACTIONS(3976),
    [anon_sym_static] = ACTIONS(3976),
    [anon_sym_LPAREN] = ACTIONS(5773),
    [anon_sym_class] = ACTIONS(3976),
    [anon_sym_ref] = ACTIONS(3976),
    [anon_sym_struct] = ACTIONS(3976),
    [anon_sym_enum] = ACTIONS(3976),
    [anon_sym_interface] = ACTIONS(3976),
    [anon_sym_delegate] = ACTIONS(3976),
    [anon_sym_record] = ACTIONS(3976),
    [anon_sym_abstract] = ACTIONS(3976),
    [anon_sym_async] = ACTIONS(3976),
    [anon_sym_const] = ACTIONS(3976),
    [anon_sym_file] = ACTIONS(3976),
    [anon_sym_fixed] = ACTIONS(3976),
    [anon_sym_internal] = ACTIONS(3976),
    [anon_sym_new] = ACTIONS(3976),
    [anon_sym_override] = ACTIONS(3976),
    [anon_sym_partial] = ACTIONS(3976),
    [anon_sym_private] = ACTIONS(3976),
    [anon_sym_protected] = ACTIONS(3976),
    [anon_sym_public] = ACTIONS(3976),
    [anon_sym_readonly] = ACTIONS(3976),
    [anon_sym_required] = ACTIONS(3976),
    [anon_sym_sealed] = ACTIONS(3976),
    [anon_sym_virtual] = ACTIONS(3976),
    [anon_sym_volatile] = ACTIONS(3976),
    [anon_sym_where] = ACTIONS(3976),
    [anon_sym_notnull] = ACTIONS(3976),
    [anon_sym_unmanaged] = ACTIONS(3976),
    [anon_sym_scoped] = ACTIONS(3976),
    [anon_sym_var] = ACTIONS(3976),
    [sym_predefined_type] = ACTIONS(3976),
    [anon_sym_yield] = ACTIONS(3976),
    [anon_sym_when] = ACTIONS(3976),
    [anon_sym_from] = ACTIONS(3976),
    [anon_sym_into] = ACTIONS(3976),
    [anon_sym_join] = ACTIONS(3976),
    [anon_sym_on] = ACTIONS(3976),
    [anon_sym_equals] = ACTIONS(3976),
    [anon_sym_let] = ACTIONS(3976),
    [anon_sym_orderby] = ACTIONS(3976),
    [anon_sym_ascending] = ACTIONS(3976),
    [anon_sym_descending] = ACTIONS(3976),
    [anon_sym_group] = ACTIONS(3976),
    [anon_sym_by] = ACTIONS(3976),
    [anon_sym_select] = ACTIONS(3976),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3984] = {
    [sym_preproc_region] = STATE(3984),
    [sym_preproc_endregion] = STATE(3984),
    [sym_preproc_line] = STATE(3984),
    [sym_preproc_pragma] = STATE(3984),
    [sym_preproc_nullable] = STATE(3984),
    [sym_preproc_error] = STATE(3984),
    [sym_preproc_define] = STATE(3984),
    [sym_preproc_undef] = STATE(3984),
    [anon_sym_SEMI] = ACTIONS(1943),
    [anon_sym_LBRACK] = ACTIONS(1943),
    [anon_sym_COLON] = ACTIONS(1943),
    [anon_sym_COMMA] = ACTIONS(1943),
    [anon_sym_RBRACK] = ACTIONS(1943),
    [anon_sym_LPAREN] = ACTIONS(5775),
    [anon_sym_RPAREN] = ACTIONS(1943),
    [anon_sym_RBRACE] = ACTIONS(1943),
    [anon_sym_LT] = ACTIONS(1941),
    [anon_sym_GT] = ACTIONS(1941),
    [anon_sym_in] = ACTIONS(1941),
    [anon_sym_QMARK] = ACTIONS(1941),
    [anon_sym_BANG] = ACTIONS(1941),
    [anon_sym_PLUS_PLUS] = ACTIONS(1943),
    [anon_sym_DASH_DASH] = ACTIONS(1943),
    [anon_sym_PLUS] = ACTIONS(1941),
    [anon_sym_DASH] = ACTIONS(1941),
    [anon_sym_STAR] = ACTIONS(1943),
    [anon_sym_SLASH] = ACTIONS(1941),
    [anon_sym_PERCENT] = ACTIONS(1943),
    [anon_sym_CARET] = ACTIONS(1943),
    [anon_sym_PIPE] = ACTIONS(1941),
    [anon_sym_AMP] = ACTIONS(1941),
    [anon_sym_LT_LT] = ACTIONS(1943),
    [anon_sym_GT_GT] = ACTIONS(1941),
    [anon_sym_GT_GT_GT] = ACTIONS(1943),
    [anon_sym_EQ_EQ] = ACTIONS(1943),
    [anon_sym_BANG_EQ] = ACTIONS(1943),
    [anon_sym_GT_EQ] = ACTIONS(1943),
    [anon_sym_LT_EQ] = ACTIONS(1943),
    [anon_sym_DOT] = ACTIONS(1941),
    [anon_sym_EQ_GT] = ACTIONS(1943),
    [anon_sym_switch] = ACTIONS(1943),
    [anon_sym_when] = ACTIONS(1943),
    [anon_sym_DOT_DOT] = ACTIONS(1943),
    [anon_sym_and] = ACTIONS(1943),
    [anon_sym_or] = ACTIONS(1943),
    [anon_sym_AMP_AMP] = ACTIONS(1943),
    [anon_sym_PIPE_PIPE] = ACTIONS(1943),
    [anon_sym_QMARK_QMARK] = ACTIONS(1943),
    [anon_sym_into] = ACTIONS(1943),
    [anon_sym_on] = ACTIONS(1943),
    [anon_sym_equals] = ACTIONS(1943),
    [anon_sym_by] = ACTIONS(1943),
    [anon_sym_as] = ACTIONS(1943),
    [anon_sym_is] = ACTIONS(1943),
    [anon_sym_DASH_GT] = ACTIONS(1943),
    [anon_sym_with] = ACTIONS(1943),
    [aux_sym_preproc_if_token3] = ACTIONS(1943),
    [aux_sym_preproc_else_token1] = ACTIONS(1943),
    [aux_sym_preproc_elif_token1] = ACTIONS(1943),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3985] = {
    [sym_preproc_region] = STATE(3985),
    [sym_preproc_endregion] = STATE(3985),
    [sym_preproc_line] = STATE(3985),
    [sym_preproc_pragma] = STATE(3985),
    [sym_preproc_nullable] = STATE(3985),
    [sym_preproc_error] = STATE(3985),
    [sym_preproc_define] = STATE(3985),
    [sym_preproc_undef] = STATE(3985),
    [anon_sym_SEMI] = ACTIONS(4570),
    [anon_sym_LBRACK] = ACTIONS(4570),
    [anon_sym_COLON] = ACTIONS(4570),
    [anon_sym_COMMA] = ACTIONS(4570),
    [anon_sym_RBRACK] = ACTIONS(4570),
    [anon_sym_LPAREN] = ACTIONS(4570),
    [anon_sym_RPAREN] = ACTIONS(4570),
    [anon_sym_LBRACE] = ACTIONS(4570),
    [anon_sym_RBRACE] = ACTIONS(4570),
    [anon_sym_LT] = ACTIONS(4568),
    [anon_sym_GT] = ACTIONS(4568),
    [anon_sym_in] = ACTIONS(4570),
    [anon_sym_QMARK] = ACTIONS(4568),
    [anon_sym_BANG] = ACTIONS(4568),
    [anon_sym_PLUS_PLUS] = ACTIONS(4570),
    [anon_sym_DASH_DASH] = ACTIONS(4570),
    [anon_sym_PLUS] = ACTIONS(4568),
    [anon_sym_DASH] = ACTIONS(4568),
    [anon_sym_STAR] = ACTIONS(4570),
    [anon_sym_SLASH] = ACTIONS(4568),
    [anon_sym_PERCENT] = ACTIONS(4570),
    [anon_sym_CARET] = ACTIONS(4570),
    [anon_sym_PIPE] = ACTIONS(4568),
    [anon_sym_AMP] = ACTIONS(4568),
    [anon_sym_LT_LT] = ACTIONS(4570),
    [anon_sym_GT_GT] = ACTIONS(4568),
    [anon_sym_GT_GT_GT] = ACTIONS(4570),
    [anon_sym_EQ_EQ] = ACTIONS(4570),
    [anon_sym_BANG_EQ] = ACTIONS(4570),
    [anon_sym_GT_EQ] = ACTIONS(4570),
    [anon_sym_LT_EQ] = ACTIONS(4570),
    [anon_sym_DOT] = ACTIONS(4568),
    [anon_sym_EQ_GT] = ACTIONS(4570),
    [anon_sym_switch] = ACTIONS(4570),
    [anon_sym_when] = ACTIONS(4570),
    [anon_sym_DOT_DOT] = ACTIONS(4570),
    [anon_sym_and] = ACTIONS(4570),
    [anon_sym_or] = ACTIONS(4570),
    [anon_sym_AMP_AMP] = ACTIONS(4570),
    [anon_sym_PIPE_PIPE] = ACTIONS(4570),
    [anon_sym_QMARK_QMARK] = ACTIONS(4570),
    [anon_sym_on] = ACTIONS(4570),
    [anon_sym_equals] = ACTIONS(4570),
    [anon_sym_by] = ACTIONS(4570),
    [anon_sym_as] = ACTIONS(4570),
    [anon_sym_is] = ACTIONS(4570),
    [anon_sym_DASH_GT] = ACTIONS(4570),
    [anon_sym_with] = ACTIONS(4570),
    [aux_sym_preproc_if_token3] = ACTIONS(4570),
    [aux_sym_preproc_else_token1] = ACTIONS(4570),
    [aux_sym_preproc_elif_token1] = ACTIONS(4570),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3986] = {
    [sym_initializer_expression] = STATE(4204),
    [sym_preproc_region] = STATE(3986),
    [sym_preproc_endregion] = STATE(3986),
    [sym_preproc_line] = STATE(3986),
    [sym_preproc_pragma] = STATE(3986),
    [sym_preproc_nullable] = STATE(3986),
    [sym_preproc_error] = STATE(3986),
    [sym_preproc_define] = STATE(3986),
    [sym_preproc_undef] = STATE(3986),
    [anon_sym_SEMI] = ACTIONS(5302),
    [anon_sym_LBRACK] = ACTIONS(5298),
    [anon_sym_COLON] = ACTIONS(5302),
    [anon_sym_COMMA] = ACTIONS(5302),
    [anon_sym_RBRACK] = ACTIONS(5302),
    [anon_sym_LPAREN] = ACTIONS(5302),
    [anon_sym_RPAREN] = ACTIONS(5302),
    [anon_sym_LBRACE] = ACTIONS(5777),
    [anon_sym_RBRACE] = ACTIONS(5302),
    [anon_sym_LT] = ACTIONS(5308),
    [anon_sym_GT] = ACTIONS(5308),
    [anon_sym_QMARK] = ACTIONS(5780),
    [anon_sym_BANG] = ACTIONS(5308),
    [anon_sym_PLUS_PLUS] = ACTIONS(5302),
    [anon_sym_DASH_DASH] = ACTIONS(5302),
    [anon_sym_PLUS] = ACTIONS(5308),
    [anon_sym_DASH] = ACTIONS(5308),
    [anon_sym_STAR] = ACTIONS(5302),
    [anon_sym_SLASH] = ACTIONS(5308),
    [anon_sym_PERCENT] = ACTIONS(5302),
    [anon_sym_CARET] = ACTIONS(5302),
    [anon_sym_PIPE] = ACTIONS(5308),
    [anon_sym_AMP] = ACTIONS(5308),
    [anon_sym_LT_LT] = ACTIONS(5302),
    [anon_sym_GT_GT] = ACTIONS(5308),
    [anon_sym_GT_GT_GT] = ACTIONS(5302),
    [anon_sym_EQ_EQ] = ACTIONS(5302),
    [anon_sym_BANG_EQ] = ACTIONS(5302),
    [anon_sym_GT_EQ] = ACTIONS(5302),
    [anon_sym_LT_EQ] = ACTIONS(5302),
    [anon_sym_DOT] = ACTIONS(5308),
    [anon_sym_EQ_GT] = ACTIONS(5302),
    [anon_sym_switch] = ACTIONS(5302),
    [anon_sym_when] = ACTIONS(5302),
    [anon_sym_DOT_DOT] = ACTIONS(5302),
    [anon_sym_and] = ACTIONS(5302),
    [anon_sym_or] = ACTIONS(5302),
    [anon_sym_AMP_AMP] = ACTIONS(5302),
    [anon_sym_PIPE_PIPE] = ACTIONS(5302),
    [anon_sym_QMARK_QMARK] = ACTIONS(5302),
    [anon_sym_on] = ACTIONS(5302),
    [anon_sym_equals] = ACTIONS(5302),
    [anon_sym_by] = ACTIONS(5302),
    [anon_sym_as] = ACTIONS(5302),
    [anon_sym_is] = ACTIONS(5302),
    [anon_sym_DASH_GT] = ACTIONS(5302),
    [anon_sym_with] = ACTIONS(5302),
    [aux_sym_preproc_if_token3] = ACTIONS(5302),
    [aux_sym_preproc_else_token1] = ACTIONS(5302),
    [aux_sym_preproc_elif_token1] = ACTIONS(5302),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3987] = {
    [sym_preproc_region] = STATE(3987),
    [sym_preproc_endregion] = STATE(3987),
    [sym_preproc_line] = STATE(3987),
    [sym_preproc_pragma] = STATE(3987),
    [sym_preproc_nullable] = STATE(3987),
    [sym_preproc_error] = STATE(3987),
    [sym_preproc_define] = STATE(3987),
    [sym_preproc_undef] = STATE(3987),
    [anon_sym_SEMI] = ACTIONS(5448),
    [anon_sym_LBRACK] = ACTIONS(5448),
    [anon_sym_COLON] = ACTIONS(5448),
    [anon_sym_COMMA] = ACTIONS(5448),
    [anon_sym_RBRACK] = ACTIONS(5448),
    [anon_sym_LPAREN] = ACTIONS(5448),
    [anon_sym_RPAREN] = ACTIONS(5448),
    [anon_sym_RBRACE] = ACTIONS(5448),
    [anon_sym_LT] = ACTIONS(5450),
    [anon_sym_GT] = ACTIONS(5450),
    [anon_sym_in] = ACTIONS(5450),
    [anon_sym_QMARK] = ACTIONS(5450),
    [anon_sym_BANG] = ACTIONS(5450),
    [anon_sym_PLUS_PLUS] = ACTIONS(5448),
    [anon_sym_DASH_DASH] = ACTIONS(5448),
    [anon_sym_PLUS] = ACTIONS(5450),
    [anon_sym_DASH] = ACTIONS(5450),
    [anon_sym_STAR] = ACTIONS(5448),
    [anon_sym_SLASH] = ACTIONS(5450),
    [anon_sym_PERCENT] = ACTIONS(5448),
    [anon_sym_CARET] = ACTIONS(5448),
    [anon_sym_PIPE] = ACTIONS(5450),
    [anon_sym_AMP] = ACTIONS(5450),
    [anon_sym_LT_LT] = ACTIONS(5448),
    [anon_sym_GT_GT] = ACTIONS(5450),
    [anon_sym_GT_GT_GT] = ACTIONS(5448),
    [anon_sym_EQ_EQ] = ACTIONS(5448),
    [anon_sym_BANG_EQ] = ACTIONS(5448),
    [anon_sym_GT_EQ] = ACTIONS(5448),
    [anon_sym_LT_EQ] = ACTIONS(5448),
    [anon_sym_DOT] = ACTIONS(5450),
    [anon_sym_EQ_GT] = ACTIONS(5448),
    [anon_sym_switch] = ACTIONS(5448),
    [anon_sym_when] = ACTIONS(5448),
    [anon_sym_DOT_DOT] = ACTIONS(5448),
    [anon_sym_and] = ACTIONS(5448),
    [anon_sym_or] = ACTIONS(5448),
    [anon_sym_AMP_AMP] = ACTIONS(5448),
    [anon_sym_PIPE_PIPE] = ACTIONS(5448),
    [anon_sym_QMARK_QMARK] = ACTIONS(5448),
    [anon_sym_into] = ACTIONS(5448),
    [anon_sym_on] = ACTIONS(5448),
    [anon_sym_equals] = ACTIONS(5448),
    [anon_sym_by] = ACTIONS(5448),
    [anon_sym_as] = ACTIONS(5448),
    [anon_sym_is] = ACTIONS(5448),
    [anon_sym_DASH_GT] = ACTIONS(5448),
    [anon_sym_with] = ACTIONS(5448),
    [aux_sym_preproc_if_token3] = ACTIONS(5448),
    [aux_sym_preproc_else_token1] = ACTIONS(5448),
    [aux_sym_preproc_elif_token1] = ACTIONS(5448),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3988] = {
    [sym_preproc_region] = STATE(3988),
    [sym_preproc_endregion] = STATE(3988),
    [sym_preproc_line] = STATE(3988),
    [sym_preproc_pragma] = STATE(3988),
    [sym_preproc_nullable] = STATE(3988),
    [sym_preproc_error] = STATE(3988),
    [sym_preproc_define] = STATE(3988),
    [sym_preproc_undef] = STATE(3988),
    [anon_sym_SEMI] = ACTIONS(5416),
    [anon_sym_LBRACK] = ACTIONS(5416),
    [anon_sym_COLON] = ACTIONS(5416),
    [anon_sym_COMMA] = ACTIONS(5416),
    [anon_sym_RBRACK] = ACTIONS(5416),
    [anon_sym_LPAREN] = ACTIONS(5416),
    [anon_sym_RPAREN] = ACTIONS(5416),
    [anon_sym_RBRACE] = ACTIONS(5416),
    [anon_sym_LT] = ACTIONS(5418),
    [anon_sym_GT] = ACTIONS(5418),
    [anon_sym_in] = ACTIONS(5418),
    [anon_sym_QMARK] = ACTIONS(5418),
    [anon_sym_BANG] = ACTIONS(5418),
    [anon_sym_PLUS_PLUS] = ACTIONS(5416),
    [anon_sym_DASH_DASH] = ACTIONS(5416),
    [anon_sym_PLUS] = ACTIONS(5418),
    [anon_sym_DASH] = ACTIONS(5418),
    [anon_sym_STAR] = ACTIONS(5416),
    [anon_sym_SLASH] = ACTIONS(5418),
    [anon_sym_PERCENT] = ACTIONS(5416),
    [anon_sym_CARET] = ACTIONS(5416),
    [anon_sym_PIPE] = ACTIONS(5418),
    [anon_sym_AMP] = ACTIONS(5418),
    [anon_sym_LT_LT] = ACTIONS(5416),
    [anon_sym_GT_GT] = ACTIONS(5418),
    [anon_sym_GT_GT_GT] = ACTIONS(5416),
    [anon_sym_EQ_EQ] = ACTIONS(5416),
    [anon_sym_BANG_EQ] = ACTIONS(5416),
    [anon_sym_GT_EQ] = ACTIONS(5416),
    [anon_sym_LT_EQ] = ACTIONS(5416),
    [anon_sym_DOT] = ACTIONS(5418),
    [anon_sym_EQ_GT] = ACTIONS(5416),
    [anon_sym_switch] = ACTIONS(5416),
    [anon_sym_when] = ACTIONS(5416),
    [anon_sym_DOT_DOT] = ACTIONS(5416),
    [anon_sym_and] = ACTIONS(5416),
    [anon_sym_or] = ACTIONS(5416),
    [anon_sym_AMP_AMP] = ACTIONS(5416),
    [anon_sym_PIPE_PIPE] = ACTIONS(5416),
    [anon_sym_QMARK_QMARK] = ACTIONS(5416),
    [anon_sym_into] = ACTIONS(5416),
    [anon_sym_on] = ACTIONS(5416),
    [anon_sym_equals] = ACTIONS(5416),
    [anon_sym_by] = ACTIONS(5416),
    [anon_sym_as] = ACTIONS(5416),
    [anon_sym_is] = ACTIONS(5416),
    [anon_sym_DASH_GT] = ACTIONS(5416),
    [anon_sym_with] = ACTIONS(5416),
    [aux_sym_preproc_if_token3] = ACTIONS(5416),
    [aux_sym_preproc_else_token1] = ACTIONS(5416),
    [aux_sym_preproc_elif_token1] = ACTIONS(5416),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3989] = {
    [sym_type_argument_list] = STATE(3605),
    [sym_preproc_region] = STATE(3989),
    [sym_preproc_endregion] = STATE(3989),
    [sym_preproc_line] = STATE(3989),
    [sym_preproc_pragma] = STATE(3989),
    [sym_preproc_nullable] = STATE(3989),
    [sym_preproc_error] = STATE(3989),
    [sym_preproc_define] = STATE(3989),
    [sym_preproc_undef] = STATE(3989),
    [anon_sym_SEMI] = ACTIONS(4076),
    [anon_sym_LBRACK] = ACTIONS(4076),
    [anon_sym_COLON] = ACTIONS(4074),
    [anon_sym_COMMA] = ACTIONS(4076),
    [anon_sym_RBRACK] = ACTIONS(4076),
    [anon_sym_LPAREN] = ACTIONS(4076),
    [anon_sym_RPAREN] = ACTIONS(4076),
    [anon_sym_LBRACE] = ACTIONS(4076),
    [anon_sym_RBRACE] = ACTIONS(4076),
    [anon_sym_LT] = ACTIONS(5209),
    [anon_sym_GT] = ACTIONS(4074),
    [anon_sym_in] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(4074),
    [anon_sym_BANG] = ACTIONS(4074),
    [anon_sym_PLUS_PLUS] = ACTIONS(4076),
    [anon_sym_DASH_DASH] = ACTIONS(4076),
    [anon_sym_PLUS] = ACTIONS(4074),
    [anon_sym_DASH] = ACTIONS(4074),
    [anon_sym_STAR] = ACTIONS(4076),
    [anon_sym_SLASH] = ACTIONS(4074),
    [anon_sym_PERCENT] = ACTIONS(4076),
    [anon_sym_CARET] = ACTIONS(4076),
    [anon_sym_PIPE] = ACTIONS(4074),
    [anon_sym_AMP] = ACTIONS(4074),
    [anon_sym_LT_LT] = ACTIONS(4076),
    [anon_sym_GT_GT] = ACTIONS(4074),
    [anon_sym_GT_GT_GT] = ACTIONS(4076),
    [anon_sym_EQ_EQ] = ACTIONS(4076),
    [anon_sym_BANG_EQ] = ACTIONS(4076),
    [anon_sym_GT_EQ] = ACTIONS(4076),
    [anon_sym_LT_EQ] = ACTIONS(4076),
    [anon_sym_DOT] = ACTIONS(4074),
    [anon_sym_EQ_GT] = ACTIONS(4076),
    [anon_sym_COLON_COLON] = ACTIONS(5784),
    [anon_sym_switch] = ACTIONS(4076),
    [anon_sym_DOT_DOT] = ACTIONS(4076),
    [anon_sym_AMP_AMP] = ACTIONS(4076),
    [anon_sym_PIPE_PIPE] = ACTIONS(4076),
    [anon_sym_QMARK_QMARK] = ACTIONS(4076),
    [anon_sym_into] = ACTIONS(4076),
    [anon_sym_on] = ACTIONS(4076),
    [anon_sym_equals] = ACTIONS(4076),
    [anon_sym_by] = ACTIONS(4076),
    [anon_sym_as] = ACTIONS(4076),
    [anon_sym_is] = ACTIONS(4076),
    [anon_sym_DASH_GT] = ACTIONS(4076),
    [anon_sym_with] = ACTIONS(4076),
    [aux_sym_preproc_if_token3] = ACTIONS(4076),
    [aux_sym_preproc_else_token1] = ACTIONS(4076),
    [aux_sym_preproc_elif_token1] = ACTIONS(4076),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3990] = {
    [sym_preproc_region] = STATE(3990),
    [sym_preproc_endregion] = STATE(3990),
    [sym_preproc_line] = STATE(3990),
    [sym_preproc_pragma] = STATE(3990),
    [sym_preproc_nullable] = STATE(3990),
    [sym_preproc_error] = STATE(3990),
    [sym_preproc_define] = STATE(3990),
    [sym_preproc_undef] = STATE(3990),
    [anon_sym_SEMI] = ACTIONS(5440),
    [anon_sym_LBRACK] = ACTIONS(5440),
    [anon_sym_COLON] = ACTIONS(5440),
    [anon_sym_COMMA] = ACTIONS(5440),
    [anon_sym_RBRACK] = ACTIONS(5440),
    [anon_sym_LPAREN] = ACTIONS(5440),
    [anon_sym_RPAREN] = ACTIONS(5440),
    [anon_sym_RBRACE] = ACTIONS(5440),
    [anon_sym_LT] = ACTIONS(5442),
    [anon_sym_GT] = ACTIONS(5442),
    [anon_sym_in] = ACTIONS(5442),
    [anon_sym_QMARK] = ACTIONS(5442),
    [anon_sym_BANG] = ACTIONS(5442),
    [anon_sym_PLUS_PLUS] = ACTIONS(5440),
    [anon_sym_DASH_DASH] = ACTIONS(5440),
    [anon_sym_PLUS] = ACTIONS(5442),
    [anon_sym_DASH] = ACTIONS(5442),
    [anon_sym_STAR] = ACTIONS(5440),
    [anon_sym_SLASH] = ACTIONS(5442),
    [anon_sym_PERCENT] = ACTIONS(5440),
    [anon_sym_CARET] = ACTIONS(5440),
    [anon_sym_PIPE] = ACTIONS(5442),
    [anon_sym_AMP] = ACTIONS(5442),
    [anon_sym_LT_LT] = ACTIONS(5440),
    [anon_sym_GT_GT] = ACTIONS(5442),
    [anon_sym_GT_GT_GT] = ACTIONS(5440),
    [anon_sym_EQ_EQ] = ACTIONS(5440),
    [anon_sym_BANG_EQ] = ACTIONS(5440),
    [anon_sym_GT_EQ] = ACTIONS(5440),
    [anon_sym_LT_EQ] = ACTIONS(5440),
    [anon_sym_DOT] = ACTIONS(5442),
    [anon_sym_EQ_GT] = ACTIONS(5440),
    [anon_sym_switch] = ACTIONS(5440),
    [anon_sym_when] = ACTIONS(5440),
    [anon_sym_DOT_DOT] = ACTIONS(5440),
    [anon_sym_and] = ACTIONS(5440),
    [anon_sym_or] = ACTIONS(5440),
    [anon_sym_AMP_AMP] = ACTIONS(5440),
    [anon_sym_PIPE_PIPE] = ACTIONS(5440),
    [anon_sym_QMARK_QMARK] = ACTIONS(5440),
    [anon_sym_into] = ACTIONS(5440),
    [anon_sym_on] = ACTIONS(5440),
    [anon_sym_equals] = ACTIONS(5440),
    [anon_sym_by] = ACTIONS(5440),
    [anon_sym_as] = ACTIONS(5440),
    [anon_sym_is] = ACTIONS(5440),
    [anon_sym_DASH_GT] = ACTIONS(5440),
    [anon_sym_with] = ACTIONS(5440),
    [aux_sym_preproc_if_token3] = ACTIONS(5440),
    [aux_sym_preproc_else_token1] = ACTIONS(5440),
    [aux_sym_preproc_elif_token1] = ACTIONS(5440),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3991] = {
    [sym_preproc_region] = STATE(3991),
    [sym_preproc_endregion] = STATE(3991),
    [sym_preproc_line] = STATE(3991),
    [sym_preproc_pragma] = STATE(3991),
    [sym_preproc_nullable] = STATE(3991),
    [sym_preproc_error] = STATE(3991),
    [sym_preproc_define] = STATE(3991),
    [sym_preproc_undef] = STATE(3991),
    [anon_sym_SEMI] = ACTIONS(5478),
    [anon_sym_LBRACK] = ACTIONS(5478),
    [anon_sym_COLON] = ACTIONS(5478),
    [anon_sym_COMMA] = ACTIONS(5478),
    [anon_sym_RBRACK] = ACTIONS(5478),
    [anon_sym_LPAREN] = ACTIONS(5478),
    [anon_sym_RPAREN] = ACTIONS(5478),
    [anon_sym_RBRACE] = ACTIONS(5478),
    [anon_sym_LT] = ACTIONS(5480),
    [anon_sym_GT] = ACTIONS(5480),
    [anon_sym_in] = ACTIONS(5480),
    [anon_sym_QMARK] = ACTIONS(5480),
    [anon_sym_BANG] = ACTIONS(5480),
    [anon_sym_PLUS_PLUS] = ACTIONS(5478),
    [anon_sym_DASH_DASH] = ACTIONS(5478),
    [anon_sym_PLUS] = ACTIONS(5480),
    [anon_sym_DASH] = ACTIONS(5480),
    [anon_sym_STAR] = ACTIONS(5478),
    [anon_sym_SLASH] = ACTIONS(5480),
    [anon_sym_PERCENT] = ACTIONS(5478),
    [anon_sym_CARET] = ACTIONS(5478),
    [anon_sym_PIPE] = ACTIONS(5480),
    [anon_sym_AMP] = ACTIONS(5480),
    [anon_sym_LT_LT] = ACTIONS(5478),
    [anon_sym_GT_GT] = ACTIONS(5480),
    [anon_sym_GT_GT_GT] = ACTIONS(5478),
    [anon_sym_EQ_EQ] = ACTIONS(5478),
    [anon_sym_BANG_EQ] = ACTIONS(5478),
    [anon_sym_GT_EQ] = ACTIONS(5478),
    [anon_sym_LT_EQ] = ACTIONS(5478),
    [anon_sym_DOT] = ACTIONS(5480),
    [anon_sym_EQ_GT] = ACTIONS(5478),
    [anon_sym_switch] = ACTIONS(5478),
    [anon_sym_when] = ACTIONS(5478),
    [anon_sym_DOT_DOT] = ACTIONS(5478),
    [anon_sym_and] = ACTIONS(5478),
    [anon_sym_or] = ACTIONS(5478),
    [anon_sym_AMP_AMP] = ACTIONS(5478),
    [anon_sym_PIPE_PIPE] = ACTIONS(5478),
    [anon_sym_QMARK_QMARK] = ACTIONS(5478),
    [anon_sym_into] = ACTIONS(5478),
    [anon_sym_on] = ACTIONS(5478),
    [anon_sym_equals] = ACTIONS(5478),
    [anon_sym_by] = ACTIONS(5478),
    [anon_sym_as] = ACTIONS(5478),
    [anon_sym_is] = ACTIONS(5478),
    [anon_sym_DASH_GT] = ACTIONS(5478),
    [anon_sym_with] = ACTIONS(5478),
    [aux_sym_preproc_if_token3] = ACTIONS(5478),
    [aux_sym_preproc_else_token1] = ACTIONS(5478),
    [aux_sym_preproc_elif_token1] = ACTIONS(5478),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3992] = {
    [sym_preproc_region] = STATE(3992),
    [sym_preproc_endregion] = STATE(3992),
    [sym_preproc_line] = STATE(3992),
    [sym_preproc_pragma] = STATE(3992),
    [sym_preproc_nullable] = STATE(3992),
    [sym_preproc_error] = STATE(3992),
    [sym_preproc_define] = STATE(3992),
    [sym_preproc_undef] = STATE(3992),
    [anon_sym_SEMI] = ACTIONS(5486),
    [anon_sym_LBRACK] = ACTIONS(5486),
    [anon_sym_COLON] = ACTIONS(5486),
    [anon_sym_COMMA] = ACTIONS(5486),
    [anon_sym_RBRACK] = ACTIONS(5486),
    [anon_sym_LPAREN] = ACTIONS(5486),
    [anon_sym_RPAREN] = ACTIONS(5486),
    [anon_sym_RBRACE] = ACTIONS(5486),
    [anon_sym_LT] = ACTIONS(5488),
    [anon_sym_GT] = ACTIONS(5488),
    [anon_sym_in] = ACTIONS(5488),
    [anon_sym_QMARK] = ACTIONS(5488),
    [anon_sym_BANG] = ACTIONS(5488),
    [anon_sym_PLUS_PLUS] = ACTIONS(5486),
    [anon_sym_DASH_DASH] = ACTIONS(5486),
    [anon_sym_PLUS] = ACTIONS(5488),
    [anon_sym_DASH] = ACTIONS(5488),
    [anon_sym_STAR] = ACTIONS(5486),
    [anon_sym_SLASH] = ACTIONS(5488),
    [anon_sym_PERCENT] = ACTIONS(5486),
    [anon_sym_CARET] = ACTIONS(5486),
    [anon_sym_PIPE] = ACTIONS(5488),
    [anon_sym_AMP] = ACTIONS(5488),
    [anon_sym_LT_LT] = ACTIONS(5486),
    [anon_sym_GT_GT] = ACTIONS(5488),
    [anon_sym_GT_GT_GT] = ACTIONS(5486),
    [anon_sym_EQ_EQ] = ACTIONS(5486),
    [anon_sym_BANG_EQ] = ACTIONS(5486),
    [anon_sym_GT_EQ] = ACTIONS(5486),
    [anon_sym_LT_EQ] = ACTIONS(5486),
    [anon_sym_DOT] = ACTIONS(5488),
    [anon_sym_EQ_GT] = ACTIONS(5486),
    [anon_sym_switch] = ACTIONS(5486),
    [anon_sym_when] = ACTIONS(5486),
    [anon_sym_DOT_DOT] = ACTIONS(5486),
    [anon_sym_and] = ACTIONS(5486),
    [anon_sym_or] = ACTIONS(5486),
    [anon_sym_AMP_AMP] = ACTIONS(5486),
    [anon_sym_PIPE_PIPE] = ACTIONS(5486),
    [anon_sym_QMARK_QMARK] = ACTIONS(5486),
    [anon_sym_into] = ACTIONS(5486),
    [anon_sym_on] = ACTIONS(5486),
    [anon_sym_equals] = ACTIONS(5486),
    [anon_sym_by] = ACTIONS(5486),
    [anon_sym_as] = ACTIONS(5486),
    [anon_sym_is] = ACTIONS(5486),
    [anon_sym_DASH_GT] = ACTIONS(5486),
    [anon_sym_with] = ACTIONS(5486),
    [aux_sym_preproc_if_token3] = ACTIONS(5486),
    [aux_sym_preproc_else_token1] = ACTIONS(5486),
    [aux_sym_preproc_elif_token1] = ACTIONS(5486),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3993] = {
    [sym_preproc_region] = STATE(3993),
    [sym_preproc_endregion] = STATE(3993),
    [sym_preproc_line] = STATE(3993),
    [sym_preproc_pragma] = STATE(3993),
    [sym_preproc_nullable] = STATE(3993),
    [sym_preproc_error] = STATE(3993),
    [sym_preproc_define] = STATE(3993),
    [sym_preproc_undef] = STATE(3993),
    [anon_sym_SEMI] = ACTIONS(4739),
    [anon_sym_LBRACK] = ACTIONS(5786),
    [anon_sym_COLON] = ACTIONS(4739),
    [anon_sym_COMMA] = ACTIONS(4739),
    [anon_sym_RBRACK] = ACTIONS(4739),
    [anon_sym_LPAREN] = ACTIONS(5786),
    [anon_sym_RPAREN] = ACTIONS(4739),
    [anon_sym_RBRACE] = ACTIONS(4739),
    [anon_sym_LT] = ACTIONS(5789),
    [anon_sym_GT] = ACTIONS(5789),
    [anon_sym_in] = ACTIONS(4747),
    [anon_sym_QMARK] = ACTIONS(5789),
    [anon_sym_BANG] = ACTIONS(5789),
    [anon_sym_PLUS_PLUS] = ACTIONS(5786),
    [anon_sym_DASH_DASH] = ACTIONS(5786),
    [anon_sym_PLUS] = ACTIONS(5789),
    [anon_sym_DASH] = ACTIONS(5789),
    [anon_sym_STAR] = ACTIONS(5786),
    [anon_sym_SLASH] = ACTIONS(5789),
    [anon_sym_PERCENT] = ACTIONS(5786),
    [anon_sym_CARET] = ACTIONS(5786),
    [anon_sym_PIPE] = ACTIONS(5789),
    [anon_sym_AMP] = ACTIONS(5789),
    [anon_sym_LT_LT] = ACTIONS(5786),
    [anon_sym_GT_GT] = ACTIONS(5789),
    [anon_sym_GT_GT_GT] = ACTIONS(5786),
    [anon_sym_EQ_EQ] = ACTIONS(5786),
    [anon_sym_BANG_EQ] = ACTIONS(5786),
    [anon_sym_GT_EQ] = ACTIONS(5786),
    [anon_sym_LT_EQ] = ACTIONS(5786),
    [anon_sym_DOT] = ACTIONS(5789),
    [anon_sym_EQ_GT] = ACTIONS(4739),
    [anon_sym_switch] = ACTIONS(5786),
    [anon_sym_when] = ACTIONS(4739),
    [anon_sym_DOT_DOT] = ACTIONS(5786),
    [anon_sym_and] = ACTIONS(4739),
    [anon_sym_or] = ACTIONS(4739),
    [anon_sym_AMP_AMP] = ACTIONS(5786),
    [anon_sym_PIPE_PIPE] = ACTIONS(5786),
    [anon_sym_QMARK_QMARK] = ACTIONS(5786),
    [anon_sym_into] = ACTIONS(4739),
    [anon_sym_on] = ACTIONS(4739),
    [anon_sym_equals] = ACTIONS(4739),
    [anon_sym_by] = ACTIONS(4739),
    [anon_sym_as] = ACTIONS(5786),
    [anon_sym_is] = ACTIONS(5786),
    [anon_sym_DASH_GT] = ACTIONS(5786),
    [anon_sym_with] = ACTIONS(5786),
    [aux_sym_preproc_if_token3] = ACTIONS(4739),
    [aux_sym_preproc_else_token1] = ACTIONS(4739),
    [aux_sym_preproc_elif_token1] = ACTIONS(4739),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3994] = {
    [sym_preproc_region] = STATE(3994),
    [sym_preproc_endregion] = STATE(3994),
    [sym_preproc_line] = STATE(3994),
    [sym_preproc_pragma] = STATE(3994),
    [sym_preproc_nullable] = STATE(3994),
    [sym_preproc_error] = STATE(3994),
    [sym_preproc_define] = STATE(3994),
    [sym_preproc_undef] = STATE(3994),
    [anon_sym_SEMI] = ACTIONS(5361),
    [anon_sym_LBRACK] = ACTIONS(5361),
    [anon_sym_COLON] = ACTIONS(5361),
    [anon_sym_COMMA] = ACTIONS(5361),
    [anon_sym_RBRACK] = ACTIONS(5361),
    [anon_sym_LPAREN] = ACTIONS(5361),
    [anon_sym_RPAREN] = ACTIONS(5361),
    [anon_sym_RBRACE] = ACTIONS(5361),
    [anon_sym_LT] = ACTIONS(5363),
    [anon_sym_GT] = ACTIONS(5363),
    [anon_sym_in] = ACTIONS(5363),
    [anon_sym_QMARK] = ACTIONS(5363),
    [anon_sym_BANG] = ACTIONS(5363),
    [anon_sym_PLUS_PLUS] = ACTIONS(5361),
    [anon_sym_DASH_DASH] = ACTIONS(5361),
    [anon_sym_PLUS] = ACTIONS(5363),
    [anon_sym_DASH] = ACTIONS(5363),
    [anon_sym_STAR] = ACTIONS(5361),
    [anon_sym_SLASH] = ACTIONS(5363),
    [anon_sym_PERCENT] = ACTIONS(5361),
    [anon_sym_CARET] = ACTIONS(5361),
    [anon_sym_PIPE] = ACTIONS(5363),
    [anon_sym_AMP] = ACTIONS(5363),
    [anon_sym_LT_LT] = ACTIONS(5361),
    [anon_sym_GT_GT] = ACTIONS(5363),
    [anon_sym_GT_GT_GT] = ACTIONS(5361),
    [anon_sym_EQ_EQ] = ACTIONS(5361),
    [anon_sym_BANG_EQ] = ACTIONS(5361),
    [anon_sym_GT_EQ] = ACTIONS(5361),
    [anon_sym_LT_EQ] = ACTIONS(5361),
    [anon_sym_DOT] = ACTIONS(5363),
    [anon_sym_EQ_GT] = ACTIONS(5361),
    [anon_sym_switch] = ACTIONS(5361),
    [anon_sym_when] = ACTIONS(5361),
    [anon_sym_DOT_DOT] = ACTIONS(5361),
    [anon_sym_and] = ACTIONS(5361),
    [anon_sym_or] = ACTIONS(5361),
    [anon_sym_AMP_AMP] = ACTIONS(5361),
    [anon_sym_PIPE_PIPE] = ACTIONS(5361),
    [anon_sym_QMARK_QMARK] = ACTIONS(5361),
    [anon_sym_into] = ACTIONS(5361),
    [anon_sym_on] = ACTIONS(5361),
    [anon_sym_equals] = ACTIONS(5361),
    [anon_sym_by] = ACTIONS(5361),
    [anon_sym_as] = ACTIONS(5361),
    [anon_sym_is] = ACTIONS(5361),
    [anon_sym_DASH_GT] = ACTIONS(5361),
    [anon_sym_with] = ACTIONS(5361),
    [aux_sym_preproc_if_token3] = ACTIONS(5361),
    [aux_sym_preproc_else_token1] = ACTIONS(5361),
    [aux_sym_preproc_elif_token1] = ACTIONS(5361),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3995] = {
    [sym_preproc_region] = STATE(3995),
    [sym_preproc_endregion] = STATE(3995),
    [sym_preproc_line] = STATE(3995),
    [sym_preproc_pragma] = STATE(3995),
    [sym_preproc_nullable] = STATE(3995),
    [sym_preproc_error] = STATE(3995),
    [sym_preproc_define] = STATE(3995),
    [sym_preproc_undef] = STATE(3995),
    [anon_sym_SEMI] = ACTIONS(4416),
    [anon_sym_LBRACK] = ACTIONS(4416),
    [anon_sym_COLON] = ACTIONS(4416),
    [anon_sym_COMMA] = ACTIONS(4416),
    [anon_sym_RBRACK] = ACTIONS(4416),
    [anon_sym_LPAREN] = ACTIONS(4416),
    [anon_sym_RPAREN] = ACTIONS(4416),
    [anon_sym_LBRACE] = ACTIONS(4416),
    [anon_sym_RBRACE] = ACTIONS(4416),
    [anon_sym_LT] = ACTIONS(4414),
    [anon_sym_GT] = ACTIONS(4414),
    [anon_sym_in] = ACTIONS(4416),
    [anon_sym_QMARK] = ACTIONS(4414),
    [anon_sym_BANG] = ACTIONS(4414),
    [anon_sym_PLUS_PLUS] = ACTIONS(4416),
    [anon_sym_DASH_DASH] = ACTIONS(4416),
    [anon_sym_PLUS] = ACTIONS(4414),
    [anon_sym_DASH] = ACTIONS(4414),
    [anon_sym_STAR] = ACTIONS(4416),
    [anon_sym_SLASH] = ACTIONS(4414),
    [anon_sym_PERCENT] = ACTIONS(4416),
    [anon_sym_CARET] = ACTIONS(4416),
    [anon_sym_PIPE] = ACTIONS(4414),
    [anon_sym_AMP] = ACTIONS(4414),
    [anon_sym_LT_LT] = ACTIONS(4416),
    [anon_sym_GT_GT] = ACTIONS(4414),
    [anon_sym_GT_GT_GT] = ACTIONS(4416),
    [anon_sym_EQ_EQ] = ACTIONS(4416),
    [anon_sym_BANG_EQ] = ACTIONS(4416),
    [anon_sym_GT_EQ] = ACTIONS(4416),
    [anon_sym_LT_EQ] = ACTIONS(4416),
    [anon_sym_DOT] = ACTIONS(4414),
    [anon_sym_EQ_GT] = ACTIONS(4416),
    [anon_sym_switch] = ACTIONS(4416),
    [anon_sym_when] = ACTIONS(4416),
    [anon_sym_DOT_DOT] = ACTIONS(4416),
    [anon_sym_and] = ACTIONS(4416),
    [anon_sym_or] = ACTIONS(4416),
    [anon_sym_AMP_AMP] = ACTIONS(4416),
    [anon_sym_PIPE_PIPE] = ACTIONS(4416),
    [anon_sym_QMARK_QMARK] = ACTIONS(4416),
    [anon_sym_on] = ACTIONS(4416),
    [anon_sym_equals] = ACTIONS(4416),
    [anon_sym_by] = ACTIONS(4416),
    [anon_sym_as] = ACTIONS(4416),
    [anon_sym_is] = ACTIONS(4416),
    [anon_sym_DASH_GT] = ACTIONS(4416),
    [anon_sym_with] = ACTIONS(4416),
    [aux_sym_preproc_if_token3] = ACTIONS(4416),
    [aux_sym_preproc_else_token1] = ACTIONS(4416),
    [aux_sym_preproc_elif_token1] = ACTIONS(4416),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3996] = {
    [sym_preproc_region] = STATE(3996),
    [sym_preproc_endregion] = STATE(3996),
    [sym_preproc_line] = STATE(3996),
    [sym_preproc_pragma] = STATE(3996),
    [sym_preproc_nullable] = STATE(3996),
    [sym_preproc_error] = STATE(3996),
    [sym_preproc_define] = STATE(3996),
    [sym_preproc_undef] = STATE(3996),
    [anon_sym_SEMI] = ACTIONS(5249),
    [anon_sym_LBRACK] = ACTIONS(5249),
    [anon_sym_COLON] = ACTIONS(5249),
    [anon_sym_COMMA] = ACTIONS(5249),
    [anon_sym_RBRACK] = ACTIONS(5249),
    [anon_sym_LPAREN] = ACTIONS(5249),
    [anon_sym_RPAREN] = ACTIONS(5249),
    [anon_sym_RBRACE] = ACTIONS(5249),
    [anon_sym_LT] = ACTIONS(5251),
    [anon_sym_GT] = ACTIONS(5251),
    [anon_sym_in] = ACTIONS(5251),
    [anon_sym_QMARK] = ACTIONS(5251),
    [anon_sym_BANG] = ACTIONS(5251),
    [anon_sym_PLUS_PLUS] = ACTIONS(5249),
    [anon_sym_DASH_DASH] = ACTIONS(5249),
    [anon_sym_PLUS] = ACTIONS(5251),
    [anon_sym_DASH] = ACTIONS(5251),
    [anon_sym_STAR] = ACTIONS(5249),
    [anon_sym_SLASH] = ACTIONS(5251),
    [anon_sym_PERCENT] = ACTIONS(5249),
    [anon_sym_CARET] = ACTIONS(5249),
    [anon_sym_PIPE] = ACTIONS(5251),
    [anon_sym_AMP] = ACTIONS(5251),
    [anon_sym_LT_LT] = ACTIONS(5249),
    [anon_sym_GT_GT] = ACTIONS(5251),
    [anon_sym_GT_GT_GT] = ACTIONS(5249),
    [anon_sym_EQ_EQ] = ACTIONS(5249),
    [anon_sym_BANG_EQ] = ACTIONS(5249),
    [anon_sym_GT_EQ] = ACTIONS(5249),
    [anon_sym_LT_EQ] = ACTIONS(5249),
    [anon_sym_DOT] = ACTIONS(5251),
    [anon_sym_EQ_GT] = ACTIONS(5249),
    [anon_sym_switch] = ACTIONS(5249),
    [anon_sym_when] = ACTIONS(5249),
    [anon_sym_DOT_DOT] = ACTIONS(5249),
    [anon_sym_and] = ACTIONS(5249),
    [anon_sym_or] = ACTIONS(5249),
    [anon_sym_AMP_AMP] = ACTIONS(5249),
    [anon_sym_PIPE_PIPE] = ACTIONS(5249),
    [anon_sym_QMARK_QMARK] = ACTIONS(5249),
    [anon_sym_into] = ACTIONS(5249),
    [anon_sym_on] = ACTIONS(5249),
    [anon_sym_equals] = ACTIONS(5249),
    [anon_sym_by] = ACTIONS(5249),
    [anon_sym_as] = ACTIONS(5249),
    [anon_sym_is] = ACTIONS(5249),
    [anon_sym_DASH_GT] = ACTIONS(5249),
    [anon_sym_with] = ACTIONS(5249),
    [aux_sym_preproc_if_token3] = ACTIONS(5249),
    [aux_sym_preproc_else_token1] = ACTIONS(5249),
    [aux_sym_preproc_elif_token1] = ACTIONS(5249),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3997] = {
    [sym_preproc_region] = STATE(3997),
    [sym_preproc_endregion] = STATE(3997),
    [sym_preproc_line] = STATE(3997),
    [sym_preproc_pragma] = STATE(3997),
    [sym_preproc_nullable] = STATE(3997),
    [sym_preproc_error] = STATE(3997),
    [sym_preproc_define] = STATE(3997),
    [sym_preproc_undef] = STATE(3997),
    [anon_sym_SEMI] = ACTIONS(4739),
    [anon_sym_LBRACK] = ACTIONS(5792),
    [anon_sym_COLON] = ACTIONS(4739),
    [anon_sym_COMMA] = ACTIONS(4739),
    [anon_sym_RBRACK] = ACTIONS(4739),
    [anon_sym_LPAREN] = ACTIONS(5792),
    [anon_sym_RPAREN] = ACTIONS(4739),
    [anon_sym_RBRACE] = ACTIONS(4739),
    [anon_sym_LT] = ACTIONS(5795),
    [anon_sym_GT] = ACTIONS(5795),
    [anon_sym_in] = ACTIONS(4747),
    [anon_sym_QMARK] = ACTIONS(5795),
    [anon_sym_BANG] = ACTIONS(5795),
    [anon_sym_PLUS_PLUS] = ACTIONS(5792),
    [anon_sym_DASH_DASH] = ACTIONS(5792),
    [anon_sym_PLUS] = ACTIONS(5795),
    [anon_sym_DASH] = ACTIONS(5795),
    [anon_sym_STAR] = ACTIONS(5792),
    [anon_sym_SLASH] = ACTIONS(5795),
    [anon_sym_PERCENT] = ACTIONS(5792),
    [anon_sym_CARET] = ACTIONS(5792),
    [anon_sym_PIPE] = ACTIONS(5795),
    [anon_sym_AMP] = ACTIONS(5795),
    [anon_sym_LT_LT] = ACTIONS(5792),
    [anon_sym_GT_GT] = ACTIONS(5795),
    [anon_sym_GT_GT_GT] = ACTIONS(5792),
    [anon_sym_EQ_EQ] = ACTIONS(5792),
    [anon_sym_BANG_EQ] = ACTIONS(5792),
    [anon_sym_GT_EQ] = ACTIONS(5792),
    [anon_sym_LT_EQ] = ACTIONS(5792),
    [anon_sym_DOT] = ACTIONS(5795),
    [anon_sym_EQ_GT] = ACTIONS(4739),
    [anon_sym_switch] = ACTIONS(5792),
    [anon_sym_when] = ACTIONS(4739),
    [anon_sym_DOT_DOT] = ACTIONS(5792),
    [anon_sym_and] = ACTIONS(4739),
    [anon_sym_or] = ACTIONS(4739),
    [anon_sym_AMP_AMP] = ACTIONS(5792),
    [anon_sym_PIPE_PIPE] = ACTIONS(5792),
    [anon_sym_QMARK_QMARK] = ACTIONS(5792),
    [anon_sym_into] = ACTIONS(4739),
    [anon_sym_on] = ACTIONS(4739),
    [anon_sym_equals] = ACTIONS(4739),
    [anon_sym_by] = ACTIONS(4739),
    [anon_sym_as] = ACTIONS(5792),
    [anon_sym_is] = ACTIONS(5792),
    [anon_sym_DASH_GT] = ACTIONS(5792),
    [anon_sym_with] = ACTIONS(5792),
    [aux_sym_preproc_if_token3] = ACTIONS(4739),
    [aux_sym_preproc_else_token1] = ACTIONS(4739),
    [aux_sym_preproc_elif_token1] = ACTIONS(4739),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3998] = {
    [sym_preproc_region] = STATE(3998),
    [sym_preproc_endregion] = STATE(3998),
    [sym_preproc_line] = STATE(3998),
    [sym_preproc_pragma] = STATE(3998),
    [sym_preproc_nullable] = STATE(3998),
    [sym_preproc_error] = STATE(3998),
    [sym_preproc_define] = STATE(3998),
    [sym_preproc_undef] = STATE(3998),
    [anon_sym_SEMI] = ACTIONS(5381),
    [anon_sym_LBRACK] = ACTIONS(5381),
    [anon_sym_COLON] = ACTIONS(5381),
    [anon_sym_COMMA] = ACTIONS(5381),
    [anon_sym_RBRACK] = ACTIONS(5381),
    [anon_sym_LPAREN] = ACTIONS(5381),
    [anon_sym_RPAREN] = ACTIONS(5381),
    [anon_sym_RBRACE] = ACTIONS(5381),
    [anon_sym_LT] = ACTIONS(5383),
    [anon_sym_GT] = ACTIONS(5383),
    [anon_sym_in] = ACTIONS(5383),
    [anon_sym_QMARK] = ACTIONS(5383),
    [anon_sym_BANG] = ACTIONS(5383),
    [anon_sym_PLUS_PLUS] = ACTIONS(5381),
    [anon_sym_DASH_DASH] = ACTIONS(5381),
    [anon_sym_PLUS] = ACTIONS(5383),
    [anon_sym_DASH] = ACTIONS(5383),
    [anon_sym_STAR] = ACTIONS(5381),
    [anon_sym_SLASH] = ACTIONS(5383),
    [anon_sym_PERCENT] = ACTIONS(5381),
    [anon_sym_CARET] = ACTIONS(5381),
    [anon_sym_PIPE] = ACTIONS(5383),
    [anon_sym_AMP] = ACTIONS(5383),
    [anon_sym_LT_LT] = ACTIONS(5381),
    [anon_sym_GT_GT] = ACTIONS(5383),
    [anon_sym_GT_GT_GT] = ACTIONS(5381),
    [anon_sym_EQ_EQ] = ACTIONS(5381),
    [anon_sym_BANG_EQ] = ACTIONS(5381),
    [anon_sym_GT_EQ] = ACTIONS(5381),
    [anon_sym_LT_EQ] = ACTIONS(5381),
    [anon_sym_DOT] = ACTIONS(5383),
    [anon_sym_EQ_GT] = ACTIONS(5381),
    [anon_sym_switch] = ACTIONS(5381),
    [anon_sym_when] = ACTIONS(5381),
    [anon_sym_DOT_DOT] = ACTIONS(5381),
    [anon_sym_and] = ACTIONS(5381),
    [anon_sym_or] = ACTIONS(5381),
    [anon_sym_AMP_AMP] = ACTIONS(5381),
    [anon_sym_PIPE_PIPE] = ACTIONS(5381),
    [anon_sym_QMARK_QMARK] = ACTIONS(5381),
    [anon_sym_into] = ACTIONS(5381),
    [anon_sym_on] = ACTIONS(5381),
    [anon_sym_equals] = ACTIONS(5381),
    [anon_sym_by] = ACTIONS(5381),
    [anon_sym_as] = ACTIONS(5381),
    [anon_sym_is] = ACTIONS(5381),
    [anon_sym_DASH_GT] = ACTIONS(5381),
    [anon_sym_with] = ACTIONS(5381),
    [aux_sym_preproc_if_token3] = ACTIONS(5381),
    [aux_sym_preproc_else_token1] = ACTIONS(5381),
    [aux_sym_preproc_elif_token1] = ACTIONS(5381),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3999] = {
    [sym_preproc_region] = STATE(3999),
    [sym_preproc_endregion] = STATE(3999),
    [sym_preproc_line] = STATE(3999),
    [sym_preproc_pragma] = STATE(3999),
    [sym_preproc_nullable] = STATE(3999),
    [sym_preproc_error] = STATE(3999),
    [sym_preproc_define] = STATE(3999),
    [sym_preproc_undef] = STATE(3999),
    [anon_sym_SEMI] = ACTIONS(4349),
    [anon_sym_LBRACK] = ACTIONS(4349),
    [anon_sym_COLON] = ACTIONS(4349),
    [anon_sym_COMMA] = ACTIONS(4349),
    [anon_sym_RBRACK] = ACTIONS(4349),
    [anon_sym_LPAREN] = ACTIONS(4349),
    [anon_sym_RPAREN] = ACTIONS(4349),
    [anon_sym_LBRACE] = ACTIONS(4349),
    [anon_sym_RBRACE] = ACTIONS(4349),
    [anon_sym_LT] = ACTIONS(4347),
    [anon_sym_GT] = ACTIONS(4347),
    [anon_sym_in] = ACTIONS(4349),
    [anon_sym_QMARK] = ACTIONS(4347),
    [anon_sym_BANG] = ACTIONS(4347),
    [anon_sym_PLUS_PLUS] = ACTIONS(4349),
    [anon_sym_DASH_DASH] = ACTIONS(4349),
    [anon_sym_PLUS] = ACTIONS(4347),
    [anon_sym_DASH] = ACTIONS(4347),
    [anon_sym_STAR] = ACTIONS(4349),
    [anon_sym_SLASH] = ACTIONS(4347),
    [anon_sym_PERCENT] = ACTIONS(4349),
    [anon_sym_CARET] = ACTIONS(4349),
    [anon_sym_PIPE] = ACTIONS(4347),
    [anon_sym_AMP] = ACTIONS(4347),
    [anon_sym_LT_LT] = ACTIONS(4349),
    [anon_sym_GT_GT] = ACTIONS(4347),
    [anon_sym_GT_GT_GT] = ACTIONS(4349),
    [anon_sym_EQ_EQ] = ACTIONS(4349),
    [anon_sym_BANG_EQ] = ACTIONS(4349),
    [anon_sym_GT_EQ] = ACTIONS(4349),
    [anon_sym_LT_EQ] = ACTIONS(4349),
    [anon_sym_DOT] = ACTIONS(4347),
    [anon_sym_EQ_GT] = ACTIONS(4349),
    [anon_sym_switch] = ACTIONS(4349),
    [anon_sym_when] = ACTIONS(4349),
    [anon_sym_DOT_DOT] = ACTIONS(4349),
    [anon_sym_and] = ACTIONS(4349),
    [anon_sym_or] = ACTIONS(4349),
    [anon_sym_AMP_AMP] = ACTIONS(4349),
    [anon_sym_PIPE_PIPE] = ACTIONS(4349),
    [anon_sym_QMARK_QMARK] = ACTIONS(4349),
    [anon_sym_on] = ACTIONS(4349),
    [anon_sym_equals] = ACTIONS(4349),
    [anon_sym_by] = ACTIONS(4349),
    [anon_sym_as] = ACTIONS(4349),
    [anon_sym_is] = ACTIONS(4349),
    [anon_sym_DASH_GT] = ACTIONS(4349),
    [anon_sym_with] = ACTIONS(4349),
    [aux_sym_preproc_if_token3] = ACTIONS(4349),
    [aux_sym_preproc_else_token1] = ACTIONS(4349),
    [aux_sym_preproc_elif_token1] = ACTIONS(4349),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4000] = {
    [sym_preproc_region] = STATE(4000),
    [sym_preproc_endregion] = STATE(4000),
    [sym_preproc_line] = STATE(4000),
    [sym_preproc_pragma] = STATE(4000),
    [sym_preproc_nullable] = STATE(4000),
    [sym_preproc_error] = STATE(4000),
    [sym_preproc_define] = STATE(4000),
    [sym_preproc_undef] = STATE(4000),
    [anon_sym_SEMI] = ACTIONS(4504),
    [anon_sym_LBRACK] = ACTIONS(4504),
    [anon_sym_COLON] = ACTIONS(4504),
    [anon_sym_COMMA] = ACTIONS(4504),
    [anon_sym_RBRACK] = ACTIONS(4504),
    [anon_sym_LPAREN] = ACTIONS(4504),
    [anon_sym_RPAREN] = ACTIONS(4504),
    [anon_sym_LBRACE] = ACTIONS(4504),
    [anon_sym_RBRACE] = ACTIONS(4504),
    [anon_sym_LT] = ACTIONS(4502),
    [anon_sym_GT] = ACTIONS(4502),
    [anon_sym_in] = ACTIONS(4504),
    [anon_sym_QMARK] = ACTIONS(4502),
    [anon_sym_BANG] = ACTIONS(4502),
    [anon_sym_PLUS_PLUS] = ACTIONS(4504),
    [anon_sym_DASH_DASH] = ACTIONS(4504),
    [anon_sym_PLUS] = ACTIONS(4502),
    [anon_sym_DASH] = ACTIONS(4502),
    [anon_sym_STAR] = ACTIONS(4504),
    [anon_sym_SLASH] = ACTIONS(4502),
    [anon_sym_PERCENT] = ACTIONS(4504),
    [anon_sym_CARET] = ACTIONS(4504),
    [anon_sym_PIPE] = ACTIONS(4502),
    [anon_sym_AMP] = ACTIONS(4502),
    [anon_sym_LT_LT] = ACTIONS(4504),
    [anon_sym_GT_GT] = ACTIONS(4502),
    [anon_sym_GT_GT_GT] = ACTIONS(4504),
    [anon_sym_EQ_EQ] = ACTIONS(4504),
    [anon_sym_BANG_EQ] = ACTIONS(4504),
    [anon_sym_GT_EQ] = ACTIONS(4504),
    [anon_sym_LT_EQ] = ACTIONS(4504),
    [anon_sym_DOT] = ACTIONS(4502),
    [anon_sym_EQ_GT] = ACTIONS(4504),
    [anon_sym_switch] = ACTIONS(4504),
    [anon_sym_when] = ACTIONS(4504),
    [anon_sym_DOT_DOT] = ACTIONS(4504),
    [anon_sym_and] = ACTIONS(4504),
    [anon_sym_or] = ACTIONS(4504),
    [anon_sym_AMP_AMP] = ACTIONS(4504),
    [anon_sym_PIPE_PIPE] = ACTIONS(4504),
    [anon_sym_QMARK_QMARK] = ACTIONS(4504),
    [anon_sym_on] = ACTIONS(4504),
    [anon_sym_equals] = ACTIONS(4504),
    [anon_sym_by] = ACTIONS(4504),
    [anon_sym_as] = ACTIONS(4504),
    [anon_sym_is] = ACTIONS(4504),
    [anon_sym_DASH_GT] = ACTIONS(4504),
    [anon_sym_with] = ACTIONS(4504),
    [aux_sym_preproc_if_token3] = ACTIONS(4504),
    [aux_sym_preproc_else_token1] = ACTIONS(4504),
    [aux_sym_preproc_elif_token1] = ACTIONS(4504),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4001] = {
    [sym_preproc_region] = STATE(4001),
    [sym_preproc_endregion] = STATE(4001),
    [sym_preproc_line] = STATE(4001),
    [sym_preproc_pragma] = STATE(4001),
    [sym_preproc_nullable] = STATE(4001),
    [sym_preproc_error] = STATE(4001),
    [sym_preproc_define] = STATE(4001),
    [sym_preproc_undef] = STATE(4001),
    [anon_sym_SEMI] = ACTIONS(5568),
    [anon_sym_LBRACK] = ACTIONS(5568),
    [anon_sym_COLON] = ACTIONS(5568),
    [anon_sym_COMMA] = ACTIONS(5568),
    [anon_sym_RBRACK] = ACTIONS(5568),
    [anon_sym_LPAREN] = ACTIONS(5568),
    [anon_sym_RPAREN] = ACTIONS(5568),
    [anon_sym_RBRACE] = ACTIONS(5568),
    [anon_sym_LT] = ACTIONS(5570),
    [anon_sym_GT] = ACTIONS(5570),
    [anon_sym_in] = ACTIONS(5570),
    [anon_sym_QMARK] = ACTIONS(5570),
    [anon_sym_BANG] = ACTIONS(5570),
    [anon_sym_PLUS_PLUS] = ACTIONS(5568),
    [anon_sym_DASH_DASH] = ACTIONS(5568),
    [anon_sym_PLUS] = ACTIONS(5570),
    [anon_sym_DASH] = ACTIONS(5570),
    [anon_sym_STAR] = ACTIONS(5568),
    [anon_sym_SLASH] = ACTIONS(5570),
    [anon_sym_PERCENT] = ACTIONS(5568),
    [anon_sym_CARET] = ACTIONS(5568),
    [anon_sym_PIPE] = ACTIONS(5570),
    [anon_sym_AMP] = ACTIONS(5570),
    [anon_sym_LT_LT] = ACTIONS(5568),
    [anon_sym_GT_GT] = ACTIONS(5570),
    [anon_sym_GT_GT_GT] = ACTIONS(5568),
    [anon_sym_EQ_EQ] = ACTIONS(5568),
    [anon_sym_BANG_EQ] = ACTIONS(5568),
    [anon_sym_GT_EQ] = ACTIONS(5568),
    [anon_sym_LT_EQ] = ACTIONS(5568),
    [anon_sym_DOT] = ACTIONS(5570),
    [anon_sym_EQ_GT] = ACTIONS(5568),
    [anon_sym_switch] = ACTIONS(5568),
    [anon_sym_when] = ACTIONS(5568),
    [anon_sym_DOT_DOT] = ACTIONS(5568),
    [anon_sym_and] = ACTIONS(5568),
    [anon_sym_or] = ACTIONS(5568),
    [anon_sym_AMP_AMP] = ACTIONS(5568),
    [anon_sym_PIPE_PIPE] = ACTIONS(5568),
    [anon_sym_QMARK_QMARK] = ACTIONS(5568),
    [anon_sym_into] = ACTIONS(5568),
    [anon_sym_on] = ACTIONS(5568),
    [anon_sym_equals] = ACTIONS(5568),
    [anon_sym_by] = ACTIONS(5568),
    [anon_sym_as] = ACTIONS(5568),
    [anon_sym_is] = ACTIONS(5568),
    [anon_sym_DASH_GT] = ACTIONS(5568),
    [anon_sym_with] = ACTIONS(5568),
    [aux_sym_preproc_if_token3] = ACTIONS(5568),
    [aux_sym_preproc_else_token1] = ACTIONS(5568),
    [aux_sym_preproc_elif_token1] = ACTIONS(5568),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4002] = {
    [sym_preproc_region] = STATE(4002),
    [sym_preproc_endregion] = STATE(4002),
    [sym_preproc_line] = STATE(4002),
    [sym_preproc_pragma] = STATE(4002),
    [sym_preproc_nullable] = STATE(4002),
    [sym_preproc_error] = STATE(4002),
    [sym_preproc_define] = STATE(4002),
    [sym_preproc_undef] = STATE(4002),
    [anon_sym_EQ] = ACTIONS(5798),
    [anon_sym_LBRACK] = ACTIONS(5249),
    [anon_sym_LPAREN] = ACTIONS(5249),
    [anon_sym_LT] = ACTIONS(5251),
    [anon_sym_GT] = ACTIONS(5251),
    [anon_sym_QMARK] = ACTIONS(5251),
    [anon_sym_BANG] = ACTIONS(5251),
    [anon_sym_PLUS_PLUS] = ACTIONS(5249),
    [anon_sym_DASH_DASH] = ACTIONS(5249),
    [anon_sym_PLUS] = ACTIONS(5251),
    [anon_sym_DASH] = ACTIONS(5251),
    [anon_sym_STAR] = ACTIONS(5251),
    [anon_sym_SLASH] = ACTIONS(5251),
    [anon_sym_PERCENT] = ACTIONS(5251),
    [anon_sym_CARET] = ACTIONS(5251),
    [anon_sym_PIPE] = ACTIONS(5251),
    [anon_sym_AMP] = ACTIONS(5251),
    [anon_sym_LT_LT] = ACTIONS(5251),
    [anon_sym_GT_GT] = ACTIONS(5251),
    [anon_sym_GT_GT_GT] = ACTIONS(5251),
    [anon_sym_EQ_EQ] = ACTIONS(5249),
    [anon_sym_BANG_EQ] = ACTIONS(5249),
    [anon_sym_GT_EQ] = ACTIONS(5249),
    [anon_sym_LT_EQ] = ACTIONS(5249),
    [anon_sym_DOT] = ACTIONS(5251),
    [anon_sym_EQ_GT] = ACTIONS(5249),
    [anon_sym_switch] = ACTIONS(5249),
    [anon_sym_when] = ACTIONS(5249),
    [anon_sym_DOT_DOT] = ACTIONS(5249),
    [anon_sym_and] = ACTIONS(5249),
    [anon_sym_or] = ACTIONS(5249),
    [anon_sym_PLUS_EQ] = ACTIONS(5800),
    [anon_sym_DASH_EQ] = ACTIONS(5800),
    [anon_sym_STAR_EQ] = ACTIONS(5800),
    [anon_sym_SLASH_EQ] = ACTIONS(5800),
    [anon_sym_PERCENT_EQ] = ACTIONS(5800),
    [anon_sym_AMP_EQ] = ACTIONS(5800),
    [anon_sym_CARET_EQ] = ACTIONS(5800),
    [anon_sym_PIPE_EQ] = ACTIONS(5800),
    [anon_sym_LT_LT_EQ] = ACTIONS(5800),
    [anon_sym_GT_GT_EQ] = ACTIONS(5800),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5800),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(5800),
    [anon_sym_AMP_AMP] = ACTIONS(5249),
    [anon_sym_PIPE_PIPE] = ACTIONS(5249),
    [anon_sym_QMARK_QMARK] = ACTIONS(5251),
    [anon_sym_into] = ACTIONS(5249),
    [anon_sym_as] = ACTIONS(5249),
    [anon_sym_is] = ACTIONS(5249),
    [anon_sym_DASH_GT] = ACTIONS(5249),
    [anon_sym_with] = ACTIONS(5249),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4003] = {
    [sym_preproc_region] = STATE(4003),
    [sym_preproc_endregion] = STATE(4003),
    [sym_preproc_line] = STATE(4003),
    [sym_preproc_pragma] = STATE(4003),
    [sym_preproc_nullable] = STATE(4003),
    [sym_preproc_error] = STATE(4003),
    [sym_preproc_define] = STATE(4003),
    [sym_preproc_undef] = STATE(4003),
    [anon_sym_SEMI] = ACTIONS(5396),
    [anon_sym_LBRACK] = ACTIONS(5396),
    [anon_sym_COLON] = ACTIONS(5396),
    [anon_sym_COMMA] = ACTIONS(5396),
    [anon_sym_RBRACK] = ACTIONS(5396),
    [anon_sym_LPAREN] = ACTIONS(5396),
    [anon_sym_RPAREN] = ACTIONS(5396),
    [anon_sym_RBRACE] = ACTIONS(5396),
    [anon_sym_LT] = ACTIONS(5398),
    [anon_sym_GT] = ACTIONS(5398),
    [anon_sym_in] = ACTIONS(5398),
    [anon_sym_QMARK] = ACTIONS(5398),
    [anon_sym_BANG] = ACTIONS(5398),
    [anon_sym_PLUS_PLUS] = ACTIONS(5396),
    [anon_sym_DASH_DASH] = ACTIONS(5396),
    [anon_sym_PLUS] = ACTIONS(5398),
    [anon_sym_DASH] = ACTIONS(5398),
    [anon_sym_STAR] = ACTIONS(5396),
    [anon_sym_SLASH] = ACTIONS(5398),
    [anon_sym_PERCENT] = ACTIONS(5396),
    [anon_sym_CARET] = ACTIONS(5396),
    [anon_sym_PIPE] = ACTIONS(5398),
    [anon_sym_AMP] = ACTIONS(5398),
    [anon_sym_LT_LT] = ACTIONS(5396),
    [anon_sym_GT_GT] = ACTIONS(5398),
    [anon_sym_GT_GT_GT] = ACTIONS(5396),
    [anon_sym_EQ_EQ] = ACTIONS(5396),
    [anon_sym_BANG_EQ] = ACTIONS(5396),
    [anon_sym_GT_EQ] = ACTIONS(5396),
    [anon_sym_LT_EQ] = ACTIONS(5396),
    [anon_sym_DOT] = ACTIONS(5398),
    [anon_sym_EQ_GT] = ACTIONS(5396),
    [anon_sym_switch] = ACTIONS(5396),
    [anon_sym_when] = ACTIONS(5396),
    [anon_sym_DOT_DOT] = ACTIONS(5396),
    [anon_sym_and] = ACTIONS(5396),
    [anon_sym_or] = ACTIONS(5396),
    [anon_sym_AMP_AMP] = ACTIONS(5396),
    [anon_sym_PIPE_PIPE] = ACTIONS(5396),
    [anon_sym_QMARK_QMARK] = ACTIONS(5396),
    [anon_sym_into] = ACTIONS(5396),
    [anon_sym_on] = ACTIONS(5396),
    [anon_sym_equals] = ACTIONS(5396),
    [anon_sym_by] = ACTIONS(5396),
    [anon_sym_as] = ACTIONS(5396),
    [anon_sym_is] = ACTIONS(5396),
    [anon_sym_DASH_GT] = ACTIONS(5396),
    [anon_sym_with] = ACTIONS(5396),
    [aux_sym_preproc_if_token3] = ACTIONS(5396),
    [aux_sym_preproc_else_token1] = ACTIONS(5396),
    [aux_sym_preproc_elif_token1] = ACTIONS(5396),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4004] = {
    [sym_preproc_region] = STATE(4004),
    [sym_preproc_endregion] = STATE(4004),
    [sym_preproc_line] = STATE(4004),
    [sym_preproc_pragma] = STATE(4004),
    [sym_preproc_nullable] = STATE(4004),
    [sym_preproc_error] = STATE(4004),
    [sym_preproc_define] = STATE(4004),
    [sym_preproc_undef] = STATE(4004),
    [anon_sym_SEMI] = ACTIONS(5400),
    [anon_sym_LBRACK] = ACTIONS(5400),
    [anon_sym_COLON] = ACTIONS(5400),
    [anon_sym_COMMA] = ACTIONS(5400),
    [anon_sym_RBRACK] = ACTIONS(5400),
    [anon_sym_LPAREN] = ACTIONS(5400),
    [anon_sym_RPAREN] = ACTIONS(5400),
    [anon_sym_RBRACE] = ACTIONS(5400),
    [anon_sym_LT] = ACTIONS(5402),
    [anon_sym_GT] = ACTIONS(5402),
    [anon_sym_in] = ACTIONS(5402),
    [anon_sym_QMARK] = ACTIONS(5402),
    [anon_sym_BANG] = ACTIONS(5402),
    [anon_sym_PLUS_PLUS] = ACTIONS(5400),
    [anon_sym_DASH_DASH] = ACTIONS(5400),
    [anon_sym_PLUS] = ACTIONS(5402),
    [anon_sym_DASH] = ACTIONS(5402),
    [anon_sym_STAR] = ACTIONS(5400),
    [anon_sym_SLASH] = ACTIONS(5402),
    [anon_sym_PERCENT] = ACTIONS(5400),
    [anon_sym_CARET] = ACTIONS(5400),
    [anon_sym_PIPE] = ACTIONS(5402),
    [anon_sym_AMP] = ACTIONS(5402),
    [anon_sym_LT_LT] = ACTIONS(5400),
    [anon_sym_GT_GT] = ACTIONS(5402),
    [anon_sym_GT_GT_GT] = ACTIONS(5400),
    [anon_sym_EQ_EQ] = ACTIONS(5400),
    [anon_sym_BANG_EQ] = ACTIONS(5400),
    [anon_sym_GT_EQ] = ACTIONS(5400),
    [anon_sym_LT_EQ] = ACTIONS(5400),
    [anon_sym_DOT] = ACTIONS(5402),
    [anon_sym_EQ_GT] = ACTIONS(5400),
    [anon_sym_switch] = ACTIONS(5400),
    [anon_sym_when] = ACTIONS(5400),
    [anon_sym_DOT_DOT] = ACTIONS(5400),
    [anon_sym_and] = ACTIONS(5400),
    [anon_sym_or] = ACTIONS(5400),
    [anon_sym_AMP_AMP] = ACTIONS(5400),
    [anon_sym_PIPE_PIPE] = ACTIONS(5400),
    [anon_sym_QMARK_QMARK] = ACTIONS(5400),
    [anon_sym_into] = ACTIONS(5400),
    [anon_sym_on] = ACTIONS(5400),
    [anon_sym_equals] = ACTIONS(5400),
    [anon_sym_by] = ACTIONS(5400),
    [anon_sym_as] = ACTIONS(5400),
    [anon_sym_is] = ACTIONS(5400),
    [anon_sym_DASH_GT] = ACTIONS(5400),
    [anon_sym_with] = ACTIONS(5400),
    [aux_sym_preproc_if_token3] = ACTIONS(5400),
    [aux_sym_preproc_else_token1] = ACTIONS(5400),
    [aux_sym_preproc_elif_token1] = ACTIONS(5400),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4005] = {
    [sym_preproc_region] = STATE(4005),
    [sym_preproc_endregion] = STATE(4005),
    [sym_preproc_line] = STATE(4005),
    [sym_preproc_pragma] = STATE(4005),
    [sym_preproc_nullable] = STATE(4005),
    [sym_preproc_error] = STATE(4005),
    [sym_preproc_define] = STATE(4005),
    [sym_preproc_undef] = STATE(4005),
    [sym__identifier_token] = ACTIONS(3976),
    [anon_sym_extern] = ACTIONS(3976),
    [anon_sym_alias] = ACTIONS(3976),
    [anon_sym_global] = ACTIONS(3976),
    [anon_sym_unsafe] = ACTIONS(3976),
    [anon_sym_static] = ACTIONS(3976),
    [anon_sym_LPAREN] = ACTIONS(5566),
    [anon_sym_class] = ACTIONS(3976),
    [anon_sym_ref] = ACTIONS(3976),
    [anon_sym_struct] = ACTIONS(3976),
    [anon_sym_enum] = ACTIONS(3976),
    [anon_sym_interface] = ACTIONS(3976),
    [anon_sym_delegate] = ACTIONS(3976),
    [anon_sym_record] = ACTIONS(3976),
    [anon_sym_abstract] = ACTIONS(3976),
    [anon_sym_async] = ACTIONS(3976),
    [anon_sym_const] = ACTIONS(3976),
    [anon_sym_file] = ACTIONS(3976),
    [anon_sym_fixed] = ACTIONS(3976),
    [anon_sym_internal] = ACTIONS(3976),
    [anon_sym_new] = ACTIONS(3976),
    [anon_sym_override] = ACTIONS(3976),
    [anon_sym_partial] = ACTIONS(3976),
    [anon_sym_private] = ACTIONS(3976),
    [anon_sym_protected] = ACTIONS(3976),
    [anon_sym_public] = ACTIONS(3976),
    [anon_sym_readonly] = ACTIONS(3976),
    [anon_sym_required] = ACTIONS(3976),
    [anon_sym_sealed] = ACTIONS(3976),
    [anon_sym_virtual] = ACTIONS(3976),
    [anon_sym_volatile] = ACTIONS(3976),
    [anon_sym_where] = ACTIONS(3976),
    [anon_sym_notnull] = ACTIONS(3976),
    [anon_sym_unmanaged] = ACTIONS(3976),
    [anon_sym_scoped] = ACTIONS(3976),
    [anon_sym_var] = ACTIONS(3976),
    [sym_predefined_type] = ACTIONS(3976),
    [anon_sym_yield] = ACTIONS(3976),
    [anon_sym_when] = ACTIONS(3976),
    [anon_sym_from] = ACTIONS(3976),
    [anon_sym_into] = ACTIONS(3976),
    [anon_sym_join] = ACTIONS(3976),
    [anon_sym_on] = ACTIONS(3976),
    [anon_sym_equals] = ACTIONS(3976),
    [anon_sym_let] = ACTIONS(3976),
    [anon_sym_orderby] = ACTIONS(3976),
    [anon_sym_ascending] = ACTIONS(3976),
    [anon_sym_descending] = ACTIONS(3976),
    [anon_sym_group] = ACTIONS(3976),
    [anon_sym_by] = ACTIONS(3976),
    [anon_sym_select] = ACTIONS(3976),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4006] = {
    [sym_preproc_region] = STATE(4006),
    [sym_preproc_endregion] = STATE(4006),
    [sym_preproc_line] = STATE(4006),
    [sym_preproc_pragma] = STATE(4006),
    [sym_preproc_nullable] = STATE(4006),
    [sym_preproc_error] = STATE(4006),
    [sym_preproc_define] = STATE(4006),
    [sym_preproc_undef] = STATE(4006),
    [anon_sym_SEMI] = ACTIONS(5369),
    [anon_sym_LBRACK] = ACTIONS(5369),
    [anon_sym_COLON] = ACTIONS(5369),
    [anon_sym_COMMA] = ACTIONS(5369),
    [anon_sym_RBRACK] = ACTIONS(5369),
    [anon_sym_LPAREN] = ACTIONS(5369),
    [anon_sym_RPAREN] = ACTIONS(5369),
    [anon_sym_RBRACE] = ACTIONS(5369),
    [anon_sym_LT] = ACTIONS(5371),
    [anon_sym_GT] = ACTIONS(5371),
    [anon_sym_in] = ACTIONS(5371),
    [anon_sym_QMARK] = ACTIONS(5371),
    [anon_sym_BANG] = ACTIONS(5371),
    [anon_sym_PLUS_PLUS] = ACTIONS(5369),
    [anon_sym_DASH_DASH] = ACTIONS(5369),
    [anon_sym_PLUS] = ACTIONS(5371),
    [anon_sym_DASH] = ACTIONS(5371),
    [anon_sym_STAR] = ACTIONS(5369),
    [anon_sym_SLASH] = ACTIONS(5371),
    [anon_sym_PERCENT] = ACTIONS(5369),
    [anon_sym_CARET] = ACTIONS(5369),
    [anon_sym_PIPE] = ACTIONS(5371),
    [anon_sym_AMP] = ACTIONS(5371),
    [anon_sym_LT_LT] = ACTIONS(5369),
    [anon_sym_GT_GT] = ACTIONS(5371),
    [anon_sym_GT_GT_GT] = ACTIONS(5369),
    [anon_sym_EQ_EQ] = ACTIONS(5369),
    [anon_sym_BANG_EQ] = ACTIONS(5369),
    [anon_sym_GT_EQ] = ACTIONS(5369),
    [anon_sym_LT_EQ] = ACTIONS(5369),
    [anon_sym_DOT] = ACTIONS(5371),
    [anon_sym_EQ_GT] = ACTIONS(5369),
    [anon_sym_switch] = ACTIONS(5369),
    [anon_sym_when] = ACTIONS(5369),
    [anon_sym_DOT_DOT] = ACTIONS(5369),
    [anon_sym_and] = ACTIONS(5369),
    [anon_sym_or] = ACTIONS(5369),
    [anon_sym_AMP_AMP] = ACTIONS(5369),
    [anon_sym_PIPE_PIPE] = ACTIONS(5369),
    [anon_sym_QMARK_QMARK] = ACTIONS(5369),
    [anon_sym_into] = ACTIONS(5369),
    [anon_sym_on] = ACTIONS(5369),
    [anon_sym_equals] = ACTIONS(5369),
    [anon_sym_by] = ACTIONS(5369),
    [anon_sym_as] = ACTIONS(5369),
    [anon_sym_is] = ACTIONS(5369),
    [anon_sym_DASH_GT] = ACTIONS(5369),
    [anon_sym_with] = ACTIONS(5369),
    [aux_sym_preproc_if_token3] = ACTIONS(5369),
    [aux_sym_preproc_else_token1] = ACTIONS(5369),
    [aux_sym_preproc_elif_token1] = ACTIONS(5369),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4007] = {
    [sym_preproc_region] = STATE(4007),
    [sym_preproc_endregion] = STATE(4007),
    [sym_preproc_line] = STATE(4007),
    [sym_preproc_pragma] = STATE(4007),
    [sym_preproc_nullable] = STATE(4007),
    [sym_preproc_error] = STATE(4007),
    [sym_preproc_define] = STATE(4007),
    [sym_preproc_undef] = STATE(4007),
    [anon_sym_SEMI] = ACTIONS(5420),
    [anon_sym_LBRACK] = ACTIONS(5420),
    [anon_sym_COLON] = ACTIONS(5420),
    [anon_sym_COMMA] = ACTIONS(5420),
    [anon_sym_RBRACK] = ACTIONS(5420),
    [anon_sym_LPAREN] = ACTIONS(5420),
    [anon_sym_RPAREN] = ACTIONS(5420),
    [anon_sym_RBRACE] = ACTIONS(5420),
    [anon_sym_LT] = ACTIONS(5422),
    [anon_sym_GT] = ACTIONS(5422),
    [anon_sym_in] = ACTIONS(5422),
    [anon_sym_QMARK] = ACTIONS(5422),
    [anon_sym_BANG] = ACTIONS(5422),
    [anon_sym_PLUS_PLUS] = ACTIONS(5420),
    [anon_sym_DASH_DASH] = ACTIONS(5420),
    [anon_sym_PLUS] = ACTIONS(5422),
    [anon_sym_DASH] = ACTIONS(5422),
    [anon_sym_STAR] = ACTIONS(5420),
    [anon_sym_SLASH] = ACTIONS(5422),
    [anon_sym_PERCENT] = ACTIONS(5420),
    [anon_sym_CARET] = ACTIONS(5420),
    [anon_sym_PIPE] = ACTIONS(5422),
    [anon_sym_AMP] = ACTIONS(5422),
    [anon_sym_LT_LT] = ACTIONS(5420),
    [anon_sym_GT_GT] = ACTIONS(5422),
    [anon_sym_GT_GT_GT] = ACTIONS(5420),
    [anon_sym_EQ_EQ] = ACTIONS(5420),
    [anon_sym_BANG_EQ] = ACTIONS(5420),
    [anon_sym_GT_EQ] = ACTIONS(5420),
    [anon_sym_LT_EQ] = ACTIONS(5420),
    [anon_sym_DOT] = ACTIONS(5422),
    [anon_sym_EQ_GT] = ACTIONS(5420),
    [anon_sym_switch] = ACTIONS(5420),
    [anon_sym_when] = ACTIONS(5420),
    [anon_sym_DOT_DOT] = ACTIONS(5420),
    [anon_sym_and] = ACTIONS(5420),
    [anon_sym_or] = ACTIONS(5420),
    [anon_sym_AMP_AMP] = ACTIONS(5420),
    [anon_sym_PIPE_PIPE] = ACTIONS(5420),
    [anon_sym_QMARK_QMARK] = ACTIONS(5420),
    [anon_sym_into] = ACTIONS(5420),
    [anon_sym_on] = ACTIONS(5420),
    [anon_sym_equals] = ACTIONS(5420),
    [anon_sym_by] = ACTIONS(5420),
    [anon_sym_as] = ACTIONS(5420),
    [anon_sym_is] = ACTIONS(5420),
    [anon_sym_DASH_GT] = ACTIONS(5420),
    [anon_sym_with] = ACTIONS(5420),
    [aux_sym_preproc_if_token3] = ACTIONS(5420),
    [aux_sym_preproc_else_token1] = ACTIONS(5420),
    [aux_sym_preproc_elif_token1] = ACTIONS(5420),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4008] = {
    [sym_preproc_region] = STATE(4008),
    [sym_preproc_endregion] = STATE(4008),
    [sym_preproc_line] = STATE(4008),
    [sym_preproc_pragma] = STATE(4008),
    [sym_preproc_nullable] = STATE(4008),
    [sym_preproc_error] = STATE(4008),
    [sym_preproc_define] = STATE(4008),
    [sym_preproc_undef] = STATE(4008),
    [anon_sym_EQ] = ACTIONS(5802),
    [anon_sym_LBRACK] = ACTIONS(5249),
    [anon_sym_COLON] = ACTIONS(5249),
    [anon_sym_COMMA] = ACTIONS(5249),
    [anon_sym_LPAREN] = ACTIONS(5249),
    [anon_sym_RPAREN] = ACTIONS(5249),
    [anon_sym_RBRACE] = ACTIONS(5249),
    [anon_sym_LT] = ACTIONS(5251),
    [anon_sym_GT] = ACTIONS(5251),
    [anon_sym_QMARK] = ACTIONS(5251),
    [anon_sym_BANG] = ACTIONS(5251),
    [anon_sym_PLUS_PLUS] = ACTIONS(5249),
    [anon_sym_DASH_DASH] = ACTIONS(5249),
    [anon_sym_PLUS] = ACTIONS(5251),
    [anon_sym_DASH] = ACTIONS(5251),
    [anon_sym_STAR] = ACTIONS(5251),
    [anon_sym_SLASH] = ACTIONS(5251),
    [anon_sym_PERCENT] = ACTIONS(5251),
    [anon_sym_CARET] = ACTIONS(5251),
    [anon_sym_PIPE] = ACTIONS(5251),
    [anon_sym_AMP] = ACTIONS(5251),
    [anon_sym_LT_LT] = ACTIONS(5251),
    [anon_sym_GT_GT] = ACTIONS(5251),
    [anon_sym_GT_GT_GT] = ACTIONS(5251),
    [anon_sym_EQ_EQ] = ACTIONS(5249),
    [anon_sym_BANG_EQ] = ACTIONS(5249),
    [anon_sym_GT_EQ] = ACTIONS(5249),
    [anon_sym_LT_EQ] = ACTIONS(5249),
    [anon_sym_DOT] = ACTIONS(5251),
    [anon_sym_switch] = ACTIONS(5249),
    [anon_sym_DOT_DOT] = ACTIONS(5249),
    [anon_sym_PLUS_EQ] = ACTIONS(5804),
    [anon_sym_DASH_EQ] = ACTIONS(5804),
    [anon_sym_STAR_EQ] = ACTIONS(5804),
    [anon_sym_SLASH_EQ] = ACTIONS(5804),
    [anon_sym_PERCENT_EQ] = ACTIONS(5804),
    [anon_sym_AMP_EQ] = ACTIONS(5804),
    [anon_sym_CARET_EQ] = ACTIONS(5804),
    [anon_sym_PIPE_EQ] = ACTIONS(5804),
    [anon_sym_LT_LT_EQ] = ACTIONS(5804),
    [anon_sym_GT_GT_EQ] = ACTIONS(5804),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5804),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(5804),
    [anon_sym_AMP_AMP] = ACTIONS(5249),
    [anon_sym_PIPE_PIPE] = ACTIONS(5249),
    [anon_sym_QMARK_QMARK] = ACTIONS(5251),
    [anon_sym_into] = ACTIONS(5249),
    [anon_sym_as] = ACTIONS(5249),
    [anon_sym_is] = ACTIONS(5249),
    [anon_sym_DASH_GT] = ACTIONS(5249),
    [anon_sym_with] = ACTIONS(5249),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4009] = {
    [sym_preproc_region] = STATE(4009),
    [sym_preproc_endregion] = STATE(4009),
    [sym_preproc_line] = STATE(4009),
    [sym_preproc_pragma] = STATE(4009),
    [sym_preproc_nullable] = STATE(4009),
    [sym_preproc_error] = STATE(4009),
    [sym_preproc_define] = STATE(4009),
    [sym_preproc_undef] = STATE(4009),
    [sym__identifier_token] = ACTIONS(3976),
    [anon_sym_extern] = ACTIONS(3976),
    [anon_sym_alias] = ACTIONS(5806),
    [anon_sym_global] = ACTIONS(3976),
    [anon_sym_unsafe] = ACTIONS(3976),
    [anon_sym_static] = ACTIONS(3976),
    [anon_sym_LPAREN] = ACTIONS(5566),
    [anon_sym_class] = ACTIONS(3976),
    [anon_sym_ref] = ACTIONS(3976),
    [anon_sym_struct] = ACTIONS(3976),
    [anon_sym_enum] = ACTIONS(3976),
    [anon_sym_interface] = ACTIONS(3976),
    [anon_sym_delegate] = ACTIONS(3976),
    [anon_sym_record] = ACTIONS(3976),
    [anon_sym_abstract] = ACTIONS(3976),
    [anon_sym_async] = ACTIONS(3976),
    [anon_sym_const] = ACTIONS(3976),
    [anon_sym_file] = ACTIONS(3976),
    [anon_sym_fixed] = ACTIONS(3976),
    [anon_sym_internal] = ACTIONS(3976),
    [anon_sym_new] = ACTIONS(3976),
    [anon_sym_override] = ACTIONS(3976),
    [anon_sym_partial] = ACTIONS(3976),
    [anon_sym_private] = ACTIONS(3976),
    [anon_sym_protected] = ACTIONS(3976),
    [anon_sym_public] = ACTIONS(3976),
    [anon_sym_readonly] = ACTIONS(3976),
    [anon_sym_required] = ACTIONS(3976),
    [anon_sym_sealed] = ACTIONS(3976),
    [anon_sym_virtual] = ACTIONS(3976),
    [anon_sym_volatile] = ACTIONS(3976),
    [anon_sym_where] = ACTIONS(3976),
    [anon_sym_notnull] = ACTIONS(3976),
    [anon_sym_unmanaged] = ACTIONS(3976),
    [anon_sym_scoped] = ACTIONS(3976),
    [anon_sym_var] = ACTIONS(3976),
    [sym_predefined_type] = ACTIONS(3976),
    [anon_sym_yield] = ACTIONS(3976),
    [anon_sym_when] = ACTIONS(3976),
    [anon_sym_from] = ACTIONS(3976),
    [anon_sym_into] = ACTIONS(3976),
    [anon_sym_join] = ACTIONS(3976),
    [anon_sym_on] = ACTIONS(3976),
    [anon_sym_equals] = ACTIONS(3976),
    [anon_sym_let] = ACTIONS(3976),
    [anon_sym_orderby] = ACTIONS(3976),
    [anon_sym_ascending] = ACTIONS(3976),
    [anon_sym_descending] = ACTIONS(3976),
    [anon_sym_group] = ACTIONS(3976),
    [anon_sym_by] = ACTIONS(3976),
    [anon_sym_select] = ACTIONS(3976),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4010] = {
    [sym_preproc_region] = STATE(4010),
    [sym_preproc_endregion] = STATE(4010),
    [sym_preproc_line] = STATE(4010),
    [sym_preproc_pragma] = STATE(4010),
    [sym_preproc_nullable] = STATE(4010),
    [sym_preproc_error] = STATE(4010),
    [sym_preproc_define] = STATE(4010),
    [sym_preproc_undef] = STATE(4010),
    [anon_sym_SEMI] = ACTIONS(5808),
    [anon_sym_LBRACK] = ACTIONS(5808),
    [anon_sym_COLON] = ACTIONS(5808),
    [anon_sym_COMMA] = ACTIONS(5808),
    [anon_sym_RBRACK] = ACTIONS(5808),
    [anon_sym_LPAREN] = ACTIONS(5808),
    [anon_sym_RPAREN] = ACTIONS(5808),
    [anon_sym_RBRACE] = ACTIONS(5808),
    [anon_sym_LT] = ACTIONS(5810),
    [anon_sym_GT] = ACTIONS(5810),
    [anon_sym_in] = ACTIONS(5810),
    [anon_sym_QMARK] = ACTIONS(5810),
    [anon_sym_BANG] = ACTIONS(5810),
    [anon_sym_PLUS_PLUS] = ACTIONS(5808),
    [anon_sym_DASH_DASH] = ACTIONS(5808),
    [anon_sym_PLUS] = ACTIONS(5810),
    [anon_sym_DASH] = ACTIONS(5810),
    [anon_sym_STAR] = ACTIONS(5808),
    [anon_sym_SLASH] = ACTIONS(5810),
    [anon_sym_PERCENT] = ACTIONS(5808),
    [anon_sym_CARET] = ACTIONS(5808),
    [anon_sym_PIPE] = ACTIONS(5810),
    [anon_sym_AMP] = ACTIONS(5810),
    [anon_sym_LT_LT] = ACTIONS(5808),
    [anon_sym_GT_GT] = ACTIONS(5810),
    [anon_sym_GT_GT_GT] = ACTIONS(5808),
    [anon_sym_EQ_EQ] = ACTIONS(5808),
    [anon_sym_BANG_EQ] = ACTIONS(5808),
    [anon_sym_GT_EQ] = ACTIONS(5808),
    [anon_sym_LT_EQ] = ACTIONS(5808),
    [anon_sym_DOT] = ACTIONS(5810),
    [anon_sym_EQ_GT] = ACTIONS(5808),
    [anon_sym_switch] = ACTIONS(5808),
    [anon_sym_when] = ACTIONS(5808),
    [anon_sym_DOT_DOT] = ACTIONS(5808),
    [anon_sym_and] = ACTIONS(5808),
    [anon_sym_or] = ACTIONS(5808),
    [anon_sym_AMP_AMP] = ACTIONS(5808),
    [anon_sym_PIPE_PIPE] = ACTIONS(5808),
    [anon_sym_QMARK_QMARK] = ACTIONS(5808),
    [anon_sym_into] = ACTIONS(5808),
    [anon_sym_on] = ACTIONS(5808),
    [anon_sym_equals] = ACTIONS(5808),
    [anon_sym_by] = ACTIONS(5808),
    [anon_sym_as] = ACTIONS(5808),
    [anon_sym_is] = ACTIONS(5808),
    [anon_sym_DASH_GT] = ACTIONS(5808),
    [anon_sym_with] = ACTIONS(5808),
    [aux_sym_preproc_if_token3] = ACTIONS(5808),
    [aux_sym_preproc_else_token1] = ACTIONS(5808),
    [aux_sym_preproc_elif_token1] = ACTIONS(5808),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4011] = {
    [sym_modifier] = STATE(4458),
    [sym_identifier] = STATE(7822),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_region] = STATE(4011),
    [sym_preproc_endregion] = STATE(4011),
    [sym_preproc_line] = STATE(4011),
    [sym_preproc_pragma] = STATE(4011),
    [sym_preproc_nullable] = STATE(4011),
    [sym_preproc_error] = STATE(4011),
    [sym_preproc_define] = STATE(4011),
    [sym_preproc_undef] = STATE(4011),
    [aux_sym_class_declaration_repeat2] = STATE(4334),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(5456),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_unsafe] = ACTIONS(5456),
    [anon_sym_static] = ACTIONS(5456),
    [anon_sym_abstract] = ACTIONS(5456),
    [anon_sym_async] = ACTIONS(5456),
    [anon_sym_const] = ACTIONS(5456),
    [anon_sym_file] = ACTIONS(5462),
    [anon_sym_fixed] = ACTIONS(5456),
    [anon_sym_internal] = ACTIONS(5456),
    [anon_sym_new] = ACTIONS(5456),
    [anon_sym_override] = ACTIONS(5456),
    [anon_sym_partial] = ACTIONS(5456),
    [anon_sym_private] = ACTIONS(5456),
    [anon_sym_protected] = ACTIONS(5456),
    [anon_sym_public] = ACTIONS(5456),
    [anon_sym_readonly] = ACTIONS(5456),
    [anon_sym_required] = ACTIONS(5456),
    [anon_sym_sealed] = ACTIONS(5456),
    [anon_sym_virtual] = ACTIONS(5456),
    [anon_sym_volatile] = ACTIONS(5456),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_get] = ACTIONS(5671),
    [anon_sym_set] = ACTIONS(5671),
    [anon_sym_add] = ACTIONS(5671),
    [anon_sym_remove] = ACTIONS(5671),
    [anon_sym_init] = ACTIONS(5671),
    [anon_sym_scoped] = ACTIONS(27),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_from] = ACTIONS(27),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4012] = {
    [sym_preproc_region] = STATE(4012),
    [sym_preproc_endregion] = STATE(4012),
    [sym_preproc_line] = STATE(4012),
    [sym_preproc_pragma] = STATE(4012),
    [sym_preproc_nullable] = STATE(4012),
    [sym_preproc_error] = STATE(4012),
    [sym_preproc_define] = STATE(4012),
    [sym_preproc_undef] = STATE(4012),
    [anon_sym_SEMI] = ACTIONS(5412),
    [anon_sym_LBRACK] = ACTIONS(5412),
    [anon_sym_COLON] = ACTIONS(5412),
    [anon_sym_COMMA] = ACTIONS(5412),
    [anon_sym_RBRACK] = ACTIONS(5412),
    [anon_sym_LPAREN] = ACTIONS(5412),
    [anon_sym_RPAREN] = ACTIONS(5412),
    [anon_sym_RBRACE] = ACTIONS(5412),
    [anon_sym_LT] = ACTIONS(5414),
    [anon_sym_GT] = ACTIONS(5414),
    [anon_sym_in] = ACTIONS(5414),
    [anon_sym_QMARK] = ACTIONS(5414),
    [anon_sym_BANG] = ACTIONS(5414),
    [anon_sym_PLUS_PLUS] = ACTIONS(5412),
    [anon_sym_DASH_DASH] = ACTIONS(5412),
    [anon_sym_PLUS] = ACTIONS(5414),
    [anon_sym_DASH] = ACTIONS(5414),
    [anon_sym_STAR] = ACTIONS(5412),
    [anon_sym_SLASH] = ACTIONS(5414),
    [anon_sym_PERCENT] = ACTIONS(5412),
    [anon_sym_CARET] = ACTIONS(5412),
    [anon_sym_PIPE] = ACTIONS(5414),
    [anon_sym_AMP] = ACTIONS(5414),
    [anon_sym_LT_LT] = ACTIONS(5412),
    [anon_sym_GT_GT] = ACTIONS(5414),
    [anon_sym_GT_GT_GT] = ACTIONS(5412),
    [anon_sym_EQ_EQ] = ACTIONS(5412),
    [anon_sym_BANG_EQ] = ACTIONS(5412),
    [anon_sym_GT_EQ] = ACTIONS(5412),
    [anon_sym_LT_EQ] = ACTIONS(5412),
    [anon_sym_DOT] = ACTIONS(5414),
    [anon_sym_EQ_GT] = ACTIONS(5412),
    [anon_sym_switch] = ACTIONS(5412),
    [anon_sym_when] = ACTIONS(5412),
    [anon_sym_DOT_DOT] = ACTIONS(5412),
    [anon_sym_and] = ACTIONS(5412),
    [anon_sym_or] = ACTIONS(5412),
    [anon_sym_AMP_AMP] = ACTIONS(5412),
    [anon_sym_PIPE_PIPE] = ACTIONS(5412),
    [anon_sym_QMARK_QMARK] = ACTIONS(5412),
    [anon_sym_into] = ACTIONS(5412),
    [anon_sym_on] = ACTIONS(5412),
    [anon_sym_equals] = ACTIONS(5412),
    [anon_sym_by] = ACTIONS(5412),
    [anon_sym_as] = ACTIONS(5412),
    [anon_sym_is] = ACTIONS(5412),
    [anon_sym_DASH_GT] = ACTIONS(5412),
    [anon_sym_with] = ACTIONS(5412),
    [aux_sym_preproc_if_token3] = ACTIONS(5412),
    [aux_sym_preproc_else_token1] = ACTIONS(5412),
    [aux_sym_preproc_elif_token1] = ACTIONS(5412),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4013] = {
    [sym_preproc_region] = STATE(4013),
    [sym_preproc_endregion] = STATE(4013),
    [sym_preproc_line] = STATE(4013),
    [sym_preproc_pragma] = STATE(4013),
    [sym_preproc_nullable] = STATE(4013),
    [sym_preproc_error] = STATE(4013),
    [sym_preproc_define] = STATE(4013),
    [sym_preproc_undef] = STATE(4013),
    [anon_sym_SEMI] = ACTIONS(5812),
    [anon_sym_LBRACK] = ACTIONS(5812),
    [anon_sym_COLON] = ACTIONS(5812),
    [anon_sym_COMMA] = ACTIONS(5812),
    [anon_sym_RBRACK] = ACTIONS(5812),
    [anon_sym_LPAREN] = ACTIONS(5812),
    [anon_sym_RPAREN] = ACTIONS(5812),
    [anon_sym_RBRACE] = ACTIONS(5812),
    [anon_sym_LT] = ACTIONS(5814),
    [anon_sym_GT] = ACTIONS(5814),
    [anon_sym_in] = ACTIONS(5814),
    [anon_sym_QMARK] = ACTIONS(5814),
    [anon_sym_BANG] = ACTIONS(5814),
    [anon_sym_PLUS_PLUS] = ACTIONS(5812),
    [anon_sym_DASH_DASH] = ACTIONS(5812),
    [anon_sym_PLUS] = ACTIONS(5814),
    [anon_sym_DASH] = ACTIONS(5814),
    [anon_sym_STAR] = ACTIONS(5812),
    [anon_sym_SLASH] = ACTIONS(5814),
    [anon_sym_PERCENT] = ACTIONS(5812),
    [anon_sym_CARET] = ACTIONS(5812),
    [anon_sym_PIPE] = ACTIONS(5814),
    [anon_sym_AMP] = ACTIONS(5814),
    [anon_sym_LT_LT] = ACTIONS(5812),
    [anon_sym_GT_GT] = ACTIONS(5814),
    [anon_sym_GT_GT_GT] = ACTIONS(5812),
    [anon_sym_EQ_EQ] = ACTIONS(5812),
    [anon_sym_BANG_EQ] = ACTIONS(5812),
    [anon_sym_GT_EQ] = ACTIONS(5812),
    [anon_sym_LT_EQ] = ACTIONS(5812),
    [anon_sym_DOT] = ACTIONS(5814),
    [anon_sym_EQ_GT] = ACTIONS(5812),
    [anon_sym_switch] = ACTIONS(5812),
    [anon_sym_when] = ACTIONS(5812),
    [anon_sym_DOT_DOT] = ACTIONS(5812),
    [anon_sym_and] = ACTIONS(5812),
    [anon_sym_or] = ACTIONS(5812),
    [anon_sym_AMP_AMP] = ACTIONS(5812),
    [anon_sym_PIPE_PIPE] = ACTIONS(5812),
    [anon_sym_QMARK_QMARK] = ACTIONS(5812),
    [anon_sym_into] = ACTIONS(5812),
    [anon_sym_on] = ACTIONS(5812),
    [anon_sym_equals] = ACTIONS(5812),
    [anon_sym_by] = ACTIONS(5812),
    [anon_sym_as] = ACTIONS(5812),
    [anon_sym_is] = ACTIONS(5812),
    [anon_sym_DASH_GT] = ACTIONS(5812),
    [anon_sym_with] = ACTIONS(5812),
    [aux_sym_preproc_if_token3] = ACTIONS(5812),
    [aux_sym_preproc_else_token1] = ACTIONS(5812),
    [aux_sym_preproc_elif_token1] = ACTIONS(5812),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4014] = {
    [sym_preproc_region] = STATE(4014),
    [sym_preproc_endregion] = STATE(4014),
    [sym_preproc_line] = STATE(4014),
    [sym_preproc_pragma] = STATE(4014),
    [sym_preproc_nullable] = STATE(4014),
    [sym_preproc_error] = STATE(4014),
    [sym_preproc_define] = STATE(4014),
    [sym_preproc_undef] = STATE(4014),
    [anon_sym_SEMI] = ACTIONS(5556),
    [anon_sym_LBRACK] = ACTIONS(5556),
    [anon_sym_COLON] = ACTIONS(5556),
    [anon_sym_COMMA] = ACTIONS(5556),
    [anon_sym_RBRACK] = ACTIONS(5556),
    [anon_sym_LPAREN] = ACTIONS(5556),
    [anon_sym_RPAREN] = ACTIONS(5556),
    [anon_sym_RBRACE] = ACTIONS(5556),
    [anon_sym_LT] = ACTIONS(5558),
    [anon_sym_GT] = ACTIONS(5558),
    [anon_sym_in] = ACTIONS(5556),
    [anon_sym_QMARK] = ACTIONS(5558),
    [anon_sym_BANG] = ACTIONS(5558),
    [anon_sym_PLUS_PLUS] = ACTIONS(5556),
    [anon_sym_DASH_DASH] = ACTIONS(5556),
    [anon_sym_PLUS] = ACTIONS(5558),
    [anon_sym_DASH] = ACTIONS(5558),
    [anon_sym_STAR] = ACTIONS(5556),
    [anon_sym_SLASH] = ACTIONS(5558),
    [anon_sym_PERCENT] = ACTIONS(5556),
    [anon_sym_CARET] = ACTIONS(5556),
    [anon_sym_PIPE] = ACTIONS(5558),
    [anon_sym_AMP] = ACTIONS(5558),
    [anon_sym_LT_LT] = ACTIONS(5556),
    [anon_sym_GT_GT] = ACTIONS(5558),
    [anon_sym_GT_GT_GT] = ACTIONS(5556),
    [anon_sym_EQ_EQ] = ACTIONS(5556),
    [anon_sym_BANG_EQ] = ACTIONS(5556),
    [anon_sym_GT_EQ] = ACTIONS(5556),
    [anon_sym_LT_EQ] = ACTIONS(5556),
    [anon_sym_DOT] = ACTIONS(5558),
    [anon_sym_EQ_GT] = ACTIONS(5556),
    [anon_sym_switch] = ACTIONS(5556),
    [anon_sym_when] = ACTIONS(5556),
    [anon_sym_DOT_DOT] = ACTIONS(5556),
    [anon_sym_and] = ACTIONS(5556),
    [anon_sym_or] = ACTIONS(5556),
    [anon_sym_AMP_AMP] = ACTIONS(5556),
    [anon_sym_PIPE_PIPE] = ACTIONS(5556),
    [anon_sym_QMARK_QMARK] = ACTIONS(5556),
    [anon_sym_on] = ACTIONS(5556),
    [anon_sym_equals] = ACTIONS(5556),
    [anon_sym_by] = ACTIONS(5556),
    [anon_sym_as] = ACTIONS(5556),
    [anon_sym_is] = ACTIONS(5556),
    [anon_sym_DQUOTE] = ACTIONS(5556),
    [anon_sym_DASH_GT] = ACTIONS(5556),
    [anon_sym_with] = ACTIONS(5556),
    [aux_sym_preproc_if_token3] = ACTIONS(5556),
    [aux_sym_preproc_else_token1] = ACTIONS(5556),
    [aux_sym_preproc_elif_token1] = ACTIONS(5556),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4015] = {
    [sym_preproc_region] = STATE(4015),
    [sym_preproc_endregion] = STATE(4015),
    [sym_preproc_line] = STATE(4015),
    [sym_preproc_pragma] = STATE(4015),
    [sym_preproc_nullable] = STATE(4015),
    [sym_preproc_error] = STATE(4015),
    [sym_preproc_define] = STATE(4015),
    [sym_preproc_undef] = STATE(4015),
    [anon_sym_SEMI] = ACTIONS(5816),
    [anon_sym_LBRACK] = ACTIONS(5816),
    [anon_sym_COLON] = ACTIONS(5816),
    [anon_sym_COMMA] = ACTIONS(5816),
    [anon_sym_RBRACK] = ACTIONS(5816),
    [anon_sym_LPAREN] = ACTIONS(5816),
    [anon_sym_RPAREN] = ACTIONS(5816),
    [anon_sym_RBRACE] = ACTIONS(5816),
    [anon_sym_LT] = ACTIONS(5818),
    [anon_sym_GT] = ACTIONS(5818),
    [anon_sym_in] = ACTIONS(5818),
    [anon_sym_QMARK] = ACTIONS(5818),
    [anon_sym_BANG] = ACTIONS(5818),
    [anon_sym_PLUS_PLUS] = ACTIONS(5816),
    [anon_sym_DASH_DASH] = ACTIONS(5816),
    [anon_sym_PLUS] = ACTIONS(5818),
    [anon_sym_DASH] = ACTIONS(5818),
    [anon_sym_STAR] = ACTIONS(5816),
    [anon_sym_SLASH] = ACTIONS(5818),
    [anon_sym_PERCENT] = ACTIONS(5816),
    [anon_sym_CARET] = ACTIONS(5816),
    [anon_sym_PIPE] = ACTIONS(5818),
    [anon_sym_AMP] = ACTIONS(5818),
    [anon_sym_LT_LT] = ACTIONS(5816),
    [anon_sym_GT_GT] = ACTIONS(5818),
    [anon_sym_GT_GT_GT] = ACTIONS(5816),
    [anon_sym_EQ_EQ] = ACTIONS(5816),
    [anon_sym_BANG_EQ] = ACTIONS(5816),
    [anon_sym_GT_EQ] = ACTIONS(5816),
    [anon_sym_LT_EQ] = ACTIONS(5816),
    [anon_sym_DOT] = ACTIONS(5818),
    [anon_sym_EQ_GT] = ACTIONS(5816),
    [anon_sym_switch] = ACTIONS(5816),
    [anon_sym_when] = ACTIONS(5816),
    [anon_sym_DOT_DOT] = ACTIONS(5816),
    [anon_sym_and] = ACTIONS(5816),
    [anon_sym_or] = ACTIONS(5816),
    [anon_sym_AMP_AMP] = ACTIONS(5816),
    [anon_sym_PIPE_PIPE] = ACTIONS(5816),
    [anon_sym_QMARK_QMARK] = ACTIONS(5816),
    [anon_sym_into] = ACTIONS(5816),
    [anon_sym_on] = ACTIONS(5816),
    [anon_sym_equals] = ACTIONS(5816),
    [anon_sym_by] = ACTIONS(5816),
    [anon_sym_as] = ACTIONS(5816),
    [anon_sym_is] = ACTIONS(5816),
    [anon_sym_DASH_GT] = ACTIONS(5816),
    [anon_sym_with] = ACTIONS(5816),
    [aux_sym_preproc_if_token3] = ACTIONS(5816),
    [aux_sym_preproc_else_token1] = ACTIONS(5816),
    [aux_sym_preproc_elif_token1] = ACTIONS(5816),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4016] = {
    [sym_preproc_region] = STATE(4016),
    [sym_preproc_endregion] = STATE(4016),
    [sym_preproc_line] = STATE(4016),
    [sym_preproc_pragma] = STATE(4016),
    [sym_preproc_nullable] = STATE(4016),
    [sym_preproc_error] = STATE(4016),
    [sym_preproc_define] = STATE(4016),
    [sym_preproc_undef] = STATE(4016),
    [anon_sym_SEMI] = ACTIONS(5820),
    [anon_sym_LBRACK] = ACTIONS(5820),
    [anon_sym_COLON] = ACTIONS(5820),
    [anon_sym_COMMA] = ACTIONS(5820),
    [anon_sym_RBRACK] = ACTIONS(5820),
    [anon_sym_LPAREN] = ACTIONS(5820),
    [anon_sym_RPAREN] = ACTIONS(5820),
    [anon_sym_RBRACE] = ACTIONS(5820),
    [anon_sym_LT] = ACTIONS(5822),
    [anon_sym_GT] = ACTIONS(5822),
    [anon_sym_in] = ACTIONS(5822),
    [anon_sym_QMARK] = ACTIONS(5822),
    [anon_sym_BANG] = ACTIONS(5822),
    [anon_sym_PLUS_PLUS] = ACTIONS(5820),
    [anon_sym_DASH_DASH] = ACTIONS(5820),
    [anon_sym_PLUS] = ACTIONS(5822),
    [anon_sym_DASH] = ACTIONS(5822),
    [anon_sym_STAR] = ACTIONS(5820),
    [anon_sym_SLASH] = ACTIONS(5822),
    [anon_sym_PERCENT] = ACTIONS(5820),
    [anon_sym_CARET] = ACTIONS(5820),
    [anon_sym_PIPE] = ACTIONS(5822),
    [anon_sym_AMP] = ACTIONS(5822),
    [anon_sym_LT_LT] = ACTIONS(5820),
    [anon_sym_GT_GT] = ACTIONS(5822),
    [anon_sym_GT_GT_GT] = ACTIONS(5820),
    [anon_sym_EQ_EQ] = ACTIONS(5820),
    [anon_sym_BANG_EQ] = ACTIONS(5820),
    [anon_sym_GT_EQ] = ACTIONS(5820),
    [anon_sym_LT_EQ] = ACTIONS(5820),
    [anon_sym_DOT] = ACTIONS(5822),
    [anon_sym_EQ_GT] = ACTIONS(5820),
    [anon_sym_switch] = ACTIONS(5820),
    [anon_sym_when] = ACTIONS(5820),
    [anon_sym_DOT_DOT] = ACTIONS(5820),
    [anon_sym_and] = ACTIONS(5820),
    [anon_sym_or] = ACTIONS(5820),
    [anon_sym_AMP_AMP] = ACTIONS(5820),
    [anon_sym_PIPE_PIPE] = ACTIONS(5820),
    [anon_sym_QMARK_QMARK] = ACTIONS(5820),
    [anon_sym_into] = ACTIONS(5820),
    [anon_sym_on] = ACTIONS(5820),
    [anon_sym_equals] = ACTIONS(5820),
    [anon_sym_by] = ACTIONS(5820),
    [anon_sym_as] = ACTIONS(5820),
    [anon_sym_is] = ACTIONS(5820),
    [anon_sym_DASH_GT] = ACTIONS(5820),
    [anon_sym_with] = ACTIONS(5820),
    [aux_sym_preproc_if_token3] = ACTIONS(5820),
    [aux_sym_preproc_else_token1] = ACTIONS(5820),
    [aux_sym_preproc_elif_token1] = ACTIONS(5820),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4017] = {
    [sym_preproc_region] = STATE(4017),
    [sym_preproc_endregion] = STATE(4017),
    [sym_preproc_line] = STATE(4017),
    [sym_preproc_pragma] = STATE(4017),
    [sym_preproc_nullable] = STATE(4017),
    [sym_preproc_error] = STATE(4017),
    [sym_preproc_define] = STATE(4017),
    [sym_preproc_undef] = STATE(4017),
    [anon_sym_SEMI] = ACTIONS(5824),
    [anon_sym_LBRACK] = ACTIONS(5824),
    [anon_sym_COLON] = ACTIONS(5824),
    [anon_sym_COMMA] = ACTIONS(5824),
    [anon_sym_RBRACK] = ACTIONS(5824),
    [anon_sym_LPAREN] = ACTIONS(5824),
    [anon_sym_RPAREN] = ACTIONS(5824),
    [anon_sym_RBRACE] = ACTIONS(5824),
    [anon_sym_LT] = ACTIONS(5826),
    [anon_sym_GT] = ACTIONS(5826),
    [anon_sym_in] = ACTIONS(5826),
    [anon_sym_QMARK] = ACTIONS(5826),
    [anon_sym_BANG] = ACTIONS(5826),
    [anon_sym_PLUS_PLUS] = ACTIONS(5824),
    [anon_sym_DASH_DASH] = ACTIONS(5824),
    [anon_sym_PLUS] = ACTIONS(5826),
    [anon_sym_DASH] = ACTIONS(5826),
    [anon_sym_STAR] = ACTIONS(5824),
    [anon_sym_SLASH] = ACTIONS(5826),
    [anon_sym_PERCENT] = ACTIONS(5824),
    [anon_sym_CARET] = ACTIONS(5824),
    [anon_sym_PIPE] = ACTIONS(5826),
    [anon_sym_AMP] = ACTIONS(5826),
    [anon_sym_LT_LT] = ACTIONS(5824),
    [anon_sym_GT_GT] = ACTIONS(5826),
    [anon_sym_GT_GT_GT] = ACTIONS(5824),
    [anon_sym_EQ_EQ] = ACTIONS(5824),
    [anon_sym_BANG_EQ] = ACTIONS(5824),
    [anon_sym_GT_EQ] = ACTIONS(5824),
    [anon_sym_LT_EQ] = ACTIONS(5824),
    [anon_sym_DOT] = ACTIONS(5826),
    [anon_sym_EQ_GT] = ACTIONS(5824),
    [anon_sym_switch] = ACTIONS(5824),
    [anon_sym_when] = ACTIONS(5824),
    [anon_sym_DOT_DOT] = ACTIONS(5824),
    [anon_sym_and] = ACTIONS(5824),
    [anon_sym_or] = ACTIONS(5824),
    [anon_sym_AMP_AMP] = ACTIONS(5824),
    [anon_sym_PIPE_PIPE] = ACTIONS(5824),
    [anon_sym_QMARK_QMARK] = ACTIONS(5824),
    [anon_sym_into] = ACTIONS(5824),
    [anon_sym_on] = ACTIONS(5824),
    [anon_sym_equals] = ACTIONS(5824),
    [anon_sym_by] = ACTIONS(5824),
    [anon_sym_as] = ACTIONS(5824),
    [anon_sym_is] = ACTIONS(5824),
    [anon_sym_DASH_GT] = ACTIONS(5824),
    [anon_sym_with] = ACTIONS(5824),
    [aux_sym_preproc_if_token3] = ACTIONS(5824),
    [aux_sym_preproc_else_token1] = ACTIONS(5824),
    [aux_sym_preproc_elif_token1] = ACTIONS(5824),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4018] = {
    [sym_preproc_region] = STATE(4018),
    [sym_preproc_endregion] = STATE(4018),
    [sym_preproc_line] = STATE(4018),
    [sym_preproc_pragma] = STATE(4018),
    [sym_preproc_nullable] = STATE(4018),
    [sym_preproc_error] = STATE(4018),
    [sym_preproc_define] = STATE(4018),
    [sym_preproc_undef] = STATE(4018),
    [anon_sym_SEMI] = ACTIONS(5408),
    [anon_sym_LBRACK] = ACTIONS(5408),
    [anon_sym_COLON] = ACTIONS(5408),
    [anon_sym_COMMA] = ACTIONS(5408),
    [anon_sym_RBRACK] = ACTIONS(5408),
    [anon_sym_LPAREN] = ACTIONS(5408),
    [anon_sym_RPAREN] = ACTIONS(5408),
    [anon_sym_RBRACE] = ACTIONS(5408),
    [anon_sym_LT] = ACTIONS(5410),
    [anon_sym_GT] = ACTIONS(5410),
    [anon_sym_in] = ACTIONS(5410),
    [anon_sym_QMARK] = ACTIONS(5410),
    [anon_sym_BANG] = ACTIONS(5410),
    [anon_sym_PLUS_PLUS] = ACTIONS(5408),
    [anon_sym_DASH_DASH] = ACTIONS(5408),
    [anon_sym_PLUS] = ACTIONS(5410),
    [anon_sym_DASH] = ACTIONS(5410),
    [anon_sym_STAR] = ACTIONS(5408),
    [anon_sym_SLASH] = ACTIONS(5410),
    [anon_sym_PERCENT] = ACTIONS(5408),
    [anon_sym_CARET] = ACTIONS(5408),
    [anon_sym_PIPE] = ACTIONS(5410),
    [anon_sym_AMP] = ACTIONS(5410),
    [anon_sym_LT_LT] = ACTIONS(5408),
    [anon_sym_GT_GT] = ACTIONS(5410),
    [anon_sym_GT_GT_GT] = ACTIONS(5408),
    [anon_sym_EQ_EQ] = ACTIONS(5408),
    [anon_sym_BANG_EQ] = ACTIONS(5408),
    [anon_sym_GT_EQ] = ACTIONS(5408),
    [anon_sym_LT_EQ] = ACTIONS(5408),
    [anon_sym_DOT] = ACTIONS(5410),
    [anon_sym_EQ_GT] = ACTIONS(5408),
    [anon_sym_switch] = ACTIONS(5408),
    [anon_sym_when] = ACTIONS(5408),
    [anon_sym_DOT_DOT] = ACTIONS(5408),
    [anon_sym_and] = ACTIONS(5408),
    [anon_sym_or] = ACTIONS(5408),
    [anon_sym_AMP_AMP] = ACTIONS(5408),
    [anon_sym_PIPE_PIPE] = ACTIONS(5408),
    [anon_sym_QMARK_QMARK] = ACTIONS(5408),
    [anon_sym_into] = ACTIONS(5408),
    [anon_sym_on] = ACTIONS(5408),
    [anon_sym_equals] = ACTIONS(5408),
    [anon_sym_by] = ACTIONS(5408),
    [anon_sym_as] = ACTIONS(5408),
    [anon_sym_is] = ACTIONS(5408),
    [anon_sym_DASH_GT] = ACTIONS(5408),
    [anon_sym_with] = ACTIONS(5408),
    [aux_sym_preproc_if_token3] = ACTIONS(5408),
    [aux_sym_preproc_else_token1] = ACTIONS(5408),
    [aux_sym_preproc_elif_token1] = ACTIONS(5408),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4019] = {
    [sym_preproc_region] = STATE(4019),
    [sym_preproc_endregion] = STATE(4019),
    [sym_preproc_line] = STATE(4019),
    [sym_preproc_pragma] = STATE(4019),
    [sym_preproc_nullable] = STATE(4019),
    [sym_preproc_error] = STATE(4019),
    [sym_preproc_define] = STATE(4019),
    [sym_preproc_undef] = STATE(4019),
    [anon_sym_EQ] = ACTIONS(5828),
    [anon_sym_LBRACK] = ACTIONS(5249),
    [anon_sym_COLON] = ACTIONS(5249),
    [anon_sym_LPAREN] = ACTIONS(5249),
    [anon_sym_LT] = ACTIONS(5251),
    [anon_sym_GT] = ACTIONS(5251),
    [anon_sym_QMARK] = ACTIONS(5251),
    [anon_sym_BANG] = ACTIONS(5251),
    [anon_sym_PLUS_PLUS] = ACTIONS(5249),
    [anon_sym_DASH_DASH] = ACTIONS(5249),
    [anon_sym_PLUS] = ACTIONS(5251),
    [anon_sym_DASH] = ACTIONS(5251),
    [anon_sym_STAR] = ACTIONS(5251),
    [anon_sym_SLASH] = ACTIONS(5251),
    [anon_sym_PERCENT] = ACTIONS(5251),
    [anon_sym_CARET] = ACTIONS(5251),
    [anon_sym_PIPE] = ACTIONS(5251),
    [anon_sym_AMP] = ACTIONS(5251),
    [anon_sym_LT_LT] = ACTIONS(5251),
    [anon_sym_GT_GT] = ACTIONS(5251),
    [anon_sym_GT_GT_GT] = ACTIONS(5251),
    [anon_sym_EQ_EQ] = ACTIONS(5249),
    [anon_sym_BANG_EQ] = ACTIONS(5249),
    [anon_sym_GT_EQ] = ACTIONS(5249),
    [anon_sym_LT_EQ] = ACTIONS(5249),
    [anon_sym_DOT] = ACTIONS(5251),
    [anon_sym_switch] = ACTIONS(5249),
    [anon_sym_when] = ACTIONS(5249),
    [anon_sym_DOT_DOT] = ACTIONS(5249),
    [anon_sym_and] = ACTIONS(5249),
    [anon_sym_or] = ACTIONS(5249),
    [anon_sym_PLUS_EQ] = ACTIONS(5830),
    [anon_sym_DASH_EQ] = ACTIONS(5830),
    [anon_sym_STAR_EQ] = ACTIONS(5830),
    [anon_sym_SLASH_EQ] = ACTIONS(5830),
    [anon_sym_PERCENT_EQ] = ACTIONS(5830),
    [anon_sym_AMP_EQ] = ACTIONS(5830),
    [anon_sym_CARET_EQ] = ACTIONS(5830),
    [anon_sym_PIPE_EQ] = ACTIONS(5830),
    [anon_sym_LT_LT_EQ] = ACTIONS(5830),
    [anon_sym_GT_GT_EQ] = ACTIONS(5830),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5830),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(5830),
    [anon_sym_AMP_AMP] = ACTIONS(5249),
    [anon_sym_PIPE_PIPE] = ACTIONS(5249),
    [anon_sym_QMARK_QMARK] = ACTIONS(5251),
    [anon_sym_into] = ACTIONS(5249),
    [anon_sym_as] = ACTIONS(5249),
    [anon_sym_is] = ACTIONS(5249),
    [anon_sym_DASH_GT] = ACTIONS(5249),
    [anon_sym_with] = ACTIONS(5249),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4020] = {
    [sym_preproc_region] = STATE(4020),
    [sym_preproc_endregion] = STATE(4020),
    [sym_preproc_line] = STATE(4020),
    [sym_preproc_pragma] = STATE(4020),
    [sym_preproc_nullable] = STATE(4020),
    [sym_preproc_error] = STATE(4020),
    [sym_preproc_define] = STATE(4020),
    [sym_preproc_undef] = STATE(4020),
    [anon_sym_SEMI] = ACTIONS(4247),
    [anon_sym_LBRACK] = ACTIONS(4247),
    [anon_sym_COLON] = ACTIONS(4247),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_RBRACK] = ACTIONS(4247),
    [anon_sym_LPAREN] = ACTIONS(4247),
    [anon_sym_RPAREN] = ACTIONS(4247),
    [anon_sym_RBRACE] = ACTIONS(4247),
    [anon_sym_LT] = ACTIONS(5832),
    [anon_sym_GT] = ACTIONS(5832),
    [anon_sym_in] = ACTIONS(5832),
    [anon_sym_QMARK] = ACTIONS(5832),
    [anon_sym_BANG] = ACTIONS(5832),
    [anon_sym_PLUS_PLUS] = ACTIONS(4247),
    [anon_sym_DASH_DASH] = ACTIONS(4247),
    [anon_sym_PLUS] = ACTIONS(5832),
    [anon_sym_DASH] = ACTIONS(5832),
    [anon_sym_STAR] = ACTIONS(4247),
    [anon_sym_SLASH] = ACTIONS(5832),
    [anon_sym_PERCENT] = ACTIONS(4247),
    [anon_sym_CARET] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(5832),
    [anon_sym_AMP] = ACTIONS(5832),
    [anon_sym_LT_LT] = ACTIONS(4247),
    [anon_sym_GT_GT] = ACTIONS(5832),
    [anon_sym_GT_GT_GT] = ACTIONS(4247),
    [anon_sym_EQ_EQ] = ACTIONS(4247),
    [anon_sym_BANG_EQ] = ACTIONS(4247),
    [anon_sym_GT_EQ] = ACTIONS(4247),
    [anon_sym_LT_EQ] = ACTIONS(4247),
    [anon_sym_DOT] = ACTIONS(5832),
    [anon_sym_EQ_GT] = ACTIONS(4247),
    [anon_sym_switch] = ACTIONS(4247),
    [anon_sym_when] = ACTIONS(4247),
    [anon_sym_DOT_DOT] = ACTIONS(4247),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_AMP_AMP] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(4247),
    [anon_sym_QMARK_QMARK] = ACTIONS(4247),
    [anon_sym_into] = ACTIONS(4247),
    [anon_sym_on] = ACTIONS(4247),
    [anon_sym_equals] = ACTIONS(4247),
    [anon_sym_by] = ACTIONS(4247),
    [anon_sym_as] = ACTIONS(4247),
    [anon_sym_is] = ACTIONS(4247),
    [anon_sym_DASH_GT] = ACTIONS(4247),
    [anon_sym_with] = ACTIONS(4247),
    [aux_sym_preproc_if_token3] = ACTIONS(4247),
    [aux_sym_preproc_else_token1] = ACTIONS(4247),
    [aux_sym_preproc_elif_token1] = ACTIONS(4247),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4021] = {
    [sym_preproc_region] = STATE(4021),
    [sym_preproc_endregion] = STATE(4021),
    [sym_preproc_line] = STATE(4021),
    [sym_preproc_pragma] = STATE(4021),
    [sym_preproc_nullable] = STATE(4021),
    [sym_preproc_error] = STATE(4021),
    [sym_preproc_define] = STATE(4021),
    [sym_preproc_undef] = STATE(4021),
    [anon_sym_SEMI] = ACTIONS(5834),
    [anon_sym_LBRACK] = ACTIONS(5834),
    [anon_sym_COLON] = ACTIONS(5834),
    [anon_sym_COMMA] = ACTIONS(5834),
    [anon_sym_RBRACK] = ACTIONS(5834),
    [anon_sym_LPAREN] = ACTIONS(5834),
    [anon_sym_RPAREN] = ACTIONS(5834),
    [anon_sym_RBRACE] = ACTIONS(5834),
    [anon_sym_LT] = ACTIONS(5836),
    [anon_sym_GT] = ACTIONS(5836),
    [anon_sym_in] = ACTIONS(5836),
    [anon_sym_QMARK] = ACTIONS(5836),
    [anon_sym_BANG] = ACTIONS(5836),
    [anon_sym_PLUS_PLUS] = ACTIONS(5834),
    [anon_sym_DASH_DASH] = ACTIONS(5834),
    [anon_sym_PLUS] = ACTIONS(5836),
    [anon_sym_DASH] = ACTIONS(5836),
    [anon_sym_STAR] = ACTIONS(5834),
    [anon_sym_SLASH] = ACTIONS(5836),
    [anon_sym_PERCENT] = ACTIONS(5834),
    [anon_sym_CARET] = ACTIONS(5834),
    [anon_sym_PIPE] = ACTIONS(5836),
    [anon_sym_AMP] = ACTIONS(5836),
    [anon_sym_LT_LT] = ACTIONS(5834),
    [anon_sym_GT_GT] = ACTIONS(5836),
    [anon_sym_GT_GT_GT] = ACTIONS(5834),
    [anon_sym_EQ_EQ] = ACTIONS(5834),
    [anon_sym_BANG_EQ] = ACTIONS(5834),
    [anon_sym_GT_EQ] = ACTIONS(5834),
    [anon_sym_LT_EQ] = ACTIONS(5834),
    [anon_sym_DOT] = ACTIONS(5836),
    [anon_sym_EQ_GT] = ACTIONS(5834),
    [anon_sym_switch] = ACTIONS(5834),
    [anon_sym_when] = ACTIONS(5834),
    [anon_sym_DOT_DOT] = ACTIONS(5834),
    [anon_sym_and] = ACTIONS(5834),
    [anon_sym_or] = ACTIONS(5834),
    [anon_sym_AMP_AMP] = ACTIONS(5834),
    [anon_sym_PIPE_PIPE] = ACTIONS(5834),
    [anon_sym_QMARK_QMARK] = ACTIONS(5834),
    [anon_sym_into] = ACTIONS(5834),
    [anon_sym_on] = ACTIONS(5834),
    [anon_sym_equals] = ACTIONS(5834),
    [anon_sym_by] = ACTIONS(5834),
    [anon_sym_as] = ACTIONS(5834),
    [anon_sym_is] = ACTIONS(5834),
    [anon_sym_DASH_GT] = ACTIONS(5834),
    [anon_sym_with] = ACTIONS(5834),
    [aux_sym_preproc_if_token3] = ACTIONS(5834),
    [aux_sym_preproc_else_token1] = ACTIONS(5834),
    [aux_sym_preproc_elif_token1] = ACTIONS(5834),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4022] = {
    [sym_preproc_region] = STATE(4022),
    [sym_preproc_endregion] = STATE(4022),
    [sym_preproc_line] = STATE(4022),
    [sym_preproc_pragma] = STATE(4022),
    [sym_preproc_nullable] = STATE(4022),
    [sym_preproc_error] = STATE(4022),
    [sym_preproc_define] = STATE(4022),
    [sym_preproc_undef] = STATE(4022),
    [anon_sym_SEMI] = ACTIONS(5404),
    [anon_sym_LBRACK] = ACTIONS(5404),
    [anon_sym_COLON] = ACTIONS(5404),
    [anon_sym_COMMA] = ACTIONS(5404),
    [anon_sym_RBRACK] = ACTIONS(5404),
    [anon_sym_LPAREN] = ACTIONS(5404),
    [anon_sym_RPAREN] = ACTIONS(5404),
    [anon_sym_RBRACE] = ACTIONS(5404),
    [anon_sym_LT] = ACTIONS(5406),
    [anon_sym_GT] = ACTIONS(5406),
    [anon_sym_in] = ACTIONS(5406),
    [anon_sym_QMARK] = ACTIONS(5406),
    [anon_sym_BANG] = ACTIONS(5406),
    [anon_sym_PLUS_PLUS] = ACTIONS(5404),
    [anon_sym_DASH_DASH] = ACTIONS(5404),
    [anon_sym_PLUS] = ACTIONS(5406),
    [anon_sym_DASH] = ACTIONS(5406),
    [anon_sym_STAR] = ACTIONS(5404),
    [anon_sym_SLASH] = ACTIONS(5406),
    [anon_sym_PERCENT] = ACTIONS(5404),
    [anon_sym_CARET] = ACTIONS(5404),
    [anon_sym_PIPE] = ACTIONS(5406),
    [anon_sym_AMP] = ACTIONS(5406),
    [anon_sym_LT_LT] = ACTIONS(5404),
    [anon_sym_GT_GT] = ACTIONS(5406),
    [anon_sym_GT_GT_GT] = ACTIONS(5404),
    [anon_sym_EQ_EQ] = ACTIONS(5404),
    [anon_sym_BANG_EQ] = ACTIONS(5404),
    [anon_sym_GT_EQ] = ACTIONS(5404),
    [anon_sym_LT_EQ] = ACTIONS(5404),
    [anon_sym_DOT] = ACTIONS(5406),
    [anon_sym_EQ_GT] = ACTIONS(5404),
    [anon_sym_switch] = ACTIONS(5404),
    [anon_sym_when] = ACTIONS(5404),
    [anon_sym_DOT_DOT] = ACTIONS(5404),
    [anon_sym_and] = ACTIONS(5404),
    [anon_sym_or] = ACTIONS(5404),
    [anon_sym_AMP_AMP] = ACTIONS(5404),
    [anon_sym_PIPE_PIPE] = ACTIONS(5404),
    [anon_sym_QMARK_QMARK] = ACTIONS(5404),
    [anon_sym_into] = ACTIONS(5404),
    [anon_sym_on] = ACTIONS(5404),
    [anon_sym_equals] = ACTIONS(5404),
    [anon_sym_by] = ACTIONS(5404),
    [anon_sym_as] = ACTIONS(5404),
    [anon_sym_is] = ACTIONS(5404),
    [anon_sym_DASH_GT] = ACTIONS(5404),
    [anon_sym_with] = ACTIONS(5404),
    [aux_sym_preproc_if_token3] = ACTIONS(5404),
    [aux_sym_preproc_else_token1] = ACTIONS(5404),
    [aux_sym_preproc_elif_token1] = ACTIONS(5404),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4023] = {
    [sym_preproc_region] = STATE(4023),
    [sym_preproc_endregion] = STATE(4023),
    [sym_preproc_line] = STATE(4023),
    [sym_preproc_pragma] = STATE(4023),
    [sym_preproc_nullable] = STATE(4023),
    [sym_preproc_error] = STATE(4023),
    [sym_preproc_define] = STATE(4023),
    [sym_preproc_undef] = STATE(4023),
    [anon_sym_SEMI] = ACTIONS(5838),
    [anon_sym_LBRACK] = ACTIONS(5838),
    [anon_sym_COLON] = ACTIONS(5838),
    [anon_sym_COMMA] = ACTIONS(5838),
    [anon_sym_RBRACK] = ACTIONS(5838),
    [anon_sym_LPAREN] = ACTIONS(5838),
    [anon_sym_RPAREN] = ACTIONS(5838),
    [anon_sym_RBRACE] = ACTIONS(5838),
    [anon_sym_LT] = ACTIONS(5840),
    [anon_sym_GT] = ACTIONS(5840),
    [anon_sym_in] = ACTIONS(5840),
    [anon_sym_QMARK] = ACTIONS(5840),
    [anon_sym_BANG] = ACTIONS(5840),
    [anon_sym_PLUS_PLUS] = ACTIONS(5838),
    [anon_sym_DASH_DASH] = ACTIONS(5838),
    [anon_sym_PLUS] = ACTIONS(5840),
    [anon_sym_DASH] = ACTIONS(5840),
    [anon_sym_STAR] = ACTIONS(5838),
    [anon_sym_SLASH] = ACTIONS(5840),
    [anon_sym_PERCENT] = ACTIONS(5838),
    [anon_sym_CARET] = ACTIONS(5838),
    [anon_sym_PIPE] = ACTIONS(5840),
    [anon_sym_AMP] = ACTIONS(5840),
    [anon_sym_LT_LT] = ACTIONS(5838),
    [anon_sym_GT_GT] = ACTIONS(5840),
    [anon_sym_GT_GT_GT] = ACTIONS(5838),
    [anon_sym_EQ_EQ] = ACTIONS(5838),
    [anon_sym_BANG_EQ] = ACTIONS(5838),
    [anon_sym_GT_EQ] = ACTIONS(5838),
    [anon_sym_LT_EQ] = ACTIONS(5838),
    [anon_sym_DOT] = ACTIONS(5840),
    [anon_sym_EQ_GT] = ACTIONS(5838),
    [anon_sym_switch] = ACTIONS(5838),
    [anon_sym_when] = ACTIONS(5838),
    [anon_sym_DOT_DOT] = ACTIONS(5838),
    [anon_sym_and] = ACTIONS(5838),
    [anon_sym_or] = ACTIONS(5838),
    [anon_sym_AMP_AMP] = ACTIONS(5838),
    [anon_sym_PIPE_PIPE] = ACTIONS(5838),
    [anon_sym_QMARK_QMARK] = ACTIONS(5838),
    [anon_sym_into] = ACTIONS(5838),
    [anon_sym_on] = ACTIONS(5838),
    [anon_sym_equals] = ACTIONS(5838),
    [anon_sym_by] = ACTIONS(5838),
    [anon_sym_as] = ACTIONS(5838),
    [anon_sym_is] = ACTIONS(5838),
    [anon_sym_DASH_GT] = ACTIONS(5838),
    [anon_sym_with] = ACTIONS(5838),
    [aux_sym_preproc_if_token3] = ACTIONS(5838),
    [aux_sym_preproc_else_token1] = ACTIONS(5838),
    [aux_sym_preproc_elif_token1] = ACTIONS(5838),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4024] = {
    [sym_preproc_region] = STATE(4024),
    [sym_preproc_endregion] = STATE(4024),
    [sym_preproc_line] = STATE(4024),
    [sym_preproc_pragma] = STATE(4024),
    [sym_preproc_nullable] = STATE(4024),
    [sym_preproc_error] = STATE(4024),
    [sym_preproc_define] = STATE(4024),
    [sym_preproc_undef] = STATE(4024),
    [anon_sym_SEMI] = ACTIONS(5494),
    [anon_sym_LBRACK] = ACTIONS(5494),
    [anon_sym_COLON] = ACTIONS(5494),
    [anon_sym_COMMA] = ACTIONS(5494),
    [anon_sym_RBRACK] = ACTIONS(5494),
    [anon_sym_LPAREN] = ACTIONS(5494),
    [anon_sym_RPAREN] = ACTIONS(5494),
    [anon_sym_RBRACE] = ACTIONS(5494),
    [anon_sym_LT] = ACTIONS(5496),
    [anon_sym_GT] = ACTIONS(5496),
    [anon_sym_in] = ACTIONS(5496),
    [anon_sym_QMARK] = ACTIONS(5496),
    [anon_sym_BANG] = ACTIONS(5496),
    [anon_sym_PLUS_PLUS] = ACTIONS(5494),
    [anon_sym_DASH_DASH] = ACTIONS(5494),
    [anon_sym_PLUS] = ACTIONS(5496),
    [anon_sym_DASH] = ACTIONS(5496),
    [anon_sym_STAR] = ACTIONS(5494),
    [anon_sym_SLASH] = ACTIONS(5496),
    [anon_sym_PERCENT] = ACTIONS(5494),
    [anon_sym_CARET] = ACTIONS(5494),
    [anon_sym_PIPE] = ACTIONS(5496),
    [anon_sym_AMP] = ACTIONS(5496),
    [anon_sym_LT_LT] = ACTIONS(5494),
    [anon_sym_GT_GT] = ACTIONS(5496),
    [anon_sym_GT_GT_GT] = ACTIONS(5494),
    [anon_sym_EQ_EQ] = ACTIONS(5494),
    [anon_sym_BANG_EQ] = ACTIONS(5494),
    [anon_sym_GT_EQ] = ACTIONS(5494),
    [anon_sym_LT_EQ] = ACTIONS(5494),
    [anon_sym_DOT] = ACTIONS(5496),
    [anon_sym_EQ_GT] = ACTIONS(5494),
    [anon_sym_switch] = ACTIONS(5494),
    [anon_sym_when] = ACTIONS(5494),
    [anon_sym_DOT_DOT] = ACTIONS(5494),
    [anon_sym_and] = ACTIONS(5494),
    [anon_sym_or] = ACTIONS(5494),
    [anon_sym_AMP_AMP] = ACTIONS(5494),
    [anon_sym_PIPE_PIPE] = ACTIONS(5494),
    [anon_sym_QMARK_QMARK] = ACTIONS(5494),
    [anon_sym_into] = ACTIONS(5494),
    [anon_sym_on] = ACTIONS(5494),
    [anon_sym_equals] = ACTIONS(5494),
    [anon_sym_by] = ACTIONS(5494),
    [anon_sym_as] = ACTIONS(5494),
    [anon_sym_is] = ACTIONS(5494),
    [anon_sym_DASH_GT] = ACTIONS(5494),
    [anon_sym_with] = ACTIONS(5494),
    [aux_sym_preproc_if_token3] = ACTIONS(5494),
    [aux_sym_preproc_else_token1] = ACTIONS(5494),
    [aux_sym_preproc_elif_token1] = ACTIONS(5494),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4025] = {
    [sym_preproc_region] = STATE(4025),
    [sym_preproc_endregion] = STATE(4025),
    [sym_preproc_line] = STATE(4025),
    [sym_preproc_pragma] = STATE(4025),
    [sym_preproc_nullable] = STATE(4025),
    [sym_preproc_error] = STATE(4025),
    [sym_preproc_define] = STATE(4025),
    [sym_preproc_undef] = STATE(4025),
    [anon_sym_SEMI] = ACTIONS(5838),
    [anon_sym_LBRACK] = ACTIONS(5838),
    [anon_sym_COLON] = ACTIONS(5838),
    [anon_sym_COMMA] = ACTIONS(5838),
    [anon_sym_RBRACK] = ACTIONS(5838),
    [anon_sym_LPAREN] = ACTIONS(5838),
    [anon_sym_RPAREN] = ACTIONS(5838),
    [anon_sym_RBRACE] = ACTIONS(5838),
    [anon_sym_LT] = ACTIONS(5840),
    [anon_sym_GT] = ACTIONS(5840),
    [anon_sym_in] = ACTIONS(5840),
    [anon_sym_QMARK] = ACTIONS(5840),
    [anon_sym_BANG] = ACTIONS(5840),
    [anon_sym_PLUS_PLUS] = ACTIONS(5838),
    [anon_sym_DASH_DASH] = ACTIONS(5838),
    [anon_sym_PLUS] = ACTIONS(5840),
    [anon_sym_DASH] = ACTIONS(5840),
    [anon_sym_STAR] = ACTIONS(5838),
    [anon_sym_SLASH] = ACTIONS(5840),
    [anon_sym_PERCENT] = ACTIONS(5838),
    [anon_sym_CARET] = ACTIONS(5838),
    [anon_sym_PIPE] = ACTIONS(5840),
    [anon_sym_AMP] = ACTIONS(5840),
    [anon_sym_LT_LT] = ACTIONS(5838),
    [anon_sym_GT_GT] = ACTIONS(5840),
    [anon_sym_GT_GT_GT] = ACTIONS(5838),
    [anon_sym_EQ_EQ] = ACTIONS(5838),
    [anon_sym_BANG_EQ] = ACTIONS(5838),
    [anon_sym_GT_EQ] = ACTIONS(5838),
    [anon_sym_LT_EQ] = ACTIONS(5838),
    [anon_sym_DOT] = ACTIONS(5840),
    [anon_sym_EQ_GT] = ACTIONS(5838),
    [anon_sym_switch] = ACTIONS(5838),
    [anon_sym_when] = ACTIONS(5838),
    [anon_sym_DOT_DOT] = ACTIONS(5838),
    [anon_sym_and] = ACTIONS(5838),
    [anon_sym_or] = ACTIONS(5838),
    [anon_sym_AMP_AMP] = ACTIONS(5838),
    [anon_sym_PIPE_PIPE] = ACTIONS(5838),
    [anon_sym_QMARK_QMARK] = ACTIONS(5838),
    [anon_sym_into] = ACTIONS(5838),
    [anon_sym_on] = ACTIONS(5838),
    [anon_sym_equals] = ACTIONS(5838),
    [anon_sym_by] = ACTIONS(5838),
    [anon_sym_as] = ACTIONS(5838),
    [anon_sym_is] = ACTIONS(5838),
    [anon_sym_DASH_GT] = ACTIONS(5838),
    [anon_sym_with] = ACTIONS(5838),
    [aux_sym_preproc_if_token3] = ACTIONS(5838),
    [aux_sym_preproc_else_token1] = ACTIONS(5838),
    [aux_sym_preproc_elif_token1] = ACTIONS(5838),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4026] = {
    [sym_preproc_region] = STATE(4026),
    [sym_preproc_endregion] = STATE(4026),
    [sym_preproc_line] = STATE(4026),
    [sym_preproc_pragma] = STATE(4026),
    [sym_preproc_nullable] = STATE(4026),
    [sym_preproc_error] = STATE(4026),
    [sym_preproc_define] = STATE(4026),
    [sym_preproc_undef] = STATE(4026),
    [anon_sym_SEMI] = ACTIONS(4420),
    [anon_sym_LBRACK] = ACTIONS(4420),
    [anon_sym_COLON] = ACTIONS(4420),
    [anon_sym_COMMA] = ACTIONS(4420),
    [anon_sym_RBRACK] = ACTIONS(4420),
    [anon_sym_LPAREN] = ACTIONS(4420),
    [anon_sym_RPAREN] = ACTIONS(4420),
    [anon_sym_LBRACE] = ACTIONS(4420),
    [anon_sym_RBRACE] = ACTIONS(4420),
    [anon_sym_LT] = ACTIONS(4418),
    [anon_sym_GT] = ACTIONS(4418),
    [anon_sym_in] = ACTIONS(4420),
    [anon_sym_QMARK] = ACTIONS(4418),
    [anon_sym_BANG] = ACTIONS(4418),
    [anon_sym_PLUS_PLUS] = ACTIONS(4420),
    [anon_sym_DASH_DASH] = ACTIONS(4420),
    [anon_sym_PLUS] = ACTIONS(4418),
    [anon_sym_DASH] = ACTIONS(4418),
    [anon_sym_STAR] = ACTIONS(4420),
    [anon_sym_SLASH] = ACTIONS(4418),
    [anon_sym_PERCENT] = ACTIONS(4420),
    [anon_sym_CARET] = ACTIONS(4420),
    [anon_sym_PIPE] = ACTIONS(4418),
    [anon_sym_AMP] = ACTIONS(4418),
    [anon_sym_LT_LT] = ACTIONS(4420),
    [anon_sym_GT_GT] = ACTIONS(4418),
    [anon_sym_GT_GT_GT] = ACTIONS(4420),
    [anon_sym_EQ_EQ] = ACTIONS(4420),
    [anon_sym_BANG_EQ] = ACTIONS(4420),
    [anon_sym_GT_EQ] = ACTIONS(4420),
    [anon_sym_LT_EQ] = ACTIONS(4420),
    [anon_sym_DOT] = ACTIONS(4418),
    [anon_sym_EQ_GT] = ACTIONS(4420),
    [anon_sym_switch] = ACTIONS(4420),
    [anon_sym_when] = ACTIONS(4420),
    [anon_sym_DOT_DOT] = ACTIONS(4420),
    [anon_sym_and] = ACTIONS(4420),
    [anon_sym_or] = ACTIONS(4420),
    [anon_sym_AMP_AMP] = ACTIONS(4420),
    [anon_sym_PIPE_PIPE] = ACTIONS(4420),
    [anon_sym_QMARK_QMARK] = ACTIONS(4420),
    [anon_sym_on] = ACTIONS(4420),
    [anon_sym_equals] = ACTIONS(4420),
    [anon_sym_by] = ACTIONS(4420),
    [anon_sym_as] = ACTIONS(4420),
    [anon_sym_is] = ACTIONS(4420),
    [anon_sym_DASH_GT] = ACTIONS(4420),
    [anon_sym_with] = ACTIONS(4420),
    [aux_sym_preproc_if_token3] = ACTIONS(4420),
    [aux_sym_preproc_else_token1] = ACTIONS(4420),
    [aux_sym_preproc_elif_token1] = ACTIONS(4420),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4027] = {
    [sym_preproc_region] = STATE(4027),
    [sym_preproc_endregion] = STATE(4027),
    [sym_preproc_line] = STATE(4027),
    [sym_preproc_pragma] = STATE(4027),
    [sym_preproc_nullable] = STATE(4027),
    [sym_preproc_error] = STATE(4027),
    [sym_preproc_define] = STATE(4027),
    [sym_preproc_undef] = STATE(4027),
    [anon_sym_SEMI] = ACTIONS(5514),
    [anon_sym_LBRACK] = ACTIONS(5514),
    [anon_sym_COLON] = ACTIONS(5514),
    [anon_sym_COMMA] = ACTIONS(5514),
    [anon_sym_RBRACK] = ACTIONS(5514),
    [anon_sym_LPAREN] = ACTIONS(5514),
    [anon_sym_RPAREN] = ACTIONS(5514),
    [anon_sym_RBRACE] = ACTIONS(5514),
    [anon_sym_LT] = ACTIONS(5516),
    [anon_sym_GT] = ACTIONS(5516),
    [anon_sym_in] = ACTIONS(5516),
    [anon_sym_QMARK] = ACTIONS(5516),
    [anon_sym_BANG] = ACTIONS(5516),
    [anon_sym_PLUS_PLUS] = ACTIONS(5514),
    [anon_sym_DASH_DASH] = ACTIONS(5514),
    [anon_sym_PLUS] = ACTIONS(5516),
    [anon_sym_DASH] = ACTIONS(5516),
    [anon_sym_STAR] = ACTIONS(5514),
    [anon_sym_SLASH] = ACTIONS(5516),
    [anon_sym_PERCENT] = ACTIONS(5514),
    [anon_sym_CARET] = ACTIONS(5514),
    [anon_sym_PIPE] = ACTIONS(5516),
    [anon_sym_AMP] = ACTIONS(5516),
    [anon_sym_LT_LT] = ACTIONS(5514),
    [anon_sym_GT_GT] = ACTIONS(5516),
    [anon_sym_GT_GT_GT] = ACTIONS(5514),
    [anon_sym_EQ_EQ] = ACTIONS(5514),
    [anon_sym_BANG_EQ] = ACTIONS(5514),
    [anon_sym_GT_EQ] = ACTIONS(5514),
    [anon_sym_LT_EQ] = ACTIONS(5514),
    [anon_sym_DOT] = ACTIONS(5516),
    [anon_sym_EQ_GT] = ACTIONS(5514),
    [anon_sym_switch] = ACTIONS(5514),
    [anon_sym_when] = ACTIONS(5514),
    [anon_sym_DOT_DOT] = ACTIONS(5514),
    [anon_sym_and] = ACTIONS(5514),
    [anon_sym_or] = ACTIONS(5514),
    [anon_sym_AMP_AMP] = ACTIONS(5514),
    [anon_sym_PIPE_PIPE] = ACTIONS(5514),
    [anon_sym_QMARK_QMARK] = ACTIONS(5514),
    [anon_sym_into] = ACTIONS(5514),
    [anon_sym_on] = ACTIONS(5514),
    [anon_sym_equals] = ACTIONS(5514),
    [anon_sym_by] = ACTIONS(5514),
    [anon_sym_as] = ACTIONS(5514),
    [anon_sym_is] = ACTIONS(5514),
    [anon_sym_DASH_GT] = ACTIONS(5514),
    [anon_sym_with] = ACTIONS(5514),
    [aux_sym_preproc_if_token3] = ACTIONS(5514),
    [aux_sym_preproc_else_token1] = ACTIONS(5514),
    [aux_sym_preproc_elif_token1] = ACTIONS(5514),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4028] = {
    [sym_preproc_region] = STATE(4028),
    [sym_preproc_endregion] = STATE(4028),
    [sym_preproc_line] = STATE(4028),
    [sym_preproc_pragma] = STATE(4028),
    [sym_preproc_nullable] = STATE(4028),
    [sym_preproc_error] = STATE(4028),
    [sym_preproc_define] = STATE(4028),
    [sym_preproc_undef] = STATE(4028),
    [anon_sym_SEMI] = ACTIONS(4480),
    [anon_sym_LBRACK] = ACTIONS(4480),
    [anon_sym_COLON] = ACTIONS(4480),
    [anon_sym_COMMA] = ACTIONS(4480),
    [anon_sym_RBRACK] = ACTIONS(4480),
    [anon_sym_LPAREN] = ACTIONS(4480),
    [anon_sym_RPAREN] = ACTIONS(4480),
    [anon_sym_LBRACE] = ACTIONS(4480),
    [anon_sym_RBRACE] = ACTIONS(4480),
    [anon_sym_LT] = ACTIONS(4478),
    [anon_sym_GT] = ACTIONS(4478),
    [anon_sym_in] = ACTIONS(4480),
    [anon_sym_QMARK] = ACTIONS(4478),
    [anon_sym_BANG] = ACTIONS(4478),
    [anon_sym_PLUS_PLUS] = ACTIONS(4480),
    [anon_sym_DASH_DASH] = ACTIONS(4480),
    [anon_sym_PLUS] = ACTIONS(4478),
    [anon_sym_DASH] = ACTIONS(4478),
    [anon_sym_STAR] = ACTIONS(4480),
    [anon_sym_SLASH] = ACTIONS(4478),
    [anon_sym_PERCENT] = ACTIONS(4480),
    [anon_sym_CARET] = ACTIONS(4480),
    [anon_sym_PIPE] = ACTIONS(4478),
    [anon_sym_AMP] = ACTIONS(4478),
    [anon_sym_LT_LT] = ACTIONS(4480),
    [anon_sym_GT_GT] = ACTIONS(4478),
    [anon_sym_GT_GT_GT] = ACTIONS(4480),
    [anon_sym_EQ_EQ] = ACTIONS(4480),
    [anon_sym_BANG_EQ] = ACTIONS(4480),
    [anon_sym_GT_EQ] = ACTIONS(4480),
    [anon_sym_LT_EQ] = ACTIONS(4480),
    [anon_sym_DOT] = ACTIONS(4478),
    [anon_sym_EQ_GT] = ACTIONS(4480),
    [anon_sym_switch] = ACTIONS(4480),
    [anon_sym_when] = ACTIONS(4480),
    [anon_sym_DOT_DOT] = ACTIONS(4480),
    [anon_sym_and] = ACTIONS(4480),
    [anon_sym_or] = ACTIONS(4480),
    [anon_sym_AMP_AMP] = ACTIONS(4480),
    [anon_sym_PIPE_PIPE] = ACTIONS(4480),
    [anon_sym_QMARK_QMARK] = ACTIONS(4480),
    [anon_sym_on] = ACTIONS(4480),
    [anon_sym_equals] = ACTIONS(4480),
    [anon_sym_by] = ACTIONS(4480),
    [anon_sym_as] = ACTIONS(4480),
    [anon_sym_is] = ACTIONS(4480),
    [anon_sym_DASH_GT] = ACTIONS(4480),
    [anon_sym_with] = ACTIONS(4480),
    [aux_sym_preproc_if_token3] = ACTIONS(4480),
    [aux_sym_preproc_else_token1] = ACTIONS(4480),
    [aux_sym_preproc_elif_token1] = ACTIONS(4480),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4029] = {
    [sym_preproc_region] = STATE(4029),
    [sym_preproc_endregion] = STATE(4029),
    [sym_preproc_line] = STATE(4029),
    [sym_preproc_pragma] = STATE(4029),
    [sym_preproc_nullable] = STATE(4029),
    [sym_preproc_error] = STATE(4029),
    [sym_preproc_define] = STATE(4029),
    [sym_preproc_undef] = STATE(4029),
    [anon_sym_SEMI] = ACTIONS(5576),
    [anon_sym_LBRACK] = ACTIONS(5576),
    [anon_sym_COLON] = ACTIONS(5576),
    [anon_sym_COMMA] = ACTIONS(5576),
    [anon_sym_RBRACK] = ACTIONS(5576),
    [anon_sym_LPAREN] = ACTIONS(5576),
    [anon_sym_RPAREN] = ACTIONS(5576),
    [anon_sym_RBRACE] = ACTIONS(5576),
    [anon_sym_LT] = ACTIONS(5578),
    [anon_sym_GT] = ACTIONS(5578),
    [anon_sym_in] = ACTIONS(5578),
    [anon_sym_QMARK] = ACTIONS(5578),
    [anon_sym_BANG] = ACTIONS(5578),
    [anon_sym_PLUS_PLUS] = ACTIONS(5576),
    [anon_sym_DASH_DASH] = ACTIONS(5576),
    [anon_sym_PLUS] = ACTIONS(5578),
    [anon_sym_DASH] = ACTIONS(5578),
    [anon_sym_STAR] = ACTIONS(5576),
    [anon_sym_SLASH] = ACTIONS(5578),
    [anon_sym_PERCENT] = ACTIONS(5576),
    [anon_sym_CARET] = ACTIONS(5576),
    [anon_sym_PIPE] = ACTIONS(5578),
    [anon_sym_AMP] = ACTIONS(5578),
    [anon_sym_LT_LT] = ACTIONS(5576),
    [anon_sym_GT_GT] = ACTIONS(5578),
    [anon_sym_GT_GT_GT] = ACTIONS(5576),
    [anon_sym_EQ_EQ] = ACTIONS(5576),
    [anon_sym_BANG_EQ] = ACTIONS(5576),
    [anon_sym_GT_EQ] = ACTIONS(5576),
    [anon_sym_LT_EQ] = ACTIONS(5576),
    [anon_sym_DOT] = ACTIONS(5578),
    [anon_sym_EQ_GT] = ACTIONS(5576),
    [anon_sym_switch] = ACTIONS(5576),
    [anon_sym_when] = ACTIONS(5576),
    [anon_sym_DOT_DOT] = ACTIONS(5576),
    [anon_sym_and] = ACTIONS(5576),
    [anon_sym_or] = ACTIONS(5576),
    [anon_sym_AMP_AMP] = ACTIONS(5576),
    [anon_sym_PIPE_PIPE] = ACTIONS(5576),
    [anon_sym_QMARK_QMARK] = ACTIONS(5576),
    [anon_sym_into] = ACTIONS(5576),
    [anon_sym_on] = ACTIONS(5576),
    [anon_sym_equals] = ACTIONS(5576),
    [anon_sym_by] = ACTIONS(5576),
    [anon_sym_as] = ACTIONS(5576),
    [anon_sym_is] = ACTIONS(5576),
    [anon_sym_DASH_GT] = ACTIONS(5576),
    [anon_sym_with] = ACTIONS(5576),
    [aux_sym_preproc_if_token3] = ACTIONS(5576),
    [aux_sym_preproc_else_token1] = ACTIONS(5576),
    [aux_sym_preproc_elif_token1] = ACTIONS(5576),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4030] = {
    [sym_preproc_region] = STATE(4030),
    [sym_preproc_endregion] = STATE(4030),
    [sym_preproc_line] = STATE(4030),
    [sym_preproc_pragma] = STATE(4030),
    [sym_preproc_nullable] = STATE(4030),
    [sym_preproc_error] = STATE(4030),
    [sym_preproc_define] = STATE(4030),
    [sym_preproc_undef] = STATE(4030),
    [anon_sym_SEMI] = ACTIONS(4062),
    [anon_sym_LBRACK] = ACTIONS(4062),
    [anon_sym_COLON] = ACTIONS(4062),
    [anon_sym_COMMA] = ACTIONS(4062),
    [anon_sym_RBRACK] = ACTIONS(4062),
    [anon_sym_LPAREN] = ACTIONS(4062),
    [anon_sym_RPAREN] = ACTIONS(4062),
    [anon_sym_LBRACE] = ACTIONS(4062),
    [anon_sym_RBRACE] = ACTIONS(4062),
    [anon_sym_LT] = ACTIONS(4060),
    [anon_sym_GT] = ACTIONS(4060),
    [anon_sym_in] = ACTIONS(4062),
    [anon_sym_QMARK] = ACTIONS(4060),
    [anon_sym_BANG] = ACTIONS(4060),
    [anon_sym_PLUS_PLUS] = ACTIONS(4062),
    [anon_sym_DASH_DASH] = ACTIONS(4062),
    [anon_sym_PLUS] = ACTIONS(4060),
    [anon_sym_DASH] = ACTIONS(4060),
    [anon_sym_STAR] = ACTIONS(4062),
    [anon_sym_SLASH] = ACTIONS(4060),
    [anon_sym_PERCENT] = ACTIONS(4062),
    [anon_sym_CARET] = ACTIONS(4062),
    [anon_sym_PIPE] = ACTIONS(4060),
    [anon_sym_AMP] = ACTIONS(4060),
    [anon_sym_LT_LT] = ACTIONS(4062),
    [anon_sym_GT_GT] = ACTIONS(4060),
    [anon_sym_GT_GT_GT] = ACTIONS(4062),
    [anon_sym_EQ_EQ] = ACTIONS(4062),
    [anon_sym_BANG_EQ] = ACTIONS(4062),
    [anon_sym_GT_EQ] = ACTIONS(4062),
    [anon_sym_LT_EQ] = ACTIONS(4062),
    [anon_sym_DOT] = ACTIONS(4060),
    [anon_sym_EQ_GT] = ACTIONS(4062),
    [anon_sym_switch] = ACTIONS(4062),
    [anon_sym_when] = ACTIONS(4062),
    [anon_sym_DOT_DOT] = ACTIONS(4062),
    [anon_sym_and] = ACTIONS(4062),
    [anon_sym_or] = ACTIONS(4062),
    [anon_sym_AMP_AMP] = ACTIONS(4062),
    [anon_sym_PIPE_PIPE] = ACTIONS(4062),
    [anon_sym_QMARK_QMARK] = ACTIONS(4062),
    [anon_sym_on] = ACTIONS(4062),
    [anon_sym_equals] = ACTIONS(4062),
    [anon_sym_by] = ACTIONS(4062),
    [anon_sym_as] = ACTIONS(4062),
    [anon_sym_is] = ACTIONS(4062),
    [anon_sym_DASH_GT] = ACTIONS(4062),
    [anon_sym_with] = ACTIONS(4062),
    [aux_sym_preproc_if_token3] = ACTIONS(4062),
    [aux_sym_preproc_else_token1] = ACTIONS(4062),
    [aux_sym_preproc_elif_token1] = ACTIONS(4062),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4031] = {
    [sym_preproc_region] = STATE(4031),
    [sym_preproc_endregion] = STATE(4031),
    [sym_preproc_line] = STATE(4031),
    [sym_preproc_pragma] = STATE(4031),
    [sym_preproc_nullable] = STATE(4031),
    [sym_preproc_error] = STATE(4031),
    [sym_preproc_define] = STATE(4031),
    [sym_preproc_undef] = STATE(4031),
    [anon_sym_SEMI] = ACTIONS(4072),
    [anon_sym_LBRACK] = ACTIONS(4072),
    [anon_sym_COLON] = ACTIONS(4072),
    [anon_sym_COMMA] = ACTIONS(4072),
    [anon_sym_RBRACK] = ACTIONS(4072),
    [anon_sym_LPAREN] = ACTIONS(4072),
    [anon_sym_RPAREN] = ACTIONS(4072),
    [anon_sym_LBRACE] = ACTIONS(4072),
    [anon_sym_RBRACE] = ACTIONS(4072),
    [anon_sym_LT] = ACTIONS(4070),
    [anon_sym_GT] = ACTIONS(4070),
    [anon_sym_in] = ACTIONS(4072),
    [anon_sym_QMARK] = ACTIONS(4070),
    [anon_sym_BANG] = ACTIONS(4070),
    [anon_sym_PLUS_PLUS] = ACTIONS(4072),
    [anon_sym_DASH_DASH] = ACTIONS(4072),
    [anon_sym_PLUS] = ACTIONS(4070),
    [anon_sym_DASH] = ACTIONS(4070),
    [anon_sym_STAR] = ACTIONS(4072),
    [anon_sym_SLASH] = ACTIONS(4070),
    [anon_sym_PERCENT] = ACTIONS(4072),
    [anon_sym_CARET] = ACTIONS(4072),
    [anon_sym_PIPE] = ACTIONS(4070),
    [anon_sym_AMP] = ACTIONS(4070),
    [anon_sym_LT_LT] = ACTIONS(4072),
    [anon_sym_GT_GT] = ACTIONS(4070),
    [anon_sym_GT_GT_GT] = ACTIONS(4072),
    [anon_sym_EQ_EQ] = ACTIONS(4072),
    [anon_sym_BANG_EQ] = ACTIONS(4072),
    [anon_sym_GT_EQ] = ACTIONS(4072),
    [anon_sym_LT_EQ] = ACTIONS(4072),
    [anon_sym_DOT] = ACTIONS(4070),
    [anon_sym_EQ_GT] = ACTIONS(4072),
    [anon_sym_switch] = ACTIONS(4072),
    [anon_sym_when] = ACTIONS(4072),
    [anon_sym_DOT_DOT] = ACTIONS(4072),
    [anon_sym_and] = ACTIONS(4072),
    [anon_sym_or] = ACTIONS(4072),
    [anon_sym_AMP_AMP] = ACTIONS(4072),
    [anon_sym_PIPE_PIPE] = ACTIONS(4072),
    [anon_sym_QMARK_QMARK] = ACTIONS(4072),
    [anon_sym_on] = ACTIONS(4072),
    [anon_sym_equals] = ACTIONS(4072),
    [anon_sym_by] = ACTIONS(4072),
    [anon_sym_as] = ACTIONS(4072),
    [anon_sym_is] = ACTIONS(4072),
    [anon_sym_DASH_GT] = ACTIONS(4072),
    [anon_sym_with] = ACTIONS(4072),
    [aux_sym_preproc_if_token3] = ACTIONS(4072),
    [aux_sym_preproc_else_token1] = ACTIONS(4072),
    [aux_sym_preproc_elif_token1] = ACTIONS(4072),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4032] = {
    [sym_preproc_region] = STATE(4032),
    [sym_preproc_endregion] = STATE(4032),
    [sym_preproc_line] = STATE(4032),
    [sym_preproc_pragma] = STATE(4032),
    [sym_preproc_nullable] = STATE(4032),
    [sym_preproc_error] = STATE(4032),
    [sym_preproc_define] = STATE(4032),
    [sym_preproc_undef] = STATE(4032),
    [anon_sym_SEMI] = ACTIONS(5598),
    [anon_sym_LBRACK] = ACTIONS(5598),
    [anon_sym_COLON] = ACTIONS(5598),
    [anon_sym_COMMA] = ACTIONS(5598),
    [anon_sym_RBRACK] = ACTIONS(5598),
    [anon_sym_LPAREN] = ACTIONS(5598),
    [anon_sym_RPAREN] = ACTIONS(5598),
    [anon_sym_RBRACE] = ACTIONS(5598),
    [anon_sym_LT] = ACTIONS(5600),
    [anon_sym_GT] = ACTIONS(5600),
    [anon_sym_in] = ACTIONS(5600),
    [anon_sym_QMARK] = ACTIONS(5600),
    [anon_sym_BANG] = ACTIONS(5600),
    [anon_sym_PLUS_PLUS] = ACTIONS(5598),
    [anon_sym_DASH_DASH] = ACTIONS(5598),
    [anon_sym_PLUS] = ACTIONS(5600),
    [anon_sym_DASH] = ACTIONS(5600),
    [anon_sym_STAR] = ACTIONS(5598),
    [anon_sym_SLASH] = ACTIONS(5600),
    [anon_sym_PERCENT] = ACTIONS(5598),
    [anon_sym_CARET] = ACTIONS(5598),
    [anon_sym_PIPE] = ACTIONS(5600),
    [anon_sym_AMP] = ACTIONS(5600),
    [anon_sym_LT_LT] = ACTIONS(5598),
    [anon_sym_GT_GT] = ACTIONS(5600),
    [anon_sym_GT_GT_GT] = ACTIONS(5598),
    [anon_sym_EQ_EQ] = ACTIONS(5598),
    [anon_sym_BANG_EQ] = ACTIONS(5598),
    [anon_sym_GT_EQ] = ACTIONS(5598),
    [anon_sym_LT_EQ] = ACTIONS(5598),
    [anon_sym_DOT] = ACTIONS(5600),
    [anon_sym_EQ_GT] = ACTIONS(5598),
    [anon_sym_switch] = ACTIONS(5598),
    [anon_sym_when] = ACTIONS(5598),
    [anon_sym_DOT_DOT] = ACTIONS(5598),
    [anon_sym_and] = ACTIONS(5598),
    [anon_sym_or] = ACTIONS(5598),
    [anon_sym_AMP_AMP] = ACTIONS(5598),
    [anon_sym_PIPE_PIPE] = ACTIONS(5598),
    [anon_sym_QMARK_QMARK] = ACTIONS(5598),
    [anon_sym_into] = ACTIONS(5598),
    [anon_sym_on] = ACTIONS(5598),
    [anon_sym_equals] = ACTIONS(5598),
    [anon_sym_by] = ACTIONS(5598),
    [anon_sym_as] = ACTIONS(5598),
    [anon_sym_is] = ACTIONS(5598),
    [anon_sym_DASH_GT] = ACTIONS(5598),
    [anon_sym_with] = ACTIONS(5598),
    [aux_sym_preproc_if_token3] = ACTIONS(5598),
    [aux_sym_preproc_else_token1] = ACTIONS(5598),
    [aux_sym_preproc_elif_token1] = ACTIONS(5598),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4033] = {
    [sym_preproc_region] = STATE(4033),
    [sym_preproc_endregion] = STATE(4033),
    [sym_preproc_line] = STATE(4033),
    [sym_preproc_pragma] = STATE(4033),
    [sym_preproc_nullable] = STATE(4033),
    [sym_preproc_error] = STATE(4033),
    [sym_preproc_define] = STATE(4033),
    [sym_preproc_undef] = STATE(4033),
    [anon_sym_SEMI] = ACTIONS(5590),
    [anon_sym_LBRACK] = ACTIONS(5590),
    [anon_sym_COLON] = ACTIONS(5590),
    [anon_sym_COMMA] = ACTIONS(5590),
    [anon_sym_RBRACK] = ACTIONS(5590),
    [anon_sym_LPAREN] = ACTIONS(5590),
    [anon_sym_RPAREN] = ACTIONS(5590),
    [anon_sym_RBRACE] = ACTIONS(5590),
    [anon_sym_LT] = ACTIONS(5592),
    [anon_sym_GT] = ACTIONS(5592),
    [anon_sym_in] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_BANG] = ACTIONS(5592),
    [anon_sym_PLUS_PLUS] = ACTIONS(5590),
    [anon_sym_DASH_DASH] = ACTIONS(5590),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_DASH] = ACTIONS(5592),
    [anon_sym_STAR] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [anon_sym_PERCENT] = ACTIONS(5590),
    [anon_sym_CARET] = ACTIONS(5590),
    [anon_sym_PIPE] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5590),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_GT_GT_GT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_BANG_EQ] = ACTIONS(5590),
    [anon_sym_GT_EQ] = ACTIONS(5590),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_DOT] = ACTIONS(5592),
    [anon_sym_EQ_GT] = ACTIONS(5590),
    [anon_sym_switch] = ACTIONS(5590),
    [anon_sym_when] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5590),
    [anon_sym_or] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5590),
    [anon_sym_PIPE_PIPE] = ACTIONS(5590),
    [anon_sym_QMARK_QMARK] = ACTIONS(5590),
    [anon_sym_into] = ACTIONS(5590),
    [anon_sym_on] = ACTIONS(5590),
    [anon_sym_equals] = ACTIONS(5590),
    [anon_sym_by] = ACTIONS(5590),
    [anon_sym_as] = ACTIONS(5590),
    [anon_sym_is] = ACTIONS(5590),
    [anon_sym_DASH_GT] = ACTIONS(5590),
    [anon_sym_with] = ACTIONS(5590),
    [aux_sym_preproc_if_token3] = ACTIONS(5590),
    [aux_sym_preproc_else_token1] = ACTIONS(5590),
    [aux_sym_preproc_elif_token1] = ACTIONS(5590),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4034] = {
    [sym_preproc_region] = STATE(4034),
    [sym_preproc_endregion] = STATE(4034),
    [sym_preproc_line] = STATE(4034),
    [sym_preproc_pragma] = STATE(4034),
    [sym_preproc_nullable] = STATE(4034),
    [sym_preproc_error] = STATE(4034),
    [sym_preproc_define] = STATE(4034),
    [sym_preproc_undef] = STATE(4034),
    [anon_sym_SEMI] = ACTIONS(4434),
    [anon_sym_LBRACK] = ACTIONS(4434),
    [anon_sym_COLON] = ACTIONS(4434),
    [anon_sym_COMMA] = ACTIONS(4434),
    [anon_sym_RBRACK] = ACTIONS(4434),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [anon_sym_RPAREN] = ACTIONS(4434),
    [anon_sym_LBRACE] = ACTIONS(4434),
    [anon_sym_RBRACE] = ACTIONS(4434),
    [anon_sym_LT] = ACTIONS(4432),
    [anon_sym_GT] = ACTIONS(4432),
    [anon_sym_in] = ACTIONS(4434),
    [anon_sym_QMARK] = ACTIONS(4432),
    [anon_sym_BANG] = ACTIONS(4432),
    [anon_sym_PLUS_PLUS] = ACTIONS(4434),
    [anon_sym_DASH_DASH] = ACTIONS(4434),
    [anon_sym_PLUS] = ACTIONS(4432),
    [anon_sym_DASH] = ACTIONS(4432),
    [anon_sym_STAR] = ACTIONS(4434),
    [anon_sym_SLASH] = ACTIONS(4432),
    [anon_sym_PERCENT] = ACTIONS(4434),
    [anon_sym_CARET] = ACTIONS(4434),
    [anon_sym_PIPE] = ACTIONS(4432),
    [anon_sym_AMP] = ACTIONS(4432),
    [anon_sym_LT_LT] = ACTIONS(4434),
    [anon_sym_GT_GT] = ACTIONS(4432),
    [anon_sym_GT_GT_GT] = ACTIONS(4434),
    [anon_sym_EQ_EQ] = ACTIONS(4434),
    [anon_sym_BANG_EQ] = ACTIONS(4434),
    [anon_sym_GT_EQ] = ACTIONS(4434),
    [anon_sym_LT_EQ] = ACTIONS(4434),
    [anon_sym_DOT] = ACTIONS(4432),
    [anon_sym_EQ_GT] = ACTIONS(4434),
    [anon_sym_switch] = ACTIONS(4434),
    [anon_sym_when] = ACTIONS(4434),
    [anon_sym_DOT_DOT] = ACTIONS(4434),
    [anon_sym_and] = ACTIONS(4434),
    [anon_sym_or] = ACTIONS(4434),
    [anon_sym_AMP_AMP] = ACTIONS(4434),
    [anon_sym_PIPE_PIPE] = ACTIONS(4434),
    [anon_sym_QMARK_QMARK] = ACTIONS(4434),
    [anon_sym_on] = ACTIONS(4434),
    [anon_sym_equals] = ACTIONS(4434),
    [anon_sym_by] = ACTIONS(4434),
    [anon_sym_as] = ACTIONS(4434),
    [anon_sym_is] = ACTIONS(4434),
    [anon_sym_DASH_GT] = ACTIONS(4434),
    [anon_sym_with] = ACTIONS(4434),
    [aux_sym_preproc_if_token3] = ACTIONS(4434),
    [aux_sym_preproc_else_token1] = ACTIONS(4434),
    [aux_sym_preproc_elif_token1] = ACTIONS(4434),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4035] = {
    [sym_preproc_region] = STATE(4035),
    [sym_preproc_endregion] = STATE(4035),
    [sym_preproc_line] = STATE(4035),
    [sym_preproc_pragma] = STATE(4035),
    [sym_preproc_nullable] = STATE(4035),
    [sym_preproc_error] = STATE(4035),
    [sym_preproc_define] = STATE(4035),
    [sym_preproc_undef] = STATE(4035),
    [anon_sym_SEMI] = ACTIONS(5842),
    [anon_sym_LBRACK] = ACTIONS(5842),
    [anon_sym_COLON] = ACTIONS(5842),
    [anon_sym_COMMA] = ACTIONS(5842),
    [anon_sym_RBRACK] = ACTIONS(5842),
    [anon_sym_LPAREN] = ACTIONS(5842),
    [anon_sym_RPAREN] = ACTIONS(5842),
    [anon_sym_RBRACE] = ACTIONS(5842),
    [anon_sym_LT] = ACTIONS(5844),
    [anon_sym_GT] = ACTIONS(5844),
    [anon_sym_in] = ACTIONS(5844),
    [anon_sym_QMARK] = ACTIONS(5844),
    [anon_sym_BANG] = ACTIONS(5844),
    [anon_sym_PLUS_PLUS] = ACTIONS(5842),
    [anon_sym_DASH_DASH] = ACTIONS(5842),
    [anon_sym_PLUS] = ACTIONS(5844),
    [anon_sym_DASH] = ACTIONS(5844),
    [anon_sym_STAR] = ACTIONS(5842),
    [anon_sym_SLASH] = ACTIONS(5844),
    [anon_sym_PERCENT] = ACTIONS(5842),
    [anon_sym_CARET] = ACTIONS(5842),
    [anon_sym_PIPE] = ACTIONS(5844),
    [anon_sym_AMP] = ACTIONS(5844),
    [anon_sym_LT_LT] = ACTIONS(5842),
    [anon_sym_GT_GT] = ACTIONS(5844),
    [anon_sym_GT_GT_GT] = ACTIONS(5842),
    [anon_sym_EQ_EQ] = ACTIONS(5842),
    [anon_sym_BANG_EQ] = ACTIONS(5842),
    [anon_sym_GT_EQ] = ACTIONS(5842),
    [anon_sym_LT_EQ] = ACTIONS(5842),
    [anon_sym_DOT] = ACTIONS(5844),
    [anon_sym_EQ_GT] = ACTIONS(5842),
    [anon_sym_switch] = ACTIONS(5842),
    [anon_sym_when] = ACTIONS(5842),
    [anon_sym_DOT_DOT] = ACTIONS(5842),
    [anon_sym_and] = ACTIONS(5842),
    [anon_sym_or] = ACTIONS(5842),
    [anon_sym_AMP_AMP] = ACTIONS(5842),
    [anon_sym_PIPE_PIPE] = ACTIONS(5842),
    [anon_sym_QMARK_QMARK] = ACTIONS(5842),
    [anon_sym_into] = ACTIONS(5842),
    [anon_sym_on] = ACTIONS(5842),
    [anon_sym_equals] = ACTIONS(5842),
    [anon_sym_by] = ACTIONS(5842),
    [anon_sym_as] = ACTIONS(5842),
    [anon_sym_is] = ACTIONS(5842),
    [anon_sym_DASH_GT] = ACTIONS(5842),
    [anon_sym_with] = ACTIONS(5842),
    [aux_sym_preproc_if_token3] = ACTIONS(5842),
    [aux_sym_preproc_else_token1] = ACTIONS(5842),
    [aux_sym_preproc_elif_token1] = ACTIONS(5842),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4036] = {
    [sym_preproc_region] = STATE(4036),
    [sym_preproc_endregion] = STATE(4036),
    [sym_preproc_line] = STATE(4036),
    [sym_preproc_pragma] = STATE(4036),
    [sym_preproc_nullable] = STATE(4036),
    [sym_preproc_error] = STATE(4036),
    [sym_preproc_define] = STATE(4036),
    [sym_preproc_undef] = STATE(4036),
    [anon_sym_SEMI] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4438),
    [anon_sym_COLON] = ACTIONS(4438),
    [anon_sym_COMMA] = ACTIONS(4438),
    [anon_sym_RBRACK] = ACTIONS(4438),
    [anon_sym_LPAREN] = ACTIONS(4438),
    [anon_sym_RPAREN] = ACTIONS(4438),
    [anon_sym_LBRACE] = ACTIONS(4438),
    [anon_sym_RBRACE] = ACTIONS(4438),
    [anon_sym_LT] = ACTIONS(4436),
    [anon_sym_GT] = ACTIONS(4436),
    [anon_sym_in] = ACTIONS(4438),
    [anon_sym_QMARK] = ACTIONS(4436),
    [anon_sym_BANG] = ACTIONS(4436),
    [anon_sym_PLUS_PLUS] = ACTIONS(4438),
    [anon_sym_DASH_DASH] = ACTIONS(4438),
    [anon_sym_PLUS] = ACTIONS(4436),
    [anon_sym_DASH] = ACTIONS(4436),
    [anon_sym_STAR] = ACTIONS(4438),
    [anon_sym_SLASH] = ACTIONS(4436),
    [anon_sym_PERCENT] = ACTIONS(4438),
    [anon_sym_CARET] = ACTIONS(4438),
    [anon_sym_PIPE] = ACTIONS(4436),
    [anon_sym_AMP] = ACTIONS(4436),
    [anon_sym_LT_LT] = ACTIONS(4438),
    [anon_sym_GT_GT] = ACTIONS(4436),
    [anon_sym_GT_GT_GT] = ACTIONS(4438),
    [anon_sym_EQ_EQ] = ACTIONS(4438),
    [anon_sym_BANG_EQ] = ACTIONS(4438),
    [anon_sym_GT_EQ] = ACTIONS(4438),
    [anon_sym_LT_EQ] = ACTIONS(4438),
    [anon_sym_DOT] = ACTIONS(4436),
    [anon_sym_EQ_GT] = ACTIONS(4438),
    [anon_sym_switch] = ACTIONS(4438),
    [anon_sym_when] = ACTIONS(4438),
    [anon_sym_DOT_DOT] = ACTIONS(4438),
    [anon_sym_and] = ACTIONS(4438),
    [anon_sym_or] = ACTIONS(4438),
    [anon_sym_AMP_AMP] = ACTIONS(4438),
    [anon_sym_PIPE_PIPE] = ACTIONS(4438),
    [anon_sym_QMARK_QMARK] = ACTIONS(4438),
    [anon_sym_on] = ACTIONS(4438),
    [anon_sym_equals] = ACTIONS(4438),
    [anon_sym_by] = ACTIONS(4438),
    [anon_sym_as] = ACTIONS(4438),
    [anon_sym_is] = ACTIONS(4438),
    [anon_sym_DASH_GT] = ACTIONS(4438),
    [anon_sym_with] = ACTIONS(4438),
    [aux_sym_preproc_if_token3] = ACTIONS(4438),
    [aux_sym_preproc_else_token1] = ACTIONS(4438),
    [aux_sym_preproc_elif_token1] = ACTIONS(4438),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4037] = {
    [sym_preproc_region] = STATE(4037),
    [sym_preproc_endregion] = STATE(4037),
    [sym_preproc_line] = STATE(4037),
    [sym_preproc_pragma] = STATE(4037),
    [sym_preproc_nullable] = STATE(4037),
    [sym_preproc_error] = STATE(4037),
    [sym_preproc_define] = STATE(4037),
    [sym_preproc_undef] = STATE(4037),
    [anon_sym_SEMI] = ACTIONS(4087),
    [anon_sym_LBRACK] = ACTIONS(4087),
    [anon_sym_COLON] = ACTIONS(4087),
    [anon_sym_COMMA] = ACTIONS(4087),
    [anon_sym_RBRACK] = ACTIONS(4087),
    [anon_sym_LPAREN] = ACTIONS(4087),
    [anon_sym_RPAREN] = ACTIONS(4087),
    [anon_sym_LBRACE] = ACTIONS(4087),
    [anon_sym_RBRACE] = ACTIONS(4087),
    [anon_sym_LT] = ACTIONS(4085),
    [anon_sym_GT] = ACTIONS(4085),
    [anon_sym_in] = ACTIONS(4087),
    [anon_sym_QMARK] = ACTIONS(4085),
    [anon_sym_BANG] = ACTIONS(4085),
    [anon_sym_PLUS_PLUS] = ACTIONS(4087),
    [anon_sym_DASH_DASH] = ACTIONS(4087),
    [anon_sym_PLUS] = ACTIONS(4085),
    [anon_sym_DASH] = ACTIONS(4085),
    [anon_sym_STAR] = ACTIONS(4087),
    [anon_sym_SLASH] = ACTIONS(4085),
    [anon_sym_PERCENT] = ACTIONS(4087),
    [anon_sym_CARET] = ACTIONS(4087),
    [anon_sym_PIPE] = ACTIONS(4085),
    [anon_sym_AMP] = ACTIONS(4085),
    [anon_sym_LT_LT] = ACTIONS(4087),
    [anon_sym_GT_GT] = ACTIONS(4085),
    [anon_sym_GT_GT_GT] = ACTIONS(4087),
    [anon_sym_EQ_EQ] = ACTIONS(4087),
    [anon_sym_BANG_EQ] = ACTIONS(4087),
    [anon_sym_GT_EQ] = ACTIONS(4087),
    [anon_sym_LT_EQ] = ACTIONS(4087),
    [anon_sym_DOT] = ACTIONS(4085),
    [anon_sym_EQ_GT] = ACTIONS(4087),
    [anon_sym_switch] = ACTIONS(4087),
    [anon_sym_when] = ACTIONS(4087),
    [anon_sym_DOT_DOT] = ACTIONS(4087),
    [anon_sym_and] = ACTIONS(4087),
    [anon_sym_or] = ACTIONS(4087),
    [anon_sym_AMP_AMP] = ACTIONS(4087),
    [anon_sym_PIPE_PIPE] = ACTIONS(4087),
    [anon_sym_QMARK_QMARK] = ACTIONS(4087),
    [anon_sym_on] = ACTIONS(4087),
    [anon_sym_equals] = ACTIONS(4087),
    [anon_sym_by] = ACTIONS(4087),
    [anon_sym_as] = ACTIONS(4087),
    [anon_sym_is] = ACTIONS(4087),
    [anon_sym_DASH_GT] = ACTIONS(4087),
    [anon_sym_with] = ACTIONS(4087),
    [aux_sym_preproc_if_token3] = ACTIONS(4087),
    [aux_sym_preproc_else_token1] = ACTIONS(4087),
    [aux_sym_preproc_elif_token1] = ACTIONS(4087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4038] = {
    [sym_preproc_region] = STATE(4038),
    [sym_preproc_endregion] = STATE(4038),
    [sym_preproc_line] = STATE(4038),
    [sym_preproc_pragma] = STATE(4038),
    [sym_preproc_nullable] = STATE(4038),
    [sym_preproc_error] = STATE(4038),
    [sym_preproc_define] = STATE(4038),
    [sym_preproc_undef] = STATE(4038),
    [anon_sym_SEMI] = ACTIONS(5846),
    [anon_sym_LBRACK] = ACTIONS(5846),
    [anon_sym_COLON] = ACTIONS(5846),
    [anon_sym_COMMA] = ACTIONS(5846),
    [anon_sym_RBRACK] = ACTIONS(5846),
    [anon_sym_LPAREN] = ACTIONS(5846),
    [anon_sym_RPAREN] = ACTIONS(5846),
    [anon_sym_RBRACE] = ACTIONS(5846),
    [anon_sym_LT] = ACTIONS(5848),
    [anon_sym_GT] = ACTIONS(5848),
    [anon_sym_in] = ACTIONS(5848),
    [anon_sym_QMARK] = ACTIONS(5848),
    [anon_sym_BANG] = ACTIONS(5848),
    [anon_sym_PLUS_PLUS] = ACTIONS(5846),
    [anon_sym_DASH_DASH] = ACTIONS(5846),
    [anon_sym_PLUS] = ACTIONS(5848),
    [anon_sym_DASH] = ACTIONS(5848),
    [anon_sym_STAR] = ACTIONS(5846),
    [anon_sym_SLASH] = ACTIONS(5848),
    [anon_sym_PERCENT] = ACTIONS(5846),
    [anon_sym_CARET] = ACTIONS(5846),
    [anon_sym_PIPE] = ACTIONS(5848),
    [anon_sym_AMP] = ACTIONS(5848),
    [anon_sym_LT_LT] = ACTIONS(5846),
    [anon_sym_GT_GT] = ACTIONS(5848),
    [anon_sym_GT_GT_GT] = ACTIONS(5846),
    [anon_sym_EQ_EQ] = ACTIONS(5846),
    [anon_sym_BANG_EQ] = ACTIONS(5846),
    [anon_sym_GT_EQ] = ACTIONS(5846),
    [anon_sym_LT_EQ] = ACTIONS(5846),
    [anon_sym_DOT] = ACTIONS(5848),
    [anon_sym_EQ_GT] = ACTIONS(5846),
    [anon_sym_switch] = ACTIONS(5846),
    [anon_sym_when] = ACTIONS(5846),
    [anon_sym_DOT_DOT] = ACTIONS(5846),
    [anon_sym_and] = ACTIONS(5846),
    [anon_sym_or] = ACTIONS(5846),
    [anon_sym_AMP_AMP] = ACTIONS(5846),
    [anon_sym_PIPE_PIPE] = ACTIONS(5846),
    [anon_sym_QMARK_QMARK] = ACTIONS(5846),
    [anon_sym_into] = ACTIONS(5846),
    [anon_sym_on] = ACTIONS(5846),
    [anon_sym_equals] = ACTIONS(5846),
    [anon_sym_by] = ACTIONS(5846),
    [anon_sym_as] = ACTIONS(5846),
    [anon_sym_is] = ACTIONS(5846),
    [anon_sym_DASH_GT] = ACTIONS(5846),
    [anon_sym_with] = ACTIONS(5846),
    [aux_sym_preproc_if_token3] = ACTIONS(5846),
    [aux_sym_preproc_else_token1] = ACTIONS(5846),
    [aux_sym_preproc_elif_token1] = ACTIONS(5846),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4039] = {
    [sym_preproc_region] = STATE(4039),
    [sym_preproc_endregion] = STATE(4039),
    [sym_preproc_line] = STATE(4039),
    [sym_preproc_pragma] = STATE(4039),
    [sym_preproc_nullable] = STATE(4039),
    [sym_preproc_error] = STATE(4039),
    [sym_preproc_define] = STATE(4039),
    [sym_preproc_undef] = STATE(4039),
    [anon_sym_SEMI] = ACTIONS(5850),
    [anon_sym_LBRACK] = ACTIONS(5850),
    [anon_sym_COLON] = ACTIONS(5850),
    [anon_sym_COMMA] = ACTIONS(5850),
    [anon_sym_RBRACK] = ACTIONS(5850),
    [anon_sym_LPAREN] = ACTIONS(5850),
    [anon_sym_RPAREN] = ACTIONS(5850),
    [anon_sym_RBRACE] = ACTIONS(5850),
    [anon_sym_LT] = ACTIONS(5852),
    [anon_sym_GT] = ACTIONS(5852),
    [anon_sym_in] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_BANG] = ACTIONS(5852),
    [anon_sym_PLUS_PLUS] = ACTIONS(5850),
    [anon_sym_DASH_DASH] = ACTIONS(5850),
    [anon_sym_PLUS] = ACTIONS(5852),
    [anon_sym_DASH] = ACTIONS(5852),
    [anon_sym_STAR] = ACTIONS(5850),
    [anon_sym_SLASH] = ACTIONS(5852),
    [anon_sym_PERCENT] = ACTIONS(5850),
    [anon_sym_CARET] = ACTIONS(5850),
    [anon_sym_PIPE] = ACTIONS(5852),
    [anon_sym_AMP] = ACTIONS(5852),
    [anon_sym_LT_LT] = ACTIONS(5850),
    [anon_sym_GT_GT] = ACTIONS(5852),
    [anon_sym_GT_GT_GT] = ACTIONS(5850),
    [anon_sym_EQ_EQ] = ACTIONS(5850),
    [anon_sym_BANG_EQ] = ACTIONS(5850),
    [anon_sym_GT_EQ] = ACTIONS(5850),
    [anon_sym_LT_EQ] = ACTIONS(5850),
    [anon_sym_DOT] = ACTIONS(5852),
    [anon_sym_EQ_GT] = ACTIONS(5850),
    [anon_sym_switch] = ACTIONS(5850),
    [anon_sym_when] = ACTIONS(5850),
    [anon_sym_DOT_DOT] = ACTIONS(5850),
    [anon_sym_and] = ACTIONS(5850),
    [anon_sym_or] = ACTIONS(5850),
    [anon_sym_AMP_AMP] = ACTIONS(5850),
    [anon_sym_PIPE_PIPE] = ACTIONS(5850),
    [anon_sym_QMARK_QMARK] = ACTIONS(5850),
    [anon_sym_into] = ACTIONS(5850),
    [anon_sym_on] = ACTIONS(5850),
    [anon_sym_equals] = ACTIONS(5850),
    [anon_sym_by] = ACTIONS(5850),
    [anon_sym_as] = ACTIONS(5850),
    [anon_sym_is] = ACTIONS(5850),
    [anon_sym_DASH_GT] = ACTIONS(5850),
    [anon_sym_with] = ACTIONS(5850),
    [aux_sym_preproc_if_token3] = ACTIONS(5850),
    [aux_sym_preproc_else_token1] = ACTIONS(5850),
    [aux_sym_preproc_elif_token1] = ACTIONS(5850),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4040] = {
    [sym_preproc_region] = STATE(4040),
    [sym_preproc_endregion] = STATE(4040),
    [sym_preproc_line] = STATE(4040),
    [sym_preproc_pragma] = STATE(4040),
    [sym_preproc_nullable] = STATE(4040),
    [sym_preproc_error] = STATE(4040),
    [sym_preproc_define] = STATE(4040),
    [sym_preproc_undef] = STATE(4040),
    [anon_sym_SEMI] = ACTIONS(4428),
    [anon_sym_LBRACK] = ACTIONS(4428),
    [anon_sym_COLON] = ACTIONS(4428),
    [anon_sym_COMMA] = ACTIONS(4428),
    [anon_sym_RBRACK] = ACTIONS(4428),
    [anon_sym_LPAREN] = ACTIONS(4428),
    [anon_sym_RPAREN] = ACTIONS(4428),
    [anon_sym_LBRACE] = ACTIONS(4428),
    [anon_sym_RBRACE] = ACTIONS(4428),
    [anon_sym_LT] = ACTIONS(4426),
    [anon_sym_GT] = ACTIONS(4426),
    [anon_sym_in] = ACTIONS(4428),
    [anon_sym_QMARK] = ACTIONS(4426),
    [anon_sym_BANG] = ACTIONS(4426),
    [anon_sym_PLUS_PLUS] = ACTIONS(4428),
    [anon_sym_DASH_DASH] = ACTIONS(4428),
    [anon_sym_PLUS] = ACTIONS(4426),
    [anon_sym_DASH] = ACTIONS(4426),
    [anon_sym_STAR] = ACTIONS(4428),
    [anon_sym_SLASH] = ACTIONS(4426),
    [anon_sym_PERCENT] = ACTIONS(4428),
    [anon_sym_CARET] = ACTIONS(4428),
    [anon_sym_PIPE] = ACTIONS(4426),
    [anon_sym_AMP] = ACTIONS(4426),
    [anon_sym_LT_LT] = ACTIONS(4428),
    [anon_sym_GT_GT] = ACTIONS(4426),
    [anon_sym_GT_GT_GT] = ACTIONS(4428),
    [anon_sym_EQ_EQ] = ACTIONS(4428),
    [anon_sym_BANG_EQ] = ACTIONS(4428),
    [anon_sym_GT_EQ] = ACTIONS(4428),
    [anon_sym_LT_EQ] = ACTIONS(4428),
    [anon_sym_DOT] = ACTIONS(4426),
    [anon_sym_EQ_GT] = ACTIONS(4428),
    [anon_sym_switch] = ACTIONS(4428),
    [anon_sym_when] = ACTIONS(4428),
    [anon_sym_DOT_DOT] = ACTIONS(4428),
    [anon_sym_and] = ACTIONS(4428),
    [anon_sym_or] = ACTIONS(4428),
    [anon_sym_AMP_AMP] = ACTIONS(4428),
    [anon_sym_PIPE_PIPE] = ACTIONS(4428),
    [anon_sym_QMARK_QMARK] = ACTIONS(4428),
    [anon_sym_on] = ACTIONS(4428),
    [anon_sym_equals] = ACTIONS(4428),
    [anon_sym_by] = ACTIONS(4428),
    [anon_sym_as] = ACTIONS(4428),
    [anon_sym_is] = ACTIONS(4428),
    [anon_sym_DASH_GT] = ACTIONS(4428),
    [anon_sym_with] = ACTIONS(4428),
    [aux_sym_preproc_if_token3] = ACTIONS(4428),
    [aux_sym_preproc_else_token1] = ACTIONS(4428),
    [aux_sym_preproc_elif_token1] = ACTIONS(4428),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4041] = {
    [sym_preproc_region] = STATE(4041),
    [sym_preproc_endregion] = STATE(4041),
    [sym_preproc_line] = STATE(4041),
    [sym_preproc_pragma] = STATE(4041),
    [sym_preproc_nullable] = STATE(4041),
    [sym_preproc_error] = STATE(4041),
    [sym_preproc_define] = STATE(4041),
    [sym_preproc_undef] = STATE(4041),
    [anon_sym_SEMI] = ACTIONS(5424),
    [anon_sym_LBRACK] = ACTIONS(5424),
    [anon_sym_COLON] = ACTIONS(5424),
    [anon_sym_COMMA] = ACTIONS(5424),
    [anon_sym_RBRACK] = ACTIONS(5424),
    [anon_sym_LPAREN] = ACTIONS(5424),
    [anon_sym_RPAREN] = ACTIONS(5424),
    [anon_sym_RBRACE] = ACTIONS(5424),
    [anon_sym_LT] = ACTIONS(5426),
    [anon_sym_GT] = ACTIONS(5426),
    [anon_sym_in] = ACTIONS(5426),
    [anon_sym_QMARK] = ACTIONS(5426),
    [anon_sym_BANG] = ACTIONS(5426),
    [anon_sym_PLUS_PLUS] = ACTIONS(5424),
    [anon_sym_DASH_DASH] = ACTIONS(5424),
    [anon_sym_PLUS] = ACTIONS(5426),
    [anon_sym_DASH] = ACTIONS(5426),
    [anon_sym_STAR] = ACTIONS(5424),
    [anon_sym_SLASH] = ACTIONS(5426),
    [anon_sym_PERCENT] = ACTIONS(5424),
    [anon_sym_CARET] = ACTIONS(5424),
    [anon_sym_PIPE] = ACTIONS(5426),
    [anon_sym_AMP] = ACTIONS(5426),
    [anon_sym_LT_LT] = ACTIONS(5424),
    [anon_sym_GT_GT] = ACTIONS(5426),
    [anon_sym_GT_GT_GT] = ACTIONS(5424),
    [anon_sym_EQ_EQ] = ACTIONS(5424),
    [anon_sym_BANG_EQ] = ACTIONS(5424),
    [anon_sym_GT_EQ] = ACTIONS(5424),
    [anon_sym_LT_EQ] = ACTIONS(5424),
    [anon_sym_DOT] = ACTIONS(5426),
    [anon_sym_EQ_GT] = ACTIONS(5424),
    [anon_sym_switch] = ACTIONS(5424),
    [anon_sym_when] = ACTIONS(5424),
    [anon_sym_DOT_DOT] = ACTIONS(5424),
    [anon_sym_and] = ACTIONS(5424),
    [anon_sym_or] = ACTIONS(5424),
    [anon_sym_AMP_AMP] = ACTIONS(5424),
    [anon_sym_PIPE_PIPE] = ACTIONS(5424),
    [anon_sym_QMARK_QMARK] = ACTIONS(5424),
    [anon_sym_into] = ACTIONS(5424),
    [anon_sym_on] = ACTIONS(5424),
    [anon_sym_equals] = ACTIONS(5424),
    [anon_sym_by] = ACTIONS(5424),
    [anon_sym_as] = ACTIONS(5424),
    [anon_sym_is] = ACTIONS(5424),
    [anon_sym_DASH_GT] = ACTIONS(5424),
    [anon_sym_with] = ACTIONS(5424),
    [aux_sym_preproc_if_token3] = ACTIONS(5424),
    [aux_sym_preproc_else_token1] = ACTIONS(5424),
    [aux_sym_preproc_elif_token1] = ACTIONS(5424),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4042] = {
    [sym_preproc_region] = STATE(4042),
    [sym_preproc_endregion] = STATE(4042),
    [sym_preproc_line] = STATE(4042),
    [sym_preproc_pragma] = STATE(4042),
    [sym_preproc_nullable] = STATE(4042),
    [sym_preproc_error] = STATE(4042),
    [sym_preproc_define] = STATE(4042),
    [sym_preproc_undef] = STATE(4042),
    [anon_sym_SEMI] = ACTIONS(2935),
    [anon_sym_LBRACK] = ACTIONS(2935),
    [anon_sym_COLON] = ACTIONS(2935),
    [anon_sym_COMMA] = ACTIONS(2935),
    [anon_sym_RBRACK] = ACTIONS(2935),
    [anon_sym_LPAREN] = ACTIONS(2935),
    [anon_sym_RPAREN] = ACTIONS(2935),
    [anon_sym_RBRACE] = ACTIONS(2935),
    [anon_sym_LT] = ACTIONS(2933),
    [anon_sym_GT] = ACTIONS(2933),
    [anon_sym_in] = ACTIONS(2933),
    [anon_sym_QMARK] = ACTIONS(2933),
    [anon_sym_BANG] = ACTIONS(2933),
    [anon_sym_PLUS_PLUS] = ACTIONS(2935),
    [anon_sym_DASH_DASH] = ACTIONS(2935),
    [anon_sym_PLUS] = ACTIONS(2933),
    [anon_sym_DASH] = ACTIONS(2933),
    [anon_sym_STAR] = ACTIONS(2935),
    [anon_sym_SLASH] = ACTIONS(2933),
    [anon_sym_PERCENT] = ACTIONS(2935),
    [anon_sym_CARET] = ACTIONS(2935),
    [anon_sym_PIPE] = ACTIONS(2933),
    [anon_sym_AMP] = ACTIONS(2933),
    [anon_sym_LT_LT] = ACTIONS(2935),
    [anon_sym_GT_GT] = ACTIONS(2933),
    [anon_sym_GT_GT_GT] = ACTIONS(2935),
    [anon_sym_EQ_EQ] = ACTIONS(2935),
    [anon_sym_BANG_EQ] = ACTIONS(2935),
    [anon_sym_GT_EQ] = ACTIONS(2935),
    [anon_sym_LT_EQ] = ACTIONS(2935),
    [anon_sym_DOT] = ACTIONS(2933),
    [anon_sym_EQ_GT] = ACTIONS(2935),
    [anon_sym_switch] = ACTIONS(2935),
    [anon_sym_when] = ACTIONS(2935),
    [anon_sym_DOT_DOT] = ACTIONS(2935),
    [anon_sym_and] = ACTIONS(2935),
    [anon_sym_or] = ACTIONS(2935),
    [anon_sym_AMP_AMP] = ACTIONS(2935),
    [anon_sym_PIPE_PIPE] = ACTIONS(2935),
    [anon_sym_QMARK_QMARK] = ACTIONS(2935),
    [anon_sym_into] = ACTIONS(2935),
    [anon_sym_on] = ACTIONS(2935),
    [anon_sym_equals] = ACTIONS(2935),
    [anon_sym_by] = ACTIONS(2935),
    [anon_sym_as] = ACTIONS(2935),
    [anon_sym_is] = ACTIONS(2935),
    [anon_sym_DASH_GT] = ACTIONS(2935),
    [anon_sym_with] = ACTIONS(2935),
    [aux_sym_preproc_if_token3] = ACTIONS(2935),
    [aux_sym_preproc_else_token1] = ACTIONS(2935),
    [aux_sym_preproc_elif_token1] = ACTIONS(2935),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4043] = {
    [sym_preproc_region] = STATE(4043),
    [sym_preproc_endregion] = STATE(4043),
    [sym_preproc_line] = STATE(4043),
    [sym_preproc_pragma] = STATE(4043),
    [sym_preproc_nullable] = STATE(4043),
    [sym_preproc_error] = STATE(4043),
    [sym_preproc_define] = STATE(4043),
    [sym_preproc_undef] = STATE(4043),
    [anon_sym_SEMI] = ACTIONS(5854),
    [anon_sym_LBRACK] = ACTIONS(5854),
    [anon_sym_COLON] = ACTIONS(5854),
    [anon_sym_COMMA] = ACTIONS(5854),
    [anon_sym_RBRACK] = ACTIONS(5854),
    [anon_sym_LPAREN] = ACTIONS(5854),
    [anon_sym_RPAREN] = ACTIONS(5854),
    [anon_sym_RBRACE] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5856),
    [anon_sym_GT] = ACTIONS(5856),
    [anon_sym_in] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_BANG] = ACTIONS(5856),
    [anon_sym_PLUS_PLUS] = ACTIONS(5854),
    [anon_sym_DASH_DASH] = ACTIONS(5854),
    [anon_sym_PLUS] = ACTIONS(5856),
    [anon_sym_DASH] = ACTIONS(5856),
    [anon_sym_STAR] = ACTIONS(5854),
    [anon_sym_SLASH] = ACTIONS(5856),
    [anon_sym_PERCENT] = ACTIONS(5854),
    [anon_sym_CARET] = ACTIONS(5854),
    [anon_sym_PIPE] = ACTIONS(5856),
    [anon_sym_AMP] = ACTIONS(5856),
    [anon_sym_LT_LT] = ACTIONS(5854),
    [anon_sym_GT_GT] = ACTIONS(5856),
    [anon_sym_GT_GT_GT] = ACTIONS(5854),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5854),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_DOT] = ACTIONS(5856),
    [anon_sym_EQ_GT] = ACTIONS(5854),
    [anon_sym_switch] = ACTIONS(5854),
    [anon_sym_when] = ACTIONS(5854),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_and] = ACTIONS(5854),
    [anon_sym_or] = ACTIONS(5854),
    [anon_sym_AMP_AMP] = ACTIONS(5854),
    [anon_sym_PIPE_PIPE] = ACTIONS(5854),
    [anon_sym_QMARK_QMARK] = ACTIONS(5854),
    [anon_sym_into] = ACTIONS(5854),
    [anon_sym_on] = ACTIONS(5854),
    [anon_sym_equals] = ACTIONS(5854),
    [anon_sym_by] = ACTIONS(5854),
    [anon_sym_as] = ACTIONS(5854),
    [anon_sym_is] = ACTIONS(5854),
    [anon_sym_DASH_GT] = ACTIONS(5854),
    [anon_sym_with] = ACTIONS(5854),
    [aux_sym_preproc_if_token3] = ACTIONS(5854),
    [aux_sym_preproc_else_token1] = ACTIONS(5854),
    [aux_sym_preproc_elif_token1] = ACTIONS(5854),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4044] = {
    [sym_preproc_region] = STATE(4044),
    [sym_preproc_endregion] = STATE(4044),
    [sym_preproc_line] = STATE(4044),
    [sym_preproc_pragma] = STATE(4044),
    [sym_preproc_nullable] = STATE(4044),
    [sym_preproc_error] = STATE(4044),
    [sym_preproc_define] = STATE(4044),
    [sym_preproc_undef] = STATE(4044),
    [anon_sym_SEMI] = ACTIONS(2969),
    [anon_sym_LBRACK] = ACTIONS(2969),
    [anon_sym_COLON] = ACTIONS(2969),
    [anon_sym_COMMA] = ACTIONS(2969),
    [anon_sym_RBRACK] = ACTIONS(2969),
    [anon_sym_LPAREN] = ACTIONS(2969),
    [anon_sym_RPAREN] = ACTIONS(2969),
    [anon_sym_RBRACE] = ACTIONS(2969),
    [anon_sym_LT] = ACTIONS(2967),
    [anon_sym_GT] = ACTIONS(2967),
    [anon_sym_in] = ACTIONS(2967),
    [anon_sym_QMARK] = ACTIONS(2967),
    [anon_sym_BANG] = ACTIONS(2967),
    [anon_sym_PLUS_PLUS] = ACTIONS(2969),
    [anon_sym_DASH_DASH] = ACTIONS(2969),
    [anon_sym_PLUS] = ACTIONS(2967),
    [anon_sym_DASH] = ACTIONS(2967),
    [anon_sym_STAR] = ACTIONS(2969),
    [anon_sym_SLASH] = ACTIONS(2967),
    [anon_sym_PERCENT] = ACTIONS(2969),
    [anon_sym_CARET] = ACTIONS(2969),
    [anon_sym_PIPE] = ACTIONS(2967),
    [anon_sym_AMP] = ACTIONS(2967),
    [anon_sym_LT_LT] = ACTIONS(2969),
    [anon_sym_GT_GT] = ACTIONS(2967),
    [anon_sym_GT_GT_GT] = ACTIONS(2969),
    [anon_sym_EQ_EQ] = ACTIONS(2969),
    [anon_sym_BANG_EQ] = ACTIONS(2969),
    [anon_sym_GT_EQ] = ACTIONS(2969),
    [anon_sym_LT_EQ] = ACTIONS(2969),
    [anon_sym_DOT] = ACTIONS(2967),
    [anon_sym_EQ_GT] = ACTIONS(2969),
    [anon_sym_switch] = ACTIONS(2969),
    [anon_sym_when] = ACTIONS(2969),
    [anon_sym_DOT_DOT] = ACTIONS(2969),
    [anon_sym_and] = ACTIONS(2969),
    [anon_sym_or] = ACTIONS(2969),
    [anon_sym_AMP_AMP] = ACTIONS(2969),
    [anon_sym_PIPE_PIPE] = ACTIONS(2969),
    [anon_sym_QMARK_QMARK] = ACTIONS(2969),
    [anon_sym_into] = ACTIONS(2969),
    [anon_sym_on] = ACTIONS(2969),
    [anon_sym_equals] = ACTIONS(2969),
    [anon_sym_by] = ACTIONS(2969),
    [anon_sym_as] = ACTIONS(2969),
    [anon_sym_is] = ACTIONS(2969),
    [anon_sym_DASH_GT] = ACTIONS(2969),
    [anon_sym_with] = ACTIONS(2969),
    [aux_sym_preproc_if_token3] = ACTIONS(2969),
    [aux_sym_preproc_else_token1] = ACTIONS(2969),
    [aux_sym_preproc_elif_token1] = ACTIONS(2969),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4045] = {
    [sym_preproc_region] = STATE(4045),
    [sym_preproc_endregion] = STATE(4045),
    [sym_preproc_line] = STATE(4045),
    [sym_preproc_pragma] = STATE(4045),
    [sym_preproc_nullable] = STATE(4045),
    [sym_preproc_error] = STATE(4045),
    [sym_preproc_define] = STATE(4045),
    [sym_preproc_undef] = STATE(4045),
    [anon_sym_SEMI] = ACTIONS(2923),
    [anon_sym_LBRACK] = ACTIONS(2923),
    [anon_sym_COLON] = ACTIONS(2923),
    [anon_sym_COMMA] = ACTIONS(2923),
    [anon_sym_RBRACK] = ACTIONS(2923),
    [anon_sym_LPAREN] = ACTIONS(2923),
    [anon_sym_RPAREN] = ACTIONS(2923),
    [anon_sym_RBRACE] = ACTIONS(2923),
    [anon_sym_LT] = ACTIONS(2921),
    [anon_sym_GT] = ACTIONS(2921),
    [anon_sym_in] = ACTIONS(2921),
    [anon_sym_QMARK] = ACTIONS(2921),
    [anon_sym_BANG] = ACTIONS(2921),
    [anon_sym_PLUS_PLUS] = ACTIONS(2923),
    [anon_sym_DASH_DASH] = ACTIONS(2923),
    [anon_sym_PLUS] = ACTIONS(2921),
    [anon_sym_DASH] = ACTIONS(2921),
    [anon_sym_STAR] = ACTIONS(2923),
    [anon_sym_SLASH] = ACTIONS(2921),
    [anon_sym_PERCENT] = ACTIONS(2923),
    [anon_sym_CARET] = ACTIONS(2923),
    [anon_sym_PIPE] = ACTIONS(2921),
    [anon_sym_AMP] = ACTIONS(2921),
    [anon_sym_LT_LT] = ACTIONS(2923),
    [anon_sym_GT_GT] = ACTIONS(2921),
    [anon_sym_GT_GT_GT] = ACTIONS(2923),
    [anon_sym_EQ_EQ] = ACTIONS(2923),
    [anon_sym_BANG_EQ] = ACTIONS(2923),
    [anon_sym_GT_EQ] = ACTIONS(2923),
    [anon_sym_LT_EQ] = ACTIONS(2923),
    [anon_sym_DOT] = ACTIONS(2921),
    [anon_sym_EQ_GT] = ACTIONS(2923),
    [anon_sym_switch] = ACTIONS(2923),
    [anon_sym_when] = ACTIONS(2923),
    [anon_sym_DOT_DOT] = ACTIONS(2923),
    [anon_sym_and] = ACTIONS(2923),
    [anon_sym_or] = ACTIONS(2923),
    [anon_sym_AMP_AMP] = ACTIONS(2923),
    [anon_sym_PIPE_PIPE] = ACTIONS(2923),
    [anon_sym_QMARK_QMARK] = ACTIONS(2923),
    [anon_sym_into] = ACTIONS(2923),
    [anon_sym_on] = ACTIONS(2923),
    [anon_sym_equals] = ACTIONS(2923),
    [anon_sym_by] = ACTIONS(2923),
    [anon_sym_as] = ACTIONS(2923),
    [anon_sym_is] = ACTIONS(2923),
    [anon_sym_DASH_GT] = ACTIONS(2923),
    [anon_sym_with] = ACTIONS(2923),
    [aux_sym_preproc_if_token3] = ACTIONS(2923),
    [aux_sym_preproc_else_token1] = ACTIONS(2923),
    [aux_sym_preproc_elif_token1] = ACTIONS(2923),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4046] = {
    [sym_preproc_region] = STATE(4046),
    [sym_preproc_endregion] = STATE(4046),
    [sym_preproc_line] = STATE(4046),
    [sym_preproc_pragma] = STATE(4046),
    [sym_preproc_nullable] = STATE(4046),
    [sym_preproc_error] = STATE(4046),
    [sym_preproc_define] = STATE(4046),
    [sym_preproc_undef] = STATE(4046),
    [anon_sym_SEMI] = ACTIONS(4068),
    [anon_sym_LBRACK] = ACTIONS(4068),
    [anon_sym_COLON] = ACTIONS(4068),
    [anon_sym_COMMA] = ACTIONS(4068),
    [anon_sym_RBRACK] = ACTIONS(4068),
    [anon_sym_LPAREN] = ACTIONS(4068),
    [anon_sym_RPAREN] = ACTIONS(4068),
    [anon_sym_LBRACE] = ACTIONS(4068),
    [anon_sym_RBRACE] = ACTIONS(4068),
    [anon_sym_LT] = ACTIONS(4066),
    [anon_sym_GT] = ACTIONS(4066),
    [anon_sym_in] = ACTIONS(4068),
    [anon_sym_QMARK] = ACTIONS(4066),
    [anon_sym_BANG] = ACTIONS(4066),
    [anon_sym_PLUS_PLUS] = ACTIONS(4068),
    [anon_sym_DASH_DASH] = ACTIONS(4068),
    [anon_sym_PLUS] = ACTIONS(4066),
    [anon_sym_DASH] = ACTIONS(4066),
    [anon_sym_STAR] = ACTIONS(4068),
    [anon_sym_SLASH] = ACTIONS(4066),
    [anon_sym_PERCENT] = ACTIONS(4068),
    [anon_sym_CARET] = ACTIONS(4068),
    [anon_sym_PIPE] = ACTIONS(4066),
    [anon_sym_AMP] = ACTIONS(4066),
    [anon_sym_LT_LT] = ACTIONS(4068),
    [anon_sym_GT_GT] = ACTIONS(4066),
    [anon_sym_GT_GT_GT] = ACTIONS(4068),
    [anon_sym_EQ_EQ] = ACTIONS(4068),
    [anon_sym_BANG_EQ] = ACTIONS(4068),
    [anon_sym_GT_EQ] = ACTIONS(4068),
    [anon_sym_LT_EQ] = ACTIONS(4068),
    [anon_sym_DOT] = ACTIONS(4066),
    [anon_sym_EQ_GT] = ACTIONS(4068),
    [anon_sym_switch] = ACTIONS(4068),
    [anon_sym_when] = ACTIONS(4068),
    [anon_sym_DOT_DOT] = ACTIONS(4068),
    [anon_sym_and] = ACTIONS(4068),
    [anon_sym_or] = ACTIONS(4068),
    [anon_sym_AMP_AMP] = ACTIONS(4068),
    [anon_sym_PIPE_PIPE] = ACTIONS(4068),
    [anon_sym_QMARK_QMARK] = ACTIONS(4068),
    [anon_sym_on] = ACTIONS(4068),
    [anon_sym_equals] = ACTIONS(4068),
    [anon_sym_by] = ACTIONS(4068),
    [anon_sym_as] = ACTIONS(4068),
    [anon_sym_is] = ACTIONS(4068),
    [anon_sym_DASH_GT] = ACTIONS(4068),
    [anon_sym_with] = ACTIONS(4068),
    [aux_sym_preproc_if_token3] = ACTIONS(4068),
    [aux_sym_preproc_else_token1] = ACTIONS(4068),
    [aux_sym_preproc_elif_token1] = ACTIONS(4068),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4047] = {
    [sym_preproc_region] = STATE(4047),
    [sym_preproc_endregion] = STATE(4047),
    [sym_preproc_line] = STATE(4047),
    [sym_preproc_pragma] = STATE(4047),
    [sym_preproc_nullable] = STATE(4047),
    [sym_preproc_error] = STATE(4047),
    [sym_preproc_define] = STATE(4047),
    [sym_preproc_undef] = STATE(4047),
    [anon_sym_SEMI] = ACTIONS(4076),
    [anon_sym_LBRACK] = ACTIONS(4076),
    [anon_sym_COLON] = ACTIONS(4076),
    [anon_sym_COMMA] = ACTIONS(4076),
    [anon_sym_RBRACK] = ACTIONS(4076),
    [anon_sym_LPAREN] = ACTIONS(4076),
    [anon_sym_RPAREN] = ACTIONS(4076),
    [anon_sym_LBRACE] = ACTIONS(4076),
    [anon_sym_RBRACE] = ACTIONS(4076),
    [anon_sym_LT] = ACTIONS(4074),
    [anon_sym_GT] = ACTIONS(4074),
    [anon_sym_in] = ACTIONS(4076),
    [anon_sym_QMARK] = ACTIONS(4074),
    [anon_sym_BANG] = ACTIONS(4074),
    [anon_sym_PLUS_PLUS] = ACTIONS(4076),
    [anon_sym_DASH_DASH] = ACTIONS(4076),
    [anon_sym_PLUS] = ACTIONS(4074),
    [anon_sym_DASH] = ACTIONS(4074),
    [anon_sym_STAR] = ACTIONS(4076),
    [anon_sym_SLASH] = ACTIONS(4074),
    [anon_sym_PERCENT] = ACTIONS(4076),
    [anon_sym_CARET] = ACTIONS(4076),
    [anon_sym_PIPE] = ACTIONS(4074),
    [anon_sym_AMP] = ACTIONS(4074),
    [anon_sym_LT_LT] = ACTIONS(4076),
    [anon_sym_GT_GT] = ACTIONS(4074),
    [anon_sym_GT_GT_GT] = ACTIONS(4076),
    [anon_sym_EQ_EQ] = ACTIONS(4076),
    [anon_sym_BANG_EQ] = ACTIONS(4076),
    [anon_sym_GT_EQ] = ACTIONS(4076),
    [anon_sym_LT_EQ] = ACTIONS(4076),
    [anon_sym_DOT] = ACTIONS(4074),
    [anon_sym_EQ_GT] = ACTIONS(4076),
    [anon_sym_switch] = ACTIONS(4076),
    [anon_sym_when] = ACTIONS(4076),
    [anon_sym_DOT_DOT] = ACTIONS(4076),
    [anon_sym_and] = ACTIONS(4076),
    [anon_sym_or] = ACTIONS(4076),
    [anon_sym_AMP_AMP] = ACTIONS(4076),
    [anon_sym_PIPE_PIPE] = ACTIONS(4076),
    [anon_sym_QMARK_QMARK] = ACTIONS(4076),
    [anon_sym_on] = ACTIONS(4076),
    [anon_sym_equals] = ACTIONS(4076),
    [anon_sym_by] = ACTIONS(4076),
    [anon_sym_as] = ACTIONS(4076),
    [anon_sym_is] = ACTIONS(4076),
    [anon_sym_DASH_GT] = ACTIONS(4076),
    [anon_sym_with] = ACTIONS(4076),
    [aux_sym_preproc_if_token3] = ACTIONS(4076),
    [aux_sym_preproc_else_token1] = ACTIONS(4076),
    [aux_sym_preproc_elif_token1] = ACTIONS(4076),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4048] = {
    [sym_preproc_region] = STATE(4048),
    [sym_preproc_endregion] = STATE(4048),
    [sym_preproc_line] = STATE(4048),
    [sym_preproc_pragma] = STATE(4048),
    [sym_preproc_nullable] = STATE(4048),
    [sym_preproc_error] = STATE(4048),
    [sym_preproc_define] = STATE(4048),
    [sym_preproc_undef] = STATE(4048),
    [anon_sym_SEMI] = ACTIONS(5586),
    [anon_sym_LBRACK] = ACTIONS(5586),
    [anon_sym_COLON] = ACTIONS(5586),
    [anon_sym_COMMA] = ACTIONS(5586),
    [anon_sym_RBRACK] = ACTIONS(5586),
    [anon_sym_LPAREN] = ACTIONS(5586),
    [anon_sym_RPAREN] = ACTIONS(5586),
    [anon_sym_RBRACE] = ACTIONS(5586),
    [anon_sym_LT] = ACTIONS(5588),
    [anon_sym_GT] = ACTIONS(5588),
    [anon_sym_in] = ACTIONS(5588),
    [anon_sym_QMARK] = ACTIONS(5588),
    [anon_sym_BANG] = ACTIONS(5588),
    [anon_sym_PLUS_PLUS] = ACTIONS(5586),
    [anon_sym_DASH_DASH] = ACTIONS(5586),
    [anon_sym_PLUS] = ACTIONS(5588),
    [anon_sym_DASH] = ACTIONS(5588),
    [anon_sym_STAR] = ACTIONS(5586),
    [anon_sym_SLASH] = ACTIONS(5588),
    [anon_sym_PERCENT] = ACTIONS(5586),
    [anon_sym_CARET] = ACTIONS(5586),
    [anon_sym_PIPE] = ACTIONS(5588),
    [anon_sym_AMP] = ACTIONS(5588),
    [anon_sym_LT_LT] = ACTIONS(5586),
    [anon_sym_GT_GT] = ACTIONS(5588),
    [anon_sym_GT_GT_GT] = ACTIONS(5586),
    [anon_sym_EQ_EQ] = ACTIONS(5586),
    [anon_sym_BANG_EQ] = ACTIONS(5586),
    [anon_sym_GT_EQ] = ACTIONS(5586),
    [anon_sym_LT_EQ] = ACTIONS(5586),
    [anon_sym_DOT] = ACTIONS(5588),
    [anon_sym_EQ_GT] = ACTIONS(5586),
    [anon_sym_switch] = ACTIONS(5586),
    [anon_sym_when] = ACTIONS(5586),
    [anon_sym_DOT_DOT] = ACTIONS(5586),
    [anon_sym_and] = ACTIONS(5586),
    [anon_sym_or] = ACTIONS(5586),
    [anon_sym_AMP_AMP] = ACTIONS(5586),
    [anon_sym_PIPE_PIPE] = ACTIONS(5586),
    [anon_sym_QMARK_QMARK] = ACTIONS(5586),
    [anon_sym_into] = ACTIONS(5586),
    [anon_sym_on] = ACTIONS(5586),
    [anon_sym_equals] = ACTIONS(5586),
    [anon_sym_by] = ACTIONS(5586),
    [anon_sym_as] = ACTIONS(5586),
    [anon_sym_is] = ACTIONS(5586),
    [anon_sym_DASH_GT] = ACTIONS(5586),
    [anon_sym_with] = ACTIONS(5586),
    [aux_sym_preproc_if_token3] = ACTIONS(5586),
    [aux_sym_preproc_else_token1] = ACTIONS(5586),
    [aux_sym_preproc_elif_token1] = ACTIONS(5586),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4049] = {
    [sym_preproc_region] = STATE(4049),
    [sym_preproc_endregion] = STATE(4049),
    [sym_preproc_line] = STATE(4049),
    [sym_preproc_pragma] = STATE(4049),
    [sym_preproc_nullable] = STATE(4049),
    [sym_preproc_error] = STATE(4049),
    [sym_preproc_define] = STATE(4049),
    [sym_preproc_undef] = STATE(4049),
    [anon_sym_SEMI] = ACTIONS(5428),
    [anon_sym_LBRACK] = ACTIONS(5428),
    [anon_sym_COLON] = ACTIONS(5428),
    [anon_sym_COMMA] = ACTIONS(5428),
    [anon_sym_RBRACK] = ACTIONS(5428),
    [anon_sym_LPAREN] = ACTIONS(5428),
    [anon_sym_RPAREN] = ACTIONS(5428),
    [anon_sym_RBRACE] = ACTIONS(5428),
    [anon_sym_LT] = ACTIONS(5430),
    [anon_sym_GT] = ACTIONS(5430),
    [anon_sym_in] = ACTIONS(5430),
    [anon_sym_QMARK] = ACTIONS(5430),
    [anon_sym_BANG] = ACTIONS(5430),
    [anon_sym_PLUS_PLUS] = ACTIONS(5428),
    [anon_sym_DASH_DASH] = ACTIONS(5428),
    [anon_sym_PLUS] = ACTIONS(5430),
    [anon_sym_DASH] = ACTIONS(5430),
    [anon_sym_STAR] = ACTIONS(5428),
    [anon_sym_SLASH] = ACTIONS(5430),
    [anon_sym_PERCENT] = ACTIONS(5428),
    [anon_sym_CARET] = ACTIONS(5428),
    [anon_sym_PIPE] = ACTIONS(5430),
    [anon_sym_AMP] = ACTIONS(5430),
    [anon_sym_LT_LT] = ACTIONS(5428),
    [anon_sym_GT_GT] = ACTIONS(5430),
    [anon_sym_GT_GT_GT] = ACTIONS(5428),
    [anon_sym_EQ_EQ] = ACTIONS(5428),
    [anon_sym_BANG_EQ] = ACTIONS(5428),
    [anon_sym_GT_EQ] = ACTIONS(5428),
    [anon_sym_LT_EQ] = ACTIONS(5428),
    [anon_sym_DOT] = ACTIONS(5430),
    [anon_sym_EQ_GT] = ACTIONS(5428),
    [anon_sym_switch] = ACTIONS(5428),
    [anon_sym_when] = ACTIONS(5428),
    [anon_sym_DOT_DOT] = ACTIONS(5428),
    [anon_sym_and] = ACTIONS(5428),
    [anon_sym_or] = ACTIONS(5428),
    [anon_sym_AMP_AMP] = ACTIONS(5428),
    [anon_sym_PIPE_PIPE] = ACTIONS(5428),
    [anon_sym_QMARK_QMARK] = ACTIONS(5428),
    [anon_sym_into] = ACTIONS(5428),
    [anon_sym_on] = ACTIONS(5428),
    [anon_sym_equals] = ACTIONS(5428),
    [anon_sym_by] = ACTIONS(5428),
    [anon_sym_as] = ACTIONS(5428),
    [anon_sym_is] = ACTIONS(5428),
    [anon_sym_DASH_GT] = ACTIONS(5428),
    [anon_sym_with] = ACTIONS(5428),
    [aux_sym_preproc_if_token3] = ACTIONS(5428),
    [aux_sym_preproc_else_token1] = ACTIONS(5428),
    [aux_sym_preproc_elif_token1] = ACTIONS(5428),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4050] = {
    [sym_preproc_region] = STATE(4050),
    [sym_preproc_endregion] = STATE(4050),
    [sym_preproc_line] = STATE(4050),
    [sym_preproc_pragma] = STATE(4050),
    [sym_preproc_nullable] = STATE(4050),
    [sym_preproc_error] = STATE(4050),
    [sym_preproc_define] = STATE(4050),
    [sym_preproc_undef] = STATE(4050),
    [anon_sym_SEMI] = ACTIONS(5325),
    [anon_sym_LBRACK] = ACTIONS(5325),
    [anon_sym_COLON] = ACTIONS(5325),
    [anon_sym_COMMA] = ACTIONS(5325),
    [anon_sym_RBRACK] = ACTIONS(5325),
    [anon_sym_LPAREN] = ACTIONS(5325),
    [anon_sym_RPAREN] = ACTIONS(5325),
    [anon_sym_RBRACE] = ACTIONS(5325),
    [anon_sym_LT] = ACTIONS(5327),
    [anon_sym_GT] = ACTIONS(5327),
    [anon_sym_in] = ACTIONS(5327),
    [anon_sym_QMARK] = ACTIONS(5327),
    [anon_sym_BANG] = ACTIONS(5327),
    [anon_sym_PLUS_PLUS] = ACTIONS(5325),
    [anon_sym_DASH_DASH] = ACTIONS(5325),
    [anon_sym_PLUS] = ACTIONS(5327),
    [anon_sym_DASH] = ACTIONS(5327),
    [anon_sym_STAR] = ACTIONS(5325),
    [anon_sym_SLASH] = ACTIONS(5327),
    [anon_sym_PERCENT] = ACTIONS(5325),
    [anon_sym_CARET] = ACTIONS(5325),
    [anon_sym_PIPE] = ACTIONS(5327),
    [anon_sym_AMP] = ACTIONS(5327),
    [anon_sym_LT_LT] = ACTIONS(5325),
    [anon_sym_GT_GT] = ACTIONS(5327),
    [anon_sym_GT_GT_GT] = ACTIONS(5325),
    [anon_sym_EQ_EQ] = ACTIONS(5325),
    [anon_sym_BANG_EQ] = ACTIONS(5325),
    [anon_sym_GT_EQ] = ACTIONS(5325),
    [anon_sym_LT_EQ] = ACTIONS(5325),
    [anon_sym_DOT] = ACTIONS(5327),
    [anon_sym_EQ_GT] = ACTIONS(5325),
    [anon_sym_switch] = ACTIONS(5325),
    [anon_sym_when] = ACTIONS(5325),
    [anon_sym_DOT_DOT] = ACTIONS(5325),
    [anon_sym_and] = ACTIONS(5325),
    [anon_sym_or] = ACTIONS(5325),
    [anon_sym_AMP_AMP] = ACTIONS(5325),
    [anon_sym_PIPE_PIPE] = ACTIONS(5325),
    [anon_sym_QMARK_QMARK] = ACTIONS(5325),
    [anon_sym_into] = ACTIONS(5325),
    [anon_sym_on] = ACTIONS(5325),
    [anon_sym_equals] = ACTIONS(5325),
    [anon_sym_by] = ACTIONS(5325),
    [anon_sym_as] = ACTIONS(5325),
    [anon_sym_is] = ACTIONS(5325),
    [anon_sym_DASH_GT] = ACTIONS(5325),
    [anon_sym_with] = ACTIONS(5325),
    [aux_sym_preproc_if_token3] = ACTIONS(5325),
    [aux_sym_preproc_else_token1] = ACTIONS(5325),
    [aux_sym_preproc_elif_token1] = ACTIONS(5325),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4051] = {
    [sym_preproc_region] = STATE(4051),
    [sym_preproc_endregion] = STATE(4051),
    [sym_preproc_line] = STATE(4051),
    [sym_preproc_pragma] = STATE(4051),
    [sym_preproc_nullable] = STATE(4051),
    [sym_preproc_error] = STATE(4051),
    [sym_preproc_define] = STATE(4051),
    [sym_preproc_undef] = STATE(4051),
    [anon_sym_SEMI] = ACTIONS(5858),
    [anon_sym_LBRACK] = ACTIONS(5858),
    [anon_sym_COLON] = ACTIONS(5858),
    [anon_sym_COMMA] = ACTIONS(5858),
    [anon_sym_RBRACK] = ACTIONS(5858),
    [anon_sym_LPAREN] = ACTIONS(5858),
    [anon_sym_RPAREN] = ACTIONS(5858),
    [anon_sym_RBRACE] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5860),
    [anon_sym_GT] = ACTIONS(5860),
    [anon_sym_in] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_BANG] = ACTIONS(5860),
    [anon_sym_PLUS_PLUS] = ACTIONS(5858),
    [anon_sym_DASH_DASH] = ACTIONS(5858),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_DASH] = ACTIONS(5860),
    [anon_sym_STAR] = ACTIONS(5858),
    [anon_sym_SLASH] = ACTIONS(5860),
    [anon_sym_PERCENT] = ACTIONS(5858),
    [anon_sym_CARET] = ACTIONS(5858),
    [anon_sym_PIPE] = ACTIONS(5860),
    [anon_sym_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5858),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_GT_GT_GT] = ACTIONS(5858),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5858),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_DOT] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5858),
    [anon_sym_switch] = ACTIONS(5858),
    [anon_sym_when] = ACTIONS(5858),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_and] = ACTIONS(5858),
    [anon_sym_or] = ACTIONS(5858),
    [anon_sym_AMP_AMP] = ACTIONS(5858),
    [anon_sym_PIPE_PIPE] = ACTIONS(5858),
    [anon_sym_QMARK_QMARK] = ACTIONS(5858),
    [anon_sym_into] = ACTIONS(5858),
    [anon_sym_on] = ACTIONS(5858),
    [anon_sym_equals] = ACTIONS(5858),
    [anon_sym_by] = ACTIONS(5858),
    [anon_sym_as] = ACTIONS(5858),
    [anon_sym_is] = ACTIONS(5858),
    [anon_sym_DASH_GT] = ACTIONS(5858),
    [anon_sym_with] = ACTIONS(5858),
    [aux_sym_preproc_if_token3] = ACTIONS(5858),
    [aux_sym_preproc_else_token1] = ACTIONS(5858),
    [aux_sym_preproc_elif_token1] = ACTIONS(5858),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4052] = {
    [sym_preproc_region] = STATE(4052),
    [sym_preproc_endregion] = STATE(4052),
    [sym_preproc_line] = STATE(4052),
    [sym_preproc_pragma] = STATE(4052),
    [sym_preproc_nullable] = STATE(4052),
    [sym_preproc_error] = STATE(4052),
    [sym_preproc_define] = STATE(4052),
    [sym_preproc_undef] = STATE(4052),
    [anon_sym_SEMI] = ACTIONS(5582),
    [anon_sym_LBRACK] = ACTIONS(5582),
    [anon_sym_COLON] = ACTIONS(5582),
    [anon_sym_COMMA] = ACTIONS(5582),
    [anon_sym_RBRACK] = ACTIONS(5582),
    [anon_sym_LPAREN] = ACTIONS(5582),
    [anon_sym_RPAREN] = ACTIONS(5582),
    [anon_sym_RBRACE] = ACTIONS(5582),
    [anon_sym_LT] = ACTIONS(5584),
    [anon_sym_GT] = ACTIONS(5584),
    [anon_sym_in] = ACTIONS(5584),
    [anon_sym_QMARK] = ACTIONS(5584),
    [anon_sym_BANG] = ACTIONS(5584),
    [anon_sym_PLUS_PLUS] = ACTIONS(5582),
    [anon_sym_DASH_DASH] = ACTIONS(5582),
    [anon_sym_PLUS] = ACTIONS(5584),
    [anon_sym_DASH] = ACTIONS(5584),
    [anon_sym_STAR] = ACTIONS(5582),
    [anon_sym_SLASH] = ACTIONS(5584),
    [anon_sym_PERCENT] = ACTIONS(5582),
    [anon_sym_CARET] = ACTIONS(5582),
    [anon_sym_PIPE] = ACTIONS(5584),
    [anon_sym_AMP] = ACTIONS(5584),
    [anon_sym_LT_LT] = ACTIONS(5582),
    [anon_sym_GT_GT] = ACTIONS(5584),
    [anon_sym_GT_GT_GT] = ACTIONS(5582),
    [anon_sym_EQ_EQ] = ACTIONS(5582),
    [anon_sym_BANG_EQ] = ACTIONS(5582),
    [anon_sym_GT_EQ] = ACTIONS(5582),
    [anon_sym_LT_EQ] = ACTIONS(5582),
    [anon_sym_DOT] = ACTIONS(5584),
    [anon_sym_EQ_GT] = ACTIONS(5582),
    [anon_sym_switch] = ACTIONS(5582),
    [anon_sym_when] = ACTIONS(5582),
    [anon_sym_DOT_DOT] = ACTIONS(5582),
    [anon_sym_and] = ACTIONS(5582),
    [anon_sym_or] = ACTIONS(5582),
    [anon_sym_AMP_AMP] = ACTIONS(5582),
    [anon_sym_PIPE_PIPE] = ACTIONS(5582),
    [anon_sym_QMARK_QMARK] = ACTIONS(5582),
    [anon_sym_into] = ACTIONS(5582),
    [anon_sym_on] = ACTIONS(5582),
    [anon_sym_equals] = ACTIONS(5582),
    [anon_sym_by] = ACTIONS(5582),
    [anon_sym_as] = ACTIONS(5582),
    [anon_sym_is] = ACTIONS(5582),
    [anon_sym_DASH_GT] = ACTIONS(5582),
    [anon_sym_with] = ACTIONS(5582),
    [aux_sym_preproc_if_token3] = ACTIONS(5582),
    [aux_sym_preproc_else_token1] = ACTIONS(5582),
    [aux_sym_preproc_elif_token1] = ACTIONS(5582),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4053] = {
    [sym_preproc_region] = STATE(4053),
    [sym_preproc_endregion] = STATE(4053),
    [sym_preproc_line] = STATE(4053),
    [sym_preproc_pragma] = STATE(4053),
    [sym_preproc_nullable] = STATE(4053),
    [sym_preproc_error] = STATE(4053),
    [sym_preproc_define] = STATE(4053),
    [sym_preproc_undef] = STATE(4053),
    [anon_sym_SEMI] = ACTIONS(5862),
    [anon_sym_LBRACK] = ACTIONS(5862),
    [anon_sym_COLON] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5862),
    [anon_sym_RBRACK] = ACTIONS(5862),
    [anon_sym_LPAREN] = ACTIONS(5862),
    [anon_sym_RPAREN] = ACTIONS(5862),
    [anon_sym_RBRACE] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5864),
    [anon_sym_GT] = ACTIONS(5864),
    [anon_sym_in] = ACTIONS(5864),
    [anon_sym_QMARK] = ACTIONS(5864),
    [anon_sym_BANG] = ACTIONS(5864),
    [anon_sym_PLUS_PLUS] = ACTIONS(5862),
    [anon_sym_DASH_DASH] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(5864),
    [anon_sym_DASH] = ACTIONS(5864),
    [anon_sym_STAR] = ACTIONS(5862),
    [anon_sym_SLASH] = ACTIONS(5864),
    [anon_sym_PERCENT] = ACTIONS(5862),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PIPE] = ACTIONS(5864),
    [anon_sym_AMP] = ACTIONS(5864),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5864),
    [anon_sym_GT_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5862),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_DOT] = ACTIONS(5864),
    [anon_sym_EQ_GT] = ACTIONS(5862),
    [anon_sym_switch] = ACTIONS(5862),
    [anon_sym_when] = ACTIONS(5862),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_and] = ACTIONS(5862),
    [anon_sym_or] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_QMARK_QMARK] = ACTIONS(5862),
    [anon_sym_into] = ACTIONS(5862),
    [anon_sym_on] = ACTIONS(5862),
    [anon_sym_equals] = ACTIONS(5862),
    [anon_sym_by] = ACTIONS(5862),
    [anon_sym_as] = ACTIONS(5862),
    [anon_sym_is] = ACTIONS(5862),
    [anon_sym_DASH_GT] = ACTIONS(5862),
    [anon_sym_with] = ACTIONS(5862),
    [aux_sym_preproc_if_token3] = ACTIONS(5862),
    [aux_sym_preproc_else_token1] = ACTIONS(5862),
    [aux_sym_preproc_elif_token1] = ACTIONS(5862),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4054] = {
    [sym_preproc_region] = STATE(4054),
    [sym_preproc_endregion] = STATE(4054),
    [sym_preproc_line] = STATE(4054),
    [sym_preproc_pragma] = STATE(4054),
    [sym_preproc_nullable] = STATE(4054),
    [sym_preproc_error] = STATE(4054),
    [sym_preproc_define] = STATE(4054),
    [sym_preproc_undef] = STATE(4054),
    [anon_sym_EQ] = ACTIONS(5866),
    [anon_sym_LBRACK] = ACTIONS(5249),
    [anon_sym_COLON] = ACTIONS(5249),
    [anon_sym_COMMA] = ACTIONS(5249),
    [anon_sym_LPAREN] = ACTIONS(5249),
    [anon_sym_LT] = ACTIONS(5251),
    [anon_sym_GT] = ACTIONS(5251),
    [anon_sym_QMARK] = ACTIONS(5251),
    [anon_sym_BANG] = ACTIONS(5251),
    [anon_sym_PLUS_PLUS] = ACTIONS(5249),
    [anon_sym_DASH_DASH] = ACTIONS(5249),
    [anon_sym_PLUS] = ACTIONS(5251),
    [anon_sym_DASH] = ACTIONS(5251),
    [anon_sym_STAR] = ACTIONS(5251),
    [anon_sym_SLASH] = ACTIONS(5251),
    [anon_sym_PERCENT] = ACTIONS(5251),
    [anon_sym_CARET] = ACTIONS(5251),
    [anon_sym_PIPE] = ACTIONS(5251),
    [anon_sym_AMP] = ACTIONS(5251),
    [anon_sym_LT_LT] = ACTIONS(5251),
    [anon_sym_GT_GT] = ACTIONS(5251),
    [anon_sym_GT_GT_GT] = ACTIONS(5251),
    [anon_sym_EQ_EQ] = ACTIONS(5249),
    [anon_sym_BANG_EQ] = ACTIONS(5249),
    [anon_sym_GT_EQ] = ACTIONS(5249),
    [anon_sym_LT_EQ] = ACTIONS(5249),
    [anon_sym_DOT] = ACTIONS(5251),
    [anon_sym_switch] = ACTIONS(5249),
    [anon_sym_DOT_DOT] = ACTIONS(5249),
    [anon_sym_and] = ACTIONS(5249),
    [anon_sym_or] = ACTIONS(5249),
    [anon_sym_PLUS_EQ] = ACTIONS(5868),
    [anon_sym_DASH_EQ] = ACTIONS(5868),
    [anon_sym_STAR_EQ] = ACTIONS(5868),
    [anon_sym_SLASH_EQ] = ACTIONS(5868),
    [anon_sym_PERCENT_EQ] = ACTIONS(5868),
    [anon_sym_AMP_EQ] = ACTIONS(5868),
    [anon_sym_CARET_EQ] = ACTIONS(5868),
    [anon_sym_PIPE_EQ] = ACTIONS(5868),
    [anon_sym_LT_LT_EQ] = ACTIONS(5868),
    [anon_sym_GT_GT_EQ] = ACTIONS(5868),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5868),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(5868),
    [anon_sym_AMP_AMP] = ACTIONS(5249),
    [anon_sym_PIPE_PIPE] = ACTIONS(5249),
    [anon_sym_QMARK_QMARK] = ACTIONS(5251),
    [anon_sym_as] = ACTIONS(5249),
    [anon_sym_is] = ACTIONS(5249),
    [anon_sym_DASH_GT] = ACTIONS(5249),
    [anon_sym_with] = ACTIONS(5249),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(5249),
  },
  [4055] = {
    [sym_preproc_region] = STATE(4055),
    [sym_preproc_endregion] = STATE(4055),
    [sym_preproc_line] = STATE(4055),
    [sym_preproc_pragma] = STATE(4055),
    [sym_preproc_nullable] = STATE(4055),
    [sym_preproc_error] = STATE(4055),
    [sym_preproc_define] = STATE(4055),
    [sym_preproc_undef] = STATE(4055),
    [anon_sym_SEMI] = ACTIONS(4247),
    [anon_sym_LBRACK] = ACTIONS(4247),
    [anon_sym_COLON] = ACTIONS(4247),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_RBRACK] = ACTIONS(4247),
    [anon_sym_LPAREN] = ACTIONS(4247),
    [anon_sym_RPAREN] = ACTIONS(4247),
    [anon_sym_RBRACE] = ACTIONS(4247),
    [anon_sym_LT] = ACTIONS(5832),
    [anon_sym_GT] = ACTIONS(5832),
    [anon_sym_in] = ACTIONS(5832),
    [anon_sym_QMARK] = ACTIONS(5832),
    [anon_sym_BANG] = ACTIONS(5832),
    [anon_sym_PLUS_PLUS] = ACTIONS(4247),
    [anon_sym_DASH_DASH] = ACTIONS(4247),
    [anon_sym_PLUS] = ACTIONS(5832),
    [anon_sym_DASH] = ACTIONS(5832),
    [anon_sym_STAR] = ACTIONS(4247),
    [anon_sym_SLASH] = ACTIONS(5832),
    [anon_sym_PERCENT] = ACTIONS(4247),
    [anon_sym_CARET] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(5832),
    [anon_sym_AMP] = ACTIONS(5832),
    [anon_sym_LT_LT] = ACTIONS(4247),
    [anon_sym_GT_GT] = ACTIONS(5832),
    [anon_sym_GT_GT_GT] = ACTIONS(4247),
    [anon_sym_EQ_EQ] = ACTIONS(4247),
    [anon_sym_BANG_EQ] = ACTIONS(4247),
    [anon_sym_GT_EQ] = ACTIONS(4247),
    [anon_sym_LT_EQ] = ACTIONS(4247),
    [anon_sym_DOT] = ACTIONS(5832),
    [anon_sym_EQ_GT] = ACTIONS(4081),
    [anon_sym_switch] = ACTIONS(4247),
    [anon_sym_when] = ACTIONS(4247),
    [anon_sym_DOT_DOT] = ACTIONS(4247),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_AMP_AMP] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(4247),
    [anon_sym_QMARK_QMARK] = ACTIONS(4247),
    [anon_sym_into] = ACTIONS(4247),
    [anon_sym_on] = ACTIONS(4247),
    [anon_sym_equals] = ACTIONS(4247),
    [anon_sym_by] = ACTIONS(4247),
    [anon_sym_as] = ACTIONS(4247),
    [anon_sym_is] = ACTIONS(4247),
    [anon_sym_DASH_GT] = ACTIONS(4247),
    [anon_sym_with] = ACTIONS(4247),
    [aux_sym_preproc_if_token3] = ACTIONS(4247),
    [aux_sym_preproc_else_token1] = ACTIONS(4247),
    [aux_sym_preproc_elif_token1] = ACTIONS(4247),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4056] = {
    [sym_preproc_region] = STATE(4056),
    [sym_preproc_endregion] = STATE(4056),
    [sym_preproc_line] = STATE(4056),
    [sym_preproc_pragma] = STATE(4056),
    [sym_preproc_nullable] = STATE(4056),
    [sym_preproc_error] = STATE(4056),
    [sym_preproc_define] = STATE(4056),
    [sym_preproc_undef] = STATE(4056),
    [anon_sym_SEMI] = ACTIONS(5870),
    [anon_sym_LBRACK] = ACTIONS(5870),
    [anon_sym_COLON] = ACTIONS(5870),
    [anon_sym_COMMA] = ACTIONS(5870),
    [anon_sym_RBRACK] = ACTIONS(5870),
    [anon_sym_LPAREN] = ACTIONS(5870),
    [anon_sym_RPAREN] = ACTIONS(5870),
    [anon_sym_RBRACE] = ACTIONS(5870),
    [anon_sym_LT] = ACTIONS(5872),
    [anon_sym_GT] = ACTIONS(5872),
    [anon_sym_in] = ACTIONS(5872),
    [anon_sym_QMARK] = ACTIONS(5872),
    [anon_sym_BANG] = ACTIONS(5872),
    [anon_sym_PLUS_PLUS] = ACTIONS(5870),
    [anon_sym_DASH_DASH] = ACTIONS(5870),
    [anon_sym_PLUS] = ACTIONS(5872),
    [anon_sym_DASH] = ACTIONS(5872),
    [anon_sym_STAR] = ACTIONS(5870),
    [anon_sym_SLASH] = ACTIONS(5872),
    [anon_sym_PERCENT] = ACTIONS(5870),
    [anon_sym_CARET] = ACTIONS(5870),
    [anon_sym_PIPE] = ACTIONS(5872),
    [anon_sym_AMP] = ACTIONS(5872),
    [anon_sym_LT_LT] = ACTIONS(5870),
    [anon_sym_GT_GT] = ACTIONS(5872),
    [anon_sym_GT_GT_GT] = ACTIONS(5870),
    [anon_sym_EQ_EQ] = ACTIONS(5870),
    [anon_sym_BANG_EQ] = ACTIONS(5870),
    [anon_sym_GT_EQ] = ACTIONS(5870),
    [anon_sym_LT_EQ] = ACTIONS(5870),
    [anon_sym_DOT] = ACTIONS(5872),
    [anon_sym_EQ_GT] = ACTIONS(5870),
    [anon_sym_switch] = ACTIONS(5870),
    [anon_sym_when] = ACTIONS(5870),
    [anon_sym_DOT_DOT] = ACTIONS(5870),
    [anon_sym_and] = ACTIONS(5870),
    [anon_sym_or] = ACTIONS(5870),
    [anon_sym_AMP_AMP] = ACTIONS(5870),
    [anon_sym_PIPE_PIPE] = ACTIONS(5870),
    [anon_sym_QMARK_QMARK] = ACTIONS(5870),
    [anon_sym_into] = ACTIONS(5870),
    [anon_sym_on] = ACTIONS(5870),
    [anon_sym_equals] = ACTIONS(5870),
    [anon_sym_by] = ACTIONS(5870),
    [anon_sym_as] = ACTIONS(5870),
    [anon_sym_is] = ACTIONS(5870),
    [anon_sym_DASH_GT] = ACTIONS(5870),
    [anon_sym_with] = ACTIONS(5870),
    [aux_sym_preproc_if_token3] = ACTIONS(5870),
    [aux_sym_preproc_else_token1] = ACTIONS(5870),
    [aux_sym_preproc_elif_token1] = ACTIONS(5870),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4057] = {
    [sym_preproc_region] = STATE(4057),
    [sym_preproc_endregion] = STATE(4057),
    [sym_preproc_line] = STATE(4057),
    [sym_preproc_pragma] = STATE(4057),
    [sym_preproc_nullable] = STATE(4057),
    [sym_preproc_error] = STATE(4057),
    [sym_preproc_define] = STATE(4057),
    [sym_preproc_undef] = STATE(4057),
    [anon_sym_SEMI] = ACTIONS(5767),
    [anon_sym_LBRACK] = ACTIONS(5767),
    [anon_sym_COLON] = ACTIONS(5767),
    [anon_sym_COMMA] = ACTIONS(5767),
    [anon_sym_RBRACK] = ACTIONS(5767),
    [anon_sym_LPAREN] = ACTIONS(5767),
    [anon_sym_RPAREN] = ACTIONS(5767),
    [anon_sym_RBRACE] = ACTIONS(5767),
    [anon_sym_LT] = ACTIONS(5769),
    [anon_sym_GT] = ACTIONS(5769),
    [anon_sym_in] = ACTIONS(5769),
    [anon_sym_QMARK] = ACTIONS(5769),
    [anon_sym_BANG] = ACTIONS(5769),
    [anon_sym_PLUS_PLUS] = ACTIONS(5767),
    [anon_sym_DASH_DASH] = ACTIONS(5767),
    [anon_sym_PLUS] = ACTIONS(5769),
    [anon_sym_DASH] = ACTIONS(5769),
    [anon_sym_STAR] = ACTIONS(5767),
    [anon_sym_SLASH] = ACTIONS(5769),
    [anon_sym_PERCENT] = ACTIONS(5767),
    [anon_sym_CARET] = ACTIONS(5767),
    [anon_sym_PIPE] = ACTIONS(5769),
    [anon_sym_AMP] = ACTIONS(5769),
    [anon_sym_LT_LT] = ACTIONS(5767),
    [anon_sym_GT_GT] = ACTIONS(5769),
    [anon_sym_GT_GT_GT] = ACTIONS(5767),
    [anon_sym_EQ_EQ] = ACTIONS(5767),
    [anon_sym_BANG_EQ] = ACTIONS(5767),
    [anon_sym_GT_EQ] = ACTIONS(5767),
    [anon_sym_LT_EQ] = ACTIONS(5767),
    [anon_sym_DOT] = ACTIONS(5769),
    [anon_sym_EQ_GT] = ACTIONS(5767),
    [anon_sym_switch] = ACTIONS(5767),
    [anon_sym_when] = ACTIONS(5767),
    [anon_sym_DOT_DOT] = ACTIONS(5767),
    [anon_sym_and] = ACTIONS(5767),
    [anon_sym_or] = ACTIONS(5767),
    [anon_sym_AMP_AMP] = ACTIONS(5767),
    [anon_sym_PIPE_PIPE] = ACTIONS(5767),
    [anon_sym_QMARK_QMARK] = ACTIONS(5767),
    [anon_sym_into] = ACTIONS(5767),
    [anon_sym_on] = ACTIONS(5767),
    [anon_sym_equals] = ACTIONS(5767),
    [anon_sym_by] = ACTIONS(5767),
    [anon_sym_as] = ACTIONS(5767),
    [anon_sym_is] = ACTIONS(5767),
    [anon_sym_DASH_GT] = ACTIONS(5767),
    [anon_sym_with] = ACTIONS(5767),
    [aux_sym_preproc_if_token3] = ACTIONS(5767),
    [aux_sym_preproc_else_token1] = ACTIONS(5767),
    [aux_sym_preproc_elif_token1] = ACTIONS(5767),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4058] = {
    [sym_preproc_region] = STATE(4058),
    [sym_preproc_endregion] = STATE(4058),
    [sym_preproc_line] = STATE(4058),
    [sym_preproc_pragma] = STATE(4058),
    [sym_preproc_nullable] = STATE(4058),
    [sym_preproc_error] = STATE(4058),
    [sym_preproc_define] = STATE(4058),
    [sym_preproc_undef] = STATE(4058),
    [anon_sym_SEMI] = ACTIONS(5526),
    [anon_sym_LBRACK] = ACTIONS(5526),
    [anon_sym_COLON] = ACTIONS(5526),
    [anon_sym_COMMA] = ACTIONS(5526),
    [anon_sym_RBRACK] = ACTIONS(5526),
    [anon_sym_LPAREN] = ACTIONS(5526),
    [anon_sym_RPAREN] = ACTIONS(5526),
    [anon_sym_RBRACE] = ACTIONS(5526),
    [anon_sym_LT] = ACTIONS(5528),
    [anon_sym_GT] = ACTIONS(5528),
    [anon_sym_in] = ACTIONS(5528),
    [anon_sym_QMARK] = ACTIONS(5528),
    [anon_sym_BANG] = ACTIONS(5528),
    [anon_sym_PLUS_PLUS] = ACTIONS(5526),
    [anon_sym_DASH_DASH] = ACTIONS(5526),
    [anon_sym_PLUS] = ACTIONS(5528),
    [anon_sym_DASH] = ACTIONS(5528),
    [anon_sym_STAR] = ACTIONS(5526),
    [anon_sym_SLASH] = ACTIONS(5528),
    [anon_sym_PERCENT] = ACTIONS(5526),
    [anon_sym_CARET] = ACTIONS(5526),
    [anon_sym_PIPE] = ACTIONS(5528),
    [anon_sym_AMP] = ACTIONS(5528),
    [anon_sym_LT_LT] = ACTIONS(5526),
    [anon_sym_GT_GT] = ACTIONS(5528),
    [anon_sym_GT_GT_GT] = ACTIONS(5526),
    [anon_sym_EQ_EQ] = ACTIONS(5526),
    [anon_sym_BANG_EQ] = ACTIONS(5526),
    [anon_sym_GT_EQ] = ACTIONS(5526),
    [anon_sym_LT_EQ] = ACTIONS(5526),
    [anon_sym_DOT] = ACTIONS(5528),
    [anon_sym_EQ_GT] = ACTIONS(5526),
    [anon_sym_switch] = ACTIONS(5526),
    [anon_sym_when] = ACTIONS(5526),
    [anon_sym_DOT_DOT] = ACTIONS(5526),
    [anon_sym_and] = ACTIONS(5526),
    [anon_sym_or] = ACTIONS(5526),
    [anon_sym_AMP_AMP] = ACTIONS(5526),
    [anon_sym_PIPE_PIPE] = ACTIONS(5526),
    [anon_sym_QMARK_QMARK] = ACTIONS(5526),
    [anon_sym_into] = ACTIONS(5526),
    [anon_sym_on] = ACTIONS(5526),
    [anon_sym_equals] = ACTIONS(5526),
    [anon_sym_by] = ACTIONS(5526),
    [anon_sym_as] = ACTIONS(5526),
    [anon_sym_is] = ACTIONS(5526),
    [anon_sym_DASH_GT] = ACTIONS(5526),
    [anon_sym_with] = ACTIONS(5526),
    [aux_sym_preproc_if_token3] = ACTIONS(5526),
    [aux_sym_preproc_else_token1] = ACTIONS(5526),
    [aux_sym_preproc_elif_token1] = ACTIONS(5526),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4059] = {
    [sym_preproc_region] = STATE(4059),
    [sym_preproc_endregion] = STATE(4059),
    [sym_preproc_line] = STATE(4059),
    [sym_preproc_pragma] = STATE(4059),
    [sym_preproc_nullable] = STATE(4059),
    [sym_preproc_error] = STATE(4059),
    [sym_preproc_define] = STATE(4059),
    [sym_preproc_undef] = STATE(4059),
    [anon_sym_SEMI] = ACTIONS(5874),
    [anon_sym_LBRACK] = ACTIONS(5874),
    [anon_sym_COLON] = ACTIONS(5874),
    [anon_sym_COMMA] = ACTIONS(5874),
    [anon_sym_RBRACK] = ACTIONS(5874),
    [anon_sym_LPAREN] = ACTIONS(5874),
    [anon_sym_RPAREN] = ACTIONS(5874),
    [anon_sym_RBRACE] = ACTIONS(5874),
    [anon_sym_LT] = ACTIONS(5876),
    [anon_sym_GT] = ACTIONS(5876),
    [anon_sym_in] = ACTIONS(5876),
    [anon_sym_QMARK] = ACTIONS(5876),
    [anon_sym_BANG] = ACTIONS(5876),
    [anon_sym_PLUS_PLUS] = ACTIONS(5874),
    [anon_sym_DASH_DASH] = ACTIONS(5874),
    [anon_sym_PLUS] = ACTIONS(5876),
    [anon_sym_DASH] = ACTIONS(5876),
    [anon_sym_STAR] = ACTIONS(5874),
    [anon_sym_SLASH] = ACTIONS(5876),
    [anon_sym_PERCENT] = ACTIONS(5874),
    [anon_sym_CARET] = ACTIONS(5874),
    [anon_sym_PIPE] = ACTIONS(5876),
    [anon_sym_AMP] = ACTIONS(5876),
    [anon_sym_LT_LT] = ACTIONS(5874),
    [anon_sym_GT_GT] = ACTIONS(5876),
    [anon_sym_GT_GT_GT] = ACTIONS(5874),
    [anon_sym_EQ_EQ] = ACTIONS(5874),
    [anon_sym_BANG_EQ] = ACTIONS(5874),
    [anon_sym_GT_EQ] = ACTIONS(5874),
    [anon_sym_LT_EQ] = ACTIONS(5874),
    [anon_sym_DOT] = ACTIONS(5876),
    [anon_sym_EQ_GT] = ACTIONS(5874),
    [anon_sym_switch] = ACTIONS(5874),
    [anon_sym_when] = ACTIONS(5874),
    [anon_sym_DOT_DOT] = ACTIONS(5874),
    [anon_sym_and] = ACTIONS(5874),
    [anon_sym_or] = ACTIONS(5874),
    [anon_sym_AMP_AMP] = ACTIONS(5874),
    [anon_sym_PIPE_PIPE] = ACTIONS(5874),
    [anon_sym_QMARK_QMARK] = ACTIONS(5874),
    [anon_sym_into] = ACTIONS(5874),
    [anon_sym_on] = ACTIONS(5874),
    [anon_sym_equals] = ACTIONS(5874),
    [anon_sym_by] = ACTIONS(5874),
    [anon_sym_as] = ACTIONS(5874),
    [anon_sym_is] = ACTIONS(5874),
    [anon_sym_DASH_GT] = ACTIONS(5874),
    [anon_sym_with] = ACTIONS(5874),
    [aux_sym_preproc_if_token3] = ACTIONS(5874),
    [aux_sym_preproc_else_token1] = ACTIONS(5874),
    [aux_sym_preproc_elif_token1] = ACTIONS(5874),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4060] = {
    [sym_preproc_region] = STATE(4060),
    [sym_preproc_endregion] = STATE(4060),
    [sym_preproc_line] = STATE(4060),
    [sym_preproc_pragma] = STATE(4060),
    [sym_preproc_nullable] = STATE(4060),
    [sym_preproc_error] = STATE(4060),
    [sym_preproc_define] = STATE(4060),
    [sym_preproc_undef] = STATE(4060),
    [anon_sym_SEMI] = ACTIONS(5432),
    [anon_sym_LBRACK] = ACTIONS(5432),
    [anon_sym_COLON] = ACTIONS(5432),
    [anon_sym_COMMA] = ACTIONS(5432),
    [anon_sym_RBRACK] = ACTIONS(5432),
    [anon_sym_LPAREN] = ACTIONS(5432),
    [anon_sym_RPAREN] = ACTIONS(5432),
    [anon_sym_RBRACE] = ACTIONS(5432),
    [anon_sym_LT] = ACTIONS(5434),
    [anon_sym_GT] = ACTIONS(5434),
    [anon_sym_in] = ACTIONS(5434),
    [anon_sym_QMARK] = ACTIONS(5434),
    [anon_sym_BANG] = ACTIONS(5434),
    [anon_sym_PLUS_PLUS] = ACTIONS(5432),
    [anon_sym_DASH_DASH] = ACTIONS(5432),
    [anon_sym_PLUS] = ACTIONS(5434),
    [anon_sym_DASH] = ACTIONS(5434),
    [anon_sym_STAR] = ACTIONS(5432),
    [anon_sym_SLASH] = ACTIONS(5434),
    [anon_sym_PERCENT] = ACTIONS(5432),
    [anon_sym_CARET] = ACTIONS(5432),
    [anon_sym_PIPE] = ACTIONS(5434),
    [anon_sym_AMP] = ACTIONS(5434),
    [anon_sym_LT_LT] = ACTIONS(5432),
    [anon_sym_GT_GT] = ACTIONS(5434),
    [anon_sym_GT_GT_GT] = ACTIONS(5432),
    [anon_sym_EQ_EQ] = ACTIONS(5432),
    [anon_sym_BANG_EQ] = ACTIONS(5432),
    [anon_sym_GT_EQ] = ACTIONS(5432),
    [anon_sym_LT_EQ] = ACTIONS(5432),
    [anon_sym_DOT] = ACTIONS(5434),
    [anon_sym_EQ_GT] = ACTIONS(5432),
    [anon_sym_switch] = ACTIONS(5432),
    [anon_sym_when] = ACTIONS(5432),
    [anon_sym_DOT_DOT] = ACTIONS(5432),
    [anon_sym_and] = ACTIONS(5432),
    [anon_sym_or] = ACTIONS(5432),
    [anon_sym_AMP_AMP] = ACTIONS(5432),
    [anon_sym_PIPE_PIPE] = ACTIONS(5432),
    [anon_sym_QMARK_QMARK] = ACTIONS(5432),
    [anon_sym_into] = ACTIONS(5432),
    [anon_sym_on] = ACTIONS(5432),
    [anon_sym_equals] = ACTIONS(5432),
    [anon_sym_by] = ACTIONS(5432),
    [anon_sym_as] = ACTIONS(5432),
    [anon_sym_is] = ACTIONS(5432),
    [anon_sym_DASH_GT] = ACTIONS(5432),
    [anon_sym_with] = ACTIONS(5432),
    [aux_sym_preproc_if_token3] = ACTIONS(5432),
    [aux_sym_preproc_else_token1] = ACTIONS(5432),
    [aux_sym_preproc_elif_token1] = ACTIONS(5432),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4061] = {
    [sym_preproc_region] = STATE(4061),
    [sym_preproc_endregion] = STATE(4061),
    [sym_preproc_line] = STATE(4061),
    [sym_preproc_pragma] = STATE(4061),
    [sym_preproc_nullable] = STATE(4061),
    [sym_preproc_error] = STATE(4061),
    [sym_preproc_define] = STATE(4061),
    [sym_preproc_undef] = STATE(4061),
    [anon_sym_SEMI] = ACTIONS(5522),
    [anon_sym_LBRACK] = ACTIONS(5522),
    [anon_sym_COLON] = ACTIONS(5522),
    [anon_sym_COMMA] = ACTIONS(5522),
    [anon_sym_RBRACK] = ACTIONS(5522),
    [anon_sym_LPAREN] = ACTIONS(5522),
    [anon_sym_RPAREN] = ACTIONS(5522),
    [anon_sym_RBRACE] = ACTIONS(5522),
    [anon_sym_LT] = ACTIONS(5524),
    [anon_sym_GT] = ACTIONS(5524),
    [anon_sym_in] = ACTIONS(5524),
    [anon_sym_QMARK] = ACTIONS(5524),
    [anon_sym_BANG] = ACTIONS(5524),
    [anon_sym_PLUS_PLUS] = ACTIONS(5522),
    [anon_sym_DASH_DASH] = ACTIONS(5522),
    [anon_sym_PLUS] = ACTIONS(5524),
    [anon_sym_DASH] = ACTIONS(5524),
    [anon_sym_STAR] = ACTIONS(5522),
    [anon_sym_SLASH] = ACTIONS(5524),
    [anon_sym_PERCENT] = ACTIONS(5522),
    [anon_sym_CARET] = ACTIONS(5522),
    [anon_sym_PIPE] = ACTIONS(5524),
    [anon_sym_AMP] = ACTIONS(5524),
    [anon_sym_LT_LT] = ACTIONS(5522),
    [anon_sym_GT_GT] = ACTIONS(5524),
    [anon_sym_GT_GT_GT] = ACTIONS(5522),
    [anon_sym_EQ_EQ] = ACTIONS(5522),
    [anon_sym_BANG_EQ] = ACTIONS(5522),
    [anon_sym_GT_EQ] = ACTIONS(5522),
    [anon_sym_LT_EQ] = ACTIONS(5522),
    [anon_sym_DOT] = ACTIONS(5524),
    [anon_sym_EQ_GT] = ACTIONS(5522),
    [anon_sym_switch] = ACTIONS(5522),
    [anon_sym_when] = ACTIONS(5522),
    [anon_sym_DOT_DOT] = ACTIONS(5522),
    [anon_sym_and] = ACTIONS(5522),
    [anon_sym_or] = ACTIONS(5522),
    [anon_sym_AMP_AMP] = ACTIONS(5522),
    [anon_sym_PIPE_PIPE] = ACTIONS(5522),
    [anon_sym_QMARK_QMARK] = ACTIONS(5522),
    [anon_sym_into] = ACTIONS(5522),
    [anon_sym_on] = ACTIONS(5522),
    [anon_sym_equals] = ACTIONS(5522),
    [anon_sym_by] = ACTIONS(5522),
    [anon_sym_as] = ACTIONS(5522),
    [anon_sym_is] = ACTIONS(5522),
    [anon_sym_DASH_GT] = ACTIONS(5522),
    [anon_sym_with] = ACTIONS(5522),
    [aux_sym_preproc_if_token3] = ACTIONS(5522),
    [aux_sym_preproc_else_token1] = ACTIONS(5522),
    [aux_sym_preproc_elif_token1] = ACTIONS(5522),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4062] = {
    [sym_preproc_region] = STATE(4062),
    [sym_preproc_endregion] = STATE(4062),
    [sym_preproc_line] = STATE(4062),
    [sym_preproc_pragma] = STATE(4062),
    [sym_preproc_nullable] = STATE(4062),
    [sym_preproc_error] = STATE(4062),
    [sym_preproc_define] = STATE(4062),
    [sym_preproc_undef] = STATE(4062),
    [anon_sym_SEMI] = ACTIONS(5490),
    [anon_sym_LBRACK] = ACTIONS(5490),
    [anon_sym_COLON] = ACTIONS(5490),
    [anon_sym_COMMA] = ACTIONS(5490),
    [anon_sym_RBRACK] = ACTIONS(5490),
    [anon_sym_LPAREN] = ACTIONS(5490),
    [anon_sym_RPAREN] = ACTIONS(5490),
    [anon_sym_RBRACE] = ACTIONS(5490),
    [anon_sym_LT] = ACTIONS(5492),
    [anon_sym_GT] = ACTIONS(5492),
    [anon_sym_in] = ACTIONS(5492),
    [anon_sym_QMARK] = ACTIONS(5492),
    [anon_sym_BANG] = ACTIONS(5492),
    [anon_sym_PLUS_PLUS] = ACTIONS(5490),
    [anon_sym_DASH_DASH] = ACTIONS(5490),
    [anon_sym_PLUS] = ACTIONS(5492),
    [anon_sym_DASH] = ACTIONS(5492),
    [anon_sym_STAR] = ACTIONS(5490),
    [anon_sym_SLASH] = ACTIONS(5492),
    [anon_sym_PERCENT] = ACTIONS(5490),
    [anon_sym_CARET] = ACTIONS(5490),
    [anon_sym_PIPE] = ACTIONS(5492),
    [anon_sym_AMP] = ACTIONS(5492),
    [anon_sym_LT_LT] = ACTIONS(5490),
    [anon_sym_GT_GT] = ACTIONS(5492),
    [anon_sym_GT_GT_GT] = ACTIONS(5490),
    [anon_sym_EQ_EQ] = ACTIONS(5490),
    [anon_sym_BANG_EQ] = ACTIONS(5490),
    [anon_sym_GT_EQ] = ACTIONS(5490),
    [anon_sym_LT_EQ] = ACTIONS(5490),
    [anon_sym_DOT] = ACTIONS(5492),
    [anon_sym_EQ_GT] = ACTIONS(5490),
    [anon_sym_switch] = ACTIONS(5490),
    [anon_sym_when] = ACTIONS(5490),
    [anon_sym_DOT_DOT] = ACTIONS(5490),
    [anon_sym_and] = ACTIONS(5490),
    [anon_sym_or] = ACTIONS(5490),
    [anon_sym_AMP_AMP] = ACTIONS(5490),
    [anon_sym_PIPE_PIPE] = ACTIONS(5490),
    [anon_sym_QMARK_QMARK] = ACTIONS(5490),
    [anon_sym_into] = ACTIONS(5490),
    [anon_sym_on] = ACTIONS(5490),
    [anon_sym_equals] = ACTIONS(5490),
    [anon_sym_by] = ACTIONS(5490),
    [anon_sym_as] = ACTIONS(5490),
    [anon_sym_is] = ACTIONS(5490),
    [anon_sym_DASH_GT] = ACTIONS(5490),
    [anon_sym_with] = ACTIONS(5490),
    [aux_sym_preproc_if_token3] = ACTIONS(5490),
    [aux_sym_preproc_else_token1] = ACTIONS(5490),
    [aux_sym_preproc_elif_token1] = ACTIONS(5490),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4063] = {
    [sym_preproc_region] = STATE(4063),
    [sym_preproc_endregion] = STATE(4063),
    [sym_preproc_line] = STATE(4063),
    [sym_preproc_pragma] = STATE(4063),
    [sym_preproc_nullable] = STATE(4063),
    [sym_preproc_error] = STATE(4063),
    [sym_preproc_define] = STATE(4063),
    [sym_preproc_undef] = STATE(4063),
    [anon_sym_SEMI] = ACTIONS(5878),
    [anon_sym_LBRACK] = ACTIONS(5878),
    [anon_sym_COLON] = ACTIONS(5878),
    [anon_sym_COMMA] = ACTIONS(5878),
    [anon_sym_RBRACK] = ACTIONS(5878),
    [anon_sym_LPAREN] = ACTIONS(5878),
    [anon_sym_RPAREN] = ACTIONS(5878),
    [anon_sym_RBRACE] = ACTIONS(5878),
    [anon_sym_LT] = ACTIONS(5880),
    [anon_sym_GT] = ACTIONS(5880),
    [anon_sym_in] = ACTIONS(5880),
    [anon_sym_QMARK] = ACTIONS(5880),
    [anon_sym_BANG] = ACTIONS(5880),
    [anon_sym_PLUS_PLUS] = ACTIONS(5878),
    [anon_sym_DASH_DASH] = ACTIONS(5878),
    [anon_sym_PLUS] = ACTIONS(5880),
    [anon_sym_DASH] = ACTIONS(5880),
    [anon_sym_STAR] = ACTIONS(5878),
    [anon_sym_SLASH] = ACTIONS(5880),
    [anon_sym_PERCENT] = ACTIONS(5878),
    [anon_sym_CARET] = ACTIONS(5878),
    [anon_sym_PIPE] = ACTIONS(5880),
    [anon_sym_AMP] = ACTIONS(5880),
    [anon_sym_LT_LT] = ACTIONS(5878),
    [anon_sym_GT_GT] = ACTIONS(5880),
    [anon_sym_GT_GT_GT] = ACTIONS(5878),
    [anon_sym_EQ_EQ] = ACTIONS(5878),
    [anon_sym_BANG_EQ] = ACTIONS(5878),
    [anon_sym_GT_EQ] = ACTIONS(5878),
    [anon_sym_LT_EQ] = ACTIONS(5878),
    [anon_sym_DOT] = ACTIONS(5880),
    [anon_sym_EQ_GT] = ACTIONS(5878),
    [anon_sym_switch] = ACTIONS(5878),
    [anon_sym_when] = ACTIONS(5878),
    [anon_sym_DOT_DOT] = ACTIONS(5878),
    [anon_sym_and] = ACTIONS(5878),
    [anon_sym_or] = ACTIONS(5878),
    [anon_sym_AMP_AMP] = ACTIONS(5878),
    [anon_sym_PIPE_PIPE] = ACTIONS(5878),
    [anon_sym_QMARK_QMARK] = ACTIONS(5878),
    [anon_sym_into] = ACTIONS(5878),
    [anon_sym_on] = ACTIONS(5878),
    [anon_sym_equals] = ACTIONS(5878),
    [anon_sym_by] = ACTIONS(5878),
    [anon_sym_as] = ACTIONS(5878),
    [anon_sym_is] = ACTIONS(5878),
    [anon_sym_DASH_GT] = ACTIONS(5878),
    [anon_sym_with] = ACTIONS(5878),
    [aux_sym_preproc_if_token3] = ACTIONS(5878),
    [aux_sym_preproc_else_token1] = ACTIONS(5878),
    [aux_sym_preproc_elif_token1] = ACTIONS(5878),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4064] = {
    [sym_preproc_region] = STATE(4064),
    [sym_preproc_endregion] = STATE(4064),
    [sym_preproc_line] = STATE(4064),
    [sym_preproc_pragma] = STATE(4064),
    [sym_preproc_nullable] = STATE(4064),
    [sym_preproc_error] = STATE(4064),
    [sym_preproc_define] = STATE(4064),
    [sym_preproc_undef] = STATE(4064),
    [anon_sym_SEMI] = ACTIONS(2923),
    [anon_sym_LBRACK] = ACTIONS(2923),
    [anon_sym_COLON] = ACTIONS(2923),
    [anon_sym_COMMA] = ACTIONS(2923),
    [anon_sym_RBRACK] = ACTIONS(2923),
    [anon_sym_LPAREN] = ACTIONS(2923),
    [anon_sym_RPAREN] = ACTIONS(2923),
    [anon_sym_RBRACE] = ACTIONS(2923),
    [anon_sym_LT] = ACTIONS(2921),
    [anon_sym_GT] = ACTIONS(2921),
    [anon_sym_in] = ACTIONS(2921),
    [anon_sym_QMARK] = ACTIONS(2921),
    [anon_sym_BANG] = ACTIONS(2921),
    [anon_sym_PLUS_PLUS] = ACTIONS(2923),
    [anon_sym_DASH_DASH] = ACTIONS(2923),
    [anon_sym_PLUS] = ACTIONS(2921),
    [anon_sym_DASH] = ACTIONS(2921),
    [anon_sym_STAR] = ACTIONS(2923),
    [anon_sym_SLASH] = ACTIONS(2921),
    [anon_sym_PERCENT] = ACTIONS(2923),
    [anon_sym_CARET] = ACTIONS(2923),
    [anon_sym_PIPE] = ACTIONS(2921),
    [anon_sym_AMP] = ACTIONS(2921),
    [anon_sym_LT_LT] = ACTIONS(2923),
    [anon_sym_GT_GT] = ACTIONS(2921),
    [anon_sym_GT_GT_GT] = ACTIONS(2923),
    [anon_sym_EQ_EQ] = ACTIONS(2923),
    [anon_sym_BANG_EQ] = ACTIONS(2923),
    [anon_sym_GT_EQ] = ACTIONS(2923),
    [anon_sym_LT_EQ] = ACTIONS(2923),
    [anon_sym_DOT] = ACTIONS(2921),
    [anon_sym_EQ_GT] = ACTIONS(2923),
    [anon_sym_switch] = ACTIONS(2923),
    [anon_sym_when] = ACTIONS(2923),
    [anon_sym_DOT_DOT] = ACTIONS(2923),
    [anon_sym_and] = ACTIONS(2923),
    [anon_sym_or] = ACTIONS(2923),
    [anon_sym_AMP_AMP] = ACTIONS(2923),
    [anon_sym_PIPE_PIPE] = ACTIONS(2923),
    [anon_sym_QMARK_QMARK] = ACTIONS(2923),
    [anon_sym_into] = ACTIONS(2923),
    [anon_sym_on] = ACTIONS(2923),
    [anon_sym_equals] = ACTIONS(2923),
    [anon_sym_by] = ACTIONS(2923),
    [anon_sym_as] = ACTIONS(2923),
    [anon_sym_is] = ACTIONS(2923),
    [anon_sym_DASH_GT] = ACTIONS(2923),
    [anon_sym_with] = ACTIONS(2923),
    [aux_sym_preproc_if_token3] = ACTIONS(2923),
    [aux_sym_preproc_else_token1] = ACTIONS(2923),
    [aux_sym_preproc_elif_token1] = ACTIONS(2923),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4065] = {
    [sym_preproc_region] = STATE(4065),
    [sym_preproc_endregion] = STATE(4065),
    [sym_preproc_line] = STATE(4065),
    [sym_preproc_pragma] = STATE(4065),
    [sym_preproc_nullable] = STATE(4065),
    [sym_preproc_error] = STATE(4065),
    [sym_preproc_define] = STATE(4065),
    [sym_preproc_undef] = STATE(4065),
    [anon_sym_SEMI] = ACTIONS(5510),
    [anon_sym_LBRACK] = ACTIONS(5510),
    [anon_sym_COLON] = ACTIONS(5510),
    [anon_sym_COMMA] = ACTIONS(5510),
    [anon_sym_RBRACK] = ACTIONS(5510),
    [anon_sym_LPAREN] = ACTIONS(5510),
    [anon_sym_RPAREN] = ACTIONS(5510),
    [anon_sym_RBRACE] = ACTIONS(5510),
    [anon_sym_LT] = ACTIONS(5512),
    [anon_sym_GT] = ACTIONS(5512),
    [anon_sym_in] = ACTIONS(5512),
    [anon_sym_QMARK] = ACTIONS(5512),
    [anon_sym_BANG] = ACTIONS(5512),
    [anon_sym_PLUS_PLUS] = ACTIONS(5510),
    [anon_sym_DASH_DASH] = ACTIONS(5510),
    [anon_sym_PLUS] = ACTIONS(5512),
    [anon_sym_DASH] = ACTIONS(5512),
    [anon_sym_STAR] = ACTIONS(5510),
    [anon_sym_SLASH] = ACTIONS(5512),
    [anon_sym_PERCENT] = ACTIONS(5510),
    [anon_sym_CARET] = ACTIONS(5510),
    [anon_sym_PIPE] = ACTIONS(5512),
    [anon_sym_AMP] = ACTIONS(5512),
    [anon_sym_LT_LT] = ACTIONS(5510),
    [anon_sym_GT_GT] = ACTIONS(5512),
    [anon_sym_GT_GT_GT] = ACTIONS(5510),
    [anon_sym_EQ_EQ] = ACTIONS(5510),
    [anon_sym_BANG_EQ] = ACTIONS(5510),
    [anon_sym_GT_EQ] = ACTIONS(5510),
    [anon_sym_LT_EQ] = ACTIONS(5510),
    [anon_sym_DOT] = ACTIONS(5512),
    [anon_sym_EQ_GT] = ACTIONS(5510),
    [anon_sym_switch] = ACTIONS(5510),
    [anon_sym_when] = ACTIONS(5510),
    [anon_sym_DOT_DOT] = ACTIONS(5510),
    [anon_sym_and] = ACTIONS(5510),
    [anon_sym_or] = ACTIONS(5510),
    [anon_sym_AMP_AMP] = ACTIONS(5510),
    [anon_sym_PIPE_PIPE] = ACTIONS(5510),
    [anon_sym_QMARK_QMARK] = ACTIONS(5510),
    [anon_sym_into] = ACTIONS(5510),
    [anon_sym_on] = ACTIONS(5510),
    [anon_sym_equals] = ACTIONS(5510),
    [anon_sym_by] = ACTIONS(5510),
    [anon_sym_as] = ACTIONS(5510),
    [anon_sym_is] = ACTIONS(5510),
    [anon_sym_DASH_GT] = ACTIONS(5510),
    [anon_sym_with] = ACTIONS(5510),
    [aux_sym_preproc_if_token3] = ACTIONS(5510),
    [aux_sym_preproc_else_token1] = ACTIONS(5510),
    [aux_sym_preproc_elif_token1] = ACTIONS(5510),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4066] = {
    [sym_preproc_region] = STATE(4066),
    [sym_preproc_endregion] = STATE(4066),
    [sym_preproc_line] = STATE(4066),
    [sym_preproc_pragma] = STATE(4066),
    [sym_preproc_nullable] = STATE(4066),
    [sym_preproc_error] = STATE(4066),
    [sym_preproc_define] = STATE(4066),
    [sym_preproc_undef] = STATE(4066),
    [anon_sym_SEMI] = ACTIONS(5396),
    [anon_sym_LBRACK] = ACTIONS(5396),
    [anon_sym_COLON] = ACTIONS(5396),
    [anon_sym_COMMA] = ACTIONS(5396),
    [anon_sym_RBRACK] = ACTIONS(5396),
    [anon_sym_LPAREN] = ACTIONS(5396),
    [anon_sym_RPAREN] = ACTIONS(5396),
    [anon_sym_RBRACE] = ACTIONS(5396),
    [anon_sym_LT] = ACTIONS(5398),
    [anon_sym_GT] = ACTIONS(5398),
    [anon_sym_in] = ACTIONS(5396),
    [anon_sym_QMARK] = ACTIONS(5398),
    [anon_sym_BANG] = ACTIONS(5398),
    [anon_sym_PLUS_PLUS] = ACTIONS(5396),
    [anon_sym_DASH_DASH] = ACTIONS(5396),
    [anon_sym_PLUS] = ACTIONS(5398),
    [anon_sym_DASH] = ACTIONS(5398),
    [anon_sym_STAR] = ACTIONS(5396),
    [anon_sym_SLASH] = ACTIONS(5398),
    [anon_sym_PERCENT] = ACTIONS(5396),
    [anon_sym_CARET] = ACTIONS(5396),
    [anon_sym_PIPE] = ACTIONS(5398),
    [anon_sym_AMP] = ACTIONS(5398),
    [anon_sym_LT_LT] = ACTIONS(5396),
    [anon_sym_GT_GT] = ACTIONS(5398),
    [anon_sym_GT_GT_GT] = ACTIONS(5396),
    [anon_sym_EQ_EQ] = ACTIONS(5396),
    [anon_sym_BANG_EQ] = ACTIONS(5396),
    [anon_sym_GT_EQ] = ACTIONS(5396),
    [anon_sym_LT_EQ] = ACTIONS(5396),
    [anon_sym_DOT] = ACTIONS(5398),
    [anon_sym_EQ_GT] = ACTIONS(5396),
    [anon_sym_switch] = ACTIONS(5396),
    [anon_sym_when] = ACTIONS(5396),
    [anon_sym_DOT_DOT] = ACTIONS(5396),
    [anon_sym_and] = ACTIONS(5396),
    [anon_sym_or] = ACTIONS(5396),
    [anon_sym_AMP_AMP] = ACTIONS(5396),
    [anon_sym_PIPE_PIPE] = ACTIONS(5396),
    [anon_sym_QMARK_QMARK] = ACTIONS(5396),
    [anon_sym_on] = ACTIONS(5396),
    [anon_sym_equals] = ACTIONS(5396),
    [anon_sym_by] = ACTIONS(5396),
    [anon_sym_as] = ACTIONS(5396),
    [anon_sym_is] = ACTIONS(5396),
    [anon_sym_DASH_GT] = ACTIONS(5396),
    [anon_sym_with] = ACTIONS(5396),
    [aux_sym_preproc_if_token3] = ACTIONS(5396),
    [aux_sym_preproc_else_token1] = ACTIONS(5396),
    [aux_sym_preproc_elif_token1] = ACTIONS(5396),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4067] = {
    [sym_preproc_region] = STATE(4067),
    [sym_preproc_endregion] = STATE(4067),
    [sym_preproc_line] = STATE(4067),
    [sym_preproc_pragma] = STATE(4067),
    [sym_preproc_nullable] = STATE(4067),
    [sym_preproc_error] = STATE(4067),
    [sym_preproc_define] = STATE(4067),
    [sym_preproc_undef] = STATE(4067),
    [anon_sym_SEMI] = ACTIONS(5594),
    [anon_sym_LBRACK] = ACTIONS(5594),
    [anon_sym_COLON] = ACTIONS(5594),
    [anon_sym_COMMA] = ACTIONS(5594),
    [anon_sym_RBRACK] = ACTIONS(5594),
    [anon_sym_LPAREN] = ACTIONS(5594),
    [anon_sym_RPAREN] = ACTIONS(5594),
    [anon_sym_RBRACE] = ACTIONS(5594),
    [anon_sym_LT] = ACTIONS(5596),
    [anon_sym_GT] = ACTIONS(5596),
    [anon_sym_in] = ACTIONS(5594),
    [anon_sym_QMARK] = ACTIONS(5596),
    [anon_sym_BANG] = ACTIONS(5596),
    [anon_sym_PLUS_PLUS] = ACTIONS(5594),
    [anon_sym_DASH_DASH] = ACTIONS(5594),
    [anon_sym_PLUS] = ACTIONS(5596),
    [anon_sym_DASH] = ACTIONS(5596),
    [anon_sym_STAR] = ACTIONS(5594),
    [anon_sym_SLASH] = ACTIONS(5596),
    [anon_sym_PERCENT] = ACTIONS(5594),
    [anon_sym_CARET] = ACTIONS(5594),
    [anon_sym_PIPE] = ACTIONS(5596),
    [anon_sym_AMP] = ACTIONS(5596),
    [anon_sym_LT_LT] = ACTIONS(5594),
    [anon_sym_GT_GT] = ACTIONS(5596),
    [anon_sym_GT_GT_GT] = ACTIONS(5594),
    [anon_sym_EQ_EQ] = ACTIONS(5594),
    [anon_sym_BANG_EQ] = ACTIONS(5594),
    [anon_sym_GT_EQ] = ACTIONS(5594),
    [anon_sym_LT_EQ] = ACTIONS(5594),
    [anon_sym_DOT] = ACTIONS(5596),
    [anon_sym_EQ_GT] = ACTIONS(5594),
    [anon_sym_switch] = ACTIONS(5594),
    [anon_sym_when] = ACTIONS(5594),
    [anon_sym_DOT_DOT] = ACTIONS(5594),
    [anon_sym_and] = ACTIONS(5594),
    [anon_sym_or] = ACTIONS(5594),
    [anon_sym_AMP_AMP] = ACTIONS(5594),
    [anon_sym_PIPE_PIPE] = ACTIONS(5594),
    [anon_sym_QMARK_QMARK] = ACTIONS(5594),
    [anon_sym_on] = ACTIONS(5594),
    [anon_sym_equals] = ACTIONS(5594),
    [anon_sym_by] = ACTIONS(5594),
    [anon_sym_as] = ACTIONS(5594),
    [anon_sym_is] = ACTIONS(5594),
    [anon_sym_DASH_GT] = ACTIONS(5594),
    [anon_sym_with] = ACTIONS(5594),
    [aux_sym_preproc_if_token3] = ACTIONS(5594),
    [aux_sym_preproc_else_token1] = ACTIONS(5594),
    [aux_sym_preproc_elif_token1] = ACTIONS(5594),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4068] = {
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7074),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9600),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4068),
    [sym_preproc_endregion] = STATE(4068),
    [sym_preproc_line] = STATE(4068),
    [sym_preproc_pragma] = STATE(4068),
    [sym_preproc_nullable] = STATE(4068),
    [sym_preproc_error] = STATE(4068),
    [sym_preproc_define] = STATE(4068),
    [sym_preproc_undef] = STATE(4068),
    [aux_sym_lambda_expression_repeat1] = STATE(6864),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4069] = {
    [sym__name] = STATE(7759),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(9011),
    [sym_implicit_type] = STATE(8901),
    [sym_array_type] = STATE(8236),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(8217),
    [sym_pointer_type] = STATE(8217),
    [sym__pointer_base_type] = STATE(9650),
    [sym_function_pointer_type] = STATE(8217),
    [sym_function_pointer_parameter] = STATE(9350),
    [sym_ref_type] = STATE(8704),
    [sym__ref_base_type] = STATE(9351),
    [sym_scoped_type] = STATE(8704),
    [sym_tuple_type] = STATE(8136),
    [sym_identifier] = STATE(4921),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4069),
    [sym_preproc_endregion] = STATE(4069),
    [sym_preproc_line] = STATE(4069),
    [sym_preproc_pragma] = STATE(4069),
    [sym_preproc_nullable] = STATE(4069),
    [sym_preproc_error] = STATE(4069),
    [sym_preproc_define] = STATE(4069),
    [sym_preproc_undef] = STATE(4069),
    [aux_sym_function_pointer_type_repeat1] = STATE(4156),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_LPAREN] = ACTIONS(2995),
    [anon_sym_ref] = ACTIONS(5882),
    [anon_sym_delegate] = ACTIONS(5659),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_in] = ACTIONS(5884),
    [anon_sym_out] = ACTIONS(5884),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(5886),
    [anon_sym_var] = ACTIONS(5284),
    [sym_predefined_type] = ACTIONS(5888),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4070] = {
    [sym_preproc_region] = STATE(4070),
    [sym_preproc_endregion] = STATE(4070),
    [sym_preproc_line] = STATE(4070),
    [sym_preproc_pragma] = STATE(4070),
    [sym_preproc_nullable] = STATE(4070),
    [sym_preproc_error] = STATE(4070),
    [sym_preproc_define] = STATE(4070),
    [sym_preproc_undef] = STATE(4070),
    [anon_sym_SEMI] = ACTIONS(2923),
    [anon_sym_LBRACK] = ACTIONS(2923),
    [anon_sym_COLON] = ACTIONS(2923),
    [anon_sym_COMMA] = ACTIONS(2923),
    [anon_sym_RBRACK] = ACTIONS(2923),
    [anon_sym_LPAREN] = ACTIONS(2923),
    [anon_sym_RPAREN] = ACTIONS(2923),
    [anon_sym_RBRACE] = ACTIONS(2923),
    [anon_sym_LT] = ACTIONS(2921),
    [anon_sym_GT] = ACTIONS(2921),
    [anon_sym_in] = ACTIONS(2923),
    [anon_sym_QMARK] = ACTIONS(2921),
    [anon_sym_BANG] = ACTIONS(2921),
    [anon_sym_PLUS_PLUS] = ACTIONS(2923),
    [anon_sym_DASH_DASH] = ACTIONS(2923),
    [anon_sym_PLUS] = ACTIONS(2921),
    [anon_sym_DASH] = ACTIONS(2921),
    [anon_sym_STAR] = ACTIONS(2923),
    [anon_sym_SLASH] = ACTIONS(2921),
    [anon_sym_PERCENT] = ACTIONS(2923),
    [anon_sym_CARET] = ACTIONS(2923),
    [anon_sym_PIPE] = ACTIONS(2921),
    [anon_sym_AMP] = ACTIONS(2921),
    [anon_sym_LT_LT] = ACTIONS(2923),
    [anon_sym_GT_GT] = ACTIONS(2921),
    [anon_sym_GT_GT_GT] = ACTIONS(2923),
    [anon_sym_EQ_EQ] = ACTIONS(2923),
    [anon_sym_BANG_EQ] = ACTIONS(2923),
    [anon_sym_GT_EQ] = ACTIONS(2923),
    [anon_sym_LT_EQ] = ACTIONS(2923),
    [anon_sym_DOT] = ACTIONS(2921),
    [anon_sym_EQ_GT] = ACTIONS(2923),
    [anon_sym_switch] = ACTIONS(2923),
    [anon_sym_when] = ACTIONS(2923),
    [anon_sym_DOT_DOT] = ACTIONS(2923),
    [anon_sym_and] = ACTIONS(2923),
    [anon_sym_or] = ACTIONS(2923),
    [anon_sym_AMP_AMP] = ACTIONS(2923),
    [anon_sym_PIPE_PIPE] = ACTIONS(2923),
    [anon_sym_QMARK_QMARK] = ACTIONS(2923),
    [anon_sym_on] = ACTIONS(2923),
    [anon_sym_equals] = ACTIONS(2923),
    [anon_sym_by] = ACTIONS(2923),
    [anon_sym_as] = ACTIONS(2923),
    [anon_sym_is] = ACTIONS(2923),
    [anon_sym_DASH_GT] = ACTIONS(2923),
    [anon_sym_with] = ACTIONS(2923),
    [aux_sym_preproc_if_token3] = ACTIONS(2923),
    [aux_sym_preproc_else_token1] = ACTIONS(2923),
    [aux_sym_preproc_elif_token1] = ACTIONS(2923),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4071] = {
    [sym_preproc_region] = STATE(4071),
    [sym_preproc_endregion] = STATE(4071),
    [sym_preproc_line] = STATE(4071),
    [sym_preproc_pragma] = STATE(4071),
    [sym_preproc_nullable] = STATE(4071),
    [sym_preproc_error] = STATE(4071),
    [sym_preproc_define] = STATE(4071),
    [sym_preproc_undef] = STATE(4071),
    [anon_sym_SEMI] = ACTIONS(2969),
    [anon_sym_LBRACK] = ACTIONS(2969),
    [anon_sym_COLON] = ACTIONS(2969),
    [anon_sym_COMMA] = ACTIONS(2969),
    [anon_sym_RBRACK] = ACTIONS(2969),
    [anon_sym_LPAREN] = ACTIONS(2969),
    [anon_sym_RPAREN] = ACTIONS(2969),
    [anon_sym_RBRACE] = ACTIONS(2969),
    [anon_sym_LT] = ACTIONS(2967),
    [anon_sym_GT] = ACTIONS(2967),
    [anon_sym_in] = ACTIONS(2969),
    [anon_sym_QMARK] = ACTIONS(2967),
    [anon_sym_BANG] = ACTIONS(2967),
    [anon_sym_PLUS_PLUS] = ACTIONS(2969),
    [anon_sym_DASH_DASH] = ACTIONS(2969),
    [anon_sym_PLUS] = ACTIONS(2967),
    [anon_sym_DASH] = ACTIONS(2967),
    [anon_sym_STAR] = ACTIONS(2969),
    [anon_sym_SLASH] = ACTIONS(2967),
    [anon_sym_PERCENT] = ACTIONS(2969),
    [anon_sym_CARET] = ACTIONS(2969),
    [anon_sym_PIPE] = ACTIONS(2967),
    [anon_sym_AMP] = ACTIONS(2967),
    [anon_sym_LT_LT] = ACTIONS(2969),
    [anon_sym_GT_GT] = ACTIONS(2967),
    [anon_sym_GT_GT_GT] = ACTIONS(2969),
    [anon_sym_EQ_EQ] = ACTIONS(2969),
    [anon_sym_BANG_EQ] = ACTIONS(2969),
    [anon_sym_GT_EQ] = ACTIONS(2969),
    [anon_sym_LT_EQ] = ACTIONS(2969),
    [anon_sym_DOT] = ACTIONS(2967),
    [anon_sym_EQ_GT] = ACTIONS(2969),
    [anon_sym_switch] = ACTIONS(2969),
    [anon_sym_when] = ACTIONS(2969),
    [anon_sym_DOT_DOT] = ACTIONS(2969),
    [anon_sym_and] = ACTIONS(2969),
    [anon_sym_or] = ACTIONS(2969),
    [anon_sym_AMP_AMP] = ACTIONS(2969),
    [anon_sym_PIPE_PIPE] = ACTIONS(2969),
    [anon_sym_QMARK_QMARK] = ACTIONS(2969),
    [anon_sym_on] = ACTIONS(2969),
    [anon_sym_equals] = ACTIONS(2969),
    [anon_sym_by] = ACTIONS(2969),
    [anon_sym_as] = ACTIONS(2969),
    [anon_sym_is] = ACTIONS(2969),
    [anon_sym_DASH_GT] = ACTIONS(2969),
    [anon_sym_with] = ACTIONS(2969),
    [aux_sym_preproc_if_token3] = ACTIONS(2969),
    [aux_sym_preproc_else_token1] = ACTIONS(2969),
    [aux_sym_preproc_elif_token1] = ACTIONS(2969),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4072] = {
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(6939),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9259),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4072),
    [sym_preproc_endregion] = STATE(4072),
    [sym_preproc_line] = STATE(4072),
    [sym_preproc_pragma] = STATE(4072),
    [sym_preproc_nullable] = STATE(4072),
    [sym_preproc_error] = STATE(4072),
    [sym_preproc_define] = STATE(4072),
    [sym_preproc_undef] = STATE(4072),
    [aux_sym_lambda_expression_repeat1] = STATE(6864),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(5890),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4073] = {
    [sym_preproc_region] = STATE(4073),
    [sym_preproc_endregion] = STATE(4073),
    [sym_preproc_line] = STATE(4073),
    [sym_preproc_pragma] = STATE(4073),
    [sym_preproc_nullable] = STATE(4073),
    [sym_preproc_error] = STATE(4073),
    [sym_preproc_define] = STATE(4073),
    [sym_preproc_undef] = STATE(4073),
    [anon_sym_SEMI] = ACTIONS(5400),
    [anon_sym_LBRACK] = ACTIONS(5400),
    [anon_sym_COLON] = ACTIONS(5400),
    [anon_sym_COMMA] = ACTIONS(5400),
    [anon_sym_RBRACK] = ACTIONS(5400),
    [anon_sym_LPAREN] = ACTIONS(5400),
    [anon_sym_RPAREN] = ACTIONS(5400),
    [anon_sym_RBRACE] = ACTIONS(5400),
    [anon_sym_LT] = ACTIONS(5402),
    [anon_sym_GT] = ACTIONS(5402),
    [anon_sym_in] = ACTIONS(5400),
    [anon_sym_QMARK] = ACTIONS(5402),
    [anon_sym_BANG] = ACTIONS(5402),
    [anon_sym_PLUS_PLUS] = ACTIONS(5400),
    [anon_sym_DASH_DASH] = ACTIONS(5400),
    [anon_sym_PLUS] = ACTIONS(5402),
    [anon_sym_DASH] = ACTIONS(5402),
    [anon_sym_STAR] = ACTIONS(5400),
    [anon_sym_SLASH] = ACTIONS(5402),
    [anon_sym_PERCENT] = ACTIONS(5400),
    [anon_sym_CARET] = ACTIONS(5400),
    [anon_sym_PIPE] = ACTIONS(5402),
    [anon_sym_AMP] = ACTIONS(5402),
    [anon_sym_LT_LT] = ACTIONS(5400),
    [anon_sym_GT_GT] = ACTIONS(5402),
    [anon_sym_GT_GT_GT] = ACTIONS(5400),
    [anon_sym_EQ_EQ] = ACTIONS(5400),
    [anon_sym_BANG_EQ] = ACTIONS(5400),
    [anon_sym_GT_EQ] = ACTIONS(5400),
    [anon_sym_LT_EQ] = ACTIONS(5400),
    [anon_sym_DOT] = ACTIONS(5402),
    [anon_sym_EQ_GT] = ACTIONS(5400),
    [anon_sym_switch] = ACTIONS(5400),
    [anon_sym_when] = ACTIONS(5400),
    [anon_sym_DOT_DOT] = ACTIONS(5400),
    [anon_sym_and] = ACTIONS(5400),
    [anon_sym_or] = ACTIONS(5400),
    [anon_sym_AMP_AMP] = ACTIONS(5400),
    [anon_sym_PIPE_PIPE] = ACTIONS(5400),
    [anon_sym_QMARK_QMARK] = ACTIONS(5400),
    [anon_sym_on] = ACTIONS(5400),
    [anon_sym_equals] = ACTIONS(5400),
    [anon_sym_by] = ACTIONS(5400),
    [anon_sym_as] = ACTIONS(5400),
    [anon_sym_is] = ACTIONS(5400),
    [anon_sym_DASH_GT] = ACTIONS(5400),
    [anon_sym_with] = ACTIONS(5400),
    [aux_sym_preproc_if_token3] = ACTIONS(5400),
    [aux_sym_preproc_else_token1] = ACTIONS(5400),
    [aux_sym_preproc_elif_token1] = ACTIONS(5400),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4074] = {
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(6942),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9257),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4074),
    [sym_preproc_endregion] = STATE(4074),
    [sym_preproc_line] = STATE(4074),
    [sym_preproc_pragma] = STATE(4074),
    [sym_preproc_nullable] = STATE(4074),
    [sym_preproc_error] = STATE(4074),
    [sym_preproc_define] = STATE(4074),
    [sym_preproc_undef] = STATE(4074),
    [aux_sym_lambda_expression_repeat1] = STATE(6864),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4075] = {
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(6955),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9714),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4075),
    [sym_preproc_endregion] = STATE(4075),
    [sym_preproc_line] = STATE(4075),
    [sym_preproc_pragma] = STATE(4075),
    [sym_preproc_nullable] = STATE(4075),
    [sym_preproc_error] = STATE(4075),
    [sym_preproc_define] = STATE(4075),
    [sym_preproc_undef] = STATE(4075),
    [aux_sym_lambda_expression_repeat1] = STATE(6864),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(5892),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4076] = {
    [sym__name] = STATE(7759),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(9011),
    [sym_implicit_type] = STATE(8901),
    [sym_array_type] = STATE(8236),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(8217),
    [sym_pointer_type] = STATE(8217),
    [sym__pointer_base_type] = STATE(9650),
    [sym_function_pointer_type] = STATE(8217),
    [sym_function_pointer_parameter] = STATE(9350),
    [sym_ref_type] = STATE(8704),
    [sym__ref_base_type] = STATE(9351),
    [sym_scoped_type] = STATE(8704),
    [sym_tuple_type] = STATE(8136),
    [sym_identifier] = STATE(4921),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4076),
    [sym_preproc_endregion] = STATE(4076),
    [sym_preproc_line] = STATE(4076),
    [sym_preproc_pragma] = STATE(4076),
    [sym_preproc_nullable] = STATE(4076),
    [sym_preproc_error] = STATE(4076),
    [sym_preproc_define] = STATE(4076),
    [sym_preproc_undef] = STATE(4076),
    [aux_sym_function_pointer_type_repeat1] = STATE(4464),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_LPAREN] = ACTIONS(2995),
    [anon_sym_ref] = ACTIONS(5882),
    [anon_sym_delegate] = ACTIONS(5659),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_in] = ACTIONS(5884),
    [anon_sym_out] = ACTIONS(5884),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(5886),
    [anon_sym_var] = ACTIONS(5284),
    [sym_predefined_type] = ACTIONS(5888),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4077] = {
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7028),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9281),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4077),
    [sym_preproc_endregion] = STATE(4077),
    [sym_preproc_line] = STATE(4077),
    [sym_preproc_pragma] = STATE(4077),
    [sym_preproc_nullable] = STATE(4077),
    [sym_preproc_error] = STATE(4077),
    [sym_preproc_define] = STATE(4077),
    [sym_preproc_undef] = STATE(4077),
    [aux_sym_lambda_expression_repeat1] = STATE(6864),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4078] = {
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(6957),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9722),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4078),
    [sym_preproc_endregion] = STATE(4078),
    [sym_preproc_line] = STATE(4078),
    [sym_preproc_pragma] = STATE(4078),
    [sym_preproc_nullable] = STATE(4078),
    [sym_preproc_error] = STATE(4078),
    [sym_preproc_define] = STATE(4078),
    [sym_preproc_undef] = STATE(4078),
    [aux_sym_lambda_expression_repeat1] = STATE(6864),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4079] = {
    [sym_preproc_region] = STATE(4079),
    [sym_preproc_endregion] = STATE(4079),
    [sym_preproc_line] = STATE(4079),
    [sym_preproc_pragma] = STATE(4079),
    [sym_preproc_nullable] = STATE(4079),
    [sym_preproc_error] = STATE(4079),
    [sym_preproc_define] = STATE(4079),
    [sym_preproc_undef] = STATE(4079),
    [anon_sym_SEMI] = ACTIONS(5586),
    [anon_sym_LBRACK] = ACTIONS(5586),
    [anon_sym_COLON] = ACTIONS(5586),
    [anon_sym_COMMA] = ACTIONS(5586),
    [anon_sym_RBRACK] = ACTIONS(5586),
    [anon_sym_LPAREN] = ACTIONS(5586),
    [anon_sym_RPAREN] = ACTIONS(5586),
    [anon_sym_RBRACE] = ACTIONS(5586),
    [anon_sym_LT] = ACTIONS(5588),
    [anon_sym_GT] = ACTIONS(5588),
    [anon_sym_in] = ACTIONS(5586),
    [anon_sym_QMARK] = ACTIONS(5588),
    [anon_sym_BANG] = ACTIONS(5588),
    [anon_sym_PLUS_PLUS] = ACTIONS(5586),
    [anon_sym_DASH_DASH] = ACTIONS(5586),
    [anon_sym_PLUS] = ACTIONS(5588),
    [anon_sym_DASH] = ACTIONS(5588),
    [anon_sym_STAR] = ACTIONS(5586),
    [anon_sym_SLASH] = ACTIONS(5588),
    [anon_sym_PERCENT] = ACTIONS(5586),
    [anon_sym_CARET] = ACTIONS(5586),
    [anon_sym_PIPE] = ACTIONS(5588),
    [anon_sym_AMP] = ACTIONS(5588),
    [anon_sym_LT_LT] = ACTIONS(5586),
    [anon_sym_GT_GT] = ACTIONS(5588),
    [anon_sym_GT_GT_GT] = ACTIONS(5586),
    [anon_sym_EQ_EQ] = ACTIONS(5586),
    [anon_sym_BANG_EQ] = ACTIONS(5586),
    [anon_sym_GT_EQ] = ACTIONS(5586),
    [anon_sym_LT_EQ] = ACTIONS(5586),
    [anon_sym_DOT] = ACTIONS(5588),
    [anon_sym_EQ_GT] = ACTIONS(5586),
    [anon_sym_switch] = ACTIONS(5586),
    [anon_sym_when] = ACTIONS(5586),
    [anon_sym_DOT_DOT] = ACTIONS(5586),
    [anon_sym_and] = ACTIONS(5586),
    [anon_sym_or] = ACTIONS(5586),
    [anon_sym_AMP_AMP] = ACTIONS(5586),
    [anon_sym_PIPE_PIPE] = ACTIONS(5586),
    [anon_sym_QMARK_QMARK] = ACTIONS(5586),
    [anon_sym_on] = ACTIONS(5586),
    [anon_sym_equals] = ACTIONS(5586),
    [anon_sym_by] = ACTIONS(5586),
    [anon_sym_as] = ACTIONS(5586),
    [anon_sym_is] = ACTIONS(5586),
    [anon_sym_DASH_GT] = ACTIONS(5586),
    [anon_sym_with] = ACTIONS(5586),
    [aux_sym_preproc_if_token3] = ACTIONS(5586),
    [aux_sym_preproc_else_token1] = ACTIONS(5586),
    [aux_sym_preproc_elif_token1] = ACTIONS(5586),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4080] = {
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(6981),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9327),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4080),
    [sym_preproc_endregion] = STATE(4080),
    [sym_preproc_line] = STATE(4080),
    [sym_preproc_pragma] = STATE(4080),
    [sym_preproc_nullable] = STATE(4080),
    [sym_preproc_error] = STATE(4080),
    [sym_preproc_define] = STATE(4080),
    [sym_preproc_undef] = STATE(4080),
    [aux_sym_lambda_expression_repeat1] = STATE(6864),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4081] = {
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(6976),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9251),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4081),
    [sym_preproc_endregion] = STATE(4081),
    [sym_preproc_line] = STATE(4081),
    [sym_preproc_pragma] = STATE(4081),
    [sym_preproc_nullable] = STATE(4081),
    [sym_preproc_error] = STATE(4081),
    [sym_preproc_define] = STATE(4081),
    [sym_preproc_undef] = STATE(4081),
    [aux_sym_lambda_expression_repeat1] = STATE(6864),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(5894),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4082] = {
    [sym_preproc_region] = STATE(4082),
    [sym_preproc_endregion] = STATE(4082),
    [sym_preproc_line] = STATE(4082),
    [sym_preproc_pragma] = STATE(4082),
    [sym_preproc_nullable] = STATE(4082),
    [sym_preproc_error] = STATE(4082),
    [sym_preproc_define] = STATE(4082),
    [sym_preproc_undef] = STATE(4082),
    [anon_sym_SEMI] = ACTIONS(5842),
    [anon_sym_LBRACK] = ACTIONS(5842),
    [anon_sym_COLON] = ACTIONS(5842),
    [anon_sym_COMMA] = ACTIONS(5842),
    [anon_sym_RBRACK] = ACTIONS(5842),
    [anon_sym_LPAREN] = ACTIONS(5842),
    [anon_sym_RPAREN] = ACTIONS(5842),
    [anon_sym_RBRACE] = ACTIONS(5842),
    [anon_sym_LT] = ACTIONS(5844),
    [anon_sym_GT] = ACTIONS(5844),
    [anon_sym_in] = ACTIONS(5842),
    [anon_sym_QMARK] = ACTIONS(5844),
    [anon_sym_BANG] = ACTIONS(5844),
    [anon_sym_PLUS_PLUS] = ACTIONS(5842),
    [anon_sym_DASH_DASH] = ACTIONS(5842),
    [anon_sym_PLUS] = ACTIONS(5844),
    [anon_sym_DASH] = ACTIONS(5844),
    [anon_sym_STAR] = ACTIONS(5842),
    [anon_sym_SLASH] = ACTIONS(5844),
    [anon_sym_PERCENT] = ACTIONS(5842),
    [anon_sym_CARET] = ACTIONS(5842),
    [anon_sym_PIPE] = ACTIONS(5844),
    [anon_sym_AMP] = ACTIONS(5844),
    [anon_sym_LT_LT] = ACTIONS(5842),
    [anon_sym_GT_GT] = ACTIONS(5844),
    [anon_sym_GT_GT_GT] = ACTIONS(5842),
    [anon_sym_EQ_EQ] = ACTIONS(5842),
    [anon_sym_BANG_EQ] = ACTIONS(5842),
    [anon_sym_GT_EQ] = ACTIONS(5842),
    [anon_sym_LT_EQ] = ACTIONS(5842),
    [anon_sym_DOT] = ACTIONS(5844),
    [anon_sym_EQ_GT] = ACTIONS(5842),
    [anon_sym_switch] = ACTIONS(5842),
    [anon_sym_when] = ACTIONS(5842),
    [anon_sym_DOT_DOT] = ACTIONS(5842),
    [anon_sym_and] = ACTIONS(5842),
    [anon_sym_or] = ACTIONS(5842),
    [anon_sym_AMP_AMP] = ACTIONS(5842),
    [anon_sym_PIPE_PIPE] = ACTIONS(5842),
    [anon_sym_QMARK_QMARK] = ACTIONS(5842),
    [anon_sym_on] = ACTIONS(5842),
    [anon_sym_equals] = ACTIONS(5842),
    [anon_sym_by] = ACTIONS(5842),
    [anon_sym_as] = ACTIONS(5842),
    [anon_sym_is] = ACTIONS(5842),
    [anon_sym_DASH_GT] = ACTIONS(5842),
    [anon_sym_with] = ACTIONS(5842),
    [aux_sym_preproc_if_token3] = ACTIONS(5842),
    [aux_sym_preproc_else_token1] = ACTIONS(5842),
    [aux_sym_preproc_elif_token1] = ACTIONS(5842),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4083] = {
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(6982),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9399),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4083),
    [sym_preproc_endregion] = STATE(4083),
    [sym_preproc_line] = STATE(4083),
    [sym_preproc_pragma] = STATE(4083),
    [sym_preproc_nullable] = STATE(4083),
    [sym_preproc_error] = STATE(4083),
    [sym_preproc_define] = STATE(4083),
    [sym_preproc_undef] = STATE(4083),
    [aux_sym_lambda_expression_repeat1] = STATE(6864),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(5896),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4084] = {
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7002),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9265),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4084),
    [sym_preproc_endregion] = STATE(4084),
    [sym_preproc_line] = STATE(4084),
    [sym_preproc_pragma] = STATE(4084),
    [sym_preproc_nullable] = STATE(4084),
    [sym_preproc_error] = STATE(4084),
    [sym_preproc_define] = STATE(4084),
    [sym_preproc_undef] = STATE(4084),
    [aux_sym_lambda_expression_repeat1] = STATE(6864),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4085] = {
    [sym_preproc_region] = STATE(4085),
    [sym_preproc_endregion] = STATE(4085),
    [sym_preproc_line] = STATE(4085),
    [sym_preproc_pragma] = STATE(4085),
    [sym_preproc_nullable] = STATE(4085),
    [sym_preproc_error] = STATE(4085),
    [sym_preproc_define] = STATE(4085),
    [sym_preproc_undef] = STATE(4085),
    [anon_sym_SEMI] = ACTIONS(5385),
    [anon_sym_LBRACK] = ACTIONS(5385),
    [anon_sym_COLON] = ACTIONS(5385),
    [anon_sym_COMMA] = ACTIONS(5385),
    [anon_sym_RBRACK] = ACTIONS(5385),
    [anon_sym_LPAREN] = ACTIONS(5385),
    [anon_sym_RPAREN] = ACTIONS(5385),
    [anon_sym_RBRACE] = ACTIONS(5385),
    [anon_sym_LT] = ACTIONS(5387),
    [anon_sym_GT] = ACTIONS(5387),
    [anon_sym_in] = ACTIONS(5385),
    [anon_sym_QMARK] = ACTIONS(5387),
    [anon_sym_BANG] = ACTIONS(5387),
    [anon_sym_PLUS_PLUS] = ACTIONS(5385),
    [anon_sym_DASH_DASH] = ACTIONS(5385),
    [anon_sym_PLUS] = ACTIONS(5387),
    [anon_sym_DASH] = ACTIONS(5387),
    [anon_sym_STAR] = ACTIONS(5385),
    [anon_sym_SLASH] = ACTIONS(5387),
    [anon_sym_PERCENT] = ACTIONS(5385),
    [anon_sym_CARET] = ACTIONS(5385),
    [anon_sym_PIPE] = ACTIONS(5387),
    [anon_sym_AMP] = ACTIONS(5387),
    [anon_sym_LT_LT] = ACTIONS(5385),
    [anon_sym_GT_GT] = ACTIONS(5387),
    [anon_sym_GT_GT_GT] = ACTIONS(5385),
    [anon_sym_EQ_EQ] = ACTIONS(5385),
    [anon_sym_BANG_EQ] = ACTIONS(5385),
    [anon_sym_GT_EQ] = ACTIONS(5385),
    [anon_sym_LT_EQ] = ACTIONS(5385),
    [anon_sym_DOT] = ACTIONS(5387),
    [anon_sym_EQ_GT] = ACTIONS(5385),
    [anon_sym_switch] = ACTIONS(5385),
    [anon_sym_when] = ACTIONS(5385),
    [anon_sym_DOT_DOT] = ACTIONS(5385),
    [anon_sym_and] = ACTIONS(5385),
    [anon_sym_or] = ACTIONS(5385),
    [anon_sym_AMP_AMP] = ACTIONS(5385),
    [anon_sym_PIPE_PIPE] = ACTIONS(5385),
    [anon_sym_QMARK_QMARK] = ACTIONS(5385),
    [anon_sym_on] = ACTIONS(5385),
    [anon_sym_equals] = ACTIONS(5385),
    [anon_sym_by] = ACTIONS(5385),
    [anon_sym_as] = ACTIONS(5385),
    [anon_sym_is] = ACTIONS(5385),
    [anon_sym_DASH_GT] = ACTIONS(5385),
    [anon_sym_with] = ACTIONS(5385),
    [aux_sym_preproc_if_token3] = ACTIONS(5385),
    [aux_sym_preproc_else_token1] = ACTIONS(5385),
    [aux_sym_preproc_elif_token1] = ACTIONS(5385),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4086] = {
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7011),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9268),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4086),
    [sym_preproc_endregion] = STATE(4086),
    [sym_preproc_line] = STATE(4086),
    [sym_preproc_pragma] = STATE(4086),
    [sym_preproc_nullable] = STATE(4086),
    [sym_preproc_error] = STATE(4086),
    [sym_preproc_define] = STATE(4086),
    [sym_preproc_undef] = STATE(4086),
    [aux_sym_lambda_expression_repeat1] = STATE(6864),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(5894),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4087] = {
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(6977),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9249),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4087),
    [sym_preproc_endregion] = STATE(4087),
    [sym_preproc_line] = STATE(4087),
    [sym_preproc_pragma] = STATE(4087),
    [sym_preproc_nullable] = STATE(4087),
    [sym_preproc_error] = STATE(4087),
    [sym_preproc_define] = STATE(4087),
    [sym_preproc_undef] = STATE(4087),
    [aux_sym_lambda_expression_repeat1] = STATE(6864),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4088] = {
    [sym_preproc_region] = STATE(4088),
    [sym_preproc_endregion] = STATE(4088),
    [sym_preproc_line] = STATE(4088),
    [sym_preproc_pragma] = STATE(4088),
    [sym_preproc_nullable] = STATE(4088),
    [sym_preproc_error] = STATE(4088),
    [sym_preproc_define] = STATE(4088),
    [sym_preproc_undef] = STATE(4088),
    [anon_sym_SEMI] = ACTIONS(5408),
    [anon_sym_LBRACK] = ACTIONS(5408),
    [anon_sym_COLON] = ACTIONS(5408),
    [anon_sym_COMMA] = ACTIONS(5408),
    [anon_sym_RBRACK] = ACTIONS(5408),
    [anon_sym_LPAREN] = ACTIONS(5408),
    [anon_sym_RPAREN] = ACTIONS(5408),
    [anon_sym_RBRACE] = ACTIONS(5408),
    [anon_sym_LT] = ACTIONS(5410),
    [anon_sym_GT] = ACTIONS(5410),
    [anon_sym_in] = ACTIONS(5408),
    [anon_sym_QMARK] = ACTIONS(5410),
    [anon_sym_BANG] = ACTIONS(5410),
    [anon_sym_PLUS_PLUS] = ACTIONS(5408),
    [anon_sym_DASH_DASH] = ACTIONS(5408),
    [anon_sym_PLUS] = ACTIONS(5410),
    [anon_sym_DASH] = ACTIONS(5410),
    [anon_sym_STAR] = ACTIONS(5408),
    [anon_sym_SLASH] = ACTIONS(5410),
    [anon_sym_PERCENT] = ACTIONS(5408),
    [anon_sym_CARET] = ACTIONS(5408),
    [anon_sym_PIPE] = ACTIONS(5410),
    [anon_sym_AMP] = ACTIONS(5410),
    [anon_sym_LT_LT] = ACTIONS(5408),
    [anon_sym_GT_GT] = ACTIONS(5410),
    [anon_sym_GT_GT_GT] = ACTIONS(5408),
    [anon_sym_EQ_EQ] = ACTIONS(5408),
    [anon_sym_BANG_EQ] = ACTIONS(5408),
    [anon_sym_GT_EQ] = ACTIONS(5408),
    [anon_sym_LT_EQ] = ACTIONS(5408),
    [anon_sym_DOT] = ACTIONS(5410),
    [anon_sym_EQ_GT] = ACTIONS(5408),
    [anon_sym_switch] = ACTIONS(5408),
    [anon_sym_when] = ACTIONS(5408),
    [anon_sym_DOT_DOT] = ACTIONS(5408),
    [anon_sym_and] = ACTIONS(5408),
    [anon_sym_or] = ACTIONS(5408),
    [anon_sym_AMP_AMP] = ACTIONS(5408),
    [anon_sym_PIPE_PIPE] = ACTIONS(5408),
    [anon_sym_QMARK_QMARK] = ACTIONS(5408),
    [anon_sym_on] = ACTIONS(5408),
    [anon_sym_equals] = ACTIONS(5408),
    [anon_sym_by] = ACTIONS(5408),
    [anon_sym_as] = ACTIONS(5408),
    [anon_sym_is] = ACTIONS(5408),
    [anon_sym_DASH_GT] = ACTIONS(5408),
    [anon_sym_with] = ACTIONS(5408),
    [aux_sym_preproc_if_token3] = ACTIONS(5408),
    [aux_sym_preproc_else_token1] = ACTIONS(5408),
    [aux_sym_preproc_elif_token1] = ACTIONS(5408),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4089] = {
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(6998),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9238),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4089),
    [sym_preproc_endregion] = STATE(4089),
    [sym_preproc_line] = STATE(4089),
    [sym_preproc_pragma] = STATE(4089),
    [sym_preproc_nullable] = STATE(4089),
    [sym_preproc_error] = STATE(4089),
    [sym_preproc_define] = STATE(4089),
    [sym_preproc_undef] = STATE(4089),
    [aux_sym_lambda_expression_repeat1] = STATE(6864),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(5894),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4090] = {
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7032),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9519),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4090),
    [sym_preproc_endregion] = STATE(4090),
    [sym_preproc_line] = STATE(4090),
    [sym_preproc_pragma] = STATE(4090),
    [sym_preproc_nullable] = STATE(4090),
    [sym_preproc_error] = STATE(4090),
    [sym_preproc_define] = STATE(4090),
    [sym_preproc_undef] = STATE(4090),
    [aux_sym_lambda_expression_repeat1] = STATE(6864),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(5898),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4091] = {
    [sym_preproc_region] = STATE(4091),
    [sym_preproc_endregion] = STATE(4091),
    [sym_preproc_line] = STATE(4091),
    [sym_preproc_pragma] = STATE(4091),
    [sym_preproc_nullable] = STATE(4091),
    [sym_preproc_error] = STATE(4091),
    [sym_preproc_define] = STATE(4091),
    [sym_preproc_undef] = STATE(4091),
    [anon_sym_SEMI] = ACTIONS(5812),
    [anon_sym_LBRACK] = ACTIONS(5812),
    [anon_sym_COLON] = ACTIONS(5812),
    [anon_sym_COMMA] = ACTIONS(5812),
    [anon_sym_RBRACK] = ACTIONS(5812),
    [anon_sym_LPAREN] = ACTIONS(5812),
    [anon_sym_RPAREN] = ACTIONS(5812),
    [anon_sym_RBRACE] = ACTIONS(5812),
    [anon_sym_LT] = ACTIONS(5814),
    [anon_sym_GT] = ACTIONS(5814),
    [anon_sym_in] = ACTIONS(5812),
    [anon_sym_QMARK] = ACTIONS(5814),
    [anon_sym_BANG] = ACTIONS(5814),
    [anon_sym_PLUS_PLUS] = ACTIONS(5812),
    [anon_sym_DASH_DASH] = ACTIONS(5812),
    [anon_sym_PLUS] = ACTIONS(5814),
    [anon_sym_DASH] = ACTIONS(5814),
    [anon_sym_STAR] = ACTIONS(5812),
    [anon_sym_SLASH] = ACTIONS(5814),
    [anon_sym_PERCENT] = ACTIONS(5812),
    [anon_sym_CARET] = ACTIONS(5812),
    [anon_sym_PIPE] = ACTIONS(5814),
    [anon_sym_AMP] = ACTIONS(5814),
    [anon_sym_LT_LT] = ACTIONS(5812),
    [anon_sym_GT_GT] = ACTIONS(5814),
    [anon_sym_GT_GT_GT] = ACTIONS(5812),
    [anon_sym_EQ_EQ] = ACTIONS(5812),
    [anon_sym_BANG_EQ] = ACTIONS(5812),
    [anon_sym_GT_EQ] = ACTIONS(5812),
    [anon_sym_LT_EQ] = ACTIONS(5812),
    [anon_sym_DOT] = ACTIONS(5814),
    [anon_sym_EQ_GT] = ACTIONS(5812),
    [anon_sym_switch] = ACTIONS(5812),
    [anon_sym_when] = ACTIONS(5812),
    [anon_sym_DOT_DOT] = ACTIONS(5812),
    [anon_sym_and] = ACTIONS(5812),
    [anon_sym_or] = ACTIONS(5812),
    [anon_sym_AMP_AMP] = ACTIONS(5812),
    [anon_sym_PIPE_PIPE] = ACTIONS(5812),
    [anon_sym_QMARK_QMARK] = ACTIONS(5812),
    [anon_sym_on] = ACTIONS(5812),
    [anon_sym_equals] = ACTIONS(5812),
    [anon_sym_by] = ACTIONS(5812),
    [anon_sym_as] = ACTIONS(5812),
    [anon_sym_is] = ACTIONS(5812),
    [anon_sym_DASH_GT] = ACTIONS(5812),
    [anon_sym_with] = ACTIONS(5812),
    [aux_sym_preproc_if_token3] = ACTIONS(5812),
    [aux_sym_preproc_else_token1] = ACTIONS(5812),
    [aux_sym_preproc_elif_token1] = ACTIONS(5812),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4092] = {
    [sym_preproc_region] = STATE(4092),
    [sym_preproc_endregion] = STATE(4092),
    [sym_preproc_line] = STATE(4092),
    [sym_preproc_pragma] = STATE(4092),
    [sym_preproc_nullable] = STATE(4092),
    [sym_preproc_error] = STATE(4092),
    [sym_preproc_define] = STATE(4092),
    [sym_preproc_undef] = STATE(4092),
    [anon_sym_SEMI] = ACTIONS(5846),
    [anon_sym_LBRACK] = ACTIONS(5846),
    [anon_sym_COLON] = ACTIONS(5846),
    [anon_sym_COMMA] = ACTIONS(5846),
    [anon_sym_RBRACK] = ACTIONS(5846),
    [anon_sym_LPAREN] = ACTIONS(5846),
    [anon_sym_RPAREN] = ACTIONS(5846),
    [anon_sym_RBRACE] = ACTIONS(5846),
    [anon_sym_LT] = ACTIONS(5848),
    [anon_sym_GT] = ACTIONS(5848),
    [anon_sym_in] = ACTIONS(5846),
    [anon_sym_QMARK] = ACTIONS(5848),
    [anon_sym_BANG] = ACTIONS(5848),
    [anon_sym_PLUS_PLUS] = ACTIONS(5846),
    [anon_sym_DASH_DASH] = ACTIONS(5846),
    [anon_sym_PLUS] = ACTIONS(5848),
    [anon_sym_DASH] = ACTIONS(5848),
    [anon_sym_STAR] = ACTIONS(5846),
    [anon_sym_SLASH] = ACTIONS(5848),
    [anon_sym_PERCENT] = ACTIONS(5846),
    [anon_sym_CARET] = ACTIONS(5846),
    [anon_sym_PIPE] = ACTIONS(5848),
    [anon_sym_AMP] = ACTIONS(5848),
    [anon_sym_LT_LT] = ACTIONS(5846),
    [anon_sym_GT_GT] = ACTIONS(5848),
    [anon_sym_GT_GT_GT] = ACTIONS(5846),
    [anon_sym_EQ_EQ] = ACTIONS(5846),
    [anon_sym_BANG_EQ] = ACTIONS(5846),
    [anon_sym_GT_EQ] = ACTIONS(5846),
    [anon_sym_LT_EQ] = ACTIONS(5846),
    [anon_sym_DOT] = ACTIONS(5848),
    [anon_sym_EQ_GT] = ACTIONS(5846),
    [anon_sym_switch] = ACTIONS(5846),
    [anon_sym_when] = ACTIONS(5846),
    [anon_sym_DOT_DOT] = ACTIONS(5846),
    [anon_sym_and] = ACTIONS(5846),
    [anon_sym_or] = ACTIONS(5846),
    [anon_sym_AMP_AMP] = ACTIONS(5846),
    [anon_sym_PIPE_PIPE] = ACTIONS(5846),
    [anon_sym_QMARK_QMARK] = ACTIONS(5846),
    [anon_sym_on] = ACTIONS(5846),
    [anon_sym_equals] = ACTIONS(5846),
    [anon_sym_by] = ACTIONS(5846),
    [anon_sym_as] = ACTIONS(5846),
    [anon_sym_is] = ACTIONS(5846),
    [anon_sym_DASH_GT] = ACTIONS(5846),
    [anon_sym_with] = ACTIONS(5846),
    [aux_sym_preproc_if_token3] = ACTIONS(5846),
    [aux_sym_preproc_else_token1] = ACTIONS(5846),
    [aux_sym_preproc_elif_token1] = ACTIONS(5846),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4093] = {
    [sym_preproc_region] = STATE(4093),
    [sym_preproc_endregion] = STATE(4093),
    [sym_preproc_line] = STATE(4093),
    [sym_preproc_pragma] = STATE(4093),
    [sym_preproc_nullable] = STATE(4093),
    [sym_preproc_error] = STATE(4093),
    [sym_preproc_define] = STATE(4093),
    [sym_preproc_undef] = STATE(4093),
    [anon_sym_SEMI] = ACTIONS(5381),
    [anon_sym_LBRACK] = ACTIONS(5381),
    [anon_sym_COLON] = ACTIONS(5381),
    [anon_sym_COMMA] = ACTIONS(5381),
    [anon_sym_RBRACK] = ACTIONS(5381),
    [anon_sym_LPAREN] = ACTIONS(5381),
    [anon_sym_RPAREN] = ACTIONS(5381),
    [anon_sym_RBRACE] = ACTIONS(5381),
    [anon_sym_LT] = ACTIONS(5383),
    [anon_sym_GT] = ACTIONS(5383),
    [anon_sym_in] = ACTIONS(5381),
    [anon_sym_QMARK] = ACTIONS(5383),
    [anon_sym_BANG] = ACTIONS(5383),
    [anon_sym_PLUS_PLUS] = ACTIONS(5381),
    [anon_sym_DASH_DASH] = ACTIONS(5381),
    [anon_sym_PLUS] = ACTIONS(5383),
    [anon_sym_DASH] = ACTIONS(5383),
    [anon_sym_STAR] = ACTIONS(5381),
    [anon_sym_SLASH] = ACTIONS(5383),
    [anon_sym_PERCENT] = ACTIONS(5381),
    [anon_sym_CARET] = ACTIONS(5381),
    [anon_sym_PIPE] = ACTIONS(5383),
    [anon_sym_AMP] = ACTIONS(5383),
    [anon_sym_LT_LT] = ACTIONS(5381),
    [anon_sym_GT_GT] = ACTIONS(5383),
    [anon_sym_GT_GT_GT] = ACTIONS(5381),
    [anon_sym_EQ_EQ] = ACTIONS(5381),
    [anon_sym_BANG_EQ] = ACTIONS(5381),
    [anon_sym_GT_EQ] = ACTIONS(5381),
    [anon_sym_LT_EQ] = ACTIONS(5381),
    [anon_sym_DOT] = ACTIONS(5383),
    [anon_sym_EQ_GT] = ACTIONS(5381),
    [anon_sym_switch] = ACTIONS(5381),
    [anon_sym_when] = ACTIONS(5381),
    [anon_sym_DOT_DOT] = ACTIONS(5381),
    [anon_sym_and] = ACTIONS(5381),
    [anon_sym_or] = ACTIONS(5381),
    [anon_sym_AMP_AMP] = ACTIONS(5381),
    [anon_sym_PIPE_PIPE] = ACTIONS(5381),
    [anon_sym_QMARK_QMARK] = ACTIONS(5381),
    [anon_sym_on] = ACTIONS(5381),
    [anon_sym_equals] = ACTIONS(5381),
    [anon_sym_by] = ACTIONS(5381),
    [anon_sym_as] = ACTIONS(5381),
    [anon_sym_is] = ACTIONS(5381),
    [anon_sym_DASH_GT] = ACTIONS(5381),
    [anon_sym_with] = ACTIONS(5381),
    [aux_sym_preproc_if_token3] = ACTIONS(5381),
    [aux_sym_preproc_else_token1] = ACTIONS(5381),
    [aux_sym_preproc_elif_token1] = ACTIONS(5381),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4094] = {
    [sym_preproc_region] = STATE(4094),
    [sym_preproc_endregion] = STATE(4094),
    [sym_preproc_line] = STATE(4094),
    [sym_preproc_pragma] = STATE(4094),
    [sym_preproc_nullable] = STATE(4094),
    [sym_preproc_error] = STATE(4094),
    [sym_preproc_define] = STATE(4094),
    [sym_preproc_undef] = STATE(4094),
    [anon_sym_SEMI] = ACTIONS(5361),
    [anon_sym_LBRACK] = ACTIONS(5361),
    [anon_sym_COLON] = ACTIONS(5361),
    [anon_sym_COMMA] = ACTIONS(5361),
    [anon_sym_RBRACK] = ACTIONS(5361),
    [anon_sym_LPAREN] = ACTIONS(5361),
    [anon_sym_RPAREN] = ACTIONS(5361),
    [anon_sym_RBRACE] = ACTIONS(5361),
    [anon_sym_LT] = ACTIONS(5363),
    [anon_sym_GT] = ACTIONS(5363),
    [anon_sym_in] = ACTIONS(5361),
    [anon_sym_QMARK] = ACTIONS(5363),
    [anon_sym_BANG] = ACTIONS(5363),
    [anon_sym_PLUS_PLUS] = ACTIONS(5361),
    [anon_sym_DASH_DASH] = ACTIONS(5361),
    [anon_sym_PLUS] = ACTIONS(5363),
    [anon_sym_DASH] = ACTIONS(5363),
    [anon_sym_STAR] = ACTIONS(5361),
    [anon_sym_SLASH] = ACTIONS(5363),
    [anon_sym_PERCENT] = ACTIONS(5361),
    [anon_sym_CARET] = ACTIONS(5361),
    [anon_sym_PIPE] = ACTIONS(5363),
    [anon_sym_AMP] = ACTIONS(5363),
    [anon_sym_LT_LT] = ACTIONS(5361),
    [anon_sym_GT_GT] = ACTIONS(5363),
    [anon_sym_GT_GT_GT] = ACTIONS(5361),
    [anon_sym_EQ_EQ] = ACTIONS(5361),
    [anon_sym_BANG_EQ] = ACTIONS(5361),
    [anon_sym_GT_EQ] = ACTIONS(5361),
    [anon_sym_LT_EQ] = ACTIONS(5361),
    [anon_sym_DOT] = ACTIONS(5363),
    [anon_sym_EQ_GT] = ACTIONS(5361),
    [anon_sym_switch] = ACTIONS(5361),
    [anon_sym_when] = ACTIONS(5361),
    [anon_sym_DOT_DOT] = ACTIONS(5361),
    [anon_sym_and] = ACTIONS(5361),
    [anon_sym_or] = ACTIONS(5361),
    [anon_sym_AMP_AMP] = ACTIONS(5361),
    [anon_sym_PIPE_PIPE] = ACTIONS(5361),
    [anon_sym_QMARK_QMARK] = ACTIONS(5361),
    [anon_sym_on] = ACTIONS(5361),
    [anon_sym_equals] = ACTIONS(5361),
    [anon_sym_by] = ACTIONS(5361),
    [anon_sym_as] = ACTIONS(5361),
    [anon_sym_is] = ACTIONS(5361),
    [anon_sym_DASH_GT] = ACTIONS(5361),
    [anon_sym_with] = ACTIONS(5361),
    [aux_sym_preproc_if_token3] = ACTIONS(5361),
    [aux_sym_preproc_else_token1] = ACTIONS(5361),
    [aux_sym_preproc_elif_token1] = ACTIONS(5361),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4095] = {
    [sym_preproc_region] = STATE(4095),
    [sym_preproc_endregion] = STATE(4095),
    [sym_preproc_line] = STATE(4095),
    [sym_preproc_pragma] = STATE(4095),
    [sym_preproc_nullable] = STATE(4095),
    [sym_preproc_error] = STATE(4095),
    [sym_preproc_define] = STATE(4095),
    [sym_preproc_undef] = STATE(4095),
    [anon_sym_SEMI] = ACTIONS(5357),
    [anon_sym_LBRACK] = ACTIONS(5357),
    [anon_sym_COLON] = ACTIONS(5357),
    [anon_sym_COMMA] = ACTIONS(5357),
    [anon_sym_RBRACK] = ACTIONS(5357),
    [anon_sym_LPAREN] = ACTIONS(5357),
    [anon_sym_RPAREN] = ACTIONS(5357),
    [anon_sym_RBRACE] = ACTIONS(5357),
    [anon_sym_LT] = ACTIONS(5359),
    [anon_sym_GT] = ACTIONS(5359),
    [anon_sym_in] = ACTIONS(5357),
    [anon_sym_QMARK] = ACTIONS(5359),
    [anon_sym_BANG] = ACTIONS(5359),
    [anon_sym_PLUS_PLUS] = ACTIONS(5357),
    [anon_sym_DASH_DASH] = ACTIONS(5357),
    [anon_sym_PLUS] = ACTIONS(5359),
    [anon_sym_DASH] = ACTIONS(5359),
    [anon_sym_STAR] = ACTIONS(5357),
    [anon_sym_SLASH] = ACTIONS(5359),
    [anon_sym_PERCENT] = ACTIONS(5357),
    [anon_sym_CARET] = ACTIONS(5357),
    [anon_sym_PIPE] = ACTIONS(5359),
    [anon_sym_AMP] = ACTIONS(5359),
    [anon_sym_LT_LT] = ACTIONS(5357),
    [anon_sym_GT_GT] = ACTIONS(5359),
    [anon_sym_GT_GT_GT] = ACTIONS(5357),
    [anon_sym_EQ_EQ] = ACTIONS(5357),
    [anon_sym_BANG_EQ] = ACTIONS(5357),
    [anon_sym_GT_EQ] = ACTIONS(5357),
    [anon_sym_LT_EQ] = ACTIONS(5357),
    [anon_sym_DOT] = ACTIONS(5359),
    [anon_sym_EQ_GT] = ACTIONS(5357),
    [anon_sym_switch] = ACTIONS(5357),
    [anon_sym_when] = ACTIONS(5357),
    [anon_sym_DOT_DOT] = ACTIONS(5357),
    [anon_sym_and] = ACTIONS(5357),
    [anon_sym_or] = ACTIONS(5357),
    [anon_sym_AMP_AMP] = ACTIONS(5357),
    [anon_sym_PIPE_PIPE] = ACTIONS(5357),
    [anon_sym_QMARK_QMARK] = ACTIONS(5357),
    [anon_sym_on] = ACTIONS(5357),
    [anon_sym_equals] = ACTIONS(5357),
    [anon_sym_by] = ACTIONS(5357),
    [anon_sym_as] = ACTIONS(5357),
    [anon_sym_is] = ACTIONS(5357),
    [anon_sym_DASH_GT] = ACTIONS(5357),
    [anon_sym_with] = ACTIONS(5357),
    [aux_sym_preproc_if_token3] = ACTIONS(5357),
    [aux_sym_preproc_else_token1] = ACTIONS(5357),
    [aux_sym_preproc_elif_token1] = ACTIONS(5357),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4096] = {
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(6978),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9162),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4096),
    [sym_preproc_endregion] = STATE(4096),
    [sym_preproc_line] = STATE(4096),
    [sym_preproc_pragma] = STATE(4096),
    [sym_preproc_nullable] = STATE(4096),
    [sym_preproc_error] = STATE(4096),
    [sym_preproc_define] = STATE(4096),
    [sym_preproc_undef] = STATE(4096),
    [aux_sym_lambda_expression_repeat1] = STATE(6864),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4097] = {
    [sym_preproc_region] = STATE(4097),
    [sym_preproc_endregion] = STATE(4097),
    [sym_preproc_line] = STATE(4097),
    [sym_preproc_pragma] = STATE(4097),
    [sym_preproc_nullable] = STATE(4097),
    [sym_preproc_error] = STATE(4097),
    [sym_preproc_define] = STATE(4097),
    [sym_preproc_undef] = STATE(4097),
    [anon_sym_SEMI] = ACTIONS(5494),
    [anon_sym_LBRACK] = ACTIONS(5494),
    [anon_sym_COLON] = ACTIONS(5494),
    [anon_sym_COMMA] = ACTIONS(5494),
    [anon_sym_RBRACK] = ACTIONS(5494),
    [anon_sym_LPAREN] = ACTIONS(5494),
    [anon_sym_RPAREN] = ACTIONS(5494),
    [anon_sym_RBRACE] = ACTIONS(5494),
    [anon_sym_LT] = ACTIONS(5496),
    [anon_sym_GT] = ACTIONS(5496),
    [anon_sym_in] = ACTIONS(5494),
    [anon_sym_QMARK] = ACTIONS(5496),
    [anon_sym_BANG] = ACTIONS(5496),
    [anon_sym_PLUS_PLUS] = ACTIONS(5494),
    [anon_sym_DASH_DASH] = ACTIONS(5494),
    [anon_sym_PLUS] = ACTIONS(5496),
    [anon_sym_DASH] = ACTIONS(5496),
    [anon_sym_STAR] = ACTIONS(5494),
    [anon_sym_SLASH] = ACTIONS(5496),
    [anon_sym_PERCENT] = ACTIONS(5494),
    [anon_sym_CARET] = ACTIONS(5494),
    [anon_sym_PIPE] = ACTIONS(5496),
    [anon_sym_AMP] = ACTIONS(5496),
    [anon_sym_LT_LT] = ACTIONS(5494),
    [anon_sym_GT_GT] = ACTIONS(5496),
    [anon_sym_GT_GT_GT] = ACTIONS(5494),
    [anon_sym_EQ_EQ] = ACTIONS(5494),
    [anon_sym_BANG_EQ] = ACTIONS(5494),
    [anon_sym_GT_EQ] = ACTIONS(5494),
    [anon_sym_LT_EQ] = ACTIONS(5494),
    [anon_sym_DOT] = ACTIONS(5496),
    [anon_sym_EQ_GT] = ACTIONS(5494),
    [anon_sym_switch] = ACTIONS(5494),
    [anon_sym_when] = ACTIONS(5494),
    [anon_sym_DOT_DOT] = ACTIONS(5494),
    [anon_sym_and] = ACTIONS(5494),
    [anon_sym_or] = ACTIONS(5494),
    [anon_sym_AMP_AMP] = ACTIONS(5494),
    [anon_sym_PIPE_PIPE] = ACTIONS(5494),
    [anon_sym_QMARK_QMARK] = ACTIONS(5494),
    [anon_sym_on] = ACTIONS(5494),
    [anon_sym_equals] = ACTIONS(5494),
    [anon_sym_by] = ACTIONS(5494),
    [anon_sym_as] = ACTIONS(5494),
    [anon_sym_is] = ACTIONS(5494),
    [anon_sym_DASH_GT] = ACTIONS(5494),
    [anon_sym_with] = ACTIONS(5494),
    [aux_sym_preproc_if_token3] = ACTIONS(5494),
    [aux_sym_preproc_else_token1] = ACTIONS(5494),
    [aux_sym_preproc_elif_token1] = ACTIONS(5494),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4098] = {
    [sym_preproc_region] = STATE(4098),
    [sym_preproc_endregion] = STATE(4098),
    [sym_preproc_line] = STATE(4098),
    [sym_preproc_pragma] = STATE(4098),
    [sym_preproc_nullable] = STATE(4098),
    [sym_preproc_error] = STATE(4098),
    [sym_preproc_define] = STATE(4098),
    [sym_preproc_undef] = STATE(4098),
    [anon_sym_SEMI] = ACTIONS(5514),
    [anon_sym_LBRACK] = ACTIONS(5514),
    [anon_sym_COLON] = ACTIONS(5514),
    [anon_sym_COMMA] = ACTIONS(5514),
    [anon_sym_RBRACK] = ACTIONS(5514),
    [anon_sym_LPAREN] = ACTIONS(5514),
    [anon_sym_RPAREN] = ACTIONS(5514),
    [anon_sym_RBRACE] = ACTIONS(5514),
    [anon_sym_LT] = ACTIONS(5516),
    [anon_sym_GT] = ACTIONS(5516),
    [anon_sym_in] = ACTIONS(5514),
    [anon_sym_QMARK] = ACTIONS(5516),
    [anon_sym_BANG] = ACTIONS(5516),
    [anon_sym_PLUS_PLUS] = ACTIONS(5514),
    [anon_sym_DASH_DASH] = ACTIONS(5514),
    [anon_sym_PLUS] = ACTIONS(5516),
    [anon_sym_DASH] = ACTIONS(5516),
    [anon_sym_STAR] = ACTIONS(5514),
    [anon_sym_SLASH] = ACTIONS(5516),
    [anon_sym_PERCENT] = ACTIONS(5514),
    [anon_sym_CARET] = ACTIONS(5514),
    [anon_sym_PIPE] = ACTIONS(5516),
    [anon_sym_AMP] = ACTIONS(5516),
    [anon_sym_LT_LT] = ACTIONS(5514),
    [anon_sym_GT_GT] = ACTIONS(5516),
    [anon_sym_GT_GT_GT] = ACTIONS(5514),
    [anon_sym_EQ_EQ] = ACTIONS(5514),
    [anon_sym_BANG_EQ] = ACTIONS(5514),
    [anon_sym_GT_EQ] = ACTIONS(5514),
    [anon_sym_LT_EQ] = ACTIONS(5514),
    [anon_sym_DOT] = ACTIONS(5516),
    [anon_sym_EQ_GT] = ACTIONS(5514),
    [anon_sym_switch] = ACTIONS(5514),
    [anon_sym_when] = ACTIONS(5514),
    [anon_sym_DOT_DOT] = ACTIONS(5514),
    [anon_sym_and] = ACTIONS(5514),
    [anon_sym_or] = ACTIONS(5514),
    [anon_sym_AMP_AMP] = ACTIONS(5514),
    [anon_sym_PIPE_PIPE] = ACTIONS(5514),
    [anon_sym_QMARK_QMARK] = ACTIONS(5514),
    [anon_sym_on] = ACTIONS(5514),
    [anon_sym_equals] = ACTIONS(5514),
    [anon_sym_by] = ACTIONS(5514),
    [anon_sym_as] = ACTIONS(5514),
    [anon_sym_is] = ACTIONS(5514),
    [anon_sym_DASH_GT] = ACTIONS(5514),
    [anon_sym_with] = ACTIONS(5514),
    [aux_sym_preproc_if_token3] = ACTIONS(5514),
    [aux_sym_preproc_else_token1] = ACTIONS(5514),
    [aux_sym_preproc_elif_token1] = ACTIONS(5514),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4099] = {
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(6999),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9236),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4099),
    [sym_preproc_endregion] = STATE(4099),
    [sym_preproc_line] = STATE(4099),
    [sym_preproc_pragma] = STATE(4099),
    [sym_preproc_nullable] = STATE(4099),
    [sym_preproc_error] = STATE(4099),
    [sym_preproc_define] = STATE(4099),
    [sym_preproc_undef] = STATE(4099),
    [aux_sym_lambda_expression_repeat1] = STATE(6864),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4100] = {
    [sym_preproc_region] = STATE(4100),
    [sym_preproc_endregion] = STATE(4100),
    [sym_preproc_line] = STATE(4100),
    [sym_preproc_pragma] = STATE(4100),
    [sym_preproc_nullable] = STATE(4100),
    [sym_preproc_error] = STATE(4100),
    [sym_preproc_define] = STATE(4100),
    [sym_preproc_undef] = STATE(4100),
    [anon_sym_SEMI] = ACTIONS(5576),
    [anon_sym_LBRACK] = ACTIONS(5576),
    [anon_sym_COLON] = ACTIONS(5576),
    [anon_sym_COMMA] = ACTIONS(5576),
    [anon_sym_RBRACK] = ACTIONS(5576),
    [anon_sym_LPAREN] = ACTIONS(5576),
    [anon_sym_RPAREN] = ACTIONS(5576),
    [anon_sym_RBRACE] = ACTIONS(5576),
    [anon_sym_LT] = ACTIONS(5578),
    [anon_sym_GT] = ACTIONS(5578),
    [anon_sym_in] = ACTIONS(5576),
    [anon_sym_QMARK] = ACTIONS(5578),
    [anon_sym_BANG] = ACTIONS(5578),
    [anon_sym_PLUS_PLUS] = ACTIONS(5576),
    [anon_sym_DASH_DASH] = ACTIONS(5576),
    [anon_sym_PLUS] = ACTIONS(5578),
    [anon_sym_DASH] = ACTIONS(5578),
    [anon_sym_STAR] = ACTIONS(5576),
    [anon_sym_SLASH] = ACTIONS(5578),
    [anon_sym_PERCENT] = ACTIONS(5576),
    [anon_sym_CARET] = ACTIONS(5576),
    [anon_sym_PIPE] = ACTIONS(5578),
    [anon_sym_AMP] = ACTIONS(5578),
    [anon_sym_LT_LT] = ACTIONS(5576),
    [anon_sym_GT_GT] = ACTIONS(5578),
    [anon_sym_GT_GT_GT] = ACTIONS(5576),
    [anon_sym_EQ_EQ] = ACTIONS(5576),
    [anon_sym_BANG_EQ] = ACTIONS(5576),
    [anon_sym_GT_EQ] = ACTIONS(5576),
    [anon_sym_LT_EQ] = ACTIONS(5576),
    [anon_sym_DOT] = ACTIONS(5578),
    [anon_sym_EQ_GT] = ACTIONS(5576),
    [anon_sym_switch] = ACTIONS(5576),
    [anon_sym_when] = ACTIONS(5576),
    [anon_sym_DOT_DOT] = ACTIONS(5576),
    [anon_sym_and] = ACTIONS(5576),
    [anon_sym_or] = ACTIONS(5576),
    [anon_sym_AMP_AMP] = ACTIONS(5576),
    [anon_sym_PIPE_PIPE] = ACTIONS(5576),
    [anon_sym_QMARK_QMARK] = ACTIONS(5576),
    [anon_sym_on] = ACTIONS(5576),
    [anon_sym_equals] = ACTIONS(5576),
    [anon_sym_by] = ACTIONS(5576),
    [anon_sym_as] = ACTIONS(5576),
    [anon_sym_is] = ACTIONS(5576),
    [anon_sym_DASH_GT] = ACTIONS(5576),
    [anon_sym_with] = ACTIONS(5576),
    [aux_sym_preproc_if_token3] = ACTIONS(5576),
    [aux_sym_preproc_else_token1] = ACTIONS(5576),
    [aux_sym_preproc_elif_token1] = ACTIONS(5576),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4101] = {
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7038),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9283),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4101),
    [sym_preproc_endregion] = STATE(4101),
    [sym_preproc_line] = STATE(4101),
    [sym_preproc_pragma] = STATE(4101),
    [sym_preproc_nullable] = STATE(4101),
    [sym_preproc_error] = STATE(4101),
    [sym_preproc_define] = STATE(4101),
    [sym_preproc_undef] = STATE(4101),
    [aux_sym_lambda_expression_repeat1] = STATE(6864),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(5890),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4102] = {
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7070),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9758),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4102),
    [sym_preproc_endregion] = STATE(4102),
    [sym_preproc_line] = STATE(4102),
    [sym_preproc_pragma] = STATE(4102),
    [sym_preproc_nullable] = STATE(4102),
    [sym_preproc_error] = STATE(4102),
    [sym_preproc_define] = STATE(4102),
    [sym_preproc_undef] = STATE(4102),
    [aux_sym_lambda_expression_repeat1] = STATE(6864),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4103] = {
    [sym_preproc_region] = STATE(4103),
    [sym_preproc_endregion] = STATE(4103),
    [sym_preproc_line] = STATE(4103),
    [sym_preproc_pragma] = STATE(4103),
    [sym_preproc_nullable] = STATE(4103),
    [sym_preproc_error] = STATE(4103),
    [sym_preproc_define] = STATE(4103),
    [sym_preproc_undef] = STATE(4103),
    [anon_sym_SEMI] = ACTIONS(5870),
    [anon_sym_LBRACK] = ACTIONS(5870),
    [anon_sym_COLON] = ACTIONS(5870),
    [anon_sym_COMMA] = ACTIONS(5870),
    [anon_sym_RBRACK] = ACTIONS(5870),
    [anon_sym_LPAREN] = ACTIONS(5870),
    [anon_sym_RPAREN] = ACTIONS(5870),
    [anon_sym_RBRACE] = ACTIONS(5870),
    [anon_sym_LT] = ACTIONS(5872),
    [anon_sym_GT] = ACTIONS(5872),
    [anon_sym_in] = ACTIONS(5870),
    [anon_sym_QMARK] = ACTIONS(5872),
    [anon_sym_BANG] = ACTIONS(5872),
    [anon_sym_PLUS_PLUS] = ACTIONS(5870),
    [anon_sym_DASH_DASH] = ACTIONS(5870),
    [anon_sym_PLUS] = ACTIONS(5872),
    [anon_sym_DASH] = ACTIONS(5872),
    [anon_sym_STAR] = ACTIONS(5870),
    [anon_sym_SLASH] = ACTIONS(5872),
    [anon_sym_PERCENT] = ACTIONS(5870),
    [anon_sym_CARET] = ACTIONS(5870),
    [anon_sym_PIPE] = ACTIONS(5872),
    [anon_sym_AMP] = ACTIONS(5872),
    [anon_sym_LT_LT] = ACTIONS(5870),
    [anon_sym_GT_GT] = ACTIONS(5872),
    [anon_sym_GT_GT_GT] = ACTIONS(5870),
    [anon_sym_EQ_EQ] = ACTIONS(5870),
    [anon_sym_BANG_EQ] = ACTIONS(5870),
    [anon_sym_GT_EQ] = ACTIONS(5870),
    [anon_sym_LT_EQ] = ACTIONS(5870),
    [anon_sym_DOT] = ACTIONS(5872),
    [anon_sym_EQ_GT] = ACTIONS(5870),
    [anon_sym_switch] = ACTIONS(5870),
    [anon_sym_when] = ACTIONS(5870),
    [anon_sym_DOT_DOT] = ACTIONS(5870),
    [anon_sym_and] = ACTIONS(5870),
    [anon_sym_or] = ACTIONS(5870),
    [anon_sym_AMP_AMP] = ACTIONS(5870),
    [anon_sym_PIPE_PIPE] = ACTIONS(5870),
    [anon_sym_QMARK_QMARK] = ACTIONS(5870),
    [anon_sym_on] = ACTIONS(5870),
    [anon_sym_equals] = ACTIONS(5870),
    [anon_sym_by] = ACTIONS(5870),
    [anon_sym_as] = ACTIONS(5870),
    [anon_sym_is] = ACTIONS(5870),
    [anon_sym_DASH_GT] = ACTIONS(5870),
    [anon_sym_with] = ACTIONS(5870),
    [aux_sym_preproc_if_token3] = ACTIONS(5870),
    [aux_sym_preproc_else_token1] = ACTIONS(5870),
    [aux_sym_preproc_elif_token1] = ACTIONS(5870),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4104] = {
    [sym_preproc_region] = STATE(4104),
    [sym_preproc_endregion] = STATE(4104),
    [sym_preproc_line] = STATE(4104),
    [sym_preproc_pragma] = STATE(4104),
    [sym_preproc_nullable] = STATE(4104),
    [sym_preproc_error] = STATE(4104),
    [sym_preproc_define] = STATE(4104),
    [sym_preproc_undef] = STATE(4104),
    [anon_sym_SEMI] = ACTIONS(5353),
    [anon_sym_LBRACK] = ACTIONS(5353),
    [anon_sym_COLON] = ACTIONS(5353),
    [anon_sym_COMMA] = ACTIONS(5353),
    [anon_sym_RBRACK] = ACTIONS(5353),
    [anon_sym_LPAREN] = ACTIONS(5353),
    [anon_sym_RPAREN] = ACTIONS(5353),
    [anon_sym_RBRACE] = ACTIONS(5353),
    [anon_sym_LT] = ACTIONS(5355),
    [anon_sym_GT] = ACTIONS(5355),
    [anon_sym_in] = ACTIONS(5353),
    [anon_sym_QMARK] = ACTIONS(5355),
    [anon_sym_BANG] = ACTIONS(5355),
    [anon_sym_PLUS_PLUS] = ACTIONS(5353),
    [anon_sym_DASH_DASH] = ACTIONS(5353),
    [anon_sym_PLUS] = ACTIONS(5355),
    [anon_sym_DASH] = ACTIONS(5355),
    [anon_sym_STAR] = ACTIONS(5353),
    [anon_sym_SLASH] = ACTIONS(5355),
    [anon_sym_PERCENT] = ACTIONS(5353),
    [anon_sym_CARET] = ACTIONS(5353),
    [anon_sym_PIPE] = ACTIONS(5355),
    [anon_sym_AMP] = ACTIONS(5355),
    [anon_sym_LT_LT] = ACTIONS(5353),
    [anon_sym_GT_GT] = ACTIONS(5355),
    [anon_sym_GT_GT_GT] = ACTIONS(5353),
    [anon_sym_EQ_EQ] = ACTIONS(5353),
    [anon_sym_BANG_EQ] = ACTIONS(5353),
    [anon_sym_GT_EQ] = ACTIONS(5353),
    [anon_sym_LT_EQ] = ACTIONS(5353),
    [anon_sym_DOT] = ACTIONS(5355),
    [anon_sym_EQ_GT] = ACTIONS(5353),
    [anon_sym_switch] = ACTIONS(5353),
    [anon_sym_when] = ACTIONS(5353),
    [anon_sym_DOT_DOT] = ACTIONS(5353),
    [anon_sym_and] = ACTIONS(5353),
    [anon_sym_or] = ACTIONS(5353),
    [anon_sym_AMP_AMP] = ACTIONS(5353),
    [anon_sym_PIPE_PIPE] = ACTIONS(5353),
    [anon_sym_QMARK_QMARK] = ACTIONS(5353),
    [anon_sym_on] = ACTIONS(5353),
    [anon_sym_equals] = ACTIONS(5353),
    [anon_sym_by] = ACTIONS(5353),
    [anon_sym_as] = ACTIONS(5353),
    [anon_sym_is] = ACTIONS(5353),
    [anon_sym_DASH_GT] = ACTIONS(5353),
    [anon_sym_with] = ACTIONS(5353),
    [aux_sym_preproc_if_token3] = ACTIONS(5353),
    [aux_sym_preproc_else_token1] = ACTIONS(5353),
    [aux_sym_preproc_elif_token1] = ACTIONS(5353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4105] = {
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7014),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9229),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4105),
    [sym_preproc_endregion] = STATE(4105),
    [sym_preproc_line] = STATE(4105),
    [sym_preproc_pragma] = STATE(4105),
    [sym_preproc_nullable] = STATE(4105),
    [sym_preproc_error] = STATE(4105),
    [sym_preproc_define] = STATE(4105),
    [sym_preproc_undef] = STATE(4105),
    [aux_sym_lambda_expression_repeat1] = STATE(6864),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(5898),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4106] = {
    [sym_preproc_region] = STATE(4106),
    [sym_preproc_endregion] = STATE(4106),
    [sym_preproc_line] = STATE(4106),
    [sym_preproc_pragma] = STATE(4106),
    [sym_preproc_nullable] = STATE(4106),
    [sym_preproc_error] = STATE(4106),
    [sym_preproc_define] = STATE(4106),
    [sym_preproc_undef] = STATE(4106),
    [anon_sym_EQ] = ACTIONS(4118),
    [anon_sym_LBRACK] = ACTIONS(4133),
    [anon_sym_COLON] = ACTIONS(4739),
    [anon_sym_LPAREN] = ACTIONS(4133),
    [anon_sym_LT] = ACTIONS(4118),
    [anon_sym_GT] = ACTIONS(4118),
    [anon_sym_QMARK] = ACTIONS(4118),
    [anon_sym_BANG] = ACTIONS(4118),
    [anon_sym_PLUS_PLUS] = ACTIONS(4133),
    [anon_sym_DASH_DASH] = ACTIONS(4133),
    [anon_sym_PLUS] = ACTIONS(4118),
    [anon_sym_DASH] = ACTIONS(4118),
    [anon_sym_STAR] = ACTIONS(4118),
    [anon_sym_SLASH] = ACTIONS(4118),
    [anon_sym_PERCENT] = ACTIONS(4118),
    [anon_sym_CARET] = ACTIONS(4118),
    [anon_sym_PIPE] = ACTIONS(4118),
    [anon_sym_AMP] = ACTIONS(4118),
    [anon_sym_LT_LT] = ACTIONS(4118),
    [anon_sym_GT_GT] = ACTIONS(4118),
    [anon_sym_GT_GT_GT] = ACTIONS(4118),
    [anon_sym_EQ_EQ] = ACTIONS(4133),
    [anon_sym_BANG_EQ] = ACTIONS(4133),
    [anon_sym_GT_EQ] = ACTIONS(4133),
    [anon_sym_LT_EQ] = ACTIONS(4133),
    [anon_sym_DOT] = ACTIONS(4118),
    [anon_sym_switch] = ACTIONS(4133),
    [anon_sym_when] = ACTIONS(4739),
    [anon_sym_DOT_DOT] = ACTIONS(4133),
    [anon_sym_and] = ACTIONS(4739),
    [anon_sym_or] = ACTIONS(4739),
    [anon_sym_PLUS_EQ] = ACTIONS(4133),
    [anon_sym_DASH_EQ] = ACTIONS(4133),
    [anon_sym_STAR_EQ] = ACTIONS(4133),
    [anon_sym_SLASH_EQ] = ACTIONS(4133),
    [anon_sym_PERCENT_EQ] = ACTIONS(4133),
    [anon_sym_AMP_EQ] = ACTIONS(4133),
    [anon_sym_CARET_EQ] = ACTIONS(4133),
    [anon_sym_PIPE_EQ] = ACTIONS(4133),
    [anon_sym_LT_LT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4133),
    [anon_sym_AMP_AMP] = ACTIONS(4133),
    [anon_sym_PIPE_PIPE] = ACTIONS(4133),
    [anon_sym_QMARK_QMARK] = ACTIONS(4118),
    [anon_sym_as] = ACTIONS(4133),
    [anon_sym_is] = ACTIONS(4133),
    [anon_sym_DASH_GT] = ACTIONS(4133),
    [anon_sym_with] = ACTIONS(4133),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4107] = {
    [sym_preproc_region] = STATE(4107),
    [sym_preproc_endregion] = STATE(4107),
    [sym_preproc_line] = STATE(4107),
    [sym_preproc_pragma] = STATE(4107),
    [sym_preproc_nullable] = STATE(4107),
    [sym_preproc_error] = STATE(4107),
    [sym_preproc_define] = STATE(4107),
    [sym_preproc_undef] = STATE(4107),
    [anon_sym_SEMI] = ACTIONS(5598),
    [anon_sym_LBRACK] = ACTIONS(5598),
    [anon_sym_COLON] = ACTIONS(5598),
    [anon_sym_COMMA] = ACTIONS(5598),
    [anon_sym_RBRACK] = ACTIONS(5598),
    [anon_sym_LPAREN] = ACTIONS(5598),
    [anon_sym_RPAREN] = ACTIONS(5598),
    [anon_sym_RBRACE] = ACTIONS(5598),
    [anon_sym_LT] = ACTIONS(5600),
    [anon_sym_GT] = ACTIONS(5600),
    [anon_sym_in] = ACTIONS(5598),
    [anon_sym_QMARK] = ACTIONS(5600),
    [anon_sym_BANG] = ACTIONS(5600),
    [anon_sym_PLUS_PLUS] = ACTIONS(5598),
    [anon_sym_DASH_DASH] = ACTIONS(5598),
    [anon_sym_PLUS] = ACTIONS(5600),
    [anon_sym_DASH] = ACTIONS(5600),
    [anon_sym_STAR] = ACTIONS(5598),
    [anon_sym_SLASH] = ACTIONS(5600),
    [anon_sym_PERCENT] = ACTIONS(5598),
    [anon_sym_CARET] = ACTIONS(5598),
    [anon_sym_PIPE] = ACTIONS(5600),
    [anon_sym_AMP] = ACTIONS(5600),
    [anon_sym_LT_LT] = ACTIONS(5598),
    [anon_sym_GT_GT] = ACTIONS(5600),
    [anon_sym_GT_GT_GT] = ACTIONS(5598),
    [anon_sym_EQ_EQ] = ACTIONS(5598),
    [anon_sym_BANG_EQ] = ACTIONS(5598),
    [anon_sym_GT_EQ] = ACTIONS(5598),
    [anon_sym_LT_EQ] = ACTIONS(5598),
    [anon_sym_DOT] = ACTIONS(5600),
    [anon_sym_EQ_GT] = ACTIONS(5598),
    [anon_sym_switch] = ACTIONS(5598),
    [anon_sym_when] = ACTIONS(5598),
    [anon_sym_DOT_DOT] = ACTIONS(5598),
    [anon_sym_and] = ACTIONS(5598),
    [anon_sym_or] = ACTIONS(5598),
    [anon_sym_AMP_AMP] = ACTIONS(5598),
    [anon_sym_PIPE_PIPE] = ACTIONS(5598),
    [anon_sym_QMARK_QMARK] = ACTIONS(5598),
    [anon_sym_on] = ACTIONS(5598),
    [anon_sym_equals] = ACTIONS(5598),
    [anon_sym_by] = ACTIONS(5598),
    [anon_sym_as] = ACTIONS(5598),
    [anon_sym_is] = ACTIONS(5598),
    [anon_sym_DASH_GT] = ACTIONS(5598),
    [anon_sym_with] = ACTIONS(5598),
    [aux_sym_preproc_if_token3] = ACTIONS(5598),
    [aux_sym_preproc_else_token1] = ACTIONS(5598),
    [aux_sym_preproc_elif_token1] = ACTIONS(5598),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4108] = {
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7084),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9913),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4108),
    [sym_preproc_endregion] = STATE(4108),
    [sym_preproc_line] = STATE(4108),
    [sym_preproc_pragma] = STATE(4108),
    [sym_preproc_nullable] = STATE(4108),
    [sym_preproc_error] = STATE(4108),
    [sym_preproc_define] = STATE(4108),
    [sym_preproc_undef] = STATE(4108),
    [aux_sym_lambda_expression_repeat1] = STATE(6864),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(5890),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4109] = {
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(6947),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9124),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4109),
    [sym_preproc_endregion] = STATE(4109),
    [sym_preproc_line] = STATE(4109),
    [sym_preproc_pragma] = STATE(4109),
    [sym_preproc_nullable] = STATE(4109),
    [sym_preproc_error] = STATE(4109),
    [sym_preproc_define] = STATE(4109),
    [sym_preproc_undef] = STATE(4109),
    [aux_sym_lambda_expression_repeat1] = STATE(6864),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4110] = {
    [sym_preproc_region] = STATE(4110),
    [sym_preproc_endregion] = STATE(4110),
    [sym_preproc_line] = STATE(4110),
    [sym_preproc_pragma] = STATE(4110),
    [sym_preproc_nullable] = STATE(4110),
    [sym_preproc_error] = STATE(4110),
    [sym_preproc_define] = STATE(4110),
    [sym_preproc_undef] = STATE(4110),
    [anon_sym_SEMI] = ACTIONS(5590),
    [anon_sym_LBRACK] = ACTIONS(5590),
    [anon_sym_COLON] = ACTIONS(5590),
    [anon_sym_COMMA] = ACTIONS(5590),
    [anon_sym_RBRACK] = ACTIONS(5590),
    [anon_sym_LPAREN] = ACTIONS(5590),
    [anon_sym_RPAREN] = ACTIONS(5590),
    [anon_sym_RBRACE] = ACTIONS(5590),
    [anon_sym_LT] = ACTIONS(5592),
    [anon_sym_GT] = ACTIONS(5592),
    [anon_sym_in] = ACTIONS(5590),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_BANG] = ACTIONS(5592),
    [anon_sym_PLUS_PLUS] = ACTIONS(5590),
    [anon_sym_DASH_DASH] = ACTIONS(5590),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_DASH] = ACTIONS(5592),
    [anon_sym_STAR] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [anon_sym_PERCENT] = ACTIONS(5590),
    [anon_sym_CARET] = ACTIONS(5590),
    [anon_sym_PIPE] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5590),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_GT_GT_GT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_BANG_EQ] = ACTIONS(5590),
    [anon_sym_GT_EQ] = ACTIONS(5590),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_DOT] = ACTIONS(5592),
    [anon_sym_EQ_GT] = ACTIONS(5590),
    [anon_sym_switch] = ACTIONS(5590),
    [anon_sym_when] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5590),
    [anon_sym_or] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5590),
    [anon_sym_PIPE_PIPE] = ACTIONS(5590),
    [anon_sym_QMARK_QMARK] = ACTIONS(5590),
    [anon_sym_on] = ACTIONS(5590),
    [anon_sym_equals] = ACTIONS(5590),
    [anon_sym_by] = ACTIONS(5590),
    [anon_sym_as] = ACTIONS(5590),
    [anon_sym_is] = ACTIONS(5590),
    [anon_sym_DASH_GT] = ACTIONS(5590),
    [anon_sym_with] = ACTIONS(5590),
    [aux_sym_preproc_if_token3] = ACTIONS(5590),
    [aux_sym_preproc_else_token1] = ACTIONS(5590),
    [aux_sym_preproc_elif_token1] = ACTIONS(5590),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4111] = {
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7119),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9293),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4111),
    [sym_preproc_endregion] = STATE(4111),
    [sym_preproc_line] = STATE(4111),
    [sym_preproc_pragma] = STATE(4111),
    [sym_preproc_nullable] = STATE(4111),
    [sym_preproc_error] = STATE(4111),
    [sym_preproc_define] = STATE(4111),
    [sym_preproc_undef] = STATE(4111),
    [aux_sym_lambda_expression_repeat1] = STATE(6864),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4112] = {
    [sym_preproc_region] = STATE(4112),
    [sym_preproc_endregion] = STATE(4112),
    [sym_preproc_line] = STATE(4112),
    [sym_preproc_pragma] = STATE(4112),
    [sym_preproc_nullable] = STATE(4112),
    [sym_preproc_error] = STATE(4112),
    [sym_preproc_define] = STATE(4112),
    [sym_preproc_undef] = STATE(4112),
    [anon_sym_SEMI] = ACTIONS(2935),
    [anon_sym_LBRACK] = ACTIONS(2935),
    [anon_sym_COLON] = ACTIONS(2935),
    [anon_sym_COMMA] = ACTIONS(2935),
    [anon_sym_RBRACK] = ACTIONS(2935),
    [anon_sym_LPAREN] = ACTIONS(2935),
    [anon_sym_RPAREN] = ACTIONS(2935),
    [anon_sym_RBRACE] = ACTIONS(2935),
    [anon_sym_LT] = ACTIONS(2933),
    [anon_sym_GT] = ACTIONS(2933),
    [anon_sym_in] = ACTIONS(2935),
    [anon_sym_QMARK] = ACTIONS(2933),
    [anon_sym_BANG] = ACTIONS(2933),
    [anon_sym_PLUS_PLUS] = ACTIONS(2935),
    [anon_sym_DASH_DASH] = ACTIONS(2935),
    [anon_sym_PLUS] = ACTIONS(2933),
    [anon_sym_DASH] = ACTIONS(2933),
    [anon_sym_STAR] = ACTIONS(2935),
    [anon_sym_SLASH] = ACTIONS(2933),
    [anon_sym_PERCENT] = ACTIONS(2935),
    [anon_sym_CARET] = ACTIONS(2935),
    [anon_sym_PIPE] = ACTIONS(2933),
    [anon_sym_AMP] = ACTIONS(2933),
    [anon_sym_LT_LT] = ACTIONS(2935),
    [anon_sym_GT_GT] = ACTIONS(2933),
    [anon_sym_GT_GT_GT] = ACTIONS(2935),
    [anon_sym_EQ_EQ] = ACTIONS(2935),
    [anon_sym_BANG_EQ] = ACTIONS(2935),
    [anon_sym_GT_EQ] = ACTIONS(2935),
    [anon_sym_LT_EQ] = ACTIONS(2935),
    [anon_sym_DOT] = ACTIONS(2933),
    [anon_sym_EQ_GT] = ACTIONS(2935),
    [anon_sym_switch] = ACTIONS(2935),
    [anon_sym_when] = ACTIONS(2935),
    [anon_sym_DOT_DOT] = ACTIONS(2935),
    [anon_sym_and] = ACTIONS(2935),
    [anon_sym_or] = ACTIONS(2935),
    [anon_sym_AMP_AMP] = ACTIONS(2935),
    [anon_sym_PIPE_PIPE] = ACTIONS(2935),
    [anon_sym_QMARK_QMARK] = ACTIONS(2935),
    [anon_sym_on] = ACTIONS(2935),
    [anon_sym_equals] = ACTIONS(2935),
    [anon_sym_by] = ACTIONS(2935),
    [anon_sym_as] = ACTIONS(2935),
    [anon_sym_is] = ACTIONS(2935),
    [anon_sym_DASH_GT] = ACTIONS(2935),
    [anon_sym_with] = ACTIONS(2935),
    [aux_sym_preproc_if_token3] = ACTIONS(2935),
    [aux_sym_preproc_else_token1] = ACTIONS(2935),
    [aux_sym_preproc_elif_token1] = ACTIONS(2935),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4113] = {
    [sym_preproc_region] = STATE(4113),
    [sym_preproc_endregion] = STATE(4113),
    [sym_preproc_line] = STATE(4113),
    [sym_preproc_pragma] = STATE(4113),
    [sym_preproc_nullable] = STATE(4113),
    [sym_preproc_error] = STATE(4113),
    [sym_preproc_define] = STATE(4113),
    [sym_preproc_undef] = STATE(4113),
    [anon_sym_SEMI] = ACTIONS(5878),
    [anon_sym_LBRACK] = ACTIONS(5878),
    [anon_sym_COLON] = ACTIONS(5878),
    [anon_sym_COMMA] = ACTIONS(5878),
    [anon_sym_RBRACK] = ACTIONS(5878),
    [anon_sym_LPAREN] = ACTIONS(5878),
    [anon_sym_RPAREN] = ACTIONS(5878),
    [anon_sym_RBRACE] = ACTIONS(5878),
    [anon_sym_LT] = ACTIONS(5880),
    [anon_sym_GT] = ACTIONS(5880),
    [anon_sym_in] = ACTIONS(5878),
    [anon_sym_QMARK] = ACTIONS(5880),
    [anon_sym_BANG] = ACTIONS(5880),
    [anon_sym_PLUS_PLUS] = ACTIONS(5878),
    [anon_sym_DASH_DASH] = ACTIONS(5878),
    [anon_sym_PLUS] = ACTIONS(5880),
    [anon_sym_DASH] = ACTIONS(5880),
    [anon_sym_STAR] = ACTIONS(5878),
    [anon_sym_SLASH] = ACTIONS(5880),
    [anon_sym_PERCENT] = ACTIONS(5878),
    [anon_sym_CARET] = ACTIONS(5878),
    [anon_sym_PIPE] = ACTIONS(5880),
    [anon_sym_AMP] = ACTIONS(5880),
    [anon_sym_LT_LT] = ACTIONS(5878),
    [anon_sym_GT_GT] = ACTIONS(5880),
    [anon_sym_GT_GT_GT] = ACTIONS(5878),
    [anon_sym_EQ_EQ] = ACTIONS(5878),
    [anon_sym_BANG_EQ] = ACTIONS(5878),
    [anon_sym_GT_EQ] = ACTIONS(5878),
    [anon_sym_LT_EQ] = ACTIONS(5878),
    [anon_sym_DOT] = ACTIONS(5880),
    [anon_sym_EQ_GT] = ACTIONS(5878),
    [anon_sym_switch] = ACTIONS(5878),
    [anon_sym_when] = ACTIONS(5878),
    [anon_sym_DOT_DOT] = ACTIONS(5878),
    [anon_sym_and] = ACTIONS(5878),
    [anon_sym_or] = ACTIONS(5878),
    [anon_sym_AMP_AMP] = ACTIONS(5878),
    [anon_sym_PIPE_PIPE] = ACTIONS(5878),
    [anon_sym_QMARK_QMARK] = ACTIONS(5878),
    [anon_sym_on] = ACTIONS(5878),
    [anon_sym_equals] = ACTIONS(5878),
    [anon_sym_by] = ACTIONS(5878),
    [anon_sym_as] = ACTIONS(5878),
    [anon_sym_is] = ACTIONS(5878),
    [anon_sym_DASH_GT] = ACTIONS(5878),
    [anon_sym_with] = ACTIONS(5878),
    [aux_sym_preproc_if_token3] = ACTIONS(5878),
    [aux_sym_preproc_else_token1] = ACTIONS(5878),
    [aux_sym_preproc_elif_token1] = ACTIONS(5878),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4114] = {
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7110),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9295),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4114),
    [sym_preproc_endregion] = STATE(4114),
    [sym_preproc_line] = STATE(4114),
    [sym_preproc_pragma] = STATE(4114),
    [sym_preproc_nullable] = STATE(4114),
    [sym_preproc_error] = STATE(4114),
    [sym_preproc_define] = STATE(4114),
    [sym_preproc_undef] = STATE(4114),
    [aux_sym_lambda_expression_repeat1] = STATE(6864),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(5890),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4115] = {
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7030),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9305),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4115),
    [sym_preproc_endregion] = STATE(4115),
    [sym_preproc_line] = STATE(4115),
    [sym_preproc_pragma] = STATE(4115),
    [sym_preproc_nullable] = STATE(4115),
    [sym_preproc_error] = STATE(4115),
    [sym_preproc_define] = STATE(4115),
    [sym_preproc_undef] = STATE(4115),
    [aux_sym_lambda_expression_repeat1] = STATE(6864),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4116] = {
    [sym_preproc_region] = STATE(4116),
    [sym_preproc_endregion] = STATE(4116),
    [sym_preproc_line] = STATE(4116),
    [sym_preproc_pragma] = STATE(4116),
    [sym_preproc_nullable] = STATE(4116),
    [sym_preproc_error] = STATE(4116),
    [sym_preproc_define] = STATE(4116),
    [sym_preproc_undef] = STATE(4116),
    [anon_sym_SEMI] = ACTIONS(5325),
    [anon_sym_LBRACK] = ACTIONS(5325),
    [anon_sym_COLON] = ACTIONS(5325),
    [anon_sym_COMMA] = ACTIONS(5325),
    [anon_sym_RBRACK] = ACTIONS(5325),
    [anon_sym_LPAREN] = ACTIONS(5325),
    [anon_sym_RPAREN] = ACTIONS(5325),
    [anon_sym_RBRACE] = ACTIONS(5325),
    [anon_sym_LT] = ACTIONS(5327),
    [anon_sym_GT] = ACTIONS(5327),
    [anon_sym_in] = ACTIONS(5325),
    [anon_sym_QMARK] = ACTIONS(5327),
    [anon_sym_BANG] = ACTIONS(5327),
    [anon_sym_PLUS_PLUS] = ACTIONS(5325),
    [anon_sym_DASH_DASH] = ACTIONS(5325),
    [anon_sym_PLUS] = ACTIONS(5327),
    [anon_sym_DASH] = ACTIONS(5327),
    [anon_sym_STAR] = ACTIONS(5325),
    [anon_sym_SLASH] = ACTIONS(5327),
    [anon_sym_PERCENT] = ACTIONS(5325),
    [anon_sym_CARET] = ACTIONS(5325),
    [anon_sym_PIPE] = ACTIONS(5327),
    [anon_sym_AMP] = ACTIONS(5327),
    [anon_sym_LT_LT] = ACTIONS(5325),
    [anon_sym_GT_GT] = ACTIONS(5327),
    [anon_sym_GT_GT_GT] = ACTIONS(5325),
    [anon_sym_EQ_EQ] = ACTIONS(5325),
    [anon_sym_BANG_EQ] = ACTIONS(5325),
    [anon_sym_GT_EQ] = ACTIONS(5325),
    [anon_sym_LT_EQ] = ACTIONS(5325),
    [anon_sym_DOT] = ACTIONS(5327),
    [anon_sym_EQ_GT] = ACTIONS(5325),
    [anon_sym_switch] = ACTIONS(5325),
    [anon_sym_when] = ACTIONS(5325),
    [anon_sym_DOT_DOT] = ACTIONS(5325),
    [anon_sym_and] = ACTIONS(5325),
    [anon_sym_or] = ACTIONS(5325),
    [anon_sym_AMP_AMP] = ACTIONS(5325),
    [anon_sym_PIPE_PIPE] = ACTIONS(5325),
    [anon_sym_QMARK_QMARK] = ACTIONS(5325),
    [anon_sym_on] = ACTIONS(5325),
    [anon_sym_equals] = ACTIONS(5325),
    [anon_sym_by] = ACTIONS(5325),
    [anon_sym_as] = ACTIONS(5325),
    [anon_sym_is] = ACTIONS(5325),
    [anon_sym_DASH_GT] = ACTIONS(5325),
    [anon_sym_with] = ACTIONS(5325),
    [aux_sym_preproc_if_token3] = ACTIONS(5325),
    [aux_sym_preproc_else_token1] = ACTIONS(5325),
    [aux_sym_preproc_elif_token1] = ACTIONS(5325),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4117] = {
    [sym_preproc_region] = STATE(4117),
    [sym_preproc_endregion] = STATE(4117),
    [sym_preproc_line] = STATE(4117),
    [sym_preproc_pragma] = STATE(4117),
    [sym_preproc_nullable] = STATE(4117),
    [sym_preproc_error] = STATE(4117),
    [sym_preproc_define] = STATE(4117),
    [sym_preproc_undef] = STATE(4117),
    [anon_sym_SEMI] = ACTIONS(5820),
    [anon_sym_LBRACK] = ACTIONS(5820),
    [anon_sym_COLON] = ACTIONS(5820),
    [anon_sym_COMMA] = ACTIONS(5820),
    [anon_sym_RBRACK] = ACTIONS(5820),
    [anon_sym_LPAREN] = ACTIONS(5820),
    [anon_sym_RPAREN] = ACTIONS(5820),
    [anon_sym_RBRACE] = ACTIONS(5820),
    [anon_sym_LT] = ACTIONS(5822),
    [anon_sym_GT] = ACTIONS(5822),
    [anon_sym_in] = ACTIONS(5820),
    [anon_sym_QMARK] = ACTIONS(5822),
    [anon_sym_BANG] = ACTIONS(5822),
    [anon_sym_PLUS_PLUS] = ACTIONS(5820),
    [anon_sym_DASH_DASH] = ACTIONS(5820),
    [anon_sym_PLUS] = ACTIONS(5822),
    [anon_sym_DASH] = ACTIONS(5822),
    [anon_sym_STAR] = ACTIONS(5820),
    [anon_sym_SLASH] = ACTIONS(5822),
    [anon_sym_PERCENT] = ACTIONS(5820),
    [anon_sym_CARET] = ACTIONS(5820),
    [anon_sym_PIPE] = ACTIONS(5822),
    [anon_sym_AMP] = ACTIONS(5822),
    [anon_sym_LT_LT] = ACTIONS(5820),
    [anon_sym_GT_GT] = ACTIONS(5822),
    [anon_sym_GT_GT_GT] = ACTIONS(5820),
    [anon_sym_EQ_EQ] = ACTIONS(5820),
    [anon_sym_BANG_EQ] = ACTIONS(5820),
    [anon_sym_GT_EQ] = ACTIONS(5820),
    [anon_sym_LT_EQ] = ACTIONS(5820),
    [anon_sym_DOT] = ACTIONS(5822),
    [anon_sym_EQ_GT] = ACTIONS(5820),
    [anon_sym_switch] = ACTIONS(5820),
    [anon_sym_when] = ACTIONS(5820),
    [anon_sym_DOT_DOT] = ACTIONS(5820),
    [anon_sym_and] = ACTIONS(5820),
    [anon_sym_or] = ACTIONS(5820),
    [anon_sym_AMP_AMP] = ACTIONS(5820),
    [anon_sym_PIPE_PIPE] = ACTIONS(5820),
    [anon_sym_QMARK_QMARK] = ACTIONS(5820),
    [anon_sym_on] = ACTIONS(5820),
    [anon_sym_equals] = ACTIONS(5820),
    [anon_sym_by] = ACTIONS(5820),
    [anon_sym_as] = ACTIONS(5820),
    [anon_sym_is] = ACTIONS(5820),
    [anon_sym_DASH_GT] = ACTIONS(5820),
    [anon_sym_with] = ACTIONS(5820),
    [aux_sym_preproc_if_token3] = ACTIONS(5820),
    [aux_sym_preproc_else_token1] = ACTIONS(5820),
    [aux_sym_preproc_elif_token1] = ACTIONS(5820),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4118] = {
    [sym_preproc_region] = STATE(4118),
    [sym_preproc_endregion] = STATE(4118),
    [sym_preproc_line] = STATE(4118),
    [sym_preproc_pragma] = STATE(4118),
    [sym_preproc_nullable] = STATE(4118),
    [sym_preproc_error] = STATE(4118),
    [sym_preproc_define] = STATE(4118),
    [sym_preproc_undef] = STATE(4118),
    [anon_sym_SEMI] = ACTIONS(5874),
    [anon_sym_LBRACK] = ACTIONS(5874),
    [anon_sym_COLON] = ACTIONS(5874),
    [anon_sym_COMMA] = ACTIONS(5874),
    [anon_sym_RBRACK] = ACTIONS(5874),
    [anon_sym_LPAREN] = ACTIONS(5874),
    [anon_sym_RPAREN] = ACTIONS(5874),
    [anon_sym_RBRACE] = ACTIONS(5874),
    [anon_sym_LT] = ACTIONS(5876),
    [anon_sym_GT] = ACTIONS(5876),
    [anon_sym_in] = ACTIONS(5874),
    [anon_sym_QMARK] = ACTIONS(5876),
    [anon_sym_BANG] = ACTIONS(5876),
    [anon_sym_PLUS_PLUS] = ACTIONS(5874),
    [anon_sym_DASH_DASH] = ACTIONS(5874),
    [anon_sym_PLUS] = ACTIONS(5876),
    [anon_sym_DASH] = ACTIONS(5876),
    [anon_sym_STAR] = ACTIONS(5874),
    [anon_sym_SLASH] = ACTIONS(5876),
    [anon_sym_PERCENT] = ACTIONS(5874),
    [anon_sym_CARET] = ACTIONS(5874),
    [anon_sym_PIPE] = ACTIONS(5876),
    [anon_sym_AMP] = ACTIONS(5876),
    [anon_sym_LT_LT] = ACTIONS(5874),
    [anon_sym_GT_GT] = ACTIONS(5876),
    [anon_sym_GT_GT_GT] = ACTIONS(5874),
    [anon_sym_EQ_EQ] = ACTIONS(5874),
    [anon_sym_BANG_EQ] = ACTIONS(5874),
    [anon_sym_GT_EQ] = ACTIONS(5874),
    [anon_sym_LT_EQ] = ACTIONS(5874),
    [anon_sym_DOT] = ACTIONS(5876),
    [anon_sym_EQ_GT] = ACTIONS(5874),
    [anon_sym_switch] = ACTIONS(5874),
    [anon_sym_when] = ACTIONS(5874),
    [anon_sym_DOT_DOT] = ACTIONS(5874),
    [anon_sym_and] = ACTIONS(5874),
    [anon_sym_or] = ACTIONS(5874),
    [anon_sym_AMP_AMP] = ACTIONS(5874),
    [anon_sym_PIPE_PIPE] = ACTIONS(5874),
    [anon_sym_QMARK_QMARK] = ACTIONS(5874),
    [anon_sym_on] = ACTIONS(5874),
    [anon_sym_equals] = ACTIONS(5874),
    [anon_sym_by] = ACTIONS(5874),
    [anon_sym_as] = ACTIONS(5874),
    [anon_sym_is] = ACTIONS(5874),
    [anon_sym_DASH_GT] = ACTIONS(5874),
    [anon_sym_with] = ACTIONS(5874),
    [aux_sym_preproc_if_token3] = ACTIONS(5874),
    [aux_sym_preproc_else_token1] = ACTIONS(5874),
    [aux_sym_preproc_elif_token1] = ACTIONS(5874),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4119] = {
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7078),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9173),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4119),
    [sym_preproc_endregion] = STATE(4119),
    [sym_preproc_line] = STATE(4119),
    [sym_preproc_pragma] = STATE(4119),
    [sym_preproc_nullable] = STATE(4119),
    [sym_preproc_error] = STATE(4119),
    [sym_preproc_define] = STATE(4119),
    [sym_preproc_undef] = STATE(4119),
    [aux_sym_lambda_expression_repeat1] = STATE(6864),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(5894),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4120] = {
    [sym_preproc_region] = STATE(4120),
    [sym_preproc_endregion] = STATE(4120),
    [sym_preproc_line] = STATE(4120),
    [sym_preproc_pragma] = STATE(4120),
    [sym_preproc_nullable] = STATE(4120),
    [sym_preproc_error] = STATE(4120),
    [sym_preproc_define] = STATE(4120),
    [sym_preproc_undef] = STATE(4120),
    [anon_sym_EQ] = ACTIONS(5900),
    [anon_sym_LBRACK] = ACTIONS(5249),
    [anon_sym_COMMA] = ACTIONS(5249),
    [anon_sym_RBRACK] = ACTIONS(5249),
    [anon_sym_LPAREN] = ACTIONS(5249),
    [anon_sym_RPAREN] = ACTIONS(5249),
    [anon_sym_RBRACE] = ACTIONS(5249),
    [anon_sym_LT] = ACTIONS(5251),
    [anon_sym_GT] = ACTIONS(5251),
    [anon_sym_QMARK] = ACTIONS(5251),
    [anon_sym_BANG] = ACTIONS(5251),
    [anon_sym_PLUS_PLUS] = ACTIONS(5249),
    [anon_sym_DASH_DASH] = ACTIONS(5249),
    [anon_sym_PLUS] = ACTIONS(5251),
    [anon_sym_DASH] = ACTIONS(5251),
    [anon_sym_STAR] = ACTIONS(5251),
    [anon_sym_SLASH] = ACTIONS(5251),
    [anon_sym_PERCENT] = ACTIONS(5251),
    [anon_sym_CARET] = ACTIONS(5251),
    [anon_sym_PIPE] = ACTIONS(5251),
    [anon_sym_AMP] = ACTIONS(5251),
    [anon_sym_LT_LT] = ACTIONS(5251),
    [anon_sym_GT_GT] = ACTIONS(5251),
    [anon_sym_GT_GT_GT] = ACTIONS(5251),
    [anon_sym_EQ_EQ] = ACTIONS(5249),
    [anon_sym_BANG_EQ] = ACTIONS(5249),
    [anon_sym_GT_EQ] = ACTIONS(5249),
    [anon_sym_LT_EQ] = ACTIONS(5249),
    [anon_sym_DOT] = ACTIONS(5251),
    [anon_sym_switch] = ACTIONS(5249),
    [anon_sym_DOT_DOT] = ACTIONS(5249),
    [anon_sym_PLUS_EQ] = ACTIONS(5902),
    [anon_sym_DASH_EQ] = ACTIONS(5902),
    [anon_sym_STAR_EQ] = ACTIONS(5902),
    [anon_sym_SLASH_EQ] = ACTIONS(5902),
    [anon_sym_PERCENT_EQ] = ACTIONS(5902),
    [anon_sym_AMP_EQ] = ACTIONS(5902),
    [anon_sym_CARET_EQ] = ACTIONS(5902),
    [anon_sym_PIPE_EQ] = ACTIONS(5902),
    [anon_sym_LT_LT_EQ] = ACTIONS(5902),
    [anon_sym_GT_GT_EQ] = ACTIONS(5902),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5902),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(5902),
    [anon_sym_AMP_AMP] = ACTIONS(5249),
    [anon_sym_PIPE_PIPE] = ACTIONS(5249),
    [anon_sym_QMARK_QMARK] = ACTIONS(5251),
    [anon_sym_as] = ACTIONS(5249),
    [anon_sym_is] = ACTIONS(5249),
    [anon_sym_DASH_GT] = ACTIONS(5249),
    [anon_sym_with] = ACTIONS(5249),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4121] = {
    [sym_preproc_region] = STATE(4121),
    [sym_preproc_endregion] = STATE(4121),
    [sym_preproc_line] = STATE(4121),
    [sym_preproc_pragma] = STATE(4121),
    [sym_preproc_nullable] = STATE(4121),
    [sym_preproc_error] = STATE(4121),
    [sym_preproc_define] = STATE(4121),
    [sym_preproc_undef] = STATE(4121),
    [anon_sym_SEMI] = ACTIONS(5582),
    [anon_sym_LBRACK] = ACTIONS(5582),
    [anon_sym_COLON] = ACTIONS(5582),
    [anon_sym_COMMA] = ACTIONS(5582),
    [anon_sym_RBRACK] = ACTIONS(5582),
    [anon_sym_LPAREN] = ACTIONS(5582),
    [anon_sym_RPAREN] = ACTIONS(5582),
    [anon_sym_RBRACE] = ACTIONS(5582),
    [anon_sym_LT] = ACTIONS(5584),
    [anon_sym_GT] = ACTIONS(5584),
    [anon_sym_in] = ACTIONS(5582),
    [anon_sym_QMARK] = ACTIONS(5584),
    [anon_sym_BANG] = ACTIONS(5584),
    [anon_sym_PLUS_PLUS] = ACTIONS(5582),
    [anon_sym_DASH_DASH] = ACTIONS(5582),
    [anon_sym_PLUS] = ACTIONS(5584),
    [anon_sym_DASH] = ACTIONS(5584),
    [anon_sym_STAR] = ACTIONS(5582),
    [anon_sym_SLASH] = ACTIONS(5584),
    [anon_sym_PERCENT] = ACTIONS(5582),
    [anon_sym_CARET] = ACTIONS(5582),
    [anon_sym_PIPE] = ACTIONS(5584),
    [anon_sym_AMP] = ACTIONS(5584),
    [anon_sym_LT_LT] = ACTIONS(5582),
    [anon_sym_GT_GT] = ACTIONS(5584),
    [anon_sym_GT_GT_GT] = ACTIONS(5582),
    [anon_sym_EQ_EQ] = ACTIONS(5582),
    [anon_sym_BANG_EQ] = ACTIONS(5582),
    [anon_sym_GT_EQ] = ACTIONS(5582),
    [anon_sym_LT_EQ] = ACTIONS(5582),
    [anon_sym_DOT] = ACTIONS(5584),
    [anon_sym_EQ_GT] = ACTIONS(5582),
    [anon_sym_switch] = ACTIONS(5582),
    [anon_sym_when] = ACTIONS(5582),
    [anon_sym_DOT_DOT] = ACTIONS(5582),
    [anon_sym_and] = ACTIONS(5582),
    [anon_sym_or] = ACTIONS(5582),
    [anon_sym_AMP_AMP] = ACTIONS(5582),
    [anon_sym_PIPE_PIPE] = ACTIONS(5582),
    [anon_sym_QMARK_QMARK] = ACTIONS(5582),
    [anon_sym_on] = ACTIONS(5582),
    [anon_sym_equals] = ACTIONS(5582),
    [anon_sym_by] = ACTIONS(5582),
    [anon_sym_as] = ACTIONS(5582),
    [anon_sym_is] = ACTIONS(5582),
    [anon_sym_DASH_GT] = ACTIONS(5582),
    [anon_sym_with] = ACTIONS(5582),
    [aux_sym_preproc_if_token3] = ACTIONS(5582),
    [aux_sym_preproc_else_token1] = ACTIONS(5582),
    [aux_sym_preproc_elif_token1] = ACTIONS(5582),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4122] = {
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7029),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9307),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4122),
    [sym_preproc_endregion] = STATE(4122),
    [sym_preproc_line] = STATE(4122),
    [sym_preproc_pragma] = STATE(4122),
    [sym_preproc_nullable] = STATE(4122),
    [sym_preproc_error] = STATE(4122),
    [sym_preproc_define] = STATE(4122),
    [sym_preproc_undef] = STATE(4122),
    [aux_sym_lambda_expression_repeat1] = STATE(6864),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(5892),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4123] = {
    [sym_preproc_region] = STATE(4123),
    [sym_preproc_endregion] = STATE(4123),
    [sym_preproc_line] = STATE(4123),
    [sym_preproc_pragma] = STATE(4123),
    [sym_preproc_nullable] = STATE(4123),
    [sym_preproc_error] = STATE(4123),
    [sym_preproc_define] = STATE(4123),
    [sym_preproc_undef] = STATE(4123),
    [anon_sym_SEMI] = ACTIONS(5767),
    [anon_sym_LBRACK] = ACTIONS(5767),
    [anon_sym_COLON] = ACTIONS(5767),
    [anon_sym_COMMA] = ACTIONS(5767),
    [anon_sym_RBRACK] = ACTIONS(5767),
    [anon_sym_LPAREN] = ACTIONS(5767),
    [anon_sym_RPAREN] = ACTIONS(5767),
    [anon_sym_RBRACE] = ACTIONS(5767),
    [anon_sym_LT] = ACTIONS(5769),
    [anon_sym_GT] = ACTIONS(5769),
    [anon_sym_in] = ACTIONS(5767),
    [anon_sym_QMARK] = ACTIONS(5769),
    [anon_sym_BANG] = ACTIONS(5769),
    [anon_sym_PLUS_PLUS] = ACTIONS(5767),
    [anon_sym_DASH_DASH] = ACTIONS(5767),
    [anon_sym_PLUS] = ACTIONS(5769),
    [anon_sym_DASH] = ACTIONS(5769),
    [anon_sym_STAR] = ACTIONS(5767),
    [anon_sym_SLASH] = ACTIONS(5769),
    [anon_sym_PERCENT] = ACTIONS(5767),
    [anon_sym_CARET] = ACTIONS(5767),
    [anon_sym_PIPE] = ACTIONS(5769),
    [anon_sym_AMP] = ACTIONS(5769),
    [anon_sym_LT_LT] = ACTIONS(5767),
    [anon_sym_GT_GT] = ACTIONS(5769),
    [anon_sym_GT_GT_GT] = ACTIONS(5767),
    [anon_sym_EQ_EQ] = ACTIONS(5767),
    [anon_sym_BANG_EQ] = ACTIONS(5767),
    [anon_sym_GT_EQ] = ACTIONS(5767),
    [anon_sym_LT_EQ] = ACTIONS(5767),
    [anon_sym_DOT] = ACTIONS(5769),
    [anon_sym_EQ_GT] = ACTIONS(5767),
    [anon_sym_switch] = ACTIONS(5767),
    [anon_sym_when] = ACTIONS(5767),
    [anon_sym_DOT_DOT] = ACTIONS(5767),
    [anon_sym_and] = ACTIONS(5767),
    [anon_sym_or] = ACTIONS(5767),
    [anon_sym_AMP_AMP] = ACTIONS(5767),
    [anon_sym_PIPE_PIPE] = ACTIONS(5767),
    [anon_sym_QMARK_QMARK] = ACTIONS(5767),
    [anon_sym_on] = ACTIONS(5767),
    [anon_sym_equals] = ACTIONS(5767),
    [anon_sym_by] = ACTIONS(5767),
    [anon_sym_as] = ACTIONS(5767),
    [anon_sym_is] = ACTIONS(5767),
    [anon_sym_DASH_GT] = ACTIONS(5767),
    [anon_sym_with] = ACTIONS(5767),
    [aux_sym_preproc_if_token3] = ACTIONS(5767),
    [aux_sym_preproc_else_token1] = ACTIONS(5767),
    [aux_sym_preproc_elif_token1] = ACTIONS(5767),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4124] = {
    [sym_preproc_region] = STATE(4124),
    [sym_preproc_endregion] = STATE(4124),
    [sym_preproc_line] = STATE(4124),
    [sym_preproc_pragma] = STATE(4124),
    [sym_preproc_nullable] = STATE(4124),
    [sym_preproc_error] = STATE(4124),
    [sym_preproc_define] = STATE(4124),
    [sym_preproc_undef] = STATE(4124),
    [anon_sym_SEMI] = ACTIONS(5767),
    [anon_sym_LBRACK] = ACTIONS(5767),
    [anon_sym_COLON] = ACTIONS(5767),
    [anon_sym_COMMA] = ACTIONS(5767),
    [anon_sym_RBRACK] = ACTIONS(5767),
    [anon_sym_LPAREN] = ACTIONS(5767),
    [anon_sym_RPAREN] = ACTIONS(5767),
    [anon_sym_RBRACE] = ACTIONS(5767),
    [anon_sym_LT] = ACTIONS(5769),
    [anon_sym_GT] = ACTIONS(5769),
    [anon_sym_in] = ACTIONS(5767),
    [anon_sym_QMARK] = ACTIONS(5769),
    [anon_sym_BANG] = ACTIONS(5769),
    [anon_sym_PLUS_PLUS] = ACTIONS(5767),
    [anon_sym_DASH_DASH] = ACTIONS(5767),
    [anon_sym_PLUS] = ACTIONS(5769),
    [anon_sym_DASH] = ACTIONS(5769),
    [anon_sym_STAR] = ACTIONS(5767),
    [anon_sym_SLASH] = ACTIONS(5769),
    [anon_sym_PERCENT] = ACTIONS(5767),
    [anon_sym_CARET] = ACTIONS(5767),
    [anon_sym_PIPE] = ACTIONS(5769),
    [anon_sym_AMP] = ACTIONS(5769),
    [anon_sym_LT_LT] = ACTIONS(5767),
    [anon_sym_GT_GT] = ACTIONS(5769),
    [anon_sym_GT_GT_GT] = ACTIONS(5767),
    [anon_sym_EQ_EQ] = ACTIONS(5767),
    [anon_sym_BANG_EQ] = ACTIONS(5767),
    [anon_sym_GT_EQ] = ACTIONS(5767),
    [anon_sym_LT_EQ] = ACTIONS(5767),
    [anon_sym_DOT] = ACTIONS(5769),
    [anon_sym_EQ_GT] = ACTIONS(5767),
    [anon_sym_switch] = ACTIONS(5767),
    [anon_sym_when] = ACTIONS(5767),
    [anon_sym_DOT_DOT] = ACTIONS(5767),
    [anon_sym_and] = ACTIONS(5767),
    [anon_sym_or] = ACTIONS(5767),
    [anon_sym_AMP_AMP] = ACTIONS(5767),
    [anon_sym_PIPE_PIPE] = ACTIONS(5767),
    [anon_sym_QMARK_QMARK] = ACTIONS(5767),
    [anon_sym_on] = ACTIONS(5767),
    [anon_sym_equals] = ACTIONS(5767),
    [anon_sym_by] = ACTIONS(5767),
    [anon_sym_as] = ACTIONS(5767),
    [anon_sym_is] = ACTIONS(5767),
    [anon_sym_DASH_GT] = ACTIONS(5767),
    [anon_sym_with] = ACTIONS(5767),
    [aux_sym_preproc_if_token3] = ACTIONS(5767),
    [aux_sym_preproc_else_token1] = ACTIONS(5767),
    [aux_sym_preproc_elif_token1] = ACTIONS(5767),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4125] = {
    [sym_preproc_region] = STATE(4125),
    [sym_preproc_endregion] = STATE(4125),
    [sym_preproc_line] = STATE(4125),
    [sym_preproc_pragma] = STATE(4125),
    [sym_preproc_nullable] = STATE(4125),
    [sym_preproc_error] = STATE(4125),
    [sym_preproc_define] = STATE(4125),
    [sym_preproc_undef] = STATE(4125),
    [anon_sym_SEMI] = ACTIONS(5349),
    [anon_sym_LBRACK] = ACTIONS(5349),
    [anon_sym_COLON] = ACTIONS(5349),
    [anon_sym_COMMA] = ACTIONS(5349),
    [anon_sym_RBRACK] = ACTIONS(5349),
    [anon_sym_LPAREN] = ACTIONS(5349),
    [anon_sym_RPAREN] = ACTIONS(5349),
    [anon_sym_RBRACE] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_GT] = ACTIONS(5351),
    [anon_sym_in] = ACTIONS(5349),
    [anon_sym_QMARK] = ACTIONS(5351),
    [anon_sym_BANG] = ACTIONS(5351),
    [anon_sym_PLUS_PLUS] = ACTIONS(5349),
    [anon_sym_DASH_DASH] = ACTIONS(5349),
    [anon_sym_PLUS] = ACTIONS(5351),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_STAR] = ACTIONS(5349),
    [anon_sym_SLASH] = ACTIONS(5351),
    [anon_sym_PERCENT] = ACTIONS(5349),
    [anon_sym_CARET] = ACTIONS(5349),
    [anon_sym_PIPE] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_LT_LT] = ACTIONS(5349),
    [anon_sym_GT_GT] = ACTIONS(5351),
    [anon_sym_GT_GT_GT] = ACTIONS(5349),
    [anon_sym_EQ_EQ] = ACTIONS(5349),
    [anon_sym_BANG_EQ] = ACTIONS(5349),
    [anon_sym_GT_EQ] = ACTIONS(5349),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_DOT] = ACTIONS(5351),
    [anon_sym_EQ_GT] = ACTIONS(5349),
    [anon_sym_switch] = ACTIONS(5349),
    [anon_sym_when] = ACTIONS(5349),
    [anon_sym_DOT_DOT] = ACTIONS(5349),
    [anon_sym_and] = ACTIONS(5349),
    [anon_sym_or] = ACTIONS(5349),
    [anon_sym_AMP_AMP] = ACTIONS(5349),
    [anon_sym_PIPE_PIPE] = ACTIONS(5349),
    [anon_sym_QMARK_QMARK] = ACTIONS(5349),
    [anon_sym_on] = ACTIONS(5349),
    [anon_sym_equals] = ACTIONS(5349),
    [anon_sym_by] = ACTIONS(5349),
    [anon_sym_as] = ACTIONS(5349),
    [anon_sym_is] = ACTIONS(5349),
    [anon_sym_DASH_GT] = ACTIONS(5349),
    [anon_sym_with] = ACTIONS(5349),
    [aux_sym_preproc_if_token3] = ACTIONS(5349),
    [aux_sym_preproc_else_token1] = ACTIONS(5349),
    [aux_sym_preproc_elif_token1] = ACTIONS(5349),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4126] = {
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(6920),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9226),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4126),
    [sym_preproc_endregion] = STATE(4126),
    [sym_preproc_line] = STATE(4126),
    [sym_preproc_pragma] = STATE(4126),
    [sym_preproc_nullable] = STATE(4126),
    [sym_preproc_error] = STATE(4126),
    [sym_preproc_define] = STATE(4126),
    [sym_preproc_undef] = STATE(4126),
    [aux_sym_lambda_expression_repeat1] = STATE(6864),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4127] = {
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(6985),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9322),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4127),
    [sym_preproc_endregion] = STATE(4127),
    [sym_preproc_line] = STATE(4127),
    [sym_preproc_pragma] = STATE(4127),
    [sym_preproc_nullable] = STATE(4127),
    [sym_preproc_error] = STATE(4127),
    [sym_preproc_define] = STATE(4127),
    [sym_preproc_undef] = STATE(4127),
    [aux_sym_lambda_expression_repeat1] = STATE(6864),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4128] = {
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(6979),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9324),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4128),
    [sym_preproc_endregion] = STATE(4128),
    [sym_preproc_line] = STATE(4128),
    [sym_preproc_pragma] = STATE(4128),
    [sym_preproc_nullable] = STATE(4128),
    [sym_preproc_error] = STATE(4128),
    [sym_preproc_define] = STATE(4128),
    [sym_preproc_undef] = STATE(4128),
    [aux_sym_lambda_expression_repeat1] = STATE(6864),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(5898),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4129] = {
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7034),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9218),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4129),
    [sym_preproc_endregion] = STATE(4129),
    [sym_preproc_line] = STATE(4129),
    [sym_preproc_pragma] = STATE(4129),
    [sym_preproc_nullable] = STATE(4129),
    [sym_preproc_error] = STATE(4129),
    [sym_preproc_define] = STATE(4129),
    [sym_preproc_undef] = STATE(4129),
    [aux_sym_lambda_expression_repeat1] = STATE(6864),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(5898),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4130] = {
    [sym_preproc_region] = STATE(4130),
    [sym_preproc_endregion] = STATE(4130),
    [sym_preproc_line] = STATE(4130),
    [sym_preproc_pragma] = STATE(4130),
    [sym_preproc_nullable] = STATE(4130),
    [sym_preproc_error] = STATE(4130),
    [sym_preproc_define] = STATE(4130),
    [sym_preproc_undef] = STATE(4130),
    [anon_sym_SEMI] = ACTIONS(5862),
    [anon_sym_LBRACK] = ACTIONS(5862),
    [anon_sym_COLON] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5862),
    [anon_sym_RBRACK] = ACTIONS(5862),
    [anon_sym_LPAREN] = ACTIONS(5862),
    [anon_sym_RPAREN] = ACTIONS(5862),
    [anon_sym_RBRACE] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5864),
    [anon_sym_GT] = ACTIONS(5864),
    [anon_sym_in] = ACTIONS(5862),
    [anon_sym_QMARK] = ACTIONS(5864),
    [anon_sym_BANG] = ACTIONS(5864),
    [anon_sym_PLUS_PLUS] = ACTIONS(5862),
    [anon_sym_DASH_DASH] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(5864),
    [anon_sym_DASH] = ACTIONS(5864),
    [anon_sym_STAR] = ACTIONS(5862),
    [anon_sym_SLASH] = ACTIONS(5864),
    [anon_sym_PERCENT] = ACTIONS(5862),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PIPE] = ACTIONS(5864),
    [anon_sym_AMP] = ACTIONS(5864),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5864),
    [anon_sym_GT_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5862),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_DOT] = ACTIONS(5864),
    [anon_sym_EQ_GT] = ACTIONS(5862),
    [anon_sym_switch] = ACTIONS(5862),
    [anon_sym_when] = ACTIONS(5862),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_and] = ACTIONS(5862),
    [anon_sym_or] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_QMARK_QMARK] = ACTIONS(5862),
    [anon_sym_on] = ACTIONS(5862),
    [anon_sym_equals] = ACTIONS(5862),
    [anon_sym_by] = ACTIONS(5862),
    [anon_sym_as] = ACTIONS(5862),
    [anon_sym_is] = ACTIONS(5862),
    [anon_sym_DASH_GT] = ACTIONS(5862),
    [anon_sym_with] = ACTIONS(5862),
    [aux_sym_preproc_if_token3] = ACTIONS(5862),
    [aux_sym_preproc_else_token1] = ACTIONS(5862),
    [aux_sym_preproc_elif_token1] = ACTIONS(5862),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4131] = {
    [sym_preproc_region] = STATE(4131),
    [sym_preproc_endregion] = STATE(4131),
    [sym_preproc_line] = STATE(4131),
    [sym_preproc_pragma] = STATE(4131),
    [sym_preproc_nullable] = STATE(4131),
    [sym_preproc_error] = STATE(4131),
    [sym_preproc_define] = STATE(4131),
    [sym_preproc_undef] = STATE(4131),
    [anon_sym_SEMI] = ACTIONS(5249),
    [anon_sym_EQ] = ACTIONS(5904),
    [anon_sym_LBRACK] = ACTIONS(5249),
    [anon_sym_LPAREN] = ACTIONS(5249),
    [anon_sym_LT] = ACTIONS(5251),
    [anon_sym_GT] = ACTIONS(5251),
    [anon_sym_QMARK] = ACTIONS(5251),
    [anon_sym_BANG] = ACTIONS(5251),
    [anon_sym_PLUS_PLUS] = ACTIONS(5249),
    [anon_sym_DASH_DASH] = ACTIONS(5249),
    [anon_sym_PLUS] = ACTIONS(5251),
    [anon_sym_DASH] = ACTIONS(5251),
    [anon_sym_STAR] = ACTIONS(5251),
    [anon_sym_SLASH] = ACTIONS(5251),
    [anon_sym_PERCENT] = ACTIONS(5251),
    [anon_sym_CARET] = ACTIONS(5251),
    [anon_sym_PIPE] = ACTIONS(5251),
    [anon_sym_AMP] = ACTIONS(5251),
    [anon_sym_LT_LT] = ACTIONS(5251),
    [anon_sym_GT_GT] = ACTIONS(5251),
    [anon_sym_GT_GT_GT] = ACTIONS(5251),
    [anon_sym_EQ_EQ] = ACTIONS(5249),
    [anon_sym_BANG_EQ] = ACTIONS(5249),
    [anon_sym_GT_EQ] = ACTIONS(5249),
    [anon_sym_LT_EQ] = ACTIONS(5249),
    [anon_sym_DOT] = ACTIONS(5251),
    [anon_sym_switch] = ACTIONS(5249),
    [anon_sym_DOT_DOT] = ACTIONS(5249),
    [anon_sym_PLUS_EQ] = ACTIONS(5906),
    [anon_sym_DASH_EQ] = ACTIONS(5906),
    [anon_sym_STAR_EQ] = ACTIONS(5906),
    [anon_sym_SLASH_EQ] = ACTIONS(5906),
    [anon_sym_PERCENT_EQ] = ACTIONS(5906),
    [anon_sym_AMP_EQ] = ACTIONS(5906),
    [anon_sym_CARET_EQ] = ACTIONS(5906),
    [anon_sym_PIPE_EQ] = ACTIONS(5906),
    [anon_sym_LT_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT_GT_EQ] = ACTIONS(5906),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5906),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(5906),
    [anon_sym_AMP_AMP] = ACTIONS(5249),
    [anon_sym_PIPE_PIPE] = ACTIONS(5249),
    [anon_sym_QMARK_QMARK] = ACTIONS(5251),
    [anon_sym_as] = ACTIONS(5249),
    [anon_sym_is] = ACTIONS(5249),
    [anon_sym_DASH_GT] = ACTIONS(5249),
    [anon_sym_with] = ACTIONS(5249),
    [aux_sym_preproc_if_token3] = ACTIONS(5249),
    [aux_sym_preproc_else_token1] = ACTIONS(5249),
    [aux_sym_preproc_elif_token1] = ACTIONS(5249),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4132] = {
    [sym_preproc_region] = STATE(4132),
    [sym_preproc_endregion] = STATE(4132),
    [sym_preproc_line] = STATE(4132),
    [sym_preproc_pragma] = STATE(4132),
    [sym_preproc_nullable] = STATE(4132),
    [sym_preproc_error] = STATE(4132),
    [sym_preproc_define] = STATE(4132),
    [sym_preproc_undef] = STATE(4132),
    [anon_sym_SEMI] = ACTIONS(5337),
    [anon_sym_LBRACK] = ACTIONS(5337),
    [anon_sym_COLON] = ACTIONS(5337),
    [anon_sym_COMMA] = ACTIONS(5337),
    [anon_sym_RBRACK] = ACTIONS(5337),
    [anon_sym_LPAREN] = ACTIONS(5337),
    [anon_sym_RPAREN] = ACTIONS(5337),
    [anon_sym_RBRACE] = ACTIONS(5337),
    [anon_sym_LT] = ACTIONS(5339),
    [anon_sym_GT] = ACTIONS(5339),
    [anon_sym_in] = ACTIONS(5337),
    [anon_sym_QMARK] = ACTIONS(5339),
    [anon_sym_BANG] = ACTIONS(5339),
    [anon_sym_PLUS_PLUS] = ACTIONS(5337),
    [anon_sym_DASH_DASH] = ACTIONS(5337),
    [anon_sym_PLUS] = ACTIONS(5339),
    [anon_sym_DASH] = ACTIONS(5339),
    [anon_sym_STAR] = ACTIONS(5337),
    [anon_sym_SLASH] = ACTIONS(5339),
    [anon_sym_PERCENT] = ACTIONS(5337),
    [anon_sym_CARET] = ACTIONS(5337),
    [anon_sym_PIPE] = ACTIONS(5339),
    [anon_sym_AMP] = ACTIONS(5339),
    [anon_sym_LT_LT] = ACTIONS(5337),
    [anon_sym_GT_GT] = ACTIONS(5339),
    [anon_sym_GT_GT_GT] = ACTIONS(5337),
    [anon_sym_EQ_EQ] = ACTIONS(5337),
    [anon_sym_BANG_EQ] = ACTIONS(5337),
    [anon_sym_GT_EQ] = ACTIONS(5337),
    [anon_sym_LT_EQ] = ACTIONS(5337),
    [anon_sym_DOT] = ACTIONS(5339),
    [anon_sym_EQ_GT] = ACTIONS(5337),
    [anon_sym_switch] = ACTIONS(5337),
    [anon_sym_when] = ACTIONS(5337),
    [anon_sym_DOT_DOT] = ACTIONS(5337),
    [anon_sym_and] = ACTIONS(5337),
    [anon_sym_or] = ACTIONS(5337),
    [anon_sym_AMP_AMP] = ACTIONS(5337),
    [anon_sym_PIPE_PIPE] = ACTIONS(5337),
    [anon_sym_QMARK_QMARK] = ACTIONS(5337),
    [anon_sym_on] = ACTIONS(5337),
    [anon_sym_equals] = ACTIONS(5337),
    [anon_sym_by] = ACTIONS(5337),
    [anon_sym_as] = ACTIONS(5337),
    [anon_sym_is] = ACTIONS(5337),
    [anon_sym_DASH_GT] = ACTIONS(5337),
    [anon_sym_with] = ACTIONS(5337),
    [aux_sym_preproc_if_token3] = ACTIONS(5337),
    [aux_sym_preproc_else_token1] = ACTIONS(5337),
    [aux_sym_preproc_elif_token1] = ACTIONS(5337),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4133] = {
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(6927),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9339),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4133),
    [sym_preproc_endregion] = STATE(4133),
    [sym_preproc_line] = STATE(4133),
    [sym_preproc_pragma] = STATE(4133),
    [sym_preproc_nullable] = STATE(4133),
    [sym_preproc_error] = STATE(4133),
    [sym_preproc_define] = STATE(4133),
    [sym_preproc_undef] = STATE(4133),
    [aux_sym_lambda_expression_repeat1] = STATE(6864),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4134] = {
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(6949),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9311),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4134),
    [sym_preproc_endregion] = STATE(4134),
    [sym_preproc_line] = STATE(4134),
    [sym_preproc_pragma] = STATE(4134),
    [sym_preproc_nullable] = STATE(4134),
    [sym_preproc_error] = STATE(4134),
    [sym_preproc_define] = STATE(4134),
    [sym_preproc_undef] = STATE(4134),
    [aux_sym_lambda_expression_repeat1] = STATE(6864),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(5896),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4135] = {
    [sym_preproc_region] = STATE(4135),
    [sym_preproc_endregion] = STATE(4135),
    [sym_preproc_line] = STATE(4135),
    [sym_preproc_pragma] = STATE(4135),
    [sym_preproc_nullable] = STATE(4135),
    [sym_preproc_error] = STATE(4135),
    [sym_preproc_define] = STATE(4135),
    [sym_preproc_undef] = STATE(4135),
    [anon_sym_SEMI] = ACTIONS(5444),
    [anon_sym_LBRACK] = ACTIONS(5444),
    [anon_sym_COLON] = ACTIONS(5444),
    [anon_sym_COMMA] = ACTIONS(5444),
    [anon_sym_RBRACK] = ACTIONS(5444),
    [anon_sym_LPAREN] = ACTIONS(5444),
    [anon_sym_RPAREN] = ACTIONS(5444),
    [anon_sym_RBRACE] = ACTIONS(5444),
    [anon_sym_LT] = ACTIONS(5446),
    [anon_sym_GT] = ACTIONS(5446),
    [anon_sym_in] = ACTIONS(5444),
    [anon_sym_QMARK] = ACTIONS(5446),
    [anon_sym_BANG] = ACTIONS(5446),
    [anon_sym_PLUS_PLUS] = ACTIONS(5444),
    [anon_sym_DASH_DASH] = ACTIONS(5444),
    [anon_sym_PLUS] = ACTIONS(5446),
    [anon_sym_DASH] = ACTIONS(5446),
    [anon_sym_STAR] = ACTIONS(5444),
    [anon_sym_SLASH] = ACTIONS(5446),
    [anon_sym_PERCENT] = ACTIONS(5444),
    [anon_sym_CARET] = ACTIONS(5444),
    [anon_sym_PIPE] = ACTIONS(5446),
    [anon_sym_AMP] = ACTIONS(5446),
    [anon_sym_LT_LT] = ACTIONS(5444),
    [anon_sym_GT_GT] = ACTIONS(5446),
    [anon_sym_GT_GT_GT] = ACTIONS(5444),
    [anon_sym_EQ_EQ] = ACTIONS(5444),
    [anon_sym_BANG_EQ] = ACTIONS(5444),
    [anon_sym_GT_EQ] = ACTIONS(5444),
    [anon_sym_LT_EQ] = ACTIONS(5444),
    [anon_sym_DOT] = ACTIONS(5446),
    [anon_sym_EQ_GT] = ACTIONS(5444),
    [anon_sym_switch] = ACTIONS(5444),
    [anon_sym_when] = ACTIONS(5444),
    [anon_sym_DOT_DOT] = ACTIONS(5444),
    [anon_sym_and] = ACTIONS(5444),
    [anon_sym_or] = ACTIONS(5444),
    [anon_sym_AMP_AMP] = ACTIONS(5444),
    [anon_sym_PIPE_PIPE] = ACTIONS(5444),
    [anon_sym_QMARK_QMARK] = ACTIONS(5444),
    [anon_sym_on] = ACTIONS(5444),
    [anon_sym_equals] = ACTIONS(5444),
    [anon_sym_by] = ACTIONS(5444),
    [anon_sym_as] = ACTIONS(5444),
    [anon_sym_is] = ACTIONS(5444),
    [anon_sym_DASH_GT] = ACTIONS(5444),
    [anon_sym_with] = ACTIONS(5444),
    [aux_sym_preproc_if_token3] = ACTIONS(5444),
    [aux_sym_preproc_else_token1] = ACTIONS(5444),
    [aux_sym_preproc_elif_token1] = ACTIONS(5444),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4136] = {
    [sym_preproc_region] = STATE(4136),
    [sym_preproc_endregion] = STATE(4136),
    [sym_preproc_line] = STATE(4136),
    [sym_preproc_pragma] = STATE(4136),
    [sym_preproc_nullable] = STATE(4136),
    [sym_preproc_error] = STATE(4136),
    [sym_preproc_define] = STATE(4136),
    [sym_preproc_undef] = STATE(4136),
    [anon_sym_SEMI] = ACTIONS(2923),
    [anon_sym_LBRACK] = ACTIONS(2923),
    [anon_sym_COLON] = ACTIONS(2923),
    [anon_sym_COMMA] = ACTIONS(2923),
    [anon_sym_RBRACK] = ACTIONS(2923),
    [anon_sym_LPAREN] = ACTIONS(2923),
    [anon_sym_RPAREN] = ACTIONS(2923),
    [anon_sym_RBRACE] = ACTIONS(2923),
    [anon_sym_LT] = ACTIONS(2921),
    [anon_sym_GT] = ACTIONS(2921),
    [anon_sym_in] = ACTIONS(2923),
    [anon_sym_QMARK] = ACTIONS(2921),
    [anon_sym_BANG] = ACTIONS(2921),
    [anon_sym_PLUS_PLUS] = ACTIONS(2923),
    [anon_sym_DASH_DASH] = ACTIONS(2923),
    [anon_sym_PLUS] = ACTIONS(2921),
    [anon_sym_DASH] = ACTIONS(2921),
    [anon_sym_STAR] = ACTIONS(2923),
    [anon_sym_SLASH] = ACTIONS(2921),
    [anon_sym_PERCENT] = ACTIONS(2923),
    [anon_sym_CARET] = ACTIONS(2923),
    [anon_sym_PIPE] = ACTIONS(2921),
    [anon_sym_AMP] = ACTIONS(2921),
    [anon_sym_LT_LT] = ACTIONS(2923),
    [anon_sym_GT_GT] = ACTIONS(2921),
    [anon_sym_GT_GT_GT] = ACTIONS(2923),
    [anon_sym_EQ_EQ] = ACTIONS(2923),
    [anon_sym_BANG_EQ] = ACTIONS(2923),
    [anon_sym_GT_EQ] = ACTIONS(2923),
    [anon_sym_LT_EQ] = ACTIONS(2923),
    [anon_sym_DOT] = ACTIONS(2921),
    [anon_sym_EQ_GT] = ACTIONS(2923),
    [anon_sym_switch] = ACTIONS(2923),
    [anon_sym_when] = ACTIONS(2923),
    [anon_sym_DOT_DOT] = ACTIONS(2923),
    [anon_sym_and] = ACTIONS(2923),
    [anon_sym_or] = ACTIONS(2923),
    [anon_sym_AMP_AMP] = ACTIONS(2923),
    [anon_sym_PIPE_PIPE] = ACTIONS(2923),
    [anon_sym_QMARK_QMARK] = ACTIONS(2923),
    [anon_sym_on] = ACTIONS(2923),
    [anon_sym_equals] = ACTIONS(2923),
    [anon_sym_by] = ACTIONS(2923),
    [anon_sym_as] = ACTIONS(2923),
    [anon_sym_is] = ACTIONS(2923),
    [anon_sym_DASH_GT] = ACTIONS(2923),
    [anon_sym_with] = ACTIONS(2923),
    [aux_sym_preproc_if_token3] = ACTIONS(2923),
    [aux_sym_preproc_else_token1] = ACTIONS(2923),
    [aux_sym_preproc_elif_token1] = ACTIONS(2923),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4137] = {
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7035),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9215),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4137),
    [sym_preproc_endregion] = STATE(4137),
    [sym_preproc_line] = STATE(4137),
    [sym_preproc_pragma] = STATE(4137),
    [sym_preproc_nullable] = STATE(4137),
    [sym_preproc_error] = STATE(4137),
    [sym_preproc_define] = STATE(4137),
    [sym_preproc_undef] = STATE(4137),
    [aux_sym_lambda_expression_repeat1] = STATE(6864),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4138] = {
    [sym_preproc_region] = STATE(4138),
    [sym_preproc_endregion] = STATE(4138),
    [sym_preproc_line] = STATE(4138),
    [sym_preproc_pragma] = STATE(4138),
    [sym_preproc_nullable] = STATE(4138),
    [sym_preproc_error] = STATE(4138),
    [sym_preproc_define] = STATE(4138),
    [sym_preproc_undef] = STATE(4138),
    [anon_sym_SEMI] = ACTIONS(5526),
    [anon_sym_LBRACK] = ACTIONS(5526),
    [anon_sym_COLON] = ACTIONS(5526),
    [anon_sym_COMMA] = ACTIONS(5526),
    [anon_sym_RBRACK] = ACTIONS(5526),
    [anon_sym_LPAREN] = ACTIONS(5526),
    [anon_sym_RPAREN] = ACTIONS(5526),
    [anon_sym_RBRACE] = ACTIONS(5526),
    [anon_sym_LT] = ACTIONS(5528),
    [anon_sym_GT] = ACTIONS(5528),
    [anon_sym_in] = ACTIONS(5526),
    [anon_sym_QMARK] = ACTIONS(5528),
    [anon_sym_BANG] = ACTIONS(5528),
    [anon_sym_PLUS_PLUS] = ACTIONS(5526),
    [anon_sym_DASH_DASH] = ACTIONS(5526),
    [anon_sym_PLUS] = ACTIONS(5528),
    [anon_sym_DASH] = ACTIONS(5528),
    [anon_sym_STAR] = ACTIONS(5526),
    [anon_sym_SLASH] = ACTIONS(5528),
    [anon_sym_PERCENT] = ACTIONS(5526),
    [anon_sym_CARET] = ACTIONS(5526),
    [anon_sym_PIPE] = ACTIONS(5528),
    [anon_sym_AMP] = ACTIONS(5528),
    [anon_sym_LT_LT] = ACTIONS(5526),
    [anon_sym_GT_GT] = ACTIONS(5528),
    [anon_sym_GT_GT_GT] = ACTIONS(5526),
    [anon_sym_EQ_EQ] = ACTIONS(5526),
    [anon_sym_BANG_EQ] = ACTIONS(5526),
    [anon_sym_GT_EQ] = ACTIONS(5526),
    [anon_sym_LT_EQ] = ACTIONS(5526),
    [anon_sym_DOT] = ACTIONS(5528),
    [anon_sym_EQ_GT] = ACTIONS(5526),
    [anon_sym_switch] = ACTIONS(5526),
    [anon_sym_when] = ACTIONS(5526),
    [anon_sym_DOT_DOT] = ACTIONS(5526),
    [anon_sym_and] = ACTIONS(5526),
    [anon_sym_or] = ACTIONS(5526),
    [anon_sym_AMP_AMP] = ACTIONS(5526),
    [anon_sym_PIPE_PIPE] = ACTIONS(5526),
    [anon_sym_QMARK_QMARK] = ACTIONS(5526),
    [anon_sym_on] = ACTIONS(5526),
    [anon_sym_equals] = ACTIONS(5526),
    [anon_sym_by] = ACTIONS(5526),
    [anon_sym_as] = ACTIONS(5526),
    [anon_sym_is] = ACTIONS(5526),
    [anon_sym_DASH_GT] = ACTIONS(5526),
    [anon_sym_with] = ACTIONS(5526),
    [aux_sym_preproc_if_token3] = ACTIONS(5526),
    [aux_sym_preproc_else_token1] = ACTIONS(5526),
    [aux_sym_preproc_elif_token1] = ACTIONS(5526),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4139] = {
    [sym_preproc_region] = STATE(4139),
    [sym_preproc_endregion] = STATE(4139),
    [sym_preproc_line] = STATE(4139),
    [sym_preproc_pragma] = STATE(4139),
    [sym_preproc_nullable] = STATE(4139),
    [sym_preproc_error] = STATE(4139),
    [sym_preproc_define] = STATE(4139),
    [sym_preproc_undef] = STATE(4139),
    [anon_sym_SEMI] = ACTIONS(5522),
    [anon_sym_LBRACK] = ACTIONS(5522),
    [anon_sym_COLON] = ACTIONS(5522),
    [anon_sym_COMMA] = ACTIONS(5522),
    [anon_sym_RBRACK] = ACTIONS(5522),
    [anon_sym_LPAREN] = ACTIONS(5522),
    [anon_sym_RPAREN] = ACTIONS(5522),
    [anon_sym_RBRACE] = ACTIONS(5522),
    [anon_sym_LT] = ACTIONS(5524),
    [anon_sym_GT] = ACTIONS(5524),
    [anon_sym_in] = ACTIONS(5522),
    [anon_sym_QMARK] = ACTIONS(5524),
    [anon_sym_BANG] = ACTIONS(5524),
    [anon_sym_PLUS_PLUS] = ACTIONS(5522),
    [anon_sym_DASH_DASH] = ACTIONS(5522),
    [anon_sym_PLUS] = ACTIONS(5524),
    [anon_sym_DASH] = ACTIONS(5524),
    [anon_sym_STAR] = ACTIONS(5522),
    [anon_sym_SLASH] = ACTIONS(5524),
    [anon_sym_PERCENT] = ACTIONS(5522),
    [anon_sym_CARET] = ACTIONS(5522),
    [anon_sym_PIPE] = ACTIONS(5524),
    [anon_sym_AMP] = ACTIONS(5524),
    [anon_sym_LT_LT] = ACTIONS(5522),
    [anon_sym_GT_GT] = ACTIONS(5524),
    [anon_sym_GT_GT_GT] = ACTIONS(5522),
    [anon_sym_EQ_EQ] = ACTIONS(5522),
    [anon_sym_BANG_EQ] = ACTIONS(5522),
    [anon_sym_GT_EQ] = ACTIONS(5522),
    [anon_sym_LT_EQ] = ACTIONS(5522),
    [anon_sym_DOT] = ACTIONS(5524),
    [anon_sym_EQ_GT] = ACTIONS(5522),
    [anon_sym_switch] = ACTIONS(5522),
    [anon_sym_when] = ACTIONS(5522),
    [anon_sym_DOT_DOT] = ACTIONS(5522),
    [anon_sym_and] = ACTIONS(5522),
    [anon_sym_or] = ACTIONS(5522),
    [anon_sym_AMP_AMP] = ACTIONS(5522),
    [anon_sym_PIPE_PIPE] = ACTIONS(5522),
    [anon_sym_QMARK_QMARK] = ACTIONS(5522),
    [anon_sym_on] = ACTIONS(5522),
    [anon_sym_equals] = ACTIONS(5522),
    [anon_sym_by] = ACTIONS(5522),
    [anon_sym_as] = ACTIONS(5522),
    [anon_sym_is] = ACTIONS(5522),
    [anon_sym_DASH_GT] = ACTIONS(5522),
    [anon_sym_with] = ACTIONS(5522),
    [aux_sym_preproc_if_token3] = ACTIONS(5522),
    [aux_sym_preproc_else_token1] = ACTIONS(5522),
    [aux_sym_preproc_elif_token1] = ACTIONS(5522),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4140] = {
    [sym_preproc_region] = STATE(4140),
    [sym_preproc_endregion] = STATE(4140),
    [sym_preproc_line] = STATE(4140),
    [sym_preproc_pragma] = STATE(4140),
    [sym_preproc_nullable] = STATE(4140),
    [sym_preproc_error] = STATE(4140),
    [sym_preproc_define] = STATE(4140),
    [sym_preproc_undef] = STATE(4140),
    [anon_sym_SEMI] = ACTIONS(5858),
    [anon_sym_LBRACK] = ACTIONS(5858),
    [anon_sym_COLON] = ACTIONS(5858),
    [anon_sym_COMMA] = ACTIONS(5858),
    [anon_sym_RBRACK] = ACTIONS(5858),
    [anon_sym_LPAREN] = ACTIONS(5858),
    [anon_sym_RPAREN] = ACTIONS(5858),
    [anon_sym_RBRACE] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5860),
    [anon_sym_GT] = ACTIONS(5860),
    [anon_sym_in] = ACTIONS(5858),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_BANG] = ACTIONS(5860),
    [anon_sym_PLUS_PLUS] = ACTIONS(5858),
    [anon_sym_DASH_DASH] = ACTIONS(5858),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_DASH] = ACTIONS(5860),
    [anon_sym_STAR] = ACTIONS(5858),
    [anon_sym_SLASH] = ACTIONS(5860),
    [anon_sym_PERCENT] = ACTIONS(5858),
    [anon_sym_CARET] = ACTIONS(5858),
    [anon_sym_PIPE] = ACTIONS(5860),
    [anon_sym_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5858),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_GT_GT_GT] = ACTIONS(5858),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5858),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_DOT] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5858),
    [anon_sym_switch] = ACTIONS(5858),
    [anon_sym_when] = ACTIONS(5858),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_and] = ACTIONS(5858),
    [anon_sym_or] = ACTIONS(5858),
    [anon_sym_AMP_AMP] = ACTIONS(5858),
    [anon_sym_PIPE_PIPE] = ACTIONS(5858),
    [anon_sym_QMARK_QMARK] = ACTIONS(5858),
    [anon_sym_on] = ACTIONS(5858),
    [anon_sym_equals] = ACTIONS(5858),
    [anon_sym_by] = ACTIONS(5858),
    [anon_sym_as] = ACTIONS(5858),
    [anon_sym_is] = ACTIONS(5858),
    [anon_sym_DASH_GT] = ACTIONS(5858),
    [anon_sym_with] = ACTIONS(5858),
    [aux_sym_preproc_if_token3] = ACTIONS(5858),
    [aux_sym_preproc_else_token1] = ACTIONS(5858),
    [aux_sym_preproc_elif_token1] = ACTIONS(5858),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4141] = {
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7093),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9342),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4141),
    [sym_preproc_endregion] = STATE(4141),
    [sym_preproc_line] = STATE(4141),
    [sym_preproc_pragma] = STATE(4141),
    [sym_preproc_nullable] = STATE(4141),
    [sym_preproc_error] = STATE(4141),
    [sym_preproc_define] = STATE(4141),
    [sym_preproc_undef] = STATE(4141),
    [aux_sym_lambda_expression_repeat1] = STATE(6864),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(5908),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4142] = {
    [sym__name] = STATE(7759),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(9748),
    [sym_implicit_type] = STATE(8901),
    [sym_array_type] = STATE(8236),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(8217),
    [sym_pointer_type] = STATE(8217),
    [sym__pointer_base_type] = STATE(9650),
    [sym_function_pointer_type] = STATE(8217),
    [sym_function_pointer_parameter] = STATE(9350),
    [sym_ref_type] = STATE(8704),
    [sym__ref_base_type] = STATE(9351),
    [sym_scoped_type] = STATE(8704),
    [sym_tuple_type] = STATE(8136),
    [sym_identifier] = STATE(4921),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4142),
    [sym_preproc_endregion] = STATE(4142),
    [sym_preproc_line] = STATE(4142),
    [sym_preproc_pragma] = STATE(4142),
    [sym_preproc_nullable] = STATE(4142),
    [sym_preproc_error] = STATE(4142),
    [sym_preproc_define] = STATE(4142),
    [sym_preproc_undef] = STATE(4142),
    [aux_sym_function_pointer_type_repeat1] = STATE(4464),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_LPAREN] = ACTIONS(2995),
    [anon_sym_ref] = ACTIONS(5882),
    [anon_sym_delegate] = ACTIONS(5659),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_in] = ACTIONS(5884),
    [anon_sym_out] = ACTIONS(5884),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(5886),
    [anon_sym_var] = ACTIONS(5284),
    [sym_predefined_type] = ACTIONS(5888),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4143] = {
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7265),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_identifier] = STATE(4921),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4143),
    [sym_preproc_endregion] = STATE(4143),
    [sym_preproc_line] = STATE(4143),
    [sym_preproc_pragma] = STATE(4143),
    [sym_preproc_nullable] = STATE(4143),
    [sym_preproc_error] = STATE(4143),
    [sym_preproc_define] = STATE(4143),
    [sym_preproc_undef] = STATE(4143),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(6755),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_LPAREN] = ACTIONS(2995),
    [anon_sym_ref] = ACTIONS(5216),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_readonly] = ACTIONS(1093),
    [anon_sym_in] = ACTIONS(1093),
    [anon_sym_out] = ACTIONS(1093),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_this] = ACTIONS(1093),
    [anon_sym_scoped] = ACTIONS(5218),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4144] = {
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(6935),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9158),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4144),
    [sym_preproc_endregion] = STATE(4144),
    [sym_preproc_line] = STATE(4144),
    [sym_preproc_pragma] = STATE(4144),
    [sym_preproc_nullable] = STATE(4144),
    [sym_preproc_error] = STATE(4144),
    [sym_preproc_define] = STATE(4144),
    [sym_preproc_undef] = STATE(4144),
    [aux_sym_lambda_expression_repeat1] = STATE(6864),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(5894),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4145] = {
    [sym__name] = STATE(7759),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(9655),
    [sym_implicit_type] = STATE(8901),
    [sym_array_type] = STATE(8236),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(8217),
    [sym_pointer_type] = STATE(8217),
    [sym__pointer_base_type] = STATE(9650),
    [sym_function_pointer_type] = STATE(8217),
    [sym_function_pointer_parameter] = STATE(9350),
    [sym_ref_type] = STATE(8704),
    [sym__ref_base_type] = STATE(9351),
    [sym_scoped_type] = STATE(8704),
    [sym_tuple_type] = STATE(8136),
    [sym_identifier] = STATE(4921),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4145),
    [sym_preproc_endregion] = STATE(4145),
    [sym_preproc_line] = STATE(4145),
    [sym_preproc_pragma] = STATE(4145),
    [sym_preproc_nullable] = STATE(4145),
    [sym_preproc_error] = STATE(4145),
    [sym_preproc_define] = STATE(4145),
    [sym_preproc_undef] = STATE(4145),
    [aux_sym_function_pointer_type_repeat1] = STATE(4464),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_LPAREN] = ACTIONS(2995),
    [anon_sym_ref] = ACTIONS(5882),
    [anon_sym_delegate] = ACTIONS(5659),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_in] = ACTIONS(5884),
    [anon_sym_out] = ACTIONS(5884),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(5886),
    [anon_sym_var] = ACTIONS(5284),
    [sym_predefined_type] = ACTIONS(5888),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4146] = {
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7057),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9207),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4146),
    [sym_preproc_endregion] = STATE(4146),
    [sym_preproc_line] = STATE(4146),
    [sym_preproc_pragma] = STATE(4146),
    [sym_preproc_nullable] = STATE(4146),
    [sym_preproc_error] = STATE(4146),
    [sym_preproc_define] = STATE(4146),
    [sym_preproc_undef] = STATE(4146),
    [aux_sym_lambda_expression_repeat1] = STATE(6864),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(5894),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4147] = {
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(6993),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9029),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4147),
    [sym_preproc_endregion] = STATE(4147),
    [sym_preproc_line] = STATE(4147),
    [sym_preproc_pragma] = STATE(4147),
    [sym_preproc_nullable] = STATE(4147),
    [sym_preproc_error] = STATE(4147),
    [sym_preproc_define] = STATE(4147),
    [sym_preproc_undef] = STATE(4147),
    [aux_sym_lambda_expression_repeat1] = STATE(6864),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4148] = {
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(6962),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9355),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4148),
    [sym_preproc_endregion] = STATE(4148),
    [sym_preproc_line] = STATE(4148),
    [sym_preproc_pragma] = STATE(4148),
    [sym_preproc_nullable] = STATE(4148),
    [sym_preproc_error] = STATE(4148),
    [sym_preproc_define] = STATE(4148),
    [sym_preproc_undef] = STATE(4148),
    [aux_sym_lambda_expression_repeat1] = STATE(6864),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4149] = {
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7013),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9357),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4149),
    [sym_preproc_endregion] = STATE(4149),
    [sym_preproc_line] = STATE(4149),
    [sym_preproc_pragma] = STATE(4149),
    [sym_preproc_nullable] = STATE(4149),
    [sym_preproc_error] = STATE(4149),
    [sym_preproc_define] = STATE(4149),
    [sym_preproc_undef] = STATE(4149),
    [aux_sym_lambda_expression_repeat1] = STATE(6864),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(5898),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4150] = {
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7058),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9205),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4150),
    [sym_preproc_endregion] = STATE(4150),
    [sym_preproc_line] = STATE(4150),
    [sym_preproc_pragma] = STATE(4150),
    [sym_preproc_nullable] = STATE(4150),
    [sym_preproc_error] = STATE(4150),
    [sym_preproc_define] = STATE(4150),
    [sym_preproc_undef] = STATE(4150),
    [aux_sym_lambda_expression_repeat1] = STATE(6864),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4151] = {
    [sym_preproc_region] = STATE(4151),
    [sym_preproc_endregion] = STATE(4151),
    [sym_preproc_line] = STATE(4151),
    [sym_preproc_pragma] = STATE(4151),
    [sym_preproc_nullable] = STATE(4151),
    [sym_preproc_error] = STATE(4151),
    [sym_preproc_define] = STATE(4151),
    [sym_preproc_undef] = STATE(4151),
    [anon_sym_SEMI] = ACTIONS(5510),
    [anon_sym_LBRACK] = ACTIONS(5510),
    [anon_sym_COLON] = ACTIONS(5510),
    [anon_sym_COMMA] = ACTIONS(5510),
    [anon_sym_RBRACK] = ACTIONS(5510),
    [anon_sym_LPAREN] = ACTIONS(5510),
    [anon_sym_RPAREN] = ACTIONS(5510),
    [anon_sym_RBRACE] = ACTIONS(5510),
    [anon_sym_LT] = ACTIONS(5512),
    [anon_sym_GT] = ACTIONS(5512),
    [anon_sym_in] = ACTIONS(5510),
    [anon_sym_QMARK] = ACTIONS(5512),
    [anon_sym_BANG] = ACTIONS(5512),
    [anon_sym_PLUS_PLUS] = ACTIONS(5510),
    [anon_sym_DASH_DASH] = ACTIONS(5510),
    [anon_sym_PLUS] = ACTIONS(5512),
    [anon_sym_DASH] = ACTIONS(5512),
    [anon_sym_STAR] = ACTIONS(5510),
    [anon_sym_SLASH] = ACTIONS(5512),
    [anon_sym_PERCENT] = ACTIONS(5510),
    [anon_sym_CARET] = ACTIONS(5510),
    [anon_sym_PIPE] = ACTIONS(5512),
    [anon_sym_AMP] = ACTIONS(5512),
    [anon_sym_LT_LT] = ACTIONS(5510),
    [anon_sym_GT_GT] = ACTIONS(5512),
    [anon_sym_GT_GT_GT] = ACTIONS(5510),
    [anon_sym_EQ_EQ] = ACTIONS(5510),
    [anon_sym_BANG_EQ] = ACTIONS(5510),
    [anon_sym_GT_EQ] = ACTIONS(5510),
    [anon_sym_LT_EQ] = ACTIONS(5510),
    [anon_sym_DOT] = ACTIONS(5512),
    [anon_sym_EQ_GT] = ACTIONS(5510),
    [anon_sym_switch] = ACTIONS(5510),
    [anon_sym_when] = ACTIONS(5510),
    [anon_sym_DOT_DOT] = ACTIONS(5510),
    [anon_sym_and] = ACTIONS(5510),
    [anon_sym_or] = ACTIONS(5510),
    [anon_sym_AMP_AMP] = ACTIONS(5510),
    [anon_sym_PIPE_PIPE] = ACTIONS(5510),
    [anon_sym_QMARK_QMARK] = ACTIONS(5510),
    [anon_sym_on] = ACTIONS(5510),
    [anon_sym_equals] = ACTIONS(5510),
    [anon_sym_by] = ACTIONS(5510),
    [anon_sym_as] = ACTIONS(5510),
    [anon_sym_is] = ACTIONS(5510),
    [anon_sym_DASH_GT] = ACTIONS(5510),
    [anon_sym_with] = ACTIONS(5510),
    [aux_sym_preproc_if_token3] = ACTIONS(5510),
    [aux_sym_preproc_else_token1] = ACTIONS(5510),
    [aux_sym_preproc_elif_token1] = ACTIONS(5510),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4152] = {
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7077),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9200),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4152),
    [sym_preproc_endregion] = STATE(4152),
    [sym_preproc_line] = STATE(4152),
    [sym_preproc_pragma] = STATE(4152),
    [sym_preproc_nullable] = STATE(4152),
    [sym_preproc_error] = STATE(4152),
    [sym_preproc_define] = STATE(4152),
    [sym_preproc_undef] = STATE(4152),
    [aux_sym_lambda_expression_repeat1] = STATE(6864),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(5898),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4153] = {
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(6930),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9156),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4153),
    [sym_preproc_endregion] = STATE(4153),
    [sym_preproc_line] = STATE(4153),
    [sym_preproc_pragma] = STATE(4153),
    [sym_preproc_nullable] = STATE(4153),
    [sym_preproc_error] = STATE(4153),
    [sym_preproc_define] = STATE(4153),
    [sym_preproc_undef] = STATE(4153),
    [aux_sym_lambda_expression_repeat1] = STATE(6864),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4154] = {
    [sym_type_parameter_constraint] = STATE(7749),
    [sym_constructor_constraint] = STATE(8100),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(8168),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_identifier] = STATE(4921),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4154),
    [sym_preproc_endregion] = STATE(4154),
    [sym_preproc_line] = STATE(4154),
    [sym_preproc_pragma] = STATE(4154),
    [sym_preproc_nullable] = STATE(4154),
    [sym_preproc_error] = STATE(4154),
    [sym_preproc_define] = STATE(4154),
    [sym_preproc_undef] = STATE(4154),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_LPAREN] = ACTIONS(2995),
    [anon_sym_class] = ACTIONS(5910),
    [anon_sym_ref] = ACTIONS(5912),
    [anon_sym_struct] = ACTIONS(5914),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_new] = ACTIONS(5916),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(5918),
    [anon_sym_unmanaged] = ACTIONS(5918),
    [anon_sym_scoped] = ACTIONS(5920),
    [anon_sym_var] = ACTIONS(5284),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4155] = {
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7073),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9390),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4155),
    [sym_preproc_endregion] = STATE(4155),
    [sym_preproc_line] = STATE(4155),
    [sym_preproc_pragma] = STATE(4155),
    [sym_preproc_nullable] = STATE(4155),
    [sym_preproc_error] = STATE(4155),
    [sym_preproc_define] = STATE(4155),
    [sym_preproc_undef] = STATE(4155),
    [aux_sym_lambda_expression_repeat1] = STATE(6864),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4156] = {
    [sym__name] = STATE(7759),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(9071),
    [sym_implicit_type] = STATE(8901),
    [sym_array_type] = STATE(8236),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(8217),
    [sym_pointer_type] = STATE(8217),
    [sym__pointer_base_type] = STATE(9650),
    [sym_function_pointer_type] = STATE(8217),
    [sym_function_pointer_parameter] = STATE(9350),
    [sym_ref_type] = STATE(8704),
    [sym__ref_base_type] = STATE(9351),
    [sym_scoped_type] = STATE(8704),
    [sym_tuple_type] = STATE(8136),
    [sym_identifier] = STATE(4921),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4156),
    [sym_preproc_endregion] = STATE(4156),
    [sym_preproc_line] = STATE(4156),
    [sym_preproc_pragma] = STATE(4156),
    [sym_preproc_nullable] = STATE(4156),
    [sym_preproc_error] = STATE(4156),
    [sym_preproc_define] = STATE(4156),
    [sym_preproc_undef] = STATE(4156),
    [aux_sym_function_pointer_type_repeat1] = STATE(4464),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_LPAREN] = ACTIONS(2995),
    [anon_sym_ref] = ACTIONS(5882),
    [anon_sym_delegate] = ACTIONS(5659),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_in] = ACTIONS(5884),
    [anon_sym_out] = ACTIONS(5884),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(5886),
    [anon_sym_var] = ACTIONS(5284),
    [sym_predefined_type] = ACTIONS(5888),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4157] = {
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7079),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9198),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4157),
    [sym_preproc_endregion] = STATE(4157),
    [sym_preproc_line] = STATE(4157),
    [sym_preproc_pragma] = STATE(4157),
    [sym_preproc_nullable] = STATE(4157),
    [sym_preproc_error] = STATE(4157),
    [sym_preproc_define] = STATE(4157),
    [sym_preproc_undef] = STATE(4157),
    [aux_sym_lambda_expression_repeat1] = STATE(6864),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4158] = {
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(6988),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9053),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4158),
    [sym_preproc_endregion] = STATE(4158),
    [sym_preproc_line] = STATE(4158),
    [sym_preproc_pragma] = STATE(4158),
    [sym_preproc_nullable] = STATE(4158),
    [sym_preproc_error] = STATE(4158),
    [sym_preproc_define] = STATE(4158),
    [sym_preproc_undef] = STATE(4158),
    [aux_sym_lambda_expression_repeat1] = STATE(6864),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4159] = {
    [sym_preproc_region] = STATE(4159),
    [sym_preproc_endregion] = STATE(4159),
    [sym_preproc_line] = STATE(4159),
    [sym_preproc_pragma] = STATE(4159),
    [sym_preproc_nullable] = STATE(4159),
    [sym_preproc_error] = STATE(4159),
    [sym_preproc_define] = STATE(4159),
    [sym_preproc_undef] = STATE(4159),
    [anon_sym_SEMI] = ACTIONS(5502),
    [anon_sym_LBRACK] = ACTIONS(5502),
    [anon_sym_COLON] = ACTIONS(5502),
    [anon_sym_COMMA] = ACTIONS(5502),
    [anon_sym_RBRACK] = ACTIONS(5502),
    [anon_sym_LPAREN] = ACTIONS(5502),
    [anon_sym_RPAREN] = ACTIONS(5502),
    [anon_sym_RBRACE] = ACTIONS(5502),
    [anon_sym_LT] = ACTIONS(5504),
    [anon_sym_GT] = ACTIONS(5504),
    [anon_sym_in] = ACTIONS(5502),
    [anon_sym_QMARK] = ACTIONS(5504),
    [anon_sym_BANG] = ACTIONS(5504),
    [anon_sym_PLUS_PLUS] = ACTIONS(5502),
    [anon_sym_DASH_DASH] = ACTIONS(5502),
    [anon_sym_PLUS] = ACTIONS(5504),
    [anon_sym_DASH] = ACTIONS(5504),
    [anon_sym_STAR] = ACTIONS(5502),
    [anon_sym_SLASH] = ACTIONS(5504),
    [anon_sym_PERCENT] = ACTIONS(5502),
    [anon_sym_CARET] = ACTIONS(5502),
    [anon_sym_PIPE] = ACTIONS(5504),
    [anon_sym_AMP] = ACTIONS(5504),
    [anon_sym_LT_LT] = ACTIONS(5502),
    [anon_sym_GT_GT] = ACTIONS(5504),
    [anon_sym_GT_GT_GT] = ACTIONS(5502),
    [anon_sym_EQ_EQ] = ACTIONS(5502),
    [anon_sym_BANG_EQ] = ACTIONS(5502),
    [anon_sym_GT_EQ] = ACTIONS(5502),
    [anon_sym_LT_EQ] = ACTIONS(5502),
    [anon_sym_DOT] = ACTIONS(5504),
    [anon_sym_EQ_GT] = ACTIONS(5502),
    [anon_sym_switch] = ACTIONS(5502),
    [anon_sym_when] = ACTIONS(5502),
    [anon_sym_DOT_DOT] = ACTIONS(5502),
    [anon_sym_and] = ACTIONS(5502),
    [anon_sym_or] = ACTIONS(5502),
    [anon_sym_AMP_AMP] = ACTIONS(5502),
    [anon_sym_PIPE_PIPE] = ACTIONS(5502),
    [anon_sym_QMARK_QMARK] = ACTIONS(5502),
    [anon_sym_on] = ACTIONS(5502),
    [anon_sym_equals] = ACTIONS(5502),
    [anon_sym_by] = ACTIONS(5502),
    [anon_sym_as] = ACTIONS(5502),
    [anon_sym_is] = ACTIONS(5502),
    [anon_sym_DASH_GT] = ACTIONS(5502),
    [anon_sym_with] = ACTIONS(5502),
    [aux_sym_preproc_if_token3] = ACTIONS(5502),
    [aux_sym_preproc_else_token1] = ACTIONS(5502),
    [aux_sym_preproc_elif_token1] = ACTIONS(5502),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4160] = {
    [sym_preproc_region] = STATE(4160),
    [sym_preproc_endregion] = STATE(4160),
    [sym_preproc_line] = STATE(4160),
    [sym_preproc_pragma] = STATE(4160),
    [sym_preproc_nullable] = STATE(4160),
    [sym_preproc_error] = STATE(4160),
    [sym_preproc_define] = STATE(4160),
    [sym_preproc_undef] = STATE(4160),
    [anon_sym_SEMI] = ACTIONS(5490),
    [anon_sym_LBRACK] = ACTIONS(5490),
    [anon_sym_COLON] = ACTIONS(5490),
    [anon_sym_COMMA] = ACTIONS(5490),
    [anon_sym_RBRACK] = ACTIONS(5490),
    [anon_sym_LPAREN] = ACTIONS(5490),
    [anon_sym_RPAREN] = ACTIONS(5490),
    [anon_sym_RBRACE] = ACTIONS(5490),
    [anon_sym_LT] = ACTIONS(5492),
    [anon_sym_GT] = ACTIONS(5492),
    [anon_sym_in] = ACTIONS(5490),
    [anon_sym_QMARK] = ACTIONS(5492),
    [anon_sym_BANG] = ACTIONS(5492),
    [anon_sym_PLUS_PLUS] = ACTIONS(5490),
    [anon_sym_DASH_DASH] = ACTIONS(5490),
    [anon_sym_PLUS] = ACTIONS(5492),
    [anon_sym_DASH] = ACTIONS(5492),
    [anon_sym_STAR] = ACTIONS(5490),
    [anon_sym_SLASH] = ACTIONS(5492),
    [anon_sym_PERCENT] = ACTIONS(5490),
    [anon_sym_CARET] = ACTIONS(5490),
    [anon_sym_PIPE] = ACTIONS(5492),
    [anon_sym_AMP] = ACTIONS(5492),
    [anon_sym_LT_LT] = ACTIONS(5490),
    [anon_sym_GT_GT] = ACTIONS(5492),
    [anon_sym_GT_GT_GT] = ACTIONS(5490),
    [anon_sym_EQ_EQ] = ACTIONS(5490),
    [anon_sym_BANG_EQ] = ACTIONS(5490),
    [anon_sym_GT_EQ] = ACTIONS(5490),
    [anon_sym_LT_EQ] = ACTIONS(5490),
    [anon_sym_DOT] = ACTIONS(5492),
    [anon_sym_EQ_GT] = ACTIONS(5490),
    [anon_sym_switch] = ACTIONS(5490),
    [anon_sym_when] = ACTIONS(5490),
    [anon_sym_DOT_DOT] = ACTIONS(5490),
    [anon_sym_and] = ACTIONS(5490),
    [anon_sym_or] = ACTIONS(5490),
    [anon_sym_AMP_AMP] = ACTIONS(5490),
    [anon_sym_PIPE_PIPE] = ACTIONS(5490),
    [anon_sym_QMARK_QMARK] = ACTIONS(5490),
    [anon_sym_on] = ACTIONS(5490),
    [anon_sym_equals] = ACTIONS(5490),
    [anon_sym_by] = ACTIONS(5490),
    [anon_sym_as] = ACTIONS(5490),
    [anon_sym_is] = ACTIONS(5490),
    [anon_sym_DASH_GT] = ACTIONS(5490),
    [anon_sym_with] = ACTIONS(5490),
    [aux_sym_preproc_if_token3] = ACTIONS(5490),
    [aux_sym_preproc_else_token1] = ACTIONS(5490),
    [aux_sym_preproc_elif_token1] = ACTIONS(5490),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4161] = {
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7088),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9193),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4161),
    [sym_preproc_endregion] = STATE(4161),
    [sym_preproc_line] = STATE(4161),
    [sym_preproc_pragma] = STATE(4161),
    [sym_preproc_nullable] = STATE(4161),
    [sym_preproc_error] = STATE(4161),
    [sym_preproc_define] = STATE(4161),
    [sym_preproc_undef] = STATE(4161),
    [aux_sym_lambda_expression_repeat1] = STATE(6864),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(5890),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4162] = {
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(6945),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9151),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4162),
    [sym_preproc_endregion] = STATE(4162),
    [sym_preproc_line] = STATE(4162),
    [sym_preproc_pragma] = STATE(4162),
    [sym_preproc_nullable] = STATE(4162),
    [sym_preproc_error] = STATE(4162),
    [sym_preproc_define] = STATE(4162),
    [sym_preproc_undef] = STATE(4162),
    [aux_sym_lambda_expression_repeat1] = STATE(6864),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(5894),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4163] = {
    [sym_preproc_region] = STATE(4163),
    [sym_preproc_endregion] = STATE(4163),
    [sym_preproc_line] = STATE(4163),
    [sym_preproc_pragma] = STATE(4163),
    [sym_preproc_nullable] = STATE(4163),
    [sym_preproc_error] = STATE(4163),
    [sym_preproc_define] = STATE(4163),
    [sym_preproc_undef] = STATE(4163),
    [anon_sym_EQ] = ACTIONS(4118),
    [anon_sym_LBRACK] = ACTIONS(4133),
    [anon_sym_COLON] = ACTIONS(4741),
    [anon_sym_LPAREN] = ACTIONS(4133),
    [anon_sym_LT] = ACTIONS(4118),
    [anon_sym_GT] = ACTIONS(4118),
    [anon_sym_QMARK] = ACTIONS(4118),
    [anon_sym_BANG] = ACTIONS(4118),
    [anon_sym_PLUS_PLUS] = ACTIONS(4133),
    [anon_sym_DASH_DASH] = ACTIONS(4133),
    [anon_sym_PLUS] = ACTIONS(4118),
    [anon_sym_DASH] = ACTIONS(4118),
    [anon_sym_STAR] = ACTIONS(4118),
    [anon_sym_SLASH] = ACTIONS(4118),
    [anon_sym_PERCENT] = ACTIONS(4118),
    [anon_sym_CARET] = ACTIONS(4118),
    [anon_sym_PIPE] = ACTIONS(4118),
    [anon_sym_AMP] = ACTIONS(4118),
    [anon_sym_LT_LT] = ACTIONS(4118),
    [anon_sym_GT_GT] = ACTIONS(4118),
    [anon_sym_GT_GT_GT] = ACTIONS(4118),
    [anon_sym_EQ_EQ] = ACTIONS(4133),
    [anon_sym_BANG_EQ] = ACTIONS(4133),
    [anon_sym_GT_EQ] = ACTIONS(4133),
    [anon_sym_LT_EQ] = ACTIONS(4133),
    [anon_sym_DOT] = ACTIONS(4118),
    [anon_sym_switch] = ACTIONS(4133),
    [anon_sym_when] = ACTIONS(4739),
    [anon_sym_DOT_DOT] = ACTIONS(4133),
    [anon_sym_and] = ACTIONS(4739),
    [anon_sym_or] = ACTIONS(4739),
    [anon_sym_PLUS_EQ] = ACTIONS(4133),
    [anon_sym_DASH_EQ] = ACTIONS(4133),
    [anon_sym_STAR_EQ] = ACTIONS(4133),
    [anon_sym_SLASH_EQ] = ACTIONS(4133),
    [anon_sym_PERCENT_EQ] = ACTIONS(4133),
    [anon_sym_AMP_EQ] = ACTIONS(4133),
    [anon_sym_CARET_EQ] = ACTIONS(4133),
    [anon_sym_PIPE_EQ] = ACTIONS(4133),
    [anon_sym_LT_LT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4133),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4133),
    [anon_sym_AMP_AMP] = ACTIONS(4133),
    [anon_sym_PIPE_PIPE] = ACTIONS(4133),
    [anon_sym_QMARK_QMARK] = ACTIONS(4118),
    [anon_sym_as] = ACTIONS(4133),
    [anon_sym_is] = ACTIONS(4133),
    [anon_sym_DASH_GT] = ACTIONS(4133),
    [anon_sym_with] = ACTIONS(4133),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4164] = {
    [sym_preproc_region] = STATE(4164),
    [sym_preproc_endregion] = STATE(4164),
    [sym_preproc_line] = STATE(4164),
    [sym_preproc_pragma] = STATE(4164),
    [sym_preproc_nullable] = STATE(4164),
    [sym_preproc_error] = STATE(4164),
    [sym_preproc_define] = STATE(4164),
    [sym_preproc_undef] = STATE(4164),
    [anon_sym_SEMI] = ACTIONS(5466),
    [anon_sym_LBRACK] = ACTIONS(5466),
    [anon_sym_COLON] = ACTIONS(5466),
    [anon_sym_COMMA] = ACTIONS(5466),
    [anon_sym_RBRACK] = ACTIONS(5466),
    [anon_sym_LPAREN] = ACTIONS(5466),
    [anon_sym_RPAREN] = ACTIONS(5466),
    [anon_sym_RBRACE] = ACTIONS(5466),
    [anon_sym_LT] = ACTIONS(5468),
    [anon_sym_GT] = ACTIONS(5468),
    [anon_sym_in] = ACTIONS(5466),
    [anon_sym_QMARK] = ACTIONS(5468),
    [anon_sym_BANG] = ACTIONS(5468),
    [anon_sym_PLUS_PLUS] = ACTIONS(5466),
    [anon_sym_DASH_DASH] = ACTIONS(5466),
    [anon_sym_PLUS] = ACTIONS(5468),
    [anon_sym_DASH] = ACTIONS(5468),
    [anon_sym_STAR] = ACTIONS(5466),
    [anon_sym_SLASH] = ACTIONS(5468),
    [anon_sym_PERCENT] = ACTIONS(5466),
    [anon_sym_CARET] = ACTIONS(5466),
    [anon_sym_PIPE] = ACTIONS(5468),
    [anon_sym_AMP] = ACTIONS(5468),
    [anon_sym_LT_LT] = ACTIONS(5466),
    [anon_sym_GT_GT] = ACTIONS(5468),
    [anon_sym_GT_GT_GT] = ACTIONS(5466),
    [anon_sym_EQ_EQ] = ACTIONS(5466),
    [anon_sym_BANG_EQ] = ACTIONS(5466),
    [anon_sym_GT_EQ] = ACTIONS(5466),
    [anon_sym_LT_EQ] = ACTIONS(5466),
    [anon_sym_DOT] = ACTIONS(5468),
    [anon_sym_EQ_GT] = ACTIONS(5466),
    [anon_sym_switch] = ACTIONS(5466),
    [anon_sym_when] = ACTIONS(5466),
    [anon_sym_DOT_DOT] = ACTIONS(5466),
    [anon_sym_and] = ACTIONS(5466),
    [anon_sym_or] = ACTIONS(5466),
    [anon_sym_AMP_AMP] = ACTIONS(5466),
    [anon_sym_PIPE_PIPE] = ACTIONS(5466),
    [anon_sym_QMARK_QMARK] = ACTIONS(5466),
    [anon_sym_on] = ACTIONS(5466),
    [anon_sym_equals] = ACTIONS(5466),
    [anon_sym_by] = ACTIONS(5466),
    [anon_sym_as] = ACTIONS(5466),
    [anon_sym_is] = ACTIONS(5466),
    [anon_sym_DASH_GT] = ACTIONS(5466),
    [anon_sym_with] = ACTIONS(5466),
    [aux_sym_preproc_if_token3] = ACTIONS(5466),
    [aux_sym_preproc_else_token1] = ACTIONS(5466),
    [aux_sym_preproc_elif_token1] = ACTIONS(5466),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4165] = {
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7086),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9395),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4165),
    [sym_preproc_endregion] = STATE(4165),
    [sym_preproc_line] = STATE(4165),
    [sym_preproc_pragma] = STATE(4165),
    [sym_preproc_nullable] = STATE(4165),
    [sym_preproc_error] = STATE(4165),
    [sym_preproc_define] = STATE(4165),
    [sym_preproc_undef] = STATE(4165),
    [aux_sym_lambda_expression_repeat1] = STATE(6864),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(5890),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4166] = {
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7100),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9191),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4166),
    [sym_preproc_endregion] = STATE(4166),
    [sym_preproc_line] = STATE(4166),
    [sym_preproc_pragma] = STATE(4166),
    [sym_preproc_nullable] = STATE(4166),
    [sym_preproc_error] = STATE(4166),
    [sym_preproc_define] = STATE(4166),
    [sym_preproc_undef] = STATE(4166),
    [aux_sym_lambda_expression_repeat1] = STATE(6864),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4167] = {
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(6948),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9148),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4167),
    [sym_preproc_endregion] = STATE(4167),
    [sym_preproc_line] = STATE(4167),
    [sym_preproc_pragma] = STATE(4167),
    [sym_preproc_nullable] = STATE(4167),
    [sym_preproc_error] = STATE(4167),
    [sym_preproc_define] = STATE(4167),
    [sym_preproc_undef] = STATE(4167),
    [aux_sym_lambda_expression_repeat1] = STATE(6864),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4168] = {
    [sym__name] = STATE(6160),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_ref_type] = STATE(2899),
    [sym__scoped_base_type] = STATE(2907),
    [sym_identifier] = STATE(5368),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_region] = STATE(4168),
    [sym_preproc_endregion] = STATE(4168),
    [sym_preproc_line] = STATE(4168),
    [sym_preproc_pragma] = STATE(4168),
    [sym_preproc_nullable] = STATE(4168),
    [sym_preproc_error] = STATE(4168),
    [sym_preproc_define] = STATE(4168),
    [sym_preproc_undef] = STATE(4168),
    [sym__identifier_token] = ACTIONS(3987),
    [anon_sym_alias] = ACTIONS(3991),
    [anon_sym_global] = ACTIONS(3991),
    [anon_sym_EQ] = ACTIONS(3719),
    [anon_sym_LBRACK] = ACTIONS(3719),
    [anon_sym_COMMA] = ACTIONS(3719),
    [anon_sym_RBRACK] = ACTIONS(3719),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_RPAREN] = ACTIONS(3719),
    [anon_sym_ref] = ACTIONS(2603),
    [anon_sym_delegate] = ACTIONS(2603),
    [anon_sym_file] = ACTIONS(3991),
    [anon_sym_readonly] = ACTIONS(2603),
    [anon_sym_LT] = ACTIONS(3719),
    [anon_sym_in] = ACTIONS(2603),
    [anon_sym_out] = ACTIONS(2603),
    [anon_sym_where] = ACTIONS(3991),
    [anon_sym_QMARK] = ACTIONS(3719),
    [anon_sym_notnull] = ACTIONS(3991),
    [anon_sym_unmanaged] = ACTIONS(3991),
    [anon_sym_STAR] = ACTIONS(3719),
    [anon_sym_this] = ACTIONS(2603),
    [anon_sym_DOT] = ACTIONS(3719),
    [anon_sym_scoped] = ACTIONS(3991),
    [anon_sym_COLON_COLON] = ACTIONS(3719),
    [anon_sym_var] = ACTIONS(3991),
    [sym_predefined_type] = ACTIONS(2603),
    [anon_sym_yield] = ACTIONS(3991),
    [anon_sym_when] = ACTIONS(3991),
    [anon_sym_from] = ACTIONS(3991),
    [anon_sym_into] = ACTIONS(3991),
    [anon_sym_join] = ACTIONS(3991),
    [anon_sym_on] = ACTIONS(3991),
    [anon_sym_equals] = ACTIONS(3991),
    [anon_sym_let] = ACTIONS(3991),
    [anon_sym_orderby] = ACTIONS(3991),
    [anon_sym_ascending] = ACTIONS(3991),
    [anon_sym_descending] = ACTIONS(3991),
    [anon_sym_group] = ACTIONS(3991),
    [anon_sym_by] = ACTIONS(3991),
    [anon_sym_select] = ACTIONS(3991),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4169] = {
    [sym_preproc_region] = STATE(4169),
    [sym_preproc_endregion] = STATE(4169),
    [sym_preproc_line] = STATE(4169),
    [sym_preproc_pragma] = STATE(4169),
    [sym_preproc_nullable] = STATE(4169),
    [sym_preproc_error] = STATE(4169),
    [sym_preproc_define] = STATE(4169),
    [sym_preproc_undef] = STATE(4169),
    [anon_sym_SEMI] = ACTIONS(5452),
    [anon_sym_LBRACK] = ACTIONS(5452),
    [anon_sym_COLON] = ACTIONS(5452),
    [anon_sym_COMMA] = ACTIONS(5452),
    [anon_sym_RBRACK] = ACTIONS(5452),
    [anon_sym_LPAREN] = ACTIONS(5452),
    [anon_sym_RPAREN] = ACTIONS(5452),
    [anon_sym_RBRACE] = ACTIONS(5452),
    [anon_sym_LT] = ACTIONS(5454),
    [anon_sym_GT] = ACTIONS(5454),
    [anon_sym_in] = ACTIONS(5452),
    [anon_sym_QMARK] = ACTIONS(5454),
    [anon_sym_BANG] = ACTIONS(5454),
    [anon_sym_PLUS_PLUS] = ACTIONS(5452),
    [anon_sym_DASH_DASH] = ACTIONS(5452),
    [anon_sym_PLUS] = ACTIONS(5454),
    [anon_sym_DASH] = ACTIONS(5454),
    [anon_sym_STAR] = ACTIONS(5452),
    [anon_sym_SLASH] = ACTIONS(5454),
    [anon_sym_PERCENT] = ACTIONS(5452),
    [anon_sym_CARET] = ACTIONS(5452),
    [anon_sym_PIPE] = ACTIONS(5454),
    [anon_sym_AMP] = ACTIONS(5454),
    [anon_sym_LT_LT] = ACTIONS(5452),
    [anon_sym_GT_GT] = ACTIONS(5454),
    [anon_sym_GT_GT_GT] = ACTIONS(5452),
    [anon_sym_EQ_EQ] = ACTIONS(5452),
    [anon_sym_BANG_EQ] = ACTIONS(5452),
    [anon_sym_GT_EQ] = ACTIONS(5452),
    [anon_sym_LT_EQ] = ACTIONS(5452),
    [anon_sym_DOT] = ACTIONS(5454),
    [anon_sym_EQ_GT] = ACTIONS(5452),
    [anon_sym_switch] = ACTIONS(5452),
    [anon_sym_when] = ACTIONS(5452),
    [anon_sym_DOT_DOT] = ACTIONS(5452),
    [anon_sym_and] = ACTIONS(5452),
    [anon_sym_or] = ACTIONS(5452),
    [anon_sym_AMP_AMP] = ACTIONS(5452),
    [anon_sym_PIPE_PIPE] = ACTIONS(5452),
    [anon_sym_QMARK_QMARK] = ACTIONS(5452),
    [anon_sym_on] = ACTIONS(5452),
    [anon_sym_equals] = ACTIONS(5452),
    [anon_sym_by] = ACTIONS(5452),
    [anon_sym_as] = ACTIONS(5452),
    [anon_sym_is] = ACTIONS(5452),
    [anon_sym_DASH_GT] = ACTIONS(5452),
    [anon_sym_with] = ACTIONS(5452),
    [aux_sym_preproc_if_token3] = ACTIONS(5452),
    [aux_sym_preproc_else_token1] = ACTIONS(5452),
    [aux_sym_preproc_elif_token1] = ACTIONS(5452),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4170] = {
    [sym_initializer_expression] = STATE(3685),
    [sym_preproc_region] = STATE(4170),
    [sym_preproc_endregion] = STATE(4170),
    [sym_preproc_line] = STATE(4170),
    [sym_preproc_pragma] = STATE(4170),
    [sym_preproc_nullable] = STATE(4170),
    [sym_preproc_error] = STATE(4170),
    [sym_preproc_define] = STATE(4170),
    [sym_preproc_undef] = STATE(4170),
    [anon_sym_SEMI] = ACTIONS(5302),
    [anon_sym_LBRACK] = ACTIONS(5298),
    [anon_sym_COLON] = ACTIONS(5302),
    [anon_sym_COMMA] = ACTIONS(5302),
    [anon_sym_RBRACK] = ACTIONS(5302),
    [anon_sym_LPAREN] = ACTIONS(5302),
    [anon_sym_RPAREN] = ACTIONS(5302),
    [anon_sym_LBRACE] = ACTIONS(5922),
    [anon_sym_RBRACE] = ACTIONS(5302),
    [anon_sym_LT] = ACTIONS(5308),
    [anon_sym_GT] = ACTIONS(5308),
    [anon_sym_in] = ACTIONS(5308),
    [anon_sym_QMARK] = ACTIONS(5925),
    [anon_sym_BANG] = ACTIONS(5308),
    [anon_sym_PLUS_PLUS] = ACTIONS(5302),
    [anon_sym_DASH_DASH] = ACTIONS(5302),
    [anon_sym_PLUS] = ACTIONS(5308),
    [anon_sym_DASH] = ACTIONS(5308),
    [anon_sym_STAR] = ACTIONS(5302),
    [anon_sym_SLASH] = ACTIONS(5308),
    [anon_sym_PERCENT] = ACTIONS(5302),
    [anon_sym_CARET] = ACTIONS(5302),
    [anon_sym_PIPE] = ACTIONS(5308),
    [anon_sym_AMP] = ACTIONS(5308),
    [anon_sym_LT_LT] = ACTIONS(5302),
    [anon_sym_GT_GT] = ACTIONS(5308),
    [anon_sym_GT_GT_GT] = ACTIONS(5302),
    [anon_sym_EQ_EQ] = ACTIONS(5302),
    [anon_sym_BANG_EQ] = ACTIONS(5302),
    [anon_sym_GT_EQ] = ACTIONS(5302),
    [anon_sym_LT_EQ] = ACTIONS(5302),
    [anon_sym_DOT] = ACTIONS(5308),
    [anon_sym_EQ_GT] = ACTIONS(5302),
    [anon_sym_switch] = ACTIONS(5302),
    [anon_sym_DOT_DOT] = ACTIONS(5302),
    [anon_sym_AMP_AMP] = ACTIONS(5302),
    [anon_sym_PIPE_PIPE] = ACTIONS(5302),
    [anon_sym_QMARK_QMARK] = ACTIONS(5302),
    [anon_sym_into] = ACTIONS(5302),
    [anon_sym_on] = ACTIONS(5302),
    [anon_sym_equals] = ACTIONS(5302),
    [anon_sym_by] = ACTIONS(5302),
    [anon_sym_as] = ACTIONS(5302),
    [anon_sym_is] = ACTIONS(5302),
    [anon_sym_DASH_GT] = ACTIONS(5302),
    [anon_sym_with] = ACTIONS(5302),
    [aux_sym_preproc_if_token3] = ACTIONS(5302),
    [aux_sym_preproc_else_token1] = ACTIONS(5302),
    [aux_sym_preproc_elif_token1] = ACTIONS(5302),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4171] = {
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7003),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9141),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4171),
    [sym_preproc_endregion] = STATE(4171),
    [sym_preproc_line] = STATE(4171),
    [sym_preproc_pragma] = STATE(4171),
    [sym_preproc_nullable] = STATE(4171),
    [sym_preproc_error] = STATE(4171),
    [sym_preproc_define] = STATE(4171),
    [sym_preproc_undef] = STATE(4171),
    [aux_sym_lambda_expression_repeat1] = STATE(6864),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(5894),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4172] = {
    [sym_preproc_region] = STATE(4172),
    [sym_preproc_endregion] = STATE(4172),
    [sym_preproc_line] = STATE(4172),
    [sym_preproc_pragma] = STATE(4172),
    [sym_preproc_nullable] = STATE(4172),
    [sym_preproc_error] = STATE(4172),
    [sym_preproc_define] = STATE(4172),
    [sym_preproc_undef] = STATE(4172),
    [anon_sym_SEMI] = ACTIONS(5436),
    [anon_sym_LBRACK] = ACTIONS(5436),
    [anon_sym_COLON] = ACTIONS(5436),
    [anon_sym_COMMA] = ACTIONS(5436),
    [anon_sym_RBRACK] = ACTIONS(5436),
    [anon_sym_LPAREN] = ACTIONS(5436),
    [anon_sym_RPAREN] = ACTIONS(5436),
    [anon_sym_RBRACE] = ACTIONS(5436),
    [anon_sym_LT] = ACTIONS(5438),
    [anon_sym_GT] = ACTIONS(5438),
    [anon_sym_in] = ACTIONS(5436),
    [anon_sym_QMARK] = ACTIONS(5438),
    [anon_sym_BANG] = ACTIONS(5438),
    [anon_sym_PLUS_PLUS] = ACTIONS(5436),
    [anon_sym_DASH_DASH] = ACTIONS(5436),
    [anon_sym_PLUS] = ACTIONS(5438),
    [anon_sym_DASH] = ACTIONS(5438),
    [anon_sym_STAR] = ACTIONS(5436),
    [anon_sym_SLASH] = ACTIONS(5438),
    [anon_sym_PERCENT] = ACTIONS(5436),
    [anon_sym_CARET] = ACTIONS(5436),
    [anon_sym_PIPE] = ACTIONS(5438),
    [anon_sym_AMP] = ACTIONS(5438),
    [anon_sym_LT_LT] = ACTIONS(5436),
    [anon_sym_GT_GT] = ACTIONS(5438),
    [anon_sym_GT_GT_GT] = ACTIONS(5436),
    [anon_sym_EQ_EQ] = ACTIONS(5436),
    [anon_sym_BANG_EQ] = ACTIONS(5436),
    [anon_sym_GT_EQ] = ACTIONS(5436),
    [anon_sym_LT_EQ] = ACTIONS(5436),
    [anon_sym_DOT] = ACTIONS(5438),
    [anon_sym_EQ_GT] = ACTIONS(5436),
    [anon_sym_switch] = ACTIONS(5436),
    [anon_sym_when] = ACTIONS(5436),
    [anon_sym_DOT_DOT] = ACTIONS(5436),
    [anon_sym_and] = ACTIONS(5436),
    [anon_sym_or] = ACTIONS(5436),
    [anon_sym_AMP_AMP] = ACTIONS(5436),
    [anon_sym_PIPE_PIPE] = ACTIONS(5436),
    [anon_sym_QMARK_QMARK] = ACTIONS(5436),
    [anon_sym_on] = ACTIONS(5436),
    [anon_sym_equals] = ACTIONS(5436),
    [anon_sym_by] = ACTIONS(5436),
    [anon_sym_as] = ACTIONS(5436),
    [anon_sym_is] = ACTIONS(5436),
    [anon_sym_DASH_GT] = ACTIONS(5436),
    [anon_sym_with] = ACTIONS(5436),
    [aux_sym_preproc_if_token3] = ACTIONS(5436),
    [aux_sym_preproc_else_token1] = ACTIONS(5436),
    [aux_sym_preproc_elif_token1] = ACTIONS(5436),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4173] = {
    [sym_preproc_region] = STATE(4173),
    [sym_preproc_endregion] = STATE(4173),
    [sym_preproc_line] = STATE(4173),
    [sym_preproc_pragma] = STATE(4173),
    [sym_preproc_nullable] = STATE(4173),
    [sym_preproc_error] = STATE(4173),
    [sym_preproc_define] = STATE(4173),
    [sym_preproc_undef] = STATE(4173),
    [anon_sym_SEMI] = ACTIONS(5432),
    [anon_sym_LBRACK] = ACTIONS(5432),
    [anon_sym_COLON] = ACTIONS(5432),
    [anon_sym_COMMA] = ACTIONS(5432),
    [anon_sym_RBRACK] = ACTIONS(5432),
    [anon_sym_LPAREN] = ACTIONS(5432),
    [anon_sym_RPAREN] = ACTIONS(5432),
    [anon_sym_RBRACE] = ACTIONS(5432),
    [anon_sym_LT] = ACTIONS(5434),
    [anon_sym_GT] = ACTIONS(5434),
    [anon_sym_in] = ACTIONS(5432),
    [anon_sym_QMARK] = ACTIONS(5434),
    [anon_sym_BANG] = ACTIONS(5434),
    [anon_sym_PLUS_PLUS] = ACTIONS(5432),
    [anon_sym_DASH_DASH] = ACTIONS(5432),
    [anon_sym_PLUS] = ACTIONS(5434),
    [anon_sym_DASH] = ACTIONS(5434),
    [anon_sym_STAR] = ACTIONS(5432),
    [anon_sym_SLASH] = ACTIONS(5434),
    [anon_sym_PERCENT] = ACTIONS(5432),
    [anon_sym_CARET] = ACTIONS(5432),
    [anon_sym_PIPE] = ACTIONS(5434),
    [anon_sym_AMP] = ACTIONS(5434),
    [anon_sym_LT_LT] = ACTIONS(5432),
    [anon_sym_GT_GT] = ACTIONS(5434),
    [anon_sym_GT_GT_GT] = ACTIONS(5432),
    [anon_sym_EQ_EQ] = ACTIONS(5432),
    [anon_sym_BANG_EQ] = ACTIONS(5432),
    [anon_sym_GT_EQ] = ACTIONS(5432),
    [anon_sym_LT_EQ] = ACTIONS(5432),
    [anon_sym_DOT] = ACTIONS(5434),
    [anon_sym_EQ_GT] = ACTIONS(5432),
    [anon_sym_switch] = ACTIONS(5432),
    [anon_sym_when] = ACTIONS(5432),
    [anon_sym_DOT_DOT] = ACTIONS(5432),
    [anon_sym_and] = ACTIONS(5432),
    [anon_sym_or] = ACTIONS(5432),
    [anon_sym_AMP_AMP] = ACTIONS(5432),
    [anon_sym_PIPE_PIPE] = ACTIONS(5432),
    [anon_sym_QMARK_QMARK] = ACTIONS(5432),
    [anon_sym_on] = ACTIONS(5432),
    [anon_sym_equals] = ACTIONS(5432),
    [anon_sym_by] = ACTIONS(5432),
    [anon_sym_as] = ACTIONS(5432),
    [anon_sym_is] = ACTIONS(5432),
    [anon_sym_DASH_GT] = ACTIONS(5432),
    [anon_sym_with] = ACTIONS(5432),
    [aux_sym_preproc_if_token3] = ACTIONS(5432),
    [aux_sym_preproc_else_token1] = ACTIONS(5432),
    [aux_sym_preproc_elif_token1] = ACTIONS(5432),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4174] = {
    [sym_preproc_region] = STATE(4174),
    [sym_preproc_endregion] = STATE(4174),
    [sym_preproc_line] = STATE(4174),
    [sym_preproc_pragma] = STATE(4174),
    [sym_preproc_nullable] = STATE(4174),
    [sym_preproc_error] = STATE(4174),
    [sym_preproc_define] = STATE(4174),
    [sym_preproc_undef] = STATE(4174),
    [anon_sym_SEMI] = ACTIONS(5428),
    [anon_sym_LBRACK] = ACTIONS(5428),
    [anon_sym_COLON] = ACTIONS(5428),
    [anon_sym_COMMA] = ACTIONS(5428),
    [anon_sym_RBRACK] = ACTIONS(5428),
    [anon_sym_LPAREN] = ACTIONS(5428),
    [anon_sym_RPAREN] = ACTIONS(5428),
    [anon_sym_RBRACE] = ACTIONS(5428),
    [anon_sym_LT] = ACTIONS(5430),
    [anon_sym_GT] = ACTIONS(5430),
    [anon_sym_in] = ACTIONS(5428),
    [anon_sym_QMARK] = ACTIONS(5430),
    [anon_sym_BANG] = ACTIONS(5430),
    [anon_sym_PLUS_PLUS] = ACTIONS(5428),
    [anon_sym_DASH_DASH] = ACTIONS(5428),
    [anon_sym_PLUS] = ACTIONS(5430),
    [anon_sym_DASH] = ACTIONS(5430),
    [anon_sym_STAR] = ACTIONS(5428),
    [anon_sym_SLASH] = ACTIONS(5430),
    [anon_sym_PERCENT] = ACTIONS(5428),
    [anon_sym_CARET] = ACTIONS(5428),
    [anon_sym_PIPE] = ACTIONS(5430),
    [anon_sym_AMP] = ACTIONS(5430),
    [anon_sym_LT_LT] = ACTIONS(5428),
    [anon_sym_GT_GT] = ACTIONS(5430),
    [anon_sym_GT_GT_GT] = ACTIONS(5428),
    [anon_sym_EQ_EQ] = ACTIONS(5428),
    [anon_sym_BANG_EQ] = ACTIONS(5428),
    [anon_sym_GT_EQ] = ACTIONS(5428),
    [anon_sym_LT_EQ] = ACTIONS(5428),
    [anon_sym_DOT] = ACTIONS(5430),
    [anon_sym_EQ_GT] = ACTIONS(5428),
    [anon_sym_switch] = ACTIONS(5428),
    [anon_sym_when] = ACTIONS(5428),
    [anon_sym_DOT_DOT] = ACTIONS(5428),
    [anon_sym_and] = ACTIONS(5428),
    [anon_sym_or] = ACTIONS(5428),
    [anon_sym_AMP_AMP] = ACTIONS(5428),
    [anon_sym_PIPE_PIPE] = ACTIONS(5428),
    [anon_sym_QMARK_QMARK] = ACTIONS(5428),
    [anon_sym_on] = ACTIONS(5428),
    [anon_sym_equals] = ACTIONS(5428),
    [anon_sym_by] = ACTIONS(5428),
    [anon_sym_as] = ACTIONS(5428),
    [anon_sym_is] = ACTIONS(5428),
    [anon_sym_DASH_GT] = ACTIONS(5428),
    [anon_sym_with] = ACTIONS(5428),
    [aux_sym_preproc_if_token3] = ACTIONS(5428),
    [aux_sym_preproc_else_token1] = ACTIONS(5428),
    [aux_sym_preproc_elif_token1] = ACTIONS(5428),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4175] = {
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7125),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9448),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4175),
    [sym_preproc_endregion] = STATE(4175),
    [sym_preproc_line] = STATE(4175),
    [sym_preproc_pragma] = STATE(4175),
    [sym_preproc_nullable] = STATE(4175),
    [sym_preproc_error] = STATE(4175),
    [sym_preproc_define] = STATE(4175),
    [sym_preproc_undef] = STATE(4175),
    [aux_sym_lambda_expression_repeat1] = STATE(6864),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4176] = {
    [sym_preproc_region] = STATE(4176),
    [sym_preproc_endregion] = STATE(4176),
    [sym_preproc_line] = STATE(4176),
    [sym_preproc_pragma] = STATE(4176),
    [sym_preproc_nullable] = STATE(4176),
    [sym_preproc_error] = STATE(4176),
    [sym_preproc_define] = STATE(4176),
    [sym_preproc_undef] = STATE(4176),
    [anon_sym_SEMI] = ACTIONS(5424),
    [anon_sym_LBRACK] = ACTIONS(5424),
    [anon_sym_COLON] = ACTIONS(5424),
    [anon_sym_COMMA] = ACTIONS(5424),
    [anon_sym_RBRACK] = ACTIONS(5424),
    [anon_sym_LPAREN] = ACTIONS(5424),
    [anon_sym_RPAREN] = ACTIONS(5424),
    [anon_sym_RBRACE] = ACTIONS(5424),
    [anon_sym_LT] = ACTIONS(5426),
    [anon_sym_GT] = ACTIONS(5426),
    [anon_sym_in] = ACTIONS(5424),
    [anon_sym_QMARK] = ACTIONS(5426),
    [anon_sym_BANG] = ACTIONS(5426),
    [anon_sym_PLUS_PLUS] = ACTIONS(5424),
    [anon_sym_DASH_DASH] = ACTIONS(5424),
    [anon_sym_PLUS] = ACTIONS(5426),
    [anon_sym_DASH] = ACTIONS(5426),
    [anon_sym_STAR] = ACTIONS(5424),
    [anon_sym_SLASH] = ACTIONS(5426),
    [anon_sym_PERCENT] = ACTIONS(5424),
    [anon_sym_CARET] = ACTIONS(5424),
    [anon_sym_PIPE] = ACTIONS(5426),
    [anon_sym_AMP] = ACTIONS(5426),
    [anon_sym_LT_LT] = ACTIONS(5424),
    [anon_sym_GT_GT] = ACTIONS(5426),
    [anon_sym_GT_GT_GT] = ACTIONS(5424),
    [anon_sym_EQ_EQ] = ACTIONS(5424),
    [anon_sym_BANG_EQ] = ACTIONS(5424),
    [anon_sym_GT_EQ] = ACTIONS(5424),
    [anon_sym_LT_EQ] = ACTIONS(5424),
    [anon_sym_DOT] = ACTIONS(5426),
    [anon_sym_EQ_GT] = ACTIONS(5424),
    [anon_sym_switch] = ACTIONS(5424),
    [anon_sym_when] = ACTIONS(5424),
    [anon_sym_DOT_DOT] = ACTIONS(5424),
    [anon_sym_and] = ACTIONS(5424),
    [anon_sym_or] = ACTIONS(5424),
    [anon_sym_AMP_AMP] = ACTIONS(5424),
    [anon_sym_PIPE_PIPE] = ACTIONS(5424),
    [anon_sym_QMARK_QMARK] = ACTIONS(5424),
    [anon_sym_on] = ACTIONS(5424),
    [anon_sym_equals] = ACTIONS(5424),
    [anon_sym_by] = ACTIONS(5424),
    [anon_sym_as] = ACTIONS(5424),
    [anon_sym_is] = ACTIONS(5424),
    [anon_sym_DASH_GT] = ACTIONS(5424),
    [anon_sym_with] = ACTIONS(5424),
    [aux_sym_preproc_if_token3] = ACTIONS(5424),
    [aux_sym_preproc_else_token1] = ACTIONS(5424),
    [aux_sym_preproc_elif_token1] = ACTIONS(5424),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4177] = {
    [sym_preproc_region] = STATE(4177),
    [sym_preproc_endregion] = STATE(4177),
    [sym_preproc_line] = STATE(4177),
    [sym_preproc_pragma] = STATE(4177),
    [sym_preproc_nullable] = STATE(4177),
    [sym_preproc_error] = STATE(4177),
    [sym_preproc_define] = STATE(4177),
    [sym_preproc_undef] = STATE(4177),
    [anon_sym_SEMI] = ACTIONS(5482),
    [anon_sym_LBRACK] = ACTIONS(5482),
    [anon_sym_COLON] = ACTIONS(5482),
    [anon_sym_COMMA] = ACTIONS(5482),
    [anon_sym_RBRACK] = ACTIONS(5482),
    [anon_sym_LPAREN] = ACTIONS(5482),
    [anon_sym_RPAREN] = ACTIONS(5482),
    [anon_sym_RBRACE] = ACTIONS(5482),
    [anon_sym_LT] = ACTIONS(5484),
    [anon_sym_GT] = ACTIONS(5484),
    [anon_sym_in] = ACTIONS(5482),
    [anon_sym_QMARK] = ACTIONS(5484),
    [anon_sym_BANG] = ACTIONS(5484),
    [anon_sym_PLUS_PLUS] = ACTIONS(5482),
    [anon_sym_DASH_DASH] = ACTIONS(5482),
    [anon_sym_PLUS] = ACTIONS(5484),
    [anon_sym_DASH] = ACTIONS(5484),
    [anon_sym_STAR] = ACTIONS(5482),
    [anon_sym_SLASH] = ACTIONS(5484),
    [anon_sym_PERCENT] = ACTIONS(5482),
    [anon_sym_CARET] = ACTIONS(5482),
    [anon_sym_PIPE] = ACTIONS(5484),
    [anon_sym_AMP] = ACTIONS(5484),
    [anon_sym_LT_LT] = ACTIONS(5482),
    [anon_sym_GT_GT] = ACTIONS(5484),
    [anon_sym_GT_GT_GT] = ACTIONS(5482),
    [anon_sym_EQ_EQ] = ACTIONS(5482),
    [anon_sym_BANG_EQ] = ACTIONS(5482),
    [anon_sym_GT_EQ] = ACTIONS(5482),
    [anon_sym_LT_EQ] = ACTIONS(5482),
    [anon_sym_DOT] = ACTIONS(5484),
    [anon_sym_EQ_GT] = ACTIONS(5482),
    [anon_sym_switch] = ACTIONS(5482),
    [anon_sym_when] = ACTIONS(5482),
    [anon_sym_DOT_DOT] = ACTIONS(5482),
    [anon_sym_and] = ACTIONS(5482),
    [anon_sym_or] = ACTIONS(5482),
    [anon_sym_AMP_AMP] = ACTIONS(5482),
    [anon_sym_PIPE_PIPE] = ACTIONS(5482),
    [anon_sym_QMARK_QMARK] = ACTIONS(5482),
    [anon_sym_on] = ACTIONS(5482),
    [anon_sym_equals] = ACTIONS(5482),
    [anon_sym_by] = ACTIONS(5482),
    [anon_sym_as] = ACTIONS(5482),
    [anon_sym_is] = ACTIONS(5482),
    [anon_sym_DASH_GT] = ACTIONS(5482),
    [anon_sym_with] = ACTIONS(5482),
    [aux_sym_preproc_if_token3] = ACTIONS(5482),
    [aux_sym_preproc_else_token1] = ACTIONS(5482),
    [aux_sym_preproc_elif_token1] = ACTIONS(5482),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4178] = {
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7116),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9452),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4178),
    [sym_preproc_endregion] = STATE(4178),
    [sym_preproc_line] = STATE(4178),
    [sym_preproc_pragma] = STATE(4178),
    [sym_preproc_nullable] = STATE(4178),
    [sym_preproc_error] = STATE(4178),
    [sym_preproc_define] = STATE(4178),
    [sym_preproc_undef] = STATE(4178),
    [aux_sym_lambda_expression_repeat1] = STATE(6864),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(5890),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4179] = {
    [sym_preproc_region] = STATE(4179),
    [sym_preproc_endregion] = STATE(4179),
    [sym_preproc_line] = STATE(4179),
    [sym_preproc_pragma] = STATE(4179),
    [sym_preproc_nullable] = STATE(4179),
    [sym_preproc_error] = STATE(4179),
    [sym_preproc_define] = STATE(4179),
    [sym_preproc_undef] = STATE(4179),
    [anon_sym_SEMI] = ACTIONS(5404),
    [anon_sym_LBRACK] = ACTIONS(5404),
    [anon_sym_COLON] = ACTIONS(5404),
    [anon_sym_COMMA] = ACTIONS(5404),
    [anon_sym_RBRACK] = ACTIONS(5404),
    [anon_sym_LPAREN] = ACTIONS(5404),
    [anon_sym_RPAREN] = ACTIONS(5404),
    [anon_sym_RBRACE] = ACTIONS(5404),
    [anon_sym_LT] = ACTIONS(5406),
    [anon_sym_GT] = ACTIONS(5406),
    [anon_sym_in] = ACTIONS(5404),
    [anon_sym_QMARK] = ACTIONS(5406),
    [anon_sym_BANG] = ACTIONS(5406),
    [anon_sym_PLUS_PLUS] = ACTIONS(5404),
    [anon_sym_DASH_DASH] = ACTIONS(5404),
    [anon_sym_PLUS] = ACTIONS(5406),
    [anon_sym_DASH] = ACTIONS(5406),
    [anon_sym_STAR] = ACTIONS(5404),
    [anon_sym_SLASH] = ACTIONS(5406),
    [anon_sym_PERCENT] = ACTIONS(5404),
    [anon_sym_CARET] = ACTIONS(5404),
    [anon_sym_PIPE] = ACTIONS(5406),
    [anon_sym_AMP] = ACTIONS(5406),
    [anon_sym_LT_LT] = ACTIONS(5404),
    [anon_sym_GT_GT] = ACTIONS(5406),
    [anon_sym_GT_GT_GT] = ACTIONS(5404),
    [anon_sym_EQ_EQ] = ACTIONS(5404),
    [anon_sym_BANG_EQ] = ACTIONS(5404),
    [anon_sym_GT_EQ] = ACTIONS(5404),
    [anon_sym_LT_EQ] = ACTIONS(5404),
    [anon_sym_DOT] = ACTIONS(5406),
    [anon_sym_EQ_GT] = ACTIONS(5404),
    [anon_sym_switch] = ACTIONS(5404),
    [anon_sym_when] = ACTIONS(5404),
    [anon_sym_DOT_DOT] = ACTIONS(5404),
    [anon_sym_and] = ACTIONS(5404),
    [anon_sym_or] = ACTIONS(5404),
    [anon_sym_AMP_AMP] = ACTIONS(5404),
    [anon_sym_PIPE_PIPE] = ACTIONS(5404),
    [anon_sym_QMARK_QMARK] = ACTIONS(5404),
    [anon_sym_on] = ACTIONS(5404),
    [anon_sym_equals] = ACTIONS(5404),
    [anon_sym_by] = ACTIONS(5404),
    [anon_sym_as] = ACTIONS(5404),
    [anon_sym_is] = ACTIONS(5404),
    [anon_sym_DASH_GT] = ACTIONS(5404),
    [anon_sym_with] = ACTIONS(5404),
    [aux_sym_preproc_if_token3] = ACTIONS(5404),
    [aux_sym_preproc_else_token1] = ACTIONS(5404),
    [aux_sym_preproc_elif_token1] = ACTIONS(5404),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4180] = {
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7117),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9182),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4180),
    [sym_preproc_endregion] = STATE(4180),
    [sym_preproc_line] = STATE(4180),
    [sym_preproc_pragma] = STATE(4180),
    [sym_preproc_nullable] = STATE(4180),
    [sym_preproc_error] = STATE(4180),
    [sym_preproc_define] = STATE(4180),
    [sym_preproc_undef] = STATE(4180),
    [aux_sym_lambda_expression_repeat1] = STATE(6864),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(5890),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4181] = {
    [sym_preproc_region] = STATE(4181),
    [sym_preproc_endregion] = STATE(4181),
    [sym_preproc_line] = STATE(4181),
    [sym_preproc_pragma] = STATE(4181),
    [sym_preproc_nullable] = STATE(4181),
    [sym_preproc_error] = STATE(4181),
    [sym_preproc_define] = STATE(4181),
    [sym_preproc_undef] = STATE(4181),
    [anon_sym_EQ] = ACTIONS(5929),
    [anon_sym_LBRACK] = ACTIONS(5249),
    [anon_sym_LPAREN] = ACTIONS(5249),
    [anon_sym_LT] = ACTIONS(5251),
    [anon_sym_GT] = ACTIONS(5251),
    [anon_sym_QMARK] = ACTIONS(5251),
    [anon_sym_BANG] = ACTIONS(5251),
    [anon_sym_PLUS_PLUS] = ACTIONS(5249),
    [anon_sym_DASH_DASH] = ACTIONS(5249),
    [anon_sym_PLUS] = ACTIONS(5251),
    [anon_sym_DASH] = ACTIONS(5251),
    [anon_sym_STAR] = ACTIONS(5251),
    [anon_sym_SLASH] = ACTIONS(5251),
    [anon_sym_PERCENT] = ACTIONS(5251),
    [anon_sym_CARET] = ACTIONS(5251),
    [anon_sym_PIPE] = ACTIONS(5251),
    [anon_sym_AMP] = ACTIONS(5251),
    [anon_sym_LT_LT] = ACTIONS(5251),
    [anon_sym_GT_GT] = ACTIONS(5251),
    [anon_sym_GT_GT_GT] = ACTIONS(5251),
    [anon_sym_EQ_EQ] = ACTIONS(5249),
    [anon_sym_BANG_EQ] = ACTIONS(5249),
    [anon_sym_GT_EQ] = ACTIONS(5249),
    [anon_sym_LT_EQ] = ACTIONS(5249),
    [anon_sym_DOT] = ACTIONS(5251),
    [anon_sym_EQ_GT] = ACTIONS(5249),
    [anon_sym_switch] = ACTIONS(5249),
    [anon_sym_DOT_DOT] = ACTIONS(5249),
    [anon_sym_and] = ACTIONS(5249),
    [anon_sym_or] = ACTIONS(5249),
    [anon_sym_PLUS_EQ] = ACTIONS(5931),
    [anon_sym_DASH_EQ] = ACTIONS(5931),
    [anon_sym_STAR_EQ] = ACTIONS(5931),
    [anon_sym_SLASH_EQ] = ACTIONS(5931),
    [anon_sym_PERCENT_EQ] = ACTIONS(5931),
    [anon_sym_AMP_EQ] = ACTIONS(5931),
    [anon_sym_CARET_EQ] = ACTIONS(5931),
    [anon_sym_PIPE_EQ] = ACTIONS(5931),
    [anon_sym_LT_LT_EQ] = ACTIONS(5931),
    [anon_sym_GT_GT_EQ] = ACTIONS(5931),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5931),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(5931),
    [anon_sym_AMP_AMP] = ACTIONS(5249),
    [anon_sym_PIPE_PIPE] = ACTIONS(5249),
    [anon_sym_QMARK_QMARK] = ACTIONS(5251),
    [anon_sym_into] = ACTIONS(5249),
    [anon_sym_as] = ACTIONS(5249),
    [anon_sym_is] = ACTIONS(5249),
    [anon_sym_DASH_GT] = ACTIONS(5249),
    [anon_sym_with] = ACTIONS(5249),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4182] = {
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9801),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4182),
    [sym_preproc_endregion] = STATE(4182),
    [sym_preproc_line] = STATE(4182),
    [sym_preproc_pragma] = STATE(4182),
    [sym_preproc_nullable] = STATE(4182),
    [sym_preproc_error] = STATE(4182),
    [sym_preproc_define] = STATE(4182),
    [sym_preproc_undef] = STATE(4182),
    [aux_sym_lambda_expression_repeat1] = STATE(6864),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(5892),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4183] = {
    [sym__name] = STATE(7759),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(9498),
    [sym_implicit_type] = STATE(8901),
    [sym_array_type] = STATE(8236),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(8217),
    [sym_pointer_type] = STATE(8217),
    [sym__pointer_base_type] = STATE(9650),
    [sym_function_pointer_type] = STATE(8217),
    [sym_function_pointer_parameter] = STATE(9350),
    [sym_ref_type] = STATE(8704),
    [sym__ref_base_type] = STATE(9351),
    [sym_scoped_type] = STATE(8704),
    [sym_tuple_type] = STATE(8136),
    [sym_identifier] = STATE(4921),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4183),
    [sym_preproc_endregion] = STATE(4183),
    [sym_preproc_line] = STATE(4183),
    [sym_preproc_pragma] = STATE(4183),
    [sym_preproc_nullable] = STATE(4183),
    [sym_preproc_error] = STATE(4183),
    [sym_preproc_define] = STATE(4183),
    [sym_preproc_undef] = STATE(4183),
    [aux_sym_function_pointer_type_repeat1] = STATE(4464),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_LPAREN] = ACTIONS(2995),
    [anon_sym_ref] = ACTIONS(5882),
    [anon_sym_delegate] = ACTIONS(5659),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_in] = ACTIONS(5884),
    [anon_sym_out] = ACTIONS(5884),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(5886),
    [anon_sym_var] = ACTIONS(5284),
    [sym_predefined_type] = ACTIONS(5888),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4184] = {
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7004),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9137),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4184),
    [sym_preproc_endregion] = STATE(4184),
    [sym_preproc_line] = STATE(4184),
    [sym_preproc_pragma] = STATE(4184),
    [sym_preproc_nullable] = STATE(4184),
    [sym_preproc_error] = STATE(4184),
    [sym_preproc_define] = STATE(4184),
    [sym_preproc_undef] = STATE(4184),
    [aux_sym_lambda_expression_repeat1] = STATE(6864),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4185] = {
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(6929),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9892),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4185),
    [sym_preproc_endregion] = STATE(4185),
    [sym_preproc_line] = STATE(4185),
    [sym_preproc_pragma] = STATE(4185),
    [sym_preproc_nullable] = STATE(4185),
    [sym_preproc_error] = STATE(4185),
    [sym_preproc_define] = STATE(4185),
    [sym_preproc_undef] = STATE(4185),
    [aux_sym_lambda_expression_repeat1] = STATE(6864),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4186] = {
    [sym_preproc_region] = STATE(4186),
    [sym_preproc_endregion] = STATE(4186),
    [sym_preproc_line] = STATE(4186),
    [sym_preproc_pragma] = STATE(4186),
    [sym_preproc_nullable] = STATE(4186),
    [sym_preproc_error] = STATE(4186),
    [sym_preproc_define] = STATE(4186),
    [sym_preproc_undef] = STATE(4186),
    [anon_sym_SEMI] = ACTIONS(5412),
    [anon_sym_LBRACK] = ACTIONS(5412),
    [anon_sym_COLON] = ACTIONS(5412),
    [anon_sym_COMMA] = ACTIONS(5412),
    [anon_sym_RBRACK] = ACTIONS(5412),
    [anon_sym_LPAREN] = ACTIONS(5412),
    [anon_sym_RPAREN] = ACTIONS(5412),
    [anon_sym_RBRACE] = ACTIONS(5412),
    [anon_sym_LT] = ACTIONS(5414),
    [anon_sym_GT] = ACTIONS(5414),
    [anon_sym_in] = ACTIONS(5412),
    [anon_sym_QMARK] = ACTIONS(5414),
    [anon_sym_BANG] = ACTIONS(5414),
    [anon_sym_PLUS_PLUS] = ACTIONS(5412),
    [anon_sym_DASH_DASH] = ACTIONS(5412),
    [anon_sym_PLUS] = ACTIONS(5414),
    [anon_sym_DASH] = ACTIONS(5414),
    [anon_sym_STAR] = ACTIONS(5412),
    [anon_sym_SLASH] = ACTIONS(5414),
    [anon_sym_PERCENT] = ACTIONS(5412),
    [anon_sym_CARET] = ACTIONS(5412),
    [anon_sym_PIPE] = ACTIONS(5414),
    [anon_sym_AMP] = ACTIONS(5414),
    [anon_sym_LT_LT] = ACTIONS(5412),
    [anon_sym_GT_GT] = ACTIONS(5414),
    [anon_sym_GT_GT_GT] = ACTIONS(5412),
    [anon_sym_EQ_EQ] = ACTIONS(5412),
    [anon_sym_BANG_EQ] = ACTIONS(5412),
    [anon_sym_GT_EQ] = ACTIONS(5412),
    [anon_sym_LT_EQ] = ACTIONS(5412),
    [anon_sym_DOT] = ACTIONS(5414),
    [anon_sym_EQ_GT] = ACTIONS(5412),
    [anon_sym_switch] = ACTIONS(5412),
    [anon_sym_when] = ACTIONS(5412),
    [anon_sym_DOT_DOT] = ACTIONS(5412),
    [anon_sym_and] = ACTIONS(5412),
    [anon_sym_or] = ACTIONS(5412),
    [anon_sym_AMP_AMP] = ACTIONS(5412),
    [anon_sym_PIPE_PIPE] = ACTIONS(5412),
    [anon_sym_QMARK_QMARK] = ACTIONS(5412),
    [anon_sym_on] = ACTIONS(5412),
    [anon_sym_equals] = ACTIONS(5412),
    [anon_sym_by] = ACTIONS(5412),
    [anon_sym_as] = ACTIONS(5412),
    [anon_sym_is] = ACTIONS(5412),
    [anon_sym_DASH_GT] = ACTIONS(5412),
    [anon_sym_with] = ACTIONS(5412),
    [aux_sym_preproc_if_token3] = ACTIONS(5412),
    [aux_sym_preproc_else_token1] = ACTIONS(5412),
    [aux_sym_preproc_elif_token1] = ACTIONS(5412),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4187] = {
    [sym__name] = STATE(7759),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(9026),
    [sym_implicit_type] = STATE(8901),
    [sym_array_type] = STATE(8236),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(8217),
    [sym_pointer_type] = STATE(8217),
    [sym__pointer_base_type] = STATE(9650),
    [sym_function_pointer_type] = STATE(8217),
    [sym_function_pointer_parameter] = STATE(9350),
    [sym_ref_type] = STATE(8704),
    [sym__ref_base_type] = STATE(9351),
    [sym_scoped_type] = STATE(8704),
    [sym_tuple_type] = STATE(8136),
    [sym_identifier] = STATE(4921),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4187),
    [sym_preproc_endregion] = STATE(4187),
    [sym_preproc_line] = STATE(4187),
    [sym_preproc_pragma] = STATE(4187),
    [sym_preproc_nullable] = STATE(4187),
    [sym_preproc_error] = STATE(4187),
    [sym_preproc_define] = STATE(4187),
    [sym_preproc_undef] = STATE(4187),
    [aux_sym_function_pointer_type_repeat1] = STATE(4076),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_LPAREN] = ACTIONS(2995),
    [anon_sym_ref] = ACTIONS(5882),
    [anon_sym_delegate] = ACTIONS(5659),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_in] = ACTIONS(5884),
    [anon_sym_out] = ACTIONS(5884),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(5886),
    [anon_sym_var] = ACTIONS(5284),
    [sym_predefined_type] = ACTIONS(5888),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4188] = {
    [sym_preproc_region] = STATE(4188),
    [sym_preproc_endregion] = STATE(4188),
    [sym_preproc_line] = STATE(4188),
    [sym_preproc_pragma] = STATE(4188),
    [sym_preproc_nullable] = STATE(4188),
    [sym_preproc_error] = STATE(4188),
    [sym_preproc_define] = STATE(4188),
    [sym_preproc_undef] = STATE(4188),
    [anon_sym_SEMI] = ACTIONS(5420),
    [anon_sym_LBRACK] = ACTIONS(5420),
    [anon_sym_COLON] = ACTIONS(5420),
    [anon_sym_COMMA] = ACTIONS(5420),
    [anon_sym_RBRACK] = ACTIONS(5420),
    [anon_sym_LPAREN] = ACTIONS(5420),
    [anon_sym_RPAREN] = ACTIONS(5420),
    [anon_sym_RBRACE] = ACTIONS(5420),
    [anon_sym_LT] = ACTIONS(5422),
    [anon_sym_GT] = ACTIONS(5422),
    [anon_sym_in] = ACTIONS(5420),
    [anon_sym_QMARK] = ACTIONS(5422),
    [anon_sym_BANG] = ACTIONS(5422),
    [anon_sym_PLUS_PLUS] = ACTIONS(5420),
    [anon_sym_DASH_DASH] = ACTIONS(5420),
    [anon_sym_PLUS] = ACTIONS(5422),
    [anon_sym_DASH] = ACTIONS(5422),
    [anon_sym_STAR] = ACTIONS(5420),
    [anon_sym_SLASH] = ACTIONS(5422),
    [anon_sym_PERCENT] = ACTIONS(5420),
    [anon_sym_CARET] = ACTIONS(5420),
    [anon_sym_PIPE] = ACTIONS(5422),
    [anon_sym_AMP] = ACTIONS(5422),
    [anon_sym_LT_LT] = ACTIONS(5420),
    [anon_sym_GT_GT] = ACTIONS(5422),
    [anon_sym_GT_GT_GT] = ACTIONS(5420),
    [anon_sym_EQ_EQ] = ACTIONS(5420),
    [anon_sym_BANG_EQ] = ACTIONS(5420),
    [anon_sym_GT_EQ] = ACTIONS(5420),
    [anon_sym_LT_EQ] = ACTIONS(5420),
    [anon_sym_DOT] = ACTIONS(5422),
    [anon_sym_EQ_GT] = ACTIONS(5420),
    [anon_sym_switch] = ACTIONS(5420),
    [anon_sym_when] = ACTIONS(5420),
    [anon_sym_DOT_DOT] = ACTIONS(5420),
    [anon_sym_and] = ACTIONS(5420),
    [anon_sym_or] = ACTIONS(5420),
    [anon_sym_AMP_AMP] = ACTIONS(5420),
    [anon_sym_PIPE_PIPE] = ACTIONS(5420),
    [anon_sym_QMARK_QMARK] = ACTIONS(5420),
    [anon_sym_on] = ACTIONS(5420),
    [anon_sym_equals] = ACTIONS(5420),
    [anon_sym_by] = ACTIONS(5420),
    [anon_sym_as] = ACTIONS(5420),
    [anon_sym_is] = ACTIONS(5420),
    [anon_sym_DASH_GT] = ACTIONS(5420),
    [anon_sym_with] = ACTIONS(5420),
    [aux_sym_preproc_if_token3] = ACTIONS(5420),
    [aux_sym_preproc_else_token1] = ACTIONS(5420),
    [aux_sym_preproc_elif_token1] = ACTIONS(5420),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4189] = {
    [sym_preproc_region] = STATE(4189),
    [sym_preproc_endregion] = STATE(4189),
    [sym_preproc_line] = STATE(4189),
    [sym_preproc_pragma] = STATE(4189),
    [sym_preproc_nullable] = STATE(4189),
    [sym_preproc_error] = STATE(4189),
    [sym_preproc_define] = STATE(4189),
    [sym_preproc_undef] = STATE(4189),
    [anon_sym_EQ] = ACTIONS(5933),
    [anon_sym_LBRACK] = ACTIONS(5249),
    [anon_sym_LPAREN] = ACTIONS(5249),
    [anon_sym_LT] = ACTIONS(5251),
    [anon_sym_GT] = ACTIONS(5251),
    [anon_sym_QMARK] = ACTIONS(5251),
    [anon_sym_BANG] = ACTIONS(5251),
    [anon_sym_PLUS_PLUS] = ACTIONS(5249),
    [anon_sym_DASH_DASH] = ACTIONS(5249),
    [anon_sym_PLUS] = ACTIONS(5251),
    [anon_sym_DASH] = ACTIONS(5251),
    [anon_sym_STAR] = ACTIONS(5251),
    [anon_sym_SLASH] = ACTIONS(5251),
    [anon_sym_PERCENT] = ACTIONS(5251),
    [anon_sym_CARET] = ACTIONS(5251),
    [anon_sym_PIPE] = ACTIONS(5251),
    [anon_sym_AMP] = ACTIONS(5251),
    [anon_sym_LT_LT] = ACTIONS(5251),
    [anon_sym_GT_GT] = ACTIONS(5251),
    [anon_sym_GT_GT_GT] = ACTIONS(5251),
    [anon_sym_EQ_EQ] = ACTIONS(5249),
    [anon_sym_BANG_EQ] = ACTIONS(5249),
    [anon_sym_GT_EQ] = ACTIONS(5249),
    [anon_sym_LT_EQ] = ACTIONS(5249),
    [anon_sym_DOT] = ACTIONS(5251),
    [anon_sym_EQ_GT] = ACTIONS(5249),
    [anon_sym_switch] = ACTIONS(5249),
    [anon_sym_when] = ACTIONS(5249),
    [anon_sym_DOT_DOT] = ACTIONS(5249),
    [anon_sym_and] = ACTIONS(5249),
    [anon_sym_or] = ACTIONS(5249),
    [anon_sym_PLUS_EQ] = ACTIONS(5935),
    [anon_sym_DASH_EQ] = ACTIONS(5935),
    [anon_sym_STAR_EQ] = ACTIONS(5935),
    [anon_sym_SLASH_EQ] = ACTIONS(5935),
    [anon_sym_PERCENT_EQ] = ACTIONS(5935),
    [anon_sym_AMP_EQ] = ACTIONS(5935),
    [anon_sym_CARET_EQ] = ACTIONS(5935),
    [anon_sym_PIPE_EQ] = ACTIONS(5935),
    [anon_sym_LT_LT_EQ] = ACTIONS(5935),
    [anon_sym_GT_GT_EQ] = ACTIONS(5935),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5935),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(5935),
    [anon_sym_AMP_AMP] = ACTIONS(5249),
    [anon_sym_PIPE_PIPE] = ACTIONS(5249),
    [anon_sym_QMARK_QMARK] = ACTIONS(5251),
    [anon_sym_as] = ACTIONS(5249),
    [anon_sym_is] = ACTIONS(5249),
    [anon_sym_DASH_GT] = ACTIONS(5249),
    [anon_sym_with] = ACTIONS(5249),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4190] = {
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(6932),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9507),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4190),
    [sym_preproc_endregion] = STATE(4190),
    [sym_preproc_line] = STATE(4190),
    [sym_preproc_pragma] = STATE(4190),
    [sym_preproc_nullable] = STATE(4190),
    [sym_preproc_error] = STATE(4190),
    [sym_preproc_define] = STATE(4190),
    [sym_preproc_undef] = STATE(4190),
    [aux_sym_lambda_expression_repeat1] = STATE(6864),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4191] = {
    [sym__name] = STATE(7759),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(9501),
    [sym_implicit_type] = STATE(8901),
    [sym_array_type] = STATE(8236),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(8217),
    [sym_pointer_type] = STATE(8217),
    [sym__pointer_base_type] = STATE(9650),
    [sym_function_pointer_type] = STATE(8217),
    [sym_function_pointer_parameter] = STATE(9350),
    [sym_ref_type] = STATE(8704),
    [sym__ref_base_type] = STATE(9351),
    [sym_scoped_type] = STATE(8704),
    [sym_tuple_type] = STATE(8136),
    [sym_identifier] = STATE(4921),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4191),
    [sym_preproc_endregion] = STATE(4191),
    [sym_preproc_line] = STATE(4191),
    [sym_preproc_pragma] = STATE(4191),
    [sym_preproc_nullable] = STATE(4191),
    [sym_preproc_error] = STATE(4191),
    [sym_preproc_define] = STATE(4191),
    [sym_preproc_undef] = STATE(4191),
    [aux_sym_function_pointer_type_repeat1] = STATE(4183),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_LPAREN] = ACTIONS(2995),
    [anon_sym_ref] = ACTIONS(5882),
    [anon_sym_delegate] = ACTIONS(5659),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_in] = ACTIONS(5884),
    [anon_sym_out] = ACTIONS(5884),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(5886),
    [anon_sym_var] = ACTIONS(5284),
    [sym_predefined_type] = ACTIONS(5888),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4192] = {
    [sym__name] = STATE(7759),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(9501),
    [sym_implicit_type] = STATE(8901),
    [sym_array_type] = STATE(8236),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(8217),
    [sym_pointer_type] = STATE(8217),
    [sym__pointer_base_type] = STATE(9650),
    [sym_function_pointer_type] = STATE(8217),
    [sym_function_pointer_parameter] = STATE(9350),
    [sym_ref_type] = STATE(8704),
    [sym__ref_base_type] = STATE(9351),
    [sym_scoped_type] = STATE(8704),
    [sym_tuple_type] = STATE(8136),
    [sym_identifier] = STATE(4921),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4192),
    [sym_preproc_endregion] = STATE(4192),
    [sym_preproc_line] = STATE(4192),
    [sym_preproc_pragma] = STATE(4192),
    [sym_preproc_nullable] = STATE(4192),
    [sym_preproc_error] = STATE(4192),
    [sym_preproc_define] = STATE(4192),
    [sym_preproc_undef] = STATE(4192),
    [aux_sym_function_pointer_type_repeat1] = STATE(4464),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_LPAREN] = ACTIONS(2995),
    [anon_sym_ref] = ACTIONS(5882),
    [anon_sym_delegate] = ACTIONS(5659),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_in] = ACTIONS(5884),
    [anon_sym_out] = ACTIONS(5884),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(5886),
    [anon_sym_var] = ACTIONS(5284),
    [sym_predefined_type] = ACTIONS(5888),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4193] = {
    [sym_preproc_region] = STATE(4193),
    [sym_preproc_endregion] = STATE(4193),
    [sym_preproc_line] = STATE(4193),
    [sym_preproc_pragma] = STATE(4193),
    [sym_preproc_nullable] = STATE(4193),
    [sym_preproc_error] = STATE(4193),
    [sym_preproc_define] = STATE(4193),
    [sym_preproc_undef] = STATE(4193),
    [anon_sym_SEMI] = ACTIONS(5854),
    [anon_sym_LBRACK] = ACTIONS(5854),
    [anon_sym_COLON] = ACTIONS(5854),
    [anon_sym_COMMA] = ACTIONS(5854),
    [anon_sym_RBRACK] = ACTIONS(5854),
    [anon_sym_LPAREN] = ACTIONS(5854),
    [anon_sym_RPAREN] = ACTIONS(5854),
    [anon_sym_RBRACE] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5856),
    [anon_sym_GT] = ACTIONS(5856),
    [anon_sym_in] = ACTIONS(5854),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_BANG] = ACTIONS(5856),
    [anon_sym_PLUS_PLUS] = ACTIONS(5854),
    [anon_sym_DASH_DASH] = ACTIONS(5854),
    [anon_sym_PLUS] = ACTIONS(5856),
    [anon_sym_DASH] = ACTIONS(5856),
    [anon_sym_STAR] = ACTIONS(5854),
    [anon_sym_SLASH] = ACTIONS(5856),
    [anon_sym_PERCENT] = ACTIONS(5854),
    [anon_sym_CARET] = ACTIONS(5854),
    [anon_sym_PIPE] = ACTIONS(5856),
    [anon_sym_AMP] = ACTIONS(5856),
    [anon_sym_LT_LT] = ACTIONS(5854),
    [anon_sym_GT_GT] = ACTIONS(5856),
    [anon_sym_GT_GT_GT] = ACTIONS(5854),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5854),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_DOT] = ACTIONS(5856),
    [anon_sym_EQ_GT] = ACTIONS(5854),
    [anon_sym_switch] = ACTIONS(5854),
    [anon_sym_when] = ACTIONS(5854),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_and] = ACTIONS(5854),
    [anon_sym_or] = ACTIONS(5854),
    [anon_sym_AMP_AMP] = ACTIONS(5854),
    [anon_sym_PIPE_PIPE] = ACTIONS(5854),
    [anon_sym_QMARK_QMARK] = ACTIONS(5854),
    [anon_sym_on] = ACTIONS(5854),
    [anon_sym_equals] = ACTIONS(5854),
    [anon_sym_by] = ACTIONS(5854),
    [anon_sym_as] = ACTIONS(5854),
    [anon_sym_is] = ACTIONS(5854),
    [anon_sym_DASH_GT] = ACTIONS(5854),
    [anon_sym_with] = ACTIONS(5854),
    [aux_sym_preproc_if_token3] = ACTIONS(5854),
    [aux_sym_preproc_else_token1] = ACTIONS(5854),
    [aux_sym_preproc_elif_token1] = ACTIONS(5854),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4194] = {
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7018),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(8989),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4194),
    [sym_preproc_endregion] = STATE(4194),
    [sym_preproc_line] = STATE(4194),
    [sym_preproc_pragma] = STATE(4194),
    [sym_preproc_nullable] = STATE(4194),
    [sym_preproc_error] = STATE(4194),
    [sym_preproc_define] = STATE(4194),
    [sym_preproc_undef] = STATE(4194),
    [aux_sym_lambda_expression_repeat1] = STATE(6864),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(5896),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4195] = {
    [sym__name] = STATE(7759),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(9512),
    [sym_implicit_type] = STATE(8901),
    [sym_array_type] = STATE(8236),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(8217),
    [sym_pointer_type] = STATE(8217),
    [sym__pointer_base_type] = STATE(9650),
    [sym_function_pointer_type] = STATE(8217),
    [sym_function_pointer_parameter] = STATE(9350),
    [sym_ref_type] = STATE(8704),
    [sym__ref_base_type] = STATE(9351),
    [sym_scoped_type] = STATE(8704),
    [sym_tuple_type] = STATE(8136),
    [sym_identifier] = STATE(4921),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4195),
    [sym_preproc_endregion] = STATE(4195),
    [sym_preproc_line] = STATE(4195),
    [sym_preproc_pragma] = STATE(4195),
    [sym_preproc_nullable] = STATE(4195),
    [sym_preproc_error] = STATE(4195),
    [sym_preproc_define] = STATE(4195),
    [sym_preproc_undef] = STATE(4195),
    [aux_sym_function_pointer_type_repeat1] = STATE(4192),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_LPAREN] = ACTIONS(2995),
    [anon_sym_ref] = ACTIONS(5882),
    [anon_sym_delegate] = ACTIONS(5659),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_in] = ACTIONS(5884),
    [anon_sym_out] = ACTIONS(5884),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(5886),
    [anon_sym_var] = ACTIONS(5284),
    [sym_predefined_type] = ACTIONS(5888),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4196] = {
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(6921),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(8999),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4196),
    [sym_preproc_endregion] = STATE(4196),
    [sym_preproc_line] = STATE(4196),
    [sym_preproc_pragma] = STATE(4196),
    [sym_preproc_nullable] = STATE(4196),
    [sym_preproc_error] = STATE(4196),
    [sym_preproc_define] = STATE(4196),
    [sym_preproc_undef] = STATE(4196),
    [aux_sym_lambda_expression_repeat1] = STATE(6864),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4197] = {
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7121),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9179),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4197),
    [sym_preproc_endregion] = STATE(4197),
    [sym_preproc_line] = STATE(4197),
    [sym_preproc_pragma] = STATE(4197),
    [sym_preproc_nullable] = STATE(4197),
    [sym_preproc_error] = STATE(4197),
    [sym_preproc_define] = STATE(4197),
    [sym_preproc_undef] = STATE(4197),
    [aux_sym_lambda_expression_repeat1] = STATE(6864),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4198] = {
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7056),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9514),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4198),
    [sym_preproc_endregion] = STATE(4198),
    [sym_preproc_line] = STATE(4198),
    [sym_preproc_pragma] = STATE(4198),
    [sym_preproc_nullable] = STATE(4198),
    [sym_preproc_error] = STATE(4198),
    [sym_preproc_define] = STATE(4198),
    [sym_preproc_undef] = STATE(4198),
    [aux_sym_lambda_expression_repeat1] = STATE(6864),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4199] = {
    [sym_preproc_region] = STATE(4199),
    [sym_preproc_endregion] = STATE(4199),
    [sym_preproc_line] = STATE(4199),
    [sym_preproc_pragma] = STATE(4199),
    [sym_preproc_nullable] = STATE(4199),
    [sym_preproc_error] = STATE(4199),
    [sym_preproc_define] = STATE(4199),
    [sym_preproc_undef] = STATE(4199),
    [anon_sym_SEMI] = ACTIONS(5506),
    [anon_sym_LBRACK] = ACTIONS(5506),
    [anon_sym_COLON] = ACTIONS(5506),
    [anon_sym_COMMA] = ACTIONS(5506),
    [anon_sym_RBRACK] = ACTIONS(5506),
    [anon_sym_LPAREN] = ACTIONS(5506),
    [anon_sym_RPAREN] = ACTIONS(5506),
    [anon_sym_RBRACE] = ACTIONS(5506),
    [anon_sym_LT] = ACTIONS(5508),
    [anon_sym_GT] = ACTIONS(5508),
    [anon_sym_in] = ACTIONS(5506),
    [anon_sym_QMARK] = ACTIONS(5508),
    [anon_sym_BANG] = ACTIONS(5508),
    [anon_sym_PLUS_PLUS] = ACTIONS(5506),
    [anon_sym_DASH_DASH] = ACTIONS(5506),
    [anon_sym_PLUS] = ACTIONS(5508),
    [anon_sym_DASH] = ACTIONS(5508),
    [anon_sym_STAR] = ACTIONS(5506),
    [anon_sym_SLASH] = ACTIONS(5508),
    [anon_sym_PERCENT] = ACTIONS(5506),
    [anon_sym_CARET] = ACTIONS(5506),
    [anon_sym_PIPE] = ACTIONS(5508),
    [anon_sym_AMP] = ACTIONS(5508),
    [anon_sym_LT_LT] = ACTIONS(5506),
    [anon_sym_GT_GT] = ACTIONS(5508),
    [anon_sym_GT_GT_GT] = ACTIONS(5506),
    [anon_sym_EQ_EQ] = ACTIONS(5506),
    [anon_sym_BANG_EQ] = ACTIONS(5506),
    [anon_sym_GT_EQ] = ACTIONS(5506),
    [anon_sym_LT_EQ] = ACTIONS(5506),
    [anon_sym_DOT] = ACTIONS(5508),
    [anon_sym_EQ_GT] = ACTIONS(5506),
    [anon_sym_switch] = ACTIONS(5506),
    [anon_sym_when] = ACTIONS(5506),
    [anon_sym_DOT_DOT] = ACTIONS(5506),
    [anon_sym_and] = ACTIONS(5506),
    [anon_sym_or] = ACTIONS(5506),
    [anon_sym_AMP_AMP] = ACTIONS(5506),
    [anon_sym_PIPE_PIPE] = ACTIONS(5506),
    [anon_sym_QMARK_QMARK] = ACTIONS(5506),
    [anon_sym_on] = ACTIONS(5506),
    [anon_sym_equals] = ACTIONS(5506),
    [anon_sym_by] = ACTIONS(5506),
    [anon_sym_as] = ACTIONS(5506),
    [anon_sym_is] = ACTIONS(5506),
    [anon_sym_DASH_GT] = ACTIONS(5506),
    [anon_sym_with] = ACTIONS(5506),
    [aux_sym_preproc_if_token3] = ACTIONS(5506),
    [aux_sym_preproc_else_token1] = ACTIONS(5506),
    [aux_sym_preproc_elif_token1] = ACTIONS(5506),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4200] = {
    [sym_preproc_region] = STATE(4200),
    [sym_preproc_endregion] = STATE(4200),
    [sym_preproc_line] = STATE(4200),
    [sym_preproc_pragma] = STATE(4200),
    [sym_preproc_nullable] = STATE(4200),
    [sym_preproc_error] = STATE(4200),
    [sym_preproc_define] = STATE(4200),
    [sym_preproc_undef] = STATE(4200),
    [sym__identifier_token] = ACTIONS(3976),
    [anon_sym_extern] = ACTIONS(3976),
    [anon_sym_alias] = ACTIONS(3976),
    [anon_sym_SEMI] = ACTIONS(3719),
    [anon_sym_global] = ACTIONS(3976),
    [anon_sym_unsafe] = ACTIONS(3976),
    [anon_sym_static] = ACTIONS(3976),
    [anon_sym_LBRACE] = ACTIONS(3719),
    [anon_sym_abstract] = ACTIONS(3976),
    [anon_sym_async] = ACTIONS(3976),
    [anon_sym_const] = ACTIONS(3976),
    [anon_sym_file] = ACTIONS(3976),
    [anon_sym_fixed] = ACTIONS(3976),
    [anon_sym_internal] = ACTIONS(3976),
    [anon_sym_new] = ACTIONS(3976),
    [anon_sym_override] = ACTIONS(3976),
    [anon_sym_partial] = ACTIONS(3976),
    [anon_sym_private] = ACTIONS(3976),
    [anon_sym_protected] = ACTIONS(3976),
    [anon_sym_public] = ACTIONS(3976),
    [anon_sym_readonly] = ACTIONS(3976),
    [anon_sym_required] = ACTIONS(3976),
    [anon_sym_sealed] = ACTIONS(3976),
    [anon_sym_virtual] = ACTIONS(3976),
    [anon_sym_volatile] = ACTIONS(3976),
    [anon_sym_where] = ACTIONS(3976),
    [anon_sym_notnull] = ACTIONS(3976),
    [anon_sym_unmanaged] = ACTIONS(3976),
    [anon_sym_get] = ACTIONS(3976),
    [anon_sym_set] = ACTIONS(3976),
    [anon_sym_add] = ACTIONS(3976),
    [anon_sym_remove] = ACTIONS(3976),
    [anon_sym_init] = ACTIONS(3976),
    [anon_sym_scoped] = ACTIONS(3976),
    [anon_sym_EQ_GT] = ACTIONS(3719),
    [anon_sym_var] = ACTIONS(3976),
    [anon_sym_yield] = ACTIONS(3976),
    [anon_sym_when] = ACTIONS(3976),
    [anon_sym_from] = ACTIONS(3976),
    [anon_sym_into] = ACTIONS(3976),
    [anon_sym_join] = ACTIONS(3976),
    [anon_sym_on] = ACTIONS(3976),
    [anon_sym_equals] = ACTIONS(3976),
    [anon_sym_let] = ACTIONS(3976),
    [anon_sym_orderby] = ACTIONS(3976),
    [anon_sym_ascending] = ACTIONS(3976),
    [anon_sym_descending] = ACTIONS(3976),
    [anon_sym_group] = ACTIONS(3976),
    [anon_sym_by] = ACTIONS(3976),
    [anon_sym_select] = ACTIONS(3976),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4201] = {
    [sym__name] = STATE(6160),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_ref_type] = STATE(2899),
    [sym__scoped_base_type] = STATE(2907),
    [sym_identifier] = STATE(5368),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_region] = STATE(4201),
    [sym_preproc_endregion] = STATE(4201),
    [sym_preproc_line] = STATE(4201),
    [sym_preproc_pragma] = STATE(4201),
    [sym_preproc_nullable] = STATE(4201),
    [sym_preproc_error] = STATE(4201),
    [sym_preproc_define] = STATE(4201),
    [sym_preproc_undef] = STATE(4201),
    [sym__identifier_token] = ACTIONS(3987),
    [anon_sym_alias] = ACTIONS(3991),
    [anon_sym_global] = ACTIONS(3991),
    [anon_sym_EQ] = ACTIONS(3721),
    [anon_sym_LBRACK] = ACTIONS(3719),
    [anon_sym_COMMA] = ACTIONS(3719),
    [anon_sym_LPAREN] = ACTIONS(3995),
    [anon_sym_RPAREN] = ACTIONS(3719),
    [anon_sym_ref] = ACTIONS(2603),
    [anon_sym_delegate] = ACTIONS(2603),
    [anon_sym_file] = ACTIONS(3991),
    [anon_sym_readonly] = ACTIONS(2603),
    [anon_sym_LT] = ACTIONS(3719),
    [anon_sym_in] = ACTIONS(2603),
    [anon_sym_out] = ACTIONS(2603),
    [anon_sym_where] = ACTIONS(3991),
    [anon_sym_QMARK] = ACTIONS(3719),
    [anon_sym_notnull] = ACTIONS(3991),
    [anon_sym_unmanaged] = ACTIONS(3991),
    [anon_sym_STAR] = ACTIONS(3719),
    [anon_sym_this] = ACTIONS(2603),
    [anon_sym_DOT] = ACTIONS(3719),
    [anon_sym_scoped] = ACTIONS(3991),
    [anon_sym_EQ_GT] = ACTIONS(3719),
    [anon_sym_COLON_COLON] = ACTIONS(3719),
    [anon_sym_var] = ACTIONS(3991),
    [sym_predefined_type] = ACTIONS(2603),
    [anon_sym_yield] = ACTIONS(3991),
    [anon_sym_when] = ACTIONS(3991),
    [anon_sym_from] = ACTIONS(3991),
    [anon_sym_into] = ACTIONS(3991),
    [anon_sym_join] = ACTIONS(3991),
    [anon_sym_on] = ACTIONS(3991),
    [anon_sym_equals] = ACTIONS(3991),
    [anon_sym_let] = ACTIONS(3991),
    [anon_sym_orderby] = ACTIONS(3991),
    [anon_sym_ascending] = ACTIONS(3991),
    [anon_sym_descending] = ACTIONS(3991),
    [anon_sym_group] = ACTIONS(3991),
    [anon_sym_by] = ACTIONS(3991),
    [anon_sym_select] = ACTIONS(3991),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4202] = {
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(6924),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9573),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4202),
    [sym_preproc_endregion] = STATE(4202),
    [sym_preproc_line] = STATE(4202),
    [sym_preproc_pragma] = STATE(4202),
    [sym_preproc_nullable] = STATE(4202),
    [sym_preproc_error] = STATE(4202),
    [sym_preproc_define] = STATE(4202),
    [sym_preproc_undef] = STATE(4202),
    [aux_sym_lambda_expression_repeat1] = STATE(6864),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(5908),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4203] = {
    [sym_preproc_region] = STATE(4203),
    [sym_preproc_endregion] = STATE(4203),
    [sym_preproc_line] = STATE(4203),
    [sym_preproc_pragma] = STATE(4203),
    [sym_preproc_nullable] = STATE(4203),
    [sym_preproc_error] = STATE(4203),
    [sym_preproc_define] = STATE(4203),
    [sym_preproc_undef] = STATE(4203),
    [anon_sym_SEMI] = ACTIONS(5329),
    [anon_sym_LBRACK] = ACTIONS(5329),
    [anon_sym_COLON] = ACTIONS(5329),
    [anon_sym_COMMA] = ACTIONS(5329),
    [anon_sym_RBRACK] = ACTIONS(5329),
    [anon_sym_LPAREN] = ACTIONS(5329),
    [anon_sym_RPAREN] = ACTIONS(5329),
    [anon_sym_RBRACE] = ACTIONS(5329),
    [anon_sym_LT] = ACTIONS(5331),
    [anon_sym_GT] = ACTIONS(5331),
    [anon_sym_in] = ACTIONS(5329),
    [anon_sym_QMARK] = ACTIONS(5331),
    [anon_sym_BANG] = ACTIONS(5331),
    [anon_sym_PLUS_PLUS] = ACTIONS(5329),
    [anon_sym_DASH_DASH] = ACTIONS(5329),
    [anon_sym_PLUS] = ACTIONS(5331),
    [anon_sym_DASH] = ACTIONS(5331),
    [anon_sym_STAR] = ACTIONS(5329),
    [anon_sym_SLASH] = ACTIONS(5331),
    [anon_sym_PERCENT] = ACTIONS(5329),
    [anon_sym_CARET] = ACTIONS(5329),
    [anon_sym_PIPE] = ACTIONS(5331),
    [anon_sym_AMP] = ACTIONS(5331),
    [anon_sym_LT_LT] = ACTIONS(5329),
    [anon_sym_GT_GT] = ACTIONS(5331),
    [anon_sym_GT_GT_GT] = ACTIONS(5329),
    [anon_sym_EQ_EQ] = ACTIONS(5329),
    [anon_sym_BANG_EQ] = ACTIONS(5329),
    [anon_sym_GT_EQ] = ACTIONS(5329),
    [anon_sym_LT_EQ] = ACTIONS(5329),
    [anon_sym_DOT] = ACTIONS(5331),
    [anon_sym_EQ_GT] = ACTIONS(5329),
    [anon_sym_switch] = ACTIONS(5329),
    [anon_sym_when] = ACTIONS(5329),
    [anon_sym_DOT_DOT] = ACTIONS(5329),
    [anon_sym_and] = ACTIONS(5329),
    [anon_sym_or] = ACTIONS(5329),
    [anon_sym_AMP_AMP] = ACTIONS(5329),
    [anon_sym_PIPE_PIPE] = ACTIONS(5329),
    [anon_sym_QMARK_QMARK] = ACTIONS(5329),
    [anon_sym_on] = ACTIONS(5329),
    [anon_sym_equals] = ACTIONS(5329),
    [anon_sym_by] = ACTIONS(5329),
    [anon_sym_as] = ACTIONS(5329),
    [anon_sym_is] = ACTIONS(5329),
    [anon_sym_DASH_GT] = ACTIONS(5329),
    [anon_sym_with] = ACTIONS(5329),
    [aux_sym_preproc_if_token3] = ACTIONS(5329),
    [aux_sym_preproc_else_token1] = ACTIONS(5329),
    [aux_sym_preproc_elif_token1] = ACTIONS(5329),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4204] = {
    [sym_preproc_region] = STATE(4204),
    [sym_preproc_endregion] = STATE(4204),
    [sym_preproc_line] = STATE(4204),
    [sym_preproc_pragma] = STATE(4204),
    [sym_preproc_nullable] = STATE(4204),
    [sym_preproc_error] = STATE(4204),
    [sym_preproc_define] = STATE(4204),
    [sym_preproc_undef] = STATE(4204),
    [anon_sym_SEMI] = ACTIONS(5518),
    [anon_sym_LBRACK] = ACTIONS(5518),
    [anon_sym_COLON] = ACTIONS(5518),
    [anon_sym_COMMA] = ACTIONS(5518),
    [anon_sym_RBRACK] = ACTIONS(5518),
    [anon_sym_LPAREN] = ACTIONS(5518),
    [anon_sym_RPAREN] = ACTIONS(5518),
    [anon_sym_RBRACE] = ACTIONS(5518),
    [anon_sym_LT] = ACTIONS(5520),
    [anon_sym_GT] = ACTIONS(5520),
    [anon_sym_in] = ACTIONS(5518),
    [anon_sym_QMARK] = ACTIONS(5520),
    [anon_sym_BANG] = ACTIONS(5520),
    [anon_sym_PLUS_PLUS] = ACTIONS(5518),
    [anon_sym_DASH_DASH] = ACTIONS(5518),
    [anon_sym_PLUS] = ACTIONS(5520),
    [anon_sym_DASH] = ACTIONS(5520),
    [anon_sym_STAR] = ACTIONS(5518),
    [anon_sym_SLASH] = ACTIONS(5520),
    [anon_sym_PERCENT] = ACTIONS(5518),
    [anon_sym_CARET] = ACTIONS(5518),
    [anon_sym_PIPE] = ACTIONS(5520),
    [anon_sym_AMP] = ACTIONS(5520),
    [anon_sym_LT_LT] = ACTIONS(5518),
    [anon_sym_GT_GT] = ACTIONS(5520),
    [anon_sym_GT_GT_GT] = ACTIONS(5518),
    [anon_sym_EQ_EQ] = ACTIONS(5518),
    [anon_sym_BANG_EQ] = ACTIONS(5518),
    [anon_sym_GT_EQ] = ACTIONS(5518),
    [anon_sym_LT_EQ] = ACTIONS(5518),
    [anon_sym_DOT] = ACTIONS(5520),
    [anon_sym_EQ_GT] = ACTIONS(5518),
    [anon_sym_switch] = ACTIONS(5518),
    [anon_sym_when] = ACTIONS(5518),
    [anon_sym_DOT_DOT] = ACTIONS(5518),
    [anon_sym_and] = ACTIONS(5518),
    [anon_sym_or] = ACTIONS(5518),
    [anon_sym_AMP_AMP] = ACTIONS(5518),
    [anon_sym_PIPE_PIPE] = ACTIONS(5518),
    [anon_sym_QMARK_QMARK] = ACTIONS(5518),
    [anon_sym_on] = ACTIONS(5518),
    [anon_sym_equals] = ACTIONS(5518),
    [anon_sym_by] = ACTIONS(5518),
    [anon_sym_as] = ACTIONS(5518),
    [anon_sym_is] = ACTIONS(5518),
    [anon_sym_DASH_GT] = ACTIONS(5518),
    [anon_sym_with] = ACTIONS(5518),
    [aux_sym_preproc_if_token3] = ACTIONS(5518),
    [aux_sym_preproc_else_token1] = ACTIONS(5518),
    [aux_sym_preproc_elif_token1] = ACTIONS(5518),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4205] = {
    [sym_preproc_region] = STATE(4205),
    [sym_preproc_endregion] = STATE(4205),
    [sym_preproc_line] = STATE(4205),
    [sym_preproc_pragma] = STATE(4205),
    [sym_preproc_nullable] = STATE(4205),
    [sym_preproc_error] = STATE(4205),
    [sym_preproc_define] = STATE(4205),
    [sym_preproc_undef] = STATE(4205),
    [anon_sym_SEMI] = ACTIONS(5498),
    [anon_sym_LBRACK] = ACTIONS(5498),
    [anon_sym_COLON] = ACTIONS(5498),
    [anon_sym_COMMA] = ACTIONS(5498),
    [anon_sym_RBRACK] = ACTIONS(5498),
    [anon_sym_LPAREN] = ACTIONS(5498),
    [anon_sym_RPAREN] = ACTIONS(5498),
    [anon_sym_RBRACE] = ACTIONS(5498),
    [anon_sym_LT] = ACTIONS(5500),
    [anon_sym_GT] = ACTIONS(5500),
    [anon_sym_in] = ACTIONS(5498),
    [anon_sym_QMARK] = ACTIONS(5500),
    [anon_sym_BANG] = ACTIONS(5500),
    [anon_sym_PLUS_PLUS] = ACTIONS(5498),
    [anon_sym_DASH_DASH] = ACTIONS(5498),
    [anon_sym_PLUS] = ACTIONS(5500),
    [anon_sym_DASH] = ACTIONS(5500),
    [anon_sym_STAR] = ACTIONS(5498),
    [anon_sym_SLASH] = ACTIONS(5500),
    [anon_sym_PERCENT] = ACTIONS(5498),
    [anon_sym_CARET] = ACTIONS(5498),
    [anon_sym_PIPE] = ACTIONS(5500),
    [anon_sym_AMP] = ACTIONS(5500),
    [anon_sym_LT_LT] = ACTIONS(5498),
    [anon_sym_GT_GT] = ACTIONS(5500),
    [anon_sym_GT_GT_GT] = ACTIONS(5498),
    [anon_sym_EQ_EQ] = ACTIONS(5498),
    [anon_sym_BANG_EQ] = ACTIONS(5498),
    [anon_sym_GT_EQ] = ACTIONS(5498),
    [anon_sym_LT_EQ] = ACTIONS(5498),
    [anon_sym_DOT] = ACTIONS(5500),
    [anon_sym_EQ_GT] = ACTIONS(5498),
    [anon_sym_switch] = ACTIONS(5498),
    [anon_sym_when] = ACTIONS(5498),
    [anon_sym_DOT_DOT] = ACTIONS(5498),
    [anon_sym_and] = ACTIONS(5498),
    [anon_sym_or] = ACTIONS(5498),
    [anon_sym_AMP_AMP] = ACTIONS(5498),
    [anon_sym_PIPE_PIPE] = ACTIONS(5498),
    [anon_sym_QMARK_QMARK] = ACTIONS(5498),
    [anon_sym_on] = ACTIONS(5498),
    [anon_sym_equals] = ACTIONS(5498),
    [anon_sym_by] = ACTIONS(5498),
    [anon_sym_as] = ACTIONS(5498),
    [anon_sym_is] = ACTIONS(5498),
    [anon_sym_DASH_GT] = ACTIONS(5498),
    [anon_sym_with] = ACTIONS(5498),
    [aux_sym_preproc_if_token3] = ACTIONS(5498),
    [aux_sym_preproc_else_token1] = ACTIONS(5498),
    [aux_sym_preproc_elif_token1] = ACTIONS(5498),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4206] = {
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7306),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_identifier] = STATE(4921),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4206),
    [sym_preproc_endregion] = STATE(4206),
    [sym_preproc_line] = STATE(4206),
    [sym_preproc_pragma] = STATE(4206),
    [sym_preproc_nullable] = STATE(4206),
    [sym_preproc_error] = STATE(4206),
    [sym_preproc_define] = STATE(4206),
    [sym_preproc_undef] = STATE(4206),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(6755),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_LPAREN] = ACTIONS(2995),
    [anon_sym_ref] = ACTIONS(5216),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_readonly] = ACTIONS(1093),
    [anon_sym_in] = ACTIONS(1093),
    [anon_sym_out] = ACTIONS(1093),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_this] = ACTIONS(1093),
    [anon_sym_scoped] = ACTIONS(5218),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4207] = {
    [sym_preproc_region] = STATE(4207),
    [sym_preproc_endregion] = STATE(4207),
    [sym_preproc_line] = STATE(4207),
    [sym_preproc_pragma] = STATE(4207),
    [sym_preproc_nullable] = STATE(4207),
    [sym_preproc_error] = STATE(4207),
    [sym_preproc_define] = STATE(4207),
    [sym_preproc_undef] = STATE(4207),
    [anon_sym_SEMI] = ACTIONS(5474),
    [anon_sym_LBRACK] = ACTIONS(5474),
    [anon_sym_COLON] = ACTIONS(5474),
    [anon_sym_COMMA] = ACTIONS(5474),
    [anon_sym_RBRACK] = ACTIONS(5474),
    [anon_sym_LPAREN] = ACTIONS(5474),
    [anon_sym_RPAREN] = ACTIONS(5474),
    [anon_sym_RBRACE] = ACTIONS(5474),
    [anon_sym_LT] = ACTIONS(5476),
    [anon_sym_GT] = ACTIONS(5476),
    [anon_sym_in] = ACTIONS(5474),
    [anon_sym_QMARK] = ACTIONS(5476),
    [anon_sym_BANG] = ACTIONS(5476),
    [anon_sym_PLUS_PLUS] = ACTIONS(5474),
    [anon_sym_DASH_DASH] = ACTIONS(5474),
    [anon_sym_PLUS] = ACTIONS(5476),
    [anon_sym_DASH] = ACTIONS(5476),
    [anon_sym_STAR] = ACTIONS(5474),
    [anon_sym_SLASH] = ACTIONS(5476),
    [anon_sym_PERCENT] = ACTIONS(5474),
    [anon_sym_CARET] = ACTIONS(5474),
    [anon_sym_PIPE] = ACTIONS(5476),
    [anon_sym_AMP] = ACTIONS(5476),
    [anon_sym_LT_LT] = ACTIONS(5474),
    [anon_sym_GT_GT] = ACTIONS(5476),
    [anon_sym_GT_GT_GT] = ACTIONS(5474),
    [anon_sym_EQ_EQ] = ACTIONS(5474),
    [anon_sym_BANG_EQ] = ACTIONS(5474),
    [anon_sym_GT_EQ] = ACTIONS(5474),
    [anon_sym_LT_EQ] = ACTIONS(5474),
    [anon_sym_DOT] = ACTIONS(5476),
    [anon_sym_EQ_GT] = ACTIONS(5474),
    [anon_sym_switch] = ACTIONS(5474),
    [anon_sym_when] = ACTIONS(5474),
    [anon_sym_DOT_DOT] = ACTIONS(5474),
    [anon_sym_and] = ACTIONS(5474),
    [anon_sym_or] = ACTIONS(5474),
    [anon_sym_AMP_AMP] = ACTIONS(5474),
    [anon_sym_PIPE_PIPE] = ACTIONS(5474),
    [anon_sym_QMARK_QMARK] = ACTIONS(5474),
    [anon_sym_on] = ACTIONS(5474),
    [anon_sym_equals] = ACTIONS(5474),
    [anon_sym_by] = ACTIONS(5474),
    [anon_sym_as] = ACTIONS(5474),
    [anon_sym_is] = ACTIONS(5474),
    [anon_sym_DASH_GT] = ACTIONS(5474),
    [anon_sym_with] = ACTIONS(5474),
    [aux_sym_preproc_if_token3] = ACTIONS(5474),
    [aux_sym_preproc_else_token1] = ACTIONS(5474),
    [aux_sym_preproc_elif_token1] = ACTIONS(5474),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4208] = {
    [sym_preproc_region] = STATE(4208),
    [sym_preproc_endregion] = STATE(4208),
    [sym_preproc_line] = STATE(4208),
    [sym_preproc_pragma] = STATE(4208),
    [sym_preproc_nullable] = STATE(4208),
    [sym_preproc_error] = STATE(4208),
    [sym_preproc_define] = STATE(4208),
    [sym_preproc_undef] = STATE(4208),
    [anon_sym_SEMI] = ACTIONS(5470),
    [anon_sym_LBRACK] = ACTIONS(5470),
    [anon_sym_COLON] = ACTIONS(5470),
    [anon_sym_COMMA] = ACTIONS(5470),
    [anon_sym_RBRACK] = ACTIONS(5470),
    [anon_sym_LPAREN] = ACTIONS(5470),
    [anon_sym_RPAREN] = ACTIONS(5470),
    [anon_sym_RBRACE] = ACTIONS(5470),
    [anon_sym_LT] = ACTIONS(5472),
    [anon_sym_GT] = ACTIONS(5472),
    [anon_sym_in] = ACTIONS(5470),
    [anon_sym_QMARK] = ACTIONS(5472),
    [anon_sym_BANG] = ACTIONS(5472),
    [anon_sym_PLUS_PLUS] = ACTIONS(5470),
    [anon_sym_DASH_DASH] = ACTIONS(5470),
    [anon_sym_PLUS] = ACTIONS(5472),
    [anon_sym_DASH] = ACTIONS(5472),
    [anon_sym_STAR] = ACTIONS(5470),
    [anon_sym_SLASH] = ACTIONS(5472),
    [anon_sym_PERCENT] = ACTIONS(5470),
    [anon_sym_CARET] = ACTIONS(5470),
    [anon_sym_PIPE] = ACTIONS(5472),
    [anon_sym_AMP] = ACTIONS(5472),
    [anon_sym_LT_LT] = ACTIONS(5470),
    [anon_sym_GT_GT] = ACTIONS(5472),
    [anon_sym_GT_GT_GT] = ACTIONS(5470),
    [anon_sym_EQ_EQ] = ACTIONS(5470),
    [anon_sym_BANG_EQ] = ACTIONS(5470),
    [anon_sym_GT_EQ] = ACTIONS(5470),
    [anon_sym_LT_EQ] = ACTIONS(5470),
    [anon_sym_DOT] = ACTIONS(5472),
    [anon_sym_EQ_GT] = ACTIONS(5470),
    [anon_sym_switch] = ACTIONS(5470),
    [anon_sym_when] = ACTIONS(5470),
    [anon_sym_DOT_DOT] = ACTIONS(5470),
    [anon_sym_and] = ACTIONS(5470),
    [anon_sym_or] = ACTIONS(5470),
    [anon_sym_AMP_AMP] = ACTIONS(5470),
    [anon_sym_PIPE_PIPE] = ACTIONS(5470),
    [anon_sym_QMARK_QMARK] = ACTIONS(5470),
    [anon_sym_on] = ACTIONS(5470),
    [anon_sym_equals] = ACTIONS(5470),
    [anon_sym_by] = ACTIONS(5470),
    [anon_sym_as] = ACTIONS(5470),
    [anon_sym_is] = ACTIONS(5470),
    [anon_sym_DASH_GT] = ACTIONS(5470),
    [anon_sym_with] = ACTIONS(5470),
    [aux_sym_preproc_if_token3] = ACTIONS(5470),
    [aux_sym_preproc_else_token1] = ACTIONS(5470),
    [aux_sym_preproc_elif_token1] = ACTIONS(5470),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4209] = {
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7041),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9290),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4209),
    [sym_preproc_endregion] = STATE(4209),
    [sym_preproc_line] = STATE(4209),
    [sym_preproc_pragma] = STATE(4209),
    [sym_preproc_nullable] = STATE(4209),
    [sym_preproc_error] = STATE(4209),
    [sym_preproc_define] = STATE(4209),
    [sym_preproc_undef] = STATE(4209),
    [aux_sym_lambda_expression_repeat1] = STATE(6864),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(5896),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4210] = {
    [sym_preproc_region] = STATE(4210),
    [sym_preproc_endregion] = STATE(4210),
    [sym_preproc_line] = STATE(4210),
    [sym_preproc_pragma] = STATE(4210),
    [sym_preproc_nullable] = STATE(4210),
    [sym_preproc_error] = STATE(4210),
    [sym_preproc_define] = STATE(4210),
    [sym_preproc_undef] = STATE(4210),
    [anon_sym_EQ] = ACTIONS(5937),
    [anon_sym_LBRACK] = ACTIONS(5249),
    [anon_sym_COLON] = ACTIONS(5249),
    [anon_sym_COMMA] = ACTIONS(5249),
    [anon_sym_LPAREN] = ACTIONS(5249),
    [anon_sym_RPAREN] = ACTIONS(5249),
    [anon_sym_RBRACE] = ACTIONS(5249),
    [anon_sym_LT] = ACTIONS(5251),
    [anon_sym_GT] = ACTIONS(5251),
    [anon_sym_QMARK] = ACTIONS(5251),
    [anon_sym_BANG] = ACTIONS(5251),
    [anon_sym_PLUS_PLUS] = ACTIONS(5249),
    [anon_sym_DASH_DASH] = ACTIONS(5249),
    [anon_sym_PLUS] = ACTIONS(5251),
    [anon_sym_DASH] = ACTIONS(5251),
    [anon_sym_STAR] = ACTIONS(5251),
    [anon_sym_SLASH] = ACTIONS(5251),
    [anon_sym_PERCENT] = ACTIONS(5251),
    [anon_sym_CARET] = ACTIONS(5251),
    [anon_sym_PIPE] = ACTIONS(5251),
    [anon_sym_AMP] = ACTIONS(5251),
    [anon_sym_LT_LT] = ACTIONS(5251),
    [anon_sym_GT_GT] = ACTIONS(5251),
    [anon_sym_GT_GT_GT] = ACTIONS(5251),
    [anon_sym_EQ_EQ] = ACTIONS(5249),
    [anon_sym_BANG_EQ] = ACTIONS(5249),
    [anon_sym_GT_EQ] = ACTIONS(5249),
    [anon_sym_LT_EQ] = ACTIONS(5249),
    [anon_sym_DOT] = ACTIONS(5251),
    [anon_sym_switch] = ACTIONS(5249),
    [anon_sym_DOT_DOT] = ACTIONS(5249),
    [anon_sym_PLUS_EQ] = ACTIONS(5939),
    [anon_sym_DASH_EQ] = ACTIONS(5939),
    [anon_sym_STAR_EQ] = ACTIONS(5939),
    [anon_sym_SLASH_EQ] = ACTIONS(5939),
    [anon_sym_PERCENT_EQ] = ACTIONS(5939),
    [anon_sym_AMP_EQ] = ACTIONS(5939),
    [anon_sym_CARET_EQ] = ACTIONS(5939),
    [anon_sym_PIPE_EQ] = ACTIONS(5939),
    [anon_sym_LT_LT_EQ] = ACTIONS(5939),
    [anon_sym_GT_GT_EQ] = ACTIONS(5939),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5939),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(5939),
    [anon_sym_AMP_AMP] = ACTIONS(5249),
    [anon_sym_PIPE_PIPE] = ACTIONS(5249),
    [anon_sym_QMARK_QMARK] = ACTIONS(5251),
    [anon_sym_as] = ACTIONS(5249),
    [anon_sym_is] = ACTIONS(5249),
    [anon_sym_DASH_GT] = ACTIONS(5249),
    [anon_sym_with] = ACTIONS(5249),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4211] = {
    [sym_preproc_region] = STATE(4211),
    [sym_preproc_endregion] = STATE(4211),
    [sym_preproc_line] = STATE(4211),
    [sym_preproc_pragma] = STATE(4211),
    [sym_preproc_nullable] = STATE(4211),
    [sym_preproc_error] = STATE(4211),
    [sym_preproc_define] = STATE(4211),
    [sym_preproc_undef] = STATE(4211),
    [anon_sym_SEMI] = ACTIONS(5392),
    [anon_sym_LBRACK] = ACTIONS(5392),
    [anon_sym_COLON] = ACTIONS(5392),
    [anon_sym_COMMA] = ACTIONS(5392),
    [anon_sym_RBRACK] = ACTIONS(5392),
    [anon_sym_LPAREN] = ACTIONS(5392),
    [anon_sym_RPAREN] = ACTIONS(5392),
    [anon_sym_RBRACE] = ACTIONS(5392),
    [anon_sym_LT] = ACTIONS(5394),
    [anon_sym_GT] = ACTIONS(5394),
    [anon_sym_in] = ACTIONS(5392),
    [anon_sym_QMARK] = ACTIONS(5394),
    [anon_sym_BANG] = ACTIONS(5394),
    [anon_sym_PLUS_PLUS] = ACTIONS(5392),
    [anon_sym_DASH_DASH] = ACTIONS(5392),
    [anon_sym_PLUS] = ACTIONS(5394),
    [anon_sym_DASH] = ACTIONS(5394),
    [anon_sym_STAR] = ACTIONS(5392),
    [anon_sym_SLASH] = ACTIONS(5394),
    [anon_sym_PERCENT] = ACTIONS(5392),
    [anon_sym_CARET] = ACTIONS(5392),
    [anon_sym_PIPE] = ACTIONS(5394),
    [anon_sym_AMP] = ACTIONS(5394),
    [anon_sym_LT_LT] = ACTIONS(5392),
    [anon_sym_GT_GT] = ACTIONS(5394),
    [anon_sym_GT_GT_GT] = ACTIONS(5392),
    [anon_sym_EQ_EQ] = ACTIONS(5392),
    [anon_sym_BANG_EQ] = ACTIONS(5392),
    [anon_sym_GT_EQ] = ACTIONS(5392),
    [anon_sym_LT_EQ] = ACTIONS(5392),
    [anon_sym_DOT] = ACTIONS(5394),
    [anon_sym_EQ_GT] = ACTIONS(5392),
    [anon_sym_switch] = ACTIONS(5392),
    [anon_sym_when] = ACTIONS(5392),
    [anon_sym_DOT_DOT] = ACTIONS(5392),
    [anon_sym_and] = ACTIONS(5392),
    [anon_sym_or] = ACTIONS(5392),
    [anon_sym_AMP_AMP] = ACTIONS(5392),
    [anon_sym_PIPE_PIPE] = ACTIONS(5392),
    [anon_sym_QMARK_QMARK] = ACTIONS(5392),
    [anon_sym_on] = ACTIONS(5392),
    [anon_sym_equals] = ACTIONS(5392),
    [anon_sym_by] = ACTIONS(5392),
    [anon_sym_as] = ACTIONS(5392),
    [anon_sym_is] = ACTIONS(5392),
    [anon_sym_DASH_GT] = ACTIONS(5392),
    [anon_sym_with] = ACTIONS(5392),
    [aux_sym_preproc_if_token3] = ACTIONS(5392),
    [aux_sym_preproc_else_token1] = ACTIONS(5392),
    [aux_sym_preproc_elif_token1] = ACTIONS(5392),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4212] = {
    [sym_preproc_region] = STATE(4212),
    [sym_preproc_endregion] = STATE(4212),
    [sym_preproc_line] = STATE(4212),
    [sym_preproc_pragma] = STATE(4212),
    [sym_preproc_nullable] = STATE(4212),
    [sym_preproc_error] = STATE(4212),
    [sym_preproc_define] = STATE(4212),
    [sym_preproc_undef] = STATE(4212),
    [anon_sym_SEMI] = ACTIONS(4695),
    [anon_sym_LBRACK] = ACTIONS(4695),
    [anon_sym_COLON] = ACTIONS(4695),
    [anon_sym_COMMA] = ACTIONS(4695),
    [anon_sym_RBRACK] = ACTIONS(4695),
    [anon_sym_LPAREN] = ACTIONS(4695),
    [anon_sym_RPAREN] = ACTIONS(4695),
    [anon_sym_RBRACE] = ACTIONS(4695),
    [anon_sym_LT] = ACTIONS(4697),
    [anon_sym_GT] = ACTIONS(4697),
    [anon_sym_in] = ACTIONS(4695),
    [anon_sym_QMARK] = ACTIONS(4697),
    [anon_sym_BANG] = ACTIONS(4697),
    [anon_sym_PLUS_PLUS] = ACTIONS(4695),
    [anon_sym_DASH_DASH] = ACTIONS(4695),
    [anon_sym_PLUS] = ACTIONS(4697),
    [anon_sym_DASH] = ACTIONS(4697),
    [anon_sym_STAR] = ACTIONS(4695),
    [anon_sym_SLASH] = ACTIONS(4697),
    [anon_sym_PERCENT] = ACTIONS(4695),
    [anon_sym_CARET] = ACTIONS(4695),
    [anon_sym_PIPE] = ACTIONS(4697),
    [anon_sym_AMP] = ACTIONS(4697),
    [anon_sym_LT_LT] = ACTIONS(4695),
    [anon_sym_GT_GT] = ACTIONS(4697),
    [anon_sym_GT_GT_GT] = ACTIONS(4695),
    [anon_sym_EQ_EQ] = ACTIONS(4695),
    [anon_sym_BANG_EQ] = ACTIONS(4695),
    [anon_sym_GT_EQ] = ACTIONS(4695),
    [anon_sym_LT_EQ] = ACTIONS(4695),
    [anon_sym_DOT] = ACTIONS(4697),
    [anon_sym_EQ_GT] = ACTIONS(4695),
    [anon_sym_switch] = ACTIONS(4695),
    [anon_sym_when] = ACTIONS(4695),
    [anon_sym_DOT_DOT] = ACTIONS(4695),
    [anon_sym_and] = ACTIONS(4695),
    [anon_sym_or] = ACTIONS(4695),
    [anon_sym_AMP_AMP] = ACTIONS(4695),
    [anon_sym_PIPE_PIPE] = ACTIONS(4695),
    [anon_sym_QMARK_QMARK] = ACTIONS(4695),
    [anon_sym_on] = ACTIONS(4695),
    [anon_sym_equals] = ACTIONS(4695),
    [anon_sym_by] = ACTIONS(4695),
    [anon_sym_as] = ACTIONS(4695),
    [anon_sym_is] = ACTIONS(4695),
    [anon_sym_DASH_GT] = ACTIONS(4695),
    [anon_sym_with] = ACTIONS(4695),
    [aux_sym_preproc_if_token3] = ACTIONS(4695),
    [aux_sym_preproc_else_token1] = ACTIONS(4695),
    [aux_sym_preproc_elif_token1] = ACTIONS(4695),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4213] = {
    [sym_preproc_region] = STATE(4213),
    [sym_preproc_endregion] = STATE(4213),
    [sym_preproc_line] = STATE(4213),
    [sym_preproc_pragma] = STATE(4213),
    [sym_preproc_nullable] = STATE(4213),
    [sym_preproc_error] = STATE(4213),
    [sym_preproc_define] = STATE(4213),
    [sym_preproc_undef] = STATE(4213),
    [anon_sym_SEMI] = ACTIONS(5572),
    [anon_sym_LBRACK] = ACTIONS(5572),
    [anon_sym_COLON] = ACTIONS(5572),
    [anon_sym_COMMA] = ACTIONS(5572),
    [anon_sym_RBRACK] = ACTIONS(5572),
    [anon_sym_LPAREN] = ACTIONS(5572),
    [anon_sym_RPAREN] = ACTIONS(5572),
    [anon_sym_RBRACE] = ACTIONS(5572),
    [anon_sym_LT] = ACTIONS(5574),
    [anon_sym_GT] = ACTIONS(5574),
    [anon_sym_in] = ACTIONS(5572),
    [anon_sym_QMARK] = ACTIONS(5574),
    [anon_sym_BANG] = ACTIONS(5574),
    [anon_sym_PLUS_PLUS] = ACTIONS(5572),
    [anon_sym_DASH_DASH] = ACTIONS(5572),
    [anon_sym_PLUS] = ACTIONS(5574),
    [anon_sym_DASH] = ACTIONS(5574),
    [anon_sym_STAR] = ACTIONS(5572),
    [anon_sym_SLASH] = ACTIONS(5574),
    [anon_sym_PERCENT] = ACTIONS(5572),
    [anon_sym_CARET] = ACTIONS(5572),
    [anon_sym_PIPE] = ACTIONS(5574),
    [anon_sym_AMP] = ACTIONS(5574),
    [anon_sym_LT_LT] = ACTIONS(5572),
    [anon_sym_GT_GT] = ACTIONS(5574),
    [anon_sym_GT_GT_GT] = ACTIONS(5572),
    [anon_sym_EQ_EQ] = ACTIONS(5572),
    [anon_sym_BANG_EQ] = ACTIONS(5572),
    [anon_sym_GT_EQ] = ACTIONS(5572),
    [anon_sym_LT_EQ] = ACTIONS(5572),
    [anon_sym_DOT] = ACTIONS(5574),
    [anon_sym_EQ_GT] = ACTIONS(5572),
    [anon_sym_switch] = ACTIONS(5572),
    [anon_sym_when] = ACTIONS(5572),
    [anon_sym_DOT_DOT] = ACTIONS(5572),
    [anon_sym_and] = ACTIONS(5572),
    [anon_sym_or] = ACTIONS(5572),
    [anon_sym_AMP_AMP] = ACTIONS(5572),
    [anon_sym_PIPE_PIPE] = ACTIONS(5572),
    [anon_sym_QMARK_QMARK] = ACTIONS(5572),
    [anon_sym_on] = ACTIONS(5572),
    [anon_sym_equals] = ACTIONS(5572),
    [anon_sym_by] = ACTIONS(5572),
    [anon_sym_as] = ACTIONS(5572),
    [anon_sym_is] = ACTIONS(5572),
    [anon_sym_DASH_GT] = ACTIONS(5572),
    [anon_sym_with] = ACTIONS(5572),
    [aux_sym_preproc_if_token3] = ACTIONS(5572),
    [aux_sym_preproc_else_token1] = ACTIONS(5572),
    [aux_sym_preproc_elif_token1] = ACTIONS(5572),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4214] = {
    [sym_preproc_region] = STATE(4214),
    [sym_preproc_endregion] = STATE(4214),
    [sym_preproc_line] = STATE(4214),
    [sym_preproc_pragma] = STATE(4214),
    [sym_preproc_nullable] = STATE(4214),
    [sym_preproc_error] = STATE(4214),
    [sym_preproc_define] = STATE(4214),
    [sym_preproc_undef] = STATE(4214),
    [anon_sym_EQ] = ACTIONS(5941),
    [anon_sym_LBRACK] = ACTIONS(5249),
    [anon_sym_LPAREN] = ACTIONS(5249),
    [anon_sym_LT] = ACTIONS(5251),
    [anon_sym_GT] = ACTIONS(5251),
    [anon_sym_QMARK] = ACTIONS(5251),
    [anon_sym_BANG] = ACTIONS(5251),
    [anon_sym_PLUS_PLUS] = ACTIONS(5249),
    [anon_sym_DASH_DASH] = ACTIONS(5249),
    [anon_sym_PLUS] = ACTIONS(5251),
    [anon_sym_DASH] = ACTIONS(5251),
    [anon_sym_STAR] = ACTIONS(5251),
    [anon_sym_SLASH] = ACTIONS(5251),
    [anon_sym_PERCENT] = ACTIONS(5251),
    [anon_sym_CARET] = ACTIONS(5251),
    [anon_sym_PIPE] = ACTIONS(5251),
    [anon_sym_AMP] = ACTIONS(5251),
    [anon_sym_LT_LT] = ACTIONS(5251),
    [anon_sym_GT_GT] = ACTIONS(5251),
    [anon_sym_GT_GT_GT] = ACTIONS(5251),
    [anon_sym_EQ_EQ] = ACTIONS(5249),
    [anon_sym_BANG_EQ] = ACTIONS(5249),
    [anon_sym_GT_EQ] = ACTIONS(5249),
    [anon_sym_LT_EQ] = ACTIONS(5249),
    [anon_sym_DOT] = ACTIONS(5251),
    [anon_sym_switch] = ACTIONS(5249),
    [anon_sym_DOT_DOT] = ACTIONS(5249),
    [anon_sym_and] = ACTIONS(5249),
    [anon_sym_or] = ACTIONS(5249),
    [anon_sym_PLUS_EQ] = ACTIONS(5943),
    [anon_sym_DASH_EQ] = ACTIONS(5943),
    [anon_sym_STAR_EQ] = ACTIONS(5943),
    [anon_sym_SLASH_EQ] = ACTIONS(5943),
    [anon_sym_PERCENT_EQ] = ACTIONS(5943),
    [anon_sym_AMP_EQ] = ACTIONS(5943),
    [anon_sym_CARET_EQ] = ACTIONS(5943),
    [anon_sym_PIPE_EQ] = ACTIONS(5943),
    [anon_sym_LT_LT_EQ] = ACTIONS(5943),
    [anon_sym_GT_GT_EQ] = ACTIONS(5943),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5943),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(5943),
    [anon_sym_AMP_AMP] = ACTIONS(5249),
    [anon_sym_PIPE_PIPE] = ACTIONS(5249),
    [anon_sym_QMARK_QMARK] = ACTIONS(5251),
    [anon_sym_into] = ACTIONS(5249),
    [anon_sym_on] = ACTIONS(5249),
    [anon_sym_as] = ACTIONS(5249),
    [anon_sym_is] = ACTIONS(5249),
    [anon_sym_DASH_GT] = ACTIONS(5249),
    [anon_sym_with] = ACTIONS(5249),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4215] = {
    [sym_preproc_region] = STATE(4215),
    [sym_preproc_endregion] = STATE(4215),
    [sym_preproc_line] = STATE(4215),
    [sym_preproc_pragma] = STATE(4215),
    [sym_preproc_nullable] = STATE(4215),
    [sym_preproc_error] = STATE(4215),
    [sym_preproc_define] = STATE(4215),
    [sym_preproc_undef] = STATE(4215),
    [anon_sym_SEMI] = ACTIONS(2927),
    [anon_sym_LBRACK] = ACTIONS(2927),
    [anon_sym_COLON] = ACTIONS(2927),
    [anon_sym_COMMA] = ACTIONS(2927),
    [anon_sym_RBRACK] = ACTIONS(2927),
    [anon_sym_LPAREN] = ACTIONS(2927),
    [anon_sym_RPAREN] = ACTIONS(2927),
    [anon_sym_RBRACE] = ACTIONS(2927),
    [anon_sym_LT] = ACTIONS(2925),
    [anon_sym_GT] = ACTIONS(2925),
    [anon_sym_in] = ACTIONS(2927),
    [anon_sym_QMARK] = ACTIONS(2925),
    [anon_sym_BANG] = ACTIONS(2925),
    [anon_sym_PLUS_PLUS] = ACTIONS(2927),
    [anon_sym_DASH_DASH] = ACTIONS(2927),
    [anon_sym_PLUS] = ACTIONS(2925),
    [anon_sym_DASH] = ACTIONS(2925),
    [anon_sym_STAR] = ACTIONS(2927),
    [anon_sym_SLASH] = ACTIONS(2925),
    [anon_sym_PERCENT] = ACTIONS(2927),
    [anon_sym_CARET] = ACTIONS(2927),
    [anon_sym_PIPE] = ACTIONS(2925),
    [anon_sym_AMP] = ACTIONS(2925),
    [anon_sym_LT_LT] = ACTIONS(2927),
    [anon_sym_GT_GT] = ACTIONS(2925),
    [anon_sym_GT_GT_GT] = ACTIONS(2927),
    [anon_sym_EQ_EQ] = ACTIONS(2927),
    [anon_sym_BANG_EQ] = ACTIONS(2927),
    [anon_sym_GT_EQ] = ACTIONS(2927),
    [anon_sym_LT_EQ] = ACTIONS(2927),
    [anon_sym_DOT] = ACTIONS(2925),
    [anon_sym_EQ_GT] = ACTIONS(2927),
    [anon_sym_switch] = ACTIONS(2927),
    [anon_sym_when] = ACTIONS(2927),
    [anon_sym_DOT_DOT] = ACTIONS(2927),
    [anon_sym_and] = ACTIONS(2927),
    [anon_sym_or] = ACTIONS(2927),
    [anon_sym_AMP_AMP] = ACTIONS(2927),
    [anon_sym_PIPE_PIPE] = ACTIONS(2927),
    [anon_sym_QMARK_QMARK] = ACTIONS(2927),
    [anon_sym_on] = ACTIONS(2927),
    [anon_sym_equals] = ACTIONS(2927),
    [anon_sym_by] = ACTIONS(2927),
    [anon_sym_as] = ACTIONS(2927),
    [anon_sym_is] = ACTIONS(2927),
    [anon_sym_DASH_GT] = ACTIONS(2927),
    [anon_sym_with] = ACTIONS(2927),
    [aux_sym_preproc_if_token3] = ACTIONS(2927),
    [aux_sym_preproc_else_token1] = ACTIONS(2927),
    [aux_sym_preproc_elif_token1] = ACTIONS(2927),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4216] = {
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7101),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9548),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4216),
    [sym_preproc_endregion] = STATE(4216),
    [sym_preproc_line] = STATE(4216),
    [sym_preproc_pragma] = STATE(4216),
    [sym_preproc_nullable] = STATE(4216),
    [sym_preproc_error] = STATE(4216),
    [sym_preproc_define] = STATE(4216),
    [sym_preproc_undef] = STATE(4216),
    [aux_sym_lambda_expression_repeat1] = STATE(6864),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(5908),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4217] = {
    [sym_preproc_region] = STATE(4217),
    [sym_preproc_endregion] = STATE(4217),
    [sym_preproc_line] = STATE(4217),
    [sym_preproc_pragma] = STATE(4217),
    [sym_preproc_nullable] = STATE(4217),
    [sym_preproc_error] = STATE(4217),
    [sym_preproc_define] = STATE(4217),
    [sym_preproc_undef] = STATE(4217),
    [anon_sym_SEMI] = ACTIONS(5560),
    [anon_sym_LBRACK] = ACTIONS(5560),
    [anon_sym_COLON] = ACTIONS(5560),
    [anon_sym_COMMA] = ACTIONS(5560),
    [anon_sym_RBRACK] = ACTIONS(5560),
    [anon_sym_LPAREN] = ACTIONS(5560),
    [anon_sym_RPAREN] = ACTIONS(5560),
    [anon_sym_RBRACE] = ACTIONS(5560),
    [anon_sym_LT] = ACTIONS(5562),
    [anon_sym_GT] = ACTIONS(5562),
    [anon_sym_in] = ACTIONS(5560),
    [anon_sym_QMARK] = ACTIONS(5562),
    [anon_sym_BANG] = ACTIONS(5562),
    [anon_sym_PLUS_PLUS] = ACTIONS(5560),
    [anon_sym_DASH_DASH] = ACTIONS(5560),
    [anon_sym_PLUS] = ACTIONS(5562),
    [anon_sym_DASH] = ACTIONS(5562),
    [anon_sym_STAR] = ACTIONS(5560),
    [anon_sym_SLASH] = ACTIONS(5562),
    [anon_sym_PERCENT] = ACTIONS(5560),
    [anon_sym_CARET] = ACTIONS(5560),
    [anon_sym_PIPE] = ACTIONS(5562),
    [anon_sym_AMP] = ACTIONS(5562),
    [anon_sym_LT_LT] = ACTIONS(5560),
    [anon_sym_GT_GT] = ACTIONS(5562),
    [anon_sym_GT_GT_GT] = ACTIONS(5560),
    [anon_sym_EQ_EQ] = ACTIONS(5560),
    [anon_sym_BANG_EQ] = ACTIONS(5560),
    [anon_sym_GT_EQ] = ACTIONS(5560),
    [anon_sym_LT_EQ] = ACTIONS(5560),
    [anon_sym_DOT] = ACTIONS(5562),
    [anon_sym_EQ_GT] = ACTIONS(5560),
    [anon_sym_switch] = ACTIONS(5560),
    [anon_sym_when] = ACTIONS(5560),
    [anon_sym_DOT_DOT] = ACTIONS(5560),
    [anon_sym_and] = ACTIONS(5560),
    [anon_sym_or] = ACTIONS(5560),
    [anon_sym_AMP_AMP] = ACTIONS(5560),
    [anon_sym_PIPE_PIPE] = ACTIONS(5560),
    [anon_sym_QMARK_QMARK] = ACTIONS(5560),
    [anon_sym_on] = ACTIONS(5560),
    [anon_sym_equals] = ACTIONS(5560),
    [anon_sym_by] = ACTIONS(5560),
    [anon_sym_as] = ACTIONS(5560),
    [anon_sym_is] = ACTIONS(5560),
    [anon_sym_DASH_GT] = ACTIONS(5560),
    [anon_sym_with] = ACTIONS(5560),
    [aux_sym_preproc_if_token3] = ACTIONS(5560),
    [aux_sym_preproc_else_token1] = ACTIONS(5560),
    [aux_sym_preproc_elif_token1] = ACTIONS(5560),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4218] = {
    [sym_preproc_region] = STATE(4218),
    [sym_preproc_endregion] = STATE(4218),
    [sym_preproc_line] = STATE(4218),
    [sym_preproc_pragma] = STATE(4218),
    [sym_preproc_nullable] = STATE(4218),
    [sym_preproc_error] = STATE(4218),
    [sym_preproc_define] = STATE(4218),
    [sym_preproc_undef] = STATE(4218),
    [anon_sym_SEMI] = ACTIONS(1963),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_COLON] = ACTIONS(1963),
    [anon_sym_COMMA] = ACTIONS(1963),
    [anon_sym_RBRACK] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1963),
    [anon_sym_RPAREN] = ACTIONS(1963),
    [anon_sym_RBRACE] = ACTIONS(1963),
    [anon_sym_LT] = ACTIONS(1965),
    [anon_sym_GT] = ACTIONS(1965),
    [anon_sym_in] = ACTIONS(1963),
    [anon_sym_QMARK] = ACTIONS(1965),
    [anon_sym_BANG] = ACTIONS(1965),
    [anon_sym_PLUS_PLUS] = ACTIONS(1963),
    [anon_sym_DASH_DASH] = ACTIONS(1963),
    [anon_sym_PLUS] = ACTIONS(1965),
    [anon_sym_DASH] = ACTIONS(1965),
    [anon_sym_STAR] = ACTIONS(1963),
    [anon_sym_SLASH] = ACTIONS(1965),
    [anon_sym_PERCENT] = ACTIONS(1963),
    [anon_sym_CARET] = ACTIONS(1963),
    [anon_sym_PIPE] = ACTIONS(1965),
    [anon_sym_AMP] = ACTIONS(1965),
    [anon_sym_LT_LT] = ACTIONS(1963),
    [anon_sym_GT_GT] = ACTIONS(1965),
    [anon_sym_GT_GT_GT] = ACTIONS(1963),
    [anon_sym_EQ_EQ] = ACTIONS(1963),
    [anon_sym_BANG_EQ] = ACTIONS(1963),
    [anon_sym_GT_EQ] = ACTIONS(1963),
    [anon_sym_LT_EQ] = ACTIONS(1963),
    [anon_sym_DOT] = ACTIONS(1965),
    [anon_sym_EQ_GT] = ACTIONS(1963),
    [anon_sym_switch] = ACTIONS(1963),
    [anon_sym_when] = ACTIONS(1963),
    [anon_sym_DOT_DOT] = ACTIONS(1963),
    [anon_sym_and] = ACTIONS(1963),
    [anon_sym_or] = ACTIONS(1963),
    [anon_sym_AMP_AMP] = ACTIONS(1963),
    [anon_sym_PIPE_PIPE] = ACTIONS(1963),
    [anon_sym_QMARK_QMARK] = ACTIONS(1963),
    [anon_sym_on] = ACTIONS(1963),
    [anon_sym_equals] = ACTIONS(1963),
    [anon_sym_by] = ACTIONS(1963),
    [anon_sym_as] = ACTIONS(1963),
    [anon_sym_is] = ACTIONS(1963),
    [anon_sym_DASH_GT] = ACTIONS(1963),
    [anon_sym_with] = ACTIONS(1963),
    [aux_sym_preproc_if_token3] = ACTIONS(1963),
    [aux_sym_preproc_else_token1] = ACTIONS(1963),
    [aux_sym_preproc_elif_token1] = ACTIONS(1963),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4219] = {
    [sym_attribute_list] = STATE(4349),
    [sym_preproc_region] = STATE(4219),
    [sym_preproc_endregion] = STATE(4219),
    [sym_preproc_line] = STATE(4219),
    [sym_preproc_pragma] = STATE(4219),
    [sym_preproc_nullable] = STATE(4219),
    [sym_preproc_error] = STATE(4219),
    [sym_preproc_define] = STATE(4219),
    [sym_preproc_undef] = STATE(4219),
    [aux_sym_class_declaration_repeat1] = STATE(4219),
    [sym__identifier_token] = ACTIONS(5277),
    [anon_sym_extern] = ACTIONS(5277),
    [anon_sym_alias] = ACTIONS(5277),
    [anon_sym_global] = ACTIONS(5277),
    [anon_sym_unsafe] = ACTIONS(5277),
    [anon_sym_static] = ACTIONS(5277),
    [anon_sym_LBRACK] = ACTIONS(5945),
    [anon_sym_abstract] = ACTIONS(5277),
    [anon_sym_async] = ACTIONS(5277),
    [anon_sym_const] = ACTIONS(5277),
    [anon_sym_file] = ACTIONS(5277),
    [anon_sym_fixed] = ACTIONS(5277),
    [anon_sym_internal] = ACTIONS(5277),
    [anon_sym_new] = ACTIONS(5277),
    [anon_sym_override] = ACTIONS(5277),
    [anon_sym_partial] = ACTIONS(5277),
    [anon_sym_private] = ACTIONS(5277),
    [anon_sym_protected] = ACTIONS(5277),
    [anon_sym_public] = ACTIONS(5277),
    [anon_sym_readonly] = ACTIONS(5277),
    [anon_sym_required] = ACTIONS(5277),
    [anon_sym_sealed] = ACTIONS(5277),
    [anon_sym_virtual] = ACTIONS(5277),
    [anon_sym_volatile] = ACTIONS(5277),
    [anon_sym_where] = ACTIONS(5277),
    [anon_sym_notnull] = ACTIONS(5277),
    [anon_sym_unmanaged] = ACTIONS(5277),
    [anon_sym_get] = ACTIONS(5277),
    [anon_sym_set] = ACTIONS(5277),
    [anon_sym_add] = ACTIONS(5277),
    [anon_sym_remove] = ACTIONS(5277),
    [anon_sym_init] = ACTIONS(5277),
    [anon_sym_scoped] = ACTIONS(5277),
    [anon_sym_var] = ACTIONS(5277),
    [anon_sym_yield] = ACTIONS(5277),
    [anon_sym_when] = ACTIONS(5277),
    [anon_sym_from] = ACTIONS(5277),
    [anon_sym_into] = ACTIONS(5277),
    [anon_sym_join] = ACTIONS(5277),
    [anon_sym_on] = ACTIONS(5277),
    [anon_sym_equals] = ACTIONS(5277),
    [anon_sym_let] = ACTIONS(5277),
    [anon_sym_orderby] = ACTIONS(5277),
    [anon_sym_ascending] = ACTIONS(5277),
    [anon_sym_descending] = ACTIONS(5277),
    [anon_sym_group] = ACTIONS(5277),
    [anon_sym_by] = ACTIONS(5277),
    [anon_sym_select] = ACTIONS(5277),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4220] = {
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7112),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9034),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4220),
    [sym_preproc_endregion] = STATE(4220),
    [sym_preproc_line] = STATE(4220),
    [sym_preproc_pragma] = STATE(4220),
    [sym_preproc_nullable] = STATE(4220),
    [sym_preproc_error] = STATE(4220),
    [sym_preproc_define] = STATE(4220),
    [sym_preproc_undef] = STATE(4220),
    [aux_sym_lambda_expression_repeat1] = STATE(6864),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(5896),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4221] = {
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7069),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9171),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4221),
    [sym_preproc_endregion] = STATE(4221),
    [sym_preproc_line] = STATE(4221),
    [sym_preproc_pragma] = STATE(4221),
    [sym_preproc_nullable] = STATE(4221),
    [sym_preproc_error] = STATE(4221),
    [sym_preproc_define] = STATE(4221),
    [sym_preproc_undef] = STATE(4221),
    [aux_sym_lambda_expression_repeat1] = STATE(6864),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4222] = {
    [sym_preproc_region] = STATE(4222),
    [sym_preproc_endregion] = STATE(4222),
    [sym_preproc_line] = STATE(4222),
    [sym_preproc_pragma] = STATE(4222),
    [sym_preproc_nullable] = STATE(4222),
    [sym_preproc_error] = STATE(4222),
    [sym_preproc_define] = STATE(4222),
    [sym_preproc_undef] = STATE(4222),
    [anon_sym_SEMI] = ACTIONS(5341),
    [anon_sym_LBRACK] = ACTIONS(5341),
    [anon_sym_COLON] = ACTIONS(5341),
    [anon_sym_COMMA] = ACTIONS(5341),
    [anon_sym_RBRACK] = ACTIONS(5341),
    [anon_sym_LPAREN] = ACTIONS(5341),
    [anon_sym_RPAREN] = ACTIONS(5341),
    [anon_sym_RBRACE] = ACTIONS(5341),
    [anon_sym_LT] = ACTIONS(5343),
    [anon_sym_GT] = ACTIONS(5343),
    [anon_sym_in] = ACTIONS(5341),
    [anon_sym_QMARK] = ACTIONS(5343),
    [anon_sym_BANG] = ACTIONS(5343),
    [anon_sym_PLUS_PLUS] = ACTIONS(5341),
    [anon_sym_DASH_DASH] = ACTIONS(5341),
    [anon_sym_PLUS] = ACTIONS(5343),
    [anon_sym_DASH] = ACTIONS(5343),
    [anon_sym_STAR] = ACTIONS(5341),
    [anon_sym_SLASH] = ACTIONS(5343),
    [anon_sym_PERCENT] = ACTIONS(5341),
    [anon_sym_CARET] = ACTIONS(5341),
    [anon_sym_PIPE] = ACTIONS(5343),
    [anon_sym_AMP] = ACTIONS(5343),
    [anon_sym_LT_LT] = ACTIONS(5341),
    [anon_sym_GT_GT] = ACTIONS(5343),
    [anon_sym_GT_GT_GT] = ACTIONS(5341),
    [anon_sym_EQ_EQ] = ACTIONS(5341),
    [anon_sym_BANG_EQ] = ACTIONS(5341),
    [anon_sym_GT_EQ] = ACTIONS(5341),
    [anon_sym_LT_EQ] = ACTIONS(5341),
    [anon_sym_DOT] = ACTIONS(5343),
    [anon_sym_EQ_GT] = ACTIONS(5341),
    [anon_sym_switch] = ACTIONS(5341),
    [anon_sym_when] = ACTIONS(5341),
    [anon_sym_DOT_DOT] = ACTIONS(5341),
    [anon_sym_and] = ACTIONS(5341),
    [anon_sym_or] = ACTIONS(5341),
    [anon_sym_AMP_AMP] = ACTIONS(5341),
    [anon_sym_PIPE_PIPE] = ACTIONS(5341),
    [anon_sym_QMARK_QMARK] = ACTIONS(5341),
    [anon_sym_on] = ACTIONS(5341),
    [anon_sym_equals] = ACTIONS(5341),
    [anon_sym_by] = ACTIONS(5341),
    [anon_sym_as] = ACTIONS(5341),
    [anon_sym_is] = ACTIONS(5341),
    [anon_sym_DASH_GT] = ACTIONS(5341),
    [anon_sym_with] = ACTIONS(5341),
    [aux_sym_preproc_if_token3] = ACTIONS(5341),
    [aux_sym_preproc_else_token1] = ACTIONS(5341),
    [aux_sym_preproc_elif_token1] = ACTIONS(5341),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4223] = {
    [sym__name] = STATE(7759),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(9577),
    [sym_implicit_type] = STATE(8901),
    [sym_array_type] = STATE(8236),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(8217),
    [sym_pointer_type] = STATE(8217),
    [sym__pointer_base_type] = STATE(9650),
    [sym_function_pointer_type] = STATE(8217),
    [sym_function_pointer_parameter] = STATE(9350),
    [sym_ref_type] = STATE(8704),
    [sym__ref_base_type] = STATE(9351),
    [sym_scoped_type] = STATE(8704),
    [sym_tuple_type] = STATE(8136),
    [sym_identifier] = STATE(4921),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4223),
    [sym_preproc_endregion] = STATE(4223),
    [sym_preproc_line] = STATE(4223),
    [sym_preproc_pragma] = STATE(4223),
    [sym_preproc_nullable] = STATE(4223),
    [sym_preproc_error] = STATE(4223),
    [sym_preproc_define] = STATE(4223),
    [sym_preproc_undef] = STATE(4223),
    [aux_sym_function_pointer_type_repeat1] = STATE(4464),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_LPAREN] = ACTIONS(2995),
    [anon_sym_ref] = ACTIONS(5882),
    [anon_sym_delegate] = ACTIONS(5659),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_in] = ACTIONS(5884),
    [anon_sym_out] = ACTIONS(5884),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(5886),
    [anon_sym_var] = ACTIONS(5284),
    [sym_predefined_type] = ACTIONS(5888),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4224] = {
    [sym_preproc_region] = STATE(4224),
    [sym_preproc_endregion] = STATE(4224),
    [sym_preproc_line] = STATE(4224),
    [sym_preproc_pragma] = STATE(4224),
    [sym_preproc_nullable] = STATE(4224),
    [sym_preproc_error] = STATE(4224),
    [sym_preproc_define] = STATE(4224),
    [sym_preproc_undef] = STATE(4224),
    [anon_sym_SEMI] = ACTIONS(5377),
    [anon_sym_LBRACK] = ACTIONS(5377),
    [anon_sym_COLON] = ACTIONS(5377),
    [anon_sym_COMMA] = ACTIONS(5377),
    [anon_sym_RBRACK] = ACTIONS(5377),
    [anon_sym_LPAREN] = ACTIONS(5377),
    [anon_sym_RPAREN] = ACTIONS(5377),
    [anon_sym_RBRACE] = ACTIONS(5377),
    [anon_sym_LT] = ACTIONS(5379),
    [anon_sym_GT] = ACTIONS(5379),
    [anon_sym_in] = ACTIONS(5377),
    [anon_sym_QMARK] = ACTIONS(5379),
    [anon_sym_BANG] = ACTIONS(5379),
    [anon_sym_PLUS_PLUS] = ACTIONS(5377),
    [anon_sym_DASH_DASH] = ACTIONS(5377),
    [anon_sym_PLUS] = ACTIONS(5379),
    [anon_sym_DASH] = ACTIONS(5379),
    [anon_sym_STAR] = ACTIONS(5377),
    [anon_sym_SLASH] = ACTIONS(5379),
    [anon_sym_PERCENT] = ACTIONS(5377),
    [anon_sym_CARET] = ACTIONS(5377),
    [anon_sym_PIPE] = ACTIONS(5379),
    [anon_sym_AMP] = ACTIONS(5379),
    [anon_sym_LT_LT] = ACTIONS(5377),
    [anon_sym_GT_GT] = ACTIONS(5379),
    [anon_sym_GT_GT_GT] = ACTIONS(5377),
    [anon_sym_EQ_EQ] = ACTIONS(5377),
    [anon_sym_BANG_EQ] = ACTIONS(5377),
    [anon_sym_GT_EQ] = ACTIONS(5377),
    [anon_sym_LT_EQ] = ACTIONS(5377),
    [anon_sym_DOT] = ACTIONS(5379),
    [anon_sym_EQ_GT] = ACTIONS(5377),
    [anon_sym_switch] = ACTIONS(5377),
    [anon_sym_when] = ACTIONS(5377),
    [anon_sym_DOT_DOT] = ACTIONS(5377),
    [anon_sym_and] = ACTIONS(5377),
    [anon_sym_or] = ACTIONS(5377),
    [anon_sym_AMP_AMP] = ACTIONS(5377),
    [anon_sym_PIPE_PIPE] = ACTIONS(5377),
    [anon_sym_QMARK_QMARK] = ACTIONS(5377),
    [anon_sym_on] = ACTIONS(5377),
    [anon_sym_equals] = ACTIONS(5377),
    [anon_sym_by] = ACTIONS(5377),
    [anon_sym_as] = ACTIONS(5377),
    [anon_sym_is] = ACTIONS(5377),
    [anon_sym_DASH_GT] = ACTIONS(5377),
    [anon_sym_with] = ACTIONS(5377),
    [aux_sym_preproc_if_token3] = ACTIONS(5377),
    [aux_sym_preproc_else_token1] = ACTIONS(5377),
    [aux_sym_preproc_elif_token1] = ACTIONS(5377),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4225] = {
    [sym__name] = STATE(7759),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(9580),
    [sym_implicit_type] = STATE(8901),
    [sym_array_type] = STATE(8236),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(8217),
    [sym_pointer_type] = STATE(8217),
    [sym__pointer_base_type] = STATE(9650),
    [sym_function_pointer_type] = STATE(8217),
    [sym_function_pointer_parameter] = STATE(9350),
    [sym_ref_type] = STATE(8704),
    [sym__ref_base_type] = STATE(9351),
    [sym_scoped_type] = STATE(8704),
    [sym_tuple_type] = STATE(8136),
    [sym_identifier] = STATE(4921),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4225),
    [sym_preproc_endregion] = STATE(4225),
    [sym_preproc_line] = STATE(4225),
    [sym_preproc_pragma] = STATE(4225),
    [sym_preproc_nullable] = STATE(4225),
    [sym_preproc_error] = STATE(4225),
    [sym_preproc_define] = STATE(4225),
    [sym_preproc_undef] = STATE(4225),
    [aux_sym_function_pointer_type_repeat1] = STATE(4223),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_LPAREN] = ACTIONS(2995),
    [anon_sym_ref] = ACTIONS(5882),
    [anon_sym_delegate] = ACTIONS(5659),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_in] = ACTIONS(5884),
    [anon_sym_out] = ACTIONS(5884),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(5886),
    [anon_sym_var] = ACTIONS(5284),
    [sym_predefined_type] = ACTIONS(5888),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4226] = {
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7106),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9044),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4226),
    [sym_preproc_endregion] = STATE(4226),
    [sym_preproc_line] = STATE(4226),
    [sym_preproc_pragma] = STATE(4226),
    [sym_preproc_nullable] = STATE(4226),
    [sym_preproc_error] = STATE(4226),
    [sym_preproc_define] = STATE(4226),
    [sym_preproc_undef] = STATE(4226),
    [aux_sym_lambda_expression_repeat1] = STATE(6864),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4227] = {
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7113),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9905),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4227),
    [sym_preproc_endregion] = STATE(4227),
    [sym_preproc_line] = STATE(4227),
    [sym_preproc_pragma] = STATE(4227),
    [sym_preproc_nullable] = STATE(4227),
    [sym_preproc_error] = STATE(4227),
    [sym_preproc_define] = STATE(4227),
    [sym_preproc_undef] = STATE(4227),
    [aux_sym_lambda_expression_repeat1] = STATE(6864),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(5892),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4228] = {
    [sym__name] = STATE(7759),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(9580),
    [sym_implicit_type] = STATE(8901),
    [sym_array_type] = STATE(8236),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(8217),
    [sym_pointer_type] = STATE(8217),
    [sym__pointer_base_type] = STATE(9650),
    [sym_function_pointer_type] = STATE(8217),
    [sym_function_pointer_parameter] = STATE(9350),
    [sym_ref_type] = STATE(8704),
    [sym__ref_base_type] = STATE(9351),
    [sym_scoped_type] = STATE(8704),
    [sym_tuple_type] = STATE(8136),
    [sym_identifier] = STATE(4921),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4228),
    [sym_preproc_endregion] = STATE(4228),
    [sym_preproc_line] = STATE(4228),
    [sym_preproc_pragma] = STATE(4228),
    [sym_preproc_nullable] = STATE(4228),
    [sym_preproc_error] = STATE(4228),
    [sym_preproc_define] = STATE(4228),
    [sym_preproc_undef] = STATE(4228),
    [aux_sym_function_pointer_type_repeat1] = STATE(4464),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_LPAREN] = ACTIONS(2995),
    [anon_sym_ref] = ACTIONS(5882),
    [anon_sym_delegate] = ACTIONS(5659),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_in] = ACTIONS(5884),
    [anon_sym_out] = ACTIONS(5884),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(5886),
    [anon_sym_var] = ACTIONS(5284),
    [sym_predefined_type] = ACTIONS(5888),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4229] = {
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7036),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9074),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4229),
    [sym_preproc_endregion] = STATE(4229),
    [sym_preproc_line] = STATE(4229),
    [sym_preproc_pragma] = STATE(4229),
    [sym_preproc_nullable] = STATE(4229),
    [sym_preproc_error] = STATE(4229),
    [sym_preproc_define] = STATE(4229),
    [sym_preproc_undef] = STATE(4229),
    [aux_sym_lambda_expression_repeat1] = STATE(6864),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(5896),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4230] = {
    [sym__name] = STATE(7759),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(9587),
    [sym_implicit_type] = STATE(8901),
    [sym_array_type] = STATE(8236),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(8217),
    [sym_pointer_type] = STATE(8217),
    [sym__pointer_base_type] = STATE(9650),
    [sym_function_pointer_type] = STATE(8217),
    [sym_function_pointer_parameter] = STATE(9350),
    [sym_ref_type] = STATE(8704),
    [sym__ref_base_type] = STATE(9351),
    [sym_scoped_type] = STATE(8704),
    [sym_tuple_type] = STATE(8136),
    [sym_identifier] = STATE(4921),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4230),
    [sym_preproc_endregion] = STATE(4230),
    [sym_preproc_line] = STATE(4230),
    [sym_preproc_pragma] = STATE(4230),
    [sym_preproc_nullable] = STATE(4230),
    [sym_preproc_error] = STATE(4230),
    [sym_preproc_define] = STATE(4230),
    [sym_preproc_undef] = STATE(4230),
    [aux_sym_function_pointer_type_repeat1] = STATE(4228),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_LPAREN] = ACTIONS(2995),
    [anon_sym_ref] = ACTIONS(5882),
    [anon_sym_delegate] = ACTIONS(5659),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_in] = ACTIONS(5884),
    [anon_sym_out] = ACTIONS(5884),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(5886),
    [anon_sym_var] = ACTIONS(5284),
    [sym_predefined_type] = ACTIONS(5888),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4231] = {
    [sym__name] = STATE(7759),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(9544),
    [sym_implicit_type] = STATE(8901),
    [sym_array_type] = STATE(8236),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(8217),
    [sym_pointer_type] = STATE(8217),
    [sym__pointer_base_type] = STATE(9650),
    [sym_function_pointer_type] = STATE(8217),
    [sym_function_pointer_parameter] = STATE(9350),
    [sym_ref_type] = STATE(8704),
    [sym__ref_base_type] = STATE(9351),
    [sym_scoped_type] = STATE(8704),
    [sym_tuple_type] = STATE(8136),
    [sym_identifier] = STATE(4921),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4231),
    [sym_preproc_endregion] = STATE(4231),
    [sym_preproc_line] = STATE(4231),
    [sym_preproc_pragma] = STATE(4231),
    [sym_preproc_nullable] = STATE(4231),
    [sym_preproc_error] = STATE(4231),
    [sym_preproc_define] = STATE(4231),
    [sym_preproc_undef] = STATE(4231),
    [aux_sym_function_pointer_type_repeat1] = STATE(4142),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_LPAREN] = ACTIONS(2995),
    [anon_sym_ref] = ACTIONS(5882),
    [anon_sym_delegate] = ACTIONS(5659),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_in] = ACTIONS(5884),
    [anon_sym_out] = ACTIONS(5884),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(5886),
    [anon_sym_var] = ACTIONS(5284),
    [sym_predefined_type] = ACTIONS(5888),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4232] = {
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(6943),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9589),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4232),
    [sym_preproc_endregion] = STATE(4232),
    [sym_preproc_line] = STATE(4232),
    [sym_preproc_pragma] = STATE(4232),
    [sym_preproc_nullable] = STATE(4232),
    [sym_preproc_error] = STATE(4232),
    [sym_preproc_define] = STATE(4232),
    [sym_preproc_undef] = STATE(4232),
    [aux_sym_lambda_expression_repeat1] = STATE(6864),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4233] = {
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7010),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9084),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4233),
    [sym_preproc_endregion] = STATE(4233),
    [sym_preproc_line] = STATE(4233),
    [sym_preproc_pragma] = STATE(4233),
    [sym_preproc_nullable] = STATE(4233),
    [sym_preproc_error] = STATE(4233),
    [sym_preproc_define] = STATE(4233),
    [sym_preproc_undef] = STATE(4233),
    [aux_sym_lambda_expression_repeat1] = STATE(6864),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4234] = {
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(6928),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9612),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4234),
    [sym_preproc_endregion] = STATE(4234),
    [sym_preproc_line] = STATE(4234),
    [sym_preproc_pragma] = STATE(4234),
    [sym_preproc_nullable] = STATE(4234),
    [sym_preproc_error] = STATE(4234),
    [sym_preproc_define] = STATE(4234),
    [sym_preproc_undef] = STATE(4234),
    [aux_sym_lambda_expression_repeat1] = STATE(6864),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(5890),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4235] = {
    [sym_preproc_region] = STATE(4235),
    [sym_preproc_endregion] = STATE(4235),
    [sym_preproc_line] = STATE(4235),
    [sym_preproc_pragma] = STATE(4235),
    [sym_preproc_nullable] = STATE(4235),
    [sym_preproc_error] = STATE(4235),
    [sym_preproc_define] = STATE(4235),
    [sym_preproc_undef] = STATE(4235),
    [anon_sym_SEMI] = ACTIONS(5333),
    [anon_sym_LBRACK] = ACTIONS(5333),
    [anon_sym_COLON] = ACTIONS(5333),
    [anon_sym_COMMA] = ACTIONS(5333),
    [anon_sym_RBRACK] = ACTIONS(5333),
    [anon_sym_LPAREN] = ACTIONS(5333),
    [anon_sym_RPAREN] = ACTIONS(5333),
    [anon_sym_RBRACE] = ACTIONS(5333),
    [anon_sym_LT] = ACTIONS(5335),
    [anon_sym_GT] = ACTIONS(5335),
    [anon_sym_in] = ACTIONS(5333),
    [anon_sym_QMARK] = ACTIONS(5335),
    [anon_sym_BANG] = ACTIONS(5335),
    [anon_sym_PLUS_PLUS] = ACTIONS(5333),
    [anon_sym_DASH_DASH] = ACTIONS(5333),
    [anon_sym_PLUS] = ACTIONS(5335),
    [anon_sym_DASH] = ACTIONS(5335),
    [anon_sym_STAR] = ACTIONS(5333),
    [anon_sym_SLASH] = ACTIONS(5335),
    [anon_sym_PERCENT] = ACTIONS(5333),
    [anon_sym_CARET] = ACTIONS(5333),
    [anon_sym_PIPE] = ACTIONS(5335),
    [anon_sym_AMP] = ACTIONS(5335),
    [anon_sym_LT_LT] = ACTIONS(5333),
    [anon_sym_GT_GT] = ACTIONS(5335),
    [anon_sym_GT_GT_GT] = ACTIONS(5333),
    [anon_sym_EQ_EQ] = ACTIONS(5333),
    [anon_sym_BANG_EQ] = ACTIONS(5333),
    [anon_sym_GT_EQ] = ACTIONS(5333),
    [anon_sym_LT_EQ] = ACTIONS(5333),
    [anon_sym_DOT] = ACTIONS(5335),
    [anon_sym_EQ_GT] = ACTIONS(5333),
    [anon_sym_switch] = ACTIONS(5333),
    [anon_sym_when] = ACTIONS(5333),
    [anon_sym_DOT_DOT] = ACTIONS(5333),
    [anon_sym_and] = ACTIONS(5333),
    [anon_sym_or] = ACTIONS(5333),
    [anon_sym_AMP_AMP] = ACTIONS(5333),
    [anon_sym_PIPE_PIPE] = ACTIONS(5333),
    [anon_sym_QMARK_QMARK] = ACTIONS(5333),
    [anon_sym_on] = ACTIONS(5333),
    [anon_sym_equals] = ACTIONS(5333),
    [anon_sym_by] = ACTIONS(5333),
    [anon_sym_as] = ACTIONS(5333),
    [anon_sym_is] = ACTIONS(5333),
    [anon_sym_DASH_GT] = ACTIONS(5333),
    [anon_sym_with] = ACTIONS(5333),
    [aux_sym_preproc_if_token3] = ACTIONS(5333),
    [aux_sym_preproc_else_token1] = ACTIONS(5333),
    [aux_sym_preproc_elif_token1] = ACTIONS(5333),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4236] = {
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7120),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9682),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4236),
    [sym_preproc_endregion] = STATE(4236),
    [sym_preproc_line] = STATE(4236),
    [sym_preproc_pragma] = STATE(4236),
    [sym_preproc_nullable] = STATE(4236),
    [sym_preproc_error] = STATE(4236),
    [sym_preproc_define] = STATE(4236),
    [sym_preproc_undef] = STATE(4236),
    [aux_sym_lambda_expression_repeat1] = STATE(6864),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(5896),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4237] = {
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7099),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9617),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4237),
    [sym_preproc_endregion] = STATE(4237),
    [sym_preproc_line] = STATE(4237),
    [sym_preproc_pragma] = STATE(4237),
    [sym_preproc_nullable] = STATE(4237),
    [sym_preproc_error] = STATE(4237),
    [sym_preproc_define] = STATE(4237),
    [sym_preproc_undef] = STATE(4237),
    [aux_sym_lambda_expression_repeat1] = STATE(6864),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4238] = {
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(6940),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9921),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4238),
    [sym_preproc_endregion] = STATE(4238),
    [sym_preproc_line] = STATE(4238),
    [sym_preproc_pragma] = STATE(4238),
    [sym_preproc_nullable] = STATE(4238),
    [sym_preproc_error] = STATE(4238),
    [sym_preproc_define] = STATE(4238),
    [sym_preproc_undef] = STATE(4238),
    [aux_sym_lambda_expression_repeat1] = STATE(6864),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4239] = {
    [sym_preproc_region] = STATE(4239),
    [sym_preproc_endregion] = STATE(4239),
    [sym_preproc_line] = STATE(4239),
    [sym_preproc_pragma] = STATE(4239),
    [sym_preproc_nullable] = STATE(4239),
    [sym_preproc_error] = STATE(4239),
    [sym_preproc_define] = STATE(4239),
    [sym_preproc_undef] = STATE(4239),
    [anon_sym_SEMI] = ACTIONS(5448),
    [anon_sym_LBRACK] = ACTIONS(5448),
    [anon_sym_COLON] = ACTIONS(5448),
    [anon_sym_COMMA] = ACTIONS(5448),
    [anon_sym_RBRACK] = ACTIONS(5448),
    [anon_sym_LPAREN] = ACTIONS(5448),
    [anon_sym_RPAREN] = ACTIONS(5448),
    [anon_sym_RBRACE] = ACTIONS(5448),
    [anon_sym_LT] = ACTIONS(5450),
    [anon_sym_GT] = ACTIONS(5450),
    [anon_sym_in] = ACTIONS(5448),
    [anon_sym_QMARK] = ACTIONS(5450),
    [anon_sym_BANG] = ACTIONS(5450),
    [anon_sym_PLUS_PLUS] = ACTIONS(5448),
    [anon_sym_DASH_DASH] = ACTIONS(5448),
    [anon_sym_PLUS] = ACTIONS(5450),
    [anon_sym_DASH] = ACTIONS(5450),
    [anon_sym_STAR] = ACTIONS(5448),
    [anon_sym_SLASH] = ACTIONS(5450),
    [anon_sym_PERCENT] = ACTIONS(5448),
    [anon_sym_CARET] = ACTIONS(5448),
    [anon_sym_PIPE] = ACTIONS(5450),
    [anon_sym_AMP] = ACTIONS(5450),
    [anon_sym_LT_LT] = ACTIONS(5448),
    [anon_sym_GT_GT] = ACTIONS(5450),
    [anon_sym_GT_GT_GT] = ACTIONS(5448),
    [anon_sym_EQ_EQ] = ACTIONS(5448),
    [anon_sym_BANG_EQ] = ACTIONS(5448),
    [anon_sym_GT_EQ] = ACTIONS(5448),
    [anon_sym_LT_EQ] = ACTIONS(5448),
    [anon_sym_DOT] = ACTIONS(5450),
    [anon_sym_EQ_GT] = ACTIONS(5448),
    [anon_sym_switch] = ACTIONS(5448),
    [anon_sym_when] = ACTIONS(5448),
    [anon_sym_DOT_DOT] = ACTIONS(5448),
    [anon_sym_and] = ACTIONS(5448),
    [anon_sym_or] = ACTIONS(5448),
    [anon_sym_AMP_AMP] = ACTIONS(5448),
    [anon_sym_PIPE_PIPE] = ACTIONS(5448),
    [anon_sym_QMARK_QMARK] = ACTIONS(5448),
    [anon_sym_on] = ACTIONS(5448),
    [anon_sym_equals] = ACTIONS(5448),
    [anon_sym_by] = ACTIONS(5448),
    [anon_sym_as] = ACTIONS(5448),
    [anon_sym_is] = ACTIONS(5448),
    [anon_sym_DASH_GT] = ACTIONS(5448),
    [anon_sym_with] = ACTIONS(5448),
    [aux_sym_preproc_if_token3] = ACTIONS(5448),
    [aux_sym_preproc_else_token1] = ACTIONS(5448),
    [aux_sym_preproc_elif_token1] = ACTIONS(5448),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4240] = {
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7071),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9887),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4240),
    [sym_preproc_endregion] = STATE(4240),
    [sym_preproc_line] = STATE(4240),
    [sym_preproc_pragma] = STATE(4240),
    [sym_preproc_nullable] = STATE(4240),
    [sym_preproc_error] = STATE(4240),
    [sym_preproc_define] = STATE(4240),
    [sym_preproc_undef] = STATE(4240),
    [aux_sym_lambda_expression_repeat1] = STATE(6864),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4241] = {
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(6923),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9111),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4241),
    [sym_preproc_endregion] = STATE(4241),
    [sym_preproc_line] = STATE(4241),
    [sym_preproc_pragma] = STATE(4241),
    [sym_preproc_nullable] = STATE(4241),
    [sym_preproc_error] = STATE(4241),
    [sym_preproc_define] = STATE(4241),
    [sym_preproc_undef] = STATE(4241),
    [aux_sym_lambda_expression_repeat1] = STATE(6864),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(5896),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4242] = {
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7037),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9492),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4242),
    [sym_preproc_endregion] = STATE(4242),
    [sym_preproc_line] = STATE(4242),
    [sym_preproc_pragma] = STATE(4242),
    [sym_preproc_nullable] = STATE(4242),
    [sym_preproc_error] = STATE(4242),
    [sym_preproc_define] = STATE(4242),
    [sym_preproc_undef] = STATE(4242),
    [aux_sym_lambda_expression_repeat1] = STATE(6864),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(5898),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4243] = {
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(6970),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9119),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4243),
    [sym_preproc_endregion] = STATE(4243),
    [sym_preproc_line] = STATE(4243),
    [sym_preproc_pragma] = STATE(4243),
    [sym_preproc_nullable] = STATE(4243),
    [sym_preproc_error] = STATE(4243),
    [sym_preproc_define] = STATE(4243),
    [sym_preproc_undef] = STATE(4243),
    [aux_sym_lambda_expression_repeat1] = STATE(6864),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4244] = {
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7019),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9139),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4244),
    [sym_preproc_endregion] = STATE(4244),
    [sym_preproc_line] = STATE(4244),
    [sym_preproc_pragma] = STATE(4244),
    [sym_preproc_nullable] = STATE(4244),
    [sym_preproc_error] = STATE(4244),
    [sym_preproc_define] = STATE(4244),
    [sym_preproc_undef] = STATE(4244),
    [aux_sym_lambda_expression_repeat1] = STATE(6864),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(5896),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4245] = {
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7128),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9593),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4245),
    [sym_preproc_endregion] = STATE(4245),
    [sym_preproc_line] = STATE(4245),
    [sym_preproc_pragma] = STATE(4245),
    [sym_preproc_nullable] = STATE(4245),
    [sym_preproc_error] = STATE(4245),
    [sym_preproc_define] = STATE(4245),
    [sym_preproc_undef] = STATE(4245),
    [aux_sym_lambda_expression_repeat1] = STATE(6864),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(5898),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4246] = {
    [sym_preproc_region] = STATE(4246),
    [sym_preproc_endregion] = STATE(4246),
    [sym_preproc_line] = STATE(4246),
    [sym_preproc_pragma] = STATE(4246),
    [sym_preproc_nullable] = STATE(4246),
    [sym_preproc_error] = STATE(4246),
    [sym_preproc_define] = STATE(4246),
    [sym_preproc_undef] = STATE(4246),
    [anon_sym_SEMI] = ACTIONS(5838),
    [anon_sym_LBRACK] = ACTIONS(5838),
    [anon_sym_COLON] = ACTIONS(5838),
    [anon_sym_COMMA] = ACTIONS(5838),
    [anon_sym_RBRACK] = ACTIONS(5838),
    [anon_sym_LPAREN] = ACTIONS(5838),
    [anon_sym_RPAREN] = ACTIONS(5838),
    [anon_sym_RBRACE] = ACTIONS(5838),
    [anon_sym_LT] = ACTIONS(5840),
    [anon_sym_GT] = ACTIONS(5840),
    [anon_sym_in] = ACTIONS(5838),
    [anon_sym_QMARK] = ACTIONS(5840),
    [anon_sym_BANG] = ACTIONS(5840),
    [anon_sym_PLUS_PLUS] = ACTIONS(5838),
    [anon_sym_DASH_DASH] = ACTIONS(5838),
    [anon_sym_PLUS] = ACTIONS(5840),
    [anon_sym_DASH] = ACTIONS(5840),
    [anon_sym_STAR] = ACTIONS(5838),
    [anon_sym_SLASH] = ACTIONS(5840),
    [anon_sym_PERCENT] = ACTIONS(5838),
    [anon_sym_CARET] = ACTIONS(5838),
    [anon_sym_PIPE] = ACTIONS(5840),
    [anon_sym_AMP] = ACTIONS(5840),
    [anon_sym_LT_LT] = ACTIONS(5838),
    [anon_sym_GT_GT] = ACTIONS(5840),
    [anon_sym_GT_GT_GT] = ACTIONS(5838),
    [anon_sym_EQ_EQ] = ACTIONS(5838),
    [anon_sym_BANG_EQ] = ACTIONS(5838),
    [anon_sym_GT_EQ] = ACTIONS(5838),
    [anon_sym_LT_EQ] = ACTIONS(5838),
    [anon_sym_DOT] = ACTIONS(5840),
    [anon_sym_EQ_GT] = ACTIONS(5838),
    [anon_sym_switch] = ACTIONS(5838),
    [anon_sym_when] = ACTIONS(5838),
    [anon_sym_DOT_DOT] = ACTIONS(5838),
    [anon_sym_and] = ACTIONS(5838),
    [anon_sym_or] = ACTIONS(5838),
    [anon_sym_AMP_AMP] = ACTIONS(5838),
    [anon_sym_PIPE_PIPE] = ACTIONS(5838),
    [anon_sym_QMARK_QMARK] = ACTIONS(5838),
    [anon_sym_on] = ACTIONS(5838),
    [anon_sym_equals] = ACTIONS(5838),
    [anon_sym_by] = ACTIONS(5838),
    [anon_sym_as] = ACTIONS(5838),
    [anon_sym_is] = ACTIONS(5838),
    [anon_sym_DASH_GT] = ACTIONS(5838),
    [anon_sym_with] = ACTIONS(5838),
    [aux_sym_preproc_if_token3] = ACTIONS(5838),
    [aux_sym_preproc_else_token1] = ACTIONS(5838),
    [aux_sym_preproc_elif_token1] = ACTIONS(5838),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4247] = {
    [sym_preproc_region] = STATE(4247),
    [sym_preproc_endregion] = STATE(4247),
    [sym_preproc_line] = STATE(4247),
    [sym_preproc_pragma] = STATE(4247),
    [sym_preproc_nullable] = STATE(4247),
    [sym_preproc_error] = STATE(4247),
    [sym_preproc_define] = STATE(4247),
    [sym_preproc_undef] = STATE(4247),
    [anon_sym_SEMI] = ACTIONS(5478),
    [anon_sym_LBRACK] = ACTIONS(5478),
    [anon_sym_COLON] = ACTIONS(5478),
    [anon_sym_COMMA] = ACTIONS(5478),
    [anon_sym_RBRACK] = ACTIONS(5478),
    [anon_sym_LPAREN] = ACTIONS(5478),
    [anon_sym_RPAREN] = ACTIONS(5478),
    [anon_sym_RBRACE] = ACTIONS(5478),
    [anon_sym_LT] = ACTIONS(5480),
    [anon_sym_GT] = ACTIONS(5480),
    [anon_sym_in] = ACTIONS(5478),
    [anon_sym_QMARK] = ACTIONS(5480),
    [anon_sym_BANG] = ACTIONS(5480),
    [anon_sym_PLUS_PLUS] = ACTIONS(5478),
    [anon_sym_DASH_DASH] = ACTIONS(5478),
    [anon_sym_PLUS] = ACTIONS(5480),
    [anon_sym_DASH] = ACTIONS(5480),
    [anon_sym_STAR] = ACTIONS(5478),
    [anon_sym_SLASH] = ACTIONS(5480),
    [anon_sym_PERCENT] = ACTIONS(5478),
    [anon_sym_CARET] = ACTIONS(5478),
    [anon_sym_PIPE] = ACTIONS(5480),
    [anon_sym_AMP] = ACTIONS(5480),
    [anon_sym_LT_LT] = ACTIONS(5478),
    [anon_sym_GT_GT] = ACTIONS(5480),
    [anon_sym_GT_GT_GT] = ACTIONS(5478),
    [anon_sym_EQ_EQ] = ACTIONS(5478),
    [anon_sym_BANG_EQ] = ACTIONS(5478),
    [anon_sym_GT_EQ] = ACTIONS(5478),
    [anon_sym_LT_EQ] = ACTIONS(5478),
    [anon_sym_DOT] = ACTIONS(5480),
    [anon_sym_EQ_GT] = ACTIONS(5478),
    [anon_sym_switch] = ACTIONS(5478),
    [anon_sym_when] = ACTIONS(5478),
    [anon_sym_DOT_DOT] = ACTIONS(5478),
    [anon_sym_and] = ACTIONS(5478),
    [anon_sym_or] = ACTIONS(5478),
    [anon_sym_AMP_AMP] = ACTIONS(5478),
    [anon_sym_PIPE_PIPE] = ACTIONS(5478),
    [anon_sym_QMARK_QMARK] = ACTIONS(5478),
    [anon_sym_on] = ACTIONS(5478),
    [anon_sym_equals] = ACTIONS(5478),
    [anon_sym_by] = ACTIONS(5478),
    [anon_sym_as] = ACTIONS(5478),
    [anon_sym_is] = ACTIONS(5478),
    [anon_sym_DASH_GT] = ACTIONS(5478),
    [anon_sym_with] = ACTIONS(5478),
    [aux_sym_preproc_if_token3] = ACTIONS(5478),
    [aux_sym_preproc_else_token1] = ACTIONS(5478),
    [aux_sym_preproc_elif_token1] = ACTIONS(5478),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4248] = {
    [sym_preproc_region] = STATE(4248),
    [sym_preproc_endregion] = STATE(4248),
    [sym_preproc_line] = STATE(4248),
    [sym_preproc_pragma] = STATE(4248),
    [sym_preproc_nullable] = STATE(4248),
    [sym_preproc_error] = STATE(4248),
    [sym_preproc_define] = STATE(4248),
    [sym_preproc_undef] = STATE(4248),
    [anon_sym_EQ] = ACTIONS(5948),
    [anon_sym_LBRACK] = ACTIONS(5249),
    [anon_sym_LPAREN] = ACTIONS(5249),
    [anon_sym_LT] = ACTIONS(5251),
    [anon_sym_GT] = ACTIONS(5251),
    [anon_sym_QMARK] = ACTIONS(5251),
    [anon_sym_BANG] = ACTIONS(5251),
    [anon_sym_PLUS_PLUS] = ACTIONS(5249),
    [anon_sym_DASH_DASH] = ACTIONS(5249),
    [anon_sym_PLUS] = ACTIONS(5251),
    [anon_sym_DASH] = ACTIONS(5251),
    [anon_sym_STAR] = ACTIONS(5251),
    [anon_sym_SLASH] = ACTIONS(5251),
    [anon_sym_PERCENT] = ACTIONS(5251),
    [anon_sym_CARET] = ACTIONS(5251),
    [anon_sym_PIPE] = ACTIONS(5251),
    [anon_sym_AMP] = ACTIONS(5251),
    [anon_sym_LT_LT] = ACTIONS(5251),
    [anon_sym_GT_GT] = ACTIONS(5251),
    [anon_sym_GT_GT_GT] = ACTIONS(5251),
    [anon_sym_EQ_EQ] = ACTIONS(5249),
    [anon_sym_BANG_EQ] = ACTIONS(5249),
    [anon_sym_GT_EQ] = ACTIONS(5249),
    [anon_sym_LT_EQ] = ACTIONS(5249),
    [anon_sym_DOT] = ACTIONS(5251),
    [anon_sym_switch] = ACTIONS(5249),
    [anon_sym_DOT_DOT] = ACTIONS(5249),
    [anon_sym_and] = ACTIONS(5249),
    [anon_sym_or] = ACTIONS(5249),
    [anon_sym_PLUS_EQ] = ACTIONS(5950),
    [anon_sym_DASH_EQ] = ACTIONS(5950),
    [anon_sym_STAR_EQ] = ACTIONS(5950),
    [anon_sym_SLASH_EQ] = ACTIONS(5950),
    [anon_sym_PERCENT_EQ] = ACTIONS(5950),
    [anon_sym_AMP_EQ] = ACTIONS(5950),
    [anon_sym_CARET_EQ] = ACTIONS(5950),
    [anon_sym_PIPE_EQ] = ACTIONS(5950),
    [anon_sym_LT_LT_EQ] = ACTIONS(5950),
    [anon_sym_GT_GT_EQ] = ACTIONS(5950),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5950),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(5950),
    [anon_sym_AMP_AMP] = ACTIONS(5249),
    [anon_sym_PIPE_PIPE] = ACTIONS(5249),
    [anon_sym_QMARK_QMARK] = ACTIONS(5251),
    [anon_sym_into] = ACTIONS(5249),
    [anon_sym_equals] = ACTIONS(5249),
    [anon_sym_as] = ACTIONS(5249),
    [anon_sym_is] = ACTIONS(5249),
    [anon_sym_DASH_GT] = ACTIONS(5249),
    [anon_sym_with] = ACTIONS(5249),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4249] = {
    [sym_preproc_region] = STATE(4249),
    [sym_preproc_endregion] = STATE(4249),
    [sym_preproc_line] = STATE(4249),
    [sym_preproc_pragma] = STATE(4249),
    [sym_preproc_nullable] = STATE(4249),
    [sym_preproc_error] = STATE(4249),
    [sym_preproc_define] = STATE(4249),
    [sym_preproc_undef] = STATE(4249),
    [anon_sym_SEMI] = ACTIONS(5486),
    [anon_sym_LBRACK] = ACTIONS(5486),
    [anon_sym_COLON] = ACTIONS(5486),
    [anon_sym_COMMA] = ACTIONS(5486),
    [anon_sym_RBRACK] = ACTIONS(5486),
    [anon_sym_LPAREN] = ACTIONS(5486),
    [anon_sym_RPAREN] = ACTIONS(5486),
    [anon_sym_RBRACE] = ACTIONS(5486),
    [anon_sym_LT] = ACTIONS(5488),
    [anon_sym_GT] = ACTIONS(5488),
    [anon_sym_in] = ACTIONS(5486),
    [anon_sym_QMARK] = ACTIONS(5488),
    [anon_sym_BANG] = ACTIONS(5488),
    [anon_sym_PLUS_PLUS] = ACTIONS(5486),
    [anon_sym_DASH_DASH] = ACTIONS(5486),
    [anon_sym_PLUS] = ACTIONS(5488),
    [anon_sym_DASH] = ACTIONS(5488),
    [anon_sym_STAR] = ACTIONS(5486),
    [anon_sym_SLASH] = ACTIONS(5488),
    [anon_sym_PERCENT] = ACTIONS(5486),
    [anon_sym_CARET] = ACTIONS(5486),
    [anon_sym_PIPE] = ACTIONS(5488),
    [anon_sym_AMP] = ACTIONS(5488),
    [anon_sym_LT_LT] = ACTIONS(5486),
    [anon_sym_GT_GT] = ACTIONS(5488),
    [anon_sym_GT_GT_GT] = ACTIONS(5486),
    [anon_sym_EQ_EQ] = ACTIONS(5486),
    [anon_sym_BANG_EQ] = ACTIONS(5486),
    [anon_sym_GT_EQ] = ACTIONS(5486),
    [anon_sym_LT_EQ] = ACTIONS(5486),
    [anon_sym_DOT] = ACTIONS(5488),
    [anon_sym_EQ_GT] = ACTIONS(5486),
    [anon_sym_switch] = ACTIONS(5486),
    [anon_sym_when] = ACTIONS(5486),
    [anon_sym_DOT_DOT] = ACTIONS(5486),
    [anon_sym_and] = ACTIONS(5486),
    [anon_sym_or] = ACTIONS(5486),
    [anon_sym_AMP_AMP] = ACTIONS(5486),
    [anon_sym_PIPE_PIPE] = ACTIONS(5486),
    [anon_sym_QMARK_QMARK] = ACTIONS(5486),
    [anon_sym_on] = ACTIONS(5486),
    [anon_sym_equals] = ACTIONS(5486),
    [anon_sym_by] = ACTIONS(5486),
    [anon_sym_as] = ACTIONS(5486),
    [anon_sym_is] = ACTIONS(5486),
    [anon_sym_DASH_GT] = ACTIONS(5486),
    [anon_sym_with] = ACTIONS(5486),
    [aux_sym_preproc_if_token3] = ACTIONS(5486),
    [aux_sym_preproc_else_token1] = ACTIONS(5486),
    [aux_sym_preproc_elif_token1] = ACTIONS(5486),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4250] = {
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7054),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9081),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4250),
    [sym_preproc_endregion] = STATE(4250),
    [sym_preproc_line] = STATE(4250),
    [sym_preproc_pragma] = STATE(4250),
    [sym_preproc_nullable] = STATE(4250),
    [sym_preproc_error] = STATE(4250),
    [sym_preproc_define] = STATE(4250),
    [sym_preproc_undef] = STATE(4250),
    [aux_sym_lambda_expression_repeat1] = STATE(6864),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(5896),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4251] = {
    [sym_preproc_region] = STATE(4251),
    [sym_preproc_endregion] = STATE(4251),
    [sym_preproc_line] = STATE(4251),
    [sym_preproc_pragma] = STATE(4251),
    [sym_preproc_nullable] = STATE(4251),
    [sym_preproc_error] = STATE(4251),
    [sym_preproc_define] = STATE(4251),
    [sym_preproc_undef] = STATE(4251),
    [anon_sym_SEMI] = ACTIONS(5249),
    [anon_sym_LBRACK] = ACTIONS(5249),
    [anon_sym_COLON] = ACTIONS(5249),
    [anon_sym_COMMA] = ACTIONS(5249),
    [anon_sym_RBRACK] = ACTIONS(5249),
    [anon_sym_LPAREN] = ACTIONS(5249),
    [anon_sym_RPAREN] = ACTIONS(5249),
    [anon_sym_RBRACE] = ACTIONS(5249),
    [anon_sym_LT] = ACTIONS(5251),
    [anon_sym_GT] = ACTIONS(5251),
    [anon_sym_in] = ACTIONS(5249),
    [anon_sym_QMARK] = ACTIONS(5251),
    [anon_sym_BANG] = ACTIONS(5251),
    [anon_sym_PLUS_PLUS] = ACTIONS(5249),
    [anon_sym_DASH_DASH] = ACTIONS(5249),
    [anon_sym_PLUS] = ACTIONS(5251),
    [anon_sym_DASH] = ACTIONS(5251),
    [anon_sym_STAR] = ACTIONS(5249),
    [anon_sym_SLASH] = ACTIONS(5251),
    [anon_sym_PERCENT] = ACTIONS(5249),
    [anon_sym_CARET] = ACTIONS(5249),
    [anon_sym_PIPE] = ACTIONS(5251),
    [anon_sym_AMP] = ACTIONS(5251),
    [anon_sym_LT_LT] = ACTIONS(5249),
    [anon_sym_GT_GT] = ACTIONS(5251),
    [anon_sym_GT_GT_GT] = ACTIONS(5249),
    [anon_sym_EQ_EQ] = ACTIONS(5249),
    [anon_sym_BANG_EQ] = ACTIONS(5249),
    [anon_sym_GT_EQ] = ACTIONS(5249),
    [anon_sym_LT_EQ] = ACTIONS(5249),
    [anon_sym_DOT] = ACTIONS(5251),
    [anon_sym_EQ_GT] = ACTIONS(5249),
    [anon_sym_switch] = ACTIONS(5249),
    [anon_sym_when] = ACTIONS(5249),
    [anon_sym_DOT_DOT] = ACTIONS(5249),
    [anon_sym_and] = ACTIONS(5249),
    [anon_sym_or] = ACTIONS(5249),
    [anon_sym_AMP_AMP] = ACTIONS(5249),
    [anon_sym_PIPE_PIPE] = ACTIONS(5249),
    [anon_sym_QMARK_QMARK] = ACTIONS(5249),
    [anon_sym_on] = ACTIONS(5249),
    [anon_sym_equals] = ACTIONS(5249),
    [anon_sym_by] = ACTIONS(5249),
    [anon_sym_as] = ACTIONS(5249),
    [anon_sym_is] = ACTIONS(5249),
    [anon_sym_DASH_GT] = ACTIONS(5249),
    [anon_sym_with] = ACTIONS(5249),
    [aux_sym_preproc_if_token3] = ACTIONS(5249),
    [aux_sym_preproc_else_token1] = ACTIONS(5249),
    [aux_sym_preproc_elif_token1] = ACTIONS(5249),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4252] = {
    [sym_preproc_region] = STATE(4252),
    [sym_preproc_endregion] = STATE(4252),
    [sym_preproc_line] = STATE(4252),
    [sym_preproc_pragma] = STATE(4252),
    [sym_preproc_nullable] = STATE(4252),
    [sym_preproc_error] = STATE(4252),
    [sym_preproc_define] = STATE(4252),
    [sym_preproc_undef] = STATE(4252),
    [anon_sym_SEMI] = ACTIONS(1943),
    [anon_sym_LBRACK] = ACTIONS(1943),
    [anon_sym_COLON] = ACTIONS(1943),
    [anon_sym_COMMA] = ACTIONS(1943),
    [anon_sym_RBRACK] = ACTIONS(1943),
    [anon_sym_LPAREN] = ACTIONS(5952),
    [anon_sym_RPAREN] = ACTIONS(1943),
    [anon_sym_RBRACE] = ACTIONS(1943),
    [anon_sym_LT] = ACTIONS(1941),
    [anon_sym_GT] = ACTIONS(1941),
    [anon_sym_in] = ACTIONS(1943),
    [anon_sym_QMARK] = ACTIONS(1941),
    [anon_sym_BANG] = ACTIONS(1941),
    [anon_sym_PLUS_PLUS] = ACTIONS(1943),
    [anon_sym_DASH_DASH] = ACTIONS(1943),
    [anon_sym_PLUS] = ACTIONS(1941),
    [anon_sym_DASH] = ACTIONS(1941),
    [anon_sym_STAR] = ACTIONS(1943),
    [anon_sym_SLASH] = ACTIONS(1941),
    [anon_sym_PERCENT] = ACTIONS(1943),
    [anon_sym_CARET] = ACTIONS(1943),
    [anon_sym_PIPE] = ACTIONS(1941),
    [anon_sym_AMP] = ACTIONS(1941),
    [anon_sym_LT_LT] = ACTIONS(1943),
    [anon_sym_GT_GT] = ACTIONS(1941),
    [anon_sym_GT_GT_GT] = ACTIONS(1943),
    [anon_sym_EQ_EQ] = ACTIONS(1943),
    [anon_sym_BANG_EQ] = ACTIONS(1943),
    [anon_sym_GT_EQ] = ACTIONS(1943),
    [anon_sym_LT_EQ] = ACTIONS(1943),
    [anon_sym_DOT] = ACTIONS(1941),
    [anon_sym_EQ_GT] = ACTIONS(1943),
    [anon_sym_switch] = ACTIONS(1943),
    [anon_sym_when] = ACTIONS(1943),
    [anon_sym_DOT_DOT] = ACTIONS(1943),
    [anon_sym_and] = ACTIONS(1943),
    [anon_sym_or] = ACTIONS(1943),
    [anon_sym_AMP_AMP] = ACTIONS(1943),
    [anon_sym_PIPE_PIPE] = ACTIONS(1943),
    [anon_sym_QMARK_QMARK] = ACTIONS(1943),
    [anon_sym_on] = ACTIONS(1943),
    [anon_sym_equals] = ACTIONS(1943),
    [anon_sym_by] = ACTIONS(1943),
    [anon_sym_as] = ACTIONS(1943),
    [anon_sym_is] = ACTIONS(1943),
    [anon_sym_DASH_GT] = ACTIONS(1943),
    [anon_sym_with] = ACTIONS(1943),
    [aux_sym_preproc_if_token3] = ACTIONS(1943),
    [aux_sym_preproc_else_token1] = ACTIONS(1943),
    [aux_sym_preproc_elif_token1] = ACTIONS(1943),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4253] = {
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7031),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9147),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4253),
    [sym_preproc_endregion] = STATE(4253),
    [sym_preproc_line] = STATE(4253),
    [sym_preproc_pragma] = STATE(4253),
    [sym_preproc_nullable] = STATE(4253),
    [sym_preproc_error] = STATE(4253),
    [sym_preproc_define] = STATE(4253),
    [sym_preproc_undef] = STATE(4253),
    [aux_sym_lambda_expression_repeat1] = STATE(6864),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4254] = {
    [sym_preproc_region] = STATE(4254),
    [sym_preproc_endregion] = STATE(4254),
    [sym_preproc_line] = STATE(4254),
    [sym_preproc_pragma] = STATE(4254),
    [sym_preproc_nullable] = STATE(4254),
    [sym_preproc_error] = STATE(4254),
    [sym_preproc_define] = STATE(4254),
    [sym_preproc_undef] = STATE(4254),
    [anon_sym_SEMI] = ACTIONS(5850),
    [anon_sym_LBRACK] = ACTIONS(5850),
    [anon_sym_COLON] = ACTIONS(5850),
    [anon_sym_COMMA] = ACTIONS(5850),
    [anon_sym_RBRACK] = ACTIONS(5850),
    [anon_sym_LPAREN] = ACTIONS(5850),
    [anon_sym_RPAREN] = ACTIONS(5850),
    [anon_sym_RBRACE] = ACTIONS(5850),
    [anon_sym_LT] = ACTIONS(5852),
    [anon_sym_GT] = ACTIONS(5852),
    [anon_sym_in] = ACTIONS(5850),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_BANG] = ACTIONS(5852),
    [anon_sym_PLUS_PLUS] = ACTIONS(5850),
    [anon_sym_DASH_DASH] = ACTIONS(5850),
    [anon_sym_PLUS] = ACTIONS(5852),
    [anon_sym_DASH] = ACTIONS(5852),
    [anon_sym_STAR] = ACTIONS(5850),
    [anon_sym_SLASH] = ACTIONS(5852),
    [anon_sym_PERCENT] = ACTIONS(5850),
    [anon_sym_CARET] = ACTIONS(5850),
    [anon_sym_PIPE] = ACTIONS(5852),
    [anon_sym_AMP] = ACTIONS(5852),
    [anon_sym_LT_LT] = ACTIONS(5850),
    [anon_sym_GT_GT] = ACTIONS(5852),
    [anon_sym_GT_GT_GT] = ACTIONS(5850),
    [anon_sym_EQ_EQ] = ACTIONS(5850),
    [anon_sym_BANG_EQ] = ACTIONS(5850),
    [anon_sym_GT_EQ] = ACTIONS(5850),
    [anon_sym_LT_EQ] = ACTIONS(5850),
    [anon_sym_DOT] = ACTIONS(5852),
    [anon_sym_EQ_GT] = ACTIONS(5850),
    [anon_sym_switch] = ACTIONS(5850),
    [anon_sym_when] = ACTIONS(5850),
    [anon_sym_DOT_DOT] = ACTIONS(5850),
    [anon_sym_and] = ACTIONS(5850),
    [anon_sym_or] = ACTIONS(5850),
    [anon_sym_AMP_AMP] = ACTIONS(5850),
    [anon_sym_PIPE_PIPE] = ACTIONS(5850),
    [anon_sym_QMARK_QMARK] = ACTIONS(5850),
    [anon_sym_on] = ACTIONS(5850),
    [anon_sym_equals] = ACTIONS(5850),
    [anon_sym_by] = ACTIONS(5850),
    [anon_sym_as] = ACTIONS(5850),
    [anon_sym_is] = ACTIONS(5850),
    [anon_sym_DASH_GT] = ACTIONS(5850),
    [anon_sym_with] = ACTIONS(5850),
    [aux_sym_preproc_if_token3] = ACTIONS(5850),
    [aux_sym_preproc_else_token1] = ACTIONS(5850),
    [aux_sym_preproc_elif_token1] = ACTIONS(5850),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4255] = {
    [sym_preproc_region] = STATE(4255),
    [sym_preproc_endregion] = STATE(4255),
    [sym_preproc_line] = STATE(4255),
    [sym_preproc_pragma] = STATE(4255),
    [sym_preproc_nullable] = STATE(4255),
    [sym_preproc_error] = STATE(4255),
    [sym_preproc_define] = STATE(4255),
    [sym_preproc_undef] = STATE(4255),
    [anon_sym_SEMI] = ACTIONS(5568),
    [anon_sym_LBRACK] = ACTIONS(5568),
    [anon_sym_COLON] = ACTIONS(5568),
    [anon_sym_COMMA] = ACTIONS(5568),
    [anon_sym_RBRACK] = ACTIONS(5568),
    [anon_sym_LPAREN] = ACTIONS(5568),
    [anon_sym_RPAREN] = ACTIONS(5568),
    [anon_sym_RBRACE] = ACTIONS(5568),
    [anon_sym_LT] = ACTIONS(5570),
    [anon_sym_GT] = ACTIONS(5570),
    [anon_sym_in] = ACTIONS(5568),
    [anon_sym_QMARK] = ACTIONS(5570),
    [anon_sym_BANG] = ACTIONS(5570),
    [anon_sym_PLUS_PLUS] = ACTIONS(5568),
    [anon_sym_DASH_DASH] = ACTIONS(5568),
    [anon_sym_PLUS] = ACTIONS(5570),
    [anon_sym_DASH] = ACTIONS(5570),
    [anon_sym_STAR] = ACTIONS(5568),
    [anon_sym_SLASH] = ACTIONS(5570),
    [anon_sym_PERCENT] = ACTIONS(5568),
    [anon_sym_CARET] = ACTIONS(5568),
    [anon_sym_PIPE] = ACTIONS(5570),
    [anon_sym_AMP] = ACTIONS(5570),
    [anon_sym_LT_LT] = ACTIONS(5568),
    [anon_sym_GT_GT] = ACTIONS(5570),
    [anon_sym_GT_GT_GT] = ACTIONS(5568),
    [anon_sym_EQ_EQ] = ACTIONS(5568),
    [anon_sym_BANG_EQ] = ACTIONS(5568),
    [anon_sym_GT_EQ] = ACTIONS(5568),
    [anon_sym_LT_EQ] = ACTIONS(5568),
    [anon_sym_DOT] = ACTIONS(5570),
    [anon_sym_EQ_GT] = ACTIONS(5568),
    [anon_sym_switch] = ACTIONS(5568),
    [anon_sym_when] = ACTIONS(5568),
    [anon_sym_DOT_DOT] = ACTIONS(5568),
    [anon_sym_and] = ACTIONS(5568),
    [anon_sym_or] = ACTIONS(5568),
    [anon_sym_AMP_AMP] = ACTIONS(5568),
    [anon_sym_PIPE_PIPE] = ACTIONS(5568),
    [anon_sym_QMARK_QMARK] = ACTIONS(5568),
    [anon_sym_on] = ACTIONS(5568),
    [anon_sym_equals] = ACTIONS(5568),
    [anon_sym_by] = ACTIONS(5568),
    [anon_sym_as] = ACTIONS(5568),
    [anon_sym_is] = ACTIONS(5568),
    [anon_sym_DASH_GT] = ACTIONS(5568),
    [anon_sym_with] = ACTIONS(5568),
    [aux_sym_preproc_if_token3] = ACTIONS(5568),
    [aux_sym_preproc_else_token1] = ACTIONS(5568),
    [aux_sym_preproc_elif_token1] = ACTIONS(5568),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4256] = {
    [sym_preproc_region] = STATE(4256),
    [sym_preproc_endregion] = STATE(4256),
    [sym_preproc_line] = STATE(4256),
    [sym_preproc_pragma] = STATE(4256),
    [sym_preproc_nullable] = STATE(4256),
    [sym_preproc_error] = STATE(4256),
    [sym_preproc_define] = STATE(4256),
    [sym_preproc_undef] = STATE(4256),
    [anon_sym_SEMI] = ACTIONS(5838),
    [anon_sym_LBRACK] = ACTIONS(5838),
    [anon_sym_COLON] = ACTIONS(5838),
    [anon_sym_COMMA] = ACTIONS(5838),
    [anon_sym_RBRACK] = ACTIONS(5838),
    [anon_sym_LPAREN] = ACTIONS(5838),
    [anon_sym_RPAREN] = ACTIONS(5838),
    [anon_sym_RBRACE] = ACTIONS(5838),
    [anon_sym_LT] = ACTIONS(5840),
    [anon_sym_GT] = ACTIONS(5840),
    [anon_sym_in] = ACTIONS(5838),
    [anon_sym_QMARK] = ACTIONS(5840),
    [anon_sym_BANG] = ACTIONS(5840),
    [anon_sym_PLUS_PLUS] = ACTIONS(5838),
    [anon_sym_DASH_DASH] = ACTIONS(5838),
    [anon_sym_PLUS] = ACTIONS(5840),
    [anon_sym_DASH] = ACTIONS(5840),
    [anon_sym_STAR] = ACTIONS(5838),
    [anon_sym_SLASH] = ACTIONS(5840),
    [anon_sym_PERCENT] = ACTIONS(5838),
    [anon_sym_CARET] = ACTIONS(5838),
    [anon_sym_PIPE] = ACTIONS(5840),
    [anon_sym_AMP] = ACTIONS(5840),
    [anon_sym_LT_LT] = ACTIONS(5838),
    [anon_sym_GT_GT] = ACTIONS(5840),
    [anon_sym_GT_GT_GT] = ACTIONS(5838),
    [anon_sym_EQ_EQ] = ACTIONS(5838),
    [anon_sym_BANG_EQ] = ACTIONS(5838),
    [anon_sym_GT_EQ] = ACTIONS(5838),
    [anon_sym_LT_EQ] = ACTIONS(5838),
    [anon_sym_DOT] = ACTIONS(5840),
    [anon_sym_EQ_GT] = ACTIONS(5838),
    [anon_sym_switch] = ACTIONS(5838),
    [anon_sym_when] = ACTIONS(5838),
    [anon_sym_DOT_DOT] = ACTIONS(5838),
    [anon_sym_and] = ACTIONS(5838),
    [anon_sym_or] = ACTIONS(5838),
    [anon_sym_AMP_AMP] = ACTIONS(5838),
    [anon_sym_PIPE_PIPE] = ACTIONS(5838),
    [anon_sym_QMARK_QMARK] = ACTIONS(5838),
    [anon_sym_on] = ACTIONS(5838),
    [anon_sym_equals] = ACTIONS(5838),
    [anon_sym_by] = ACTIONS(5838),
    [anon_sym_as] = ACTIONS(5838),
    [anon_sym_is] = ACTIONS(5838),
    [anon_sym_DASH_GT] = ACTIONS(5838),
    [anon_sym_with] = ACTIONS(5838),
    [aux_sym_preproc_if_token3] = ACTIONS(5838),
    [aux_sym_preproc_else_token1] = ACTIONS(5838),
    [aux_sym_preproc_elif_token1] = ACTIONS(5838),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4257] = {
    [sym_argument_list] = STATE(3597),
    [sym_initializer_expression] = STATE(3718),
    [sym_preproc_region] = STATE(4257),
    [sym_preproc_endregion] = STATE(4257),
    [sym_preproc_line] = STATE(4257),
    [sym_preproc_pragma] = STATE(4257),
    [sym_preproc_nullable] = STATE(4257),
    [sym_preproc_error] = STATE(4257),
    [sym_preproc_define] = STATE(4257),
    [sym_preproc_undef] = STATE(4257),
    [anon_sym_SEMI] = ACTIONS(5185),
    [anon_sym_LBRACK] = ACTIONS(5185),
    [anon_sym_COLON] = ACTIONS(5185),
    [anon_sym_COMMA] = ACTIONS(5185),
    [anon_sym_RBRACK] = ACTIONS(5185),
    [anon_sym_LPAREN] = ACTIONS(5711),
    [anon_sym_RPAREN] = ACTIONS(5185),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_RBRACE] = ACTIONS(5185),
    [anon_sym_LT] = ACTIONS(5189),
    [anon_sym_GT] = ACTIONS(5189),
    [anon_sym_in] = ACTIONS(5185),
    [anon_sym_QMARK] = ACTIONS(5189),
    [anon_sym_BANG] = ACTIONS(5189),
    [anon_sym_PLUS_PLUS] = ACTIONS(5185),
    [anon_sym_DASH_DASH] = ACTIONS(5185),
    [anon_sym_PLUS] = ACTIONS(5189),
    [anon_sym_DASH] = ACTIONS(5189),
    [anon_sym_STAR] = ACTIONS(5185),
    [anon_sym_SLASH] = ACTIONS(5189),
    [anon_sym_PERCENT] = ACTIONS(5185),
    [anon_sym_CARET] = ACTIONS(5185),
    [anon_sym_PIPE] = ACTIONS(5189),
    [anon_sym_AMP] = ACTIONS(5189),
    [anon_sym_LT_LT] = ACTIONS(5185),
    [anon_sym_GT_GT] = ACTIONS(5189),
    [anon_sym_GT_GT_GT] = ACTIONS(5185),
    [anon_sym_EQ_EQ] = ACTIONS(5185),
    [anon_sym_BANG_EQ] = ACTIONS(5185),
    [anon_sym_GT_EQ] = ACTIONS(5185),
    [anon_sym_LT_EQ] = ACTIONS(5185),
    [anon_sym_DOT] = ACTIONS(5189),
    [anon_sym_EQ_GT] = ACTIONS(5185),
    [anon_sym_switch] = ACTIONS(5185),
    [anon_sym_DOT_DOT] = ACTIONS(5185),
    [anon_sym_AMP_AMP] = ACTIONS(5185),
    [anon_sym_PIPE_PIPE] = ACTIONS(5185),
    [anon_sym_QMARK_QMARK] = ACTIONS(5185),
    [anon_sym_on] = ACTIONS(5185),
    [anon_sym_equals] = ACTIONS(5185),
    [anon_sym_by] = ACTIONS(5185),
    [anon_sym_as] = ACTIONS(5185),
    [anon_sym_is] = ACTIONS(5185),
    [anon_sym_DASH_GT] = ACTIONS(5185),
    [anon_sym_with] = ACTIONS(5185),
    [aux_sym_preproc_if_token3] = ACTIONS(5185),
    [aux_sym_preproc_else_token1] = ACTIONS(5185),
    [aux_sym_preproc_elif_token1] = ACTIONS(5185),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4258] = {
    [sym__name] = STATE(7759),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(9882),
    [sym_implicit_type] = STATE(8901),
    [sym_array_type] = STATE(8236),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(8217),
    [sym_pointer_type] = STATE(8217),
    [sym__pointer_base_type] = STATE(9650),
    [sym_function_pointer_type] = STATE(8217),
    [sym_function_pointer_parameter] = STATE(9350),
    [sym_ref_type] = STATE(8704),
    [sym__ref_base_type] = STATE(9351),
    [sym_scoped_type] = STATE(8704),
    [sym_tuple_type] = STATE(8136),
    [sym_identifier] = STATE(4921),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4258),
    [sym_preproc_endregion] = STATE(4258),
    [sym_preproc_line] = STATE(4258),
    [sym_preproc_pragma] = STATE(4258),
    [sym_preproc_nullable] = STATE(4258),
    [sym_preproc_error] = STATE(4258),
    [sym_preproc_define] = STATE(4258),
    [sym_preproc_undef] = STATE(4258),
    [aux_sym_function_pointer_type_repeat1] = STATE(4263),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_LPAREN] = ACTIONS(2995),
    [anon_sym_ref] = ACTIONS(5882),
    [anon_sym_delegate] = ACTIONS(5659),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_in] = ACTIONS(5884),
    [anon_sym_out] = ACTIONS(5884),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(5886),
    [anon_sym_var] = ACTIONS(5284),
    [sym_predefined_type] = ACTIONS(5888),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4259] = {
    [sym_preproc_region] = STATE(4259),
    [sym_preproc_endregion] = STATE(4259),
    [sym_preproc_line] = STATE(4259),
    [sym_preproc_pragma] = STATE(4259),
    [sym_preproc_nullable] = STATE(4259),
    [sym_preproc_error] = STATE(4259),
    [sym_preproc_define] = STATE(4259),
    [sym_preproc_undef] = STATE(4259),
    [anon_sym_SEMI] = ACTIONS(4247),
    [anon_sym_LBRACK] = ACTIONS(4247),
    [anon_sym_COLON] = ACTIONS(4247),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_RBRACK] = ACTIONS(4247),
    [anon_sym_LPAREN] = ACTIONS(4247),
    [anon_sym_RPAREN] = ACTIONS(4247),
    [anon_sym_RBRACE] = ACTIONS(4247),
    [anon_sym_LT] = ACTIONS(5832),
    [anon_sym_GT] = ACTIONS(5832),
    [anon_sym_in] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(5832),
    [anon_sym_BANG] = ACTIONS(5832),
    [anon_sym_PLUS_PLUS] = ACTIONS(4247),
    [anon_sym_DASH_DASH] = ACTIONS(4247),
    [anon_sym_PLUS] = ACTIONS(5832),
    [anon_sym_DASH] = ACTIONS(5832),
    [anon_sym_STAR] = ACTIONS(4247),
    [anon_sym_SLASH] = ACTIONS(5832),
    [anon_sym_PERCENT] = ACTIONS(4247),
    [anon_sym_CARET] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(5832),
    [anon_sym_AMP] = ACTIONS(5832),
    [anon_sym_LT_LT] = ACTIONS(4247),
    [anon_sym_GT_GT] = ACTIONS(5832),
    [anon_sym_GT_GT_GT] = ACTIONS(4247),
    [anon_sym_EQ_EQ] = ACTIONS(4247),
    [anon_sym_BANG_EQ] = ACTIONS(4247),
    [anon_sym_GT_EQ] = ACTIONS(4247),
    [anon_sym_LT_EQ] = ACTIONS(4247),
    [anon_sym_DOT] = ACTIONS(5832),
    [anon_sym_EQ_GT] = ACTIONS(4081),
    [anon_sym_switch] = ACTIONS(4247),
    [anon_sym_when] = ACTIONS(4247),
    [anon_sym_DOT_DOT] = ACTIONS(4247),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_AMP_AMP] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(4247),
    [anon_sym_QMARK_QMARK] = ACTIONS(4247),
    [anon_sym_on] = ACTIONS(4247),
    [anon_sym_equals] = ACTIONS(4247),
    [anon_sym_by] = ACTIONS(4247),
    [anon_sym_as] = ACTIONS(4247),
    [anon_sym_is] = ACTIONS(4247),
    [anon_sym_DASH_GT] = ACTIONS(4247),
    [anon_sym_with] = ACTIONS(4247),
    [aux_sym_preproc_if_token3] = ACTIONS(4247),
    [aux_sym_preproc_else_token1] = ACTIONS(4247),
    [aux_sym_preproc_elif_token1] = ACTIONS(4247),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4260] = {
    [sym_preproc_region] = STATE(4260),
    [sym_preproc_endregion] = STATE(4260),
    [sym_preproc_line] = STATE(4260),
    [sym_preproc_pragma] = STATE(4260),
    [sym_preproc_nullable] = STATE(4260),
    [sym_preproc_error] = STATE(4260),
    [sym_preproc_define] = STATE(4260),
    [sym_preproc_undef] = STATE(4260),
    [anon_sym_SEMI] = ACTIONS(5834),
    [anon_sym_LBRACK] = ACTIONS(5834),
    [anon_sym_COLON] = ACTIONS(5834),
    [anon_sym_COMMA] = ACTIONS(5834),
    [anon_sym_RBRACK] = ACTIONS(5834),
    [anon_sym_LPAREN] = ACTIONS(5834),
    [anon_sym_RPAREN] = ACTIONS(5834),
    [anon_sym_RBRACE] = ACTIONS(5834),
    [anon_sym_LT] = ACTIONS(5836),
    [anon_sym_GT] = ACTIONS(5836),
    [anon_sym_in] = ACTIONS(5834),
    [anon_sym_QMARK] = ACTIONS(5836),
    [anon_sym_BANG] = ACTIONS(5836),
    [anon_sym_PLUS_PLUS] = ACTIONS(5834),
    [anon_sym_DASH_DASH] = ACTIONS(5834),
    [anon_sym_PLUS] = ACTIONS(5836),
    [anon_sym_DASH] = ACTIONS(5836),
    [anon_sym_STAR] = ACTIONS(5834),
    [anon_sym_SLASH] = ACTIONS(5836),
    [anon_sym_PERCENT] = ACTIONS(5834),
    [anon_sym_CARET] = ACTIONS(5834),
    [anon_sym_PIPE] = ACTIONS(5836),
    [anon_sym_AMP] = ACTIONS(5836),
    [anon_sym_LT_LT] = ACTIONS(5834),
    [anon_sym_GT_GT] = ACTIONS(5836),
    [anon_sym_GT_GT_GT] = ACTIONS(5834),
    [anon_sym_EQ_EQ] = ACTIONS(5834),
    [anon_sym_BANG_EQ] = ACTIONS(5834),
    [anon_sym_GT_EQ] = ACTIONS(5834),
    [anon_sym_LT_EQ] = ACTIONS(5834),
    [anon_sym_DOT] = ACTIONS(5836),
    [anon_sym_EQ_GT] = ACTIONS(5834),
    [anon_sym_switch] = ACTIONS(5834),
    [anon_sym_when] = ACTIONS(5834),
    [anon_sym_DOT_DOT] = ACTIONS(5834),
    [anon_sym_and] = ACTIONS(5834),
    [anon_sym_or] = ACTIONS(5834),
    [anon_sym_AMP_AMP] = ACTIONS(5834),
    [anon_sym_PIPE_PIPE] = ACTIONS(5834),
    [anon_sym_QMARK_QMARK] = ACTIONS(5834),
    [anon_sym_on] = ACTIONS(5834),
    [anon_sym_equals] = ACTIONS(5834),
    [anon_sym_by] = ACTIONS(5834),
    [anon_sym_as] = ACTIONS(5834),
    [anon_sym_is] = ACTIONS(5834),
    [anon_sym_DASH_GT] = ACTIONS(5834),
    [anon_sym_with] = ACTIONS(5834),
    [aux_sym_preproc_if_token3] = ACTIONS(5834),
    [aux_sym_preproc_else_token1] = ACTIONS(5834),
    [aux_sym_preproc_elif_token1] = ACTIONS(5834),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4261] = {
    [sym_preproc_region] = STATE(4261),
    [sym_preproc_endregion] = STATE(4261),
    [sym_preproc_line] = STATE(4261),
    [sym_preproc_pragma] = STATE(4261),
    [sym_preproc_nullable] = STATE(4261),
    [sym_preproc_error] = STATE(4261),
    [sym_preproc_define] = STATE(4261),
    [sym_preproc_undef] = STATE(4261),
    [anon_sym_SEMI] = ACTIONS(5365),
    [anon_sym_LBRACK] = ACTIONS(5365),
    [anon_sym_COLON] = ACTIONS(5365),
    [anon_sym_COMMA] = ACTIONS(5365),
    [anon_sym_RBRACK] = ACTIONS(5365),
    [anon_sym_LPAREN] = ACTIONS(5365),
    [anon_sym_RPAREN] = ACTIONS(5365),
    [anon_sym_RBRACE] = ACTIONS(5365),
    [anon_sym_LT] = ACTIONS(5367),
    [anon_sym_GT] = ACTIONS(5367),
    [anon_sym_in] = ACTIONS(5365),
    [anon_sym_QMARK] = ACTIONS(5367),
    [anon_sym_BANG] = ACTIONS(5367),
    [anon_sym_PLUS_PLUS] = ACTIONS(5365),
    [anon_sym_DASH_DASH] = ACTIONS(5365),
    [anon_sym_PLUS] = ACTIONS(5367),
    [anon_sym_DASH] = ACTIONS(5367),
    [anon_sym_STAR] = ACTIONS(5365),
    [anon_sym_SLASH] = ACTIONS(5367),
    [anon_sym_PERCENT] = ACTIONS(5365),
    [anon_sym_CARET] = ACTIONS(5365),
    [anon_sym_PIPE] = ACTIONS(5367),
    [anon_sym_AMP] = ACTIONS(5367),
    [anon_sym_LT_LT] = ACTIONS(5365),
    [anon_sym_GT_GT] = ACTIONS(5367),
    [anon_sym_GT_GT_GT] = ACTIONS(5365),
    [anon_sym_EQ_EQ] = ACTIONS(5365),
    [anon_sym_BANG_EQ] = ACTIONS(5365),
    [anon_sym_GT_EQ] = ACTIONS(5365),
    [anon_sym_LT_EQ] = ACTIONS(5365),
    [anon_sym_DOT] = ACTIONS(5367),
    [anon_sym_EQ_GT] = ACTIONS(5365),
    [anon_sym_switch] = ACTIONS(5365),
    [anon_sym_when] = ACTIONS(5365),
    [anon_sym_DOT_DOT] = ACTIONS(5365),
    [anon_sym_and] = ACTIONS(5365),
    [anon_sym_or] = ACTIONS(5365),
    [anon_sym_AMP_AMP] = ACTIONS(5365),
    [anon_sym_PIPE_PIPE] = ACTIONS(5365),
    [anon_sym_QMARK_QMARK] = ACTIONS(5365),
    [anon_sym_on] = ACTIONS(5365),
    [anon_sym_equals] = ACTIONS(5365),
    [anon_sym_by] = ACTIONS(5365),
    [anon_sym_as] = ACTIONS(5365),
    [anon_sym_is] = ACTIONS(5365),
    [anon_sym_DASH_GT] = ACTIONS(5365),
    [anon_sym_with] = ACTIONS(5365),
    [aux_sym_preproc_if_token3] = ACTIONS(5365),
    [aux_sym_preproc_else_token1] = ACTIONS(5365),
    [aux_sym_preproc_elif_token1] = ACTIONS(5365),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4262] = {
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7033),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9803),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4262),
    [sym_preproc_endregion] = STATE(4262),
    [sym_preproc_line] = STATE(4262),
    [sym_preproc_pragma] = STATE(4262),
    [sym_preproc_nullable] = STATE(4262),
    [sym_preproc_error] = STATE(4262),
    [sym_preproc_define] = STATE(4262),
    [sym_preproc_undef] = STATE(4262),
    [aux_sym_lambda_expression_repeat1] = STATE(6864),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4263] = {
    [sym__name] = STATE(7759),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(9857),
    [sym_implicit_type] = STATE(8901),
    [sym_array_type] = STATE(8236),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(8217),
    [sym_pointer_type] = STATE(8217),
    [sym__pointer_base_type] = STATE(9650),
    [sym_function_pointer_type] = STATE(8217),
    [sym_function_pointer_parameter] = STATE(9350),
    [sym_ref_type] = STATE(8704),
    [sym__ref_base_type] = STATE(9351),
    [sym_scoped_type] = STATE(8704),
    [sym_tuple_type] = STATE(8136),
    [sym_identifier] = STATE(4921),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4263),
    [sym_preproc_endregion] = STATE(4263),
    [sym_preproc_line] = STATE(4263),
    [sym_preproc_pragma] = STATE(4263),
    [sym_preproc_nullable] = STATE(4263),
    [sym_preproc_error] = STATE(4263),
    [sym_preproc_define] = STATE(4263),
    [sym_preproc_undef] = STATE(4263),
    [aux_sym_function_pointer_type_repeat1] = STATE(4464),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_LPAREN] = ACTIONS(2995),
    [anon_sym_ref] = ACTIONS(5882),
    [anon_sym_delegate] = ACTIONS(5659),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_in] = ACTIONS(5884),
    [anon_sym_out] = ACTIONS(5884),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(5886),
    [anon_sym_var] = ACTIONS(5284),
    [sym_predefined_type] = ACTIONS(5888),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4264] = {
    [sym__name] = STATE(7759),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(9544),
    [sym_implicit_type] = STATE(8901),
    [sym_array_type] = STATE(8236),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(8217),
    [sym_pointer_type] = STATE(8217),
    [sym__pointer_base_type] = STATE(9650),
    [sym_function_pointer_type] = STATE(8217),
    [sym_function_pointer_parameter] = STATE(9350),
    [sym_ref_type] = STATE(8704),
    [sym__ref_base_type] = STATE(9351),
    [sym_scoped_type] = STATE(8704),
    [sym_tuple_type] = STATE(8136),
    [sym_identifier] = STATE(4921),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4264),
    [sym_preproc_endregion] = STATE(4264),
    [sym_preproc_line] = STATE(4264),
    [sym_preproc_pragma] = STATE(4264),
    [sym_preproc_nullable] = STATE(4264),
    [sym_preproc_error] = STATE(4264),
    [sym_preproc_define] = STATE(4264),
    [sym_preproc_undef] = STATE(4264),
    [aux_sym_function_pointer_type_repeat1] = STATE(4464),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_LPAREN] = ACTIONS(2995),
    [anon_sym_ref] = ACTIONS(5882),
    [anon_sym_delegate] = ACTIONS(5659),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_in] = ACTIONS(5884),
    [anon_sym_out] = ACTIONS(5884),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(5886),
    [anon_sym_var] = ACTIONS(5284),
    [sym_predefined_type] = ACTIONS(5888),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4265] = {
    [sym__name] = STATE(7759),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(9344),
    [sym_implicit_type] = STATE(8901),
    [sym_array_type] = STATE(8236),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(8217),
    [sym_pointer_type] = STATE(8217),
    [sym__pointer_base_type] = STATE(9650),
    [sym_function_pointer_type] = STATE(8217),
    [sym_function_pointer_parameter] = STATE(9350),
    [sym_ref_type] = STATE(8704),
    [sym__ref_base_type] = STATE(9351),
    [sym_scoped_type] = STATE(8704),
    [sym_tuple_type] = STATE(8136),
    [sym_identifier] = STATE(4921),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4265),
    [sym_preproc_endregion] = STATE(4265),
    [sym_preproc_line] = STATE(4265),
    [sym_preproc_pragma] = STATE(4265),
    [sym_preproc_nullable] = STATE(4265),
    [sym_preproc_error] = STATE(4265),
    [sym_preproc_define] = STATE(4265),
    [sym_preproc_undef] = STATE(4265),
    [aux_sym_function_pointer_type_repeat1] = STATE(4264),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_LPAREN] = ACTIONS(2995),
    [anon_sym_ref] = ACTIONS(5882),
    [anon_sym_delegate] = ACTIONS(5659),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_in] = ACTIONS(5884),
    [anon_sym_out] = ACTIONS(5884),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(5886),
    [anon_sym_var] = ACTIONS(5284),
    [sym_predefined_type] = ACTIONS(5888),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4266] = {
    [sym__name] = STATE(7759),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(9687),
    [sym_implicit_type] = STATE(8901),
    [sym_array_type] = STATE(8236),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(8217),
    [sym_pointer_type] = STATE(8217),
    [sym__pointer_base_type] = STATE(9650),
    [sym_function_pointer_type] = STATE(8217),
    [sym_function_pointer_parameter] = STATE(9350),
    [sym_ref_type] = STATE(8704),
    [sym__ref_base_type] = STATE(9351),
    [sym_scoped_type] = STATE(8704),
    [sym_tuple_type] = STATE(8136),
    [sym_identifier] = STATE(4921),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4266),
    [sym_preproc_endregion] = STATE(4266),
    [sym_preproc_line] = STATE(4266),
    [sym_preproc_pragma] = STATE(4266),
    [sym_preproc_nullable] = STATE(4266),
    [sym_preproc_error] = STATE(4266),
    [sym_preproc_define] = STATE(4266),
    [sym_preproc_undef] = STATE(4266),
    [aux_sym_function_pointer_type_repeat1] = STATE(4464),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_LPAREN] = ACTIONS(2995),
    [anon_sym_ref] = ACTIONS(5882),
    [anon_sym_delegate] = ACTIONS(5659),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_in] = ACTIONS(5884),
    [anon_sym_out] = ACTIONS(5884),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(5886),
    [anon_sym_var] = ACTIONS(5284),
    [sym_predefined_type] = ACTIONS(5888),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4267] = {
    [sym_preproc_region] = STATE(4267),
    [sym_preproc_endregion] = STATE(4267),
    [sym_preproc_line] = STATE(4267),
    [sym_preproc_pragma] = STATE(4267),
    [sym_preproc_nullable] = STATE(4267),
    [sym_preproc_error] = STATE(4267),
    [sym_preproc_define] = STATE(4267),
    [sym_preproc_undef] = STATE(4267),
    [anon_sym_SEMI] = ACTIONS(4428),
    [anon_sym_LBRACK] = ACTIONS(4428),
    [anon_sym_COLON] = ACTIONS(4428),
    [anon_sym_COMMA] = ACTIONS(4428),
    [anon_sym_RBRACK] = ACTIONS(4428),
    [anon_sym_LPAREN] = ACTIONS(4428),
    [anon_sym_RPAREN] = ACTIONS(4428),
    [anon_sym_LBRACE] = ACTIONS(4428),
    [anon_sym_RBRACE] = ACTIONS(4428),
    [anon_sym_LT] = ACTIONS(4426),
    [anon_sym_GT] = ACTIONS(4426),
    [anon_sym_QMARK] = ACTIONS(4426),
    [anon_sym_BANG] = ACTIONS(4426),
    [anon_sym_PLUS_PLUS] = ACTIONS(4428),
    [anon_sym_DASH_DASH] = ACTIONS(4428),
    [anon_sym_PLUS] = ACTIONS(4426),
    [anon_sym_DASH] = ACTIONS(4426),
    [anon_sym_STAR] = ACTIONS(4428),
    [anon_sym_SLASH] = ACTIONS(4426),
    [anon_sym_PERCENT] = ACTIONS(4428),
    [anon_sym_CARET] = ACTIONS(4428),
    [anon_sym_PIPE] = ACTIONS(4426),
    [anon_sym_AMP] = ACTIONS(4426),
    [anon_sym_LT_LT] = ACTIONS(4428),
    [anon_sym_GT_GT] = ACTIONS(4426),
    [anon_sym_GT_GT_GT] = ACTIONS(4428),
    [anon_sym_EQ_EQ] = ACTIONS(4428),
    [anon_sym_BANG_EQ] = ACTIONS(4428),
    [anon_sym_GT_EQ] = ACTIONS(4428),
    [anon_sym_LT_EQ] = ACTIONS(4428),
    [anon_sym_DOT] = ACTIONS(5954),
    [anon_sym_EQ_GT] = ACTIONS(4428),
    [anon_sym_switch] = ACTIONS(4428),
    [anon_sym_when] = ACTIONS(4428),
    [anon_sym_DOT_DOT] = ACTIONS(4428),
    [anon_sym_and] = ACTIONS(4428),
    [anon_sym_or] = ACTIONS(4428),
    [anon_sym_AMP_AMP] = ACTIONS(4428),
    [anon_sym_PIPE_PIPE] = ACTIONS(4428),
    [anon_sym_QMARK_QMARK] = ACTIONS(4428),
    [anon_sym_on] = ACTIONS(4428),
    [anon_sym_equals] = ACTIONS(4428),
    [anon_sym_by] = ACTIONS(4428),
    [anon_sym_as] = ACTIONS(4428),
    [anon_sym_is] = ACTIONS(4428),
    [anon_sym_DASH_GT] = ACTIONS(4428),
    [anon_sym_with] = ACTIONS(4428),
    [aux_sym_preproc_if_token3] = ACTIONS(4428),
    [aux_sym_preproc_else_token1] = ACTIONS(4428),
    [aux_sym_preproc_elif_token1] = ACTIONS(4428),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4268] = {
    [sym_preproc_region] = STATE(4268),
    [sym_preproc_endregion] = STATE(4268),
    [sym_preproc_line] = STATE(4268),
    [sym_preproc_pragma] = STATE(4268),
    [sym_preproc_nullable] = STATE(4268),
    [sym_preproc_error] = STATE(4268),
    [sym_preproc_define] = STATE(4268),
    [sym_preproc_undef] = STATE(4268),
    [anon_sym_SEMI] = ACTIONS(4424),
    [anon_sym_LBRACK] = ACTIONS(4547),
    [anon_sym_COLON] = ACTIONS(4424),
    [anon_sym_COMMA] = ACTIONS(4424),
    [anon_sym_RBRACK] = ACTIONS(4424),
    [anon_sym_LPAREN] = ACTIONS(4424),
    [anon_sym_RPAREN] = ACTIONS(4424),
    [anon_sym_LBRACE] = ACTIONS(4424),
    [anon_sym_RBRACE] = ACTIONS(4424),
    [anon_sym_LT] = ACTIONS(4422),
    [anon_sym_GT] = ACTIONS(4422),
    [anon_sym_QMARK] = ACTIONS(5758),
    [anon_sym_BANG] = ACTIONS(4422),
    [anon_sym_PLUS_PLUS] = ACTIONS(4424),
    [anon_sym_DASH_DASH] = ACTIONS(4424),
    [anon_sym_PLUS] = ACTIONS(4422),
    [anon_sym_DASH] = ACTIONS(4422),
    [anon_sym_STAR] = ACTIONS(4553),
    [anon_sym_SLASH] = ACTIONS(4422),
    [anon_sym_PERCENT] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4424),
    [anon_sym_PIPE] = ACTIONS(4422),
    [anon_sym_AMP] = ACTIONS(4422),
    [anon_sym_LT_LT] = ACTIONS(4424),
    [anon_sym_GT_GT] = ACTIONS(4422),
    [anon_sym_GT_GT_GT] = ACTIONS(4424),
    [anon_sym_EQ_EQ] = ACTIONS(4424),
    [anon_sym_BANG_EQ] = ACTIONS(4424),
    [anon_sym_GT_EQ] = ACTIONS(4424),
    [anon_sym_LT_EQ] = ACTIONS(4424),
    [anon_sym_DOT] = ACTIONS(5954),
    [anon_sym_EQ_GT] = ACTIONS(4424),
    [anon_sym_switch] = ACTIONS(4424),
    [anon_sym_when] = ACTIONS(4424),
    [anon_sym_DOT_DOT] = ACTIONS(4424),
    [anon_sym_and] = ACTIONS(4424),
    [anon_sym_or] = ACTIONS(4424),
    [anon_sym_AMP_AMP] = ACTIONS(4424),
    [anon_sym_PIPE_PIPE] = ACTIONS(4424),
    [anon_sym_QMARK_QMARK] = ACTIONS(4424),
    [anon_sym_on] = ACTIONS(4424),
    [anon_sym_equals] = ACTIONS(4424),
    [anon_sym_by] = ACTIONS(4424),
    [anon_sym_as] = ACTIONS(4424),
    [anon_sym_is] = ACTIONS(4424),
    [anon_sym_DASH_GT] = ACTIONS(4424),
    [anon_sym_with] = ACTIONS(4424),
    [aux_sym_preproc_if_token3] = ACTIONS(4424),
    [aux_sym_preproc_else_token1] = ACTIONS(4424),
    [aux_sym_preproc_elif_token1] = ACTIONS(4424),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4269] = {
    [sym_preproc_region] = STATE(4269),
    [sym_preproc_endregion] = STATE(4269),
    [sym_preproc_line] = STATE(4269),
    [sym_preproc_pragma] = STATE(4269),
    [sym_preproc_nullable] = STATE(4269),
    [sym_preproc_error] = STATE(4269),
    [sym_preproc_define] = STATE(4269),
    [sym_preproc_undef] = STATE(4269),
    [anon_sym_SEMI] = ACTIONS(4247),
    [anon_sym_LBRACK] = ACTIONS(4247),
    [anon_sym_COLON] = ACTIONS(4247),
    [anon_sym_COMMA] = ACTIONS(4247),
    [anon_sym_RBRACK] = ACTIONS(4247),
    [anon_sym_LPAREN] = ACTIONS(4247),
    [anon_sym_RPAREN] = ACTIONS(4247),
    [anon_sym_RBRACE] = ACTIONS(4247),
    [anon_sym_LT] = ACTIONS(5832),
    [anon_sym_GT] = ACTIONS(5832),
    [anon_sym_in] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(5832),
    [anon_sym_BANG] = ACTIONS(5832),
    [anon_sym_PLUS_PLUS] = ACTIONS(4247),
    [anon_sym_DASH_DASH] = ACTIONS(4247),
    [anon_sym_PLUS] = ACTIONS(5832),
    [anon_sym_DASH] = ACTIONS(5832),
    [anon_sym_STAR] = ACTIONS(4247),
    [anon_sym_SLASH] = ACTIONS(5832),
    [anon_sym_PERCENT] = ACTIONS(4247),
    [anon_sym_CARET] = ACTIONS(4247),
    [anon_sym_PIPE] = ACTIONS(5832),
    [anon_sym_AMP] = ACTIONS(5832),
    [anon_sym_LT_LT] = ACTIONS(4247),
    [anon_sym_GT_GT] = ACTIONS(5832),
    [anon_sym_GT_GT_GT] = ACTIONS(4247),
    [anon_sym_EQ_EQ] = ACTIONS(4247),
    [anon_sym_BANG_EQ] = ACTIONS(4247),
    [anon_sym_GT_EQ] = ACTIONS(4247),
    [anon_sym_LT_EQ] = ACTIONS(4247),
    [anon_sym_DOT] = ACTIONS(5832),
    [anon_sym_EQ_GT] = ACTIONS(4247),
    [anon_sym_switch] = ACTIONS(4247),
    [anon_sym_when] = ACTIONS(4247),
    [anon_sym_DOT_DOT] = ACTIONS(4247),
    [anon_sym_and] = ACTIONS(4247),
    [anon_sym_or] = ACTIONS(4247),
    [anon_sym_AMP_AMP] = ACTIONS(4247),
    [anon_sym_PIPE_PIPE] = ACTIONS(4247),
    [anon_sym_QMARK_QMARK] = ACTIONS(4247),
    [anon_sym_on] = ACTIONS(4247),
    [anon_sym_equals] = ACTIONS(4247),
    [anon_sym_by] = ACTIONS(4247),
    [anon_sym_as] = ACTIONS(4247),
    [anon_sym_is] = ACTIONS(4247),
    [anon_sym_DASH_GT] = ACTIONS(4247),
    [anon_sym_with] = ACTIONS(4247),
    [aux_sym_preproc_if_token3] = ACTIONS(4247),
    [aux_sym_preproc_else_token1] = ACTIONS(4247),
    [aux_sym_preproc_elif_token1] = ACTIONS(4247),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4270] = {
    [sym_preproc_region] = STATE(4270),
    [sym_preproc_endregion] = STATE(4270),
    [sym_preproc_line] = STATE(4270),
    [sym_preproc_pragma] = STATE(4270),
    [sym_preproc_nullable] = STATE(4270),
    [sym_preproc_error] = STATE(4270),
    [sym_preproc_define] = STATE(4270),
    [sym_preproc_undef] = STATE(4270),
    [anon_sym_SEMI] = ACTIONS(5824),
    [anon_sym_LBRACK] = ACTIONS(5824),
    [anon_sym_COLON] = ACTIONS(5824),
    [anon_sym_COMMA] = ACTIONS(5824),
    [anon_sym_RBRACK] = ACTIONS(5824),
    [anon_sym_LPAREN] = ACTIONS(5824),
    [anon_sym_RPAREN] = ACTIONS(5824),
    [anon_sym_RBRACE] = ACTIONS(5824),
    [anon_sym_LT] = ACTIONS(5826),
    [anon_sym_GT] = ACTIONS(5826),
    [anon_sym_in] = ACTIONS(5824),
    [anon_sym_QMARK] = ACTIONS(5826),
    [anon_sym_BANG] = ACTIONS(5826),
    [anon_sym_PLUS_PLUS] = ACTIONS(5824),
    [anon_sym_DASH_DASH] = ACTIONS(5824),
    [anon_sym_PLUS] = ACTIONS(5826),
    [anon_sym_DASH] = ACTIONS(5826),
    [anon_sym_STAR] = ACTIONS(5824),
    [anon_sym_SLASH] = ACTIONS(5826),
    [anon_sym_PERCENT] = ACTIONS(5824),
    [anon_sym_CARET] = ACTIONS(5824),
    [anon_sym_PIPE] = ACTIONS(5826),
    [anon_sym_AMP] = ACTIONS(5826),
    [anon_sym_LT_LT] = ACTIONS(5824),
    [anon_sym_GT_GT] = ACTIONS(5826),
    [anon_sym_GT_GT_GT] = ACTIONS(5824),
    [anon_sym_EQ_EQ] = ACTIONS(5824),
    [anon_sym_BANG_EQ] = ACTIONS(5824),
    [anon_sym_GT_EQ] = ACTIONS(5824),
    [anon_sym_LT_EQ] = ACTIONS(5824),
    [anon_sym_DOT] = ACTIONS(5826),
    [anon_sym_EQ_GT] = ACTIONS(5824),
    [anon_sym_switch] = ACTIONS(5824),
    [anon_sym_when] = ACTIONS(5824),
    [anon_sym_DOT_DOT] = ACTIONS(5824),
    [anon_sym_and] = ACTIONS(5824),
    [anon_sym_or] = ACTIONS(5824),
    [anon_sym_AMP_AMP] = ACTIONS(5824),
    [anon_sym_PIPE_PIPE] = ACTIONS(5824),
    [anon_sym_QMARK_QMARK] = ACTIONS(5824),
    [anon_sym_on] = ACTIONS(5824),
    [anon_sym_equals] = ACTIONS(5824),
    [anon_sym_by] = ACTIONS(5824),
    [anon_sym_as] = ACTIONS(5824),
    [anon_sym_is] = ACTIONS(5824),
    [anon_sym_DASH_GT] = ACTIONS(5824),
    [anon_sym_with] = ACTIONS(5824),
    [aux_sym_preproc_if_token3] = ACTIONS(5824),
    [aux_sym_preproc_else_token1] = ACTIONS(5824),
    [aux_sym_preproc_elif_token1] = ACTIONS(5824),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4271] = {
    [sym__name] = STATE(7759),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(9698),
    [sym_implicit_type] = STATE(8901),
    [sym_array_type] = STATE(8236),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(8217),
    [sym_pointer_type] = STATE(8217),
    [sym__pointer_base_type] = STATE(9650),
    [sym_function_pointer_type] = STATE(8217),
    [sym_function_pointer_parameter] = STATE(9350),
    [sym_ref_type] = STATE(8704),
    [sym__ref_base_type] = STATE(9351),
    [sym_scoped_type] = STATE(8704),
    [sym_tuple_type] = STATE(8136),
    [sym_identifier] = STATE(4921),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4271),
    [sym_preproc_endregion] = STATE(4271),
    [sym_preproc_line] = STATE(4271),
    [sym_preproc_pragma] = STATE(4271),
    [sym_preproc_nullable] = STATE(4271),
    [sym_preproc_error] = STATE(4271),
    [sym_preproc_define] = STATE(4271),
    [sym_preproc_undef] = STATE(4271),
    [aux_sym_function_pointer_type_repeat1] = STATE(4266),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_LPAREN] = ACTIONS(2995),
    [anon_sym_ref] = ACTIONS(5882),
    [anon_sym_delegate] = ACTIONS(5659),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_in] = ACTIONS(5884),
    [anon_sym_out] = ACTIONS(5884),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(5886),
    [anon_sym_var] = ACTIONS(5284),
    [sym_predefined_type] = ACTIONS(5888),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4272] = {
    [sym__name] = STATE(7759),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(9698),
    [sym_implicit_type] = STATE(8901),
    [sym_array_type] = STATE(8236),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(8217),
    [sym_pointer_type] = STATE(8217),
    [sym__pointer_base_type] = STATE(9650),
    [sym_function_pointer_type] = STATE(8217),
    [sym_function_pointer_parameter] = STATE(9350),
    [sym_ref_type] = STATE(8704),
    [sym__ref_base_type] = STATE(9351),
    [sym_scoped_type] = STATE(8704),
    [sym_tuple_type] = STATE(8136),
    [sym_identifier] = STATE(4921),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4272),
    [sym_preproc_endregion] = STATE(4272),
    [sym_preproc_line] = STATE(4272),
    [sym_preproc_pragma] = STATE(4272),
    [sym_preproc_nullable] = STATE(4272),
    [sym_preproc_error] = STATE(4272),
    [sym_preproc_define] = STATE(4272),
    [sym_preproc_undef] = STATE(4272),
    [aux_sym_function_pointer_type_repeat1] = STATE(4464),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_LPAREN] = ACTIONS(2995),
    [anon_sym_ref] = ACTIONS(5882),
    [anon_sym_delegate] = ACTIONS(5659),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_in] = ACTIONS(5884),
    [anon_sym_out] = ACTIONS(5884),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(5886),
    [anon_sym_var] = ACTIONS(5284),
    [sym_predefined_type] = ACTIONS(5888),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4273] = {
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7007),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9545),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4273),
    [sym_preproc_endregion] = STATE(4273),
    [sym_preproc_line] = STATE(4273),
    [sym_preproc_pragma] = STATE(4273),
    [sym_preproc_nullable] = STATE(4273),
    [sym_preproc_error] = STATE(4273),
    [sym_preproc_define] = STATE(4273),
    [sym_preproc_undef] = STATE(4273),
    [aux_sym_lambda_expression_repeat1] = STATE(6864),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(5896),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4274] = {
    [sym_preproc_region] = STATE(4274),
    [sym_preproc_endregion] = STATE(4274),
    [sym_preproc_line] = STATE(4274),
    [sym_preproc_pragma] = STATE(4274),
    [sym_preproc_nullable] = STATE(4274),
    [sym_preproc_error] = STATE(4274),
    [sym_preproc_define] = STATE(4274),
    [sym_preproc_undef] = STATE(4274),
    [anon_sym_SEMI] = ACTIONS(5816),
    [anon_sym_LBRACK] = ACTIONS(5816),
    [anon_sym_COLON] = ACTIONS(5816),
    [anon_sym_COMMA] = ACTIONS(5816),
    [anon_sym_RBRACK] = ACTIONS(5816),
    [anon_sym_LPAREN] = ACTIONS(5816),
    [anon_sym_RPAREN] = ACTIONS(5816),
    [anon_sym_RBRACE] = ACTIONS(5816),
    [anon_sym_LT] = ACTIONS(5818),
    [anon_sym_GT] = ACTIONS(5818),
    [anon_sym_in] = ACTIONS(5816),
    [anon_sym_QMARK] = ACTIONS(5818),
    [anon_sym_BANG] = ACTIONS(5818),
    [anon_sym_PLUS_PLUS] = ACTIONS(5816),
    [anon_sym_DASH_DASH] = ACTIONS(5816),
    [anon_sym_PLUS] = ACTIONS(5818),
    [anon_sym_DASH] = ACTIONS(5818),
    [anon_sym_STAR] = ACTIONS(5816),
    [anon_sym_SLASH] = ACTIONS(5818),
    [anon_sym_PERCENT] = ACTIONS(5816),
    [anon_sym_CARET] = ACTIONS(5816),
    [anon_sym_PIPE] = ACTIONS(5818),
    [anon_sym_AMP] = ACTIONS(5818),
    [anon_sym_LT_LT] = ACTIONS(5816),
    [anon_sym_GT_GT] = ACTIONS(5818),
    [anon_sym_GT_GT_GT] = ACTIONS(5816),
    [anon_sym_EQ_EQ] = ACTIONS(5816),
    [anon_sym_BANG_EQ] = ACTIONS(5816),
    [anon_sym_GT_EQ] = ACTIONS(5816),
    [anon_sym_LT_EQ] = ACTIONS(5816),
    [anon_sym_DOT] = ACTIONS(5818),
    [anon_sym_EQ_GT] = ACTIONS(5816),
    [anon_sym_switch] = ACTIONS(5816),
    [anon_sym_when] = ACTIONS(5816),
    [anon_sym_DOT_DOT] = ACTIONS(5816),
    [anon_sym_and] = ACTIONS(5816),
    [anon_sym_or] = ACTIONS(5816),
    [anon_sym_AMP_AMP] = ACTIONS(5816),
    [anon_sym_PIPE_PIPE] = ACTIONS(5816),
    [anon_sym_QMARK_QMARK] = ACTIONS(5816),
    [anon_sym_on] = ACTIONS(5816),
    [anon_sym_equals] = ACTIONS(5816),
    [anon_sym_by] = ACTIONS(5816),
    [anon_sym_as] = ACTIONS(5816),
    [anon_sym_is] = ACTIONS(5816),
    [anon_sym_DASH_GT] = ACTIONS(5816),
    [anon_sym_with] = ACTIONS(5816),
    [aux_sym_preproc_if_token3] = ACTIONS(5816),
    [aux_sym_preproc_else_token1] = ACTIONS(5816),
    [aux_sym_preproc_elif_token1] = ACTIONS(5816),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4275] = {
    [sym__name] = STATE(7759),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(9713),
    [sym_implicit_type] = STATE(8901),
    [sym_array_type] = STATE(8236),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(8217),
    [sym_pointer_type] = STATE(8217),
    [sym__pointer_base_type] = STATE(9650),
    [sym_function_pointer_type] = STATE(8217),
    [sym_function_pointer_parameter] = STATE(9350),
    [sym_ref_type] = STATE(8704),
    [sym__ref_base_type] = STATE(9351),
    [sym_scoped_type] = STATE(8704),
    [sym_tuple_type] = STATE(8136),
    [sym_identifier] = STATE(4921),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4275),
    [sym_preproc_endregion] = STATE(4275),
    [sym_preproc_line] = STATE(4275),
    [sym_preproc_pragma] = STATE(4275),
    [sym_preproc_nullable] = STATE(4275),
    [sym_preproc_error] = STATE(4275),
    [sym_preproc_define] = STATE(4275),
    [sym_preproc_undef] = STATE(4275),
    [aux_sym_function_pointer_type_repeat1] = STATE(4272),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_LPAREN] = ACTIONS(2995),
    [anon_sym_ref] = ACTIONS(5882),
    [anon_sym_delegate] = ACTIONS(5659),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_in] = ACTIONS(5884),
    [anon_sym_out] = ACTIONS(5884),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(5886),
    [anon_sym_var] = ACTIONS(5284),
    [sym_predefined_type] = ACTIONS(5888),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4276] = {
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(6969),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9567),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4276),
    [sym_preproc_endregion] = STATE(4276),
    [sym_preproc_line] = STATE(4276),
    [sym_preproc_pragma] = STATE(4276),
    [sym_preproc_nullable] = STATE(4276),
    [sym_preproc_error] = STATE(4276),
    [sym_preproc_define] = STATE(4276),
    [sym_preproc_undef] = STATE(4276),
    [aux_sym_lambda_expression_repeat1] = STATE(6864),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4277] = {
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7118),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9781),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4277),
    [sym_preproc_endregion] = STATE(4277),
    [sym_preproc_line] = STATE(4277),
    [sym_preproc_pragma] = STATE(4277),
    [sym_preproc_nullable] = STATE(4277),
    [sym_preproc_error] = STATE(4277),
    [sym_preproc_define] = STATE(4277),
    [sym_preproc_undef] = STATE(4277),
    [aux_sym_lambda_expression_repeat1] = STATE(6864),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(5908),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4278] = {
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(6931),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9719),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4278),
    [sym_preproc_endregion] = STATE(4278),
    [sym_preproc_line] = STATE(4278),
    [sym_preproc_pragma] = STATE(4278),
    [sym_preproc_nullable] = STATE(4278),
    [sym_preproc_error] = STATE(4278),
    [sym_preproc_define] = STATE(4278),
    [sym_preproc_undef] = STATE(4278),
    [aux_sym_lambda_expression_repeat1] = STATE(6864),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4279] = {
    [sym__name] = STATE(7759),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(9569),
    [sym_implicit_type] = STATE(8901),
    [sym_array_type] = STATE(8236),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(8217),
    [sym_pointer_type] = STATE(8217),
    [sym__pointer_base_type] = STATE(9650),
    [sym_function_pointer_type] = STATE(8217),
    [sym_function_pointer_parameter] = STATE(9350),
    [sym_ref_type] = STATE(8704),
    [sym__ref_base_type] = STATE(9351),
    [sym_scoped_type] = STATE(8704),
    [sym_tuple_type] = STATE(8136),
    [sym_identifier] = STATE(4921),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4279),
    [sym_preproc_endregion] = STATE(4279),
    [sym_preproc_line] = STATE(4279),
    [sym_preproc_pragma] = STATE(4279),
    [sym_preproc_nullable] = STATE(4279),
    [sym_preproc_error] = STATE(4279),
    [sym_preproc_define] = STATE(4279),
    [sym_preproc_undef] = STATE(4279),
    [aux_sym_function_pointer_type_repeat1] = STATE(4285),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_LPAREN] = ACTIONS(2995),
    [anon_sym_ref] = ACTIONS(5882),
    [anon_sym_delegate] = ACTIONS(5659),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_in] = ACTIONS(5884),
    [anon_sym_out] = ACTIONS(5884),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(5886),
    [anon_sym_var] = ACTIONS(5284),
    [sym_predefined_type] = ACTIONS(5888),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4280] = {
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7017),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9735),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4280),
    [sym_preproc_endregion] = STATE(4280),
    [sym_preproc_line] = STATE(4280),
    [sym_preproc_pragma] = STATE(4280),
    [sym_preproc_nullable] = STATE(4280),
    [sym_preproc_error] = STATE(4280),
    [sym_preproc_define] = STATE(4280),
    [sym_preproc_undef] = STATE(4280),
    [aux_sym_lambda_expression_repeat1] = STATE(6864),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(5890),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4281] = {
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7122),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9596),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4281),
    [sym_preproc_endregion] = STATE(4281),
    [sym_preproc_line] = STATE(4281),
    [sym_preproc_pragma] = STATE(4281),
    [sym_preproc_nullable] = STATE(4281),
    [sym_preproc_error] = STATE(4281),
    [sym_preproc_define] = STATE(4281),
    [sym_preproc_undef] = STATE(4281),
    [aux_sym_lambda_expression_repeat1] = STATE(6864),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4282] = {
    [sym_preproc_region] = STATE(4282),
    [sym_preproc_endregion] = STATE(4282),
    [sym_preproc_line] = STATE(4282),
    [sym_preproc_pragma] = STATE(4282),
    [sym_preproc_nullable] = STATE(4282),
    [sym_preproc_error] = STATE(4282),
    [sym_preproc_define] = STATE(4282),
    [sym_preproc_undef] = STATE(4282),
    [anon_sym_SEMI] = ACTIONS(5345),
    [anon_sym_LBRACK] = ACTIONS(5345),
    [anon_sym_COLON] = ACTIONS(5345),
    [anon_sym_COMMA] = ACTIONS(5345),
    [anon_sym_RBRACK] = ACTIONS(5345),
    [anon_sym_LPAREN] = ACTIONS(5345),
    [anon_sym_RPAREN] = ACTIONS(5345),
    [anon_sym_RBRACE] = ACTIONS(5345),
    [anon_sym_LT] = ACTIONS(5347),
    [anon_sym_GT] = ACTIONS(5347),
    [anon_sym_in] = ACTIONS(5345),
    [anon_sym_QMARK] = ACTIONS(5347),
    [anon_sym_BANG] = ACTIONS(5347),
    [anon_sym_PLUS_PLUS] = ACTIONS(5345),
    [anon_sym_DASH_DASH] = ACTIONS(5345),
    [anon_sym_PLUS] = ACTIONS(5347),
    [anon_sym_DASH] = ACTIONS(5347),
    [anon_sym_STAR] = ACTIONS(5345),
    [anon_sym_SLASH] = ACTIONS(5347),
    [anon_sym_PERCENT] = ACTIONS(5345),
    [anon_sym_CARET] = ACTIONS(5345),
    [anon_sym_PIPE] = ACTIONS(5347),
    [anon_sym_AMP] = ACTIONS(5347),
    [anon_sym_LT_LT] = ACTIONS(5345),
    [anon_sym_GT_GT] = ACTIONS(5347),
    [anon_sym_GT_GT_GT] = ACTIONS(5345),
    [anon_sym_EQ_EQ] = ACTIONS(5345),
    [anon_sym_BANG_EQ] = ACTIONS(5345),
    [anon_sym_GT_EQ] = ACTIONS(5345),
    [anon_sym_LT_EQ] = ACTIONS(5345),
    [anon_sym_DOT] = ACTIONS(5347),
    [anon_sym_EQ_GT] = ACTIONS(5345),
    [anon_sym_switch] = ACTIONS(5345),
    [anon_sym_when] = ACTIONS(5345),
    [anon_sym_DOT_DOT] = ACTIONS(5345),
    [anon_sym_and] = ACTIONS(5345),
    [anon_sym_or] = ACTIONS(5345),
    [anon_sym_AMP_AMP] = ACTIONS(5345),
    [anon_sym_PIPE_PIPE] = ACTIONS(5345),
    [anon_sym_QMARK_QMARK] = ACTIONS(5345),
    [anon_sym_on] = ACTIONS(5345),
    [anon_sym_equals] = ACTIONS(5345),
    [anon_sym_by] = ACTIONS(5345),
    [anon_sym_as] = ACTIONS(5345),
    [anon_sym_is] = ACTIONS(5345),
    [anon_sym_DASH_GT] = ACTIONS(5345),
    [anon_sym_with] = ACTIONS(5345),
    [aux_sym_preproc_if_token3] = ACTIONS(5345),
    [aux_sym_preproc_else_token1] = ACTIONS(5345),
    [aux_sym_preproc_elif_token1] = ACTIONS(5345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4283] = {
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7021),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9910),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4283),
    [sym_preproc_endregion] = STATE(4283),
    [sym_preproc_line] = STATE(4283),
    [sym_preproc_pragma] = STATE(4283),
    [sym_preproc_nullable] = STATE(4283),
    [sym_preproc_error] = STATE(4283),
    [sym_preproc_define] = STATE(4283),
    [sym_preproc_undef] = STATE(4283),
    [aux_sym_lambda_expression_repeat1] = STATE(6864),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(5896),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4284] = {
    [sym_type_parameter_constraint] = STATE(8160),
    [sym_constructor_constraint] = STATE(8100),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(8168),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_identifier] = STATE(4921),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4284),
    [sym_preproc_endregion] = STATE(4284),
    [sym_preproc_line] = STATE(4284),
    [sym_preproc_pragma] = STATE(4284),
    [sym_preproc_nullable] = STATE(4284),
    [sym_preproc_error] = STATE(4284),
    [sym_preproc_define] = STATE(4284),
    [sym_preproc_undef] = STATE(4284),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_LPAREN] = ACTIONS(2995),
    [anon_sym_class] = ACTIONS(5910),
    [anon_sym_ref] = ACTIONS(5912),
    [anon_sym_struct] = ACTIONS(5914),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_new] = ACTIONS(5916),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(5918),
    [anon_sym_unmanaged] = ACTIONS(5918),
    [anon_sym_scoped] = ACTIONS(5920),
    [anon_sym_var] = ACTIONS(5284),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4285] = {
    [sym__name] = STATE(7759),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(9613),
    [sym_implicit_type] = STATE(8901),
    [sym_array_type] = STATE(8236),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(8217),
    [sym_pointer_type] = STATE(8217),
    [sym__pointer_base_type] = STATE(9650),
    [sym_function_pointer_type] = STATE(8217),
    [sym_function_pointer_parameter] = STATE(9350),
    [sym_ref_type] = STATE(8704),
    [sym__ref_base_type] = STATE(9351),
    [sym_scoped_type] = STATE(8704),
    [sym_tuple_type] = STATE(8136),
    [sym_identifier] = STATE(4921),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4285),
    [sym_preproc_endregion] = STATE(4285),
    [sym_preproc_line] = STATE(4285),
    [sym_preproc_pragma] = STATE(4285),
    [sym_preproc_nullable] = STATE(4285),
    [sym_preproc_error] = STATE(4285),
    [sym_preproc_define] = STATE(4285),
    [sym_preproc_undef] = STATE(4285),
    [aux_sym_function_pointer_type_repeat1] = STATE(4464),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_LPAREN] = ACTIONS(2995),
    [anon_sym_ref] = ACTIONS(5882),
    [anon_sym_delegate] = ACTIONS(5659),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_in] = ACTIONS(5884),
    [anon_sym_out] = ACTIONS(5884),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(5886),
    [anon_sym_var] = ACTIONS(5284),
    [sym_predefined_type] = ACTIONS(5888),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4286] = {
    [sym_preproc_region] = STATE(4286),
    [sym_preproc_endregion] = STATE(4286),
    [sym_preproc_line] = STATE(4286),
    [sym_preproc_pragma] = STATE(4286),
    [sym_preproc_nullable] = STATE(4286),
    [sym_preproc_error] = STATE(4286),
    [sym_preproc_define] = STATE(4286),
    [sym_preproc_undef] = STATE(4286),
    [anon_sym_SEMI] = ACTIONS(5808),
    [anon_sym_LBRACK] = ACTIONS(5808),
    [anon_sym_COLON] = ACTIONS(5808),
    [anon_sym_COMMA] = ACTIONS(5808),
    [anon_sym_RBRACK] = ACTIONS(5808),
    [anon_sym_LPAREN] = ACTIONS(5808),
    [anon_sym_RPAREN] = ACTIONS(5808),
    [anon_sym_RBRACE] = ACTIONS(5808),
    [anon_sym_LT] = ACTIONS(5810),
    [anon_sym_GT] = ACTIONS(5810),
    [anon_sym_in] = ACTIONS(5808),
    [anon_sym_QMARK] = ACTIONS(5810),
    [anon_sym_BANG] = ACTIONS(5810),
    [anon_sym_PLUS_PLUS] = ACTIONS(5808),
    [anon_sym_DASH_DASH] = ACTIONS(5808),
    [anon_sym_PLUS] = ACTIONS(5810),
    [anon_sym_DASH] = ACTIONS(5810),
    [anon_sym_STAR] = ACTIONS(5808),
    [anon_sym_SLASH] = ACTIONS(5810),
    [anon_sym_PERCENT] = ACTIONS(5808),
    [anon_sym_CARET] = ACTIONS(5808),
    [anon_sym_PIPE] = ACTIONS(5810),
    [anon_sym_AMP] = ACTIONS(5810),
    [anon_sym_LT_LT] = ACTIONS(5808),
    [anon_sym_GT_GT] = ACTIONS(5810),
    [anon_sym_GT_GT_GT] = ACTIONS(5808),
    [anon_sym_EQ_EQ] = ACTIONS(5808),
    [anon_sym_BANG_EQ] = ACTIONS(5808),
    [anon_sym_GT_EQ] = ACTIONS(5808),
    [anon_sym_LT_EQ] = ACTIONS(5808),
    [anon_sym_DOT] = ACTIONS(5810),
    [anon_sym_EQ_GT] = ACTIONS(5808),
    [anon_sym_switch] = ACTIONS(5808),
    [anon_sym_when] = ACTIONS(5808),
    [anon_sym_DOT_DOT] = ACTIONS(5808),
    [anon_sym_and] = ACTIONS(5808),
    [anon_sym_or] = ACTIONS(5808),
    [anon_sym_AMP_AMP] = ACTIONS(5808),
    [anon_sym_PIPE_PIPE] = ACTIONS(5808),
    [anon_sym_QMARK_QMARK] = ACTIONS(5808),
    [anon_sym_on] = ACTIONS(5808),
    [anon_sym_equals] = ACTIONS(5808),
    [anon_sym_by] = ACTIONS(5808),
    [anon_sym_as] = ACTIONS(5808),
    [anon_sym_is] = ACTIONS(5808),
    [anon_sym_DASH_GT] = ACTIONS(5808),
    [anon_sym_with] = ACTIONS(5808),
    [aux_sym_preproc_if_token3] = ACTIONS(5808),
    [aux_sym_preproc_else_token1] = ACTIONS(5808),
    [aux_sym_preproc_elif_token1] = ACTIONS(5808),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4287] = {
    [sym__name] = STATE(7759),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(9613),
    [sym_implicit_type] = STATE(8901),
    [sym_array_type] = STATE(8236),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(8217),
    [sym_pointer_type] = STATE(8217),
    [sym__pointer_base_type] = STATE(9650),
    [sym_function_pointer_type] = STATE(8217),
    [sym_function_pointer_parameter] = STATE(9350),
    [sym_ref_type] = STATE(8704),
    [sym__ref_base_type] = STATE(9351),
    [sym_scoped_type] = STATE(8704),
    [sym_tuple_type] = STATE(8136),
    [sym_identifier] = STATE(4921),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4287),
    [sym_preproc_endregion] = STATE(4287),
    [sym_preproc_line] = STATE(4287),
    [sym_preproc_pragma] = STATE(4287),
    [sym_preproc_nullable] = STATE(4287),
    [sym_preproc_error] = STATE(4287),
    [sym_preproc_define] = STATE(4287),
    [sym_preproc_undef] = STATE(4287),
    [aux_sym_function_pointer_type_repeat1] = STATE(4145),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_LPAREN] = ACTIONS(2995),
    [anon_sym_ref] = ACTIONS(5882),
    [anon_sym_delegate] = ACTIONS(5659),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_in] = ACTIONS(5884),
    [anon_sym_out] = ACTIONS(5884),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(5886),
    [anon_sym_var] = ACTIONS(5284),
    [sym_predefined_type] = ACTIONS(5888),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4288] = {
    [sym_preproc_region] = STATE(4288),
    [sym_preproc_endregion] = STATE(4288),
    [sym_preproc_line] = STATE(4288),
    [sym_preproc_pragma] = STATE(4288),
    [sym_preproc_nullable] = STATE(4288),
    [sym_preproc_error] = STATE(4288),
    [sym_preproc_define] = STATE(4288),
    [sym_preproc_undef] = STATE(4288),
    [anon_sym_EQ] = ACTIONS(5956),
    [anon_sym_LBRACK] = ACTIONS(5249),
    [anon_sym_LPAREN] = ACTIONS(5249),
    [anon_sym_LT] = ACTIONS(5251),
    [anon_sym_GT] = ACTIONS(5251),
    [anon_sym_QMARK] = ACTIONS(5251),
    [anon_sym_BANG] = ACTIONS(5251),
    [anon_sym_PLUS_PLUS] = ACTIONS(5249),
    [anon_sym_DASH_DASH] = ACTIONS(5249),
    [anon_sym_PLUS] = ACTIONS(5251),
    [anon_sym_DASH] = ACTIONS(5251),
    [anon_sym_STAR] = ACTIONS(5251),
    [anon_sym_SLASH] = ACTIONS(5251),
    [anon_sym_PERCENT] = ACTIONS(5251),
    [anon_sym_CARET] = ACTIONS(5251),
    [anon_sym_PIPE] = ACTIONS(5251),
    [anon_sym_AMP] = ACTIONS(5251),
    [anon_sym_LT_LT] = ACTIONS(5251),
    [anon_sym_GT_GT] = ACTIONS(5251),
    [anon_sym_GT_GT_GT] = ACTIONS(5251),
    [anon_sym_EQ_EQ] = ACTIONS(5249),
    [anon_sym_BANG_EQ] = ACTIONS(5249),
    [anon_sym_GT_EQ] = ACTIONS(5249),
    [anon_sym_LT_EQ] = ACTIONS(5249),
    [anon_sym_DOT] = ACTIONS(5251),
    [anon_sym_switch] = ACTIONS(5249),
    [anon_sym_DOT_DOT] = ACTIONS(5249),
    [anon_sym_and] = ACTIONS(5249),
    [anon_sym_or] = ACTIONS(5249),
    [anon_sym_PLUS_EQ] = ACTIONS(5958),
    [anon_sym_DASH_EQ] = ACTIONS(5958),
    [anon_sym_STAR_EQ] = ACTIONS(5958),
    [anon_sym_SLASH_EQ] = ACTIONS(5958),
    [anon_sym_PERCENT_EQ] = ACTIONS(5958),
    [anon_sym_AMP_EQ] = ACTIONS(5958),
    [anon_sym_CARET_EQ] = ACTIONS(5958),
    [anon_sym_PIPE_EQ] = ACTIONS(5958),
    [anon_sym_LT_LT_EQ] = ACTIONS(5958),
    [anon_sym_GT_GT_EQ] = ACTIONS(5958),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5958),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(5958),
    [anon_sym_AMP_AMP] = ACTIONS(5249),
    [anon_sym_PIPE_PIPE] = ACTIONS(5249),
    [anon_sym_QMARK_QMARK] = ACTIONS(5251),
    [anon_sym_into] = ACTIONS(5249),
    [anon_sym_by] = ACTIONS(5249),
    [anon_sym_as] = ACTIONS(5249),
    [anon_sym_is] = ACTIONS(5249),
    [anon_sym_DASH_GT] = ACTIONS(5249),
    [anon_sym_with] = ACTIONS(5249),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4289] = {
    [sym_preproc_region] = STATE(4289),
    [sym_preproc_endregion] = STATE(4289),
    [sym_preproc_line] = STATE(4289),
    [sym_preproc_pragma] = STATE(4289),
    [sym_preproc_nullable] = STATE(4289),
    [sym_preproc_error] = STATE(4289),
    [sym_preproc_define] = STATE(4289),
    [sym_preproc_undef] = STATE(4289),
    [anon_sym_SEMI] = ACTIONS(5761),
    [anon_sym_LBRACK] = ACTIONS(5761),
    [anon_sym_COLON] = ACTIONS(5761),
    [anon_sym_COMMA] = ACTIONS(5761),
    [anon_sym_RBRACK] = ACTIONS(5761),
    [anon_sym_LPAREN] = ACTIONS(5761),
    [anon_sym_RPAREN] = ACTIONS(5761),
    [anon_sym_RBRACE] = ACTIONS(5761),
    [anon_sym_LT] = ACTIONS(5763),
    [anon_sym_GT] = ACTIONS(5763),
    [anon_sym_in] = ACTIONS(5761),
    [anon_sym_QMARK] = ACTIONS(5763),
    [anon_sym_BANG] = ACTIONS(5763),
    [anon_sym_PLUS_PLUS] = ACTIONS(5761),
    [anon_sym_DASH_DASH] = ACTIONS(5761),
    [anon_sym_PLUS] = ACTIONS(5763),
    [anon_sym_DASH] = ACTIONS(5763),
    [anon_sym_STAR] = ACTIONS(5761),
    [anon_sym_SLASH] = ACTIONS(5763),
    [anon_sym_PERCENT] = ACTIONS(5761),
    [anon_sym_CARET] = ACTIONS(5761),
    [anon_sym_PIPE] = ACTIONS(5763),
    [anon_sym_AMP] = ACTIONS(5763),
    [anon_sym_LT_LT] = ACTIONS(5761),
    [anon_sym_GT_GT] = ACTIONS(5763),
    [anon_sym_GT_GT_GT] = ACTIONS(5761),
    [anon_sym_EQ_EQ] = ACTIONS(5761),
    [anon_sym_BANG_EQ] = ACTIONS(5761),
    [anon_sym_GT_EQ] = ACTIONS(5761),
    [anon_sym_LT_EQ] = ACTIONS(5761),
    [anon_sym_DOT] = ACTIONS(5763),
    [anon_sym_EQ_GT] = ACTIONS(5761),
    [anon_sym_switch] = ACTIONS(5761),
    [anon_sym_when] = ACTIONS(5761),
    [anon_sym_DOT_DOT] = ACTIONS(5761),
    [anon_sym_and] = ACTIONS(5761),
    [anon_sym_or] = ACTIONS(5761),
    [anon_sym_AMP_AMP] = ACTIONS(5761),
    [anon_sym_PIPE_PIPE] = ACTIONS(5761),
    [anon_sym_QMARK_QMARK] = ACTIONS(5761),
    [anon_sym_on] = ACTIONS(5761),
    [anon_sym_equals] = ACTIONS(5761),
    [anon_sym_by] = ACTIONS(5761),
    [anon_sym_as] = ACTIONS(5761),
    [anon_sym_is] = ACTIONS(5761),
    [anon_sym_DASH_GT] = ACTIONS(5761),
    [anon_sym_with] = ACTIONS(5761),
    [aux_sym_preproc_if_token3] = ACTIONS(5761),
    [aux_sym_preproc_else_token1] = ACTIONS(5761),
    [aux_sym_preproc_elif_token1] = ACTIONS(5761),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4290] = {
    [sym_preproc_region] = STATE(4290),
    [sym_preproc_endregion] = STATE(4290),
    [sym_preproc_line] = STATE(4290),
    [sym_preproc_pragma] = STATE(4290),
    [sym_preproc_nullable] = STATE(4290),
    [sym_preproc_error] = STATE(4290),
    [sym_preproc_define] = STATE(4290),
    [sym_preproc_undef] = STATE(4290),
    [anon_sym_SEMI] = ACTIONS(4739),
    [anon_sym_LBRACK] = ACTIONS(5786),
    [anon_sym_COLON] = ACTIONS(4739),
    [anon_sym_COMMA] = ACTIONS(4739),
    [anon_sym_RBRACK] = ACTIONS(4739),
    [anon_sym_LPAREN] = ACTIONS(5786),
    [anon_sym_RPAREN] = ACTIONS(4739),
    [anon_sym_RBRACE] = ACTIONS(4739),
    [anon_sym_LT] = ACTIONS(5789),
    [anon_sym_GT] = ACTIONS(5789),
    [anon_sym_in] = ACTIONS(4739),
    [anon_sym_QMARK] = ACTIONS(5789),
    [anon_sym_BANG] = ACTIONS(5789),
    [anon_sym_PLUS_PLUS] = ACTIONS(5786),
    [anon_sym_DASH_DASH] = ACTIONS(5786),
    [anon_sym_PLUS] = ACTIONS(5789),
    [anon_sym_DASH] = ACTIONS(5789),
    [anon_sym_STAR] = ACTIONS(5786),
    [anon_sym_SLASH] = ACTIONS(5789),
    [anon_sym_PERCENT] = ACTIONS(5786),
    [anon_sym_CARET] = ACTIONS(5786),
    [anon_sym_PIPE] = ACTIONS(5789),
    [anon_sym_AMP] = ACTIONS(5789),
    [anon_sym_LT_LT] = ACTIONS(5786),
    [anon_sym_GT_GT] = ACTIONS(5789),
    [anon_sym_GT_GT_GT] = ACTIONS(5786),
    [anon_sym_EQ_EQ] = ACTIONS(5786),
    [anon_sym_BANG_EQ] = ACTIONS(5786),
    [anon_sym_GT_EQ] = ACTIONS(5786),
    [anon_sym_LT_EQ] = ACTIONS(5786),
    [anon_sym_DOT] = ACTIONS(5789),
    [anon_sym_EQ_GT] = ACTIONS(4739),
    [anon_sym_switch] = ACTIONS(5786),
    [anon_sym_when] = ACTIONS(4739),
    [anon_sym_DOT_DOT] = ACTIONS(5786),
    [anon_sym_and] = ACTIONS(4739),
    [anon_sym_or] = ACTIONS(4739),
    [anon_sym_AMP_AMP] = ACTIONS(5786),
    [anon_sym_PIPE_PIPE] = ACTIONS(5786),
    [anon_sym_QMARK_QMARK] = ACTIONS(5786),
    [anon_sym_on] = ACTIONS(4739),
    [anon_sym_equals] = ACTIONS(4739),
    [anon_sym_by] = ACTIONS(4739),
    [anon_sym_as] = ACTIONS(5786),
    [anon_sym_is] = ACTIONS(5786),
    [anon_sym_DASH_GT] = ACTIONS(5786),
    [anon_sym_with] = ACTIONS(5786),
    [aux_sym_preproc_if_token3] = ACTIONS(4739),
    [aux_sym_preproc_else_token1] = ACTIONS(4739),
    [aux_sym_preproc_elif_token1] = ACTIONS(4739),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4291] = {
    [sym_preproc_region] = STATE(4291),
    [sym_preproc_endregion] = STATE(4291),
    [sym_preproc_line] = STATE(4291),
    [sym_preproc_pragma] = STATE(4291),
    [sym_preproc_nullable] = STATE(4291),
    [sym_preproc_error] = STATE(4291),
    [sym_preproc_define] = STATE(4291),
    [sym_preproc_undef] = STATE(4291),
    [anon_sym_EQ] = ACTIONS(5960),
    [anon_sym_LBRACK] = ACTIONS(5249),
    [anon_sym_COLON] = ACTIONS(5249),
    [anon_sym_LPAREN] = ACTIONS(5249),
    [anon_sym_LT] = ACTIONS(5251),
    [anon_sym_GT] = ACTIONS(5251),
    [anon_sym_QMARK] = ACTIONS(5251),
    [anon_sym_BANG] = ACTIONS(5251),
    [anon_sym_PLUS_PLUS] = ACTIONS(5249),
    [anon_sym_DASH_DASH] = ACTIONS(5249),
    [anon_sym_PLUS] = ACTIONS(5251),
    [anon_sym_DASH] = ACTIONS(5251),
    [anon_sym_STAR] = ACTIONS(5251),
    [anon_sym_SLASH] = ACTIONS(5251),
    [anon_sym_PERCENT] = ACTIONS(5251),
    [anon_sym_CARET] = ACTIONS(5251),
    [anon_sym_PIPE] = ACTIONS(5251),
    [anon_sym_AMP] = ACTIONS(5251),
    [anon_sym_LT_LT] = ACTIONS(5251),
    [anon_sym_GT_GT] = ACTIONS(5251),
    [anon_sym_GT_GT_GT] = ACTIONS(5251),
    [anon_sym_EQ_EQ] = ACTIONS(5249),
    [anon_sym_BANG_EQ] = ACTIONS(5249),
    [anon_sym_GT_EQ] = ACTIONS(5249),
    [anon_sym_LT_EQ] = ACTIONS(5249),
    [anon_sym_DOT] = ACTIONS(5251),
    [anon_sym_switch] = ACTIONS(5249),
    [anon_sym_when] = ACTIONS(5249),
    [anon_sym_DOT_DOT] = ACTIONS(5249),
    [anon_sym_and] = ACTIONS(5249),
    [anon_sym_or] = ACTIONS(5249),
    [anon_sym_PLUS_EQ] = ACTIONS(5962),
    [anon_sym_DASH_EQ] = ACTIONS(5962),
    [anon_sym_STAR_EQ] = ACTIONS(5962),
    [anon_sym_SLASH_EQ] = ACTIONS(5962),
    [anon_sym_PERCENT_EQ] = ACTIONS(5962),
    [anon_sym_AMP_EQ] = ACTIONS(5962),
    [anon_sym_CARET_EQ] = ACTIONS(5962),
    [anon_sym_PIPE_EQ] = ACTIONS(5962),
    [anon_sym_LT_LT_EQ] = ACTIONS(5962),
    [anon_sym_GT_GT_EQ] = ACTIONS(5962),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5962),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(5962),
    [anon_sym_AMP_AMP] = ACTIONS(5249),
    [anon_sym_PIPE_PIPE] = ACTIONS(5249),
    [anon_sym_QMARK_QMARK] = ACTIONS(5251),
    [anon_sym_as] = ACTIONS(5249),
    [anon_sym_is] = ACTIONS(5249),
    [anon_sym_DASH_GT] = ACTIONS(5249),
    [anon_sym_with] = ACTIONS(5249),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4292] = {
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7107),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9785),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4292),
    [sym_preproc_endregion] = STATE(4292),
    [sym_preproc_line] = STATE(4292),
    [sym_preproc_pragma] = STATE(4292),
    [sym_preproc_nullable] = STATE(4292),
    [sym_preproc_error] = STATE(4292),
    [sym_preproc_define] = STATE(4292),
    [sym_preproc_undef] = STATE(4292),
    [aux_sym_lambda_expression_repeat1] = STATE(6864),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4293] = {
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(6990),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9164),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4293),
    [sym_preproc_endregion] = STATE(4293),
    [sym_preproc_line] = STATE(4293),
    [sym_preproc_pragma] = STATE(4293),
    [sym_preproc_nullable] = STATE(4293),
    [sym_preproc_error] = STATE(4293),
    [sym_preproc_define] = STATE(4293),
    [sym_preproc_undef] = STATE(4293),
    [aux_sym_lambda_expression_repeat1] = STATE(6864),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(5890),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4294] = {
    [sym_preproc_region] = STATE(4294),
    [sym_preproc_endregion] = STATE(4294),
    [sym_preproc_line] = STATE(4294),
    [sym_preproc_pragma] = STATE(4294),
    [sym_preproc_nullable] = STATE(4294),
    [sym_preproc_error] = STATE(4294),
    [sym_preproc_define] = STATE(4294),
    [sym_preproc_undef] = STATE(4294),
    [anon_sym_SEMI] = ACTIONS(4739),
    [anon_sym_LBRACK] = ACTIONS(5792),
    [anon_sym_COLON] = ACTIONS(4739),
    [anon_sym_COMMA] = ACTIONS(4739),
    [anon_sym_RBRACK] = ACTIONS(4739),
    [anon_sym_LPAREN] = ACTIONS(5792),
    [anon_sym_RPAREN] = ACTIONS(4739),
    [anon_sym_RBRACE] = ACTIONS(4739),
    [anon_sym_LT] = ACTIONS(5795),
    [anon_sym_GT] = ACTIONS(5795),
    [anon_sym_in] = ACTIONS(4739),
    [anon_sym_QMARK] = ACTIONS(5795),
    [anon_sym_BANG] = ACTIONS(5795),
    [anon_sym_PLUS_PLUS] = ACTIONS(5792),
    [anon_sym_DASH_DASH] = ACTIONS(5792),
    [anon_sym_PLUS] = ACTIONS(5795),
    [anon_sym_DASH] = ACTIONS(5795),
    [anon_sym_STAR] = ACTIONS(5792),
    [anon_sym_SLASH] = ACTIONS(5795),
    [anon_sym_PERCENT] = ACTIONS(5792),
    [anon_sym_CARET] = ACTIONS(5792),
    [anon_sym_PIPE] = ACTIONS(5795),
    [anon_sym_AMP] = ACTIONS(5795),
    [anon_sym_LT_LT] = ACTIONS(5792),
    [anon_sym_GT_GT] = ACTIONS(5795),
    [anon_sym_GT_GT_GT] = ACTIONS(5792),
    [anon_sym_EQ_EQ] = ACTIONS(5792),
    [anon_sym_BANG_EQ] = ACTIONS(5792),
    [anon_sym_GT_EQ] = ACTIONS(5792),
    [anon_sym_LT_EQ] = ACTIONS(5792),
    [anon_sym_DOT] = ACTIONS(5795),
    [anon_sym_EQ_GT] = ACTIONS(4739),
    [anon_sym_switch] = ACTIONS(5792),
    [anon_sym_when] = ACTIONS(4739),
    [anon_sym_DOT_DOT] = ACTIONS(5792),
    [anon_sym_and] = ACTIONS(4739),
    [anon_sym_or] = ACTIONS(4739),
    [anon_sym_AMP_AMP] = ACTIONS(5792),
    [anon_sym_PIPE_PIPE] = ACTIONS(5792),
    [anon_sym_QMARK_QMARK] = ACTIONS(5792),
    [anon_sym_on] = ACTIONS(4739),
    [anon_sym_equals] = ACTIONS(4739),
    [anon_sym_by] = ACTIONS(4739),
    [anon_sym_as] = ACTIONS(5792),
    [anon_sym_is] = ACTIONS(5792),
    [anon_sym_DASH_GT] = ACTIONS(5792),
    [anon_sym_with] = ACTIONS(5792),
    [aux_sym_preproc_if_token3] = ACTIONS(4739),
    [aux_sym_preproc_else_token1] = ACTIONS(4739),
    [aux_sym_preproc_elif_token1] = ACTIONS(4739),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4295] = {
    [sym_preproc_region] = STATE(4295),
    [sym_preproc_endregion] = STATE(4295),
    [sym_preproc_line] = STATE(4295),
    [sym_preproc_pragma] = STATE(4295),
    [sym_preproc_nullable] = STATE(4295),
    [sym_preproc_error] = STATE(4295),
    [sym_preproc_define] = STATE(4295),
    [sym_preproc_undef] = STATE(4295),
    [anon_sym_EQ] = ACTIONS(5964),
    [anon_sym_LBRACK] = ACTIONS(5249),
    [anon_sym_COLON] = ACTIONS(5249),
    [anon_sym_COMMA] = ACTIONS(5249),
    [anon_sym_LPAREN] = ACTIONS(5249),
    [anon_sym_LT] = ACTIONS(5251),
    [anon_sym_GT] = ACTIONS(5251),
    [anon_sym_QMARK] = ACTIONS(5251),
    [anon_sym_BANG] = ACTIONS(5251),
    [anon_sym_PLUS_PLUS] = ACTIONS(5249),
    [anon_sym_DASH_DASH] = ACTIONS(5249),
    [anon_sym_PLUS] = ACTIONS(5251),
    [anon_sym_DASH] = ACTIONS(5251),
    [anon_sym_STAR] = ACTIONS(5251),
    [anon_sym_SLASH] = ACTIONS(5251),
    [anon_sym_PERCENT] = ACTIONS(5251),
    [anon_sym_CARET] = ACTIONS(5251),
    [anon_sym_PIPE] = ACTIONS(5251),
    [anon_sym_AMP] = ACTIONS(5251),
    [anon_sym_LT_LT] = ACTIONS(5251),
    [anon_sym_GT_GT] = ACTIONS(5251),
    [anon_sym_GT_GT_GT] = ACTIONS(5251),
    [anon_sym_EQ_EQ] = ACTIONS(5249),
    [anon_sym_BANG_EQ] = ACTIONS(5249),
    [anon_sym_GT_EQ] = ACTIONS(5249),
    [anon_sym_LT_EQ] = ACTIONS(5249),
    [anon_sym_DOT] = ACTIONS(5251),
    [anon_sym_switch] = ACTIONS(5249),
    [anon_sym_DOT_DOT] = ACTIONS(5249),
    [anon_sym_PLUS_EQ] = ACTIONS(5966),
    [anon_sym_DASH_EQ] = ACTIONS(5966),
    [anon_sym_STAR_EQ] = ACTIONS(5966),
    [anon_sym_SLASH_EQ] = ACTIONS(5966),
    [anon_sym_PERCENT_EQ] = ACTIONS(5966),
    [anon_sym_AMP_EQ] = ACTIONS(5966),
    [anon_sym_CARET_EQ] = ACTIONS(5966),
    [anon_sym_PIPE_EQ] = ACTIONS(5966),
    [anon_sym_LT_LT_EQ] = ACTIONS(5966),
    [anon_sym_GT_GT_EQ] = ACTIONS(5966),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5966),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(5966),
    [anon_sym_AMP_AMP] = ACTIONS(5249),
    [anon_sym_PIPE_PIPE] = ACTIONS(5249),
    [anon_sym_QMARK_QMARK] = ACTIONS(5251),
    [anon_sym_into] = ACTIONS(5249),
    [anon_sym_as] = ACTIONS(5249),
    [anon_sym_is] = ACTIONS(5249),
    [anon_sym_DASH_GT] = ACTIONS(5249),
    [anon_sym_with] = ACTIONS(5249),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(5249),
  },
  [4296] = {
    [sym__name] = STATE(7759),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(9487),
    [sym_implicit_type] = STATE(8901),
    [sym_array_type] = STATE(8236),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(8217),
    [sym_pointer_type] = STATE(8217),
    [sym__pointer_base_type] = STATE(9650),
    [sym_function_pointer_type] = STATE(8217),
    [sym_function_pointer_parameter] = STATE(9350),
    [sym_ref_type] = STATE(8704),
    [sym__ref_base_type] = STATE(9351),
    [sym_scoped_type] = STATE(8704),
    [sym_tuple_type] = STATE(8136),
    [sym_identifier] = STATE(4921),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4296),
    [sym_preproc_endregion] = STATE(4296),
    [sym_preproc_line] = STATE(4296),
    [sym_preproc_pragma] = STATE(4296),
    [sym_preproc_nullable] = STATE(4296),
    [sym_preproc_error] = STATE(4296),
    [sym_preproc_define] = STATE(4296),
    [sym_preproc_undef] = STATE(4296),
    [aux_sym_function_pointer_type_repeat1] = STATE(4464),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_LPAREN] = ACTIONS(2995),
    [anon_sym_ref] = ACTIONS(5882),
    [anon_sym_delegate] = ACTIONS(5659),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_in] = ACTIONS(5884),
    [anon_sym_out] = ACTIONS(5884),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(5886),
    [anon_sym_var] = ACTIONS(5284),
    [sym_predefined_type] = ACTIONS(5888),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4297] = {
    [sym__name] = STATE(7759),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(8990),
    [sym_implicit_type] = STATE(8901),
    [sym_array_type] = STATE(8236),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(8217),
    [sym_pointer_type] = STATE(8217),
    [sym__pointer_base_type] = STATE(9650),
    [sym_function_pointer_type] = STATE(8217),
    [sym_function_pointer_parameter] = STATE(9350),
    [sym_ref_type] = STATE(8704),
    [sym__ref_base_type] = STATE(9351),
    [sym_scoped_type] = STATE(8704),
    [sym_tuple_type] = STATE(8136),
    [sym_identifier] = STATE(4921),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4297),
    [sym_preproc_endregion] = STATE(4297),
    [sym_preproc_line] = STATE(4297),
    [sym_preproc_pragma] = STATE(4297),
    [sym_preproc_nullable] = STATE(4297),
    [sym_preproc_error] = STATE(4297),
    [sym_preproc_define] = STATE(4297),
    [sym_preproc_undef] = STATE(4297),
    [aux_sym_function_pointer_type_repeat1] = STATE(4296),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_LPAREN] = ACTIONS(2995),
    [anon_sym_ref] = ACTIONS(5882),
    [anon_sym_delegate] = ACTIONS(5659),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_in] = ACTIONS(5884),
    [anon_sym_out] = ACTIONS(5884),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(5886),
    [anon_sym_var] = ACTIONS(5284),
    [sym_predefined_type] = ACTIONS(5888),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4298] = {
    [sym__name] = STATE(7759),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(9848),
    [sym_implicit_type] = STATE(8901),
    [sym_array_type] = STATE(8236),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(8217),
    [sym_pointer_type] = STATE(8217),
    [sym__pointer_base_type] = STATE(9650),
    [sym_function_pointer_type] = STATE(8217),
    [sym_function_pointer_parameter] = STATE(9350),
    [sym_ref_type] = STATE(8704),
    [sym__ref_base_type] = STATE(9351),
    [sym_scoped_type] = STATE(8704),
    [sym_tuple_type] = STATE(8136),
    [sym_identifier] = STATE(4921),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4298),
    [sym_preproc_endregion] = STATE(4298),
    [sym_preproc_line] = STATE(4298),
    [sym_preproc_pragma] = STATE(4298),
    [sym_preproc_nullable] = STATE(4298),
    [sym_preproc_error] = STATE(4298),
    [sym_preproc_define] = STATE(4298),
    [sym_preproc_undef] = STATE(4298),
    [aux_sym_function_pointer_type_repeat1] = STATE(4464),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_LPAREN] = ACTIONS(2995),
    [anon_sym_ref] = ACTIONS(5882),
    [anon_sym_delegate] = ACTIONS(5659),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_in] = ACTIONS(5884),
    [anon_sym_out] = ACTIONS(5884),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(5886),
    [anon_sym_var] = ACTIONS(5284),
    [sym_predefined_type] = ACTIONS(5888),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4299] = {
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(6934),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9883),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4299),
    [sym_preproc_endregion] = STATE(4299),
    [sym_preproc_line] = STATE(4299),
    [sym_preproc_pragma] = STATE(4299),
    [sym_preproc_nullable] = STATE(4299),
    [sym_preproc_error] = STATE(4299),
    [sym_preproc_define] = STATE(4299),
    [sym_preproc_undef] = STATE(4299),
    [aux_sym_lambda_expression_repeat1] = STATE(6864),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(5896),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4300] = {
    [sym__name] = STATE(7759),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(8990),
    [sym_implicit_type] = STATE(8901),
    [sym_array_type] = STATE(8236),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(8217),
    [sym_pointer_type] = STATE(8217),
    [sym__pointer_base_type] = STATE(9650),
    [sym_function_pointer_type] = STATE(8217),
    [sym_function_pointer_parameter] = STATE(9350),
    [sym_ref_type] = STATE(8704),
    [sym__ref_base_type] = STATE(9351),
    [sym_scoped_type] = STATE(8704),
    [sym_tuple_type] = STATE(8136),
    [sym_identifier] = STATE(4921),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4300),
    [sym_preproc_endregion] = STATE(4300),
    [sym_preproc_line] = STATE(4300),
    [sym_preproc_pragma] = STATE(4300),
    [sym_preproc_nullable] = STATE(4300),
    [sym_preproc_error] = STATE(4300),
    [sym_preproc_define] = STATE(4300),
    [sym_preproc_undef] = STATE(4300),
    [aux_sym_function_pointer_type_repeat1] = STATE(4464),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_LPAREN] = ACTIONS(2995),
    [anon_sym_ref] = ACTIONS(5882),
    [anon_sym_delegate] = ACTIONS(5659),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_in] = ACTIONS(5884),
    [anon_sym_out] = ACTIONS(5884),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(5886),
    [anon_sym_var] = ACTIONS(5284),
    [sym_predefined_type] = ACTIONS(5888),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4301] = {
    [sym__name] = STATE(7759),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(9075),
    [sym_implicit_type] = STATE(8901),
    [sym_array_type] = STATE(8236),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(8217),
    [sym_pointer_type] = STATE(8217),
    [sym__pointer_base_type] = STATE(9650),
    [sym_function_pointer_type] = STATE(8217),
    [sym_function_pointer_parameter] = STATE(9350),
    [sym_ref_type] = STATE(8704),
    [sym__ref_base_type] = STATE(9351),
    [sym_scoped_type] = STATE(8704),
    [sym_tuple_type] = STATE(8136),
    [sym_identifier] = STATE(4921),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4301),
    [sym_preproc_endregion] = STATE(4301),
    [sym_preproc_line] = STATE(4301),
    [sym_preproc_pragma] = STATE(4301),
    [sym_preproc_nullable] = STATE(4301),
    [sym_preproc_error] = STATE(4301),
    [sym_preproc_define] = STATE(4301),
    [sym_preproc_undef] = STATE(4301),
    [aux_sym_function_pointer_type_repeat1] = STATE(4300),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_LPAREN] = ACTIONS(2995),
    [anon_sym_ref] = ACTIONS(5882),
    [anon_sym_delegate] = ACTIONS(5659),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_in] = ACTIONS(5884),
    [anon_sym_out] = ACTIONS(5884),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(5886),
    [anon_sym_var] = ACTIONS(5284),
    [sym_predefined_type] = ACTIONS(5888),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4302] = {
    [sym_preproc_region] = STATE(4302),
    [sym_preproc_endregion] = STATE(4302),
    [sym_preproc_line] = STATE(4302),
    [sym_preproc_pragma] = STATE(4302),
    [sym_preproc_nullable] = STATE(4302),
    [sym_preproc_error] = STATE(4302),
    [sym_preproc_define] = STATE(4302),
    [sym_preproc_undef] = STATE(4302),
    [anon_sym_SEMI] = ACTIONS(5373),
    [anon_sym_LBRACK] = ACTIONS(5373),
    [anon_sym_COLON] = ACTIONS(5373),
    [anon_sym_COMMA] = ACTIONS(5373),
    [anon_sym_RBRACK] = ACTIONS(5373),
    [anon_sym_LPAREN] = ACTIONS(5373),
    [anon_sym_RPAREN] = ACTIONS(5373),
    [anon_sym_RBRACE] = ACTIONS(5373),
    [anon_sym_LT] = ACTIONS(5375),
    [anon_sym_GT] = ACTIONS(5375),
    [anon_sym_in] = ACTIONS(5373),
    [anon_sym_QMARK] = ACTIONS(5375),
    [anon_sym_BANG] = ACTIONS(5375),
    [anon_sym_PLUS_PLUS] = ACTIONS(5373),
    [anon_sym_DASH_DASH] = ACTIONS(5373),
    [anon_sym_PLUS] = ACTIONS(5375),
    [anon_sym_DASH] = ACTIONS(5375),
    [anon_sym_STAR] = ACTIONS(5373),
    [anon_sym_SLASH] = ACTIONS(5375),
    [anon_sym_PERCENT] = ACTIONS(5373),
    [anon_sym_CARET] = ACTIONS(5373),
    [anon_sym_PIPE] = ACTIONS(5375),
    [anon_sym_AMP] = ACTIONS(5375),
    [anon_sym_LT_LT] = ACTIONS(5373),
    [anon_sym_GT_GT] = ACTIONS(5375),
    [anon_sym_GT_GT_GT] = ACTIONS(5373),
    [anon_sym_EQ_EQ] = ACTIONS(5373),
    [anon_sym_BANG_EQ] = ACTIONS(5373),
    [anon_sym_GT_EQ] = ACTIONS(5373),
    [anon_sym_LT_EQ] = ACTIONS(5373),
    [anon_sym_DOT] = ACTIONS(5375),
    [anon_sym_EQ_GT] = ACTIONS(5373),
    [anon_sym_switch] = ACTIONS(5373),
    [anon_sym_when] = ACTIONS(5373),
    [anon_sym_DOT_DOT] = ACTIONS(5373),
    [anon_sym_and] = ACTIONS(5373),
    [anon_sym_or] = ACTIONS(5373),
    [anon_sym_AMP_AMP] = ACTIONS(5373),
    [anon_sym_PIPE_PIPE] = ACTIONS(5373),
    [anon_sym_QMARK_QMARK] = ACTIONS(5373),
    [anon_sym_on] = ACTIONS(5373),
    [anon_sym_equals] = ACTIONS(5373),
    [anon_sym_by] = ACTIONS(5373),
    [anon_sym_as] = ACTIONS(5373),
    [anon_sym_is] = ACTIONS(5373),
    [anon_sym_DASH_GT] = ACTIONS(5373),
    [anon_sym_with] = ACTIONS(5373),
    [aux_sym_preproc_if_token3] = ACTIONS(5373),
    [aux_sym_preproc_else_token1] = ACTIONS(5373),
    [aux_sym_preproc_elif_token1] = ACTIONS(5373),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4303] = {
    [sym_parameter_list] = STATE(9765),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(6975),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym__lambda_parameters] = STATE(9104),
    [sym_identifier] = STATE(6754),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4303),
    [sym_preproc_endregion] = STATE(4303),
    [sym_preproc_line] = STATE(4303),
    [sym_preproc_pragma] = STATE(4303),
    [sym_preproc_nullable] = STATE(4303),
    [sym_preproc_error] = STATE(4303),
    [sym_preproc_define] = STATE(4303),
    [sym_preproc_undef] = STATE(4303),
    [aux_sym_lambda_expression_repeat1] = STATE(6864),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_async] = ACTIONS(1037),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4304] = {
    [sym__name] = STATE(7759),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(9857),
    [sym_implicit_type] = STATE(8901),
    [sym_array_type] = STATE(8236),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(8217),
    [sym_pointer_type] = STATE(8217),
    [sym__pointer_base_type] = STATE(9650),
    [sym_function_pointer_type] = STATE(8217),
    [sym_function_pointer_parameter] = STATE(9350),
    [sym_ref_type] = STATE(8704),
    [sym__ref_base_type] = STATE(9351),
    [sym_scoped_type] = STATE(8704),
    [sym_tuple_type] = STATE(8136),
    [sym_identifier] = STATE(4921),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4304),
    [sym_preproc_endregion] = STATE(4304),
    [sym_preproc_line] = STATE(4304),
    [sym_preproc_pragma] = STATE(4304),
    [sym_preproc_nullable] = STATE(4304),
    [sym_preproc_error] = STATE(4304),
    [sym_preproc_define] = STATE(4304),
    [sym_preproc_undef] = STATE(4304),
    [aux_sym_function_pointer_type_repeat1] = STATE(4298),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_LPAREN] = ACTIONS(2995),
    [anon_sym_ref] = ACTIONS(5882),
    [anon_sym_delegate] = ACTIONS(5659),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_in] = ACTIONS(5884),
    [anon_sym_out] = ACTIONS(5884),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(5886),
    [anon_sym_var] = ACTIONS(5284),
    [sym_predefined_type] = ACTIONS(5888),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4305] = {
    [sym_preproc_region] = STATE(4305),
    [sym_preproc_endregion] = STATE(4305),
    [sym_preproc_line] = STATE(4305),
    [sym_preproc_pragma] = STATE(4305),
    [sym_preproc_nullable] = STATE(4305),
    [sym_preproc_error] = STATE(4305),
    [sym_preproc_define] = STATE(4305),
    [sym_preproc_undef] = STATE(4305),
    [sym__identifier_token] = ACTIONS(5968),
    [anon_sym_extern] = ACTIONS(5968),
    [anon_sym_alias] = ACTIONS(5968),
    [anon_sym_global] = ACTIONS(5968),
    [anon_sym_unsafe] = ACTIONS(5968),
    [anon_sym_static] = ACTIONS(5968),
    [anon_sym_LBRACK] = ACTIONS(5970),
    [anon_sym_RBRACE] = ACTIONS(5970),
    [anon_sym_abstract] = ACTIONS(5968),
    [anon_sym_async] = ACTIONS(5968),
    [anon_sym_const] = ACTIONS(5968),
    [anon_sym_file] = ACTIONS(5968),
    [anon_sym_fixed] = ACTIONS(5968),
    [anon_sym_internal] = ACTIONS(5968),
    [anon_sym_new] = ACTIONS(5968),
    [anon_sym_override] = ACTIONS(5968),
    [anon_sym_partial] = ACTIONS(5968),
    [anon_sym_private] = ACTIONS(5968),
    [anon_sym_protected] = ACTIONS(5968),
    [anon_sym_public] = ACTIONS(5968),
    [anon_sym_readonly] = ACTIONS(5968),
    [anon_sym_required] = ACTIONS(5968),
    [anon_sym_sealed] = ACTIONS(5968),
    [anon_sym_virtual] = ACTIONS(5968),
    [anon_sym_volatile] = ACTIONS(5968),
    [anon_sym_where] = ACTIONS(5968),
    [anon_sym_notnull] = ACTIONS(5968),
    [anon_sym_unmanaged] = ACTIONS(5968),
    [anon_sym_get] = ACTIONS(5968),
    [anon_sym_set] = ACTIONS(5968),
    [anon_sym_add] = ACTIONS(5968),
    [anon_sym_remove] = ACTIONS(5968),
    [anon_sym_init] = ACTIONS(5968),
    [anon_sym_scoped] = ACTIONS(5968),
    [anon_sym_var] = ACTIONS(5968),
    [anon_sym_yield] = ACTIONS(5968),
    [anon_sym_when] = ACTIONS(5968),
    [anon_sym_from] = ACTIONS(5968),
    [anon_sym_into] = ACTIONS(5968),
    [anon_sym_join] = ACTIONS(5968),
    [anon_sym_on] = ACTIONS(5968),
    [anon_sym_equals] = ACTIONS(5968),
    [anon_sym_let] = ACTIONS(5968),
    [anon_sym_orderby] = ACTIONS(5968),
    [anon_sym_ascending] = ACTIONS(5968),
    [anon_sym_descending] = ACTIONS(5968),
    [anon_sym_group] = ACTIONS(5968),
    [anon_sym_by] = ACTIONS(5968),
    [anon_sym_select] = ACTIONS(5968),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4306] = {
    [sym_preproc_region] = STATE(4306),
    [sym_preproc_endregion] = STATE(4306),
    [sym_preproc_line] = STATE(4306),
    [sym_preproc_pragma] = STATE(4306),
    [sym_preproc_nullable] = STATE(4306),
    [sym_preproc_error] = STATE(4306),
    [sym_preproc_define] = STATE(4306),
    [sym_preproc_undef] = STATE(4306),
    [anon_sym_EQ] = ACTIONS(5937),
    [anon_sym_LBRACK] = ACTIONS(5249),
    [anon_sym_COLON] = ACTIONS(5249),
    [anon_sym_COMMA] = ACTIONS(5249),
    [anon_sym_LPAREN] = ACTIONS(5249),
    [anon_sym_RPAREN] = ACTIONS(5972),
    [anon_sym_LT] = ACTIONS(5251),
    [anon_sym_GT] = ACTIONS(5251),
    [anon_sym_QMARK] = ACTIONS(5251),
    [anon_sym_BANG] = ACTIONS(5251),
    [anon_sym_PLUS_PLUS] = ACTIONS(5249),
    [anon_sym_DASH_DASH] = ACTIONS(5249),
    [anon_sym_PLUS] = ACTIONS(5251),
    [anon_sym_DASH] = ACTIONS(5251),
    [anon_sym_STAR] = ACTIONS(5251),
    [anon_sym_SLASH] = ACTIONS(5251),
    [anon_sym_PERCENT] = ACTIONS(5251),
    [anon_sym_CARET] = ACTIONS(5251),
    [anon_sym_PIPE] = ACTIONS(5251),
    [anon_sym_AMP] = ACTIONS(5251),
    [anon_sym_LT_LT] = ACTIONS(5251),
    [anon_sym_GT_GT] = ACTIONS(5251),
    [anon_sym_GT_GT_GT] = ACTIONS(5251),
    [anon_sym_EQ_EQ] = ACTIONS(5249),
    [anon_sym_BANG_EQ] = ACTIONS(5249),
    [anon_sym_GT_EQ] = ACTIONS(5249),
    [anon_sym_LT_EQ] = ACTIONS(5249),
    [anon_sym_DOT] = ACTIONS(5251),
    [anon_sym_switch] = ACTIONS(5249),
    [anon_sym_DOT_DOT] = ACTIONS(5249),
    [anon_sym_PLUS_EQ] = ACTIONS(5939),
    [anon_sym_DASH_EQ] = ACTIONS(5939),
    [anon_sym_STAR_EQ] = ACTIONS(5939),
    [anon_sym_SLASH_EQ] = ACTIONS(5939),
    [anon_sym_PERCENT_EQ] = ACTIONS(5939),
    [anon_sym_AMP_EQ] = ACTIONS(5939),
    [anon_sym_CARET_EQ] = ACTIONS(5939),
    [anon_sym_PIPE_EQ] = ACTIONS(5939),
    [anon_sym_LT_LT_EQ] = ACTIONS(5939),
    [anon_sym_GT_GT_EQ] = ACTIONS(5939),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5939),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(5939),
    [anon_sym_AMP_AMP] = ACTIONS(5249),
    [anon_sym_PIPE_PIPE] = ACTIONS(5249),
    [anon_sym_QMARK_QMARK] = ACTIONS(5251),
    [anon_sym_as] = ACTIONS(5249),
    [anon_sym_is] = ACTIONS(5249),
    [anon_sym_DASH_GT] = ACTIONS(5249),
    [anon_sym_with] = ACTIONS(5249),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4307] = {
    [sym_preproc_region] = STATE(4307),
    [sym_preproc_endregion] = STATE(4307),
    [sym_preproc_line] = STATE(4307),
    [sym_preproc_pragma] = STATE(4307),
    [sym_preproc_nullable] = STATE(4307),
    [sym_preproc_error] = STATE(4307),
    [sym_preproc_define] = STATE(4307),
    [sym_preproc_undef] = STATE(4307),
    [sym__identifier_token] = ACTIONS(5974),
    [anon_sym_extern] = ACTIONS(5974),
    [anon_sym_alias] = ACTIONS(5974),
    [anon_sym_global] = ACTIONS(5974),
    [anon_sym_unsafe] = ACTIONS(5974),
    [anon_sym_static] = ACTIONS(5974),
    [anon_sym_LBRACK] = ACTIONS(5976),
    [anon_sym_RBRACE] = ACTIONS(5976),
    [anon_sym_abstract] = ACTIONS(5974),
    [anon_sym_async] = ACTIONS(5974),
    [anon_sym_const] = ACTIONS(5974),
    [anon_sym_file] = ACTIONS(5974),
    [anon_sym_fixed] = ACTIONS(5974),
    [anon_sym_internal] = ACTIONS(5974),
    [anon_sym_new] = ACTIONS(5974),
    [anon_sym_override] = ACTIONS(5974),
    [anon_sym_partial] = ACTIONS(5974),
    [anon_sym_private] = ACTIONS(5974),
    [anon_sym_protected] = ACTIONS(5974),
    [anon_sym_public] = ACTIONS(5974),
    [anon_sym_readonly] = ACTIONS(5974),
    [anon_sym_required] = ACTIONS(5974),
    [anon_sym_sealed] = ACTIONS(5974),
    [anon_sym_virtual] = ACTIONS(5974),
    [anon_sym_volatile] = ACTIONS(5974),
    [anon_sym_where] = ACTIONS(5974),
    [anon_sym_notnull] = ACTIONS(5974),
    [anon_sym_unmanaged] = ACTIONS(5974),
    [anon_sym_get] = ACTIONS(5974),
    [anon_sym_set] = ACTIONS(5974),
    [anon_sym_add] = ACTIONS(5974),
    [anon_sym_remove] = ACTIONS(5974),
    [anon_sym_init] = ACTIONS(5974),
    [anon_sym_scoped] = ACTIONS(5974),
    [anon_sym_var] = ACTIONS(5974),
    [anon_sym_yield] = ACTIONS(5974),
    [anon_sym_when] = ACTIONS(5974),
    [anon_sym_from] = ACTIONS(5974),
    [anon_sym_into] = ACTIONS(5974),
    [anon_sym_join] = ACTIONS(5974),
    [anon_sym_on] = ACTIONS(5974),
    [anon_sym_equals] = ACTIONS(5974),
    [anon_sym_let] = ACTIONS(5974),
    [anon_sym_orderby] = ACTIONS(5974),
    [anon_sym_ascending] = ACTIONS(5974),
    [anon_sym_descending] = ACTIONS(5974),
    [anon_sym_group] = ACTIONS(5974),
    [anon_sym_by] = ACTIONS(5974),
    [anon_sym_select] = ACTIONS(5974),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4308] = {
    [sym_argument_list] = STATE(4235),
    [sym_bracketed_argument_list] = STATE(3015),
    [sym_preproc_region] = STATE(4308),
    [sym_preproc_endregion] = STATE(4308),
    [sym_preproc_line] = STATE(4308),
    [sym_preproc_pragma] = STATE(4308),
    [sym_preproc_nullable] = STATE(4308),
    [sym_preproc_error] = STATE(4308),
    [sym_preproc_define] = STATE(4308),
    [sym_preproc_undef] = STATE(4308),
    [anon_sym_SEMI] = ACTIONS(5243),
    [anon_sym_LBRACK] = ACTIONS(5978),
    [anon_sym_COLON] = ACTIONS(5243),
    [anon_sym_COMMA] = ACTIONS(5243),
    [anon_sym_RBRACK] = ACTIONS(5243),
    [anon_sym_LPAREN] = ACTIONS(5711),
    [anon_sym_RPAREN] = ACTIONS(5243),
    [anon_sym_RBRACE] = ACTIONS(5243),
    [anon_sym_LT] = ACTIONS(5245),
    [anon_sym_GT] = ACTIONS(5245),
    [anon_sym_in] = ACTIONS(5243),
    [anon_sym_QMARK] = ACTIONS(5245),
    [anon_sym_BANG] = ACTIONS(5745),
    [anon_sym_PLUS_PLUS] = ACTIONS(5747),
    [anon_sym_DASH_DASH] = ACTIONS(5747),
    [anon_sym_PLUS] = ACTIONS(5245),
    [anon_sym_DASH] = ACTIONS(5245),
    [anon_sym_STAR] = ACTIONS(5243),
    [anon_sym_SLASH] = ACTIONS(5245),
    [anon_sym_PERCENT] = ACTIONS(5243),
    [anon_sym_CARET] = ACTIONS(5243),
    [anon_sym_PIPE] = ACTIONS(5245),
    [anon_sym_AMP] = ACTIONS(5245),
    [anon_sym_LT_LT] = ACTIONS(5243),
    [anon_sym_GT_GT] = ACTIONS(5245),
    [anon_sym_GT_GT_GT] = ACTIONS(5243),
    [anon_sym_EQ_EQ] = ACTIONS(5243),
    [anon_sym_BANG_EQ] = ACTIONS(5243),
    [anon_sym_GT_EQ] = ACTIONS(5243),
    [anon_sym_LT_EQ] = ACTIONS(5243),
    [anon_sym_DOT] = ACTIONS(4560),
    [anon_sym_EQ_GT] = ACTIONS(5243),
    [anon_sym_switch] = ACTIONS(5243),
    [anon_sym_DOT_DOT] = ACTIONS(5243),
    [anon_sym_AMP_AMP] = ACTIONS(5243),
    [anon_sym_PIPE_PIPE] = ACTIONS(5243),
    [anon_sym_QMARK_QMARK] = ACTIONS(5243),
    [anon_sym_on] = ACTIONS(5243),
    [anon_sym_equals] = ACTIONS(5243),
    [anon_sym_by] = ACTIONS(5243),
    [anon_sym_as] = ACTIONS(5243),
    [anon_sym_is] = ACTIONS(5243),
    [anon_sym_DASH_GT] = ACTIONS(4562),
    [anon_sym_with] = ACTIONS(5243),
    [aux_sym_preproc_if_token3] = ACTIONS(5243),
    [aux_sym_preproc_else_token1] = ACTIONS(5243),
    [aux_sym_preproc_elif_token1] = ACTIONS(5243),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4309] = {
    [sym_argument_list] = STATE(4235),
    [sym_bracketed_argument_list] = STATE(3015),
    [sym_preproc_region] = STATE(4309),
    [sym_preproc_endregion] = STATE(4309),
    [sym_preproc_line] = STATE(4309),
    [sym_preproc_pragma] = STATE(4309),
    [sym_preproc_nullable] = STATE(4309),
    [sym_preproc_error] = STATE(4309),
    [sym_preproc_define] = STATE(4309),
    [sym_preproc_undef] = STATE(4309),
    [anon_sym_SEMI] = ACTIONS(5255),
    [anon_sym_LBRACK] = ACTIONS(5978),
    [anon_sym_COLON] = ACTIONS(5255),
    [anon_sym_COMMA] = ACTIONS(5255),
    [anon_sym_RBRACK] = ACTIONS(5255),
    [anon_sym_LPAREN] = ACTIONS(5711),
    [anon_sym_RPAREN] = ACTIONS(5255),
    [anon_sym_RBRACE] = ACTIONS(5255),
    [anon_sym_LT] = ACTIONS(5257),
    [anon_sym_GT] = ACTIONS(5257),
    [anon_sym_in] = ACTIONS(5255),
    [anon_sym_QMARK] = ACTIONS(5257),
    [anon_sym_BANG] = ACTIONS(5745),
    [anon_sym_PLUS_PLUS] = ACTIONS(5747),
    [anon_sym_DASH_DASH] = ACTIONS(5747),
    [anon_sym_PLUS] = ACTIONS(5257),
    [anon_sym_DASH] = ACTIONS(5257),
    [anon_sym_STAR] = ACTIONS(5255),
    [anon_sym_SLASH] = ACTIONS(5257),
    [anon_sym_PERCENT] = ACTIONS(5255),
    [anon_sym_CARET] = ACTIONS(5255),
    [anon_sym_PIPE] = ACTIONS(5257),
    [anon_sym_AMP] = ACTIONS(5257),
    [anon_sym_LT_LT] = ACTIONS(5255),
    [anon_sym_GT_GT] = ACTIONS(5257),
    [anon_sym_GT_GT_GT] = ACTIONS(5255),
    [anon_sym_EQ_EQ] = ACTIONS(5255),
    [anon_sym_BANG_EQ] = ACTIONS(5255),
    [anon_sym_GT_EQ] = ACTIONS(5255),
    [anon_sym_LT_EQ] = ACTIONS(5255),
    [anon_sym_DOT] = ACTIONS(4560),
    [anon_sym_EQ_GT] = ACTIONS(5255),
    [anon_sym_switch] = ACTIONS(5255),
    [anon_sym_DOT_DOT] = ACTIONS(5255),
    [anon_sym_AMP_AMP] = ACTIONS(5255),
    [anon_sym_PIPE_PIPE] = ACTIONS(5255),
    [anon_sym_QMARK_QMARK] = ACTIONS(5255),
    [anon_sym_on] = ACTIONS(5255),
    [anon_sym_equals] = ACTIONS(5255),
    [anon_sym_by] = ACTIONS(5255),
    [anon_sym_as] = ACTIONS(5255),
    [anon_sym_is] = ACTIONS(5255),
    [anon_sym_DASH_GT] = ACTIONS(4562),
    [anon_sym_with] = ACTIONS(5255),
    [aux_sym_preproc_if_token3] = ACTIONS(5255),
    [aux_sym_preproc_else_token1] = ACTIONS(5255),
    [aux_sym_preproc_elif_token1] = ACTIONS(5255),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4310] = {
    [sym_parameter_list] = STATE(8873),
    [sym_block] = STATE(3759),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7325),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_identifier] = STATE(4921),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4310),
    [sym_preproc_endregion] = STATE(4310),
    [sym_preproc_line] = STATE(4310),
    [sym_preproc_pragma] = STATE(4310),
    [sym_preproc_nullable] = STATE(4310),
    [sym_preproc_error] = STATE(4310),
    [sym_preproc_define] = STATE(4310),
    [sym_preproc_undef] = STATE(4310),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_LBRACE] = ACTIONS(5980),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_STAR] = ACTIONS(5982),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4311] = {
    [sym_parameter_list] = STATE(8873),
    [sym_block] = STATE(3759),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7345),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_identifier] = STATE(4921),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4311),
    [sym_preproc_endregion] = STATE(4311),
    [sym_preproc_line] = STATE(4311),
    [sym_preproc_pragma] = STATE(4311),
    [sym_preproc_nullable] = STATE(4311),
    [sym_preproc_error] = STATE(4311),
    [sym_preproc_define] = STATE(4311),
    [sym_preproc_undef] = STATE(4311),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_ref] = ACTIONS(3726),
    [anon_sym_LBRACE] = ACTIONS(5980),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_STAR] = ACTIONS(5982),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4312] = {
    [sym_preproc_region] = STATE(4312),
    [sym_preproc_endregion] = STATE(4312),
    [sym_preproc_line] = STATE(4312),
    [sym_preproc_pragma] = STATE(4312),
    [sym_preproc_nullable] = STATE(4312),
    [sym_preproc_error] = STATE(4312),
    [sym_preproc_define] = STATE(4312),
    [sym_preproc_undef] = STATE(4312),
    [anon_sym_EQ] = ACTIONS(5984),
    [anon_sym_LBRACK] = ACTIONS(5249),
    [anon_sym_COLON] = ACTIONS(5249),
    [anon_sym_LPAREN] = ACTIONS(5249),
    [anon_sym_LT] = ACTIONS(5251),
    [anon_sym_GT] = ACTIONS(5251),
    [anon_sym_QMARK] = ACTIONS(5251),
    [anon_sym_BANG] = ACTIONS(5251),
    [anon_sym_PLUS_PLUS] = ACTIONS(5249),
    [anon_sym_DASH_DASH] = ACTIONS(5249),
    [anon_sym_PLUS] = ACTIONS(5251),
    [anon_sym_DASH] = ACTIONS(5251),
    [anon_sym_STAR] = ACTIONS(5251),
    [anon_sym_SLASH] = ACTIONS(5251),
    [anon_sym_PERCENT] = ACTIONS(5251),
    [anon_sym_CARET] = ACTIONS(5251),
    [anon_sym_PIPE] = ACTIONS(5251),
    [anon_sym_AMP] = ACTIONS(5251),
    [anon_sym_LT_LT] = ACTIONS(5251),
    [anon_sym_GT_GT] = ACTIONS(5251),
    [anon_sym_GT_GT_GT] = ACTIONS(5251),
    [anon_sym_EQ_EQ] = ACTIONS(5249),
    [anon_sym_BANG_EQ] = ACTIONS(5249),
    [anon_sym_GT_EQ] = ACTIONS(5249),
    [anon_sym_LT_EQ] = ACTIONS(5249),
    [anon_sym_DOT] = ACTIONS(5251),
    [anon_sym_switch] = ACTIONS(5249),
    [anon_sym_DOT_DOT] = ACTIONS(5249),
    [anon_sym_and] = ACTIONS(5249),
    [anon_sym_or] = ACTIONS(5249),
    [anon_sym_PLUS_EQ] = ACTIONS(5986),
    [anon_sym_DASH_EQ] = ACTIONS(5986),
    [anon_sym_STAR_EQ] = ACTIONS(5986),
    [anon_sym_SLASH_EQ] = ACTIONS(5986),
    [anon_sym_PERCENT_EQ] = ACTIONS(5986),
    [anon_sym_AMP_EQ] = ACTIONS(5986),
    [anon_sym_CARET_EQ] = ACTIONS(5986),
    [anon_sym_PIPE_EQ] = ACTIONS(5986),
    [anon_sym_LT_LT_EQ] = ACTIONS(5986),
    [anon_sym_GT_GT_EQ] = ACTIONS(5986),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5986),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(5986),
    [anon_sym_AMP_AMP] = ACTIONS(5249),
    [anon_sym_PIPE_PIPE] = ACTIONS(5249),
    [anon_sym_QMARK_QMARK] = ACTIONS(5251),
    [anon_sym_as] = ACTIONS(5249),
    [anon_sym_is] = ACTIONS(5249),
    [anon_sym_DASH_GT] = ACTIONS(5249),
    [anon_sym_with] = ACTIONS(5249),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4313] = {
    [sym_preproc_region] = STATE(4313),
    [sym_preproc_endregion] = STATE(4313),
    [sym_preproc_line] = STATE(4313),
    [sym_preproc_pragma] = STATE(4313),
    [sym_preproc_nullable] = STATE(4313),
    [sym_preproc_error] = STATE(4313),
    [sym_preproc_define] = STATE(4313),
    [sym_preproc_undef] = STATE(4313),
    [anon_sym_EQ] = ACTIONS(5988),
    [anon_sym_LBRACK] = ACTIONS(5249),
    [anon_sym_LPAREN] = ACTIONS(5249),
    [anon_sym_LT] = ACTIONS(5251),
    [anon_sym_GT] = ACTIONS(5251),
    [anon_sym_in] = ACTIONS(5249),
    [anon_sym_QMARK] = ACTIONS(5251),
    [anon_sym_BANG] = ACTIONS(5251),
    [anon_sym_PLUS_PLUS] = ACTIONS(5249),
    [anon_sym_DASH_DASH] = ACTIONS(5249),
    [anon_sym_PLUS] = ACTIONS(5251),
    [anon_sym_DASH] = ACTIONS(5251),
    [anon_sym_STAR] = ACTIONS(5251),
    [anon_sym_SLASH] = ACTIONS(5251),
    [anon_sym_PERCENT] = ACTIONS(5251),
    [anon_sym_CARET] = ACTIONS(5251),
    [anon_sym_PIPE] = ACTIONS(5251),
    [anon_sym_AMP] = ACTIONS(5251),
    [anon_sym_LT_LT] = ACTIONS(5251),
    [anon_sym_GT_GT] = ACTIONS(5251),
    [anon_sym_GT_GT_GT] = ACTIONS(5251),
    [anon_sym_EQ_EQ] = ACTIONS(5249),
    [anon_sym_BANG_EQ] = ACTIONS(5249),
    [anon_sym_GT_EQ] = ACTIONS(5249),
    [anon_sym_LT_EQ] = ACTIONS(5249),
    [anon_sym_DOT] = ACTIONS(5251),
    [anon_sym_switch] = ACTIONS(5249),
    [anon_sym_DOT_DOT] = ACTIONS(5249),
    [anon_sym_and] = ACTIONS(5249),
    [anon_sym_or] = ACTIONS(5249),
    [anon_sym_PLUS_EQ] = ACTIONS(5990),
    [anon_sym_DASH_EQ] = ACTIONS(5990),
    [anon_sym_STAR_EQ] = ACTIONS(5990),
    [anon_sym_SLASH_EQ] = ACTIONS(5990),
    [anon_sym_PERCENT_EQ] = ACTIONS(5990),
    [anon_sym_AMP_EQ] = ACTIONS(5990),
    [anon_sym_CARET_EQ] = ACTIONS(5990),
    [anon_sym_PIPE_EQ] = ACTIONS(5990),
    [anon_sym_LT_LT_EQ] = ACTIONS(5990),
    [anon_sym_GT_GT_EQ] = ACTIONS(5990),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5990),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(5990),
    [anon_sym_AMP_AMP] = ACTIONS(5249),
    [anon_sym_PIPE_PIPE] = ACTIONS(5249),
    [anon_sym_QMARK_QMARK] = ACTIONS(5251),
    [anon_sym_as] = ACTIONS(5249),
    [anon_sym_is] = ACTIONS(5249),
    [anon_sym_DASH_GT] = ACTIONS(5249),
    [anon_sym_with] = ACTIONS(5249),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4314] = {
    [sym_preproc_region] = STATE(4314),
    [sym_preproc_endregion] = STATE(4314),
    [sym_preproc_line] = STATE(4314),
    [sym_preproc_pragma] = STATE(4314),
    [sym_preproc_nullable] = STATE(4314),
    [sym_preproc_error] = STATE(4314),
    [sym_preproc_define] = STATE(4314),
    [sym_preproc_undef] = STATE(4314),
    [anon_sym_SEMI] = ACTIONS(5249),
    [anon_sym_EQ] = ACTIONS(5992),
    [anon_sym_LBRACK] = ACTIONS(5249),
    [anon_sym_COMMA] = ACTIONS(5249),
    [anon_sym_LPAREN] = ACTIONS(5249),
    [anon_sym_RBRACE] = ACTIONS(5249),
    [anon_sym_LT] = ACTIONS(5251),
    [anon_sym_GT] = ACTIONS(5251),
    [anon_sym_QMARK] = ACTIONS(5251),
    [anon_sym_BANG] = ACTIONS(5251),
    [anon_sym_PLUS_PLUS] = ACTIONS(5249),
    [anon_sym_DASH_DASH] = ACTIONS(5249),
    [anon_sym_PLUS] = ACTIONS(5251),
    [anon_sym_DASH] = ACTIONS(5251),
    [anon_sym_STAR] = ACTIONS(5251),
    [anon_sym_SLASH] = ACTIONS(5251),
    [anon_sym_PERCENT] = ACTIONS(5251),
    [anon_sym_CARET] = ACTIONS(5251),
    [anon_sym_PIPE] = ACTIONS(5251),
    [anon_sym_AMP] = ACTIONS(5251),
    [anon_sym_LT_LT] = ACTIONS(5251),
    [anon_sym_GT_GT] = ACTIONS(5251),
    [anon_sym_GT_GT_GT] = ACTIONS(5251),
    [anon_sym_EQ_EQ] = ACTIONS(5249),
    [anon_sym_BANG_EQ] = ACTIONS(5249),
    [anon_sym_GT_EQ] = ACTIONS(5249),
    [anon_sym_LT_EQ] = ACTIONS(5249),
    [anon_sym_DOT] = ACTIONS(5251),
    [anon_sym_switch] = ACTIONS(5249),
    [anon_sym_DOT_DOT] = ACTIONS(5249),
    [anon_sym_PLUS_EQ] = ACTIONS(5994),
    [anon_sym_DASH_EQ] = ACTIONS(5994),
    [anon_sym_STAR_EQ] = ACTIONS(5994),
    [anon_sym_SLASH_EQ] = ACTIONS(5994),
    [anon_sym_PERCENT_EQ] = ACTIONS(5994),
    [anon_sym_AMP_EQ] = ACTIONS(5994),
    [anon_sym_CARET_EQ] = ACTIONS(5994),
    [anon_sym_PIPE_EQ] = ACTIONS(5994),
    [anon_sym_LT_LT_EQ] = ACTIONS(5994),
    [anon_sym_GT_GT_EQ] = ACTIONS(5994),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5994),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(5994),
    [anon_sym_AMP_AMP] = ACTIONS(5249),
    [anon_sym_PIPE_PIPE] = ACTIONS(5249),
    [anon_sym_QMARK_QMARK] = ACTIONS(5251),
    [anon_sym_as] = ACTIONS(5249),
    [anon_sym_is] = ACTIONS(5249),
    [anon_sym_DASH_GT] = ACTIONS(5249),
    [anon_sym_with] = ACTIONS(5249),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4315] = {
    [sym_preproc_region] = STATE(4315),
    [sym_preproc_endregion] = STATE(4315),
    [sym_preproc_line] = STATE(4315),
    [sym_preproc_pragma] = STATE(4315),
    [sym_preproc_nullable] = STATE(4315),
    [sym_preproc_error] = STATE(4315),
    [sym_preproc_define] = STATE(4315),
    [sym_preproc_undef] = STATE(4315),
    [sym__identifier_token] = ACTIONS(5996),
    [anon_sym_extern] = ACTIONS(5996),
    [anon_sym_alias] = ACTIONS(5996),
    [anon_sym_global] = ACTIONS(5996),
    [anon_sym_unsafe] = ACTIONS(5996),
    [anon_sym_static] = ACTIONS(5996),
    [anon_sym_LBRACK] = ACTIONS(5998),
    [anon_sym_RBRACE] = ACTIONS(5998),
    [anon_sym_abstract] = ACTIONS(5996),
    [anon_sym_async] = ACTIONS(5996),
    [anon_sym_const] = ACTIONS(5996),
    [anon_sym_file] = ACTIONS(5996),
    [anon_sym_fixed] = ACTIONS(5996),
    [anon_sym_internal] = ACTIONS(5996),
    [anon_sym_new] = ACTIONS(5996),
    [anon_sym_override] = ACTIONS(5996),
    [anon_sym_partial] = ACTIONS(5996),
    [anon_sym_private] = ACTIONS(5996),
    [anon_sym_protected] = ACTIONS(5996),
    [anon_sym_public] = ACTIONS(5996),
    [anon_sym_readonly] = ACTIONS(5996),
    [anon_sym_required] = ACTIONS(5996),
    [anon_sym_sealed] = ACTIONS(5996),
    [anon_sym_virtual] = ACTIONS(5996),
    [anon_sym_volatile] = ACTIONS(5996),
    [anon_sym_where] = ACTIONS(5996),
    [anon_sym_notnull] = ACTIONS(5996),
    [anon_sym_unmanaged] = ACTIONS(5996),
    [anon_sym_get] = ACTIONS(5996),
    [anon_sym_set] = ACTIONS(5996),
    [anon_sym_add] = ACTIONS(5996),
    [anon_sym_remove] = ACTIONS(5996),
    [anon_sym_init] = ACTIONS(5996),
    [anon_sym_scoped] = ACTIONS(5996),
    [anon_sym_var] = ACTIONS(5996),
    [anon_sym_yield] = ACTIONS(5996),
    [anon_sym_when] = ACTIONS(5996),
    [anon_sym_from] = ACTIONS(5996),
    [anon_sym_into] = ACTIONS(5996),
    [anon_sym_join] = ACTIONS(5996),
    [anon_sym_on] = ACTIONS(5996),
    [anon_sym_equals] = ACTIONS(5996),
    [anon_sym_let] = ACTIONS(5996),
    [anon_sym_orderby] = ACTIONS(5996),
    [anon_sym_ascending] = ACTIONS(5996),
    [anon_sym_descending] = ACTIONS(5996),
    [anon_sym_group] = ACTIONS(5996),
    [anon_sym_by] = ACTIONS(5996),
    [anon_sym_select] = ACTIONS(5996),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4316] = {
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(5969),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_identifier] = STATE(4921),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4316),
    [sym_preproc_endregion] = STATE(4316),
    [sym_preproc_line] = STATE(4316),
    [sym_preproc_pragma] = STATE(4316),
    [sym_preproc_nullable] = STATE(4316),
    [sym_preproc_error] = STATE(4316),
    [sym_preproc_define] = STATE(4316),
    [sym_preproc_undef] = STATE(4316),
    [sym__identifier_token] = ACTIONS(2603),
    [anon_sym_alias] = ACTIONS(2603),
    [anon_sym_global] = ACTIONS(2603),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_ref] = ACTIONS(2603),
    [anon_sym_delegate] = ACTIONS(2603),
    [anon_sym_file] = ACTIONS(2603),
    [anon_sym_readonly] = ACTIONS(2603),
    [anon_sym_in] = ACTIONS(2603),
    [anon_sym_out] = ACTIONS(2603),
    [anon_sym_where] = ACTIONS(2603),
    [anon_sym_notnull] = ACTIONS(2603),
    [anon_sym_unmanaged] = ACTIONS(2603),
    [anon_sym_this] = ACTIONS(2603),
    [anon_sym_scoped] = ACTIONS(2603),
    [anon_sym_var] = ACTIONS(2603),
    [sym_predefined_type] = ACTIONS(2603),
    [anon_sym_yield] = ACTIONS(2603),
    [anon_sym_when] = ACTIONS(2603),
    [anon_sym_from] = ACTIONS(2603),
    [anon_sym_into] = ACTIONS(2603),
    [anon_sym_join] = ACTIONS(2603),
    [anon_sym_on] = ACTIONS(2603),
    [anon_sym_equals] = ACTIONS(2603),
    [anon_sym_let] = ACTIONS(2603),
    [anon_sym_orderby] = ACTIONS(2603),
    [anon_sym_ascending] = ACTIONS(2603),
    [anon_sym_descending] = ACTIONS(2603),
    [anon_sym_group] = ACTIONS(2603),
    [anon_sym_by] = ACTIONS(2603),
    [anon_sym_select] = ACTIONS(2603),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4317] = {
    [sym_preproc_region] = STATE(4317),
    [sym_preproc_endregion] = STATE(4317),
    [sym_preproc_line] = STATE(4317),
    [sym_preproc_pragma] = STATE(4317),
    [sym_preproc_nullable] = STATE(4317),
    [sym_preproc_error] = STATE(4317),
    [sym_preproc_define] = STATE(4317),
    [sym_preproc_undef] = STATE(4317),
    [anon_sym_EQ] = ACTIONS(6000),
    [anon_sym_LBRACK] = ACTIONS(5249),
    [anon_sym_LPAREN] = ACTIONS(5249),
    [anon_sym_LT] = ACTIONS(5251),
    [anon_sym_GT] = ACTIONS(5251),
    [anon_sym_QMARK] = ACTIONS(5251),
    [anon_sym_BANG] = ACTIONS(5251),
    [anon_sym_PLUS_PLUS] = ACTIONS(5249),
    [anon_sym_DASH_DASH] = ACTIONS(5249),
    [anon_sym_PLUS] = ACTIONS(5251),
    [anon_sym_DASH] = ACTIONS(5251),
    [anon_sym_STAR] = ACTIONS(5251),
    [anon_sym_SLASH] = ACTIONS(5251),
    [anon_sym_PERCENT] = ACTIONS(5251),
    [anon_sym_CARET] = ACTIONS(5251),
    [anon_sym_PIPE] = ACTIONS(5251),
    [anon_sym_AMP] = ACTIONS(5251),
    [anon_sym_LT_LT] = ACTIONS(5251),
    [anon_sym_GT_GT] = ACTIONS(5251),
    [anon_sym_GT_GT_GT] = ACTIONS(5251),
    [anon_sym_EQ_EQ] = ACTIONS(5249),
    [anon_sym_BANG_EQ] = ACTIONS(5249),
    [anon_sym_GT_EQ] = ACTIONS(5249),
    [anon_sym_LT_EQ] = ACTIONS(5249),
    [anon_sym_DOT] = ACTIONS(5251),
    [anon_sym_switch] = ACTIONS(5249),
    [anon_sym_DOT_DOT] = ACTIONS(5249),
    [anon_sym_PLUS_EQ] = ACTIONS(6002),
    [anon_sym_DASH_EQ] = ACTIONS(6002),
    [anon_sym_STAR_EQ] = ACTIONS(6002),
    [anon_sym_SLASH_EQ] = ACTIONS(6002),
    [anon_sym_PERCENT_EQ] = ACTIONS(6002),
    [anon_sym_AMP_EQ] = ACTIONS(6002),
    [anon_sym_CARET_EQ] = ACTIONS(6002),
    [anon_sym_PIPE_EQ] = ACTIONS(6002),
    [anon_sym_LT_LT_EQ] = ACTIONS(6002),
    [anon_sym_GT_GT_EQ] = ACTIONS(6002),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6002),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(6002),
    [anon_sym_AMP_AMP] = ACTIONS(5249),
    [anon_sym_PIPE_PIPE] = ACTIONS(5249),
    [anon_sym_QMARK_QMARK] = ACTIONS(5251),
    [anon_sym_as] = ACTIONS(5249),
    [anon_sym_is] = ACTIONS(5249),
    [anon_sym_DASH_GT] = ACTIONS(5249),
    [anon_sym_with] = ACTIONS(5249),
    [aux_sym_preproc_if_token3] = ACTIONS(5249),
    [aux_sym_preproc_else_token1] = ACTIONS(5249),
    [aux_sym_preproc_elif_token1] = ACTIONS(5249),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4318] = {
    [sym_preproc_region] = STATE(4318),
    [sym_preproc_endregion] = STATE(4318),
    [sym_preproc_line] = STATE(4318),
    [sym_preproc_pragma] = STATE(4318),
    [sym_preproc_nullable] = STATE(4318),
    [sym_preproc_error] = STATE(4318),
    [sym_preproc_define] = STATE(4318),
    [sym_preproc_undef] = STATE(4318),
    [anon_sym_EQ] = ACTIONS(6004),
    [anon_sym_LBRACK] = ACTIONS(5249),
    [anon_sym_LPAREN] = ACTIONS(5249),
    [anon_sym_LT] = ACTIONS(5251),
    [anon_sym_GT] = ACTIONS(5251),
    [anon_sym_QMARK] = ACTIONS(5251),
    [anon_sym_BANG] = ACTIONS(5251),
    [anon_sym_PLUS_PLUS] = ACTIONS(5249),
    [anon_sym_DASH_DASH] = ACTIONS(5249),
    [anon_sym_PLUS] = ACTIONS(5251),
    [anon_sym_DASH] = ACTIONS(5251),
    [anon_sym_STAR] = ACTIONS(5251),
    [anon_sym_SLASH] = ACTIONS(5251),
    [anon_sym_PERCENT] = ACTIONS(5251),
    [anon_sym_CARET] = ACTIONS(5251),
    [anon_sym_PIPE] = ACTIONS(5251),
    [anon_sym_AMP] = ACTIONS(5251),
    [anon_sym_LT_LT] = ACTIONS(5251),
    [anon_sym_GT_GT] = ACTIONS(5251),
    [anon_sym_GT_GT_GT] = ACTIONS(5251),
    [anon_sym_EQ_EQ] = ACTIONS(5249),
    [anon_sym_BANG_EQ] = ACTIONS(5249),
    [anon_sym_GT_EQ] = ACTIONS(5249),
    [anon_sym_LT_EQ] = ACTIONS(5249),
    [anon_sym_DOT] = ACTIONS(5251),
    [anon_sym_switch] = ACTIONS(5249),
    [anon_sym_DOT_DOT] = ACTIONS(5249),
    [anon_sym_and] = ACTIONS(5249),
    [anon_sym_or] = ACTIONS(5249),
    [anon_sym_PLUS_EQ] = ACTIONS(6006),
    [anon_sym_DASH_EQ] = ACTIONS(6006),
    [anon_sym_STAR_EQ] = ACTIONS(6006),
    [anon_sym_SLASH_EQ] = ACTIONS(6006),
    [anon_sym_PERCENT_EQ] = ACTIONS(6006),
    [anon_sym_AMP_EQ] = ACTIONS(6006),
    [anon_sym_CARET_EQ] = ACTIONS(6006),
    [anon_sym_PIPE_EQ] = ACTIONS(6006),
    [anon_sym_LT_LT_EQ] = ACTIONS(6006),
    [anon_sym_GT_GT_EQ] = ACTIONS(6006),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6006),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(6006),
    [anon_sym_AMP_AMP] = ACTIONS(5249),
    [anon_sym_PIPE_PIPE] = ACTIONS(5249),
    [anon_sym_QMARK_QMARK] = ACTIONS(5251),
    [anon_sym_by] = ACTIONS(5249),
    [anon_sym_as] = ACTIONS(5249),
    [anon_sym_is] = ACTIONS(5249),
    [anon_sym_DASH_GT] = ACTIONS(5249),
    [anon_sym_with] = ACTIONS(5249),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4319] = {
    [sym_argument_list] = STATE(4350),
    [sym_initializer_expression] = STATE(4598),
    [sym_preproc_region] = STATE(4319),
    [sym_preproc_endregion] = STATE(4319),
    [sym_preproc_line] = STATE(4319),
    [sym_preproc_pragma] = STATE(4319),
    [sym_preproc_nullable] = STATE(4319),
    [sym_preproc_error] = STATE(4319),
    [sym_preproc_define] = STATE(4319),
    [sym_preproc_undef] = STATE(4319),
    [anon_sym_LBRACK] = ACTIONS(5185),
    [anon_sym_COMMA] = ACTIONS(5185),
    [anon_sym_LPAREN] = ACTIONS(6008),
    [anon_sym_LBRACE] = ACTIONS(1611),
    [anon_sym_LT] = ACTIONS(5189),
    [anon_sym_GT] = ACTIONS(5189),
    [anon_sym_where] = ACTIONS(5185),
    [anon_sym_QMARK] = ACTIONS(5189),
    [anon_sym_BANG] = ACTIONS(5189),
    [anon_sym_PLUS_PLUS] = ACTIONS(5185),
    [anon_sym_DASH_DASH] = ACTIONS(5185),
    [anon_sym_PLUS] = ACTIONS(5189),
    [anon_sym_DASH] = ACTIONS(5189),
    [anon_sym_STAR] = ACTIONS(5185),
    [anon_sym_SLASH] = ACTIONS(5189),
    [anon_sym_PERCENT] = ACTIONS(5185),
    [anon_sym_CARET] = ACTIONS(5185),
    [anon_sym_PIPE] = ACTIONS(5189),
    [anon_sym_AMP] = ACTIONS(5189),
    [anon_sym_LT_LT] = ACTIONS(5185),
    [anon_sym_GT_GT] = ACTIONS(5189),
    [anon_sym_GT_GT_GT] = ACTIONS(5185),
    [anon_sym_EQ_EQ] = ACTIONS(5185),
    [anon_sym_BANG_EQ] = ACTIONS(5185),
    [anon_sym_GT_EQ] = ACTIONS(5185),
    [anon_sym_LT_EQ] = ACTIONS(5185),
    [anon_sym_DOT] = ACTIONS(5189),
    [anon_sym_switch] = ACTIONS(5185),
    [anon_sym_DOT_DOT] = ACTIONS(5185),
    [anon_sym_and] = ACTIONS(5185),
    [anon_sym_or] = ACTIONS(5189),
    [anon_sym_AMP_AMP] = ACTIONS(5185),
    [anon_sym_PIPE_PIPE] = ACTIONS(5185),
    [anon_sym_QMARK_QMARK] = ACTIONS(5185),
    [anon_sym_from] = ACTIONS(5185),
    [anon_sym_into] = ACTIONS(5185),
    [anon_sym_join] = ACTIONS(5185),
    [anon_sym_let] = ACTIONS(5185),
    [anon_sym_orderby] = ACTIONS(5185),
    [anon_sym_ascending] = ACTIONS(5185),
    [anon_sym_descending] = ACTIONS(5185),
    [anon_sym_group] = ACTIONS(5185),
    [anon_sym_select] = ACTIONS(5185),
    [anon_sym_as] = ACTIONS(5189),
    [anon_sym_is] = ACTIONS(5185),
    [anon_sym_DASH_GT] = ACTIONS(5185),
    [anon_sym_with] = ACTIONS(5185),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4320] = {
    [sym_preproc_region] = STATE(4320),
    [sym_preproc_endregion] = STATE(4320),
    [sym_preproc_line] = STATE(4320),
    [sym_preproc_pragma] = STATE(4320),
    [sym_preproc_nullable] = STATE(4320),
    [sym_preproc_error] = STATE(4320),
    [sym_preproc_define] = STATE(4320),
    [sym_preproc_undef] = STATE(4320),
    [sym__identifier_token] = ACTIONS(2921),
    [anon_sym_extern] = ACTIONS(2921),
    [anon_sym_alias] = ACTIONS(2921),
    [anon_sym_global] = ACTIONS(2921),
    [anon_sym_unsafe] = ACTIONS(2921),
    [anon_sym_static] = ACTIONS(2921),
    [anon_sym_LBRACK] = ACTIONS(2923),
    [anon_sym_RBRACE] = ACTIONS(2923),
    [anon_sym_abstract] = ACTIONS(2921),
    [anon_sym_async] = ACTIONS(2921),
    [anon_sym_const] = ACTIONS(2921),
    [anon_sym_file] = ACTIONS(2921),
    [anon_sym_fixed] = ACTIONS(2921),
    [anon_sym_internal] = ACTIONS(2921),
    [anon_sym_new] = ACTIONS(2921),
    [anon_sym_override] = ACTIONS(2921),
    [anon_sym_partial] = ACTIONS(2921),
    [anon_sym_private] = ACTIONS(2921),
    [anon_sym_protected] = ACTIONS(2921),
    [anon_sym_public] = ACTIONS(2921),
    [anon_sym_readonly] = ACTIONS(2921),
    [anon_sym_required] = ACTIONS(2921),
    [anon_sym_sealed] = ACTIONS(2921),
    [anon_sym_virtual] = ACTIONS(2921),
    [anon_sym_volatile] = ACTIONS(2921),
    [anon_sym_where] = ACTIONS(2921),
    [anon_sym_notnull] = ACTIONS(2921),
    [anon_sym_unmanaged] = ACTIONS(2921),
    [anon_sym_get] = ACTIONS(2921),
    [anon_sym_set] = ACTIONS(2921),
    [anon_sym_add] = ACTIONS(2921),
    [anon_sym_remove] = ACTIONS(2921),
    [anon_sym_init] = ACTIONS(2921),
    [anon_sym_scoped] = ACTIONS(2921),
    [anon_sym_var] = ACTIONS(2921),
    [anon_sym_yield] = ACTIONS(2921),
    [anon_sym_when] = ACTIONS(2921),
    [anon_sym_from] = ACTIONS(2921),
    [anon_sym_into] = ACTIONS(2921),
    [anon_sym_join] = ACTIONS(2921),
    [anon_sym_on] = ACTIONS(2921),
    [anon_sym_equals] = ACTIONS(2921),
    [anon_sym_let] = ACTIONS(2921),
    [anon_sym_orderby] = ACTIONS(2921),
    [anon_sym_ascending] = ACTIONS(2921),
    [anon_sym_descending] = ACTIONS(2921),
    [anon_sym_group] = ACTIONS(2921),
    [anon_sym_by] = ACTIONS(2921),
    [anon_sym_select] = ACTIONS(2921),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4321] = {
    [sym_preproc_region] = STATE(4321),
    [sym_preproc_endregion] = STATE(4321),
    [sym_preproc_line] = STATE(4321),
    [sym_preproc_pragma] = STATE(4321),
    [sym_preproc_nullable] = STATE(4321),
    [sym_preproc_error] = STATE(4321),
    [sym_preproc_define] = STATE(4321),
    [sym_preproc_undef] = STATE(4321),
    [sym__identifier_token] = ACTIONS(2967),
    [anon_sym_extern] = ACTIONS(2967),
    [anon_sym_alias] = ACTIONS(2967),
    [anon_sym_global] = ACTIONS(2967),
    [anon_sym_unsafe] = ACTIONS(2967),
    [anon_sym_static] = ACTIONS(2967),
    [anon_sym_LBRACK] = ACTIONS(2969),
    [anon_sym_RBRACE] = ACTIONS(2969),
    [anon_sym_abstract] = ACTIONS(2967),
    [anon_sym_async] = ACTIONS(2967),
    [anon_sym_const] = ACTIONS(2967),
    [anon_sym_file] = ACTIONS(2967),
    [anon_sym_fixed] = ACTIONS(2967),
    [anon_sym_internal] = ACTIONS(2967),
    [anon_sym_new] = ACTIONS(2967),
    [anon_sym_override] = ACTIONS(2967),
    [anon_sym_partial] = ACTIONS(2967),
    [anon_sym_private] = ACTIONS(2967),
    [anon_sym_protected] = ACTIONS(2967),
    [anon_sym_public] = ACTIONS(2967),
    [anon_sym_readonly] = ACTIONS(2967),
    [anon_sym_required] = ACTIONS(2967),
    [anon_sym_sealed] = ACTIONS(2967),
    [anon_sym_virtual] = ACTIONS(2967),
    [anon_sym_volatile] = ACTIONS(2967),
    [anon_sym_where] = ACTIONS(2967),
    [anon_sym_notnull] = ACTIONS(2967),
    [anon_sym_unmanaged] = ACTIONS(2967),
    [anon_sym_get] = ACTIONS(2967),
    [anon_sym_set] = ACTIONS(2967),
    [anon_sym_add] = ACTIONS(2967),
    [anon_sym_remove] = ACTIONS(2967),
    [anon_sym_init] = ACTIONS(2967),
    [anon_sym_scoped] = ACTIONS(2967),
    [anon_sym_var] = ACTIONS(2967),
    [anon_sym_yield] = ACTIONS(2967),
    [anon_sym_when] = ACTIONS(2967),
    [anon_sym_from] = ACTIONS(2967),
    [anon_sym_into] = ACTIONS(2967),
    [anon_sym_join] = ACTIONS(2967),
    [anon_sym_on] = ACTIONS(2967),
    [anon_sym_equals] = ACTIONS(2967),
    [anon_sym_let] = ACTIONS(2967),
    [anon_sym_orderby] = ACTIONS(2967),
    [anon_sym_ascending] = ACTIONS(2967),
    [anon_sym_descending] = ACTIONS(2967),
    [anon_sym_group] = ACTIONS(2967),
    [anon_sym_by] = ACTIONS(2967),
    [anon_sym_select] = ACTIONS(2967),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4322] = {
    [sym_preproc_region] = STATE(4322),
    [sym_preproc_endregion] = STATE(4322),
    [sym_preproc_line] = STATE(4322),
    [sym_preproc_pragma] = STATE(4322),
    [sym_preproc_nullable] = STATE(4322),
    [sym_preproc_error] = STATE(4322),
    [sym_preproc_define] = STATE(4322),
    [sym_preproc_undef] = STATE(4322),
    [anon_sym_EQ] = ACTIONS(6010),
    [anon_sym_LBRACK] = ACTIONS(5249),
    [anon_sym_LPAREN] = ACTIONS(5249),
    [anon_sym_LT] = ACTIONS(5251),
    [anon_sym_GT] = ACTIONS(5251),
    [anon_sym_QMARK] = ACTIONS(5251),
    [anon_sym_BANG] = ACTIONS(5251),
    [anon_sym_PLUS_PLUS] = ACTIONS(5249),
    [anon_sym_DASH_DASH] = ACTIONS(5249),
    [anon_sym_PLUS] = ACTIONS(5251),
    [anon_sym_DASH] = ACTIONS(5251),
    [anon_sym_STAR] = ACTIONS(5251),
    [anon_sym_SLASH] = ACTIONS(5251),
    [anon_sym_PERCENT] = ACTIONS(5251),
    [anon_sym_CARET] = ACTIONS(5251),
    [anon_sym_PIPE] = ACTIONS(5251),
    [anon_sym_AMP] = ACTIONS(5251),
    [anon_sym_LT_LT] = ACTIONS(5251),
    [anon_sym_GT_GT] = ACTIONS(5251),
    [anon_sym_GT_GT_GT] = ACTIONS(5251),
    [anon_sym_EQ_EQ] = ACTIONS(5249),
    [anon_sym_BANG_EQ] = ACTIONS(5249),
    [anon_sym_GT_EQ] = ACTIONS(5249),
    [anon_sym_LT_EQ] = ACTIONS(5249),
    [anon_sym_DOT] = ACTIONS(5251),
    [anon_sym_switch] = ACTIONS(5249),
    [anon_sym_DOT_DOT] = ACTIONS(5249),
    [anon_sym_and] = ACTIONS(5249),
    [anon_sym_or] = ACTIONS(5249),
    [anon_sym_PLUS_EQ] = ACTIONS(6012),
    [anon_sym_DASH_EQ] = ACTIONS(6012),
    [anon_sym_STAR_EQ] = ACTIONS(6012),
    [anon_sym_SLASH_EQ] = ACTIONS(6012),
    [anon_sym_PERCENT_EQ] = ACTIONS(6012),
    [anon_sym_AMP_EQ] = ACTIONS(6012),
    [anon_sym_CARET_EQ] = ACTIONS(6012),
    [anon_sym_PIPE_EQ] = ACTIONS(6012),
    [anon_sym_LT_LT_EQ] = ACTIONS(6012),
    [anon_sym_GT_GT_EQ] = ACTIONS(6012),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6012),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(6012),
    [anon_sym_AMP_AMP] = ACTIONS(5249),
    [anon_sym_PIPE_PIPE] = ACTIONS(5249),
    [anon_sym_QMARK_QMARK] = ACTIONS(5251),
    [anon_sym_equals] = ACTIONS(5249),
    [anon_sym_as] = ACTIONS(5249),
    [anon_sym_is] = ACTIONS(5249),
    [anon_sym_DASH_GT] = ACTIONS(5249),
    [anon_sym_with] = ACTIONS(5249),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4323] = {
    [sym_preproc_region] = STATE(4323),
    [sym_preproc_endregion] = STATE(4323),
    [sym_preproc_line] = STATE(4323),
    [sym_preproc_pragma] = STATE(4323),
    [sym_preproc_nullable] = STATE(4323),
    [sym_preproc_error] = STATE(4323),
    [sym_preproc_define] = STATE(4323),
    [sym_preproc_undef] = STATE(4323),
    [anon_sym_EQ] = ACTIONS(6014),
    [anon_sym_LBRACK] = ACTIONS(5249),
    [anon_sym_COLON] = ACTIONS(5249),
    [anon_sym_COMMA] = ACTIONS(5249),
    [anon_sym_LPAREN] = ACTIONS(5249),
    [anon_sym_LT] = ACTIONS(5251),
    [anon_sym_GT] = ACTIONS(5251),
    [anon_sym_QMARK] = ACTIONS(5251),
    [anon_sym_BANG] = ACTIONS(5251),
    [anon_sym_PLUS_PLUS] = ACTIONS(5249),
    [anon_sym_DASH_DASH] = ACTIONS(5249),
    [anon_sym_PLUS] = ACTIONS(5251),
    [anon_sym_DASH] = ACTIONS(5251),
    [anon_sym_STAR] = ACTIONS(5251),
    [anon_sym_SLASH] = ACTIONS(5251),
    [anon_sym_PERCENT] = ACTIONS(5251),
    [anon_sym_CARET] = ACTIONS(5251),
    [anon_sym_PIPE] = ACTIONS(5251),
    [anon_sym_AMP] = ACTIONS(5251),
    [anon_sym_LT_LT] = ACTIONS(5251),
    [anon_sym_GT_GT] = ACTIONS(5251),
    [anon_sym_GT_GT_GT] = ACTIONS(5251),
    [anon_sym_EQ_EQ] = ACTIONS(5249),
    [anon_sym_BANG_EQ] = ACTIONS(5249),
    [anon_sym_GT_EQ] = ACTIONS(5249),
    [anon_sym_LT_EQ] = ACTIONS(5249),
    [anon_sym_DOT] = ACTIONS(5251),
    [anon_sym_switch] = ACTIONS(5249),
    [anon_sym_DOT_DOT] = ACTIONS(5249),
    [anon_sym_PLUS_EQ] = ACTIONS(6016),
    [anon_sym_DASH_EQ] = ACTIONS(6016),
    [anon_sym_STAR_EQ] = ACTIONS(6016),
    [anon_sym_SLASH_EQ] = ACTIONS(6016),
    [anon_sym_PERCENT_EQ] = ACTIONS(6016),
    [anon_sym_AMP_EQ] = ACTIONS(6016),
    [anon_sym_CARET_EQ] = ACTIONS(6016),
    [anon_sym_PIPE_EQ] = ACTIONS(6016),
    [anon_sym_LT_LT_EQ] = ACTIONS(6016),
    [anon_sym_GT_GT_EQ] = ACTIONS(6016),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6016),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(6016),
    [anon_sym_AMP_AMP] = ACTIONS(5249),
    [anon_sym_PIPE_PIPE] = ACTIONS(5249),
    [anon_sym_QMARK_QMARK] = ACTIONS(5251),
    [anon_sym_as] = ACTIONS(5249),
    [anon_sym_is] = ACTIONS(5249),
    [anon_sym_DASH_GT] = ACTIONS(5249),
    [anon_sym_with] = ACTIONS(5249),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(5249),
  },
  [4324] = {
    [sym__name] = STATE(6160),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(2738),
    [sym_ref_type] = STATE(2899),
    [sym__scoped_base_type] = STATE(2907),
    [sym_identifier] = STATE(5368),
    [sym__reserved_identifier] = STATE(2733),
    [sym_preproc_region] = STATE(4324),
    [sym_preproc_endregion] = STATE(4324),
    [sym_preproc_line] = STATE(4324),
    [sym_preproc_pragma] = STATE(4324),
    [sym_preproc_nullable] = STATE(4324),
    [sym_preproc_error] = STATE(4324),
    [sym_preproc_define] = STATE(4324),
    [sym_preproc_undef] = STATE(4324),
    [sym__identifier_token] = ACTIONS(4006),
    [anon_sym_alias] = ACTIONS(4009),
    [anon_sym_global] = ACTIONS(4009),
    [anon_sym_LBRACK] = ACTIONS(3719),
    [anon_sym_COMMA] = ACTIONS(3719),
    [anon_sym_RBRACK] = ACTIONS(3719),
    [anon_sym_LPAREN] = ACTIONS(3719),
    [anon_sym_RPAREN] = ACTIONS(3719),
    [anon_sym_ref] = ACTIONS(4012),
    [anon_sym_LBRACE] = ACTIONS(3719),
    [anon_sym_RBRACE] = ACTIONS(3719),
    [anon_sym_file] = ACTIONS(4009),
    [anon_sym_LT] = ACTIONS(3719),
    [anon_sym_where] = ACTIONS(4009),
    [anon_sym_QMARK] = ACTIONS(3719),
    [anon_sym_notnull] = ACTIONS(4009),
    [anon_sym_unmanaged] = ACTIONS(4009),
    [anon_sym_STAR] = ACTIONS(3719),
    [anon_sym_DOT] = ACTIONS(3719),
    [anon_sym_scoped] = ACTIONS(4009),
    [anon_sym_EQ_GT] = ACTIONS(3719),
    [anon_sym_COLON_COLON] = ACTIONS(3719),
    [anon_sym_var] = ACTIONS(4009),
    [anon_sym_yield] = ACTIONS(4009),
    [anon_sym_when] = ACTIONS(4009),
    [sym_discard] = ACTIONS(3721),
    [anon_sym_and] = ACTIONS(3721),
    [anon_sym_or] = ACTIONS(3721),
    [anon_sym_from] = ACTIONS(4009),
    [anon_sym_into] = ACTIONS(4009),
    [anon_sym_join] = ACTIONS(4009),
    [anon_sym_on] = ACTIONS(4009),
    [anon_sym_equals] = ACTIONS(4009),
    [anon_sym_let] = ACTIONS(4009),
    [anon_sym_orderby] = ACTIONS(4009),
    [anon_sym_ascending] = ACTIONS(4009),
    [anon_sym_descending] = ACTIONS(4009),
    [anon_sym_group] = ACTIONS(4009),
    [anon_sym_by] = ACTIONS(4009),
    [anon_sym_select] = ACTIONS(4009),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4325] = {
    [sym_argument_list] = STATE(4235),
    [sym_bracketed_argument_list] = STATE(3015),
    [sym_preproc_region] = STATE(4325),
    [sym_preproc_endregion] = STATE(4325),
    [sym_preproc_line] = STATE(4325),
    [sym_preproc_pragma] = STATE(4325),
    [sym_preproc_nullable] = STATE(4325),
    [sym_preproc_error] = STATE(4325),
    [sym_preproc_define] = STATE(4325),
    [sym_preproc_undef] = STATE(4325),
    [anon_sym_SEMI] = ACTIONS(5233),
    [anon_sym_LBRACK] = ACTIONS(5978),
    [anon_sym_COLON] = ACTIONS(5233),
    [anon_sym_COMMA] = ACTIONS(5233),
    [anon_sym_RBRACK] = ACTIONS(5233),
    [anon_sym_LPAREN] = ACTIONS(5711),
    [anon_sym_RPAREN] = ACTIONS(5233),
    [anon_sym_RBRACE] = ACTIONS(5233),
    [anon_sym_LT] = ACTIONS(5237),
    [anon_sym_GT] = ACTIONS(5237),
    [anon_sym_in] = ACTIONS(5233),
    [anon_sym_QMARK] = ACTIONS(5237),
    [anon_sym_BANG] = ACTIONS(5745),
    [anon_sym_PLUS_PLUS] = ACTIONS(5747),
    [anon_sym_DASH_DASH] = ACTIONS(5747),
    [anon_sym_PLUS] = ACTIONS(5237),
    [anon_sym_DASH] = ACTIONS(5237),
    [anon_sym_STAR] = ACTIONS(5233),
    [anon_sym_SLASH] = ACTIONS(5237),
    [anon_sym_PERCENT] = ACTIONS(5233),
    [anon_sym_CARET] = ACTIONS(5233),
    [anon_sym_PIPE] = ACTIONS(5237),
    [anon_sym_AMP] = ACTIONS(5237),
    [anon_sym_LT_LT] = ACTIONS(5233),
    [anon_sym_GT_GT] = ACTIONS(5237),
    [anon_sym_GT_GT_GT] = ACTIONS(5233),
    [anon_sym_EQ_EQ] = ACTIONS(5233),
    [anon_sym_BANG_EQ] = ACTIONS(5233),
    [anon_sym_GT_EQ] = ACTIONS(5233),
    [anon_sym_LT_EQ] = ACTIONS(5233),
    [anon_sym_DOT] = ACTIONS(4560),
    [anon_sym_EQ_GT] = ACTIONS(5233),
    [anon_sym_switch] = ACTIONS(5233),
    [anon_sym_DOT_DOT] = ACTIONS(5233),
    [anon_sym_AMP_AMP] = ACTIONS(5233),
    [anon_sym_PIPE_PIPE] = ACTIONS(5233),
    [anon_sym_QMARK_QMARK] = ACTIONS(5233),
    [anon_sym_on] = ACTIONS(5233),
    [anon_sym_equals] = ACTIONS(5233),
    [anon_sym_by] = ACTIONS(5233),
    [anon_sym_as] = ACTIONS(5233),
    [anon_sym_is] = ACTIONS(5233),
    [anon_sym_DASH_GT] = ACTIONS(4562),
    [anon_sym_with] = ACTIONS(5233),
    [aux_sym_preproc_if_token3] = ACTIONS(5233),
    [aux_sym_preproc_else_token1] = ACTIONS(5233),
    [aux_sym_preproc_elif_token1] = ACTIONS(5233),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4326] = {
    [sym_preproc_region] = STATE(4326),
    [sym_preproc_endregion] = STATE(4326),
    [sym_preproc_line] = STATE(4326),
    [sym_preproc_pragma] = STATE(4326),
    [sym_preproc_nullable] = STATE(4326),
    [sym_preproc_error] = STATE(4326),
    [sym_preproc_define] = STATE(4326),
    [sym_preproc_undef] = STATE(4326),
    [anon_sym_EQ] = ACTIONS(6018),
    [anon_sym_LBRACK] = ACTIONS(5249),
    [anon_sym_LPAREN] = ACTIONS(5249),
    [anon_sym_LT] = ACTIONS(5251),
    [anon_sym_GT] = ACTIONS(5251),
    [anon_sym_QMARK] = ACTIONS(5251),
    [anon_sym_BANG] = ACTIONS(5251),
    [anon_sym_PLUS_PLUS] = ACTIONS(5249),
    [anon_sym_DASH_DASH] = ACTIONS(5249),
    [anon_sym_PLUS] = ACTIONS(5251),
    [anon_sym_DASH] = ACTIONS(5251),
    [anon_sym_STAR] = ACTIONS(5251),
    [anon_sym_SLASH] = ACTIONS(5251),
    [anon_sym_PERCENT] = ACTIONS(5251),
    [anon_sym_CARET] = ACTIONS(5251),
    [anon_sym_PIPE] = ACTIONS(5251),
    [anon_sym_AMP] = ACTIONS(5251),
    [anon_sym_LT_LT] = ACTIONS(5251),
    [anon_sym_GT_GT] = ACTIONS(5251),
    [anon_sym_GT_GT_GT] = ACTIONS(5251),
    [anon_sym_EQ_EQ] = ACTIONS(5249),
    [anon_sym_BANG_EQ] = ACTIONS(5249),
    [anon_sym_GT_EQ] = ACTIONS(5249),
    [anon_sym_LT_EQ] = ACTIONS(5249),
    [anon_sym_DOT] = ACTIONS(5251),
    [anon_sym_switch] = ACTIONS(5249),
    [anon_sym_DOT_DOT] = ACTIONS(5249),
    [anon_sym_and] = ACTIONS(5249),
    [anon_sym_or] = ACTIONS(5249),
    [anon_sym_PLUS_EQ] = ACTIONS(6020),
    [anon_sym_DASH_EQ] = ACTIONS(6020),
    [anon_sym_STAR_EQ] = ACTIONS(6020),
    [anon_sym_SLASH_EQ] = ACTIONS(6020),
    [anon_sym_PERCENT_EQ] = ACTIONS(6020),
    [anon_sym_AMP_EQ] = ACTIONS(6020),
    [anon_sym_CARET_EQ] = ACTIONS(6020),
    [anon_sym_PIPE_EQ] = ACTIONS(6020),
    [anon_sym_LT_LT_EQ] = ACTIONS(6020),
    [anon_sym_GT_GT_EQ] = ACTIONS(6020),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6020),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(6020),
    [anon_sym_AMP_AMP] = ACTIONS(5249),
    [anon_sym_PIPE_PIPE] = ACTIONS(5249),
    [anon_sym_QMARK_QMARK] = ACTIONS(5251),
    [anon_sym_on] = ACTIONS(5249),
    [anon_sym_as] = ACTIONS(5249),
    [anon_sym_is] = ACTIONS(5249),
    [anon_sym_DASH_GT] = ACTIONS(5249),
    [anon_sym_with] = ACTIONS(5249),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4327] = {
    [sym_preproc_region] = STATE(4327),
    [sym_preproc_endregion] = STATE(4327),
    [sym_preproc_line] = STATE(4327),
    [sym_preproc_pragma] = STATE(4327),
    [sym_preproc_nullable] = STATE(4327),
    [sym_preproc_error] = STATE(4327),
    [sym_preproc_define] = STATE(4327),
    [sym_preproc_undef] = STATE(4327),
    [anon_sym_SEMI] = ACTIONS(4428),
    [anon_sym_LBRACK] = ACTIONS(4428),
    [anon_sym_COLON] = ACTIONS(4428),
    [anon_sym_COMMA] = ACTIONS(4428),
    [anon_sym_RBRACK] = ACTIONS(4428),
    [anon_sym_LPAREN] = ACTIONS(4428),
    [anon_sym_RPAREN] = ACTIONS(4428),
    [anon_sym_LBRACE] = ACTIONS(4428),
    [anon_sym_RBRACE] = ACTIONS(4428),
    [anon_sym_LT] = ACTIONS(4426),
    [anon_sym_GT] = ACTIONS(4426),
    [anon_sym_in] = ACTIONS(4426),
    [anon_sym_QMARK] = ACTIONS(4426),
    [anon_sym_BANG] = ACTIONS(4426),
    [anon_sym_PLUS_PLUS] = ACTIONS(4428),
    [anon_sym_DASH_DASH] = ACTIONS(4428),
    [anon_sym_PLUS] = ACTIONS(4426),
    [anon_sym_DASH] = ACTIONS(4426),
    [anon_sym_STAR] = ACTIONS(4428),
    [anon_sym_SLASH] = ACTIONS(4426),
    [anon_sym_PERCENT] = ACTIONS(4428),
    [anon_sym_CARET] = ACTIONS(4428),
    [anon_sym_PIPE] = ACTIONS(4426),
    [anon_sym_AMP] = ACTIONS(4426),
    [anon_sym_LT_LT] = ACTIONS(4428),
    [anon_sym_GT_GT] = ACTIONS(4426),
    [anon_sym_GT_GT_GT] = ACTIONS(4428),
    [anon_sym_EQ_EQ] = ACTIONS(4428),
    [anon_sym_BANG_EQ] = ACTIONS(4428),
    [anon_sym_GT_EQ] = ACTIONS(4428),
    [anon_sym_LT_EQ] = ACTIONS(4428),
    [anon_sym_DOT] = ACTIONS(6022),
    [anon_sym_EQ_GT] = ACTIONS(4428),
    [anon_sym_switch] = ACTIONS(4428),
    [anon_sym_DOT_DOT] = ACTIONS(4428),
    [anon_sym_AMP_AMP] = ACTIONS(4428),
    [anon_sym_PIPE_PIPE] = ACTIONS(4428),
    [anon_sym_QMARK_QMARK] = ACTIONS(4428),
    [anon_sym_into] = ACTIONS(4428),
    [anon_sym_on] = ACTIONS(4428),
    [anon_sym_equals] = ACTIONS(4428),
    [anon_sym_by] = ACTIONS(4428),
    [anon_sym_as] = ACTIONS(4428),
    [anon_sym_is] = ACTIONS(4428),
    [anon_sym_DASH_GT] = ACTIONS(4428),
    [anon_sym_with] = ACTIONS(4428),
    [aux_sym_preproc_if_token3] = ACTIONS(4428),
    [aux_sym_preproc_else_token1] = ACTIONS(4428),
    [aux_sym_preproc_elif_token1] = ACTIONS(4428),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4328] = {
    [sym_preproc_region] = STATE(4328),
    [sym_preproc_endregion] = STATE(4328),
    [sym_preproc_line] = STATE(4328),
    [sym_preproc_pragma] = STATE(4328),
    [sym_preproc_nullable] = STATE(4328),
    [sym_preproc_error] = STATE(4328),
    [sym_preproc_define] = STATE(4328),
    [sym_preproc_undef] = STATE(4328),
    [anon_sym_SEMI] = ACTIONS(4424),
    [anon_sym_LBRACK] = ACTIONS(4547),
    [anon_sym_COLON] = ACTIONS(4424),
    [anon_sym_COMMA] = ACTIONS(4424),
    [anon_sym_RBRACK] = ACTIONS(4424),
    [anon_sym_LPAREN] = ACTIONS(4424),
    [anon_sym_RPAREN] = ACTIONS(4424),
    [anon_sym_LBRACE] = ACTIONS(4424),
    [anon_sym_RBRACE] = ACTIONS(4424),
    [anon_sym_LT] = ACTIONS(4422),
    [anon_sym_GT] = ACTIONS(4422),
    [anon_sym_in] = ACTIONS(4422),
    [anon_sym_QMARK] = ACTIONS(5274),
    [anon_sym_BANG] = ACTIONS(4422),
    [anon_sym_PLUS_PLUS] = ACTIONS(4424),
    [anon_sym_DASH_DASH] = ACTIONS(4424),
    [anon_sym_PLUS] = ACTIONS(4422),
    [anon_sym_DASH] = ACTIONS(4422),
    [anon_sym_STAR] = ACTIONS(4553),
    [anon_sym_SLASH] = ACTIONS(4422),
    [anon_sym_PERCENT] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4424),
    [anon_sym_PIPE] = ACTIONS(4422),
    [anon_sym_AMP] = ACTIONS(4422),
    [anon_sym_LT_LT] = ACTIONS(4424),
    [anon_sym_GT_GT] = ACTIONS(4422),
    [anon_sym_GT_GT_GT] = ACTIONS(4424),
    [anon_sym_EQ_EQ] = ACTIONS(4424),
    [anon_sym_BANG_EQ] = ACTIONS(4424),
    [anon_sym_GT_EQ] = ACTIONS(4424),
    [anon_sym_LT_EQ] = ACTIONS(4424),
    [anon_sym_DOT] = ACTIONS(6022),
    [anon_sym_EQ_GT] = ACTIONS(4424),
    [anon_sym_switch] = ACTIONS(4424),
    [anon_sym_DOT_DOT] = ACTIONS(4424),
    [anon_sym_AMP_AMP] = ACTIONS(4424),
    [anon_sym_PIPE_PIPE] = ACTIONS(4424),
    [anon_sym_QMARK_QMARK] = ACTIONS(4424),
    [anon_sym_into] = ACTIONS(4424),
    [anon_sym_on] = ACTIONS(4424),
    [anon_sym_equals] = ACTIONS(4424),
    [anon_sym_by] = ACTIONS(4424),
    [anon_sym_as] = ACTIONS(4424),
    [anon_sym_is] = ACTIONS(4424),
    [anon_sym_DASH_GT] = ACTIONS(4424),
    [anon_sym_with] = ACTIONS(4424),
    [aux_sym_preproc_if_token3] = ACTIONS(4424),
    [aux_sym_preproc_else_token1] = ACTIONS(4424),
    [aux_sym_preproc_elif_token1] = ACTIONS(4424),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4329] = {
    [sym_preproc_region] = STATE(4329),
    [sym_preproc_endregion] = STATE(4329),
    [sym_preproc_line] = STATE(4329),
    [sym_preproc_pragma] = STATE(4329),
    [sym_preproc_nullable] = STATE(4329),
    [sym_preproc_error] = STATE(4329),
    [sym_preproc_define] = STATE(4329),
    [sym_preproc_undef] = STATE(4329),
    [anon_sym_EQ] = ACTIONS(6024),
    [anon_sym_LBRACK] = ACTIONS(5249),
    [anon_sym_LPAREN] = ACTIONS(5249),
    [anon_sym_LT] = ACTIONS(5251),
    [anon_sym_GT] = ACTIONS(5251),
    [anon_sym_QMARK] = ACTIONS(5251),
    [anon_sym_BANG] = ACTIONS(5251),
    [anon_sym_PLUS_PLUS] = ACTIONS(5249),
    [anon_sym_DASH_DASH] = ACTIONS(5249),
    [anon_sym_PLUS] = ACTIONS(5251),
    [anon_sym_DASH] = ACTIONS(5251),
    [anon_sym_STAR] = ACTIONS(5251),
    [anon_sym_SLASH] = ACTIONS(5251),
    [anon_sym_PERCENT] = ACTIONS(5251),
    [anon_sym_CARET] = ACTIONS(5251),
    [anon_sym_PIPE] = ACTIONS(5251),
    [anon_sym_AMP] = ACTIONS(5251),
    [anon_sym_LT_LT] = ACTIONS(5251),
    [anon_sym_GT_GT] = ACTIONS(5251),
    [anon_sym_GT_GT_GT] = ACTIONS(5251),
    [anon_sym_EQ_EQ] = ACTIONS(5249),
    [anon_sym_BANG_EQ] = ACTIONS(5249),
    [anon_sym_GT_EQ] = ACTIONS(5249),
    [anon_sym_LT_EQ] = ACTIONS(5249),
    [anon_sym_DOT] = ACTIONS(5251),
    [anon_sym_EQ_GT] = ACTIONS(5249),
    [anon_sym_switch] = ACTIONS(5249),
    [anon_sym_DOT_DOT] = ACTIONS(5249),
    [anon_sym_and] = ACTIONS(5249),
    [anon_sym_or] = ACTIONS(5249),
    [anon_sym_PLUS_EQ] = ACTIONS(6026),
    [anon_sym_DASH_EQ] = ACTIONS(6026),
    [anon_sym_STAR_EQ] = ACTIONS(6026),
    [anon_sym_SLASH_EQ] = ACTIONS(6026),
    [anon_sym_PERCENT_EQ] = ACTIONS(6026),
    [anon_sym_AMP_EQ] = ACTIONS(6026),
    [anon_sym_CARET_EQ] = ACTIONS(6026),
    [anon_sym_PIPE_EQ] = ACTIONS(6026),
    [anon_sym_LT_LT_EQ] = ACTIONS(6026),
    [anon_sym_GT_GT_EQ] = ACTIONS(6026),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6026),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(6026),
    [anon_sym_AMP_AMP] = ACTIONS(5249),
    [anon_sym_PIPE_PIPE] = ACTIONS(5249),
    [anon_sym_QMARK_QMARK] = ACTIONS(5251),
    [anon_sym_as] = ACTIONS(5249),
    [anon_sym_is] = ACTIONS(5249),
    [anon_sym_DASH_GT] = ACTIONS(5249),
    [anon_sym_with] = ACTIONS(5249),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4330] = {
    [sym_preproc_region] = STATE(4330),
    [sym_preproc_endregion] = STATE(4330),
    [sym_preproc_line] = STATE(4330),
    [sym_preproc_pragma] = STATE(4330),
    [sym_preproc_nullable] = STATE(4330),
    [sym_preproc_error] = STATE(4330),
    [sym_preproc_define] = STATE(4330),
    [sym_preproc_undef] = STATE(4330),
    [sym__identifier_token] = ACTIONS(6028),
    [anon_sym_extern] = ACTIONS(6028),
    [anon_sym_alias] = ACTIONS(6028),
    [anon_sym_global] = ACTIONS(6028),
    [anon_sym_unsafe] = ACTIONS(6028),
    [anon_sym_static] = ACTIONS(6028),
    [anon_sym_LBRACK] = ACTIONS(6030),
    [anon_sym_RBRACE] = ACTIONS(6030),
    [anon_sym_abstract] = ACTIONS(6028),
    [anon_sym_async] = ACTIONS(6028),
    [anon_sym_const] = ACTIONS(6028),
    [anon_sym_file] = ACTIONS(6028),
    [anon_sym_fixed] = ACTIONS(6028),
    [anon_sym_internal] = ACTIONS(6028),
    [anon_sym_new] = ACTIONS(6028),
    [anon_sym_override] = ACTIONS(6028),
    [anon_sym_partial] = ACTIONS(6028),
    [anon_sym_private] = ACTIONS(6028),
    [anon_sym_protected] = ACTIONS(6028),
    [anon_sym_public] = ACTIONS(6028),
    [anon_sym_readonly] = ACTIONS(6028),
    [anon_sym_required] = ACTIONS(6028),
    [anon_sym_sealed] = ACTIONS(6028),
    [anon_sym_virtual] = ACTIONS(6028),
    [anon_sym_volatile] = ACTIONS(6028),
    [anon_sym_where] = ACTIONS(6028),
    [anon_sym_notnull] = ACTIONS(6028),
    [anon_sym_unmanaged] = ACTIONS(6028),
    [anon_sym_get] = ACTIONS(6028),
    [anon_sym_set] = ACTIONS(6028),
    [anon_sym_add] = ACTIONS(6028),
    [anon_sym_remove] = ACTIONS(6028),
    [anon_sym_init] = ACTIONS(6028),
    [anon_sym_scoped] = ACTIONS(6028),
    [anon_sym_var] = ACTIONS(6028),
    [anon_sym_yield] = ACTIONS(6028),
    [anon_sym_when] = ACTIONS(6028),
    [anon_sym_from] = ACTIONS(6028),
    [anon_sym_into] = ACTIONS(6028),
    [anon_sym_join] = ACTIONS(6028),
    [anon_sym_on] = ACTIONS(6028),
    [anon_sym_equals] = ACTIONS(6028),
    [anon_sym_let] = ACTIONS(6028),
    [anon_sym_orderby] = ACTIONS(6028),
    [anon_sym_ascending] = ACTIONS(6028),
    [anon_sym_descending] = ACTIONS(6028),
    [anon_sym_group] = ACTIONS(6028),
    [anon_sym_by] = ACTIONS(6028),
    [anon_sym_select] = ACTIONS(6028),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4331] = {
    [sym_preproc_region] = STATE(4331),
    [sym_preproc_endregion] = STATE(4331),
    [sym_preproc_line] = STATE(4331),
    [sym_preproc_pragma] = STATE(4331),
    [sym_preproc_nullable] = STATE(4331),
    [sym_preproc_error] = STATE(4331),
    [sym_preproc_define] = STATE(4331),
    [sym_preproc_undef] = STATE(4331),
    [sym__identifier_token] = ACTIONS(3247),
    [anon_sym_extern] = ACTIONS(3247),
    [anon_sym_alias] = ACTIONS(3247),
    [anon_sym_global] = ACTIONS(3247),
    [anon_sym_unsafe] = ACTIONS(3247),
    [anon_sym_static] = ACTIONS(3247),
    [anon_sym_LBRACK] = ACTIONS(3249),
    [anon_sym_RBRACE] = ACTIONS(3249),
    [anon_sym_abstract] = ACTIONS(3247),
    [anon_sym_async] = ACTIONS(3247),
    [anon_sym_const] = ACTIONS(3247),
    [anon_sym_file] = ACTIONS(3247),
    [anon_sym_fixed] = ACTIONS(3247),
    [anon_sym_internal] = ACTIONS(3247),
    [anon_sym_new] = ACTIONS(3247),
    [anon_sym_override] = ACTIONS(3247),
    [anon_sym_partial] = ACTIONS(3247),
    [anon_sym_private] = ACTIONS(3247),
    [anon_sym_protected] = ACTIONS(3247),
    [anon_sym_public] = ACTIONS(3247),
    [anon_sym_readonly] = ACTIONS(3247),
    [anon_sym_required] = ACTIONS(3247),
    [anon_sym_sealed] = ACTIONS(3247),
    [anon_sym_virtual] = ACTIONS(3247),
    [anon_sym_volatile] = ACTIONS(3247),
    [anon_sym_where] = ACTIONS(3247),
    [anon_sym_notnull] = ACTIONS(3247),
    [anon_sym_unmanaged] = ACTIONS(3247),
    [anon_sym_get] = ACTIONS(3247),
    [anon_sym_set] = ACTIONS(3247),
    [anon_sym_add] = ACTIONS(3247),
    [anon_sym_remove] = ACTIONS(3247),
    [anon_sym_init] = ACTIONS(3247),
    [anon_sym_scoped] = ACTIONS(3247),
    [anon_sym_var] = ACTIONS(3247),
    [anon_sym_yield] = ACTIONS(3247),
    [anon_sym_when] = ACTIONS(3247),
    [anon_sym_from] = ACTIONS(3247),
    [anon_sym_into] = ACTIONS(3247),
    [anon_sym_join] = ACTIONS(3247),
    [anon_sym_on] = ACTIONS(3247),
    [anon_sym_equals] = ACTIONS(3247),
    [anon_sym_let] = ACTIONS(3247),
    [anon_sym_orderby] = ACTIONS(3247),
    [anon_sym_ascending] = ACTIONS(3247),
    [anon_sym_descending] = ACTIONS(3247),
    [anon_sym_group] = ACTIONS(3247),
    [anon_sym_by] = ACTIONS(3247),
    [anon_sym_select] = ACTIONS(3247),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4332] = {
    [sym_preproc_region] = STATE(4332),
    [sym_preproc_endregion] = STATE(4332),
    [sym_preproc_line] = STATE(4332),
    [sym_preproc_pragma] = STATE(4332),
    [sym_preproc_nullable] = STATE(4332),
    [sym_preproc_error] = STATE(4332),
    [sym_preproc_define] = STATE(4332),
    [sym_preproc_undef] = STATE(4332),
    [sym__identifier_token] = ACTIONS(3271),
    [anon_sym_extern] = ACTIONS(3271),
    [anon_sym_alias] = ACTIONS(3271),
    [anon_sym_global] = ACTIONS(3271),
    [anon_sym_unsafe] = ACTIONS(3271),
    [anon_sym_static] = ACTIONS(3271),
    [anon_sym_LBRACK] = ACTIONS(3273),
    [anon_sym_RBRACE] = ACTIONS(3273),
    [anon_sym_abstract] = ACTIONS(3271),
    [anon_sym_async] = ACTIONS(3271),
    [anon_sym_const] = ACTIONS(3271),
    [anon_sym_file] = ACTIONS(3271),
    [anon_sym_fixed] = ACTIONS(3271),
    [anon_sym_internal] = ACTIONS(3271),
    [anon_sym_new] = ACTIONS(3271),
    [anon_sym_override] = ACTIONS(3271),
    [anon_sym_partial] = ACTIONS(3271),
    [anon_sym_private] = ACTIONS(3271),
    [anon_sym_protected] = ACTIONS(3271),
    [anon_sym_public] = ACTIONS(3271),
    [anon_sym_readonly] = ACTIONS(3271),
    [anon_sym_required] = ACTIONS(3271),
    [anon_sym_sealed] = ACTIONS(3271),
    [anon_sym_virtual] = ACTIONS(3271),
    [anon_sym_volatile] = ACTIONS(3271),
    [anon_sym_where] = ACTIONS(3271),
    [anon_sym_notnull] = ACTIONS(3271),
    [anon_sym_unmanaged] = ACTIONS(3271),
    [anon_sym_get] = ACTIONS(3271),
    [anon_sym_set] = ACTIONS(3271),
    [anon_sym_add] = ACTIONS(3271),
    [anon_sym_remove] = ACTIONS(3271),
    [anon_sym_init] = ACTIONS(3271),
    [anon_sym_scoped] = ACTIONS(3271),
    [anon_sym_var] = ACTIONS(3271),
    [anon_sym_yield] = ACTIONS(3271),
    [anon_sym_when] = ACTIONS(3271),
    [anon_sym_from] = ACTIONS(3271),
    [anon_sym_into] = ACTIONS(3271),
    [anon_sym_join] = ACTIONS(3271),
    [anon_sym_on] = ACTIONS(3271),
    [anon_sym_equals] = ACTIONS(3271),
    [anon_sym_let] = ACTIONS(3271),
    [anon_sym_orderby] = ACTIONS(3271),
    [anon_sym_ascending] = ACTIONS(3271),
    [anon_sym_descending] = ACTIONS(3271),
    [anon_sym_group] = ACTIONS(3271),
    [anon_sym_by] = ACTIONS(3271),
    [anon_sym_select] = ACTIONS(3271),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4333] = {
    [sym_attribute_list] = STATE(4467),
    [sym_preproc_region] = STATE(4333),
    [sym_preproc_endregion] = STATE(4333),
    [sym_preproc_line] = STATE(4333),
    [sym_preproc_pragma] = STATE(4333),
    [sym_preproc_nullable] = STATE(4333),
    [sym_preproc_error] = STATE(4333),
    [sym_preproc_define] = STATE(4333),
    [sym_preproc_undef] = STATE(4333),
    [aux_sym_class_declaration_repeat1] = STATE(4333),
    [sym__identifier_token] = ACTIONS(5277),
    [anon_sym_extern] = ACTIONS(5277),
    [anon_sym_alias] = ACTIONS(5277),
    [anon_sym_global] = ACTIONS(5277),
    [anon_sym_unsafe] = ACTIONS(5277),
    [anon_sym_static] = ACTIONS(5277),
    [anon_sym_LBRACK] = ACTIONS(6032),
    [anon_sym_LPAREN] = ACTIONS(5282),
    [anon_sym_ref] = ACTIONS(5277),
    [anon_sym_delegate] = ACTIONS(5277),
    [anon_sym_abstract] = ACTIONS(5277),
    [anon_sym_async] = ACTIONS(5277),
    [anon_sym_const] = ACTIONS(5277),
    [anon_sym_file] = ACTIONS(5277),
    [anon_sym_fixed] = ACTIONS(5277),
    [anon_sym_internal] = ACTIONS(5277),
    [anon_sym_new] = ACTIONS(5277),
    [anon_sym_override] = ACTIONS(5277),
    [anon_sym_partial] = ACTIONS(5277),
    [anon_sym_private] = ACTIONS(5277),
    [anon_sym_protected] = ACTIONS(5277),
    [anon_sym_public] = ACTIONS(5277),
    [anon_sym_readonly] = ACTIONS(5277),
    [anon_sym_required] = ACTIONS(5277),
    [anon_sym_sealed] = ACTIONS(5277),
    [anon_sym_virtual] = ACTIONS(5277),
    [anon_sym_volatile] = ACTIONS(5277),
    [anon_sym_where] = ACTIONS(5277),
    [anon_sym_notnull] = ACTIONS(5277),
    [anon_sym_unmanaged] = ACTIONS(5277),
    [anon_sym_scoped] = ACTIONS(5277),
    [anon_sym_var] = ACTIONS(5277),
    [sym_predefined_type] = ACTIONS(5277),
    [anon_sym_yield] = ACTIONS(5277),
    [anon_sym_when] = ACTIONS(5277),
    [anon_sym_from] = ACTIONS(5277),
    [anon_sym_into] = ACTIONS(5277),
    [anon_sym_join] = ACTIONS(5277),
    [anon_sym_on] = ACTIONS(5277),
    [anon_sym_equals] = ACTIONS(5277),
    [anon_sym_let] = ACTIONS(5277),
    [anon_sym_orderby] = ACTIONS(5277),
    [anon_sym_ascending] = ACTIONS(5277),
    [anon_sym_descending] = ACTIONS(5277),
    [anon_sym_group] = ACTIONS(5277),
    [anon_sym_by] = ACTIONS(5277),
    [anon_sym_select] = ACTIONS(5277),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4334] = {
    [sym_modifier] = STATE(4458),
    [sym_preproc_region] = STATE(4334),
    [sym_preproc_endregion] = STATE(4334),
    [sym_preproc_line] = STATE(4334),
    [sym_preproc_pragma] = STATE(4334),
    [sym_preproc_nullable] = STATE(4334),
    [sym_preproc_error] = STATE(4334),
    [sym_preproc_define] = STATE(4334),
    [sym_preproc_undef] = STATE(4334),
    [aux_sym_class_declaration_repeat2] = STATE(4334),
    [sym__identifier_token] = ACTIONS(5626),
    [anon_sym_extern] = ACTIONS(6035),
    [anon_sym_alias] = ACTIONS(5626),
    [anon_sym_global] = ACTIONS(5626),
    [anon_sym_unsafe] = ACTIONS(6035),
    [anon_sym_static] = ACTIONS(6035),
    [anon_sym_abstract] = ACTIONS(6035),
    [anon_sym_async] = ACTIONS(6035),
    [anon_sym_const] = ACTIONS(6035),
    [anon_sym_file] = ACTIONS(6035),
    [anon_sym_fixed] = ACTIONS(6035),
    [anon_sym_internal] = ACTIONS(6035),
    [anon_sym_new] = ACTIONS(6035),
    [anon_sym_override] = ACTIONS(6035),
    [anon_sym_partial] = ACTIONS(6035),
    [anon_sym_private] = ACTIONS(6035),
    [anon_sym_protected] = ACTIONS(6035),
    [anon_sym_public] = ACTIONS(6035),
    [anon_sym_readonly] = ACTIONS(6035),
    [anon_sym_required] = ACTIONS(6035),
    [anon_sym_sealed] = ACTIONS(6035),
    [anon_sym_virtual] = ACTIONS(6035),
    [anon_sym_volatile] = ACTIONS(6035),
    [anon_sym_where] = ACTIONS(5626),
    [anon_sym_notnull] = ACTIONS(5626),
    [anon_sym_unmanaged] = ACTIONS(5626),
    [anon_sym_get] = ACTIONS(5626),
    [anon_sym_set] = ACTIONS(5626),
    [anon_sym_add] = ACTIONS(5626),
    [anon_sym_remove] = ACTIONS(5626),
    [anon_sym_init] = ACTIONS(5626),
    [anon_sym_scoped] = ACTIONS(5626),
    [anon_sym_var] = ACTIONS(5626),
    [anon_sym_yield] = ACTIONS(5626),
    [anon_sym_when] = ACTIONS(5626),
    [anon_sym_from] = ACTIONS(5626),
    [anon_sym_into] = ACTIONS(5626),
    [anon_sym_join] = ACTIONS(5626),
    [anon_sym_on] = ACTIONS(5626),
    [anon_sym_equals] = ACTIONS(5626),
    [anon_sym_let] = ACTIONS(5626),
    [anon_sym_orderby] = ACTIONS(5626),
    [anon_sym_ascending] = ACTIONS(5626),
    [anon_sym_descending] = ACTIONS(5626),
    [anon_sym_group] = ACTIONS(5626),
    [anon_sym_by] = ACTIONS(5626),
    [anon_sym_select] = ACTIONS(5626),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4335] = {
    [sym_preproc_region] = STATE(4335),
    [sym_preproc_endregion] = STATE(4335),
    [sym_preproc_line] = STATE(4335),
    [sym_preproc_pragma] = STATE(4335),
    [sym_preproc_nullable] = STATE(4335),
    [sym_preproc_error] = STATE(4335),
    [sym_preproc_define] = STATE(4335),
    [sym_preproc_undef] = STATE(4335),
    [sym__identifier_token] = ACTIONS(3347),
    [anon_sym_extern] = ACTIONS(3347),
    [anon_sym_alias] = ACTIONS(3347),
    [anon_sym_global] = ACTIONS(3347),
    [anon_sym_unsafe] = ACTIONS(3347),
    [anon_sym_static] = ACTIONS(3347),
    [anon_sym_LBRACK] = ACTIONS(3349),
    [anon_sym_RBRACE] = ACTIONS(3349),
    [anon_sym_abstract] = ACTIONS(3347),
    [anon_sym_async] = ACTIONS(3347),
    [anon_sym_const] = ACTIONS(3347),
    [anon_sym_file] = ACTIONS(3347),
    [anon_sym_fixed] = ACTIONS(3347),
    [anon_sym_internal] = ACTIONS(3347),
    [anon_sym_new] = ACTIONS(3347),
    [anon_sym_override] = ACTIONS(3347),
    [anon_sym_partial] = ACTIONS(3347),
    [anon_sym_private] = ACTIONS(3347),
    [anon_sym_protected] = ACTIONS(3347),
    [anon_sym_public] = ACTIONS(3347),
    [anon_sym_readonly] = ACTIONS(3347),
    [anon_sym_required] = ACTIONS(3347),
    [anon_sym_sealed] = ACTIONS(3347),
    [anon_sym_virtual] = ACTIONS(3347),
    [anon_sym_volatile] = ACTIONS(3347),
    [anon_sym_where] = ACTIONS(3347),
    [anon_sym_notnull] = ACTIONS(3347),
    [anon_sym_unmanaged] = ACTIONS(3347),
    [anon_sym_get] = ACTIONS(3347),
    [anon_sym_set] = ACTIONS(3347),
    [anon_sym_add] = ACTIONS(3347),
    [anon_sym_remove] = ACTIONS(3347),
    [anon_sym_init] = ACTIONS(3347),
    [anon_sym_scoped] = ACTIONS(3347),
    [anon_sym_var] = ACTIONS(3347),
    [anon_sym_yield] = ACTIONS(3347),
    [anon_sym_when] = ACTIONS(3347),
    [anon_sym_from] = ACTIONS(3347),
    [anon_sym_into] = ACTIONS(3347),
    [anon_sym_join] = ACTIONS(3347),
    [anon_sym_on] = ACTIONS(3347),
    [anon_sym_equals] = ACTIONS(3347),
    [anon_sym_let] = ACTIONS(3347),
    [anon_sym_orderby] = ACTIONS(3347),
    [anon_sym_ascending] = ACTIONS(3347),
    [anon_sym_descending] = ACTIONS(3347),
    [anon_sym_group] = ACTIONS(3347),
    [anon_sym_by] = ACTIONS(3347),
    [anon_sym_select] = ACTIONS(3347),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4336] = {
    [sym_argument_list] = STATE(4571),
    [sym_bracketed_argument_list] = STATE(3551),
    [sym_preproc_region] = STATE(4336),
    [sym_preproc_endregion] = STATE(4336),
    [sym_preproc_line] = STATE(4336),
    [sym_preproc_pragma] = STATE(4336),
    [sym_preproc_nullable] = STATE(4336),
    [sym_preproc_error] = STATE(4336),
    [sym_preproc_define] = STATE(4336),
    [sym_preproc_undef] = STATE(4336),
    [anon_sym_LBRACK] = ACTIONS(6038),
    [anon_sym_COMMA] = ACTIONS(5385),
    [anon_sym_LPAREN] = ACTIONS(6008),
    [anon_sym_LT] = ACTIONS(6040),
    [anon_sym_GT] = ACTIONS(6040),
    [anon_sym_where] = ACTIONS(5385),
    [anon_sym_QMARK] = ACTIONS(6042),
    [anon_sym_BANG] = ACTIONS(6044),
    [anon_sym_PLUS_PLUS] = ACTIONS(6046),
    [anon_sym_DASH_DASH] = ACTIONS(6046),
    [anon_sym_PLUS] = ACTIONS(6048),
    [anon_sym_DASH] = ACTIONS(6048),
    [anon_sym_STAR] = ACTIONS(6050),
    [anon_sym_SLASH] = ACTIONS(6052),
    [anon_sym_PERCENT] = ACTIONS(6050),
    [anon_sym_CARET] = ACTIONS(6054),
    [anon_sym_PIPE] = ACTIONS(6056),
    [anon_sym_AMP] = ACTIONS(6058),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6062),
    [anon_sym_GT_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6064),
    [anon_sym_BANG_EQ] = ACTIONS(6064),
    [anon_sym_GT_EQ] = ACTIONS(6066),
    [anon_sym_LT_EQ] = ACTIONS(6066),
    [anon_sym_DOT] = ACTIONS(5165),
    [anon_sym_switch] = ACTIONS(6068),
    [anon_sym_DOT_DOT] = ACTIONS(6070),
    [anon_sym_and] = ACTIONS(5385),
    [anon_sym_or] = ACTIONS(5387),
    [anon_sym_AMP_AMP] = ACTIONS(6072),
    [anon_sym_PIPE_PIPE] = ACTIONS(6074),
    [anon_sym_QMARK_QMARK] = ACTIONS(6076),
    [anon_sym_from] = ACTIONS(5385),
    [anon_sym_into] = ACTIONS(5385),
    [anon_sym_join] = ACTIONS(5385),
    [anon_sym_let] = ACTIONS(5385),
    [anon_sym_orderby] = ACTIONS(5385),
    [anon_sym_ascending] = ACTIONS(5385),
    [anon_sym_descending] = ACTIONS(5385),
    [anon_sym_group] = ACTIONS(5385),
    [anon_sym_select] = ACTIONS(5385),
    [anon_sym_as] = ACTIONS(6078),
    [anon_sym_is] = ACTIONS(6080),
    [anon_sym_DASH_GT] = ACTIONS(5167),
    [anon_sym_with] = ACTIONS(6082),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4337] = {
    [sym_argument_list] = STATE(5116),
    [sym__name] = STATE(5257),
    [sym_alias_qualified_name] = STATE(5302),
    [sym__simple_name] = STATE(5302),
    [sym_qualified_name] = STATE(5302),
    [sym_generic_name] = STATE(5211),
    [sym_type] = STATE(5083),
    [sym_implicit_type] = STATE(5380),
    [sym_array_type] = STATE(5192),
    [sym__array_base_type] = STATE(8680),
    [sym_nullable_type] = STATE(5271),
    [sym_pointer_type] = STATE(5271),
    [sym__pointer_base_type] = STATE(9933),
    [sym_function_pointer_type] = STATE(5271),
    [sym_ref_type] = STATE(5380),
    [sym_scoped_type] = STATE(5380),
    [sym_tuple_type] = STATE(5293),
    [sym_identifier] = STATE(5034),
    [sym__reserved_identifier] = STATE(5144),
    [sym_preproc_region] = STATE(4337),
    [sym_preproc_endregion] = STATE(4337),
    [sym_preproc_line] = STATE(4337),
    [sym_preproc_pragma] = STATE(4337),
    [sym_preproc_nullable] = STATE(4337),
    [sym_preproc_error] = STATE(4337),
    [sym_preproc_define] = STATE(4337),
    [sym_preproc_undef] = STATE(4337),
    [sym__identifier_token] = ACTIONS(4391),
    [anon_sym_alias] = ACTIONS(4393),
    [anon_sym_global] = ACTIONS(4393),
    [anon_sym_LBRACK] = ACTIONS(6084),
    [anon_sym_LPAREN] = ACTIONS(6086),
    [anon_sym_ref] = ACTIONS(4395),
    [anon_sym_LBRACE] = ACTIONS(6088),
    [anon_sym_delegate] = ACTIONS(6090),
    [anon_sym_file] = ACTIONS(4393),
    [anon_sym_where] = ACTIONS(4393),
    [anon_sym_notnull] = ACTIONS(4393),
    [anon_sym_unmanaged] = ACTIONS(4393),
    [anon_sym_scoped] = ACTIONS(6092),
    [anon_sym_var] = ACTIONS(6094),
    [sym_predefined_type] = ACTIONS(6096),
    [anon_sym_yield] = ACTIONS(4393),
    [anon_sym_when] = ACTIONS(4393),
    [anon_sym_from] = ACTIONS(4393),
    [anon_sym_into] = ACTIONS(4393),
    [anon_sym_join] = ACTIONS(4393),
    [anon_sym_on] = ACTIONS(4393),
    [anon_sym_equals] = ACTIONS(4393),
    [anon_sym_let] = ACTIONS(4393),
    [anon_sym_orderby] = ACTIONS(4393),
    [anon_sym_ascending] = ACTIONS(4393),
    [anon_sym_descending] = ACTIONS(4393),
    [anon_sym_group] = ACTIONS(4393),
    [anon_sym_by] = ACTIONS(4393),
    [anon_sym_select] = ACTIONS(4393),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4338] = {
    [sym_argument_list] = STATE(3572),
    [sym__name] = STATE(3770),
    [sym_alias_qualified_name] = STATE(3635),
    [sym__simple_name] = STATE(3635),
    [sym_qualified_name] = STATE(3635),
    [sym_generic_name] = STATE(3708),
    [sym_type] = STATE(4788),
    [sym_implicit_type] = STATE(3706),
    [sym_array_type] = STATE(3601),
    [sym__array_base_type] = STATE(8888),
    [sym_nullable_type] = STATE(3618),
    [sym_pointer_type] = STATE(3618),
    [sym__pointer_base_type] = STATE(9386),
    [sym_function_pointer_type] = STATE(3618),
    [sym_ref_type] = STATE(3706),
    [sym_scoped_type] = STATE(3706),
    [sym_tuple_type] = STATE(3633),
    [sym_identifier] = STATE(3590),
    [sym__reserved_identifier] = STATE(3568),
    [sym_preproc_region] = STATE(4338),
    [sym_preproc_endregion] = STATE(4338),
    [sym_preproc_line] = STATE(4338),
    [sym_preproc_pragma] = STATE(4338),
    [sym_preproc_nullable] = STATE(4338),
    [sym_preproc_error] = STATE(4338),
    [sym_preproc_define] = STATE(4338),
    [sym_preproc_undef] = STATE(4338),
    [sym__identifier_token] = ACTIONS(4287),
    [anon_sym_alias] = ACTIONS(4289),
    [anon_sym_global] = ACTIONS(4289),
    [anon_sym_LBRACK] = ACTIONS(4449),
    [anon_sym_LPAREN] = ACTIONS(6098),
    [anon_sym_ref] = ACTIONS(4610),
    [anon_sym_LBRACE] = ACTIONS(4453),
    [anon_sym_delegate] = ACTIONS(4455),
    [anon_sym_file] = ACTIONS(4289),
    [anon_sym_where] = ACTIONS(4289),
    [anon_sym_notnull] = ACTIONS(4289),
    [anon_sym_unmanaged] = ACTIONS(4289),
    [anon_sym_scoped] = ACTIONS(6100),
    [anon_sym_var] = ACTIONS(4459),
    [sym_predefined_type] = ACTIONS(4461),
    [anon_sym_yield] = ACTIONS(4289),
    [anon_sym_when] = ACTIONS(4289),
    [anon_sym_from] = ACTIONS(4289),
    [anon_sym_into] = ACTIONS(4289),
    [anon_sym_join] = ACTIONS(4289),
    [anon_sym_on] = ACTIONS(4289),
    [anon_sym_equals] = ACTIONS(4289),
    [anon_sym_let] = ACTIONS(4289),
    [anon_sym_orderby] = ACTIONS(4289),
    [anon_sym_ascending] = ACTIONS(4289),
    [anon_sym_descending] = ACTIONS(4289),
    [anon_sym_group] = ACTIONS(4289),
    [anon_sym_by] = ACTIONS(4289),
    [anon_sym_select] = ACTIONS(4289),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4339] = {
    [sym_argument_list] = STATE(3572),
    [sym__name] = STATE(6086),
    [sym_alias_qualified_name] = STATE(3635),
    [sym__simple_name] = STATE(3635),
    [sym_qualified_name] = STATE(3635),
    [sym_generic_name] = STATE(3708),
    [sym_type] = STATE(4257),
    [sym_implicit_type] = STATE(3706),
    [sym_array_type] = STATE(3601),
    [sym__array_base_type] = STATE(8888),
    [sym_nullable_type] = STATE(3618),
    [sym_pointer_type] = STATE(3618),
    [sym__pointer_base_type] = STATE(9386),
    [sym_function_pointer_type] = STATE(3618),
    [sym_ref_type] = STATE(3706),
    [sym_scoped_type] = STATE(3706),
    [sym_tuple_type] = STATE(3633),
    [sym_identifier] = STATE(5332),
    [sym__reserved_identifier] = STATE(3568),
    [sym_preproc_region] = STATE(4339),
    [sym_preproc_endregion] = STATE(4339),
    [sym_preproc_line] = STATE(4339),
    [sym_preproc_pragma] = STATE(4339),
    [sym_preproc_nullable] = STATE(4339),
    [sym_preproc_error] = STATE(4339),
    [sym_preproc_define] = STATE(4339),
    [sym_preproc_undef] = STATE(4339),
    [sym__identifier_token] = ACTIONS(4287),
    [anon_sym_alias] = ACTIONS(4289),
    [anon_sym_global] = ACTIONS(4289),
    [anon_sym_LBRACK] = ACTIONS(4449),
    [anon_sym_LPAREN] = ACTIONS(4451),
    [anon_sym_ref] = ACTIONS(4444),
    [anon_sym_LBRACE] = ACTIONS(4453),
    [anon_sym_delegate] = ACTIONS(4455),
    [anon_sym_file] = ACTIONS(4289),
    [anon_sym_where] = ACTIONS(4289),
    [anon_sym_notnull] = ACTIONS(4289),
    [anon_sym_unmanaged] = ACTIONS(4289),
    [anon_sym_scoped] = ACTIONS(6102),
    [anon_sym_var] = ACTIONS(4459),
    [sym_predefined_type] = ACTIONS(4461),
    [anon_sym_yield] = ACTIONS(4289),
    [anon_sym_when] = ACTIONS(4289),
    [anon_sym_from] = ACTIONS(4289),
    [anon_sym_into] = ACTIONS(4289),
    [anon_sym_join] = ACTIONS(4289),
    [anon_sym_on] = ACTIONS(4289),
    [anon_sym_equals] = ACTIONS(4289),
    [anon_sym_let] = ACTIONS(4289),
    [anon_sym_orderby] = ACTIONS(4289),
    [anon_sym_ascending] = ACTIONS(4289),
    [anon_sym_descending] = ACTIONS(4289),
    [anon_sym_group] = ACTIONS(4289),
    [anon_sym_by] = ACTIONS(4289),
    [anon_sym_select] = ACTIONS(4289),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4340] = {
    [sym_preproc_region] = STATE(4340),
    [sym_preproc_endregion] = STATE(4340),
    [sym_preproc_line] = STATE(4340),
    [sym_preproc_pragma] = STATE(4340),
    [sym_preproc_nullable] = STATE(4340),
    [sym_preproc_error] = STATE(4340),
    [sym_preproc_define] = STATE(4340),
    [sym_preproc_undef] = STATE(4340),
    [sym__identifier_token] = ACTIONS(5633),
    [anon_sym_extern] = ACTIONS(5633),
    [anon_sym_alias] = ACTIONS(5633),
    [anon_sym_global] = ACTIONS(5633),
    [anon_sym_unsafe] = ACTIONS(5633),
    [anon_sym_static] = ACTIONS(5633),
    [anon_sym_LBRACK] = ACTIONS(5635),
    [anon_sym_abstract] = ACTIONS(5633),
    [anon_sym_async] = ACTIONS(5633),
    [anon_sym_const] = ACTIONS(5633),
    [anon_sym_file] = ACTIONS(5633),
    [anon_sym_fixed] = ACTIONS(5633),
    [anon_sym_internal] = ACTIONS(5633),
    [anon_sym_new] = ACTIONS(5633),
    [anon_sym_override] = ACTIONS(5633),
    [anon_sym_partial] = ACTIONS(5633),
    [anon_sym_private] = ACTIONS(5633),
    [anon_sym_protected] = ACTIONS(5633),
    [anon_sym_public] = ACTIONS(5633),
    [anon_sym_readonly] = ACTIONS(5633),
    [anon_sym_required] = ACTIONS(5633),
    [anon_sym_sealed] = ACTIONS(5633),
    [anon_sym_virtual] = ACTIONS(5633),
    [anon_sym_volatile] = ACTIONS(5633),
    [anon_sym_where] = ACTIONS(5633),
    [anon_sym_notnull] = ACTIONS(5633),
    [anon_sym_unmanaged] = ACTIONS(5633),
    [anon_sym_get] = ACTIONS(5633),
    [anon_sym_set] = ACTIONS(5633),
    [anon_sym_add] = ACTIONS(5633),
    [anon_sym_remove] = ACTIONS(5633),
    [anon_sym_init] = ACTIONS(5633),
    [anon_sym_scoped] = ACTIONS(5633),
    [anon_sym_var] = ACTIONS(5633),
    [anon_sym_yield] = ACTIONS(5633),
    [anon_sym_when] = ACTIONS(5633),
    [anon_sym_from] = ACTIONS(5633),
    [anon_sym_into] = ACTIONS(5633),
    [anon_sym_join] = ACTIONS(5633),
    [anon_sym_on] = ACTIONS(5633),
    [anon_sym_equals] = ACTIONS(5633),
    [anon_sym_let] = ACTIONS(5633),
    [anon_sym_orderby] = ACTIONS(5633),
    [anon_sym_ascending] = ACTIONS(5633),
    [anon_sym_descending] = ACTIONS(5633),
    [anon_sym_group] = ACTIONS(5633),
    [anon_sym_by] = ACTIONS(5633),
    [anon_sym_select] = ACTIONS(5633),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4341] = {
    [sym_block] = STATE(2669),
    [sym_preproc_region] = STATE(4341),
    [sym_preproc_endregion] = STATE(4341),
    [sym_preproc_line] = STATE(4341),
    [sym_preproc_pragma] = STATE(4341),
    [sym_preproc_nullable] = STATE(4341),
    [sym_preproc_error] = STATE(4341),
    [sym_preproc_define] = STATE(4341),
    [sym_preproc_undef] = STATE(4341),
    [sym__identifier_token] = ACTIONS(3976),
    [anon_sym_extern] = ACTIONS(3976),
    [anon_sym_alias] = ACTIONS(3976),
    [anon_sym_global] = ACTIONS(3976),
    [anon_sym_unsafe] = ACTIONS(3976),
    [anon_sym_static] = ACTIONS(3976),
    [anon_sym_LPAREN] = ACTIONS(5566),
    [anon_sym_ref] = ACTIONS(3976),
    [anon_sym_LBRACE] = ACTIONS(6104),
    [anon_sym_delegate] = ACTIONS(3976),
    [anon_sym_abstract] = ACTIONS(3976),
    [anon_sym_async] = ACTIONS(3976),
    [anon_sym_const] = ACTIONS(3976),
    [anon_sym_file] = ACTIONS(3976),
    [anon_sym_fixed] = ACTIONS(3976),
    [anon_sym_internal] = ACTIONS(3976),
    [anon_sym_new] = ACTIONS(3976),
    [anon_sym_override] = ACTIONS(3976),
    [anon_sym_partial] = ACTIONS(3976),
    [anon_sym_private] = ACTIONS(3976),
    [anon_sym_protected] = ACTIONS(3976),
    [anon_sym_public] = ACTIONS(3976),
    [anon_sym_readonly] = ACTIONS(3976),
    [anon_sym_required] = ACTIONS(3976),
    [anon_sym_sealed] = ACTIONS(3976),
    [anon_sym_virtual] = ACTIONS(3976),
    [anon_sym_volatile] = ACTIONS(3976),
    [anon_sym_where] = ACTIONS(3976),
    [anon_sym_notnull] = ACTIONS(3976),
    [anon_sym_unmanaged] = ACTIONS(3976),
    [anon_sym_scoped] = ACTIONS(3976),
    [anon_sym_var] = ACTIONS(3976),
    [sym_predefined_type] = ACTIONS(3976),
    [anon_sym_yield] = ACTIONS(3976),
    [anon_sym_when] = ACTIONS(3976),
    [anon_sym_from] = ACTIONS(3976),
    [anon_sym_into] = ACTIONS(3976),
    [anon_sym_join] = ACTIONS(3976),
    [anon_sym_on] = ACTIONS(3976),
    [anon_sym_equals] = ACTIONS(3976),
    [anon_sym_let] = ACTIONS(3976),
    [anon_sym_orderby] = ACTIONS(3976),
    [anon_sym_ascending] = ACTIONS(3976),
    [anon_sym_descending] = ACTIONS(3976),
    [anon_sym_group] = ACTIONS(3976),
    [anon_sym_by] = ACTIONS(3976),
    [anon_sym_select] = ACTIONS(3976),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4342] = {
    [sym_argument_list] = STATE(3572),
    [sym__name] = STATE(3770),
    [sym_alias_qualified_name] = STATE(3635),
    [sym__simple_name] = STATE(3635),
    [sym_qualified_name] = STATE(3635),
    [sym_generic_name] = STATE(3708),
    [sym_type] = STATE(4257),
    [sym_implicit_type] = STATE(3706),
    [sym_array_type] = STATE(3601),
    [sym__array_base_type] = STATE(8888),
    [sym_nullable_type] = STATE(3618),
    [sym_pointer_type] = STATE(3618),
    [sym__pointer_base_type] = STATE(9386),
    [sym_function_pointer_type] = STATE(3618),
    [sym_ref_type] = STATE(3706),
    [sym_scoped_type] = STATE(3706),
    [sym_tuple_type] = STATE(3633),
    [sym_identifier] = STATE(3590),
    [sym__reserved_identifier] = STATE(3568),
    [sym_preproc_region] = STATE(4342),
    [sym_preproc_endregion] = STATE(4342),
    [sym_preproc_line] = STATE(4342),
    [sym_preproc_pragma] = STATE(4342),
    [sym_preproc_nullable] = STATE(4342),
    [sym_preproc_error] = STATE(4342),
    [sym_preproc_define] = STATE(4342),
    [sym_preproc_undef] = STATE(4342),
    [sym__identifier_token] = ACTIONS(4287),
    [anon_sym_alias] = ACTIONS(4289),
    [anon_sym_global] = ACTIONS(4289),
    [anon_sym_LBRACK] = ACTIONS(4449),
    [anon_sym_LPAREN] = ACTIONS(4451),
    [anon_sym_ref] = ACTIONS(4655),
    [anon_sym_LBRACE] = ACTIONS(4453),
    [anon_sym_delegate] = ACTIONS(4455),
    [anon_sym_file] = ACTIONS(4289),
    [anon_sym_where] = ACTIONS(4289),
    [anon_sym_notnull] = ACTIONS(4289),
    [anon_sym_unmanaged] = ACTIONS(4289),
    [anon_sym_scoped] = ACTIONS(6106),
    [anon_sym_var] = ACTIONS(4459),
    [sym_predefined_type] = ACTIONS(4461),
    [anon_sym_yield] = ACTIONS(4289),
    [anon_sym_when] = ACTIONS(4289),
    [anon_sym_from] = ACTIONS(4289),
    [anon_sym_into] = ACTIONS(4289),
    [anon_sym_join] = ACTIONS(4289),
    [anon_sym_on] = ACTIONS(4289),
    [anon_sym_equals] = ACTIONS(4289),
    [anon_sym_let] = ACTIONS(4289),
    [anon_sym_orderby] = ACTIONS(4289),
    [anon_sym_ascending] = ACTIONS(4289),
    [anon_sym_descending] = ACTIONS(4289),
    [anon_sym_group] = ACTIONS(4289),
    [anon_sym_by] = ACTIONS(4289),
    [anon_sym_select] = ACTIONS(4289),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4343] = {
    [sym_preproc_region] = STATE(4343),
    [sym_preproc_endregion] = STATE(4343),
    [sym_preproc_line] = STATE(4343),
    [sym_preproc_pragma] = STATE(4343),
    [sym_preproc_nullable] = STATE(4343),
    [sym_preproc_error] = STATE(4343),
    [sym_preproc_define] = STATE(4343),
    [sym_preproc_undef] = STATE(4343),
    [anon_sym_EQ] = ACTIONS(5900),
    [anon_sym_LBRACK] = ACTIONS(5249),
    [anon_sym_COMMA] = ACTIONS(5249),
    [anon_sym_LPAREN] = ACTIONS(5249),
    [anon_sym_RPAREN] = ACTIONS(6108),
    [anon_sym_LT] = ACTIONS(5251),
    [anon_sym_GT] = ACTIONS(5251),
    [anon_sym_QMARK] = ACTIONS(5251),
    [anon_sym_BANG] = ACTIONS(5251),
    [anon_sym_PLUS_PLUS] = ACTIONS(5249),
    [anon_sym_DASH_DASH] = ACTIONS(5249),
    [anon_sym_PLUS] = ACTIONS(5251),
    [anon_sym_DASH] = ACTIONS(5251),
    [anon_sym_STAR] = ACTIONS(5251),
    [anon_sym_SLASH] = ACTIONS(5251),
    [anon_sym_PERCENT] = ACTIONS(5251),
    [anon_sym_CARET] = ACTIONS(5251),
    [anon_sym_PIPE] = ACTIONS(5251),
    [anon_sym_AMP] = ACTIONS(5251),
    [anon_sym_LT_LT] = ACTIONS(5251),
    [anon_sym_GT_GT] = ACTIONS(5251),
    [anon_sym_GT_GT_GT] = ACTIONS(5251),
    [anon_sym_EQ_EQ] = ACTIONS(5249),
    [anon_sym_BANG_EQ] = ACTIONS(5249),
    [anon_sym_GT_EQ] = ACTIONS(5249),
    [anon_sym_LT_EQ] = ACTIONS(5249),
    [anon_sym_DOT] = ACTIONS(5251),
    [anon_sym_switch] = ACTIONS(5249),
    [anon_sym_DOT_DOT] = ACTIONS(5249),
    [anon_sym_PLUS_EQ] = ACTIONS(5902),
    [anon_sym_DASH_EQ] = ACTIONS(5902),
    [anon_sym_STAR_EQ] = ACTIONS(5902),
    [anon_sym_SLASH_EQ] = ACTIONS(5902),
    [anon_sym_PERCENT_EQ] = ACTIONS(5902),
    [anon_sym_AMP_EQ] = ACTIONS(5902),
    [anon_sym_CARET_EQ] = ACTIONS(5902),
    [anon_sym_PIPE_EQ] = ACTIONS(5902),
    [anon_sym_LT_LT_EQ] = ACTIONS(5902),
    [anon_sym_GT_GT_EQ] = ACTIONS(5902),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5902),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(5902),
    [anon_sym_AMP_AMP] = ACTIONS(5249),
    [anon_sym_PIPE_PIPE] = ACTIONS(5249),
    [anon_sym_QMARK_QMARK] = ACTIONS(5251),
    [anon_sym_as] = ACTIONS(5249),
    [anon_sym_is] = ACTIONS(5249),
    [anon_sym_DASH_GT] = ACTIONS(5249),
    [anon_sym_with] = ACTIONS(5249),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4344] = {
    [sym_initializer_expression] = STATE(4516),
    [sym_preproc_region] = STATE(4344),
    [sym_preproc_endregion] = STATE(4344),
    [sym_preproc_line] = STATE(4344),
    [sym_preproc_pragma] = STATE(4344),
    [sym_preproc_nullable] = STATE(4344),
    [sym_preproc_error] = STATE(4344),
    [sym_preproc_define] = STATE(4344),
    [sym_preproc_undef] = STATE(4344),
    [anon_sym_LBRACK] = ACTIONS(5201),
    [anon_sym_COMMA] = ACTIONS(5201),
    [anon_sym_LPAREN] = ACTIONS(5201),
    [anon_sym_LBRACE] = ACTIONS(1611),
    [anon_sym_LT] = ACTIONS(5203),
    [anon_sym_GT] = ACTIONS(5203),
    [anon_sym_where] = ACTIONS(5201),
    [anon_sym_QMARK] = ACTIONS(5203),
    [anon_sym_BANG] = ACTIONS(5203),
    [anon_sym_PLUS_PLUS] = ACTIONS(5201),
    [anon_sym_DASH_DASH] = ACTIONS(5201),
    [anon_sym_PLUS] = ACTIONS(5203),
    [anon_sym_DASH] = ACTIONS(5203),
    [anon_sym_STAR] = ACTIONS(5201),
    [anon_sym_SLASH] = ACTIONS(5203),
    [anon_sym_PERCENT] = ACTIONS(5201),
    [anon_sym_CARET] = ACTIONS(5201),
    [anon_sym_PIPE] = ACTIONS(5203),
    [anon_sym_AMP] = ACTIONS(5203),
    [anon_sym_LT_LT] = ACTIONS(5201),
    [anon_sym_GT_GT] = ACTIONS(5203),
    [anon_sym_GT_GT_GT] = ACTIONS(5201),
    [anon_sym_EQ_EQ] = ACTIONS(5201),
    [anon_sym_BANG_EQ] = ACTIONS(5201),
    [anon_sym_GT_EQ] = ACTIONS(5201),
    [anon_sym_LT_EQ] = ACTIONS(5201),
    [anon_sym_DOT] = ACTIONS(5203),
    [anon_sym_switch] = ACTIONS(5201),
    [anon_sym_DOT_DOT] = ACTIONS(5201),
    [anon_sym_and] = ACTIONS(5201),
    [anon_sym_or] = ACTIONS(5203),
    [anon_sym_AMP_AMP] = ACTIONS(5201),
    [anon_sym_PIPE_PIPE] = ACTIONS(5201),
    [anon_sym_QMARK_QMARK] = ACTIONS(5201),
    [anon_sym_from] = ACTIONS(5201),
    [anon_sym_into] = ACTIONS(5201),
    [anon_sym_join] = ACTIONS(5201),
    [anon_sym_let] = ACTIONS(5201),
    [anon_sym_orderby] = ACTIONS(5201),
    [anon_sym_ascending] = ACTIONS(5201),
    [anon_sym_descending] = ACTIONS(5201),
    [anon_sym_group] = ACTIONS(5201),
    [anon_sym_select] = ACTIONS(5201),
    [anon_sym_as] = ACTIONS(5203),
    [anon_sym_is] = ACTIONS(5201),
    [anon_sym_DASH_GT] = ACTIONS(5201),
    [anon_sym_with] = ACTIONS(5201),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4345] = {
    [sym_argument_list] = STATE(4571),
    [sym_bracketed_argument_list] = STATE(3551),
    [sym_preproc_region] = STATE(4345),
    [sym_preproc_endregion] = STATE(4345),
    [sym_preproc_line] = STATE(4345),
    [sym_preproc_pragma] = STATE(4345),
    [sym_preproc_nullable] = STATE(4345),
    [sym_preproc_error] = STATE(4345),
    [sym_preproc_define] = STATE(4345),
    [sym_preproc_undef] = STATE(4345),
    [anon_sym_LBRACK] = ACTIONS(6038),
    [anon_sym_COMMA] = ACTIONS(5243),
    [anon_sym_LPAREN] = ACTIONS(6008),
    [anon_sym_LT] = ACTIONS(5245),
    [anon_sym_GT] = ACTIONS(5245),
    [anon_sym_where] = ACTIONS(5243),
    [anon_sym_QMARK] = ACTIONS(5245),
    [anon_sym_BANG] = ACTIONS(6044),
    [anon_sym_PLUS_PLUS] = ACTIONS(6046),
    [anon_sym_DASH_DASH] = ACTIONS(6046),
    [anon_sym_PLUS] = ACTIONS(5245),
    [anon_sym_DASH] = ACTIONS(5245),
    [anon_sym_STAR] = ACTIONS(5243),
    [anon_sym_SLASH] = ACTIONS(5245),
    [anon_sym_PERCENT] = ACTIONS(5243),
    [anon_sym_CARET] = ACTIONS(5243),
    [anon_sym_PIPE] = ACTIONS(5245),
    [anon_sym_AMP] = ACTIONS(5245),
    [anon_sym_LT_LT] = ACTIONS(5243),
    [anon_sym_GT_GT] = ACTIONS(5245),
    [anon_sym_GT_GT_GT] = ACTIONS(5243),
    [anon_sym_EQ_EQ] = ACTIONS(5243),
    [anon_sym_BANG_EQ] = ACTIONS(5243),
    [anon_sym_GT_EQ] = ACTIONS(5243),
    [anon_sym_LT_EQ] = ACTIONS(5243),
    [anon_sym_DOT] = ACTIONS(5165),
    [anon_sym_switch] = ACTIONS(5243),
    [anon_sym_DOT_DOT] = ACTIONS(5243),
    [anon_sym_and] = ACTIONS(5243),
    [anon_sym_or] = ACTIONS(5245),
    [anon_sym_AMP_AMP] = ACTIONS(5243),
    [anon_sym_PIPE_PIPE] = ACTIONS(5243),
    [anon_sym_QMARK_QMARK] = ACTIONS(5243),
    [anon_sym_from] = ACTIONS(5243),
    [anon_sym_into] = ACTIONS(5243),
    [anon_sym_join] = ACTIONS(5243),
    [anon_sym_let] = ACTIONS(5243),
    [anon_sym_orderby] = ACTIONS(5243),
    [anon_sym_ascending] = ACTIONS(5243),
    [anon_sym_descending] = ACTIONS(5243),
    [anon_sym_group] = ACTIONS(5243),
    [anon_sym_select] = ACTIONS(5243),
    [anon_sym_as] = ACTIONS(5245),
    [anon_sym_is] = ACTIONS(5243),
    [anon_sym_DASH_GT] = ACTIONS(5167),
    [anon_sym_with] = ACTIONS(5243),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4346] = {
    [sym_argument_list] = STATE(4571),
    [sym_bracketed_argument_list] = STATE(3551),
    [sym_preproc_region] = STATE(4346),
    [sym_preproc_endregion] = STATE(4346),
    [sym_preproc_line] = STATE(4346),
    [sym_preproc_pragma] = STATE(4346),
    [sym_preproc_nullable] = STATE(4346),
    [sym_preproc_error] = STATE(4346),
    [sym_preproc_define] = STATE(4346),
    [sym_preproc_undef] = STATE(4346),
    [anon_sym_LBRACK] = ACTIONS(6038),
    [anon_sym_COMMA] = ACTIONS(5233),
    [anon_sym_LPAREN] = ACTIONS(6008),
    [anon_sym_LT] = ACTIONS(5237),
    [anon_sym_GT] = ACTIONS(5237),
    [anon_sym_where] = ACTIONS(5233),
    [anon_sym_QMARK] = ACTIONS(5237),
    [anon_sym_BANG] = ACTIONS(6044),
    [anon_sym_PLUS_PLUS] = ACTIONS(6046),
    [anon_sym_DASH_DASH] = ACTIONS(6046),
    [anon_sym_PLUS] = ACTIONS(5237),
    [anon_sym_DASH] = ACTIONS(5237),
    [anon_sym_STAR] = ACTIONS(5233),
    [anon_sym_SLASH] = ACTIONS(5237),
    [anon_sym_PERCENT] = ACTIONS(5233),
    [anon_sym_CARET] = ACTIONS(5233),
    [anon_sym_PIPE] = ACTIONS(5237),
    [anon_sym_AMP] = ACTIONS(5237),
    [anon_sym_LT_LT] = ACTIONS(5233),
    [anon_sym_GT_GT] = ACTIONS(5237),
    [anon_sym_GT_GT_GT] = ACTIONS(5233),
    [anon_sym_EQ_EQ] = ACTIONS(5233),
    [anon_sym_BANG_EQ] = ACTIONS(5233),
    [anon_sym_GT_EQ] = ACTIONS(5233),
    [anon_sym_LT_EQ] = ACTIONS(5233),
    [anon_sym_DOT] = ACTIONS(5165),
    [anon_sym_switch] = ACTIONS(5233),
    [anon_sym_DOT_DOT] = ACTIONS(5233),
    [anon_sym_and] = ACTIONS(5233),
    [anon_sym_or] = ACTIONS(5237),
    [anon_sym_AMP_AMP] = ACTIONS(5233),
    [anon_sym_PIPE_PIPE] = ACTIONS(5233),
    [anon_sym_QMARK_QMARK] = ACTIONS(5233),
    [anon_sym_from] = ACTIONS(5233),
    [anon_sym_into] = ACTIONS(5233),
    [anon_sym_join] = ACTIONS(5233),
    [anon_sym_let] = ACTIONS(5233),
    [anon_sym_orderby] = ACTIONS(5233),
    [anon_sym_ascending] = ACTIONS(5233),
    [anon_sym_descending] = ACTIONS(5233),
    [anon_sym_group] = ACTIONS(5233),
    [anon_sym_select] = ACTIONS(5233),
    [anon_sym_as] = ACTIONS(5237),
    [anon_sym_is] = ACTIONS(5233),
    [anon_sym_DASH_GT] = ACTIONS(5167),
    [anon_sym_with] = ACTIONS(5233),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4347] = {
    [sym_initializer_expression] = STATE(4619),
    [sym_preproc_region] = STATE(4347),
    [sym_preproc_endregion] = STATE(4347),
    [sym_preproc_line] = STATE(4347),
    [sym_preproc_pragma] = STATE(4347),
    [sym_preproc_nullable] = STATE(4347),
    [sym_preproc_error] = STATE(4347),
    [sym_preproc_define] = STATE(4347),
    [sym_preproc_undef] = STATE(4347),
    [anon_sym_LBRACK] = ACTIONS(5228),
    [anon_sym_COMMA] = ACTIONS(5226),
    [anon_sym_LPAREN] = ACTIONS(5226),
    [anon_sym_LBRACE] = ACTIONS(1611),
    [anon_sym_LT] = ACTIONS(5231),
    [anon_sym_GT] = ACTIONS(5231),
    [anon_sym_where] = ACTIONS(5226),
    [anon_sym_QMARK] = ACTIONS(5231),
    [anon_sym_BANG] = ACTIONS(5231),
    [anon_sym_PLUS_PLUS] = ACTIONS(5226),
    [anon_sym_DASH_DASH] = ACTIONS(5226),
    [anon_sym_PLUS] = ACTIONS(5231),
    [anon_sym_DASH] = ACTIONS(5231),
    [anon_sym_STAR] = ACTIONS(5226),
    [anon_sym_SLASH] = ACTIONS(5231),
    [anon_sym_PERCENT] = ACTIONS(5226),
    [anon_sym_CARET] = ACTIONS(5226),
    [anon_sym_PIPE] = ACTIONS(5231),
    [anon_sym_AMP] = ACTIONS(5231),
    [anon_sym_LT_LT] = ACTIONS(5226),
    [anon_sym_GT_GT] = ACTIONS(5231),
    [anon_sym_GT_GT_GT] = ACTIONS(5226),
    [anon_sym_EQ_EQ] = ACTIONS(5226),
    [anon_sym_BANG_EQ] = ACTIONS(5226),
    [anon_sym_GT_EQ] = ACTIONS(5226),
    [anon_sym_LT_EQ] = ACTIONS(5226),
    [anon_sym_DOT] = ACTIONS(5231),
    [anon_sym_switch] = ACTIONS(5226),
    [anon_sym_DOT_DOT] = ACTIONS(5226),
    [anon_sym_and] = ACTIONS(5226),
    [anon_sym_or] = ACTIONS(5231),
    [anon_sym_AMP_AMP] = ACTIONS(5226),
    [anon_sym_PIPE_PIPE] = ACTIONS(5226),
    [anon_sym_QMARK_QMARK] = ACTIONS(5226),
    [anon_sym_from] = ACTIONS(5226),
    [anon_sym_into] = ACTIONS(5226),
    [anon_sym_join] = ACTIONS(5226),
    [anon_sym_let] = ACTIONS(5226),
    [anon_sym_orderby] = ACTIONS(5226),
    [anon_sym_ascending] = ACTIONS(5226),
    [anon_sym_descending] = ACTIONS(5226),
    [anon_sym_group] = ACTIONS(5226),
    [anon_sym_select] = ACTIONS(5226),
    [anon_sym_as] = ACTIONS(5231),
    [anon_sym_is] = ACTIONS(5226),
    [anon_sym_DASH_GT] = ACTIONS(5226),
    [anon_sym_with] = ACTIONS(5226),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4348] = {
    [sym_preproc_region] = STATE(4348),
    [sym_preproc_endregion] = STATE(4348),
    [sym_preproc_line] = STATE(4348),
    [sym_preproc_pragma] = STATE(4348),
    [sym_preproc_nullable] = STATE(4348),
    [sym_preproc_error] = STATE(4348),
    [sym_preproc_define] = STATE(4348),
    [sym_preproc_undef] = STATE(4348),
    [sym__identifier_token] = ACTIONS(5614),
    [anon_sym_extern] = ACTIONS(5614),
    [anon_sym_alias] = ACTIONS(5614),
    [anon_sym_global] = ACTIONS(5614),
    [anon_sym_unsafe] = ACTIONS(5614),
    [anon_sym_static] = ACTIONS(5614),
    [anon_sym_LBRACK] = ACTIONS(5616),
    [anon_sym_abstract] = ACTIONS(5614),
    [anon_sym_async] = ACTIONS(5614),
    [anon_sym_const] = ACTIONS(5614),
    [anon_sym_file] = ACTIONS(5614),
    [anon_sym_fixed] = ACTIONS(5614),
    [anon_sym_internal] = ACTIONS(5614),
    [anon_sym_new] = ACTIONS(5614),
    [anon_sym_override] = ACTIONS(5614),
    [anon_sym_partial] = ACTIONS(5614),
    [anon_sym_private] = ACTIONS(5614),
    [anon_sym_protected] = ACTIONS(5614),
    [anon_sym_public] = ACTIONS(5614),
    [anon_sym_readonly] = ACTIONS(5614),
    [anon_sym_required] = ACTIONS(5614),
    [anon_sym_sealed] = ACTIONS(5614),
    [anon_sym_virtual] = ACTIONS(5614),
    [anon_sym_volatile] = ACTIONS(5614),
    [anon_sym_where] = ACTIONS(5614),
    [anon_sym_notnull] = ACTIONS(5614),
    [anon_sym_unmanaged] = ACTIONS(5614),
    [anon_sym_get] = ACTIONS(5614),
    [anon_sym_set] = ACTIONS(5614),
    [anon_sym_add] = ACTIONS(5614),
    [anon_sym_remove] = ACTIONS(5614),
    [anon_sym_init] = ACTIONS(5614),
    [anon_sym_scoped] = ACTIONS(5614),
    [anon_sym_var] = ACTIONS(5614),
    [anon_sym_yield] = ACTIONS(5614),
    [anon_sym_when] = ACTIONS(5614),
    [anon_sym_from] = ACTIONS(5614),
    [anon_sym_into] = ACTIONS(5614),
    [anon_sym_join] = ACTIONS(5614),
    [anon_sym_on] = ACTIONS(5614),
    [anon_sym_equals] = ACTIONS(5614),
    [anon_sym_let] = ACTIONS(5614),
    [anon_sym_orderby] = ACTIONS(5614),
    [anon_sym_ascending] = ACTIONS(5614),
    [anon_sym_descending] = ACTIONS(5614),
    [anon_sym_group] = ACTIONS(5614),
    [anon_sym_by] = ACTIONS(5614),
    [anon_sym_select] = ACTIONS(5614),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4349] = {
    [sym_preproc_region] = STATE(4349),
    [sym_preproc_endregion] = STATE(4349),
    [sym_preproc_line] = STATE(4349),
    [sym_preproc_pragma] = STATE(4349),
    [sym_preproc_nullable] = STATE(4349),
    [sym_preproc_error] = STATE(4349),
    [sym_preproc_define] = STATE(4349),
    [sym_preproc_undef] = STATE(4349),
    [sym__identifier_token] = ACTIONS(5622),
    [anon_sym_extern] = ACTIONS(5622),
    [anon_sym_alias] = ACTIONS(5622),
    [anon_sym_global] = ACTIONS(5622),
    [anon_sym_unsafe] = ACTIONS(5622),
    [anon_sym_static] = ACTIONS(5622),
    [anon_sym_LBRACK] = ACTIONS(5624),
    [anon_sym_abstract] = ACTIONS(5622),
    [anon_sym_async] = ACTIONS(5622),
    [anon_sym_const] = ACTIONS(5622),
    [anon_sym_file] = ACTIONS(5622),
    [anon_sym_fixed] = ACTIONS(5622),
    [anon_sym_internal] = ACTIONS(5622),
    [anon_sym_new] = ACTIONS(5622),
    [anon_sym_override] = ACTIONS(5622),
    [anon_sym_partial] = ACTIONS(5622),
    [anon_sym_private] = ACTIONS(5622),
    [anon_sym_protected] = ACTIONS(5622),
    [anon_sym_public] = ACTIONS(5622),
    [anon_sym_readonly] = ACTIONS(5622),
    [anon_sym_required] = ACTIONS(5622),
    [anon_sym_sealed] = ACTIONS(5622),
    [anon_sym_virtual] = ACTIONS(5622),
    [anon_sym_volatile] = ACTIONS(5622),
    [anon_sym_where] = ACTIONS(5622),
    [anon_sym_notnull] = ACTIONS(5622),
    [anon_sym_unmanaged] = ACTIONS(5622),
    [anon_sym_get] = ACTIONS(5622),
    [anon_sym_set] = ACTIONS(5622),
    [anon_sym_add] = ACTIONS(5622),
    [anon_sym_remove] = ACTIONS(5622),
    [anon_sym_init] = ACTIONS(5622),
    [anon_sym_scoped] = ACTIONS(5622),
    [anon_sym_var] = ACTIONS(5622),
    [anon_sym_yield] = ACTIONS(5622),
    [anon_sym_when] = ACTIONS(5622),
    [anon_sym_from] = ACTIONS(5622),
    [anon_sym_into] = ACTIONS(5622),
    [anon_sym_join] = ACTIONS(5622),
    [anon_sym_on] = ACTIONS(5622),
    [anon_sym_equals] = ACTIONS(5622),
    [anon_sym_let] = ACTIONS(5622),
    [anon_sym_orderby] = ACTIONS(5622),
    [anon_sym_ascending] = ACTIONS(5622),
    [anon_sym_descending] = ACTIONS(5622),
    [anon_sym_group] = ACTIONS(5622),
    [anon_sym_by] = ACTIONS(5622),
    [anon_sym_select] = ACTIONS(5622),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4350] = {
    [sym_initializer_expression] = STATE(4678),
    [sym_preproc_region] = STATE(4350),
    [sym_preproc_endregion] = STATE(4350),
    [sym_preproc_line] = STATE(4350),
    [sym_preproc_pragma] = STATE(4350),
    [sym_preproc_nullable] = STATE(4350),
    [sym_preproc_error] = STATE(4350),
    [sym_preproc_define] = STATE(4350),
    [sym_preproc_undef] = STATE(4350),
    [anon_sym_LBRACK] = ACTIONS(5205),
    [anon_sym_COMMA] = ACTIONS(5205),
    [anon_sym_LPAREN] = ACTIONS(5205),
    [anon_sym_LBRACE] = ACTIONS(1611),
    [anon_sym_LT] = ACTIONS(5207),
    [anon_sym_GT] = ACTIONS(5207),
    [anon_sym_where] = ACTIONS(5205),
    [anon_sym_QMARK] = ACTIONS(5207),
    [anon_sym_BANG] = ACTIONS(5207),
    [anon_sym_PLUS_PLUS] = ACTIONS(5205),
    [anon_sym_DASH_DASH] = ACTIONS(5205),
    [anon_sym_PLUS] = ACTIONS(5207),
    [anon_sym_DASH] = ACTIONS(5207),
    [anon_sym_STAR] = ACTIONS(5205),
    [anon_sym_SLASH] = ACTIONS(5207),
    [anon_sym_PERCENT] = ACTIONS(5205),
    [anon_sym_CARET] = ACTIONS(5205),
    [anon_sym_PIPE] = ACTIONS(5207),
    [anon_sym_AMP] = ACTIONS(5207),
    [anon_sym_LT_LT] = ACTIONS(5205),
    [anon_sym_GT_GT] = ACTIONS(5207),
    [anon_sym_GT_GT_GT] = ACTIONS(5205),
    [anon_sym_EQ_EQ] = ACTIONS(5205),
    [anon_sym_BANG_EQ] = ACTIONS(5205),
    [anon_sym_GT_EQ] = ACTIONS(5205),
    [anon_sym_LT_EQ] = ACTIONS(5205),
    [anon_sym_DOT] = ACTIONS(5207),
    [anon_sym_switch] = ACTIONS(5205),
    [anon_sym_DOT_DOT] = ACTIONS(5205),
    [anon_sym_and] = ACTIONS(5205),
    [anon_sym_or] = ACTIONS(5207),
    [anon_sym_AMP_AMP] = ACTIONS(5205),
    [anon_sym_PIPE_PIPE] = ACTIONS(5205),
    [anon_sym_QMARK_QMARK] = ACTIONS(5205),
    [anon_sym_from] = ACTIONS(5205),
    [anon_sym_into] = ACTIONS(5205),
    [anon_sym_join] = ACTIONS(5205),
    [anon_sym_let] = ACTIONS(5205),
    [anon_sym_orderby] = ACTIONS(5205),
    [anon_sym_ascending] = ACTIONS(5205),
    [anon_sym_descending] = ACTIONS(5205),
    [anon_sym_group] = ACTIONS(5205),
    [anon_sym_select] = ACTIONS(5205),
    [anon_sym_as] = ACTIONS(5207),
    [anon_sym_is] = ACTIONS(5205),
    [anon_sym_DASH_GT] = ACTIONS(5205),
    [anon_sym_with] = ACTIONS(5205),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4351] = {
    [sym_argument_list] = STATE(3572),
    [sym__name] = STATE(3770),
    [sym_alias_qualified_name] = STATE(3635),
    [sym__simple_name] = STATE(3635),
    [sym_qualified_name] = STATE(3635),
    [sym_generic_name] = STATE(3708),
    [sym_type] = STATE(4257),
    [sym_implicit_type] = STATE(3706),
    [sym_array_type] = STATE(5137),
    [sym__array_base_type] = STATE(8888),
    [sym_nullable_type] = STATE(3618),
    [sym_pointer_type] = STATE(3618),
    [sym__pointer_base_type] = STATE(9386),
    [sym_function_pointer_type] = STATE(3618),
    [sym_ref_type] = STATE(3706),
    [sym_scoped_type] = STATE(3706),
    [sym_tuple_type] = STATE(3633),
    [sym_identifier] = STATE(3590),
    [sym__reserved_identifier] = STATE(3568),
    [sym_preproc_region] = STATE(4351),
    [sym_preproc_endregion] = STATE(4351),
    [sym_preproc_line] = STATE(4351),
    [sym_preproc_pragma] = STATE(4351),
    [sym_preproc_nullable] = STATE(4351),
    [sym_preproc_error] = STATE(4351),
    [sym_preproc_define] = STATE(4351),
    [sym_preproc_undef] = STATE(4351),
    [sym__identifier_token] = ACTIONS(4287),
    [anon_sym_alias] = ACTIONS(4289),
    [anon_sym_global] = ACTIONS(4289),
    [anon_sym_LBRACK] = ACTIONS(4449),
    [anon_sym_LPAREN] = ACTIONS(4451),
    [anon_sym_ref] = ACTIONS(4291),
    [anon_sym_LBRACE] = ACTIONS(4453),
    [anon_sym_delegate] = ACTIONS(4455),
    [anon_sym_file] = ACTIONS(4289),
    [anon_sym_where] = ACTIONS(4289),
    [anon_sym_notnull] = ACTIONS(4289),
    [anon_sym_unmanaged] = ACTIONS(4289),
    [anon_sym_scoped] = ACTIONS(4457),
    [anon_sym_var] = ACTIONS(4459),
    [sym_predefined_type] = ACTIONS(4461),
    [anon_sym_yield] = ACTIONS(4289),
    [anon_sym_when] = ACTIONS(4289),
    [anon_sym_from] = ACTIONS(4289),
    [anon_sym_into] = ACTIONS(4289),
    [anon_sym_join] = ACTIONS(4289),
    [anon_sym_on] = ACTIONS(4289),
    [anon_sym_equals] = ACTIONS(4289),
    [anon_sym_let] = ACTIONS(4289),
    [anon_sym_orderby] = ACTIONS(4289),
    [anon_sym_ascending] = ACTIONS(4289),
    [anon_sym_descending] = ACTIONS(4289),
    [anon_sym_group] = ACTIONS(4289),
    [anon_sym_by] = ACTIONS(4289),
    [anon_sym_select] = ACTIONS(4289),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4352] = {
    [sym__name] = STATE(7762),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(8530),
    [sym_implicit_type] = STATE(8704),
    [sym_array_type] = STATE(8215),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9650),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(8704),
    [sym_scoped_type] = STATE(8704),
    [sym_tuple_type] = STATE(8180),
    [sym_identifier] = STATE(4921),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4352),
    [sym_preproc_endregion] = STATE(4352),
    [sym_preproc_line] = STATE(4352),
    [sym_preproc_pragma] = STATE(4352),
    [sym_preproc_nullable] = STATE(4352),
    [sym_preproc_error] = STATE(4352),
    [sym_preproc_define] = STATE(4352),
    [sym_preproc_undef] = STATE(4352),
    [aux_sym_type_argument_list_repeat1] = STATE(8548),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_COMMA] = ACTIONS(5655),
    [anon_sym_LPAREN] = ACTIONS(2995),
    [anon_sym_ref] = ACTIONS(5657),
    [anon_sym_delegate] = ACTIONS(5659),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_GT] = ACTIONS(6110),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(5665),
    [anon_sym_var] = ACTIONS(5284),
    [sym_predefined_type] = ACTIONS(5667),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4353] = {
    [sym__name] = STATE(7762),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(8519),
    [sym_implicit_type] = STATE(8704),
    [sym_array_type] = STATE(8215),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9650),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(8704),
    [sym_scoped_type] = STATE(8704),
    [sym_tuple_type] = STATE(8180),
    [sym_identifier] = STATE(4921),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4353),
    [sym_preproc_endregion] = STATE(4353),
    [sym_preproc_line] = STATE(4353),
    [sym_preproc_pragma] = STATE(4353),
    [sym_preproc_nullable] = STATE(4353),
    [sym_preproc_error] = STATE(4353),
    [sym_preproc_define] = STATE(4353),
    [sym_preproc_undef] = STATE(4353),
    [aux_sym_type_argument_list_repeat1] = STATE(8414),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_COMMA] = ACTIONS(5655),
    [anon_sym_LPAREN] = ACTIONS(2995),
    [anon_sym_ref] = ACTIONS(5657),
    [anon_sym_delegate] = ACTIONS(5659),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_GT] = ACTIONS(6112),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(5665),
    [anon_sym_var] = ACTIONS(5284),
    [sym_predefined_type] = ACTIONS(5667),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4354] = {
    [sym_argument_list] = STATE(4571),
    [sym_bracketed_argument_list] = STATE(3551),
    [sym_preproc_region] = STATE(4354),
    [sym_preproc_endregion] = STATE(4354),
    [sym_preproc_line] = STATE(4354),
    [sym_preproc_pragma] = STATE(4354),
    [sym_preproc_nullable] = STATE(4354),
    [sym_preproc_error] = STATE(4354),
    [sym_preproc_define] = STATE(4354),
    [sym_preproc_undef] = STATE(4354),
    [anon_sym_LBRACK] = ACTIONS(6038),
    [anon_sym_COMMA] = ACTIONS(6114),
    [anon_sym_LPAREN] = ACTIONS(6008),
    [anon_sym_LT] = ACTIONS(6116),
    [anon_sym_GT] = ACTIONS(6116),
    [anon_sym_where] = ACTIONS(6114),
    [anon_sym_QMARK] = ACTIONS(6116),
    [anon_sym_BANG] = ACTIONS(6044),
    [anon_sym_PLUS_PLUS] = ACTIONS(6046),
    [anon_sym_DASH_DASH] = ACTIONS(6046),
    [anon_sym_PLUS] = ACTIONS(6048),
    [anon_sym_DASH] = ACTIONS(6048),
    [anon_sym_STAR] = ACTIONS(6050),
    [anon_sym_SLASH] = ACTIONS(6052),
    [anon_sym_PERCENT] = ACTIONS(6050),
    [anon_sym_CARET] = ACTIONS(6114),
    [anon_sym_PIPE] = ACTIONS(6116),
    [anon_sym_AMP] = ACTIONS(6116),
    [anon_sym_LT_LT] = ACTIONS(6114),
    [anon_sym_GT_GT] = ACTIONS(6116),
    [anon_sym_GT_GT_GT] = ACTIONS(6114),
    [anon_sym_EQ_EQ] = ACTIONS(6114),
    [anon_sym_BANG_EQ] = ACTIONS(6114),
    [anon_sym_GT_EQ] = ACTIONS(6114),
    [anon_sym_LT_EQ] = ACTIONS(6114),
    [anon_sym_DOT] = ACTIONS(5165),
    [anon_sym_switch] = ACTIONS(6068),
    [anon_sym_DOT_DOT] = ACTIONS(6070),
    [anon_sym_and] = ACTIONS(6114),
    [anon_sym_or] = ACTIONS(6116),
    [anon_sym_AMP_AMP] = ACTIONS(6114),
    [anon_sym_PIPE_PIPE] = ACTIONS(6114),
    [anon_sym_QMARK_QMARK] = ACTIONS(6114),
    [anon_sym_from] = ACTIONS(6114),
    [anon_sym_into] = ACTIONS(6114),
    [anon_sym_join] = ACTIONS(6114),
    [anon_sym_let] = ACTIONS(6114),
    [anon_sym_orderby] = ACTIONS(6114),
    [anon_sym_ascending] = ACTIONS(6114),
    [anon_sym_descending] = ACTIONS(6114),
    [anon_sym_group] = ACTIONS(6114),
    [anon_sym_select] = ACTIONS(6114),
    [anon_sym_as] = ACTIONS(6116),
    [anon_sym_is] = ACTIONS(6114),
    [anon_sym_DASH_GT] = ACTIONS(5167),
    [anon_sym_with] = ACTIONS(6082),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4355] = {
    [sym_preproc_region] = STATE(4355),
    [sym_preproc_endregion] = STATE(4355),
    [sym_preproc_line] = STATE(4355),
    [sym_preproc_pragma] = STATE(4355),
    [sym_preproc_nullable] = STATE(4355),
    [sym_preproc_error] = STATE(4355),
    [sym_preproc_define] = STATE(4355),
    [sym_preproc_undef] = STATE(4355),
    [anon_sym_EQ] = ACTIONS(5900),
    [anon_sym_LBRACK] = ACTIONS(5249),
    [anon_sym_COMMA] = ACTIONS(5249),
    [anon_sym_LPAREN] = ACTIONS(5249),
    [anon_sym_RPAREN] = ACTIONS(6118),
    [anon_sym_LT] = ACTIONS(5251),
    [anon_sym_GT] = ACTIONS(5251),
    [anon_sym_QMARK] = ACTIONS(5251),
    [anon_sym_BANG] = ACTIONS(5251),
    [anon_sym_PLUS_PLUS] = ACTIONS(5249),
    [anon_sym_DASH_DASH] = ACTIONS(5249),
    [anon_sym_PLUS] = ACTIONS(5251),
    [anon_sym_DASH] = ACTIONS(5251),
    [anon_sym_STAR] = ACTIONS(5251),
    [anon_sym_SLASH] = ACTIONS(5251),
    [anon_sym_PERCENT] = ACTIONS(5251),
    [anon_sym_CARET] = ACTIONS(5251),
    [anon_sym_PIPE] = ACTIONS(5251),
    [anon_sym_AMP] = ACTIONS(5251),
    [anon_sym_LT_LT] = ACTIONS(5251),
    [anon_sym_GT_GT] = ACTIONS(5251),
    [anon_sym_GT_GT_GT] = ACTIONS(5251),
    [anon_sym_EQ_EQ] = ACTIONS(5249),
    [anon_sym_BANG_EQ] = ACTIONS(5249),
    [anon_sym_GT_EQ] = ACTIONS(5249),
    [anon_sym_LT_EQ] = ACTIONS(5249),
    [anon_sym_DOT] = ACTIONS(5251),
    [anon_sym_switch] = ACTIONS(5249),
    [anon_sym_DOT_DOT] = ACTIONS(5249),
    [anon_sym_PLUS_EQ] = ACTIONS(5902),
    [anon_sym_DASH_EQ] = ACTIONS(5902),
    [anon_sym_STAR_EQ] = ACTIONS(5902),
    [anon_sym_SLASH_EQ] = ACTIONS(5902),
    [anon_sym_PERCENT_EQ] = ACTIONS(5902),
    [anon_sym_AMP_EQ] = ACTIONS(5902),
    [anon_sym_CARET_EQ] = ACTIONS(5902),
    [anon_sym_PIPE_EQ] = ACTIONS(5902),
    [anon_sym_LT_LT_EQ] = ACTIONS(5902),
    [anon_sym_GT_GT_EQ] = ACTIONS(5902),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5902),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(5902),
    [anon_sym_AMP_AMP] = ACTIONS(5249),
    [anon_sym_PIPE_PIPE] = ACTIONS(5249),
    [anon_sym_QMARK_QMARK] = ACTIONS(5251),
    [anon_sym_as] = ACTIONS(5249),
    [anon_sym_is] = ACTIONS(5249),
    [anon_sym_DASH_GT] = ACTIONS(5249),
    [anon_sym_with] = ACTIONS(5249),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4356] = {
    [sym_argument_list] = STATE(4571),
    [sym_bracketed_argument_list] = STATE(3551),
    [sym_preproc_region] = STATE(4356),
    [sym_preproc_endregion] = STATE(4356),
    [sym_preproc_line] = STATE(4356),
    [sym_preproc_pragma] = STATE(4356),
    [sym_preproc_nullable] = STATE(4356),
    [sym_preproc_error] = STATE(4356),
    [sym_preproc_define] = STATE(4356),
    [sym_preproc_undef] = STATE(4356),
    [anon_sym_LBRACK] = ACTIONS(6038),
    [anon_sym_COMMA] = ACTIONS(6114),
    [anon_sym_LPAREN] = ACTIONS(6008),
    [anon_sym_LT] = ACTIONS(6116),
    [anon_sym_GT] = ACTIONS(6116),
    [anon_sym_where] = ACTIONS(6114),
    [anon_sym_QMARK] = ACTIONS(6116),
    [anon_sym_BANG] = ACTIONS(6044),
    [anon_sym_PLUS_PLUS] = ACTIONS(6046),
    [anon_sym_DASH_DASH] = ACTIONS(6046),
    [anon_sym_PLUS] = ACTIONS(6116),
    [anon_sym_DASH] = ACTIONS(6116),
    [anon_sym_STAR] = ACTIONS(6114),
    [anon_sym_SLASH] = ACTIONS(6116),
    [anon_sym_PERCENT] = ACTIONS(6114),
    [anon_sym_CARET] = ACTIONS(6114),
    [anon_sym_PIPE] = ACTIONS(6116),
    [anon_sym_AMP] = ACTIONS(6116),
    [anon_sym_LT_LT] = ACTIONS(6114),
    [anon_sym_GT_GT] = ACTIONS(6116),
    [anon_sym_GT_GT_GT] = ACTIONS(6114),
    [anon_sym_EQ_EQ] = ACTIONS(6114),
    [anon_sym_BANG_EQ] = ACTIONS(6114),
    [anon_sym_GT_EQ] = ACTIONS(6114),
    [anon_sym_LT_EQ] = ACTIONS(6114),
    [anon_sym_DOT] = ACTIONS(5165),
    [anon_sym_switch] = ACTIONS(6068),
    [anon_sym_DOT_DOT] = ACTIONS(6070),
    [anon_sym_and] = ACTIONS(6114),
    [anon_sym_or] = ACTIONS(6116),
    [anon_sym_AMP_AMP] = ACTIONS(6114),
    [anon_sym_PIPE_PIPE] = ACTIONS(6114),
    [anon_sym_QMARK_QMARK] = ACTIONS(6114),
    [anon_sym_from] = ACTIONS(6114),
    [anon_sym_into] = ACTIONS(6114),
    [anon_sym_join] = ACTIONS(6114),
    [anon_sym_let] = ACTIONS(6114),
    [anon_sym_orderby] = ACTIONS(6114),
    [anon_sym_ascending] = ACTIONS(6114),
    [anon_sym_descending] = ACTIONS(6114),
    [anon_sym_group] = ACTIONS(6114),
    [anon_sym_select] = ACTIONS(6114),
    [anon_sym_as] = ACTIONS(6116),
    [anon_sym_is] = ACTIONS(6114),
    [anon_sym_DASH_GT] = ACTIONS(5167),
    [anon_sym_with] = ACTIONS(6082),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4357] = {
    [sym_argument_list] = STATE(4571),
    [sym_bracketed_argument_list] = STATE(3551),
    [sym_preproc_region] = STATE(4357),
    [sym_preproc_endregion] = STATE(4357),
    [sym_preproc_line] = STATE(4357),
    [sym_preproc_pragma] = STATE(4357),
    [sym_preproc_nullable] = STATE(4357),
    [sym_preproc_error] = STATE(4357),
    [sym_preproc_define] = STATE(4357),
    [sym_preproc_undef] = STATE(4357),
    [anon_sym_LBRACK] = ACTIONS(6038),
    [anon_sym_COMMA] = ACTIONS(6114),
    [anon_sym_LPAREN] = ACTIONS(6008),
    [anon_sym_LT] = ACTIONS(6116),
    [anon_sym_GT] = ACTIONS(6116),
    [anon_sym_where] = ACTIONS(6114),
    [anon_sym_QMARK] = ACTIONS(6116),
    [anon_sym_BANG] = ACTIONS(6044),
    [anon_sym_PLUS_PLUS] = ACTIONS(6046),
    [anon_sym_DASH_DASH] = ACTIONS(6046),
    [anon_sym_PLUS] = ACTIONS(6116),
    [anon_sym_DASH] = ACTIONS(6116),
    [anon_sym_STAR] = ACTIONS(6050),
    [anon_sym_SLASH] = ACTIONS(6052),
    [anon_sym_PERCENT] = ACTIONS(6050),
    [anon_sym_CARET] = ACTIONS(6114),
    [anon_sym_PIPE] = ACTIONS(6116),
    [anon_sym_AMP] = ACTIONS(6116),
    [anon_sym_LT_LT] = ACTIONS(6114),
    [anon_sym_GT_GT] = ACTIONS(6116),
    [anon_sym_GT_GT_GT] = ACTIONS(6114),
    [anon_sym_EQ_EQ] = ACTIONS(6114),
    [anon_sym_BANG_EQ] = ACTIONS(6114),
    [anon_sym_GT_EQ] = ACTIONS(6114),
    [anon_sym_LT_EQ] = ACTIONS(6114),
    [anon_sym_DOT] = ACTIONS(5165),
    [anon_sym_switch] = ACTIONS(6068),
    [anon_sym_DOT_DOT] = ACTIONS(6070),
    [anon_sym_and] = ACTIONS(6114),
    [anon_sym_or] = ACTIONS(6116),
    [anon_sym_AMP_AMP] = ACTIONS(6114),
    [anon_sym_PIPE_PIPE] = ACTIONS(6114),
    [anon_sym_QMARK_QMARK] = ACTIONS(6114),
    [anon_sym_from] = ACTIONS(6114),
    [anon_sym_into] = ACTIONS(6114),
    [anon_sym_join] = ACTIONS(6114),
    [anon_sym_let] = ACTIONS(6114),
    [anon_sym_orderby] = ACTIONS(6114),
    [anon_sym_ascending] = ACTIONS(6114),
    [anon_sym_descending] = ACTIONS(6114),
    [anon_sym_group] = ACTIONS(6114),
    [anon_sym_select] = ACTIONS(6114),
    [anon_sym_as] = ACTIONS(6116),
    [anon_sym_is] = ACTIONS(6114),
    [anon_sym_DASH_GT] = ACTIONS(5167),
    [anon_sym_with] = ACTIONS(6082),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4358] = {
    [sym_argument_list] = STATE(4571),
    [sym_bracketed_argument_list] = STATE(3551),
    [sym_preproc_region] = STATE(4358),
    [sym_preproc_endregion] = STATE(4358),
    [sym_preproc_line] = STATE(4358),
    [sym_preproc_pragma] = STATE(4358),
    [sym_preproc_nullable] = STATE(4358),
    [sym_preproc_error] = STATE(4358),
    [sym_preproc_define] = STATE(4358),
    [sym_preproc_undef] = STATE(4358),
    [anon_sym_LBRACK] = ACTIONS(6038),
    [anon_sym_COMMA] = ACTIONS(6114),
    [anon_sym_LPAREN] = ACTIONS(6008),
    [anon_sym_LT] = ACTIONS(6116),
    [anon_sym_GT] = ACTIONS(6116),
    [anon_sym_where] = ACTIONS(6114),
    [anon_sym_QMARK] = ACTIONS(6116),
    [anon_sym_BANG] = ACTIONS(6044),
    [anon_sym_PLUS_PLUS] = ACTIONS(6046),
    [anon_sym_DASH_DASH] = ACTIONS(6046),
    [anon_sym_PLUS] = ACTIONS(6048),
    [anon_sym_DASH] = ACTIONS(6048),
    [anon_sym_STAR] = ACTIONS(6050),
    [anon_sym_SLASH] = ACTIONS(6052),
    [anon_sym_PERCENT] = ACTIONS(6050),
    [anon_sym_CARET] = ACTIONS(6114),
    [anon_sym_PIPE] = ACTIONS(6116),
    [anon_sym_AMP] = ACTIONS(6116),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6062),
    [anon_sym_GT_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6114),
    [anon_sym_BANG_EQ] = ACTIONS(6114),
    [anon_sym_GT_EQ] = ACTIONS(6114),
    [anon_sym_LT_EQ] = ACTIONS(6114),
    [anon_sym_DOT] = ACTIONS(5165),
    [anon_sym_switch] = ACTIONS(6068),
    [anon_sym_DOT_DOT] = ACTIONS(6070),
    [anon_sym_and] = ACTIONS(6114),
    [anon_sym_or] = ACTIONS(6116),
    [anon_sym_AMP_AMP] = ACTIONS(6114),
    [anon_sym_PIPE_PIPE] = ACTIONS(6114),
    [anon_sym_QMARK_QMARK] = ACTIONS(6114),
    [anon_sym_from] = ACTIONS(6114),
    [anon_sym_into] = ACTIONS(6114),
    [anon_sym_join] = ACTIONS(6114),
    [anon_sym_let] = ACTIONS(6114),
    [anon_sym_orderby] = ACTIONS(6114),
    [anon_sym_ascending] = ACTIONS(6114),
    [anon_sym_descending] = ACTIONS(6114),
    [anon_sym_group] = ACTIONS(6114),
    [anon_sym_select] = ACTIONS(6114),
    [anon_sym_as] = ACTIONS(6116),
    [anon_sym_is] = ACTIONS(6114),
    [anon_sym_DASH_GT] = ACTIONS(5167),
    [anon_sym_with] = ACTIONS(6082),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4359] = {
    [sym_argument_list] = STATE(4571),
    [sym_bracketed_argument_list] = STATE(3551),
    [sym_preproc_region] = STATE(4359),
    [sym_preproc_endregion] = STATE(4359),
    [sym_preproc_line] = STATE(4359),
    [sym_preproc_pragma] = STATE(4359),
    [sym_preproc_nullable] = STATE(4359),
    [sym_preproc_error] = STATE(4359),
    [sym_preproc_define] = STATE(4359),
    [sym_preproc_undef] = STATE(4359),
    [anon_sym_LBRACK] = ACTIONS(6038),
    [anon_sym_COMMA] = ACTIONS(6120),
    [anon_sym_LPAREN] = ACTIONS(6008),
    [anon_sym_LT] = ACTIONS(6122),
    [anon_sym_GT] = ACTIONS(6122),
    [anon_sym_where] = ACTIONS(6120),
    [anon_sym_QMARK] = ACTIONS(6122),
    [anon_sym_BANG] = ACTIONS(6044),
    [anon_sym_PLUS_PLUS] = ACTIONS(6046),
    [anon_sym_DASH_DASH] = ACTIONS(6046),
    [anon_sym_PLUS] = ACTIONS(6122),
    [anon_sym_DASH] = ACTIONS(6122),
    [anon_sym_STAR] = ACTIONS(6120),
    [anon_sym_SLASH] = ACTIONS(6122),
    [anon_sym_PERCENT] = ACTIONS(6120),
    [anon_sym_CARET] = ACTIONS(6120),
    [anon_sym_PIPE] = ACTIONS(6122),
    [anon_sym_AMP] = ACTIONS(6122),
    [anon_sym_LT_LT] = ACTIONS(6120),
    [anon_sym_GT_GT] = ACTIONS(6122),
    [anon_sym_GT_GT_GT] = ACTIONS(6120),
    [anon_sym_EQ_EQ] = ACTIONS(6120),
    [anon_sym_BANG_EQ] = ACTIONS(6120),
    [anon_sym_GT_EQ] = ACTIONS(6120),
    [anon_sym_LT_EQ] = ACTIONS(6120),
    [anon_sym_DOT] = ACTIONS(5165),
    [anon_sym_switch] = ACTIONS(6120),
    [anon_sym_DOT_DOT] = ACTIONS(6070),
    [anon_sym_and] = ACTIONS(6120),
    [anon_sym_or] = ACTIONS(6122),
    [anon_sym_AMP_AMP] = ACTIONS(6120),
    [anon_sym_PIPE_PIPE] = ACTIONS(6120),
    [anon_sym_QMARK_QMARK] = ACTIONS(6120),
    [anon_sym_from] = ACTIONS(6120),
    [anon_sym_into] = ACTIONS(6120),
    [anon_sym_join] = ACTIONS(6120),
    [anon_sym_let] = ACTIONS(6120),
    [anon_sym_orderby] = ACTIONS(6120),
    [anon_sym_ascending] = ACTIONS(6120),
    [anon_sym_descending] = ACTIONS(6120),
    [anon_sym_group] = ACTIONS(6120),
    [anon_sym_select] = ACTIONS(6120),
    [anon_sym_as] = ACTIONS(6122),
    [anon_sym_is] = ACTIONS(6120),
    [anon_sym_DASH_GT] = ACTIONS(5167),
    [anon_sym_with] = ACTIONS(6120),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4360] = {
    [sym_modifier] = STATE(4545),
    [sym_preproc_region] = STATE(4360),
    [sym_preproc_endregion] = STATE(4360),
    [sym_preproc_line] = STATE(4360),
    [sym_preproc_pragma] = STATE(4360),
    [sym_preproc_nullable] = STATE(4360),
    [sym_preproc_error] = STATE(4360),
    [sym_preproc_define] = STATE(4360),
    [sym_preproc_undef] = STATE(4360),
    [aux_sym_class_declaration_repeat2] = STATE(4360),
    [sym__identifier_token] = ACTIONS(5626),
    [anon_sym_extern] = ACTIONS(6124),
    [anon_sym_alias] = ACTIONS(5626),
    [anon_sym_global] = ACTIONS(5626),
    [anon_sym_unsafe] = ACTIONS(6124),
    [anon_sym_static] = ACTIONS(6124),
    [anon_sym_LPAREN] = ACTIONS(5631),
    [anon_sym_ref] = ACTIONS(5626),
    [anon_sym_delegate] = ACTIONS(5626),
    [anon_sym_abstract] = ACTIONS(6124),
    [anon_sym_async] = ACTIONS(6124),
    [anon_sym_const] = ACTIONS(6124),
    [anon_sym_file] = ACTIONS(6124),
    [anon_sym_fixed] = ACTIONS(6124),
    [anon_sym_internal] = ACTIONS(6124),
    [anon_sym_new] = ACTIONS(6124),
    [anon_sym_override] = ACTIONS(6124),
    [anon_sym_partial] = ACTIONS(6124),
    [anon_sym_private] = ACTIONS(6124),
    [anon_sym_protected] = ACTIONS(6124),
    [anon_sym_public] = ACTIONS(6124),
    [anon_sym_readonly] = ACTIONS(6124),
    [anon_sym_required] = ACTIONS(6124),
    [anon_sym_sealed] = ACTIONS(6124),
    [anon_sym_virtual] = ACTIONS(6124),
    [anon_sym_volatile] = ACTIONS(6124),
    [anon_sym_where] = ACTIONS(5626),
    [anon_sym_notnull] = ACTIONS(5626),
    [anon_sym_unmanaged] = ACTIONS(5626),
    [anon_sym_scoped] = ACTIONS(5626),
    [anon_sym_var] = ACTIONS(5626),
    [sym_predefined_type] = ACTIONS(5626),
    [anon_sym_yield] = ACTIONS(5626),
    [anon_sym_when] = ACTIONS(5626),
    [anon_sym_from] = ACTIONS(5626),
    [anon_sym_into] = ACTIONS(5626),
    [anon_sym_join] = ACTIONS(5626),
    [anon_sym_on] = ACTIONS(5626),
    [anon_sym_equals] = ACTIONS(5626),
    [anon_sym_let] = ACTIONS(5626),
    [anon_sym_orderby] = ACTIONS(5626),
    [anon_sym_ascending] = ACTIONS(5626),
    [anon_sym_descending] = ACTIONS(5626),
    [anon_sym_group] = ACTIONS(5626),
    [anon_sym_by] = ACTIONS(5626),
    [anon_sym_select] = ACTIONS(5626),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4361] = {
    [sym_argument_list] = STATE(3572),
    [sym__name] = STATE(3770),
    [sym_alias_qualified_name] = STATE(3635),
    [sym__simple_name] = STATE(3635),
    [sym_qualified_name] = STATE(3635),
    [sym_generic_name] = STATE(3708),
    [sym_type] = STATE(4257),
    [sym_implicit_type] = STATE(3706),
    [sym_array_type] = STATE(3601),
    [sym__array_base_type] = STATE(8888),
    [sym_nullable_type] = STATE(3618),
    [sym_pointer_type] = STATE(3618),
    [sym__pointer_base_type] = STATE(9386),
    [sym_function_pointer_type] = STATE(3618),
    [sym_ref_type] = STATE(3706),
    [sym_scoped_type] = STATE(3706),
    [sym_tuple_type] = STATE(3633),
    [sym_identifier] = STATE(3590),
    [sym__reserved_identifier] = STATE(3568),
    [sym_preproc_region] = STATE(4361),
    [sym_preproc_endregion] = STATE(4361),
    [sym_preproc_line] = STATE(4361),
    [sym_preproc_pragma] = STATE(4361),
    [sym_preproc_nullable] = STATE(4361),
    [sym_preproc_error] = STATE(4361),
    [sym_preproc_define] = STATE(4361),
    [sym_preproc_undef] = STATE(4361),
    [sym__identifier_token] = ACTIONS(4287),
    [anon_sym_alias] = ACTIONS(4289),
    [anon_sym_global] = ACTIONS(4289),
    [anon_sym_LBRACK] = ACTIONS(4449),
    [anon_sym_LPAREN] = ACTIONS(4451),
    [anon_sym_ref] = ACTIONS(4657),
    [anon_sym_LBRACE] = ACTIONS(4453),
    [anon_sym_delegate] = ACTIONS(4455),
    [anon_sym_file] = ACTIONS(4289),
    [anon_sym_where] = ACTIONS(4289),
    [anon_sym_notnull] = ACTIONS(4289),
    [anon_sym_unmanaged] = ACTIONS(4289),
    [anon_sym_scoped] = ACTIONS(6127),
    [anon_sym_var] = ACTIONS(4459),
    [sym_predefined_type] = ACTIONS(4461),
    [anon_sym_yield] = ACTIONS(4289),
    [anon_sym_when] = ACTIONS(4289),
    [anon_sym_from] = ACTIONS(4289),
    [anon_sym_into] = ACTIONS(4289),
    [anon_sym_join] = ACTIONS(4289),
    [anon_sym_on] = ACTIONS(4289),
    [anon_sym_equals] = ACTIONS(4289),
    [anon_sym_let] = ACTIONS(4289),
    [anon_sym_orderby] = ACTIONS(4289),
    [anon_sym_ascending] = ACTIONS(4289),
    [anon_sym_descending] = ACTIONS(4289),
    [anon_sym_group] = ACTIONS(4289),
    [anon_sym_by] = ACTIONS(4289),
    [anon_sym_select] = ACTIONS(4289),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4362] = {
    [sym__name] = STATE(7762),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(8576),
    [sym_implicit_type] = STATE(8704),
    [sym_array_type] = STATE(8215),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9650),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(8704),
    [sym_scoped_type] = STATE(8704),
    [sym_tuple_type] = STATE(8180),
    [sym_identifier] = STATE(4921),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4362),
    [sym_preproc_endregion] = STATE(4362),
    [sym_preproc_line] = STATE(4362),
    [sym_preproc_pragma] = STATE(4362),
    [sym_preproc_nullable] = STATE(4362),
    [sym_preproc_error] = STATE(4362),
    [sym_preproc_define] = STATE(4362),
    [sym_preproc_undef] = STATE(4362),
    [aux_sym_type_argument_list_repeat1] = STATE(8550),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_COMMA] = ACTIONS(5655),
    [anon_sym_LPAREN] = ACTIONS(2995),
    [anon_sym_ref] = ACTIONS(5657),
    [anon_sym_delegate] = ACTIONS(5659),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_GT] = ACTIONS(6129),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(5665),
    [anon_sym_var] = ACTIONS(5284),
    [sym_predefined_type] = ACTIONS(5667),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4363] = {
    [sym_preproc_region] = STATE(4363),
    [sym_preproc_endregion] = STATE(4363),
    [sym_preproc_line] = STATE(4363),
    [sym_preproc_pragma] = STATE(4363),
    [sym_preproc_nullable] = STATE(4363),
    [sym_preproc_error] = STATE(4363),
    [sym_preproc_define] = STATE(4363),
    [sym_preproc_undef] = STATE(4363),
    [sym__identifier_token] = ACTIONS(5610),
    [anon_sym_extern] = ACTIONS(5610),
    [anon_sym_alias] = ACTIONS(5610),
    [anon_sym_global] = ACTIONS(5610),
    [anon_sym_unsafe] = ACTIONS(5610),
    [anon_sym_static] = ACTIONS(5610),
    [anon_sym_LBRACK] = ACTIONS(5612),
    [anon_sym_abstract] = ACTIONS(5610),
    [anon_sym_async] = ACTIONS(5610),
    [anon_sym_const] = ACTIONS(5610),
    [anon_sym_file] = ACTIONS(5610),
    [anon_sym_fixed] = ACTIONS(5610),
    [anon_sym_internal] = ACTIONS(5610),
    [anon_sym_new] = ACTIONS(5610),
    [anon_sym_override] = ACTIONS(5610),
    [anon_sym_partial] = ACTIONS(5610),
    [anon_sym_private] = ACTIONS(5610),
    [anon_sym_protected] = ACTIONS(5610),
    [anon_sym_public] = ACTIONS(5610),
    [anon_sym_readonly] = ACTIONS(5610),
    [anon_sym_required] = ACTIONS(5610),
    [anon_sym_sealed] = ACTIONS(5610),
    [anon_sym_virtual] = ACTIONS(5610),
    [anon_sym_volatile] = ACTIONS(5610),
    [anon_sym_where] = ACTIONS(5610),
    [anon_sym_notnull] = ACTIONS(5610),
    [anon_sym_unmanaged] = ACTIONS(5610),
    [anon_sym_get] = ACTIONS(5610),
    [anon_sym_set] = ACTIONS(5610),
    [anon_sym_add] = ACTIONS(5610),
    [anon_sym_remove] = ACTIONS(5610),
    [anon_sym_init] = ACTIONS(5610),
    [anon_sym_scoped] = ACTIONS(5610),
    [anon_sym_var] = ACTIONS(5610),
    [anon_sym_yield] = ACTIONS(5610),
    [anon_sym_when] = ACTIONS(5610),
    [anon_sym_from] = ACTIONS(5610),
    [anon_sym_into] = ACTIONS(5610),
    [anon_sym_join] = ACTIONS(5610),
    [anon_sym_on] = ACTIONS(5610),
    [anon_sym_equals] = ACTIONS(5610),
    [anon_sym_let] = ACTIONS(5610),
    [anon_sym_orderby] = ACTIONS(5610),
    [anon_sym_ascending] = ACTIONS(5610),
    [anon_sym_descending] = ACTIONS(5610),
    [anon_sym_group] = ACTIONS(5610),
    [anon_sym_by] = ACTIONS(5610),
    [anon_sym_select] = ACTIONS(5610),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4364] = {
    [sym_argument_list] = STATE(3818),
    [sym__name] = STATE(3925),
    [sym_alias_qualified_name] = STATE(3912),
    [sym__simple_name] = STATE(3912),
    [sym_qualified_name] = STATE(3912),
    [sym_generic_name] = STATE(3874),
    [sym_type] = STATE(3782),
    [sym_implicit_type] = STATE(3915),
    [sym_array_type] = STATE(3823),
    [sym__array_base_type] = STATE(8833),
    [sym_nullable_type] = STATE(3917),
    [sym_pointer_type] = STATE(3917),
    [sym__pointer_base_type] = STATE(9537),
    [sym_function_pointer_type] = STATE(3917),
    [sym_ref_type] = STATE(3915),
    [sym_scoped_type] = STATE(3915),
    [sym_tuple_type] = STATE(3918),
    [sym_identifier] = STATE(3787),
    [sym__reserved_identifier] = STATE(3838),
    [sym_preproc_region] = STATE(4364),
    [sym_preproc_endregion] = STATE(4364),
    [sym_preproc_line] = STATE(4364),
    [sym_preproc_pragma] = STATE(4364),
    [sym_preproc_nullable] = STATE(4364),
    [sym_preproc_error] = STATE(4364),
    [sym_preproc_define] = STATE(4364),
    [sym_preproc_undef] = STATE(4364),
    [sym__identifier_token] = ACTIONS(4157),
    [anon_sym_alias] = ACTIONS(4159),
    [anon_sym_global] = ACTIONS(4159),
    [anon_sym_LBRACK] = ACTIONS(6131),
    [anon_sym_LPAREN] = ACTIONS(6133),
    [anon_sym_ref] = ACTIONS(4574),
    [anon_sym_LBRACE] = ACTIONS(6135),
    [anon_sym_delegate] = ACTIONS(6137),
    [anon_sym_file] = ACTIONS(4159),
    [anon_sym_where] = ACTIONS(4159),
    [anon_sym_notnull] = ACTIONS(4159),
    [anon_sym_unmanaged] = ACTIONS(4159),
    [anon_sym_scoped] = ACTIONS(6139),
    [anon_sym_var] = ACTIONS(6141),
    [sym_predefined_type] = ACTIONS(6143),
    [anon_sym_yield] = ACTIONS(4159),
    [anon_sym_when] = ACTIONS(4159),
    [anon_sym_from] = ACTIONS(4159),
    [anon_sym_into] = ACTIONS(4159),
    [anon_sym_join] = ACTIONS(4159),
    [anon_sym_on] = ACTIONS(4159),
    [anon_sym_equals] = ACTIONS(4159),
    [anon_sym_let] = ACTIONS(4159),
    [anon_sym_orderby] = ACTIONS(4159),
    [anon_sym_ascending] = ACTIONS(4159),
    [anon_sym_descending] = ACTIONS(4159),
    [anon_sym_group] = ACTIONS(4159),
    [anon_sym_by] = ACTIONS(4159),
    [anon_sym_select] = ACTIONS(4159),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4365] = {
    [sym_block] = STATE(2439),
    [sym_preproc_region] = STATE(4365),
    [sym_preproc_endregion] = STATE(4365),
    [sym_preproc_line] = STATE(4365),
    [sym_preproc_pragma] = STATE(4365),
    [sym_preproc_nullable] = STATE(4365),
    [sym_preproc_error] = STATE(4365),
    [sym_preproc_define] = STATE(4365),
    [sym_preproc_undef] = STATE(4365),
    [sym__identifier_token] = ACTIONS(3976),
    [anon_sym_extern] = ACTIONS(3976),
    [anon_sym_alias] = ACTIONS(3976),
    [anon_sym_global] = ACTIONS(3976),
    [anon_sym_unsafe] = ACTIONS(3976),
    [anon_sym_static] = ACTIONS(3976),
    [anon_sym_LPAREN] = ACTIONS(5566),
    [anon_sym_ref] = ACTIONS(3976),
    [anon_sym_LBRACE] = ACTIONS(5707),
    [anon_sym_delegate] = ACTIONS(3976),
    [anon_sym_abstract] = ACTIONS(3976),
    [anon_sym_async] = ACTIONS(3976),
    [anon_sym_const] = ACTIONS(3976),
    [anon_sym_file] = ACTIONS(3976),
    [anon_sym_fixed] = ACTIONS(3976),
    [anon_sym_internal] = ACTIONS(3976),
    [anon_sym_new] = ACTIONS(3976),
    [anon_sym_override] = ACTIONS(3976),
    [anon_sym_partial] = ACTIONS(3976),
    [anon_sym_private] = ACTIONS(3976),
    [anon_sym_protected] = ACTIONS(3976),
    [anon_sym_public] = ACTIONS(3976),
    [anon_sym_readonly] = ACTIONS(3976),
    [anon_sym_required] = ACTIONS(3976),
    [anon_sym_sealed] = ACTIONS(3976),
    [anon_sym_virtual] = ACTIONS(3976),
    [anon_sym_volatile] = ACTIONS(3976),
    [anon_sym_where] = ACTIONS(3976),
    [anon_sym_notnull] = ACTIONS(3976),
    [anon_sym_unmanaged] = ACTIONS(3976),
    [anon_sym_scoped] = ACTIONS(3976),
    [anon_sym_var] = ACTIONS(3976),
    [sym_predefined_type] = ACTIONS(3976),
    [anon_sym_yield] = ACTIONS(3976),
    [anon_sym_when] = ACTIONS(3976),
    [anon_sym_from] = ACTIONS(3976),
    [anon_sym_into] = ACTIONS(3976),
    [anon_sym_join] = ACTIONS(3976),
    [anon_sym_on] = ACTIONS(3976),
    [anon_sym_equals] = ACTIONS(3976),
    [anon_sym_let] = ACTIONS(3976),
    [anon_sym_orderby] = ACTIONS(3976),
    [anon_sym_ascending] = ACTIONS(3976),
    [anon_sym_descending] = ACTIONS(3976),
    [anon_sym_group] = ACTIONS(3976),
    [anon_sym_by] = ACTIONS(3976),
    [anon_sym_select] = ACTIONS(3976),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4366] = {
    [sym_argument_list] = STATE(4344),
    [sym__name] = STATE(3002),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2977),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2956),
    [sym_type] = STATE(4319),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(4379),
    [sym__array_base_type] = STATE(8712),
    [sym_nullable_type] = STATE(2974),
    [sym_pointer_type] = STATE(2974),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(2974),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(2973),
    [sym_identifier] = STATE(2913),
    [sym__reserved_identifier] = STATE(2914),
    [sym_preproc_region] = STATE(4366),
    [sym_preproc_endregion] = STATE(4366),
    [sym_preproc_line] = STATE(4366),
    [sym_preproc_pragma] = STATE(4366),
    [sym_preproc_nullable] = STATE(4366),
    [sym_preproc_error] = STATE(4366),
    [sym_preproc_define] = STATE(4366),
    [sym_preproc_undef] = STATE(4366),
    [sym__identifier_token] = ACTIONS(4490),
    [anon_sym_alias] = ACTIONS(4492),
    [anon_sym_global] = ACTIONS(4492),
    [anon_sym_LBRACK] = ACTIONS(6145),
    [anon_sym_LPAREN] = ACTIONS(6147),
    [anon_sym_ref] = ACTIONS(4545),
    [anon_sym_LBRACE] = ACTIONS(6149),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_file] = ACTIONS(4492),
    [anon_sym_where] = ACTIONS(4492),
    [anon_sym_notnull] = ACTIONS(4492),
    [anon_sym_unmanaged] = ACTIONS(4492),
    [anon_sym_scoped] = ACTIONS(6151),
    [anon_sym_var] = ACTIONS(6153),
    [sym_predefined_type] = ACTIONS(6155),
    [anon_sym_yield] = ACTIONS(4492),
    [anon_sym_when] = ACTIONS(4492),
    [anon_sym_from] = ACTIONS(4492),
    [anon_sym_into] = ACTIONS(4492),
    [anon_sym_join] = ACTIONS(4492),
    [anon_sym_on] = ACTIONS(4492),
    [anon_sym_equals] = ACTIONS(4492),
    [anon_sym_let] = ACTIONS(4492),
    [anon_sym_orderby] = ACTIONS(4492),
    [anon_sym_ascending] = ACTIONS(4492),
    [anon_sym_descending] = ACTIONS(4492),
    [anon_sym_group] = ACTIONS(4492),
    [anon_sym_by] = ACTIONS(4492),
    [anon_sym_select] = ACTIONS(4492),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4367] = {
    [sym__name] = STATE(7762),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(8556),
    [sym_implicit_type] = STATE(8704),
    [sym_array_type] = STATE(8215),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9650),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(8704),
    [sym_scoped_type] = STATE(8704),
    [sym_tuple_type] = STATE(8180),
    [sym_identifier] = STATE(4921),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4367),
    [sym_preproc_endregion] = STATE(4367),
    [sym_preproc_line] = STATE(4367),
    [sym_preproc_pragma] = STATE(4367),
    [sym_preproc_nullable] = STATE(4367),
    [sym_preproc_error] = STATE(4367),
    [sym_preproc_define] = STATE(4367),
    [sym_preproc_undef] = STATE(4367),
    [aux_sym_type_argument_list_repeat1] = STATE(8557),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_COMMA] = ACTIONS(5655),
    [anon_sym_LPAREN] = ACTIONS(2995),
    [anon_sym_ref] = ACTIONS(5657),
    [anon_sym_delegate] = ACTIONS(5659),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_GT] = ACTIONS(6157),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(5665),
    [anon_sym_var] = ACTIONS(5284),
    [sym_predefined_type] = ACTIONS(5667),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4368] = {
    [sym_argument_list] = STATE(3545),
    [sym__name] = STATE(4328),
    [sym_alias_qualified_name] = STATE(3592),
    [sym__simple_name] = STATE(3592),
    [sym_qualified_name] = STATE(3592),
    [sym_generic_name] = STATE(3608),
    [sym_type] = STATE(3535),
    [sym_implicit_type] = STATE(3569),
    [sym_array_type] = STATE(4170),
    [sym__array_base_type] = STATE(8879),
    [sym_nullable_type] = STATE(3585),
    [sym_pointer_type] = STATE(3585),
    [sym__pointer_base_type] = STATE(9439),
    [sym_function_pointer_type] = STATE(3585),
    [sym_ref_type] = STATE(3569),
    [sym_scoped_type] = STATE(3569),
    [sym_tuple_type] = STATE(3583),
    [sym_identifier] = STATE(3989),
    [sym__reserved_identifier] = STATE(3558),
    [sym_preproc_region] = STATE(4368),
    [sym_preproc_endregion] = STATE(4368),
    [sym_preproc_line] = STATE(4368),
    [sym_preproc_pragma] = STATE(4368),
    [sym_preproc_nullable] = STATE(4368),
    [sym_preproc_error] = STATE(4368),
    [sym_preproc_define] = STATE(4368),
    [sym_preproc_undef] = STATE(4368),
    [sym__identifier_token] = ACTIONS(4225),
    [anon_sym_alias] = ACTIONS(4227),
    [anon_sym_global] = ACTIONS(4227),
    [anon_sym_LBRACK] = ACTIONS(6159),
    [anon_sym_LPAREN] = ACTIONS(6161),
    [anon_sym_ref] = ACTIONS(4229),
    [anon_sym_LBRACE] = ACTIONS(6163),
    [anon_sym_delegate] = ACTIONS(6165),
    [anon_sym_file] = ACTIONS(4227),
    [anon_sym_where] = ACTIONS(4227),
    [anon_sym_notnull] = ACTIONS(4227),
    [anon_sym_unmanaged] = ACTIONS(4227),
    [anon_sym_scoped] = ACTIONS(6167),
    [anon_sym_var] = ACTIONS(6169),
    [sym_predefined_type] = ACTIONS(6171),
    [anon_sym_yield] = ACTIONS(4227),
    [anon_sym_when] = ACTIONS(4227),
    [anon_sym_from] = ACTIONS(4227),
    [anon_sym_into] = ACTIONS(4227),
    [anon_sym_join] = ACTIONS(4227),
    [anon_sym_on] = ACTIONS(4227),
    [anon_sym_equals] = ACTIONS(4227),
    [anon_sym_let] = ACTIONS(4227),
    [anon_sym_orderby] = ACTIONS(4227),
    [anon_sym_ascending] = ACTIONS(4227),
    [anon_sym_descending] = ACTIONS(4227),
    [anon_sym_group] = ACTIONS(4227),
    [anon_sym_by] = ACTIONS(4227),
    [anon_sym_select] = ACTIONS(4227),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4369] = {
    [sym_argument_list] = STATE(4571),
    [sym_bracketed_argument_list] = STATE(3551),
    [sym_preproc_region] = STATE(4369),
    [sym_preproc_endregion] = STATE(4369),
    [sym_preproc_line] = STATE(4369),
    [sym_preproc_pragma] = STATE(4369),
    [sym_preproc_nullable] = STATE(4369),
    [sym_preproc_error] = STATE(4369),
    [sym_preproc_define] = STATE(4369),
    [sym_preproc_undef] = STATE(4369),
    [anon_sym_LBRACK] = ACTIONS(6038),
    [anon_sym_COMMA] = ACTIONS(6173),
    [anon_sym_LPAREN] = ACTIONS(6008),
    [anon_sym_LT] = ACTIONS(6040),
    [anon_sym_GT] = ACTIONS(6040),
    [anon_sym_where] = ACTIONS(6173),
    [anon_sym_QMARK] = ACTIONS(6042),
    [anon_sym_BANG] = ACTIONS(6044),
    [anon_sym_PLUS_PLUS] = ACTIONS(6046),
    [anon_sym_DASH_DASH] = ACTIONS(6046),
    [anon_sym_PLUS] = ACTIONS(6048),
    [anon_sym_DASH] = ACTIONS(6048),
    [anon_sym_STAR] = ACTIONS(6050),
    [anon_sym_SLASH] = ACTIONS(6052),
    [anon_sym_PERCENT] = ACTIONS(6050),
    [anon_sym_CARET] = ACTIONS(6054),
    [anon_sym_PIPE] = ACTIONS(6056),
    [anon_sym_AMP] = ACTIONS(6058),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6062),
    [anon_sym_GT_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6064),
    [anon_sym_BANG_EQ] = ACTIONS(6064),
    [anon_sym_GT_EQ] = ACTIONS(6066),
    [anon_sym_LT_EQ] = ACTIONS(6066),
    [anon_sym_DOT] = ACTIONS(5165),
    [anon_sym_switch] = ACTIONS(6068),
    [anon_sym_DOT_DOT] = ACTIONS(6070),
    [anon_sym_and] = ACTIONS(6173),
    [anon_sym_or] = ACTIONS(6175),
    [anon_sym_AMP_AMP] = ACTIONS(6072),
    [anon_sym_PIPE_PIPE] = ACTIONS(6074),
    [anon_sym_QMARK_QMARK] = ACTIONS(6076),
    [anon_sym_from] = ACTIONS(6173),
    [anon_sym_into] = ACTIONS(6173),
    [anon_sym_join] = ACTIONS(6173),
    [anon_sym_let] = ACTIONS(6173),
    [anon_sym_orderby] = ACTIONS(6173),
    [anon_sym_ascending] = ACTIONS(6173),
    [anon_sym_descending] = ACTIONS(6173),
    [anon_sym_group] = ACTIONS(6173),
    [anon_sym_select] = ACTIONS(6173),
    [anon_sym_as] = ACTIONS(6078),
    [anon_sym_is] = ACTIONS(6080),
    [anon_sym_DASH_GT] = ACTIONS(5167),
    [anon_sym_with] = ACTIONS(6082),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4370] = {
    [sym_preproc_region] = STATE(4370),
    [sym_preproc_endregion] = STATE(4370),
    [sym_preproc_line] = STATE(4370),
    [sym_preproc_pragma] = STATE(4370),
    [sym_preproc_nullable] = STATE(4370),
    [sym_preproc_error] = STATE(4370),
    [sym_preproc_define] = STATE(4370),
    [sym_preproc_undef] = STATE(4370),
    [anon_sym_EQ] = ACTIONS(5900),
    [anon_sym_LBRACK] = ACTIONS(5249),
    [anon_sym_COMMA] = ACTIONS(5249),
    [anon_sym_LPAREN] = ACTIONS(5249),
    [anon_sym_RPAREN] = ACTIONS(6177),
    [anon_sym_LT] = ACTIONS(5251),
    [anon_sym_GT] = ACTIONS(5251),
    [anon_sym_QMARK] = ACTIONS(5251),
    [anon_sym_BANG] = ACTIONS(5251),
    [anon_sym_PLUS_PLUS] = ACTIONS(5249),
    [anon_sym_DASH_DASH] = ACTIONS(5249),
    [anon_sym_PLUS] = ACTIONS(5251),
    [anon_sym_DASH] = ACTIONS(5251),
    [anon_sym_STAR] = ACTIONS(5251),
    [anon_sym_SLASH] = ACTIONS(5251),
    [anon_sym_PERCENT] = ACTIONS(5251),
    [anon_sym_CARET] = ACTIONS(5251),
    [anon_sym_PIPE] = ACTIONS(5251),
    [anon_sym_AMP] = ACTIONS(5251),
    [anon_sym_LT_LT] = ACTIONS(5251),
    [anon_sym_GT_GT] = ACTIONS(5251),
    [anon_sym_GT_GT_GT] = ACTIONS(5251),
    [anon_sym_EQ_EQ] = ACTIONS(5249),
    [anon_sym_BANG_EQ] = ACTIONS(5249),
    [anon_sym_GT_EQ] = ACTIONS(5249),
    [anon_sym_LT_EQ] = ACTIONS(5249),
    [anon_sym_DOT] = ACTIONS(5251),
    [anon_sym_switch] = ACTIONS(5249),
    [anon_sym_DOT_DOT] = ACTIONS(5249),
    [anon_sym_PLUS_EQ] = ACTIONS(5902),
    [anon_sym_DASH_EQ] = ACTIONS(5902),
    [anon_sym_STAR_EQ] = ACTIONS(5902),
    [anon_sym_SLASH_EQ] = ACTIONS(5902),
    [anon_sym_PERCENT_EQ] = ACTIONS(5902),
    [anon_sym_AMP_EQ] = ACTIONS(5902),
    [anon_sym_CARET_EQ] = ACTIONS(5902),
    [anon_sym_PIPE_EQ] = ACTIONS(5902),
    [anon_sym_LT_LT_EQ] = ACTIONS(5902),
    [anon_sym_GT_GT_EQ] = ACTIONS(5902),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5902),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(5902),
    [anon_sym_AMP_AMP] = ACTIONS(5249),
    [anon_sym_PIPE_PIPE] = ACTIONS(5249),
    [anon_sym_QMARK_QMARK] = ACTIONS(5251),
    [anon_sym_as] = ACTIONS(5249),
    [anon_sym_is] = ACTIONS(5249),
    [anon_sym_DASH_GT] = ACTIONS(5249),
    [anon_sym_with] = ACTIONS(5249),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4371] = {
    [sym_argument_list] = STATE(4571),
    [sym_bracketed_argument_list] = STATE(3551),
    [sym_preproc_region] = STATE(4371),
    [sym_preproc_endregion] = STATE(4371),
    [sym_preproc_line] = STATE(4371),
    [sym_preproc_pragma] = STATE(4371),
    [sym_preproc_nullable] = STATE(4371),
    [sym_preproc_error] = STATE(4371),
    [sym_preproc_define] = STATE(4371),
    [sym_preproc_undef] = STATE(4371),
    [anon_sym_LBRACK] = ACTIONS(6038),
    [anon_sym_COMMA] = ACTIONS(1133),
    [anon_sym_LPAREN] = ACTIONS(6008),
    [anon_sym_LT] = ACTIONS(1147),
    [anon_sym_GT] = ACTIONS(1147),
    [anon_sym_where] = ACTIONS(1133),
    [anon_sym_QMARK] = ACTIONS(1147),
    [anon_sym_BANG] = ACTIONS(6044),
    [anon_sym_PLUS_PLUS] = ACTIONS(6046),
    [anon_sym_DASH_DASH] = ACTIONS(6046),
    [anon_sym_PLUS] = ACTIONS(1147),
    [anon_sym_DASH] = ACTIONS(1147),
    [anon_sym_STAR] = ACTIONS(1133),
    [anon_sym_SLASH] = ACTIONS(1147),
    [anon_sym_PERCENT] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(1133),
    [anon_sym_PIPE] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(1147),
    [anon_sym_LT_LT] = ACTIONS(1133),
    [anon_sym_GT_GT] = ACTIONS(1147),
    [anon_sym_GT_GT_GT] = ACTIONS(1133),
    [anon_sym_EQ_EQ] = ACTIONS(1133),
    [anon_sym_BANG_EQ] = ACTIONS(1133),
    [anon_sym_GT_EQ] = ACTIONS(1133),
    [anon_sym_LT_EQ] = ACTIONS(1133),
    [anon_sym_DOT] = ACTIONS(5165),
    [anon_sym_switch] = ACTIONS(1133),
    [anon_sym_DOT_DOT] = ACTIONS(6070),
    [anon_sym_and] = ACTIONS(1133),
    [anon_sym_or] = ACTIONS(1147),
    [anon_sym_AMP_AMP] = ACTIONS(1133),
    [anon_sym_PIPE_PIPE] = ACTIONS(1133),
    [anon_sym_QMARK_QMARK] = ACTIONS(1133),
    [anon_sym_from] = ACTIONS(1133),
    [anon_sym_into] = ACTIONS(1133),
    [anon_sym_join] = ACTIONS(1133),
    [anon_sym_let] = ACTIONS(1133),
    [anon_sym_orderby] = ACTIONS(1133),
    [anon_sym_ascending] = ACTIONS(1133),
    [anon_sym_descending] = ACTIONS(1133),
    [anon_sym_group] = ACTIONS(1133),
    [anon_sym_select] = ACTIONS(1133),
    [anon_sym_as] = ACTIONS(1147),
    [anon_sym_is] = ACTIONS(1133),
    [anon_sym_DASH_GT] = ACTIONS(5167),
    [anon_sym_with] = ACTIONS(1133),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4372] = {
    [sym__name] = STATE(7762),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(8481),
    [sym_implicit_type] = STATE(8704),
    [sym_array_type] = STATE(8215),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9650),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(8704),
    [sym_scoped_type] = STATE(8704),
    [sym_tuple_type] = STATE(8180),
    [sym_identifier] = STATE(4921),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4372),
    [sym_preproc_endregion] = STATE(4372),
    [sym_preproc_line] = STATE(4372),
    [sym_preproc_pragma] = STATE(4372),
    [sym_preproc_nullable] = STATE(4372),
    [sym_preproc_error] = STATE(4372),
    [sym_preproc_define] = STATE(4372),
    [sym_preproc_undef] = STATE(4372),
    [aux_sym_type_argument_list_repeat1] = STATE(8479),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_COMMA] = ACTIONS(5655),
    [anon_sym_LPAREN] = ACTIONS(2995),
    [anon_sym_ref] = ACTIONS(5657),
    [anon_sym_delegate] = ACTIONS(5659),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_GT] = ACTIONS(6179),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(5665),
    [anon_sym_var] = ACTIONS(5284),
    [sym_predefined_type] = ACTIONS(5667),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4373] = {
    [sym_argument_list] = STATE(4571),
    [sym_bracketed_argument_list] = STATE(3551),
    [sym_preproc_region] = STATE(4373),
    [sym_preproc_endregion] = STATE(4373),
    [sym_preproc_line] = STATE(4373),
    [sym_preproc_pragma] = STATE(4373),
    [sym_preproc_nullable] = STATE(4373),
    [sym_preproc_error] = STATE(4373),
    [sym_preproc_define] = STATE(4373),
    [sym_preproc_undef] = STATE(4373),
    [anon_sym_LBRACK] = ACTIONS(6038),
    [anon_sym_COMMA] = ACTIONS(6114),
    [anon_sym_LPAREN] = ACTIONS(6008),
    [anon_sym_LT] = ACTIONS(6040),
    [anon_sym_GT] = ACTIONS(6040),
    [anon_sym_where] = ACTIONS(6114),
    [anon_sym_QMARK] = ACTIONS(6116),
    [anon_sym_BANG] = ACTIONS(6044),
    [anon_sym_PLUS_PLUS] = ACTIONS(6046),
    [anon_sym_DASH_DASH] = ACTIONS(6046),
    [anon_sym_PLUS] = ACTIONS(6048),
    [anon_sym_DASH] = ACTIONS(6048),
    [anon_sym_STAR] = ACTIONS(6050),
    [anon_sym_SLASH] = ACTIONS(6052),
    [anon_sym_PERCENT] = ACTIONS(6050),
    [anon_sym_CARET] = ACTIONS(6054),
    [anon_sym_PIPE] = ACTIONS(6056),
    [anon_sym_AMP] = ACTIONS(6058),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6062),
    [anon_sym_GT_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6064),
    [anon_sym_BANG_EQ] = ACTIONS(6064),
    [anon_sym_GT_EQ] = ACTIONS(6066),
    [anon_sym_LT_EQ] = ACTIONS(6066),
    [anon_sym_DOT] = ACTIONS(5165),
    [anon_sym_switch] = ACTIONS(6068),
    [anon_sym_DOT_DOT] = ACTIONS(6070),
    [anon_sym_and] = ACTIONS(6114),
    [anon_sym_or] = ACTIONS(6116),
    [anon_sym_AMP_AMP] = ACTIONS(6072),
    [anon_sym_PIPE_PIPE] = ACTIONS(6074),
    [anon_sym_QMARK_QMARK] = ACTIONS(6076),
    [anon_sym_from] = ACTIONS(6114),
    [anon_sym_into] = ACTIONS(6114),
    [anon_sym_join] = ACTIONS(6114),
    [anon_sym_let] = ACTIONS(6114),
    [anon_sym_orderby] = ACTIONS(6114),
    [anon_sym_ascending] = ACTIONS(6114),
    [anon_sym_descending] = ACTIONS(6114),
    [anon_sym_group] = ACTIONS(6114),
    [anon_sym_select] = ACTIONS(6114),
    [anon_sym_as] = ACTIONS(6078),
    [anon_sym_is] = ACTIONS(6080),
    [anon_sym_DASH_GT] = ACTIONS(5167),
    [anon_sym_with] = ACTIONS(6082),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4374] = {
    [sym_block] = STATE(8871),
    [sym_preproc_region] = STATE(4374),
    [sym_preproc_endregion] = STATE(4374),
    [sym_preproc_line] = STATE(4374),
    [sym_preproc_pragma] = STATE(4374),
    [sym_preproc_nullable] = STATE(4374),
    [sym_preproc_error] = STATE(4374),
    [sym_preproc_define] = STATE(4374),
    [sym_preproc_undef] = STATE(4374),
    [sym__identifier_token] = ACTIONS(3976),
    [anon_sym_extern] = ACTIONS(3976),
    [anon_sym_alias] = ACTIONS(3976),
    [anon_sym_global] = ACTIONS(3976),
    [anon_sym_unsafe] = ACTIONS(3976),
    [anon_sym_static] = ACTIONS(3976),
    [anon_sym_LPAREN] = ACTIONS(5566),
    [anon_sym_ref] = ACTIONS(3976),
    [anon_sym_LBRACE] = ACTIONS(5980),
    [anon_sym_delegate] = ACTIONS(3976),
    [anon_sym_abstract] = ACTIONS(3976),
    [anon_sym_async] = ACTIONS(3976),
    [anon_sym_const] = ACTIONS(3976),
    [anon_sym_file] = ACTIONS(3976),
    [anon_sym_fixed] = ACTIONS(3976),
    [anon_sym_internal] = ACTIONS(3976),
    [anon_sym_new] = ACTIONS(3976),
    [anon_sym_override] = ACTIONS(3976),
    [anon_sym_partial] = ACTIONS(3976),
    [anon_sym_private] = ACTIONS(3976),
    [anon_sym_protected] = ACTIONS(3976),
    [anon_sym_public] = ACTIONS(3976),
    [anon_sym_readonly] = ACTIONS(3976),
    [anon_sym_required] = ACTIONS(3976),
    [anon_sym_sealed] = ACTIONS(3976),
    [anon_sym_virtual] = ACTIONS(3976),
    [anon_sym_volatile] = ACTIONS(3976),
    [anon_sym_where] = ACTIONS(3976),
    [anon_sym_notnull] = ACTIONS(3976),
    [anon_sym_unmanaged] = ACTIONS(3976),
    [anon_sym_scoped] = ACTIONS(3976),
    [anon_sym_var] = ACTIONS(3976),
    [sym_predefined_type] = ACTIONS(3976),
    [anon_sym_yield] = ACTIONS(3976),
    [anon_sym_when] = ACTIONS(3976),
    [anon_sym_from] = ACTIONS(3976),
    [anon_sym_into] = ACTIONS(3976),
    [anon_sym_join] = ACTIONS(3976),
    [anon_sym_on] = ACTIONS(3976),
    [anon_sym_equals] = ACTIONS(3976),
    [anon_sym_let] = ACTIONS(3976),
    [anon_sym_orderby] = ACTIONS(3976),
    [anon_sym_ascending] = ACTIONS(3976),
    [anon_sym_descending] = ACTIONS(3976),
    [anon_sym_group] = ACTIONS(3976),
    [anon_sym_by] = ACTIONS(3976),
    [anon_sym_select] = ACTIONS(3976),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4375] = {
    [sym_argument_list] = STATE(3818),
    [sym__name] = STATE(3925),
    [sym_alias_qualified_name] = STATE(3912),
    [sym__simple_name] = STATE(3912),
    [sym_qualified_name] = STATE(3912),
    [sym_generic_name] = STATE(3874),
    [sym_type] = STATE(3782),
    [sym_implicit_type] = STATE(3915),
    [sym_array_type] = STATE(3823),
    [sym__array_base_type] = STATE(8833),
    [sym_nullable_type] = STATE(3917),
    [sym_pointer_type] = STATE(3917),
    [sym__pointer_base_type] = STATE(9537),
    [sym_function_pointer_type] = STATE(3917),
    [sym_ref_type] = STATE(3915),
    [sym_scoped_type] = STATE(3915),
    [sym_tuple_type] = STATE(3918),
    [sym_identifier] = STATE(3787),
    [sym__reserved_identifier] = STATE(3838),
    [sym_preproc_region] = STATE(4375),
    [sym_preproc_endregion] = STATE(4375),
    [sym_preproc_line] = STATE(4375),
    [sym_preproc_pragma] = STATE(4375),
    [sym_preproc_nullable] = STATE(4375),
    [sym_preproc_error] = STATE(4375),
    [sym_preproc_define] = STATE(4375),
    [sym_preproc_undef] = STATE(4375),
    [sym__identifier_token] = ACTIONS(4157),
    [anon_sym_alias] = ACTIONS(4159),
    [anon_sym_global] = ACTIONS(4159),
    [anon_sym_LBRACK] = ACTIONS(6131),
    [anon_sym_LPAREN] = ACTIONS(6133),
    [anon_sym_ref] = ACTIONS(4572),
    [anon_sym_LBRACE] = ACTIONS(6135),
    [anon_sym_delegate] = ACTIONS(6137),
    [anon_sym_file] = ACTIONS(4159),
    [anon_sym_where] = ACTIONS(4159),
    [anon_sym_notnull] = ACTIONS(4159),
    [anon_sym_unmanaged] = ACTIONS(4159),
    [anon_sym_scoped] = ACTIONS(6181),
    [anon_sym_var] = ACTIONS(6141),
    [sym_predefined_type] = ACTIONS(6143),
    [anon_sym_yield] = ACTIONS(4159),
    [anon_sym_when] = ACTIONS(4159),
    [anon_sym_from] = ACTIONS(4159),
    [anon_sym_into] = ACTIONS(4159),
    [anon_sym_join] = ACTIONS(4159),
    [anon_sym_on] = ACTIONS(4159),
    [anon_sym_equals] = ACTIONS(4159),
    [anon_sym_let] = ACTIONS(4159),
    [anon_sym_orderby] = ACTIONS(4159),
    [anon_sym_ascending] = ACTIONS(4159),
    [anon_sym_descending] = ACTIONS(4159),
    [anon_sym_group] = ACTIONS(4159),
    [anon_sym_by] = ACTIONS(4159),
    [anon_sym_select] = ACTIONS(4159),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4376] = {
    [sym_argument_list] = STATE(3545),
    [sym__name] = STATE(4328),
    [sym_alias_qualified_name] = STATE(3592),
    [sym__simple_name] = STATE(3592),
    [sym_qualified_name] = STATE(3592),
    [sym_generic_name] = STATE(3608),
    [sym_type] = STATE(3535),
    [sym_implicit_type] = STATE(3569),
    [sym_array_type] = STATE(4170),
    [sym__array_base_type] = STATE(8879),
    [sym_nullable_type] = STATE(3585),
    [sym_pointer_type] = STATE(3585),
    [sym__pointer_base_type] = STATE(9439),
    [sym_function_pointer_type] = STATE(3585),
    [sym_ref_type] = STATE(3569),
    [sym_scoped_type] = STATE(3569),
    [sym_tuple_type] = STATE(3583),
    [sym_identifier] = STATE(3989),
    [sym__reserved_identifier] = STATE(3558),
    [sym_preproc_region] = STATE(4376),
    [sym_preproc_endregion] = STATE(4376),
    [sym_preproc_line] = STATE(4376),
    [sym_preproc_pragma] = STATE(4376),
    [sym_preproc_nullable] = STATE(4376),
    [sym_preproc_error] = STATE(4376),
    [sym_preproc_define] = STATE(4376),
    [sym_preproc_undef] = STATE(4376),
    [sym__identifier_token] = ACTIONS(4225),
    [anon_sym_alias] = ACTIONS(4227),
    [anon_sym_global] = ACTIONS(4227),
    [anon_sym_LBRACK] = ACTIONS(6159),
    [anon_sym_LPAREN] = ACTIONS(6161),
    [anon_sym_ref] = ACTIONS(4661),
    [anon_sym_LBRACE] = ACTIONS(6163),
    [anon_sym_delegate] = ACTIONS(6165),
    [anon_sym_file] = ACTIONS(4227),
    [anon_sym_where] = ACTIONS(4227),
    [anon_sym_notnull] = ACTIONS(4227),
    [anon_sym_unmanaged] = ACTIONS(4227),
    [anon_sym_scoped] = ACTIONS(6183),
    [anon_sym_var] = ACTIONS(6169),
    [sym_predefined_type] = ACTIONS(6171),
    [anon_sym_yield] = ACTIONS(4227),
    [anon_sym_when] = ACTIONS(4227),
    [anon_sym_from] = ACTIONS(4227),
    [anon_sym_into] = ACTIONS(4227),
    [anon_sym_join] = ACTIONS(4227),
    [anon_sym_on] = ACTIONS(4227),
    [anon_sym_equals] = ACTIONS(4227),
    [anon_sym_let] = ACTIONS(4227),
    [anon_sym_orderby] = ACTIONS(4227),
    [anon_sym_ascending] = ACTIONS(4227),
    [anon_sym_descending] = ACTIONS(4227),
    [anon_sym_group] = ACTIONS(4227),
    [anon_sym_by] = ACTIONS(4227),
    [anon_sym_select] = ACTIONS(4227),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4377] = {
    [sym__name] = STATE(7762),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(8620),
    [sym_implicit_type] = STATE(8704),
    [sym_array_type] = STATE(8215),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9650),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(8704),
    [sym_scoped_type] = STATE(8704),
    [sym_tuple_type] = STATE(8180),
    [sym_identifier] = STATE(4921),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4377),
    [sym_preproc_endregion] = STATE(4377),
    [sym_preproc_line] = STATE(4377),
    [sym_preproc_pragma] = STATE(4377),
    [sym_preproc_nullable] = STATE(4377),
    [sym_preproc_error] = STATE(4377),
    [sym_preproc_define] = STATE(4377),
    [sym_preproc_undef] = STATE(4377),
    [aux_sym_type_argument_list_repeat1] = STATE(8619),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_COMMA] = ACTIONS(5655),
    [anon_sym_LPAREN] = ACTIONS(2995),
    [anon_sym_ref] = ACTIONS(5657),
    [anon_sym_delegate] = ACTIONS(5659),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_GT] = ACTIONS(6185),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(5665),
    [anon_sym_var] = ACTIONS(5284),
    [sym_predefined_type] = ACTIONS(5667),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4378] = {
    [sym__name] = STATE(7762),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(8564),
    [sym_implicit_type] = STATE(8704),
    [sym_array_type] = STATE(8215),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9650),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(8704),
    [sym_scoped_type] = STATE(8704),
    [sym_tuple_type] = STATE(8180),
    [sym_identifier] = STATE(4921),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4378),
    [sym_preproc_endregion] = STATE(4378),
    [sym_preproc_line] = STATE(4378),
    [sym_preproc_pragma] = STATE(4378),
    [sym_preproc_nullable] = STATE(4378),
    [sym_preproc_error] = STATE(4378),
    [sym_preproc_define] = STATE(4378),
    [sym_preproc_undef] = STATE(4378),
    [aux_sym_type_argument_list_repeat1] = STATE(8565),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_COMMA] = ACTIONS(5655),
    [anon_sym_LPAREN] = ACTIONS(2995),
    [anon_sym_ref] = ACTIONS(5657),
    [anon_sym_delegate] = ACTIONS(5659),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_GT] = ACTIONS(6187),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(5665),
    [anon_sym_var] = ACTIONS(5284),
    [sym_predefined_type] = ACTIONS(5667),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4379] = {
    [sym_initializer_expression] = STATE(4601),
    [sym_preproc_region] = STATE(4379),
    [sym_preproc_endregion] = STATE(4379),
    [sym_preproc_line] = STATE(4379),
    [sym_preproc_pragma] = STATE(4379),
    [sym_preproc_nullable] = STATE(4379),
    [sym_preproc_error] = STATE(4379),
    [sym_preproc_define] = STATE(4379),
    [sym_preproc_undef] = STATE(4379),
    [anon_sym_LBRACK] = ACTIONS(5298),
    [anon_sym_COMMA] = ACTIONS(5302),
    [anon_sym_LPAREN] = ACTIONS(5302),
    [anon_sym_LBRACE] = ACTIONS(6189),
    [anon_sym_LT] = ACTIONS(5308),
    [anon_sym_GT] = ACTIONS(5308),
    [anon_sym_where] = ACTIONS(5302),
    [anon_sym_QMARK] = ACTIONS(6192),
    [anon_sym_BANG] = ACTIONS(5308),
    [anon_sym_PLUS_PLUS] = ACTIONS(5302),
    [anon_sym_DASH_DASH] = ACTIONS(5302),
    [anon_sym_PLUS] = ACTIONS(5308),
    [anon_sym_DASH] = ACTIONS(5308),
    [anon_sym_STAR] = ACTIONS(5302),
    [anon_sym_SLASH] = ACTIONS(5308),
    [anon_sym_PERCENT] = ACTIONS(5302),
    [anon_sym_CARET] = ACTIONS(5302),
    [anon_sym_PIPE] = ACTIONS(5308),
    [anon_sym_AMP] = ACTIONS(5308),
    [anon_sym_LT_LT] = ACTIONS(5302),
    [anon_sym_GT_GT] = ACTIONS(5308),
    [anon_sym_GT_GT_GT] = ACTIONS(5302),
    [anon_sym_EQ_EQ] = ACTIONS(5302),
    [anon_sym_BANG_EQ] = ACTIONS(5302),
    [anon_sym_GT_EQ] = ACTIONS(5302),
    [anon_sym_LT_EQ] = ACTIONS(5302),
    [anon_sym_DOT] = ACTIONS(5308),
    [anon_sym_switch] = ACTIONS(5302),
    [anon_sym_DOT_DOT] = ACTIONS(5302),
    [anon_sym_and] = ACTIONS(5302),
    [anon_sym_or] = ACTIONS(5308),
    [anon_sym_AMP_AMP] = ACTIONS(5302),
    [anon_sym_PIPE_PIPE] = ACTIONS(5302),
    [anon_sym_QMARK_QMARK] = ACTIONS(5302),
    [anon_sym_from] = ACTIONS(5302),
    [anon_sym_into] = ACTIONS(5302),
    [anon_sym_join] = ACTIONS(5302),
    [anon_sym_let] = ACTIONS(5302),
    [anon_sym_orderby] = ACTIONS(5302),
    [anon_sym_ascending] = ACTIONS(5302),
    [anon_sym_descending] = ACTIONS(5302),
    [anon_sym_group] = ACTIONS(5302),
    [anon_sym_select] = ACTIONS(5302),
    [anon_sym_as] = ACTIONS(5308),
    [anon_sym_is] = ACTIONS(5302),
    [anon_sym_DASH_GT] = ACTIONS(5302),
    [anon_sym_with] = ACTIONS(5302),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4380] = {
    [sym_preproc_region] = STATE(4380),
    [sym_preproc_endregion] = STATE(4380),
    [sym_preproc_line] = STATE(4380),
    [sym_preproc_pragma] = STATE(4380),
    [sym_preproc_nullable] = STATE(4380),
    [sym_preproc_error] = STATE(4380),
    [sym_preproc_define] = STATE(4380),
    [sym_preproc_undef] = STATE(4380),
    [sym__identifier_token] = ACTIONS(5637),
    [anon_sym_extern] = ACTIONS(5637),
    [anon_sym_alias] = ACTIONS(5637),
    [anon_sym_global] = ACTIONS(5637),
    [anon_sym_unsafe] = ACTIONS(5637),
    [anon_sym_static] = ACTIONS(5637),
    [anon_sym_LBRACK] = ACTIONS(5639),
    [anon_sym_abstract] = ACTIONS(5637),
    [anon_sym_async] = ACTIONS(5637),
    [anon_sym_const] = ACTIONS(5637),
    [anon_sym_file] = ACTIONS(5637),
    [anon_sym_fixed] = ACTIONS(5637),
    [anon_sym_internal] = ACTIONS(5637),
    [anon_sym_new] = ACTIONS(5637),
    [anon_sym_override] = ACTIONS(5637),
    [anon_sym_partial] = ACTIONS(5637),
    [anon_sym_private] = ACTIONS(5637),
    [anon_sym_protected] = ACTIONS(5637),
    [anon_sym_public] = ACTIONS(5637),
    [anon_sym_readonly] = ACTIONS(5637),
    [anon_sym_required] = ACTIONS(5637),
    [anon_sym_sealed] = ACTIONS(5637),
    [anon_sym_virtual] = ACTIONS(5637),
    [anon_sym_volatile] = ACTIONS(5637),
    [anon_sym_where] = ACTIONS(5637),
    [anon_sym_notnull] = ACTIONS(5637),
    [anon_sym_unmanaged] = ACTIONS(5637),
    [anon_sym_get] = ACTIONS(5637),
    [anon_sym_set] = ACTIONS(5637),
    [anon_sym_add] = ACTIONS(5637),
    [anon_sym_remove] = ACTIONS(5637),
    [anon_sym_init] = ACTIONS(5637),
    [anon_sym_scoped] = ACTIONS(5637),
    [anon_sym_var] = ACTIONS(5637),
    [anon_sym_yield] = ACTIONS(5637),
    [anon_sym_when] = ACTIONS(5637),
    [anon_sym_from] = ACTIONS(5637),
    [anon_sym_into] = ACTIONS(5637),
    [anon_sym_join] = ACTIONS(5637),
    [anon_sym_on] = ACTIONS(5637),
    [anon_sym_equals] = ACTIONS(5637),
    [anon_sym_let] = ACTIONS(5637),
    [anon_sym_orderby] = ACTIONS(5637),
    [anon_sym_ascending] = ACTIONS(5637),
    [anon_sym_descending] = ACTIONS(5637),
    [anon_sym_group] = ACTIONS(5637),
    [anon_sym_by] = ACTIONS(5637),
    [anon_sym_select] = ACTIONS(5637),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4381] = {
    [sym_argument_list] = STATE(5116),
    [sym__name] = STATE(5257),
    [sym_alias_qualified_name] = STATE(5302),
    [sym__simple_name] = STATE(5302),
    [sym_qualified_name] = STATE(5302),
    [sym_generic_name] = STATE(5211),
    [sym_type] = STATE(5083),
    [sym_implicit_type] = STATE(5380),
    [sym_array_type] = STATE(5192),
    [sym__array_base_type] = STATE(8680),
    [sym_nullable_type] = STATE(5271),
    [sym_pointer_type] = STATE(5271),
    [sym__pointer_base_type] = STATE(9933),
    [sym_function_pointer_type] = STATE(5271),
    [sym_ref_type] = STATE(5380),
    [sym_scoped_type] = STATE(5380),
    [sym_tuple_type] = STATE(5293),
    [sym_identifier] = STATE(5034),
    [sym__reserved_identifier] = STATE(5144),
    [sym_preproc_region] = STATE(4381),
    [sym_preproc_endregion] = STATE(4381),
    [sym_preproc_line] = STATE(4381),
    [sym_preproc_pragma] = STATE(4381),
    [sym_preproc_nullable] = STATE(4381),
    [sym_preproc_error] = STATE(4381),
    [sym_preproc_define] = STATE(4381),
    [sym_preproc_undef] = STATE(4381),
    [sym__identifier_token] = ACTIONS(4391),
    [anon_sym_alias] = ACTIONS(4393),
    [anon_sym_global] = ACTIONS(4393),
    [anon_sym_LBRACK] = ACTIONS(6084),
    [anon_sym_LPAREN] = ACTIONS(6086),
    [anon_sym_ref] = ACTIONS(4397),
    [anon_sym_LBRACE] = ACTIONS(6088),
    [anon_sym_delegate] = ACTIONS(6090),
    [anon_sym_file] = ACTIONS(4393),
    [anon_sym_where] = ACTIONS(4393),
    [anon_sym_notnull] = ACTIONS(4393),
    [anon_sym_unmanaged] = ACTIONS(4393),
    [anon_sym_scoped] = ACTIONS(6196),
    [anon_sym_var] = ACTIONS(6094),
    [sym_predefined_type] = ACTIONS(6096),
    [anon_sym_yield] = ACTIONS(4393),
    [anon_sym_when] = ACTIONS(4393),
    [anon_sym_from] = ACTIONS(4393),
    [anon_sym_into] = ACTIONS(4393),
    [anon_sym_join] = ACTIONS(4393),
    [anon_sym_on] = ACTIONS(4393),
    [anon_sym_equals] = ACTIONS(4393),
    [anon_sym_let] = ACTIONS(4393),
    [anon_sym_orderby] = ACTIONS(4393),
    [anon_sym_ascending] = ACTIONS(4393),
    [anon_sym_descending] = ACTIONS(4393),
    [anon_sym_group] = ACTIONS(4393),
    [anon_sym_by] = ACTIONS(4393),
    [anon_sym_select] = ACTIONS(4393),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4382] = {
    [sym_argument_list] = STATE(4571),
    [sym_bracketed_argument_list] = STATE(3551),
    [sym_preproc_region] = STATE(4382),
    [sym_preproc_endregion] = STATE(4382),
    [sym_preproc_line] = STATE(4382),
    [sym_preproc_pragma] = STATE(4382),
    [sym_preproc_nullable] = STATE(4382),
    [sym_preproc_error] = STATE(4382),
    [sym_preproc_define] = STATE(4382),
    [sym_preproc_undef] = STATE(4382),
    [anon_sym_LBRACK] = ACTIONS(6038),
    [anon_sym_COMMA] = ACTIONS(6114),
    [anon_sym_LPAREN] = ACTIONS(6008),
    [anon_sym_LT] = ACTIONS(6040),
    [anon_sym_GT] = ACTIONS(6040),
    [anon_sym_where] = ACTIONS(6114),
    [anon_sym_QMARK] = ACTIONS(6116),
    [anon_sym_BANG] = ACTIONS(6044),
    [anon_sym_PLUS_PLUS] = ACTIONS(6046),
    [anon_sym_DASH_DASH] = ACTIONS(6046),
    [anon_sym_PLUS] = ACTIONS(6048),
    [anon_sym_DASH] = ACTIONS(6048),
    [anon_sym_STAR] = ACTIONS(6050),
    [anon_sym_SLASH] = ACTIONS(6052),
    [anon_sym_PERCENT] = ACTIONS(6050),
    [anon_sym_CARET] = ACTIONS(6054),
    [anon_sym_PIPE] = ACTIONS(6056),
    [anon_sym_AMP] = ACTIONS(6058),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6062),
    [anon_sym_GT_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6064),
    [anon_sym_BANG_EQ] = ACTIONS(6064),
    [anon_sym_GT_EQ] = ACTIONS(6066),
    [anon_sym_LT_EQ] = ACTIONS(6066),
    [anon_sym_DOT] = ACTIONS(5165),
    [anon_sym_switch] = ACTIONS(6068),
    [anon_sym_DOT_DOT] = ACTIONS(6070),
    [anon_sym_and] = ACTIONS(6114),
    [anon_sym_or] = ACTIONS(6116),
    [anon_sym_AMP_AMP] = ACTIONS(6114),
    [anon_sym_PIPE_PIPE] = ACTIONS(6114),
    [anon_sym_QMARK_QMARK] = ACTIONS(6114),
    [anon_sym_from] = ACTIONS(6114),
    [anon_sym_into] = ACTIONS(6114),
    [anon_sym_join] = ACTIONS(6114),
    [anon_sym_let] = ACTIONS(6114),
    [anon_sym_orderby] = ACTIONS(6114),
    [anon_sym_ascending] = ACTIONS(6114),
    [anon_sym_descending] = ACTIONS(6114),
    [anon_sym_group] = ACTIONS(6114),
    [anon_sym_select] = ACTIONS(6114),
    [anon_sym_as] = ACTIONS(6078),
    [anon_sym_is] = ACTIONS(6080),
    [anon_sym_DASH_GT] = ACTIONS(5167),
    [anon_sym_with] = ACTIONS(6082),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4383] = {
    [sym_preproc_region] = STATE(4383),
    [sym_preproc_endregion] = STATE(4383),
    [sym_preproc_line] = STATE(4383),
    [sym_preproc_pragma] = STATE(4383),
    [sym_preproc_nullable] = STATE(4383),
    [sym_preproc_error] = STATE(4383),
    [sym_preproc_define] = STATE(4383),
    [sym_preproc_undef] = STATE(4383),
    [anon_sym_EQ] = ACTIONS(5900),
    [anon_sym_LBRACK] = ACTIONS(5249),
    [anon_sym_COMMA] = ACTIONS(5249),
    [anon_sym_LPAREN] = ACTIONS(5249),
    [anon_sym_RPAREN] = ACTIONS(6198),
    [anon_sym_LT] = ACTIONS(5251),
    [anon_sym_GT] = ACTIONS(5251),
    [anon_sym_QMARK] = ACTIONS(5251),
    [anon_sym_BANG] = ACTIONS(5251),
    [anon_sym_PLUS_PLUS] = ACTIONS(5249),
    [anon_sym_DASH_DASH] = ACTIONS(5249),
    [anon_sym_PLUS] = ACTIONS(5251),
    [anon_sym_DASH] = ACTIONS(5251),
    [anon_sym_STAR] = ACTIONS(5251),
    [anon_sym_SLASH] = ACTIONS(5251),
    [anon_sym_PERCENT] = ACTIONS(5251),
    [anon_sym_CARET] = ACTIONS(5251),
    [anon_sym_PIPE] = ACTIONS(5251),
    [anon_sym_AMP] = ACTIONS(5251),
    [anon_sym_LT_LT] = ACTIONS(5251),
    [anon_sym_GT_GT] = ACTIONS(5251),
    [anon_sym_GT_GT_GT] = ACTIONS(5251),
    [anon_sym_EQ_EQ] = ACTIONS(5249),
    [anon_sym_BANG_EQ] = ACTIONS(5249),
    [anon_sym_GT_EQ] = ACTIONS(5249),
    [anon_sym_LT_EQ] = ACTIONS(5249),
    [anon_sym_DOT] = ACTIONS(5251),
    [anon_sym_switch] = ACTIONS(5249),
    [anon_sym_DOT_DOT] = ACTIONS(5249),
    [anon_sym_PLUS_EQ] = ACTIONS(5902),
    [anon_sym_DASH_EQ] = ACTIONS(5902),
    [anon_sym_STAR_EQ] = ACTIONS(5902),
    [anon_sym_SLASH_EQ] = ACTIONS(5902),
    [anon_sym_PERCENT_EQ] = ACTIONS(5902),
    [anon_sym_AMP_EQ] = ACTIONS(5902),
    [anon_sym_CARET_EQ] = ACTIONS(5902),
    [anon_sym_PIPE_EQ] = ACTIONS(5902),
    [anon_sym_LT_LT_EQ] = ACTIONS(5902),
    [anon_sym_GT_GT_EQ] = ACTIONS(5902),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5902),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(5902),
    [anon_sym_AMP_AMP] = ACTIONS(5249),
    [anon_sym_PIPE_PIPE] = ACTIONS(5249),
    [anon_sym_QMARK_QMARK] = ACTIONS(5251),
    [anon_sym_as] = ACTIONS(5249),
    [anon_sym_is] = ACTIONS(5249),
    [anon_sym_DASH_GT] = ACTIONS(5249),
    [anon_sym_with] = ACTIONS(5249),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4384] = {
    [sym_argument_list] = STATE(4571),
    [sym_bracketed_argument_list] = STATE(3551),
    [sym_preproc_region] = STATE(4384),
    [sym_preproc_endregion] = STATE(4384),
    [sym_preproc_line] = STATE(4384),
    [sym_preproc_pragma] = STATE(4384),
    [sym_preproc_nullable] = STATE(4384),
    [sym_preproc_error] = STATE(4384),
    [sym_preproc_define] = STATE(4384),
    [sym_preproc_undef] = STATE(4384),
    [anon_sym_LBRACK] = ACTIONS(6038),
    [anon_sym_COMMA] = ACTIONS(6114),
    [anon_sym_LPAREN] = ACTIONS(6008),
    [anon_sym_LT] = ACTIONS(6040),
    [anon_sym_GT] = ACTIONS(6040),
    [anon_sym_where] = ACTIONS(6114),
    [anon_sym_QMARK] = ACTIONS(6116),
    [anon_sym_BANG] = ACTIONS(6044),
    [anon_sym_PLUS_PLUS] = ACTIONS(6046),
    [anon_sym_DASH_DASH] = ACTIONS(6046),
    [anon_sym_PLUS] = ACTIONS(6048),
    [anon_sym_DASH] = ACTIONS(6048),
    [anon_sym_STAR] = ACTIONS(6050),
    [anon_sym_SLASH] = ACTIONS(6052),
    [anon_sym_PERCENT] = ACTIONS(6050),
    [anon_sym_CARET] = ACTIONS(6054),
    [anon_sym_PIPE] = ACTIONS(6056),
    [anon_sym_AMP] = ACTIONS(6058),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6062),
    [anon_sym_GT_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6064),
    [anon_sym_BANG_EQ] = ACTIONS(6064),
    [anon_sym_GT_EQ] = ACTIONS(6066),
    [anon_sym_LT_EQ] = ACTIONS(6066),
    [anon_sym_DOT] = ACTIONS(5165),
    [anon_sym_switch] = ACTIONS(6068),
    [anon_sym_DOT_DOT] = ACTIONS(6070),
    [anon_sym_and] = ACTIONS(6114),
    [anon_sym_or] = ACTIONS(6116),
    [anon_sym_AMP_AMP] = ACTIONS(6072),
    [anon_sym_PIPE_PIPE] = ACTIONS(6114),
    [anon_sym_QMARK_QMARK] = ACTIONS(6114),
    [anon_sym_from] = ACTIONS(6114),
    [anon_sym_into] = ACTIONS(6114),
    [anon_sym_join] = ACTIONS(6114),
    [anon_sym_let] = ACTIONS(6114),
    [anon_sym_orderby] = ACTIONS(6114),
    [anon_sym_ascending] = ACTIONS(6114),
    [anon_sym_descending] = ACTIONS(6114),
    [anon_sym_group] = ACTIONS(6114),
    [anon_sym_select] = ACTIONS(6114),
    [anon_sym_as] = ACTIONS(6078),
    [anon_sym_is] = ACTIONS(6080),
    [anon_sym_DASH_GT] = ACTIONS(5167),
    [anon_sym_with] = ACTIONS(6082),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4385] = {
    [sym_argument_list] = STATE(4571),
    [sym_bracketed_argument_list] = STATE(3551),
    [sym_preproc_region] = STATE(4385),
    [sym_preproc_endregion] = STATE(4385),
    [sym_preproc_line] = STATE(4385),
    [sym_preproc_pragma] = STATE(4385),
    [sym_preproc_nullable] = STATE(4385),
    [sym_preproc_error] = STATE(4385),
    [sym_preproc_define] = STATE(4385),
    [sym_preproc_undef] = STATE(4385),
    [anon_sym_LBRACK] = ACTIONS(6038),
    [anon_sym_COMMA] = ACTIONS(6114),
    [anon_sym_LPAREN] = ACTIONS(6008),
    [anon_sym_LT] = ACTIONS(6040),
    [anon_sym_GT] = ACTIONS(6040),
    [anon_sym_where] = ACTIONS(6114),
    [anon_sym_QMARK] = ACTIONS(6116),
    [anon_sym_BANG] = ACTIONS(6044),
    [anon_sym_PLUS_PLUS] = ACTIONS(6046),
    [anon_sym_DASH_DASH] = ACTIONS(6046),
    [anon_sym_PLUS] = ACTIONS(6048),
    [anon_sym_DASH] = ACTIONS(6048),
    [anon_sym_STAR] = ACTIONS(6050),
    [anon_sym_SLASH] = ACTIONS(6052),
    [anon_sym_PERCENT] = ACTIONS(6050),
    [anon_sym_CARET] = ACTIONS(6114),
    [anon_sym_PIPE] = ACTIONS(6116),
    [anon_sym_AMP] = ACTIONS(6116),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6062),
    [anon_sym_GT_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6114),
    [anon_sym_BANG_EQ] = ACTIONS(6114),
    [anon_sym_GT_EQ] = ACTIONS(6066),
    [anon_sym_LT_EQ] = ACTIONS(6066),
    [anon_sym_DOT] = ACTIONS(5165),
    [anon_sym_switch] = ACTIONS(6068),
    [anon_sym_DOT_DOT] = ACTIONS(6070),
    [anon_sym_and] = ACTIONS(6114),
    [anon_sym_or] = ACTIONS(6116),
    [anon_sym_AMP_AMP] = ACTIONS(6114),
    [anon_sym_PIPE_PIPE] = ACTIONS(6114),
    [anon_sym_QMARK_QMARK] = ACTIONS(6114),
    [anon_sym_from] = ACTIONS(6114),
    [anon_sym_into] = ACTIONS(6114),
    [anon_sym_join] = ACTIONS(6114),
    [anon_sym_let] = ACTIONS(6114),
    [anon_sym_orderby] = ACTIONS(6114),
    [anon_sym_ascending] = ACTIONS(6114),
    [anon_sym_descending] = ACTIONS(6114),
    [anon_sym_group] = ACTIONS(6114),
    [anon_sym_select] = ACTIONS(6114),
    [anon_sym_as] = ACTIONS(6078),
    [anon_sym_is] = ACTIONS(6080),
    [anon_sym_DASH_GT] = ACTIONS(5167),
    [anon_sym_with] = ACTIONS(6082),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4386] = {
    [sym_argument_list] = STATE(4571),
    [sym_bracketed_argument_list] = STATE(3551),
    [sym_preproc_region] = STATE(4386),
    [sym_preproc_endregion] = STATE(4386),
    [sym_preproc_line] = STATE(4386),
    [sym_preproc_pragma] = STATE(4386),
    [sym_preproc_nullable] = STATE(4386),
    [sym_preproc_error] = STATE(4386),
    [sym_preproc_define] = STATE(4386),
    [sym_preproc_undef] = STATE(4386),
    [anon_sym_LBRACK] = ACTIONS(6038),
    [anon_sym_COMMA] = ACTIONS(6114),
    [anon_sym_LPAREN] = ACTIONS(6008),
    [anon_sym_LT] = ACTIONS(6040),
    [anon_sym_GT] = ACTIONS(6040),
    [anon_sym_where] = ACTIONS(6114),
    [anon_sym_QMARK] = ACTIONS(6116),
    [anon_sym_BANG] = ACTIONS(6044),
    [anon_sym_PLUS_PLUS] = ACTIONS(6046),
    [anon_sym_DASH_DASH] = ACTIONS(6046),
    [anon_sym_PLUS] = ACTIONS(6048),
    [anon_sym_DASH] = ACTIONS(6048),
    [anon_sym_STAR] = ACTIONS(6050),
    [anon_sym_SLASH] = ACTIONS(6052),
    [anon_sym_PERCENT] = ACTIONS(6050),
    [anon_sym_CARET] = ACTIONS(6114),
    [anon_sym_PIPE] = ACTIONS(6116),
    [anon_sym_AMP] = ACTIONS(6116),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6062),
    [anon_sym_GT_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6064),
    [anon_sym_BANG_EQ] = ACTIONS(6064),
    [anon_sym_GT_EQ] = ACTIONS(6066),
    [anon_sym_LT_EQ] = ACTIONS(6066),
    [anon_sym_DOT] = ACTIONS(5165),
    [anon_sym_switch] = ACTIONS(6068),
    [anon_sym_DOT_DOT] = ACTIONS(6070),
    [anon_sym_and] = ACTIONS(6114),
    [anon_sym_or] = ACTIONS(6116),
    [anon_sym_AMP_AMP] = ACTIONS(6114),
    [anon_sym_PIPE_PIPE] = ACTIONS(6114),
    [anon_sym_QMARK_QMARK] = ACTIONS(6114),
    [anon_sym_from] = ACTIONS(6114),
    [anon_sym_into] = ACTIONS(6114),
    [anon_sym_join] = ACTIONS(6114),
    [anon_sym_let] = ACTIONS(6114),
    [anon_sym_orderby] = ACTIONS(6114),
    [anon_sym_ascending] = ACTIONS(6114),
    [anon_sym_descending] = ACTIONS(6114),
    [anon_sym_group] = ACTIONS(6114),
    [anon_sym_select] = ACTIONS(6114),
    [anon_sym_as] = ACTIONS(6078),
    [anon_sym_is] = ACTIONS(6080),
    [anon_sym_DASH_GT] = ACTIONS(5167),
    [anon_sym_with] = ACTIONS(6082),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4387] = {
    [sym_argument_list] = STATE(4571),
    [sym_bracketed_argument_list] = STATE(3551),
    [sym_preproc_region] = STATE(4387),
    [sym_preproc_endregion] = STATE(4387),
    [sym_preproc_line] = STATE(4387),
    [sym_preproc_pragma] = STATE(4387),
    [sym_preproc_nullable] = STATE(4387),
    [sym_preproc_error] = STATE(4387),
    [sym_preproc_define] = STATE(4387),
    [sym_preproc_undef] = STATE(4387),
    [anon_sym_LBRACK] = ACTIONS(6038),
    [anon_sym_COMMA] = ACTIONS(6114),
    [anon_sym_LPAREN] = ACTIONS(6008),
    [anon_sym_LT] = ACTIONS(6040),
    [anon_sym_GT] = ACTIONS(6040),
    [anon_sym_where] = ACTIONS(6114),
    [anon_sym_QMARK] = ACTIONS(6116),
    [anon_sym_BANG] = ACTIONS(6044),
    [anon_sym_PLUS_PLUS] = ACTIONS(6046),
    [anon_sym_DASH_DASH] = ACTIONS(6046),
    [anon_sym_PLUS] = ACTIONS(6048),
    [anon_sym_DASH] = ACTIONS(6048),
    [anon_sym_STAR] = ACTIONS(6050),
    [anon_sym_SLASH] = ACTIONS(6052),
    [anon_sym_PERCENT] = ACTIONS(6050),
    [anon_sym_CARET] = ACTIONS(6054),
    [anon_sym_PIPE] = ACTIONS(6116),
    [anon_sym_AMP] = ACTIONS(6058),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6062),
    [anon_sym_GT_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6064),
    [anon_sym_BANG_EQ] = ACTIONS(6064),
    [anon_sym_GT_EQ] = ACTIONS(6066),
    [anon_sym_LT_EQ] = ACTIONS(6066),
    [anon_sym_DOT] = ACTIONS(5165),
    [anon_sym_switch] = ACTIONS(6068),
    [anon_sym_DOT_DOT] = ACTIONS(6070),
    [anon_sym_and] = ACTIONS(6114),
    [anon_sym_or] = ACTIONS(6116),
    [anon_sym_AMP_AMP] = ACTIONS(6114),
    [anon_sym_PIPE_PIPE] = ACTIONS(6114),
    [anon_sym_QMARK_QMARK] = ACTIONS(6114),
    [anon_sym_from] = ACTIONS(6114),
    [anon_sym_into] = ACTIONS(6114),
    [anon_sym_join] = ACTIONS(6114),
    [anon_sym_let] = ACTIONS(6114),
    [anon_sym_orderby] = ACTIONS(6114),
    [anon_sym_ascending] = ACTIONS(6114),
    [anon_sym_descending] = ACTIONS(6114),
    [anon_sym_group] = ACTIONS(6114),
    [anon_sym_select] = ACTIONS(6114),
    [anon_sym_as] = ACTIONS(6078),
    [anon_sym_is] = ACTIONS(6080),
    [anon_sym_DASH_GT] = ACTIONS(5167),
    [anon_sym_with] = ACTIONS(6082),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4388] = {
    [sym_argument_list] = STATE(4571),
    [sym_bracketed_argument_list] = STATE(3551),
    [sym_preproc_region] = STATE(4388),
    [sym_preproc_endregion] = STATE(4388),
    [sym_preproc_line] = STATE(4388),
    [sym_preproc_pragma] = STATE(4388),
    [sym_preproc_nullable] = STATE(4388),
    [sym_preproc_error] = STATE(4388),
    [sym_preproc_define] = STATE(4388),
    [sym_preproc_undef] = STATE(4388),
    [anon_sym_LBRACK] = ACTIONS(6038),
    [anon_sym_COMMA] = ACTIONS(6114),
    [anon_sym_LPAREN] = ACTIONS(6008),
    [anon_sym_LT] = ACTIONS(6040),
    [anon_sym_GT] = ACTIONS(6040),
    [anon_sym_where] = ACTIONS(6114),
    [anon_sym_QMARK] = ACTIONS(6116),
    [anon_sym_BANG] = ACTIONS(6044),
    [anon_sym_PLUS_PLUS] = ACTIONS(6046),
    [anon_sym_DASH_DASH] = ACTIONS(6046),
    [anon_sym_PLUS] = ACTIONS(6048),
    [anon_sym_DASH] = ACTIONS(6048),
    [anon_sym_STAR] = ACTIONS(6050),
    [anon_sym_SLASH] = ACTIONS(6052),
    [anon_sym_PERCENT] = ACTIONS(6050),
    [anon_sym_CARET] = ACTIONS(6114),
    [anon_sym_PIPE] = ACTIONS(6116),
    [anon_sym_AMP] = ACTIONS(6058),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6062),
    [anon_sym_GT_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6064),
    [anon_sym_BANG_EQ] = ACTIONS(6064),
    [anon_sym_GT_EQ] = ACTIONS(6066),
    [anon_sym_LT_EQ] = ACTIONS(6066),
    [anon_sym_DOT] = ACTIONS(5165),
    [anon_sym_switch] = ACTIONS(6068),
    [anon_sym_DOT_DOT] = ACTIONS(6070),
    [anon_sym_and] = ACTIONS(6114),
    [anon_sym_or] = ACTIONS(6116),
    [anon_sym_AMP_AMP] = ACTIONS(6114),
    [anon_sym_PIPE_PIPE] = ACTIONS(6114),
    [anon_sym_QMARK_QMARK] = ACTIONS(6114),
    [anon_sym_from] = ACTIONS(6114),
    [anon_sym_into] = ACTIONS(6114),
    [anon_sym_join] = ACTIONS(6114),
    [anon_sym_let] = ACTIONS(6114),
    [anon_sym_orderby] = ACTIONS(6114),
    [anon_sym_ascending] = ACTIONS(6114),
    [anon_sym_descending] = ACTIONS(6114),
    [anon_sym_group] = ACTIONS(6114),
    [anon_sym_select] = ACTIONS(6114),
    [anon_sym_as] = ACTIONS(6078),
    [anon_sym_is] = ACTIONS(6080),
    [anon_sym_DASH_GT] = ACTIONS(5167),
    [anon_sym_with] = ACTIONS(6082),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4389] = {
    [sym_argument_list] = STATE(3900),
    [sym__name] = STATE(6161),
    [sym_alias_qualified_name] = STATE(3955),
    [sym__simple_name] = STATE(3955),
    [sym_qualified_name] = STATE(3955),
    [sym_generic_name] = STATE(4047),
    [sym_type] = STATE(3847),
    [sym_implicit_type] = STATE(3954),
    [sym_array_type] = STATE(6055),
    [sym__array_base_type] = STATE(8755),
    [sym_nullable_type] = STATE(3937),
    [sym_pointer_type] = STATE(3937),
    [sym__pointer_base_type] = STATE(9763),
    [sym_function_pointer_type] = STATE(3937),
    [sym_ref_type] = STATE(3954),
    [sym_scoped_type] = STATE(3954),
    [sym_tuple_type] = STATE(3962),
    [sym_identifier] = STATE(5594),
    [sym__reserved_identifier] = STATE(3897),
    [sym_preproc_region] = STATE(4389),
    [sym_preproc_endregion] = STATE(4389),
    [sym_preproc_line] = STATE(4389),
    [sym_preproc_pragma] = STATE(4389),
    [sym_preproc_nullable] = STATE(4389),
    [sym_preproc_error] = STATE(4389),
    [sym_preproc_define] = STATE(4389),
    [sym_preproc_undef] = STATE(4389),
    [sym__identifier_token] = ACTIONS(4168),
    [anon_sym_alias] = ACTIONS(4170),
    [anon_sym_global] = ACTIONS(4170),
    [anon_sym_LBRACK] = ACTIONS(6200),
    [anon_sym_LPAREN] = ACTIONS(6202),
    [anon_sym_ref] = ACTIONS(4543),
    [anon_sym_LBRACE] = ACTIONS(6204),
    [anon_sym_delegate] = ACTIONS(6206),
    [anon_sym_file] = ACTIONS(4170),
    [anon_sym_where] = ACTIONS(4170),
    [anon_sym_notnull] = ACTIONS(4170),
    [anon_sym_unmanaged] = ACTIONS(4170),
    [anon_sym_scoped] = ACTIONS(6208),
    [anon_sym_var] = ACTIONS(6210),
    [sym_predefined_type] = ACTIONS(6212),
    [anon_sym_yield] = ACTIONS(4170),
    [anon_sym_when] = ACTIONS(4170),
    [anon_sym_from] = ACTIONS(4170),
    [anon_sym_into] = ACTIONS(4170),
    [anon_sym_join] = ACTIONS(4170),
    [anon_sym_on] = ACTIONS(4170),
    [anon_sym_equals] = ACTIONS(4170),
    [anon_sym_let] = ACTIONS(4170),
    [anon_sym_orderby] = ACTIONS(4170),
    [anon_sym_ascending] = ACTIONS(4170),
    [anon_sym_descending] = ACTIONS(4170),
    [anon_sym_group] = ACTIONS(4170),
    [anon_sym_by] = ACTIONS(4170),
    [anon_sym_select] = ACTIONS(4170),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4390] = {
    [sym_argument_list] = STATE(4571),
    [sym_bracketed_argument_list] = STATE(3551),
    [sym_preproc_region] = STATE(4390),
    [sym_preproc_endregion] = STATE(4390),
    [sym_preproc_line] = STATE(4390),
    [sym_preproc_pragma] = STATE(4390),
    [sym_preproc_nullable] = STATE(4390),
    [sym_preproc_error] = STATE(4390),
    [sym_preproc_define] = STATE(4390),
    [sym_preproc_undef] = STATE(4390),
    [anon_sym_LBRACK] = ACTIONS(6038),
    [anon_sym_COMMA] = ACTIONS(5337),
    [anon_sym_LPAREN] = ACTIONS(6008),
    [anon_sym_LT] = ACTIONS(6040),
    [anon_sym_GT] = ACTIONS(6040),
    [anon_sym_where] = ACTIONS(5337),
    [anon_sym_QMARK] = ACTIONS(6042),
    [anon_sym_BANG] = ACTIONS(6044),
    [anon_sym_PLUS_PLUS] = ACTIONS(6046),
    [anon_sym_DASH_DASH] = ACTIONS(6046),
    [anon_sym_PLUS] = ACTIONS(6048),
    [anon_sym_DASH] = ACTIONS(6048),
    [anon_sym_STAR] = ACTIONS(6050),
    [anon_sym_SLASH] = ACTIONS(6052),
    [anon_sym_PERCENT] = ACTIONS(6050),
    [anon_sym_CARET] = ACTIONS(6054),
    [anon_sym_PIPE] = ACTIONS(6056),
    [anon_sym_AMP] = ACTIONS(6058),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6062),
    [anon_sym_GT_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6064),
    [anon_sym_BANG_EQ] = ACTIONS(6064),
    [anon_sym_GT_EQ] = ACTIONS(6066),
    [anon_sym_LT_EQ] = ACTIONS(6066),
    [anon_sym_DOT] = ACTIONS(5165),
    [anon_sym_switch] = ACTIONS(6068),
    [anon_sym_DOT_DOT] = ACTIONS(6070),
    [anon_sym_and] = ACTIONS(5337),
    [anon_sym_or] = ACTIONS(5339),
    [anon_sym_AMP_AMP] = ACTIONS(6072),
    [anon_sym_PIPE_PIPE] = ACTIONS(6074),
    [anon_sym_QMARK_QMARK] = ACTIONS(6076),
    [anon_sym_from] = ACTIONS(5337),
    [anon_sym_into] = ACTIONS(5337),
    [anon_sym_join] = ACTIONS(5337),
    [anon_sym_let] = ACTIONS(5337),
    [anon_sym_orderby] = ACTIONS(5337),
    [anon_sym_ascending] = ACTIONS(5337),
    [anon_sym_descending] = ACTIONS(5337),
    [anon_sym_group] = ACTIONS(5337),
    [anon_sym_select] = ACTIONS(5337),
    [anon_sym_as] = ACTIONS(6078),
    [anon_sym_is] = ACTIONS(6080),
    [anon_sym_DASH_GT] = ACTIONS(5167),
    [anon_sym_with] = ACTIONS(6082),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4391] = {
    [sym_argument_list] = STATE(4571),
    [sym_bracketed_argument_list] = STATE(3551),
    [sym_preproc_region] = STATE(4391),
    [sym_preproc_endregion] = STATE(4391),
    [sym_preproc_line] = STATE(4391),
    [sym_preproc_pragma] = STATE(4391),
    [sym_preproc_nullable] = STATE(4391),
    [sym_preproc_error] = STATE(4391),
    [sym_preproc_define] = STATE(4391),
    [sym_preproc_undef] = STATE(4391),
    [anon_sym_LBRACK] = ACTIONS(6038),
    [anon_sym_COMMA] = ACTIONS(5396),
    [anon_sym_LPAREN] = ACTIONS(6008),
    [anon_sym_LT] = ACTIONS(6040),
    [anon_sym_GT] = ACTIONS(6040),
    [anon_sym_where] = ACTIONS(5396),
    [anon_sym_QMARK] = ACTIONS(6042),
    [anon_sym_BANG] = ACTIONS(6044),
    [anon_sym_PLUS_PLUS] = ACTIONS(6046),
    [anon_sym_DASH_DASH] = ACTIONS(6046),
    [anon_sym_PLUS] = ACTIONS(6048),
    [anon_sym_DASH] = ACTIONS(6048),
    [anon_sym_STAR] = ACTIONS(6050),
    [anon_sym_SLASH] = ACTIONS(6052),
    [anon_sym_PERCENT] = ACTIONS(6050),
    [anon_sym_CARET] = ACTIONS(6054),
    [anon_sym_PIPE] = ACTIONS(6056),
    [anon_sym_AMP] = ACTIONS(6058),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6062),
    [anon_sym_GT_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6064),
    [anon_sym_BANG_EQ] = ACTIONS(6064),
    [anon_sym_GT_EQ] = ACTIONS(6066),
    [anon_sym_LT_EQ] = ACTIONS(6066),
    [anon_sym_DOT] = ACTIONS(5165),
    [anon_sym_switch] = ACTIONS(6068),
    [anon_sym_DOT_DOT] = ACTIONS(6070),
    [anon_sym_and] = ACTIONS(5396),
    [anon_sym_or] = ACTIONS(5398),
    [anon_sym_AMP_AMP] = ACTIONS(6072),
    [anon_sym_PIPE_PIPE] = ACTIONS(6074),
    [anon_sym_QMARK_QMARK] = ACTIONS(6076),
    [anon_sym_from] = ACTIONS(5396),
    [anon_sym_into] = ACTIONS(5396),
    [anon_sym_join] = ACTIONS(5396),
    [anon_sym_let] = ACTIONS(5396),
    [anon_sym_orderby] = ACTIONS(5396),
    [anon_sym_ascending] = ACTIONS(5396),
    [anon_sym_descending] = ACTIONS(5396),
    [anon_sym_group] = ACTIONS(5396),
    [anon_sym_select] = ACTIONS(5396),
    [anon_sym_as] = ACTIONS(6078),
    [anon_sym_is] = ACTIONS(6080),
    [anon_sym_DASH_GT] = ACTIONS(5167),
    [anon_sym_with] = ACTIONS(6082),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4392] = {
    [sym__name] = STATE(7762),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(8590),
    [sym_implicit_type] = STATE(8704),
    [sym_array_type] = STATE(8215),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9650),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(8704),
    [sym_scoped_type] = STATE(8704),
    [sym_tuple_type] = STATE(8180),
    [sym_identifier] = STATE(4921),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4392),
    [sym_preproc_endregion] = STATE(4392),
    [sym_preproc_line] = STATE(4392),
    [sym_preproc_pragma] = STATE(4392),
    [sym_preproc_nullable] = STATE(4392),
    [sym_preproc_error] = STATE(4392),
    [sym_preproc_define] = STATE(4392),
    [sym_preproc_undef] = STATE(4392),
    [aux_sym_type_argument_list_repeat1] = STATE(8591),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_COMMA] = ACTIONS(5655),
    [anon_sym_LPAREN] = ACTIONS(2995),
    [anon_sym_ref] = ACTIONS(5657),
    [anon_sym_delegate] = ACTIONS(5659),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_GT] = ACTIONS(5661),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(5665),
    [anon_sym_var] = ACTIONS(5284),
    [sym_predefined_type] = ACTIONS(5667),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4393] = {
    [sym_tuple_pattern] = STATE(8536),
    [sym__name] = STATE(5381),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(7204),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(5548),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(5237),
    [sym_tuple_element] = STATE(8846),
    [sym_identifier] = STATE(6740),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4393),
    [sym_preproc_endregion] = STATE(4393),
    [sym_preproc_line] = STATE(4393),
    [sym_preproc_pragma] = STATE(4393),
    [sym_preproc_nullable] = STATE(4393),
    [sym_preproc_error] = STATE(4393),
    [sym_preproc_define] = STATE(4393),
    [sym_preproc_undef] = STATE(4393),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_LPAREN] = ACTIONS(5214),
    [anon_sym_ref] = ACTIONS(4012),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(6214),
    [anon_sym_var] = ACTIONS(5284),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [sym_discard] = ACTIONS(5220),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4394] = {
    [sym_argument_list] = STATE(4571),
    [sym_bracketed_argument_list] = STATE(3551),
    [sym_preproc_region] = STATE(4394),
    [sym_preproc_endregion] = STATE(4394),
    [sym_preproc_line] = STATE(4394),
    [sym_preproc_pragma] = STATE(4394),
    [sym_preproc_nullable] = STATE(4394),
    [sym_preproc_error] = STATE(4394),
    [sym_preproc_define] = STATE(4394),
    [sym_preproc_undef] = STATE(4394),
    [anon_sym_LBRACK] = ACTIONS(6038),
    [anon_sym_COMMA] = ACTIONS(6216),
    [anon_sym_LPAREN] = ACTIONS(6008),
    [anon_sym_LT] = ACTIONS(6040),
    [anon_sym_GT] = ACTIONS(6040),
    [anon_sym_where] = ACTIONS(6216),
    [anon_sym_QMARK] = ACTIONS(6042),
    [anon_sym_BANG] = ACTIONS(6044),
    [anon_sym_PLUS_PLUS] = ACTIONS(6046),
    [anon_sym_DASH_DASH] = ACTIONS(6046),
    [anon_sym_PLUS] = ACTIONS(6048),
    [anon_sym_DASH] = ACTIONS(6048),
    [anon_sym_STAR] = ACTIONS(6050),
    [anon_sym_SLASH] = ACTIONS(6052),
    [anon_sym_PERCENT] = ACTIONS(6050),
    [anon_sym_CARET] = ACTIONS(6054),
    [anon_sym_PIPE] = ACTIONS(6056),
    [anon_sym_AMP] = ACTIONS(6058),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6062),
    [anon_sym_GT_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6064),
    [anon_sym_BANG_EQ] = ACTIONS(6064),
    [anon_sym_GT_EQ] = ACTIONS(6066),
    [anon_sym_LT_EQ] = ACTIONS(6066),
    [anon_sym_DOT] = ACTIONS(5165),
    [anon_sym_switch] = ACTIONS(6068),
    [anon_sym_DOT_DOT] = ACTIONS(6070),
    [anon_sym_and] = ACTIONS(6216),
    [anon_sym_or] = ACTIONS(6218),
    [anon_sym_AMP_AMP] = ACTIONS(6072),
    [anon_sym_PIPE_PIPE] = ACTIONS(6074),
    [anon_sym_QMARK_QMARK] = ACTIONS(6076),
    [anon_sym_from] = ACTIONS(6216),
    [anon_sym_into] = ACTIONS(6216),
    [anon_sym_join] = ACTIONS(6216),
    [anon_sym_let] = ACTIONS(6216),
    [anon_sym_orderby] = ACTIONS(6216),
    [anon_sym_ascending] = ACTIONS(6216),
    [anon_sym_descending] = ACTIONS(6216),
    [anon_sym_group] = ACTIONS(6216),
    [anon_sym_select] = ACTIONS(6216),
    [anon_sym_as] = ACTIONS(6078),
    [anon_sym_is] = ACTIONS(6080),
    [anon_sym_DASH_GT] = ACTIONS(5167),
    [anon_sym_with] = ACTIONS(6082),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4395] = {
    [sym_argument_list] = STATE(4571),
    [sym_bracketed_argument_list] = STATE(3551),
    [sym_preproc_region] = STATE(4395),
    [sym_preproc_endregion] = STATE(4395),
    [sym_preproc_line] = STATE(4395),
    [sym_preproc_pragma] = STATE(4395),
    [sym_preproc_nullable] = STATE(4395),
    [sym_preproc_error] = STATE(4395),
    [sym_preproc_define] = STATE(4395),
    [sym_preproc_undef] = STATE(4395),
    [anon_sym_LBRACK] = ACTIONS(6038),
    [anon_sym_COMMA] = ACTIONS(5325),
    [anon_sym_LPAREN] = ACTIONS(6008),
    [anon_sym_LT] = ACTIONS(6040),
    [anon_sym_GT] = ACTIONS(6040),
    [anon_sym_where] = ACTIONS(5325),
    [anon_sym_QMARK] = ACTIONS(6042),
    [anon_sym_BANG] = ACTIONS(6044),
    [anon_sym_PLUS_PLUS] = ACTIONS(6046),
    [anon_sym_DASH_DASH] = ACTIONS(6046),
    [anon_sym_PLUS] = ACTIONS(6048),
    [anon_sym_DASH] = ACTIONS(6048),
    [anon_sym_STAR] = ACTIONS(6050),
    [anon_sym_SLASH] = ACTIONS(6052),
    [anon_sym_PERCENT] = ACTIONS(6050),
    [anon_sym_CARET] = ACTIONS(6054),
    [anon_sym_PIPE] = ACTIONS(6056),
    [anon_sym_AMP] = ACTIONS(6058),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6062),
    [anon_sym_GT_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6064),
    [anon_sym_BANG_EQ] = ACTIONS(6064),
    [anon_sym_GT_EQ] = ACTIONS(6066),
    [anon_sym_LT_EQ] = ACTIONS(6066),
    [anon_sym_DOT] = ACTIONS(5165),
    [anon_sym_switch] = ACTIONS(6068),
    [anon_sym_DOT_DOT] = ACTIONS(6070),
    [anon_sym_and] = ACTIONS(5325),
    [anon_sym_or] = ACTIONS(5327),
    [anon_sym_AMP_AMP] = ACTIONS(6072),
    [anon_sym_PIPE_PIPE] = ACTIONS(6074),
    [anon_sym_QMARK_QMARK] = ACTIONS(6076),
    [anon_sym_from] = ACTIONS(5325),
    [anon_sym_into] = ACTIONS(5325),
    [anon_sym_join] = ACTIONS(5325),
    [anon_sym_let] = ACTIONS(5325),
    [anon_sym_orderby] = ACTIONS(5325),
    [anon_sym_ascending] = ACTIONS(5325),
    [anon_sym_descending] = ACTIONS(5325),
    [anon_sym_group] = ACTIONS(5325),
    [anon_sym_select] = ACTIONS(5325),
    [anon_sym_as] = ACTIONS(6078),
    [anon_sym_is] = ACTIONS(6080),
    [anon_sym_DASH_GT] = ACTIONS(5167),
    [anon_sym_with] = ACTIONS(6082),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4396] = {
    [sym_argument_list] = STATE(4571),
    [sym_bracketed_argument_list] = STATE(3551),
    [sym_preproc_region] = STATE(4396),
    [sym_preproc_endregion] = STATE(4396),
    [sym_preproc_line] = STATE(4396),
    [sym_preproc_pragma] = STATE(4396),
    [sym_preproc_nullable] = STATE(4396),
    [sym_preproc_error] = STATE(4396),
    [sym_preproc_define] = STATE(4396),
    [sym_preproc_undef] = STATE(4396),
    [anon_sym_LBRACK] = ACTIONS(6038),
    [anon_sym_COMMA] = ACTIONS(5510),
    [anon_sym_LPAREN] = ACTIONS(6008),
    [anon_sym_LT] = ACTIONS(6040),
    [anon_sym_GT] = ACTIONS(6040),
    [anon_sym_where] = ACTIONS(5510),
    [anon_sym_QMARK] = ACTIONS(6042),
    [anon_sym_BANG] = ACTIONS(6044),
    [anon_sym_PLUS_PLUS] = ACTIONS(6046),
    [anon_sym_DASH_DASH] = ACTIONS(6046),
    [anon_sym_PLUS] = ACTIONS(6048),
    [anon_sym_DASH] = ACTIONS(6048),
    [anon_sym_STAR] = ACTIONS(6050),
    [anon_sym_SLASH] = ACTIONS(6052),
    [anon_sym_PERCENT] = ACTIONS(6050),
    [anon_sym_CARET] = ACTIONS(6054),
    [anon_sym_PIPE] = ACTIONS(6056),
    [anon_sym_AMP] = ACTIONS(6058),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6062),
    [anon_sym_GT_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6064),
    [anon_sym_BANG_EQ] = ACTIONS(6064),
    [anon_sym_GT_EQ] = ACTIONS(6066),
    [anon_sym_LT_EQ] = ACTIONS(6066),
    [anon_sym_DOT] = ACTIONS(5165),
    [anon_sym_switch] = ACTIONS(6068),
    [anon_sym_DOT_DOT] = ACTIONS(6070),
    [anon_sym_and] = ACTIONS(5510),
    [anon_sym_or] = ACTIONS(5512),
    [anon_sym_AMP_AMP] = ACTIONS(6072),
    [anon_sym_PIPE_PIPE] = ACTIONS(6074),
    [anon_sym_QMARK_QMARK] = ACTIONS(6076),
    [anon_sym_from] = ACTIONS(5510),
    [anon_sym_into] = ACTIONS(5510),
    [anon_sym_join] = ACTIONS(5510),
    [anon_sym_let] = ACTIONS(5510),
    [anon_sym_orderby] = ACTIONS(5510),
    [anon_sym_ascending] = ACTIONS(5510),
    [anon_sym_descending] = ACTIONS(5510),
    [anon_sym_group] = ACTIONS(5510),
    [anon_sym_select] = ACTIONS(5510),
    [anon_sym_as] = ACTIONS(6078),
    [anon_sym_is] = ACTIONS(6080),
    [anon_sym_DASH_GT] = ACTIONS(5167),
    [anon_sym_with] = ACTIONS(6082),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4397] = {
    [sym_preproc_region] = STATE(4397),
    [sym_preproc_endregion] = STATE(4397),
    [sym_preproc_line] = STATE(4397),
    [sym_preproc_pragma] = STATE(4397),
    [sym_preproc_nullable] = STATE(4397),
    [sym_preproc_error] = STATE(4397),
    [sym_preproc_define] = STATE(4397),
    [sym_preproc_undef] = STATE(4397),
    [anon_sym_EQ] = ACTIONS(5900),
    [anon_sym_LBRACK] = ACTIONS(5249),
    [anon_sym_COMMA] = ACTIONS(5249),
    [anon_sym_LPAREN] = ACTIONS(5249),
    [anon_sym_RPAREN] = ACTIONS(5972),
    [anon_sym_LT] = ACTIONS(5251),
    [anon_sym_GT] = ACTIONS(5251),
    [anon_sym_QMARK] = ACTIONS(5251),
    [anon_sym_BANG] = ACTIONS(5251),
    [anon_sym_PLUS_PLUS] = ACTIONS(5249),
    [anon_sym_DASH_DASH] = ACTIONS(5249),
    [anon_sym_PLUS] = ACTIONS(5251),
    [anon_sym_DASH] = ACTIONS(5251),
    [anon_sym_STAR] = ACTIONS(5251),
    [anon_sym_SLASH] = ACTIONS(5251),
    [anon_sym_PERCENT] = ACTIONS(5251),
    [anon_sym_CARET] = ACTIONS(5251),
    [anon_sym_PIPE] = ACTIONS(5251),
    [anon_sym_AMP] = ACTIONS(5251),
    [anon_sym_LT_LT] = ACTIONS(5251),
    [anon_sym_GT_GT] = ACTIONS(5251),
    [anon_sym_GT_GT_GT] = ACTIONS(5251),
    [anon_sym_EQ_EQ] = ACTIONS(5249),
    [anon_sym_BANG_EQ] = ACTIONS(5249),
    [anon_sym_GT_EQ] = ACTIONS(5249),
    [anon_sym_LT_EQ] = ACTIONS(5249),
    [anon_sym_DOT] = ACTIONS(5251),
    [anon_sym_switch] = ACTIONS(5249),
    [anon_sym_DOT_DOT] = ACTIONS(5249),
    [anon_sym_PLUS_EQ] = ACTIONS(5902),
    [anon_sym_DASH_EQ] = ACTIONS(5902),
    [anon_sym_STAR_EQ] = ACTIONS(5902),
    [anon_sym_SLASH_EQ] = ACTIONS(5902),
    [anon_sym_PERCENT_EQ] = ACTIONS(5902),
    [anon_sym_AMP_EQ] = ACTIONS(5902),
    [anon_sym_CARET_EQ] = ACTIONS(5902),
    [anon_sym_PIPE_EQ] = ACTIONS(5902),
    [anon_sym_LT_LT_EQ] = ACTIONS(5902),
    [anon_sym_GT_GT_EQ] = ACTIONS(5902),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5902),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(5902),
    [anon_sym_AMP_AMP] = ACTIONS(5249),
    [anon_sym_PIPE_PIPE] = ACTIONS(5249),
    [anon_sym_QMARK_QMARK] = ACTIONS(5251),
    [anon_sym_as] = ACTIONS(5249),
    [anon_sym_is] = ACTIONS(5249),
    [anon_sym_DASH_GT] = ACTIONS(5249),
    [anon_sym_with] = ACTIONS(5249),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4398] = {
    [sym_argument_list] = STATE(4571),
    [sym_bracketed_argument_list] = STATE(3551),
    [sym_preproc_region] = STATE(4398),
    [sym_preproc_endregion] = STATE(4398),
    [sym_preproc_line] = STATE(4398),
    [sym_preproc_pragma] = STATE(4398),
    [sym_preproc_nullable] = STATE(4398),
    [sym_preproc_error] = STATE(4398),
    [sym_preproc_define] = STATE(4398),
    [sym_preproc_undef] = STATE(4398),
    [anon_sym_LBRACK] = ACTIONS(6038),
    [anon_sym_COMMA] = ACTIONS(6220),
    [anon_sym_LPAREN] = ACTIONS(6008),
    [anon_sym_LT] = ACTIONS(6040),
    [anon_sym_GT] = ACTIONS(6040),
    [anon_sym_where] = ACTIONS(6220),
    [anon_sym_QMARK] = ACTIONS(6042),
    [anon_sym_BANG] = ACTIONS(6044),
    [anon_sym_PLUS_PLUS] = ACTIONS(6046),
    [anon_sym_DASH_DASH] = ACTIONS(6046),
    [anon_sym_PLUS] = ACTIONS(6048),
    [anon_sym_DASH] = ACTIONS(6048),
    [anon_sym_STAR] = ACTIONS(6050),
    [anon_sym_SLASH] = ACTIONS(6052),
    [anon_sym_PERCENT] = ACTIONS(6050),
    [anon_sym_CARET] = ACTIONS(6054),
    [anon_sym_PIPE] = ACTIONS(6056),
    [anon_sym_AMP] = ACTIONS(6058),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6062),
    [anon_sym_GT_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6064),
    [anon_sym_BANG_EQ] = ACTIONS(6064),
    [anon_sym_GT_EQ] = ACTIONS(6066),
    [anon_sym_LT_EQ] = ACTIONS(6066),
    [anon_sym_DOT] = ACTIONS(5165),
    [anon_sym_switch] = ACTIONS(6068),
    [anon_sym_DOT_DOT] = ACTIONS(6070),
    [anon_sym_and] = ACTIONS(6220),
    [anon_sym_or] = ACTIONS(6222),
    [anon_sym_AMP_AMP] = ACTIONS(6072),
    [anon_sym_PIPE_PIPE] = ACTIONS(6074),
    [anon_sym_QMARK_QMARK] = ACTIONS(6076),
    [anon_sym_from] = ACTIONS(6220),
    [anon_sym_into] = ACTIONS(6220),
    [anon_sym_join] = ACTIONS(6220),
    [anon_sym_let] = ACTIONS(6220),
    [anon_sym_orderby] = ACTIONS(6220),
    [anon_sym_ascending] = ACTIONS(6220),
    [anon_sym_descending] = ACTIONS(6220),
    [anon_sym_group] = ACTIONS(6220),
    [anon_sym_select] = ACTIONS(6220),
    [anon_sym_as] = ACTIONS(6078),
    [anon_sym_is] = ACTIONS(6080),
    [anon_sym_DASH_GT] = ACTIONS(5167),
    [anon_sym_with] = ACTIONS(6082),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4399] = {
    [sym_preproc_region] = STATE(4399),
    [sym_preproc_endregion] = STATE(4399),
    [sym_preproc_line] = STATE(4399),
    [sym_preproc_pragma] = STATE(4399),
    [sym_preproc_nullable] = STATE(4399),
    [sym_preproc_error] = STATE(4399),
    [sym_preproc_define] = STATE(4399),
    [sym_preproc_undef] = STATE(4399),
    [anon_sym_EQ] = ACTIONS(6224),
    [anon_sym_LBRACK] = ACTIONS(5249),
    [anon_sym_LPAREN] = ACTIONS(5249),
    [anon_sym_LT] = ACTIONS(5251),
    [anon_sym_GT] = ACTIONS(5251),
    [anon_sym_QMARK] = ACTIONS(5251),
    [anon_sym_BANG] = ACTIONS(5251),
    [anon_sym_PLUS_PLUS] = ACTIONS(5249),
    [anon_sym_DASH_DASH] = ACTIONS(5249),
    [anon_sym_PLUS] = ACTIONS(5251),
    [anon_sym_DASH] = ACTIONS(5251),
    [anon_sym_STAR] = ACTIONS(5251),
    [anon_sym_SLASH] = ACTIONS(5251),
    [anon_sym_PERCENT] = ACTIONS(5251),
    [anon_sym_CARET] = ACTIONS(5251),
    [anon_sym_PIPE] = ACTIONS(5251),
    [anon_sym_AMP] = ACTIONS(5251),
    [anon_sym_LT_LT] = ACTIONS(5251),
    [anon_sym_GT_GT] = ACTIONS(5251),
    [anon_sym_GT_GT_GT] = ACTIONS(5251),
    [anon_sym_EQ_EQ] = ACTIONS(5249),
    [anon_sym_BANG_EQ] = ACTIONS(5249),
    [anon_sym_GT_EQ] = ACTIONS(5249),
    [anon_sym_LT_EQ] = ACTIONS(5249),
    [anon_sym_DOT] = ACTIONS(5251),
    [anon_sym_switch] = ACTIONS(5249),
    [anon_sym_DOT_DOT] = ACTIONS(5249),
    [anon_sym_PLUS_EQ] = ACTIONS(6226),
    [anon_sym_DASH_EQ] = ACTIONS(6226),
    [anon_sym_STAR_EQ] = ACTIONS(6226),
    [anon_sym_SLASH_EQ] = ACTIONS(6226),
    [anon_sym_PERCENT_EQ] = ACTIONS(6226),
    [anon_sym_AMP_EQ] = ACTIONS(6226),
    [anon_sym_CARET_EQ] = ACTIONS(6226),
    [anon_sym_PIPE_EQ] = ACTIONS(6226),
    [anon_sym_LT_LT_EQ] = ACTIONS(6226),
    [anon_sym_GT_GT_EQ] = ACTIONS(6226),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6226),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(6226),
    [anon_sym_AMP_AMP] = ACTIONS(5249),
    [anon_sym_PIPE_PIPE] = ACTIONS(5249),
    [anon_sym_QMARK_QMARK] = ACTIONS(5251),
    [anon_sym_into] = ACTIONS(5249),
    [anon_sym_by] = ACTIONS(5249),
    [anon_sym_as] = ACTIONS(5249),
    [anon_sym_is] = ACTIONS(5249),
    [anon_sym_DASH_GT] = ACTIONS(5249),
    [anon_sym_with] = ACTIONS(5249),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4400] = {
    [sym__name] = STATE(7762),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(8509),
    [sym_implicit_type] = STATE(8704),
    [sym_array_type] = STATE(8215),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9650),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(8704),
    [sym_scoped_type] = STATE(8704),
    [sym_tuple_type] = STATE(8180),
    [sym_identifier] = STATE(4921),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4400),
    [sym_preproc_endregion] = STATE(4400),
    [sym_preproc_line] = STATE(4400),
    [sym_preproc_pragma] = STATE(4400),
    [sym_preproc_nullable] = STATE(4400),
    [sym_preproc_error] = STATE(4400),
    [sym_preproc_define] = STATE(4400),
    [sym_preproc_undef] = STATE(4400),
    [aux_sym_type_argument_list_repeat1] = STATE(8533),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_COMMA] = ACTIONS(5655),
    [anon_sym_LPAREN] = ACTIONS(2995),
    [anon_sym_ref] = ACTIONS(5657),
    [anon_sym_delegate] = ACTIONS(5659),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_GT] = ACTIONS(6228),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(5665),
    [anon_sym_var] = ACTIONS(5284),
    [sym_predefined_type] = ACTIONS(5667),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4401] = {
    [sym_argument_list] = STATE(4571),
    [sym_bracketed_argument_list] = STATE(3551),
    [sym_preproc_region] = STATE(4401),
    [sym_preproc_endregion] = STATE(4401),
    [sym_preproc_line] = STATE(4401),
    [sym_preproc_pragma] = STATE(4401),
    [sym_preproc_nullable] = STATE(4401),
    [sym_preproc_error] = STATE(4401),
    [sym_preproc_define] = STATE(4401),
    [sym_preproc_undef] = STATE(4401),
    [anon_sym_LBRACK] = ACTIONS(6038),
    [anon_sym_COMMA] = ACTIONS(5420),
    [anon_sym_LPAREN] = ACTIONS(6008),
    [anon_sym_LT] = ACTIONS(6040),
    [anon_sym_GT] = ACTIONS(6040),
    [anon_sym_where] = ACTIONS(5420),
    [anon_sym_QMARK] = ACTIONS(6042),
    [anon_sym_BANG] = ACTIONS(6044),
    [anon_sym_PLUS_PLUS] = ACTIONS(6046),
    [anon_sym_DASH_DASH] = ACTIONS(6046),
    [anon_sym_PLUS] = ACTIONS(6048),
    [anon_sym_DASH] = ACTIONS(6048),
    [anon_sym_STAR] = ACTIONS(6050),
    [anon_sym_SLASH] = ACTIONS(6052),
    [anon_sym_PERCENT] = ACTIONS(6050),
    [anon_sym_CARET] = ACTIONS(6054),
    [anon_sym_PIPE] = ACTIONS(6056),
    [anon_sym_AMP] = ACTIONS(6058),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6062),
    [anon_sym_GT_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6064),
    [anon_sym_BANG_EQ] = ACTIONS(6064),
    [anon_sym_GT_EQ] = ACTIONS(6066),
    [anon_sym_LT_EQ] = ACTIONS(6066),
    [anon_sym_DOT] = ACTIONS(5165),
    [anon_sym_switch] = ACTIONS(6068),
    [anon_sym_DOT_DOT] = ACTIONS(6070),
    [anon_sym_and] = ACTIONS(5420),
    [anon_sym_or] = ACTIONS(5422),
    [anon_sym_AMP_AMP] = ACTIONS(6072),
    [anon_sym_PIPE_PIPE] = ACTIONS(6074),
    [anon_sym_QMARK_QMARK] = ACTIONS(6076),
    [anon_sym_from] = ACTIONS(5420),
    [anon_sym_into] = ACTIONS(5420),
    [anon_sym_join] = ACTIONS(5420),
    [anon_sym_let] = ACTIONS(5420),
    [anon_sym_orderby] = ACTIONS(5420),
    [anon_sym_ascending] = ACTIONS(5420),
    [anon_sym_descending] = ACTIONS(5420),
    [anon_sym_group] = ACTIONS(5420),
    [anon_sym_select] = ACTIONS(5420),
    [anon_sym_as] = ACTIONS(6078),
    [anon_sym_is] = ACTIONS(6080),
    [anon_sym_DASH_GT] = ACTIONS(5167),
    [anon_sym_with] = ACTIONS(6082),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4402] = {
    [sym_argument_list] = STATE(4571),
    [sym_bracketed_argument_list] = STATE(3551),
    [sym_preproc_region] = STATE(4402),
    [sym_preproc_endregion] = STATE(4402),
    [sym_preproc_line] = STATE(4402),
    [sym_preproc_pragma] = STATE(4402),
    [sym_preproc_nullable] = STATE(4402),
    [sym_preproc_error] = STATE(4402),
    [sym_preproc_define] = STATE(4402),
    [sym_preproc_undef] = STATE(4402),
    [anon_sym_LBRACK] = ACTIONS(6038),
    [anon_sym_COMMA] = ACTIONS(6230),
    [anon_sym_LPAREN] = ACTIONS(6008),
    [anon_sym_LT] = ACTIONS(6040),
    [anon_sym_GT] = ACTIONS(6040),
    [anon_sym_where] = ACTIONS(6230),
    [anon_sym_QMARK] = ACTIONS(6042),
    [anon_sym_BANG] = ACTIONS(6044),
    [anon_sym_PLUS_PLUS] = ACTIONS(6046),
    [anon_sym_DASH_DASH] = ACTIONS(6046),
    [anon_sym_PLUS] = ACTIONS(6048),
    [anon_sym_DASH] = ACTIONS(6048),
    [anon_sym_STAR] = ACTIONS(6050),
    [anon_sym_SLASH] = ACTIONS(6052),
    [anon_sym_PERCENT] = ACTIONS(6050),
    [anon_sym_CARET] = ACTIONS(6054),
    [anon_sym_PIPE] = ACTIONS(6056),
    [anon_sym_AMP] = ACTIONS(6058),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6062),
    [anon_sym_GT_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6064),
    [anon_sym_BANG_EQ] = ACTIONS(6064),
    [anon_sym_GT_EQ] = ACTIONS(6066),
    [anon_sym_LT_EQ] = ACTIONS(6066),
    [anon_sym_DOT] = ACTIONS(5165),
    [anon_sym_switch] = ACTIONS(6068),
    [anon_sym_DOT_DOT] = ACTIONS(6070),
    [anon_sym_and] = ACTIONS(6230),
    [anon_sym_or] = ACTIONS(6232),
    [anon_sym_AMP_AMP] = ACTIONS(6072),
    [anon_sym_PIPE_PIPE] = ACTIONS(6074),
    [anon_sym_QMARK_QMARK] = ACTIONS(6076),
    [anon_sym_from] = ACTIONS(6230),
    [anon_sym_into] = ACTIONS(6230),
    [anon_sym_join] = ACTIONS(6230),
    [anon_sym_let] = ACTIONS(6230),
    [anon_sym_orderby] = ACTIONS(6230),
    [anon_sym_ascending] = ACTIONS(6230),
    [anon_sym_descending] = ACTIONS(6230),
    [anon_sym_group] = ACTIONS(6230),
    [anon_sym_select] = ACTIONS(6230),
    [anon_sym_as] = ACTIONS(6078),
    [anon_sym_is] = ACTIONS(6080),
    [anon_sym_DASH_GT] = ACTIONS(5167),
    [anon_sym_with] = ACTIONS(6082),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4403] = {
    [sym_argument_list] = STATE(3818),
    [sym__name] = STATE(3925),
    [sym_alias_qualified_name] = STATE(3912),
    [sym__simple_name] = STATE(3912),
    [sym_qualified_name] = STATE(3912),
    [sym_generic_name] = STATE(3874),
    [sym_type] = STATE(3782),
    [sym_implicit_type] = STATE(3915),
    [sym_array_type] = STATE(3823),
    [sym__array_base_type] = STATE(8833),
    [sym_nullable_type] = STATE(3917),
    [sym_pointer_type] = STATE(3917),
    [sym__pointer_base_type] = STATE(9537),
    [sym_function_pointer_type] = STATE(3917),
    [sym_ref_type] = STATE(3915),
    [sym_scoped_type] = STATE(3915),
    [sym_tuple_type] = STATE(3918),
    [sym_identifier] = STATE(3787),
    [sym__reserved_identifier] = STATE(3838),
    [sym_preproc_region] = STATE(4403),
    [sym_preproc_endregion] = STATE(4403),
    [sym_preproc_line] = STATE(4403),
    [sym_preproc_pragma] = STATE(4403),
    [sym_preproc_nullable] = STATE(4403),
    [sym_preproc_error] = STATE(4403),
    [sym_preproc_define] = STATE(4403),
    [sym_preproc_undef] = STATE(4403),
    [sym__identifier_token] = ACTIONS(4157),
    [anon_sym_alias] = ACTIONS(4159),
    [anon_sym_global] = ACTIONS(4159),
    [anon_sym_LBRACK] = ACTIONS(6131),
    [anon_sym_LPAREN] = ACTIONS(6133),
    [anon_sym_ref] = ACTIONS(4161),
    [anon_sym_LBRACE] = ACTIONS(6135),
    [anon_sym_delegate] = ACTIONS(6137),
    [anon_sym_file] = ACTIONS(4159),
    [anon_sym_where] = ACTIONS(4159),
    [anon_sym_notnull] = ACTIONS(4159),
    [anon_sym_unmanaged] = ACTIONS(4159),
    [anon_sym_scoped] = ACTIONS(6234),
    [anon_sym_var] = ACTIONS(6141),
    [sym_predefined_type] = ACTIONS(6143),
    [anon_sym_yield] = ACTIONS(4159),
    [anon_sym_when] = ACTIONS(4159),
    [anon_sym_from] = ACTIONS(4159),
    [anon_sym_into] = ACTIONS(4159),
    [anon_sym_join] = ACTIONS(4159),
    [anon_sym_on] = ACTIONS(4159),
    [anon_sym_equals] = ACTIONS(4159),
    [anon_sym_let] = ACTIONS(4159),
    [anon_sym_orderby] = ACTIONS(4159),
    [anon_sym_ascending] = ACTIONS(4159),
    [anon_sym_descending] = ACTIONS(4159),
    [anon_sym_group] = ACTIONS(4159),
    [anon_sym_by] = ACTIONS(4159),
    [anon_sym_select] = ACTIONS(4159),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4404] = {
    [sym_argument_list] = STATE(4571),
    [sym_bracketed_argument_list] = STATE(3551),
    [sym_preproc_region] = STATE(4404),
    [sym_preproc_endregion] = STATE(4404),
    [sym_preproc_line] = STATE(4404),
    [sym_preproc_pragma] = STATE(4404),
    [sym_preproc_nullable] = STATE(4404),
    [sym_preproc_error] = STATE(4404),
    [sym_preproc_define] = STATE(4404),
    [sym_preproc_undef] = STATE(4404),
    [anon_sym_LBRACK] = ACTIONS(6038),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_LPAREN] = ACTIONS(6008),
    [anon_sym_LT] = ACTIONS(6040),
    [anon_sym_GT] = ACTIONS(6040),
    [anon_sym_where] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6042),
    [anon_sym_BANG] = ACTIONS(6044),
    [anon_sym_PLUS_PLUS] = ACTIONS(6046),
    [anon_sym_DASH_DASH] = ACTIONS(6046),
    [anon_sym_PLUS] = ACTIONS(6048),
    [anon_sym_DASH] = ACTIONS(6048),
    [anon_sym_STAR] = ACTIONS(6050),
    [anon_sym_SLASH] = ACTIONS(6052),
    [anon_sym_PERCENT] = ACTIONS(6050),
    [anon_sym_CARET] = ACTIONS(6054),
    [anon_sym_PIPE] = ACTIONS(6056),
    [anon_sym_AMP] = ACTIONS(6058),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6062),
    [anon_sym_GT_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6064),
    [anon_sym_BANG_EQ] = ACTIONS(6064),
    [anon_sym_GT_EQ] = ACTIONS(6066),
    [anon_sym_LT_EQ] = ACTIONS(6066),
    [anon_sym_DOT] = ACTIONS(5165),
    [anon_sym_switch] = ACTIONS(6068),
    [anon_sym_DOT_DOT] = ACTIONS(6070),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6238),
    [anon_sym_AMP_AMP] = ACTIONS(6072),
    [anon_sym_PIPE_PIPE] = ACTIONS(6074),
    [anon_sym_QMARK_QMARK] = ACTIONS(6076),
    [anon_sym_from] = ACTIONS(6236),
    [anon_sym_into] = ACTIONS(6236),
    [anon_sym_join] = ACTIONS(6236),
    [anon_sym_let] = ACTIONS(6236),
    [anon_sym_orderby] = ACTIONS(6236),
    [anon_sym_ascending] = ACTIONS(6236),
    [anon_sym_descending] = ACTIONS(6236),
    [anon_sym_group] = ACTIONS(6236),
    [anon_sym_select] = ACTIONS(6236),
    [anon_sym_as] = ACTIONS(6078),
    [anon_sym_is] = ACTIONS(6080),
    [anon_sym_DASH_GT] = ACTIONS(5167),
    [anon_sym_with] = ACTIONS(6082),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4405] = {
    [sym_argument_list] = STATE(3900),
    [sym__name] = STATE(4268),
    [sym_alias_qualified_name] = STATE(3955),
    [sym__simple_name] = STATE(3955),
    [sym_qualified_name] = STATE(3955),
    [sym_generic_name] = STATE(4047),
    [sym_type] = STATE(3847),
    [sym_implicit_type] = STATE(3954),
    [sym_array_type] = STATE(3986),
    [sym__array_base_type] = STATE(8755),
    [sym_nullable_type] = STATE(3937),
    [sym_pointer_type] = STATE(3937),
    [sym__pointer_base_type] = STATE(9763),
    [sym_function_pointer_type] = STATE(3937),
    [sym_ref_type] = STATE(3954),
    [sym_scoped_type] = STATE(3954),
    [sym_tuple_type] = STATE(3962),
    [sym_identifier] = STATE(3891),
    [sym__reserved_identifier] = STATE(3897),
    [sym_preproc_region] = STATE(4405),
    [sym_preproc_endregion] = STATE(4405),
    [sym_preproc_line] = STATE(4405),
    [sym_preproc_pragma] = STATE(4405),
    [sym_preproc_nullable] = STATE(4405),
    [sym_preproc_error] = STATE(4405),
    [sym_preproc_define] = STATE(4405),
    [sym_preproc_undef] = STATE(4405),
    [sym__identifier_token] = ACTIONS(4168),
    [anon_sym_alias] = ACTIONS(4170),
    [anon_sym_global] = ACTIONS(4170),
    [anon_sym_LBRACK] = ACTIONS(6200),
    [anon_sym_LPAREN] = ACTIONS(6202),
    [anon_sym_ref] = ACTIONS(4619),
    [anon_sym_LBRACE] = ACTIONS(6204),
    [anon_sym_delegate] = ACTIONS(6206),
    [anon_sym_file] = ACTIONS(4170),
    [anon_sym_where] = ACTIONS(4170),
    [anon_sym_notnull] = ACTIONS(4170),
    [anon_sym_unmanaged] = ACTIONS(4170),
    [anon_sym_scoped] = ACTIONS(6240),
    [anon_sym_var] = ACTIONS(6210),
    [sym_predefined_type] = ACTIONS(6212),
    [anon_sym_yield] = ACTIONS(4170),
    [anon_sym_when] = ACTIONS(4170),
    [anon_sym_from] = ACTIONS(4170),
    [anon_sym_into] = ACTIONS(4170),
    [anon_sym_join] = ACTIONS(4170),
    [anon_sym_on] = ACTIONS(4170),
    [anon_sym_equals] = ACTIONS(4170),
    [anon_sym_let] = ACTIONS(4170),
    [anon_sym_orderby] = ACTIONS(4170),
    [anon_sym_ascending] = ACTIONS(4170),
    [anon_sym_descending] = ACTIONS(4170),
    [anon_sym_group] = ACTIONS(4170),
    [anon_sym_by] = ACTIONS(4170),
    [anon_sym_select] = ACTIONS(4170),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4406] = {
    [sym_argument_list] = STATE(3545),
    [sym__name] = STATE(4952),
    [sym_alias_qualified_name] = STATE(3592),
    [sym__simple_name] = STATE(3592),
    [sym_qualified_name] = STATE(3592),
    [sym_generic_name] = STATE(3608),
    [sym_type] = STATE(3535),
    [sym_implicit_type] = STATE(3569),
    [sym_array_type] = STATE(4832),
    [sym__array_base_type] = STATE(8879),
    [sym_nullable_type] = STATE(3585),
    [sym_pointer_type] = STATE(3585),
    [sym__pointer_base_type] = STATE(9439),
    [sym_function_pointer_type] = STATE(3585),
    [sym_ref_type] = STATE(3569),
    [sym_scoped_type] = STATE(3569),
    [sym_tuple_type] = STATE(3583),
    [sym_identifier] = STATE(4643),
    [sym__reserved_identifier] = STATE(3558),
    [sym_preproc_region] = STATE(4406),
    [sym_preproc_endregion] = STATE(4406),
    [sym_preproc_line] = STATE(4406),
    [sym_preproc_pragma] = STATE(4406),
    [sym_preproc_nullable] = STATE(4406),
    [sym_preproc_error] = STATE(4406),
    [sym_preproc_define] = STATE(4406),
    [sym_preproc_undef] = STATE(4406),
    [sym__identifier_token] = ACTIONS(4225),
    [anon_sym_alias] = ACTIONS(4227),
    [anon_sym_global] = ACTIONS(4227),
    [anon_sym_LBRACK] = ACTIONS(6159),
    [anon_sym_LPAREN] = ACTIONS(6161),
    [anon_sym_ref] = ACTIONS(4584),
    [anon_sym_LBRACE] = ACTIONS(6163),
    [anon_sym_delegate] = ACTIONS(6165),
    [anon_sym_file] = ACTIONS(4227),
    [anon_sym_where] = ACTIONS(4227),
    [anon_sym_notnull] = ACTIONS(4227),
    [anon_sym_unmanaged] = ACTIONS(4227),
    [anon_sym_scoped] = ACTIONS(6242),
    [anon_sym_var] = ACTIONS(6169),
    [sym_predefined_type] = ACTIONS(6171),
    [anon_sym_yield] = ACTIONS(4227),
    [anon_sym_when] = ACTIONS(4227),
    [anon_sym_from] = ACTIONS(4227),
    [anon_sym_into] = ACTIONS(4227),
    [anon_sym_join] = ACTIONS(4227),
    [anon_sym_on] = ACTIONS(4227),
    [anon_sym_equals] = ACTIONS(4227),
    [anon_sym_let] = ACTIONS(4227),
    [anon_sym_orderby] = ACTIONS(4227),
    [anon_sym_ascending] = ACTIONS(4227),
    [anon_sym_descending] = ACTIONS(4227),
    [anon_sym_group] = ACTIONS(4227),
    [anon_sym_by] = ACTIONS(4227),
    [anon_sym_select] = ACTIONS(4227),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4407] = {
    [sym_argument_list] = STATE(3818),
    [sym__name] = STATE(3925),
    [sym_alias_qualified_name] = STATE(3912),
    [sym__simple_name] = STATE(3912),
    [sym_qualified_name] = STATE(3912),
    [sym_generic_name] = STATE(3874),
    [sym_type] = STATE(3782),
    [sym_implicit_type] = STATE(3915),
    [sym_array_type] = STATE(3823),
    [sym__array_base_type] = STATE(8833),
    [sym_nullable_type] = STATE(3917),
    [sym_pointer_type] = STATE(3917),
    [sym__pointer_base_type] = STATE(9537),
    [sym_function_pointer_type] = STATE(3917),
    [sym_ref_type] = STATE(3915),
    [sym_scoped_type] = STATE(3915),
    [sym_tuple_type] = STATE(3918),
    [sym_identifier] = STATE(3787),
    [sym__reserved_identifier] = STATE(3838),
    [sym_preproc_region] = STATE(4407),
    [sym_preproc_endregion] = STATE(4407),
    [sym_preproc_line] = STATE(4407),
    [sym_preproc_pragma] = STATE(4407),
    [sym_preproc_nullable] = STATE(4407),
    [sym_preproc_error] = STATE(4407),
    [sym_preproc_define] = STATE(4407),
    [sym_preproc_undef] = STATE(4407),
    [sym__identifier_token] = ACTIONS(4157),
    [anon_sym_alias] = ACTIONS(4159),
    [anon_sym_global] = ACTIONS(4159),
    [anon_sym_LBRACK] = ACTIONS(6131),
    [anon_sym_LPAREN] = ACTIONS(6133),
    [anon_sym_ref] = ACTIONS(4463),
    [anon_sym_LBRACE] = ACTIONS(6135),
    [anon_sym_delegate] = ACTIONS(6137),
    [anon_sym_file] = ACTIONS(4159),
    [anon_sym_where] = ACTIONS(4159),
    [anon_sym_notnull] = ACTIONS(4159),
    [anon_sym_unmanaged] = ACTIONS(4159),
    [anon_sym_scoped] = ACTIONS(6244),
    [anon_sym_var] = ACTIONS(6141),
    [sym_predefined_type] = ACTIONS(6143),
    [anon_sym_yield] = ACTIONS(4159),
    [anon_sym_when] = ACTIONS(4159),
    [anon_sym_from] = ACTIONS(4159),
    [anon_sym_into] = ACTIONS(4159),
    [anon_sym_join] = ACTIONS(4159),
    [anon_sym_on] = ACTIONS(4159),
    [anon_sym_equals] = ACTIONS(4159),
    [anon_sym_let] = ACTIONS(4159),
    [anon_sym_orderby] = ACTIONS(4159),
    [anon_sym_ascending] = ACTIONS(4159),
    [anon_sym_descending] = ACTIONS(4159),
    [anon_sym_group] = ACTIONS(4159),
    [anon_sym_by] = ACTIONS(4159),
    [anon_sym_select] = ACTIONS(4159),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4408] = {
    [sym__name] = STATE(7762),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(8623),
    [sym_implicit_type] = STATE(8704),
    [sym_array_type] = STATE(8215),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9650),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(8704),
    [sym_scoped_type] = STATE(8704),
    [sym_tuple_type] = STATE(8180),
    [sym_identifier] = STATE(4921),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4408),
    [sym_preproc_endregion] = STATE(4408),
    [sym_preproc_line] = STATE(4408),
    [sym_preproc_pragma] = STATE(4408),
    [sym_preproc_nullable] = STATE(4408),
    [sym_preproc_error] = STATE(4408),
    [sym_preproc_define] = STATE(4408),
    [sym_preproc_undef] = STATE(4408),
    [aux_sym_type_argument_list_repeat1] = STATE(8628),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_COMMA] = ACTIONS(5655),
    [anon_sym_LPAREN] = ACTIONS(2995),
    [anon_sym_ref] = ACTIONS(5657),
    [anon_sym_delegate] = ACTIONS(5659),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_GT] = ACTIONS(6246),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(5665),
    [anon_sym_var] = ACTIONS(5284),
    [sym_predefined_type] = ACTIONS(5667),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4409] = {
    [sym__name] = STATE(7762),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(8370),
    [sym_implicit_type] = STATE(8704),
    [sym_array_type] = STATE(8215),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9650),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(8704),
    [sym_scoped_type] = STATE(8704),
    [sym_tuple_type] = STATE(8180),
    [sym_identifier] = STATE(4921),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4409),
    [sym_preproc_endregion] = STATE(4409),
    [sym_preproc_line] = STATE(4409),
    [sym_preproc_pragma] = STATE(4409),
    [sym_preproc_nullable] = STATE(4409),
    [sym_preproc_error] = STATE(4409),
    [sym_preproc_define] = STATE(4409),
    [sym_preproc_undef] = STATE(4409),
    [aux_sym_type_argument_list_repeat1] = STATE(8369),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_COMMA] = ACTIONS(5655),
    [anon_sym_LPAREN] = ACTIONS(2995),
    [anon_sym_ref] = ACTIONS(5657),
    [anon_sym_delegate] = ACTIONS(5659),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_GT] = ACTIONS(6248),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(5665),
    [anon_sym_var] = ACTIONS(5284),
    [sym_predefined_type] = ACTIONS(5667),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4410] = {
    [sym_argument_list] = STATE(3545),
    [sym__name] = STATE(4328),
    [sym_alias_qualified_name] = STATE(3592),
    [sym__simple_name] = STATE(3592),
    [sym_qualified_name] = STATE(3592),
    [sym_generic_name] = STATE(3608),
    [sym_type] = STATE(3535),
    [sym_implicit_type] = STATE(3569),
    [sym_array_type] = STATE(4170),
    [sym__array_base_type] = STATE(8879),
    [sym_nullable_type] = STATE(3585),
    [sym_pointer_type] = STATE(3585),
    [sym__pointer_base_type] = STATE(9439),
    [sym_function_pointer_type] = STATE(3585),
    [sym_ref_type] = STATE(3569),
    [sym_scoped_type] = STATE(3569),
    [sym_tuple_type] = STATE(3583),
    [sym_identifier] = STATE(3989),
    [sym__reserved_identifier] = STATE(3558),
    [sym_preproc_region] = STATE(4410),
    [sym_preproc_endregion] = STATE(4410),
    [sym_preproc_line] = STATE(4410),
    [sym_preproc_pragma] = STATE(4410),
    [sym_preproc_nullable] = STATE(4410),
    [sym_preproc_error] = STATE(4410),
    [sym_preproc_define] = STATE(4410),
    [sym_preproc_undef] = STATE(4410),
    [sym__identifier_token] = ACTIONS(4225),
    [anon_sym_alias] = ACTIONS(4227),
    [anon_sym_global] = ACTIONS(4227),
    [anon_sym_LBRACK] = ACTIONS(6159),
    [anon_sym_LPAREN] = ACTIONS(6161),
    [anon_sym_ref] = ACTIONS(4651),
    [anon_sym_LBRACE] = ACTIONS(6163),
    [anon_sym_delegate] = ACTIONS(6165),
    [anon_sym_file] = ACTIONS(4227),
    [anon_sym_where] = ACTIONS(4227),
    [anon_sym_notnull] = ACTIONS(4227),
    [anon_sym_unmanaged] = ACTIONS(4227),
    [anon_sym_scoped] = ACTIONS(6250),
    [anon_sym_var] = ACTIONS(6169),
    [sym_predefined_type] = ACTIONS(6171),
    [anon_sym_yield] = ACTIONS(4227),
    [anon_sym_when] = ACTIONS(4227),
    [anon_sym_from] = ACTIONS(4227),
    [anon_sym_into] = ACTIONS(4227),
    [anon_sym_join] = ACTIONS(4227),
    [anon_sym_on] = ACTIONS(4227),
    [anon_sym_equals] = ACTIONS(4227),
    [anon_sym_let] = ACTIONS(4227),
    [anon_sym_orderby] = ACTIONS(4227),
    [anon_sym_ascending] = ACTIONS(4227),
    [anon_sym_descending] = ACTIONS(4227),
    [anon_sym_group] = ACTIONS(4227),
    [anon_sym_by] = ACTIONS(4227),
    [anon_sym_select] = ACTIONS(4227),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4411] = {
    [sym_argument_list] = STATE(3545),
    [sym__name] = STATE(4328),
    [sym_alias_qualified_name] = STATE(3592),
    [sym__simple_name] = STATE(3592),
    [sym_qualified_name] = STATE(3592),
    [sym_generic_name] = STATE(3608),
    [sym_type] = STATE(3535),
    [sym_implicit_type] = STATE(3569),
    [sym_array_type] = STATE(4170),
    [sym__array_base_type] = STATE(8879),
    [sym_nullable_type] = STATE(3585),
    [sym_pointer_type] = STATE(3585),
    [sym__pointer_base_type] = STATE(9439),
    [sym_function_pointer_type] = STATE(3585),
    [sym_ref_type] = STATE(3569),
    [sym_scoped_type] = STATE(3569),
    [sym_tuple_type] = STATE(3583),
    [sym_identifier] = STATE(3989),
    [sym__reserved_identifier] = STATE(3558),
    [sym_preproc_region] = STATE(4411),
    [sym_preproc_endregion] = STATE(4411),
    [sym_preproc_line] = STATE(4411),
    [sym_preproc_pragma] = STATE(4411),
    [sym_preproc_nullable] = STATE(4411),
    [sym_preproc_error] = STATE(4411),
    [sym_preproc_define] = STATE(4411),
    [sym_preproc_undef] = STATE(4411),
    [sym__identifier_token] = ACTIONS(4225),
    [anon_sym_alias] = ACTIONS(4227),
    [anon_sym_global] = ACTIONS(4227),
    [anon_sym_LBRACK] = ACTIONS(6159),
    [anon_sym_LPAREN] = ACTIONS(6161),
    [anon_sym_ref] = ACTIONS(4659),
    [anon_sym_LBRACE] = ACTIONS(6163),
    [anon_sym_delegate] = ACTIONS(6165),
    [anon_sym_file] = ACTIONS(4227),
    [anon_sym_where] = ACTIONS(4227),
    [anon_sym_notnull] = ACTIONS(4227),
    [anon_sym_unmanaged] = ACTIONS(4227),
    [anon_sym_scoped] = ACTIONS(6252),
    [anon_sym_var] = ACTIONS(6169),
    [sym_predefined_type] = ACTIONS(6171),
    [anon_sym_yield] = ACTIONS(4227),
    [anon_sym_when] = ACTIONS(4227),
    [anon_sym_from] = ACTIONS(4227),
    [anon_sym_into] = ACTIONS(4227),
    [anon_sym_join] = ACTIONS(4227),
    [anon_sym_on] = ACTIONS(4227),
    [anon_sym_equals] = ACTIONS(4227),
    [anon_sym_let] = ACTIONS(4227),
    [anon_sym_orderby] = ACTIONS(4227),
    [anon_sym_ascending] = ACTIONS(4227),
    [anon_sym_descending] = ACTIONS(4227),
    [anon_sym_group] = ACTIONS(4227),
    [anon_sym_by] = ACTIONS(4227),
    [anon_sym_select] = ACTIONS(4227),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4412] = {
    [sym_argument_list] = STATE(3900),
    [sym__name] = STATE(4268),
    [sym_alias_qualified_name] = STATE(3955),
    [sym__simple_name] = STATE(3955),
    [sym_qualified_name] = STATE(3955),
    [sym_generic_name] = STATE(4047),
    [sym_type] = STATE(3847),
    [sym_implicit_type] = STATE(3954),
    [sym_array_type] = STATE(3986),
    [sym__array_base_type] = STATE(8755),
    [sym_nullable_type] = STATE(3937),
    [sym_pointer_type] = STATE(3937),
    [sym__pointer_base_type] = STATE(9763),
    [sym_function_pointer_type] = STATE(3937),
    [sym_ref_type] = STATE(3954),
    [sym_scoped_type] = STATE(3954),
    [sym_tuple_type] = STATE(3962),
    [sym_identifier] = STATE(3891),
    [sym__reserved_identifier] = STATE(3897),
    [sym_preproc_region] = STATE(4412),
    [sym_preproc_endregion] = STATE(4412),
    [sym_preproc_line] = STATE(4412),
    [sym_preproc_pragma] = STATE(4412),
    [sym_preproc_nullable] = STATE(4412),
    [sym_preproc_error] = STATE(4412),
    [sym_preproc_define] = STATE(4412),
    [sym_preproc_undef] = STATE(4412),
    [sym__identifier_token] = ACTIONS(4168),
    [anon_sym_alias] = ACTIONS(4170),
    [anon_sym_global] = ACTIONS(4170),
    [anon_sym_LBRACK] = ACTIONS(6200),
    [anon_sym_LPAREN] = ACTIONS(6202),
    [anon_sym_ref] = ACTIONS(4598),
    [anon_sym_LBRACE] = ACTIONS(6204),
    [anon_sym_delegate] = ACTIONS(6206),
    [anon_sym_file] = ACTIONS(4170),
    [anon_sym_where] = ACTIONS(4170),
    [anon_sym_notnull] = ACTIONS(4170),
    [anon_sym_unmanaged] = ACTIONS(4170),
    [anon_sym_scoped] = ACTIONS(6254),
    [anon_sym_var] = ACTIONS(6210),
    [sym_predefined_type] = ACTIONS(6212),
    [anon_sym_yield] = ACTIONS(4170),
    [anon_sym_when] = ACTIONS(4170),
    [anon_sym_from] = ACTIONS(4170),
    [anon_sym_into] = ACTIONS(4170),
    [anon_sym_join] = ACTIONS(4170),
    [anon_sym_on] = ACTIONS(4170),
    [anon_sym_equals] = ACTIONS(4170),
    [anon_sym_let] = ACTIONS(4170),
    [anon_sym_orderby] = ACTIONS(4170),
    [anon_sym_ascending] = ACTIONS(4170),
    [anon_sym_descending] = ACTIONS(4170),
    [anon_sym_group] = ACTIONS(4170),
    [anon_sym_by] = ACTIONS(4170),
    [anon_sym_select] = ACTIONS(4170),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4413] = {
    [sym_preproc_region] = STATE(4413),
    [sym_preproc_endregion] = STATE(4413),
    [sym_preproc_line] = STATE(4413),
    [sym_preproc_pragma] = STATE(4413),
    [sym_preproc_nullable] = STATE(4413),
    [sym_preproc_error] = STATE(4413),
    [sym_preproc_define] = STATE(4413),
    [sym_preproc_undef] = STATE(4413),
    [anon_sym_EQ] = ACTIONS(6256),
    [anon_sym_LBRACK] = ACTIONS(5249),
    [anon_sym_LPAREN] = ACTIONS(5249),
    [anon_sym_LT] = ACTIONS(5251),
    [anon_sym_GT] = ACTIONS(5251),
    [anon_sym_QMARK] = ACTIONS(5251),
    [anon_sym_BANG] = ACTIONS(5251),
    [anon_sym_PLUS_PLUS] = ACTIONS(5249),
    [anon_sym_DASH_DASH] = ACTIONS(5249),
    [anon_sym_PLUS] = ACTIONS(5251),
    [anon_sym_DASH] = ACTIONS(5251),
    [anon_sym_STAR] = ACTIONS(5251),
    [anon_sym_SLASH] = ACTIONS(5251),
    [anon_sym_PERCENT] = ACTIONS(5251),
    [anon_sym_CARET] = ACTIONS(5251),
    [anon_sym_PIPE] = ACTIONS(5251),
    [anon_sym_AMP] = ACTIONS(5251),
    [anon_sym_LT_LT] = ACTIONS(5251),
    [anon_sym_GT_GT] = ACTIONS(5251),
    [anon_sym_GT_GT_GT] = ACTIONS(5251),
    [anon_sym_EQ_EQ] = ACTIONS(5249),
    [anon_sym_BANG_EQ] = ACTIONS(5249),
    [anon_sym_GT_EQ] = ACTIONS(5249),
    [anon_sym_LT_EQ] = ACTIONS(5249),
    [anon_sym_DOT] = ACTIONS(5251),
    [anon_sym_switch] = ACTIONS(5249),
    [anon_sym_DOT_DOT] = ACTIONS(5249),
    [anon_sym_PLUS_EQ] = ACTIONS(6258),
    [anon_sym_DASH_EQ] = ACTIONS(6258),
    [anon_sym_STAR_EQ] = ACTIONS(6258),
    [anon_sym_SLASH_EQ] = ACTIONS(6258),
    [anon_sym_PERCENT_EQ] = ACTIONS(6258),
    [anon_sym_AMP_EQ] = ACTIONS(6258),
    [anon_sym_CARET_EQ] = ACTIONS(6258),
    [anon_sym_PIPE_EQ] = ACTIONS(6258),
    [anon_sym_LT_LT_EQ] = ACTIONS(6258),
    [anon_sym_GT_GT_EQ] = ACTIONS(6258),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6258),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(6258),
    [anon_sym_AMP_AMP] = ACTIONS(5249),
    [anon_sym_PIPE_PIPE] = ACTIONS(5249),
    [anon_sym_QMARK_QMARK] = ACTIONS(5251),
    [anon_sym_into] = ACTIONS(5249),
    [anon_sym_equals] = ACTIONS(5249),
    [anon_sym_as] = ACTIONS(5249),
    [anon_sym_is] = ACTIONS(5249),
    [anon_sym_DASH_GT] = ACTIONS(5249),
    [anon_sym_with] = ACTIONS(5249),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4414] = {
    [sym_argument_list] = STATE(3900),
    [sym__name] = STATE(4268),
    [sym_alias_qualified_name] = STATE(3955),
    [sym__simple_name] = STATE(3955),
    [sym_qualified_name] = STATE(3955),
    [sym_generic_name] = STATE(4047),
    [sym_type] = STATE(3847),
    [sym_implicit_type] = STATE(3954),
    [sym_array_type] = STATE(3986),
    [sym__array_base_type] = STATE(8755),
    [sym_nullable_type] = STATE(3937),
    [sym_pointer_type] = STATE(3937),
    [sym__pointer_base_type] = STATE(9763),
    [sym_function_pointer_type] = STATE(3937),
    [sym_ref_type] = STATE(3954),
    [sym_scoped_type] = STATE(3954),
    [sym_tuple_type] = STATE(3962),
    [sym_identifier] = STATE(3891),
    [sym__reserved_identifier] = STATE(3897),
    [sym_preproc_region] = STATE(4414),
    [sym_preproc_endregion] = STATE(4414),
    [sym_preproc_line] = STATE(4414),
    [sym_preproc_pragma] = STATE(4414),
    [sym_preproc_nullable] = STATE(4414),
    [sym_preproc_error] = STATE(4414),
    [sym_preproc_define] = STATE(4414),
    [sym_preproc_undef] = STATE(4414),
    [sym__identifier_token] = ACTIONS(4168),
    [anon_sym_alias] = ACTIONS(4170),
    [anon_sym_global] = ACTIONS(4170),
    [anon_sym_LBRACK] = ACTIONS(6200),
    [anon_sym_LPAREN] = ACTIONS(6202),
    [anon_sym_ref] = ACTIONS(4592),
    [anon_sym_LBRACE] = ACTIONS(6204),
    [anon_sym_delegate] = ACTIONS(6206),
    [anon_sym_file] = ACTIONS(4170),
    [anon_sym_where] = ACTIONS(4170),
    [anon_sym_notnull] = ACTIONS(4170),
    [anon_sym_unmanaged] = ACTIONS(4170),
    [anon_sym_scoped] = ACTIONS(6260),
    [anon_sym_var] = ACTIONS(6210),
    [sym_predefined_type] = ACTIONS(6212),
    [anon_sym_yield] = ACTIONS(4170),
    [anon_sym_when] = ACTIONS(4170),
    [anon_sym_from] = ACTIONS(4170),
    [anon_sym_into] = ACTIONS(4170),
    [anon_sym_join] = ACTIONS(4170),
    [anon_sym_on] = ACTIONS(4170),
    [anon_sym_equals] = ACTIONS(4170),
    [anon_sym_let] = ACTIONS(4170),
    [anon_sym_orderby] = ACTIONS(4170),
    [anon_sym_ascending] = ACTIONS(4170),
    [anon_sym_descending] = ACTIONS(4170),
    [anon_sym_group] = ACTIONS(4170),
    [anon_sym_by] = ACTIONS(4170),
    [anon_sym_select] = ACTIONS(4170),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4415] = {
    [sym_argument_list] = STATE(4344),
    [sym__name] = STATE(3002),
    [sym_alias_qualified_name] = STATE(2977),
    [sym__simple_name] = STATE(2977),
    [sym_qualified_name] = STATE(2977),
    [sym_generic_name] = STATE(2956),
    [sym_type] = STATE(4319),
    [sym_implicit_type] = STATE(2898),
    [sym_array_type] = STATE(4379),
    [sym__array_base_type] = STATE(8712),
    [sym_nullable_type] = STATE(2974),
    [sym_pointer_type] = STATE(2974),
    [sym__pointer_base_type] = STATE(9721),
    [sym_function_pointer_type] = STATE(2974),
    [sym_ref_type] = STATE(2898),
    [sym_scoped_type] = STATE(2898),
    [sym_tuple_type] = STATE(2973),
    [sym_identifier] = STATE(2913),
    [sym__reserved_identifier] = STATE(2914),
    [sym_preproc_region] = STATE(4415),
    [sym_preproc_endregion] = STATE(4415),
    [sym_preproc_line] = STATE(4415),
    [sym_preproc_pragma] = STATE(4415),
    [sym_preproc_nullable] = STATE(4415),
    [sym_preproc_error] = STATE(4415),
    [sym_preproc_define] = STATE(4415),
    [sym_preproc_undef] = STATE(4415),
    [sym__identifier_token] = ACTIONS(4490),
    [anon_sym_alias] = ACTIONS(4492),
    [anon_sym_global] = ACTIONS(4492),
    [anon_sym_LBRACK] = ACTIONS(6145),
    [anon_sym_LPAREN] = ACTIONS(6147),
    [anon_sym_ref] = ACTIONS(4494),
    [anon_sym_LBRACE] = ACTIONS(6149),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_file] = ACTIONS(4492),
    [anon_sym_where] = ACTIONS(4492),
    [anon_sym_notnull] = ACTIONS(4492),
    [anon_sym_unmanaged] = ACTIONS(4492),
    [anon_sym_scoped] = ACTIONS(6262),
    [anon_sym_var] = ACTIONS(6153),
    [sym_predefined_type] = ACTIONS(6155),
    [anon_sym_yield] = ACTIONS(4492),
    [anon_sym_when] = ACTIONS(4492),
    [anon_sym_from] = ACTIONS(4492),
    [anon_sym_into] = ACTIONS(4492),
    [anon_sym_join] = ACTIONS(4492),
    [anon_sym_on] = ACTIONS(4492),
    [anon_sym_equals] = ACTIONS(4492),
    [anon_sym_let] = ACTIONS(4492),
    [anon_sym_orderby] = ACTIONS(4492),
    [anon_sym_ascending] = ACTIONS(4492),
    [anon_sym_descending] = ACTIONS(4492),
    [anon_sym_group] = ACTIONS(4492),
    [anon_sym_by] = ACTIONS(4492),
    [anon_sym_select] = ACTIONS(4492),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4416] = {
    [sym_preproc_region] = STATE(4416),
    [sym_preproc_endregion] = STATE(4416),
    [sym_preproc_line] = STATE(4416),
    [sym_preproc_pragma] = STATE(4416),
    [sym_preproc_nullable] = STATE(4416),
    [sym_preproc_error] = STATE(4416),
    [sym_preproc_define] = STATE(4416),
    [sym_preproc_undef] = STATE(4416),
    [anon_sym_EQ] = ACTIONS(6264),
    [anon_sym_LBRACK] = ACTIONS(5249),
    [anon_sym_LPAREN] = ACTIONS(5249),
    [anon_sym_LT] = ACTIONS(5251),
    [anon_sym_GT] = ACTIONS(5251),
    [anon_sym_QMARK] = ACTIONS(5251),
    [anon_sym_BANG] = ACTIONS(5251),
    [anon_sym_PLUS_PLUS] = ACTIONS(5249),
    [anon_sym_DASH_DASH] = ACTIONS(5249),
    [anon_sym_PLUS] = ACTIONS(5251),
    [anon_sym_DASH] = ACTIONS(5251),
    [anon_sym_STAR] = ACTIONS(5251),
    [anon_sym_SLASH] = ACTIONS(5251),
    [anon_sym_PERCENT] = ACTIONS(5251),
    [anon_sym_CARET] = ACTIONS(5251),
    [anon_sym_PIPE] = ACTIONS(5251),
    [anon_sym_AMP] = ACTIONS(5251),
    [anon_sym_LT_LT] = ACTIONS(5251),
    [anon_sym_GT_GT] = ACTIONS(5251),
    [anon_sym_GT_GT_GT] = ACTIONS(5251),
    [anon_sym_EQ_EQ] = ACTIONS(5249),
    [anon_sym_BANG_EQ] = ACTIONS(5249),
    [anon_sym_GT_EQ] = ACTIONS(5249),
    [anon_sym_LT_EQ] = ACTIONS(5249),
    [anon_sym_DOT] = ACTIONS(5251),
    [anon_sym_switch] = ACTIONS(5249),
    [anon_sym_DOT_DOT] = ACTIONS(5249),
    [anon_sym_PLUS_EQ] = ACTIONS(6266),
    [anon_sym_DASH_EQ] = ACTIONS(6266),
    [anon_sym_STAR_EQ] = ACTIONS(6266),
    [anon_sym_SLASH_EQ] = ACTIONS(6266),
    [anon_sym_PERCENT_EQ] = ACTIONS(6266),
    [anon_sym_AMP_EQ] = ACTIONS(6266),
    [anon_sym_CARET_EQ] = ACTIONS(6266),
    [anon_sym_PIPE_EQ] = ACTIONS(6266),
    [anon_sym_LT_LT_EQ] = ACTIONS(6266),
    [anon_sym_GT_GT_EQ] = ACTIONS(6266),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6266),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(6266),
    [anon_sym_AMP_AMP] = ACTIONS(5249),
    [anon_sym_PIPE_PIPE] = ACTIONS(5249),
    [anon_sym_QMARK_QMARK] = ACTIONS(5251),
    [anon_sym_into] = ACTIONS(5249),
    [anon_sym_on] = ACTIONS(5249),
    [anon_sym_as] = ACTIONS(5249),
    [anon_sym_is] = ACTIONS(5249),
    [anon_sym_DASH_GT] = ACTIONS(5249),
    [anon_sym_with] = ACTIONS(5249),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4417] = {
    [sym__name] = STATE(7762),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(8476),
    [sym_implicit_type] = STATE(8704),
    [sym_array_type] = STATE(8215),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9650),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(8704),
    [sym_scoped_type] = STATE(8704),
    [sym_tuple_type] = STATE(8180),
    [sym_identifier] = STATE(4921),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4417),
    [sym_preproc_endregion] = STATE(4417),
    [sym_preproc_line] = STATE(4417),
    [sym_preproc_pragma] = STATE(4417),
    [sym_preproc_nullable] = STATE(4417),
    [sym_preproc_error] = STATE(4417),
    [sym_preproc_define] = STATE(4417),
    [sym_preproc_undef] = STATE(4417),
    [aux_sym_type_argument_list_repeat1] = STATE(8480),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_COMMA] = ACTIONS(5655),
    [anon_sym_LPAREN] = ACTIONS(2995),
    [anon_sym_ref] = ACTIONS(5657),
    [anon_sym_delegate] = ACTIONS(5659),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_GT] = ACTIONS(6268),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(5665),
    [anon_sym_var] = ACTIONS(5284),
    [sym_predefined_type] = ACTIONS(5667),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4418] = {
    [sym_preproc_region] = STATE(4418),
    [sym_preproc_endregion] = STATE(4418),
    [sym_preproc_line] = STATE(4418),
    [sym_preproc_pragma] = STATE(4418),
    [sym_preproc_nullable] = STATE(4418),
    [sym_preproc_error] = STATE(4418),
    [sym_preproc_define] = STATE(4418),
    [sym_preproc_undef] = STATE(4418),
    [anon_sym_EQ] = ACTIONS(5900),
    [anon_sym_LBRACK] = ACTIONS(5249),
    [anon_sym_COMMA] = ACTIONS(5249),
    [anon_sym_LPAREN] = ACTIONS(5249),
    [anon_sym_RPAREN] = ACTIONS(6270),
    [anon_sym_LT] = ACTIONS(5251),
    [anon_sym_GT] = ACTIONS(5251),
    [anon_sym_QMARK] = ACTIONS(5251),
    [anon_sym_BANG] = ACTIONS(5251),
    [anon_sym_PLUS_PLUS] = ACTIONS(5249),
    [anon_sym_DASH_DASH] = ACTIONS(5249),
    [anon_sym_PLUS] = ACTIONS(5251),
    [anon_sym_DASH] = ACTIONS(5251),
    [anon_sym_STAR] = ACTIONS(5251),
    [anon_sym_SLASH] = ACTIONS(5251),
    [anon_sym_PERCENT] = ACTIONS(5251),
    [anon_sym_CARET] = ACTIONS(5251),
    [anon_sym_PIPE] = ACTIONS(5251),
    [anon_sym_AMP] = ACTIONS(5251),
    [anon_sym_LT_LT] = ACTIONS(5251),
    [anon_sym_GT_GT] = ACTIONS(5251),
    [anon_sym_GT_GT_GT] = ACTIONS(5251),
    [anon_sym_EQ_EQ] = ACTIONS(5249),
    [anon_sym_BANG_EQ] = ACTIONS(5249),
    [anon_sym_GT_EQ] = ACTIONS(5249),
    [anon_sym_LT_EQ] = ACTIONS(5249),
    [anon_sym_DOT] = ACTIONS(5251),
    [anon_sym_switch] = ACTIONS(5249),
    [anon_sym_DOT_DOT] = ACTIONS(5249),
    [anon_sym_PLUS_EQ] = ACTIONS(5902),
    [anon_sym_DASH_EQ] = ACTIONS(5902),
    [anon_sym_STAR_EQ] = ACTIONS(5902),
    [anon_sym_SLASH_EQ] = ACTIONS(5902),
    [anon_sym_PERCENT_EQ] = ACTIONS(5902),
    [anon_sym_AMP_EQ] = ACTIONS(5902),
    [anon_sym_CARET_EQ] = ACTIONS(5902),
    [anon_sym_PIPE_EQ] = ACTIONS(5902),
    [anon_sym_LT_LT_EQ] = ACTIONS(5902),
    [anon_sym_GT_GT_EQ] = ACTIONS(5902),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5902),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(5902),
    [anon_sym_AMP_AMP] = ACTIONS(5249),
    [anon_sym_PIPE_PIPE] = ACTIONS(5249),
    [anon_sym_QMARK_QMARK] = ACTIONS(5251),
    [anon_sym_as] = ACTIONS(5249),
    [anon_sym_is] = ACTIONS(5249),
    [anon_sym_DASH_GT] = ACTIONS(5249),
    [anon_sym_with] = ACTIONS(5249),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4419] = {
    [sym_argument_list] = STATE(3818),
    [sym__name] = STATE(3925),
    [sym_alias_qualified_name] = STATE(3912),
    [sym__simple_name] = STATE(3912),
    [sym_qualified_name] = STATE(3912),
    [sym_generic_name] = STATE(3874),
    [sym_type] = STATE(3782),
    [sym_implicit_type] = STATE(3915),
    [sym_array_type] = STATE(3823),
    [sym__array_base_type] = STATE(8833),
    [sym_nullable_type] = STATE(3917),
    [sym_pointer_type] = STATE(3917),
    [sym__pointer_base_type] = STATE(9537),
    [sym_function_pointer_type] = STATE(3917),
    [sym_ref_type] = STATE(3915),
    [sym_scoped_type] = STATE(3915),
    [sym_tuple_type] = STATE(3918),
    [sym_identifier] = STATE(3787),
    [sym__reserved_identifier] = STATE(3838),
    [sym_preproc_region] = STATE(4419),
    [sym_preproc_endregion] = STATE(4419),
    [sym_preproc_line] = STATE(4419),
    [sym_preproc_pragma] = STATE(4419),
    [sym_preproc_nullable] = STATE(4419),
    [sym_preproc_error] = STATE(4419),
    [sym_preproc_define] = STATE(4419),
    [sym_preproc_undef] = STATE(4419),
    [sym__identifier_token] = ACTIONS(4157),
    [anon_sym_alias] = ACTIONS(4159),
    [anon_sym_global] = ACTIONS(4159),
    [anon_sym_LBRACK] = ACTIONS(6131),
    [anon_sym_LPAREN] = ACTIONS(6133),
    [anon_sym_ref] = ACTIONS(4586),
    [anon_sym_LBRACE] = ACTIONS(6135),
    [anon_sym_delegate] = ACTIONS(6137),
    [anon_sym_file] = ACTIONS(4159),
    [anon_sym_where] = ACTIONS(4159),
    [anon_sym_notnull] = ACTIONS(4159),
    [anon_sym_unmanaged] = ACTIONS(4159),
    [anon_sym_scoped] = ACTIONS(6272),
    [anon_sym_var] = ACTIONS(6141),
    [sym_predefined_type] = ACTIONS(6143),
    [anon_sym_yield] = ACTIONS(4159),
    [anon_sym_when] = ACTIONS(4159),
    [anon_sym_from] = ACTIONS(4159),
    [anon_sym_into] = ACTIONS(4159),
    [anon_sym_join] = ACTIONS(4159),
    [anon_sym_on] = ACTIONS(4159),
    [anon_sym_equals] = ACTIONS(4159),
    [anon_sym_let] = ACTIONS(4159),
    [anon_sym_orderby] = ACTIONS(4159),
    [anon_sym_ascending] = ACTIONS(4159),
    [anon_sym_descending] = ACTIONS(4159),
    [anon_sym_group] = ACTIONS(4159),
    [anon_sym_by] = ACTIONS(4159),
    [anon_sym_select] = ACTIONS(4159),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4420] = {
    [sym_argument_list] = STATE(4571),
    [sym_bracketed_argument_list] = STATE(3551),
    [sym_preproc_region] = STATE(4420),
    [sym_preproc_endregion] = STATE(4420),
    [sym_preproc_line] = STATE(4420),
    [sym_preproc_pragma] = STATE(4420),
    [sym_preproc_nullable] = STATE(4420),
    [sym_preproc_error] = STATE(4420),
    [sym_preproc_define] = STATE(4420),
    [sym_preproc_undef] = STATE(4420),
    [anon_sym_LBRACK] = ACTIONS(6038),
    [anon_sym_COMMA] = ACTIONS(6274),
    [anon_sym_LPAREN] = ACTIONS(6008),
    [anon_sym_LT] = ACTIONS(6040),
    [anon_sym_GT] = ACTIONS(6040),
    [anon_sym_where] = ACTIONS(6274),
    [anon_sym_QMARK] = ACTIONS(6042),
    [anon_sym_BANG] = ACTIONS(6044),
    [anon_sym_PLUS_PLUS] = ACTIONS(6046),
    [anon_sym_DASH_DASH] = ACTIONS(6046),
    [anon_sym_PLUS] = ACTIONS(6048),
    [anon_sym_DASH] = ACTIONS(6048),
    [anon_sym_STAR] = ACTIONS(6050),
    [anon_sym_SLASH] = ACTIONS(6052),
    [anon_sym_PERCENT] = ACTIONS(6050),
    [anon_sym_CARET] = ACTIONS(6054),
    [anon_sym_PIPE] = ACTIONS(6056),
    [anon_sym_AMP] = ACTIONS(6058),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6062),
    [anon_sym_GT_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6064),
    [anon_sym_BANG_EQ] = ACTIONS(6064),
    [anon_sym_GT_EQ] = ACTIONS(6066),
    [anon_sym_LT_EQ] = ACTIONS(6066),
    [anon_sym_DOT] = ACTIONS(5165),
    [anon_sym_switch] = ACTIONS(6068),
    [anon_sym_DOT_DOT] = ACTIONS(6070),
    [anon_sym_and] = ACTIONS(6274),
    [anon_sym_or] = ACTIONS(6276),
    [anon_sym_AMP_AMP] = ACTIONS(6072),
    [anon_sym_PIPE_PIPE] = ACTIONS(6074),
    [anon_sym_QMARK_QMARK] = ACTIONS(6076),
    [anon_sym_from] = ACTIONS(6274),
    [anon_sym_into] = ACTIONS(6274),
    [anon_sym_join] = ACTIONS(6274),
    [anon_sym_let] = ACTIONS(6274),
    [anon_sym_orderby] = ACTIONS(6274),
    [anon_sym_ascending] = ACTIONS(6274),
    [anon_sym_descending] = ACTIONS(6274),
    [anon_sym_group] = ACTIONS(6274),
    [anon_sym_select] = ACTIONS(6274),
    [anon_sym_as] = ACTIONS(6078),
    [anon_sym_is] = ACTIONS(6080),
    [anon_sym_DASH_GT] = ACTIONS(5167),
    [anon_sym_with] = ACTIONS(6082),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4421] = {
    [sym_argument_list] = STATE(4571),
    [sym_bracketed_argument_list] = STATE(3551),
    [sym_preproc_region] = STATE(4421),
    [sym_preproc_endregion] = STATE(4421),
    [sym_preproc_line] = STATE(4421),
    [sym_preproc_pragma] = STATE(4421),
    [sym_preproc_nullable] = STATE(4421),
    [sym_preproc_error] = STATE(4421),
    [sym_preproc_define] = STATE(4421),
    [sym_preproc_undef] = STATE(4421),
    [anon_sym_LBRACK] = ACTIONS(6038),
    [anon_sym_COMMA] = ACTIONS(5255),
    [anon_sym_LPAREN] = ACTIONS(6008),
    [anon_sym_LT] = ACTIONS(5257),
    [anon_sym_GT] = ACTIONS(5257),
    [anon_sym_where] = ACTIONS(5255),
    [anon_sym_QMARK] = ACTIONS(5257),
    [anon_sym_BANG] = ACTIONS(6044),
    [anon_sym_PLUS_PLUS] = ACTIONS(6046),
    [anon_sym_DASH_DASH] = ACTIONS(6046),
    [anon_sym_PLUS] = ACTIONS(5257),
    [anon_sym_DASH] = ACTIONS(5257),
    [anon_sym_STAR] = ACTIONS(5255),
    [anon_sym_SLASH] = ACTIONS(5257),
    [anon_sym_PERCENT] = ACTIONS(5255),
    [anon_sym_CARET] = ACTIONS(5255),
    [anon_sym_PIPE] = ACTIONS(5257),
    [anon_sym_AMP] = ACTIONS(5257),
    [anon_sym_LT_LT] = ACTIONS(5255),
    [anon_sym_GT_GT] = ACTIONS(5257),
    [anon_sym_GT_GT_GT] = ACTIONS(5255),
    [anon_sym_EQ_EQ] = ACTIONS(5255),
    [anon_sym_BANG_EQ] = ACTIONS(5255),
    [anon_sym_GT_EQ] = ACTIONS(5255),
    [anon_sym_LT_EQ] = ACTIONS(5255),
    [anon_sym_DOT] = ACTIONS(5165),
    [anon_sym_switch] = ACTIONS(5255),
    [anon_sym_DOT_DOT] = ACTIONS(5255),
    [anon_sym_and] = ACTIONS(5255),
    [anon_sym_or] = ACTIONS(5257),
    [anon_sym_AMP_AMP] = ACTIONS(5255),
    [anon_sym_PIPE_PIPE] = ACTIONS(5255),
    [anon_sym_QMARK_QMARK] = ACTIONS(5255),
    [anon_sym_from] = ACTIONS(5255),
    [anon_sym_into] = ACTIONS(5255),
    [anon_sym_join] = ACTIONS(5255),
    [anon_sym_let] = ACTIONS(5255),
    [anon_sym_orderby] = ACTIONS(5255),
    [anon_sym_ascending] = ACTIONS(5255),
    [anon_sym_descending] = ACTIONS(5255),
    [anon_sym_group] = ACTIONS(5255),
    [anon_sym_select] = ACTIONS(5255),
    [anon_sym_as] = ACTIONS(5257),
    [anon_sym_is] = ACTIONS(5255),
    [anon_sym_DASH_GT] = ACTIONS(5167),
    [anon_sym_with] = ACTIONS(5255),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4422] = {
    [sym_argument_list] = STATE(3900),
    [sym__name] = STATE(4268),
    [sym_alias_qualified_name] = STATE(3955),
    [sym__simple_name] = STATE(3955),
    [sym_qualified_name] = STATE(3955),
    [sym_generic_name] = STATE(4047),
    [sym_type] = STATE(3847),
    [sym_implicit_type] = STATE(3954),
    [sym_array_type] = STATE(3986),
    [sym__array_base_type] = STATE(8755),
    [sym_nullable_type] = STATE(3937),
    [sym_pointer_type] = STATE(3937),
    [sym__pointer_base_type] = STATE(9763),
    [sym_function_pointer_type] = STATE(3937),
    [sym_ref_type] = STATE(3954),
    [sym_scoped_type] = STATE(3954),
    [sym_tuple_type] = STATE(3962),
    [sym_identifier] = STATE(3891),
    [sym__reserved_identifier] = STATE(3897),
    [sym_preproc_region] = STATE(4422),
    [sym_preproc_endregion] = STATE(4422),
    [sym_preproc_line] = STATE(4422),
    [sym_preproc_pragma] = STATE(4422),
    [sym_preproc_nullable] = STATE(4422),
    [sym_preproc_error] = STATE(4422),
    [sym_preproc_define] = STATE(4422),
    [sym_preproc_undef] = STATE(4422),
    [sym__identifier_token] = ACTIONS(4168),
    [anon_sym_alias] = ACTIONS(4170),
    [anon_sym_global] = ACTIONS(4170),
    [anon_sym_LBRACK] = ACTIONS(6200),
    [anon_sym_LPAREN] = ACTIONS(6202),
    [anon_sym_ref] = ACTIONS(4465),
    [anon_sym_LBRACE] = ACTIONS(6204),
    [anon_sym_delegate] = ACTIONS(6206),
    [anon_sym_file] = ACTIONS(4170),
    [anon_sym_where] = ACTIONS(4170),
    [anon_sym_notnull] = ACTIONS(4170),
    [anon_sym_unmanaged] = ACTIONS(4170),
    [anon_sym_scoped] = ACTIONS(6278),
    [anon_sym_var] = ACTIONS(6210),
    [sym_predefined_type] = ACTIONS(6212),
    [anon_sym_yield] = ACTIONS(4170),
    [anon_sym_when] = ACTIONS(4170),
    [anon_sym_from] = ACTIONS(4170),
    [anon_sym_into] = ACTIONS(4170),
    [anon_sym_join] = ACTIONS(4170),
    [anon_sym_on] = ACTIONS(4170),
    [anon_sym_equals] = ACTIONS(4170),
    [anon_sym_let] = ACTIONS(4170),
    [anon_sym_orderby] = ACTIONS(4170),
    [anon_sym_ascending] = ACTIONS(4170),
    [anon_sym_descending] = ACTIONS(4170),
    [anon_sym_group] = ACTIONS(4170),
    [anon_sym_by] = ACTIONS(4170),
    [anon_sym_select] = ACTIONS(4170),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4423] = {
    [sym_preproc_region] = STATE(4423),
    [sym_preproc_endregion] = STATE(4423),
    [sym_preproc_line] = STATE(4423),
    [sym_preproc_pragma] = STATE(4423),
    [sym_preproc_nullable] = STATE(4423),
    [sym_preproc_error] = STATE(4423),
    [sym_preproc_define] = STATE(4423),
    [sym_preproc_undef] = STATE(4423),
    [anon_sym_EQ] = ACTIONS(6280),
    [anon_sym_LBRACK] = ACTIONS(5249),
    [anon_sym_LPAREN] = ACTIONS(5249),
    [anon_sym_LT] = ACTIONS(5251),
    [anon_sym_GT] = ACTIONS(5251),
    [anon_sym_QMARK] = ACTIONS(5251),
    [anon_sym_BANG] = ACTIONS(5251),
    [anon_sym_PLUS_PLUS] = ACTIONS(5249),
    [anon_sym_DASH_DASH] = ACTIONS(5249),
    [anon_sym_PLUS] = ACTIONS(5251),
    [anon_sym_DASH] = ACTIONS(5251),
    [anon_sym_STAR] = ACTIONS(5251),
    [anon_sym_SLASH] = ACTIONS(5251),
    [anon_sym_PERCENT] = ACTIONS(5251),
    [anon_sym_CARET] = ACTIONS(5251),
    [anon_sym_PIPE] = ACTIONS(5251),
    [anon_sym_AMP] = ACTIONS(5251),
    [anon_sym_LT_LT] = ACTIONS(5251),
    [anon_sym_GT_GT] = ACTIONS(5251),
    [anon_sym_GT_GT_GT] = ACTIONS(5251),
    [anon_sym_EQ_EQ] = ACTIONS(5249),
    [anon_sym_BANG_EQ] = ACTIONS(5249),
    [anon_sym_GT_EQ] = ACTIONS(5249),
    [anon_sym_LT_EQ] = ACTIONS(5249),
    [anon_sym_DOT] = ACTIONS(5251),
    [anon_sym_EQ_GT] = ACTIONS(5249),
    [anon_sym_switch] = ACTIONS(5249),
    [anon_sym_DOT_DOT] = ACTIONS(5249),
    [anon_sym_PLUS_EQ] = ACTIONS(6282),
    [anon_sym_DASH_EQ] = ACTIONS(6282),
    [anon_sym_STAR_EQ] = ACTIONS(6282),
    [anon_sym_SLASH_EQ] = ACTIONS(6282),
    [anon_sym_PERCENT_EQ] = ACTIONS(6282),
    [anon_sym_AMP_EQ] = ACTIONS(6282),
    [anon_sym_CARET_EQ] = ACTIONS(6282),
    [anon_sym_PIPE_EQ] = ACTIONS(6282),
    [anon_sym_LT_LT_EQ] = ACTIONS(6282),
    [anon_sym_GT_GT_EQ] = ACTIONS(6282),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6282),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(6282),
    [anon_sym_AMP_AMP] = ACTIONS(5249),
    [anon_sym_PIPE_PIPE] = ACTIONS(5249),
    [anon_sym_QMARK_QMARK] = ACTIONS(5251),
    [anon_sym_into] = ACTIONS(5249),
    [anon_sym_as] = ACTIONS(5249),
    [anon_sym_is] = ACTIONS(5249),
    [anon_sym_DASH_GT] = ACTIONS(5249),
    [anon_sym_with] = ACTIONS(5249),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4424] = {
    [sym_argument_list] = STATE(4571),
    [sym_bracketed_argument_list] = STATE(3551),
    [sym_preproc_region] = STATE(4424),
    [sym_preproc_endregion] = STATE(4424),
    [sym_preproc_line] = STATE(4424),
    [sym_preproc_pragma] = STATE(4424),
    [sym_preproc_nullable] = STATE(4424),
    [sym_preproc_error] = STATE(4424),
    [sym_preproc_define] = STATE(4424),
    [sym_preproc_undef] = STATE(4424),
    [anon_sym_LBRACK] = ACTIONS(6038),
    [anon_sym_COMMA] = ACTIONS(6284),
    [anon_sym_LPAREN] = ACTIONS(6008),
    [anon_sym_LT] = ACTIONS(6040),
    [anon_sym_GT] = ACTIONS(6040),
    [anon_sym_where] = ACTIONS(6284),
    [anon_sym_QMARK] = ACTIONS(6042),
    [anon_sym_BANG] = ACTIONS(6044),
    [anon_sym_PLUS_PLUS] = ACTIONS(6046),
    [anon_sym_DASH_DASH] = ACTIONS(6046),
    [anon_sym_PLUS] = ACTIONS(6048),
    [anon_sym_DASH] = ACTIONS(6048),
    [anon_sym_STAR] = ACTIONS(6050),
    [anon_sym_SLASH] = ACTIONS(6052),
    [anon_sym_PERCENT] = ACTIONS(6050),
    [anon_sym_CARET] = ACTIONS(6054),
    [anon_sym_PIPE] = ACTIONS(6056),
    [anon_sym_AMP] = ACTIONS(6058),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6062),
    [anon_sym_GT_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6064),
    [anon_sym_BANG_EQ] = ACTIONS(6064),
    [anon_sym_GT_EQ] = ACTIONS(6066),
    [anon_sym_LT_EQ] = ACTIONS(6066),
    [anon_sym_DOT] = ACTIONS(5165),
    [anon_sym_switch] = ACTIONS(6068),
    [anon_sym_DOT_DOT] = ACTIONS(6070),
    [anon_sym_and] = ACTIONS(6284),
    [anon_sym_or] = ACTIONS(6286),
    [anon_sym_AMP_AMP] = ACTIONS(6072),
    [anon_sym_PIPE_PIPE] = ACTIONS(6074),
    [anon_sym_QMARK_QMARK] = ACTIONS(6076),
    [anon_sym_from] = ACTIONS(6284),
    [anon_sym_into] = ACTIONS(6284),
    [anon_sym_join] = ACTIONS(6284),
    [anon_sym_let] = ACTIONS(6284),
    [anon_sym_orderby] = ACTIONS(6284),
    [anon_sym_ascending] = ACTIONS(6284),
    [anon_sym_descending] = ACTIONS(6284),
    [anon_sym_group] = ACTIONS(6284),
    [anon_sym_select] = ACTIONS(6284),
    [anon_sym_as] = ACTIONS(6078),
    [anon_sym_is] = ACTIONS(6080),
    [anon_sym_DASH_GT] = ACTIONS(5167),
    [anon_sym_with] = ACTIONS(6082),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4425] = {
    [sym_argument_list] = STATE(3572),
    [sym__name] = STATE(3770),
    [sym_alias_qualified_name] = STATE(3635),
    [sym__simple_name] = STATE(3635),
    [sym_qualified_name] = STATE(3635),
    [sym_generic_name] = STATE(3708),
    [sym_type] = STATE(4257),
    [sym_implicit_type] = STATE(3706),
    [sym_array_type] = STATE(3601),
    [sym__array_base_type] = STATE(8888),
    [sym_nullable_type] = STATE(3618),
    [sym_pointer_type] = STATE(3618),
    [sym__pointer_base_type] = STATE(9386),
    [sym_function_pointer_type] = STATE(3618),
    [sym_ref_type] = STATE(3706),
    [sym_scoped_type] = STATE(3706),
    [sym_tuple_type] = STATE(3633),
    [sym_identifier] = STATE(3590),
    [sym__reserved_identifier] = STATE(3568),
    [sym_preproc_region] = STATE(4425),
    [sym_preproc_endregion] = STATE(4425),
    [sym_preproc_line] = STATE(4425),
    [sym_preproc_pragma] = STATE(4425),
    [sym_preproc_nullable] = STATE(4425),
    [sym_preproc_error] = STATE(4425),
    [sym_preproc_define] = STATE(4425),
    [sym_preproc_undef] = STATE(4425),
    [sym__identifier_token] = ACTIONS(4287),
    [anon_sym_alias] = ACTIONS(4289),
    [anon_sym_global] = ACTIONS(4289),
    [anon_sym_LBRACK] = ACTIONS(4449),
    [anon_sym_LPAREN] = ACTIONS(4451),
    [anon_sym_ref] = ACTIONS(4653),
    [anon_sym_LBRACE] = ACTIONS(4453),
    [anon_sym_delegate] = ACTIONS(4455),
    [anon_sym_file] = ACTIONS(4289),
    [anon_sym_where] = ACTIONS(4289),
    [anon_sym_notnull] = ACTIONS(4289),
    [anon_sym_unmanaged] = ACTIONS(4289),
    [anon_sym_scoped] = ACTIONS(6288),
    [anon_sym_var] = ACTIONS(4459),
    [sym_predefined_type] = ACTIONS(4461),
    [anon_sym_yield] = ACTIONS(4289),
    [anon_sym_when] = ACTIONS(4289),
    [anon_sym_from] = ACTIONS(4289),
    [anon_sym_into] = ACTIONS(4289),
    [anon_sym_join] = ACTIONS(4289),
    [anon_sym_on] = ACTIONS(4289),
    [anon_sym_equals] = ACTIONS(4289),
    [anon_sym_let] = ACTIONS(4289),
    [anon_sym_orderby] = ACTIONS(4289),
    [anon_sym_ascending] = ACTIONS(4289),
    [anon_sym_descending] = ACTIONS(4289),
    [anon_sym_group] = ACTIONS(4289),
    [anon_sym_by] = ACTIONS(4289),
    [anon_sym_select] = ACTIONS(4289),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4426] = {
    [sym__name] = STATE(7762),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(8391),
    [sym_implicit_type] = STATE(8704),
    [sym_array_type] = STATE(8215),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9650),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(8704),
    [sym_scoped_type] = STATE(8704),
    [sym_tuple_type] = STATE(8180),
    [sym_identifier] = STATE(4921),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4426),
    [sym_preproc_endregion] = STATE(4426),
    [sym_preproc_line] = STATE(4426),
    [sym_preproc_pragma] = STATE(4426),
    [sym_preproc_nullable] = STATE(4426),
    [sym_preproc_error] = STATE(4426),
    [sym_preproc_define] = STATE(4426),
    [sym_preproc_undef] = STATE(4426),
    [aux_sym_type_argument_list_repeat1] = STATE(8396),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_COMMA] = ACTIONS(5655),
    [anon_sym_LPAREN] = ACTIONS(2995),
    [anon_sym_ref] = ACTIONS(5657),
    [anon_sym_delegate] = ACTIONS(5659),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_GT] = ACTIONS(6290),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(5665),
    [anon_sym_var] = ACTIONS(5284),
    [sym_predefined_type] = ACTIONS(5667),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4427] = {
    [sym__name] = STATE(7762),
    [sym_alias_qualified_name] = STATE(4975),
    [sym__simple_name] = STATE(4975),
    [sym_qualified_name] = STATE(4975),
    [sym_generic_name] = STATE(4959),
    [sym_type] = STATE(8406),
    [sym_implicit_type] = STATE(8704),
    [sym_array_type] = STATE(8215),
    [sym__array_base_type] = STATE(8768),
    [sym_nullable_type] = STATE(5234),
    [sym_pointer_type] = STATE(5234),
    [sym__pointer_base_type] = STATE(9650),
    [sym_function_pointer_type] = STATE(5234),
    [sym_ref_type] = STATE(8704),
    [sym_scoped_type] = STATE(8704),
    [sym_tuple_type] = STATE(8180),
    [sym_identifier] = STATE(4921),
    [sym__reserved_identifier] = STATE(4443),
    [sym_preproc_region] = STATE(4427),
    [sym_preproc_endregion] = STATE(4427),
    [sym_preproc_line] = STATE(4427),
    [sym_preproc_pragma] = STATE(4427),
    [sym_preproc_nullable] = STATE(4427),
    [sym_preproc_error] = STATE(4427),
    [sym_preproc_define] = STATE(4427),
    [sym_preproc_undef] = STATE(4427),
    [aux_sym_type_argument_list_repeat1] = STATE(8407),
    [sym__identifier_token] = ACTIONS(2983),
    [anon_sym_alias] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2987),
    [anon_sym_COMMA] = ACTIONS(5655),
    [anon_sym_LPAREN] = ACTIONS(2995),
    [anon_sym_ref] = ACTIONS(5657),
    [anon_sym_delegate] = ACTIONS(5659),
    [anon_sym_file] = ACTIONS(2987),
    [anon_sym_GT] = ACTIONS(6292),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_notnull] = ACTIONS(2987),
    [anon_sym_unmanaged] = ACTIONS(2987),
    [anon_sym_scoped] = ACTIONS(5665),
    [anon_sym_var] = ACTIONS(5284),
    [sym_predefined_type] = ACTIONS(5667),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_ascending] = ACTIONS(2987),
    [anon_sym_descending] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4428] = {
    [sym_argument_list] = STATE(3900),
    [sym__name] = STATE(4268),
    [sym_alias_qualified_name] = STATE(3955),
    [sym__simple_name] = STATE(3955),
    [sym_qualified_name] = STATE(3955),
    [sym_generic_name] = STATE(4047),
    [sym_type] = STATE(3847),
    [sym_implicit_type] = STATE(3954),
    [sym_array_type] = STATE(3986),
    [sym__array_base_type] = STATE(8755),
    [sym_nullable_type] = STATE(3937),
    [sym_pointer_type] = STATE(3937),
    [sym__pointer_base_type] = STATE(9763),
    [sym_function_pointer_type] = STATE(3937),
    [sym_ref_type] = STATE(3954),
    [sym_scoped_type] = STATE(3954),
    [sym_tuple_type] = STATE(3962),
    [sym_identifier] = STATE(3891),
    [sym__reserved_identifier] = STATE(3897),
    [sym_preproc_region] = STATE(4428),
    [sym_preproc_endregion] = STATE(4428),
    [sym_preproc_line] = STATE(4428),
    [sym_preproc_pragma] = STATE(4428),
    [sym_preproc_nullable] = STATE(4428),
    [sym_preproc_error] = STATE(4428),
    [sym_preproc_define] = STATE(4428),
    [sym_preproc_undef] = STATE(4428),
    [sym__identifier_token] = ACTIONS(4168),
    [anon_sym_alias] = ACTIONS(4170),
    [anon_sym_global] = ACTIONS(4170),
    [anon_sym_LBRACK] = ACTIONS(6200),
    [anon_sym_LPAREN] = ACTIONS(6202),
    [anon_sym_ref] = ACTIONS(4172),
    [anon_sym_LBRACE] = ACTIONS(6204),
    [anon_sym_delegate] = ACTIONS(6206),
    [anon_sym_file] = ACTIONS(4170),
    [anon_sym_where] = ACTIONS(4170),
    [anon_sym_notnull] = ACTIONS(4170),
    [anon_sym_unmanaged] = ACTIONS(4170),
    [anon_sym_scoped] = ACTIONS(6294),
    [anon_sym_var] = ACTIONS(6210),
    [sym_predefined_type] = ACTIONS(6212),
    [anon_sym_yield] = ACTIONS(4170),
    [anon_sym_when] = ACTIONS(4170),
    [anon_sym_from] = ACTIONS(4170),
    [anon_sym_into] = ACTIONS(4170),
    [anon_sym_join] = ACTIONS(4170),
    [anon_sym_on] = ACTIONS(4170),
    [anon_sym_equals] = ACTIONS(4170),
    [anon_sym_let] = ACTIONS(4170),
    [anon_sym_orderby] = ACTIONS(4170),
    [anon_sym_ascending] = ACTIONS(4170),
    [anon_sym_descending] = ACTIONS(4170),
    [anon_sym_group] = ACTIONS(4170),
    [anon_sym_by] = ACTIONS(4170),
    [anon_sym_select] = ACTIONS(4170),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4429] = {
    [sym_block] = STATE(2231),
    [sym_preproc_region] = STATE(4429),
    [sym_preproc_endregion] = STATE(4429),
    [sym_preproc_line] = STATE(4429),
    [sym_preproc_pragma] = STATE(4429),
    [sym_preproc_nullable] = STATE(4429),
    [sym_preproc_error] = STATE(4429),
    [sym_preproc_define] = STATE(4429),
    [sym_preproc_undef] = STATE(4429),
    [sym__identifier_token] = ACTIONS(3976),
    [anon_sym_extern] = ACTIONS(3976),
    [anon_sym_alias] = ACTIONS(3976),
    [anon_sym_global] = ACTIONS(3976),
    [anon_sym_unsafe] = ACTIONS(3976),
    [anon_sym_static] = ACTIONS(3976),
    [anon_sym_LPAREN] = ACTIONS(5566),
    [anon_sym_ref] = ACTIONS(3976),
    [anon_sym_LBRACE] = ACTIONS(5709),
    [anon_sym_delegate] = ACTIONS(3976),
    [anon_sym_abstract] = ACTIONS(3976),
    [anon_sym_async] = ACTIONS(3976),
    [anon_sym_const] = ACTIONS(3976),
    [anon_sym_file] = ACTIONS(3976),
    [anon_sym_fixed] = ACTIONS(3976),
    [anon_sym_internal] = ACTIONS(3976),
    [anon_sym_new] = ACTIONS(3976),
    [anon_sym_override] = ACTIONS(3976),
    [anon_sym_partial] = ACTIONS(3976),
    [anon_sym_private] = ACTIONS(3976),
    [anon_sym_protected] = ACTIONS(3976),
    [anon_sym_public] = ACTIONS(3976),
    [anon_sym_readonly] = ACTIONS(3976),
    [anon_sym_required] = ACTIONS(3976),
    [anon_sym_sealed] = ACTIONS(3976),
    [anon_sym_virtual] = ACTIONS(3976),
    [anon_sym_volatile] = ACTIONS(3976),
    [anon_sym_where] = ACTIONS(3976),
    [anon_sym_notnull] = ACTIONS(3976),
    [anon_sym_unmanaged] = ACTIONS(3976),
    [anon_sym_scoped] = ACTIONS(3976),
    [anon_sym_var] = ACTIONS(3976),
    [sym_predefined_type] = ACTIONS(3976),
    [anon_sym_yield] = ACTIONS(3976),
    [anon_sym_when] = ACTIONS(3976),
    [anon_sym_from] = ACTIONS(3976),
    [anon_sym_into] = ACTIONS(3976),
    [anon_sym_join] = ACTIONS(3976),
    [anon_sym_on] = ACTIONS(3976),
    [anon_sym_equals] = ACTIONS(3976),
    [anon_sym_let] = ACTIONS(3976),
    [anon_sym_orderby] = ACTIONS(3976),
    [anon_sym_ascending] = ACTIONS(3976),
    [anon_sym_descending] = ACTIONS(3976),
    [anon_sym_group] = ACTIONS(3976),
    [anon_sym_by] = ACTIONS(3976),
    [anon_sym_select] = ACTIONS(3976),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4430] = {
    [sym_argument_list] = STATE(3572),
    [sym__name] = STATE(3770),
    [sym_alias_qualified_name] = STATE(3635),
    [sym__simple_name] = STATE(3635),
    [sym_qualified_name] = STATE(3635),
    [sym_generic_name] = STATE(3708),
    [sym_type] = STATE(4257),
    [sym_implicit_type] = STATE(3706),
    [sym_array_type] = STATE(3601),
    [sym__array_base_type] = STATE(8888),
    [sym_nullable_type] = STATE(3618),
    [sym_pointer_type] = STATE(3618),
    [sym__pointer_base_type] = STATE(9386),
    [sym_function_pointer_type] = STATE(3618),
    [sym_ref_type] = STATE(3706),
    [sym_scoped_type] = STATE(3706),
    [sym_tuple_type] = STATE(3633),
    [sym_identifier] = STATE(3590),
    [sym__reserved_identifier] = STATE(3568),
    [sym_preproc_region] = STATE(4430),
    [sym_preproc_endregion] = STATE(4430),
    [sym_preproc_line] = STATE(4430),
    [sym_preproc_pragma] = STATE(4430),
    [sym_preproc_nullable] = STATE(4430),
    [sym_preproc_error] = STATE(4430),
    [sym_preproc_define] = STATE(4430),
    [sym_preproc_undef] = STATE(4430),
    [sym__identifier_token] = ACTIONS(4287),
    [anon_sym_alias] = ACTIONS(4289),
    [anon_sym_global] = ACTIONS(4289),
    [anon_sym_LBRACK] = ACTIONS(4449),
    [anon_sym_LPAREN] = ACTIONS(4451),
    [anon_sym_ref] = ACTIONS(4291),
    [anon_sym_LBRACE] = ACTIONS(4453),
    [anon_sym_delegate] = ACTIONS(4455),
    [anon_sym_file] = ACTIONS(4289),
    [anon_sym_where] = ACTIONS(4289),
    [anon_sym_notnull] = ACTIONS(4289),
    [anon_sym_unmanaged] = ACTIONS(4289),
    [anon_sym_scoped] = ACTIONS(4457),
    [anon_sym_var] = ACTIONS(4459),
    [sym_predefined_type] = ACTIONS(4461),
    [anon_sym_yield] = ACTIONS(4289),
    [anon_sym_when] = ACTIONS(4289),
    [anon_sym_from] = ACTIONS(4289),
    [anon_sym_into] = ACTIONS(4289),
    [anon_sym_join] = ACTIONS(4289),
    [anon_sym_on] = ACTIONS(4289),
    [anon_sym_equals] = ACTIONS(4289),
    [anon_sym_let] = ACTIONS(4289),
    [anon_sym_orderby] = ACTIONS(4289),
    [anon_sym_ascending] = ACTIONS(4289),
    [anon_sym_descending] = ACTIONS(4289),
    [anon_sym_group] = ACTIONS(4289),
    [anon_sym_by] = ACTIONS(4289),
    [anon_sym_select] = ACTIONS(4289),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5387), 1,
      anon_sym_in,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6298), 1,
      anon_sym_QMARK,
    ACTIONS(6304), 1,
      anon_sym_SLASH,
    ACTIONS(6306), 1,
      anon_sym_CARET,
    ACTIONS(6308), 1,
      anon_sym_PIPE,
    ACTIONS(6310), 1,
      anon_sym_AMP,
    ACTIONS(6314), 1,
      anon_sym_GT_GT,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6322), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6324), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6326), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6328), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6330), 1,
      anon_sym_as,
    ACTIONS(6332), 1,
      anon_sym_is,
    ACTIONS(6334), 1,
      anon_sym_with,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6296), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6300), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6302), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6312), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6316), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6318), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4431), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5385), 11,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [145] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5165), 1,
      anon_sym_DOT,
    ACTIONS(5167), 1,
      anon_sym_DASH_GT,
    ACTIONS(5422), 1,
      anon_sym_or,
    ACTIONS(6008), 1,
      anon_sym_LPAREN,
    ACTIONS(6038), 1,
      anon_sym_LBRACK,
    ACTIONS(6044), 1,
      anon_sym_BANG,
    ACTIONS(6068), 1,
      anon_sym_switch,
    ACTIONS(6082), 1,
      anon_sym_with,
    ACTIONS(6338), 1,
      anon_sym_QMARK,
    ACTIONS(6344), 1,
      anon_sym_SLASH,
    ACTIONS(6346), 1,
      anon_sym_CARET,
    ACTIONS(6348), 1,
      anon_sym_PIPE,
    ACTIONS(6350), 1,
      anon_sym_AMP,
    ACTIONS(6354), 1,
      anon_sym_GT_GT,
    ACTIONS(6360), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6362), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6364), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6366), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6368), 1,
      anon_sym_as,
    ACTIONS(6370), 1,
      anon_sym_is,
    STATE(3551), 1,
      sym_bracketed_argument_list,
    STATE(4571), 1,
      sym_argument_list,
    ACTIONS(6046), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6336), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6340), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6342), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6352), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6356), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6358), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4432), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5420), 11,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [290] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4433), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3719), 16,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
    ACTIONS(3721), 31,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_file,
      anon_sym_in,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_operator,
      anon_sym_this,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [379] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5165), 1,
      anon_sym_DOT,
    ACTIONS(5167), 1,
      anon_sym_DASH_GT,
    ACTIONS(6008), 1,
      anon_sym_LPAREN,
    ACTIONS(6038), 1,
      anon_sym_LBRACK,
    ACTIONS(6044), 1,
      anon_sym_BANG,
    ACTIONS(6068), 1,
      anon_sym_switch,
    ACTIONS(6082), 1,
      anon_sym_with,
    ACTIONS(6238), 1,
      anon_sym_or,
    ACTIONS(6338), 1,
      anon_sym_QMARK,
    ACTIONS(6344), 1,
      anon_sym_SLASH,
    ACTIONS(6346), 1,
      anon_sym_CARET,
    ACTIONS(6348), 1,
      anon_sym_PIPE,
    ACTIONS(6350), 1,
      anon_sym_AMP,
    ACTIONS(6354), 1,
      anon_sym_GT_GT,
    ACTIONS(6360), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6362), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6364), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6366), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6368), 1,
      anon_sym_as,
    ACTIONS(6370), 1,
      anon_sym_is,
    STATE(3551), 1,
      sym_bracketed_argument_list,
    STATE(4571), 1,
      sym_argument_list,
    ACTIONS(6046), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6336), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6340), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6342), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6352), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6356), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6358), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4434), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6236), 11,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [524] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6372), 1,
      sym_string_literal_encoding,
    STATE(4435), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5321), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5319), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [615] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5165), 1,
      anon_sym_DOT,
    ACTIONS(5167), 1,
      anon_sym_DASH_GT,
    ACTIONS(5512), 1,
      anon_sym_or,
    ACTIONS(6008), 1,
      anon_sym_LPAREN,
    ACTIONS(6038), 1,
      anon_sym_LBRACK,
    ACTIONS(6044), 1,
      anon_sym_BANG,
    ACTIONS(6068), 1,
      anon_sym_switch,
    ACTIONS(6082), 1,
      anon_sym_with,
    ACTIONS(6338), 1,
      anon_sym_QMARK,
    ACTIONS(6344), 1,
      anon_sym_SLASH,
    ACTIONS(6346), 1,
      anon_sym_CARET,
    ACTIONS(6348), 1,
      anon_sym_PIPE,
    ACTIONS(6350), 1,
      anon_sym_AMP,
    ACTIONS(6354), 1,
      anon_sym_GT_GT,
    ACTIONS(6360), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6362), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6364), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6366), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6368), 1,
      anon_sym_as,
    ACTIONS(6370), 1,
      anon_sym_is,
    STATE(3551), 1,
      sym_bracketed_argument_list,
    STATE(4571), 1,
      sym_argument_list,
    ACTIONS(6046), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6336), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6340), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6342), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6352), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6356), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6358), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4436), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5510), 11,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [760] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6378), 1,
      anon_sym_into,
    STATE(4437), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym__query_body_repeat2,
    ACTIONS(6376), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(6374), 32,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [851] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5165), 1,
      anon_sym_DOT,
    ACTIONS(5167), 1,
      anon_sym_DASH_GT,
    ACTIONS(6008), 1,
      anon_sym_LPAREN,
    ACTIONS(6038), 1,
      anon_sym_LBRACK,
    ACTIONS(6044), 1,
      anon_sym_BANG,
    ACTIONS(6068), 1,
      anon_sym_switch,
    ACTIONS(6082), 1,
      anon_sym_with,
    ACTIONS(6232), 1,
      anon_sym_or,
    ACTIONS(6338), 1,
      anon_sym_QMARK,
    ACTIONS(6344), 1,
      anon_sym_SLASH,
    ACTIONS(6346), 1,
      anon_sym_CARET,
    ACTIONS(6348), 1,
      anon_sym_PIPE,
    ACTIONS(6350), 1,
      anon_sym_AMP,
    ACTIONS(6354), 1,
      anon_sym_GT_GT,
    ACTIONS(6360), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6362), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6364), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6366), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6368), 1,
      anon_sym_as,
    ACTIONS(6370), 1,
      anon_sym_is,
    STATE(3551), 1,
      sym_bracketed_argument_list,
    STATE(4571), 1,
      sym_argument_list,
    ACTIONS(6046), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6336), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6340), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6342), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6352), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6356), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6358), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4438), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6230), 11,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [996] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6385), 1,
      anon_sym_into,
    STATE(4437), 1,
      aux_sym__query_body_repeat2,
    STATE(4439), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6383), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(6381), 32,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [1089] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5165), 1,
      anon_sym_DOT,
    ACTIONS(5167), 1,
      anon_sym_DASH_GT,
    ACTIONS(5327), 1,
      anon_sym_or,
    ACTIONS(6008), 1,
      anon_sym_LPAREN,
    ACTIONS(6038), 1,
      anon_sym_LBRACK,
    ACTIONS(6044), 1,
      anon_sym_BANG,
    ACTIONS(6068), 1,
      anon_sym_switch,
    ACTIONS(6082), 1,
      anon_sym_with,
    ACTIONS(6338), 1,
      anon_sym_QMARK,
    ACTIONS(6344), 1,
      anon_sym_SLASH,
    ACTIONS(6346), 1,
      anon_sym_CARET,
    ACTIONS(6348), 1,
      anon_sym_PIPE,
    ACTIONS(6350), 1,
      anon_sym_AMP,
    ACTIONS(6354), 1,
      anon_sym_GT_GT,
    ACTIONS(6360), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6362), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6364), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6366), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6368), 1,
      anon_sym_as,
    ACTIONS(6370), 1,
      anon_sym_is,
    STATE(3551), 1,
      sym_bracketed_argument_list,
    STATE(4571), 1,
      sym_argument_list,
    ACTIONS(6046), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6336), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6340), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6342), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6352), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6356), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6358), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4440), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5325), 11,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [1234] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5165), 1,
      anon_sym_DOT,
    ACTIONS(5167), 1,
      anon_sym_DASH_GT,
    ACTIONS(6008), 1,
      anon_sym_LPAREN,
    ACTIONS(6038), 1,
      anon_sym_LBRACK,
    ACTIONS(6044), 1,
      anon_sym_BANG,
    ACTIONS(6068), 1,
      anon_sym_switch,
    ACTIONS(6082), 1,
      anon_sym_with,
    ACTIONS(6218), 1,
      anon_sym_or,
    ACTIONS(6338), 1,
      anon_sym_QMARK,
    ACTIONS(6344), 1,
      anon_sym_SLASH,
    ACTIONS(6346), 1,
      anon_sym_CARET,
    ACTIONS(6348), 1,
      anon_sym_PIPE,
    ACTIONS(6350), 1,
      anon_sym_AMP,
    ACTIONS(6354), 1,
      anon_sym_GT_GT,
    ACTIONS(6360), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6362), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6364), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6366), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6368), 1,
      anon_sym_as,
    ACTIONS(6370), 1,
      anon_sym_is,
    STATE(3551), 1,
      sym_bracketed_argument_list,
    STATE(4571), 1,
      sym_argument_list,
    ACTIONS(6046), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6336), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6340), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6342), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6352), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6356), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6358), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4441), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6216), 11,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [1379] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5165), 1,
      anon_sym_DOT,
    ACTIONS(5167), 1,
      anon_sym_DASH_GT,
    ACTIONS(5398), 1,
      anon_sym_or,
    ACTIONS(6008), 1,
      anon_sym_LPAREN,
    ACTIONS(6038), 1,
      anon_sym_LBRACK,
    ACTIONS(6044), 1,
      anon_sym_BANG,
    ACTIONS(6068), 1,
      anon_sym_switch,
    ACTIONS(6082), 1,
      anon_sym_with,
    ACTIONS(6338), 1,
      anon_sym_QMARK,
    ACTIONS(6344), 1,
      anon_sym_SLASH,
    ACTIONS(6346), 1,
      anon_sym_CARET,
    ACTIONS(6348), 1,
      anon_sym_PIPE,
    ACTIONS(6350), 1,
      anon_sym_AMP,
    ACTIONS(6354), 1,
      anon_sym_GT_GT,
    ACTIONS(6360), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6362), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6364), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6366), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6368), 1,
      anon_sym_as,
    ACTIONS(6370), 1,
      anon_sym_is,
    STATE(3551), 1,
      sym_bracketed_argument_list,
    STATE(4571), 1,
      sym_argument_list,
    ACTIONS(6046), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6336), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6340), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6342), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6352), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6356), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6358), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4442), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5396), 11,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [1524] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4443), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4058), 16,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
    ACTIONS(4056), 31,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_file,
      anon_sym_in,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_operator,
      anon_sym_this,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [1613] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5165), 1,
      anon_sym_DOT,
    ACTIONS(5167), 1,
      anon_sym_DASH_GT,
    ACTIONS(5387), 1,
      anon_sym_or,
    ACTIONS(6008), 1,
      anon_sym_LPAREN,
    ACTIONS(6038), 1,
      anon_sym_LBRACK,
    ACTIONS(6044), 1,
      anon_sym_BANG,
    ACTIONS(6068), 1,
      anon_sym_switch,
    ACTIONS(6082), 1,
      anon_sym_with,
    ACTIONS(6338), 1,
      anon_sym_QMARK,
    ACTIONS(6344), 1,
      anon_sym_SLASH,
    ACTIONS(6346), 1,
      anon_sym_CARET,
    ACTIONS(6348), 1,
      anon_sym_PIPE,
    ACTIONS(6350), 1,
      anon_sym_AMP,
    ACTIONS(6354), 1,
      anon_sym_GT_GT,
    ACTIONS(6360), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6362), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6364), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6366), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6368), 1,
      anon_sym_as,
    ACTIONS(6370), 1,
      anon_sym_is,
    STATE(3551), 1,
      sym_bracketed_argument_list,
    STATE(4571), 1,
      sym_argument_list,
    ACTIONS(6046), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6336), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6340), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6342), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6352), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6356), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6358), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4444), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5385), 11,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [1758] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5165), 1,
      anon_sym_DOT,
    ACTIONS(5167), 1,
      anon_sym_DASH_GT,
    ACTIONS(5339), 1,
      anon_sym_or,
    ACTIONS(6008), 1,
      anon_sym_LPAREN,
    ACTIONS(6038), 1,
      anon_sym_LBRACK,
    ACTIONS(6044), 1,
      anon_sym_BANG,
    ACTIONS(6068), 1,
      anon_sym_switch,
    ACTIONS(6082), 1,
      anon_sym_with,
    ACTIONS(6338), 1,
      anon_sym_QMARK,
    ACTIONS(6344), 1,
      anon_sym_SLASH,
    ACTIONS(6346), 1,
      anon_sym_CARET,
    ACTIONS(6348), 1,
      anon_sym_PIPE,
    ACTIONS(6350), 1,
      anon_sym_AMP,
    ACTIONS(6354), 1,
      anon_sym_GT_GT,
    ACTIONS(6360), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6362), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6364), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6366), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6368), 1,
      anon_sym_as,
    ACTIONS(6370), 1,
      anon_sym_is,
    STATE(3551), 1,
      sym_bracketed_argument_list,
    STATE(4571), 1,
      sym_argument_list,
    ACTIONS(6046), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6336), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6340), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6342), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6352), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6356), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6358), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4445), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5337), 11,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [1903] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4446), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5264), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5262), 34,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [1992] = 32,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2693), 1,
      anon_sym_readonly,
    ACTIONS(2983), 1,
      sym__identifier_token,
    ACTIONS(2995), 1,
      anon_sym_LPAREN,
    ACTIONS(3021), 1,
      anon_sym_scoped,
    ACTIONS(3023), 1,
      anon_sym_var,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3726), 1,
      anon_sym_ref,
    ACTIONS(3728), 1,
      anon_sym_delegate,
    ACTIONS(4357), 1,
      anon_sym_struct,
    STATE(4443), 1,
      sym__reserved_identifier,
    STATE(4921), 1,
      sym_identifier,
    STATE(4959), 1,
      sym_generic_name,
    STATE(5237), 1,
      sym_tuple_type,
    STATE(5381), 1,
      sym__name,
    STATE(5548), 1,
      sym_array_type,
    STATE(5969), 1,
      sym_type,
    STATE(8768), 1,
      sym__array_base_type,
    STATE(9721), 1,
      sym__pointer_base_type,
    STATE(2898), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5234), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4447), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2987), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [2121] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5639), 2,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
    STATE(4448), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5637), 45,
      anon_sym_extern,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_unsafe,
      anon_sym_static,
      anon_sym_ref,
      anon_sym_delegate,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_file,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_required,
      anon_sym_sealed,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      sym_predefined_type,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [2210] = 32,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2693), 1,
      anon_sym_readonly,
    ACTIONS(2983), 1,
      sym__identifier_token,
    ACTIONS(2995), 1,
      anon_sym_LPAREN,
    ACTIONS(3021), 1,
      anon_sym_scoped,
    ACTIONS(3023), 1,
      anon_sym_var,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3726), 1,
      anon_sym_ref,
    ACTIONS(3728), 1,
      anon_sym_delegate,
    ACTIONS(6387), 1,
      anon_sym_struct,
    STATE(4443), 1,
      sym__reserved_identifier,
    STATE(4921), 1,
      sym_identifier,
    STATE(4959), 1,
      sym_generic_name,
    STATE(5237), 1,
      sym_tuple_type,
    STATE(5381), 1,
      sym__name,
    STATE(5548), 1,
      sym_array_type,
    STATE(5969), 1,
      sym_type,
    STATE(8768), 1,
      sym__array_base_type,
    STATE(9721), 1,
      sym__pointer_base_type,
    STATE(2898), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5234), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4449), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2987), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [2339] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2983), 1,
      sym__identifier_token,
    ACTIONS(2995), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_var,
    ACTIONS(5659), 1,
      anon_sym_delegate,
    ACTIONS(5886), 1,
      anon_sym_scoped,
    ACTIONS(5888), 1,
      sym_predefined_type,
    ACTIONS(6389), 1,
      anon_sym_ref,
    ACTIONS(6391), 1,
      anon_sym_readonly,
    STATE(4443), 1,
      sym__reserved_identifier,
    STATE(4921), 1,
      sym_identifier,
    STATE(4959), 1,
      sym_generic_name,
    STATE(5969), 1,
      sym_type,
    STATE(7759), 1,
      sym__name,
    STATE(8136), 1,
      sym_tuple_type,
    STATE(8236), 1,
      sym_array_type,
    STATE(8768), 1,
      sym__array_base_type,
    STATE(8901), 1,
      sym_implicit_type,
    STATE(9542), 1,
      sym__ref_base_type,
    STATE(9650), 1,
      sym__pointer_base_type,
    STATE(8704), 2,
      sym_ref_type,
      sym_scoped_type,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(8217), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4450), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2987), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [2470] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5165), 1,
      anon_sym_DOT,
    ACTIONS(5167), 1,
      anon_sym_DASH_GT,
    ACTIONS(6008), 1,
      anon_sym_LPAREN,
    ACTIONS(6038), 1,
      anon_sym_LBRACK,
    ACTIONS(6044), 1,
      anon_sym_BANG,
    ACTIONS(6068), 1,
      anon_sym_switch,
    ACTIONS(6082), 1,
      anon_sym_with,
    ACTIONS(6344), 1,
      anon_sym_SLASH,
    ACTIONS(6346), 1,
      anon_sym_CARET,
    ACTIONS(6348), 1,
      anon_sym_PIPE,
    ACTIONS(6350), 1,
      anon_sym_AMP,
    ACTIONS(6354), 1,
      anon_sym_GT_GT,
    ACTIONS(6360), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6362), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6364), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6366), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6368), 1,
      anon_sym_as,
    ACTIONS(6370), 1,
      anon_sym_is,
    STATE(3551), 1,
      sym_bracketed_argument_list,
    STATE(4571), 1,
      sym_argument_list,
    ACTIONS(6046), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6116), 2,
      anon_sym_QMARK,
      anon_sym_or,
    ACTIONS(6336), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6340), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6342), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6352), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6356), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6358), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4451), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 11,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [2613] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5165), 1,
      anon_sym_DOT,
    ACTIONS(5167), 1,
      anon_sym_DASH_GT,
    ACTIONS(6008), 1,
      anon_sym_LPAREN,
    ACTIONS(6038), 1,
      anon_sym_LBRACK,
    ACTIONS(6044), 1,
      anon_sym_BANG,
    ACTIONS(6068), 1,
      anon_sym_switch,
    ACTIONS(6082), 1,
      anon_sym_with,
    ACTIONS(6344), 1,
      anon_sym_SLASH,
    ACTIONS(6346), 1,
      anon_sym_CARET,
    ACTIONS(6348), 1,
      anon_sym_PIPE,
    ACTIONS(6350), 1,
      anon_sym_AMP,
    ACTIONS(6354), 1,
      anon_sym_GT_GT,
    ACTIONS(6360), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6362), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6368), 1,
      anon_sym_as,
    ACTIONS(6370), 1,
      anon_sym_is,
    STATE(3551), 1,
      sym_bracketed_argument_list,
    STATE(4571), 1,
      sym_argument_list,
    ACTIONS(6046), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6116), 2,
      anon_sym_QMARK,
      anon_sym_or,
    ACTIONS(6336), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6340), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6342), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6352), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6356), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6358), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4452), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 13,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_and,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [2752] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5165), 1,
      anon_sym_DOT,
    ACTIONS(5167), 1,
      anon_sym_DASH_GT,
    ACTIONS(6008), 1,
      anon_sym_LPAREN,
    ACTIONS(6038), 1,
      anon_sym_LBRACK,
    ACTIONS(6044), 1,
      anon_sym_BANG,
    ACTIONS(6068), 1,
      anon_sym_switch,
    ACTIONS(6082), 1,
      anon_sym_with,
    ACTIONS(6344), 1,
      anon_sym_SLASH,
    ACTIONS(6346), 1,
      anon_sym_CARET,
    ACTIONS(6348), 1,
      anon_sym_PIPE,
    ACTIONS(6350), 1,
      anon_sym_AMP,
    ACTIONS(6354), 1,
      anon_sym_GT_GT,
    ACTIONS(6360), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6368), 1,
      anon_sym_as,
    ACTIONS(6370), 1,
      anon_sym_is,
    STATE(3551), 1,
      sym_bracketed_argument_list,
    STATE(4571), 1,
      sym_argument_list,
    ACTIONS(6046), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6116), 2,
      anon_sym_QMARK,
      anon_sym_or,
    ACTIONS(6336), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6340), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6342), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6352), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6356), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6358), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4453), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 14,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [2889] = 32,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5165), 1,
      anon_sym_DOT,
    ACTIONS(5167), 1,
      anon_sym_DASH_GT,
    ACTIONS(6008), 1,
      anon_sym_LPAREN,
    ACTIONS(6038), 1,
      anon_sym_LBRACK,
    ACTIONS(6044), 1,
      anon_sym_BANG,
    ACTIONS(6068), 1,
      anon_sym_switch,
    ACTIONS(6082), 1,
      anon_sym_with,
    ACTIONS(6344), 1,
      anon_sym_SLASH,
    ACTIONS(6354), 1,
      anon_sym_GT_GT,
    ACTIONS(6360), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6368), 1,
      anon_sym_as,
    ACTIONS(6370), 1,
      anon_sym_is,
    STATE(3551), 1,
      sym_bracketed_argument_list,
    STATE(4571), 1,
      sym_argument_list,
    ACTIONS(6046), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6336), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6340), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6342), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6352), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6358), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6116), 4,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_or,
    STATE(4454), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [3018] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5165), 1,
      anon_sym_DOT,
    ACTIONS(5167), 1,
      anon_sym_DASH_GT,
    ACTIONS(6008), 1,
      anon_sym_LPAREN,
    ACTIONS(6038), 1,
      anon_sym_LBRACK,
    ACTIONS(6044), 1,
      anon_sym_BANG,
    ACTIONS(6068), 1,
      anon_sym_switch,
    ACTIONS(6082), 1,
      anon_sym_with,
    ACTIONS(6344), 1,
      anon_sym_SLASH,
    ACTIONS(6354), 1,
      anon_sym_GT_GT,
    ACTIONS(6360), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6368), 1,
      anon_sym_as,
    ACTIONS(6370), 1,
      anon_sym_is,
    STATE(3551), 1,
      sym_bracketed_argument_list,
    STATE(4571), 1,
      sym_argument_list,
    ACTIONS(6046), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6336), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6340), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6342), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6352), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6356), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6358), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6116), 4,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_or,
    STATE(4455), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 15,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_CARET,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [3149] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5165), 1,
      anon_sym_DOT,
    ACTIONS(5167), 1,
      anon_sym_DASH_GT,
    ACTIONS(6008), 1,
      anon_sym_LPAREN,
    ACTIONS(6038), 1,
      anon_sym_LBRACK,
    ACTIONS(6044), 1,
      anon_sym_BANG,
    ACTIONS(6068), 1,
      anon_sym_switch,
    ACTIONS(6082), 1,
      anon_sym_with,
    ACTIONS(6344), 1,
      anon_sym_SLASH,
    ACTIONS(6346), 1,
      anon_sym_CARET,
    ACTIONS(6350), 1,
      anon_sym_AMP,
    ACTIONS(6354), 1,
      anon_sym_GT_GT,
    ACTIONS(6360), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6368), 1,
      anon_sym_as,
    ACTIONS(6370), 1,
      anon_sym_is,
    STATE(3551), 1,
      sym_bracketed_argument_list,
    STATE(4571), 1,
      sym_argument_list,
    ACTIONS(6046), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6336), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6340), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6342), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6352), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6356), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6358), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6116), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_or,
    STATE(4456), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 14,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [3284] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5165), 1,
      anon_sym_DOT,
    ACTIONS(5167), 1,
      anon_sym_DASH_GT,
    ACTIONS(6008), 1,
      anon_sym_LPAREN,
    ACTIONS(6038), 1,
      anon_sym_LBRACK,
    ACTIONS(6044), 1,
      anon_sym_BANG,
    ACTIONS(6068), 1,
      anon_sym_switch,
    ACTIONS(6082), 1,
      anon_sym_with,
    ACTIONS(6344), 1,
      anon_sym_SLASH,
    ACTIONS(6350), 1,
      anon_sym_AMP,
    ACTIONS(6354), 1,
      anon_sym_GT_GT,
    ACTIONS(6360), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6368), 1,
      anon_sym_as,
    ACTIONS(6370), 1,
      anon_sym_is,
    STATE(3551), 1,
      sym_bracketed_argument_list,
    STATE(4571), 1,
      sym_argument_list,
    ACTIONS(6046), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6336), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6340), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6342), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6352), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6356), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6358), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6116), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_or,
    STATE(4457), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 15,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_CARET,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [3417] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4458), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5649), 47,
      anon_sym_extern,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_unsafe,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_file,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_required,
      anon_sym_sealed,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_init,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [3504] = 32,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2693), 1,
      anon_sym_readonly,
    ACTIONS(2983), 1,
      sym__identifier_token,
    ACTIONS(2995), 1,
      anon_sym_LPAREN,
    ACTIONS(3021), 1,
      anon_sym_scoped,
    ACTIONS(3023), 1,
      anon_sym_var,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3726), 1,
      anon_sym_ref,
    ACTIONS(3728), 1,
      anon_sym_delegate,
    ACTIONS(4257), 1,
      anon_sym_struct,
    STATE(4443), 1,
      sym__reserved_identifier,
    STATE(4921), 1,
      sym_identifier,
    STATE(4959), 1,
      sym_generic_name,
    STATE(5237), 1,
      sym_tuple_type,
    STATE(5381), 1,
      sym__name,
    STATE(5548), 1,
      sym_array_type,
    STATE(5969), 1,
      sym_type,
    STATE(8768), 1,
      sym__array_base_type,
    STATE(9721), 1,
      sym__pointer_base_type,
    STATE(2898), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5234), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4459), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2987), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [3633] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6322), 1,
      anon_sym_DOT_DOT,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(4460), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1147), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(1133), 27,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [3740] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4461), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5268), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5266), 34,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [3829] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6393), 1,
      anon_sym_EQ,
    STATE(4462), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6395), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(5249), 17,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
    ACTIONS(5251), 17,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_DOT,
      anon_sym_QMARK_QMARK,
  [3922] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6286), 1,
      anon_sym_in,
    ACTIONS(6298), 1,
      anon_sym_QMARK,
    ACTIONS(6304), 1,
      anon_sym_SLASH,
    ACTIONS(6306), 1,
      anon_sym_CARET,
    ACTIONS(6308), 1,
      anon_sym_PIPE,
    ACTIONS(6310), 1,
      anon_sym_AMP,
    ACTIONS(6314), 1,
      anon_sym_GT_GT,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6322), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6324), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6326), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6328), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6330), 1,
      anon_sym_as,
    ACTIONS(6332), 1,
      anon_sym_is,
    ACTIONS(6334), 1,
      anon_sym_with,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6296), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6300), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6302), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6312), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6316), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6318), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4463), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6284), 11,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [4067] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6397), 1,
      sym__identifier_token,
    ACTIONS(6403), 1,
      anon_sym_LPAREN,
    ACTIONS(6409), 1,
      anon_sym_delegate,
    ACTIONS(6412), 1,
      anon_sym_var,
    ACTIONS(6415), 1,
      sym_predefined_type,
    STATE(4443), 1,
      sym__reserved_identifier,
    STATE(4921), 1,
      sym_identifier,
    STATE(4959), 1,
      sym_generic_name,
    STATE(8006), 1,
      sym__name,
    STATE(8314), 1,
      sym_tuple_type,
    STATE(8354), 1,
      sym_array_type,
    STATE(8768), 1,
      sym__array_base_type,
    STATE(9350), 1,
      sym_function_pointer_parameter,
    STATE(9351), 1,
      sym__ref_base_type,
    STATE(9494), 1,
      sym_implicit_type,
    STATE(9721), 1,
      sym__pointer_base_type,
    ACTIONS(6406), 3,
      anon_sym_ref,
      anon_sym_in,
      anon_sym_out,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(8397), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4464), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_function_pointer_type_repeat1,
    ACTIONS(6400), 21,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [4192] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6276), 1,
      anon_sym_in,
    ACTIONS(6298), 1,
      anon_sym_QMARK,
    ACTIONS(6304), 1,
      anon_sym_SLASH,
    ACTIONS(6306), 1,
      anon_sym_CARET,
    ACTIONS(6308), 1,
      anon_sym_PIPE,
    ACTIONS(6310), 1,
      anon_sym_AMP,
    ACTIONS(6314), 1,
      anon_sym_GT_GT,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6322), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6324), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6326), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6328), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6330), 1,
      anon_sym_as,
    ACTIONS(6332), 1,
      anon_sym_is,
    ACTIONS(6334), 1,
      anon_sym_with,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6296), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6300), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6302), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6312), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6316), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6318), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4465), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6274), 11,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [4337] = 32,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2693), 1,
      anon_sym_readonly,
    ACTIONS(2983), 1,
      sym__identifier_token,
    ACTIONS(2995), 1,
      anon_sym_LPAREN,
    ACTIONS(3021), 1,
      anon_sym_scoped,
    ACTIONS(3023), 1,
      anon_sym_var,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3726), 1,
      anon_sym_ref,
    ACTIONS(3728), 1,
      anon_sym_delegate,
    ACTIONS(4533), 1,
      anon_sym_struct,
    STATE(4443), 1,
      sym__reserved_identifier,
    STATE(4921), 1,
      sym_identifier,
    STATE(4959), 1,
      sym_generic_name,
    STATE(5237), 1,
      sym_tuple_type,
    STATE(5381), 1,
      sym__name,
    STATE(5548), 1,
      sym_array_type,
    STATE(5969), 1,
      sym_type,
    STATE(8768), 1,
      sym__array_base_type,
    STATE(9721), 1,
      sym__pointer_base_type,
    STATE(2898), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5234), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4466), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2987), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [4466] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5624), 2,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
    STATE(4467), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5622), 45,
      anon_sym_extern,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_unsafe,
      anon_sym_static,
      anon_sym_ref,
      anon_sym_delegate,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_file,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_required,
      anon_sym_sealed,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      sym_predefined_type,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [4555] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5165), 1,
      anon_sym_DOT,
    ACTIONS(5167), 1,
      anon_sym_DASH_GT,
    ACTIONS(6008), 1,
      anon_sym_LPAREN,
    ACTIONS(6038), 1,
      anon_sym_LBRACK,
    ACTIONS(6044), 1,
      anon_sym_BANG,
    ACTIONS(6068), 1,
      anon_sym_switch,
    ACTIONS(6082), 1,
      anon_sym_with,
    ACTIONS(6344), 1,
      anon_sym_SLASH,
    ACTIONS(6360), 1,
      anon_sym_DOT_DOT,
    STATE(3551), 1,
      sym_bracketed_argument_list,
    STATE(4571), 1,
      sym_argument_list,
    ACTIONS(6046), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6340), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6342), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6116), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_as,
    STATE(4468), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 22,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
  [4672] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5165), 1,
      anon_sym_DOT,
    ACTIONS(5167), 1,
      anon_sym_DASH_GT,
    ACTIONS(6008), 1,
      anon_sym_LPAREN,
    ACTIONS(6038), 1,
      anon_sym_LBRACK,
    ACTIONS(6044), 1,
      anon_sym_BANG,
    ACTIONS(6068), 1,
      anon_sym_switch,
    ACTIONS(6082), 1,
      anon_sym_with,
    ACTIONS(6360), 1,
      anon_sym_DOT_DOT,
    STATE(3551), 1,
      sym_bracketed_argument_list,
    STATE(4571), 1,
      sym_argument_list,
    ACTIONS(6046), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(4469), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6116), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(6114), 24,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
  [4783] = 25,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5165), 1,
      anon_sym_DOT,
    ACTIONS(5167), 1,
      anon_sym_DASH_GT,
    ACTIONS(6008), 1,
      anon_sym_LPAREN,
    ACTIONS(6038), 1,
      anon_sym_LBRACK,
    ACTIONS(6044), 1,
      anon_sym_BANG,
    ACTIONS(6068), 1,
      anon_sym_switch,
    ACTIONS(6082), 1,
      anon_sym_with,
    ACTIONS(6344), 1,
      anon_sym_SLASH,
    ACTIONS(6360), 1,
      anon_sym_DOT_DOT,
    STATE(3551), 1,
      sym_bracketed_argument_list,
    STATE(4571), 1,
      sym_argument_list,
    ACTIONS(6046), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6342), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    STATE(4470), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6116), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(6114), 22,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
  [4898] = 28,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5165), 1,
      anon_sym_DOT,
    ACTIONS(5167), 1,
      anon_sym_DASH_GT,
    ACTIONS(6008), 1,
      anon_sym_LPAREN,
    ACTIONS(6038), 1,
      anon_sym_LBRACK,
    ACTIONS(6044), 1,
      anon_sym_BANG,
    ACTIONS(6068), 1,
      anon_sym_switch,
    ACTIONS(6082), 1,
      anon_sym_with,
    ACTIONS(6344), 1,
      anon_sym_SLASH,
    ACTIONS(6354), 1,
      anon_sym_GT_GT,
    ACTIONS(6360), 1,
      anon_sym_DOT_DOT,
    STATE(3551), 1,
      sym_bracketed_argument_list,
    STATE(4571), 1,
      sym_argument_list,
    ACTIONS(6046), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6340), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6342), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6352), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6116), 7,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_as,
    STATE(4471), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 20,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
  [5019] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5165), 1,
      anon_sym_DOT,
    ACTIONS(5167), 1,
      anon_sym_DASH_GT,
    ACTIONS(6008), 1,
      anon_sym_LPAREN,
    ACTIONS(6038), 1,
      anon_sym_LBRACK,
    ACTIONS(6044), 1,
      anon_sym_BANG,
    ACTIONS(6068), 1,
      anon_sym_switch,
    ACTIONS(6082), 1,
      anon_sym_with,
    ACTIONS(6222), 1,
      anon_sym_or,
    ACTIONS(6338), 1,
      anon_sym_QMARK,
    ACTIONS(6344), 1,
      anon_sym_SLASH,
    ACTIONS(6346), 1,
      anon_sym_CARET,
    ACTIONS(6348), 1,
      anon_sym_PIPE,
    ACTIONS(6350), 1,
      anon_sym_AMP,
    ACTIONS(6354), 1,
      anon_sym_GT_GT,
    ACTIONS(6360), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6362), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6364), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6366), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6368), 1,
      anon_sym_as,
    ACTIONS(6370), 1,
      anon_sym_is,
    STATE(3551), 1,
      sym_bracketed_argument_list,
    STATE(4571), 1,
      sym_argument_list,
    ACTIONS(6046), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6336), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6340), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6342), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6352), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6356), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6358), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4472), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6220), 11,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [5164] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5612), 2,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
    STATE(4473), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5610), 45,
      anon_sym_extern,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_unsafe,
      anon_sym_static,
      anon_sym_ref,
      anon_sym_delegate,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_file,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_required,
      anon_sym_sealed,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      sym_predefined_type,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [5253] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5635), 2,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
    STATE(4474), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5633), 45,
      anon_sym_extern,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_unsafe,
      anon_sym_static,
      anon_sym_ref,
      anon_sym_delegate,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_file,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_required,
      anon_sym_sealed,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      sym_predefined_type,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [5342] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5165), 1,
      anon_sym_DOT,
    ACTIONS(5167), 1,
      anon_sym_DASH_GT,
    ACTIONS(6008), 1,
      anon_sym_LPAREN,
    ACTIONS(6038), 1,
      anon_sym_LBRACK,
    ACTIONS(6044), 1,
      anon_sym_BANG,
    ACTIONS(6360), 1,
      anon_sym_DOT_DOT,
    STATE(3551), 1,
      sym_bracketed_argument_list,
    STATE(4571), 1,
      sym_argument_list,
    ACTIONS(6046), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(4475), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6122), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(6120), 26,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_with,
  [5449] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6385), 1,
      anon_sym_into,
    STATE(4439), 1,
      aux_sym__query_body_repeat2,
    STATE(4476), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6420), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(6418), 32,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [5542] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6422), 1,
      anon_sym_EQ,
    STATE(4477), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6424), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(5249), 17,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
    ACTIONS(5251), 17,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_DOT,
      anon_sym_QMARK_QMARK,
  [5635] = 32,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2693), 1,
      anon_sym_readonly,
    ACTIONS(2983), 1,
      sym__identifier_token,
    ACTIONS(2995), 1,
      anon_sym_LPAREN,
    ACTIONS(3021), 1,
      anon_sym_scoped,
    ACTIONS(3023), 1,
      anon_sym_var,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3726), 1,
      anon_sym_ref,
    ACTIONS(3728), 1,
      anon_sym_delegate,
    ACTIONS(4513), 1,
      anon_sym_struct,
    STATE(4443), 1,
      sym__reserved_identifier,
    STATE(4921), 1,
      sym_identifier,
    STATE(4959), 1,
      sym_generic_name,
    STATE(5237), 1,
      sym_tuple_type,
    STATE(5381), 1,
      sym__name,
    STATE(5548), 1,
      sym_array_type,
    STATE(5969), 1,
      sym_type,
    STATE(8768), 1,
      sym__array_base_type,
    STATE(9721), 1,
      sym__pointer_base_type,
    STATE(2898), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5234), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4478), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2987), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [5764] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6385), 1,
      anon_sym_into,
    STATE(4437), 1,
      aux_sym__query_body_repeat2,
    STATE(4479), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6420), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(6418), 32,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [5857] = 32,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2693), 1,
      anon_sym_readonly,
    ACTIONS(2983), 1,
      sym__identifier_token,
    ACTIONS(2995), 1,
      anon_sym_LPAREN,
    ACTIONS(3021), 1,
      anon_sym_scoped,
    ACTIONS(3023), 1,
      anon_sym_var,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3726), 1,
      anon_sym_ref,
    ACTIONS(3728), 1,
      anon_sym_delegate,
    ACTIONS(6426), 1,
      anon_sym_struct,
    STATE(4443), 1,
      sym__reserved_identifier,
    STATE(4921), 1,
      sym_identifier,
    STATE(4959), 1,
      sym_generic_name,
    STATE(5237), 1,
      sym_tuple_type,
    STATE(5381), 1,
      sym__name,
    STATE(5548), 1,
      sym_array_type,
    STATE(5969), 1,
      sym_type,
    STATE(8768), 1,
      sym__array_base_type,
    STATE(9721), 1,
      sym__pointer_base_type,
    STATE(2898), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5234), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4480), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2987), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [5986] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5165), 1,
      anon_sym_DOT,
    ACTIONS(5167), 1,
      anon_sym_DASH_GT,
    ACTIONS(6008), 1,
      anon_sym_LPAREN,
    ACTIONS(6038), 1,
      anon_sym_LBRACK,
    ACTIONS(6044), 1,
      anon_sym_BANG,
    ACTIONS(6068), 1,
      anon_sym_switch,
    ACTIONS(6082), 1,
      anon_sym_with,
    ACTIONS(6175), 1,
      anon_sym_or,
    ACTIONS(6338), 1,
      anon_sym_QMARK,
    ACTIONS(6344), 1,
      anon_sym_SLASH,
    ACTIONS(6346), 1,
      anon_sym_CARET,
    ACTIONS(6348), 1,
      anon_sym_PIPE,
    ACTIONS(6350), 1,
      anon_sym_AMP,
    ACTIONS(6354), 1,
      anon_sym_GT_GT,
    ACTIONS(6360), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6362), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6364), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6366), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6368), 1,
      anon_sym_as,
    ACTIONS(6370), 1,
      anon_sym_is,
    STATE(3551), 1,
      sym_bracketed_argument_list,
    STATE(4571), 1,
      sym_argument_list,
    ACTIONS(6046), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6336), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6340), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6342), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6352), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6356), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6358), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4481), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6173), 11,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [6131] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6428), 1,
      anon_sym_EQ,
    STATE(4482), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6430), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(5249), 17,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
    ACTIONS(5251), 17,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_DOT,
      anon_sym_QMARK_QMARK,
  [6224] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6238), 1,
      anon_sym_in,
    ACTIONS(6298), 1,
      anon_sym_QMARK,
    ACTIONS(6304), 1,
      anon_sym_SLASH,
    ACTIONS(6306), 1,
      anon_sym_CARET,
    ACTIONS(6308), 1,
      anon_sym_PIPE,
    ACTIONS(6310), 1,
      anon_sym_AMP,
    ACTIONS(6314), 1,
      anon_sym_GT_GT,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6322), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6324), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6326), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6328), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6330), 1,
      anon_sym_as,
    ACTIONS(6332), 1,
      anon_sym_is,
    ACTIONS(6334), 1,
      anon_sym_with,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6296), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6300), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6302), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6312), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6316), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6318), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4483), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6236), 11,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [6369] = 28,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6304), 1,
      anon_sym_SLASH,
    ACTIONS(6314), 1,
      anon_sym_GT_GT,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6322), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6334), 1,
      anon_sym_with,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6300), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6302), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6312), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6116), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(4484), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 21,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [6490] = 25,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6304), 1,
      anon_sym_SLASH,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6322), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6334), 1,
      anon_sym_with,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6302), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    STATE(4485), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6116), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6114), 23,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [6605] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6322), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6334), 1,
      anon_sym_with,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(4486), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6116), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6114), 25,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [6716] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6304), 1,
      anon_sym_SLASH,
    ACTIONS(6310), 1,
      anon_sym_AMP,
    ACTIONS(6314), 1,
      anon_sym_GT_GT,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6322), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6330), 1,
      anon_sym_as,
    ACTIONS(6332), 1,
      anon_sym_is,
    ACTIONS(6334), 1,
      anon_sym_with,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6296), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6300), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6302), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6312), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6316), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6318), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6116), 3,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PIPE,
    STATE(4487), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 15,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [6849] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6304), 1,
      anon_sym_SLASH,
    ACTIONS(6306), 1,
      anon_sym_CARET,
    ACTIONS(6310), 1,
      anon_sym_AMP,
    ACTIONS(6314), 1,
      anon_sym_GT_GT,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6322), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6330), 1,
      anon_sym_as,
    ACTIONS(6332), 1,
      anon_sym_is,
    ACTIONS(6334), 1,
      anon_sym_with,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6296), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6300), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6302), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6312), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6316), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6318), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6116), 3,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PIPE,
    STATE(4488), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 14,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [6984] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6432), 1,
      sym_string_literal_encoding,
    STATE(4489), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5294), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5292), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [7075] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6304), 1,
      anon_sym_SLASH,
    ACTIONS(6314), 1,
      anon_sym_GT_GT,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6322), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6330), 1,
      anon_sym_as,
    ACTIONS(6332), 1,
      anon_sym_is,
    ACTIONS(6334), 1,
      anon_sym_with,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6296), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6300), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6302), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6312), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6316), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6318), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6116), 4,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(4490), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 15,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [7206] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6304), 1,
      anon_sym_SLASH,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6322), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6334), 1,
      anon_sym_with,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6300), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6302), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6116), 7,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4491), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 23,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [7323] = 32,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6304), 1,
      anon_sym_SLASH,
    ACTIONS(6314), 1,
      anon_sym_GT_GT,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6322), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6330), 1,
      anon_sym_as,
    ACTIONS(6332), 1,
      anon_sym_is,
    ACTIONS(6334), 1,
      anon_sym_with,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6296), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6300), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6302), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6312), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6318), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6116), 4,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(4492), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 17,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [7452] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6322), 1,
      anon_sym_DOT_DOT,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(4493), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6122), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6120), 27,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [7559] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6304), 1,
      anon_sym_SLASH,
    ACTIONS(6306), 1,
      anon_sym_CARET,
    ACTIONS(6308), 1,
      anon_sym_PIPE,
    ACTIONS(6310), 1,
      anon_sym_AMP,
    ACTIONS(6314), 1,
      anon_sym_GT_GT,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6322), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6330), 1,
      anon_sym_as,
    ACTIONS(6332), 1,
      anon_sym_is,
    ACTIONS(6334), 1,
      anon_sym_with,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6116), 2,
      anon_sym_in,
      anon_sym_QMARK,
    ACTIONS(6296), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6300), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6302), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6312), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6316), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6318), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4494), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 14,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [7696] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6434), 1,
      anon_sym_EQ,
    STATE(4495), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6436), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(5249), 17,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
    ACTIONS(5251), 17,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_DOT,
      anon_sym_QMARK_QMARK,
  [7789] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6304), 1,
      anon_sym_SLASH,
    ACTIONS(6306), 1,
      anon_sym_CARET,
    ACTIONS(6308), 1,
      anon_sym_PIPE,
    ACTIONS(6310), 1,
      anon_sym_AMP,
    ACTIONS(6314), 1,
      anon_sym_GT_GT,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6322), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6324), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6330), 1,
      anon_sym_as,
    ACTIONS(6332), 1,
      anon_sym_is,
    ACTIONS(6334), 1,
      anon_sym_with,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6116), 2,
      anon_sym_in,
      anon_sym_QMARK,
    ACTIONS(6296), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6300), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6302), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6312), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6316), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6318), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4496), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 13,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [7928] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6304), 1,
      anon_sym_SLASH,
    ACTIONS(6306), 1,
      anon_sym_CARET,
    ACTIONS(6308), 1,
      anon_sym_PIPE,
    ACTIONS(6310), 1,
      anon_sym_AMP,
    ACTIONS(6314), 1,
      anon_sym_GT_GT,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6322), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6324), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6326), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6328), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6330), 1,
      anon_sym_as,
    ACTIONS(6332), 1,
      anon_sym_is,
    ACTIONS(6334), 1,
      anon_sym_with,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6116), 2,
      anon_sym_in,
      anon_sym_QMARK,
    ACTIONS(6296), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6300), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6302), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6312), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6316), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6318), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4497), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 11,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [8071] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6438), 1,
      anon_sym_EQ,
    STATE(4498), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6440), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(5249), 17,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
    ACTIONS(5251), 17,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_DOT,
      anon_sym_QMARK_QMARK,
  [8164] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6232), 1,
      anon_sym_in,
    ACTIONS(6298), 1,
      anon_sym_QMARK,
    ACTIONS(6304), 1,
      anon_sym_SLASH,
    ACTIONS(6306), 1,
      anon_sym_CARET,
    ACTIONS(6308), 1,
      anon_sym_PIPE,
    ACTIONS(6310), 1,
      anon_sym_AMP,
    ACTIONS(6314), 1,
      anon_sym_GT_GT,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6322), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6324), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6326), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6328), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6330), 1,
      anon_sym_as,
    ACTIONS(6332), 1,
      anon_sym_is,
    ACTIONS(6334), 1,
      anon_sym_with,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6296), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6300), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6302), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6312), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6316), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6318), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4499), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6230), 11,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [8309] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5616), 2,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
    STATE(4500), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5614), 45,
      anon_sym_extern,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_unsafe,
      anon_sym_static,
      anon_sym_ref,
      anon_sym_delegate,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_file,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_required,
      anon_sym_sealed,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      sym_predefined_type,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [8398] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5398), 1,
      anon_sym_in,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6298), 1,
      anon_sym_QMARK,
    ACTIONS(6304), 1,
      anon_sym_SLASH,
    ACTIONS(6306), 1,
      anon_sym_CARET,
    ACTIONS(6308), 1,
      anon_sym_PIPE,
    ACTIONS(6310), 1,
      anon_sym_AMP,
    ACTIONS(6314), 1,
      anon_sym_GT_GT,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6322), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6324), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6326), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6328), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6330), 1,
      anon_sym_as,
    ACTIONS(6332), 1,
      anon_sym_is,
    ACTIONS(6334), 1,
      anon_sym_with,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6296), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6300), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6302), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6312), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6316), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6318), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4501), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5396), 11,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [8543] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4081), 1,
      anon_sym_EQ_GT,
    STATE(4502), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5832), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(4247), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [8634] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6175), 1,
      anon_sym_in,
    ACTIONS(6298), 1,
      anon_sym_QMARK,
    ACTIONS(6304), 1,
      anon_sym_SLASH,
    ACTIONS(6306), 1,
      anon_sym_CARET,
    ACTIONS(6308), 1,
      anon_sym_PIPE,
    ACTIONS(6310), 1,
      anon_sym_AMP,
    ACTIONS(6314), 1,
      anon_sym_GT_GT,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6322), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6324), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6326), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6328), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6330), 1,
      anon_sym_as,
    ACTIONS(6332), 1,
      anon_sym_is,
    ACTIONS(6334), 1,
      anon_sym_with,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6296), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6300), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6302), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6312), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6316), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6318), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4503), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6173), 11,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [8779] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6222), 1,
      anon_sym_in,
    ACTIONS(6298), 1,
      anon_sym_QMARK,
    ACTIONS(6304), 1,
      anon_sym_SLASH,
    ACTIONS(6306), 1,
      anon_sym_CARET,
    ACTIONS(6308), 1,
      anon_sym_PIPE,
    ACTIONS(6310), 1,
      anon_sym_AMP,
    ACTIONS(6314), 1,
      anon_sym_GT_GT,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6322), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6324), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6326), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6328), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6330), 1,
      anon_sym_as,
    ACTIONS(6332), 1,
      anon_sym_is,
    ACTIONS(6334), 1,
      anon_sym_with,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6296), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6300), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6302), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6312), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6316), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6318), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4504), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6220), 11,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [8924] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5422), 1,
      anon_sym_in,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6298), 1,
      anon_sym_QMARK,
    ACTIONS(6304), 1,
      anon_sym_SLASH,
    ACTIONS(6306), 1,
      anon_sym_CARET,
    ACTIONS(6308), 1,
      anon_sym_PIPE,
    ACTIONS(6310), 1,
      anon_sym_AMP,
    ACTIONS(6314), 1,
      anon_sym_GT_GT,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6322), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6324), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6326), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6328), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6330), 1,
      anon_sym_as,
    ACTIONS(6332), 1,
      anon_sym_is,
    ACTIONS(6334), 1,
      anon_sym_with,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6296), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6300), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6302), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6312), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6316), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6318), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4505), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5420), 11,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [9069] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4506), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3976), 47,
      anon_sym_extern,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_unsafe,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_file,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_required,
      anon_sym_sealed,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_init,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [9156] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6442), 1,
      anon_sym_EQ,
    STATE(4507), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6444), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(5249), 17,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
    ACTIONS(5251), 17,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_DOT,
      anon_sym_QMARK_QMARK,
  [9249] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4508), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5290), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5288), 34,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [9338] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5165), 1,
      anon_sym_DOT,
    ACTIONS(5167), 1,
      anon_sym_DASH_GT,
    ACTIONS(6008), 1,
      anon_sym_LPAREN,
    ACTIONS(6038), 1,
      anon_sym_LBRACK,
    ACTIONS(6044), 1,
      anon_sym_BANG,
    ACTIONS(6360), 1,
      anon_sym_DOT_DOT,
    STATE(3551), 1,
      sym_bracketed_argument_list,
    STATE(4571), 1,
      sym_argument_list,
    ACTIONS(6046), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(4509), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1147), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(1133), 26,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_with,
  [9445] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6385), 1,
      anon_sym_into,
    STATE(4479), 1,
      aux_sym__query_body_repeat2,
    STATE(4510), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6448), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(6446), 32,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [9538] = 32,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2693), 1,
      anon_sym_readonly,
    ACTIONS(2983), 1,
      sym__identifier_token,
    ACTIONS(2995), 1,
      anon_sym_LPAREN,
    ACTIONS(3021), 1,
      anon_sym_scoped,
    ACTIONS(3023), 1,
      anon_sym_var,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3726), 1,
      anon_sym_ref,
    ACTIONS(3728), 1,
      anon_sym_delegate,
    ACTIONS(6450), 1,
      anon_sym_struct,
    STATE(4443), 1,
      sym__reserved_identifier,
    STATE(4921), 1,
      sym_identifier,
    STATE(4959), 1,
      sym_generic_name,
    STATE(5237), 1,
      sym_tuple_type,
    STATE(5381), 1,
      sym__name,
    STATE(5548), 1,
      sym_array_type,
    STATE(5969), 1,
      sym_type,
    STATE(8768), 1,
      sym__array_base_type,
    STATE(9721), 1,
      sym__pointer_base_type,
    STATE(2898), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5234), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4511), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2987), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [9667] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5327), 1,
      anon_sym_in,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6298), 1,
      anon_sym_QMARK,
    ACTIONS(6304), 1,
      anon_sym_SLASH,
    ACTIONS(6306), 1,
      anon_sym_CARET,
    ACTIONS(6308), 1,
      anon_sym_PIPE,
    ACTIONS(6310), 1,
      anon_sym_AMP,
    ACTIONS(6314), 1,
      anon_sym_GT_GT,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6322), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6324), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6326), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6328), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6330), 1,
      anon_sym_as,
    ACTIONS(6332), 1,
      anon_sym_is,
    ACTIONS(6334), 1,
      anon_sym_with,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6296), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6300), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6302), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6312), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6316), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6318), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4512), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5325), 11,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [9812] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6218), 1,
      anon_sym_in,
    ACTIONS(6298), 1,
      anon_sym_QMARK,
    ACTIONS(6304), 1,
      anon_sym_SLASH,
    ACTIONS(6306), 1,
      anon_sym_CARET,
    ACTIONS(6308), 1,
      anon_sym_PIPE,
    ACTIONS(6310), 1,
      anon_sym_AMP,
    ACTIONS(6314), 1,
      anon_sym_GT_GT,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6322), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6324), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6326), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6328), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6330), 1,
      anon_sym_as,
    ACTIONS(6332), 1,
      anon_sym_is,
    ACTIONS(6334), 1,
      anon_sym_with,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6296), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6300), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6302), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6312), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6316), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6318), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4513), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6216), 11,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [9957] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5512), 1,
      anon_sym_in,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6298), 1,
      anon_sym_QMARK,
    ACTIONS(6304), 1,
      anon_sym_SLASH,
    ACTIONS(6306), 1,
      anon_sym_CARET,
    ACTIONS(6308), 1,
      anon_sym_PIPE,
    ACTIONS(6310), 1,
      anon_sym_AMP,
    ACTIONS(6314), 1,
      anon_sym_GT_GT,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6322), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6324), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6326), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6328), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6330), 1,
      anon_sym_as,
    ACTIONS(6332), 1,
      anon_sym_is,
    ACTIONS(6334), 1,
      anon_sym_with,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6296), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6300), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6302), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6312), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6316), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6318), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4514), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5510), 11,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [10102] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5339), 1,
      anon_sym_in,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6298), 1,
      anon_sym_QMARK,
    ACTIONS(6304), 1,
      anon_sym_SLASH,
    ACTIONS(6306), 1,
      anon_sym_CARET,
    ACTIONS(6308), 1,
      anon_sym_PIPE,
    ACTIONS(6310), 1,
      anon_sym_AMP,
    ACTIONS(6314), 1,
      anon_sym_GT_GT,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6322), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6324), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6326), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6328), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6330), 1,
      anon_sym_as,
    ACTIONS(6332), 1,
      anon_sym_is,
    ACTIONS(6334), 1,
      anon_sym_with,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6296), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6300), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6302), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6312), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6316), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6318), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4515), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5337), 11,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [10247] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4516), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5476), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5474), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [10335] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2983), 1,
      sym__identifier_token,
    ACTIONS(2995), 1,
      anon_sym_LPAREN,
    ACTIONS(3023), 1,
      anon_sym_var,
    ACTIONS(5659), 1,
      anon_sym_delegate,
    ACTIONS(5667), 1,
      sym_predefined_type,
    ACTIONS(5886), 1,
      anon_sym_scoped,
    ACTIONS(6389), 1,
      anon_sym_ref,
    ACTIONS(6391), 1,
      anon_sym_readonly,
    STATE(4443), 1,
      sym__reserved_identifier,
    STATE(4921), 1,
      sym_identifier,
    STATE(4959), 1,
      sym_generic_name,
    STATE(5969), 1,
      sym_type,
    STATE(7762), 1,
      sym__name,
    STATE(8180), 1,
      sym_tuple_type,
    STATE(8215), 1,
      sym_array_type,
    STATE(8768), 1,
      sym__array_base_type,
    STATE(9650), 1,
      sym__pointer_base_type,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5234), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(8704), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4517), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2987), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [10461] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2983), 1,
      sym__identifier_token,
    ACTIONS(2995), 1,
      anon_sym_LPAREN,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3728), 1,
      anon_sym_delegate,
    ACTIONS(5284), 1,
      anon_sym_var,
    ACTIONS(5912), 1,
      anon_sym_ref,
    ACTIONS(5920), 1,
      anon_sym_scoped,
    ACTIONS(6452), 1,
      anon_sym_readonly,
    STATE(4443), 1,
      sym__reserved_identifier,
    STATE(4921), 1,
      sym_identifier,
    STATE(4959), 1,
      sym_generic_name,
    STATE(5237), 1,
      sym_tuple_type,
    STATE(5381), 1,
      sym__name,
    STATE(5548), 1,
      sym_array_type,
    STATE(5969), 1,
      sym_type,
    STATE(8768), 1,
      sym__array_base_type,
    STATE(9721), 1,
      sym__pointer_base_type,
    STATE(2898), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5234), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4518), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2987), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [10587] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4519), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5814), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5812), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [10675] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5773), 1,
      anon_sym_LPAREN,
    STATE(4520), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3976), 45,
      anon_sym_extern,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_unsafe,
      anon_sym_static,
      anon_sym_ref,
      anon_sym_delegate,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_file,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_required,
      anon_sym_sealed,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      sym_predefined_type,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [10763] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4521), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5516), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5514), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [10851] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4522), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5822), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5820), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [10939] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5165), 1,
      anon_sym_DOT,
    ACTIONS(5167), 1,
      anon_sym_DASH_GT,
    ACTIONS(6008), 1,
      anon_sym_LPAREN,
    ACTIONS(6038), 1,
      anon_sym_LBRACK,
    ACTIONS(6044), 1,
      anon_sym_BANG,
    ACTIONS(6068), 1,
      anon_sym_switch,
    ACTIONS(6078), 1,
      anon_sym_as,
    ACTIONS(6082), 1,
      anon_sym_with,
    ACTIONS(6456), 1,
      anon_sym_QMARK,
    ACTIONS(6462), 1,
      anon_sym_SLASH,
    ACTIONS(6464), 1,
      anon_sym_CARET,
    ACTIONS(6466), 1,
      anon_sym_PIPE,
    ACTIONS(6468), 1,
      anon_sym_AMP,
    ACTIONS(6472), 1,
      anon_sym_GT_GT,
    ACTIONS(6478), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6480), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6482), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6484), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6486), 1,
      anon_sym_is,
    STATE(3551), 1,
      sym_bracketed_argument_list,
    STATE(4571), 1,
      sym_argument_list,
    ACTIONS(6046), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6454), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6458), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6460), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6470), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6474), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6476), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4523), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6220), 11,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [11081] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5165), 1,
      anon_sym_DOT,
    ACTIONS(5167), 1,
      anon_sym_DASH_GT,
    ACTIONS(6008), 1,
      anon_sym_LPAREN,
    ACTIONS(6038), 1,
      anon_sym_LBRACK,
    ACTIONS(6044), 1,
      anon_sym_BANG,
    ACTIONS(6478), 1,
      anon_sym_DOT_DOT,
    STATE(3551), 1,
      sym_bracketed_argument_list,
    STATE(4571), 1,
      sym_argument_list,
    ACTIONS(6046), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(4524), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1147), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
    ACTIONS(1133), 26,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_with,
  [11187] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2983), 1,
      sym__identifier_token,
    ACTIONS(2995), 1,
      anon_sym_LPAREN,
    ACTIONS(3023), 1,
      anon_sym_var,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3728), 1,
      anon_sym_delegate,
    ACTIONS(6488), 1,
      anon_sym_ref,
    ACTIONS(6490), 1,
      anon_sym_checked,
    ACTIONS(6492), 1,
      anon_sym_scoped,
    STATE(4443), 1,
      sym__reserved_identifier,
    STATE(4921), 1,
      sym_identifier,
    STATE(4959), 1,
      sym_generic_name,
    STATE(5237), 1,
      sym_tuple_type,
    STATE(5381), 1,
      sym__name,
    STATE(5548), 1,
      sym_array_type,
    STATE(8768), 1,
      sym__array_base_type,
    STATE(8894), 1,
      sym_type,
    STATE(9721), 1,
      sym__pointer_base_type,
    STATE(2898), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5234), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4525), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2987), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [11313] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4526), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5578), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5576), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [11401] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2983), 1,
      sym__identifier_token,
    ACTIONS(2995), 1,
      anon_sym_LPAREN,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3728), 1,
      anon_sym_delegate,
    ACTIONS(4054), 1,
      anon_sym_ref,
    ACTIONS(6494), 1,
      anon_sym_scoped,
    ACTIONS(6496), 1,
      anon_sym_var,
    STATE(4443), 1,
      sym__reserved_identifier,
    STATE(4921), 1,
      sym_identifier,
    STATE(4959), 1,
      sym_generic_name,
    STATE(5237), 1,
      sym_tuple_type,
    STATE(5381), 1,
      sym__name,
    STATE(5548), 1,
      sym_array_type,
    STATE(7204), 1,
      sym_type,
    STATE(8768), 1,
      sym__array_base_type,
    STATE(8911), 1,
      sym_tuple_element,
    STATE(9721), 1,
      sym__pointer_base_type,
    STATE(2898), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5234), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4527), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2987), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [11527] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2983), 1,
      sym__identifier_token,
    ACTIONS(2995), 1,
      anon_sym_LPAREN,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3728), 1,
      anon_sym_delegate,
    ACTIONS(6496), 1,
      anon_sym_var,
    ACTIONS(6498), 1,
      anon_sym_ref,
    ACTIONS(6500), 1,
      anon_sym_readonly,
    ACTIONS(6502), 1,
      anon_sym_scoped,
    STATE(4443), 1,
      sym__reserved_identifier,
    STATE(4921), 1,
      sym_identifier,
    STATE(4959), 1,
      sym_generic_name,
    STATE(5237), 1,
      sym_tuple_type,
    STATE(5381), 1,
      sym__name,
    STATE(5548), 1,
      sym_array_type,
    STATE(5969), 1,
      sym_type,
    STATE(8768), 1,
      sym__array_base_type,
    STATE(9721), 1,
      sym__pointer_base_type,
    STATE(2898), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5234), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4528), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2987), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [11653] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2983), 1,
      sym__identifier_token,
    ACTIONS(2995), 1,
      anon_sym_LPAREN,
    ACTIONS(3023), 1,
      anon_sym_var,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3728), 1,
      anon_sym_delegate,
    ACTIONS(6488), 1,
      anon_sym_ref,
    ACTIONS(6492), 1,
      anon_sym_scoped,
    ACTIONS(6504), 1,
      anon_sym_checked,
    STATE(4443), 1,
      sym__reserved_identifier,
    STATE(4921), 1,
      sym_identifier,
    STATE(4959), 1,
      sym_generic_name,
    STATE(5237), 1,
      sym_tuple_type,
    STATE(5381), 1,
      sym__name,
    STATE(5548), 1,
      sym_array_type,
    STATE(8699), 1,
      sym_type,
    STATE(8768), 1,
      sym__array_base_type,
    STATE(9721), 1,
      sym__pointer_base_type,
    STATE(2898), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5234), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4529), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2987), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [11779] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2791), 1,
      anon_sym_readonly,
    ACTIONS(3728), 1,
      anon_sym_delegate,
    ACTIONS(4014), 1,
      anon_sym_ref,
    ACTIONS(4490), 1,
      sym__identifier_token,
    ACTIONS(6153), 1,
      anon_sym_var,
    ACTIONS(6155), 1,
      sym_predefined_type,
    ACTIONS(6506), 1,
      anon_sym_LPAREN,
    ACTIONS(6508), 1,
      anon_sym_scoped,
    STATE(2914), 1,
      sym__reserved_identifier,
    STATE(2949), 1,
      sym_type,
    STATE(2956), 1,
      sym_generic_name,
    STATE(2973), 1,
      sym_tuple_type,
    STATE(2975), 1,
      sym_array_type,
    STATE(3126), 1,
      sym_identifier,
    STATE(3167), 1,
      sym__name,
    STATE(8712), 1,
      sym__array_base_type,
    STATE(9721), 1,
      sym__pointer_base_type,
    STATE(2898), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(2974), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(2977), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4530), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4492), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [11905] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5566), 1,
      anon_sym_LPAREN,
    STATE(4531), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3976), 45,
      anon_sym_extern,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_unsafe,
      anon_sym_static,
      anon_sym_ref,
      anon_sym_delegate,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_file,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_required,
      anon_sym_sealed,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      sym_predefined_type,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [11993] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3728), 1,
      anon_sym_delegate,
    ACTIONS(4490), 1,
      sym__identifier_token,
    ACTIONS(4545), 1,
      anon_sym_ref,
    ACTIONS(6151), 1,
      anon_sym_scoped,
    ACTIONS(6153), 1,
      anon_sym_var,
    ACTIONS(6155), 1,
      sym_predefined_type,
    ACTIONS(6506), 1,
      anon_sym_LPAREN,
    ACTIONS(6510), 1,
      anon_sym_readonly,
    STATE(2913), 1,
      sym_identifier,
    STATE(2914), 1,
      sym__reserved_identifier,
    STATE(2949), 1,
      sym_type,
    STATE(2956), 1,
      sym_generic_name,
    STATE(2973), 1,
      sym_tuple_type,
    STATE(2975), 1,
      sym_array_type,
    STATE(3002), 1,
      sym__name,
    STATE(8712), 1,
      sym__array_base_type,
    STATE(9721), 1,
      sym__pointer_base_type,
    STATE(2898), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(2974), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(2977), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4532), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4492), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [12119] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5566), 1,
      anon_sym_LPAREN,
    STATE(4533), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3976), 45,
      anon_sym_extern,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_unsafe,
      anon_sym_static,
      anon_sym_ref,
      anon_sym_delegate,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_file,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_required,
      anon_sym_sealed,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      sym_predefined_type,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [12207] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4534), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5347), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5345), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [12295] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2983), 1,
      sym__identifier_token,
    ACTIONS(2995), 1,
      anon_sym_LPAREN,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3728), 1,
      anon_sym_delegate,
    ACTIONS(4012), 1,
      anon_sym_ref,
    ACTIONS(5284), 1,
      anon_sym_var,
    ACTIONS(6214), 1,
      anon_sym_scoped,
    STATE(4443), 1,
      sym__reserved_identifier,
    STATE(4921), 1,
      sym_identifier,
    STATE(4959), 1,
      sym_generic_name,
    STATE(5237), 1,
      sym_tuple_type,
    STATE(5381), 1,
      sym__name,
    STATE(5548), 1,
      sym_array_type,
    STATE(7204), 1,
      sym_type,
    STATE(8768), 1,
      sym__array_base_type,
    STATE(8931), 1,
      sym_tuple_element,
    STATE(9721), 1,
      sym__pointer_base_type,
    STATE(2898), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5234), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4535), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2987), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [12421] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2983), 1,
      sym__identifier_token,
    ACTIONS(2995), 1,
      anon_sym_LPAREN,
    ACTIONS(3021), 1,
      anon_sym_scoped,
    ACTIONS(3023), 1,
      anon_sym_var,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3726), 1,
      anon_sym_ref,
    ACTIONS(3728), 1,
      anon_sym_delegate,
    STATE(4443), 1,
      sym__reserved_identifier,
    STATE(4921), 1,
      sym_identifier,
    STATE(4959), 1,
      sym_generic_name,
    STATE(5237), 1,
      sym_tuple_type,
    STATE(5381), 1,
      sym__name,
    STATE(5548), 1,
      sym_array_type,
    STATE(7065), 1,
      sym_type,
    STATE(8768), 1,
      sym__array_base_type,
    STATE(9217), 1,
      sym_variable_declaration,
    STATE(9721), 1,
      sym__pointer_base_type,
    STATE(2898), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5234), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4536), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2987), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [12547] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6512), 1,
      anon_sym_LPAREN,
    STATE(4537), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3976), 45,
      anon_sym_extern,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_unsafe,
      anon_sym_static,
      anon_sym_ref,
      anon_sym_delegate,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_file,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_required,
      anon_sym_sealed,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      sym_predefined_type,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [12635] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2983), 1,
      sym__identifier_token,
    ACTIONS(2995), 1,
      anon_sym_LPAREN,
    ACTIONS(3023), 1,
      anon_sym_var,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3728), 1,
      anon_sym_delegate,
    ACTIONS(6488), 1,
      anon_sym_ref,
    ACTIONS(6492), 1,
      anon_sym_scoped,
    ACTIONS(6514), 1,
      anon_sym_readonly,
    STATE(4443), 1,
      sym__reserved_identifier,
    STATE(4921), 1,
      sym_identifier,
    STATE(4959), 1,
      sym_generic_name,
    STATE(5237), 1,
      sym_tuple_type,
    STATE(5381), 1,
      sym__name,
    STATE(5548), 1,
      sym_array_type,
    STATE(5969), 1,
      sym_type,
    STATE(8768), 1,
      sym__array_base_type,
    STATE(9721), 1,
      sym__pointer_base_type,
    STATE(2898), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5234), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4538), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2987), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [12761] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4539), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5600), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5598), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [12849] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4540), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2967), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(2969), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [12937] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3726), 1,
      anon_sym_ref,
    ACTIONS(4006), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(2738), 1,
      sym_generic_name,
    STATE(2899), 1,
      sym_ref_type,
    STATE(2907), 1,
      sym__scoped_base_type,
    STATE(5368), 1,
      sym_identifier,
    STATE(6160), 1,
      sym__name,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    ACTIONS(3721), 4,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_operator,
      anon_sym_this,
    STATE(4541), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3719), 9,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
    ACTIONS(4009), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [13045] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6516), 1,
      anon_sym_LPAREN,
    STATE(4542), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1941), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(1943), 32,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [13135] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4543), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5562), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5560), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [13223] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4544), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5844), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5842), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [13311] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5651), 1,
      anon_sym_LPAREN,
    STATE(4545), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5649), 45,
      anon_sym_extern,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_unsafe,
      anon_sym_static,
      anon_sym_ref,
      anon_sym_delegate,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_file,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_required,
      anon_sym_sealed,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      sym_predefined_type,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [13399] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4546), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5355), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5353), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [13487] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4547), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5321), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5319), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [13575] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4168), 1,
      sym__identifier_token,
    ACTIONS(4465), 1,
      anon_sym_ref,
    ACTIONS(6206), 1,
      anon_sym_delegate,
    ACTIONS(6210), 1,
      anon_sym_var,
    ACTIONS(6212), 1,
      sym_predefined_type,
    ACTIONS(6278), 1,
      anon_sym_scoped,
    ACTIONS(6518), 1,
      anon_sym_LPAREN,
    ACTIONS(6520), 1,
      anon_sym_readonly,
    STATE(3891), 1,
      sym_identifier,
    STATE(3897), 1,
      sym__reserved_identifier,
    STATE(3950), 1,
      sym_array_type,
    STATE(3962), 1,
      sym_tuple_type,
    STATE(3999), 1,
      sym_type,
    STATE(4047), 1,
      sym_generic_name,
    STATE(4268), 1,
      sym__name,
    STATE(8755), 1,
      sym__array_base_type,
    STATE(9763), 1,
      sym__pointer_base_type,
    STATE(3937), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3954), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3955), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4548), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4170), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [13701] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5165), 1,
      anon_sym_DOT,
    ACTIONS(5167), 1,
      anon_sym_DASH_GT,
    ACTIONS(6008), 1,
      anon_sym_LPAREN,
    ACTIONS(6038), 1,
      anon_sym_LBRACK,
    ACTIONS(6044), 1,
      anon_sym_BANG,
    ACTIONS(6068), 1,
      anon_sym_switch,
    ACTIONS(6078), 1,
      anon_sym_as,
    ACTIONS(6082), 1,
      anon_sym_with,
    ACTIONS(6462), 1,
      anon_sym_SLASH,
    ACTIONS(6468), 1,
      anon_sym_AMP,
    ACTIONS(6472), 1,
      anon_sym_GT_GT,
    ACTIONS(6478), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6486), 1,
      anon_sym_is,
    STATE(3551), 1,
      sym_bracketed_argument_list,
    STATE(4571), 1,
      sym_argument_list,
    ACTIONS(6046), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6116), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(6454), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6458), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6460), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6470), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6474), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6476), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4549), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 15,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [13833] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5165), 1,
      anon_sym_DOT,
    ACTIONS(5167), 1,
      anon_sym_DASH_GT,
    ACTIONS(6008), 1,
      anon_sym_LPAREN,
    ACTIONS(6038), 1,
      anon_sym_LBRACK,
    ACTIONS(6044), 1,
      anon_sym_BANG,
    ACTIONS(6068), 1,
      anon_sym_switch,
    ACTIONS(6078), 1,
      anon_sym_as,
    ACTIONS(6082), 1,
      anon_sym_with,
    ACTIONS(6462), 1,
      anon_sym_SLASH,
    ACTIONS(6464), 1,
      anon_sym_CARET,
    ACTIONS(6468), 1,
      anon_sym_AMP,
    ACTIONS(6472), 1,
      anon_sym_GT_GT,
    ACTIONS(6478), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6486), 1,
      anon_sym_is,
    STATE(3551), 1,
      sym_bracketed_argument_list,
    STATE(4571), 1,
      sym_argument_list,
    ACTIONS(6046), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6116), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(6454), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6458), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6460), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6470), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6474), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6476), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4550), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 14,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [13967] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5165), 1,
      anon_sym_DOT,
    ACTIONS(5167), 1,
      anon_sym_DASH_GT,
    ACTIONS(6008), 1,
      anon_sym_LPAREN,
    ACTIONS(6038), 1,
      anon_sym_LBRACK,
    ACTIONS(6044), 1,
      anon_sym_BANG,
    ACTIONS(6068), 1,
      anon_sym_switch,
    ACTIONS(6078), 1,
      anon_sym_as,
    ACTIONS(6082), 1,
      anon_sym_with,
    ACTIONS(6462), 1,
      anon_sym_SLASH,
    ACTIONS(6472), 1,
      anon_sym_GT_GT,
    ACTIONS(6478), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6486), 1,
      anon_sym_is,
    STATE(3551), 1,
      sym_bracketed_argument_list,
    STATE(4571), 1,
      sym_argument_list,
    ACTIONS(6046), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6454), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6458), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6460), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6470), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6474), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6476), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6116), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(4551), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 15,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [14097] = 32,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5165), 1,
      anon_sym_DOT,
    ACTIONS(5167), 1,
      anon_sym_DASH_GT,
    ACTIONS(6008), 1,
      anon_sym_LPAREN,
    ACTIONS(6038), 1,
      anon_sym_LBRACK,
    ACTIONS(6044), 1,
      anon_sym_BANG,
    ACTIONS(6068), 1,
      anon_sym_switch,
    ACTIONS(6078), 1,
      anon_sym_as,
    ACTIONS(6082), 1,
      anon_sym_with,
    ACTIONS(6462), 1,
      anon_sym_SLASH,
    ACTIONS(6472), 1,
      anon_sym_GT_GT,
    ACTIONS(6478), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6486), 1,
      anon_sym_is,
    STATE(3551), 1,
      sym_bracketed_argument_list,
    STATE(4571), 1,
      sym_argument_list,
    ACTIONS(6046), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6454), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6458), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6460), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6470), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6476), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6116), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(4552), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [14225] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4553), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5251), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5249), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [14313] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5165), 1,
      anon_sym_DOT,
    ACTIONS(5167), 1,
      anon_sym_DASH_GT,
    ACTIONS(6008), 1,
      anon_sym_LPAREN,
    ACTIONS(6038), 1,
      anon_sym_LBRACK,
    ACTIONS(6044), 1,
      anon_sym_BANG,
    ACTIONS(6068), 1,
      anon_sym_switch,
    ACTIONS(6078), 1,
      anon_sym_as,
    ACTIONS(6082), 1,
      anon_sym_with,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6462), 1,
      anon_sym_SLASH,
    ACTIONS(6464), 1,
      anon_sym_CARET,
    ACTIONS(6466), 1,
      anon_sym_PIPE,
    ACTIONS(6468), 1,
      anon_sym_AMP,
    ACTIONS(6472), 1,
      anon_sym_GT_GT,
    ACTIONS(6478), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6486), 1,
      anon_sym_is,
    STATE(3551), 1,
      sym_bracketed_argument_list,
    STATE(4571), 1,
      sym_argument_list,
    ACTIONS(6046), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6454), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6458), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6460), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6470), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6474), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6476), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4554), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 14,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [14449] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5165), 1,
      anon_sym_DOT,
    ACTIONS(5167), 1,
      anon_sym_DASH_GT,
    ACTIONS(6008), 1,
      anon_sym_LPAREN,
    ACTIONS(6038), 1,
      anon_sym_LBRACK,
    ACTIONS(6044), 1,
      anon_sym_BANG,
    ACTIONS(6068), 1,
      anon_sym_switch,
    ACTIONS(6078), 1,
      anon_sym_as,
    ACTIONS(6082), 1,
      anon_sym_with,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6462), 1,
      anon_sym_SLASH,
    ACTIONS(6464), 1,
      anon_sym_CARET,
    ACTIONS(6466), 1,
      anon_sym_PIPE,
    ACTIONS(6468), 1,
      anon_sym_AMP,
    ACTIONS(6472), 1,
      anon_sym_GT_GT,
    ACTIONS(6478), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6480), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6486), 1,
      anon_sym_is,
    STATE(3551), 1,
      sym_bracketed_argument_list,
    STATE(4571), 1,
      sym_argument_list,
    ACTIONS(6046), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6454), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6458), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6460), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6470), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6474), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6476), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4555), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 13,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [14587] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2983), 1,
      sym__identifier_token,
    ACTIONS(2995), 1,
      anon_sym_LPAREN,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3728), 1,
      anon_sym_delegate,
    ACTIONS(4012), 1,
      anon_sym_ref,
    ACTIONS(5284), 1,
      anon_sym_var,
    ACTIONS(6214), 1,
      anon_sym_scoped,
    STATE(4443), 1,
      sym__reserved_identifier,
    STATE(4921), 1,
      sym_identifier,
    STATE(4959), 1,
      sym_generic_name,
    STATE(5237), 1,
      sym_tuple_type,
    STATE(5381), 1,
      sym__name,
    STATE(5548), 1,
      sym_array_type,
    STATE(7204), 1,
      sym_type,
    STATE(8768), 1,
      sym__array_base_type,
    STATE(8952), 1,
      sym_tuple_element,
    STATE(9721), 1,
      sym__pointer_base_type,
    STATE(2898), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5234), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4556), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2987), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [14713] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5165), 1,
      anon_sym_DOT,
    ACTIONS(5167), 1,
      anon_sym_DASH_GT,
    ACTIONS(6008), 1,
      anon_sym_LPAREN,
    ACTIONS(6038), 1,
      anon_sym_LBRACK,
    ACTIONS(6044), 1,
      anon_sym_BANG,
    ACTIONS(6068), 1,
      anon_sym_switch,
    ACTIONS(6078), 1,
      anon_sym_as,
    ACTIONS(6082), 1,
      anon_sym_with,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6462), 1,
      anon_sym_SLASH,
    ACTIONS(6464), 1,
      anon_sym_CARET,
    ACTIONS(6466), 1,
      anon_sym_PIPE,
    ACTIONS(6468), 1,
      anon_sym_AMP,
    ACTIONS(6472), 1,
      anon_sym_GT_GT,
    ACTIONS(6478), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6480), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6482), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6484), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6486), 1,
      anon_sym_is,
    STATE(3551), 1,
      sym_bracketed_argument_list,
    STATE(4571), 1,
      sym_argument_list,
    ACTIONS(6046), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6454), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6458), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6460), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6470), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6474), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6476), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4557), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 11,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [14855] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4558), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5488), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5486), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [14943] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4559), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5480), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5478), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [15031] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4287), 1,
      sym__identifier_token,
    ACTIONS(4291), 1,
      anon_sym_ref,
    ACTIONS(4455), 1,
      anon_sym_delegate,
    ACTIONS(4457), 1,
      anon_sym_scoped,
    ACTIONS(4459), 1,
      anon_sym_var,
    ACTIONS(4461), 1,
      sym_predefined_type,
    ACTIONS(6522), 1,
      anon_sym_LPAREN,
    ACTIONS(6524), 1,
      anon_sym_readonly,
    STATE(3568), 1,
      sym__reserved_identifier,
    STATE(3590), 1,
      sym_identifier,
    STATE(3633), 1,
      sym_tuple_type,
    STATE(3661), 1,
      sym_array_type,
    STATE(3700), 1,
      sym_type,
    STATE(3708), 1,
      sym_generic_name,
    STATE(3770), 1,
      sym__name,
    STATE(8888), 1,
      sym__array_base_type,
    STATE(9386), 1,
      sym__pointer_base_type,
    STATE(3618), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3635), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(3706), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4560), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4289), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [15157] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2983), 1,
      sym__identifier_token,
    ACTIONS(2995), 1,
      anon_sym_LPAREN,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3728), 1,
      anon_sym_delegate,
    ACTIONS(4012), 1,
      anon_sym_ref,
    ACTIONS(5284), 1,
      anon_sym_var,
    ACTIONS(6214), 1,
      anon_sym_scoped,
    STATE(4443), 1,
      sym__reserved_identifier,
    STATE(4921), 1,
      sym_identifier,
    STATE(4959), 1,
      sym_generic_name,
    STATE(5237), 1,
      sym_tuple_type,
    STATE(5381), 1,
      sym__name,
    STATE(5548), 1,
      sym_array_type,
    STATE(7204), 1,
      sym_type,
    STATE(8706), 1,
      sym_tuple_element,
    STATE(8768), 1,
      sym__array_base_type,
    STATE(9721), 1,
      sym__pointer_base_type,
    STATE(2898), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5234), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4561), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2987), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [15283] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4562), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5450), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5448), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [15371] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2983), 1,
      sym__identifier_token,
    ACTIONS(2995), 1,
      anon_sym_LPAREN,
    ACTIONS(3021), 1,
      anon_sym_scoped,
    ACTIONS(3023), 1,
      anon_sym_var,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3726), 1,
      anon_sym_ref,
    ACTIONS(3728), 1,
      anon_sym_delegate,
    ACTIONS(5982), 1,
      anon_sym_STAR,
    STATE(4443), 1,
      sym__reserved_identifier,
    STATE(4921), 1,
      sym_identifier,
    STATE(4959), 1,
      sym_generic_name,
    STATE(5237), 1,
      sym_tuple_type,
    STATE(5381), 1,
      sym__name,
    STATE(5548), 1,
      sym_array_type,
    STATE(7349), 1,
      sym_type,
    STATE(8768), 1,
      sym__array_base_type,
    STATE(9721), 1,
      sym__pointer_base_type,
    STATE(2898), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5234), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4563), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2987), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [15497] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2795), 1,
      anon_sym_readonly,
    ACTIONS(2983), 1,
      sym__identifier_token,
    ACTIONS(2995), 1,
      anon_sym_LPAREN,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3728), 1,
      anon_sym_delegate,
    ACTIONS(4054), 1,
      anon_sym_ref,
    ACTIONS(6494), 1,
      anon_sym_scoped,
    ACTIONS(6496), 1,
      anon_sym_var,
    STATE(4443), 1,
      sym__reserved_identifier,
    STATE(4921), 1,
      sym_identifier,
    STATE(4959), 1,
      sym_generic_name,
    STATE(5237), 1,
      sym_tuple_type,
    STATE(5381), 1,
      sym__name,
    STATE(5548), 1,
      sym_array_type,
    STATE(5969), 1,
      sym_type,
    STATE(8768), 1,
      sym__array_base_type,
    STATE(9721), 1,
      sym__pointer_base_type,
    STATE(2898), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5234), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4564), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2987), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [15623] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4565), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5351), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5349), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [15711] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2861), 1,
      anon_sym_readonly,
    ACTIONS(4044), 1,
      anon_sym_ref,
    ACTIONS(6526), 1,
      sym__identifier_token,
    ACTIONS(6530), 1,
      anon_sym_LPAREN,
    ACTIONS(6532), 1,
      anon_sym_delegate,
    ACTIONS(6534), 1,
      anon_sym_scoped,
    ACTIONS(6536), 1,
      anon_sym_var,
    ACTIONS(6538), 1,
      sym_predefined_type,
    STATE(3133), 1,
      sym_identifier,
    STATE(3163), 1,
      sym__reserved_identifier,
    STATE(3314), 1,
      sym_generic_name,
    STATE(3348), 1,
      sym_type,
    STATE(3434), 1,
      sym_array_type,
    STATE(3436), 1,
      sym_tuple_type,
    STATE(3450), 1,
      sym__name,
    STATE(8808), 1,
      sym__array_base_type,
    STATE(9626), 1,
      sym__pointer_base_type,
    STATE(3403), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3430), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(3435), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4566), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6528), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [15837] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4567), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5592), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5590), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [15925] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4225), 1,
      sym__identifier_token,
    ACTIONS(4661), 1,
      anon_sym_ref,
    ACTIONS(6165), 1,
      anon_sym_delegate,
    ACTIONS(6169), 1,
      anon_sym_var,
    ACTIONS(6171), 1,
      sym_predefined_type,
    ACTIONS(6183), 1,
      anon_sym_scoped,
    ACTIONS(6540), 1,
      anon_sym_LPAREN,
    ACTIONS(6542), 1,
      anon_sym_readonly,
    STATE(3558), 1,
      sym__reserved_identifier,
    STATE(3583), 1,
      sym_tuple_type,
    STATE(3587), 1,
      sym_array_type,
    STATE(3593), 1,
      sym_type,
    STATE(3608), 1,
      sym_generic_name,
    STATE(3989), 1,
      sym_identifier,
    STATE(4328), 1,
      sym__name,
    STATE(8879), 1,
      sym__array_base_type,
    STATE(9439), 1,
      sym__pointer_base_type,
    STATE(3569), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3585), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3592), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4568), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4227), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [16051] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4569), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5856), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5854), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [16139] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4570), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5574), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5572), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [16227] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4571), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5335), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5333), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [16315] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2983), 1,
      sym__identifier_token,
    ACTIONS(2995), 1,
      anon_sym_LPAREN,
    ACTIONS(3021), 1,
      anon_sym_scoped,
    ACTIONS(3023), 1,
      anon_sym_var,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3726), 1,
      anon_sym_ref,
    ACTIONS(3728), 1,
      anon_sym_delegate,
    STATE(4443), 1,
      sym__reserved_identifier,
    STATE(4959), 1,
      sym_generic_name,
    STATE(5237), 1,
      sym_tuple_type,
    STATE(5381), 1,
      sym__name,
    STATE(5548), 1,
      sym_array_type,
    STATE(6786), 1,
      sym_identifier,
    STATE(7308), 1,
      sym_type,
    STATE(8768), 1,
      sym__array_base_type,
    STATE(8937), 1,
      sym__join_header,
    STATE(9721), 1,
      sym__pointer_base_type,
    STATE(2898), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5234), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4572), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2987), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [16441] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6548), 1,
      anon_sym_and,
    STATE(4573), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6546), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(6544), 32,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [16531] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4574), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5343), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5341), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [16619] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4575), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5418), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5416), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [16707] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4287), 1,
      sym__identifier_token,
    ACTIONS(4455), 1,
      anon_sym_delegate,
    ACTIONS(4459), 1,
      anon_sym_var,
    ACTIONS(4461), 1,
      sym_predefined_type,
    ACTIONS(4657), 1,
      anon_sym_ref,
    ACTIONS(6127), 1,
      anon_sym_scoped,
    ACTIONS(6522), 1,
      anon_sym_LPAREN,
    ACTIONS(6550), 1,
      anon_sym_readonly,
    STATE(3568), 1,
      sym__reserved_identifier,
    STATE(3590), 1,
      sym_identifier,
    STATE(3633), 1,
      sym_tuple_type,
    STATE(3661), 1,
      sym_array_type,
    STATE(3700), 1,
      sym_type,
    STATE(3708), 1,
      sym_generic_name,
    STATE(3770), 1,
      sym__name,
    STATE(8888), 1,
      sym__array_base_type,
    STATE(9386), 1,
      sym__pointer_base_type,
    STATE(3618), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3635), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(3706), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4576), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4289), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [16833] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4287), 1,
      sym__identifier_token,
    ACTIONS(4444), 1,
      anon_sym_ref,
    ACTIONS(4455), 1,
      anon_sym_delegate,
    ACTIONS(4459), 1,
      anon_sym_var,
    ACTIONS(4461), 1,
      sym_predefined_type,
    ACTIONS(6102), 1,
      anon_sym_scoped,
    ACTIONS(6522), 1,
      anon_sym_LPAREN,
    ACTIONS(6552), 1,
      anon_sym_readonly,
    STATE(3568), 1,
      sym__reserved_identifier,
    STATE(3633), 1,
      sym_tuple_type,
    STATE(3661), 1,
      sym_array_type,
    STATE(3700), 1,
      sym_type,
    STATE(3708), 1,
      sym_generic_name,
    STATE(5332), 1,
      sym_identifier,
    STATE(6086), 1,
      sym__name,
    STATE(8888), 1,
      sym__array_base_type,
    STATE(9386), 1,
      sym__pointer_base_type,
    STATE(3618), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3635), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(3706), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4577), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4289), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [16959] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4287), 1,
      sym__identifier_token,
    ACTIONS(4455), 1,
      anon_sym_delegate,
    ACTIONS(4459), 1,
      anon_sym_var,
    ACTIONS(4461), 1,
      sym_predefined_type,
    ACTIONS(4655), 1,
      anon_sym_ref,
    ACTIONS(6106), 1,
      anon_sym_scoped,
    ACTIONS(6522), 1,
      anon_sym_LPAREN,
    ACTIONS(6554), 1,
      anon_sym_readonly,
    STATE(3568), 1,
      sym__reserved_identifier,
    STATE(3590), 1,
      sym_identifier,
    STATE(3633), 1,
      sym_tuple_type,
    STATE(3661), 1,
      sym_array_type,
    STATE(3700), 1,
      sym_type,
    STATE(3708), 1,
      sym_generic_name,
    STATE(3770), 1,
      sym__name,
    STATE(8888), 1,
      sym__array_base_type,
    STATE(9386), 1,
      sym__pointer_base_type,
    STATE(3618), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3635), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(3706), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4578), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4289), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [17085] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4579), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5496), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5494), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [17173] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4580), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5588), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5586), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [17261] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4581), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5363), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5361), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [17349] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4582), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5880), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5878), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [17437] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4583), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5367), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5365), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [17525] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4584), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5848), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5846), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [17613] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4585), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5852), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5850), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [17701] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4586), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2925), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(2927), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [17789] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4587), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5410), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5408), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [17877] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4391), 1,
      sym__identifier_token,
    ACTIONS(4395), 1,
      anon_sym_ref,
    ACTIONS(6090), 1,
      anon_sym_delegate,
    ACTIONS(6092), 1,
      anon_sym_scoped,
    ACTIONS(6094), 1,
      anon_sym_var,
    ACTIONS(6096), 1,
      sym_predefined_type,
    ACTIONS(6556), 1,
      anon_sym_LPAREN,
    ACTIONS(6558), 1,
      anon_sym_readonly,
    STATE(5034), 1,
      sym_identifier,
    STATE(5144), 1,
      sym__reserved_identifier,
    STATE(5211), 1,
      sym_generic_name,
    STATE(5257), 1,
      sym__name,
    STATE(5293), 1,
      sym_tuple_type,
    STATE(5296), 1,
      sym_array_type,
    STATE(5362), 1,
      sym_type,
    STATE(8680), 1,
      sym__array_base_type,
    STATE(9933), 1,
      sym__pointer_base_type,
    STATE(5271), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(5302), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5380), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4588), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4393), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [18003] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4589), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5379), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5377), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [18091] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4590), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5383), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5381), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [18179] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2983), 1,
      sym__identifier_token,
    ACTIONS(2995), 1,
      anon_sym_LPAREN,
    ACTIONS(3021), 1,
      anon_sym_scoped,
    ACTIONS(3023), 1,
      anon_sym_var,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3726), 1,
      anon_sym_ref,
    ACTIONS(3728), 1,
      anon_sym_delegate,
    ACTIONS(5982), 1,
      anon_sym_STAR,
    STATE(4443), 1,
      sym__reserved_identifier,
    STATE(4921), 1,
      sym_identifier,
    STATE(4959), 1,
      sym_generic_name,
    STATE(5237), 1,
      sym_tuple_type,
    STATE(5381), 1,
      sym__name,
    STATE(5548), 1,
      sym_array_type,
    STATE(7338), 1,
      sym_type,
    STATE(8768), 1,
      sym__array_base_type,
    STATE(9721), 1,
      sym__pointer_base_type,
    STATE(2898), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5234), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4591), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2987), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [18305] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4592), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5558), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5556), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [18393] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4593), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4697), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(4695), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [18481] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4594), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5394), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5392), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [18569] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4595), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5472), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5470), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [18657] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4225), 1,
      sym__identifier_token,
    ACTIONS(4651), 1,
      anon_sym_ref,
    ACTIONS(6165), 1,
      anon_sym_delegate,
    ACTIONS(6169), 1,
      anon_sym_var,
    ACTIONS(6171), 1,
      sym_predefined_type,
    ACTIONS(6250), 1,
      anon_sym_scoped,
    ACTIONS(6540), 1,
      anon_sym_LPAREN,
    ACTIONS(6560), 1,
      anon_sym_readonly,
    STATE(3558), 1,
      sym__reserved_identifier,
    STATE(3583), 1,
      sym_tuple_type,
    STATE(3587), 1,
      sym_array_type,
    STATE(3593), 1,
      sym_type,
    STATE(3608), 1,
      sym_generic_name,
    STATE(3989), 1,
      sym_identifier,
    STATE(4328), 1,
      sym__name,
    STATE(8879), 1,
      sym__array_base_type,
    STATE(9439), 1,
      sym__pointer_base_type,
    STATE(3569), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3585), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3592), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4596), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4227), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [18783] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4597), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5442), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5440), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [18871] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4598), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5500), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5498), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [18959] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4599), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5359), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5357), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [19047] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2983), 1,
      sym__identifier_token,
    ACTIONS(2995), 1,
      anon_sym_LPAREN,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3728), 1,
      anon_sym_delegate,
    ACTIONS(4012), 1,
      anon_sym_ref,
    ACTIONS(5284), 1,
      anon_sym_var,
    ACTIONS(6214), 1,
      anon_sym_scoped,
    STATE(4443), 1,
      sym__reserved_identifier,
    STATE(4921), 1,
      sym_identifier,
    STATE(4959), 1,
      sym_generic_name,
    STATE(5237), 1,
      sym_tuple_type,
    STATE(5381), 1,
      sym__name,
    STATE(5548), 1,
      sym_array_type,
    STATE(7204), 1,
      sym_type,
    STATE(8768), 1,
      sym__array_base_type,
    STATE(8934), 1,
      sym_tuple_element,
    STATE(9721), 1,
      sym__pointer_base_type,
    STATE(2898), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5234), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4600), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2987), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [19173] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4601), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5520), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5518), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [19261] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2983), 1,
      sym__identifier_token,
    ACTIONS(2995), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_var,
    ACTIONS(5657), 1,
      anon_sym_ref,
    ACTIONS(5659), 1,
      anon_sym_delegate,
    ACTIONS(5665), 1,
      anon_sym_scoped,
    ACTIONS(5667), 1,
      sym_predefined_type,
    ACTIONS(6562), 1,
      anon_sym_readonly,
    STATE(4443), 1,
      sym__reserved_identifier,
    STATE(4921), 1,
      sym_identifier,
    STATE(4959), 1,
      sym_generic_name,
    STATE(5969), 1,
      sym_type,
    STATE(7762), 1,
      sym__name,
    STATE(8180), 1,
      sym_tuple_type,
    STATE(8215), 1,
      sym_array_type,
    STATE(8768), 1,
      sym__array_base_type,
    STATE(9650), 1,
      sym__pointer_base_type,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5234), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(8704), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4602), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2987), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [19387] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6564), 1,
      anon_sym_into,
    STATE(4603), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym__query_body_repeat2,
    ACTIONS(6376), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6374), 32,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [19477] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4604), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5339), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5337), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [19565] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4225), 1,
      sym__identifier_token,
    ACTIONS(4659), 1,
      anon_sym_ref,
    ACTIONS(6165), 1,
      anon_sym_delegate,
    ACTIONS(6169), 1,
      anon_sym_var,
    ACTIONS(6171), 1,
      sym_predefined_type,
    ACTIONS(6252), 1,
      anon_sym_scoped,
    ACTIONS(6540), 1,
      anon_sym_LPAREN,
    ACTIONS(6567), 1,
      anon_sym_readonly,
    STATE(3558), 1,
      sym__reserved_identifier,
    STATE(3583), 1,
      sym_tuple_type,
    STATE(3587), 1,
      sym_array_type,
    STATE(3593), 1,
      sym_type,
    STATE(3608), 1,
      sym_generic_name,
    STATE(3989), 1,
      sym_identifier,
    STATE(4328), 1,
      sym__name,
    STATE(8879), 1,
      sym__array_base_type,
    STATE(9439), 1,
      sym__pointer_base_type,
    STATE(3569), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3585), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3592), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4605), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4227), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [19691] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4606), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5446), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5444), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [19779] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6569), 1,
      anon_sym_into,
    STATE(4603), 1,
      aux_sym__query_body_repeat2,
    STATE(4607), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6383), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6381), 32,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [19871] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2983), 1,
      sym__identifier_token,
    ACTIONS(2995), 1,
      anon_sym_LPAREN,
    ACTIONS(3021), 1,
      anon_sym_scoped,
    ACTIONS(3023), 1,
      anon_sym_var,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3726), 1,
      anon_sym_ref,
    ACTIONS(3728), 1,
      anon_sym_delegate,
    ACTIONS(5982), 1,
      anon_sym_STAR,
    STATE(4443), 1,
      sym__reserved_identifier,
    STATE(4921), 1,
      sym_identifier,
    STATE(4959), 1,
      sym_generic_name,
    STATE(5237), 1,
      sym_tuple_type,
    STATE(5381), 1,
      sym__name,
    STATE(5548), 1,
      sym_array_type,
    STATE(7340), 1,
      sym_type,
    STATE(8768), 1,
      sym__array_base_type,
    STATE(9721), 1,
      sym__pointer_base_type,
    STATE(2898), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5234), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4608), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2987), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [19997] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2683), 1,
      anon_sym_readonly,
    ACTIONS(2983), 1,
      sym__identifier_token,
    ACTIONS(2995), 1,
      anon_sym_LPAREN,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3728), 1,
      anon_sym_delegate,
    ACTIONS(4012), 1,
      anon_sym_ref,
    ACTIONS(5284), 1,
      anon_sym_var,
    ACTIONS(6214), 1,
      anon_sym_scoped,
    STATE(4443), 1,
      sym__reserved_identifier,
    STATE(4921), 1,
      sym_identifier,
    STATE(4959), 1,
      sym_generic_name,
    STATE(5237), 1,
      sym_tuple_type,
    STATE(5381), 1,
      sym__name,
    STATE(5548), 1,
      sym_array_type,
    STATE(5969), 1,
      sym_type,
    STATE(8768), 1,
      sym__array_base_type,
    STATE(9721), 1,
      sym__pointer_base_type,
    STATE(2898), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5234), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4609), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2987), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [20123] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4225), 1,
      sym__identifier_token,
    ACTIONS(4229), 1,
      anon_sym_ref,
    ACTIONS(6165), 1,
      anon_sym_delegate,
    ACTIONS(6167), 1,
      anon_sym_scoped,
    ACTIONS(6169), 1,
      anon_sym_var,
    ACTIONS(6171), 1,
      sym_predefined_type,
    ACTIONS(6540), 1,
      anon_sym_LPAREN,
    ACTIONS(6571), 1,
      anon_sym_readonly,
    STATE(3558), 1,
      sym__reserved_identifier,
    STATE(3583), 1,
      sym_tuple_type,
    STATE(3587), 1,
      sym_array_type,
    STATE(3593), 1,
      sym_type,
    STATE(3608), 1,
      sym_generic_name,
    STATE(3989), 1,
      sym_identifier,
    STATE(4328), 1,
      sym__name,
    STATE(8879), 1,
      sym__array_base_type,
    STATE(9439), 1,
      sym__pointer_base_type,
    STATE(3569), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3585), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3592), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4610), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4227), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [20249] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4611), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5810), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5808), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [20337] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2983), 1,
      sym__identifier_token,
    ACTIONS(2995), 1,
      anon_sym_LPAREN,
    ACTIONS(3021), 1,
      anon_sym_scoped,
    ACTIONS(3023), 1,
      anon_sym_var,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3726), 1,
      anon_sym_ref,
    ACTIONS(3728), 1,
      anon_sym_delegate,
    ACTIONS(5982), 1,
      anon_sym_STAR,
    STATE(4443), 1,
      sym__reserved_identifier,
    STATE(4921), 1,
      sym_identifier,
    STATE(4959), 1,
      sym_generic_name,
    STATE(5237), 1,
      sym_tuple_type,
    STATE(5381), 1,
      sym__name,
    STATE(5548), 1,
      sym_array_type,
    STATE(7290), 1,
      sym_type,
    STATE(8768), 1,
      sym__array_base_type,
    STATE(9721), 1,
      sym__pointer_base_type,
    STATE(2898), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5234), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4612), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2987), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [20463] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4168), 1,
      sym__identifier_token,
    ACTIONS(4619), 1,
      anon_sym_ref,
    ACTIONS(6206), 1,
      anon_sym_delegate,
    ACTIONS(6210), 1,
      anon_sym_var,
    ACTIONS(6212), 1,
      sym_predefined_type,
    ACTIONS(6240), 1,
      anon_sym_scoped,
    ACTIONS(6518), 1,
      anon_sym_LPAREN,
    ACTIONS(6573), 1,
      anon_sym_readonly,
    STATE(3891), 1,
      sym_identifier,
    STATE(3897), 1,
      sym__reserved_identifier,
    STATE(3950), 1,
      sym_array_type,
    STATE(3962), 1,
      sym_tuple_type,
    STATE(3999), 1,
      sym_type,
    STATE(4047), 1,
      sym_generic_name,
    STATE(4268), 1,
      sym__name,
    STATE(8755), 1,
      sym__array_base_type,
    STATE(9763), 1,
      sym__pointer_base_type,
    STATE(3937), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3954), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3955), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4613), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4170), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [20589] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4614), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5818), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5816), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [20677] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4615), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5826), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5824), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [20765] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4168), 1,
      sym__identifier_token,
    ACTIONS(4543), 1,
      anon_sym_ref,
    ACTIONS(6206), 1,
      anon_sym_delegate,
    ACTIONS(6208), 1,
      anon_sym_scoped,
    ACTIONS(6210), 1,
      anon_sym_var,
    ACTIONS(6212), 1,
      sym_predefined_type,
    ACTIONS(6518), 1,
      anon_sym_LPAREN,
    ACTIONS(6575), 1,
      anon_sym_readonly,
    STATE(3897), 1,
      sym__reserved_identifier,
    STATE(3950), 1,
      sym_array_type,
    STATE(3962), 1,
      sym_tuple_type,
    STATE(3999), 1,
      sym_type,
    STATE(4047), 1,
      sym_generic_name,
    STATE(5594), 1,
      sym_identifier,
    STATE(6161), 1,
      sym__name,
    STATE(8755), 1,
      sym__array_base_type,
    STATE(9763), 1,
      sym__pointer_base_type,
    STATE(3937), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3954), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3955), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4616), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4170), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [20891] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4617), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5327), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5325), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [20979] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4157), 1,
      sym__identifier_token,
    ACTIONS(4463), 1,
      anon_sym_ref,
    ACTIONS(6137), 1,
      anon_sym_delegate,
    ACTIONS(6141), 1,
      anon_sym_var,
    ACTIONS(6143), 1,
      sym_predefined_type,
    ACTIONS(6244), 1,
      anon_sym_scoped,
    ACTIONS(6577), 1,
      anon_sym_LPAREN,
    ACTIONS(6579), 1,
      anon_sym_readonly,
    STATE(3787), 1,
      sym_identifier,
    STATE(3838), 1,
      sym__reserved_identifier,
    STATE(3874), 1,
      sym_generic_name,
    STATE(3916), 1,
      sym_array_type,
    STATE(3918), 1,
      sym_tuple_type,
    STATE(3919), 1,
      sym_type,
    STATE(3925), 1,
      sym__name,
    STATE(8833), 1,
      sym__array_base_type,
    STATE(9537), 1,
      sym__pointer_base_type,
    STATE(3912), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(3915), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3917), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4618), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4159), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [21105] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4619), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5331), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5329), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [21193] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4620), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5596), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5594), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [21281] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2983), 1,
      sym__identifier_token,
    ACTIONS(2995), 1,
      anon_sym_LPAREN,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3728), 1,
      anon_sym_delegate,
    ACTIONS(4012), 1,
      anon_sym_ref,
    ACTIONS(5284), 1,
      anon_sym_var,
    ACTIONS(6214), 1,
      anon_sym_scoped,
    STATE(4443), 1,
      sym__reserved_identifier,
    STATE(4921), 1,
      sym_identifier,
    STATE(4959), 1,
      sym_generic_name,
    STATE(5237), 1,
      sym_tuple_type,
    STATE(5381), 1,
      sym__name,
    STATE(5548), 1,
      sym_array_type,
    STATE(7204), 1,
      sym_type,
    STATE(8768), 1,
      sym__array_base_type,
    STATE(8921), 1,
      sym_tuple_element,
    STATE(9721), 1,
      sym__pointer_base_type,
    STATE(2898), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5234), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4621), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2987), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [21407] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6581), 1,
      anon_sym_LPAREN,
    STATE(4622), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3976), 45,
      anon_sym_extern,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_unsafe,
      anon_sym_static,
      anon_sym_ref,
      anon_sym_delegate,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_file,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_required,
      anon_sym_sealed,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      sym_predefined_type,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [21495] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2983), 1,
      sym__identifier_token,
    ACTIONS(2995), 1,
      anon_sym_LPAREN,
    ACTIONS(3021), 1,
      anon_sym_scoped,
    ACTIONS(3023), 1,
      anon_sym_var,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3726), 1,
      anon_sym_ref,
    ACTIONS(3728), 1,
      anon_sym_delegate,
    ACTIONS(5982), 1,
      anon_sym_STAR,
    STATE(4443), 1,
      sym__reserved_identifier,
    STATE(4921), 1,
      sym_identifier,
    STATE(4959), 1,
      sym_generic_name,
    STATE(5237), 1,
      sym_tuple_type,
    STATE(5381), 1,
      sym__name,
    STATE(5548), 1,
      sym_array_type,
    STATE(7295), 1,
      sym_type,
    STATE(8768), 1,
      sym__array_base_type,
    STATE(9721), 1,
      sym__pointer_base_type,
    STATE(2898), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5234), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4623), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2987), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [21621] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4624), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5832), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(4247), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [21709] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2983), 1,
      sym__identifier_token,
    ACTIONS(2995), 1,
      anon_sym_LPAREN,
    ACTIONS(3021), 1,
      anon_sym_scoped,
    ACTIONS(3023), 1,
      anon_sym_var,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3726), 1,
      anon_sym_ref,
    ACTIONS(3728), 1,
      anon_sym_delegate,
    STATE(4443), 1,
      sym__reserved_identifier,
    STATE(4921), 1,
      sym_identifier,
    STATE(4959), 1,
      sym_generic_name,
    STATE(5237), 1,
      sym_tuple_type,
    STATE(5381), 1,
      sym__name,
    STATE(5548), 1,
      sym_array_type,
    STATE(7065), 1,
      sym_type,
    STATE(8768), 1,
      sym__array_base_type,
    STATE(9472), 1,
      sym_variable_declaration,
    STATE(9721), 1,
      sym__pointer_base_type,
    STATE(2898), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5234), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4625), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2987), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [21835] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6569), 1,
      anon_sym_into,
    STATE(4707), 1,
      aux_sym__query_body_repeat2,
    STATE(4626), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6448), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6446), 32,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [21927] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4391), 1,
      sym__identifier_token,
    ACTIONS(4397), 1,
      anon_sym_ref,
    ACTIONS(6090), 1,
      anon_sym_delegate,
    ACTIONS(6094), 1,
      anon_sym_var,
    ACTIONS(6096), 1,
      sym_predefined_type,
    ACTIONS(6196), 1,
      anon_sym_scoped,
    ACTIONS(6556), 1,
      anon_sym_LPAREN,
    ACTIONS(6583), 1,
      anon_sym_readonly,
    STATE(5034), 1,
      sym_identifier,
    STATE(5144), 1,
      sym__reserved_identifier,
    STATE(5211), 1,
      sym_generic_name,
    STATE(5257), 1,
      sym__name,
    STATE(5293), 1,
      sym_tuple_type,
    STATE(5296), 1,
      sym_array_type,
    STATE(5362), 1,
      sym_type,
    STATE(8680), 1,
      sym__array_base_type,
    STATE(9933), 1,
      sym__pointer_base_type,
    STATE(5271), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(5302), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5380), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4627), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4393), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [22053] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4628), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5570), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5568), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [22141] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4287), 1,
      sym__identifier_token,
    ACTIONS(4455), 1,
      anon_sym_delegate,
    ACTIONS(4459), 1,
      anon_sym_var,
    ACTIONS(4461), 1,
      sym_predefined_type,
    ACTIONS(4653), 1,
      anon_sym_ref,
    ACTIONS(6288), 1,
      anon_sym_scoped,
    ACTIONS(6522), 1,
      anon_sym_LPAREN,
    ACTIONS(6585), 1,
      anon_sym_readonly,
    STATE(3568), 1,
      sym__reserved_identifier,
    STATE(3590), 1,
      sym_identifier,
    STATE(3633), 1,
      sym_tuple_type,
    STATE(3661), 1,
      sym_array_type,
    STATE(3700), 1,
      sym_type,
    STATE(3708), 1,
      sym_generic_name,
    STATE(3770), 1,
      sym__name,
    STATE(8888), 1,
      sym__array_base_type,
    STATE(9386), 1,
      sym__pointer_base_type,
    STATE(3618), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3635), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(3706), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4629), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4289), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [22267] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4630), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5508), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5506), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [22355] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4006), 1,
      sym__identifier_token,
    ACTIONS(4054), 1,
      anon_sym_ref,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(2738), 1,
      sym_generic_name,
    STATE(2899), 1,
      sym_ref_type,
    STATE(2907), 1,
      sym__scoped_base_type,
    STATE(5368), 1,
      sym_identifier,
    STATE(6160), 1,
      sym__name,
    ACTIONS(3721), 3,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4631), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3719), 10,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
    ACTIONS(4009), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [22463] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4168), 1,
      sym__identifier_token,
    ACTIONS(4598), 1,
      anon_sym_ref,
    ACTIONS(6206), 1,
      anon_sym_delegate,
    ACTIONS(6210), 1,
      anon_sym_var,
    ACTIONS(6212), 1,
      sym_predefined_type,
    ACTIONS(6254), 1,
      anon_sym_scoped,
    ACTIONS(6518), 1,
      anon_sym_LPAREN,
    ACTIONS(6587), 1,
      anon_sym_readonly,
    STATE(3891), 1,
      sym_identifier,
    STATE(3897), 1,
      sym__reserved_identifier,
    STATE(3950), 1,
      sym_array_type,
    STATE(3962), 1,
      sym_tuple_type,
    STATE(3999), 1,
      sym_type,
    STATE(4047), 1,
      sym_generic_name,
    STATE(4268), 1,
      sym__name,
    STATE(8755), 1,
      sym__array_base_type,
    STATE(9763), 1,
      sym__pointer_base_type,
    STATE(3937), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3954), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3955), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4632), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4170), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [22589] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2693), 1,
      anon_sym_readonly,
    ACTIONS(2983), 1,
      sym__identifier_token,
    ACTIONS(2995), 1,
      anon_sym_LPAREN,
    ACTIONS(3021), 1,
      anon_sym_scoped,
    ACTIONS(3023), 1,
      anon_sym_var,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3726), 1,
      anon_sym_ref,
    ACTIONS(3728), 1,
      anon_sym_delegate,
    STATE(4443), 1,
      sym__reserved_identifier,
    STATE(4921), 1,
      sym_identifier,
    STATE(4959), 1,
      sym_generic_name,
    STATE(5237), 1,
      sym_tuple_type,
    STATE(5381), 1,
      sym__name,
    STATE(5548), 1,
      sym_array_type,
    STATE(5969), 1,
      sym_type,
    STATE(8768), 1,
      sym__array_base_type,
    STATE(9721), 1,
      sym__pointer_base_type,
    STATE(2898), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5234), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4633), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2987), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [22715] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5165), 1,
      anon_sym_DOT,
    ACTIONS(5167), 1,
      anon_sym_DASH_GT,
    ACTIONS(6008), 1,
      anon_sym_LPAREN,
    ACTIONS(6038), 1,
      anon_sym_LBRACK,
    ACTIONS(6044), 1,
      anon_sym_BANG,
    ACTIONS(6068), 1,
      anon_sym_switch,
    ACTIONS(6082), 1,
      anon_sym_with,
    ACTIONS(6462), 1,
      anon_sym_SLASH,
    ACTIONS(6478), 1,
      anon_sym_DOT_DOT,
    STATE(3551), 1,
      sym_bracketed_argument_list,
    STATE(4571), 1,
      sym_argument_list,
    ACTIONS(6046), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6458), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6460), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6116), 7,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
    STATE(4634), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 22,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
  [22831] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5165), 1,
      anon_sym_DOT,
    ACTIONS(5167), 1,
      anon_sym_DASH_GT,
    ACTIONS(6008), 1,
      anon_sym_LPAREN,
    ACTIONS(6038), 1,
      anon_sym_LBRACK,
    ACTIONS(6044), 1,
      anon_sym_BANG,
    ACTIONS(6068), 1,
      anon_sym_switch,
    ACTIONS(6082), 1,
      anon_sym_with,
    ACTIONS(6478), 1,
      anon_sym_DOT_DOT,
    STATE(3551), 1,
      sym_bracketed_argument_list,
    STATE(4571), 1,
      sym_argument_list,
    ACTIONS(6046), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(4635), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6116), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
    ACTIONS(6114), 24,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
  [22941] = 25,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5165), 1,
      anon_sym_DOT,
    ACTIONS(5167), 1,
      anon_sym_DASH_GT,
    ACTIONS(6008), 1,
      anon_sym_LPAREN,
    ACTIONS(6038), 1,
      anon_sym_LBRACK,
    ACTIONS(6044), 1,
      anon_sym_BANG,
    ACTIONS(6068), 1,
      anon_sym_switch,
    ACTIONS(6082), 1,
      anon_sym_with,
    ACTIONS(6462), 1,
      anon_sym_SLASH,
    ACTIONS(6478), 1,
      anon_sym_DOT_DOT,
    STATE(3551), 1,
      sym_bracketed_argument_list,
    STATE(4571), 1,
      sym_argument_list,
    ACTIONS(6046), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6460), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    STATE(4636), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6116), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
    ACTIONS(6114), 22,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
  [23055] = 28,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5165), 1,
      anon_sym_DOT,
    ACTIONS(5167), 1,
      anon_sym_DASH_GT,
    ACTIONS(6008), 1,
      anon_sym_LPAREN,
    ACTIONS(6038), 1,
      anon_sym_LBRACK,
    ACTIONS(6044), 1,
      anon_sym_BANG,
    ACTIONS(6068), 1,
      anon_sym_switch,
    ACTIONS(6082), 1,
      anon_sym_with,
    ACTIONS(6462), 1,
      anon_sym_SLASH,
    ACTIONS(6472), 1,
      anon_sym_GT_GT,
    ACTIONS(6478), 1,
      anon_sym_DOT_DOT,
    STATE(3551), 1,
      sym_bracketed_argument_list,
    STATE(4571), 1,
      sym_argument_list,
    ACTIONS(6046), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6458), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6460), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6470), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6116), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_as,
    STATE(4637), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 20,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
  [23175] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2983), 1,
      sym__identifier_token,
    ACTIONS(2995), 1,
      anon_sym_LPAREN,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3728), 1,
      anon_sym_delegate,
    ACTIONS(4012), 1,
      anon_sym_ref,
    ACTIONS(5284), 1,
      anon_sym_var,
    ACTIONS(6214), 1,
      anon_sym_scoped,
    STATE(4443), 1,
      sym__reserved_identifier,
    STATE(4921), 1,
      sym_identifier,
    STATE(4959), 1,
      sym_generic_name,
    STATE(5237), 1,
      sym_tuple_type,
    STATE(5381), 1,
      sym__name,
    STATE(5548), 1,
      sym_array_type,
    STATE(7204), 1,
      sym_type,
    STATE(8768), 1,
      sym__array_base_type,
    STATE(8887), 1,
      sym_tuple_element,
    STATE(9721), 1,
      sym__pointer_base_type,
    STATE(2898), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5234), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4638), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2987), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [23301] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2983), 1,
      sym__identifier_token,
    ACTIONS(2995), 1,
      anon_sym_LPAREN,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3728), 1,
      anon_sym_delegate,
    ACTIONS(4012), 1,
      anon_sym_ref,
    ACTIONS(5284), 1,
      anon_sym_var,
    ACTIONS(6214), 1,
      anon_sym_scoped,
    STATE(4443), 1,
      sym__reserved_identifier,
    STATE(4921), 1,
      sym_identifier,
    STATE(4959), 1,
      sym_generic_name,
    STATE(5237), 1,
      sym_tuple_type,
    STATE(5381), 1,
      sym__name,
    STATE(5548), 1,
      sym_array_type,
    STATE(7204), 1,
      sym_type,
    STATE(8768), 1,
      sym__array_base_type,
    STATE(8846), 1,
      sym_tuple_element,
    STATE(9721), 1,
      sym__pointer_base_type,
    STATE(2898), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5234), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4639), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2987), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [23427] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5165), 1,
      anon_sym_DOT,
    ACTIONS(5167), 1,
      anon_sym_DASH_GT,
    ACTIONS(6008), 1,
      anon_sym_LPAREN,
    ACTIONS(6038), 1,
      anon_sym_LBRACK,
    ACTIONS(6044), 1,
      anon_sym_BANG,
    ACTIONS(6068), 1,
      anon_sym_switch,
    ACTIONS(6078), 1,
      anon_sym_as,
    ACTIONS(6082), 1,
      anon_sym_with,
    ACTIONS(6456), 1,
      anon_sym_QMARK,
    ACTIONS(6462), 1,
      anon_sym_SLASH,
    ACTIONS(6464), 1,
      anon_sym_CARET,
    ACTIONS(6466), 1,
      anon_sym_PIPE,
    ACTIONS(6468), 1,
      anon_sym_AMP,
    ACTIONS(6472), 1,
      anon_sym_GT_GT,
    ACTIONS(6478), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6480), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6482), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6484), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6486), 1,
      anon_sym_is,
    STATE(3551), 1,
      sym_bracketed_argument_list,
    STATE(4571), 1,
      sym_argument_list,
    ACTIONS(6046), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6454), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6458), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6460), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6470), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6474), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6476), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4640), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6284), 11,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [23569] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4641), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5422), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5420), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [23657] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4642), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5836), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5834), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [23745] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5209), 1,
      anon_sym_LT,
    ACTIONS(6589), 1,
      anon_sym_COLON_COLON,
    STATE(3605), 1,
      sym_type_argument_list,
    STATE(4643), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4074), 11,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
    ACTIONS(4076), 32,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [23839] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2983), 1,
      sym__identifier_token,
    ACTIONS(2995), 1,
      anon_sym_LPAREN,
    ACTIONS(3023), 1,
      anon_sym_var,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3728), 1,
      anon_sym_delegate,
    ACTIONS(6488), 1,
      anon_sym_ref,
    ACTIONS(6492), 1,
      anon_sym_scoped,
    ACTIONS(6591), 1,
      anon_sym_checked,
    STATE(4443), 1,
      sym__reserved_identifier,
    STATE(4921), 1,
      sym_identifier,
    STATE(4959), 1,
      sym_generic_name,
    STATE(5237), 1,
      sym_tuple_type,
    STATE(5381), 1,
      sym__name,
    STATE(5548), 1,
      sym_array_type,
    STATE(8768), 1,
      sym__array_base_type,
    STATE(8791), 1,
      sym_type,
    STATE(9721), 1,
      sym__pointer_base_type,
    STATE(2898), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5234), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4644), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2987), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [23965] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2983), 1,
      sym__identifier_token,
    ACTIONS(2995), 1,
      anon_sym_LPAREN,
    ACTIONS(3021), 1,
      anon_sym_scoped,
    ACTIONS(3023), 1,
      anon_sym_var,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3726), 1,
      anon_sym_ref,
    ACTIONS(3728), 1,
      anon_sym_delegate,
    ACTIONS(5982), 1,
      anon_sym_STAR,
    STATE(4443), 1,
      sym__reserved_identifier,
    STATE(4921), 1,
      sym_identifier,
    STATE(4959), 1,
      sym_generic_name,
    STATE(5237), 1,
      sym_tuple_type,
    STATE(5381), 1,
      sym__name,
    STATE(5548), 1,
      sym_array_type,
    STATE(7348), 1,
      sym_type,
    STATE(8768), 1,
      sym__array_base_type,
    STATE(9721), 1,
      sym__pointer_base_type,
    STATE(2898), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5234), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4645), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2987), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [24091] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4646), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5584), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5582), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [24179] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4647), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5414), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5412), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [24267] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4648), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5375), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5373), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [24355] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4747), 1,
      anon_sym_or,
    STATE(4649), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4739), 12,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
    ACTIONS(5789), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_as,
    ACTIONS(5786), 21,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [24447] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4650), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5840), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5838), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [24535] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4651), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2921), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(2923), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [24623] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4168), 1,
      sym__identifier_token,
    ACTIONS(4592), 1,
      anon_sym_ref,
    ACTIONS(6206), 1,
      anon_sym_delegate,
    ACTIONS(6210), 1,
      anon_sym_var,
    ACTIONS(6212), 1,
      sym_predefined_type,
    ACTIONS(6260), 1,
      anon_sym_scoped,
    ACTIONS(6518), 1,
      anon_sym_LPAREN,
    ACTIONS(6593), 1,
      anon_sym_readonly,
    STATE(3891), 1,
      sym_identifier,
    STATE(3897), 1,
      sym__reserved_identifier,
    STATE(3950), 1,
      sym_array_type,
    STATE(3962), 1,
      sym_tuple_type,
    STATE(3999), 1,
      sym_type,
    STATE(4047), 1,
      sym_generic_name,
    STATE(4268), 1,
      sym__name,
    STATE(8755), 1,
      sym__array_base_type,
    STATE(9763), 1,
      sym__pointer_base_type,
    STATE(3937), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3954), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3955), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4652), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4170), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [24749] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4168), 1,
      sym__identifier_token,
    ACTIONS(4172), 1,
      anon_sym_ref,
    ACTIONS(6206), 1,
      anon_sym_delegate,
    ACTIONS(6210), 1,
      anon_sym_var,
    ACTIONS(6212), 1,
      sym_predefined_type,
    ACTIONS(6294), 1,
      anon_sym_scoped,
    ACTIONS(6518), 1,
      anon_sym_LPAREN,
    ACTIONS(6595), 1,
      anon_sym_readonly,
    STATE(3891), 1,
      sym_identifier,
    STATE(3897), 1,
      sym__reserved_identifier,
    STATE(3950), 1,
      sym_array_type,
    STATE(3962), 1,
      sym_tuple_type,
    STATE(3999), 1,
      sym_type,
    STATE(4047), 1,
      sym_generic_name,
    STATE(4268), 1,
      sym__name,
    STATE(8755), 1,
      sym__array_base_type,
    STATE(9763), 1,
      sym__pointer_base_type,
    STATE(3937), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3954), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3955), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4653), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4170), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [24875] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2983), 1,
      sym__identifier_token,
    ACTIONS(2995), 1,
      anon_sym_LPAREN,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3728), 1,
      anon_sym_delegate,
    ACTIONS(5284), 1,
      anon_sym_var,
    ACTIONS(6597), 1,
      anon_sym_ref,
    ACTIONS(6599), 1,
      anon_sym_readonly,
    ACTIONS(6601), 1,
      anon_sym_scoped,
    STATE(4443), 1,
      sym__reserved_identifier,
    STATE(4921), 1,
      sym_identifier,
    STATE(4959), 1,
      sym_generic_name,
    STATE(5237), 1,
      sym_tuple_type,
    STATE(5381), 1,
      sym__name,
    STATE(5548), 1,
      sym_array_type,
    STATE(5969), 1,
      sym_type,
    STATE(8768), 1,
      sym__array_base_type,
    STATE(9721), 1,
      sym__pointer_base_type,
    STATE(2898), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5234), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4654), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2987), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [25001] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4655), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2921), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(2923), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [25089] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5165), 1,
      anon_sym_DOT,
    ACTIONS(5167), 1,
      anon_sym_DASH_GT,
    ACTIONS(6008), 1,
      anon_sym_LPAREN,
    ACTIONS(6038), 1,
      anon_sym_LBRACK,
    ACTIONS(6044), 1,
      anon_sym_BANG,
    ACTIONS(6068), 1,
      anon_sym_switch,
    ACTIONS(6078), 1,
      anon_sym_as,
    ACTIONS(6082), 1,
      anon_sym_with,
    ACTIONS(6456), 1,
      anon_sym_QMARK,
    ACTIONS(6462), 1,
      anon_sym_SLASH,
    ACTIONS(6464), 1,
      anon_sym_CARET,
    ACTIONS(6466), 1,
      anon_sym_PIPE,
    ACTIONS(6468), 1,
      anon_sym_AMP,
    ACTIONS(6472), 1,
      anon_sym_GT_GT,
    ACTIONS(6478), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6480), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6482), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6484), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6486), 1,
      anon_sym_is,
    STATE(3551), 1,
      sym_bracketed_argument_list,
    STATE(4571), 1,
      sym_argument_list,
    ACTIONS(6046), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6454), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6458), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6460), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6470), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6474), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6476), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4656), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5337), 11,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [25231] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5165), 1,
      anon_sym_DOT,
    ACTIONS(5167), 1,
      anon_sym_DASH_GT,
    ACTIONS(6008), 1,
      anon_sym_LPAREN,
    ACTIONS(6038), 1,
      anon_sym_LBRACK,
    ACTIONS(6044), 1,
      anon_sym_BANG,
    ACTIONS(6068), 1,
      anon_sym_switch,
    ACTIONS(6078), 1,
      anon_sym_as,
    ACTIONS(6082), 1,
      anon_sym_with,
    ACTIONS(6456), 1,
      anon_sym_QMARK,
    ACTIONS(6462), 1,
      anon_sym_SLASH,
    ACTIONS(6464), 1,
      anon_sym_CARET,
    ACTIONS(6466), 1,
      anon_sym_PIPE,
    ACTIONS(6468), 1,
      anon_sym_AMP,
    ACTIONS(6472), 1,
      anon_sym_GT_GT,
    ACTIONS(6478), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6480), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6482), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6484), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6486), 1,
      anon_sym_is,
    STATE(3551), 1,
      sym_bracketed_argument_list,
    STATE(4571), 1,
      sym_argument_list,
    ACTIONS(6046), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6454), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6458), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6460), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6470), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6474), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6476), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4657), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5385), 11,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [25373] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5165), 1,
      anon_sym_DOT,
    ACTIONS(5167), 1,
      anon_sym_DASH_GT,
    ACTIONS(6008), 1,
      anon_sym_LPAREN,
    ACTIONS(6038), 1,
      anon_sym_LBRACK,
    ACTIONS(6044), 1,
      anon_sym_BANG,
    ACTIONS(6068), 1,
      anon_sym_switch,
    ACTIONS(6078), 1,
      anon_sym_as,
    ACTIONS(6082), 1,
      anon_sym_with,
    ACTIONS(6456), 1,
      anon_sym_QMARK,
    ACTIONS(6462), 1,
      anon_sym_SLASH,
    ACTIONS(6464), 1,
      anon_sym_CARET,
    ACTIONS(6466), 1,
      anon_sym_PIPE,
    ACTIONS(6468), 1,
      anon_sym_AMP,
    ACTIONS(6472), 1,
      anon_sym_GT_GT,
    ACTIONS(6478), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6480), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6482), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6484), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6486), 1,
      anon_sym_is,
    STATE(3551), 1,
      sym_bracketed_argument_list,
    STATE(4571), 1,
      sym_argument_list,
    ACTIONS(6046), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6454), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6458), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6460), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6470), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6474), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6476), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4658), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5396), 11,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [25515] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5165), 1,
      anon_sym_DOT,
    ACTIONS(5167), 1,
      anon_sym_DASH_GT,
    ACTIONS(6008), 1,
      anon_sym_LPAREN,
    ACTIONS(6038), 1,
      anon_sym_LBRACK,
    ACTIONS(6044), 1,
      anon_sym_BANG,
    ACTIONS(6068), 1,
      anon_sym_switch,
    ACTIONS(6078), 1,
      anon_sym_as,
    ACTIONS(6082), 1,
      anon_sym_with,
    ACTIONS(6456), 1,
      anon_sym_QMARK,
    ACTIONS(6462), 1,
      anon_sym_SLASH,
    ACTIONS(6464), 1,
      anon_sym_CARET,
    ACTIONS(6466), 1,
      anon_sym_PIPE,
    ACTIONS(6468), 1,
      anon_sym_AMP,
    ACTIONS(6472), 1,
      anon_sym_GT_GT,
    ACTIONS(6478), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6480), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6482), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6484), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6486), 1,
      anon_sym_is,
    STATE(3551), 1,
      sym_bracketed_argument_list,
    STATE(4571), 1,
      sym_argument_list,
    ACTIONS(6046), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6454), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6458), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6460), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6470), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6474), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6476), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4659), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6216), 11,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [25657] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5165), 1,
      anon_sym_DOT,
    ACTIONS(5167), 1,
      anon_sym_DASH_GT,
    ACTIONS(6008), 1,
      anon_sym_LPAREN,
    ACTIONS(6038), 1,
      anon_sym_LBRACK,
    ACTIONS(6044), 1,
      anon_sym_BANG,
    ACTIONS(6068), 1,
      anon_sym_switch,
    ACTIONS(6078), 1,
      anon_sym_as,
    ACTIONS(6082), 1,
      anon_sym_with,
    ACTIONS(6456), 1,
      anon_sym_QMARK,
    ACTIONS(6462), 1,
      anon_sym_SLASH,
    ACTIONS(6464), 1,
      anon_sym_CARET,
    ACTIONS(6466), 1,
      anon_sym_PIPE,
    ACTIONS(6468), 1,
      anon_sym_AMP,
    ACTIONS(6472), 1,
      anon_sym_GT_GT,
    ACTIONS(6478), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6480), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6482), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6484), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6486), 1,
      anon_sym_is,
    STATE(3551), 1,
      sym_bracketed_argument_list,
    STATE(4571), 1,
      sym_argument_list,
    ACTIONS(6046), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6454), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6458), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6460), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6470), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6474), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6476), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4660), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5325), 11,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [25799] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4661), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5406), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5404), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [25887] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6548), 1,
      anon_sym_and,
    ACTIONS(6603), 1,
      anon_sym_or,
    STATE(4662), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5856), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_as,
    ACTIONS(5854), 32,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [25979] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4663), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5840), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5838), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [26067] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4664), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5402), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5400), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [26155] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4157), 1,
      sym__identifier_token,
    ACTIONS(4161), 1,
      anon_sym_ref,
    ACTIONS(6137), 1,
      anon_sym_delegate,
    ACTIONS(6141), 1,
      anon_sym_var,
    ACTIONS(6143), 1,
      sym_predefined_type,
    ACTIONS(6234), 1,
      anon_sym_scoped,
    ACTIONS(6577), 1,
      anon_sym_LPAREN,
    ACTIONS(6605), 1,
      anon_sym_readonly,
    STATE(3787), 1,
      sym_identifier,
    STATE(3838), 1,
      sym__reserved_identifier,
    STATE(3874), 1,
      sym_generic_name,
    STATE(3916), 1,
      sym_array_type,
    STATE(3918), 1,
      sym_tuple_type,
    STATE(3919), 1,
      sym_type,
    STATE(3925), 1,
      sym__name,
    STATE(8833), 1,
      sym__array_base_type,
    STATE(9537), 1,
      sym__pointer_base_type,
    STATE(3912), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(3915), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3917), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4665), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4159), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [26281] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5165), 1,
      anon_sym_DOT,
    ACTIONS(5167), 1,
      anon_sym_DASH_GT,
    ACTIONS(6008), 1,
      anon_sym_LPAREN,
    ACTIONS(6038), 1,
      anon_sym_LBRACK,
    ACTIONS(6044), 1,
      anon_sym_BANG,
    ACTIONS(6068), 1,
      anon_sym_switch,
    ACTIONS(6078), 1,
      anon_sym_as,
    ACTIONS(6082), 1,
      anon_sym_with,
    ACTIONS(6456), 1,
      anon_sym_QMARK,
    ACTIONS(6462), 1,
      anon_sym_SLASH,
    ACTIONS(6464), 1,
      anon_sym_CARET,
    ACTIONS(6466), 1,
      anon_sym_PIPE,
    ACTIONS(6468), 1,
      anon_sym_AMP,
    ACTIONS(6472), 1,
      anon_sym_GT_GT,
    ACTIONS(6478), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6480), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6482), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6484), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6486), 1,
      anon_sym_is,
    STATE(3551), 1,
      sym_bracketed_argument_list,
    STATE(4571), 1,
      sym_argument_list,
    ACTIONS(6046), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6454), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6458), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6460), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6470), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6474), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6476), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4666), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6274), 11,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [26423] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5165), 1,
      anon_sym_DOT,
    ACTIONS(5167), 1,
      anon_sym_DASH_GT,
    ACTIONS(6008), 1,
      anon_sym_LPAREN,
    ACTIONS(6038), 1,
      anon_sym_LBRACK,
    ACTIONS(6044), 1,
      anon_sym_BANG,
    ACTIONS(6068), 1,
      anon_sym_switch,
    ACTIONS(6078), 1,
      anon_sym_as,
    ACTIONS(6082), 1,
      anon_sym_with,
    ACTIONS(6456), 1,
      anon_sym_QMARK,
    ACTIONS(6462), 1,
      anon_sym_SLASH,
    ACTIONS(6464), 1,
      anon_sym_CARET,
    ACTIONS(6466), 1,
      anon_sym_PIPE,
    ACTIONS(6468), 1,
      anon_sym_AMP,
    ACTIONS(6472), 1,
      anon_sym_GT_GT,
    ACTIONS(6478), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6480), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6482), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6484), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6486), 1,
      anon_sym_is,
    STATE(3551), 1,
      sym_bracketed_argument_list,
    STATE(4571), 1,
      sym_argument_list,
    ACTIONS(6046), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6454), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6458), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6460), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6470), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6474), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6476), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4667), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5510), 11,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [26565] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6548), 1,
      anon_sym_and,
    ACTIONS(6603), 1,
      anon_sym_or,
    STATE(4668), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6609), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_as,
    ACTIONS(6607), 32,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [26657] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4669), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5371), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5369), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [26745] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5165), 1,
      anon_sym_DOT,
    ACTIONS(5167), 1,
      anon_sym_DASH_GT,
    ACTIONS(6008), 1,
      anon_sym_LPAREN,
    ACTIONS(6038), 1,
      anon_sym_LBRACK,
    ACTIONS(6044), 1,
      anon_sym_BANG,
    ACTIONS(6068), 1,
      anon_sym_switch,
    ACTIONS(6078), 1,
      anon_sym_as,
    ACTIONS(6082), 1,
      anon_sym_with,
    ACTIONS(6456), 1,
      anon_sym_QMARK,
    ACTIONS(6462), 1,
      anon_sym_SLASH,
    ACTIONS(6464), 1,
      anon_sym_CARET,
    ACTIONS(6466), 1,
      anon_sym_PIPE,
    ACTIONS(6468), 1,
      anon_sym_AMP,
    ACTIONS(6472), 1,
      anon_sym_GT_GT,
    ACTIONS(6478), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6480), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6482), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6484), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6486), 1,
      anon_sym_is,
    STATE(3551), 1,
      sym_bracketed_argument_list,
    STATE(4571), 1,
      sym_argument_list,
    ACTIONS(6046), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6454), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6458), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6460), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6470), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6474), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6476), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4670), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5420), 11,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [26887] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5165), 1,
      anon_sym_DOT,
    ACTIONS(5167), 1,
      anon_sym_DASH_GT,
    ACTIONS(6008), 1,
      anon_sym_LPAREN,
    ACTIONS(6038), 1,
      anon_sym_LBRACK,
    ACTIONS(6044), 1,
      anon_sym_BANG,
    ACTIONS(6068), 1,
      anon_sym_switch,
    ACTIONS(6078), 1,
      anon_sym_as,
    ACTIONS(6082), 1,
      anon_sym_with,
    ACTIONS(6456), 1,
      anon_sym_QMARK,
    ACTIONS(6462), 1,
      anon_sym_SLASH,
    ACTIONS(6464), 1,
      anon_sym_CARET,
    ACTIONS(6466), 1,
      anon_sym_PIPE,
    ACTIONS(6468), 1,
      anon_sym_AMP,
    ACTIONS(6472), 1,
      anon_sym_GT_GT,
    ACTIONS(6478), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6480), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6482), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6484), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6486), 1,
      anon_sym_is,
    STATE(3551), 1,
      sym_bracketed_argument_list,
    STATE(4571), 1,
      sym_argument_list,
    ACTIONS(6046), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6454), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6458), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6460), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6470), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6474), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6476), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4671), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6230), 11,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [27029] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4672), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5426), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5424), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [27117] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5165), 1,
      anon_sym_DOT,
    ACTIONS(5167), 1,
      anon_sym_DASH_GT,
    ACTIONS(6008), 1,
      anon_sym_LPAREN,
    ACTIONS(6038), 1,
      anon_sym_LBRACK,
    ACTIONS(6044), 1,
      anon_sym_BANG,
    ACTIONS(6478), 1,
      anon_sym_DOT_DOT,
    STATE(3551), 1,
      sym_bracketed_argument_list,
    STATE(4571), 1,
      sym_argument_list,
    ACTIONS(6046), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(4673), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6122), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
    ACTIONS(6120), 26,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_with,
  [27223] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4157), 1,
      sym__identifier_token,
    ACTIONS(4572), 1,
      anon_sym_ref,
    ACTIONS(6137), 1,
      anon_sym_delegate,
    ACTIONS(6141), 1,
      anon_sym_var,
    ACTIONS(6143), 1,
      sym_predefined_type,
    ACTIONS(6181), 1,
      anon_sym_scoped,
    ACTIONS(6577), 1,
      anon_sym_LPAREN,
    ACTIONS(6611), 1,
      anon_sym_readonly,
    STATE(3787), 1,
      sym_identifier,
    STATE(3838), 1,
      sym__reserved_identifier,
    STATE(3874), 1,
      sym_generic_name,
    STATE(3916), 1,
      sym_array_type,
    STATE(3918), 1,
      sym_tuple_type,
    STATE(3919), 1,
      sym_type,
    STATE(3925), 1,
      sym__name,
    STATE(8833), 1,
      sym__array_base_type,
    STATE(9537), 1,
      sym__pointer_base_type,
    STATE(3912), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(3915), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3917), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4674), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4159), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [27349] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4675), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2933), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(2935), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [27437] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5165), 1,
      anon_sym_DOT,
    ACTIONS(5167), 1,
      anon_sym_DASH_GT,
    ACTIONS(6008), 1,
      anon_sym_LPAREN,
    ACTIONS(6038), 1,
      anon_sym_LBRACK,
    ACTIONS(6044), 1,
      anon_sym_BANG,
    ACTIONS(6068), 1,
      anon_sym_switch,
    ACTIONS(6078), 1,
      anon_sym_as,
    ACTIONS(6082), 1,
      anon_sym_with,
    ACTIONS(6456), 1,
      anon_sym_QMARK,
    ACTIONS(6462), 1,
      anon_sym_SLASH,
    ACTIONS(6464), 1,
      anon_sym_CARET,
    ACTIONS(6466), 1,
      anon_sym_PIPE,
    ACTIONS(6468), 1,
      anon_sym_AMP,
    ACTIONS(6472), 1,
      anon_sym_GT_GT,
    ACTIONS(6478), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6480), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6482), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6484), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6486), 1,
      anon_sym_is,
    STATE(3551), 1,
      sym_bracketed_argument_list,
    STATE(4571), 1,
      sym_argument_list,
    ACTIONS(6046), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6454), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6458), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6460), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6470), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6474), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6476), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4676), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6236), 11,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [27579] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4677), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5430), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5428), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [27667] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4678), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5434), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5432), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [27755] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4679), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5438), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5436), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [27843] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4680), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1965), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(1963), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [27931] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4681), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5454), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5452), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [28019] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4682), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5468), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5466), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [28107] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2983), 1,
      sym__identifier_token,
    ACTIONS(2995), 1,
      anon_sym_LPAREN,
    ACTIONS(3023), 1,
      anon_sym_var,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3728), 1,
      anon_sym_delegate,
    ACTIONS(6488), 1,
      anon_sym_ref,
    ACTIONS(6492), 1,
      anon_sym_scoped,
    ACTIONS(6613), 1,
      anon_sym_checked,
    STATE(4443), 1,
      sym__reserved_identifier,
    STATE(4921), 1,
      sym_identifier,
    STATE(4959), 1,
      sym_generic_name,
    STATE(5237), 1,
      sym_tuple_type,
    STATE(5381), 1,
      sym__name,
    STATE(5548), 1,
      sym_array_type,
    STATE(8768), 1,
      sym__array_base_type,
    STATE(8793), 1,
      sym_type,
    STATE(9721), 1,
      sym__pointer_base_type,
    STATE(2898), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5234), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4683), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2987), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [28233] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4684), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5484), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5482), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [28321] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4685), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5512), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5510), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [28409] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3728), 1,
      anon_sym_delegate,
    ACTIONS(4490), 1,
      sym__identifier_token,
    ACTIONS(4494), 1,
      anon_sym_ref,
    ACTIONS(6153), 1,
      anon_sym_var,
    ACTIONS(6155), 1,
      sym_predefined_type,
    ACTIONS(6262), 1,
      anon_sym_scoped,
    ACTIONS(6506), 1,
      anon_sym_LPAREN,
    ACTIONS(6615), 1,
      anon_sym_readonly,
    STATE(2913), 1,
      sym_identifier,
    STATE(2914), 1,
      sym__reserved_identifier,
    STATE(2949), 1,
      sym_type,
    STATE(2956), 1,
      sym_generic_name,
    STATE(2973), 1,
      sym_tuple_type,
    STATE(2975), 1,
      sym_array_type,
    STATE(3002), 1,
      sym__name,
    STATE(8712), 1,
      sym__array_base_type,
    STATE(9721), 1,
      sym__pointer_base_type,
    STATE(2898), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(2974), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(2977), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4686), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4492), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [28535] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4687), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5492), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5490), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [28623] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4688), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5398), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5396), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [28711] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4689), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5504), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5502), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [28799] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4690), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5876), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5874), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [28887] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2983), 1,
      sym__identifier_token,
    ACTIONS(2995), 1,
      anon_sym_LPAREN,
    ACTIONS(3021), 1,
      anon_sym_scoped,
    ACTIONS(3023), 1,
      anon_sym_var,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3726), 1,
      anon_sym_ref,
    ACTIONS(3728), 1,
      anon_sym_delegate,
    STATE(4443), 1,
      sym__reserved_identifier,
    STATE(4921), 1,
      sym_identifier,
    STATE(4959), 1,
      sym_generic_name,
    STATE(5237), 1,
      sym_tuple_type,
    STATE(5381), 1,
      sym__name,
    STATE(5548), 1,
      sym_array_type,
    STATE(6715), 1,
      sym_type,
    STATE(8768), 1,
      sym__array_base_type,
    STATE(9685), 1,
      sym_variable_declaration,
    STATE(9721), 1,
      sym__pointer_base_type,
    STATE(2898), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5234), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4691), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2987), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [29013] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4692), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5769), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5767), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [29101] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4693), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5769), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5767), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [29189] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2983), 1,
      sym__identifier_token,
    ACTIONS(2995), 1,
      anon_sym_LPAREN,
    ACTIONS(3021), 1,
      anon_sym_scoped,
    ACTIONS(3023), 1,
      anon_sym_var,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3726), 1,
      anon_sym_ref,
    ACTIONS(3728), 1,
      anon_sym_delegate,
    STATE(4443), 1,
      sym__reserved_identifier,
    STATE(4921), 1,
      sym_identifier,
    STATE(4959), 1,
      sym_generic_name,
    STATE(5237), 1,
      sym_tuple_type,
    STATE(5381), 1,
      sym__name,
    STATE(5548), 1,
      sym_array_type,
    STATE(7065), 1,
      sym_type,
    STATE(8768), 1,
      sym__array_base_type,
    STATE(9224), 1,
      sym_variable_declaration,
    STATE(9721), 1,
      sym__pointer_base_type,
    STATE(2898), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5234), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4694), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2987), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [29315] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4695), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5387), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5385), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [29403] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4696), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5524), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5522), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [29491] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    STATE(4697), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3976), 45,
      anon_sym_extern,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_unsafe,
      anon_sym_static,
      anon_sym_ref,
      anon_sym_delegate,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_file,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_required,
      anon_sym_sealed,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      sym_predefined_type,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [29579] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4698), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5528), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5526), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [29667] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4699), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5872), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5870), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [29755] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4700), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5864), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5862), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [29843] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4701), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5860), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5858), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [29931] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2983), 1,
      sym__identifier_token,
    ACTIONS(2995), 1,
      anon_sym_LPAREN,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3728), 1,
      anon_sym_delegate,
    ACTIONS(4012), 1,
      anon_sym_ref,
    ACTIONS(5284), 1,
      anon_sym_var,
    ACTIONS(6214), 1,
      anon_sym_scoped,
    STATE(4443), 1,
      sym__reserved_identifier,
    STATE(4921), 1,
      sym_identifier,
    STATE(4959), 1,
      sym_generic_name,
    STATE(5237), 1,
      sym_tuple_type,
    STATE(5381), 1,
      sym__name,
    STATE(5548), 1,
      sym_array_type,
    STATE(7204), 1,
      sym_type,
    STATE(8761), 1,
      sym_tuple_element,
    STATE(8768), 1,
      sym__array_base_type,
    STATE(9721), 1,
      sym__pointer_base_type,
    STATE(2898), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5234), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4702), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2987), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [30057] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4287), 1,
      sym__identifier_token,
    ACTIONS(4455), 1,
      anon_sym_delegate,
    ACTIONS(4459), 1,
      anon_sym_var,
    ACTIONS(4461), 1,
      sym_predefined_type,
    ACTIONS(4610), 1,
      anon_sym_ref,
    ACTIONS(6100), 1,
      anon_sym_scoped,
    ACTIONS(6522), 1,
      anon_sym_LPAREN,
    ACTIONS(6617), 1,
      anon_sym_readonly,
    STATE(3568), 1,
      sym__reserved_identifier,
    STATE(3590), 1,
      sym_identifier,
    STATE(3633), 1,
      sym_tuple_type,
    STATE(3661), 1,
      sym_array_type,
    STATE(3700), 1,
      sym_type,
    STATE(3708), 1,
      sym_generic_name,
    STATE(3770), 1,
      sym__name,
    STATE(8888), 1,
      sym__array_base_type,
    STATE(9386), 1,
      sym__pointer_base_type,
    STATE(3618), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3635), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(3706), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4703), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4289), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [30183] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2983), 1,
      sym__identifier_token,
    ACTIONS(2995), 1,
      anon_sym_LPAREN,
    ACTIONS(3021), 1,
      anon_sym_scoped,
    ACTIONS(3023), 1,
      anon_sym_var,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3726), 1,
      anon_sym_ref,
    ACTIONS(3728), 1,
      anon_sym_delegate,
    STATE(4443), 1,
      sym__reserved_identifier,
    STATE(4921), 1,
      sym_identifier,
    STATE(4959), 1,
      sym_generic_name,
    STATE(5237), 1,
      sym_tuple_type,
    STATE(5381), 1,
      sym__name,
    STATE(5548), 1,
      sym_array_type,
    STATE(6721), 1,
      sym_type,
    STATE(8768), 1,
      sym__array_base_type,
    STATE(9497), 1,
      sym_variable_declaration,
    STATE(9721), 1,
      sym__pointer_base_type,
    STATE(2898), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5234), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4704), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2987), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [30309] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4157), 1,
      sym__identifier_token,
    ACTIONS(4586), 1,
      anon_sym_ref,
    ACTIONS(6137), 1,
      anon_sym_delegate,
    ACTIONS(6141), 1,
      anon_sym_var,
    ACTIONS(6143), 1,
      sym_predefined_type,
    ACTIONS(6272), 1,
      anon_sym_scoped,
    ACTIONS(6577), 1,
      anon_sym_LPAREN,
    ACTIONS(6619), 1,
      anon_sym_readonly,
    STATE(3787), 1,
      sym_identifier,
    STATE(3838), 1,
      sym__reserved_identifier,
    STATE(3874), 1,
      sym_generic_name,
    STATE(3916), 1,
      sym_array_type,
    STATE(3918), 1,
      sym_tuple_type,
    STATE(3919), 1,
      sym_type,
    STATE(3925), 1,
      sym__name,
    STATE(8833), 1,
      sym__array_base_type,
    STATE(9537), 1,
      sym__pointer_base_type,
    STATE(3912), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(3915), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3917), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4705), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4159), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [30435] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2853), 1,
      anon_sym_readonly,
    ACTIONS(3728), 1,
      anon_sym_delegate,
    ACTIONS(4004), 1,
      anon_sym_ref,
    ACTIONS(4490), 1,
      sym__identifier_token,
    ACTIONS(6153), 1,
      anon_sym_var,
    ACTIONS(6155), 1,
      sym_predefined_type,
    ACTIONS(6506), 1,
      anon_sym_LPAREN,
    ACTIONS(6621), 1,
      anon_sym_scoped,
    STATE(2913), 1,
      sym_identifier,
    STATE(2914), 1,
      sym__reserved_identifier,
    STATE(2949), 1,
      sym_type,
    STATE(2956), 1,
      sym_generic_name,
    STATE(2973), 1,
      sym_tuple_type,
    STATE(2975), 1,
      sym_array_type,
    STATE(3002), 1,
      sym__name,
    STATE(8712), 1,
      sym__array_base_type,
    STATE(9721), 1,
      sym__pointer_base_type,
    STATE(2898), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(2974), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(2977), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4706), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4492), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [30561] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6569), 1,
      anon_sym_into,
    STATE(4603), 1,
      aux_sym__query_body_repeat2,
    STATE(4707), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6420), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6418), 32,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [30653] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2983), 1,
      sym__identifier_token,
    ACTIONS(2995), 1,
      anon_sym_LPAREN,
    ACTIONS(3021), 1,
      anon_sym_scoped,
    ACTIONS(3023), 1,
      anon_sym_var,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3726), 1,
      anon_sym_ref,
    ACTIONS(3728), 1,
      anon_sym_delegate,
    STATE(4443), 1,
      sym__reserved_identifier,
    STATE(4921), 1,
      sym_identifier,
    STATE(4959), 1,
      sym_generic_name,
    STATE(5237), 1,
      sym_tuple_type,
    STATE(5381), 1,
      sym__name,
    STATE(5548), 1,
      sym_array_type,
    STATE(7065), 1,
      sym_type,
    STATE(8768), 1,
      sym__array_base_type,
    STATE(9521), 1,
      sym_variable_declaration,
    STATE(9721), 1,
      sym__pointer_base_type,
    STATE(2898), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5234), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4708), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2987), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [30779] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4709), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5763), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5761), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [30867] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4157), 1,
      sym__identifier_token,
    ACTIONS(4574), 1,
      anon_sym_ref,
    ACTIONS(6137), 1,
      anon_sym_delegate,
    ACTIONS(6139), 1,
      anon_sym_scoped,
    ACTIONS(6141), 1,
      anon_sym_var,
    ACTIONS(6143), 1,
      sym_predefined_type,
    ACTIONS(6577), 1,
      anon_sym_LPAREN,
    ACTIONS(6623), 1,
      anon_sym_readonly,
    STATE(3787), 1,
      sym_identifier,
    STATE(3838), 1,
      sym__reserved_identifier,
    STATE(3874), 1,
      sym_generic_name,
    STATE(3916), 1,
      sym_array_type,
    STATE(3918), 1,
      sym_tuple_type,
    STATE(3919), 1,
      sym_type,
    STATE(3925), 1,
      sym__name,
    STATE(8833), 1,
      sym__array_base_type,
    STATE(9537), 1,
      sym__pointer_base_type,
    STATE(3912), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(3915), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3917), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4710), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4159), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [30993] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6569), 1,
      anon_sym_into,
    STATE(4607), 1,
      aux_sym__query_body_repeat2,
    STATE(4711), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6420), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6418), 32,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [31085] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4747), 1,
      anon_sym_or,
    STATE(4712), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4739), 12,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
    ACTIONS(5795), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_as,
    ACTIONS(5792), 21,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [31177] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4225), 1,
      sym__identifier_token,
    ACTIONS(4584), 1,
      anon_sym_ref,
    ACTIONS(6165), 1,
      anon_sym_delegate,
    ACTIONS(6169), 1,
      anon_sym_var,
    ACTIONS(6171), 1,
      sym_predefined_type,
    ACTIONS(6242), 1,
      anon_sym_scoped,
    ACTIONS(6540), 1,
      anon_sym_LPAREN,
    ACTIONS(6625), 1,
      anon_sym_readonly,
    STATE(3558), 1,
      sym__reserved_identifier,
    STATE(3583), 1,
      sym_tuple_type,
    STATE(3587), 1,
      sym_array_type,
    STATE(3593), 1,
      sym_type,
    STATE(3608), 1,
      sym_generic_name,
    STATE(4643), 1,
      sym_identifier,
    STATE(4952), 1,
      sym__name,
    STATE(8879), 1,
      sym__array_base_type,
    STATE(9439), 1,
      sym__pointer_base_type,
    STATE(3569), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3585), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3592), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4713), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4227), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [31303] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2807), 1,
      anon_sym_readonly,
    ACTIONS(2983), 1,
      sym__identifier_token,
    ACTIONS(2995), 1,
      anon_sym_LPAREN,
    ACTIONS(3023), 1,
      anon_sym_var,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3728), 1,
      anon_sym_delegate,
    ACTIONS(4064), 1,
      anon_sym_ref,
    ACTIONS(6627), 1,
      anon_sym_scoped,
    STATE(4443), 1,
      sym__reserved_identifier,
    STATE(4959), 1,
      sym_generic_name,
    STATE(5237), 1,
      sym_tuple_type,
    STATE(5548), 1,
      sym_array_type,
    STATE(5969), 1,
      sym_type,
    STATE(6502), 1,
      sym_identifier,
    STATE(6734), 1,
      sym__name,
    STATE(8768), 1,
      sym__array_base_type,
    STATE(9721), 1,
      sym__pointer_base_type,
    STATE(2898), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5234), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4714), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2987), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [31429] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2983), 1,
      sym__identifier_token,
    ACTIONS(2995), 1,
      anon_sym_LPAREN,
    ACTIONS(3021), 1,
      anon_sym_scoped,
    ACTIONS(3023), 1,
      anon_sym_var,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3726), 1,
      anon_sym_ref,
    ACTIONS(3728), 1,
      anon_sym_delegate,
    ACTIONS(5982), 1,
      anon_sym_STAR,
    STATE(4443), 1,
      sym__reserved_identifier,
    STATE(4921), 1,
      sym_identifier,
    STATE(4959), 1,
      sym_generic_name,
    STATE(5237), 1,
      sym_tuple_type,
    STATE(5381), 1,
      sym__name,
    STATE(5548), 1,
      sym_array_type,
    STATE(7287), 1,
      sym_type,
    STATE(8768), 1,
      sym__array_base_type,
    STATE(9721), 1,
      sym__pointer_base_type,
    STATE(2898), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5234), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4715), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2987), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [31555] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2983), 1,
      sym__identifier_token,
    ACTIONS(2995), 1,
      anon_sym_LPAREN,
    ACTIONS(3021), 1,
      anon_sym_scoped,
    ACTIONS(3023), 1,
      anon_sym_var,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3726), 1,
      anon_sym_ref,
    ACTIONS(3728), 1,
      anon_sym_delegate,
    STATE(4443), 1,
      sym__reserved_identifier,
    STATE(4921), 1,
      sym_identifier,
    STATE(4959), 1,
      sym_generic_name,
    STATE(5237), 1,
      sym_tuple_type,
    STATE(5381), 1,
      sym__name,
    STATE(5548), 1,
      sym_array_type,
    STATE(6712), 1,
      sym_type,
    STATE(8768), 1,
      sym__array_base_type,
    STATE(9721), 1,
      sym__pointer_base_type,
    STATE(9766), 1,
      sym_variable_declaration,
    STATE(2898), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5234), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4716), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2987), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [31681] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6232), 1,
      anon_sym_or,
    ACTIONS(6631), 1,
      anon_sym_QMARK,
    ACTIONS(6637), 1,
      anon_sym_SLASH,
    ACTIONS(6639), 1,
      anon_sym_CARET,
    ACTIONS(6641), 1,
      anon_sym_PIPE,
    ACTIONS(6643), 1,
      anon_sym_AMP,
    ACTIONS(6647), 1,
      anon_sym_GT_GT,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6655), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6657), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6659), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6661), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6663), 1,
      anon_sym_as,
    ACTIONS(6665), 1,
      anon_sym_is,
    ACTIONS(6667), 1,
      anon_sym_with,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6629), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6633), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6635), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6645), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6649), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6651), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4717), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6230), 9,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [31824] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(6675), 1,
      anon_sym_SLASH,
    ACTIONS(6677), 1,
      anon_sym_CARET,
    ACTIONS(6679), 1,
      anon_sym_PIPE,
    ACTIONS(6681), 1,
      anon_sym_AMP,
    ACTIONS(6685), 1,
      anon_sym_GT_GT,
    ACTIONS(6691), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6693), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6695), 1,
      anon_sym_as,
    ACTIONS(6697), 1,
      anon_sym_is,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6116), 2,
      anon_sym_in,
      anon_sym_QMARK,
    ACTIONS(6669), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6671), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6673), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6683), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6687), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6689), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4718), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 11,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [31961] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4168), 1,
      sym__identifier_token,
    ACTIONS(4465), 1,
      anon_sym_ref,
    ACTIONS(6206), 1,
      anon_sym_delegate,
    ACTIONS(6210), 1,
      anon_sym_var,
    ACTIONS(6212), 1,
      sym_predefined_type,
    ACTIONS(6278), 1,
      anon_sym_scoped,
    ACTIONS(6518), 1,
      anon_sym_LPAREN,
    STATE(3891), 1,
      sym_identifier,
    STATE(3897), 1,
      sym__reserved_identifier,
    STATE(3950), 1,
      sym_array_type,
    STATE(3962), 1,
      sym_tuple_type,
    STATE(3995), 1,
      sym_type,
    STATE(4047), 1,
      sym_generic_name,
    STATE(4268), 1,
      sym__name,
    STATE(8755), 1,
      sym__array_base_type,
    STATE(9763), 1,
      sym__pointer_base_type,
    STATE(3937), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3954), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3955), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4719), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4170), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [32084] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2983), 1,
      sym__identifier_token,
    ACTIONS(2995), 1,
      anon_sym_LPAREN,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3728), 1,
      anon_sym_delegate,
    ACTIONS(5284), 1,
      anon_sym_var,
    ACTIONS(6597), 1,
      anon_sym_ref,
    ACTIONS(6601), 1,
      anon_sym_scoped,
    STATE(4443), 1,
      sym__reserved_identifier,
    STATE(4921), 1,
      sym_identifier,
    STATE(4959), 1,
      sym_generic_name,
    STATE(5237), 1,
      sym_tuple_type,
    STATE(5381), 1,
      sym__name,
    STATE(5548), 1,
      sym_array_type,
    STATE(8663), 1,
      sym_type,
    STATE(8768), 1,
      sym__array_base_type,
    STATE(9721), 1,
      sym__pointer_base_type,
    STATE(2898), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5234), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4720), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2987), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [32207] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(5422), 1,
      anon_sym_in,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(6675), 1,
      anon_sym_SLASH,
    ACTIONS(6677), 1,
      anon_sym_CARET,
    ACTIONS(6679), 1,
      anon_sym_PIPE,
    ACTIONS(6681), 1,
      anon_sym_AMP,
    ACTIONS(6685), 1,
      anon_sym_GT_GT,
    ACTIONS(6691), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6693), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6695), 1,
      anon_sym_as,
    ACTIONS(6697), 1,
      anon_sym_is,
    ACTIONS(6699), 1,
      anon_sym_QMARK,
    ACTIONS(6701), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6703), 1,
      anon_sym_QMARK_QMARK,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6669), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6671), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6673), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6683), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6687), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6689), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4721), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5420), 9,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_into,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [32350] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2983), 1,
      sym__identifier_token,
    ACTIONS(2995), 1,
      anon_sym_LPAREN,
    ACTIONS(3021), 1,
      anon_sym_scoped,
    ACTIONS(3023), 1,
      anon_sym_var,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3726), 1,
      anon_sym_ref,
    ACTIONS(3728), 1,
      anon_sym_delegate,
    STATE(2892), 1,
      sym_type,
    STATE(4443), 1,
      sym__reserved_identifier,
    STATE(4921), 1,
      sym_identifier,
    STATE(4959), 1,
      sym_generic_name,
    STATE(5237), 1,
      sym_tuple_type,
    STATE(5381), 1,
      sym__name,
    STATE(5548), 1,
      sym_array_type,
    STATE(8768), 1,
      sym__array_base_type,
    STATE(9721), 1,
      sym__pointer_base_type,
    STATE(2898), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5234), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4722), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2987), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [32473] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4168), 1,
      sym__identifier_token,
    ACTIONS(4172), 1,
      anon_sym_ref,
    ACTIONS(6206), 1,
      anon_sym_delegate,
    ACTIONS(6210), 1,
      anon_sym_var,
    ACTIONS(6212), 1,
      sym_predefined_type,
    ACTIONS(6294), 1,
      anon_sym_scoped,
    ACTIONS(6518), 1,
      anon_sym_LPAREN,
    STATE(3891), 1,
      sym_identifier,
    STATE(3897), 1,
      sym__reserved_identifier,
    STATE(3950), 1,
      sym_array_type,
    STATE(3962), 1,
      sym_tuple_type,
    STATE(4047), 1,
      sym_generic_name,
    STATE(4199), 1,
      sym_type,
    STATE(4268), 1,
      sym__name,
    STATE(8755), 1,
      sym__array_base_type,
    STATE(9763), 1,
      sym__pointer_base_type,
    STATE(3937), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3954), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3955), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4723), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4170), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [32596] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6232), 1,
      anon_sym_in,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(6675), 1,
      anon_sym_SLASH,
    ACTIONS(6677), 1,
      anon_sym_CARET,
    ACTIONS(6679), 1,
      anon_sym_PIPE,
    ACTIONS(6681), 1,
      anon_sym_AMP,
    ACTIONS(6685), 1,
      anon_sym_GT_GT,
    ACTIONS(6691), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6693), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6695), 1,
      anon_sym_as,
    ACTIONS(6697), 1,
      anon_sym_is,
    ACTIONS(6699), 1,
      anon_sym_QMARK,
    ACTIONS(6701), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6703), 1,
      anon_sym_QMARK_QMARK,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6669), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6671), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6673), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6683), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6687), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6689), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4724), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6230), 9,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_into,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [32739] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2983), 1,
      sym__identifier_token,
    ACTIONS(2995), 1,
      anon_sym_LPAREN,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3728), 1,
      anon_sym_delegate,
    ACTIONS(5284), 1,
      anon_sym_var,
    ACTIONS(6597), 1,
      anon_sym_ref,
    ACTIONS(6601), 1,
      anon_sym_scoped,
    STATE(4443), 1,
      sym__reserved_identifier,
    STATE(4921), 1,
      sym_identifier,
    STATE(4959), 1,
      sym_generic_name,
    STATE(5237), 1,
      sym_tuple_type,
    STATE(5381), 1,
      sym__name,
    STATE(5548), 1,
      sym_array_type,
    STATE(8768), 1,
      sym__array_base_type,
    STATE(9471), 1,
      sym_type,
    STATE(9721), 1,
      sym__pointer_base_type,
    STATE(2898), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5234), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4725), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2987), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [32862] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4287), 1,
      sym__identifier_token,
    ACTIONS(4444), 1,
      anon_sym_ref,
    ACTIONS(4455), 1,
      anon_sym_delegate,
    ACTIONS(4459), 1,
      anon_sym_var,
    ACTIONS(4461), 1,
      sym_predefined_type,
    ACTIONS(6102), 1,
      anon_sym_scoped,
    ACTIONS(6522), 1,
      anon_sym_LPAREN,
    STATE(3568), 1,
      sym__reserved_identifier,
    STATE(3633), 1,
      sym_tuple_type,
    STATE(3661), 1,
      sym_array_type,
    STATE(3663), 1,
      sym_type,
    STATE(3708), 1,
      sym_generic_name,
    STATE(5332), 1,
      sym_identifier,
    STATE(6086), 1,
      sym__name,
    STATE(8888), 1,
      sym__array_base_type,
    STATE(9386), 1,
      sym__pointer_base_type,
    STATE(3618), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3635), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(3706), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4726), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4289), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [32985] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4157), 1,
      sym__identifier_token,
    ACTIONS(4161), 1,
      anon_sym_ref,
    ACTIONS(6137), 1,
      anon_sym_delegate,
    ACTIONS(6141), 1,
      anon_sym_var,
    ACTIONS(6143), 1,
      sym_predefined_type,
    ACTIONS(6234), 1,
      anon_sym_scoped,
    ACTIONS(6577), 1,
      anon_sym_LPAREN,
    STATE(3787), 1,
      sym_identifier,
    STATE(3838), 1,
      sym__reserved_identifier,
    STATE(3874), 1,
      sym_generic_name,
    STATE(3916), 1,
      sym_array_type,
    STATE(3918), 1,
      sym_tuple_type,
    STATE(3925), 1,
      sym__name,
    STATE(3973), 1,
      sym_type,
    STATE(8833), 1,
      sym__array_base_type,
    STATE(9537), 1,
      sym__pointer_base_type,
    STATE(3912), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(3915), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3917), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4727), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4159), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [33108] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2983), 1,
      sym__identifier_token,
    ACTIONS(2995), 1,
      anon_sym_LPAREN,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3728), 1,
      anon_sym_delegate,
    ACTIONS(5284), 1,
      anon_sym_var,
    ACTIONS(6597), 1,
      anon_sym_ref,
    ACTIONS(6601), 1,
      anon_sym_scoped,
    STATE(4443), 1,
      sym__reserved_identifier,
    STATE(4921), 1,
      sym_identifier,
    STATE(4959), 1,
      sym_generic_name,
    STATE(5237), 1,
      sym_tuple_type,
    STATE(5381), 1,
      sym__name,
    STATE(5548), 1,
      sym_array_type,
    STATE(8768), 1,
      sym__array_base_type,
    STATE(9662), 1,
      sym_type,
    STATE(9721), 1,
      sym__pointer_base_type,
    STATE(2898), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5234), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4728), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2987), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [33231] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2983), 1,
      sym__identifier_token,
    ACTIONS(2995), 1,
      anon_sym_LPAREN,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3728), 1,
      anon_sym_delegate,
    ACTIONS(6496), 1,
      anon_sym_var,
    ACTIONS(6498), 1,
      anon_sym_ref,
    ACTIONS(6502), 1,
      anon_sym_scoped,
    STATE(4443), 1,
      sym__reserved_identifier,
    STATE(4921), 1,
      sym_identifier,
    STATE(4959), 1,
      sym_generic_name,
    STATE(5237), 1,
      sym_tuple_type,
    STATE(5381), 1,
      sym__name,
    STATE(5548), 1,
      sym_array_type,
    STATE(8768), 1,
      sym__array_base_type,
    STATE(9169), 1,
      sym_type,
    STATE(9721), 1,
      sym__pointer_base_type,
    STATE(2898), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5234), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4729), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2987), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [33354] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(5398), 1,
      anon_sym_in,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(6675), 1,
      anon_sym_SLASH,
    ACTIONS(6677), 1,
      anon_sym_CARET,
    ACTIONS(6679), 1,
      anon_sym_PIPE,
    ACTIONS(6681), 1,
      anon_sym_AMP,
    ACTIONS(6685), 1,
      anon_sym_GT_GT,
    ACTIONS(6691), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6693), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6695), 1,
      anon_sym_as,
    ACTIONS(6697), 1,
      anon_sym_is,
    ACTIONS(6699), 1,
      anon_sym_QMARK,
    ACTIONS(6701), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6703), 1,
      anon_sym_QMARK_QMARK,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6669), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6671), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6673), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6683), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6687), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6689), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4730), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5396), 9,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_into,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [33497] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4168), 1,
      sym__identifier_token,
    ACTIONS(4543), 1,
      anon_sym_ref,
    ACTIONS(6206), 1,
      anon_sym_delegate,
    ACTIONS(6208), 1,
      anon_sym_scoped,
    ACTIONS(6210), 1,
      anon_sym_var,
    ACTIONS(6212), 1,
      sym_predefined_type,
    ACTIONS(6518), 1,
      anon_sym_LPAREN,
    STATE(3897), 1,
      sym__reserved_identifier,
    STATE(3950), 1,
      sym_array_type,
    STATE(3962), 1,
      sym_tuple_type,
    STATE(4047), 1,
      sym_generic_name,
    STATE(4199), 1,
      sym_type,
    STATE(5594), 1,
      sym_identifier,
    STATE(6161), 1,
      sym__name,
    STATE(8755), 1,
      sym__array_base_type,
    STATE(9763), 1,
      sym__pointer_base_type,
    STATE(3937), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3954), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3955), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4731), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4170), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [33620] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5165), 1,
      anon_sym_DOT,
    ACTIONS(5167), 1,
      anon_sym_DASH_GT,
    ACTIONS(6008), 1,
      anon_sym_LPAREN,
    ACTIONS(6038), 1,
      anon_sym_LBRACK,
    ACTIONS(6044), 1,
      anon_sym_BANG,
    ACTIONS(6068), 1,
      anon_sym_switch,
    ACTIONS(6082), 1,
      anon_sym_with,
    ACTIONS(6709), 1,
      anon_sym_SLASH,
    ACTIONS(6711), 1,
      anon_sym_DOT_DOT,
    STATE(3551), 1,
      sym_bracketed_argument_list,
    STATE(4571), 1,
      sym_argument_list,
    ACTIONS(6046), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6705), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6707), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6116), 7,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
    STATE(4732), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 21,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
  [33735] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(5387), 1,
      anon_sym_in,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(6675), 1,
      anon_sym_SLASH,
    ACTIONS(6677), 1,
      anon_sym_CARET,
    ACTIONS(6679), 1,
      anon_sym_PIPE,
    ACTIONS(6681), 1,
      anon_sym_AMP,
    ACTIONS(6685), 1,
      anon_sym_GT_GT,
    ACTIONS(6691), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6693), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6695), 1,
      anon_sym_as,
    ACTIONS(6697), 1,
      anon_sym_is,
    ACTIONS(6699), 1,
      anon_sym_QMARK,
    ACTIONS(6701), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6703), 1,
      anon_sym_QMARK_QMARK,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6669), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6671), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6673), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6683), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6687), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6689), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4733), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5385), 9,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_into,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [33878] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4225), 1,
      sym__identifier_token,
    ACTIONS(4229), 1,
      anon_sym_ref,
    ACTIONS(6165), 1,
      anon_sym_delegate,
    ACTIONS(6167), 1,
      anon_sym_scoped,
    ACTIONS(6169), 1,
      anon_sym_var,
    ACTIONS(6171), 1,
      sym_predefined_type,
    ACTIONS(6540), 1,
      anon_sym_LPAREN,
    STATE(3558), 1,
      sym__reserved_identifier,
    STATE(3583), 1,
      sym_tuple_type,
    STATE(3587), 1,
      sym_array_type,
    STATE(3608), 1,
      sym_generic_name,
    STATE(3681), 1,
      sym_type,
    STATE(3989), 1,
      sym_identifier,
    STATE(4328), 1,
      sym__name,
    STATE(8879), 1,
      sym__array_base_type,
    STATE(9439), 1,
      sym__pointer_base_type,
    STATE(3569), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3585), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3592), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4734), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4227), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [34001] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5165), 1,
      anon_sym_DOT,
    ACTIONS(5167), 1,
      anon_sym_DASH_GT,
    ACTIONS(6008), 1,
      anon_sym_LPAREN,
    ACTIONS(6038), 1,
      anon_sym_LBRACK,
    ACTIONS(6044), 1,
      anon_sym_BANG,
    ACTIONS(6068), 1,
      anon_sym_switch,
    ACTIONS(6082), 1,
      anon_sym_with,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6368), 1,
      anon_sym_as,
    ACTIONS(6709), 1,
      anon_sym_SLASH,
    ACTIONS(6711), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6715), 1,
      anon_sym_CARET,
    ACTIONS(6717), 1,
      anon_sym_PIPE,
    ACTIONS(6719), 1,
      anon_sym_AMP,
    ACTIONS(6723), 1,
      anon_sym_GT_GT,
    ACTIONS(6729), 1,
      anon_sym_is,
    STATE(3551), 1,
      sym_bracketed_argument_list,
    STATE(4571), 1,
      sym_argument_list,
    ACTIONS(6046), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6705), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6707), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6713), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6721), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6725), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6727), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4735), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 13,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [34136] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3728), 1,
      anon_sym_delegate,
    ACTIONS(4490), 1,
      sym__identifier_token,
    ACTIONS(4545), 1,
      anon_sym_ref,
    ACTIONS(6151), 1,
      anon_sym_scoped,
    ACTIONS(6153), 1,
      anon_sym_var,
    ACTIONS(6155), 1,
      sym_predefined_type,
    ACTIONS(6506), 1,
      anon_sym_LPAREN,
    STATE(2892), 1,
      sym_type,
    STATE(2913), 1,
      sym_identifier,
    STATE(2914), 1,
      sym__reserved_identifier,
    STATE(2956), 1,
      sym_generic_name,
    STATE(2973), 1,
      sym_tuple_type,
    STATE(2975), 1,
      sym_array_type,
    STATE(3002), 1,
      sym__name,
    STATE(8712), 1,
      sym__array_base_type,
    STATE(9721), 1,
      sym__pointer_base_type,
    STATE(2898), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(2974), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(2977), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4736), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4492), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [34259] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2983), 1,
      sym__identifier_token,
    ACTIONS(2995), 1,
      anon_sym_LPAREN,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3728), 1,
      anon_sym_delegate,
    ACTIONS(6496), 1,
      anon_sym_var,
    ACTIONS(6498), 1,
      anon_sym_ref,
    ACTIONS(6502), 1,
      anon_sym_scoped,
    STATE(4443), 1,
      sym__reserved_identifier,
    STATE(4921), 1,
      sym_identifier,
    STATE(4959), 1,
      sym_generic_name,
    STATE(5237), 1,
      sym_tuple_type,
    STATE(5381), 1,
      sym__name,
    STATE(5548), 1,
      sym_array_type,
    STATE(8768), 1,
      sym__array_base_type,
    STATE(9113), 1,
      sym_type,
    STATE(9721), 1,
      sym__pointer_base_type,
    STATE(2898), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5234), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4737), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2987), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [34382] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4157), 1,
      sym__identifier_token,
    ACTIONS(4586), 1,
      anon_sym_ref,
    ACTIONS(6137), 1,
      anon_sym_delegate,
    ACTIONS(6141), 1,
      anon_sym_var,
    ACTIONS(6143), 1,
      sym_predefined_type,
    ACTIONS(6272), 1,
      anon_sym_scoped,
    ACTIONS(6577), 1,
      anon_sym_LPAREN,
    STATE(3787), 1,
      sym_identifier,
    STATE(3838), 1,
      sym__reserved_identifier,
    STATE(3874), 1,
      sym_generic_name,
    STATE(3916), 1,
      sym_array_type,
    STATE(3918), 1,
      sym_tuple_type,
    STATE(3923), 1,
      sym_type,
    STATE(3925), 1,
      sym__name,
    STATE(8833), 1,
      sym__array_base_type,
    STATE(9537), 1,
      sym__pointer_base_type,
    STATE(3912), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(3915), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3917), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4738), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4159), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [34505] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2983), 1,
      sym__identifier_token,
    ACTIONS(2995), 1,
      anon_sym_LPAREN,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3728), 1,
      anon_sym_delegate,
    ACTIONS(6496), 1,
      anon_sym_var,
    ACTIONS(6498), 1,
      anon_sym_ref,
    ACTIONS(6502), 1,
      anon_sym_scoped,
    STATE(4443), 1,
      sym__reserved_identifier,
    STATE(4921), 1,
      sym_identifier,
    STATE(4959), 1,
      sym_generic_name,
    STATE(5237), 1,
      sym_tuple_type,
    STATE(5381), 1,
      sym__name,
    STATE(5548), 1,
      sym_array_type,
    STATE(8768), 1,
      sym__array_base_type,
    STATE(9101), 1,
      sym_type,
    STATE(9721), 1,
      sym__pointer_base_type,
    STATE(2898), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5234), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4739), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2987), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [34628] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2983), 1,
      sym__identifier_token,
    ACTIONS(2995), 1,
      anon_sym_LPAREN,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3728), 1,
      anon_sym_delegate,
    ACTIONS(6496), 1,
      anon_sym_var,
    ACTIONS(6498), 1,
      anon_sym_ref,
    ACTIONS(6502), 1,
      anon_sym_scoped,
    STATE(4443), 1,
      sym__reserved_identifier,
    STATE(4921), 1,
      sym_identifier,
    STATE(4959), 1,
      sym_generic_name,
    STATE(5237), 1,
      sym_tuple_type,
    STATE(5381), 1,
      sym__name,
    STATE(5548), 1,
      sym_array_type,
    STATE(8768), 1,
      sym__array_base_type,
    STATE(9551), 1,
      sym_type,
    STATE(9721), 1,
      sym__pointer_base_type,
    STATE(2898), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5234), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4740), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2987), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [34751] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2983), 1,
      sym__identifier_token,
    ACTIONS(2995), 1,
      anon_sym_LPAREN,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3728), 1,
      anon_sym_delegate,
    ACTIONS(6496), 1,
      anon_sym_var,
    ACTIONS(6498), 1,
      anon_sym_ref,
    ACTIONS(6502), 1,
      anon_sym_scoped,
    STATE(4443), 1,
      sym__reserved_identifier,
    STATE(4921), 1,
      sym_identifier,
    STATE(4959), 1,
      sym_generic_name,
    STATE(5237), 1,
      sym_tuple_type,
    STATE(5381), 1,
      sym__name,
    STATE(5548), 1,
      sym_array_type,
    STATE(8768), 1,
      sym__array_base_type,
    STATE(9166), 1,
      sym_type,
    STATE(9721), 1,
      sym__pointer_base_type,
    STATE(2898), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5234), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4741), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2987), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [34874] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6731), 1,
      anon_sym_and,
    STATE(4742), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6546), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6544), 32,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [34963] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6222), 1,
      anon_sym_or,
    ACTIONS(6631), 1,
      anon_sym_QMARK,
    ACTIONS(6637), 1,
      anon_sym_SLASH,
    ACTIONS(6639), 1,
      anon_sym_CARET,
    ACTIONS(6641), 1,
      anon_sym_PIPE,
    ACTIONS(6643), 1,
      anon_sym_AMP,
    ACTIONS(6647), 1,
      anon_sym_GT_GT,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6655), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6657), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6659), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6661), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6663), 1,
      anon_sym_as,
    ACTIONS(6665), 1,
      anon_sym_is,
    ACTIONS(6667), 1,
      anon_sym_with,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6629), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6633), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6635), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6645), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6649), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6651), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4743), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6220), 9,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [35106] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3721), 2,
      anon_sym_EQ,
      anon_sym_in,
    ACTIONS(4024), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_GT,
    STATE(4744), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3719), 11,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
    ACTIONS(4027), 29,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_COLON,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_operator,
      anon_sym_this,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [35197] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6238), 1,
      anon_sym_in,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(6675), 1,
      anon_sym_SLASH,
    ACTIONS(6677), 1,
      anon_sym_CARET,
    ACTIONS(6679), 1,
      anon_sym_PIPE,
    ACTIONS(6681), 1,
      anon_sym_AMP,
    ACTIONS(6685), 1,
      anon_sym_GT_GT,
    ACTIONS(6691), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6693), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6695), 1,
      anon_sym_as,
    ACTIONS(6697), 1,
      anon_sym_is,
    ACTIONS(6699), 1,
      anon_sym_QMARK,
    ACTIONS(6701), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6703), 1,
      anon_sym_QMARK_QMARK,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6669), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6671), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6673), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6683), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6687), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6689), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4745), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6236), 9,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_into,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [35340] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4391), 1,
      sym__identifier_token,
    ACTIONS(4397), 1,
      anon_sym_ref,
    ACTIONS(6090), 1,
      anon_sym_delegate,
    ACTIONS(6094), 1,
      anon_sym_var,
    ACTIONS(6096), 1,
      sym_predefined_type,
    ACTIONS(6196), 1,
      anon_sym_scoped,
    ACTIONS(6556), 1,
      anon_sym_LPAREN,
    STATE(5034), 1,
      sym_identifier,
    STATE(5144), 1,
      sym__reserved_identifier,
    STATE(5211), 1,
      sym_generic_name,
    STATE(5257), 1,
      sym__name,
    STATE(5293), 1,
      sym_tuple_type,
    STATE(5296), 1,
      sym_array_type,
    STATE(5723), 1,
      sym_type,
    STATE(8680), 1,
      sym__array_base_type,
    STATE(9933), 1,
      sym__pointer_base_type,
    STATE(5271), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(5302), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5380), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4746), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4393), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [35463] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2983), 1,
      sym__identifier_token,
    ACTIONS(2995), 1,
      anon_sym_LPAREN,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3728), 1,
      anon_sym_delegate,
    ACTIONS(5284), 1,
      anon_sym_var,
    ACTIONS(5912), 1,
      anon_sym_ref,
    ACTIONS(5920), 1,
      anon_sym_scoped,
    STATE(2892), 1,
      sym_type,
    STATE(4443), 1,
      sym__reserved_identifier,
    STATE(4921), 1,
      sym_identifier,
    STATE(4959), 1,
      sym_generic_name,
    STATE(5237), 1,
      sym_tuple_type,
    STATE(5381), 1,
      sym__name,
    STATE(5548), 1,
      sym_array_type,
    STATE(8768), 1,
      sym__array_base_type,
    STATE(9721), 1,
      sym__pointer_base_type,
    STATE(2898), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5234), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4747), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2987), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [35586] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2983), 1,
      sym__identifier_token,
    ACTIONS(2995), 1,
      anon_sym_LPAREN,
    ACTIONS(3023), 1,
      anon_sym_var,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3728), 1,
      anon_sym_delegate,
    ACTIONS(6488), 1,
      anon_sym_ref,
    ACTIONS(6492), 1,
      anon_sym_scoped,
    STATE(4443), 1,
      sym__reserved_identifier,
    STATE(4921), 1,
      sym_identifier,
    STATE(4959), 1,
      sym_generic_name,
    STATE(5237), 1,
      sym_tuple_type,
    STATE(5381), 1,
      sym__name,
    STATE(5548), 1,
      sym_array_type,
    STATE(8768), 1,
      sym__array_base_type,
    STATE(8894), 1,
      sym_type,
    STATE(9721), 1,
      sym__pointer_base_type,
    STATE(2898), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5234), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4748), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2987), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [35709] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6276), 1,
      anon_sym_or,
    ACTIONS(6631), 1,
      anon_sym_QMARK,
    ACTIONS(6637), 1,
      anon_sym_SLASH,
    ACTIONS(6639), 1,
      anon_sym_CARET,
    ACTIONS(6641), 1,
      anon_sym_PIPE,
    ACTIONS(6643), 1,
      anon_sym_AMP,
    ACTIONS(6647), 1,
      anon_sym_GT_GT,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6655), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6657), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6659), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6661), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6663), 1,
      anon_sym_as,
    ACTIONS(6665), 1,
      anon_sym_is,
    ACTIONS(6667), 1,
      anon_sym_with,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6629), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6633), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6635), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6645), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6649), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6651), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4749), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6274), 9,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [35852] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2983), 1,
      sym__identifier_token,
    ACTIONS(2995), 1,
      anon_sym_LPAREN,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3728), 1,
      anon_sym_delegate,
    ACTIONS(6496), 1,
      anon_sym_var,
    ACTIONS(6498), 1,
      anon_sym_ref,
    ACTIONS(6502), 1,
      anon_sym_scoped,
    STATE(4443), 1,
      sym__reserved_identifier,
    STATE(4921), 1,
      sym_identifier,
    STATE(4959), 1,
      sym_generic_name,
    STATE(5237), 1,
      sym_tuple_type,
    STATE(5381), 1,
      sym__name,
    STATE(5548), 1,
      sym_array_type,
    STATE(8768), 1,
      sym__array_base_type,
    STATE(9180), 1,
      sym_type,
    STATE(9721), 1,
      sym__pointer_base_type,
    STATE(2898), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5234), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4750), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2987), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [35975] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2983), 1,
      sym__identifier_token,
    ACTIONS(2995), 1,
      anon_sym_LPAREN,
    ACTIONS(3023), 1,
      anon_sym_var,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3728), 1,
      anon_sym_delegate,
    ACTIONS(6488), 1,
      anon_sym_ref,
    ACTIONS(6492), 1,
      anon_sym_scoped,
    STATE(2892), 1,
      sym_type,
    STATE(4443), 1,
      sym__reserved_identifier,
    STATE(4921), 1,
      sym_identifier,
    STATE(4959), 1,
      sym_generic_name,
    STATE(5237), 1,
      sym_tuple_type,
    STATE(5381), 1,
      sym__name,
    STATE(5548), 1,
      sym_array_type,
    STATE(8768), 1,
      sym__array_base_type,
    STATE(9721), 1,
      sym__pointer_base_type,
    STATE(2898), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5234), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4751), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2987), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [36098] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3728), 1,
      anon_sym_delegate,
    ACTIONS(4004), 1,
      anon_sym_ref,
    ACTIONS(4490), 1,
      sym__identifier_token,
    ACTIONS(6153), 1,
      anon_sym_var,
    ACTIONS(6155), 1,
      sym_predefined_type,
    ACTIONS(6506), 1,
      anon_sym_LPAREN,
    ACTIONS(6621), 1,
      anon_sym_scoped,
    STATE(2892), 1,
      sym_type,
    STATE(2913), 1,
      sym_identifier,
    STATE(2914), 1,
      sym__reserved_identifier,
    STATE(2956), 1,
      sym_generic_name,
    STATE(2973), 1,
      sym_tuple_type,
    STATE(2975), 1,
      sym_array_type,
    STATE(3002), 1,
      sym__name,
    STATE(8712), 1,
      sym__array_base_type,
    STATE(9721), 1,
      sym__pointer_base_type,
    STATE(2898), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(2974), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(2977), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4752), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4492), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [36221] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5165), 1,
      anon_sym_DOT,
    ACTIONS(5167), 1,
      anon_sym_DASH_GT,
    ACTIONS(6008), 1,
      anon_sym_LPAREN,
    ACTIONS(6038), 1,
      anon_sym_LBRACK,
    ACTIONS(6044), 1,
      anon_sym_BANG,
    ACTIONS(6068), 1,
      anon_sym_switch,
    ACTIONS(6082), 1,
      anon_sym_with,
    ACTIONS(6368), 1,
      anon_sym_as,
    ACTIONS(6709), 1,
      anon_sym_SLASH,
    ACTIONS(6711), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6715), 1,
      anon_sym_CARET,
    ACTIONS(6717), 1,
      anon_sym_PIPE,
    ACTIONS(6719), 1,
      anon_sym_AMP,
    ACTIONS(6723), 1,
      anon_sym_GT_GT,
    ACTIONS(6729), 1,
      anon_sym_is,
    ACTIONS(6733), 1,
      anon_sym_QMARK,
    ACTIONS(6735), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6737), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6739), 1,
      anon_sym_QMARK_QMARK,
    STATE(3551), 1,
      sym_bracketed_argument_list,
    STATE(4571), 1,
      sym_argument_list,
    ACTIONS(6046), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6705), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6707), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6713), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6721), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6725), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6727), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4753), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6216), 10,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [36362] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4287), 1,
      sym__identifier_token,
    ACTIONS(4444), 1,
      anon_sym_ref,
    ACTIONS(4455), 1,
      anon_sym_delegate,
    ACTIONS(4459), 1,
      anon_sym_var,
    ACTIONS(4461), 1,
      sym_predefined_type,
    ACTIONS(6102), 1,
      anon_sym_scoped,
    ACTIONS(6522), 1,
      anon_sym_LPAREN,
    STATE(3568), 1,
      sym__reserved_identifier,
    STATE(3633), 1,
      sym_tuple_type,
    STATE(3661), 1,
      sym_array_type,
    STATE(3708), 1,
      sym_generic_name,
    STATE(3716), 1,
      sym_type,
    STATE(5332), 1,
      sym_identifier,
    STATE(6086), 1,
      sym__name,
    STATE(8888), 1,
      sym__array_base_type,
    STATE(9386), 1,
      sym__pointer_base_type,
    STATE(3618), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3635), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(3706), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4754), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4289), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [36485] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2983), 1,
      sym__identifier_token,
    ACTIONS(2995), 1,
      anon_sym_LPAREN,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3728), 1,
      anon_sym_delegate,
    ACTIONS(6496), 1,
      anon_sym_var,
    ACTIONS(6498), 1,
      anon_sym_ref,
    ACTIONS(6502), 1,
      anon_sym_scoped,
    STATE(4443), 1,
      sym__reserved_identifier,
    STATE(4921), 1,
      sym_identifier,
    STATE(4959), 1,
      sym_generic_name,
    STATE(5237), 1,
      sym_tuple_type,
    STATE(5381), 1,
      sym__name,
    STATE(5548), 1,
      sym_array_type,
    STATE(8768), 1,
      sym__array_base_type,
    STATE(9098), 1,
      sym_type,
    STATE(9721), 1,
      sym__pointer_base_type,
    STATE(2898), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5234), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4755), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2987), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [36608] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2983), 1,
      sym__identifier_token,
    ACTIONS(2995), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_var,
    ACTIONS(5657), 1,
      anon_sym_ref,
    ACTIONS(5659), 1,
      anon_sym_delegate,
    ACTIONS(5665), 1,
      anon_sym_scoped,
    ACTIONS(5667), 1,
      sym_predefined_type,
    STATE(4443), 1,
      sym__reserved_identifier,
    STATE(4921), 1,
      sym_identifier,
    STATE(4959), 1,
      sym_generic_name,
    STATE(7762), 1,
      sym__name,
    STATE(8180), 1,
      sym_tuple_type,
    STATE(8215), 1,
      sym_array_type,
    STATE(8343), 1,
      sym_type,
    STATE(8768), 1,
      sym__array_base_type,
    STATE(9650), 1,
      sym__pointer_base_type,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5234), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(8704), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4756), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2987), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [36731] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2983), 1,
      sym__identifier_token,
    ACTIONS(2995), 1,
      anon_sym_LPAREN,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3728), 1,
      anon_sym_delegate,
    ACTIONS(4012), 1,
      anon_sym_ref,
    ACTIONS(5284), 1,
      anon_sym_var,
    ACTIONS(6214), 1,
      anon_sym_scoped,
    STATE(2892), 1,
      sym_type,
    STATE(4443), 1,
      sym__reserved_identifier,
    STATE(4921), 1,
      sym_identifier,
    STATE(4959), 1,
      sym_generic_name,
    STATE(5237), 1,
      sym_tuple_type,
    STATE(5381), 1,
      sym__name,
    STATE(5548), 1,
      sym_array_type,
    STATE(8768), 1,
      sym__array_base_type,
    STATE(9721), 1,
      sym__pointer_base_type,
    STATE(2898), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5234), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4757), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2987), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [36854] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4287), 1,
      sym__identifier_token,
    ACTIONS(4455), 1,
      anon_sym_delegate,
    ACTIONS(4459), 1,
      anon_sym_var,
    ACTIONS(4461), 1,
      sym_predefined_type,
    ACTIONS(4610), 1,
      anon_sym_ref,
    ACTIONS(6100), 1,
      anon_sym_scoped,
    ACTIONS(6522), 1,
      anon_sym_LPAREN,
    STATE(3568), 1,
      sym__reserved_identifier,
    STATE(3590), 1,
      sym_identifier,
    STATE(3633), 1,
      sym_tuple_type,
    STATE(3661), 1,
      sym_array_type,
    STATE(3663), 1,
      sym_type,
    STATE(3708), 1,
      sym_generic_name,
    STATE(3770), 1,
      sym__name,
    STATE(8888), 1,
      sym__array_base_type,
    STATE(9386), 1,
      sym__pointer_base_type,
    STATE(3618), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3635), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(3706), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4758), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4289), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [36977] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4157), 1,
      sym__identifier_token,
    ACTIONS(4572), 1,
      anon_sym_ref,
    ACTIONS(6137), 1,
      anon_sym_delegate,
    ACTIONS(6141), 1,
      anon_sym_var,
    ACTIONS(6143), 1,
      sym_predefined_type,
    ACTIONS(6181), 1,
      anon_sym_scoped,
    ACTIONS(6577), 1,
      anon_sym_LPAREN,
    STATE(3787), 1,
      sym_identifier,
    STATE(3838), 1,
      sym__reserved_identifier,
    STATE(3874), 1,
      sym_generic_name,
    STATE(3916), 1,
      sym_array_type,
    STATE(3918), 1,
      sym_tuple_type,
    STATE(3925), 1,
      sym__name,
    STATE(3973), 1,
      sym_type,
    STATE(8833), 1,
      sym__array_base_type,
    STATE(9537), 1,
      sym__pointer_base_type,
    STATE(3912), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(3915), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3917), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4759), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4159), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [37100] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2983), 1,
      sym__identifier_token,
    ACTIONS(2995), 1,
      anon_sym_LPAREN,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3728), 1,
      anon_sym_delegate,
    ACTIONS(6496), 1,
      anon_sym_var,
    ACTIONS(6498), 1,
      anon_sym_ref,
    ACTIONS(6502), 1,
      anon_sym_scoped,
    STATE(4443), 1,
      sym__reserved_identifier,
    STATE(4921), 1,
      sym_identifier,
    STATE(4959), 1,
      sym_generic_name,
    STATE(5237), 1,
      sym_tuple_type,
    STATE(5381), 1,
      sym__name,
    STATE(5548), 1,
      sym_array_type,
    STATE(8768), 1,
      sym__array_base_type,
    STATE(9549), 1,
      sym_type,
    STATE(9721), 1,
      sym__pointer_base_type,
    STATE(2898), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5234), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4760), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2987), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [37223] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2983), 1,
      sym__identifier_token,
    ACTIONS(2995), 1,
      anon_sym_LPAREN,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3728), 1,
      anon_sym_delegate,
    ACTIONS(6496), 1,
      anon_sym_var,
    ACTIONS(6498), 1,
      anon_sym_ref,
    ACTIONS(6502), 1,
      anon_sym_scoped,
    STATE(4443), 1,
      sym__reserved_identifier,
    STATE(4921), 1,
      sym_identifier,
    STATE(4959), 1,
      sym_generic_name,
    STATE(5237), 1,
      sym_tuple_type,
    STATE(5381), 1,
      sym__name,
    STATE(5548), 1,
      sym_array_type,
    STATE(8768), 1,
      sym__array_base_type,
    STATE(9550), 1,
      sym_type,
    STATE(9721), 1,
      sym__pointer_base_type,
    STATE(2898), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5234), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4761), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2987), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [37346] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4287), 1,
      sym__identifier_token,
    ACTIONS(4455), 1,
      anon_sym_delegate,
    ACTIONS(4459), 1,
      anon_sym_var,
    ACTIONS(4461), 1,
      sym_predefined_type,
    ACTIONS(4657), 1,
      anon_sym_ref,
    ACTIONS(6127), 1,
      anon_sym_scoped,
    ACTIONS(6522), 1,
      anon_sym_LPAREN,
    STATE(3568), 1,
      sym__reserved_identifier,
    STATE(3590), 1,
      sym_identifier,
    STATE(3633), 1,
      sym_tuple_type,
    STATE(3661), 1,
      sym_array_type,
    STATE(3708), 1,
      sym_generic_name,
    STATE(3716), 1,
      sym_type,
    STATE(3770), 1,
      sym__name,
    STATE(8888), 1,
      sym__array_base_type,
    STATE(9386), 1,
      sym__pointer_base_type,
    STATE(3618), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3635), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(3706), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4762), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4289), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [37469] = 28,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(6675), 1,
      anon_sym_SLASH,
    ACTIONS(6685), 1,
      anon_sym_GT_GT,
    ACTIONS(6691), 1,
      anon_sym_DOT_DOT,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6671), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6673), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6683), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6116), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(4763), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 19,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [37588] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2983), 1,
      sym__identifier_token,
    ACTIONS(2995), 1,
      anon_sym_LPAREN,
    ACTIONS(3023), 1,
      anon_sym_var,
    ACTIONS(5659), 1,
      anon_sym_delegate,
    ACTIONS(5667), 1,
      sym_predefined_type,
    ACTIONS(5886), 1,
      anon_sym_scoped,
    ACTIONS(6389), 1,
      anon_sym_ref,
    STATE(4443), 1,
      sym__reserved_identifier,
    STATE(4921), 1,
      sym_identifier,
    STATE(4959), 1,
      sym_generic_name,
    STATE(7762), 1,
      sym__name,
    STATE(8180), 1,
      sym_tuple_type,
    STATE(8215), 1,
      sym_array_type,
    STATE(8736), 1,
      sym_type,
    STATE(8768), 1,
      sym__array_base_type,
    STATE(9650), 1,
      sym__pointer_base_type,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5234), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(8704), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4764), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2987), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [37711] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6691), 1,
      anon_sym_DOT_DOT,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(4765), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6122), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6120), 25,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [37816] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4391), 1,
      sym__identifier_token,
    ACTIONS(4395), 1,
      anon_sym_ref,
    ACTIONS(6090), 1,
      anon_sym_delegate,
    ACTIONS(6092), 1,
      anon_sym_scoped,
    ACTIONS(6094), 1,
      anon_sym_var,
    ACTIONS(6096), 1,
      sym_predefined_type,
    ACTIONS(6556), 1,
      anon_sym_LPAREN,
    STATE(5034), 1,
      sym_identifier,
    STATE(5144), 1,
      sym__reserved_identifier,
    STATE(5211), 1,
      sym_generic_name,
    STATE(5257), 1,
      sym__name,
    STATE(5293), 1,
      sym_tuple_type,
    STATE(5296), 1,
      sym_array_type,
    STATE(5723), 1,
      sym_type,
    STATE(8680), 1,
      sym__array_base_type,
    STATE(9933), 1,
      sym__pointer_base_type,
    STATE(5271), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(5302), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5380), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4766), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4393), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [37939] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6286), 1,
      anon_sym_in,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(6675), 1,
      anon_sym_SLASH,
    ACTIONS(6677), 1,
      anon_sym_CARET,
    ACTIONS(6679), 1,
      anon_sym_PIPE,
    ACTIONS(6681), 1,
      anon_sym_AMP,
    ACTIONS(6685), 1,
      anon_sym_GT_GT,
    ACTIONS(6691), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6693), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6695), 1,
      anon_sym_as,
    ACTIONS(6697), 1,
      anon_sym_is,
    ACTIONS(6699), 1,
      anon_sym_QMARK,
    ACTIONS(6701), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6703), 1,
      anon_sym_QMARK_QMARK,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6669), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6671), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6673), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6683), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6687), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6689), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4767), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6284), 9,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_into,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [38082] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4044), 1,
      anon_sym_ref,
    ACTIONS(6526), 1,
      sym__identifier_token,
    ACTIONS(6530), 1,
      anon_sym_LPAREN,
    ACTIONS(6532), 1,
      anon_sym_delegate,
    ACTIONS(6534), 1,
      anon_sym_scoped,
    ACTIONS(6536), 1,
      anon_sym_var,
    ACTIONS(6538), 1,
      sym_predefined_type,
    STATE(3133), 1,
      sym_identifier,
    STATE(3163), 1,
      sym__reserved_identifier,
    STATE(3314), 1,
      sym_generic_name,
    STATE(3342), 1,
      sym_type,
    STATE(3434), 1,
      sym_array_type,
    STATE(3436), 1,
      sym_tuple_type,
    STATE(3450), 1,
      sym__name,
    STATE(8808), 1,
      sym__array_base_type,
    STATE(9626), 1,
      sym__pointer_base_type,
    STATE(3403), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3430), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(3435), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4768), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6528), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [38205] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4168), 1,
      sym__identifier_token,
    ACTIONS(4619), 1,
      anon_sym_ref,
    ACTIONS(6206), 1,
      anon_sym_delegate,
    ACTIONS(6210), 1,
      anon_sym_var,
    ACTIONS(6212), 1,
      sym_predefined_type,
    ACTIONS(6240), 1,
      anon_sym_scoped,
    ACTIONS(6518), 1,
      anon_sym_LPAREN,
    STATE(3891), 1,
      sym_identifier,
    STATE(3897), 1,
      sym__reserved_identifier,
    STATE(3950), 1,
      sym_array_type,
    STATE(3962), 1,
      sym_tuple_type,
    STATE(4047), 1,
      sym_generic_name,
    STATE(4199), 1,
      sym_type,
    STATE(4268), 1,
      sym__name,
    STATE(8755), 1,
      sym__array_base_type,
    STATE(9763), 1,
      sym__pointer_base_type,
    STATE(3937), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3954), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3955), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4769), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4170), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [38328] = 28,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6637), 1,
      anon_sym_SLASH,
    ACTIONS(6647), 1,
      anon_sym_GT_GT,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6655), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6667), 1,
      anon_sym_with,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6633), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6635), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6645), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6116), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_or,
    STATE(4770), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 19,
      anon_sym_where,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
  [38447] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2983), 1,
      sym__identifier_token,
    ACTIONS(2995), 1,
      anon_sym_LPAREN,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3728), 1,
      anon_sym_delegate,
    ACTIONS(6496), 1,
      anon_sym_var,
    ACTIONS(6498), 1,
      anon_sym_ref,
    ACTIONS(6502), 1,
      anon_sym_scoped,
    STATE(4443), 1,
      sym__reserved_identifier,
    STATE(4921), 1,
      sym_identifier,
    STATE(4959), 1,
      sym_generic_name,
    STATE(5237), 1,
      sym_tuple_type,
    STATE(5381), 1,
      sym__name,
    STATE(5548), 1,
      sym_array_type,
    STATE(8768), 1,
      sym__array_base_type,
    STATE(9619), 1,
      sym_type,
    STATE(9721), 1,
      sym__pointer_base_type,
    STATE(2898), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5234), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4771), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2987), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [38570] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2983), 1,
      sym__identifier_token,
    ACTIONS(2995), 1,
      anon_sym_LPAREN,
    ACTIONS(3023), 1,
      anon_sym_var,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3728), 1,
      anon_sym_delegate,
    ACTIONS(4064), 1,
      anon_sym_ref,
    ACTIONS(6627), 1,
      anon_sym_scoped,
    STATE(2892), 1,
      sym_type,
    STATE(4443), 1,
      sym__reserved_identifier,
    STATE(4959), 1,
      sym_generic_name,
    STATE(5237), 1,
      sym_tuple_type,
    STATE(5548), 1,
      sym_array_type,
    STATE(6502), 1,
      sym_identifier,
    STATE(6734), 1,
      sym__name,
    STATE(8768), 1,
      sym__array_base_type,
    STATE(9721), 1,
      sym__pointer_base_type,
    STATE(2898), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5234), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4772), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2987), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [38693] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5165), 1,
      anon_sym_DOT,
    ACTIONS(5167), 1,
      anon_sym_DASH_GT,
    ACTIONS(6008), 1,
      anon_sym_LPAREN,
    ACTIONS(6038), 1,
      anon_sym_LBRACK,
    ACTIONS(6044), 1,
      anon_sym_BANG,
    ACTIONS(6068), 1,
      anon_sym_switch,
    ACTIONS(6082), 1,
      anon_sym_with,
    ACTIONS(6368), 1,
      anon_sym_as,
    ACTIONS(6709), 1,
      anon_sym_SLASH,
    ACTIONS(6711), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6715), 1,
      anon_sym_CARET,
    ACTIONS(6717), 1,
      anon_sym_PIPE,
    ACTIONS(6719), 1,
      anon_sym_AMP,
    ACTIONS(6723), 1,
      anon_sym_GT_GT,
    ACTIONS(6729), 1,
      anon_sym_is,
    ACTIONS(6733), 1,
      anon_sym_QMARK,
    ACTIONS(6735), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6737), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6739), 1,
      anon_sym_QMARK_QMARK,
    STATE(3551), 1,
      sym_bracketed_argument_list,
    STATE(4571), 1,
      sym_argument_list,
    ACTIONS(6046), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6705), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6707), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6713), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6721), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6725), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6727), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4773), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5337), 10,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [38834] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4168), 1,
      sym__identifier_token,
    ACTIONS(4465), 1,
      anon_sym_ref,
    ACTIONS(6206), 1,
      anon_sym_delegate,
    ACTIONS(6210), 1,
      anon_sym_var,
    ACTIONS(6212), 1,
      sym_predefined_type,
    ACTIONS(6278), 1,
      anon_sym_scoped,
    ACTIONS(6518), 1,
      anon_sym_LPAREN,
    STATE(3891), 1,
      sym_identifier,
    STATE(3897), 1,
      sym__reserved_identifier,
    STATE(3950), 1,
      sym_array_type,
    STATE(3962), 1,
      sym_tuple_type,
    STATE(4047), 1,
      sym_generic_name,
    STATE(4199), 1,
      sym_type,
    STATE(4268), 1,
      sym__name,
    STATE(8755), 1,
      sym__array_base_type,
    STATE(9763), 1,
      sym__pointer_base_type,
    STATE(3937), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3954), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3955), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4774), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4170), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [38957] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4225), 1,
      sym__identifier_token,
    ACTIONS(4661), 1,
      anon_sym_ref,
    ACTIONS(6165), 1,
      anon_sym_delegate,
    ACTIONS(6169), 1,
      anon_sym_var,
    ACTIONS(6171), 1,
      sym_predefined_type,
    ACTIONS(6183), 1,
      anon_sym_scoped,
    ACTIONS(6540), 1,
      anon_sym_LPAREN,
    STATE(3558), 1,
      sym__reserved_identifier,
    STATE(3583), 1,
      sym_tuple_type,
    STATE(3587), 1,
      sym_array_type,
    STATE(3598), 1,
      sym_type,
    STATE(3608), 1,
      sym_generic_name,
    STATE(3989), 1,
      sym_identifier,
    STATE(4328), 1,
      sym__name,
    STATE(8879), 1,
      sym__array_base_type,
    STATE(9439), 1,
      sym__pointer_base_type,
    STATE(3569), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3585), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3592), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4775), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4227), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [39080] = 25,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(6675), 1,
      anon_sym_SLASH,
    ACTIONS(6691), 1,
      anon_sym_DOT_DOT,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6673), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    STATE(4776), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6116), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6114), 21,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [39193] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(6691), 1,
      anon_sym_DOT_DOT,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(4777), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6116), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6114), 23,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [39302] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6286), 1,
      anon_sym_or,
    ACTIONS(6631), 1,
      anon_sym_QMARK,
    ACTIONS(6637), 1,
      anon_sym_SLASH,
    ACTIONS(6639), 1,
      anon_sym_CARET,
    ACTIONS(6641), 1,
      anon_sym_PIPE,
    ACTIONS(6643), 1,
      anon_sym_AMP,
    ACTIONS(6647), 1,
      anon_sym_GT_GT,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6655), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6657), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6659), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6661), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6663), 1,
      anon_sym_as,
    ACTIONS(6665), 1,
      anon_sym_is,
    ACTIONS(6667), 1,
      anon_sym_with,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6629), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6633), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6635), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6645), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6649), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6651), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4778), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6284), 9,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [39445] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5165), 1,
      anon_sym_DOT,
    ACTIONS(5167), 1,
      anon_sym_DASH_GT,
    ACTIONS(6008), 1,
      anon_sym_LPAREN,
    ACTIONS(6038), 1,
      anon_sym_LBRACK,
    ACTIONS(6044), 1,
      anon_sym_BANG,
    ACTIONS(6068), 1,
      anon_sym_switch,
    ACTIONS(6082), 1,
      anon_sym_with,
    ACTIONS(6368), 1,
      anon_sym_as,
    ACTIONS(6709), 1,
      anon_sym_SLASH,
    ACTIONS(6711), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6715), 1,
      anon_sym_CARET,
    ACTIONS(6717), 1,
      anon_sym_PIPE,
    ACTIONS(6719), 1,
      anon_sym_AMP,
    ACTIONS(6723), 1,
      anon_sym_GT_GT,
    ACTIONS(6729), 1,
      anon_sym_is,
    ACTIONS(6733), 1,
      anon_sym_QMARK,
    ACTIONS(6735), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6737), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6739), 1,
      anon_sym_QMARK_QMARK,
    STATE(3551), 1,
      sym_bracketed_argument_list,
    STATE(4571), 1,
      sym_argument_list,
    ACTIONS(6046), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6705), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6707), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6713), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6721), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6725), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6727), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6743), 2,
      anon_sym_ascending,
      anon_sym_descending,
    ACTIONS(6741), 8,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(4779), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [39588] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(6675), 1,
      anon_sym_SLASH,
    ACTIONS(6681), 1,
      anon_sym_AMP,
    ACTIONS(6685), 1,
      anon_sym_GT_GT,
    ACTIONS(6691), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6695), 1,
      anon_sym_as,
    ACTIONS(6697), 1,
      anon_sym_is,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6669), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6671), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6673), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6683), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6687), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6689), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6116), 3,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PIPE,
    STATE(4780), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 13,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [39719] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2983), 1,
      sym__identifier_token,
    ACTIONS(2995), 1,
      anon_sym_LPAREN,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3728), 1,
      anon_sym_delegate,
    ACTIONS(6496), 1,
      anon_sym_var,
    ACTIONS(6498), 1,
      anon_sym_ref,
    ACTIONS(6502), 1,
      anon_sym_scoped,
    STATE(2892), 1,
      sym_type,
    STATE(4443), 1,
      sym__reserved_identifier,
    STATE(4921), 1,
      sym_identifier,
    STATE(4959), 1,
      sym_generic_name,
    STATE(5237), 1,
      sym_tuple_type,
    STATE(5381), 1,
      sym__name,
    STATE(5548), 1,
      sym_array_type,
    STATE(8768), 1,
      sym__array_base_type,
    STATE(9721), 1,
      sym__pointer_base_type,
    STATE(2898), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5234), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4781), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2987), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [39842] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2983), 1,
      sym__identifier_token,
    ACTIONS(2995), 1,
      anon_sym_LPAREN,
    ACTIONS(3023), 1,
      anon_sym_var,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3728), 1,
      anon_sym_delegate,
    ACTIONS(6488), 1,
      anon_sym_ref,
    ACTIONS(6492), 1,
      anon_sym_scoped,
    STATE(4443), 1,
      sym__reserved_identifier,
    STATE(4921), 1,
      sym_identifier,
    STATE(4959), 1,
      sym_generic_name,
    STATE(5237), 1,
      sym_tuple_type,
    STATE(5381), 1,
      sym__name,
    STATE(5548), 1,
      sym_array_type,
    STATE(8768), 1,
      sym__array_base_type,
    STATE(8939), 1,
      sym_type,
    STATE(9721), 1,
      sym__pointer_base_type,
    STATE(2898), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5234), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4782), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2987), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [39965] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6745), 1,
      anon_sym_LT,
    STATE(4976), 1,
      sym_type_argument_list,
    STATE(4783), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4076), 15,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_DASH_GT,
    ACTIONS(4074), 28,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_operator,
      anon_sym_this,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [40056] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4287), 1,
      sym__identifier_token,
    ACTIONS(4291), 1,
      anon_sym_ref,
    ACTIONS(4455), 1,
      anon_sym_delegate,
    ACTIONS(4457), 1,
      anon_sym_scoped,
    ACTIONS(4459), 1,
      anon_sym_var,
    ACTIONS(4461), 1,
      sym_predefined_type,
    ACTIONS(6522), 1,
      anon_sym_LPAREN,
    STATE(3568), 1,
      sym__reserved_identifier,
    STATE(3590), 1,
      sym_identifier,
    STATE(3633), 1,
      sym_tuple_type,
    STATE(3661), 1,
      sym_array_type,
    STATE(3708), 1,
      sym_generic_name,
    STATE(3716), 1,
      sym_type,
    STATE(3770), 1,
      sym__name,
    STATE(8888), 1,
      sym__array_base_type,
    STATE(9386), 1,
      sym__pointer_base_type,
    STATE(3618), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3635), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(3706), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4784), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4289), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [40179] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2983), 1,
      sym__identifier_token,
    ACTIONS(2995), 1,
      anon_sym_LPAREN,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3728), 1,
      anon_sym_delegate,
    ACTIONS(6496), 1,
      anon_sym_var,
    ACTIONS(6498), 1,
      anon_sym_ref,
    ACTIONS(6502), 1,
      anon_sym_scoped,
    STATE(4443), 1,
      sym__reserved_identifier,
    STATE(4921), 1,
      sym_identifier,
    STATE(4959), 1,
      sym_generic_name,
    STATE(5237), 1,
      sym_tuple_type,
    STATE(5381), 1,
      sym__name,
    STATE(5548), 1,
      sym_array_type,
    STATE(8768), 1,
      sym__array_base_type,
    STATE(8964), 1,
      sym_type,
    STATE(9721), 1,
      sym__pointer_base_type,
    STATE(2898), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5234), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4785), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2987), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [40302] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(6675), 1,
      anon_sym_SLASH,
    ACTIONS(6677), 1,
      anon_sym_CARET,
    ACTIONS(6681), 1,
      anon_sym_AMP,
    ACTIONS(6685), 1,
      anon_sym_GT_GT,
    ACTIONS(6691), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6695), 1,
      anon_sym_as,
    ACTIONS(6697), 1,
      anon_sym_is,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6669), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6671), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6673), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6683), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6687), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6689), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6116), 3,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PIPE,
    STATE(4786), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 12,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [40435] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(6675), 1,
      anon_sym_SLASH,
    ACTIONS(6685), 1,
      anon_sym_GT_GT,
    ACTIONS(6691), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6695), 1,
      anon_sym_as,
    ACTIONS(6697), 1,
      anon_sym_is,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6669), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6671), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6673), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6683), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6687), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6689), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6116), 4,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(4787), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 13,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [40564] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(1463), 1,
      anon_sym_LBRACE,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    STATE(3597), 1,
      sym_argument_list,
    STATE(3718), 1,
      sym_initializer_expression,
    STATE(4788), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5189), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
    ACTIONS(5185), 29,
      anon_sym_LBRACK,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [40659] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4287), 1,
      sym__identifier_token,
    ACTIONS(4455), 1,
      anon_sym_delegate,
    ACTIONS(4459), 1,
      anon_sym_var,
    ACTIONS(4461), 1,
      sym_predefined_type,
    ACTIONS(4655), 1,
      anon_sym_ref,
    ACTIONS(6106), 1,
      anon_sym_scoped,
    ACTIONS(6522), 1,
      anon_sym_LPAREN,
    STATE(3568), 1,
      sym__reserved_identifier,
    STATE(3590), 1,
      sym_identifier,
    STATE(3633), 1,
      sym_tuple_type,
    STATE(3661), 1,
      sym_array_type,
    STATE(3663), 1,
      sym_type,
    STATE(3708), 1,
      sym_generic_name,
    STATE(3770), 1,
      sym__name,
    STATE(8888), 1,
      sym__array_base_type,
    STATE(9386), 1,
      sym__pointer_base_type,
    STATE(3618), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3635), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(3706), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4789), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4289), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [40782] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(6675), 1,
      anon_sym_SLASH,
    ACTIONS(6691), 1,
      anon_sym_DOT_DOT,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6671), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6673), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6116), 7,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4790), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 21,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [40897] = 32,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(6675), 1,
      anon_sym_SLASH,
    ACTIONS(6685), 1,
      anon_sym_GT_GT,
    ACTIONS(6691), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6695), 1,
      anon_sym_as,
    ACTIONS(6697), 1,
      anon_sym_is,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6669), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6671), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6673), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6683), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6689), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6116), 4,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(4791), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 15,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [41024] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4287), 1,
      sym__identifier_token,
    ACTIONS(4291), 1,
      anon_sym_ref,
    ACTIONS(4455), 1,
      anon_sym_delegate,
    ACTIONS(4457), 1,
      anon_sym_scoped,
    ACTIONS(4459), 1,
      anon_sym_var,
    ACTIONS(4461), 1,
      sym_predefined_type,
    ACTIONS(6522), 1,
      anon_sym_LPAREN,
    STATE(3568), 1,
      sym__reserved_identifier,
    STATE(3590), 1,
      sym_identifier,
    STATE(3633), 1,
      sym_tuple_type,
    STATE(3661), 1,
      sym_array_type,
    STATE(3663), 1,
      sym_type,
    STATE(3708), 1,
      sym_generic_name,
    STATE(3770), 1,
      sym__name,
    STATE(8888), 1,
      sym__array_base_type,
    STATE(9386), 1,
      sym__pointer_base_type,
    STATE(3618), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3635), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(3706), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4792), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4289), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [41147] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5165), 1,
      anon_sym_DOT,
    ACTIONS(5167), 1,
      anon_sym_DASH_GT,
    ACTIONS(6008), 1,
      anon_sym_LPAREN,
    ACTIONS(6038), 1,
      anon_sym_LBRACK,
    ACTIONS(6044), 1,
      anon_sym_BANG,
    ACTIONS(6068), 1,
      anon_sym_switch,
    ACTIONS(6082), 1,
      anon_sym_with,
    ACTIONS(6368), 1,
      anon_sym_as,
    ACTIONS(6709), 1,
      anon_sym_SLASH,
    ACTIONS(6711), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6715), 1,
      anon_sym_CARET,
    ACTIONS(6717), 1,
      anon_sym_PIPE,
    ACTIONS(6719), 1,
      anon_sym_AMP,
    ACTIONS(6723), 1,
      anon_sym_GT_GT,
    ACTIONS(6729), 1,
      anon_sym_is,
    ACTIONS(6733), 1,
      anon_sym_QMARK,
    ACTIONS(6735), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6737), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6739), 1,
      anon_sym_QMARK_QMARK,
    STATE(3551), 1,
      sym_bracketed_argument_list,
    STATE(4571), 1,
      sym_argument_list,
    ACTIONS(6046), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6705), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6707), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6713), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6721), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6725), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6727), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4793), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6220), 10,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [41288] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5165), 1,
      anon_sym_DOT,
    ACTIONS(5167), 1,
      anon_sym_DASH_GT,
    ACTIONS(6008), 1,
      anon_sym_LPAREN,
    ACTIONS(6038), 1,
      anon_sym_LBRACK,
    ACTIONS(6044), 1,
      anon_sym_BANG,
    ACTIONS(6068), 1,
      anon_sym_switch,
    ACTIONS(6082), 1,
      anon_sym_with,
    ACTIONS(6368), 1,
      anon_sym_as,
    ACTIONS(6709), 1,
      anon_sym_SLASH,
    ACTIONS(6711), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6723), 1,
      anon_sym_GT_GT,
    ACTIONS(6729), 1,
      anon_sym_is,
    STATE(3551), 1,
      sym_bracketed_argument_list,
    STATE(4571), 1,
      sym_argument_list,
    ACTIONS(6046), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6705), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6707), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6713), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6721), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6725), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6727), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6116), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(4794), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 14,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [41417] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6637), 1,
      anon_sym_SLASH,
    ACTIONS(6639), 1,
      anon_sym_CARET,
    ACTIONS(6641), 1,
      anon_sym_PIPE,
    ACTIONS(6643), 1,
      anon_sym_AMP,
    ACTIONS(6647), 1,
      anon_sym_GT_GT,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6655), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6657), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6659), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6661), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6663), 1,
      anon_sym_as,
    ACTIONS(6665), 1,
      anon_sym_is,
    ACTIONS(6667), 1,
      anon_sym_with,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6116), 2,
      anon_sym_QMARK,
      anon_sym_or,
    ACTIONS(6629), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6633), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6635), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6645), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6649), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6651), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4795), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 9,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [41558] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6637), 1,
      anon_sym_SLASH,
    ACTIONS(6639), 1,
      anon_sym_CARET,
    ACTIONS(6641), 1,
      anon_sym_PIPE,
    ACTIONS(6643), 1,
      anon_sym_AMP,
    ACTIONS(6647), 1,
      anon_sym_GT_GT,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6655), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6657), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6663), 1,
      anon_sym_as,
    ACTIONS(6665), 1,
      anon_sym_is,
    ACTIONS(6667), 1,
      anon_sym_with,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6116), 2,
      anon_sym_QMARK,
      anon_sym_or,
    ACTIONS(6629), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6633), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6635), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6645), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6649), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6651), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4796), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 11,
      anon_sym_where,
      anon_sym_and,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [41695] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6175), 1,
      anon_sym_or,
    ACTIONS(6631), 1,
      anon_sym_QMARK,
    ACTIONS(6637), 1,
      anon_sym_SLASH,
    ACTIONS(6639), 1,
      anon_sym_CARET,
    ACTIONS(6641), 1,
      anon_sym_PIPE,
    ACTIONS(6643), 1,
      anon_sym_AMP,
    ACTIONS(6647), 1,
      anon_sym_GT_GT,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6655), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6657), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6659), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6661), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6663), 1,
      anon_sym_as,
    ACTIONS(6665), 1,
      anon_sym_is,
    ACTIONS(6667), 1,
      anon_sym_with,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6629), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6633), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6635), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6645), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6649), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6651), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4797), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6173), 9,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [41838] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5165), 1,
      anon_sym_DOT,
    ACTIONS(5167), 1,
      anon_sym_DASH_GT,
    ACTIONS(6008), 1,
      anon_sym_LPAREN,
    ACTIONS(6038), 1,
      anon_sym_LBRACK,
    ACTIONS(6044), 1,
      anon_sym_BANG,
    ACTIONS(6068), 1,
      anon_sym_switch,
    ACTIONS(6082), 1,
      anon_sym_with,
    ACTIONS(6368), 1,
      anon_sym_as,
    ACTIONS(6709), 1,
      anon_sym_SLASH,
    ACTIONS(6711), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6715), 1,
      anon_sym_CARET,
    ACTIONS(6717), 1,
      anon_sym_PIPE,
    ACTIONS(6719), 1,
      anon_sym_AMP,
    ACTIONS(6723), 1,
      anon_sym_GT_GT,
    ACTIONS(6729), 1,
      anon_sym_is,
    ACTIONS(6733), 1,
      anon_sym_QMARK,
    ACTIONS(6735), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6737), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6739), 1,
      anon_sym_QMARK_QMARK,
    STATE(3551), 1,
      sym_bracketed_argument_list,
    STATE(4571), 1,
      sym_argument_list,
    ACTIONS(6046), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6705), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6707), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6713), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6721), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6725), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6727), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4798), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5325), 10,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [41979] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2983), 1,
      sym__identifier_token,
    ACTIONS(2995), 1,
      anon_sym_LPAREN,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3728), 1,
      anon_sym_delegate,
    ACTIONS(6496), 1,
      anon_sym_var,
    ACTIONS(6498), 1,
      anon_sym_ref,
    ACTIONS(6502), 1,
      anon_sym_scoped,
    STATE(4443), 1,
      sym__reserved_identifier,
    STATE(4921), 1,
      sym_identifier,
    STATE(4959), 1,
      sym_generic_name,
    STATE(5237), 1,
      sym_tuple_type,
    STATE(5381), 1,
      sym__name,
    STATE(5548), 1,
      sym_array_type,
    STATE(8768), 1,
      sym__array_base_type,
    STATE(9184), 1,
      sym_type,
    STATE(9721), 1,
      sym__pointer_base_type,
    STATE(2898), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5234), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4799), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2987), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [42102] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5165), 1,
      anon_sym_DOT,
    ACTIONS(5167), 1,
      anon_sym_DASH_GT,
    ACTIONS(6008), 1,
      anon_sym_LPAREN,
    ACTIONS(6038), 1,
      anon_sym_LBRACK,
    ACTIONS(6044), 1,
      anon_sym_BANG,
    ACTIONS(6068), 1,
      anon_sym_switch,
    ACTIONS(6082), 1,
      anon_sym_with,
    ACTIONS(6368), 1,
      anon_sym_as,
    ACTIONS(6709), 1,
      anon_sym_SLASH,
    ACTIONS(6711), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6715), 1,
      anon_sym_CARET,
    ACTIONS(6717), 1,
      anon_sym_PIPE,
    ACTIONS(6719), 1,
      anon_sym_AMP,
    ACTIONS(6723), 1,
      anon_sym_GT_GT,
    ACTIONS(6729), 1,
      anon_sym_is,
    ACTIONS(6733), 1,
      anon_sym_QMARK,
    ACTIONS(6735), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6737), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6739), 1,
      anon_sym_QMARK_QMARK,
    STATE(3551), 1,
      sym_bracketed_argument_list,
    STATE(4571), 1,
      sym_argument_list,
    ACTIONS(6046), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6705), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6707), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6713), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6721), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6725), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6727), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4800), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6230), 10,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [42243] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2983), 1,
      sym__identifier_token,
    ACTIONS(2995), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_var,
    ACTIONS(5657), 1,
      anon_sym_ref,
    ACTIONS(5659), 1,
      anon_sym_delegate,
    ACTIONS(5665), 1,
      anon_sym_scoped,
    ACTIONS(5667), 1,
      sym_predefined_type,
    STATE(4443), 1,
      sym__reserved_identifier,
    STATE(4921), 1,
      sym_identifier,
    STATE(4959), 1,
      sym_generic_name,
    STATE(7762), 1,
      sym__name,
    STATE(8180), 1,
      sym_tuple_type,
    STATE(8215), 1,
      sym_array_type,
    STATE(8736), 1,
      sym_type,
    STATE(8768), 1,
      sym__array_base_type,
    STATE(9650), 1,
      sym__pointer_base_type,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5234), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(8704), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4801), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2987), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [42366] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2983), 1,
      sym__identifier_token,
    ACTIONS(2995), 1,
      anon_sym_LPAREN,
    ACTIONS(3021), 1,
      anon_sym_scoped,
    ACTIONS(3023), 1,
      anon_sym_var,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3726), 1,
      anon_sym_ref,
    ACTIONS(3728), 1,
      anon_sym_delegate,
    STATE(4443), 1,
      sym__reserved_identifier,
    STATE(4959), 1,
      sym_generic_name,
    STATE(5237), 1,
      sym_tuple_type,
    STATE(5381), 1,
      sym__name,
    STATE(5548), 1,
      sym_array_type,
    STATE(6784), 1,
      sym_identifier,
    STATE(7330), 1,
      sym_type,
    STATE(8768), 1,
      sym__array_base_type,
    STATE(9721), 1,
      sym__pointer_base_type,
    STATE(2898), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5234), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4802), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2987), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [42489] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3728), 1,
      anon_sym_delegate,
    ACTIONS(4490), 1,
      sym__identifier_token,
    ACTIONS(4494), 1,
      anon_sym_ref,
    ACTIONS(6153), 1,
      anon_sym_var,
    ACTIONS(6155), 1,
      sym_predefined_type,
    ACTIONS(6262), 1,
      anon_sym_scoped,
    ACTIONS(6506), 1,
      anon_sym_LPAREN,
    STATE(2892), 1,
      sym_type,
    STATE(2913), 1,
      sym_identifier,
    STATE(2914), 1,
      sym__reserved_identifier,
    STATE(2956), 1,
      sym_generic_name,
    STATE(2973), 1,
      sym_tuple_type,
    STATE(2975), 1,
      sym_array_type,
    STATE(3002), 1,
      sym__name,
    STATE(8712), 1,
      sym__array_base_type,
    STATE(9721), 1,
      sym__pointer_base_type,
    STATE(2898), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(2974), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(2977), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4803), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4492), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [42612] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(6675), 1,
      anon_sym_SLASH,
    ACTIONS(6677), 1,
      anon_sym_CARET,
    ACTIONS(6679), 1,
      anon_sym_PIPE,
    ACTIONS(6681), 1,
      anon_sym_AMP,
    ACTIONS(6685), 1,
      anon_sym_GT_GT,
    ACTIONS(6691), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6695), 1,
      anon_sym_as,
    ACTIONS(6697), 1,
      anon_sym_is,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6116), 2,
      anon_sym_in,
      anon_sym_QMARK,
    ACTIONS(6669), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6671), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6673), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6683), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6687), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6689), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4804), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 12,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [42747] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2983), 1,
      sym__identifier_token,
    ACTIONS(2995), 1,
      anon_sym_LPAREN,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3728), 1,
      anon_sym_delegate,
    ACTIONS(4054), 1,
      anon_sym_ref,
    ACTIONS(6494), 1,
      anon_sym_scoped,
    ACTIONS(6496), 1,
      anon_sym_var,
    STATE(4443), 1,
      sym__reserved_identifier,
    STATE(4921), 1,
      sym_identifier,
    STATE(4959), 1,
      sym_generic_name,
    STATE(5237), 1,
      sym_tuple_type,
    STATE(5381), 1,
      sym__name,
    STATE(5548), 1,
      sym_array_type,
    STATE(7257), 1,
      sym_type,
    STATE(8768), 1,
      sym__array_base_type,
    STATE(9721), 1,
      sym__pointer_base_type,
    STATE(2898), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5234), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4805), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2987), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [42870] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5165), 1,
      anon_sym_DOT,
    ACTIONS(5167), 1,
      anon_sym_DASH_GT,
    ACTIONS(6008), 1,
      anon_sym_LPAREN,
    ACTIONS(6038), 1,
      anon_sym_LBRACK,
    ACTIONS(6044), 1,
      anon_sym_BANG,
    ACTIONS(6068), 1,
      anon_sym_switch,
    ACTIONS(6082), 1,
      anon_sym_with,
    ACTIONS(6368), 1,
      anon_sym_as,
    ACTIONS(6709), 1,
      anon_sym_SLASH,
    ACTIONS(6711), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6715), 1,
      anon_sym_CARET,
    ACTIONS(6717), 1,
      anon_sym_PIPE,
    ACTIONS(6719), 1,
      anon_sym_AMP,
    ACTIONS(6723), 1,
      anon_sym_GT_GT,
    ACTIONS(6729), 1,
      anon_sym_is,
    ACTIONS(6733), 1,
      anon_sym_QMARK,
    ACTIONS(6735), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6737), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6739), 1,
      anon_sym_QMARK_QMARK,
    STATE(3551), 1,
      sym_bracketed_argument_list,
    STATE(4571), 1,
      sym_argument_list,
    ACTIONS(6046), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6705), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6707), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6713), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6721), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6725), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6727), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4806), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6236), 10,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [43011] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6637), 1,
      anon_sym_SLASH,
    ACTIONS(6639), 1,
      anon_sym_CARET,
    ACTIONS(6641), 1,
      anon_sym_PIPE,
    ACTIONS(6643), 1,
      anon_sym_AMP,
    ACTIONS(6647), 1,
      anon_sym_GT_GT,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6655), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6663), 1,
      anon_sym_as,
    ACTIONS(6665), 1,
      anon_sym_is,
    ACTIONS(6667), 1,
      anon_sym_with,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6116), 2,
      anon_sym_QMARK,
      anon_sym_or,
    ACTIONS(6629), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6633), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6635), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6645), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6649), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6651), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4807), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 12,
      anon_sym_where,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [43146] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6218), 1,
      anon_sym_in,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(6675), 1,
      anon_sym_SLASH,
    ACTIONS(6677), 1,
      anon_sym_CARET,
    ACTIONS(6679), 1,
      anon_sym_PIPE,
    ACTIONS(6681), 1,
      anon_sym_AMP,
    ACTIONS(6685), 1,
      anon_sym_GT_GT,
    ACTIONS(6691), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6693), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6695), 1,
      anon_sym_as,
    ACTIONS(6697), 1,
      anon_sym_is,
    ACTIONS(6699), 1,
      anon_sym_QMARK,
    ACTIONS(6701), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6703), 1,
      anon_sym_QMARK_QMARK,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6669), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6671), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6673), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6683), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6687), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6689), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4808), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6216), 9,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_into,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [43289] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4168), 1,
      sym__identifier_token,
    ACTIONS(4592), 1,
      anon_sym_ref,
    ACTIONS(6206), 1,
      anon_sym_delegate,
    ACTIONS(6210), 1,
      anon_sym_var,
    ACTIONS(6212), 1,
      sym_predefined_type,
    ACTIONS(6260), 1,
      anon_sym_scoped,
    ACTIONS(6518), 1,
      anon_sym_LPAREN,
    STATE(3891), 1,
      sym_identifier,
    STATE(3897), 1,
      sym__reserved_identifier,
    STATE(3950), 1,
      sym_array_type,
    STATE(3962), 1,
      sym_tuple_type,
    STATE(3995), 1,
      sym_type,
    STATE(4047), 1,
      sym_generic_name,
    STATE(4268), 1,
      sym__name,
    STATE(8755), 1,
      sym__array_base_type,
    STATE(9763), 1,
      sym__pointer_base_type,
    STATE(3937), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3954), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3955), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4809), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4170), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [43412] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4157), 1,
      sym__identifier_token,
    ACTIONS(4574), 1,
      anon_sym_ref,
    ACTIONS(6137), 1,
      anon_sym_delegate,
    ACTIONS(6139), 1,
      anon_sym_scoped,
    ACTIONS(6141), 1,
      anon_sym_var,
    ACTIONS(6143), 1,
      sym_predefined_type,
    ACTIONS(6577), 1,
      anon_sym_LPAREN,
    STATE(3787), 1,
      sym_identifier,
    STATE(3838), 1,
      sym__reserved_identifier,
    STATE(3874), 1,
      sym_generic_name,
    STATE(3916), 1,
      sym_array_type,
    STATE(3918), 1,
      sym_tuple_type,
    STATE(3923), 1,
      sym_type,
    STATE(3925), 1,
      sym__name,
    STATE(8833), 1,
      sym__array_base_type,
    STATE(9537), 1,
      sym__pointer_base_type,
    STATE(3912), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(3915), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3917), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4810), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4159), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [43535] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(6675), 1,
      anon_sym_SLASH,
    ACTIONS(6677), 1,
      anon_sym_CARET,
    ACTIONS(6679), 1,
      anon_sym_PIPE,
    ACTIONS(6681), 1,
      anon_sym_AMP,
    ACTIONS(6685), 1,
      anon_sym_GT_GT,
    ACTIONS(6691), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6693), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6695), 1,
      anon_sym_as,
    ACTIONS(6697), 1,
      anon_sym_is,
    ACTIONS(6701), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6703), 1,
      anon_sym_QMARK_QMARK,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6116), 2,
      anon_sym_in,
      anon_sym_QMARK,
    ACTIONS(6669), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6671), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6673), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6683), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6687), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6689), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4811), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 9,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_into,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [43676] = 32,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6637), 1,
      anon_sym_SLASH,
    ACTIONS(6647), 1,
      anon_sym_GT_GT,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6655), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6663), 1,
      anon_sym_as,
    ACTIONS(6665), 1,
      anon_sym_is,
    ACTIONS(6667), 1,
      anon_sym_with,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6629), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6633), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6635), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6645), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6651), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6116), 4,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_or,
    STATE(4812), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 15,
      anon_sym_where,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [43803] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6637), 1,
      anon_sym_SLASH,
    ACTIONS(6647), 1,
      anon_sym_GT_GT,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6655), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6663), 1,
      anon_sym_as,
    ACTIONS(6665), 1,
      anon_sym_is,
    ACTIONS(6667), 1,
      anon_sym_with,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6629), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6633), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6635), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6645), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6649), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6651), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6116), 4,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_or,
    STATE(4813), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 13,
      anon_sym_where,
      anon_sym_CARET,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [43932] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6637), 1,
      anon_sym_SLASH,
    ACTIONS(6639), 1,
      anon_sym_CARET,
    ACTIONS(6643), 1,
      anon_sym_AMP,
    ACTIONS(6647), 1,
      anon_sym_GT_GT,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6655), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6663), 1,
      anon_sym_as,
    ACTIONS(6665), 1,
      anon_sym_is,
    ACTIONS(6667), 1,
      anon_sym_with,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6629), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6633), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6635), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6645), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6649), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6651), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6116), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_or,
    STATE(4814), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 12,
      anon_sym_where,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [44065] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6747), 1,
      anon_sym_and,
    STATE(4815), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6546), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(6544), 31,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [44154] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2983), 1,
      sym__identifier_token,
    ACTIONS(2995), 1,
      anon_sym_LPAREN,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3728), 1,
      anon_sym_delegate,
    ACTIONS(6496), 1,
      anon_sym_var,
    ACTIONS(6498), 1,
      anon_sym_ref,
    ACTIONS(6502), 1,
      anon_sym_scoped,
    STATE(4443), 1,
      sym__reserved_identifier,
    STATE(4921), 1,
      sym_identifier,
    STATE(4959), 1,
      sym_generic_name,
    STATE(5237), 1,
      sym_tuple_type,
    STATE(5381), 1,
      sym__name,
    STATE(5548), 1,
      sym_array_type,
    STATE(8768), 1,
      sym__array_base_type,
    STATE(9134), 1,
      sym_type,
    STATE(9721), 1,
      sym__pointer_base_type,
    STATE(2898), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5234), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4816), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2987), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [44277] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5165), 1,
      anon_sym_DOT,
    ACTIONS(5167), 1,
      anon_sym_DASH_GT,
    ACTIONS(6008), 1,
      anon_sym_LPAREN,
    ACTIONS(6038), 1,
      anon_sym_LBRACK,
    ACTIONS(6044), 1,
      anon_sym_BANG,
    ACTIONS(6068), 1,
      anon_sym_switch,
    ACTIONS(6082), 1,
      anon_sym_with,
    ACTIONS(6368), 1,
      anon_sym_as,
    ACTIONS(6709), 1,
      anon_sym_SLASH,
    ACTIONS(6711), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6715), 1,
      anon_sym_CARET,
    ACTIONS(6719), 1,
      anon_sym_AMP,
    ACTIONS(6723), 1,
      anon_sym_GT_GT,
    ACTIONS(6729), 1,
      anon_sym_is,
    STATE(3551), 1,
      sym_bracketed_argument_list,
    STATE(4571), 1,
      sym_argument_list,
    ACTIONS(6046), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6116), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(6705), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6707), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6713), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6721), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6725), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6727), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4817), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 13,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [44410] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5165), 1,
      anon_sym_DOT,
    ACTIONS(5167), 1,
      anon_sym_DASH_GT,
    ACTIONS(6008), 1,
      anon_sym_LPAREN,
    ACTIONS(6038), 1,
      anon_sym_LBRACK,
    ACTIONS(6044), 1,
      anon_sym_BANG,
    ACTIONS(6711), 1,
      anon_sym_DOT_DOT,
    STATE(3551), 1,
      sym_bracketed_argument_list,
    STATE(4571), 1,
      sym_argument_list,
    ACTIONS(6046), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(4818), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1147), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
    ACTIONS(1133), 25,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_with,
  [44515] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2983), 1,
      sym__identifier_token,
    ACTIONS(2995), 1,
      anon_sym_LPAREN,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3728), 1,
      anon_sym_delegate,
    ACTIONS(6496), 1,
      anon_sym_var,
    ACTIONS(6498), 1,
      anon_sym_ref,
    ACTIONS(6502), 1,
      anon_sym_scoped,
    STATE(4443), 1,
      sym__reserved_identifier,
    STATE(4921), 1,
      sym_identifier,
    STATE(4959), 1,
      sym_generic_name,
    STATE(5237), 1,
      sym_tuple_type,
    STATE(5381), 1,
      sym__name,
    STATE(5548), 1,
      sym_array_type,
    STATE(8768), 1,
      sym__array_base_type,
    STATE(9128), 1,
      sym_type,
    STATE(9721), 1,
      sym__pointer_base_type,
    STATE(2898), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5234), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4819), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2987), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [44638] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4287), 1,
      sym__identifier_token,
    ACTIONS(4455), 1,
      anon_sym_delegate,
    ACTIONS(4459), 1,
      anon_sym_var,
    ACTIONS(4461), 1,
      sym_predefined_type,
    ACTIONS(4655), 1,
      anon_sym_ref,
    ACTIONS(6106), 1,
      anon_sym_scoped,
    ACTIONS(6522), 1,
      anon_sym_LPAREN,
    STATE(3568), 1,
      sym__reserved_identifier,
    STATE(3590), 1,
      sym_identifier,
    STATE(3633), 1,
      sym_tuple_type,
    STATE(3661), 1,
      sym_array_type,
    STATE(3708), 1,
      sym_generic_name,
    STATE(3716), 1,
      sym_type,
    STATE(3770), 1,
      sym__name,
    STATE(8888), 1,
      sym__array_base_type,
    STATE(9386), 1,
      sym__pointer_base_type,
    STATE(3618), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3635), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(3706), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4820), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4289), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [44761] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4287), 1,
      sym__identifier_token,
    ACTIONS(4455), 1,
      anon_sym_delegate,
    ACTIONS(4459), 1,
      anon_sym_var,
    ACTIONS(4461), 1,
      sym_predefined_type,
    ACTIONS(4610), 1,
      anon_sym_ref,
    ACTIONS(6100), 1,
      anon_sym_scoped,
    ACTIONS(6522), 1,
      anon_sym_LPAREN,
    STATE(3568), 1,
      sym__reserved_identifier,
    STATE(3590), 1,
      sym_identifier,
    STATE(3633), 1,
      sym_tuple_type,
    STATE(3661), 1,
      sym_array_type,
    STATE(3708), 1,
      sym_generic_name,
    STATE(3716), 1,
      sym_type,
    STATE(3770), 1,
      sym__name,
    STATE(8888), 1,
      sym__array_base_type,
    STATE(9386), 1,
      sym__pointer_base_type,
    STATE(3618), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3635), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(3706), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4821), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4289), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [44884] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2983), 1,
      sym__identifier_token,
    ACTIONS(2995), 1,
      anon_sym_LPAREN,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3728), 1,
      anon_sym_delegate,
    ACTIONS(5284), 1,
      anon_sym_var,
    ACTIONS(6597), 1,
      anon_sym_ref,
    ACTIONS(6601), 1,
      anon_sym_scoped,
    STATE(2892), 1,
      sym_type,
    STATE(4443), 1,
      sym__reserved_identifier,
    STATE(4921), 1,
      sym_identifier,
    STATE(4959), 1,
      sym_generic_name,
    STATE(5237), 1,
      sym_tuple_type,
    STATE(5381), 1,
      sym__name,
    STATE(5548), 1,
      sym_array_type,
    STATE(8768), 1,
      sym__array_base_type,
    STATE(9721), 1,
      sym__pointer_base_type,
    STATE(2898), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5234), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4822), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2987), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [45007] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4157), 1,
      sym__identifier_token,
    ACTIONS(4572), 1,
      anon_sym_ref,
    ACTIONS(6137), 1,
      anon_sym_delegate,
    ACTIONS(6141), 1,
      anon_sym_var,
    ACTIONS(6143), 1,
      sym_predefined_type,
    ACTIONS(6181), 1,
      anon_sym_scoped,
    ACTIONS(6577), 1,
      anon_sym_LPAREN,
    STATE(3787), 1,
      sym_identifier,
    STATE(3838), 1,
      sym__reserved_identifier,
    STATE(3874), 1,
      sym_generic_name,
    STATE(3916), 1,
      sym_array_type,
    STATE(3918), 1,
      sym_tuple_type,
    STATE(3923), 1,
      sym_type,
    STATE(3925), 1,
      sym__name,
    STATE(8833), 1,
      sym__array_base_type,
    STATE(9537), 1,
      sym__pointer_base_type,
    STATE(3912), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(3915), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3917), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4823), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4159), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [45130] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2983), 1,
      sym__identifier_token,
    ACTIONS(2995), 1,
      anon_sym_LPAREN,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3728), 1,
      anon_sym_delegate,
    ACTIONS(5284), 1,
      anon_sym_var,
    ACTIONS(6597), 1,
      anon_sym_ref,
    ACTIONS(6601), 1,
      anon_sym_scoped,
    STATE(4443), 1,
      sym__reserved_identifier,
    STATE(4921), 1,
      sym_identifier,
    STATE(4959), 1,
      sym_generic_name,
    STATE(5237), 1,
      sym_tuple_type,
    STATE(5381), 1,
      sym__name,
    STATE(5548), 1,
      sym_array_type,
    STATE(8768), 1,
      sym__array_base_type,
    STATE(9068), 1,
      sym_type,
    STATE(9721), 1,
      sym__pointer_base_type,
    STATE(2898), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5234), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4824), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2987), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [45253] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2983), 1,
      sym__identifier_token,
    ACTIONS(2995), 1,
      anon_sym_LPAREN,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3728), 1,
      anon_sym_delegate,
    ACTIONS(5284), 1,
      anon_sym_var,
    ACTIONS(6597), 1,
      anon_sym_ref,
    ACTIONS(6601), 1,
      anon_sym_scoped,
    STATE(4443), 1,
      sym__reserved_identifier,
    STATE(4921), 1,
      sym_identifier,
    STATE(4959), 1,
      sym_generic_name,
    STATE(5237), 1,
      sym_tuple_type,
    STATE(5381), 1,
      sym__name,
    STATE(5548), 1,
      sym_array_type,
    STATE(8768), 1,
      sym__array_base_type,
    STATE(9096), 1,
      sym_type,
    STATE(9721), 1,
      sym__pointer_base_type,
    STATE(2898), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5234), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4825), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2987), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [45376] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4157), 1,
      sym__identifier_token,
    ACTIONS(4161), 1,
      anon_sym_ref,
    ACTIONS(6137), 1,
      anon_sym_delegate,
    ACTIONS(6141), 1,
      anon_sym_var,
    ACTIONS(6143), 1,
      sym_predefined_type,
    ACTIONS(6234), 1,
      anon_sym_scoped,
    ACTIONS(6577), 1,
      anon_sym_LPAREN,
    STATE(3787), 1,
      sym_identifier,
    STATE(3838), 1,
      sym__reserved_identifier,
    STATE(3874), 1,
      sym_generic_name,
    STATE(3916), 1,
      sym_array_type,
    STATE(3918), 1,
      sym_tuple_type,
    STATE(3923), 1,
      sym_type,
    STATE(3925), 1,
      sym__name,
    STATE(8833), 1,
      sym__array_base_type,
    STATE(9537), 1,
      sym__pointer_base_type,
    STATE(3912), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(3915), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3917), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4826), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4159), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [45499] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4157), 1,
      sym__identifier_token,
    ACTIONS(4463), 1,
      anon_sym_ref,
    ACTIONS(6137), 1,
      anon_sym_delegate,
    ACTIONS(6141), 1,
      anon_sym_var,
    ACTIONS(6143), 1,
      sym_predefined_type,
    ACTIONS(6244), 1,
      anon_sym_scoped,
    ACTIONS(6577), 1,
      anon_sym_LPAREN,
    STATE(3787), 1,
      sym_identifier,
    STATE(3838), 1,
      sym__reserved_identifier,
    STATE(3874), 1,
      sym_generic_name,
    STATE(3916), 1,
      sym_array_type,
    STATE(3918), 1,
      sym_tuple_type,
    STATE(3925), 1,
      sym__name,
    STATE(3973), 1,
      sym_type,
    STATE(8833), 1,
      sym__array_base_type,
    STATE(9537), 1,
      sym__pointer_base_type,
    STATE(3912), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(3915), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3917), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4827), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4159), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [45622] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4225), 1,
      sym__identifier_token,
    ACTIONS(4584), 1,
      anon_sym_ref,
    ACTIONS(6165), 1,
      anon_sym_delegate,
    ACTIONS(6169), 1,
      anon_sym_var,
    ACTIONS(6171), 1,
      sym_predefined_type,
    ACTIONS(6242), 1,
      anon_sym_scoped,
    ACTIONS(6540), 1,
      anon_sym_LPAREN,
    STATE(3558), 1,
      sym__reserved_identifier,
    STATE(3583), 1,
      sym_tuple_type,
    STATE(3587), 1,
      sym_array_type,
    STATE(3598), 1,
      sym_type,
    STATE(3608), 1,
      sym_generic_name,
    STATE(4643), 1,
      sym_identifier,
    STATE(4952), 1,
      sym__name,
    STATE(8879), 1,
      sym__array_base_type,
    STATE(9439), 1,
      sym__pointer_base_type,
    STATE(3569), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3585), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3592), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4828), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4227), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [45745] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5165), 1,
      anon_sym_DOT,
    ACTIONS(5167), 1,
      anon_sym_DASH_GT,
    ACTIONS(6008), 1,
      anon_sym_LPAREN,
    ACTIONS(6038), 1,
      anon_sym_LBRACK,
    ACTIONS(6044), 1,
      anon_sym_BANG,
    ACTIONS(6068), 1,
      anon_sym_switch,
    ACTIONS(6082), 1,
      anon_sym_with,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6368), 1,
      anon_sym_as,
    ACTIONS(6709), 1,
      anon_sym_SLASH,
    ACTIONS(6711), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6715), 1,
      anon_sym_CARET,
    ACTIONS(6717), 1,
      anon_sym_PIPE,
    ACTIONS(6719), 1,
      anon_sym_AMP,
    ACTIONS(6723), 1,
      anon_sym_GT_GT,
    ACTIONS(6729), 1,
      anon_sym_is,
    ACTIONS(6735), 1,
      anon_sym_AMP_AMP,
    STATE(3551), 1,
      sym_bracketed_argument_list,
    STATE(4571), 1,
      sym_argument_list,
    ACTIONS(6046), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6705), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6707), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6713), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6721), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6725), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6727), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4829), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 12,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [45882] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6637), 1,
      anon_sym_SLASH,
    ACTIONS(6643), 1,
      anon_sym_AMP,
    ACTIONS(6647), 1,
      anon_sym_GT_GT,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6655), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6663), 1,
      anon_sym_as,
    ACTIONS(6665), 1,
      anon_sym_is,
    ACTIONS(6667), 1,
      anon_sym_with,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6629), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6633), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6635), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6645), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6649), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6651), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6116), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_or,
    STATE(4830), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 13,
      anon_sym_where,
      anon_sym_CARET,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [46013] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6655), 1,
      anon_sym_DOT_DOT,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(4831), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1147), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_or,
    ACTIONS(1133), 25,
      anon_sym_where,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [46118] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5298), 1,
      anon_sym_LBRACK,
    ACTIONS(5922), 1,
      anon_sym_LBRACE,
    ACTIONS(5925), 1,
      anon_sym_QMARK,
    STATE(3685), 1,
      sym_initializer_expression,
    STATE(4832), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5308), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
    ACTIONS(5302), 30,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [46213] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4225), 1,
      sym__identifier_token,
    ACTIONS(4584), 1,
      anon_sym_ref,
    ACTIONS(6165), 1,
      anon_sym_delegate,
    ACTIONS(6169), 1,
      anon_sym_var,
    ACTIONS(6171), 1,
      sym_predefined_type,
    ACTIONS(6242), 1,
      anon_sym_scoped,
    ACTIONS(6540), 1,
      anon_sym_LPAREN,
    STATE(3558), 1,
      sym__reserved_identifier,
    STATE(3583), 1,
      sym_tuple_type,
    STATE(3587), 1,
      sym_array_type,
    STATE(3608), 1,
      sym_generic_name,
    STATE(3681), 1,
      sym_type,
    STATE(4643), 1,
      sym_identifier,
    STATE(4952), 1,
      sym__name,
    STATE(8879), 1,
      sym__array_base_type,
    STATE(9439), 1,
      sym__pointer_base_type,
    STATE(3569), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3585), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3592), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4833), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4227), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [46336] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2983), 1,
      sym__identifier_token,
    ACTIONS(2995), 1,
      anon_sym_LPAREN,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3728), 1,
      anon_sym_delegate,
    ACTIONS(6496), 1,
      anon_sym_var,
    ACTIONS(6498), 1,
      anon_sym_ref,
    ACTIONS(6502), 1,
      anon_sym_scoped,
    STATE(4443), 1,
      sym__reserved_identifier,
    STATE(4921), 1,
      sym_identifier,
    STATE(4959), 1,
      sym_generic_name,
    STATE(5237), 1,
      sym_tuple_type,
    STATE(5381), 1,
      sym__name,
    STATE(5548), 1,
      sym_array_type,
    STATE(8768), 1,
      sym__array_base_type,
    STATE(9558), 1,
      sym_type,
    STATE(9721), 1,
      sym__pointer_base_type,
    STATE(2898), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5234), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4834), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2987), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [46459] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2983), 1,
      sym__identifier_token,
    ACTIONS(2995), 1,
      anon_sym_LPAREN,
    ACTIONS(3023), 1,
      anon_sym_var,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3728), 1,
      anon_sym_delegate,
    ACTIONS(6488), 1,
      anon_sym_ref,
    ACTIONS(6492), 1,
      anon_sym_scoped,
    STATE(4443), 1,
      sym__reserved_identifier,
    STATE(4921), 1,
      sym_identifier,
    STATE(4959), 1,
      sym_generic_name,
    STATE(5237), 1,
      sym_tuple_type,
    STATE(5381), 1,
      sym__name,
    STATE(5548), 1,
      sym_array_type,
    STATE(8699), 1,
      sym_type,
    STATE(8768), 1,
      sym__array_base_type,
    STATE(9721), 1,
      sym__pointer_base_type,
    STATE(2898), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5234), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4835), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2987), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [46582] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(5339), 1,
      anon_sym_or,
    ACTIONS(6631), 1,
      anon_sym_QMARK,
    ACTIONS(6637), 1,
      anon_sym_SLASH,
    ACTIONS(6639), 1,
      anon_sym_CARET,
    ACTIONS(6641), 1,
      anon_sym_PIPE,
    ACTIONS(6643), 1,
      anon_sym_AMP,
    ACTIONS(6647), 1,
      anon_sym_GT_GT,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6655), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6657), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6659), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6661), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6663), 1,
      anon_sym_as,
    ACTIONS(6665), 1,
      anon_sym_is,
    ACTIONS(6667), 1,
      anon_sym_with,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6629), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6633), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6635), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6645), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6649), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6651), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4836), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5337), 9,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [46725] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2983), 1,
      sym__identifier_token,
    ACTIONS(2995), 1,
      anon_sym_LPAREN,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3728), 1,
      anon_sym_delegate,
    ACTIONS(5284), 1,
      anon_sym_var,
    ACTIONS(5912), 1,
      anon_sym_ref,
    ACTIONS(5920), 1,
      anon_sym_scoped,
    STATE(4443), 1,
      sym__reserved_identifier,
    STATE(4921), 1,
      sym_identifier,
    STATE(4959), 1,
      sym_generic_name,
    STATE(5237), 1,
      sym_tuple_type,
    STATE(5381), 1,
      sym__name,
    STATE(5548), 1,
      sym_array_type,
    STATE(8343), 1,
      sym_type,
    STATE(8768), 1,
      sym__array_base_type,
    STATE(9721), 1,
      sym__pointer_base_type,
    STATE(2898), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5234), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4837), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2987), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [46848] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6749), 1,
      anon_sym_into,
    STATE(4855), 1,
      aux_sym__query_body_repeat2,
    STATE(4838), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6448), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_as,
    ACTIONS(6446), 31,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [46939] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6747), 1,
      anon_sym_and,
    ACTIONS(6751), 1,
      anon_sym_or,
    STATE(4839), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5856), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_as,
    ACTIONS(5854), 31,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [47030] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6637), 1,
      anon_sym_SLASH,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6655), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6667), 1,
      anon_sym_with,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6633), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6635), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6116), 7,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_or,
    STATE(4840), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 21,
      anon_sym_where,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
  [47145] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4168), 1,
      sym__identifier_token,
    ACTIONS(4172), 1,
      anon_sym_ref,
    ACTIONS(6206), 1,
      anon_sym_delegate,
    ACTIONS(6210), 1,
      anon_sym_var,
    ACTIONS(6212), 1,
      sym_predefined_type,
    ACTIONS(6294), 1,
      anon_sym_scoped,
    ACTIONS(6518), 1,
      anon_sym_LPAREN,
    STATE(3891), 1,
      sym_identifier,
    STATE(3897), 1,
      sym__reserved_identifier,
    STATE(3950), 1,
      sym_array_type,
    STATE(3962), 1,
      sym_tuple_type,
    STATE(3995), 1,
      sym_type,
    STATE(4047), 1,
      sym_generic_name,
    STATE(4268), 1,
      sym__name,
    STATE(8755), 1,
      sym__array_base_type,
    STATE(9763), 1,
      sym__pointer_base_type,
    STATE(3937), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3954), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3955), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4841), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4170), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [47268] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(5387), 1,
      anon_sym_or,
    ACTIONS(6631), 1,
      anon_sym_QMARK,
    ACTIONS(6637), 1,
      anon_sym_SLASH,
    ACTIONS(6639), 1,
      anon_sym_CARET,
    ACTIONS(6641), 1,
      anon_sym_PIPE,
    ACTIONS(6643), 1,
      anon_sym_AMP,
    ACTIONS(6647), 1,
      anon_sym_GT_GT,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6655), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6657), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6659), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6661), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6663), 1,
      anon_sym_as,
    ACTIONS(6665), 1,
      anon_sym_is,
    ACTIONS(6667), 1,
      anon_sym_with,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6629), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6633), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6635), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6645), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6649), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6651), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4842), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5385), 9,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [47411] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5165), 1,
      anon_sym_DOT,
    ACTIONS(5167), 1,
      anon_sym_DASH_GT,
    ACTIONS(6008), 1,
      anon_sym_LPAREN,
    ACTIONS(6038), 1,
      anon_sym_LBRACK,
    ACTIONS(6044), 1,
      anon_sym_BANG,
    ACTIONS(6068), 1,
      anon_sym_switch,
    ACTIONS(6082), 1,
      anon_sym_with,
    ACTIONS(6368), 1,
      anon_sym_as,
    ACTIONS(6709), 1,
      anon_sym_SLASH,
    ACTIONS(6711), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6715), 1,
      anon_sym_CARET,
    ACTIONS(6717), 1,
      anon_sym_PIPE,
    ACTIONS(6719), 1,
      anon_sym_AMP,
    ACTIONS(6723), 1,
      anon_sym_GT_GT,
    ACTIONS(6729), 1,
      anon_sym_is,
    ACTIONS(6733), 1,
      anon_sym_QMARK,
    ACTIONS(6735), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6737), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6739), 1,
      anon_sym_QMARK_QMARK,
    STATE(3551), 1,
      sym_bracketed_argument_list,
    STATE(4571), 1,
      sym_argument_list,
    ACTIONS(6046), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6705), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6707), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6713), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6721), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6725), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6727), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4843), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5396), 10,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [47552] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4225), 1,
      sym__identifier_token,
    ACTIONS(4661), 1,
      anon_sym_ref,
    ACTIONS(6165), 1,
      anon_sym_delegate,
    ACTIONS(6169), 1,
      anon_sym_var,
    ACTIONS(6171), 1,
      sym_predefined_type,
    ACTIONS(6183), 1,
      anon_sym_scoped,
    ACTIONS(6540), 1,
      anon_sym_LPAREN,
    STATE(3558), 1,
      sym__reserved_identifier,
    STATE(3583), 1,
      sym_tuple_type,
    STATE(3587), 1,
      sym_array_type,
    STATE(3608), 1,
      sym_generic_name,
    STATE(3681), 1,
      sym_type,
    STATE(3989), 1,
      sym_identifier,
    STATE(4328), 1,
      sym__name,
    STATE(8879), 1,
      sym__array_base_type,
    STATE(9439), 1,
      sym__pointer_base_type,
    STATE(3569), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3585), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3592), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4844), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4227), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [47675] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2983), 1,
      sym__identifier_token,
    ACTIONS(2995), 1,
      anon_sym_LPAREN,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3728), 1,
      anon_sym_delegate,
    ACTIONS(5284), 1,
      anon_sym_var,
    ACTIONS(6597), 1,
      anon_sym_ref,
    ACTIONS(6601), 1,
      anon_sym_scoped,
    STATE(4443), 1,
      sym__reserved_identifier,
    STATE(4921), 1,
      sym_identifier,
    STATE(4959), 1,
      sym_generic_name,
    STATE(5237), 1,
      sym_tuple_type,
    STATE(5381), 1,
      sym__name,
    STATE(5548), 1,
      sym_array_type,
    STATE(8768), 1,
      sym__array_base_type,
    STATE(9055), 1,
      sym_type,
    STATE(9721), 1,
      sym__pointer_base_type,
    STATE(2898), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5234), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4845), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2987), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [47798] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2983), 1,
      sym__identifier_token,
    ACTIONS(2995), 1,
      anon_sym_LPAREN,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3728), 1,
      anon_sym_delegate,
    ACTIONS(5284), 1,
      anon_sym_var,
    ACTIONS(6597), 1,
      anon_sym_ref,
    ACTIONS(6601), 1,
      anon_sym_scoped,
    STATE(4443), 1,
      sym__reserved_identifier,
    STATE(4921), 1,
      sym_identifier,
    STATE(4959), 1,
      sym_generic_name,
    STATE(5237), 1,
      sym_tuple_type,
    STATE(5381), 1,
      sym__name,
    STATE(5548), 1,
      sym_array_type,
    STATE(8768), 1,
      sym__array_base_type,
    STATE(9105), 1,
      sym_type,
    STATE(9721), 1,
      sym__pointer_base_type,
    STATE(2898), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5234), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4846), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2987), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [47921] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(5398), 1,
      anon_sym_or,
    ACTIONS(6631), 1,
      anon_sym_QMARK,
    ACTIONS(6637), 1,
      anon_sym_SLASH,
    ACTIONS(6639), 1,
      anon_sym_CARET,
    ACTIONS(6641), 1,
      anon_sym_PIPE,
    ACTIONS(6643), 1,
      anon_sym_AMP,
    ACTIONS(6647), 1,
      anon_sym_GT_GT,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6655), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6657), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6659), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6661), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6663), 1,
      anon_sym_as,
    ACTIONS(6665), 1,
      anon_sym_is,
    ACTIONS(6667), 1,
      anon_sym_with,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6629), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6633), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6635), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6645), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6649), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6651), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4847), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5396), 9,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [48064] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4225), 1,
      sym__identifier_token,
    ACTIONS(4651), 1,
      anon_sym_ref,
    ACTIONS(6165), 1,
      anon_sym_delegate,
    ACTIONS(6169), 1,
      anon_sym_var,
    ACTIONS(6171), 1,
      sym_predefined_type,
    ACTIONS(6250), 1,
      anon_sym_scoped,
    ACTIONS(6540), 1,
      anon_sym_LPAREN,
    STATE(3558), 1,
      sym__reserved_identifier,
    STATE(3583), 1,
      sym_tuple_type,
    STATE(3587), 1,
      sym_array_type,
    STATE(3608), 1,
      sym_generic_name,
    STATE(3681), 1,
      sym_type,
    STATE(3989), 1,
      sym_identifier,
    STATE(4328), 1,
      sym__name,
    STATE(8879), 1,
      sym__array_base_type,
    STATE(9439), 1,
      sym__pointer_base_type,
    STATE(3569), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3585), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3592), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4848), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4227), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [48187] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4225), 1,
      sym__identifier_token,
    ACTIONS(4659), 1,
      anon_sym_ref,
    ACTIONS(6165), 1,
      anon_sym_delegate,
    ACTIONS(6169), 1,
      anon_sym_var,
    ACTIONS(6171), 1,
      sym_predefined_type,
    ACTIONS(6252), 1,
      anon_sym_scoped,
    ACTIONS(6540), 1,
      anon_sym_LPAREN,
    STATE(3558), 1,
      sym__reserved_identifier,
    STATE(3583), 1,
      sym_tuple_type,
    STATE(3587), 1,
      sym_array_type,
    STATE(3608), 1,
      sym_generic_name,
    STATE(3681), 1,
      sym_type,
    STATE(3989), 1,
      sym_identifier,
    STATE(4328), 1,
      sym__name,
    STATE(8879), 1,
      sym__array_base_type,
    STATE(9439), 1,
      sym__pointer_base_type,
    STATE(3569), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3585), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3592), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4849), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4227), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [48310] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6218), 1,
      anon_sym_or,
    ACTIONS(6631), 1,
      anon_sym_QMARK,
    ACTIONS(6637), 1,
      anon_sym_SLASH,
    ACTIONS(6639), 1,
      anon_sym_CARET,
    ACTIONS(6641), 1,
      anon_sym_PIPE,
    ACTIONS(6643), 1,
      anon_sym_AMP,
    ACTIONS(6647), 1,
      anon_sym_GT_GT,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6655), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6657), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6659), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6661), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6663), 1,
      anon_sym_as,
    ACTIONS(6665), 1,
      anon_sym_is,
    ACTIONS(6667), 1,
      anon_sym_with,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6629), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6633), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6635), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6645), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6649), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6651), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4850), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6216), 9,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [48453] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4287), 1,
      sym__identifier_token,
    ACTIONS(4455), 1,
      anon_sym_delegate,
    ACTIONS(4459), 1,
      anon_sym_var,
    ACTIONS(4461), 1,
      sym_predefined_type,
    ACTIONS(4657), 1,
      anon_sym_ref,
    ACTIONS(6127), 1,
      anon_sym_scoped,
    ACTIONS(6522), 1,
      anon_sym_LPAREN,
    STATE(3568), 1,
      sym__reserved_identifier,
    STATE(3590), 1,
      sym_identifier,
    STATE(3633), 1,
      sym_tuple_type,
    STATE(3661), 1,
      sym_array_type,
    STATE(3663), 1,
      sym_type,
    STATE(3708), 1,
      sym_generic_name,
    STATE(3770), 1,
      sym__name,
    STATE(8888), 1,
      sym__array_base_type,
    STATE(9386), 1,
      sym__pointer_base_type,
    STATE(3618), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3635), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(3706), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4851), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4289), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [48576] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(5327), 1,
      anon_sym_or,
    ACTIONS(6631), 1,
      anon_sym_QMARK,
    ACTIONS(6637), 1,
      anon_sym_SLASH,
    ACTIONS(6639), 1,
      anon_sym_CARET,
    ACTIONS(6641), 1,
      anon_sym_PIPE,
    ACTIONS(6643), 1,
      anon_sym_AMP,
    ACTIONS(6647), 1,
      anon_sym_GT_GT,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6655), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6657), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6659), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6661), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6663), 1,
      anon_sym_as,
    ACTIONS(6665), 1,
      anon_sym_is,
    ACTIONS(6667), 1,
      anon_sym_with,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6629), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6633), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6635), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6645), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6649), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6651), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4852), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5325), 9,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [48719] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4287), 1,
      sym__identifier_token,
    ACTIONS(4455), 1,
      anon_sym_delegate,
    ACTIONS(4459), 1,
      anon_sym_var,
    ACTIONS(4461), 1,
      sym_predefined_type,
    ACTIONS(4653), 1,
      anon_sym_ref,
    ACTIONS(6288), 1,
      anon_sym_scoped,
    ACTIONS(6522), 1,
      anon_sym_LPAREN,
    STATE(3568), 1,
      sym__reserved_identifier,
    STATE(3590), 1,
      sym_identifier,
    STATE(3633), 1,
      sym_tuple_type,
    STATE(3661), 1,
      sym_array_type,
    STATE(3708), 1,
      sym_generic_name,
    STATE(3716), 1,
      sym_type,
    STATE(3770), 1,
      sym__name,
    STATE(8888), 1,
      sym__array_base_type,
    STATE(9386), 1,
      sym__pointer_base_type,
    STATE(3618), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3635), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(3706), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4853), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4289), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [48842] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6749), 1,
      anon_sym_into,
    STATE(4898), 1,
      aux_sym__query_body_repeat2,
    STATE(4854), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6420), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_as,
    ACTIONS(6418), 31,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [48933] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6749), 1,
      anon_sym_into,
    STATE(4894), 1,
      aux_sym__query_body_repeat2,
    STATE(4855), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6420), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_as,
    ACTIONS(6418), 31,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [49024] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4168), 1,
      sym__identifier_token,
    ACTIONS(4598), 1,
      anon_sym_ref,
    ACTIONS(6206), 1,
      anon_sym_delegate,
    ACTIONS(6210), 1,
      anon_sym_var,
    ACTIONS(6212), 1,
      sym_predefined_type,
    ACTIONS(6254), 1,
      anon_sym_scoped,
    ACTIONS(6518), 1,
      anon_sym_LPAREN,
    STATE(3891), 1,
      sym_identifier,
    STATE(3897), 1,
      sym__reserved_identifier,
    STATE(3950), 1,
      sym_array_type,
    STATE(3962), 1,
      sym_tuple_type,
    STATE(4047), 1,
      sym_generic_name,
    STATE(4199), 1,
      sym_type,
    STATE(4268), 1,
      sym__name,
    STATE(8755), 1,
      sym__array_base_type,
    STATE(9763), 1,
      sym__pointer_base_type,
    STATE(3937), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3954), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3955), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4856), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4170), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [49147] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(5512), 1,
      anon_sym_or,
    ACTIONS(6631), 1,
      anon_sym_QMARK,
    ACTIONS(6637), 1,
      anon_sym_SLASH,
    ACTIONS(6639), 1,
      anon_sym_CARET,
    ACTIONS(6641), 1,
      anon_sym_PIPE,
    ACTIONS(6643), 1,
      anon_sym_AMP,
    ACTIONS(6647), 1,
      anon_sym_GT_GT,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6655), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6657), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6659), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6661), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6663), 1,
      anon_sym_as,
    ACTIONS(6665), 1,
      anon_sym_is,
    ACTIONS(6667), 1,
      anon_sym_with,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6629), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6633), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6635), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6645), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6649), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6651), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4857), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5510), 9,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [49290] = 32,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5165), 1,
      anon_sym_DOT,
    ACTIONS(5167), 1,
      anon_sym_DASH_GT,
    ACTIONS(6008), 1,
      anon_sym_LPAREN,
    ACTIONS(6038), 1,
      anon_sym_LBRACK,
    ACTIONS(6044), 1,
      anon_sym_BANG,
    ACTIONS(6068), 1,
      anon_sym_switch,
    ACTIONS(6082), 1,
      anon_sym_with,
    ACTIONS(6368), 1,
      anon_sym_as,
    ACTIONS(6709), 1,
      anon_sym_SLASH,
    ACTIONS(6711), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6723), 1,
      anon_sym_GT_GT,
    ACTIONS(6729), 1,
      anon_sym_is,
    STATE(3551), 1,
      sym_bracketed_argument_list,
    STATE(4571), 1,
      sym_argument_list,
    ACTIONS(6046), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6705), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6707), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6713), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6721), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6727), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6116), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(4858), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 16,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [49417] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5165), 1,
      anon_sym_DOT,
    ACTIONS(5167), 1,
      anon_sym_DASH_GT,
    ACTIONS(6008), 1,
      anon_sym_LPAREN,
    ACTIONS(6038), 1,
      anon_sym_LBRACK,
    ACTIONS(6044), 1,
      anon_sym_BANG,
    ACTIONS(6068), 1,
      anon_sym_switch,
    ACTIONS(6082), 1,
      anon_sym_with,
    ACTIONS(6368), 1,
      anon_sym_as,
    ACTIONS(6709), 1,
      anon_sym_SLASH,
    ACTIONS(6711), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6715), 1,
      anon_sym_CARET,
    ACTIONS(6717), 1,
      anon_sym_PIPE,
    ACTIONS(6719), 1,
      anon_sym_AMP,
    ACTIONS(6723), 1,
      anon_sym_GT_GT,
    ACTIONS(6729), 1,
      anon_sym_is,
    ACTIONS(6733), 1,
      anon_sym_QMARK,
    ACTIONS(6735), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6737), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6739), 1,
      anon_sym_QMARK_QMARK,
    STATE(3551), 1,
      sym_bracketed_argument_list,
    STATE(4571), 1,
      sym_argument_list,
    ACTIONS(6046), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6705), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6707), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6713), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6721), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6725), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6727), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4859), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5385), 10,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [49558] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6655), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6667), 1,
      anon_sym_with,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(4860), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6116), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_or,
    ACTIONS(6114), 23,
      anon_sym_where,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
  [49667] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2983), 1,
      sym__identifier_token,
    ACTIONS(2995), 1,
      anon_sym_LPAREN,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3728), 1,
      anon_sym_delegate,
    ACTIONS(6496), 1,
      anon_sym_var,
    ACTIONS(6498), 1,
      anon_sym_ref,
    ACTIONS(6502), 1,
      anon_sym_scoped,
    STATE(4443), 1,
      sym__reserved_identifier,
    STATE(4921), 1,
      sym_identifier,
    STATE(4959), 1,
      sym_generic_name,
    STATE(5237), 1,
      sym_tuple_type,
    STATE(5381), 1,
      sym__name,
    STATE(5548), 1,
      sym_array_type,
    STATE(8768), 1,
      sym__array_base_type,
    STATE(9721), 1,
      sym__pointer_base_type,
    STATE(9899), 1,
      sym_type,
    STATE(2898), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5234), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4861), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2987), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [49790] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2983), 1,
      sym__identifier_token,
    ACTIONS(2995), 1,
      anon_sym_LPAREN,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3728), 1,
      anon_sym_delegate,
    ACTIONS(6496), 1,
      anon_sym_var,
    ACTIONS(6498), 1,
      anon_sym_ref,
    ACTIONS(6502), 1,
      anon_sym_scoped,
    STATE(4443), 1,
      sym__reserved_identifier,
    STATE(4921), 1,
      sym_identifier,
    STATE(4959), 1,
      sym_generic_name,
    STATE(5237), 1,
      sym_tuple_type,
    STATE(5381), 1,
      sym__name,
    STATE(5548), 1,
      sym_array_type,
    STATE(8768), 1,
      sym__array_base_type,
    STATE(9721), 1,
      sym__pointer_base_type,
    STATE(9897), 1,
      sym_type,
    STATE(2898), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5234), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4862), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2987), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [49913] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2983), 1,
      sym__identifier_token,
    ACTIONS(2995), 1,
      anon_sym_LPAREN,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3728), 1,
      anon_sym_delegate,
    ACTIONS(6496), 1,
      anon_sym_var,
    ACTIONS(6498), 1,
      anon_sym_ref,
    ACTIONS(6502), 1,
      anon_sym_scoped,
    STATE(4443), 1,
      sym__reserved_identifier,
    STATE(4921), 1,
      sym_identifier,
    STATE(4959), 1,
      sym_generic_name,
    STATE(5237), 1,
      sym_tuple_type,
    STATE(5381), 1,
      sym__name,
    STATE(5548), 1,
      sym_array_type,
    STATE(8768), 1,
      sym__array_base_type,
    STATE(9721), 1,
      sym__pointer_base_type,
    STATE(9896), 1,
      sym_type,
    STATE(2898), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5234), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4863), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2987), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [50036] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(5422), 1,
      anon_sym_or,
    ACTIONS(6631), 1,
      anon_sym_QMARK,
    ACTIONS(6637), 1,
      anon_sym_SLASH,
    ACTIONS(6639), 1,
      anon_sym_CARET,
    ACTIONS(6641), 1,
      anon_sym_PIPE,
    ACTIONS(6643), 1,
      anon_sym_AMP,
    ACTIONS(6647), 1,
      anon_sym_GT_GT,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6655), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6657), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6659), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6661), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6663), 1,
      anon_sym_as,
    ACTIONS(6665), 1,
      anon_sym_is,
    ACTIONS(6667), 1,
      anon_sym_with,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6629), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6633), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6635), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6645), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6649), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6651), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4864), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5420), 9,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [50179] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4391), 1,
      sym__identifier_token,
    ACTIONS(4395), 1,
      anon_sym_ref,
    ACTIONS(6090), 1,
      anon_sym_delegate,
    ACTIONS(6092), 1,
      anon_sym_scoped,
    ACTIONS(6094), 1,
      anon_sym_var,
    ACTIONS(6096), 1,
      sym_predefined_type,
    ACTIONS(6556), 1,
      anon_sym_LPAREN,
    STATE(5034), 1,
      sym_identifier,
    STATE(5144), 1,
      sym__reserved_identifier,
    STATE(5211), 1,
      sym_generic_name,
    STATE(5257), 1,
      sym__name,
    STATE(5293), 1,
      sym_tuple_type,
    STATE(5296), 1,
      sym_array_type,
    STATE(5361), 1,
      sym_type,
    STATE(8680), 1,
      sym__array_base_type,
    STATE(9933), 1,
      sym__pointer_base_type,
    STATE(5271), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(5302), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5380), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4865), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4393), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [50302] = 25,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6637), 1,
      anon_sym_SLASH,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6655), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6667), 1,
      anon_sym_with,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6635), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    STATE(4866), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6116), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_or,
    ACTIONS(6114), 21,
      anon_sym_where,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
  [50415] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2983), 1,
      sym__identifier_token,
    ACTIONS(2995), 1,
      anon_sym_LPAREN,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3728), 1,
      anon_sym_delegate,
    ACTIONS(5284), 1,
      anon_sym_var,
    ACTIONS(6597), 1,
      anon_sym_ref,
    ACTIONS(6601), 1,
      anon_sym_scoped,
    STATE(4443), 1,
      sym__reserved_identifier,
    STATE(4921), 1,
      sym_identifier,
    STATE(4959), 1,
      sym_generic_name,
    STATE(5237), 1,
      sym_tuple_type,
    STATE(5381), 1,
      sym__name,
    STATE(5548), 1,
      sym_array_type,
    STATE(8768), 1,
      sym__array_base_type,
    STATE(9488), 1,
      sym_type,
    STATE(9721), 1,
      sym__pointer_base_type,
    STATE(2898), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5234), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4867), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2987), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [50538] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3728), 1,
      anon_sym_delegate,
    ACTIONS(4014), 1,
      anon_sym_ref,
    ACTIONS(4490), 1,
      sym__identifier_token,
    ACTIONS(6153), 1,
      anon_sym_var,
    ACTIONS(6155), 1,
      sym_predefined_type,
    ACTIONS(6506), 1,
      anon_sym_LPAREN,
    ACTIONS(6508), 1,
      anon_sym_scoped,
    STATE(2892), 1,
      sym_type,
    STATE(2914), 1,
      sym__reserved_identifier,
    STATE(2956), 1,
      sym_generic_name,
    STATE(2973), 1,
      sym_tuple_type,
    STATE(2975), 1,
      sym_array_type,
    STATE(3126), 1,
      sym_identifier,
    STATE(3167), 1,
      sym__name,
    STATE(8712), 1,
      sym__array_base_type,
    STATE(9721), 1,
      sym__pointer_base_type,
    STATE(2898), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(2974), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(2977), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4868), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4492), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [50661] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6276), 1,
      anon_sym_in,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(6675), 1,
      anon_sym_SLASH,
    ACTIONS(6677), 1,
      anon_sym_CARET,
    ACTIONS(6679), 1,
      anon_sym_PIPE,
    ACTIONS(6681), 1,
      anon_sym_AMP,
    ACTIONS(6685), 1,
      anon_sym_GT_GT,
    ACTIONS(6691), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6693), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6695), 1,
      anon_sym_as,
    ACTIONS(6697), 1,
      anon_sym_is,
    ACTIONS(6699), 1,
      anon_sym_QMARK,
    ACTIONS(6701), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6703), 1,
      anon_sym_QMARK_QMARK,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6669), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6671), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6673), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6683), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6687), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6689), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4869), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6274), 9,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_into,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [50804] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4168), 1,
      sym__identifier_token,
    ACTIONS(4592), 1,
      anon_sym_ref,
    ACTIONS(6206), 1,
      anon_sym_delegate,
    ACTIONS(6210), 1,
      anon_sym_var,
    ACTIONS(6212), 1,
      sym_predefined_type,
    ACTIONS(6260), 1,
      anon_sym_scoped,
    ACTIONS(6518), 1,
      anon_sym_LPAREN,
    STATE(3891), 1,
      sym_identifier,
    STATE(3897), 1,
      sym__reserved_identifier,
    STATE(3950), 1,
      sym_array_type,
    STATE(3962), 1,
      sym_tuple_type,
    STATE(4047), 1,
      sym_generic_name,
    STATE(4199), 1,
      sym_type,
    STATE(4268), 1,
      sym__name,
    STATE(8755), 1,
      sym__array_base_type,
    STATE(9763), 1,
      sym__pointer_base_type,
    STATE(3937), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3954), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3955), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4870), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4170), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [50927] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6655), 1,
      anon_sym_DOT_DOT,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(4871), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6122), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_or,
    ACTIONS(6120), 25,
      anon_sym_where,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [51032] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5165), 1,
      anon_sym_DOT,
    ACTIONS(5167), 1,
      anon_sym_DASH_GT,
    ACTIONS(6008), 1,
      anon_sym_LPAREN,
    ACTIONS(6038), 1,
      anon_sym_LBRACK,
    ACTIONS(6044), 1,
      anon_sym_BANG,
    ACTIONS(6068), 1,
      anon_sym_switch,
    ACTIONS(6082), 1,
      anon_sym_with,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6368), 1,
      anon_sym_as,
    ACTIONS(6709), 1,
      anon_sym_SLASH,
    ACTIONS(6711), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6715), 1,
      anon_sym_CARET,
    ACTIONS(6717), 1,
      anon_sym_PIPE,
    ACTIONS(6719), 1,
      anon_sym_AMP,
    ACTIONS(6723), 1,
      anon_sym_GT_GT,
    ACTIONS(6729), 1,
      anon_sym_is,
    ACTIONS(6735), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6737), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6739), 1,
      anon_sym_QMARK_QMARK,
    STATE(3551), 1,
      sym_bracketed_argument_list,
    STATE(4571), 1,
      sym_argument_list,
    ACTIONS(6046), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6705), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6707), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6713), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6721), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6725), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6727), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4872), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 10,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [51173] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5165), 1,
      anon_sym_DOT,
    ACTIONS(5167), 1,
      anon_sym_DASH_GT,
    ACTIONS(6008), 1,
      anon_sym_LPAREN,
    ACTIONS(6038), 1,
      anon_sym_LBRACK,
    ACTIONS(6044), 1,
      anon_sym_BANG,
    ACTIONS(6068), 1,
      anon_sym_switch,
    ACTIONS(6082), 1,
      anon_sym_with,
    ACTIONS(6368), 1,
      anon_sym_as,
    ACTIONS(6709), 1,
      anon_sym_SLASH,
    ACTIONS(6711), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6715), 1,
      anon_sym_CARET,
    ACTIONS(6717), 1,
      anon_sym_PIPE,
    ACTIONS(6719), 1,
      anon_sym_AMP,
    ACTIONS(6723), 1,
      anon_sym_GT_GT,
    ACTIONS(6729), 1,
      anon_sym_is,
    ACTIONS(6733), 1,
      anon_sym_QMARK,
    ACTIONS(6735), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6737), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6739), 1,
      anon_sym_QMARK_QMARK,
    STATE(3551), 1,
      sym_bracketed_argument_list,
    STATE(4571), 1,
      sym_argument_list,
    ACTIONS(6046), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6705), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6707), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6713), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6721), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6725), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6727), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4873), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5420), 10,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [51314] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4168), 1,
      sym__identifier_token,
    ACTIONS(4598), 1,
      anon_sym_ref,
    ACTIONS(6206), 1,
      anon_sym_delegate,
    ACTIONS(6210), 1,
      anon_sym_var,
    ACTIONS(6212), 1,
      sym_predefined_type,
    ACTIONS(6254), 1,
      anon_sym_scoped,
    ACTIONS(6518), 1,
      anon_sym_LPAREN,
    STATE(3891), 1,
      sym_identifier,
    STATE(3897), 1,
      sym__reserved_identifier,
    STATE(3950), 1,
      sym_array_type,
    STATE(3962), 1,
      sym_tuple_type,
    STATE(3995), 1,
      sym_type,
    STATE(4047), 1,
      sym_generic_name,
    STATE(4268), 1,
      sym__name,
    STATE(8755), 1,
      sym__array_base_type,
    STATE(9763), 1,
      sym__pointer_base_type,
    STATE(3937), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3954), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3955), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4874), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4170), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [51437] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6731), 1,
      anon_sym_and,
    ACTIONS(6753), 1,
      anon_sym_or,
    STATE(4875), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6609), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6607), 31,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [51528] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2983), 1,
      sym__identifier_token,
    ACTIONS(2995), 1,
      anon_sym_LPAREN,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3728), 1,
      anon_sym_delegate,
    ACTIONS(6496), 1,
      anon_sym_var,
    ACTIONS(6498), 1,
      anon_sym_ref,
    ACTIONS(6502), 1,
      anon_sym_scoped,
    STATE(4443), 1,
      sym__reserved_identifier,
    STATE(4921), 1,
      sym_identifier,
    STATE(4959), 1,
      sym_generic_name,
    STATE(5237), 1,
      sym_tuple_type,
    STATE(5381), 1,
      sym__name,
    STATE(5548), 1,
      sym_array_type,
    STATE(8768), 1,
      sym__array_base_type,
    STATE(9697), 1,
      sym_type,
    STATE(9721), 1,
      sym__pointer_base_type,
    STATE(2898), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5234), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4876), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2987), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [51651] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2983), 1,
      sym__identifier_token,
    ACTIONS(2995), 1,
      anon_sym_LPAREN,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3728), 1,
      anon_sym_delegate,
    ACTIONS(5284), 1,
      anon_sym_var,
    ACTIONS(6597), 1,
      anon_sym_ref,
    ACTIONS(6601), 1,
      anon_sym_scoped,
    STATE(4443), 1,
      sym__reserved_identifier,
    STATE(4921), 1,
      sym_identifier,
    STATE(4959), 1,
      sym_generic_name,
    STATE(5237), 1,
      sym_tuple_type,
    STATE(5381), 1,
      sym__name,
    STATE(5548), 1,
      sym_array_type,
    STATE(8768), 1,
      sym__array_base_type,
    STATE(8996), 1,
      sym_type,
    STATE(9721), 1,
      sym__pointer_base_type,
    STATE(2898), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5234), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4877), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2987), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [51774] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4157), 1,
      sym__identifier_token,
    ACTIONS(4574), 1,
      anon_sym_ref,
    ACTIONS(6137), 1,
      anon_sym_delegate,
    ACTIONS(6139), 1,
      anon_sym_scoped,
    ACTIONS(6141), 1,
      anon_sym_var,
    ACTIONS(6143), 1,
      sym_predefined_type,
    ACTIONS(6577), 1,
      anon_sym_LPAREN,
    STATE(3787), 1,
      sym_identifier,
    STATE(3838), 1,
      sym__reserved_identifier,
    STATE(3874), 1,
      sym_generic_name,
    STATE(3916), 1,
      sym_array_type,
    STATE(3918), 1,
      sym_tuple_type,
    STATE(3925), 1,
      sym__name,
    STATE(3973), 1,
      sym_type,
    STATE(8833), 1,
      sym__array_base_type,
    STATE(9537), 1,
      sym__pointer_base_type,
    STATE(3912), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(3915), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3917), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4878), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4159), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [51897] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4225), 1,
      sym__identifier_token,
    ACTIONS(4651), 1,
      anon_sym_ref,
    ACTIONS(6165), 1,
      anon_sym_delegate,
    ACTIONS(6169), 1,
      anon_sym_var,
    ACTIONS(6171), 1,
      sym_predefined_type,
    ACTIONS(6250), 1,
      anon_sym_scoped,
    ACTIONS(6540), 1,
      anon_sym_LPAREN,
    STATE(3558), 1,
      sym__reserved_identifier,
    STATE(3583), 1,
      sym_tuple_type,
    STATE(3587), 1,
      sym_array_type,
    STATE(3598), 1,
      sym_type,
    STATE(3608), 1,
      sym_generic_name,
    STATE(3989), 1,
      sym_identifier,
    STATE(4328), 1,
      sym__name,
    STATE(8879), 1,
      sym__array_base_type,
    STATE(9439), 1,
      sym__pointer_base_type,
    STATE(3569), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3585), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3592), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4879), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4227), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [52020] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5165), 1,
      anon_sym_DOT,
    ACTIONS(5167), 1,
      anon_sym_DASH_GT,
    ACTIONS(6008), 1,
      anon_sym_LPAREN,
    ACTIONS(6038), 1,
      anon_sym_LBRACK,
    ACTIONS(6044), 1,
      anon_sym_BANG,
    ACTIONS(6711), 1,
      anon_sym_DOT_DOT,
    STATE(3551), 1,
      sym_bracketed_argument_list,
    STATE(4571), 1,
      sym_argument_list,
    ACTIONS(6046), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(4880), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6122), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
    ACTIONS(6120), 25,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_with,
  [52125] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3728), 1,
      anon_sym_delegate,
    ACTIONS(4490), 1,
      sym__identifier_token,
    ACTIONS(4494), 1,
      anon_sym_ref,
    ACTIONS(6153), 1,
      anon_sym_var,
    ACTIONS(6155), 1,
      sym_predefined_type,
    ACTIONS(6262), 1,
      anon_sym_scoped,
    ACTIONS(6506), 1,
      anon_sym_LPAREN,
    STATE(2913), 1,
      sym_identifier,
    STATE(2914), 1,
      sym__reserved_identifier,
    STATE(2956), 1,
      sym_generic_name,
    STATE(2973), 1,
      sym_tuple_type,
    STATE(2975), 1,
      sym_array_type,
    STATE(3002), 1,
      sym__name,
    STATE(4630), 1,
      sym_type,
    STATE(8712), 1,
      sym__array_base_type,
    STATE(9721), 1,
      sym__pointer_base_type,
    STATE(2898), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(2974), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(2977), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4881), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4492), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [52248] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6238), 1,
      anon_sym_or,
    ACTIONS(6631), 1,
      anon_sym_QMARK,
    ACTIONS(6637), 1,
      anon_sym_SLASH,
    ACTIONS(6639), 1,
      anon_sym_CARET,
    ACTIONS(6641), 1,
      anon_sym_PIPE,
    ACTIONS(6643), 1,
      anon_sym_AMP,
    ACTIONS(6647), 1,
      anon_sym_GT_GT,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6655), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6657), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6659), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6661), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6663), 1,
      anon_sym_as,
    ACTIONS(6665), 1,
      anon_sym_is,
    ACTIONS(6667), 1,
      anon_sym_with,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6629), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6633), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6635), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6645), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6649), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6651), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4882), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6236), 9,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [52391] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6747), 1,
      anon_sym_and,
    ACTIONS(6751), 1,
      anon_sym_or,
    STATE(4883), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6609), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_as,
    ACTIONS(6607), 31,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [52482] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(5512), 1,
      anon_sym_in,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(6675), 1,
      anon_sym_SLASH,
    ACTIONS(6677), 1,
      anon_sym_CARET,
    ACTIONS(6679), 1,
      anon_sym_PIPE,
    ACTIONS(6681), 1,
      anon_sym_AMP,
    ACTIONS(6685), 1,
      anon_sym_GT_GT,
    ACTIONS(6691), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6693), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6695), 1,
      anon_sym_as,
    ACTIONS(6697), 1,
      anon_sym_is,
    ACTIONS(6699), 1,
      anon_sym_QMARK,
    ACTIONS(6701), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6703), 1,
      anon_sym_QMARK_QMARK,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6669), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6671), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6673), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6683), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6687), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6689), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4884), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5510), 9,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_into,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [52625] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2983), 1,
      sym__identifier_token,
    ACTIONS(2995), 1,
      anon_sym_LPAREN,
    ACTIONS(3023), 1,
      anon_sym_var,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3728), 1,
      anon_sym_delegate,
    ACTIONS(6488), 1,
      anon_sym_ref,
    ACTIONS(6492), 1,
      anon_sym_scoped,
    STATE(4443), 1,
      sym__reserved_identifier,
    STATE(4921), 1,
      sym_identifier,
    STATE(4959), 1,
      sym_generic_name,
    STATE(5237), 1,
      sym_tuple_type,
    STATE(5381), 1,
      sym__name,
    STATE(5548), 1,
      sym_array_type,
    STATE(8768), 1,
      sym__array_base_type,
    STATE(8793), 1,
      sym_type,
    STATE(9721), 1,
      sym__pointer_base_type,
    STATE(2898), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5234), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4885), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2987), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [52748] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2983), 1,
      sym__identifier_token,
    ACTIONS(2995), 1,
      anon_sym_LPAREN,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3728), 1,
      anon_sym_delegate,
    ACTIONS(5284), 1,
      anon_sym_var,
    ACTIONS(6597), 1,
      anon_sym_ref,
    ACTIONS(6601), 1,
      anon_sym_scoped,
    STATE(4443), 1,
      sym__reserved_identifier,
    STATE(4921), 1,
      sym_identifier,
    STATE(4959), 1,
      sym_generic_name,
    STATE(5237), 1,
      sym_tuple_type,
    STATE(5381), 1,
      sym__name,
    STATE(5548), 1,
      sym_array_type,
    STATE(8768), 1,
      sym__array_base_type,
    STATE(9009), 1,
      sym_type,
    STATE(9721), 1,
      sym__pointer_base_type,
    STATE(2898), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5234), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4886), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2987), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [52871] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2983), 1,
      sym__identifier_token,
    ACTIONS(2995), 1,
      anon_sym_LPAREN,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3728), 1,
      anon_sym_delegate,
    ACTIONS(6496), 1,
      anon_sym_var,
    ACTIONS(6498), 1,
      anon_sym_ref,
    ACTIONS(6502), 1,
      anon_sym_scoped,
    STATE(4443), 1,
      sym__reserved_identifier,
    STATE(4921), 1,
      sym_identifier,
    STATE(4959), 1,
      sym_generic_name,
    STATE(5237), 1,
      sym_tuple_type,
    STATE(5381), 1,
      sym__name,
    STATE(5548), 1,
      sym_array_type,
    STATE(8768), 1,
      sym__array_base_type,
    STATE(9721), 1,
      sym__pointer_base_type,
    STATE(9853), 1,
      sym_type,
    STATE(2898), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5234), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4887), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2987), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [52994] = 28,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5165), 1,
      anon_sym_DOT,
    ACTIONS(5167), 1,
      anon_sym_DASH_GT,
    ACTIONS(6008), 1,
      anon_sym_LPAREN,
    ACTIONS(6038), 1,
      anon_sym_LBRACK,
    ACTIONS(6044), 1,
      anon_sym_BANG,
    ACTIONS(6068), 1,
      anon_sym_switch,
    ACTIONS(6082), 1,
      anon_sym_with,
    ACTIONS(6709), 1,
      anon_sym_SLASH,
    ACTIONS(6711), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6723), 1,
      anon_sym_GT_GT,
    STATE(3551), 1,
      sym_bracketed_argument_list,
    STATE(4571), 1,
      sym_argument_list,
    ACTIONS(6046), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6705), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6707), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6721), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6116), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_as,
    STATE(4888), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 19,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
  [53113] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4157), 1,
      sym__identifier_token,
    ACTIONS(4586), 1,
      anon_sym_ref,
    ACTIONS(6137), 1,
      anon_sym_delegate,
    ACTIONS(6141), 1,
      anon_sym_var,
    ACTIONS(6143), 1,
      sym_predefined_type,
    ACTIONS(6272), 1,
      anon_sym_scoped,
    ACTIONS(6577), 1,
      anon_sym_LPAREN,
    STATE(3787), 1,
      sym_identifier,
    STATE(3838), 1,
      sym__reserved_identifier,
    STATE(3874), 1,
      sym_generic_name,
    STATE(3916), 1,
      sym_array_type,
    STATE(3918), 1,
      sym_tuple_type,
    STATE(3925), 1,
      sym__name,
    STATE(3973), 1,
      sym_type,
    STATE(8833), 1,
      sym__array_base_type,
    STATE(9537), 1,
      sym__pointer_base_type,
    STATE(3912), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(3915), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3917), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4889), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4159), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [53236] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4287), 1,
      sym__identifier_token,
    ACTIONS(4455), 1,
      anon_sym_delegate,
    ACTIONS(4459), 1,
      anon_sym_var,
    ACTIONS(4461), 1,
      sym_predefined_type,
    ACTIONS(4653), 1,
      anon_sym_ref,
    ACTIONS(6288), 1,
      anon_sym_scoped,
    ACTIONS(6522), 1,
      anon_sym_LPAREN,
    STATE(3568), 1,
      sym__reserved_identifier,
    STATE(3590), 1,
      sym_identifier,
    STATE(3633), 1,
      sym_tuple_type,
    STATE(3661), 1,
      sym_array_type,
    STATE(3663), 1,
      sym_type,
    STATE(3708), 1,
      sym_generic_name,
    STATE(3770), 1,
      sym__name,
    STATE(8888), 1,
      sym__array_base_type,
    STATE(9386), 1,
      sym__pointer_base_type,
    STATE(3618), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3635), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(3706), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4890), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4289), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [53359] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4006), 1,
      sym__identifier_token,
    ACTIONS(4064), 1,
      anon_sym_ref,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(2738), 1,
      sym_generic_name,
    STATE(2899), 1,
      sym_ref_type,
    STATE(2907), 1,
      sym__scoped_base_type,
    STATE(6733), 1,
      sym_identifier,
    STATE(6820), 1,
      sym__name,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    ACTIONS(3721), 4,
      anon_sym_COLON,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3719), 8,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
    STATE(4891), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4009), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [53466] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6731), 1,
      anon_sym_and,
    ACTIONS(6753), 1,
      anon_sym_or,
    STATE(4892), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5856), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5854), 31,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [53557] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4391), 1,
      sym__identifier_token,
    ACTIONS(4397), 1,
      anon_sym_ref,
    ACTIONS(6090), 1,
      anon_sym_delegate,
    ACTIONS(6094), 1,
      anon_sym_var,
    ACTIONS(6096), 1,
      sym_predefined_type,
    ACTIONS(6196), 1,
      anon_sym_scoped,
    ACTIONS(6556), 1,
      anon_sym_LPAREN,
    STATE(5034), 1,
      sym_identifier,
    STATE(5144), 1,
      sym__reserved_identifier,
    STATE(5211), 1,
      sym_generic_name,
    STATE(5257), 1,
      sym__name,
    STATE(5293), 1,
      sym_tuple_type,
    STATE(5296), 1,
      sym_array_type,
    STATE(5361), 1,
      sym_type,
    STATE(8680), 1,
      sym__array_base_type,
    STATE(9933), 1,
      sym__pointer_base_type,
    STATE(5271), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(5302), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5380), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4893), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4393), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [53680] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6755), 1,
      anon_sym_into,
    STATE(4894), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym__query_body_repeat2,
    ACTIONS(6376), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_as,
    ACTIONS(6374), 31,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [53769] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3728), 1,
      anon_sym_delegate,
    ACTIONS(4490), 1,
      sym__identifier_token,
    ACTIONS(4545), 1,
      anon_sym_ref,
    ACTIONS(6151), 1,
      anon_sym_scoped,
    ACTIONS(6153), 1,
      anon_sym_var,
    ACTIONS(6155), 1,
      sym_predefined_type,
    ACTIONS(6506), 1,
      anon_sym_LPAREN,
    STATE(2913), 1,
      sym_identifier,
    STATE(2914), 1,
      sym__reserved_identifier,
    STATE(2956), 1,
      sym_generic_name,
    STATE(2973), 1,
      sym_tuple_type,
    STATE(2975), 1,
      sym_array_type,
    STATE(3002), 1,
      sym__name,
    STATE(4630), 1,
      sym_type,
    STATE(8712), 1,
      sym__array_base_type,
    STATE(9721), 1,
      sym__pointer_base_type,
    STATE(2898), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(2974), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(2977), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4895), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4492), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [53892] = 25,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5165), 1,
      anon_sym_DOT,
    ACTIONS(5167), 1,
      anon_sym_DASH_GT,
    ACTIONS(6008), 1,
      anon_sym_LPAREN,
    ACTIONS(6038), 1,
      anon_sym_LBRACK,
    ACTIONS(6044), 1,
      anon_sym_BANG,
    ACTIONS(6068), 1,
      anon_sym_switch,
    ACTIONS(6082), 1,
      anon_sym_with,
    ACTIONS(6709), 1,
      anon_sym_SLASH,
    ACTIONS(6711), 1,
      anon_sym_DOT_DOT,
    STATE(3551), 1,
      sym_bracketed_argument_list,
    STATE(4571), 1,
      sym_argument_list,
    ACTIONS(6046), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6707), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    STATE(4896), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6116), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
    ACTIONS(6114), 21,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
  [54005] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(5339), 1,
      anon_sym_in,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(6675), 1,
      anon_sym_SLASH,
    ACTIONS(6677), 1,
      anon_sym_CARET,
    ACTIONS(6679), 1,
      anon_sym_PIPE,
    ACTIONS(6681), 1,
      anon_sym_AMP,
    ACTIONS(6685), 1,
      anon_sym_GT_GT,
    ACTIONS(6691), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6693), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6695), 1,
      anon_sym_as,
    ACTIONS(6697), 1,
      anon_sym_is,
    ACTIONS(6699), 1,
      anon_sym_QMARK,
    ACTIONS(6701), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6703), 1,
      anon_sym_QMARK_QMARK,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6669), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6671), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6673), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6683), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6687), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6689), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4897), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5337), 9,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_into,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [54148] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6749), 1,
      anon_sym_into,
    STATE(4894), 1,
      aux_sym__query_body_repeat2,
    STATE(4898), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6383), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_as,
    ACTIONS(6381), 31,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [54239] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6691), 1,
      anon_sym_DOT_DOT,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(4899), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1147), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(1133), 25,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [54344] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2983), 1,
      sym__identifier_token,
    ACTIONS(2995), 1,
      anon_sym_LPAREN,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3728), 1,
      anon_sym_delegate,
    ACTIONS(5284), 1,
      anon_sym_var,
    ACTIONS(6597), 1,
      anon_sym_ref,
    ACTIONS(6601), 1,
      anon_sym_scoped,
    STATE(4443), 1,
      sym__reserved_identifier,
    STATE(4921), 1,
      sym_identifier,
    STATE(4959), 1,
      sym_generic_name,
    STATE(5237), 1,
      sym_tuple_type,
    STATE(5381), 1,
      sym__name,
    STATE(5548), 1,
      sym_array_type,
    STATE(8343), 1,
      sym_type,
    STATE(8768), 1,
      sym__array_base_type,
    STATE(9721), 1,
      sym__pointer_base_type,
    STATE(2898), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5234), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4900), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2987), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [54467] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5165), 1,
      anon_sym_DOT,
    ACTIONS(5167), 1,
      anon_sym_DASH_GT,
    ACTIONS(6008), 1,
      anon_sym_LPAREN,
    ACTIONS(6038), 1,
      anon_sym_LBRACK,
    ACTIONS(6044), 1,
      anon_sym_BANG,
    ACTIONS(6068), 1,
      anon_sym_switch,
    ACTIONS(6082), 1,
      anon_sym_with,
    ACTIONS(6711), 1,
      anon_sym_DOT_DOT,
    STATE(3551), 1,
      sym_bracketed_argument_list,
    STATE(4571), 1,
      sym_argument_list,
    ACTIONS(6046), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(4901), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6116), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
    ACTIONS(6114), 23,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
  [54576] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4168), 1,
      sym__identifier_token,
    ACTIONS(4619), 1,
      anon_sym_ref,
    ACTIONS(6206), 1,
      anon_sym_delegate,
    ACTIONS(6210), 1,
      anon_sym_var,
    ACTIONS(6212), 1,
      sym_predefined_type,
    ACTIONS(6240), 1,
      anon_sym_scoped,
    ACTIONS(6518), 1,
      anon_sym_LPAREN,
    STATE(3891), 1,
      sym_identifier,
    STATE(3897), 1,
      sym__reserved_identifier,
    STATE(3950), 1,
      sym_array_type,
    STATE(3962), 1,
      sym_tuple_type,
    STATE(3995), 1,
      sym_type,
    STATE(4047), 1,
      sym_generic_name,
    STATE(4268), 1,
      sym__name,
    STATE(8755), 1,
      sym__array_base_type,
    STATE(9763), 1,
      sym__pointer_base_type,
    STATE(3937), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3954), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3955), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4902), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4170), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [54699] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2983), 1,
      sym__identifier_token,
    ACTIONS(2995), 1,
      anon_sym_LPAREN,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3728), 1,
      anon_sym_delegate,
    ACTIONS(5284), 1,
      anon_sym_var,
    ACTIONS(5912), 1,
      anon_sym_ref,
    ACTIONS(5920), 1,
      anon_sym_scoped,
    STATE(4443), 1,
      sym__reserved_identifier,
    STATE(4921), 1,
      sym_identifier,
    STATE(4959), 1,
      sym_generic_name,
    STATE(5237), 1,
      sym_tuple_type,
    STATE(5381), 1,
      sym__name,
    STATE(5548), 1,
      sym_array_type,
    STATE(8299), 1,
      sym_type,
    STATE(8768), 1,
      sym__array_base_type,
    STATE(9721), 1,
      sym__pointer_base_type,
    STATE(2898), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5234), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4903), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2987), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [54822] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5165), 1,
      anon_sym_DOT,
    ACTIONS(5167), 1,
      anon_sym_DASH_GT,
    ACTIONS(6008), 1,
      anon_sym_LPAREN,
    ACTIONS(6038), 1,
      anon_sym_LBRACK,
    ACTIONS(6044), 1,
      anon_sym_BANG,
    ACTIONS(6068), 1,
      anon_sym_switch,
    ACTIONS(6082), 1,
      anon_sym_with,
    ACTIONS(6368), 1,
      anon_sym_as,
    ACTIONS(6709), 1,
      anon_sym_SLASH,
    ACTIONS(6711), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6715), 1,
      anon_sym_CARET,
    ACTIONS(6717), 1,
      anon_sym_PIPE,
    ACTIONS(6719), 1,
      anon_sym_AMP,
    ACTIONS(6723), 1,
      anon_sym_GT_GT,
    ACTIONS(6729), 1,
      anon_sym_is,
    ACTIONS(6733), 1,
      anon_sym_QMARK,
    ACTIONS(6735), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6737), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6739), 1,
      anon_sym_QMARK_QMARK,
    STATE(3551), 1,
      sym_bracketed_argument_list,
    STATE(4571), 1,
      sym_argument_list,
    ACTIONS(6046), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6705), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6707), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6713), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6721), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6725), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6727), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4904), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5510), 10,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [54963] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4225), 1,
      sym__identifier_token,
    ACTIONS(4659), 1,
      anon_sym_ref,
    ACTIONS(6165), 1,
      anon_sym_delegate,
    ACTIONS(6169), 1,
      anon_sym_var,
    ACTIONS(6171), 1,
      sym_predefined_type,
    ACTIONS(6252), 1,
      anon_sym_scoped,
    ACTIONS(6540), 1,
      anon_sym_LPAREN,
    STATE(3558), 1,
      sym__reserved_identifier,
    STATE(3583), 1,
      sym_tuple_type,
    STATE(3587), 1,
      sym_array_type,
    STATE(3598), 1,
      sym_type,
    STATE(3608), 1,
      sym_generic_name,
    STATE(3989), 1,
      sym_identifier,
    STATE(4328), 1,
      sym__name,
    STATE(8879), 1,
      sym__array_base_type,
    STATE(9439), 1,
      sym__pointer_base_type,
    STATE(3569), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3585), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3592), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4905), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4227), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [55086] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5165), 1,
      anon_sym_DOT,
    ACTIONS(5167), 1,
      anon_sym_DASH_GT,
    ACTIONS(6008), 1,
      anon_sym_LPAREN,
    ACTIONS(6038), 1,
      anon_sym_LBRACK,
    ACTIONS(6044), 1,
      anon_sym_BANG,
    ACTIONS(6068), 1,
      anon_sym_switch,
    ACTIONS(6082), 1,
      anon_sym_with,
    ACTIONS(6368), 1,
      anon_sym_as,
    ACTIONS(6709), 1,
      anon_sym_SLASH,
    ACTIONS(6711), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6719), 1,
      anon_sym_AMP,
    ACTIONS(6723), 1,
      anon_sym_GT_GT,
    ACTIONS(6729), 1,
      anon_sym_is,
    STATE(3551), 1,
      sym_bracketed_argument_list,
    STATE(4571), 1,
      sym_argument_list,
    ACTIONS(6046), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6116), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(6705), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6707), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6713), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6721), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6725), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6727), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4906), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 14,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [55217] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(5327), 1,
      anon_sym_in,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(6675), 1,
      anon_sym_SLASH,
    ACTIONS(6677), 1,
      anon_sym_CARET,
    ACTIONS(6679), 1,
      anon_sym_PIPE,
    ACTIONS(6681), 1,
      anon_sym_AMP,
    ACTIONS(6685), 1,
      anon_sym_GT_GT,
    ACTIONS(6691), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6693), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6695), 1,
      anon_sym_as,
    ACTIONS(6697), 1,
      anon_sym_is,
    ACTIONS(6699), 1,
      anon_sym_QMARK,
    ACTIONS(6701), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6703), 1,
      anon_sym_QMARK_QMARK,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6669), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6671), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6673), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6683), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6687), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6689), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4907), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5325), 9,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_into,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [55360] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2983), 1,
      sym__identifier_token,
    ACTIONS(2995), 1,
      anon_sym_LPAREN,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3728), 1,
      anon_sym_delegate,
    ACTIONS(6496), 1,
      anon_sym_var,
    ACTIONS(6498), 1,
      anon_sym_ref,
    ACTIONS(6502), 1,
      anon_sym_scoped,
    STATE(4443), 1,
      sym__reserved_identifier,
    STATE(4921), 1,
      sym_identifier,
    STATE(4959), 1,
      sym_generic_name,
    STATE(5237), 1,
      sym_tuple_type,
    STATE(5381), 1,
      sym__name,
    STATE(5548), 1,
      sym_array_type,
    STATE(8768), 1,
      sym__array_base_type,
    STATE(9020), 1,
      sym_type,
    STATE(9721), 1,
      sym__pointer_base_type,
    STATE(2898), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5234), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4908), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2987), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [55483] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4168), 1,
      sym__identifier_token,
    ACTIONS(4543), 1,
      anon_sym_ref,
    ACTIONS(6206), 1,
      anon_sym_delegate,
    ACTIONS(6208), 1,
      anon_sym_scoped,
    ACTIONS(6210), 1,
      anon_sym_var,
    ACTIONS(6212), 1,
      sym_predefined_type,
    ACTIONS(6518), 1,
      anon_sym_LPAREN,
    STATE(3897), 1,
      sym__reserved_identifier,
    STATE(3950), 1,
      sym_array_type,
    STATE(3962), 1,
      sym_tuple_type,
    STATE(3995), 1,
      sym_type,
    STATE(4047), 1,
      sym_generic_name,
    STATE(5594), 1,
      sym_identifier,
    STATE(6161), 1,
      sym__name,
    STATE(8755), 1,
      sym__array_base_type,
    STATE(9763), 1,
      sym__pointer_base_type,
    STATE(3937), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3954), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3955), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4909), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4170), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [55606] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4157), 1,
      sym__identifier_token,
    ACTIONS(4463), 1,
      anon_sym_ref,
    ACTIONS(6137), 1,
      anon_sym_delegate,
    ACTIONS(6141), 1,
      anon_sym_var,
    ACTIONS(6143), 1,
      sym_predefined_type,
    ACTIONS(6244), 1,
      anon_sym_scoped,
    ACTIONS(6577), 1,
      anon_sym_LPAREN,
    STATE(3787), 1,
      sym_identifier,
    STATE(3838), 1,
      sym__reserved_identifier,
    STATE(3874), 1,
      sym_generic_name,
    STATE(3916), 1,
      sym_array_type,
    STATE(3918), 1,
      sym_tuple_type,
    STATE(3923), 1,
      sym_type,
    STATE(3925), 1,
      sym__name,
    STATE(8833), 1,
      sym__array_base_type,
    STATE(9537), 1,
      sym__pointer_base_type,
    STATE(3912), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(3915), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3917), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4910), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4159), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [55729] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2983), 1,
      sym__identifier_token,
    ACTIONS(2995), 1,
      anon_sym_LPAREN,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3728), 1,
      anon_sym_delegate,
    ACTIONS(4054), 1,
      anon_sym_ref,
    ACTIONS(6494), 1,
      anon_sym_scoped,
    ACTIONS(6496), 1,
      anon_sym_var,
    STATE(2892), 1,
      sym_type,
    STATE(4443), 1,
      sym__reserved_identifier,
    STATE(4921), 1,
      sym_identifier,
    STATE(4959), 1,
      sym_generic_name,
    STATE(5237), 1,
      sym_tuple_type,
    STATE(5381), 1,
      sym__name,
    STATE(5548), 1,
      sym_array_type,
    STATE(8768), 1,
      sym__array_base_type,
    STATE(9721), 1,
      sym__pointer_base_type,
    STATE(2898), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5234), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4911), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2987), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [55852] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6222), 1,
      anon_sym_in,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(6675), 1,
      anon_sym_SLASH,
    ACTIONS(6677), 1,
      anon_sym_CARET,
    ACTIONS(6679), 1,
      anon_sym_PIPE,
    ACTIONS(6681), 1,
      anon_sym_AMP,
    ACTIONS(6685), 1,
      anon_sym_GT_GT,
    ACTIONS(6691), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6693), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6695), 1,
      anon_sym_as,
    ACTIONS(6697), 1,
      anon_sym_is,
    ACTIONS(6699), 1,
      anon_sym_QMARK,
    ACTIONS(6701), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6703), 1,
      anon_sym_QMARK_QMARK,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6669), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6671), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6673), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6683), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6687), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6689), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4912), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6220), 9,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_into,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [55995] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4225), 1,
      sym__identifier_token,
    ACTIONS(4229), 1,
      anon_sym_ref,
    ACTIONS(6165), 1,
      anon_sym_delegate,
    ACTIONS(6167), 1,
      anon_sym_scoped,
    ACTIONS(6169), 1,
      anon_sym_var,
    ACTIONS(6171), 1,
      sym_predefined_type,
    ACTIONS(6540), 1,
      anon_sym_LPAREN,
    STATE(3558), 1,
      sym__reserved_identifier,
    STATE(3583), 1,
      sym_tuple_type,
    STATE(3587), 1,
      sym_array_type,
    STATE(3598), 1,
      sym_type,
    STATE(3608), 1,
      sym_generic_name,
    STATE(3989), 1,
      sym_identifier,
    STATE(4328), 1,
      sym__name,
    STATE(8879), 1,
      sym__array_base_type,
    STATE(9439), 1,
      sym__pointer_base_type,
    STATE(3569), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3585), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3592), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4913), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4227), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [56118] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6238), 1,
      anon_sym_or,
    ACTIONS(6760), 1,
      anon_sym_QMARK,
    ACTIONS(6766), 1,
      anon_sym_SLASH,
    ACTIONS(6768), 1,
      anon_sym_CARET,
    ACTIONS(6770), 1,
      anon_sym_PIPE,
    ACTIONS(6772), 1,
      anon_sym_AMP,
    ACTIONS(6776), 1,
      anon_sym_GT_GT,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6784), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6786), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6788), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6790), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6792), 1,
      anon_sym_as,
    ACTIONS(6794), 1,
      anon_sym_is,
    ACTIONS(6796), 1,
      anon_sym_with,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6758), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6762), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6764), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6774), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6778), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6780), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6236), 8,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(4914), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [56260] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(5339), 1,
      anon_sym_or,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6760), 1,
      anon_sym_QMARK,
    ACTIONS(6766), 1,
      anon_sym_SLASH,
    ACTIONS(6768), 1,
      anon_sym_CARET,
    ACTIONS(6770), 1,
      anon_sym_PIPE,
    ACTIONS(6772), 1,
      anon_sym_AMP,
    ACTIONS(6776), 1,
      anon_sym_GT_GT,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6784), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6786), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6788), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6790), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6792), 1,
      anon_sym_as,
    ACTIONS(6794), 1,
      anon_sym_is,
    ACTIONS(6796), 1,
      anon_sym_with,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6758), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6762), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6764), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6774), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6778), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6780), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5337), 8,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(4915), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [56402] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(5398), 1,
      anon_sym_or,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6760), 1,
      anon_sym_QMARK,
    ACTIONS(6766), 1,
      anon_sym_SLASH,
    ACTIONS(6768), 1,
      anon_sym_CARET,
    ACTIONS(6770), 1,
      anon_sym_PIPE,
    ACTIONS(6772), 1,
      anon_sym_AMP,
    ACTIONS(6776), 1,
      anon_sym_GT_GT,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6784), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6786), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6788), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6790), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6792), 1,
      anon_sym_as,
    ACTIONS(6794), 1,
      anon_sym_is,
    ACTIONS(6796), 1,
      anon_sym_with,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6758), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6762), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6764), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6774), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6778), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6780), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5396), 8,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(4916), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [56544] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6218), 1,
      anon_sym_or,
    ACTIONS(6760), 1,
      anon_sym_QMARK,
    ACTIONS(6766), 1,
      anon_sym_SLASH,
    ACTIONS(6768), 1,
      anon_sym_CARET,
    ACTIONS(6770), 1,
      anon_sym_PIPE,
    ACTIONS(6772), 1,
      anon_sym_AMP,
    ACTIONS(6776), 1,
      anon_sym_GT_GT,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6784), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6786), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6788), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6790), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6792), 1,
      anon_sym_as,
    ACTIONS(6794), 1,
      anon_sym_is,
    ACTIONS(6796), 1,
      anon_sym_with,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6758), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6762), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6764), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6774), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6778), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6780), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6216), 8,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(4917), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [56686] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6766), 1,
      anon_sym_SLASH,
    ACTIONS(6772), 1,
      anon_sym_AMP,
    ACTIONS(6776), 1,
      anon_sym_GT_GT,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6784), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6792), 1,
      anon_sym_as,
    ACTIONS(6794), 1,
      anon_sym_is,
    ACTIONS(6796), 1,
      anon_sym_with,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6758), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6762), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6764), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6774), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6778), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6780), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6116), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_or,
    STATE(4918), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 12,
      anon_sym_where,
      anon_sym_CARET,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [56816] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6766), 1,
      anon_sym_SLASH,
    ACTIONS(6768), 1,
      anon_sym_CARET,
    ACTIONS(6772), 1,
      anon_sym_AMP,
    ACTIONS(6776), 1,
      anon_sym_GT_GT,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6784), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6792), 1,
      anon_sym_as,
    ACTIONS(6794), 1,
      anon_sym_is,
    ACTIONS(6796), 1,
      anon_sym_with,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6758), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6762), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6764), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6774), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6778), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6780), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6116), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_or,
    STATE(4919), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 11,
      anon_sym_where,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [56948] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6766), 1,
      anon_sym_SLASH,
    ACTIONS(6776), 1,
      anon_sym_GT_GT,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6784), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6792), 1,
      anon_sym_as,
    ACTIONS(6794), 1,
      anon_sym_is,
    ACTIONS(6796), 1,
      anon_sym_with,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6758), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6762), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6764), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6774), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6778), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6780), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6116), 4,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_or,
    STATE(4920), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 12,
      anon_sym_where,
      anon_sym_CARET,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [57076] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4083), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6745), 1,
      anon_sym_LT,
    STATE(4976), 1,
      sym_type_argument_list,
    STATE(4921), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4076), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_EQ_GT,
    ACTIONS(4074), 28,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_operator,
      anon_sym_this,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [57168] = 32,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6766), 1,
      anon_sym_SLASH,
    ACTIONS(6776), 1,
      anon_sym_GT_GT,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6784), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6792), 1,
      anon_sym_as,
    ACTIONS(6794), 1,
      anon_sym_is,
    ACTIONS(6796), 1,
      anon_sym_with,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6758), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6762), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6764), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6774), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6780), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6116), 4,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_or,
    STATE(4922), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 14,
      anon_sym_where,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [57294] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6766), 1,
      anon_sym_SLASH,
    ACTIONS(6768), 1,
      anon_sym_CARET,
    ACTIONS(6770), 1,
      anon_sym_PIPE,
    ACTIONS(6772), 1,
      anon_sym_AMP,
    ACTIONS(6776), 1,
      anon_sym_GT_GT,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6784), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6792), 1,
      anon_sym_as,
    ACTIONS(6794), 1,
      anon_sym_is,
    ACTIONS(6796), 1,
      anon_sym_with,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6116), 2,
      anon_sym_QMARK,
      anon_sym_or,
    ACTIONS(6758), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6762), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6764), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6774), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6778), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6780), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4923), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 11,
      anon_sym_where,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [57428] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6766), 1,
      anon_sym_SLASH,
    ACTIONS(6768), 1,
      anon_sym_CARET,
    ACTIONS(6770), 1,
      anon_sym_PIPE,
    ACTIONS(6772), 1,
      anon_sym_AMP,
    ACTIONS(6776), 1,
      anon_sym_GT_GT,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6784), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6786), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6792), 1,
      anon_sym_as,
    ACTIONS(6794), 1,
      anon_sym_is,
    ACTIONS(6796), 1,
      anon_sym_with,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6116), 2,
      anon_sym_QMARK,
      anon_sym_or,
    ACTIONS(6758), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6762), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6764), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6774), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6778), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6780), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4924), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 10,
      anon_sym_where,
      anon_sym_and,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [57564] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6766), 1,
      anon_sym_SLASH,
    ACTIONS(6768), 1,
      anon_sym_CARET,
    ACTIONS(6770), 1,
      anon_sym_PIPE,
    ACTIONS(6772), 1,
      anon_sym_AMP,
    ACTIONS(6776), 1,
      anon_sym_GT_GT,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6784), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6786), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6788), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6790), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6792), 1,
      anon_sym_as,
    ACTIONS(6794), 1,
      anon_sym_is,
    ACTIONS(6796), 1,
      anon_sym_with,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6116), 2,
      anon_sym_QMARK,
      anon_sym_or,
    ACTIONS(6758), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6762), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6764), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6774), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6778), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6780), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 8,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(4925), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [57704] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6798), 1,
      anon_sym_into,
    STATE(4926), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym__query_body_repeat2,
    ACTIONS(6376), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
    ACTIONS(6374), 30,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [57792] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6801), 1,
      anon_sym_into,
    STATE(4926), 1,
      aux_sym__query_body_repeat2,
    STATE(4927), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6383), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
    ACTIONS(6381), 30,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [57882] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(5327), 1,
      anon_sym_or,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6760), 1,
      anon_sym_QMARK,
    ACTIONS(6766), 1,
      anon_sym_SLASH,
    ACTIONS(6768), 1,
      anon_sym_CARET,
    ACTIONS(6770), 1,
      anon_sym_PIPE,
    ACTIONS(6772), 1,
      anon_sym_AMP,
    ACTIONS(6776), 1,
      anon_sym_GT_GT,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6784), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6786), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6788), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6790), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6792), 1,
      anon_sym_as,
    ACTIONS(6794), 1,
      anon_sym_is,
    ACTIONS(6796), 1,
      anon_sym_with,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6758), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6762), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6764), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6774), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6778), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6780), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5325), 8,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(4928), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [58024] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6803), 1,
      anon_sym_into,
    STATE(4954), 1,
      aux_sym__query_body_repeat2,
    STATE(4929), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6448), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6446), 30,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [58114] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6784), 1,
      anon_sym_DOT_DOT,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(4930), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1147), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_or,
    ACTIONS(1133), 24,
      anon_sym_where,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [58218] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6766), 1,
      anon_sym_SLASH,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6784), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6796), 1,
      anon_sym_with,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6762), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6764), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6116), 7,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_or,
    STATE(4931), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 20,
      anon_sym_where,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
  [58332] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(5512), 1,
      anon_sym_or,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6760), 1,
      anon_sym_QMARK,
    ACTIONS(6766), 1,
      anon_sym_SLASH,
    ACTIONS(6768), 1,
      anon_sym_CARET,
    ACTIONS(6770), 1,
      anon_sym_PIPE,
    ACTIONS(6772), 1,
      anon_sym_AMP,
    ACTIONS(6776), 1,
      anon_sym_GT_GT,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6784), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6786), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6788), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6790), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6792), 1,
      anon_sym_as,
    ACTIONS(6794), 1,
      anon_sym_is,
    ACTIONS(6796), 1,
      anon_sym_with,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6758), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6762), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6764), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6774), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6778), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6780), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5510), 8,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(4932), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [58474] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6784), 1,
      anon_sym_DOT_DOT,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(4933), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6122), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_or,
    ACTIONS(6120), 24,
      anon_sym_where,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [58578] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(5422), 1,
      anon_sym_or,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6760), 1,
      anon_sym_QMARK,
    ACTIONS(6766), 1,
      anon_sym_SLASH,
    ACTIONS(6768), 1,
      anon_sym_CARET,
    ACTIONS(6770), 1,
      anon_sym_PIPE,
    ACTIONS(6772), 1,
      anon_sym_AMP,
    ACTIONS(6776), 1,
      anon_sym_GT_GT,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6784), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6786), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6788), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6790), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6792), 1,
      anon_sym_as,
    ACTIONS(6794), 1,
      anon_sym_is,
    ACTIONS(6796), 1,
      anon_sym_with,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6758), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6762), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6764), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6774), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6778), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6780), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5420), 8,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(4934), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [58720] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6232), 1,
      anon_sym_or,
    ACTIONS(6760), 1,
      anon_sym_QMARK,
    ACTIONS(6766), 1,
      anon_sym_SLASH,
    ACTIONS(6768), 1,
      anon_sym_CARET,
    ACTIONS(6770), 1,
      anon_sym_PIPE,
    ACTIONS(6772), 1,
      anon_sym_AMP,
    ACTIONS(6776), 1,
      anon_sym_GT_GT,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6784), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6786), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6788), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6790), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6792), 1,
      anon_sym_as,
    ACTIONS(6794), 1,
      anon_sym_is,
    ACTIONS(6796), 1,
      anon_sym_with,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6758), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6762), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6764), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6774), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6778), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6780), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6230), 8,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(4935), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [58862] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6784), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6796), 1,
      anon_sym_with,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(4936), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6116), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_or,
    ACTIONS(6114), 22,
      anon_sym_where,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
  [58970] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6801), 1,
      anon_sym_into,
    STATE(4948), 1,
      aux_sym__query_body_repeat2,
    STATE(4937), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6448), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
    ACTIONS(6446), 30,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [59060] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(5387), 1,
      anon_sym_or,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6760), 1,
      anon_sym_QMARK,
    ACTIONS(6766), 1,
      anon_sym_SLASH,
    ACTIONS(6768), 1,
      anon_sym_CARET,
    ACTIONS(6770), 1,
      anon_sym_PIPE,
    ACTIONS(6772), 1,
      anon_sym_AMP,
    ACTIONS(6776), 1,
      anon_sym_GT_GT,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6784), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6786), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6788), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6790), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6792), 1,
      anon_sym_as,
    ACTIONS(6794), 1,
      anon_sym_is,
    ACTIONS(6796), 1,
      anon_sym_with,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6758), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6762), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6764), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6774), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6778), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6780), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5385), 8,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(4938), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [59202] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6803), 1,
      anon_sym_into,
    STATE(4950), 1,
      aux_sym__query_body_repeat2,
    STATE(4939), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6420), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6418), 30,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [59292] = 25,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6766), 1,
      anon_sym_SLASH,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6784), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6796), 1,
      anon_sym_with,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6764), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    STATE(4940), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6116), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_or,
    ACTIONS(6114), 20,
      anon_sym_where,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
  [59404] = 28,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6766), 1,
      anon_sym_SLASH,
    ACTIONS(6776), 1,
      anon_sym_GT_GT,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6784), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6796), 1,
      anon_sym_with,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6762), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6764), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6774), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6116), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_or,
    STATE(4941), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 18,
      anon_sym_where,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
  [59522] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(4942), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5257), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_or,
    ACTIONS(5255), 25,
      anon_sym_where,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [59624] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(4943), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5245), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_or,
    ACTIONS(5243), 25,
      anon_sym_where,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [59726] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4081), 1,
      anon_sym_EQ_GT,
    STATE(4944), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5832), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
    ACTIONS(4247), 31,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [59814] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6805), 1,
      anon_sym_into,
    STATE(4945), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym__query_body_repeat2,
    ACTIONS(6376), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6374), 30,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [59902] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(4946), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5237), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_or,
    ACTIONS(5233), 25,
      anon_sym_where,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [60004] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6801), 1,
      anon_sym_into,
    STATE(4927), 1,
      aux_sym__query_body_repeat2,
    STATE(4947), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6420), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
    ACTIONS(6418), 30,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [60094] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6801), 1,
      anon_sym_into,
    STATE(4926), 1,
      aux_sym__query_body_repeat2,
    STATE(4948), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6420), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
    ACTIONS(6418), 30,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [60184] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6808), 1,
      anon_sym_DOT,
    STATE(4949), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4426), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_or,
    ACTIONS(4428), 32,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [60272] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6803), 1,
      anon_sym_into,
    STATE(4945), 1,
      aux_sym__query_body_repeat2,
    STATE(4950), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6383), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6381), 30,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [60362] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6222), 1,
      anon_sym_or,
    ACTIONS(6760), 1,
      anon_sym_QMARK,
    ACTIONS(6766), 1,
      anon_sym_SLASH,
    ACTIONS(6768), 1,
      anon_sym_CARET,
    ACTIONS(6770), 1,
      anon_sym_PIPE,
    ACTIONS(6772), 1,
      anon_sym_AMP,
    ACTIONS(6776), 1,
      anon_sym_GT_GT,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6784), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6786), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6788), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6790), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6792), 1,
      anon_sym_as,
    ACTIONS(6794), 1,
      anon_sym_is,
    ACTIONS(6796), 1,
      anon_sym_with,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6758), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6762), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6764), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6774), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6778), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6780), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6220), 8,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(4951), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [60504] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4547), 1,
      anon_sym_LBRACK,
    ACTIONS(4553), 1,
      anon_sym_STAR,
    ACTIONS(5274), 1,
      anon_sym_QMARK,
    ACTIONS(6808), 1,
      anon_sym_DOT,
    STATE(4952), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4422), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_or,
    ACTIONS(4424), 30,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [60598] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6175), 1,
      anon_sym_or,
    ACTIONS(6760), 1,
      anon_sym_QMARK,
    ACTIONS(6766), 1,
      anon_sym_SLASH,
    ACTIONS(6768), 1,
      anon_sym_CARET,
    ACTIONS(6770), 1,
      anon_sym_PIPE,
    ACTIONS(6772), 1,
      anon_sym_AMP,
    ACTIONS(6776), 1,
      anon_sym_GT_GT,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6784), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6786), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6788), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6790), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6792), 1,
      anon_sym_as,
    ACTIONS(6794), 1,
      anon_sym_is,
    ACTIONS(6796), 1,
      anon_sym_with,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6758), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6762), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6764), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6774), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6778), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6780), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6173), 8,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(4953), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [60740] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6803), 1,
      anon_sym_into,
    STATE(4945), 1,
      aux_sym__query_body_repeat2,
    STATE(4954), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6420), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6418), 30,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [60830] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6810), 1,
      anon_sym_DOT_DOT,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(4955), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1147), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(1133), 24,
      anon_sym_where,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [60933] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4956), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5852), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
    ACTIONS(5850), 31,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [61018] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4957), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5818), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
    ACTIONS(5816), 31,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [61103] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4958), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5860), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
    ACTIONS(5858), 31,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [61188] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4959), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4076), 15,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_DASH_GT,
    ACTIONS(4074), 28,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_operator,
      anon_sym_this,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [61273] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6663), 1,
      anon_sym_as,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(6810), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6814), 1,
      anon_sym_QMARK,
    ACTIONS(6820), 1,
      anon_sym_SLASH,
    ACTIONS(6822), 1,
      anon_sym_CARET,
    ACTIONS(6824), 1,
      anon_sym_PIPE,
    ACTIONS(6826), 1,
      anon_sym_AMP,
    ACTIONS(6830), 1,
      anon_sym_GT_GT,
    ACTIONS(6836), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6838), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6840), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6842), 1,
      anon_sym_is,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6812), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6816), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6818), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6828), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6832), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6834), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6284), 8,
      anon_sym_where,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(4960), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [61412] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4961), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5810), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
    ACTIONS(5808), 31,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [61497] = 32,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6663), 1,
      anon_sym_as,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(6810), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6820), 1,
      anon_sym_SLASH,
    ACTIONS(6830), 1,
      anon_sym_GT_GT,
    ACTIONS(6842), 1,
      anon_sym_is,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6812), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6816), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6818), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6828), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6834), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6116), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(4962), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 14,
      anon_sym_where,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [61622] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(6810), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6820), 1,
      anon_sym_SLASH,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6816), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6818), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6116), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4963), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 20,
      anon_sym_where,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
  [61735] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6663), 1,
      anon_sym_as,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(6810), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6814), 1,
      anon_sym_QMARK,
    ACTIONS(6820), 1,
      anon_sym_SLASH,
    ACTIONS(6822), 1,
      anon_sym_CARET,
    ACTIONS(6824), 1,
      anon_sym_PIPE,
    ACTIONS(6826), 1,
      anon_sym_AMP,
    ACTIONS(6830), 1,
      anon_sym_GT_GT,
    ACTIONS(6836), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6838), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6840), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6842), 1,
      anon_sym_is,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6812), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6816), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6818), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6828), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6832), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6834), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5385), 8,
      anon_sym_where,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(4964), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [61874] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6663), 1,
      anon_sym_as,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(6810), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6814), 1,
      anon_sym_QMARK,
    ACTIONS(6820), 1,
      anon_sym_SLASH,
    ACTIONS(6822), 1,
      anon_sym_CARET,
    ACTIONS(6824), 1,
      anon_sym_PIPE,
    ACTIONS(6826), 1,
      anon_sym_AMP,
    ACTIONS(6830), 1,
      anon_sym_GT_GT,
    ACTIONS(6836), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6838), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6840), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6842), 1,
      anon_sym_is,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6812), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6816), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6818), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6828), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6832), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6834), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5396), 8,
      anon_sym_where,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(4965), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [62013] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6663), 1,
      anon_sym_as,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(6810), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6814), 1,
      anon_sym_QMARK,
    ACTIONS(6820), 1,
      anon_sym_SLASH,
    ACTIONS(6822), 1,
      anon_sym_CARET,
    ACTIONS(6824), 1,
      anon_sym_PIPE,
    ACTIONS(6826), 1,
      anon_sym_AMP,
    ACTIONS(6830), 1,
      anon_sym_GT_GT,
    ACTIONS(6836), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6838), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6840), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6842), 1,
      anon_sym_is,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6812), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6816), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6818), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6828), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6832), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6834), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6216), 8,
      anon_sym_where,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(4966), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [62152] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6663), 1,
      anon_sym_as,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(6810), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6814), 1,
      anon_sym_QMARK,
    ACTIONS(6820), 1,
      anon_sym_SLASH,
    ACTIONS(6822), 1,
      anon_sym_CARET,
    ACTIONS(6824), 1,
      anon_sym_PIPE,
    ACTIONS(6826), 1,
      anon_sym_AMP,
    ACTIONS(6830), 1,
      anon_sym_GT_GT,
    ACTIONS(6836), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6838), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6840), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6842), 1,
      anon_sym_is,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6812), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6816), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6818), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6828), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6832), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6834), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6236), 8,
      anon_sym_where,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(4967), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [62291] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4968), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4072), 15,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_DASH_GT,
    ACTIONS(4070), 28,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_operator,
      anon_sym_this,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [62376] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4969), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5826), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
    ACTIONS(5824), 31,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [62461] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6810), 1,
      anon_sym_DOT_DOT,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(4970), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6122), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6120), 24,
      anon_sym_where,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [62564] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4971), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5832), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
    ACTIONS(4247), 31,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [62649] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4972), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5872), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
    ACTIONS(5870), 31,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [62734] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4973), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4087), 15,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_DASH_GT,
    ACTIONS(4085), 28,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_operator,
      anon_sym_this,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [62819] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4974), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5856), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
    ACTIONS(5854), 31,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [62904] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4975), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4124), 15,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_DASH_GT,
    ACTIONS(4113), 28,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_operator,
      anon_sym_this,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [62989] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4976), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4068), 15,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_DASH_GT,
    ACTIONS(4066), 28,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_operator,
      anon_sym_this,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [63074] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6663), 1,
      anon_sym_as,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(6810), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6814), 1,
      anon_sym_QMARK,
    ACTIONS(6820), 1,
      anon_sym_SLASH,
    ACTIONS(6822), 1,
      anon_sym_CARET,
    ACTIONS(6824), 1,
      anon_sym_PIPE,
    ACTIONS(6826), 1,
      anon_sym_AMP,
    ACTIONS(6830), 1,
      anon_sym_GT_GT,
    ACTIONS(6836), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6838), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6840), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6842), 1,
      anon_sym_is,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6812), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6816), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6818), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6828), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6832), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6834), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6230), 8,
      anon_sym_where,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(4977), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [63213] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6663), 1,
      anon_sym_as,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(6810), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6814), 1,
      anon_sym_QMARK,
    ACTIONS(6820), 1,
      anon_sym_SLASH,
    ACTIONS(6822), 1,
      anon_sym_CARET,
    ACTIONS(6824), 1,
      anon_sym_PIPE,
    ACTIONS(6826), 1,
      anon_sym_AMP,
    ACTIONS(6830), 1,
      anon_sym_GT_GT,
    ACTIONS(6836), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6838), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6840), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6842), 1,
      anon_sym_is,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6812), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6816), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6818), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6828), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6832), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6834), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5420), 8,
      anon_sym_where,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(4978), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [63352] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4979), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5880), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
    ACTIONS(5878), 31,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [63437] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6663), 1,
      anon_sym_as,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(6810), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6814), 1,
      anon_sym_QMARK,
    ACTIONS(6820), 1,
      anon_sym_SLASH,
    ACTIONS(6822), 1,
      anon_sym_CARET,
    ACTIONS(6824), 1,
      anon_sym_PIPE,
    ACTIONS(6826), 1,
      anon_sym_AMP,
    ACTIONS(6830), 1,
      anon_sym_GT_GT,
    ACTIONS(6836), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6838), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6840), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6842), 1,
      anon_sym_is,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6812), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6816), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6818), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6828), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6832), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6834), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5510), 8,
      anon_sym_where,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(4980), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [63576] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6663), 1,
      anon_sym_as,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(6810), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6814), 1,
      anon_sym_QMARK,
    ACTIONS(6820), 1,
      anon_sym_SLASH,
    ACTIONS(6822), 1,
      anon_sym_CARET,
    ACTIONS(6824), 1,
      anon_sym_PIPE,
    ACTIONS(6826), 1,
      anon_sym_AMP,
    ACTIONS(6830), 1,
      anon_sym_GT_GT,
    ACTIONS(6836), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6838), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6840), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6842), 1,
      anon_sym_is,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6812), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6816), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6818), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6828), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6832), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6834), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6220), 8,
      anon_sym_where,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(4981), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [63715] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6844), 1,
      anon_sym_and,
    STATE(4982), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6546), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
    ACTIONS(6544), 30,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [63802] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6663), 1,
      anon_sym_as,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(6810), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6814), 1,
      anon_sym_QMARK,
    ACTIONS(6820), 1,
      anon_sym_SLASH,
    ACTIONS(6822), 1,
      anon_sym_CARET,
    ACTIONS(6824), 1,
      anon_sym_PIPE,
    ACTIONS(6826), 1,
      anon_sym_AMP,
    ACTIONS(6830), 1,
      anon_sym_GT_GT,
    ACTIONS(6836), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6838), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6840), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6842), 1,
      anon_sym_is,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6812), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6816), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6818), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6828), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6832), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6834), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5337), 8,
      anon_sym_where,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(4983), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [63941] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4984), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5864), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
    ACTIONS(5862), 31,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [64026] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4985), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5876), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
    ACTIONS(5874), 31,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [64111] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4986), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5840), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
    ACTIONS(5838), 31,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [64196] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6844), 1,
      anon_sym_and,
    ACTIONS(6846), 1,
      anon_sym_or,
    STATE(4987), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5856), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5854), 30,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [64285] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4988), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5763), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
    ACTIONS(5761), 31,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [64370] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4989), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5814), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
    ACTIONS(5812), 31,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [64455] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6663), 1,
      anon_sym_as,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(6810), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6820), 1,
      anon_sym_SLASH,
    ACTIONS(6822), 1,
      anon_sym_CARET,
    ACTIONS(6824), 1,
      anon_sym_PIPE,
    ACTIONS(6826), 1,
      anon_sym_AMP,
    ACTIONS(6830), 1,
      anon_sym_GT_GT,
    ACTIONS(6842), 1,
      anon_sym_is,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6812), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6816), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6818), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6828), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6832), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6834), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4990), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 11,
      anon_sym_where,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [64588] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(4009), 1,
      anon_sym_where,
    ACTIONS(5912), 1,
      anon_sym_ref,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(2738), 1,
      sym_generic_name,
    STATE(2899), 1,
      sym_ref_type,
    STATE(2907), 1,
      sym__scoped_base_type,
    STATE(5368), 1,
      sym_identifier,
    STATE(6160), 1,
      sym__name,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4991), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3719), 10,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
    ACTIONS(27), 21,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [64693] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6844), 1,
      anon_sym_and,
    ACTIONS(6846), 1,
      anon_sym_or,
    STATE(4992), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6609), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6607), 30,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [64782] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4993), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5848), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
    ACTIONS(5846), 31,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [64867] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4747), 1,
      anon_sym_or,
    STATE(4994), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4739), 9,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    ACTIONS(5795), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5792), 22,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [64956] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4747), 1,
      anon_sym_or,
    STATE(4995), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4739), 9,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    ACTIONS(5789), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5786), 22,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [65045] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6663), 1,
      anon_sym_as,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(6810), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6814), 1,
      anon_sym_QMARK,
    ACTIONS(6820), 1,
      anon_sym_SLASH,
    ACTIONS(6822), 1,
      anon_sym_CARET,
    ACTIONS(6824), 1,
      anon_sym_PIPE,
    ACTIONS(6826), 1,
      anon_sym_AMP,
    ACTIONS(6830), 1,
      anon_sym_GT_GT,
    ACTIONS(6836), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6838), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6840), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6842), 1,
      anon_sym_is,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6812), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6816), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6818), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6828), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6832), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6834), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5325), 8,
      anon_sym_where,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(4996), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [65184] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4997), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5844), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
    ACTIONS(5842), 31,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [65269] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4998), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5840), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
    ACTIONS(5838), 31,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [65354] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6663), 1,
      anon_sym_as,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(6810), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6814), 1,
      anon_sym_QMARK,
    ACTIONS(6820), 1,
      anon_sym_SLASH,
    ACTIONS(6822), 1,
      anon_sym_CARET,
    ACTIONS(6824), 1,
      anon_sym_PIPE,
    ACTIONS(6826), 1,
      anon_sym_AMP,
    ACTIONS(6830), 1,
      anon_sym_GT_GT,
    ACTIONS(6836), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6838), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6840), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6842), 1,
      anon_sym_is,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6812), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6816), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6818), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6828), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6832), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6834), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6848), 8,
      anon_sym_where,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(4999), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [65493] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6663), 1,
      anon_sym_as,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(6810), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6820), 1,
      anon_sym_SLASH,
    ACTIONS(6822), 1,
      anon_sym_CARET,
    ACTIONS(6824), 1,
      anon_sym_PIPE,
    ACTIONS(6826), 1,
      anon_sym_AMP,
    ACTIONS(6830), 1,
      anon_sym_GT_GT,
    ACTIONS(6836), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6842), 1,
      anon_sym_is,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6812), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6816), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6818), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6828), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6832), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6834), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5000), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 10,
      anon_sym_where,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [65628] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5001), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5836), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
    ACTIONS(5834), 31,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [65713] = 28,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(6810), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6820), 1,
      anon_sym_SLASH,
    ACTIONS(6830), 1,
      anon_sym_GT_GT,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6816), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6818), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6828), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6116), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5002), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 18,
      anon_sym_where,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
  [65830] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6663), 1,
      anon_sym_as,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(6810), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6820), 1,
      anon_sym_SLASH,
    ACTIONS(6830), 1,
      anon_sym_GT_GT,
    ACTIONS(6842), 1,
      anon_sym_is,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6812), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6816), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6818), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6828), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6832), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6834), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6116), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5003), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 12,
      anon_sym_where,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [65957] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6663), 1,
      anon_sym_as,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(6810), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6820), 1,
      anon_sym_SLASH,
    ACTIONS(6822), 1,
      anon_sym_CARET,
    ACTIONS(6824), 1,
      anon_sym_PIPE,
    ACTIONS(6826), 1,
      anon_sym_AMP,
    ACTIONS(6830), 1,
      anon_sym_GT_GT,
    ACTIONS(6836), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6838), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6840), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6842), 1,
      anon_sym_is,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6812), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6816), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6818), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6828), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6832), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6834), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 8,
      anon_sym_where,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(5004), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [66096] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5005), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5769), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
    ACTIONS(5767), 31,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [66181] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5006), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5822), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
    ACTIONS(5820), 31,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [66266] = 25,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(6810), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6820), 1,
      anon_sym_SLASH,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6818), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6116), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5007), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 20,
      anon_sym_where,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
  [66377] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5008), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4527), 15,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_DASH_GT,
    ACTIONS(4525), 28,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_operator,
      anon_sym_this,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [66462] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6663), 1,
      anon_sym_as,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(6810), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6820), 1,
      anon_sym_SLASH,
    ACTIONS(6822), 1,
      anon_sym_CARET,
    ACTIONS(6826), 1,
      anon_sym_AMP,
    ACTIONS(6830), 1,
      anon_sym_GT_GT,
    ACTIONS(6842), 1,
      anon_sym_is,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6116), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(6812), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6816), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6818), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6828), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6832), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6834), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5009), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 11,
      anon_sym_where,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [66593] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5010), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5769), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
    ACTIONS(5767), 31,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [66678] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6663), 1,
      anon_sym_as,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(6810), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6820), 1,
      anon_sym_SLASH,
    ACTIONS(6826), 1,
      anon_sym_AMP,
    ACTIONS(6830), 1,
      anon_sym_GT_GT,
    ACTIONS(6842), 1,
      anon_sym_is,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6116), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(6812), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6816), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6818), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6828), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6832), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6834), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5011), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 12,
      anon_sym_where,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [66807] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5012), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4062), 15,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_DASH_GT,
    ACTIONS(4060), 28,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_operator,
      anon_sym_this,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [66892] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6663), 1,
      anon_sym_as,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(6810), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6814), 1,
      anon_sym_QMARK,
    ACTIONS(6820), 1,
      anon_sym_SLASH,
    ACTIONS(6822), 1,
      anon_sym_CARET,
    ACTIONS(6824), 1,
      anon_sym_PIPE,
    ACTIONS(6826), 1,
      anon_sym_AMP,
    ACTIONS(6830), 1,
      anon_sym_GT_GT,
    ACTIONS(6836), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6838), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6840), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6842), 1,
      anon_sym_is,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6812), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6816), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6818), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6828), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6832), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6834), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6274), 8,
      anon_sym_where,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(5013), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [67031] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(6810), 1,
      anon_sym_DOT_DOT,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5014), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6116), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6114), 22,
      anon_sym_where,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
  [67138] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(6597), 1,
      anon_sym_ref,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(2738), 1,
      sym_generic_name,
    STATE(2899), 1,
      sym_ref_type,
    STATE(2907), 1,
      sym__scoped_base_type,
    STATE(5368), 1,
      sym_identifier,
    STATE(6160), 1,
      sym__name,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5015), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3719), 9,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [67240] = 25,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(6852), 1,
      anon_sym_SLASH,
    ACTIONS(6854), 1,
      anon_sym_DOT_DOT,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6850), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6116), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5016), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 19,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
  [67350] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(6854), 1,
      anon_sym_DOT_DOT,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5017), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6116), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6114), 21,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
  [67456] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6330), 1,
      anon_sym_as,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(6852), 1,
      anon_sym_SLASH,
    ACTIONS(6854), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6860), 1,
      anon_sym_AMP,
    ACTIONS(6864), 1,
      anon_sym_GT_GT,
    ACTIONS(6870), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6116), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(6850), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6856), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6858), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6866), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6868), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5018), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 11,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
  [67584] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6330), 1,
      anon_sym_as,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(6852), 1,
      anon_sym_SLASH,
    ACTIONS(6854), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6860), 1,
      anon_sym_AMP,
    ACTIONS(6864), 1,
      anon_sym_GT_GT,
    ACTIONS(6870), 1,
      anon_sym_is,
    ACTIONS(6872), 1,
      anon_sym_CARET,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6116), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(6850), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6856), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6858), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6866), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6868), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5019), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 10,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
  [67714] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6330), 1,
      anon_sym_as,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(6852), 1,
      anon_sym_SLASH,
    ACTIONS(6854), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6864), 1,
      anon_sym_GT_GT,
    ACTIONS(6870), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6850), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6856), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6858), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6866), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6868), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6116), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5020), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 11,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
  [67840] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(6852), 1,
      anon_sym_SLASH,
    ACTIONS(6854), 1,
      anon_sym_DOT_DOT,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6850), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6858), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6116), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5021), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 19,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
  [67952] = 32,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6330), 1,
      anon_sym_as,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(6852), 1,
      anon_sym_SLASH,
    ACTIONS(6854), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6864), 1,
      anon_sym_GT_GT,
    ACTIONS(6870), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6850), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6856), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6858), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6868), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6116), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5022), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 13,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
  [68076] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6792), 1,
      anon_sym_as,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(6876), 1,
      anon_sym_QMARK,
    ACTIONS(6882), 1,
      anon_sym_SLASH,
    ACTIONS(6884), 1,
      anon_sym_CARET,
    ACTIONS(6886), 1,
      anon_sym_PIPE,
    ACTIONS(6888), 1,
      anon_sym_AMP,
    ACTIONS(6892), 1,
      anon_sym_GT_GT,
    ACTIONS(6898), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6900), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6902), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6904), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6906), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6874), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6878), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6880), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6890), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6894), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6896), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5396), 7,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(5023), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [68214] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6330), 1,
      anon_sym_as,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(6852), 1,
      anon_sym_SLASH,
    ACTIONS(6854), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6860), 1,
      anon_sym_AMP,
    ACTIONS(6864), 1,
      anon_sym_GT_GT,
    ACTIONS(6870), 1,
      anon_sym_is,
    ACTIONS(6872), 1,
      anon_sym_CARET,
    ACTIONS(6908), 1,
      anon_sym_PIPE,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6850), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6856), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6858), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6866), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6868), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5024), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 10,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
  [68346] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6330), 1,
      anon_sym_as,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(6852), 1,
      anon_sym_SLASH,
    ACTIONS(6854), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6860), 1,
      anon_sym_AMP,
    ACTIONS(6864), 1,
      anon_sym_GT_GT,
    ACTIONS(6870), 1,
      anon_sym_is,
    ACTIONS(6872), 1,
      anon_sym_CARET,
    ACTIONS(6908), 1,
      anon_sym_PIPE,
    ACTIONS(6910), 1,
      anon_sym_AMP_AMP,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6850), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6856), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6858), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6866), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6868), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5025), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 9,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
  [68480] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6330), 1,
      anon_sym_as,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(6852), 1,
      anon_sym_SLASH,
    ACTIONS(6854), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6860), 1,
      anon_sym_AMP,
    ACTIONS(6864), 1,
      anon_sym_GT_GT,
    ACTIONS(6870), 1,
      anon_sym_is,
    ACTIONS(6872), 1,
      anon_sym_CARET,
    ACTIONS(6908), 1,
      anon_sym_PIPE,
    ACTIONS(6910), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6912), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6914), 1,
      anon_sym_QMARK_QMARK,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6850), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6856), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6858), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6866), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6868), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 7,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5026), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [68618] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6330), 1,
      anon_sym_as,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(6852), 1,
      anon_sym_SLASH,
    ACTIONS(6854), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6860), 1,
      anon_sym_AMP,
    ACTIONS(6864), 1,
      anon_sym_GT_GT,
    ACTIONS(6870), 1,
      anon_sym_is,
    ACTIONS(6872), 1,
      anon_sym_CARET,
    ACTIONS(6908), 1,
      anon_sym_PIPE,
    ACTIONS(6910), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6912), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6914), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6916), 1,
      anon_sym_QMARK,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6850), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6856), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6858), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6866), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6868), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6236), 7,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5027), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [68756] = 28,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(6852), 1,
      anon_sym_SLASH,
    ACTIONS(6854), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6864), 1,
      anon_sym_GT_GT,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6850), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6858), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6116), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5028), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 17,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
  [68872] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6330), 1,
      anon_sym_as,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(6852), 1,
      anon_sym_SLASH,
    ACTIONS(6854), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6860), 1,
      anon_sym_AMP,
    ACTIONS(6864), 1,
      anon_sym_GT_GT,
    ACTIONS(6870), 1,
      anon_sym_is,
    ACTIONS(6872), 1,
      anon_sym_CARET,
    ACTIONS(6908), 1,
      anon_sym_PIPE,
    ACTIONS(6910), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6912), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6914), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6916), 1,
      anon_sym_QMARK,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6850), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6856), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6858), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6866), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6868), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6230), 7,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5029), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [69010] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6330), 1,
      anon_sym_as,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(6852), 1,
      anon_sym_SLASH,
    ACTIONS(6854), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6860), 1,
      anon_sym_AMP,
    ACTIONS(6864), 1,
      anon_sym_GT_GT,
    ACTIONS(6870), 1,
      anon_sym_is,
    ACTIONS(6872), 1,
      anon_sym_CARET,
    ACTIONS(6908), 1,
      anon_sym_PIPE,
    ACTIONS(6910), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6912), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6914), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6916), 1,
      anon_sym_QMARK,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6850), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6856), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6858), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6866), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6868), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5420), 7,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5030), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [69148] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6792), 1,
      anon_sym_as,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(6876), 1,
      anon_sym_QMARK,
    ACTIONS(6882), 1,
      anon_sym_SLASH,
    ACTIONS(6884), 1,
      anon_sym_CARET,
    ACTIONS(6886), 1,
      anon_sym_PIPE,
    ACTIONS(6888), 1,
      anon_sym_AMP,
    ACTIONS(6892), 1,
      anon_sym_GT_GT,
    ACTIONS(6898), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6900), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6902), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6904), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6906), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6874), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6878), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6880), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6890), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6894), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6896), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5325), 7,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(5031), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [69286] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6330), 1,
      anon_sym_as,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(6852), 1,
      anon_sym_SLASH,
    ACTIONS(6854), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6860), 1,
      anon_sym_AMP,
    ACTIONS(6864), 1,
      anon_sym_GT_GT,
    ACTIONS(6870), 1,
      anon_sym_is,
    ACTIONS(6872), 1,
      anon_sym_CARET,
    ACTIONS(6908), 1,
      anon_sym_PIPE,
    ACTIONS(6910), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6912), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6914), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6916), 1,
      anon_sym_QMARK,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6850), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6856), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6858), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6866), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6868), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5510), 7,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5032), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [69424] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6792), 1,
      anon_sym_as,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(6876), 1,
      anon_sym_QMARK,
    ACTIONS(6882), 1,
      anon_sym_SLASH,
    ACTIONS(6884), 1,
      anon_sym_CARET,
    ACTIONS(6886), 1,
      anon_sym_PIPE,
    ACTIONS(6888), 1,
      anon_sym_AMP,
    ACTIONS(6892), 1,
      anon_sym_GT_GT,
    ACTIONS(6898), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6900), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6902), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6904), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6906), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6874), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6878), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6880), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6890), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6894), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6896), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6918), 7,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(5033), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [69562] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6920), 1,
      anon_sym_LT,
    ACTIONS(6923), 1,
      anon_sym_COLON_COLON,
    STATE(5254), 1,
      sym_type_argument_list,
    STATE(5034), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4074), 11,
      anon_sym_COLON,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4076), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [69652] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6927), 1,
      anon_sym_QMARK,
    ACTIONS(6933), 1,
      anon_sym_SLASH,
    ACTIONS(6935), 1,
      anon_sym_CARET,
    ACTIONS(6937), 1,
      anon_sym_PIPE,
    ACTIONS(6939), 1,
      anon_sym_AMP,
    ACTIONS(6943), 1,
      anon_sym_GT_GT,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6951), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6953), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6955), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6957), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6959), 1,
      anon_sym_as,
    ACTIONS(6961), 1,
      anon_sym_is,
    ACTIONS(6963), 1,
      anon_sym_with,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6925), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6929), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6931), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6941), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6945), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6947), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6220), 7,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
    STATE(5035), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [69790] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6927), 1,
      anon_sym_QMARK,
    ACTIONS(6933), 1,
      anon_sym_SLASH,
    ACTIONS(6935), 1,
      anon_sym_CARET,
    ACTIONS(6937), 1,
      anon_sym_PIPE,
    ACTIONS(6939), 1,
      anon_sym_AMP,
    ACTIONS(6943), 1,
      anon_sym_GT_GT,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6951), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6953), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6955), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6957), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6959), 1,
      anon_sym_as,
    ACTIONS(6961), 1,
      anon_sym_is,
    ACTIONS(6963), 1,
      anon_sym_with,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6925), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6929), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6931), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6941), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6945), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6947), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5337), 7,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
    STATE(5036), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [69928] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6927), 1,
      anon_sym_QMARK,
    ACTIONS(6933), 1,
      anon_sym_SLASH,
    ACTIONS(6935), 1,
      anon_sym_CARET,
    ACTIONS(6937), 1,
      anon_sym_PIPE,
    ACTIONS(6939), 1,
      anon_sym_AMP,
    ACTIONS(6943), 1,
      anon_sym_GT_GT,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6951), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6953), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6955), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6957), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6959), 1,
      anon_sym_as,
    ACTIONS(6961), 1,
      anon_sym_is,
    ACTIONS(6963), 1,
      anon_sym_with,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6925), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6929), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6931), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6941), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6945), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6947), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5385), 7,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
    STATE(5037), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [70066] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6854), 1,
      anon_sym_DOT_DOT,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5038), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6122), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6120), 23,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [70168] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6330), 1,
      anon_sym_as,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(6852), 1,
      anon_sym_SLASH,
    ACTIONS(6854), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6860), 1,
      anon_sym_AMP,
    ACTIONS(6864), 1,
      anon_sym_GT_GT,
    ACTIONS(6870), 1,
      anon_sym_is,
    ACTIONS(6872), 1,
      anon_sym_CARET,
    ACTIONS(6908), 1,
      anon_sym_PIPE,
    ACTIONS(6910), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6912), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6914), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6916), 1,
      anon_sym_QMARK,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6850), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6856), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6858), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6866), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6868), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5325), 7,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5039), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [70306] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6927), 1,
      anon_sym_QMARK,
    ACTIONS(6933), 1,
      anon_sym_SLASH,
    ACTIONS(6935), 1,
      anon_sym_CARET,
    ACTIONS(6937), 1,
      anon_sym_PIPE,
    ACTIONS(6939), 1,
      anon_sym_AMP,
    ACTIONS(6943), 1,
      anon_sym_GT_GT,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6951), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6953), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6955), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6957), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6959), 1,
      anon_sym_as,
    ACTIONS(6961), 1,
      anon_sym_is,
    ACTIONS(6963), 1,
      anon_sym_with,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6925), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6929), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6931), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6941), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6945), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6947), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5396), 7,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
    STATE(5040), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [70444] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6330), 1,
      anon_sym_as,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(6852), 1,
      anon_sym_SLASH,
    ACTIONS(6854), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6860), 1,
      anon_sym_AMP,
    ACTIONS(6864), 1,
      anon_sym_GT_GT,
    ACTIONS(6870), 1,
      anon_sym_is,
    ACTIONS(6872), 1,
      anon_sym_CARET,
    ACTIONS(6908), 1,
      anon_sym_PIPE,
    ACTIONS(6910), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6912), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6914), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6916), 1,
      anon_sym_QMARK,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6850), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6856), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6858), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6866), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6868), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6216), 7,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5041), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [70582] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6927), 1,
      anon_sym_QMARK,
    ACTIONS(6933), 1,
      anon_sym_SLASH,
    ACTIONS(6935), 1,
      anon_sym_CARET,
    ACTIONS(6937), 1,
      anon_sym_PIPE,
    ACTIONS(6939), 1,
      anon_sym_AMP,
    ACTIONS(6943), 1,
      anon_sym_GT_GT,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6951), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6953), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6955), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6957), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6959), 1,
      anon_sym_as,
    ACTIONS(6961), 1,
      anon_sym_is,
    ACTIONS(6963), 1,
      anon_sym_with,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6925), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6929), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6931), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6941), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6945), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6947), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6216), 7,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
    STATE(5042), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [70720] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6330), 1,
      anon_sym_as,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(6852), 1,
      anon_sym_SLASH,
    ACTIONS(6854), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6860), 1,
      anon_sym_AMP,
    ACTIONS(6864), 1,
      anon_sym_GT_GT,
    ACTIONS(6870), 1,
      anon_sym_is,
    ACTIONS(6872), 1,
      anon_sym_CARET,
    ACTIONS(6908), 1,
      anon_sym_PIPE,
    ACTIONS(6910), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6912), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6914), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6916), 1,
      anon_sym_QMARK,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6850), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6856), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6858), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6866), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6868), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5396), 7,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5043), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [70858] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6933), 1,
      anon_sym_SLASH,
    ACTIONS(6935), 1,
      anon_sym_CARET,
    ACTIONS(6937), 1,
      anon_sym_PIPE,
    ACTIONS(6939), 1,
      anon_sym_AMP,
    ACTIONS(6943), 1,
      anon_sym_GT_GT,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6951), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6953), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6955), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6957), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6959), 1,
      anon_sym_as,
    ACTIONS(6961), 1,
      anon_sym_is,
    ACTIONS(6963), 1,
      anon_sym_with,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6925), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6929), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6931), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6941), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6945), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6947), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 7,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
    STATE(5044), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [70996] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6330), 1,
      anon_sym_as,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(6852), 1,
      anon_sym_SLASH,
    ACTIONS(6854), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6860), 1,
      anon_sym_AMP,
    ACTIONS(6864), 1,
      anon_sym_GT_GT,
    ACTIONS(6870), 1,
      anon_sym_is,
    ACTIONS(6872), 1,
      anon_sym_CARET,
    ACTIONS(6908), 1,
      anon_sym_PIPE,
    ACTIONS(6910), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6912), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6914), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6916), 1,
      anon_sym_QMARK,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6850), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6856), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6858), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6866), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6868), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5385), 7,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5045), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [71134] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6330), 1,
      anon_sym_as,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(6852), 1,
      anon_sym_SLASH,
    ACTIONS(6854), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6860), 1,
      anon_sym_AMP,
    ACTIONS(6864), 1,
      anon_sym_GT_GT,
    ACTIONS(6870), 1,
      anon_sym_is,
    ACTIONS(6872), 1,
      anon_sym_CARET,
    ACTIONS(6908), 1,
      anon_sym_PIPE,
    ACTIONS(6910), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6912), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6914), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6916), 1,
      anon_sym_QMARK,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6850), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6856), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6858), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6866), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6868), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5337), 7,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5046), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [71272] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6933), 1,
      anon_sym_SLASH,
    ACTIONS(6935), 1,
      anon_sym_CARET,
    ACTIONS(6937), 1,
      anon_sym_PIPE,
    ACTIONS(6939), 1,
      anon_sym_AMP,
    ACTIONS(6943), 1,
      anon_sym_GT_GT,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6951), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6953), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6959), 1,
      anon_sym_as,
    ACTIONS(6961), 1,
      anon_sym_is,
    ACTIONS(6963), 1,
      anon_sym_with,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6925), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6929), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6931), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6941), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6945), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6947), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5047), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 9,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [71406] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6330), 1,
      anon_sym_as,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(6852), 1,
      anon_sym_SLASH,
    ACTIONS(6854), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6860), 1,
      anon_sym_AMP,
    ACTIONS(6864), 1,
      anon_sym_GT_GT,
    ACTIONS(6870), 1,
      anon_sym_is,
    ACTIONS(6872), 1,
      anon_sym_CARET,
    ACTIONS(6908), 1,
      anon_sym_PIPE,
    ACTIONS(6910), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6912), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6914), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6916), 1,
      anon_sym_QMARK,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6850), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6856), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6858), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6866), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6868), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6220), 7,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5048), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [71544] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6927), 1,
      anon_sym_QMARK,
    ACTIONS(6933), 1,
      anon_sym_SLASH,
    ACTIONS(6935), 1,
      anon_sym_CARET,
    ACTIONS(6937), 1,
      anon_sym_PIPE,
    ACTIONS(6939), 1,
      anon_sym_AMP,
    ACTIONS(6943), 1,
      anon_sym_GT_GT,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6951), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6953), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6955), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6957), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6959), 1,
      anon_sym_as,
    ACTIONS(6961), 1,
      anon_sym_is,
    ACTIONS(6963), 1,
      anon_sym_with,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6925), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6929), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6931), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6941), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6945), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6947), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5325), 7,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
    STATE(5049), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [71682] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6933), 1,
      anon_sym_SLASH,
    ACTIONS(6935), 1,
      anon_sym_CARET,
    ACTIONS(6937), 1,
      anon_sym_PIPE,
    ACTIONS(6939), 1,
      anon_sym_AMP,
    ACTIONS(6943), 1,
      anon_sym_GT_GT,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6951), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6959), 1,
      anon_sym_as,
    ACTIONS(6961), 1,
      anon_sym_is,
    ACTIONS(6963), 1,
      anon_sym_with,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6925), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6929), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6931), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6941), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6945), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6947), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5050), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 10,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [71814] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6927), 1,
      anon_sym_QMARK,
    ACTIONS(6933), 1,
      anon_sym_SLASH,
    ACTIONS(6935), 1,
      anon_sym_CARET,
    ACTIONS(6937), 1,
      anon_sym_PIPE,
    ACTIONS(6939), 1,
      anon_sym_AMP,
    ACTIONS(6943), 1,
      anon_sym_GT_GT,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6951), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6953), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6955), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6957), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6959), 1,
      anon_sym_as,
    ACTIONS(6961), 1,
      anon_sym_is,
    ACTIONS(6963), 1,
      anon_sym_with,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6925), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6929), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6931), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6941), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6945), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6947), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5510), 7,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
    STATE(5051), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [71952] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6927), 1,
      anon_sym_QMARK,
    ACTIONS(6933), 1,
      anon_sym_SLASH,
    ACTIONS(6935), 1,
      anon_sym_CARET,
    ACTIONS(6937), 1,
      anon_sym_PIPE,
    ACTIONS(6939), 1,
      anon_sym_AMP,
    ACTIONS(6943), 1,
      anon_sym_GT_GT,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6951), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6953), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6955), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6957), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6959), 1,
      anon_sym_as,
    ACTIONS(6961), 1,
      anon_sym_is,
    ACTIONS(6963), 1,
      anon_sym_with,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6925), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6929), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6931), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6941), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6945), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6947), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5420), 7,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
    STATE(5052), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [72090] = 32,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6933), 1,
      anon_sym_SLASH,
    ACTIONS(6943), 1,
      anon_sym_GT_GT,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6951), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6959), 1,
      anon_sym_as,
    ACTIONS(6961), 1,
      anon_sym_is,
    ACTIONS(6963), 1,
      anon_sym_with,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6925), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6929), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6931), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6941), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6947), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6116), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5053), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 13,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [72214] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6927), 1,
      anon_sym_QMARK,
    ACTIONS(6933), 1,
      anon_sym_SLASH,
    ACTIONS(6935), 1,
      anon_sym_CARET,
    ACTIONS(6937), 1,
      anon_sym_PIPE,
    ACTIONS(6939), 1,
      anon_sym_AMP,
    ACTIONS(6943), 1,
      anon_sym_GT_GT,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6951), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6953), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6955), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6957), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6959), 1,
      anon_sym_as,
    ACTIONS(6961), 1,
      anon_sym_is,
    ACTIONS(6963), 1,
      anon_sym_with,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6925), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6929), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6931), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6941), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6945), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6947), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6230), 7,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
    STATE(5054), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [72352] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6951), 1,
      anon_sym_DOT_DOT,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5055), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6122), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6120), 23,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [72454] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6792), 1,
      anon_sym_as,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(6876), 1,
      anon_sym_QMARK,
    ACTIONS(6882), 1,
      anon_sym_SLASH,
    ACTIONS(6884), 1,
      anon_sym_CARET,
    ACTIONS(6886), 1,
      anon_sym_PIPE,
    ACTIONS(6888), 1,
      anon_sym_AMP,
    ACTIONS(6892), 1,
      anon_sym_GT_GT,
    ACTIONS(6898), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6900), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6902), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6904), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6906), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6874), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6878), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6880), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6890), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6894), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6896), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5420), 7,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(5056), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [72592] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6933), 1,
      anon_sym_SLASH,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6951), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6963), 1,
      anon_sym_with,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6929), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6931), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6116), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5057), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 19,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [72704] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6792), 1,
      anon_sym_as,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(6876), 1,
      anon_sym_QMARK,
    ACTIONS(6882), 1,
      anon_sym_SLASH,
    ACTIONS(6884), 1,
      anon_sym_CARET,
    ACTIONS(6886), 1,
      anon_sym_PIPE,
    ACTIONS(6888), 1,
      anon_sym_AMP,
    ACTIONS(6892), 1,
      anon_sym_GT_GT,
    ACTIONS(6898), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6900), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6902), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6904), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6906), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6874), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6878), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6880), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6890), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6894), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6896), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6230), 7,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(5058), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [72842] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6933), 1,
      anon_sym_SLASH,
    ACTIONS(6943), 1,
      anon_sym_GT_GT,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6951), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6959), 1,
      anon_sym_as,
    ACTIONS(6961), 1,
      anon_sym_is,
    ACTIONS(6963), 1,
      anon_sym_with,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6925), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6929), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6931), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6941), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6945), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6947), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6116), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5059), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 11,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [72968] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6933), 1,
      anon_sym_SLASH,
    ACTIONS(6935), 1,
      anon_sym_CARET,
    ACTIONS(6939), 1,
      anon_sym_AMP,
    ACTIONS(6943), 1,
      anon_sym_GT_GT,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6951), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6959), 1,
      anon_sym_as,
    ACTIONS(6961), 1,
      anon_sym_is,
    ACTIONS(6963), 1,
      anon_sym_with,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6116), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(6925), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6929), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6931), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6941), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6945), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6947), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5060), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 10,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [73098] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4739), 4,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5792), 4,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    STATE(5061), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5488), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5486), 23,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [73186] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6933), 1,
      anon_sym_SLASH,
    ACTIONS(6939), 1,
      anon_sym_AMP,
    ACTIONS(6943), 1,
      anon_sym_GT_GT,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6951), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6959), 1,
      anon_sym_as,
    ACTIONS(6961), 1,
      anon_sym_is,
    ACTIONS(6963), 1,
      anon_sym_with,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6116), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(6925), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6929), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6931), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6941), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6945), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6947), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5062), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 11,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [73314] = 25,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6933), 1,
      anon_sym_SLASH,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6951), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6963), 1,
      anon_sym_with,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6931), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6116), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5063), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 19,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [73424] = 28,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6933), 1,
      anon_sym_SLASH,
    ACTIONS(6943), 1,
      anon_sym_GT_GT,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6951), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6963), 1,
      anon_sym_with,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6929), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6931), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6941), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6116), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5064), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 17,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [73540] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6792), 1,
      anon_sym_as,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(6882), 1,
      anon_sym_SLASH,
    ACTIONS(6884), 1,
      anon_sym_CARET,
    ACTIONS(6888), 1,
      anon_sym_AMP,
    ACTIONS(6892), 1,
      anon_sym_GT_GT,
    ACTIONS(6898), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6906), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6116), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(6874), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6878), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6880), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6890), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6894), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6896), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5065), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 10,
      anon_sym_where,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [73670] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6792), 1,
      anon_sym_as,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(6882), 1,
      anon_sym_SLASH,
    ACTIONS(6884), 1,
      anon_sym_CARET,
    ACTIONS(6886), 1,
      anon_sym_PIPE,
    ACTIONS(6888), 1,
      anon_sym_AMP,
    ACTIONS(6892), 1,
      anon_sym_GT_GT,
    ACTIONS(6898), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6900), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6902), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6904), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6906), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6874), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6878), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6880), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6890), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6894), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6896), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 7,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(5066), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [73808] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6792), 1,
      anon_sym_as,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(6876), 1,
      anon_sym_QMARK,
    ACTIONS(6882), 1,
      anon_sym_SLASH,
    ACTIONS(6884), 1,
      anon_sym_CARET,
    ACTIONS(6886), 1,
      anon_sym_PIPE,
    ACTIONS(6888), 1,
      anon_sym_AMP,
    ACTIONS(6892), 1,
      anon_sym_GT_GT,
    ACTIONS(6898), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6900), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6902), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6904), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6906), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6874), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6878), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6880), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6890), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6894), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6896), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5510), 7,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(5067), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [73946] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6792), 1,
      anon_sym_as,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(6882), 1,
      anon_sym_SLASH,
    ACTIONS(6884), 1,
      anon_sym_CARET,
    ACTIONS(6886), 1,
      anon_sym_PIPE,
    ACTIONS(6888), 1,
      anon_sym_AMP,
    ACTIONS(6892), 1,
      anon_sym_GT_GT,
    ACTIONS(6898), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6900), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6906), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6874), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6878), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6880), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6890), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6894), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6896), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5068), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 9,
      anon_sym_where,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [74080] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6792), 1,
      anon_sym_as,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(6882), 1,
      anon_sym_SLASH,
    ACTIONS(6884), 1,
      anon_sym_CARET,
    ACTIONS(6886), 1,
      anon_sym_PIPE,
    ACTIONS(6888), 1,
      anon_sym_AMP,
    ACTIONS(6892), 1,
      anon_sym_GT_GT,
    ACTIONS(6898), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6906), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6874), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6878), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6880), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6890), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6894), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6896), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5069), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 10,
      anon_sym_where,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [74212] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6927), 1,
      anon_sym_QMARK,
    ACTIONS(6933), 1,
      anon_sym_SLASH,
    ACTIONS(6935), 1,
      anon_sym_CARET,
    ACTIONS(6937), 1,
      anon_sym_PIPE,
    ACTIONS(6939), 1,
      anon_sym_AMP,
    ACTIONS(6943), 1,
      anon_sym_GT_GT,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6951), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6953), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6955), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6957), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6959), 1,
      anon_sym_as,
    ACTIONS(6961), 1,
      anon_sym_is,
    ACTIONS(6963), 1,
      anon_sym_with,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6925), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6929), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6931), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6941), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6945), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6947), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6236), 7,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
    STATE(5070), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [74350] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4739), 4,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5786), 4,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    STATE(5071), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5480), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5478), 23,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [74438] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6927), 1,
      anon_sym_QMARK,
    ACTIONS(6933), 1,
      anon_sym_SLASH,
    ACTIONS(6935), 1,
      anon_sym_CARET,
    ACTIONS(6937), 1,
      anon_sym_PIPE,
    ACTIONS(6939), 1,
      anon_sym_AMP,
    ACTIONS(6943), 1,
      anon_sym_GT_GT,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6951), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6953), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6955), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6957), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6959), 1,
      anon_sym_as,
    ACTIONS(6961), 1,
      anon_sym_is,
    ACTIONS(6963), 1,
      anon_sym_with,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6925), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6929), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6931), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6941), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6945), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6947), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6173), 7,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
    STATE(5072), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [74576] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6792), 1,
      anon_sym_as,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(6876), 1,
      anon_sym_QMARK,
    ACTIONS(6882), 1,
      anon_sym_SLASH,
    ACTIONS(6884), 1,
      anon_sym_CARET,
    ACTIONS(6886), 1,
      anon_sym_PIPE,
    ACTIONS(6888), 1,
      anon_sym_AMP,
    ACTIONS(6892), 1,
      anon_sym_GT_GT,
    ACTIONS(6898), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6900), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6902), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6904), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6906), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6874), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6878), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6880), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6890), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6894), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6896), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6216), 7,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(5073), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [74714] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6965), 1,
      anon_sym_into,
    STATE(5085), 1,
      aux_sym__query_body_repeat2,
    STATE(5074), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6420), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6418), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [74802] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6792), 1,
      anon_sym_as,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(6882), 1,
      anon_sym_SLASH,
    ACTIONS(6888), 1,
      anon_sym_AMP,
    ACTIONS(6892), 1,
      anon_sym_GT_GT,
    ACTIONS(6898), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6906), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6116), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(6874), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6878), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6880), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6890), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6894), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6896), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5075), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 11,
      anon_sym_where,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [74930] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6792), 1,
      anon_sym_as,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(6876), 1,
      anon_sym_QMARK,
    ACTIONS(6882), 1,
      anon_sym_SLASH,
    ACTIONS(6884), 1,
      anon_sym_CARET,
    ACTIONS(6886), 1,
      anon_sym_PIPE,
    ACTIONS(6888), 1,
      anon_sym_AMP,
    ACTIONS(6892), 1,
      anon_sym_GT_GT,
    ACTIONS(6898), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6900), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6902), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6904), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6906), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6874), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6878), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6880), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6890), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6894), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6896), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6236), 7,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(5076), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [75068] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6965), 1,
      anon_sym_into,
    STATE(5082), 1,
      aux_sym__query_body_repeat2,
    STATE(5077), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6420), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6418), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [75156] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6792), 1,
      anon_sym_as,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(6876), 1,
      anon_sym_QMARK,
    ACTIONS(6882), 1,
      anon_sym_SLASH,
    ACTIONS(6884), 1,
      anon_sym_CARET,
    ACTIONS(6886), 1,
      anon_sym_PIPE,
    ACTIONS(6888), 1,
      anon_sym_AMP,
    ACTIONS(6892), 1,
      anon_sym_GT_GT,
    ACTIONS(6898), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6900), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6902), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6904), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6906), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6874), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6878), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6880), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6890), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6894), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6896), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6967), 7,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(5078), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [75294] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(6898), 1,
      anon_sym_DOT_DOT,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5079), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6116), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6114), 21,
      anon_sym_where,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
  [75400] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6969), 1,
      anon_sym_and,
    ACTIONS(6971), 1,
      anon_sym_or,
    STATE(5080), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6609), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6607), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [75488] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5081), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4106), 14,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_EQ_GT,
    ACTIONS(4099), 28,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_operator,
      anon_sym_this,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [75572] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6965), 1,
      anon_sym_into,
    STATE(5085), 1,
      aux_sym__query_body_repeat2,
    STATE(5082), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6383), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6381), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [75660] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(1377), 1,
      anon_sym_LBRACE,
    ACTIONS(6973), 1,
      anon_sym_LPAREN,
    STATE(5131), 1,
      sym_argument_list,
    STATE(5672), 1,
      sym_initializer_expression,
    STATE(5083), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5189), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5185), 27,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [75752] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6965), 1,
      anon_sym_into,
    STATE(5074), 1,
      aux_sym__query_body_repeat2,
    STATE(5084), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6448), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6446), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [75840] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6975), 1,
      anon_sym_into,
    STATE(5085), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym__query_body_repeat2,
    ACTIONS(6376), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6374), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [75926] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6792), 1,
      anon_sym_as,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(6882), 1,
      anon_sym_SLASH,
    ACTIONS(6892), 1,
      anon_sym_GT_GT,
    ACTIONS(6898), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6906), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6874), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6878), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6880), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6890), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6894), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6896), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6116), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5086), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 11,
      anon_sym_where,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [76052] = 25,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(6882), 1,
      anon_sym_SLASH,
    ACTIONS(6898), 1,
      anon_sym_DOT_DOT,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6880), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6116), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5087), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 19,
      anon_sym_where,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
  [76162] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6969), 1,
      anon_sym_and,
    ACTIONS(6971), 1,
      anon_sym_or,
    STATE(5088), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5856), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5854), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [76250] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6792), 1,
      anon_sym_as,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(6876), 1,
      anon_sym_QMARK,
    ACTIONS(6882), 1,
      anon_sym_SLASH,
    ACTIONS(6884), 1,
      anon_sym_CARET,
    ACTIONS(6886), 1,
      anon_sym_PIPE,
    ACTIONS(6888), 1,
      anon_sym_AMP,
    ACTIONS(6892), 1,
      anon_sym_GT_GT,
    ACTIONS(6898), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6900), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6902), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6904), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6906), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6874), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6878), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6880), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6890), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6894), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6896), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6978), 7,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(5089), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [76388] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3721), 1,
      anon_sym_EQ,
    ACTIONS(3719), 7,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
    ACTIONS(4024), 8,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_GT,
      anon_sym_EQ_GT,
    STATE(5090), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4027), 26,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [76476] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6792), 1,
      anon_sym_as,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(6876), 1,
      anon_sym_QMARK,
    ACTIONS(6882), 1,
      anon_sym_SLASH,
    ACTIONS(6884), 1,
      anon_sym_CARET,
    ACTIONS(6886), 1,
      anon_sym_PIPE,
    ACTIONS(6888), 1,
      anon_sym_AMP,
    ACTIONS(6892), 1,
      anon_sym_GT_GT,
    ACTIONS(6898), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6900), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6902), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6904), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6906), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6874), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6878), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6880), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6890), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6894), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6896), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6980), 7,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(5091), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [76614] = 28,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2983), 1,
      sym__identifier_token,
    ACTIONS(2995), 1,
      anon_sym_LPAREN,
    ACTIONS(3728), 1,
      anon_sym_delegate,
    ACTIONS(5284), 1,
      anon_sym_var,
    ACTIONS(6982), 1,
      sym_predefined_type,
    STATE(4443), 1,
      sym__reserved_identifier,
    STATE(4921), 1,
      sym_identifier,
    STATE(4959), 1,
      sym_generic_name,
    STATE(8006), 1,
      sym__name,
    STATE(8314), 1,
      sym_tuple_type,
    STATE(8354), 1,
      sym_array_type,
    STATE(8768), 1,
      sym__array_base_type,
    STATE(9494), 1,
      sym_implicit_type,
    STATE(9542), 1,
      sym__ref_base_type,
    STATE(9721), 1,
      sym__pointer_base_type,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(8397), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(5092), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2987), 21,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [76730] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6951), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6963), 1,
      anon_sym_with,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5093), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6116), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6114), 21,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [76836] = 28,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(6882), 1,
      anon_sym_SLASH,
    ACTIONS(6892), 1,
      anon_sym_GT_GT,
    ACTIONS(6898), 1,
      anon_sym_DOT_DOT,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6878), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6880), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6890), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6116), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5094), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 17,
      anon_sym_where,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
  [76952] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6898), 1,
      anon_sym_DOT_DOT,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5095), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1147), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(1133), 23,
      anon_sym_where,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [77054] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6898), 1,
      anon_sym_DOT_DOT,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5096), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6122), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6120), 23,
      anon_sym_where,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [77156] = 32,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6792), 1,
      anon_sym_as,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(6882), 1,
      anon_sym_SLASH,
    ACTIONS(6892), 1,
      anon_sym_GT_GT,
    ACTIONS(6898), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6906), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6874), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6878), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6880), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6890), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6896), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6116), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5097), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 13,
      anon_sym_where,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [77280] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(6882), 1,
      anon_sym_SLASH,
    ACTIONS(6898), 1,
      anon_sym_DOT_DOT,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6878), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6880), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6116), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5098), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 19,
      anon_sym_where,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
  [77392] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6854), 1,
      anon_sym_DOT_DOT,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5099), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1147), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(1133), 23,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [77494] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6792), 1,
      anon_sym_as,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(6876), 1,
      anon_sym_QMARK,
    ACTIONS(6882), 1,
      anon_sym_SLASH,
    ACTIONS(6884), 1,
      anon_sym_CARET,
    ACTIONS(6886), 1,
      anon_sym_PIPE,
    ACTIONS(6888), 1,
      anon_sym_AMP,
    ACTIONS(6892), 1,
      anon_sym_GT_GT,
    ACTIONS(6898), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6900), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6902), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6904), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6906), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6874), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6878), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6880), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6890), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6894), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6896), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5385), 7,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(5100), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [77632] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6969), 1,
      anon_sym_and,
    STATE(5101), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6546), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
    ACTIONS(6544), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [77718] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6330), 1,
      anon_sym_as,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(6852), 1,
      anon_sym_SLASH,
    ACTIONS(6854), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6860), 1,
      anon_sym_AMP,
    ACTIONS(6864), 1,
      anon_sym_GT_GT,
    ACTIONS(6870), 1,
      anon_sym_is,
    ACTIONS(6872), 1,
      anon_sym_CARET,
    ACTIONS(6908), 1,
      anon_sym_PIPE,
    ACTIONS(6910), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6912), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6914), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6916), 1,
      anon_sym_QMARK,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6850), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6856), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6858), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6866), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6868), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6284), 7,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5102), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [77856] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6792), 1,
      anon_sym_as,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(6876), 1,
      anon_sym_QMARK,
    ACTIONS(6882), 1,
      anon_sym_SLASH,
    ACTIONS(6884), 1,
      anon_sym_CARET,
    ACTIONS(6886), 1,
      anon_sym_PIPE,
    ACTIONS(6888), 1,
      anon_sym_AMP,
    ACTIONS(6892), 1,
      anon_sym_GT_GT,
    ACTIONS(6898), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6900), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6902), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6904), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6906), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6874), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6878), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6880), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6890), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6894), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6896), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5337), 7,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(5103), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [77994] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6792), 1,
      anon_sym_as,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(6876), 1,
      anon_sym_QMARK,
    ACTIONS(6882), 1,
      anon_sym_SLASH,
    ACTIONS(6884), 1,
      anon_sym_CARET,
    ACTIONS(6886), 1,
      anon_sym_PIPE,
    ACTIONS(6888), 1,
      anon_sym_AMP,
    ACTIONS(6892), 1,
      anon_sym_GT_GT,
    ACTIONS(6898), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6900), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6902), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6904), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6906), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6874), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6878), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6880), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6890), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6894), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6896), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6220), 7,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(5104), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [78132] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6951), 1,
      anon_sym_DOT_DOT,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5105), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1147), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(1133), 23,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [78234] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6330), 1,
      anon_sym_as,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(6852), 1,
      anon_sym_SLASH,
    ACTIONS(6854), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6860), 1,
      anon_sym_AMP,
    ACTIONS(6864), 1,
      anon_sym_GT_GT,
    ACTIONS(6870), 1,
      anon_sym_is,
    ACTIONS(6872), 1,
      anon_sym_CARET,
    ACTIONS(6908), 1,
      anon_sym_PIPE,
    ACTIONS(6910), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6912), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6914), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6916), 1,
      anon_sym_QMARK,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6850), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6856), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6858), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6866), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6868), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6173), 7,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5106), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [78372] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6330), 1,
      anon_sym_as,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(6852), 1,
      anon_sym_SLASH,
    ACTIONS(6854), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6860), 1,
      anon_sym_AMP,
    ACTIONS(6864), 1,
      anon_sym_GT_GT,
    ACTIONS(6870), 1,
      anon_sym_is,
    ACTIONS(6872), 1,
      anon_sym_CARET,
    ACTIONS(6908), 1,
      anon_sym_PIPE,
    ACTIONS(6910), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6912), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6914), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6916), 1,
      anon_sym_QMARK,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6850), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6856), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6858), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6866), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6868), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6274), 7,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5107), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [78510] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6959), 1,
      anon_sym_as,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(6990), 1,
      anon_sym_SLASH,
    ACTIONS(6992), 1,
      anon_sym_AMP,
    ACTIONS(6996), 1,
      anon_sym_GT_GT,
    ACTIONS(7002), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7004), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6116), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(6984), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6986), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6988), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6994), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6998), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7000), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5108), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 10,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [78637] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2983), 1,
      sym__identifier_token,
    ACTIONS(2995), 1,
      anon_sym_LPAREN,
    ACTIONS(3728), 1,
      anon_sym_delegate,
    ACTIONS(7006), 1,
      anon_sym_LBRACK,
    ACTIONS(7008), 1,
      sym_predefined_type,
    STATE(3824), 1,
      sym_array_type,
    STATE(4443), 1,
      sym__reserved_identifier,
    STATE(4921), 1,
      sym_identifier,
    STATE(4959), 1,
      sym_generic_name,
    STATE(8214), 1,
      sym__name,
    STATE(8572), 1,
      sym_tuple_type,
    STATE(8833), 1,
      sym__array_base_type,
    STATE(9721), 1,
      sym__pointer_base_type,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(8906), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(5109), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2987), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [78748] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6959), 1,
      anon_sym_as,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(6990), 1,
      anon_sym_SLASH,
    ACTIONS(6992), 1,
      anon_sym_AMP,
    ACTIONS(6996), 1,
      anon_sym_GT_GT,
    ACTIONS(7002), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7004), 1,
      anon_sym_is,
    ACTIONS(7010), 1,
      anon_sym_QMARK,
    ACTIONS(7012), 1,
      anon_sym_CARET,
    ACTIONS(7014), 1,
      anon_sym_PIPE,
    ACTIONS(7016), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7018), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7020), 1,
      anon_sym_QMARK_QMARK,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6984), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6986), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6988), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6994), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6998), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7000), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6230), 6,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
    STATE(5110), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [78885] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6959), 1,
      anon_sym_as,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(6990), 1,
      anon_sym_SLASH,
    ACTIONS(6992), 1,
      anon_sym_AMP,
    ACTIONS(6996), 1,
      anon_sym_GT_GT,
    ACTIONS(7002), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7004), 1,
      anon_sym_is,
    ACTIONS(7010), 1,
      anon_sym_QMARK,
    ACTIONS(7012), 1,
      anon_sym_CARET,
    ACTIONS(7014), 1,
      anon_sym_PIPE,
    ACTIONS(7016), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7018), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7020), 1,
      anon_sym_QMARK_QMARK,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6984), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6986), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6988), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6994), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6998), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7000), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5420), 6,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
    STATE(5111), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [79022] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6959), 1,
      anon_sym_as,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(6990), 1,
      anon_sym_SLASH,
    ACTIONS(6992), 1,
      anon_sym_AMP,
    ACTIONS(6996), 1,
      anon_sym_GT_GT,
    ACTIONS(7002), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7004), 1,
      anon_sym_is,
    ACTIONS(7010), 1,
      anon_sym_QMARK,
    ACTIONS(7012), 1,
      anon_sym_CARET,
    ACTIONS(7014), 1,
      anon_sym_PIPE,
    ACTIONS(7016), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7018), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7020), 1,
      anon_sym_QMARK_QMARK,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6984), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6986), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6988), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6994), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6998), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7000), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5510), 6,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
    STATE(5112), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [79159] = 32,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4953), 1,
      anon_sym_DASH_GT,
    ACTIONS(5067), 1,
      anon_sym_DOT,
    ACTIONS(6973), 1,
      anon_sym_LPAREN,
    ACTIONS(7022), 1,
      anon_sym_LBRACK,
    ACTIONS(7026), 1,
      anon_sym_BANG,
    ACTIONS(7034), 1,
      anon_sym_SLASH,
    ACTIONS(7038), 1,
      anon_sym_GT_GT,
    ACTIONS(7042), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7046), 1,
      anon_sym_as,
    ACTIONS(7048), 1,
      anon_sym_is,
    ACTIONS(7050), 1,
      anon_sym_with,
    STATE(3870), 1,
      sym_bracketed_argument_list,
    STATE(5721), 1,
      sym_argument_list,
    ACTIONS(7024), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7028), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7030), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7032), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7036), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7040), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6116), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5113), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 12,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
  [79282] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4953), 1,
      anon_sym_DASH_GT,
    ACTIONS(5067), 1,
      anon_sym_DOT,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6973), 1,
      anon_sym_LPAREN,
    ACTIONS(7022), 1,
      anon_sym_LBRACK,
    ACTIONS(7026), 1,
      anon_sym_BANG,
    ACTIONS(7034), 1,
      anon_sym_SLASH,
    ACTIONS(7038), 1,
      anon_sym_GT_GT,
    ACTIONS(7042), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7046), 1,
      anon_sym_as,
    ACTIONS(7048), 1,
      anon_sym_is,
    ACTIONS(7050), 1,
      anon_sym_with,
    ACTIONS(7052), 1,
      anon_sym_CARET,
    ACTIONS(7054), 1,
      anon_sym_PIPE,
    ACTIONS(7056), 1,
      anon_sym_AMP,
    ACTIONS(7060), 1,
      anon_sym_AMP_AMP,
    STATE(3870), 1,
      sym_bracketed_argument_list,
    STATE(5721), 1,
      sym_argument_list,
    ACTIONS(7024), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7028), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7030), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7032), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7036), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7040), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7058), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6114), 8,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
    STATE(5114), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [79415] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2983), 1,
      sym__identifier_token,
    ACTIONS(2995), 1,
      anon_sym_LPAREN,
    ACTIONS(3728), 1,
      anon_sym_delegate,
    ACTIONS(7008), 1,
      sym_predefined_type,
    ACTIONS(7062), 1,
      anon_sym_LBRACK,
    STATE(3553), 1,
      sym_array_type,
    STATE(4443), 1,
      sym__reserved_identifier,
    STATE(4921), 1,
      sym_identifier,
    STATE(4959), 1,
      sym_generic_name,
    STATE(8214), 1,
      sym__name,
    STATE(8572), 1,
      sym_tuple_type,
    STATE(8879), 1,
      sym__array_base_type,
    STATE(9721), 1,
      sym__pointer_base_type,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(8906), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(5115), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2987), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [79526] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(1377), 1,
      anon_sym_LBRACE,
    STATE(5673), 1,
      sym_initializer_expression,
    STATE(5116), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5203), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5201), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [79613] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6959), 1,
      anon_sym_as,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(6990), 1,
      anon_sym_SLASH,
    ACTIONS(6992), 1,
      anon_sym_AMP,
    ACTIONS(6996), 1,
      anon_sym_GT_GT,
    ACTIONS(7002), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7004), 1,
      anon_sym_is,
    ACTIONS(7010), 1,
      anon_sym_QMARK,
    ACTIONS(7012), 1,
      anon_sym_CARET,
    ACTIONS(7014), 1,
      anon_sym_PIPE,
    ACTIONS(7016), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7018), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7020), 1,
      anon_sym_QMARK_QMARK,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6984), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6986), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6988), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6994), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6998), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7000), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5325), 6,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
    STATE(5117), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [79750] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6959), 1,
      anon_sym_as,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(6990), 1,
      anon_sym_SLASH,
    ACTIONS(6992), 1,
      anon_sym_AMP,
    ACTIONS(6996), 1,
      anon_sym_GT_GT,
    ACTIONS(7002), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7004), 1,
      anon_sym_is,
    ACTIONS(7010), 1,
      anon_sym_QMARK,
    ACTIONS(7012), 1,
      anon_sym_CARET,
    ACTIONS(7014), 1,
      anon_sym_PIPE,
    ACTIONS(7016), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7018), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7020), 1,
      anon_sym_QMARK_QMARK,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6984), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6986), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6988), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6994), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6998), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7000), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6216), 6,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
    STATE(5118), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [79887] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4953), 1,
      anon_sym_DASH_GT,
    ACTIONS(5067), 1,
      anon_sym_DOT,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6973), 1,
      anon_sym_LPAREN,
    ACTIONS(7022), 1,
      anon_sym_LBRACK,
    ACTIONS(7026), 1,
      anon_sym_BANG,
    ACTIONS(7034), 1,
      anon_sym_SLASH,
    ACTIONS(7038), 1,
      anon_sym_GT_GT,
    ACTIONS(7042), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7046), 1,
      anon_sym_as,
    ACTIONS(7048), 1,
      anon_sym_is,
    ACTIONS(7050), 1,
      anon_sym_with,
    ACTIONS(7052), 1,
      anon_sym_CARET,
    ACTIONS(7054), 1,
      anon_sym_PIPE,
    ACTIONS(7056), 1,
      anon_sym_AMP,
    STATE(3870), 1,
      sym_bracketed_argument_list,
    STATE(5721), 1,
      sym_argument_list,
    ACTIONS(7024), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7028), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7030), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7032), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7036), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7040), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7058), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    STATE(5119), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 9,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
  [80018] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4953), 1,
      anon_sym_DASH_GT,
    ACTIONS(5067), 1,
      anon_sym_DOT,
    ACTIONS(6973), 1,
      anon_sym_LPAREN,
    ACTIONS(7022), 1,
      anon_sym_LBRACK,
    ACTIONS(7026), 1,
      anon_sym_BANG,
    STATE(3870), 1,
      sym_bracketed_argument_list,
    STATE(5721), 1,
      sym_argument_list,
    ACTIONS(7028), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5120), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5245), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5243), 23,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [80117] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5121), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4504), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_EQ_GT,
    ACTIONS(4502), 28,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_operator,
      anon_sym_this,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [80200] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(7002), 1,
      anon_sym_DOT_DOT,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5122), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6122), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6120), 22,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [80301] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4953), 1,
      anon_sym_DASH_GT,
    ACTIONS(5067), 1,
      anon_sym_DOT,
    ACTIONS(6973), 1,
      anon_sym_LPAREN,
    ACTIONS(7022), 1,
      anon_sym_LBRACK,
    ACTIONS(7026), 1,
      anon_sym_BANG,
    STATE(3870), 1,
      sym_bracketed_argument_list,
    STATE(5721), 1,
      sym_argument_list,
    ACTIONS(7028), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5123), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5257), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5255), 23,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [80400] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4953), 1,
      anon_sym_DASH_GT,
    ACTIONS(5067), 1,
      anon_sym_DOT,
    ACTIONS(6973), 1,
      anon_sym_LPAREN,
    ACTIONS(7022), 1,
      anon_sym_LBRACK,
    ACTIONS(7026), 1,
      anon_sym_BANG,
    STATE(3870), 1,
      sym_bracketed_argument_list,
    STATE(5721), 1,
      sym_argument_list,
    ACTIONS(7028), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5124), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5237), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5233), 23,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [80499] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(1377), 1,
      anon_sym_LBRACE,
    ACTIONS(5228), 1,
      anon_sym_LBRACK,
    STATE(5662), 1,
      sym_initializer_expression,
    STATE(5125), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5231), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5226), 27,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [80588] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4953), 1,
      anon_sym_DASH_GT,
    ACTIONS(5067), 1,
      anon_sym_DOT,
    ACTIONS(6973), 1,
      anon_sym_LPAREN,
    ACTIONS(7022), 1,
      anon_sym_LBRACK,
    ACTIONS(7026), 1,
      anon_sym_BANG,
    ACTIONS(7034), 1,
      anon_sym_SLASH,
    ACTIONS(7038), 1,
      anon_sym_GT_GT,
    ACTIONS(7042), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7046), 1,
      anon_sym_as,
    ACTIONS(7048), 1,
      anon_sym_is,
    ACTIONS(7050), 1,
      anon_sym_with,
    ACTIONS(7052), 1,
      anon_sym_CARET,
    ACTIONS(7054), 1,
      anon_sym_PIPE,
    ACTIONS(7056), 1,
      anon_sym_AMP,
    ACTIONS(7060), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7064), 1,
      anon_sym_QMARK,
    ACTIONS(7066), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7068), 1,
      anon_sym_QMARK_QMARK,
    STATE(3870), 1,
      sym_bracketed_argument_list,
    STATE(5721), 1,
      sym_argument_list,
    ACTIONS(7024), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7028), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7030), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7032), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7036), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7040), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7058), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5337), 6,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5126), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [80725] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4953), 1,
      anon_sym_DASH_GT,
    ACTIONS(5067), 1,
      anon_sym_DOT,
    ACTIONS(6973), 1,
      anon_sym_LPAREN,
    ACTIONS(7022), 1,
      anon_sym_LBRACK,
    ACTIONS(7026), 1,
      anon_sym_BANG,
    ACTIONS(7034), 1,
      anon_sym_SLASH,
    ACTIONS(7038), 1,
      anon_sym_GT_GT,
    ACTIONS(7042), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7046), 1,
      anon_sym_as,
    ACTIONS(7048), 1,
      anon_sym_is,
    ACTIONS(7050), 1,
      anon_sym_with,
    STATE(3870), 1,
      sym_bracketed_argument_list,
    STATE(5721), 1,
      sym_argument_list,
    ACTIONS(7024), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7028), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7030), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7032), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7036), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7040), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7058), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6116), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5127), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 10,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_CARET,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
  [80850] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5128), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4056), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4058), 30,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [80933] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2983), 1,
      sym__identifier_token,
    ACTIONS(2995), 1,
      anon_sym_LPAREN,
    ACTIONS(3728), 1,
      anon_sym_delegate,
    ACTIONS(7008), 1,
      sym_predefined_type,
    ACTIONS(7070), 1,
      anon_sym_LBRACK,
    STATE(3903), 1,
      sym_array_type,
    STATE(4443), 1,
      sym__reserved_identifier,
    STATE(4921), 1,
      sym_identifier,
    STATE(4959), 1,
      sym_generic_name,
    STATE(8214), 1,
      sym__name,
    STATE(8572), 1,
      sym_tuple_type,
    STATE(8755), 1,
      sym__array_base_type,
    STATE(9721), 1,
      sym__pointer_base_type,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(8906), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(5129), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2987), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [81044] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5130), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3721), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(3719), 30,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [81127] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(1377), 1,
      anon_sym_LBRACE,
    STATE(5639), 1,
      sym_initializer_expression,
    STATE(5131), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5207), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5205), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [81214] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2983), 1,
      sym__identifier_token,
    ACTIONS(2995), 1,
      anon_sym_LPAREN,
    ACTIONS(3728), 1,
      anon_sym_delegate,
    ACTIONS(7008), 1,
      sym_predefined_type,
    ACTIONS(7072), 1,
      anon_sym_LBRACK,
    STATE(3606), 1,
      sym_array_type,
    STATE(4443), 1,
      sym__reserved_identifier,
    STATE(4921), 1,
      sym_identifier,
    STATE(4959), 1,
      sym_generic_name,
    STATE(8214), 1,
      sym__name,
    STATE(8572), 1,
      sym_tuple_type,
    STATE(8888), 1,
      sym__array_base_type,
    STATE(9721), 1,
      sym__pointer_base_type,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(8906), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(5132), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2987), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [81325] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2983), 1,
      sym__identifier_token,
    ACTIONS(2995), 1,
      anon_sym_LPAREN,
    ACTIONS(3728), 1,
      anon_sym_delegate,
    ACTIONS(7008), 1,
      sym_predefined_type,
    ACTIONS(7074), 1,
      anon_sym_LBRACK,
    STATE(4347), 1,
      sym_array_type,
    STATE(4443), 1,
      sym__reserved_identifier,
    STATE(4921), 1,
      sym_identifier,
    STATE(4959), 1,
      sym_generic_name,
    STATE(8214), 1,
      sym__name,
    STATE(8572), 1,
      sym_tuple_type,
    STATE(8712), 1,
      sym__array_base_type,
    STATE(9721), 1,
      sym__pointer_base_type,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(8906), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(5133), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2987), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [81436] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6959), 1,
      anon_sym_as,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(6990), 1,
      anon_sym_SLASH,
    ACTIONS(6992), 1,
      anon_sym_AMP,
    ACTIONS(6996), 1,
      anon_sym_GT_GT,
    ACTIONS(7002), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7004), 1,
      anon_sym_is,
    ACTIONS(7012), 1,
      anon_sym_CARET,
    ACTIONS(7014), 1,
      anon_sym_PIPE,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6984), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6986), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6988), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6994), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6998), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7000), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5134), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 9,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [81567] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4953), 1,
      anon_sym_DASH_GT,
    ACTIONS(5067), 1,
      anon_sym_DOT,
    ACTIONS(6973), 1,
      anon_sym_LPAREN,
    ACTIONS(7022), 1,
      anon_sym_LBRACK,
    ACTIONS(7026), 1,
      anon_sym_BANG,
    ACTIONS(7034), 1,
      anon_sym_SLASH,
    ACTIONS(7038), 1,
      anon_sym_GT_GT,
    ACTIONS(7042), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7046), 1,
      anon_sym_as,
    ACTIONS(7048), 1,
      anon_sym_is,
    ACTIONS(7050), 1,
      anon_sym_with,
    ACTIONS(7052), 1,
      anon_sym_CARET,
    ACTIONS(7056), 1,
      anon_sym_AMP,
    STATE(3870), 1,
      sym_bracketed_argument_list,
    STATE(5721), 1,
      sym_argument_list,
    ACTIONS(6116), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7024), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7028), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7030), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7032), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7036), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7040), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7058), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    STATE(5135), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 9,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
  [81696] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6920), 1,
      anon_sym_LT,
    STATE(5254), 1,
      sym_type_argument_list,
    STATE(5136), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4074), 10,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4076), 29,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [81783] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5298), 1,
      anon_sym_LBRACK,
    ACTIONS(5305), 1,
      anon_sym_LBRACE,
    ACTIONS(5311), 1,
      anon_sym_QMARK,
    STATE(3719), 1,
      sym_initializer_expression,
    STATE(5137), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5308), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5302), 27,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [81874] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6959), 1,
      anon_sym_as,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(6990), 1,
      anon_sym_SLASH,
    ACTIONS(6992), 1,
      anon_sym_AMP,
    ACTIONS(6996), 1,
      anon_sym_GT_GT,
    ACTIONS(7002), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7004), 1,
      anon_sym_is,
    ACTIONS(7010), 1,
      anon_sym_QMARK,
    ACTIONS(7012), 1,
      anon_sym_CARET,
    ACTIONS(7014), 1,
      anon_sym_PIPE,
    ACTIONS(7016), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7018), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7020), 1,
      anon_sym_QMARK_QMARK,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6984), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6986), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6988), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6994), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6998), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7000), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5385), 6,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
    STATE(5138), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [82011] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(7076), 1,
      anon_sym_DOT_DOT,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5139), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1147), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(1133), 22,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [82112] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4953), 1,
      anon_sym_DASH_GT,
    ACTIONS(5067), 1,
      anon_sym_DOT,
    ACTIONS(6973), 1,
      anon_sym_LPAREN,
    ACTIONS(7022), 1,
      anon_sym_LBRACK,
    ACTIONS(7026), 1,
      anon_sym_BANG,
    ACTIONS(7034), 1,
      anon_sym_SLASH,
    ACTIONS(7038), 1,
      anon_sym_GT_GT,
    ACTIONS(7042), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7046), 1,
      anon_sym_as,
    ACTIONS(7048), 1,
      anon_sym_is,
    ACTIONS(7050), 1,
      anon_sym_with,
    ACTIONS(7056), 1,
      anon_sym_AMP,
    STATE(3870), 1,
      sym_bracketed_argument_list,
    STATE(5721), 1,
      sym_argument_list,
    ACTIONS(6116), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7024), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7028), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7030), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7032), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7036), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7040), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7058), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    STATE(5140), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 10,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_CARET,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
  [82239] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6959), 1,
      anon_sym_as,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(6990), 1,
      anon_sym_SLASH,
    ACTIONS(6992), 1,
      anon_sym_AMP,
    ACTIONS(6996), 1,
      anon_sym_GT_GT,
    ACTIONS(7002), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7004), 1,
      anon_sym_is,
    ACTIONS(7010), 1,
      anon_sym_QMARK,
    ACTIONS(7012), 1,
      anon_sym_CARET,
    ACTIONS(7014), 1,
      anon_sym_PIPE,
    ACTIONS(7016), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7018), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7020), 1,
      anon_sym_QMARK_QMARK,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6984), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6986), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6988), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6994), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6998), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7000), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6236), 6,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
    STATE(5141), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [82376] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6959), 1,
      anon_sym_as,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(6990), 1,
      anon_sym_SLASH,
    ACTIONS(6992), 1,
      anon_sym_AMP,
    ACTIONS(6996), 1,
      anon_sym_GT_GT,
    ACTIONS(7002), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7004), 1,
      anon_sym_is,
    ACTIONS(7010), 1,
      anon_sym_QMARK,
    ACTIONS(7012), 1,
      anon_sym_CARET,
    ACTIONS(7014), 1,
      anon_sym_PIPE,
    ACTIONS(7016), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7018), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7020), 1,
      anon_sym_QMARK_QMARK,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6984), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6986), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6988), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6994), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6998), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7000), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6173), 6,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
    STATE(5142), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [82513] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6959), 1,
      anon_sym_as,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(6990), 1,
      anon_sym_SLASH,
    ACTIONS(6992), 1,
      anon_sym_AMP,
    ACTIONS(6996), 1,
      anon_sym_GT_GT,
    ACTIONS(7002), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7004), 1,
      anon_sym_is,
    ACTIONS(7010), 1,
      anon_sym_QMARK,
    ACTIONS(7012), 1,
      anon_sym_CARET,
    ACTIONS(7014), 1,
      anon_sym_PIPE,
    ACTIONS(7016), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7018), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7020), 1,
      anon_sym_QMARK_QMARK,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6984), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6986), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6988), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6994), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6998), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7000), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5396), 6,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
    STATE(5143), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [82650] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5144), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4056), 12,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4058), 29,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [82733] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4953), 1,
      anon_sym_DASH_GT,
    ACTIONS(5067), 1,
      anon_sym_DOT,
    ACTIONS(6973), 1,
      anon_sym_LPAREN,
    ACTIONS(7022), 1,
      anon_sym_LBRACK,
    ACTIONS(7026), 1,
      anon_sym_BANG,
    ACTIONS(7034), 1,
      anon_sym_SLASH,
    ACTIONS(7038), 1,
      anon_sym_GT_GT,
    ACTIONS(7042), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7046), 1,
      anon_sym_as,
    ACTIONS(7048), 1,
      anon_sym_is,
    ACTIONS(7050), 1,
      anon_sym_with,
    ACTIONS(7052), 1,
      anon_sym_CARET,
    ACTIONS(7054), 1,
      anon_sym_PIPE,
    ACTIONS(7056), 1,
      anon_sym_AMP,
    ACTIONS(7060), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7064), 1,
      anon_sym_QMARK,
    ACTIONS(7066), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7068), 1,
      anon_sym_QMARK_QMARK,
    STATE(3870), 1,
      sym_bracketed_argument_list,
    STATE(5721), 1,
      sym_argument_list,
    ACTIONS(7024), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7028), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7030), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7032), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7036), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7040), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7058), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5385), 6,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5145), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [82870] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3719), 1,
      anon_sym_COLON_COLON,
    STATE(5146), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4027), 12,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4024), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [82955] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6959), 1,
      anon_sym_as,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(6990), 1,
      anon_sym_SLASH,
    ACTIONS(6992), 1,
      anon_sym_AMP,
    ACTIONS(6996), 1,
      anon_sym_GT_GT,
    ACTIONS(7002), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7004), 1,
      anon_sym_is,
    ACTIONS(7010), 1,
      anon_sym_QMARK,
    ACTIONS(7012), 1,
      anon_sym_CARET,
    ACTIONS(7014), 1,
      anon_sym_PIPE,
    ACTIONS(7016), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7018), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7020), 1,
      anon_sym_QMARK_QMARK,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6984), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6986), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6988), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6994), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6998), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7000), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5337), 6,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
    STATE(5147), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [83092] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6959), 1,
      anon_sym_as,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(6990), 1,
      anon_sym_SLASH,
    ACTIONS(6992), 1,
      anon_sym_AMP,
    ACTIONS(6996), 1,
      anon_sym_GT_GT,
    ACTIONS(7002), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7004), 1,
      anon_sym_is,
    ACTIONS(7010), 1,
      anon_sym_QMARK,
    ACTIONS(7012), 1,
      anon_sym_CARET,
    ACTIONS(7014), 1,
      anon_sym_PIPE,
    ACTIONS(7016), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7018), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7020), 1,
      anon_sym_QMARK_QMARK,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6984), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6986), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6988), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6994), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6998), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7000), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6220), 6,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
    STATE(5148), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [83229] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5149), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3721), 12,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(3719), 29,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [83312] = 28,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(6990), 1,
      anon_sym_SLASH,
    ACTIONS(6996), 1,
      anon_sym_GT_GT,
    ACTIONS(7002), 1,
      anon_sym_DOT_DOT,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6986), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6988), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6994), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6116), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5150), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 16,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [83427] = 25,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(6990), 1,
      anon_sym_SLASH,
    ACTIONS(7002), 1,
      anon_sym_DOT_DOT,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6988), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6116), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5151), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 18,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [83536] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4953), 1,
      anon_sym_DASH_GT,
    ACTIONS(5067), 1,
      anon_sym_DOT,
    ACTIONS(6973), 1,
      anon_sym_LPAREN,
    ACTIONS(7022), 1,
      anon_sym_LBRACK,
    ACTIONS(7026), 1,
      anon_sym_BANG,
    ACTIONS(7034), 1,
      anon_sym_SLASH,
    ACTIONS(7038), 1,
      anon_sym_GT_GT,
    ACTIONS(7042), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7046), 1,
      anon_sym_as,
    ACTIONS(7048), 1,
      anon_sym_is,
    ACTIONS(7050), 1,
      anon_sym_with,
    ACTIONS(7052), 1,
      anon_sym_CARET,
    ACTIONS(7054), 1,
      anon_sym_PIPE,
    ACTIONS(7056), 1,
      anon_sym_AMP,
    ACTIONS(7060), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7064), 1,
      anon_sym_QMARK,
    ACTIONS(7066), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7068), 1,
      anon_sym_QMARK_QMARK,
    STATE(3870), 1,
      sym_bracketed_argument_list,
    STATE(5721), 1,
      sym_argument_list,
    ACTIONS(7024), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7028), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7030), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7032), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7036), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7040), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7058), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5396), 6,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5152), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [83673] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6959), 1,
      anon_sym_as,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(6990), 1,
      anon_sym_SLASH,
    ACTIONS(6992), 1,
      anon_sym_AMP,
    ACTIONS(6996), 1,
      anon_sym_GT_GT,
    ACTIONS(7002), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7004), 1,
      anon_sym_is,
    ACTIONS(7012), 1,
      anon_sym_CARET,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6116), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(6984), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6986), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6988), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6994), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6998), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7000), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5153), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 9,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [83802] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6959), 1,
      anon_sym_as,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(6990), 1,
      anon_sym_SLASH,
    ACTIONS(6996), 1,
      anon_sym_GT_GT,
    ACTIONS(7002), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7004), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6984), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6986), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6988), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6994), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6998), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7000), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6116), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5154), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 10,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [83927] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(6990), 1,
      anon_sym_SLASH,
    ACTIONS(7002), 1,
      anon_sym_DOT_DOT,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6986), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6988), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6116), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5155), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 18,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [84038] = 32,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6959), 1,
      anon_sym_as,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(6990), 1,
      anon_sym_SLASH,
    ACTIONS(6996), 1,
      anon_sym_GT_GT,
    ACTIONS(7002), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7004), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6984), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6986), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6988), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6994), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7000), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6116), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5156), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 12,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [84161] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4953), 1,
      anon_sym_DASH_GT,
    ACTIONS(5067), 1,
      anon_sym_DOT,
    ACTIONS(6973), 1,
      anon_sym_LPAREN,
    ACTIONS(7022), 1,
      anon_sym_LBRACK,
    ACTIONS(7026), 1,
      anon_sym_BANG,
    ACTIONS(7034), 1,
      anon_sym_SLASH,
    ACTIONS(7038), 1,
      anon_sym_GT_GT,
    ACTIONS(7042), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7046), 1,
      anon_sym_as,
    ACTIONS(7048), 1,
      anon_sym_is,
    ACTIONS(7050), 1,
      anon_sym_with,
    ACTIONS(7052), 1,
      anon_sym_CARET,
    ACTIONS(7054), 1,
      anon_sym_PIPE,
    ACTIONS(7056), 1,
      anon_sym_AMP,
    ACTIONS(7060), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7064), 1,
      anon_sym_QMARK,
    ACTIONS(7066), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7068), 1,
      anon_sym_QMARK_QMARK,
    STATE(3870), 1,
      sym_bracketed_argument_list,
    STATE(5721), 1,
      sym_argument_list,
    ACTIONS(7024), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7028), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7030), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7032), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7036), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7040), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7058), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6216), 6,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5157), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [84298] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6959), 1,
      anon_sym_as,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7076), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7080), 1,
      anon_sym_QMARK,
    ACTIONS(7086), 1,
      anon_sym_SLASH,
    ACTIONS(7088), 1,
      anon_sym_CARET,
    ACTIONS(7090), 1,
      anon_sym_PIPE,
    ACTIONS(7092), 1,
      anon_sym_AMP,
    ACTIONS(7096), 1,
      anon_sym_GT_GT,
    ACTIONS(7102), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7104), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7106), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7108), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7078), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7082), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7084), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7094), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7098), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7100), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6173), 6,
      anon_sym_SEMI,
      anon_sym_and,
      anon_sym_or,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(5158), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [84435] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4953), 1,
      anon_sym_DASH_GT,
    ACTIONS(5067), 1,
      anon_sym_DOT,
    ACTIONS(6973), 1,
      anon_sym_LPAREN,
    ACTIONS(7022), 1,
      anon_sym_LBRACK,
    ACTIONS(7026), 1,
      anon_sym_BANG,
    ACTIONS(7034), 1,
      anon_sym_SLASH,
    ACTIONS(7038), 1,
      anon_sym_GT_GT,
    ACTIONS(7042), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7046), 1,
      anon_sym_as,
    ACTIONS(7048), 1,
      anon_sym_is,
    ACTIONS(7050), 1,
      anon_sym_with,
    ACTIONS(7052), 1,
      anon_sym_CARET,
    ACTIONS(7054), 1,
      anon_sym_PIPE,
    ACTIONS(7056), 1,
      anon_sym_AMP,
    ACTIONS(7060), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7064), 1,
      anon_sym_QMARK,
    ACTIONS(7066), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7068), 1,
      anon_sym_QMARK_QMARK,
    STATE(3870), 1,
      sym_bracketed_argument_list,
    STATE(5721), 1,
      sym_argument_list,
    ACTIONS(7024), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7028), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7030), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7032), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7036), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7040), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7058), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5325), 6,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5159), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [84572] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7110), 1,
      anon_sym_into,
    STATE(5201), 1,
      aux_sym__query_body_repeat2,
    STATE(5160), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6383), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6381), 28,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [84659] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4953), 1,
      anon_sym_DASH_GT,
    ACTIONS(5067), 1,
      anon_sym_DOT,
    ACTIONS(6973), 1,
      anon_sym_LPAREN,
    ACTIONS(7022), 1,
      anon_sym_LBRACK,
    ACTIONS(7026), 1,
      anon_sym_BANG,
    ACTIONS(7034), 1,
      anon_sym_SLASH,
    ACTIONS(7038), 1,
      anon_sym_GT_GT,
    ACTIONS(7042), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7046), 1,
      anon_sym_as,
    ACTIONS(7048), 1,
      anon_sym_is,
    ACTIONS(7050), 1,
      anon_sym_with,
    ACTIONS(7052), 1,
      anon_sym_CARET,
    ACTIONS(7054), 1,
      anon_sym_PIPE,
    ACTIONS(7056), 1,
      anon_sym_AMP,
    ACTIONS(7060), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7064), 1,
      anon_sym_QMARK,
    ACTIONS(7066), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7068), 1,
      anon_sym_QMARK_QMARK,
    STATE(3870), 1,
      sym_bracketed_argument_list,
    STATE(5721), 1,
      sym_argument_list,
    ACTIONS(7024), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7028), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7030), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7032), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7036), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7040), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7058), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5510), 6,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5161), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [84796] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2983), 1,
      sym__identifier_token,
    ACTIONS(2995), 1,
      anon_sym_LPAREN,
    ACTIONS(3728), 1,
      anon_sym_delegate,
    ACTIONS(7008), 1,
      sym_predefined_type,
    ACTIONS(7112), 1,
      anon_sym_LBRACK,
    STATE(4443), 1,
      sym__reserved_identifier,
    STATE(4921), 1,
      sym_identifier,
    STATE(4959), 1,
      sym_generic_name,
    STATE(5125), 1,
      sym_array_type,
    STATE(8214), 1,
      sym__name,
    STATE(8572), 1,
      sym_tuple_type,
    STATE(8680), 1,
      sym__array_base_type,
    STATE(9721), 1,
      sym__pointer_base_type,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(8906), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(5162), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2987), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [84907] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4953), 1,
      anon_sym_DASH_GT,
    ACTIONS(5067), 1,
      anon_sym_DOT,
    ACTIONS(6973), 1,
      anon_sym_LPAREN,
    ACTIONS(7022), 1,
      anon_sym_LBRACK,
    ACTIONS(7026), 1,
      anon_sym_BANG,
    ACTIONS(7034), 1,
      anon_sym_SLASH,
    ACTIONS(7038), 1,
      anon_sym_GT_GT,
    ACTIONS(7042), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7046), 1,
      anon_sym_as,
    ACTIONS(7048), 1,
      anon_sym_is,
    ACTIONS(7050), 1,
      anon_sym_with,
    ACTIONS(7052), 1,
      anon_sym_CARET,
    ACTIONS(7054), 1,
      anon_sym_PIPE,
    ACTIONS(7056), 1,
      anon_sym_AMP,
    ACTIONS(7060), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7064), 1,
      anon_sym_QMARK,
    ACTIONS(7066), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7068), 1,
      anon_sym_QMARK_QMARK,
    STATE(3870), 1,
      sym_bracketed_argument_list,
    STATE(5721), 1,
      sym_argument_list,
    ACTIONS(7024), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7028), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7030), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7032), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7036), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7040), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7058), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5420), 6,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5163), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [85044] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4953), 1,
      anon_sym_DASH_GT,
    ACTIONS(5067), 1,
      anon_sym_DOT,
    ACTIONS(6973), 1,
      anon_sym_LPAREN,
    ACTIONS(7022), 1,
      anon_sym_LBRACK,
    ACTIONS(7026), 1,
      anon_sym_BANG,
    ACTIONS(7034), 1,
      anon_sym_SLASH,
    ACTIONS(7038), 1,
      anon_sym_GT_GT,
    ACTIONS(7042), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7046), 1,
      anon_sym_as,
    ACTIONS(7048), 1,
      anon_sym_is,
    ACTIONS(7050), 1,
      anon_sym_with,
    ACTIONS(7052), 1,
      anon_sym_CARET,
    ACTIONS(7054), 1,
      anon_sym_PIPE,
    ACTIONS(7056), 1,
      anon_sym_AMP,
    ACTIONS(7060), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7064), 1,
      anon_sym_QMARK,
    ACTIONS(7066), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7068), 1,
      anon_sym_QMARK_QMARK,
    STATE(3870), 1,
      sym_bracketed_argument_list,
    STATE(5721), 1,
      sym_argument_list,
    ACTIONS(7024), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7028), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7030), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7032), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7036), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7040), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7058), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6230), 6,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5164), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [85181] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6959), 1,
      anon_sym_as,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(6990), 1,
      anon_sym_SLASH,
    ACTIONS(6992), 1,
      anon_sym_AMP,
    ACTIONS(6996), 1,
      anon_sym_GT_GT,
    ACTIONS(7002), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7004), 1,
      anon_sym_is,
    ACTIONS(7012), 1,
      anon_sym_CARET,
    ACTIONS(7014), 1,
      anon_sym_PIPE,
    ACTIONS(7016), 1,
      anon_sym_AMP_AMP,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6984), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6986), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6988), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6994), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6998), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7000), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 8,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(5165), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [85314] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4953), 1,
      anon_sym_DASH_GT,
    ACTIONS(5067), 1,
      anon_sym_DOT,
    ACTIONS(6973), 1,
      anon_sym_LPAREN,
    ACTIONS(7022), 1,
      anon_sym_LBRACK,
    ACTIONS(7026), 1,
      anon_sym_BANG,
    ACTIONS(7034), 1,
      anon_sym_SLASH,
    ACTIONS(7038), 1,
      anon_sym_GT_GT,
    ACTIONS(7042), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7046), 1,
      anon_sym_as,
    ACTIONS(7048), 1,
      anon_sym_is,
    ACTIONS(7050), 1,
      anon_sym_with,
    ACTIONS(7052), 1,
      anon_sym_CARET,
    ACTIONS(7054), 1,
      anon_sym_PIPE,
    ACTIONS(7056), 1,
      anon_sym_AMP,
    ACTIONS(7060), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7064), 1,
      anon_sym_QMARK,
    ACTIONS(7066), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7068), 1,
      anon_sym_QMARK_QMARK,
    STATE(3870), 1,
      sym_bracketed_argument_list,
    STATE(5721), 1,
      sym_argument_list,
    ACTIONS(7024), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7028), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7030), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7032), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7036), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7040), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7058), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6173), 6,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5166), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [85451] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4953), 1,
      anon_sym_DASH_GT,
    ACTIONS(5067), 1,
      anon_sym_DOT,
    ACTIONS(6973), 1,
      anon_sym_LPAREN,
    ACTIONS(7022), 1,
      anon_sym_LBRACK,
    ACTIONS(7026), 1,
      anon_sym_BANG,
    ACTIONS(7034), 1,
      anon_sym_SLASH,
    ACTIONS(7038), 1,
      anon_sym_GT_GT,
    ACTIONS(7042), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7046), 1,
      anon_sym_as,
    ACTIONS(7048), 1,
      anon_sym_is,
    ACTIONS(7050), 1,
      anon_sym_with,
    ACTIONS(7052), 1,
      anon_sym_CARET,
    ACTIONS(7054), 1,
      anon_sym_PIPE,
    ACTIONS(7056), 1,
      anon_sym_AMP,
    ACTIONS(7060), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7064), 1,
      anon_sym_QMARK,
    ACTIONS(7066), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7068), 1,
      anon_sym_QMARK_QMARK,
    STATE(3870), 1,
      sym_bracketed_argument_list,
    STATE(5721), 1,
      sym_argument_list,
    ACTIONS(7024), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7028), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7030), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7032), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7036), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7040), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7058), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6236), 6,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5167), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [85588] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6959), 1,
      anon_sym_as,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7076), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7080), 1,
      anon_sym_QMARK,
    ACTIONS(7086), 1,
      anon_sym_SLASH,
    ACTIONS(7088), 1,
      anon_sym_CARET,
    ACTIONS(7090), 1,
      anon_sym_PIPE,
    ACTIONS(7092), 1,
      anon_sym_AMP,
    ACTIONS(7096), 1,
      anon_sym_GT_GT,
    ACTIONS(7102), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7104), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7106), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7108), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7078), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7082), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7084), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7094), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7098), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7100), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6220), 6,
      anon_sym_SEMI,
      anon_sym_and,
      anon_sym_or,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(5168), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [85725] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6959), 1,
      anon_sym_as,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(6990), 1,
      anon_sym_SLASH,
    ACTIONS(6992), 1,
      anon_sym_AMP,
    ACTIONS(6996), 1,
      anon_sym_GT_GT,
    ACTIONS(7002), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7004), 1,
      anon_sym_is,
    ACTIONS(7012), 1,
      anon_sym_CARET,
    ACTIONS(7014), 1,
      anon_sym_PIPE,
    ACTIONS(7016), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7018), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7020), 1,
      anon_sym_QMARK_QMARK,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6984), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6986), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6988), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6994), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6998), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7000), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 6,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
    STATE(5169), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [85862] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4953), 1,
      anon_sym_DASH_GT,
    ACTIONS(5067), 1,
      anon_sym_DOT,
    ACTIONS(6973), 1,
      anon_sym_LPAREN,
    ACTIONS(7022), 1,
      anon_sym_LBRACK,
    ACTIONS(7026), 1,
      anon_sym_BANG,
    ACTIONS(7034), 1,
      anon_sym_SLASH,
    ACTIONS(7042), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7050), 1,
      anon_sym_with,
    STATE(3870), 1,
      sym_bracketed_argument_list,
    STATE(5721), 1,
      sym_argument_list,
    ACTIONS(7028), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7030), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7032), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6116), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5170), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 18,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
  [85973] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4953), 1,
      anon_sym_DASH_GT,
    ACTIONS(5067), 1,
      anon_sym_DOT,
    ACTIONS(6973), 1,
      anon_sym_LPAREN,
    ACTIONS(7022), 1,
      anon_sym_LBRACK,
    ACTIONS(7026), 1,
      anon_sym_BANG,
    ACTIONS(7042), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7050), 1,
      anon_sym_with,
    STATE(3870), 1,
      sym_bracketed_argument_list,
    STATE(5721), 1,
      sym_argument_list,
    ACTIONS(7028), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5171), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6116), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6114), 20,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
  [86078] = 25,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4953), 1,
      anon_sym_DASH_GT,
    ACTIONS(5067), 1,
      anon_sym_DOT,
    ACTIONS(6973), 1,
      anon_sym_LPAREN,
    ACTIONS(7022), 1,
      anon_sym_LBRACK,
    ACTIONS(7026), 1,
      anon_sym_BANG,
    ACTIONS(7034), 1,
      anon_sym_SLASH,
    ACTIONS(7042), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7050), 1,
      anon_sym_with,
    STATE(3870), 1,
      sym_bracketed_argument_list,
    STATE(5721), 1,
      sym_argument_list,
    ACTIONS(7028), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7032), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6116), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5172), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 18,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
  [86187] = 28,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4953), 1,
      anon_sym_DASH_GT,
    ACTIONS(5067), 1,
      anon_sym_DOT,
    ACTIONS(6973), 1,
      anon_sym_LPAREN,
    ACTIONS(7022), 1,
      anon_sym_LBRACK,
    ACTIONS(7026), 1,
      anon_sym_BANG,
    ACTIONS(7034), 1,
      anon_sym_SLASH,
    ACTIONS(7038), 1,
      anon_sym_GT_GT,
    ACTIONS(7042), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7050), 1,
      anon_sym_with,
    STATE(3870), 1,
      sym_bracketed_argument_list,
    STATE(5721), 1,
      sym_argument_list,
    ACTIONS(7028), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7030), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7032), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7036), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6116), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5173), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 16,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
  [86302] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4953), 1,
      anon_sym_DASH_GT,
    ACTIONS(5067), 1,
      anon_sym_DOT,
    ACTIONS(6973), 1,
      anon_sym_LPAREN,
    ACTIONS(7022), 1,
      anon_sym_LBRACK,
    ACTIONS(7026), 1,
      anon_sym_BANG,
    ACTIONS(7034), 1,
      anon_sym_SLASH,
    ACTIONS(7038), 1,
      anon_sym_GT_GT,
    ACTIONS(7042), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7046), 1,
      anon_sym_as,
    ACTIONS(7048), 1,
      anon_sym_is,
    ACTIONS(7050), 1,
      anon_sym_with,
    ACTIONS(7052), 1,
      anon_sym_CARET,
    ACTIONS(7054), 1,
      anon_sym_PIPE,
    ACTIONS(7056), 1,
      anon_sym_AMP,
    ACTIONS(7060), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7064), 1,
      anon_sym_QMARK,
    ACTIONS(7066), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7068), 1,
      anon_sym_QMARK_QMARK,
    STATE(3870), 1,
      sym_bracketed_argument_list,
    STATE(5721), 1,
      sym_argument_list,
    ACTIONS(7024), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7028), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7030), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7032), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7036), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7040), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7058), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6284), 6,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5174), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [86439] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4953), 1,
      anon_sym_DASH_GT,
    ACTIONS(5067), 1,
      anon_sym_DOT,
    ACTIONS(6973), 1,
      anon_sym_LPAREN,
    ACTIONS(7022), 1,
      anon_sym_LBRACK,
    ACTIONS(7026), 1,
      anon_sym_BANG,
    ACTIONS(7044), 1,
      anon_sym_DOT_DOT,
    STATE(3870), 1,
      sym_bracketed_argument_list,
    STATE(5721), 1,
      sym_argument_list,
    ACTIONS(7028), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5175), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6122), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6120), 22,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [86540] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6959), 1,
      anon_sym_as,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7076), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7080), 1,
      anon_sym_QMARK,
    ACTIONS(7086), 1,
      anon_sym_SLASH,
    ACTIONS(7088), 1,
      anon_sym_CARET,
    ACTIONS(7090), 1,
      anon_sym_PIPE,
    ACTIONS(7092), 1,
      anon_sym_AMP,
    ACTIONS(7096), 1,
      anon_sym_GT_GT,
    ACTIONS(7102), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7104), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7106), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7108), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7078), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7082), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7084), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7094), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7098), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7100), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5337), 6,
      anon_sym_SEMI,
      anon_sym_and,
      anon_sym_or,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(5176), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [86677] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6959), 1,
      anon_sym_as,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7076), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7080), 1,
      anon_sym_QMARK,
    ACTIONS(7086), 1,
      anon_sym_SLASH,
    ACTIONS(7088), 1,
      anon_sym_CARET,
    ACTIONS(7090), 1,
      anon_sym_PIPE,
    ACTIONS(7092), 1,
      anon_sym_AMP,
    ACTIONS(7096), 1,
      anon_sym_GT_GT,
    ACTIONS(7102), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7104), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7106), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7108), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7078), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7082), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7084), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7094), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7098), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7100), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5385), 6,
      anon_sym_SEMI,
      anon_sym_and,
      anon_sym_or,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(5177), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [86814] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6959), 1,
      anon_sym_as,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7076), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7080), 1,
      anon_sym_QMARK,
    ACTIONS(7086), 1,
      anon_sym_SLASH,
    ACTIONS(7088), 1,
      anon_sym_CARET,
    ACTIONS(7090), 1,
      anon_sym_PIPE,
    ACTIONS(7092), 1,
      anon_sym_AMP,
    ACTIONS(7096), 1,
      anon_sym_GT_GT,
    ACTIONS(7102), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7104), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7106), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7108), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7078), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7082), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7084), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7094), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7098), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7100), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5396), 6,
      anon_sym_SEMI,
      anon_sym_and,
      anon_sym_or,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(5178), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [86951] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4953), 1,
      anon_sym_DASH_GT,
    ACTIONS(5067), 1,
      anon_sym_DOT,
    ACTIONS(6973), 1,
      anon_sym_LPAREN,
    ACTIONS(7022), 1,
      anon_sym_LBRACK,
    ACTIONS(7026), 1,
      anon_sym_BANG,
    ACTIONS(7034), 1,
      anon_sym_SLASH,
    ACTIONS(7038), 1,
      anon_sym_GT_GT,
    ACTIONS(7042), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7046), 1,
      anon_sym_as,
    ACTIONS(7048), 1,
      anon_sym_is,
    ACTIONS(7050), 1,
      anon_sym_with,
    ACTIONS(7052), 1,
      anon_sym_CARET,
    ACTIONS(7054), 1,
      anon_sym_PIPE,
    ACTIONS(7056), 1,
      anon_sym_AMP,
    ACTIONS(7060), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7064), 1,
      anon_sym_QMARK,
    ACTIONS(7066), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7068), 1,
      anon_sym_QMARK_QMARK,
    STATE(3870), 1,
      sym_bracketed_argument_list,
    STATE(5721), 1,
      sym_argument_list,
    ACTIONS(7024), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7028), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7030), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7032), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7036), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7040), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7058), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6274), 6,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5179), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [87088] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(7002), 1,
      anon_sym_DOT_DOT,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5180), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1147), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(1133), 22,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [87189] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6959), 1,
      anon_sym_as,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7076), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7080), 1,
      anon_sym_QMARK,
    ACTIONS(7086), 1,
      anon_sym_SLASH,
    ACTIONS(7088), 1,
      anon_sym_CARET,
    ACTIONS(7090), 1,
      anon_sym_PIPE,
    ACTIONS(7092), 1,
      anon_sym_AMP,
    ACTIONS(7096), 1,
      anon_sym_GT_GT,
    ACTIONS(7102), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7104), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7106), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7108), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7078), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7082), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7084), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7094), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7098), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7100), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6216), 6,
      anon_sym_SEMI,
      anon_sym_and,
      anon_sym_or,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(5181), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [87326] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4953), 1,
      anon_sym_DASH_GT,
    ACTIONS(5067), 1,
      anon_sym_DOT,
    ACTIONS(6973), 1,
      anon_sym_LPAREN,
    ACTIONS(7022), 1,
      anon_sym_LBRACK,
    ACTIONS(7026), 1,
      anon_sym_BANG,
    ACTIONS(7034), 1,
      anon_sym_SLASH,
    ACTIONS(7038), 1,
      anon_sym_GT_GT,
    ACTIONS(7042), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7046), 1,
      anon_sym_as,
    ACTIONS(7048), 1,
      anon_sym_is,
    ACTIONS(7050), 1,
      anon_sym_with,
    ACTIONS(7052), 1,
      anon_sym_CARET,
    ACTIONS(7054), 1,
      anon_sym_PIPE,
    ACTIONS(7056), 1,
      anon_sym_AMP,
    ACTIONS(7060), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7064), 1,
      anon_sym_QMARK,
    ACTIONS(7066), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7068), 1,
      anon_sym_QMARK_QMARK,
    STATE(3870), 1,
      sym_bracketed_argument_list,
    STATE(5721), 1,
      sym_argument_list,
    ACTIONS(7024), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7028), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7030), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7032), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7036), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7040), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7058), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6220), 6,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5182), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [87463] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7002), 1,
      anon_sym_DOT_DOT,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5183), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6116), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6114), 20,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [87568] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6959), 1,
      anon_sym_as,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7076), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7080), 1,
      anon_sym_QMARK,
    ACTIONS(7086), 1,
      anon_sym_SLASH,
    ACTIONS(7088), 1,
      anon_sym_CARET,
    ACTIONS(7090), 1,
      anon_sym_PIPE,
    ACTIONS(7092), 1,
      anon_sym_AMP,
    ACTIONS(7096), 1,
      anon_sym_GT_GT,
    ACTIONS(7102), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7104), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7106), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7108), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7078), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7082), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7084), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7094), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7098), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7100), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5325), 6,
      anon_sym_SEMI,
      anon_sym_and,
      anon_sym_or,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(5184), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [87705] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6959), 1,
      anon_sym_as,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7076), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7080), 1,
      anon_sym_QMARK,
    ACTIONS(7086), 1,
      anon_sym_SLASH,
    ACTIONS(7088), 1,
      anon_sym_CARET,
    ACTIONS(7090), 1,
      anon_sym_PIPE,
    ACTIONS(7092), 1,
      anon_sym_AMP,
    ACTIONS(7096), 1,
      anon_sym_GT_GT,
    ACTIONS(7102), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7104), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7106), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7108), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7078), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7082), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7084), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7094), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7098), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7100), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5510), 6,
      anon_sym_SEMI,
      anon_sym_and,
      anon_sym_or,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(5185), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [87842] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6959), 1,
      anon_sym_as,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7076), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7080), 1,
      anon_sym_QMARK,
    ACTIONS(7086), 1,
      anon_sym_SLASH,
    ACTIONS(7088), 1,
      anon_sym_CARET,
    ACTIONS(7090), 1,
      anon_sym_PIPE,
    ACTIONS(7092), 1,
      anon_sym_AMP,
    ACTIONS(7096), 1,
      anon_sym_GT_GT,
    ACTIONS(7102), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7104), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7106), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7108), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7078), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7082), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7084), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7094), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7098), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7100), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5420), 6,
      anon_sym_SEMI,
      anon_sym_and,
      anon_sym_or,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(5186), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [87979] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6959), 1,
      anon_sym_as,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7076), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7080), 1,
      anon_sym_QMARK,
    ACTIONS(7086), 1,
      anon_sym_SLASH,
    ACTIONS(7088), 1,
      anon_sym_CARET,
    ACTIONS(7090), 1,
      anon_sym_PIPE,
    ACTIONS(7092), 1,
      anon_sym_AMP,
    ACTIONS(7096), 1,
      anon_sym_GT_GT,
    ACTIONS(7102), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7104), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7106), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7108), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7078), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7082), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7084), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7094), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7098), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7100), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6230), 6,
      anon_sym_SEMI,
      anon_sym_and,
      anon_sym_or,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(5187), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [88116] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7110), 1,
      anon_sym_into,
    STATE(5189), 1,
      aux_sym__query_body_repeat2,
    STATE(5188), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6448), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6446), 28,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [88203] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7110), 1,
      anon_sym_into,
    STATE(5201), 1,
      aux_sym__query_body_repeat2,
    STATE(5189), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6420), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6418), 28,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [88290] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7110), 1,
      anon_sym_into,
    STATE(5160), 1,
      aux_sym__query_body_repeat2,
    STATE(5190), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6420), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6418), 28,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [88377] = 28,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7076), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7086), 1,
      anon_sym_SLASH,
    ACTIONS(7096), 1,
      anon_sym_GT_GT,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7082), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7084), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7094), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6116), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5191), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 16,
      anon_sym_SEMI,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [88492] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5298), 1,
      anon_sym_LBRACK,
    ACTIONS(7114), 1,
      anon_sym_LBRACE,
    ACTIONS(7117), 1,
      anon_sym_QMARK,
    STATE(5671), 1,
      sym_initializer_expression,
    STATE(5192), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5308), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5302), 27,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [88583] = 25,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7076), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7086), 1,
      anon_sym_SLASH,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7084), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6116), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5193), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 18,
      anon_sym_SEMI,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [88692] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(7076), 1,
      anon_sym_DOT_DOT,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5194), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6122), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6120), 22,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [88793] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4953), 1,
      anon_sym_DASH_GT,
    ACTIONS(5067), 1,
      anon_sym_DOT,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6973), 1,
      anon_sym_LPAREN,
    ACTIONS(7022), 1,
      anon_sym_LBRACK,
    ACTIONS(7026), 1,
      anon_sym_BANG,
    ACTIONS(7034), 1,
      anon_sym_SLASH,
    ACTIONS(7038), 1,
      anon_sym_GT_GT,
    ACTIONS(7042), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7046), 1,
      anon_sym_as,
    ACTIONS(7048), 1,
      anon_sym_is,
    ACTIONS(7050), 1,
      anon_sym_with,
    ACTIONS(7052), 1,
      anon_sym_CARET,
    ACTIONS(7054), 1,
      anon_sym_PIPE,
    ACTIONS(7056), 1,
      anon_sym_AMP,
    ACTIONS(7060), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7066), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7068), 1,
      anon_sym_QMARK_QMARK,
    STATE(3870), 1,
      sym_bracketed_argument_list,
    STATE(5721), 1,
      sym_argument_list,
    ACTIONS(7024), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7028), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7030), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7032), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7036), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7040), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7058), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6114), 6,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5195), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [88930] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7076), 1,
      anon_sym_DOT_DOT,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5196), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6116), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6114), 20,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [89035] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6959), 1,
      anon_sym_as,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7076), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7086), 1,
      anon_sym_SLASH,
    ACTIONS(7092), 1,
      anon_sym_AMP,
    ACTIONS(7096), 1,
      anon_sym_GT_GT,
    ACTIONS(7108), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6116), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7078), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7082), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7084), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7094), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7098), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7100), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5197), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 10,
      anon_sym_SEMI,
      anon_sym_CARET,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [89162] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6959), 1,
      anon_sym_as,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7076), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7086), 1,
      anon_sym_SLASH,
    ACTIONS(7088), 1,
      anon_sym_CARET,
    ACTIONS(7092), 1,
      anon_sym_AMP,
    ACTIONS(7096), 1,
      anon_sym_GT_GT,
    ACTIONS(7108), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6116), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7078), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7082), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7084), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7094), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7098), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7100), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5198), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 9,
      anon_sym_SEMI,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [89291] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6959), 1,
      anon_sym_as,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7076), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7086), 1,
      anon_sym_SLASH,
    ACTIONS(7096), 1,
      anon_sym_GT_GT,
    ACTIONS(7108), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7078), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7082), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7084), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7094), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7098), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7100), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6116), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5199), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 10,
      anon_sym_SEMI,
      anon_sym_CARET,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [89416] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7076), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7086), 1,
      anon_sym_SLASH,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7082), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7084), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6116), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5200), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 18,
      anon_sym_SEMI,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [89527] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7121), 1,
      anon_sym_into,
    STATE(5201), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym__query_body_repeat2,
    ACTIONS(6376), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6374), 28,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [89612] = 32,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6959), 1,
      anon_sym_as,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7076), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7086), 1,
      anon_sym_SLASH,
    ACTIONS(7096), 1,
      anon_sym_GT_GT,
    ACTIONS(7108), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7078), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7082), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7084), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7094), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7100), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6116), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5202), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 12,
      anon_sym_SEMI,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [89735] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6959), 1,
      anon_sym_as,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7076), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7086), 1,
      anon_sym_SLASH,
    ACTIONS(7088), 1,
      anon_sym_CARET,
    ACTIONS(7090), 1,
      anon_sym_PIPE,
    ACTIONS(7092), 1,
      anon_sym_AMP,
    ACTIONS(7096), 1,
      anon_sym_GT_GT,
    ACTIONS(7108), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7078), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7082), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7084), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7094), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7098), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7100), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5203), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 9,
      anon_sym_SEMI,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [89866] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6959), 1,
      anon_sym_as,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7076), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7086), 1,
      anon_sym_SLASH,
    ACTIONS(7088), 1,
      anon_sym_CARET,
    ACTIONS(7090), 1,
      anon_sym_PIPE,
    ACTIONS(7092), 1,
      anon_sym_AMP,
    ACTIONS(7096), 1,
      anon_sym_GT_GT,
    ACTIONS(7102), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7108), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7078), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7082), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7084), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7094), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7098), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7100), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 8,
      anon_sym_SEMI,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(5204), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [89999] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2983), 1,
      sym__identifier_token,
    ACTIONS(5657), 1,
      anon_sym_ref,
    STATE(4443), 1,
      sym__reserved_identifier,
    STATE(4921), 1,
      sym_identifier,
    STATE(4959), 1,
      sym_generic_name,
    STATE(8582), 1,
      sym__name,
    STATE(8715), 1,
      sym_ref_type,
    STATE(8716), 1,
      sym__scoped_base_type,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    ACTIONS(3719), 8,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
    STATE(5205), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2987), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [90100] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6959), 1,
      anon_sym_as,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7076), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7086), 1,
      anon_sym_SLASH,
    ACTIONS(7088), 1,
      anon_sym_CARET,
    ACTIONS(7090), 1,
      anon_sym_PIPE,
    ACTIONS(7092), 1,
      anon_sym_AMP,
    ACTIONS(7096), 1,
      anon_sym_GT_GT,
    ACTIONS(7102), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7104), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7106), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7108), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7078), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7082), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7084), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7094), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7098), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7100), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 6,
      anon_sym_SEMI,
      anon_sym_and,
      anon_sym_or,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(5206), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [90237] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2983), 1,
      sym__identifier_token,
    ACTIONS(6389), 1,
      anon_sym_ref,
    STATE(4443), 1,
      sym__reserved_identifier,
    STATE(4921), 1,
      sym_identifier,
    STATE(4959), 1,
      sym_generic_name,
    STATE(8582), 1,
      sym__name,
    STATE(8715), 1,
      sym_ref_type,
    STATE(8716), 1,
      sym__scoped_base_type,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    ACTIONS(3719), 8,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
    STATE(5207), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2987), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [90338] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6959), 1,
      anon_sym_as,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7076), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7080), 1,
      anon_sym_QMARK,
    ACTIONS(7086), 1,
      anon_sym_SLASH,
    ACTIONS(7088), 1,
      anon_sym_CARET,
    ACTIONS(7090), 1,
      anon_sym_PIPE,
    ACTIONS(7092), 1,
      anon_sym_AMP,
    ACTIONS(7096), 1,
      anon_sym_GT_GT,
    ACTIONS(7102), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7104), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7106), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7108), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7078), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7082), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7084), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7094), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7098), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7100), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6236), 6,
      anon_sym_SEMI,
      anon_sym_and,
      anon_sym_or,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(5208), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [90475] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4953), 1,
      anon_sym_DASH_GT,
    ACTIONS(5067), 1,
      anon_sym_DOT,
    ACTIONS(6973), 1,
      anon_sym_LPAREN,
    ACTIONS(7022), 1,
      anon_sym_LBRACK,
    ACTIONS(7026), 1,
      anon_sym_BANG,
    ACTIONS(7044), 1,
      anon_sym_DOT_DOT,
    STATE(3870), 1,
      sym_bracketed_argument_list,
    STATE(5721), 1,
      sym_argument_list,
    ACTIONS(7028), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5209), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1147), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(1133), 22,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [90576] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(7124), 1,
      anon_sym_DOT_DOT,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5210), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6122), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6120), 21,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [90676] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5211), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4074), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4076), 29,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [90758] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7126), 1,
      anon_sym_into,
    STATE(5356), 1,
      aux_sym__query_body_repeat2,
    STATE(5212), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6420), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6418), 27,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [90844] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(6695), 1,
      anon_sym_as,
    ACTIONS(7130), 1,
      anon_sym_QMARK,
    ACTIONS(7136), 1,
      anon_sym_SLASH,
    ACTIONS(7138), 1,
      anon_sym_CARET,
    ACTIONS(7140), 1,
      anon_sym_PIPE,
    ACTIONS(7142), 1,
      anon_sym_AMP,
    ACTIONS(7146), 1,
      anon_sym_GT_GT,
    ACTIONS(7152), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7154), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7156), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7158), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7160), 1,
      anon_sym_is,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7128), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7132), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7134), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7144), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7148), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7150), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5337), 5,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_into,
    STATE(5213), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [90980] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(6695), 1,
      anon_sym_as,
    ACTIONS(7130), 1,
      anon_sym_QMARK,
    ACTIONS(7136), 1,
      anon_sym_SLASH,
    ACTIONS(7138), 1,
      anon_sym_CARET,
    ACTIONS(7140), 1,
      anon_sym_PIPE,
    ACTIONS(7142), 1,
      anon_sym_AMP,
    ACTIONS(7146), 1,
      anon_sym_GT_GT,
    ACTIONS(7152), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7154), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7156), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7158), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7160), 1,
      anon_sym_is,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7128), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7132), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7134), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7144), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7148), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7150), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5385), 5,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_into,
    STATE(5214), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [91116] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(6695), 1,
      anon_sym_as,
    ACTIONS(7130), 1,
      anon_sym_QMARK,
    ACTIONS(7136), 1,
      anon_sym_SLASH,
    ACTIONS(7138), 1,
      anon_sym_CARET,
    ACTIONS(7140), 1,
      anon_sym_PIPE,
    ACTIONS(7142), 1,
      anon_sym_AMP,
    ACTIONS(7146), 1,
      anon_sym_GT_GT,
    ACTIONS(7152), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7154), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7156), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7158), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7160), 1,
      anon_sym_is,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7128), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7132), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7134), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7144), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7148), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7150), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5396), 5,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_into,
    STATE(5215), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [91252] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4953), 1,
      anon_sym_DASH_GT,
    ACTIONS(5067), 1,
      anon_sym_DOT,
    ACTIONS(6973), 1,
      anon_sym_LPAREN,
    ACTIONS(7022), 1,
      anon_sym_LBRACK,
    ACTIONS(7026), 1,
      anon_sym_BANG,
    ACTIONS(7042), 1,
      anon_sym_switch,
    ACTIONS(7050), 1,
      anon_sym_with,
    ACTIONS(7166), 1,
      anon_sym_SLASH,
    ACTIONS(7168), 1,
      anon_sym_DOT_DOT,
    STATE(3870), 1,
      sym_bracketed_argument_list,
    STATE(5721), 1,
      sym_argument_list,
    ACTIONS(7028), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7162), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7164), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6116), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5216), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 17,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [91362] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4953), 1,
      anon_sym_DASH_GT,
    ACTIONS(5067), 1,
      anon_sym_DOT,
    ACTIONS(6973), 1,
      anon_sym_LPAREN,
    ACTIONS(7022), 1,
      anon_sym_LBRACK,
    ACTIONS(7026), 1,
      anon_sym_BANG,
    ACTIONS(7042), 1,
      anon_sym_switch,
    ACTIONS(7050), 1,
      anon_sym_with,
    ACTIONS(7168), 1,
      anon_sym_DOT_DOT,
    STATE(3870), 1,
      sym_bracketed_argument_list,
    STATE(5721), 1,
      sym_argument_list,
    ACTIONS(7028), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5217), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6116), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6114), 19,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [91466] = 25,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4953), 1,
      anon_sym_DASH_GT,
    ACTIONS(5067), 1,
      anon_sym_DOT,
    ACTIONS(6973), 1,
      anon_sym_LPAREN,
    ACTIONS(7022), 1,
      anon_sym_LBRACK,
    ACTIONS(7026), 1,
      anon_sym_BANG,
    ACTIONS(7042), 1,
      anon_sym_switch,
    ACTIONS(7050), 1,
      anon_sym_with,
    ACTIONS(7166), 1,
      anon_sym_SLASH,
    ACTIONS(7168), 1,
      anon_sym_DOT_DOT,
    STATE(3870), 1,
      sym_bracketed_argument_list,
    STATE(5721), 1,
      sym_argument_list,
    ACTIONS(7028), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7164), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6116), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5218), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 17,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [91574] = 28,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4953), 1,
      anon_sym_DASH_GT,
    ACTIONS(5067), 1,
      anon_sym_DOT,
    ACTIONS(6973), 1,
      anon_sym_LPAREN,
    ACTIONS(7022), 1,
      anon_sym_LBRACK,
    ACTIONS(7026), 1,
      anon_sym_BANG,
    ACTIONS(7042), 1,
      anon_sym_switch,
    ACTIONS(7050), 1,
      anon_sym_with,
    ACTIONS(7166), 1,
      anon_sym_SLASH,
    ACTIONS(7168), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7172), 1,
      anon_sym_GT_GT,
    STATE(3870), 1,
      sym_bracketed_argument_list,
    STATE(5721), 1,
      sym_argument_list,
    ACTIONS(7028), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7162), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7164), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7170), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6116), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5219), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 15,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [91688] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(6695), 1,
      anon_sym_as,
    ACTIONS(7130), 1,
      anon_sym_QMARK,
    ACTIONS(7136), 1,
      anon_sym_SLASH,
    ACTIONS(7138), 1,
      anon_sym_CARET,
    ACTIONS(7140), 1,
      anon_sym_PIPE,
    ACTIONS(7142), 1,
      anon_sym_AMP,
    ACTIONS(7146), 1,
      anon_sym_GT_GT,
    ACTIONS(7152), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7154), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7156), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7158), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7160), 1,
      anon_sym_is,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7128), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7132), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7134), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7144), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7148), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7150), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6216), 5,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_into,
    STATE(5220), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [91824] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(6695), 1,
      anon_sym_as,
    ACTIONS(7130), 1,
      anon_sym_QMARK,
    ACTIONS(7136), 1,
      anon_sym_SLASH,
    ACTIONS(7138), 1,
      anon_sym_CARET,
    ACTIONS(7140), 1,
      anon_sym_PIPE,
    ACTIONS(7142), 1,
      anon_sym_AMP,
    ACTIONS(7146), 1,
      anon_sym_GT_GT,
    ACTIONS(7152), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7154), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7156), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7158), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7160), 1,
      anon_sym_is,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7128), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7132), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7134), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7144), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7148), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7150), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5325), 5,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_into,
    STATE(5221), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [91960] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(7174), 1,
      anon_sym_DOT_DOT,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5222), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1147), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(1133), 21,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [92060] = 42,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2585), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(2587), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7178), 1,
      anon_sym_QMARK,
    ACTIONS(7184), 1,
      anon_sym_SLASH,
    ACTIONS(7186), 1,
      anon_sym_CARET,
    ACTIONS(7188), 1,
      anon_sym_PIPE,
    ACTIONS(7190), 1,
      anon_sym_AMP,
    ACTIONS(7194), 1,
      anon_sym_GT_GT,
    ACTIONS(7200), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7202), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7204), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7206), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7210), 1,
      anon_sym_is,
    ACTIONS(7212), 1,
      aux_sym_preproc_if_token3,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7176), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7180), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7182), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7192), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7196), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7198), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(9852), 2,
      sym_preproc_else_in_expression,
      sym_preproc_elif_in_expression,
    STATE(5223), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [92202] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7126), 1,
      anon_sym_into,
    STATE(5240), 1,
      aux_sym__query_body_repeat2,
    STATE(5224), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6420), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6418), 27,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [92288] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(6695), 1,
      anon_sym_as,
    ACTIONS(7130), 1,
      anon_sym_QMARK,
    ACTIONS(7136), 1,
      anon_sym_SLASH,
    ACTIONS(7138), 1,
      anon_sym_CARET,
    ACTIONS(7140), 1,
      anon_sym_PIPE,
    ACTIONS(7142), 1,
      anon_sym_AMP,
    ACTIONS(7146), 1,
      anon_sym_GT_GT,
    ACTIONS(7152), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7154), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7156), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7158), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7160), 1,
      anon_sym_is,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7128), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7132), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7134), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7144), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7148), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7150), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5510), 5,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_into,
    STATE(5225), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [92424] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(6695), 1,
      anon_sym_as,
    ACTIONS(7130), 1,
      anon_sym_QMARK,
    ACTIONS(7136), 1,
      anon_sym_SLASH,
    ACTIONS(7138), 1,
      anon_sym_CARET,
    ACTIONS(7140), 1,
      anon_sym_PIPE,
    ACTIONS(7142), 1,
      anon_sym_AMP,
    ACTIONS(7146), 1,
      anon_sym_GT_GT,
    ACTIONS(7152), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7154), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7156), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7158), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7160), 1,
      anon_sym_is,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7128), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7132), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7134), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7144), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7148), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7150), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5420), 5,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_into,
    STATE(5226), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [92560] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(6695), 1,
      anon_sym_as,
    ACTIONS(7130), 1,
      anon_sym_QMARK,
    ACTIONS(7136), 1,
      anon_sym_SLASH,
    ACTIONS(7138), 1,
      anon_sym_CARET,
    ACTIONS(7140), 1,
      anon_sym_PIPE,
    ACTIONS(7142), 1,
      anon_sym_AMP,
    ACTIONS(7146), 1,
      anon_sym_GT_GT,
    ACTIONS(7152), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7154), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7156), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7158), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7160), 1,
      anon_sym_is,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7128), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7132), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7134), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7144), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7148), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7150), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6230), 5,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_into,
    STATE(5227), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [92696] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(7152), 1,
      anon_sym_DOT_DOT,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5228), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6122), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6120), 21,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [92796] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4953), 1,
      anon_sym_DASH_GT,
    ACTIONS(5067), 1,
      anon_sym_DOT,
    ACTIONS(6973), 1,
      anon_sym_LPAREN,
    ACTIONS(7022), 1,
      anon_sym_LBRACK,
    ACTIONS(7026), 1,
      anon_sym_BANG,
    ACTIONS(7042), 1,
      anon_sym_switch,
    ACTIONS(7050), 1,
      anon_sym_with,
    ACTIONS(7166), 1,
      anon_sym_SLASH,
    ACTIONS(7168), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7172), 1,
      anon_sym_GT_GT,
    ACTIONS(7216), 1,
      anon_sym_QMARK,
    ACTIONS(7218), 1,
      anon_sym_CARET,
    ACTIONS(7220), 1,
      anon_sym_PIPE,
    ACTIONS(7222), 1,
      anon_sym_AMP,
    ACTIONS(7228), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7230), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7232), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7234), 1,
      anon_sym_as,
    ACTIONS(7236), 1,
      anon_sym_is,
    STATE(3870), 1,
      sym_bracketed_argument_list,
    STATE(5721), 1,
      sym_argument_list,
    ACTIONS(7028), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7162), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7164), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7170), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7214), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7224), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7226), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5420), 5,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_and,
      anon_sym_or,
    STATE(5229), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [92932] = 28,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7124), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7242), 1,
      anon_sym_SLASH,
    ACTIONS(7246), 1,
      anon_sym_GT_GT,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7238), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7240), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7244), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6116), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5230), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 15,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
  [93046] = 25,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7124), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7242), 1,
      anon_sym_SLASH,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7240), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6116), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5231), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 17,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
  [93154] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7124), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7242), 1,
      anon_sym_SLASH,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7238), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7240), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6116), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5232), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 17,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
  [93264] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7248), 1,
      anon_sym_LT,
    STATE(2736), 1,
      sym_type_argument_list,
    STATE(5233), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4076), 10,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_EQ_GT,
    ACTIONS(4074), 28,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_operator,
      anon_sym_this,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [93350] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7250), 1,
      anon_sym_LBRACK,
    ACTIONS(7252), 1,
      anon_sym_STAR,
    STATE(5234), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4424), 10,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_GT,
      anon_sym_EQ_GT,
    ACTIONS(4422), 28,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_operator,
      anon_sym_this,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [93436] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4953), 1,
      anon_sym_DASH_GT,
    ACTIONS(5067), 1,
      anon_sym_DOT,
    ACTIONS(6973), 1,
      anon_sym_LPAREN,
    ACTIONS(7022), 1,
      anon_sym_LBRACK,
    ACTIONS(7026), 1,
      anon_sym_BANG,
    ACTIONS(7042), 1,
      anon_sym_switch,
    ACTIONS(7050), 1,
      anon_sym_with,
    ACTIONS(7166), 1,
      anon_sym_SLASH,
    ACTIONS(7168), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7172), 1,
      anon_sym_GT_GT,
    ACTIONS(7216), 1,
      anon_sym_QMARK,
    ACTIONS(7218), 1,
      anon_sym_CARET,
    ACTIONS(7220), 1,
      anon_sym_PIPE,
    ACTIONS(7222), 1,
      anon_sym_AMP,
    ACTIONS(7228), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7230), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7232), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7234), 1,
      anon_sym_as,
    ACTIONS(7236), 1,
      anon_sym_is,
    STATE(3870), 1,
      sym_bracketed_argument_list,
    STATE(5721), 1,
      sym_argument_list,
    ACTIONS(7028), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7162), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7164), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7170), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7214), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7224), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7226), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6220), 5,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_and,
      anon_sym_or,
    STATE(5235), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [93572] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(6488), 1,
      anon_sym_ref,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(2738), 1,
      sym_generic_name,
    STATE(2899), 1,
      sym_ref_type,
    STATE(2907), 1,
      sym__scoped_base_type,
    STATE(5368), 1,
      sym_identifier,
    STATE(6160), 1,
      sym__name,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    ACTIONS(3719), 7,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
    STATE(5236), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [93672] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7250), 1,
      anon_sym_LBRACK,
    ACTIONS(7252), 1,
      anon_sym_STAR,
    ACTIONS(7254), 1,
      anon_sym_QMARK,
    STATE(5237), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4424), 9,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
    ACTIONS(4422), 28,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_operator,
      anon_sym_this,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [93760] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7124), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7242), 1,
      anon_sym_SLASH,
    ACTIONS(7246), 1,
      anon_sym_GT_GT,
    ACTIONS(7258), 1,
      anon_sym_QMARK,
    ACTIONS(7260), 1,
      anon_sym_CARET,
    ACTIONS(7262), 1,
      anon_sym_PIPE,
    ACTIONS(7264), 1,
      anon_sym_AMP,
    ACTIONS(7270), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7272), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7274), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7276), 1,
      anon_sym_as,
    ACTIONS(7278), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7238), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7240), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7244), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7256), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7266), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7268), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6284), 5,
      anon_sym_COLON,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5238), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [93896] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7124), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7242), 1,
      anon_sym_SLASH,
    ACTIONS(7246), 1,
      anon_sym_GT_GT,
    ACTIONS(7258), 1,
      anon_sym_QMARK,
    ACTIONS(7260), 1,
      anon_sym_CARET,
    ACTIONS(7262), 1,
      anon_sym_PIPE,
    ACTIONS(7264), 1,
      anon_sym_AMP,
    ACTIONS(7270), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7272), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7274), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7276), 1,
      anon_sym_as,
    ACTIONS(7278), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7238), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7240), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7244), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7256), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7266), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7268), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6274), 5,
      anon_sym_COLON,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5239), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [94032] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7126), 1,
      anon_sym_into,
    STATE(5356), 1,
      aux_sym__query_body_repeat2,
    STATE(5240), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6383), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6381), 27,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [94118] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7124), 1,
      anon_sym_DOT_DOT,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5241), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6116), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6114), 19,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
  [94222] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4953), 1,
      anon_sym_DASH_GT,
    ACTIONS(5067), 1,
      anon_sym_DOT,
    ACTIONS(6973), 1,
      anon_sym_LPAREN,
    ACTIONS(7022), 1,
      anon_sym_LBRACK,
    ACTIONS(7026), 1,
      anon_sym_BANG,
    ACTIONS(7042), 1,
      anon_sym_switch,
    ACTIONS(7050), 1,
      anon_sym_with,
    ACTIONS(7166), 1,
      anon_sym_SLASH,
    ACTIONS(7168), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7172), 1,
      anon_sym_GT_GT,
    ACTIONS(7216), 1,
      anon_sym_QMARK,
    ACTIONS(7218), 1,
      anon_sym_CARET,
    ACTIONS(7220), 1,
      anon_sym_PIPE,
    ACTIONS(7222), 1,
      anon_sym_AMP,
    ACTIONS(7228), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7230), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7232), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7234), 1,
      anon_sym_as,
    ACTIONS(7236), 1,
      anon_sym_is,
    STATE(3870), 1,
      sym_bracketed_argument_list,
    STATE(5721), 1,
      sym_argument_list,
    ACTIONS(7028), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7162), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7164), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7170), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7214), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7224), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7226), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6230), 5,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_and,
      anon_sym_or,
    STATE(5242), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [94358] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7280), 1,
      anon_sym_and,
    ACTIONS(7282), 1,
      anon_sym_or,
    STATE(5243), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6609), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6607), 27,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [94444] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4953), 1,
      anon_sym_DASH_GT,
    ACTIONS(5067), 1,
      anon_sym_DOT,
    ACTIONS(6973), 1,
      anon_sym_LPAREN,
    ACTIONS(7022), 1,
      anon_sym_LBRACK,
    ACTIONS(7026), 1,
      anon_sym_BANG,
    ACTIONS(7168), 1,
      anon_sym_DOT_DOT,
    STATE(3870), 1,
      sym_bracketed_argument_list,
    STATE(5721), 1,
      sym_argument_list,
    ACTIONS(7028), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5244), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6122), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6120), 21,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [94544] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5245), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4478), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4480), 29,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [94626] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4953), 1,
      anon_sym_DASH_GT,
    ACTIONS(5067), 1,
      anon_sym_DOT,
    ACTIONS(6973), 1,
      anon_sym_LPAREN,
    ACTIONS(7022), 1,
      anon_sym_LBRACK,
    ACTIONS(7026), 1,
      anon_sym_BANG,
    ACTIONS(7042), 1,
      anon_sym_switch,
    ACTIONS(7050), 1,
      anon_sym_with,
    ACTIONS(7166), 1,
      anon_sym_SLASH,
    ACTIONS(7168), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7172), 1,
      anon_sym_GT_GT,
    ACTIONS(7216), 1,
      anon_sym_QMARK,
    ACTIONS(7218), 1,
      anon_sym_CARET,
    ACTIONS(7220), 1,
      anon_sym_PIPE,
    ACTIONS(7222), 1,
      anon_sym_AMP,
    ACTIONS(7228), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7230), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7232), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7234), 1,
      anon_sym_as,
    ACTIONS(7236), 1,
      anon_sym_is,
    STATE(3870), 1,
      sym_bracketed_argument_list,
    STATE(5721), 1,
      sym_argument_list,
    ACTIONS(7028), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7162), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7164), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7170), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7214), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7224), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7226), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5510), 5,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_and,
      anon_sym_or,
    STATE(5246), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [94762] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4953), 1,
      anon_sym_DASH_GT,
    ACTIONS(5067), 1,
      anon_sym_DOT,
    ACTIONS(6973), 1,
      anon_sym_LPAREN,
    ACTIONS(7022), 1,
      anon_sym_LBRACK,
    ACTIONS(7026), 1,
      anon_sym_BANG,
    ACTIONS(7042), 1,
      anon_sym_switch,
    ACTIONS(7050), 1,
      anon_sym_with,
    ACTIONS(7166), 1,
      anon_sym_SLASH,
    ACTIONS(7168), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7172), 1,
      anon_sym_GT_GT,
    ACTIONS(7216), 1,
      anon_sym_QMARK,
    ACTIONS(7218), 1,
      anon_sym_CARET,
    ACTIONS(7220), 1,
      anon_sym_PIPE,
    ACTIONS(7222), 1,
      anon_sym_AMP,
    ACTIONS(7228), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7230), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7232), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7234), 1,
      anon_sym_as,
    ACTIONS(7236), 1,
      anon_sym_is,
    STATE(3870), 1,
      sym_bracketed_argument_list,
    STATE(5721), 1,
      sym_argument_list,
    ACTIONS(7028), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7162), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7164), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7170), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7214), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7224), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7226), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5325), 5,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_and,
      anon_sym_or,
    STATE(5247), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [94898] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4953), 1,
      anon_sym_DASH_GT,
    ACTIONS(5067), 1,
      anon_sym_DOT,
    ACTIONS(6973), 1,
      anon_sym_LPAREN,
    ACTIONS(7022), 1,
      anon_sym_LBRACK,
    ACTIONS(7026), 1,
      anon_sym_BANG,
    ACTIONS(7042), 1,
      anon_sym_switch,
    ACTIONS(7050), 1,
      anon_sym_with,
    ACTIONS(7166), 1,
      anon_sym_SLASH,
    ACTIONS(7168), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7172), 1,
      anon_sym_GT_GT,
    ACTIONS(7216), 1,
      anon_sym_QMARK,
    ACTIONS(7218), 1,
      anon_sym_CARET,
    ACTIONS(7220), 1,
      anon_sym_PIPE,
    ACTIONS(7222), 1,
      anon_sym_AMP,
    ACTIONS(7228), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7230), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7232), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7234), 1,
      anon_sym_as,
    ACTIONS(7236), 1,
      anon_sym_is,
    STATE(3870), 1,
      sym_bracketed_argument_list,
    STATE(5721), 1,
      sym_argument_list,
    ACTIONS(7028), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7162), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7164), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7170), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7214), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7224), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7226), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6216), 5,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_and,
      anon_sym_or,
    STATE(5248), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [95034] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4953), 1,
      anon_sym_DASH_GT,
    ACTIONS(5067), 1,
      anon_sym_DOT,
    ACTIONS(6973), 1,
      anon_sym_LPAREN,
    ACTIONS(7022), 1,
      anon_sym_LBRACK,
    ACTIONS(7026), 1,
      anon_sym_BANG,
    ACTIONS(7042), 1,
      anon_sym_switch,
    ACTIONS(7050), 1,
      anon_sym_with,
    ACTIONS(7166), 1,
      anon_sym_SLASH,
    ACTIONS(7168), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7172), 1,
      anon_sym_GT_GT,
    ACTIONS(7216), 1,
      anon_sym_QMARK,
    ACTIONS(7218), 1,
      anon_sym_CARET,
    ACTIONS(7220), 1,
      anon_sym_PIPE,
    ACTIONS(7222), 1,
      anon_sym_AMP,
    ACTIONS(7228), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7230), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7232), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7234), 1,
      anon_sym_as,
    ACTIONS(7236), 1,
      anon_sym_is,
    STATE(3870), 1,
      sym_bracketed_argument_list,
    STATE(5721), 1,
      sym_argument_list,
    ACTIONS(7028), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7162), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7164), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7170), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7214), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7224), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7226), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5396), 5,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_and,
      anon_sym_or,
    STATE(5249), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [95170] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4953), 1,
      anon_sym_DASH_GT,
    ACTIONS(5067), 1,
      anon_sym_DOT,
    ACTIONS(6973), 1,
      anon_sym_LPAREN,
    ACTIONS(7022), 1,
      anon_sym_LBRACK,
    ACTIONS(7026), 1,
      anon_sym_BANG,
    ACTIONS(7042), 1,
      anon_sym_switch,
    ACTIONS(7050), 1,
      anon_sym_with,
    ACTIONS(7166), 1,
      anon_sym_SLASH,
    ACTIONS(7168), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7172), 1,
      anon_sym_GT_GT,
    ACTIONS(7216), 1,
      anon_sym_QMARK,
    ACTIONS(7218), 1,
      anon_sym_CARET,
    ACTIONS(7220), 1,
      anon_sym_PIPE,
    ACTIONS(7222), 1,
      anon_sym_AMP,
    ACTIONS(7228), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7230), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7232), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7234), 1,
      anon_sym_as,
    ACTIONS(7236), 1,
      anon_sym_is,
    STATE(3870), 1,
      sym_bracketed_argument_list,
    STATE(5721), 1,
      sym_argument_list,
    ACTIONS(7028), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7162), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7164), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7170), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7214), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7224), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7226), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5385), 5,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_and,
      anon_sym_or,
    STATE(5250), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [95306] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4953), 1,
      anon_sym_DASH_GT,
    ACTIONS(5067), 1,
      anon_sym_DOT,
    ACTIONS(6973), 1,
      anon_sym_LPAREN,
    ACTIONS(7022), 1,
      anon_sym_LBRACK,
    ACTIONS(7026), 1,
      anon_sym_BANG,
    ACTIONS(7042), 1,
      anon_sym_switch,
    ACTIONS(7050), 1,
      anon_sym_with,
    ACTIONS(7166), 1,
      anon_sym_SLASH,
    ACTIONS(7168), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7172), 1,
      anon_sym_GT_GT,
    ACTIONS(7216), 1,
      anon_sym_QMARK,
    ACTIONS(7218), 1,
      anon_sym_CARET,
    ACTIONS(7220), 1,
      anon_sym_PIPE,
    ACTIONS(7222), 1,
      anon_sym_AMP,
    ACTIONS(7228), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7230), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7232), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7234), 1,
      anon_sym_as,
    ACTIONS(7236), 1,
      anon_sym_is,
    STATE(3870), 1,
      sym_bracketed_argument_list,
    STATE(5721), 1,
      sym_argument_list,
    ACTIONS(7028), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7162), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7164), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7170), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7214), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7224), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7226), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5337), 5,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_and,
      anon_sym_or,
    STATE(5251), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [95442] = 42,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2585), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(2587), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7178), 1,
      anon_sym_QMARK,
    ACTIONS(7184), 1,
      anon_sym_SLASH,
    ACTIONS(7186), 1,
      anon_sym_CARET,
    ACTIONS(7188), 1,
      anon_sym_PIPE,
    ACTIONS(7190), 1,
      anon_sym_AMP,
    ACTIONS(7194), 1,
      anon_sym_GT_GT,
    ACTIONS(7200), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7202), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7204), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7206), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7210), 1,
      anon_sym_is,
    ACTIONS(7284), 1,
      aux_sym_preproc_if_token3,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7176), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7180), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7182), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7192), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7196), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7198), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(9663), 2,
      sym_preproc_else_in_expression,
      sym_preproc_elif_in_expression,
    STATE(5252), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [95584] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2983), 1,
      sym__identifier_token,
    ACTIONS(2995), 1,
      anon_sym_LPAREN,
    ACTIONS(3728), 1,
      anon_sym_delegate,
    ACTIONS(7008), 1,
      sym_predefined_type,
    STATE(4443), 1,
      sym__reserved_identifier,
    STATE(4921), 1,
      sym_identifier,
    STATE(4959), 1,
      sym_generic_name,
    STATE(7168), 1,
      sym_array_type,
    STATE(7178), 1,
      sym_nullable_type,
    STATE(8214), 1,
      sym__name,
    STATE(8572), 1,
      sym_tuple_type,
    STATE(8768), 1,
      sym__array_base_type,
    STATE(9721), 1,
      sym__pointer_base_type,
    STATE(8906), 2,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5253), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2987), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [95694] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5254), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4066), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4068), 29,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [95776] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7286), 1,
      sym_string_literal_encoding,
    STATE(5255), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5294), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5292), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [95860] = 28,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(7136), 1,
      anon_sym_SLASH,
    ACTIONS(7146), 1,
      anon_sym_GT_GT,
    ACTIONS(7152), 1,
      anon_sym_DOT_DOT,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7132), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7134), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7144), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6116), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5256), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 15,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
  [95974] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4547), 1,
      anon_sym_LBRACK,
    ACTIONS(4553), 1,
      anon_sym_STAR,
    ACTIONS(7288), 1,
      anon_sym_QMARK,
    ACTIONS(7291), 1,
      anon_sym_DOT,
    STATE(5257), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4422), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(4424), 27,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [96064] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5258), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5290), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5288), 29,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [96146] = 25,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(7136), 1,
      anon_sym_SLASH,
    ACTIONS(7152), 1,
      anon_sym_DOT_DOT,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7134), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6116), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5259), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 17,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
  [96254] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(7152), 1,
      anon_sym_DOT_DOT,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5260), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6116), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6114), 19,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
  [96358] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5261), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4406), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4408), 29,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [96440] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5262), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4570), 12,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
    ACTIONS(4568), 28,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_operator,
      anon_sym_this,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [96522] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(6695), 1,
      anon_sym_as,
    ACTIONS(7136), 1,
      anon_sym_SLASH,
    ACTIONS(7142), 1,
      anon_sym_AMP,
    ACTIONS(7146), 1,
      anon_sym_GT_GT,
    ACTIONS(7152), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7160), 1,
      anon_sym_is,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6116), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7128), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7132), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7134), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7144), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7148), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7150), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5263), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 9,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
  [96648] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(6695), 1,
      anon_sym_as,
    ACTIONS(7136), 1,
      anon_sym_SLASH,
    ACTIONS(7138), 1,
      anon_sym_CARET,
    ACTIONS(7142), 1,
      anon_sym_AMP,
    ACTIONS(7146), 1,
      anon_sym_GT_GT,
    ACTIONS(7152), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7160), 1,
      anon_sym_is,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6116), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7128), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7132), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7134), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7144), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7148), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7150), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 8,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
    STATE(5264), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [96776] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(7152), 1,
      anon_sym_DOT_DOT,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5265), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1147), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(1133), 21,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [96876] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(6695), 1,
      anon_sym_as,
    ACTIONS(7130), 1,
      anon_sym_QMARK,
    ACTIONS(7136), 1,
      anon_sym_SLASH,
    ACTIONS(7138), 1,
      anon_sym_CARET,
    ACTIONS(7140), 1,
      anon_sym_PIPE,
    ACTIONS(7142), 1,
      anon_sym_AMP,
    ACTIONS(7146), 1,
      anon_sym_GT_GT,
    ACTIONS(7152), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7154), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7156), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7158), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7160), 1,
      anon_sym_is,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7128), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7132), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7134), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7144), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7148), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7150), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6220), 5,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_into,
    STATE(5266), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [97012] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(6695), 1,
      anon_sym_as,
    ACTIONS(7136), 1,
      anon_sym_SLASH,
    ACTIONS(7146), 1,
      anon_sym_GT_GT,
    ACTIONS(7152), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7160), 1,
      anon_sym_is,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7128), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7132), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7134), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7144), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7148), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7150), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6116), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5267), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 9,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
  [97136] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(7136), 1,
      anon_sym_SLASH,
    ACTIONS(7152), 1,
      anon_sym_DOT_DOT,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7132), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7134), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6116), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5268), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 17,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
  [97246] = 32,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(6695), 1,
      anon_sym_as,
    ACTIONS(7136), 1,
      anon_sym_SLASH,
    ACTIONS(7146), 1,
      anon_sym_GT_GT,
    ACTIONS(7152), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7160), 1,
      anon_sym_is,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7128), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7132), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7134), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7144), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7150), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6116), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5269), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 11,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
  [97368] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(6695), 1,
      anon_sym_as,
    ACTIONS(7136), 1,
      anon_sym_SLASH,
    ACTIONS(7138), 1,
      anon_sym_CARET,
    ACTIONS(7140), 1,
      anon_sym_PIPE,
    ACTIONS(7142), 1,
      anon_sym_AMP,
    ACTIONS(7146), 1,
      anon_sym_GT_GT,
    ACTIONS(7152), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7160), 1,
      anon_sym_is,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7128), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7132), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7134), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7144), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7148), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7150), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 8,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
    STATE(5270), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [97498] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4547), 1,
      anon_sym_LBRACK,
    ACTIONS(4553), 1,
      anon_sym_STAR,
    STATE(5271), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4422), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4424), 27,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [97584] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5272), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4474), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4476), 29,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [97666] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(7124), 1,
      anon_sym_DOT_DOT,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5273), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1147), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(1133), 21,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [97766] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(6695), 1,
      anon_sym_as,
    ACTIONS(7136), 1,
      anon_sym_SLASH,
    ACTIONS(7138), 1,
      anon_sym_CARET,
    ACTIONS(7140), 1,
      anon_sym_PIPE,
    ACTIONS(7142), 1,
      anon_sym_AMP,
    ACTIONS(7146), 1,
      anon_sym_GT_GT,
    ACTIONS(7152), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7154), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7160), 1,
      anon_sym_is,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7128), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7132), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7134), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7144), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7148), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7150), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 7,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
    STATE(5274), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [97898] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(6695), 1,
      anon_sym_as,
    ACTIONS(7136), 1,
      anon_sym_SLASH,
    ACTIONS(7138), 1,
      anon_sym_CARET,
    ACTIONS(7140), 1,
      anon_sym_PIPE,
    ACTIONS(7142), 1,
      anon_sym_AMP,
    ACTIONS(7146), 1,
      anon_sym_GT_GT,
    ACTIONS(7152), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7154), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7156), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7158), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7160), 1,
      anon_sym_is,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7128), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7132), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7134), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7144), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7148), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7150), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 5,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_into,
    STATE(5275), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [98034] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5276), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4387), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4389), 29,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [98116] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7293), 1,
      sym_string_literal_encoding,
    STATE(5277), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5321), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5319), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [98200] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7174), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7276), 1,
      anon_sym_as,
    ACTIONS(7297), 1,
      anon_sym_QMARK,
    ACTIONS(7303), 1,
      anon_sym_SLASH,
    ACTIONS(7305), 1,
      anon_sym_CARET,
    ACTIONS(7307), 1,
      anon_sym_PIPE,
    ACTIONS(7309), 1,
      anon_sym_AMP,
    ACTIONS(7313), 1,
      anon_sym_GT_GT,
    ACTIONS(7319), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7321), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7323), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7325), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7295), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7299), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7301), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7311), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7315), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7317), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6274), 5,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5278), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [98336] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7124), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7242), 1,
      anon_sym_SLASH,
    ACTIONS(7246), 1,
      anon_sym_GT_GT,
    ACTIONS(7258), 1,
      anon_sym_QMARK,
    ACTIONS(7260), 1,
      anon_sym_CARET,
    ACTIONS(7262), 1,
      anon_sym_PIPE,
    ACTIONS(7264), 1,
      anon_sym_AMP,
    ACTIONS(7270), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7272), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7274), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7276), 1,
      anon_sym_as,
    ACTIONS(7278), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7238), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7240), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7244), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7256), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7266), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7268), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6236), 5,
      anon_sym_COLON,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5279), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [98472] = 28,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7174), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7303), 1,
      anon_sym_SLASH,
    ACTIONS(7313), 1,
      anon_sym_GT_GT,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7299), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7301), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7311), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6116), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5280), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 15,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
  [98586] = 25,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7174), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7303), 1,
      anon_sym_SLASH,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7301), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6116), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5281), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 17,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
  [98694] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7174), 1,
      anon_sym_DOT_DOT,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5282), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6116), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6114), 19,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
  [98798] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7174), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7303), 1,
      anon_sym_SLASH,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7299), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7301), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6116), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5283), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 17,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
  [98908] = 42,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2585), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(2587), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7178), 1,
      anon_sym_QMARK,
    ACTIONS(7184), 1,
      anon_sym_SLASH,
    ACTIONS(7186), 1,
      anon_sym_CARET,
    ACTIONS(7188), 1,
      anon_sym_PIPE,
    ACTIONS(7190), 1,
      anon_sym_AMP,
    ACTIONS(7194), 1,
      anon_sym_GT_GT,
    ACTIONS(7200), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7202), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7204), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7206), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7210), 1,
      anon_sym_is,
    ACTIONS(7327), 1,
      aux_sym_preproc_if_token3,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7176), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7180), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7182), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7192), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7196), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7198), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(9559), 2,
      sym_preproc_else_in_expression,
      sym_preproc_elif_in_expression,
    STATE(5284), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [99050] = 42,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2585), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(2587), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7178), 1,
      anon_sym_QMARK,
    ACTIONS(7184), 1,
      anon_sym_SLASH,
    ACTIONS(7186), 1,
      anon_sym_CARET,
    ACTIONS(7188), 1,
      anon_sym_PIPE,
    ACTIONS(7190), 1,
      anon_sym_AMP,
    ACTIONS(7194), 1,
      anon_sym_GT_GT,
    ACTIONS(7200), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7202), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7204), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7206), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7210), 1,
      anon_sym_is,
    ACTIONS(7329), 1,
      aux_sym_preproc_if_token3,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7176), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7180), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7182), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7192), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7196), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7198), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(9021), 2,
      sym_preproc_else_in_expression,
      sym_preproc_elif_in_expression,
    STATE(5285), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [99192] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7124), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7242), 1,
      anon_sym_SLASH,
    ACTIONS(7246), 1,
      anon_sym_GT_GT,
    ACTIONS(7258), 1,
      anon_sym_QMARK,
    ACTIONS(7260), 1,
      anon_sym_CARET,
    ACTIONS(7262), 1,
      anon_sym_PIPE,
    ACTIONS(7264), 1,
      anon_sym_AMP,
    ACTIONS(7270), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7272), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7274), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7276), 1,
      anon_sym_as,
    ACTIONS(7278), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7238), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7240), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7244), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7256), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7266), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7268), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6230), 5,
      anon_sym_COLON,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5286), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [99328] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7124), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7242), 1,
      anon_sym_SLASH,
    ACTIONS(7246), 1,
      anon_sym_GT_GT,
    ACTIONS(7258), 1,
      anon_sym_QMARK,
    ACTIONS(7260), 1,
      anon_sym_CARET,
    ACTIONS(7262), 1,
      anon_sym_PIPE,
    ACTIONS(7264), 1,
      anon_sym_AMP,
    ACTIONS(7270), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7272), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7274), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7276), 1,
      anon_sym_as,
    ACTIONS(7278), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7238), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7240), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7244), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7256), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7266), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7268), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5420), 5,
      anon_sym_COLON,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5287), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [99464] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7124), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7242), 1,
      anon_sym_SLASH,
    ACTIONS(7246), 1,
      anon_sym_GT_GT,
    ACTIONS(7258), 1,
      anon_sym_QMARK,
    ACTIONS(7260), 1,
      anon_sym_CARET,
    ACTIONS(7262), 1,
      anon_sym_PIPE,
    ACTIONS(7264), 1,
      anon_sym_AMP,
    ACTIONS(7270), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7272), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7274), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7276), 1,
      anon_sym_as,
    ACTIONS(7278), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7238), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7240), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7244), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7256), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7266), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7268), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5510), 5,
      anon_sym_COLON,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5288), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [99600] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7124), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7242), 1,
      anon_sym_SLASH,
    ACTIONS(7246), 1,
      anon_sym_GT_GT,
    ACTIONS(7258), 1,
      anon_sym_QMARK,
    ACTIONS(7260), 1,
      anon_sym_CARET,
    ACTIONS(7262), 1,
      anon_sym_PIPE,
    ACTIONS(7264), 1,
      anon_sym_AMP,
    ACTIONS(7270), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7272), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7274), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7276), 1,
      anon_sym_as,
    ACTIONS(7278), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7238), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7240), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7244), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7256), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7266), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7268), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5325), 5,
      anon_sym_COLON,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5289), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [99736] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7124), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7242), 1,
      anon_sym_SLASH,
    ACTIONS(7246), 1,
      anon_sym_GT_GT,
    ACTIONS(7258), 1,
      anon_sym_QMARK,
    ACTIONS(7260), 1,
      anon_sym_CARET,
    ACTIONS(7262), 1,
      anon_sym_PIPE,
    ACTIONS(7264), 1,
      anon_sym_AMP,
    ACTIONS(7270), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7272), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7274), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7276), 1,
      anon_sym_as,
    ACTIONS(7278), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7238), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7240), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7244), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7256), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7266), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7268), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6216), 5,
      anon_sym_COLON,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5290), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [99872] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7124), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7242), 1,
      anon_sym_SLASH,
    ACTIONS(7246), 1,
      anon_sym_GT_GT,
    ACTIONS(7258), 1,
      anon_sym_QMARK,
    ACTIONS(7260), 1,
      anon_sym_CARET,
    ACTIONS(7262), 1,
      anon_sym_PIPE,
    ACTIONS(7264), 1,
      anon_sym_AMP,
    ACTIONS(7270), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7272), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7274), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7276), 1,
      anon_sym_as,
    ACTIONS(7278), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7238), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7240), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7244), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7256), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7266), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7268), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5396), 5,
      anon_sym_COLON,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5291), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [100008] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7124), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7242), 1,
      anon_sym_SLASH,
    ACTIONS(7246), 1,
      anon_sym_GT_GT,
    ACTIONS(7258), 1,
      anon_sym_QMARK,
    ACTIONS(7260), 1,
      anon_sym_CARET,
    ACTIONS(7262), 1,
      anon_sym_PIPE,
    ACTIONS(7264), 1,
      anon_sym_AMP,
    ACTIONS(7270), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7272), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7274), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7276), 1,
      anon_sym_as,
    ACTIONS(7278), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7238), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7240), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7244), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7256), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7266), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7268), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5385), 5,
      anon_sym_COLON,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5292), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [100144] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4547), 1,
      anon_sym_LBRACK,
    ACTIONS(4553), 1,
      anon_sym_STAR,
    ACTIONS(7288), 1,
      anon_sym_QMARK,
    STATE(5293), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4422), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4424), 27,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [100232] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7124), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7242), 1,
      anon_sym_SLASH,
    ACTIONS(7246), 1,
      anon_sym_GT_GT,
    ACTIONS(7258), 1,
      anon_sym_QMARK,
    ACTIONS(7260), 1,
      anon_sym_CARET,
    ACTIONS(7262), 1,
      anon_sym_PIPE,
    ACTIONS(7264), 1,
      anon_sym_AMP,
    ACTIONS(7270), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7272), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7274), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7276), 1,
      anon_sym_as,
    ACTIONS(7278), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7238), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7240), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7244), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7256), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7266), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7268), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5337), 5,
      anon_sym_COLON,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5294), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [100368] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7126), 1,
      anon_sym_into,
    STATE(5212), 1,
      aux_sym__query_body_repeat2,
    STATE(5295), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6448), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6446), 27,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [100454] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4547), 1,
      anon_sym_LBRACK,
    ACTIONS(7288), 1,
      anon_sym_QMARK,
    STATE(5296), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4422), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4424), 28,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [100540] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4953), 1,
      anon_sym_DASH_GT,
    ACTIONS(5067), 1,
      anon_sym_DOT,
    ACTIONS(6973), 1,
      anon_sym_LPAREN,
    ACTIONS(7022), 1,
      anon_sym_LBRACK,
    ACTIONS(7026), 1,
      anon_sym_BANG,
    ACTIONS(7042), 1,
      anon_sym_switch,
    ACTIONS(7050), 1,
      anon_sym_with,
    ACTIONS(7166), 1,
      anon_sym_SLASH,
    ACTIONS(7168), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7172), 1,
      anon_sym_GT_GT,
    ACTIONS(7216), 1,
      anon_sym_QMARK,
    ACTIONS(7218), 1,
      anon_sym_CARET,
    ACTIONS(7220), 1,
      anon_sym_PIPE,
    ACTIONS(7222), 1,
      anon_sym_AMP,
    ACTIONS(7228), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7230), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7232), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7234), 1,
      anon_sym_as,
    ACTIONS(7236), 1,
      anon_sym_is,
    STATE(3870), 1,
      sym_bracketed_argument_list,
    STATE(5721), 1,
      sym_argument_list,
    ACTIONS(7028), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7162), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7164), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7170), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7214), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7224), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7226), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6236), 5,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_and,
      anon_sym_or,
    STATE(5297), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [100676] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7331), 1,
      anon_sym_and,
    STATE(5298), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6546), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6544), 28,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [100760] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7124), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7242), 1,
      anon_sym_SLASH,
    ACTIONS(7246), 1,
      anon_sym_GT_GT,
    ACTIONS(7258), 1,
      anon_sym_QMARK,
    ACTIONS(7260), 1,
      anon_sym_CARET,
    ACTIONS(7262), 1,
      anon_sym_PIPE,
    ACTIONS(7264), 1,
      anon_sym_AMP,
    ACTIONS(7270), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7272), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7274), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7276), 1,
      anon_sym_as,
    ACTIONS(7278), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7238), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7240), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7244), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7256), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7266), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7268), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6220), 5,
      anon_sym_COLON,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5299), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [100896] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7174), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7276), 1,
      anon_sym_as,
    ACTIONS(7297), 1,
      anon_sym_QMARK,
    ACTIONS(7303), 1,
      anon_sym_SLASH,
    ACTIONS(7305), 1,
      anon_sym_CARET,
    ACTIONS(7307), 1,
      anon_sym_PIPE,
    ACTIONS(7309), 1,
      anon_sym_AMP,
    ACTIONS(7313), 1,
      anon_sym_GT_GT,
    ACTIONS(7319), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7321), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7323), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7325), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7295), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7299), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7301), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7311), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7315), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7317), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6284), 5,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5300), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [101032] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5301), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4566), 12,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
    ACTIONS(4564), 28,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_operator,
      anon_sym_this,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [101114] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5302), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4113), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4124), 29,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [101196] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4081), 1,
      anon_sym_EQ_GT,
    STATE(5303), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5832), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4247), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [101280] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(6498), 1,
      anon_sym_ref,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(2738), 1,
      sym_generic_name,
    STATE(2899), 1,
      sym_ref_type,
    STATE(2907), 1,
      sym__scoped_base_type,
    STATE(5368), 1,
      sym_identifier,
    STATE(6160), 1,
      sym__name,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    ACTIONS(3719), 7,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
    STATE(5304), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [101380] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4953), 1,
      anon_sym_DASH_GT,
    ACTIONS(5067), 1,
      anon_sym_DOT,
    ACTIONS(6973), 1,
      anon_sym_LPAREN,
    ACTIONS(7022), 1,
      anon_sym_LBRACK,
    ACTIONS(7026), 1,
      anon_sym_BANG,
    ACTIONS(7042), 1,
      anon_sym_switch,
    ACTIONS(7050), 1,
      anon_sym_with,
    ACTIONS(7166), 1,
      anon_sym_SLASH,
    ACTIONS(7168), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7172), 1,
      anon_sym_GT_GT,
    ACTIONS(7216), 1,
      anon_sym_QMARK,
    ACTIONS(7218), 1,
      anon_sym_CARET,
    ACTIONS(7220), 1,
      anon_sym_PIPE,
    ACTIONS(7222), 1,
      anon_sym_AMP,
    ACTIONS(7228), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7230), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7232), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7234), 1,
      anon_sym_as,
    ACTIONS(7236), 1,
      anon_sym_is,
    STATE(3870), 1,
      sym_bracketed_argument_list,
    STATE(5721), 1,
      sym_argument_list,
    ACTIONS(7028), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7162), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7164), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7170), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7214), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7224), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7226), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6173), 5,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_and,
      anon_sym_or,
    STATE(5305), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [101516] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4953), 1,
      anon_sym_DASH_GT,
    ACTIONS(5067), 1,
      anon_sym_DOT,
    ACTIONS(6973), 1,
      anon_sym_LPAREN,
    ACTIONS(7022), 1,
      anon_sym_LBRACK,
    ACTIONS(7026), 1,
      anon_sym_BANG,
    ACTIONS(7042), 1,
      anon_sym_switch,
    ACTIONS(7050), 1,
      anon_sym_with,
    ACTIONS(7166), 1,
      anon_sym_SLASH,
    ACTIONS(7168), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7172), 1,
      anon_sym_GT_GT,
    ACTIONS(7222), 1,
      anon_sym_AMP,
    ACTIONS(7234), 1,
      anon_sym_as,
    ACTIONS(7236), 1,
      anon_sym_is,
    STATE(3870), 1,
      sym_bracketed_argument_list,
    STATE(5721), 1,
      sym_argument_list,
    ACTIONS(6116), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7028), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7162), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7164), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7170), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7214), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7224), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7226), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5306), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 9,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_CARET,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [101642] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4953), 1,
      anon_sym_DASH_GT,
    ACTIONS(5067), 1,
      anon_sym_DOT,
    ACTIONS(6973), 1,
      anon_sym_LPAREN,
    ACTIONS(7022), 1,
      anon_sym_LBRACK,
    ACTIONS(7026), 1,
      anon_sym_BANG,
    ACTIONS(7042), 1,
      anon_sym_switch,
    ACTIONS(7050), 1,
      anon_sym_with,
    ACTIONS(7166), 1,
      anon_sym_SLASH,
    ACTIONS(7168), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7172), 1,
      anon_sym_GT_GT,
    ACTIONS(7218), 1,
      anon_sym_CARET,
    ACTIONS(7222), 1,
      anon_sym_AMP,
    ACTIONS(7234), 1,
      anon_sym_as,
    ACTIONS(7236), 1,
      anon_sym_is,
    STATE(3870), 1,
      sym_bracketed_argument_list,
    STATE(5721), 1,
      sym_argument_list,
    ACTIONS(6116), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7028), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7162), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7164), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7170), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7214), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7224), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7226), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 8,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(5307), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [101770] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7174), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7276), 1,
      anon_sym_as,
    ACTIONS(7297), 1,
      anon_sym_QMARK,
    ACTIONS(7303), 1,
      anon_sym_SLASH,
    ACTIONS(7305), 1,
      anon_sym_CARET,
    ACTIONS(7307), 1,
      anon_sym_PIPE,
    ACTIONS(7309), 1,
      anon_sym_AMP,
    ACTIONS(7313), 1,
      anon_sym_GT_GT,
    ACTIONS(7319), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7321), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7323), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7325), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7295), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7299), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7301), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7311), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7315), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7317), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5510), 5,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5308), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [101906] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4953), 1,
      anon_sym_DASH_GT,
    ACTIONS(5067), 1,
      anon_sym_DOT,
    ACTIONS(6973), 1,
      anon_sym_LPAREN,
    ACTIONS(7022), 1,
      anon_sym_LBRACK,
    ACTIONS(7026), 1,
      anon_sym_BANG,
    ACTIONS(7042), 1,
      anon_sym_switch,
    ACTIONS(7050), 1,
      anon_sym_with,
    ACTIONS(7166), 1,
      anon_sym_SLASH,
    ACTIONS(7168), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7172), 1,
      anon_sym_GT_GT,
    ACTIONS(7234), 1,
      anon_sym_as,
    ACTIONS(7236), 1,
      anon_sym_is,
    STATE(3870), 1,
      sym_bracketed_argument_list,
    STATE(5721), 1,
      sym_argument_list,
    ACTIONS(7028), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7162), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7164), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7170), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7214), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7224), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7226), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6116), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5309), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 9,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_CARET,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [102030] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7174), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7276), 1,
      anon_sym_as,
    ACTIONS(7297), 1,
      anon_sym_QMARK,
    ACTIONS(7303), 1,
      anon_sym_SLASH,
    ACTIONS(7305), 1,
      anon_sym_CARET,
    ACTIONS(7307), 1,
      anon_sym_PIPE,
    ACTIONS(7309), 1,
      anon_sym_AMP,
    ACTIONS(7313), 1,
      anon_sym_GT_GT,
    ACTIONS(7319), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7321), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7323), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7325), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7295), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7299), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7301), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7311), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7315), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7317), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6220), 5,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5310), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [102166] = 32,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4953), 1,
      anon_sym_DASH_GT,
    ACTIONS(5067), 1,
      anon_sym_DOT,
    ACTIONS(6973), 1,
      anon_sym_LPAREN,
    ACTIONS(7022), 1,
      anon_sym_LBRACK,
    ACTIONS(7026), 1,
      anon_sym_BANG,
    ACTIONS(7042), 1,
      anon_sym_switch,
    ACTIONS(7050), 1,
      anon_sym_with,
    ACTIONS(7166), 1,
      anon_sym_SLASH,
    ACTIONS(7168), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7172), 1,
      anon_sym_GT_GT,
    ACTIONS(7234), 1,
      anon_sym_as,
    ACTIONS(7236), 1,
      anon_sym_is,
    STATE(3870), 1,
      sym_bracketed_argument_list,
    STATE(5721), 1,
      sym_argument_list,
    ACTIONS(7028), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7162), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7164), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7170), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7214), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7226), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6116), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5311), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 11,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [102288] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7124), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7242), 1,
      anon_sym_SLASH,
    ACTIONS(7246), 1,
      anon_sym_GT_GT,
    ACTIONS(7258), 1,
      anon_sym_QMARK,
    ACTIONS(7260), 1,
      anon_sym_CARET,
    ACTIONS(7262), 1,
      anon_sym_PIPE,
    ACTIONS(7264), 1,
      anon_sym_AMP,
    ACTIONS(7270), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7272), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7274), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7276), 1,
      anon_sym_as,
    ACTIONS(7278), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7238), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7240), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7244), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7256), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7266), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7268), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6173), 5,
      anon_sym_COLON,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5312), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [102424] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4739), 6,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
    STATE(5313), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5480), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5478), 23,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [102508] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4739), 6,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
    STATE(5314), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5488), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5486), 23,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [102592] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5315), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4085), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4087), 29,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [102674] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7174), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7276), 1,
      anon_sym_as,
    ACTIONS(7297), 1,
      anon_sym_QMARK,
    ACTIONS(7303), 1,
      anon_sym_SLASH,
    ACTIONS(7305), 1,
      anon_sym_CARET,
    ACTIONS(7307), 1,
      anon_sym_PIPE,
    ACTIONS(7309), 1,
      anon_sym_AMP,
    ACTIONS(7313), 1,
      anon_sym_GT_GT,
    ACTIONS(7319), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7321), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7323), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7325), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7295), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7299), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7301), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7311), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7315), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7317), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6173), 5,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5316), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [102810] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5317), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5268), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5266), 29,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [102892] = 25,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4277), 1,
      anon_sym_LBRACE,
    ACTIONS(4295), 1,
      sym_discard,
    ACTIONS(7333), 1,
      sym__identifier_token,
    ACTIONS(7337), 1,
      anon_sym_LPAREN,
    STATE(3127), 1,
      sym__reserved_identifier,
    STATE(4259), 1,
      sym_identifier,
    STATE(4260), 1,
      sym__variable_designation,
    STATE(4274), 1,
      sym_parenthesized_variable_designation,
    STATE(6162), 1,
      sym_positional_pattern_clause,
    STATE(6695), 1,
      sym_property_pattern_clause,
    STATE(9127), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    ACTIONS(4279), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(4275), 4,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    STATE(5318), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7335), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [103000] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5319), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4070), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4072), 29,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [103082] = 42,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2585), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(2587), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7178), 1,
      anon_sym_QMARK,
    ACTIONS(7184), 1,
      anon_sym_SLASH,
    ACTIONS(7186), 1,
      anon_sym_CARET,
    ACTIONS(7188), 1,
      anon_sym_PIPE,
    ACTIONS(7190), 1,
      anon_sym_AMP,
    ACTIONS(7194), 1,
      anon_sym_GT_GT,
    ACTIONS(7200), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7202), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7204), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7206), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7210), 1,
      anon_sym_is,
    ACTIONS(7339), 1,
      aux_sym_preproc_if_token3,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7176), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7180), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7182), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7192), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7196), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7198), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(8962), 2,
      sym_preproc_else_in_expression,
      sym_preproc_elif_in_expression,
    STATE(5320), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [103224] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5321), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4060), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4062), 29,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [103306] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4953), 1,
      anon_sym_DASH_GT,
    ACTIONS(5067), 1,
      anon_sym_DOT,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6973), 1,
      anon_sym_LPAREN,
    ACTIONS(7022), 1,
      anon_sym_LBRACK,
    ACTIONS(7026), 1,
      anon_sym_BANG,
    ACTIONS(7042), 1,
      anon_sym_switch,
    ACTIONS(7050), 1,
      anon_sym_with,
    ACTIONS(7166), 1,
      anon_sym_SLASH,
    ACTIONS(7168), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7172), 1,
      anon_sym_GT_GT,
    ACTIONS(7218), 1,
      anon_sym_CARET,
    ACTIONS(7220), 1,
      anon_sym_PIPE,
    ACTIONS(7222), 1,
      anon_sym_AMP,
    ACTIONS(7234), 1,
      anon_sym_as,
    ACTIONS(7236), 1,
      anon_sym_is,
    STATE(3870), 1,
      sym_bracketed_argument_list,
    STATE(5721), 1,
      sym_argument_list,
    ACTIONS(7028), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7162), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7164), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7170), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7214), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7224), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7226), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 8,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(5322), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [103436] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4953), 1,
      anon_sym_DASH_GT,
    ACTIONS(5067), 1,
      anon_sym_DOT,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6973), 1,
      anon_sym_LPAREN,
    ACTIONS(7022), 1,
      anon_sym_LBRACK,
    ACTIONS(7026), 1,
      anon_sym_BANG,
    ACTIONS(7042), 1,
      anon_sym_switch,
    ACTIONS(7050), 1,
      anon_sym_with,
    ACTIONS(7166), 1,
      anon_sym_SLASH,
    ACTIONS(7168), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7172), 1,
      anon_sym_GT_GT,
    ACTIONS(7218), 1,
      anon_sym_CARET,
    ACTIONS(7220), 1,
      anon_sym_PIPE,
    ACTIONS(7222), 1,
      anon_sym_AMP,
    ACTIONS(7228), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7234), 1,
      anon_sym_as,
    ACTIONS(7236), 1,
      anon_sym_is,
    STATE(3870), 1,
      sym_bracketed_argument_list,
    STATE(5721), 1,
      sym_argument_list,
    ACTIONS(7028), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7162), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7164), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7170), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7214), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7224), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7226), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 7,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(5323), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [103568] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4953), 1,
      anon_sym_DASH_GT,
    ACTIONS(5067), 1,
      anon_sym_DOT,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6973), 1,
      anon_sym_LPAREN,
    ACTIONS(7022), 1,
      anon_sym_LBRACK,
    ACTIONS(7026), 1,
      anon_sym_BANG,
    ACTIONS(7042), 1,
      anon_sym_switch,
    ACTIONS(7050), 1,
      anon_sym_with,
    ACTIONS(7166), 1,
      anon_sym_SLASH,
    ACTIONS(7168), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7172), 1,
      anon_sym_GT_GT,
    ACTIONS(7218), 1,
      anon_sym_CARET,
    ACTIONS(7220), 1,
      anon_sym_PIPE,
    ACTIONS(7222), 1,
      anon_sym_AMP,
    ACTIONS(7228), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7230), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7232), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7234), 1,
      anon_sym_as,
    ACTIONS(7236), 1,
      anon_sym_is,
    STATE(3870), 1,
      sym_bracketed_argument_list,
    STATE(5721), 1,
      sym_argument_list,
    ACTIONS(7028), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7162), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7164), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7170), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7214), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7224), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7226), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 5,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_and,
      anon_sym_or,
    STATE(5324), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [103704] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7174), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7276), 1,
      anon_sym_as,
    ACTIONS(7297), 1,
      anon_sym_QMARK,
    ACTIONS(7303), 1,
      anon_sym_SLASH,
    ACTIONS(7305), 1,
      anon_sym_CARET,
    ACTIONS(7307), 1,
      anon_sym_PIPE,
    ACTIONS(7309), 1,
      anon_sym_AMP,
    ACTIONS(7313), 1,
      anon_sym_GT_GT,
    ACTIONS(7319), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7321), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7323), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7325), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7295), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7299), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7301), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7311), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7315), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7317), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6236), 5,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5325), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [103840] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(6695), 1,
      anon_sym_as,
    ACTIONS(7130), 1,
      anon_sym_QMARK,
    ACTIONS(7136), 1,
      anon_sym_SLASH,
    ACTIONS(7138), 1,
      anon_sym_CARET,
    ACTIONS(7140), 1,
      anon_sym_PIPE,
    ACTIONS(7142), 1,
      anon_sym_AMP,
    ACTIONS(7146), 1,
      anon_sym_GT_GT,
    ACTIONS(7152), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7154), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7156), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7158), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7160), 1,
      anon_sym_is,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7128), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7132), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7134), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7144), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7148), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7150), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6236), 5,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_into,
    STATE(5326), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [103976] = 42,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2585), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(2587), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7178), 1,
      anon_sym_QMARK,
    ACTIONS(7184), 1,
      anon_sym_SLASH,
    ACTIONS(7186), 1,
      anon_sym_CARET,
    ACTIONS(7188), 1,
      anon_sym_PIPE,
    ACTIONS(7190), 1,
      anon_sym_AMP,
    ACTIONS(7194), 1,
      anon_sym_GT_GT,
    ACTIONS(7200), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7202), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7204), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7206), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7210), 1,
      anon_sym_is,
    ACTIONS(7341), 1,
      aux_sym_preproc_if_token3,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7176), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7180), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7182), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7192), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7196), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7198), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(9426), 2,
      sym_preproc_else_in_expression,
      sym_preproc_elif_in_expression,
    STATE(5327), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [104118] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7174), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7276), 1,
      anon_sym_as,
    ACTIONS(7303), 1,
      anon_sym_SLASH,
    ACTIONS(7309), 1,
      anon_sym_AMP,
    ACTIONS(7313), 1,
      anon_sym_GT_GT,
    ACTIONS(7325), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6116), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7295), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7299), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7301), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7311), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7315), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7317), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5328), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 9,
      anon_sym_CARET,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
  [104244] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7174), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7276), 1,
      anon_sym_as,
    ACTIONS(7303), 1,
      anon_sym_SLASH,
    ACTIONS(7305), 1,
      anon_sym_CARET,
    ACTIONS(7309), 1,
      anon_sym_AMP,
    ACTIONS(7313), 1,
      anon_sym_GT_GT,
    ACTIONS(7325), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6116), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7295), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7299), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7301), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7311), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7315), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7317), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 8,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
    STATE(5329), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [104372] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7174), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7276), 1,
      anon_sym_as,
    ACTIONS(7303), 1,
      anon_sym_SLASH,
    ACTIONS(7313), 1,
      anon_sym_GT_GT,
    ACTIONS(7325), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7295), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7299), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7301), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7311), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7315), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7317), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6116), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5330), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 9,
      anon_sym_CARET,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
  [104496] = 43,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4953), 1,
      anon_sym_DASH_GT,
    ACTIONS(5067), 1,
      anon_sym_DOT,
    ACTIONS(6973), 1,
      anon_sym_LPAREN,
    ACTIONS(7022), 1,
      anon_sym_LBRACK,
    ACTIONS(7026), 1,
      anon_sym_BANG,
    ACTIONS(7042), 1,
      anon_sym_switch,
    ACTIONS(7050), 1,
      anon_sym_with,
    ACTIONS(7234), 1,
      anon_sym_as,
    ACTIONS(7343), 1,
      anon_sym_COLON,
    ACTIONS(7345), 1,
      anon_sym_COMMA,
    ACTIONS(7349), 1,
      anon_sym_QMARK,
    ACTIONS(7355), 1,
      anon_sym_SLASH,
    ACTIONS(7357), 1,
      anon_sym_CARET,
    ACTIONS(7359), 1,
      anon_sym_PIPE,
    ACTIONS(7361), 1,
      anon_sym_AMP,
    ACTIONS(7365), 1,
      anon_sym_GT_GT,
    ACTIONS(7371), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7373), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7375), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7377), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7379), 1,
      anon_sym_is,
    ACTIONS(7381), 1,
      sym_interpolation_close_brace,
    STATE(3870), 1,
      sym_bracketed_argument_list,
    STATE(5721), 1,
      sym_argument_list,
    STATE(8585), 1,
      sym_interpolation_alignment_clause,
    STATE(9010), 1,
      sym_interpolation_format_clause,
    ACTIONS(7028), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7347), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7351), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7353), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7363), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7367), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7369), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5331), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [104640] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5259), 1,
      anon_sym_LT,
    ACTIONS(7383), 1,
      anon_sym_COLON_COLON,
    STATE(3657), 1,
      sym_type_argument_list,
    STATE(5332), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4074), 11,
      anon_sym_COLON,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4076), 26,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [104728] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5333), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4480), 12,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
    ACTIONS(4478), 28,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_operator,
      anon_sym_this,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [104810] = 32,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7174), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7276), 1,
      anon_sym_as,
    ACTIONS(7303), 1,
      anon_sym_SLASH,
    ACTIONS(7313), 1,
      anon_sym_GT_GT,
    ACTIONS(7325), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7295), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7299), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7301), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7311), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7317), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6116), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5334), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 11,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
  [104932] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(6695), 1,
      anon_sym_as,
    ACTIONS(7130), 1,
      anon_sym_QMARK,
    ACTIONS(7136), 1,
      anon_sym_SLASH,
    ACTIONS(7138), 1,
      anon_sym_CARET,
    ACTIONS(7140), 1,
      anon_sym_PIPE,
    ACTIONS(7142), 1,
      anon_sym_AMP,
    ACTIONS(7146), 1,
      anon_sym_GT_GT,
    ACTIONS(7152), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7154), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7156), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7158), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7160), 1,
      anon_sym_is,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7128), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7132), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7134), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7144), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7148), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7150), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6274), 5,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_into,
    STATE(5335), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [105068] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7174), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7276), 1,
      anon_sym_as,
    ACTIONS(7303), 1,
      anon_sym_SLASH,
    ACTIONS(7305), 1,
      anon_sym_CARET,
    ACTIONS(7307), 1,
      anon_sym_PIPE,
    ACTIONS(7309), 1,
      anon_sym_AMP,
    ACTIONS(7313), 1,
      anon_sym_GT_GT,
    ACTIONS(7325), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7295), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7299), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7301), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7311), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7315), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7317), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 8,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
    STATE(5336), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [105198] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7174), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7276), 1,
      anon_sym_as,
    ACTIONS(7303), 1,
      anon_sym_SLASH,
    ACTIONS(7305), 1,
      anon_sym_CARET,
    ACTIONS(7307), 1,
      anon_sym_PIPE,
    ACTIONS(7309), 1,
      anon_sym_AMP,
    ACTIONS(7313), 1,
      anon_sym_GT_GT,
    ACTIONS(7319), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7325), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7295), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7299), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7301), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7311), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7315), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7317), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 7,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
    STATE(5337), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [105330] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7331), 1,
      anon_sym_and,
    ACTIONS(7385), 1,
      anon_sym_or,
    STATE(5338), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6609), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6607), 27,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [105416] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7174), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7276), 1,
      anon_sym_as,
    ACTIONS(7303), 1,
      anon_sym_SLASH,
    ACTIONS(7305), 1,
      anon_sym_CARET,
    ACTIONS(7307), 1,
      anon_sym_PIPE,
    ACTIONS(7309), 1,
      anon_sym_AMP,
    ACTIONS(7313), 1,
      anon_sym_GT_GT,
    ACTIONS(7319), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7321), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7323), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7325), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7295), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7299), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7301), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7311), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7315), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7317), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 5,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5339), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [105552] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7174), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7276), 1,
      anon_sym_as,
    ACTIONS(7297), 1,
      anon_sym_QMARK,
    ACTIONS(7303), 1,
      anon_sym_SLASH,
    ACTIONS(7305), 1,
      anon_sym_CARET,
    ACTIONS(7307), 1,
      anon_sym_PIPE,
    ACTIONS(7309), 1,
      anon_sym_AMP,
    ACTIONS(7313), 1,
      anon_sym_GT_GT,
    ACTIONS(7319), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7321), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7323), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7325), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7295), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7299), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7301), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7311), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7315), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7317), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6230), 5,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5340), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [105688] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7174), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7276), 1,
      anon_sym_as,
    ACTIONS(7297), 1,
      anon_sym_QMARK,
    ACTIONS(7303), 1,
      anon_sym_SLASH,
    ACTIONS(7305), 1,
      anon_sym_CARET,
    ACTIONS(7307), 1,
      anon_sym_PIPE,
    ACTIONS(7309), 1,
      anon_sym_AMP,
    ACTIONS(7313), 1,
      anon_sym_GT_GT,
    ACTIONS(7319), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7321), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7323), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7325), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7295), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7299), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7301), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7311), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7315), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7317), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5420), 5,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5341), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [105824] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(7174), 1,
      anon_sym_DOT_DOT,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5342), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6122), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6120), 21,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [105924] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7280), 1,
      anon_sym_and,
    STATE(5343), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6546), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6544), 28,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [106008] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5344), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4564), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4566), 29,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [106090] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7174), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7276), 1,
      anon_sym_as,
    ACTIONS(7297), 1,
      anon_sym_QMARK,
    ACTIONS(7303), 1,
      anon_sym_SLASH,
    ACTIONS(7305), 1,
      anon_sym_CARET,
    ACTIONS(7307), 1,
      anon_sym_PIPE,
    ACTIONS(7309), 1,
      anon_sym_AMP,
    ACTIONS(7313), 1,
      anon_sym_GT_GT,
    ACTIONS(7319), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7321), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7323), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7325), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7295), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7299), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7301), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7311), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7315), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7317), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5325), 5,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5345), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [106226] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(6695), 1,
      anon_sym_as,
    ACTIONS(7130), 1,
      anon_sym_QMARK,
    ACTIONS(7136), 1,
      anon_sym_SLASH,
    ACTIONS(7138), 1,
      anon_sym_CARET,
    ACTIONS(7140), 1,
      anon_sym_PIPE,
    ACTIONS(7142), 1,
      anon_sym_AMP,
    ACTIONS(7146), 1,
      anon_sym_GT_GT,
    ACTIONS(7152), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7154), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7156), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7158), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7160), 1,
      anon_sym_is,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7128), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7132), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7134), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7144), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7148), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7150), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6284), 5,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_into,
    STATE(5346), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [106362] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7331), 1,
      anon_sym_and,
    ACTIONS(7385), 1,
      anon_sym_or,
    STATE(5347), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5856), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5854), 27,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [106448] = 43,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4953), 1,
      anon_sym_DASH_GT,
    ACTIONS(5067), 1,
      anon_sym_DOT,
    ACTIONS(6973), 1,
      anon_sym_LPAREN,
    ACTIONS(7022), 1,
      anon_sym_LBRACK,
    ACTIONS(7026), 1,
      anon_sym_BANG,
    ACTIONS(7042), 1,
      anon_sym_switch,
    ACTIONS(7050), 1,
      anon_sym_with,
    ACTIONS(7234), 1,
      anon_sym_as,
    ACTIONS(7343), 1,
      anon_sym_COLON,
    ACTIONS(7345), 1,
      anon_sym_COMMA,
    ACTIONS(7349), 1,
      anon_sym_QMARK,
    ACTIONS(7355), 1,
      anon_sym_SLASH,
    ACTIONS(7357), 1,
      anon_sym_CARET,
    ACTIONS(7359), 1,
      anon_sym_PIPE,
    ACTIONS(7361), 1,
      anon_sym_AMP,
    ACTIONS(7365), 1,
      anon_sym_GT_GT,
    ACTIONS(7371), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7373), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7375), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7377), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7379), 1,
      anon_sym_is,
    ACTIONS(7387), 1,
      sym_interpolation_close_brace,
    STATE(3870), 1,
      sym_bracketed_argument_list,
    STATE(5721), 1,
      sym_argument_list,
    STATE(8456), 1,
      sym_interpolation_alignment_clause,
    STATE(9485), 1,
      sym_interpolation_format_clause,
    ACTIONS(7028), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7347), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7351), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7353), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7363), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7367), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7369), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5348), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [106592] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7174), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7276), 1,
      anon_sym_as,
    ACTIONS(7297), 1,
      anon_sym_QMARK,
    ACTIONS(7303), 1,
      anon_sym_SLASH,
    ACTIONS(7305), 1,
      anon_sym_CARET,
    ACTIONS(7307), 1,
      anon_sym_PIPE,
    ACTIONS(7309), 1,
      anon_sym_AMP,
    ACTIONS(7313), 1,
      anon_sym_GT_GT,
    ACTIONS(7319), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7321), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7323), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7325), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7295), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7299), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7301), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7311), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7315), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7317), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6216), 5,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5349), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [106728] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7174), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7276), 1,
      anon_sym_as,
    ACTIONS(7297), 1,
      anon_sym_QMARK,
    ACTIONS(7303), 1,
      anon_sym_SLASH,
    ACTIONS(7305), 1,
      anon_sym_CARET,
    ACTIONS(7307), 1,
      anon_sym_PIPE,
    ACTIONS(7309), 1,
      anon_sym_AMP,
    ACTIONS(7313), 1,
      anon_sym_GT_GT,
    ACTIONS(7319), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7321), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7323), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7325), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7295), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7299), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7301), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7311), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7315), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7317), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5396), 5,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5350), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [106864] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7174), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7276), 1,
      anon_sym_as,
    ACTIONS(7297), 1,
      anon_sym_QMARK,
    ACTIONS(7303), 1,
      anon_sym_SLASH,
    ACTIONS(7305), 1,
      anon_sym_CARET,
    ACTIONS(7307), 1,
      anon_sym_PIPE,
    ACTIONS(7309), 1,
      anon_sym_AMP,
    ACTIONS(7313), 1,
      anon_sym_GT_GT,
    ACTIONS(7319), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7321), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7323), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7325), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7295), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7299), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7301), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7311), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7315), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7317), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5385), 5,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5351), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [107000] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7174), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7276), 1,
      anon_sym_as,
    ACTIONS(7297), 1,
      anon_sym_QMARK,
    ACTIONS(7303), 1,
      anon_sym_SLASH,
    ACTIONS(7305), 1,
      anon_sym_CARET,
    ACTIONS(7307), 1,
      anon_sym_PIPE,
    ACTIONS(7309), 1,
      anon_sym_AMP,
    ACTIONS(7313), 1,
      anon_sym_GT_GT,
    ACTIONS(7319), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7321), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7323), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7325), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7295), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7299), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7301), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7311), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7315), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7317), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5337), 5,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5352), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [107136] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2983), 1,
      sym__identifier_token,
    ACTIONS(2995), 1,
      anon_sym_LPAREN,
    ACTIONS(3728), 1,
      anon_sym_delegate,
    ACTIONS(7008), 1,
      sym_predefined_type,
    STATE(4443), 1,
      sym__reserved_identifier,
    STATE(4921), 1,
      sym_identifier,
    STATE(4959), 1,
      sym_generic_name,
    STATE(7196), 1,
      sym_nullable_type,
    STATE(7202), 1,
      sym_array_type,
    STATE(8214), 1,
      sym__name,
    STATE(8572), 1,
      sym_tuple_type,
    STATE(8768), 1,
      sym__array_base_type,
    STATE(9721), 1,
      sym__pointer_base_type,
    STATE(8906), 2,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5353), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2987), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [107246] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4953), 1,
      anon_sym_DASH_GT,
    ACTIONS(5067), 1,
      anon_sym_DOT,
    ACTIONS(6973), 1,
      anon_sym_LPAREN,
    ACTIONS(7022), 1,
      anon_sym_LBRACK,
    ACTIONS(7026), 1,
      anon_sym_BANG,
    ACTIONS(7168), 1,
      anon_sym_DOT_DOT,
    STATE(3870), 1,
      sym_bracketed_argument_list,
    STATE(5721), 1,
      sym_argument_list,
    ACTIONS(7028), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5354), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1147), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(1133), 21,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [107346] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7280), 1,
      anon_sym_and,
    ACTIONS(7282), 1,
      anon_sym_or,
    STATE(5355), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5856), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5854), 27,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [107432] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7389), 1,
      anon_sym_into,
    STATE(5356), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym__query_body_repeat2,
    ACTIONS(6376), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6374), 27,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [107516] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7124), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7242), 1,
      anon_sym_SLASH,
    ACTIONS(7246), 1,
      anon_sym_GT_GT,
    ACTIONS(7264), 1,
      anon_sym_AMP,
    ACTIONS(7276), 1,
      anon_sym_as,
    ACTIONS(7278), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6116), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7238), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7240), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7244), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7256), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7266), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7268), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5357), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 9,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
  [107642] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5358), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5264), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5262), 29,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [107724] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5359), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4402), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4404), 29,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [107806] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5360), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4568), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4570), 29,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [107888] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5361), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4414), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4416), 29,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [107970] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5362), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4347), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4349), 29,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [108052] = 42,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2585), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(2587), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7178), 1,
      anon_sym_QMARK,
    ACTIONS(7184), 1,
      anon_sym_SLASH,
    ACTIONS(7186), 1,
      anon_sym_CARET,
    ACTIONS(7188), 1,
      anon_sym_PIPE,
    ACTIONS(7190), 1,
      anon_sym_AMP,
    ACTIONS(7194), 1,
      anon_sym_GT_GT,
    ACTIONS(7200), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7202), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7204), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7206), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7210), 1,
      anon_sym_is,
    ACTIONS(7392), 1,
      aux_sym_preproc_if_token3,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7176), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7180), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7182), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7192), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7196), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7198), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(9621), 2,
      sym_preproc_else_in_expression,
      sym_preproc_elif_in_expression,
    STATE(5363), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [108194] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5364), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4418), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4420), 29,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [108276] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5365), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4525), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4527), 29,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [108358] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7124), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7242), 1,
      anon_sym_SLASH,
    ACTIONS(7246), 1,
      anon_sym_GT_GT,
    ACTIONS(7260), 1,
      anon_sym_CARET,
    ACTIONS(7264), 1,
      anon_sym_AMP,
    ACTIONS(7276), 1,
      anon_sym_as,
    ACTIONS(7278), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6116), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7238), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7240), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7244), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7256), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7266), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7268), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 8,
      anon_sym_COLON,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
    STATE(5366), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [108486] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7124), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7242), 1,
      anon_sym_SLASH,
    ACTIONS(7246), 1,
      anon_sym_GT_GT,
    ACTIONS(7276), 1,
      anon_sym_as,
    ACTIONS(7278), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7238), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7240), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7244), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7256), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7266), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7268), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6116), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5367), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 9,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
  [108610] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7248), 1,
      anon_sym_LT,
    ACTIONS(7394), 1,
      anon_sym_COLON_COLON,
    STATE(2736), 1,
      sym_type_argument_list,
    STATE(5368), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4076), 9,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_EQ_GT,
    ACTIONS(4074), 28,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_operator,
      anon_sym_this,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [108698] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5369), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4502), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4504), 29,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [108780] = 32,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7124), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7242), 1,
      anon_sym_SLASH,
    ACTIONS(7246), 1,
      anon_sym_GT_GT,
    ACTIONS(7276), 1,
      anon_sym_as,
    ACTIONS(7278), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7238), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7240), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7244), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7256), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7268), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6116), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5370), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 11,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
  [108902] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5371), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4432), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4434), 29,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [108984] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5372), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4436), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4438), 29,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [109066] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5373), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4426), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4428), 29,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [109148] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7124), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7242), 1,
      anon_sym_SLASH,
    ACTIONS(7246), 1,
      anon_sym_GT_GT,
    ACTIONS(7260), 1,
      anon_sym_CARET,
    ACTIONS(7262), 1,
      anon_sym_PIPE,
    ACTIONS(7264), 1,
      anon_sym_AMP,
    ACTIONS(7276), 1,
      anon_sym_as,
    ACTIONS(7278), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7238), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7240), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7244), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7256), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7266), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7268), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 8,
      anon_sym_COLON,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
    STATE(5374), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [109278] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5375), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4099), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4106), 29,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [109360] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7291), 1,
      anon_sym_DOT,
    STATE(5376), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4426), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(4428), 29,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [109444] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7124), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7242), 1,
      anon_sym_SLASH,
    ACTIONS(7246), 1,
      anon_sym_GT_GT,
    ACTIONS(7260), 1,
      anon_sym_CARET,
    ACTIONS(7262), 1,
      anon_sym_PIPE,
    ACTIONS(7264), 1,
      anon_sym_AMP,
    ACTIONS(7270), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7276), 1,
      anon_sym_as,
    ACTIONS(7278), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7238), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7240), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7244), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7256), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7266), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7268), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 7,
      anon_sym_COLON,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
    STATE(5377), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [109576] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7124), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7242), 1,
      anon_sym_SLASH,
    ACTIONS(7246), 1,
      anon_sym_GT_GT,
    ACTIONS(7260), 1,
      anon_sym_CARET,
    ACTIONS(7262), 1,
      anon_sym_PIPE,
    ACTIONS(7264), 1,
      anon_sym_AMP,
    ACTIONS(7270), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7272), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7274), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7276), 1,
      anon_sym_as,
    ACTIONS(7278), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7238), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7240), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7244), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7256), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7266), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7268), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 5,
      anon_sym_COLON,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5378), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [109712] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5379), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4476), 12,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
    ACTIONS(4474), 28,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_operator,
      anon_sym_this,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [109794] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5380), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4422), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4424), 29,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [109876] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7250), 1,
      anon_sym_LBRACK,
    ACTIONS(7252), 1,
      anon_sym_STAR,
    ACTIONS(7254), 1,
      anon_sym_QMARK,
    ACTIONS(7396), 1,
      anon_sym_DOT,
    ACTIONS(4424), 8,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
    STATE(5381), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4422), 28,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_operator,
      anon_sym_this,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [109966] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7400), 1,
      anon_sym_QMARK,
    ACTIONS(7406), 1,
      anon_sym_SLASH,
    ACTIONS(7408), 1,
      anon_sym_CARET,
    ACTIONS(7410), 1,
      anon_sym_PIPE,
    ACTIONS(7412), 1,
      anon_sym_AMP,
    ACTIONS(7416), 1,
      anon_sym_GT_GT,
    ACTIONS(7422), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7424), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7426), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7428), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7430), 1,
      anon_sym_as,
    ACTIONS(7432), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7398), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7402), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7404), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7414), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7418), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7420), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5385), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_on,
    STATE(5382), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [110101] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5383), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2933), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(2935), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [110182] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5384), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1147), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(1133), 20,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [110281] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5385), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5763), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5761), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [110362] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5386), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5558), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5556), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [110443] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7210), 1,
      anon_sym_is,
    ACTIONS(7438), 1,
      anon_sym_QMARK,
    ACTIONS(7444), 1,
      anon_sym_SLASH,
    ACTIONS(7446), 1,
      anon_sym_CARET,
    ACTIONS(7448), 1,
      anon_sym_PIPE,
    ACTIONS(7450), 1,
      anon_sym_AMP,
    ACTIONS(7454), 1,
      anon_sym_GT_GT,
    ACTIONS(7460), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7462), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7464), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7466), 1,
      anon_sym_QMARK_QMARK,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7436), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7440), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7442), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7452), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7456), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7458), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5396), 4,
      anon_sym_SEMI,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(5387), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [110578] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7210), 1,
      anon_sym_is,
    ACTIONS(7438), 1,
      anon_sym_QMARK,
    ACTIONS(7444), 1,
      anon_sym_SLASH,
    ACTIONS(7446), 1,
      anon_sym_CARET,
    ACTIONS(7448), 1,
      anon_sym_PIPE,
    ACTIONS(7450), 1,
      anon_sym_AMP,
    ACTIONS(7454), 1,
      anon_sym_GT_GT,
    ACTIONS(7460), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7462), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7464), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7466), 1,
      anon_sym_QMARK_QMARK,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7436), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7440), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7442), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7452), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7456), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7458), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6216), 4,
      anon_sym_SEMI,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(5388), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [110713] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5389), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5810), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5808), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [110794] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5390), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5818), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5816), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [110875] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7210), 1,
      anon_sym_is,
    ACTIONS(7438), 1,
      anon_sym_QMARK,
    ACTIONS(7444), 1,
      anon_sym_SLASH,
    ACTIONS(7446), 1,
      anon_sym_CARET,
    ACTIONS(7448), 1,
      anon_sym_PIPE,
    ACTIONS(7450), 1,
      anon_sym_AMP,
    ACTIONS(7454), 1,
      anon_sym_GT_GT,
    ACTIONS(7460), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7462), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7464), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7466), 1,
      anon_sym_QMARK_QMARK,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7436), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7440), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7442), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7452), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7456), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7458), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6220), 4,
      anon_sym_SEMI,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(5391), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [111010] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5392), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5826), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5824), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [111091] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7468), 1,
      anon_sym_into,
    STATE(5408), 1,
      aux_sym__query_body_repeat2,
    STATE(5393), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6420), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6418), 26,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [111176] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7210), 1,
      anon_sym_is,
    ACTIONS(7438), 1,
      anon_sym_QMARK,
    ACTIONS(7444), 1,
      anon_sym_SLASH,
    ACTIONS(7446), 1,
      anon_sym_CARET,
    ACTIONS(7448), 1,
      anon_sym_PIPE,
    ACTIONS(7450), 1,
      anon_sym_AMP,
    ACTIONS(7454), 1,
      anon_sym_GT_GT,
    ACTIONS(7460), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7462), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7464), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7466), 1,
      anon_sym_QMARK_QMARK,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7436), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7440), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7442), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7452), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7456), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7458), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5385), 4,
      anon_sym_SEMI,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(5394), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [111311] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7468), 1,
      anon_sym_into,
    STATE(5409), 1,
      aux_sym__query_body_repeat2,
    STATE(5395), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6420), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6418), 26,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [111396] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5396), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5832), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4247), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [111477] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6230), 4,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    STATE(5397), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [111612] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5398), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5836), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5834), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [111693] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5399), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5840), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5838), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [111774] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5400), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5840), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5838), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [111855] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5401), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5347), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5345), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [111936] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7210), 1,
      anon_sym_is,
    ACTIONS(7438), 1,
      anon_sym_QMARK,
    ACTIONS(7444), 1,
      anon_sym_SLASH,
    ACTIONS(7446), 1,
      anon_sym_CARET,
    ACTIONS(7448), 1,
      anon_sym_PIPE,
    ACTIONS(7450), 1,
      anon_sym_AMP,
    ACTIONS(7454), 1,
      anon_sym_GT_GT,
    ACTIONS(7460), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7462), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7464), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7466), 1,
      anon_sym_QMARK_QMARK,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7436), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7440), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7442), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7452), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7456), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7458), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6236), 4,
      anon_sym_SEMI,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(5402), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [112071] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5403), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5321), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5319), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [112152] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5404), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5860), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5858), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [112233] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7210), 1,
      anon_sym_is,
    ACTIONS(7438), 1,
      anon_sym_QMARK,
    ACTIONS(7444), 1,
      anon_sym_SLASH,
    ACTIONS(7446), 1,
      anon_sym_CARET,
    ACTIONS(7448), 1,
      anon_sym_PIPE,
    ACTIONS(7450), 1,
      anon_sym_AMP,
    ACTIONS(7454), 1,
      anon_sym_GT_GT,
    ACTIONS(7460), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7462), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7464), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7466), 1,
      anon_sym_QMARK_QMARK,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7436), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7440), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7442), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7452), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7456), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7458), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5337), 4,
      anon_sym_SEMI,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(5405), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [112368] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5406), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5864), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5862), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [112449] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5407), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5872), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5870), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [112530] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7468), 1,
      anon_sym_into,
    STATE(5409), 1,
      aux_sym__query_body_repeat2,
    STATE(5408), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6383), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6381), 26,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [112615] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7502), 1,
      anon_sym_into,
    STATE(5409), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym__query_body_repeat2,
    ACTIONS(6376), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6374), 26,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [112698] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5410), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5769), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5767), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [112779] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5411), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5769), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5767), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [112860] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5412), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5876), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5874), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [112941] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5413), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5880), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5878), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [113022] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7509), 1,
      anon_sym_SLASH,
    ACTIONS(7511), 1,
      anon_sym_DOT_DOT,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7505), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7507), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6116), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5414), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 16,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
  [113131] = 25,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7509), 1,
      anon_sym_SLASH,
    ACTIONS(7511), 1,
      anon_sym_DOT_DOT,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7507), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6116), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5415), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 16,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
  [113238] = 28,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7509), 1,
      anon_sym_SLASH,
    ACTIONS(7511), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7515), 1,
      anon_sym_GT_GT,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7505), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7507), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7513), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6116), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5416), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 14,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
  [113351] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7210), 1,
      anon_sym_is,
    ACTIONS(7438), 1,
      anon_sym_QMARK,
    ACTIONS(7444), 1,
      anon_sym_SLASH,
    ACTIONS(7446), 1,
      anon_sym_CARET,
    ACTIONS(7448), 1,
      anon_sym_PIPE,
    ACTIONS(7450), 1,
      anon_sym_AMP,
    ACTIONS(7454), 1,
      anon_sym_GT_GT,
    ACTIONS(7460), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7462), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7464), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7466), 1,
      anon_sym_QMARK_QMARK,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7436), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7440), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7442), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7452), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7456), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7458), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5325), 4,
      anon_sym_SEMI,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(5417), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [113486] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4953), 1,
      anon_sym_DASH_GT,
    ACTIONS(5067), 1,
      anon_sym_DOT,
    ACTIONS(6973), 1,
      anon_sym_LPAREN,
    ACTIONS(7022), 1,
      anon_sym_LBRACK,
    ACTIONS(7026), 1,
      anon_sym_BANG,
    ACTIONS(7042), 1,
      anon_sym_switch,
    ACTIONS(7046), 1,
      anon_sym_as,
    ACTIONS(7050), 1,
      anon_sym_with,
    ACTIONS(7519), 1,
      anon_sym_QMARK,
    ACTIONS(7525), 1,
      anon_sym_SLASH,
    ACTIONS(7527), 1,
      anon_sym_CARET,
    ACTIONS(7529), 1,
      anon_sym_PIPE,
    ACTIONS(7531), 1,
      anon_sym_AMP,
    ACTIONS(7535), 1,
      anon_sym_GT_GT,
    ACTIONS(7541), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7543), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7545), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7547), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7549), 1,
      anon_sym_is,
    STATE(3870), 1,
      sym_bracketed_argument_list,
    STATE(5721), 1,
      sym_argument_list,
    ACTIONS(7028), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7517), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7521), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7523), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7533), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7537), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7539), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6220), 4,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_into,
    STATE(5418), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [113621] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4953), 1,
      anon_sym_DASH_GT,
    ACTIONS(5067), 1,
      anon_sym_DOT,
    ACTIONS(6973), 1,
      anon_sym_LPAREN,
    ACTIONS(7022), 1,
      anon_sym_LBRACK,
    ACTIONS(7026), 1,
      anon_sym_BANG,
    ACTIONS(7541), 1,
      anon_sym_DOT_DOT,
    STATE(3870), 1,
      sym_bracketed_argument_list,
    STATE(5721), 1,
      sym_argument_list,
    ACTIONS(7028), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5419), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1147), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(1133), 20,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [113720] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7210), 1,
      anon_sym_is,
    ACTIONS(7438), 1,
      anon_sym_QMARK,
    ACTIONS(7444), 1,
      anon_sym_SLASH,
    ACTIONS(7446), 1,
      anon_sym_CARET,
    ACTIONS(7448), 1,
      anon_sym_PIPE,
    ACTIONS(7450), 1,
      anon_sym_AMP,
    ACTIONS(7454), 1,
      anon_sym_GT_GT,
    ACTIONS(7460), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7462), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7464), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7466), 1,
      anon_sym_QMARK_QMARK,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7436), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7440), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7442), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7452), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7456), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7458), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6230), 4,
      anon_sym_SEMI,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(5420), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [113855] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7551), 1,
      anon_sym_and,
    ACTIONS(7553), 1,
      anon_sym_or,
    STATE(5421), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5856), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5854), 26,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [113940] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(2738), 1,
      sym_generic_name,
    STATE(5368), 1,
      sym_identifier,
    STATE(6790), 1,
      sym_attribute_target_specifier,
    STATE(8106), 1,
      sym__name,
    STATE(8660), 1,
      sym_attribute,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    ACTIONS(1045), 7,
      anon_sym_field,
      anon_sym_event,
      anon_sym_method,
      anon_sym_param,
      anon_sym_property,
      anon_sym_return,
      anon_sym_type,
    STATE(5422), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [114037] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5423), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5852), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5850), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [114118] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5424), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5848), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5846), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [114199] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5425), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5844), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5842), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [114280] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5426), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5814), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5812), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [114361] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5427), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5570), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5568), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [114442] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7210), 1,
      anon_sym_is,
    ACTIONS(7438), 1,
      anon_sym_QMARK,
    ACTIONS(7444), 1,
      anon_sym_SLASH,
    ACTIONS(7446), 1,
      anon_sym_CARET,
    ACTIONS(7448), 1,
      anon_sym_PIPE,
    ACTIONS(7450), 1,
      anon_sym_AMP,
    ACTIONS(7454), 1,
      anon_sym_GT_GT,
    ACTIONS(7460), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7462), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7464), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7466), 1,
      anon_sym_QMARK_QMARK,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7436), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7440), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7442), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7452), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7456), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7458), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5510), 4,
      anon_sym_SEMI,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(5428), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [114577] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7444), 1,
      anon_sym_SLASH,
    ACTIONS(7460), 1,
      anon_sym_DOT_DOT,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7440), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7442), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6116), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5429), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 16,
      anon_sym_SEMI,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [114686] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7250), 1,
      anon_sym_LBRACK,
    ACTIONS(7252), 1,
      anon_sym_STAR,
    ACTIONS(7254), 1,
      anon_sym_QMARK,
    ACTIONS(4562), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4424), 8,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
    STATE(5430), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4422), 26,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [114775] = 28,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7559), 1,
      anon_sym_SLASH,
    ACTIONS(7563), 1,
      anon_sym_GT_GT,
    ACTIONS(7565), 1,
      anon_sym_DOT_DOT,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7555), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7557), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7561), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6116), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5431), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 14,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [114888] = 25,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7559), 1,
      anon_sym_SLASH,
    ACTIONS(7565), 1,
      anon_sym_DOT_DOT,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7557), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6116), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5432), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 16,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [114995] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7559), 1,
      anon_sym_SLASH,
    ACTIONS(7563), 1,
      anon_sym_GT_GT,
    ACTIONS(7565), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7569), 1,
      anon_sym_AMP,
    ACTIONS(7575), 1,
      anon_sym_as,
    ACTIONS(7577), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6116), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7555), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7557), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7561), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7567), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7571), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7573), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 8,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(5433), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [115120] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7559), 1,
      anon_sym_SLASH,
    ACTIONS(7563), 1,
      anon_sym_GT_GT,
    ACTIONS(7565), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7569), 1,
      anon_sym_AMP,
    ACTIONS(7575), 1,
      anon_sym_as,
    ACTIONS(7577), 1,
      anon_sym_is,
    ACTIONS(7579), 1,
      anon_sym_CARET,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6116), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7555), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7557), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7561), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7567), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7571), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7573), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 7,
      anon_sym_COLON,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(5434), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [115247] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7559), 1,
      anon_sym_SLASH,
    ACTIONS(7563), 1,
      anon_sym_GT_GT,
    ACTIONS(7565), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7575), 1,
      anon_sym_as,
    ACTIONS(7577), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7555), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7557), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7561), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7567), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7571), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7573), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6116), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(6114), 8,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(5435), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [115370] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7559), 1,
      anon_sym_SLASH,
    ACTIONS(7565), 1,
      anon_sym_DOT_DOT,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7555), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7557), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6116), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5436), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 16,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [115479] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7581), 1,
      anon_sym_and,
    ACTIONS(7583), 1,
      anon_sym_or,
    STATE(5437), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5856), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5854), 26,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [115564] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5438), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5446), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5444), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [115645] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7581), 1,
      anon_sym_and,
    ACTIONS(7583), 1,
      anon_sym_or,
    STATE(5439), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6609), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6607), 26,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [115730] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5440), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2921), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(2923), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [115811] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6330), 1,
      anon_sym_as,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7587), 1,
      anon_sym_QMARK,
    ACTIONS(7593), 1,
      anon_sym_SLASH,
    ACTIONS(7595), 1,
      anon_sym_CARET,
    ACTIONS(7597), 1,
      anon_sym_PIPE,
    ACTIONS(7599), 1,
      anon_sym_AMP,
    ACTIONS(7603), 1,
      anon_sym_GT_GT,
    ACTIONS(7609), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7611), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7613), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7615), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7617), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7585), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7589), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7591), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7601), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7605), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7607), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6220), 4,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5441), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [115946] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7210), 1,
      anon_sym_is,
    ACTIONS(7438), 1,
      anon_sym_QMARK,
    ACTIONS(7444), 1,
      anon_sym_SLASH,
    ACTIONS(7446), 1,
      anon_sym_CARET,
    ACTIONS(7448), 1,
      anon_sym_PIPE,
    ACTIONS(7450), 1,
      anon_sym_AMP,
    ACTIONS(7454), 1,
      anon_sym_GT_GT,
    ACTIONS(7460), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7462), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7464), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7466), 1,
      anon_sym_QMARK_QMARK,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7436), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7440), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7442), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7452), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7456), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7458), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5420), 4,
      anon_sym_SEMI,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(5442), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [116081] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7210), 1,
      anon_sym_is,
    ACTIONS(7444), 1,
      anon_sym_SLASH,
    ACTIONS(7446), 1,
      anon_sym_CARET,
    ACTIONS(7448), 1,
      anon_sym_PIPE,
    ACTIONS(7450), 1,
      anon_sym_AMP,
    ACTIONS(7454), 1,
      anon_sym_GT_GT,
    ACTIONS(7460), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7462), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7464), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7466), 1,
      anon_sym_QMARK_QMARK,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7436), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7440), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7442), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7452), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7456), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7458), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 4,
      anon_sym_SEMI,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(5443), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [116216] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7210), 1,
      anon_sym_is,
    ACTIONS(7444), 1,
      anon_sym_SLASH,
    ACTIONS(7446), 1,
      anon_sym_CARET,
    ACTIONS(7448), 1,
      anon_sym_PIPE,
    ACTIONS(7450), 1,
      anon_sym_AMP,
    ACTIONS(7454), 1,
      anon_sym_GT_GT,
    ACTIONS(7460), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7462), 1,
      anon_sym_AMP_AMP,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7436), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7440), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7442), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7452), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7456), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7458), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 6,
      anon_sym_SEMI,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(5444), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [116347] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5445), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5822), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5820), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [116428] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7210), 1,
      anon_sym_is,
    ACTIONS(7444), 1,
      anon_sym_SLASH,
    ACTIONS(7446), 1,
      anon_sym_CARET,
    ACTIONS(7448), 1,
      anon_sym_PIPE,
    ACTIONS(7450), 1,
      anon_sym_AMP,
    ACTIONS(7454), 1,
      anon_sym_GT_GT,
    ACTIONS(7460), 1,
      anon_sym_DOT_DOT,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7436), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7440), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7442), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7452), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7456), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7458), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 7,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(5446), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [116557] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(7460), 1,
      anon_sym_DOT_DOT,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5447), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6122), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6120), 20,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [116656] = 32,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7210), 1,
      anon_sym_is,
    ACTIONS(7444), 1,
      anon_sym_SLASH,
    ACTIONS(7454), 1,
      anon_sym_GT_GT,
    ACTIONS(7460), 1,
      anon_sym_DOT_DOT,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7436), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7440), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7442), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7452), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7458), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6116), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5448), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 10,
      anon_sym_SEMI,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [116777] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7621), 1,
      anon_sym_QMARK,
    ACTIONS(7627), 1,
      anon_sym_SLASH,
    ACTIONS(7629), 1,
      anon_sym_CARET,
    ACTIONS(7631), 1,
      anon_sym_PIPE,
    ACTIONS(7633), 1,
      anon_sym_AMP,
    ACTIONS(7637), 1,
      anon_sym_GT_GT,
    ACTIONS(7643), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7645), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7647), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7649), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7651), 1,
      anon_sym_as,
    ACTIONS(7653), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7619), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7623), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7625), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7635), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7639), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7641), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6230), 4,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    STATE(5449), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [116912] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5450), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5339), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5337), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [116993] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7210), 1,
      anon_sym_is,
    ACTIONS(7444), 1,
      anon_sym_SLASH,
    ACTIONS(7454), 1,
      anon_sym_GT_GT,
    ACTIONS(7460), 1,
      anon_sym_DOT_DOT,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7436), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7440), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7442), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7452), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7456), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7458), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6116), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(6114), 8,
      anon_sym_SEMI,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(5451), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [117116] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7210), 1,
      anon_sym_is,
    ACTIONS(7444), 1,
      anon_sym_SLASH,
    ACTIONS(7446), 1,
      anon_sym_CARET,
    ACTIONS(7450), 1,
      anon_sym_AMP,
    ACTIONS(7454), 1,
      anon_sym_GT_GT,
    ACTIONS(7460), 1,
      anon_sym_DOT_DOT,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6116), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7436), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7440), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7442), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7452), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7456), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7458), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 7,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(5452), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [117243] = 32,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7559), 1,
      anon_sym_SLASH,
    ACTIONS(7563), 1,
      anon_sym_GT_GT,
    ACTIONS(7565), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7575), 1,
      anon_sym_as,
    ACTIONS(7577), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7555), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7557), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7561), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7567), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7573), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6116), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5453), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 10,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [117364] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7210), 1,
      anon_sym_is,
    ACTIONS(7444), 1,
      anon_sym_SLASH,
    ACTIONS(7450), 1,
      anon_sym_AMP,
    ACTIONS(7454), 1,
      anon_sym_GT_GT,
    ACTIONS(7460), 1,
      anon_sym_DOT_DOT,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6116), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7436), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7440), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7442), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7452), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7456), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7458), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 8,
      anon_sym_SEMI,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(5454), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [117489] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7460), 1,
      anon_sym_DOT_DOT,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5455), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6116), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6114), 18,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [117592] = 25,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7444), 1,
      anon_sym_SLASH,
    ACTIONS(7460), 1,
      anon_sym_DOT_DOT,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7442), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6116), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5456), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 16,
      anon_sym_SEMI,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [117699] = 28,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7444), 1,
      anon_sym_SLASH,
    ACTIONS(7454), 1,
      anon_sym_GT_GT,
    ACTIONS(7460), 1,
      anon_sym_DOT_DOT,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7440), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7442), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7452), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6116), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5457), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 14,
      anon_sym_SEMI,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [117812] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7559), 1,
      anon_sym_SLASH,
    ACTIONS(7563), 1,
      anon_sym_GT_GT,
    ACTIONS(7565), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7569), 1,
      anon_sym_AMP,
    ACTIONS(7575), 1,
      anon_sym_as,
    ACTIONS(7577), 1,
      anon_sym_is,
    ACTIONS(7579), 1,
      anon_sym_CARET,
    ACTIONS(7655), 1,
      anon_sym_PIPE,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7555), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7557), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7561), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7567), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7571), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7573), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 7,
      anon_sym_COLON,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(5458), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [117941] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7559), 1,
      anon_sym_SLASH,
    ACTIONS(7563), 1,
      anon_sym_GT_GT,
    ACTIONS(7565), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7569), 1,
      anon_sym_AMP,
    ACTIONS(7575), 1,
      anon_sym_as,
    ACTIONS(7577), 1,
      anon_sym_is,
    ACTIONS(7579), 1,
      anon_sym_CARET,
    ACTIONS(7655), 1,
      anon_sym_PIPE,
    ACTIONS(7657), 1,
      anon_sym_AMP_AMP,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7555), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7557), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7561), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7567), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7571), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7573), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 6,
      anon_sym_COLON,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(5459), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [118072] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4739), 6,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5460), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5789), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5786), 22,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [118155] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7559), 1,
      anon_sym_SLASH,
    ACTIONS(7563), 1,
      anon_sym_GT_GT,
    ACTIONS(7565), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7569), 1,
      anon_sym_AMP,
    ACTIONS(7575), 1,
      anon_sym_as,
    ACTIONS(7577), 1,
      anon_sym_is,
    ACTIONS(7579), 1,
      anon_sym_CARET,
    ACTIONS(7655), 1,
      anon_sym_PIPE,
    ACTIONS(7657), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7659), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7661), 1,
      anon_sym_QMARK_QMARK,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7555), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7557), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7561), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7567), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7571), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7573), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 4,
      anon_sym_COLON,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
    STATE(5461), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [118290] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4739), 6,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5462), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5795), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5792), 22,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [118373] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5463), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5442), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5440), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [118454] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5464), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5351), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5349), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [118535] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5465), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5355), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5353), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [118616] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5466), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5359), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5357), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [118697] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5467), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5363), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5361), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [118778] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7559), 1,
      anon_sym_SLASH,
    ACTIONS(7563), 1,
      anon_sym_GT_GT,
    ACTIONS(7565), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7569), 1,
      anon_sym_AMP,
    ACTIONS(7575), 1,
      anon_sym_as,
    ACTIONS(7577), 1,
      anon_sym_is,
    ACTIONS(7579), 1,
      anon_sym_CARET,
    ACTIONS(7655), 1,
      anon_sym_PIPE,
    ACTIONS(7657), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7659), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7661), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7663), 1,
      anon_sym_QMARK,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7555), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7557), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7561), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7567), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7571), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7573), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6236), 4,
      anon_sym_COLON,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
    STATE(5468), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [118913] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(7565), 1,
      anon_sym_DOT_DOT,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5469), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6122), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6120), 20,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [119012] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7559), 1,
      anon_sym_SLASH,
    ACTIONS(7563), 1,
      anon_sym_GT_GT,
    ACTIONS(7565), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7569), 1,
      anon_sym_AMP,
    ACTIONS(7575), 1,
      anon_sym_as,
    ACTIONS(7577), 1,
      anon_sym_is,
    ACTIONS(7579), 1,
      anon_sym_CARET,
    ACTIONS(7655), 1,
      anon_sym_PIPE,
    ACTIONS(7657), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7659), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7661), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7663), 1,
      anon_sym_QMARK,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7555), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7557), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7561), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7567), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7571), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7573), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6230), 4,
      anon_sym_COLON,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
    STATE(5470), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [119147] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7559), 1,
      anon_sym_SLASH,
    ACTIONS(7563), 1,
      anon_sym_GT_GT,
    ACTIONS(7565), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7569), 1,
      anon_sym_AMP,
    ACTIONS(7575), 1,
      anon_sym_as,
    ACTIONS(7577), 1,
      anon_sym_is,
    ACTIONS(7579), 1,
      anon_sym_CARET,
    ACTIONS(7655), 1,
      anon_sym_PIPE,
    ACTIONS(7657), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7659), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7661), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7663), 1,
      anon_sym_QMARK,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7555), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7557), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7561), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7567), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7571), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7573), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5420), 4,
      anon_sym_COLON,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
    STATE(5471), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [119282] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(2738), 1,
      sym_generic_name,
    STATE(5368), 1,
      sym_identifier,
    STATE(6782), 1,
      sym_attribute_target_specifier,
    STATE(8106), 1,
      sym__name,
    STATE(8359), 1,
      sym_attribute,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    ACTIONS(1045), 7,
      anon_sym_field,
      anon_sym_event,
      anon_sym_method,
      anon_sym_param,
      anon_sym_property,
      anon_sym_return,
      anon_sym_type,
    STATE(5472), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [119379] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7511), 1,
      anon_sym_DOT_DOT,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5473), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6116), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6114), 18,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
  [119482] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7559), 1,
      anon_sym_SLASH,
    ACTIONS(7563), 1,
      anon_sym_GT_GT,
    ACTIONS(7565), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7569), 1,
      anon_sym_AMP,
    ACTIONS(7575), 1,
      anon_sym_as,
    ACTIONS(7577), 1,
      anon_sym_is,
    ACTIONS(7579), 1,
      anon_sym_CARET,
    ACTIONS(7655), 1,
      anon_sym_PIPE,
    ACTIONS(7657), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7659), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7661), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7663), 1,
      anon_sym_QMARK,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7555), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7557), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7561), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7567), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7571), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7573), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5510), 4,
      anon_sym_COLON,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
    STATE(5474), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [119617] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7621), 1,
      anon_sym_QMARK,
    ACTIONS(7627), 1,
      anon_sym_SLASH,
    ACTIONS(7629), 1,
      anon_sym_CARET,
    ACTIONS(7631), 1,
      anon_sym_PIPE,
    ACTIONS(7633), 1,
      anon_sym_AMP,
    ACTIONS(7637), 1,
      anon_sym_GT_GT,
    ACTIONS(7643), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7645), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7647), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7649), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7651), 1,
      anon_sym_as,
    ACTIONS(7653), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7619), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7623), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7625), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7635), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7639), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7641), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6236), 4,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    STATE(5475), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [119752] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6330), 1,
      anon_sym_as,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7587), 1,
      anon_sym_QMARK,
    ACTIONS(7593), 1,
      anon_sym_SLASH,
    ACTIONS(7595), 1,
      anon_sym_CARET,
    ACTIONS(7597), 1,
      anon_sym_PIPE,
    ACTIONS(7599), 1,
      anon_sym_AMP,
    ACTIONS(7603), 1,
      anon_sym_GT_GT,
    ACTIONS(7609), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7611), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7613), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7615), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7617), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7585), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7589), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7591), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7601), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7605), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7607), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6173), 4,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5476), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [119887] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7509), 1,
      anon_sym_SLASH,
    ACTIONS(7511), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7515), 1,
      anon_sym_GT_GT,
    ACTIONS(7667), 1,
      anon_sym_QMARK,
    ACTIONS(7669), 1,
      anon_sym_CARET,
    ACTIONS(7671), 1,
      anon_sym_PIPE,
    ACTIONS(7673), 1,
      anon_sym_AMP,
    ACTIONS(7679), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7681), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7683), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7685), 1,
      anon_sym_as,
    ACTIONS(7687), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7505), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7507), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7513), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7665), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7675), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7677), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6236), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_by,
    STATE(5477), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [120022] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7559), 1,
      anon_sym_SLASH,
    ACTIONS(7563), 1,
      anon_sym_GT_GT,
    ACTIONS(7565), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7569), 1,
      anon_sym_AMP,
    ACTIONS(7575), 1,
      anon_sym_as,
    ACTIONS(7577), 1,
      anon_sym_is,
    ACTIONS(7579), 1,
      anon_sym_CARET,
    ACTIONS(7655), 1,
      anon_sym_PIPE,
    ACTIONS(7657), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7659), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7661), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7663), 1,
      anon_sym_QMARK,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7555), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7557), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7561), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7567), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7571), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7573), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5325), 4,
      anon_sym_COLON,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
    STATE(5478), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [120157] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7559), 1,
      anon_sym_SLASH,
    ACTIONS(7563), 1,
      anon_sym_GT_GT,
    ACTIONS(7565), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7569), 1,
      anon_sym_AMP,
    ACTIONS(7575), 1,
      anon_sym_as,
    ACTIONS(7577), 1,
      anon_sym_is,
    ACTIONS(7579), 1,
      anon_sym_CARET,
    ACTIONS(7655), 1,
      anon_sym_PIPE,
    ACTIONS(7657), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7659), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7661), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7663), 1,
      anon_sym_QMARK,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7555), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7557), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7561), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7567), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7571), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7573), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6216), 4,
      anon_sym_COLON,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
    STATE(5479), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [120292] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7509), 1,
      anon_sym_SLASH,
    ACTIONS(7511), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7515), 1,
      anon_sym_GT_GT,
    ACTIONS(7667), 1,
      anon_sym_QMARK,
    ACTIONS(7669), 1,
      anon_sym_CARET,
    ACTIONS(7671), 1,
      anon_sym_PIPE,
    ACTIONS(7673), 1,
      anon_sym_AMP,
    ACTIONS(7679), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7681), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7683), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7685), 1,
      anon_sym_as,
    ACTIONS(7687), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7505), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7507), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7513), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7665), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7675), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7677), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6230), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_by,
    STATE(5480), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [120427] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7509), 1,
      anon_sym_SLASH,
    ACTIONS(7511), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7515), 1,
      anon_sym_GT_GT,
    ACTIONS(7667), 1,
      anon_sym_QMARK,
    ACTIONS(7669), 1,
      anon_sym_CARET,
    ACTIONS(7671), 1,
      anon_sym_PIPE,
    ACTIONS(7673), 1,
      anon_sym_AMP,
    ACTIONS(7679), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7681), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7683), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7685), 1,
      anon_sym_as,
    ACTIONS(7687), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7505), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7507), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7513), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7665), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7675), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7677), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5420), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_by,
    STATE(5481), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [120562] = 28,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7693), 1,
      anon_sym_SLASH,
    ACTIONS(7697), 1,
      anon_sym_GT_GT,
    ACTIONS(7699), 1,
      anon_sym_DOT_DOT,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7689), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7691), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7695), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6116), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5482), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 14,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [120675] = 25,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7693), 1,
      anon_sym_SLASH,
    ACTIONS(7699), 1,
      anon_sym_DOT_DOT,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7691), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6116), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5483), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 16,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [120782] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7575), 1,
      anon_sym_as,
    ACTIONS(7693), 1,
      anon_sym_SLASH,
    ACTIONS(7697), 1,
      anon_sym_GT_GT,
    ACTIONS(7699), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7703), 1,
      anon_sym_AMP,
    ACTIONS(7709), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6116), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7689), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7691), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7695), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7701), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7705), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7707), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 8,
      anon_sym_CARET,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(5484), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [120907] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7575), 1,
      anon_sym_as,
    ACTIONS(7693), 1,
      anon_sym_SLASH,
    ACTIONS(7697), 1,
      anon_sym_GT_GT,
    ACTIONS(7699), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7703), 1,
      anon_sym_AMP,
    ACTIONS(7709), 1,
      anon_sym_is,
    ACTIONS(7711), 1,
      anon_sym_CARET,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6116), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7689), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7691), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7695), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7701), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7705), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7707), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 7,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(5485), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [121034] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7575), 1,
      anon_sym_as,
    ACTIONS(7693), 1,
      anon_sym_SLASH,
    ACTIONS(7697), 1,
      anon_sym_GT_GT,
    ACTIONS(7699), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7709), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7689), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7691), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7695), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7701), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7705), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7707), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6116), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(6114), 8,
      anon_sym_CARET,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(5486), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [121157] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7693), 1,
      anon_sym_SLASH,
    ACTIONS(7699), 1,
      anon_sym_DOT_DOT,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7689), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7691), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6116), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5487), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 16,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [121266] = 32,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7575), 1,
      anon_sym_as,
    ACTIONS(7693), 1,
      anon_sym_SLASH,
    ACTIONS(7697), 1,
      anon_sym_GT_GT,
    ACTIONS(7699), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7709), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7689), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7691), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7695), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7701), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7707), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6116), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5488), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 10,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [121387] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7575), 1,
      anon_sym_as,
    ACTIONS(7693), 1,
      anon_sym_SLASH,
    ACTIONS(7697), 1,
      anon_sym_GT_GT,
    ACTIONS(7699), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7703), 1,
      anon_sym_AMP,
    ACTIONS(7709), 1,
      anon_sym_is,
    ACTIONS(7711), 1,
      anon_sym_CARET,
    ACTIONS(7713), 1,
      anon_sym_PIPE,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7689), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7691), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7695), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7701), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7705), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7707), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 7,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(5489), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [121516] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7575), 1,
      anon_sym_as,
    ACTIONS(7693), 1,
      anon_sym_SLASH,
    ACTIONS(7697), 1,
      anon_sym_GT_GT,
    ACTIONS(7699), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7703), 1,
      anon_sym_AMP,
    ACTIONS(7709), 1,
      anon_sym_is,
    ACTIONS(7711), 1,
      anon_sym_CARET,
    ACTIONS(7713), 1,
      anon_sym_PIPE,
    ACTIONS(7715), 1,
      anon_sym_AMP_AMP,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7689), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7691), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7695), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7701), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7705), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7707), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 6,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(5490), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [121647] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7575), 1,
      anon_sym_as,
    ACTIONS(7693), 1,
      anon_sym_SLASH,
    ACTIONS(7697), 1,
      anon_sym_GT_GT,
    ACTIONS(7699), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7703), 1,
      anon_sym_AMP,
    ACTIONS(7709), 1,
      anon_sym_is,
    ACTIONS(7711), 1,
      anon_sym_CARET,
    ACTIONS(7713), 1,
      anon_sym_PIPE,
    ACTIONS(7715), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7717), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7719), 1,
      anon_sym_QMARK_QMARK,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7689), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7691), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7695), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7701), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7705), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7707), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 4,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
    STATE(5491), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [121782] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7509), 1,
      anon_sym_SLASH,
    ACTIONS(7511), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7515), 1,
      anon_sym_GT_GT,
    ACTIONS(7667), 1,
      anon_sym_QMARK,
    ACTIONS(7669), 1,
      anon_sym_CARET,
    ACTIONS(7671), 1,
      anon_sym_PIPE,
    ACTIONS(7673), 1,
      anon_sym_AMP,
    ACTIONS(7679), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7681), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7683), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7685), 1,
      anon_sym_as,
    ACTIONS(7687), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7505), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7507), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7513), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7665), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7675), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7677), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5510), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_by,
    STATE(5492), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [121917] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7559), 1,
      anon_sym_SLASH,
    ACTIONS(7563), 1,
      anon_sym_GT_GT,
    ACTIONS(7565), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7569), 1,
      anon_sym_AMP,
    ACTIONS(7575), 1,
      anon_sym_as,
    ACTIONS(7577), 1,
      anon_sym_is,
    ACTIONS(7579), 1,
      anon_sym_CARET,
    ACTIONS(7655), 1,
      anon_sym_PIPE,
    ACTIONS(7657), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7659), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7661), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7663), 1,
      anon_sym_QMARK,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7555), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7557), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7561), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7567), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7571), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7573), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5396), 4,
      anon_sym_COLON,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
    STATE(5493), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [122052] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7509), 1,
      anon_sym_SLASH,
    ACTIONS(7511), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7515), 1,
      anon_sym_GT_GT,
    ACTIONS(7667), 1,
      anon_sym_QMARK,
    ACTIONS(7669), 1,
      anon_sym_CARET,
    ACTIONS(7671), 1,
      anon_sym_PIPE,
    ACTIONS(7673), 1,
      anon_sym_AMP,
    ACTIONS(7679), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7681), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7683), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7685), 1,
      anon_sym_as,
    ACTIONS(7687), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7505), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7507), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7513), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7665), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7675), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7677), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5325), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_by,
    STATE(5494), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [122187] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7509), 1,
      anon_sym_SLASH,
    ACTIONS(7511), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7515), 1,
      anon_sym_GT_GT,
    ACTIONS(7667), 1,
      anon_sym_QMARK,
    ACTIONS(7669), 1,
      anon_sym_CARET,
    ACTIONS(7671), 1,
      anon_sym_PIPE,
    ACTIONS(7673), 1,
      anon_sym_AMP,
    ACTIONS(7679), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7681), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7683), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7685), 1,
      anon_sym_as,
    ACTIONS(7687), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7505), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7507), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7513), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7665), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7675), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7677), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6216), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_by,
    STATE(5495), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [122322] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7509), 1,
      anon_sym_SLASH,
    ACTIONS(7511), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7515), 1,
      anon_sym_GT_GT,
    ACTIONS(7667), 1,
      anon_sym_QMARK,
    ACTIONS(7669), 1,
      anon_sym_CARET,
    ACTIONS(7671), 1,
      anon_sym_PIPE,
    ACTIONS(7673), 1,
      anon_sym_AMP,
    ACTIONS(7679), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7681), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7683), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7685), 1,
      anon_sym_as,
    ACTIONS(7687), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7505), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7507), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7513), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7665), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7675), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7677), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5396), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_by,
    STATE(5496), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [122457] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7509), 1,
      anon_sym_SLASH,
    ACTIONS(7511), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7515), 1,
      anon_sym_GT_GT,
    ACTIONS(7667), 1,
      anon_sym_QMARK,
    ACTIONS(7669), 1,
      anon_sym_CARET,
    ACTIONS(7671), 1,
      anon_sym_PIPE,
    ACTIONS(7673), 1,
      anon_sym_AMP,
    ACTIONS(7679), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7681), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7683), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7685), 1,
      anon_sym_as,
    ACTIONS(7687), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7505), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7507), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7513), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7665), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7675), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7677), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5385), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_by,
    STATE(5497), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [122592] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7509), 1,
      anon_sym_SLASH,
    ACTIONS(7511), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7515), 1,
      anon_sym_GT_GT,
    ACTIONS(7667), 1,
      anon_sym_QMARK,
    ACTIONS(7669), 1,
      anon_sym_CARET,
    ACTIONS(7671), 1,
      anon_sym_PIPE,
    ACTIONS(7673), 1,
      anon_sym_AMP,
    ACTIONS(7679), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7681), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7683), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7685), 1,
      anon_sym_as,
    ACTIONS(7687), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7505), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7507), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7513), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7665), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7675), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7677), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5337), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_by,
    STATE(5498), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [122727] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7509), 1,
      anon_sym_SLASH,
    ACTIONS(7511), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7515), 1,
      anon_sym_GT_GT,
    ACTIONS(7667), 1,
      anon_sym_QMARK,
    ACTIONS(7669), 1,
      anon_sym_CARET,
    ACTIONS(7671), 1,
      anon_sym_PIPE,
    ACTIONS(7673), 1,
      anon_sym_AMP,
    ACTIONS(7679), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7681), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7683), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7685), 1,
      anon_sym_as,
    ACTIONS(7687), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7505), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7507), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7513), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7665), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7675), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7677), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6220), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_by,
    STATE(5499), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [122862] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7559), 1,
      anon_sym_SLASH,
    ACTIONS(7563), 1,
      anon_sym_GT_GT,
    ACTIONS(7565), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7569), 1,
      anon_sym_AMP,
    ACTIONS(7575), 1,
      anon_sym_as,
    ACTIONS(7577), 1,
      anon_sym_is,
    ACTIONS(7579), 1,
      anon_sym_CARET,
    ACTIONS(7655), 1,
      anon_sym_PIPE,
    ACTIONS(7657), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7659), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7661), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7663), 1,
      anon_sym_QMARK,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7555), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7557), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7561), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7567), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7571), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7573), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5385), 4,
      anon_sym_COLON,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
    STATE(5500), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [122997] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7721), 1,
      anon_sym_and,
    STATE(5501), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6546), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6544), 27,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [123080] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6220), 4,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    STATE(5502), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [123215] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6236), 4,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    STATE(5503), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [123350] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7559), 1,
      anon_sym_SLASH,
    ACTIONS(7563), 1,
      anon_sym_GT_GT,
    ACTIONS(7565), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7569), 1,
      anon_sym_AMP,
    ACTIONS(7575), 1,
      anon_sym_as,
    ACTIONS(7577), 1,
      anon_sym_is,
    ACTIONS(7579), 1,
      anon_sym_CARET,
    ACTIONS(7655), 1,
      anon_sym_PIPE,
    ACTIONS(7657), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7659), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7661), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7663), 1,
      anon_sym_QMARK,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7555), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7557), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7561), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7567), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7571), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7573), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5337), 4,
      anon_sym_COLON,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
    STATE(5504), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [123485] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5505), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5383), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5381), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [123566] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7559), 1,
      anon_sym_SLASH,
    ACTIONS(7563), 1,
      anon_sym_GT_GT,
    ACTIONS(7565), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7569), 1,
      anon_sym_AMP,
    ACTIONS(7575), 1,
      anon_sym_as,
    ACTIONS(7577), 1,
      anon_sym_is,
    ACTIONS(7579), 1,
      anon_sym_CARET,
    ACTIONS(7655), 1,
      anon_sym_PIPE,
    ACTIONS(7657), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7659), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7661), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7663), 1,
      anon_sym_QMARK,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7555), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7557), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7561), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7567), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7571), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7573), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6220), 4,
      anon_sym_COLON,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
    STATE(5506), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [123701] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6330), 1,
      anon_sym_as,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7587), 1,
      anon_sym_QMARK,
    ACTIONS(7593), 1,
      anon_sym_SLASH,
    ACTIONS(7595), 1,
      anon_sym_CARET,
    ACTIONS(7597), 1,
      anon_sym_PIPE,
    ACTIONS(7599), 1,
      anon_sym_AMP,
    ACTIONS(7603), 1,
      anon_sym_GT_GT,
    ACTIONS(7609), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7611), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7613), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7615), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7617), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7585), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7589), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7591), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7601), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7605), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7607), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5337), 4,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5507), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [123836] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5508), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5387), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5385), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [123917] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7723), 1,
      anon_sym_into,
    STATE(5511), 1,
      aux_sym__query_body_repeat2,
    STATE(5509), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6383), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6381), 26,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_when,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [124002] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6330), 1,
      anon_sym_as,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7587), 1,
      anon_sym_QMARK,
    ACTIONS(7593), 1,
      anon_sym_SLASH,
    ACTIONS(7595), 1,
      anon_sym_CARET,
    ACTIONS(7597), 1,
      anon_sym_PIPE,
    ACTIONS(7599), 1,
      anon_sym_AMP,
    ACTIONS(7603), 1,
      anon_sym_GT_GT,
    ACTIONS(7609), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7611), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7613), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7615), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7617), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7585), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7589), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7591), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7601), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7605), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7607), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5385), 4,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5510), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [124137] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7725), 1,
      anon_sym_into,
    STATE(5511), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym__query_body_repeat2,
    ACTIONS(6376), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6374), 26,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_when,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [124220] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7723), 1,
      anon_sym_into,
    STATE(5509), 1,
      aux_sym__query_body_repeat2,
    STATE(5512), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6420), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6418), 26,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_when,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [124305] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5513), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5398), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5396), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [124386] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6330), 1,
      anon_sym_as,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7587), 1,
      anon_sym_QMARK,
    ACTIONS(7593), 1,
      anon_sym_SLASH,
    ACTIONS(7595), 1,
      anon_sym_CARET,
    ACTIONS(7597), 1,
      anon_sym_PIPE,
    ACTIONS(7599), 1,
      anon_sym_AMP,
    ACTIONS(7603), 1,
      anon_sym_GT_GT,
    ACTIONS(7609), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7611), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7613), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7615), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7617), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7585), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7589), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7591), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7601), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7605), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7607), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5396), 4,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5514), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [124521] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7581), 1,
      anon_sym_and,
    STATE(5515), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6546), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6544), 27,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [124604] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5516), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5371), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5369), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [124685] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6330), 1,
      anon_sym_as,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7587), 1,
      anon_sym_QMARK,
    ACTIONS(7593), 1,
      anon_sym_SLASH,
    ACTIONS(7595), 1,
      anon_sym_CARET,
    ACTIONS(7597), 1,
      anon_sym_PIPE,
    ACTIONS(7599), 1,
      anon_sym_AMP,
    ACTIONS(7603), 1,
      anon_sym_GT_GT,
    ACTIONS(7609), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7611), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7613), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7615), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7617), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7585), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7589), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7591), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7601), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7605), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7607), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6216), 4,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5517), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [124820] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6330), 1,
      anon_sym_as,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7587), 1,
      anon_sym_QMARK,
    ACTIONS(7593), 1,
      anon_sym_SLASH,
    ACTIONS(7595), 1,
      anon_sym_CARET,
    ACTIONS(7597), 1,
      anon_sym_PIPE,
    ACTIONS(7599), 1,
      anon_sym_AMP,
    ACTIONS(7603), 1,
      anon_sym_GT_GT,
    ACTIONS(7609), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7611), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7613), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7615), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7617), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7585), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7589), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7591), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7601), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7605), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7607), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5325), 4,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5518), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [124955] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6330), 1,
      anon_sym_as,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7587), 1,
      anon_sym_QMARK,
    ACTIONS(7593), 1,
      anon_sym_SLASH,
    ACTIONS(7595), 1,
      anon_sym_CARET,
    ACTIONS(7597), 1,
      anon_sym_PIPE,
    ACTIONS(7599), 1,
      anon_sym_AMP,
    ACTIONS(7603), 1,
      anon_sym_GT_GT,
    ACTIONS(7609), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7611), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7613), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7615), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7617), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7585), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7589), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7591), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7601), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7605), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7607), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5510), 4,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5519), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [125090] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6330), 1,
      anon_sym_as,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7587), 1,
      anon_sym_QMARK,
    ACTIONS(7593), 1,
      anon_sym_SLASH,
    ACTIONS(7595), 1,
      anon_sym_CARET,
    ACTIONS(7597), 1,
      anon_sym_PIPE,
    ACTIONS(7599), 1,
      anon_sym_AMP,
    ACTIONS(7603), 1,
      anon_sym_GT_GT,
    ACTIONS(7609), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7611), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7613), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7615), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7617), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7585), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7589), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7591), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7601), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7605), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7607), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5420), 4,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5520), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [125225] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6330), 1,
      anon_sym_as,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7587), 1,
      anon_sym_QMARK,
    ACTIONS(7593), 1,
      anon_sym_SLASH,
    ACTIONS(7595), 1,
      anon_sym_CARET,
    ACTIONS(7597), 1,
      anon_sym_PIPE,
    ACTIONS(7599), 1,
      anon_sym_AMP,
    ACTIONS(7603), 1,
      anon_sym_GT_GT,
    ACTIONS(7609), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7611), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7613), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7615), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7617), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7585), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7589), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7591), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7601), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7605), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7607), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6230), 4,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5521), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [125360] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6330), 1,
      anon_sym_as,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7593), 1,
      anon_sym_SLASH,
    ACTIONS(7595), 1,
      anon_sym_CARET,
    ACTIONS(7597), 1,
      anon_sym_PIPE,
    ACTIONS(7599), 1,
      anon_sym_AMP,
    ACTIONS(7603), 1,
      anon_sym_GT_GT,
    ACTIONS(7609), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7611), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7613), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7615), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7617), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7585), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7589), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7591), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7601), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7605), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7607), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 4,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5522), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [125495] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6330), 1,
      anon_sym_as,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7593), 1,
      anon_sym_SLASH,
    ACTIONS(7595), 1,
      anon_sym_CARET,
    ACTIONS(7597), 1,
      anon_sym_PIPE,
    ACTIONS(7599), 1,
      anon_sym_AMP,
    ACTIONS(7603), 1,
      anon_sym_GT_GT,
    ACTIONS(7609), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7611), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7617), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7585), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7589), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7591), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7601), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7605), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7607), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 6,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
    STATE(5523), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [125626] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6330), 1,
      anon_sym_as,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7593), 1,
      anon_sym_SLASH,
    ACTIONS(7595), 1,
      anon_sym_CARET,
    ACTIONS(7597), 1,
      anon_sym_PIPE,
    ACTIONS(7599), 1,
      anon_sym_AMP,
    ACTIONS(7603), 1,
      anon_sym_GT_GT,
    ACTIONS(7609), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7617), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7585), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7589), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7591), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7601), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7605), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7607), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 7,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
    STATE(5524), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [125755] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(7511), 1,
      anon_sym_DOT_DOT,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5525), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6122), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6120), 20,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [125854] = 32,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6330), 1,
      anon_sym_as,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7593), 1,
      anon_sym_SLASH,
    ACTIONS(7603), 1,
      anon_sym_GT_GT,
    ACTIONS(7609), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7617), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7585), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7589), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7591), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7601), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7607), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6116), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5526), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 10,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
  [125975] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6330), 1,
      anon_sym_as,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7593), 1,
      anon_sym_SLASH,
    ACTIONS(7603), 1,
      anon_sym_GT_GT,
    ACTIONS(7609), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7617), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7585), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7589), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7591), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7601), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7605), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7607), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6116), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(6114), 8,
      anon_sym_CARET,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
    STATE(5527), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [126098] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6330), 1,
      anon_sym_as,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7593), 1,
      anon_sym_SLASH,
    ACTIONS(7595), 1,
      anon_sym_CARET,
    ACTIONS(7599), 1,
      anon_sym_AMP,
    ACTIONS(7603), 1,
      anon_sym_GT_GT,
    ACTIONS(7609), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7617), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6116), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7585), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7589), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7591), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7601), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7605), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7607), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 7,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
    STATE(5528), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [126225] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6330), 1,
      anon_sym_as,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7593), 1,
      anon_sym_SLASH,
    ACTIONS(7599), 1,
      anon_sym_AMP,
    ACTIONS(7603), 1,
      anon_sym_GT_GT,
    ACTIONS(7609), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7617), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6116), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7585), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7589), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7591), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7601), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7605), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7607), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 8,
      anon_sym_CARET,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
    STATE(5529), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [126350] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6330), 1,
      anon_sym_as,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7587), 1,
      anon_sym_QMARK,
    ACTIONS(7593), 1,
      anon_sym_SLASH,
    ACTIONS(7595), 1,
      anon_sym_CARET,
    ACTIONS(7597), 1,
      anon_sym_PIPE,
    ACTIONS(7599), 1,
      anon_sym_AMP,
    ACTIONS(7603), 1,
      anon_sym_GT_GT,
    ACTIONS(7609), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7611), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7613), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7615), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7617), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7585), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7589), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7591), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7601), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7605), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7607), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6236), 4,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5530), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [126485] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(7460), 1,
      anon_sym_DOT_DOT,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5531), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1147), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(1133), 20,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [126584] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7575), 1,
      anon_sym_as,
    ACTIONS(7693), 1,
      anon_sym_SLASH,
    ACTIONS(7697), 1,
      anon_sym_GT_GT,
    ACTIONS(7699), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7703), 1,
      anon_sym_AMP,
    ACTIONS(7709), 1,
      anon_sym_is,
    ACTIONS(7711), 1,
      anon_sym_CARET,
    ACTIONS(7713), 1,
      anon_sym_PIPE,
    ACTIONS(7715), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7717), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7719), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7728), 1,
      anon_sym_QMARK,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7689), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7691), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7695), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7701), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7705), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7707), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6173), 4,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
    STATE(5532), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [126719] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4953), 1,
      anon_sym_DASH_GT,
    ACTIONS(5067), 1,
      anon_sym_DOT,
    ACTIONS(6973), 1,
      anon_sym_LPAREN,
    ACTIONS(7022), 1,
      anon_sym_LBRACK,
    ACTIONS(7026), 1,
      anon_sym_BANG,
    ACTIONS(7042), 1,
      anon_sym_switch,
    ACTIONS(7046), 1,
      anon_sym_as,
    ACTIONS(7050), 1,
      anon_sym_with,
    ACTIONS(7519), 1,
      anon_sym_QMARK,
    ACTIONS(7525), 1,
      anon_sym_SLASH,
    ACTIONS(7527), 1,
      anon_sym_CARET,
    ACTIONS(7529), 1,
      anon_sym_PIPE,
    ACTIONS(7531), 1,
      anon_sym_AMP,
    ACTIONS(7535), 1,
      anon_sym_GT_GT,
    ACTIONS(7541), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7543), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7545), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7547), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7549), 1,
      anon_sym_is,
    STATE(3870), 1,
      sym_bracketed_argument_list,
    STATE(5721), 1,
      sym_argument_list,
    ACTIONS(7028), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7517), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7521), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7523), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7533), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7537), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7539), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6274), 4,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_into,
    STATE(5533), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [126854] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4953), 1,
      anon_sym_DASH_GT,
    ACTIONS(5067), 1,
      anon_sym_DOT,
    ACTIONS(6973), 1,
      anon_sym_LPAREN,
    ACTIONS(7022), 1,
      anon_sym_LBRACK,
    ACTIONS(7026), 1,
      anon_sym_BANG,
    ACTIONS(7042), 1,
      anon_sym_switch,
    ACTIONS(7050), 1,
      anon_sym_with,
    ACTIONS(7525), 1,
      anon_sym_SLASH,
    ACTIONS(7541), 1,
      anon_sym_DOT_DOT,
    STATE(3870), 1,
      sym_bracketed_argument_list,
    STATE(5721), 1,
      sym_argument_list,
    ACTIONS(7028), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7521), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7523), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6116), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5534), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 16,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
  [126963] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4953), 1,
      anon_sym_DASH_GT,
    ACTIONS(5067), 1,
      anon_sym_DOT,
    ACTIONS(6973), 1,
      anon_sym_LPAREN,
    ACTIONS(7022), 1,
      anon_sym_LBRACK,
    ACTIONS(7026), 1,
      anon_sym_BANG,
    ACTIONS(7042), 1,
      anon_sym_switch,
    ACTIONS(7050), 1,
      anon_sym_with,
    ACTIONS(7541), 1,
      anon_sym_DOT_DOT,
    STATE(3870), 1,
      sym_bracketed_argument_list,
    STATE(5721), 1,
      sym_argument_list,
    ACTIONS(7028), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5535), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6116), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6114), 18,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
  [127066] = 25,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4953), 1,
      anon_sym_DASH_GT,
    ACTIONS(5067), 1,
      anon_sym_DOT,
    ACTIONS(6973), 1,
      anon_sym_LPAREN,
    ACTIONS(7022), 1,
      anon_sym_LBRACK,
    ACTIONS(7026), 1,
      anon_sym_BANG,
    ACTIONS(7042), 1,
      anon_sym_switch,
    ACTIONS(7050), 1,
      anon_sym_with,
    ACTIONS(7525), 1,
      anon_sym_SLASH,
    ACTIONS(7541), 1,
      anon_sym_DOT_DOT,
    STATE(3870), 1,
      sym_bracketed_argument_list,
    STATE(5721), 1,
      sym_argument_list,
    ACTIONS(7028), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7523), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6116), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5536), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 16,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
  [127173] = 28,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4953), 1,
      anon_sym_DASH_GT,
    ACTIONS(5067), 1,
      anon_sym_DOT,
    ACTIONS(6973), 1,
      anon_sym_LPAREN,
    ACTIONS(7022), 1,
      anon_sym_LBRACK,
    ACTIONS(7026), 1,
      anon_sym_BANG,
    ACTIONS(7042), 1,
      anon_sym_switch,
    ACTIONS(7050), 1,
      anon_sym_with,
    ACTIONS(7525), 1,
      anon_sym_SLASH,
    ACTIONS(7535), 1,
      anon_sym_GT_GT,
    ACTIONS(7541), 1,
      anon_sym_DOT_DOT,
    STATE(3870), 1,
      sym_bracketed_argument_list,
    STATE(5721), 1,
      sym_argument_list,
    ACTIONS(7028), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7521), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7523), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7533), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6116), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5537), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 14,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
  [127286] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7723), 1,
      anon_sym_into,
    STATE(5511), 1,
      aux_sym__query_body_repeat2,
    STATE(5538), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6420), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6418), 26,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_when,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [127371] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4953), 1,
      anon_sym_DASH_GT,
    ACTIONS(5067), 1,
      anon_sym_DOT,
    ACTIONS(6973), 1,
      anon_sym_LPAREN,
    ACTIONS(7022), 1,
      anon_sym_LBRACK,
    ACTIONS(7026), 1,
      anon_sym_BANG,
    ACTIONS(7042), 1,
      anon_sym_switch,
    ACTIONS(7046), 1,
      anon_sym_as,
    ACTIONS(7050), 1,
      anon_sym_with,
    ACTIONS(7519), 1,
      anon_sym_QMARK,
    ACTIONS(7525), 1,
      anon_sym_SLASH,
    ACTIONS(7527), 1,
      anon_sym_CARET,
    ACTIONS(7529), 1,
      anon_sym_PIPE,
    ACTIONS(7531), 1,
      anon_sym_AMP,
    ACTIONS(7535), 1,
      anon_sym_GT_GT,
    ACTIONS(7541), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7543), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7545), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7547), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7549), 1,
      anon_sym_is,
    STATE(3870), 1,
      sym_bracketed_argument_list,
    STATE(5721), 1,
      sym_argument_list,
    ACTIONS(7028), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7517), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7521), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7523), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7533), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7537), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7539), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5337), 4,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_into,
    STATE(5539), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [127506] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4953), 1,
      anon_sym_DASH_GT,
    ACTIONS(5067), 1,
      anon_sym_DOT,
    ACTIONS(6973), 1,
      anon_sym_LPAREN,
    ACTIONS(7022), 1,
      anon_sym_LBRACK,
    ACTIONS(7026), 1,
      anon_sym_BANG,
    ACTIONS(7042), 1,
      anon_sym_switch,
    ACTIONS(7046), 1,
      anon_sym_as,
    ACTIONS(7050), 1,
      anon_sym_with,
    ACTIONS(7519), 1,
      anon_sym_QMARK,
    ACTIONS(7525), 1,
      anon_sym_SLASH,
    ACTIONS(7527), 1,
      anon_sym_CARET,
    ACTIONS(7529), 1,
      anon_sym_PIPE,
    ACTIONS(7531), 1,
      anon_sym_AMP,
    ACTIONS(7535), 1,
      anon_sym_GT_GT,
    ACTIONS(7541), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7543), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7545), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7547), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7549), 1,
      anon_sym_is,
    STATE(3870), 1,
      sym_bracketed_argument_list,
    STATE(5721), 1,
      sym_argument_list,
    ACTIONS(7028), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7517), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7521), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7523), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7533), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7537), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7539), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5385), 4,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_into,
    STATE(5540), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [127641] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4953), 1,
      anon_sym_DASH_GT,
    ACTIONS(5067), 1,
      anon_sym_DOT,
    ACTIONS(6973), 1,
      anon_sym_LPAREN,
    ACTIONS(7022), 1,
      anon_sym_LBRACK,
    ACTIONS(7026), 1,
      anon_sym_BANG,
    ACTIONS(7042), 1,
      anon_sym_switch,
    ACTIONS(7046), 1,
      anon_sym_as,
    ACTIONS(7050), 1,
      anon_sym_with,
    ACTIONS(7519), 1,
      anon_sym_QMARK,
    ACTIONS(7525), 1,
      anon_sym_SLASH,
    ACTIONS(7527), 1,
      anon_sym_CARET,
    ACTIONS(7529), 1,
      anon_sym_PIPE,
    ACTIONS(7531), 1,
      anon_sym_AMP,
    ACTIONS(7535), 1,
      anon_sym_GT_GT,
    ACTIONS(7541), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7543), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7545), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7547), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7549), 1,
      anon_sym_is,
    STATE(3870), 1,
      sym_bracketed_argument_list,
    STATE(5721), 1,
      sym_argument_list,
    ACTIONS(7028), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7517), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7521), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7523), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7533), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7537), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7539), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5396), 4,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_into,
    STATE(5541), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [127776] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6330), 1,
      anon_sym_as,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7587), 1,
      anon_sym_QMARK,
    ACTIONS(7593), 1,
      anon_sym_SLASH,
    ACTIONS(7595), 1,
      anon_sym_CARET,
    ACTIONS(7597), 1,
      anon_sym_PIPE,
    ACTIONS(7599), 1,
      anon_sym_AMP,
    ACTIONS(7603), 1,
      anon_sym_GT_GT,
    ACTIONS(7609), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7611), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7613), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7615), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7617), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7585), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7589), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7591), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7601), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7605), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7607), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6274), 4,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5542), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [127911] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5543), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5402), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5400), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [127992] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4953), 1,
      anon_sym_DASH_GT,
    ACTIONS(5067), 1,
      anon_sym_DOT,
    ACTIONS(6973), 1,
      anon_sym_LPAREN,
    ACTIONS(7022), 1,
      anon_sym_LBRACK,
    ACTIONS(7026), 1,
      anon_sym_BANG,
    ACTIONS(7042), 1,
      anon_sym_switch,
    ACTIONS(7046), 1,
      anon_sym_as,
    ACTIONS(7050), 1,
      anon_sym_with,
    ACTIONS(7519), 1,
      anon_sym_QMARK,
    ACTIONS(7525), 1,
      anon_sym_SLASH,
    ACTIONS(7527), 1,
      anon_sym_CARET,
    ACTIONS(7529), 1,
      anon_sym_PIPE,
    ACTIONS(7531), 1,
      anon_sym_AMP,
    ACTIONS(7535), 1,
      anon_sym_GT_GT,
    ACTIONS(7541), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7543), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7545), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7547), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7549), 1,
      anon_sym_is,
    STATE(3870), 1,
      sym_bracketed_argument_list,
    STATE(5721), 1,
      sym_argument_list,
    ACTIONS(7028), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7517), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7521), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7523), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7533), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7537), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7539), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6216), 4,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_into,
    STATE(5544), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [128127] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5545), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5592), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5590), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [128208] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7723), 1,
      anon_sym_into,
    STATE(5538), 1,
      aux_sym__query_body_repeat2,
    STATE(5546), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6448), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6446), 26,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_when,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [128293] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4953), 1,
      anon_sym_DASH_GT,
    ACTIONS(5067), 1,
      anon_sym_DOT,
    ACTIONS(6973), 1,
      anon_sym_LPAREN,
    ACTIONS(7022), 1,
      anon_sym_LBRACK,
    ACTIONS(7026), 1,
      anon_sym_BANG,
    ACTIONS(7042), 1,
      anon_sym_switch,
    ACTIONS(7046), 1,
      anon_sym_as,
    ACTIONS(7050), 1,
      anon_sym_with,
    ACTIONS(7519), 1,
      anon_sym_QMARK,
    ACTIONS(7525), 1,
      anon_sym_SLASH,
    ACTIONS(7527), 1,
      anon_sym_CARET,
    ACTIONS(7529), 1,
      anon_sym_PIPE,
    ACTIONS(7531), 1,
      anon_sym_AMP,
    ACTIONS(7535), 1,
      anon_sym_GT_GT,
    ACTIONS(7541), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7543), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7545), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7547), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7549), 1,
      anon_sym_is,
    STATE(3870), 1,
      sym_bracketed_argument_list,
    STATE(5721), 1,
      sym_argument_list,
    ACTIONS(7028), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7517), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7521), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7523), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7533), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7537), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7539), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5325), 4,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_into,
    STATE(5547), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [128428] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7250), 1,
      anon_sym_LBRACK,
    ACTIONS(7254), 1,
      anon_sym_QMARK,
    STATE(5548), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4424), 9,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
    ACTIONS(4422), 28,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_operator,
      anon_sym_this,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [128513] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5549), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5410), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5408), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [128594] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5550), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5496), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5494), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [128675] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4953), 1,
      anon_sym_DASH_GT,
    ACTIONS(5067), 1,
      anon_sym_DOT,
    ACTIONS(6973), 1,
      anon_sym_LPAREN,
    ACTIONS(7022), 1,
      anon_sym_LBRACK,
    ACTIONS(7026), 1,
      anon_sym_BANG,
    ACTIONS(7042), 1,
      anon_sym_switch,
    ACTIONS(7046), 1,
      anon_sym_as,
    ACTIONS(7050), 1,
      anon_sym_with,
    ACTIONS(7519), 1,
      anon_sym_QMARK,
    ACTIONS(7525), 1,
      anon_sym_SLASH,
    ACTIONS(7527), 1,
      anon_sym_CARET,
    ACTIONS(7529), 1,
      anon_sym_PIPE,
    ACTIONS(7531), 1,
      anon_sym_AMP,
    ACTIONS(7535), 1,
      anon_sym_GT_GT,
    ACTIONS(7541), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7543), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7545), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7547), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7549), 1,
      anon_sym_is,
    STATE(3870), 1,
      sym_bracketed_argument_list,
    STATE(5721), 1,
      sym_argument_list,
    ACTIONS(7028), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7517), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7521), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7523), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7533), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7537), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7539), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5510), 4,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_into,
    STATE(5551), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [128810] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4953), 1,
      anon_sym_DASH_GT,
    ACTIONS(5067), 1,
      anon_sym_DOT,
    ACTIONS(6973), 1,
      anon_sym_LPAREN,
    ACTIONS(7022), 1,
      anon_sym_LBRACK,
    ACTIONS(7026), 1,
      anon_sym_BANG,
    ACTIONS(7042), 1,
      anon_sym_switch,
    ACTIONS(7046), 1,
      anon_sym_as,
    ACTIONS(7050), 1,
      anon_sym_with,
    ACTIONS(7519), 1,
      anon_sym_QMARK,
    ACTIONS(7525), 1,
      anon_sym_SLASH,
    ACTIONS(7527), 1,
      anon_sym_CARET,
    ACTIONS(7529), 1,
      anon_sym_PIPE,
    ACTIONS(7531), 1,
      anon_sym_AMP,
    ACTIONS(7535), 1,
      anon_sym_GT_GT,
    ACTIONS(7541), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7543), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7545), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7547), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7549), 1,
      anon_sym_is,
    STATE(3870), 1,
      sym_bracketed_argument_list,
    STATE(5721), 1,
      sym_argument_list,
    ACTIONS(7028), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7517), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7521), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7523), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7533), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7537), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7539), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5420), 4,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_into,
    STATE(5552), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [128945] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6330), 1,
      anon_sym_as,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7587), 1,
      anon_sym_QMARK,
    ACTIONS(7593), 1,
      anon_sym_SLASH,
    ACTIONS(7595), 1,
      anon_sym_CARET,
    ACTIONS(7597), 1,
      anon_sym_PIPE,
    ACTIONS(7599), 1,
      anon_sym_AMP,
    ACTIONS(7603), 1,
      anon_sym_GT_GT,
    ACTIONS(7609), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7611), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7613), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7615), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7617), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7585), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7589), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7591), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7601), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7605), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7607), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6284), 4,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5553), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [129080] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4953), 1,
      anon_sym_DASH_GT,
    ACTIONS(5067), 1,
      anon_sym_DOT,
    ACTIONS(6973), 1,
      anon_sym_LPAREN,
    ACTIONS(7022), 1,
      anon_sym_LBRACK,
    ACTIONS(7026), 1,
      anon_sym_BANG,
    ACTIONS(7042), 1,
      anon_sym_switch,
    ACTIONS(7046), 1,
      anon_sym_as,
    ACTIONS(7050), 1,
      anon_sym_with,
    ACTIONS(7519), 1,
      anon_sym_QMARK,
    ACTIONS(7525), 1,
      anon_sym_SLASH,
    ACTIONS(7527), 1,
      anon_sym_CARET,
    ACTIONS(7529), 1,
      anon_sym_PIPE,
    ACTIONS(7531), 1,
      anon_sym_AMP,
    ACTIONS(7535), 1,
      anon_sym_GT_GT,
    ACTIONS(7541), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7543), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7545), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7547), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7549), 1,
      anon_sym_is,
    STATE(3870), 1,
      sym_bracketed_argument_list,
    STATE(5721), 1,
      sym_argument_list,
    ACTIONS(7028), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7517), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7521), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7523), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7533), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7537), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7539), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6230), 4,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_into,
    STATE(5554), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [129215] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4953), 1,
      anon_sym_DASH_GT,
    ACTIONS(5067), 1,
      anon_sym_DOT,
    ACTIONS(6973), 1,
      anon_sym_LPAREN,
    ACTIONS(7022), 1,
      anon_sym_LBRACK,
    ACTIONS(7026), 1,
      anon_sym_BANG,
    ACTIONS(7541), 1,
      anon_sym_DOT_DOT,
    STATE(3870), 1,
      sym_bracketed_argument_list,
    STATE(5721), 1,
      sym_argument_list,
    ACTIONS(7028), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5555), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6122), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6120), 20,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [129314] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5556), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5516), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5514), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [129395] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4953), 1,
      anon_sym_DASH_GT,
    ACTIONS(5067), 1,
      anon_sym_DOT,
    ACTIONS(6973), 1,
      anon_sym_LPAREN,
    ACTIONS(7022), 1,
      anon_sym_LBRACK,
    ACTIONS(7026), 1,
      anon_sym_BANG,
    ACTIONS(7042), 1,
      anon_sym_switch,
    ACTIONS(7046), 1,
      anon_sym_as,
    ACTIONS(7050), 1,
      anon_sym_with,
    ACTIONS(7519), 1,
      anon_sym_QMARK,
    ACTIONS(7525), 1,
      anon_sym_SLASH,
    ACTIONS(7527), 1,
      anon_sym_CARET,
    ACTIONS(7529), 1,
      anon_sym_PIPE,
    ACTIONS(7531), 1,
      anon_sym_AMP,
    ACTIONS(7535), 1,
      anon_sym_GT_GT,
    ACTIONS(7541), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7543), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7545), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7547), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7549), 1,
      anon_sym_is,
    STATE(3870), 1,
      sym_bracketed_argument_list,
    STATE(5721), 1,
      sym_argument_list,
    ACTIONS(7028), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7517), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7521), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7523), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7533), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7537), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7539), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6236), 4,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_into,
    STATE(5557), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [129530] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5558), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2967), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(2969), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [129611] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7732), 1,
      anon_sym_QMARK,
    ACTIONS(7738), 1,
      anon_sym_SLASH,
    ACTIONS(7740), 1,
      anon_sym_CARET,
    ACTIONS(7742), 1,
      anon_sym_PIPE,
    ACTIONS(7744), 1,
      anon_sym_AMP,
    ACTIONS(7748), 1,
      anon_sym_GT_GT,
    ACTIONS(7754), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7756), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7758), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7760), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7762), 1,
      anon_sym_as,
    ACTIONS(7764), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7730), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7734), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7736), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7746), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7750), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7752), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5510), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_equals,
    STATE(5559), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [129746] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7699), 1,
      anon_sym_DOT_DOT,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5560), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6116), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6114), 18,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [129849] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5561), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5578), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5576), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [129930] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7509), 1,
      anon_sym_SLASH,
    ACTIONS(7511), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7515), 1,
      anon_sym_GT_GT,
    ACTIONS(7667), 1,
      anon_sym_QMARK,
    ACTIONS(7669), 1,
      anon_sym_CARET,
    ACTIONS(7671), 1,
      anon_sym_PIPE,
    ACTIONS(7673), 1,
      anon_sym_AMP,
    ACTIONS(7679), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7681), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7683), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7685), 1,
      anon_sym_as,
    ACTIONS(7687), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7505), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7507), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7513), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7665), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7675), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7677), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6173), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_by,
    STATE(5562), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [130065] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(7699), 1,
      anon_sym_DOT_DOT,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5563), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1147), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(1133), 20,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [130164] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7732), 1,
      anon_sym_QMARK,
    ACTIONS(7738), 1,
      anon_sym_SLASH,
    ACTIONS(7740), 1,
      anon_sym_CARET,
    ACTIONS(7742), 1,
      anon_sym_PIPE,
    ACTIONS(7744), 1,
      anon_sym_AMP,
    ACTIONS(7748), 1,
      anon_sym_GT_GT,
    ACTIONS(7754), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7756), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7758), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7760), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7762), 1,
      anon_sym_as,
    ACTIONS(7764), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7730), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7734), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7736), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7746), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7750), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7752), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6236), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_equals,
    STATE(5564), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [130299] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7738), 1,
      anon_sym_SLASH,
    ACTIONS(7744), 1,
      anon_sym_AMP,
    ACTIONS(7748), 1,
      anon_sym_GT_GT,
    ACTIONS(7754), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7762), 1,
      anon_sym_as,
    ACTIONS(7764), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6116), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7730), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7734), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7736), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7746), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7750), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7752), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 8,
      anon_sym_CARET,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_equals,
    STATE(5565), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [130424] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7738), 1,
      anon_sym_SLASH,
    ACTIONS(7740), 1,
      anon_sym_CARET,
    ACTIONS(7744), 1,
      anon_sym_AMP,
    ACTIONS(7748), 1,
      anon_sym_GT_GT,
    ACTIONS(7754), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7762), 1,
      anon_sym_as,
    ACTIONS(7764), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6116), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7730), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7734), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7736), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7746), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7750), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7752), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 7,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_equals,
    STATE(5566), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [130551] = 25,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6116), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5567), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 16,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [130658] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7738), 1,
      anon_sym_SLASH,
    ACTIONS(7748), 1,
      anon_sym_GT_GT,
    ACTIONS(7754), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7762), 1,
      anon_sym_as,
    ACTIONS(7764), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7730), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7734), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7736), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7746), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7750), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7752), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6116), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(6114), 8,
      anon_sym_CARET,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_equals,
    STATE(5568), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [130781] = 32,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7738), 1,
      anon_sym_SLASH,
    ACTIONS(7748), 1,
      anon_sym_GT_GT,
    ACTIONS(7754), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7762), 1,
      anon_sym_as,
    ACTIONS(7764), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7730), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7734), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7736), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7746), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7752), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6116), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5569), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 10,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_equals,
  [130902] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5570), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5588), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5586), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [130983] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7738), 1,
      anon_sym_SLASH,
    ACTIONS(7740), 1,
      anon_sym_CARET,
    ACTIONS(7742), 1,
      anon_sym_PIPE,
    ACTIONS(7744), 1,
      anon_sym_AMP,
    ACTIONS(7748), 1,
      anon_sym_GT_GT,
    ACTIONS(7754), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7762), 1,
      anon_sym_as,
    ACTIONS(7764), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7730), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7734), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7736), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7746), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7750), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7752), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 7,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_equals,
    STATE(5571), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [131112] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7738), 1,
      anon_sym_SLASH,
    ACTIONS(7740), 1,
      anon_sym_CARET,
    ACTIONS(7742), 1,
      anon_sym_PIPE,
    ACTIONS(7744), 1,
      anon_sym_AMP,
    ACTIONS(7748), 1,
      anon_sym_GT_GT,
    ACTIONS(7754), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7756), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7762), 1,
      anon_sym_as,
    ACTIONS(7764), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7730), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7734), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7736), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7746), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7750), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7752), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 6,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_equals,
    STATE(5572), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [131243] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5573), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5327), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5325), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [131324] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7738), 1,
      anon_sym_SLASH,
    ACTIONS(7740), 1,
      anon_sym_CARET,
    ACTIONS(7742), 1,
      anon_sym_PIPE,
    ACTIONS(7744), 1,
      anon_sym_AMP,
    ACTIONS(7748), 1,
      anon_sym_GT_GT,
    ACTIONS(7754), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7756), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7758), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7760), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7762), 1,
      anon_sym_as,
    ACTIONS(7764), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7730), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7734), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7736), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7746), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7750), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7752), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_equals,
    STATE(5574), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [131459] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7732), 1,
      anon_sym_QMARK,
    ACTIONS(7738), 1,
      anon_sym_SLASH,
    ACTIONS(7740), 1,
      anon_sym_CARET,
    ACTIONS(7742), 1,
      anon_sym_PIPE,
    ACTIONS(7744), 1,
      anon_sym_AMP,
    ACTIONS(7748), 1,
      anon_sym_GT_GT,
    ACTIONS(7754), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7756), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7758), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7760), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7762), 1,
      anon_sym_as,
    ACTIONS(7764), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7730), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7734), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7736), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7746), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7750), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7752), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6230), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_equals,
    STATE(5575), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [131594] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7732), 1,
      anon_sym_QMARK,
    ACTIONS(7738), 1,
      anon_sym_SLASH,
    ACTIONS(7740), 1,
      anon_sym_CARET,
    ACTIONS(7742), 1,
      anon_sym_PIPE,
    ACTIONS(7744), 1,
      anon_sym_AMP,
    ACTIONS(7748), 1,
      anon_sym_GT_GT,
    ACTIONS(7754), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7756), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7758), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7760), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7762), 1,
      anon_sym_as,
    ACTIONS(7764), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7730), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7734), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7736), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7746), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7750), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7752), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5420), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_equals,
    STATE(5576), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [131729] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7400), 1,
      anon_sym_QMARK,
    ACTIONS(7406), 1,
      anon_sym_SLASH,
    ACTIONS(7408), 1,
      anon_sym_CARET,
    ACTIONS(7410), 1,
      anon_sym_PIPE,
    ACTIONS(7412), 1,
      anon_sym_AMP,
    ACTIONS(7416), 1,
      anon_sym_GT_GT,
    ACTIONS(7422), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7424), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7426), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7428), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7430), 1,
      anon_sym_as,
    ACTIONS(7432), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7398), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7402), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7404), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7414), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7418), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7420), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6220), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_on,
    STATE(5577), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [131864] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7732), 1,
      anon_sym_QMARK,
    ACTIONS(7738), 1,
      anon_sym_SLASH,
    ACTIONS(7740), 1,
      anon_sym_CARET,
    ACTIONS(7742), 1,
      anon_sym_PIPE,
    ACTIONS(7744), 1,
      anon_sym_AMP,
    ACTIONS(7748), 1,
      anon_sym_GT_GT,
    ACTIONS(7754), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7756), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7758), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7760), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7762), 1,
      anon_sym_as,
    ACTIONS(7764), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7730), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7734), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7736), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7746), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7750), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7752), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5325), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_equals,
    STATE(5578), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [131999] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5579), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5584), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5582), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [132080] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7575), 1,
      anon_sym_as,
    ACTIONS(7693), 1,
      anon_sym_SLASH,
    ACTIONS(7697), 1,
      anon_sym_GT_GT,
    ACTIONS(7699), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7703), 1,
      anon_sym_AMP,
    ACTIONS(7709), 1,
      anon_sym_is,
    ACTIONS(7711), 1,
      anon_sym_CARET,
    ACTIONS(7713), 1,
      anon_sym_PIPE,
    ACTIONS(7715), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7717), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7719), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7728), 1,
      anon_sym_QMARK,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7689), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7691), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7695), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7701), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7705), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7707), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6236), 4,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
    STATE(5580), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [132215] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7732), 1,
      anon_sym_QMARK,
    ACTIONS(7738), 1,
      anon_sym_SLASH,
    ACTIONS(7740), 1,
      anon_sym_CARET,
    ACTIONS(7742), 1,
      anon_sym_PIPE,
    ACTIONS(7744), 1,
      anon_sym_AMP,
    ACTIONS(7748), 1,
      anon_sym_GT_GT,
    ACTIONS(7754), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7756), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7758), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7760), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7762), 1,
      anon_sym_as,
    ACTIONS(7764), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7730), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7734), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7736), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7746), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7750), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7752), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6216), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_equals,
    STATE(5581), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [132350] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4953), 1,
      anon_sym_DASH_GT,
    ACTIONS(5067), 1,
      anon_sym_DOT,
    ACTIONS(6973), 1,
      anon_sym_LPAREN,
    ACTIONS(7022), 1,
      anon_sym_LBRACK,
    ACTIONS(7026), 1,
      anon_sym_BANG,
    ACTIONS(7042), 1,
      anon_sym_switch,
    ACTIONS(7046), 1,
      anon_sym_as,
    ACTIONS(7050), 1,
      anon_sym_with,
    ACTIONS(7525), 1,
      anon_sym_SLASH,
    ACTIONS(7531), 1,
      anon_sym_AMP,
    ACTIONS(7535), 1,
      anon_sym_GT_GT,
    ACTIONS(7541), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7549), 1,
      anon_sym_is,
    STATE(3870), 1,
      sym_bracketed_argument_list,
    STATE(5721), 1,
      sym_argument_list,
    ACTIONS(6116), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7028), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7517), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7521), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7523), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7533), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7537), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7539), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 8,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
    STATE(5582), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [132475] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4953), 1,
      anon_sym_DASH_GT,
    ACTIONS(5067), 1,
      anon_sym_DOT,
    ACTIONS(6973), 1,
      anon_sym_LPAREN,
    ACTIONS(7022), 1,
      anon_sym_LBRACK,
    ACTIONS(7026), 1,
      anon_sym_BANG,
    ACTIONS(7042), 1,
      anon_sym_switch,
    ACTIONS(7046), 1,
      anon_sym_as,
    ACTIONS(7050), 1,
      anon_sym_with,
    ACTIONS(7525), 1,
      anon_sym_SLASH,
    ACTIONS(7527), 1,
      anon_sym_CARET,
    ACTIONS(7531), 1,
      anon_sym_AMP,
    ACTIONS(7535), 1,
      anon_sym_GT_GT,
    ACTIONS(7541), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7549), 1,
      anon_sym_is,
    STATE(3870), 1,
      sym_bracketed_argument_list,
    STATE(5721), 1,
      sym_argument_list,
    ACTIONS(6116), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7028), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7517), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7521), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7523), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7533), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7537), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7539), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 7,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
    STATE(5583), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [132602] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4953), 1,
      anon_sym_DASH_GT,
    ACTIONS(5067), 1,
      anon_sym_DOT,
    ACTIONS(6973), 1,
      anon_sym_LPAREN,
    ACTIONS(7022), 1,
      anon_sym_LBRACK,
    ACTIONS(7026), 1,
      anon_sym_BANG,
    ACTIONS(7042), 1,
      anon_sym_switch,
    ACTIONS(7046), 1,
      anon_sym_as,
    ACTIONS(7050), 1,
      anon_sym_with,
    ACTIONS(7525), 1,
      anon_sym_SLASH,
    ACTIONS(7535), 1,
      anon_sym_GT_GT,
    ACTIONS(7541), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7549), 1,
      anon_sym_is,
    STATE(3870), 1,
      sym_bracketed_argument_list,
    STATE(5721), 1,
      sym_argument_list,
    ACTIONS(7028), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7517), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7521), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7523), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7533), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7537), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7539), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6116), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(6114), 8,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
    STATE(5584), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [132725] = 32,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4953), 1,
      anon_sym_DASH_GT,
    ACTIONS(5067), 1,
      anon_sym_DOT,
    ACTIONS(6973), 1,
      anon_sym_LPAREN,
    ACTIONS(7022), 1,
      anon_sym_LBRACK,
    ACTIONS(7026), 1,
      anon_sym_BANG,
    ACTIONS(7042), 1,
      anon_sym_switch,
    ACTIONS(7046), 1,
      anon_sym_as,
    ACTIONS(7050), 1,
      anon_sym_with,
    ACTIONS(7525), 1,
      anon_sym_SLASH,
    ACTIONS(7535), 1,
      anon_sym_GT_GT,
    ACTIONS(7541), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7549), 1,
      anon_sym_is,
    STATE(3870), 1,
      sym_bracketed_argument_list,
    STATE(5721), 1,
      sym_argument_list,
    ACTIONS(7028), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7517), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7521), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7523), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7533), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7539), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6116), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5585), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 10,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
  [132846] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(7699), 1,
      anon_sym_DOT_DOT,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5586), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6122), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6120), 20,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [132945] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4953), 1,
      anon_sym_DASH_GT,
    ACTIONS(5067), 1,
      anon_sym_DOT,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6973), 1,
      anon_sym_LPAREN,
    ACTIONS(7022), 1,
      anon_sym_LBRACK,
    ACTIONS(7026), 1,
      anon_sym_BANG,
    ACTIONS(7042), 1,
      anon_sym_switch,
    ACTIONS(7046), 1,
      anon_sym_as,
    ACTIONS(7050), 1,
      anon_sym_with,
    ACTIONS(7525), 1,
      anon_sym_SLASH,
    ACTIONS(7527), 1,
      anon_sym_CARET,
    ACTIONS(7529), 1,
      anon_sym_PIPE,
    ACTIONS(7531), 1,
      anon_sym_AMP,
    ACTIONS(7535), 1,
      anon_sym_GT_GT,
    ACTIONS(7541), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7549), 1,
      anon_sym_is,
    STATE(3870), 1,
      sym_bracketed_argument_list,
    STATE(5721), 1,
      sym_argument_list,
    ACTIONS(7028), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7517), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7521), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7523), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7533), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7537), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7539), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 7,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
    STATE(5587), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [133074] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4953), 1,
      anon_sym_DASH_GT,
    ACTIONS(5067), 1,
      anon_sym_DOT,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6973), 1,
      anon_sym_LPAREN,
    ACTIONS(7022), 1,
      anon_sym_LBRACK,
    ACTIONS(7026), 1,
      anon_sym_BANG,
    ACTIONS(7042), 1,
      anon_sym_switch,
    ACTIONS(7046), 1,
      anon_sym_as,
    ACTIONS(7050), 1,
      anon_sym_with,
    ACTIONS(7525), 1,
      anon_sym_SLASH,
    ACTIONS(7527), 1,
      anon_sym_CARET,
    ACTIONS(7529), 1,
      anon_sym_PIPE,
    ACTIONS(7531), 1,
      anon_sym_AMP,
    ACTIONS(7535), 1,
      anon_sym_GT_GT,
    ACTIONS(7541), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7543), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7549), 1,
      anon_sym_is,
    STATE(3870), 1,
      sym_bracketed_argument_list,
    STATE(5721), 1,
      sym_argument_list,
    ACTIONS(7028), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7517), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7521), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7523), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7533), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7537), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7539), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 6,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
    STATE(5588), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [133205] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4953), 1,
      anon_sym_DASH_GT,
    ACTIONS(5067), 1,
      anon_sym_DOT,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6973), 1,
      anon_sym_LPAREN,
    ACTIONS(7022), 1,
      anon_sym_LBRACK,
    ACTIONS(7026), 1,
      anon_sym_BANG,
    ACTIONS(7042), 1,
      anon_sym_switch,
    ACTIONS(7046), 1,
      anon_sym_as,
    ACTIONS(7050), 1,
      anon_sym_with,
    ACTIONS(7525), 1,
      anon_sym_SLASH,
    ACTIONS(7527), 1,
      anon_sym_CARET,
    ACTIONS(7529), 1,
      anon_sym_PIPE,
    ACTIONS(7531), 1,
      anon_sym_AMP,
    ACTIONS(7535), 1,
      anon_sym_GT_GT,
    ACTIONS(7541), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7543), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7545), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7547), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7549), 1,
      anon_sym_is,
    STATE(3870), 1,
      sym_bracketed_argument_list,
    STATE(5721), 1,
      sym_argument_list,
    ACTIONS(7028), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7517), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7521), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7523), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7533), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7537), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7539), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 4,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_into,
    STATE(5589), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [133340] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7575), 1,
      anon_sym_as,
    ACTIONS(7693), 1,
      anon_sym_SLASH,
    ACTIONS(7697), 1,
      anon_sym_GT_GT,
    ACTIONS(7699), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7703), 1,
      anon_sym_AMP,
    ACTIONS(7709), 1,
      anon_sym_is,
    ACTIONS(7711), 1,
      anon_sym_CARET,
    ACTIONS(7713), 1,
      anon_sym_PIPE,
    ACTIONS(7715), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7717), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7719), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7728), 1,
      anon_sym_QMARK,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7689), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7691), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7695), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7701), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7705), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7707), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6230), 4,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
    STATE(5590), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [133475] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7575), 1,
      anon_sym_as,
    ACTIONS(7693), 1,
      anon_sym_SLASH,
    ACTIONS(7697), 1,
      anon_sym_GT_GT,
    ACTIONS(7699), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7703), 1,
      anon_sym_AMP,
    ACTIONS(7709), 1,
      anon_sym_is,
    ACTIONS(7711), 1,
      anon_sym_CARET,
    ACTIONS(7713), 1,
      anon_sym_PIPE,
    ACTIONS(7715), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7717), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7719), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7728), 1,
      anon_sym_QMARK,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7689), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7691), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7695), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7701), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7705), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7707), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5420), 4,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
    STATE(5591), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [133610] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7732), 1,
      anon_sym_QMARK,
    ACTIONS(7738), 1,
      anon_sym_SLASH,
    ACTIONS(7740), 1,
      anon_sym_CARET,
    ACTIONS(7742), 1,
      anon_sym_PIPE,
    ACTIONS(7744), 1,
      anon_sym_AMP,
    ACTIONS(7748), 1,
      anon_sym_GT_GT,
    ACTIONS(7754), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7756), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7758), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7760), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7762), 1,
      anon_sym_as,
    ACTIONS(7764), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7730), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7734), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7736), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7746), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7750), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7752), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5396), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_equals,
    STATE(5592), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [133745] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7575), 1,
      anon_sym_as,
    ACTIONS(7693), 1,
      anon_sym_SLASH,
    ACTIONS(7697), 1,
      anon_sym_GT_GT,
    ACTIONS(7699), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7703), 1,
      anon_sym_AMP,
    ACTIONS(7709), 1,
      anon_sym_is,
    ACTIONS(7711), 1,
      anon_sym_CARET,
    ACTIONS(7713), 1,
      anon_sym_PIPE,
    ACTIONS(7715), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7717), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7719), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7728), 1,
      anon_sym_QMARK,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7689), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7691), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7695), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7701), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7705), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7707), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5510), 4,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
    STATE(5593), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [133880] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5728), 1,
      anon_sym_LT,
    ACTIONS(7766), 1,
      anon_sym_COLON_COLON,
    STATE(4046), 1,
      sym_type_argument_list,
    STATE(5594), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4074), 10,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4076), 26,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [133967] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5595), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2921), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(2923), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [134048] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7575), 1,
      anon_sym_as,
    ACTIONS(7693), 1,
      anon_sym_SLASH,
    ACTIONS(7697), 1,
      anon_sym_GT_GT,
    ACTIONS(7699), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7703), 1,
      anon_sym_AMP,
    ACTIONS(7709), 1,
      anon_sym_is,
    ACTIONS(7711), 1,
      anon_sym_CARET,
    ACTIONS(7713), 1,
      anon_sym_PIPE,
    ACTIONS(7715), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7717), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7719), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7728), 1,
      anon_sym_QMARK,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7689), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7691), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7695), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7701), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7705), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7707), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5325), 4,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
    STATE(5596), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [134183] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7732), 1,
      anon_sym_QMARK,
    ACTIONS(7738), 1,
      anon_sym_SLASH,
    ACTIONS(7740), 1,
      anon_sym_CARET,
    ACTIONS(7742), 1,
      anon_sym_PIPE,
    ACTIONS(7744), 1,
      anon_sym_AMP,
    ACTIONS(7748), 1,
      anon_sym_GT_GT,
    ACTIONS(7754), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7756), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7758), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7760), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7762), 1,
      anon_sym_as,
    ACTIONS(7764), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7730), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7734), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7736), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7746), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7750), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7752), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5385), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_equals,
    STATE(5597), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [134318] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7575), 1,
      anon_sym_as,
    ACTIONS(7693), 1,
      anon_sym_SLASH,
    ACTIONS(7697), 1,
      anon_sym_GT_GT,
    ACTIONS(7699), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7703), 1,
      anon_sym_AMP,
    ACTIONS(7709), 1,
      anon_sym_is,
    ACTIONS(7711), 1,
      anon_sym_CARET,
    ACTIONS(7713), 1,
      anon_sym_PIPE,
    ACTIONS(7715), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7717), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7719), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7728), 1,
      anon_sym_QMARK,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7689), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7691), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7695), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7701), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7705), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7707), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6216), 4,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
    STATE(5598), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [134453] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7575), 1,
      anon_sym_as,
    ACTIONS(7693), 1,
      anon_sym_SLASH,
    ACTIONS(7697), 1,
      anon_sym_GT_GT,
    ACTIONS(7699), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7703), 1,
      anon_sym_AMP,
    ACTIONS(7709), 1,
      anon_sym_is,
    ACTIONS(7711), 1,
      anon_sym_CARET,
    ACTIONS(7713), 1,
      anon_sym_PIPE,
    ACTIONS(7715), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7717), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7719), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7728), 1,
      anon_sym_QMARK,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7689), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7691), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7695), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7701), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7705), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7707), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5396), 4,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
    STATE(5599), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [134588] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7732), 1,
      anon_sym_QMARK,
    ACTIONS(7738), 1,
      anon_sym_SLASH,
    ACTIONS(7740), 1,
      anon_sym_CARET,
    ACTIONS(7742), 1,
      anon_sym_PIPE,
    ACTIONS(7744), 1,
      anon_sym_AMP,
    ACTIONS(7748), 1,
      anon_sym_GT_GT,
    ACTIONS(7754), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7756), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7758), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7760), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7762), 1,
      anon_sym_as,
    ACTIONS(7764), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7730), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7734), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7736), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7746), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7750), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7752), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5337), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_equals,
    STATE(5600), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [134723] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7575), 1,
      anon_sym_as,
    ACTIONS(7693), 1,
      anon_sym_SLASH,
    ACTIONS(7697), 1,
      anon_sym_GT_GT,
    ACTIONS(7699), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7703), 1,
      anon_sym_AMP,
    ACTIONS(7709), 1,
      anon_sym_is,
    ACTIONS(7711), 1,
      anon_sym_CARET,
    ACTIONS(7713), 1,
      anon_sym_PIPE,
    ACTIONS(7715), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7717), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7719), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7728), 1,
      anon_sym_QMARK,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7689), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7691), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7695), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7701), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7705), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7707), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5385), 4,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
    STATE(5601), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [134858] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7575), 1,
      anon_sym_as,
    ACTIONS(7693), 1,
      anon_sym_SLASH,
    ACTIONS(7697), 1,
      anon_sym_GT_GT,
    ACTIONS(7699), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7703), 1,
      anon_sym_AMP,
    ACTIONS(7709), 1,
      anon_sym_is,
    ACTIONS(7711), 1,
      anon_sym_CARET,
    ACTIONS(7713), 1,
      anon_sym_PIPE,
    ACTIONS(7715), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7717), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7719), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7728), 1,
      anon_sym_QMARK,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7689), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7691), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7695), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7701), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7705), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7707), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5337), 4,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
    STATE(5602), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [134993] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7732), 1,
      anon_sym_QMARK,
    ACTIONS(7738), 1,
      anon_sym_SLASH,
    ACTIONS(7740), 1,
      anon_sym_CARET,
    ACTIONS(7742), 1,
      anon_sym_PIPE,
    ACTIONS(7744), 1,
      anon_sym_AMP,
    ACTIONS(7748), 1,
      anon_sym_GT_GT,
    ACTIONS(7754), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7756), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7758), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7760), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7762), 1,
      anon_sym_as,
    ACTIONS(7764), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7730), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7734), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7736), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7746), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7750), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7752), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6220), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_equals,
    STATE(5603), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [135128] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5604), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5528), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5526), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [135209] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5605), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5524), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5522), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [135290] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7575), 1,
      anon_sym_as,
    ACTIONS(7693), 1,
      anon_sym_SLASH,
    ACTIONS(7697), 1,
      anon_sym_GT_GT,
    ACTIONS(7699), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7703), 1,
      anon_sym_AMP,
    ACTIONS(7709), 1,
      anon_sym_is,
    ACTIONS(7711), 1,
      anon_sym_CARET,
    ACTIONS(7713), 1,
      anon_sym_PIPE,
    ACTIONS(7715), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7717), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7719), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7728), 1,
      anon_sym_QMARK,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7689), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7691), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7695), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7701), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7705), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7707), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6220), 4,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
    STATE(5606), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [135425] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5607), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5512), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5510), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [135506] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5608), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5504), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5502), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [135587] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5609), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5492), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5490), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [135668] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5337), 4,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    STATE(5610), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [135803] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5611), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5484), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5482), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [135884] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7559), 1,
      anon_sym_SLASH,
    ACTIONS(7563), 1,
      anon_sym_GT_GT,
    ACTIONS(7565), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7569), 1,
      anon_sym_AMP,
    ACTIONS(7575), 1,
      anon_sym_as,
    ACTIONS(7577), 1,
      anon_sym_is,
    ACTIONS(7579), 1,
      anon_sym_CARET,
    ACTIONS(7655), 1,
      anon_sym_PIPE,
    ACTIONS(7657), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7659), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7661), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7663), 1,
      anon_sym_QMARK,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7555), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7557), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7561), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7567), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7571), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7573), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6173), 4,
      anon_sym_COLON,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
    STATE(5612), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [136019] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5613), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5468), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5466), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [136100] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7509), 1,
      anon_sym_SLASH,
    ACTIONS(7511), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7515), 1,
      anon_sym_GT_GT,
    ACTIONS(7667), 1,
      anon_sym_QMARK,
    ACTIONS(7669), 1,
      anon_sym_CARET,
    ACTIONS(7671), 1,
      anon_sym_PIPE,
    ACTIONS(7673), 1,
      anon_sym_AMP,
    ACTIONS(7679), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7681), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7683), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7685), 1,
      anon_sym_as,
    ACTIONS(7687), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7505), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7507), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7513), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7665), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7675), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7677), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6284), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_by,
    STATE(5614), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [136235] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7732), 1,
      anon_sym_QMARK,
    ACTIONS(7738), 1,
      anon_sym_SLASH,
    ACTIONS(7740), 1,
      anon_sym_CARET,
    ACTIONS(7742), 1,
      anon_sym_PIPE,
    ACTIONS(7744), 1,
      anon_sym_AMP,
    ACTIONS(7748), 1,
      anon_sym_GT_GT,
    ACTIONS(7754), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7756), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7758), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7760), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7762), 1,
      anon_sym_as,
    ACTIONS(7764), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7730), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7734), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7736), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7746), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7750), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7752), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6173), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_equals,
    STATE(5615), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [136370] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7509), 1,
      anon_sym_SLASH,
    ACTIONS(7511), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7515), 1,
      anon_sym_GT_GT,
    ACTIONS(7667), 1,
      anon_sym_QMARK,
    ACTIONS(7669), 1,
      anon_sym_CARET,
    ACTIONS(7671), 1,
      anon_sym_PIPE,
    ACTIONS(7673), 1,
      anon_sym_AMP,
    ACTIONS(7679), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7681), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7683), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7685), 1,
      anon_sym_as,
    ACTIONS(7687), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7505), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7507), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7513), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7665), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7675), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7677), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6274), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_by,
    STATE(5616), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [136505] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5617), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5454), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5452), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [136586] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7754), 1,
      anon_sym_DOT_DOT,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5618), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6116), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6114), 18,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
  [136689] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7400), 1,
      anon_sym_QMARK,
    ACTIONS(7406), 1,
      anon_sym_SLASH,
    ACTIONS(7408), 1,
      anon_sym_CARET,
    ACTIONS(7410), 1,
      anon_sym_PIPE,
    ACTIONS(7412), 1,
      anon_sym_AMP,
    ACTIONS(7416), 1,
      anon_sym_GT_GT,
    ACTIONS(7422), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7424), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7426), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7428), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7430), 1,
      anon_sym_as,
    ACTIONS(7432), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7398), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7402), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7404), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7414), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7418), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7420), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6236), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_on,
    STATE(5619), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [136824] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7406), 1,
      anon_sym_SLASH,
    ACTIONS(7412), 1,
      anon_sym_AMP,
    ACTIONS(7416), 1,
      anon_sym_GT_GT,
    ACTIONS(7422), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7430), 1,
      anon_sym_as,
    ACTIONS(7432), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6116), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7398), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7402), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7404), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7414), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7418), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7420), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 8,
      anon_sym_CARET,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_on,
    STATE(5620), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [136949] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5621), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5600), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5598), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [137030] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5622), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5438), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5436), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [137111] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7406), 1,
      anon_sym_SLASH,
    ACTIONS(7408), 1,
      anon_sym_CARET,
    ACTIONS(7412), 1,
      anon_sym_AMP,
    ACTIONS(7416), 1,
      anon_sym_GT_GT,
    ACTIONS(7422), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7430), 1,
      anon_sym_as,
    ACTIONS(7432), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6116), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7398), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7402), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7404), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7414), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7418), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7420), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 7,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_on,
    STATE(5623), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [137238] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7406), 1,
      anon_sym_SLASH,
    ACTIONS(7416), 1,
      anon_sym_GT_GT,
    ACTIONS(7422), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7430), 1,
      anon_sym_as,
    ACTIONS(7432), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7398), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7402), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7404), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7414), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7418), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7420), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6116), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(6114), 8,
      anon_sym_CARET,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_on,
    STATE(5624), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [137361] = 32,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7406), 1,
      anon_sym_SLASH,
    ACTIONS(7416), 1,
      anon_sym_GT_GT,
    ACTIONS(7422), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7430), 1,
      anon_sym_as,
    ACTIONS(7432), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7398), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7402), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7404), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7414), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7420), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6116), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5625), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 10,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_on,
  [137482] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7406), 1,
      anon_sym_SLASH,
    ACTIONS(7408), 1,
      anon_sym_CARET,
    ACTIONS(7410), 1,
      anon_sym_PIPE,
    ACTIONS(7412), 1,
      anon_sym_AMP,
    ACTIONS(7416), 1,
      anon_sym_GT_GT,
    ACTIONS(7422), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7430), 1,
      anon_sym_as,
    ACTIONS(7432), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7398), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7402), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7404), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7414), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7418), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7420), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 7,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_on,
    STATE(5626), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [137611] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7509), 1,
      anon_sym_SLASH,
    ACTIONS(7511), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7515), 1,
      anon_sym_GT_GT,
    ACTIONS(7673), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_as,
    ACTIONS(7687), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6116), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7505), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7507), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7513), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7665), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7675), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7677), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 8,
      anon_sym_CARET,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_by,
    STATE(5627), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [137736] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7509), 1,
      anon_sym_SLASH,
    ACTIONS(7511), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7515), 1,
      anon_sym_GT_GT,
    ACTIONS(7669), 1,
      anon_sym_CARET,
    ACTIONS(7673), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_as,
    ACTIONS(7687), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6116), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7505), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7507), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7513), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7665), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7675), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7677), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 7,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_by,
    STATE(5628), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [137863] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7509), 1,
      anon_sym_SLASH,
    ACTIONS(7511), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7515), 1,
      anon_sym_GT_GT,
    ACTIONS(7685), 1,
      anon_sym_as,
    ACTIONS(7687), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7505), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7507), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7513), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7665), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7675), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7677), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6116), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(6114), 8,
      anon_sym_CARET,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_by,
    STATE(5629), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [137986] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7406), 1,
      anon_sym_SLASH,
    ACTIONS(7408), 1,
      anon_sym_CARET,
    ACTIONS(7410), 1,
      anon_sym_PIPE,
    ACTIONS(7412), 1,
      anon_sym_AMP,
    ACTIONS(7416), 1,
      anon_sym_GT_GT,
    ACTIONS(7422), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7424), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7430), 1,
      anon_sym_as,
    ACTIONS(7432), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7398), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7402), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7404), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7414), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7418), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7420), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 6,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_on,
    STATE(5630), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [138117] = 32,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7509), 1,
      anon_sym_SLASH,
    ACTIONS(7511), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7515), 1,
      anon_sym_GT_GT,
    ACTIONS(7685), 1,
      anon_sym_as,
    ACTIONS(7687), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7505), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7507), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7513), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7665), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7677), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6116), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5631), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 10,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_by,
  [138238] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7406), 1,
      anon_sym_SLASH,
    ACTIONS(7408), 1,
      anon_sym_CARET,
    ACTIONS(7410), 1,
      anon_sym_PIPE,
    ACTIONS(7412), 1,
      anon_sym_AMP,
    ACTIONS(7416), 1,
      anon_sym_GT_GT,
    ACTIONS(7422), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7424), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7426), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7428), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7430), 1,
      anon_sym_as,
    ACTIONS(7432), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7398), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7402), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7404), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7414), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7418), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7420), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_on,
    STATE(5632), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [138373] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7509), 1,
      anon_sym_SLASH,
    ACTIONS(7511), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7515), 1,
      anon_sym_GT_GT,
    ACTIONS(7669), 1,
      anon_sym_CARET,
    ACTIONS(7671), 1,
      anon_sym_PIPE,
    ACTIONS(7673), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_as,
    ACTIONS(7687), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7505), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7507), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7513), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7665), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7675), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7677), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 7,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_by,
    STATE(5633), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [138502] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7509), 1,
      anon_sym_SLASH,
    ACTIONS(7511), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7515), 1,
      anon_sym_GT_GT,
    ACTIONS(7669), 1,
      anon_sym_CARET,
    ACTIONS(7671), 1,
      anon_sym_PIPE,
    ACTIONS(7673), 1,
      anon_sym_AMP,
    ACTIONS(7679), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7685), 1,
      anon_sym_as,
    ACTIONS(7687), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7505), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7507), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7513), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7665), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7675), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7677), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 6,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_by,
    STATE(5634), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [138633] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7509), 1,
      anon_sym_SLASH,
    ACTIONS(7511), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7515), 1,
      anon_sym_GT_GT,
    ACTIONS(7669), 1,
      anon_sym_CARET,
    ACTIONS(7671), 1,
      anon_sym_PIPE,
    ACTIONS(7673), 1,
      anon_sym_AMP,
    ACTIONS(7679), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7681), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7683), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7685), 1,
      anon_sym_as,
    ACTIONS(7687), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7505), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7507), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7513), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7665), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7675), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7677), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_by,
    STATE(5635), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [138768] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7400), 1,
      anon_sym_QMARK,
    ACTIONS(7406), 1,
      anon_sym_SLASH,
    ACTIONS(7408), 1,
      anon_sym_CARET,
    ACTIONS(7410), 1,
      anon_sym_PIPE,
    ACTIONS(7412), 1,
      anon_sym_AMP,
    ACTIONS(7416), 1,
      anon_sym_GT_GT,
    ACTIONS(7422), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7424), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7426), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7428), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7430), 1,
      anon_sym_as,
    ACTIONS(7432), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7398), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7402), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7404), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7414), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7418), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7420), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6230), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_on,
    STATE(5636), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [138903] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7400), 1,
      anon_sym_QMARK,
    ACTIONS(7406), 1,
      anon_sym_SLASH,
    ACTIONS(7408), 1,
      anon_sym_CARET,
    ACTIONS(7410), 1,
      anon_sym_PIPE,
    ACTIONS(7412), 1,
      anon_sym_AMP,
    ACTIONS(7416), 1,
      anon_sym_GT_GT,
    ACTIONS(7422), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7424), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7426), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7428), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7430), 1,
      anon_sym_as,
    ACTIONS(7432), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7398), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7402), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7404), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7414), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7418), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7420), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5420), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_on,
    STATE(5637), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [139038] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7400), 1,
      anon_sym_QMARK,
    ACTIONS(7406), 1,
      anon_sym_SLASH,
    ACTIONS(7408), 1,
      anon_sym_CARET,
    ACTIONS(7410), 1,
      anon_sym_PIPE,
    ACTIONS(7412), 1,
      anon_sym_AMP,
    ACTIONS(7416), 1,
      anon_sym_GT_GT,
    ACTIONS(7422), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7424), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7426), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7428), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7430), 1,
      anon_sym_as,
    ACTIONS(7432), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7398), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7402), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7404), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7414), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7418), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7420), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5510), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_on,
    STATE(5638), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [139173] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5639), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5434), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5432), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [139254] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7400), 1,
      anon_sym_QMARK,
    ACTIONS(7406), 1,
      anon_sym_SLASH,
    ACTIONS(7408), 1,
      anon_sym_CARET,
    ACTIONS(7410), 1,
      anon_sym_PIPE,
    ACTIONS(7412), 1,
      anon_sym_AMP,
    ACTIONS(7416), 1,
      anon_sym_GT_GT,
    ACTIONS(7422), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7424), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7426), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7428), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7430), 1,
      anon_sym_as,
    ACTIONS(7432), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7398), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7402), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7404), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7414), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7418), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7420), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5325), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_on,
    STATE(5640), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [139389] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7400), 1,
      anon_sym_QMARK,
    ACTIONS(7406), 1,
      anon_sym_SLASH,
    ACTIONS(7408), 1,
      anon_sym_CARET,
    ACTIONS(7410), 1,
      anon_sym_PIPE,
    ACTIONS(7412), 1,
      anon_sym_AMP,
    ACTIONS(7416), 1,
      anon_sym_GT_GT,
    ACTIONS(7422), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7424), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7426), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7428), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7430), 1,
      anon_sym_as,
    ACTIONS(7432), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7398), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7402), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7404), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7414), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7418), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7420), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6216), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_on,
    STATE(5641), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [139524] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5642), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5430), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5428), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [139605] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5643), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5426), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5424), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [139686] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5644), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5406), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5404), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [139767] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5645), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5375), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5373), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [139848] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7400), 1,
      anon_sym_QMARK,
    ACTIONS(7406), 1,
      anon_sym_SLASH,
    ACTIONS(7408), 1,
      anon_sym_CARET,
    ACTIONS(7410), 1,
      anon_sym_PIPE,
    ACTIONS(7412), 1,
      anon_sym_AMP,
    ACTIONS(7416), 1,
      anon_sym_GT_GT,
    ACTIONS(7422), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7424), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7426), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7428), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7430), 1,
      anon_sym_as,
    ACTIONS(7432), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7398), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7402), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7404), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7414), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7418), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7420), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5396), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_on,
    STATE(5646), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [139983] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5647), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5414), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5412), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [140064] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7400), 1,
      anon_sym_QMARK,
    ACTIONS(7406), 1,
      anon_sym_SLASH,
    ACTIONS(7408), 1,
      anon_sym_CARET,
    ACTIONS(7410), 1,
      anon_sym_PIPE,
    ACTIONS(7412), 1,
      anon_sym_AMP,
    ACTIONS(7416), 1,
      anon_sym_GT_GT,
    ACTIONS(7422), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7424), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7426), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7428), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7430), 1,
      anon_sym_as,
    ACTIONS(7432), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7398), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7402), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7404), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7414), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7418), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7420), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5337), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_on,
    STATE(5648), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [140199] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5649), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5422), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5420), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [140280] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5650), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5856), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5854), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [140361] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4953), 1,
      anon_sym_DASH_GT,
    ACTIONS(5067), 1,
      anon_sym_DOT,
    ACTIONS(6973), 1,
      anon_sym_LPAREN,
    ACTIONS(7022), 1,
      anon_sym_LBRACK,
    ACTIONS(7026), 1,
      anon_sym_BANG,
    ACTIONS(7042), 1,
      anon_sym_switch,
    ACTIONS(7046), 1,
      anon_sym_as,
    ACTIONS(7050), 1,
      anon_sym_with,
    ACTIONS(7519), 1,
      anon_sym_QMARK,
    ACTIONS(7525), 1,
      anon_sym_SLASH,
    ACTIONS(7527), 1,
      anon_sym_CARET,
    ACTIONS(7529), 1,
      anon_sym_PIPE,
    ACTIONS(7531), 1,
      anon_sym_AMP,
    ACTIONS(7535), 1,
      anon_sym_GT_GT,
    ACTIONS(7541), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7543), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7545), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7547), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7549), 1,
      anon_sym_is,
    STATE(3870), 1,
      sym_bracketed_argument_list,
    STATE(5721), 1,
      sym_argument_list,
    ACTIONS(7028), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7517), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7521), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7523), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7533), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7537), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7539), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6284), 4,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_into,
    STATE(5651), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [140496] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5385), 4,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    STATE(5652), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [140631] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5396), 4,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    STATE(5653), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [140766] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(2738), 1,
      sym_generic_name,
    STATE(5368), 1,
      sym_identifier,
    STATE(6792), 1,
      sym_attribute_target_specifier,
    STATE(8106), 1,
      sym__name,
    STATE(8395), 1,
      sym_attribute,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    ACTIONS(1045), 7,
      anon_sym_field,
      anon_sym_event,
      anon_sym_method,
      anon_sym_param,
      anon_sym_property,
      anon_sym_return,
      anon_sym_type,
    STATE(5654), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [140863] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5655), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1965), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(1963), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [140944] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7768), 1,
      anon_sym_into,
    STATE(5657), 1,
      aux_sym__query_body_repeat2,
    STATE(5656), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6383), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6381), 26,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_when,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [141029] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7770), 1,
      anon_sym_into,
    STATE(5657), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym__query_body_repeat2,
    ACTIONS(6376), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6374), 26,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_when,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [141112] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7768), 1,
      anon_sym_into,
    STATE(5656), 1,
      aux_sym__query_body_repeat2,
    STATE(5658), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6420), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6418), 26,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_when,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [141197] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5659), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5596), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5594), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [141278] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7768), 1,
      anon_sym_into,
    STATE(5657), 1,
      aux_sym__query_body_repeat2,
    STATE(5660), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6420), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6418), 26,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_when,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [141363] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7768), 1,
      anon_sym_into,
    STATE(5660), 1,
      aux_sym__query_body_repeat2,
    STATE(5661), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6448), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6446), 26,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_when,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [141448] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5662), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5331), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5329), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [141529] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7565), 1,
      anon_sym_DOT_DOT,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5663), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6116), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6114), 18,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [141632] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7732), 1,
      anon_sym_QMARK,
    ACTIONS(7738), 1,
      anon_sym_SLASH,
    ACTIONS(7740), 1,
      anon_sym_CARET,
    ACTIONS(7742), 1,
      anon_sym_PIPE,
    ACTIONS(7744), 1,
      anon_sym_AMP,
    ACTIONS(7748), 1,
      anon_sym_GT_GT,
    ACTIONS(7754), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7756), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7758), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7760), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7762), 1,
      anon_sym_as,
    ACTIONS(7764), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7730), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7734), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7736), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7746), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7750), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7752), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6284), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_equals,
    STATE(5664), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [141767] = 28,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7738), 1,
      anon_sym_SLASH,
    ACTIONS(7748), 1,
      anon_sym_GT_GT,
    ACTIONS(7754), 1,
      anon_sym_DOT_DOT,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7734), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7736), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7746), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6116), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5665), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 14,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
  [141880] = 25,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7738), 1,
      anon_sym_SLASH,
    ACTIONS(7754), 1,
      anon_sym_DOT_DOT,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7736), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6116), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5666), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 16,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
  [141987] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7738), 1,
      anon_sym_SLASH,
    ACTIONS(7754), 1,
      anon_sym_DOT_DOT,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7734), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7736), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6116), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5667), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 16,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
  [142096] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(7754), 1,
      anon_sym_DOT_DOT,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5668), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6122), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6120), 20,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [142195] = 25,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4277), 1,
      anon_sym_LBRACE,
    ACTIONS(4295), 1,
      sym_discard,
    ACTIONS(7333), 1,
      sym__identifier_token,
    ACTIONS(7337), 1,
      anon_sym_LPAREN,
    STATE(3127), 1,
      sym__reserved_identifier,
    STATE(4259), 1,
      sym_identifier,
    STATE(4260), 1,
      sym__variable_designation,
    STATE(4274), 1,
      sym_parenthesized_variable_designation,
    STATE(6162), 1,
      sym_positional_pattern_clause,
    STATE(6695), 1,
      sym_property_pattern_clause,
    STATE(9359), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    ACTIONS(4279), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(4275), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    STATE(5669), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7335), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [142302] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7400), 1,
      anon_sym_QMARK,
    ACTIONS(7406), 1,
      anon_sym_SLASH,
    ACTIONS(7408), 1,
      anon_sym_CARET,
    ACTIONS(7410), 1,
      anon_sym_PIPE,
    ACTIONS(7412), 1,
      anon_sym_AMP,
    ACTIONS(7416), 1,
      anon_sym_GT_GT,
    ACTIONS(7422), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7424), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7426), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7428), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7430), 1,
      anon_sym_as,
    ACTIONS(7432), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7398), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7402), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7404), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7414), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7418), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7420), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6173), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_on,
    STATE(5670), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [142437] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5671), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5520), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5518), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [142518] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5672), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5500), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5498), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [142599] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5673), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5476), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5474), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [142680] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5674), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5472), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5470), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [142761] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5675), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5394), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5392), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [142842] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6216), 4,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    STATE(5676), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [142977] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7732), 1,
      anon_sym_QMARK,
    ACTIONS(7738), 1,
      anon_sym_SLASH,
    ACTIONS(7740), 1,
      anon_sym_CARET,
    ACTIONS(7742), 1,
      anon_sym_PIPE,
    ACTIONS(7744), 1,
      anon_sym_AMP,
    ACTIONS(7748), 1,
      anon_sym_GT_GT,
    ACTIONS(7754), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7756), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7758), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7760), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7762), 1,
      anon_sym_as,
    ACTIONS(7764), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7730), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7734), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7736), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7746), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7750), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7752), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6274), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_equals,
    STATE(5677), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [143112] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(7565), 1,
      anon_sym_DOT_DOT,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5678), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1147), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(1133), 20,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [143211] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5679), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4697), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4695), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [143292] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5680), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5379), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5377), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [143373] = 42,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(6990), 1,
      anon_sym_SLASH,
    ACTIONS(6992), 1,
      anon_sym_AMP,
    ACTIONS(6996), 1,
      anon_sym_GT_GT,
    ACTIONS(7012), 1,
      anon_sym_CARET,
    ACTIONS(7014), 1,
      anon_sym_PIPE,
    ACTIONS(7016), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7018), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7020), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7621), 1,
      anon_sym_QMARK,
    ACTIONS(7643), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7651), 1,
      anon_sym_as,
    ACTIONS(7653), 1,
      anon_sym_is,
    ACTIONS(7773), 1,
      anon_sym_COLON,
    ACTIONS(7775), 1,
      anon_sym_COMMA,
    ACTIONS(7777), 1,
      anon_sym_RBRACE,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    STATE(8400), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6984), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6986), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6988), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6994), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6998), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7000), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5681), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [143514] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5682), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2925), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(2927), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [143595] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(7511), 1,
      anon_sym_DOT_DOT,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5683), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1147), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(1133), 20,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [143694] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7422), 1,
      anon_sym_DOT_DOT,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5684), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6116), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6114), 18,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
  [143797] = 28,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7627), 1,
      anon_sym_SLASH,
    ACTIONS(7637), 1,
      anon_sym_GT_GT,
    ACTIONS(7643), 1,
      anon_sym_DOT_DOT,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7623), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7625), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7635), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6116), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5685), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 14,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [143910] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7721), 1,
      anon_sym_and,
    ACTIONS(7779), 1,
      anon_sym_or,
    STATE(5686), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5856), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5854), 26,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [143995] = 25,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7627), 1,
      anon_sym_SLASH,
    ACTIONS(7643), 1,
      anon_sym_DOT_DOT,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7625), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6116), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5687), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 16,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [144102] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7643), 1,
      anon_sym_DOT_DOT,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5688), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6116), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6114), 18,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [144205] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7551), 1,
      anon_sym_and,
    ACTIONS(7553), 1,
      anon_sym_or,
    STATE(5689), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6609), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6607), 26,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [144290] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7721), 1,
      anon_sym_and,
    ACTIONS(7779), 1,
      anon_sym_or,
    STATE(5690), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6609), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6607), 26,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [144375] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7627), 1,
      anon_sym_SLASH,
    ACTIONS(7633), 1,
      anon_sym_AMP,
    ACTIONS(7637), 1,
      anon_sym_GT_GT,
    ACTIONS(7643), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7651), 1,
      anon_sym_as,
    ACTIONS(7653), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6116), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7619), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7623), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7625), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7635), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7639), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7641), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 8,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(5691), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [144500] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7400), 1,
      anon_sym_QMARK,
    ACTIONS(7406), 1,
      anon_sym_SLASH,
    ACTIONS(7408), 1,
      anon_sym_CARET,
    ACTIONS(7410), 1,
      anon_sym_PIPE,
    ACTIONS(7412), 1,
      anon_sym_AMP,
    ACTIONS(7416), 1,
      anon_sym_GT_GT,
    ACTIONS(7422), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7424), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7426), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7428), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7430), 1,
      anon_sym_as,
    ACTIONS(7432), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7398), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7402), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7404), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7414), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7418), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7420), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6284), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_on,
    STATE(5692), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [144635] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5325), 4,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    STATE(5693), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [144770] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7400), 1,
      anon_sym_QMARK,
    ACTIONS(7406), 1,
      anon_sym_SLASH,
    ACTIONS(7408), 1,
      anon_sym_CARET,
    ACTIONS(7410), 1,
      anon_sym_PIPE,
    ACTIONS(7412), 1,
      anon_sym_AMP,
    ACTIONS(7416), 1,
      anon_sym_GT_GT,
    ACTIONS(7422), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7424), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7426), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7428), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7430), 1,
      anon_sym_as,
    ACTIONS(7432), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7398), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7402), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7404), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7414), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7418), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7420), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6274), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_on,
    STATE(5694), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [144905] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7627), 1,
      anon_sym_SLASH,
    ACTIONS(7629), 1,
      anon_sym_CARET,
    ACTIONS(7633), 1,
      anon_sym_AMP,
    ACTIONS(7637), 1,
      anon_sym_GT_GT,
    ACTIONS(7643), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7651), 1,
      anon_sym_as,
    ACTIONS(7653), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6116), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7619), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7623), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7625), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7635), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7639), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7641), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 7,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(5695), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [145032] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7627), 1,
      anon_sym_SLASH,
    ACTIONS(7637), 1,
      anon_sym_GT_GT,
    ACTIONS(7643), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7651), 1,
      anon_sym_as,
    ACTIONS(7653), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7619), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7623), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7625), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7635), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7639), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7641), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6116), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(6114), 8,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(5696), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [145155] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(7754), 1,
      anon_sym_DOT_DOT,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5697), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1147), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(1133), 20,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [145254] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7609), 1,
      anon_sym_DOT_DOT,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5698), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6116), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6114), 18,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
  [145357] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7627), 1,
      anon_sym_SLASH,
    ACTIONS(7643), 1,
      anon_sym_DOT_DOT,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7623), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7625), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6116), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5699), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 16,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [145466] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7621), 1,
      anon_sym_QMARK,
    ACTIONS(7627), 1,
      anon_sym_SLASH,
    ACTIONS(7629), 1,
      anon_sym_CARET,
    ACTIONS(7631), 1,
      anon_sym_PIPE,
    ACTIONS(7633), 1,
      anon_sym_AMP,
    ACTIONS(7637), 1,
      anon_sym_GT_GT,
    ACTIONS(7643), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7645), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7647), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7649), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7651), 1,
      anon_sym_as,
    ACTIONS(7653), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7619), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7623), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7625), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7635), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7639), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7641), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6220), 4,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    STATE(5700), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [145601] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5701), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5367), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5365), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [145682] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(7643), 1,
      anon_sym_DOT_DOT,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5702), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1147), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(1133), 20,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [145781] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5510), 4,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    STATE(5703), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [145916] = 32,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7627), 1,
      anon_sym_SLASH,
    ACTIONS(7637), 1,
      anon_sym_GT_GT,
    ACTIONS(7643), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7651), 1,
      anon_sym_as,
    ACTIONS(7653), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7619), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7623), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7625), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7635), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7641), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6116), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5704), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 10,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [146037] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(7422), 1,
      anon_sym_DOT_DOT,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5705), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1147), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(1133), 20,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [146136] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(7643), 1,
      anon_sym_DOT_DOT,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5706), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6122), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6120), 20,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [146235] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(7609), 1,
      anon_sym_DOT_DOT,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5707), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6122), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6120), 20,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [146334] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7593), 1,
      anon_sym_SLASH,
    ACTIONS(7609), 1,
      anon_sym_DOT_DOT,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7589), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7591), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6116), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5708), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 16,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
  [146443] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7210), 1,
      anon_sym_is,
    ACTIONS(7438), 1,
      anon_sym_QMARK,
    ACTIONS(7444), 1,
      anon_sym_SLASH,
    ACTIONS(7446), 1,
      anon_sym_CARET,
    ACTIONS(7448), 1,
      anon_sym_PIPE,
    ACTIONS(7450), 1,
      anon_sym_AMP,
    ACTIONS(7454), 1,
      anon_sym_GT_GT,
    ACTIONS(7460), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7462), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7464), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7466), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7781), 1,
      anon_sym_SEMI,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7436), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7440), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7442), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7452), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7456), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7458), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6236), 3,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(5709), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [146580] = 25,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7593), 1,
      anon_sym_SLASH,
    ACTIONS(7609), 1,
      anon_sym_DOT_DOT,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7591), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6116), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5710), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 16,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
  [146687] = 28,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7593), 1,
      anon_sym_SLASH,
    ACTIONS(7603), 1,
      anon_sym_GT_GT,
    ACTIONS(7609), 1,
      anon_sym_DOT_DOT,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7589), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7591), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7601), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6116), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5711), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 14,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
  [146800] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7627), 1,
      anon_sym_SLASH,
    ACTIONS(7629), 1,
      anon_sym_CARET,
    ACTIONS(7631), 1,
      anon_sym_PIPE,
    ACTIONS(7633), 1,
      anon_sym_AMP,
    ACTIONS(7637), 1,
      anon_sym_GT_GT,
    ACTIONS(7643), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7651), 1,
      anon_sym_as,
    ACTIONS(7653), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7619), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7623), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7625), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7635), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7639), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7641), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 7,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(5712), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [146929] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7627), 1,
      anon_sym_SLASH,
    ACTIONS(7629), 1,
      anon_sym_CARET,
    ACTIONS(7631), 1,
      anon_sym_PIPE,
    ACTIONS(7633), 1,
      anon_sym_AMP,
    ACTIONS(7637), 1,
      anon_sym_GT_GT,
    ACTIONS(7643), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7645), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7651), 1,
      anon_sym_as,
    ACTIONS(7653), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7619), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7623), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7625), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7635), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7639), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7641), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 6,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(5713), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [147060] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(2738), 1,
      sym_generic_name,
    STATE(5368), 1,
      sym_identifier,
    STATE(6777), 1,
      sym_attribute_target_specifier,
    STATE(8106), 1,
      sym__name,
    STATE(8527), 1,
      sym_attribute,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    ACTIONS(1045), 7,
      anon_sym_field,
      anon_sym_event,
      anon_sym_method,
      anon_sym_param,
      anon_sym_property,
      anon_sym_return,
      anon_sym_type,
    STATE(5714), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [147157] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7627), 1,
      anon_sym_SLASH,
    ACTIONS(7629), 1,
      anon_sym_CARET,
    ACTIONS(7631), 1,
      anon_sym_PIPE,
    ACTIONS(7633), 1,
      anon_sym_AMP,
    ACTIONS(7637), 1,
      anon_sym_GT_GT,
    ACTIONS(7643), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7645), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7647), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7649), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7651), 1,
      anon_sym_as,
    ACTIONS(7653), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7619), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7623), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7625), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7635), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7639), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7641), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 4,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    STATE(5715), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [147292] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7551), 1,
      anon_sym_and,
    STATE(5716), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6546), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6544), 27,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [147375] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5717), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5418), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5416), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [147456] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7621), 1,
      anon_sym_QMARK,
    ACTIONS(7627), 1,
      anon_sym_SLASH,
    ACTIONS(7629), 1,
      anon_sym_CARET,
    ACTIONS(7631), 1,
      anon_sym_PIPE,
    ACTIONS(7633), 1,
      anon_sym_AMP,
    ACTIONS(7637), 1,
      anon_sym_GT_GT,
    ACTIONS(7643), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7645), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7647), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7649), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7651), 1,
      anon_sym_as,
    ACTIONS(7653), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7619), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7623), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7625), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7635), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7639), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7641), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5420), 4,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    STATE(5718), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [147591] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5719), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5343), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5341), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [147672] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7621), 1,
      anon_sym_QMARK,
    ACTIONS(7627), 1,
      anon_sym_SLASH,
    ACTIONS(7629), 1,
      anon_sym_CARET,
    ACTIONS(7631), 1,
      anon_sym_PIPE,
    ACTIONS(7633), 1,
      anon_sym_AMP,
    ACTIONS(7637), 1,
      anon_sym_GT_GT,
    ACTIONS(7643), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7645), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7647), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7649), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7651), 1,
      anon_sym_as,
    ACTIONS(7653), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7619), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7623), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7625), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7635), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7639), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7641), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5510), 4,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    STATE(5720), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [147807] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5721), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5335), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5333), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [147888] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7621), 1,
      anon_sym_QMARK,
    ACTIONS(7627), 1,
      anon_sym_SLASH,
    ACTIONS(7629), 1,
      anon_sym_CARET,
    ACTIONS(7631), 1,
      anon_sym_PIPE,
    ACTIONS(7633), 1,
      anon_sym_AMP,
    ACTIONS(7637), 1,
      anon_sym_GT_GT,
    ACTIONS(7643), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7645), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7647), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7649), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7651), 1,
      anon_sym_as,
    ACTIONS(7653), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7619), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7623), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7625), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7635), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7639), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7641), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5325), 4,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    STATE(5722), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [148023] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5723), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5508), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5506), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [148104] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7621), 1,
      anon_sym_QMARK,
    ACTIONS(7627), 1,
      anon_sym_SLASH,
    ACTIONS(7629), 1,
      anon_sym_CARET,
    ACTIONS(7631), 1,
      anon_sym_PIPE,
    ACTIONS(7633), 1,
      anon_sym_AMP,
    ACTIONS(7637), 1,
      anon_sym_GT_GT,
    ACTIONS(7643), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7645), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7647), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7649), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7651), 1,
      anon_sym_as,
    ACTIONS(7653), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7619), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7623), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7625), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7635), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7639), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7641), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6216), 4,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    STATE(5724), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [148239] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(7609), 1,
      anon_sym_DOT_DOT,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5725), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1147), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(1133), 20,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [148338] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7621), 1,
      anon_sym_QMARK,
    ACTIONS(7627), 1,
      anon_sym_SLASH,
    ACTIONS(7629), 1,
      anon_sym_CARET,
    ACTIONS(7631), 1,
      anon_sym_PIPE,
    ACTIONS(7633), 1,
      anon_sym_AMP,
    ACTIONS(7637), 1,
      anon_sym_GT_GT,
    ACTIONS(7643), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7645), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7647), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7649), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7651), 1,
      anon_sym_as,
    ACTIONS(7653), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7619), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7623), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7625), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7635), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7639), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7641), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5396), 4,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    STATE(5726), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [148473] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7621), 1,
      anon_sym_QMARK,
    ACTIONS(7627), 1,
      anon_sym_SLASH,
    ACTIONS(7629), 1,
      anon_sym_CARET,
    ACTIONS(7631), 1,
      anon_sym_PIPE,
    ACTIONS(7633), 1,
      anon_sym_AMP,
    ACTIONS(7637), 1,
      anon_sym_GT_GT,
    ACTIONS(7643), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7645), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7647), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7649), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7651), 1,
      anon_sym_as,
    ACTIONS(7653), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7619), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7623), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7625), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7635), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7639), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7641), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5385), 4,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    STATE(5727), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [148608] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7621), 1,
      anon_sym_QMARK,
    ACTIONS(7627), 1,
      anon_sym_SLASH,
    ACTIONS(7629), 1,
      anon_sym_CARET,
    ACTIONS(7631), 1,
      anon_sym_PIPE,
    ACTIONS(7633), 1,
      anon_sym_AMP,
    ACTIONS(7637), 1,
      anon_sym_GT_GT,
    ACTIONS(7643), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7645), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7647), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7649), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7651), 1,
      anon_sym_as,
    ACTIONS(7653), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7619), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7623), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7625), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7635), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7639), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7641), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5337), 4,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    STATE(5728), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [148743] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5420), 4,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    STATE(5729), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [148878] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5730), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5574), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5572), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [148959] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5731), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5450), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5448), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [149040] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7468), 1,
      anon_sym_into,
    STATE(5395), 1,
      aux_sym__query_body_repeat2,
    STATE(5732), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6448), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6446), 26,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [149125] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5733), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5480), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5478), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [149206] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5734), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5488), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5486), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [149287] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5735), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5251), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5249), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [149368] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 4,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    STATE(5736), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [149503] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7500), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 6,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(5737), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [149634] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7500), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 7,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(5738), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [149763] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5739), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6122), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6120), 20,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [149862] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5740), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5562), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5560), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [149943] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(2738), 1,
      sym_generic_name,
    STATE(5368), 1,
      sym_identifier,
    STATE(6775), 1,
      sym_attribute_target_specifier,
    STATE(8106), 1,
      sym__name,
    STATE(8465), 1,
      sym_attribute,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    ACTIONS(1045), 7,
      anon_sym_field,
      anon_sym_event,
      anon_sym_method,
      anon_sym_param,
      anon_sym_property,
      anon_sym_return,
      anon_sym_type,
    STATE(5741), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [150040] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7783), 1,
      anon_sym_LPAREN,
    STATE(5742), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1941), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(1943), 27,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [150123] = 28,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7406), 1,
      anon_sym_SLASH,
    ACTIONS(7416), 1,
      anon_sym_GT_GT,
    ACTIONS(7422), 1,
      anon_sym_DOT_DOT,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7402), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7404), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7414), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6116), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5743), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 14,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
  [150236] = 25,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7406), 1,
      anon_sym_SLASH,
    ACTIONS(7422), 1,
      anon_sym_DOT_DOT,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7404), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6116), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5744), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 16,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
  [150343] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(6320), 1,
      anon_sym_switch,
    ACTIONS(6334), 1,
      anon_sym_with,
    ACTIONS(7406), 1,
      anon_sym_SLASH,
    ACTIONS(7422), 1,
      anon_sym_DOT_DOT,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7402), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7404), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6116), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5745), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 16,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
  [150452] = 32,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7500), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6116), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5746), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 10,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [150573] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(7422), 1,
      anon_sym_DOT_DOT,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5747), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6122), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6120), 20,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [150672] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6116), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5748), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 16,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [150781] = 28,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6116), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5749), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 14,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [150894] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7500), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6116), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(6114), 8,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(5750), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [151017] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7500), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6116), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 7,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(5751), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [151144] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7500), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6116), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 8,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(5752), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [151269] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5753), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6116), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6114), 18,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [151372] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(7785), 1,
      anon_sym_DOT_DOT,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5754), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1147), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(1133), 19,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [151470] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7793), 1,
      anon_sym_SLASH,
    ACTIONS(7797), 1,
      anon_sym_GT_GT,
    ACTIONS(7803), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7805), 1,
      anon_sym_as,
    ACTIONS(7807), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7787), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7789), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7791), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7795), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7799), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7801), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6116), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(6114), 7,
      anon_sym_CARET,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_equals,
    STATE(5755), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [151592] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7793), 1,
      anon_sym_SLASH,
    ACTIONS(7797), 1,
      anon_sym_GT_GT,
    ACTIONS(7803), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7805), 1,
      anon_sym_as,
    ACTIONS(7807), 1,
      anon_sym_is,
    ACTIONS(7809), 1,
      anon_sym_CARET,
    ACTIONS(7811), 1,
      anon_sym_AMP,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6116), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7787), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7789), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7791), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7795), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7799), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7801), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 6,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_equals,
    STATE(5756), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [151718] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7793), 1,
      anon_sym_SLASH,
    ACTIONS(7797), 1,
      anon_sym_GT_GT,
    ACTIONS(7803), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7805), 1,
      anon_sym_as,
    ACTIONS(7807), 1,
      anon_sym_is,
    ACTIONS(7811), 1,
      anon_sym_AMP,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6116), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7787), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7789), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7791), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7795), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7799), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7801), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 7,
      anon_sym_CARET,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_equals,
    STATE(5757), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [151842] = 25,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7793), 1,
      anon_sym_SLASH,
    ACTIONS(7803), 1,
      anon_sym_DOT_DOT,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7791), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6116), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5758), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 15,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
  [151948] = 28,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7793), 1,
      anon_sym_SLASH,
    ACTIONS(7797), 1,
      anon_sym_GT_GT,
    ACTIONS(7803), 1,
      anon_sym_DOT_DOT,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7789), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7791), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7795), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6116), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5759), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 13,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
  [152060] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7813), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
    STATE(5760), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [152194] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7813), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
    STATE(5761), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [152328] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7815), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
    STATE(5762), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [152462] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7817), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
    STATE(5763), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [152596] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4277), 1,
      anon_sym_LBRACE,
    ACTIONS(4295), 1,
      sym_discard,
    ACTIONS(7333), 1,
      sym__identifier_token,
    ACTIONS(7337), 1,
      anon_sym_LPAREN,
    ACTIONS(7819), 1,
      anon_sym_COMMA,
    ACTIONS(7822), 1,
      anon_sym_RPAREN,
    STATE(3127), 1,
      sym__reserved_identifier,
    STATE(4260), 1,
      sym__variable_designation,
    STATE(4274), 1,
      sym_parenthesized_variable_designation,
    STATE(6162), 1,
      sym_positional_pattern_clause,
    STATE(6695), 1,
      sym_property_pattern_clause,
    STATE(7809), 1,
      sym_identifier,
    STATE(9033), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    ACTIONS(4279), 2,
      anon_sym_and,
      anon_sym_or,
    STATE(5764), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7335), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [152704] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2607), 1,
      anon_sym_COMMA,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(7824), 1,
      anon_sym_RBRACK,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    STATE(8449), 1,
      aux_sym_array_rank_specifier_repeat1,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5765), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [152842] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4277), 1,
      anon_sym_LBRACE,
    ACTIONS(4295), 1,
      sym_discard,
    ACTIONS(7333), 1,
      sym__identifier_token,
    ACTIONS(7337), 1,
      anon_sym_LPAREN,
    ACTIONS(7819), 1,
      anon_sym_COMMA,
    ACTIONS(7826), 1,
      anon_sym_RPAREN,
    STATE(3127), 1,
      sym__reserved_identifier,
    STATE(4260), 1,
      sym__variable_designation,
    STATE(4274), 1,
      sym_parenthesized_variable_designation,
    STATE(6162), 1,
      sym_positional_pattern_clause,
    STATE(6695), 1,
      sym_property_pattern_clause,
    STATE(7809), 1,
      sym_identifier,
    STATE(9033), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    ACTIONS(4279), 2,
      anon_sym_and,
      anon_sym_or,
    STATE(5766), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7335), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [152950] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7785), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7830), 1,
      anon_sym_QMARK,
    ACTIONS(7836), 1,
      anon_sym_SLASH,
    ACTIONS(7838), 1,
      anon_sym_CARET,
    ACTIONS(7840), 1,
      anon_sym_PIPE,
    ACTIONS(7842), 1,
      anon_sym_AMP,
    ACTIONS(7846), 1,
      anon_sym_GT_GT,
    ACTIONS(7852), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7854), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7856), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7858), 1,
      anon_sym_as,
    ACTIONS(7860), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7828), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7832), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7834), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7844), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7848), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7850), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6173), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_on,
    STATE(5767), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [153084] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2607), 1,
      anon_sym_COMMA,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(7862), 1,
      anon_sym_RBRACK,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    STATE(8666), 1,
      aux_sym_array_rank_specifier_repeat1,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5768), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [153222] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7793), 1,
      anon_sym_SLASH,
    ACTIONS(7797), 1,
      anon_sym_GT_GT,
    ACTIONS(7803), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7805), 1,
      anon_sym_as,
    ACTIONS(7807), 1,
      anon_sym_is,
    ACTIONS(7809), 1,
      anon_sym_CARET,
    ACTIONS(7811), 1,
      anon_sym_AMP,
    ACTIONS(7864), 1,
      anon_sym_QMARK,
    ACTIONS(7866), 1,
      anon_sym_PIPE,
    ACTIONS(7868), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7870), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7872), 1,
      anon_sym_QMARK_QMARK,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7787), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7789), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7791), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7795), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7799), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7801), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5420), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_equals,
    STATE(5769), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [153356] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7793), 1,
      anon_sym_SLASH,
    ACTIONS(7803), 1,
      anon_sym_DOT_DOT,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7789), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7791), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6116), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5770), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 15,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
  [153464] = 32,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7793), 1,
      anon_sym_SLASH,
    ACTIONS(7797), 1,
      anon_sym_GT_GT,
    ACTIONS(7803), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7805), 1,
      anon_sym_as,
    ACTIONS(7807), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7787), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7789), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7791), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7795), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7801), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6116), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5771), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 9,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_equals,
  [153584] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7874), 1,
      anon_sym_DOT_DOT,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5772), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6116), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6114), 17,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [153686] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(7874), 1,
      anon_sym_DOT_DOT,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5773), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1147), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(1133), 19,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [153784] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7878), 1,
      anon_sym_QMARK,
    ACTIONS(7884), 1,
      anon_sym_SLASH,
    ACTIONS(7886), 1,
      anon_sym_CARET,
    ACTIONS(7888), 1,
      anon_sym_PIPE,
    ACTIONS(7890), 1,
      anon_sym_AMP,
    ACTIONS(7894), 1,
      anon_sym_GT_GT,
    ACTIONS(7900), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7902), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7904), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7906), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7908), 1,
      anon_sym_as,
    ACTIONS(7910), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7876), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7880), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7882), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7892), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7896), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7898), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6220), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_by,
    STATE(5774), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [153918] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7878), 1,
      anon_sym_QMARK,
    ACTIONS(7884), 1,
      anon_sym_SLASH,
    ACTIONS(7886), 1,
      anon_sym_CARET,
    ACTIONS(7888), 1,
      anon_sym_PIPE,
    ACTIONS(7890), 1,
      anon_sym_AMP,
    ACTIONS(7894), 1,
      anon_sym_GT_GT,
    ACTIONS(7900), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7902), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7904), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7906), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7908), 1,
      anon_sym_as,
    ACTIONS(7910), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7876), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7880), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7882), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7892), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7896), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7898), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5337), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_by,
    STATE(5775), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [154052] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7878), 1,
      anon_sym_QMARK,
    ACTIONS(7884), 1,
      anon_sym_SLASH,
    ACTIONS(7886), 1,
      anon_sym_CARET,
    ACTIONS(7888), 1,
      anon_sym_PIPE,
    ACTIONS(7890), 1,
      anon_sym_AMP,
    ACTIONS(7894), 1,
      anon_sym_GT_GT,
    ACTIONS(7900), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7902), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7904), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7906), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7908), 1,
      anon_sym_as,
    ACTIONS(7910), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7876), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7880), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7882), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7892), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7896), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7898), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5385), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_by,
    STATE(5776), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [154186] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7878), 1,
      anon_sym_QMARK,
    ACTIONS(7884), 1,
      anon_sym_SLASH,
    ACTIONS(7886), 1,
      anon_sym_CARET,
    ACTIONS(7888), 1,
      anon_sym_PIPE,
    ACTIONS(7890), 1,
      anon_sym_AMP,
    ACTIONS(7894), 1,
      anon_sym_GT_GT,
    ACTIONS(7900), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7902), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7904), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7906), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7908), 1,
      anon_sym_as,
    ACTIONS(7910), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7876), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7880), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7882), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7892), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7896), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7898), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5396), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_by,
    STATE(5777), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [154320] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7878), 1,
      anon_sym_QMARK,
    ACTIONS(7884), 1,
      anon_sym_SLASH,
    ACTIONS(7886), 1,
      anon_sym_CARET,
    ACTIONS(7888), 1,
      anon_sym_PIPE,
    ACTIONS(7890), 1,
      anon_sym_AMP,
    ACTIONS(7894), 1,
      anon_sym_GT_GT,
    ACTIONS(7900), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7902), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7904), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7906), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7908), 1,
      anon_sym_as,
    ACTIONS(7910), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7876), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7880), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7882), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7892), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7896), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7898), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6216), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_by,
    STATE(5778), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [154454] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7878), 1,
      anon_sym_QMARK,
    ACTIONS(7884), 1,
      anon_sym_SLASH,
    ACTIONS(7886), 1,
      anon_sym_CARET,
    ACTIONS(7888), 1,
      anon_sym_PIPE,
    ACTIONS(7890), 1,
      anon_sym_AMP,
    ACTIONS(7894), 1,
      anon_sym_GT_GT,
    ACTIONS(7900), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7902), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7904), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7906), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7908), 1,
      anon_sym_as,
    ACTIONS(7910), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7876), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7880), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7882), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7892), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7896), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7898), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5325), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_by,
    STATE(5779), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [154588] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7878), 1,
      anon_sym_QMARK,
    ACTIONS(7884), 1,
      anon_sym_SLASH,
    ACTIONS(7886), 1,
      anon_sym_CARET,
    ACTIONS(7888), 1,
      anon_sym_PIPE,
    ACTIONS(7890), 1,
      anon_sym_AMP,
    ACTIONS(7894), 1,
      anon_sym_GT_GT,
    ACTIONS(7900), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7902), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7904), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7906), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7908), 1,
      anon_sym_as,
    ACTIONS(7910), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7876), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7880), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7882), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7892), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7896), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7898), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5510), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_by,
    STATE(5780), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [154722] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6959), 1,
      anon_sym_as,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7874), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7914), 1,
      anon_sym_QMARK,
    ACTIONS(7920), 1,
      anon_sym_SLASH,
    ACTIONS(7922), 1,
      anon_sym_CARET,
    ACTIONS(7924), 1,
      anon_sym_PIPE,
    ACTIONS(7926), 1,
      anon_sym_AMP,
    ACTIONS(7930), 1,
      anon_sym_GT_GT,
    ACTIONS(7936), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7938), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7940), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7942), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7912), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7916), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7918), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7928), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7932), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7934), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6173), 3,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
    STATE(5781), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [154856] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7178), 1,
      anon_sym_QMARK,
    ACTIONS(7184), 1,
      anon_sym_SLASH,
    ACTIONS(7186), 1,
      anon_sym_CARET,
    ACTIONS(7188), 1,
      anon_sym_PIPE,
    ACTIONS(7190), 1,
      anon_sym_AMP,
    ACTIONS(7194), 1,
      anon_sym_GT_GT,
    ACTIONS(7200), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7202), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7204), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7206), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7210), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7176), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7180), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7182), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7192), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7196), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7198), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6236), 3,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(5782), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [154990] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7878), 1,
      anon_sym_QMARK,
    ACTIONS(7884), 1,
      anon_sym_SLASH,
    ACTIONS(7886), 1,
      anon_sym_CARET,
    ACTIONS(7888), 1,
      anon_sym_PIPE,
    ACTIONS(7890), 1,
      anon_sym_AMP,
    ACTIONS(7894), 1,
      anon_sym_GT_GT,
    ACTIONS(7900), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7902), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7904), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7906), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7908), 1,
      anon_sym_as,
    ACTIONS(7910), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7876), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7880), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7882), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7892), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7896), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7898), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5420), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_by,
    STATE(5783), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [155124] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2607), 1,
      anon_sym_COMMA,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(7944), 1,
      anon_sym_RBRACK,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    STATE(8433), 1,
      aux_sym_array_rank_specifier_repeat1,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5784), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [155262] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7878), 1,
      anon_sym_QMARK,
    ACTIONS(7884), 1,
      anon_sym_SLASH,
    ACTIONS(7886), 1,
      anon_sym_CARET,
    ACTIONS(7888), 1,
      anon_sym_PIPE,
    ACTIONS(7890), 1,
      anon_sym_AMP,
    ACTIONS(7894), 1,
      anon_sym_GT_GT,
    ACTIONS(7900), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7902), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7904), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7906), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7908), 1,
      anon_sym_as,
    ACTIONS(7910), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7876), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7880), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7882), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7892), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7896), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7898), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6230), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_by,
    STATE(5785), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [155396] = 28,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7950), 1,
      anon_sym_SLASH,
    ACTIONS(7954), 1,
      anon_sym_GT_GT,
    ACTIONS(7956), 1,
      anon_sym_DOT_DOT,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7946), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7948), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7952), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6116), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5786), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 13,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [155508] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(7900), 1,
      anon_sym_DOT_DOT,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5787), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6122), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6120), 19,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [155606] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7878), 1,
      anon_sym_QMARK,
    ACTIONS(7884), 1,
      anon_sym_SLASH,
    ACTIONS(7886), 1,
      anon_sym_CARET,
    ACTIONS(7888), 1,
      anon_sym_PIPE,
    ACTIONS(7890), 1,
      anon_sym_AMP,
    ACTIONS(7894), 1,
      anon_sym_GT_GT,
    ACTIONS(7900), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7902), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7904), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7906), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7908), 1,
      anon_sym_as,
    ACTIONS(7910), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7876), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7880), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7882), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7892), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7896), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7898), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6236), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_by,
    STATE(5788), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [155740] = 25,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7950), 1,
      anon_sym_SLASH,
    ACTIONS(7956), 1,
      anon_sym_DOT_DOT,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7948), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6116), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5789), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 15,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [155846] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7956), 1,
      anon_sym_DOT_DOT,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5790), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6116), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6114), 17,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [155948] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(7950), 1,
      anon_sym_SLASH,
    ACTIONS(7954), 1,
      anon_sym_GT_GT,
    ACTIONS(7956), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7960), 1,
      anon_sym_AMP,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6116), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7946), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7948), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7952), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7958), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7962), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7964), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 7,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(5791), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [156072] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(7950), 1,
      anon_sym_SLASH,
    ACTIONS(7954), 1,
      anon_sym_GT_GT,
    ACTIONS(7956), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7960), 1,
      anon_sym_AMP,
    ACTIONS(7966), 1,
      anon_sym_CARET,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6116), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7946), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7948), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7952), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7958), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7962), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7964), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 6,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(5792), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [156198] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(7950), 1,
      anon_sym_SLASH,
    ACTIONS(7954), 1,
      anon_sym_GT_GT,
    ACTIONS(7956), 1,
      anon_sym_DOT_DOT,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7946), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7948), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7952), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7958), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7962), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7964), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6116), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(6114), 7,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(5793), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [156320] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7950), 1,
      anon_sym_SLASH,
    ACTIONS(7956), 1,
      anon_sym_DOT_DOT,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7946), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7948), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6116), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5794), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 15,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [156428] = 32,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(7950), 1,
      anon_sym_SLASH,
    ACTIONS(7954), 1,
      anon_sym_GT_GT,
    ACTIONS(7956), 1,
      anon_sym_DOT_DOT,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7946), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7948), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7952), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7958), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7964), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6116), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5795), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 9,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [156548] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7621), 1,
      anon_sym_QMARK,
    ACTIONS(7627), 1,
      anon_sym_SLASH,
    ACTIONS(7629), 1,
      anon_sym_CARET,
    ACTIONS(7631), 1,
      anon_sym_PIPE,
    ACTIONS(7633), 1,
      anon_sym_AMP,
    ACTIONS(7637), 1,
      anon_sym_GT_GT,
    ACTIONS(7643), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7645), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7647), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7649), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7651), 1,
      anon_sym_as,
    ACTIONS(7653), 1,
      anon_sym_is,
    ACTIONS(7968), 1,
      anon_sym_COMMA,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6220), 2,
      anon_sym_COLON,
      anon_sym_RPAREN,
    ACTIONS(7619), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7623), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7625), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7635), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7639), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7641), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5796), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [156684] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(7956), 1,
      anon_sym_DOT_DOT,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5797), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6122), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6120), 19,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [156782] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(7950), 1,
      anon_sym_SLASH,
    ACTIONS(7954), 1,
      anon_sym_GT_GT,
    ACTIONS(7956), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7960), 1,
      anon_sym_AMP,
    ACTIONS(7966), 1,
      anon_sym_CARET,
    ACTIONS(7970), 1,
      anon_sym_PIPE,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7946), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7948), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7952), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7958), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7962), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7964), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 6,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(5798), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [156910] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(7950), 1,
      anon_sym_SLASH,
    ACTIONS(7954), 1,
      anon_sym_GT_GT,
    ACTIONS(7956), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7960), 1,
      anon_sym_AMP,
    ACTIONS(7966), 1,
      anon_sym_CARET,
    ACTIONS(7970), 1,
      anon_sym_PIPE,
    ACTIONS(7972), 1,
      anon_sym_AMP_AMP,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7946), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7948), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7952), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7958), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7962), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7964), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 5,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(5799), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [157040] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(7950), 1,
      anon_sym_SLASH,
    ACTIONS(7954), 1,
      anon_sym_GT_GT,
    ACTIONS(7956), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7960), 1,
      anon_sym_AMP,
    ACTIONS(7966), 1,
      anon_sym_CARET,
    ACTIONS(7970), 1,
      anon_sym_PIPE,
    ACTIONS(7972), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7974), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7976), 1,
      anon_sym_QMARK_QMARK,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7946), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7948), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7952), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7958), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7962), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7964), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 3,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(5800), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [157174] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(7200), 1,
      anon_sym_DOT_DOT,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5801), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1147), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(1133), 19,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [157272] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(7950), 1,
      anon_sym_SLASH,
    ACTIONS(7954), 1,
      anon_sym_GT_GT,
    ACTIONS(7956), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7960), 1,
      anon_sym_AMP,
    ACTIONS(7966), 1,
      anon_sym_CARET,
    ACTIONS(7970), 1,
      anon_sym_PIPE,
    ACTIONS(7972), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7974), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7976), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7978), 1,
      anon_sym_SEMI,
    ACTIONS(7980), 1,
      anon_sym_QMARK,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6236), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(7946), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7948), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7952), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7958), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7962), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7964), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5802), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [157408] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(7982), 1,
      anon_sym_COMMA,
    ACTIONS(7984), 1,
      anon_sym_RBRACE,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    STATE(8589), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5803), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [157546] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4953), 1,
      anon_sym_DASH_GT,
    ACTIONS(5067), 1,
      anon_sym_DOT,
    ACTIONS(6973), 1,
      anon_sym_LPAREN,
    ACTIONS(7022), 1,
      anon_sym_LBRACK,
    ACTIONS(7026), 1,
      anon_sym_BANG,
    ACTIONS(7371), 1,
      anon_sym_DOT_DOT,
    STATE(3870), 1,
      sym_bracketed_argument_list,
    STATE(5721), 1,
      sym_argument_list,
    ACTIONS(7028), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5804), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1147), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(1133), 19,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [157644] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(7986), 1,
      anon_sym_COMMA,
    ACTIONS(7988), 1,
      anon_sym_RPAREN,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    STATE(8520), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5805), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [157782] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7793), 1,
      anon_sym_SLASH,
    ACTIONS(7797), 1,
      anon_sym_GT_GT,
    ACTIONS(7803), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7805), 1,
      anon_sym_as,
    ACTIONS(7807), 1,
      anon_sym_is,
    ACTIONS(7809), 1,
      anon_sym_CARET,
    ACTIONS(7811), 1,
      anon_sym_AMP,
    ACTIONS(7866), 1,
      anon_sym_PIPE,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7787), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7789), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7791), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7795), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7799), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7801), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 6,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_equals,
    STATE(5806), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [157910] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7793), 1,
      anon_sym_SLASH,
    ACTIONS(7797), 1,
      anon_sym_GT_GT,
    ACTIONS(7803), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7805), 1,
      anon_sym_as,
    ACTIONS(7807), 1,
      anon_sym_is,
    ACTIONS(7809), 1,
      anon_sym_CARET,
    ACTIONS(7811), 1,
      anon_sym_AMP,
    ACTIONS(7866), 1,
      anon_sym_PIPE,
    ACTIONS(7868), 1,
      anon_sym_AMP_AMP,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7787), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7789), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7791), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7795), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7799), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7801), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 5,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_equals,
    STATE(5807), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [158040] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(7775), 1,
      anon_sym_COMMA,
    ACTIONS(7777), 1,
      anon_sym_RBRACE,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    STATE(8400), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5808), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [158178] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(7950), 1,
      anon_sym_SLASH,
    ACTIONS(7954), 1,
      anon_sym_GT_GT,
    ACTIONS(7956), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7960), 1,
      anon_sym_AMP,
    ACTIONS(7966), 1,
      anon_sym_CARET,
    ACTIONS(7970), 1,
      anon_sym_PIPE,
    ACTIONS(7972), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7974), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7976), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7980), 1,
      anon_sym_QMARK,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7946), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7948), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7952), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7958), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7962), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7964), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5420), 3,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(5809), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [158312] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7793), 1,
      anon_sym_SLASH,
    ACTIONS(7797), 1,
      anon_sym_GT_GT,
    ACTIONS(7803), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7805), 1,
      anon_sym_as,
    ACTIONS(7807), 1,
      anon_sym_is,
    ACTIONS(7809), 1,
      anon_sym_CARET,
    ACTIONS(7811), 1,
      anon_sym_AMP,
    ACTIONS(7866), 1,
      anon_sym_PIPE,
    ACTIONS(7868), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7870), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7872), 1,
      anon_sym_QMARK_QMARK,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7787), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7789), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7791), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7795), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7799), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7801), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_equals,
    STATE(5810), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [158446] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7178), 1,
      anon_sym_QMARK,
    ACTIONS(7184), 1,
      anon_sym_SLASH,
    ACTIONS(7186), 1,
      anon_sym_CARET,
    ACTIONS(7188), 1,
      anon_sym_PIPE,
    ACTIONS(7190), 1,
      anon_sym_AMP,
    ACTIONS(7194), 1,
      anon_sym_GT_GT,
    ACTIONS(7200), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7202), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7204), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7206), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7210), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7176), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7180), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7182), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7192), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7196), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7198), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6230), 3,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(5811), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [158580] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7884), 1,
      anon_sym_SLASH,
    ACTIONS(7886), 1,
      anon_sym_CARET,
    ACTIONS(7888), 1,
      anon_sym_PIPE,
    ACTIONS(7890), 1,
      anon_sym_AMP,
    ACTIONS(7894), 1,
      anon_sym_GT_GT,
    ACTIONS(7900), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7902), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7904), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7906), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7908), 1,
      anon_sym_as,
    ACTIONS(7910), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7876), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7880), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7882), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7892), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7896), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7898), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_by,
    STATE(5812), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [158714] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7884), 1,
      anon_sym_SLASH,
    ACTIONS(7886), 1,
      anon_sym_CARET,
    ACTIONS(7888), 1,
      anon_sym_PIPE,
    ACTIONS(7890), 1,
      anon_sym_AMP,
    ACTIONS(7894), 1,
      anon_sym_GT_GT,
    ACTIONS(7900), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7902), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7908), 1,
      anon_sym_as,
    ACTIONS(7910), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7876), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7880), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7882), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7892), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7896), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7898), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 5,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_by,
    STATE(5813), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [158844] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4277), 1,
      anon_sym_LBRACE,
    ACTIONS(4295), 1,
      sym_discard,
    ACTIONS(7333), 1,
      sym__identifier_token,
    ACTIONS(7337), 1,
      anon_sym_LPAREN,
    ACTIONS(7819), 1,
      anon_sym_COMMA,
    ACTIONS(7990), 1,
      anon_sym_RPAREN,
    STATE(3127), 1,
      sym__reserved_identifier,
    STATE(4260), 1,
      sym__variable_designation,
    STATE(4274), 1,
      sym_parenthesized_variable_designation,
    STATE(6162), 1,
      sym_positional_pattern_clause,
    STATE(6695), 1,
      sym_property_pattern_clause,
    STATE(7809), 1,
      sym_identifier,
    STATE(9033), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    ACTIONS(4279), 2,
      anon_sym_and,
      anon_sym_or,
    STATE(5814), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7335), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [158952] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7884), 1,
      anon_sym_SLASH,
    ACTIONS(7886), 1,
      anon_sym_CARET,
    ACTIONS(7888), 1,
      anon_sym_PIPE,
    ACTIONS(7890), 1,
      anon_sym_AMP,
    ACTIONS(7894), 1,
      anon_sym_GT_GT,
    ACTIONS(7900), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7908), 1,
      anon_sym_as,
    ACTIONS(7910), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7876), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7880), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7882), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7892), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7896), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7898), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 6,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_by,
    STATE(5815), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [159080] = 32,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7884), 1,
      anon_sym_SLASH,
    ACTIONS(7894), 1,
      anon_sym_GT_GT,
    ACTIONS(7900), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7908), 1,
      anon_sym_as,
    ACTIONS(7910), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7876), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7880), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7882), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7892), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7898), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6116), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5816), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 9,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_by,
  [159200] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7884), 1,
      anon_sym_SLASH,
    ACTIONS(7900), 1,
      anon_sym_DOT_DOT,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7880), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7882), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6116), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5817), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 15,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
  [159308] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7785), 1,
      anon_sym_DOT_DOT,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5818), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6116), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6114), 17,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
  [159410] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7884), 1,
      anon_sym_SLASH,
    ACTIONS(7894), 1,
      anon_sym_GT_GT,
    ACTIONS(7900), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7908), 1,
      anon_sym_as,
    ACTIONS(7910), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7876), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7880), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7882), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7892), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7896), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7898), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6116), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(6114), 7,
      anon_sym_CARET,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_by,
    STATE(5819), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [159532] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7884), 1,
      anon_sym_SLASH,
    ACTIONS(7886), 1,
      anon_sym_CARET,
    ACTIONS(7890), 1,
      anon_sym_AMP,
    ACTIONS(7894), 1,
      anon_sym_GT_GT,
    ACTIONS(7900), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7908), 1,
      anon_sym_as,
    ACTIONS(7910), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6116), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7876), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7880), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7882), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7892), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7896), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7898), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 6,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_by,
    STATE(5820), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [159658] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4953), 1,
      anon_sym_DASH_GT,
    ACTIONS(5067), 1,
      anon_sym_DOT,
    ACTIONS(6973), 1,
      anon_sym_LPAREN,
    ACTIONS(7022), 1,
      anon_sym_LBRACK,
    ACTIONS(7026), 1,
      anon_sym_BANG,
    ACTIONS(7042), 1,
      anon_sym_switch,
    ACTIONS(7050), 1,
      anon_sym_with,
    ACTIONS(7234), 1,
      anon_sym_as,
    ACTIONS(7349), 1,
      anon_sym_QMARK,
    ACTIONS(7355), 1,
      anon_sym_SLASH,
    ACTIONS(7357), 1,
      anon_sym_CARET,
    ACTIONS(7359), 1,
      anon_sym_PIPE,
    ACTIONS(7361), 1,
      anon_sym_AMP,
    ACTIONS(7365), 1,
      anon_sym_GT_GT,
    ACTIONS(7371), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7373), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7375), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7377), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7379), 1,
      anon_sym_is,
    STATE(3870), 1,
      sym_bracketed_argument_list,
    STATE(5721), 1,
      sym_argument_list,
    ACTIONS(7028), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7347), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7351), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7353), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7363), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7367), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7369), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6220), 3,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(5821), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [159792] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7884), 1,
      anon_sym_SLASH,
    ACTIONS(7890), 1,
      anon_sym_AMP,
    ACTIONS(7894), 1,
      anon_sym_GT_GT,
    ACTIONS(7900), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7908), 1,
      anon_sym_as,
    ACTIONS(7910), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6116), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7876), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7880), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7882), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7892), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7896), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7898), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 7,
      anon_sym_CARET,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_by,
    STATE(5822), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [159916] = 25,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7884), 1,
      anon_sym_SLASH,
    ACTIONS(7900), 1,
      anon_sym_DOT_DOT,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7882), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6116), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5823), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 15,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
  [160022] = 28,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7884), 1,
      anon_sym_SLASH,
    ACTIONS(7894), 1,
      anon_sym_GT_GT,
    ACTIONS(7900), 1,
      anon_sym_DOT_DOT,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7880), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7882), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7892), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6116), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5824), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 13,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
  [160134] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7178), 1,
      anon_sym_QMARK,
    ACTIONS(7184), 1,
      anon_sym_SLASH,
    ACTIONS(7186), 1,
      anon_sym_CARET,
    ACTIONS(7188), 1,
      anon_sym_PIPE,
    ACTIONS(7190), 1,
      anon_sym_AMP,
    ACTIONS(7194), 1,
      anon_sym_GT_GT,
    ACTIONS(7200), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7202), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7204), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7206), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7210), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7176), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7180), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7182), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7192), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7196), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7198), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6220), 3,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(5825), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [160268] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7178), 1,
      anon_sym_QMARK,
    ACTIONS(7184), 1,
      anon_sym_SLASH,
    ACTIONS(7186), 1,
      anon_sym_CARET,
    ACTIONS(7188), 1,
      anon_sym_PIPE,
    ACTIONS(7190), 1,
      anon_sym_AMP,
    ACTIONS(7194), 1,
      anon_sym_GT_GT,
    ACTIONS(7200), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7202), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7204), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7206), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7210), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7176), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7180), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7182), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7192), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7196), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7198), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6216), 3,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(5826), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [160402] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7793), 1,
      anon_sym_SLASH,
    ACTIONS(7797), 1,
      anon_sym_GT_GT,
    ACTIONS(7803), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7805), 1,
      anon_sym_as,
    ACTIONS(7807), 1,
      anon_sym_is,
    ACTIONS(7809), 1,
      anon_sym_CARET,
    ACTIONS(7811), 1,
      anon_sym_AMP,
    ACTIONS(7864), 1,
      anon_sym_QMARK,
    ACTIONS(7866), 1,
      anon_sym_PIPE,
    ACTIONS(7868), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7870), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7872), 1,
      anon_sym_QMARK_QMARK,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7787), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7789), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7791), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7795), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7799), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7801), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6236), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_equals,
    STATE(5827), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [160536] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(7950), 1,
      anon_sym_SLASH,
    ACTIONS(7954), 1,
      anon_sym_GT_GT,
    ACTIONS(7956), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7960), 1,
      anon_sym_AMP,
    ACTIONS(7966), 1,
      anon_sym_CARET,
    ACTIONS(7970), 1,
      anon_sym_PIPE,
    ACTIONS(7972), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7974), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7976), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7980), 1,
      anon_sym_QMARK,
    ACTIONS(7992), 1,
      anon_sym_SEMI,
    ACTIONS(7994), 1,
      anon_sym_COMMA,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    STATE(8421), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7946), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7948), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7952), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7958), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7962), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7964), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5828), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [160674] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4277), 1,
      anon_sym_LBRACE,
    ACTIONS(4295), 1,
      sym_discard,
    ACTIONS(7333), 1,
      sym__identifier_token,
    ACTIONS(7337), 1,
      anon_sym_LPAREN,
    ACTIONS(7819), 1,
      anon_sym_COMMA,
    ACTIONS(7996), 1,
      anon_sym_RPAREN,
    STATE(3127), 1,
      sym__reserved_identifier,
    STATE(4260), 1,
      sym__variable_designation,
    STATE(4274), 1,
      sym_parenthesized_variable_designation,
    STATE(6162), 1,
      sym_positional_pattern_clause,
    STATE(6695), 1,
      sym_property_pattern_clause,
    STATE(7809), 1,
      sym_identifier,
    STATE(9033), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    ACTIONS(4279), 2,
      anon_sym_and,
      anon_sym_or,
    STATE(5829), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7335), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [160782] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(7803), 1,
      anon_sym_DOT_DOT,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5830), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6122), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6120), 19,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [160880] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7793), 1,
      anon_sym_SLASH,
    ACTIONS(7797), 1,
      anon_sym_GT_GT,
    ACTIONS(7803), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7805), 1,
      anon_sym_as,
    ACTIONS(7807), 1,
      anon_sym_is,
    ACTIONS(7809), 1,
      anon_sym_CARET,
    ACTIONS(7811), 1,
      anon_sym_AMP,
    ACTIONS(7864), 1,
      anon_sym_QMARK,
    ACTIONS(7866), 1,
      anon_sym_PIPE,
    ACTIONS(7868), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7870), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7872), 1,
      anon_sym_QMARK_QMARK,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7787), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7789), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7791), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7795), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7799), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7801), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6230), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_equals,
    STATE(5831), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [161014] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7793), 1,
      anon_sym_SLASH,
    ACTIONS(7797), 1,
      anon_sym_GT_GT,
    ACTIONS(7803), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7805), 1,
      anon_sym_as,
    ACTIONS(7807), 1,
      anon_sym_is,
    ACTIONS(7809), 1,
      anon_sym_CARET,
    ACTIONS(7811), 1,
      anon_sym_AMP,
    ACTIONS(7864), 1,
      anon_sym_QMARK,
    ACTIONS(7866), 1,
      anon_sym_PIPE,
    ACTIONS(7868), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7870), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7872), 1,
      anon_sym_QMARK_QMARK,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7787), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7789), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7791), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7795), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7799), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7801), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6173), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_equals,
    STATE(5832), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [161148] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7785), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7830), 1,
      anon_sym_QMARK,
    ACTIONS(7836), 1,
      anon_sym_SLASH,
    ACTIONS(7838), 1,
      anon_sym_CARET,
    ACTIONS(7840), 1,
      anon_sym_PIPE,
    ACTIONS(7842), 1,
      anon_sym_AMP,
    ACTIONS(7846), 1,
      anon_sym_GT_GT,
    ACTIONS(7852), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7854), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7856), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7858), 1,
      anon_sym_as,
    ACTIONS(7860), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7828), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7832), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7834), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7844), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7848), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7850), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6220), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_on,
    STATE(5833), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [161282] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4277), 1,
      anon_sym_LBRACE,
    ACTIONS(4295), 1,
      sym_discard,
    ACTIONS(7333), 1,
      sym__identifier_token,
    ACTIONS(7337), 1,
      anon_sym_LPAREN,
    ACTIONS(7819), 1,
      anon_sym_COMMA,
    ACTIONS(7998), 1,
      anon_sym_RPAREN,
    STATE(3127), 1,
      sym__reserved_identifier,
    STATE(4260), 1,
      sym__variable_designation,
    STATE(4274), 1,
      sym_parenthesized_variable_designation,
    STATE(6162), 1,
      sym_positional_pattern_clause,
    STATE(6695), 1,
      sym_property_pattern_clause,
    STATE(7809), 1,
      sym_identifier,
    STATE(9033), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    ACTIONS(4279), 2,
      anon_sym_and,
      anon_sym_or,
    STATE(5834), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7335), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [161390] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(7803), 1,
      anon_sym_DOT_DOT,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5835), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1147), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(1133), 19,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [161488] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7793), 1,
      anon_sym_SLASH,
    ACTIONS(7797), 1,
      anon_sym_GT_GT,
    ACTIONS(7803), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7805), 1,
      anon_sym_as,
    ACTIONS(7807), 1,
      anon_sym_is,
    ACTIONS(7809), 1,
      anon_sym_CARET,
    ACTIONS(7811), 1,
      anon_sym_AMP,
    ACTIONS(7864), 1,
      anon_sym_QMARK,
    ACTIONS(7866), 1,
      anon_sym_PIPE,
    ACTIONS(7868), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7870), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7872), 1,
      anon_sym_QMARK_QMARK,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7787), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7789), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7791), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7795), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7799), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7801), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5510), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_equals,
    STATE(5836), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [161622] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4277), 1,
      anon_sym_LBRACE,
    ACTIONS(4295), 1,
      sym_discard,
    ACTIONS(7333), 1,
      sym__identifier_token,
    ACTIONS(7337), 1,
      anon_sym_LPAREN,
    ACTIONS(7819), 1,
      anon_sym_COMMA,
    ACTIONS(8000), 1,
      anon_sym_RPAREN,
    STATE(3127), 1,
      sym__reserved_identifier,
    STATE(4260), 1,
      sym__variable_designation,
    STATE(4274), 1,
      sym_parenthesized_variable_designation,
    STATE(6162), 1,
      sym_positional_pattern_clause,
    STATE(6695), 1,
      sym_property_pattern_clause,
    STATE(7809), 1,
      sym_identifier,
    STATE(9033), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    ACTIONS(4279), 2,
      anon_sym_and,
      anon_sym_or,
    STATE(5837), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7335), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [161730] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7793), 1,
      anon_sym_SLASH,
    ACTIONS(7797), 1,
      anon_sym_GT_GT,
    ACTIONS(7803), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7805), 1,
      anon_sym_as,
    ACTIONS(7807), 1,
      anon_sym_is,
    ACTIONS(7809), 1,
      anon_sym_CARET,
    ACTIONS(7811), 1,
      anon_sym_AMP,
    ACTIONS(7864), 1,
      anon_sym_QMARK,
    ACTIONS(7866), 1,
      anon_sym_PIPE,
    ACTIONS(7868), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7870), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7872), 1,
      anon_sym_QMARK_QMARK,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7787), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7789), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7791), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7795), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7799), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7801), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5325), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_equals,
    STATE(5838), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [161864] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(7950), 1,
      anon_sym_SLASH,
    ACTIONS(7954), 1,
      anon_sym_GT_GT,
    ACTIONS(7956), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7960), 1,
      anon_sym_AMP,
    ACTIONS(7966), 1,
      anon_sym_CARET,
    ACTIONS(7970), 1,
      anon_sym_PIPE,
    ACTIONS(7972), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7974), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7976), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7980), 1,
      anon_sym_QMARK,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7946), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7948), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7952), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7958), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7962), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7964), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5510), 3,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(5839), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [161998] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7803), 1,
      anon_sym_DOT_DOT,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5840), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6116), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6114), 17,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
  [162100] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4277), 1,
      anon_sym_LBRACE,
    ACTIONS(4295), 1,
      sym_discard,
    ACTIONS(7333), 1,
      sym__identifier_token,
    ACTIONS(7337), 1,
      anon_sym_LPAREN,
    ACTIONS(7819), 1,
      anon_sym_COMMA,
    ACTIONS(8002), 1,
      anon_sym_RPAREN,
    STATE(3127), 1,
      sym__reserved_identifier,
    STATE(4260), 1,
      sym__variable_designation,
    STATE(4274), 1,
      sym_parenthesized_variable_designation,
    STATE(6162), 1,
      sym_positional_pattern_clause,
    STATE(6695), 1,
      sym_property_pattern_clause,
    STATE(7809), 1,
      sym_identifier,
    STATE(9033), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    ACTIONS(4279), 2,
      anon_sym_and,
      anon_sym_or,
    STATE(5841), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7335), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [162208] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7793), 1,
      anon_sym_SLASH,
    ACTIONS(7797), 1,
      anon_sym_GT_GT,
    ACTIONS(7803), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7805), 1,
      anon_sym_as,
    ACTIONS(7807), 1,
      anon_sym_is,
    ACTIONS(7809), 1,
      anon_sym_CARET,
    ACTIONS(7811), 1,
      anon_sym_AMP,
    ACTIONS(7864), 1,
      anon_sym_QMARK,
    ACTIONS(7866), 1,
      anon_sym_PIPE,
    ACTIONS(7868), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7870), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7872), 1,
      anon_sym_QMARK_QMARK,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7787), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7789), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7791), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7795), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7799), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7801), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6216), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_equals,
    STATE(5842), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [162342] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8004), 1,
      anon_sym_into,
    STATE(5914), 1,
      aux_sym__query_body_repeat2,
    STATE(5843), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6448), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6446), 25,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [162426] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7793), 1,
      anon_sym_SLASH,
    ACTIONS(7797), 1,
      anon_sym_GT_GT,
    ACTIONS(7803), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7805), 1,
      anon_sym_as,
    ACTIONS(7807), 1,
      anon_sym_is,
    ACTIONS(7809), 1,
      anon_sym_CARET,
    ACTIONS(7811), 1,
      anon_sym_AMP,
    ACTIONS(7864), 1,
      anon_sym_QMARK,
    ACTIONS(7866), 1,
      anon_sym_PIPE,
    ACTIONS(7868), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7870), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7872), 1,
      anon_sym_QMARK_QMARK,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7787), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7789), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7791), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7795), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7799), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7801), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5396), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_equals,
    STATE(5844), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [162560] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7793), 1,
      anon_sym_SLASH,
    ACTIONS(7797), 1,
      anon_sym_GT_GT,
    ACTIONS(7803), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7805), 1,
      anon_sym_as,
    ACTIONS(7807), 1,
      anon_sym_is,
    ACTIONS(7809), 1,
      anon_sym_CARET,
    ACTIONS(7811), 1,
      anon_sym_AMP,
    ACTIONS(7864), 1,
      anon_sym_QMARK,
    ACTIONS(7866), 1,
      anon_sym_PIPE,
    ACTIONS(7868), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7870), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7872), 1,
      anon_sym_QMARK_QMARK,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7787), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7789), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7791), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7795), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7799), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7801), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5385), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_equals,
    STATE(5845), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [162694] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7793), 1,
      anon_sym_SLASH,
    ACTIONS(7797), 1,
      anon_sym_GT_GT,
    ACTIONS(7803), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7805), 1,
      anon_sym_as,
    ACTIONS(7807), 1,
      anon_sym_is,
    ACTIONS(7809), 1,
      anon_sym_CARET,
    ACTIONS(7811), 1,
      anon_sym_AMP,
    ACTIONS(7864), 1,
      anon_sym_QMARK,
    ACTIONS(7866), 1,
      anon_sym_PIPE,
    ACTIONS(7868), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7870), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7872), 1,
      anon_sym_QMARK_QMARK,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7787), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7789), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7791), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7795), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7799), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7801), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5337), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_equals,
    STATE(5846), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [162828] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4277), 1,
      anon_sym_LBRACE,
    ACTIONS(4295), 1,
      sym_discard,
    ACTIONS(7333), 1,
      sym__identifier_token,
    ACTIONS(7337), 1,
      anon_sym_LPAREN,
    ACTIONS(7819), 1,
      anon_sym_COMMA,
    ACTIONS(8006), 1,
      anon_sym_RPAREN,
    STATE(3127), 1,
      sym__reserved_identifier,
    STATE(4260), 1,
      sym__variable_designation,
    STATE(4274), 1,
      sym_parenthesized_variable_designation,
    STATE(6162), 1,
      sym_positional_pattern_clause,
    STATE(6695), 1,
      sym_property_pattern_clause,
    STATE(7809), 1,
      sym_identifier,
    STATE(9033), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    ACTIONS(4279), 2,
      anon_sym_and,
      anon_sym_or,
    STATE(5847), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7335), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [162936] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7793), 1,
      anon_sym_SLASH,
    ACTIONS(7797), 1,
      anon_sym_GT_GT,
    ACTIONS(7803), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7805), 1,
      anon_sym_as,
    ACTIONS(7807), 1,
      anon_sym_is,
    ACTIONS(7809), 1,
      anon_sym_CARET,
    ACTIONS(7811), 1,
      anon_sym_AMP,
    ACTIONS(7864), 1,
      anon_sym_QMARK,
    ACTIONS(7866), 1,
      anon_sym_PIPE,
    ACTIONS(7868), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7870), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7872), 1,
      anon_sym_QMARK_QMARK,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7787), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7789), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7791), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7795), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7799), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7801), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6220), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_equals,
    STATE(5848), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [163070] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7178), 1,
      anon_sym_QMARK,
    ACTIONS(7184), 1,
      anon_sym_SLASH,
    ACTIONS(7186), 1,
      anon_sym_CARET,
    ACTIONS(7188), 1,
      anon_sym_PIPE,
    ACTIONS(7190), 1,
      anon_sym_AMP,
    ACTIONS(7194), 1,
      anon_sym_GT_GT,
    ACTIONS(7200), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7202), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7204), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7206), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7210), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7176), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7180), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7182), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7192), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7196), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7198), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5325), 3,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(5849), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [163204] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(7900), 1,
      anon_sym_DOT_DOT,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5850), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1147), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(1133), 19,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [163302] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7900), 1,
      anon_sym_DOT_DOT,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5851), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6116), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6114), 17,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
  [163404] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4277), 1,
      anon_sym_LBRACE,
    ACTIONS(4295), 1,
      sym_discard,
    ACTIONS(7333), 1,
      sym__identifier_token,
    ACTIONS(7337), 1,
      anon_sym_LPAREN,
    ACTIONS(7819), 1,
      anon_sym_COMMA,
    ACTIONS(8008), 1,
      anon_sym_RPAREN,
    STATE(3127), 1,
      sym__reserved_identifier,
    STATE(4260), 1,
      sym__variable_designation,
    STATE(4274), 1,
      sym_parenthesized_variable_designation,
    STATE(6162), 1,
      sym_positional_pattern_clause,
    STATE(6695), 1,
      sym_property_pattern_clause,
    STATE(7809), 1,
      sym_identifier,
    STATE(9033), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    ACTIONS(4279), 2,
      anon_sym_and,
      anon_sym_or,
    STATE(5852), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7335), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [163512] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(8010), 1,
      anon_sym_COMMA,
    ACTIONS(8012), 1,
      anon_sym_RBRACE,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    STATE(8399), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5853), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [163650] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4277), 1,
      anon_sym_LBRACE,
    ACTIONS(4295), 1,
      sym_discard,
    ACTIONS(7333), 1,
      sym__identifier_token,
    ACTIONS(7337), 1,
      anon_sym_LPAREN,
    ACTIONS(7819), 1,
      anon_sym_COMMA,
    ACTIONS(8014), 1,
      anon_sym_RPAREN,
    STATE(3127), 1,
      sym__reserved_identifier,
    STATE(4260), 1,
      sym__variable_designation,
    STATE(4274), 1,
      sym_parenthesized_variable_designation,
    STATE(6162), 1,
      sym_positional_pattern_clause,
    STATE(6695), 1,
      sym_property_pattern_clause,
    STATE(7809), 1,
      sym_identifier,
    STATE(9033), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    ACTIONS(4279), 2,
      anon_sym_and,
      anon_sym_or,
    STATE(5854), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7335), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [163758] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8016), 1,
      anon_sym_and,
    ACTIONS(8018), 1,
      anon_sym_or,
    STATE(5855), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6609), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6607), 25,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_when,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [163842] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(8020), 1,
      anon_sym_DOT_DOT,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5856), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1147), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(1133), 19,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [163940] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(8020), 1,
      anon_sym_DOT_DOT,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5857), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6116), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6114), 17,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [164042] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6959), 1,
      anon_sym_as,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(8020), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8024), 1,
      anon_sym_QMARK,
    ACTIONS(8030), 1,
      anon_sym_SLASH,
    ACTIONS(8032), 1,
      anon_sym_CARET,
    ACTIONS(8034), 1,
      anon_sym_PIPE,
    ACTIONS(8036), 1,
      anon_sym_AMP,
    ACTIONS(8040), 1,
      anon_sym_GT_GT,
    ACTIONS(8046), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8048), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8050), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8052), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8022), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8026), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8028), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8038), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8042), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8044), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6173), 3,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_or,
    STATE(5858), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [164176] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4277), 1,
      anon_sym_LBRACE,
    ACTIONS(4295), 1,
      sym_discard,
    ACTIONS(7333), 1,
      sym__identifier_token,
    ACTIONS(7337), 1,
      anon_sym_LPAREN,
    ACTIONS(7819), 1,
      anon_sym_COMMA,
    ACTIONS(8054), 1,
      anon_sym_RPAREN,
    STATE(3127), 1,
      sym__reserved_identifier,
    STATE(4260), 1,
      sym__variable_designation,
    STATE(4274), 1,
      sym_parenthesized_variable_designation,
    STATE(6162), 1,
      sym_positional_pattern_clause,
    STATE(6695), 1,
      sym_property_pattern_clause,
    STATE(7809), 1,
      sym_identifier,
    STATE(9033), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    ACTIONS(4279), 2,
      anon_sym_and,
      anon_sym_or,
    STATE(5859), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7335), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [164284] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(7950), 1,
      anon_sym_SLASH,
    ACTIONS(7954), 1,
      anon_sym_GT_GT,
    ACTIONS(7956), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7960), 1,
      anon_sym_AMP,
    ACTIONS(7966), 1,
      anon_sym_CARET,
    ACTIONS(7970), 1,
      anon_sym_PIPE,
    ACTIONS(7972), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7974), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7976), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7980), 1,
      anon_sym_QMARK,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7946), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7948), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7952), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7958), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7962), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7964), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5325), 3,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(5860), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [164418] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2607), 1,
      anon_sym_COMMA,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(8056), 1,
      anon_sym_RBRACK,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    STATE(8368), 1,
      aux_sym_array_rank_specifier_repeat1,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5861), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [164556] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(7986), 1,
      anon_sym_COMMA,
    ACTIONS(8058), 1,
      anon_sym_RPAREN,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    STATE(8439), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5862), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [164694] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8060), 1,
      anon_sym_and,
    STATE(5863), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6546), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6544), 26,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_when,
      anon_sym_DOT_DOT,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [164776] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4277), 1,
      anon_sym_LBRACE,
    ACTIONS(4295), 1,
      sym_discard,
    ACTIONS(7333), 1,
      sym__identifier_token,
    ACTIONS(7337), 1,
      anon_sym_LPAREN,
    ACTIONS(7819), 1,
      anon_sym_COMMA,
    ACTIONS(8062), 1,
      anon_sym_RPAREN,
    STATE(3127), 1,
      sym__reserved_identifier,
    STATE(4260), 1,
      sym__variable_designation,
    STATE(4274), 1,
      sym_parenthesized_variable_designation,
    STATE(6162), 1,
      sym_positional_pattern_clause,
    STATE(6695), 1,
      sym_property_pattern_clause,
    STATE(7809), 1,
      sym_identifier,
    STATE(9033), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    ACTIONS(4279), 2,
      anon_sym_and,
      anon_sym_or,
    STATE(5864), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7335), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [164884] = 25,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4277), 1,
      anon_sym_LBRACE,
    ACTIONS(4295), 1,
      sym_discard,
    ACTIONS(7333), 1,
      sym__identifier_token,
    ACTIONS(7337), 1,
      anon_sym_LPAREN,
    STATE(3127), 1,
      sym__reserved_identifier,
    STATE(4260), 1,
      sym__variable_designation,
    STATE(4274), 1,
      sym_parenthesized_variable_designation,
    STATE(6162), 1,
      sym_positional_pattern_clause,
    STATE(6695), 1,
      sym_property_pattern_clause,
    STATE(7934), 1,
      sym_identifier,
    STATE(9092), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    ACTIONS(4275), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(4279), 2,
      anon_sym_and,
      anon_sym_or,
    STATE(5865), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7335), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [164990] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4277), 1,
      anon_sym_LBRACE,
    ACTIONS(4295), 1,
      sym_discard,
    ACTIONS(7333), 1,
      sym__identifier_token,
    ACTIONS(7337), 1,
      anon_sym_LPAREN,
    ACTIONS(7819), 1,
      anon_sym_COMMA,
    ACTIONS(8064), 1,
      anon_sym_RPAREN,
    STATE(3127), 1,
      sym__reserved_identifier,
    STATE(4260), 1,
      sym__variable_designation,
    STATE(4274), 1,
      sym_parenthesized_variable_designation,
    STATE(6162), 1,
      sym_positional_pattern_clause,
    STATE(6695), 1,
      sym_property_pattern_clause,
    STATE(7809), 1,
      sym_identifier,
    STATE(9033), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    ACTIONS(4279), 2,
      anon_sym_and,
      anon_sym_or,
    STATE(5866), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7335), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [165098] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(7986), 1,
      anon_sym_COMMA,
    ACTIONS(8066), 1,
      anon_sym_RPAREN,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    STATE(8422), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5867), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [165236] = 28,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7785), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7836), 1,
      anon_sym_SLASH,
    ACTIONS(7846), 1,
      anon_sym_GT_GT,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7832), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7834), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7844), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6116), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5868), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 13,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
  [165348] = 25,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7785), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7836), 1,
      anon_sym_SLASH,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7834), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6116), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5869), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 15,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
  [165454] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7785), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7836), 1,
      anon_sym_SLASH,
    ACTIONS(7842), 1,
      anon_sym_AMP,
    ACTIONS(7846), 1,
      anon_sym_GT_GT,
    ACTIONS(7858), 1,
      anon_sym_as,
    ACTIONS(7860), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6116), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7828), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7832), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7834), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7844), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7848), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7850), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 7,
      anon_sym_CARET,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_on,
    STATE(5870), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [165578] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7785), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7836), 1,
      anon_sym_SLASH,
    ACTIONS(7838), 1,
      anon_sym_CARET,
    ACTIONS(7842), 1,
      anon_sym_AMP,
    ACTIONS(7846), 1,
      anon_sym_GT_GT,
    ACTIONS(7858), 1,
      anon_sym_as,
    ACTIONS(7860), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6116), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7828), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7832), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7834), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7844), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7848), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7850), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 6,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_on,
    STATE(5871), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [165704] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(8068), 1,
      anon_sym_DOT_DOT,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5872), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6116), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6114), 17,
      anon_sym_in,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [165806] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7785), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7836), 1,
      anon_sym_SLASH,
    ACTIONS(7846), 1,
      anon_sym_GT_GT,
    ACTIONS(7858), 1,
      anon_sym_as,
    ACTIONS(7860), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7828), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7832), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7834), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7844), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7848), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7850), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6116), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(6114), 7,
      anon_sym_CARET,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_on,
    STATE(5873), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [165928] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8016), 1,
      anon_sym_and,
    STATE(5874), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6546), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6544), 26,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_when,
      anon_sym_DOT_DOT,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [166010] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(7950), 1,
      anon_sym_SLASH,
    ACTIONS(7954), 1,
      anon_sym_GT_GT,
    ACTIONS(7956), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7960), 1,
      anon_sym_AMP,
    ACTIONS(7966), 1,
      anon_sym_CARET,
    ACTIONS(7970), 1,
      anon_sym_PIPE,
    ACTIONS(7972), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7974), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7976), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7980), 1,
      anon_sym_QMARK,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7946), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7948), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7952), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7958), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7962), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7964), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6216), 3,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(5875), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [166144] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7785), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7836), 1,
      anon_sym_SLASH,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7832), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7834), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6116), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5876), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 15,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
  [166252] = 32,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7785), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7836), 1,
      anon_sym_SLASH,
    ACTIONS(7846), 1,
      anon_sym_GT_GT,
    ACTIONS(7858), 1,
      anon_sym_as,
    ACTIONS(7860), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7828), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7832), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7834), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7844), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7850), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6116), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5877), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 9,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_on,
  [166372] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7785), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7836), 1,
      anon_sym_SLASH,
    ACTIONS(7838), 1,
      anon_sym_CARET,
    ACTIONS(7840), 1,
      anon_sym_PIPE,
    ACTIONS(7842), 1,
      anon_sym_AMP,
    ACTIONS(7846), 1,
      anon_sym_GT_GT,
    ACTIONS(7858), 1,
      anon_sym_as,
    ACTIONS(7860), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7828), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7832), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7834), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7844), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7848), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7850), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 6,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_on,
    STATE(5878), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [166500] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7785), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7836), 1,
      anon_sym_SLASH,
    ACTIONS(7838), 1,
      anon_sym_CARET,
    ACTIONS(7840), 1,
      anon_sym_PIPE,
    ACTIONS(7842), 1,
      anon_sym_AMP,
    ACTIONS(7846), 1,
      anon_sym_GT_GT,
    ACTIONS(7852), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7858), 1,
      anon_sym_as,
    ACTIONS(7860), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7828), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7832), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7834), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7844), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7848), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7850), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 5,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_on,
    STATE(5879), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [166630] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7785), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7836), 1,
      anon_sym_SLASH,
    ACTIONS(7838), 1,
      anon_sym_CARET,
    ACTIONS(7840), 1,
      anon_sym_PIPE,
    ACTIONS(7842), 1,
      anon_sym_AMP,
    ACTIONS(7846), 1,
      anon_sym_GT_GT,
    ACTIONS(7852), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7854), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7856), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7858), 1,
      anon_sym_as,
    ACTIONS(7860), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7828), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7832), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7834), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7844), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7848), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7850), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_on,
    STATE(5880), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [166764] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7178), 1,
      anon_sym_QMARK,
    ACTIONS(7184), 1,
      anon_sym_SLASH,
    ACTIONS(7186), 1,
      anon_sym_CARET,
    ACTIONS(7188), 1,
      anon_sym_PIPE,
    ACTIONS(7190), 1,
      anon_sym_AMP,
    ACTIONS(7194), 1,
      anon_sym_GT_GT,
    ACTIONS(7200), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7202), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7204), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7206), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7210), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7176), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7180), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7182), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7192), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7196), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7198), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5396), 3,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(5881), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [166898] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6959), 1,
      anon_sym_as,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(8020), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8024), 1,
      anon_sym_QMARK,
    ACTIONS(8030), 1,
      anon_sym_SLASH,
    ACTIONS(8032), 1,
      anon_sym_CARET,
    ACTIONS(8034), 1,
      anon_sym_PIPE,
    ACTIONS(8036), 1,
      anon_sym_AMP,
    ACTIONS(8040), 1,
      anon_sym_GT_GT,
    ACTIONS(8046), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8048), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8050), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8052), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8022), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8026), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8028), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8038), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8042), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8044), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6220), 3,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_or,
    STATE(5882), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [167032] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6959), 1,
      anon_sym_as,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(8020), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8024), 1,
      anon_sym_QMARK,
    ACTIONS(8030), 1,
      anon_sym_SLASH,
    ACTIONS(8032), 1,
      anon_sym_CARET,
    ACTIONS(8034), 1,
      anon_sym_PIPE,
    ACTIONS(8036), 1,
      anon_sym_AMP,
    ACTIONS(8040), 1,
      anon_sym_GT_GT,
    ACTIONS(8046), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8048), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8050), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8052), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8022), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8026), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8028), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8038), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8042), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8044), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5337), 3,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_or,
    STATE(5883), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [167166] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(7950), 1,
      anon_sym_SLASH,
    ACTIONS(7954), 1,
      anon_sym_GT_GT,
    ACTIONS(7956), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7960), 1,
      anon_sym_AMP,
    ACTIONS(7966), 1,
      anon_sym_CARET,
    ACTIONS(7970), 1,
      anon_sym_PIPE,
    ACTIONS(7972), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7974), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7976), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7980), 1,
      anon_sym_QMARK,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7946), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7948), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7952), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7958), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7962), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7964), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5396), 3,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(5884), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [167300] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6959), 1,
      anon_sym_as,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(8020), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8024), 1,
      anon_sym_QMARK,
    ACTIONS(8030), 1,
      anon_sym_SLASH,
    ACTIONS(8032), 1,
      anon_sym_CARET,
    ACTIONS(8034), 1,
      anon_sym_PIPE,
    ACTIONS(8036), 1,
      anon_sym_AMP,
    ACTIONS(8040), 1,
      anon_sym_GT_GT,
    ACTIONS(8046), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8048), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8050), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8052), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8022), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8026), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8028), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8038), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8042), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8044), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5385), 3,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_or,
    STATE(5885), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [167434] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6959), 1,
      anon_sym_as,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(8020), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8024), 1,
      anon_sym_QMARK,
    ACTIONS(8030), 1,
      anon_sym_SLASH,
    ACTIONS(8032), 1,
      anon_sym_CARET,
    ACTIONS(8034), 1,
      anon_sym_PIPE,
    ACTIONS(8036), 1,
      anon_sym_AMP,
    ACTIONS(8040), 1,
      anon_sym_GT_GT,
    ACTIONS(8046), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8048), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8050), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8052), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8022), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8026), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8028), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8038), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8042), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8044), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5396), 3,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_or,
    STATE(5886), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [167568] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(7950), 1,
      anon_sym_SLASH,
    ACTIONS(7954), 1,
      anon_sym_GT_GT,
    ACTIONS(7956), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7960), 1,
      anon_sym_AMP,
    ACTIONS(7966), 1,
      anon_sym_CARET,
    ACTIONS(7970), 1,
      anon_sym_PIPE,
    ACTIONS(7972), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7974), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7976), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7980), 1,
      anon_sym_QMARK,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7946), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7948), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7952), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7958), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7962), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7964), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5385), 3,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(5887), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [167702] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6959), 1,
      anon_sym_as,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(8020), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8024), 1,
      anon_sym_QMARK,
    ACTIONS(8030), 1,
      anon_sym_SLASH,
    ACTIONS(8032), 1,
      anon_sym_CARET,
    ACTIONS(8034), 1,
      anon_sym_PIPE,
    ACTIONS(8036), 1,
      anon_sym_AMP,
    ACTIONS(8040), 1,
      anon_sym_GT_GT,
    ACTIONS(8046), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8048), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8050), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8052), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8022), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8026), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8028), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8038), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8042), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8044), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6216), 3,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_or,
    STATE(5888), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [167836] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(8068), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8072), 1,
      anon_sym_QMARK,
    ACTIONS(8078), 1,
      anon_sym_SLASH,
    ACTIONS(8080), 1,
      anon_sym_CARET,
    ACTIONS(8082), 1,
      anon_sym_PIPE,
    ACTIONS(8084), 1,
      anon_sym_AMP,
    ACTIONS(8088), 1,
      anon_sym_GT_GT,
    ACTIONS(8094), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8096), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8098), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8100), 1,
      anon_sym_as,
    ACTIONS(8102), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8070), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8074), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8076), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8086), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8090), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8092), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6173), 3,
      anon_sym_in,
      anon_sym_and,
      anon_sym_or,
    STATE(5889), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [167970] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6959), 1,
      anon_sym_as,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(8020), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8024), 1,
      anon_sym_QMARK,
    ACTIONS(8030), 1,
      anon_sym_SLASH,
    ACTIONS(8032), 1,
      anon_sym_CARET,
    ACTIONS(8034), 1,
      anon_sym_PIPE,
    ACTIONS(8036), 1,
      anon_sym_AMP,
    ACTIONS(8040), 1,
      anon_sym_GT_GT,
    ACTIONS(8046), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8048), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8050), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8052), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8022), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8026), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8028), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8038), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8042), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8044), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5325), 3,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_or,
    STATE(5890), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [168104] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(7986), 1,
      anon_sym_COMMA,
    ACTIONS(8104), 1,
      anon_sym_RPAREN,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    STATE(8426), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5891), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [168242] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(7986), 1,
      anon_sym_COMMA,
    ACTIONS(8106), 1,
      anon_sym_RPAREN,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    STATE(8427), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5892), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [168380] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7785), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7830), 1,
      anon_sym_QMARK,
    ACTIONS(7836), 1,
      anon_sym_SLASH,
    ACTIONS(7838), 1,
      anon_sym_CARET,
    ACTIONS(7840), 1,
      anon_sym_PIPE,
    ACTIONS(7842), 1,
      anon_sym_AMP,
    ACTIONS(7846), 1,
      anon_sym_GT_GT,
    ACTIONS(7852), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7854), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7856), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7858), 1,
      anon_sym_as,
    ACTIONS(7860), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7828), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7832), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7834), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7844), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7848), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7850), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6236), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_on,
    STATE(5893), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [168514] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7178), 1,
      anon_sym_QMARK,
    ACTIONS(7184), 1,
      anon_sym_SLASH,
    ACTIONS(7186), 1,
      anon_sym_CARET,
    ACTIONS(7188), 1,
      anon_sym_PIPE,
    ACTIONS(7190), 1,
      anon_sym_AMP,
    ACTIONS(7194), 1,
      anon_sym_GT_GT,
    ACTIONS(7200), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7202), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7204), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7206), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7210), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7176), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7180), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7182), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7192), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7196), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7198), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5385), 3,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(5894), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [168648] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(7785), 1,
      anon_sym_DOT_DOT,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5895), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6122), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6120), 19,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [168746] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6959), 1,
      anon_sym_as,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(8020), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8024), 1,
      anon_sym_QMARK,
    ACTIONS(8030), 1,
      anon_sym_SLASH,
    ACTIONS(8032), 1,
      anon_sym_CARET,
    ACTIONS(8034), 1,
      anon_sym_PIPE,
    ACTIONS(8036), 1,
      anon_sym_AMP,
    ACTIONS(8040), 1,
      anon_sym_GT_GT,
    ACTIONS(8046), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8048), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8050), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8052), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8022), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8026), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8028), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8038), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8042), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8044), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5510), 3,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_or,
    STATE(5896), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [168880] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7785), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7830), 1,
      anon_sym_QMARK,
    ACTIONS(7836), 1,
      anon_sym_SLASH,
    ACTIONS(7838), 1,
      anon_sym_CARET,
    ACTIONS(7840), 1,
      anon_sym_PIPE,
    ACTIONS(7842), 1,
      anon_sym_AMP,
    ACTIONS(7846), 1,
      anon_sym_GT_GT,
    ACTIONS(7852), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7854), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7856), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7858), 1,
      anon_sym_as,
    ACTIONS(7860), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7828), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7832), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7834), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7844), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7848), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7850), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6230), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_on,
    STATE(5897), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [169014] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7785), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7830), 1,
      anon_sym_QMARK,
    ACTIONS(7836), 1,
      anon_sym_SLASH,
    ACTIONS(7838), 1,
      anon_sym_CARET,
    ACTIONS(7840), 1,
      anon_sym_PIPE,
    ACTIONS(7842), 1,
      anon_sym_AMP,
    ACTIONS(7846), 1,
      anon_sym_GT_GT,
    ACTIONS(7852), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7854), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7856), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7858), 1,
      anon_sym_as,
    ACTIONS(7860), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7828), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7832), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7834), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7844), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7848), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7850), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5420), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_on,
    STATE(5898), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [169148] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6959), 1,
      anon_sym_as,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(8020), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8024), 1,
      anon_sym_QMARK,
    ACTIONS(8030), 1,
      anon_sym_SLASH,
    ACTIONS(8032), 1,
      anon_sym_CARET,
    ACTIONS(8034), 1,
      anon_sym_PIPE,
    ACTIONS(8036), 1,
      anon_sym_AMP,
    ACTIONS(8040), 1,
      anon_sym_GT_GT,
    ACTIONS(8046), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8048), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8050), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8052), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8022), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8026), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8028), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8038), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8042), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8044), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5420), 3,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_or,
    STATE(5899), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [169282] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(7950), 1,
      anon_sym_SLASH,
    ACTIONS(7954), 1,
      anon_sym_GT_GT,
    ACTIONS(7956), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7960), 1,
      anon_sym_AMP,
    ACTIONS(7966), 1,
      anon_sym_CARET,
    ACTIONS(7970), 1,
      anon_sym_PIPE,
    ACTIONS(7972), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7974), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7976), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7980), 1,
      anon_sym_QMARK,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7946), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7948), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7952), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7958), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7962), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7964), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5337), 3,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(5900), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [169416] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6959), 1,
      anon_sym_as,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(8020), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8024), 1,
      anon_sym_QMARK,
    ACTIONS(8030), 1,
      anon_sym_SLASH,
    ACTIONS(8032), 1,
      anon_sym_CARET,
    ACTIONS(8034), 1,
      anon_sym_PIPE,
    ACTIONS(8036), 1,
      anon_sym_AMP,
    ACTIONS(8040), 1,
      anon_sym_GT_GT,
    ACTIONS(8046), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8048), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8050), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8052), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8022), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8026), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8028), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8038), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8042), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8044), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6230), 3,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_or,
    STATE(5901), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [169550] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(8020), 1,
      anon_sym_DOT_DOT,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5902), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6122), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6120), 19,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [169648] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(7986), 1,
      anon_sym_COMMA,
    ACTIONS(8108), 1,
      anon_sym_RPAREN,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    STATE(8473), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5903), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [169786] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(7986), 1,
      anon_sym_COMMA,
    ACTIONS(8110), 1,
      anon_sym_RPAREN,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    STATE(8444), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5904), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [169924] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6959), 1,
      anon_sym_as,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(8020), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8024), 1,
      anon_sym_QMARK,
    ACTIONS(8030), 1,
      anon_sym_SLASH,
    ACTIONS(8032), 1,
      anon_sym_CARET,
    ACTIONS(8034), 1,
      anon_sym_PIPE,
    ACTIONS(8036), 1,
      anon_sym_AMP,
    ACTIONS(8040), 1,
      anon_sym_GT_GT,
    ACTIONS(8046), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8048), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8050), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8052), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8022), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8026), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8028), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8038), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8042), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8044), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6236), 3,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_or,
    STATE(5905), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [170058] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7178), 1,
      anon_sym_QMARK,
    ACTIONS(7184), 1,
      anon_sym_SLASH,
    ACTIONS(7186), 1,
      anon_sym_CARET,
    ACTIONS(7188), 1,
      anon_sym_PIPE,
    ACTIONS(7190), 1,
      anon_sym_AMP,
    ACTIONS(7194), 1,
      anon_sym_GT_GT,
    ACTIONS(7200), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7202), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7204), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7206), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7210), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7176), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7180), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7182), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7192), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7196), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7198), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5510), 3,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(5906), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [170192] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8112), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
    STATE(5907), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [170326] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(8068), 1,
      anon_sym_DOT_DOT,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5908), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1147), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(1133), 19,
      anon_sym_in,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [170424] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(7986), 1,
      anon_sym_COMMA,
    ACTIONS(8114), 1,
      anon_sym_RPAREN,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    STATE(8446), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5909), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [170562] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8116), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
    STATE(5910), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [170696] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7785), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7830), 1,
      anon_sym_QMARK,
    ACTIONS(7836), 1,
      anon_sym_SLASH,
    ACTIONS(7838), 1,
      anon_sym_CARET,
    ACTIONS(7840), 1,
      anon_sym_PIPE,
    ACTIONS(7842), 1,
      anon_sym_AMP,
    ACTIONS(7846), 1,
      anon_sym_GT_GT,
    ACTIONS(7852), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7854), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7856), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7858), 1,
      anon_sym_as,
    ACTIONS(7860), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7828), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7832), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7834), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7844), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7848), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7850), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5510), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_on,
    STATE(5911), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [170830] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8118), 1,
      anon_sym_and,
    STATE(5912), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6546), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6544), 26,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [170912] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4277), 1,
      anon_sym_LBRACE,
    ACTIONS(4295), 1,
      sym_discard,
    ACTIONS(7333), 1,
      sym__identifier_token,
    ACTIONS(7337), 1,
      anon_sym_LPAREN,
    ACTIONS(7819), 1,
      anon_sym_COMMA,
    ACTIONS(8120), 1,
      anon_sym_RPAREN,
    STATE(3127), 1,
      sym__reserved_identifier,
    STATE(4260), 1,
      sym__variable_designation,
    STATE(4274), 1,
      sym_parenthesized_variable_designation,
    STATE(6162), 1,
      sym_positional_pattern_clause,
    STATE(6695), 1,
      sym_property_pattern_clause,
    STATE(7809), 1,
      sym_identifier,
    STATE(9033), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    ACTIONS(4279), 2,
      anon_sym_and,
      anon_sym_or,
    STATE(5913), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7335), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [171020] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8004), 1,
      anon_sym_into,
    STATE(5944), 1,
      aux_sym__query_body_repeat2,
    STATE(5914), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6420), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6418), 25,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [171104] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8004), 1,
      anon_sym_into,
    STATE(5949), 1,
      aux_sym__query_body_repeat2,
    STATE(5915), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6420), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6418), 25,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [171188] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(7986), 1,
      anon_sym_COMMA,
    ACTIONS(8122), 1,
      anon_sym_RPAREN,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    STATE(8542), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5916), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [171326] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7878), 1,
      anon_sym_QMARK,
    ACTIONS(7884), 1,
      anon_sym_SLASH,
    ACTIONS(7886), 1,
      anon_sym_CARET,
    ACTIONS(7888), 1,
      anon_sym_PIPE,
    ACTIONS(7890), 1,
      anon_sym_AMP,
    ACTIONS(7894), 1,
      anon_sym_GT_GT,
    ACTIONS(7900), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7902), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7904), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7906), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7908), 1,
      anon_sym_as,
    ACTIONS(7910), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7876), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7880), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7882), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7892), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7896), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7898), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6173), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_by,
    STATE(5917), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [171460] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7785), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7830), 1,
      anon_sym_QMARK,
    ACTIONS(7836), 1,
      anon_sym_SLASH,
    ACTIONS(7838), 1,
      anon_sym_CARET,
    ACTIONS(7840), 1,
      anon_sym_PIPE,
    ACTIONS(7842), 1,
      anon_sym_AMP,
    ACTIONS(7846), 1,
      anon_sym_GT_GT,
    ACTIONS(7852), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7854), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7856), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7858), 1,
      anon_sym_as,
    ACTIONS(7860), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7828), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7832), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7834), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7844), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7848), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7850), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5325), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_on,
    STATE(5918), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [171594] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7785), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7830), 1,
      anon_sym_QMARK,
    ACTIONS(7836), 1,
      anon_sym_SLASH,
    ACTIONS(7838), 1,
      anon_sym_CARET,
    ACTIONS(7840), 1,
      anon_sym_PIPE,
    ACTIONS(7842), 1,
      anon_sym_AMP,
    ACTIONS(7846), 1,
      anon_sym_GT_GT,
    ACTIONS(7852), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7854), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7856), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7858), 1,
      anon_sym_as,
    ACTIONS(7860), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7828), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7832), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7834), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7844), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7848), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7850), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6216), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_on,
    STATE(5919), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [171728] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7785), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7830), 1,
      anon_sym_QMARK,
    ACTIONS(7836), 1,
      anon_sym_SLASH,
    ACTIONS(7838), 1,
      anon_sym_CARET,
    ACTIONS(7840), 1,
      anon_sym_PIPE,
    ACTIONS(7842), 1,
      anon_sym_AMP,
    ACTIONS(7846), 1,
      anon_sym_GT_GT,
    ACTIONS(7852), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7854), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7856), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7858), 1,
      anon_sym_as,
    ACTIONS(7860), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7828), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7832), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7834), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7844), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7848), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7850), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5396), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_on,
    STATE(5920), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [171862] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7785), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7830), 1,
      anon_sym_QMARK,
    ACTIONS(7836), 1,
      anon_sym_SLASH,
    ACTIONS(7838), 1,
      anon_sym_CARET,
    ACTIONS(7840), 1,
      anon_sym_PIPE,
    ACTIONS(7842), 1,
      anon_sym_AMP,
    ACTIONS(7846), 1,
      anon_sym_GT_GT,
    ACTIONS(7852), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7854), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7856), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7858), 1,
      anon_sym_as,
    ACTIONS(7860), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7828), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7832), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7834), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7844), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7848), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7850), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5385), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_on,
    STATE(5921), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [171996] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7785), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7830), 1,
      anon_sym_QMARK,
    ACTIONS(7836), 1,
      anon_sym_SLASH,
    ACTIONS(7838), 1,
      anon_sym_CARET,
    ACTIONS(7840), 1,
      anon_sym_PIPE,
    ACTIONS(7842), 1,
      anon_sym_AMP,
    ACTIONS(7846), 1,
      anon_sym_GT_GT,
    ACTIONS(7852), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7854), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7856), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7858), 1,
      anon_sym_as,
    ACTIONS(7860), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7828), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7832), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7834), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7844), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7848), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7850), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5337), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_on,
    STATE(5922), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [172130] = 25,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4277), 1,
      anon_sym_LBRACE,
    ACTIONS(4295), 1,
      sym_discard,
    ACTIONS(7333), 1,
      sym__identifier_token,
    ACTIONS(7337), 1,
      anon_sym_LPAREN,
    STATE(3127), 1,
      sym__reserved_identifier,
    STATE(4259), 1,
      sym_identifier,
    STATE(4260), 1,
      sym__variable_designation,
    STATE(4274), 1,
      sym_parenthesized_variable_designation,
    STATE(6162), 1,
      sym_positional_pattern_clause,
    STATE(6695), 1,
      sym_property_pattern_clause,
    STATE(9033), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    ACTIONS(4275), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4279), 2,
      anon_sym_and,
      anon_sym_or,
    STATE(5923), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7335), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [172236] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7178), 1,
      anon_sym_QMARK,
    ACTIONS(7184), 1,
      anon_sym_SLASH,
    ACTIONS(7186), 1,
      anon_sym_CARET,
    ACTIONS(7188), 1,
      anon_sym_PIPE,
    ACTIONS(7190), 1,
      anon_sym_AMP,
    ACTIONS(7194), 1,
      anon_sym_GT_GT,
    ACTIONS(7200), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7202), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7204), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7206), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7210), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7176), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7180), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7182), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7192), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7196), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7198), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8124), 3,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(5924), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [172370] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6959), 1,
      anon_sym_as,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(8020), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8030), 1,
      anon_sym_SLASH,
    ACTIONS(8032), 1,
      anon_sym_CARET,
    ACTIONS(8034), 1,
      anon_sym_PIPE,
    ACTIONS(8036), 1,
      anon_sym_AMP,
    ACTIONS(8040), 1,
      anon_sym_GT_GT,
    ACTIONS(8046), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8048), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8050), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8052), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8022), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8026), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8028), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8038), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8042), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8044), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 3,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_or,
    STATE(5925), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [172504] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6959), 1,
      anon_sym_as,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(8020), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8030), 1,
      anon_sym_SLASH,
    ACTIONS(8032), 1,
      anon_sym_CARET,
    ACTIONS(8034), 1,
      anon_sym_PIPE,
    ACTIONS(8036), 1,
      anon_sym_AMP,
    ACTIONS(8040), 1,
      anon_sym_GT_GT,
    ACTIONS(8046), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8052), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8022), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8026), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8028), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8038), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8042), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8044), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(5926), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [172634] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6959), 1,
      anon_sym_as,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(8020), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8030), 1,
      anon_sym_SLASH,
    ACTIONS(8032), 1,
      anon_sym_CARET,
    ACTIONS(8034), 1,
      anon_sym_PIPE,
    ACTIONS(8036), 1,
      anon_sym_AMP,
    ACTIONS(8040), 1,
      anon_sym_GT_GT,
    ACTIONS(8052), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8022), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8026), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8028), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8038), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8042), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8044), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 6,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(5927), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [172762] = 32,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6959), 1,
      anon_sym_as,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(8020), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8030), 1,
      anon_sym_SLASH,
    ACTIONS(8040), 1,
      anon_sym_GT_GT,
    ACTIONS(8052), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8022), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8026), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8028), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8038), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8044), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6116), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5928), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 9,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [172882] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(8020), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8030), 1,
      anon_sym_SLASH,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8026), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8028), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6116), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5929), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 15,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [172990] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6959), 1,
      anon_sym_as,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(8020), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8030), 1,
      anon_sym_SLASH,
    ACTIONS(8040), 1,
      anon_sym_GT_GT,
    ACTIONS(8052), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8022), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8026), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8028), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8038), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8042), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8044), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6116), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(6114), 7,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(5930), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [173112] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(7986), 1,
      anon_sym_COMMA,
    ACTIONS(8126), 1,
      anon_sym_RPAREN,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    STATE(8379), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5931), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [173250] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(7986), 1,
      anon_sym_COMMA,
    ACTIONS(8128), 1,
      anon_sym_RPAREN,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    STATE(8381), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5932), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [173388] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5933), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5832), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4247), 27,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_when,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [173468] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4277), 1,
      anon_sym_LBRACE,
    ACTIONS(4295), 1,
      sym_discard,
    ACTIONS(7333), 1,
      sym__identifier_token,
    ACTIONS(7337), 1,
      anon_sym_LPAREN,
    ACTIONS(7819), 1,
      anon_sym_COMMA,
    ACTIONS(8130), 1,
      anon_sym_RPAREN,
    STATE(3127), 1,
      sym__reserved_identifier,
    STATE(4260), 1,
      sym__variable_designation,
    STATE(4274), 1,
      sym_parenthesized_variable_designation,
    STATE(6162), 1,
      sym_positional_pattern_clause,
    STATE(6695), 1,
      sym_property_pattern_clause,
    STATE(7809), 1,
      sym_identifier,
    STATE(9033), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    ACTIONS(4279), 2,
      anon_sym_and,
      anon_sym_or,
    STATE(5934), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7335), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [173576] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4277), 1,
      anon_sym_LBRACE,
    ACTIONS(4295), 1,
      sym_discard,
    ACTIONS(7333), 1,
      sym__identifier_token,
    ACTIONS(7337), 1,
      anon_sym_LPAREN,
    ACTIONS(7819), 1,
      anon_sym_COMMA,
    ACTIONS(8132), 1,
      anon_sym_RPAREN,
    STATE(3127), 1,
      sym__reserved_identifier,
    STATE(4260), 1,
      sym__variable_designation,
    STATE(4274), 1,
      sym_parenthesized_variable_designation,
    STATE(6162), 1,
      sym_positional_pattern_clause,
    STATE(6695), 1,
      sym_property_pattern_clause,
    STATE(7809), 1,
      sym_identifier,
    STATE(9033), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    ACTIONS(4279), 2,
      anon_sym_and,
      anon_sym_or,
    STATE(5935), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7335), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [173684] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7178), 1,
      anon_sym_QMARK,
    ACTIONS(7184), 1,
      anon_sym_SLASH,
    ACTIONS(7186), 1,
      anon_sym_CARET,
    ACTIONS(7188), 1,
      anon_sym_PIPE,
    ACTIONS(7190), 1,
      anon_sym_AMP,
    ACTIONS(7194), 1,
      anon_sym_GT_GT,
    ACTIONS(7200), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7202), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7204), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7206), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7210), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7176), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7180), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7182), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7192), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7196), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7198), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8134), 3,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(5936), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [173818] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(7986), 1,
      anon_sym_COMMA,
    ACTIONS(8136), 1,
      anon_sym_RPAREN,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    STATE(8430), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5937), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [173956] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(7986), 1,
      anon_sym_COMMA,
    ACTIONS(8138), 1,
      anon_sym_RPAREN,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    STATE(8431), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5938), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [174094] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(7956), 1,
      anon_sym_DOT_DOT,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5939), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1147), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(1133), 19,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [174192] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(7950), 1,
      anon_sym_SLASH,
    ACTIONS(7954), 1,
      anon_sym_GT_GT,
    ACTIONS(7956), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7960), 1,
      anon_sym_AMP,
    ACTIONS(7966), 1,
      anon_sym_CARET,
    ACTIONS(7970), 1,
      anon_sym_PIPE,
    ACTIONS(7972), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7974), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7976), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7980), 1,
      anon_sym_QMARK,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7946), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7948), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7952), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7958), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7962), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7964), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6220), 3,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(5940), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [174326] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6959), 1,
      anon_sym_as,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(8020), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8030), 1,
      anon_sym_SLASH,
    ACTIONS(8032), 1,
      anon_sym_CARET,
    ACTIONS(8036), 1,
      anon_sym_AMP,
    ACTIONS(8040), 1,
      anon_sym_GT_GT,
    ACTIONS(8052), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6116), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(8022), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8026), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8028), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8038), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8042), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8044), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 6,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(5941), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [174452] = 28,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7874), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7920), 1,
      anon_sym_SLASH,
    ACTIONS(7930), 1,
      anon_sym_GT_GT,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7916), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7918), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7928), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6116), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5942), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 13,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [174564] = 25,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7874), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7920), 1,
      anon_sym_SLASH,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7918), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6116), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5943), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 15,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [174670] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8140), 1,
      anon_sym_into,
    STATE(5944), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym__query_body_repeat2,
    ACTIONS(6376), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6374), 25,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [174752] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(7950), 1,
      anon_sym_SLASH,
    ACTIONS(7954), 1,
      anon_sym_GT_GT,
    ACTIONS(7956), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7960), 1,
      anon_sym_AMP,
    ACTIONS(7966), 1,
      anon_sym_CARET,
    ACTIONS(7970), 1,
      anon_sym_PIPE,
    ACTIONS(7972), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7974), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7976), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7980), 1,
      anon_sym_QMARK,
    ACTIONS(7994), 1,
      anon_sym_COMMA,
    ACTIONS(8143), 1,
      anon_sym_SEMI,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    STATE(8453), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7946), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7948), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7952), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7958), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7962), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7964), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5945), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [174890] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6959), 1,
      anon_sym_as,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7874), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7920), 1,
      anon_sym_SLASH,
    ACTIONS(7926), 1,
      anon_sym_AMP,
    ACTIONS(7930), 1,
      anon_sym_GT_GT,
    ACTIONS(7942), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6116), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7912), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7916), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7918), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7928), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7932), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7934), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 7,
      anon_sym_CARET,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(5946), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [175014] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6959), 1,
      anon_sym_as,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7874), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7920), 1,
      anon_sym_SLASH,
    ACTIONS(7922), 1,
      anon_sym_CARET,
    ACTIONS(7926), 1,
      anon_sym_AMP,
    ACTIONS(7930), 1,
      anon_sym_GT_GT,
    ACTIONS(7942), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6116), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7912), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7916), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7918), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7928), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7932), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7934), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 6,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(5947), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [175140] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(7986), 1,
      anon_sym_COMMA,
    ACTIONS(8145), 1,
      anon_sym_RPAREN,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    STATE(8445), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5948), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [175278] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8004), 1,
      anon_sym_into,
    STATE(5944), 1,
      aux_sym__query_body_repeat2,
    STATE(5949), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6383), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6381), 25,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [175362] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4953), 1,
      anon_sym_DASH_GT,
    ACTIONS(5067), 1,
      anon_sym_DOT,
    ACTIONS(6973), 1,
      anon_sym_LPAREN,
    ACTIONS(7022), 1,
      anon_sym_LBRACK,
    ACTIONS(7026), 1,
      anon_sym_BANG,
    ACTIONS(7042), 1,
      anon_sym_switch,
    ACTIONS(7050), 1,
      anon_sym_with,
    ACTIONS(7234), 1,
      anon_sym_as,
    ACTIONS(7355), 1,
      anon_sym_SLASH,
    ACTIONS(7357), 1,
      anon_sym_CARET,
    ACTIONS(7361), 1,
      anon_sym_AMP,
    ACTIONS(7365), 1,
      anon_sym_GT_GT,
    ACTIONS(7371), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7379), 1,
      anon_sym_is,
    STATE(3870), 1,
      sym_bracketed_argument_list,
    STATE(5721), 1,
      sym_argument_list,
    ACTIONS(6116), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7028), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7347), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7351), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7353), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7363), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7367), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7369), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 6,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(5950), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [175488] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6959), 1,
      anon_sym_as,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(8020), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8030), 1,
      anon_sym_SLASH,
    ACTIONS(8036), 1,
      anon_sym_AMP,
    ACTIONS(8040), 1,
      anon_sym_GT_GT,
    ACTIONS(8052), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6116), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(8022), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8026), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8028), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8038), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8042), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8044), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 7,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(5951), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [175612] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6959), 1,
      anon_sym_as,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7874), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7920), 1,
      anon_sym_SLASH,
    ACTIONS(7930), 1,
      anon_sym_GT_GT,
    ACTIONS(7942), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7912), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7916), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7918), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7928), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7932), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7934), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6116), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(6114), 7,
      anon_sym_CARET,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(5952), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [175734] = 25,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(8020), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8030), 1,
      anon_sym_SLASH,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8028), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6116), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5953), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 15,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [175840] = 28,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(8020), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8030), 1,
      anon_sym_SLASH,
    ACTIONS(8040), 1,
      anon_sym_GT_GT,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8026), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8028), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8038), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6116), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5954), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 13,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [175952] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4953), 1,
      anon_sym_DASH_GT,
    ACTIONS(5067), 1,
      anon_sym_DOT,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6973), 1,
      anon_sym_LPAREN,
    ACTIONS(7022), 1,
      anon_sym_LBRACK,
    ACTIONS(7026), 1,
      anon_sym_BANG,
    ACTIONS(7042), 1,
      anon_sym_switch,
    ACTIONS(7050), 1,
      anon_sym_with,
    ACTIONS(7234), 1,
      anon_sym_as,
    ACTIONS(7355), 1,
      anon_sym_SLASH,
    ACTIONS(7357), 1,
      anon_sym_CARET,
    ACTIONS(7359), 1,
      anon_sym_PIPE,
    ACTIONS(7361), 1,
      anon_sym_AMP,
    ACTIONS(7365), 1,
      anon_sym_GT_GT,
    ACTIONS(7371), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7373), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7375), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7377), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7379), 1,
      anon_sym_is,
    STATE(3870), 1,
      sym_bracketed_argument_list,
    STATE(5721), 1,
      sym_argument_list,
    ACTIONS(7028), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7347), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7351), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7353), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7363), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7367), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7369), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 3,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(5955), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [176086] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4953), 1,
      anon_sym_DASH_GT,
    ACTIONS(5067), 1,
      anon_sym_DOT,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6973), 1,
      anon_sym_LPAREN,
    ACTIONS(7022), 1,
      anon_sym_LBRACK,
    ACTIONS(7026), 1,
      anon_sym_BANG,
    ACTIONS(7042), 1,
      anon_sym_switch,
    ACTIONS(7050), 1,
      anon_sym_with,
    ACTIONS(7234), 1,
      anon_sym_as,
    ACTIONS(7355), 1,
      anon_sym_SLASH,
    ACTIONS(7357), 1,
      anon_sym_CARET,
    ACTIONS(7359), 1,
      anon_sym_PIPE,
    ACTIONS(7361), 1,
      anon_sym_AMP,
    ACTIONS(7365), 1,
      anon_sym_GT_GT,
    ACTIONS(7371), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7373), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7379), 1,
      anon_sym_is,
    STATE(3870), 1,
      sym_bracketed_argument_list,
    STATE(5721), 1,
      sym_argument_list,
    ACTIONS(7028), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7347), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7351), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7353), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7363), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7367), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7369), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 5,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(5956), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [176216] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4953), 1,
      anon_sym_DASH_GT,
    ACTIONS(5067), 1,
      anon_sym_DOT,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6973), 1,
      anon_sym_LPAREN,
    ACTIONS(7022), 1,
      anon_sym_LBRACK,
    ACTIONS(7026), 1,
      anon_sym_BANG,
    ACTIONS(7042), 1,
      anon_sym_switch,
    ACTIONS(7050), 1,
      anon_sym_with,
    ACTIONS(7234), 1,
      anon_sym_as,
    ACTIONS(7355), 1,
      anon_sym_SLASH,
    ACTIONS(7357), 1,
      anon_sym_CARET,
    ACTIONS(7359), 1,
      anon_sym_PIPE,
    ACTIONS(7361), 1,
      anon_sym_AMP,
    ACTIONS(7365), 1,
      anon_sym_GT_GT,
    ACTIONS(7371), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7379), 1,
      anon_sym_is,
    STATE(3870), 1,
      sym_bracketed_argument_list,
    STATE(5721), 1,
      sym_argument_list,
    ACTIONS(7028), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7347), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7351), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7353), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7363), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7367), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7369), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 6,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(5957), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [176344] = 32,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4953), 1,
      anon_sym_DASH_GT,
    ACTIONS(5067), 1,
      anon_sym_DOT,
    ACTIONS(6973), 1,
      anon_sym_LPAREN,
    ACTIONS(7022), 1,
      anon_sym_LBRACK,
    ACTIONS(7026), 1,
      anon_sym_BANG,
    ACTIONS(7042), 1,
      anon_sym_switch,
    ACTIONS(7050), 1,
      anon_sym_with,
    ACTIONS(7234), 1,
      anon_sym_as,
    ACTIONS(7355), 1,
      anon_sym_SLASH,
    ACTIONS(7365), 1,
      anon_sym_GT_GT,
    ACTIONS(7371), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7379), 1,
      anon_sym_is,
    STATE(3870), 1,
      sym_bracketed_argument_list,
    STATE(5721), 1,
      sym_argument_list,
    ACTIONS(7028), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7347), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7351), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7353), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7363), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7369), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6116), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5958), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 9,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [176464] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4953), 1,
      anon_sym_DASH_GT,
    ACTIONS(5067), 1,
      anon_sym_DOT,
    ACTIONS(6973), 1,
      anon_sym_LPAREN,
    ACTIONS(7022), 1,
      anon_sym_LBRACK,
    ACTIONS(7026), 1,
      anon_sym_BANG,
    ACTIONS(7042), 1,
      anon_sym_switch,
    ACTIONS(7050), 1,
      anon_sym_with,
    ACTIONS(7355), 1,
      anon_sym_SLASH,
    ACTIONS(7371), 1,
      anon_sym_DOT_DOT,
    STATE(3870), 1,
      sym_bracketed_argument_list,
    STATE(5721), 1,
      sym_argument_list,
    ACTIONS(7028), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7351), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7353), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6116), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5959), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 15,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [176572] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4953), 1,
      anon_sym_DASH_GT,
    ACTIONS(5067), 1,
      anon_sym_DOT,
    ACTIONS(6973), 1,
      anon_sym_LPAREN,
    ACTIONS(7022), 1,
      anon_sym_LBRACK,
    ACTIONS(7026), 1,
      anon_sym_BANG,
    ACTIONS(7042), 1,
      anon_sym_switch,
    ACTIONS(7050), 1,
      anon_sym_with,
    ACTIONS(7234), 1,
      anon_sym_as,
    ACTIONS(7355), 1,
      anon_sym_SLASH,
    ACTIONS(7365), 1,
      anon_sym_GT_GT,
    ACTIONS(7371), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7379), 1,
      anon_sym_is,
    STATE(3870), 1,
      sym_bracketed_argument_list,
    STATE(5721), 1,
      sym_argument_list,
    ACTIONS(7028), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7347), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7351), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7353), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7363), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7367), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7369), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6116), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(6114), 7,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(5960), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [176694] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4277), 1,
      anon_sym_LBRACE,
    ACTIONS(4295), 1,
      sym_discard,
    ACTIONS(7333), 1,
      sym__identifier_token,
    ACTIONS(7337), 1,
      anon_sym_LPAREN,
    ACTIONS(7819), 1,
      anon_sym_COMMA,
    ACTIONS(8147), 1,
      anon_sym_RPAREN,
    STATE(3127), 1,
      sym__reserved_identifier,
    STATE(4260), 1,
      sym__variable_designation,
    STATE(4274), 1,
      sym_parenthesized_variable_designation,
    STATE(6162), 1,
      sym_positional_pattern_clause,
    STATE(6695), 1,
      sym_property_pattern_clause,
    STATE(7809), 1,
      sym_identifier,
    STATE(9033), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    ACTIONS(4279), 2,
      anon_sym_and,
      anon_sym_or,
    STATE(5961), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7335), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [176802] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4953), 1,
      anon_sym_DASH_GT,
    ACTIONS(5067), 1,
      anon_sym_DOT,
    ACTIONS(6973), 1,
      anon_sym_LPAREN,
    ACTIONS(7022), 1,
      anon_sym_LBRACK,
    ACTIONS(7026), 1,
      anon_sym_BANG,
    ACTIONS(7042), 1,
      anon_sym_switch,
    ACTIONS(7050), 1,
      anon_sym_with,
    ACTIONS(7234), 1,
      anon_sym_as,
    ACTIONS(7349), 1,
      anon_sym_QMARK,
    ACTIONS(7355), 1,
      anon_sym_SLASH,
    ACTIONS(7357), 1,
      anon_sym_CARET,
    ACTIONS(7359), 1,
      anon_sym_PIPE,
    ACTIONS(7361), 1,
      anon_sym_AMP,
    ACTIONS(7365), 1,
      anon_sym_GT_GT,
    ACTIONS(7371), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7373), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7375), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7377), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7379), 1,
      anon_sym_is,
    STATE(3870), 1,
      sym_bracketed_argument_list,
    STATE(5721), 1,
      sym_argument_list,
    ACTIONS(7028), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7347), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7351), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7353), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7363), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7367), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7369), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5396), 3,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(5962), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [176936] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4953), 1,
      anon_sym_DASH_GT,
    ACTIONS(5067), 1,
      anon_sym_DOT,
    ACTIONS(6973), 1,
      anon_sym_LPAREN,
    ACTIONS(7022), 1,
      anon_sym_LBRACK,
    ACTIONS(7026), 1,
      anon_sym_BANG,
    ACTIONS(7042), 1,
      anon_sym_switch,
    ACTIONS(7050), 1,
      anon_sym_with,
    ACTIONS(7234), 1,
      anon_sym_as,
    ACTIONS(7355), 1,
      anon_sym_SLASH,
    ACTIONS(7361), 1,
      anon_sym_AMP,
    ACTIONS(7365), 1,
      anon_sym_GT_GT,
    ACTIONS(7371), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7379), 1,
      anon_sym_is,
    STATE(3870), 1,
      sym_bracketed_argument_list,
    STATE(5721), 1,
      sym_argument_list,
    ACTIONS(6116), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7028), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7347), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7351), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7353), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7363), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7367), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7369), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 7,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(5963), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [177060] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4953), 1,
      anon_sym_DASH_GT,
    ACTIONS(5067), 1,
      anon_sym_DOT,
    ACTIONS(6973), 1,
      anon_sym_LPAREN,
    ACTIONS(7022), 1,
      anon_sym_LBRACK,
    ACTIONS(7026), 1,
      anon_sym_BANG,
    ACTIONS(7042), 1,
      anon_sym_switch,
    ACTIONS(7050), 1,
      anon_sym_with,
    ACTIONS(7371), 1,
      anon_sym_DOT_DOT,
    STATE(3870), 1,
      sym_bracketed_argument_list,
    STATE(5721), 1,
      sym_argument_list,
    ACTIONS(7028), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5964), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6116), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6114), 17,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [177162] = 25,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4953), 1,
      anon_sym_DASH_GT,
    ACTIONS(5067), 1,
      anon_sym_DOT,
    ACTIONS(6973), 1,
      anon_sym_LPAREN,
    ACTIONS(7022), 1,
      anon_sym_LBRACK,
    ACTIONS(7026), 1,
      anon_sym_BANG,
    ACTIONS(7042), 1,
      anon_sym_switch,
    ACTIONS(7050), 1,
      anon_sym_with,
    ACTIONS(7355), 1,
      anon_sym_SLASH,
    ACTIONS(7371), 1,
      anon_sym_DOT_DOT,
    STATE(3870), 1,
      sym_bracketed_argument_list,
    STATE(5721), 1,
      sym_argument_list,
    ACTIONS(7028), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7353), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6116), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5965), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 15,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [177268] = 28,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4953), 1,
      anon_sym_DASH_GT,
    ACTIONS(5067), 1,
      anon_sym_DOT,
    ACTIONS(6973), 1,
      anon_sym_LPAREN,
    ACTIONS(7022), 1,
      anon_sym_LBRACK,
    ACTIONS(7026), 1,
      anon_sym_BANG,
    ACTIONS(7042), 1,
      anon_sym_switch,
    ACTIONS(7050), 1,
      anon_sym_with,
    ACTIONS(7355), 1,
      anon_sym_SLASH,
    ACTIONS(7365), 1,
      anon_sym_GT_GT,
    ACTIONS(7371), 1,
      anon_sym_DOT_DOT,
    STATE(3870), 1,
      sym_bracketed_argument_list,
    STATE(5721), 1,
      sym_argument_list,
    ACTIONS(7028), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7351), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7353), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7363), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6116), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5966), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 13,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [177380] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6959), 1,
      anon_sym_as,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7874), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7914), 1,
      anon_sym_QMARK,
    ACTIONS(7920), 1,
      anon_sym_SLASH,
    ACTIONS(7922), 1,
      anon_sym_CARET,
    ACTIONS(7924), 1,
      anon_sym_PIPE,
    ACTIONS(7926), 1,
      anon_sym_AMP,
    ACTIONS(7930), 1,
      anon_sym_GT_GT,
    ACTIONS(7936), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7938), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7940), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7942), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7912), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7916), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7918), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7928), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7932), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7934), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6230), 3,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
    STATE(5967), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [177514] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4277), 1,
      anon_sym_LBRACE,
    ACTIONS(4295), 1,
      sym_discard,
    ACTIONS(7333), 1,
      sym__identifier_token,
    ACTIONS(7337), 1,
      anon_sym_LPAREN,
    ACTIONS(7819), 1,
      anon_sym_COMMA,
    ACTIONS(8149), 1,
      anon_sym_RPAREN,
    STATE(3127), 1,
      sym__reserved_identifier,
    STATE(4260), 1,
      sym__variable_designation,
    STATE(4274), 1,
      sym_parenthesized_variable_designation,
    STATE(6162), 1,
      sym_positional_pattern_clause,
    STATE(6695), 1,
      sym_property_pattern_clause,
    STATE(7809), 1,
      sym_identifier,
    STATE(9033), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    ACTIONS(4279), 2,
      anon_sym_and,
      anon_sym_or,
    STATE(5968), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7335), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [177622] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5969), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4349), 10,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_GT,
      anon_sym_EQ_GT,
    ACTIONS(4347), 28,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_operator,
      anon_sym_this,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [177702] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2607), 1,
      anon_sym_COMMA,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(8151), 1,
      anon_sym_RBRACK,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    STATE(8472), 1,
      aux_sym_array_rank_specifier_repeat1,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5970), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [177840] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(7950), 1,
      anon_sym_SLASH,
    ACTIONS(7954), 1,
      anon_sym_GT_GT,
    ACTIONS(7956), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7960), 1,
      anon_sym_AMP,
    ACTIONS(7966), 1,
      anon_sym_CARET,
    ACTIONS(7970), 1,
      anon_sym_PIPE,
    ACTIONS(7972), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7974), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7976), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7980), 1,
      anon_sym_QMARK,
    ACTIONS(7994), 1,
      anon_sym_COMMA,
    ACTIONS(8153), 1,
      anon_sym_SEMI,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    STATE(8495), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7946), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7948), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7952), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7958), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7962), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7964), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5971), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [177978] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7874), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7920), 1,
      anon_sym_SLASH,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7916), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7918), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6116), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5972), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 15,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [178086] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(8155), 1,
      anon_sym_COMMA,
    ACTIONS(8157), 1,
      anon_sym_RBRACE,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    STATE(8486), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5973), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [178224] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8060), 1,
      anon_sym_and,
    ACTIONS(8159), 1,
      anon_sym_or,
    STATE(5974), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6609), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6607), 25,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_when,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [178308] = 32,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6959), 1,
      anon_sym_as,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7874), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7920), 1,
      anon_sym_SLASH,
    ACTIONS(7930), 1,
      anon_sym_GT_GT,
    ACTIONS(7942), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7912), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7916), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7918), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7928), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7934), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6116), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5975), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 9,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [178428] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6959), 1,
      anon_sym_as,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7874), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7920), 1,
      anon_sym_SLASH,
    ACTIONS(7922), 1,
      anon_sym_CARET,
    ACTIONS(7924), 1,
      anon_sym_PIPE,
    ACTIONS(7926), 1,
      anon_sym_AMP,
    ACTIONS(7930), 1,
      anon_sym_GT_GT,
    ACTIONS(7942), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7912), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7916), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7918), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7928), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7932), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7934), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 6,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(5976), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [178556] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6959), 1,
      anon_sym_as,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7874), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7920), 1,
      anon_sym_SLASH,
    ACTIONS(7922), 1,
      anon_sym_CARET,
    ACTIONS(7924), 1,
      anon_sym_PIPE,
    ACTIONS(7926), 1,
      anon_sym_AMP,
    ACTIONS(7930), 1,
      anon_sym_GT_GT,
    ACTIONS(7936), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7942), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7912), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7916), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7918), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7928), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7932), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7934), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 5,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(5977), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [178686] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6959), 1,
      anon_sym_as,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7874), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7920), 1,
      anon_sym_SLASH,
    ACTIONS(7922), 1,
      anon_sym_CARET,
    ACTIONS(7924), 1,
      anon_sym_PIPE,
    ACTIONS(7926), 1,
      anon_sym_AMP,
    ACTIONS(7930), 1,
      anon_sym_GT_GT,
    ACTIONS(7936), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7938), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7940), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7942), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7912), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7916), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7918), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7928), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7932), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7934), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 3,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
    STATE(5978), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [178820] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(7950), 1,
      anon_sym_SLASH,
    ACTIONS(7954), 1,
      anon_sym_GT_GT,
    ACTIONS(7956), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7960), 1,
      anon_sym_AMP,
    ACTIONS(7966), 1,
      anon_sym_CARET,
    ACTIONS(7970), 1,
      anon_sym_PIPE,
    ACTIONS(7972), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7974), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7976), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7980), 1,
      anon_sym_QMARK,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7946), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7948), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7952), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7958), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7962), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7964), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6230), 3,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(5979), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [178954] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(7986), 1,
      anon_sym_COMMA,
    ACTIONS(8161), 1,
      anon_sym_RPAREN,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    STATE(8568), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5980), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [179092] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(7986), 1,
      anon_sym_COMMA,
    ACTIONS(8163), 1,
      anon_sym_RPAREN,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    STATE(8601), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5981), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [179230] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(7950), 1,
      anon_sym_SLASH,
    ACTIONS(7954), 1,
      anon_sym_GT_GT,
    ACTIONS(7956), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7960), 1,
      anon_sym_AMP,
    ACTIONS(7966), 1,
      anon_sym_CARET,
    ACTIONS(7970), 1,
      anon_sym_PIPE,
    ACTIONS(7972), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7974), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7976), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7980), 1,
      anon_sym_QMARK,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7946), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7948), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7952), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7958), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7962), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7964), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6236), 3,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(5982), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [179364] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6959), 1,
      anon_sym_as,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7874), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7914), 1,
      anon_sym_QMARK,
    ACTIONS(7920), 1,
      anon_sym_SLASH,
    ACTIONS(7922), 1,
      anon_sym_CARET,
    ACTIONS(7924), 1,
      anon_sym_PIPE,
    ACTIONS(7926), 1,
      anon_sym_AMP,
    ACTIONS(7930), 1,
      anon_sym_GT_GT,
    ACTIONS(7936), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7938), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7940), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7942), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7912), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7916), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7918), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7928), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7932), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7934), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6236), 3,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
    STATE(5983), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [179498] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(7874), 1,
      anon_sym_DOT_DOT,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5984), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6122), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6120), 19,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [179596] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(8068), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8078), 1,
      anon_sym_SLASH,
    ACTIONS(8088), 1,
      anon_sym_GT_GT,
    ACTIONS(8100), 1,
      anon_sym_as,
    ACTIONS(8102), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8070), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8074), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8076), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8086), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8090), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8092), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6116), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(6114), 7,
      anon_sym_in,
      anon_sym_CARET,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(5985), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [179718] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6959), 1,
      anon_sym_as,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7874), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7914), 1,
      anon_sym_QMARK,
    ACTIONS(7920), 1,
      anon_sym_SLASH,
    ACTIONS(7922), 1,
      anon_sym_CARET,
    ACTIONS(7924), 1,
      anon_sym_PIPE,
    ACTIONS(7926), 1,
      anon_sym_AMP,
    ACTIONS(7930), 1,
      anon_sym_GT_GT,
    ACTIONS(7936), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7938), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7940), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7942), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7912), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7916), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7918), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7928), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7932), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7934), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5420), 3,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
    STATE(5986), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [179852] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6959), 1,
      anon_sym_as,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7874), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7914), 1,
      anon_sym_QMARK,
    ACTIONS(7920), 1,
      anon_sym_SLASH,
    ACTIONS(7922), 1,
      anon_sym_CARET,
    ACTIONS(7924), 1,
      anon_sym_PIPE,
    ACTIONS(7926), 1,
      anon_sym_AMP,
    ACTIONS(7930), 1,
      anon_sym_GT_GT,
    ACTIONS(7936), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7938), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7940), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7942), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7912), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7916), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7918), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7928), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7932), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7934), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5510), 3,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
    STATE(5987), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [179986] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6959), 1,
      anon_sym_as,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7874), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7914), 1,
      anon_sym_QMARK,
    ACTIONS(7920), 1,
      anon_sym_SLASH,
    ACTIONS(7922), 1,
      anon_sym_CARET,
    ACTIONS(7924), 1,
      anon_sym_PIPE,
    ACTIONS(7926), 1,
      anon_sym_AMP,
    ACTIONS(7930), 1,
      anon_sym_GT_GT,
    ACTIONS(7936), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7938), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7940), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7942), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7912), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7916), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7918), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7928), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7932), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7934), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5325), 3,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
    STATE(5988), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [180120] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4953), 1,
      anon_sym_DASH_GT,
    ACTIONS(5067), 1,
      anon_sym_DOT,
    ACTIONS(6973), 1,
      anon_sym_LPAREN,
    ACTIONS(7022), 1,
      anon_sym_LBRACK,
    ACTIONS(7026), 1,
      anon_sym_BANG,
    ACTIONS(7042), 1,
      anon_sym_switch,
    ACTIONS(7050), 1,
      anon_sym_with,
    ACTIONS(7234), 1,
      anon_sym_as,
    ACTIONS(7349), 1,
      anon_sym_QMARK,
    ACTIONS(7355), 1,
      anon_sym_SLASH,
    ACTIONS(7357), 1,
      anon_sym_CARET,
    ACTIONS(7359), 1,
      anon_sym_PIPE,
    ACTIONS(7361), 1,
      anon_sym_AMP,
    ACTIONS(7365), 1,
      anon_sym_GT_GT,
    ACTIONS(7371), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7373), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7375), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7377), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7379), 1,
      anon_sym_is,
    STATE(3870), 1,
      sym_bracketed_argument_list,
    STATE(5721), 1,
      sym_argument_list,
    ACTIONS(7028), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7347), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7351), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7353), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7363), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7367), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7369), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5337), 3,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(5989), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [180254] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6959), 1,
      anon_sym_as,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7874), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7914), 1,
      anon_sym_QMARK,
    ACTIONS(7920), 1,
      anon_sym_SLASH,
    ACTIONS(7922), 1,
      anon_sym_CARET,
    ACTIONS(7924), 1,
      anon_sym_PIPE,
    ACTIONS(7926), 1,
      anon_sym_AMP,
    ACTIONS(7930), 1,
      anon_sym_GT_GT,
    ACTIONS(7936), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7938), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7940), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7942), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7912), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7916), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7918), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7928), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7932), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7934), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6216), 3,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
    STATE(5990), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [180388] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4953), 1,
      anon_sym_DASH_GT,
    ACTIONS(5067), 1,
      anon_sym_DOT,
    ACTIONS(6973), 1,
      anon_sym_LPAREN,
    ACTIONS(7022), 1,
      anon_sym_LBRACK,
    ACTIONS(7026), 1,
      anon_sym_BANG,
    ACTIONS(7042), 1,
      anon_sym_switch,
    ACTIONS(7050), 1,
      anon_sym_with,
    ACTIONS(7234), 1,
      anon_sym_as,
    ACTIONS(7349), 1,
      anon_sym_QMARK,
    ACTIONS(7355), 1,
      anon_sym_SLASH,
    ACTIONS(7357), 1,
      anon_sym_CARET,
    ACTIONS(7359), 1,
      anon_sym_PIPE,
    ACTIONS(7361), 1,
      anon_sym_AMP,
    ACTIONS(7365), 1,
      anon_sym_GT_GT,
    ACTIONS(7371), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7373), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7375), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7377), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7379), 1,
      anon_sym_is,
    STATE(3870), 1,
      sym_bracketed_argument_list,
    STATE(5721), 1,
      sym_argument_list,
    ACTIONS(7028), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7347), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7351), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7353), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7363), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7367), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7369), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5385), 3,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(5991), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [180522] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8165), 1,
      anon_sym_into,
    STATE(5992), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym__query_body_repeat2,
    ACTIONS(6376), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6374), 25,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [180604] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6959), 1,
      anon_sym_as,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7874), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7914), 1,
      anon_sym_QMARK,
    ACTIONS(7920), 1,
      anon_sym_SLASH,
    ACTIONS(7922), 1,
      anon_sym_CARET,
    ACTIONS(7924), 1,
      anon_sym_PIPE,
    ACTIONS(7926), 1,
      anon_sym_AMP,
    ACTIONS(7930), 1,
      anon_sym_GT_GT,
    ACTIONS(7936), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7938), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7940), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7942), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7912), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7916), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7918), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7928), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7932), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7934), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5396), 3,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
    STATE(5993), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [180738] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6220), 1,
      anon_sym_RPAREN,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7968), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    STATE(5994), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [180874] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4953), 1,
      anon_sym_DASH_GT,
    ACTIONS(5067), 1,
      anon_sym_DOT,
    ACTIONS(6973), 1,
      anon_sym_LPAREN,
    ACTIONS(7022), 1,
      anon_sym_LBRACK,
    ACTIONS(7026), 1,
      anon_sym_BANG,
    ACTIONS(7042), 1,
      anon_sym_switch,
    ACTIONS(7050), 1,
      anon_sym_with,
    ACTIONS(7234), 1,
      anon_sym_as,
    ACTIONS(7349), 1,
      anon_sym_QMARK,
    ACTIONS(7355), 1,
      anon_sym_SLASH,
    ACTIONS(7357), 1,
      anon_sym_CARET,
    ACTIONS(7359), 1,
      anon_sym_PIPE,
    ACTIONS(7361), 1,
      anon_sym_AMP,
    ACTIONS(7365), 1,
      anon_sym_GT_GT,
    ACTIONS(7371), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7373), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7375), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7377), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7379), 1,
      anon_sym_is,
    STATE(3870), 1,
      sym_bracketed_argument_list,
    STATE(5721), 1,
      sym_argument_list,
    ACTIONS(7028), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7347), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7351), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7353), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7363), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7367), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7369), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6216), 3,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(5995), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [181008] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4953), 1,
      anon_sym_DASH_GT,
    ACTIONS(5067), 1,
      anon_sym_DOT,
    ACTIONS(6973), 1,
      anon_sym_LPAREN,
    ACTIONS(7022), 1,
      anon_sym_LBRACK,
    ACTIONS(7026), 1,
      anon_sym_BANG,
    ACTIONS(7042), 1,
      anon_sym_switch,
    ACTIONS(7050), 1,
      anon_sym_with,
    ACTIONS(7234), 1,
      anon_sym_as,
    ACTIONS(7349), 1,
      anon_sym_QMARK,
    ACTIONS(7355), 1,
      anon_sym_SLASH,
    ACTIONS(7357), 1,
      anon_sym_CARET,
    ACTIONS(7359), 1,
      anon_sym_PIPE,
    ACTIONS(7361), 1,
      anon_sym_AMP,
    ACTIONS(7365), 1,
      anon_sym_GT_GT,
    ACTIONS(7371), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7373), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7375), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7377), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7379), 1,
      anon_sym_is,
    STATE(3870), 1,
      sym_bracketed_argument_list,
    STATE(5721), 1,
      sym_argument_list,
    ACTIONS(7028), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7347), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7351), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7353), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7363), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7367), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7369), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5325), 3,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(5996), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [181142] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7968), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
    STATE(5997), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [181276] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6959), 1,
      anon_sym_as,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7874), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7914), 1,
      anon_sym_QMARK,
    ACTIONS(7920), 1,
      anon_sym_SLASH,
    ACTIONS(7922), 1,
      anon_sym_CARET,
    ACTIONS(7924), 1,
      anon_sym_PIPE,
    ACTIONS(7926), 1,
      anon_sym_AMP,
    ACTIONS(7930), 1,
      anon_sym_GT_GT,
    ACTIONS(7936), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7938), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7940), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7942), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7912), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7916), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7918), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7928), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7932), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7934), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5385), 3,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
    STATE(5998), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [181410] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6959), 1,
      anon_sym_as,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7874), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7914), 1,
      anon_sym_QMARK,
    ACTIONS(7920), 1,
      anon_sym_SLASH,
    ACTIONS(7922), 1,
      anon_sym_CARET,
    ACTIONS(7924), 1,
      anon_sym_PIPE,
    ACTIONS(7926), 1,
      anon_sym_AMP,
    ACTIONS(7930), 1,
      anon_sym_GT_GT,
    ACTIONS(7936), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7938), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7940), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7942), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7912), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7916), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7918), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7928), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7932), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7934), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5337), 3,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
    STATE(5999), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [181544] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8168), 1,
      anon_sym_into,
    STATE(6007), 1,
      aux_sym__query_body_repeat2,
    STATE(6000), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6448), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6446), 25,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [181628] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6959), 1,
      anon_sym_as,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(7874), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7914), 1,
      anon_sym_QMARK,
    ACTIONS(7920), 1,
      anon_sym_SLASH,
    ACTIONS(7922), 1,
      anon_sym_CARET,
    ACTIONS(7924), 1,
      anon_sym_PIPE,
    ACTIONS(7926), 1,
      anon_sym_AMP,
    ACTIONS(7930), 1,
      anon_sym_GT_GT,
    ACTIONS(7936), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7938), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7940), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7942), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7912), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7916), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7918), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7928), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7932), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7934), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6220), 3,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
    STATE(6001), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [181762] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(8170), 1,
      anon_sym_COMMA,
    ACTIONS(8172), 1,
      anon_sym_RBRACE,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    STATE(8470), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6002), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [181900] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4277), 1,
      anon_sym_LBRACE,
    ACTIONS(4295), 1,
      sym_discard,
    ACTIONS(7333), 1,
      sym__identifier_token,
    ACTIONS(7337), 1,
      anon_sym_LPAREN,
    ACTIONS(7819), 1,
      anon_sym_COMMA,
    ACTIONS(8174), 1,
      anon_sym_RPAREN,
    STATE(3127), 1,
      sym__reserved_identifier,
    STATE(4260), 1,
      sym__variable_designation,
    STATE(4274), 1,
      sym_parenthesized_variable_designation,
    STATE(6162), 1,
      sym_positional_pattern_clause,
    STATE(6695), 1,
      sym_property_pattern_clause,
    STATE(7809), 1,
      sym_identifier,
    STATE(9033), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    ACTIONS(4279), 2,
      anon_sym_and,
      anon_sym_or,
    STATE(6003), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7335), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [182008] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(8068), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8072), 1,
      anon_sym_QMARK,
    ACTIONS(8078), 1,
      anon_sym_SLASH,
    ACTIONS(8080), 1,
      anon_sym_CARET,
    ACTIONS(8082), 1,
      anon_sym_PIPE,
    ACTIONS(8084), 1,
      anon_sym_AMP,
    ACTIONS(8088), 1,
      anon_sym_GT_GT,
    ACTIONS(8094), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8096), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8098), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8100), 1,
      anon_sym_as,
    ACTIONS(8102), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8070), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8074), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8076), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8086), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8090), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8092), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6220), 3,
      anon_sym_in,
      anon_sym_and,
      anon_sym_or,
    STATE(6004), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [182142] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(8068), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8072), 1,
      anon_sym_QMARK,
    ACTIONS(8078), 1,
      anon_sym_SLASH,
    ACTIONS(8080), 1,
      anon_sym_CARET,
    ACTIONS(8082), 1,
      anon_sym_PIPE,
    ACTIONS(8084), 1,
      anon_sym_AMP,
    ACTIONS(8088), 1,
      anon_sym_GT_GT,
    ACTIONS(8094), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8096), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8098), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8100), 1,
      anon_sym_as,
    ACTIONS(8102), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8070), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8074), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8076), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8086), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8090), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8092), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5337), 3,
      anon_sym_in,
      anon_sym_and,
      anon_sym_or,
    STATE(6005), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [182276] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(8068), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8072), 1,
      anon_sym_QMARK,
    ACTIONS(8078), 1,
      anon_sym_SLASH,
    ACTIONS(8080), 1,
      anon_sym_CARET,
    ACTIONS(8082), 1,
      anon_sym_PIPE,
    ACTIONS(8084), 1,
      anon_sym_AMP,
    ACTIONS(8088), 1,
      anon_sym_GT_GT,
    ACTIONS(8094), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8096), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8098), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8100), 1,
      anon_sym_as,
    ACTIONS(8102), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8070), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8074), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8076), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8086), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8090), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8092), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5385), 3,
      anon_sym_in,
      anon_sym_and,
      anon_sym_or,
    STATE(6006), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [182410] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8168), 1,
      anon_sym_into,
    STATE(6011), 1,
      aux_sym__query_body_repeat2,
    STATE(6007), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6420), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6418), 25,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [182494] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(8068), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8072), 1,
      anon_sym_QMARK,
    ACTIONS(8078), 1,
      anon_sym_SLASH,
    ACTIONS(8080), 1,
      anon_sym_CARET,
    ACTIONS(8082), 1,
      anon_sym_PIPE,
    ACTIONS(8084), 1,
      anon_sym_AMP,
    ACTIONS(8088), 1,
      anon_sym_GT_GT,
    ACTIONS(8094), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8096), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8098), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8100), 1,
      anon_sym_as,
    ACTIONS(8102), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8070), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8074), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8076), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8086), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8090), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8092), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5396), 3,
      anon_sym_in,
      anon_sym_and,
      anon_sym_or,
    STATE(6008), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [182628] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(8068), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8072), 1,
      anon_sym_QMARK,
    ACTIONS(8078), 1,
      anon_sym_SLASH,
    ACTIONS(8080), 1,
      anon_sym_CARET,
    ACTIONS(8082), 1,
      anon_sym_PIPE,
    ACTIONS(8084), 1,
      anon_sym_AMP,
    ACTIONS(8088), 1,
      anon_sym_GT_GT,
    ACTIONS(8094), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8096), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8098), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8100), 1,
      anon_sym_as,
    ACTIONS(8102), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8070), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8074), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8076), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8086), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8090), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8092), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6216), 3,
      anon_sym_in,
      anon_sym_and,
      anon_sym_or,
    STATE(6009), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [182762] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8168), 1,
      anon_sym_into,
    STATE(6023), 1,
      aux_sym__query_body_repeat2,
    STATE(6010), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6420), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6418), 25,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [182846] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8176), 1,
      anon_sym_into,
    STATE(6011), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym__query_body_repeat2,
    ACTIONS(6376), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6374), 25,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [182928] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(8068), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8072), 1,
      anon_sym_QMARK,
    ACTIONS(8078), 1,
      anon_sym_SLASH,
    ACTIONS(8080), 1,
      anon_sym_CARET,
    ACTIONS(8082), 1,
      anon_sym_PIPE,
    ACTIONS(8084), 1,
      anon_sym_AMP,
    ACTIONS(8088), 1,
      anon_sym_GT_GT,
    ACTIONS(8094), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8096), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8098), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8100), 1,
      anon_sym_as,
    ACTIONS(8102), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8070), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8074), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8076), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8086), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8090), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8092), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5325), 3,
      anon_sym_in,
      anon_sym_and,
      anon_sym_or,
    STATE(6012), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [183062] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4953), 1,
      anon_sym_DASH_GT,
    ACTIONS(5067), 1,
      anon_sym_DOT,
    ACTIONS(6973), 1,
      anon_sym_LPAREN,
    ACTIONS(7022), 1,
      anon_sym_LBRACK,
    ACTIONS(7026), 1,
      anon_sym_BANG,
    ACTIONS(7042), 1,
      anon_sym_switch,
    ACTIONS(7050), 1,
      anon_sym_with,
    ACTIONS(7234), 1,
      anon_sym_as,
    ACTIONS(7349), 1,
      anon_sym_QMARK,
    ACTIONS(7355), 1,
      anon_sym_SLASH,
    ACTIONS(7357), 1,
      anon_sym_CARET,
    ACTIONS(7359), 1,
      anon_sym_PIPE,
    ACTIONS(7361), 1,
      anon_sym_AMP,
    ACTIONS(7365), 1,
      anon_sym_GT_GT,
    ACTIONS(7371), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7373), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7375), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7377), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7379), 1,
      anon_sym_is,
    STATE(3870), 1,
      sym_bracketed_argument_list,
    STATE(5721), 1,
      sym_argument_list,
    ACTIONS(7028), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7347), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7351), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7353), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7363), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7367), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7369), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5510), 3,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(6013), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [183196] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4277), 1,
      anon_sym_LBRACE,
    ACTIONS(4295), 1,
      sym_discard,
    ACTIONS(7333), 1,
      sym__identifier_token,
    ACTIONS(7337), 1,
      anon_sym_LPAREN,
    ACTIONS(7819), 1,
      anon_sym_COMMA,
    ACTIONS(8179), 1,
      anon_sym_RPAREN,
    STATE(3127), 1,
      sym__reserved_identifier,
    STATE(4260), 1,
      sym__variable_designation,
    STATE(4274), 1,
      sym_parenthesized_variable_designation,
    STATE(6162), 1,
      sym_positional_pattern_clause,
    STATE(6695), 1,
      sym_property_pattern_clause,
    STATE(7809), 1,
      sym_identifier,
    STATE(9033), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    ACTIONS(4279), 2,
      anon_sym_and,
      anon_sym_or,
    STATE(6014), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7335), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [183304] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(8068), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8072), 1,
      anon_sym_QMARK,
    ACTIONS(8078), 1,
      anon_sym_SLASH,
    ACTIONS(8080), 1,
      anon_sym_CARET,
    ACTIONS(8082), 1,
      anon_sym_PIPE,
    ACTIONS(8084), 1,
      anon_sym_AMP,
    ACTIONS(8088), 1,
      anon_sym_GT_GT,
    ACTIONS(8094), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8096), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8098), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8100), 1,
      anon_sym_as,
    ACTIONS(8102), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8070), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8074), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8076), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8086), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8090), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8092), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5510), 3,
      anon_sym_in,
      anon_sym_and,
      anon_sym_or,
    STATE(6015), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [183438] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4953), 1,
      anon_sym_DASH_GT,
    ACTIONS(5067), 1,
      anon_sym_DOT,
    ACTIONS(6973), 1,
      anon_sym_LPAREN,
    ACTIONS(7022), 1,
      anon_sym_LBRACK,
    ACTIONS(7026), 1,
      anon_sym_BANG,
    ACTIONS(7042), 1,
      anon_sym_switch,
    ACTIONS(7050), 1,
      anon_sym_with,
    ACTIONS(7234), 1,
      anon_sym_as,
    ACTIONS(7349), 1,
      anon_sym_QMARK,
    ACTIONS(7355), 1,
      anon_sym_SLASH,
    ACTIONS(7357), 1,
      anon_sym_CARET,
    ACTIONS(7359), 1,
      anon_sym_PIPE,
    ACTIONS(7361), 1,
      anon_sym_AMP,
    ACTIONS(7365), 1,
      anon_sym_GT_GT,
    ACTIONS(7371), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7373), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7375), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7377), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7379), 1,
      anon_sym_is,
    STATE(3870), 1,
      sym_bracketed_argument_list,
    STATE(5721), 1,
      sym_argument_list,
    ACTIONS(7028), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7347), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7351), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7353), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7363), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7367), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7369), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5420), 3,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(6016), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [183572] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4953), 1,
      anon_sym_DASH_GT,
    ACTIONS(5067), 1,
      anon_sym_DOT,
    ACTIONS(6973), 1,
      anon_sym_LPAREN,
    ACTIONS(7022), 1,
      anon_sym_LBRACK,
    ACTIONS(7026), 1,
      anon_sym_BANG,
    ACTIONS(7042), 1,
      anon_sym_switch,
    ACTIONS(7050), 1,
      anon_sym_with,
    ACTIONS(7234), 1,
      anon_sym_as,
    ACTIONS(7349), 1,
      anon_sym_QMARK,
    ACTIONS(7355), 1,
      anon_sym_SLASH,
    ACTIONS(7357), 1,
      anon_sym_CARET,
    ACTIONS(7359), 1,
      anon_sym_PIPE,
    ACTIONS(7361), 1,
      anon_sym_AMP,
    ACTIONS(7365), 1,
      anon_sym_GT_GT,
    ACTIONS(7371), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7373), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7375), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7377), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7379), 1,
      anon_sym_is,
    STATE(3870), 1,
      sym_bracketed_argument_list,
    STATE(5721), 1,
      sym_argument_list,
    ACTIONS(7028), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7347), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7351), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7353), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7363), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7367), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7369), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6230), 3,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(6017), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [183706] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(8068), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8072), 1,
      anon_sym_QMARK,
    ACTIONS(8078), 1,
      anon_sym_SLASH,
    ACTIONS(8080), 1,
      anon_sym_CARET,
    ACTIONS(8082), 1,
      anon_sym_PIPE,
    ACTIONS(8084), 1,
      anon_sym_AMP,
    ACTIONS(8088), 1,
      anon_sym_GT_GT,
    ACTIONS(8094), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8096), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8098), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8100), 1,
      anon_sym_as,
    ACTIONS(8102), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8070), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8074), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8076), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8086), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8090), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8092), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5420), 3,
      anon_sym_in,
      anon_sym_and,
      anon_sym_or,
    STATE(6018), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [183840] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(8068), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8072), 1,
      anon_sym_QMARK,
    ACTIONS(8078), 1,
      anon_sym_SLASH,
    ACTIONS(8080), 1,
      anon_sym_CARET,
    ACTIONS(8082), 1,
      anon_sym_PIPE,
    ACTIONS(8084), 1,
      anon_sym_AMP,
    ACTIONS(8088), 1,
      anon_sym_GT_GT,
    ACTIONS(8094), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8096), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8098), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8100), 1,
      anon_sym_as,
    ACTIONS(8102), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8070), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8074), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8076), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8086), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8090), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8092), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6230), 3,
      anon_sym_in,
      anon_sym_and,
      anon_sym_or,
    STATE(6019), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [183974] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(8068), 1,
      anon_sym_DOT_DOT,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(6020), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6122), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6120), 19,
      anon_sym_in,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [184072] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(7950), 1,
      anon_sym_SLASH,
    ACTIONS(7954), 1,
      anon_sym_GT_GT,
    ACTIONS(7956), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7960), 1,
      anon_sym_AMP,
    ACTIONS(7966), 1,
      anon_sym_CARET,
    ACTIONS(7970), 1,
      anon_sym_PIPE,
    ACTIONS(7972), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7974), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7976), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7980), 1,
      anon_sym_QMARK,
    ACTIONS(7994), 1,
      anon_sym_COMMA,
    ACTIONS(8181), 1,
      anon_sym_SEMI,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    STATE(8516), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7946), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7948), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7952), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7958), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7962), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7964), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6021), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [184210] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(8068), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8072), 1,
      anon_sym_QMARK,
    ACTIONS(8078), 1,
      anon_sym_SLASH,
    ACTIONS(8080), 1,
      anon_sym_CARET,
    ACTIONS(8082), 1,
      anon_sym_PIPE,
    ACTIONS(8084), 1,
      anon_sym_AMP,
    ACTIONS(8088), 1,
      anon_sym_GT_GT,
    ACTIONS(8094), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8096), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8098), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8100), 1,
      anon_sym_as,
    ACTIONS(8102), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8070), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8074), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8076), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8086), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8090), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8092), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6236), 3,
      anon_sym_in,
      anon_sym_and,
      anon_sym_or,
    STATE(6022), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [184344] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8168), 1,
      anon_sym_into,
    STATE(6011), 1,
      aux_sym__query_body_repeat2,
    STATE(6023), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6383), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6381), 25,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [184428] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2607), 1,
      anon_sym_COMMA,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(8183), 1,
      anon_sym_RBRACK,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    STATE(8562), 1,
      aux_sym_array_rank_specifier_repeat1,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6024), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [184566] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8185), 1,
      anon_sym_into,
    STATE(6028), 1,
      aux_sym__query_body_repeat2,
    STATE(6025), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6448), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6446), 25,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [184650] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4277), 1,
      anon_sym_LBRACE,
    ACTIONS(4295), 1,
      sym_discard,
    ACTIONS(7333), 1,
      sym__identifier_token,
    ACTIONS(7337), 1,
      anon_sym_LPAREN,
    ACTIONS(7819), 1,
      anon_sym_COMMA,
    ACTIONS(8187), 1,
      anon_sym_RPAREN,
    STATE(3127), 1,
      sym__reserved_identifier,
    STATE(4260), 1,
      sym__variable_designation,
    STATE(4274), 1,
      sym_parenthesized_variable_designation,
    STATE(6162), 1,
      sym_positional_pattern_clause,
    STATE(6695), 1,
      sym_property_pattern_clause,
    STATE(7809), 1,
      sym_identifier,
    STATE(9033), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    ACTIONS(4279), 2,
      anon_sym_and,
      anon_sym_or,
    STATE(6026), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7335), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [184758] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4953), 1,
      anon_sym_DASH_GT,
    ACTIONS(5067), 1,
      anon_sym_DOT,
    ACTIONS(6973), 1,
      anon_sym_LPAREN,
    ACTIONS(7022), 1,
      anon_sym_LBRACK,
    ACTIONS(7026), 1,
      anon_sym_BANG,
    ACTIONS(7371), 1,
      anon_sym_DOT_DOT,
    STATE(3870), 1,
      sym_bracketed_argument_list,
    STATE(5721), 1,
      sym_argument_list,
    ACTIONS(7028), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(6027), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6122), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6120), 19,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [184856] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8185), 1,
      anon_sym_into,
    STATE(5992), 1,
      aux_sym__query_body_repeat2,
    STATE(6028), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6420), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6418), 25,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [184940] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8185), 1,
      anon_sym_into,
    STATE(6031), 1,
      aux_sym__query_body_repeat2,
    STATE(6029), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6420), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6418), 25,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [185024] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8189), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    STATE(6030), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [185158] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8185), 1,
      anon_sym_into,
    STATE(5992), 1,
      aux_sym__query_body_repeat2,
    STATE(6031), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6383), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6381), 25,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [185242] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4953), 1,
      anon_sym_DASH_GT,
    ACTIONS(5067), 1,
      anon_sym_DOT,
    ACTIONS(6973), 1,
      anon_sym_LPAREN,
    ACTIONS(7022), 1,
      anon_sym_LBRACK,
    ACTIONS(7026), 1,
      anon_sym_BANG,
    ACTIONS(7042), 1,
      anon_sym_switch,
    ACTIONS(7050), 1,
      anon_sym_with,
    ACTIONS(7234), 1,
      anon_sym_as,
    ACTIONS(7349), 1,
      anon_sym_QMARK,
    ACTIONS(7355), 1,
      anon_sym_SLASH,
    ACTIONS(7357), 1,
      anon_sym_CARET,
    ACTIONS(7359), 1,
      anon_sym_PIPE,
    ACTIONS(7361), 1,
      anon_sym_AMP,
    ACTIONS(7365), 1,
      anon_sym_GT_GT,
    ACTIONS(7371), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7373), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7375), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7377), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7379), 1,
      anon_sym_is,
    STATE(3870), 1,
      sym_bracketed_argument_list,
    STATE(5721), 1,
      sym_argument_list,
    ACTIONS(7028), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7347), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7351), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7353), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7363), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7367), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7369), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6236), 3,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(6032), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [185376] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4277), 1,
      anon_sym_LBRACE,
    ACTIONS(4295), 1,
      sym_discard,
    ACTIONS(7333), 1,
      sym__identifier_token,
    ACTIONS(7337), 1,
      anon_sym_LPAREN,
    ACTIONS(7819), 1,
      anon_sym_COMMA,
    ACTIONS(8191), 1,
      anon_sym_RPAREN,
    STATE(3127), 1,
      sym__reserved_identifier,
    STATE(4260), 1,
      sym__variable_designation,
    STATE(4274), 1,
      sym_parenthesized_variable_designation,
    STATE(6162), 1,
      sym_positional_pattern_clause,
    STATE(6695), 1,
      sym_property_pattern_clause,
    STATE(7809), 1,
      sym_identifier,
    STATE(9033), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    ACTIONS(4279), 2,
      anon_sym_and,
      anon_sym_or,
    STATE(6033), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7335), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [185484] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4277), 1,
      anon_sym_LBRACE,
    ACTIONS(4295), 1,
      sym_discard,
    ACTIONS(7333), 1,
      sym__identifier_token,
    ACTIONS(7337), 1,
      anon_sym_LPAREN,
    ACTIONS(7819), 1,
      anon_sym_COMMA,
    ACTIONS(8193), 1,
      anon_sym_RPAREN,
    STATE(3127), 1,
      sym__reserved_identifier,
    STATE(4260), 1,
      sym__variable_designation,
    STATE(4274), 1,
      sym_parenthesized_variable_designation,
    STATE(6162), 1,
      sym_positional_pattern_clause,
    STATE(6695), 1,
      sym_property_pattern_clause,
    STATE(7809), 1,
      sym_identifier,
    STATE(9033), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    ACTIONS(4279), 2,
      anon_sym_and,
      anon_sym_or,
    STATE(6034), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7335), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [185592] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(7986), 1,
      anon_sym_COMMA,
    ACTIONS(8195), 1,
      anon_sym_RPAREN,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    STATE(8493), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6035), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [185730] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8197), 1,
      anon_sym_into,
    STATE(6039), 1,
      aux_sym__query_body_repeat2,
    STATE(6036), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6448), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6446), 25,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [185814] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(7986), 1,
      anon_sym_COMMA,
    ACTIONS(8199), 1,
      anon_sym_RPAREN,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    STATE(8501), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6037), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [185952] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(7986), 1,
      anon_sym_COMMA,
    ACTIONS(8201), 1,
      anon_sym_RPAREN,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    STATE(8560), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6038), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [186090] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8197), 1,
      anon_sym_into,
    STATE(6042), 1,
      aux_sym__query_body_repeat2,
    STATE(6039), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6420), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6418), 25,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [186174] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2607), 1,
      anon_sym_COMMA,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(8203), 1,
      anon_sym_RBRACK,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    STATE(8498), 1,
      aux_sym_array_rank_specifier_repeat1,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6040), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [186312] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8197), 1,
      anon_sym_into,
    STATE(6044), 1,
      aux_sym__query_body_repeat2,
    STATE(6041), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6420), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6418), 25,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [186396] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8205), 1,
      anon_sym_into,
    STATE(6042), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym__query_body_repeat2,
    ACTIONS(6376), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6374), 25,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [186478] = 28,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7184), 1,
      anon_sym_SLASH,
    ACTIONS(7194), 1,
      anon_sym_GT_GT,
    ACTIONS(7200), 1,
      anon_sym_DOT_DOT,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7180), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7182), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7192), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6116), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(6043), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 13,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [186590] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8197), 1,
      anon_sym_into,
    STATE(6042), 1,
      aux_sym__query_body_repeat2,
    STATE(6044), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6383), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6381), 25,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [186674] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8208), 1,
      anon_sym_into,
    STATE(6049), 1,
      aux_sym__query_body_repeat2,
    STATE(6045), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6448), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6446), 25,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [186758] = 25,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7184), 1,
      anon_sym_SLASH,
    ACTIONS(7200), 1,
      anon_sym_DOT_DOT,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7182), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6116), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(6046), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 15,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [186864] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7200), 1,
      anon_sym_DOT_DOT,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(6047), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6116), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6114), 17,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [186966] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7184), 1,
      anon_sym_SLASH,
    ACTIONS(7190), 1,
      anon_sym_AMP,
    ACTIONS(7194), 1,
      anon_sym_GT_GT,
    ACTIONS(7200), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7210), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6116), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7176), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7180), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7182), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7192), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7196), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7198), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 7,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(6048), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [187090] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8208), 1,
      anon_sym_into,
    STATE(6051), 1,
      aux_sym__query_body_repeat2,
    STATE(6049), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6420), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6418), 25,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [187174] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8208), 1,
      anon_sym_into,
    STATE(6053), 1,
      aux_sym__query_body_repeat2,
    STATE(6050), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6420), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6418), 25,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [187258] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8210), 1,
      anon_sym_into,
    STATE(6051), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym__query_body_repeat2,
    ACTIONS(6376), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6374), 25,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [187340] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7178), 1,
      anon_sym_QMARK,
    ACTIONS(7184), 1,
      anon_sym_SLASH,
    ACTIONS(7186), 1,
      anon_sym_CARET,
    ACTIONS(7188), 1,
      anon_sym_PIPE,
    ACTIONS(7190), 1,
      anon_sym_AMP,
    ACTIONS(7194), 1,
      anon_sym_GT_GT,
    ACTIONS(7200), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7202), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7204), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7206), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7210), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7176), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7180), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7182), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7192), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7196), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7198), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5337), 3,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(6052), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [187474] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8208), 1,
      anon_sym_into,
    STATE(6051), 1,
      aux_sym__query_body_repeat2,
    STATE(6053), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6383), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6381), 25,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [187558] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8213), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
    STATE(6054), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [187692] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5298), 1,
      anon_sym_LBRACK,
    ACTIONS(5777), 1,
      anon_sym_LBRACE,
    ACTIONS(5780), 1,
      anon_sym_QMARK,
    STATE(4204), 1,
      sym_initializer_expression,
    STATE(6055), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5308), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5302), 24,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [187780] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7184), 1,
      anon_sym_SLASH,
    ACTIONS(7186), 1,
      anon_sym_CARET,
    ACTIONS(7190), 1,
      anon_sym_AMP,
    ACTIONS(7194), 1,
      anon_sym_GT_GT,
    ACTIONS(7200), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7210), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6116), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7176), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7180), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7182), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7192), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7196), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7198), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 6,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(6056), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [187906] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7184), 1,
      anon_sym_SLASH,
    ACTIONS(7194), 1,
      anon_sym_GT_GT,
    ACTIONS(7200), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7210), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7176), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7180), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7182), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7192), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7196), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7198), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6116), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(6114), 7,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(6057), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [188028] = 32,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7184), 1,
      anon_sym_SLASH,
    ACTIONS(7194), 1,
      anon_sym_GT_GT,
    ACTIONS(7200), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7210), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7176), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7180), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7182), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7192), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7198), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6116), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(6058), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 9,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [188148] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8118), 1,
      anon_sym_and,
    ACTIONS(8215), 1,
      anon_sym_or,
    STATE(6059), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5856), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5854), 25,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [188232] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4277), 1,
      anon_sym_LBRACE,
    ACTIONS(4295), 1,
      sym_discard,
    ACTIONS(7333), 1,
      sym__identifier_token,
    ACTIONS(7337), 1,
      anon_sym_LPAREN,
    ACTIONS(7819), 1,
      anon_sym_COMMA,
    ACTIONS(8217), 1,
      anon_sym_RPAREN,
    STATE(3127), 1,
      sym__reserved_identifier,
    STATE(4260), 1,
      sym__variable_designation,
    STATE(4274), 1,
      sym_parenthesized_variable_designation,
    STATE(6162), 1,
      sym_positional_pattern_clause,
    STATE(6695), 1,
      sym_property_pattern_clause,
    STATE(7809), 1,
      sym_identifier,
    STATE(9033), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    ACTIONS(4279), 2,
      anon_sym_and,
      anon_sym_or,
    STATE(6060), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7335), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [188340] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(7200), 1,
      anon_sym_DOT_DOT,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(6061), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6122), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6120), 19,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [188438] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7184), 1,
      anon_sym_SLASH,
    ACTIONS(7186), 1,
      anon_sym_CARET,
    ACTIONS(7188), 1,
      anon_sym_PIPE,
    ACTIONS(7190), 1,
      anon_sym_AMP,
    ACTIONS(7194), 1,
      anon_sym_GT_GT,
    ACTIONS(7200), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7210), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7176), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7180), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7182), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7192), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7196), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7198), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 6,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(6062), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [188566] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7184), 1,
      anon_sym_SLASH,
    ACTIONS(7186), 1,
      anon_sym_CARET,
    ACTIONS(7188), 1,
      anon_sym_PIPE,
    ACTIONS(7190), 1,
      anon_sym_AMP,
    ACTIONS(7194), 1,
      anon_sym_GT_GT,
    ACTIONS(7200), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7202), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7210), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7176), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7180), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7182), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7192), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7196), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7198), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(6063), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [188696] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2607), 1,
      anon_sym_COMMA,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(8219), 1,
      anon_sym_RBRACK,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    STATE(8549), 1,
      aux_sym_array_rank_specifier_repeat1,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6064), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [188834] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7184), 1,
      anon_sym_SLASH,
    ACTIONS(7186), 1,
      anon_sym_CARET,
    ACTIONS(7188), 1,
      anon_sym_PIPE,
    ACTIONS(7190), 1,
      anon_sym_AMP,
    ACTIONS(7194), 1,
      anon_sym_GT_GT,
    ACTIONS(7200), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7202), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7204), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7206), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7210), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7176), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7180), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7182), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7192), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7196), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7198), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 3,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(6065), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [188968] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4277), 1,
      anon_sym_LBRACE,
    ACTIONS(4295), 1,
      sym_discard,
    ACTIONS(7333), 1,
      sym__identifier_token,
    ACTIONS(7337), 1,
      anon_sym_LPAREN,
    ACTIONS(7819), 1,
      anon_sym_COMMA,
    ACTIONS(8221), 1,
      anon_sym_RPAREN,
    STATE(3127), 1,
      sym__reserved_identifier,
    STATE(4260), 1,
      sym__variable_designation,
    STATE(4274), 1,
      sym_parenthesized_variable_designation,
    STATE(6162), 1,
      sym_positional_pattern_clause,
    STATE(6695), 1,
      sym_property_pattern_clause,
    STATE(7809), 1,
      sym_identifier,
    STATE(9033), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    ACTIONS(4279), 2,
      anon_sym_and,
      anon_sym_or,
    STATE(6066), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7335), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [189076] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(7986), 1,
      anon_sym_COMMA,
    ACTIONS(8223), 1,
      anon_sym_RPAREN,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    STATE(8574), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6067), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [189214] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(7986), 1,
      anon_sym_COMMA,
    ACTIONS(8225), 1,
      anon_sym_RPAREN,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    STATE(8575), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6068), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [189352] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7184), 1,
      anon_sym_SLASH,
    ACTIONS(7200), 1,
      anon_sym_DOT_DOT,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7180), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7182), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6116), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(6069), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 15,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [189460] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(8068), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8078), 1,
      anon_sym_SLASH,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8074), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8076), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6116), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(6070), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 15,
      anon_sym_in,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [189568] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(7986), 1,
      anon_sym_COMMA,
    ACTIONS(8227), 1,
      anon_sym_RPAREN,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    STATE(8602), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6071), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [189706] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(7986), 1,
      anon_sym_COMMA,
    ACTIONS(8229), 1,
      anon_sym_RPAREN,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    STATE(8621), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6072), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [189844] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7178), 1,
      anon_sym_QMARK,
    ACTIONS(7184), 1,
      anon_sym_SLASH,
    ACTIONS(7186), 1,
      anon_sym_CARET,
    ACTIONS(7188), 1,
      anon_sym_PIPE,
    ACTIONS(7190), 1,
      anon_sym_AMP,
    ACTIONS(7194), 1,
      anon_sym_GT_GT,
    ACTIONS(7200), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7202), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7204), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7206), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7210), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7176), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7180), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7182), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7192), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7196), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7198), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5420), 3,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(6073), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [189978] = 32,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(8068), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8078), 1,
      anon_sym_SLASH,
    ACTIONS(8088), 1,
      anon_sym_GT_GT,
    ACTIONS(8100), 1,
      anon_sym_as,
    ACTIONS(8102), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8070), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8074), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8076), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8086), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8092), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6116), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(6074), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 9,
      anon_sym_in,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [190098] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(8068), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8078), 1,
      anon_sym_SLASH,
    ACTIONS(8080), 1,
      anon_sym_CARET,
    ACTIONS(8082), 1,
      anon_sym_PIPE,
    ACTIONS(8084), 1,
      anon_sym_AMP,
    ACTIONS(8088), 1,
      anon_sym_GT_GT,
    ACTIONS(8094), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8096), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8098), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8100), 1,
      anon_sym_as,
    ACTIONS(8102), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8070), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8074), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8076), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8086), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8090), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8092), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 3,
      anon_sym_in,
      anon_sym_and,
      anon_sym_or,
    STATE(6075), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [190232] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(8231), 1,
      anon_sym_COMMA,
    ACTIONS(8233), 1,
      anon_sym_RBRACE,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    STATE(8637), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6076), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [190370] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8235), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
    STATE(6077), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [190504] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(8068), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8078), 1,
      anon_sym_SLASH,
    ACTIONS(8080), 1,
      anon_sym_CARET,
    ACTIONS(8082), 1,
      anon_sym_PIPE,
    ACTIONS(8084), 1,
      anon_sym_AMP,
    ACTIONS(8088), 1,
      anon_sym_GT_GT,
    ACTIONS(8100), 1,
      anon_sym_as,
    ACTIONS(8102), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8070), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8074), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8076), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8086), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8090), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8092), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 6,
      anon_sym_in,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(6078), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [190632] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8237), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
    STATE(6079), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [190766] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(7986), 1,
      anon_sym_COMMA,
    ACTIONS(8239), 1,
      anon_sym_RPAREN,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    STATE(8645), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6080), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [190904] = 28,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(8068), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8078), 1,
      anon_sym_SLASH,
    ACTIONS(8088), 1,
      anon_sym_GT_GT,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8074), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8076), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8086), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6116), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(6081), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 13,
      anon_sym_in,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [191016] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8118), 1,
      anon_sym_and,
    ACTIONS(8215), 1,
      anon_sym_or,
    STATE(6082), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6609), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6607), 25,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [191100] = 25,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(8068), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8078), 1,
      anon_sym_SLASH,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8076), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6116), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(6083), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 15,
      anon_sym_in,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [191206] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(8068), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8078), 1,
      anon_sym_SLASH,
    ACTIONS(8080), 1,
      anon_sym_CARET,
    ACTIONS(8082), 1,
      anon_sym_PIPE,
    ACTIONS(8084), 1,
      anon_sym_AMP,
    ACTIONS(8088), 1,
      anon_sym_GT_GT,
    ACTIONS(8094), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8100), 1,
      anon_sym_as,
    ACTIONS(8102), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8070), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8074), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8076), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8086), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8090), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8092), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 5,
      anon_sym_in,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(6084), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [191336] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(8068), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8078), 1,
      anon_sym_SLASH,
    ACTIONS(8084), 1,
      anon_sym_AMP,
    ACTIONS(8088), 1,
      anon_sym_GT_GT,
    ACTIONS(8100), 1,
      anon_sym_as,
    ACTIONS(8102), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6116), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(8070), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8074), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8076), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8086), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8090), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8092), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 7,
      anon_sym_in,
      anon_sym_CARET,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(6085), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [191460] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4547), 1,
      anon_sym_LBRACK,
    ACTIONS(4553), 1,
      anon_sym_STAR,
    ACTIONS(5389), 1,
      anon_sym_QMARK,
    ACTIONS(8241), 1,
      anon_sym_DOT,
    STATE(6086), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4422), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(4424), 25,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [191548] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8241), 1,
      anon_sym_DOT,
    STATE(6087), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4426), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(4428), 27,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [191630] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_switch,
    ACTIONS(6963), 1,
      anon_sym_with,
    ACTIONS(8068), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8078), 1,
      anon_sym_SLASH,
    ACTIONS(8080), 1,
      anon_sym_CARET,
    ACTIONS(8084), 1,
      anon_sym_AMP,
    ACTIONS(8088), 1,
      anon_sym_GT_GT,
    ACTIONS(8100), 1,
      anon_sym_as,
    ACTIONS(8102), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6116), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(8070), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8074), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8076), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8086), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8090), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8092), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 6,
      anon_sym_in,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(6088), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [191756] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(8245), 1,
      anon_sym_QMARK,
    ACTIONS(8251), 1,
      anon_sym_SLASH,
    ACTIONS(8253), 1,
      anon_sym_CARET,
    ACTIONS(8255), 1,
      anon_sym_PIPE,
    ACTIONS(8257), 1,
      anon_sym_AMP,
    ACTIONS(8261), 1,
      anon_sym_GT_GT,
    ACTIONS(8267), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8269), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8271), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8273), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8275), 1,
      anon_sym_as,
    ACTIONS(8277), 1,
      anon_sym_is,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6216), 2,
      anon_sym_into,
      anon_sym_on,
    ACTIONS(8243), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8247), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8249), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8259), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8263), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8265), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6089), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [191889] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8279), 1,
      sym__identifier_token,
    ACTIONS(8283), 1,
      anon_sym_LPAREN,
    ACTIONS(8285), 1,
      anon_sym_BANG,
    ACTIONS(8289), 1,
      anon_sym_SQUOTE,
    ACTIONS(8291), 1,
      sym_integer_literal,
    STATE(7840), 1,
      sym__reserved_identifier,
    STATE(8047), 1,
      sym__preproc_expression,
    ACTIONS(8287), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(8065), 6,
      sym_character_literal,
      sym_boolean_literal,
      sym_identifier,
      sym_preproc_parenthesized_expression,
      sym_preproc_unary_expression,
      sym_preproc_binary_expression,
    STATE(6090), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(8281), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [191984] = 25,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4275), 1,
      anon_sym_COLON,
    ACTIONS(4277), 1,
      anon_sym_LBRACE,
    ACTIONS(4295), 1,
      sym_discard,
    ACTIONS(7333), 1,
      sym__identifier_token,
    ACTIONS(7337), 1,
      anon_sym_LPAREN,
    STATE(3127), 1,
      sym__reserved_identifier,
    STATE(4259), 1,
      sym_identifier,
    STATE(4260), 1,
      sym__variable_designation,
    STATE(4274), 1,
      sym_parenthesized_variable_designation,
    STATE(6656), 1,
      sym_positional_pattern_clause,
    STATE(6731), 1,
      sym_property_pattern_clause,
    STATE(9359), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    ACTIONS(4279), 3,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
    STATE(6091), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7335), 21,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [192089] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(6695), 1,
      anon_sym_as,
    ACTIONS(8299), 1,
      anon_sym_SLASH,
    ACTIONS(8301), 1,
      anon_sym_CARET,
    ACTIONS(8303), 1,
      anon_sym_PIPE,
    ACTIONS(8305), 1,
      anon_sym_AMP,
    ACTIONS(8309), 1,
      anon_sym_GT_GT,
    ACTIONS(8315), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8317), 1,
      anon_sym_is,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8293), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8295), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8297), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8307), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8311), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8313), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 5,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
    STATE(6092), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [192216] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8319), 1,
      anon_sym_and,
    ACTIONS(8321), 1,
      anon_sym_or,
    STATE(6093), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5856), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5854), 24,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [192299] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8323), 1,
      anon_sym_and,
    ACTIONS(8325), 1,
      anon_sym_or,
    STATE(6094), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6609), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6607), 24,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [192382] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8327), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(6095), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [192515] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(8329), 1,
      anon_sym_DOT_DOT,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(6096), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1147), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(1133), 18,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [192612] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8323), 1,
      anon_sym_and,
    STATE(6097), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6546), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6544), 25,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [192693] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8331), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(6098), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [192826] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(6695), 1,
      anon_sym_as,
    ACTIONS(8299), 1,
      anon_sym_SLASH,
    ACTIONS(8301), 1,
      anon_sym_CARET,
    ACTIONS(8303), 1,
      anon_sym_PIPE,
    ACTIONS(8305), 1,
      anon_sym_AMP,
    ACTIONS(8309), 1,
      anon_sym_GT_GT,
    ACTIONS(8315), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8317), 1,
      anon_sym_is,
    ACTIONS(8333), 1,
      anon_sym_QMARK,
    ACTIONS(8335), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8337), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8339), 1,
      anon_sym_QMARK_QMARK,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5337), 2,
      anon_sym_EQ_GT,
      anon_sym_into,
    ACTIONS(8293), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8295), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8297), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8307), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8311), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8313), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6099), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [192959] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8323), 1,
      anon_sym_and,
    ACTIONS(8325), 1,
      anon_sym_or,
    STATE(6100), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5856), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5854), 24,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [193042] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(8329), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8343), 1,
      anon_sym_QMARK,
    ACTIONS(8349), 1,
      anon_sym_SLASH,
    ACTIONS(8351), 1,
      anon_sym_CARET,
    ACTIONS(8353), 1,
      anon_sym_PIPE,
    ACTIONS(8355), 1,
      anon_sym_AMP,
    ACTIONS(8359), 1,
      anon_sym_GT_GT,
    ACTIONS(8365), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8367), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8369), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8371), 1,
      anon_sym_as,
    ACTIONS(8373), 1,
      anon_sym_is,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6220), 2,
      anon_sym_into,
      anon_sym_by,
    ACTIONS(8341), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8345), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8347), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8357), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8361), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8363), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6101), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [193175] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(6695), 1,
      anon_sym_as,
    ACTIONS(8299), 1,
      anon_sym_SLASH,
    ACTIONS(8301), 1,
      anon_sym_CARET,
    ACTIONS(8303), 1,
      anon_sym_PIPE,
    ACTIONS(8305), 1,
      anon_sym_AMP,
    ACTIONS(8309), 1,
      anon_sym_GT_GT,
    ACTIONS(8315), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8317), 1,
      anon_sym_is,
    ACTIONS(8333), 1,
      anon_sym_QMARK,
    ACTIONS(8335), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8337), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8339), 1,
      anon_sym_QMARK_QMARK,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5385), 2,
      anon_sym_EQ_GT,
      anon_sym_into,
    ACTIONS(8293), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8295), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8297), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8307), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8311), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8313), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6102), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [193308] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(6695), 1,
      anon_sym_as,
    ACTIONS(8299), 1,
      anon_sym_SLASH,
    ACTIONS(8301), 1,
      anon_sym_CARET,
    ACTIONS(8303), 1,
      anon_sym_PIPE,
    ACTIONS(8305), 1,
      anon_sym_AMP,
    ACTIONS(8309), 1,
      anon_sym_GT_GT,
    ACTIONS(8315), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8317), 1,
      anon_sym_is,
    ACTIONS(8333), 1,
      anon_sym_QMARK,
    ACTIONS(8335), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8337), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8339), 1,
      anon_sym_QMARK_QMARK,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5396), 2,
      anon_sym_EQ_GT,
      anon_sym_into,
    ACTIONS(8293), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8295), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8297), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8307), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8311), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8313), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6103), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [193441] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8375), 1,
      anon_sym_and,
    STATE(6104), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6546), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6544), 25,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_when,
      anon_sym_DOT_DOT,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [193522] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(7950), 1,
      anon_sym_SLASH,
    ACTIONS(7954), 1,
      anon_sym_GT_GT,
    ACTIONS(7956), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7960), 1,
      anon_sym_AMP,
    ACTIONS(7966), 1,
      anon_sym_CARET,
    ACTIONS(7970), 1,
      anon_sym_PIPE,
    ACTIONS(7972), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7974), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7976), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7980), 1,
      anon_sym_QMARK,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7946), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7948), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7952), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7958), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7962), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7964), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8189), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(6105), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [193655] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(6695), 1,
      anon_sym_as,
    ACTIONS(8299), 1,
      anon_sym_SLASH,
    ACTIONS(8301), 1,
      anon_sym_CARET,
    ACTIONS(8303), 1,
      anon_sym_PIPE,
    ACTIONS(8305), 1,
      anon_sym_AMP,
    ACTIONS(8309), 1,
      anon_sym_GT_GT,
    ACTIONS(8315), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8317), 1,
      anon_sym_is,
    ACTIONS(8333), 1,
      anon_sym_QMARK,
    ACTIONS(8335), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8337), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8339), 1,
      anon_sym_QMARK_QMARK,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6216), 2,
      anon_sym_EQ_GT,
      anon_sym_into,
    ACTIONS(8293), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8295), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8297), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8307), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8311), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8313), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6106), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [193788] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(6695), 1,
      anon_sym_as,
    ACTIONS(8299), 1,
      anon_sym_SLASH,
    ACTIONS(8301), 1,
      anon_sym_CARET,
    ACTIONS(8303), 1,
      anon_sym_PIPE,
    ACTIONS(8305), 1,
      anon_sym_AMP,
    ACTIONS(8309), 1,
      anon_sym_GT_GT,
    ACTIONS(8315), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8317), 1,
      anon_sym_is,
    ACTIONS(8333), 1,
      anon_sym_QMARK,
    ACTIONS(8335), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8337), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8339), 1,
      anon_sym_QMARK_QMARK,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5325), 2,
      anon_sym_EQ_GT,
      anon_sym_into,
    ACTIONS(8293), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8295), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8297), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8307), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8311), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8313), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6107), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [193921] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(6695), 1,
      anon_sym_as,
    ACTIONS(8299), 1,
      anon_sym_SLASH,
    ACTIONS(8301), 1,
      anon_sym_CARET,
    ACTIONS(8303), 1,
      anon_sym_PIPE,
    ACTIONS(8305), 1,
      anon_sym_AMP,
    ACTIONS(8309), 1,
      anon_sym_GT_GT,
    ACTIONS(8315), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8317), 1,
      anon_sym_is,
    ACTIONS(8333), 1,
      anon_sym_QMARK,
    ACTIONS(8335), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8337), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8339), 1,
      anon_sym_QMARK_QMARK,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5510), 2,
      anon_sym_EQ_GT,
      anon_sym_into,
    ACTIONS(8293), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8295), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8297), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8307), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8311), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8313), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6108), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [194054] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(8329), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8343), 1,
      anon_sym_QMARK,
    ACTIONS(8349), 1,
      anon_sym_SLASH,
    ACTIONS(8351), 1,
      anon_sym_CARET,
    ACTIONS(8353), 1,
      anon_sym_PIPE,
    ACTIONS(8355), 1,
      anon_sym_AMP,
    ACTIONS(8359), 1,
      anon_sym_GT_GT,
    ACTIONS(8365), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8367), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8369), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8371), 1,
      anon_sym_as,
    ACTIONS(8373), 1,
      anon_sym_is,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6274), 2,
      anon_sym_into,
      anon_sym_by,
    ACTIONS(8341), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8345), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8347), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8357), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8361), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8363), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6109), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [194187] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(6695), 1,
      anon_sym_as,
    ACTIONS(8299), 1,
      anon_sym_SLASH,
    ACTIONS(8301), 1,
      anon_sym_CARET,
    ACTIONS(8303), 1,
      anon_sym_PIPE,
    ACTIONS(8305), 1,
      anon_sym_AMP,
    ACTIONS(8309), 1,
      anon_sym_GT_GT,
    ACTIONS(8315), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8317), 1,
      anon_sym_is,
    ACTIONS(8333), 1,
      anon_sym_QMARK,
    ACTIONS(8335), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8337), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8339), 1,
      anon_sym_QMARK_QMARK,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5420), 2,
      anon_sym_EQ_GT,
      anon_sym_into,
    ACTIONS(8293), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8295), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8297), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8307), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8311), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8313), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6110), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [194320] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(6695), 1,
      anon_sym_as,
    ACTIONS(8299), 1,
      anon_sym_SLASH,
    ACTIONS(8301), 1,
      anon_sym_CARET,
    ACTIONS(8303), 1,
      anon_sym_PIPE,
    ACTIONS(8305), 1,
      anon_sym_AMP,
    ACTIONS(8309), 1,
      anon_sym_GT_GT,
    ACTIONS(8315), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8317), 1,
      anon_sym_is,
    ACTIONS(8333), 1,
      anon_sym_QMARK,
    ACTIONS(8335), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8337), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8339), 1,
      anon_sym_QMARK_QMARK,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6230), 2,
      anon_sym_EQ_GT,
      anon_sym_into,
    ACTIONS(8293), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8295), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8297), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8307), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8311), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8313), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6111), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [194453] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4739), 4,
      anon_sym_COLON,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
    STATE(6112), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5488), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5486), 22,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [194534] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4739), 4,
      anon_sym_COLON,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
    STATE(6113), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5480), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5478), 22,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [194615] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(8315), 1,
      anon_sym_DOT_DOT,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(6114), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1147), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(1133), 18,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [194712] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8377), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(6115), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [194845] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8379), 1,
      anon_sym_and,
    STATE(6116), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6546), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6544), 25,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_when,
      anon_sym_DOT_DOT,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [194926] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(6695), 1,
      anon_sym_as,
    ACTIONS(8299), 1,
      anon_sym_SLASH,
    ACTIONS(8301), 1,
      anon_sym_CARET,
    ACTIONS(8303), 1,
      anon_sym_PIPE,
    ACTIONS(8305), 1,
      anon_sym_AMP,
    ACTIONS(8309), 1,
      anon_sym_GT_GT,
    ACTIONS(8315), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8317), 1,
      anon_sym_is,
    ACTIONS(8335), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8337), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8339), 1,
      anon_sym_QMARK_QMARK,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6114), 2,
      anon_sym_EQ_GT,
      anon_sym_into,
    ACTIONS(8293), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8295), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8297), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8307), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8311), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8313), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6117), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [195059] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8381), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(6118), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [195192] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(6695), 1,
      anon_sym_as,
    ACTIONS(8299), 1,
      anon_sym_SLASH,
    ACTIONS(8301), 1,
      anon_sym_CARET,
    ACTIONS(8303), 1,
      anon_sym_PIPE,
    ACTIONS(8305), 1,
      anon_sym_AMP,
    ACTIONS(8309), 1,
      anon_sym_GT_GT,
    ACTIONS(8315), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8317), 1,
      anon_sym_is,
    ACTIONS(8335), 1,
      anon_sym_AMP_AMP,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8293), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8295), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8297), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8307), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8311), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8313), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 4,
      anon_sym_EQ_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
    STATE(6119), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [195321] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8383), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(6120), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [195454] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(8299), 1,
      anon_sym_SLASH,
    ACTIONS(8315), 1,
      anon_sym_DOT_DOT,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8295), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8297), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6116), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(6121), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 14,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
  [195561] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(8315), 1,
      anon_sym_DOT_DOT,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(6122), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6116), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6114), 16,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
  [195662] = 25,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(8299), 1,
      anon_sym_SLASH,
    ACTIONS(8315), 1,
      anon_sym_DOT_DOT,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8297), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6116), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(6123), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 14,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
  [195767] = 28,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(8299), 1,
      anon_sym_SLASH,
    ACTIONS(8309), 1,
      anon_sym_GT_GT,
    ACTIONS(8315), 1,
      anon_sym_DOT_DOT,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8295), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8297), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8307), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6116), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(6124), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 12,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
  [195878] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8279), 1,
      sym__identifier_token,
    ACTIONS(8283), 1,
      anon_sym_LPAREN,
    ACTIONS(8285), 1,
      anon_sym_BANG,
    ACTIONS(8289), 1,
      anon_sym_SQUOTE,
    ACTIONS(8291), 1,
      sym_integer_literal,
    STATE(7840), 1,
      sym__reserved_identifier,
    STATE(8103), 1,
      sym__preproc_expression,
    ACTIONS(8287), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(8065), 6,
      sym_character_literal,
      sym_boolean_literal,
      sym_identifier,
      sym_preproc_parenthesized_expression,
      sym_preproc_unary_expression,
      sym_preproc_binary_expression,
    STATE(6125), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(8281), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [195973] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(8329), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8343), 1,
      anon_sym_QMARK,
    ACTIONS(8349), 1,
      anon_sym_SLASH,
    ACTIONS(8351), 1,
      anon_sym_CARET,
    ACTIONS(8353), 1,
      anon_sym_PIPE,
    ACTIONS(8355), 1,
      anon_sym_AMP,
    ACTIONS(8359), 1,
      anon_sym_GT_GT,
    ACTIONS(8365), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8367), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8369), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8371), 1,
      anon_sym_as,
    ACTIONS(8373), 1,
      anon_sym_is,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6284), 2,
      anon_sym_into,
      anon_sym_by,
    ACTIONS(8341), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8345), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8347), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8357), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8361), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8363), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6126), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [196106] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(8315), 1,
      anon_sym_DOT_DOT,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(6127), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6122), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6120), 18,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [196203] = 25,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4275), 1,
      anon_sym_COLON,
    ACTIONS(4277), 1,
      anon_sym_LBRACE,
    ACTIONS(4295), 1,
      sym_discard,
    ACTIONS(7333), 1,
      sym__identifier_token,
    ACTIONS(7337), 1,
      anon_sym_LPAREN,
    STATE(3127), 1,
      sym__reserved_identifier,
    STATE(4259), 1,
      sym_identifier,
    STATE(4260), 1,
      sym__variable_designation,
    STATE(4274), 1,
      sym_parenthesized_variable_designation,
    STATE(6656), 1,
      sym_positional_pattern_clause,
    STATE(6731), 1,
      sym_property_pattern_clause,
    STATE(9127), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    ACTIONS(4279), 3,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
    STATE(6128), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7335), 21,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [196308] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8279), 1,
      sym__identifier_token,
    ACTIONS(8283), 1,
      anon_sym_LPAREN,
    ACTIONS(8285), 1,
      anon_sym_BANG,
    ACTIONS(8289), 1,
      anon_sym_SQUOTE,
    ACTIONS(8291), 1,
      sym_integer_literal,
    STATE(7840), 1,
      sym__reserved_identifier,
    STATE(8122), 1,
      sym__preproc_expression,
    ACTIONS(8287), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(8065), 6,
      sym_character_literal,
      sym_boolean_literal,
      sym_identifier,
      sym_preproc_parenthesized_expression,
      sym_preproc_unary_expression,
      sym_preproc_binary_expression,
    STATE(6129), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(8281), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [196403] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(7950), 1,
      anon_sym_SLASH,
    ACTIONS(7954), 1,
      anon_sym_GT_GT,
    ACTIONS(7956), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7960), 1,
      anon_sym_AMP,
    ACTIONS(7966), 1,
      anon_sym_CARET,
    ACTIONS(7970), 1,
      anon_sym_PIPE,
    ACTIONS(7972), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7974), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7976), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7980), 1,
      anon_sym_QMARK,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7946), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7948), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7952), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7958), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7962), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7964), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8377), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(6130), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [196536] = 32,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(6695), 1,
      anon_sym_as,
    ACTIONS(8299), 1,
      anon_sym_SLASH,
    ACTIONS(8309), 1,
      anon_sym_GT_GT,
    ACTIONS(8315), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8317), 1,
      anon_sym_is,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8293), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8295), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8297), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8307), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8313), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6116), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(6114), 8,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
    STATE(6131), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [196655] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(6695), 1,
      anon_sym_as,
    ACTIONS(8299), 1,
      anon_sym_SLASH,
    ACTIONS(8309), 1,
      anon_sym_GT_GT,
    ACTIONS(8315), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8317), 1,
      anon_sym_is,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8293), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8295), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8297), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8307), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8311), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8313), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6116), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(6114), 6,
      anon_sym_CARET,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
    STATE(6132), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [196776] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(7950), 1,
      anon_sym_SLASH,
    ACTIONS(7954), 1,
      anon_sym_GT_GT,
    ACTIONS(7956), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7960), 1,
      anon_sym_AMP,
    ACTIONS(7966), 1,
      anon_sym_CARET,
    ACTIONS(7970), 1,
      anon_sym_PIPE,
    ACTIONS(7972), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7974), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7976), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7980), 1,
      anon_sym_QMARK,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7946), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7948), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7952), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7958), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7962), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7964), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8381), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(6133), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [196909] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(8116), 1,
      anon_sym_COMMA,
    ACTIONS(8385), 1,
      anon_sym_RPAREN,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6134), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [197044] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(8116), 1,
      anon_sym_COMMA,
    ACTIONS(8387), 1,
      anon_sym_RPAREN,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6135), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [197179] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(6695), 1,
      anon_sym_as,
    ACTIONS(8299), 1,
      anon_sym_SLASH,
    ACTIONS(8301), 1,
      anon_sym_CARET,
    ACTIONS(8305), 1,
      anon_sym_AMP,
    ACTIONS(8309), 1,
      anon_sym_GT_GT,
    ACTIONS(8315), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8317), 1,
      anon_sym_is,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6116), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(8293), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8295), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8297), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8307), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8311), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8313), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 5,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
    STATE(6136), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [197304] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(6695), 1,
      anon_sym_as,
    ACTIONS(8299), 1,
      anon_sym_SLASH,
    ACTIONS(8305), 1,
      anon_sym_AMP,
    ACTIONS(8309), 1,
      anon_sym_GT_GT,
    ACTIONS(8315), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8317), 1,
      anon_sym_is,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6116), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(8293), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8295), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8297), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8307), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8311), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8313), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 6,
      anon_sym_CARET,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
    STATE(6137), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [197427] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(6695), 1,
      anon_sym_as,
    ACTIONS(8299), 1,
      anon_sym_SLASH,
    ACTIONS(8301), 1,
      anon_sym_CARET,
    ACTIONS(8303), 1,
      anon_sym_PIPE,
    ACTIONS(8305), 1,
      anon_sym_AMP,
    ACTIONS(8309), 1,
      anon_sym_GT_GT,
    ACTIONS(8315), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8317), 1,
      anon_sym_is,
    ACTIONS(8333), 1,
      anon_sym_QMARK,
    ACTIONS(8335), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8337), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8339), 1,
      anon_sym_QMARK_QMARK,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6236), 2,
      anon_sym_EQ_GT,
      anon_sym_into,
    ACTIONS(8293), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8295), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8297), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8307), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8311), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8313), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6138), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [197560] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8389), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(6139), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [197693] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8279), 1,
      sym__identifier_token,
    ACTIONS(8283), 1,
      anon_sym_LPAREN,
    ACTIONS(8285), 1,
      anon_sym_BANG,
    ACTIONS(8289), 1,
      anon_sym_SQUOTE,
    ACTIONS(8291), 1,
      sym_integer_literal,
    STATE(7840), 1,
      sym__reserved_identifier,
    STATE(8158), 1,
      sym__preproc_expression,
    ACTIONS(8287), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(8065), 6,
      sym_character_literal,
      sym_boolean_literal,
      sym_identifier,
      sym_preproc_parenthesized_expression,
      sym_preproc_unary_expression,
      sym_preproc_binary_expression,
    STATE(6140), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(8281), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [197788] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4277), 1,
      anon_sym_LBRACE,
    ACTIONS(4295), 1,
      sym_discard,
    ACTIONS(7333), 1,
      sym__identifier_token,
    ACTIONS(8391), 1,
      anon_sym_LPAREN,
    STATE(3127), 1,
      sym__reserved_identifier,
    STATE(4256), 1,
      sym__variable_designation,
    STATE(4269), 1,
      sym_identifier,
    STATE(4274), 1,
      sym_parenthesized_variable_designation,
    STATE(6708), 1,
      sym_property_pattern_clause,
    ACTIONS(4331), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(4329), 4,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    STATE(6141), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7335), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [197887] = 25,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4275), 1,
      anon_sym_COMMA,
    ACTIONS(4277), 1,
      anon_sym_LBRACE,
    ACTIONS(4295), 1,
      sym_discard,
    ACTIONS(7333), 1,
      sym__identifier_token,
    ACTIONS(7337), 1,
      anon_sym_LPAREN,
    STATE(3127), 1,
      sym__reserved_identifier,
    STATE(4260), 1,
      sym__variable_designation,
    STATE(4274), 1,
      sym_parenthesized_variable_designation,
    STATE(6162), 1,
      sym_positional_pattern_clause,
    STATE(6695), 1,
      sym_property_pattern_clause,
    STATE(7879), 1,
      sym_identifier,
    STATE(9359), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    ACTIONS(4279), 2,
      anon_sym_and,
      anon_sym_or,
    STATE(6142), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7335), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [197992] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5792), 1,
      anon_sym_COLON,
    ACTIONS(4739), 3,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
    STATE(6143), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5488), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5486), 22,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [198075] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5786), 1,
      anon_sym_COLON,
    ACTIONS(4739), 3,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
    STATE(6144), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5480), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5478), 22,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [198158] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(6990), 1,
      anon_sym_SLASH,
    ACTIONS(6992), 1,
      anon_sym_AMP,
    ACTIONS(6996), 1,
      anon_sym_GT_GT,
    ACTIONS(7012), 1,
      anon_sym_CARET,
    ACTIONS(7014), 1,
      anon_sym_PIPE,
    ACTIONS(7016), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7018), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7020), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7621), 1,
      anon_sym_QMARK,
    ACTIONS(7643), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7651), 1,
      anon_sym_as,
    ACTIONS(7653), 1,
      anon_sym_is,
    ACTIONS(7773), 1,
      anon_sym_COLON,
    ACTIONS(8116), 1,
      anon_sym_COMMA,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6984), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6986), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6988), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6994), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6998), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7000), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6145), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [198293] = 25,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4275), 1,
      anon_sym_EQ_GT,
    ACTIONS(4277), 1,
      anon_sym_LBRACE,
    ACTIONS(4295), 1,
      sym_discard,
    ACTIONS(7333), 1,
      sym__identifier_token,
    ACTIONS(8393), 1,
      anon_sym_LPAREN,
    STATE(3127), 1,
      sym__reserved_identifier,
    STATE(4260), 1,
      sym__variable_designation,
    STATE(4274), 1,
      sym_parenthesized_variable_designation,
    STATE(5933), 1,
      sym_identifier,
    STATE(6656), 1,
      sym_positional_pattern_clause,
    STATE(6731), 1,
      sym_property_pattern_clause,
    STATE(9127), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    ACTIONS(4279), 3,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
    STATE(6146), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7335), 21,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [198398] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8279), 1,
      sym__identifier_token,
    ACTIONS(8283), 1,
      anon_sym_LPAREN,
    ACTIONS(8285), 1,
      anon_sym_BANG,
    ACTIONS(8289), 1,
      anon_sym_SQUOTE,
    ACTIONS(8291), 1,
      sym_integer_literal,
    STATE(7840), 1,
      sym__reserved_identifier,
    STATE(8163), 1,
      sym__preproc_expression,
    ACTIONS(8287), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(8065), 6,
      sym_character_literal,
      sym_boolean_literal,
      sym_identifier,
      sym_preproc_parenthesized_expression,
      sym_preproc_unary_expression,
      sym_preproc_binary_expression,
    STATE(6147), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(8281), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [198493] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(139), 1,
      anon_sym_SQUOTE,
    ACTIONS(8395), 1,
      anon_sym_LPAREN,
    ACTIONS(8397), 1,
      anon_sym_BANG,
    ACTIONS(8399), 1,
      sym_integer_literal,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(8050), 1,
      sym__preproc_expression,
    ACTIONS(75), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(8179), 6,
      sym_character_literal,
      sym_boolean_literal,
      sym_identifier,
      sym_preproc_parenthesized_expression,
      sym_preproc_unary_expression,
      sym_preproc_binary_expression,
    STATE(6148), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [198588] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(8403), 1,
      anon_sym_QMARK,
    ACTIONS(8409), 1,
      anon_sym_SLASH,
    ACTIONS(8411), 1,
      anon_sym_CARET,
    ACTIONS(8413), 1,
      anon_sym_PIPE,
    ACTIONS(8415), 1,
      anon_sym_AMP,
    ACTIONS(8419), 1,
      anon_sym_GT_GT,
    ACTIONS(8425), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8427), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8429), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8431), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8433), 1,
      anon_sym_as,
    ACTIONS(8435), 1,
      anon_sym_is,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6284), 2,
      anon_sym_into,
      anon_sym_equals,
    ACTIONS(8401), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8405), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8407), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8417), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8421), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8423), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6149), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [198721] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8437), 1,
      anon_sym_SEMI,
    STATE(6150), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5480), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5478), 25,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [198802] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8279), 1,
      sym__identifier_token,
    ACTIONS(8283), 1,
      anon_sym_LPAREN,
    ACTIONS(8285), 1,
      anon_sym_BANG,
    ACTIONS(8289), 1,
      anon_sym_SQUOTE,
    ACTIONS(8291), 1,
      sym_integer_literal,
    STATE(7840), 1,
      sym__reserved_identifier,
    STATE(8181), 1,
      sym__preproc_expression,
    ACTIONS(8287), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(8065), 6,
      sym_character_literal,
      sym_boolean_literal,
      sym_identifier,
      sym_preproc_parenthesized_expression,
      sym_preproc_unary_expression,
      sym_preproc_binary_expression,
    STATE(6151), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(8281), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [198897] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8439), 1,
      anon_sym_DOT,
    STATE(6152), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4426), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(4428), 26,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [198978] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8441), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    STATE(6153), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [199111] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(7950), 1,
      anon_sym_SLASH,
    ACTIONS(7954), 1,
      anon_sym_GT_GT,
    ACTIONS(7956), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7960), 1,
      anon_sym_AMP,
    ACTIONS(7966), 1,
      anon_sym_CARET,
    ACTIONS(7970), 1,
      anon_sym_PIPE,
    ACTIONS(7972), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7974), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7976), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7980), 1,
      anon_sym_QMARK,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7946), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7948), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7952), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7958), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7962), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7964), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8327), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(6154), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [199244] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8279), 1,
      sym__identifier_token,
    ACTIONS(8283), 1,
      anon_sym_LPAREN,
    ACTIONS(8285), 1,
      anon_sym_BANG,
    ACTIONS(8289), 1,
      anon_sym_SQUOTE,
    ACTIONS(8291), 1,
      sym_integer_literal,
    STATE(7840), 1,
      sym__reserved_identifier,
    STATE(7976), 1,
      sym__preproc_expression,
    ACTIONS(8287), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(8065), 6,
      sym_character_literal,
      sym_boolean_literal,
      sym_identifier,
      sym_preproc_parenthesized_expression,
      sym_preproc_unary_expression,
      sym_preproc_binary_expression,
    STATE(6155), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(8281), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [199339] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(8116), 1,
      anon_sym_COMMA,
    ACTIONS(8443), 1,
      anon_sym_RPAREN,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6156), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [199474] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8445), 1,
      anon_sym_and,
    ACTIONS(8447), 1,
      anon_sym_or,
    STATE(6157), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5856), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5854), 24,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [199557] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8445), 1,
      anon_sym_and,
    STATE(6158), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6546), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6544), 25,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [199638] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(7950), 1,
      anon_sym_SLASH,
    ACTIONS(7954), 1,
      anon_sym_GT_GT,
    ACTIONS(7956), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7960), 1,
      anon_sym_AMP,
    ACTIONS(7966), 1,
      anon_sym_CARET,
    ACTIONS(7970), 1,
      anon_sym_PIPE,
    ACTIONS(7972), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7974), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7976), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7980), 1,
      anon_sym_QMARK,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7946), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7948), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7952), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7958), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7962), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7964), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8331), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(6159), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [199771] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8449), 1,
      anon_sym_DOT,
    ACTIONS(4428), 8,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
    STATE(6160), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4426), 28,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_operator,
      anon_sym_this,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [199852] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4547), 1,
      anon_sym_LBRACK,
    ACTIONS(4553), 1,
      anon_sym_STAR,
    ACTIONS(5758), 1,
      anon_sym_QMARK,
    ACTIONS(8439), 1,
      anon_sym_DOT,
    STATE(6161), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4422), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(4424), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [199939] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4277), 1,
      anon_sym_LBRACE,
    ACTIONS(4295), 1,
      sym_discard,
    ACTIONS(7333), 1,
      sym__identifier_token,
    ACTIONS(8391), 1,
      anon_sym_LPAREN,
    STATE(3127), 1,
      sym__reserved_identifier,
    STATE(4124), 1,
      sym__variable_designation,
    STATE(4269), 1,
      sym_identifier,
    STATE(4274), 1,
      sym_parenthesized_variable_designation,
    STATE(6671), 1,
      sym_property_pattern_clause,
    ACTIONS(4337), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(4335), 4,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    STATE(6162), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7335), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [200038] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8279), 1,
      sym__identifier_token,
    ACTIONS(8283), 1,
      anon_sym_LPAREN,
    ACTIONS(8285), 1,
      anon_sym_BANG,
    ACTIONS(8289), 1,
      anon_sym_SQUOTE,
    ACTIONS(8291), 1,
      sym_integer_literal,
    STATE(7840), 1,
      sym__reserved_identifier,
    STATE(7984), 1,
      sym__preproc_expression,
    ACTIONS(8287), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(8065), 6,
      sym_character_literal,
      sym_boolean_literal,
      sym_identifier,
      sym_preproc_parenthesized_expression,
      sym_preproc_unary_expression,
      sym_preproc_binary_expression,
    STATE(6163), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(8281), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [200133] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8279), 1,
      sym__identifier_token,
    ACTIONS(8283), 1,
      anon_sym_LPAREN,
    ACTIONS(8285), 1,
      anon_sym_BANG,
    ACTIONS(8289), 1,
      anon_sym_SQUOTE,
    ACTIONS(8291), 1,
      sym_integer_literal,
    STATE(7840), 1,
      sym__reserved_identifier,
    STATE(7959), 1,
      sym__preproc_expression,
    ACTIONS(8287), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(8065), 6,
      sym_character_literal,
      sym_boolean_literal,
      sym_identifier,
      sym_preproc_parenthesized_expression,
      sym_preproc_unary_expression,
      sym_preproc_binary_expression,
    STATE(6164), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(8281), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [200228] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4953), 1,
      anon_sym_DASH_GT,
    ACTIONS(5067), 1,
      anon_sym_DOT,
    ACTIONS(6973), 1,
      anon_sym_LPAREN,
    ACTIONS(7022), 1,
      anon_sym_LBRACK,
    ACTIONS(7026), 1,
      anon_sym_BANG,
    ACTIONS(7042), 1,
      anon_sym_switch,
    ACTIONS(7050), 1,
      anon_sym_with,
    ACTIONS(7234), 1,
      anon_sym_as,
    ACTIONS(7349), 1,
      anon_sym_QMARK,
    ACTIONS(7355), 1,
      anon_sym_SLASH,
    ACTIONS(7357), 1,
      anon_sym_CARET,
    ACTIONS(7359), 1,
      anon_sym_PIPE,
    ACTIONS(7361), 1,
      anon_sym_AMP,
    ACTIONS(7365), 1,
      anon_sym_GT_GT,
    ACTIONS(7371), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7373), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7375), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7377), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7379), 1,
      anon_sym_is,
    STATE(3870), 1,
      sym_bracketed_argument_list,
    STATE(5721), 1,
      sym_argument_list,
    ACTIONS(7028), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7347), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7351), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7353), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7363), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7367), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7369), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8451), 2,
      sym_interpolation_close_brace,
      anon_sym_COLON,
    STATE(6165), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [200361] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(7250), 1,
      anon_sym_LBRACK,
    ACTIONS(7252), 1,
      anon_sym_STAR,
    ACTIONS(7254), 1,
      anon_sym_QMARK,
    ACTIONS(8453), 1,
      anon_sym_DOT,
    ACTIONS(4424), 6,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
    STATE(6166), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4422), 26,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [200450] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(8251), 1,
      anon_sym_SLASH,
    ACTIONS(8253), 1,
      anon_sym_CARET,
    ACTIONS(8255), 1,
      anon_sym_PIPE,
    ACTIONS(8257), 1,
      anon_sym_AMP,
    ACTIONS(8261), 1,
      anon_sym_GT_GT,
    ACTIONS(8267), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8269), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8271), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8273), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8275), 1,
      anon_sym_as,
    ACTIONS(8277), 1,
      anon_sym_is,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6114), 2,
      anon_sym_into,
      anon_sym_on,
    ACTIONS(8243), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8247), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8249), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8259), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8263), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8265), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6167), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [200583] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(8251), 1,
      anon_sym_SLASH,
    ACTIONS(8253), 1,
      anon_sym_CARET,
    ACTIONS(8255), 1,
      anon_sym_PIPE,
    ACTIONS(8257), 1,
      anon_sym_AMP,
    ACTIONS(8261), 1,
      anon_sym_GT_GT,
    ACTIONS(8267), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8269), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8275), 1,
      anon_sym_as,
    ACTIONS(8277), 1,
      anon_sym_is,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8243), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8247), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8249), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8259), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8263), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8265), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 4,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_on,
    STATE(6168), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [200712] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(8251), 1,
      anon_sym_SLASH,
    ACTIONS(8253), 1,
      anon_sym_CARET,
    ACTIONS(8255), 1,
      anon_sym_PIPE,
    ACTIONS(8257), 1,
      anon_sym_AMP,
    ACTIONS(8261), 1,
      anon_sym_GT_GT,
    ACTIONS(8267), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8275), 1,
      anon_sym_as,
    ACTIONS(8277), 1,
      anon_sym_is,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8243), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8247), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8249), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8259), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8263), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8265), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 5,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_on,
    STATE(6169), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [200839] = 32,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(8251), 1,
      anon_sym_SLASH,
    ACTIONS(8261), 1,
      anon_sym_GT_GT,
    ACTIONS(8267), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8275), 1,
      anon_sym_as,
    ACTIONS(8277), 1,
      anon_sym_is,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8243), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8247), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8249), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8259), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8265), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6116), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(6114), 8,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_on,
    STATE(6170), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [200958] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(8251), 1,
      anon_sym_SLASH,
    ACTIONS(8267), 1,
      anon_sym_DOT_DOT,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8247), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8249), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6116), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(6171), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 14,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
  [201065] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(8251), 1,
      anon_sym_SLASH,
    ACTIONS(8261), 1,
      anon_sym_GT_GT,
    ACTIONS(8267), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8275), 1,
      anon_sym_as,
    ACTIONS(8277), 1,
      anon_sym_is,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8243), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8247), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8249), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8259), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8263), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8265), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6116), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(6114), 6,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_on,
    STATE(6172), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [201186] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(8251), 1,
      anon_sym_SLASH,
    ACTIONS(8253), 1,
      anon_sym_CARET,
    ACTIONS(8257), 1,
      anon_sym_AMP,
    ACTIONS(8261), 1,
      anon_sym_GT_GT,
    ACTIONS(8267), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8275), 1,
      anon_sym_as,
    ACTIONS(8277), 1,
      anon_sym_is,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6116), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(8243), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8247), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8249), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8259), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8263), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8265), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 5,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_on,
    STATE(6173), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [201311] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(8251), 1,
      anon_sym_SLASH,
    ACTIONS(8257), 1,
      anon_sym_AMP,
    ACTIONS(8261), 1,
      anon_sym_GT_GT,
    ACTIONS(8267), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8275), 1,
      anon_sym_as,
    ACTIONS(8277), 1,
      anon_sym_is,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6116), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(8243), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8247), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8249), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8259), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8263), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8265), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 6,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_on,
    STATE(6174), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [201434] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8279), 1,
      sym__identifier_token,
    ACTIONS(8283), 1,
      anon_sym_LPAREN,
    ACTIONS(8285), 1,
      anon_sym_BANG,
    ACTIONS(8289), 1,
      anon_sym_SQUOTE,
    ACTIONS(8291), 1,
      sym_integer_literal,
    STATE(7840), 1,
      sym__reserved_identifier,
    STATE(8208), 1,
      sym__preproc_expression,
    ACTIONS(8287), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(8065), 6,
      sym_character_literal,
      sym_boolean_literal,
      sym_identifier,
      sym_preproc_parenthesized_expression,
      sym_preproc_unary_expression,
      sym_preproc_binary_expression,
    STATE(6175), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(8281), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [201529] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(8267), 1,
      anon_sym_DOT_DOT,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(6176), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6116), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6114), 16,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
  [201630] = 25,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(8251), 1,
      anon_sym_SLASH,
    ACTIONS(8267), 1,
      anon_sym_DOT_DOT,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8249), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6116), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(6177), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 14,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
  [201735] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8379), 1,
      anon_sym_and,
    ACTIONS(8455), 1,
      anon_sym_or,
    STATE(6178), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6609), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6607), 24,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_when,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [201818] = 28,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(8251), 1,
      anon_sym_SLASH,
    ACTIONS(8261), 1,
      anon_sym_GT_GT,
    ACTIONS(8267), 1,
      anon_sym_DOT_DOT,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8247), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8249), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8259), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6116), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(6179), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 12,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
  [201929] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8457), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(6180), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [202062] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8459), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(6181), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [202195] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(8245), 1,
      anon_sym_QMARK,
    ACTIONS(8251), 1,
      anon_sym_SLASH,
    ACTIONS(8253), 1,
      anon_sym_CARET,
    ACTIONS(8255), 1,
      anon_sym_PIPE,
    ACTIONS(8257), 1,
      anon_sym_AMP,
    ACTIONS(8261), 1,
      anon_sym_GT_GT,
    ACTIONS(8267), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8269), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8271), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8273), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8275), 1,
      anon_sym_as,
    ACTIONS(8277), 1,
      anon_sym_is,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5337), 2,
      anon_sym_into,
      anon_sym_on,
    ACTIONS(8243), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8247), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8249), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8259), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8263), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8265), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6182), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [202328] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(8245), 1,
      anon_sym_QMARK,
    ACTIONS(8251), 1,
      anon_sym_SLASH,
    ACTIONS(8253), 1,
      anon_sym_CARET,
    ACTIONS(8255), 1,
      anon_sym_PIPE,
    ACTIONS(8257), 1,
      anon_sym_AMP,
    ACTIONS(8261), 1,
      anon_sym_GT_GT,
    ACTIONS(8267), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8269), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8271), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8273), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8275), 1,
      anon_sym_as,
    ACTIONS(8277), 1,
      anon_sym_is,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5385), 2,
      anon_sym_into,
      anon_sym_on,
    ACTIONS(8243), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8247), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8249), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8259), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8263), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8265), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6183), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [202461] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8445), 1,
      anon_sym_and,
    ACTIONS(8447), 1,
      anon_sym_or,
    STATE(6184), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6609), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6607), 24,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [202544] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(8245), 1,
      anon_sym_QMARK,
    ACTIONS(8251), 1,
      anon_sym_SLASH,
    ACTIONS(8253), 1,
      anon_sym_CARET,
    ACTIONS(8255), 1,
      anon_sym_PIPE,
    ACTIONS(8257), 1,
      anon_sym_AMP,
    ACTIONS(8261), 1,
      anon_sym_GT_GT,
    ACTIONS(8267), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8269), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8271), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8273), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8275), 1,
      anon_sym_as,
    ACTIONS(8277), 1,
      anon_sym_is,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5396), 2,
      anon_sym_into,
      anon_sym_on,
    ACTIONS(8243), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8247), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8249), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8259), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8263), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8265), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6185), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [202677] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(8245), 1,
      anon_sym_QMARK,
    ACTIONS(8251), 1,
      anon_sym_SLASH,
    ACTIONS(8253), 1,
      anon_sym_CARET,
    ACTIONS(8255), 1,
      anon_sym_PIPE,
    ACTIONS(8257), 1,
      anon_sym_AMP,
    ACTIONS(8261), 1,
      anon_sym_GT_GT,
    ACTIONS(8267), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8269), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8271), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8273), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8275), 1,
      anon_sym_as,
    ACTIONS(8277), 1,
      anon_sym_is,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5325), 2,
      anon_sym_into,
      anon_sym_on,
    ACTIONS(8243), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8247), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8249), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8259), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8263), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8265), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6186), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [202810] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(8245), 1,
      anon_sym_QMARK,
    ACTIONS(8251), 1,
      anon_sym_SLASH,
    ACTIONS(8253), 1,
      anon_sym_CARET,
    ACTIONS(8255), 1,
      anon_sym_PIPE,
    ACTIONS(8257), 1,
      anon_sym_AMP,
    ACTIONS(8261), 1,
      anon_sym_GT_GT,
    ACTIONS(8267), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8269), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8271), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8273), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8275), 1,
      anon_sym_as,
    ACTIONS(8277), 1,
      anon_sym_is,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5510), 2,
      anon_sym_into,
      anon_sym_on,
    ACTIONS(8243), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8247), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8249), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8259), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8263), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8265), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6187), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [202943] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(8245), 1,
      anon_sym_QMARK,
    ACTIONS(8251), 1,
      anon_sym_SLASH,
    ACTIONS(8253), 1,
      anon_sym_CARET,
    ACTIONS(8255), 1,
      anon_sym_PIPE,
    ACTIONS(8257), 1,
      anon_sym_AMP,
    ACTIONS(8261), 1,
      anon_sym_GT_GT,
    ACTIONS(8267), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8269), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8271), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8273), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8275), 1,
      anon_sym_as,
    ACTIONS(8277), 1,
      anon_sym_is,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5420), 2,
      anon_sym_into,
      anon_sym_on,
    ACTIONS(8243), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8247), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8249), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8259), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8263), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8265), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6188), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [203076] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(8245), 1,
      anon_sym_QMARK,
    ACTIONS(8251), 1,
      anon_sym_SLASH,
    ACTIONS(8253), 1,
      anon_sym_CARET,
    ACTIONS(8255), 1,
      anon_sym_PIPE,
    ACTIONS(8257), 1,
      anon_sym_AMP,
    ACTIONS(8261), 1,
      anon_sym_GT_GT,
    ACTIONS(8267), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8269), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8271), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8273), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8275), 1,
      anon_sym_as,
    ACTIONS(8277), 1,
      anon_sym_is,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6230), 2,
      anon_sym_into,
      anon_sym_on,
    ACTIONS(8243), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8247), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8249), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8259), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8263), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8265), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6189), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [203209] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(8267), 1,
      anon_sym_DOT_DOT,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(6190), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6122), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6120), 18,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [203306] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(8245), 1,
      anon_sym_QMARK,
    ACTIONS(8251), 1,
      anon_sym_SLASH,
    ACTIONS(8253), 1,
      anon_sym_CARET,
    ACTIONS(8255), 1,
      anon_sym_PIPE,
    ACTIONS(8257), 1,
      anon_sym_AMP,
    ACTIONS(8261), 1,
      anon_sym_GT_GT,
    ACTIONS(8267), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8269), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8271), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8273), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8275), 1,
      anon_sym_as,
    ACTIONS(8277), 1,
      anon_sym_is,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6236), 2,
      anon_sym_into,
      anon_sym_on,
    ACTIONS(8243), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8247), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8249), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8259), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8263), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8265), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6191), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [203439] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(6695), 1,
      anon_sym_as,
    ACTIONS(8299), 1,
      anon_sym_SLASH,
    ACTIONS(8301), 1,
      anon_sym_CARET,
    ACTIONS(8303), 1,
      anon_sym_PIPE,
    ACTIONS(8305), 1,
      anon_sym_AMP,
    ACTIONS(8309), 1,
      anon_sym_GT_GT,
    ACTIONS(8315), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8317), 1,
      anon_sym_is,
    ACTIONS(8333), 1,
      anon_sym_QMARK,
    ACTIONS(8335), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8337), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8339), 1,
      anon_sym_QMARK_QMARK,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6274), 2,
      anon_sym_EQ_GT,
      anon_sym_into,
    ACTIONS(8293), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8295), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8297), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8307), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8311), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8313), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6192), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [203572] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(6695), 1,
      anon_sym_as,
    ACTIONS(8299), 1,
      anon_sym_SLASH,
    ACTIONS(8301), 1,
      anon_sym_CARET,
    ACTIONS(8303), 1,
      anon_sym_PIPE,
    ACTIONS(8305), 1,
      anon_sym_AMP,
    ACTIONS(8309), 1,
      anon_sym_GT_GT,
    ACTIONS(8315), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8317), 1,
      anon_sym_is,
    ACTIONS(8333), 1,
      anon_sym_QMARK,
    ACTIONS(8335), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8337), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8339), 1,
      anon_sym_QMARK_QMARK,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6284), 2,
      anon_sym_EQ_GT,
      anon_sym_into,
    ACTIONS(8293), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8295), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8297), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8307), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8311), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8313), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6193), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [203705] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8279), 1,
      sym__identifier_token,
    ACTIONS(8283), 1,
      anon_sym_LPAREN,
    ACTIONS(8285), 1,
      anon_sym_BANG,
    ACTIONS(8289), 1,
      anon_sym_SQUOTE,
    ACTIONS(8291), 1,
      sym_integer_literal,
    STATE(7840), 1,
      sym__reserved_identifier,
    STATE(8193), 1,
      sym__preproc_expression,
    ACTIONS(8287), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(8065), 6,
      sym_character_literal,
      sym_boolean_literal,
      sym_identifier,
      sym_preproc_parenthesized_expression,
      sym_preproc_unary_expression,
      sym_preproc_binary_expression,
    STATE(6194), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(8281), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [203800] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8461), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(6195), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [203933] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(8329), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8343), 1,
      anon_sym_QMARK,
    ACTIONS(8349), 1,
      anon_sym_SLASH,
    ACTIONS(8351), 1,
      anon_sym_CARET,
    ACTIONS(8353), 1,
      anon_sym_PIPE,
    ACTIONS(8355), 1,
      anon_sym_AMP,
    ACTIONS(8359), 1,
      anon_sym_GT_GT,
    ACTIONS(8365), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8367), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8369), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8371), 1,
      anon_sym_as,
    ACTIONS(8373), 1,
      anon_sym_is,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6236), 2,
      anon_sym_into,
      anon_sym_by,
    ACTIONS(8341), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8345), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8347), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8357), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8361), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8363), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6196), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [204066] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8319), 1,
      anon_sym_and,
    ACTIONS(8321), 1,
      anon_sym_or,
    STATE(6197), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6609), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6607), 24,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [204149] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8279), 1,
      sym__identifier_token,
    ACTIONS(8283), 1,
      anon_sym_LPAREN,
    ACTIONS(8285), 1,
      anon_sym_BANG,
    ACTIONS(8289), 1,
      anon_sym_SQUOTE,
    ACTIONS(8291), 1,
      sym_integer_literal,
    STATE(7840), 1,
      sym__reserved_identifier,
    STATE(8194), 1,
      sym__preproc_expression,
    ACTIONS(8287), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(8065), 6,
      sym_character_literal,
      sym_boolean_literal,
      sym_identifier,
      sym_preproc_parenthesized_expression,
      sym_preproc_unary_expression,
      sym_preproc_binary_expression,
    STATE(6198), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(8281), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [204244] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(8403), 1,
      anon_sym_QMARK,
    ACTIONS(8409), 1,
      anon_sym_SLASH,
    ACTIONS(8411), 1,
      anon_sym_CARET,
    ACTIONS(8413), 1,
      anon_sym_PIPE,
    ACTIONS(8415), 1,
      anon_sym_AMP,
    ACTIONS(8419), 1,
      anon_sym_GT_GT,
    ACTIONS(8425), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8427), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8429), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8431), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8433), 1,
      anon_sym_as,
    ACTIONS(8435), 1,
      anon_sym_is,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6274), 2,
      anon_sym_into,
      anon_sym_equals,
    ACTIONS(8401), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8405), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8407), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8417), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8421), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8423), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6199), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [204377] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8319), 1,
      anon_sym_and,
    STATE(6200), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6546), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6544), 25,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [204458] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(8329), 1,
      anon_sym_DOT_DOT,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(6201), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6122), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6120), 18,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [204555] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8279), 1,
      sym__identifier_token,
    ACTIONS(8283), 1,
      anon_sym_LPAREN,
    ACTIONS(8285), 1,
      anon_sym_BANG,
    ACTIONS(8289), 1,
      anon_sym_SQUOTE,
    ACTIONS(8291), 1,
      sym_integer_literal,
    STATE(7840), 1,
      sym__reserved_identifier,
    STATE(7926), 1,
      sym__preproc_expression,
    ACTIONS(8287), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(8065), 6,
      sym_character_literal,
      sym_boolean_literal,
      sym_identifier,
      sym_preproc_parenthesized_expression,
      sym_preproc_unary_expression,
      sym_preproc_binary_expression,
    STATE(6202), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(8281), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [204650] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(8403), 1,
      anon_sym_QMARK,
    ACTIONS(8409), 1,
      anon_sym_SLASH,
    ACTIONS(8411), 1,
      anon_sym_CARET,
    ACTIONS(8413), 1,
      anon_sym_PIPE,
    ACTIONS(8415), 1,
      anon_sym_AMP,
    ACTIONS(8419), 1,
      anon_sym_GT_GT,
    ACTIONS(8425), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8427), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8429), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8431), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8433), 1,
      anon_sym_as,
    ACTIONS(8435), 1,
      anon_sym_is,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6220), 2,
      anon_sym_into,
      anon_sym_equals,
    ACTIONS(8401), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8405), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8407), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8417), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8421), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8423), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6203), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [204783] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8279), 1,
      sym__identifier_token,
    ACTIONS(8283), 1,
      anon_sym_LPAREN,
    ACTIONS(8285), 1,
      anon_sym_BANG,
    ACTIONS(8289), 1,
      anon_sym_SQUOTE,
    ACTIONS(8291), 1,
      sym_integer_literal,
    STATE(7840), 1,
      sym__reserved_identifier,
    STATE(7938), 1,
      sym__preproc_expression,
    ACTIONS(8287), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(8065), 6,
      sym_character_literal,
      sym_boolean_literal,
      sym_identifier,
      sym_preproc_parenthesized_expression,
      sym_preproc_unary_expression,
      sym_preproc_binary_expression,
    STATE(6204), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(8281), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [204878] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(8425), 1,
      anon_sym_DOT_DOT,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(6205), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1147), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(1133), 18,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [204975] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(6933), 1,
      anon_sym_SLASH,
    ACTIONS(6935), 1,
      anon_sym_CARET,
    ACTIONS(6937), 1,
      anon_sym_PIPE,
    ACTIONS(6939), 1,
      anon_sym_AMP,
    ACTIONS(6943), 1,
      anon_sym_GT_GT,
    ACTIONS(6953), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6955), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6957), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6925), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6929), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6931), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6941), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6945), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6947), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8116), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    STATE(6206), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [205108] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8463), 1,
      anon_sym_and,
    ACTIONS(8465), 1,
      anon_sym_or,
    STATE(6207), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6609), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6607), 24,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [205191] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(8329), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8343), 1,
      anon_sym_QMARK,
    ACTIONS(8349), 1,
      anon_sym_SLASH,
    ACTIONS(8351), 1,
      anon_sym_CARET,
    ACTIONS(8353), 1,
      anon_sym_PIPE,
    ACTIONS(8355), 1,
      anon_sym_AMP,
    ACTIONS(8359), 1,
      anon_sym_GT_GT,
    ACTIONS(8365), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8367), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8369), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8371), 1,
      anon_sym_as,
    ACTIONS(8373), 1,
      anon_sym_is,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6230), 2,
      anon_sym_into,
      anon_sym_by,
    ACTIONS(8341), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8345), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8347), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8357), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8361), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8363), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6208), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [205324] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(8329), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8343), 1,
      anon_sym_QMARK,
    ACTIONS(8349), 1,
      anon_sym_SLASH,
    ACTIONS(8351), 1,
      anon_sym_CARET,
    ACTIONS(8353), 1,
      anon_sym_PIPE,
    ACTIONS(8355), 1,
      anon_sym_AMP,
    ACTIONS(8359), 1,
      anon_sym_GT_GT,
    ACTIONS(8365), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8367), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8369), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8371), 1,
      anon_sym_as,
    ACTIONS(8373), 1,
      anon_sym_is,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5420), 2,
      anon_sym_into,
      anon_sym_by,
    ACTIONS(8341), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8345), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8347), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8357), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8361), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8363), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6209), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [205457] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(139), 1,
      anon_sym_SQUOTE,
    ACTIONS(8395), 1,
      anon_sym_LPAREN,
    ACTIONS(8397), 1,
      anon_sym_BANG,
    ACTIONS(8399), 1,
      sym_integer_literal,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(8109), 1,
      sym__preproc_expression,
    ACTIONS(75), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(8179), 6,
      sym_character_literal,
      sym_boolean_literal,
      sym_identifier,
      sym_preproc_parenthesized_expression,
      sym_preproc_unary_expression,
      sym_preproc_binary_expression,
    STATE(6210), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [205552] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(6695), 1,
      anon_sym_as,
    ACTIONS(8299), 1,
      anon_sym_SLASH,
    ACTIONS(8301), 1,
      anon_sym_CARET,
    ACTIONS(8303), 1,
      anon_sym_PIPE,
    ACTIONS(8305), 1,
      anon_sym_AMP,
    ACTIONS(8309), 1,
      anon_sym_GT_GT,
    ACTIONS(8315), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8317), 1,
      anon_sym_is,
    ACTIONS(8333), 1,
      anon_sym_QMARK,
    ACTIONS(8335), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8337), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8339), 1,
      anon_sym_QMARK_QMARK,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6220), 2,
      anon_sym_EQ_GT,
      anon_sym_into,
    ACTIONS(8293), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8295), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8297), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8307), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8311), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8313), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6211), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [205685] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8124), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(6212), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [205818] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8279), 1,
      sym__identifier_token,
    ACTIONS(8283), 1,
      anon_sym_LPAREN,
    ACTIONS(8285), 1,
      anon_sym_BANG,
    ACTIONS(8289), 1,
      anon_sym_SQUOTE,
    ACTIONS(8291), 1,
      sym_integer_literal,
    STATE(7840), 1,
      sym__reserved_identifier,
    STATE(8097), 1,
      sym__preproc_expression,
    ACTIONS(8287), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(8065), 6,
      sym_character_literal,
      sym_boolean_literal,
      sym_identifier,
      sym_preproc_parenthesized_expression,
      sym_preproc_unary_expression,
      sym_preproc_binary_expression,
    STATE(6213), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(8281), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [205913] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(8329), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8343), 1,
      anon_sym_QMARK,
    ACTIONS(8349), 1,
      anon_sym_SLASH,
    ACTIONS(8351), 1,
      anon_sym_CARET,
    ACTIONS(8353), 1,
      anon_sym_PIPE,
    ACTIONS(8355), 1,
      anon_sym_AMP,
    ACTIONS(8359), 1,
      anon_sym_GT_GT,
    ACTIONS(8365), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8367), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8369), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8371), 1,
      anon_sym_as,
    ACTIONS(8373), 1,
      anon_sym_is,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5510), 2,
      anon_sym_into,
      anon_sym_by,
    ACTIONS(8341), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8345), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8347), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8357), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8361), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8363), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6214), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [206046] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8279), 1,
      sym__identifier_token,
    ACTIONS(8283), 1,
      anon_sym_LPAREN,
    ACTIONS(8285), 1,
      anon_sym_BANG,
    ACTIONS(8289), 1,
      anon_sym_SQUOTE,
    ACTIONS(8291), 1,
      sym_integer_literal,
    STATE(7840), 1,
      sym__reserved_identifier,
    STATE(8176), 1,
      sym__preproc_expression,
    ACTIONS(8287), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(8065), 6,
      sym_character_literal,
      sym_boolean_literal,
      sym_identifier,
      sym_preproc_parenthesized_expression,
      sym_preproc_unary_expression,
      sym_preproc_binary_expression,
    STATE(6215), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(8281), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [206141] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8279), 1,
      sym__identifier_token,
    ACTIONS(8283), 1,
      anon_sym_LPAREN,
    ACTIONS(8285), 1,
      anon_sym_BANG,
    ACTIONS(8289), 1,
      anon_sym_SQUOTE,
    ACTIONS(8291), 1,
      sym_integer_literal,
    STATE(7840), 1,
      sym__reserved_identifier,
    STATE(8016), 1,
      sym__preproc_expression,
    ACTIONS(8287), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(8065), 6,
      sym_character_literal,
      sym_boolean_literal,
      sym_identifier,
      sym_preproc_parenthesized_expression,
      sym_preproc_unary_expression,
      sym_preproc_binary_expression,
    STATE(6216), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(8281), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [206236] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(8329), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8343), 1,
      anon_sym_QMARK,
    ACTIONS(8349), 1,
      anon_sym_SLASH,
    ACTIONS(8351), 1,
      anon_sym_CARET,
    ACTIONS(8353), 1,
      anon_sym_PIPE,
    ACTIONS(8355), 1,
      anon_sym_AMP,
    ACTIONS(8359), 1,
      anon_sym_GT_GT,
    ACTIONS(8365), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8367), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8369), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8371), 1,
      anon_sym_as,
    ACTIONS(8373), 1,
      anon_sym_is,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5325), 2,
      anon_sym_into,
      anon_sym_by,
    ACTIONS(8341), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8345), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8347), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8357), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8361), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8363), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6217), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [206369] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(7250), 1,
      anon_sym_LBRACK,
    ACTIONS(7252), 1,
      anon_sym_STAR,
    ACTIONS(7254), 1,
      anon_sym_QMARK,
    ACTIONS(8467), 1,
      anon_sym_DOT,
    ACTIONS(4424), 6,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
    STATE(6218), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4422), 26,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [206458] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(8116), 1,
      anon_sym_COMMA,
    ACTIONS(8469), 1,
      anon_sym_RPAREN,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6219), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [206593] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(8329), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8343), 1,
      anon_sym_QMARK,
    ACTIONS(8349), 1,
      anon_sym_SLASH,
    ACTIONS(8351), 1,
      anon_sym_CARET,
    ACTIONS(8353), 1,
      anon_sym_PIPE,
    ACTIONS(8355), 1,
      anon_sym_AMP,
    ACTIONS(8359), 1,
      anon_sym_GT_GT,
    ACTIONS(8365), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8367), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8369), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8371), 1,
      anon_sym_as,
    ACTIONS(8373), 1,
      anon_sym_is,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6216), 2,
      anon_sym_into,
      anon_sym_by,
    ACTIONS(8341), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8345), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8347), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8357), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8361), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8363), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6220), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [206726] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8279), 1,
      sym__identifier_token,
    ACTIONS(8283), 1,
      anon_sym_LPAREN,
    ACTIONS(8285), 1,
      anon_sym_BANG,
    ACTIONS(8289), 1,
      anon_sym_SQUOTE,
    ACTIONS(8291), 1,
      sym_integer_literal,
    STATE(7840), 1,
      sym__reserved_identifier,
    STATE(8195), 1,
      sym__preproc_expression,
    ACTIONS(8287), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(8065), 6,
      sym_character_literal,
      sym_boolean_literal,
      sym_identifier,
      sym_preproc_parenthesized_expression,
      sym_preproc_unary_expression,
      sym_preproc_binary_expression,
    STATE(6221), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(8281), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [206821] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(139), 1,
      anon_sym_SQUOTE,
    ACTIONS(8395), 1,
      anon_sym_LPAREN,
    ACTIONS(8397), 1,
      anon_sym_BANG,
    ACTIONS(8399), 1,
      sym_integer_literal,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(8134), 1,
      sym__preproc_expression,
    ACTIONS(75), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(8179), 6,
      sym_character_literal,
      sym_boolean_literal,
      sym_identifier,
      sym_preproc_parenthesized_expression,
      sym_preproc_unary_expression,
      sym_preproc_binary_expression,
    STATE(6222), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [206916] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(8245), 1,
      anon_sym_QMARK,
    ACTIONS(8251), 1,
      anon_sym_SLASH,
    ACTIONS(8253), 1,
      anon_sym_CARET,
    ACTIONS(8255), 1,
      anon_sym_PIPE,
    ACTIONS(8257), 1,
      anon_sym_AMP,
    ACTIONS(8261), 1,
      anon_sym_GT_GT,
    ACTIONS(8267), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8269), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8271), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8273), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8275), 1,
      anon_sym_as,
    ACTIONS(8277), 1,
      anon_sym_is,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6284), 2,
      anon_sym_into,
      anon_sym_on,
    ACTIONS(8243), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8247), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8249), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8259), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8263), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8265), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6223), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [207049] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(8329), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8343), 1,
      anon_sym_QMARK,
    ACTIONS(8349), 1,
      anon_sym_SLASH,
    ACTIONS(8351), 1,
      anon_sym_CARET,
    ACTIONS(8353), 1,
      anon_sym_PIPE,
    ACTIONS(8355), 1,
      anon_sym_AMP,
    ACTIONS(8359), 1,
      anon_sym_GT_GT,
    ACTIONS(8365), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8367), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8369), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8371), 1,
      anon_sym_as,
    ACTIONS(8373), 1,
      anon_sym_is,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5396), 2,
      anon_sym_into,
      anon_sym_by,
    ACTIONS(8341), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8345), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8347), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8357), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8361), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8363), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6224), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [207182] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8463), 1,
      anon_sym_and,
    ACTIONS(8465), 1,
      anon_sym_or,
    STATE(6225), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5856), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5854), 24,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [207265] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(8329), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8343), 1,
      anon_sym_QMARK,
    ACTIONS(8349), 1,
      anon_sym_SLASH,
    ACTIONS(8351), 1,
      anon_sym_CARET,
    ACTIONS(8353), 1,
      anon_sym_PIPE,
    ACTIONS(8355), 1,
      anon_sym_AMP,
    ACTIONS(8359), 1,
      anon_sym_GT_GT,
    ACTIONS(8365), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8367), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8369), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8371), 1,
      anon_sym_as,
    ACTIONS(8373), 1,
      anon_sym_is,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5385), 2,
      anon_sym_into,
      anon_sym_by,
    ACTIONS(8341), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8345), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8347), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8357), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8361), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8363), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6226), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [207398] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8375), 1,
      anon_sym_and,
    ACTIONS(8471), 1,
      anon_sym_or,
    STATE(6227), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6609), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6607), 24,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_when,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [207481] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8463), 1,
      anon_sym_and,
    STATE(6228), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6546), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6544), 25,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [207562] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(8329), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8343), 1,
      anon_sym_QMARK,
    ACTIONS(8349), 1,
      anon_sym_SLASH,
    ACTIONS(8351), 1,
      anon_sym_CARET,
    ACTIONS(8353), 1,
      anon_sym_PIPE,
    ACTIONS(8355), 1,
      anon_sym_AMP,
    ACTIONS(8359), 1,
      anon_sym_GT_GT,
    ACTIONS(8365), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8367), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8369), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8371), 1,
      anon_sym_as,
    ACTIONS(8373), 1,
      anon_sym_is,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5337), 2,
      anon_sym_into,
      anon_sym_by,
    ACTIONS(8341), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8345), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8347), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8357), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8361), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8363), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6229), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [207695] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5282), 1,
      anon_sym_LPAREN,
    ACTIONS(8473), 1,
      anon_sym_LBRACK,
    STATE(6703), 1,
      sym_attribute_list,
    STATE(6230), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_class_declaration_repeat1,
    ACTIONS(5277), 33,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_static,
      anon_sym_ref,
      anon_sym_delegate,
      anon_sym_async,
      anon_sym_file,
      anon_sym_readonly,
      anon_sym_in,
      anon_sym_out,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_this,
      anon_sym_scoped,
      anon_sym_params,
      anon_sym_var,
      sym_predefined_type,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [207778] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8476), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(6231), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [207911] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7968), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(6232), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [208044] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8279), 1,
      sym__identifier_token,
    ACTIONS(8283), 1,
      anon_sym_LPAREN,
    ACTIONS(8285), 1,
      anon_sym_BANG,
    ACTIONS(8289), 1,
      anon_sym_SQUOTE,
    ACTIONS(8291), 1,
      sym_integer_literal,
    STATE(7840), 1,
      sym__reserved_identifier,
    STATE(8098), 1,
      sym__preproc_expression,
    ACTIONS(8287), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(8065), 6,
      sym_character_literal,
      sym_boolean_literal,
      sym_identifier,
      sym_preproc_parenthesized_expression,
      sym_preproc_unary_expression,
      sym_preproc_binary_expression,
    STATE(6233), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(8281), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [208139] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(8245), 1,
      anon_sym_QMARK,
    ACTIONS(8251), 1,
      anon_sym_SLASH,
    ACTIONS(8253), 1,
      anon_sym_CARET,
    ACTIONS(8255), 1,
      anon_sym_PIPE,
    ACTIONS(8257), 1,
      anon_sym_AMP,
    ACTIONS(8261), 1,
      anon_sym_GT_GT,
    ACTIONS(8267), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8269), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8271), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8273), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8275), 1,
      anon_sym_as,
    ACTIONS(8277), 1,
      anon_sym_is,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6274), 2,
      anon_sym_into,
      anon_sym_on,
    ACTIONS(8243), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8247), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8249), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8259), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8263), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8265), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6234), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [208272] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(139), 1,
      anon_sym_SQUOTE,
    ACTIONS(8395), 1,
      anon_sym_LPAREN,
    ACTIONS(8397), 1,
      anon_sym_BANG,
    ACTIONS(8399), 1,
      sym_integer_literal,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(8114), 1,
      sym__preproc_expression,
    ACTIONS(75), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(8179), 6,
      sym_character_literal,
      sym_boolean_literal,
      sym_identifier,
      sym_preproc_parenthesized_expression,
      sym_preproc_unary_expression,
      sym_preproc_binary_expression,
    STATE(6235), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [208367] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(8245), 1,
      anon_sym_QMARK,
    ACTIONS(8251), 1,
      anon_sym_SLASH,
    ACTIONS(8253), 1,
      anon_sym_CARET,
    ACTIONS(8255), 1,
      anon_sym_PIPE,
    ACTIONS(8257), 1,
      anon_sym_AMP,
    ACTIONS(8261), 1,
      anon_sym_GT_GT,
    ACTIONS(8267), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8269), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8271), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8273), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8275), 1,
      anon_sym_as,
    ACTIONS(8277), 1,
      anon_sym_is,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6220), 2,
      anon_sym_into,
      anon_sym_on,
    ACTIONS(8243), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8247), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8249), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8259), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8263), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8265), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6236), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [208500] = 28,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(8329), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8349), 1,
      anon_sym_SLASH,
    ACTIONS(8359), 1,
      anon_sym_GT_GT,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8345), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8347), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8357), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6116), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(6237), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 12,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
  [208611] = 25,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(8329), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8349), 1,
      anon_sym_SLASH,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8347), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6116), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(6238), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 14,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
  [208716] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8279), 1,
      sym__identifier_token,
    ACTIONS(8283), 1,
      anon_sym_LPAREN,
    ACTIONS(8285), 1,
      anon_sym_BANG,
    ACTIONS(8289), 1,
      anon_sym_SQUOTE,
    ACTIONS(8291), 1,
      sym_integer_literal,
    STATE(7840), 1,
      sym__reserved_identifier,
    STATE(8062), 1,
      sym__preproc_expression,
    ACTIONS(8287), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(8065), 6,
      sym_character_literal,
      sym_boolean_literal,
      sym_identifier,
      sym_preproc_parenthesized_expression,
      sym_preproc_unary_expression,
      sym_preproc_binary_expression,
    STATE(6239), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(8281), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [208811] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(8267), 1,
      anon_sym_DOT_DOT,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(6240), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1147), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(1133), 18,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [208908] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(8329), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8349), 1,
      anon_sym_SLASH,
    ACTIONS(8355), 1,
      anon_sym_AMP,
    ACTIONS(8359), 1,
      anon_sym_GT_GT,
    ACTIONS(8371), 1,
      anon_sym_as,
    ACTIONS(8373), 1,
      anon_sym_is,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6116), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(8341), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8345), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8347), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8357), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8361), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8363), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 6,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_by,
    STATE(6241), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [209031] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(8329), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8349), 1,
      anon_sym_SLASH,
    ACTIONS(8351), 1,
      anon_sym_CARET,
    ACTIONS(8355), 1,
      anon_sym_AMP,
    ACTIONS(8359), 1,
      anon_sym_GT_GT,
    ACTIONS(8371), 1,
      anon_sym_as,
    ACTIONS(8373), 1,
      anon_sym_is,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6116), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(8341), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8345), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8347), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8357), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8361), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8363), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 5,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_by,
    STATE(6242), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [209156] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(8329), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8349), 1,
      anon_sym_SLASH,
    ACTIONS(8359), 1,
      anon_sym_GT_GT,
    ACTIONS(8371), 1,
      anon_sym_as,
    ACTIONS(8373), 1,
      anon_sym_is,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8341), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8345), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8347), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8357), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8361), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8363), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6116), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(6114), 6,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_by,
    STATE(6243), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [209277] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8478), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(6244), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [209410] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(8329), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8349), 1,
      anon_sym_SLASH,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8345), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8347), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6116), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(6245), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 14,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
  [209517] = 32,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(8329), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8349), 1,
      anon_sym_SLASH,
    ACTIONS(8359), 1,
      anon_sym_GT_GT,
    ACTIONS(8371), 1,
      anon_sym_as,
    ACTIONS(8373), 1,
      anon_sym_is,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8341), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8345), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8347), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8357), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8363), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6116), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(6114), 8,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_by,
    STATE(6246), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [209636] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(8329), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8349), 1,
      anon_sym_SLASH,
    ACTIONS(8351), 1,
      anon_sym_CARET,
    ACTIONS(8353), 1,
      anon_sym_PIPE,
    ACTIONS(8355), 1,
      anon_sym_AMP,
    ACTIONS(8359), 1,
      anon_sym_GT_GT,
    ACTIONS(8371), 1,
      anon_sym_as,
    ACTIONS(8373), 1,
      anon_sym_is,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8341), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8345), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8347), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8357), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8361), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8363), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 5,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_by,
    STATE(6247), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [209763] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(8329), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8349), 1,
      anon_sym_SLASH,
    ACTIONS(8351), 1,
      anon_sym_CARET,
    ACTIONS(8353), 1,
      anon_sym_PIPE,
    ACTIONS(8355), 1,
      anon_sym_AMP,
    ACTIONS(8359), 1,
      anon_sym_GT_GT,
    ACTIONS(8365), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8371), 1,
      anon_sym_as,
    ACTIONS(8373), 1,
      anon_sym_is,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8341), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8345), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8347), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8357), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8361), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8363), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 4,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_by,
    STATE(6248), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [209892] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(8329), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8349), 1,
      anon_sym_SLASH,
    ACTIONS(8351), 1,
      anon_sym_CARET,
    ACTIONS(8353), 1,
      anon_sym_PIPE,
    ACTIONS(8355), 1,
      anon_sym_AMP,
    ACTIONS(8359), 1,
      anon_sym_GT_GT,
    ACTIONS(8365), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8367), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8369), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8371), 1,
      anon_sym_as,
    ACTIONS(8373), 1,
      anon_sym_is,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6114), 2,
      anon_sym_into,
      anon_sym_by,
    ACTIONS(8341), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8345), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8347), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8357), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8361), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8363), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6249), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [210025] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8480), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(6250), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [210158] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(8409), 1,
      anon_sym_SLASH,
    ACTIONS(8411), 1,
      anon_sym_CARET,
    ACTIONS(8413), 1,
      anon_sym_PIPE,
    ACTIONS(8415), 1,
      anon_sym_AMP,
    ACTIONS(8419), 1,
      anon_sym_GT_GT,
    ACTIONS(8425), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8427), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8429), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8431), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8433), 1,
      anon_sym_as,
    ACTIONS(8435), 1,
      anon_sym_is,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6114), 2,
      anon_sym_into,
      anon_sym_equals,
    ACTIONS(8401), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8405), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8407), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8417), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8421), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8423), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6251), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [210291] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(8409), 1,
      anon_sym_SLASH,
    ACTIONS(8411), 1,
      anon_sym_CARET,
    ACTIONS(8413), 1,
      anon_sym_PIPE,
    ACTIONS(8415), 1,
      anon_sym_AMP,
    ACTIONS(8419), 1,
      anon_sym_GT_GT,
    ACTIONS(8425), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8427), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8433), 1,
      anon_sym_as,
    ACTIONS(8435), 1,
      anon_sym_is,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8401), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8405), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8407), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8417), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8421), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8423), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 4,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_equals,
    STATE(6252), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [210420] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8134), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(6253), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [210553] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(8409), 1,
      anon_sym_SLASH,
    ACTIONS(8411), 1,
      anon_sym_CARET,
    ACTIONS(8413), 1,
      anon_sym_PIPE,
    ACTIONS(8415), 1,
      anon_sym_AMP,
    ACTIONS(8419), 1,
      anon_sym_GT_GT,
    ACTIONS(8425), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8433), 1,
      anon_sym_as,
    ACTIONS(8435), 1,
      anon_sym_is,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8401), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8405), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8407), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8417), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8421), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8423), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 5,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_equals,
    STATE(6254), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [210680] = 32,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(8409), 1,
      anon_sym_SLASH,
    ACTIONS(8419), 1,
      anon_sym_GT_GT,
    ACTIONS(8425), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8433), 1,
      anon_sym_as,
    ACTIONS(8435), 1,
      anon_sym_is,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8401), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8405), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8407), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8417), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8423), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6116), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(6114), 8,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_equals,
    STATE(6255), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [210799] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(8409), 1,
      anon_sym_SLASH,
    ACTIONS(8425), 1,
      anon_sym_DOT_DOT,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8405), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8407), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6116), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(6256), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 14,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
  [210906] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(8409), 1,
      anon_sym_SLASH,
    ACTIONS(8419), 1,
      anon_sym_GT_GT,
    ACTIONS(8425), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8433), 1,
      anon_sym_as,
    ACTIONS(8435), 1,
      anon_sym_is,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8401), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8405), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8407), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8417), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8421), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8423), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6116), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(6114), 6,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_equals,
    STATE(6257), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [211027] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(8409), 1,
      anon_sym_SLASH,
    ACTIONS(8411), 1,
      anon_sym_CARET,
    ACTIONS(8415), 1,
      anon_sym_AMP,
    ACTIONS(8419), 1,
      anon_sym_GT_GT,
    ACTIONS(8425), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8433), 1,
      anon_sym_as,
    ACTIONS(8435), 1,
      anon_sym_is,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6116), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(8401), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8405), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8407), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8417), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8421), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8423), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 5,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_equals,
    STATE(6258), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [211152] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(8409), 1,
      anon_sym_SLASH,
    ACTIONS(8415), 1,
      anon_sym_AMP,
    ACTIONS(8419), 1,
      anon_sym_GT_GT,
    ACTIONS(8425), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8433), 1,
      anon_sym_as,
    ACTIONS(8435), 1,
      anon_sym_is,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6116), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(8401), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8405), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8407), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8417), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8421), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8423), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 6,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_equals,
    STATE(6259), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [211275] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(8425), 1,
      anon_sym_DOT_DOT,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(6260), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6116), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6114), 16,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
  [211376] = 25,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(8409), 1,
      anon_sym_SLASH,
    ACTIONS(8425), 1,
      anon_sym_DOT_DOT,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8407), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6116), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(6261), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 14,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
  [211481] = 28,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(8409), 1,
      anon_sym_SLASH,
    ACTIONS(8419), 1,
      anon_sym_GT_GT,
    ACTIONS(8425), 1,
      anon_sym_DOT_DOT,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8405), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8407), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8417), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6116), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(6262), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 12,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
  [211592] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(139), 1,
      anon_sym_SQUOTE,
    ACTIONS(8395), 1,
      anon_sym_LPAREN,
    ACTIONS(8397), 1,
      anon_sym_BANG,
    ACTIONS(8399), 1,
      sym_integer_literal,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(8172), 1,
      sym__preproc_expression,
    ACTIONS(75), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(8179), 6,
      sym_character_literal,
      sym_boolean_literal,
      sym_identifier,
      sym_preproc_parenthesized_expression,
      sym_preproc_unary_expression,
      sym_preproc_binary_expression,
    STATE(6263), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [211687] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(8403), 1,
      anon_sym_QMARK,
    ACTIONS(8409), 1,
      anon_sym_SLASH,
    ACTIONS(8411), 1,
      anon_sym_CARET,
    ACTIONS(8413), 1,
      anon_sym_PIPE,
    ACTIONS(8415), 1,
      anon_sym_AMP,
    ACTIONS(8419), 1,
      anon_sym_GT_GT,
    ACTIONS(8425), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8427), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8429), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8431), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8433), 1,
      anon_sym_as,
    ACTIONS(8435), 1,
      anon_sym_is,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5337), 2,
      anon_sym_into,
      anon_sym_equals,
    ACTIONS(8401), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8405), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8407), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8417), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8421), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8423), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6264), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [211820] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(8403), 1,
      anon_sym_QMARK,
    ACTIONS(8409), 1,
      anon_sym_SLASH,
    ACTIONS(8411), 1,
      anon_sym_CARET,
    ACTIONS(8413), 1,
      anon_sym_PIPE,
    ACTIONS(8415), 1,
      anon_sym_AMP,
    ACTIONS(8419), 1,
      anon_sym_GT_GT,
    ACTIONS(8425), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8427), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8429), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8431), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8433), 1,
      anon_sym_as,
    ACTIONS(8435), 1,
      anon_sym_is,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5385), 2,
      anon_sym_into,
      anon_sym_equals,
    ACTIONS(8401), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8405), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8407), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8417), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8421), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8423), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6265), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [211953] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8279), 1,
      sym__identifier_token,
    ACTIONS(8283), 1,
      anon_sym_LPAREN,
    ACTIONS(8285), 1,
      anon_sym_BANG,
    ACTIONS(8289), 1,
      anon_sym_SQUOTE,
    ACTIONS(8291), 1,
      sym_integer_literal,
    STATE(7840), 1,
      sym__reserved_identifier,
    STATE(8169), 1,
      sym__preproc_expression,
    ACTIONS(8287), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(8065), 6,
      sym_character_literal,
      sym_boolean_literal,
      sym_identifier,
      sym_preproc_parenthesized_expression,
      sym_preproc_unary_expression,
      sym_preproc_binary_expression,
    STATE(6266), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(8281), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [212048] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(8403), 1,
      anon_sym_QMARK,
    ACTIONS(8409), 1,
      anon_sym_SLASH,
    ACTIONS(8411), 1,
      anon_sym_CARET,
    ACTIONS(8413), 1,
      anon_sym_PIPE,
    ACTIONS(8415), 1,
      anon_sym_AMP,
    ACTIONS(8419), 1,
      anon_sym_GT_GT,
    ACTIONS(8425), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8427), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8429), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8431), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8433), 1,
      anon_sym_as,
    ACTIONS(8435), 1,
      anon_sym_is,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5396), 2,
      anon_sym_into,
      anon_sym_equals,
    ACTIONS(8401), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8405), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8407), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8417), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8421), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8423), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6267), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [212181] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(8403), 1,
      anon_sym_QMARK,
    ACTIONS(8409), 1,
      anon_sym_SLASH,
    ACTIONS(8411), 1,
      anon_sym_CARET,
    ACTIONS(8413), 1,
      anon_sym_PIPE,
    ACTIONS(8415), 1,
      anon_sym_AMP,
    ACTIONS(8419), 1,
      anon_sym_GT_GT,
    ACTIONS(8425), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8427), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8429), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8431), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8433), 1,
      anon_sym_as,
    ACTIONS(8435), 1,
      anon_sym_is,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6216), 2,
      anon_sym_into,
      anon_sym_equals,
    ACTIONS(8401), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8405), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8407), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8417), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8421), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8423), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6268), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [212314] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(8403), 1,
      anon_sym_QMARK,
    ACTIONS(8409), 1,
      anon_sym_SLASH,
    ACTIONS(8411), 1,
      anon_sym_CARET,
    ACTIONS(8413), 1,
      anon_sym_PIPE,
    ACTIONS(8415), 1,
      anon_sym_AMP,
    ACTIONS(8419), 1,
      anon_sym_GT_GT,
    ACTIONS(8425), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8427), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8429), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8431), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8433), 1,
      anon_sym_as,
    ACTIONS(8435), 1,
      anon_sym_is,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5325), 2,
      anon_sym_into,
      anon_sym_equals,
    ACTIONS(8401), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8405), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8407), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8417), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8421), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8423), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6269), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [212447] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(8403), 1,
      anon_sym_QMARK,
    ACTIONS(8409), 1,
      anon_sym_SLASH,
    ACTIONS(8411), 1,
      anon_sym_CARET,
    ACTIONS(8413), 1,
      anon_sym_PIPE,
    ACTIONS(8415), 1,
      anon_sym_AMP,
    ACTIONS(8419), 1,
      anon_sym_GT_GT,
    ACTIONS(8425), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8427), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8429), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8431), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8433), 1,
      anon_sym_as,
    ACTIONS(8435), 1,
      anon_sym_is,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5510), 2,
      anon_sym_into,
      anon_sym_equals,
    ACTIONS(8401), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8405), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8407), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8417), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8421), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8423), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6270), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [212580] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(8403), 1,
      anon_sym_QMARK,
    ACTIONS(8409), 1,
      anon_sym_SLASH,
    ACTIONS(8411), 1,
      anon_sym_CARET,
    ACTIONS(8413), 1,
      anon_sym_PIPE,
    ACTIONS(8415), 1,
      anon_sym_AMP,
    ACTIONS(8419), 1,
      anon_sym_GT_GT,
    ACTIONS(8425), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8427), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8429), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8431), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8433), 1,
      anon_sym_as,
    ACTIONS(8435), 1,
      anon_sym_is,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5420), 2,
      anon_sym_into,
      anon_sym_equals,
    ACTIONS(8401), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8405), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8407), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8417), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8421), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8423), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6271), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [212713] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(8403), 1,
      anon_sym_QMARK,
    ACTIONS(8409), 1,
      anon_sym_SLASH,
    ACTIONS(8411), 1,
      anon_sym_CARET,
    ACTIONS(8413), 1,
      anon_sym_PIPE,
    ACTIONS(8415), 1,
      anon_sym_AMP,
    ACTIONS(8419), 1,
      anon_sym_GT_GT,
    ACTIONS(8425), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8427), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8429), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8431), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8433), 1,
      anon_sym_as,
    ACTIONS(8435), 1,
      anon_sym_is,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6230), 2,
      anon_sym_into,
      anon_sym_equals,
    ACTIONS(8401), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8405), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8407), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8417), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8421), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8423), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6272), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [212846] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(8425), 1,
      anon_sym_DOT_DOT,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(6273), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6122), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6120), 18,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [212943] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(8403), 1,
      anon_sym_QMARK,
    ACTIONS(8409), 1,
      anon_sym_SLASH,
    ACTIONS(8411), 1,
      anon_sym_CARET,
    ACTIONS(8413), 1,
      anon_sym_PIPE,
    ACTIONS(8415), 1,
      anon_sym_AMP,
    ACTIONS(8419), 1,
      anon_sym_GT_GT,
    ACTIONS(8425), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8427), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8429), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8431), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8433), 1,
      anon_sym_as,
    ACTIONS(8435), 1,
      anon_sym_is,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6236), 2,
      anon_sym_into,
      anon_sym_equals,
    ACTIONS(8401), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8405), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8407), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8417), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8421), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8423), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6274), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [213076] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(139), 1,
      anon_sym_SQUOTE,
    ACTIONS(8395), 1,
      anon_sym_LPAREN,
    ACTIONS(8397), 1,
      anon_sym_BANG,
    ACTIONS(8399), 1,
      sym_integer_literal,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(8139), 1,
      sym__preproc_expression,
    ACTIONS(75), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(8179), 6,
      sym_character_literal,
      sym_boolean_literal,
      sym_identifier,
      sym_preproc_parenthesized_expression,
      sym_preproc_unary_expression,
      sym_preproc_binary_expression,
    STATE(6275), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [213171] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_switch,
    ACTIONS(6667), 1,
      anon_sym_with,
    ACTIONS(8329), 1,
      anon_sym_DOT_DOT,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(6276), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6116), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6114), 16,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
  [213272] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7651), 1,
      anon_sym_as,
    ACTIONS(8482), 1,
      anon_sym_COLON,
    ACTIONS(8486), 1,
      anon_sym_QMARK,
    ACTIONS(8492), 1,
      anon_sym_SLASH,
    ACTIONS(8494), 1,
      anon_sym_CARET,
    ACTIONS(8496), 1,
      anon_sym_PIPE,
    ACTIONS(8498), 1,
      anon_sym_AMP,
    ACTIONS(8502), 1,
      anon_sym_GT_GT,
    ACTIONS(8508), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8512), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8514), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8516), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8484), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8488), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8490), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8500), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8504), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8506), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6277), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [213404] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7210), 1,
      anon_sym_is,
    ACTIONS(7438), 1,
      anon_sym_QMARK,
    ACTIONS(7444), 1,
      anon_sym_SLASH,
    ACTIONS(7446), 1,
      anon_sym_CARET,
    ACTIONS(7448), 1,
      anon_sym_PIPE,
    ACTIONS(7450), 1,
      anon_sym_AMP,
    ACTIONS(7454), 1,
      anon_sym_GT_GT,
    ACTIONS(7460), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7462), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7464), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7466), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8518), 1,
      anon_sym_SEMI,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7436), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7440), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7442), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7452), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7456), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7458), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6278), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [213536] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5420), 1,
      anon_sym_equals,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(8522), 1,
      anon_sym_QMARK,
    ACTIONS(8528), 1,
      anon_sym_SLASH,
    ACTIONS(8530), 1,
      anon_sym_CARET,
    ACTIONS(8532), 1,
      anon_sym_PIPE,
    ACTIONS(8534), 1,
      anon_sym_AMP,
    ACTIONS(8538), 1,
      anon_sym_GT_GT,
    ACTIONS(8544), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8546), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8548), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8550), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8552), 1,
      anon_sym_as,
    ACTIONS(8554), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8520), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8524), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8526), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8536), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8540), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8542), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6279), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [213668] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8556), 1,
      anon_sym_and,
    ACTIONS(8558), 1,
      anon_sym_or,
    STATE(6280), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5856), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5854), 23,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [213750] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(8560), 1,
      anon_sym_RPAREN,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6281), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [213882] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8562), 1,
      anon_sym_and,
    ACTIONS(8564), 1,
      anon_sym_or,
    STATE(6282), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6609), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6607), 23,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [213964] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6114), 1,
      anon_sym_equals,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(8528), 1,
      anon_sym_SLASH,
    ACTIONS(8530), 1,
      anon_sym_CARET,
    ACTIONS(8532), 1,
      anon_sym_PIPE,
    ACTIONS(8534), 1,
      anon_sym_AMP,
    ACTIONS(8538), 1,
      anon_sym_GT_GT,
    ACTIONS(8544), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8546), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8548), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8550), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8552), 1,
      anon_sym_as,
    ACTIONS(8554), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8520), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8524), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8526), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8536), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8540), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8542), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6283), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [214096] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7651), 1,
      anon_sym_as,
    ACTIONS(8486), 1,
      anon_sym_QMARK,
    ACTIONS(8492), 1,
      anon_sym_SLASH,
    ACTIONS(8494), 1,
      anon_sym_CARET,
    ACTIONS(8496), 1,
      anon_sym_PIPE,
    ACTIONS(8498), 1,
      anon_sym_AMP,
    ACTIONS(8502), 1,
      anon_sym_GT_GT,
    ACTIONS(8508), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8512), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8514), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8516), 1,
      anon_sym_is,
    ACTIONS(8566), 1,
      anon_sym_COLON,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8484), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8488), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8490), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8500), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8504), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8506), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6284), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [214228] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(8568), 1,
      anon_sym_RPAREN,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6285), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [214360] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(8570), 1,
      anon_sym_RPAREN,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6286), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [214492] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(8572), 1,
      anon_sym_RPAREN,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6287), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [214624] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(8528), 1,
      anon_sym_SLASH,
    ACTIONS(8530), 1,
      anon_sym_CARET,
    ACTIONS(8532), 1,
      anon_sym_PIPE,
    ACTIONS(8534), 1,
      anon_sym_AMP,
    ACTIONS(8538), 1,
      anon_sym_GT_GT,
    ACTIONS(8544), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8546), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8552), 1,
      anon_sym_as,
    ACTIONS(8554), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8520), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8524), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8526), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8536), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8540), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8542), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 3,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_equals,
    STATE(6288), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [214752] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(8576), 1,
      anon_sym_QMARK,
    ACTIONS(8582), 1,
      anon_sym_SLASH,
    ACTIONS(8584), 1,
      anon_sym_CARET,
    ACTIONS(8586), 1,
      anon_sym_PIPE,
    ACTIONS(8588), 1,
      anon_sym_AMP,
    ACTIONS(8592), 1,
      anon_sym_GT_GT,
    ACTIONS(8598), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8600), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8602), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8604), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8606), 1,
      anon_sym_by,
    ACTIONS(8608), 1,
      anon_sym_as,
    ACTIONS(8610), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8574), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8578), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8580), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8590), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8594), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8596), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6289), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [214884] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(8612), 1,
      anon_sym_RPAREN,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6290), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [215016] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8614), 1,
      anon_sym_into,
    STATE(6431), 1,
      aux_sym__query_body_repeat2,
    STATE(6291), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6448), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6446), 23,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [215098] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(8528), 1,
      anon_sym_SLASH,
    ACTIONS(8530), 1,
      anon_sym_CARET,
    ACTIONS(8532), 1,
      anon_sym_PIPE,
    ACTIONS(8534), 1,
      anon_sym_AMP,
    ACTIONS(8538), 1,
      anon_sym_GT_GT,
    ACTIONS(8544), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8552), 1,
      anon_sym_as,
    ACTIONS(8554), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8520), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8524), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8526), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8536), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8540), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8542), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 4,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_equals,
    STATE(6292), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [215224] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7210), 1,
      anon_sym_is,
    ACTIONS(7438), 1,
      anon_sym_QMARK,
    ACTIONS(7444), 1,
      anon_sym_SLASH,
    ACTIONS(7446), 1,
      anon_sym_CARET,
    ACTIONS(7448), 1,
      anon_sym_PIPE,
    ACTIONS(7450), 1,
      anon_sym_AMP,
    ACTIONS(7454), 1,
      anon_sym_GT_GT,
    ACTIONS(7460), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7462), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7464), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7466), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8616), 1,
      anon_sym_SEMI,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7436), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7440), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7442), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7452), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7456), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7458), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6293), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [215356] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(8544), 1,
      anon_sym_DOT_DOT,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(6294), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6122), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6120), 17,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [215452] = 32,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(8528), 1,
      anon_sym_SLASH,
    ACTIONS(8538), 1,
      anon_sym_GT_GT,
    ACTIONS(8544), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8552), 1,
      anon_sym_as,
    ACTIONS(8554), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8520), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8524), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8526), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8536), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8542), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6116), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(6114), 7,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_equals,
    STATE(6295), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [215570] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(8528), 1,
      anon_sym_SLASH,
    ACTIONS(8544), 1,
      anon_sym_DOT_DOT,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8524), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8526), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6116), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(6296), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 13,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
  [215676] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(8528), 1,
      anon_sym_SLASH,
    ACTIONS(8538), 1,
      anon_sym_GT_GT,
    ACTIONS(8544), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8552), 1,
      anon_sym_as,
    ACTIONS(8554), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8520), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8524), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8526), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8536), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8540), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8542), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6116), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(6114), 5,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_equals,
    STATE(6297), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [215796] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(8618), 1,
      anon_sym_RPAREN,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6298), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [215928] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7651), 1,
      anon_sym_as,
    ACTIONS(8486), 1,
      anon_sym_QMARK,
    ACTIONS(8492), 1,
      anon_sym_SLASH,
    ACTIONS(8494), 1,
      anon_sym_CARET,
    ACTIONS(8496), 1,
      anon_sym_PIPE,
    ACTIONS(8498), 1,
      anon_sym_AMP,
    ACTIONS(8502), 1,
      anon_sym_GT_GT,
    ACTIONS(8508), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8512), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8514), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8516), 1,
      anon_sym_is,
    ACTIONS(8620), 1,
      anon_sym_COLON,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8484), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8488), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8490), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8500), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8504), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8506), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6299), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [216060] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(8576), 1,
      anon_sym_QMARK,
    ACTIONS(8582), 1,
      anon_sym_SLASH,
    ACTIONS(8584), 1,
      anon_sym_CARET,
    ACTIONS(8586), 1,
      anon_sym_PIPE,
    ACTIONS(8588), 1,
      anon_sym_AMP,
    ACTIONS(8592), 1,
      anon_sym_GT_GT,
    ACTIONS(8598), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8600), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8602), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8604), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8608), 1,
      anon_sym_as,
    ACTIONS(8610), 1,
      anon_sym_is,
    ACTIONS(8622), 1,
      anon_sym_by,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8574), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8578), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8580), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8590), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8594), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8596), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6300), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [216192] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(8528), 1,
      anon_sym_SLASH,
    ACTIONS(8530), 1,
      anon_sym_CARET,
    ACTIONS(8534), 1,
      anon_sym_AMP,
    ACTIONS(8538), 1,
      anon_sym_GT_GT,
    ACTIONS(8544), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8552), 1,
      anon_sym_as,
    ACTIONS(8554), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6116), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(8520), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8524), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8526), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8536), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8540), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8542), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 4,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_equals,
    STATE(6301), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [216316] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(8528), 1,
      anon_sym_SLASH,
    ACTIONS(8534), 1,
      anon_sym_AMP,
    ACTIONS(8538), 1,
      anon_sym_GT_GT,
    ACTIONS(8544), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8552), 1,
      anon_sym_as,
    ACTIONS(8554), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6116), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(8520), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8524), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8526), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8536), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8540), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8542), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 5,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_equals,
    STATE(6302), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [216438] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(8576), 1,
      anon_sym_QMARK,
    ACTIONS(8582), 1,
      anon_sym_SLASH,
    ACTIONS(8584), 1,
      anon_sym_CARET,
    ACTIONS(8586), 1,
      anon_sym_PIPE,
    ACTIONS(8588), 1,
      anon_sym_AMP,
    ACTIONS(8592), 1,
      anon_sym_GT_GT,
    ACTIONS(8598), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8600), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8602), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8604), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8608), 1,
      anon_sym_as,
    ACTIONS(8610), 1,
      anon_sym_is,
    ACTIONS(8624), 1,
      anon_sym_by,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8574), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8578), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8580), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8590), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8594), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8596), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6303), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [216570] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(8544), 1,
      anon_sym_DOT_DOT,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(6304), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6116), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6114), 15,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
  [216670] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(8626), 1,
      anon_sym_RPAREN,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6305), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [216802] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(8628), 1,
      anon_sym_LPAREN,
    ACTIONS(8630), 1,
      anon_sym_operator,
    ACTIONS(8632), 1,
      anon_sym_this,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(2738), 1,
      sym_generic_name,
    STATE(7253), 1,
      sym_explicit_interface_specifier,
    STATE(7475), 1,
      sym_identifier,
    STATE(8056), 1,
      sym_tuple_pattern,
    STATE(8608), 1,
      sym_variable_declarator,
    STATE(9003), 1,
      sym__name,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6306), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [216902] = 25,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(8528), 1,
      anon_sym_SLASH,
    ACTIONS(8544), 1,
      anon_sym_DOT_DOT,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8526), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6116), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(6307), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 13,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
  [217006] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7210), 1,
      anon_sym_is,
    ACTIONS(7438), 1,
      anon_sym_QMARK,
    ACTIONS(7444), 1,
      anon_sym_SLASH,
    ACTIONS(7446), 1,
      anon_sym_CARET,
    ACTIONS(7448), 1,
      anon_sym_PIPE,
    ACTIONS(7450), 1,
      anon_sym_AMP,
    ACTIONS(7454), 1,
      anon_sym_GT_GT,
    ACTIONS(7460), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7462), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7464), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7466), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8634), 1,
      anon_sym_SEMI,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7436), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7440), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7442), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7452), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7456), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7458), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6308), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [217138] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7651), 1,
      anon_sym_as,
    ACTIONS(8486), 1,
      anon_sym_QMARK,
    ACTIONS(8492), 1,
      anon_sym_SLASH,
    ACTIONS(8494), 1,
      anon_sym_CARET,
    ACTIONS(8496), 1,
      anon_sym_PIPE,
    ACTIONS(8498), 1,
      anon_sym_AMP,
    ACTIONS(8502), 1,
      anon_sym_GT_GT,
    ACTIONS(8508), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8512), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8514), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8516), 1,
      anon_sym_is,
    ACTIONS(8636), 1,
      anon_sym_COLON,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8484), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8488), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8490), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8500), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8504), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8506), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6309), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [217270] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7651), 1,
      anon_sym_as,
    ACTIONS(8486), 1,
      anon_sym_QMARK,
    ACTIONS(8492), 1,
      anon_sym_SLASH,
    ACTIONS(8494), 1,
      anon_sym_CARET,
    ACTIONS(8496), 1,
      anon_sym_PIPE,
    ACTIONS(8498), 1,
      anon_sym_AMP,
    ACTIONS(8502), 1,
      anon_sym_GT_GT,
    ACTIONS(8508), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8512), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8514), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8516), 1,
      anon_sym_is,
    ACTIONS(8638), 1,
      anon_sym_COLON,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8484), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8488), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8490), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8500), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8504), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8506), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6310), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [217402] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(8576), 1,
      anon_sym_QMARK,
    ACTIONS(8582), 1,
      anon_sym_SLASH,
    ACTIONS(8584), 1,
      anon_sym_CARET,
    ACTIONS(8586), 1,
      anon_sym_PIPE,
    ACTIONS(8588), 1,
      anon_sym_AMP,
    ACTIONS(8592), 1,
      anon_sym_GT_GT,
    ACTIONS(8598), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8600), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8602), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8604), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8608), 1,
      anon_sym_as,
    ACTIONS(8610), 1,
      anon_sym_is,
    ACTIONS(8640), 1,
      anon_sym_by,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8574), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8578), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8580), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8590), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8594), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8596), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6311), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [217534] = 28,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(8528), 1,
      anon_sym_SLASH,
    ACTIONS(8538), 1,
      anon_sym_GT_GT,
    ACTIONS(8544), 1,
      anon_sym_DOT_DOT,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8524), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8526), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8536), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6116), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(6312), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 11,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
  [217644] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7651), 1,
      anon_sym_as,
    ACTIONS(8486), 1,
      anon_sym_QMARK,
    ACTIONS(8492), 1,
      anon_sym_SLASH,
    ACTIONS(8494), 1,
      anon_sym_CARET,
    ACTIONS(8496), 1,
      anon_sym_PIPE,
    ACTIONS(8498), 1,
      anon_sym_AMP,
    ACTIONS(8502), 1,
      anon_sym_GT_GT,
    ACTIONS(8508), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8512), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8514), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8516), 1,
      anon_sym_is,
    ACTIONS(8642), 1,
      anon_sym_COLON,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8484), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8488), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8490), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8500), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8504), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8506), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6313), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [217776] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(8576), 1,
      anon_sym_QMARK,
    ACTIONS(8582), 1,
      anon_sym_SLASH,
    ACTIONS(8584), 1,
      anon_sym_CARET,
    ACTIONS(8586), 1,
      anon_sym_PIPE,
    ACTIONS(8588), 1,
      anon_sym_AMP,
    ACTIONS(8592), 1,
      anon_sym_GT_GT,
    ACTIONS(8598), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8600), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8602), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8604), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8608), 1,
      anon_sym_as,
    ACTIONS(8610), 1,
      anon_sym_is,
    ACTIONS(8644), 1,
      anon_sym_by,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8574), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8578), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8580), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8590), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8594), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8596), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6314), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [217908] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(8576), 1,
      anon_sym_QMARK,
    ACTIONS(8582), 1,
      anon_sym_SLASH,
    ACTIONS(8584), 1,
      anon_sym_CARET,
    ACTIONS(8586), 1,
      anon_sym_PIPE,
    ACTIONS(8588), 1,
      anon_sym_AMP,
    ACTIONS(8592), 1,
      anon_sym_GT_GT,
    ACTIONS(8598), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8600), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8602), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8604), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8608), 1,
      anon_sym_as,
    ACTIONS(8610), 1,
      anon_sym_is,
    ACTIONS(8646), 1,
      anon_sym_by,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8574), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8578), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8580), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8590), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8594), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8596), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6315), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [218040] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5510), 1,
      anon_sym_in,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(8650), 1,
      anon_sym_QMARK,
    ACTIONS(8656), 1,
      anon_sym_SLASH,
    ACTIONS(8658), 1,
      anon_sym_CARET,
    ACTIONS(8660), 1,
      anon_sym_PIPE,
    ACTIONS(8662), 1,
      anon_sym_AMP,
    ACTIONS(8666), 1,
      anon_sym_GT_GT,
    ACTIONS(8672), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8674), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8676), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8678), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8680), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8648), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8652), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8654), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8664), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8668), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8670), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6316), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [218172] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(8628), 1,
      anon_sym_LPAREN,
    ACTIONS(8682), 1,
      anon_sym_operator,
    ACTIONS(8684), 1,
      anon_sym_this,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(2738), 1,
      sym_generic_name,
    STATE(7187), 1,
      sym_explicit_interface_specifier,
    STATE(7473), 1,
      sym_identifier,
    STATE(8056), 1,
      sym_tuple_pattern,
    STATE(8608), 1,
      sym_variable_declarator,
    STATE(9003), 1,
      sym__name,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6317), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [218272] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7210), 1,
      anon_sym_is,
    ACTIONS(7438), 1,
      anon_sym_QMARK,
    ACTIONS(7444), 1,
      anon_sym_SLASH,
    ACTIONS(7446), 1,
      anon_sym_CARET,
    ACTIONS(7448), 1,
      anon_sym_PIPE,
    ACTIONS(7450), 1,
      anon_sym_AMP,
    ACTIONS(7454), 1,
      anon_sym_GT_GT,
    ACTIONS(7460), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7462), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7464), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7466), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8686), 1,
      anon_sym_SEMI,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7436), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7440), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7442), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7452), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7456), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7458), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6318), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [218404] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8556), 1,
      anon_sym_and,
    ACTIONS(8558), 1,
      anon_sym_or,
    STATE(6319), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6609), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6607), 23,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [218486] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(8688), 1,
      anon_sym_COMMA,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6320), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [218618] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(8690), 1,
      anon_sym_RPAREN,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6321), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [218750] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7651), 1,
      anon_sym_as,
    ACTIONS(8486), 1,
      anon_sym_QMARK,
    ACTIONS(8492), 1,
      anon_sym_SLASH,
    ACTIONS(8494), 1,
      anon_sym_CARET,
    ACTIONS(8496), 1,
      anon_sym_PIPE,
    ACTIONS(8498), 1,
      anon_sym_AMP,
    ACTIONS(8502), 1,
      anon_sym_GT_GT,
    ACTIONS(8508), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8512), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8514), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8516), 1,
      anon_sym_is,
    ACTIONS(8692), 1,
      anon_sym_COLON,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8484), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8488), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8490), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8500), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8504), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8506), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6322), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [218882] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5325), 1,
      anon_sym_in,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(8650), 1,
      anon_sym_QMARK,
    ACTIONS(8656), 1,
      anon_sym_SLASH,
    ACTIONS(8658), 1,
      anon_sym_CARET,
    ACTIONS(8660), 1,
      anon_sym_PIPE,
    ACTIONS(8662), 1,
      anon_sym_AMP,
    ACTIONS(8666), 1,
      anon_sym_GT_GT,
    ACTIONS(8672), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8674), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8676), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8678), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8680), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8648), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8652), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8654), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8664), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8668), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8670), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6323), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [219014] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7210), 1,
      anon_sym_is,
    ACTIONS(7438), 1,
      anon_sym_QMARK,
    ACTIONS(7444), 1,
      anon_sym_SLASH,
    ACTIONS(7446), 1,
      anon_sym_CARET,
    ACTIONS(7448), 1,
      anon_sym_PIPE,
    ACTIONS(7450), 1,
      anon_sym_AMP,
    ACTIONS(7454), 1,
      anon_sym_GT_GT,
    ACTIONS(7460), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7462), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7464), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7466), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8694), 1,
      anon_sym_SEMI,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7436), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7440), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7442), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7452), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7456), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7458), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6324), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [219146] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7651), 1,
      anon_sym_as,
    ACTIONS(8486), 1,
      anon_sym_QMARK,
    ACTIONS(8492), 1,
      anon_sym_SLASH,
    ACTIONS(8494), 1,
      anon_sym_CARET,
    ACTIONS(8496), 1,
      anon_sym_PIPE,
    ACTIONS(8498), 1,
      anon_sym_AMP,
    ACTIONS(8502), 1,
      anon_sym_GT_GT,
    ACTIONS(8508), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8512), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8514), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8516), 1,
      anon_sym_is,
    ACTIONS(8696), 1,
      anon_sym_COLON,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8484), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8488), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8490), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8500), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8504), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8506), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6325), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [219278] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(8698), 1,
      anon_sym_RPAREN,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6326), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [219410] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7210), 1,
      anon_sym_is,
    ACTIONS(7438), 1,
      anon_sym_QMARK,
    ACTIONS(7444), 1,
      anon_sym_SLASH,
    ACTIONS(7446), 1,
      anon_sym_CARET,
    ACTIONS(7448), 1,
      anon_sym_PIPE,
    ACTIONS(7450), 1,
      anon_sym_AMP,
    ACTIONS(7454), 1,
      anon_sym_GT_GT,
    ACTIONS(7460), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7462), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7464), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7466), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8700), 1,
      anon_sym_SEMI,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7436), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7440), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7442), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7452), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7456), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7458), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6327), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [219542] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5337), 1,
      anon_sym_COLON,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7651), 1,
      anon_sym_as,
    ACTIONS(8486), 1,
      anon_sym_QMARK,
    ACTIONS(8492), 1,
      anon_sym_SLASH,
    ACTIONS(8494), 1,
      anon_sym_CARET,
    ACTIONS(8496), 1,
      anon_sym_PIPE,
    ACTIONS(8498), 1,
      anon_sym_AMP,
    ACTIONS(8502), 1,
      anon_sym_GT_GT,
    ACTIONS(8508), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8512), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8514), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8516), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8484), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8488), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8490), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8500), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8504), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8506), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6328), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [219674] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(8576), 1,
      anon_sym_QMARK,
    ACTIONS(8582), 1,
      anon_sym_SLASH,
    ACTIONS(8584), 1,
      anon_sym_CARET,
    ACTIONS(8586), 1,
      anon_sym_PIPE,
    ACTIONS(8588), 1,
      anon_sym_AMP,
    ACTIONS(8592), 1,
      anon_sym_GT_GT,
    ACTIONS(8598), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8600), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8602), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8604), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8608), 1,
      anon_sym_as,
    ACTIONS(8610), 1,
      anon_sym_is,
    ACTIONS(8702), 1,
      anon_sym_by,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8574), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8578), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8580), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8590), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8594), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8596), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6329), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [219806] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(8704), 1,
      anon_sym_RPAREN,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6330), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [219938] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8706), 1,
      anon_sym_RPAREN,
    STATE(6331), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5251), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5249), 24,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [220018] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(8708), 1,
      anon_sym_RPAREN,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6332), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [220150] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5385), 1,
      anon_sym_COLON,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7651), 1,
      anon_sym_as,
    ACTIONS(8486), 1,
      anon_sym_QMARK,
    ACTIONS(8492), 1,
      anon_sym_SLASH,
    ACTIONS(8494), 1,
      anon_sym_CARET,
    ACTIONS(8496), 1,
      anon_sym_PIPE,
    ACTIONS(8498), 1,
      anon_sym_AMP,
    ACTIONS(8502), 1,
      anon_sym_GT_GT,
    ACTIONS(8508), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8512), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8514), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8516), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8484), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8488), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8490), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8500), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8504), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8506), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6333), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [220282] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5396), 1,
      anon_sym_COLON,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7651), 1,
      anon_sym_as,
    ACTIONS(8486), 1,
      anon_sym_QMARK,
    ACTIONS(8492), 1,
      anon_sym_SLASH,
    ACTIONS(8494), 1,
      anon_sym_CARET,
    ACTIONS(8496), 1,
      anon_sym_PIPE,
    ACTIONS(8498), 1,
      anon_sym_AMP,
    ACTIONS(8502), 1,
      anon_sym_GT_GT,
    ACTIONS(8508), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8512), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8514), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8516), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8484), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8488), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8490), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8500), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8504), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8506), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6334), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [220414] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6236), 1,
      anon_sym_COLON,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7651), 1,
      anon_sym_as,
    ACTIONS(8486), 1,
      anon_sym_QMARK,
    ACTIONS(8492), 1,
      anon_sym_SLASH,
    ACTIONS(8494), 1,
      anon_sym_CARET,
    ACTIONS(8496), 1,
      anon_sym_PIPE,
    ACTIONS(8498), 1,
      anon_sym_AMP,
    ACTIONS(8502), 1,
      anon_sym_GT_GT,
    ACTIONS(8508), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8512), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8514), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8516), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8484), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8488), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8490), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8500), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8504), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8506), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6335), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [220546] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5510), 1,
      anon_sym_equals,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(8522), 1,
      anon_sym_QMARK,
    ACTIONS(8528), 1,
      anon_sym_SLASH,
    ACTIONS(8530), 1,
      anon_sym_CARET,
    ACTIONS(8532), 1,
      anon_sym_PIPE,
    ACTIONS(8534), 1,
      anon_sym_AMP,
    ACTIONS(8538), 1,
      anon_sym_GT_GT,
    ACTIONS(8544), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8546), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8548), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8550), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8552), 1,
      anon_sym_as,
    ACTIONS(8554), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8520), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8524), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8526), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8536), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8540), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8542), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6336), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [220678] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(8710), 1,
      anon_sym_RPAREN,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6337), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [220810] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7651), 1,
      anon_sym_as,
    ACTIONS(8486), 1,
      anon_sym_QMARK,
    ACTIONS(8492), 1,
      anon_sym_SLASH,
    ACTIONS(8494), 1,
      anon_sym_CARET,
    ACTIONS(8496), 1,
      anon_sym_PIPE,
    ACTIONS(8498), 1,
      anon_sym_AMP,
    ACTIONS(8502), 1,
      anon_sym_GT_GT,
    ACTIONS(8508), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8512), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8514), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8516), 1,
      anon_sym_is,
    ACTIONS(8712), 1,
      anon_sym_COLON,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8484), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8488), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8490), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8500), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8504), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8506), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6338), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [220942] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7210), 1,
      anon_sym_is,
    ACTIONS(7438), 1,
      anon_sym_QMARK,
    ACTIONS(7444), 1,
      anon_sym_SLASH,
    ACTIONS(7446), 1,
      anon_sym_CARET,
    ACTIONS(7448), 1,
      anon_sym_PIPE,
    ACTIONS(7450), 1,
      anon_sym_AMP,
    ACTIONS(7454), 1,
      anon_sym_GT_GT,
    ACTIONS(7460), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7462), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7464), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7466), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8714), 1,
      anon_sym_SEMI,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7436), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7440), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7442), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7452), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7456), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7458), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6339), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [221074] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8716), 1,
      anon_sym_into,
    STATE(6522), 1,
      aux_sym__query_body_repeat2,
    STATE(6340), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6448), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6446), 23,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [221156] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(8718), 1,
      anon_sym_RPAREN,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6341), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [221288] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7651), 1,
      anon_sym_as,
    ACTIONS(8486), 1,
      anon_sym_QMARK,
    ACTIONS(8492), 1,
      anon_sym_SLASH,
    ACTIONS(8494), 1,
      anon_sym_CARET,
    ACTIONS(8496), 1,
      anon_sym_PIPE,
    ACTIONS(8498), 1,
      anon_sym_AMP,
    ACTIONS(8502), 1,
      anon_sym_GT_GT,
    ACTIONS(8508), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8512), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8514), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8516), 1,
      anon_sym_is,
    ACTIONS(8720), 1,
      anon_sym_COLON,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8484), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8488), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8490), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8500), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8504), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8506), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6342), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [221420] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(8722), 1,
      anon_sym_RPAREN,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6343), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [221552] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8724), 1,
      anon_sym_and,
    STATE(6344), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6546), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6544), 24,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [221632] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7210), 1,
      anon_sym_is,
    ACTIONS(7438), 1,
      anon_sym_QMARK,
    ACTIONS(7444), 1,
      anon_sym_SLASH,
    ACTIONS(7446), 1,
      anon_sym_CARET,
    ACTIONS(7448), 1,
      anon_sym_PIPE,
    ACTIONS(7450), 1,
      anon_sym_AMP,
    ACTIONS(7454), 1,
      anon_sym_GT_GT,
    ACTIONS(7460), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7462), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7464), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7466), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8726), 1,
      anon_sym_SEMI,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7436), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7440), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7442), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7452), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7456), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7458), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6345), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [221764] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7651), 1,
      anon_sym_as,
    ACTIONS(8486), 1,
      anon_sym_QMARK,
    ACTIONS(8492), 1,
      anon_sym_SLASH,
    ACTIONS(8494), 1,
      anon_sym_CARET,
    ACTIONS(8496), 1,
      anon_sym_PIPE,
    ACTIONS(8498), 1,
      anon_sym_AMP,
    ACTIONS(8502), 1,
      anon_sym_GT_GT,
    ACTIONS(8508), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8512), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8514), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8516), 1,
      anon_sym_is,
    ACTIONS(8728), 1,
      anon_sym_COLON,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8484), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8488), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8490), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8500), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8504), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8506), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6346), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [221896] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(8732), 1,
      anon_sym_QMARK,
    ACTIONS(8738), 1,
      anon_sym_SLASH,
    ACTIONS(8740), 1,
      anon_sym_CARET,
    ACTIONS(8742), 1,
      anon_sym_PIPE,
    ACTIONS(8744), 1,
      anon_sym_AMP,
    ACTIONS(8748), 1,
      anon_sym_GT_GT,
    ACTIONS(8754), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8756), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8758), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8760), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8762), 1,
      anon_sym_on,
    ACTIONS(8764), 1,
      anon_sym_as,
    ACTIONS(8766), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8730), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8734), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8736), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8746), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8750), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8752), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6347), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [222028] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(8768), 1,
      anon_sym_RPAREN,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6348), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [222160] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8562), 1,
      anon_sym_and,
    STATE(6349), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6546), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6544), 24,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [222240] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(8770), 1,
      anon_sym_RPAREN,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6350), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [222372] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7210), 1,
      anon_sym_is,
    ACTIONS(7438), 1,
      anon_sym_QMARK,
    ACTIONS(7444), 1,
      anon_sym_SLASH,
    ACTIONS(7446), 1,
      anon_sym_CARET,
    ACTIONS(7448), 1,
      anon_sym_PIPE,
    ACTIONS(7450), 1,
      anon_sym_AMP,
    ACTIONS(7454), 1,
      anon_sym_GT_GT,
    ACTIONS(7460), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7462), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7464), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7466), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8772), 1,
      anon_sym_SEMI,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7436), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7440), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7442), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7452), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7456), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7458), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6351), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [222504] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6216), 1,
      anon_sym_COLON,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7651), 1,
      anon_sym_as,
    ACTIONS(8486), 1,
      anon_sym_QMARK,
    ACTIONS(8492), 1,
      anon_sym_SLASH,
    ACTIONS(8494), 1,
      anon_sym_CARET,
    ACTIONS(8496), 1,
      anon_sym_PIPE,
    ACTIONS(8498), 1,
      anon_sym_AMP,
    ACTIONS(8502), 1,
      anon_sym_GT_GT,
    ACTIONS(8508), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8512), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8514), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8516), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8484), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8488), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8490), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8500), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8504), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8506), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6352), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [222636] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5420), 1,
      anon_sym_in,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(8650), 1,
      anon_sym_QMARK,
    ACTIONS(8656), 1,
      anon_sym_SLASH,
    ACTIONS(8658), 1,
      anon_sym_CARET,
    ACTIONS(8660), 1,
      anon_sym_PIPE,
    ACTIONS(8662), 1,
      anon_sym_AMP,
    ACTIONS(8666), 1,
      anon_sym_GT_GT,
    ACTIONS(8672), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8674), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8676), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8678), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8680), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8648), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8652), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8654), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8664), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8668), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8670), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6353), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [222768] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(8774), 1,
      anon_sym_RPAREN,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6354), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [222900] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(8576), 1,
      anon_sym_QMARK,
    ACTIONS(8582), 1,
      anon_sym_SLASH,
    ACTIONS(8584), 1,
      anon_sym_CARET,
    ACTIONS(8586), 1,
      anon_sym_PIPE,
    ACTIONS(8588), 1,
      anon_sym_AMP,
    ACTIONS(8592), 1,
      anon_sym_GT_GT,
    ACTIONS(8598), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8600), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8602), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8604), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8608), 1,
      anon_sym_as,
    ACTIONS(8610), 1,
      anon_sym_is,
    ACTIONS(8776), 1,
      anon_sym_by,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8574), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8578), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8580), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8590), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8594), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8596), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6355), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [223032] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7651), 1,
      anon_sym_as,
    ACTIONS(8486), 1,
      anon_sym_QMARK,
    ACTIONS(8492), 1,
      anon_sym_SLASH,
    ACTIONS(8494), 1,
      anon_sym_CARET,
    ACTIONS(8496), 1,
      anon_sym_PIPE,
    ACTIONS(8498), 1,
      anon_sym_AMP,
    ACTIONS(8502), 1,
      anon_sym_GT_GT,
    ACTIONS(8508), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8512), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8514), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8516), 1,
      anon_sym_is,
    ACTIONS(8778), 1,
      anon_sym_COLON,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8484), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8488), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8490), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8500), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8504), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8506), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6356), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [223164] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5325), 1,
      anon_sym_equals,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(8522), 1,
      anon_sym_QMARK,
    ACTIONS(8528), 1,
      anon_sym_SLASH,
    ACTIONS(8530), 1,
      anon_sym_CARET,
    ACTIONS(8532), 1,
      anon_sym_PIPE,
    ACTIONS(8534), 1,
      anon_sym_AMP,
    ACTIONS(8538), 1,
      anon_sym_GT_GT,
    ACTIONS(8544), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8546), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8548), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8550), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8552), 1,
      anon_sym_as,
    ACTIONS(8554), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8520), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8524), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8526), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8536), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8540), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8542), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6357), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [223296] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8780), 1,
      anon_sym_into,
    STATE(6361), 1,
      aux_sym__query_body_repeat2,
    STATE(6358), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6383), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6381), 23,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [223378] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(8782), 1,
      anon_sym_RPAREN,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6359), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [223510] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7210), 1,
      anon_sym_is,
    ACTIONS(7438), 1,
      anon_sym_QMARK,
    ACTIONS(7444), 1,
      anon_sym_SLASH,
    ACTIONS(7446), 1,
      anon_sym_CARET,
    ACTIONS(7448), 1,
      anon_sym_PIPE,
    ACTIONS(7450), 1,
      anon_sym_AMP,
    ACTIONS(7454), 1,
      anon_sym_GT_GT,
    ACTIONS(7460), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7462), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7464), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7466), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8784), 1,
      anon_sym_SEMI,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7436), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7440), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7442), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7452), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7456), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7458), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6360), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [223642] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8786), 1,
      anon_sym_into,
    STATE(6361), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym__query_body_repeat2,
    ACTIONS(6376), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6374), 23,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [223722] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5325), 1,
      anon_sym_COLON,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7651), 1,
      anon_sym_as,
    ACTIONS(8486), 1,
      anon_sym_QMARK,
    ACTIONS(8492), 1,
      anon_sym_SLASH,
    ACTIONS(8494), 1,
      anon_sym_CARET,
    ACTIONS(8496), 1,
      anon_sym_PIPE,
    ACTIONS(8498), 1,
      anon_sym_AMP,
    ACTIONS(8502), 1,
      anon_sym_GT_GT,
    ACTIONS(8508), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8512), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8514), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8516), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8484), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8488), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8490), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8500), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8504), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8506), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6362), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [223854] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7651), 1,
      anon_sym_as,
    ACTIONS(8486), 1,
      anon_sym_QMARK,
    ACTIONS(8492), 1,
      anon_sym_SLASH,
    ACTIONS(8494), 1,
      anon_sym_CARET,
    ACTIONS(8496), 1,
      anon_sym_PIPE,
    ACTIONS(8498), 1,
      anon_sym_AMP,
    ACTIONS(8502), 1,
      anon_sym_GT_GT,
    ACTIONS(8508), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8512), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8514), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8516), 1,
      anon_sym_is,
    ACTIONS(8789), 1,
      anon_sym_COLON,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8484), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8488), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8490), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8500), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8504), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8506), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6363), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [223986] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2001), 1,
      anon_sym_SEMI,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7210), 1,
      anon_sym_is,
    ACTIONS(7438), 1,
      anon_sym_QMARK,
    ACTIONS(7444), 1,
      anon_sym_SLASH,
    ACTIONS(7446), 1,
      anon_sym_CARET,
    ACTIONS(7448), 1,
      anon_sym_PIPE,
    ACTIONS(7450), 1,
      anon_sym_AMP,
    ACTIONS(7454), 1,
      anon_sym_GT_GT,
    ACTIONS(7460), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7462), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7464), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7466), 1,
      anon_sym_QMARK_QMARK,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7436), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7440), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7442), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7452), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7456), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7458), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6364), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [224118] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7651), 1,
      anon_sym_as,
    ACTIONS(8486), 1,
      anon_sym_QMARK,
    ACTIONS(8492), 1,
      anon_sym_SLASH,
    ACTIONS(8494), 1,
      anon_sym_CARET,
    ACTIONS(8496), 1,
      anon_sym_PIPE,
    ACTIONS(8498), 1,
      anon_sym_AMP,
    ACTIONS(8502), 1,
      anon_sym_GT_GT,
    ACTIONS(8508), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8512), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8514), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8516), 1,
      anon_sym_is,
    ACTIONS(8791), 1,
      anon_sym_COLON,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8484), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8488), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8490), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8500), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8504), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8506), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6365), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [224250] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(8650), 1,
      anon_sym_QMARK,
    ACTIONS(8656), 1,
      anon_sym_SLASH,
    ACTIONS(8658), 1,
      anon_sym_CARET,
    ACTIONS(8660), 1,
      anon_sym_PIPE,
    ACTIONS(8662), 1,
      anon_sym_AMP,
    ACTIONS(8666), 1,
      anon_sym_GT_GT,
    ACTIONS(8672), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8674), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8676), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8678), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8680), 1,
      anon_sym_is,
    ACTIONS(8793), 1,
      anon_sym_in,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8648), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8652), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8654), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8664), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8668), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8670), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6366), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [224382] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6216), 1,
      anon_sym_equals,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(8522), 1,
      anon_sym_QMARK,
    ACTIONS(8528), 1,
      anon_sym_SLASH,
    ACTIONS(8530), 1,
      anon_sym_CARET,
    ACTIONS(8532), 1,
      anon_sym_PIPE,
    ACTIONS(8534), 1,
      anon_sym_AMP,
    ACTIONS(8538), 1,
      anon_sym_GT_GT,
    ACTIONS(8544), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8546), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8548), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8550), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8552), 1,
      anon_sym_as,
    ACTIONS(8554), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8520), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8524), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8526), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8536), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8540), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8542), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6367), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [224514] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(8795), 1,
      anon_sym_RPAREN,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6368), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [224646] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(8576), 1,
      anon_sym_QMARK,
    ACTIONS(8582), 1,
      anon_sym_SLASH,
    ACTIONS(8584), 1,
      anon_sym_CARET,
    ACTIONS(8586), 1,
      anon_sym_PIPE,
    ACTIONS(8588), 1,
      anon_sym_AMP,
    ACTIONS(8592), 1,
      anon_sym_GT_GT,
    ACTIONS(8598), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8600), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8602), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8604), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8608), 1,
      anon_sym_as,
    ACTIONS(8610), 1,
      anon_sym_is,
    ACTIONS(8797), 1,
      anon_sym_by,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8574), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8578), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8580), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8590), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8594), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8596), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6369), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [224778] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(8576), 1,
      anon_sym_QMARK,
    ACTIONS(8582), 1,
      anon_sym_SLASH,
    ACTIONS(8584), 1,
      anon_sym_CARET,
    ACTIONS(8586), 1,
      anon_sym_PIPE,
    ACTIONS(8588), 1,
      anon_sym_AMP,
    ACTIONS(8592), 1,
      anon_sym_GT_GT,
    ACTIONS(8598), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8600), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8602), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8604), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8608), 1,
      anon_sym_as,
    ACTIONS(8610), 1,
      anon_sym_is,
    ACTIONS(8799), 1,
      anon_sym_by,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8574), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8578), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8580), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8590), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8594), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8596), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6370), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [224910] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5396), 1,
      anon_sym_equals,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(8522), 1,
      anon_sym_QMARK,
    ACTIONS(8528), 1,
      anon_sym_SLASH,
    ACTIONS(8530), 1,
      anon_sym_CARET,
    ACTIONS(8532), 1,
      anon_sym_PIPE,
    ACTIONS(8534), 1,
      anon_sym_AMP,
    ACTIONS(8538), 1,
      anon_sym_GT_GT,
    ACTIONS(8544), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8546), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8548), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8550), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8552), 1,
      anon_sym_as,
    ACTIONS(8554), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8520), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8524), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8526), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8536), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8540), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8542), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6371), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [225042] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(8801), 1,
      anon_sym_RPAREN,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6372), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [225174] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(8728), 1,
      anon_sym_EQ_GT,
    ACTIONS(8805), 1,
      anon_sym_QMARK,
    ACTIONS(8811), 1,
      anon_sym_SLASH,
    ACTIONS(8813), 1,
      anon_sym_CARET,
    ACTIONS(8815), 1,
      anon_sym_PIPE,
    ACTIONS(8817), 1,
      anon_sym_AMP,
    ACTIONS(8821), 1,
      anon_sym_GT_GT,
    ACTIONS(8827), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8829), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8831), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8833), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8835), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8803), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8807), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8809), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8819), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8823), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8825), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6373), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [225306] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7651), 1,
      anon_sym_as,
    ACTIONS(8486), 1,
      anon_sym_QMARK,
    ACTIONS(8492), 1,
      anon_sym_SLASH,
    ACTIONS(8494), 1,
      anon_sym_CARET,
    ACTIONS(8496), 1,
      anon_sym_PIPE,
    ACTIONS(8498), 1,
      anon_sym_AMP,
    ACTIONS(8502), 1,
      anon_sym_GT_GT,
    ACTIONS(8508), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8512), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8514), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8516), 1,
      anon_sym_is,
    ACTIONS(8837), 1,
      anon_sym_COLON,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8484), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8488), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8490), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8500), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8504), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8506), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6374), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [225438] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8839), 1,
      anon_sym_and,
    ACTIONS(8841), 1,
      anon_sym_or,
    STATE(6375), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6609), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6607), 23,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [225520] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7210), 1,
      anon_sym_is,
    ACTIONS(7438), 1,
      anon_sym_QMARK,
    ACTIONS(7444), 1,
      anon_sym_SLASH,
    ACTIONS(7446), 1,
      anon_sym_CARET,
    ACTIONS(7448), 1,
      anon_sym_PIPE,
    ACTIONS(7450), 1,
      anon_sym_AMP,
    ACTIONS(7454), 1,
      anon_sym_GT_GT,
    ACTIONS(7460), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7462), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7464), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7466), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8843), 1,
      anon_sym_SEMI,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7436), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7440), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7442), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7452), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7456), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7458), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6376), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [225652] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7651), 1,
      anon_sym_as,
    ACTIONS(8486), 1,
      anon_sym_QMARK,
    ACTIONS(8492), 1,
      anon_sym_SLASH,
    ACTIONS(8494), 1,
      anon_sym_CARET,
    ACTIONS(8496), 1,
      anon_sym_PIPE,
    ACTIONS(8498), 1,
      anon_sym_AMP,
    ACTIONS(8502), 1,
      anon_sym_GT_GT,
    ACTIONS(8508), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8512), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8514), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8516), 1,
      anon_sym_is,
    ACTIONS(8845), 1,
      anon_sym_COLON,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8484), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8488), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8490), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8500), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8504), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8506), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6377), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [225784] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(8847), 1,
      anon_sym_RPAREN,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6378), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [225916] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(8576), 1,
      anon_sym_QMARK,
    ACTIONS(8582), 1,
      anon_sym_SLASH,
    ACTIONS(8584), 1,
      anon_sym_CARET,
    ACTIONS(8586), 1,
      anon_sym_PIPE,
    ACTIONS(8588), 1,
      anon_sym_AMP,
    ACTIONS(8592), 1,
      anon_sym_GT_GT,
    ACTIONS(8598), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8600), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8602), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8604), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8608), 1,
      anon_sym_as,
    ACTIONS(8610), 1,
      anon_sym_is,
    ACTIONS(8849), 1,
      anon_sym_by,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8574), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8578), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8580), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8590), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8594), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8596), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6379), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [226048] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(8851), 1,
      anon_sym_RPAREN,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6380), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [226180] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(8853), 1,
      anon_sym_RPAREN,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6381), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [226312] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(8855), 1,
      anon_sym_RPAREN,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6382), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [226444] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(8857), 1,
      anon_sym_RPAREN,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6383), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [226576] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(8859), 1,
      anon_sym_RPAREN,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6384), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [226708] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8562), 1,
      anon_sym_and,
    ACTIONS(8564), 1,
      anon_sym_or,
    STATE(6385), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5856), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5854), 23,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [226790] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5385), 1,
      anon_sym_equals,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(8522), 1,
      anon_sym_QMARK,
    ACTIONS(8528), 1,
      anon_sym_SLASH,
    ACTIONS(8530), 1,
      anon_sym_CARET,
    ACTIONS(8532), 1,
      anon_sym_PIPE,
    ACTIONS(8534), 1,
      anon_sym_AMP,
    ACTIONS(8538), 1,
      anon_sym_GT_GT,
    ACTIONS(8544), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8546), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8548), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8550), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8552), 1,
      anon_sym_as,
    ACTIONS(8554), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8520), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8524), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8526), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8536), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8540), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8542), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6386), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [226922] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(8861), 1,
      anon_sym_COMMA,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6387), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [227054] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7210), 1,
      anon_sym_is,
    ACTIONS(7438), 1,
      anon_sym_QMARK,
    ACTIONS(7444), 1,
      anon_sym_SLASH,
    ACTIONS(7446), 1,
      anon_sym_CARET,
    ACTIONS(7448), 1,
      anon_sym_PIPE,
    ACTIONS(7450), 1,
      anon_sym_AMP,
    ACTIONS(7454), 1,
      anon_sym_GT_GT,
    ACTIONS(7460), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7462), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7464), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7466), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8863), 1,
      anon_sym_SEMI,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7436), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7440), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7442), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7452), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7456), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7458), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6388), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [227186] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5337), 1,
      anon_sym_equals,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(8522), 1,
      anon_sym_QMARK,
    ACTIONS(8528), 1,
      anon_sym_SLASH,
    ACTIONS(8530), 1,
      anon_sym_CARET,
    ACTIONS(8532), 1,
      anon_sym_PIPE,
    ACTIONS(8534), 1,
      anon_sym_AMP,
    ACTIONS(8538), 1,
      anon_sym_GT_GT,
    ACTIONS(8544), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8546), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8548), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8550), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8552), 1,
      anon_sym_as,
    ACTIONS(8554), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8520), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8524), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8526), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8536), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8540), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8542), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6389), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [227318] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7210), 1,
      anon_sym_is,
    ACTIONS(7438), 1,
      anon_sym_QMARK,
    ACTIONS(7444), 1,
      anon_sym_SLASH,
    ACTIONS(7446), 1,
      anon_sym_CARET,
    ACTIONS(7448), 1,
      anon_sym_PIPE,
    ACTIONS(7450), 1,
      anon_sym_AMP,
    ACTIONS(7454), 1,
      anon_sym_GT_GT,
    ACTIONS(7460), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7462), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7464), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7466), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8865), 1,
      anon_sym_SEMI,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7436), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7440), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7442), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7452), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7456), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7458), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6390), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [227450] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7210), 1,
      anon_sym_is,
    ACTIONS(7438), 1,
      anon_sym_QMARK,
    ACTIONS(7444), 1,
      anon_sym_SLASH,
    ACTIONS(7446), 1,
      anon_sym_CARET,
    ACTIONS(7448), 1,
      anon_sym_PIPE,
    ACTIONS(7450), 1,
      anon_sym_AMP,
    ACTIONS(7454), 1,
      anon_sym_GT_GT,
    ACTIONS(7460), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7462), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7464), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7466), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8867), 1,
      anon_sym_SEMI,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7436), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7440), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7442), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7452), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7456), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7458), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6391), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [227582] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7651), 1,
      anon_sym_as,
    ACTIONS(8486), 1,
      anon_sym_QMARK,
    ACTIONS(8492), 1,
      anon_sym_SLASH,
    ACTIONS(8494), 1,
      anon_sym_CARET,
    ACTIONS(8496), 1,
      anon_sym_PIPE,
    ACTIONS(8498), 1,
      anon_sym_AMP,
    ACTIONS(8502), 1,
      anon_sym_GT_GT,
    ACTIONS(8508), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8512), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8514), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8516), 1,
      anon_sym_is,
    ACTIONS(8869), 1,
      anon_sym_COLON,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8484), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8488), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8490), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8500), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8504), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8506), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6392), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [227714] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7651), 1,
      anon_sym_as,
    ACTIONS(8486), 1,
      anon_sym_QMARK,
    ACTIONS(8492), 1,
      anon_sym_SLASH,
    ACTIONS(8494), 1,
      anon_sym_CARET,
    ACTIONS(8496), 1,
      anon_sym_PIPE,
    ACTIONS(8498), 1,
      anon_sym_AMP,
    ACTIONS(8502), 1,
      anon_sym_GT_GT,
    ACTIONS(8508), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8512), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8514), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8516), 1,
      anon_sym_is,
    ACTIONS(8871), 1,
      anon_sym_COLON,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8484), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8488), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8490), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8500), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8504), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8506), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6393), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [227846] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7651), 1,
      anon_sym_as,
    ACTIONS(8486), 1,
      anon_sym_QMARK,
    ACTIONS(8492), 1,
      anon_sym_SLASH,
    ACTIONS(8494), 1,
      anon_sym_CARET,
    ACTIONS(8496), 1,
      anon_sym_PIPE,
    ACTIONS(8498), 1,
      anon_sym_AMP,
    ACTIONS(8502), 1,
      anon_sym_GT_GT,
    ACTIONS(8508), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8512), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8514), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8516), 1,
      anon_sym_is,
    ACTIONS(8873), 1,
      anon_sym_COLON,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8484), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8488), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8490), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8500), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8504), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8506), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6394), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [227978] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8780), 1,
      anon_sym_into,
    STATE(6358), 1,
      aux_sym__query_body_repeat2,
    STATE(6395), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6420), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6418), 23,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [228060] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7210), 1,
      anon_sym_is,
    ACTIONS(7438), 1,
      anon_sym_QMARK,
    ACTIONS(7444), 1,
      anon_sym_SLASH,
    ACTIONS(7446), 1,
      anon_sym_CARET,
    ACTIONS(7448), 1,
      anon_sym_PIPE,
    ACTIONS(7450), 1,
      anon_sym_AMP,
    ACTIONS(7454), 1,
      anon_sym_GT_GT,
    ACTIONS(7460), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7462), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7464), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7466), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8875), 1,
      anon_sym_SEMI,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7436), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7440), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7442), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7452), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7456), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7458), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6396), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [228192] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8877), 1,
      anon_sym_into,
    STATE(6571), 1,
      aux_sym__query_body_repeat2,
    STATE(6397), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6448), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6446), 23,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [228274] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6114), 1,
      anon_sym_in,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(8656), 1,
      anon_sym_SLASH,
    ACTIONS(8658), 1,
      anon_sym_CARET,
    ACTIONS(8660), 1,
      anon_sym_PIPE,
    ACTIONS(8662), 1,
      anon_sym_AMP,
    ACTIONS(8666), 1,
      anon_sym_GT_GT,
    ACTIONS(8672), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8674), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8676), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8678), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8680), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8648), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8652), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8654), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8664), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8668), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8670), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6398), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [228406] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(8879), 1,
      anon_sym_RPAREN,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6399), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [228538] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8881), 1,
      anon_sym_RPAREN,
    STATE(6400), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5251), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5249), 24,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [228618] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(8656), 1,
      anon_sym_SLASH,
    ACTIONS(8658), 1,
      anon_sym_CARET,
    ACTIONS(8660), 1,
      anon_sym_PIPE,
    ACTIONS(8662), 1,
      anon_sym_AMP,
    ACTIONS(8666), 1,
      anon_sym_GT_GT,
    ACTIONS(8672), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8674), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8680), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8648), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8652), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8654), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8664), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8668), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8670), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 3,
      anon_sym_in,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(6401), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [228746] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(8656), 1,
      anon_sym_SLASH,
    ACTIONS(8658), 1,
      anon_sym_CARET,
    ACTIONS(8660), 1,
      anon_sym_PIPE,
    ACTIONS(8662), 1,
      anon_sym_AMP,
    ACTIONS(8666), 1,
      anon_sym_GT_GT,
    ACTIONS(8672), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8680), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8648), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8652), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8654), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8664), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8668), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8670), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 4,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(6402), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [228872] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6236), 1,
      anon_sym_by,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(8576), 1,
      anon_sym_QMARK,
    ACTIONS(8582), 1,
      anon_sym_SLASH,
    ACTIONS(8584), 1,
      anon_sym_CARET,
    ACTIONS(8586), 1,
      anon_sym_PIPE,
    ACTIONS(8588), 1,
      anon_sym_AMP,
    ACTIONS(8592), 1,
      anon_sym_GT_GT,
    ACTIONS(8598), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8600), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8602), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8604), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8608), 1,
      anon_sym_as,
    ACTIONS(8610), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8574), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8578), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8580), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8590), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8594), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8596), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6403), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [229004] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7210), 1,
      anon_sym_is,
    ACTIONS(7438), 1,
      anon_sym_QMARK,
    ACTIONS(7444), 1,
      anon_sym_SLASH,
    ACTIONS(7446), 1,
      anon_sym_CARET,
    ACTIONS(7448), 1,
      anon_sym_PIPE,
    ACTIONS(7450), 1,
      anon_sym_AMP,
    ACTIONS(7454), 1,
      anon_sym_GT_GT,
    ACTIONS(7460), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7462), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7464), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7466), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8883), 1,
      anon_sym_SEMI,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7436), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7440), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7442), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7452), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7456), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7458), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6404), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [229136] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9359), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    ACTIONS(4349), 6,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
    STATE(6405), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4347), 26,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [229222] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(8576), 1,
      anon_sym_QMARK,
    ACTIONS(8582), 1,
      anon_sym_SLASH,
    ACTIONS(8584), 1,
      anon_sym_CARET,
    ACTIONS(8586), 1,
      anon_sym_PIPE,
    ACTIONS(8588), 1,
      anon_sym_AMP,
    ACTIONS(8592), 1,
      anon_sym_GT_GT,
    ACTIONS(8598), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8600), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8602), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8604), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8608), 1,
      anon_sym_as,
    ACTIONS(8610), 1,
      anon_sym_is,
    ACTIONS(8885), 1,
      anon_sym_by,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8574), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8578), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8580), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8590), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8594), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8596), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6406), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [229354] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(8887), 1,
      anon_sym_RPAREN,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6407), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [229486] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7210), 1,
      anon_sym_is,
    ACTIONS(7438), 1,
      anon_sym_QMARK,
    ACTIONS(7444), 1,
      anon_sym_SLASH,
    ACTIONS(7446), 1,
      anon_sym_CARET,
    ACTIONS(7448), 1,
      anon_sym_PIPE,
    ACTIONS(7450), 1,
      anon_sym_AMP,
    ACTIONS(7454), 1,
      anon_sym_GT_GT,
    ACTIONS(7460), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7462), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7464), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7466), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8889), 1,
      anon_sym_SEMI,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7436), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7440), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7442), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7452), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7456), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7458), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6408), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [229618] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(8576), 1,
      anon_sym_QMARK,
    ACTIONS(8582), 1,
      anon_sym_SLASH,
    ACTIONS(8584), 1,
      anon_sym_CARET,
    ACTIONS(8586), 1,
      anon_sym_PIPE,
    ACTIONS(8588), 1,
      anon_sym_AMP,
    ACTIONS(8592), 1,
      anon_sym_GT_GT,
    ACTIONS(8598), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8600), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8602), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8604), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8608), 1,
      anon_sym_as,
    ACTIONS(8610), 1,
      anon_sym_is,
    ACTIONS(8891), 1,
      anon_sym_by,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8574), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8578), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8580), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8590), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8594), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8596), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6409), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [229750] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6230), 1,
      anon_sym_equals,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(8522), 1,
      anon_sym_QMARK,
    ACTIONS(8528), 1,
      anon_sym_SLASH,
    ACTIONS(8530), 1,
      anon_sym_CARET,
    ACTIONS(8532), 1,
      anon_sym_PIPE,
    ACTIONS(8534), 1,
      anon_sym_AMP,
    ACTIONS(8538), 1,
      anon_sym_GT_GT,
    ACTIONS(8544), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8546), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8548), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8550), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8552), 1,
      anon_sym_as,
    ACTIONS(8554), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8520), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8524), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8526), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8536), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8540), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8542), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6410), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [229882] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7651), 1,
      anon_sym_as,
    ACTIONS(8486), 1,
      anon_sym_QMARK,
    ACTIONS(8492), 1,
      anon_sym_SLASH,
    ACTIONS(8494), 1,
      anon_sym_CARET,
    ACTIONS(8496), 1,
      anon_sym_PIPE,
    ACTIONS(8498), 1,
      anon_sym_AMP,
    ACTIONS(8502), 1,
      anon_sym_GT_GT,
    ACTIONS(8508), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8512), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8514), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8516), 1,
      anon_sym_is,
    ACTIONS(8893), 1,
      anon_sym_COLON,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8484), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8488), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8490), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8500), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8504), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8506), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6411), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [230014] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7651), 1,
      anon_sym_as,
    ACTIONS(8486), 1,
      anon_sym_QMARK,
    ACTIONS(8492), 1,
      anon_sym_SLASH,
    ACTIONS(8494), 1,
      anon_sym_CARET,
    ACTIONS(8496), 1,
      anon_sym_PIPE,
    ACTIONS(8498), 1,
      anon_sym_AMP,
    ACTIONS(8502), 1,
      anon_sym_GT_GT,
    ACTIONS(8508), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8512), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8514), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8516), 1,
      anon_sym_is,
    ACTIONS(8895), 1,
      anon_sym_COLON,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8484), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8488), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8490), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8500), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8504), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8506), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6412), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [230146] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7559), 1,
      anon_sym_SLASH,
    ACTIONS(7563), 1,
      anon_sym_GT_GT,
    ACTIONS(7569), 1,
      anon_sym_AMP,
    ACTIONS(7579), 1,
      anon_sym_CARET,
    ACTIONS(7651), 1,
      anon_sym_as,
    ACTIONS(7655), 1,
      anon_sym_PIPE,
    ACTIONS(7657), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7659), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7661), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8486), 1,
      anon_sym_QMARK,
    ACTIONS(8508), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8516), 1,
      anon_sym_is,
    ACTIONS(8897), 1,
      anon_sym_COLON,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7555), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7557), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7561), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7567), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7571), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7573), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6413), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [230278] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7210), 1,
      anon_sym_is,
    ACTIONS(7438), 1,
      anon_sym_QMARK,
    ACTIONS(7444), 1,
      anon_sym_SLASH,
    ACTIONS(7446), 1,
      anon_sym_CARET,
    ACTIONS(7448), 1,
      anon_sym_PIPE,
    ACTIONS(7450), 1,
      anon_sym_AMP,
    ACTIONS(7454), 1,
      anon_sym_GT_GT,
    ACTIONS(7460), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7462), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7464), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7466), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8899), 1,
      anon_sym_SEMI,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7436), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7440), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7442), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7452), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7456), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7458), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6414), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [230410] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8780), 1,
      anon_sym_into,
    STATE(6361), 1,
      aux_sym__query_body_repeat2,
    STATE(6415), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6420), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6418), 23,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [230492] = 32,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(8656), 1,
      anon_sym_SLASH,
    ACTIONS(8666), 1,
      anon_sym_GT_GT,
    ACTIONS(8672), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8680), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8648), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8652), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8654), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8664), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8670), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6116), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(6114), 7,
      anon_sym_in,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(6416), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [230610] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5510), 1,
      anon_sym_COLON,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7651), 1,
      anon_sym_as,
    ACTIONS(8486), 1,
      anon_sym_QMARK,
    ACTIONS(8492), 1,
      anon_sym_SLASH,
    ACTIONS(8494), 1,
      anon_sym_CARET,
    ACTIONS(8496), 1,
      anon_sym_PIPE,
    ACTIONS(8498), 1,
      anon_sym_AMP,
    ACTIONS(8502), 1,
      anon_sym_GT_GT,
    ACTIONS(8508), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8512), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8514), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8516), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8484), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8488), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8490), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8500), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8504), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8506), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6417), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [230742] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(8901), 1,
      anon_sym_RPAREN,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6418), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [230874] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7651), 1,
      anon_sym_as,
    ACTIONS(8486), 1,
      anon_sym_QMARK,
    ACTIONS(8492), 1,
      anon_sym_SLASH,
    ACTIONS(8494), 1,
      anon_sym_CARET,
    ACTIONS(8496), 1,
      anon_sym_PIPE,
    ACTIONS(8498), 1,
      anon_sym_AMP,
    ACTIONS(8502), 1,
      anon_sym_GT_GT,
    ACTIONS(8508), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8512), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8514), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8516), 1,
      anon_sym_is,
    ACTIONS(8903), 1,
      anon_sym_COLON,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8484), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8488), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8490), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8500), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8504), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8506), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6419), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [231006] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7178), 1,
      anon_sym_QMARK,
    ACTIONS(7184), 1,
      anon_sym_SLASH,
    ACTIONS(7186), 1,
      anon_sym_CARET,
    ACTIONS(7188), 1,
      anon_sym_PIPE,
    ACTIONS(7190), 1,
      anon_sym_AMP,
    ACTIONS(7194), 1,
      anon_sym_GT_GT,
    ACTIONS(7200), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7202), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7204), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7206), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7210), 1,
      anon_sym_is,
    ACTIONS(8905), 1,
      aux_sym_preproc_if_token3,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7176), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7180), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7182), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7192), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7196), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7198), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6420), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [231138] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7651), 1,
      anon_sym_as,
    ACTIONS(8486), 1,
      anon_sym_QMARK,
    ACTIONS(8492), 1,
      anon_sym_SLASH,
    ACTIONS(8494), 1,
      anon_sym_CARET,
    ACTIONS(8496), 1,
      anon_sym_PIPE,
    ACTIONS(8498), 1,
      anon_sym_AMP,
    ACTIONS(8502), 1,
      anon_sym_GT_GT,
    ACTIONS(8508), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8512), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8514), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8516), 1,
      anon_sym_is,
    ACTIONS(8907), 1,
      anon_sym_COLON,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8484), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8488), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8490), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8500), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8504), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8506), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6421), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [231270] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6230), 1,
      anon_sym_by,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(8576), 1,
      anon_sym_QMARK,
    ACTIONS(8582), 1,
      anon_sym_SLASH,
    ACTIONS(8584), 1,
      anon_sym_CARET,
    ACTIONS(8586), 1,
      anon_sym_PIPE,
    ACTIONS(8588), 1,
      anon_sym_AMP,
    ACTIONS(8592), 1,
      anon_sym_GT_GT,
    ACTIONS(8598), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8600), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8602), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8604), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8608), 1,
      anon_sym_as,
    ACTIONS(8610), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8574), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8578), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8580), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8590), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8594), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8596), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6422), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [231402] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(8598), 1,
      anon_sym_DOT_DOT,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(6423), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1147), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(1133), 17,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [231498] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(8672), 1,
      anon_sym_DOT_DOT,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(6424), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6122), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6120), 17,
      anon_sym_in,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [231594] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(8656), 1,
      anon_sym_SLASH,
    ACTIONS(8666), 1,
      anon_sym_GT_GT,
    ACTIONS(8672), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8680), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8648), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8652), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8654), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8664), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8668), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8670), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6116), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(6114), 5,
      anon_sym_in,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(6425), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [231714] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8614), 1,
      anon_sym_into,
    STATE(6427), 1,
      aux_sym__query_body_repeat2,
    STATE(6426), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6383), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6381), 23,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [231796] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8909), 1,
      anon_sym_into,
    STATE(6427), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym__query_body_repeat2,
    ACTIONS(6376), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6374), 23,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [231876] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(8656), 1,
      anon_sym_SLASH,
    ACTIONS(8658), 1,
      anon_sym_CARET,
    ACTIONS(8662), 1,
      anon_sym_AMP,
    ACTIONS(8666), 1,
      anon_sym_GT_GT,
    ACTIONS(8672), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8680), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6116), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(8648), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8652), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8654), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8664), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8668), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8670), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 4,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(6428), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [232000] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8614), 1,
      anon_sym_into,
    STATE(6426), 1,
      aux_sym__query_body_repeat2,
    STATE(6429), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6420), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6418), 23,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [232082] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6220), 1,
      anon_sym_by,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(8576), 1,
      anon_sym_QMARK,
    ACTIONS(8582), 1,
      anon_sym_SLASH,
    ACTIONS(8584), 1,
      anon_sym_CARET,
    ACTIONS(8586), 1,
      anon_sym_PIPE,
    ACTIONS(8588), 1,
      anon_sym_AMP,
    ACTIONS(8592), 1,
      anon_sym_GT_GT,
    ACTIONS(8598), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8600), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8602), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8604), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8608), 1,
      anon_sym_as,
    ACTIONS(8610), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8574), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8578), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8580), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8590), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8594), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8596), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6430), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [232214] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8614), 1,
      anon_sym_into,
    STATE(6427), 1,
      aux_sym__query_body_repeat2,
    STATE(6431), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6420), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6418), 23,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [232296] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(8656), 1,
      anon_sym_SLASH,
    ACTIONS(8662), 1,
      anon_sym_AMP,
    ACTIONS(8666), 1,
      anon_sym_GT_GT,
    ACTIONS(8672), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8680), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6116), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(8648), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8652), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8654), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8664), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8668), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8670), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 5,
      anon_sym_in,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(6432), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [232418] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(1937), 1,
      anon_sym_SEMI,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7210), 1,
      anon_sym_is,
    ACTIONS(7438), 1,
      anon_sym_QMARK,
    ACTIONS(7444), 1,
      anon_sym_SLASH,
    ACTIONS(7446), 1,
      anon_sym_CARET,
    ACTIONS(7448), 1,
      anon_sym_PIPE,
    ACTIONS(7450), 1,
      anon_sym_AMP,
    ACTIONS(7454), 1,
      anon_sym_GT_GT,
    ACTIONS(7460), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7462), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7464), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7466), 1,
      anon_sym_QMARK_QMARK,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7436), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7440), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7442), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7452), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7456), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7458), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6433), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [232550] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7651), 1,
      anon_sym_as,
    ACTIONS(8486), 1,
      anon_sym_QMARK,
    ACTIONS(8492), 1,
      anon_sym_SLASH,
    ACTIONS(8494), 1,
      anon_sym_CARET,
    ACTIONS(8496), 1,
      anon_sym_PIPE,
    ACTIONS(8498), 1,
      anon_sym_AMP,
    ACTIONS(8502), 1,
      anon_sym_GT_GT,
    ACTIONS(8508), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8512), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8514), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8516), 1,
      anon_sym_is,
    ACTIONS(8912), 1,
      anon_sym_COLON,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8484), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8488), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8490), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8500), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8504), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8506), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6434), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [232682] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7651), 1,
      anon_sym_as,
    ACTIONS(8486), 1,
      anon_sym_QMARK,
    ACTIONS(8492), 1,
      anon_sym_SLASH,
    ACTIONS(8494), 1,
      anon_sym_CARET,
    ACTIONS(8496), 1,
      anon_sym_PIPE,
    ACTIONS(8498), 1,
      anon_sym_AMP,
    ACTIONS(8502), 1,
      anon_sym_GT_GT,
    ACTIONS(8508), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8512), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8514), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8516), 1,
      anon_sym_is,
    ACTIONS(8914), 1,
      anon_sym_COLON,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8484), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8488), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8490), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8500), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8504), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8506), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6435), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [232814] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(8576), 1,
      anon_sym_QMARK,
    ACTIONS(8582), 1,
      anon_sym_SLASH,
    ACTIONS(8584), 1,
      anon_sym_CARET,
    ACTIONS(8586), 1,
      anon_sym_PIPE,
    ACTIONS(8588), 1,
      anon_sym_AMP,
    ACTIONS(8592), 1,
      anon_sym_GT_GT,
    ACTIONS(8598), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8600), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8602), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8604), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8608), 1,
      anon_sym_as,
    ACTIONS(8610), 1,
      anon_sym_is,
    ACTIONS(8916), 1,
      anon_sym_by,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8574), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8578), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8580), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8590), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8594), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8596), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6436), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [232946] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(8576), 1,
      anon_sym_QMARK,
    ACTIONS(8582), 1,
      anon_sym_SLASH,
    ACTIONS(8584), 1,
      anon_sym_CARET,
    ACTIONS(8586), 1,
      anon_sym_PIPE,
    ACTIONS(8588), 1,
      anon_sym_AMP,
    ACTIONS(8592), 1,
      anon_sym_GT_GT,
    ACTIONS(8598), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8600), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8602), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8604), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8608), 1,
      anon_sym_as,
    ACTIONS(8610), 1,
      anon_sym_is,
    ACTIONS(8918), 1,
      anon_sym_by,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8574), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8578), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8580), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8590), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8594), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8596), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6437), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [233078] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(8920), 1,
      anon_sym_RPAREN,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6438), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [233210] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7210), 1,
      anon_sym_is,
    ACTIONS(7438), 1,
      anon_sym_QMARK,
    ACTIONS(7444), 1,
      anon_sym_SLASH,
    ACTIONS(7446), 1,
      anon_sym_CARET,
    ACTIONS(7448), 1,
      anon_sym_PIPE,
    ACTIONS(7450), 1,
      anon_sym_AMP,
    ACTIONS(7454), 1,
      anon_sym_GT_GT,
    ACTIONS(7460), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7462), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7464), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7466), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8922), 1,
      anon_sym_SEMI,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7436), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7440), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7442), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7452), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7456), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7458), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6439), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [233342] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7651), 1,
      anon_sym_as,
    ACTIONS(8486), 1,
      anon_sym_QMARK,
    ACTIONS(8492), 1,
      anon_sym_SLASH,
    ACTIONS(8494), 1,
      anon_sym_CARET,
    ACTIONS(8496), 1,
      anon_sym_PIPE,
    ACTIONS(8498), 1,
      anon_sym_AMP,
    ACTIONS(8502), 1,
      anon_sym_GT_GT,
    ACTIONS(8508), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8512), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8514), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8516), 1,
      anon_sym_is,
    ACTIONS(8924), 1,
      anon_sym_COLON,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8484), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8488), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8490), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8500), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8504), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8506), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6440), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [233474] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(8656), 1,
      anon_sym_SLASH,
    ACTIONS(8672), 1,
      anon_sym_DOT_DOT,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8652), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8654), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6116), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(6441), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 13,
      anon_sym_in,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [233580] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(8650), 1,
      anon_sym_QMARK,
    ACTIONS(8656), 1,
      anon_sym_SLASH,
    ACTIONS(8658), 1,
      anon_sym_CARET,
    ACTIONS(8660), 1,
      anon_sym_PIPE,
    ACTIONS(8662), 1,
      anon_sym_AMP,
    ACTIONS(8666), 1,
      anon_sym_GT_GT,
    ACTIONS(8672), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8674), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8676), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8678), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8680), 1,
      anon_sym_is,
    ACTIONS(8926), 1,
      anon_sym_in,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8648), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8652), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8654), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8664), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8668), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8670), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6442), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [233712] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8839), 1,
      anon_sym_and,
    ACTIONS(8841), 1,
      anon_sym_or,
    STATE(6443), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5856), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5854), 23,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [233794] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7651), 1,
      anon_sym_as,
    ACTIONS(8486), 1,
      anon_sym_QMARK,
    ACTIONS(8492), 1,
      anon_sym_SLASH,
    ACTIONS(8494), 1,
      anon_sym_CARET,
    ACTIONS(8496), 1,
      anon_sym_PIPE,
    ACTIONS(8498), 1,
      anon_sym_AMP,
    ACTIONS(8502), 1,
      anon_sym_GT_GT,
    ACTIONS(8508), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8512), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8514), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8516), 1,
      anon_sym_is,
    ACTIONS(8928), 1,
      anon_sym_COLON,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8484), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8488), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8490), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8500), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8504), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8506), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6444), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [233926] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6216), 1,
      anon_sym_in,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(8650), 1,
      anon_sym_QMARK,
    ACTIONS(8656), 1,
      anon_sym_SLASH,
    ACTIONS(8658), 1,
      anon_sym_CARET,
    ACTIONS(8660), 1,
      anon_sym_PIPE,
    ACTIONS(8662), 1,
      anon_sym_AMP,
    ACTIONS(8666), 1,
      anon_sym_GT_GT,
    ACTIONS(8672), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8674), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8676), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8678), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8680), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8648), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8652), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8654), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8664), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8668), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8670), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6445), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [234058] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(8672), 1,
      anon_sym_DOT_DOT,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(6446), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6116), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6114), 15,
      anon_sym_in,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [234158] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(8672), 1,
      anon_sym_DOT_DOT,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(6447), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1147), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(1133), 17,
      anon_sym_in,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [234254] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7651), 1,
      anon_sym_as,
    ACTIONS(8486), 1,
      anon_sym_QMARK,
    ACTIONS(8492), 1,
      anon_sym_SLASH,
    ACTIONS(8494), 1,
      anon_sym_CARET,
    ACTIONS(8496), 1,
      anon_sym_PIPE,
    ACTIONS(8498), 1,
      anon_sym_AMP,
    ACTIONS(8502), 1,
      anon_sym_GT_GT,
    ACTIONS(8508), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8512), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8514), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8516), 1,
      anon_sym_is,
    ACTIONS(8930), 1,
      anon_sym_COLON,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8484), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8488), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8490), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8500), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8504), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8506), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6448), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [234386] = 25,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(8656), 1,
      anon_sym_SLASH,
    ACTIONS(8672), 1,
      anon_sym_DOT_DOT,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8654), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6116), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(6449), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 13,
      anon_sym_in,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [234490] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6230), 1,
      anon_sym_in,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(8650), 1,
      anon_sym_QMARK,
    ACTIONS(8656), 1,
      anon_sym_SLASH,
    ACTIONS(8658), 1,
      anon_sym_CARET,
    ACTIONS(8660), 1,
      anon_sym_PIPE,
    ACTIONS(8662), 1,
      anon_sym_AMP,
    ACTIONS(8666), 1,
      anon_sym_GT_GT,
    ACTIONS(8672), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8674), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8676), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8678), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8680), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8648), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8652), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8654), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8664), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8668), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8670), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6450), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [234622] = 28,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(8656), 1,
      anon_sym_SLASH,
    ACTIONS(8666), 1,
      anon_sym_GT_GT,
    ACTIONS(8672), 1,
      anon_sym_DOT_DOT,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8652), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8654), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8664), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6116), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(6451), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 11,
      anon_sym_in,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [234732] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7210), 1,
      anon_sym_is,
    ACTIONS(7438), 1,
      anon_sym_QMARK,
    ACTIONS(7444), 1,
      anon_sym_SLASH,
    ACTIONS(7446), 1,
      anon_sym_CARET,
    ACTIONS(7448), 1,
      anon_sym_PIPE,
    ACTIONS(7450), 1,
      anon_sym_AMP,
    ACTIONS(7454), 1,
      anon_sym_GT_GT,
    ACTIONS(7460), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7462), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7464), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7466), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8932), 1,
      anon_sym_SEMI,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7436), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7440), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7442), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7452), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7456), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7458), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6452), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [234864] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6236), 1,
      anon_sym_EQ_GT,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(8805), 1,
      anon_sym_QMARK,
    ACTIONS(8811), 1,
      anon_sym_SLASH,
    ACTIONS(8813), 1,
      anon_sym_CARET,
    ACTIONS(8815), 1,
      anon_sym_PIPE,
    ACTIONS(8817), 1,
      anon_sym_AMP,
    ACTIONS(8821), 1,
      anon_sym_GT_GT,
    ACTIONS(8827), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8829), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8831), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8833), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8835), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8803), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8807), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8809), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8819), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8823), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8825), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6453), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [234996] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6220), 1,
      anon_sym_equals,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(8522), 1,
      anon_sym_QMARK,
    ACTIONS(8528), 1,
      anon_sym_SLASH,
    ACTIONS(8530), 1,
      anon_sym_CARET,
    ACTIONS(8532), 1,
      anon_sym_PIPE,
    ACTIONS(8534), 1,
      anon_sym_AMP,
    ACTIONS(8538), 1,
      anon_sym_GT_GT,
    ACTIONS(8544), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8546), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8548), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8550), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8552), 1,
      anon_sym_as,
    ACTIONS(8554), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8520), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8524), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8526), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8536), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8540), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8542), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6454), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [235128] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(6990), 1,
      anon_sym_SLASH,
    ACTIONS(6992), 1,
      anon_sym_AMP,
    ACTIONS(6996), 1,
      anon_sym_GT_GT,
    ACTIONS(7012), 1,
      anon_sym_CARET,
    ACTIONS(7014), 1,
      anon_sym_PIPE,
    ACTIONS(7016), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7018), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7020), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7651), 1,
      anon_sym_as,
    ACTIONS(8486), 1,
      anon_sym_QMARK,
    ACTIONS(8508), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8516), 1,
      anon_sym_is,
    ACTIONS(8934), 1,
      anon_sym_COLON,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6984), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6986), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6988), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6994), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6998), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7000), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6455), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [235260] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7210), 1,
      anon_sym_is,
    ACTIONS(7438), 1,
      anon_sym_QMARK,
    ACTIONS(7444), 1,
      anon_sym_SLASH,
    ACTIONS(7446), 1,
      anon_sym_CARET,
    ACTIONS(7448), 1,
      anon_sym_PIPE,
    ACTIONS(7450), 1,
      anon_sym_AMP,
    ACTIONS(7454), 1,
      anon_sym_GT_GT,
    ACTIONS(7460), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7462), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7464), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7466), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8936), 1,
      anon_sym_SEMI,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7436), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7440), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7442), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7452), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7456), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7458), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6456), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [235392] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8938), 1,
      anon_sym_RPAREN,
    STATE(6457), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5251), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5249), 24,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [235472] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7651), 1,
      anon_sym_as,
    ACTIONS(8486), 1,
      anon_sym_QMARK,
    ACTIONS(8492), 1,
      anon_sym_SLASH,
    ACTIONS(8494), 1,
      anon_sym_CARET,
    ACTIONS(8496), 1,
      anon_sym_PIPE,
    ACTIONS(8498), 1,
      anon_sym_AMP,
    ACTIONS(8502), 1,
      anon_sym_GT_GT,
    ACTIONS(8508), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8512), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8514), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8516), 1,
      anon_sym_is,
    ACTIONS(8940), 1,
      anon_sym_COLON,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8484), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8488), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8490), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8500), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8504), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8506), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6458), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [235604] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(8942), 1,
      anon_sym_COMMA,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6459), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [235736] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(8650), 1,
      anon_sym_QMARK,
    ACTIONS(8656), 1,
      anon_sym_SLASH,
    ACTIONS(8658), 1,
      anon_sym_CARET,
    ACTIONS(8660), 1,
      anon_sym_PIPE,
    ACTIONS(8662), 1,
      anon_sym_AMP,
    ACTIONS(8666), 1,
      anon_sym_GT_GT,
    ACTIONS(8672), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8674), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8676), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8678), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8680), 1,
      anon_sym_is,
    ACTIONS(8944), 1,
      anon_sym_in,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8648), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8652), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8654), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8664), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8668), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8670), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6460), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [235868] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7651), 1,
      anon_sym_as,
    ACTIONS(8486), 1,
      anon_sym_QMARK,
    ACTIONS(8492), 1,
      anon_sym_SLASH,
    ACTIONS(8494), 1,
      anon_sym_CARET,
    ACTIONS(8496), 1,
      anon_sym_PIPE,
    ACTIONS(8498), 1,
      anon_sym_AMP,
    ACTIONS(8502), 1,
      anon_sym_GT_GT,
    ACTIONS(8508), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8512), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8514), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8516), 1,
      anon_sym_is,
    ACTIONS(8946), 1,
      anon_sym_COLON,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8484), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8488), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8490), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8500), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8504), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8506), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6461), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [236000] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(8948), 1,
      anon_sym_RPAREN,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6462), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [236132] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(8950), 1,
      anon_sym_COMMA,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6463), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [236264] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(8952), 1,
      anon_sym_RPAREN,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6464), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [236396] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(8954), 1,
      anon_sym_RPAREN,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6465), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [236528] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7210), 1,
      anon_sym_is,
    ACTIONS(7438), 1,
      anon_sym_QMARK,
    ACTIONS(7444), 1,
      anon_sym_SLASH,
    ACTIONS(7446), 1,
      anon_sym_CARET,
    ACTIONS(7448), 1,
      anon_sym_PIPE,
    ACTIONS(7450), 1,
      anon_sym_AMP,
    ACTIONS(7454), 1,
      anon_sym_GT_GT,
    ACTIONS(7460), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7462), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7464), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7466), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8956), 1,
      anon_sym_SEMI,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7436), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7440), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7442), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7452), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7456), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7458), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6466), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [236660] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7651), 1,
      anon_sym_as,
    ACTIONS(8486), 1,
      anon_sym_QMARK,
    ACTIONS(8492), 1,
      anon_sym_SLASH,
    ACTIONS(8494), 1,
      anon_sym_CARET,
    ACTIONS(8496), 1,
      anon_sym_PIPE,
    ACTIONS(8498), 1,
      anon_sym_AMP,
    ACTIONS(8502), 1,
      anon_sym_GT_GT,
    ACTIONS(8508), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8512), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8514), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8516), 1,
      anon_sym_is,
    ACTIONS(8958), 1,
      anon_sym_COLON,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8484), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8488), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8490), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8500), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8504), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8506), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6467), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [236792] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8960), 1,
      anon_sym_RPAREN,
    STATE(6468), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5251), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5249), 24,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [236872] = 28,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(8582), 1,
      anon_sym_SLASH,
    ACTIONS(8592), 1,
      anon_sym_GT_GT,
    ACTIONS(8598), 1,
      anon_sym_DOT_DOT,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8578), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8580), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8590), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6116), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(6469), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 11,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
  [236982] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(8544), 1,
      anon_sym_DOT_DOT,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(6470), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1147), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(1133), 17,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [237078] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7651), 1,
      anon_sym_as,
    ACTIONS(8486), 1,
      anon_sym_QMARK,
    ACTIONS(8492), 1,
      anon_sym_SLASH,
    ACTIONS(8494), 1,
      anon_sym_CARET,
    ACTIONS(8496), 1,
      anon_sym_PIPE,
    ACTIONS(8498), 1,
      anon_sym_AMP,
    ACTIONS(8502), 1,
      anon_sym_GT_GT,
    ACTIONS(8508), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8512), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8514), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8516), 1,
      anon_sym_is,
    ACTIONS(8962), 1,
      anon_sym_COLON,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8484), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8488), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8490), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8500), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8504), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8506), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6471), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [237210] = 25,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(8582), 1,
      anon_sym_SLASH,
    ACTIONS(8598), 1,
      anon_sym_DOT_DOT,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8580), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6116), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(6472), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 13,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
  [237314] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(8598), 1,
      anon_sym_DOT_DOT,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(6473), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6116), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6114), 15,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
  [237414] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(8582), 1,
      anon_sym_SLASH,
    ACTIONS(8588), 1,
      anon_sym_AMP,
    ACTIONS(8592), 1,
      anon_sym_GT_GT,
    ACTIONS(8598), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8608), 1,
      anon_sym_as,
    ACTIONS(8610), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6116), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(8574), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8578), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8580), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8590), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8594), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8596), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 5,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_by,
    STATE(6474), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [237536] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(8582), 1,
      anon_sym_SLASH,
    ACTIONS(8584), 1,
      anon_sym_CARET,
    ACTIONS(8588), 1,
      anon_sym_AMP,
    ACTIONS(8592), 1,
      anon_sym_GT_GT,
    ACTIONS(8598), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8608), 1,
      anon_sym_as,
    ACTIONS(8610), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6116), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(8574), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8578), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8580), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8590), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8594), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8596), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 4,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_by,
    STATE(6475), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [237660] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(8582), 1,
      anon_sym_SLASH,
    ACTIONS(8592), 1,
      anon_sym_GT_GT,
    ACTIONS(8598), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8608), 1,
      anon_sym_as,
    ACTIONS(8610), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8574), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8578), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8580), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8590), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8594), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8596), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6116), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(6114), 5,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_by,
    STATE(6476), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [237780] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(8582), 1,
      anon_sym_SLASH,
    ACTIONS(8598), 1,
      anon_sym_DOT_DOT,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8578), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8580), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6116), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(6477), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 13,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
  [237886] = 32,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(8582), 1,
      anon_sym_SLASH,
    ACTIONS(8592), 1,
      anon_sym_GT_GT,
    ACTIONS(8598), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8608), 1,
      anon_sym_as,
    ACTIONS(8610), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8574), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8578), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8580), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8590), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8596), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6116), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(6114), 7,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_by,
    STATE(6478), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [238004] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(8964), 1,
      anon_sym_RPAREN,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6479), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [238136] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(8598), 1,
      anon_sym_DOT_DOT,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(6480), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6122), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6120), 17,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [238232] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(8582), 1,
      anon_sym_SLASH,
    ACTIONS(8584), 1,
      anon_sym_CARET,
    ACTIONS(8586), 1,
      anon_sym_PIPE,
    ACTIONS(8588), 1,
      anon_sym_AMP,
    ACTIONS(8592), 1,
      anon_sym_GT_GT,
    ACTIONS(8598), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8608), 1,
      anon_sym_as,
    ACTIONS(8610), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8574), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8578), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8580), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8590), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8594), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8596), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 4,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_by,
    STATE(6481), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [238358] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(8582), 1,
      anon_sym_SLASH,
    ACTIONS(8584), 1,
      anon_sym_CARET,
    ACTIONS(8586), 1,
      anon_sym_PIPE,
    ACTIONS(8588), 1,
      anon_sym_AMP,
    ACTIONS(8592), 1,
      anon_sym_GT_GT,
    ACTIONS(8598), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8600), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8608), 1,
      anon_sym_as,
    ACTIONS(8610), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8574), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8578), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8580), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8590), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8594), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8596), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 3,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_by,
    STATE(6482), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [238486] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6114), 1,
      anon_sym_by,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(8582), 1,
      anon_sym_SLASH,
    ACTIONS(8584), 1,
      anon_sym_CARET,
    ACTIONS(8586), 1,
      anon_sym_PIPE,
    ACTIONS(8588), 1,
      anon_sym_AMP,
    ACTIONS(8592), 1,
      anon_sym_GT_GT,
    ACTIONS(8598), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8600), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8602), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8604), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8608), 1,
      anon_sym_as,
    ACTIONS(8610), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8574), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8578), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8580), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8590), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8594), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8596), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6483), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [238618] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(8650), 1,
      anon_sym_QMARK,
    ACTIONS(8656), 1,
      anon_sym_SLASH,
    ACTIONS(8658), 1,
      anon_sym_CARET,
    ACTIONS(8660), 1,
      anon_sym_PIPE,
    ACTIONS(8662), 1,
      anon_sym_AMP,
    ACTIONS(8666), 1,
      anon_sym_GT_GT,
    ACTIONS(8672), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8674), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8676), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8678), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8680), 1,
      anon_sym_is,
    ACTIONS(8966), 1,
      anon_sym_in,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8648), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8652), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8654), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8664), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8668), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8670), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6484), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [238750] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(1951), 1,
      anon_sym_SEMI,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7210), 1,
      anon_sym_is,
    ACTIONS(7438), 1,
      anon_sym_QMARK,
    ACTIONS(7444), 1,
      anon_sym_SLASH,
    ACTIONS(7446), 1,
      anon_sym_CARET,
    ACTIONS(7448), 1,
      anon_sym_PIPE,
    ACTIONS(7450), 1,
      anon_sym_AMP,
    ACTIONS(7454), 1,
      anon_sym_GT_GT,
    ACTIONS(7460), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7462), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7464), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7466), 1,
      anon_sym_QMARK_QMARK,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7436), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7440), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7442), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7452), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7456), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7458), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6485), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [238882] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8968), 1,
      anon_sym_and,
    ACTIONS(8970), 1,
      anon_sym_or,
    STATE(6486), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5856), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5854), 23,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [238964] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8780), 1,
      anon_sym_into,
    STATE(6415), 1,
      aux_sym__query_body_repeat2,
    STATE(6487), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6448), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6446), 23,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [239046] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5396), 1,
      anon_sym_in,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(8650), 1,
      anon_sym_QMARK,
    ACTIONS(8656), 1,
      anon_sym_SLASH,
    ACTIONS(8658), 1,
      anon_sym_CARET,
    ACTIONS(8660), 1,
      anon_sym_PIPE,
    ACTIONS(8662), 1,
      anon_sym_AMP,
    ACTIONS(8666), 1,
      anon_sym_GT_GT,
    ACTIONS(8672), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8674), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8676), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8678), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8680), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8648), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8652), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8654), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8664), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8668), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8670), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6488), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [239178] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6230), 1,
      anon_sym_EQ_GT,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(8805), 1,
      anon_sym_QMARK,
    ACTIONS(8811), 1,
      anon_sym_SLASH,
    ACTIONS(8813), 1,
      anon_sym_CARET,
    ACTIONS(8815), 1,
      anon_sym_PIPE,
    ACTIONS(8817), 1,
      anon_sym_AMP,
    ACTIONS(8821), 1,
      anon_sym_GT_GT,
    ACTIONS(8827), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8829), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8831), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8833), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8835), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8803), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8807), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8809), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8819), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8823), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8825), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6489), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [239310] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5420), 1,
      anon_sym_by,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(8576), 1,
      anon_sym_QMARK,
    ACTIONS(8582), 1,
      anon_sym_SLASH,
    ACTIONS(8584), 1,
      anon_sym_CARET,
    ACTIONS(8586), 1,
      anon_sym_PIPE,
    ACTIONS(8588), 1,
      anon_sym_AMP,
    ACTIONS(8592), 1,
      anon_sym_GT_GT,
    ACTIONS(8598), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8600), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8602), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8604), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8608), 1,
      anon_sym_as,
    ACTIONS(8610), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8574), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8578), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8580), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8590), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8594), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8596), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6490), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [239442] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(8972), 1,
      anon_sym_RPAREN,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6491), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [239574] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6236), 1,
      anon_sym_in,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(8650), 1,
      anon_sym_QMARK,
    ACTIONS(8656), 1,
      anon_sym_SLASH,
    ACTIONS(8658), 1,
      anon_sym_CARET,
    ACTIONS(8660), 1,
      anon_sym_PIPE,
    ACTIONS(8662), 1,
      anon_sym_AMP,
    ACTIONS(8666), 1,
      anon_sym_GT_GT,
    ACTIONS(8672), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8674), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8676), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8678), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8680), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8648), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8652), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8654), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8664), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8668), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8670), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6492), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [239706] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8974), 1,
      anon_sym_and,
    STATE(6493), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6546), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6544), 24,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [239786] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7210), 1,
      anon_sym_is,
    ACTIONS(7438), 1,
      anon_sym_QMARK,
    ACTIONS(7444), 1,
      anon_sym_SLASH,
    ACTIONS(7446), 1,
      anon_sym_CARET,
    ACTIONS(7448), 1,
      anon_sym_PIPE,
    ACTIONS(7450), 1,
      anon_sym_AMP,
    ACTIONS(7454), 1,
      anon_sym_GT_GT,
    ACTIONS(7460), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7462), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7464), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7466), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7978), 1,
      anon_sym_SEMI,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7436), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7440), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7442), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7452), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7456), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7458), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6494), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [239918] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(6990), 1,
      anon_sym_SLASH,
    ACTIONS(6992), 1,
      anon_sym_AMP,
    ACTIONS(6996), 1,
      anon_sym_GT_GT,
    ACTIONS(7012), 1,
      anon_sym_CARET,
    ACTIONS(7014), 1,
      anon_sym_PIPE,
    ACTIONS(7016), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7018), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7020), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7651), 1,
      anon_sym_as,
    ACTIONS(7773), 1,
      anon_sym_COLON,
    ACTIONS(8486), 1,
      anon_sym_QMARK,
    ACTIONS(8508), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8516), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6984), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6986), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6988), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6994), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6998), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7000), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6495), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [240050] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7651), 1,
      anon_sym_as,
    ACTIONS(8486), 1,
      anon_sym_QMARK,
    ACTIONS(8492), 1,
      anon_sym_SLASH,
    ACTIONS(8494), 1,
      anon_sym_CARET,
    ACTIONS(8496), 1,
      anon_sym_PIPE,
    ACTIONS(8498), 1,
      anon_sym_AMP,
    ACTIONS(8502), 1,
      anon_sym_GT_GT,
    ACTIONS(8508), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8512), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8514), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8516), 1,
      anon_sym_is,
    ACTIONS(8976), 1,
      anon_sym_COLON,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8484), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8488), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8490), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8500), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8504), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8506), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6496), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [240182] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7651), 1,
      anon_sym_as,
    ACTIONS(8486), 1,
      anon_sym_QMARK,
    ACTIONS(8492), 1,
      anon_sym_SLASH,
    ACTIONS(8494), 1,
      anon_sym_CARET,
    ACTIONS(8496), 1,
      anon_sym_PIPE,
    ACTIONS(8498), 1,
      anon_sym_AMP,
    ACTIONS(8502), 1,
      anon_sym_GT_GT,
    ACTIONS(8508), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8512), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8514), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8516), 1,
      anon_sym_is,
    ACTIONS(8978), 1,
      anon_sym_COLON,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8484), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8488), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8490), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8500), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8504), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8506), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6497), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [240314] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(8827), 1,
      anon_sym_DOT_DOT,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(6498), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1147), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(1133), 17,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [240410] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7651), 1,
      anon_sym_as,
    ACTIONS(8486), 1,
      anon_sym_QMARK,
    ACTIONS(8492), 1,
      anon_sym_SLASH,
    ACTIONS(8494), 1,
      anon_sym_CARET,
    ACTIONS(8496), 1,
      anon_sym_PIPE,
    ACTIONS(8498), 1,
      anon_sym_AMP,
    ACTIONS(8502), 1,
      anon_sym_GT_GT,
    ACTIONS(8508), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8512), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8514), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8516), 1,
      anon_sym_is,
    ACTIONS(8980), 1,
      anon_sym_COLON,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8484), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8488), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8490), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8500), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8504), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8506), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6499), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [240542] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8974), 1,
      anon_sym_and,
    ACTIONS(8982), 1,
      anon_sym_or,
    STATE(6500), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5856), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5854), 23,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [240624] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(8984), 1,
      anon_sym_RPAREN,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6501), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [240756] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4293), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6745), 1,
      anon_sym_LT,
    STATE(4976), 1,
      sym_type_argument_list,
    ACTIONS(4076), 6,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
    STATE(6502), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4074), 27,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_COLON,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [240840] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7210), 1,
      anon_sym_is,
    ACTIONS(7438), 1,
      anon_sym_QMARK,
    ACTIONS(7444), 1,
      anon_sym_SLASH,
    ACTIONS(7446), 1,
      anon_sym_CARET,
    ACTIONS(7448), 1,
      anon_sym_PIPE,
    ACTIONS(7450), 1,
      anon_sym_AMP,
    ACTIONS(7454), 1,
      anon_sym_GT_GT,
    ACTIONS(7460), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7462), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7464), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7466), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8986), 1,
      anon_sym_SEMI,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7436), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7440), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7442), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7452), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7456), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7458), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6503), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [240972] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7651), 1,
      anon_sym_as,
    ACTIONS(8486), 1,
      anon_sym_QMARK,
    ACTIONS(8492), 1,
      anon_sym_SLASH,
    ACTIONS(8494), 1,
      anon_sym_CARET,
    ACTIONS(8496), 1,
      anon_sym_PIPE,
    ACTIONS(8498), 1,
      anon_sym_AMP,
    ACTIONS(8502), 1,
      anon_sym_GT_GT,
    ACTIONS(8508), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8512), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8514), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8516), 1,
      anon_sym_is,
    ACTIONS(8988), 1,
      anon_sym_COLON,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8484), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8488), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8490), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8500), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8504), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8506), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6504), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [241104] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5510), 1,
      anon_sym_by,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(8576), 1,
      anon_sym_QMARK,
    ACTIONS(8582), 1,
      anon_sym_SLASH,
    ACTIONS(8584), 1,
      anon_sym_CARET,
    ACTIONS(8586), 1,
      anon_sym_PIPE,
    ACTIONS(8588), 1,
      anon_sym_AMP,
    ACTIONS(8592), 1,
      anon_sym_GT_GT,
    ACTIONS(8598), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8600), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8602), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8604), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8608), 1,
      anon_sym_as,
    ACTIONS(8610), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8574), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8578), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8580), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8590), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8594), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8596), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6505), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [241236] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8990), 1,
      anon_sym_RPAREN,
    STATE(6506), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5251), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5249), 24,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [241316] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(8628), 1,
      anon_sym_LPAREN,
    ACTIONS(8992), 1,
      anon_sym_operator,
    ACTIONS(8994), 1,
      anon_sym_this,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(2738), 1,
      sym_generic_name,
    STATE(7225), 1,
      sym_explicit_interface_specifier,
    STATE(7474), 1,
      sym_identifier,
    STATE(8056), 1,
      sym_tuple_pattern,
    STATE(8608), 1,
      sym_variable_declarator,
    STATE(9003), 1,
      sym__name,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6507), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [241416] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8716), 1,
      anon_sym_into,
    STATE(6512), 1,
      aux_sym__query_body_repeat2,
    STATE(6508), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6383), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6381), 23,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [241498] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4424), 1,
      anon_sym_LBRACE,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(7250), 1,
      anon_sym_LBRACK,
    ACTIONS(7252), 1,
      anon_sym_STAR,
    ACTIONS(7254), 1,
      anon_sym_QMARK,
    ACTIONS(8467), 1,
      anon_sym_DOT,
    ACTIONS(8999), 1,
      anon_sym_LPAREN,
    STATE(8721), 1,
      sym_attribute_argument_list,
    ACTIONS(8996), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    STATE(6509), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4422), 26,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [241592] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6220), 1,
      anon_sym_EQ_GT,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(8805), 1,
      anon_sym_QMARK,
    ACTIONS(8811), 1,
      anon_sym_SLASH,
    ACTIONS(8813), 1,
      anon_sym_CARET,
    ACTIONS(8815), 1,
      anon_sym_PIPE,
    ACTIONS(8817), 1,
      anon_sym_AMP,
    ACTIONS(8821), 1,
      anon_sym_GT_GT,
    ACTIONS(8827), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8829), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8831), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8833), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8835), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8803), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8807), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8809), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8819), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8823), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8825), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6510), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [241724] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8968), 1,
      anon_sym_and,
    ACTIONS(8970), 1,
      anon_sym_or,
    STATE(6511), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6609), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6607), 23,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [241806] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9002), 1,
      anon_sym_into,
    STATE(6512), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym__query_body_repeat2,
    ACTIONS(6376), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6374), 23,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [241886] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6220), 1,
      anon_sym_COLON,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7651), 1,
      anon_sym_as,
    ACTIONS(8486), 1,
      anon_sym_QMARK,
    ACTIONS(8492), 1,
      anon_sym_SLASH,
    ACTIONS(8494), 1,
      anon_sym_CARET,
    ACTIONS(8496), 1,
      anon_sym_PIPE,
    ACTIONS(8498), 1,
      anon_sym_AMP,
    ACTIONS(8502), 1,
      anon_sym_GT_GT,
    ACTIONS(8508), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8512), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8514), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8516), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8484), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8488), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8490), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8500), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8504), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8506), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6513), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [242018] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8968), 1,
      anon_sym_and,
    STATE(6514), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6546), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6544), 24,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [242098] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4024), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(3719), 6,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
    STATE(6515), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4027), 26,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [242178] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7651), 1,
      anon_sym_as,
    ACTIONS(8486), 1,
      anon_sym_QMARK,
    ACTIONS(8492), 1,
      anon_sym_SLASH,
    ACTIONS(8494), 1,
      anon_sym_CARET,
    ACTIONS(8496), 1,
      anon_sym_PIPE,
    ACTIONS(8498), 1,
      anon_sym_AMP,
    ACTIONS(8502), 1,
      anon_sym_GT_GT,
    ACTIONS(8508), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8512), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8514), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8516), 1,
      anon_sym_is,
    ACTIONS(9005), 1,
      anon_sym_COLON,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8484), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8488), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8490), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8500), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8504), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8506), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6516), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [242310] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(8508), 1,
      anon_sym_DOT_DOT,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(6517), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1147), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(1133), 17,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [242406] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(8576), 1,
      anon_sym_QMARK,
    ACTIONS(8582), 1,
      anon_sym_SLASH,
    ACTIONS(8584), 1,
      anon_sym_CARET,
    ACTIONS(8586), 1,
      anon_sym_PIPE,
    ACTIONS(8588), 1,
      anon_sym_AMP,
    ACTIONS(8592), 1,
      anon_sym_GT_GT,
    ACTIONS(8598), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8600), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8602), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8604), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8608), 1,
      anon_sym_as,
    ACTIONS(8610), 1,
      anon_sym_is,
    ACTIONS(9007), 1,
      anon_sym_by,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8574), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8578), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8580), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8590), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8594), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8596), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6518), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [242538] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5325), 1,
      anon_sym_by,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(8576), 1,
      anon_sym_QMARK,
    ACTIONS(8582), 1,
      anon_sym_SLASH,
    ACTIONS(8584), 1,
      anon_sym_CARET,
    ACTIONS(8586), 1,
      anon_sym_PIPE,
    ACTIONS(8588), 1,
      anon_sym_AMP,
    ACTIONS(8592), 1,
      anon_sym_GT_GT,
    ACTIONS(8598), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8600), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8602), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8604), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8608), 1,
      anon_sym_as,
    ACTIONS(8610), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8574), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8578), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8580), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8590), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8594), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8596), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6519), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [242670] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8716), 1,
      anon_sym_into,
    STATE(6508), 1,
      aux_sym__query_body_repeat2,
    STATE(6520), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6420), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6418), 23,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [242752] = 28,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(8738), 1,
      anon_sym_SLASH,
    ACTIONS(8748), 1,
      anon_sym_GT_GT,
    ACTIONS(8754), 1,
      anon_sym_DOT_DOT,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8734), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8736), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8746), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6116), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(6521), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 11,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
  [242862] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8716), 1,
      anon_sym_into,
    STATE(6512), 1,
      aux_sym__query_body_repeat2,
    STATE(6522), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6420), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6418), 23,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [242944] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7651), 1,
      anon_sym_as,
    ACTIONS(8486), 1,
      anon_sym_QMARK,
    ACTIONS(8492), 1,
      anon_sym_SLASH,
    ACTIONS(8494), 1,
      anon_sym_CARET,
    ACTIONS(8496), 1,
      anon_sym_PIPE,
    ACTIONS(8498), 1,
      anon_sym_AMP,
    ACTIONS(8502), 1,
      anon_sym_GT_GT,
    ACTIONS(8508), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8512), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8514), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8516), 1,
      anon_sym_is,
    ACTIONS(9009), 1,
      anon_sym_COLON,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8484), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8488), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8490), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8500), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8504), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8506), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6523), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [243076] = 25,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(8738), 1,
      anon_sym_SLASH,
    ACTIONS(8754), 1,
      anon_sym_DOT_DOT,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8736), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6116), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(6524), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 13,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
  [243180] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(8754), 1,
      anon_sym_DOT_DOT,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(6525), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6116), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6114), 15,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
  [243280] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6216), 1,
      anon_sym_by,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(8576), 1,
      anon_sym_QMARK,
    ACTIONS(8582), 1,
      anon_sym_SLASH,
    ACTIONS(8584), 1,
      anon_sym_CARET,
    ACTIONS(8586), 1,
      anon_sym_PIPE,
    ACTIONS(8588), 1,
      anon_sym_AMP,
    ACTIONS(8592), 1,
      anon_sym_GT_GT,
    ACTIONS(8598), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8600), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8602), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8604), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8608), 1,
      anon_sym_as,
    ACTIONS(8610), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8574), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8578), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8580), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8590), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8594), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8596), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6526), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [243412] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(8738), 1,
      anon_sym_SLASH,
    ACTIONS(8744), 1,
      anon_sym_AMP,
    ACTIONS(8748), 1,
      anon_sym_GT_GT,
    ACTIONS(8754), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8764), 1,
      anon_sym_as,
    ACTIONS(8766), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6116), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(8730), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8734), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8736), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8746), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8750), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8752), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 5,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_on,
    STATE(6527), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [243534] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7651), 1,
      anon_sym_as,
    ACTIONS(8486), 1,
      anon_sym_QMARK,
    ACTIONS(8492), 1,
      anon_sym_SLASH,
    ACTIONS(8494), 1,
      anon_sym_CARET,
    ACTIONS(8496), 1,
      anon_sym_PIPE,
    ACTIONS(8498), 1,
      anon_sym_AMP,
    ACTIONS(8502), 1,
      anon_sym_GT_GT,
    ACTIONS(8508), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8512), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8514), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8516), 1,
      anon_sym_is,
    ACTIONS(9011), 1,
      anon_sym_COLON,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8484), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8488), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8490), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8500), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8504), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8506), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6528), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [243666] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8556), 1,
      anon_sym_and,
    STATE(6529), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6546), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6544), 24,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [243746] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(8738), 1,
      anon_sym_SLASH,
    ACTIONS(8740), 1,
      anon_sym_CARET,
    ACTIONS(8744), 1,
      anon_sym_AMP,
    ACTIONS(8748), 1,
      anon_sym_GT_GT,
    ACTIONS(8754), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8764), 1,
      anon_sym_as,
    ACTIONS(8766), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6116), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(8730), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8734), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8736), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8746), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8750), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8752), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 4,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_on,
    STATE(6530), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [243870] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7210), 1,
      anon_sym_is,
    ACTIONS(7438), 1,
      anon_sym_QMARK,
    ACTIONS(7444), 1,
      anon_sym_SLASH,
    ACTIONS(7446), 1,
      anon_sym_CARET,
    ACTIONS(7448), 1,
      anon_sym_PIPE,
    ACTIONS(7450), 1,
      anon_sym_AMP,
    ACTIONS(7454), 1,
      anon_sym_GT_GT,
    ACTIONS(7460), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7462), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7464), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7466), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(9013), 1,
      anon_sym_SEMI,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7436), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7440), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7442), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7452), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7456), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7458), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6531), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [244002] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5396), 1,
      anon_sym_by,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(8576), 1,
      anon_sym_QMARK,
    ACTIONS(8582), 1,
      anon_sym_SLASH,
    ACTIONS(8584), 1,
      anon_sym_CARET,
    ACTIONS(8586), 1,
      anon_sym_PIPE,
    ACTIONS(8588), 1,
      anon_sym_AMP,
    ACTIONS(8592), 1,
      anon_sym_GT_GT,
    ACTIONS(8598), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8600), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8602), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8604), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8608), 1,
      anon_sym_as,
    ACTIONS(8610), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8574), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8578), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8580), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8590), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8594), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8596), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6532), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [244134] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5420), 1,
      anon_sym_COLON,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7651), 1,
      anon_sym_as,
    ACTIONS(8486), 1,
      anon_sym_QMARK,
    ACTIONS(8492), 1,
      anon_sym_SLASH,
    ACTIONS(8494), 1,
      anon_sym_CARET,
    ACTIONS(8496), 1,
      anon_sym_PIPE,
    ACTIONS(8498), 1,
      anon_sym_AMP,
    ACTIONS(8502), 1,
      anon_sym_GT_GT,
    ACTIONS(8508), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8512), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8514), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8516), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8484), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8488), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8490), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8500), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8504), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8506), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6533), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [244266] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5385), 1,
      anon_sym_by,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(8576), 1,
      anon_sym_QMARK,
    ACTIONS(8582), 1,
      anon_sym_SLASH,
    ACTIONS(8584), 1,
      anon_sym_CARET,
    ACTIONS(8586), 1,
      anon_sym_PIPE,
    ACTIONS(8588), 1,
      anon_sym_AMP,
    ACTIONS(8592), 1,
      anon_sym_GT_GT,
    ACTIONS(8598), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8600), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8602), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8604), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8608), 1,
      anon_sym_as,
    ACTIONS(8610), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8574), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8578), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8580), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8590), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8594), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8596), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6534), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [244398] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5385), 1,
      anon_sym_in,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(8650), 1,
      anon_sym_QMARK,
    ACTIONS(8656), 1,
      anon_sym_SLASH,
    ACTIONS(8658), 1,
      anon_sym_CARET,
    ACTIONS(8660), 1,
      anon_sym_PIPE,
    ACTIONS(8662), 1,
      anon_sym_AMP,
    ACTIONS(8666), 1,
      anon_sym_GT_GT,
    ACTIONS(8672), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8674), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8676), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8678), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8680), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8648), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8652), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8654), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8664), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8668), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8670), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6535), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [244530] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(8576), 1,
      anon_sym_QMARK,
    ACTIONS(8582), 1,
      anon_sym_SLASH,
    ACTIONS(8584), 1,
      anon_sym_CARET,
    ACTIONS(8586), 1,
      anon_sym_PIPE,
    ACTIONS(8588), 1,
      anon_sym_AMP,
    ACTIONS(8592), 1,
      anon_sym_GT_GT,
    ACTIONS(8598), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8600), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8602), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8604), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8608), 1,
      anon_sym_as,
    ACTIONS(8610), 1,
      anon_sym_is,
    ACTIONS(9015), 1,
      anon_sym_by,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8574), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8578), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8580), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8590), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8594), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8596), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6536), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [244662] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5337), 1,
      anon_sym_by,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(8576), 1,
      anon_sym_QMARK,
    ACTIONS(8582), 1,
      anon_sym_SLASH,
    ACTIONS(8584), 1,
      anon_sym_CARET,
    ACTIONS(8586), 1,
      anon_sym_PIPE,
    ACTIONS(8588), 1,
      anon_sym_AMP,
    ACTIONS(8592), 1,
      anon_sym_GT_GT,
    ACTIONS(8598), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8600), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8602), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8604), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8608), 1,
      anon_sym_as,
    ACTIONS(8610), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8574), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8578), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8580), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8590), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8594), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8596), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6537), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [244794] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7210), 1,
      anon_sym_is,
    ACTIONS(7438), 1,
      anon_sym_QMARK,
    ACTIONS(7444), 1,
      anon_sym_SLASH,
    ACTIONS(7446), 1,
      anon_sym_CARET,
    ACTIONS(7448), 1,
      anon_sym_PIPE,
    ACTIONS(7450), 1,
      anon_sym_AMP,
    ACTIONS(7454), 1,
      anon_sym_GT_GT,
    ACTIONS(7460), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7462), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7464), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7466), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(9017), 1,
      anon_sym_SEMI,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7436), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7440), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7442), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7452), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7456), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7458), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6538), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [244926] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(8738), 1,
      anon_sym_SLASH,
    ACTIONS(8748), 1,
      anon_sym_GT_GT,
    ACTIONS(8754), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8764), 1,
      anon_sym_as,
    ACTIONS(8766), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8730), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8734), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8736), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8746), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8750), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8752), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6116), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(6114), 5,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_on,
    STATE(6539), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [245046] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(9019), 1,
      anon_sym_RPAREN,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6540), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [245178] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(8650), 1,
      anon_sym_QMARK,
    ACTIONS(8656), 1,
      anon_sym_SLASH,
    ACTIONS(8658), 1,
      anon_sym_CARET,
    ACTIONS(8660), 1,
      anon_sym_PIPE,
    ACTIONS(8662), 1,
      anon_sym_AMP,
    ACTIONS(8666), 1,
      anon_sym_GT_GT,
    ACTIONS(8672), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8674), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8676), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8678), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8680), 1,
      anon_sym_is,
    ACTIONS(9021), 1,
      anon_sym_in,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8648), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8652), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8654), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8664), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8668), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8670), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6541), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [245310] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8724), 1,
      anon_sym_and,
    ACTIONS(9023), 1,
      anon_sym_or,
    STATE(6542), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6609), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6607), 23,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [245392] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9025), 1,
      anon_sym_SEMI,
    STATE(6543), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5480), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5478), 24,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [245472] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(9027), 1,
      anon_sym_COMMA,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6544), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [245604] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7210), 1,
      anon_sym_is,
    ACTIONS(7438), 1,
      anon_sym_QMARK,
    ACTIONS(7444), 1,
      anon_sym_SLASH,
    ACTIONS(7446), 1,
      anon_sym_CARET,
    ACTIONS(7448), 1,
      anon_sym_PIPE,
    ACTIONS(7450), 1,
      anon_sym_AMP,
    ACTIONS(7454), 1,
      anon_sym_GT_GT,
    ACTIONS(7460), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7462), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7464), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7466), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(9029), 1,
      anon_sym_SEMI,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7436), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7440), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7442), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7452), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7456), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7458), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6545), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [245736] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(9031), 1,
      anon_sym_RPAREN,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6546), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [245868] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2029), 1,
      anon_sym_SEMI,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7210), 1,
      anon_sym_is,
    ACTIONS(7438), 1,
      anon_sym_QMARK,
    ACTIONS(7444), 1,
      anon_sym_SLASH,
    ACTIONS(7446), 1,
      anon_sym_CARET,
    ACTIONS(7448), 1,
      anon_sym_PIPE,
    ACTIONS(7450), 1,
      anon_sym_AMP,
    ACTIONS(7454), 1,
      anon_sym_GT_GT,
    ACTIONS(7460), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7462), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7464), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7466), 1,
      anon_sym_QMARK_QMARK,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7436), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7440), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7442), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7452), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7456), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7458), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6547), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [246000] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6230), 1,
      anon_sym_COLON,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7651), 1,
      anon_sym_as,
    ACTIONS(8486), 1,
      anon_sym_QMARK,
    ACTIONS(8492), 1,
      anon_sym_SLASH,
    ACTIONS(8494), 1,
      anon_sym_CARET,
    ACTIONS(8496), 1,
      anon_sym_PIPE,
    ACTIONS(8498), 1,
      anon_sym_AMP,
    ACTIONS(8502), 1,
      anon_sym_GT_GT,
    ACTIONS(8508), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8512), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8514), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8516), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8484), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8488), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8490), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8500), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8504), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8506), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6548), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [246132] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(9033), 1,
      anon_sym_RPAREN,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6549), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [246264] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5337), 1,
      anon_sym_EQ_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(8805), 1,
      anon_sym_QMARK,
    ACTIONS(8811), 1,
      anon_sym_SLASH,
    ACTIONS(8813), 1,
      anon_sym_CARET,
    ACTIONS(8815), 1,
      anon_sym_PIPE,
    ACTIONS(8817), 1,
      anon_sym_AMP,
    ACTIONS(8821), 1,
      anon_sym_GT_GT,
    ACTIONS(8827), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8829), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8831), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8833), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8835), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8803), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8807), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8809), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8819), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8823), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8825), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6550), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [246396] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5385), 1,
      anon_sym_EQ_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(8805), 1,
      anon_sym_QMARK,
    ACTIONS(8811), 1,
      anon_sym_SLASH,
    ACTIONS(8813), 1,
      anon_sym_CARET,
    ACTIONS(8815), 1,
      anon_sym_PIPE,
    ACTIONS(8817), 1,
      anon_sym_AMP,
    ACTIONS(8821), 1,
      anon_sym_GT_GT,
    ACTIONS(8827), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8829), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8831), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8833), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8835), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8803), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8807), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8809), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8819), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8823), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8825), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6551), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [246528] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5396), 1,
      anon_sym_EQ_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(8805), 1,
      anon_sym_QMARK,
    ACTIONS(8811), 1,
      anon_sym_SLASH,
    ACTIONS(8813), 1,
      anon_sym_CARET,
    ACTIONS(8815), 1,
      anon_sym_PIPE,
    ACTIONS(8817), 1,
      anon_sym_AMP,
    ACTIONS(8821), 1,
      anon_sym_GT_GT,
    ACTIONS(8827), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8829), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8831), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8833), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8835), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8803), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8807), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8809), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8819), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8823), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8825), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6552), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [246660] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6216), 1,
      anon_sym_EQ_GT,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(8805), 1,
      anon_sym_QMARK,
    ACTIONS(8811), 1,
      anon_sym_SLASH,
    ACTIONS(8813), 1,
      anon_sym_CARET,
    ACTIONS(8815), 1,
      anon_sym_PIPE,
    ACTIONS(8817), 1,
      anon_sym_AMP,
    ACTIONS(8821), 1,
      anon_sym_GT_GT,
    ACTIONS(8827), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8829), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8831), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8833), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8835), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8803), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8807), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8809), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8819), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8823), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8825), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6553), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [246792] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(8738), 1,
      anon_sym_SLASH,
    ACTIONS(8754), 1,
      anon_sym_DOT_DOT,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8734), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8736), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6116), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(6554), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 13,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
  [246898] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5325), 1,
      anon_sym_EQ_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(8805), 1,
      anon_sym_QMARK,
    ACTIONS(8811), 1,
      anon_sym_SLASH,
    ACTIONS(8813), 1,
      anon_sym_CARET,
    ACTIONS(8815), 1,
      anon_sym_PIPE,
    ACTIONS(8817), 1,
      anon_sym_AMP,
    ACTIONS(8821), 1,
      anon_sym_GT_GT,
    ACTIONS(8827), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8829), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8831), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8833), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8835), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8803), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8807), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8809), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8819), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8823), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8825), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6555), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [247030] = 32,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(8738), 1,
      anon_sym_SLASH,
    ACTIONS(8748), 1,
      anon_sym_GT_GT,
    ACTIONS(8754), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8764), 1,
      anon_sym_as,
    ACTIONS(8766), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8730), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8734), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8736), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8746), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8752), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6116), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(6114), 7,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_on,
    STATE(6556), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [247148] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5510), 1,
      anon_sym_EQ_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(8805), 1,
      anon_sym_QMARK,
    ACTIONS(8811), 1,
      anon_sym_SLASH,
    ACTIONS(8813), 1,
      anon_sym_CARET,
    ACTIONS(8815), 1,
      anon_sym_PIPE,
    ACTIONS(8817), 1,
      anon_sym_AMP,
    ACTIONS(8821), 1,
      anon_sym_GT_GT,
    ACTIONS(8827), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8829), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8831), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8833), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8835), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8803), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8807), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8809), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8819), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8823), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8825), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6557), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [247280] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(9035), 1,
      anon_sym_RPAREN,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6558), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [247412] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5420), 1,
      anon_sym_EQ_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(8805), 1,
      anon_sym_QMARK,
    ACTIONS(8811), 1,
      anon_sym_SLASH,
    ACTIONS(8813), 1,
      anon_sym_CARET,
    ACTIONS(8815), 1,
      anon_sym_PIPE,
    ACTIONS(8817), 1,
      anon_sym_AMP,
    ACTIONS(8821), 1,
      anon_sym_GT_GT,
    ACTIONS(8827), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8829), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8831), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8833), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8835), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8803), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8807), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8809), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8819), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8823), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8825), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6559), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [247544] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(7250), 1,
      anon_sym_LBRACK,
    ACTIONS(7252), 1,
      anon_sym_STAR,
    ACTIONS(7254), 1,
      anon_sym_QMARK,
    ACTIONS(9037), 1,
      anon_sym_DOT,
    ACTIONS(4424), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
    STATE(6560), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4422), 26,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [247632] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6236), 1,
      anon_sym_on,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(8732), 1,
      anon_sym_QMARK,
    ACTIONS(8738), 1,
      anon_sym_SLASH,
    ACTIONS(8740), 1,
      anon_sym_CARET,
    ACTIONS(8742), 1,
      anon_sym_PIPE,
    ACTIONS(8744), 1,
      anon_sym_AMP,
    ACTIONS(8748), 1,
      anon_sym_GT_GT,
    ACTIONS(8754), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8756), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8758), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8760), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8764), 1,
      anon_sym_as,
    ACTIONS(8766), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8730), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8734), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8736), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8746), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8750), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8752), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6561), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [247764] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6114), 1,
      anon_sym_EQ_GT,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(8811), 1,
      anon_sym_SLASH,
    ACTIONS(8813), 1,
      anon_sym_CARET,
    ACTIONS(8815), 1,
      anon_sym_PIPE,
    ACTIONS(8817), 1,
      anon_sym_AMP,
    ACTIONS(8821), 1,
      anon_sym_GT_GT,
    ACTIONS(8827), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8829), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8831), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8833), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8835), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8803), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8807), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8809), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8819), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8823), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8825), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6562), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [247896] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(8811), 1,
      anon_sym_SLASH,
    ACTIONS(8813), 1,
      anon_sym_CARET,
    ACTIONS(8815), 1,
      anon_sym_PIPE,
    ACTIONS(8817), 1,
      anon_sym_AMP,
    ACTIONS(8821), 1,
      anon_sym_GT_GT,
    ACTIONS(8827), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8829), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8835), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8803), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8807), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8809), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8819), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8823), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8825), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(6563), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [248024] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(8811), 1,
      anon_sym_SLASH,
    ACTIONS(8813), 1,
      anon_sym_CARET,
    ACTIONS(8815), 1,
      anon_sym_PIPE,
    ACTIONS(8817), 1,
      anon_sym_AMP,
    ACTIONS(8821), 1,
      anon_sym_GT_GT,
    ACTIONS(8827), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8835), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8803), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8807), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8809), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8819), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8823), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8825), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 4,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(6564), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [248150] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(8754), 1,
      anon_sym_DOT_DOT,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(6565), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6122), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6120), 17,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [248246] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(8827), 1,
      anon_sym_DOT_DOT,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(6566), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6122), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6120), 17,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [248342] = 32,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(8811), 1,
      anon_sym_SLASH,
    ACTIONS(8821), 1,
      anon_sym_GT_GT,
    ACTIONS(8827), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8835), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8803), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8807), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8809), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8819), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8825), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6116), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(6114), 7,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(6567), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [248460] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(8811), 1,
      anon_sym_SLASH,
    ACTIONS(8827), 1,
      anon_sym_DOT_DOT,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8807), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8809), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6116), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(6568), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 13,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [248566] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(8811), 1,
      anon_sym_SLASH,
    ACTIONS(8821), 1,
      anon_sym_GT_GT,
    ACTIONS(8827), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8835), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8803), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8807), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8809), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8819), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8823), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8825), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6116), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(6114), 5,
      anon_sym_CARET,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(6569), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [248686] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(8811), 1,
      anon_sym_SLASH,
    ACTIONS(8813), 1,
      anon_sym_CARET,
    ACTIONS(8817), 1,
      anon_sym_AMP,
    ACTIONS(8821), 1,
      anon_sym_GT_GT,
    ACTIONS(8827), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8835), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6116), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(8803), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8807), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8809), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8819), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8823), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8825), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 4,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(6570), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [248810] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8877), 1,
      anon_sym_into,
    STATE(6607), 1,
      aux_sym__query_body_repeat2,
    STATE(6571), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6420), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6418), 23,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [248892] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(8811), 1,
      anon_sym_SLASH,
    ACTIONS(8817), 1,
      anon_sym_AMP,
    ACTIONS(8821), 1,
      anon_sym_GT_GT,
    ACTIONS(8827), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8835), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6116), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(8803), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8807), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8809), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8819), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8823), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8825), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 5,
      anon_sym_CARET,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(6572), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [249014] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6114), 1,
      anon_sym_COLON,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7651), 1,
      anon_sym_as,
    ACTIONS(8492), 1,
      anon_sym_SLASH,
    ACTIONS(8494), 1,
      anon_sym_CARET,
    ACTIONS(8496), 1,
      anon_sym_PIPE,
    ACTIONS(8498), 1,
      anon_sym_AMP,
    ACTIONS(8502), 1,
      anon_sym_GT_GT,
    ACTIONS(8508), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8512), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8514), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8516), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8484), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8488), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8490), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8500), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8504), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8506), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6573), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [249146] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(9039), 1,
      anon_sym_COMMA,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6574), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [249278] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7651), 1,
      anon_sym_as,
    ACTIONS(8492), 1,
      anon_sym_SLASH,
    ACTIONS(8494), 1,
      anon_sym_CARET,
    ACTIONS(8496), 1,
      anon_sym_PIPE,
    ACTIONS(8498), 1,
      anon_sym_AMP,
    ACTIONS(8502), 1,
      anon_sym_GT_GT,
    ACTIONS(8508), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8516), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8484), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8488), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8490), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8500), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8504), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8506), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 3,
      anon_sym_COLON,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(6575), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [249406] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7651), 1,
      anon_sym_as,
    ACTIONS(8492), 1,
      anon_sym_SLASH,
    ACTIONS(8494), 1,
      anon_sym_CARET,
    ACTIONS(8496), 1,
      anon_sym_PIPE,
    ACTIONS(8498), 1,
      anon_sym_AMP,
    ACTIONS(8502), 1,
      anon_sym_GT_GT,
    ACTIONS(8508), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8516), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8484), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8488), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8490), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8500), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8504), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8506), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 4,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(6576), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [249532] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(8827), 1,
      anon_sym_DOT_DOT,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(6577), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6116), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6114), 15,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [249632] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(8508), 1,
      anon_sym_DOT_DOT,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(6578), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6122), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6120), 17,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [249728] = 25,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(8811), 1,
      anon_sym_SLASH,
    ACTIONS(8827), 1,
      anon_sym_DOT_DOT,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8809), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6116), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(6579), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 13,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [249832] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7651), 1,
      anon_sym_as,
    ACTIONS(8486), 1,
      anon_sym_QMARK,
    ACTIONS(8492), 1,
      anon_sym_SLASH,
    ACTIONS(8494), 1,
      anon_sym_CARET,
    ACTIONS(8496), 1,
      anon_sym_PIPE,
    ACTIONS(8498), 1,
      anon_sym_AMP,
    ACTIONS(8502), 1,
      anon_sym_GT_GT,
    ACTIONS(8508), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8512), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8514), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8516), 1,
      anon_sym_is,
    ACTIONS(9041), 1,
      anon_sym_COLON,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8484), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8488), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8490), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8500), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8504), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8506), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6580), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [249964] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5337), 1,
      anon_sym_in,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(8650), 1,
      anon_sym_QMARK,
    ACTIONS(8656), 1,
      anon_sym_SLASH,
    ACTIONS(8658), 1,
      anon_sym_CARET,
    ACTIONS(8660), 1,
      anon_sym_PIPE,
    ACTIONS(8662), 1,
      anon_sym_AMP,
    ACTIONS(8666), 1,
      anon_sym_GT_GT,
    ACTIONS(8672), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8674), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8676), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8678), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8680), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8648), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8652), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8654), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8664), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8668), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8670), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6581), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [250096] = 28,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(8811), 1,
      anon_sym_SLASH,
    ACTIONS(8821), 1,
      anon_sym_GT_GT,
    ACTIONS(8827), 1,
      anon_sym_DOT_DOT,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8807), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8809), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8819), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6116), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(6582), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 11,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [250206] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(8650), 1,
      anon_sym_QMARK,
    ACTIONS(8656), 1,
      anon_sym_SLASH,
    ACTIONS(8658), 1,
      anon_sym_CARET,
    ACTIONS(8660), 1,
      anon_sym_PIPE,
    ACTIONS(8662), 1,
      anon_sym_AMP,
    ACTIONS(8666), 1,
      anon_sym_GT_GT,
    ACTIONS(8672), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8674), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8676), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8678), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8680), 1,
      anon_sym_is,
    ACTIONS(9043), 1,
      anon_sym_in,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8648), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8652), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8654), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8664), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8668), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8670), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6583), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [250338] = 32,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7651), 1,
      anon_sym_as,
    ACTIONS(8492), 1,
      anon_sym_SLASH,
    ACTIONS(8502), 1,
      anon_sym_GT_GT,
    ACTIONS(8508), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8516), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8484), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8488), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8490), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8500), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8506), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6116), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(6114), 7,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(6584), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [250456] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(8492), 1,
      anon_sym_SLASH,
    ACTIONS(8508), 1,
      anon_sym_DOT_DOT,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8488), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8490), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6116), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(6585), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 13,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [250562] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7651), 1,
      anon_sym_as,
    ACTIONS(8492), 1,
      anon_sym_SLASH,
    ACTIONS(8502), 1,
      anon_sym_GT_GT,
    ACTIONS(8508), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8516), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8484), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8488), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8490), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8500), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8504), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8506), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6116), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(6114), 5,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(6586), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [250682] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7651), 1,
      anon_sym_as,
    ACTIONS(8492), 1,
      anon_sym_SLASH,
    ACTIONS(8494), 1,
      anon_sym_CARET,
    ACTIONS(8498), 1,
      anon_sym_AMP,
    ACTIONS(8502), 1,
      anon_sym_GT_GT,
    ACTIONS(8508), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8516), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6116), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(8484), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8488), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8490), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8500), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8504), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8506), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 4,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(6587), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [250806] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(8738), 1,
      anon_sym_SLASH,
    ACTIONS(8740), 1,
      anon_sym_CARET,
    ACTIONS(8742), 1,
      anon_sym_PIPE,
    ACTIONS(8744), 1,
      anon_sym_AMP,
    ACTIONS(8748), 1,
      anon_sym_GT_GT,
    ACTIONS(8754), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8764), 1,
      anon_sym_as,
    ACTIONS(8766), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8730), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8734), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8736), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8746), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8750), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8752), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 4,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_on,
    STATE(6588), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [250932] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7651), 1,
      anon_sym_as,
    ACTIONS(8486), 1,
      anon_sym_QMARK,
    ACTIONS(8492), 1,
      anon_sym_SLASH,
    ACTIONS(8494), 1,
      anon_sym_CARET,
    ACTIONS(8496), 1,
      anon_sym_PIPE,
    ACTIONS(8498), 1,
      anon_sym_AMP,
    ACTIONS(8502), 1,
      anon_sym_GT_GT,
    ACTIONS(8508), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8512), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8514), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8516), 1,
      anon_sym_is,
    ACTIONS(9045), 1,
      anon_sym_COLON,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8484), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8488), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8490), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8500), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8504), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8506), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6589), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [251064] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7651), 1,
      anon_sym_as,
    ACTIONS(8492), 1,
      anon_sym_SLASH,
    ACTIONS(8498), 1,
      anon_sym_AMP,
    ACTIONS(8502), 1,
      anon_sym_GT_GT,
    ACTIONS(8508), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8516), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6116), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(8484), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8488), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8490), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8500), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8504), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8506), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 5,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(6590), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [251186] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(8522), 1,
      anon_sym_QMARK,
    ACTIONS(8528), 1,
      anon_sym_SLASH,
    ACTIONS(8530), 1,
      anon_sym_CARET,
    ACTIONS(8532), 1,
      anon_sym_PIPE,
    ACTIONS(8534), 1,
      anon_sym_AMP,
    ACTIONS(8538), 1,
      anon_sym_GT_GT,
    ACTIONS(8544), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8546), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8548), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8550), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8552), 1,
      anon_sym_as,
    ACTIONS(8554), 1,
      anon_sym_is,
    ACTIONS(9047), 1,
      anon_sym_equals,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8520), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8524), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8526), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8536), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8540), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8542), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6591), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [251318] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(8650), 1,
      anon_sym_QMARK,
    ACTIONS(8656), 1,
      anon_sym_SLASH,
    ACTIONS(8658), 1,
      anon_sym_CARET,
    ACTIONS(8660), 1,
      anon_sym_PIPE,
    ACTIONS(8662), 1,
      anon_sym_AMP,
    ACTIONS(8666), 1,
      anon_sym_GT_GT,
    ACTIONS(8672), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8674), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8676), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8678), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8680), 1,
      anon_sym_is,
    ACTIONS(9049), 1,
      anon_sym_in,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8648), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8652), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8654), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8664), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8668), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8670), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6592), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [251450] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(8738), 1,
      anon_sym_SLASH,
    ACTIONS(8740), 1,
      anon_sym_CARET,
    ACTIONS(8742), 1,
      anon_sym_PIPE,
    ACTIONS(8744), 1,
      anon_sym_AMP,
    ACTIONS(8748), 1,
      anon_sym_GT_GT,
    ACTIONS(8754), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8756), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8764), 1,
      anon_sym_as,
    ACTIONS(8766), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8730), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8734), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8736), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8746), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8750), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8752), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6114), 3,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_on,
    STATE(6593), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [251578] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(9051), 1,
      anon_sym_RPAREN,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6594), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [251710] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6230), 1,
      anon_sym_on,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(8732), 1,
      anon_sym_QMARK,
    ACTIONS(8738), 1,
      anon_sym_SLASH,
    ACTIONS(8740), 1,
      anon_sym_CARET,
    ACTIONS(8742), 1,
      anon_sym_PIPE,
    ACTIONS(8744), 1,
      anon_sym_AMP,
    ACTIONS(8748), 1,
      anon_sym_GT_GT,
    ACTIONS(8754), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8756), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8758), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8760), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8764), 1,
      anon_sym_as,
    ACTIONS(8766), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8730), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8734), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8736), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8746), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8750), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8752), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6595), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [251842] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6114), 1,
      anon_sym_on,
    ACTIONS(6116), 1,
      anon_sym_QMARK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(8738), 1,
      anon_sym_SLASH,
    ACTIONS(8740), 1,
      anon_sym_CARET,
    ACTIONS(8742), 1,
      anon_sym_PIPE,
    ACTIONS(8744), 1,
      anon_sym_AMP,
    ACTIONS(8748), 1,
      anon_sym_GT_GT,
    ACTIONS(8754), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8756), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8758), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8760), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8764), 1,
      anon_sym_as,
    ACTIONS(8766), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8730), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8734), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8736), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8746), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8750), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8752), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6596), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [251974] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(8508), 1,
      anon_sym_DOT_DOT,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(6597), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6116), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6114), 15,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [252074] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(8732), 1,
      anon_sym_QMARK,
    ACTIONS(8738), 1,
      anon_sym_SLASH,
    ACTIONS(8740), 1,
      anon_sym_CARET,
    ACTIONS(8742), 1,
      anon_sym_PIPE,
    ACTIONS(8744), 1,
      anon_sym_AMP,
    ACTIONS(8748), 1,
      anon_sym_GT_GT,
    ACTIONS(8754), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8756), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8758), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8760), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8764), 1,
      anon_sym_as,
    ACTIONS(8766), 1,
      anon_sym_is,
    ACTIONS(9053), 1,
      anon_sym_on,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8730), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8734), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8736), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8746), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8750), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8752), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6598), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [252206] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8877), 1,
      anon_sym_into,
    STATE(6617), 1,
      aux_sym__query_body_repeat2,
    STATE(6599), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6420), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6418), 23,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [252288] = 25,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(8492), 1,
      anon_sym_SLASH,
    ACTIONS(8508), 1,
      anon_sym_DOT_DOT,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8490), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6116), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(6600), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 13,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [252392] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7651), 1,
      anon_sym_as,
    ACTIONS(8486), 1,
      anon_sym_QMARK,
    ACTIONS(8492), 1,
      anon_sym_SLASH,
    ACTIONS(8494), 1,
      anon_sym_CARET,
    ACTIONS(8496), 1,
      anon_sym_PIPE,
    ACTIONS(8498), 1,
      anon_sym_AMP,
    ACTIONS(8502), 1,
      anon_sym_GT_GT,
    ACTIONS(8508), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8512), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8514), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8516), 1,
      anon_sym_is,
    ACTIONS(9055), 1,
      anon_sym_COLON,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8484), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8488), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8490), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8500), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8504), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8506), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6601), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [252524] = 28,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(8492), 1,
      anon_sym_SLASH,
    ACTIONS(8502), 1,
      anon_sym_GT_GT,
    ACTIONS(8508), 1,
      anon_sym_DOT_DOT,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8488), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8490), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8500), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6116), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(6602), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6114), 11,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [252634] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5420), 1,
      anon_sym_on,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(8732), 1,
      anon_sym_QMARK,
    ACTIONS(8738), 1,
      anon_sym_SLASH,
    ACTIONS(8740), 1,
      anon_sym_CARET,
    ACTIONS(8742), 1,
      anon_sym_PIPE,
    ACTIONS(8744), 1,
      anon_sym_AMP,
    ACTIONS(8748), 1,
      anon_sym_GT_GT,
    ACTIONS(8754), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8756), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8758), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8760), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8764), 1,
      anon_sym_as,
    ACTIONS(8766), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8730), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8734), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8736), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8746), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8750), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8752), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6603), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [252766] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(9057), 1,
      anon_sym_RPAREN,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6604), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [252898] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(9059), 1,
      anon_sym_RPAREN,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6605), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [253030] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(9061), 1,
      anon_sym_RPAREN,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6606), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [253162] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9063), 1,
      anon_sym_into,
    STATE(6607), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym__query_body_repeat2,
    ACTIONS(6376), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6374), 23,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [253242] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(8576), 1,
      anon_sym_QMARK,
    ACTIONS(8582), 1,
      anon_sym_SLASH,
    ACTIONS(8584), 1,
      anon_sym_CARET,
    ACTIONS(8586), 1,
      anon_sym_PIPE,
    ACTIONS(8588), 1,
      anon_sym_AMP,
    ACTIONS(8592), 1,
      anon_sym_GT_GT,
    ACTIONS(8598), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8600), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8602), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8604), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8608), 1,
      anon_sym_as,
    ACTIONS(8610), 1,
      anon_sym_is,
    ACTIONS(9066), 1,
      anon_sym_by,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8574), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8578), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8580), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8590), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8594), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8596), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6608), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [253374] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7651), 1,
      anon_sym_as,
    ACTIONS(8486), 1,
      anon_sym_QMARK,
    ACTIONS(8492), 1,
      anon_sym_SLASH,
    ACTIONS(8494), 1,
      anon_sym_CARET,
    ACTIONS(8496), 1,
      anon_sym_PIPE,
    ACTIONS(8498), 1,
      anon_sym_AMP,
    ACTIONS(8502), 1,
      anon_sym_GT_GT,
    ACTIONS(8508), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8512), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8514), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8516), 1,
      anon_sym_is,
    ACTIONS(9068), 1,
      anon_sym_COLON,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8484), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8488), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8490), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8500), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8504), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8506), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6609), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [253506] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(9070), 1,
      anon_sym_RPAREN,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6610), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [253638] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7210), 1,
      anon_sym_is,
    ACTIONS(7438), 1,
      anon_sym_QMARK,
    ACTIONS(7444), 1,
      anon_sym_SLASH,
    ACTIONS(7446), 1,
      anon_sym_CARET,
    ACTIONS(7448), 1,
      anon_sym_PIPE,
    ACTIONS(7450), 1,
      anon_sym_AMP,
    ACTIONS(7454), 1,
      anon_sym_GT_GT,
    ACTIONS(7460), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7462), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7464), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7466), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(9072), 1,
      anon_sym_SEMI,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7436), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7440), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7442), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7452), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7456), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7458), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6611), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [253770] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7651), 1,
      anon_sym_as,
    ACTIONS(8486), 1,
      anon_sym_QMARK,
    ACTIONS(8492), 1,
      anon_sym_SLASH,
    ACTIONS(8494), 1,
      anon_sym_CARET,
    ACTIONS(8496), 1,
      anon_sym_PIPE,
    ACTIONS(8498), 1,
      anon_sym_AMP,
    ACTIONS(8502), 1,
      anon_sym_GT_GT,
    ACTIONS(8508), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8512), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8514), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8516), 1,
      anon_sym_is,
    ACTIONS(9074), 1,
      anon_sym_COLON,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8484), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8488), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8490), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8500), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8504), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8506), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6612), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [253902] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5510), 1,
      anon_sym_on,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(8732), 1,
      anon_sym_QMARK,
    ACTIONS(8738), 1,
      anon_sym_SLASH,
    ACTIONS(8740), 1,
      anon_sym_CARET,
    ACTIONS(8742), 1,
      anon_sym_PIPE,
    ACTIONS(8744), 1,
      anon_sym_AMP,
    ACTIONS(8748), 1,
      anon_sym_GT_GT,
    ACTIONS(8754), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8756), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8758), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8760), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8764), 1,
      anon_sym_as,
    ACTIONS(8766), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8730), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8734), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8736), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8746), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8750), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8752), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6613), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [254034] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(9076), 1,
      anon_sym_RPAREN,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6614), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [254166] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(9078), 1,
      anon_sym_RPAREN,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6615), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [254298] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(9080), 1,
      anon_sym_RPAREN,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6616), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [254430] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8877), 1,
      anon_sym_into,
    STATE(6607), 1,
      aux_sym__query_body_repeat2,
    STATE(6617), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6383), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6381), 23,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [254512] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(9082), 1,
      anon_sym_RPAREN,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6618), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [254644] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5325), 1,
      anon_sym_on,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(8732), 1,
      anon_sym_QMARK,
    ACTIONS(8738), 1,
      anon_sym_SLASH,
    ACTIONS(8740), 1,
      anon_sym_CARET,
    ACTIONS(8742), 1,
      anon_sym_PIPE,
    ACTIONS(8744), 1,
      anon_sym_AMP,
    ACTIONS(8748), 1,
      anon_sym_GT_GT,
    ACTIONS(8754), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8756), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8758), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8760), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8764), 1,
      anon_sym_as,
    ACTIONS(8766), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8730), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8734), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8736), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8746), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8750), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8752), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6619), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [254776] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(9084), 1,
      anon_sym_RPAREN,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6620), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [254908] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7210), 1,
      anon_sym_is,
    ACTIONS(7438), 1,
      anon_sym_QMARK,
    ACTIONS(7444), 1,
      anon_sym_SLASH,
    ACTIONS(7446), 1,
      anon_sym_CARET,
    ACTIONS(7448), 1,
      anon_sym_PIPE,
    ACTIONS(7450), 1,
      anon_sym_AMP,
    ACTIONS(7454), 1,
      anon_sym_GT_GT,
    ACTIONS(7460), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7462), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7464), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7466), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(9086), 1,
      anon_sym_SEMI,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7436), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7440), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7442), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7452), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7456), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7458), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6621), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [255040] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6216), 1,
      anon_sym_on,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(8732), 1,
      anon_sym_QMARK,
    ACTIONS(8738), 1,
      anon_sym_SLASH,
    ACTIONS(8740), 1,
      anon_sym_CARET,
    ACTIONS(8742), 1,
      anon_sym_PIPE,
    ACTIONS(8744), 1,
      anon_sym_AMP,
    ACTIONS(8748), 1,
      anon_sym_GT_GT,
    ACTIONS(8754), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8756), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8758), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8760), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8764), 1,
      anon_sym_as,
    ACTIONS(8766), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8730), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8734), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8736), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8746), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8750), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8752), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6622), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [255172] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7210), 1,
      anon_sym_is,
    ACTIONS(7438), 1,
      anon_sym_QMARK,
    ACTIONS(7444), 1,
      anon_sym_SLASH,
    ACTIONS(7446), 1,
      anon_sym_CARET,
    ACTIONS(7448), 1,
      anon_sym_PIPE,
    ACTIONS(7450), 1,
      anon_sym_AMP,
    ACTIONS(7454), 1,
      anon_sym_GT_GT,
    ACTIONS(7460), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7462), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7464), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7466), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(9088), 1,
      anon_sym_SEMI,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7436), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7440), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7442), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7452), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7456), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7458), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6623), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [255304] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5396), 1,
      anon_sym_on,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(8732), 1,
      anon_sym_QMARK,
    ACTIONS(8738), 1,
      anon_sym_SLASH,
    ACTIONS(8740), 1,
      anon_sym_CARET,
    ACTIONS(8742), 1,
      anon_sym_PIPE,
    ACTIONS(8744), 1,
      anon_sym_AMP,
    ACTIONS(8748), 1,
      anon_sym_GT_GT,
    ACTIONS(8754), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8756), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8758), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8760), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8764), 1,
      anon_sym_as,
    ACTIONS(8766), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8730), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8734), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8736), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8746), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8750), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8752), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6624), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [255436] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(9090), 1,
      anon_sym_RPAREN,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6625), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [255568] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(9092), 1,
      anon_sym_RPAREN,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6626), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [255700] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(8754), 1,
      anon_sym_DOT_DOT,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(6627), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1147), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(1133), 17,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [255796] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(9094), 1,
      anon_sym_RPAREN,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6628), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [255928] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5385), 1,
      anon_sym_on,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(8732), 1,
      anon_sym_QMARK,
    ACTIONS(8738), 1,
      anon_sym_SLASH,
    ACTIONS(8740), 1,
      anon_sym_CARET,
    ACTIONS(8742), 1,
      anon_sym_PIPE,
    ACTIONS(8744), 1,
      anon_sym_AMP,
    ACTIONS(8748), 1,
      anon_sym_GT_GT,
    ACTIONS(8754), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8756), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8758), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8760), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8764), 1,
      anon_sym_as,
    ACTIONS(8766), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8730), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8734), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8736), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8746), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8750), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8752), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6629), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [256060] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6220), 1,
      anon_sym_on,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(8732), 1,
      anon_sym_QMARK,
    ACTIONS(8738), 1,
      anon_sym_SLASH,
    ACTIONS(8740), 1,
      anon_sym_CARET,
    ACTIONS(8742), 1,
      anon_sym_PIPE,
    ACTIONS(8744), 1,
      anon_sym_AMP,
    ACTIONS(8748), 1,
      anon_sym_GT_GT,
    ACTIONS(8754), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8756), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8758), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8760), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8764), 1,
      anon_sym_as,
    ACTIONS(8766), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8730), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8734), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8736), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8746), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8750), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8752), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6630), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [256192] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7651), 1,
      anon_sym_as,
    ACTIONS(8486), 1,
      anon_sym_QMARK,
    ACTIONS(8492), 1,
      anon_sym_SLASH,
    ACTIONS(8494), 1,
      anon_sym_CARET,
    ACTIONS(8496), 1,
      anon_sym_PIPE,
    ACTIONS(8498), 1,
      anon_sym_AMP,
    ACTIONS(8502), 1,
      anon_sym_GT_GT,
    ACTIONS(8508), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8512), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8514), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8516), 1,
      anon_sym_is,
    ACTIONS(9096), 1,
      anon_sym_COLON,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8484), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8488), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8490), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8500), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8504), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8506), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6631), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [256324] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(8650), 1,
      anon_sym_QMARK,
    ACTIONS(8656), 1,
      anon_sym_SLASH,
    ACTIONS(8658), 1,
      anon_sym_CARET,
    ACTIONS(8660), 1,
      anon_sym_PIPE,
    ACTIONS(8662), 1,
      anon_sym_AMP,
    ACTIONS(8666), 1,
      anon_sym_GT_GT,
    ACTIONS(8672), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8674), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8676), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8678), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8680), 1,
      anon_sym_is,
    ACTIONS(9098), 1,
      anon_sym_in,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8648), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8652), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8654), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8664), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8668), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8670), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6632), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [256456] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5337), 1,
      anon_sym_on,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(8732), 1,
      anon_sym_QMARK,
    ACTIONS(8738), 1,
      anon_sym_SLASH,
    ACTIONS(8740), 1,
      anon_sym_CARET,
    ACTIONS(8742), 1,
      anon_sym_PIPE,
    ACTIONS(8744), 1,
      anon_sym_AMP,
    ACTIONS(8748), 1,
      anon_sym_GT_GT,
    ACTIONS(8754), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8756), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8758), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8760), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8764), 1,
      anon_sym_as,
    ACTIONS(8766), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8730), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8734), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8736), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8746), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8750), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8752), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6633), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [256588] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(8576), 1,
      anon_sym_QMARK,
    ACTIONS(8582), 1,
      anon_sym_SLASH,
    ACTIONS(8584), 1,
      anon_sym_CARET,
    ACTIONS(8586), 1,
      anon_sym_PIPE,
    ACTIONS(8588), 1,
      anon_sym_AMP,
    ACTIONS(8592), 1,
      anon_sym_GT_GT,
    ACTIONS(8598), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8600), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8602), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8604), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8608), 1,
      anon_sym_as,
    ACTIONS(8610), 1,
      anon_sym_is,
    ACTIONS(9100), 1,
      anon_sym_by,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8574), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8578), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8580), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8590), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8594), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8596), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6634), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [256720] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7651), 1,
      anon_sym_as,
    ACTIONS(8486), 1,
      anon_sym_QMARK,
    ACTIONS(8492), 1,
      anon_sym_SLASH,
    ACTIONS(8494), 1,
      anon_sym_CARET,
    ACTIONS(8496), 1,
      anon_sym_PIPE,
    ACTIONS(8498), 1,
      anon_sym_AMP,
    ACTIONS(8502), 1,
      anon_sym_GT_GT,
    ACTIONS(8508), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8512), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8514), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8516), 1,
      anon_sym_is,
    ACTIONS(9102), 1,
      anon_sym_COLON,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8484), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8488), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8490), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8500), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8504), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8506), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6635), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [256852] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7210), 1,
      anon_sym_is,
    ACTIONS(7438), 1,
      anon_sym_QMARK,
    ACTIONS(7444), 1,
      anon_sym_SLASH,
    ACTIONS(7446), 1,
      anon_sym_CARET,
    ACTIONS(7448), 1,
      anon_sym_PIPE,
    ACTIONS(7450), 1,
      anon_sym_AMP,
    ACTIONS(7454), 1,
      anon_sym_GT_GT,
    ACTIONS(7460), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7462), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7464), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7466), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(9104), 1,
      anon_sym_SEMI,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7436), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7440), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7442), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7452), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7456), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7458), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6636), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [256984] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(9106), 1,
      anon_sym_RPAREN,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6637), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [257116] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8724), 1,
      anon_sym_and,
    ACTIONS(9023), 1,
      anon_sym_or,
    STATE(6638), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5856), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5854), 23,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [257198] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7651), 1,
      anon_sym_as,
    ACTIONS(8486), 1,
      anon_sym_QMARK,
    ACTIONS(8492), 1,
      anon_sym_SLASH,
    ACTIONS(8494), 1,
      anon_sym_CARET,
    ACTIONS(8496), 1,
      anon_sym_PIPE,
    ACTIONS(8498), 1,
      anon_sym_AMP,
    ACTIONS(8502), 1,
      anon_sym_GT_GT,
    ACTIONS(8508), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8512), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8514), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8516), 1,
      anon_sym_is,
    ACTIONS(9108), 1,
      anon_sym_COLON,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8484), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8488), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8490), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8500), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8504), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8506), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6639), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [257330] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8974), 1,
      anon_sym_and,
    ACTIONS(8982), 1,
      anon_sym_or,
    STATE(6640), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6609), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6607), 23,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [257412] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7210), 1,
      anon_sym_is,
    ACTIONS(7438), 1,
      anon_sym_QMARK,
    ACTIONS(7444), 1,
      anon_sym_SLASH,
    ACTIONS(7446), 1,
      anon_sym_CARET,
    ACTIONS(7448), 1,
      anon_sym_PIPE,
    ACTIONS(7450), 1,
      anon_sym_AMP,
    ACTIONS(7454), 1,
      anon_sym_GT_GT,
    ACTIONS(7460), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7462), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7464), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7466), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(9110), 1,
      anon_sym_SEMI,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7436), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7440), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7442), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7452), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7456), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7458), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6641), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [257544] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(8576), 1,
      anon_sym_QMARK,
    ACTIONS(8582), 1,
      anon_sym_SLASH,
    ACTIONS(8584), 1,
      anon_sym_CARET,
    ACTIONS(8586), 1,
      anon_sym_PIPE,
    ACTIONS(8588), 1,
      anon_sym_AMP,
    ACTIONS(8592), 1,
      anon_sym_GT_GT,
    ACTIONS(8598), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8600), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8602), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8604), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8608), 1,
      anon_sym_as,
    ACTIONS(8610), 1,
      anon_sym_is,
    ACTIONS(9112), 1,
      anon_sym_by,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8574), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8578), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8580), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8590), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8594), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8596), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6642), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [257676] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7651), 1,
      anon_sym_as,
    ACTIONS(8486), 1,
      anon_sym_QMARK,
    ACTIONS(8492), 1,
      anon_sym_SLASH,
    ACTIONS(8494), 1,
      anon_sym_CARET,
    ACTIONS(8496), 1,
      anon_sym_PIPE,
    ACTIONS(8498), 1,
      anon_sym_AMP,
    ACTIONS(8502), 1,
      anon_sym_GT_GT,
    ACTIONS(8508), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8512), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8514), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8516), 1,
      anon_sym_is,
    ACTIONS(9114), 1,
      anon_sym_COLON,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8484), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8488), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8490), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8500), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8504), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8506), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6643), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [257808] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7210), 1,
      anon_sym_is,
    ACTIONS(7438), 1,
      anon_sym_QMARK,
    ACTIONS(7444), 1,
      anon_sym_SLASH,
    ACTIONS(7446), 1,
      anon_sym_CARET,
    ACTIONS(7448), 1,
      anon_sym_PIPE,
    ACTIONS(7450), 1,
      anon_sym_AMP,
    ACTIONS(7454), 1,
      anon_sym_GT_GT,
    ACTIONS(7460), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7462), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7464), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7466), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(9116), 1,
      anon_sym_SEMI,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7436), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7440), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7442), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7452), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7456), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7458), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6644), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [257940] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(9118), 1,
      anon_sym_RPAREN,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6645), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [258072] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7210), 1,
      anon_sym_is,
    ACTIONS(7438), 1,
      anon_sym_QMARK,
    ACTIONS(7444), 1,
      anon_sym_SLASH,
    ACTIONS(7446), 1,
      anon_sym_CARET,
    ACTIONS(7448), 1,
      anon_sym_PIPE,
    ACTIONS(7450), 1,
      anon_sym_AMP,
    ACTIONS(7454), 1,
      anon_sym_GT_GT,
    ACTIONS(7460), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7462), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7464), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7466), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(9120), 1,
      anon_sym_SEMI,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7436), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7440), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7442), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7452), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7456), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7458), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6646), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [258204] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(9122), 1,
      anon_sym_RPAREN,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6647), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [258336] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(9124), 1,
      anon_sym_RPAREN,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6648), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [258468] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6236), 1,
      anon_sym_equals,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(8522), 1,
      anon_sym_QMARK,
    ACTIONS(8528), 1,
      anon_sym_SLASH,
    ACTIONS(8530), 1,
      anon_sym_CARET,
    ACTIONS(8532), 1,
      anon_sym_PIPE,
    ACTIONS(8534), 1,
      anon_sym_AMP,
    ACTIONS(8538), 1,
      anon_sym_GT_GT,
    ACTIONS(8544), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8546), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8548), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8550), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8552), 1,
      anon_sym_as,
    ACTIONS(8554), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8520), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8524), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8526), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8536), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8540), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8542), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6649), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [258600] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(9126), 1,
      anon_sym_RPAREN,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6650), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [258732] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6220), 1,
      anon_sym_in,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(8650), 1,
      anon_sym_QMARK,
    ACTIONS(8656), 1,
      anon_sym_SLASH,
    ACTIONS(8658), 1,
      anon_sym_CARET,
    ACTIONS(8660), 1,
      anon_sym_PIPE,
    ACTIONS(8662), 1,
      anon_sym_AMP,
    ACTIONS(8666), 1,
      anon_sym_GT_GT,
    ACTIONS(8672), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8674), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8676), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8678), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8680), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8648), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8652), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8654), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8664), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8668), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8670), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6651), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [258864] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_QMARK,
    ACTIONS(7478), 1,
      anon_sym_SLASH,
    ACTIONS(7480), 1,
      anon_sym_CARET,
    ACTIONS(7482), 1,
      anon_sym_PIPE,
    ACTIONS(7484), 1,
      anon_sym_AMP,
    ACTIONS(7488), 1,
      anon_sym_GT_GT,
    ACTIONS(7494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7496), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7498), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7500), 1,
      anon_sym_is,
    ACTIONS(9128), 1,
      anon_sym_RPAREN,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7470), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7474), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7476), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7486), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6652), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [258996] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8839), 1,
      anon_sym_and,
    STATE(6653), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6546), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6544), 24,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [259076] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7651), 1,
      anon_sym_as,
    ACTIONS(8486), 1,
      anon_sym_QMARK,
    ACTIONS(8492), 1,
      anon_sym_SLASH,
    ACTIONS(8494), 1,
      anon_sym_CARET,
    ACTIONS(8496), 1,
      anon_sym_PIPE,
    ACTIONS(8498), 1,
      anon_sym_AMP,
    ACTIONS(8502), 1,
      anon_sym_GT_GT,
    ACTIONS(8508), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8512), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8514), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8516), 1,
      anon_sym_is,
    ACTIONS(9130), 1,
      anon_sym_COLON,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8484), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8488), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8490), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8500), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8504), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8506), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6654), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [259208] = 38,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7178), 1,
      anon_sym_QMARK,
    ACTIONS(7200), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7210), 1,
      anon_sym_is,
    ACTIONS(7242), 1,
      anon_sym_SLASH,
    ACTIONS(7246), 1,
      anon_sym_GT_GT,
    ACTIONS(7260), 1,
      anon_sym_CARET,
    ACTIONS(7262), 1,
      anon_sym_PIPE,
    ACTIONS(7264), 1,
      anon_sym_AMP,
    ACTIONS(7270), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7272), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7274), 1,
      anon_sym_QMARK_QMARK,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7238), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7240), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7244), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7256), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7266), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7268), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6655), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [259337] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4277), 1,
      anon_sym_LBRACE,
    ACTIONS(4295), 1,
      sym_discard,
    ACTIONS(7333), 1,
      sym__identifier_token,
    ACTIONS(8391), 1,
      anon_sym_LPAREN,
    STATE(3127), 1,
      sym__reserved_identifier,
    STATE(4124), 1,
      sym__variable_designation,
    STATE(4269), 1,
      sym_identifier,
    STATE(4274), 1,
      sym_parenthesized_variable_designation,
    STATE(6739), 1,
      sym_property_pattern_clause,
    ACTIONS(4335), 2,
      anon_sym_COLON,
      anon_sym_EQ_GT,
    ACTIONS(4337), 3,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
    STATE(6656), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7335), 21,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [259434] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4277), 1,
      anon_sym_LBRACE,
    ACTIONS(4295), 1,
      sym_discard,
    ACTIONS(7333), 1,
      sym__identifier_token,
    ACTIONS(8391), 1,
      anon_sym_LPAREN,
    STATE(3127), 1,
      sym__reserved_identifier,
    STATE(4256), 1,
      sym__variable_designation,
    STATE(4269), 1,
      sym_identifier,
    STATE(4274), 1,
      sym_parenthesized_variable_designation,
    STATE(6735), 1,
      sym_property_pattern_clause,
    ACTIONS(4329), 2,
      anon_sym_COLON,
      anon_sym_EQ_GT,
    ACTIONS(4331), 3,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
    STATE(6657), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7335), 21,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [259531] = 38,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4953), 1,
      anon_sym_DASH_GT,
    ACTIONS(5067), 1,
      anon_sym_DOT,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_LPAREN,
    ACTIONS(7026), 1,
      anon_sym_BANG,
    ACTIONS(7034), 1,
      anon_sym_SLASH,
    ACTIONS(7038), 1,
      anon_sym_GT_GT,
    ACTIONS(7052), 1,
      anon_sym_CARET,
    ACTIONS(7054), 1,
      anon_sym_PIPE,
    ACTIONS(7056), 1,
      anon_sym_AMP,
    ACTIONS(7060), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7066), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7068), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7178), 1,
      anon_sym_QMARK,
    ACTIONS(7200), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7210), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(5721), 1,
      sym_argument_list,
    ACTIONS(7024), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7028), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7030), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7032), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7036), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7040), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7058), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    STATE(6658), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [259660] = 38,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7178), 1,
      anon_sym_QMARK,
    ACTIONS(7200), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7210), 1,
      anon_sym_is,
    ACTIONS(7693), 1,
      anon_sym_SLASH,
    ACTIONS(7697), 1,
      anon_sym_GT_GT,
    ACTIONS(7703), 1,
      anon_sym_AMP,
    ACTIONS(7711), 1,
      anon_sym_CARET,
    ACTIONS(7713), 1,
      anon_sym_PIPE,
    ACTIONS(7715), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7717), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7719), 1,
      anon_sym_QMARK_QMARK,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7689), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7691), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7695), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7701), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7705), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7707), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6659), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [259789] = 38,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7178), 1,
      anon_sym_QMARK,
    ACTIONS(7200), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7210), 1,
      anon_sym_is,
    ACTIONS(7509), 1,
      anon_sym_SLASH,
    ACTIONS(7515), 1,
      anon_sym_GT_GT,
    ACTIONS(7669), 1,
      anon_sym_CARET,
    ACTIONS(7671), 1,
      anon_sym_PIPE,
    ACTIONS(7673), 1,
      anon_sym_AMP,
    ACTIONS(7679), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7681), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7683), 1,
      anon_sym_QMARK_QMARK,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7505), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7507), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7513), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7665), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7675), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7677), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6660), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [259918] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9033), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    ACTIONS(4349), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
    STATE(6661), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4347), 26,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [260003] = 38,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6304), 1,
      anon_sym_SLASH,
    ACTIONS(6306), 1,
      anon_sym_CARET,
    ACTIONS(6308), 1,
      anon_sym_PIPE,
    ACTIONS(6310), 1,
      anon_sym_AMP,
    ACTIONS(6314), 1,
      anon_sym_GT_GT,
    ACTIONS(6324), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6326), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6328), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7178), 1,
      anon_sym_QMARK,
    ACTIONS(7200), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7210), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6296), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6300), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6302), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6312), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6316), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6318), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6662), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [260132] = 38,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7178), 1,
      anon_sym_QMARK,
    ACTIONS(7200), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7210), 1,
      anon_sym_is,
    ACTIONS(7920), 1,
      anon_sym_SLASH,
    ACTIONS(7922), 1,
      anon_sym_CARET,
    ACTIONS(7924), 1,
      anon_sym_PIPE,
    ACTIONS(7926), 1,
      anon_sym_AMP,
    ACTIONS(7930), 1,
      anon_sym_GT_GT,
    ACTIONS(7936), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7938), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7940), 1,
      anon_sym_QMARK_QMARK,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7912), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7916), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7918), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7928), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7932), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7934), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6663), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [260261] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(7250), 1,
      anon_sym_LBRACK,
    ACTIONS(7252), 1,
      anon_sym_STAR,
    ACTIONS(7254), 1,
      anon_sym_QMARK,
    ACTIONS(9132), 1,
      anon_sym_DOT,
    ACTIONS(4424), 4,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    STATE(6664), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4422), 26,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [260348] = 38,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5165), 1,
      anon_sym_DOT,
    ACTIONS(5167), 1,
      anon_sym_DASH_GT,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6008), 1,
      anon_sym_LPAREN,
    ACTIONS(6044), 1,
      anon_sym_BANG,
    ACTIONS(6052), 1,
      anon_sym_SLASH,
    ACTIONS(6054), 1,
      anon_sym_CARET,
    ACTIONS(6056), 1,
      anon_sym_PIPE,
    ACTIONS(6058), 1,
      anon_sym_AMP,
    ACTIONS(6062), 1,
      anon_sym_GT_GT,
    ACTIONS(6072), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6074), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6076), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7178), 1,
      anon_sym_QMARK,
    ACTIONS(7200), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7210), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4571), 1,
      sym_argument_list,
    ACTIONS(6040), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6046), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6048), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6050), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6060), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6064), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6066), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6665), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [260477] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(7250), 1,
      anon_sym_LBRACK,
    ACTIONS(7252), 1,
      anon_sym_STAR,
    ACTIONS(7254), 1,
      anon_sym_QMARK,
    ACTIONS(9134), 1,
      anon_sym_DOT,
    ACTIONS(4424), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    STATE(6666), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4422), 26,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [260564] = 38,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(6933), 1,
      anon_sym_SLASH,
    ACTIONS(6935), 1,
      anon_sym_CARET,
    ACTIONS(6937), 1,
      anon_sym_PIPE,
    ACTIONS(6939), 1,
      anon_sym_AMP,
    ACTIONS(6943), 1,
      anon_sym_GT_GT,
    ACTIONS(6953), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6955), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6957), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7178), 1,
      anon_sym_QMARK,
    ACTIONS(7200), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7210), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6925), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6929), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6931), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6941), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6945), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6947), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6667), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [260693] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9092), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    ACTIONS(4349), 5,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    STATE(6668), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4347), 26,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [260778] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(7250), 1,
      anon_sym_LBRACK,
    ACTIONS(7252), 1,
      anon_sym_STAR,
    ACTIONS(7254), 1,
      anon_sym_QMARK,
    ACTIONS(9136), 1,
      anon_sym_DOT,
    ACTIONS(4424), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
    STATE(6669), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4422), 26,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [260865] = 38,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7178), 1,
      anon_sym_QMARK,
    ACTIONS(7200), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7210), 1,
      anon_sym_is,
    ACTIONS(7884), 1,
      anon_sym_SLASH,
    ACTIONS(7886), 1,
      anon_sym_CARET,
    ACTIONS(7888), 1,
      anon_sym_PIPE,
    ACTIONS(7890), 1,
      anon_sym_AMP,
    ACTIONS(7894), 1,
      anon_sym_GT_GT,
    ACTIONS(7902), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7904), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7906), 1,
      anon_sym_QMARK_QMARK,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7876), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7880), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7882), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7892), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7896), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7898), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6670), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [260994] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4295), 1,
      sym_discard,
    ACTIONS(7333), 1,
      sym__identifier_token,
    ACTIONS(8391), 1,
      anon_sym_LPAREN,
    STATE(3127), 1,
      sym__reserved_identifier,
    STATE(4082), 1,
      sym__variable_designation,
    STATE(4269), 1,
      sym_identifier,
    STATE(4274), 1,
      sym_parenthesized_variable_designation,
    ACTIONS(4385), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(4383), 4,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    STATE(6671), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7335), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [261087] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4295), 1,
      sym_discard,
    ACTIONS(7333), 1,
      sym__identifier_token,
    ACTIONS(8391), 1,
      anon_sym_LPAREN,
    STATE(3127), 1,
      sym__reserved_identifier,
    STATE(4246), 1,
      sym__variable_designation,
    STATE(4269), 1,
      sym_identifier,
    STATE(4274), 1,
      sym_parenthesized_variable_designation,
    ACTIONS(4331), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(4329), 4,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    STATE(6672), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7335), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [261180] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(7250), 1,
      anon_sym_LBRACK,
    ACTIONS(7252), 1,
      anon_sym_STAR,
    ACTIONS(7254), 1,
      anon_sym_QMARK,
    ACTIONS(9138), 1,
      anon_sym_DOT,
    ACTIONS(4424), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    STATE(6673), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4422), 26,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [261267] = 38,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4953), 1,
      anon_sym_DASH_GT,
    ACTIONS(5067), 1,
      anon_sym_DOT,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_LPAREN,
    ACTIONS(7026), 1,
      anon_sym_BANG,
    ACTIONS(7166), 1,
      anon_sym_SLASH,
    ACTIONS(7172), 1,
      anon_sym_GT_GT,
    ACTIONS(7178), 1,
      anon_sym_QMARK,
    ACTIONS(7200), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7210), 1,
      anon_sym_is,
    ACTIONS(7218), 1,
      anon_sym_CARET,
    ACTIONS(7220), 1,
      anon_sym_PIPE,
    ACTIONS(7222), 1,
      anon_sym_AMP,
    ACTIONS(7228), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7230), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7232), 1,
      anon_sym_QMARK_QMARK,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(5721), 1,
      sym_argument_list,
    ACTIONS(7028), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7162), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7164), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7170), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7214), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7224), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7226), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6674), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [261396] = 38,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7178), 1,
      anon_sym_QMARK,
    ACTIONS(7200), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7210), 1,
      anon_sym_is,
    ACTIONS(7836), 1,
      anon_sym_SLASH,
    ACTIONS(7838), 1,
      anon_sym_CARET,
    ACTIONS(7840), 1,
      anon_sym_PIPE,
    ACTIONS(7842), 1,
      anon_sym_AMP,
    ACTIONS(7846), 1,
      anon_sym_GT_GT,
    ACTIONS(7852), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7854), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7856), 1,
      anon_sym_QMARK_QMARK,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7828), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7832), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7834), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7844), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7848), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7850), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6675), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [261525] = 38,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4953), 1,
      anon_sym_DASH_GT,
    ACTIONS(5067), 1,
      anon_sym_DOT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7022), 1,
      anon_sym_LBRACK,
    ACTIONS(7178), 1,
      anon_sym_QMARK,
    ACTIONS(7184), 1,
      anon_sym_SLASH,
    ACTIONS(7186), 1,
      anon_sym_CARET,
    ACTIONS(7188), 1,
      anon_sym_PIPE,
    ACTIONS(7190), 1,
      anon_sym_AMP,
    ACTIONS(7194), 1,
      anon_sym_GT_GT,
    ACTIONS(7200), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7202), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7204), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7206), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7210), 1,
      anon_sym_is,
    STATE(3870), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7176), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7180), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7182), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7192), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7196), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7198), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6676), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [261654] = 38,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7178), 1,
      anon_sym_QMARK,
    ACTIONS(7184), 1,
      anon_sym_SLASH,
    ACTIONS(7186), 1,
      anon_sym_CARET,
    ACTIONS(7188), 1,
      anon_sym_PIPE,
    ACTIONS(7190), 1,
      anon_sym_AMP,
    ACTIONS(7194), 1,
      anon_sym_GT_GT,
    ACTIONS(7200), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7202), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7204), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7206), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7210), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7176), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7180), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7182), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7192), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7196), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7198), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6677), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [261783] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5639), 2,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
    STATE(6678), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5637), 33,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_static,
      anon_sym_ref,
      anon_sym_delegate,
      anon_sym_async,
      anon_sym_file,
      anon_sym_readonly,
      anon_sym_in,
      anon_sym_out,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_this,
      anon_sym_scoped,
      anon_sym_params,
      anon_sym_var,
      sym_predefined_type,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [261860] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5612), 2,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
    STATE(6679), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5610), 33,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_static,
      anon_sym_ref,
      anon_sym_delegate,
      anon_sym_async,
      anon_sym_file,
      anon_sym_readonly,
      anon_sym_in,
      anon_sym_out,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_this,
      anon_sym_scoped,
      anon_sym_params,
      anon_sym_var,
      sym_predefined_type,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [261937] = 38,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7178), 1,
      anon_sym_QMARK,
    ACTIONS(7200), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7210), 1,
      anon_sym_is,
    ACTIONS(7303), 1,
      anon_sym_SLASH,
    ACTIONS(7305), 1,
      anon_sym_CARET,
    ACTIONS(7307), 1,
      anon_sym_PIPE,
    ACTIONS(7309), 1,
      anon_sym_AMP,
    ACTIONS(7313), 1,
      anon_sym_GT_GT,
    ACTIONS(7319), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7321), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7323), 1,
      anon_sym_QMARK_QMARK,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7295), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7299), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7301), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7311), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7315), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7317), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6680), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [262066] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2931), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(6681), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2933), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(2935), 22,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [262145] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2923), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(6682), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2925), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(2927), 22,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [262224] = 38,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6766), 1,
      anon_sym_SLASH,
    ACTIONS(6768), 1,
      anon_sym_CARET,
    ACTIONS(6770), 1,
      anon_sym_PIPE,
    ACTIONS(6772), 1,
      anon_sym_AMP,
    ACTIONS(6776), 1,
      anon_sym_GT_GT,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6786), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6788), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6790), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7178), 1,
      anon_sym_QMARK,
    ACTIONS(7200), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7210), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6758), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6762), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6764), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6774), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6778), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6780), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6683), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [262353] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(7250), 1,
      anon_sym_LBRACK,
    ACTIONS(7252), 1,
      anon_sym_STAR,
    ACTIONS(7254), 1,
      anon_sym_QMARK,
    ACTIONS(9140), 1,
      anon_sym_DOT,
    ACTIONS(4424), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    STATE(6684), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4422), 26,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [262440] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(7250), 1,
      anon_sym_LBRACK,
    ACTIONS(7252), 1,
      anon_sym_STAR,
    ACTIONS(7254), 1,
      anon_sym_QMARK,
    ACTIONS(9142), 1,
      anon_sym_DOT,
    ACTIONS(4424), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
    STATE(6685), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4422), 26,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [262527] = 38,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7178), 1,
      anon_sym_QMARK,
    ACTIONS(7200), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7210), 1,
      anon_sym_is,
    ACTIONS(7738), 1,
      anon_sym_SLASH,
    ACTIONS(7740), 1,
      anon_sym_CARET,
    ACTIONS(7742), 1,
      anon_sym_PIPE,
    ACTIONS(7744), 1,
      anon_sym_AMP,
    ACTIONS(7748), 1,
      anon_sym_GT_GT,
    ACTIONS(7756), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7758), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7760), 1,
      anon_sym_QMARK_QMARK,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7730), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7734), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7736), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7746), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7750), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7752), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6686), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [262656] = 38,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5743), 1,
      anon_sym_LBRACK,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7178), 1,
      anon_sym_QMARK,
    ACTIONS(7184), 1,
      anon_sym_SLASH,
    ACTIONS(7186), 1,
      anon_sym_CARET,
    ACTIONS(7188), 1,
      anon_sym_PIPE,
    ACTIONS(7190), 1,
      anon_sym_AMP,
    ACTIONS(7194), 1,
      anon_sym_GT_GT,
    ACTIONS(7200), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7202), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7204), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7206), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7210), 1,
      anon_sym_is,
    STATE(3481), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7176), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7180), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7182), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7192), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7196), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7198), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6687), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [262785] = 38,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7178), 1,
      anon_sym_QMARK,
    ACTIONS(7200), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7210), 1,
      anon_sym_is,
    ACTIONS(7559), 1,
      anon_sym_SLASH,
    ACTIONS(7563), 1,
      anon_sym_GT_GT,
    ACTIONS(7569), 1,
      anon_sym_AMP,
    ACTIONS(7579), 1,
      anon_sym_CARET,
    ACTIONS(7655), 1,
      anon_sym_PIPE,
    ACTIONS(7657), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7659), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7661), 1,
      anon_sym_QMARK_QMARK,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7555), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7557), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7561), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7567), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7571), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7573), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6688), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [262914] = 38,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(6990), 1,
      anon_sym_SLASH,
    ACTIONS(6992), 1,
      anon_sym_AMP,
    ACTIONS(6996), 1,
      anon_sym_GT_GT,
    ACTIONS(7012), 1,
      anon_sym_CARET,
    ACTIONS(7014), 1,
      anon_sym_PIPE,
    ACTIONS(7016), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7018), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7020), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7178), 1,
      anon_sym_QMARK,
    ACTIONS(7200), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7210), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6984), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6986), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6988), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6994), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6998), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7000), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6689), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [263043] = 38,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7178), 1,
      anon_sym_QMARK,
    ACTIONS(7200), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7210), 1,
      anon_sym_is,
    ACTIONS(8030), 1,
      anon_sym_SLASH,
    ACTIONS(8032), 1,
      anon_sym_CARET,
    ACTIONS(8034), 1,
      anon_sym_PIPE,
    ACTIONS(8036), 1,
      anon_sym_AMP,
    ACTIONS(8040), 1,
      anon_sym_GT_GT,
    ACTIONS(8046), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8048), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8050), 1,
      anon_sym_QMARK_QMARK,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8022), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8026), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8028), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8038), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8042), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8044), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6690), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [263172] = 38,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5235), 1,
      anon_sym_LBRACK,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7178), 1,
      anon_sym_QMARK,
    ACTIONS(7184), 1,
      anon_sym_SLASH,
    ACTIONS(7186), 1,
      anon_sym_CARET,
    ACTIONS(7188), 1,
      anon_sym_PIPE,
    ACTIONS(7190), 1,
      anon_sym_AMP,
    ACTIONS(7194), 1,
      anon_sym_GT_GT,
    ACTIONS(7200), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7202), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7204), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7206), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7210), 1,
      anon_sym_is,
    STATE(3009), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7176), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7180), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7182), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7192), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7196), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7198), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6691), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [263301] = 38,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5165), 1,
      anon_sym_DOT,
    ACTIONS(5167), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6038), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7178), 1,
      anon_sym_QMARK,
    ACTIONS(7184), 1,
      anon_sym_SLASH,
    ACTIONS(7186), 1,
      anon_sym_CARET,
    ACTIONS(7188), 1,
      anon_sym_PIPE,
    ACTIONS(7190), 1,
      anon_sym_AMP,
    ACTIONS(7194), 1,
      anon_sym_GT_GT,
    ACTIONS(7200), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7202), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7204), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7206), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7210), 1,
      anon_sym_is,
    STATE(3551), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7176), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7180), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7182), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7192), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7196), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7198), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6692), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [263430] = 38,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7178), 1,
      anon_sym_QMARK,
    ACTIONS(7200), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7210), 1,
      anon_sym_is,
    ACTIONS(7793), 1,
      anon_sym_SLASH,
    ACTIONS(7797), 1,
      anon_sym_GT_GT,
    ACTIONS(7809), 1,
      anon_sym_CARET,
    ACTIONS(7811), 1,
      anon_sym_AMP,
    ACTIONS(7866), 1,
      anon_sym_PIPE,
    ACTIONS(7868), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7870), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7872), 1,
      anon_sym_QMARK_QMARK,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7787), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7789), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7791), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7795), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7799), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7801), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6693), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [263559] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(6694), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3719), 9,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3721), 26,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [263636] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4295), 1,
      sym_discard,
    ACTIONS(7333), 1,
      sym__identifier_token,
    ACTIONS(8391), 1,
      anon_sym_LPAREN,
    STATE(3127), 1,
      sym__reserved_identifier,
    STATE(4123), 1,
      sym__variable_designation,
    STATE(4269), 1,
      sym_identifier,
    STATE(4274), 1,
      sym_parenthesized_variable_designation,
    ACTIONS(4337), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(4335), 4,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    STATE(6695), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7335), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [263729] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(6696), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4058), 9,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4056), 26,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [263806] = 38,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7178), 1,
      anon_sym_QMARK,
    ACTIONS(7200), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7210), 1,
      anon_sym_is,
    ACTIONS(7593), 1,
      anon_sym_SLASH,
    ACTIONS(7595), 1,
      anon_sym_CARET,
    ACTIONS(7597), 1,
      anon_sym_PIPE,
    ACTIONS(7599), 1,
      anon_sym_AMP,
    ACTIONS(7603), 1,
      anon_sym_GT_GT,
    ACTIONS(7611), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7613), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7615), 1,
      anon_sym_QMARK_QMARK,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7585), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7589), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7591), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7601), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7605), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7607), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6697), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [263935] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(8268), 1,
      sym_identifier,
    STATE(9092), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    ACTIONS(4349), 5,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    STATE(6698), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4347), 26,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [264020] = 38,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7178), 1,
      anon_sym_QMARK,
    ACTIONS(7184), 1,
      anon_sym_SLASH,
    ACTIONS(7186), 1,
      anon_sym_CARET,
    ACTIONS(7188), 1,
      anon_sym_PIPE,
    ACTIONS(7190), 1,
      anon_sym_AMP,
    ACTIONS(7194), 1,
      anon_sym_GT_GT,
    ACTIONS(7200), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7202), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7204), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7206), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7210), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7176), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7180), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7182), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7192), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7196), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7198), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6699), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [264149] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4081), 1,
      anon_sym_EQ_GT,
    ACTIONS(4083), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6745), 1,
      anon_sym_LT,
    ACTIONS(9144), 1,
      anon_sym_EQ,
    STATE(4976), 1,
      sym_type_argument_list,
    ACTIONS(9146), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(4076), 5,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
    STATE(6700), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4074), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [264238] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5635), 2,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
    STATE(6701), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5633), 33,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_static,
      anon_sym_ref,
      anon_sym_delegate,
      anon_sym_async,
      anon_sym_file,
      anon_sym_readonly,
      anon_sym_in,
      anon_sym_out,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_this,
      anon_sym_scoped,
      anon_sym_params,
      anon_sym_var,
      sym_predefined_type,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [264315] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5616), 2,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
    STATE(6702), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5614), 33,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_static,
      anon_sym_ref,
      anon_sym_delegate,
      anon_sym_async,
      anon_sym_file,
      anon_sym_readonly,
      anon_sym_in,
      anon_sym_out,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_this,
      anon_sym_scoped,
      anon_sym_params,
      anon_sym_var,
      sym_predefined_type,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [264392] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5624), 2,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
    STATE(6703), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5622), 33,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_static,
      anon_sym_ref,
      anon_sym_delegate,
      anon_sym_async,
      anon_sym_file,
      anon_sym_readonly,
      anon_sym_in,
      anon_sym_out,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_this,
      anon_sym_scoped,
      anon_sym_params,
      anon_sym_var,
      sym_predefined_type,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [264469] = 38,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(6852), 1,
      anon_sym_SLASH,
    ACTIONS(6860), 1,
      anon_sym_AMP,
    ACTIONS(6864), 1,
      anon_sym_GT_GT,
    ACTIONS(6872), 1,
      anon_sym_CARET,
    ACTIONS(6908), 1,
      anon_sym_PIPE,
    ACTIONS(6910), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6912), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6914), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7178), 1,
      anon_sym_QMARK,
    ACTIONS(7200), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7210), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6850), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6856), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6858), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6866), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6868), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6704), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [264598] = 38,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5669), 1,
      anon_sym_LPAREN,
    ACTIONS(5690), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7178), 1,
      anon_sym_QMARK,
    ACTIONS(7200), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7210), 1,
      anon_sym_is,
    ACTIONS(7406), 1,
      anon_sym_SLASH,
    ACTIONS(7408), 1,
      anon_sym_CARET,
    ACTIONS(7410), 1,
      anon_sym_PIPE,
    ACTIONS(7412), 1,
      anon_sym_AMP,
    ACTIONS(7416), 1,
      anon_sym_GT_GT,
    ACTIONS(7424), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7426), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7428), 1,
      anon_sym_QMARK_QMARK,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(3942), 1,
      sym_argument_list,
    ACTIONS(5692), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7398), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7402), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7404), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7414), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7418), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7420), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6705), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [264727] = 38,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7178), 1,
      anon_sym_QMARK,
    ACTIONS(7200), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7210), 1,
      anon_sym_is,
    ACTIONS(8078), 1,
      anon_sym_SLASH,
    ACTIONS(8080), 1,
      anon_sym_CARET,
    ACTIONS(8082), 1,
      anon_sym_PIPE,
    ACTIONS(8084), 1,
      anon_sym_AMP,
    ACTIONS(8088), 1,
      anon_sym_GT_GT,
    ACTIONS(8094), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8096), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8098), 1,
      anon_sym_QMARK_QMARK,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8070), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8074), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8076), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8086), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8090), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8092), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6706), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [264856] = 38,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5165), 1,
      anon_sym_DOT,
    ACTIONS(5167), 1,
      anon_sym_DASH_GT,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6008), 1,
      anon_sym_LPAREN,
    ACTIONS(6044), 1,
      anon_sym_BANG,
    ACTIONS(6344), 1,
      anon_sym_SLASH,
    ACTIONS(6346), 1,
      anon_sym_CARET,
    ACTIONS(6348), 1,
      anon_sym_PIPE,
    ACTIONS(6350), 1,
      anon_sym_AMP,
    ACTIONS(6354), 1,
      anon_sym_GT_GT,
    ACTIONS(6362), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6364), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6366), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7178), 1,
      anon_sym_QMARK,
    ACTIONS(7200), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7210), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4571), 1,
      sym_argument_list,
    ACTIONS(6046), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6336), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6340), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6342), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6352), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6356), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6358), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6707), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [264985] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4295), 1,
      sym_discard,
    ACTIONS(7333), 1,
      sym__identifier_token,
    ACTIONS(8391), 1,
      anon_sym_LPAREN,
    STATE(3127), 1,
      sym__reserved_identifier,
    STATE(4113), 1,
      sym__variable_designation,
    STATE(4269), 1,
      sym_identifier,
    STATE(4274), 1,
      sym_parenthesized_variable_designation,
    ACTIONS(4375), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(4373), 4,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    STATE(6708), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7335), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [265078] = 38,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_DOT,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(5688), 1,
      anon_sym_LBRACK,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7178), 1,
      anon_sym_QMARK,
    ACTIONS(7184), 1,
      anon_sym_SLASH,
    ACTIONS(7186), 1,
      anon_sym_CARET,
    ACTIONS(7188), 1,
      anon_sym_PIPE,
    ACTIONS(7190), 1,
      anon_sym_AMP,
    ACTIONS(7194), 1,
      anon_sym_GT_GT,
    ACTIONS(7200), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7202), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7204), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7206), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7210), 1,
      anon_sym_is,
    STATE(3206), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7176), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7180), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7182), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7192), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7196), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7198), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6709), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [265207] = 38,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(5745), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7086), 1,
      anon_sym_SLASH,
    ACTIONS(7088), 1,
      anon_sym_CARET,
    ACTIONS(7090), 1,
      anon_sym_PIPE,
    ACTIONS(7092), 1,
      anon_sym_AMP,
    ACTIONS(7096), 1,
      anon_sym_GT_GT,
    ACTIONS(7102), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7104), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7106), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7178), 1,
      anon_sym_QMARK,
    ACTIONS(7200), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7210), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym_argument_list,
    ACTIONS(5747), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7078), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7082), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7084), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7094), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7098), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7100), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6710), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [265336] = 38,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(5187), 1,
      anon_sym_LPAREN,
    ACTIONS(5193), 1,
      anon_sym_DOT,
    ACTIONS(5239), 1,
      anon_sym_BANG,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(6637), 1,
      anon_sym_SLASH,
    ACTIONS(6639), 1,
      anon_sym_CARET,
    ACTIONS(6641), 1,
      anon_sym_PIPE,
    ACTIONS(6643), 1,
      anon_sym_AMP,
    ACTIONS(6647), 1,
      anon_sym_GT_GT,
    ACTIONS(6657), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6659), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6661), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6782), 1,
      anon_sym_switch,
    ACTIONS(6796), 1,
      anon_sym_with,
    ACTIONS(7178), 1,
      anon_sym_QMARK,
    ACTIONS(7200), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7208), 1,
      anon_sym_as,
    ACTIONS(7210), 1,
      anon_sym_is,
    STATE(3015), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym_argument_list,
    ACTIONS(5241), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6629), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6633), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6635), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6645), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6649), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6651), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6711), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [265465] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(8628), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(2738), 1,
      sym_generic_name,
    STATE(7332), 1,
      sym_explicit_interface_specifier,
    STATE(7493), 1,
      sym_identifier,
    STATE(8056), 1,
      sym_tuple_pattern,
    STATE(8608), 1,
      sym_variable_declarator,
    STATE(9003), 1,
      sym__name,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6712), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [265559] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4083), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6745), 1,
      anon_sym_LT,
    ACTIONS(9148), 1,
      anon_sym_LPAREN,
    STATE(4976), 1,
      sym_type_argument_list,
    STATE(7653), 1,
      sym_parameter_list,
    ACTIONS(4076), 4,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
    STATE(6713), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4074), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_operator,
      anon_sym_this,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [265645] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4083), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6745), 1,
      anon_sym_LT,
    ACTIONS(9151), 1,
      anon_sym_EQ,
    STATE(4976), 1,
      sym_type_argument_list,
    ACTIONS(9146), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
    ACTIONS(4076), 4,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
    STATE(6714), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4074), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [265731] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(8628), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(2738), 1,
      sym_generic_name,
    STATE(7302), 1,
      sym_explicit_interface_specifier,
    STATE(7494), 1,
      sym_identifier,
    STATE(8056), 1,
      sym_tuple_pattern,
    STATE(8608), 1,
      sym_variable_declarator,
    STATE(9003), 1,
      sym__name,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6715), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [265825] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(5653), 1,
      anon_sym_LBRACK,
    ACTIONS(9153), 1,
      aux_sym_preproc_if_token3,
    ACTIONS(9155), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(9157), 1,
      aux_sym_preproc_elif_token1,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(6974), 1,
      aux_sym_class_declaration_repeat1,
    STATE(7261), 1,
      sym_attribute_list,
    STATE(8061), 1,
      sym_enum_member_declaration,
    STATE(8334), 1,
      sym_identifier,
    STATE(9866), 2,
      sym_preproc_else_in_enum_member_declaration,
      sym_preproc_elif_in_enum_member_declaration,
    STATE(6716), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [265921] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(8268), 1,
      sym_identifier,
    STATE(9033), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    ACTIONS(4349), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    STATE(6717), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4347), 26,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [266005] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9159), 1,
      anon_sym_SEMI,
    STATE(6718), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5480), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5478), 22,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [266083] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4083), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6745), 1,
      anon_sym_LT,
    ACTIONS(9148), 1,
      anon_sym_LPAREN,
    STATE(4976), 1,
      sym_type_argument_list,
    STATE(7661), 1,
      sym_parameter_list,
    ACTIONS(4076), 4,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
    STATE(6719), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4074), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_operator,
      anon_sym_this,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [266169] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4083), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6745), 1,
      anon_sym_LT,
    ACTIONS(9148), 1,
      anon_sym_LPAREN,
    STATE(4976), 1,
      sym_type_argument_list,
    STATE(7655), 1,
      sym_parameter_list,
    ACTIONS(4076), 4,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
    STATE(6720), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4074), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_operator,
      anon_sym_this,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [266255] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(8628), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(2738), 1,
      sym_generic_name,
    STATE(7294), 1,
      sym_explicit_interface_specifier,
    STATE(7512), 1,
      sym_identifier,
    STATE(8056), 1,
      sym_tuple_pattern,
    STATE(8608), 1,
      sym_variable_declarator,
    STATE(9003), 1,
      sym__name,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6721), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [266349] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(7250), 1,
      anon_sym_LBRACK,
    ACTIONS(7252), 1,
      anon_sym_STAR,
    ACTIONS(7254), 1,
      anon_sym_QMARK,
    ACTIONS(9161), 1,
      anon_sym_DOT,
    ACTIONS(4424), 3,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    STATE(6722), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4422), 26,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [266435] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(7250), 1,
      anon_sym_LBRACK,
    ACTIONS(7252), 1,
      anon_sym_STAR,
    ACTIONS(7254), 1,
      anon_sym_QMARK,
    ACTIONS(9163), 1,
      anon_sym_DOT,
    ACTIONS(4424), 3,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    STATE(6723), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4422), 26,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [266521] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9165), 1,
      anon_sym_SEMI,
    STATE(6724), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5480), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5478), 22,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [266599] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(5653), 1,
      anon_sym_LBRACK,
    ACTIONS(9155), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(9157), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(9167), 1,
      aux_sym_preproc_if_token3,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(6974), 1,
      aux_sym_class_declaration_repeat1,
    STATE(7261), 1,
      sym_attribute_list,
    STATE(8141), 1,
      sym_enum_member_declaration,
    STATE(8334), 1,
      sym_identifier,
    STATE(9381), 2,
      sym_preproc_else_in_enum_member_declaration,
      sym_preproc_elif_in_enum_member_declaration,
    STATE(6725), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [266695] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(7250), 1,
      anon_sym_LBRACK,
    ACTIONS(7252), 1,
      anon_sym_STAR,
    ACTIONS(7254), 1,
      anon_sym_QMARK,
    ACTIONS(9169), 1,
      anon_sym_DOT,
    ACTIONS(4424), 3,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    STATE(6726), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4422), 26,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [266781] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(7250), 1,
      anon_sym_LBRACK,
    ACTIONS(7252), 1,
      anon_sym_STAR,
    ACTIONS(7254), 1,
      anon_sym_QMARK,
    ACTIONS(9171), 1,
      anon_sym_DOT,
    ACTIONS(4424), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
    STATE(6727), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4422), 26,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [266867] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4083), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6745), 1,
      anon_sym_LT,
    ACTIONS(9173), 1,
      anon_sym_EQ,
    ACTIONS(9175), 1,
      anon_sym_COMMA,
    ACTIONS(9178), 1,
      anon_sym_RPAREN,
    STATE(4976), 1,
      sym_type_argument_list,
    STATE(8504), 1,
      aux_sym_tuple_pattern_repeat1,
    ACTIONS(4076), 4,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
    STATE(6728), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4074), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [266957] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4083), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6745), 1,
      anon_sym_LT,
    ACTIONS(9173), 1,
      anon_sym_EQ,
    STATE(4976), 1,
      sym_type_argument_list,
    ACTIONS(9181), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
    ACTIONS(4076), 4,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
    STATE(6729), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4074), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [267043] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9183), 1,
      anon_sym_using,
    ACTIONS(3719), 7,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
    STATE(6730), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3721), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_operator,
      anon_sym_this,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [267120] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4295), 1,
      sym_discard,
    ACTIONS(7333), 1,
      sym__identifier_token,
    ACTIONS(8391), 1,
      anon_sym_LPAREN,
    STATE(3127), 1,
      sym__reserved_identifier,
    STATE(4123), 1,
      sym__variable_designation,
    STATE(4269), 1,
      sym_identifier,
    STATE(4274), 1,
      sym_parenthesized_variable_designation,
    ACTIONS(4335), 2,
      anon_sym_COLON,
      anon_sym_EQ_GT,
    ACTIONS(4337), 3,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
    STATE(6731), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7335), 21,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [267211] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4083), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6745), 1,
      anon_sym_LT,
    ACTIONS(9185), 1,
      anon_sym_EQ,
    STATE(4976), 1,
      sym_type_argument_list,
    ACTIONS(4076), 6,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
    STATE(6732), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4074), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [267294] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7248), 1,
      anon_sym_LT,
    ACTIONS(9187), 1,
      anon_sym_COLON_COLON,
    STATE(2736), 1,
      sym_type_argument_list,
    ACTIONS(4076), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_DOT,
    STATE(6733), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4074), 27,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_COLON,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [267375] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7250), 1,
      anon_sym_LBRACK,
    ACTIONS(7252), 1,
      anon_sym_STAR,
    ACTIONS(7254), 1,
      anon_sym_QMARK,
    ACTIONS(9189), 1,
      anon_sym_DOT,
    ACTIONS(4424), 3,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    STATE(6734), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4422), 26,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [267458] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4295), 1,
      sym_discard,
    ACTIONS(7333), 1,
      sym__identifier_token,
    ACTIONS(8391), 1,
      anon_sym_LPAREN,
    STATE(3127), 1,
      sym__reserved_identifier,
    STATE(4113), 1,
      sym__variable_designation,
    STATE(4269), 1,
      sym_identifier,
    STATE(4274), 1,
      sym_parenthesized_variable_designation,
    ACTIONS(4373), 2,
      anon_sym_COLON,
      anon_sym_EQ_GT,
    ACTIONS(4375), 3,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
    STATE(6735), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7335), 21,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [267549] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4083), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4222), 1,
      anon_sym_COMMA,
    ACTIONS(6745), 1,
      anon_sym_LT,
    ACTIONS(9173), 1,
      anon_sym_EQ,
    ACTIONS(9181), 1,
      anon_sym_RPAREN,
    STATE(4976), 1,
      sym_type_argument_list,
    ACTIONS(4076), 4,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
    STATE(6736), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4074), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [267636] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4083), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6745), 1,
      anon_sym_LT,
    ACTIONS(9191), 1,
      anon_sym_EQ,
    STATE(4976), 1,
      sym_type_argument_list,
    ACTIONS(4076), 6,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
    STATE(6737), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4074), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [267719] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(5653), 1,
      anon_sym_LBRACK,
    ACTIONS(9193), 1,
      anon_sym_COMMA,
    ACTIONS(9195), 1,
      anon_sym_RBRACE,
    ACTIONS(9197), 1,
      aux_sym_preproc_if_token1,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(7026), 1,
      aux_sym_class_declaration_repeat1,
    STATE(7261), 1,
      sym_attribute_list,
    STATE(8567), 1,
      sym_identifier,
    STATE(8571), 2,
      sym_enum_member_declaration,
      sym_preproc_if_in_enum_member_declaration,
    STATE(6738), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [267812] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4295), 1,
      sym_discard,
    ACTIONS(7333), 1,
      sym__identifier_token,
    ACTIONS(8391), 1,
      anon_sym_LPAREN,
    STATE(3127), 1,
      sym__reserved_identifier,
    STATE(4082), 1,
      sym__variable_designation,
    STATE(4269), 1,
      sym_identifier,
    STATE(4274), 1,
      sym_parenthesized_variable_designation,
    ACTIONS(4383), 2,
      anon_sym_COLON,
      anon_sym_EQ_GT,
    ACTIONS(4385), 3,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
    STATE(6739), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7335), 21,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [267903] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4083), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6745), 1,
      anon_sym_LT,
    ACTIONS(9199), 1,
      anon_sym_COMMA,
    ACTIONS(9202), 1,
      anon_sym_RPAREN,
    STATE(4976), 1,
      sym_type_argument_list,
    STATE(8504), 1,
      aux_sym_tuple_pattern_repeat1,
    ACTIONS(4076), 4,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
    STATE(6740), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4074), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [267990] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4295), 1,
      sym_discard,
    ACTIONS(7333), 1,
      sym__identifier_token,
    ACTIONS(8391), 1,
      anon_sym_LPAREN,
    STATE(3127), 1,
      sym__reserved_identifier,
    STATE(4246), 1,
      sym__variable_designation,
    STATE(4269), 1,
      sym_identifier,
    STATE(4274), 1,
      sym_parenthesized_variable_designation,
    ACTIONS(4329), 2,
      anon_sym_COLON,
      anon_sym_EQ_GT,
    ACTIONS(4331), 3,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
    STATE(6741), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7335), 21,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [268081] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(7250), 1,
      anon_sym_LBRACK,
    ACTIONS(7252), 1,
      anon_sym_STAR,
    ACTIONS(7254), 1,
      anon_sym_QMARK,
    ACTIONS(8467), 1,
      anon_sym_DOT,
    ACTIONS(8999), 1,
      anon_sym_LPAREN,
    STATE(8721), 1,
      sym_attribute_argument_list,
    ACTIONS(9204), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    STATE(6742), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4422), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [268169] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9206), 1,
      anon_sym_operator,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(2738), 1,
      sym_generic_name,
    STATE(5368), 1,
      sym_identifier,
    STATE(9505), 1,
      sym_explicit_interface_specifier,
    STATE(9506), 1,
      sym__name,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6743), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [268257] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9208), 1,
      anon_sym_RBRACK,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(2738), 1,
      sym_generic_name,
    STATE(5368), 1,
      sym_identifier,
    STATE(8106), 1,
      sym__name,
    STATE(8918), 1,
      sym_attribute,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6744), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [268345] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9210), 1,
      anon_sym_unsafe,
    ACTIONS(9212), 1,
      anon_sym_static,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(2738), 1,
      sym_generic_name,
    STATE(7802), 1,
      sym_identifier,
    STATE(8905), 1,
      sym__name,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6745), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [268433] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9214), 1,
      anon_sym_RBRACK,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(2738), 1,
      sym_generic_name,
    STATE(5368), 1,
      sym_identifier,
    STATE(8106), 1,
      sym__name,
    STATE(8918), 1,
      sym_attribute,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6746), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [268521] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(5653), 1,
      anon_sym_LBRACK,
    ACTIONS(9197), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(9216), 1,
      anon_sym_RBRACE,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(7026), 1,
      aux_sym_class_declaration_repeat1,
    STATE(7261), 1,
      sym_attribute_list,
    STATE(8567), 1,
      sym_identifier,
    STATE(8758), 2,
      sym_enum_member_declaration,
      sym_preproc_if_in_enum_member_declaration,
    STATE(6747), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [268611] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9218), 1,
      anon_sym_RBRACK,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(2738), 1,
      sym_generic_name,
    STATE(5368), 1,
      sym_identifier,
    STATE(8106), 1,
      sym__name,
    STATE(8918), 1,
      sym_attribute,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6748), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [268699] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9220), 1,
      anon_sym_RBRACK,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(2738), 1,
      sym_generic_name,
    STATE(5368), 1,
      sym_identifier,
    STATE(8106), 1,
      sym__name,
    STATE(8918), 1,
      sym_attribute,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6749), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [268787] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9222), 1,
      anon_sym_RBRACK,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(2738), 1,
      sym_generic_name,
    STATE(5368), 1,
      sym_identifier,
    STATE(8106), 1,
      sym__name,
    STATE(8918), 1,
      sym_attribute,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6750), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [268875] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9224), 1,
      anon_sym_RBRACK,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(2738), 1,
      sym_generic_name,
    STATE(5368), 1,
      sym_identifier,
    STATE(8106), 1,
      sym__name,
    STATE(8918), 1,
      sym_attribute,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6751), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [268963] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9226), 1,
      anon_sym_RBRACK,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(2738), 1,
      sym_generic_name,
    STATE(5368), 1,
      sym_identifier,
    STATE(8106), 1,
      sym__name,
    STATE(8918), 1,
      sym_attribute,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6752), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [269051] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9228), 1,
      anon_sym_RBRACK,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(2738), 1,
      sym_generic_name,
    STATE(5368), 1,
      sym_identifier,
    STATE(8106), 1,
      sym__name,
    STATE(8918), 1,
      sym_attribute,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6753), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [269139] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4081), 1,
      anon_sym_EQ_GT,
    ACTIONS(4083), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6745), 1,
      anon_sym_LT,
    STATE(4976), 1,
      sym_type_argument_list,
    ACTIONS(4076), 5,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
    STATE(6754), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4074), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [269221] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9232), 1,
      anon_sym_LPAREN,
    ACTIONS(9234), 6,
      anon_sym_ref,
      anon_sym_readonly,
      anon_sym_in,
      anon_sym_out,
      anon_sym_this,
      anon_sym_scoped,
    STATE(6755), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym__parameter_type_with_modifiers_repeat1,
    ACTIONS(9230), 24,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_delegate,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_var,
      sym_predefined_type,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [269297] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9237), 1,
      anon_sym_RBRACK,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(2738), 1,
      sym_generic_name,
    STATE(5368), 1,
      sym_identifier,
    STATE(8106), 1,
      sym__name,
    STATE(8918), 1,
      sym_attribute,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6756), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [269385] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9239), 1,
      anon_sym_unsafe,
    ACTIONS(9241), 1,
      anon_sym_static,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(2738), 1,
      sym_generic_name,
    STATE(7752), 1,
      sym_identifier,
    STATE(8845), 1,
      sym__name,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6757), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [269473] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9243), 1,
      anon_sym_RBRACK,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(2738), 1,
      sym_generic_name,
    STATE(5368), 1,
      sym_identifier,
    STATE(8106), 1,
      sym__name,
    STATE(8918), 1,
      sym_attribute,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6758), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [269561] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9245), 1,
      anon_sym_RBRACK,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(2738), 1,
      sym_generic_name,
    STATE(5368), 1,
      sym_identifier,
    STATE(8106), 1,
      sym__name,
    STATE(8918), 1,
      sym_attribute,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6759), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [269649] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9247), 1,
      anon_sym_operator,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(2738), 1,
      sym_generic_name,
    STATE(5368), 1,
      sym_identifier,
    STATE(9506), 1,
      sym__name,
    STATE(9686), 1,
      sym_explicit_interface_specifier,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6760), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [269737] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9249), 1,
      anon_sym_RBRACK,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(2738), 1,
      sym_generic_name,
    STATE(5368), 1,
      sym_identifier,
    STATE(8106), 1,
      sym__name,
    STATE(8918), 1,
      sym_attribute,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6761), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [269825] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(5653), 1,
      anon_sym_LBRACK,
    ACTIONS(9197), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(9251), 1,
      anon_sym_RBRACE,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(7026), 1,
      aux_sym_class_declaration_repeat1,
    STATE(7261), 1,
      sym_attribute_list,
    STATE(8567), 1,
      sym_identifier,
    STATE(8758), 2,
      sym_enum_member_declaration,
      sym_preproc_if_in_enum_member_declaration,
    STATE(6762), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [269915] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9253), 1,
      anon_sym_unsafe,
    ACTIONS(9255), 1,
      anon_sym_static,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(2738), 1,
      sym_generic_name,
    STATE(7779), 1,
      sym_identifier,
    STATE(8674), 1,
      sym__name,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6763), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [270003] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9257), 1,
      anon_sym_RBRACK,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(2738), 1,
      sym_generic_name,
    STATE(5368), 1,
      sym_identifier,
    STATE(8106), 1,
      sym__name,
    STATE(8918), 1,
      sym_attribute,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6764), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [270091] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9259), 1,
      anon_sym_RBRACK,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(2738), 1,
      sym_generic_name,
    STATE(5368), 1,
      sym_identifier,
    STATE(8106), 1,
      sym__name,
    STATE(8918), 1,
      sym_attribute,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6765), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [270179] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9261), 1,
      anon_sym_RBRACK,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(2738), 1,
      sym_generic_name,
    STATE(5368), 1,
      sym_identifier,
    STATE(8106), 1,
      sym__name,
    STATE(8918), 1,
      sym_attribute,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6766), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [270267] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9263), 1,
      anon_sym_RBRACK,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(2738), 1,
      sym_generic_name,
    STATE(5368), 1,
      sym_identifier,
    STATE(8106), 1,
      sym__name,
    STATE(8918), 1,
      sym_attribute,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6767), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [270355] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9265), 1,
      anon_sym_RBRACK,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(2738), 1,
      sym_generic_name,
    STATE(5368), 1,
      sym_identifier,
    STATE(8106), 1,
      sym__name,
    STATE(8918), 1,
      sym_attribute,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6768), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [270443] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9267), 1,
      anon_sym_RBRACK,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(2738), 1,
      sym_generic_name,
    STATE(5368), 1,
      sym_identifier,
    STATE(8106), 1,
      sym__name,
    STATE(8918), 1,
      sym_attribute,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6769), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [270531] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9269), 1,
      anon_sym_operator,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(2738), 1,
      sym_generic_name,
    STATE(5368), 1,
      sym_identifier,
    STATE(9506), 1,
      sym__name,
    STATE(9740), 1,
      sym_explicit_interface_specifier,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6770), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [270619] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9271), 1,
      anon_sym_unsafe,
    ACTIONS(9273), 1,
      anon_sym_static,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(2738), 1,
      sym_generic_name,
    STATE(7742), 1,
      sym_identifier,
    STATE(8856), 1,
      sym__name,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6771), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [270707] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9275), 1,
      anon_sym_RBRACK,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(2738), 1,
      sym_generic_name,
    STATE(5368), 1,
      sym_identifier,
    STATE(8106), 1,
      sym__name,
    STATE(8918), 1,
      sym_attribute,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6772), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [270795] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2621), 1,
      anon_sym_LPAREN,
    STATE(6773), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2603), 30,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_ref,
      anon_sym_delegate,
      anon_sym_file,
      anon_sym_readonly,
      anon_sym_in,
      anon_sym_out,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_this,
      anon_sym_scoped,
      anon_sym_var,
      sym_predefined_type,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [270868] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9277), 1,
      anon_sym_unsafe,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(2738), 1,
      sym_generic_name,
    STATE(5368), 1,
      sym_identifier,
    STATE(8924), 1,
      sym__name,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6774), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [270953] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(2738), 1,
      sym_generic_name,
    STATE(5368), 1,
      sym_identifier,
    STATE(8106), 1,
      sym__name,
    STATE(8428), 1,
      sym_attribute,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6775), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [271038] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2983), 1,
      sym__identifier_token,
    ACTIONS(5653), 1,
      anon_sym_LBRACK,
    STATE(4443), 1,
      sym__reserved_identifier,
    STATE(6855), 1,
      aux_sym_class_declaration_repeat1,
    STATE(7261), 1,
      sym_attribute_list,
    STATE(8776), 1,
      sym_type_parameter,
    STATE(8908), 1,
      sym_identifier,
    ACTIONS(5663), 2,
      anon_sym_in,
      anon_sym_out,
    STATE(6776), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2987), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [271125] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(2738), 1,
      sym_generic_name,
    STATE(5368), 1,
      sym_identifier,
    STATE(8106), 1,
      sym__name,
    STATE(8578), 1,
      sym_attribute,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6777), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [271210] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9279), 1,
      anon_sym_unsafe,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(2738), 1,
      sym_generic_name,
    STATE(5368), 1,
      sym_identifier,
    STATE(8930), 1,
      sym__name,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6778), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [271295] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9281), 1,
      anon_sym_unsafe,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(2738), 1,
      sym_generic_name,
    STATE(5368), 1,
      sym_identifier,
    STATE(8925), 1,
      sym__name,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6779), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [271380] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2983), 1,
      sym__identifier_token,
    ACTIONS(5653), 1,
      anon_sym_LBRACK,
    STATE(4443), 1,
      sym__reserved_identifier,
    STATE(6855), 1,
      aux_sym_class_declaration_repeat1,
    STATE(7261), 1,
      sym_attribute_list,
    STATE(8588), 1,
      sym_type_parameter,
    STATE(8908), 1,
      sym_identifier,
    ACTIONS(5663), 2,
      anon_sym_in,
      anon_sym_out,
    STATE(6780), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2987), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [271467] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(5653), 1,
      anon_sym_LBRACK,
    ACTIONS(9197), 1,
      aux_sym_preproc_if_token1,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(7026), 1,
      aux_sym_class_declaration_repeat1,
    STATE(7261), 1,
      sym_attribute_list,
    STATE(8567), 1,
      sym_identifier,
    STATE(8758), 2,
      sym_enum_member_declaration,
      sym_preproc_if_in_enum_member_declaration,
    STATE(6781), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [271554] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(2738), 1,
      sym_generic_name,
    STATE(5368), 1,
      sym_identifier,
    STATE(8106), 1,
      sym__name,
    STATE(8535), 1,
      sym_attribute,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6782), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [271639] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4500), 1,
      anon_sym_EQ_GT,
    ACTIONS(5870), 1,
      anon_sym_RPAREN,
    ACTIONS(4498), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    STATE(6783), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4496), 26,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [271716] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4083), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6745), 1,
      anon_sym_LT,
    ACTIONS(9283), 1,
      anon_sym_in,
    STATE(4976), 1,
      sym_type_argument_list,
    ACTIONS(4076), 4,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
    STATE(6784), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4074), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [271797] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(2738), 1,
      sym_generic_name,
    STATE(5368), 1,
      sym_identifier,
    STATE(8106), 1,
      sym__name,
    STATE(8642), 1,
      sym_attribute,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6785), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [271882] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4083), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6745), 1,
      anon_sym_LT,
    ACTIONS(9285), 1,
      anon_sym_in,
    STATE(4976), 1,
      sym_type_argument_list,
    ACTIONS(4076), 4,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
    STATE(6786), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4074), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [271963] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(2738), 1,
      sym_generic_name,
    STATE(5368), 1,
      sym_identifier,
    STATE(8106), 1,
      sym__name,
    STATE(8918), 1,
      sym_attribute,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6787), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [272048] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9287), 1,
      anon_sym_unsafe,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(2738), 1,
      sym_generic_name,
    STATE(5368), 1,
      sym_identifier,
    STATE(8905), 1,
      sym__name,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6788), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [272133] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(2738), 1,
      sym_generic_name,
    STATE(5368), 1,
      sym_identifier,
    STATE(8106), 1,
      sym__name,
    STATE(8632), 1,
      sym_attribute,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6789), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [272218] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(2738), 1,
      sym_generic_name,
    STATE(5368), 1,
      sym_identifier,
    STATE(8106), 1,
      sym__name,
    STATE(8646), 1,
      sym_attribute,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6790), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [272303] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(2738), 1,
      sym_generic_name,
    STATE(5368), 1,
      sym_identifier,
    STATE(7670), 1,
      sym__name,
    STATE(8224), 1,
      sym_primary_constructor_base_type,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6791), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [272388] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(2738), 1,
      sym_generic_name,
    STATE(5368), 1,
      sym_identifier,
    STATE(8106), 1,
      sym__name,
    STATE(8441), 1,
      sym_attribute,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6792), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [272473] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(2738), 1,
      sym_generic_name,
    STATE(5368), 1,
      sym_identifier,
    STATE(7838), 1,
      sym__name,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6793), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [272555] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(2738), 1,
      sym_generic_name,
    STATE(7788), 1,
      sym_identifier,
    STATE(8925), 1,
      sym__name,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6794), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [272637] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9289), 1,
      anon_sym_COMMA,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9293), 1,
      anon_sym_RPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(8342), 1,
      sym_identifier,
    STATE(9092), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6795), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [272723] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(2738), 1,
      sym_generic_name,
    STATE(5368), 1,
      sym_identifier,
    STATE(8859), 1,
      sym__name,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6796), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [272805] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(8193), 1,
      anon_sym_RPAREN,
    ACTIONS(9289), 1,
      anon_sym_COMMA,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(8342), 1,
      sym_identifier,
    STATE(9092), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6797), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [272891] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9289), 1,
      anon_sym_COMMA,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9295), 1,
      anon_sym_RPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(8342), 1,
      sym_identifier,
    STATE(9092), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6798), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [272977] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(8191), 1,
      anon_sym_RPAREN,
    ACTIONS(9289), 1,
      anon_sym_COMMA,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(8342), 1,
      sym_identifier,
    STATE(9092), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6799), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [273063] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(8130), 1,
      anon_sym_RPAREN,
    ACTIONS(9289), 1,
      anon_sym_COMMA,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(8342), 1,
      sym_identifier,
    STATE(9092), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6800), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [273149] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9297), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(7515), 1,
      sym_identifier,
    STATE(8056), 1,
      sym_tuple_pattern,
    STATE(8608), 1,
      sym_variable_declarator,
    STATE(9127), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6801), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [273235] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(7822), 1,
      anon_sym_RPAREN,
    ACTIONS(9289), 1,
      anon_sym_COMMA,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(8342), 1,
      sym_identifier,
    STATE(9092), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6802), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [273321] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9289), 1,
      anon_sym_COMMA,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9299), 1,
      anon_sym_RPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(8342), 1,
      sym_identifier,
    STATE(9092), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6803), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [273407] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9289), 1,
      anon_sym_COMMA,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9301), 1,
      anon_sym_RPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(8342), 1,
      sym_identifier,
    STATE(9092), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6804), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [273493] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9289), 1,
      anon_sym_COMMA,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9303), 1,
      anon_sym_RPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(8342), 1,
      sym_identifier,
    STATE(9092), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6805), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [273579] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9289), 1,
      anon_sym_COMMA,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9305), 1,
      anon_sym_RPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(8342), 1,
      sym_identifier,
    STATE(9092), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6806), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [273665] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(8002), 1,
      anon_sym_RPAREN,
    ACTIONS(9289), 1,
      anon_sym_COMMA,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(8342), 1,
      sym_identifier,
    STATE(9092), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6807), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [273751] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9289), 1,
      anon_sym_COMMA,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9307), 1,
      anon_sym_RPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(8342), 1,
      sym_identifier,
    STATE(9092), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6808), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [273837] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9297), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(7527), 1,
      sym_identifier,
    STATE(8056), 1,
      sym_tuple_pattern,
    STATE(8608), 1,
      sym_variable_declarator,
    STATE(9127), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6809), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [273923] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(4295), 1,
      sym_discard,
    ACTIONS(8391), 1,
      anon_sym_LPAREN,
    ACTIONS(9309), 1,
      anon_sym_RPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(4269), 1,
      sym_identifier,
    STATE(4274), 1,
      sym_parenthesized_variable_designation,
    STATE(8607), 1,
      sym__variable_designation,
    STATE(6810), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [274009] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(2738), 1,
      sym_generic_name,
    STATE(5368), 1,
      sym_identifier,
    STATE(8924), 1,
      sym__name,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6811), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [274091] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(2738), 1,
      sym_generic_name,
    STATE(7903), 1,
      sym_identifier,
    STATE(8930), 1,
      sym__name,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6812), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [274173] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9289), 1,
      anon_sym_COMMA,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9311), 1,
      anon_sym_RPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(8342), 1,
      sym_identifier,
    STATE(9092), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6813), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [274259] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(8120), 1,
      anon_sym_RPAREN,
    ACTIONS(9289), 1,
      anon_sym_COMMA,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(8342), 1,
      sym_identifier,
    STATE(9092), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6814), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [274345] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9289), 1,
      anon_sym_COMMA,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9313), 1,
      anon_sym_RPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(8342), 1,
      sym_identifier,
    STATE(9092), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6815), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [274431] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(8064), 1,
      anon_sym_RPAREN,
    ACTIONS(9289), 1,
      anon_sym_COMMA,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(8342), 1,
      sym_identifier,
    STATE(9092), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6816), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [274517] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(8149), 1,
      anon_sym_RPAREN,
    ACTIONS(9289), 1,
      anon_sym_COMMA,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(8342), 1,
      sym_identifier,
    STATE(9092), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6817), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [274603] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(8054), 1,
      anon_sym_RPAREN,
    ACTIONS(9289), 1,
      anon_sym_COMMA,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(8342), 1,
      sym_identifier,
    STATE(9092), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6818), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [274689] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(2738), 1,
      sym_generic_name,
    STATE(7854), 1,
      sym_identifier,
    STATE(8924), 1,
      sym__name,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6819), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [274771] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9315), 1,
      anon_sym_DOT,
    ACTIONS(4428), 3,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    STATE(6820), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4426), 26,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [274845] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(8187), 1,
      anon_sym_RPAREN,
    ACTIONS(9289), 1,
      anon_sym_COMMA,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(8342), 1,
      sym_identifier,
    STATE(9092), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6821), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [274931] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9289), 1,
      anon_sym_COMMA,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9317), 1,
      anon_sym_RPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(8342), 1,
      sym_identifier,
    STATE(9092), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6822), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [275017] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9289), 1,
      anon_sym_COMMA,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9319), 1,
      anon_sym_RPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(8342), 1,
      sym_identifier,
    STATE(9092), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6823), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [275103] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(2738), 1,
      sym_generic_name,
    STATE(5368), 1,
      sym_identifier,
    STATE(8925), 1,
      sym__name,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6824), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [275185] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(5653), 1,
      anon_sym_LBRACK,
    ACTIONS(9321), 1,
      aux_sym_preproc_if_token3,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(6974), 1,
      aux_sym_class_declaration_repeat1,
    STATE(7261), 1,
      sym_attribute_list,
    STATE(8334), 1,
      sym_identifier,
    STATE(9436), 1,
      sym_enum_member_declaration,
    STATE(6825), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [275271] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9289), 1,
      anon_sym_COMMA,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9323), 1,
      anon_sym_RPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(8342), 1,
      sym_identifier,
    STATE(9092), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6826), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [275357] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9297), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(7521), 1,
      sym_identifier,
    STATE(8056), 1,
      sym_tuple_pattern,
    STATE(8608), 1,
      sym_variable_declarator,
    STATE(9127), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6827), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [275443] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(8014), 1,
      anon_sym_RPAREN,
    ACTIONS(9289), 1,
      anon_sym_COMMA,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(8342), 1,
      sym_identifier,
    STATE(9092), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6828), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [275529] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9289), 1,
      anon_sym_COMMA,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9325), 1,
      anon_sym_RPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(8342), 1,
      sym_identifier,
    STATE(9092), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6829), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [275615] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9289), 1,
      anon_sym_COMMA,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(8320), 1,
      sym_identifier,
    STATE(8641), 1,
      sym_using_variable_declarator,
    STATE(9092), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6830), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [275701] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(8000), 1,
      anon_sym_RPAREN,
    ACTIONS(9289), 1,
      anon_sym_COMMA,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(8342), 1,
      sym_identifier,
    STATE(9092), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6831), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [275787] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(4295), 1,
      sym_discard,
    ACTIONS(8391), 1,
      anon_sym_LPAREN,
    ACTIONS(9327), 1,
      anon_sym_RPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(4269), 1,
      sym_identifier,
    STATE(4274), 1,
      sym_parenthesized_variable_designation,
    STATE(8594), 1,
      sym__variable_designation,
    STATE(6832), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [275873] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(2738), 1,
      sym_generic_name,
    STATE(7802), 1,
      sym_identifier,
    STATE(8905), 1,
      sym__name,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6833), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [275955] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9289), 1,
      anon_sym_COMMA,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9329), 1,
      anon_sym_RPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(8342), 1,
      sym_identifier,
    STATE(9092), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6834), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [276041] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9289), 1,
      anon_sym_COMMA,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9331), 1,
      anon_sym_RPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(8342), 1,
      sym_identifier,
    STATE(9092), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6835), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [276127] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(8006), 1,
      anon_sym_RPAREN,
    ACTIONS(9289), 1,
      anon_sym_COMMA,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(8342), 1,
      sym_identifier,
    STATE(9092), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6836), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [276213] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(4295), 1,
      sym_discard,
    ACTIONS(8391), 1,
      anon_sym_LPAREN,
    ACTIONS(9333), 1,
      anon_sym_RPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(4269), 1,
      sym_identifier,
    STATE(4274), 1,
      sym_parenthesized_variable_designation,
    STATE(8410), 1,
      sym__variable_designation,
    STATE(6837), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [276299] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9289), 1,
      anon_sym_COMMA,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9335), 1,
      anon_sym_RPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(8342), 1,
      sym_identifier,
    STATE(9092), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6838), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [276385] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9289), 1,
      anon_sym_COMMA,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9337), 1,
      anon_sym_RPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(8342), 1,
      sym_identifier,
    STATE(9092), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6839), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [276471] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9297), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(7847), 1,
      sym_identifier,
    STATE(8056), 1,
      sym_tuple_pattern,
    STATE(8608), 1,
      sym_variable_declarator,
    STATE(9692), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6840), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [276557] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9297), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(7521), 1,
      sym_identifier,
    STATE(8056), 1,
      sym_tuple_pattern,
    STATE(8608), 1,
      sym_variable_declarator,
    STATE(9092), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6841), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [276643] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(2738), 1,
      sym_generic_name,
    STATE(5368), 1,
      sym_identifier,
    STATE(8420), 1,
      sym__name,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6842), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [276725] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(8179), 1,
      anon_sym_RPAREN,
    ACTIONS(9289), 1,
      anon_sym_COMMA,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(8342), 1,
      sym_identifier,
    STATE(9092), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6843), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [276811] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(8217), 1,
      anon_sym_RPAREN,
    ACTIONS(9289), 1,
      anon_sym_COMMA,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(8342), 1,
      sym_identifier,
    STATE(9092), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6844), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [276897] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(2738), 1,
      sym_generic_name,
    STATE(5368), 1,
      sym_identifier,
    STATE(8182), 1,
      sym__name,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6845), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [276979] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9289), 1,
      anon_sym_COMMA,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9339), 1,
      anon_sym_RPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(8342), 1,
      sym_identifier,
    STATE(9092), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6846), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [277065] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(2738), 1,
      sym_generic_name,
    STATE(5368), 1,
      sym_identifier,
    STATE(8254), 1,
      sym__name,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6847), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [277147] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(7990), 1,
      anon_sym_RPAREN,
    ACTIONS(9289), 1,
      anon_sym_COMMA,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(8342), 1,
      sym_identifier,
    STATE(9092), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6848), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [277233] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(8008), 1,
      anon_sym_RPAREN,
    ACTIONS(9289), 1,
      anon_sym_COMMA,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(8342), 1,
      sym_identifier,
    STATE(9092), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6849), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [277319] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(2738), 1,
      sym_generic_name,
    STATE(5368), 1,
      sym_identifier,
    STATE(8237), 1,
      sym__name,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6850), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [277401] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(2738), 1,
      sym_generic_name,
    STATE(5368), 1,
      sym_identifier,
    STATE(8944), 1,
      sym__name,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6851), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [277483] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9289), 1,
      anon_sym_COMMA,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9341), 1,
      anon_sym_RPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(8342), 1,
      sym_identifier,
    STATE(9092), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6852), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [277569] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(8147), 1,
      anon_sym_RPAREN,
    ACTIONS(9289), 1,
      anon_sym_COMMA,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(8342), 1,
      sym_identifier,
    STATE(9092), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6853), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [277655] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(7998), 1,
      anon_sym_RPAREN,
    ACTIONS(9289), 1,
      anon_sym_COMMA,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(8342), 1,
      sym_identifier,
    STATE(9092), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6854), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [277741] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2983), 1,
      sym__identifier_token,
    ACTIONS(5653), 1,
      anon_sym_LBRACK,
    STATE(4443), 1,
      sym__reserved_identifier,
    STATE(7051), 1,
      aux_sym_class_declaration_repeat1,
    STATE(7261), 1,
      sym_attribute_list,
    STATE(8834), 1,
      sym_identifier,
    ACTIONS(9343), 2,
      anon_sym_in,
      anon_sym_out,
    STATE(6855), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2987), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [277825] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9289), 1,
      anon_sym_COMMA,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9345), 1,
      anon_sym_RPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(8342), 1,
      sym_identifier,
    STATE(9092), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6856), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [277911] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(8132), 1,
      anon_sym_RPAREN,
    ACTIONS(9289), 1,
      anon_sym_COMMA,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(8342), 1,
      sym_identifier,
    STATE(9092), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6857), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [277997] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9289), 1,
      anon_sym_COMMA,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9347), 1,
      anon_sym_RPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(8342), 1,
      sym_identifier,
    STATE(9092), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6858), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [278083] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(2738), 1,
      sym_generic_name,
    STATE(5368), 1,
      sym_identifier,
    STATE(8946), 1,
      sym__name,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6859), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [278165] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9289), 1,
      anon_sym_COMMA,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9349), 1,
      anon_sym_RPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(8342), 1,
      sym_identifier,
    STATE(9092), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6860), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [278251] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(7826), 1,
      anon_sym_RPAREN,
    ACTIONS(9289), 1,
      anon_sym_COMMA,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(8342), 1,
      sym_identifier,
    STATE(9092), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6861), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [278337] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(8062), 1,
      anon_sym_RPAREN,
    ACTIONS(9289), 1,
      anon_sym_COMMA,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(8342), 1,
      sym_identifier,
    STATE(9092), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6862), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [278423] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(8221), 1,
      anon_sym_RPAREN,
    ACTIONS(9289), 1,
      anon_sym_COMMA,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(8342), 1,
      sym_identifier,
    STATE(9092), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6863), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [278509] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9356), 1,
      anon_sym_LPAREN,
    ACTIONS(9353), 2,
      anon_sym_static,
      anon_sym_async,
    STATE(6864), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_lambda_expression_repeat1,
    ACTIONS(9351), 26,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_ref,
      anon_sym_delegate,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      sym_predefined_type,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [278583] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(8174), 1,
      anon_sym_RPAREN,
    ACTIONS(9289), 1,
      anon_sym_COMMA,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(8342), 1,
      sym_identifier,
    STATE(9092), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6865), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [278669] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9289), 1,
      anon_sym_COMMA,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9358), 1,
      anon_sym_RPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(8342), 1,
      sym_identifier,
    STATE(9092), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6866), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [278755] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(2738), 1,
      sym_generic_name,
    STATE(5368), 1,
      sym_identifier,
    STATE(8930), 1,
      sym__name,
    STATE(4975), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6867), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [278837] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(7996), 1,
      anon_sym_RPAREN,
    ACTIONS(9289), 1,
      anon_sym_COMMA,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(8342), 1,
      sym_identifier,
    STATE(9092), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6868), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [278923] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9289), 1,
      anon_sym_COMMA,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9360), 1,
      anon_sym_RPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(8342), 1,
      sym_identifier,
    STATE(9092), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6869), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [279009] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9297), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(7847), 1,
      sym_identifier,
    STATE(8056), 1,
      sym_tuple_pattern,
    STATE(8608), 1,
      sym_variable_declarator,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(9901), 1,
      sym__lambda_parameters,
    STATE(6870), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [279095] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(4295), 1,
      sym_discard,
    ACTIONS(8391), 1,
      anon_sym_LPAREN,
    ACTIONS(9362), 1,
      anon_sym_RPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(4269), 1,
      sym_identifier,
    STATE(4274), 1,
      sym_parenthesized_variable_designation,
    STATE(8365), 1,
      sym__variable_designation,
    STATE(6871), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [279181] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(4295), 1,
      sym_discard,
    ACTIONS(8391), 1,
      anon_sym_LPAREN,
    ACTIONS(9364), 1,
      anon_sym_RPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(4269), 1,
      sym_identifier,
    STATE(4274), 1,
      sym_parenthesized_variable_designation,
    STATE(8524), 1,
      sym__variable_designation,
    STATE(6872), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [279267] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9297), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(7516), 1,
      sym_identifier,
    STATE(8056), 1,
      sym_tuple_pattern,
    STATE(8608), 1,
      sym_variable_declarator,
    STATE(9127), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6873), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [279353] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4424), 1,
      anon_sym_LPAREN,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(7250), 1,
      anon_sym_LBRACK,
    ACTIONS(7252), 1,
      anon_sym_STAR,
    ACTIONS(7254), 1,
      anon_sym_QMARK,
    ACTIONS(9366), 1,
      anon_sym_DOT,
    STATE(6874), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4422), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [279434] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7333), 1,
      sym__identifier_token,
    ACTIONS(9297), 1,
      anon_sym_LPAREN,
    STATE(3127), 1,
      sym__reserved_identifier,
    STATE(8827), 1,
      sym_identifier,
    STATE(9556), 1,
      sym_tuple_pattern,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(9880), 1,
      sym__lambda_parameters,
    STATE(6875), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7335), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [279517] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7333), 1,
      sym__identifier_token,
    ACTIONS(9297), 1,
      anon_sym_LPAREN,
    STATE(3127), 1,
      sym__reserved_identifier,
    STATE(8760), 1,
      sym_identifier,
    STATE(9739), 1,
      sym_tuple_pattern,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(9880), 1,
      sym__lambda_parameters,
    STATE(6876), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7335), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [279600] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4424), 1,
      anon_sym_LPAREN,
    ACTIONS(5167), 1,
      anon_sym_DASH_GT,
    ACTIONS(7250), 1,
      anon_sym_LBRACK,
    ACTIONS(7252), 1,
      anon_sym_STAR,
    ACTIONS(7254), 1,
      anon_sym_QMARK,
    ACTIONS(9368), 1,
      anon_sym_DOT,
    STATE(6877), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4422), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [279681] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4424), 1,
      anon_sym_LPAREN,
    ACTIONS(5167), 1,
      anon_sym_DASH_GT,
    ACTIONS(7250), 1,
      anon_sym_LBRACK,
    ACTIONS(7252), 1,
      anon_sym_STAR,
    ACTIONS(7254), 1,
      anon_sym_QMARK,
    ACTIONS(9370), 1,
      anon_sym_DOT,
    STATE(6878), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4422), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [279762] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4424), 1,
      anon_sym_LPAREN,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(7250), 1,
      anon_sym_LBRACK,
    ACTIONS(7252), 1,
      anon_sym_STAR,
    ACTIONS(7254), 1,
      anon_sym_QMARK,
    ACTIONS(9372), 1,
      anon_sym_DOT,
    STATE(6879), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4422), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [279843] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4424), 1,
      anon_sym_LPAREN,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(7250), 1,
      anon_sym_LBRACK,
    ACTIONS(7252), 1,
      anon_sym_STAR,
    ACTIONS(7254), 1,
      anon_sym_QMARK,
    ACTIONS(9374), 1,
      anon_sym_DOT,
    STATE(6880), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4422), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [279924] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4424), 1,
      anon_sym_LPAREN,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(7250), 1,
      anon_sym_LBRACK,
    ACTIONS(7252), 1,
      anon_sym_STAR,
    ACTIONS(7254), 1,
      anon_sym_QMARK,
    ACTIONS(9376), 1,
      anon_sym_DOT,
    STATE(6881), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4422), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [280005] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4424), 1,
      anon_sym_LPAREN,
    ACTIONS(7250), 1,
      anon_sym_LBRACK,
    ACTIONS(7252), 1,
      anon_sym_STAR,
    ACTIONS(7254), 1,
      anon_sym_QMARK,
    ACTIONS(5167), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    STATE(6882), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4422), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [280084] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4424), 1,
      anon_sym_LPAREN,
    ACTIONS(7250), 1,
      anon_sym_LBRACK,
    ACTIONS(7252), 1,
      anon_sym_STAR,
    ACTIONS(7254), 1,
      anon_sym_QMARK,
    ACTIONS(4953), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    STATE(6883), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4422), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [280163] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7333), 1,
      sym__identifier_token,
    ACTIONS(9297), 1,
      anon_sym_LPAREN,
    STATE(3127), 1,
      sym__reserved_identifier,
    STATE(8849), 1,
      sym_identifier,
    STATE(9509), 1,
      sym_tuple_pattern,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(9880), 1,
      sym__lambda_parameters,
    STATE(6884), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7335), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [280246] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9380), 1,
      anon_sym_LPAREN,
    STATE(6885), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9378), 28,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_ref,
      anon_sym_delegate,
      anon_sym_file,
      anon_sym_in,
      anon_sym_out,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      sym_predefined_type,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [280317] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7333), 1,
      sym__identifier_token,
    ACTIONS(9297), 1,
      anon_sym_LPAREN,
    STATE(3127), 1,
      sym__reserved_identifier,
    STATE(8763), 1,
      sym_identifier,
    STATE(9737), 1,
      sym_tuple_pattern,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(9880), 1,
      sym__lambda_parameters,
    STATE(6886), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7335), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [280400] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4424), 1,
      anon_sym_LPAREN,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(7250), 1,
      anon_sym_LBRACK,
    ACTIONS(7252), 1,
      anon_sym_STAR,
    ACTIONS(7254), 1,
      anon_sym_QMARK,
    ACTIONS(9372), 1,
      anon_sym_DOT,
    STATE(6887), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4422), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [280481] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4424), 1,
      anon_sym_LPAREN,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(7250), 1,
      anon_sym_LBRACK,
    ACTIONS(7252), 1,
      anon_sym_STAR,
    ACTIONS(7254), 1,
      anon_sym_QMARK,
    ACTIONS(9382), 1,
      anon_sym_DOT,
    STATE(6888), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4422), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [280562] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4424), 1,
      anon_sym_LPAREN,
    ACTIONS(4953), 1,
      anon_sym_DASH_GT,
    ACTIONS(7250), 1,
      anon_sym_LBRACK,
    ACTIONS(7252), 1,
      anon_sym_STAR,
    ACTIONS(7254), 1,
      anon_sym_QMARK,
    ACTIONS(9384), 1,
      anon_sym_DOT,
    STATE(6889), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4422), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [280643] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4424), 1,
      anon_sym_LPAREN,
    ACTIONS(7250), 1,
      anon_sym_LBRACK,
    ACTIONS(7252), 1,
      anon_sym_STAR,
    ACTIONS(7254), 1,
      anon_sym_QMARK,
    ACTIONS(5177), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    STATE(6890), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4422), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [280722] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(4295), 1,
      sym_discard,
    ACTIONS(8391), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(4269), 1,
      sym_identifier,
    STATE(4274), 1,
      sym_parenthesized_variable_designation,
    STATE(8742), 1,
      sym__variable_designation,
    STATE(6891), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [280805] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4424), 1,
      anon_sym_LPAREN,
    ACTIONS(7250), 1,
      anon_sym_LBRACK,
    ACTIONS(7252), 1,
      anon_sym_STAR,
    ACTIONS(7254), 1,
      anon_sym_QMARK,
    ACTIONS(4558), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    STATE(6892), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4422), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [280884] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4424), 1,
      anon_sym_LPAREN,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(7250), 1,
      anon_sym_LBRACK,
    ACTIONS(7252), 1,
      anon_sym_STAR,
    ACTIONS(7254), 1,
      anon_sym_QMARK,
    ACTIONS(9366), 1,
      anon_sym_DOT,
    STATE(6893), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4422), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [280965] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4424), 1,
      anon_sym_LPAREN,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(7250), 1,
      anon_sym_LBRACK,
    ACTIONS(7252), 1,
      anon_sym_STAR,
    ACTIONS(7254), 1,
      anon_sym_QMARK,
    ACTIONS(9386), 1,
      anon_sym_DOT,
    STATE(6894), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4422), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [281046] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4424), 1,
      anon_sym_LPAREN,
    ACTIONS(7250), 1,
      anon_sym_LBRACK,
    ACTIONS(7252), 1,
      anon_sym_STAR,
    ACTIONS(7254), 1,
      anon_sym_QMARK,
    ACTIONS(7396), 1,
      anon_sym_DOT,
    ACTIONS(9388), 1,
      anon_sym_SEMI,
    STATE(6895), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4422), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [281127] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4424), 1,
      anon_sym_LPAREN,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(7250), 1,
      anon_sym_LBRACK,
    ACTIONS(7252), 1,
      anon_sym_STAR,
    ACTIONS(7254), 1,
      anon_sym_QMARK,
    ACTIONS(9390), 1,
      anon_sym_DOT,
    STATE(6896), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4422), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [281208] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4424), 1,
      anon_sym_LPAREN,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(7250), 1,
      anon_sym_LBRACK,
    ACTIONS(7252), 1,
      anon_sym_STAR,
    ACTIONS(7254), 1,
      anon_sym_QMARK,
    ACTIONS(9392), 1,
      anon_sym_DOT,
    STATE(6897), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4422), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [281289] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4424), 1,
      anon_sym_LPAREN,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(7250), 1,
      anon_sym_LBRACK,
    ACTIONS(7252), 1,
      anon_sym_STAR,
    ACTIONS(7254), 1,
      anon_sym_QMARK,
    ACTIONS(9394), 1,
      anon_sym_DOT,
    STATE(6898), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4422), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [281370] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7333), 1,
      sym__identifier_token,
    ACTIONS(9297), 1,
      anon_sym_LPAREN,
    STATE(3127), 1,
      sym__reserved_identifier,
    STATE(8785), 1,
      sym_identifier,
    STATE(9688), 1,
      sym_tuple_pattern,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(9880), 1,
      sym__lambda_parameters,
    STATE(6899), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7335), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [281453] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4424), 1,
      anon_sym_LPAREN,
    ACTIONS(7250), 1,
      anon_sym_LBRACK,
    ACTIONS(7252), 1,
      anon_sym_STAR,
    ACTIONS(7254), 1,
      anon_sym_QMARK,
    ACTIONS(7396), 1,
      anon_sym_DOT,
    ACTIONS(9396), 1,
      anon_sym_SEMI,
    STATE(6900), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4422), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [281534] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4424), 1,
      anon_sym_LPAREN,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(7250), 1,
      anon_sym_LBRACK,
    ACTIONS(7252), 1,
      anon_sym_STAR,
    ACTIONS(7254), 1,
      anon_sym_QMARK,
    ACTIONS(9398), 1,
      anon_sym_DOT,
    STATE(6901), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4422), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [281615] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7333), 1,
      sym__identifier_token,
    ACTIONS(9297), 1,
      anon_sym_LPAREN,
    STATE(3127), 1,
      sym__reserved_identifier,
    STATE(8855), 1,
      sym_identifier,
    STATE(9499), 1,
      sym_tuple_pattern,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(9880), 1,
      sym__lambda_parameters,
    STATE(6902), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7335), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [281698] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(8374), 1,
      sym_identifier,
    ACTIONS(9400), 4,
      anon_sym_Cdecl,
      anon_sym_Stdcall,
      anon_sym_Thiscall,
      anon_sym_Fastcall,
    STATE(6903), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [281775] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4424), 1,
      anon_sym_LPAREN,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(7250), 1,
      anon_sym_LBRACK,
    ACTIONS(7252), 1,
      anon_sym_STAR,
    ACTIONS(7254), 1,
      anon_sym_QMARK,
    ACTIONS(9402), 1,
      anon_sym_DOT,
    STATE(6904), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4422), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [281856] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4424), 1,
      anon_sym_LPAREN,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(7250), 1,
      anon_sym_LBRACK,
    ACTIONS(7252), 1,
      anon_sym_STAR,
    ACTIONS(7254), 1,
      anon_sym_QMARK,
    ACTIONS(9390), 1,
      anon_sym_DOT,
    STATE(6905), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4422), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [281937] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9289), 1,
      anon_sym_COMMA,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(8518), 1,
      sym_identifier,
    STATE(9092), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6906), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [282020] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(8713), 1,
      sym_identifier,
    ACTIONS(9404), 4,
      anon_sym_Cdecl,
      anon_sym_Stdcall,
      anon_sym_Thiscall,
      anon_sym_Fastcall,
    STATE(6907), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [282097] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4424), 1,
      anon_sym_LPAREN,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(7250), 1,
      anon_sym_LBRACK,
    ACTIONS(7252), 1,
      anon_sym_STAR,
    ACTIONS(7254), 1,
      anon_sym_QMARK,
    ACTIONS(9406), 1,
      anon_sym_DOT,
    STATE(6908), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4422), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [282178] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4424), 1,
      anon_sym_LPAREN,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    ACTIONS(7250), 1,
      anon_sym_LBRACK,
    ACTIONS(7252), 1,
      anon_sym_STAR,
    ACTIONS(7254), 1,
      anon_sym_QMARK,
    ACTIONS(9408), 1,
      anon_sym_DOT,
    STATE(6909), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4422), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [282259] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4424), 1,
      anon_sym_LPAREN,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(7250), 1,
      anon_sym_LBRACK,
    ACTIONS(7252), 1,
      anon_sym_STAR,
    ACTIONS(7254), 1,
      anon_sym_QMARK,
    ACTIONS(9410), 1,
      anon_sym_DOT,
    STATE(6910), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4422), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [282340] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4424), 1,
      anon_sym_LPAREN,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(7250), 1,
      anon_sym_LBRACK,
    ACTIONS(7252), 1,
      anon_sym_STAR,
    ACTIONS(7254), 1,
      anon_sym_QMARK,
    ACTIONS(9402), 1,
      anon_sym_DOT,
    STATE(6911), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4422), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [282421] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7333), 1,
      sym__identifier_token,
    ACTIONS(9297), 1,
      anon_sym_LPAREN,
    STATE(3127), 1,
      sym__reserved_identifier,
    STATE(8886), 1,
      sym_identifier,
    STATE(9393), 1,
      sym_tuple_pattern,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(9880), 1,
      sym__lambda_parameters,
    STATE(6912), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7335), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [282504] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4424), 1,
      anon_sym_LPAREN,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(7250), 1,
      anon_sym_LBRACK,
    ACTIONS(7252), 1,
      anon_sym_STAR,
    ACTIONS(7254), 1,
      anon_sym_QMARK,
    ACTIONS(9412), 1,
      anon_sym_DOT,
    STATE(6913), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4422), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [282585] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4424), 1,
      anon_sym_LPAREN,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    ACTIONS(7250), 1,
      anon_sym_LBRACK,
    ACTIONS(7252), 1,
      anon_sym_STAR,
    ACTIONS(7254), 1,
      anon_sym_QMARK,
    ACTIONS(9414), 1,
      anon_sym_DOT,
    STATE(6914), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4422), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [282666] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7333), 1,
      sym__identifier_token,
    ACTIONS(9297), 1,
      anon_sym_LPAREN,
    STATE(3127), 1,
      sym__reserved_identifier,
    STATE(8786), 1,
      sym_identifier,
    STATE(9683), 1,
      sym_tuple_pattern,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(9880), 1,
      sym__lambda_parameters,
    STATE(6915), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7335), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [282749] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9416), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(2738), 1,
      sym_generic_name,
    STATE(5081), 1,
      sym__simple_name,
    STATE(5233), 1,
      sym_identifier,
    ACTIONS(9422), 2,
      anon_sym_operator,
      anon_sym_this,
    STATE(6916), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9419), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [282830] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9426), 1,
      anon_sym_LPAREN,
    STATE(6917), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9424), 28,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_static,
      anon_sym_ref,
      anon_sym_delegate,
      anon_sym_async,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      sym_predefined_type,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [282901] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4424), 1,
      anon_sym_LPAREN,
    ACTIONS(5177), 1,
      anon_sym_DASH_GT,
    ACTIONS(7250), 1,
      anon_sym_LBRACK,
    ACTIONS(7252), 1,
      anon_sym_STAR,
    ACTIONS(7254), 1,
      anon_sym_QMARK,
    ACTIONS(9412), 1,
      anon_sym_DOT,
    STATE(6918), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4422), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [282982] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4424), 1,
      anon_sym_LPAREN,
    ACTIONS(4953), 1,
      anon_sym_DASH_GT,
    ACTIONS(7250), 1,
      anon_sym_LBRACK,
    ACTIONS(7252), 1,
      anon_sym_STAR,
    ACTIONS(7254), 1,
      anon_sym_QMARK,
    ACTIONS(9428), 1,
      anon_sym_DOT,
    STATE(6919), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4422), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [283063] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9223), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6920), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [283143] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9006), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6921), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [283223] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4349), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9110), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6922), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4347), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [283301] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9117), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6923), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [283381] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9443), 1,
      sym_identifier,
    STATE(9599), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6924), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [283461] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(8986), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6925), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [283541] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4349), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9443), 1,
      sym_identifier,
    STATE(9570), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6926), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4347), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [283619] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9337), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6927), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [283699] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9443), 1,
      sym_identifier,
    STATE(9591), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6928), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [283779] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(9894), 1,
      sym__lambda_parameters,
    STATE(6929), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [283859] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9155), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6930), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [283939] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9443), 1,
      sym_identifier,
    STATE(9699), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6931), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [284019] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(8995), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6932), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [284099] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4349), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9347), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6933), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4347), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [284177] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(9889), 1,
      sym__lambda_parameters,
    STATE(6934), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [284257] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9157), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6935), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [284337] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9260), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6936), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [284417] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4349), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9260), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6937), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4347), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [284495] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9443), 1,
      sym_identifier,
    STATE(9570), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6938), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [284575] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9258), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6939), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [284655] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9099), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6940), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [284735] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9152), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6941), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [284815] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9256), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6942), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [284895] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9443), 1,
      sym_identifier,
    STATE(9582), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6943), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [284975] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4349), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9152), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6944), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4347), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [285053] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9149), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6945), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [285133] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4349), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9159), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6946), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4347), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [285211] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9093), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6947), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [285291] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9146), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6948), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [285371] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9126), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6949), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [285451] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9443), 1,
      sym_identifier,
    STATE(9644), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6950), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [285531] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4349), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9443), 1,
      sym_identifier,
    STATE(9644), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6951), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4347), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [285609] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9159), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6952), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [285689] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(5220), 1,
      sym_discard,
    ACTIONS(8628), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(8536), 1,
      sym_tuple_pattern,
    STATE(8634), 1,
      sym_identifier,
    STATE(6953), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [285769] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4349), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9443), 1,
      sym_identifier,
    STATE(9563), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6954), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4347), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [285847] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9443), 1,
      sym_identifier,
    STATE(9717), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6955), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [285927] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(8628), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(7546), 1,
      sym_identifier,
    STATE(8056), 1,
      sym_tuple_pattern,
    STATE(8608), 1,
      sym_variable_declarator,
    STATE(6956), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [286007] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9443), 1,
      sym_identifier,
    STATE(9730), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6957), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [286087] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9347), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6958), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [286167] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9329), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6959), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [286247] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9443), 1,
      sym_identifier,
    STATE(9563), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6960), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [286327] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(9901), 1,
      sym__lambda_parameters,
    STATE(6961), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [286407] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9352), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6962), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [286487] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9253), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6963), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [286567] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4349), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(9880), 1,
      sym__lambda_parameters,
    STATE(6964), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4347), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [286645] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4349), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9443), 1,
      sym_identifier,
    STATE(9618), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6965), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4347), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [286723] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4349), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9253), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6966), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4347), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [286801] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9443), 1,
      sym_identifier,
    STATE(9618), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6967), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [286881] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4349), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(8986), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6968), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4347), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [286959] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9443), 1,
      sym_identifier,
    STATE(9605), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6969), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [287039] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9123), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6970), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [287119] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(8268), 1,
      sym_identifier,
    STATE(9092), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6971), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [287199] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9110), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6972), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [287279] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4349), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9329), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6973), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4347), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [287357] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(5653), 1,
      anon_sym_LBRACK,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(7051), 1,
      aux_sym_class_declaration_repeat1,
    STATE(7261), 1,
      sym_attribute_list,
    STATE(8332), 1,
      sym_identifier,
    STATE(6974), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [287437] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9014), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6975), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [287517] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9250), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6976), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [287597] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9247), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6977), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [287677] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9161), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6978), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [287757] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9323), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6979), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [287837] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9359), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6980), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [287917] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9443), 1,
      sym_identifier,
    STATE(9445), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6981), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [287997] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9434), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6982), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [288077] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4349), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9397), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6983), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4347), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [288155] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9397), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6984), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [288235] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9319), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6985), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [288315] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9422), 1,
      anon_sym_operator,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(2738), 1,
      sym_generic_name,
    STATE(5081), 1,
      sym__simple_name,
    STATE(5233), 1,
      sym_identifier,
    STATE(6986), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [288395] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9138), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6987), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [288475] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9032), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6988), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [288555] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4349), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9138), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6989), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4347), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [288633] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9163), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6990), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [288713] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(8958), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6991), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [288793] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9241), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6992), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [288873] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9443), 1,
      sym_identifier,
    STATE(9478), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6993), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [288953] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(8628), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(7979), 1,
      sym_identifier,
    STATE(7980), 1,
      sym_tuple_pattern,
    STATE(8503), 1,
      sym_variable_declarator,
    STATE(6994), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [289033] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(8059), 1,
      sym_identifier,
    STATE(9022), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6995), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [289113] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4349), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9241), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6996), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4347), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [289191] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(8307), 1,
      sym_identifier,
    STATE(9126), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6997), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [289271] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9237), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6998), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [289351] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9234), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(6999), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [289431] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9142), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(7000), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [289511] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4349), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9142), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(7001), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4347), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [289589] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9264), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(7002), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [289669] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9140), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(7003), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [289749] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9136), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(7004), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [289829] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4349), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(8958), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(7005), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4347), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [289907] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9231), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(7006), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [289987] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9022), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(7007), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [290067] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4349), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9231), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(7008), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4347), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [290145] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9443), 1,
      sym_identifier,
    STATE(9533), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(7009), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [290225] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9090), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(7010), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [290305] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9267), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(7011), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [290385] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4349), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9443), 1,
      sym_identifier,
    STATE(9533), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(7012), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4347), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [290463] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9356), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(7013), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [290543] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9227), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(7014), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [290623] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4349), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9272), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(7015), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4347), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [290701] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9272), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(7016), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [290781] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9443), 1,
      sym_identifier,
    STATE(9723), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(7017), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [290861] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(8997), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(7018), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [290941] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9145), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(7019), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [291021] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4349), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9361), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(7020), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4347), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [291099] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(9827), 1,
      sym__lambda_parameters,
    STATE(7021), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [291179] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4349), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9165), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(7022), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4347), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [291257] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9219), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(7023), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [291337] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4349), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9219), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(7024), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4347), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [291415] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9443), 1,
      sym_identifier,
    STATE(9592), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(7025), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [291495] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(5653), 1,
      anon_sym_LBRACK,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(7051), 1,
      aux_sym_class_declaration_repeat1,
    STATE(7261), 1,
      sym_attribute_list,
    STATE(8349), 1,
      sym_identifier,
    STATE(7026), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [291575] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9165), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(7027), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [291655] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9196), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(7028), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [291735] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9306), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(7029), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [291815] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9304), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(7030), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [291895] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9150), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(7031), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [291975] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9443), 1,
      sym_identifier,
    STATE(9516), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(7032), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [292055] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(9804), 1,
      sym__lambda_parameters,
    STATE(7033), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [292135] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9216), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(7034), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [292215] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9214), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(7035), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [292295] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9082), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(7036), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [292375] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9443), 1,
      sym_identifier,
    STATE(9564), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(7037), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [292455] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9282), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(7038), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [292535] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4349), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9285), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(7039), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4347), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [292613] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(9802), 1,
      sym__lambda_parameters,
    STATE(7040), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [292693] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9120), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(7041), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [292773] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(8628), 1,
      anon_sym_LPAREN,
    ACTIONS(9430), 1,
      sym_discard,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(8825), 1,
      sym_identifier,
    STATE(8826), 1,
      sym_tuple_pattern,
    STATE(7042), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [292853] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4349), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9073), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(7043), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4347), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [292931] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(8628), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(7586), 1,
      sym_identifier,
    STATE(8056), 1,
      sym_tuple_pattern,
    STATE(8608), 1,
      sym_variable_declarator,
    STATE(7044), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [293011] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(8307), 1,
      sym_identifier,
    STATE(9042), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(7045), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [293091] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9361), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(7046), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [293171] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(8628), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(7556), 1,
      sym_identifier,
    STATE(8056), 1,
      sym_tuple_pattern,
    STATE(8608), 1,
      sym_variable_declarator,
    STATE(7047), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [293251] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9208), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(7048), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [293331] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(8015), 1,
      sym_identifier,
    STATE(9022), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(7049), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [293411] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9073), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(7050), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [293491] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9432), 1,
      anon_sym_LBRACK,
    STATE(7261), 1,
      sym_attribute_list,
    STATE(7051), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_class_declaration_repeat1,
    ACTIONS(5277), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_in,
      anon_sym_out,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [293563] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4349), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9208), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(7052), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4347), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [293641] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(8015), 1,
      sym_identifier,
    STATE(9054), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(7053), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [293721] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9054), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(7054), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [293801] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9285), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(7055), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [293881] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9443), 1,
      sym_identifier,
    STATE(9503), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(7056), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [293961] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9206), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(7057), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [294041] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9204), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(7058), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [294121] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4349), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(9795), 1,
      sym__lambda_parameters,
    STATE(7059), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4347), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [294199] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4349), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9443), 1,
      sym_identifier,
    STATE(9750), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(7060), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4347), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [294277] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(9795), 1,
      sym__lambda_parameters,
    STATE(7061), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [294357] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9298), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(7062), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [294437] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4349), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9298), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(7063), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4347), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [294515] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9443), 1,
      sym_identifier,
    STATE(9750), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(7064), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [294595] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(8628), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(7979), 1,
      sym_identifier,
    STATE(7980), 1,
      sym_tuple_pattern,
    STATE(8491), 1,
      sym_variable_declarator,
    STATE(7065), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [294675] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9201), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(7066), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [294755] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4349), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9201), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(7067), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4347), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [294833] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(9911), 1,
      sym__lambda_parameters,
    STATE(7068), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [294913] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9170), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(7069), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [294993] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(9771), 1,
      sym__lambda_parameters,
    STATE(7070), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [295073] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(9867), 1,
      sym__lambda_parameters,
    STATE(7071), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [295153] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9033), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(7072), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [295233] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9384), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(7073), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [295313] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9443), 1,
      sym_identifier,
    STATE(9609), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(7074), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [295393] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9092), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(7075), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [295473] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9443), 1,
      sym_identifier,
    STATE(9692), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(7076), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [295553] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9199), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(7077), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [295633] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9172), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(7078), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [295713] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9197), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(7079), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [295793] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(9880), 1,
      sym__lambda_parameters,
    STATE(7080), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [295873] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4349), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9314), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(7081), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4347), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [295951] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9443), 1,
      sym_identifier,
    STATE(9461), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(7082), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [296031] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4349), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(9911), 1,
      sym__lambda_parameters,
    STATE(7083), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4347), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [296109] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9443), 1,
      sym_identifier,
    STATE(9744), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(7084), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [296189] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9194), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(7085), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [296269] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9340), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(7086), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [296349] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4349), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9194), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(7087), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4347), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [296427] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9192), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(7088), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [296507] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9314), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(7089), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [296587] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(8307), 1,
      sym_identifier,
    STATE(9054), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(7090), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [296667] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4349), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9443), 1,
      sym_identifier,
    STATE(9692), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(7091), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4347), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [296745] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4349), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9443), 1,
      sym_identifier,
    STATE(9461), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(7092), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4347), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [296823] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9312), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(7093), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [296903] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9127), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(7094), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [296983] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4349), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9174), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(7095), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4347), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [297061] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9174), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(7096), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [297141] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4349), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(9901), 1,
      sym__lambda_parameters,
    STATE(7097), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4347), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [297219] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4349), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9443), 1,
      sym_identifier,
    STATE(9738), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(7098), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4347), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [297297] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9443), 1,
      sym_identifier,
    STATE(9575), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(7099), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [297377] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9190), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(7100), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [297457] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9072), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(7101), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [297537] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(8628), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(7625), 1,
      sym_identifier,
    STATE(8056), 1,
      sym_tuple_pattern,
    STATE(8608), 1,
      sym_variable_declarator,
    STATE(7102), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [297617] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4349), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9409), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(7103), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4347), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [297695] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9409), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(7104), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [297775] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(8628), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(8056), 1,
      sym_tuple_pattern,
    STATE(8175), 1,
      sym_identifier,
    STATE(8503), 1,
      sym_variable_declarator,
    STATE(7105), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [297855] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9049), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(7106), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [297935] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(9789), 1,
      sym__lambda_parameters,
    STATE(7107), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [298015] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9443), 1,
      sym_identifier,
    STATE(9738), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(7108), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [298095] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9183), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(7109), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [298175] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9294), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(7110), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [298255] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(7949), 1,
      sym_identifier,
    STATE(9022), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(7111), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [298335] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9042), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(7112), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [298415] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(9891), 1,
      sym__lambda_parameters,
    STATE(7113), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [298495] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(8628), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(8056), 1,
      sym_tuple_pattern,
    STATE(8175), 1,
      sym_identifier,
    STATE(8608), 1,
      sym_variable_declarator,
    STATE(7114), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [298575] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4349), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9183), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(7115), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4347), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [298653] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9440), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(7116), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [298733] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9181), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(7117), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [298813] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(9784), 1,
      sym__lambda_parameters,
    STATE(7118), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [298893] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9289), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(7119), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [298973] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9443), 1,
      sym_identifier,
    STATE(9639), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(7120), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [299053] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9178), 1,
      sym__lambda_parameters,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(7121), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [299133] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9443), 1,
      sym_identifier,
    STATE(9597), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(7122), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [299213] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4349), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9443), 1,
      sym_identifier,
    STATE(9592), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(7123), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4347), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [299291] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4349), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9443), 1,
      sym_identifier,
    STATE(9482), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(7124), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4347), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [299369] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9443), 1,
      sym_identifier,
    STATE(9446), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(7125), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [299449] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9443), 1,
      sym_identifier,
    STATE(9482), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(7126), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [299529] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(8166), 1,
      sym_identifier,
    STATE(9022), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(7127), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [299609] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9443), 1,
      sym_identifier,
    STATE(9595), 1,
      sym__lambda_parameters,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(7128), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [299689] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(9778), 1,
      sym__lambda_parameters,
    STATE(7129), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [299769] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4349), 1,
      anon_sym_LPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9443), 1,
      sym_identifier,
    STATE(9765), 1,
      sym_parameter_list,
    STATE(9778), 1,
      sym__lambda_parameters,
    STATE(7130), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4347), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [299847] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9435), 1,
      sym__identifier_token,
    STATE(2925), 1,
      sym_identifier,
    STATE(2956), 1,
      sym_generic_name,
    STATE(2972), 1,
      sym__simple_name,
    STATE(3195), 1,
      sym__reserved_identifier,
    STATE(7131), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9437), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [299924] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7333), 1,
      sym__identifier_token,
    STATE(3127), 1,
      sym__reserved_identifier,
    STATE(7477), 1,
      sym_identifier,
    ACTIONS(9439), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(7132), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7335), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [299999] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(2738), 1,
      sym_generic_name,
    STATE(2744), 1,
      sym_identifier,
    STATE(2919), 1,
      sym__simple_name,
    STATE(7133), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [300076] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4482), 1,
      sym__identifier_token,
    STATE(5128), 1,
      sym__reserved_identifier,
    STATE(5136), 1,
      sym_identifier,
    STATE(5211), 1,
      sym_generic_name,
    STATE(5605), 1,
      sym__simple_name,
    STATE(7134), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4484), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [300153] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9441), 1,
      sym__identifier_token,
    STATE(2796), 1,
      sym_identifier,
    STATE(2807), 1,
      sym__simple_name,
    STATE(2813), 1,
      sym_generic_name,
    STATE(2827), 1,
      sym__reserved_identifier,
    STATE(7135), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9443), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [300230] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9445), 1,
      sym__identifier_token,
    STATE(2738), 1,
      sym_generic_name,
    STATE(2744), 1,
      sym_identifier,
    STATE(2752), 1,
      sym__simple_name,
    STATE(2799), 1,
      sym__reserved_identifier,
    STATE(7136), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9447), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [300307] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4271), 1,
      sym__identifier_token,
    STATE(3869), 1,
      sym_identifier,
    STATE(3908), 1,
      sym__reserved_identifier,
    STATE(4047), 1,
      sym_generic_name,
    STATE(4139), 1,
      sym__simple_name,
    STATE(7137), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4273), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [300384] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(2738), 1,
      sym_generic_name,
    STATE(2744), 1,
      sym_identifier,
    STATE(2879), 1,
      sym__simple_name,
    STATE(7138), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [300461] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4225), 1,
      sym__identifier_token,
    STATE(3547), 1,
      sym_identifier,
    STATE(3558), 1,
      sym__reserved_identifier,
    STATE(3575), 1,
      sym__simple_name,
    STATE(3608), 1,
      sym_generic_name,
    STATE(7139), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4227), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [300538] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9449), 1,
      sym__identifier_token,
    STATE(4783), 1,
      sym_identifier,
    STATE(4959), 1,
      sym_generic_name,
    STATE(5081), 1,
      sym__simple_name,
    STATE(6696), 1,
      sym__reserved_identifier,
    STATE(7140), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9451), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [300615] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9445), 1,
      sym__identifier_token,
    STATE(2738), 1,
      sym_generic_name,
    STATE(2744), 1,
      sym_identifier,
    STATE(2799), 1,
      sym__reserved_identifier,
    STATE(2841), 1,
      sym__simple_name,
    STATE(7141), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9447), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [300692] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9453), 1,
      anon_sym_RBRACE,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(8600), 1,
      sym_with_initializer,
    STATE(9454), 1,
      sym_identifier,
    STATE(7142), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [300769] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9441), 1,
      sym__identifier_token,
    STATE(2796), 1,
      sym_identifier,
    STATE(2813), 1,
      sym_generic_name,
    STATE(2827), 1,
      sym__reserved_identifier,
    STATE(2849), 1,
      sym__simple_name,
    STATE(7143), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9443), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [300846] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(2738), 1,
      sym_generic_name,
    STATE(2744), 1,
      sym_identifier,
    STATE(2832), 1,
      sym__simple_name,
    STATE(7144), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [300923] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9455), 1,
      anon_sym_RBRACE,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(8469), 1,
      sym_with_initializer,
    STATE(9454), 1,
      sym_identifier,
    STATE(7145), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [301000] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9457), 1,
      anon_sym_RBRACE,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(8603), 1,
      sym_with_initializer,
    STATE(9454), 1,
      sym_identifier,
    STATE(7146), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [301077] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9445), 1,
      sym__identifier_token,
    STATE(2738), 1,
      sym_generic_name,
    STATE(2744), 1,
      sym_identifier,
    STATE(2799), 1,
      sym__reserved_identifier,
    STATE(2837), 1,
      sym__simple_name,
    STATE(7147), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9447), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [301154] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7333), 1,
      sym__identifier_token,
    STATE(3127), 1,
      sym__reserved_identifier,
    STATE(7485), 1,
      sym_identifier,
    ACTIONS(9459), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(7148), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7335), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [301229] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(2738), 1,
      sym_generic_name,
    STATE(2744), 1,
      sym_identifier,
    STATE(2905), 1,
      sym__simple_name,
    STATE(7149), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [301306] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4287), 1,
      sym__identifier_token,
    STATE(3568), 1,
      sym__reserved_identifier,
    STATE(3570), 1,
      sym_identifier,
    STATE(3708), 1,
      sym_generic_name,
    STATE(3763), 1,
      sym__simple_name,
    STATE(7150), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4289), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [301383] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9449), 1,
      sym__identifier_token,
    STATE(4783), 1,
      sym_identifier,
    STATE(4959), 1,
      sym_generic_name,
    STATE(5008), 1,
      sym__simple_name,
    STATE(6696), 1,
      sym__reserved_identifier,
    STATE(7151), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9451), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [301460] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9445), 1,
      sym__identifier_token,
    STATE(2738), 1,
      sym_generic_name,
    STATE(2744), 1,
      sym_identifier,
    STATE(2799), 1,
      sym__reserved_identifier,
    STATE(2857), 1,
      sym__simple_name,
    STATE(7152), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9447), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [301537] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(2738), 1,
      sym_generic_name,
    STATE(2744), 1,
      sym_identifier,
    STATE(2903), 1,
      sym__simple_name,
    STATE(7153), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [301614] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9441), 1,
      sym__identifier_token,
    STATE(2796), 1,
      sym_identifier,
    STATE(2813), 1,
      sym_generic_name,
    STATE(2827), 1,
      sym__reserved_identifier,
    STATE(2862), 1,
      sym__simple_name,
    STATE(7154), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9443), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [301691] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4271), 1,
      sym__identifier_token,
    STATE(3869), 1,
      sym_identifier,
    STATE(3908), 1,
      sym__reserved_identifier,
    STATE(3963), 1,
      sym__simple_name,
    STATE(4047), 1,
      sym_generic_name,
    STATE(7155), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4273), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [301768] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(2738), 1,
      sym_generic_name,
    STATE(2744), 1,
      sym_identifier,
    STATE(2841), 1,
      sym__simple_name,
    STATE(7156), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [301845] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(2738), 1,
      sym_generic_name,
    STATE(2744), 1,
      sym_identifier,
    STATE(2923), 1,
      sym__simple_name,
    STATE(7157), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [301922] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9445), 1,
      sym__identifier_token,
    STATE(2738), 1,
      sym_generic_name,
    STATE(2744), 1,
      sym_identifier,
    STATE(2799), 1,
      sym__reserved_identifier,
    STATE(2879), 1,
      sym__simple_name,
    STATE(7158), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9447), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [301999] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4225), 1,
      sym__identifier_token,
    STATE(3547), 1,
      sym_identifier,
    STATE(3558), 1,
      sym__reserved_identifier,
    STATE(3608), 1,
      sym_generic_name,
    STATE(3686), 1,
      sym__simple_name,
    STATE(7159), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4227), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [302076] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4271), 1,
      sym__identifier_token,
    STATE(3821), 1,
      sym_identifier,
    STATE(3874), 1,
      sym_generic_name,
    STATE(3908), 1,
      sym__reserved_identifier,
    STATE(4061), 1,
      sym__simple_name,
    STATE(7160), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4273), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [302153] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4482), 1,
      sym__identifier_token,
    STATE(5128), 1,
      sym__reserved_identifier,
    STATE(5136), 1,
      sym_identifier,
    STATE(5211), 1,
      sym_generic_name,
    STATE(5375), 1,
      sym__simple_name,
    STATE(7161), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4484), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [302230] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(2738), 1,
      sym_generic_name,
    STATE(2744), 1,
      sym_identifier,
    STATE(2948), 1,
      sym__simple_name,
    STATE(7162), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [302307] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4482), 1,
      sym__identifier_token,
    STATE(5128), 1,
      sym__reserved_identifier,
    STATE(5136), 1,
      sym_identifier,
    STATE(5211), 1,
      sym_generic_name,
    STATE(5365), 1,
      sym__simple_name,
    STATE(7163), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4484), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [302384] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7333), 1,
      sym__identifier_token,
    STATE(3127), 1,
      sym__reserved_identifier,
    STATE(7478), 1,
      sym_identifier,
    ACTIONS(9461), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(7164), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7335), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [302459] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4271), 1,
      sym__identifier_token,
    STATE(3869), 1,
      sym_identifier,
    STATE(3908), 1,
      sym__reserved_identifier,
    STATE(3964), 1,
      sym__simple_name,
    STATE(4047), 1,
      sym_generic_name,
    STATE(7165), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4273), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [302536] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(2738), 1,
      sym_generic_name,
    STATE(2744), 1,
      sym_identifier,
    STATE(2894), 1,
      sym__simple_name,
    STATE(7166), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [302613] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(2738), 1,
      sym_generic_name,
    STATE(2744), 1,
      sym_identifier,
    STATE(2887), 1,
      sym__simple_name,
    STATE(7167), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [302690] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(7250), 1,
      anon_sym_LBRACK,
    ACTIONS(7254), 1,
      anon_sym_QMARK,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(8424), 1,
      sym_identifier,
    STATE(7168), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [302767] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4168), 1,
      sym__identifier_token,
    STATE(3869), 1,
      sym_identifier,
    STATE(3897), 1,
      sym__reserved_identifier,
    STATE(3964), 1,
      sym__simple_name,
    STATE(4047), 1,
      sym_generic_name,
    STATE(7169), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4170), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [302844] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4168), 1,
      sym__identifier_token,
    STATE(3869), 1,
      sym_identifier,
    STATE(3897), 1,
      sym__reserved_identifier,
    STATE(3963), 1,
      sym__simple_name,
    STATE(4047), 1,
      sym_generic_name,
    STATE(7170), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4170), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [302921] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(2738), 1,
      sym_generic_name,
    STATE(2744), 1,
      sym_identifier,
    STATE(2828), 1,
      sym__simple_name,
    STATE(7171), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [302998] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2983), 1,
      sym__identifier_token,
    STATE(4443), 1,
      sym__reserved_identifier,
    STATE(4783), 1,
      sym_identifier,
    STATE(4959), 1,
      sym_generic_name,
    STATE(5081), 1,
      sym__simple_name,
    STATE(7172), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2987), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [303075] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(2738), 1,
      sym_generic_name,
    STATE(2744), 1,
      sym_identifier,
    STATE(3552), 1,
      sym__simple_name,
    STATE(7173), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [303152] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9463), 1,
      sym__identifier_token,
    STATE(3203), 1,
      sym_identifier,
    STATE(3314), 1,
      sym_generic_name,
    STATE(3397), 1,
      sym__reserved_identifier,
    STATE(3445), 1,
      sym__simple_name,
    STATE(7174), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9465), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [303229] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7333), 1,
      sym__identifier_token,
    STATE(3127), 1,
      sym__reserved_identifier,
    STATE(7480), 1,
      sym_identifier,
    ACTIONS(9467), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(7175), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7335), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [303304] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4271), 1,
      sym__identifier_token,
    STATE(3570), 1,
      sym_identifier,
    STATE(3708), 1,
      sym_generic_name,
    STATE(3763), 1,
      sym__simple_name,
    STATE(3908), 1,
      sym__reserved_identifier,
    STATE(7176), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4273), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [303381] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(2738), 1,
      sym_generic_name,
    STATE(2744), 1,
      sym_identifier,
    STATE(2866), 1,
      sym__simple_name,
    STATE(7177), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [303458] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(7250), 1,
      anon_sym_LBRACK,
    ACTIONS(7252), 1,
      anon_sym_STAR,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(8424), 1,
      sym_identifier,
    STATE(7178), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [303535] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7333), 1,
      sym__identifier_token,
    STATE(3127), 1,
      sym__reserved_identifier,
    STATE(7483), 1,
      sym_identifier,
    ACTIONS(9469), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(7179), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7335), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [303610] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4271), 1,
      sym__identifier_token,
    STATE(3547), 1,
      sym_identifier,
    STATE(3577), 1,
      sym__simple_name,
    STATE(3608), 1,
      sym_generic_name,
    STATE(3908), 1,
      sym__reserved_identifier,
    STATE(7180), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4273), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [303687] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(2738), 1,
      sym_generic_name,
    STATE(2744), 1,
      sym_identifier,
    STATE(2758), 1,
      sym__simple_name,
    STATE(7181), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [303764] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9445), 1,
      sym__identifier_token,
    STATE(2738), 1,
      sym_generic_name,
    STATE(2799), 1,
      sym__reserved_identifier,
    STATE(5008), 1,
      sym__simple_name,
    STATE(5233), 1,
      sym_identifier,
    STATE(7182), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9447), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [303841] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9445), 1,
      sym__identifier_token,
    STATE(2738), 1,
      sym_generic_name,
    STATE(2744), 1,
      sym_identifier,
    STATE(2799), 1,
      sym__reserved_identifier,
    STATE(2889), 1,
      sym__simple_name,
    STATE(7183), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9447), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [303918] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(2738), 1,
      sym_generic_name,
    STATE(2744), 1,
      sym_identifier,
    STATE(2754), 1,
      sym__simple_name,
    STATE(7184), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [303995] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9471), 1,
      sym__identifier_token,
    STATE(3135), 1,
      sym_identifier,
    STATE(3187), 1,
      sym__reserved_identifier,
    STATE(3201), 1,
      sym__simple_name,
    STATE(3205), 1,
      sym_generic_name,
    STATE(7185), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9473), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [304072] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(2738), 1,
      sym_generic_name,
    STATE(2744), 1,
      sym_identifier,
    STATE(2748), 1,
      sym__simple_name,
    STATE(7186), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [304149] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9475), 1,
      anon_sym_operator,
    ACTIONS(9477), 1,
      anon_sym_this,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(7668), 1,
      sym_identifier,
    STATE(7187), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [304226] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9445), 1,
      sym__identifier_token,
    STATE(2738), 1,
      sym_generic_name,
    STATE(2744), 1,
      sym_identifier,
    STATE(2748), 1,
      sym__simple_name,
    STATE(2799), 1,
      sym__reserved_identifier,
    STATE(7188), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9447), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [304303] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(2738), 1,
      sym_generic_name,
    STATE(2744), 1,
      sym_identifier,
    STATE(2969), 1,
      sym__simple_name,
    STATE(7189), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [304380] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7333), 1,
      sym__identifier_token,
    STATE(3127), 1,
      sym__reserved_identifier,
    STATE(7488), 1,
      sym_identifier,
    ACTIONS(9479), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(7190), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7335), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [304455] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(2738), 1,
      sym_generic_name,
    STATE(2744), 1,
      sym_identifier,
    STATE(2941), 1,
      sym__simple_name,
    STATE(7191), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [304532] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4168), 1,
      sym__identifier_token,
    STATE(3869), 1,
      sym_identifier,
    STATE(3897), 1,
      sym__reserved_identifier,
    STATE(4047), 1,
      sym_generic_name,
    STATE(4139), 1,
      sym__simple_name,
    STATE(7192), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4170), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [304609] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4271), 1,
      sym__identifier_token,
    STATE(3547), 1,
      sym_identifier,
    STATE(3575), 1,
      sym__simple_name,
    STATE(3608), 1,
      sym_generic_name,
    STATE(3908), 1,
      sym__reserved_identifier,
    STATE(7193), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4273), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [304686] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(2738), 1,
      sym_generic_name,
    STATE(2744), 1,
      sym_identifier,
    STATE(2932), 1,
      sym__simple_name,
    STATE(7194), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [304763] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9445), 1,
      sym__identifier_token,
    STATE(2738), 1,
      sym_generic_name,
    STATE(2744), 1,
      sym_identifier,
    STATE(2754), 1,
      sym__simple_name,
    STATE(2799), 1,
      sym__reserved_identifier,
    STATE(7195), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9447), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [304840] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(7250), 1,
      anon_sym_LBRACK,
    ACTIONS(7252), 1,
      anon_sym_STAR,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(8614), 1,
      sym_identifier,
    STATE(7196), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [304917] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7333), 1,
      sym__identifier_token,
    STATE(3127), 1,
      sym__reserved_identifier,
    STATE(3204), 1,
      sym_identifier,
    STATE(3357), 1,
      sym__simple_name,
    STATE(3404), 1,
      sym_generic_name,
    STATE(7197), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7335), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [304994] = 16,
    ACTIONS(8279), 1,
      sym__identifier_token,
    ACTIONS(9481), 1,
      sym_integer_literal,
    ACTIONS(9483), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(9485), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9487), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9489), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9491), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9493), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9495), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9497), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9499), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9501), 1,
      sym_comment,
    STATE(7840), 1,
      sym__reserved_identifier,
    STATE(8657), 1,
      sym_identifier,
    STATE(7198), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(8281), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [305071] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(2738), 1,
      sym_generic_name,
    STATE(2744), 1,
      sym_identifier,
    STATE(2837), 1,
      sym__simple_name,
    STATE(7199), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [305148] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(2738), 1,
      sym_generic_name,
    STATE(2744), 1,
      sym_identifier,
    STATE(2976), 1,
      sym__simple_name,
    STATE(7200), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [305225] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(2738), 1,
      sym_generic_name,
    STATE(2744), 1,
      sym_identifier,
    STATE(2889), 1,
      sym__simple_name,
    STATE(7201), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [305302] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(7250), 1,
      anon_sym_LBRACK,
    ACTIONS(7254), 1,
      anon_sym_QMARK,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(8614), 1,
      sym_identifier,
    STATE(7202), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [305379] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(2738), 1,
      sym_generic_name,
    STATE(2744), 1,
      sym_identifier,
    STATE(2746), 1,
      sym__simple_name,
    STATE(7203), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [305456] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(8884), 1,
      sym_identifier,
    ACTIONS(9289), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(7204), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [305531] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4271), 1,
      sym__identifier_token,
    STATE(3821), 1,
      sym_identifier,
    STATE(3874), 1,
      sym_generic_name,
    STATE(3890), 1,
      sym__simple_name,
    STATE(3908), 1,
      sym__reserved_identifier,
    STATE(7205), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4273), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [305608] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4490), 1,
      sym__identifier_token,
    STATE(2914), 1,
      sym__reserved_identifier,
    STATE(2925), 1,
      sym_identifier,
    STATE(2956), 1,
      sym_generic_name,
    STATE(4696), 1,
      sym__simple_name,
    STATE(7206), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4492), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [305685] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(2738), 1,
      sym_generic_name,
    STATE(2744), 1,
      sym_identifier,
    STATE(2791), 1,
      sym__simple_name,
    STATE(7207), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [305762] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4271), 1,
      sym__identifier_token,
    STATE(3821), 1,
      sym_identifier,
    STATE(3874), 1,
      sym_generic_name,
    STATE(3889), 1,
      sym__simple_name,
    STATE(3908), 1,
      sym__reserved_identifier,
    STATE(7208), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4273), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [305839] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(2738), 1,
      sym_generic_name,
    STATE(5081), 1,
      sym__simple_name,
    STATE(5233), 1,
      sym_identifier,
    STATE(7209), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [305916] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7333), 1,
      sym__identifier_token,
    STATE(3127), 1,
      sym__reserved_identifier,
    STATE(7479), 1,
      sym_identifier,
    ACTIONS(9503), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(7210), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7335), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [305991] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9505), 1,
      sym__identifier_token,
    STATE(3853), 1,
      sym_identifier,
    STATE(3862), 1,
      sym__simple_name,
    STATE(3873), 1,
      sym__reserved_identifier,
    STATE(3914), 1,
      sym_generic_name,
    STATE(7211), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9507), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [306068] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9509), 1,
      anon_sym_RBRACE,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(8462), 1,
      sym_with_initializer,
    STATE(9454), 1,
      sym_identifier,
    STATE(7212), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [306145] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9445), 1,
      sym__identifier_token,
    STATE(2738), 1,
      sym_generic_name,
    STATE(2744), 1,
      sym_identifier,
    STATE(2799), 1,
      sym__reserved_identifier,
    STATE(2832), 1,
      sym__simple_name,
    STATE(7213), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9447), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [306222] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(2738), 1,
      sym_generic_name,
    STATE(2744), 1,
      sym_identifier,
    STATE(2777), 1,
      sym__simple_name,
    STATE(7214), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [306299] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9445), 1,
      sym__identifier_token,
    STATE(2738), 1,
      sym_generic_name,
    STATE(2744), 1,
      sym_identifier,
    STATE(2777), 1,
      sym__simple_name,
    STATE(2799), 1,
      sym__reserved_identifier,
    STATE(7215), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9447), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [306376] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9511), 1,
      sym__identifier_token,
    STATE(2945), 1,
      sym_identifier,
    STATE(2980), 1,
      sym__simple_name,
    STATE(2982), 1,
      sym_generic_name,
    STATE(2993), 1,
      sym__reserved_identifier,
    STATE(7216), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9513), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [306453] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(2738), 1,
      sym_generic_name,
    STATE(2744), 1,
      sym_identifier,
    STATE(2938), 1,
      sym__simple_name,
    STATE(7217), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [306530] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7333), 1,
      sym__identifier_token,
    STATE(3127), 1,
      sym__reserved_identifier,
    STATE(7487), 1,
      sym_identifier,
    ACTIONS(9515), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(7218), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7335), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [306605] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9517), 1,
      anon_sym_RBRACE,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(8375), 1,
      sym_with_initializer,
    STATE(9454), 1,
      sym_identifier,
    STATE(7219), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [306682] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(2738), 1,
      sym_generic_name,
    STATE(2744), 1,
      sym_identifier,
    STATE(2967), 1,
      sym__simple_name,
    STATE(7220), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [306759] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9463), 1,
      sym__identifier_token,
    STATE(3203), 1,
      sym_identifier,
    STATE(3314), 1,
      sym_generic_name,
    STATE(3397), 1,
      sym__reserved_identifier,
    STATE(3457), 1,
      sym__simple_name,
    STATE(7221), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9465), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [306836] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4287), 1,
      sym__identifier_token,
    STATE(3568), 1,
      sym__reserved_identifier,
    STATE(3570), 1,
      sym_identifier,
    STATE(3648), 1,
      sym__simple_name,
    STATE(3708), 1,
      sym_generic_name,
    STATE(7222), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4289), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [306913] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4225), 1,
      sym__identifier_token,
    STATE(3547), 1,
      sym_identifier,
    STATE(3558), 1,
      sym__reserved_identifier,
    STATE(3577), 1,
      sym__simple_name,
    STATE(3608), 1,
      sym_generic_name,
    STATE(7223), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4227), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [306990] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9441), 1,
      sym__identifier_token,
    STATE(2796), 1,
      sym_identifier,
    STATE(2813), 1,
      sym_generic_name,
    STATE(2825), 1,
      sym__simple_name,
    STATE(2827), 1,
      sym__reserved_identifier,
    STATE(7224), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9443), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [307067] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9519), 1,
      anon_sym_operator,
    ACTIONS(9521), 1,
      anon_sym_this,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(7654), 1,
      sym_identifier,
    STATE(7225), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [307144] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(2738), 1,
      sym_generic_name,
    STATE(2744), 1,
      sym_identifier,
    STATE(2883), 1,
      sym__simple_name,
    STATE(7226), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [307221] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4271), 1,
      sym__identifier_token,
    STATE(3570), 1,
      sym_identifier,
    STATE(3648), 1,
      sym__simple_name,
    STATE(3708), 1,
      sym_generic_name,
    STATE(3908), 1,
      sym__reserved_identifier,
    STATE(7227), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4273), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [307298] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7333), 1,
      sym__identifier_token,
    STATE(3127), 1,
      sym__reserved_identifier,
    STATE(7481), 1,
      sym_identifier,
    ACTIONS(9523), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(7228), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7335), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [307373] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(2738), 1,
      sym_generic_name,
    STATE(2744), 1,
      sym_identifier,
    STATE(2750), 1,
      sym__simple_name,
    STATE(7229), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [307450] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9445), 1,
      sym__identifier_token,
    STATE(2738), 1,
      sym_generic_name,
    STATE(2744), 1,
      sym_identifier,
    STATE(2750), 1,
      sym__simple_name,
    STATE(2799), 1,
      sym__reserved_identifier,
    STATE(7230), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9447), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [307527] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4490), 1,
      sym__identifier_token,
    STATE(2914), 1,
      sym__reserved_identifier,
    STATE(2925), 1,
      sym_identifier,
    STATE(2956), 1,
      sym_generic_name,
    STATE(2972), 1,
      sym__simple_name,
    STATE(7231), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4492), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [307604] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9441), 1,
      sym__identifier_token,
    STATE(2796), 1,
      sym_identifier,
    STATE(2812), 1,
      sym__simple_name,
    STATE(2813), 1,
      sym_generic_name,
    STATE(2827), 1,
      sym__reserved_identifier,
    STATE(7232), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9443), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [307681] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9445), 1,
      sym__identifier_token,
    STATE(2738), 1,
      sym_generic_name,
    STATE(2744), 1,
      sym_identifier,
    STATE(2746), 1,
      sym__simple_name,
    STATE(2799), 1,
      sym__reserved_identifier,
    STATE(7233), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9447), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [307758] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(2738), 1,
      sym_generic_name,
    STATE(2744), 1,
      sym_identifier,
    STATE(2752), 1,
      sym__simple_name,
    STATE(7234), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [307835] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(2738), 1,
      sym_generic_name,
    STATE(2744), 1,
      sym_identifier,
    STATE(2960), 1,
      sym__simple_name,
    STATE(7235), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [307912] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4271), 1,
      sym__identifier_token,
    STATE(3547), 1,
      sym_identifier,
    STATE(3608), 1,
      sym_generic_name,
    STATE(3686), 1,
      sym__simple_name,
    STATE(3908), 1,
      sym__reserved_identifier,
    STATE(7236), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4273), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [307989] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(2738), 1,
      sym_generic_name,
    STATE(2744), 1,
      sym_identifier,
    STATE(2885), 1,
      sym__simple_name,
    STATE(7237), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [308066] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(2738), 1,
      sym_generic_name,
    STATE(2744), 1,
      sym_identifier,
    STATE(2902), 1,
      sym__simple_name,
    STATE(7238), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [308143] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9445), 1,
      sym__identifier_token,
    STATE(2738), 1,
      sym_generic_name,
    STATE(2744), 1,
      sym_identifier,
    STATE(2791), 1,
      sym__simple_name,
    STATE(2799), 1,
      sym__reserved_identifier,
    STATE(7239), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9447), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [308220] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(2738), 1,
      sym_generic_name,
    STATE(2744), 1,
      sym_identifier,
    STATE(2875), 1,
      sym__simple_name,
    STATE(7240), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [308297] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9445), 1,
      sym__identifier_token,
    STATE(2738), 1,
      sym_generic_name,
    STATE(2744), 1,
      sym_identifier,
    STATE(2799), 1,
      sym__reserved_identifier,
    STATE(2828), 1,
      sym__simple_name,
    STATE(7241), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9447), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [308374] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9445), 1,
      sym__identifier_token,
    STATE(2738), 1,
      sym_generic_name,
    STATE(2744), 1,
      sym_identifier,
    STATE(2799), 1,
      sym__reserved_identifier,
    STATE(2829), 1,
      sym__simple_name,
    STATE(7242), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9447), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [308451] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9445), 1,
      sym__identifier_token,
    STATE(2738), 1,
      sym_generic_name,
    STATE(2744), 1,
      sym_identifier,
    STATE(2799), 1,
      sym__reserved_identifier,
    STATE(2856), 1,
      sym__simple_name,
    STATE(7243), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9447), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [308528] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9445), 1,
      sym__identifier_token,
    STATE(2738), 1,
      sym_generic_name,
    STATE(2744), 1,
      sym_identifier,
    STATE(2758), 1,
      sym__simple_name,
    STATE(2799), 1,
      sym__reserved_identifier,
    STATE(7244), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9447), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [308605] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4490), 1,
      sym__identifier_token,
    STATE(2914), 1,
      sym__reserved_identifier,
    STATE(2925), 1,
      sym_identifier,
    STATE(2951), 1,
      sym__simple_name,
    STATE(2956), 1,
      sym_generic_name,
    STATE(7245), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4492), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [308682] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9525), 1,
      anon_sym_RBRACE,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(8566), 1,
      sym_with_initializer,
    STATE(9454), 1,
      sym_identifier,
    STATE(7246), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [308759] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(2738), 1,
      sym_generic_name,
    STATE(2744), 1,
      sym_identifier,
    STATE(2865), 1,
      sym__simple_name,
    STATE(7247), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [308836] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4287), 1,
      sym__identifier_token,
    STATE(3568), 1,
      sym__reserved_identifier,
    STATE(3570), 1,
      sym_identifier,
    STATE(3653), 1,
      sym__simple_name,
    STATE(3708), 1,
      sym_generic_name,
    STATE(7248), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4289), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [308913] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4271), 1,
      sym__identifier_token,
    STATE(3570), 1,
      sym_identifier,
    STATE(3653), 1,
      sym__simple_name,
    STATE(3708), 1,
      sym_generic_name,
    STATE(3908), 1,
      sym__reserved_identifier,
    STATE(7249), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4273), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [308990] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9445), 1,
      sym__identifier_token,
    STATE(2738), 1,
      sym_generic_name,
    STATE(2799), 1,
      sym__reserved_identifier,
    STATE(5081), 1,
      sym__simple_name,
    STATE(5233), 1,
      sym_identifier,
    STATE(7250), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9447), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [309067] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9435), 1,
      sym__identifier_token,
    STATE(2925), 1,
      sym_identifier,
    STATE(2951), 1,
      sym__simple_name,
    STATE(2956), 1,
      sym_generic_name,
    STATE(3195), 1,
      sym__reserved_identifier,
    STATE(7251), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9437), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [309144] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2983), 1,
      sym__identifier_token,
    STATE(4443), 1,
      sym__reserved_identifier,
    STATE(4783), 1,
      sym_identifier,
    STATE(4959), 1,
      sym_generic_name,
    STATE(5008), 1,
      sym__simple_name,
    STATE(7252), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2987), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [309221] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9527), 1,
      anon_sym_operator,
    ACTIONS(9529), 1,
      anon_sym_this,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(7659), 1,
      sym_identifier,
    STATE(7253), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [309298] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(2738), 1,
      sym_generic_name,
    STATE(5008), 1,
      sym__simple_name,
    STATE(5233), 1,
      sym_identifier,
    STATE(7254), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [309375] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(8437), 1,
      sym_identifier,
    STATE(8821), 1,
      sym_using_variable_declarator,
    STATE(7255), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [309449] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5612), 1,
      anon_sym_LBRACK,
    STATE(7256), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5610), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_in,
      anon_sym_out,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [309517] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9531), 1,
      anon_sym_RPAREN,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9786), 1,
      sym_identifier,
    STATE(7257), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [309591] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8279), 1,
      sym__identifier_token,
    ACTIONS(9533), 1,
      sym_integer_literal,
    STATE(7840), 1,
      sym__reserved_identifier,
    STATE(8797), 1,
      sym_identifier,
    STATE(7258), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(8281), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [309665] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9289), 1,
      anon_sym_COMMA,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(8553), 1,
      sym_identifier,
    STATE(7259), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [309739] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5639), 1,
      anon_sym_LBRACK,
    STATE(7260), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5637), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_in,
      anon_sym_out,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [309807] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5624), 1,
      anon_sym_LBRACK,
    STATE(7261), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5622), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_in,
      anon_sym_out,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [309875] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5635), 1,
      anon_sym_LBRACK,
    STATE(7262), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5633), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_in,
      anon_sym_out,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [309943] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(8767), 1,
      sym_with_initializer,
    STATE(9454), 1,
      sym_identifier,
    STATE(7263), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [310017] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5616), 1,
      anon_sym_LBRACK,
    STATE(7264), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5614), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_in,
      anon_sym_out,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [310085] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(8305), 1,
      sym_identifier,
    STATE(7265), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [310156] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(7463), 1,
      sym_identifier,
    STATE(7266), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [310227] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7333), 1,
      sym__identifier_token,
    STATE(3127), 1,
      sym__reserved_identifier,
    STATE(8291), 1,
      sym_identifier,
    STATE(7267), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7335), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [310298] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7333), 1,
      sym__identifier_token,
    STATE(3127), 1,
      sym__reserved_identifier,
    STATE(7638), 1,
      sym_identifier,
    STATE(7268), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7335), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [310369] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7333), 1,
      sym__identifier_token,
    STATE(3127), 1,
      sym__reserved_identifier,
    STATE(9263), 1,
      sym_identifier,
    STATE(7269), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7335), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [310440] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(8275), 1,
      sym_identifier,
    STATE(7270), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [310511] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(7458), 1,
      sym_identifier,
    STATE(7271), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [310582] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7333), 1,
      sym__identifier_token,
    STATE(3127), 1,
      sym__reserved_identifier,
    STATE(7492), 1,
      sym_identifier,
    STATE(7272), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7335), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [310653] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(7440), 1,
      sym_identifier,
    STATE(7273), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [310724] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2983), 1,
      sym__identifier_token,
    STATE(4443), 1,
      sym__reserved_identifier,
    STATE(8769), 1,
      sym_identifier,
    STATE(7274), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2987), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [310795] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(7421), 1,
      sym_identifier,
    STATE(7275), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [310866] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(8686), 1,
      sym_identifier,
    STATE(7276), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [310937] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7333), 1,
      sym__identifier_token,
    STATE(3127), 1,
      sym__reserved_identifier,
    STATE(7505), 1,
      sym_identifier,
    STATE(7277), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7335), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [311008] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9811), 1,
      sym_identifier,
    STATE(7278), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [311079] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7333), 1,
      sym__identifier_token,
    STATE(3127), 1,
      sym__reserved_identifier,
    STATE(7504), 1,
      sym_identifier,
    STATE(7279), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7335), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [311150] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(7431), 1,
      sym_identifier,
    STATE(7280), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [311221] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7333), 1,
      sym__identifier_token,
    STATE(3127), 1,
      sym__reserved_identifier,
    STATE(7482), 1,
      sym_identifier,
    STATE(7281), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7335), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [311292] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7333), 1,
      sym__identifier_token,
    STATE(3127), 1,
      sym__reserved_identifier,
    STATE(7545), 1,
      sym_identifier,
    STATE(7282), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7335), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [311363] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7333), 1,
      sym__identifier_token,
    STATE(3127), 1,
      sym__reserved_identifier,
    STATE(7501), 1,
      sym_identifier,
    STATE(7283), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7335), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [311434] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7333), 1,
      sym__identifier_token,
    STATE(3127), 1,
      sym__reserved_identifier,
    STATE(7478), 1,
      sym_identifier,
    STATE(7284), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7335), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [311505] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7333), 1,
      sym__identifier_token,
    STATE(3127), 1,
      sym__reserved_identifier,
    STATE(8330), 1,
      sym_identifier,
    STATE(7285), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7335), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [311576] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(7459), 1,
      sym_identifier,
    STATE(7286), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [311647] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(8286), 1,
      sym_identifier,
    STATE(7287), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [311718] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(7450), 1,
      sym_identifier,
    STATE(7288), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [311789] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7333), 1,
      sym__identifier_token,
    STATE(3127), 1,
      sym__reserved_identifier,
    STATE(7491), 1,
      sym_identifier,
    STATE(7289), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7335), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [311860] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(8311), 1,
      sym_identifier,
    STATE(7290), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [311931] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7333), 1,
      sym__identifier_token,
    STATE(3127), 1,
      sym__reserved_identifier,
    STATE(7508), 1,
      sym_identifier,
    STATE(7291), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7335), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [312002] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(7442), 1,
      sym_identifier,
    STATE(7292), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [312073] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(7443), 1,
      sym_identifier,
    STATE(7293), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [312144] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(8622), 1,
      sym_identifier,
    STATE(7294), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [312215] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(8321), 1,
      sym_identifier,
    STATE(7295), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [312286] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7333), 1,
      sym__identifier_token,
    STATE(3127), 1,
      sym__reserved_identifier,
    STATE(7486), 1,
      sym_identifier,
    STATE(7296), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7335), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [312357] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(7437), 1,
      sym_identifier,
    STATE(7297), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [312428] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7333), 1,
      sym__identifier_token,
    STATE(3127), 1,
      sym__reserved_identifier,
    STATE(7509), 1,
      sym_identifier,
    STATE(7298), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7335), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [312499] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7333), 1,
      sym__identifier_token,
    STATE(3127), 1,
      sym__reserved_identifier,
    STATE(8301), 1,
      sym_identifier,
    STATE(7299), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7335), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [312570] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7333), 1,
      sym__identifier_token,
    STATE(3127), 1,
      sym__reserved_identifier,
    STATE(8247), 1,
      sym_identifier,
    STATE(7300), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7335), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [312641] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(8853), 1,
      sym_identifier,
    STATE(7301), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [312712] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(8362), 1,
      sym_identifier,
    STATE(7302), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [312783] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7333), 1,
      sym__identifier_token,
    STATE(3127), 1,
      sym__reserved_identifier,
    STATE(7497), 1,
      sym_identifier,
    STATE(7303), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7335), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [312854] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7333), 1,
      sym__identifier_token,
    STATE(3127), 1,
      sym__reserved_identifier,
    STATE(7507), 1,
      sym_identifier,
    STATE(7304), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7335), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [312925] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(7430), 1,
      sym_identifier,
    STATE(7305), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [312996] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(8273), 1,
      sym_identifier,
    STATE(7306), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [313067] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(7414), 1,
      sym_identifier,
    STATE(7307), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [313138] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7333), 1,
      sym__identifier_token,
    STATE(3127), 1,
      sym__reserved_identifier,
    STATE(8959), 1,
      sym_identifier,
    STATE(7308), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7335), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [313209] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7333), 1,
      sym__identifier_token,
    STATE(3127), 1,
      sym__reserved_identifier,
    STATE(7480), 1,
      sym_identifier,
    STATE(7309), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7335), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [313280] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7333), 1,
      sym__identifier_token,
    STATE(3127), 1,
      sym__reserved_identifier,
    STATE(7510), 1,
      sym_identifier,
    STATE(7310), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7335), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [313351] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7333), 1,
      sym__identifier_token,
    STATE(3127), 1,
      sym__reserved_identifier,
    STATE(7533), 1,
      sym_identifier,
    STATE(7311), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7335), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [313422] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7333), 1,
      sym__identifier_token,
    STATE(3127), 1,
      sym__reserved_identifier,
    STATE(8315), 1,
      sym_identifier,
    STATE(7312), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7335), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [313493] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7333), 1,
      sym__identifier_token,
    STATE(3127), 1,
      sym__reserved_identifier,
    STATE(7585), 1,
      sym_identifier,
    STATE(7313), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7335), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [313564] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(7452), 1,
      sym_identifier,
    STATE(7314), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [313635] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7333), 1,
      sym__identifier_token,
    STATE(3127), 1,
      sym__reserved_identifier,
    STATE(8231), 1,
      sym_identifier,
    STATE(7315), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7335), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [313706] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7333), 1,
      sym__identifier_token,
    STATE(3127), 1,
      sym__reserved_identifier,
    STATE(7513), 1,
      sym_identifier,
    STATE(7316), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7335), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [313777] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7333), 1,
      sym__identifier_token,
    STATE(3127), 1,
      sym__reserved_identifier,
    STATE(7484), 1,
      sym_identifier,
    STATE(7317), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7335), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [313848] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7333), 1,
      sym__identifier_token,
    STATE(3127), 1,
      sym__reserved_identifier,
    STATE(7511), 1,
      sym_identifier,
    STATE(7318), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7335), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [313919] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(8993), 1,
      sym_identifier,
    STATE(7319), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [313990] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(7466), 1,
      sym_identifier,
    STATE(7320), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [314061] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7333), 1,
      sym__identifier_token,
    STATE(3127), 1,
      sym__reserved_identifier,
    STATE(7495), 1,
      sym_identifier,
    STATE(7321), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7335), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [314132] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7333), 1,
      sym__identifier_token,
    STATE(3127), 1,
      sym__reserved_identifier,
    STATE(7566), 1,
      sym_identifier,
    STATE(7322), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7335), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [314203] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(7416), 1,
      sym_identifier,
    STATE(7323), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [314274] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7333), 1,
      sym__identifier_token,
    STATE(3127), 1,
      sym__reserved_identifier,
    STATE(7479), 1,
      sym_identifier,
    STATE(7324), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7335), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [314345] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(8213), 1,
      sym_identifier,
    STATE(7325), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [314416] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(7685), 1,
      sym_identifier,
    STATE(7326), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [314487] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7333), 1,
      sym__identifier_token,
    STATE(3127), 1,
      sym__reserved_identifier,
    STATE(7489), 1,
      sym_identifier,
    STATE(7327), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7335), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [314558] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(8339), 1,
      sym_identifier,
    STATE(7328), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [314629] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(8794), 1,
      sym_identifier,
    STATE(7329), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [314700] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7333), 1,
      sym__identifier_token,
    STATE(3127), 1,
      sym__reserved_identifier,
    STATE(9109), 1,
      sym_identifier,
    STATE(7330), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7335), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [314771] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7333), 1,
      sym__identifier_token,
    STATE(3127), 1,
      sym__reserved_identifier,
    STATE(7498), 1,
      sym_identifier,
    STATE(7331), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7335), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [314842] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(8523), 1,
      sym_identifier,
    STATE(7332), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [314913] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(8297), 1,
      sym_identifier,
    STATE(7333), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [314984] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7333), 1,
      sym__identifier_token,
    STATE(3127), 1,
      sym__reserved_identifier,
    STATE(7506), 1,
      sym_identifier,
    STATE(7334), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7335), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [315055] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(7436), 1,
      sym_identifier,
    STATE(7335), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [315126] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7333), 1,
      sym__identifier_token,
    STATE(3127), 1,
      sym__reserved_identifier,
    STATE(7587), 1,
      sym_identifier,
    STATE(7336), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7335), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [315197] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(8278), 1,
      sym_identifier,
    STATE(7337), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [315268] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(8272), 1,
      sym_identifier,
    STATE(7338), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [315339] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7333), 1,
      sym__identifier_token,
    STATE(3127), 1,
      sym__reserved_identifier,
    STATE(8240), 1,
      sym_identifier,
    STATE(7339), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7335), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [315410] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(8344), 1,
      sym_identifier,
    STATE(7340), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [315481] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7333), 1,
      sym__identifier_token,
    STATE(3127), 1,
      sym__reserved_identifier,
    STATE(7502), 1,
      sym_identifier,
    STATE(7341), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7335), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [315552] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(7453), 1,
      sym_identifier,
    STATE(7342), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [315623] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7333), 1,
      sym__identifier_token,
    STATE(3127), 1,
      sym__reserved_identifier,
    STATE(7499), 1,
      sym_identifier,
    STATE(7343), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7335), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [315694] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7333), 1,
      sym__identifier_token,
    STATE(3127), 1,
      sym__reserved_identifier,
    STATE(7500), 1,
      sym_identifier,
    STATE(7344), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7335), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [315765] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(8274), 1,
      sym_identifier,
    STATE(7345), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [315836] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7333), 1,
      sym__identifier_token,
    STATE(3127), 1,
      sym__reserved_identifier,
    STATE(7487), 1,
      sym_identifier,
    STATE(7346), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7335), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [315907] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(7441), 1,
      sym_identifier,
    STATE(7347), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [315978] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(8246), 1,
      sym_identifier,
    STATE(7348), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [316049] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(8326), 1,
      sym_identifier,
    STATE(7349), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [316120] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7333), 1,
      sym__identifier_token,
    STATE(3127), 1,
      sym__reserved_identifier,
    STATE(7488), 1,
      sym_identifier,
    STATE(7350), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7335), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [316191] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7333), 1,
      sym__identifier_token,
    STATE(3127), 1,
      sym__reserved_identifier,
    STATE(7481), 1,
      sym_identifier,
    STATE(7351), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7335), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [316262] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7333), 1,
      sym__identifier_token,
    STATE(3127), 1,
      sym__reserved_identifier,
    STATE(7599), 1,
      sym_identifier,
    STATE(7352), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7335), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [316333] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(9278), 1,
      sym_identifier,
    STATE(7353), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [316404] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7333), 1,
      sym__identifier_token,
    STATE(3127), 1,
      sym__reserved_identifier,
    STATE(7614), 1,
      sym_identifier,
    STATE(7354), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7335), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [316475] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7333), 1,
      sym__identifier_token,
    STATE(3127), 1,
      sym__reserved_identifier,
    STATE(7503), 1,
      sym_identifier,
    STATE(7355), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7335), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [316546] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7333), 1,
      sym__identifier_token,
    STATE(3127), 1,
      sym__reserved_identifier,
    STATE(8255), 1,
      sym_identifier,
    STATE(7356), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7335), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [316617] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7333), 1,
      sym__identifier_token,
    STATE(3127), 1,
      sym__reserved_identifier,
    STATE(7496), 1,
      sym_identifier,
    STATE(7357), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7335), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [316688] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7333), 1,
      sym__identifier_token,
    STATE(3127), 1,
      sym__reserved_identifier,
    STATE(7538), 1,
      sym_identifier,
    STATE(7358), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7335), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [316759] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(7467), 1,
      sym_identifier,
    STATE(7359), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [316830] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(8248), 1,
      sym_identifier,
    STATE(7360), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [316901] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2733), 1,
      sym__reserved_identifier,
    STATE(7445), 1,
      sym_identifier,
    STATE(7361), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [316972] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7333), 1,
      sym__identifier_token,
    STATE(3127), 1,
      sym__reserved_identifier,
    STATE(8337), 1,
      sym_identifier,
    STATE(7362), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7335), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [317043] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2983), 1,
      sym__identifier_token,
    STATE(4443), 1,
      sym__reserved_identifier,
    STATE(8834), 1,
      sym_identifier,
    STATE(7363), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2987), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [317114] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9537), 1,
      anon_sym_checked,
    ACTIONS(9535), 7,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    STATE(7364), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9539), 16,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_true,
      anon_sym_false,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [317182] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9543), 1,
      anon_sym_checked,
    ACTIONS(9541), 7,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    STATE(7365), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9545), 16,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_true,
      anon_sym_false,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [317250] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9549), 1,
      anon_sym_checked,
    ACTIONS(9547), 7,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    STATE(7366), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9551), 16,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_true,
      anon_sym_false,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [317318] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9555), 1,
      anon_sym_checked,
    ACTIONS(9553), 7,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    STATE(7367), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9557), 16,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_true,
      anon_sym_false,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [317386] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9561), 1,
      anon_sym_checked,
    ACTIONS(9559), 7,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    STATE(7368), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9563), 16,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_true,
      anon_sym_false,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [317454] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9567), 1,
      anon_sym_checked,
    ACTIONS(9565), 7,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    STATE(7369), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9569), 16,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_true,
      anon_sym_false,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [317522] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9559), 7,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    STATE(7370), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9563), 16,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_true,
      anon_sym_false,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [317587] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9571), 7,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    STATE(7371), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9573), 16,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_true,
      anon_sym_false,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [317652] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9547), 7,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    STATE(7372), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9551), 16,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_true,
      anon_sym_false,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [317717] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9575), 7,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    STATE(7373), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9577), 16,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_true,
      anon_sym_false,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [317782] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9565), 7,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    STATE(7374), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9569), 16,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_true,
      anon_sym_false,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [317847] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(7375), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9579), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [317910] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9581), 7,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    STATE(7376), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9583), 16,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_true,
      anon_sym_false,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [317975] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9585), 1,
      anon_sym_where,
    ACTIONS(9587), 1,
      anon_sym_from,
    ACTIONS(9589), 1,
      anon_sym_join,
    ACTIONS(9591), 1,
      anon_sym_let,
    ACTIONS(9593), 1,
      anon_sym_orderby,
    ACTIONS(9595), 1,
      anon_sym_group,
    ACTIONS(9597), 1,
      anon_sym_select,
    STATE(3616), 1,
      sym__query_body,
    STATE(4929), 1,
      sym__select_or_group_clause,
    STATE(7462), 1,
      aux_sym__query_body_repeat1,
    STATE(7735), 1,
      sym__query_clause,
    STATE(3649), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7709), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7377), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [318057] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9585), 1,
      anon_sym_where,
    ACTIONS(9587), 1,
      anon_sym_from,
    ACTIONS(9589), 1,
      anon_sym_join,
    ACTIONS(9591), 1,
      anon_sym_let,
    ACTIONS(9593), 1,
      anon_sym_orderby,
    ACTIONS(9599), 1,
      anon_sym_group,
    ACTIONS(9601), 1,
      anon_sym_select,
    STATE(3756), 1,
      sym__query_body,
    STATE(6397), 1,
      sym__select_or_group_clause,
    STATE(7449), 1,
      aux_sym__query_body_repeat1,
    STATE(7735), 1,
      sym__query_clause,
    STATE(3649), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7709), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7378), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [318139] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9585), 1,
      anon_sym_where,
    ACTIONS(9587), 1,
      anon_sym_from,
    ACTIONS(9589), 1,
      anon_sym_join,
    ACTIONS(9591), 1,
      anon_sym_let,
    ACTIONS(9593), 1,
      anon_sym_orderby,
    ACTIONS(9603), 1,
      anon_sym_group,
    ACTIONS(9605), 1,
      anon_sym_select,
    STATE(3959), 1,
      sym__query_body,
    STATE(6000), 1,
      sym__select_or_group_clause,
    STATE(7434), 1,
      aux_sym__query_body_repeat1,
    STATE(7735), 1,
      sym__query_clause,
    STATE(3988), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7709), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7379), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [318221] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9585), 1,
      anon_sym_where,
    ACTIONS(9587), 1,
      anon_sym_from,
    ACTIONS(9589), 1,
      anon_sym_join,
    ACTIONS(9591), 1,
      anon_sym_let,
    ACTIONS(9593), 1,
      anon_sym_orderby,
    ACTIONS(9607), 1,
      anon_sym_group,
    ACTIONS(9609), 1,
      anon_sym_select,
    STATE(4222), 1,
      sym__query_body,
    STATE(5188), 1,
      sym__select_or_group_clause,
    STATE(7420), 1,
      aux_sym__query_body_repeat1,
    STATE(7735), 1,
      sym__query_clause,
    STATE(3988), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7709), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7380), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [318303] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9585), 1,
      anon_sym_where,
    ACTIONS(9587), 1,
      anon_sym_from,
    ACTIONS(9589), 1,
      anon_sym_join,
    ACTIONS(9591), 1,
      anon_sym_let,
    ACTIONS(9593), 1,
      anon_sym_orderby,
    ACTIONS(9611), 1,
      anon_sym_group,
    ACTIONS(9613), 1,
      anon_sym_select,
    STATE(3616), 1,
      sym__query_body,
    STATE(5732), 1,
      sym__select_or_group_clause,
    STATE(7413), 1,
      aux_sym__query_body_repeat1,
    STATE(7735), 1,
      sym__query_clause,
    STATE(3649), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7709), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7381), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [318385] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9585), 1,
      anon_sym_where,
    ACTIONS(9587), 1,
      anon_sym_from,
    ACTIONS(9589), 1,
      anon_sym_join,
    ACTIONS(9591), 1,
      anon_sym_let,
    ACTIONS(9593), 1,
      anon_sym_orderby,
    ACTIONS(9615), 1,
      anon_sym_group,
    ACTIONS(9617), 1,
      anon_sym_select,
    STATE(4222), 1,
      sym__query_body,
    STATE(4626), 1,
      sym__select_or_group_clause,
    STATE(7446), 1,
      aux_sym__query_body_repeat1,
    STATE(7735), 1,
      sym__query_clause,
    STATE(3988), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7709), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7382), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [318467] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9585), 1,
      anon_sym_where,
    ACTIONS(9587), 1,
      anon_sym_from,
    ACTIONS(9589), 1,
      anon_sym_join,
    ACTIONS(9591), 1,
      anon_sym_let,
    ACTIONS(9593), 1,
      anon_sym_orderby,
    ACTIONS(9619), 1,
      anon_sym_group,
    ACTIONS(9621), 1,
      anon_sym_select,
    STATE(3616), 1,
      sym__query_body,
    STATE(6291), 1,
      sym__select_or_group_clause,
    STATE(7468), 1,
      aux_sym__query_body_repeat1,
    STATE(7735), 1,
      sym__query_clause,
    STATE(3649), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7709), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7383), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [318549] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9585), 1,
      anon_sym_where,
    ACTIONS(9587), 1,
      anon_sym_from,
    ACTIONS(9589), 1,
      anon_sym_join,
    ACTIONS(9591), 1,
      anon_sym_let,
    ACTIONS(9593), 1,
      anon_sym_orderby,
    ACTIONS(9623), 1,
      anon_sym_group,
    ACTIONS(9625), 1,
      anon_sym_select,
    STATE(3959), 1,
      sym__query_body,
    STATE(6045), 1,
      sym__select_or_group_clause,
    STATE(7447), 1,
      aux_sym__query_body_repeat1,
    STATE(7735), 1,
      sym__query_clause,
    STATE(3988), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7709), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7384), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [318631] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9585), 1,
      anon_sym_where,
    ACTIONS(9587), 1,
      anon_sym_from,
    ACTIONS(9589), 1,
      anon_sym_join,
    ACTIONS(9591), 1,
      anon_sym_let,
    ACTIONS(9593), 1,
      anon_sym_orderby,
    ACTIONS(9627), 1,
      anon_sym_group,
    ACTIONS(9629), 1,
      anon_sym_select,
    STATE(4510), 1,
      sym__select_or_group_clause,
    STATE(4574), 1,
      sym__query_body,
    STATE(7444), 1,
      aux_sym__query_body_repeat1,
    STATE(7735), 1,
      sym__query_clause,
    STATE(4575), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7709), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7385), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [318713] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9585), 1,
      anon_sym_where,
    ACTIONS(9587), 1,
      anon_sym_from,
    ACTIONS(9589), 1,
      anon_sym_join,
    ACTIONS(9591), 1,
      anon_sym_let,
    ACTIONS(9593), 1,
      anon_sym_orderby,
    ACTIONS(9631), 1,
      anon_sym_group,
    ACTIONS(9633), 1,
      anon_sym_select,
    STATE(3959), 1,
      sym__query_body,
    STATE(5661), 1,
      sym__select_or_group_clause,
    STATE(7456), 1,
      aux_sym__query_body_repeat1,
    STATE(7735), 1,
      sym__query_clause,
    STATE(3988), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7709), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7386), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [318795] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9585), 1,
      anon_sym_where,
    ACTIONS(9587), 1,
      anon_sym_from,
    ACTIONS(9589), 1,
      anon_sym_join,
    ACTIONS(9591), 1,
      anon_sym_let,
    ACTIONS(9593), 1,
      anon_sym_orderby,
    ACTIONS(9635), 1,
      anon_sym_group,
    ACTIONS(9637), 1,
      anon_sym_select,
    STATE(3756), 1,
      sym__query_body,
    STATE(4937), 1,
      sym__select_or_group_clause,
    STATE(7469), 1,
      aux_sym__query_body_repeat1,
    STATE(7735), 1,
      sym__query_clause,
    STATE(3649), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7709), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7387), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [318877] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9585), 1,
      anon_sym_where,
    ACTIONS(9587), 1,
      anon_sym_from,
    ACTIONS(9589), 1,
      anon_sym_join,
    ACTIONS(9591), 1,
      anon_sym_let,
    ACTIONS(9593), 1,
      anon_sym_orderby,
    ACTIONS(9631), 1,
      anon_sym_group,
    ACTIONS(9633), 1,
      anon_sym_select,
    STATE(4222), 1,
      sym__query_body,
    STATE(5661), 1,
      sym__select_or_group_clause,
    STATE(7456), 1,
      aux_sym__query_body_repeat1,
    STATE(7735), 1,
      sym__query_clause,
    STATE(3988), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7709), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7388), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [318959] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9585), 1,
      anon_sym_where,
    ACTIONS(9587), 1,
      anon_sym_from,
    ACTIONS(9589), 1,
      anon_sym_join,
    ACTIONS(9591), 1,
      anon_sym_let,
    ACTIONS(9593), 1,
      anon_sym_orderby,
    ACTIONS(9611), 1,
      anon_sym_group,
    ACTIONS(9613), 1,
      anon_sym_select,
    STATE(3756), 1,
      sym__query_body,
    STATE(5732), 1,
      sym__select_or_group_clause,
    STATE(7413), 1,
      aux_sym__query_body_repeat1,
    STATE(7735), 1,
      sym__query_clause,
    STATE(3649), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7709), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7389), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [319041] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9585), 1,
      anon_sym_where,
    ACTIONS(9587), 1,
      anon_sym_from,
    ACTIONS(9589), 1,
      anon_sym_join,
    ACTIONS(9591), 1,
      anon_sym_let,
    ACTIONS(9593), 1,
      anon_sym_orderby,
    ACTIONS(9639), 1,
      anon_sym_group,
    ACTIONS(9641), 1,
      anon_sym_select,
    STATE(3616), 1,
      sym__query_body,
    STATE(6340), 1,
      sym__select_or_group_clause,
    STATE(7427), 1,
      aux_sym__query_body_repeat1,
    STATE(7735), 1,
      sym__query_clause,
    STATE(3649), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7709), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7390), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [319123] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9585), 1,
      anon_sym_where,
    ACTIONS(9587), 1,
      anon_sym_from,
    ACTIONS(9589), 1,
      anon_sym_join,
    ACTIONS(9591), 1,
      anon_sym_let,
    ACTIONS(9593), 1,
      anon_sym_orderby,
    ACTIONS(9607), 1,
      anon_sym_group,
    ACTIONS(9609), 1,
      anon_sym_select,
    STATE(3959), 1,
      sym__query_body,
    STATE(5188), 1,
      sym__select_or_group_clause,
    STATE(7420), 1,
      aux_sym__query_body_repeat1,
    STATE(7735), 1,
      sym__query_clause,
    STATE(3988), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7709), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7391), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [319205] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9585), 1,
      anon_sym_where,
    ACTIONS(9587), 1,
      anon_sym_from,
    ACTIONS(9589), 1,
      anon_sym_join,
    ACTIONS(9591), 1,
      anon_sym_let,
    ACTIONS(9593), 1,
      anon_sym_orderby,
    ACTIONS(9643), 1,
      anon_sym_group,
    ACTIONS(9645), 1,
      anon_sym_select,
    STATE(4222), 1,
      sym__query_body,
    STATE(6025), 1,
      sym__select_or_group_clause,
    STATE(7432), 1,
      aux_sym__query_body_repeat1,
    STATE(7735), 1,
      sym__query_clause,
    STATE(3988), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7709), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7392), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [319287] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9585), 1,
      anon_sym_where,
    ACTIONS(9587), 1,
      anon_sym_from,
    ACTIONS(9589), 1,
      anon_sym_join,
    ACTIONS(9591), 1,
      anon_sym_let,
    ACTIONS(9593), 1,
      anon_sym_orderby,
    ACTIONS(9647), 1,
      anon_sym_group,
    ACTIONS(9649), 1,
      anon_sym_select,
    STATE(5719), 1,
      sym__query_body,
    STATE(5843), 1,
      sym__select_or_group_clause,
    STATE(7455), 1,
      aux_sym__query_body_repeat1,
    STATE(7735), 1,
      sym__query_clause,
    STATE(5717), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7709), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7393), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [319369] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9585), 1,
      anon_sym_where,
    ACTIONS(9587), 1,
      anon_sym_from,
    ACTIONS(9589), 1,
      anon_sym_join,
    ACTIONS(9591), 1,
      anon_sym_let,
    ACTIONS(9593), 1,
      anon_sym_orderby,
    ACTIONS(9651), 1,
      anon_sym_group,
    ACTIONS(9653), 1,
      anon_sym_select,
    STATE(4222), 1,
      sym__query_body,
    STATE(6036), 1,
      sym__select_or_group_clause,
    STATE(7465), 1,
      aux_sym__query_body_repeat1,
    STATE(7735), 1,
      sym__query_clause,
    STATE(3988), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7709), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7394), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [319451] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9585), 1,
      anon_sym_where,
    ACTIONS(9587), 1,
      anon_sym_from,
    ACTIONS(9589), 1,
      anon_sym_join,
    ACTIONS(9591), 1,
      anon_sym_let,
    ACTIONS(9593), 1,
      anon_sym_orderby,
    ACTIONS(9655), 1,
      anon_sym_group,
    ACTIONS(9657), 1,
      anon_sym_select,
    STATE(3756), 1,
      sym__query_body,
    STATE(5084), 1,
      sym__select_or_group_clause,
    STATE(7438), 1,
      aux_sym__query_body_repeat1,
    STATE(7735), 1,
      sym__query_clause,
    STATE(3649), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7709), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7395), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [319533] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9585), 1,
      anon_sym_where,
    ACTIONS(9587), 1,
      anon_sym_from,
    ACTIONS(9589), 1,
      anon_sym_join,
    ACTIONS(9591), 1,
      anon_sym_let,
    ACTIONS(9593), 1,
      anon_sym_orderby,
    ACTIONS(9643), 1,
      anon_sym_group,
    ACTIONS(9645), 1,
      anon_sym_select,
    STATE(3959), 1,
      sym__query_body,
    STATE(6025), 1,
      sym__select_or_group_clause,
    STATE(7432), 1,
      aux_sym__query_body_repeat1,
    STATE(7735), 1,
      sym__query_clause,
    STATE(3988), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7709), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7396), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [319615] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9585), 1,
      anon_sym_where,
    ACTIONS(9587), 1,
      anon_sym_from,
    ACTIONS(9589), 1,
      anon_sym_join,
    ACTIONS(9591), 1,
      anon_sym_let,
    ACTIONS(9593), 1,
      anon_sym_orderby,
    ACTIONS(9635), 1,
      anon_sym_group,
    ACTIONS(9637), 1,
      anon_sym_select,
    STATE(3616), 1,
      sym__query_body,
    STATE(4937), 1,
      sym__select_or_group_clause,
    STATE(7469), 1,
      aux_sym__query_body_repeat1,
    STATE(7735), 1,
      sym__query_clause,
    STATE(3649), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7709), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7397), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [319697] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9585), 1,
      anon_sym_where,
    ACTIONS(9587), 1,
      anon_sym_from,
    ACTIONS(9589), 1,
      anon_sym_join,
    ACTIONS(9591), 1,
      anon_sym_let,
    ACTIONS(9593), 1,
      anon_sym_orderby,
    ACTIONS(9639), 1,
      anon_sym_group,
    ACTIONS(9641), 1,
      anon_sym_select,
    STATE(3756), 1,
      sym__query_body,
    STATE(6340), 1,
      sym__select_or_group_clause,
    STATE(7427), 1,
      aux_sym__query_body_repeat1,
    STATE(7735), 1,
      sym__query_clause,
    STATE(3649), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7709), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7398), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [319779] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9585), 1,
      anon_sym_where,
    ACTIONS(9587), 1,
      anon_sym_from,
    ACTIONS(9589), 1,
      anon_sym_join,
    ACTIONS(9591), 1,
      anon_sym_let,
    ACTIONS(9593), 1,
      anon_sym_orderby,
    ACTIONS(9595), 1,
      anon_sym_group,
    ACTIONS(9597), 1,
      anon_sym_select,
    STATE(3756), 1,
      sym__query_body,
    STATE(4929), 1,
      sym__select_or_group_clause,
    STATE(7462), 1,
      aux_sym__query_body_repeat1,
    STATE(7735), 1,
      sym__query_clause,
    STATE(3649), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7709), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7399), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [319861] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9585), 1,
      anon_sym_where,
    ACTIONS(9587), 1,
      anon_sym_from,
    ACTIONS(9589), 1,
      anon_sym_join,
    ACTIONS(9591), 1,
      anon_sym_let,
    ACTIONS(9593), 1,
      anon_sym_orderby,
    ACTIONS(9659), 1,
      anon_sym_group,
    ACTIONS(9661), 1,
      anon_sym_select,
    STATE(5295), 1,
      sym__select_or_group_clause,
    STATE(5719), 1,
      sym__query_body,
    STATE(7418), 1,
      aux_sym__query_body_repeat1,
    STATE(7735), 1,
      sym__query_clause,
    STATE(5717), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7709), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7400), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [319943] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9585), 1,
      anon_sym_where,
    ACTIONS(9587), 1,
      anon_sym_from,
    ACTIONS(9589), 1,
      anon_sym_join,
    ACTIONS(9591), 1,
      anon_sym_let,
    ACTIONS(9593), 1,
      anon_sym_orderby,
    ACTIONS(9603), 1,
      anon_sym_group,
    ACTIONS(9605), 1,
      anon_sym_select,
    STATE(4222), 1,
      sym__query_body,
    STATE(6000), 1,
      sym__select_or_group_clause,
    STATE(7434), 1,
      aux_sym__query_body_repeat1,
    STATE(7735), 1,
      sym__query_clause,
    STATE(3988), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7709), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7401), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [320025] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9585), 1,
      anon_sym_where,
    ACTIONS(9587), 1,
      anon_sym_from,
    ACTIONS(9589), 1,
      anon_sym_join,
    ACTIONS(9591), 1,
      anon_sym_let,
    ACTIONS(9593), 1,
      anon_sym_orderby,
    ACTIONS(9623), 1,
      anon_sym_group,
    ACTIONS(9625), 1,
      anon_sym_select,
    STATE(4222), 1,
      sym__query_body,
    STATE(6045), 1,
      sym__select_or_group_clause,
    STATE(7447), 1,
      aux_sym__query_body_repeat1,
    STATE(7735), 1,
      sym__query_clause,
    STATE(3988), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7709), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7402), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [320107] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9585), 1,
      anon_sym_where,
    ACTIONS(9587), 1,
      anon_sym_from,
    ACTIONS(9589), 1,
      anon_sym_join,
    ACTIONS(9591), 1,
      anon_sym_let,
    ACTIONS(9593), 1,
      anon_sym_orderby,
    ACTIONS(9663), 1,
      anon_sym_group,
    ACTIONS(9665), 1,
      anon_sym_select,
    STATE(3756), 1,
      sym__query_body,
    STATE(6487), 1,
      sym__select_or_group_clause,
    STATE(7428), 1,
      aux_sym__query_body_repeat1,
    STATE(7735), 1,
      sym__query_clause,
    STATE(3649), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7709), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7403), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [320189] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9585), 1,
      anon_sym_where,
    ACTIONS(9587), 1,
      anon_sym_from,
    ACTIONS(9589), 1,
      anon_sym_join,
    ACTIONS(9591), 1,
      anon_sym_let,
    ACTIONS(9593), 1,
      anon_sym_orderby,
    ACTIONS(9599), 1,
      anon_sym_group,
    ACTIONS(9601), 1,
      anon_sym_select,
    STATE(3616), 1,
      sym__query_body,
    STATE(6397), 1,
      sym__select_or_group_clause,
    STATE(7449), 1,
      aux_sym__query_body_repeat1,
    STATE(7735), 1,
      sym__query_clause,
    STATE(3649), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7709), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7404), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [320271] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9585), 1,
      anon_sym_where,
    ACTIONS(9587), 1,
      anon_sym_from,
    ACTIONS(9589), 1,
      anon_sym_join,
    ACTIONS(9591), 1,
      anon_sym_let,
    ACTIONS(9593), 1,
      anon_sym_orderby,
    ACTIONS(9619), 1,
      anon_sym_group,
    ACTIONS(9621), 1,
      anon_sym_select,
    STATE(3756), 1,
      sym__query_body,
    STATE(6291), 1,
      sym__select_or_group_clause,
    STATE(7468), 1,
      aux_sym__query_body_repeat1,
    STATE(7735), 1,
      sym__query_clause,
    STATE(3649), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7709), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7405), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [320353] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9585), 1,
      anon_sym_where,
    ACTIONS(9587), 1,
      anon_sym_from,
    ACTIONS(9589), 1,
      anon_sym_join,
    ACTIONS(9591), 1,
      anon_sym_let,
    ACTIONS(9593), 1,
      anon_sym_orderby,
    ACTIONS(9667), 1,
      anon_sym_group,
    ACTIONS(9669), 1,
      anon_sym_select,
    STATE(4574), 1,
      sym__query_body,
    STATE(4838), 1,
      sym__select_or_group_clause,
    STATE(7472), 1,
      aux_sym__query_body_repeat1,
    STATE(7735), 1,
      sym__query_clause,
    STATE(4575), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7709), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7406), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [320435] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9585), 1,
      anon_sym_where,
    ACTIONS(9587), 1,
      anon_sym_from,
    ACTIONS(9589), 1,
      anon_sym_join,
    ACTIONS(9591), 1,
      anon_sym_let,
    ACTIONS(9593), 1,
      anon_sym_orderby,
    ACTIONS(9615), 1,
      anon_sym_group,
    ACTIONS(9617), 1,
      anon_sym_select,
    STATE(3959), 1,
      sym__query_body,
    STATE(4626), 1,
      sym__select_or_group_clause,
    STATE(7446), 1,
      aux_sym__query_body_repeat1,
    STATE(7735), 1,
      sym__query_clause,
    STATE(3988), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7709), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7407), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [320517] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9585), 1,
      anon_sym_where,
    ACTIONS(9587), 1,
      anon_sym_from,
    ACTIONS(9589), 1,
      anon_sym_join,
    ACTIONS(9591), 1,
      anon_sym_let,
    ACTIONS(9593), 1,
      anon_sym_orderby,
    ACTIONS(9655), 1,
      anon_sym_group,
    ACTIONS(9657), 1,
      anon_sym_select,
    STATE(3616), 1,
      sym__query_body,
    STATE(5084), 1,
      sym__select_or_group_clause,
    STATE(7438), 1,
      aux_sym__query_body_repeat1,
    STATE(7735), 1,
      sym__query_clause,
    STATE(3649), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7709), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7408), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [320599] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9585), 1,
      anon_sym_where,
    ACTIONS(9587), 1,
      anon_sym_from,
    ACTIONS(9589), 1,
      anon_sym_join,
    ACTIONS(9591), 1,
      anon_sym_let,
    ACTIONS(9593), 1,
      anon_sym_orderby,
    ACTIONS(9671), 1,
      anon_sym_group,
    ACTIONS(9673), 1,
      anon_sym_select,
    STATE(3959), 1,
      sym__query_body,
    STATE(5546), 1,
      sym__select_or_group_clause,
    STATE(7451), 1,
      aux_sym__query_body_repeat1,
    STATE(7735), 1,
      sym__query_clause,
    STATE(3988), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7709), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7409), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [320681] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9585), 1,
      anon_sym_where,
    ACTIONS(9587), 1,
      anon_sym_from,
    ACTIONS(9589), 1,
      anon_sym_join,
    ACTIONS(9591), 1,
      anon_sym_let,
    ACTIONS(9593), 1,
      anon_sym_orderby,
    ACTIONS(9663), 1,
      anon_sym_group,
    ACTIONS(9665), 1,
      anon_sym_select,
    STATE(3616), 1,
      sym__query_body,
    STATE(6487), 1,
      sym__select_or_group_clause,
    STATE(7428), 1,
      aux_sym__query_body_repeat1,
    STATE(7735), 1,
      sym__query_clause,
    STATE(3649), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7709), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7410), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [320763] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9585), 1,
      anon_sym_where,
    ACTIONS(9587), 1,
      anon_sym_from,
    ACTIONS(9589), 1,
      anon_sym_join,
    ACTIONS(9591), 1,
      anon_sym_let,
    ACTIONS(9593), 1,
      anon_sym_orderby,
    ACTIONS(9671), 1,
      anon_sym_group,
    ACTIONS(9673), 1,
      anon_sym_select,
    STATE(4222), 1,
      sym__query_body,
    STATE(5546), 1,
      sym__select_or_group_clause,
    STATE(7451), 1,
      aux_sym__query_body_repeat1,
    STATE(7735), 1,
      sym__query_clause,
    STATE(3988), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7709), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7411), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [320845] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9585), 1,
      anon_sym_where,
    ACTIONS(9587), 1,
      anon_sym_from,
    ACTIONS(9589), 1,
      anon_sym_join,
    ACTIONS(9591), 1,
      anon_sym_let,
    ACTIONS(9593), 1,
      anon_sym_orderby,
    ACTIONS(9651), 1,
      anon_sym_group,
    ACTIONS(9653), 1,
      anon_sym_select,
    STATE(3959), 1,
      sym__query_body,
    STATE(6036), 1,
      sym__select_or_group_clause,
    STATE(7465), 1,
      aux_sym__query_body_repeat1,
    STATE(7735), 1,
      sym__query_clause,
    STATE(3988), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7709), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7412), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [320927] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9585), 1,
      anon_sym_where,
    ACTIONS(9587), 1,
      anon_sym_from,
    ACTIONS(9589), 1,
      anon_sym_join,
    ACTIONS(9591), 1,
      anon_sym_let,
    ACTIONS(9593), 1,
      anon_sym_orderby,
    ACTIONS(9611), 1,
      anon_sym_group,
    ACTIONS(9613), 1,
      anon_sym_select,
    STATE(5393), 1,
      sym__select_or_group_clause,
    STATE(7476), 1,
      aux_sym__query_body_repeat1,
    STATE(7735), 1,
      sym__query_clause,
    STATE(3649), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7709), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7413), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [321006] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9585), 1,
      anon_sym_where,
    ACTIONS(9587), 1,
      anon_sym_from,
    ACTIONS(9589), 1,
      anon_sym_join,
    ACTIONS(9591), 1,
      anon_sym_let,
    ACTIONS(9593), 1,
      anon_sym_orderby,
    ACTIONS(9615), 1,
      anon_sym_group,
    ACTIONS(9617), 1,
      anon_sym_select,
    STATE(4006), 1,
      sym__select_or_group_clause,
    STATE(7429), 1,
      aux_sym__query_body_repeat1,
    STATE(7735), 1,
      sym__query_clause,
    STATE(3988), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7709), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7414), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [321085] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9585), 1,
      anon_sym_where,
    ACTIONS(9587), 1,
      anon_sym_from,
    ACTIONS(9589), 1,
      anon_sym_join,
    ACTIONS(9591), 1,
      anon_sym_let,
    ACTIONS(9593), 1,
      anon_sym_orderby,
    ACTIONS(9603), 1,
      anon_sym_group,
    ACTIONS(9605), 1,
      anon_sym_select,
    STATE(3990), 1,
      sym__select_or_group_clause,
    STATE(7476), 1,
      aux_sym__query_body_repeat1,
    STATE(7735), 1,
      sym__query_clause,
    STATE(3988), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7709), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7415), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [321164] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9585), 1,
      anon_sym_where,
    ACTIONS(9587), 1,
      anon_sym_from,
    ACTIONS(9589), 1,
      anon_sym_join,
    ACTIONS(9591), 1,
      anon_sym_let,
    ACTIONS(9593), 1,
      anon_sym_orderby,
    ACTIONS(9659), 1,
      anon_sym_group,
    ACTIONS(9661), 1,
      anon_sym_select,
    STATE(5516), 1,
      sym__select_or_group_clause,
    STATE(7417), 1,
      aux_sym__query_body_repeat1,
    STATE(7735), 1,
      sym__query_clause,
    STATE(5717), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7709), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7416), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [321243] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9585), 1,
      anon_sym_where,
    ACTIONS(9587), 1,
      anon_sym_from,
    ACTIONS(9589), 1,
      anon_sym_join,
    ACTIONS(9591), 1,
      anon_sym_let,
    ACTIONS(9593), 1,
      anon_sym_orderby,
    ACTIONS(9659), 1,
      anon_sym_group,
    ACTIONS(9661), 1,
      anon_sym_select,
    STATE(5463), 1,
      sym__select_or_group_clause,
    STATE(7476), 1,
      aux_sym__query_body_repeat1,
    STATE(7735), 1,
      sym__query_clause,
    STATE(5717), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7709), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7417), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [321322] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9585), 1,
      anon_sym_where,
    ACTIONS(9587), 1,
      anon_sym_from,
    ACTIONS(9589), 1,
      anon_sym_join,
    ACTIONS(9591), 1,
      anon_sym_let,
    ACTIONS(9593), 1,
      anon_sym_orderby,
    ACTIONS(9659), 1,
      anon_sym_group,
    ACTIONS(9661), 1,
      anon_sym_select,
    STATE(5224), 1,
      sym__select_or_group_clause,
    STATE(7476), 1,
      aux_sym__query_body_repeat1,
    STATE(7735), 1,
      sym__query_clause,
    STATE(5717), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7709), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7418), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [321401] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9585), 1,
      anon_sym_where,
    ACTIONS(9587), 1,
      anon_sym_from,
    ACTIONS(9589), 1,
      anon_sym_join,
    ACTIONS(9591), 1,
      anon_sym_let,
    ACTIONS(9593), 1,
      anon_sym_orderby,
    ACTIONS(9631), 1,
      anon_sym_group,
    ACTIONS(9633), 1,
      anon_sym_select,
    STATE(3990), 1,
      sym__select_or_group_clause,
    STATE(7476), 1,
      aux_sym__query_body_repeat1,
    STATE(7735), 1,
      sym__query_clause,
    STATE(3988), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7709), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7419), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [321480] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9585), 1,
      anon_sym_where,
    ACTIONS(9587), 1,
      anon_sym_from,
    ACTIONS(9589), 1,
      anon_sym_join,
    ACTIONS(9591), 1,
      anon_sym_let,
    ACTIONS(9593), 1,
      anon_sym_orderby,
    ACTIONS(9607), 1,
      anon_sym_group,
    ACTIONS(9609), 1,
      anon_sym_select,
    STATE(5190), 1,
      sym__select_or_group_clause,
    STATE(7476), 1,
      aux_sym__query_body_repeat1,
    STATE(7735), 1,
      sym__query_clause,
    STATE(3988), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7709), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7420), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [321559] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9585), 1,
      anon_sym_where,
    ACTIONS(9587), 1,
      anon_sym_from,
    ACTIONS(9589), 1,
      anon_sym_join,
    ACTIONS(9591), 1,
      anon_sym_let,
    ACTIONS(9593), 1,
      anon_sym_orderby,
    ACTIONS(9631), 1,
      anon_sym_group,
    ACTIONS(9633), 1,
      anon_sym_select,
    STATE(4006), 1,
      sym__select_or_group_clause,
    STATE(7419), 1,
      aux_sym__query_body_repeat1,
    STATE(7735), 1,
      sym__query_clause,
    STATE(3988), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7709), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7421), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [321638] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9585), 1,
      anon_sym_where,
    ACTIONS(9587), 1,
      anon_sym_from,
    ACTIONS(9589), 1,
      anon_sym_join,
    ACTIONS(9591), 1,
      anon_sym_let,
    ACTIONS(9593), 1,
      anon_sym_orderby,
    ACTIONS(9667), 1,
      anon_sym_group,
    ACTIONS(9669), 1,
      anon_sym_select,
    STATE(4597), 1,
      sym__select_or_group_clause,
    STATE(7476), 1,
      aux_sym__query_body_repeat1,
    STATE(7735), 1,
      sym__query_clause,
    STATE(4575), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7709), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7422), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [321717] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9585), 1,
      anon_sym_where,
    ACTIONS(9587), 1,
      anon_sym_from,
    ACTIONS(9589), 1,
      anon_sym_join,
    ACTIONS(9591), 1,
      anon_sym_let,
    ACTIONS(9593), 1,
      anon_sym_orderby,
    ACTIONS(9663), 1,
      anon_sym_group,
    ACTIONS(9665), 1,
      anon_sym_select,
    STATE(3659), 1,
      sym__select_or_group_clause,
    STATE(7476), 1,
      aux_sym__query_body_repeat1,
    STATE(7735), 1,
      sym__query_clause,
    STATE(3649), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7709), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7423), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [321796] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9585), 1,
      anon_sym_where,
    ACTIONS(9587), 1,
      anon_sym_from,
    ACTIONS(9589), 1,
      anon_sym_join,
    ACTIONS(9591), 1,
      anon_sym_let,
    ACTIONS(9593), 1,
      anon_sym_orderby,
    ACTIONS(9655), 1,
      anon_sym_group,
    ACTIONS(9657), 1,
      anon_sym_select,
    STATE(3659), 1,
      sym__select_or_group_clause,
    STATE(7476), 1,
      aux_sym__query_body_repeat1,
    STATE(7735), 1,
      sym__query_clause,
    STATE(3649), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7709), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7424), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [321875] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9585), 1,
      anon_sym_where,
    ACTIONS(9587), 1,
      anon_sym_from,
    ACTIONS(9589), 1,
      anon_sym_join,
    ACTIONS(9591), 1,
      anon_sym_let,
    ACTIONS(9593), 1,
      anon_sym_orderby,
    ACTIONS(9611), 1,
      anon_sym_group,
    ACTIONS(9613), 1,
      anon_sym_select,
    STATE(3659), 1,
      sym__select_or_group_clause,
    STATE(7476), 1,
      aux_sym__query_body_repeat1,
    STATE(7735), 1,
      sym__query_clause,
    STATE(3649), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7709), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7425), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [321954] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9585), 1,
      anon_sym_where,
    ACTIONS(9587), 1,
      anon_sym_from,
    ACTIONS(9589), 1,
      anon_sym_join,
    ACTIONS(9591), 1,
      anon_sym_let,
    ACTIONS(9593), 1,
      anon_sym_orderby,
    ACTIONS(9647), 1,
      anon_sym_group,
    ACTIONS(9649), 1,
      anon_sym_select,
    STATE(5463), 1,
      sym__select_or_group_clause,
    STATE(7476), 1,
      aux_sym__query_body_repeat1,
    STATE(7735), 1,
      sym__query_clause,
    STATE(5717), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7709), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7426), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [322033] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9585), 1,
      anon_sym_where,
    ACTIONS(9587), 1,
      anon_sym_from,
    ACTIONS(9589), 1,
      anon_sym_join,
    ACTIONS(9591), 1,
      anon_sym_let,
    ACTIONS(9593), 1,
      anon_sym_orderby,
    ACTIONS(9639), 1,
      anon_sym_group,
    ACTIONS(9641), 1,
      anon_sym_select,
    STATE(6520), 1,
      sym__select_or_group_clause,
    STATE(7476), 1,
      aux_sym__query_body_repeat1,
    STATE(7735), 1,
      sym__query_clause,
    STATE(3649), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7709), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7427), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [322112] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9585), 1,
      anon_sym_where,
    ACTIONS(9587), 1,
      anon_sym_from,
    ACTIONS(9589), 1,
      anon_sym_join,
    ACTIONS(9591), 1,
      anon_sym_let,
    ACTIONS(9593), 1,
      anon_sym_orderby,
    ACTIONS(9663), 1,
      anon_sym_group,
    ACTIONS(9665), 1,
      anon_sym_select,
    STATE(6395), 1,
      sym__select_or_group_clause,
    STATE(7476), 1,
      aux_sym__query_body_repeat1,
    STATE(7735), 1,
      sym__query_clause,
    STATE(3649), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7709), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7428), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [322191] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9585), 1,
      anon_sym_where,
    ACTIONS(9587), 1,
      anon_sym_from,
    ACTIONS(9589), 1,
      anon_sym_join,
    ACTIONS(9591), 1,
      anon_sym_let,
    ACTIONS(9593), 1,
      anon_sym_orderby,
    ACTIONS(9615), 1,
      anon_sym_group,
    ACTIONS(9617), 1,
      anon_sym_select,
    STATE(3990), 1,
      sym__select_or_group_clause,
    STATE(7476), 1,
      aux_sym__query_body_repeat1,
    STATE(7735), 1,
      sym__query_clause,
    STATE(3988), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7709), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7429), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [322270] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9585), 1,
      anon_sym_where,
    ACTIONS(9587), 1,
      anon_sym_from,
    ACTIONS(9589), 1,
      anon_sym_join,
    ACTIONS(9591), 1,
      anon_sym_let,
    ACTIONS(9593), 1,
      anon_sym_orderby,
    ACTIONS(9603), 1,
      anon_sym_group,
    ACTIONS(9605), 1,
      anon_sym_select,
    STATE(4006), 1,
      sym__select_or_group_clause,
    STATE(7415), 1,
      aux_sym__query_body_repeat1,
    STATE(7735), 1,
      sym__query_clause,
    STATE(3988), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7709), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7430), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [322349] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9585), 1,
      anon_sym_where,
    ACTIONS(9587), 1,
      anon_sym_from,
    ACTIONS(9589), 1,
      anon_sym_join,
    ACTIONS(9591), 1,
      anon_sym_let,
    ACTIONS(9593), 1,
      anon_sym_orderby,
    ACTIONS(9607), 1,
      anon_sym_group,
    ACTIONS(9609), 1,
      anon_sym_select,
    STATE(4006), 1,
      sym__select_or_group_clause,
    STATE(7439), 1,
      aux_sym__query_body_repeat1,
    STATE(7735), 1,
      sym__query_clause,
    STATE(3988), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7709), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7431), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [322428] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9585), 1,
      anon_sym_where,
    ACTIONS(9587), 1,
      anon_sym_from,
    ACTIONS(9589), 1,
      anon_sym_join,
    ACTIONS(9591), 1,
      anon_sym_let,
    ACTIONS(9593), 1,
      anon_sym_orderby,
    ACTIONS(9643), 1,
      anon_sym_group,
    ACTIONS(9645), 1,
      anon_sym_select,
    STATE(6029), 1,
      sym__select_or_group_clause,
    STATE(7476), 1,
      aux_sym__query_body_repeat1,
    STATE(7735), 1,
      sym__query_clause,
    STATE(3988), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7709), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7432), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [322507] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9585), 1,
      anon_sym_where,
    ACTIONS(9587), 1,
      anon_sym_from,
    ACTIONS(9589), 1,
      anon_sym_join,
    ACTIONS(9591), 1,
      anon_sym_let,
    ACTIONS(9593), 1,
      anon_sym_orderby,
    ACTIONS(9623), 1,
      anon_sym_group,
    ACTIONS(9625), 1,
      anon_sym_select,
    STATE(3990), 1,
      sym__select_or_group_clause,
    STATE(7476), 1,
      aux_sym__query_body_repeat1,
    STATE(7735), 1,
      sym__query_clause,
    STATE(3988), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7709), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7433), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [322586] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9585), 1,
      anon_sym_where,
    ACTIONS(9587), 1,
      anon_sym_from,
    ACTIONS(9589), 1,
      anon_sym_join,
    ACTIONS(9591), 1,
      anon_sym_let,
    ACTIONS(9593), 1,
      anon_sym_orderby,
    ACTIONS(9603), 1,
      anon_sym_group,
    ACTIONS(9605), 1,
      anon_sym_select,
    STATE(6010), 1,
      sym__select_or_group_clause,
    STATE(7476), 1,
      aux_sym__query_body_repeat1,
    STATE(7735), 1,
      sym__query_clause,
    STATE(3988), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7709), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7434), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [322665] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9585), 1,
      anon_sym_where,
    ACTIONS(9587), 1,
      anon_sym_from,
    ACTIONS(9589), 1,
      anon_sym_join,
    ACTIONS(9591), 1,
      anon_sym_let,
    ACTIONS(9593), 1,
      anon_sym_orderby,
    ACTIONS(9639), 1,
      anon_sym_group,
    ACTIONS(9641), 1,
      anon_sym_select,
    STATE(3659), 1,
      sym__select_or_group_clause,
    STATE(7476), 1,
      aux_sym__query_body_repeat1,
    STATE(7735), 1,
      sym__query_clause,
    STATE(3649), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7709), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7435), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [322744] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9585), 1,
      anon_sym_where,
    ACTIONS(9587), 1,
      anon_sym_from,
    ACTIONS(9589), 1,
      anon_sym_join,
    ACTIONS(9591), 1,
      anon_sym_let,
    ACTIONS(9593), 1,
      anon_sym_orderby,
    ACTIONS(9595), 1,
      anon_sym_group,
    ACTIONS(9597), 1,
      anon_sym_select,
    STATE(3626), 1,
      sym__select_or_group_clause,
    STATE(7460), 1,
      aux_sym__query_body_repeat1,
    STATE(7735), 1,
      sym__query_clause,
    STATE(3649), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7709), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7436), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [322823] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9585), 1,
      anon_sym_where,
    ACTIONS(9587), 1,
      anon_sym_from,
    ACTIONS(9589), 1,
      anon_sym_join,
    ACTIONS(9591), 1,
      anon_sym_let,
    ACTIONS(9593), 1,
      anon_sym_orderby,
    ACTIONS(9623), 1,
      anon_sym_group,
    ACTIONS(9625), 1,
      anon_sym_select,
    STATE(4006), 1,
      sym__select_or_group_clause,
    STATE(7433), 1,
      aux_sym__query_body_repeat1,
    STATE(7735), 1,
      sym__query_clause,
    STATE(3988), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7709), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7437), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [322902] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9585), 1,
      anon_sym_where,
    ACTIONS(9587), 1,
      anon_sym_from,
    ACTIONS(9589), 1,
      anon_sym_join,
    ACTIONS(9591), 1,
      anon_sym_let,
    ACTIONS(9593), 1,
      anon_sym_orderby,
    ACTIONS(9655), 1,
      anon_sym_group,
    ACTIONS(9657), 1,
      anon_sym_select,
    STATE(5077), 1,
      sym__select_or_group_clause,
    STATE(7476), 1,
      aux_sym__query_body_repeat1,
    STATE(7735), 1,
      sym__query_clause,
    STATE(3649), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7709), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7438), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [322981] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9585), 1,
      anon_sym_where,
    ACTIONS(9587), 1,
      anon_sym_from,
    ACTIONS(9589), 1,
      anon_sym_join,
    ACTIONS(9591), 1,
      anon_sym_let,
    ACTIONS(9593), 1,
      anon_sym_orderby,
    ACTIONS(9607), 1,
      anon_sym_group,
    ACTIONS(9609), 1,
      anon_sym_select,
    STATE(3990), 1,
      sym__select_or_group_clause,
    STATE(7476), 1,
      aux_sym__query_body_repeat1,
    STATE(7735), 1,
      sym__query_clause,
    STATE(3988), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7709), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7439), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [323060] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9585), 1,
      anon_sym_where,
    ACTIONS(9587), 1,
      anon_sym_from,
    ACTIONS(9589), 1,
      anon_sym_join,
    ACTIONS(9591), 1,
      anon_sym_let,
    ACTIONS(9593), 1,
      anon_sym_orderby,
    ACTIONS(9655), 1,
      anon_sym_group,
    ACTIONS(9657), 1,
      anon_sym_select,
    STATE(3626), 1,
      sym__select_or_group_clause,
    STATE(7424), 1,
      aux_sym__query_body_repeat1,
    STATE(7735), 1,
      sym__query_clause,
    STATE(3649), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7709), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7440), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [323139] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9585), 1,
      anon_sym_where,
    ACTIONS(9587), 1,
      anon_sym_from,
    ACTIONS(9589), 1,
      anon_sym_join,
    ACTIONS(9591), 1,
      anon_sym_let,
    ACTIONS(9593), 1,
      anon_sym_orderby,
    ACTIONS(9663), 1,
      anon_sym_group,
    ACTIONS(9665), 1,
      anon_sym_select,
    STATE(3626), 1,
      sym__select_or_group_clause,
    STATE(7423), 1,
      aux_sym__query_body_repeat1,
    STATE(7735), 1,
      sym__query_clause,
    STATE(3649), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7709), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7441), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [323218] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9585), 1,
      anon_sym_where,
    ACTIONS(9587), 1,
      anon_sym_from,
    ACTIONS(9589), 1,
      anon_sym_join,
    ACTIONS(9591), 1,
      anon_sym_let,
    ACTIONS(9593), 1,
      anon_sym_orderby,
    ACTIONS(9651), 1,
      anon_sym_group,
    ACTIONS(9653), 1,
      anon_sym_select,
    STATE(4006), 1,
      sym__select_or_group_clause,
    STATE(7471), 1,
      aux_sym__query_body_repeat1,
    STATE(7735), 1,
      sym__query_clause,
    STATE(3988), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7709), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7442), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [323297] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9585), 1,
      anon_sym_where,
    ACTIONS(9587), 1,
      anon_sym_from,
    ACTIONS(9589), 1,
      anon_sym_join,
    ACTIONS(9591), 1,
      anon_sym_let,
    ACTIONS(9593), 1,
      anon_sym_orderby,
    ACTIONS(9647), 1,
      anon_sym_group,
    ACTIONS(9649), 1,
      anon_sym_select,
    STATE(5516), 1,
      sym__select_or_group_clause,
    STATE(7426), 1,
      aux_sym__query_body_repeat1,
    STATE(7735), 1,
      sym__query_clause,
    STATE(5717), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7709), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7443), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [323376] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9585), 1,
      anon_sym_where,
    ACTIONS(9587), 1,
      anon_sym_from,
    ACTIONS(9589), 1,
      anon_sym_join,
    ACTIONS(9591), 1,
      anon_sym_let,
    ACTIONS(9593), 1,
      anon_sym_orderby,
    ACTIONS(9627), 1,
      anon_sym_group,
    ACTIONS(9629), 1,
      anon_sym_select,
    STATE(4476), 1,
      sym__select_or_group_clause,
    STATE(7476), 1,
      aux_sym__query_body_repeat1,
    STATE(7735), 1,
      sym__query_clause,
    STATE(4575), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7709), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7444), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [323455] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9585), 1,
      anon_sym_where,
    ACTIONS(9587), 1,
      anon_sym_from,
    ACTIONS(9589), 1,
      anon_sym_join,
    ACTIONS(9591), 1,
      anon_sym_let,
    ACTIONS(9593), 1,
      anon_sym_orderby,
    ACTIONS(9643), 1,
      anon_sym_group,
    ACTIONS(9645), 1,
      anon_sym_select,
    STATE(4006), 1,
      sym__select_or_group_clause,
    STATE(7448), 1,
      aux_sym__query_body_repeat1,
    STATE(7735), 1,
      sym__query_clause,
    STATE(3988), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7709), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7445), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [323534] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9585), 1,
      anon_sym_where,
    ACTIONS(9587), 1,
      anon_sym_from,
    ACTIONS(9589), 1,
      anon_sym_join,
    ACTIONS(9591), 1,
      anon_sym_let,
    ACTIONS(9593), 1,
      anon_sym_orderby,
    ACTIONS(9615), 1,
      anon_sym_group,
    ACTIONS(9617), 1,
      anon_sym_select,
    STATE(4711), 1,
      sym__select_or_group_clause,
    STATE(7476), 1,
      aux_sym__query_body_repeat1,
    STATE(7735), 1,
      sym__query_clause,
    STATE(3988), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7709), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7446), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [323613] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9585), 1,
      anon_sym_where,
    ACTIONS(9587), 1,
      anon_sym_from,
    ACTIONS(9589), 1,
      anon_sym_join,
    ACTIONS(9591), 1,
      anon_sym_let,
    ACTIONS(9593), 1,
      anon_sym_orderby,
    ACTIONS(9623), 1,
      anon_sym_group,
    ACTIONS(9625), 1,
      anon_sym_select,
    STATE(6050), 1,
      sym__select_or_group_clause,
    STATE(7476), 1,
      aux_sym__query_body_repeat1,
    STATE(7735), 1,
      sym__query_clause,
    STATE(3988), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7709), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7447), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [323692] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9585), 1,
      anon_sym_where,
    ACTIONS(9587), 1,
      anon_sym_from,
    ACTIONS(9589), 1,
      anon_sym_join,
    ACTIONS(9591), 1,
      anon_sym_let,
    ACTIONS(9593), 1,
      anon_sym_orderby,
    ACTIONS(9643), 1,
      anon_sym_group,
    ACTIONS(9645), 1,
      anon_sym_select,
    STATE(3990), 1,
      sym__select_or_group_clause,
    STATE(7476), 1,
      aux_sym__query_body_repeat1,
    STATE(7735), 1,
      sym__query_clause,
    STATE(3988), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7709), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7448), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [323771] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9585), 1,
      anon_sym_where,
    ACTIONS(9587), 1,
      anon_sym_from,
    ACTIONS(9589), 1,
      anon_sym_join,
    ACTIONS(9591), 1,
      anon_sym_let,
    ACTIONS(9593), 1,
      anon_sym_orderby,
    ACTIONS(9599), 1,
      anon_sym_group,
    ACTIONS(9601), 1,
      anon_sym_select,
    STATE(6599), 1,
      sym__select_or_group_clause,
    STATE(7476), 1,
      aux_sym__query_body_repeat1,
    STATE(7735), 1,
      sym__query_clause,
    STATE(3649), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7709), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7449), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [323850] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9585), 1,
      anon_sym_where,
    ACTIONS(9587), 1,
      anon_sym_from,
    ACTIONS(9589), 1,
      anon_sym_join,
    ACTIONS(9591), 1,
      anon_sym_let,
    ACTIONS(9593), 1,
      anon_sym_orderby,
    ACTIONS(9627), 1,
      anon_sym_group,
    ACTIONS(9629), 1,
      anon_sym_select,
    STATE(4669), 1,
      sym__select_or_group_clause,
    STATE(7454), 1,
      aux_sym__query_body_repeat1,
    STATE(7735), 1,
      sym__query_clause,
    STATE(4575), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7709), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7450), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [323929] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9585), 1,
      anon_sym_where,
    ACTIONS(9587), 1,
      anon_sym_from,
    ACTIONS(9589), 1,
      anon_sym_join,
    ACTIONS(9591), 1,
      anon_sym_let,
    ACTIONS(9593), 1,
      anon_sym_orderby,
    ACTIONS(9671), 1,
      anon_sym_group,
    ACTIONS(9673), 1,
      anon_sym_select,
    STATE(5512), 1,
      sym__select_or_group_clause,
    STATE(7476), 1,
      aux_sym__query_body_repeat1,
    STATE(7735), 1,
      sym__query_clause,
    STATE(3988), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7709), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7451), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [324008] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9585), 1,
      anon_sym_where,
    ACTIONS(9587), 1,
      anon_sym_from,
    ACTIONS(9589), 1,
      anon_sym_join,
    ACTIONS(9591), 1,
      anon_sym_let,
    ACTIONS(9593), 1,
      anon_sym_orderby,
    ACTIONS(9667), 1,
      anon_sym_group,
    ACTIONS(9669), 1,
      anon_sym_select,
    STATE(4669), 1,
      sym__select_or_group_clause,
    STATE(7422), 1,
      aux_sym__query_body_repeat1,
    STATE(7735), 1,
      sym__query_clause,
    STATE(4575), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7709), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7452), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [324087] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9585), 1,
      anon_sym_where,
    ACTIONS(9587), 1,
      anon_sym_from,
    ACTIONS(9589), 1,
      anon_sym_join,
    ACTIONS(9591), 1,
      anon_sym_let,
    ACTIONS(9593), 1,
      anon_sym_orderby,
    ACTIONS(9611), 1,
      anon_sym_group,
    ACTIONS(9613), 1,
      anon_sym_select,
    STATE(3626), 1,
      sym__select_or_group_clause,
    STATE(7425), 1,
      aux_sym__query_body_repeat1,
    STATE(7735), 1,
      sym__query_clause,
    STATE(3649), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7709), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7453), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [324166] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9585), 1,
      anon_sym_where,
    ACTIONS(9587), 1,
      anon_sym_from,
    ACTIONS(9589), 1,
      anon_sym_join,
    ACTIONS(9591), 1,
      anon_sym_let,
    ACTIONS(9593), 1,
      anon_sym_orderby,
    ACTIONS(9627), 1,
      anon_sym_group,
    ACTIONS(9629), 1,
      anon_sym_select,
    STATE(4597), 1,
      sym__select_or_group_clause,
    STATE(7476), 1,
      aux_sym__query_body_repeat1,
    STATE(7735), 1,
      sym__query_clause,
    STATE(4575), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7709), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7454), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [324245] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9585), 1,
      anon_sym_where,
    ACTIONS(9587), 1,
      anon_sym_from,
    ACTIONS(9589), 1,
      anon_sym_join,
    ACTIONS(9591), 1,
      anon_sym_let,
    ACTIONS(9593), 1,
      anon_sym_orderby,
    ACTIONS(9647), 1,
      anon_sym_group,
    ACTIONS(9649), 1,
      anon_sym_select,
    STATE(5915), 1,
      sym__select_or_group_clause,
    STATE(7476), 1,
      aux_sym__query_body_repeat1,
    STATE(7735), 1,
      sym__query_clause,
    STATE(5717), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7709), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7455), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [324324] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9585), 1,
      anon_sym_where,
    ACTIONS(9587), 1,
      anon_sym_from,
    ACTIONS(9589), 1,
      anon_sym_join,
    ACTIONS(9591), 1,
      anon_sym_let,
    ACTIONS(9593), 1,
      anon_sym_orderby,
    ACTIONS(9631), 1,
      anon_sym_group,
    ACTIONS(9633), 1,
      anon_sym_select,
    STATE(5658), 1,
      sym__select_or_group_clause,
    STATE(7476), 1,
      aux_sym__query_body_repeat1,
    STATE(7735), 1,
      sym__query_clause,
    STATE(3988), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7709), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7456), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [324403] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9585), 1,
      anon_sym_where,
    ACTIONS(9587), 1,
      anon_sym_from,
    ACTIONS(9589), 1,
      anon_sym_join,
    ACTIONS(9591), 1,
      anon_sym_let,
    ACTIONS(9593), 1,
      anon_sym_orderby,
    ACTIONS(9619), 1,
      anon_sym_group,
    ACTIONS(9621), 1,
      anon_sym_select,
    STATE(3659), 1,
      sym__select_or_group_clause,
    STATE(7476), 1,
      aux_sym__query_body_repeat1,
    STATE(7735), 1,
      sym__query_clause,
    STATE(3649), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7709), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7457), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [324482] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9585), 1,
      anon_sym_where,
    ACTIONS(9587), 1,
      anon_sym_from,
    ACTIONS(9589), 1,
      anon_sym_join,
    ACTIONS(9591), 1,
      anon_sym_let,
    ACTIONS(9593), 1,
      anon_sym_orderby,
    ACTIONS(9619), 1,
      anon_sym_group,
    ACTIONS(9621), 1,
      anon_sym_select,
    STATE(3626), 1,
      sym__select_or_group_clause,
    STATE(7457), 1,
      aux_sym__query_body_repeat1,
    STATE(7735), 1,
      sym__query_clause,
    STATE(3649), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7709), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7458), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [324561] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9585), 1,
      anon_sym_where,
    ACTIONS(9587), 1,
      anon_sym_from,
    ACTIONS(9589), 1,
      anon_sym_join,
    ACTIONS(9591), 1,
      anon_sym_let,
    ACTIONS(9593), 1,
      anon_sym_orderby,
    ACTIONS(9671), 1,
      anon_sym_group,
    ACTIONS(9673), 1,
      anon_sym_select,
    STATE(4006), 1,
      sym__select_or_group_clause,
    STATE(7464), 1,
      aux_sym__query_body_repeat1,
    STATE(7735), 1,
      sym__query_clause,
    STATE(3988), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7709), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7459), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [324640] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9585), 1,
      anon_sym_where,
    ACTIONS(9587), 1,
      anon_sym_from,
    ACTIONS(9589), 1,
      anon_sym_join,
    ACTIONS(9591), 1,
      anon_sym_let,
    ACTIONS(9593), 1,
      anon_sym_orderby,
    ACTIONS(9595), 1,
      anon_sym_group,
    ACTIONS(9597), 1,
      anon_sym_select,
    STATE(3659), 1,
      sym__select_or_group_clause,
    STATE(7476), 1,
      aux_sym__query_body_repeat1,
    STATE(7735), 1,
      sym__query_clause,
    STATE(3649), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7709), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7460), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [324719] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9585), 1,
      anon_sym_where,
    ACTIONS(9587), 1,
      anon_sym_from,
    ACTIONS(9589), 1,
      anon_sym_join,
    ACTIONS(9591), 1,
      anon_sym_let,
    ACTIONS(9593), 1,
      anon_sym_orderby,
    ACTIONS(9635), 1,
      anon_sym_group,
    ACTIONS(9637), 1,
      anon_sym_select,
    STATE(3659), 1,
      sym__select_or_group_clause,
    STATE(7476), 1,
      aux_sym__query_body_repeat1,
    STATE(7735), 1,
      sym__query_clause,
    STATE(3649), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7709), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7461), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [324798] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9585), 1,
      anon_sym_where,
    ACTIONS(9587), 1,
      anon_sym_from,
    ACTIONS(9589), 1,
      anon_sym_join,
    ACTIONS(9591), 1,
      anon_sym_let,
    ACTIONS(9593), 1,
      anon_sym_orderby,
    ACTIONS(9595), 1,
      anon_sym_group,
    ACTIONS(9597), 1,
      anon_sym_select,
    STATE(4939), 1,
      sym__select_or_group_clause,
    STATE(7476), 1,
      aux_sym__query_body_repeat1,
    STATE(7735), 1,
      sym__query_clause,
    STATE(3649), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7709), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7462), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [324877] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9585), 1,
      anon_sym_where,
    ACTIONS(9587), 1,
      anon_sym_from,
    ACTIONS(9589), 1,
      anon_sym_join,
    ACTIONS(9591), 1,
      anon_sym_let,
    ACTIONS(9593), 1,
      anon_sym_orderby,
    ACTIONS(9639), 1,
      anon_sym_group,
    ACTIONS(9641), 1,
      anon_sym_select,
    STATE(3626), 1,
      sym__select_or_group_clause,
    STATE(7435), 1,
      aux_sym__query_body_repeat1,
    STATE(7735), 1,
      sym__query_clause,
    STATE(3649), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7709), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7463), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [324956] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9585), 1,
      anon_sym_where,
    ACTIONS(9587), 1,
      anon_sym_from,
    ACTIONS(9589), 1,
      anon_sym_join,
    ACTIONS(9591), 1,
      anon_sym_let,
    ACTIONS(9593), 1,
      anon_sym_orderby,
    ACTIONS(9671), 1,
      anon_sym_group,
    ACTIONS(9673), 1,
      anon_sym_select,
    STATE(3990), 1,
      sym__select_or_group_clause,
    STATE(7476), 1,
      aux_sym__query_body_repeat1,
    STATE(7735), 1,
      sym__query_clause,
    STATE(3988), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7709), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7464), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [325035] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9585), 1,
      anon_sym_where,
    ACTIONS(9587), 1,
      anon_sym_from,
    ACTIONS(9589), 1,
      anon_sym_join,
    ACTIONS(9591), 1,
      anon_sym_let,
    ACTIONS(9593), 1,
      anon_sym_orderby,
    ACTIONS(9651), 1,
      anon_sym_group,
    ACTIONS(9653), 1,
      anon_sym_select,
    STATE(6041), 1,
      sym__select_or_group_clause,
    STATE(7476), 1,
      aux_sym__query_body_repeat1,
    STATE(7735), 1,
      sym__query_clause,
    STATE(3988), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7709), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7465), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [325114] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9585), 1,
      anon_sym_where,
    ACTIONS(9587), 1,
      anon_sym_from,
    ACTIONS(9589), 1,
      anon_sym_join,
    ACTIONS(9591), 1,
      anon_sym_let,
    ACTIONS(9593), 1,
      anon_sym_orderby,
    ACTIONS(9635), 1,
      anon_sym_group,
    ACTIONS(9637), 1,
      anon_sym_select,
    STATE(3626), 1,
      sym__select_or_group_clause,
    STATE(7461), 1,
      aux_sym__query_body_repeat1,
    STATE(7735), 1,
      sym__query_clause,
    STATE(3649), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7709), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7466), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [325193] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9585), 1,
      anon_sym_where,
    ACTIONS(9587), 1,
      anon_sym_from,
    ACTIONS(9589), 1,
      anon_sym_join,
    ACTIONS(9591), 1,
      anon_sym_let,
    ACTIONS(9593), 1,
      anon_sym_orderby,
    ACTIONS(9599), 1,
      anon_sym_group,
    ACTIONS(9601), 1,
      anon_sym_select,
    STATE(3626), 1,
      sym__select_or_group_clause,
    STATE(7470), 1,
      aux_sym__query_body_repeat1,
    STATE(7735), 1,
      sym__query_clause,
    STATE(3649), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7709), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7467), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [325272] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9585), 1,
      anon_sym_where,
    ACTIONS(9587), 1,
      anon_sym_from,
    ACTIONS(9589), 1,
      anon_sym_join,
    ACTIONS(9591), 1,
      anon_sym_let,
    ACTIONS(9593), 1,
      anon_sym_orderby,
    ACTIONS(9619), 1,
      anon_sym_group,
    ACTIONS(9621), 1,
      anon_sym_select,
    STATE(6429), 1,
      sym__select_or_group_clause,
    STATE(7476), 1,
      aux_sym__query_body_repeat1,
    STATE(7735), 1,
      sym__query_clause,
    STATE(3649), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7709), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7468), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [325351] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9585), 1,
      anon_sym_where,
    ACTIONS(9587), 1,
      anon_sym_from,
    ACTIONS(9589), 1,
      anon_sym_join,
    ACTIONS(9591), 1,
      anon_sym_let,
    ACTIONS(9593), 1,
      anon_sym_orderby,
    ACTIONS(9635), 1,
      anon_sym_group,
    ACTIONS(9637), 1,
      anon_sym_select,
    STATE(4947), 1,
      sym__select_or_group_clause,
    STATE(7476), 1,
      aux_sym__query_body_repeat1,
    STATE(7735), 1,
      sym__query_clause,
    STATE(3649), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7709), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7469), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [325430] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9585), 1,
      anon_sym_where,
    ACTIONS(9587), 1,
      anon_sym_from,
    ACTIONS(9589), 1,
      anon_sym_join,
    ACTIONS(9591), 1,
      anon_sym_let,
    ACTIONS(9593), 1,
      anon_sym_orderby,
    ACTIONS(9599), 1,
      anon_sym_group,
    ACTIONS(9601), 1,
      anon_sym_select,
    STATE(3659), 1,
      sym__select_or_group_clause,
    STATE(7476), 1,
      aux_sym__query_body_repeat1,
    STATE(7735), 1,
      sym__query_clause,
    STATE(3649), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7709), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7470), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [325509] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9585), 1,
      anon_sym_where,
    ACTIONS(9587), 1,
      anon_sym_from,
    ACTIONS(9589), 1,
      anon_sym_join,
    ACTIONS(9591), 1,
      anon_sym_let,
    ACTIONS(9593), 1,
      anon_sym_orderby,
    ACTIONS(9651), 1,
      anon_sym_group,
    ACTIONS(9653), 1,
      anon_sym_select,
    STATE(3990), 1,
      sym__select_or_group_clause,
    STATE(7476), 1,
      aux_sym__query_body_repeat1,
    STATE(7735), 1,
      sym__query_clause,
    STATE(3988), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7709), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7471), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [325588] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9585), 1,
      anon_sym_where,
    ACTIONS(9587), 1,
      anon_sym_from,
    ACTIONS(9589), 1,
      anon_sym_join,
    ACTIONS(9591), 1,
      anon_sym_let,
    ACTIONS(9593), 1,
      anon_sym_orderby,
    ACTIONS(9667), 1,
      anon_sym_group,
    ACTIONS(9669), 1,
      anon_sym_select,
    STATE(4854), 1,
      sym__select_or_group_clause,
    STATE(7476), 1,
      aux_sym__query_body_repeat1,
    STATE(7735), 1,
      sym__query_clause,
    STATE(4575), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7709), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7472), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [325667] = 25,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4076), 1,
      anon_sym_DOT,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(7394), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9677), 1,
      anon_sym_EQ,
    ACTIONS(9679), 1,
      anon_sym_LBRACE,
    ACTIONS(9681), 1,
      anon_sym_LT,
    ACTIONS(9683), 1,
      anon_sym_EQ_GT,
    STATE(2736), 1,
      sym_type_argument_list,
    STATE(3211), 1,
      sym_accessor_list,
    STATE(7547), 1,
      sym_parameter_list,
    STATE(8545), 1,
      sym_bracketed_argument_list,
    STATE(8681), 1,
      sym_type_parameter_list,
    STATE(9922), 1,
      sym_arrow_expression_clause,
    ACTIONS(9675), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(7473), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [325751] = 25,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4076), 1,
      anon_sym_DOT,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(7394), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9677), 1,
      anon_sym_EQ,
    ACTIONS(9679), 1,
      anon_sym_LBRACE,
    ACTIONS(9681), 1,
      anon_sym_LT,
    ACTIONS(9683), 1,
      anon_sym_EQ_GT,
    STATE(2736), 1,
      sym_type_argument_list,
    STATE(3208), 1,
      sym_accessor_list,
    STATE(7576), 1,
      sym_parameter_list,
    STATE(8545), 1,
      sym_bracketed_argument_list,
    STATE(8869), 1,
      sym_type_parameter_list,
    STATE(9458), 1,
      sym_arrow_expression_clause,
    ACTIONS(9675), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(7474), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [325835] = 25,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4076), 1,
      anon_sym_DOT,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(7394), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9677), 1,
      anon_sym_EQ,
    ACTIONS(9679), 1,
      anon_sym_LBRACE,
    ACTIONS(9681), 1,
      anon_sym_LT,
    ACTIONS(9683), 1,
      anon_sym_EQ_GT,
    STATE(2736), 1,
      sym_type_argument_list,
    STATE(3176), 1,
      sym_accessor_list,
    STATE(7637), 1,
      sym_parameter_list,
    STATE(8545), 1,
      sym_bracketed_argument_list,
    STATE(8788), 1,
      sym_type_parameter_list,
    STATE(9681), 1,
      sym_arrow_expression_clause,
    ACTIONS(9675), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(7475), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [325919] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9685), 1,
      anon_sym_where,
    ACTIONS(9688), 1,
      anon_sym_from,
    ACTIONS(9691), 1,
      anon_sym_join,
    ACTIONS(9694), 1,
      anon_sym_let,
    ACTIONS(9697), 1,
      anon_sym_orderby,
    STATE(7735), 1,
      sym__query_clause,
    ACTIONS(9700), 2,
      anon_sym_group,
      anon_sym_select,
    STATE(7709), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7476), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym__query_body_repeat1,
  [325987] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9702), 1,
      anon_sym_SEMI,
    ACTIONS(9704), 1,
      anon_sym_COLON,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9708), 1,
      anon_sym_LT,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7529), 1,
      sym_type_parameter_list,
    STATE(7642), 1,
      sym_parameter_list,
    STATE(7830), 1,
      sym_record_base,
    STATE(7833), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9225), 1,
      sym_declaration_list,
    STATE(7477), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [326061] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9704), 1,
      anon_sym_COLON,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9708), 1,
      anon_sym_LT,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9712), 1,
      anon_sym_SEMI,
    STATE(7526), 1,
      sym_type_parameter_list,
    STATE(7648), 1,
      sym_parameter_list,
    STATE(7745), 1,
      aux_sym_class_declaration_repeat3,
    STATE(7821), 1,
      sym_record_base,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9041), 1,
      sym_declaration_list,
    STATE(7478), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [326135] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9704), 1,
      anon_sym_COLON,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9708), 1,
      anon_sym_LT,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9714), 1,
      anon_sym_SEMI,
    STATE(7518), 1,
      sym_type_parameter_list,
    STATE(7656), 1,
      sym_parameter_list,
    STATE(7808), 1,
      aux_sym_class_declaration_repeat3,
    STATE(7814), 1,
      sym_record_base,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(8968), 1,
      sym_declaration_list,
    STATE(7479), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [326209] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9704), 1,
      anon_sym_COLON,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9708), 1,
      anon_sym_LT,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9716), 1,
      anon_sym_SEMI,
    STATE(7520), 1,
      sym_type_parameter_list,
    STATE(7651), 1,
      sym_parameter_list,
    STATE(7744), 1,
      sym_record_base,
    STATE(7799), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9643), 1,
      sym_declaration_list,
    STATE(7480), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [326283] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9704), 1,
      anon_sym_COLON,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9708), 1,
      anon_sym_LT,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9718), 1,
      anon_sym_SEMI,
    STATE(7528), 1,
      sym_type_parameter_list,
    STATE(7657), 1,
      sym_parameter_list,
    STATE(7817), 1,
      aux_sym_class_declaration_repeat3,
    STATE(7825), 1,
      sym_record_base,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9378), 1,
      sym_declaration_list,
    STATE(7481), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [326357] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9704), 1,
      anon_sym_COLON,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9708), 1,
      anon_sym_LT,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9720), 1,
      anon_sym_SEMI,
    STATE(7524), 1,
      sym_type_parameter_list,
    STATE(7645), 1,
      sym_parameter_list,
    STATE(7753), 1,
      aux_sym_class_declaration_repeat3,
    STATE(7757), 1,
      sym_record_base,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9606), 1,
      sym_declaration_list,
    STATE(7482), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [326431] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9704), 1,
      anon_sym_COLON,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9708), 1,
      anon_sym_LT,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9722), 1,
      anon_sym_SEMI,
    STATE(7523), 1,
      sym_type_parameter_list,
    STATE(7665), 1,
      sym_parameter_list,
    STATE(7858), 1,
      aux_sym_class_declaration_repeat3,
    STATE(7866), 1,
      sym_record_base,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9490), 1,
      sym_declaration_list,
    STATE(7483), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [326505] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9704), 1,
      anon_sym_COLON,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9708), 1,
      anon_sym_LT,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9724), 1,
      anon_sym_SEMI,
    STATE(7517), 1,
      sym_type_parameter_list,
    STATE(7663), 1,
      sym_parameter_list,
    STATE(7853), 1,
      sym_record_base,
    STATE(7906), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9135), 1,
      sym_declaration_list,
    STATE(7484), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [326579] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9704), 1,
      anon_sym_COLON,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9708), 1,
      anon_sym_LT,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9726), 1,
      anon_sym_SEMI,
    STATE(7519), 1,
      sym_type_parameter_list,
    STATE(7664), 1,
      sym_parameter_list,
    STATE(7823), 1,
      sym_record_base,
    STATE(7856), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9367), 1,
      sym_declaration_list,
    STATE(7485), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [326653] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9704), 1,
      anon_sym_COLON,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9708), 1,
      anon_sym_LT,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9728), 1,
      anon_sym_SEMI,
    STATE(7514), 1,
      sym_type_parameter_list,
    STATE(7644), 1,
      sym_parameter_list,
    STATE(7873), 1,
      sym_record_base,
    STATE(7912), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9837), 1,
      sym_declaration_list,
    STATE(7486), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [326727] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9704), 1,
      anon_sym_COLON,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9708), 1,
      anon_sym_LT,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9730), 1,
      anon_sym_SEMI,
    STATE(7525), 1,
      sym_type_parameter_list,
    STATE(7662), 1,
      sym_parameter_list,
    STATE(7816), 1,
      sym_record_base,
    STATE(7837), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9364), 1,
      sym_declaration_list,
    STATE(7487), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [326801] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9704), 1,
      anon_sym_COLON,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9708), 1,
      anon_sym_LT,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9732), 1,
      anon_sym_SEMI,
    STATE(7522), 1,
      sym_type_parameter_list,
    STATE(7660), 1,
      sym_parameter_list,
    STATE(7891), 1,
      sym_record_base,
    STATE(7894), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9064), 1,
      sym_declaration_list,
    STATE(7488), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [326875] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9708), 1,
      anon_sym_LT,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9734), 1,
      anon_sym_COLON,
    STATE(7623), 1,
      sym_type_parameter_list,
    STATE(7715), 1,
      sym_parameter_list,
    STATE(8127), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8132), 1,
      sym_base_list,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9463), 1,
      sym_declaration_list,
    STATE(7489), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [326946] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9736), 5,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_where,
      anon_sym_EQ_GT,
    ACTIONS(3719), 6,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
    STATE(7490), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [326999] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9708), 1,
      anon_sym_LT,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9734), 1,
      anon_sym_COLON,
    STATE(7532), 1,
      sym_type_parameter_list,
    STATE(7737), 1,
      sym_parameter_list,
    STATE(7916), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8079), 1,
      sym_base_list,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9018), 1,
      sym_declaration_list,
    STATE(7491), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [327070] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9708), 1,
      anon_sym_LT,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9734), 1,
      anon_sym_COLON,
    STATE(7594), 1,
      sym_type_parameter_list,
    STATE(7692), 1,
      sym_parameter_list,
    STATE(8116), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8117), 1,
      sym_base_list,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9807), 1,
      sym_declaration_list,
    STATE(7492), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [327141] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4076), 1,
      anon_sym_DOT,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(7248), 1,
      anon_sym_LT,
    ACTIONS(7394), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9675), 1,
      anon_sym_COMMA,
    ACTIONS(9679), 1,
      anon_sym_LBRACE,
    ACTIONS(9739), 1,
      anon_sym_SEMI,
    ACTIONS(9742), 1,
      anon_sym_EQ,
    STATE(2736), 1,
      sym_type_argument_list,
    STATE(3508), 1,
      sym_accessor_list,
    STATE(8545), 1,
      sym_bracketed_argument_list,
    STATE(7493), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [327212] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4076), 1,
      anon_sym_DOT,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(7248), 1,
      anon_sym_LT,
    ACTIONS(7394), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9675), 1,
      anon_sym_COMMA,
    ACTIONS(9679), 1,
      anon_sym_LBRACE,
    ACTIONS(9742), 1,
      anon_sym_EQ,
    ACTIONS(9744), 1,
      anon_sym_SEMI,
    STATE(2736), 1,
      sym_type_argument_list,
    STATE(3343), 1,
      sym_accessor_list,
    STATE(8545), 1,
      sym_bracketed_argument_list,
    STATE(7494), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [327283] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9708), 1,
      anon_sym_LT,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9734), 1,
      anon_sym_COLON,
    STATE(7558), 1,
      sym_type_parameter_list,
    STATE(7695), 1,
      sym_parameter_list,
    STATE(7962), 1,
      sym_base_list,
    STATE(7964), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9255), 1,
      sym_declaration_list,
    STATE(7495), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [327354] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9708), 1,
      anon_sym_LT,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9734), 1,
      anon_sym_COLON,
    STATE(7593), 1,
      sym_type_parameter_list,
    STATE(7730), 1,
      sym_parameter_list,
    STATE(8192), 1,
      sym_base_list,
    STATE(8199), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9450), 1,
      sym_declaration_list,
    STATE(7496), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [327425] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9708), 1,
      anon_sym_LT,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9734), 1,
      anon_sym_COLON,
    STATE(7563), 1,
      sym_type_parameter_list,
    STATE(7704), 1,
      sym_parameter_list,
    STATE(7973), 1,
      aux_sym_class_declaration_repeat3,
    STATE(7974), 1,
      sym_base_list,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9245), 1,
      sym_declaration_list,
    STATE(7497), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [327496] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9708), 1,
      anon_sym_LT,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9734), 1,
      anon_sym_COLON,
    STATE(7600), 1,
      sym_type_parameter_list,
    STATE(7741), 1,
      sym_parameter_list,
    STATE(8077), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8130), 1,
      sym_base_list,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9620), 1,
      sym_declaration_list,
    STATE(7498), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [327567] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9708), 1,
      anon_sym_LT,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9734), 1,
      anon_sym_COLON,
    STATE(7540), 1,
      sym_type_parameter_list,
    STATE(7680), 1,
      sym_parameter_list,
    STATE(7942), 1,
      aux_sym_class_declaration_repeat3,
    STATE(7943), 1,
      sym_base_list,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9088), 1,
      sym_declaration_list,
    STATE(7499), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [327638] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9708), 1,
      anon_sym_LT,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9734), 1,
      anon_sym_COLON,
    STATE(7536), 1,
      sym_type_parameter_list,
    STATE(7722), 1,
      sym_parameter_list,
    STATE(8051), 1,
      sym_base_list,
    STATE(8064), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9525), 1,
      sym_declaration_list,
    STATE(7500), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [327709] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9708), 1,
      anon_sym_LT,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9734), 1,
      anon_sym_COLON,
    STATE(7548), 1,
      sym_type_parameter_list,
    STATE(7684), 1,
      sym_parameter_list,
    STATE(7954), 1,
      aux_sym_class_declaration_repeat3,
    STATE(7955), 1,
      sym_base_list,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9115), 1,
      sym_declaration_list,
    STATE(7501), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [327780] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9708), 1,
      anon_sym_LT,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9734), 1,
      anon_sym_COLON,
    STATE(7534), 1,
      sym_type_parameter_list,
    STATE(7708), 1,
      sym_parameter_list,
    STATE(8070), 1,
      sym_base_list,
    STATE(8075), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9524), 1,
      sym_declaration_list,
    STATE(7502), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [327851] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9708), 1,
      anon_sym_LT,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9734), 1,
      anon_sym_COLON,
    STATE(7564), 1,
      sym_type_parameter_list,
    STATE(7675), 1,
      sym_parameter_list,
    STATE(7975), 1,
      sym_base_list,
    STATE(7977), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9379), 1,
      sym_declaration_list,
    STATE(7503), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [327922] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9708), 1,
      anon_sym_LT,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9734), 1,
      anon_sym_COLON,
    STATE(7601), 1,
      sym_type_parameter_list,
    STATE(7734), 1,
      sym_parameter_list,
    STATE(8020), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8022), 1,
      sym_base_list,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9043), 1,
      sym_declaration_list,
    STATE(7504), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [327993] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9708), 1,
      anon_sym_LT,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9734), 1,
      anon_sym_COLON,
    STATE(7541), 1,
      sym_type_parameter_list,
    STATE(7686), 1,
      sym_parameter_list,
    STATE(8088), 1,
      sym_base_list,
    STATE(8092), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9284), 1,
      sym_declaration_list,
    STATE(7505), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [328064] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9708), 1,
      anon_sym_LT,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9734), 1,
      anon_sym_COLON,
    STATE(7542), 1,
      sym_type_parameter_list,
    STATE(7681), 1,
      sym_parameter_list,
    STATE(8148), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8150), 1,
      sym_base_list,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9455), 1,
      sym_declaration_list,
    STATE(7506), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [328135] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9708), 1,
      anon_sym_LT,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9734), 1,
      anon_sym_COLON,
    STATE(7591), 1,
      sym_type_parameter_list,
    STATE(7736), 1,
      sym_parameter_list,
    STATE(8009), 1,
      sym_base_list,
    STATE(8011), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9538), 1,
      sym_declaration_list,
    STATE(7507), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [328206] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9708), 1,
      anon_sym_LT,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9734), 1,
      anon_sym_COLON,
    STATE(7621), 1,
      sym_type_parameter_list,
    STATE(7702), 1,
      sym_parameter_list,
    STATE(8036), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8046), 1,
      sym_base_list,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9031), 1,
      sym_declaration_list,
    STATE(7508), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [328277] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9708), 1,
      anon_sym_LT,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9734), 1,
      anon_sym_COLON,
    STATE(7617), 1,
      sym_type_parameter_list,
    STATE(7700), 1,
      sym_parameter_list,
    STATE(8087), 1,
      sym_base_list,
    STATE(8089), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9645), 1,
      sym_declaration_list,
    STATE(7509), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [328348] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9708), 1,
      anon_sym_LT,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9734), 1,
      anon_sym_COLON,
    STATE(7560), 1,
      sym_type_parameter_list,
    STATE(7698), 1,
      sym_parameter_list,
    STATE(7971), 1,
      aux_sym_class_declaration_repeat3,
    STATE(7972), 1,
      sym_base_list,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9244), 1,
      sym_declaration_list,
    STATE(7510), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [328419] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9708), 1,
      anon_sym_LT,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9734), 1,
      anon_sym_COLON,
    STATE(7590), 1,
      sym_type_parameter_list,
    STATE(7728), 1,
      sym_parameter_list,
    STATE(8203), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8205), 1,
      sym_base_list,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9402), 1,
      sym_declaration_list,
    STATE(7511), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [328490] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4076), 1,
      anon_sym_DOT,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(7248), 1,
      anon_sym_LT,
    ACTIONS(7394), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9675), 1,
      anon_sym_COMMA,
    ACTIONS(9679), 1,
      anon_sym_LBRACE,
    ACTIONS(9742), 1,
      anon_sym_EQ,
    ACTIONS(9747), 1,
      anon_sym_SEMI,
    STATE(2736), 1,
      sym_type_argument_list,
    STATE(3384), 1,
      sym_accessor_list,
    STATE(8545), 1,
      sym_bracketed_argument_list,
    STATE(7512), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [328561] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9708), 1,
      anon_sym_LT,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9734), 1,
      anon_sym_COLON,
    STATE(7616), 1,
      sym_type_parameter_list,
    STATE(7705), 1,
      sym_parameter_list,
    STATE(8096), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8101), 1,
      sym_base_list,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(8984), 1,
      sym_declaration_list,
    STATE(7513), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [328632] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9704), 1,
      anon_sym_COLON,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9750), 1,
      anon_sym_SEMI,
    STATE(7671), 1,
      sym_parameter_list,
    STATE(7880), 1,
      sym_record_base,
    STATE(7881), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9674), 1,
      sym_declaration_list,
    STATE(7514), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [328700] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4081), 1,
      anon_sym_EQ_GT,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9677), 1,
      anon_sym_EQ,
    ACTIONS(9708), 1,
      anon_sym_LT,
    STATE(7626), 1,
      sym_parameter_list,
    STATE(8545), 1,
      sym_bracketed_argument_list,
    STATE(8676), 1,
      sym_type_parameter_list,
    ACTIONS(9675), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(7515), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [328766] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4081), 1,
      anon_sym_EQ_GT,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9677), 1,
      anon_sym_EQ,
    ACTIONS(9708), 1,
      anon_sym_LT,
    STATE(7608), 1,
      sym_parameter_list,
    STATE(8545), 1,
      sym_bracketed_argument_list,
    STATE(8935), 1,
      sym_type_parameter_list,
    ACTIONS(9675), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(7516), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [328832] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9704), 1,
      anon_sym_COLON,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9752), 1,
      anon_sym_SEMI,
    STATE(7666), 1,
      sym_parameter_list,
    STATE(7751), 1,
      aux_sym_class_declaration_repeat3,
    STATE(7834), 1,
      sym_record_base,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9271), 1,
      sym_declaration_list,
    STATE(7517), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [328900] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9704), 1,
      anon_sym_COLON,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9754), 1,
      anon_sym_SEMI,
    STATE(7672), 1,
      sym_parameter_list,
    STATE(7884), 1,
      sym_record_base,
    STATE(7888), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9013), 1,
      sym_declaration_list,
    STATE(7518), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [328968] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9704), 1,
      anon_sym_COLON,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9756), 1,
      anon_sym_SEMI,
    STATE(7646), 1,
      sym_parameter_list,
    STATE(7769), 1,
      sym_record_base,
    STATE(7773), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(8970), 1,
      sym_declaration_list,
    STATE(7519), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [329036] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9704), 1,
      anon_sym_COLON,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9758), 1,
      anon_sym_SEMI,
    STATE(7652), 1,
      sym_parameter_list,
    STATE(7778), 1,
      sym_record_base,
    STATE(7803), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9805), 1,
      sym_declaration_list,
    STATE(7520), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [329104] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4081), 1,
      anon_sym_EQ_GT,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9677), 1,
      anon_sym_EQ,
    ACTIONS(9708), 1,
      anon_sym_LT,
    STATE(7622), 1,
      sym_parameter_list,
    STATE(8545), 1,
      sym_bracketed_argument_list,
    STATE(8928), 1,
      sym_type_parameter_list,
    ACTIONS(9675), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(7521), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [329170] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9704), 1,
      anon_sym_COLON,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9760), 1,
      anon_sym_SEMI,
    STATE(7673), 1,
      sym_parameter_list,
    STATE(7876), 1,
      sym_record_base,
    STATE(7878), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(8974), 1,
      sym_declaration_list,
    STATE(7522), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [329238] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9704), 1,
      anon_sym_COLON,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9762), 1,
      anon_sym_SEMI,
    STATE(7647), 1,
      sym_parameter_list,
    STATE(7812), 1,
      sym_record_base,
    STATE(7890), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9371), 1,
      sym_declaration_list,
    STATE(7523), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [329306] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9704), 1,
      anon_sym_COLON,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9764), 1,
      anon_sym_SEMI,
    STATE(7641), 1,
      sym_parameter_list,
    STATE(7776), 1,
      sym_record_base,
    STATE(7827), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9711), 1,
      sym_declaration_list,
    STATE(7524), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [329374] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9704), 1,
      anon_sym_COLON,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9766), 1,
      anon_sym_SEMI,
    STATE(7667), 1,
      sym_parameter_list,
    STATE(7883), 1,
      sym_record_base,
    STATE(7885), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9547), 1,
      sym_declaration_list,
    STATE(7525), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [329442] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9704), 1,
      anon_sym_COLON,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9768), 1,
      anon_sym_SEMI,
    STATE(7669), 1,
      sym_parameter_list,
    STATE(7783), 1,
      aux_sym_class_declaration_repeat3,
    STATE(7793), 1,
      sym_record_base,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9056), 1,
      sym_declaration_list,
    STATE(7526), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [329510] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4081), 1,
      anon_sym_EQ_GT,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9677), 1,
      anon_sym_EQ,
    ACTIONS(9708), 1,
      anon_sym_LT,
    STATE(7539), 1,
      sym_parameter_list,
    STATE(8545), 1,
      sym_bracketed_argument_list,
    STATE(8799), 1,
      sym_type_parameter_list,
    ACTIONS(9675), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(7527), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [329576] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9704), 1,
      anon_sym_COLON,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9770), 1,
      anon_sym_SEMI,
    STATE(7649), 1,
      sym_parameter_list,
    STATE(7770), 1,
      sym_record_base,
    STATE(7774), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9528), 1,
      sym_declaration_list,
    STATE(7528), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [329644] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9704), 1,
      anon_sym_COLON,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9772), 1,
      anon_sym_SEMI,
    STATE(7658), 1,
      sym_parameter_list,
    STATE(7895), 1,
      aux_sym_class_declaration_repeat3,
    STATE(7896), 1,
      sym_record_base,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9060), 1,
      sym_declaration_list,
    STATE(7529), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [329712] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9683), 1,
      anon_sym_EQ_GT,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9774), 1,
      anon_sym_SEMI,
    ACTIONS(9776), 1,
      anon_sym_LBRACE,
    STATE(3144), 1,
      sym_block,
    STATE(3388), 1,
      sym__function_body,
    STATE(7640), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(8980), 1,
      sym_arrow_expression_clause,
    STATE(7530), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [329777] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5707), 1,
      anon_sym_LBRACE,
    ACTIONS(9683), 1,
      anon_sym_EQ_GT,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9778), 1,
      anon_sym_SEMI,
    STATE(2443), 1,
      sym__function_body,
    STATE(2465), 1,
      sym_block,
    STATE(7630), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9431), 1,
      sym_arrow_expression_clause,
    STATE(7531), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [329842] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9734), 1,
      anon_sym_COLON,
    STATE(7691), 1,
      sym_parameter_list,
    STATE(7958), 1,
      sym_base_list,
    STATE(7960), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9680), 1,
      sym_declaration_list,
    STATE(7532), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [329907] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9708), 1,
      anon_sym_LT,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9734), 1,
      anon_sym_COLON,
    STATE(7732), 1,
      sym_type_parameter_list,
    STATE(8085), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8086), 1,
      sym_base_list,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(8991), 1,
      sym_declaration_list,
    STATE(7533), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [329972] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9734), 1,
      anon_sym_COLON,
    STATE(7690), 1,
      sym_parameter_list,
    STATE(8094), 1,
      sym_base_list,
    STATE(8099), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9291), 1,
      sym_declaration_list,
    STATE(7534), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [330037] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5980), 1,
      anon_sym_LBRACE,
    ACTIONS(9683), 1,
      anon_sym_EQ_GT,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9774), 1,
      anon_sym_SEMI,
    STATE(3144), 1,
      sym_block,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(8754), 1,
      sym__function_body,
    STATE(8980), 1,
      sym_arrow_expression_clause,
    STATE(7535), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [330102] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9734), 1,
      anon_sym_COLON,
    STATE(7720), 1,
      sym_parameter_list,
    STATE(8060), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8129), 1,
      sym_base_list,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9270), 1,
      sym_declaration_list,
    STATE(7536), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [330167] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5709), 1,
      anon_sym_LBRACE,
    ACTIONS(9683), 1,
      anon_sym_EQ_GT,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9780), 1,
      anon_sym_SEMI,
    STATE(2256), 1,
      sym_block,
    STATE(2289), 1,
      sym__function_body,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9585), 1,
      sym_arrow_expression_clause,
    STATE(7537), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [330232] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9708), 1,
      anon_sym_LT,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9734), 1,
      anon_sym_COLON,
    STATE(7716), 1,
      sym_type_parameter_list,
    STATE(7981), 1,
      sym_base_list,
    STATE(7982), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9435), 1,
      sym_declaration_list,
    STATE(7538), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [330297] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5709), 1,
      anon_sym_LBRACE,
    ACTIONS(9683), 1,
      anon_sym_EQ_GT,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9780), 1,
      anon_sym_SEMI,
    STATE(2256), 1,
      sym_block,
    STATE(2257), 1,
      sym__function_body,
    STATE(7537), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9585), 1,
      sym_arrow_expression_clause,
    STATE(7539), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [330362] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9734), 1,
      anon_sym_COLON,
    STATE(7678), 1,
      sym_parameter_list,
    STATE(7933), 1,
      sym_base_list,
    STATE(7935), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9001), 1,
      sym_declaration_list,
    STATE(7540), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [330427] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9734), 1,
      anon_sym_COLON,
    STATE(7739), 1,
      sym_parameter_list,
    STATE(8048), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8054), 1,
      sym_base_list,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9534), 1,
      sym_declaration_list,
    STATE(7541), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [330492] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9734), 1,
      anon_sym_COLON,
    STATE(7707), 1,
      sym_parameter_list,
    STATE(8069), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8072), 1,
      sym_base_list,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9004), 1,
      sym_declaration_list,
    STATE(7542), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [330557] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9683), 1,
      anon_sym_EQ_GT,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9774), 1,
      anon_sym_SEMI,
    ACTIONS(9776), 1,
      anon_sym_LBRACE,
    STATE(3144), 1,
      sym_block,
    STATE(3422), 1,
      sym__function_body,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(8980), 1,
      sym_arrow_expression_clause,
    STATE(7543), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [330622] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5709), 1,
      anon_sym_LBRACE,
    ACTIONS(9683), 1,
      anon_sym_EQ_GT,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9780), 1,
      anon_sym_SEMI,
    STATE(2256), 1,
      sym_block,
    STATE(2295), 1,
      sym__function_body,
    STATE(7559), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9585), 1,
      sym_arrow_expression_clause,
    STATE(7544), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [330687] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9708), 1,
      anon_sym_LT,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9734), 1,
      anon_sym_COLON,
    STATE(7706), 1,
      sym_type_parameter_list,
    STATE(7920), 1,
      sym_base_list,
    STATE(7921), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9016), 1,
      sym_declaration_list,
    STATE(7545), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [330752] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9708), 1,
      anon_sym_LT,
    ACTIONS(9742), 1,
      anon_sym_EQ,
    STATE(7571), 1,
      sym_parameter_list,
    STATE(8545), 1,
      sym_bracketed_argument_list,
    STATE(8865), 1,
      sym_type_parameter_list,
    ACTIONS(9675), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(7546), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [330815] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9683), 1,
      anon_sym_EQ_GT,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9774), 1,
      anon_sym_SEMI,
    ACTIONS(9776), 1,
      anon_sym_LBRACE,
    STATE(3144), 1,
      sym_block,
    STATE(3302), 1,
      sym__function_body,
    STATE(7554), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(8980), 1,
      sym_arrow_expression_clause,
    STATE(7547), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [330880] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9734), 1,
      anon_sym_COLON,
    STATE(7699), 1,
      sym_parameter_list,
    STATE(8076), 1,
      sym_base_list,
    STATE(8104), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9240), 1,
      sym_declaration_list,
    STATE(7548), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [330945] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5709), 1,
      anon_sym_LBRACE,
    ACTIONS(9683), 1,
      anon_sym_EQ_GT,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9780), 1,
      anon_sym_SEMI,
    STATE(2256), 1,
      sym_block,
    STATE(2269), 1,
      sym__function_body,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9585), 1,
      sym_arrow_expression_clause,
    STATE(7549), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [331010] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9683), 1,
      anon_sym_EQ_GT,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9774), 1,
      anon_sym_SEMI,
    ACTIONS(9776), 1,
      anon_sym_LBRACE,
    STATE(3144), 1,
      sym_block,
    STATE(3249), 1,
      sym__function_body,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(8980), 1,
      sym_arrow_expression_clause,
    STATE(7550), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [331075] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9683), 1,
      anon_sym_EQ_GT,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9774), 1,
      anon_sym_SEMI,
    ACTIONS(9776), 1,
      anon_sym_LBRACE,
    STATE(3144), 1,
      sym_block,
    STATE(3465), 1,
      sym__function_body,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(8980), 1,
      sym_arrow_expression_clause,
    STATE(7551), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [331140] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9683), 1,
      anon_sym_EQ_GT,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9774), 1,
      anon_sym_SEMI,
    ACTIONS(9776), 1,
      anon_sym_LBRACE,
    STATE(3144), 1,
      sym_block,
    STATE(3385), 1,
      sym__function_body,
    STATE(7635), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(8980), 1,
      sym_arrow_expression_clause,
    STATE(7552), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [331205] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9782), 1,
      anon_sym_COMMA,
    STATE(7579), 1,
      aux_sym_order_by_clause_repeat1,
    ACTIONS(9784), 7,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(7553), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [331258] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9683), 1,
      anon_sym_EQ_GT,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9774), 1,
      anon_sym_SEMI,
    ACTIONS(9776), 1,
      anon_sym_LBRACE,
    STATE(3144), 1,
      sym_block,
    STATE(3449), 1,
      sym__function_body,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(8980), 1,
      sym_arrow_expression_clause,
    STATE(7554), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [331323] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5709), 1,
      anon_sym_LBRACE,
    ACTIONS(9683), 1,
      anon_sym_EQ_GT,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9780), 1,
      anon_sym_SEMI,
    STATE(2256), 1,
      sym_block,
    STATE(2264), 1,
      sym__function_body,
    STATE(7596), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9585), 1,
      sym_arrow_expression_clause,
    STATE(7555), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [331388] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9708), 1,
      anon_sym_LT,
    ACTIONS(9742), 1,
      anon_sym_EQ,
    STATE(7544), 1,
      sym_parameter_list,
    STATE(8545), 1,
      sym_bracketed_argument_list,
    STATE(8818), 1,
      sym_type_parameter_list,
    ACTIONS(9675), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(7556), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [331451] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5980), 1,
      anon_sym_LBRACE,
    ACTIONS(9683), 1,
      anon_sym_EQ_GT,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9774), 1,
      anon_sym_SEMI,
    STATE(3144), 1,
      sym_block,
    STATE(7609), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(8731), 1,
      sym__function_body,
    STATE(8980), 1,
      sym_arrow_expression_clause,
    STATE(7557), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [331516] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9734), 1,
      anon_sym_COLON,
    STATE(7721), 1,
      sym_parameter_list,
    STATE(7998), 1,
      sym_base_list,
    STATE(8000), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9518), 1,
      sym_declaration_list,
    STATE(7558), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [331581] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5709), 1,
      anon_sym_LBRACE,
    ACTIONS(9683), 1,
      anon_sym_EQ_GT,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9780), 1,
      anon_sym_SEMI,
    STATE(2256), 1,
      sym_block,
    STATE(2263), 1,
      sym__function_body,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9585), 1,
      sym_arrow_expression_clause,
    STATE(7559), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [331646] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9734), 1,
      anon_sym_COLON,
    STATE(7679), 1,
      sym_parameter_list,
    STATE(7940), 1,
      aux_sym_class_declaration_repeat3,
    STATE(7941), 1,
      sym_base_list,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9087), 1,
      sym_declaration_list,
    STATE(7560), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [331711] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5707), 1,
      anon_sym_LBRACE,
    ACTIONS(9683), 1,
      anon_sym_EQ_GT,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9778), 1,
      anon_sym_SEMI,
    STATE(2428), 1,
      sym__function_body,
    STATE(2465), 1,
      sym_block,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9431), 1,
      sym_arrow_expression_clause,
    STATE(7561), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [331776] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9683), 1,
      anon_sym_EQ_GT,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9774), 1,
      anon_sym_SEMI,
    ACTIONS(9776), 1,
      anon_sym_LBRACE,
    STATE(3144), 1,
      sym_block,
    STATE(3482), 1,
      sym__function_body,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(8980), 1,
      sym_arrow_expression_clause,
    STATE(7562), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [331841] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9734), 1,
      anon_sym_COLON,
    STATE(7682), 1,
      sym_parameter_list,
    STATE(7944), 1,
      aux_sym_class_declaration_repeat3,
    STATE(7945), 1,
      sym_base_list,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9091), 1,
      sym_declaration_list,
    STATE(7563), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [331906] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9734), 1,
      anon_sym_COLON,
    STATE(7733), 1,
      sym_parameter_list,
    STATE(8005), 1,
      sym_base_list,
    STATE(8007), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9530), 1,
      sym_declaration_list,
    STATE(7564), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [331971] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9683), 1,
      anon_sym_EQ_GT,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9774), 1,
      anon_sym_SEMI,
    ACTIONS(9776), 1,
      anon_sym_LBRACE,
    STATE(3144), 1,
      sym_block,
    STATE(3401), 1,
      sym__function_body,
    STATE(7550), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(8980), 1,
      sym_arrow_expression_clause,
    STATE(7565), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [332036] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9708), 1,
      anon_sym_LT,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9734), 1,
      anon_sym_COLON,
    STATE(7694), 1,
      sym_type_parameter_list,
    STATE(8091), 1,
      sym_base_list,
    STATE(8095), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9649), 1,
      sym_declaration_list,
    STATE(7566), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [332101] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6104), 1,
      anon_sym_LBRACE,
    ACTIONS(9683), 1,
      anon_sym_EQ_GT,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9786), 1,
      anon_sym_SEMI,
    STATE(2663), 1,
      sym__function_body,
    STATE(2690), 1,
      sym_block,
    STATE(7613), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9040), 1,
      sym_arrow_expression_clause,
    STATE(7567), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [332166] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6104), 1,
      anon_sym_LBRACE,
    ACTIONS(9683), 1,
      anon_sym_EQ_GT,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9786), 1,
      anon_sym_SEMI,
    STATE(2664), 1,
      sym__function_body,
    STATE(2690), 1,
      sym_block,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9040), 1,
      sym_arrow_expression_clause,
    STATE(7568), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [332231] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4083), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6745), 1,
      anon_sym_LT,
    STATE(4976), 1,
      sym_type_argument_list,
    ACTIONS(9788), 2,
      anon_sym_COMMA,
      anon_sym_GT,
    ACTIONS(4076), 4,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
    STATE(7569), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [332288] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5709), 1,
      anon_sym_LBRACE,
    ACTIONS(9683), 1,
      anon_sym_EQ_GT,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9780), 1,
      anon_sym_SEMI,
    STATE(2256), 1,
      sym_block,
    STATE(2261), 1,
      sym__function_body,
    STATE(7598), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9585), 1,
      sym_arrow_expression_clause,
    STATE(7570), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [332353] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5707), 1,
      anon_sym_LBRACE,
    ACTIONS(9683), 1,
      anon_sym_EQ_GT,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9778), 1,
      anon_sym_SEMI,
    STATE(2430), 1,
      sym__function_body,
    STATE(2465), 1,
      sym_block,
    STATE(7611), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9431), 1,
      sym_arrow_expression_clause,
    STATE(7571), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [332418] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5980), 1,
      anon_sym_LBRACE,
    ACTIONS(9683), 1,
      anon_sym_EQ_GT,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9774), 1,
      anon_sym_SEMI,
    STATE(3144), 1,
      sym_block,
    STATE(7574), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(8739), 1,
      sym__function_body,
    STATE(8980), 1,
      sym_arrow_expression_clause,
    STATE(7572), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [332483] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9683), 1,
      anon_sym_EQ_GT,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9774), 1,
      anon_sym_SEMI,
    ACTIONS(9776), 1,
      anon_sym_LBRACE,
    STATE(3144), 1,
      sym_block,
    STATE(3324), 1,
      sym__function_body,
    STATE(7629), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(8980), 1,
      sym_arrow_expression_clause,
    STATE(7573), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [332548] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5980), 1,
      anon_sym_LBRACE,
    ACTIONS(9683), 1,
      anon_sym_EQ_GT,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9774), 1,
      anon_sym_SEMI,
    STATE(3144), 1,
      sym_block,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(8732), 1,
      sym__function_body,
    STATE(8980), 1,
      sym_arrow_expression_clause,
    STATE(7574), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [332613] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6104), 1,
      anon_sym_LBRACE,
    ACTIONS(9683), 1,
      anon_sym_EQ_GT,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9786), 1,
      anon_sym_SEMI,
    STATE(2672), 1,
      sym__function_body,
    STATE(2690), 1,
      sym_block,
    STATE(7604), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9040), 1,
      sym_arrow_expression_clause,
    STATE(7575), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [332678] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9683), 1,
      anon_sym_EQ_GT,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9774), 1,
      anon_sym_SEMI,
    ACTIONS(9776), 1,
      anon_sym_LBRACE,
    STATE(3144), 1,
      sym_block,
    STATE(3474), 1,
      sym__function_body,
    STATE(7619), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(8980), 1,
      sym_arrow_expression_clause,
    STATE(7576), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [332743] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5709), 1,
      anon_sym_LBRACE,
    ACTIONS(9683), 1,
      anon_sym_EQ_GT,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9780), 1,
      anon_sym_SEMI,
    STATE(2256), 1,
      sym_block,
    STATE(2294), 1,
      sym__function_body,
    STATE(7549), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9585), 1,
      sym_arrow_expression_clause,
    STATE(7577), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [332808] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5980), 1,
      anon_sym_LBRACE,
    ACTIONS(9683), 1,
      anon_sym_EQ_GT,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9774), 1,
      anon_sym_SEMI,
    STATE(3144), 1,
      sym_block,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(8744), 1,
      sym__function_body,
    STATE(8980), 1,
      sym_arrow_expression_clause,
    STATE(7578), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [332873] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9782), 1,
      anon_sym_COMMA,
    STATE(7595), 1,
      aux_sym_order_by_clause_repeat1,
    ACTIONS(9791), 7,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(7579), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [332926] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5980), 1,
      anon_sym_LBRACE,
    ACTIONS(9683), 1,
      anon_sym_EQ_GT,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9774), 1,
      anon_sym_SEMI,
    STATE(3144), 1,
      sym_block,
    STATE(7602), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(8770), 1,
      sym__function_body,
    STATE(8980), 1,
      sym_arrow_expression_clause,
    STATE(7580), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [332991] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9683), 1,
      anon_sym_EQ_GT,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9774), 1,
      anon_sym_SEMI,
    ACTIONS(9776), 1,
      anon_sym_LBRACE,
    STATE(3144), 1,
      sym_block,
    STATE(3373), 1,
      sym__function_body,
    STATE(7589), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(8980), 1,
      sym_arrow_expression_clause,
    STATE(7581), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [333056] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5707), 1,
      anon_sym_LBRACE,
    ACTIONS(9683), 1,
      anon_sym_EQ_GT,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9778), 1,
      anon_sym_SEMI,
    STATE(2465), 1,
      sym_block,
    STATE(2473), 1,
      sym__function_body,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9431), 1,
      sym_arrow_expression_clause,
    STATE(7582), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [333121] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5980), 1,
      anon_sym_LBRACE,
    ACTIONS(9683), 1,
      anon_sym_EQ_GT,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9774), 1,
      anon_sym_SEMI,
    STATE(3144), 1,
      sym_block,
    STATE(7535), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(8747), 1,
      sym__function_body,
    STATE(8980), 1,
      sym_arrow_expression_clause,
    STATE(7583), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [333186] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9795), 1,
      anon_sym_into,
    STATE(7740), 1,
      sym_join_into_clause,
    ACTIONS(9793), 7,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(7584), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [333239] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9708), 1,
      anon_sym_LT,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9734), 1,
      anon_sym_COLON,
    STATE(7696), 1,
      sym_type_parameter_list,
    STATE(7969), 1,
      aux_sym_class_declaration_repeat3,
    STATE(7970), 1,
      sym_base_list,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9235), 1,
      sym_declaration_list,
    STATE(7585), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [333304] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9708), 1,
      anon_sym_LT,
    ACTIONS(9742), 1,
      anon_sym_EQ,
    STATE(7607), 1,
      sym_parameter_list,
    STATE(8545), 1,
      sym_bracketed_argument_list,
    STATE(8957), 1,
      sym_type_parameter_list,
    ACTIONS(9675), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(7586), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [333367] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9708), 1,
      anon_sym_LT,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9734), 1,
      anon_sym_COLON,
    STATE(7710), 1,
      sym_type_parameter_list,
    STATE(8082), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8198), 1,
      sym_base_list,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9513), 1,
      sym_declaration_list,
    STATE(7587), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [333432] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5980), 1,
      anon_sym_LBRACE,
    ACTIONS(9683), 1,
      anon_sym_EQ_GT,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9774), 1,
      anon_sym_SEMI,
    STATE(3144), 1,
      sym_block,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(8765), 1,
      sym__function_body,
    STATE(8980), 1,
      sym_arrow_expression_clause,
    STATE(7588), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [333497] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9683), 1,
      anon_sym_EQ_GT,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9774), 1,
      anon_sym_SEMI,
    ACTIONS(9776), 1,
      anon_sym_LBRACE,
    STATE(3144), 1,
      sym_block,
    STATE(3248), 1,
      sym__function_body,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(8980), 1,
      sym_arrow_expression_clause,
    STATE(7589), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [333562] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9734), 1,
      anon_sym_COLON,
    STATE(7723), 1,
      sym_parameter_list,
    STATE(8144), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8147), 1,
      sym_base_list,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9069), 1,
      sym_declaration_list,
    STATE(7590), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [333627] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9734), 1,
      anon_sym_COLON,
    STATE(7727), 1,
      sym_parameter_list,
    STATE(8030), 1,
      sym_base_list,
    STATE(8032), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9777), 1,
      sym_declaration_list,
    STATE(7591), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [333692] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9683), 1,
      anon_sym_EQ_GT,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9774), 1,
      anon_sym_SEMI,
    ACTIONS(9776), 1,
      anon_sym_LBRACE,
    STATE(3144), 1,
      sym_block,
    STATE(3247), 1,
      sym__function_body,
    STATE(7639), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(8980), 1,
      sym_arrow_expression_clause,
    STATE(7592), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [333757] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9734), 1,
      anon_sym_COLON,
    STATE(7677), 1,
      sym_parameter_list,
    STATE(8151), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8152), 1,
      sym_base_list,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9057), 1,
      sym_declaration_list,
    STATE(7593), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [333822] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9734), 1,
      anon_sym_COLON,
    STATE(7697), 1,
      sym_parameter_list,
    STATE(8111), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8119), 1,
      sym_base_list,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9679), 1,
      sym_declaration_list,
    STATE(7594), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [333887] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9797), 1,
      anon_sym_COMMA,
    ACTIONS(9800), 7,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(7595), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_order_by_clause_repeat1,
  [333938] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5709), 1,
      anon_sym_LBRACE,
    ACTIONS(9683), 1,
      anon_sym_EQ_GT,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9780), 1,
      anon_sym_SEMI,
    STATE(2243), 1,
      sym__function_body,
    STATE(2256), 1,
      sym_block,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9585), 1,
      sym_arrow_expression_clause,
    STATE(7596), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [334003] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5709), 1,
      anon_sym_LBRACE,
    ACTIONS(9683), 1,
      anon_sym_EQ_GT,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9780), 1,
      anon_sym_SEMI,
    STATE(2242), 1,
      sym__function_body,
    STATE(2256), 1,
      sym_block,
    STATE(7603), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9585), 1,
      sym_arrow_expression_clause,
    STATE(7597), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [334068] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5709), 1,
      anon_sym_LBRACE,
    ACTIONS(9683), 1,
      anon_sym_EQ_GT,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9780), 1,
      anon_sym_SEMI,
    STATE(2240), 1,
      sym__function_body,
    STATE(2256), 1,
      sym_block,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9585), 1,
      sym_arrow_expression_clause,
    STATE(7598), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [334133] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9708), 1,
      anon_sym_LT,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9734), 1,
      anon_sym_COLON,
    STATE(7718), 1,
      sym_type_parameter_list,
    STATE(8123), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8125), 1,
      sym_base_list,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9469), 1,
      sym_declaration_list,
    STATE(7599), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [334198] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9734), 1,
      anon_sym_COLON,
    STATE(7674), 1,
      sym_parameter_list,
    STATE(7914), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8131), 1,
      sym_base_list,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9792), 1,
      sym_declaration_list,
    STATE(7600), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [334263] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9734), 1,
      anon_sym_COLON,
    STATE(7687), 1,
      sym_parameter_list,
    STATE(7957), 1,
      aux_sym_class_declaration_repeat3,
    STATE(7968), 1,
      sym_base_list,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9114), 1,
      sym_declaration_list,
    STATE(7601), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [334328] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5980), 1,
      anon_sym_LBRACE,
    ACTIONS(9683), 1,
      anon_sym_EQ_GT,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9774), 1,
      anon_sym_SEMI,
    STATE(3144), 1,
      sym_block,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(8749), 1,
      sym__function_body,
    STATE(8980), 1,
      sym_arrow_expression_clause,
    STATE(7602), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [334393] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5709), 1,
      anon_sym_LBRACE,
    ACTIONS(9683), 1,
      anon_sym_EQ_GT,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9780), 1,
      anon_sym_SEMI,
    STATE(2225), 1,
      sym__function_body,
    STATE(2256), 1,
      sym_block,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9585), 1,
      sym_arrow_expression_clause,
    STATE(7603), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [334458] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6104), 1,
      anon_sym_LBRACE,
    ACTIONS(9683), 1,
      anon_sym_EQ_GT,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9786), 1,
      anon_sym_SEMI,
    STATE(2666), 1,
      sym__function_body,
    STATE(2690), 1,
      sym_block,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9040), 1,
      sym_arrow_expression_clause,
    STATE(7604), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [334523] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6104), 1,
      anon_sym_LBRACE,
    ACTIONS(9683), 1,
      anon_sym_EQ_GT,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9786), 1,
      anon_sym_SEMI,
    STATE(2650), 1,
      sym__function_body,
    STATE(2690), 1,
      sym_block,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9040), 1,
      sym_arrow_expression_clause,
    STATE(7605), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [334588] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6104), 1,
      anon_sym_LBRACE,
    ACTIONS(9683), 1,
      anon_sym_EQ_GT,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9786), 1,
      anon_sym_SEMI,
    STATE(2667), 1,
      sym__function_body,
    STATE(2690), 1,
      sym_block,
    STATE(7618), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9040), 1,
      sym_arrow_expression_clause,
    STATE(7606), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [334653] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6104), 1,
      anon_sym_LBRACE,
    ACTIONS(9683), 1,
      anon_sym_EQ_GT,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9786), 1,
      anon_sym_SEMI,
    STATE(2660), 1,
      sym__function_body,
    STATE(2690), 1,
      sym_block,
    STATE(7568), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9040), 1,
      sym_arrow_expression_clause,
    STATE(7607), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [334718] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5707), 1,
      anon_sym_LBRACE,
    ACTIONS(9683), 1,
      anon_sym_EQ_GT,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9778), 1,
      anon_sym_SEMI,
    STATE(2462), 1,
      sym__function_body,
    STATE(2465), 1,
      sym_block,
    STATE(7612), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9431), 1,
      sym_arrow_expression_clause,
    STATE(7608), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [334783] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5980), 1,
      anon_sym_LBRACE,
    ACTIONS(9683), 1,
      anon_sym_EQ_GT,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9774), 1,
      anon_sym_SEMI,
    STATE(3144), 1,
      sym_block,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(8717), 1,
      sym__function_body,
    STATE(8980), 1,
      sym_arrow_expression_clause,
    STATE(7609), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [334848] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5707), 1,
      anon_sym_LBRACE,
    ACTIONS(9683), 1,
      anon_sym_EQ_GT,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9778), 1,
      anon_sym_SEMI,
    STATE(2436), 1,
      sym__function_body,
    STATE(2465), 1,
      sym_block,
    STATE(7582), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9431), 1,
      sym_arrow_expression_clause,
    STATE(7610), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [334913] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5707), 1,
      anon_sym_LBRACE,
    ACTIONS(9683), 1,
      anon_sym_EQ_GT,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9778), 1,
      anon_sym_SEMI,
    STATE(2438), 1,
      sym__function_body,
    STATE(2465), 1,
      sym_block,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9431), 1,
      sym_arrow_expression_clause,
    STATE(7611), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [334978] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5707), 1,
      anon_sym_LBRACE,
    ACTIONS(9683), 1,
      anon_sym_EQ_GT,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9778), 1,
      anon_sym_SEMI,
    STATE(2431), 1,
      sym__function_body,
    STATE(2465), 1,
      sym_block,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9431), 1,
      sym_arrow_expression_clause,
    STATE(7612), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [335043] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6104), 1,
      anon_sym_LBRACE,
    ACTIONS(9683), 1,
      anon_sym_EQ_GT,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9786), 1,
      anon_sym_SEMI,
    STATE(2670), 1,
      sym__function_body,
    STATE(2690), 1,
      sym_block,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9040), 1,
      sym_arrow_expression_clause,
    STATE(7613), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [335108] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9708), 1,
      anon_sym_LT,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9734), 1,
      anon_sym_COLON,
    STATE(7724), 1,
      sym_type_parameter_list,
    STATE(8190), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8197), 1,
      sym_base_list,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9377), 1,
      sym_declaration_list,
    STATE(7614), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [335173] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5707), 1,
      anon_sym_LBRACE,
    ACTIONS(9683), 1,
      anon_sym_EQ_GT,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9778), 1,
      anon_sym_SEMI,
    STATE(2440), 1,
      sym__function_body,
    STATE(2465), 1,
      sym_block,
    STATE(7561), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9431), 1,
      sym_arrow_expression_clause,
    STATE(7615), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [335238] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9734), 1,
      anon_sym_COLON,
    STATE(7711), 1,
      sym_parameter_list,
    STATE(8049), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8052), 1,
      sym_base_list,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9030), 1,
      sym_declaration_list,
    STATE(7616), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [335303] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9734), 1,
      anon_sym_COLON,
    STATE(7731), 1,
      sym_parameter_list,
    STATE(8118), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8121), 1,
      sym_base_list,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9806), 1,
      sym_declaration_list,
    STATE(7617), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [335368] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6104), 1,
      anon_sym_LBRACE,
    ACTIONS(9683), 1,
      anon_sym_EQ_GT,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9786), 1,
      anon_sym_SEMI,
    STATE(2681), 1,
      sym__function_body,
    STATE(2690), 1,
      sym_block,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9040), 1,
      sym_arrow_expression_clause,
    STATE(7618), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [335433] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9683), 1,
      anon_sym_EQ_GT,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9774), 1,
      anon_sym_SEMI,
    ACTIONS(9776), 1,
      anon_sym_LBRACE,
    STATE(3144), 1,
      sym_block,
    STATE(3347), 1,
      sym__function_body,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(8980), 1,
      sym_arrow_expression_clause,
    STATE(7619), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [335498] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9683), 1,
      anon_sym_EQ_GT,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9774), 1,
      anon_sym_SEMI,
    ACTIONS(9776), 1,
      anon_sym_LBRACE,
    STATE(3144), 1,
      sym_block,
    STATE(3331), 1,
      sym__function_body,
    STATE(7627), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(8980), 1,
      sym_arrow_expression_clause,
    STATE(7620), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [335563] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9734), 1,
      anon_sym_COLON,
    STATE(7693), 1,
      sym_parameter_list,
    STATE(7991), 1,
      aux_sym_class_declaration_repeat3,
    STATE(7992), 1,
      sym_base_list,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9100), 1,
      sym_declaration_list,
    STATE(7621), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [335628] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6104), 1,
      anon_sym_LBRACE,
    ACTIONS(9683), 1,
      anon_sym_EQ_GT,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9786), 1,
      anon_sym_SEMI,
    STATE(2690), 1,
      sym_block,
    STATE(2693), 1,
      sym__function_body,
    STATE(7633), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9040), 1,
      sym_arrow_expression_clause,
    STATE(7622), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [335693] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9734), 1,
      anon_sym_COLON,
    STATE(7726), 1,
      sym_parameter_list,
    STATE(7917), 1,
      aux_sym_class_declaration_repeat3,
    STATE(7922), 1,
      sym_base_list,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9616), 1,
      sym_declaration_list,
    STATE(7623), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [335758] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5707), 1,
      anon_sym_LBRACE,
    ACTIONS(9683), 1,
      anon_sym_EQ_GT,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9778), 1,
      anon_sym_SEMI,
    STATE(2457), 1,
      sym__function_body,
    STATE(2465), 1,
      sym_block,
    STATE(7634), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9431), 1,
      sym_arrow_expression_clause,
    STATE(7624), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [335823] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9708), 1,
      anon_sym_LT,
    ACTIONS(9742), 1,
      anon_sym_EQ,
    STATE(7628), 1,
      sym_parameter_list,
    STATE(8545), 1,
      sym_bracketed_argument_list,
    STATE(8669), 1,
      sym_type_parameter_list,
    ACTIONS(9675), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(7625), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [335886] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5980), 1,
      anon_sym_LBRACE,
    ACTIONS(9683), 1,
      anon_sym_EQ_GT,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9774), 1,
      anon_sym_SEMI,
    STATE(3144), 1,
      sym_block,
    STATE(7588), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(8806), 1,
      sym__function_body,
    STATE(8980), 1,
      sym_arrow_expression_clause,
    STATE(7626), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [335951] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9683), 1,
      anon_sym_EQ_GT,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9774), 1,
      anon_sym_SEMI,
    ACTIONS(9776), 1,
      anon_sym_LBRACE,
    STATE(3144), 1,
      sym_block,
    STATE(3456), 1,
      sym__function_body,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(8980), 1,
      sym_arrow_expression_clause,
    STATE(7627), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [336016] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5980), 1,
      anon_sym_LBRACE,
    ACTIONS(9683), 1,
      anon_sym_EQ_GT,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9774), 1,
      anon_sym_SEMI,
    STATE(3144), 1,
      sym_block,
    STATE(7578), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(8757), 1,
      sym__function_body,
    STATE(8980), 1,
      sym_arrow_expression_clause,
    STATE(7628), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [336081] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9683), 1,
      anon_sym_EQ_GT,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9774), 1,
      anon_sym_SEMI,
    ACTIONS(9776), 1,
      anon_sym_LBRACE,
    STATE(3144), 1,
      sym_block,
    STATE(3453), 1,
      sym__function_body,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(8980), 1,
      sym_arrow_expression_clause,
    STATE(7629), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [336146] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5707), 1,
      anon_sym_LBRACE,
    ACTIONS(9683), 1,
      anon_sym_EQ_GT,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9778), 1,
      anon_sym_SEMI,
    STATE(2429), 1,
      sym__function_body,
    STATE(2465), 1,
      sym_block,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9431), 1,
      sym_arrow_expression_clause,
    STATE(7630), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [336211] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9683), 1,
      anon_sym_EQ_GT,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9774), 1,
      anon_sym_SEMI,
    ACTIONS(9776), 1,
      anon_sym_LBRACE,
    STATE(3144), 1,
      sym_block,
    STATE(3447), 1,
      sym__function_body,
    STATE(7551), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(8980), 1,
      sym_arrow_expression_clause,
    STATE(7631), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [336276] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6104), 1,
      anon_sym_LBRACE,
    ACTIONS(9683), 1,
      anon_sym_EQ_GT,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9786), 1,
      anon_sym_SEMI,
    STATE(2690), 1,
      sym_block,
    STATE(2696), 1,
      sym__function_body,
    STATE(7605), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9040), 1,
      sym_arrow_expression_clause,
    STATE(7632), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [336341] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6104), 1,
      anon_sym_LBRACE,
    ACTIONS(9683), 1,
      anon_sym_EQ_GT,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9786), 1,
      anon_sym_SEMI,
    STATE(2690), 1,
      sym_block,
    STATE(2691), 1,
      sym__function_body,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9040), 1,
      sym_arrow_expression_clause,
    STATE(7633), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [336406] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5707), 1,
      anon_sym_LBRACE,
    ACTIONS(9683), 1,
      anon_sym_EQ_GT,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9778), 1,
      anon_sym_SEMI,
    STATE(2434), 1,
      sym__function_body,
    STATE(2465), 1,
      sym_block,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9431), 1,
      sym_arrow_expression_clause,
    STATE(7634), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [336471] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9683), 1,
      anon_sym_EQ_GT,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9774), 1,
      anon_sym_SEMI,
    ACTIONS(9776), 1,
      anon_sym_LBRACE,
    STATE(3144), 1,
      sym_block,
    STATE(3271), 1,
      sym__function_body,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(8980), 1,
      sym_arrow_expression_clause,
    STATE(7635), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [336536] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9683), 1,
      anon_sym_EQ_GT,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9774), 1,
      anon_sym_SEMI,
    ACTIONS(9776), 1,
      anon_sym_LBRACE,
    STATE(3144), 1,
      sym_block,
    STATE(3269), 1,
      sym__function_body,
    STATE(7543), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(8980), 1,
      sym_arrow_expression_clause,
    STATE(7636), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [336601] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9683), 1,
      anon_sym_EQ_GT,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9774), 1,
      anon_sym_SEMI,
    ACTIONS(9776), 1,
      anon_sym_LBRACE,
    STATE(3144), 1,
      sym_block,
    STATE(3220), 1,
      sym__function_body,
    STATE(7562), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(8980), 1,
      sym_arrow_expression_clause,
    STATE(7637), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [336666] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9708), 1,
      anon_sym_LT,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9734), 1,
      anon_sym_COLON,
    STATE(7729), 1,
      sym_type_parameter_list,
    STATE(8017), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8018), 1,
      sym_base_list,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9050), 1,
      sym_declaration_list,
    STATE(7638), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [336731] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9683), 1,
      anon_sym_EQ_GT,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9774), 1,
      anon_sym_SEMI,
    ACTIONS(9776), 1,
      anon_sym_LBRACE,
    STATE(3144), 1,
      sym_block,
    STATE(3237), 1,
      sym__function_body,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(8980), 1,
      sym_arrow_expression_clause,
    STATE(7639), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [336796] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9683), 1,
      anon_sym_EQ_GT,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9774), 1,
      anon_sym_SEMI,
    ACTIONS(9776), 1,
      anon_sym_LBRACE,
    STATE(3144), 1,
      sym_block,
    STATE(3275), 1,
      sym__function_body,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(8980), 1,
      sym_arrow_expression_clause,
    STATE(7640), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [336861] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9704), 1,
      anon_sym_COLON,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9802), 1,
      anon_sym_SEMI,
    STATE(7790), 1,
      aux_sym_class_declaration_repeat3,
    STATE(7804), 1,
      sym_record_base,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9854), 1,
      sym_declaration_list,
    STATE(7641), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [336923] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9704), 1,
      anon_sym_COLON,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9772), 1,
      anon_sym_SEMI,
    STATE(7895), 1,
      aux_sym_class_declaration_repeat3,
    STATE(7896), 1,
      sym_record_base,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9060), 1,
      sym_declaration_list,
    STATE(7642), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [336985] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9800), 8,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(7643), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [337033] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9704), 1,
      anon_sym_COLON,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9750), 1,
      anon_sym_SEMI,
    STATE(7880), 1,
      sym_record_base,
    STATE(7881), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9674), 1,
      sym_declaration_list,
    STATE(7644), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [337095] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9704), 1,
      anon_sym_COLON,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9764), 1,
      anon_sym_SEMI,
    STATE(7776), 1,
      sym_record_base,
    STATE(7827), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9711), 1,
      sym_declaration_list,
    STATE(7645), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [337157] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9704), 1,
      anon_sym_COLON,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9804), 1,
      anon_sym_SEMI,
    STATE(7846), 1,
      sym_record_base,
    STATE(7848), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9019), 1,
      sym_declaration_list,
    STATE(7646), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [337219] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9704), 1,
      anon_sym_COLON,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9806), 1,
      anon_sym_SEMI,
    STATE(7867), 1,
      sym_record_base,
    STATE(7868), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9553), 1,
      sym_declaration_list,
    STATE(7647), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [337281] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9704), 1,
      anon_sym_COLON,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9768), 1,
      anon_sym_SEMI,
    STATE(7783), 1,
      aux_sym_class_declaration_repeat3,
    STATE(7793), 1,
      sym_record_base,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9056), 1,
      sym_declaration_list,
    STATE(7648), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [337343] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9704), 1,
      anon_sym_COLON,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9808), 1,
      anon_sym_SEMI,
    STATE(7746), 1,
      sym_record_base,
    STATE(7748), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9773), 1,
      sym_declaration_list,
    STATE(7649), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [337405] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9810), 8,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(7650), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [337453] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9704), 1,
      anon_sym_COLON,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9758), 1,
      anon_sym_SEMI,
    STATE(7778), 1,
      sym_record_base,
    STATE(7803), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9805), 1,
      sym_declaration_list,
    STATE(7651), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [337515] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9704), 1,
      anon_sym_COLON,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9812), 1,
      anon_sym_SEMI,
    STATE(7815), 1,
      sym_record_base,
    STATE(7819), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9761), 1,
      sym_declaration_list,
    STATE(7652), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [337577] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9683), 1,
      anon_sym_EQ_GT,
    ACTIONS(9774), 1,
      anon_sym_SEMI,
    ACTIONS(9776), 1,
      anon_sym_LBRACE,
    ACTIONS(9814), 1,
      anon_sym_COLON,
    STATE(3144), 1,
      sym_block,
    STATE(3232), 1,
      sym__function_body,
    STATE(7767), 1,
      sym_constructor_initializer,
    STATE(8980), 1,
      sym_arrow_expression_clause,
    STATE(7653), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [337639] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9679), 1,
      anon_sym_LBRACE,
    ACTIONS(9683), 1,
      anon_sym_EQ_GT,
    ACTIONS(9708), 1,
      anon_sym_LT,
    STATE(3188), 1,
      sym_accessor_list,
    STATE(7573), 1,
      sym_parameter_list,
    STATE(8898), 1,
      sym_type_parameter_list,
    STATE(9365), 1,
      sym_arrow_expression_clause,
    STATE(7654), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [337701] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9683), 1,
      anon_sym_EQ_GT,
    ACTIONS(9774), 1,
      anon_sym_SEMI,
    ACTIONS(9776), 1,
      anon_sym_LBRACE,
    ACTIONS(9814), 1,
      anon_sym_COLON,
    STATE(3144), 1,
      sym_block,
    STATE(3242), 1,
      sym__function_body,
    STATE(7860), 1,
      sym_constructor_initializer,
    STATE(8980), 1,
      sym_arrow_expression_clause,
    STATE(7655), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [337763] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9704), 1,
      anon_sym_COLON,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9754), 1,
      anon_sym_SEMI,
    STATE(7884), 1,
      sym_record_base,
    STATE(7888), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9013), 1,
      sym_declaration_list,
    STATE(7656), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [337825] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9704), 1,
      anon_sym_COLON,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9770), 1,
      anon_sym_SEMI,
    STATE(7770), 1,
      sym_record_base,
    STATE(7774), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9528), 1,
      sym_declaration_list,
    STATE(7657), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [337887] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9704), 1,
      anon_sym_COLON,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9816), 1,
      anon_sym_SEMI,
    STATE(7871), 1,
      sym_record_base,
    STATE(7872), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(8971), 1,
      sym_declaration_list,
    STATE(7658), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [337949] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9679), 1,
      anon_sym_LBRACE,
    ACTIONS(9683), 1,
      anon_sym_EQ_GT,
    ACTIONS(9708), 1,
      anon_sym_LT,
    STATE(3198), 1,
      sym_accessor_list,
    STATE(7581), 1,
      sym_parameter_list,
    STATE(8688), 1,
      sym_type_parameter_list,
    STATE(9906), 1,
      sym_arrow_expression_clause,
    STATE(7659), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [338011] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9704), 1,
      anon_sym_COLON,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9760), 1,
      anon_sym_SEMI,
    STATE(7876), 1,
      sym_record_base,
    STATE(7878), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(8974), 1,
      sym_declaration_list,
    STATE(7660), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [338073] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9683), 1,
      anon_sym_EQ_GT,
    ACTIONS(9774), 1,
      anon_sym_SEMI,
    ACTIONS(9776), 1,
      anon_sym_LBRACE,
    ACTIONS(9814), 1,
      anon_sym_COLON,
    STATE(3144), 1,
      sym_block,
    STATE(3245), 1,
      sym__function_body,
    STATE(7907), 1,
      sym_constructor_initializer,
    STATE(8980), 1,
      sym_arrow_expression_clause,
    STATE(7661), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [338135] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9704), 1,
      anon_sym_COLON,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9766), 1,
      anon_sym_SEMI,
    STATE(7883), 1,
      sym_record_base,
    STATE(7885), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9547), 1,
      sym_declaration_list,
    STATE(7662), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [338197] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9704), 1,
      anon_sym_COLON,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9752), 1,
      anon_sym_SEMI,
    STATE(7751), 1,
      aux_sym_class_declaration_repeat3,
    STATE(7834), 1,
      sym_record_base,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9271), 1,
      sym_declaration_list,
    STATE(7663), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [338259] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9704), 1,
      anon_sym_COLON,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9756), 1,
      anon_sym_SEMI,
    STATE(7769), 1,
      sym_record_base,
    STATE(7773), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(8970), 1,
      sym_declaration_list,
    STATE(7664), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [338321] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9704), 1,
      anon_sym_COLON,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9762), 1,
      anon_sym_SEMI,
    STATE(7812), 1,
      sym_record_base,
    STATE(7890), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9371), 1,
      sym_declaration_list,
    STATE(7665), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [338383] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9704), 1,
      anon_sym_COLON,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9818), 1,
      anon_sym_SEMI,
    STATE(7747), 1,
      sym_record_base,
    STATE(7760), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9310), 1,
      sym_declaration_list,
    STATE(7666), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [338445] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9704), 1,
      anon_sym_COLON,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9820), 1,
      anon_sym_SEMI,
    STATE(7811), 1,
      aux_sym_class_declaration_repeat3,
    STATE(7818), 1,
      sym_record_base,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9756), 1,
      sym_declaration_list,
    STATE(7667), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [338507] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9679), 1,
      anon_sym_LBRACE,
    ACTIONS(9683), 1,
      anon_sym_EQ_GT,
    ACTIONS(9708), 1,
      anon_sym_LT,
    STATE(3181), 1,
      sym_accessor_list,
    STATE(7552), 1,
      sym_parameter_list,
    STATE(8858), 1,
      sym_type_parameter_list,
    STATE(9489), 1,
      sym_arrow_expression_clause,
    STATE(7668), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [338569] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9704), 1,
      anon_sym_COLON,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9822), 1,
      anon_sym_SEMI,
    STATE(7755), 1,
      sym_record_base,
    STATE(7766), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9230), 1,
      sym_declaration_list,
    STATE(7669), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [338631] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    ACTIONS(8449), 1,
      anon_sym_DOT,
    ACTIONS(9826), 1,
      anon_sym_COMMA,
    STATE(7978), 1,
      aux_sym_record_base_repeat1,
    STATE(8323), 1,
      sym_argument_list,
    ACTIONS(9824), 3,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_where,
    STATE(7670), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [338689] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9704), 1,
      anon_sym_COLON,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9828), 1,
      anon_sym_SEMI,
    STATE(7824), 1,
      aux_sym_class_declaration_repeat3,
    STATE(7901), 1,
      sym_record_base,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9387), 1,
      sym_declaration_list,
    STATE(7671), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [338751] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9704), 1,
      anon_sym_COLON,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9830), 1,
      anon_sym_SEMI,
    STATE(7763), 1,
      aux_sym_class_declaration_repeat3,
    STATE(7764), 1,
      sym_record_base,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9078), 1,
      sym_declaration_list,
    STATE(7672), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [338813] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9704), 1,
      anon_sym_COLON,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9832), 1,
      anon_sym_SEMI,
    STATE(7781), 1,
      sym_record_base,
    STATE(7786), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9496), 1,
      sym_declaration_list,
    STATE(7673), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [338875] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9734), 1,
      anon_sym_COLON,
    STATE(8159), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8161), 1,
      sym_base_list,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9783), 1,
      sym_declaration_list,
    STATE(7674), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [338934] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9734), 1,
      anon_sym_COLON,
    STATE(8005), 1,
      sym_base_list,
    STATE(8007), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9530), 1,
      sym_declaration_list,
    STATE(7675), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [338993] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9834), 1,
      anon_sym_DQUOTE,
    ACTIONS(9838), 1,
      sym_interpolation_open_brace,
    STATE(7712), 1,
      aux_sym_interpolated_string_expression_repeat1,
    STATE(8283), 1,
      sym__interpolated_string_content,
    STATE(8292), 1,
      sym_interpolation,
    ACTIONS(9836), 2,
      sym_interpolation_string_content,
      sym_escape_sequence,
    STATE(7676), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [339050] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9734), 1,
      anon_sym_COLON,
    STATE(8073), 1,
      sym_base_list,
    STATE(8074), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(8998), 1,
      sym_declaration_list,
    STATE(7677), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [339109] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9734), 1,
      anon_sym_COLON,
    STATE(7987), 1,
      aux_sym_class_declaration_repeat3,
    STATE(7988), 1,
      sym_base_list,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9476), 1,
      sym_declaration_list,
    STATE(7678), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [339168] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9734), 1,
      anon_sym_COLON,
    STATE(7936), 1,
      aux_sym_class_declaration_repeat3,
    STATE(7937), 1,
      sym_base_list,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9000), 1,
      sym_declaration_list,
    STATE(7679), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [339227] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9734), 1,
      anon_sym_COLON,
    STATE(7933), 1,
      sym_base_list,
    STATE(7935), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9001), 1,
      sym_declaration_list,
    STATE(7680), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [339286] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9734), 1,
      anon_sym_COLON,
    STATE(8069), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8072), 1,
      sym_base_list,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9004), 1,
      sym_declaration_list,
    STATE(7681), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [339345] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9734), 1,
      anon_sym_COLON,
    STATE(7931), 1,
      aux_sym_class_declaration_repeat3,
    STATE(7932), 1,
      sym_base_list,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9002), 1,
      sym_declaration_list,
    STATE(7682), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [339404] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9838), 1,
      sym_interpolation_open_brace,
    ACTIONS(9840), 1,
      anon_sym_DQUOTE,
    STATE(7717), 1,
      aux_sym_interpolated_string_expression_repeat1,
    STATE(8283), 1,
      sym__interpolated_string_content,
    STATE(8292), 1,
      sym_interpolation,
    ACTIONS(9836), 2,
      sym_interpolation_string_content,
      sym_escape_sequence,
    STATE(7683), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [339461] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9734), 1,
      anon_sym_COLON,
    STATE(8076), 1,
      sym_base_list,
    STATE(8104), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9240), 1,
      sym_declaration_list,
    STATE(7684), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [339520] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9842), 7,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(7685), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [339567] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9734), 1,
      anon_sym_COLON,
    STATE(8048), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8054), 1,
      sym_base_list,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9534), 1,
      sym_declaration_list,
    STATE(7686), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [339626] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9734), 1,
      anon_sym_COLON,
    STATE(8026), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8057), 1,
      sym_base_list,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9232), 1,
      sym_declaration_list,
    STATE(7687), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [339685] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9838), 1,
      sym_interpolation_open_brace,
    ACTIONS(9844), 1,
      anon_sym_DQUOTE,
    STATE(7712), 1,
      aux_sym_interpolated_string_expression_repeat1,
    STATE(8283), 1,
      sym__interpolated_string_content,
    STATE(8292), 1,
      sym_interpolation,
    ACTIONS(9836), 2,
      sym_interpolation_string_content,
      sym_escape_sequence,
    STATE(7688), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [339742] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9838), 1,
      sym_interpolation_open_brace,
    ACTIONS(9846), 1,
      anon_sym_DQUOTE,
    STATE(7703), 1,
      aux_sym_interpolated_string_expression_repeat1,
    STATE(8283), 1,
      sym__interpolated_string_content,
    STATE(8292), 1,
      sym_interpolation,
    ACTIONS(9836), 2,
      sym_interpolation_string_content,
      sym_escape_sequence,
    STATE(7689), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [339799] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9734), 1,
      anon_sym_COLON,
    STATE(7956), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8042), 1,
      sym_base_list,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9535), 1,
      sym_declaration_list,
    STATE(7690), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [339858] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9734), 1,
      anon_sym_COLON,
    STATE(7996), 1,
      aux_sym_class_declaration_repeat3,
    STATE(7997), 1,
      sym_base_list,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9517), 1,
      sym_declaration_list,
    STATE(7691), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [339917] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9734), 1,
      anon_sym_COLON,
    STATE(8111), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8119), 1,
      sym_base_list,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9679), 1,
      sym_declaration_list,
    STATE(7692), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [339976] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9734), 1,
      anon_sym_COLON,
    STATE(7915), 1,
      sym_base_list,
    STATE(7918), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9211), 1,
      sym_declaration_list,
    STATE(7693), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [340035] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9734), 1,
      anon_sym_COLON,
    STATE(8105), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8107), 1,
      sym_base_list,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9815), 1,
      sym_declaration_list,
    STATE(7694), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [340094] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9734), 1,
      anon_sym_COLON,
    STATE(7998), 1,
      sym_base_list,
    STATE(8000), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9518), 1,
      sym_declaration_list,
    STATE(7695), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [340153] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9734), 1,
      anon_sym_COLON,
    STATE(7925), 1,
      aux_sym_class_declaration_repeat3,
    STATE(7927), 1,
      sym_base_list,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9085), 1,
      sym_declaration_list,
    STATE(7696), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [340212] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9734), 1,
      anon_sym_COLON,
    STATE(8187), 1,
      sym_base_list,
    STATE(8188), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9405), 1,
      sym_declaration_list,
    STATE(7697), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [340271] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9734), 1,
      anon_sym_COLON,
    STATE(7940), 1,
      aux_sym_class_declaration_repeat3,
    STATE(7941), 1,
      sym_base_list,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9087), 1,
      sym_declaration_list,
    STATE(7698), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [340330] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9734), 1,
      anon_sym_COLON,
    STATE(8167), 1,
      sym_base_list,
    STATE(8201), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9302), 1,
      sym_declaration_list,
    STATE(7699), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [340389] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9734), 1,
      anon_sym_COLON,
    STATE(8118), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8121), 1,
      sym_base_list,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9806), 1,
      sym_declaration_list,
    STATE(7700), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [340448] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9848), 1,
      anon_sym_catch,
    ACTIONS(9850), 1,
      anon_sym_finally,
    STATE(7719), 1,
      aux_sym_try_statement_repeat1,
    STATE(8308), 1,
      sym_catch_clause,
    STATE(8838), 1,
      sym_finally_clause,
    ACTIONS(2947), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(7701), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [340505] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9734), 1,
      anon_sym_COLON,
    STATE(7991), 1,
      aux_sym_class_declaration_repeat3,
    STATE(7992), 1,
      sym_base_list,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9100), 1,
      sym_declaration_list,
    STATE(7702), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [340564] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9838), 1,
      sym_interpolation_open_brace,
    ACTIONS(9852), 1,
      anon_sym_DQUOTE,
    STATE(7712), 1,
      aux_sym_interpolated_string_expression_repeat1,
    STATE(8283), 1,
      sym__interpolated_string_content,
    STATE(8292), 1,
      sym_interpolation,
    ACTIONS(9836), 2,
      sym_interpolation_string_content,
      sym_escape_sequence,
    STATE(7703), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [340621] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9734), 1,
      anon_sym_COLON,
    STATE(7944), 1,
      aux_sym_class_declaration_repeat3,
    STATE(7945), 1,
      sym_base_list,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9091), 1,
      sym_declaration_list,
    STATE(7704), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [340680] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9734), 1,
      anon_sym_COLON,
    STATE(8049), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8052), 1,
      sym_base_list,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9030), 1,
      sym_declaration_list,
    STATE(7705), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [340739] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9734), 1,
      anon_sym_COLON,
    STATE(7965), 1,
      sym_base_list,
    STATE(7966), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9360), 1,
      sym_declaration_list,
    STATE(7706), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [340798] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9734), 1,
      anon_sym_COLON,
    STATE(8002), 1,
      sym_base_list,
    STATE(8003), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9058), 1,
      sym_declaration_list,
    STATE(7707), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [340857] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9734), 1,
      anon_sym_COLON,
    STATE(8094), 1,
      sym_base_list,
    STATE(8099), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9291), 1,
      sym_declaration_list,
    STATE(7708), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [340916] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9854), 7,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(7709), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [340963] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9734), 1,
      anon_sym_COLON,
    STATE(8120), 1,
      sym_base_list,
    STATE(8124), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9320), 1,
      sym_declaration_list,
    STATE(7710), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [341022] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9734), 1,
      anon_sym_COLON,
    STATE(7993), 1,
      sym_base_list,
    STATE(7994), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9097), 1,
      sym_declaration_list,
    STATE(7711), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [341081] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9856), 1,
      anon_sym_DQUOTE,
    ACTIONS(9861), 1,
      sym_interpolation_open_brace,
    STATE(8283), 1,
      sym__interpolated_string_content,
    STATE(8292), 1,
      sym_interpolation,
    ACTIONS(9858), 2,
      sym_interpolation_string_content,
      sym_escape_sequence,
    STATE(7712), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_interpolated_string_expression_repeat1,
  [341136] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9838), 1,
      sym_interpolation_open_brace,
    ACTIONS(9864), 1,
      anon_sym_DQUOTE,
    STATE(7712), 1,
      aux_sym_interpolated_string_expression_repeat1,
    STATE(8283), 1,
      sym__interpolated_string_content,
    STATE(8292), 1,
      sym_interpolation,
    ACTIONS(9836), 2,
      sym_interpolation_string_content,
      sym_escape_sequence,
    STATE(7713), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [341193] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9838), 1,
      sym_interpolation_open_brace,
    ACTIONS(9866), 1,
      anon_sym_DQUOTE,
    STATE(7713), 1,
      aux_sym_interpolated_string_expression_repeat1,
    STATE(8283), 1,
      sym__interpolated_string_content,
    STATE(8292), 1,
      sym_interpolation,
    ACTIONS(9836), 2,
      sym_interpolation_string_content,
      sym_escape_sequence,
    STATE(7714), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [341250] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9734), 1,
      anon_sym_COLON,
    STATE(7917), 1,
      aux_sym_class_declaration_repeat3,
    STATE(7922), 1,
      sym_base_list,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9616), 1,
      sym_declaration_list,
    STATE(7715), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [341309] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9734), 1,
      anon_sym_COLON,
    STATE(8012), 1,
      sym_base_list,
    STATE(8013), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9555), 1,
      sym_declaration_list,
    STATE(7716), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [341368] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9838), 1,
      sym_interpolation_open_brace,
    ACTIONS(9868), 1,
      anon_sym_DQUOTE,
    STATE(7712), 1,
      aux_sym_interpolated_string_expression_repeat1,
    STATE(8283), 1,
      sym__interpolated_string_content,
    STATE(8292), 1,
      sym_interpolation,
    ACTIONS(9836), 2,
      sym_interpolation_string_content,
      sym_escape_sequence,
    STATE(7717), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [341425] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9734), 1,
      anon_sym_COLON,
    STATE(8078), 1,
      sym_base_list,
    STATE(8081), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9629), 1,
      sym_declaration_list,
    STATE(7718), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [341484] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9848), 1,
      anon_sym_catch,
    ACTIONS(9850), 1,
      anon_sym_finally,
    STATE(7756), 1,
      aux_sym_try_statement_repeat1,
    STATE(8308), 1,
      sym_catch_clause,
    STATE(8812), 1,
      sym_finally_clause,
    ACTIONS(2939), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(7719), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [341541] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9734), 1,
      anon_sym_COLON,
    STATE(8055), 1,
      sym_base_list,
    STATE(8067), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9532), 1,
      sym_declaration_list,
    STATE(7720), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [341600] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9734), 1,
      anon_sym_COLON,
    STATE(8024), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8025), 1,
      sym_base_list,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9724), 1,
      sym_declaration_list,
    STATE(7721), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [341659] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9734), 1,
      anon_sym_COLON,
    STATE(8060), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8129), 1,
      sym_base_list,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9270), 1,
      sym_declaration_list,
    STATE(7722), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [341718] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9734), 1,
      anon_sym_COLON,
    STATE(8066), 1,
      sym_base_list,
    STATE(8068), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9005), 1,
      sym_declaration_list,
    STATE(7723), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [341777] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9734), 1,
      anon_sym_COLON,
    STATE(8138), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8140), 1,
      sym_base_list,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(8963), 1,
      sym_declaration_list,
    STATE(7724), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [341836] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9838), 1,
      sym_interpolation_open_brace,
    ACTIONS(9870), 1,
      anon_sym_DQUOTE,
    STATE(7688), 1,
      aux_sym_interpolated_string_expression_repeat1,
    STATE(8283), 1,
      sym__interpolated_string_content,
    STATE(8292), 1,
      sym_interpolation,
    ACTIONS(9836), 2,
      sym_interpolation_string_content,
      sym_escape_sequence,
    STATE(7725), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [341893] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9734), 1,
      anon_sym_COLON,
    STATE(8133), 1,
      sym_base_list,
    STATE(8135), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9791), 1,
      sym_declaration_list,
    STATE(7726), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [341952] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9734), 1,
      anon_sym_COLON,
    STATE(8040), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8041), 1,
      sym_base_list,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9844), 1,
      sym_declaration_list,
    STATE(7727), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [342011] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9734), 1,
      anon_sym_COLON,
    STATE(8144), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8147), 1,
      sym_base_list,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9069), 1,
      sym_declaration_list,
    STATE(7728), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [342070] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9734), 1,
      anon_sym_COLON,
    STATE(7952), 1,
      aux_sym_class_declaration_repeat3,
    STATE(7953), 1,
      sym_base_list,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9118), 1,
      sym_declaration_list,
    STATE(7729), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [342129] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9734), 1,
      anon_sym_COLON,
    STATE(8151), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8152), 1,
      sym_base_list,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9057), 1,
      sym_declaration_list,
    STATE(7730), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [342188] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9734), 1,
      anon_sym_COLON,
    STATE(8145), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8153), 1,
      sym_base_list,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9741), 1,
      sym_declaration_list,
    STATE(7731), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [342247] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9734), 1,
      anon_sym_COLON,
    STATE(8034), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8035), 1,
      sym_base_list,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9037), 1,
      sym_declaration_list,
    STATE(7732), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [342306] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9734), 1,
      anon_sym_COLON,
    STATE(8028), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8029), 1,
      sym_base_list,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9774), 1,
      sym_declaration_list,
    STATE(7733), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [342365] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9734), 1,
      anon_sym_COLON,
    STATE(7957), 1,
      aux_sym_class_declaration_repeat3,
    STATE(7968), 1,
      sym_base_list,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9114), 1,
      sym_declaration_list,
    STATE(7734), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [342424] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9872), 7,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(7735), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [342471] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9734), 1,
      anon_sym_COLON,
    STATE(8030), 1,
      sym_base_list,
    STATE(8032), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9777), 1,
      sym_declaration_list,
    STATE(7736), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [342530] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9734), 1,
      anon_sym_COLON,
    STATE(7958), 1,
      sym_base_list,
    STATE(7960), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9680), 1,
      sym_declaration_list,
    STATE(7737), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [342589] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9838), 1,
      sym_interpolation_open_brace,
    ACTIONS(9874), 1,
      anon_sym_DQUOTE,
    STATE(7676), 1,
      aux_sym_interpolated_string_expression_repeat1,
    STATE(8283), 1,
      sym__interpolated_string_content,
    STATE(8292), 1,
      sym_interpolation,
    ACTIONS(9836), 2,
      sym_interpolation_string_content,
      sym_escape_sequence,
    STATE(7738), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [342646] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9734), 1,
      anon_sym_COLON,
    STATE(8206), 1,
      sym_base_list,
    STATE(8207), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9736), 1,
      sym_declaration_list,
    STATE(7739), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [342705] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9876), 7,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(7740), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [342752] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9734), 1,
      anon_sym_COLON,
    STATE(7914), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8131), 1,
      sym_base_list,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9792), 1,
      sym_declaration_list,
    STATE(7741), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [342811] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7248), 1,
      anon_sym_LT,
    ACTIONS(7394), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9878), 1,
      anon_sym_EQ,
    STATE(2736), 1,
      sym_type_argument_list,
    ACTIONS(4076), 2,
      anon_sym_SEMI,
      anon_sym_DOT,
    STATE(7742), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [342865] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9880), 1,
      anon_sym_SEMI,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9886), 1,
      sym_declaration_list,
    STATE(7743), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [342921] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9758), 1,
      anon_sym_SEMI,
    STATE(7803), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9805), 1,
      sym_declaration_list,
    STATE(7744), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [342977] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9768), 1,
      anon_sym_SEMI,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9056), 1,
      sym_declaration_list,
    STATE(7745), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [343033] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9882), 1,
      anon_sym_SEMI,
    STATE(7775), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9839), 1,
      sym_declaration_list,
    STATE(7746), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [343089] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9884), 1,
      anon_sym_SEMI,
    STATE(7796), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9328), 1,
      sym_declaration_list,
    STATE(7747), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [343145] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9882), 1,
      anon_sym_SEMI,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9839), 1,
      sym_declaration_list,
    STATE(7748), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [343201] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9888), 1,
      anon_sym_COMMA,
    STATE(7909), 1,
      aux_sym_type_parameter_constraints_clause_repeat1,
    ACTIONS(9886), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_where,
      anon_sym_EQ_GT,
    STATE(7749), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [343251] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9890), 1,
      anon_sym_SEMI,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9830), 1,
      sym_declaration_list,
    STATE(7750), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [343307] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9818), 1,
      anon_sym_SEMI,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9310), 1,
      sym_declaration_list,
    STATE(7751), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [343363] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7248), 1,
      anon_sym_LT,
    ACTIONS(7394), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9892), 1,
      anon_sym_EQ,
    STATE(2736), 1,
      sym_type_argument_list,
    ACTIONS(4076), 2,
      anon_sym_SEMI,
      anon_sym_DOT,
    STATE(7752), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [343417] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9764), 1,
      anon_sym_SEMI,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9711), 1,
      sym_declaration_list,
    STATE(7753), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [343473] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5980), 1,
      anon_sym_LBRACE,
    ACTIONS(9894), 1,
      anon_sym_LPAREN,
    ACTIONS(9896), 1,
      anon_sym_when,
    STATE(8244), 1,
      sym_catch_declaration,
    STATE(8340), 1,
      sym_block,
    STATE(8956), 1,
      sym_catch_filter_clause,
    STATE(7754), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [343529] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9898), 1,
      anon_sym_SEMI,
    STATE(7777), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9297), 1,
      sym_declaration_list,
    STATE(7755), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [343585] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9900), 1,
      anon_sym_catch,
    STATE(8308), 1,
      sym_catch_clause,
    ACTIONS(2951), 3,
      anon_sym_while,
      anon_sym_finally,
      anon_sym_else,
    STATE(7756), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_try_statement_repeat1,
  [343635] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9764), 1,
      anon_sym_SEMI,
    STATE(7827), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9711), 1,
      sym_declaration_list,
    STATE(7757), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [343691] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9874), 1,
      sym_interpolation_end_quote,
    ACTIONS(9903), 1,
      sym_interpolation_open_brace,
    ACTIONS(9905), 1,
      sym_interpolation_string_content,
    STATE(7844), 1,
      aux_sym_interpolated_string_expression_repeat3,
    STATE(8416), 1,
      sym_interpolation,
    STATE(8418), 1,
      sym__interpolated_raw_string_content,
    STATE(7758), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [343747] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4424), 1,
      anon_sym_GT,
    ACTIONS(7250), 1,
      anon_sym_LBRACK,
    ACTIONS(7252), 1,
      anon_sym_STAR,
    ACTIONS(7396), 1,
      anon_sym_DOT,
    ACTIONS(9907), 1,
      anon_sym_COMMA,
    ACTIONS(9909), 1,
      anon_sym_QMARK,
    STATE(7759), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [343803] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9884), 1,
      anon_sym_SEMI,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9328), 1,
      sym_declaration_list,
    STATE(7760), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [343859] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9913), 1,
      anon_sym_COMMA,
    ACTIONS(9911), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_where,
      anon_sym_EQ_GT,
    STATE(7761), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_type_parameter_constraints_clause_repeat1,
  [343907] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7250), 1,
      anon_sym_LBRACK,
    ACTIONS(7252), 1,
      anon_sym_STAR,
    ACTIONS(7396), 1,
      anon_sym_DOT,
    ACTIONS(9909), 1,
      anon_sym_QMARK,
    ACTIONS(4424), 2,
      anon_sym_COMMA,
      anon_sym_GT,
    STATE(7762), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [343961] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9916), 1,
      anon_sym_SEMI,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9112), 1,
      sym_declaration_list,
    STATE(7763), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [344017] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9916), 1,
      anon_sym_SEMI,
    STATE(7782), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9112), 1,
      sym_declaration_list,
    STATE(7764), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [344073] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9683), 1,
      anon_sym_EQ_GT,
    ACTIONS(9774), 1,
      anon_sym_SEMI,
    ACTIONS(9776), 1,
      anon_sym_LBRACE,
    STATE(3144), 1,
      sym_block,
    STATE(3441), 1,
      sym__function_body,
    STATE(8980), 1,
      sym_arrow_expression_clause,
    STATE(7765), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [344129] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9898), 1,
      anon_sym_SEMI,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9297), 1,
      sym_declaration_list,
    STATE(7766), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [344185] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9683), 1,
      anon_sym_EQ_GT,
    ACTIONS(9774), 1,
      anon_sym_SEMI,
    ACTIONS(9776), 1,
      anon_sym_LBRACE,
    STATE(3144), 1,
      sym_block,
    STATE(3472), 1,
      sym__function_body,
    STATE(8980), 1,
      sym_arrow_expression_clause,
    STATE(7767), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [344241] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9838), 1,
      sym_interpolation_open_brace,
    ACTIONS(9846), 1,
      anon_sym_DQUOTE,
    ACTIONS(9918), 1,
      sym_interpolation_string_content,
    STATE(7898), 1,
      aux_sym_interpolated_string_expression_repeat2,
    STATE(8411), 1,
      sym_interpolation,
    STATE(8412), 1,
      sym__interpolated_verbatim_string_content,
    STATE(7768), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [344297] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9804), 1,
      anon_sym_SEMI,
    STATE(7848), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9019), 1,
      sym_declaration_list,
    STATE(7769), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [344353] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9808), 1,
      anon_sym_SEMI,
    STATE(7748), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9773), 1,
      sym_declaration_list,
    STATE(7770), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [344409] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9920), 1,
      anon_sym_SEMI,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9195), 1,
      sym_declaration_list,
    STATE(7771), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [344465] = 16,
    ACTIONS(9485), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9487), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9489), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9491), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9493), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9495), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9497), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9499), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9501), 1,
      sym_comment,
    ACTIONS(9922), 1,
      anon_sym_DQUOTE,
    ACTIONS(9924), 1,
      aux_sym_string_literal_content_token1,
    ACTIONS(9926), 1,
      aux_sym_string_literal_content_token2,
    ACTIONS(9928), 1,
      sym_escape_sequence,
    STATE(7882), 1,
      aux_sym_string_literal_repeat1,
    STATE(8266), 1,
      sym_string_literal_content,
    STATE(7772), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [344521] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9804), 1,
      anon_sym_SEMI,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9019), 1,
      sym_declaration_list,
    STATE(7773), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [344577] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9808), 1,
      anon_sym_SEMI,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9773), 1,
      sym_declaration_list,
    STATE(7774), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [344633] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9930), 1,
      anon_sym_SEMI,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9864), 1,
      sym_declaration_list,
    STATE(7775), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [344689] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9802), 1,
      anon_sym_SEMI,
    STATE(7790), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9854), 1,
      sym_declaration_list,
    STATE(7776), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [344745] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9932), 1,
      anon_sym_SEMI,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9316), 1,
      sym_declaration_list,
    STATE(7777), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [344801] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9812), 1,
      anon_sym_SEMI,
    STATE(7819), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9761), 1,
      sym_declaration_list,
    STATE(7778), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [344857] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7248), 1,
      anon_sym_LT,
    ACTIONS(7394), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9934), 1,
      anon_sym_EQ,
    STATE(2736), 1,
      sym_type_argument_list,
    ACTIONS(4076), 2,
      anon_sym_SEMI,
      anon_sym_DOT,
    STATE(7779), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [344911] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9936), 1,
      anon_sym_SEMI,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9888), 1,
      sym_declaration_list,
    STATE(7780), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [344967] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9938), 1,
      anon_sym_SEMI,
    STATE(7750), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9615), 1,
      sym_declaration_list,
    STATE(7781), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [345023] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9940), 1,
      anon_sym_SEMI,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9279), 1,
      sym_declaration_list,
    STATE(7782), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [345079] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9822), 1,
      anon_sym_SEMI,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9230), 1,
      sym_declaration_list,
    STATE(7783), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [345135] = 16,
    ACTIONS(9485), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9487), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9489), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9491), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9493), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9495), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9497), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9499), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9501), 1,
      sym_comment,
    ACTIONS(9924), 1,
      aux_sym_string_literal_content_token1,
    ACTIONS(9926), 1,
      aux_sym_string_literal_content_token2,
    ACTIONS(9928), 1,
      sym_escape_sequence,
    ACTIONS(9942), 1,
      anon_sym_DQUOTE,
    STATE(7882), 1,
      aux_sym_string_literal_repeat1,
    STATE(8266), 1,
      sym_string_literal_content,
    STATE(7784), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [345191] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9868), 1,
      sym_interpolation_end_quote,
    ACTIONS(9903), 1,
      sym_interpolation_open_brace,
    ACTIONS(9905), 1,
      sym_interpolation_string_content,
    STATE(7795), 1,
      aux_sym_interpolated_string_expression_repeat3,
    STATE(8416), 1,
      sym_interpolation,
    STATE(8418), 1,
      sym__interpolated_raw_string_content,
    STATE(7785), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [345247] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9938), 1,
      anon_sym_SEMI,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9615), 1,
      sym_declaration_list,
    STATE(7786), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [345303] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9838), 1,
      sym_interpolation_open_brace,
    ACTIONS(9868), 1,
      anon_sym_DQUOTE,
    ACTIONS(9918), 1,
      sym_interpolation_string_content,
    STATE(7797), 1,
      aux_sym_interpolated_string_expression_repeat2,
    STATE(8411), 1,
      sym_interpolation,
    STATE(8412), 1,
      sym__interpolated_verbatim_string_content,
    STATE(7787), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [345359] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7248), 1,
      anon_sym_LT,
    ACTIONS(7394), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9944), 1,
      anon_sym_EQ,
    STATE(2736), 1,
      sym_type_argument_list,
    ACTIONS(4076), 2,
      anon_sym_SEMI,
      anon_sym_DOT,
    STATE(7788), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [345413] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9683), 1,
      anon_sym_EQ_GT,
    ACTIONS(9774), 1,
      anon_sym_SEMI,
    ACTIONS(9776), 1,
      anon_sym_LBRACE,
    STATE(3144), 1,
      sym_block,
    STATE(3412), 1,
      sym__function_body,
    STATE(8980), 1,
      sym_arrow_expression_clause,
    STATE(7789), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [345469] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9946), 1,
      anon_sym_SEMI,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9870), 1,
      sym_declaration_list,
    STATE(7790), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [345525] = 16,
    ACTIONS(9485), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9487), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9489), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9491), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9493), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9495), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9497), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9499), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9501), 1,
      sym_comment,
    ACTIONS(9924), 1,
      aux_sym_string_literal_content_token1,
    ACTIONS(9926), 1,
      aux_sym_string_literal_content_token2,
    ACTIONS(9928), 1,
      sym_escape_sequence,
    ACTIONS(9948), 1,
      anon_sym_DQUOTE,
    STATE(7806), 1,
      aux_sym_string_literal_repeat1,
    STATE(8266), 1,
      sym_string_literal_content,
    STATE(7791), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [345581] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9846), 1,
      sym_interpolation_end_quote,
    ACTIONS(9903), 1,
      sym_interpolation_open_brace,
    ACTIONS(9905), 1,
      sym_interpolation_string_content,
    STATE(7899), 1,
      aux_sym_interpolated_string_expression_repeat3,
    STATE(8416), 1,
      sym_interpolation,
    STATE(8418), 1,
      sym__interpolated_raw_string_content,
    STATE(7792), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [345637] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9822), 1,
      anon_sym_SEMI,
    STATE(7766), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9230), 1,
      sym_declaration_list,
    STATE(7793), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [345693] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9952), 1,
      anon_sym_QMARK,
    ACTIONS(9950), 5,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_where,
      anon_sym_EQ_GT,
    STATE(7794), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [345741] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9954), 1,
      sym_interpolation_end_quote,
    ACTIONS(9956), 1,
      sym_interpolation_open_brace,
    ACTIONS(9959), 1,
      sym_interpolation_string_content,
    STATE(8416), 1,
      sym_interpolation,
    STATE(8418), 1,
      sym__interpolated_raw_string_content,
    STATE(7795), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_interpolated_string_expression_repeat3,
  [345795] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9962), 1,
      anon_sym_SEMI,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9334), 1,
      sym_declaration_list,
    STATE(7796), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [345851] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9964), 1,
      anon_sym_DQUOTE,
    ACTIONS(9966), 1,
      sym_interpolation_open_brace,
    ACTIONS(9969), 1,
      sym_interpolation_string_content,
    STATE(8411), 1,
      sym_interpolation,
    STATE(8412), 1,
      sym__interpolated_verbatim_string_content,
    STATE(7797), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_interpolated_string_expression_repeat2,
  [345905] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9838), 1,
      sym_interpolation_open_brace,
    ACTIONS(9866), 1,
      anon_sym_DQUOTE,
    ACTIONS(9918), 1,
      sym_interpolation_string_content,
    STATE(7820), 1,
      aux_sym_interpolated_string_expression_repeat2,
    STATE(8411), 1,
      sym_interpolation,
    STATE(8412), 1,
      sym__interpolated_verbatim_string_content,
    STATE(7798), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [345961] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9758), 1,
      anon_sym_SEMI,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9805), 1,
      sym_declaration_list,
    STATE(7799), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [346017] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9866), 1,
      sym_interpolation_end_quote,
    ACTIONS(9903), 1,
      sym_interpolation_open_brace,
    ACTIONS(9905), 1,
      sym_interpolation_string_content,
    STATE(7832), 1,
      aux_sym_interpolated_string_expression_repeat3,
    STATE(8416), 1,
      sym_interpolation,
    STATE(8418), 1,
      sym__interpolated_raw_string_content,
    STATE(7800), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [346073] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9683), 1,
      anon_sym_EQ_GT,
    ACTIONS(9774), 1,
      anon_sym_SEMI,
    ACTIONS(9776), 1,
      anon_sym_LBRACE,
    STATE(3144), 1,
      sym_block,
    STATE(3366), 1,
      sym__function_body,
    STATE(8980), 1,
      sym_arrow_expression_clause,
    STATE(7801), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [346129] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7248), 1,
      anon_sym_LT,
    ACTIONS(7394), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9972), 1,
      anon_sym_EQ,
    STATE(2736), 1,
      sym_type_argument_list,
    ACTIONS(4076), 2,
      anon_sym_SEMI,
      anon_sym_DOT,
    STATE(7802), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [346183] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9812), 1,
      anon_sym_SEMI,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9761), 1,
      sym_declaration_list,
    STATE(7803), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [346239] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9946), 1,
      anon_sym_SEMI,
    STATE(7743), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9870), 1,
      sym_declaration_list,
    STATE(7804), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [346295] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9683), 1,
      anon_sym_EQ_GT,
    ACTIONS(9774), 1,
      anon_sym_SEMI,
    ACTIONS(9776), 1,
      anon_sym_LBRACE,
    STATE(3144), 1,
      sym_block,
    STATE(3234), 1,
      sym__function_body,
    STATE(8980), 1,
      sym_arrow_expression_clause,
    STATE(7805), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [346351] = 16,
    ACTIONS(9485), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9487), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9489), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9491), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9493), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9495), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9497), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9499), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9501), 1,
      sym_comment,
    ACTIONS(9924), 1,
      aux_sym_string_literal_content_token1,
    ACTIONS(9926), 1,
      aux_sym_string_literal_content_token2,
    ACTIONS(9928), 1,
      sym_escape_sequence,
    ACTIONS(9974), 1,
      anon_sym_DQUOTE,
    STATE(7882), 1,
      aux_sym_string_literal_repeat1,
    STATE(8266), 1,
      sym_string_literal_content,
    STATE(7806), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [346407] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9683), 1,
      anon_sym_EQ_GT,
    ACTIONS(9976), 1,
      anon_sym_SEMI,
    ACTIONS(9978), 1,
      anon_sym_LBRACE,
    STATE(4330), 1,
      sym__function_body,
    STATE(4332), 1,
      sym_block,
    STATE(9876), 1,
      sym_arrow_expression_clause,
    STATE(7807), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [346463] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9754), 1,
      anon_sym_SEMI,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9013), 1,
      sym_declaration_list,
    STATE(7808), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [346519] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4081), 1,
      anon_sym_EQ_GT,
    ACTIONS(9980), 1,
      anon_sym_EQ,
    ACTIONS(4247), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_or,
    STATE(7809), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [346569] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9683), 1,
      anon_sym_EQ_GT,
    ACTIONS(9774), 1,
      anon_sym_SEMI,
    ACTIONS(9776), 1,
      anon_sym_LBRACE,
    STATE(3144), 1,
      sym_block,
    STATE(3335), 1,
      sym__function_body,
    STATE(8980), 1,
      sym_arrow_expression_clause,
    STATE(7810), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [346625] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9982), 1,
      anon_sym_SEMI,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9831), 1,
      sym_declaration_list,
    STATE(7811), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [346681] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9806), 1,
      anon_sym_SEMI,
    STATE(7868), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9553), 1,
      sym_declaration_list,
    STATE(7812), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [346737] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9984), 1,
      anon_sym_SEMI,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9428), 1,
      sym_declaration_list,
    STATE(7813), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [346793] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9754), 1,
      anon_sym_SEMI,
    STATE(7888), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9013), 1,
      sym_declaration_list,
    STATE(7814), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [346849] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9986), 1,
      anon_sym_SEMI,
    STATE(7851), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9407), 1,
      sym_declaration_list,
    STATE(7815), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [346905] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9766), 1,
      anon_sym_SEMI,
    STATE(7885), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9547), 1,
      sym_declaration_list,
    STATE(7816), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [346961] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9770), 1,
      anon_sym_SEMI,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9528), 1,
      sym_declaration_list,
    STATE(7817), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [347017] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9982), 1,
      anon_sym_SEMI,
    STATE(7813), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9831), 1,
      sym_declaration_list,
    STATE(7818), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [347073] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9986), 1,
      anon_sym_SEMI,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9407), 1,
      sym_declaration_list,
    STATE(7819), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [347129] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9838), 1,
      sym_interpolation_open_brace,
    ACTIONS(9864), 1,
      anon_sym_DQUOTE,
    ACTIONS(9918), 1,
      sym_interpolation_string_content,
    STATE(7797), 1,
      aux_sym_interpolated_string_expression_repeat2,
    STATE(8411), 1,
      sym_interpolation,
    STATE(8412), 1,
      sym__interpolated_verbatim_string_content,
    STATE(7820), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [347185] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9768), 1,
      anon_sym_SEMI,
    STATE(7783), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9056), 1,
      sym_declaration_list,
    STATE(7821), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [347241] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9683), 1,
      anon_sym_EQ_GT,
    ACTIONS(9976), 1,
      anon_sym_SEMI,
    ACTIONS(9978), 1,
      anon_sym_LBRACE,
    STATE(4315), 1,
      sym__function_body,
    STATE(4332), 1,
      sym_block,
    STATE(9876), 1,
      sym_arrow_expression_clause,
    STATE(7822), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [347297] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9756), 1,
      anon_sym_SEMI,
    STATE(7773), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(8970), 1,
      sym_declaration_list,
    STATE(7823), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [347353] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9988), 1,
      anon_sym_SEMI,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9343), 1,
      sym_declaration_list,
    STATE(7824), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [347409] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9770), 1,
      anon_sym_SEMI,
    STATE(7774), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9528), 1,
      sym_declaration_list,
    STATE(7825), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [347465] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5707), 1,
      anon_sym_LBRACE,
    ACTIONS(9894), 1,
      anon_sym_LPAREN,
    ACTIONS(9896), 1,
      anon_sym_when,
    STATE(2296), 1,
      sym_block,
    STATE(8216), 1,
      sym_catch_declaration,
    STATE(8889), 1,
      sym_catch_filter_clause,
    STATE(7826), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [347521] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9802), 1,
      anon_sym_SEMI,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9854), 1,
      sym_declaration_list,
    STATE(7827), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [347577] = 16,
    ACTIONS(9485), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9487), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9489), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9491), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9493), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9495), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9497), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9499), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9501), 1,
      sym_comment,
    ACTIONS(9924), 1,
      aux_sym_string_literal_content_token1,
    ACTIONS(9926), 1,
      aux_sym_string_literal_content_token2,
    ACTIONS(9928), 1,
      sym_escape_sequence,
    ACTIONS(9990), 1,
      anon_sym_DQUOTE,
    STATE(7892), 1,
      aux_sym_string_literal_repeat1,
    STATE(8266), 1,
      sym_string_literal_content,
    STATE(7828), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [347633] = 12,
    ACTIONS(3719), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(9485), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9487), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9489), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9491), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9493), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9495), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9497), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9499), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9501), 1,
      sym_comment,
    ACTIONS(3721), 5,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
    STATE(7829), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [347681] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9772), 1,
      anon_sym_SEMI,
    STATE(7895), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9060), 1,
      sym_declaration_list,
    STATE(7830), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [347737] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9992), 6,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_in,
    STATE(7831), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [347783] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9864), 1,
      sym_interpolation_end_quote,
    ACTIONS(9903), 1,
      sym_interpolation_open_brace,
    ACTIONS(9905), 1,
      sym_interpolation_string_content,
    STATE(7795), 1,
      aux_sym_interpolated_string_expression_repeat3,
    STATE(8416), 1,
      sym_interpolation,
    STATE(8418), 1,
      sym__interpolated_raw_string_content,
    STATE(7832), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [347839] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9772), 1,
      anon_sym_SEMI,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9060), 1,
      sym_declaration_list,
    STATE(7833), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [347895] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9818), 1,
      anon_sym_SEMI,
    STATE(7760), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9310), 1,
      sym_declaration_list,
    STATE(7834), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [347951] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9994), 6,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_in,
    STATE(7835), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [347997] = 16,
    ACTIONS(9485), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9487), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9489), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9491), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9493), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9495), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9497), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9499), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9501), 1,
      sym_comment,
    ACTIONS(9924), 1,
      aux_sym_string_literal_content_token1,
    ACTIONS(9926), 1,
      aux_sym_string_literal_content_token2,
    ACTIONS(9928), 1,
      sym_escape_sequence,
    ACTIONS(9996), 1,
      anon_sym_DQUOTE,
    STATE(7882), 1,
      aux_sym_string_literal_repeat1,
    STATE(8266), 1,
      sym_string_literal_content,
    STATE(7836), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [348053] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9766), 1,
      anon_sym_SEMI,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9547), 1,
      sym_declaration_list,
    STATE(7837), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [348109] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8449), 1,
      anon_sym_DOT,
    ACTIONS(9826), 1,
      anon_sym_COMMA,
    STATE(8102), 1,
      aux_sym_record_base_repeat1,
    ACTIONS(9998), 3,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_where,
    STATE(7838), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [348161] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9683), 1,
      anon_sym_EQ_GT,
    ACTIONS(9774), 1,
      anon_sym_SEMI,
    ACTIONS(9776), 1,
      anon_sym_LBRACE,
    STATE(3144), 1,
      sym_block,
    STATE(3293), 1,
      sym__function_body,
    STATE(8980), 1,
      sym_arrow_expression_clause,
    STATE(7839), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [348217] = 12,
    ACTIONS(4058), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(9485), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9487), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9489), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9491), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9493), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9495), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9497), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9499), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9501), 1,
      sym_comment,
    ACTIONS(4056), 5,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
    STATE(7840), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [348265] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9838), 1,
      sym_interpolation_open_brace,
    ACTIONS(9874), 1,
      anon_sym_DQUOTE,
    ACTIONS(9918), 1,
      sym_interpolation_string_content,
    STATE(7843), 1,
      aux_sym_interpolated_string_expression_repeat2,
    STATE(8411), 1,
      sym_interpolation,
    STATE(8412), 1,
      sym__interpolated_verbatim_string_content,
    STATE(7841), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [348321] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9683), 1,
      anon_sym_EQ_GT,
    ACTIONS(9774), 1,
      anon_sym_SEMI,
    ACTIONS(9776), 1,
      anon_sym_LBRACE,
    STATE(3144), 1,
      sym_block,
    STATE(3228), 1,
      sym__function_body,
    STATE(8980), 1,
      sym_arrow_expression_clause,
    STATE(7842), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [348377] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9834), 1,
      anon_sym_DQUOTE,
    ACTIONS(9838), 1,
      sym_interpolation_open_brace,
    ACTIONS(9918), 1,
      sym_interpolation_string_content,
    STATE(7797), 1,
      aux_sym_interpolated_string_expression_repeat2,
    STATE(8411), 1,
      sym_interpolation,
    STATE(8412), 1,
      sym__interpolated_verbatim_string_content,
    STATE(7843), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [348433] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9834), 1,
      sym_interpolation_end_quote,
    ACTIONS(9903), 1,
      sym_interpolation_open_brace,
    ACTIONS(9905), 1,
      sym_interpolation_string_content,
    STATE(7795), 1,
      aux_sym_interpolated_string_expression_repeat3,
    STATE(8416), 1,
      sym_interpolation,
    STATE(8418), 1,
      sym__interpolated_raw_string_content,
    STATE(7844), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [348489] = 16,
    ACTIONS(9485), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9487), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9489), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9491), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9493), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9495), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9497), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9499), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9501), 1,
      sym_comment,
    ACTIONS(9924), 1,
      aux_sym_string_literal_content_token1,
    ACTIONS(9926), 1,
      aux_sym_string_literal_content_token2,
    ACTIONS(9928), 1,
      sym_escape_sequence,
    ACTIONS(10000), 1,
      anon_sym_DQUOTE,
    STATE(7882), 1,
      aux_sym_string_literal_repeat1,
    STATE(8266), 1,
      sym_string_literal_content,
    STATE(7845), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [348545] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(10002), 1,
      anon_sym_SEMI,
    STATE(7771), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9080), 1,
      sym_declaration_list,
    STATE(7846), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [348601] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4081), 1,
      anon_sym_EQ_GT,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(9677), 1,
      anon_sym_EQ,
    STATE(8545), 1,
      sym_bracketed_argument_list,
    ACTIONS(9675), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(7847), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [348655] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(10002), 1,
      anon_sym_SEMI,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9080), 1,
      sym_declaration_list,
    STATE(7848), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [348711] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10004), 6,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_in,
    STATE(7849), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [348757] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9683), 1,
      anon_sym_EQ_GT,
    ACTIONS(9774), 1,
      anon_sym_SEMI,
    ACTIONS(9776), 1,
      anon_sym_LBRACE,
    STATE(3144), 1,
      sym_block,
    STATE(3461), 1,
      sym__function_body,
    STATE(8980), 1,
      sym_arrow_expression_clause,
    STATE(7850), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [348813] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(10006), 1,
      anon_sym_SEMI,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9353), 1,
      sym_declaration_list,
    STATE(7851), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [348869] = 16,
    ACTIONS(9485), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9487), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9489), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9491), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9493), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9495), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9497), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9499), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9501), 1,
      sym_comment,
    ACTIONS(9924), 1,
      aux_sym_string_literal_content_token1,
    ACTIONS(9926), 1,
      aux_sym_string_literal_content_token2,
    ACTIONS(9928), 1,
      sym_escape_sequence,
    ACTIONS(10008), 1,
      anon_sym_DQUOTE,
    STATE(7772), 1,
      aux_sym_string_literal_repeat1,
    STATE(8266), 1,
      sym_string_literal_content,
    STATE(7852), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [348925] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9752), 1,
      anon_sym_SEMI,
    STATE(7751), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9271), 1,
      sym_declaration_list,
    STATE(7853), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [348981] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7248), 1,
      anon_sym_LT,
    ACTIONS(7394), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10010), 1,
      anon_sym_EQ,
    STATE(2736), 1,
      sym_type_argument_list,
    ACTIONS(4076), 2,
      anon_sym_SEMI,
      anon_sym_DOT,
    STATE(7854), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [349035] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9683), 1,
      anon_sym_EQ_GT,
    ACTIONS(9774), 1,
      anon_sym_SEMI,
    ACTIONS(9776), 1,
      anon_sym_LBRACE,
    STATE(3144), 1,
      sym_block,
    STATE(3459), 1,
      sym__function_body,
    STATE(8980), 1,
      sym_arrow_expression_clause,
    STATE(7855), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [349091] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9756), 1,
      anon_sym_SEMI,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(8970), 1,
      sym_declaration_list,
    STATE(7856), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [349147] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9683), 1,
      anon_sym_EQ_GT,
    ACTIONS(9774), 1,
      anon_sym_SEMI,
    ACTIONS(9776), 1,
      anon_sym_LBRACE,
    STATE(3144), 1,
      sym_block,
    STATE(3261), 1,
      sym__function_body,
    STATE(8980), 1,
      sym_arrow_expression_clause,
    STATE(7857), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [349203] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9762), 1,
      anon_sym_SEMI,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9371), 1,
      sym_declaration_list,
    STATE(7858), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [349259] = 16,
    ACTIONS(9485), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9487), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9489), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9491), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9493), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9495), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9497), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9499), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9501), 1,
      sym_comment,
    ACTIONS(9924), 1,
      aux_sym_string_literal_content_token1,
    ACTIONS(9926), 1,
      aux_sym_string_literal_content_token2,
    ACTIONS(9928), 1,
      sym_escape_sequence,
    ACTIONS(10012), 1,
      anon_sym_DQUOTE,
    STATE(7784), 1,
      aux_sym_string_literal_repeat1,
    STATE(8266), 1,
      sym_string_literal_content,
    STATE(7859), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [349315] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9683), 1,
      anon_sym_EQ_GT,
    ACTIONS(9774), 1,
      anon_sym_SEMI,
    ACTIONS(9776), 1,
      anon_sym_LBRACE,
    STATE(3144), 1,
      sym_block,
    STATE(3299), 1,
      sym__function_body,
    STATE(8980), 1,
      sym_arrow_expression_clause,
    STATE(7860), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [349371] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9840), 1,
      sym_interpolation_end_quote,
    ACTIONS(9903), 1,
      sym_interpolation_open_brace,
    ACTIONS(9905), 1,
      sym_interpolation_string_content,
    STATE(7785), 1,
      aux_sym_interpolated_string_expression_repeat3,
    STATE(8416), 1,
      sym_interpolation,
    STATE(8418), 1,
      sym__interpolated_raw_string_content,
    STATE(7861), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [349427] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9870), 1,
      sym_interpolation_end_quote,
    ACTIONS(9903), 1,
      sym_interpolation_open_brace,
    ACTIONS(9905), 1,
      sym_interpolation_string_content,
    STATE(7904), 1,
      aux_sym_interpolated_string_expression_repeat3,
    STATE(8416), 1,
      sym_interpolation,
    STATE(8418), 1,
      sym__interpolated_raw_string_content,
    STATE(7862), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [349483] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9838), 1,
      sym_interpolation_open_brace,
    ACTIONS(9840), 1,
      anon_sym_DQUOTE,
    ACTIONS(9918), 1,
      sym_interpolation_string_content,
    STATE(7787), 1,
      aux_sym_interpolated_string_expression_repeat2,
    STATE(8411), 1,
      sym_interpolation,
    STATE(8412), 1,
      sym__interpolated_verbatim_string_content,
    STATE(7863), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [349539] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9838), 1,
      sym_interpolation_open_brace,
    ACTIONS(9844), 1,
      anon_sym_DQUOTE,
    ACTIONS(9918), 1,
      sym_interpolation_string_content,
    STATE(7797), 1,
      aux_sym_interpolated_string_expression_repeat2,
    STATE(8411), 1,
      sym_interpolation,
    STATE(8412), 1,
      sym__interpolated_verbatim_string_content,
    STATE(7864), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [349595] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(10014), 1,
      anon_sym_SEMI,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9611), 1,
      sym_declaration_list,
    STATE(7865), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [349651] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9762), 1,
      anon_sym_SEMI,
    STATE(7890), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9371), 1,
      sym_declaration_list,
    STATE(7866), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [349707] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(10016), 1,
      anon_sym_SEMI,
    STATE(7869), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9767), 1,
      sym_declaration_list,
    STATE(7867), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [349763] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(10016), 1,
      anon_sym_SEMI,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9767), 1,
      sym_declaration_list,
    STATE(7868), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [349819] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(10018), 1,
      anon_sym_SEMI,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9825), 1,
      sym_declaration_list,
    STATE(7869), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [349875] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9683), 1,
      anon_sym_EQ_GT,
    ACTIONS(9774), 1,
      anon_sym_SEMI,
    ACTIONS(9776), 1,
      anon_sym_LBRACE,
    STATE(3144), 1,
      sym_block,
    STATE(3407), 1,
      sym__function_body,
    STATE(8980), 1,
      sym_arrow_expression_clause,
    STATE(7870), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [349931] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(10020), 1,
      anon_sym_SEMI,
    STATE(7780), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9502), 1,
      sym_declaration_list,
    STATE(7871), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [349987] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(10020), 1,
      anon_sym_SEMI,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9502), 1,
      sym_declaration_list,
    STATE(7872), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [350043] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9750), 1,
      anon_sym_SEMI,
    STATE(7881), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9674), 1,
      sym_declaration_list,
    STATE(7873), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [350099] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9683), 1,
      anon_sym_EQ_GT,
    ACTIONS(9774), 1,
      anon_sym_SEMI,
    ACTIONS(9776), 1,
      anon_sym_LBRACE,
    STATE(3144), 1,
      sym_block,
    STATE(3383), 1,
      sym__function_body,
    STATE(8980), 1,
      sym_arrow_expression_clause,
    STATE(7874), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [350155] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9683), 1,
      anon_sym_EQ_GT,
    ACTIONS(9774), 1,
      anon_sym_SEMI,
    ACTIONS(9776), 1,
      anon_sym_LBRACE,
    STATE(3144), 1,
      sym_block,
    STATE(3217), 1,
      sym__function_body,
    STATE(8980), 1,
      sym_arrow_expression_clause,
    STATE(7875), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [350211] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9832), 1,
      anon_sym_SEMI,
    STATE(7786), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9496), 1,
      sym_declaration_list,
    STATE(7876), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [350267] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9838), 1,
      sym_interpolation_open_brace,
    ACTIONS(9870), 1,
      anon_sym_DQUOTE,
    ACTIONS(9918), 1,
      sym_interpolation_string_content,
    STATE(7864), 1,
      aux_sym_interpolated_string_expression_repeat2,
    STATE(8411), 1,
      sym_interpolation,
    STATE(8412), 1,
      sym__interpolated_verbatim_string_content,
    STATE(7877), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [350323] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9832), 1,
      anon_sym_SEMI,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9496), 1,
      sym_declaration_list,
    STATE(7878), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [350379] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4081), 1,
      anon_sym_EQ_GT,
    ACTIONS(9980), 1,
      anon_sym_EQ,
    ACTIONS(10022), 1,
      anon_sym_RPAREN,
    ACTIONS(4247), 3,
      anon_sym_COMMA,
      anon_sym_and,
      anon_sym_or,
    STATE(7879), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [350431] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9828), 1,
      anon_sym_SEMI,
    STATE(7824), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9387), 1,
      sym_declaration_list,
    STATE(7880), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [350487] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9828), 1,
      anon_sym_SEMI,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9387), 1,
      sym_declaration_list,
    STATE(7881), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [350543] = 15,
    ACTIONS(9485), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9487), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9489), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9491), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9493), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9495), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9497), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9499), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9501), 1,
      sym_comment,
    ACTIONS(10024), 1,
      anon_sym_DQUOTE,
    ACTIONS(10026), 1,
      aux_sym_string_literal_content_token1,
    ACTIONS(10029), 1,
      aux_sym_string_literal_content_token2,
    ACTIONS(10032), 1,
      sym_escape_sequence,
    STATE(8266), 1,
      sym_string_literal_content,
    STATE(7882), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_string_literal_repeat1,
  [350597] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9820), 1,
      anon_sym_SEMI,
    STATE(7811), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9756), 1,
      sym_declaration_list,
    STATE(7883), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [350653] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9830), 1,
      anon_sym_SEMI,
    STATE(7763), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9078), 1,
      sym_declaration_list,
    STATE(7884), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [350709] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9820), 1,
      anon_sym_SEMI,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9756), 1,
      sym_declaration_list,
    STATE(7885), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [350765] = 16,
    ACTIONS(9485), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9487), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9489), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9491), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9493), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9495), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9497), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9499), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9501), 1,
      sym_comment,
    ACTIONS(9924), 1,
      aux_sym_string_literal_content_token1,
    ACTIONS(9926), 1,
      aux_sym_string_literal_content_token2,
    ACTIONS(9928), 1,
      sym_escape_sequence,
    ACTIONS(10035), 1,
      anon_sym_DQUOTE,
    STATE(7845), 1,
      aux_sym_string_literal_repeat1,
    STATE(8266), 1,
      sym_string_literal_content,
    STATE(7886), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [350821] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9683), 1,
      anon_sym_EQ_GT,
    ACTIONS(9774), 1,
      anon_sym_SEMI,
    ACTIONS(9776), 1,
      anon_sym_LBRACE,
    STATE(3144), 1,
      sym_block,
    STATE(3281), 1,
      sym__function_body,
    STATE(8980), 1,
      sym_arrow_expression_clause,
    STATE(7887), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [350877] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9830), 1,
      anon_sym_SEMI,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9078), 1,
      sym_declaration_list,
    STATE(7888), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [350933] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10039), 1,
      anon_sym_where,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    ACTIONS(10037), 3,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
    STATE(7889), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_class_declaration_repeat3,
  [350983] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9806), 1,
      anon_sym_SEMI,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9553), 1,
      sym_declaration_list,
    STATE(7890), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [351039] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9760), 1,
      anon_sym_SEMI,
    STATE(7878), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(8974), 1,
      sym_declaration_list,
    STATE(7891), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [351095] = 16,
    ACTIONS(9485), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9487), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9489), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9491), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9493), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9495), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9497), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9499), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9501), 1,
      sym_comment,
    ACTIONS(9924), 1,
      aux_sym_string_literal_content_token1,
    ACTIONS(9926), 1,
      aux_sym_string_literal_content_token2,
    ACTIONS(9928), 1,
      sym_escape_sequence,
    ACTIONS(10042), 1,
      anon_sym_DQUOTE,
    STATE(7882), 1,
      aux_sym_string_literal_repeat1,
    STATE(8266), 1,
      sym_string_literal_content,
    STATE(7892), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [351151] = 16,
    ACTIONS(9485), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9487), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9489), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9491), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9493), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9495), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9497), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9499), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9501), 1,
      sym_comment,
    ACTIONS(9924), 1,
      aux_sym_string_literal_content_token1,
    ACTIONS(9926), 1,
      aux_sym_string_literal_content_token2,
    ACTIONS(9928), 1,
      sym_escape_sequence,
    ACTIONS(10044), 1,
      anon_sym_DQUOTE,
    STATE(7836), 1,
      aux_sym_string_literal_repeat1,
    STATE(8266), 1,
      sym_string_literal_content,
    STATE(7893), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [351207] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9760), 1,
      anon_sym_SEMI,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(8974), 1,
      sym_declaration_list,
    STATE(7894), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [351263] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9816), 1,
      anon_sym_SEMI,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(8971), 1,
      sym_declaration_list,
    STATE(7895), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [351319] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9816), 1,
      anon_sym_SEMI,
    STATE(7872), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(8971), 1,
      sym_declaration_list,
    STATE(7896), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [351375] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9683), 1,
      anon_sym_EQ_GT,
    ACTIONS(9774), 1,
      anon_sym_SEMI,
    ACTIONS(9776), 1,
      anon_sym_LBRACE,
    STATE(3144), 1,
      sym_block,
    STATE(3297), 1,
      sym__function_body,
    STATE(8980), 1,
      sym_arrow_expression_clause,
    STATE(7897), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [351431] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9838), 1,
      sym_interpolation_open_brace,
    ACTIONS(9852), 1,
      anon_sym_DQUOTE,
    ACTIONS(9918), 1,
      sym_interpolation_string_content,
    STATE(7797), 1,
      aux_sym_interpolated_string_expression_repeat2,
    STATE(8411), 1,
      sym_interpolation,
    STATE(8412), 1,
      sym__interpolated_verbatim_string_content,
    STATE(7898), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [351487] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9852), 1,
      sym_interpolation_end_quote,
    ACTIONS(9903), 1,
      sym_interpolation_open_brace,
    ACTIONS(9905), 1,
      sym_interpolation_string_content,
    STATE(7795), 1,
      aux_sym_interpolated_string_expression_repeat3,
    STATE(8416), 1,
      sym_interpolation,
    STATE(8418), 1,
      sym__interpolated_raw_string_content,
    STATE(7899), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [351543] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5709), 1,
      anon_sym_LBRACE,
    ACTIONS(9894), 1,
      anon_sym_LPAREN,
    ACTIONS(9896), 1,
      anon_sym_when,
    STATE(2204), 1,
      sym_block,
    STATE(8333), 1,
      sym_catch_declaration,
    STATE(8822), 1,
      sym_catch_filter_clause,
    STATE(7900), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [351599] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9988), 1,
      anon_sym_SEMI,
    STATE(7865), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9343), 1,
      sym_declaration_list,
    STATE(7901), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [351655] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10046), 6,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_in,
    STATE(7902), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [351701] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7248), 1,
      anon_sym_LT,
    ACTIONS(7394), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10048), 1,
      anon_sym_EQ,
    STATE(2736), 1,
      sym_type_argument_list,
    ACTIONS(4076), 2,
      anon_sym_SEMI,
      anon_sym_DOT,
    STATE(7903), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [351755] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9844), 1,
      sym_interpolation_end_quote,
    ACTIONS(9903), 1,
      sym_interpolation_open_brace,
    ACTIONS(9905), 1,
      sym_interpolation_string_content,
    STATE(7795), 1,
      aux_sym_interpolated_string_expression_repeat3,
    STATE(8416), 1,
      sym_interpolation,
    STATE(8418), 1,
      sym__interpolated_raw_string_content,
    STATE(7904), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [351811] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9683), 1,
      anon_sym_EQ_GT,
    ACTIONS(9774), 1,
      anon_sym_SEMI,
    ACTIONS(9776), 1,
      anon_sym_LBRACE,
    STATE(3144), 1,
      sym_block,
    STATE(3355), 1,
      sym__function_body,
    STATE(8980), 1,
      sym_arrow_expression_clause,
    STATE(7905), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [351867] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9752), 1,
      anon_sym_SEMI,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9271), 1,
      sym_declaration_list,
    STATE(7906), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [351923] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9683), 1,
      anon_sym_EQ_GT,
    ACTIONS(9774), 1,
      anon_sym_SEMI,
    ACTIONS(9776), 1,
      anon_sym_LBRACE,
    STATE(3144), 1,
      sym_block,
    STATE(3266), 1,
      sym__function_body,
    STATE(8980), 1,
      sym_arrow_expression_clause,
    STATE(7907), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [351979] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9683), 1,
      anon_sym_EQ_GT,
    ACTIONS(9976), 1,
      anon_sym_SEMI,
    ACTIONS(9978), 1,
      anon_sym_LBRACE,
    STATE(4305), 1,
      sym__function_body,
    STATE(4332), 1,
      sym_block,
    STATE(9876), 1,
      sym_arrow_expression_clause,
    STATE(7908), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [352035] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9888), 1,
      anon_sym_COMMA,
    STATE(7761), 1,
      aux_sym_type_parameter_constraints_clause_repeat1,
    ACTIONS(10050), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_where,
      anon_sym_EQ_GT,
    STATE(7909), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [352085] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6104), 1,
      anon_sym_LBRACE,
    ACTIONS(9894), 1,
      anon_sym_LPAREN,
    ACTIONS(9896), 1,
      anon_sym_when,
    STATE(2643), 1,
      sym_block,
    STATE(8331), 1,
      sym_catch_declaration,
    STATE(8940), 1,
      sym_catch_filter_clause,
    STATE(7910), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [352141] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9683), 1,
      anon_sym_EQ_GT,
    ACTIONS(9774), 1,
      anon_sym_SEMI,
    ACTIONS(9776), 1,
      anon_sym_LBRACE,
    STATE(3144), 1,
      sym_block,
    STATE(3352), 1,
      sym__function_body,
    STATE(8980), 1,
      sym_arrow_expression_clause,
    STATE(7911), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [352197] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(9750), 1,
      anon_sym_SEMI,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9674), 1,
      sym_declaration_list,
    STATE(7912), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [352253] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10052), 1,
      anon_sym_COMMA,
    ACTIONS(10054), 1,
      anon_sym_RBRACK,
    ACTIONS(10056), 1,
      anon_sym_and,
    ACTIONS(10058), 1,
      anon_sym_or,
    STATE(8372), 1,
      aux_sym_list_pattern_repeat1,
    STATE(7913), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [352306] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9783), 1,
      sym_declaration_list,
    STATE(7914), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [352359] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(8154), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9288), 1,
      sym_declaration_list,
    STATE(7915), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [352412] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9680), 1,
      sym_declaration_list,
    STATE(7916), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [352465] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9791), 1,
      sym_declaration_list,
    STATE(7917), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [352518] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9288), 1,
      sym_declaration_list,
    STATE(7918), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [352571] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9287), 1,
      sym_declaration_list,
    STATE(7919), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [352624] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7967), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9370), 1,
      sym_declaration_list,
    STATE(7920), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [352677] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9370), 1,
      sym_declaration_list,
    STATE(7921), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [352730] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(8135), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9791), 1,
      sym_declaration_list,
    STATE(7922), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [352783] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10060), 5,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_where,
      anon_sym_EQ_GT,
    STATE(7923), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [352828] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(8992), 1,
      sym_declaration_list,
    STATE(7924), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [352881] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(8994), 1,
      sym_declaration_list,
    STATE(7925), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [352934] = 14,
    ACTIONS(9485), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9487), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9489), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9491), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9493), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9495), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9497), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9499), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9501), 1,
      sym_comment,
    ACTIONS(10064), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10066), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10068), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(10062), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    STATE(7926), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [352985] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7939), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(8994), 1,
      sym_declaration_list,
    STATE(7927), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [353038] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10056), 1,
      anon_sym_and,
    ACTIONS(10058), 1,
      anon_sym_or,
    ACTIONS(10070), 1,
      anon_sym_COMMA,
    ACTIONS(10072), 1,
      anon_sym_RBRACK,
    STATE(8544), 1,
      aux_sym_list_pattern_repeat1,
    STATE(7928), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [353091] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5982), 1,
      anon_sym_STAR,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(10074), 1,
      anon_sym_LBRACE,
    STATE(3665), 1,
      sym_block,
    STATE(8762), 1,
      sym_parameter_list,
    STATE(7929), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [353144] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9336), 1,
      sym_declaration_list,
    STATE(7930), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [353197] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9475), 1,
      sym_declaration_list,
    STATE(7931), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [353250] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7986), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9475), 1,
      sym_declaration_list,
    STATE(7932), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [353303] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7987), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9476), 1,
      sym_declaration_list,
    STATE(7933), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [353356] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4081), 1,
      anon_sym_EQ_GT,
    ACTIONS(4247), 4,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
    STATE(7934), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [353403] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9476), 1,
      sym_declaration_list,
    STATE(7935), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [353456] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9484), 1,
      sym_declaration_list,
    STATE(7936), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [353509] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7989), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9484), 1,
      sym_declaration_list,
    STATE(7937), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [353562] = 14,
    ACTIONS(9485), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9487), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9489), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9491), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9493), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9495), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9497), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9499), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9501), 1,
      sym_comment,
    ACTIONS(10064), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10066), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10076), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(10062), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    STATE(7938), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [353613] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9486), 1,
      sym_declaration_list,
    STATE(7939), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [353666] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9000), 1,
      sym_declaration_list,
    STATE(7940), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [353719] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7936), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9000), 1,
      sym_declaration_list,
    STATE(7941), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [353772] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9001), 1,
      sym_declaration_list,
    STATE(7942), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [353825] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7935), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9001), 1,
      sym_declaration_list,
    STATE(7943), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [353878] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9002), 1,
      sym_declaration_list,
    STATE(7944), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [353931] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7931), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9002), 1,
      sym_declaration_list,
    STATE(7945), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [353984] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5982), 1,
      anon_sym_STAR,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(10078), 1,
      anon_sym_LBRACE,
    STATE(4239), 1,
      sym_block,
    STATE(8682), 1,
      sym_parameter_list,
    STATE(7946), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [354037] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10080), 1,
      anon_sym_RBRACE,
    ACTIONS(10082), 1,
      anon_sym_case,
    ACTIONS(10084), 1,
      anon_sym_default,
    STATE(7961), 1,
      aux_sym_switch_body_repeat1,
    STATE(8515), 1,
      sym_switch_section,
    STATE(7947), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [354090] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10082), 1,
      anon_sym_case,
    ACTIONS(10084), 1,
      anon_sym_default,
    ACTIONS(10086), 1,
      anon_sym_RBRACE,
    STATE(7961), 1,
      aux_sym_switch_body_repeat1,
    STATE(8515), 1,
      sym_switch_section,
    STATE(7948), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [354143] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4081), 1,
      anon_sym_EQ_GT,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9708), 1,
      anon_sym_LT,
    STATE(7544), 1,
      sym_parameter_list,
    STATE(8818), 1,
      sym_type_parameter_list,
    STATE(7949), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [354196] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5980), 1,
      anon_sym_LBRACE,
    ACTIONS(5982), 1,
      anon_sym_STAR,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(3759), 1,
      sym_block,
    STATE(8873), 1,
      sym_parameter_list,
    STATE(7950), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [354249] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9252), 1,
      sym_declaration_list,
    STATE(7951), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [354302] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9243), 1,
      sym_declaration_list,
    STATE(7952), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [354355] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(8115), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9243), 1,
      sym_declaration_list,
    STATE(7953), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [354408] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9240), 1,
      sym_declaration_list,
    STATE(7954), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [354461] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(8104), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9240), 1,
      sym_declaration_list,
    STATE(7955), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [354514] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9742), 1,
      sym_declaration_list,
    STATE(7956), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [354567] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9232), 1,
      sym_declaration_list,
    STATE(7957), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [354620] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7996), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9517), 1,
      sym_declaration_list,
    STATE(7958), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [354673] = 14,
    ACTIONS(9485), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9487), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9489), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9491), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9493), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9495), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9497), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9499), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9501), 1,
      sym_comment,
    ACTIONS(10064), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10066), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10088), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(10062), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    STATE(7959), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [354724] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9517), 1,
      sym_declaration_list,
    STATE(7960), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [354777] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10090), 1,
      anon_sym_RBRACE,
    ACTIONS(10092), 1,
      anon_sym_case,
    ACTIONS(10095), 1,
      anon_sym_default,
    STATE(8515), 1,
      sym_switch_section,
    STATE(7961), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_switch_body_repeat1,
  [354828] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(8000), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9518), 1,
      sym_declaration_list,
    STATE(7962), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [354881] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8897), 1,
      anon_sym_COLON,
    ACTIONS(10098), 1,
      anon_sym_when,
    ACTIONS(10100), 1,
      anon_sym_and,
    ACTIONS(10102), 1,
      anon_sym_or,
    STATE(9772), 1,
      sym_when_clause,
    STATE(7963), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [354934] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9518), 1,
      sym_declaration_list,
    STATE(7964), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [354987] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(8001), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9520), 1,
      sym_declaration_list,
    STATE(7965), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [355040] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9520), 1,
      sym_declaration_list,
    STATE(7966), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [355093] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9522), 1,
      sym_declaration_list,
    STATE(7967), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [355146] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(8026), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9232), 1,
      sym_declaration_list,
    STATE(7968), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [355199] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9077), 1,
      sym_declaration_list,
    STATE(7969), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [355252] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7924), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9077), 1,
      sym_declaration_list,
    STATE(7970), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [355305] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9087), 1,
      sym_declaration_list,
    STATE(7971), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [355358] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7940), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9087), 1,
      sym_declaration_list,
    STATE(7972), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [355411] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9091), 1,
      sym_declaration_list,
    STATE(7973), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [355464] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7944), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9091), 1,
      sym_declaration_list,
    STATE(7974), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [355517] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(8007), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9530), 1,
      sym_declaration_list,
    STATE(7975), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [355570] = 14,
    ACTIONS(9485), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9487), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9489), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9491), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9493), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9495), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9497), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9499), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9501), 1,
      sym_comment,
    ACTIONS(10064), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10066), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10104), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(10062), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    STATE(7976), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [355621] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9530), 1,
      sym_declaration_list,
    STATE(7977), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [355674] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9826), 1,
      anon_sym_COMMA,
    STATE(8177), 1,
      aux_sym_record_base_repeat1,
    ACTIONS(10106), 3,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_where,
    STATE(7978), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [355723] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(10108), 1,
      anon_sym_EQ,
    STATE(8656), 1,
      sym_bracketed_argument_list,
    ACTIONS(9675), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(7979), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [355774] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(10110), 1,
      anon_sym_EQ,
    STATE(8653), 1,
      sym_bracketed_argument_list,
    ACTIONS(10112), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(7980), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [355825] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(8014), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9557), 1,
      sym_declaration_list,
    STATE(7981), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [355878] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9557), 1,
      sym_declaration_list,
    STATE(7982), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [355931] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5980), 1,
      anon_sym_LBRACE,
    ACTIONS(5982), 1,
      anon_sym_STAR,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(3732), 1,
      sym_block,
    STATE(8954), 1,
      sym_parameter_list,
    STATE(7983), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [355984] = 14,
    ACTIONS(9485), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9487), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9489), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9491), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9493), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9495), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9497), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9499), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9501), 1,
      sym_comment,
    ACTIONS(10064), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10066), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10114), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(10062), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    STATE(7984), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [356035] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5982), 1,
      anon_sym_STAR,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(10078), 1,
      anon_sym_LBRACE,
    STATE(4186), 1,
      sym_block,
    STATE(8695), 1,
      sym_parameter_list,
    STATE(7985), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [356088] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9607), 1,
      sym_declaration_list,
    STATE(7986), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [356141] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9608), 1,
      sym_declaration_list,
    STATE(7987), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [356194] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(8021), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9608), 1,
      sym_declaration_list,
    STATE(7988), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [356247] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9610), 1,
      sym_declaration_list,
    STATE(7989), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [356300] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9212), 1,
      sym_declaration_list,
    STATE(7990), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [356353] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9211), 1,
      sym_declaration_list,
    STATE(7991), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [356406] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7918), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9211), 1,
      sym_declaration_list,
    STATE(7992), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [356459] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7919), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9209), 1,
      sym_declaration_list,
    STATE(7993), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [356512] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9209), 1,
      sym_declaration_list,
    STATE(7994), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [356565] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9176), 1,
      sym_declaration_list,
    STATE(7995), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [356618] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9718), 1,
      sym_declaration_list,
    STATE(7996), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [356671] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(8023), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9718), 1,
      sym_declaration_list,
    STATE(7997), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [356724] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(8024), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9724), 1,
      sym_declaration_list,
    STATE(7998), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [356777] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4500), 5,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_where,
      anon_sym_EQ_GT,
    STATE(7999), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [356822] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9724), 1,
      sym_declaration_list,
    STATE(8000), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [356875] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9732), 1,
      sym_declaration_list,
    STATE(8001), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [356928] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7930), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9168), 1,
      sym_declaration_list,
    STATE(8002), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [356981] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9168), 1,
      sym_declaration_list,
    STATE(8003), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [357034] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9144), 1,
      sym_declaration_list,
    STATE(8004), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [357087] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(8028), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9774), 1,
      sym_declaration_list,
    STATE(8005), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [357140] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7250), 1,
      anon_sym_LBRACK,
    ACTIONS(7252), 1,
      anon_sym_STAR,
    ACTIONS(7254), 1,
      anon_sym_QMARK,
    ACTIONS(7396), 1,
      anon_sym_DOT,
    ACTIONS(9907), 1,
      anon_sym_COMMA,
    STATE(8006), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [357193] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9774), 1,
      sym_declaration_list,
    STATE(8007), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [357246] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10082), 1,
      anon_sym_case,
    ACTIONS(10084), 1,
      anon_sym_default,
    ACTIONS(10116), 1,
      anon_sym_RBRACE,
    STATE(7947), 1,
      aux_sym_switch_body_repeat1,
    STATE(8515), 1,
      sym_switch_section,
    STATE(8008), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [357299] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(8032), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9777), 1,
      sym_declaration_list,
    STATE(8009), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [357352] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9746), 1,
      sym_declaration_list,
    STATE(8010), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [357405] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9777), 1,
      sym_declaration_list,
    STATE(8011), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [357458] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(8033), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9820), 1,
      sym_declaration_list,
    STATE(8012), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [357511] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9820), 1,
      sym_declaration_list,
    STATE(8013), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [357564] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9822), 1,
      sym_declaration_list,
    STATE(8014), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [357617] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4081), 1,
      anon_sym_EQ_GT,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9708), 1,
      anon_sym_LT,
    STATE(7607), 1,
      sym_parameter_list,
    STATE(8957), 1,
      sym_type_parameter_list,
    STATE(8015), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [357670] = 14,
    ACTIONS(9485), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9487), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9489), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9491), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9493), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9495), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9497), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9499), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9501), 1,
      sym_comment,
    ACTIONS(10064), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10066), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10118), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(10062), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    STATE(8016), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [357721] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9122), 1,
      sym_declaration_list,
    STATE(8017), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [357774] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7951), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9122), 1,
      sym_declaration_list,
    STATE(8018), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [357827] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9442), 1,
      sym_declaration_list,
    STATE(8019), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [357880] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9114), 1,
      sym_declaration_list,
    STATE(8020), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [357933] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9828), 1,
      sym_declaration_list,
    STATE(8021), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [357986] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7957), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9114), 1,
      sym_declaration_list,
    STATE(8022), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [358039] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9834), 1,
      sym_declaration_list,
    STATE(8023), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [358092] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9835), 1,
      sym_declaration_list,
    STATE(8024), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [358145] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(8037), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9835), 1,
      sym_declaration_list,
    STATE(8025), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [358198] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9299), 1,
      sym_declaration_list,
    STATE(8026), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [358251] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5982), 1,
      anon_sym_STAR,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(10074), 1,
      anon_sym_LBRACE,
    STATE(3647), 1,
      sym_block,
    STATE(8929), 1,
      sym_parameter_list,
    STATE(8027), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [358304] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9842), 1,
      sym_declaration_list,
    STATE(8028), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [358357] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(8039), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9842), 1,
      sym_declaration_list,
    STATE(8029), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [358410] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(8040), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9844), 1,
      sym_declaration_list,
    STATE(8030), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [358463] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9106), 1,
      sym_declaration_list,
    STATE(8031), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [358516] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9844), 1,
      sym_declaration_list,
    STATE(8032), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [358569] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9846), 1,
      sym_declaration_list,
    STATE(8033), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [358622] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9103), 1,
      sym_declaration_list,
    STATE(8034), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [358675] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7990), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9103), 1,
      sym_declaration_list,
    STATE(8035), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [358728] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9100), 1,
      sym_declaration_list,
    STATE(8036), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [358781] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9855), 1,
      sym_declaration_list,
    STATE(8037), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [358834] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10120), 5,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_where,
      anon_sym_EQ_GT,
    STATE(8038), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [358879] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9865), 1,
      sym_declaration_list,
    STATE(8039), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [358932] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9868), 1,
      sym_declaration_list,
    STATE(8040), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [358985] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(8044), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9868), 1,
      sym_declaration_list,
    STATE(8041), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [359038] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(8204), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9742), 1,
      sym_declaration_list,
    STATE(8042), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [359091] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10122), 5,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_where,
      anon_sym_EQ_GT,
    STATE(8043), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [359136] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9879), 1,
      sym_declaration_list,
    STATE(8044), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [359189] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5980), 1,
      anon_sym_LBRACE,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(10124), 1,
      anon_sym_STAR,
    STATE(3759), 1,
      sym_block,
    STATE(8873), 1,
      sym_parameter_list,
    STATE(8045), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [359242] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7991), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9100), 1,
      sym_declaration_list,
    STATE(8046), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [359295] = 14,
    ACTIONS(9485), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9487), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9489), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9491), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9493), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9495), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9497), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9499), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9501), 1,
      sym_comment,
    ACTIONS(10064), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10066), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10126), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(10062), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    STATE(8047), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [359346] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9736), 1,
      sym_declaration_list,
    STATE(8048), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [359399] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9097), 1,
      sym_declaration_list,
    STATE(8049), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [359452] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10128), 1,
      anon_sym_RPAREN,
    ACTIONS(10132), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10134), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10130), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    STATE(8050), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [359503] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(8060), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9270), 1,
      sym_declaration_list,
    STATE(8051), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [359556] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7994), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9097), 1,
      sym_declaration_list,
    STATE(8052), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [359609] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10056), 1,
      anon_sym_and,
    ACTIONS(10058), 1,
      anon_sym_or,
    ACTIONS(10136), 1,
      anon_sym_COMMA,
    ACTIONS(10138), 1,
      anon_sym_RBRACK,
    STATE(8595), 1,
      aux_sym_list_pattern_repeat1,
    STATE(8053), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [359662] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(8207), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9736), 1,
      sym_declaration_list,
    STATE(8054), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [359715] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(8185), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9734), 1,
      sym_declaration_list,
    STATE(8055), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [359768] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(10140), 1,
      anon_sym_EQ,
    STATE(8541), 1,
      sym_bracketed_argument_list,
    ACTIONS(10112), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(8056), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [359819] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(8173), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9299), 1,
      sym_declaration_list,
    STATE(8057), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [359872] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10082), 1,
      anon_sym_case,
    ACTIONS(10084), 1,
      anon_sym_default,
    ACTIONS(10142), 1,
      anon_sym_RBRACE,
    STATE(7948), 1,
      aux_sym_switch_body_repeat1,
    STATE(8515), 1,
      sym_switch_section,
    STATE(8058), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [359925] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4081), 1,
      anon_sym_EQ_GT,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9708), 1,
      anon_sym_LT,
    STATE(7571), 1,
      sym_parameter_list,
    STATE(8865), 1,
      sym_type_parameter_list,
    STATE(8059), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [359978] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9532), 1,
      sym_declaration_list,
    STATE(8060), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [360031] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9155), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(9157), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(10144), 1,
      aux_sym_preproc_if_token3,
    STATE(9430), 2,
      sym_preproc_else_in_enum_member_declaration,
      sym_preproc_elif_in_enum_member_declaration,
    STATE(8061), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [360082] = 14,
    ACTIONS(9485), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9487), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9489), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9491), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9493), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9495), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9497), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9499), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9501), 1,
      sym_comment,
    ACTIONS(10064), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10066), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10146), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(10062), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    STATE(8062), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [360133] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9061), 1,
      sym_declaration_list,
    STATE(8063), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [360186] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9270), 1,
      sym_declaration_list,
    STATE(8064), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [360239] = 12,
    ACTIONS(9485), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9487), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9489), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9491), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9493), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9495), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9497), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9499), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9501), 1,
      sym_comment,
    ACTIONS(10150), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(10148), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
    STATE(8065), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [360286] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7995), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9059), 1,
      sym_declaration_list,
    STATE(8066), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [360339] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9734), 1,
      sym_declaration_list,
    STATE(8067), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [360392] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9059), 1,
      sym_declaration_list,
    STATE(8068), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [360445] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9058), 1,
      sym_declaration_list,
    STATE(8069), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [360498] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(8099), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9291), 1,
      sym_declaration_list,
    STATE(8070), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [360551] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10152), 5,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_where,
    STATE(8071), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [360596] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(8003), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9058), 1,
      sym_declaration_list,
    STATE(8072), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [360649] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(8004), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9052), 1,
      sym_declaration_list,
    STATE(8073), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [360702] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9052), 1,
      sym_declaration_list,
    STATE(8074), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [360755] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9291), 1,
      sym_declaration_list,
    STATE(8075), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [360808] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(8201), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9302), 1,
      sym_declaration_list,
    STATE(8076), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [360861] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9792), 1,
      sym_declaration_list,
    STATE(8077), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [360914] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(8128), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9794), 1,
      sym_declaration_list,
    STATE(8078), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [360967] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7960), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9680), 1,
      sym_declaration_list,
    STATE(8079), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [361020] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10154), 5,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_where,
      anon_sym_EQ_GT,
    STATE(8080), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [361065] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9794), 1,
      sym_declaration_list,
    STATE(8081), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [361118] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9326), 1,
      sym_declaration_list,
    STATE(8082), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [361171] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10156), 5,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_where,
      anon_sym_EQ_GT,
    STATE(8083), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [361216] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9796), 1,
      sym_declaration_list,
    STATE(8084), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [361269] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9038), 1,
      sym_declaration_list,
    STATE(8085), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [361322] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(8031), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9038), 1,
      sym_declaration_list,
    STATE(8086), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [361375] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(8118), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9806), 1,
      sym_declaration_list,
    STATE(8087), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [361428] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(8048), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9534), 1,
      sym_declaration_list,
    STATE(8088), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [361481] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9806), 1,
      sym_declaration_list,
    STATE(8089), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [361534] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9676), 1,
      sym_declaration_list,
    STATE(8090), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [361587] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(8090), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9833), 1,
      sym_declaration_list,
    STATE(8091), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [361640] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9534), 1,
      sym_declaration_list,
    STATE(8092), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [361693] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5982), 1,
      anon_sym_STAR,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(10158), 1,
      anon_sym_LBRACE,
    STATE(4647), 1,
      sym_block,
    STATE(8923), 1,
      sym_parameter_list,
    STATE(8093), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [361746] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7956), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9535), 1,
      sym_declaration_list,
    STATE(8094), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [361799] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9833), 1,
      sym_declaration_list,
    STATE(8095), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [361852] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9030), 1,
      sym_declaration_list,
    STATE(8096), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [361905] = 14,
    ACTIONS(9485), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9487), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9489), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9491), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9493), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9495), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9497), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9499), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9501), 1,
      sym_comment,
    ACTIONS(10064), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10066), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10160), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(10062), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    STATE(8097), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [361956] = 14,
    ACTIONS(9485), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9487), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9489), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9491), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9493), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9495), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9497), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9499), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9501), 1,
      sym_comment,
    ACTIONS(10064), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10066), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10162), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(10062), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    STATE(8098), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [362007] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9535), 1,
      sym_declaration_list,
    STATE(8099), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [362060] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9950), 5,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_where,
      anon_sym_EQ_GT,
    STATE(8100), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [362105] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(8049), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9030), 1,
      sym_declaration_list,
    STATE(8101), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [362158] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9826), 1,
      anon_sym_COMMA,
    STATE(8177), 1,
      aux_sym_record_base_repeat1,
    ACTIONS(10164), 3,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_where,
    STATE(8102), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [362207] = 14,
    ACTIONS(9485), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9487), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9489), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9491), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9493), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9495), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9497), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9499), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9501), 1,
      sym_comment,
    ACTIONS(10064), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10066), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10166), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(10062), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    STATE(8103), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [362258] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9302), 1,
      sym_declaration_list,
    STATE(8104), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [362311] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9677), 1,
      sym_declaration_list,
    STATE(8105), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [362364] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8449), 1,
      anon_sym_DOT,
    ACTIONS(10168), 1,
      anon_sym_LPAREN,
    STATE(8721), 1,
      sym_attribute_argument_list,
    ACTIONS(9204), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    STATE(8106), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [362415] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(8110), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9677), 1,
      sym_declaration_list,
    STATE(8107), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [362468] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10056), 1,
      anon_sym_and,
    ACTIONS(10058), 1,
      anon_sym_or,
    ACTIONS(6607), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
    STATE(8108), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [362517] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10170), 5,
      anon_sym_RPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
    STATE(8109), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [362562] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9400), 1,
      sym_declaration_list,
    STATE(8110), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [362615] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9405), 1,
      sym_declaration_list,
    STATE(8111), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [362668] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10056), 1,
      anon_sym_and,
    ACTIONS(10058), 1,
      anon_sym_or,
    ACTIONS(10172), 1,
      anon_sym_COMMA,
    ACTIONS(10174), 1,
      anon_sym_RBRACK,
    STATE(8605), 1,
      aux_sym_list_pattern_repeat1,
    STATE(8112), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [362721] = 12,
    ACTIONS(5345), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(9485), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9487), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9489), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9491), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9493), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9495), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9497), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9499), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9501), 1,
      sym_comment,
    ACTIONS(5347), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
    STATE(8113), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [362768] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10132), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10130), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10176), 2,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
    STATE(8114), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [362817] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9303), 1,
      sym_declaration_list,
    STATE(8115), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [362870] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9679), 1,
      sym_declaration_list,
    STATE(8116), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [362923] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(8111), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9679), 1,
      sym_declaration_list,
    STATE(8117), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [362976] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9741), 1,
      sym_declaration_list,
    STATE(8118), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [363029] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(8188), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9405), 1,
      sym_declaration_list,
    STATE(8119), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [363082] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(8010), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9540), 1,
      sym_declaration_list,
    STATE(8120), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [363135] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(8145), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9741), 1,
      sym_declaration_list,
    STATE(8121), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [363188] = 14,
    ACTIONS(9485), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9487), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9489), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9491), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9493), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9495), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9497), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9499), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9501), 1,
      sym_comment,
    ACTIONS(10064), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10066), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10178), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(10062), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    STATE(8122), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [363239] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9637), 1,
      sym_declaration_list,
    STATE(8123), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [363292] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9540), 1,
      sym_declaration_list,
    STATE(8124), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [363345] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(8084), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9637), 1,
      sym_declaration_list,
    STATE(8125), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [363398] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10082), 1,
      anon_sym_case,
    ACTIONS(10084), 1,
      anon_sym_default,
    ACTIONS(10180), 1,
      anon_sym_RBRACE,
    STATE(7961), 1,
      aux_sym_switch_body_repeat1,
    STATE(8515), 1,
      sym_switch_section,
    STATE(8126), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [363451] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9616), 1,
      sym_declaration_list,
    STATE(8127), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [363504] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9603), 1,
      sym_declaration_list,
    STATE(8128), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [363557] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(8067), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9532), 1,
      sym_declaration_list,
    STATE(8129), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [363610] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7914), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9792), 1,
      sym_declaration_list,
    STATE(8130), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [363663] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(8159), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9783), 1,
      sym_declaration_list,
    STATE(8131), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [363716] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7917), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9616), 1,
      sym_declaration_list,
    STATE(8132), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [363769] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(8157), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9787), 1,
      sym_declaration_list,
    STATE(8133), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [363822] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10130), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10176), 3,
      anon_sym_RPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
    STATE(8134), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [363869] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9787), 1,
      sym_declaration_list,
    STATE(8135), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [363922] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4424), 1,
      anon_sym_GT,
    ACTIONS(7250), 1,
      anon_sym_LBRACK,
    ACTIONS(7252), 1,
      anon_sym_STAR,
    ACTIONS(9907), 1,
      anon_sym_COMMA,
    ACTIONS(9909), 1,
      anon_sym_QMARK,
    STATE(8136), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [363975] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9008), 1,
      sym_declaration_list,
    STATE(8137), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [364028] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9007), 1,
      sym_declaration_list,
    STATE(8138), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [364081] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10176), 5,
      anon_sym_RPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
    STATE(8139), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [364126] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(8063), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9007), 1,
      sym_declaration_list,
    STATE(8140), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [364179] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9155), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(9157), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(10182), 1,
      aux_sym_preproc_if_token3,
    STATE(9642), 2,
      sym_preproc_else_in_enum_member_declaration,
      sym_preproc_elif_in_enum_member_declaration,
    STATE(8141), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [364230] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9470), 1,
      sym_declaration_list,
    STATE(8142), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [364283] = 12,
    ACTIONS(5568), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(9485), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9487), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9489), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9491), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9493), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9495), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9497), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9499), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9501), 1,
      sym_comment,
    ACTIONS(5570), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
    STATE(8143), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [364330] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9005), 1,
      sym_declaration_list,
    STATE(8144), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [364383] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9406), 1,
      sym_declaration_list,
    STATE(8145), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [364436] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9541), 1,
      sym_declaration_list,
    STATE(8146), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [364489] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(8068), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9005), 1,
      sym_declaration_list,
    STATE(8147), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [364542] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9004), 1,
      sym_declaration_list,
    STATE(8148), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [364595] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10184), 5,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_where,
      anon_sym_EQ_GT,
    STATE(8149), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [364640] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(8069), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9004), 1,
      sym_declaration_list,
    STATE(8150), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [364693] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(8998), 1,
      sym_declaration_list,
    STATE(8151), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [364746] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(8074), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(8998), 1,
      sym_declaration_list,
    STATE(8152), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [364799] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(8189), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9406), 1,
      sym_declaration_list,
    STATE(8153), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [364852] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9280), 1,
      sym_declaration_list,
    STATE(8154), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [364905] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10186), 5,
      anon_sym_RPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
    STATE(8155), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [364950] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5982), 1,
      anon_sym_STAR,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(10188), 1,
      anon_sym_LBRACE,
    STATE(5731), 1,
      sym_block,
    STATE(8870), 1,
      sym_parameter_list,
    STATE(8156), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [365003] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9423), 1,
      sym_declaration_list,
    STATE(8157), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [365056] = 14,
    ACTIONS(9485), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9487), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9489), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9491), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9493), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9495), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9497), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9499), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9501), 1,
      sym_comment,
    ACTIONS(10064), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10066), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10190), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(10062), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    STATE(8158), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [365107] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9421), 1,
      sym_declaration_list,
    STATE(8159), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [365160] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9911), 5,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_where,
      anon_sym_EQ_GT,
    STATE(8160), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [365205] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(8196), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9421), 1,
      sym_declaration_list,
    STATE(8161), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [365258] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5982), 1,
      anon_sym_STAR,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(10158), 1,
      anon_sym_LBRACE,
    STATE(4562), 1,
      sym_block,
    STATE(8902), 1,
      sym_parameter_list,
    STATE(8162), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [365311] = 14,
    ACTIONS(9485), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9487), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9489), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9491), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9493), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9495), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9497), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9499), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9501), 1,
      sym_comment,
    ACTIONS(10064), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10066), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10192), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(10062), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    STATE(8163), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [365362] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9331), 1,
      sym_declaration_list,
    STATE(8164), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [365415] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5982), 1,
      anon_sym_STAR,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(10188), 1,
      anon_sym_LBRACE,
    STATE(5647), 1,
      sym_block,
    STATE(8832), 1,
      sym_parameter_list,
    STATE(8165), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [365468] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4081), 1,
      anon_sym_EQ_GT,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9708), 1,
      anon_sym_LT,
    STATE(7628), 1,
      sym_parameter_list,
    STATE(8669), 1,
      sym_type_parameter_list,
    STATE(8166), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [365521] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(8164), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9321), 1,
      sym_declaration_list,
    STATE(8167), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [365574] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10194), 5,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_where,
      anon_sym_EQ_GT,
    STATE(8168), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [365619] = 12,
    ACTIONS(9485), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9487), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9489), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9491), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9493), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9495), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9497), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9499), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9501), 1,
      sym_comment,
    ACTIONS(10170), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(10196), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
    STATE(8169), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [365666] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10198), 5,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_where,
    STATE(8170), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [365711] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5982), 1,
      anon_sym_STAR,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(10200), 1,
      anon_sym_LBRACE,
    STATE(4012), 1,
      sym_block,
    STATE(8774), 1,
      sym_parameter_list,
    STATE(8171), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [365764] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10132), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10134), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10202), 1,
      anon_sym_RPAREN,
    ACTIONS(10130), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    STATE(8172), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [365815] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9317), 1,
      sym_declaration_list,
    STATE(8173), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [365868] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10082), 1,
      anon_sym_case,
    ACTIONS(10084), 1,
      anon_sym_default,
    ACTIONS(10204), 1,
      anon_sym_RBRACE,
    STATE(8126), 1,
      aux_sym_switch_body_repeat1,
    STATE(8515), 1,
      sym_switch_section,
    STATE(8174), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [365921] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5978), 1,
      anon_sym_LBRACK,
    ACTIONS(9742), 1,
      anon_sym_EQ,
    STATE(8545), 1,
      sym_bracketed_argument_list,
    ACTIONS(9675), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(8175), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [365972] = 14,
    ACTIONS(9485), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9487), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9489), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9491), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9493), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9495), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9497), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9499), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9501), 1,
      sym_comment,
    ACTIONS(10064), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10066), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10206), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(10062), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    STATE(8176), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [366023] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10210), 1,
      anon_sym_COMMA,
    ACTIONS(10208), 3,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_where,
    STATE(8177), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_record_base_repeat1,
  [366070] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5982), 1,
      anon_sym_STAR,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(10200), 1,
      anon_sym_LBRACE,
    STATE(3987), 1,
      sym_block,
    STATE(8756), 1,
      sym_parameter_list,
    STATE(8178), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [366123] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10150), 5,
      anon_sym_RPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
    STATE(8179), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [366168] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7250), 1,
      anon_sym_LBRACK,
    ACTIONS(7252), 1,
      anon_sym_STAR,
    ACTIONS(9909), 1,
      anon_sym_QMARK,
    ACTIONS(4424), 2,
      anon_sym_COMMA,
      anon_sym_GT,
    STATE(8180), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [366219] = 14,
    ACTIONS(9485), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9487), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9489), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9491), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9493), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9495), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9497), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9499), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9501), 1,
      sym_comment,
    ACTIONS(10064), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10066), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10213), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(10062), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    STATE(8181), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [366270] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8449), 1,
      anon_sym_DOT,
    ACTIONS(10208), 4,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_where,
    STATE(8182), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [366317] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10056), 1,
      anon_sym_and,
    ACTIONS(10058), 1,
      anon_sym_or,
    ACTIONS(10215), 1,
      anon_sym_COMMA,
    ACTIONS(10217), 1,
      anon_sym_RBRACK,
    STATE(8360), 1,
      aux_sym_list_pattern_repeat1,
    STATE(8183), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [366370] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10082), 1,
      anon_sym_case,
    ACTIONS(10084), 1,
      anon_sym_default,
    ACTIONS(10219), 1,
      anon_sym_RBRACE,
    STATE(7961), 1,
      aux_sym_switch_body_repeat1,
    STATE(8515), 1,
      sym_switch_section,
    STATE(8184), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [366423] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9875), 1,
      sym_declaration_list,
    STATE(8185), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [366476] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10221), 1,
      anon_sym_EQ_GT,
    ACTIONS(10223), 1,
      anon_sym_when,
    ACTIONS(10225), 1,
      anon_sym_and,
    ACTIONS(10227), 1,
      anon_sym_or,
    STATE(9574), 1,
      sym_when_clause,
    STATE(8186), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [366529] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(8142), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9349), 1,
      sym_declaration_list,
    STATE(8187), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [366582] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9349), 1,
      sym_declaration_list,
    STATE(8188), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [366635] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9025), 1,
      sym_declaration_list,
    STATE(8189), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [366688] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(8965), 1,
      sym_declaration_list,
    STATE(8190), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [366741] = 12,
    ACTIONS(9485), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9487), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9489), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9491), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9493), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9495), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9497), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9499), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9501), 1,
      sym_comment,
    ACTIONS(10186), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(10229), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
    STATE(8191), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [366788] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(8151), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9057), 1,
      sym_declaration_list,
    STATE(8192), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [366841] = 12,
    ACTIONS(9485), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9487), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9489), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9491), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9493), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9495), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9497), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9499), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9501), 1,
      sym_comment,
    ACTIONS(10176), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(10231), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
    STATE(8193), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [366888] = 13,
    ACTIONS(9485), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9487), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9489), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9491), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9493), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9495), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9497), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9499), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9501), 1,
      sym_comment,
    ACTIONS(10176), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(10062), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10231), 2,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
    STATE(8194), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [366937] = 14,
    ACTIONS(9485), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9487), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9489), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9491), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9493), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9495), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9497), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9499), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9501), 1,
      sym_comment,
    ACTIONS(10064), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10176), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(10231), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10062), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    STATE(8195), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [366988] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9358), 1,
      sym_declaration_list,
    STATE(8196), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [367041] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(8137), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(8965), 1,
      sym_declaration_list,
    STATE(8197), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [367094] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(8146), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9326), 1,
      sym_declaration_list,
    STATE(8198), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [367147] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9057), 1,
      sym_declaration_list,
    STATE(8199), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [367200] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10056), 1,
      anon_sym_and,
    ACTIONS(6544), 4,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_or,
    STATE(8200), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [367247] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9321), 1,
      sym_declaration_list,
    STATE(8201), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [367300] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10082), 1,
      anon_sym_case,
    ACTIONS(10084), 1,
      anon_sym_default,
    ACTIONS(10233), 1,
      anon_sym_RBRACE,
    STATE(8184), 1,
      aux_sym_switch_body_repeat1,
    STATE(8515), 1,
      sym_switch_section,
    STATE(8202), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [367353] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9069), 1,
      sym_declaration_list,
    STATE(8203), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [367406] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9878), 1,
      sym_declaration_list,
    STATE(8204), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [367459] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(8144), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9069), 1,
      sym_declaration_list,
    STATE(8205), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [367512] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(8019), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9468), 1,
      sym_declaration_list,
    STATE(8206), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [367565] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(9710), 1,
      anon_sym_where,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(9468), 1,
      sym_declaration_list,
    STATE(8207), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [367618] = 14,
    ACTIONS(9485), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9487), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9489), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9491), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9493), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9495), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9497), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9499), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9501), 1,
      sym_comment,
    ACTIONS(10064), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10066), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10235), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(10062), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    STATE(8208), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [367669] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10239), 1,
      anon_sym_and,
    ACTIONS(10241), 1,
      anon_sym_or,
    ACTIONS(10237), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(8209), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [367717] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(10243), 1,
      anon_sym_SEMI,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(8210), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [367767] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10245), 1,
      anon_sym_LT,
    ACTIONS(10247), 1,
      anon_sym_unmanaged,
    ACTIONS(10249), 1,
      anon_sym_managed,
    STATE(9473), 1,
      sym_calling_convention,
    STATE(8211), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [367817] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(10251), 1,
      anon_sym_SEMI,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(8212), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [367867] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9708), 1,
      anon_sym_LT,
    STATE(8239), 1,
      sym_parameter_list,
    STATE(8675), 1,
      sym_type_parameter_list,
    STATE(8213), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [367917] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7250), 1,
      anon_sym_LBRACK,
    ACTIONS(7252), 1,
      anon_sym_STAR,
    ACTIONS(7254), 1,
      anon_sym_QMARK,
    ACTIONS(7396), 1,
      anon_sym_DOT,
    STATE(8214), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [367967] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7250), 1,
      anon_sym_LBRACK,
    ACTIONS(9909), 1,
      anon_sym_QMARK,
    ACTIONS(4424), 2,
      anon_sym_COMMA,
      anon_sym_GT,
    STATE(8215), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [368015] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5707), 1,
      anon_sym_LBRACE,
    ACTIONS(9896), 1,
      anon_sym_when,
    STATE(2279), 1,
      sym_block,
    STATE(8828), 1,
      sym_catch_filter_clause,
    STATE(8216), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [368065] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4424), 1,
      anon_sym_GT,
    ACTIONS(7250), 1,
      anon_sym_LBRACK,
    ACTIONS(7252), 1,
      anon_sym_STAR,
    ACTIONS(9907), 1,
      anon_sym_COMMA,
    STATE(8217), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [368115] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4404), 4,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_STAR,
    STATE(8218), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [368159] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10247), 1,
      anon_sym_unmanaged,
    ACTIONS(10249), 1,
      anon_sym_managed,
    ACTIONS(10253), 1,
      anon_sym_LT,
    STATE(9769), 1,
      sym_calling_convention,
    STATE(8219), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [368209] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4389), 4,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_STAR,
    STATE(8220), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [368253] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10056), 1,
      anon_sym_and,
    ACTIONS(10058), 1,
      anon_sym_or,
    ACTIONS(10237), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(8221), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [368301] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10255), 1,
      anon_sym_COMMA,
    ACTIONS(10258), 2,
      anon_sym_RBRACK,
      anon_sym_GT,
    STATE(8222), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_type_argument_list_repeat1,
  [368347] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(10260), 1,
      anon_sym_SEMI,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(8223), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [368397] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10262), 1,
      anon_sym_COMMA,
    ACTIONS(9824), 3,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_where,
    STATE(8224), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [368443] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9679), 1,
      anon_sym_LBRACE,
    ACTIONS(9683), 1,
      anon_sym_EQ_GT,
    STATE(3316), 1,
      sym_accessor_list,
    STATE(9108), 1,
      sym_arrow_expression_clause,
    STATE(8225), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [368493] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10247), 1,
      anon_sym_unmanaged,
    ACTIONS(10249), 1,
      anon_sym_managed,
    ACTIONS(10264), 1,
      anon_sym_LT,
    STATE(9727), 1,
      sym_calling_convention,
    STATE(8226), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [368543] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2973), 4,
      anon_sym_while,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_else,
    STATE(8227), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [368587] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(10266), 1,
      anon_sym_SEMI,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(8319), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8228), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [368637] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2981), 4,
      anon_sym_while,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_else,
    STATE(8229), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [368681] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(10268), 1,
      anon_sym_SEMI,
    STATE(8294), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(8230), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [368731] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10270), 1,
      anon_sym_COLON,
    ACTIONS(10272), 1,
      anon_sym_LBRACE,
    STATE(8672), 1,
      sym_base_list,
    STATE(8985), 1,
      sym_enum_member_declaration_list,
    STATE(8231), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [368781] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10056), 1,
      anon_sym_and,
    ACTIONS(10058), 1,
      anon_sym_or,
    ACTIONS(1903), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    STATE(8232), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [368829] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10056), 1,
      anon_sym_and,
    ACTIONS(10058), 1,
      anon_sym_or,
    ACTIONS(10274), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(8233), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [368877] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4408), 4,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_STAR,
    STATE(8234), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [368921] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10247), 1,
      anon_sym_unmanaged,
    ACTIONS(10249), 1,
      anon_sym_managed,
    ACTIONS(10276), 1,
      anon_sym_LT,
    STATE(9793), 1,
      sym_calling_convention,
    STATE(8235), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [368971] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4424), 1,
      anon_sym_GT,
    ACTIONS(7250), 1,
      anon_sym_LBRACK,
    ACTIONS(9907), 1,
      anon_sym_COMMA,
    ACTIONS(9909), 1,
      anon_sym_QMARK,
    STATE(8236), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [369021] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8449), 1,
      anon_sym_DOT,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(10278), 1,
      anon_sym_SEMI,
    STATE(9460), 1,
      sym_declaration_list,
    STATE(8237), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [369071] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10247), 1,
      anon_sym_unmanaged,
    ACTIONS(10249), 1,
      anon_sym_managed,
    ACTIONS(10280), 1,
      anon_sym_LT,
    STATE(9508), 1,
      sym_calling_convention,
    STATE(8238), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [369121] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(10282), 1,
      anon_sym_SEMI,
    STATE(8290), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(8239), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [369171] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10270), 1,
      anon_sym_COLON,
    ACTIONS(10272), 1,
      anon_sym_LBRACE,
    STATE(8841), 1,
      sym_base_list,
    STATE(9523), 1,
      sym_enum_member_declaration_list,
    STATE(8240), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [369221] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10239), 1,
      anon_sym_and,
    ACTIONS(6544), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_or,
    STATE(8241), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [369267] = 12,
    ACTIONS(9485), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9487), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9489), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9491), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9493), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9495), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9497), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9499), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9501), 1,
      sym_comment,
    ACTIONS(10286), 1,
      aux_sym_string_literal_content_token1,
    ACTIONS(10284), 3,
      anon_sym_DQUOTE,
      aux_sym_string_literal_content_token2,
      sym_escape_sequence,
    STATE(8242), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [369313] = 12,
    ACTIONS(9485), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9487), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9489), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9491), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9493), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9495), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9497), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9499), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9501), 1,
      sym_comment,
    ACTIONS(10286), 1,
      aux_sym_string_literal_content_token1,
    ACTIONS(10284), 3,
      anon_sym_DQUOTE,
      aux_sym_string_literal_content_token2,
      sym_escape_sequence,
    STATE(8243), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [369359] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5980), 1,
      anon_sym_LBRACE,
    ACTIONS(9896), 1,
      anon_sym_when,
    STATE(8227), 1,
      sym_block,
    STATE(8945), 1,
      sym_catch_filter_clause,
    STATE(8244), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [369409] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(10288), 1,
      anon_sym_SEMI,
    STATE(8223), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(8245), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [369459] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9708), 1,
      anon_sym_LT,
    STATE(8284), 1,
      sym_parameter_list,
    STATE(8807), 1,
      sym_type_parameter_list,
    STATE(8246), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [369509] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10270), 1,
      anon_sym_COLON,
    ACTIONS(10272), 1,
      anon_sym_LBRACE,
    STATE(8803), 1,
      sym_base_list,
    STATE(9646), 1,
      sym_enum_member_declaration_list,
    STATE(8247), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [369559] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9708), 1,
      anon_sym_LT,
    STATE(7624), 1,
      sym_parameter_list,
    STATE(8801), 1,
      sym_type_parameter_list,
    STATE(8248), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [369609] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(10290), 1,
      anon_sym_SEMI,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(8249), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [369659] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10292), 4,
      sym_interpolation_open_brace,
      sym_interpolation_string_content,
      anon_sym_DQUOTE,
      sym_escape_sequence,
    STATE(8250), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [369703] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10294), 1,
      anon_sym_COMMA,
    ACTIONS(8189), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    STATE(8251), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_for_statement_repeat1,
  [369749] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9679), 1,
      anon_sym_LBRACE,
    ACTIONS(9683), 1,
      anon_sym_EQ_GT,
    STATE(3510), 1,
      sym_accessor_list,
    STATE(9369), 1,
      sym_arrow_expression_clause,
    STATE(8252), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [369799] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10237), 1,
      anon_sym_COMMA,
    ACTIONS(10239), 1,
      anon_sym_and,
    ACTIONS(10241), 1,
      anon_sym_or,
    ACTIONS(10297), 1,
      anon_sym_RPAREN,
    STATE(8253), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [369849] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8449), 1,
      anon_sym_DOT,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    ACTIONS(10299), 1,
      anon_sym_SEMI,
    STATE(9562), 1,
      sym_declaration_list,
    STATE(8254), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [369899] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10270), 1,
      anon_sym_COLON,
    ACTIONS(10272), 1,
      anon_sym_LBRACE,
    STATE(8684), 1,
      sym_base_list,
    STATE(9389), 1,
      sym_enum_member_declaration_list,
    STATE(8255), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [369949] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9679), 1,
      anon_sym_LBRACE,
    ACTIONS(9683), 1,
      anon_sym_EQ_GT,
    STATE(3382), 1,
      sym_accessor_list,
    STATE(9373), 1,
      sym_arrow_expression_clause,
    STATE(8256), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [369999] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(10301), 1,
      anon_sym_SEMI,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(8257), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [370049] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10237), 1,
      anon_sym_COMMA,
    ACTIONS(10239), 1,
      anon_sym_and,
    ACTIONS(10241), 1,
      anon_sym_or,
    ACTIONS(10303), 1,
      anon_sym_RPAREN,
    STATE(8258), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [370099] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10247), 1,
      anon_sym_unmanaged,
    ACTIONS(10249), 1,
      anon_sym_managed,
    ACTIONS(10305), 1,
      anon_sym_LT,
    STATE(9813), 1,
      sym_calling_convention,
    STATE(8259), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [370149] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(10307), 1,
      anon_sym_SEMI,
    STATE(8212), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(8260), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [370199] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(10309), 1,
      anon_sym_SEMI,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(8261), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [370249] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9679), 1,
      anon_sym_LBRACE,
    ACTIONS(9683), 1,
      anon_sym_EQ_GT,
    STATE(3325), 1,
      sym_accessor_list,
    STATE(9895), 1,
      sym_arrow_expression_clause,
    STATE(8262), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [370299] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(10311), 1,
      anon_sym_SEMI,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(8263), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [370349] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(10313), 1,
      anon_sym_SEMI,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(8264), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [370399] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(10315), 1,
      anon_sym_SEMI,
    STATE(8263), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(8265), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [370449] = 12,
    ACTIONS(9485), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9487), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9489), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9491), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9493), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9495), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9497), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9499), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9501), 1,
      sym_comment,
    ACTIONS(10319), 1,
      aux_sym_string_literal_content_token1,
    ACTIONS(10317), 3,
      anon_sym_DQUOTE,
      aux_sym_string_literal_content_token2,
      sym_escape_sequence,
    STATE(8266), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [370495] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(10321), 1,
      anon_sym_SEMI,
    STATE(8261), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(8267), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [370545] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4081), 1,
      anon_sym_EQ_GT,
    ACTIONS(10323), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
    STATE(8268), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [370591] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10247), 1,
      anon_sym_unmanaged,
    ACTIONS(10249), 1,
      anon_sym_managed,
    ACTIONS(10325), 1,
      anon_sym_LT,
    STATE(9832), 1,
      sym_calling_convention,
    STATE(8269), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [370641] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(10327), 1,
      anon_sym_SEMI,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(8270), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [370691] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(10329), 1,
      anon_sym_SEMI,
    STATE(8279), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(8271), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [370741] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9708), 1,
      anon_sym_LT,
    STATE(8267), 1,
      sym_parameter_list,
    STATE(8718), 1,
      sym_type_parameter_list,
    STATE(8272), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [370791] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10331), 1,
      anon_sym_EQ,
    ACTIONS(10333), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
    STATE(8273), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [370837] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9708), 1,
      anon_sym_LT,
    STATE(8228), 1,
      sym_parameter_list,
    STATE(8900), 1,
      sym_type_parameter_list,
    STATE(8274), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [370887] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9708), 1,
      anon_sym_LT,
    STATE(7572), 1,
      sym_parameter_list,
    STATE(8938), 1,
      sym_type_parameter_list,
    STATE(8275), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [370937] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10247), 1,
      anon_sym_unmanaged,
    ACTIONS(10249), 1,
      anon_sym_managed,
    ACTIONS(10335), 1,
      anon_sym_LT,
    STATE(9665), 1,
      sym_calling_convention,
    STATE(8276), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [370987] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10337), 1,
      anon_sym_COMMA,
    ACTIONS(10340), 2,
      anon_sym_LBRACE,
      anon_sym_where,
    STATE(8277), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_base_list_repeat1,
  [371033] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10342), 1,
      anon_sym_EQ,
    ACTIONS(10022), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
    STATE(8278), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [371079] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(10344), 1,
      anon_sym_SEMI,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(8279), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [371129] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4420), 4,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_STAR,
    STATE(8280), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [371173] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10346), 4,
      sym_interpolation_open_brace,
      sym_interpolation_string_content,
      anon_sym_DQUOTE,
      sym_escape_sequence,
    STATE(8281), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [371217] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10239), 1,
      anon_sym_and,
    ACTIONS(10241), 1,
      anon_sym_or,
    ACTIONS(10274), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(8282), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [371265] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10348), 4,
      sym_interpolation_open_brace,
      sym_interpolation_string_content,
      anon_sym_DQUOTE,
      sym_escape_sequence,
    STATE(8283), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [371309] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(10350), 1,
      anon_sym_SEMI,
    STATE(8249), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(8284), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [371359] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(10352), 1,
      anon_sym_SEMI,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(8285), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [371409] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9708), 1,
      anon_sym_LT,
    STATE(8345), 1,
      sym_parameter_list,
    STATE(8670), 1,
      sym_type_parameter_list,
    STATE(8286), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [371459] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10225), 1,
      anon_sym_and,
    ACTIONS(6544), 3,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_or,
    STATE(8287), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [371505] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4434), 4,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_STAR,
    STATE(8288), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [371549] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(10354), 1,
      anon_sym_SEMI,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(8325), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8289), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [371599] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(10356), 1,
      anon_sym_SEMI,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(8290), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [371649] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10270), 1,
      anon_sym_COLON,
    ACTIONS(10272), 1,
      anon_sym_LBRACE,
    STATE(8671), 1,
      sym_base_list,
    STATE(9107), 1,
      sym_enum_member_declaration_list,
    STATE(8291), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [371699] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10358), 4,
      sym_interpolation_open_brace,
      sym_interpolation_string_content,
      anon_sym_DQUOTE,
      sym_escape_sequence,
    STATE(8292), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [371743] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(10360), 1,
      anon_sym_SEMI,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(8341), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8293), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [371793] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(10362), 1,
      anon_sym_SEMI,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(8294), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [371843] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(10364), 1,
      anon_sym_SEMI,
    STATE(8264), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(8295), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [371893] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10366), 1,
      anon_sym_COMMA,
    STATE(8277), 1,
      aux_sym_base_list_repeat1,
    ACTIONS(10368), 2,
      anon_sym_LBRACE,
      anon_sym_where,
    STATE(8296), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [371941] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9708), 1,
      anon_sym_LT,
    STATE(7575), 1,
      sym_parameter_list,
    STATE(8878), 1,
      sym_type_parameter_list,
    STATE(8297), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [371991] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10370), 4,
      sym_interpolation_open_brace,
      sym_interpolation_string_content,
      anon_sym_DQUOTE,
      sym_escape_sequence,
    STATE(8298), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [372035] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10366), 1,
      anon_sym_COMMA,
    STATE(8296), 1,
      aux_sym_base_list_repeat1,
    ACTIONS(10372), 2,
      anon_sym_LBRACE,
      anon_sym_where,
    STATE(8299), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [372083] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(10374), 1,
      anon_sym_SEMI,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(8300), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [372133] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10270), 1,
      anon_sym_COLON,
    ACTIONS(10272), 1,
      anon_sym_LBRACE,
    STATE(8668), 1,
      sym_base_list,
    STATE(9467), 1,
      sym_enum_member_declaration_list,
    STATE(8301), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [372183] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10237), 1,
      anon_sym_COMMA,
    ACTIONS(10239), 1,
      anon_sym_and,
    ACTIONS(10241), 1,
      anon_sym_or,
    ACTIONS(10376), 1,
      anon_sym_RPAREN,
    STATE(8302), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [372233] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10225), 1,
      anon_sym_and,
    ACTIONS(10227), 1,
      anon_sym_or,
    ACTIONS(6607), 2,
      anon_sym_EQ_GT,
      anon_sym_when,
    STATE(8303), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [372281] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10378), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_where,
      anon_sym_EQ_GT,
    STATE(8304), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [372325] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10380), 1,
      anon_sym_EQ,
    ACTIONS(10382), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
    STATE(8305), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [372371] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10384), 1,
      anon_sym_LPAREN,
    ACTIONS(10388), 1,
      sym_integer_literal,
    ACTIONS(10386), 2,
      anon_sym_default,
      anon_sym_hidden,
    STATE(8306), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [372419] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4081), 1,
      anon_sym_EQ_GT,
    ACTIONS(10390), 1,
      anon_sym_EQ,
    ACTIONS(10382), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(8307), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [372467] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2977), 4,
      anon_sym_while,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_else,
    STATE(8308), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [372511] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10392), 1,
      anon_sym_COMMA,
    ACTIONS(10395), 2,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
    STATE(8309), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_bracketed_parameter_list_repeat1,
  [372557] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(10397), 1,
      anon_sym_SEMI,
    STATE(8285), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(8310), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [372607] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9708), 1,
      anon_sym_LT,
    STATE(8310), 1,
      sym_parameter_list,
    STATE(8904), 1,
      sym_type_parameter_list,
    STATE(8311), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [372657] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9679), 1,
      anon_sym_LBRACE,
    ACTIONS(9683), 1,
      anon_sym_EQ_GT,
    STATE(3304), 1,
      sym_accessor_list,
    STATE(9601), 1,
      sym_arrow_expression_clause,
    STATE(8312), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [372707] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(10399), 1,
      anon_sym_SEMI,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(8313), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [372757] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7250), 1,
      anon_sym_LBRACK,
    ACTIONS(7252), 1,
      anon_sym_STAR,
    ACTIONS(7254), 1,
      anon_sym_QMARK,
    ACTIONS(9907), 1,
      anon_sym_COMMA,
    STATE(8314), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [372807] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10270), 1,
      anon_sym_COLON,
    ACTIONS(10272), 1,
      anon_sym_LBRACE,
    STATE(8926), 1,
      sym_base_list,
    STATE(9239), 1,
      sym_enum_member_declaration_list,
    STATE(8315), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [372857] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(10401), 1,
      anon_sym_SEMI,
    STATE(8270), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(8316), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [372907] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10237), 1,
      anon_sym_COMMA,
    ACTIONS(10239), 1,
      anon_sym_and,
    ACTIONS(10241), 1,
      anon_sym_or,
    ACTIONS(10403), 1,
      anon_sym_RPAREN,
    STATE(8317), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [372957] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(10405), 1,
      anon_sym_SEMI,
    STATE(8210), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(8318), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [373007] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(10407), 1,
      anon_sym_SEMI,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(8319), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [373057] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4081), 1,
      anon_sym_EQ_GT,
    ACTIONS(10409), 1,
      anon_sym_EQ,
    ACTIONS(10411), 1,
      anon_sym_COMMA,
    ACTIONS(10414), 1,
      anon_sym_RPAREN,
    STATE(8320), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [373107] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9708), 1,
      anon_sym_LT,
    STATE(8316), 1,
      sym_parameter_list,
    STATE(8943), 1,
      sym_type_parameter_list,
    STATE(8321), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [373157] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10239), 1,
      anon_sym_and,
    ACTIONS(10241), 1,
      anon_sym_or,
    ACTIONS(6607), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(8322), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [373205] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10416), 4,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_where,
    STATE(8323), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [373249] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(10418), 1,
      anon_sym_SEMI,
    STATE(8257), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(8324), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [373299] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(10420), 1,
      anon_sym_SEMI,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(8325), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [373349] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9708), 1,
      anon_sym_LT,
    STATE(8324), 1,
      sym_parameter_list,
    STATE(8949), 1,
      sym_type_parameter_list,
    STATE(8326), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [373399] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10100), 1,
      anon_sym_and,
    ACTIONS(6544), 3,
      anon_sym_COLON,
      anon_sym_when,
      anon_sym_or,
    STATE(8327), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [373445] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9679), 1,
      anon_sym_LBRACE,
    ACTIONS(9683), 1,
      anon_sym_EQ_GT,
    STATE(3310), 1,
      sym_accessor_list,
    STATE(9491), 1,
      sym_arrow_expression_clause,
    STATE(8328), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [373495] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10237), 1,
      anon_sym_COMMA,
    ACTIONS(10239), 1,
      anon_sym_and,
    ACTIONS(10241), 1,
      anon_sym_or,
    ACTIONS(10422), 1,
      anon_sym_RPAREN,
    STATE(8329), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [373545] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10270), 1,
      anon_sym_COLON,
    ACTIONS(10272), 1,
      anon_sym_LBRACE,
    STATE(8947), 1,
      sym_base_list,
    STATE(9017), 1,
      sym_enum_member_declaration_list,
    STATE(8330), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [373595] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6104), 1,
      anon_sym_LBRACE,
    ACTIONS(9896), 1,
      anon_sym_when,
    STATE(2640), 1,
      sym_block,
    STATE(8942), 1,
      sym_catch_filter_clause,
    STATE(8331), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [373645] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10424), 1,
      anon_sym_EQ,
    ACTIONS(10426), 3,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(8332), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [373691] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5709), 1,
      anon_sym_LBRACE,
    ACTIONS(9896), 1,
      anon_sym_when,
    STATE(2207), 1,
      sym_block,
    STATE(8810), 1,
      sym_catch_filter_clause,
    STATE(8333), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [373741] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10428), 1,
      anon_sym_EQ,
    ACTIONS(10430), 3,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(8334), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [373787] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(10432), 1,
      anon_sym_SEMI,
    STATE(8300), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(8335), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [373837] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5761), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5816), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(8336), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [373883] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10270), 1,
      anon_sym_COLON,
    ACTIONS(10272), 1,
      anon_sym_LBRACE,
    STATE(8941), 1,
      sym_base_list,
    STATE(9401), 1,
      sym_enum_member_declaration_list,
    STATE(8337), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [373933] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10100), 1,
      anon_sym_and,
    ACTIONS(10102), 1,
      anon_sym_or,
    ACTIONS(6607), 2,
      anon_sym_COLON,
      anon_sym_when,
    STATE(8338), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [373981] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9708), 1,
      anon_sym_LT,
    STATE(7570), 1,
      sym_parameter_list,
    STATE(8800), 1,
      sym_type_parameter_list,
    STATE(8339), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [374031] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2965), 4,
      anon_sym_while,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_else,
    STATE(8340), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [374075] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(10434), 1,
      anon_sym_SEMI,
    STATE(7889), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(8341), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [374125] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4081), 1,
      anon_sym_EQ_GT,
    ACTIONS(9980), 1,
      anon_sym_EQ,
    ACTIONS(10022), 1,
      anon_sym_RPAREN,
    ACTIONS(10436), 1,
      anon_sym_COMMA,
    STATE(8342), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [374175] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10340), 4,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_GT,
      anon_sym_where,
    STATE(8343), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [374219] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    ACTIONS(9708), 1,
      anon_sym_LT,
    STATE(8230), 1,
      sym_parameter_list,
    STATE(8948), 1,
      sym_type_parameter_list,
    STATE(8344), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [374269] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9710), 1,
      anon_sym_where,
    ACTIONS(10440), 1,
      anon_sym_SEMI,
    STATE(8304), 1,
      sym_type_parameter_constraints_clause,
    STATE(8313), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8345), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [374319] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10442), 1,
      anon_sym_COMMA,
    ACTIONS(10444), 1,
      anon_sym_RPAREN,
    STATE(8540), 1,
      aux_sym_tuple_type_repeat1,
    STATE(8346), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [374366] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10446), 1,
      anon_sym_COMMA,
    ACTIONS(10449), 1,
      anon_sym_RPAREN,
    STATE(8347), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_tuple_pattern_repeat1,
  [374411] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9216), 1,
      anon_sym_RBRACE,
    ACTIONS(10451), 1,
      anon_sym_COMMA,
    STATE(8506), 1,
      aux_sym_enum_member_declaration_list_repeat1,
    STATE(8348), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [374458] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10453), 1,
      anon_sym_EQ,
    ACTIONS(10426), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(8349), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [374503] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9265), 1,
      anon_sym_RBRACK,
    ACTIONS(10455), 1,
      anon_sym_COMMA,
    STATE(8630), 1,
      aux_sym_global_attribute_repeat1,
    STATE(8350), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [374550] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10457), 1,
      anon_sym_COMMA,
    ACTIONS(10459), 1,
      anon_sym_RPAREN,
    STATE(8649), 1,
      aux_sym_argument_list_repeat1,
    STATE(8351), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [374597] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5655), 1,
      anon_sym_COMMA,
    ACTIONS(10461), 1,
      anon_sym_RBRACK,
    STATE(8222), 1,
      aux_sym_type_argument_list_repeat1,
    STATE(8352), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [374644] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2757), 1,
      anon_sym_RBRACE,
    ACTIONS(10463), 1,
      anon_sym_COMMA,
    STATE(8373), 1,
      aux_sym_anonymous_object_creation_expression_repeat1,
    STATE(8353), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [374691] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7250), 1,
      anon_sym_LBRACK,
    ACTIONS(7254), 1,
      anon_sym_QMARK,
    ACTIONS(9907), 1,
      anon_sym_COMMA,
    STATE(8354), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [374738] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8116), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
    STATE(8355), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [374781] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2085), 1,
      anon_sym_RBRACE,
    ACTIONS(10465), 1,
      anon_sym_COMMA,
    STATE(8529), 1,
      aux_sym_switch_expression_repeat1,
    STATE(8356), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [374828] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10467), 1,
      anon_sym_COMMA,
    ACTIONS(10469), 1,
      anon_sym_GT,
    STATE(8478), 1,
      aux_sym_type_parameter_list_repeat1,
    STATE(8357), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [374875] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10471), 1,
      anon_sym_COMMA,
    ACTIONS(10473), 1,
      anon_sym_RBRACK,
    STATE(8435), 1,
      aux_sym_argument_list_repeat1,
    STATE(8358), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [374922] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10475), 1,
      anon_sym_COMMA,
    ACTIONS(10477), 1,
      anon_sym_RBRACK,
    STATE(8417), 1,
      aux_sym_global_attribute_repeat1,
    STATE(8359), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [374969] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2255), 1,
      anon_sym_RBRACK,
    ACTIONS(10479), 1,
      anon_sym_COMMA,
    STATE(8531), 1,
      aux_sym_list_pattern_repeat1,
    STATE(8360), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [375016] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2607), 1,
      anon_sym_COMMA,
    ACTIONS(7944), 1,
      anon_sym_RBRACK,
    STATE(8497), 1,
      aux_sym_array_rank_specifier_repeat1,
    STATE(8361), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [375063] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9679), 1,
      anon_sym_LBRACE,
    ACTIONS(10481), 1,
      anon_sym_SEMI,
    STATE(3292), 1,
      sym_accessor_list,
    STATE(8362), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [375110] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10483), 1,
      anon_sym_COMMA,
    ACTIONS(10485), 1,
      anon_sym_RPAREN,
    STATE(8534), 1,
      aux_sym_positional_pattern_clause_repeat1,
    STATE(8363), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [375157] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2213), 1,
      anon_sym_RBRACE,
    ACTIONS(10487), 1,
      anon_sym_COMMA,
    STATE(8640), 1,
      aux_sym_positional_pattern_clause_repeat1,
    STATE(8364), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [375204] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10489), 1,
      anon_sym_COMMA,
    ACTIONS(10491), 1,
      anon_sym_RPAREN,
    STATE(8539), 1,
      aux_sym_parenthesized_variable_designation_repeat1,
    STATE(8365), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [375251] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10493), 1,
      anon_sym_COMMA,
    ACTIONS(10495), 1,
      anon_sym_GT,
    STATE(8392), 1,
      aux_sym_base_list_repeat1,
    STATE(8366), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [375298] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10497), 3,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
    STATE(8367), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [375341] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2607), 1,
      anon_sym_COMMA,
    ACTIONS(10499), 1,
      anon_sym_RBRACK,
    STATE(8497), 1,
      aux_sym_array_rank_specifier_repeat1,
    STATE(8368), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [375388] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5655), 1,
      anon_sym_COMMA,
    ACTIONS(10501), 1,
      anon_sym_GT,
    STATE(8222), 1,
      aux_sym_type_argument_list_repeat1,
    STATE(8369), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [375435] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10493), 1,
      anon_sym_COMMA,
    ACTIONS(10501), 1,
      anon_sym_GT,
    STATE(8366), 1,
      aux_sym_base_list_repeat1,
    STATE(8370), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [375482] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10503), 1,
      anon_sym_COMMA,
    ACTIONS(10505), 1,
      anon_sym_RBRACE,
    STATE(8408), 1,
      aux_sym_switch_expression_repeat1,
    STATE(8371), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [375529] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2267), 1,
      anon_sym_RBRACK,
    ACTIONS(10507), 1,
      anon_sym_COMMA,
    STATE(8531), 1,
      aux_sym_list_pattern_repeat1,
    STATE(8372), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [375576] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10509), 1,
      anon_sym_COMMA,
    ACTIONS(10512), 1,
      anon_sym_RBRACE,
    STATE(8373), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_anonymous_object_creation_expression_repeat1,
  [375621] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10514), 1,
      anon_sym_COMMA,
    ACTIONS(10516), 1,
      anon_sym_RBRACK,
    STATE(8508), 1,
      aux_sym_calling_convention_repeat1,
    STATE(8374), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [375668] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10518), 1,
      anon_sym_COMMA,
    ACTIONS(10520), 1,
      anon_sym_RBRACE,
    STATE(8413), 1,
      aux_sym_with_expression_repeat1,
    STATE(8375), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [375715] = 12,
    ACTIONS(9485), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9487), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9489), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9491), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9493), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9495), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9497), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9499), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9501), 1,
      sym_comment,
    ACTIONS(10522), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(10524), 2,
      anon_sym_annotations,
      anon_sym_warnings,
    STATE(8376), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [375760] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10442), 1,
      anon_sym_COMMA,
    ACTIONS(10526), 1,
      anon_sym_RPAREN,
    STATE(8540), 1,
      aux_sym_tuple_type_repeat1,
    STATE(8377), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [375807] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10493), 1,
      anon_sym_COMMA,
    ACTIONS(10528), 1,
      anon_sym_GT,
    STATE(8392), 1,
      aux_sym_base_list_repeat1,
    STATE(8378), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [375854] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7986), 1,
      anon_sym_COMMA,
    ACTIONS(10530), 1,
      anon_sym_RPAREN,
    STATE(8251), 1,
      aux_sym_for_statement_repeat1,
    STATE(8379), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [375901] = 13,
    ACTIONS(9485), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9487), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9489), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9491), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9493), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9495), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9497), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9499), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9501), 1,
      sym_comment,
    ACTIONS(10532), 1,
      anon_sym_DQUOTE,
    ACTIONS(10534), 1,
      aux_sym_preproc_if_token2,
    STATE(9720), 1,
      sym_string_literal,
    STATE(8380), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [375948] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7986), 1,
      anon_sym_COMMA,
    ACTIONS(10536), 1,
      anon_sym_RPAREN,
    STATE(8251), 1,
      aux_sym_for_statement_repeat1,
    STATE(8381), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [375995] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10538), 1,
      anon_sym_COMMA,
    ACTIONS(10540), 1,
      anon_sym_RPAREN,
    STATE(8403), 1,
      aux_sym_bracketed_parameter_list_repeat1,
    STATE(8382), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [376042] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2607), 1,
      anon_sym_COMMA,
    ACTIONS(8056), 1,
      anon_sym_RBRACK,
    STATE(8497), 1,
      aux_sym_array_rank_specifier_repeat1,
    STATE(8383), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [376089] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10442), 1,
      anon_sym_COMMA,
    ACTIONS(10542), 1,
      anon_sym_RPAREN,
    STATE(8540), 1,
      aux_sym_tuple_type_repeat1,
    STATE(8384), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [376136] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10544), 1,
      anon_sym_DQUOTE,
    ACTIONS(10546), 1,
      sym_integer_literal,
    STATE(9669), 1,
      sym_string_literal,
    STATE(8385), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [376183] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10518), 1,
      anon_sym_COMMA,
    ACTIONS(10548), 1,
      anon_sym_RBRACE,
    STATE(8537), 1,
      aux_sym_with_expression_repeat1,
    STATE(8386), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [376230] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10538), 1,
      anon_sym_COMMA,
    ACTIONS(10550), 1,
      anon_sym_RBRACK,
    STATE(8309), 1,
      aux_sym_bracketed_parameter_list_repeat1,
    STATE(8387), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [376277] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5655), 1,
      anon_sym_COMMA,
    ACTIONS(10552), 1,
      anon_sym_RBRACK,
    STATE(8352), 1,
      aux_sym_type_argument_list_repeat1,
    STATE(8388), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [376324] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10471), 1,
      anon_sym_COMMA,
    ACTIONS(10554), 1,
      anon_sym_RBRACK,
    STATE(8432), 1,
      aux_sym_argument_list_repeat1,
    STATE(8389), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [376371] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10538), 1,
      anon_sym_COMMA,
    ACTIONS(10556), 1,
      anon_sym_RPAREN,
    STATE(8401), 1,
      aux_sym_bracketed_parameter_list_repeat1,
    STATE(8390), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [376418] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10493), 1,
      anon_sym_COMMA,
    ACTIONS(10558), 1,
      anon_sym_GT,
    STATE(8378), 1,
      aux_sym_base_list_repeat1,
    STATE(8391), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [376465] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10340), 1,
      anon_sym_GT,
    ACTIONS(10560), 1,
      anon_sym_COMMA,
    STATE(8392), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_base_list_repeat1,
  [376510] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10563), 1,
      anon_sym_COMMA,
    ACTIONS(10565), 1,
      anon_sym_RBRACE,
    STATE(8353), 1,
      aux_sym_anonymous_object_creation_expression_repeat1,
    STATE(8393), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [376557] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10457), 1,
      anon_sym_COMMA,
    ACTIONS(10567), 1,
      anon_sym_RPAREN,
    STATE(8649), 1,
      aux_sym_argument_list_repeat1,
    STATE(8394), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [376604] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10569), 1,
      anon_sym_COMMA,
    ACTIONS(10571), 1,
      anon_sym_RBRACK,
    STATE(8442), 1,
      aux_sym_global_attribute_repeat1,
    STATE(8395), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [376651] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5655), 1,
      anon_sym_COMMA,
    ACTIONS(10558), 1,
      anon_sym_GT,
    STATE(8222), 1,
      aux_sym_type_argument_list_repeat1,
    STATE(8396), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [376698] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7250), 1,
      anon_sym_LBRACK,
    ACTIONS(7252), 1,
      anon_sym_STAR,
    ACTIONS(9907), 1,
      anon_sym_COMMA,
    STATE(8397), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [376745] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10457), 1,
      anon_sym_COMMA,
    ACTIONS(10573), 1,
      anon_sym_RPAREN,
    STATE(8351), 1,
      aux_sym_argument_list_repeat1,
    STATE(8398), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [376792] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2763), 1,
      anon_sym_RBRACE,
    ACTIONS(10575), 1,
      anon_sym_COMMA,
    STATE(8251), 1,
      aux_sym_for_statement_repeat1,
    STATE(8399), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [376839] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2775), 1,
      anon_sym_RBRACE,
    ACTIONS(10577), 1,
      anon_sym_COMMA,
    STATE(8251), 1,
      aux_sym_for_statement_repeat1,
    STATE(8400), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [376886] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10538), 1,
      anon_sym_COMMA,
    ACTIONS(10579), 1,
      anon_sym_RPAREN,
    STATE(8309), 1,
      aux_sym_bracketed_parameter_list_repeat1,
    STATE(8401), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [376933] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10489), 1,
      anon_sym_COMMA,
    ACTIONS(10581), 1,
      anon_sym_RPAREN,
    STATE(8482), 1,
      aux_sym_parenthesized_variable_designation_repeat1,
    STATE(8402), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [376980] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10538), 1,
      anon_sym_COMMA,
    ACTIONS(10583), 1,
      anon_sym_RPAREN,
    STATE(8309), 1,
      aux_sym_bracketed_parameter_list_repeat1,
    STATE(8403), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [377027] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2607), 1,
      anon_sym_COMMA,
    ACTIONS(7824), 1,
      anon_sym_RBRACK,
    STATE(8497), 1,
      aux_sym_array_rank_specifier_repeat1,
    STATE(8404), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [377074] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10538), 1,
      anon_sym_COMMA,
    ACTIONS(10585), 1,
      anon_sym_RBRACK,
    STATE(8309), 1,
      aux_sym_bracketed_parameter_list_repeat1,
    STATE(8405), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [377121] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10493), 1,
      anon_sym_COMMA,
    ACTIONS(10587), 1,
      anon_sym_GT,
    STATE(8419), 1,
      aux_sym_base_list_repeat1,
    STATE(8406), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [377168] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5655), 1,
      anon_sym_COMMA,
    ACTIONS(10587), 1,
      anon_sym_GT,
    STATE(8222), 1,
      aux_sym_type_argument_list_repeat1,
    STATE(8407), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [377215] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2095), 1,
      anon_sym_RBRACE,
    ACTIONS(10589), 1,
      anon_sym_COMMA,
    STATE(8529), 1,
      aux_sym_switch_expression_repeat1,
    STATE(8408), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [377262] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10442), 1,
      anon_sym_COMMA,
    ACTIONS(10591), 1,
      anon_sym_RPAREN,
    STATE(8540), 1,
      aux_sym_tuple_type_repeat1,
    STATE(8409), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [377309] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10489), 1,
      anon_sym_COMMA,
    ACTIONS(10593), 1,
      anon_sym_RPAREN,
    STATE(8425), 1,
      aux_sym_parenthesized_variable_designation_repeat1,
    STATE(8410), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [377356] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10595), 3,
      sym_interpolation_open_brace,
      sym_interpolation_string_content,
      anon_sym_DQUOTE,
    STATE(8411), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [377399] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10597), 3,
      sym_interpolation_open_brace,
      sym_interpolation_string_content,
      anon_sym_DQUOTE,
    STATE(8412), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [377442] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10518), 1,
      anon_sym_COMMA,
    ACTIONS(10599), 1,
      anon_sym_RBRACE,
    STATE(8537), 1,
      aux_sym_with_expression_repeat1,
    STATE(8413), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [377489] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5655), 1,
      anon_sym_COMMA,
    ACTIONS(10601), 1,
      anon_sym_GT,
    STATE(8222), 1,
      aux_sym_type_argument_list_repeat1,
    STATE(8414), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [377536] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10457), 1,
      anon_sym_COMMA,
    ACTIONS(10603), 1,
      anon_sym_RPAREN,
    STATE(8649), 1,
      aux_sym_argument_list_repeat1,
    STATE(8415), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [377583] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10605), 3,
      sym_interpolation_end_quote,
      sym_interpolation_open_brace,
      sym_interpolation_string_content,
    STATE(8416), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [377626] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9237), 1,
      anon_sym_RBRACK,
    ACTIONS(10607), 1,
      anon_sym_COMMA,
    STATE(8630), 1,
      aux_sym_global_attribute_repeat1,
    STATE(8417), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [377673] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10609), 3,
      sym_interpolation_end_quote,
      sym_interpolation_open_brace,
      sym_interpolation_string_content,
    STATE(8418), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [377716] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10493), 1,
      anon_sym_COMMA,
    ACTIONS(10611), 1,
      anon_sym_GT,
    STATE(8392), 1,
      aux_sym_base_list_repeat1,
    STATE(8419), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [377763] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8449), 1,
      anon_sym_DOT,
    ACTIONS(9706), 1,
      anon_sym_LBRACE,
    STATE(9248), 1,
      sym_declaration_list,
    STATE(8420), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [377810] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7994), 1,
      anon_sym_COMMA,
    ACTIONS(10613), 1,
      anon_sym_SEMI,
    STATE(8665), 1,
      aux_sym_for_statement_repeat1,
    STATE(8421), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [377857] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7986), 1,
      anon_sym_COMMA,
    ACTIONS(10615), 1,
      anon_sym_RPAREN,
    STATE(8251), 1,
      aux_sym_for_statement_repeat1,
    STATE(8422), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [377904] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10471), 1,
      anon_sym_COMMA,
    ACTIONS(10617), 1,
      anon_sym_RBRACK,
    STATE(8625), 1,
      aux_sym_argument_list_repeat1,
    STATE(8423), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [377951] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10619), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
    STATE(8424), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [377994] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10489), 1,
      anon_sym_COMMA,
    ACTIONS(10621), 1,
      anon_sym_RPAREN,
    STATE(8482), 1,
      aux_sym_parenthesized_variable_designation_repeat1,
    STATE(8425), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [378041] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7986), 1,
      anon_sym_COMMA,
    ACTIONS(10623), 1,
      anon_sym_RPAREN,
    STATE(8251), 1,
      aux_sym_for_statement_repeat1,
    STATE(8426), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [378088] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7986), 1,
      anon_sym_COMMA,
    ACTIONS(10625), 1,
      anon_sym_RPAREN,
    STATE(8251), 1,
      aux_sym_for_statement_repeat1,
    STATE(8427), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [378135] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9263), 1,
      anon_sym_RBRACK,
    ACTIONS(10627), 1,
      anon_sym_COMMA,
    STATE(8350), 1,
      aux_sym_global_attribute_repeat1,
    STATE(8428), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [378182] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9263), 1,
      anon_sym_RBRACK,
    ACTIONS(10627), 1,
      anon_sym_COMMA,
    STATE(8630), 1,
      aux_sym_global_attribute_repeat1,
    STATE(8429), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [378229] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7986), 1,
      anon_sym_COMMA,
    ACTIONS(10629), 1,
      anon_sym_RPAREN,
    STATE(8251), 1,
      aux_sym_for_statement_repeat1,
    STATE(8430), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [378276] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7986), 1,
      anon_sym_COMMA,
    ACTIONS(10631), 1,
      anon_sym_RPAREN,
    STATE(8251), 1,
      aux_sym_for_statement_repeat1,
    STATE(8431), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [378323] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10471), 1,
      anon_sym_COMMA,
    ACTIONS(10633), 1,
      anon_sym_RBRACK,
    STATE(8625), 1,
      aux_sym_argument_list_repeat1,
    STATE(8432), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [378370] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2607), 1,
      anon_sym_COMMA,
    ACTIONS(10635), 1,
      anon_sym_RBRACK,
    STATE(8497), 1,
      aux_sym_array_rank_specifier_repeat1,
    STATE(8433), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [378417] = 12,
    ACTIONS(9485), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9487), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9489), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9491), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9493), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9495), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9497), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9499), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9501), 1,
      sym_comment,
    ACTIONS(10637), 1,
      anon_sym_COMMA,
    ACTIONS(10640), 1,
      aux_sym_preproc_if_token2,
    STATE(8434), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_preproc_pragma_repeat1,
  [378462] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10471), 1,
      anon_sym_COMMA,
    ACTIONS(10642), 1,
      anon_sym_RBRACK,
    STATE(8625), 1,
      aux_sym_argument_list_repeat1,
    STATE(8435), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [378509] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10457), 1,
      anon_sym_COMMA,
    ACTIONS(10644), 1,
      anon_sym_RPAREN,
    STATE(8649), 1,
      aux_sym_argument_list_repeat1,
    STATE(8436), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [378556] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10646), 1,
      anon_sym_EQ,
    ACTIONS(10414), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(8437), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [378601] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10648), 1,
      anon_sym_COMMA,
    ACTIONS(10651), 1,
      anon_sym_RPAREN,
    STATE(8438), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_using_variable_declaration_repeat1,
  [378646] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7986), 1,
      anon_sym_COMMA,
    ACTIONS(10653), 1,
      anon_sym_RPAREN,
    STATE(8251), 1,
      aux_sym_for_statement_repeat1,
    STATE(8439), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [378693] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7813), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
    STATE(8440), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [378736] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9245), 1,
      anon_sym_RBRACK,
    ACTIONS(10655), 1,
      anon_sym_COMMA,
    STATE(8629), 1,
      aux_sym_global_attribute_repeat1,
    STATE(8441), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [378783] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9245), 1,
      anon_sym_RBRACK,
    ACTIONS(10655), 1,
      anon_sym_COMMA,
    STATE(8630), 1,
      aux_sym_global_attribute_repeat1,
    STATE(8442), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [378830] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10657), 1,
      anon_sym_COMMA,
    ACTIONS(10660), 1,
      anon_sym_RPAREN,
    STATE(8443), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_attribute_argument_list_repeat1,
  [378875] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7986), 1,
      anon_sym_COMMA,
    ACTIONS(10662), 1,
      anon_sym_RPAREN,
    STATE(8251), 1,
      aux_sym_for_statement_repeat1,
    STATE(8444), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [378922] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7986), 1,
      anon_sym_COMMA,
    ACTIONS(10664), 1,
      anon_sym_RPAREN,
    STATE(8251), 1,
      aux_sym_for_statement_repeat1,
    STATE(8445), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [378969] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7986), 1,
      anon_sym_COMMA,
    ACTIONS(10666), 1,
      anon_sym_RPAREN,
    STATE(8251), 1,
      aux_sym_for_statement_repeat1,
    STATE(8446), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [379016] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10668), 1,
      anon_sym_COMMA,
    ACTIONS(10670), 1,
      anon_sym_RPAREN,
    STATE(8443), 1,
      aux_sym_attribute_argument_list_repeat1,
    STATE(8447), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [379063] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10672), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_GT,
    STATE(8448), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [379106] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2607), 1,
      anon_sym_COMMA,
    ACTIONS(10674), 1,
      anon_sym_RBRACK,
    STATE(8497), 1,
      aux_sym_array_rank_specifier_repeat1,
    STATE(8449), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [379153] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9228), 1,
      anon_sym_RBRACK,
    ACTIONS(10676), 1,
      anon_sym_COMMA,
    STATE(8630), 1,
      aux_sym_global_attribute_repeat1,
    STATE(8450), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [379200] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5655), 1,
      anon_sym_COMMA,
    ACTIONS(10678), 1,
      anon_sym_RBRACK,
    STATE(8222), 1,
      aux_sym_type_argument_list_repeat1,
    STATE(8451), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [379247] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10442), 1,
      anon_sym_COMMA,
    ACTIONS(10680), 1,
      anon_sym_RPAREN,
    STATE(8540), 1,
      aux_sym_tuple_type_repeat1,
    STATE(8452), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [379294] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7994), 1,
      anon_sym_COMMA,
    ACTIONS(10682), 1,
      anon_sym_SEMI,
    STATE(8665), 1,
      aux_sym_for_statement_repeat1,
    STATE(8453), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [379341] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10457), 1,
      anon_sym_COMMA,
    ACTIONS(10684), 1,
      anon_sym_RPAREN,
    STATE(8522), 1,
      aux_sym_argument_list_repeat1,
    STATE(8454), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [379388] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10686), 1,
      anon_sym_COMMA,
    ACTIONS(10688), 1,
      anon_sym_RPAREN,
    STATE(8438), 1,
      aux_sym_using_variable_declaration_repeat1,
    STATE(8455), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [379435] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7343), 1,
      anon_sym_COLON,
    ACTIONS(10690), 1,
      sym_interpolation_close_brace,
    STATE(9716), 1,
      sym_interpolation_format_clause,
    STATE(8456), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [379482] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10518), 1,
      anon_sym_COMMA,
    ACTIONS(10692), 1,
      anon_sym_RBRACE,
    STATE(8537), 1,
      aux_sym_with_expression_repeat1,
    STATE(8457), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [379529] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2137), 1,
      anon_sym_RBRACE,
    ACTIONS(10694), 1,
      anon_sym_COMMA,
    STATE(8529), 1,
      aux_sym_switch_expression_repeat1,
    STATE(8458), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [379576] = 13,
    ACTIONS(9485), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9487), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9489), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9491), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9493), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9495), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9497), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9499), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9501), 1,
      sym_comment,
    ACTIONS(10696), 1,
      anon_sym_COMMA,
    ACTIONS(10698), 1,
      aux_sym_preproc_if_token2,
    STATE(8434), 1,
      aux_sym_preproc_pragma_repeat1,
    STATE(8459), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [379623] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5655), 1,
      anon_sym_COMMA,
    ACTIONS(10700), 1,
      anon_sym_RBRACK,
    STATE(8513), 1,
      aux_sym_type_argument_list_repeat1,
    STATE(8460), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [379670] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10493), 1,
      anon_sym_COMMA,
    ACTIONS(10702), 1,
      anon_sym_GT,
    STATE(8392), 1,
      aux_sym_base_list_repeat1,
    STATE(8461), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [379717] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10518), 1,
      anon_sym_COMMA,
    ACTIONS(10704), 1,
      anon_sym_RBRACE,
    STATE(8386), 1,
      aux_sym_with_expression_repeat1,
    STATE(8462), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [379764] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5980), 1,
      anon_sym_LBRACE,
    ACTIONS(10706), 1,
      anon_sym_LPAREN,
    STATE(8866), 1,
      sym_block,
    STATE(8463), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [379811] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10471), 1,
      anon_sym_COMMA,
    ACTIONS(10708), 1,
      anon_sym_RBRACK,
    STATE(8423), 1,
      aux_sym_argument_list_repeat1,
    STATE(8464), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [379858] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10710), 1,
      anon_sym_COMMA,
    ACTIONS(10712), 1,
      anon_sym_RBRACK,
    STATE(8429), 1,
      aux_sym_global_attribute_repeat1,
    STATE(8465), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [379905] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7968), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
    STATE(8466), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [379948] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10493), 1,
      anon_sym_COMMA,
    ACTIONS(10714), 1,
      anon_sym_GT,
    STATE(8392), 1,
      aux_sym_base_list_repeat1,
    STATE(8467), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [379995] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10716), 1,
      anon_sym_COMMA,
    ACTIONS(10718), 1,
      anon_sym_RBRACE,
    STATE(8517), 1,
      aux_sym_anonymous_object_creation_expression_repeat1,
    STATE(8468), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [380042] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10518), 1,
      anon_sym_COMMA,
    ACTIONS(10720), 1,
      anon_sym_RBRACE,
    STATE(8457), 1,
      aux_sym_with_expression_repeat1,
    STATE(8469), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [380089] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2893), 1,
      anon_sym_RBRACE,
    ACTIONS(10722), 1,
      anon_sym_COMMA,
    STATE(8251), 1,
      aux_sym_for_statement_repeat1,
    STATE(8470), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [380136] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10724), 1,
      anon_sym_COMMA,
    ACTIONS(10726), 1,
      anon_sym_RBRACE,
    STATE(8458), 1,
      aux_sym_switch_expression_repeat1,
    STATE(8471), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [380183] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2607), 1,
      anon_sym_COMMA,
    ACTIONS(10728), 1,
      anon_sym_RBRACK,
    STATE(8497), 1,
      aux_sym_array_rank_specifier_repeat1,
    STATE(8472), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [380230] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7986), 1,
      anon_sym_COMMA,
    ACTIONS(10730), 1,
      anon_sym_RPAREN,
    STATE(8251), 1,
      aux_sym_for_statement_repeat1,
    STATE(8473), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [380277] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2669), 1,
      anon_sym_RBRACE,
    ACTIONS(10732), 1,
      anon_sym_COMMA,
    STATE(8373), 1,
      aux_sym_anonymous_object_creation_expression_repeat1,
    STATE(8474), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [380324] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5655), 1,
      anon_sym_COMMA,
    ACTIONS(10734), 1,
      anon_sym_RBRACK,
    STATE(8492), 1,
      aux_sym_type_argument_list_repeat1,
    STATE(8475), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [380371] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10493), 1,
      anon_sym_COMMA,
    ACTIONS(10736), 1,
      anon_sym_GT,
    STATE(8511), 1,
      aux_sym_base_list_repeat1,
    STATE(8476), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [380418] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10457), 1,
      anon_sym_COMMA,
    ACTIONS(10738), 1,
      anon_sym_RPAREN,
    STATE(8554), 1,
      aux_sym_argument_list_repeat1,
    STATE(8477), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [380465] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10740), 1,
      anon_sym_COMMA,
    ACTIONS(10743), 1,
      anon_sym_GT,
    STATE(8478), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_type_parameter_list_repeat1,
  [380510] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5655), 1,
      anon_sym_COMMA,
    ACTIONS(10745), 1,
      anon_sym_GT,
    STATE(8222), 1,
      aux_sym_type_argument_list_repeat1,
    STATE(8479), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [380557] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5655), 1,
      anon_sym_COMMA,
    ACTIONS(10736), 1,
      anon_sym_GT,
    STATE(8222), 1,
      aux_sym_type_argument_list_repeat1,
    STATE(8480), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [380604] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10493), 1,
      anon_sym_COMMA,
    ACTIONS(10745), 1,
      anon_sym_GT,
    STATE(8467), 1,
      aux_sym_base_list_repeat1,
    STATE(8481), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [380651] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10747), 1,
      anon_sym_COMMA,
    ACTIONS(10750), 1,
      anon_sym_RPAREN,
    STATE(8482), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_parenthesized_variable_designation_repeat1,
  [380696] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2607), 1,
      anon_sym_COMMA,
    ACTIONS(8151), 1,
      anon_sym_RBRACK,
    STATE(8497), 1,
      aux_sym_array_rank_specifier_repeat1,
    STATE(8483), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [380743] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10752), 1,
      anon_sym_COMMA,
    ACTIONS(10754), 1,
      anon_sym_RBRACE,
    STATE(8555), 1,
      aux_sym_anonymous_object_creation_expression_repeat1,
    STATE(8484), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [380790] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10756), 1,
      anon_sym_COMMA,
    ACTIONS(10758), 1,
      anon_sym_RBRACE,
    STATE(8474), 1,
      aux_sym_anonymous_object_creation_expression_repeat1,
    STATE(8485), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [380837] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2881), 1,
      anon_sym_RBRACE,
    ACTIONS(10760), 1,
      anon_sym_COMMA,
    STATE(8251), 1,
      aux_sym_for_statement_repeat1,
    STATE(8486), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [380884] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10762), 1,
      anon_sym_COMMA,
    ACTIONS(10764), 1,
      anon_sym_RBRACE,
    STATE(8364), 1,
      aux_sym_positional_pattern_clause_repeat1,
    STATE(8487), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [380931] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10442), 1,
      anon_sym_COMMA,
    ACTIONS(10766), 1,
      anon_sym_RPAREN,
    STATE(8540), 1,
      aux_sym_tuple_type_repeat1,
    STATE(8488), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [380978] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10471), 1,
      anon_sym_COMMA,
    ACTIONS(10768), 1,
      anon_sym_RBRACK,
    STATE(8625), 1,
      aux_sym_argument_list_repeat1,
    STATE(8489), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [381025] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5655), 1,
      anon_sym_COMMA,
    ACTIONS(10770), 1,
      anon_sym_RBRACK,
    STATE(8451), 1,
      aux_sym_type_argument_list_repeat1,
    STATE(8490), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [381072] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10772), 1,
      anon_sym_COMMA,
    ACTIONS(10774), 1,
      anon_sym_RPAREN,
    STATE(8655), 1,
      aux_sym_variable_declaration_repeat1,
    STATE(8491), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [381119] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5655), 1,
      anon_sym_COMMA,
    ACTIONS(10776), 1,
      anon_sym_RBRACK,
    STATE(8222), 1,
      aux_sym_type_argument_list_repeat1,
    STATE(8492), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [381166] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7986), 1,
      anon_sym_COMMA,
    ACTIONS(10778), 1,
      anon_sym_RPAREN,
    STATE(8251), 1,
      aux_sym_for_statement_repeat1,
    STATE(8493), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [381213] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10780), 1,
      anon_sym_COMMA,
    ACTIONS(10782), 1,
      anon_sym_RBRACE,
    STATE(8356), 1,
      aux_sym_switch_expression_repeat1,
    STATE(8494), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [381260] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7994), 1,
      anon_sym_COMMA,
    ACTIONS(10784), 1,
      anon_sym_SEMI,
    STATE(8665), 1,
      aux_sym_for_statement_repeat1,
    STATE(8495), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [381307] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10370), 3,
      sym_interpolation_end_quote,
      sym_interpolation_open_brace,
      sym_interpolation_string_content,
    STATE(8496), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [381350] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8441), 1,
      anon_sym_RBRACK,
    ACTIONS(10786), 1,
      anon_sym_COMMA,
    STATE(8497), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_array_rank_specifier_repeat1,
  [381395] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2607), 1,
      anon_sym_COMMA,
    ACTIONS(10789), 1,
      anon_sym_RBRACK,
    STATE(8497), 1,
      aux_sym_array_rank_specifier_repeat1,
    STATE(8498), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [381442] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6104), 1,
      anon_sym_LBRACE,
    ACTIONS(10706), 1,
      anon_sym_LPAREN,
    STATE(2676), 1,
      sym_block,
    STATE(8499), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [381489] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5709), 1,
      anon_sym_LBRACE,
    ACTIONS(10706), 1,
      anon_sym_LPAREN,
    STATE(2214), 1,
      sym_block,
    STATE(8500), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [381536] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7986), 1,
      anon_sym_COMMA,
    ACTIONS(10791), 1,
      anon_sym_RPAREN,
    STATE(8251), 1,
      aux_sym_for_statement_repeat1,
    STATE(8501), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [381583] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10793), 1,
      anon_sym_SEMI,
    ACTIONS(10795), 1,
      anon_sym_COMMA,
    STATE(8502), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_variable_declaration_repeat1,
  [381628] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10793), 3,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(8503), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [381671] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10798), 1,
      anon_sym_COMMA,
    ACTIONS(10800), 1,
      anon_sym_RPAREN,
    STATE(8347), 1,
      aux_sym_tuple_pattern_repeat1,
    STATE(8504), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [381718] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10798), 1,
      anon_sym_COMMA,
    ACTIONS(10802), 1,
      anon_sym_RPAREN,
    STATE(8347), 1,
      aux_sym_tuple_pattern_repeat1,
    STATE(8505), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [381765] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10804), 1,
      anon_sym_COMMA,
    ACTIONS(10807), 1,
      anon_sym_RBRACE,
    STATE(8506), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_enum_member_declaration_list_repeat1,
  [381810] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2607), 1,
      anon_sym_COMMA,
    ACTIONS(8183), 1,
      anon_sym_RBRACK,
    STATE(8497), 1,
      aux_sym_array_rank_specifier_repeat1,
    STATE(8507), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [381857] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10514), 1,
      anon_sym_COMMA,
    ACTIONS(10809), 1,
      anon_sym_RBRACK,
    STATE(8580), 1,
      aux_sym_calling_convention_repeat1,
    STATE(8508), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [381904] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10493), 1,
      anon_sym_COMMA,
    ACTIONS(10811), 1,
      anon_sym_GT,
    STATE(8512), 1,
      aux_sym_base_list_repeat1,
    STATE(8509), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [381951] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10471), 1,
      anon_sym_COMMA,
    ACTIONS(10813), 1,
      anon_sym_RBRACK,
    STATE(8489), 1,
      aux_sym_argument_list_repeat1,
    STATE(8510), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [381998] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10493), 1,
      anon_sym_COMMA,
    ACTIONS(10815), 1,
      anon_sym_GT,
    STATE(8392), 1,
      aux_sym_base_list_repeat1,
    STATE(8511), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [382045] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10493), 1,
      anon_sym_COMMA,
    ACTIONS(10817), 1,
      anon_sym_GT,
    STATE(8392), 1,
      aux_sym_base_list_repeat1,
    STATE(8512), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [382092] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5655), 1,
      anon_sym_COMMA,
    ACTIONS(10819), 1,
      anon_sym_RBRACK,
    STATE(8222), 1,
      aux_sym_type_argument_list_repeat1,
    STATE(8513), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [382139] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10518), 1,
      anon_sym_COMMA,
    ACTIONS(10821), 1,
      anon_sym_RBRACE,
    STATE(8537), 1,
      aux_sym_with_expression_repeat1,
    STATE(8514), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [382186] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10823), 3,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
    STATE(8515), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [382229] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7994), 1,
      anon_sym_COMMA,
    ACTIONS(10825), 1,
      anon_sym_SEMI,
    STATE(8665), 1,
      aux_sym_for_statement_repeat1,
    STATE(8516), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [382276] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2731), 1,
      anon_sym_RBRACE,
    ACTIONS(10827), 1,
      anon_sym_COMMA,
    STATE(8373), 1,
      aux_sym_anonymous_object_creation_expression_repeat1,
    STATE(8517), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [382323] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4081), 1,
      anon_sym_EQ_GT,
    ACTIONS(10323), 1,
      anon_sym_RPAREN,
    ACTIONS(10829), 1,
      anon_sym_COMMA,
    STATE(8518), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [382370] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10493), 1,
      anon_sym_COMMA,
    ACTIONS(10601), 1,
      anon_sym_GT,
    STATE(8569), 1,
      aux_sym_base_list_repeat1,
    STATE(8519), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [382417] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7986), 1,
      anon_sym_COMMA,
    ACTIONS(10832), 1,
      anon_sym_RPAREN,
    STATE(8251), 1,
      aux_sym_for_statement_repeat1,
    STATE(8520), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [382464] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10493), 1,
      anon_sym_COMMA,
    ACTIONS(10834), 1,
      anon_sym_GT,
    STATE(8392), 1,
      aux_sym_base_list_repeat1,
    STATE(8521), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [382511] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10457), 1,
      anon_sym_COMMA,
    ACTIONS(10836), 1,
      anon_sym_RPAREN,
    STATE(8649), 1,
      aux_sym_argument_list_repeat1,
    STATE(8522), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [382558] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9679), 1,
      anon_sym_LBRACE,
    ACTIONS(10838), 1,
      anon_sym_SEMI,
    STATE(3296), 1,
      sym_accessor_list,
    STATE(8523), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [382605] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10489), 1,
      anon_sym_COMMA,
    ACTIONS(10840), 1,
      anon_sym_RPAREN,
    STATE(8402), 1,
      aux_sym_parenthesized_variable_designation_repeat1,
    STATE(8524), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [382652] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2135), 1,
      anon_sym_RBRACE,
    ACTIONS(10842), 1,
      anon_sym_COMMA,
    STATE(8640), 1,
      aux_sym_positional_pattern_clause_repeat1,
    STATE(8525), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [382699] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10483), 1,
      anon_sym_COMMA,
    ACTIONS(10844), 1,
      anon_sym_RPAREN,
    STATE(8534), 1,
      aux_sym_positional_pattern_clause_repeat1,
    STATE(8526), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [382746] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10846), 1,
      anon_sym_COMMA,
    ACTIONS(10848), 1,
      anon_sym_RBRACK,
    STATE(8577), 1,
      aux_sym_global_attribute_repeat1,
    STATE(8527), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [382793] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9226), 1,
      anon_sym_RBRACK,
    ACTIONS(10850), 1,
      anon_sym_COMMA,
    STATE(8630), 1,
      aux_sym_global_attribute_repeat1,
    STATE(8528), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [382840] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10852), 1,
      anon_sym_COMMA,
    ACTIONS(10855), 1,
      anon_sym_RBRACE,
    STATE(8529), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_switch_expression_repeat1,
  [382885] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10493), 1,
      anon_sym_COMMA,
    ACTIONS(10857), 1,
      anon_sym_GT,
    STATE(8521), 1,
      aux_sym_base_list_repeat1,
    STATE(8530), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [382932] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(1903), 1,
      anon_sym_RBRACK,
    ACTIONS(10859), 1,
      anon_sym_COMMA,
    STATE(8531), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_list_pattern_repeat1,
  [382977] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10862), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    STATE(8532), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [383020] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5655), 1,
      anon_sym_COMMA,
    ACTIONS(10811), 1,
      anon_sym_GT,
    STATE(8222), 1,
      aux_sym_type_argument_list_repeat1,
    STATE(8533), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [383067] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10862), 1,
      anon_sym_RPAREN,
    ACTIONS(10864), 1,
      anon_sym_COMMA,
    STATE(8534), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_positional_pattern_clause_repeat1,
  [383112] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9237), 1,
      anon_sym_RBRACK,
    ACTIONS(10607), 1,
      anon_sym_COMMA,
    STATE(8528), 1,
      aux_sym_global_attribute_repeat1,
    STATE(8535), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [383159] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10798), 1,
      anon_sym_COMMA,
    ACTIONS(10867), 1,
      anon_sym_RPAREN,
    STATE(8505), 1,
      aux_sym_tuple_pattern_repeat1,
    STATE(8536), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [383206] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10869), 1,
      anon_sym_COMMA,
    ACTIONS(10872), 1,
      anon_sym_RBRACE,
    STATE(8537), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_with_expression_repeat1,
  [383251] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10471), 1,
      anon_sym_COMMA,
    ACTIONS(10874), 1,
      anon_sym_RBRACK,
    STATE(8581), 1,
      aux_sym_argument_list_repeat1,
    STATE(8538), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [383298] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10489), 1,
      anon_sym_COMMA,
    ACTIONS(10876), 1,
      anon_sym_RPAREN,
    STATE(8482), 1,
      aux_sym_parenthesized_variable_designation_repeat1,
    STATE(8539), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [383345] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10878), 1,
      anon_sym_COMMA,
    ACTIONS(10881), 1,
      anon_sym_RPAREN,
    STATE(8540), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_tuple_type_repeat1,
  [383390] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10885), 1,
      anon_sym_EQ,
    ACTIONS(10883), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(8541), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [383435] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7986), 1,
      anon_sym_COMMA,
    ACTIONS(10887), 1,
      anon_sym_RPAREN,
    STATE(8251), 1,
      aux_sym_for_statement_repeat1,
    STATE(8542), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [383482] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10889), 1,
      anon_sym_SEMI,
    ACTIONS(10891), 1,
      anon_sym_COMMA,
    STATE(8502), 1,
      aux_sym_variable_declaration_repeat1,
    STATE(8543), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [383529] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2273), 1,
      anon_sym_RBRACK,
    ACTIONS(10893), 1,
      anon_sym_COMMA,
    STATE(8531), 1,
      aux_sym_list_pattern_repeat1,
    STATE(8544), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [383576] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10897), 1,
      anon_sym_EQ,
    ACTIONS(10895), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(8545), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [383621] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2171), 1,
      anon_sym_RBRACE,
    ACTIONS(10899), 1,
      anon_sym_COMMA,
    STATE(8529), 1,
      aux_sym_switch_expression_repeat1,
    STATE(8546), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [383668] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2607), 1,
      anon_sym_COMMA,
    ACTIONS(8203), 1,
      anon_sym_RBRACK,
    STATE(8497), 1,
      aux_sym_array_rank_specifier_repeat1,
    STATE(8547), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [383715] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5655), 1,
      anon_sym_COMMA,
    ACTIONS(10857), 1,
      anon_sym_GT,
    STATE(8222), 1,
      aux_sym_type_argument_list_repeat1,
    STATE(8548), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [383762] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2607), 1,
      anon_sym_COMMA,
    ACTIONS(10901), 1,
      anon_sym_RBRACK,
    STATE(8497), 1,
      aux_sym_array_rank_specifier_repeat1,
    STATE(8549), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [383809] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5655), 1,
      anon_sym_COMMA,
    ACTIONS(10903), 1,
      anon_sym_GT,
    STATE(8222), 1,
      aux_sym_type_argument_list_repeat1,
    STATE(8550), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [383856] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10292), 3,
      sym_interpolation_end_quote,
      sym_interpolation_open_brace,
      sym_interpolation_string_content,
    STATE(8551), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [383899] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10493), 1,
      anon_sym_COMMA,
    ACTIONS(10905), 1,
      anon_sym_GT,
    STATE(8392), 1,
      aux_sym_base_list_repeat1,
    STATE(8552), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [383946] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10022), 1,
      anon_sym_RPAREN,
    ACTIONS(10342), 1,
      anon_sym_EQ,
    ACTIONS(10907), 1,
      anon_sym_COMMA,
    STATE(8553), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [383993] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10457), 1,
      anon_sym_COMMA,
    ACTIONS(10910), 1,
      anon_sym_RPAREN,
    STATE(8649), 1,
      aux_sym_argument_list_repeat1,
    STATE(8554), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [384040] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2661), 1,
      anon_sym_RBRACE,
    ACTIONS(10912), 1,
      anon_sym_COMMA,
    STATE(8373), 1,
      aux_sym_anonymous_object_creation_expression_repeat1,
    STATE(8555), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [384087] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10493), 1,
      anon_sym_COMMA,
    ACTIONS(10914), 1,
      anon_sym_GT,
    STATE(8558), 1,
      aux_sym_base_list_repeat1,
    STATE(8556), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [384134] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5655), 1,
      anon_sym_COMMA,
    ACTIONS(10914), 1,
      anon_sym_GT,
    STATE(8222), 1,
      aux_sym_type_argument_list_repeat1,
    STATE(8557), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [384181] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10493), 1,
      anon_sym_COMMA,
    ACTIONS(10916), 1,
      anon_sym_GT,
    STATE(8392), 1,
      aux_sym_base_list_repeat1,
    STATE(8558), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [384228] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10346), 3,
      sym_interpolation_end_quote,
      sym_interpolation_open_brace,
      sym_interpolation_string_content,
    STATE(8559), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [384271] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7986), 1,
      anon_sym_COMMA,
    ACTIONS(10918), 1,
      anon_sym_RPAREN,
    STATE(8251), 1,
      aux_sym_for_statement_repeat1,
    STATE(8560), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [384318] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5655), 1,
      anon_sym_COMMA,
    ACTIONS(10920), 1,
      anon_sym_RBRACK,
    STATE(8573), 1,
      aux_sym_type_argument_list_repeat1,
    STATE(8561), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [384365] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2607), 1,
      anon_sym_COMMA,
    ACTIONS(10922), 1,
      anon_sym_RBRACK,
    STATE(8497), 1,
      aux_sym_array_rank_specifier_repeat1,
    STATE(8562), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [384412] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10924), 1,
      anon_sym_COMMA,
    ACTIONS(10926), 1,
      anon_sym_RBRACE,
    STATE(8604), 1,
      aux_sym_switch_expression_repeat1,
    STATE(8563), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [384459] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10493), 1,
      anon_sym_COMMA,
    ACTIONS(10928), 1,
      anon_sym_GT,
    STATE(8570), 1,
      aux_sym_base_list_repeat1,
    STATE(8564), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [384506] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5655), 1,
      anon_sym_COMMA,
    ACTIONS(10928), 1,
      anon_sym_GT,
    STATE(8222), 1,
      aux_sym_type_argument_list_repeat1,
    STATE(8565), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [384553] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10518), 1,
      anon_sym_COMMA,
    ACTIONS(10930), 1,
      anon_sym_RBRACE,
    STATE(8609), 1,
      aux_sym_with_expression_repeat1,
    STATE(8566), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [384600] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10932), 1,
      anon_sym_EQ,
    ACTIONS(10430), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(8567), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [384645] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7986), 1,
      anon_sym_COMMA,
    ACTIONS(10934), 1,
      anon_sym_RPAREN,
    STATE(8251), 1,
      aux_sym_for_statement_repeat1,
    STATE(8568), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [384692] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10493), 1,
      anon_sym_COMMA,
    ACTIONS(10936), 1,
      anon_sym_GT,
    STATE(8392), 1,
      aux_sym_base_list_repeat1,
    STATE(8569), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [384739] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10493), 1,
      anon_sym_COMMA,
    ACTIONS(10938), 1,
      anon_sym_GT,
    STATE(8392), 1,
      aux_sym_base_list_repeat1,
    STATE(8570), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [384786] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10940), 1,
      anon_sym_COMMA,
    ACTIONS(10942), 1,
      anon_sym_RBRACE,
    STATE(8348), 1,
      aux_sym_enum_member_declaration_list_repeat1,
    STATE(8571), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [384833] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7250), 1,
      anon_sym_LBRACK,
    ACTIONS(7252), 1,
      anon_sym_STAR,
    ACTIONS(7254), 1,
      anon_sym_QMARK,
    STATE(8572), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [384880] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5655), 1,
      anon_sym_COMMA,
    ACTIONS(10944), 1,
      anon_sym_RBRACK,
    STATE(8222), 1,
      aux_sym_type_argument_list_repeat1,
    STATE(8573), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [384927] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7986), 1,
      anon_sym_COMMA,
    ACTIONS(10946), 1,
      anon_sym_RPAREN,
    STATE(8251), 1,
      aux_sym_for_statement_repeat1,
    STATE(8574), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [384974] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7986), 1,
      anon_sym_COMMA,
    ACTIONS(10948), 1,
      anon_sym_RPAREN,
    STATE(8251), 1,
      aux_sym_for_statement_repeat1,
    STATE(8575), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [385021] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10493), 1,
      anon_sym_COMMA,
    ACTIONS(10903), 1,
      anon_sym_GT,
    STATE(8552), 1,
      aux_sym_base_list_repeat1,
    STATE(8576), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [385068] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9249), 1,
      anon_sym_RBRACK,
    ACTIONS(10950), 1,
      anon_sym_COMMA,
    STATE(8630), 1,
      aux_sym_global_attribute_repeat1,
    STATE(8577), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [385115] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9249), 1,
      anon_sym_RBRACK,
    ACTIONS(10950), 1,
      anon_sym_COMMA,
    STATE(8648), 1,
      aux_sym_global_attribute_repeat1,
    STATE(8578), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [385162] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9220), 1,
      anon_sym_RBRACK,
    ACTIONS(10952), 1,
      anon_sym_COMMA,
    STATE(8630), 1,
      aux_sym_global_attribute_repeat1,
    STATE(8579), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [385209] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10954), 1,
      anon_sym_COMMA,
    ACTIONS(10957), 1,
      anon_sym_RBRACK,
    STATE(8580), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_calling_convention_repeat1,
  [385254] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10471), 1,
      anon_sym_COMMA,
    ACTIONS(10959), 1,
      anon_sym_RBRACK,
    STATE(8625), 1,
      aux_sym_argument_list_repeat1,
    STATE(8581), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [385301] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7396), 1,
      anon_sym_DOT,
    ACTIONS(4428), 2,
      anon_sym_COMMA,
      anon_sym_GT,
    STATE(8582), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [385346] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10457), 1,
      anon_sym_COMMA,
    ACTIONS(10961), 1,
      anon_sym_RPAREN,
    STATE(8649), 1,
      aux_sym_argument_list_repeat1,
    STATE(8583), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [385393] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10489), 1,
      anon_sym_COMMA,
    ACTIONS(10963), 1,
      anon_sym_RPAREN,
    STATE(8482), 1,
      aux_sym_parenthesized_variable_designation_repeat1,
    STATE(8584), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [385440] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7343), 1,
      anon_sym_COLON,
    ACTIONS(10965), 1,
      sym_interpolation_close_brace,
    STATE(9462), 1,
      sym_interpolation_format_clause,
    STATE(8585), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [385487] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10442), 1,
      anon_sym_COMMA,
    ACTIONS(10967), 1,
      anon_sym_RPAREN,
    STATE(8540), 1,
      aux_sym_tuple_type_repeat1,
    STATE(8586), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [385534] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10493), 1,
      anon_sym_COMMA,
    ACTIONS(10969), 1,
      anon_sym_GT,
    STATE(8392), 1,
      aux_sym_base_list_repeat1,
    STATE(8587), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [385581] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10467), 1,
      anon_sym_COMMA,
    ACTIONS(10971), 1,
      anon_sym_GT,
    STATE(8357), 1,
      aux_sym_type_parameter_list_repeat1,
    STATE(8588), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [385628] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2835), 1,
      anon_sym_RBRACE,
    ACTIONS(10973), 1,
      anon_sym_COMMA,
    STATE(8251), 1,
      aux_sym_for_statement_repeat1,
    STATE(8589), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [385675] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10493), 1,
      anon_sym_COMMA,
    ACTIONS(10975), 1,
      anon_sym_GT,
    STATE(8461), 1,
      aux_sym_base_list_repeat1,
    STATE(8590), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [385722] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5655), 1,
      anon_sym_COMMA,
    ACTIONS(10975), 1,
      anon_sym_GT,
    STATE(8222), 1,
      aux_sym_type_argument_list_repeat1,
    STATE(8591), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [385769] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10457), 1,
      anon_sym_COMMA,
    ACTIONS(10977), 1,
      anon_sym_RPAREN,
    STATE(8658), 1,
      aux_sym_argument_list_repeat1,
    STATE(8592), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [385816] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10518), 1,
      anon_sym_COMMA,
    ACTIONS(10979), 1,
      anon_sym_RBRACE,
    STATE(8537), 1,
      aux_sym_with_expression_repeat1,
    STATE(8593), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [385863] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10489), 1,
      anon_sym_COMMA,
    ACTIONS(10981), 1,
      anon_sym_RPAREN,
    STATE(8584), 1,
      aux_sym_parenthesized_variable_designation_repeat1,
    STATE(8594), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [385910] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2275), 1,
      anon_sym_RBRACK,
    ACTIONS(10983), 1,
      anon_sym_COMMA,
    STATE(8531), 1,
      aux_sym_list_pattern_repeat1,
    STATE(8595), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [385957] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2133), 1,
      anon_sym_RBRACE,
    ACTIONS(10985), 1,
      anon_sym_COMMA,
    STATE(8529), 1,
      aux_sym_switch_expression_repeat1,
    STATE(8596), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [386004] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5707), 1,
      anon_sym_LBRACE,
    ACTIONS(10706), 1,
      anon_sym_LPAREN,
    STATE(2472), 1,
      sym_block,
    STATE(8597), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [386051] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10987), 1,
      anon_sym_COMMA,
    ACTIONS(10989), 1,
      anon_sym_RBRACE,
    STATE(8661), 1,
      aux_sym_anonymous_object_creation_expression_repeat1,
    STATE(8598), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [386098] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10493), 1,
      anon_sym_COMMA,
    ACTIONS(10991), 1,
      anon_sym_GT,
    STATE(8392), 1,
      aux_sym_base_list_repeat1,
    STATE(8599), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [386145] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10518), 1,
      anon_sym_COMMA,
    ACTIONS(10993), 1,
      anon_sym_RBRACE,
    STATE(8593), 1,
      aux_sym_with_expression_repeat1,
    STATE(8600), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [386192] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7986), 1,
      anon_sym_COMMA,
    ACTIONS(10995), 1,
      anon_sym_RPAREN,
    STATE(8251), 1,
      aux_sym_for_statement_repeat1,
    STATE(8601), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [386239] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7986), 1,
      anon_sym_COMMA,
    ACTIONS(10997), 1,
      anon_sym_RPAREN,
    STATE(8251), 1,
      aux_sym_for_statement_repeat1,
    STATE(8602), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [386286] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10518), 1,
      anon_sym_COMMA,
    ACTIONS(10999), 1,
      anon_sym_RBRACE,
    STATE(8514), 1,
      aux_sym_with_expression_repeat1,
    STATE(8603), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [386333] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2087), 1,
      anon_sym_RBRACE,
    ACTIONS(11001), 1,
      anon_sym_COMMA,
    STATE(8529), 1,
      aux_sym_switch_expression_repeat1,
    STATE(8604), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [386380] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2277), 1,
      anon_sym_RBRACK,
    ACTIONS(11003), 1,
      anon_sym_COMMA,
    STATE(8531), 1,
      aux_sym_list_pattern_repeat1,
    STATE(8605), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [386427] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11005), 1,
      anon_sym_COMMA,
    ACTIONS(11007), 1,
      anon_sym_RBRACE,
    STATE(8596), 1,
      aux_sym_switch_expression_repeat1,
    STATE(8606), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [386474] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10489), 1,
      anon_sym_COMMA,
    ACTIONS(11009), 1,
      anon_sym_RPAREN,
    STATE(8644), 1,
      aux_sym_parenthesized_variable_designation_repeat1,
    STATE(8607), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [386521] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10774), 1,
      anon_sym_SEMI,
    ACTIONS(10891), 1,
      anon_sym_COMMA,
    STATE(8543), 1,
      aux_sym_variable_declaration_repeat1,
    STATE(8608), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [386568] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10518), 1,
      anon_sym_COMMA,
    ACTIONS(11011), 1,
      anon_sym_RBRACE,
    STATE(8537), 1,
      aux_sym_with_expression_repeat1,
    STATE(8609), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [386615] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2607), 1,
      anon_sym_COMMA,
    ACTIONS(7862), 1,
      anon_sym_RBRACK,
    STATE(8497), 1,
      aux_sym_array_rank_specifier_repeat1,
    STATE(8610), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [386662] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10793), 1,
      anon_sym_RPAREN,
    ACTIONS(11013), 1,
      anon_sym_COMMA,
    STATE(8611), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_variable_declaration_repeat1,
  [386707] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11016), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
    STATE(8612), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [386750] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11018), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
    STATE(8613), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [386793] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11020), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
    STATE(8614), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [386836] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8237), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
    STATE(8615), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [386879] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2705), 1,
      anon_sym_RBRACE,
    ACTIONS(11022), 1,
      anon_sym_COMMA,
    STATE(8373), 1,
      aux_sym_anonymous_object_creation_expression_repeat1,
    STATE(8616), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [386926] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10457), 1,
      anon_sym_COMMA,
    ACTIONS(11024), 1,
      anon_sym_RPAREN,
    STATE(8649), 1,
      aux_sym_argument_list_repeat1,
    STATE(8617), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [386973] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9222), 1,
      anon_sym_RBRACK,
    ACTIONS(11026), 1,
      anon_sym_COMMA,
    STATE(8630), 1,
      aux_sym_global_attribute_repeat1,
    STATE(8618), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [387020] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5655), 1,
      anon_sym_COMMA,
    ACTIONS(11028), 1,
      anon_sym_GT,
    STATE(8222), 1,
      aux_sym_type_argument_list_repeat1,
    STATE(8619), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [387067] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10493), 1,
      anon_sym_COMMA,
    ACTIONS(11028), 1,
      anon_sym_GT,
    STATE(8599), 1,
      aux_sym_base_list_repeat1,
    STATE(8620), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [387114] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7986), 1,
      anon_sym_COMMA,
    ACTIONS(11030), 1,
      anon_sym_RPAREN,
    STATE(8251), 1,
      aux_sym_for_statement_repeat1,
    STATE(8621), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [387161] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9679), 1,
      anon_sym_LBRACE,
    ACTIONS(11032), 1,
      anon_sym_SEMI,
    STATE(3287), 1,
      sym_accessor_list,
    STATE(8622), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [387208] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10493), 1,
      anon_sym_COMMA,
    ACTIONS(11034), 1,
      anon_sym_GT,
    STATE(8587), 1,
      aux_sym_base_list_repeat1,
    STATE(8623), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [387255] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10538), 1,
      anon_sym_COMMA,
    ACTIONS(11036), 1,
      anon_sym_RBRACK,
    STATE(8387), 1,
      aux_sym_bracketed_parameter_list_repeat1,
    STATE(8624), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [387302] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11038), 1,
      anon_sym_COMMA,
    ACTIONS(11041), 1,
      anon_sym_RBRACK,
    STATE(8625), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_argument_list_repeat1,
  [387347] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2607), 1,
      anon_sym_COMMA,
    ACTIONS(8219), 1,
      anon_sym_RBRACK,
    STATE(8497), 1,
      aux_sym_array_rank_specifier_repeat1,
    STATE(8626), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [387394] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11041), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
    STATE(8627), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [387437] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5655), 1,
      anon_sym_COMMA,
    ACTIONS(11034), 1,
      anon_sym_GT,
    STATE(8222), 1,
      aux_sym_type_argument_list_repeat1,
    STATE(8628), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [387484] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9218), 1,
      anon_sym_RBRACK,
    ACTIONS(11043), 1,
      anon_sym_COMMA,
    STATE(8630), 1,
      aux_sym_global_attribute_repeat1,
    STATE(8629), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [387531] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11045), 1,
      anon_sym_COMMA,
    ACTIONS(11048), 1,
      anon_sym_RBRACK,
    STATE(8630), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_global_attribute_repeat1,
  [387576] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10668), 1,
      anon_sym_COMMA,
    ACTIONS(11050), 1,
      anon_sym_RPAREN,
    STATE(8447), 1,
      aux_sym_attribute_argument_list_repeat1,
    STATE(8631), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [387623] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11052), 1,
      anon_sym_COMMA,
    ACTIONS(11054), 1,
      anon_sym_RBRACK,
    STATE(8450), 1,
      aux_sym_global_attribute_repeat1,
    STATE(8632), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [387670] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5655), 1,
      anon_sym_COMMA,
    ACTIONS(11056), 1,
      anon_sym_RBRACK,
    STATE(8651), 1,
      aux_sym_type_argument_list_repeat1,
    STATE(8633), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [387717] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9202), 1,
      anon_sym_RPAREN,
    ACTIONS(10798), 1,
      anon_sym_COMMA,
    STATE(8504), 1,
      aux_sym_tuple_pattern_repeat1,
    STATE(8634), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [387764] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11058), 1,
      anon_sym_COMMA,
    ACTIONS(11060), 1,
      anon_sym_RBRACE,
    STATE(8616), 1,
      aux_sym_anonymous_object_creation_expression_repeat1,
    STATE(8635), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [387811] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10457), 1,
      anon_sym_COMMA,
    ACTIONS(11062), 1,
      anon_sym_RPAREN,
    STATE(8617), 1,
      aux_sym_argument_list_repeat1,
    STATE(8636), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [387858] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2843), 1,
      anon_sym_RBRACE,
    ACTIONS(11064), 1,
      anon_sym_COMMA,
    STATE(8251), 1,
      aux_sym_for_statement_repeat1,
    STATE(8637), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [387905] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10442), 1,
      anon_sym_COMMA,
    ACTIONS(11066), 1,
      anon_sym_RPAREN,
    STATE(8540), 1,
      aux_sym_tuple_type_repeat1,
    STATE(8638), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [387952] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10457), 1,
      anon_sym_COMMA,
    ACTIONS(11068), 1,
      anon_sym_RPAREN,
    STATE(8649), 1,
      aux_sym_argument_list_repeat1,
    STATE(8639), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [387999] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10862), 1,
      anon_sym_RBRACE,
    ACTIONS(11070), 1,
      anon_sym_COMMA,
    STATE(8640), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_positional_pattern_clause_repeat1,
  [388044] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10686), 1,
      anon_sym_COMMA,
    ACTIONS(11073), 1,
      anon_sym_RPAREN,
    STATE(8455), 1,
      aux_sym_using_variable_declaration_repeat1,
    STATE(8641), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [388091] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11075), 1,
      anon_sym_COMMA,
    ACTIONS(11077), 1,
      anon_sym_RBRACK,
    STATE(8579), 1,
      aux_sym_global_attribute_repeat1,
    STATE(8642), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [388138] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10471), 1,
      anon_sym_COMMA,
    ACTIONS(11079), 1,
      anon_sym_RBRACK,
    STATE(8625), 1,
      aux_sym_argument_list_repeat1,
    STATE(8643), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [388185] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10489), 1,
      anon_sym_COMMA,
    ACTIONS(11081), 1,
      anon_sym_RPAREN,
    STATE(8482), 1,
      aux_sym_parenthesized_variable_designation_repeat1,
    STATE(8644), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [388232] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7986), 1,
      anon_sym_COMMA,
    ACTIONS(11083), 1,
      anon_sym_RPAREN,
    STATE(8251), 1,
      aux_sym_for_statement_repeat1,
    STATE(8645), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [388279] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9214), 1,
      anon_sym_RBRACK,
    ACTIONS(11085), 1,
      anon_sym_COMMA,
    STATE(8618), 1,
      aux_sym_global_attribute_repeat1,
    STATE(8646), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [388326] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9214), 1,
      anon_sym_RBRACK,
    ACTIONS(11085), 1,
      anon_sym_COMMA,
    STATE(8630), 1,
      aux_sym_global_attribute_repeat1,
    STATE(8647), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [388373] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9267), 1,
      anon_sym_RBRACK,
    ACTIONS(11087), 1,
      anon_sym_COMMA,
    STATE(8630), 1,
      aux_sym_global_attribute_repeat1,
    STATE(8648), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [388420] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11041), 1,
      anon_sym_RPAREN,
    ACTIONS(11089), 1,
      anon_sym_COMMA,
    STATE(8649), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_argument_list_repeat1,
  [388465] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11092), 1,
      anon_sym_COMMA,
    ACTIONS(11094), 1,
      anon_sym_RBRACE,
    STATE(8525), 1,
      aux_sym_positional_pattern_clause_repeat1,
    STATE(8650), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [388512] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5655), 1,
      anon_sym_COMMA,
    ACTIONS(11096), 1,
      anon_sym_RBRACK,
    STATE(8222), 1,
      aux_sym_type_argument_list_repeat1,
    STATE(8651), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [388559] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10340), 1,
      anon_sym_LBRACE,
    ACTIONS(11098), 1,
      anon_sym_COMMA,
    STATE(8652), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_base_list_repeat1,
  [388604] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11101), 1,
      anon_sym_EQ,
    ACTIONS(10883), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(8653), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [388649] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10538), 1,
      anon_sym_COMMA,
    ACTIONS(11103), 1,
      anon_sym_RBRACK,
    STATE(8405), 1,
      aux_sym_bracketed_parameter_list_repeat1,
    STATE(8654), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [388696] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10772), 1,
      anon_sym_COMMA,
    ACTIONS(10889), 1,
      anon_sym_RPAREN,
    STATE(8611), 1,
      aux_sym_variable_declaration_repeat1,
    STATE(8655), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [388743] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11105), 1,
      anon_sym_EQ,
    ACTIONS(10895), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(8656), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [388788] = 13,
    ACTIONS(9485), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9487), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9489), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9491), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9493), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9495), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9497), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9499), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9501), 1,
      sym_comment,
    ACTIONS(10696), 1,
      anon_sym_COMMA,
    ACTIONS(11107), 1,
      aux_sym_preproc_if_token2,
    STATE(8459), 1,
      aux_sym_preproc_pragma_repeat1,
    STATE(8657), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [388835] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10457), 1,
      anon_sym_COMMA,
    ACTIONS(11109), 1,
      anon_sym_RPAREN,
    STATE(8649), 1,
      aux_sym_argument_list_repeat1,
    STATE(8658), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [388882] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10471), 1,
      anon_sym_COMMA,
    ACTIONS(11111), 1,
      anon_sym_RBRACK,
    STATE(8643), 1,
      aux_sym_argument_list_repeat1,
    STATE(8659), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [388929] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11113), 1,
      anon_sym_COMMA,
    ACTIONS(11115), 1,
      anon_sym_RBRACK,
    STATE(8647), 1,
      aux_sym_global_attribute_repeat1,
    STATE(8660), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [388976] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2729), 1,
      anon_sym_RBRACE,
    ACTIONS(11117), 1,
      anon_sym_COMMA,
    STATE(8373), 1,
      aux_sym_anonymous_object_creation_expression_repeat1,
    STATE(8661), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [389023] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11119), 3,
      anon_sym_disable,
      anon_sym_restore,
      anon_sym_enable,
    STATE(8662), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [389066] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10372), 1,
      anon_sym_LBRACE,
    ACTIONS(11121), 1,
      anon_sym_COMMA,
    STATE(8664), 1,
      aux_sym_base_list_repeat1,
    STATE(8663), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [389113] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10368), 1,
      anon_sym_LBRACE,
    ACTIONS(11121), 1,
      anon_sym_COMMA,
    STATE(8652), 1,
      aux_sym_base_list_repeat1,
    STATE(8664), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [389160] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8189), 1,
      anon_sym_SEMI,
    ACTIONS(11123), 1,
      anon_sym_COMMA,
    STATE(8665), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_for_statement_repeat1,
  [389205] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2607), 1,
      anon_sym_COMMA,
    ACTIONS(11126), 1,
      anon_sym_RBRACK,
    STATE(8497), 1,
      aux_sym_array_rank_specifier_repeat1,
    STATE(8666), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [389252] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11128), 1,
      anon_sym_COMMA,
    ACTIONS(11130), 1,
      anon_sym_RBRACE,
    STATE(8546), 1,
      aux_sym_switch_expression_repeat1,
    STATE(8667), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [389299] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10272), 1,
      anon_sym_LBRACE,
    STATE(9628), 1,
      sym_enum_member_declaration_list,
    STATE(8668), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [389343] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(7583), 1,
      sym_parameter_list,
    STATE(8669), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [389387] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(8335), 1,
      sym_parameter_list,
    STATE(8670), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [389431] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10272), 1,
      anon_sym_LBRACE,
    STATE(9116), 1,
      sym_enum_member_declaration_list,
    STATE(8671), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [389475] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10272), 1,
      anon_sym_LBRACE,
    STATE(9036), 1,
      sym_enum_member_declaration_list,
    STATE(8672), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [389519] = 12,
    ACTIONS(5319), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(9485), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9487), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9489), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9491), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9493), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9495), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9497), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9499), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9501), 1,
      sym_comment,
    ACTIONS(11132), 1,
      sym_string_literal_encoding,
    STATE(8673), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [389563] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8449), 1,
      anon_sym_DOT,
    ACTIONS(11134), 1,
      anon_sym_SEMI,
    STATE(8674), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [389607] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(8289), 1,
      sym_parameter_list,
    STATE(8675), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [389651] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(7580), 1,
      sym_parameter_list,
    STATE(8676), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [389695] = 12,
    ACTIONS(9485), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9487), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9489), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9491), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9493), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9495), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9497), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9499), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9501), 1,
      sym_comment,
    ACTIONS(11136), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(11138), 1,
      sym_preproc_arg,
    STATE(8677), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [389739] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11140), 1,
      anon_sym_warning,
    ACTIONS(11142), 1,
      anon_sym_checksum,
    STATE(8678), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [389783] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11144), 1,
      anon_sym_LBRACK,
    STATE(8252), 1,
      sym_bracketed_parameter_list,
    STATE(8679), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [389827] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11146), 1,
      anon_sym_LBRACK,
    STATE(5245), 1,
      sym_array_rank_specifier,
    STATE(8680), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [389871] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(7530), 1,
      sym_parameter_list,
    STATE(8681), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [389915] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10078), 1,
      anon_sym_LBRACE,
    STATE(4211), 1,
      sym_block,
    STATE(8682), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [389959] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(7801), 1,
      sym_parameter_list,
    STATE(8683), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [390003] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10272), 1,
      anon_sym_LBRACE,
    STATE(8960), 1,
      sym_enum_member_declaration_list,
    STATE(8684), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [390047] = 12,
    ACTIONS(5292), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(9485), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9487), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9489), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9491), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9493), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9495), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9497), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9499), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9501), 1,
      sym_comment,
    ACTIONS(11148), 1,
      sym_string_literal_encoding,
    STATE(8685), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [390091] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(7857), 1,
      sym_parameter_list,
    STATE(8686), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [390135] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    STATE(8367), 1,
      sym_argument_list,
    STATE(8687), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [390179] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(7592), 1,
      sym_parameter_list,
    STATE(8688), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [390223] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(1295), 1,
      anon_sym_LBRACE,
    STATE(4176), 1,
      sym_initializer_expression,
    STATE(8689), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [390267] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(1295), 1,
      anon_sym_LBRACE,
    STATE(4169), 1,
      sym_initializer_expression,
    STATE(8690), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [390311] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11150), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
    STATE(8691), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [390353] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3051), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8692), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [390395] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(7842), 1,
      sym_parameter_list,
    STATE(8693), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [390439] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5980), 1,
      anon_sym_LBRACE,
    STATE(7701), 1,
      sym_block,
    STATE(8694), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [390483] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10078), 1,
      anon_sym_LBRACE,
    STATE(4079), 1,
      sym_block,
    STATE(8695), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [390527] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3341), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8696), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [390569] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(1295), 1,
      anon_sym_LBRACE,
    STATE(4107), 1,
      sym_initializer_expression,
    STATE(8697), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [390613] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3317), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8698), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [390655] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(7875), 1,
      sym_parameter_list,
    STATE(8699), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [390699] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3269), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8700), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [390741] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3265), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8701), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [390783] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3055), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8702), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [390825] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11152), 1,
      anon_sym_LPAREN,
    STATE(8883), 1,
      sym_tuple_expression,
    STATE(8703), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [390869] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4424), 2,
      anon_sym_COMMA,
      anon_sym_GT,
    STATE(8704), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [390911] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3059), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8705), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [390953] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10442), 1,
      anon_sym_COMMA,
    STATE(8452), 1,
      aux_sym_tuple_type_repeat1,
    STATE(8706), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [390997] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10457), 1,
      anon_sym_COMMA,
    STATE(8436), 1,
      aux_sym_argument_list_repeat1,
    STATE(8707), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [391041] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3063), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8708), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [391083] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3071), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8709), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [391125] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5707), 1,
      anon_sym_LBRACE,
    STATE(2202), 1,
      sym_block,
    STATE(8710), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [391169] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3075), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8711), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [391211] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11154), 1,
      anon_sym_LBRACK,
    STATE(2930), 1,
      sym_array_rank_specifier,
    STATE(8712), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [391255] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10957), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    STATE(8713), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [391297] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3079), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8714), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [391339] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4428), 2,
      anon_sym_COMMA,
      anon_sym_GT,
    STATE(8715), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [391381] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4438), 2,
      anon_sym_COMMA,
      anon_sym_GT,
    STATE(8716), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [391423] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3083), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8717), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [391465] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(8260), 1,
      sym_parameter_list,
    STATE(8718), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [391509] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3087), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8719), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [391551] = 11,
    ACTIONS(9485), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9487), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9489), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9491), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9493), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9495), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9497), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9499), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9501), 1,
      sym_comment,
    ACTIONS(11156), 2,
      aux_sym_character_literal_token1,
      sym_escape_sequence,
    STATE(8720), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [391593] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11158), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    STATE(8721), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [391635] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3091), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8722), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [391677] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3099), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8723), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [391719] = 12,
    ACTIONS(9485), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9487), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9489), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9491), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9493), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9495), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9497), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9499), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9501), 1,
      sym_comment,
    ACTIONS(11160), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(11162), 1,
      sym_preproc_arg,
    STATE(8724), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [391763] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11164), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(8725), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [391805] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3103), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8726), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [391847] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11166), 1,
      anon_sym_LPAREN,
    STATE(8802), 1,
      sym_tuple_expression,
    STATE(8727), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [391891] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3193), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8728), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [391933] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3197), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8729), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [391975] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3205), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8730), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [392017] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3217), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8731), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [392059] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3209), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8732), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [392101] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3225), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8733), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [392143] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3229), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8734), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [392185] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3261), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8735), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [392227] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4416), 2,
      anon_sym_COMMA,
      anon_sym_GT,
    STATE(8736), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [392269] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3281), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8737), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [392311] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3285), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8738), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [392353] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3293), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8739), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [392395] = 11,
    ACTIONS(9485), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9487), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9489), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9491), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9493), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9495), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9497), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9499), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9501), 1,
      sym_comment,
    ACTIONS(11168), 2,
      aux_sym_character_literal_token1,
      sym_escape_sequence,
    STATE(8740), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [392437] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11170), 2,
      anon_sym_LBRACE,
      anon_sym_when,
    STATE(8741), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [392479] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11172), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(8742), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [392521] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10855), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(8743), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [392563] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3301), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8744), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [392605] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11144), 1,
      anon_sym_LBRACK,
    STATE(8256), 1,
      sym_bracketed_parameter_list,
    STATE(8745), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [392649] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11174), 1,
      anon_sym_LPAREN,
    STATE(8864), 1,
      sym_tuple_expression,
    STATE(8746), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [392693] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3305), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8747), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [392735] = 11,
    ACTIONS(9485), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9487), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9489), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9491), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9493), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9495), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9497), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9499), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9501), 1,
      sym_comment,
    ACTIONS(11176), 2,
      aux_sym_character_literal_token1,
      sym_escape_sequence,
    STATE(8748), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [392777] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3325), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8749), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [392819] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3329), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8750), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [392861] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3333), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8751), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [392903] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11178), 2,
      anon_sym_LBRACE,
      anon_sym_when,
    STATE(8752), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [392945] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3345), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8753), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [392987] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3221), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8754), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [393029] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11180), 1,
      anon_sym_LBRACK,
    STATE(4028), 1,
      sym_array_rank_specifier,
    STATE(8755), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [393073] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10200), 1,
      anon_sym_LBRACE,
    STATE(3944), 1,
      sym_block,
    STATE(8756), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [393117] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3415), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8757), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [393159] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10807), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(8758), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [393201] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10457), 1,
      anon_sym_COMMA,
    STATE(8415), 1,
      aux_sym_argument_list_repeat1,
    STATE(8759), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [393245] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4081), 1,
      anon_sym_EQ_GT,
    ACTIONS(11182), 1,
      anon_sym_in,
    STATE(8760), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [393289] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10442), 1,
      anon_sym_COMMA,
    STATE(8409), 1,
      aux_sym_tuple_type_repeat1,
    STATE(8761), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [393333] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10074), 1,
      anon_sym_LBRACE,
    STATE(3637), 1,
      sym_block,
    STATE(8762), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [393377] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4081), 1,
      anon_sym_EQ_GT,
    ACTIONS(11184), 1,
      anon_sym_in,
    STATE(8763), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [393421] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(1141), 1,
      anon_sym_LBRACE,
    STATE(4041), 1,
      sym_initializer_expression,
    STATE(8764), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [393465] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3389), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8765), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [393507] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(1141), 1,
      anon_sym_LBRACE,
    STATE(3974), 1,
      sym_initializer_expression,
    STATE(8766), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [393551] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10872), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(8767), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [393593] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11186), 1,
      anon_sym_LBRACK,
    STATE(5333), 1,
      sym_array_rank_specifier,
    STATE(8768), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [393637] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11188), 2,
      anon_sym_COMMA,
      anon_sym_GT,
    STATE(8769), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [393679] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3411), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8770), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [393721] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11190), 1,
      anon_sym_DQUOTE,
    STATE(8927), 1,
      sym_string_literal,
    STATE(8771), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [393765] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3403), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8772), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [393807] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3399), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8773), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [393849] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10200), 1,
      anon_sym_LBRACE,
    STATE(4048), 1,
      sym_block,
    STATE(8774), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [393893] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3393), 1,
      anon_sym_while,
    ACTIONS(11192), 1,
      anon_sym_else,
    STATE(8775), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [393937] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10743), 2,
      anon_sym_COMMA,
      anon_sym_GT,
    STATE(8776), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [393979] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3385), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8777), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [394021] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(1141), 1,
      anon_sym_LBRACE,
    STATE(4032), 1,
      sym_initializer_expression,
    STATE(8778), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [394065] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11144), 1,
      anon_sym_LBRACK,
    STATE(8328), 1,
      sym_bracketed_parameter_list,
    STATE(8779), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [394109] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3361), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8780), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [394151] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3357), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8781), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [394193] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3321), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8782), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [394235] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3313), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8783), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [394277] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3365), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8784), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [394319] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4081), 1,
      anon_sym_EQ_GT,
    ACTIONS(11194), 1,
      anon_sym_in,
    STATE(8785), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [394363] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4081), 1,
      anon_sym_EQ_GT,
    ACTIONS(11196), 1,
      anon_sym_in,
    STATE(8786), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [394407] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11198), 2,
      anon_sym_this,
      anon_sym_base,
    STATE(8787), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [394449] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(7565), 1,
      sym_parameter_list,
    STATE(8788), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [394493] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11144), 1,
      anon_sym_LBRACK,
    STATE(8312), 1,
      sym_bracketed_parameter_list,
    STATE(8789), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [394537] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(7810), 1,
      sym_parameter_list,
    STATE(8790), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [394581] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(7839), 1,
      sym_parameter_list,
    STATE(8791), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [394625] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3289), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8792), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [394667] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(7905), 1,
      sym_parameter_list,
    STATE(8793), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [394711] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(7887), 1,
      sym_parameter_list,
    STATE(8794), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [394755] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11200), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    STATE(8795), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [394797] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10660), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(8796), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [394839] = 12,
    ACTIONS(9485), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9487), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9489), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9491), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9493), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9495), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9497), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9499), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9501), 1,
      sym_comment,
    ACTIONS(10640), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(11202), 1,
      anon_sym_COMMA,
    STATE(8797), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [394883] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10544), 1,
      anon_sym_DQUOTE,
    STATE(9671), 1,
      sym_string_literal,
    STATE(8798), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [394927] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(7577), 1,
      sym_parameter_list,
    STATE(8799), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [394971] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(7597), 1,
      sym_parameter_list,
    STATE(8800), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [395015] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(7531), 1,
      sym_parameter_list,
    STATE(8801), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [395059] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11204), 1,
      anon_sym_LBRACE,
    STATE(8840), 1,
      sym_switch_body,
    STATE(8802), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [395103] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10272), 1,
      anon_sym_LBRACE,
    STATE(9810), 1,
      sym_enum_member_declaration_list,
    STATE(8803), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [395147] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11206), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
    STATE(8804), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [395189] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3309), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8805), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [395231] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3277), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8806), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [395273] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(8245), 1,
      sym_parameter_list,
    STATE(8807), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [395317] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11208), 1,
      anon_sym_LBRACK,
    STATE(3464), 1,
      sym_array_rank_specifier,
    STATE(8808), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [395361] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3213), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8809), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [395403] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5709), 1,
      anon_sym_LBRACE,
    STATE(2209), 1,
      sym_block,
    STATE(8810), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [395447] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11210), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
    STATE(8811), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [395489] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3201), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8812), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [395531] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3111), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8813), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [395573] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(7805), 1,
      sym_parameter_list,
    STATE(8814), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [395617] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3407), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8815), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [395659] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3369), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8816), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [395701] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3095), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8817), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [395743] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(7555), 1,
      sym_parameter_list,
    STATE(8818), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [395787] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11212), 2,
      anon_sym_disable,
      anon_sym_restore,
    STATE(8819), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [395829] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11190), 1,
      anon_sym_DQUOTE,
    STATE(8771), 1,
      sym_string_literal,
    STATE(8820), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [395873] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10651), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(8821), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [395915] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5709), 1,
      anon_sym_LBRACE,
    STATE(2207), 1,
      sym_block,
    STATE(8822), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [395959] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11214), 1,
      anon_sym_LBRACE,
    STATE(2282), 1,
      sym_switch_body,
    STATE(8823), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [396003] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(1377), 1,
      anon_sym_LBRACE,
    STATE(5621), 1,
      sym_initializer_expression,
    STATE(8824), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [396047] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11216), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(8825), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [396089] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11218), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(8826), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [396131] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4081), 1,
      anon_sym_EQ_GT,
    ACTIONS(11220), 1,
      anon_sym_in,
    STATE(8827), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [396175] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5707), 1,
      anon_sym_LBRACE,
    STATE(2278), 1,
      sym_block,
    STATE(8828), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [396219] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10512), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(8829), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [396261] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(1377), 1,
      anon_sym_LBRACE,
    STATE(5617), 1,
      sym_initializer_expression,
    STATE(8830), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [396305] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5709), 1,
      anon_sym_LBRACE,
    STATE(2232), 1,
      sym_block,
    STATE(8831), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [396349] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10188), 1,
      anon_sym_LBRACE,
    STATE(5570), 1,
      sym_block,
    STATE(8832), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [396393] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11222), 1,
      anon_sym_LBRACK,
    STATE(3932), 1,
      sym_array_rank_specifier,
    STATE(8833), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [396437] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11224), 2,
      anon_sym_COMMA,
      anon_sym_GT,
    STATE(8834), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [396479] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3373), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8835), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [396521] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10457), 1,
      anon_sym_COMMA,
    STATE(8394), 1,
      aux_sym_argument_list_repeat1,
    STATE(8836), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [396565] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(1377), 1,
      anon_sym_LBRACE,
    STATE(5643), 1,
      sym_initializer_expression,
    STATE(8837), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [396609] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2939), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8838), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [396651] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3353), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8839), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [396693] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3377), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8840), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [396735] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10272), 1,
      anon_sym_LBRACE,
    STATE(9309), 1,
      sym_enum_member_declaration_list,
    STATE(8841), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [396779] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3381), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8842), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [396821] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11144), 1,
      anon_sym_LBRACK,
    STATE(8262), 1,
      sym_bracketed_parameter_list,
    STATE(8843), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [396865] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3237), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8844), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [396907] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8449), 1,
      anon_sym_DOT,
    ACTIONS(11226), 1,
      anon_sym_SEMI,
    STATE(8845), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [396951] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10442), 1,
      anon_sym_COMMA,
    STATE(8377), 1,
      aux_sym_tuple_type_repeat1,
    STATE(8846), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [396995] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3297), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8847), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [397037] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3047), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8848), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [397079] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4081), 1,
      anon_sym_EQ_GT,
    ACTIONS(11228), 1,
      anon_sym_in,
    STATE(8849), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [397123] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11230), 1,
      anon_sym_LBRACK,
    ACTIONS(11232), 1,
      anon_sym_LT,
    STATE(8850), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [397167] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3257), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8851), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [397209] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(7911), 1,
      sym_parameter_list,
    STATE(8852), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [397253] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(7874), 1,
      sym_parameter_list,
    STATE(8853), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [397297] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3245), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8854), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [397339] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4081), 1,
      anon_sym_EQ_GT,
    ACTIONS(11234), 1,
      anon_sym_in,
    STATE(8855), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [397383] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8449), 1,
      anon_sym_DOT,
    ACTIONS(11236), 1,
      anon_sym_SEMI,
    STATE(8856), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [397427] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11238), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    STATE(8857), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [397469] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(7636), 1,
      sym_parameter_list,
    STATE(8858), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [397513] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8449), 1,
      anon_sym_DOT,
    ACTIONS(11240), 1,
      anon_sym_SEMI,
    STATE(8859), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [397557] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(7897), 1,
      sym_parameter_list,
    STATE(8860), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [397601] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3241), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8861), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [397643] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11144), 1,
      anon_sym_LBRACK,
    STATE(8225), 1,
      sym_bracketed_parameter_list,
    STATE(8862), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [397687] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3233), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8863), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [397729] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11214), 1,
      anon_sym_LBRACE,
    STATE(2286), 1,
      sym_switch_body,
    STATE(8864), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [397773] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(7610), 1,
      sym_parameter_list,
    STATE(8865), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [397817] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3043), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8866), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [397859] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3189), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8867), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [397901] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(1463), 1,
      anon_sym_LBRACE,
    STATE(3720), 1,
      sym_initializer_expression,
    STATE(8868), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [397945] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(7620), 1,
      sym_parameter_list,
    STATE(8869), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [397989] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10188), 1,
      anon_sym_LBRACE,
    STATE(5675), 1,
      sym_block,
    STATE(8870), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [398033] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3107), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8871), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [398075] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3067), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8872), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [398117] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5980), 1,
      anon_sym_LBRACE,
    STATE(3741), 1,
      sym_block,
    STATE(8873), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [398161] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3253), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8874), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [398203] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3337), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8875), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [398245] = 11,
    ACTIONS(9485), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9487), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9489), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9491), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9493), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9495), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9497), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9499), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9501), 1,
      sym_comment,
    ACTIONS(11242), 2,
      aux_sym_character_literal_token1,
      sym_escape_sequence,
    STATE(8876), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [398287] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10483), 1,
      anon_sym_COMMA,
    STATE(8363), 1,
      aux_sym_positional_pattern_clause_repeat1,
    STATE(8877), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [398331] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(7606), 1,
      sym_parameter_list,
    STATE(8878), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [398375] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11244), 1,
      anon_sym_LBRACK,
    STATE(3589), 1,
      sym_array_rank_specifier,
    STATE(8879), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [398419] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5709), 1,
      anon_sym_LBRACE,
    STATE(2199), 1,
      sym_block,
    STATE(8880), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [398463] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11246), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(8881), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [398505] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6104), 1,
      anon_sym_LBRACE,
    STATE(2450), 1,
      sym_block,
    STATE(8882), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [398549] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11248), 1,
      anon_sym_LBRACE,
    STATE(2471), 1,
      sym_switch_body,
    STATE(8883), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [398593] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11250), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(8884), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [398635] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10457), 1,
      anon_sym_COMMA,
    STATE(8639), 1,
      aux_sym_argument_list_repeat1,
    STATE(8885), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [398679] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4081), 1,
      anon_sym_EQ_GT,
    ACTIONS(11252), 1,
      anon_sym_in,
    STATE(8886), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [398723] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10442), 1,
      anon_sym_COMMA,
    STATE(8638), 1,
      aux_sym_tuple_type_repeat1,
    STATE(8887), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [398767] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11254), 1,
      anon_sym_LBRACK,
    STATE(3662), 1,
      sym_array_rank_specifier,
    STATE(8888), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [398811] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5707), 1,
      anon_sym_LBRACE,
    STATE(2279), 1,
      sym_block,
    STATE(8889), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [398855] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11248), 1,
      anon_sym_LBRACE,
    STATE(2446), 1,
      sym_switch_body,
    STATE(8890), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [398899] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11256), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
    STATE(8891), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [398941] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11258), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
    STATE(8892), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [398983] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11260), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(8893), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [399025] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(7870), 1,
      sym_parameter_list,
    STATE(8894), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [399069] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(7789), 1,
      sym_parameter_list,
    STATE(8895), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [399113] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(1463), 1,
      anon_sym_LBRACE,
    STATE(3731), 1,
      sym_initializer_expression,
    STATE(8896), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [399157] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(7765), 1,
      sym_parameter_list,
    STATE(8897), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [399201] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(7631), 1,
      sym_parameter_list,
    STATE(8898), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [399245] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11262), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(8899), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [399287] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(8318), 1,
      sym_parameter_list,
    STATE(8900), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [399331] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4424), 1,
      anon_sym_GT,
    ACTIONS(9907), 1,
      anon_sym_COMMA,
    STATE(8901), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [399375] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10158), 1,
      anon_sym_LBRACE,
    STATE(4594), 1,
      sym_block,
    STATE(8902), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [399419] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11264), 1,
      anon_sym_LBRACE,
    STATE(2653), 1,
      sym_switch_body,
    STATE(8903), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [399463] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(8295), 1,
      sym_parameter_list,
    STATE(8904), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [399507] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8449), 1,
      anon_sym_DOT,
    ACTIONS(11266), 1,
      anon_sym_SEMI,
    STATE(8905), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [399551] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7250), 1,
      anon_sym_LBRACK,
    ACTIONS(7252), 1,
      anon_sym_STAR,
    STATE(8906), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [399595] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(1217), 1,
      anon_sym_LBRACE,
    STATE(3651), 1,
      sym_initializer_expression,
    STATE(8907), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [399639] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11268), 2,
      anon_sym_COMMA,
      anon_sym_GT,
    STATE(8908), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [399681] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(1611), 1,
      anon_sym_LBRACE,
    STATE(4672), 1,
      sym_initializer_expression,
    STATE(8909), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [399725] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6104), 1,
      anon_sym_LBRACE,
    STATE(2658), 1,
      sym_block,
    STATE(8910), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [399769] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10881), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(8911), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [399811] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5980), 1,
      anon_sym_LBRACE,
    STATE(8813), 1,
      sym_block,
    STATE(8912), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [399855] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(1217), 1,
      anon_sym_LBRACE,
    STATE(3667), 1,
      sym_initializer_expression,
    STATE(8913), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [399899] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11270), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    STATE(8914), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [399941] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11272), 1,
      anon_sym_LPAREN,
    STATE(8903), 1,
      sym_tuple_expression,
    STATE(8915), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [399985] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(1611), 1,
      anon_sym_LBRACE,
    STATE(4681), 1,
      sym_initializer_expression,
    STATE(8916), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [400029] = 11,
    ACTIONS(9485), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9487), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9489), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9491), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9493), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9495), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9497), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9499), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9501), 1,
      sym_comment,
    ACTIONS(11274), 2,
      aux_sym_character_literal_token1,
      sym_escape_sequence,
    STATE(8917), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [400071] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11048), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    STATE(8918), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [400113] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10457), 1,
      anon_sym_COMMA,
    STATE(8583), 1,
      aux_sym_argument_list_repeat1,
    STATE(8919), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [400157] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5707), 1,
      anon_sym_LBRACE,
    STATE(2495), 1,
      sym_block,
    STATE(8920), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [400201] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10442), 1,
      anon_sym_COMMA,
    STATE(8586), 1,
      aux_sym_tuple_type_repeat1,
    STATE(8921), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [400245] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(1463), 1,
      anon_sym_LBRACE,
    STATE(3745), 1,
      sym_initializer_expression,
    STATE(8922), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [400289] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10158), 1,
      anon_sym_LBRACE,
    STATE(4580), 1,
      sym_block,
    STATE(8923), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [400333] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8449), 1,
      anon_sym_DOT,
    ACTIONS(11276), 1,
      anon_sym_SEMI,
    STATE(8924), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [400377] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8449), 1,
      anon_sym_DOT,
    ACTIONS(11278), 1,
      anon_sym_SEMI,
    STATE(8925), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [400421] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10272), 1,
      anon_sym_LBRACE,
    STATE(9086), 1,
      sym_enum_member_declaration_list,
    STATE(8926), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [400465] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10544), 1,
      anon_sym_DQUOTE,
    STATE(9481), 1,
      sym_string_literal,
    STATE(8927), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [400509] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(7632), 1,
      sym_parameter_list,
    STATE(8928), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [400553] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10074), 1,
      anon_sym_LBRACE,
    STATE(3707), 1,
      sym_block,
    STATE(8929), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [400597] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8449), 1,
      anon_sym_DOT,
    ACTIONS(11280), 1,
      anon_sym_SEMI,
    STATE(8930), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [400641] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10442), 1,
      anon_sym_COMMA,
    STATE(8346), 1,
      aux_sym_tuple_type_repeat1,
    STATE(8931), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [400685] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(7850), 1,
      sym_parameter_list,
    STATE(8932), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [400729] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(1611), 1,
      anon_sym_LBRACE,
    STATE(4539), 1,
      sym_initializer_expression,
    STATE(8933), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [400773] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10442), 1,
      anon_sym_COMMA,
    STATE(8488), 1,
      aux_sym_tuple_type_repeat1,
    STATE(8934), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [400817] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(7615), 1,
      sym_parameter_list,
    STATE(8935), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [400861] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10483), 1,
      anon_sym_COMMA,
    STATE(8526), 1,
      aux_sym_positional_pattern_clause_repeat1,
    STATE(8936), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [400905] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11282), 1,
      anon_sym_on,
    STATE(7584), 1,
      sym__join_body,
    STATE(8937), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [400949] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(7557), 1,
      sym_parameter_list,
    STATE(8938), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [400993] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(7855), 1,
      sym_parameter_list,
    STATE(8939), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [401037] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6104), 1,
      anon_sym_LBRACE,
    STATE(2640), 1,
      sym_block,
    STATE(8940), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [401081] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10272), 1,
      anon_sym_LBRACE,
    STATE(9543), 1,
      sym_enum_member_declaration_list,
    STATE(8941), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [401125] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6104), 1,
      anon_sym_LBRACE,
    STATE(2641), 1,
      sym_block,
    STATE(8942), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [401169] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(8271), 1,
      sym_parameter_list,
    STATE(8943), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [401213] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8449), 1,
      anon_sym_DOT,
    ACTIONS(11284), 1,
      anon_sym_SEMI,
    STATE(8944), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [401257] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5980), 1,
      anon_sym_LBRACE,
    STATE(8229), 1,
      sym_block,
    STATE(8945), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [401301] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8449), 1,
      anon_sym_DOT,
    ACTIONS(11286), 1,
      anon_sym_SEMI,
    STATE(8946), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [401345] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10272), 1,
      anon_sym_LBRACE,
    STATE(9277), 1,
      sym_enum_member_declaration_list,
    STATE(8947), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [401389] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(8293), 1,
      sym_parameter_list,
    STATE(8948), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [401433] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(8265), 1,
      sym_parameter_list,
    STATE(8949), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [401477] = 11,
    ACTIONS(9485), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9487), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9489), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9491), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9493), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9495), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9497), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9499), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9501), 1,
      sym_comment,
    ACTIONS(11288), 2,
      aux_sym_character_literal_token1,
      sym_escape_sequence,
    STATE(8950), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [401519] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(1217), 1,
      anon_sym_LBRACE,
    STATE(3712), 1,
      sym_initializer_expression,
    STATE(8951), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [401563] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10442), 1,
      anon_sym_COMMA,
    STATE(8384), 1,
      aux_sym_tuple_type_repeat1,
    STATE(8952), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [401607] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11204), 1,
      anon_sym_LBRACE,
    STATE(8780), 1,
      sym_switch_body,
    STATE(8953), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [401651] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5980), 1,
      anon_sym_LBRACE,
    STATE(3722), 1,
      sym_block,
    STATE(8954), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [401695] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11264), 1,
      anon_sym_LBRACE,
    STATE(2716), 1,
      sym_switch_body,
    STATE(8955), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [401739] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5980), 1,
      anon_sym_LBRACE,
    STATE(8227), 1,
      sym_block,
    STATE(8956), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [401783] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9291), 1,
      anon_sym_LPAREN,
    STATE(7567), 1,
      sym_parameter_list,
    STATE(8957), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [401827] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11290), 1,
      anon_sym_EQ_GT,
    STATE(8958), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [401868] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11292), 1,
      anon_sym_in,
    STATE(8959), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [401909] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11294), 1,
      sym__optional_semi,
    STATE(8960), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [401950] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11296), 1,
      aux_sym_preproc_if_token3,
    STATE(8961), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [401991] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11298), 1,
      aux_sym_preproc_if_token3,
    STATE(8962), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [402032] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11300), 1,
      sym__optional_semi,
    STATE(8963), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [402073] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11302), 1,
      anon_sym_RPAREN,
    STATE(8964), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [402114] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11304), 1,
      sym__optional_semi,
    STATE(8965), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [402155] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11306), 1,
      anon_sym_LBRACE,
    STATE(8966), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [402196] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11308), 1,
      sym__optional_semi,
    STATE(8967), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [402237] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11310), 1,
      sym__optional_semi,
    STATE(8968), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [402278] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11312), 1,
      sym__optional_semi,
    STATE(8969), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [402319] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11314), 1,
      sym__optional_semi,
    STATE(8970), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [402360] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11316), 1,
      sym__optional_semi,
    STATE(8971), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [402401] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11318), 1,
      sym__optional_semi,
    STATE(8972), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [402442] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11320), 1,
      anon_sym_EQ_GT,
    STATE(8973), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [402483] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11322), 1,
      sym__optional_semi,
    STATE(8974), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [402524] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11324), 1,
      sym__optional_semi,
    STATE(8975), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [402565] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8920), 1,
      anon_sym_RPAREN,
    STATE(8976), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [402606] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11326), 1,
      anon_sym_SEMI,
    STATE(8977), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [402647] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11328), 1,
      aux_sym_preproc_if_token3,
    STATE(8978), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [402688] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11330), 1,
      aux_sym_preproc_if_token3,
    STATE(8979), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [402729] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11332), 1,
      anon_sym_SEMI,
    STATE(8980), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [402770] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10926), 1,
      anon_sym_RBRACE,
    STATE(8981), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [402811] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11334), 1,
      anon_sym_RBRACE,
    STATE(8982), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [402852] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11336), 1,
      anon_sym_RBRACK,
    STATE(8983), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [402893] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11338), 1,
      sym__optional_semi,
    STATE(8984), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [402934] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11340), 1,
      sym__optional_semi,
    STATE(8985), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [402975] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11342), 1,
      anon_sym_EQ_GT,
    STATE(8986), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [403016] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11344), 1,
      anon_sym_LBRACE,
    STATE(8987), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [403057] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11346), 1,
      anon_sym_LBRACE,
    STATE(8988), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [403098] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11348), 1,
      anon_sym_EQ_GT,
    STATE(8989), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [403139] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11350), 1,
      anon_sym_GT,
    STATE(8990), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [403180] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11352), 1,
      sym__optional_semi,
    STATE(8991), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [403221] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11354), 1,
      sym__optional_semi,
    STATE(8992), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [403262] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11356), 1,
      anon_sym_EQ,
    STATE(8993), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [403303] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11358), 1,
      sym__optional_semi,
    STATE(8994), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [403344] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11360), 1,
      anon_sym_EQ_GT,
    STATE(8995), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [403385] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11362), 1,
      anon_sym_SEMI,
    STATE(8996), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [403426] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11364), 1,
      anon_sym_EQ_GT,
    STATE(8997), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [403467] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11366), 1,
      sym__optional_semi,
    STATE(8998), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [403508] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11368), 1,
      anon_sym_EQ_GT,
    STATE(8999), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [403549] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11370), 1,
      sym__optional_semi,
    STATE(9000), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [403590] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11372), 1,
      sym__optional_semi,
    STATE(9001), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [403631] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11374), 1,
      sym__optional_semi,
    STATE(9002), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [403672] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11376), 1,
      anon_sym_DOT,
    STATE(9003), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [403713] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11378), 1,
      sym__optional_semi,
    STATE(9004), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [403754] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11380), 1,
      sym__optional_semi,
    STATE(9005), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [403795] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11382), 1,
      anon_sym_EQ_GT,
    STATE(9006), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [403836] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11384), 1,
      sym__optional_semi,
    STATE(9007), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [403877] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11386), 1,
      sym__optional_semi,
    STATE(9008), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [403918] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11388), 1,
      anon_sym_SEMI,
    STATE(9009), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [403959] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10965), 1,
      sym_interpolation_close_brace,
    STATE(9010), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [404000] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11390), 1,
      anon_sym_GT,
    STATE(9011), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [404041] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11392), 1,
      sym__optional_semi,
    STATE(9012), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [404082] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11394), 1,
      sym__optional_semi,
    STATE(9013), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [404123] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11396), 1,
      anon_sym_EQ_GT,
    STATE(9014), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [404164] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11398), 1,
      sym__optional_semi,
    STATE(9015), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [404205] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11400), 1,
      sym__optional_semi,
    STATE(9016), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [404246] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11402), 1,
      sym__optional_semi,
    STATE(9017), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [404287] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11404), 1,
      sym__optional_semi,
    STATE(9018), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [404328] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11406), 1,
      sym__optional_semi,
    STATE(9019), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [404369] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11408), 1,
      anon_sym_RPAREN,
    STATE(9020), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [404410] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11410), 1,
      aux_sym_preproc_if_token3,
    STATE(9021), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [404451] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11412), 1,
      anon_sym_EQ_GT,
    STATE(9022), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [404492] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11414), 1,
      aux_sym_preproc_if_token3,
    STATE(9023), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [404533] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11416), 1,
      anon_sym_LBRACE,
    STATE(9024), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [404574] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11418), 1,
      sym__optional_semi,
    STATE(9025), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [404615] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11420), 1,
      anon_sym_GT,
    STATE(9026), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [404656] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11422), 1,
      anon_sym_EQ_GT,
    STATE(9027), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [404697] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11424), 1,
      anon_sym_RBRACE,
    STATE(9028), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [404738] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11426), 1,
      anon_sym_EQ_GT,
    STATE(9029), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [404779] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11428), 1,
      sym__optional_semi,
    STATE(9030), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [404820] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11430), 1,
      sym__optional_semi,
    STATE(9031), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [404861] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11432), 1,
      anon_sym_EQ_GT,
    STATE(9032), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [404902] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11434), 1,
      anon_sym_EQ_GT,
    STATE(9033), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [404943] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11436), 1,
      anon_sym_EQ_GT,
    STATE(9034), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [404984] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11130), 1,
      anon_sym_RBRACE,
    STATE(9035), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [405025] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11438), 1,
      sym__optional_semi,
    STATE(9036), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [405066] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11440), 1,
      sym__optional_semi,
    STATE(9037), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [405107] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11442), 1,
      sym__optional_semi,
    STATE(9038), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [405148] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11444), 1,
      sym__optional_semi,
    STATE(9039), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [405189] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11446), 1,
      anon_sym_SEMI,
    STATE(9040), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [405230] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11448), 1,
      sym__optional_semi,
    STATE(9041), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [405271] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11450), 1,
      anon_sym_EQ_GT,
    STATE(9042), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [405312] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11452), 1,
      sym__optional_semi,
    STATE(9043), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [405353] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11454), 1,
      anon_sym_EQ_GT,
    STATE(9044), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [405394] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11456), 1,
      sym_integer_literal,
    STATE(9045), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [405435] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11458), 1,
      aux_sym_preproc_if_token3,
    STATE(9046), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [405476] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11460), 1,
      aux_sym_preproc_if_token3,
    STATE(9047), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [405517] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11462), 1,
      anon_sym_SEMI,
    STATE(9048), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [405558] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11464), 1,
      anon_sym_EQ_GT,
    STATE(9049), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [405599] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11466), 1,
      sym__optional_semi,
    STATE(9050), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [405640] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8690), 1,
      anon_sym_RPAREN,
    STATE(9051), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [405681] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11468), 1,
      sym__optional_semi,
    STATE(9052), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [405722] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11470), 1,
      anon_sym_EQ_GT,
    STATE(9053), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [405763] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11472), 1,
      anon_sym_EQ_GT,
    STATE(9054), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [405804] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11474), 1,
      anon_sym_SEMI,
    STATE(9055), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [405845] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11476), 1,
      sym__optional_semi,
    STATE(9056), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [405886] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11478), 1,
      sym__optional_semi,
    STATE(9057), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [405927] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11480), 1,
      sym__optional_semi,
    STATE(9058), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [405968] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11482), 1,
      sym__optional_semi,
    STATE(9059), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [406009] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11484), 1,
      sym__optional_semi,
    STATE(9060), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [406050] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11486), 1,
      sym__optional_semi,
    STATE(9061), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [406091] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11488), 1,
      sym__optional_semi,
    STATE(9062), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [406132] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11490), 1,
      anon_sym_EQ_GT,
    STATE(9063), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [406173] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11492), 1,
      sym__optional_semi,
    STATE(9064), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [406214] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11494), 1,
      sym__optional_semi,
    STATE(9065), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [406255] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8612), 1,
      anon_sym_RPAREN,
    STATE(9066), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [406296] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11496), 1,
      anon_sym_LPAREN,
    STATE(9067), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [406337] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11498), 1,
      anon_sym_SEMI,
    STATE(9068), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [406378] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11500), 1,
      sym__optional_semi,
    STATE(9069), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [406419] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11502), 1,
      anon_sym_RPAREN,
    STATE(9070), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [406460] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11504), 1,
      anon_sym_GT,
    STATE(9071), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [406501] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11506), 1,
      anon_sym_EQ_GT,
    STATE(9072), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [406542] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11508), 1,
      anon_sym_EQ_GT,
    STATE(9073), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [406583] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11510), 1,
      anon_sym_EQ_GT,
    STATE(9074), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [406624] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11512), 1,
      anon_sym_GT,
    STATE(9075), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [406665] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11514), 1,
      sym__optional_semi,
    STATE(9076), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [406706] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11516), 1,
      sym__optional_semi,
    STATE(9077), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [406747] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11518), 1,
      sym__optional_semi,
    STATE(9078), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [406788] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11520), 1,
      sym__optional_semi,
    STATE(9079), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [406829] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11522), 1,
      sym__optional_semi,
    STATE(9080), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [406870] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11524), 1,
      anon_sym_EQ_GT,
    STATE(9081), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [406911] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11526), 1,
      anon_sym_EQ_GT,
    STATE(9082), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [406952] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11528), 1,
      anon_sym_LBRACE,
    STATE(9083), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [406993] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11530), 1,
      anon_sym_EQ_GT,
    STATE(9084), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [407034] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11532), 1,
      sym__optional_semi,
    STATE(9085), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [407075] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11534), 1,
      sym__optional_semi,
    STATE(9086), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [407116] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11536), 1,
      sym__optional_semi,
    STATE(9087), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [407157] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11538), 1,
      sym__optional_semi,
    STATE(9088), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [407198] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11540), 1,
      anon_sym_LBRACE,
    STATE(9089), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [407239] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11542), 1,
      anon_sym_EQ_GT,
    STATE(9090), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [407280] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11544), 1,
      sym__optional_semi,
    STATE(9091), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [407321] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11546), 1,
      anon_sym_EQ_GT,
    STATE(9092), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [407362] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11548), 1,
      anon_sym_EQ_GT,
    STATE(9093), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [407403] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11550), 1,
      anon_sym_SEMI,
    STATE(9094), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [407444] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11552), 1,
      anon_sym_RBRACK,
    STATE(9095), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [407485] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11554), 1,
      anon_sym_SEMI,
    STATE(9096), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [407526] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11556), 1,
      sym__optional_semi,
    STATE(9097), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [407567] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11558), 1,
      anon_sym_RPAREN,
    STATE(9098), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [407608] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11560), 1,
      anon_sym_EQ_GT,
    STATE(9099), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [407649] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11562), 1,
      sym__optional_semi,
    STATE(9100), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [407690] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11564), 1,
      anon_sym_RPAREN,
    STATE(9101), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [407731] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11566), 1,
      anon_sym_EQ_GT,
    STATE(9102), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [407772] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11568), 1,
      sym__optional_semi,
    STATE(9103), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [407813] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11570), 1,
      anon_sym_EQ_GT,
    STATE(9104), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [407854] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11572), 1,
      anon_sym_SEMI,
    STATE(9105), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [407895] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11574), 1,
      sym__optional_semi,
    STATE(9106), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [407936] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11576), 1,
      sym__optional_semi,
    STATE(9107), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [407977] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11578), 1,
      anon_sym_SEMI,
    STATE(9108), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [408018] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11580), 1,
      anon_sym_in,
    STATE(9109), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [408059] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11582), 1,
      anon_sym_EQ_GT,
    STATE(9110), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [408100] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11584), 1,
      anon_sym_EQ_GT,
    STATE(9111), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [408141] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11586), 1,
      sym__optional_semi,
    STATE(9112), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [408182] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11588), 1,
      anon_sym_RPAREN,
    STATE(9113), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [408223] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11590), 1,
      sym__optional_semi,
    STATE(9114), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [408264] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11592), 1,
      sym__optional_semi,
    STATE(9115), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [408305] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11594), 1,
      sym__optional_semi,
    STATE(9116), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [408346] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11596), 1,
      anon_sym_EQ_GT,
    STATE(9117), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [408387] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11598), 1,
      sym__optional_semi,
    STATE(9118), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [408428] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11600), 1,
      anon_sym_EQ_GT,
    STATE(9119), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [408469] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11602), 1,
      anon_sym_EQ_GT,
    STATE(9120), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [408510] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11604), 1,
      anon_sym_EQ_GT,
    STATE(9121), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [408551] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11606), 1,
      sym__optional_semi,
    STATE(9122), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [408592] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11608), 1,
      anon_sym_EQ_GT,
    STATE(9123), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [408633] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11610), 1,
      anon_sym_EQ_GT,
    STATE(9124), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [408674] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8181), 1,
      anon_sym_SEMI,
    STATE(9125), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [408715] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11612), 1,
      anon_sym_EQ_GT,
    STATE(9126), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [408756] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11614), 1,
      anon_sym_EQ_GT,
    STATE(9127), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [408797] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11616), 1,
      anon_sym_RPAREN,
    STATE(9128), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [408838] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11618), 1,
      sym_interpolation_start_quote,
    STATE(9129), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [408879] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11620), 1,
      anon_sym_EQ_GT,
    STATE(9130), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [408920] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11622), 1,
      anon_sym_DQUOTE,
    STATE(9131), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [408961] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11624), 1,
      anon_sym_DQUOTE,
    STATE(9132), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [409002] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11626), 1,
      sym__optional_semi,
    STATE(9133), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [409043] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11628), 1,
      anon_sym_RPAREN,
    STATE(9134), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [409084] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11630), 1,
      sym__optional_semi,
    STATE(9135), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [409125] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11632), 1,
      anon_sym_EQ_GT,
    STATE(9136), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [409166] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11634), 1,
      anon_sym_EQ_GT,
    STATE(9137), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [409207] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11636), 1,
      anon_sym_EQ_GT,
    STATE(9138), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [409248] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11638), 1,
      anon_sym_EQ_GT,
    STATE(9139), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [409289] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11640), 1,
      anon_sym_EQ_GT,
    STATE(9140), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [409330] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11642), 1,
      anon_sym_EQ_GT,
    STATE(9141), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [409371] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11644), 1,
      anon_sym_EQ_GT,
    STATE(9142), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [409412] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11646), 1,
      anon_sym_EQ_GT,
    STATE(9143), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [409453] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11648), 1,
      sym__optional_semi,
    STATE(9144), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [409494] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11650), 1,
      anon_sym_EQ_GT,
    STATE(9145), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [409535] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11652), 1,
      anon_sym_EQ_GT,
    STATE(9146), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [409576] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11654), 1,
      anon_sym_EQ_GT,
    STATE(9147), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [409617] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11656), 1,
      anon_sym_EQ_GT,
    STATE(9148), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [409658] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11658), 1,
      anon_sym_EQ_GT,
    STATE(9149), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [409699] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11660), 1,
      anon_sym_EQ_GT,
    STATE(9150), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [409740] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11662), 1,
      anon_sym_EQ_GT,
    STATE(9151), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [409781] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11664), 1,
      anon_sym_EQ_GT,
    STATE(9152), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [409822] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11094), 1,
      anon_sym_RBRACE,
    STATE(9153), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [409863] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11666), 1,
      anon_sym_EQ_GT,
    STATE(9154), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [409904] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11668), 1,
      anon_sym_EQ_GT,
    STATE(9155), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [409945] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11670), 1,
      anon_sym_EQ_GT,
    STATE(9156), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [409986] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11672), 1,
      anon_sym_EQ_GT,
    STATE(9157), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [410027] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11674), 1,
      anon_sym_EQ_GT,
    STATE(9158), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [410068] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11676), 1,
      anon_sym_EQ_GT,
    STATE(9159), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [410109] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11678), 1,
      anon_sym_EQ_GT,
    STATE(9160), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [410150] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11680), 1,
      anon_sym_EQ_GT,
    STATE(9161), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [410191] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11682), 1,
      anon_sym_EQ_GT,
    STATE(9162), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [410232] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11684), 1,
      anon_sym_EQ_GT,
    STATE(9163), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [410273] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11686), 1,
      anon_sym_EQ_GT,
    STATE(9164), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [410314] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11688), 1,
      anon_sym_EQ_GT,
    STATE(9165), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [410355] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11690), 1,
      anon_sym_RPAREN,
    STATE(9166), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [410396] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11692), 1,
      anon_sym_EQ_GT,
    STATE(9167), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [410437] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11694), 1,
      sym__optional_semi,
    STATE(9168), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [410478] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11696), 1,
      anon_sym_RPAREN,
    STATE(9169), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [410519] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11698), 1,
      anon_sym_EQ_GT,
    STATE(9170), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [410560] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11700), 1,
      anon_sym_EQ_GT,
    STATE(9171), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [410601] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11702), 1,
      anon_sym_EQ_GT,
    STATE(9172), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [410642] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11704), 1,
      anon_sym_EQ_GT,
    STATE(9173), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [410683] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11706), 1,
      anon_sym_EQ_GT,
    STATE(9174), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [410724] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11708), 1,
      anon_sym_EQ_GT,
    STATE(9175), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [410765] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11710), 1,
      sym__optional_semi,
    STATE(9176), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [410806] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11712), 1,
      sym__optional_semi,
    STATE(9177), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [410847] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11714), 1,
      anon_sym_EQ_GT,
    STATE(9178), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [410888] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11716), 1,
      anon_sym_EQ_GT,
    STATE(9179), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [410929] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11718), 1,
      anon_sym_RPAREN,
    STATE(9180), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [410970] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11720), 1,
      anon_sym_EQ_GT,
    STATE(9181), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [411011] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11722), 1,
      anon_sym_EQ_GT,
    STATE(9182), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [411052] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11724), 1,
      anon_sym_EQ_GT,
    STATE(9183), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [411093] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11726), 1,
      anon_sym_RPAREN,
    STATE(9184), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [411134] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11728), 1,
      anon_sym_EQ_GT,
    STATE(9185), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [411175] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11730), 1,
      anon_sym_EQ_GT,
    STATE(9186), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [411216] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11732), 1,
      sym__optional_semi,
    STATE(9187), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [411257] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11734), 1,
      sym__optional_semi,
    STATE(9188), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [411298] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11736), 1,
      anon_sym_RBRACK,
    STATE(9189), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [411339] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11738), 1,
      anon_sym_EQ_GT,
    STATE(9190), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [411380] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11740), 1,
      anon_sym_EQ_GT,
    STATE(9191), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [411421] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11742), 1,
      anon_sym_EQ_GT,
    STATE(9192), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [411462] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11744), 1,
      anon_sym_EQ_GT,
    STATE(9193), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [411503] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11746), 1,
      anon_sym_EQ_GT,
    STATE(9194), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [411544] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11748), 1,
      sym__optional_semi,
    STATE(9195), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [411585] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11750), 1,
      anon_sym_EQ_GT,
    STATE(9196), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [411626] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11752), 1,
      anon_sym_EQ_GT,
    STATE(9197), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [411667] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11754), 1,
      anon_sym_EQ_GT,
    STATE(9198), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [411708] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11756), 1,
      anon_sym_EQ_GT,
    STATE(9199), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [411749] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11758), 1,
      anon_sym_EQ_GT,
    STATE(9200), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [411790] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11760), 1,
      anon_sym_EQ_GT,
    STATE(9201), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [411831] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11762), 1,
      aux_sym_preproc_if_token3,
    STATE(9202), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [411872] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11764), 1,
      anon_sym_EQ_GT,
    STATE(9203), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [411913] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11766), 1,
      anon_sym_EQ_GT,
    STATE(9204), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [411954] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11768), 1,
      anon_sym_EQ_GT,
    STATE(9205), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [411995] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11770), 1,
      anon_sym_EQ_GT,
    STATE(9206), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [412036] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11772), 1,
      anon_sym_EQ_GT,
    STATE(9207), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [412077] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11774), 1,
      anon_sym_EQ_GT,
    STATE(9208), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [412118] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11776), 1,
      sym__optional_semi,
    STATE(9209), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [412159] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11778), 1,
      anon_sym_EQ_GT,
    STATE(9210), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [412200] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11780), 1,
      sym__optional_semi,
    STATE(9211), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [412241] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11782), 1,
      sym__optional_semi,
    STATE(9212), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [412282] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10989), 1,
      anon_sym_RBRACE,
    STATE(9213), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [412323] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11784), 1,
      anon_sym_EQ_GT,
    STATE(9214), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [412364] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11786), 1,
      anon_sym_EQ_GT,
    STATE(9215), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [412405] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11788), 1,
      anon_sym_EQ_GT,
    STATE(9216), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [412446] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11790), 1,
      anon_sym_RPAREN,
    STATE(9217), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [412487] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11792), 1,
      anon_sym_EQ_GT,
    STATE(9218), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [412528] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11794), 1,
      anon_sym_EQ_GT,
    STATE(9219), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [412569] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11796), 1,
      sym__optional_semi,
    STATE(9220), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [412610] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11798), 1,
      anon_sym_EQ_GT,
    STATE(9221), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [412651] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11800), 1,
      anon_sym_SEMI,
    STATE(9222), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [412692] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11802), 1,
      anon_sym_EQ_GT,
    STATE(9223), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [412733] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11804), 1,
      anon_sym_RPAREN,
    STATE(9224), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [412774] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11806), 1,
      sym__optional_semi,
    STATE(9225), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [412815] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11808), 1,
      anon_sym_EQ_GT,
    STATE(9226), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [412856] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11810), 1,
      anon_sym_EQ_GT,
    STATE(9227), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [412897] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11812), 1,
      sym__optional_semi,
    STATE(9228), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [412938] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11814), 1,
      anon_sym_EQ_GT,
    STATE(9229), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [412979] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11816), 1,
      sym__optional_semi,
    STATE(9230), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [413020] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11818), 1,
      anon_sym_EQ_GT,
    STATE(9231), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [413061] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11820), 1,
      sym__optional_semi,
    STATE(9232), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [413102] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11822), 1,
      anon_sym_EQ_GT,
    STATE(9233), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [413143] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11824), 1,
      anon_sym_EQ_GT,
    STATE(9234), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [413184] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11826), 1,
      sym__optional_semi,
    STATE(9235), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [413225] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11828), 1,
      anon_sym_EQ_GT,
    STATE(9236), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [413266] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11830), 1,
      anon_sym_EQ_GT,
    STATE(9237), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [413307] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11832), 1,
      anon_sym_EQ_GT,
    STATE(9238), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [413348] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11834), 1,
      sym__optional_semi,
    STATE(9239), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [413389] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11836), 1,
      sym__optional_semi,
    STATE(9240), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [413430] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11838), 1,
      anon_sym_EQ_GT,
    STATE(9241), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [413471] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11840), 1,
      anon_sym_SQUOTE,
    STATE(9242), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [413512] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11842), 1,
      sym__optional_semi,
    STATE(9243), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [413553] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11844), 1,
      sym__optional_semi,
    STATE(9244), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [413594] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11846), 1,
      sym__optional_semi,
    STATE(9245), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [413635] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11848), 1,
      anon_sym_EQ_GT,
    STATE(9246), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [413676] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11850), 1,
      anon_sym_EQ_GT,
    STATE(9247), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [413717] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11852), 1,
      sym__optional_semi,
    STATE(9248), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [413758] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11854), 1,
      anon_sym_EQ_GT,
    STATE(9249), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [413799] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11856), 1,
      anon_sym_EQ_GT,
    STATE(9250), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [413840] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11858), 1,
      anon_sym_EQ_GT,
    STATE(9251), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [413881] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11860), 1,
      sym__optional_semi,
    STATE(9252), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [413922] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11862), 1,
      anon_sym_EQ_GT,
    STATE(9253), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [413963] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11864), 1,
      anon_sym_EQ_GT,
    STATE(9254), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [414004] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11866), 1,
      sym__optional_semi,
    STATE(9255), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [414045] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11868), 1,
      anon_sym_EQ_GT,
    STATE(9256), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [414086] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11870), 1,
      anon_sym_EQ_GT,
    STATE(9257), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [414127] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11872), 1,
      anon_sym_EQ_GT,
    STATE(9258), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [414168] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11874), 1,
      anon_sym_EQ_GT,
    STATE(9259), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [414209] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11876), 1,
      anon_sym_EQ_GT,
    STATE(9260), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [414250] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11878), 1,
      sym__optional_semi,
    STATE(9261), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [414291] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11880), 1,
      anon_sym_EQ_GT,
    STATE(9262), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [414332] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11882), 1,
      anon_sym_COLON,
    STATE(9263), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [414373] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11884), 1,
      anon_sym_EQ_GT,
    STATE(9264), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [414414] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11886), 1,
      anon_sym_EQ_GT,
    STATE(9265), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [414455] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11888), 1,
      anon_sym_SEMI,
    STATE(9266), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [414496] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11890), 1,
      anon_sym_EQ_GT,
    STATE(9267), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [414537] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11892), 1,
      anon_sym_EQ_GT,
    STATE(9268), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [414578] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10754), 1,
      anon_sym_RBRACE,
    STATE(9269), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [414619] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11894), 1,
      sym__optional_semi,
    STATE(9270), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [414660] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11896), 1,
      sym__optional_semi,
    STATE(9271), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [414701] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11898), 1,
      anon_sym_EQ_GT,
    STATE(9272), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [414742] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11900), 1,
      sym__optional_semi,
    STATE(9273), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [414783] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8851), 1,
      anon_sym_RPAREN,
    STATE(9274), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [414824] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11902), 1,
      anon_sym_EQ_GT,
    STATE(9275), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [414865] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11904), 1,
      sym__optional_semi,
    STATE(9276), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [414906] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11906), 1,
      sym__optional_semi,
    STATE(9277), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [414947] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11908), 1,
      anon_sym_SEMI,
    STATE(9278), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [414988] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11910), 1,
      sym__optional_semi,
    STATE(9279), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [415029] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11912), 1,
      sym__optional_semi,
    STATE(9280), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [415070] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11914), 1,
      anon_sym_EQ_GT,
    STATE(9281), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [415111] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11916), 1,
      anon_sym_EQ_GT,
    STATE(9282), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [415152] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11918), 1,
      anon_sym_EQ_GT,
    STATE(9283), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [415193] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11920), 1,
      sym__optional_semi,
    STATE(9284), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [415234] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11922), 1,
      anon_sym_EQ_GT,
    STATE(9285), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [415275] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11924), 1,
      anon_sym_EQ_GT,
    STATE(9286), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [415316] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11926), 1,
      sym__optional_semi,
    STATE(9287), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [415357] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11928), 1,
      sym__optional_semi,
    STATE(9288), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [415398] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11930), 1,
      anon_sym_EQ_GT,
    STATE(9289), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [415439] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11932), 1,
      anon_sym_EQ_GT,
    STATE(9290), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [415480] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11934), 1,
      sym__optional_semi,
    STATE(9291), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [415521] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11936), 1,
      sym__optional_semi,
    STATE(9292), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [415562] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11938), 1,
      anon_sym_EQ_GT,
    STATE(9293), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [415603] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11940), 1,
      anon_sym_EQ_GT,
    STATE(9294), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [415644] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11942), 1,
      anon_sym_EQ_GT,
    STATE(9295), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [415685] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10942), 1,
      anon_sym_RBRACE,
    STATE(9296), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [415726] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11944), 1,
      sym__optional_semi,
    STATE(9297), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [415767] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11946), 1,
      anon_sym_EQ_GT,
    STATE(9298), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [415808] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11948), 1,
      sym__optional_semi,
    STATE(9299), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [415849] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11950), 1,
      anon_sym_EQ_GT,
    STATE(9300), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [415890] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11952), 1,
      sym__optional_semi,
    STATE(9301), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [415931] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11954), 1,
      sym__optional_semi,
    STATE(9302), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [415972] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11956), 1,
      sym__optional_semi,
    STATE(9303), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [416013] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11958), 1,
      anon_sym_EQ_GT,
    STATE(9304), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [416054] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11960), 1,
      anon_sym_EQ_GT,
    STATE(9305), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [416095] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11962), 1,
      anon_sym_EQ_GT,
    STATE(9306), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [416136] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11964), 1,
      anon_sym_EQ_GT,
    STATE(9307), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [416177] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11966), 1,
      sym__optional_semi,
    STATE(9308), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [416218] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11968), 1,
      sym__optional_semi,
    STATE(9309), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [416259] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11970), 1,
      sym__optional_semi,
    STATE(9310), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [416300] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11972), 1,
      anon_sym_EQ_GT,
    STATE(9311), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [416341] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11974), 1,
      anon_sym_EQ_GT,
    STATE(9312), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [416382] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11976), 1,
      anon_sym_EQ_GT,
    STATE(9313), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [416423] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11978), 1,
      anon_sym_EQ_GT,
    STATE(9314), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [416464] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11980), 1,
      sym__optional_semi,
    STATE(9315), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [416505] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11982), 1,
      sym__optional_semi,
    STATE(9316), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [416546] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11984), 1,
      sym__optional_semi,
    STATE(9317), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [416587] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11986), 1,
      anon_sym_SQUOTE,
    STATE(9318), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [416628] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11988), 1,
      anon_sym_EQ_GT,
    STATE(9319), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [416669] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11990), 1,
      sym__optional_semi,
    STATE(9320), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [416710] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11992), 1,
      sym__optional_semi,
    STATE(9321), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [416751] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11994), 1,
      anon_sym_EQ_GT,
    STATE(9322), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [416792] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11996), 1,
      anon_sym_EQ_GT,
    STATE(9323), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [416833] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11998), 1,
      anon_sym_EQ_GT,
    STATE(9324), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [416874] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12000), 1,
      sym__optional_semi,
    STATE(9325), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [416915] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12002), 1,
      sym__optional_semi,
    STATE(9326), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [416956] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12004), 1,
      anon_sym_EQ_GT,
    STATE(9327), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [416997] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12006), 1,
      sym__optional_semi,
    STATE(9328), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [417038] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12008), 1,
      anon_sym_EQ_GT,
    STATE(9329), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [417079] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12010), 1,
      anon_sym_SEMI,
    STATE(9330), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [417120] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12012), 1,
      sym__optional_semi,
    STATE(9331), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [417161] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12014), 1,
      anon_sym_EQ_GT,
    STATE(9332), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [417202] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12016), 1,
      sym__optional_semi,
    STATE(9333), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [417243] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12018), 1,
      sym__optional_semi,
    STATE(9334), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [417284] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12020), 1,
      sym_integer_literal,
    STATE(9335), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [417325] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12022), 1,
      sym__optional_semi,
    STATE(9336), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [417366] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12024), 1,
      anon_sym_EQ_GT,
    STATE(9337), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [417407] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12026), 1,
      anon_sym_LBRACE,
    STATE(9338), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [417448] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12028), 1,
      anon_sym_EQ_GT,
    STATE(9339), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [417489] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12030), 1,
      anon_sym_EQ_GT,
    STATE(9340), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [417530] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7984), 1,
      anon_sym_RBRACE,
    STATE(9341), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [417571] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12032), 1,
      anon_sym_EQ_GT,
    STATE(9342), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [417612] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12034), 1,
      sym__optional_semi,
    STATE(9343), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [417653] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12036), 1,
      anon_sym_GT,
    STATE(9344), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [417694] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12038), 1,
      anon_sym_LBRACE,
    STATE(9345), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [417735] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12040), 1,
      sym__optional_semi,
    STATE(9346), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [417776] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12042), 1,
      anon_sym_EQ_GT,
    STATE(9347), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [417817] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12044), 1,
      anon_sym_EQ_GT,
    STATE(9348), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [417858] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12046), 1,
      sym__optional_semi,
    STATE(9349), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [417899] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12048), 1,
      anon_sym_COMMA,
    STATE(9350), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [417940] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12050), 1,
      anon_sym_COMMA,
    STATE(9351), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [417981] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12052), 1,
      anon_sym_EQ_GT,
    STATE(9352), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [418022] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12054), 1,
      sym__optional_semi,
    STATE(9353), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [418063] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12056), 1,
      sym__optional_semi,
    STATE(9354), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [418104] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12058), 1,
      anon_sym_EQ_GT,
    STATE(9355), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [418145] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12060), 1,
      anon_sym_EQ_GT,
    STATE(9356), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [418186] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12062), 1,
      anon_sym_EQ_GT,
    STATE(9357), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [418227] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12064), 1,
      sym__optional_semi,
    STATE(9358), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [418268] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12066), 1,
      anon_sym_EQ_GT,
    STATE(9359), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [418309] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12068), 1,
      sym__optional_semi,
    STATE(9360), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [418350] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12070), 1,
      anon_sym_EQ_GT,
    STATE(9361), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [418391] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12072), 1,
      sym__optional_semi,
    STATE(9362), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [418432] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12074), 1,
      anon_sym_EQ_GT,
    STATE(9363), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [418473] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12076), 1,
      sym__optional_semi,
    STATE(9364), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [418514] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12078), 1,
      anon_sym_SEMI,
    STATE(9365), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [418555] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12080), 1,
      anon_sym_SEMI,
    STATE(9366), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [418596] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12082), 1,
      sym__optional_semi,
    STATE(9367), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [418637] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12084), 1,
      sym__optional_semi,
    STATE(9368), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [418678] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12086), 1,
      anon_sym_SEMI,
    STATE(9369), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [418719] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12088), 1,
      sym__optional_semi,
    STATE(9370), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [418760] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12090), 1,
      sym__optional_semi,
    STATE(9371), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [418801] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12092), 1,
      sym__optional_semi,
    STATE(9372), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [418842] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12094), 1,
      anon_sym_SEMI,
    STATE(9373), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [418883] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12096), 1,
      anon_sym_EQ_GT,
    STATE(9374), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [418924] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12098), 1,
      anon_sym_RBRACK,
    STATE(9375), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [418965] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12100), 1,
      sym__optional_semi,
    STATE(9376), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [419006] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12102), 1,
      sym__optional_semi,
    STATE(9377), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [419047] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12104), 1,
      sym__optional_semi,
    STATE(9378), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [419088] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12106), 1,
      sym__optional_semi,
    STATE(9379), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [419129] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12108), 1,
      anon_sym_COMMA,
    STATE(9380), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [419170] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12110), 1,
      aux_sym_preproc_if_token3,
    STATE(9381), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [419211] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12112), 1,
      anon_sym_COLON,
    STATE(9382), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [419252] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12114), 1,
      anon_sym_LPAREN,
    STATE(9383), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [419293] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12116), 1,
      anon_sym_EQ_GT,
    STATE(9384), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [419334] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12118), 1,
      anon_sym_EQ_GT,
    STATE(9385), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [419375] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12120), 1,
      anon_sym_STAR,
    STATE(9386), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [419416] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12122), 1,
      sym__optional_semi,
    STATE(9387), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [419457] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9035), 1,
      anon_sym_RPAREN,
    STATE(9388), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [419498] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12124), 1,
      sym__optional_semi,
    STATE(9389), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [419539] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12126), 1,
      anon_sym_EQ_GT,
    STATE(9390), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [419580] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10782), 1,
      anon_sym_RBRACE,
    STATE(9391), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [419621] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12128), 1,
      anon_sym_SEMI,
    STATE(9392), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [419662] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11252), 1,
      anon_sym_in,
    STATE(9393), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [419703] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12130), 1,
      anon_sym_SEMI,
    STATE(9394), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [419744] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12132), 1,
      anon_sym_EQ_GT,
    STATE(9395), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [419785] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12134), 1,
      sym__optional_semi,
    STATE(9396), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [419826] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12136), 1,
      anon_sym_EQ_GT,
    STATE(9397), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [419867] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12138), 1,
      anon_sym_LPAREN,
    STATE(9398), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [419908] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12140), 1,
      anon_sym_EQ_GT,
    STATE(9399), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [419949] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12142), 1,
      sym__optional_semi,
    STATE(9400), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [419990] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12144), 1,
      sym__optional_semi,
    STATE(9401), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [420031] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12146), 1,
      sym__optional_semi,
    STATE(9402), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [420072] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12148), 1,
      anon_sym_SEMI,
    STATE(9403), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [420113] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12150), 1,
      anon_sym_while,
    STATE(9404), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [420154] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12152), 1,
      sym__optional_semi,
    STATE(9405), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [420195] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12154), 1,
      sym__optional_semi,
    STATE(9406), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [420236] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12156), 1,
      sym__optional_semi,
    STATE(9407), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [420277] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12158), 1,
      sym__optional_semi,
    STATE(9408), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [420318] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12160), 1,
      anon_sym_EQ_GT,
    STATE(9409), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [420359] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12162), 1,
      anon_sym_SEMI,
    STATE(9410), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [420400] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12164), 1,
      anon_sym_LPAREN,
    STATE(9411), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [420441] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12166), 1,
      anon_sym_LPAREN,
    STATE(9412), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [420482] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12168), 1,
      anon_sym_LPAREN,
    STATE(9413), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [420523] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12170), 1,
      aux_sym_preproc_if_token3,
    STATE(9414), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [420564] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12172), 1,
      anon_sym_LPAREN,
    STATE(9415), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [420605] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12174), 1,
      anon_sym_LPAREN,
    STATE(9416), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [420646] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12176), 1,
      anon_sym_LPAREN,
    STATE(9417), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [420687] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12178), 1,
      anon_sym_LPAREN,
    STATE(9418), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [420728] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12180), 1,
      aux_sym_preproc_if_token3,
    STATE(9419), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [420769] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12182), 1,
      anon_sym_EQ_GT,
    STATE(9420), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [420810] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12184), 1,
      sym__optional_semi,
    STATE(9421), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [420851] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12186), 1,
      anon_sym_SEMI,
    STATE(9422), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [420892] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12188), 1,
      sym__optional_semi,
    STATE(9423), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [420933] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12190), 1,
      aux_sym_preproc_if_token3,
    STATE(9424), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [420974] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12192), 1,
      anon_sym_COLON,
    STATE(9425), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [421015] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12194), 1,
      aux_sym_preproc_if_token3,
    STATE(9426), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [421056] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12196), 1,
      anon_sym_LPAREN,
    STATE(9427), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [421097] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12198), 1,
      sym__optional_semi,
    STATE(9428), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [421138] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12200), 1,
      sym__optional_semi,
    STATE(9429), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [421179] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12202), 1,
      aux_sym_preproc_if_token3,
    STATE(9430), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [421220] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12204), 1,
      anon_sym_SEMI,
    STATE(9431), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [421261] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12206), 1,
      anon_sym_SEMI,
    STATE(9432), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [421302] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12208), 1,
      anon_sym_SEMI,
    STATE(9433), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [421343] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12210), 1,
      anon_sym_EQ_GT,
    STATE(9434), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [421384] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12212), 1,
      sym__optional_semi,
    STATE(9435), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [421425] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12214), 1,
      aux_sym_preproc_if_token3,
    STATE(9436), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [421466] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12216), 1,
      anon_sym_SEMI,
    STATE(9437), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [421507] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12218), 1,
      anon_sym_EQ_GT,
    STATE(9438), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [421548] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12220), 1,
      anon_sym_STAR,
    STATE(9439), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [421589] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12222), 1,
      anon_sym_EQ_GT,
    STATE(9440), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [421630] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12224), 1,
      anon_sym_EQ_GT,
    STATE(9441), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [421671] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12226), 1,
      sym__optional_semi,
    STATE(9442), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [421712] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4081), 1,
      anon_sym_EQ_GT,
    STATE(9443), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [421753] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12228), 1,
      anon_sym_RBRACE,
    STATE(9444), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [421794] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12230), 1,
      anon_sym_EQ_GT,
    STATE(9445), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [421835] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12232), 1,
      anon_sym_EQ_GT,
    STATE(9446), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [421876] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12234), 1,
      anon_sym_SEMI,
    STATE(9447), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [421917] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12236), 1,
      anon_sym_EQ_GT,
    STATE(9448), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [421958] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12238), 1,
      anon_sym_SEMI,
    STATE(9449), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [421999] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12240), 1,
      sym__optional_semi,
    STATE(9450), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [422040] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12242), 1,
      sym_interpolation_start_quote,
    STATE(9451), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [422081] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12244), 1,
      anon_sym_EQ_GT,
    STATE(9452), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [422122] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8012), 1,
      anon_sym_RBRACE,
    STATE(9453), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [422163] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12246), 1,
      anon_sym_EQ,
    STATE(9454), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [422204] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12248), 1,
      sym__optional_semi,
    STATE(9455), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [422245] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7777), 1,
      anon_sym_RBRACE,
    STATE(9456), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [422286] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12250), 1,
      anon_sym_DQUOTE,
    STATE(9457), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [422327] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12252), 1,
      anon_sym_SEMI,
    STATE(9458), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [422368] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12254), 1,
      anon_sym_DQUOTE,
    STATE(9459), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [422409] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12256), 1,
      sym__optional_semi,
    STATE(9460), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [422450] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12258), 1,
      anon_sym_EQ_GT,
    STATE(9461), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [422491] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12260), 1,
      sym_interpolation_close_brace,
    STATE(9462), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [422532] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12262), 1,
      sym__optional_semi,
    STATE(9463), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [422573] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12264), 1,
      anon_sym_SEMI,
    STATE(9464), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [422614] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10718), 1,
      anon_sym_RBRACE,
    STATE(9465), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [422655] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12266), 1,
      anon_sym_EQ_GT,
    STATE(9466), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [422696] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12268), 1,
      sym__optional_semi,
    STATE(9467), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [422737] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12270), 1,
      sym__optional_semi,
    STATE(9468), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [422778] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12272), 1,
      sym__optional_semi,
    STATE(9469), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [422819] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12274), 1,
      sym__optional_semi,
    STATE(9470), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [422860] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12276), 1,
      anon_sym_SEMI,
    STATE(9471), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [422901] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12278), 1,
      anon_sym_RPAREN,
    STATE(9472), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [422942] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12280), 1,
      anon_sym_LT,
    STATE(9473), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [422983] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7992), 1,
      anon_sym_SEMI,
    STATE(9474), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [423024] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12282), 1,
      sym__optional_semi,
    STATE(9475), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [423065] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12284), 1,
      sym__optional_semi,
    STATE(9476), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [423106] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12286), 1,
      anon_sym_SQUOTE,
    STATE(9477), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [423147] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12288), 1,
      anon_sym_EQ_GT,
    STATE(9478), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [423188] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12290), 1,
      anon_sym_RPAREN,
    STATE(9479), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [423229] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12292), 1,
      anon_sym_LPAREN,
    STATE(9480), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [423270] = 11,
    ACTIONS(9485), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9487), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9489), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9491), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9493), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9495), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9497), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9499), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9501), 1,
      sym_comment,
    ACTIONS(10698), 1,
      aux_sym_preproc_if_token2,
    STATE(9481), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [423311] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12294), 1,
      anon_sym_EQ_GT,
    STATE(9482), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [423352] = 11,
    ACTIONS(9485), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9487), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9489), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9491), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9493), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9495), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9497), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9499), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9501), 1,
      sym_comment,
    ACTIONS(12296), 1,
      aux_sym_interpolation_format_clause_token1,
    STATE(9483), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [423393] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12298), 1,
      sym__optional_semi,
    STATE(9484), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [423434] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10690), 1,
      sym_interpolation_close_brace,
    STATE(9485), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [423475] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12300), 1,
      sym__optional_semi,
    STATE(9486), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [423516] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12302), 1,
      anon_sym_GT,
    STATE(9487), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [423557] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12304), 1,
      anon_sym_SEMI,
    STATE(9488), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [423598] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12306), 1,
      anon_sym_SEMI,
    STATE(9489), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [423639] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12308), 1,
      sym__optional_semi,
    STATE(9490), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [423680] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12310), 1,
      anon_sym_SEMI,
    STATE(9491), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [423721] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12312), 1,
      anon_sym_EQ_GT,
    STATE(9492), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [423762] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8887), 1,
      anon_sym_RPAREN,
    STATE(9493), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [423803] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9907), 1,
      anon_sym_COMMA,
    STATE(9494), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [423844] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12314), 1,
      sym__optional_semi,
    STATE(9495), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [423885] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12316), 1,
      sym__optional_semi,
    STATE(9496), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [423926] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12318), 1,
      anon_sym_SEMI,
    STATE(9497), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [423967] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12320), 1,
      anon_sym_GT,
    STATE(9498), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [424008] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11234), 1,
      anon_sym_in,
    STATE(9499), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [424049] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12322), 1,
      sym__optional_semi,
    STATE(9500), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [424090] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12324), 1,
      anon_sym_GT,
    STATE(9501), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [424131] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12326), 1,
      sym__optional_semi,
    STATE(9502), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [424172] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12328), 1,
      anon_sym_EQ_GT,
    STATE(9503), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [424213] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12330), 1,
      anon_sym_SEMI,
    STATE(9504), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [424254] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12332), 1,
      anon_sym_operator,
    STATE(9505), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [424295] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12334), 1,
      anon_sym_DOT,
    STATE(9506), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [424336] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12336), 1,
      anon_sym_EQ_GT,
    STATE(9507), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [424377] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12338), 1,
      anon_sym_LT,
    STATE(9508), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [424418] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11228), 1,
      anon_sym_in,
    STATE(9509), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [424459] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11232), 1,
      anon_sym_LT,
    STATE(9510), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [424500] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12340), 1,
      anon_sym_SEMI,
    STATE(9511), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [424541] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12342), 1,
      anon_sym_GT,
    STATE(9512), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [424582] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12344), 1,
      sym__optional_semi,
    STATE(9513), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [424623] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12346), 1,
      anon_sym_EQ_GT,
    STATE(9514), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [424664] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8618), 1,
      anon_sym_RPAREN,
    STATE(9515), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [424705] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12348), 1,
      anon_sym_EQ_GT,
    STATE(9516), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [424746] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12350), 1,
      sym__optional_semi,
    STATE(9517), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [424787] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12352), 1,
      sym__optional_semi,
    STATE(9518), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [424828] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12354), 1,
      anon_sym_EQ_GT,
    STATE(9519), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [424869] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12356), 1,
      sym__optional_semi,
    STATE(9520), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [424910] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12358), 1,
      anon_sym_RPAREN,
    STATE(9521), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [424951] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12360), 1,
      sym__optional_semi,
    STATE(9522), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [424992] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12362), 1,
      sym__optional_semi,
    STATE(9523), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [425033] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12364), 1,
      sym__optional_semi,
    STATE(9524), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [425074] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12366), 1,
      sym__optional_semi,
    STATE(9525), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [425115] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12368), 1,
      sym__optional_semi,
    STATE(9526), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [425156] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12370), 1,
      anon_sym_SEMI,
    STATE(9527), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [425197] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12372), 1,
      sym__optional_semi,
    STATE(9528), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [425238] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12374), 1,
      sym__optional_semi,
    STATE(9529), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [425279] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12376), 1,
      sym__optional_semi,
    STATE(9530), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [425320] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10565), 1,
      anon_sym_RBRACE,
    STATE(9531), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [425361] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12378), 1,
      sym__optional_semi,
    STATE(9532), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [425402] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12380), 1,
      anon_sym_EQ_GT,
    STATE(9533), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [425443] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12382), 1,
      sym__optional_semi,
    STATE(9534), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [425484] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12384), 1,
      sym__optional_semi,
    STATE(9535), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [425525] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12386), 1,
      anon_sym_EQ_GT,
    STATE(9536), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [425566] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12388), 1,
      anon_sym_STAR,
    STATE(9537), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [425607] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12390), 1,
      sym__optional_semi,
    STATE(9538), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [425648] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12392), 1,
      sym__optional_semi,
    STATE(9539), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [425689] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12394), 1,
      sym__optional_semi,
    STATE(9540), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [425730] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12396), 1,
      sym__optional_semi,
    STATE(9541), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [425771] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12398), 1,
      anon_sym_COMMA,
    STATE(9542), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [425812] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12400), 1,
      sym__optional_semi,
    STATE(9543), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [425853] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12402), 1,
      anon_sym_GT,
    STATE(9544), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [425894] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12404), 1,
      anon_sym_EQ_GT,
    STATE(9545), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [425935] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12406), 1,
      sym__optional_semi,
    STATE(9546), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [425976] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12408), 1,
      sym__optional_semi,
    STATE(9547), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [426017] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12410), 1,
      anon_sym_EQ_GT,
    STATE(9548), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [426058] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12412), 1,
      anon_sym_RPAREN,
    STATE(9549), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [426099] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12414), 1,
      anon_sym_RPAREN,
    STATE(9550), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [426140] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12416), 1,
      anon_sym_RPAREN,
    STATE(9551), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [426181] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12418), 1,
      sym__optional_semi,
    STATE(9552), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [426222] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12420), 1,
      sym__optional_semi,
    STATE(9553), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [426263] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12422), 1,
      anon_sym_EQ_GT,
    STATE(9554), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [426304] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12424), 1,
      sym__optional_semi,
    STATE(9555), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [426345] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11220), 1,
      anon_sym_in,
    STATE(9556), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [426386] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12426), 1,
      sym__optional_semi,
    STATE(9557), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [426427] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12428), 1,
      anon_sym_RPAREN,
    STATE(9558), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [426468] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12430), 1,
      aux_sym_preproc_if_token3,
    STATE(9559), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [426509] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12432), 1,
      aux_sym_preproc_if_token3,
    STATE(9560), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [426550] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10706), 1,
      anon_sym_LPAREN,
    STATE(9561), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [426591] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12434), 1,
      sym__optional_semi,
    STATE(9562), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [426632] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12436), 1,
      anon_sym_EQ_GT,
    STATE(9563), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [426673] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12438), 1,
      anon_sym_EQ_GT,
    STATE(9564), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [426714] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12440), 1,
      anon_sym_COLON,
    STATE(9565), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [426755] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12442), 1,
      anon_sym_COLON,
    STATE(9566), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [426796] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12444), 1,
      anon_sym_EQ_GT,
    STATE(9567), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [426837] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12446), 1,
      anon_sym_RBRACE,
    STATE(9568), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [426878] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12448), 1,
      anon_sym_GT,
    STATE(9569), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [426919] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12450), 1,
      anon_sym_EQ_GT,
    STATE(9570), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [426960] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12452), 1,
      anon_sym_SEMI,
    STATE(9571), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [427001] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5982), 1,
      anon_sym_STAR,
    STATE(9572), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [427042] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12454), 1,
      anon_sym_EQ_GT,
    STATE(9573), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [427083] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12456), 1,
      anon_sym_EQ_GT,
    STATE(9574), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [427124] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12458), 1,
      anon_sym_EQ_GT,
    STATE(9575), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [427165] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8972), 1,
      anon_sym_RPAREN,
    STATE(9576), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [427206] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12460), 1,
      anon_sym_GT,
    STATE(9577), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [427247] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12462), 1,
      anon_sym_SEMI,
    STATE(9578), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [427288] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12464), 1,
      aux_sym_preproc_if_token3,
    STATE(9579), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [427329] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12466), 1,
      anon_sym_GT,
    STATE(9580), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [427370] = 11,
    ACTIONS(9485), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9487), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9489), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9491), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9493), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9495), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9497), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9499), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9501), 1,
      sym_comment,
    ACTIONS(12468), 1,
      aux_sym_preproc_if_token2,
    STATE(9581), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [427411] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12470), 1,
      anon_sym_EQ_GT,
    STATE(9582), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [427452] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12472), 1,
      aux_sym_preproc_if_token3,
    STATE(9583), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [427493] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10764), 1,
      anon_sym_RBRACE,
    STATE(9584), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [427534] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12474), 1,
      anon_sym_SEMI,
    STATE(9585), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [427575] = 11,
    ACTIONS(9485), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9487), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9489), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9491), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9493), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9495), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9497), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9499), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9501), 1,
      sym_comment,
    ACTIONS(12476), 1,
      aux_sym_preproc_if_token2,
    STATE(9586), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [427616] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12478), 1,
      anon_sym_GT,
    STATE(9587), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [427657] = 11,
    ACTIONS(9485), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9487), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9489), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9491), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9493), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9495), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9497), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9499), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9501), 1,
      sym_comment,
    ACTIONS(12480), 1,
      aux_sym_preproc_if_token2,
    STATE(9588), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [427698] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12482), 1,
      anon_sym_EQ_GT,
    STATE(9589), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [427739] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12484), 1,
      anon_sym_EQ_GT,
    STATE(9590), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [427780] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12486), 1,
      anon_sym_EQ_GT,
    STATE(9591), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [427821] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12488), 1,
      anon_sym_EQ_GT,
    STATE(9592), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [427862] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12490), 1,
      anon_sym_EQ_GT,
    STATE(9593), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [427903] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10505), 1,
      anon_sym_RBRACE,
    STATE(9594), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [427944] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12492), 1,
      anon_sym_EQ_GT,
    STATE(9595), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [427985] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12494), 1,
      anon_sym_EQ_GT,
    STATE(9596), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [428026] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12496), 1,
      anon_sym_EQ_GT,
    STATE(9597), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [428067] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12498), 1,
      sym__optional_semi,
    STATE(9598), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [428108] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12500), 1,
      anon_sym_EQ_GT,
    STATE(9599), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [428149] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12502), 1,
      anon_sym_EQ_GT,
    STATE(9600), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [428190] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12504), 1,
      anon_sym_SEMI,
    STATE(9601), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [428231] = 11,
    ACTIONS(9485), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9487), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9489), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9491), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9493), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9495), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9497), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9499), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9501), 1,
      sym_comment,
    ACTIONS(10534), 1,
      aux_sym_preproc_if_token2,
    STATE(9602), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [428272] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12506), 1,
      sym__optional_semi,
    STATE(9603), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [428313] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12508), 1,
      sym__optional_semi,
    STATE(9604), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [428354] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12510), 1,
      anon_sym_EQ_GT,
    STATE(9605), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [428395] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12512), 1,
      sym__optional_semi,
    STATE(9606), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [428436] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12514), 1,
      sym__optional_semi,
    STATE(9607), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [428477] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12516), 1,
      sym__optional_semi,
    STATE(9608), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [428518] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12518), 1,
      anon_sym_EQ_GT,
    STATE(9609), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [428559] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12520), 1,
      sym__optional_semi,
    STATE(9610), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [428600] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12522), 1,
      sym__optional_semi,
    STATE(9611), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [428641] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12524), 1,
      anon_sym_EQ_GT,
    STATE(9612), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [428682] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12526), 1,
      anon_sym_GT,
    STATE(9613), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [428723] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12528), 1,
      sym__optional_semi,
    STATE(9614), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [428764] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12530), 1,
      sym__optional_semi,
    STATE(9615), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [428805] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12532), 1,
      sym__optional_semi,
    STATE(9616), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [428846] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12534), 1,
      anon_sym_EQ_GT,
    STATE(9617), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [428887] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12536), 1,
      anon_sym_EQ_GT,
    STATE(9618), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [428928] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12538), 1,
      anon_sym_RPAREN,
    STATE(9619), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [428969] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12540), 1,
      sym__optional_semi,
    STATE(9620), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [429010] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12542), 1,
      aux_sym_preproc_if_token3,
    STATE(9621), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [429051] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12544), 1,
      aux_sym_preproc_if_token3,
    STATE(9622), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [429092] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12546), 1,
      sym_integer_literal,
    STATE(9623), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [429133] = 11,
    ACTIONS(9485), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9487), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9489), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9491), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9493), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9495), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9497), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9499), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9501), 1,
      sym_comment,
    ACTIONS(12548), 1,
      aux_sym_preproc_if_token2,
    STATE(9624), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [429174] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12550), 1,
      anon_sym_EQ_GT,
    STATE(9625), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [429215] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12552), 1,
      anon_sym_STAR,
    STATE(9626), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [429256] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12554), 1,
      anon_sym_RPAREN,
    STATE(9627), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [429297] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12556), 1,
      sym__optional_semi,
    STATE(9628), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [429338] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12558), 1,
      sym__optional_semi,
    STATE(9629), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [429379] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12560), 1,
      anon_sym_LPAREN,
    STATE(9630), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [429420] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12562), 1,
      anon_sym_LPAREN,
    STATE(9631), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [429461] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12564), 1,
      anon_sym_LPAREN,
    STATE(9632), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [429502] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12566), 1,
      anon_sym_LPAREN,
    STATE(9633), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [429543] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12568), 1,
      anon_sym_LPAREN,
    STATE(9634), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [429584] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12570), 1,
      anon_sym_LPAREN,
    STATE(9635), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [429625] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12572), 1,
      anon_sym_LPAREN,
    STATE(9636), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [429666] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12574), 1,
      sym__optional_semi,
    STATE(9637), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [429707] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12576), 1,
      aux_sym_preproc_if_token3,
    STATE(9638), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [429748] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12578), 1,
      anon_sym_EQ_GT,
    STATE(9639), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [429789] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12580), 1,
      anon_sym_LPAREN,
    STATE(9640), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [429830] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12582), 1,
      sym__optional_semi,
    STATE(9641), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [429871] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12584), 1,
      aux_sym_preproc_if_token3,
    STATE(9642), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [429912] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12586), 1,
      sym__optional_semi,
    STATE(9643), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [429953] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12588), 1,
      anon_sym_EQ_GT,
    STATE(9644), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [429994] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12590), 1,
      sym__optional_semi,
    STATE(9645), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [430035] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12592), 1,
      sym__optional_semi,
    STATE(9646), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [430076] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12594), 1,
      anon_sym_LPAREN,
    STATE(9647), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [430117] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12596), 1,
      anon_sym_SQUOTE,
    STATE(9648), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [430158] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12598), 1,
      sym__optional_semi,
    STATE(9649), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [430199] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12600), 1,
      anon_sym_STAR,
    STATE(9650), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [430240] = 11,
    ACTIONS(9485), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9487), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9489), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9491), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9493), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9495), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9497), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9499), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9501), 1,
      sym_comment,
    ACTIONS(12602), 1,
      aux_sym_preproc_if_token2,
    STATE(9651), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [430281] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12604), 1,
      anon_sym_LPAREN,
    STATE(9652), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [430322] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12606), 1,
      anon_sym_SEMI,
    STATE(9653), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [430363] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12608), 1,
      anon_sym_EQ_GT,
    STATE(9654), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [430404] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12610), 1,
      anon_sym_GT,
    STATE(9655), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [430445] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12612), 1,
      anon_sym_SEMI,
    STATE(9656), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [430486] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12614), 1,
      aux_sym_preproc_if_token3,
    STATE(9657), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [430527] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12616), 1,
      sym__optional_semi,
    STATE(9658), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [430568] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12618), 1,
      anon_sym_while,
    STATE(9659), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [430609] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12620), 1,
      sym_interpolation_close_brace,
    STATE(9660), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [430650] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12622), 1,
      anon_sym_DASH,
    STATE(9661), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [430691] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12624), 1,
      anon_sym_SEMI,
    STATE(9662), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [430732] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12626), 1,
      aux_sym_preproc_if_token3,
    STATE(9663), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [430773] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12628), 1,
      anon_sym_LPAREN,
    STATE(9664), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [430814] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12630), 1,
      anon_sym_LT,
    STATE(9665), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [430855] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8143), 1,
      anon_sym_SEMI,
    STATE(9666), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [430896] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8172), 1,
      anon_sym_RBRACE,
    STATE(9667), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [430937] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12632), 1,
      anon_sym_LPAREN,
    STATE(9668), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [430978] = 11,
    ACTIONS(9485), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9487), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9489), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9491), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9493), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9495), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9497), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9499), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9501), 1,
      sym_comment,
    ACTIONS(12634), 1,
      aux_sym_preproc_if_token2,
    STATE(9669), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [431019] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12636), 1,
      sym__optional_semi,
    STATE(9670), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [431060] = 11,
    ACTIONS(9485), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9487), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9489), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9491), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9493), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9495), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9497), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9499), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9501), 1,
      sym_comment,
    ACTIONS(12638), 1,
      aux_sym_preproc_if_token2,
    STATE(9671), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [431101] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12640), 1,
      anon_sym_LPAREN,
    STATE(9672), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [431142] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12642), 1,
      sym_integer_literal,
    STATE(9673), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [431183] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12644), 1,
      sym__optional_semi,
    STATE(9674), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [431224] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12646), 1,
      sym__optional_semi,
    STATE(9675), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [431265] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12648), 1,
      sym__optional_semi,
    STATE(9676), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [431306] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12650), 1,
      sym__optional_semi,
    STATE(9677), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [431347] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12652), 1,
      anon_sym_while,
    STATE(9678), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [431388] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12654), 1,
      sym__optional_semi,
    STATE(9679), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [431429] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12656), 1,
      sym__optional_semi,
    STATE(9680), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [431470] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12658), 1,
      anon_sym_SEMI,
    STATE(9681), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [431511] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12660), 1,
      anon_sym_EQ_GT,
    STATE(9682), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [431552] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11196), 1,
      anon_sym_in,
    STATE(9683), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [431593] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12662), 1,
      anon_sym_SEMI,
    STATE(9684), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [431634] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12664), 1,
      anon_sym_SEMI,
    STATE(9685), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [431675] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12666), 1,
      anon_sym_operator,
    STATE(9686), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [431716] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12668), 1,
      anon_sym_GT,
    STATE(9687), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [431757] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11194), 1,
      anon_sym_in,
    STATE(9688), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [431798] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12670), 1,
      anon_sym_LBRACE,
    STATE(9689), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [431839] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12672), 1,
      anon_sym_LBRACE,
    STATE(9690), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [431880] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12674), 1,
      anon_sym_EQ_GT,
    STATE(9691), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [431921] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12676), 1,
      anon_sym_EQ_GT,
    STATE(9692), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [431962] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12678), 1,
      anon_sym_EQ_GT,
    STATE(9693), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [432003] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12680), 1,
      anon_sym_COMMA,
    STATE(9694), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [432044] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12682), 1,
      anon_sym_LPAREN,
    STATE(9695), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [432085] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12684), 1,
      anon_sym_LPAREN,
    STATE(9696), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [432126] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12686), 1,
      anon_sym_RPAREN,
    STATE(9697), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [432167] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12688), 1,
      anon_sym_GT,
    STATE(9698), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [432208] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12690), 1,
      anon_sym_EQ_GT,
    STATE(9699), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [432249] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12692), 1,
      anon_sym_SEMI,
    STATE(9700), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [432290] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12694), 1,
      anon_sym_LPAREN,
    STATE(9701), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [432331] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12696), 1,
      anon_sym_LPAREN,
    STATE(9702), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [432372] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12698), 1,
      anon_sym_LPAREN,
    STATE(9703), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [432413] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12700), 1,
      anon_sym_LPAREN,
    STATE(9704), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [432454] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12702), 1,
      anon_sym_LPAREN,
    STATE(9705), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [432495] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12704), 1,
      anon_sym_LPAREN,
    STATE(9706), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [432536] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12706), 1,
      anon_sym_LPAREN,
    STATE(9707), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [432577] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12708), 1,
      anon_sym_LPAREN,
    STATE(9708), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [432618] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10726), 1,
      anon_sym_RBRACE,
    STATE(9709), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [432659] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12710), 1,
      aux_sym_preproc_if_token3,
    STATE(9710), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [432700] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12712), 1,
      sym__optional_semi,
    STATE(9711), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [432741] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12714), 1,
      anon_sym_LPAREN,
    STATE(9712), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [432782] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12716), 1,
      anon_sym_GT,
    STATE(9713), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [432823] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12718), 1,
      anon_sym_EQ_GT,
    STATE(9714), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [432864] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12720), 1,
      anon_sym_RBRACK,
    STATE(9715), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [432905] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12722), 1,
      sym_interpolation_close_brace,
    STATE(9716), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [432946] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12724), 1,
      anon_sym_EQ_GT,
    STATE(9717), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [432987] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12726), 1,
      sym__optional_semi,
    STATE(9718), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [433028] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12728), 1,
      anon_sym_EQ_GT,
    STATE(9719), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [433069] = 11,
    ACTIONS(9485), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9487), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9489), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9491), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9493), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9495), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9497), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9499), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9501), 1,
      sym_comment,
    ACTIONS(12730), 1,
      aux_sym_preproc_if_token2,
    STATE(9720), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [433110] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12732), 1,
      anon_sym_STAR,
    STATE(9721), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [433151] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12734), 1,
      anon_sym_EQ_GT,
    STATE(9722), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [433192] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12736), 1,
      anon_sym_EQ_GT,
    STATE(9723), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [433233] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12738), 1,
      sym__optional_semi,
    STATE(9724), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [433274] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12740), 1,
      anon_sym_LPAREN,
    STATE(9725), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [433315] = 11,
    ACTIONS(9485), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9487), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9489), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9491), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9493), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9495), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9497), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9499), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9501), 1,
      sym_comment,
    ACTIONS(12742), 1,
      aux_sym_preproc_if_token2,
    STATE(9726), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [433356] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12744), 1,
      anon_sym_LT,
    STATE(9727), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [433397] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8153), 1,
      anon_sym_SEMI,
    STATE(9728), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [433438] = 11,
    ACTIONS(5556), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(9485), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9487), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9489), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9491), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9493), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9495), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9497), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9499), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9501), 1,
      sym_comment,
    STATE(9729), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [433479] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12746), 1,
      anon_sym_EQ_GT,
    STATE(9730), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [433520] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10758), 1,
      anon_sym_RBRACE,
    STATE(9731), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [433561] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12748), 1,
      sym__optional_semi,
    STATE(9732), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [433602] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12750), 1,
      anon_sym_EQ_GT,
    STATE(9733), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [433643] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12752), 1,
      sym__optional_semi,
    STATE(9734), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [433684] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12754), 1,
      anon_sym_EQ_GT,
    STATE(9735), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [433725] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12756), 1,
      sym__optional_semi,
    STATE(9736), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [433766] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11184), 1,
      anon_sym_in,
    STATE(9737), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [433807] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12758), 1,
      anon_sym_EQ_GT,
    STATE(9738), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [433848] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11182), 1,
      anon_sym_in,
    STATE(9739), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [433889] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12760), 1,
      anon_sym_operator,
    STATE(9740), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [433930] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12762), 1,
      sym__optional_semi,
    STATE(9741), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [433971] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12764), 1,
      sym__optional_semi,
    STATE(9742), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [434012] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12766), 1,
      sym__optional_semi,
    STATE(9743), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [434053] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12768), 1,
      anon_sym_EQ_GT,
    STATE(9744), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [434094] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12770), 1,
      sym__optional_semi,
    STATE(9745), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [434135] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12772), 1,
      sym__optional_semi,
    STATE(9746), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [434176] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12774), 1,
      anon_sym_LT,
    STATE(9747), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [434217] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12776), 1,
      anon_sym_GT,
    STATE(9748), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [434258] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12778), 1,
      sym__optional_semi,
    STATE(9749), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [434299] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12780), 1,
      anon_sym_EQ_GT,
    STATE(9750), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [434340] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12782), 1,
      anon_sym_LPAREN,
    STATE(9751), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [434381] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12784), 1,
      anon_sym_LPAREN,
    STATE(9752), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [434422] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12786), 1,
      anon_sym_LPAREN,
    STATE(9753), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [434463] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12788), 1,
      anon_sym_LPAREN,
    STATE(9754), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [434504] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12790), 1,
      anon_sym_SQUOTE,
    STATE(9755), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [434545] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12792), 1,
      sym__optional_semi,
    STATE(9756), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [434586] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12794), 1,
      anon_sym_LPAREN,
    STATE(9757), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [434627] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12796), 1,
      anon_sym_EQ_GT,
    STATE(9758), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [434668] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8157), 1,
      anon_sym_RBRACE,
    STATE(9759), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [434709] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12798), 1,
      sym__optional_semi,
    STATE(9760), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [434750] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12800), 1,
      sym__optional_semi,
    STATE(9761), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [434791] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12802), 1,
      anon_sym_EQ_GT,
    STATE(9762), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [434832] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12804), 1,
      anon_sym_STAR,
    STATE(9763), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [434873] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12806), 1,
      anon_sym_SEMI,
    STATE(9764), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [434914] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12808), 1,
      anon_sym_EQ_GT,
    STATE(9765), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [434955] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12810), 1,
      anon_sym_SEMI,
    STATE(9766), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [434996] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12812), 1,
      sym__optional_semi,
    STATE(9767), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [435037] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12814), 1,
      anon_sym_SEMI,
    STATE(9768), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [435078] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12816), 1,
      anon_sym_LT,
    STATE(9769), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [435119] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12818), 1,
      sym__optional_semi,
    STATE(9770), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [435160] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12820), 1,
      anon_sym_EQ_GT,
    STATE(9771), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [435201] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12822), 1,
      anon_sym_COLON,
    STATE(9772), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [435242] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12824), 1,
      sym__optional_semi,
    STATE(9773), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [435283] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12826), 1,
      sym__optional_semi,
    STATE(9774), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [435324] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12828), 1,
      anon_sym_EQ_GT,
    STATE(9775), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [435365] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12830), 1,
      anon_sym_EQ_GT,
    STATE(9776), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [435406] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12832), 1,
      sym__optional_semi,
    STATE(9777), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [435447] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12834), 1,
      anon_sym_EQ_GT,
    STATE(9778), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [435488] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12836), 1,
      anon_sym_LPAREN,
    STATE(9779), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [435529] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12838), 1,
      anon_sym_LPAREN,
    STATE(9780), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [435570] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12840), 1,
      anon_sym_EQ_GT,
    STATE(9781), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [435611] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12842), 1,
      anon_sym_LPAREN,
    STATE(9782), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [435652] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12844), 1,
      sym__optional_semi,
    STATE(9783), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [435693] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12846), 1,
      anon_sym_EQ_GT,
    STATE(9784), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [435734] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12848), 1,
      anon_sym_EQ_GT,
    STATE(9785), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [435775] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12850), 1,
      anon_sym_RPAREN,
    STATE(9786), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [435816] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12852), 1,
      sym__optional_semi,
    STATE(9787), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [435857] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12854), 1,
      ts_builtin_sym_end,
    STATE(9788), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [435898] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12856), 1,
      anon_sym_EQ_GT,
    STATE(9789), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [435939] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12858), 1,
      anon_sym_EQ_GT,
    STATE(9790), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [435980] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12860), 1,
      sym__optional_semi,
    STATE(9791), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [436021] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12862), 1,
      sym__optional_semi,
    STATE(9792), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [436062] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12864), 1,
      anon_sym_LT,
    STATE(9793), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [436103] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12866), 1,
      sym__optional_semi,
    STATE(9794), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [436144] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12868), 1,
      anon_sym_EQ_GT,
    STATE(9795), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [436185] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12870), 1,
      sym__optional_semi,
    STATE(9796), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [436226] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12872), 1,
      sym_interpolation_start_quote,
    STATE(9797), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [436267] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12874), 1,
      sym__optional_semi,
    STATE(9798), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [436308] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12876), 1,
      anon_sym_DQUOTE,
    STATE(9799), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [436349] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12878), 1,
      anon_sym_DQUOTE,
    STATE(9800), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [436390] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12880), 1,
      anon_sym_EQ_GT,
    STATE(9801), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [436431] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12882), 1,
      anon_sym_EQ_GT,
    STATE(9802), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [436472] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12884), 1,
      anon_sym_EQ_GT,
    STATE(9803), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [436513] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12886), 1,
      anon_sym_EQ_GT,
    STATE(9804), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [436554] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12888), 1,
      sym__optional_semi,
    STATE(9805), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [436595] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12890), 1,
      sym__optional_semi,
    STATE(9806), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [436636] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12892), 1,
      sym__optional_semi,
    STATE(9807), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [436677] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12894), 1,
      anon_sym_LPAREN,
    STATE(9808), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [436718] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12896), 1,
      anon_sym_LPAREN,
    STATE(9809), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [436759] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12898), 1,
      sym__optional_semi,
    STATE(9810), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [436800] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12900), 1,
      anon_sym_SEMI,
    STATE(9811), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [436841] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12902), 1,
      aux_sym_preproc_if_token3,
    STATE(9812), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [436882] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12904), 1,
      anon_sym_LT,
    STATE(9813), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [436923] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12906), 1,
      anon_sym_LPAREN,
    STATE(9814), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [436964] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12908), 1,
      sym__optional_semi,
    STATE(9815), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [437005] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12910), 1,
      anon_sym_DQUOTE,
    STATE(9816), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [437046] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12912), 1,
      aux_sym_preproc_if_token3,
    STATE(9817), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [437087] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12914), 1,
      anon_sym_LBRACE,
    STATE(9818), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [437128] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12916), 1,
      anon_sym_DQUOTE,
    STATE(9819), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [437169] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12918), 1,
      sym__optional_semi,
    STATE(9820), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [437210] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12920), 1,
      anon_sym_LPAREN,
    STATE(9821), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [437251] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12922), 1,
      sym__optional_semi,
    STATE(9822), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [437292] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12924), 1,
      sym_interpolation_start_quote,
    STATE(9823), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [437333] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12926), 1,
      sym__optional_semi,
    STATE(9824), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [437374] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12928), 1,
      sym__optional_semi,
    STATE(9825), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [437415] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12930), 1,
      sym__optional_semi,
    STATE(9826), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [437456] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12932), 1,
      anon_sym_EQ_GT,
    STATE(9827), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [437497] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12934), 1,
      sym__optional_semi,
    STATE(9828), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [437538] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12936), 1,
      sym__optional_semi,
    STATE(9829), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [437579] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12938), 1,
      sym__optional_semi,
    STATE(9830), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [437620] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12940), 1,
      sym__optional_semi,
    STATE(9831), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [437661] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12942), 1,
      anon_sym_LT,
    STATE(9832), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [437702] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12944), 1,
      sym__optional_semi,
    STATE(9833), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [437743] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12946), 1,
      sym__optional_semi,
    STATE(9834), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [437784] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12948), 1,
      sym__optional_semi,
    STATE(9835), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [437825] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12950), 1,
      sym__optional_semi,
    STATE(9836), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [437866] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12952), 1,
      sym__optional_semi,
    STATE(9837), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [437907] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12954), 1,
      sym__optional_semi,
    STATE(9838), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [437948] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12956), 1,
      sym__optional_semi,
    STATE(9839), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [437989] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12958), 1,
      anon_sym_LPAREN,
    STATE(9840), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [438030] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12960), 1,
      sym__optional_semi,
    STATE(9841), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [438071] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12962), 1,
      sym__optional_semi,
    STATE(9842), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [438112] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12964), 1,
      anon_sym_LT,
    STATE(9843), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [438153] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12966), 1,
      sym__optional_semi,
    STATE(9844), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [438194] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12968), 1,
      anon_sym_LPAREN,
    STATE(9845), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [438235] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12970), 1,
      sym__optional_semi,
    STATE(9846), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [438276] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12972), 1,
      anon_sym_LPAREN,
    STATE(9847), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [438317] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12974), 1,
      anon_sym_GT,
    STATE(9848), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [438358] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12976), 1,
      anon_sym_EQ_GT,
    STATE(9849), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [438399] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12978), 1,
      anon_sym_SEMI,
    STATE(9850), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [438440] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12980), 1,
      sym__optional_semi,
    STATE(9851), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [438481] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12982), 1,
      aux_sym_preproc_if_token3,
    STATE(9852), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [438522] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12984), 1,
      anon_sym_RPAREN,
    STATE(9853), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [438563] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12986), 1,
      sym__optional_semi,
    STATE(9854), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [438604] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12988), 1,
      sym__optional_semi,
    STATE(9855), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [438645] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12990), 1,
      sym__optional_semi,
    STATE(9856), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [438686] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12992), 1,
      anon_sym_GT,
    STATE(9857), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [438727] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12994), 1,
      sym__optional_semi,
    STATE(9858), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [438768] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12996), 1,
      anon_sym_LPAREN,
    STATE(9859), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [438809] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12998), 1,
      anon_sym_LPAREN,
    STATE(9860), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [438850] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13000), 1,
      anon_sym_LPAREN,
    STATE(9861), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [438891] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13002), 1,
      anon_sym_SEMI,
    STATE(9862), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [438932] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13004), 1,
      anon_sym_SEMI,
    STATE(9863), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [438973] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13006), 1,
      sym__optional_semi,
    STATE(9864), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [439014] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13008), 1,
      sym__optional_semi,
    STATE(9865), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [439055] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13010), 1,
      aux_sym_preproc_if_token3,
    STATE(9866), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [439096] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13012), 1,
      anon_sym_EQ_GT,
    STATE(9867), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [439137] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13014), 1,
      sym__optional_semi,
    STATE(9868), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [439178] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13016), 1,
      sym__optional_semi,
    STATE(9869), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [439219] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13018), 1,
      sym__optional_semi,
    STATE(9870), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [439260] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11007), 1,
      anon_sym_RBRACE,
    STATE(9871), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [439301] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13020), 1,
      anon_sym_LPAREN,
    STATE(9872), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [439342] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13022), 1,
      anon_sym_EQ_GT,
    STATE(9873), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [439383] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13024), 1,
      anon_sym_STAR,
    STATE(9874), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [439424] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13026), 1,
      sym__optional_semi,
    STATE(9875), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [439465] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13028), 1,
      anon_sym_SEMI,
    STATE(9876), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [439506] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13030), 1,
      aux_sym_preproc_if_token3,
    STATE(9877), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [439547] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13032), 1,
      sym__optional_semi,
    STATE(9878), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [439588] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13034), 1,
      sym__optional_semi,
    STATE(9879), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [439629] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13036), 1,
      anon_sym_EQ_GT,
    STATE(9880), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [439670] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13038), 1,
      sym__optional_semi,
    STATE(9881), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [439711] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13040), 1,
      anon_sym_GT,
    STATE(9882), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [439752] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13042), 1,
      anon_sym_EQ_GT,
    STATE(9883), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [439793] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13044), 1,
      anon_sym_LPAREN,
    STATE(9884), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [439834] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13046), 1,
      aux_sym_preproc_if_token3,
    STATE(9885), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [439875] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13048), 1,
      sym__optional_semi,
    STATE(9886), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [439916] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13050), 1,
      anon_sym_EQ_GT,
    STATE(9887), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [439957] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13052), 1,
      sym__optional_semi,
    STATE(9888), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [439998] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13054), 1,
      anon_sym_EQ_GT,
    STATE(9889), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [440039] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13056), 1,
      anon_sym_SEMI,
    STATE(9890), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [440080] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13058), 1,
      anon_sym_EQ_GT,
    STATE(9891), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [440121] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13060), 1,
      anon_sym_EQ_GT,
    STATE(9892), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [440162] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13062), 1,
      anon_sym_SEMI,
    STATE(9893), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [440203] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13064), 1,
      anon_sym_EQ_GT,
    STATE(9894), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [440244] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13066), 1,
      anon_sym_SEMI,
    STATE(9895), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [440285] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13068), 1,
      anon_sym_RPAREN,
    STATE(9896), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [440326] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13070), 1,
      anon_sym_RPAREN,
    STATE(9897), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [440367] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13072), 1,
      anon_sym_RBRACK,
    STATE(9898), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [440408] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13074), 1,
      anon_sym_RPAREN,
    STATE(9899), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [440449] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11060), 1,
      anon_sym_RBRACE,
    STATE(9900), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [440490] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13076), 1,
      anon_sym_EQ_GT,
    STATE(9901), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [440531] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13078), 1,
      anon_sym_LBRACE,
    STATE(9902), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [440572] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13080), 1,
      anon_sym_LPAREN,
    STATE(9903), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [440613] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13082), 1,
      anon_sym_STAR,
    STATE(9904), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [440654] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13084), 1,
      anon_sym_EQ_GT,
    STATE(9905), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [440695] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13086), 1,
      anon_sym_SEMI,
    STATE(9906), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [440736] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13088), 1,
      anon_sym_SEMI,
    STATE(9907), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [440777] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13090), 1,
      anon_sym_LBRACE,
    STATE(9908), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [440818] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13092), 1,
      anon_sym_LPAREN,
    STATE(9909), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [440859] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13094), 1,
      anon_sym_EQ_GT,
    STATE(9910), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [440900] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13096), 1,
      anon_sym_EQ_GT,
    STATE(9911), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [440941] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13098), 1,
      anon_sym_SQUOTE,
    STATE(9912), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [440982] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13100), 1,
      anon_sym_EQ_GT,
    STATE(9913), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [441023] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8233), 1,
      anon_sym_RBRACE,
    STATE(9914), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [441064] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13102), 1,
      anon_sym_LPAREN,
    STATE(9915), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [441105] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13104), 1,
      anon_sym_STAR,
    STATE(9916), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [441146] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13106), 1,
      sym_interpolation_start_quote,
    STATE(9917), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [441187] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13108), 1,
      anon_sym_DQUOTE,
    STATE(9918), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [441228] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13110), 1,
      anon_sym_LPAREN,
    STATE(9919), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [441269] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13112), 1,
      anon_sym_DQUOTE,
    STATE(9920), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [441310] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13114), 1,
      anon_sym_EQ_GT,
    STATE(9921), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [441351] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13116), 1,
      anon_sym_SEMI,
    STATE(9922), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [441392] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13118), 1,
      anon_sym_STAR,
    STATE(9923), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [441433] = 11,
    ACTIONS(9485), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9487), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9489), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9491), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9493), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9495), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9497), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9499), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9501), 1,
      sym_comment,
    ACTIONS(13120), 1,
      sym_preproc_arg,
    STATE(9924), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [441474] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13122), 1,
      anon_sym_STAR,
    STATE(9925), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [441515] = 11,
    ACTIONS(9485), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9487), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9489), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9491), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9493), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9495), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9497), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9499), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9501), 1,
      sym_comment,
    ACTIONS(13124), 1,
      sym_preproc_arg,
    STATE(9926), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [441556] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13126), 1,
      anon_sym_STAR,
    STATE(9927), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [441597] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10124), 1,
      anon_sym_STAR,
    STATE(9928), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [441638] = 11,
    ACTIONS(9485), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9487), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9489), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9491), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9493), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9495), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9497), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9499), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9501), 1,
      sym_comment,
    ACTIONS(13128), 1,
      sym_preproc_arg,
    STATE(9929), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [441679] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13130), 1,
      anon_sym_LPAREN,
    STATE(9930), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [441720] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13132), 1,
      anon_sym_LPAREN,
    STATE(9931), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [441761] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13134), 1,
      anon_sym_EQ_GT,
    STATE(9932), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [441802] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13136), 1,
      anon_sym_STAR,
    STATE(9933), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [441843] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13138), 1,
      anon_sym_while,
    STATE(9934), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [441884] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13140), 1,
      anon_sym_LPAREN,
    STATE(9935), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [441925] = 11,
    ACTIONS(5319), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(9485), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9487), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9489), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9491), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9493), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9495), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9497), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9499), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9501), 1,
      sym_comment,
    STATE(9936), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [441966] = 1,
    ACTIONS(13142), 1,
      ts_builtin_sym_end,
  [441970] = 1,
    ACTIONS(13144), 1,
      ts_builtin_sym_end,
  [441974] = 1,
    ACTIONS(13146), 1,
      ts_builtin_sym_end,
  [441978] = 1,
    ACTIONS(13148), 1,
      ts_builtin_sym_end,
  [441982] = 1,
    ACTIONS(13150), 1,
      ts_builtin_sym_end,
  [441986] = 1,
    ACTIONS(13152), 1,
      ts_builtin_sym_end,
  [441990] = 1,
    ACTIONS(13154), 1,
      ts_builtin_sym_end,
  [441994] = 1,
    ACTIONS(13156), 1,
      ts_builtin_sym_end,
  [441998] = 1,
    ACTIONS(13158), 1,
      ts_builtin_sym_end,
  [442002] = 1,
    ACTIONS(13160), 1,
      ts_builtin_sym_end,
  [442006] = 1,
    ACTIONS(13162), 1,
      ts_builtin_sym_end,
  [442010] = 1,
    ACTIONS(13164), 1,
      ts_builtin_sym_end,
  [442014] = 1,
    ACTIONS(13166), 1,
      ts_builtin_sym_end,
  [442018] = 1,
    ACTIONS(13168), 1,
      ts_builtin_sym_end,
  [442022] = 1,
    ACTIONS(13170), 1,
      ts_builtin_sym_end,
  [442026] = 1,
    ACTIONS(13172), 1,
      ts_builtin_sym_end,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(4431)] = 0,
  [SMALL_STATE(4432)] = 145,
  [SMALL_STATE(4433)] = 290,
  [SMALL_STATE(4434)] = 379,
  [SMALL_STATE(4435)] = 524,
  [SMALL_STATE(4436)] = 615,
  [SMALL_STATE(4437)] = 760,
  [SMALL_STATE(4438)] = 851,
  [SMALL_STATE(4439)] = 996,
  [SMALL_STATE(4440)] = 1089,
  [SMALL_STATE(4441)] = 1234,
  [SMALL_STATE(4442)] = 1379,
  [SMALL_STATE(4443)] = 1524,
  [SMALL_STATE(4444)] = 1613,
  [SMALL_STATE(4445)] = 1758,
  [SMALL_STATE(4446)] = 1903,
  [SMALL_STATE(4447)] = 1992,
  [SMALL_STATE(4448)] = 2121,
  [SMALL_STATE(4449)] = 2210,
  [SMALL_STATE(4450)] = 2339,
  [SMALL_STATE(4451)] = 2470,
  [SMALL_STATE(4452)] = 2613,
  [SMALL_STATE(4453)] = 2752,
  [SMALL_STATE(4454)] = 2889,
  [SMALL_STATE(4455)] = 3018,
  [SMALL_STATE(4456)] = 3149,
  [SMALL_STATE(4457)] = 3284,
  [SMALL_STATE(4458)] = 3417,
  [SMALL_STATE(4459)] = 3504,
  [SMALL_STATE(4460)] = 3633,
  [SMALL_STATE(4461)] = 3740,
  [SMALL_STATE(4462)] = 3829,
  [SMALL_STATE(4463)] = 3922,
  [SMALL_STATE(4464)] = 4067,
  [SMALL_STATE(4465)] = 4192,
  [SMALL_STATE(4466)] = 4337,
  [SMALL_STATE(4467)] = 4466,
  [SMALL_STATE(4468)] = 4555,
  [SMALL_STATE(4469)] = 4672,
  [SMALL_STATE(4470)] = 4783,
  [SMALL_STATE(4471)] = 4898,
  [SMALL_STATE(4472)] = 5019,
  [SMALL_STATE(4473)] = 5164,
  [SMALL_STATE(4474)] = 5253,
  [SMALL_STATE(4475)] = 5342,
  [SMALL_STATE(4476)] = 5449,
  [SMALL_STATE(4477)] = 5542,
  [SMALL_STATE(4478)] = 5635,
  [SMALL_STATE(4479)] = 5764,
  [SMALL_STATE(4480)] = 5857,
  [SMALL_STATE(4481)] = 5986,
  [SMALL_STATE(4482)] = 6131,
  [SMALL_STATE(4483)] = 6224,
  [SMALL_STATE(4484)] = 6369,
  [SMALL_STATE(4485)] = 6490,
  [SMALL_STATE(4486)] = 6605,
  [SMALL_STATE(4487)] = 6716,
  [SMALL_STATE(4488)] = 6849,
  [SMALL_STATE(4489)] = 6984,
  [SMALL_STATE(4490)] = 7075,
  [SMALL_STATE(4491)] = 7206,
  [SMALL_STATE(4492)] = 7323,
  [SMALL_STATE(4493)] = 7452,
  [SMALL_STATE(4494)] = 7559,
  [SMALL_STATE(4495)] = 7696,
  [SMALL_STATE(4496)] = 7789,
  [SMALL_STATE(4497)] = 7928,
  [SMALL_STATE(4498)] = 8071,
  [SMALL_STATE(4499)] = 8164,
  [SMALL_STATE(4500)] = 8309,
  [SMALL_STATE(4501)] = 8398,
  [SMALL_STATE(4502)] = 8543,
  [SMALL_STATE(4503)] = 8634,
  [SMALL_STATE(4504)] = 8779,
  [SMALL_STATE(4505)] = 8924,
  [SMALL_STATE(4506)] = 9069,
  [SMALL_STATE(4507)] = 9156,
  [SMALL_STATE(4508)] = 9249,
  [SMALL_STATE(4509)] = 9338,
  [SMALL_STATE(4510)] = 9445,
  [SMALL_STATE(4511)] = 9538,
  [SMALL_STATE(4512)] = 9667,
  [SMALL_STATE(4513)] = 9812,
  [SMALL_STATE(4514)] = 9957,
  [SMALL_STATE(4515)] = 10102,
  [SMALL_STATE(4516)] = 10247,
  [SMALL_STATE(4517)] = 10335,
  [SMALL_STATE(4518)] = 10461,
  [SMALL_STATE(4519)] = 10587,
  [SMALL_STATE(4520)] = 10675,
  [SMALL_STATE(4521)] = 10763,
  [SMALL_STATE(4522)] = 10851,
  [SMALL_STATE(4523)] = 10939,
  [SMALL_STATE(4524)] = 11081,
  [SMALL_STATE(4525)] = 11187,
  [SMALL_STATE(4526)] = 11313,
  [SMALL_STATE(4527)] = 11401,
  [SMALL_STATE(4528)] = 11527,
  [SMALL_STATE(4529)] = 11653,
  [SMALL_STATE(4530)] = 11779,
  [SMALL_STATE(4531)] = 11905,
  [SMALL_STATE(4532)] = 11993,
  [SMALL_STATE(4533)] = 12119,
  [SMALL_STATE(4534)] = 12207,
  [SMALL_STATE(4535)] = 12295,
  [SMALL_STATE(4536)] = 12421,
  [SMALL_STATE(4537)] = 12547,
  [SMALL_STATE(4538)] = 12635,
  [SMALL_STATE(4539)] = 12761,
  [SMALL_STATE(4540)] = 12849,
  [SMALL_STATE(4541)] = 12937,
  [SMALL_STATE(4542)] = 13045,
  [SMALL_STATE(4543)] = 13135,
  [SMALL_STATE(4544)] = 13223,
  [SMALL_STATE(4545)] = 13311,
  [SMALL_STATE(4546)] = 13399,
  [SMALL_STATE(4547)] = 13487,
  [SMALL_STATE(4548)] = 13575,
  [SMALL_STATE(4549)] = 13701,
  [SMALL_STATE(4550)] = 13833,
  [SMALL_STATE(4551)] = 13967,
  [SMALL_STATE(4552)] = 14097,
  [SMALL_STATE(4553)] = 14225,
  [SMALL_STATE(4554)] = 14313,
  [SMALL_STATE(4555)] = 14449,
  [SMALL_STATE(4556)] = 14587,
  [SMALL_STATE(4557)] = 14713,
  [SMALL_STATE(4558)] = 14855,
  [SMALL_STATE(4559)] = 14943,
  [SMALL_STATE(4560)] = 15031,
  [SMALL_STATE(4561)] = 15157,
  [SMALL_STATE(4562)] = 15283,
  [SMALL_STATE(4563)] = 15371,
  [SMALL_STATE(4564)] = 15497,
  [SMALL_STATE(4565)] = 15623,
  [SMALL_STATE(4566)] = 15711,
  [SMALL_STATE(4567)] = 15837,
  [SMALL_STATE(4568)] = 15925,
  [SMALL_STATE(4569)] = 16051,
  [SMALL_STATE(4570)] = 16139,
  [SMALL_STATE(4571)] = 16227,
  [SMALL_STATE(4572)] = 16315,
  [SMALL_STATE(4573)] = 16441,
  [SMALL_STATE(4574)] = 16531,
  [SMALL_STATE(4575)] = 16619,
  [SMALL_STATE(4576)] = 16707,
  [SMALL_STATE(4577)] = 16833,
  [SMALL_STATE(4578)] = 16959,
  [SMALL_STATE(4579)] = 17085,
  [SMALL_STATE(4580)] = 17173,
  [SMALL_STATE(4581)] = 17261,
  [SMALL_STATE(4582)] = 17349,
  [SMALL_STATE(4583)] = 17437,
  [SMALL_STATE(4584)] = 17525,
  [SMALL_STATE(4585)] = 17613,
  [SMALL_STATE(4586)] = 17701,
  [SMALL_STATE(4587)] = 17789,
  [SMALL_STATE(4588)] = 17877,
  [SMALL_STATE(4589)] = 18003,
  [SMALL_STATE(4590)] = 18091,
  [SMALL_STATE(4591)] = 18179,
  [SMALL_STATE(4592)] = 18305,
  [SMALL_STATE(4593)] = 18393,
  [SMALL_STATE(4594)] = 18481,
  [SMALL_STATE(4595)] = 18569,
  [SMALL_STATE(4596)] = 18657,
  [SMALL_STATE(4597)] = 18783,
  [SMALL_STATE(4598)] = 18871,
  [SMALL_STATE(4599)] = 18959,
  [SMALL_STATE(4600)] = 19047,
  [SMALL_STATE(4601)] = 19173,
  [SMALL_STATE(4602)] = 19261,
  [SMALL_STATE(4603)] = 19387,
  [SMALL_STATE(4604)] = 19477,
  [SMALL_STATE(4605)] = 19565,
  [SMALL_STATE(4606)] = 19691,
  [SMALL_STATE(4607)] = 19779,
  [SMALL_STATE(4608)] = 19871,
  [SMALL_STATE(4609)] = 19997,
  [SMALL_STATE(4610)] = 20123,
  [SMALL_STATE(4611)] = 20249,
  [SMALL_STATE(4612)] = 20337,
  [SMALL_STATE(4613)] = 20463,
  [SMALL_STATE(4614)] = 20589,
  [SMALL_STATE(4615)] = 20677,
  [SMALL_STATE(4616)] = 20765,
  [SMALL_STATE(4617)] = 20891,
  [SMALL_STATE(4618)] = 20979,
  [SMALL_STATE(4619)] = 21105,
  [SMALL_STATE(4620)] = 21193,
  [SMALL_STATE(4621)] = 21281,
  [SMALL_STATE(4622)] = 21407,
  [SMALL_STATE(4623)] = 21495,
  [SMALL_STATE(4624)] = 21621,
  [SMALL_STATE(4625)] = 21709,
  [SMALL_STATE(4626)] = 21835,
  [SMALL_STATE(4627)] = 21927,
  [SMALL_STATE(4628)] = 22053,
  [SMALL_STATE(4629)] = 22141,
  [SMALL_STATE(4630)] = 22267,
  [SMALL_STATE(4631)] = 22355,
  [SMALL_STATE(4632)] = 22463,
  [SMALL_STATE(4633)] = 22589,
  [SMALL_STATE(4634)] = 22715,
  [SMALL_STATE(4635)] = 22831,
  [SMALL_STATE(4636)] = 22941,
  [SMALL_STATE(4637)] = 23055,
  [SMALL_STATE(4638)] = 23175,
  [SMALL_STATE(4639)] = 23301,
  [SMALL_STATE(4640)] = 23427,
  [SMALL_STATE(4641)] = 23569,
  [SMALL_STATE(4642)] = 23657,
  [SMALL_STATE(4643)] = 23745,
  [SMALL_STATE(4644)] = 23839,
  [SMALL_STATE(4645)] = 23965,
  [SMALL_STATE(4646)] = 24091,
  [SMALL_STATE(4647)] = 24179,
  [SMALL_STATE(4648)] = 24267,
  [SMALL_STATE(4649)] = 24355,
  [SMALL_STATE(4650)] = 24447,
  [SMALL_STATE(4651)] = 24535,
  [SMALL_STATE(4652)] = 24623,
  [SMALL_STATE(4653)] = 24749,
  [SMALL_STATE(4654)] = 24875,
  [SMALL_STATE(4655)] = 25001,
  [SMALL_STATE(4656)] = 25089,
  [SMALL_STATE(4657)] = 25231,
  [SMALL_STATE(4658)] = 25373,
  [SMALL_STATE(4659)] = 25515,
  [SMALL_STATE(4660)] = 25657,
  [SMALL_STATE(4661)] = 25799,
  [SMALL_STATE(4662)] = 25887,
  [SMALL_STATE(4663)] = 25979,
  [SMALL_STATE(4664)] = 26067,
  [SMALL_STATE(4665)] = 26155,
  [SMALL_STATE(4666)] = 26281,
  [SMALL_STATE(4667)] = 26423,
  [SMALL_STATE(4668)] = 26565,
  [SMALL_STATE(4669)] = 26657,
  [SMALL_STATE(4670)] = 26745,
  [SMALL_STATE(4671)] = 26887,
  [SMALL_STATE(4672)] = 27029,
  [SMALL_STATE(4673)] = 27117,
  [SMALL_STATE(4674)] = 27223,
  [SMALL_STATE(4675)] = 27349,
  [SMALL_STATE(4676)] = 27437,
  [SMALL_STATE(4677)] = 27579,
  [SMALL_STATE(4678)] = 27667,
  [SMALL_STATE(4679)] = 27755,
  [SMALL_STATE(4680)] = 27843,
  [SMALL_STATE(4681)] = 27931,
  [SMALL_STATE(4682)] = 28019,
  [SMALL_STATE(4683)] = 28107,
  [SMALL_STATE(4684)] = 28233,
  [SMALL_STATE(4685)] = 28321,
  [SMALL_STATE(4686)] = 28409,
  [SMALL_STATE(4687)] = 28535,
  [SMALL_STATE(4688)] = 28623,
  [SMALL_STATE(4689)] = 28711,
  [SMALL_STATE(4690)] = 28799,
  [SMALL_STATE(4691)] = 28887,
  [SMALL_STATE(4692)] = 29013,
  [SMALL_STATE(4693)] = 29101,
  [SMALL_STATE(4694)] = 29189,
  [SMALL_STATE(4695)] = 29315,
  [SMALL_STATE(4696)] = 29403,
  [SMALL_STATE(4697)] = 29491,
  [SMALL_STATE(4698)] = 29579,
  [SMALL_STATE(4699)] = 29667,
  [SMALL_STATE(4700)] = 29755,
  [SMALL_STATE(4701)] = 29843,
  [SMALL_STATE(4702)] = 29931,
  [SMALL_STATE(4703)] = 30057,
  [SMALL_STATE(4704)] = 30183,
  [SMALL_STATE(4705)] = 30309,
  [SMALL_STATE(4706)] = 30435,
  [SMALL_STATE(4707)] = 30561,
  [SMALL_STATE(4708)] = 30653,
  [SMALL_STATE(4709)] = 30779,
  [SMALL_STATE(4710)] = 30867,
  [SMALL_STATE(4711)] = 30993,
  [SMALL_STATE(4712)] = 31085,
  [SMALL_STATE(4713)] = 31177,
  [SMALL_STATE(4714)] = 31303,
  [SMALL_STATE(4715)] = 31429,
  [SMALL_STATE(4716)] = 31555,
  [SMALL_STATE(4717)] = 31681,
  [SMALL_STATE(4718)] = 31824,
  [SMALL_STATE(4719)] = 31961,
  [SMALL_STATE(4720)] = 32084,
  [SMALL_STATE(4721)] = 32207,
  [SMALL_STATE(4722)] = 32350,
  [SMALL_STATE(4723)] = 32473,
  [SMALL_STATE(4724)] = 32596,
  [SMALL_STATE(4725)] = 32739,
  [SMALL_STATE(4726)] = 32862,
  [SMALL_STATE(4727)] = 32985,
  [SMALL_STATE(4728)] = 33108,
  [SMALL_STATE(4729)] = 33231,
  [SMALL_STATE(4730)] = 33354,
  [SMALL_STATE(4731)] = 33497,
  [SMALL_STATE(4732)] = 33620,
  [SMALL_STATE(4733)] = 33735,
  [SMALL_STATE(4734)] = 33878,
  [SMALL_STATE(4735)] = 34001,
  [SMALL_STATE(4736)] = 34136,
  [SMALL_STATE(4737)] = 34259,
  [SMALL_STATE(4738)] = 34382,
  [SMALL_STATE(4739)] = 34505,
  [SMALL_STATE(4740)] = 34628,
  [SMALL_STATE(4741)] = 34751,
  [SMALL_STATE(4742)] = 34874,
  [SMALL_STATE(4743)] = 34963,
  [SMALL_STATE(4744)] = 35106,
  [SMALL_STATE(4745)] = 35197,
  [SMALL_STATE(4746)] = 35340,
  [SMALL_STATE(4747)] = 35463,
  [SMALL_STATE(4748)] = 35586,
  [SMALL_STATE(4749)] = 35709,
  [SMALL_STATE(4750)] = 35852,
  [SMALL_STATE(4751)] = 35975,
  [SMALL_STATE(4752)] = 36098,
  [SMALL_STATE(4753)] = 36221,
  [SMALL_STATE(4754)] = 36362,
  [SMALL_STATE(4755)] = 36485,
  [SMALL_STATE(4756)] = 36608,
  [SMALL_STATE(4757)] = 36731,
  [SMALL_STATE(4758)] = 36854,
  [SMALL_STATE(4759)] = 36977,
  [SMALL_STATE(4760)] = 37100,
  [SMALL_STATE(4761)] = 37223,
  [SMALL_STATE(4762)] = 37346,
  [SMALL_STATE(4763)] = 37469,
  [SMALL_STATE(4764)] = 37588,
  [SMALL_STATE(4765)] = 37711,
  [SMALL_STATE(4766)] = 37816,
  [SMALL_STATE(4767)] = 37939,
  [SMALL_STATE(4768)] = 38082,
  [SMALL_STATE(4769)] = 38205,
  [SMALL_STATE(4770)] = 38328,
  [SMALL_STATE(4771)] = 38447,
  [SMALL_STATE(4772)] = 38570,
  [SMALL_STATE(4773)] = 38693,
  [SMALL_STATE(4774)] = 38834,
  [SMALL_STATE(4775)] = 38957,
  [SMALL_STATE(4776)] = 39080,
  [SMALL_STATE(4777)] = 39193,
  [SMALL_STATE(4778)] = 39302,
  [SMALL_STATE(4779)] = 39445,
  [SMALL_STATE(4780)] = 39588,
  [SMALL_STATE(4781)] = 39719,
  [SMALL_STATE(4782)] = 39842,
  [SMALL_STATE(4783)] = 39965,
  [SMALL_STATE(4784)] = 40056,
  [SMALL_STATE(4785)] = 40179,
  [SMALL_STATE(4786)] = 40302,
  [SMALL_STATE(4787)] = 40435,
  [SMALL_STATE(4788)] = 40564,
  [SMALL_STATE(4789)] = 40659,
  [SMALL_STATE(4790)] = 40782,
  [SMALL_STATE(4791)] = 40897,
  [SMALL_STATE(4792)] = 41024,
  [SMALL_STATE(4793)] = 41147,
  [SMALL_STATE(4794)] = 41288,
  [SMALL_STATE(4795)] = 41417,
  [SMALL_STATE(4796)] = 41558,
  [SMALL_STATE(4797)] = 41695,
  [SMALL_STATE(4798)] = 41838,
  [SMALL_STATE(4799)] = 41979,
  [SMALL_STATE(4800)] = 42102,
  [SMALL_STATE(4801)] = 42243,
  [SMALL_STATE(4802)] = 42366,
  [SMALL_STATE(4803)] = 42489,
  [SMALL_STATE(4804)] = 42612,
  [SMALL_STATE(4805)] = 42747,
  [SMALL_STATE(4806)] = 42870,
  [SMALL_STATE(4807)] = 43011,
  [SMALL_STATE(4808)] = 43146,
  [SMALL_STATE(4809)] = 43289,
  [SMALL_STATE(4810)] = 43412,
  [SMALL_STATE(4811)] = 43535,
  [SMALL_STATE(4812)] = 43676,
  [SMALL_STATE(4813)] = 43803,
  [SMALL_STATE(4814)] = 43932,
  [SMALL_STATE(4815)] = 44065,
  [SMALL_STATE(4816)] = 44154,
  [SMALL_STATE(4817)] = 44277,
  [SMALL_STATE(4818)] = 44410,
  [SMALL_STATE(4819)] = 44515,
  [SMALL_STATE(4820)] = 44638,
  [SMALL_STATE(4821)] = 44761,
  [SMALL_STATE(4822)] = 44884,
  [SMALL_STATE(4823)] = 45007,
  [SMALL_STATE(4824)] = 45130,
  [SMALL_STATE(4825)] = 45253,
  [SMALL_STATE(4826)] = 45376,
  [SMALL_STATE(4827)] = 45499,
  [SMALL_STATE(4828)] = 45622,
  [SMALL_STATE(4829)] = 45745,
  [SMALL_STATE(4830)] = 45882,
  [SMALL_STATE(4831)] = 46013,
  [SMALL_STATE(4832)] = 46118,
  [SMALL_STATE(4833)] = 46213,
  [SMALL_STATE(4834)] = 46336,
  [SMALL_STATE(4835)] = 46459,
  [SMALL_STATE(4836)] = 46582,
  [SMALL_STATE(4837)] = 46725,
  [SMALL_STATE(4838)] = 46848,
  [SMALL_STATE(4839)] = 46939,
  [SMALL_STATE(4840)] = 47030,
  [SMALL_STATE(4841)] = 47145,
  [SMALL_STATE(4842)] = 47268,
  [SMALL_STATE(4843)] = 47411,
  [SMALL_STATE(4844)] = 47552,
  [SMALL_STATE(4845)] = 47675,
  [SMALL_STATE(4846)] = 47798,
  [SMALL_STATE(4847)] = 47921,
  [SMALL_STATE(4848)] = 48064,
  [SMALL_STATE(4849)] = 48187,
  [SMALL_STATE(4850)] = 48310,
  [SMALL_STATE(4851)] = 48453,
  [SMALL_STATE(4852)] = 48576,
  [SMALL_STATE(4853)] = 48719,
  [SMALL_STATE(4854)] = 48842,
  [SMALL_STATE(4855)] = 48933,
  [SMALL_STATE(4856)] = 49024,
  [SMALL_STATE(4857)] = 49147,
  [SMALL_STATE(4858)] = 49290,
  [SMALL_STATE(4859)] = 49417,
  [SMALL_STATE(4860)] = 49558,
  [SMALL_STATE(4861)] = 49667,
  [SMALL_STATE(4862)] = 49790,
  [SMALL_STATE(4863)] = 49913,
  [SMALL_STATE(4864)] = 50036,
  [SMALL_STATE(4865)] = 50179,
  [SMALL_STATE(4866)] = 50302,
  [SMALL_STATE(4867)] = 50415,
  [SMALL_STATE(4868)] = 50538,
  [SMALL_STATE(4869)] = 50661,
  [SMALL_STATE(4870)] = 50804,
  [SMALL_STATE(4871)] = 50927,
  [SMALL_STATE(4872)] = 51032,
  [SMALL_STATE(4873)] = 51173,
  [SMALL_STATE(4874)] = 51314,
  [SMALL_STATE(4875)] = 51437,
  [SMALL_STATE(4876)] = 51528,
  [SMALL_STATE(4877)] = 51651,
  [SMALL_STATE(4878)] = 51774,
  [SMALL_STATE(4879)] = 51897,
  [SMALL_STATE(4880)] = 52020,
  [SMALL_STATE(4881)] = 52125,
  [SMALL_STATE(4882)] = 52248,
  [SMALL_STATE(4883)] = 52391,
  [SMALL_STATE(4884)] = 52482,
  [SMALL_STATE(4885)] = 52625,
  [SMALL_STATE(4886)] = 52748,
  [SMALL_STATE(4887)] = 52871,
  [SMALL_STATE(4888)] = 52994,
  [SMALL_STATE(4889)] = 53113,
  [SMALL_STATE(4890)] = 53236,
  [SMALL_STATE(4891)] = 53359,
  [SMALL_STATE(4892)] = 53466,
  [SMALL_STATE(4893)] = 53557,
  [SMALL_STATE(4894)] = 53680,
  [SMALL_STATE(4895)] = 53769,
  [SMALL_STATE(4896)] = 53892,
  [SMALL_STATE(4897)] = 54005,
  [SMALL_STATE(4898)] = 54148,
  [SMALL_STATE(4899)] = 54239,
  [SMALL_STATE(4900)] = 54344,
  [SMALL_STATE(4901)] = 54467,
  [SMALL_STATE(4902)] = 54576,
  [SMALL_STATE(4903)] = 54699,
  [SMALL_STATE(4904)] = 54822,
  [SMALL_STATE(4905)] = 54963,
  [SMALL_STATE(4906)] = 55086,
  [SMALL_STATE(4907)] = 55217,
  [SMALL_STATE(4908)] = 55360,
  [SMALL_STATE(4909)] = 55483,
  [SMALL_STATE(4910)] = 55606,
  [SMALL_STATE(4911)] = 55729,
  [SMALL_STATE(4912)] = 55852,
  [SMALL_STATE(4913)] = 55995,
  [SMALL_STATE(4914)] = 56118,
  [SMALL_STATE(4915)] = 56260,
  [SMALL_STATE(4916)] = 56402,
  [SMALL_STATE(4917)] = 56544,
  [SMALL_STATE(4918)] = 56686,
  [SMALL_STATE(4919)] = 56816,
  [SMALL_STATE(4920)] = 56948,
  [SMALL_STATE(4921)] = 57076,
  [SMALL_STATE(4922)] = 57168,
  [SMALL_STATE(4923)] = 57294,
  [SMALL_STATE(4924)] = 57428,
  [SMALL_STATE(4925)] = 57564,
  [SMALL_STATE(4926)] = 57704,
  [SMALL_STATE(4927)] = 57792,
  [SMALL_STATE(4928)] = 57882,
  [SMALL_STATE(4929)] = 58024,
  [SMALL_STATE(4930)] = 58114,
  [SMALL_STATE(4931)] = 58218,
  [SMALL_STATE(4932)] = 58332,
  [SMALL_STATE(4933)] = 58474,
  [SMALL_STATE(4934)] = 58578,
  [SMALL_STATE(4935)] = 58720,
  [SMALL_STATE(4936)] = 58862,
  [SMALL_STATE(4937)] = 58970,
  [SMALL_STATE(4938)] = 59060,
  [SMALL_STATE(4939)] = 59202,
  [SMALL_STATE(4940)] = 59292,
  [SMALL_STATE(4941)] = 59404,
  [SMALL_STATE(4942)] = 59522,
  [SMALL_STATE(4943)] = 59624,
  [SMALL_STATE(4944)] = 59726,
  [SMALL_STATE(4945)] = 59814,
  [SMALL_STATE(4946)] = 59902,
  [SMALL_STATE(4947)] = 60004,
  [SMALL_STATE(4948)] = 60094,
  [SMALL_STATE(4949)] = 60184,
  [SMALL_STATE(4950)] = 60272,
  [SMALL_STATE(4951)] = 60362,
  [SMALL_STATE(4952)] = 60504,
  [SMALL_STATE(4953)] = 60598,
  [SMALL_STATE(4954)] = 60740,
  [SMALL_STATE(4955)] = 60830,
  [SMALL_STATE(4956)] = 60933,
  [SMALL_STATE(4957)] = 61018,
  [SMALL_STATE(4958)] = 61103,
  [SMALL_STATE(4959)] = 61188,
  [SMALL_STATE(4960)] = 61273,
  [SMALL_STATE(4961)] = 61412,
  [SMALL_STATE(4962)] = 61497,
  [SMALL_STATE(4963)] = 61622,
  [SMALL_STATE(4964)] = 61735,
  [SMALL_STATE(4965)] = 61874,
  [SMALL_STATE(4966)] = 62013,
  [SMALL_STATE(4967)] = 62152,
  [SMALL_STATE(4968)] = 62291,
  [SMALL_STATE(4969)] = 62376,
  [SMALL_STATE(4970)] = 62461,
  [SMALL_STATE(4971)] = 62564,
  [SMALL_STATE(4972)] = 62649,
  [SMALL_STATE(4973)] = 62734,
  [SMALL_STATE(4974)] = 62819,
  [SMALL_STATE(4975)] = 62904,
  [SMALL_STATE(4976)] = 62989,
  [SMALL_STATE(4977)] = 63074,
  [SMALL_STATE(4978)] = 63213,
  [SMALL_STATE(4979)] = 63352,
  [SMALL_STATE(4980)] = 63437,
  [SMALL_STATE(4981)] = 63576,
  [SMALL_STATE(4982)] = 63715,
  [SMALL_STATE(4983)] = 63802,
  [SMALL_STATE(4984)] = 63941,
  [SMALL_STATE(4985)] = 64026,
  [SMALL_STATE(4986)] = 64111,
  [SMALL_STATE(4987)] = 64196,
  [SMALL_STATE(4988)] = 64285,
  [SMALL_STATE(4989)] = 64370,
  [SMALL_STATE(4990)] = 64455,
  [SMALL_STATE(4991)] = 64588,
  [SMALL_STATE(4992)] = 64693,
  [SMALL_STATE(4993)] = 64782,
  [SMALL_STATE(4994)] = 64867,
  [SMALL_STATE(4995)] = 64956,
  [SMALL_STATE(4996)] = 65045,
  [SMALL_STATE(4997)] = 65184,
  [SMALL_STATE(4998)] = 65269,
  [SMALL_STATE(4999)] = 65354,
  [SMALL_STATE(5000)] = 65493,
  [SMALL_STATE(5001)] = 65628,
  [SMALL_STATE(5002)] = 65713,
  [SMALL_STATE(5003)] = 65830,
  [SMALL_STATE(5004)] = 65957,
  [SMALL_STATE(5005)] = 66096,
  [SMALL_STATE(5006)] = 66181,
  [SMALL_STATE(5007)] = 66266,
  [SMALL_STATE(5008)] = 66377,
  [SMALL_STATE(5009)] = 66462,
  [SMALL_STATE(5010)] = 66593,
  [SMALL_STATE(5011)] = 66678,
  [SMALL_STATE(5012)] = 66807,
  [SMALL_STATE(5013)] = 66892,
  [SMALL_STATE(5014)] = 67031,
  [SMALL_STATE(5015)] = 67138,
  [SMALL_STATE(5016)] = 67240,
  [SMALL_STATE(5017)] = 67350,
  [SMALL_STATE(5018)] = 67456,
  [SMALL_STATE(5019)] = 67584,
  [SMALL_STATE(5020)] = 67714,
  [SMALL_STATE(5021)] = 67840,
  [SMALL_STATE(5022)] = 67952,
  [SMALL_STATE(5023)] = 68076,
  [SMALL_STATE(5024)] = 68214,
  [SMALL_STATE(5025)] = 68346,
  [SMALL_STATE(5026)] = 68480,
  [SMALL_STATE(5027)] = 68618,
  [SMALL_STATE(5028)] = 68756,
  [SMALL_STATE(5029)] = 68872,
  [SMALL_STATE(5030)] = 69010,
  [SMALL_STATE(5031)] = 69148,
  [SMALL_STATE(5032)] = 69286,
  [SMALL_STATE(5033)] = 69424,
  [SMALL_STATE(5034)] = 69562,
  [SMALL_STATE(5035)] = 69652,
  [SMALL_STATE(5036)] = 69790,
  [SMALL_STATE(5037)] = 69928,
  [SMALL_STATE(5038)] = 70066,
  [SMALL_STATE(5039)] = 70168,
  [SMALL_STATE(5040)] = 70306,
  [SMALL_STATE(5041)] = 70444,
  [SMALL_STATE(5042)] = 70582,
  [SMALL_STATE(5043)] = 70720,
  [SMALL_STATE(5044)] = 70858,
  [SMALL_STATE(5045)] = 70996,
  [SMALL_STATE(5046)] = 71134,
  [SMALL_STATE(5047)] = 71272,
  [SMALL_STATE(5048)] = 71406,
  [SMALL_STATE(5049)] = 71544,
  [SMALL_STATE(5050)] = 71682,
  [SMALL_STATE(5051)] = 71814,
  [SMALL_STATE(5052)] = 71952,
  [SMALL_STATE(5053)] = 72090,
  [SMALL_STATE(5054)] = 72214,
  [SMALL_STATE(5055)] = 72352,
  [SMALL_STATE(5056)] = 72454,
  [SMALL_STATE(5057)] = 72592,
  [SMALL_STATE(5058)] = 72704,
  [SMALL_STATE(5059)] = 72842,
  [SMALL_STATE(5060)] = 72968,
  [SMALL_STATE(5061)] = 73098,
  [SMALL_STATE(5062)] = 73186,
  [SMALL_STATE(5063)] = 73314,
  [SMALL_STATE(5064)] = 73424,
  [SMALL_STATE(5065)] = 73540,
  [SMALL_STATE(5066)] = 73670,
  [SMALL_STATE(5067)] = 73808,
  [SMALL_STATE(5068)] = 73946,
  [SMALL_STATE(5069)] = 74080,
  [SMALL_STATE(5070)] = 74212,
  [SMALL_STATE(5071)] = 74350,
  [SMALL_STATE(5072)] = 74438,
  [SMALL_STATE(5073)] = 74576,
  [SMALL_STATE(5074)] = 74714,
  [SMALL_STATE(5075)] = 74802,
  [SMALL_STATE(5076)] = 74930,
  [SMALL_STATE(5077)] = 75068,
  [SMALL_STATE(5078)] = 75156,
  [SMALL_STATE(5079)] = 75294,
  [SMALL_STATE(5080)] = 75400,
  [SMALL_STATE(5081)] = 75488,
  [SMALL_STATE(5082)] = 75572,
  [SMALL_STATE(5083)] = 75660,
  [SMALL_STATE(5084)] = 75752,
  [SMALL_STATE(5085)] = 75840,
  [SMALL_STATE(5086)] = 75926,
  [SMALL_STATE(5087)] = 76052,
  [SMALL_STATE(5088)] = 76162,
  [SMALL_STATE(5089)] = 76250,
  [SMALL_STATE(5090)] = 76388,
  [SMALL_STATE(5091)] = 76476,
  [SMALL_STATE(5092)] = 76614,
  [SMALL_STATE(5093)] = 76730,
  [SMALL_STATE(5094)] = 76836,
  [SMALL_STATE(5095)] = 76952,
  [SMALL_STATE(5096)] = 77054,
  [SMALL_STATE(5097)] = 77156,
  [SMALL_STATE(5098)] = 77280,
  [SMALL_STATE(5099)] = 77392,
  [SMALL_STATE(5100)] = 77494,
  [SMALL_STATE(5101)] = 77632,
  [SMALL_STATE(5102)] = 77718,
  [SMALL_STATE(5103)] = 77856,
  [SMALL_STATE(5104)] = 77994,
  [SMALL_STATE(5105)] = 78132,
  [SMALL_STATE(5106)] = 78234,
  [SMALL_STATE(5107)] = 78372,
  [SMALL_STATE(5108)] = 78510,
  [SMALL_STATE(5109)] = 78637,
  [SMALL_STATE(5110)] = 78748,
  [SMALL_STATE(5111)] = 78885,
  [SMALL_STATE(5112)] = 79022,
  [SMALL_STATE(5113)] = 79159,
  [SMALL_STATE(5114)] = 79282,
  [SMALL_STATE(5115)] = 79415,
  [SMALL_STATE(5116)] = 79526,
  [SMALL_STATE(5117)] = 79613,
  [SMALL_STATE(5118)] = 79750,
  [SMALL_STATE(5119)] = 79887,
  [SMALL_STATE(5120)] = 80018,
  [SMALL_STATE(5121)] = 80117,
  [SMALL_STATE(5122)] = 80200,
  [SMALL_STATE(5123)] = 80301,
  [SMALL_STATE(5124)] = 80400,
  [SMALL_STATE(5125)] = 80499,
  [SMALL_STATE(5126)] = 80588,
  [SMALL_STATE(5127)] = 80725,
  [SMALL_STATE(5128)] = 80850,
  [SMALL_STATE(5129)] = 80933,
  [SMALL_STATE(5130)] = 81044,
  [SMALL_STATE(5131)] = 81127,
  [SMALL_STATE(5132)] = 81214,
  [SMALL_STATE(5133)] = 81325,
  [SMALL_STATE(5134)] = 81436,
  [SMALL_STATE(5135)] = 81567,
  [SMALL_STATE(5136)] = 81696,
  [SMALL_STATE(5137)] = 81783,
  [SMALL_STATE(5138)] = 81874,
  [SMALL_STATE(5139)] = 82011,
  [SMALL_STATE(5140)] = 82112,
  [SMALL_STATE(5141)] = 82239,
  [SMALL_STATE(5142)] = 82376,
  [SMALL_STATE(5143)] = 82513,
  [SMALL_STATE(5144)] = 82650,
  [SMALL_STATE(5145)] = 82733,
  [SMALL_STATE(5146)] = 82870,
  [SMALL_STATE(5147)] = 82955,
  [SMALL_STATE(5148)] = 83092,
  [SMALL_STATE(5149)] = 83229,
  [SMALL_STATE(5150)] = 83312,
  [SMALL_STATE(5151)] = 83427,
  [SMALL_STATE(5152)] = 83536,
  [SMALL_STATE(5153)] = 83673,
  [SMALL_STATE(5154)] = 83802,
  [SMALL_STATE(5155)] = 83927,
  [SMALL_STATE(5156)] = 84038,
  [SMALL_STATE(5157)] = 84161,
  [SMALL_STATE(5158)] = 84298,
  [SMALL_STATE(5159)] = 84435,
  [SMALL_STATE(5160)] = 84572,
  [SMALL_STATE(5161)] = 84659,
  [SMALL_STATE(5162)] = 84796,
  [SMALL_STATE(5163)] = 84907,
  [SMALL_STATE(5164)] = 85044,
  [SMALL_STATE(5165)] = 85181,
  [SMALL_STATE(5166)] = 85314,
  [SMALL_STATE(5167)] = 85451,
  [SMALL_STATE(5168)] = 85588,
  [SMALL_STATE(5169)] = 85725,
  [SMALL_STATE(5170)] = 85862,
  [SMALL_STATE(5171)] = 85973,
  [SMALL_STATE(5172)] = 86078,
  [SMALL_STATE(5173)] = 86187,
  [SMALL_STATE(5174)] = 86302,
  [SMALL_STATE(5175)] = 86439,
  [SMALL_STATE(5176)] = 86540,
  [SMALL_STATE(5177)] = 86677,
  [SMALL_STATE(5178)] = 86814,
  [SMALL_STATE(5179)] = 86951,
  [SMALL_STATE(5180)] = 87088,
  [SMALL_STATE(5181)] = 87189,
  [SMALL_STATE(5182)] = 87326,
  [SMALL_STATE(5183)] = 87463,
  [SMALL_STATE(5184)] = 87568,
  [SMALL_STATE(5185)] = 87705,
  [SMALL_STATE(5186)] = 87842,
  [SMALL_STATE(5187)] = 87979,
  [SMALL_STATE(5188)] = 88116,
  [SMALL_STATE(5189)] = 88203,
  [SMALL_STATE(5190)] = 88290,
  [SMALL_STATE(5191)] = 88377,
  [SMALL_STATE(5192)] = 88492,
  [SMALL_STATE(5193)] = 88583,
  [SMALL_STATE(5194)] = 88692,
  [SMALL_STATE(5195)] = 88793,
  [SMALL_STATE(5196)] = 88930,
  [SMALL_STATE(5197)] = 89035,
  [SMALL_STATE(5198)] = 89162,
  [SMALL_STATE(5199)] = 89291,
  [SMALL_STATE(5200)] = 89416,
  [SMALL_STATE(5201)] = 89527,
  [SMALL_STATE(5202)] = 89612,
  [SMALL_STATE(5203)] = 89735,
  [SMALL_STATE(5204)] = 89866,
  [SMALL_STATE(5205)] = 89999,
  [SMALL_STATE(5206)] = 90100,
  [SMALL_STATE(5207)] = 90237,
  [SMALL_STATE(5208)] = 90338,
  [SMALL_STATE(5209)] = 90475,
  [SMALL_STATE(5210)] = 90576,
  [SMALL_STATE(5211)] = 90676,
  [SMALL_STATE(5212)] = 90758,
  [SMALL_STATE(5213)] = 90844,
  [SMALL_STATE(5214)] = 90980,
  [SMALL_STATE(5215)] = 91116,
  [SMALL_STATE(5216)] = 91252,
  [SMALL_STATE(5217)] = 91362,
  [SMALL_STATE(5218)] = 91466,
  [SMALL_STATE(5219)] = 91574,
  [SMALL_STATE(5220)] = 91688,
  [SMALL_STATE(5221)] = 91824,
  [SMALL_STATE(5222)] = 91960,
  [SMALL_STATE(5223)] = 92060,
  [SMALL_STATE(5224)] = 92202,
  [SMALL_STATE(5225)] = 92288,
  [SMALL_STATE(5226)] = 92424,
  [SMALL_STATE(5227)] = 92560,
  [SMALL_STATE(5228)] = 92696,
  [SMALL_STATE(5229)] = 92796,
  [SMALL_STATE(5230)] = 92932,
  [SMALL_STATE(5231)] = 93046,
  [SMALL_STATE(5232)] = 93154,
  [SMALL_STATE(5233)] = 93264,
  [SMALL_STATE(5234)] = 93350,
  [SMALL_STATE(5235)] = 93436,
  [SMALL_STATE(5236)] = 93572,
  [SMALL_STATE(5237)] = 93672,
  [SMALL_STATE(5238)] = 93760,
  [SMALL_STATE(5239)] = 93896,
  [SMALL_STATE(5240)] = 94032,
  [SMALL_STATE(5241)] = 94118,
  [SMALL_STATE(5242)] = 94222,
  [SMALL_STATE(5243)] = 94358,
  [SMALL_STATE(5244)] = 94444,
  [SMALL_STATE(5245)] = 94544,
  [SMALL_STATE(5246)] = 94626,
  [SMALL_STATE(5247)] = 94762,
  [SMALL_STATE(5248)] = 94898,
  [SMALL_STATE(5249)] = 95034,
  [SMALL_STATE(5250)] = 95170,
  [SMALL_STATE(5251)] = 95306,
  [SMALL_STATE(5252)] = 95442,
  [SMALL_STATE(5253)] = 95584,
  [SMALL_STATE(5254)] = 95694,
  [SMALL_STATE(5255)] = 95776,
  [SMALL_STATE(5256)] = 95860,
  [SMALL_STATE(5257)] = 95974,
  [SMALL_STATE(5258)] = 96064,
  [SMALL_STATE(5259)] = 96146,
  [SMALL_STATE(5260)] = 96254,
  [SMALL_STATE(5261)] = 96358,
  [SMALL_STATE(5262)] = 96440,
  [SMALL_STATE(5263)] = 96522,
  [SMALL_STATE(5264)] = 96648,
  [SMALL_STATE(5265)] = 96776,
  [SMALL_STATE(5266)] = 96876,
  [SMALL_STATE(5267)] = 97012,
  [SMALL_STATE(5268)] = 97136,
  [SMALL_STATE(5269)] = 97246,
  [SMALL_STATE(5270)] = 97368,
  [SMALL_STATE(5271)] = 97498,
  [SMALL_STATE(5272)] = 97584,
  [SMALL_STATE(5273)] = 97666,
  [SMALL_STATE(5274)] = 97766,
  [SMALL_STATE(5275)] = 97898,
  [SMALL_STATE(5276)] = 98034,
  [SMALL_STATE(5277)] = 98116,
  [SMALL_STATE(5278)] = 98200,
  [SMALL_STATE(5279)] = 98336,
  [SMALL_STATE(5280)] = 98472,
  [SMALL_STATE(5281)] = 98586,
  [SMALL_STATE(5282)] = 98694,
  [SMALL_STATE(5283)] = 98798,
  [SMALL_STATE(5284)] = 98908,
  [SMALL_STATE(5285)] = 99050,
  [SMALL_STATE(5286)] = 99192,
  [SMALL_STATE(5287)] = 99328,
  [SMALL_STATE(5288)] = 99464,
  [SMALL_STATE(5289)] = 99600,
  [SMALL_STATE(5290)] = 99736,
  [SMALL_STATE(5291)] = 99872,
  [SMALL_STATE(5292)] = 100008,
  [SMALL_STATE(5293)] = 100144,
  [SMALL_STATE(5294)] = 100232,
  [SMALL_STATE(5295)] = 100368,
  [SMALL_STATE(5296)] = 100454,
  [SMALL_STATE(5297)] = 100540,
  [SMALL_STATE(5298)] = 100676,
  [SMALL_STATE(5299)] = 100760,
  [SMALL_STATE(5300)] = 100896,
  [SMALL_STATE(5301)] = 101032,
  [SMALL_STATE(5302)] = 101114,
  [SMALL_STATE(5303)] = 101196,
  [SMALL_STATE(5304)] = 101280,
  [SMALL_STATE(5305)] = 101380,
  [SMALL_STATE(5306)] = 101516,
  [SMALL_STATE(5307)] = 101642,
  [SMALL_STATE(5308)] = 101770,
  [SMALL_STATE(5309)] = 101906,
  [SMALL_STATE(5310)] = 102030,
  [SMALL_STATE(5311)] = 102166,
  [SMALL_STATE(5312)] = 102288,
  [SMALL_STATE(5313)] = 102424,
  [SMALL_STATE(5314)] = 102508,
  [SMALL_STATE(5315)] = 102592,
  [SMALL_STATE(5316)] = 102674,
  [SMALL_STATE(5317)] = 102810,
  [SMALL_STATE(5318)] = 102892,
  [SMALL_STATE(5319)] = 103000,
  [SMALL_STATE(5320)] = 103082,
  [SMALL_STATE(5321)] = 103224,
  [SMALL_STATE(5322)] = 103306,
  [SMALL_STATE(5323)] = 103436,
  [SMALL_STATE(5324)] = 103568,
  [SMALL_STATE(5325)] = 103704,
  [SMALL_STATE(5326)] = 103840,
  [SMALL_STATE(5327)] = 103976,
  [SMALL_STATE(5328)] = 104118,
  [SMALL_STATE(5329)] = 104244,
  [SMALL_STATE(5330)] = 104372,
  [SMALL_STATE(5331)] = 104496,
  [SMALL_STATE(5332)] = 104640,
  [SMALL_STATE(5333)] = 104728,
  [SMALL_STATE(5334)] = 104810,
  [SMALL_STATE(5335)] = 104932,
  [SMALL_STATE(5336)] = 105068,
  [SMALL_STATE(5337)] = 105198,
  [SMALL_STATE(5338)] = 105330,
  [SMALL_STATE(5339)] = 105416,
  [SMALL_STATE(5340)] = 105552,
  [SMALL_STATE(5341)] = 105688,
  [SMALL_STATE(5342)] = 105824,
  [SMALL_STATE(5343)] = 105924,
  [SMALL_STATE(5344)] = 106008,
  [SMALL_STATE(5345)] = 106090,
  [SMALL_STATE(5346)] = 106226,
  [SMALL_STATE(5347)] = 106362,
  [SMALL_STATE(5348)] = 106448,
  [SMALL_STATE(5349)] = 106592,
  [SMALL_STATE(5350)] = 106728,
  [SMALL_STATE(5351)] = 106864,
  [SMALL_STATE(5352)] = 107000,
  [SMALL_STATE(5353)] = 107136,
  [SMALL_STATE(5354)] = 107246,
  [SMALL_STATE(5355)] = 107346,
  [SMALL_STATE(5356)] = 107432,
  [SMALL_STATE(5357)] = 107516,
  [SMALL_STATE(5358)] = 107642,
  [SMALL_STATE(5359)] = 107724,
  [SMALL_STATE(5360)] = 107806,
  [SMALL_STATE(5361)] = 107888,
  [SMALL_STATE(5362)] = 107970,
  [SMALL_STATE(5363)] = 108052,
  [SMALL_STATE(5364)] = 108194,
  [SMALL_STATE(5365)] = 108276,
  [SMALL_STATE(5366)] = 108358,
  [SMALL_STATE(5367)] = 108486,
  [SMALL_STATE(5368)] = 108610,
  [SMALL_STATE(5369)] = 108698,
  [SMALL_STATE(5370)] = 108780,
  [SMALL_STATE(5371)] = 108902,
  [SMALL_STATE(5372)] = 108984,
  [SMALL_STATE(5373)] = 109066,
  [SMALL_STATE(5374)] = 109148,
  [SMALL_STATE(5375)] = 109278,
  [SMALL_STATE(5376)] = 109360,
  [SMALL_STATE(5377)] = 109444,
  [SMALL_STATE(5378)] = 109576,
  [SMALL_STATE(5379)] = 109712,
  [SMALL_STATE(5380)] = 109794,
  [SMALL_STATE(5381)] = 109876,
  [SMALL_STATE(5382)] = 109966,
  [SMALL_STATE(5383)] = 110101,
  [SMALL_STATE(5384)] = 110182,
  [SMALL_STATE(5385)] = 110281,
  [SMALL_STATE(5386)] = 110362,
  [SMALL_STATE(5387)] = 110443,
  [SMALL_STATE(5388)] = 110578,
  [SMALL_STATE(5389)] = 110713,
  [SMALL_STATE(5390)] = 110794,
  [SMALL_STATE(5391)] = 110875,
  [SMALL_STATE(5392)] = 111010,
  [SMALL_STATE(5393)] = 111091,
  [SMALL_STATE(5394)] = 111176,
  [SMALL_STATE(5395)] = 111311,
  [SMALL_STATE(5396)] = 111396,
  [SMALL_STATE(5397)] = 111477,
  [SMALL_STATE(5398)] = 111612,
  [SMALL_STATE(5399)] = 111693,
  [SMALL_STATE(5400)] = 111774,
  [SMALL_STATE(5401)] = 111855,
  [SMALL_STATE(5402)] = 111936,
  [SMALL_STATE(5403)] = 112071,
  [SMALL_STATE(5404)] = 112152,
  [SMALL_STATE(5405)] = 112233,
  [SMALL_STATE(5406)] = 112368,
  [SMALL_STATE(5407)] = 112449,
  [SMALL_STATE(5408)] = 112530,
  [SMALL_STATE(5409)] = 112615,
  [SMALL_STATE(5410)] = 112698,
  [SMALL_STATE(5411)] = 112779,
  [SMALL_STATE(5412)] = 112860,
  [SMALL_STATE(5413)] = 112941,
  [SMALL_STATE(5414)] = 113022,
  [SMALL_STATE(5415)] = 113131,
  [SMALL_STATE(5416)] = 113238,
  [SMALL_STATE(5417)] = 113351,
  [SMALL_STATE(5418)] = 113486,
  [SMALL_STATE(5419)] = 113621,
  [SMALL_STATE(5420)] = 113720,
  [SMALL_STATE(5421)] = 113855,
  [SMALL_STATE(5422)] = 113940,
  [SMALL_STATE(5423)] = 114037,
  [SMALL_STATE(5424)] = 114118,
  [SMALL_STATE(5425)] = 114199,
  [SMALL_STATE(5426)] = 114280,
  [SMALL_STATE(5427)] = 114361,
  [SMALL_STATE(5428)] = 114442,
  [SMALL_STATE(5429)] = 114577,
  [SMALL_STATE(5430)] = 114686,
  [SMALL_STATE(5431)] = 114775,
  [SMALL_STATE(5432)] = 114888,
  [SMALL_STATE(5433)] = 114995,
  [SMALL_STATE(5434)] = 115120,
  [SMALL_STATE(5435)] = 115247,
  [SMALL_STATE(5436)] = 115370,
  [SMALL_STATE(5437)] = 115479,
  [SMALL_STATE(5438)] = 115564,
  [SMALL_STATE(5439)] = 115645,
  [SMALL_STATE(5440)] = 115730,
  [SMALL_STATE(5441)] = 115811,
  [SMALL_STATE(5442)] = 115946,
  [SMALL_STATE(5443)] = 116081,
  [SMALL_STATE(5444)] = 116216,
  [SMALL_STATE(5445)] = 116347,
  [SMALL_STATE(5446)] = 116428,
  [SMALL_STATE(5447)] = 116557,
  [SMALL_STATE(5448)] = 116656,
  [SMALL_STATE(5449)] = 116777,
  [SMALL_STATE(5450)] = 116912,
  [SMALL_STATE(5451)] = 116993,
  [SMALL_STATE(5452)] = 117116,
  [SMALL_STATE(5453)] = 117243,
  [SMALL_STATE(5454)] = 117364,
  [SMALL_STATE(5455)] = 117489,
  [SMALL_STATE(5456)] = 117592,
  [SMALL_STATE(5457)] = 117699,
  [SMALL_STATE(5458)] = 117812,
  [SMALL_STATE(5459)] = 117941,
  [SMALL_STATE(5460)] = 118072,
  [SMALL_STATE(5461)] = 118155,
  [SMALL_STATE(5462)] = 118290,
  [SMALL_STATE(5463)] = 118373,
  [SMALL_STATE(5464)] = 118454,
  [SMALL_STATE(5465)] = 118535,
  [SMALL_STATE(5466)] = 118616,
  [SMALL_STATE(5467)] = 118697,
  [SMALL_STATE(5468)] = 118778,
  [SMALL_STATE(5469)] = 118913,
  [SMALL_STATE(5470)] = 119012,
  [SMALL_STATE(5471)] = 119147,
  [SMALL_STATE(5472)] = 119282,
  [SMALL_STATE(5473)] = 119379,
  [SMALL_STATE(5474)] = 119482,
  [SMALL_STATE(5475)] = 119617,
  [SMALL_STATE(5476)] = 119752,
  [SMALL_STATE(5477)] = 119887,
  [SMALL_STATE(5478)] = 120022,
  [SMALL_STATE(5479)] = 120157,
  [SMALL_STATE(5480)] = 120292,
  [SMALL_STATE(5481)] = 120427,
  [SMALL_STATE(5482)] = 120562,
  [SMALL_STATE(5483)] = 120675,
  [SMALL_STATE(5484)] = 120782,
  [SMALL_STATE(5485)] = 120907,
  [SMALL_STATE(5486)] = 121034,
  [SMALL_STATE(5487)] = 121157,
  [SMALL_STATE(5488)] = 121266,
  [SMALL_STATE(5489)] = 121387,
  [SMALL_STATE(5490)] = 121516,
  [SMALL_STATE(5491)] = 121647,
  [SMALL_STATE(5492)] = 121782,
  [SMALL_STATE(5493)] = 121917,
  [SMALL_STATE(5494)] = 122052,
  [SMALL_STATE(5495)] = 122187,
  [SMALL_STATE(5496)] = 122322,
  [SMALL_STATE(5497)] = 122457,
  [SMALL_STATE(5498)] = 122592,
  [SMALL_STATE(5499)] = 122727,
  [SMALL_STATE(5500)] = 122862,
  [SMALL_STATE(5501)] = 122997,
  [SMALL_STATE(5502)] = 123080,
  [SMALL_STATE(5503)] = 123215,
  [SMALL_STATE(5504)] = 123350,
  [SMALL_STATE(5505)] = 123485,
  [SMALL_STATE(5506)] = 123566,
  [SMALL_STATE(5507)] = 123701,
  [SMALL_STATE(5508)] = 123836,
  [SMALL_STATE(5509)] = 123917,
  [SMALL_STATE(5510)] = 124002,
  [SMALL_STATE(5511)] = 124137,
  [SMALL_STATE(5512)] = 124220,
  [SMALL_STATE(5513)] = 124305,
  [SMALL_STATE(5514)] = 124386,
  [SMALL_STATE(5515)] = 124521,
  [SMALL_STATE(5516)] = 124604,
  [SMALL_STATE(5517)] = 124685,
  [SMALL_STATE(5518)] = 124820,
  [SMALL_STATE(5519)] = 124955,
  [SMALL_STATE(5520)] = 125090,
  [SMALL_STATE(5521)] = 125225,
  [SMALL_STATE(5522)] = 125360,
  [SMALL_STATE(5523)] = 125495,
  [SMALL_STATE(5524)] = 125626,
  [SMALL_STATE(5525)] = 125755,
  [SMALL_STATE(5526)] = 125854,
  [SMALL_STATE(5527)] = 125975,
  [SMALL_STATE(5528)] = 126098,
  [SMALL_STATE(5529)] = 126225,
  [SMALL_STATE(5530)] = 126350,
  [SMALL_STATE(5531)] = 126485,
  [SMALL_STATE(5532)] = 126584,
  [SMALL_STATE(5533)] = 126719,
  [SMALL_STATE(5534)] = 126854,
  [SMALL_STATE(5535)] = 126963,
  [SMALL_STATE(5536)] = 127066,
  [SMALL_STATE(5537)] = 127173,
  [SMALL_STATE(5538)] = 127286,
  [SMALL_STATE(5539)] = 127371,
  [SMALL_STATE(5540)] = 127506,
  [SMALL_STATE(5541)] = 127641,
  [SMALL_STATE(5542)] = 127776,
  [SMALL_STATE(5543)] = 127911,
  [SMALL_STATE(5544)] = 127992,
  [SMALL_STATE(5545)] = 128127,
  [SMALL_STATE(5546)] = 128208,
  [SMALL_STATE(5547)] = 128293,
  [SMALL_STATE(5548)] = 128428,
  [SMALL_STATE(5549)] = 128513,
  [SMALL_STATE(5550)] = 128594,
  [SMALL_STATE(5551)] = 128675,
  [SMALL_STATE(5552)] = 128810,
  [SMALL_STATE(5553)] = 128945,
  [SMALL_STATE(5554)] = 129080,
  [SMALL_STATE(5555)] = 129215,
  [SMALL_STATE(5556)] = 129314,
  [SMALL_STATE(5557)] = 129395,
  [SMALL_STATE(5558)] = 129530,
  [SMALL_STATE(5559)] = 129611,
  [SMALL_STATE(5560)] = 129746,
  [SMALL_STATE(5561)] = 129849,
  [SMALL_STATE(5562)] = 129930,
  [SMALL_STATE(5563)] = 130065,
  [SMALL_STATE(5564)] = 130164,
  [SMALL_STATE(5565)] = 130299,
  [SMALL_STATE(5566)] = 130424,
  [SMALL_STATE(5567)] = 130551,
  [SMALL_STATE(5568)] = 130658,
  [SMALL_STATE(5569)] = 130781,
  [SMALL_STATE(5570)] = 130902,
  [SMALL_STATE(5571)] = 130983,
  [SMALL_STATE(5572)] = 131112,
  [SMALL_STATE(5573)] = 131243,
  [SMALL_STATE(5574)] = 131324,
  [SMALL_STATE(5575)] = 131459,
  [SMALL_STATE(5576)] = 131594,
  [SMALL_STATE(5577)] = 131729,
  [SMALL_STATE(5578)] = 131864,
  [SMALL_STATE(5579)] = 131999,
  [SMALL_STATE(5580)] = 132080,
  [SMALL_STATE(5581)] = 132215,
  [SMALL_STATE(5582)] = 132350,
  [SMALL_STATE(5583)] = 132475,
  [SMALL_STATE(5584)] = 132602,
  [SMALL_STATE(5585)] = 132725,
  [SMALL_STATE(5586)] = 132846,
  [SMALL_STATE(5587)] = 132945,
  [SMALL_STATE(5588)] = 133074,
  [SMALL_STATE(5589)] = 133205,
  [SMALL_STATE(5590)] = 133340,
  [SMALL_STATE(5591)] = 133475,
  [SMALL_STATE(5592)] = 133610,
  [SMALL_STATE(5593)] = 133745,
  [SMALL_STATE(5594)] = 133880,
  [SMALL_STATE(5595)] = 133967,
  [SMALL_STATE(5596)] = 134048,
  [SMALL_STATE(5597)] = 134183,
  [SMALL_STATE(5598)] = 134318,
  [SMALL_STATE(5599)] = 134453,
  [SMALL_STATE(5600)] = 134588,
  [SMALL_STATE(5601)] = 134723,
  [SMALL_STATE(5602)] = 134858,
  [SMALL_STATE(5603)] = 134993,
  [SMALL_STATE(5604)] = 135128,
  [SMALL_STATE(5605)] = 135209,
  [SMALL_STATE(5606)] = 135290,
  [SMALL_STATE(5607)] = 135425,
  [SMALL_STATE(5608)] = 135506,
  [SMALL_STATE(5609)] = 135587,
  [SMALL_STATE(5610)] = 135668,
  [SMALL_STATE(5611)] = 135803,
  [SMALL_STATE(5612)] = 135884,
  [SMALL_STATE(5613)] = 136019,
  [SMALL_STATE(5614)] = 136100,
  [SMALL_STATE(5615)] = 136235,
  [SMALL_STATE(5616)] = 136370,
  [SMALL_STATE(5617)] = 136505,
  [SMALL_STATE(5618)] = 136586,
  [SMALL_STATE(5619)] = 136689,
  [SMALL_STATE(5620)] = 136824,
  [SMALL_STATE(5621)] = 136949,
  [SMALL_STATE(5622)] = 137030,
  [SMALL_STATE(5623)] = 137111,
  [SMALL_STATE(5624)] = 137238,
  [SMALL_STATE(5625)] = 137361,
  [SMALL_STATE(5626)] = 137482,
  [SMALL_STATE(5627)] = 137611,
  [SMALL_STATE(5628)] = 137736,
  [SMALL_STATE(5629)] = 137863,
  [SMALL_STATE(5630)] = 137986,
  [SMALL_STATE(5631)] = 138117,
  [SMALL_STATE(5632)] = 138238,
  [SMALL_STATE(5633)] = 138373,
  [SMALL_STATE(5634)] = 138502,
  [SMALL_STATE(5635)] = 138633,
  [SMALL_STATE(5636)] = 138768,
  [SMALL_STATE(5637)] = 138903,
  [SMALL_STATE(5638)] = 139038,
  [SMALL_STATE(5639)] = 139173,
  [SMALL_STATE(5640)] = 139254,
  [SMALL_STATE(5641)] = 139389,
  [SMALL_STATE(5642)] = 139524,
  [SMALL_STATE(5643)] = 139605,
  [SMALL_STATE(5644)] = 139686,
  [SMALL_STATE(5645)] = 139767,
  [SMALL_STATE(5646)] = 139848,
  [SMALL_STATE(5647)] = 139983,
  [SMALL_STATE(5648)] = 140064,
  [SMALL_STATE(5649)] = 140199,
  [SMALL_STATE(5650)] = 140280,
  [SMALL_STATE(5651)] = 140361,
  [SMALL_STATE(5652)] = 140496,
  [SMALL_STATE(5653)] = 140631,
  [SMALL_STATE(5654)] = 140766,
  [SMALL_STATE(5655)] = 140863,
  [SMALL_STATE(5656)] = 140944,
  [SMALL_STATE(5657)] = 141029,
  [SMALL_STATE(5658)] = 141112,
  [SMALL_STATE(5659)] = 141197,
  [SMALL_STATE(5660)] = 141278,
  [SMALL_STATE(5661)] = 141363,
  [SMALL_STATE(5662)] = 141448,
  [SMALL_STATE(5663)] = 141529,
  [SMALL_STATE(5664)] = 141632,
  [SMALL_STATE(5665)] = 141767,
  [SMALL_STATE(5666)] = 141880,
  [SMALL_STATE(5667)] = 141987,
  [SMALL_STATE(5668)] = 142096,
  [SMALL_STATE(5669)] = 142195,
  [SMALL_STATE(5670)] = 142302,
  [SMALL_STATE(5671)] = 142437,
  [SMALL_STATE(5672)] = 142518,
  [SMALL_STATE(5673)] = 142599,
  [SMALL_STATE(5674)] = 142680,
  [SMALL_STATE(5675)] = 142761,
  [SMALL_STATE(5676)] = 142842,
  [SMALL_STATE(5677)] = 142977,
  [SMALL_STATE(5678)] = 143112,
  [SMALL_STATE(5679)] = 143211,
  [SMALL_STATE(5680)] = 143292,
  [SMALL_STATE(5681)] = 143373,
  [SMALL_STATE(5682)] = 143514,
  [SMALL_STATE(5683)] = 143595,
  [SMALL_STATE(5684)] = 143694,
  [SMALL_STATE(5685)] = 143797,
  [SMALL_STATE(5686)] = 143910,
  [SMALL_STATE(5687)] = 143995,
  [SMALL_STATE(5688)] = 144102,
  [SMALL_STATE(5689)] = 144205,
  [SMALL_STATE(5690)] = 144290,
  [SMALL_STATE(5691)] = 144375,
  [SMALL_STATE(5692)] = 144500,
  [SMALL_STATE(5693)] = 144635,
  [SMALL_STATE(5694)] = 144770,
  [SMALL_STATE(5695)] = 144905,
  [SMALL_STATE(5696)] = 145032,
  [SMALL_STATE(5697)] = 145155,
  [SMALL_STATE(5698)] = 145254,
  [SMALL_STATE(5699)] = 145357,
  [SMALL_STATE(5700)] = 145466,
  [SMALL_STATE(5701)] = 145601,
  [SMALL_STATE(5702)] = 145682,
  [SMALL_STATE(5703)] = 145781,
  [SMALL_STATE(5704)] = 145916,
  [SMALL_STATE(5705)] = 146037,
  [SMALL_STATE(5706)] = 146136,
  [SMALL_STATE(5707)] = 146235,
  [SMALL_STATE(5708)] = 146334,
  [SMALL_STATE(5709)] = 146443,
  [SMALL_STATE(5710)] = 146580,
  [SMALL_STATE(5711)] = 146687,
  [SMALL_STATE(5712)] = 146800,
  [SMALL_STATE(5713)] = 146929,
  [SMALL_STATE(5714)] = 147060,
  [SMALL_STATE(5715)] = 147157,
  [SMALL_STATE(5716)] = 147292,
  [SMALL_STATE(5717)] = 147375,
  [SMALL_STATE(5718)] = 147456,
  [SMALL_STATE(5719)] = 147591,
  [SMALL_STATE(5720)] = 147672,
  [SMALL_STATE(5721)] = 147807,
  [SMALL_STATE(5722)] = 147888,
  [SMALL_STATE(5723)] = 148023,
  [SMALL_STATE(5724)] = 148104,
  [SMALL_STATE(5725)] = 148239,
  [SMALL_STATE(5726)] = 148338,
  [SMALL_STATE(5727)] = 148473,
  [SMALL_STATE(5728)] = 148608,
  [SMALL_STATE(5729)] = 148743,
  [SMALL_STATE(5730)] = 148878,
  [SMALL_STATE(5731)] = 148959,
  [SMALL_STATE(5732)] = 149040,
  [SMALL_STATE(5733)] = 149125,
  [SMALL_STATE(5734)] = 149206,
  [SMALL_STATE(5735)] = 149287,
  [SMALL_STATE(5736)] = 149368,
  [SMALL_STATE(5737)] = 149503,
  [SMALL_STATE(5738)] = 149634,
  [SMALL_STATE(5739)] = 149763,
  [SMALL_STATE(5740)] = 149862,
  [SMALL_STATE(5741)] = 149943,
  [SMALL_STATE(5742)] = 150040,
  [SMALL_STATE(5743)] = 150123,
  [SMALL_STATE(5744)] = 150236,
  [SMALL_STATE(5745)] = 150343,
  [SMALL_STATE(5746)] = 150452,
  [SMALL_STATE(5747)] = 150573,
  [SMALL_STATE(5748)] = 150672,
  [SMALL_STATE(5749)] = 150781,
  [SMALL_STATE(5750)] = 150894,
  [SMALL_STATE(5751)] = 151017,
  [SMALL_STATE(5752)] = 151144,
  [SMALL_STATE(5753)] = 151269,
  [SMALL_STATE(5754)] = 151372,
  [SMALL_STATE(5755)] = 151470,
  [SMALL_STATE(5756)] = 151592,
  [SMALL_STATE(5757)] = 151718,
  [SMALL_STATE(5758)] = 151842,
  [SMALL_STATE(5759)] = 151948,
  [SMALL_STATE(5760)] = 152060,
  [SMALL_STATE(5761)] = 152194,
  [SMALL_STATE(5762)] = 152328,
  [SMALL_STATE(5763)] = 152462,
  [SMALL_STATE(5764)] = 152596,
  [SMALL_STATE(5765)] = 152704,
  [SMALL_STATE(5766)] = 152842,
  [SMALL_STATE(5767)] = 152950,
  [SMALL_STATE(5768)] = 153084,
  [SMALL_STATE(5769)] = 153222,
  [SMALL_STATE(5770)] = 153356,
  [SMALL_STATE(5771)] = 153464,
  [SMALL_STATE(5772)] = 153584,
  [SMALL_STATE(5773)] = 153686,
  [SMALL_STATE(5774)] = 153784,
  [SMALL_STATE(5775)] = 153918,
  [SMALL_STATE(5776)] = 154052,
  [SMALL_STATE(5777)] = 154186,
  [SMALL_STATE(5778)] = 154320,
  [SMALL_STATE(5779)] = 154454,
  [SMALL_STATE(5780)] = 154588,
  [SMALL_STATE(5781)] = 154722,
  [SMALL_STATE(5782)] = 154856,
  [SMALL_STATE(5783)] = 154990,
  [SMALL_STATE(5784)] = 155124,
  [SMALL_STATE(5785)] = 155262,
  [SMALL_STATE(5786)] = 155396,
  [SMALL_STATE(5787)] = 155508,
  [SMALL_STATE(5788)] = 155606,
  [SMALL_STATE(5789)] = 155740,
  [SMALL_STATE(5790)] = 155846,
  [SMALL_STATE(5791)] = 155948,
  [SMALL_STATE(5792)] = 156072,
  [SMALL_STATE(5793)] = 156198,
  [SMALL_STATE(5794)] = 156320,
  [SMALL_STATE(5795)] = 156428,
  [SMALL_STATE(5796)] = 156548,
  [SMALL_STATE(5797)] = 156684,
  [SMALL_STATE(5798)] = 156782,
  [SMALL_STATE(5799)] = 156910,
  [SMALL_STATE(5800)] = 157040,
  [SMALL_STATE(5801)] = 157174,
  [SMALL_STATE(5802)] = 157272,
  [SMALL_STATE(5803)] = 157408,
  [SMALL_STATE(5804)] = 157546,
  [SMALL_STATE(5805)] = 157644,
  [SMALL_STATE(5806)] = 157782,
  [SMALL_STATE(5807)] = 157910,
  [SMALL_STATE(5808)] = 158040,
  [SMALL_STATE(5809)] = 158178,
  [SMALL_STATE(5810)] = 158312,
  [SMALL_STATE(5811)] = 158446,
  [SMALL_STATE(5812)] = 158580,
  [SMALL_STATE(5813)] = 158714,
  [SMALL_STATE(5814)] = 158844,
  [SMALL_STATE(5815)] = 158952,
  [SMALL_STATE(5816)] = 159080,
  [SMALL_STATE(5817)] = 159200,
  [SMALL_STATE(5818)] = 159308,
  [SMALL_STATE(5819)] = 159410,
  [SMALL_STATE(5820)] = 159532,
  [SMALL_STATE(5821)] = 159658,
  [SMALL_STATE(5822)] = 159792,
  [SMALL_STATE(5823)] = 159916,
  [SMALL_STATE(5824)] = 160022,
  [SMALL_STATE(5825)] = 160134,
  [SMALL_STATE(5826)] = 160268,
  [SMALL_STATE(5827)] = 160402,
  [SMALL_STATE(5828)] = 160536,
  [SMALL_STATE(5829)] = 160674,
  [SMALL_STATE(5830)] = 160782,
  [SMALL_STATE(5831)] = 160880,
  [SMALL_STATE(5832)] = 161014,
  [SMALL_STATE(5833)] = 161148,
  [SMALL_STATE(5834)] = 161282,
  [SMALL_STATE(5835)] = 161390,
  [SMALL_STATE(5836)] = 161488,
  [SMALL_STATE(5837)] = 161622,
  [SMALL_STATE(5838)] = 161730,
  [SMALL_STATE(5839)] = 161864,
  [SMALL_STATE(5840)] = 161998,
  [SMALL_STATE(5841)] = 162100,
  [SMALL_STATE(5842)] = 162208,
  [SMALL_STATE(5843)] = 162342,
  [SMALL_STATE(5844)] = 162426,
  [SMALL_STATE(5845)] = 162560,
  [SMALL_STATE(5846)] = 162694,
  [SMALL_STATE(5847)] = 162828,
  [SMALL_STATE(5848)] = 162936,
  [SMALL_STATE(5849)] = 163070,
  [SMALL_STATE(5850)] = 163204,
  [SMALL_STATE(5851)] = 163302,
  [SMALL_STATE(5852)] = 163404,
  [SMALL_STATE(5853)] = 163512,
  [SMALL_STATE(5854)] = 163650,
  [SMALL_STATE(5855)] = 163758,
  [SMALL_STATE(5856)] = 163842,
  [SMALL_STATE(5857)] = 163940,
  [SMALL_STATE(5858)] = 164042,
  [SMALL_STATE(5859)] = 164176,
  [SMALL_STATE(5860)] = 164284,
  [SMALL_STATE(5861)] = 164418,
  [SMALL_STATE(5862)] = 164556,
  [SMALL_STATE(5863)] = 164694,
  [SMALL_STATE(5864)] = 164776,
  [SMALL_STATE(5865)] = 164884,
  [SMALL_STATE(5866)] = 164990,
  [SMALL_STATE(5867)] = 165098,
  [SMALL_STATE(5868)] = 165236,
  [SMALL_STATE(5869)] = 165348,
  [SMALL_STATE(5870)] = 165454,
  [SMALL_STATE(5871)] = 165578,
  [SMALL_STATE(5872)] = 165704,
  [SMALL_STATE(5873)] = 165806,
  [SMALL_STATE(5874)] = 165928,
  [SMALL_STATE(5875)] = 166010,
  [SMALL_STATE(5876)] = 166144,
  [SMALL_STATE(5877)] = 166252,
  [SMALL_STATE(5878)] = 166372,
  [SMALL_STATE(5879)] = 166500,
  [SMALL_STATE(5880)] = 166630,
  [SMALL_STATE(5881)] = 166764,
  [SMALL_STATE(5882)] = 166898,
  [SMALL_STATE(5883)] = 167032,
  [SMALL_STATE(5884)] = 167166,
  [SMALL_STATE(5885)] = 167300,
  [SMALL_STATE(5886)] = 167434,
  [SMALL_STATE(5887)] = 167568,
  [SMALL_STATE(5888)] = 167702,
  [SMALL_STATE(5889)] = 167836,
  [SMALL_STATE(5890)] = 167970,
  [SMALL_STATE(5891)] = 168104,
  [SMALL_STATE(5892)] = 168242,
  [SMALL_STATE(5893)] = 168380,
  [SMALL_STATE(5894)] = 168514,
  [SMALL_STATE(5895)] = 168648,
  [SMALL_STATE(5896)] = 168746,
  [SMALL_STATE(5897)] = 168880,
  [SMALL_STATE(5898)] = 169014,
  [SMALL_STATE(5899)] = 169148,
  [SMALL_STATE(5900)] = 169282,
  [SMALL_STATE(5901)] = 169416,
  [SMALL_STATE(5902)] = 169550,
  [SMALL_STATE(5903)] = 169648,
  [SMALL_STATE(5904)] = 169786,
  [SMALL_STATE(5905)] = 169924,
  [SMALL_STATE(5906)] = 170058,
  [SMALL_STATE(5907)] = 170192,
  [SMALL_STATE(5908)] = 170326,
  [SMALL_STATE(5909)] = 170424,
  [SMALL_STATE(5910)] = 170562,
  [SMALL_STATE(5911)] = 170696,
  [SMALL_STATE(5912)] = 170830,
  [SMALL_STATE(5913)] = 170912,
  [SMALL_STATE(5914)] = 171020,
  [SMALL_STATE(5915)] = 171104,
  [SMALL_STATE(5916)] = 171188,
  [SMALL_STATE(5917)] = 171326,
  [SMALL_STATE(5918)] = 171460,
  [SMALL_STATE(5919)] = 171594,
  [SMALL_STATE(5920)] = 171728,
  [SMALL_STATE(5921)] = 171862,
  [SMALL_STATE(5922)] = 171996,
  [SMALL_STATE(5923)] = 172130,
  [SMALL_STATE(5924)] = 172236,
  [SMALL_STATE(5925)] = 172370,
  [SMALL_STATE(5926)] = 172504,
  [SMALL_STATE(5927)] = 172634,
  [SMALL_STATE(5928)] = 172762,
  [SMALL_STATE(5929)] = 172882,
  [SMALL_STATE(5930)] = 172990,
  [SMALL_STATE(5931)] = 173112,
  [SMALL_STATE(5932)] = 173250,
  [SMALL_STATE(5933)] = 173388,
  [SMALL_STATE(5934)] = 173468,
  [SMALL_STATE(5935)] = 173576,
  [SMALL_STATE(5936)] = 173684,
  [SMALL_STATE(5937)] = 173818,
  [SMALL_STATE(5938)] = 173956,
  [SMALL_STATE(5939)] = 174094,
  [SMALL_STATE(5940)] = 174192,
  [SMALL_STATE(5941)] = 174326,
  [SMALL_STATE(5942)] = 174452,
  [SMALL_STATE(5943)] = 174564,
  [SMALL_STATE(5944)] = 174670,
  [SMALL_STATE(5945)] = 174752,
  [SMALL_STATE(5946)] = 174890,
  [SMALL_STATE(5947)] = 175014,
  [SMALL_STATE(5948)] = 175140,
  [SMALL_STATE(5949)] = 175278,
  [SMALL_STATE(5950)] = 175362,
  [SMALL_STATE(5951)] = 175488,
  [SMALL_STATE(5952)] = 175612,
  [SMALL_STATE(5953)] = 175734,
  [SMALL_STATE(5954)] = 175840,
  [SMALL_STATE(5955)] = 175952,
  [SMALL_STATE(5956)] = 176086,
  [SMALL_STATE(5957)] = 176216,
  [SMALL_STATE(5958)] = 176344,
  [SMALL_STATE(5959)] = 176464,
  [SMALL_STATE(5960)] = 176572,
  [SMALL_STATE(5961)] = 176694,
  [SMALL_STATE(5962)] = 176802,
  [SMALL_STATE(5963)] = 176936,
  [SMALL_STATE(5964)] = 177060,
  [SMALL_STATE(5965)] = 177162,
  [SMALL_STATE(5966)] = 177268,
  [SMALL_STATE(5967)] = 177380,
  [SMALL_STATE(5968)] = 177514,
  [SMALL_STATE(5969)] = 177622,
  [SMALL_STATE(5970)] = 177702,
  [SMALL_STATE(5971)] = 177840,
  [SMALL_STATE(5972)] = 177978,
  [SMALL_STATE(5973)] = 178086,
  [SMALL_STATE(5974)] = 178224,
  [SMALL_STATE(5975)] = 178308,
  [SMALL_STATE(5976)] = 178428,
  [SMALL_STATE(5977)] = 178556,
  [SMALL_STATE(5978)] = 178686,
  [SMALL_STATE(5979)] = 178820,
  [SMALL_STATE(5980)] = 178954,
  [SMALL_STATE(5981)] = 179092,
  [SMALL_STATE(5982)] = 179230,
  [SMALL_STATE(5983)] = 179364,
  [SMALL_STATE(5984)] = 179498,
  [SMALL_STATE(5985)] = 179596,
  [SMALL_STATE(5986)] = 179718,
  [SMALL_STATE(5987)] = 179852,
  [SMALL_STATE(5988)] = 179986,
  [SMALL_STATE(5989)] = 180120,
  [SMALL_STATE(5990)] = 180254,
  [SMALL_STATE(5991)] = 180388,
  [SMALL_STATE(5992)] = 180522,
  [SMALL_STATE(5993)] = 180604,
  [SMALL_STATE(5994)] = 180738,
  [SMALL_STATE(5995)] = 180874,
  [SMALL_STATE(5996)] = 181008,
  [SMALL_STATE(5997)] = 181142,
  [SMALL_STATE(5998)] = 181276,
  [SMALL_STATE(5999)] = 181410,
  [SMALL_STATE(6000)] = 181544,
  [SMALL_STATE(6001)] = 181628,
  [SMALL_STATE(6002)] = 181762,
  [SMALL_STATE(6003)] = 181900,
  [SMALL_STATE(6004)] = 182008,
  [SMALL_STATE(6005)] = 182142,
  [SMALL_STATE(6006)] = 182276,
  [SMALL_STATE(6007)] = 182410,
  [SMALL_STATE(6008)] = 182494,
  [SMALL_STATE(6009)] = 182628,
  [SMALL_STATE(6010)] = 182762,
  [SMALL_STATE(6011)] = 182846,
  [SMALL_STATE(6012)] = 182928,
  [SMALL_STATE(6013)] = 183062,
  [SMALL_STATE(6014)] = 183196,
  [SMALL_STATE(6015)] = 183304,
  [SMALL_STATE(6016)] = 183438,
  [SMALL_STATE(6017)] = 183572,
  [SMALL_STATE(6018)] = 183706,
  [SMALL_STATE(6019)] = 183840,
  [SMALL_STATE(6020)] = 183974,
  [SMALL_STATE(6021)] = 184072,
  [SMALL_STATE(6022)] = 184210,
  [SMALL_STATE(6023)] = 184344,
  [SMALL_STATE(6024)] = 184428,
  [SMALL_STATE(6025)] = 184566,
  [SMALL_STATE(6026)] = 184650,
  [SMALL_STATE(6027)] = 184758,
  [SMALL_STATE(6028)] = 184856,
  [SMALL_STATE(6029)] = 184940,
  [SMALL_STATE(6030)] = 185024,
  [SMALL_STATE(6031)] = 185158,
  [SMALL_STATE(6032)] = 185242,
  [SMALL_STATE(6033)] = 185376,
  [SMALL_STATE(6034)] = 185484,
  [SMALL_STATE(6035)] = 185592,
  [SMALL_STATE(6036)] = 185730,
  [SMALL_STATE(6037)] = 185814,
  [SMALL_STATE(6038)] = 185952,
  [SMALL_STATE(6039)] = 186090,
  [SMALL_STATE(6040)] = 186174,
  [SMALL_STATE(6041)] = 186312,
  [SMALL_STATE(6042)] = 186396,
  [SMALL_STATE(6043)] = 186478,
  [SMALL_STATE(6044)] = 186590,
  [SMALL_STATE(6045)] = 186674,
  [SMALL_STATE(6046)] = 186758,
  [SMALL_STATE(6047)] = 186864,
  [SMALL_STATE(6048)] = 186966,
  [SMALL_STATE(6049)] = 187090,
  [SMALL_STATE(6050)] = 187174,
  [SMALL_STATE(6051)] = 187258,
  [SMALL_STATE(6052)] = 187340,
  [SMALL_STATE(6053)] = 187474,
  [SMALL_STATE(6054)] = 187558,
  [SMALL_STATE(6055)] = 187692,
  [SMALL_STATE(6056)] = 187780,
  [SMALL_STATE(6057)] = 187906,
  [SMALL_STATE(6058)] = 188028,
  [SMALL_STATE(6059)] = 188148,
  [SMALL_STATE(6060)] = 188232,
  [SMALL_STATE(6061)] = 188340,
  [SMALL_STATE(6062)] = 188438,
  [SMALL_STATE(6063)] = 188566,
  [SMALL_STATE(6064)] = 188696,
  [SMALL_STATE(6065)] = 188834,
  [SMALL_STATE(6066)] = 188968,
  [SMALL_STATE(6067)] = 189076,
  [SMALL_STATE(6068)] = 189214,
  [SMALL_STATE(6069)] = 189352,
  [SMALL_STATE(6070)] = 189460,
  [SMALL_STATE(6071)] = 189568,
  [SMALL_STATE(6072)] = 189706,
  [SMALL_STATE(6073)] = 189844,
  [SMALL_STATE(6074)] = 189978,
  [SMALL_STATE(6075)] = 190098,
  [SMALL_STATE(6076)] = 190232,
  [SMALL_STATE(6077)] = 190370,
  [SMALL_STATE(6078)] = 190504,
  [SMALL_STATE(6079)] = 190632,
  [SMALL_STATE(6080)] = 190766,
  [SMALL_STATE(6081)] = 190904,
  [SMALL_STATE(6082)] = 191016,
  [SMALL_STATE(6083)] = 191100,
  [SMALL_STATE(6084)] = 191206,
  [SMALL_STATE(6085)] = 191336,
  [SMALL_STATE(6086)] = 191460,
  [SMALL_STATE(6087)] = 191548,
  [SMALL_STATE(6088)] = 191630,
  [SMALL_STATE(6089)] = 191756,
  [SMALL_STATE(6090)] = 191889,
  [SMALL_STATE(6091)] = 191984,
  [SMALL_STATE(6092)] = 192089,
  [SMALL_STATE(6093)] = 192216,
  [SMALL_STATE(6094)] = 192299,
  [SMALL_STATE(6095)] = 192382,
  [SMALL_STATE(6096)] = 192515,
  [SMALL_STATE(6097)] = 192612,
  [SMALL_STATE(6098)] = 192693,
  [SMALL_STATE(6099)] = 192826,
  [SMALL_STATE(6100)] = 192959,
  [SMALL_STATE(6101)] = 193042,
  [SMALL_STATE(6102)] = 193175,
  [SMALL_STATE(6103)] = 193308,
  [SMALL_STATE(6104)] = 193441,
  [SMALL_STATE(6105)] = 193522,
  [SMALL_STATE(6106)] = 193655,
  [SMALL_STATE(6107)] = 193788,
  [SMALL_STATE(6108)] = 193921,
  [SMALL_STATE(6109)] = 194054,
  [SMALL_STATE(6110)] = 194187,
  [SMALL_STATE(6111)] = 194320,
  [SMALL_STATE(6112)] = 194453,
  [SMALL_STATE(6113)] = 194534,
  [SMALL_STATE(6114)] = 194615,
  [SMALL_STATE(6115)] = 194712,
  [SMALL_STATE(6116)] = 194845,
  [SMALL_STATE(6117)] = 194926,
  [SMALL_STATE(6118)] = 195059,
  [SMALL_STATE(6119)] = 195192,
  [SMALL_STATE(6120)] = 195321,
  [SMALL_STATE(6121)] = 195454,
  [SMALL_STATE(6122)] = 195561,
  [SMALL_STATE(6123)] = 195662,
  [SMALL_STATE(6124)] = 195767,
  [SMALL_STATE(6125)] = 195878,
  [SMALL_STATE(6126)] = 195973,
  [SMALL_STATE(6127)] = 196106,
  [SMALL_STATE(6128)] = 196203,
  [SMALL_STATE(6129)] = 196308,
  [SMALL_STATE(6130)] = 196403,
  [SMALL_STATE(6131)] = 196536,
  [SMALL_STATE(6132)] = 196655,
  [SMALL_STATE(6133)] = 196776,
  [SMALL_STATE(6134)] = 196909,
  [SMALL_STATE(6135)] = 197044,
  [SMALL_STATE(6136)] = 197179,
  [SMALL_STATE(6137)] = 197304,
  [SMALL_STATE(6138)] = 197427,
  [SMALL_STATE(6139)] = 197560,
  [SMALL_STATE(6140)] = 197693,
  [SMALL_STATE(6141)] = 197788,
  [SMALL_STATE(6142)] = 197887,
  [SMALL_STATE(6143)] = 197992,
  [SMALL_STATE(6144)] = 198075,
  [SMALL_STATE(6145)] = 198158,
  [SMALL_STATE(6146)] = 198293,
  [SMALL_STATE(6147)] = 198398,
  [SMALL_STATE(6148)] = 198493,
  [SMALL_STATE(6149)] = 198588,
  [SMALL_STATE(6150)] = 198721,
  [SMALL_STATE(6151)] = 198802,
  [SMALL_STATE(6152)] = 198897,
  [SMALL_STATE(6153)] = 198978,
  [SMALL_STATE(6154)] = 199111,
  [SMALL_STATE(6155)] = 199244,
  [SMALL_STATE(6156)] = 199339,
  [SMALL_STATE(6157)] = 199474,
  [SMALL_STATE(6158)] = 199557,
  [SMALL_STATE(6159)] = 199638,
  [SMALL_STATE(6160)] = 199771,
  [SMALL_STATE(6161)] = 199852,
  [SMALL_STATE(6162)] = 199939,
  [SMALL_STATE(6163)] = 200038,
  [SMALL_STATE(6164)] = 200133,
  [SMALL_STATE(6165)] = 200228,
  [SMALL_STATE(6166)] = 200361,
  [SMALL_STATE(6167)] = 200450,
  [SMALL_STATE(6168)] = 200583,
  [SMALL_STATE(6169)] = 200712,
  [SMALL_STATE(6170)] = 200839,
  [SMALL_STATE(6171)] = 200958,
  [SMALL_STATE(6172)] = 201065,
  [SMALL_STATE(6173)] = 201186,
  [SMALL_STATE(6174)] = 201311,
  [SMALL_STATE(6175)] = 201434,
  [SMALL_STATE(6176)] = 201529,
  [SMALL_STATE(6177)] = 201630,
  [SMALL_STATE(6178)] = 201735,
  [SMALL_STATE(6179)] = 201818,
  [SMALL_STATE(6180)] = 201929,
  [SMALL_STATE(6181)] = 202062,
  [SMALL_STATE(6182)] = 202195,
  [SMALL_STATE(6183)] = 202328,
  [SMALL_STATE(6184)] = 202461,
  [SMALL_STATE(6185)] = 202544,
  [SMALL_STATE(6186)] = 202677,
  [SMALL_STATE(6187)] = 202810,
  [SMALL_STATE(6188)] = 202943,
  [SMALL_STATE(6189)] = 203076,
  [SMALL_STATE(6190)] = 203209,
  [SMALL_STATE(6191)] = 203306,
  [SMALL_STATE(6192)] = 203439,
  [SMALL_STATE(6193)] = 203572,
  [SMALL_STATE(6194)] = 203705,
  [SMALL_STATE(6195)] = 203800,
  [SMALL_STATE(6196)] = 203933,
  [SMALL_STATE(6197)] = 204066,
  [SMALL_STATE(6198)] = 204149,
  [SMALL_STATE(6199)] = 204244,
  [SMALL_STATE(6200)] = 204377,
  [SMALL_STATE(6201)] = 204458,
  [SMALL_STATE(6202)] = 204555,
  [SMALL_STATE(6203)] = 204650,
  [SMALL_STATE(6204)] = 204783,
  [SMALL_STATE(6205)] = 204878,
  [SMALL_STATE(6206)] = 204975,
  [SMALL_STATE(6207)] = 205108,
  [SMALL_STATE(6208)] = 205191,
  [SMALL_STATE(6209)] = 205324,
  [SMALL_STATE(6210)] = 205457,
  [SMALL_STATE(6211)] = 205552,
  [SMALL_STATE(6212)] = 205685,
  [SMALL_STATE(6213)] = 205818,
  [SMALL_STATE(6214)] = 205913,
  [SMALL_STATE(6215)] = 206046,
  [SMALL_STATE(6216)] = 206141,
  [SMALL_STATE(6217)] = 206236,
  [SMALL_STATE(6218)] = 206369,
  [SMALL_STATE(6219)] = 206458,
  [SMALL_STATE(6220)] = 206593,
  [SMALL_STATE(6221)] = 206726,
  [SMALL_STATE(6222)] = 206821,
  [SMALL_STATE(6223)] = 206916,
  [SMALL_STATE(6224)] = 207049,
  [SMALL_STATE(6225)] = 207182,
  [SMALL_STATE(6226)] = 207265,
  [SMALL_STATE(6227)] = 207398,
  [SMALL_STATE(6228)] = 207481,
  [SMALL_STATE(6229)] = 207562,
  [SMALL_STATE(6230)] = 207695,
  [SMALL_STATE(6231)] = 207778,
  [SMALL_STATE(6232)] = 207911,
  [SMALL_STATE(6233)] = 208044,
  [SMALL_STATE(6234)] = 208139,
  [SMALL_STATE(6235)] = 208272,
  [SMALL_STATE(6236)] = 208367,
  [SMALL_STATE(6237)] = 208500,
  [SMALL_STATE(6238)] = 208611,
  [SMALL_STATE(6239)] = 208716,
  [SMALL_STATE(6240)] = 208811,
  [SMALL_STATE(6241)] = 208908,
  [SMALL_STATE(6242)] = 209031,
  [SMALL_STATE(6243)] = 209156,
  [SMALL_STATE(6244)] = 209277,
  [SMALL_STATE(6245)] = 209410,
  [SMALL_STATE(6246)] = 209517,
  [SMALL_STATE(6247)] = 209636,
  [SMALL_STATE(6248)] = 209763,
  [SMALL_STATE(6249)] = 209892,
  [SMALL_STATE(6250)] = 210025,
  [SMALL_STATE(6251)] = 210158,
  [SMALL_STATE(6252)] = 210291,
  [SMALL_STATE(6253)] = 210420,
  [SMALL_STATE(6254)] = 210553,
  [SMALL_STATE(6255)] = 210680,
  [SMALL_STATE(6256)] = 210799,
  [SMALL_STATE(6257)] = 210906,
  [SMALL_STATE(6258)] = 211027,
  [SMALL_STATE(6259)] = 211152,
  [SMALL_STATE(6260)] = 211275,
  [SMALL_STATE(6261)] = 211376,
  [SMALL_STATE(6262)] = 211481,
  [SMALL_STATE(6263)] = 211592,
  [SMALL_STATE(6264)] = 211687,
  [SMALL_STATE(6265)] = 211820,
  [SMALL_STATE(6266)] = 211953,
  [SMALL_STATE(6267)] = 212048,
  [SMALL_STATE(6268)] = 212181,
  [SMALL_STATE(6269)] = 212314,
  [SMALL_STATE(6270)] = 212447,
  [SMALL_STATE(6271)] = 212580,
  [SMALL_STATE(6272)] = 212713,
  [SMALL_STATE(6273)] = 212846,
  [SMALL_STATE(6274)] = 212943,
  [SMALL_STATE(6275)] = 213076,
  [SMALL_STATE(6276)] = 213171,
  [SMALL_STATE(6277)] = 213272,
  [SMALL_STATE(6278)] = 213404,
  [SMALL_STATE(6279)] = 213536,
  [SMALL_STATE(6280)] = 213668,
  [SMALL_STATE(6281)] = 213750,
  [SMALL_STATE(6282)] = 213882,
  [SMALL_STATE(6283)] = 213964,
  [SMALL_STATE(6284)] = 214096,
  [SMALL_STATE(6285)] = 214228,
  [SMALL_STATE(6286)] = 214360,
  [SMALL_STATE(6287)] = 214492,
  [SMALL_STATE(6288)] = 214624,
  [SMALL_STATE(6289)] = 214752,
  [SMALL_STATE(6290)] = 214884,
  [SMALL_STATE(6291)] = 215016,
  [SMALL_STATE(6292)] = 215098,
  [SMALL_STATE(6293)] = 215224,
  [SMALL_STATE(6294)] = 215356,
  [SMALL_STATE(6295)] = 215452,
  [SMALL_STATE(6296)] = 215570,
  [SMALL_STATE(6297)] = 215676,
  [SMALL_STATE(6298)] = 215796,
  [SMALL_STATE(6299)] = 215928,
  [SMALL_STATE(6300)] = 216060,
  [SMALL_STATE(6301)] = 216192,
  [SMALL_STATE(6302)] = 216316,
  [SMALL_STATE(6303)] = 216438,
  [SMALL_STATE(6304)] = 216570,
  [SMALL_STATE(6305)] = 216670,
  [SMALL_STATE(6306)] = 216802,
  [SMALL_STATE(6307)] = 216902,
  [SMALL_STATE(6308)] = 217006,
  [SMALL_STATE(6309)] = 217138,
  [SMALL_STATE(6310)] = 217270,
  [SMALL_STATE(6311)] = 217402,
  [SMALL_STATE(6312)] = 217534,
  [SMALL_STATE(6313)] = 217644,
  [SMALL_STATE(6314)] = 217776,
  [SMALL_STATE(6315)] = 217908,
  [SMALL_STATE(6316)] = 218040,
  [SMALL_STATE(6317)] = 218172,
  [SMALL_STATE(6318)] = 218272,
  [SMALL_STATE(6319)] = 218404,
  [SMALL_STATE(6320)] = 218486,
  [SMALL_STATE(6321)] = 218618,
  [SMALL_STATE(6322)] = 218750,
  [SMALL_STATE(6323)] = 218882,
  [SMALL_STATE(6324)] = 219014,
  [SMALL_STATE(6325)] = 219146,
  [SMALL_STATE(6326)] = 219278,
  [SMALL_STATE(6327)] = 219410,
  [SMALL_STATE(6328)] = 219542,
  [SMALL_STATE(6329)] = 219674,
  [SMALL_STATE(6330)] = 219806,
  [SMALL_STATE(6331)] = 219938,
  [SMALL_STATE(6332)] = 220018,
  [SMALL_STATE(6333)] = 220150,
  [SMALL_STATE(6334)] = 220282,
  [SMALL_STATE(6335)] = 220414,
  [SMALL_STATE(6336)] = 220546,
  [SMALL_STATE(6337)] = 220678,
  [SMALL_STATE(6338)] = 220810,
  [SMALL_STATE(6339)] = 220942,
  [SMALL_STATE(6340)] = 221074,
  [SMALL_STATE(6341)] = 221156,
  [SMALL_STATE(6342)] = 221288,
  [SMALL_STATE(6343)] = 221420,
  [SMALL_STATE(6344)] = 221552,
  [SMALL_STATE(6345)] = 221632,
  [SMALL_STATE(6346)] = 221764,
  [SMALL_STATE(6347)] = 221896,
  [SMALL_STATE(6348)] = 222028,
  [SMALL_STATE(6349)] = 222160,
  [SMALL_STATE(6350)] = 222240,
  [SMALL_STATE(6351)] = 222372,
  [SMALL_STATE(6352)] = 222504,
  [SMALL_STATE(6353)] = 222636,
  [SMALL_STATE(6354)] = 222768,
  [SMALL_STATE(6355)] = 222900,
  [SMALL_STATE(6356)] = 223032,
  [SMALL_STATE(6357)] = 223164,
  [SMALL_STATE(6358)] = 223296,
  [SMALL_STATE(6359)] = 223378,
  [SMALL_STATE(6360)] = 223510,
  [SMALL_STATE(6361)] = 223642,
  [SMALL_STATE(6362)] = 223722,
  [SMALL_STATE(6363)] = 223854,
  [SMALL_STATE(6364)] = 223986,
  [SMALL_STATE(6365)] = 224118,
  [SMALL_STATE(6366)] = 224250,
  [SMALL_STATE(6367)] = 224382,
  [SMALL_STATE(6368)] = 224514,
  [SMALL_STATE(6369)] = 224646,
  [SMALL_STATE(6370)] = 224778,
  [SMALL_STATE(6371)] = 224910,
  [SMALL_STATE(6372)] = 225042,
  [SMALL_STATE(6373)] = 225174,
  [SMALL_STATE(6374)] = 225306,
  [SMALL_STATE(6375)] = 225438,
  [SMALL_STATE(6376)] = 225520,
  [SMALL_STATE(6377)] = 225652,
  [SMALL_STATE(6378)] = 225784,
  [SMALL_STATE(6379)] = 225916,
  [SMALL_STATE(6380)] = 226048,
  [SMALL_STATE(6381)] = 226180,
  [SMALL_STATE(6382)] = 226312,
  [SMALL_STATE(6383)] = 226444,
  [SMALL_STATE(6384)] = 226576,
  [SMALL_STATE(6385)] = 226708,
  [SMALL_STATE(6386)] = 226790,
  [SMALL_STATE(6387)] = 226922,
  [SMALL_STATE(6388)] = 227054,
  [SMALL_STATE(6389)] = 227186,
  [SMALL_STATE(6390)] = 227318,
  [SMALL_STATE(6391)] = 227450,
  [SMALL_STATE(6392)] = 227582,
  [SMALL_STATE(6393)] = 227714,
  [SMALL_STATE(6394)] = 227846,
  [SMALL_STATE(6395)] = 227978,
  [SMALL_STATE(6396)] = 228060,
  [SMALL_STATE(6397)] = 228192,
  [SMALL_STATE(6398)] = 228274,
  [SMALL_STATE(6399)] = 228406,
  [SMALL_STATE(6400)] = 228538,
  [SMALL_STATE(6401)] = 228618,
  [SMALL_STATE(6402)] = 228746,
  [SMALL_STATE(6403)] = 228872,
  [SMALL_STATE(6404)] = 229004,
  [SMALL_STATE(6405)] = 229136,
  [SMALL_STATE(6406)] = 229222,
  [SMALL_STATE(6407)] = 229354,
  [SMALL_STATE(6408)] = 229486,
  [SMALL_STATE(6409)] = 229618,
  [SMALL_STATE(6410)] = 229750,
  [SMALL_STATE(6411)] = 229882,
  [SMALL_STATE(6412)] = 230014,
  [SMALL_STATE(6413)] = 230146,
  [SMALL_STATE(6414)] = 230278,
  [SMALL_STATE(6415)] = 230410,
  [SMALL_STATE(6416)] = 230492,
  [SMALL_STATE(6417)] = 230610,
  [SMALL_STATE(6418)] = 230742,
  [SMALL_STATE(6419)] = 230874,
  [SMALL_STATE(6420)] = 231006,
  [SMALL_STATE(6421)] = 231138,
  [SMALL_STATE(6422)] = 231270,
  [SMALL_STATE(6423)] = 231402,
  [SMALL_STATE(6424)] = 231498,
  [SMALL_STATE(6425)] = 231594,
  [SMALL_STATE(6426)] = 231714,
  [SMALL_STATE(6427)] = 231796,
  [SMALL_STATE(6428)] = 231876,
  [SMALL_STATE(6429)] = 232000,
  [SMALL_STATE(6430)] = 232082,
  [SMALL_STATE(6431)] = 232214,
  [SMALL_STATE(6432)] = 232296,
  [SMALL_STATE(6433)] = 232418,
  [SMALL_STATE(6434)] = 232550,
  [SMALL_STATE(6435)] = 232682,
  [SMALL_STATE(6436)] = 232814,
  [SMALL_STATE(6437)] = 232946,
  [SMALL_STATE(6438)] = 233078,
  [SMALL_STATE(6439)] = 233210,
  [SMALL_STATE(6440)] = 233342,
  [SMALL_STATE(6441)] = 233474,
  [SMALL_STATE(6442)] = 233580,
  [SMALL_STATE(6443)] = 233712,
  [SMALL_STATE(6444)] = 233794,
  [SMALL_STATE(6445)] = 233926,
  [SMALL_STATE(6446)] = 234058,
  [SMALL_STATE(6447)] = 234158,
  [SMALL_STATE(6448)] = 234254,
  [SMALL_STATE(6449)] = 234386,
  [SMALL_STATE(6450)] = 234490,
  [SMALL_STATE(6451)] = 234622,
  [SMALL_STATE(6452)] = 234732,
  [SMALL_STATE(6453)] = 234864,
  [SMALL_STATE(6454)] = 234996,
  [SMALL_STATE(6455)] = 235128,
  [SMALL_STATE(6456)] = 235260,
  [SMALL_STATE(6457)] = 235392,
  [SMALL_STATE(6458)] = 235472,
  [SMALL_STATE(6459)] = 235604,
  [SMALL_STATE(6460)] = 235736,
  [SMALL_STATE(6461)] = 235868,
  [SMALL_STATE(6462)] = 236000,
  [SMALL_STATE(6463)] = 236132,
  [SMALL_STATE(6464)] = 236264,
  [SMALL_STATE(6465)] = 236396,
  [SMALL_STATE(6466)] = 236528,
  [SMALL_STATE(6467)] = 236660,
  [SMALL_STATE(6468)] = 236792,
  [SMALL_STATE(6469)] = 236872,
  [SMALL_STATE(6470)] = 236982,
  [SMALL_STATE(6471)] = 237078,
  [SMALL_STATE(6472)] = 237210,
  [SMALL_STATE(6473)] = 237314,
  [SMALL_STATE(6474)] = 237414,
  [SMALL_STATE(6475)] = 237536,
  [SMALL_STATE(6476)] = 237660,
  [SMALL_STATE(6477)] = 237780,
  [SMALL_STATE(6478)] = 237886,
  [SMALL_STATE(6479)] = 238004,
  [SMALL_STATE(6480)] = 238136,
  [SMALL_STATE(6481)] = 238232,
  [SMALL_STATE(6482)] = 238358,
  [SMALL_STATE(6483)] = 238486,
  [SMALL_STATE(6484)] = 238618,
  [SMALL_STATE(6485)] = 238750,
  [SMALL_STATE(6486)] = 238882,
  [SMALL_STATE(6487)] = 238964,
  [SMALL_STATE(6488)] = 239046,
  [SMALL_STATE(6489)] = 239178,
  [SMALL_STATE(6490)] = 239310,
  [SMALL_STATE(6491)] = 239442,
  [SMALL_STATE(6492)] = 239574,
  [SMALL_STATE(6493)] = 239706,
  [SMALL_STATE(6494)] = 239786,
  [SMALL_STATE(6495)] = 239918,
  [SMALL_STATE(6496)] = 240050,
  [SMALL_STATE(6497)] = 240182,
  [SMALL_STATE(6498)] = 240314,
  [SMALL_STATE(6499)] = 240410,
  [SMALL_STATE(6500)] = 240542,
  [SMALL_STATE(6501)] = 240624,
  [SMALL_STATE(6502)] = 240756,
  [SMALL_STATE(6503)] = 240840,
  [SMALL_STATE(6504)] = 240972,
  [SMALL_STATE(6505)] = 241104,
  [SMALL_STATE(6506)] = 241236,
  [SMALL_STATE(6507)] = 241316,
  [SMALL_STATE(6508)] = 241416,
  [SMALL_STATE(6509)] = 241498,
  [SMALL_STATE(6510)] = 241592,
  [SMALL_STATE(6511)] = 241724,
  [SMALL_STATE(6512)] = 241806,
  [SMALL_STATE(6513)] = 241886,
  [SMALL_STATE(6514)] = 242018,
  [SMALL_STATE(6515)] = 242098,
  [SMALL_STATE(6516)] = 242178,
  [SMALL_STATE(6517)] = 242310,
  [SMALL_STATE(6518)] = 242406,
  [SMALL_STATE(6519)] = 242538,
  [SMALL_STATE(6520)] = 242670,
  [SMALL_STATE(6521)] = 242752,
  [SMALL_STATE(6522)] = 242862,
  [SMALL_STATE(6523)] = 242944,
  [SMALL_STATE(6524)] = 243076,
  [SMALL_STATE(6525)] = 243180,
  [SMALL_STATE(6526)] = 243280,
  [SMALL_STATE(6527)] = 243412,
  [SMALL_STATE(6528)] = 243534,
  [SMALL_STATE(6529)] = 243666,
  [SMALL_STATE(6530)] = 243746,
  [SMALL_STATE(6531)] = 243870,
  [SMALL_STATE(6532)] = 244002,
  [SMALL_STATE(6533)] = 244134,
  [SMALL_STATE(6534)] = 244266,
  [SMALL_STATE(6535)] = 244398,
  [SMALL_STATE(6536)] = 244530,
  [SMALL_STATE(6537)] = 244662,
  [SMALL_STATE(6538)] = 244794,
  [SMALL_STATE(6539)] = 244926,
  [SMALL_STATE(6540)] = 245046,
  [SMALL_STATE(6541)] = 245178,
  [SMALL_STATE(6542)] = 245310,
  [SMALL_STATE(6543)] = 245392,
  [SMALL_STATE(6544)] = 245472,
  [SMALL_STATE(6545)] = 245604,
  [SMALL_STATE(6546)] = 245736,
  [SMALL_STATE(6547)] = 245868,
  [SMALL_STATE(6548)] = 246000,
  [SMALL_STATE(6549)] = 246132,
  [SMALL_STATE(6550)] = 246264,
  [SMALL_STATE(6551)] = 246396,
  [SMALL_STATE(6552)] = 246528,
  [SMALL_STATE(6553)] = 246660,
  [SMALL_STATE(6554)] = 246792,
  [SMALL_STATE(6555)] = 246898,
  [SMALL_STATE(6556)] = 247030,
  [SMALL_STATE(6557)] = 247148,
  [SMALL_STATE(6558)] = 247280,
  [SMALL_STATE(6559)] = 247412,
  [SMALL_STATE(6560)] = 247544,
  [SMALL_STATE(6561)] = 247632,
  [SMALL_STATE(6562)] = 247764,
  [SMALL_STATE(6563)] = 247896,
  [SMALL_STATE(6564)] = 248024,
  [SMALL_STATE(6565)] = 248150,
  [SMALL_STATE(6566)] = 248246,
  [SMALL_STATE(6567)] = 248342,
  [SMALL_STATE(6568)] = 248460,
  [SMALL_STATE(6569)] = 248566,
  [SMALL_STATE(6570)] = 248686,
  [SMALL_STATE(6571)] = 248810,
  [SMALL_STATE(6572)] = 248892,
  [SMALL_STATE(6573)] = 249014,
  [SMALL_STATE(6574)] = 249146,
  [SMALL_STATE(6575)] = 249278,
  [SMALL_STATE(6576)] = 249406,
  [SMALL_STATE(6577)] = 249532,
  [SMALL_STATE(6578)] = 249632,
  [SMALL_STATE(6579)] = 249728,
  [SMALL_STATE(6580)] = 249832,
  [SMALL_STATE(6581)] = 249964,
  [SMALL_STATE(6582)] = 250096,
  [SMALL_STATE(6583)] = 250206,
  [SMALL_STATE(6584)] = 250338,
  [SMALL_STATE(6585)] = 250456,
  [SMALL_STATE(6586)] = 250562,
  [SMALL_STATE(6587)] = 250682,
  [SMALL_STATE(6588)] = 250806,
  [SMALL_STATE(6589)] = 250932,
  [SMALL_STATE(6590)] = 251064,
  [SMALL_STATE(6591)] = 251186,
  [SMALL_STATE(6592)] = 251318,
  [SMALL_STATE(6593)] = 251450,
  [SMALL_STATE(6594)] = 251578,
  [SMALL_STATE(6595)] = 251710,
  [SMALL_STATE(6596)] = 251842,
  [SMALL_STATE(6597)] = 251974,
  [SMALL_STATE(6598)] = 252074,
  [SMALL_STATE(6599)] = 252206,
  [SMALL_STATE(6600)] = 252288,
  [SMALL_STATE(6601)] = 252392,
  [SMALL_STATE(6602)] = 252524,
  [SMALL_STATE(6603)] = 252634,
  [SMALL_STATE(6604)] = 252766,
  [SMALL_STATE(6605)] = 252898,
  [SMALL_STATE(6606)] = 253030,
  [SMALL_STATE(6607)] = 253162,
  [SMALL_STATE(6608)] = 253242,
  [SMALL_STATE(6609)] = 253374,
  [SMALL_STATE(6610)] = 253506,
  [SMALL_STATE(6611)] = 253638,
  [SMALL_STATE(6612)] = 253770,
  [SMALL_STATE(6613)] = 253902,
  [SMALL_STATE(6614)] = 254034,
  [SMALL_STATE(6615)] = 254166,
  [SMALL_STATE(6616)] = 254298,
  [SMALL_STATE(6617)] = 254430,
  [SMALL_STATE(6618)] = 254512,
  [SMALL_STATE(6619)] = 254644,
  [SMALL_STATE(6620)] = 254776,
  [SMALL_STATE(6621)] = 254908,
  [SMALL_STATE(6622)] = 255040,
  [SMALL_STATE(6623)] = 255172,
  [SMALL_STATE(6624)] = 255304,
  [SMALL_STATE(6625)] = 255436,
  [SMALL_STATE(6626)] = 255568,
  [SMALL_STATE(6627)] = 255700,
  [SMALL_STATE(6628)] = 255796,
  [SMALL_STATE(6629)] = 255928,
  [SMALL_STATE(6630)] = 256060,
  [SMALL_STATE(6631)] = 256192,
  [SMALL_STATE(6632)] = 256324,
  [SMALL_STATE(6633)] = 256456,
  [SMALL_STATE(6634)] = 256588,
  [SMALL_STATE(6635)] = 256720,
  [SMALL_STATE(6636)] = 256852,
  [SMALL_STATE(6637)] = 256984,
  [SMALL_STATE(6638)] = 257116,
  [SMALL_STATE(6639)] = 257198,
  [SMALL_STATE(6640)] = 257330,
  [SMALL_STATE(6641)] = 257412,
  [SMALL_STATE(6642)] = 257544,
  [SMALL_STATE(6643)] = 257676,
  [SMALL_STATE(6644)] = 257808,
  [SMALL_STATE(6645)] = 257940,
  [SMALL_STATE(6646)] = 258072,
  [SMALL_STATE(6647)] = 258204,
  [SMALL_STATE(6648)] = 258336,
  [SMALL_STATE(6649)] = 258468,
  [SMALL_STATE(6650)] = 258600,
  [SMALL_STATE(6651)] = 258732,
  [SMALL_STATE(6652)] = 258864,
  [SMALL_STATE(6653)] = 258996,
  [SMALL_STATE(6654)] = 259076,
  [SMALL_STATE(6655)] = 259208,
  [SMALL_STATE(6656)] = 259337,
  [SMALL_STATE(6657)] = 259434,
  [SMALL_STATE(6658)] = 259531,
  [SMALL_STATE(6659)] = 259660,
  [SMALL_STATE(6660)] = 259789,
  [SMALL_STATE(6661)] = 259918,
  [SMALL_STATE(6662)] = 260003,
  [SMALL_STATE(6663)] = 260132,
  [SMALL_STATE(6664)] = 260261,
  [SMALL_STATE(6665)] = 260348,
  [SMALL_STATE(6666)] = 260477,
  [SMALL_STATE(6667)] = 260564,
  [SMALL_STATE(6668)] = 260693,
  [SMALL_STATE(6669)] = 260778,
  [SMALL_STATE(6670)] = 260865,
  [SMALL_STATE(6671)] = 260994,
  [SMALL_STATE(6672)] = 261087,
  [SMALL_STATE(6673)] = 261180,
  [SMALL_STATE(6674)] = 261267,
  [SMALL_STATE(6675)] = 261396,
  [SMALL_STATE(6676)] = 261525,
  [SMALL_STATE(6677)] = 261654,
  [SMALL_STATE(6678)] = 261783,
  [SMALL_STATE(6679)] = 261860,
  [SMALL_STATE(6680)] = 261937,
  [SMALL_STATE(6681)] = 262066,
  [SMALL_STATE(6682)] = 262145,
  [SMALL_STATE(6683)] = 262224,
  [SMALL_STATE(6684)] = 262353,
  [SMALL_STATE(6685)] = 262440,
  [SMALL_STATE(6686)] = 262527,
  [SMALL_STATE(6687)] = 262656,
  [SMALL_STATE(6688)] = 262785,
  [SMALL_STATE(6689)] = 262914,
  [SMALL_STATE(6690)] = 263043,
  [SMALL_STATE(6691)] = 263172,
  [SMALL_STATE(6692)] = 263301,
  [SMALL_STATE(6693)] = 263430,
  [SMALL_STATE(6694)] = 263559,
  [SMALL_STATE(6695)] = 263636,
  [SMALL_STATE(6696)] = 263729,
  [SMALL_STATE(6697)] = 263806,
  [SMALL_STATE(6698)] = 263935,
  [SMALL_STATE(6699)] = 264020,
  [SMALL_STATE(6700)] = 264149,
  [SMALL_STATE(6701)] = 264238,
  [SMALL_STATE(6702)] = 264315,
  [SMALL_STATE(6703)] = 264392,
  [SMALL_STATE(6704)] = 264469,
  [SMALL_STATE(6705)] = 264598,
  [SMALL_STATE(6706)] = 264727,
  [SMALL_STATE(6707)] = 264856,
  [SMALL_STATE(6708)] = 264985,
  [SMALL_STATE(6709)] = 265078,
  [SMALL_STATE(6710)] = 265207,
  [SMALL_STATE(6711)] = 265336,
  [SMALL_STATE(6712)] = 265465,
  [SMALL_STATE(6713)] = 265559,
  [SMALL_STATE(6714)] = 265645,
  [SMALL_STATE(6715)] = 265731,
  [SMALL_STATE(6716)] = 265825,
  [SMALL_STATE(6717)] = 265921,
  [SMALL_STATE(6718)] = 266005,
  [SMALL_STATE(6719)] = 266083,
  [SMALL_STATE(6720)] = 266169,
  [SMALL_STATE(6721)] = 266255,
  [SMALL_STATE(6722)] = 266349,
  [SMALL_STATE(6723)] = 266435,
  [SMALL_STATE(6724)] = 266521,
  [SMALL_STATE(6725)] = 266599,
  [SMALL_STATE(6726)] = 266695,
  [SMALL_STATE(6727)] = 266781,
  [SMALL_STATE(6728)] = 266867,
  [SMALL_STATE(6729)] = 266957,
  [SMALL_STATE(6730)] = 267043,
  [SMALL_STATE(6731)] = 267120,
  [SMALL_STATE(6732)] = 267211,
  [SMALL_STATE(6733)] = 267294,
  [SMALL_STATE(6734)] = 267375,
  [SMALL_STATE(6735)] = 267458,
  [SMALL_STATE(6736)] = 267549,
  [SMALL_STATE(6737)] = 267636,
  [SMALL_STATE(6738)] = 267719,
  [SMALL_STATE(6739)] = 267812,
  [SMALL_STATE(6740)] = 267903,
  [SMALL_STATE(6741)] = 267990,
  [SMALL_STATE(6742)] = 268081,
  [SMALL_STATE(6743)] = 268169,
  [SMALL_STATE(6744)] = 268257,
  [SMALL_STATE(6745)] = 268345,
  [SMALL_STATE(6746)] = 268433,
  [SMALL_STATE(6747)] = 268521,
  [SMALL_STATE(6748)] = 268611,
  [SMALL_STATE(6749)] = 268699,
  [SMALL_STATE(6750)] = 268787,
  [SMALL_STATE(6751)] = 268875,
  [SMALL_STATE(6752)] = 268963,
  [SMALL_STATE(6753)] = 269051,
  [SMALL_STATE(6754)] = 269139,
  [SMALL_STATE(6755)] = 269221,
  [SMALL_STATE(6756)] = 269297,
  [SMALL_STATE(6757)] = 269385,
  [SMALL_STATE(6758)] = 269473,
  [SMALL_STATE(6759)] = 269561,
  [SMALL_STATE(6760)] = 269649,
  [SMALL_STATE(6761)] = 269737,
  [SMALL_STATE(6762)] = 269825,
  [SMALL_STATE(6763)] = 269915,
  [SMALL_STATE(6764)] = 270003,
  [SMALL_STATE(6765)] = 270091,
  [SMALL_STATE(6766)] = 270179,
  [SMALL_STATE(6767)] = 270267,
  [SMALL_STATE(6768)] = 270355,
  [SMALL_STATE(6769)] = 270443,
  [SMALL_STATE(6770)] = 270531,
  [SMALL_STATE(6771)] = 270619,
  [SMALL_STATE(6772)] = 270707,
  [SMALL_STATE(6773)] = 270795,
  [SMALL_STATE(6774)] = 270868,
  [SMALL_STATE(6775)] = 270953,
  [SMALL_STATE(6776)] = 271038,
  [SMALL_STATE(6777)] = 271125,
  [SMALL_STATE(6778)] = 271210,
  [SMALL_STATE(6779)] = 271295,
  [SMALL_STATE(6780)] = 271380,
  [SMALL_STATE(6781)] = 271467,
  [SMALL_STATE(6782)] = 271554,
  [SMALL_STATE(6783)] = 271639,
  [SMALL_STATE(6784)] = 271716,
  [SMALL_STATE(6785)] = 271797,
  [SMALL_STATE(6786)] = 271882,
  [SMALL_STATE(6787)] = 271963,
  [SMALL_STATE(6788)] = 272048,
  [SMALL_STATE(6789)] = 272133,
  [SMALL_STATE(6790)] = 272218,
  [SMALL_STATE(6791)] = 272303,
  [SMALL_STATE(6792)] = 272388,
  [SMALL_STATE(6793)] = 272473,
  [SMALL_STATE(6794)] = 272555,
  [SMALL_STATE(6795)] = 272637,
  [SMALL_STATE(6796)] = 272723,
  [SMALL_STATE(6797)] = 272805,
  [SMALL_STATE(6798)] = 272891,
  [SMALL_STATE(6799)] = 272977,
  [SMALL_STATE(6800)] = 273063,
  [SMALL_STATE(6801)] = 273149,
  [SMALL_STATE(6802)] = 273235,
  [SMALL_STATE(6803)] = 273321,
  [SMALL_STATE(6804)] = 273407,
  [SMALL_STATE(6805)] = 273493,
  [SMALL_STATE(6806)] = 273579,
  [SMALL_STATE(6807)] = 273665,
  [SMALL_STATE(6808)] = 273751,
  [SMALL_STATE(6809)] = 273837,
  [SMALL_STATE(6810)] = 273923,
  [SMALL_STATE(6811)] = 274009,
  [SMALL_STATE(6812)] = 274091,
  [SMALL_STATE(6813)] = 274173,
  [SMALL_STATE(6814)] = 274259,
  [SMALL_STATE(6815)] = 274345,
  [SMALL_STATE(6816)] = 274431,
  [SMALL_STATE(6817)] = 274517,
  [SMALL_STATE(6818)] = 274603,
  [SMALL_STATE(6819)] = 274689,
  [SMALL_STATE(6820)] = 274771,
  [SMALL_STATE(6821)] = 274845,
  [SMALL_STATE(6822)] = 274931,
  [SMALL_STATE(6823)] = 275017,
  [SMALL_STATE(6824)] = 275103,
  [SMALL_STATE(6825)] = 275185,
  [SMALL_STATE(6826)] = 275271,
  [SMALL_STATE(6827)] = 275357,
  [SMALL_STATE(6828)] = 275443,
  [SMALL_STATE(6829)] = 275529,
  [SMALL_STATE(6830)] = 275615,
  [SMALL_STATE(6831)] = 275701,
  [SMALL_STATE(6832)] = 275787,
  [SMALL_STATE(6833)] = 275873,
  [SMALL_STATE(6834)] = 275955,
  [SMALL_STATE(6835)] = 276041,
  [SMALL_STATE(6836)] = 276127,
  [SMALL_STATE(6837)] = 276213,
  [SMALL_STATE(6838)] = 276299,
  [SMALL_STATE(6839)] = 276385,
  [SMALL_STATE(6840)] = 276471,
  [SMALL_STATE(6841)] = 276557,
  [SMALL_STATE(6842)] = 276643,
  [SMALL_STATE(6843)] = 276725,
  [SMALL_STATE(6844)] = 276811,
  [SMALL_STATE(6845)] = 276897,
  [SMALL_STATE(6846)] = 276979,
  [SMALL_STATE(6847)] = 277065,
  [SMALL_STATE(6848)] = 277147,
  [SMALL_STATE(6849)] = 277233,
  [SMALL_STATE(6850)] = 277319,
  [SMALL_STATE(6851)] = 277401,
  [SMALL_STATE(6852)] = 277483,
  [SMALL_STATE(6853)] = 277569,
  [SMALL_STATE(6854)] = 277655,
  [SMALL_STATE(6855)] = 277741,
  [SMALL_STATE(6856)] = 277825,
  [SMALL_STATE(6857)] = 277911,
  [SMALL_STATE(6858)] = 277997,
  [SMALL_STATE(6859)] = 278083,
  [SMALL_STATE(6860)] = 278165,
  [SMALL_STATE(6861)] = 278251,
  [SMALL_STATE(6862)] = 278337,
  [SMALL_STATE(6863)] = 278423,
  [SMALL_STATE(6864)] = 278509,
  [SMALL_STATE(6865)] = 278583,
  [SMALL_STATE(6866)] = 278669,
  [SMALL_STATE(6867)] = 278755,
  [SMALL_STATE(6868)] = 278837,
  [SMALL_STATE(6869)] = 278923,
  [SMALL_STATE(6870)] = 279009,
  [SMALL_STATE(6871)] = 279095,
  [SMALL_STATE(6872)] = 279181,
  [SMALL_STATE(6873)] = 279267,
  [SMALL_STATE(6874)] = 279353,
  [SMALL_STATE(6875)] = 279434,
  [SMALL_STATE(6876)] = 279517,
  [SMALL_STATE(6877)] = 279600,
  [SMALL_STATE(6878)] = 279681,
  [SMALL_STATE(6879)] = 279762,
  [SMALL_STATE(6880)] = 279843,
  [SMALL_STATE(6881)] = 279924,
  [SMALL_STATE(6882)] = 280005,
  [SMALL_STATE(6883)] = 280084,
  [SMALL_STATE(6884)] = 280163,
  [SMALL_STATE(6885)] = 280246,
  [SMALL_STATE(6886)] = 280317,
  [SMALL_STATE(6887)] = 280400,
  [SMALL_STATE(6888)] = 280481,
  [SMALL_STATE(6889)] = 280562,
  [SMALL_STATE(6890)] = 280643,
  [SMALL_STATE(6891)] = 280722,
  [SMALL_STATE(6892)] = 280805,
  [SMALL_STATE(6893)] = 280884,
  [SMALL_STATE(6894)] = 280965,
  [SMALL_STATE(6895)] = 281046,
  [SMALL_STATE(6896)] = 281127,
  [SMALL_STATE(6897)] = 281208,
  [SMALL_STATE(6898)] = 281289,
  [SMALL_STATE(6899)] = 281370,
  [SMALL_STATE(6900)] = 281453,
  [SMALL_STATE(6901)] = 281534,
  [SMALL_STATE(6902)] = 281615,
  [SMALL_STATE(6903)] = 281698,
  [SMALL_STATE(6904)] = 281775,
  [SMALL_STATE(6905)] = 281856,
  [SMALL_STATE(6906)] = 281937,
  [SMALL_STATE(6907)] = 282020,
  [SMALL_STATE(6908)] = 282097,
  [SMALL_STATE(6909)] = 282178,
  [SMALL_STATE(6910)] = 282259,
  [SMALL_STATE(6911)] = 282340,
  [SMALL_STATE(6912)] = 282421,
  [SMALL_STATE(6913)] = 282504,
  [SMALL_STATE(6914)] = 282585,
  [SMALL_STATE(6915)] = 282666,
  [SMALL_STATE(6916)] = 282749,
  [SMALL_STATE(6917)] = 282830,
  [SMALL_STATE(6918)] = 282901,
  [SMALL_STATE(6919)] = 282982,
  [SMALL_STATE(6920)] = 283063,
  [SMALL_STATE(6921)] = 283143,
  [SMALL_STATE(6922)] = 283223,
  [SMALL_STATE(6923)] = 283301,
  [SMALL_STATE(6924)] = 283381,
  [SMALL_STATE(6925)] = 283461,
  [SMALL_STATE(6926)] = 283541,
  [SMALL_STATE(6927)] = 283619,
  [SMALL_STATE(6928)] = 283699,
  [SMALL_STATE(6929)] = 283779,
  [SMALL_STATE(6930)] = 283859,
  [SMALL_STATE(6931)] = 283939,
  [SMALL_STATE(6932)] = 284019,
  [SMALL_STATE(6933)] = 284099,
  [SMALL_STATE(6934)] = 284177,
  [SMALL_STATE(6935)] = 284257,
  [SMALL_STATE(6936)] = 284337,
  [SMALL_STATE(6937)] = 284417,
  [SMALL_STATE(6938)] = 284495,
  [SMALL_STATE(6939)] = 284575,
  [SMALL_STATE(6940)] = 284655,
  [SMALL_STATE(6941)] = 284735,
  [SMALL_STATE(6942)] = 284815,
  [SMALL_STATE(6943)] = 284895,
  [SMALL_STATE(6944)] = 284975,
  [SMALL_STATE(6945)] = 285053,
  [SMALL_STATE(6946)] = 285133,
  [SMALL_STATE(6947)] = 285211,
  [SMALL_STATE(6948)] = 285291,
  [SMALL_STATE(6949)] = 285371,
  [SMALL_STATE(6950)] = 285451,
  [SMALL_STATE(6951)] = 285531,
  [SMALL_STATE(6952)] = 285609,
  [SMALL_STATE(6953)] = 285689,
  [SMALL_STATE(6954)] = 285769,
  [SMALL_STATE(6955)] = 285847,
  [SMALL_STATE(6956)] = 285927,
  [SMALL_STATE(6957)] = 286007,
  [SMALL_STATE(6958)] = 286087,
  [SMALL_STATE(6959)] = 286167,
  [SMALL_STATE(6960)] = 286247,
  [SMALL_STATE(6961)] = 286327,
  [SMALL_STATE(6962)] = 286407,
  [SMALL_STATE(6963)] = 286487,
  [SMALL_STATE(6964)] = 286567,
  [SMALL_STATE(6965)] = 286645,
  [SMALL_STATE(6966)] = 286723,
  [SMALL_STATE(6967)] = 286801,
  [SMALL_STATE(6968)] = 286881,
  [SMALL_STATE(6969)] = 286959,
  [SMALL_STATE(6970)] = 287039,
  [SMALL_STATE(6971)] = 287119,
  [SMALL_STATE(6972)] = 287199,
  [SMALL_STATE(6973)] = 287279,
  [SMALL_STATE(6974)] = 287357,
  [SMALL_STATE(6975)] = 287437,
  [SMALL_STATE(6976)] = 287517,
  [SMALL_STATE(6977)] = 287597,
  [SMALL_STATE(6978)] = 287677,
  [SMALL_STATE(6979)] = 287757,
  [SMALL_STATE(6980)] = 287837,
  [SMALL_STATE(6981)] = 287917,
  [SMALL_STATE(6982)] = 287997,
  [SMALL_STATE(6983)] = 288077,
  [SMALL_STATE(6984)] = 288155,
  [SMALL_STATE(6985)] = 288235,
  [SMALL_STATE(6986)] = 288315,
  [SMALL_STATE(6987)] = 288395,
  [SMALL_STATE(6988)] = 288475,
  [SMALL_STATE(6989)] = 288555,
  [SMALL_STATE(6990)] = 288633,
  [SMALL_STATE(6991)] = 288713,
  [SMALL_STATE(6992)] = 288793,
  [SMALL_STATE(6993)] = 288873,
  [SMALL_STATE(6994)] = 288953,
  [SMALL_STATE(6995)] = 289033,
  [SMALL_STATE(6996)] = 289113,
  [SMALL_STATE(6997)] = 289191,
  [SMALL_STATE(6998)] = 289271,
  [SMALL_STATE(6999)] = 289351,
  [SMALL_STATE(7000)] = 289431,
  [SMALL_STATE(7001)] = 289511,
  [SMALL_STATE(7002)] = 289589,
  [SMALL_STATE(7003)] = 289669,
  [SMALL_STATE(7004)] = 289749,
  [SMALL_STATE(7005)] = 289829,
  [SMALL_STATE(7006)] = 289907,
  [SMALL_STATE(7007)] = 289987,
  [SMALL_STATE(7008)] = 290067,
  [SMALL_STATE(7009)] = 290145,
  [SMALL_STATE(7010)] = 290225,
  [SMALL_STATE(7011)] = 290305,
  [SMALL_STATE(7012)] = 290385,
  [SMALL_STATE(7013)] = 290463,
  [SMALL_STATE(7014)] = 290543,
  [SMALL_STATE(7015)] = 290623,
  [SMALL_STATE(7016)] = 290701,
  [SMALL_STATE(7017)] = 290781,
  [SMALL_STATE(7018)] = 290861,
  [SMALL_STATE(7019)] = 290941,
  [SMALL_STATE(7020)] = 291021,
  [SMALL_STATE(7021)] = 291099,
  [SMALL_STATE(7022)] = 291179,
  [SMALL_STATE(7023)] = 291257,
  [SMALL_STATE(7024)] = 291337,
  [SMALL_STATE(7025)] = 291415,
  [SMALL_STATE(7026)] = 291495,
  [SMALL_STATE(7027)] = 291575,
  [SMALL_STATE(7028)] = 291655,
  [SMALL_STATE(7029)] = 291735,
  [SMALL_STATE(7030)] = 291815,
  [SMALL_STATE(7031)] = 291895,
  [SMALL_STATE(7032)] = 291975,
  [SMALL_STATE(7033)] = 292055,
  [SMALL_STATE(7034)] = 292135,
  [SMALL_STATE(7035)] = 292215,
  [SMALL_STATE(7036)] = 292295,
  [SMALL_STATE(7037)] = 292375,
  [SMALL_STATE(7038)] = 292455,
  [SMALL_STATE(7039)] = 292535,
  [SMALL_STATE(7040)] = 292613,
  [SMALL_STATE(7041)] = 292693,
  [SMALL_STATE(7042)] = 292773,
  [SMALL_STATE(7043)] = 292853,
  [SMALL_STATE(7044)] = 292931,
  [SMALL_STATE(7045)] = 293011,
  [SMALL_STATE(7046)] = 293091,
  [SMALL_STATE(7047)] = 293171,
  [SMALL_STATE(7048)] = 293251,
  [SMALL_STATE(7049)] = 293331,
  [SMALL_STATE(7050)] = 293411,
  [SMALL_STATE(7051)] = 293491,
  [SMALL_STATE(7052)] = 293563,
  [SMALL_STATE(7053)] = 293641,
  [SMALL_STATE(7054)] = 293721,
  [SMALL_STATE(7055)] = 293801,
  [SMALL_STATE(7056)] = 293881,
  [SMALL_STATE(7057)] = 293961,
  [SMALL_STATE(7058)] = 294041,
  [SMALL_STATE(7059)] = 294121,
  [SMALL_STATE(7060)] = 294199,
  [SMALL_STATE(7061)] = 294277,
  [SMALL_STATE(7062)] = 294357,
  [SMALL_STATE(7063)] = 294437,
  [SMALL_STATE(7064)] = 294515,
  [SMALL_STATE(7065)] = 294595,
  [SMALL_STATE(7066)] = 294675,
  [SMALL_STATE(7067)] = 294755,
  [SMALL_STATE(7068)] = 294833,
  [SMALL_STATE(7069)] = 294913,
  [SMALL_STATE(7070)] = 294993,
  [SMALL_STATE(7071)] = 295073,
  [SMALL_STATE(7072)] = 295153,
  [SMALL_STATE(7073)] = 295233,
  [SMALL_STATE(7074)] = 295313,
  [SMALL_STATE(7075)] = 295393,
  [SMALL_STATE(7076)] = 295473,
  [SMALL_STATE(7077)] = 295553,
  [SMALL_STATE(7078)] = 295633,
  [SMALL_STATE(7079)] = 295713,
  [SMALL_STATE(7080)] = 295793,
  [SMALL_STATE(7081)] = 295873,
  [SMALL_STATE(7082)] = 295951,
  [SMALL_STATE(7083)] = 296031,
  [SMALL_STATE(7084)] = 296109,
  [SMALL_STATE(7085)] = 296189,
  [SMALL_STATE(7086)] = 296269,
  [SMALL_STATE(7087)] = 296349,
  [SMALL_STATE(7088)] = 296427,
  [SMALL_STATE(7089)] = 296507,
  [SMALL_STATE(7090)] = 296587,
  [SMALL_STATE(7091)] = 296667,
  [SMALL_STATE(7092)] = 296745,
  [SMALL_STATE(7093)] = 296823,
  [SMALL_STATE(7094)] = 296903,
  [SMALL_STATE(7095)] = 296983,
  [SMALL_STATE(7096)] = 297061,
  [SMALL_STATE(7097)] = 297141,
  [SMALL_STATE(7098)] = 297219,
  [SMALL_STATE(7099)] = 297297,
  [SMALL_STATE(7100)] = 297377,
  [SMALL_STATE(7101)] = 297457,
  [SMALL_STATE(7102)] = 297537,
  [SMALL_STATE(7103)] = 297617,
  [SMALL_STATE(7104)] = 297695,
  [SMALL_STATE(7105)] = 297775,
  [SMALL_STATE(7106)] = 297855,
  [SMALL_STATE(7107)] = 297935,
  [SMALL_STATE(7108)] = 298015,
  [SMALL_STATE(7109)] = 298095,
  [SMALL_STATE(7110)] = 298175,
  [SMALL_STATE(7111)] = 298255,
  [SMALL_STATE(7112)] = 298335,
  [SMALL_STATE(7113)] = 298415,
  [SMALL_STATE(7114)] = 298495,
  [SMALL_STATE(7115)] = 298575,
  [SMALL_STATE(7116)] = 298653,
  [SMALL_STATE(7117)] = 298733,
  [SMALL_STATE(7118)] = 298813,
  [SMALL_STATE(7119)] = 298893,
  [SMALL_STATE(7120)] = 298973,
  [SMALL_STATE(7121)] = 299053,
  [SMALL_STATE(7122)] = 299133,
  [SMALL_STATE(7123)] = 299213,
  [SMALL_STATE(7124)] = 299291,
  [SMALL_STATE(7125)] = 299369,
  [SMALL_STATE(7126)] = 299449,
  [SMALL_STATE(7127)] = 299529,
  [SMALL_STATE(7128)] = 299609,
  [SMALL_STATE(7129)] = 299689,
  [SMALL_STATE(7130)] = 299769,
  [SMALL_STATE(7131)] = 299847,
  [SMALL_STATE(7132)] = 299924,
  [SMALL_STATE(7133)] = 299999,
  [SMALL_STATE(7134)] = 300076,
  [SMALL_STATE(7135)] = 300153,
  [SMALL_STATE(7136)] = 300230,
  [SMALL_STATE(7137)] = 300307,
  [SMALL_STATE(7138)] = 300384,
  [SMALL_STATE(7139)] = 300461,
  [SMALL_STATE(7140)] = 300538,
  [SMALL_STATE(7141)] = 300615,
  [SMALL_STATE(7142)] = 300692,
  [SMALL_STATE(7143)] = 300769,
  [SMALL_STATE(7144)] = 300846,
  [SMALL_STATE(7145)] = 300923,
  [SMALL_STATE(7146)] = 301000,
  [SMALL_STATE(7147)] = 301077,
  [SMALL_STATE(7148)] = 301154,
  [SMALL_STATE(7149)] = 301229,
  [SMALL_STATE(7150)] = 301306,
  [SMALL_STATE(7151)] = 301383,
  [SMALL_STATE(7152)] = 301460,
  [SMALL_STATE(7153)] = 301537,
  [SMALL_STATE(7154)] = 301614,
  [SMALL_STATE(7155)] = 301691,
  [SMALL_STATE(7156)] = 301768,
  [SMALL_STATE(7157)] = 301845,
  [SMALL_STATE(7158)] = 301922,
  [SMALL_STATE(7159)] = 301999,
  [SMALL_STATE(7160)] = 302076,
  [SMALL_STATE(7161)] = 302153,
  [SMALL_STATE(7162)] = 302230,
  [SMALL_STATE(7163)] = 302307,
  [SMALL_STATE(7164)] = 302384,
  [SMALL_STATE(7165)] = 302459,
  [SMALL_STATE(7166)] = 302536,
  [SMALL_STATE(7167)] = 302613,
  [SMALL_STATE(7168)] = 302690,
  [SMALL_STATE(7169)] = 302767,
  [SMALL_STATE(7170)] = 302844,
  [SMALL_STATE(7171)] = 302921,
  [SMALL_STATE(7172)] = 302998,
  [SMALL_STATE(7173)] = 303075,
  [SMALL_STATE(7174)] = 303152,
  [SMALL_STATE(7175)] = 303229,
  [SMALL_STATE(7176)] = 303304,
  [SMALL_STATE(7177)] = 303381,
  [SMALL_STATE(7178)] = 303458,
  [SMALL_STATE(7179)] = 303535,
  [SMALL_STATE(7180)] = 303610,
  [SMALL_STATE(7181)] = 303687,
  [SMALL_STATE(7182)] = 303764,
  [SMALL_STATE(7183)] = 303841,
  [SMALL_STATE(7184)] = 303918,
  [SMALL_STATE(7185)] = 303995,
  [SMALL_STATE(7186)] = 304072,
  [SMALL_STATE(7187)] = 304149,
  [SMALL_STATE(7188)] = 304226,
  [SMALL_STATE(7189)] = 304303,
  [SMALL_STATE(7190)] = 304380,
  [SMALL_STATE(7191)] = 304455,
  [SMALL_STATE(7192)] = 304532,
  [SMALL_STATE(7193)] = 304609,
  [SMALL_STATE(7194)] = 304686,
  [SMALL_STATE(7195)] = 304763,
  [SMALL_STATE(7196)] = 304840,
  [SMALL_STATE(7197)] = 304917,
  [SMALL_STATE(7198)] = 304994,
  [SMALL_STATE(7199)] = 305071,
  [SMALL_STATE(7200)] = 305148,
  [SMALL_STATE(7201)] = 305225,
  [SMALL_STATE(7202)] = 305302,
  [SMALL_STATE(7203)] = 305379,
  [SMALL_STATE(7204)] = 305456,
  [SMALL_STATE(7205)] = 305531,
  [SMALL_STATE(7206)] = 305608,
  [SMALL_STATE(7207)] = 305685,
  [SMALL_STATE(7208)] = 305762,
  [SMALL_STATE(7209)] = 305839,
  [SMALL_STATE(7210)] = 305916,
  [SMALL_STATE(7211)] = 305991,
  [SMALL_STATE(7212)] = 306068,
  [SMALL_STATE(7213)] = 306145,
  [SMALL_STATE(7214)] = 306222,
  [SMALL_STATE(7215)] = 306299,
  [SMALL_STATE(7216)] = 306376,
  [SMALL_STATE(7217)] = 306453,
  [SMALL_STATE(7218)] = 306530,
  [SMALL_STATE(7219)] = 306605,
  [SMALL_STATE(7220)] = 306682,
  [SMALL_STATE(7221)] = 306759,
  [SMALL_STATE(7222)] = 306836,
  [SMALL_STATE(7223)] = 306913,
  [SMALL_STATE(7224)] = 306990,
  [SMALL_STATE(7225)] = 307067,
  [SMALL_STATE(7226)] = 307144,
  [SMALL_STATE(7227)] = 307221,
  [SMALL_STATE(7228)] = 307298,
  [SMALL_STATE(7229)] = 307373,
  [SMALL_STATE(7230)] = 307450,
  [SMALL_STATE(7231)] = 307527,
  [SMALL_STATE(7232)] = 307604,
  [SMALL_STATE(7233)] = 307681,
  [SMALL_STATE(7234)] = 307758,
  [SMALL_STATE(7235)] = 307835,
  [SMALL_STATE(7236)] = 307912,
  [SMALL_STATE(7237)] = 307989,
  [SMALL_STATE(7238)] = 308066,
  [SMALL_STATE(7239)] = 308143,
  [SMALL_STATE(7240)] = 308220,
  [SMALL_STATE(7241)] = 308297,
  [SMALL_STATE(7242)] = 308374,
  [SMALL_STATE(7243)] = 308451,
  [SMALL_STATE(7244)] = 308528,
  [SMALL_STATE(7245)] = 308605,
  [SMALL_STATE(7246)] = 308682,
  [SMALL_STATE(7247)] = 308759,
  [SMALL_STATE(7248)] = 308836,
  [SMALL_STATE(7249)] = 308913,
  [SMALL_STATE(7250)] = 308990,
  [SMALL_STATE(7251)] = 309067,
  [SMALL_STATE(7252)] = 309144,
  [SMALL_STATE(7253)] = 309221,
  [SMALL_STATE(7254)] = 309298,
  [SMALL_STATE(7255)] = 309375,
  [SMALL_STATE(7256)] = 309449,
  [SMALL_STATE(7257)] = 309517,
  [SMALL_STATE(7258)] = 309591,
  [SMALL_STATE(7259)] = 309665,
  [SMALL_STATE(7260)] = 309739,
  [SMALL_STATE(7261)] = 309807,
  [SMALL_STATE(7262)] = 309875,
  [SMALL_STATE(7263)] = 309943,
  [SMALL_STATE(7264)] = 310017,
  [SMALL_STATE(7265)] = 310085,
  [SMALL_STATE(7266)] = 310156,
  [SMALL_STATE(7267)] = 310227,
  [SMALL_STATE(7268)] = 310298,
  [SMALL_STATE(7269)] = 310369,
  [SMALL_STATE(7270)] = 310440,
  [SMALL_STATE(7271)] = 310511,
  [SMALL_STATE(7272)] = 310582,
  [SMALL_STATE(7273)] = 310653,
  [SMALL_STATE(7274)] = 310724,
  [SMALL_STATE(7275)] = 310795,
  [SMALL_STATE(7276)] = 310866,
  [SMALL_STATE(7277)] = 310937,
  [SMALL_STATE(7278)] = 311008,
  [SMALL_STATE(7279)] = 311079,
  [SMALL_STATE(7280)] = 311150,
  [SMALL_STATE(7281)] = 311221,
  [SMALL_STATE(7282)] = 311292,
  [SMALL_STATE(7283)] = 311363,
  [SMALL_STATE(7284)] = 311434,
  [SMALL_STATE(7285)] = 311505,
  [SMALL_STATE(7286)] = 311576,
  [SMALL_STATE(7287)] = 311647,
  [SMALL_STATE(7288)] = 311718,
  [SMALL_STATE(7289)] = 311789,
  [SMALL_STATE(7290)] = 311860,
  [SMALL_STATE(7291)] = 311931,
  [SMALL_STATE(7292)] = 312002,
  [SMALL_STATE(7293)] = 312073,
  [SMALL_STATE(7294)] = 312144,
  [SMALL_STATE(7295)] = 312215,
  [SMALL_STATE(7296)] = 312286,
  [SMALL_STATE(7297)] = 312357,
  [SMALL_STATE(7298)] = 312428,
  [SMALL_STATE(7299)] = 312499,
  [SMALL_STATE(7300)] = 312570,
  [SMALL_STATE(7301)] = 312641,
  [SMALL_STATE(7302)] = 312712,
  [SMALL_STATE(7303)] = 312783,
  [SMALL_STATE(7304)] = 312854,
  [SMALL_STATE(7305)] = 312925,
  [SMALL_STATE(7306)] = 312996,
  [SMALL_STATE(7307)] = 313067,
  [SMALL_STATE(7308)] = 313138,
  [SMALL_STATE(7309)] = 313209,
  [SMALL_STATE(7310)] = 313280,
  [SMALL_STATE(7311)] = 313351,
  [SMALL_STATE(7312)] = 313422,
  [SMALL_STATE(7313)] = 313493,
  [SMALL_STATE(7314)] = 313564,
  [SMALL_STATE(7315)] = 313635,
  [SMALL_STATE(7316)] = 313706,
  [SMALL_STATE(7317)] = 313777,
  [SMALL_STATE(7318)] = 313848,
  [SMALL_STATE(7319)] = 313919,
  [SMALL_STATE(7320)] = 313990,
  [SMALL_STATE(7321)] = 314061,
  [SMALL_STATE(7322)] = 314132,
  [SMALL_STATE(7323)] = 314203,
  [SMALL_STATE(7324)] = 314274,
  [SMALL_STATE(7325)] = 314345,
  [SMALL_STATE(7326)] = 314416,
  [SMALL_STATE(7327)] = 314487,
  [SMALL_STATE(7328)] = 314558,
  [SMALL_STATE(7329)] = 314629,
  [SMALL_STATE(7330)] = 314700,
  [SMALL_STATE(7331)] = 314771,
  [SMALL_STATE(7332)] = 314842,
  [SMALL_STATE(7333)] = 314913,
  [SMALL_STATE(7334)] = 314984,
  [SMALL_STATE(7335)] = 315055,
  [SMALL_STATE(7336)] = 315126,
  [SMALL_STATE(7337)] = 315197,
  [SMALL_STATE(7338)] = 315268,
  [SMALL_STATE(7339)] = 315339,
  [SMALL_STATE(7340)] = 315410,
  [SMALL_STATE(7341)] = 315481,
  [SMALL_STATE(7342)] = 315552,
  [SMALL_STATE(7343)] = 315623,
  [SMALL_STATE(7344)] = 315694,
  [SMALL_STATE(7345)] = 315765,
  [SMALL_STATE(7346)] = 315836,
  [SMALL_STATE(7347)] = 315907,
  [SMALL_STATE(7348)] = 315978,
  [SMALL_STATE(7349)] = 316049,
  [SMALL_STATE(7350)] = 316120,
  [SMALL_STATE(7351)] = 316191,
  [SMALL_STATE(7352)] = 316262,
  [SMALL_STATE(7353)] = 316333,
  [SMALL_STATE(7354)] = 316404,
  [SMALL_STATE(7355)] = 316475,
  [SMALL_STATE(7356)] = 316546,
  [SMALL_STATE(7357)] = 316617,
  [SMALL_STATE(7358)] = 316688,
  [SMALL_STATE(7359)] = 316759,
  [SMALL_STATE(7360)] = 316830,
  [SMALL_STATE(7361)] = 316901,
  [SMALL_STATE(7362)] = 316972,
  [SMALL_STATE(7363)] = 317043,
  [SMALL_STATE(7364)] = 317114,
  [SMALL_STATE(7365)] = 317182,
  [SMALL_STATE(7366)] = 317250,
  [SMALL_STATE(7367)] = 317318,
  [SMALL_STATE(7368)] = 317386,
  [SMALL_STATE(7369)] = 317454,
  [SMALL_STATE(7370)] = 317522,
  [SMALL_STATE(7371)] = 317587,
  [SMALL_STATE(7372)] = 317652,
  [SMALL_STATE(7373)] = 317717,
  [SMALL_STATE(7374)] = 317782,
  [SMALL_STATE(7375)] = 317847,
  [SMALL_STATE(7376)] = 317910,
  [SMALL_STATE(7377)] = 317975,
  [SMALL_STATE(7378)] = 318057,
  [SMALL_STATE(7379)] = 318139,
  [SMALL_STATE(7380)] = 318221,
  [SMALL_STATE(7381)] = 318303,
  [SMALL_STATE(7382)] = 318385,
  [SMALL_STATE(7383)] = 318467,
  [SMALL_STATE(7384)] = 318549,
  [SMALL_STATE(7385)] = 318631,
  [SMALL_STATE(7386)] = 318713,
  [SMALL_STATE(7387)] = 318795,
  [SMALL_STATE(7388)] = 318877,
  [SMALL_STATE(7389)] = 318959,
  [SMALL_STATE(7390)] = 319041,
  [SMALL_STATE(7391)] = 319123,
  [SMALL_STATE(7392)] = 319205,
  [SMALL_STATE(7393)] = 319287,
  [SMALL_STATE(7394)] = 319369,
  [SMALL_STATE(7395)] = 319451,
  [SMALL_STATE(7396)] = 319533,
  [SMALL_STATE(7397)] = 319615,
  [SMALL_STATE(7398)] = 319697,
  [SMALL_STATE(7399)] = 319779,
  [SMALL_STATE(7400)] = 319861,
  [SMALL_STATE(7401)] = 319943,
  [SMALL_STATE(7402)] = 320025,
  [SMALL_STATE(7403)] = 320107,
  [SMALL_STATE(7404)] = 320189,
  [SMALL_STATE(7405)] = 320271,
  [SMALL_STATE(7406)] = 320353,
  [SMALL_STATE(7407)] = 320435,
  [SMALL_STATE(7408)] = 320517,
  [SMALL_STATE(7409)] = 320599,
  [SMALL_STATE(7410)] = 320681,
  [SMALL_STATE(7411)] = 320763,
  [SMALL_STATE(7412)] = 320845,
  [SMALL_STATE(7413)] = 320927,
  [SMALL_STATE(7414)] = 321006,
  [SMALL_STATE(7415)] = 321085,
  [SMALL_STATE(7416)] = 321164,
  [SMALL_STATE(7417)] = 321243,
  [SMALL_STATE(7418)] = 321322,
  [SMALL_STATE(7419)] = 321401,
  [SMALL_STATE(7420)] = 321480,
  [SMALL_STATE(7421)] = 321559,
  [SMALL_STATE(7422)] = 321638,
  [SMALL_STATE(7423)] = 321717,
  [SMALL_STATE(7424)] = 321796,
  [SMALL_STATE(7425)] = 321875,
  [SMALL_STATE(7426)] = 321954,
  [SMALL_STATE(7427)] = 322033,
  [SMALL_STATE(7428)] = 322112,
  [SMALL_STATE(7429)] = 322191,
  [SMALL_STATE(7430)] = 322270,
  [SMALL_STATE(7431)] = 322349,
  [SMALL_STATE(7432)] = 322428,
  [SMALL_STATE(7433)] = 322507,
  [SMALL_STATE(7434)] = 322586,
  [SMALL_STATE(7435)] = 322665,
  [SMALL_STATE(7436)] = 322744,
  [SMALL_STATE(7437)] = 322823,
  [SMALL_STATE(7438)] = 322902,
  [SMALL_STATE(7439)] = 322981,
  [SMALL_STATE(7440)] = 323060,
  [SMALL_STATE(7441)] = 323139,
  [SMALL_STATE(7442)] = 323218,
  [SMALL_STATE(7443)] = 323297,
  [SMALL_STATE(7444)] = 323376,
  [SMALL_STATE(7445)] = 323455,
  [SMALL_STATE(7446)] = 323534,
  [SMALL_STATE(7447)] = 323613,
  [SMALL_STATE(7448)] = 323692,
  [SMALL_STATE(7449)] = 323771,
  [SMALL_STATE(7450)] = 323850,
  [SMALL_STATE(7451)] = 323929,
  [SMALL_STATE(7452)] = 324008,
  [SMALL_STATE(7453)] = 324087,
  [SMALL_STATE(7454)] = 324166,
  [SMALL_STATE(7455)] = 324245,
  [SMALL_STATE(7456)] = 324324,
  [SMALL_STATE(7457)] = 324403,
  [SMALL_STATE(7458)] = 324482,
  [SMALL_STATE(7459)] = 324561,
  [SMALL_STATE(7460)] = 324640,
  [SMALL_STATE(7461)] = 324719,
  [SMALL_STATE(7462)] = 324798,
  [SMALL_STATE(7463)] = 324877,
  [SMALL_STATE(7464)] = 324956,
  [SMALL_STATE(7465)] = 325035,
  [SMALL_STATE(7466)] = 325114,
  [SMALL_STATE(7467)] = 325193,
  [SMALL_STATE(7468)] = 325272,
  [SMALL_STATE(7469)] = 325351,
  [SMALL_STATE(7470)] = 325430,
  [SMALL_STATE(7471)] = 325509,
  [SMALL_STATE(7472)] = 325588,
  [SMALL_STATE(7473)] = 325667,
  [SMALL_STATE(7474)] = 325751,
  [SMALL_STATE(7475)] = 325835,
  [SMALL_STATE(7476)] = 325919,
  [SMALL_STATE(7477)] = 325987,
  [SMALL_STATE(7478)] = 326061,
  [SMALL_STATE(7479)] = 326135,
  [SMALL_STATE(7480)] = 326209,
  [SMALL_STATE(7481)] = 326283,
  [SMALL_STATE(7482)] = 326357,
  [SMALL_STATE(7483)] = 326431,
  [SMALL_STATE(7484)] = 326505,
  [SMALL_STATE(7485)] = 326579,
  [SMALL_STATE(7486)] = 326653,
  [SMALL_STATE(7487)] = 326727,
  [SMALL_STATE(7488)] = 326801,
  [SMALL_STATE(7489)] = 326875,
  [SMALL_STATE(7490)] = 326946,
  [SMALL_STATE(7491)] = 326999,
  [SMALL_STATE(7492)] = 327070,
  [SMALL_STATE(7493)] = 327141,
  [SMALL_STATE(7494)] = 327212,
  [SMALL_STATE(7495)] = 327283,
  [SMALL_STATE(7496)] = 327354,
  [SMALL_STATE(7497)] = 327425,
  [SMALL_STATE(7498)] = 327496,
  [SMALL_STATE(7499)] = 327567,
  [SMALL_STATE(7500)] = 327638,
  [SMALL_STATE(7501)] = 327709,
  [SMALL_STATE(7502)] = 327780,
  [SMALL_STATE(7503)] = 327851,
  [SMALL_STATE(7504)] = 327922,
  [SMALL_STATE(7505)] = 327993,
  [SMALL_STATE(7506)] = 328064,
  [SMALL_STATE(7507)] = 328135,
  [SMALL_STATE(7508)] = 328206,
  [SMALL_STATE(7509)] = 328277,
  [SMALL_STATE(7510)] = 328348,
  [SMALL_STATE(7511)] = 328419,
  [SMALL_STATE(7512)] = 328490,
  [SMALL_STATE(7513)] = 328561,
  [SMALL_STATE(7514)] = 328632,
  [SMALL_STATE(7515)] = 328700,
  [SMALL_STATE(7516)] = 328766,
  [SMALL_STATE(7517)] = 328832,
  [SMALL_STATE(7518)] = 328900,
  [SMALL_STATE(7519)] = 328968,
  [SMALL_STATE(7520)] = 329036,
  [SMALL_STATE(7521)] = 329104,
  [SMALL_STATE(7522)] = 329170,
  [SMALL_STATE(7523)] = 329238,
  [SMALL_STATE(7524)] = 329306,
  [SMALL_STATE(7525)] = 329374,
  [SMALL_STATE(7526)] = 329442,
  [SMALL_STATE(7527)] = 329510,
  [SMALL_STATE(7528)] = 329576,
  [SMALL_STATE(7529)] = 329644,
  [SMALL_STATE(7530)] = 329712,
  [SMALL_STATE(7531)] = 329777,
  [SMALL_STATE(7532)] = 329842,
  [SMALL_STATE(7533)] = 329907,
  [SMALL_STATE(7534)] = 329972,
  [SMALL_STATE(7535)] = 330037,
  [SMALL_STATE(7536)] = 330102,
  [SMALL_STATE(7537)] = 330167,
  [SMALL_STATE(7538)] = 330232,
  [SMALL_STATE(7539)] = 330297,
  [SMALL_STATE(7540)] = 330362,
  [SMALL_STATE(7541)] = 330427,
  [SMALL_STATE(7542)] = 330492,
  [SMALL_STATE(7543)] = 330557,
  [SMALL_STATE(7544)] = 330622,
  [SMALL_STATE(7545)] = 330687,
  [SMALL_STATE(7546)] = 330752,
  [SMALL_STATE(7547)] = 330815,
  [SMALL_STATE(7548)] = 330880,
  [SMALL_STATE(7549)] = 330945,
  [SMALL_STATE(7550)] = 331010,
  [SMALL_STATE(7551)] = 331075,
  [SMALL_STATE(7552)] = 331140,
  [SMALL_STATE(7553)] = 331205,
  [SMALL_STATE(7554)] = 331258,
  [SMALL_STATE(7555)] = 331323,
  [SMALL_STATE(7556)] = 331388,
  [SMALL_STATE(7557)] = 331451,
  [SMALL_STATE(7558)] = 331516,
  [SMALL_STATE(7559)] = 331581,
  [SMALL_STATE(7560)] = 331646,
  [SMALL_STATE(7561)] = 331711,
  [SMALL_STATE(7562)] = 331776,
  [SMALL_STATE(7563)] = 331841,
  [SMALL_STATE(7564)] = 331906,
  [SMALL_STATE(7565)] = 331971,
  [SMALL_STATE(7566)] = 332036,
  [SMALL_STATE(7567)] = 332101,
  [SMALL_STATE(7568)] = 332166,
  [SMALL_STATE(7569)] = 332231,
  [SMALL_STATE(7570)] = 332288,
  [SMALL_STATE(7571)] = 332353,
  [SMALL_STATE(7572)] = 332418,
  [SMALL_STATE(7573)] = 332483,
  [SMALL_STATE(7574)] = 332548,
  [SMALL_STATE(7575)] = 332613,
  [SMALL_STATE(7576)] = 332678,
  [SMALL_STATE(7577)] = 332743,
  [SMALL_STATE(7578)] = 332808,
  [SMALL_STATE(7579)] = 332873,
  [SMALL_STATE(7580)] = 332926,
  [SMALL_STATE(7581)] = 332991,
  [SMALL_STATE(7582)] = 333056,
  [SMALL_STATE(7583)] = 333121,
  [SMALL_STATE(7584)] = 333186,
  [SMALL_STATE(7585)] = 333239,
  [SMALL_STATE(7586)] = 333304,
  [SMALL_STATE(7587)] = 333367,
  [SMALL_STATE(7588)] = 333432,
  [SMALL_STATE(7589)] = 333497,
  [SMALL_STATE(7590)] = 333562,
  [SMALL_STATE(7591)] = 333627,
  [SMALL_STATE(7592)] = 333692,
  [SMALL_STATE(7593)] = 333757,
  [SMALL_STATE(7594)] = 333822,
  [SMALL_STATE(7595)] = 333887,
  [SMALL_STATE(7596)] = 333938,
  [SMALL_STATE(7597)] = 334003,
  [SMALL_STATE(7598)] = 334068,
  [SMALL_STATE(7599)] = 334133,
  [SMALL_STATE(7600)] = 334198,
  [SMALL_STATE(7601)] = 334263,
  [SMALL_STATE(7602)] = 334328,
  [SMALL_STATE(7603)] = 334393,
  [SMALL_STATE(7604)] = 334458,
  [SMALL_STATE(7605)] = 334523,
  [SMALL_STATE(7606)] = 334588,
  [SMALL_STATE(7607)] = 334653,
  [SMALL_STATE(7608)] = 334718,
  [SMALL_STATE(7609)] = 334783,
  [SMALL_STATE(7610)] = 334848,
  [SMALL_STATE(7611)] = 334913,
  [SMALL_STATE(7612)] = 334978,
  [SMALL_STATE(7613)] = 335043,
  [SMALL_STATE(7614)] = 335108,
  [SMALL_STATE(7615)] = 335173,
  [SMALL_STATE(7616)] = 335238,
  [SMALL_STATE(7617)] = 335303,
  [SMALL_STATE(7618)] = 335368,
  [SMALL_STATE(7619)] = 335433,
  [SMALL_STATE(7620)] = 335498,
  [SMALL_STATE(7621)] = 335563,
  [SMALL_STATE(7622)] = 335628,
  [SMALL_STATE(7623)] = 335693,
  [SMALL_STATE(7624)] = 335758,
  [SMALL_STATE(7625)] = 335823,
  [SMALL_STATE(7626)] = 335886,
  [SMALL_STATE(7627)] = 335951,
  [SMALL_STATE(7628)] = 336016,
  [SMALL_STATE(7629)] = 336081,
  [SMALL_STATE(7630)] = 336146,
  [SMALL_STATE(7631)] = 336211,
  [SMALL_STATE(7632)] = 336276,
  [SMALL_STATE(7633)] = 336341,
  [SMALL_STATE(7634)] = 336406,
  [SMALL_STATE(7635)] = 336471,
  [SMALL_STATE(7636)] = 336536,
  [SMALL_STATE(7637)] = 336601,
  [SMALL_STATE(7638)] = 336666,
  [SMALL_STATE(7639)] = 336731,
  [SMALL_STATE(7640)] = 336796,
  [SMALL_STATE(7641)] = 336861,
  [SMALL_STATE(7642)] = 336923,
  [SMALL_STATE(7643)] = 336985,
  [SMALL_STATE(7644)] = 337033,
  [SMALL_STATE(7645)] = 337095,
  [SMALL_STATE(7646)] = 337157,
  [SMALL_STATE(7647)] = 337219,
  [SMALL_STATE(7648)] = 337281,
  [SMALL_STATE(7649)] = 337343,
  [SMALL_STATE(7650)] = 337405,
  [SMALL_STATE(7651)] = 337453,
  [SMALL_STATE(7652)] = 337515,
  [SMALL_STATE(7653)] = 337577,
  [SMALL_STATE(7654)] = 337639,
  [SMALL_STATE(7655)] = 337701,
  [SMALL_STATE(7656)] = 337763,
  [SMALL_STATE(7657)] = 337825,
  [SMALL_STATE(7658)] = 337887,
  [SMALL_STATE(7659)] = 337949,
  [SMALL_STATE(7660)] = 338011,
  [SMALL_STATE(7661)] = 338073,
  [SMALL_STATE(7662)] = 338135,
  [SMALL_STATE(7663)] = 338197,
  [SMALL_STATE(7664)] = 338259,
  [SMALL_STATE(7665)] = 338321,
  [SMALL_STATE(7666)] = 338383,
  [SMALL_STATE(7667)] = 338445,
  [SMALL_STATE(7668)] = 338507,
  [SMALL_STATE(7669)] = 338569,
  [SMALL_STATE(7670)] = 338631,
  [SMALL_STATE(7671)] = 338689,
  [SMALL_STATE(7672)] = 338751,
  [SMALL_STATE(7673)] = 338813,
  [SMALL_STATE(7674)] = 338875,
  [SMALL_STATE(7675)] = 338934,
  [SMALL_STATE(7676)] = 338993,
  [SMALL_STATE(7677)] = 339050,
  [SMALL_STATE(7678)] = 339109,
  [SMALL_STATE(7679)] = 339168,
  [SMALL_STATE(7680)] = 339227,
  [SMALL_STATE(7681)] = 339286,
  [SMALL_STATE(7682)] = 339345,
  [SMALL_STATE(7683)] = 339404,
  [SMALL_STATE(7684)] = 339461,
  [SMALL_STATE(7685)] = 339520,
  [SMALL_STATE(7686)] = 339567,
  [SMALL_STATE(7687)] = 339626,
  [SMALL_STATE(7688)] = 339685,
  [SMALL_STATE(7689)] = 339742,
  [SMALL_STATE(7690)] = 339799,
  [SMALL_STATE(7691)] = 339858,
  [SMALL_STATE(7692)] = 339917,
  [SMALL_STATE(7693)] = 339976,
  [SMALL_STATE(7694)] = 340035,
  [SMALL_STATE(7695)] = 340094,
  [SMALL_STATE(7696)] = 340153,
  [SMALL_STATE(7697)] = 340212,
  [SMALL_STATE(7698)] = 340271,
  [SMALL_STATE(7699)] = 340330,
  [SMALL_STATE(7700)] = 340389,
  [SMALL_STATE(7701)] = 340448,
  [SMALL_STATE(7702)] = 340505,
  [SMALL_STATE(7703)] = 340564,
  [SMALL_STATE(7704)] = 340621,
  [SMALL_STATE(7705)] = 340680,
  [SMALL_STATE(7706)] = 340739,
  [SMALL_STATE(7707)] = 340798,
  [SMALL_STATE(7708)] = 340857,
  [SMALL_STATE(7709)] = 340916,
  [SMALL_STATE(7710)] = 340963,
  [SMALL_STATE(7711)] = 341022,
  [SMALL_STATE(7712)] = 341081,
  [SMALL_STATE(7713)] = 341136,
  [SMALL_STATE(7714)] = 341193,
  [SMALL_STATE(7715)] = 341250,
  [SMALL_STATE(7716)] = 341309,
  [SMALL_STATE(7717)] = 341368,
  [SMALL_STATE(7718)] = 341425,
  [SMALL_STATE(7719)] = 341484,
  [SMALL_STATE(7720)] = 341541,
  [SMALL_STATE(7721)] = 341600,
  [SMALL_STATE(7722)] = 341659,
  [SMALL_STATE(7723)] = 341718,
  [SMALL_STATE(7724)] = 341777,
  [SMALL_STATE(7725)] = 341836,
  [SMALL_STATE(7726)] = 341893,
  [SMALL_STATE(7727)] = 341952,
  [SMALL_STATE(7728)] = 342011,
  [SMALL_STATE(7729)] = 342070,
  [SMALL_STATE(7730)] = 342129,
  [SMALL_STATE(7731)] = 342188,
  [SMALL_STATE(7732)] = 342247,
  [SMALL_STATE(7733)] = 342306,
  [SMALL_STATE(7734)] = 342365,
  [SMALL_STATE(7735)] = 342424,
  [SMALL_STATE(7736)] = 342471,
  [SMALL_STATE(7737)] = 342530,
  [SMALL_STATE(7738)] = 342589,
  [SMALL_STATE(7739)] = 342646,
  [SMALL_STATE(7740)] = 342705,
  [SMALL_STATE(7741)] = 342752,
  [SMALL_STATE(7742)] = 342811,
  [SMALL_STATE(7743)] = 342865,
  [SMALL_STATE(7744)] = 342921,
  [SMALL_STATE(7745)] = 342977,
  [SMALL_STATE(7746)] = 343033,
  [SMALL_STATE(7747)] = 343089,
  [SMALL_STATE(7748)] = 343145,
  [SMALL_STATE(7749)] = 343201,
  [SMALL_STATE(7750)] = 343251,
  [SMALL_STATE(7751)] = 343307,
  [SMALL_STATE(7752)] = 343363,
  [SMALL_STATE(7753)] = 343417,
  [SMALL_STATE(7754)] = 343473,
  [SMALL_STATE(7755)] = 343529,
  [SMALL_STATE(7756)] = 343585,
  [SMALL_STATE(7757)] = 343635,
  [SMALL_STATE(7758)] = 343691,
  [SMALL_STATE(7759)] = 343747,
  [SMALL_STATE(7760)] = 343803,
  [SMALL_STATE(7761)] = 343859,
  [SMALL_STATE(7762)] = 343907,
  [SMALL_STATE(7763)] = 343961,
  [SMALL_STATE(7764)] = 344017,
  [SMALL_STATE(7765)] = 344073,
  [SMALL_STATE(7766)] = 344129,
  [SMALL_STATE(7767)] = 344185,
  [SMALL_STATE(7768)] = 344241,
  [SMALL_STATE(7769)] = 344297,
  [SMALL_STATE(7770)] = 344353,
  [SMALL_STATE(7771)] = 344409,
  [SMALL_STATE(7772)] = 344465,
  [SMALL_STATE(7773)] = 344521,
  [SMALL_STATE(7774)] = 344577,
  [SMALL_STATE(7775)] = 344633,
  [SMALL_STATE(7776)] = 344689,
  [SMALL_STATE(7777)] = 344745,
  [SMALL_STATE(7778)] = 344801,
  [SMALL_STATE(7779)] = 344857,
  [SMALL_STATE(7780)] = 344911,
  [SMALL_STATE(7781)] = 344967,
  [SMALL_STATE(7782)] = 345023,
  [SMALL_STATE(7783)] = 345079,
  [SMALL_STATE(7784)] = 345135,
  [SMALL_STATE(7785)] = 345191,
  [SMALL_STATE(7786)] = 345247,
  [SMALL_STATE(7787)] = 345303,
  [SMALL_STATE(7788)] = 345359,
  [SMALL_STATE(7789)] = 345413,
  [SMALL_STATE(7790)] = 345469,
  [SMALL_STATE(7791)] = 345525,
  [SMALL_STATE(7792)] = 345581,
  [SMALL_STATE(7793)] = 345637,
  [SMALL_STATE(7794)] = 345693,
  [SMALL_STATE(7795)] = 345741,
  [SMALL_STATE(7796)] = 345795,
  [SMALL_STATE(7797)] = 345851,
  [SMALL_STATE(7798)] = 345905,
  [SMALL_STATE(7799)] = 345961,
  [SMALL_STATE(7800)] = 346017,
  [SMALL_STATE(7801)] = 346073,
  [SMALL_STATE(7802)] = 346129,
  [SMALL_STATE(7803)] = 346183,
  [SMALL_STATE(7804)] = 346239,
  [SMALL_STATE(7805)] = 346295,
  [SMALL_STATE(7806)] = 346351,
  [SMALL_STATE(7807)] = 346407,
  [SMALL_STATE(7808)] = 346463,
  [SMALL_STATE(7809)] = 346519,
  [SMALL_STATE(7810)] = 346569,
  [SMALL_STATE(7811)] = 346625,
  [SMALL_STATE(7812)] = 346681,
  [SMALL_STATE(7813)] = 346737,
  [SMALL_STATE(7814)] = 346793,
  [SMALL_STATE(7815)] = 346849,
  [SMALL_STATE(7816)] = 346905,
  [SMALL_STATE(7817)] = 346961,
  [SMALL_STATE(7818)] = 347017,
  [SMALL_STATE(7819)] = 347073,
  [SMALL_STATE(7820)] = 347129,
  [SMALL_STATE(7821)] = 347185,
  [SMALL_STATE(7822)] = 347241,
  [SMALL_STATE(7823)] = 347297,
  [SMALL_STATE(7824)] = 347353,
  [SMALL_STATE(7825)] = 347409,
  [SMALL_STATE(7826)] = 347465,
  [SMALL_STATE(7827)] = 347521,
  [SMALL_STATE(7828)] = 347577,
  [SMALL_STATE(7829)] = 347633,
  [SMALL_STATE(7830)] = 347681,
  [SMALL_STATE(7831)] = 347737,
  [SMALL_STATE(7832)] = 347783,
  [SMALL_STATE(7833)] = 347839,
  [SMALL_STATE(7834)] = 347895,
  [SMALL_STATE(7835)] = 347951,
  [SMALL_STATE(7836)] = 347997,
  [SMALL_STATE(7837)] = 348053,
  [SMALL_STATE(7838)] = 348109,
  [SMALL_STATE(7839)] = 348161,
  [SMALL_STATE(7840)] = 348217,
  [SMALL_STATE(7841)] = 348265,
  [SMALL_STATE(7842)] = 348321,
  [SMALL_STATE(7843)] = 348377,
  [SMALL_STATE(7844)] = 348433,
  [SMALL_STATE(7845)] = 348489,
  [SMALL_STATE(7846)] = 348545,
  [SMALL_STATE(7847)] = 348601,
  [SMALL_STATE(7848)] = 348655,
  [SMALL_STATE(7849)] = 348711,
  [SMALL_STATE(7850)] = 348757,
  [SMALL_STATE(7851)] = 348813,
  [SMALL_STATE(7852)] = 348869,
  [SMALL_STATE(7853)] = 348925,
  [SMALL_STATE(7854)] = 348981,
  [SMALL_STATE(7855)] = 349035,
  [SMALL_STATE(7856)] = 349091,
  [SMALL_STATE(7857)] = 349147,
  [SMALL_STATE(7858)] = 349203,
  [SMALL_STATE(7859)] = 349259,
  [SMALL_STATE(7860)] = 349315,
  [SMALL_STATE(7861)] = 349371,
  [SMALL_STATE(7862)] = 349427,
  [SMALL_STATE(7863)] = 349483,
  [SMALL_STATE(7864)] = 349539,
  [SMALL_STATE(7865)] = 349595,
  [SMALL_STATE(7866)] = 349651,
  [SMALL_STATE(7867)] = 349707,
  [SMALL_STATE(7868)] = 349763,
  [SMALL_STATE(7869)] = 349819,
  [SMALL_STATE(7870)] = 349875,
  [SMALL_STATE(7871)] = 349931,
  [SMALL_STATE(7872)] = 349987,
  [SMALL_STATE(7873)] = 350043,
  [SMALL_STATE(7874)] = 350099,
  [SMALL_STATE(7875)] = 350155,
  [SMALL_STATE(7876)] = 350211,
  [SMALL_STATE(7877)] = 350267,
  [SMALL_STATE(7878)] = 350323,
  [SMALL_STATE(7879)] = 350379,
  [SMALL_STATE(7880)] = 350431,
  [SMALL_STATE(7881)] = 350487,
  [SMALL_STATE(7882)] = 350543,
  [SMALL_STATE(7883)] = 350597,
  [SMALL_STATE(7884)] = 350653,
  [SMALL_STATE(7885)] = 350709,
  [SMALL_STATE(7886)] = 350765,
  [SMALL_STATE(7887)] = 350821,
  [SMALL_STATE(7888)] = 350877,
  [SMALL_STATE(7889)] = 350933,
  [SMALL_STATE(7890)] = 350983,
  [SMALL_STATE(7891)] = 351039,
  [SMALL_STATE(7892)] = 351095,
  [SMALL_STATE(7893)] = 351151,
  [SMALL_STATE(7894)] = 351207,
  [SMALL_STATE(7895)] = 351263,
  [SMALL_STATE(7896)] = 351319,
  [SMALL_STATE(7897)] = 351375,
  [SMALL_STATE(7898)] = 351431,
  [SMALL_STATE(7899)] = 351487,
  [SMALL_STATE(7900)] = 351543,
  [SMALL_STATE(7901)] = 351599,
  [SMALL_STATE(7902)] = 351655,
  [SMALL_STATE(7903)] = 351701,
  [SMALL_STATE(7904)] = 351755,
  [SMALL_STATE(7905)] = 351811,
  [SMALL_STATE(7906)] = 351867,
  [SMALL_STATE(7907)] = 351923,
  [SMALL_STATE(7908)] = 351979,
  [SMALL_STATE(7909)] = 352035,
  [SMALL_STATE(7910)] = 352085,
  [SMALL_STATE(7911)] = 352141,
  [SMALL_STATE(7912)] = 352197,
  [SMALL_STATE(7913)] = 352253,
  [SMALL_STATE(7914)] = 352306,
  [SMALL_STATE(7915)] = 352359,
  [SMALL_STATE(7916)] = 352412,
  [SMALL_STATE(7917)] = 352465,
  [SMALL_STATE(7918)] = 352518,
  [SMALL_STATE(7919)] = 352571,
  [SMALL_STATE(7920)] = 352624,
  [SMALL_STATE(7921)] = 352677,
  [SMALL_STATE(7922)] = 352730,
  [SMALL_STATE(7923)] = 352783,
  [SMALL_STATE(7924)] = 352828,
  [SMALL_STATE(7925)] = 352881,
  [SMALL_STATE(7926)] = 352934,
  [SMALL_STATE(7927)] = 352985,
  [SMALL_STATE(7928)] = 353038,
  [SMALL_STATE(7929)] = 353091,
  [SMALL_STATE(7930)] = 353144,
  [SMALL_STATE(7931)] = 353197,
  [SMALL_STATE(7932)] = 353250,
  [SMALL_STATE(7933)] = 353303,
  [SMALL_STATE(7934)] = 353356,
  [SMALL_STATE(7935)] = 353403,
  [SMALL_STATE(7936)] = 353456,
  [SMALL_STATE(7937)] = 353509,
  [SMALL_STATE(7938)] = 353562,
  [SMALL_STATE(7939)] = 353613,
  [SMALL_STATE(7940)] = 353666,
  [SMALL_STATE(7941)] = 353719,
  [SMALL_STATE(7942)] = 353772,
  [SMALL_STATE(7943)] = 353825,
  [SMALL_STATE(7944)] = 353878,
  [SMALL_STATE(7945)] = 353931,
  [SMALL_STATE(7946)] = 353984,
  [SMALL_STATE(7947)] = 354037,
  [SMALL_STATE(7948)] = 354090,
  [SMALL_STATE(7949)] = 354143,
  [SMALL_STATE(7950)] = 354196,
  [SMALL_STATE(7951)] = 354249,
  [SMALL_STATE(7952)] = 354302,
  [SMALL_STATE(7953)] = 354355,
  [SMALL_STATE(7954)] = 354408,
  [SMALL_STATE(7955)] = 354461,
  [SMALL_STATE(7956)] = 354514,
  [SMALL_STATE(7957)] = 354567,
  [SMALL_STATE(7958)] = 354620,
  [SMALL_STATE(7959)] = 354673,
  [SMALL_STATE(7960)] = 354724,
  [SMALL_STATE(7961)] = 354777,
  [SMALL_STATE(7962)] = 354828,
  [SMALL_STATE(7963)] = 354881,
  [SMALL_STATE(7964)] = 354934,
  [SMALL_STATE(7965)] = 354987,
  [SMALL_STATE(7966)] = 355040,
  [SMALL_STATE(7967)] = 355093,
  [SMALL_STATE(7968)] = 355146,
  [SMALL_STATE(7969)] = 355199,
  [SMALL_STATE(7970)] = 355252,
  [SMALL_STATE(7971)] = 355305,
  [SMALL_STATE(7972)] = 355358,
  [SMALL_STATE(7973)] = 355411,
  [SMALL_STATE(7974)] = 355464,
  [SMALL_STATE(7975)] = 355517,
  [SMALL_STATE(7976)] = 355570,
  [SMALL_STATE(7977)] = 355621,
  [SMALL_STATE(7978)] = 355674,
  [SMALL_STATE(7979)] = 355723,
  [SMALL_STATE(7980)] = 355774,
  [SMALL_STATE(7981)] = 355825,
  [SMALL_STATE(7982)] = 355878,
  [SMALL_STATE(7983)] = 355931,
  [SMALL_STATE(7984)] = 355984,
  [SMALL_STATE(7985)] = 356035,
  [SMALL_STATE(7986)] = 356088,
  [SMALL_STATE(7987)] = 356141,
  [SMALL_STATE(7988)] = 356194,
  [SMALL_STATE(7989)] = 356247,
  [SMALL_STATE(7990)] = 356300,
  [SMALL_STATE(7991)] = 356353,
  [SMALL_STATE(7992)] = 356406,
  [SMALL_STATE(7993)] = 356459,
  [SMALL_STATE(7994)] = 356512,
  [SMALL_STATE(7995)] = 356565,
  [SMALL_STATE(7996)] = 356618,
  [SMALL_STATE(7997)] = 356671,
  [SMALL_STATE(7998)] = 356724,
  [SMALL_STATE(7999)] = 356777,
  [SMALL_STATE(8000)] = 356822,
  [SMALL_STATE(8001)] = 356875,
  [SMALL_STATE(8002)] = 356928,
  [SMALL_STATE(8003)] = 356981,
  [SMALL_STATE(8004)] = 357034,
  [SMALL_STATE(8005)] = 357087,
  [SMALL_STATE(8006)] = 357140,
  [SMALL_STATE(8007)] = 357193,
  [SMALL_STATE(8008)] = 357246,
  [SMALL_STATE(8009)] = 357299,
  [SMALL_STATE(8010)] = 357352,
  [SMALL_STATE(8011)] = 357405,
  [SMALL_STATE(8012)] = 357458,
  [SMALL_STATE(8013)] = 357511,
  [SMALL_STATE(8014)] = 357564,
  [SMALL_STATE(8015)] = 357617,
  [SMALL_STATE(8016)] = 357670,
  [SMALL_STATE(8017)] = 357721,
  [SMALL_STATE(8018)] = 357774,
  [SMALL_STATE(8019)] = 357827,
  [SMALL_STATE(8020)] = 357880,
  [SMALL_STATE(8021)] = 357933,
  [SMALL_STATE(8022)] = 357986,
  [SMALL_STATE(8023)] = 358039,
  [SMALL_STATE(8024)] = 358092,
  [SMALL_STATE(8025)] = 358145,
  [SMALL_STATE(8026)] = 358198,
  [SMALL_STATE(8027)] = 358251,
  [SMALL_STATE(8028)] = 358304,
  [SMALL_STATE(8029)] = 358357,
  [SMALL_STATE(8030)] = 358410,
  [SMALL_STATE(8031)] = 358463,
  [SMALL_STATE(8032)] = 358516,
  [SMALL_STATE(8033)] = 358569,
  [SMALL_STATE(8034)] = 358622,
  [SMALL_STATE(8035)] = 358675,
  [SMALL_STATE(8036)] = 358728,
  [SMALL_STATE(8037)] = 358781,
  [SMALL_STATE(8038)] = 358834,
  [SMALL_STATE(8039)] = 358879,
  [SMALL_STATE(8040)] = 358932,
  [SMALL_STATE(8041)] = 358985,
  [SMALL_STATE(8042)] = 359038,
  [SMALL_STATE(8043)] = 359091,
  [SMALL_STATE(8044)] = 359136,
  [SMALL_STATE(8045)] = 359189,
  [SMALL_STATE(8046)] = 359242,
  [SMALL_STATE(8047)] = 359295,
  [SMALL_STATE(8048)] = 359346,
  [SMALL_STATE(8049)] = 359399,
  [SMALL_STATE(8050)] = 359452,
  [SMALL_STATE(8051)] = 359503,
  [SMALL_STATE(8052)] = 359556,
  [SMALL_STATE(8053)] = 359609,
  [SMALL_STATE(8054)] = 359662,
  [SMALL_STATE(8055)] = 359715,
  [SMALL_STATE(8056)] = 359768,
  [SMALL_STATE(8057)] = 359819,
  [SMALL_STATE(8058)] = 359872,
  [SMALL_STATE(8059)] = 359925,
  [SMALL_STATE(8060)] = 359978,
  [SMALL_STATE(8061)] = 360031,
  [SMALL_STATE(8062)] = 360082,
  [SMALL_STATE(8063)] = 360133,
  [SMALL_STATE(8064)] = 360186,
  [SMALL_STATE(8065)] = 360239,
  [SMALL_STATE(8066)] = 360286,
  [SMALL_STATE(8067)] = 360339,
  [SMALL_STATE(8068)] = 360392,
  [SMALL_STATE(8069)] = 360445,
  [SMALL_STATE(8070)] = 360498,
  [SMALL_STATE(8071)] = 360551,
  [SMALL_STATE(8072)] = 360596,
  [SMALL_STATE(8073)] = 360649,
  [SMALL_STATE(8074)] = 360702,
  [SMALL_STATE(8075)] = 360755,
  [SMALL_STATE(8076)] = 360808,
  [SMALL_STATE(8077)] = 360861,
  [SMALL_STATE(8078)] = 360914,
  [SMALL_STATE(8079)] = 360967,
  [SMALL_STATE(8080)] = 361020,
  [SMALL_STATE(8081)] = 361065,
  [SMALL_STATE(8082)] = 361118,
  [SMALL_STATE(8083)] = 361171,
  [SMALL_STATE(8084)] = 361216,
  [SMALL_STATE(8085)] = 361269,
  [SMALL_STATE(8086)] = 361322,
  [SMALL_STATE(8087)] = 361375,
  [SMALL_STATE(8088)] = 361428,
  [SMALL_STATE(8089)] = 361481,
  [SMALL_STATE(8090)] = 361534,
  [SMALL_STATE(8091)] = 361587,
  [SMALL_STATE(8092)] = 361640,
  [SMALL_STATE(8093)] = 361693,
  [SMALL_STATE(8094)] = 361746,
  [SMALL_STATE(8095)] = 361799,
  [SMALL_STATE(8096)] = 361852,
  [SMALL_STATE(8097)] = 361905,
  [SMALL_STATE(8098)] = 361956,
  [SMALL_STATE(8099)] = 362007,
  [SMALL_STATE(8100)] = 362060,
  [SMALL_STATE(8101)] = 362105,
  [SMALL_STATE(8102)] = 362158,
  [SMALL_STATE(8103)] = 362207,
  [SMALL_STATE(8104)] = 362258,
  [SMALL_STATE(8105)] = 362311,
  [SMALL_STATE(8106)] = 362364,
  [SMALL_STATE(8107)] = 362415,
  [SMALL_STATE(8108)] = 362468,
  [SMALL_STATE(8109)] = 362517,
  [SMALL_STATE(8110)] = 362562,
  [SMALL_STATE(8111)] = 362615,
  [SMALL_STATE(8112)] = 362668,
  [SMALL_STATE(8113)] = 362721,
  [SMALL_STATE(8114)] = 362768,
  [SMALL_STATE(8115)] = 362817,
  [SMALL_STATE(8116)] = 362870,
  [SMALL_STATE(8117)] = 362923,
  [SMALL_STATE(8118)] = 362976,
  [SMALL_STATE(8119)] = 363029,
  [SMALL_STATE(8120)] = 363082,
  [SMALL_STATE(8121)] = 363135,
  [SMALL_STATE(8122)] = 363188,
  [SMALL_STATE(8123)] = 363239,
  [SMALL_STATE(8124)] = 363292,
  [SMALL_STATE(8125)] = 363345,
  [SMALL_STATE(8126)] = 363398,
  [SMALL_STATE(8127)] = 363451,
  [SMALL_STATE(8128)] = 363504,
  [SMALL_STATE(8129)] = 363557,
  [SMALL_STATE(8130)] = 363610,
  [SMALL_STATE(8131)] = 363663,
  [SMALL_STATE(8132)] = 363716,
  [SMALL_STATE(8133)] = 363769,
  [SMALL_STATE(8134)] = 363822,
  [SMALL_STATE(8135)] = 363869,
  [SMALL_STATE(8136)] = 363922,
  [SMALL_STATE(8137)] = 363975,
  [SMALL_STATE(8138)] = 364028,
  [SMALL_STATE(8139)] = 364081,
  [SMALL_STATE(8140)] = 364126,
  [SMALL_STATE(8141)] = 364179,
  [SMALL_STATE(8142)] = 364230,
  [SMALL_STATE(8143)] = 364283,
  [SMALL_STATE(8144)] = 364330,
  [SMALL_STATE(8145)] = 364383,
  [SMALL_STATE(8146)] = 364436,
  [SMALL_STATE(8147)] = 364489,
  [SMALL_STATE(8148)] = 364542,
  [SMALL_STATE(8149)] = 364595,
  [SMALL_STATE(8150)] = 364640,
  [SMALL_STATE(8151)] = 364693,
  [SMALL_STATE(8152)] = 364746,
  [SMALL_STATE(8153)] = 364799,
  [SMALL_STATE(8154)] = 364852,
  [SMALL_STATE(8155)] = 364905,
  [SMALL_STATE(8156)] = 364950,
  [SMALL_STATE(8157)] = 365003,
  [SMALL_STATE(8158)] = 365056,
  [SMALL_STATE(8159)] = 365107,
  [SMALL_STATE(8160)] = 365160,
  [SMALL_STATE(8161)] = 365205,
  [SMALL_STATE(8162)] = 365258,
  [SMALL_STATE(8163)] = 365311,
  [SMALL_STATE(8164)] = 365362,
  [SMALL_STATE(8165)] = 365415,
  [SMALL_STATE(8166)] = 365468,
  [SMALL_STATE(8167)] = 365521,
  [SMALL_STATE(8168)] = 365574,
  [SMALL_STATE(8169)] = 365619,
  [SMALL_STATE(8170)] = 365666,
  [SMALL_STATE(8171)] = 365711,
  [SMALL_STATE(8172)] = 365764,
  [SMALL_STATE(8173)] = 365815,
  [SMALL_STATE(8174)] = 365868,
  [SMALL_STATE(8175)] = 365921,
  [SMALL_STATE(8176)] = 365972,
  [SMALL_STATE(8177)] = 366023,
  [SMALL_STATE(8178)] = 366070,
  [SMALL_STATE(8179)] = 366123,
  [SMALL_STATE(8180)] = 366168,
  [SMALL_STATE(8181)] = 366219,
  [SMALL_STATE(8182)] = 366270,
  [SMALL_STATE(8183)] = 366317,
  [SMALL_STATE(8184)] = 366370,
  [SMALL_STATE(8185)] = 366423,
  [SMALL_STATE(8186)] = 366476,
  [SMALL_STATE(8187)] = 366529,
  [SMALL_STATE(8188)] = 366582,
  [SMALL_STATE(8189)] = 366635,
  [SMALL_STATE(8190)] = 366688,
  [SMALL_STATE(8191)] = 366741,
  [SMALL_STATE(8192)] = 366788,
  [SMALL_STATE(8193)] = 366841,
  [SMALL_STATE(8194)] = 366888,
  [SMALL_STATE(8195)] = 366937,
  [SMALL_STATE(8196)] = 366988,
  [SMALL_STATE(8197)] = 367041,
  [SMALL_STATE(8198)] = 367094,
  [SMALL_STATE(8199)] = 367147,
  [SMALL_STATE(8200)] = 367200,
  [SMALL_STATE(8201)] = 367247,
  [SMALL_STATE(8202)] = 367300,
  [SMALL_STATE(8203)] = 367353,
  [SMALL_STATE(8204)] = 367406,
  [SMALL_STATE(8205)] = 367459,
  [SMALL_STATE(8206)] = 367512,
  [SMALL_STATE(8207)] = 367565,
  [SMALL_STATE(8208)] = 367618,
  [SMALL_STATE(8209)] = 367669,
  [SMALL_STATE(8210)] = 367717,
  [SMALL_STATE(8211)] = 367767,
  [SMALL_STATE(8212)] = 367817,
  [SMALL_STATE(8213)] = 367867,
  [SMALL_STATE(8214)] = 367917,
  [SMALL_STATE(8215)] = 367967,
  [SMALL_STATE(8216)] = 368015,
  [SMALL_STATE(8217)] = 368065,
  [SMALL_STATE(8218)] = 368115,
  [SMALL_STATE(8219)] = 368159,
  [SMALL_STATE(8220)] = 368209,
  [SMALL_STATE(8221)] = 368253,
  [SMALL_STATE(8222)] = 368301,
  [SMALL_STATE(8223)] = 368347,
  [SMALL_STATE(8224)] = 368397,
  [SMALL_STATE(8225)] = 368443,
  [SMALL_STATE(8226)] = 368493,
  [SMALL_STATE(8227)] = 368543,
  [SMALL_STATE(8228)] = 368587,
  [SMALL_STATE(8229)] = 368637,
  [SMALL_STATE(8230)] = 368681,
  [SMALL_STATE(8231)] = 368731,
  [SMALL_STATE(8232)] = 368781,
  [SMALL_STATE(8233)] = 368829,
  [SMALL_STATE(8234)] = 368877,
  [SMALL_STATE(8235)] = 368921,
  [SMALL_STATE(8236)] = 368971,
  [SMALL_STATE(8237)] = 369021,
  [SMALL_STATE(8238)] = 369071,
  [SMALL_STATE(8239)] = 369121,
  [SMALL_STATE(8240)] = 369171,
  [SMALL_STATE(8241)] = 369221,
  [SMALL_STATE(8242)] = 369267,
  [SMALL_STATE(8243)] = 369313,
  [SMALL_STATE(8244)] = 369359,
  [SMALL_STATE(8245)] = 369409,
  [SMALL_STATE(8246)] = 369459,
  [SMALL_STATE(8247)] = 369509,
  [SMALL_STATE(8248)] = 369559,
  [SMALL_STATE(8249)] = 369609,
  [SMALL_STATE(8250)] = 369659,
  [SMALL_STATE(8251)] = 369703,
  [SMALL_STATE(8252)] = 369749,
  [SMALL_STATE(8253)] = 369799,
  [SMALL_STATE(8254)] = 369849,
  [SMALL_STATE(8255)] = 369899,
  [SMALL_STATE(8256)] = 369949,
  [SMALL_STATE(8257)] = 369999,
  [SMALL_STATE(8258)] = 370049,
  [SMALL_STATE(8259)] = 370099,
  [SMALL_STATE(8260)] = 370149,
  [SMALL_STATE(8261)] = 370199,
  [SMALL_STATE(8262)] = 370249,
  [SMALL_STATE(8263)] = 370299,
  [SMALL_STATE(8264)] = 370349,
  [SMALL_STATE(8265)] = 370399,
  [SMALL_STATE(8266)] = 370449,
  [SMALL_STATE(8267)] = 370495,
  [SMALL_STATE(8268)] = 370545,
  [SMALL_STATE(8269)] = 370591,
  [SMALL_STATE(8270)] = 370641,
  [SMALL_STATE(8271)] = 370691,
  [SMALL_STATE(8272)] = 370741,
  [SMALL_STATE(8273)] = 370791,
  [SMALL_STATE(8274)] = 370837,
  [SMALL_STATE(8275)] = 370887,
  [SMALL_STATE(8276)] = 370937,
  [SMALL_STATE(8277)] = 370987,
  [SMALL_STATE(8278)] = 371033,
  [SMALL_STATE(8279)] = 371079,
  [SMALL_STATE(8280)] = 371129,
  [SMALL_STATE(8281)] = 371173,
  [SMALL_STATE(8282)] = 371217,
  [SMALL_STATE(8283)] = 371265,
  [SMALL_STATE(8284)] = 371309,
  [SMALL_STATE(8285)] = 371359,
  [SMALL_STATE(8286)] = 371409,
  [SMALL_STATE(8287)] = 371459,
  [SMALL_STATE(8288)] = 371505,
  [SMALL_STATE(8289)] = 371549,
  [SMALL_STATE(8290)] = 371599,
  [SMALL_STATE(8291)] = 371649,
  [SMALL_STATE(8292)] = 371699,
  [SMALL_STATE(8293)] = 371743,
  [SMALL_STATE(8294)] = 371793,
  [SMALL_STATE(8295)] = 371843,
  [SMALL_STATE(8296)] = 371893,
  [SMALL_STATE(8297)] = 371941,
  [SMALL_STATE(8298)] = 371991,
  [SMALL_STATE(8299)] = 372035,
  [SMALL_STATE(8300)] = 372083,
  [SMALL_STATE(8301)] = 372133,
  [SMALL_STATE(8302)] = 372183,
  [SMALL_STATE(8303)] = 372233,
  [SMALL_STATE(8304)] = 372281,
  [SMALL_STATE(8305)] = 372325,
  [SMALL_STATE(8306)] = 372371,
  [SMALL_STATE(8307)] = 372419,
  [SMALL_STATE(8308)] = 372467,
  [SMALL_STATE(8309)] = 372511,
  [SMALL_STATE(8310)] = 372557,
  [SMALL_STATE(8311)] = 372607,
  [SMALL_STATE(8312)] = 372657,
  [SMALL_STATE(8313)] = 372707,
  [SMALL_STATE(8314)] = 372757,
  [SMALL_STATE(8315)] = 372807,
  [SMALL_STATE(8316)] = 372857,
  [SMALL_STATE(8317)] = 372907,
  [SMALL_STATE(8318)] = 372957,
  [SMALL_STATE(8319)] = 373007,
  [SMALL_STATE(8320)] = 373057,
  [SMALL_STATE(8321)] = 373107,
  [SMALL_STATE(8322)] = 373157,
  [SMALL_STATE(8323)] = 373205,
  [SMALL_STATE(8324)] = 373249,
  [SMALL_STATE(8325)] = 373299,
  [SMALL_STATE(8326)] = 373349,
  [SMALL_STATE(8327)] = 373399,
  [SMALL_STATE(8328)] = 373445,
  [SMALL_STATE(8329)] = 373495,
  [SMALL_STATE(8330)] = 373545,
  [SMALL_STATE(8331)] = 373595,
  [SMALL_STATE(8332)] = 373645,
  [SMALL_STATE(8333)] = 373691,
  [SMALL_STATE(8334)] = 373741,
  [SMALL_STATE(8335)] = 373787,
  [SMALL_STATE(8336)] = 373837,
  [SMALL_STATE(8337)] = 373883,
  [SMALL_STATE(8338)] = 373933,
  [SMALL_STATE(8339)] = 373981,
  [SMALL_STATE(8340)] = 374031,
  [SMALL_STATE(8341)] = 374075,
  [SMALL_STATE(8342)] = 374125,
  [SMALL_STATE(8343)] = 374175,
  [SMALL_STATE(8344)] = 374219,
  [SMALL_STATE(8345)] = 374269,
  [SMALL_STATE(8346)] = 374319,
  [SMALL_STATE(8347)] = 374366,
  [SMALL_STATE(8348)] = 374411,
  [SMALL_STATE(8349)] = 374458,
  [SMALL_STATE(8350)] = 374503,
  [SMALL_STATE(8351)] = 374550,
  [SMALL_STATE(8352)] = 374597,
  [SMALL_STATE(8353)] = 374644,
  [SMALL_STATE(8354)] = 374691,
  [SMALL_STATE(8355)] = 374738,
  [SMALL_STATE(8356)] = 374781,
  [SMALL_STATE(8357)] = 374828,
  [SMALL_STATE(8358)] = 374875,
  [SMALL_STATE(8359)] = 374922,
  [SMALL_STATE(8360)] = 374969,
  [SMALL_STATE(8361)] = 375016,
  [SMALL_STATE(8362)] = 375063,
  [SMALL_STATE(8363)] = 375110,
  [SMALL_STATE(8364)] = 375157,
  [SMALL_STATE(8365)] = 375204,
  [SMALL_STATE(8366)] = 375251,
  [SMALL_STATE(8367)] = 375298,
  [SMALL_STATE(8368)] = 375341,
  [SMALL_STATE(8369)] = 375388,
  [SMALL_STATE(8370)] = 375435,
  [SMALL_STATE(8371)] = 375482,
  [SMALL_STATE(8372)] = 375529,
  [SMALL_STATE(8373)] = 375576,
  [SMALL_STATE(8374)] = 375621,
  [SMALL_STATE(8375)] = 375668,
  [SMALL_STATE(8376)] = 375715,
  [SMALL_STATE(8377)] = 375760,
  [SMALL_STATE(8378)] = 375807,
  [SMALL_STATE(8379)] = 375854,
  [SMALL_STATE(8380)] = 375901,
  [SMALL_STATE(8381)] = 375948,
  [SMALL_STATE(8382)] = 375995,
  [SMALL_STATE(8383)] = 376042,
  [SMALL_STATE(8384)] = 376089,
  [SMALL_STATE(8385)] = 376136,
  [SMALL_STATE(8386)] = 376183,
  [SMALL_STATE(8387)] = 376230,
  [SMALL_STATE(8388)] = 376277,
  [SMALL_STATE(8389)] = 376324,
  [SMALL_STATE(8390)] = 376371,
  [SMALL_STATE(8391)] = 376418,
  [SMALL_STATE(8392)] = 376465,
  [SMALL_STATE(8393)] = 376510,
  [SMALL_STATE(8394)] = 376557,
  [SMALL_STATE(8395)] = 376604,
  [SMALL_STATE(8396)] = 376651,
  [SMALL_STATE(8397)] = 376698,
  [SMALL_STATE(8398)] = 376745,
  [SMALL_STATE(8399)] = 376792,
  [SMALL_STATE(8400)] = 376839,
  [SMALL_STATE(8401)] = 376886,
  [SMALL_STATE(8402)] = 376933,
  [SMALL_STATE(8403)] = 376980,
  [SMALL_STATE(8404)] = 377027,
  [SMALL_STATE(8405)] = 377074,
  [SMALL_STATE(8406)] = 377121,
  [SMALL_STATE(8407)] = 377168,
  [SMALL_STATE(8408)] = 377215,
  [SMALL_STATE(8409)] = 377262,
  [SMALL_STATE(8410)] = 377309,
  [SMALL_STATE(8411)] = 377356,
  [SMALL_STATE(8412)] = 377399,
  [SMALL_STATE(8413)] = 377442,
  [SMALL_STATE(8414)] = 377489,
  [SMALL_STATE(8415)] = 377536,
  [SMALL_STATE(8416)] = 377583,
  [SMALL_STATE(8417)] = 377626,
  [SMALL_STATE(8418)] = 377673,
  [SMALL_STATE(8419)] = 377716,
  [SMALL_STATE(8420)] = 377763,
  [SMALL_STATE(8421)] = 377810,
  [SMALL_STATE(8422)] = 377857,
  [SMALL_STATE(8423)] = 377904,
  [SMALL_STATE(8424)] = 377951,
  [SMALL_STATE(8425)] = 377994,
  [SMALL_STATE(8426)] = 378041,
  [SMALL_STATE(8427)] = 378088,
  [SMALL_STATE(8428)] = 378135,
  [SMALL_STATE(8429)] = 378182,
  [SMALL_STATE(8430)] = 378229,
  [SMALL_STATE(8431)] = 378276,
  [SMALL_STATE(8432)] = 378323,
  [SMALL_STATE(8433)] = 378370,
  [SMALL_STATE(8434)] = 378417,
  [SMALL_STATE(8435)] = 378462,
  [SMALL_STATE(8436)] = 378509,
  [SMALL_STATE(8437)] = 378556,
  [SMALL_STATE(8438)] = 378601,
  [SMALL_STATE(8439)] = 378646,
  [SMALL_STATE(8440)] = 378693,
  [SMALL_STATE(8441)] = 378736,
  [SMALL_STATE(8442)] = 378783,
  [SMALL_STATE(8443)] = 378830,
  [SMALL_STATE(8444)] = 378875,
  [SMALL_STATE(8445)] = 378922,
  [SMALL_STATE(8446)] = 378969,
  [SMALL_STATE(8447)] = 379016,
  [SMALL_STATE(8448)] = 379063,
  [SMALL_STATE(8449)] = 379106,
  [SMALL_STATE(8450)] = 379153,
  [SMALL_STATE(8451)] = 379200,
  [SMALL_STATE(8452)] = 379247,
  [SMALL_STATE(8453)] = 379294,
  [SMALL_STATE(8454)] = 379341,
  [SMALL_STATE(8455)] = 379388,
  [SMALL_STATE(8456)] = 379435,
  [SMALL_STATE(8457)] = 379482,
  [SMALL_STATE(8458)] = 379529,
  [SMALL_STATE(8459)] = 379576,
  [SMALL_STATE(8460)] = 379623,
  [SMALL_STATE(8461)] = 379670,
  [SMALL_STATE(8462)] = 379717,
  [SMALL_STATE(8463)] = 379764,
  [SMALL_STATE(8464)] = 379811,
  [SMALL_STATE(8465)] = 379858,
  [SMALL_STATE(8466)] = 379905,
  [SMALL_STATE(8467)] = 379948,
  [SMALL_STATE(8468)] = 379995,
  [SMALL_STATE(8469)] = 380042,
  [SMALL_STATE(8470)] = 380089,
  [SMALL_STATE(8471)] = 380136,
  [SMALL_STATE(8472)] = 380183,
  [SMALL_STATE(8473)] = 380230,
  [SMALL_STATE(8474)] = 380277,
  [SMALL_STATE(8475)] = 380324,
  [SMALL_STATE(8476)] = 380371,
  [SMALL_STATE(8477)] = 380418,
  [SMALL_STATE(8478)] = 380465,
  [SMALL_STATE(8479)] = 380510,
  [SMALL_STATE(8480)] = 380557,
  [SMALL_STATE(8481)] = 380604,
  [SMALL_STATE(8482)] = 380651,
  [SMALL_STATE(8483)] = 380696,
  [SMALL_STATE(8484)] = 380743,
  [SMALL_STATE(8485)] = 380790,
  [SMALL_STATE(8486)] = 380837,
  [SMALL_STATE(8487)] = 380884,
  [SMALL_STATE(8488)] = 380931,
  [SMALL_STATE(8489)] = 380978,
  [SMALL_STATE(8490)] = 381025,
  [SMALL_STATE(8491)] = 381072,
  [SMALL_STATE(8492)] = 381119,
  [SMALL_STATE(8493)] = 381166,
  [SMALL_STATE(8494)] = 381213,
  [SMALL_STATE(8495)] = 381260,
  [SMALL_STATE(8496)] = 381307,
  [SMALL_STATE(8497)] = 381350,
  [SMALL_STATE(8498)] = 381395,
  [SMALL_STATE(8499)] = 381442,
  [SMALL_STATE(8500)] = 381489,
  [SMALL_STATE(8501)] = 381536,
  [SMALL_STATE(8502)] = 381583,
  [SMALL_STATE(8503)] = 381628,
  [SMALL_STATE(8504)] = 381671,
  [SMALL_STATE(8505)] = 381718,
  [SMALL_STATE(8506)] = 381765,
  [SMALL_STATE(8507)] = 381810,
  [SMALL_STATE(8508)] = 381857,
  [SMALL_STATE(8509)] = 381904,
  [SMALL_STATE(8510)] = 381951,
  [SMALL_STATE(8511)] = 381998,
  [SMALL_STATE(8512)] = 382045,
  [SMALL_STATE(8513)] = 382092,
  [SMALL_STATE(8514)] = 382139,
  [SMALL_STATE(8515)] = 382186,
  [SMALL_STATE(8516)] = 382229,
  [SMALL_STATE(8517)] = 382276,
  [SMALL_STATE(8518)] = 382323,
  [SMALL_STATE(8519)] = 382370,
  [SMALL_STATE(8520)] = 382417,
  [SMALL_STATE(8521)] = 382464,
  [SMALL_STATE(8522)] = 382511,
  [SMALL_STATE(8523)] = 382558,
  [SMALL_STATE(8524)] = 382605,
  [SMALL_STATE(8525)] = 382652,
  [SMALL_STATE(8526)] = 382699,
  [SMALL_STATE(8527)] = 382746,
  [SMALL_STATE(8528)] = 382793,
  [SMALL_STATE(8529)] = 382840,
  [SMALL_STATE(8530)] = 382885,
  [SMALL_STATE(8531)] = 382932,
  [SMALL_STATE(8532)] = 382977,
  [SMALL_STATE(8533)] = 383020,
  [SMALL_STATE(8534)] = 383067,
  [SMALL_STATE(8535)] = 383112,
  [SMALL_STATE(8536)] = 383159,
  [SMALL_STATE(8537)] = 383206,
  [SMALL_STATE(8538)] = 383251,
  [SMALL_STATE(8539)] = 383298,
  [SMALL_STATE(8540)] = 383345,
  [SMALL_STATE(8541)] = 383390,
  [SMALL_STATE(8542)] = 383435,
  [SMALL_STATE(8543)] = 383482,
  [SMALL_STATE(8544)] = 383529,
  [SMALL_STATE(8545)] = 383576,
  [SMALL_STATE(8546)] = 383621,
  [SMALL_STATE(8547)] = 383668,
  [SMALL_STATE(8548)] = 383715,
  [SMALL_STATE(8549)] = 383762,
  [SMALL_STATE(8550)] = 383809,
  [SMALL_STATE(8551)] = 383856,
  [SMALL_STATE(8552)] = 383899,
  [SMALL_STATE(8553)] = 383946,
  [SMALL_STATE(8554)] = 383993,
  [SMALL_STATE(8555)] = 384040,
  [SMALL_STATE(8556)] = 384087,
  [SMALL_STATE(8557)] = 384134,
  [SMALL_STATE(8558)] = 384181,
  [SMALL_STATE(8559)] = 384228,
  [SMALL_STATE(8560)] = 384271,
  [SMALL_STATE(8561)] = 384318,
  [SMALL_STATE(8562)] = 384365,
  [SMALL_STATE(8563)] = 384412,
  [SMALL_STATE(8564)] = 384459,
  [SMALL_STATE(8565)] = 384506,
  [SMALL_STATE(8566)] = 384553,
  [SMALL_STATE(8567)] = 384600,
  [SMALL_STATE(8568)] = 384645,
  [SMALL_STATE(8569)] = 384692,
  [SMALL_STATE(8570)] = 384739,
  [SMALL_STATE(8571)] = 384786,
  [SMALL_STATE(8572)] = 384833,
  [SMALL_STATE(8573)] = 384880,
  [SMALL_STATE(8574)] = 384927,
  [SMALL_STATE(8575)] = 384974,
  [SMALL_STATE(8576)] = 385021,
  [SMALL_STATE(8577)] = 385068,
  [SMALL_STATE(8578)] = 385115,
  [SMALL_STATE(8579)] = 385162,
  [SMALL_STATE(8580)] = 385209,
  [SMALL_STATE(8581)] = 385254,
  [SMALL_STATE(8582)] = 385301,
  [SMALL_STATE(8583)] = 385346,
  [SMALL_STATE(8584)] = 385393,
  [SMALL_STATE(8585)] = 385440,
  [SMALL_STATE(8586)] = 385487,
  [SMALL_STATE(8587)] = 385534,
  [SMALL_STATE(8588)] = 385581,
  [SMALL_STATE(8589)] = 385628,
  [SMALL_STATE(8590)] = 385675,
  [SMALL_STATE(8591)] = 385722,
  [SMALL_STATE(8592)] = 385769,
  [SMALL_STATE(8593)] = 385816,
  [SMALL_STATE(8594)] = 385863,
  [SMALL_STATE(8595)] = 385910,
  [SMALL_STATE(8596)] = 385957,
  [SMALL_STATE(8597)] = 386004,
  [SMALL_STATE(8598)] = 386051,
  [SMALL_STATE(8599)] = 386098,
  [SMALL_STATE(8600)] = 386145,
  [SMALL_STATE(8601)] = 386192,
  [SMALL_STATE(8602)] = 386239,
  [SMALL_STATE(8603)] = 386286,
  [SMALL_STATE(8604)] = 386333,
  [SMALL_STATE(8605)] = 386380,
  [SMALL_STATE(8606)] = 386427,
  [SMALL_STATE(8607)] = 386474,
  [SMALL_STATE(8608)] = 386521,
  [SMALL_STATE(8609)] = 386568,
  [SMALL_STATE(8610)] = 386615,
  [SMALL_STATE(8611)] = 386662,
  [SMALL_STATE(8612)] = 386707,
  [SMALL_STATE(8613)] = 386750,
  [SMALL_STATE(8614)] = 386793,
  [SMALL_STATE(8615)] = 386836,
  [SMALL_STATE(8616)] = 386879,
  [SMALL_STATE(8617)] = 386926,
  [SMALL_STATE(8618)] = 386973,
  [SMALL_STATE(8619)] = 387020,
  [SMALL_STATE(8620)] = 387067,
  [SMALL_STATE(8621)] = 387114,
  [SMALL_STATE(8622)] = 387161,
  [SMALL_STATE(8623)] = 387208,
  [SMALL_STATE(8624)] = 387255,
  [SMALL_STATE(8625)] = 387302,
  [SMALL_STATE(8626)] = 387347,
  [SMALL_STATE(8627)] = 387394,
  [SMALL_STATE(8628)] = 387437,
  [SMALL_STATE(8629)] = 387484,
  [SMALL_STATE(8630)] = 387531,
  [SMALL_STATE(8631)] = 387576,
  [SMALL_STATE(8632)] = 387623,
  [SMALL_STATE(8633)] = 387670,
  [SMALL_STATE(8634)] = 387717,
  [SMALL_STATE(8635)] = 387764,
  [SMALL_STATE(8636)] = 387811,
  [SMALL_STATE(8637)] = 387858,
  [SMALL_STATE(8638)] = 387905,
  [SMALL_STATE(8639)] = 387952,
  [SMALL_STATE(8640)] = 387999,
  [SMALL_STATE(8641)] = 388044,
  [SMALL_STATE(8642)] = 388091,
  [SMALL_STATE(8643)] = 388138,
  [SMALL_STATE(8644)] = 388185,
  [SMALL_STATE(8645)] = 388232,
  [SMALL_STATE(8646)] = 388279,
  [SMALL_STATE(8647)] = 388326,
  [SMALL_STATE(8648)] = 388373,
  [SMALL_STATE(8649)] = 388420,
  [SMALL_STATE(8650)] = 388465,
  [SMALL_STATE(8651)] = 388512,
  [SMALL_STATE(8652)] = 388559,
  [SMALL_STATE(8653)] = 388604,
  [SMALL_STATE(8654)] = 388649,
  [SMALL_STATE(8655)] = 388696,
  [SMALL_STATE(8656)] = 388743,
  [SMALL_STATE(8657)] = 388788,
  [SMALL_STATE(8658)] = 388835,
  [SMALL_STATE(8659)] = 388882,
  [SMALL_STATE(8660)] = 388929,
  [SMALL_STATE(8661)] = 388976,
  [SMALL_STATE(8662)] = 389023,
  [SMALL_STATE(8663)] = 389066,
  [SMALL_STATE(8664)] = 389113,
  [SMALL_STATE(8665)] = 389160,
  [SMALL_STATE(8666)] = 389205,
  [SMALL_STATE(8667)] = 389252,
  [SMALL_STATE(8668)] = 389299,
  [SMALL_STATE(8669)] = 389343,
  [SMALL_STATE(8670)] = 389387,
  [SMALL_STATE(8671)] = 389431,
  [SMALL_STATE(8672)] = 389475,
  [SMALL_STATE(8673)] = 389519,
  [SMALL_STATE(8674)] = 389563,
  [SMALL_STATE(8675)] = 389607,
  [SMALL_STATE(8676)] = 389651,
  [SMALL_STATE(8677)] = 389695,
  [SMALL_STATE(8678)] = 389739,
  [SMALL_STATE(8679)] = 389783,
  [SMALL_STATE(8680)] = 389827,
  [SMALL_STATE(8681)] = 389871,
  [SMALL_STATE(8682)] = 389915,
  [SMALL_STATE(8683)] = 389959,
  [SMALL_STATE(8684)] = 390003,
  [SMALL_STATE(8685)] = 390047,
  [SMALL_STATE(8686)] = 390091,
  [SMALL_STATE(8687)] = 390135,
  [SMALL_STATE(8688)] = 390179,
  [SMALL_STATE(8689)] = 390223,
  [SMALL_STATE(8690)] = 390267,
  [SMALL_STATE(8691)] = 390311,
  [SMALL_STATE(8692)] = 390353,
  [SMALL_STATE(8693)] = 390395,
  [SMALL_STATE(8694)] = 390439,
  [SMALL_STATE(8695)] = 390483,
  [SMALL_STATE(8696)] = 390527,
  [SMALL_STATE(8697)] = 390569,
  [SMALL_STATE(8698)] = 390613,
  [SMALL_STATE(8699)] = 390655,
  [SMALL_STATE(8700)] = 390699,
  [SMALL_STATE(8701)] = 390741,
  [SMALL_STATE(8702)] = 390783,
  [SMALL_STATE(8703)] = 390825,
  [SMALL_STATE(8704)] = 390869,
  [SMALL_STATE(8705)] = 390911,
  [SMALL_STATE(8706)] = 390953,
  [SMALL_STATE(8707)] = 390997,
  [SMALL_STATE(8708)] = 391041,
  [SMALL_STATE(8709)] = 391083,
  [SMALL_STATE(8710)] = 391125,
  [SMALL_STATE(8711)] = 391169,
  [SMALL_STATE(8712)] = 391211,
  [SMALL_STATE(8713)] = 391255,
  [SMALL_STATE(8714)] = 391297,
  [SMALL_STATE(8715)] = 391339,
  [SMALL_STATE(8716)] = 391381,
  [SMALL_STATE(8717)] = 391423,
  [SMALL_STATE(8718)] = 391465,
  [SMALL_STATE(8719)] = 391509,
  [SMALL_STATE(8720)] = 391551,
  [SMALL_STATE(8721)] = 391593,
  [SMALL_STATE(8722)] = 391635,
  [SMALL_STATE(8723)] = 391677,
  [SMALL_STATE(8724)] = 391719,
  [SMALL_STATE(8725)] = 391763,
  [SMALL_STATE(8726)] = 391805,
  [SMALL_STATE(8727)] = 391847,
  [SMALL_STATE(8728)] = 391891,
  [SMALL_STATE(8729)] = 391933,
  [SMALL_STATE(8730)] = 391975,
  [SMALL_STATE(8731)] = 392017,
  [SMALL_STATE(8732)] = 392059,
  [SMALL_STATE(8733)] = 392101,
  [SMALL_STATE(8734)] = 392143,
  [SMALL_STATE(8735)] = 392185,
  [SMALL_STATE(8736)] = 392227,
  [SMALL_STATE(8737)] = 392269,
  [SMALL_STATE(8738)] = 392311,
  [SMALL_STATE(8739)] = 392353,
  [SMALL_STATE(8740)] = 392395,
  [SMALL_STATE(8741)] = 392437,
  [SMALL_STATE(8742)] = 392479,
  [SMALL_STATE(8743)] = 392521,
  [SMALL_STATE(8744)] = 392563,
  [SMALL_STATE(8745)] = 392605,
  [SMALL_STATE(8746)] = 392649,
  [SMALL_STATE(8747)] = 392693,
  [SMALL_STATE(8748)] = 392735,
  [SMALL_STATE(8749)] = 392777,
  [SMALL_STATE(8750)] = 392819,
  [SMALL_STATE(8751)] = 392861,
  [SMALL_STATE(8752)] = 392903,
  [SMALL_STATE(8753)] = 392945,
  [SMALL_STATE(8754)] = 392987,
  [SMALL_STATE(8755)] = 393029,
  [SMALL_STATE(8756)] = 393073,
  [SMALL_STATE(8757)] = 393117,
  [SMALL_STATE(8758)] = 393159,
  [SMALL_STATE(8759)] = 393201,
  [SMALL_STATE(8760)] = 393245,
  [SMALL_STATE(8761)] = 393289,
  [SMALL_STATE(8762)] = 393333,
  [SMALL_STATE(8763)] = 393377,
  [SMALL_STATE(8764)] = 393421,
  [SMALL_STATE(8765)] = 393465,
  [SMALL_STATE(8766)] = 393507,
  [SMALL_STATE(8767)] = 393551,
  [SMALL_STATE(8768)] = 393593,
  [SMALL_STATE(8769)] = 393637,
  [SMALL_STATE(8770)] = 393679,
  [SMALL_STATE(8771)] = 393721,
  [SMALL_STATE(8772)] = 393765,
  [SMALL_STATE(8773)] = 393807,
  [SMALL_STATE(8774)] = 393849,
  [SMALL_STATE(8775)] = 393893,
  [SMALL_STATE(8776)] = 393937,
  [SMALL_STATE(8777)] = 393979,
  [SMALL_STATE(8778)] = 394021,
  [SMALL_STATE(8779)] = 394065,
  [SMALL_STATE(8780)] = 394109,
  [SMALL_STATE(8781)] = 394151,
  [SMALL_STATE(8782)] = 394193,
  [SMALL_STATE(8783)] = 394235,
  [SMALL_STATE(8784)] = 394277,
  [SMALL_STATE(8785)] = 394319,
  [SMALL_STATE(8786)] = 394363,
  [SMALL_STATE(8787)] = 394407,
  [SMALL_STATE(8788)] = 394449,
  [SMALL_STATE(8789)] = 394493,
  [SMALL_STATE(8790)] = 394537,
  [SMALL_STATE(8791)] = 394581,
  [SMALL_STATE(8792)] = 394625,
  [SMALL_STATE(8793)] = 394667,
  [SMALL_STATE(8794)] = 394711,
  [SMALL_STATE(8795)] = 394755,
  [SMALL_STATE(8796)] = 394797,
  [SMALL_STATE(8797)] = 394839,
  [SMALL_STATE(8798)] = 394883,
  [SMALL_STATE(8799)] = 394927,
  [SMALL_STATE(8800)] = 394971,
  [SMALL_STATE(8801)] = 395015,
  [SMALL_STATE(8802)] = 395059,
  [SMALL_STATE(8803)] = 395103,
  [SMALL_STATE(8804)] = 395147,
  [SMALL_STATE(8805)] = 395189,
  [SMALL_STATE(8806)] = 395231,
  [SMALL_STATE(8807)] = 395273,
  [SMALL_STATE(8808)] = 395317,
  [SMALL_STATE(8809)] = 395361,
  [SMALL_STATE(8810)] = 395403,
  [SMALL_STATE(8811)] = 395447,
  [SMALL_STATE(8812)] = 395489,
  [SMALL_STATE(8813)] = 395531,
  [SMALL_STATE(8814)] = 395573,
  [SMALL_STATE(8815)] = 395617,
  [SMALL_STATE(8816)] = 395659,
  [SMALL_STATE(8817)] = 395701,
  [SMALL_STATE(8818)] = 395743,
  [SMALL_STATE(8819)] = 395787,
  [SMALL_STATE(8820)] = 395829,
  [SMALL_STATE(8821)] = 395873,
  [SMALL_STATE(8822)] = 395915,
  [SMALL_STATE(8823)] = 395959,
  [SMALL_STATE(8824)] = 396003,
  [SMALL_STATE(8825)] = 396047,
  [SMALL_STATE(8826)] = 396089,
  [SMALL_STATE(8827)] = 396131,
  [SMALL_STATE(8828)] = 396175,
  [SMALL_STATE(8829)] = 396219,
  [SMALL_STATE(8830)] = 396261,
  [SMALL_STATE(8831)] = 396305,
  [SMALL_STATE(8832)] = 396349,
  [SMALL_STATE(8833)] = 396393,
  [SMALL_STATE(8834)] = 396437,
  [SMALL_STATE(8835)] = 396479,
  [SMALL_STATE(8836)] = 396521,
  [SMALL_STATE(8837)] = 396565,
  [SMALL_STATE(8838)] = 396609,
  [SMALL_STATE(8839)] = 396651,
  [SMALL_STATE(8840)] = 396693,
  [SMALL_STATE(8841)] = 396735,
  [SMALL_STATE(8842)] = 396779,
  [SMALL_STATE(8843)] = 396821,
  [SMALL_STATE(8844)] = 396865,
  [SMALL_STATE(8845)] = 396907,
  [SMALL_STATE(8846)] = 396951,
  [SMALL_STATE(8847)] = 396995,
  [SMALL_STATE(8848)] = 397037,
  [SMALL_STATE(8849)] = 397079,
  [SMALL_STATE(8850)] = 397123,
  [SMALL_STATE(8851)] = 397167,
  [SMALL_STATE(8852)] = 397209,
  [SMALL_STATE(8853)] = 397253,
  [SMALL_STATE(8854)] = 397297,
  [SMALL_STATE(8855)] = 397339,
  [SMALL_STATE(8856)] = 397383,
  [SMALL_STATE(8857)] = 397427,
  [SMALL_STATE(8858)] = 397469,
  [SMALL_STATE(8859)] = 397513,
  [SMALL_STATE(8860)] = 397557,
  [SMALL_STATE(8861)] = 397601,
  [SMALL_STATE(8862)] = 397643,
  [SMALL_STATE(8863)] = 397687,
  [SMALL_STATE(8864)] = 397729,
  [SMALL_STATE(8865)] = 397773,
  [SMALL_STATE(8866)] = 397817,
  [SMALL_STATE(8867)] = 397859,
  [SMALL_STATE(8868)] = 397901,
  [SMALL_STATE(8869)] = 397945,
  [SMALL_STATE(8870)] = 397989,
  [SMALL_STATE(8871)] = 398033,
  [SMALL_STATE(8872)] = 398075,
  [SMALL_STATE(8873)] = 398117,
  [SMALL_STATE(8874)] = 398161,
  [SMALL_STATE(8875)] = 398203,
  [SMALL_STATE(8876)] = 398245,
  [SMALL_STATE(8877)] = 398287,
  [SMALL_STATE(8878)] = 398331,
  [SMALL_STATE(8879)] = 398375,
  [SMALL_STATE(8880)] = 398419,
  [SMALL_STATE(8881)] = 398463,
  [SMALL_STATE(8882)] = 398505,
  [SMALL_STATE(8883)] = 398549,
  [SMALL_STATE(8884)] = 398593,
  [SMALL_STATE(8885)] = 398635,
  [SMALL_STATE(8886)] = 398679,
  [SMALL_STATE(8887)] = 398723,
  [SMALL_STATE(8888)] = 398767,
  [SMALL_STATE(8889)] = 398811,
  [SMALL_STATE(8890)] = 398855,
  [SMALL_STATE(8891)] = 398899,
  [SMALL_STATE(8892)] = 398941,
  [SMALL_STATE(8893)] = 398983,
  [SMALL_STATE(8894)] = 399025,
  [SMALL_STATE(8895)] = 399069,
  [SMALL_STATE(8896)] = 399113,
  [SMALL_STATE(8897)] = 399157,
  [SMALL_STATE(8898)] = 399201,
  [SMALL_STATE(8899)] = 399245,
  [SMALL_STATE(8900)] = 399287,
  [SMALL_STATE(8901)] = 399331,
  [SMALL_STATE(8902)] = 399375,
  [SMALL_STATE(8903)] = 399419,
  [SMALL_STATE(8904)] = 399463,
  [SMALL_STATE(8905)] = 399507,
  [SMALL_STATE(8906)] = 399551,
  [SMALL_STATE(8907)] = 399595,
  [SMALL_STATE(8908)] = 399639,
  [SMALL_STATE(8909)] = 399681,
  [SMALL_STATE(8910)] = 399725,
  [SMALL_STATE(8911)] = 399769,
  [SMALL_STATE(8912)] = 399811,
  [SMALL_STATE(8913)] = 399855,
  [SMALL_STATE(8914)] = 399899,
  [SMALL_STATE(8915)] = 399941,
  [SMALL_STATE(8916)] = 399985,
  [SMALL_STATE(8917)] = 400029,
  [SMALL_STATE(8918)] = 400071,
  [SMALL_STATE(8919)] = 400113,
  [SMALL_STATE(8920)] = 400157,
  [SMALL_STATE(8921)] = 400201,
  [SMALL_STATE(8922)] = 400245,
  [SMALL_STATE(8923)] = 400289,
  [SMALL_STATE(8924)] = 400333,
  [SMALL_STATE(8925)] = 400377,
  [SMALL_STATE(8926)] = 400421,
  [SMALL_STATE(8927)] = 400465,
  [SMALL_STATE(8928)] = 400509,
  [SMALL_STATE(8929)] = 400553,
  [SMALL_STATE(8930)] = 400597,
  [SMALL_STATE(8931)] = 400641,
  [SMALL_STATE(8932)] = 400685,
  [SMALL_STATE(8933)] = 400729,
  [SMALL_STATE(8934)] = 400773,
  [SMALL_STATE(8935)] = 400817,
  [SMALL_STATE(8936)] = 400861,
  [SMALL_STATE(8937)] = 400905,
  [SMALL_STATE(8938)] = 400949,
  [SMALL_STATE(8939)] = 400993,
  [SMALL_STATE(8940)] = 401037,
  [SMALL_STATE(8941)] = 401081,
  [SMALL_STATE(8942)] = 401125,
  [SMALL_STATE(8943)] = 401169,
  [SMALL_STATE(8944)] = 401213,
  [SMALL_STATE(8945)] = 401257,
  [SMALL_STATE(8946)] = 401301,
  [SMALL_STATE(8947)] = 401345,
  [SMALL_STATE(8948)] = 401389,
  [SMALL_STATE(8949)] = 401433,
  [SMALL_STATE(8950)] = 401477,
  [SMALL_STATE(8951)] = 401519,
  [SMALL_STATE(8952)] = 401563,
  [SMALL_STATE(8953)] = 401607,
  [SMALL_STATE(8954)] = 401651,
  [SMALL_STATE(8955)] = 401695,
  [SMALL_STATE(8956)] = 401739,
  [SMALL_STATE(8957)] = 401783,
  [SMALL_STATE(8958)] = 401827,
  [SMALL_STATE(8959)] = 401868,
  [SMALL_STATE(8960)] = 401909,
  [SMALL_STATE(8961)] = 401950,
  [SMALL_STATE(8962)] = 401991,
  [SMALL_STATE(8963)] = 402032,
  [SMALL_STATE(8964)] = 402073,
  [SMALL_STATE(8965)] = 402114,
  [SMALL_STATE(8966)] = 402155,
  [SMALL_STATE(8967)] = 402196,
  [SMALL_STATE(8968)] = 402237,
  [SMALL_STATE(8969)] = 402278,
  [SMALL_STATE(8970)] = 402319,
  [SMALL_STATE(8971)] = 402360,
  [SMALL_STATE(8972)] = 402401,
  [SMALL_STATE(8973)] = 402442,
  [SMALL_STATE(8974)] = 402483,
  [SMALL_STATE(8975)] = 402524,
  [SMALL_STATE(8976)] = 402565,
  [SMALL_STATE(8977)] = 402606,
  [SMALL_STATE(8978)] = 402647,
  [SMALL_STATE(8979)] = 402688,
  [SMALL_STATE(8980)] = 402729,
  [SMALL_STATE(8981)] = 402770,
  [SMALL_STATE(8982)] = 402811,
  [SMALL_STATE(8983)] = 402852,
  [SMALL_STATE(8984)] = 402893,
  [SMALL_STATE(8985)] = 402934,
  [SMALL_STATE(8986)] = 402975,
  [SMALL_STATE(8987)] = 403016,
  [SMALL_STATE(8988)] = 403057,
  [SMALL_STATE(8989)] = 403098,
  [SMALL_STATE(8990)] = 403139,
  [SMALL_STATE(8991)] = 403180,
  [SMALL_STATE(8992)] = 403221,
  [SMALL_STATE(8993)] = 403262,
  [SMALL_STATE(8994)] = 403303,
  [SMALL_STATE(8995)] = 403344,
  [SMALL_STATE(8996)] = 403385,
  [SMALL_STATE(8997)] = 403426,
  [SMALL_STATE(8998)] = 403467,
  [SMALL_STATE(8999)] = 403508,
  [SMALL_STATE(9000)] = 403549,
  [SMALL_STATE(9001)] = 403590,
  [SMALL_STATE(9002)] = 403631,
  [SMALL_STATE(9003)] = 403672,
  [SMALL_STATE(9004)] = 403713,
  [SMALL_STATE(9005)] = 403754,
  [SMALL_STATE(9006)] = 403795,
  [SMALL_STATE(9007)] = 403836,
  [SMALL_STATE(9008)] = 403877,
  [SMALL_STATE(9009)] = 403918,
  [SMALL_STATE(9010)] = 403959,
  [SMALL_STATE(9011)] = 404000,
  [SMALL_STATE(9012)] = 404041,
  [SMALL_STATE(9013)] = 404082,
  [SMALL_STATE(9014)] = 404123,
  [SMALL_STATE(9015)] = 404164,
  [SMALL_STATE(9016)] = 404205,
  [SMALL_STATE(9017)] = 404246,
  [SMALL_STATE(9018)] = 404287,
  [SMALL_STATE(9019)] = 404328,
  [SMALL_STATE(9020)] = 404369,
  [SMALL_STATE(9021)] = 404410,
  [SMALL_STATE(9022)] = 404451,
  [SMALL_STATE(9023)] = 404492,
  [SMALL_STATE(9024)] = 404533,
  [SMALL_STATE(9025)] = 404574,
  [SMALL_STATE(9026)] = 404615,
  [SMALL_STATE(9027)] = 404656,
  [SMALL_STATE(9028)] = 404697,
  [SMALL_STATE(9029)] = 404738,
  [SMALL_STATE(9030)] = 404779,
  [SMALL_STATE(9031)] = 404820,
  [SMALL_STATE(9032)] = 404861,
  [SMALL_STATE(9033)] = 404902,
  [SMALL_STATE(9034)] = 404943,
  [SMALL_STATE(9035)] = 404984,
  [SMALL_STATE(9036)] = 405025,
  [SMALL_STATE(9037)] = 405066,
  [SMALL_STATE(9038)] = 405107,
  [SMALL_STATE(9039)] = 405148,
  [SMALL_STATE(9040)] = 405189,
  [SMALL_STATE(9041)] = 405230,
  [SMALL_STATE(9042)] = 405271,
  [SMALL_STATE(9043)] = 405312,
  [SMALL_STATE(9044)] = 405353,
  [SMALL_STATE(9045)] = 405394,
  [SMALL_STATE(9046)] = 405435,
  [SMALL_STATE(9047)] = 405476,
  [SMALL_STATE(9048)] = 405517,
  [SMALL_STATE(9049)] = 405558,
  [SMALL_STATE(9050)] = 405599,
  [SMALL_STATE(9051)] = 405640,
  [SMALL_STATE(9052)] = 405681,
  [SMALL_STATE(9053)] = 405722,
  [SMALL_STATE(9054)] = 405763,
  [SMALL_STATE(9055)] = 405804,
  [SMALL_STATE(9056)] = 405845,
  [SMALL_STATE(9057)] = 405886,
  [SMALL_STATE(9058)] = 405927,
  [SMALL_STATE(9059)] = 405968,
  [SMALL_STATE(9060)] = 406009,
  [SMALL_STATE(9061)] = 406050,
  [SMALL_STATE(9062)] = 406091,
  [SMALL_STATE(9063)] = 406132,
  [SMALL_STATE(9064)] = 406173,
  [SMALL_STATE(9065)] = 406214,
  [SMALL_STATE(9066)] = 406255,
  [SMALL_STATE(9067)] = 406296,
  [SMALL_STATE(9068)] = 406337,
  [SMALL_STATE(9069)] = 406378,
  [SMALL_STATE(9070)] = 406419,
  [SMALL_STATE(9071)] = 406460,
  [SMALL_STATE(9072)] = 406501,
  [SMALL_STATE(9073)] = 406542,
  [SMALL_STATE(9074)] = 406583,
  [SMALL_STATE(9075)] = 406624,
  [SMALL_STATE(9076)] = 406665,
  [SMALL_STATE(9077)] = 406706,
  [SMALL_STATE(9078)] = 406747,
  [SMALL_STATE(9079)] = 406788,
  [SMALL_STATE(9080)] = 406829,
  [SMALL_STATE(9081)] = 406870,
  [SMALL_STATE(9082)] = 406911,
  [SMALL_STATE(9083)] = 406952,
  [SMALL_STATE(9084)] = 406993,
  [SMALL_STATE(9085)] = 407034,
  [SMALL_STATE(9086)] = 407075,
  [SMALL_STATE(9087)] = 407116,
  [SMALL_STATE(9088)] = 407157,
  [SMALL_STATE(9089)] = 407198,
  [SMALL_STATE(9090)] = 407239,
  [SMALL_STATE(9091)] = 407280,
  [SMALL_STATE(9092)] = 407321,
  [SMALL_STATE(9093)] = 407362,
  [SMALL_STATE(9094)] = 407403,
  [SMALL_STATE(9095)] = 407444,
  [SMALL_STATE(9096)] = 407485,
  [SMALL_STATE(9097)] = 407526,
  [SMALL_STATE(9098)] = 407567,
  [SMALL_STATE(9099)] = 407608,
  [SMALL_STATE(9100)] = 407649,
  [SMALL_STATE(9101)] = 407690,
  [SMALL_STATE(9102)] = 407731,
  [SMALL_STATE(9103)] = 407772,
  [SMALL_STATE(9104)] = 407813,
  [SMALL_STATE(9105)] = 407854,
  [SMALL_STATE(9106)] = 407895,
  [SMALL_STATE(9107)] = 407936,
  [SMALL_STATE(9108)] = 407977,
  [SMALL_STATE(9109)] = 408018,
  [SMALL_STATE(9110)] = 408059,
  [SMALL_STATE(9111)] = 408100,
  [SMALL_STATE(9112)] = 408141,
  [SMALL_STATE(9113)] = 408182,
  [SMALL_STATE(9114)] = 408223,
  [SMALL_STATE(9115)] = 408264,
  [SMALL_STATE(9116)] = 408305,
  [SMALL_STATE(9117)] = 408346,
  [SMALL_STATE(9118)] = 408387,
  [SMALL_STATE(9119)] = 408428,
  [SMALL_STATE(9120)] = 408469,
  [SMALL_STATE(9121)] = 408510,
  [SMALL_STATE(9122)] = 408551,
  [SMALL_STATE(9123)] = 408592,
  [SMALL_STATE(9124)] = 408633,
  [SMALL_STATE(9125)] = 408674,
  [SMALL_STATE(9126)] = 408715,
  [SMALL_STATE(9127)] = 408756,
  [SMALL_STATE(9128)] = 408797,
  [SMALL_STATE(9129)] = 408838,
  [SMALL_STATE(9130)] = 408879,
  [SMALL_STATE(9131)] = 408920,
  [SMALL_STATE(9132)] = 408961,
  [SMALL_STATE(9133)] = 409002,
  [SMALL_STATE(9134)] = 409043,
  [SMALL_STATE(9135)] = 409084,
  [SMALL_STATE(9136)] = 409125,
  [SMALL_STATE(9137)] = 409166,
  [SMALL_STATE(9138)] = 409207,
  [SMALL_STATE(9139)] = 409248,
  [SMALL_STATE(9140)] = 409289,
  [SMALL_STATE(9141)] = 409330,
  [SMALL_STATE(9142)] = 409371,
  [SMALL_STATE(9143)] = 409412,
  [SMALL_STATE(9144)] = 409453,
  [SMALL_STATE(9145)] = 409494,
  [SMALL_STATE(9146)] = 409535,
  [SMALL_STATE(9147)] = 409576,
  [SMALL_STATE(9148)] = 409617,
  [SMALL_STATE(9149)] = 409658,
  [SMALL_STATE(9150)] = 409699,
  [SMALL_STATE(9151)] = 409740,
  [SMALL_STATE(9152)] = 409781,
  [SMALL_STATE(9153)] = 409822,
  [SMALL_STATE(9154)] = 409863,
  [SMALL_STATE(9155)] = 409904,
  [SMALL_STATE(9156)] = 409945,
  [SMALL_STATE(9157)] = 409986,
  [SMALL_STATE(9158)] = 410027,
  [SMALL_STATE(9159)] = 410068,
  [SMALL_STATE(9160)] = 410109,
  [SMALL_STATE(9161)] = 410150,
  [SMALL_STATE(9162)] = 410191,
  [SMALL_STATE(9163)] = 410232,
  [SMALL_STATE(9164)] = 410273,
  [SMALL_STATE(9165)] = 410314,
  [SMALL_STATE(9166)] = 410355,
  [SMALL_STATE(9167)] = 410396,
  [SMALL_STATE(9168)] = 410437,
  [SMALL_STATE(9169)] = 410478,
  [SMALL_STATE(9170)] = 410519,
  [SMALL_STATE(9171)] = 410560,
  [SMALL_STATE(9172)] = 410601,
  [SMALL_STATE(9173)] = 410642,
  [SMALL_STATE(9174)] = 410683,
  [SMALL_STATE(9175)] = 410724,
  [SMALL_STATE(9176)] = 410765,
  [SMALL_STATE(9177)] = 410806,
  [SMALL_STATE(9178)] = 410847,
  [SMALL_STATE(9179)] = 410888,
  [SMALL_STATE(9180)] = 410929,
  [SMALL_STATE(9181)] = 410970,
  [SMALL_STATE(9182)] = 411011,
  [SMALL_STATE(9183)] = 411052,
  [SMALL_STATE(9184)] = 411093,
  [SMALL_STATE(9185)] = 411134,
  [SMALL_STATE(9186)] = 411175,
  [SMALL_STATE(9187)] = 411216,
  [SMALL_STATE(9188)] = 411257,
  [SMALL_STATE(9189)] = 411298,
  [SMALL_STATE(9190)] = 411339,
  [SMALL_STATE(9191)] = 411380,
  [SMALL_STATE(9192)] = 411421,
  [SMALL_STATE(9193)] = 411462,
  [SMALL_STATE(9194)] = 411503,
  [SMALL_STATE(9195)] = 411544,
  [SMALL_STATE(9196)] = 411585,
  [SMALL_STATE(9197)] = 411626,
  [SMALL_STATE(9198)] = 411667,
  [SMALL_STATE(9199)] = 411708,
  [SMALL_STATE(9200)] = 411749,
  [SMALL_STATE(9201)] = 411790,
  [SMALL_STATE(9202)] = 411831,
  [SMALL_STATE(9203)] = 411872,
  [SMALL_STATE(9204)] = 411913,
  [SMALL_STATE(9205)] = 411954,
  [SMALL_STATE(9206)] = 411995,
  [SMALL_STATE(9207)] = 412036,
  [SMALL_STATE(9208)] = 412077,
  [SMALL_STATE(9209)] = 412118,
  [SMALL_STATE(9210)] = 412159,
  [SMALL_STATE(9211)] = 412200,
  [SMALL_STATE(9212)] = 412241,
  [SMALL_STATE(9213)] = 412282,
  [SMALL_STATE(9214)] = 412323,
  [SMALL_STATE(9215)] = 412364,
  [SMALL_STATE(9216)] = 412405,
  [SMALL_STATE(9217)] = 412446,
  [SMALL_STATE(9218)] = 412487,
  [SMALL_STATE(9219)] = 412528,
  [SMALL_STATE(9220)] = 412569,
  [SMALL_STATE(9221)] = 412610,
  [SMALL_STATE(9222)] = 412651,
  [SMALL_STATE(9223)] = 412692,
  [SMALL_STATE(9224)] = 412733,
  [SMALL_STATE(9225)] = 412774,
  [SMALL_STATE(9226)] = 412815,
  [SMALL_STATE(9227)] = 412856,
  [SMALL_STATE(9228)] = 412897,
  [SMALL_STATE(9229)] = 412938,
  [SMALL_STATE(9230)] = 412979,
  [SMALL_STATE(9231)] = 413020,
  [SMALL_STATE(9232)] = 413061,
  [SMALL_STATE(9233)] = 413102,
  [SMALL_STATE(9234)] = 413143,
  [SMALL_STATE(9235)] = 413184,
  [SMALL_STATE(9236)] = 413225,
  [SMALL_STATE(9237)] = 413266,
  [SMALL_STATE(9238)] = 413307,
  [SMALL_STATE(9239)] = 413348,
  [SMALL_STATE(9240)] = 413389,
  [SMALL_STATE(9241)] = 413430,
  [SMALL_STATE(9242)] = 413471,
  [SMALL_STATE(9243)] = 413512,
  [SMALL_STATE(9244)] = 413553,
  [SMALL_STATE(9245)] = 413594,
  [SMALL_STATE(9246)] = 413635,
  [SMALL_STATE(9247)] = 413676,
  [SMALL_STATE(9248)] = 413717,
  [SMALL_STATE(9249)] = 413758,
  [SMALL_STATE(9250)] = 413799,
  [SMALL_STATE(9251)] = 413840,
  [SMALL_STATE(9252)] = 413881,
  [SMALL_STATE(9253)] = 413922,
  [SMALL_STATE(9254)] = 413963,
  [SMALL_STATE(9255)] = 414004,
  [SMALL_STATE(9256)] = 414045,
  [SMALL_STATE(9257)] = 414086,
  [SMALL_STATE(9258)] = 414127,
  [SMALL_STATE(9259)] = 414168,
  [SMALL_STATE(9260)] = 414209,
  [SMALL_STATE(9261)] = 414250,
  [SMALL_STATE(9262)] = 414291,
  [SMALL_STATE(9263)] = 414332,
  [SMALL_STATE(9264)] = 414373,
  [SMALL_STATE(9265)] = 414414,
  [SMALL_STATE(9266)] = 414455,
  [SMALL_STATE(9267)] = 414496,
  [SMALL_STATE(9268)] = 414537,
  [SMALL_STATE(9269)] = 414578,
  [SMALL_STATE(9270)] = 414619,
  [SMALL_STATE(9271)] = 414660,
  [SMALL_STATE(9272)] = 414701,
  [SMALL_STATE(9273)] = 414742,
  [SMALL_STATE(9274)] = 414783,
  [SMALL_STATE(9275)] = 414824,
  [SMALL_STATE(9276)] = 414865,
  [SMALL_STATE(9277)] = 414906,
  [SMALL_STATE(9278)] = 414947,
  [SMALL_STATE(9279)] = 414988,
  [SMALL_STATE(9280)] = 415029,
  [SMALL_STATE(9281)] = 415070,
  [SMALL_STATE(9282)] = 415111,
  [SMALL_STATE(9283)] = 415152,
  [SMALL_STATE(9284)] = 415193,
  [SMALL_STATE(9285)] = 415234,
  [SMALL_STATE(9286)] = 415275,
  [SMALL_STATE(9287)] = 415316,
  [SMALL_STATE(9288)] = 415357,
  [SMALL_STATE(9289)] = 415398,
  [SMALL_STATE(9290)] = 415439,
  [SMALL_STATE(9291)] = 415480,
  [SMALL_STATE(9292)] = 415521,
  [SMALL_STATE(9293)] = 415562,
  [SMALL_STATE(9294)] = 415603,
  [SMALL_STATE(9295)] = 415644,
  [SMALL_STATE(9296)] = 415685,
  [SMALL_STATE(9297)] = 415726,
  [SMALL_STATE(9298)] = 415767,
  [SMALL_STATE(9299)] = 415808,
  [SMALL_STATE(9300)] = 415849,
  [SMALL_STATE(9301)] = 415890,
  [SMALL_STATE(9302)] = 415931,
  [SMALL_STATE(9303)] = 415972,
  [SMALL_STATE(9304)] = 416013,
  [SMALL_STATE(9305)] = 416054,
  [SMALL_STATE(9306)] = 416095,
  [SMALL_STATE(9307)] = 416136,
  [SMALL_STATE(9308)] = 416177,
  [SMALL_STATE(9309)] = 416218,
  [SMALL_STATE(9310)] = 416259,
  [SMALL_STATE(9311)] = 416300,
  [SMALL_STATE(9312)] = 416341,
  [SMALL_STATE(9313)] = 416382,
  [SMALL_STATE(9314)] = 416423,
  [SMALL_STATE(9315)] = 416464,
  [SMALL_STATE(9316)] = 416505,
  [SMALL_STATE(9317)] = 416546,
  [SMALL_STATE(9318)] = 416587,
  [SMALL_STATE(9319)] = 416628,
  [SMALL_STATE(9320)] = 416669,
  [SMALL_STATE(9321)] = 416710,
  [SMALL_STATE(9322)] = 416751,
  [SMALL_STATE(9323)] = 416792,
  [SMALL_STATE(9324)] = 416833,
  [SMALL_STATE(9325)] = 416874,
  [SMALL_STATE(9326)] = 416915,
  [SMALL_STATE(9327)] = 416956,
  [SMALL_STATE(9328)] = 416997,
  [SMALL_STATE(9329)] = 417038,
  [SMALL_STATE(9330)] = 417079,
  [SMALL_STATE(9331)] = 417120,
  [SMALL_STATE(9332)] = 417161,
  [SMALL_STATE(9333)] = 417202,
  [SMALL_STATE(9334)] = 417243,
  [SMALL_STATE(9335)] = 417284,
  [SMALL_STATE(9336)] = 417325,
  [SMALL_STATE(9337)] = 417366,
  [SMALL_STATE(9338)] = 417407,
  [SMALL_STATE(9339)] = 417448,
  [SMALL_STATE(9340)] = 417489,
  [SMALL_STATE(9341)] = 417530,
  [SMALL_STATE(9342)] = 417571,
  [SMALL_STATE(9343)] = 417612,
  [SMALL_STATE(9344)] = 417653,
  [SMALL_STATE(9345)] = 417694,
  [SMALL_STATE(9346)] = 417735,
  [SMALL_STATE(9347)] = 417776,
  [SMALL_STATE(9348)] = 417817,
  [SMALL_STATE(9349)] = 417858,
  [SMALL_STATE(9350)] = 417899,
  [SMALL_STATE(9351)] = 417940,
  [SMALL_STATE(9352)] = 417981,
  [SMALL_STATE(9353)] = 418022,
  [SMALL_STATE(9354)] = 418063,
  [SMALL_STATE(9355)] = 418104,
  [SMALL_STATE(9356)] = 418145,
  [SMALL_STATE(9357)] = 418186,
  [SMALL_STATE(9358)] = 418227,
  [SMALL_STATE(9359)] = 418268,
  [SMALL_STATE(9360)] = 418309,
  [SMALL_STATE(9361)] = 418350,
  [SMALL_STATE(9362)] = 418391,
  [SMALL_STATE(9363)] = 418432,
  [SMALL_STATE(9364)] = 418473,
  [SMALL_STATE(9365)] = 418514,
  [SMALL_STATE(9366)] = 418555,
  [SMALL_STATE(9367)] = 418596,
  [SMALL_STATE(9368)] = 418637,
  [SMALL_STATE(9369)] = 418678,
  [SMALL_STATE(9370)] = 418719,
  [SMALL_STATE(9371)] = 418760,
  [SMALL_STATE(9372)] = 418801,
  [SMALL_STATE(9373)] = 418842,
  [SMALL_STATE(9374)] = 418883,
  [SMALL_STATE(9375)] = 418924,
  [SMALL_STATE(9376)] = 418965,
  [SMALL_STATE(9377)] = 419006,
  [SMALL_STATE(9378)] = 419047,
  [SMALL_STATE(9379)] = 419088,
  [SMALL_STATE(9380)] = 419129,
  [SMALL_STATE(9381)] = 419170,
  [SMALL_STATE(9382)] = 419211,
  [SMALL_STATE(9383)] = 419252,
  [SMALL_STATE(9384)] = 419293,
  [SMALL_STATE(9385)] = 419334,
  [SMALL_STATE(9386)] = 419375,
  [SMALL_STATE(9387)] = 419416,
  [SMALL_STATE(9388)] = 419457,
  [SMALL_STATE(9389)] = 419498,
  [SMALL_STATE(9390)] = 419539,
  [SMALL_STATE(9391)] = 419580,
  [SMALL_STATE(9392)] = 419621,
  [SMALL_STATE(9393)] = 419662,
  [SMALL_STATE(9394)] = 419703,
  [SMALL_STATE(9395)] = 419744,
  [SMALL_STATE(9396)] = 419785,
  [SMALL_STATE(9397)] = 419826,
  [SMALL_STATE(9398)] = 419867,
  [SMALL_STATE(9399)] = 419908,
  [SMALL_STATE(9400)] = 419949,
  [SMALL_STATE(9401)] = 419990,
  [SMALL_STATE(9402)] = 420031,
  [SMALL_STATE(9403)] = 420072,
  [SMALL_STATE(9404)] = 420113,
  [SMALL_STATE(9405)] = 420154,
  [SMALL_STATE(9406)] = 420195,
  [SMALL_STATE(9407)] = 420236,
  [SMALL_STATE(9408)] = 420277,
  [SMALL_STATE(9409)] = 420318,
  [SMALL_STATE(9410)] = 420359,
  [SMALL_STATE(9411)] = 420400,
  [SMALL_STATE(9412)] = 420441,
  [SMALL_STATE(9413)] = 420482,
  [SMALL_STATE(9414)] = 420523,
  [SMALL_STATE(9415)] = 420564,
  [SMALL_STATE(9416)] = 420605,
  [SMALL_STATE(9417)] = 420646,
  [SMALL_STATE(9418)] = 420687,
  [SMALL_STATE(9419)] = 420728,
  [SMALL_STATE(9420)] = 420769,
  [SMALL_STATE(9421)] = 420810,
  [SMALL_STATE(9422)] = 420851,
  [SMALL_STATE(9423)] = 420892,
  [SMALL_STATE(9424)] = 420933,
  [SMALL_STATE(9425)] = 420974,
  [SMALL_STATE(9426)] = 421015,
  [SMALL_STATE(9427)] = 421056,
  [SMALL_STATE(9428)] = 421097,
  [SMALL_STATE(9429)] = 421138,
  [SMALL_STATE(9430)] = 421179,
  [SMALL_STATE(9431)] = 421220,
  [SMALL_STATE(9432)] = 421261,
  [SMALL_STATE(9433)] = 421302,
  [SMALL_STATE(9434)] = 421343,
  [SMALL_STATE(9435)] = 421384,
  [SMALL_STATE(9436)] = 421425,
  [SMALL_STATE(9437)] = 421466,
  [SMALL_STATE(9438)] = 421507,
  [SMALL_STATE(9439)] = 421548,
  [SMALL_STATE(9440)] = 421589,
  [SMALL_STATE(9441)] = 421630,
  [SMALL_STATE(9442)] = 421671,
  [SMALL_STATE(9443)] = 421712,
  [SMALL_STATE(9444)] = 421753,
  [SMALL_STATE(9445)] = 421794,
  [SMALL_STATE(9446)] = 421835,
  [SMALL_STATE(9447)] = 421876,
  [SMALL_STATE(9448)] = 421917,
  [SMALL_STATE(9449)] = 421958,
  [SMALL_STATE(9450)] = 421999,
  [SMALL_STATE(9451)] = 422040,
  [SMALL_STATE(9452)] = 422081,
  [SMALL_STATE(9453)] = 422122,
  [SMALL_STATE(9454)] = 422163,
  [SMALL_STATE(9455)] = 422204,
  [SMALL_STATE(9456)] = 422245,
  [SMALL_STATE(9457)] = 422286,
  [SMALL_STATE(9458)] = 422327,
  [SMALL_STATE(9459)] = 422368,
  [SMALL_STATE(9460)] = 422409,
  [SMALL_STATE(9461)] = 422450,
  [SMALL_STATE(9462)] = 422491,
  [SMALL_STATE(9463)] = 422532,
  [SMALL_STATE(9464)] = 422573,
  [SMALL_STATE(9465)] = 422614,
  [SMALL_STATE(9466)] = 422655,
  [SMALL_STATE(9467)] = 422696,
  [SMALL_STATE(9468)] = 422737,
  [SMALL_STATE(9469)] = 422778,
  [SMALL_STATE(9470)] = 422819,
  [SMALL_STATE(9471)] = 422860,
  [SMALL_STATE(9472)] = 422901,
  [SMALL_STATE(9473)] = 422942,
  [SMALL_STATE(9474)] = 422983,
  [SMALL_STATE(9475)] = 423024,
  [SMALL_STATE(9476)] = 423065,
  [SMALL_STATE(9477)] = 423106,
  [SMALL_STATE(9478)] = 423147,
  [SMALL_STATE(9479)] = 423188,
  [SMALL_STATE(9480)] = 423229,
  [SMALL_STATE(9481)] = 423270,
  [SMALL_STATE(9482)] = 423311,
  [SMALL_STATE(9483)] = 423352,
  [SMALL_STATE(9484)] = 423393,
  [SMALL_STATE(9485)] = 423434,
  [SMALL_STATE(9486)] = 423475,
  [SMALL_STATE(9487)] = 423516,
  [SMALL_STATE(9488)] = 423557,
  [SMALL_STATE(9489)] = 423598,
  [SMALL_STATE(9490)] = 423639,
  [SMALL_STATE(9491)] = 423680,
  [SMALL_STATE(9492)] = 423721,
  [SMALL_STATE(9493)] = 423762,
  [SMALL_STATE(9494)] = 423803,
  [SMALL_STATE(9495)] = 423844,
  [SMALL_STATE(9496)] = 423885,
  [SMALL_STATE(9497)] = 423926,
  [SMALL_STATE(9498)] = 423967,
  [SMALL_STATE(9499)] = 424008,
  [SMALL_STATE(9500)] = 424049,
  [SMALL_STATE(9501)] = 424090,
  [SMALL_STATE(9502)] = 424131,
  [SMALL_STATE(9503)] = 424172,
  [SMALL_STATE(9504)] = 424213,
  [SMALL_STATE(9505)] = 424254,
  [SMALL_STATE(9506)] = 424295,
  [SMALL_STATE(9507)] = 424336,
  [SMALL_STATE(9508)] = 424377,
  [SMALL_STATE(9509)] = 424418,
  [SMALL_STATE(9510)] = 424459,
  [SMALL_STATE(9511)] = 424500,
  [SMALL_STATE(9512)] = 424541,
  [SMALL_STATE(9513)] = 424582,
  [SMALL_STATE(9514)] = 424623,
  [SMALL_STATE(9515)] = 424664,
  [SMALL_STATE(9516)] = 424705,
  [SMALL_STATE(9517)] = 424746,
  [SMALL_STATE(9518)] = 424787,
  [SMALL_STATE(9519)] = 424828,
  [SMALL_STATE(9520)] = 424869,
  [SMALL_STATE(9521)] = 424910,
  [SMALL_STATE(9522)] = 424951,
  [SMALL_STATE(9523)] = 424992,
  [SMALL_STATE(9524)] = 425033,
  [SMALL_STATE(9525)] = 425074,
  [SMALL_STATE(9526)] = 425115,
  [SMALL_STATE(9527)] = 425156,
  [SMALL_STATE(9528)] = 425197,
  [SMALL_STATE(9529)] = 425238,
  [SMALL_STATE(9530)] = 425279,
  [SMALL_STATE(9531)] = 425320,
  [SMALL_STATE(9532)] = 425361,
  [SMALL_STATE(9533)] = 425402,
  [SMALL_STATE(9534)] = 425443,
  [SMALL_STATE(9535)] = 425484,
  [SMALL_STATE(9536)] = 425525,
  [SMALL_STATE(9537)] = 425566,
  [SMALL_STATE(9538)] = 425607,
  [SMALL_STATE(9539)] = 425648,
  [SMALL_STATE(9540)] = 425689,
  [SMALL_STATE(9541)] = 425730,
  [SMALL_STATE(9542)] = 425771,
  [SMALL_STATE(9543)] = 425812,
  [SMALL_STATE(9544)] = 425853,
  [SMALL_STATE(9545)] = 425894,
  [SMALL_STATE(9546)] = 425935,
  [SMALL_STATE(9547)] = 425976,
  [SMALL_STATE(9548)] = 426017,
  [SMALL_STATE(9549)] = 426058,
  [SMALL_STATE(9550)] = 426099,
  [SMALL_STATE(9551)] = 426140,
  [SMALL_STATE(9552)] = 426181,
  [SMALL_STATE(9553)] = 426222,
  [SMALL_STATE(9554)] = 426263,
  [SMALL_STATE(9555)] = 426304,
  [SMALL_STATE(9556)] = 426345,
  [SMALL_STATE(9557)] = 426386,
  [SMALL_STATE(9558)] = 426427,
  [SMALL_STATE(9559)] = 426468,
  [SMALL_STATE(9560)] = 426509,
  [SMALL_STATE(9561)] = 426550,
  [SMALL_STATE(9562)] = 426591,
  [SMALL_STATE(9563)] = 426632,
  [SMALL_STATE(9564)] = 426673,
  [SMALL_STATE(9565)] = 426714,
  [SMALL_STATE(9566)] = 426755,
  [SMALL_STATE(9567)] = 426796,
  [SMALL_STATE(9568)] = 426837,
  [SMALL_STATE(9569)] = 426878,
  [SMALL_STATE(9570)] = 426919,
  [SMALL_STATE(9571)] = 426960,
  [SMALL_STATE(9572)] = 427001,
  [SMALL_STATE(9573)] = 427042,
  [SMALL_STATE(9574)] = 427083,
  [SMALL_STATE(9575)] = 427124,
  [SMALL_STATE(9576)] = 427165,
  [SMALL_STATE(9577)] = 427206,
  [SMALL_STATE(9578)] = 427247,
  [SMALL_STATE(9579)] = 427288,
  [SMALL_STATE(9580)] = 427329,
  [SMALL_STATE(9581)] = 427370,
  [SMALL_STATE(9582)] = 427411,
  [SMALL_STATE(9583)] = 427452,
  [SMALL_STATE(9584)] = 427493,
  [SMALL_STATE(9585)] = 427534,
  [SMALL_STATE(9586)] = 427575,
  [SMALL_STATE(9587)] = 427616,
  [SMALL_STATE(9588)] = 427657,
  [SMALL_STATE(9589)] = 427698,
  [SMALL_STATE(9590)] = 427739,
  [SMALL_STATE(9591)] = 427780,
  [SMALL_STATE(9592)] = 427821,
  [SMALL_STATE(9593)] = 427862,
  [SMALL_STATE(9594)] = 427903,
  [SMALL_STATE(9595)] = 427944,
  [SMALL_STATE(9596)] = 427985,
  [SMALL_STATE(9597)] = 428026,
  [SMALL_STATE(9598)] = 428067,
  [SMALL_STATE(9599)] = 428108,
  [SMALL_STATE(9600)] = 428149,
  [SMALL_STATE(9601)] = 428190,
  [SMALL_STATE(9602)] = 428231,
  [SMALL_STATE(9603)] = 428272,
  [SMALL_STATE(9604)] = 428313,
  [SMALL_STATE(9605)] = 428354,
  [SMALL_STATE(9606)] = 428395,
  [SMALL_STATE(9607)] = 428436,
  [SMALL_STATE(9608)] = 428477,
  [SMALL_STATE(9609)] = 428518,
  [SMALL_STATE(9610)] = 428559,
  [SMALL_STATE(9611)] = 428600,
  [SMALL_STATE(9612)] = 428641,
  [SMALL_STATE(9613)] = 428682,
  [SMALL_STATE(9614)] = 428723,
  [SMALL_STATE(9615)] = 428764,
  [SMALL_STATE(9616)] = 428805,
  [SMALL_STATE(9617)] = 428846,
  [SMALL_STATE(9618)] = 428887,
  [SMALL_STATE(9619)] = 428928,
  [SMALL_STATE(9620)] = 428969,
  [SMALL_STATE(9621)] = 429010,
  [SMALL_STATE(9622)] = 429051,
  [SMALL_STATE(9623)] = 429092,
  [SMALL_STATE(9624)] = 429133,
  [SMALL_STATE(9625)] = 429174,
  [SMALL_STATE(9626)] = 429215,
  [SMALL_STATE(9627)] = 429256,
  [SMALL_STATE(9628)] = 429297,
  [SMALL_STATE(9629)] = 429338,
  [SMALL_STATE(9630)] = 429379,
  [SMALL_STATE(9631)] = 429420,
  [SMALL_STATE(9632)] = 429461,
  [SMALL_STATE(9633)] = 429502,
  [SMALL_STATE(9634)] = 429543,
  [SMALL_STATE(9635)] = 429584,
  [SMALL_STATE(9636)] = 429625,
  [SMALL_STATE(9637)] = 429666,
  [SMALL_STATE(9638)] = 429707,
  [SMALL_STATE(9639)] = 429748,
  [SMALL_STATE(9640)] = 429789,
  [SMALL_STATE(9641)] = 429830,
  [SMALL_STATE(9642)] = 429871,
  [SMALL_STATE(9643)] = 429912,
  [SMALL_STATE(9644)] = 429953,
  [SMALL_STATE(9645)] = 429994,
  [SMALL_STATE(9646)] = 430035,
  [SMALL_STATE(9647)] = 430076,
  [SMALL_STATE(9648)] = 430117,
  [SMALL_STATE(9649)] = 430158,
  [SMALL_STATE(9650)] = 430199,
  [SMALL_STATE(9651)] = 430240,
  [SMALL_STATE(9652)] = 430281,
  [SMALL_STATE(9653)] = 430322,
  [SMALL_STATE(9654)] = 430363,
  [SMALL_STATE(9655)] = 430404,
  [SMALL_STATE(9656)] = 430445,
  [SMALL_STATE(9657)] = 430486,
  [SMALL_STATE(9658)] = 430527,
  [SMALL_STATE(9659)] = 430568,
  [SMALL_STATE(9660)] = 430609,
  [SMALL_STATE(9661)] = 430650,
  [SMALL_STATE(9662)] = 430691,
  [SMALL_STATE(9663)] = 430732,
  [SMALL_STATE(9664)] = 430773,
  [SMALL_STATE(9665)] = 430814,
  [SMALL_STATE(9666)] = 430855,
  [SMALL_STATE(9667)] = 430896,
  [SMALL_STATE(9668)] = 430937,
  [SMALL_STATE(9669)] = 430978,
  [SMALL_STATE(9670)] = 431019,
  [SMALL_STATE(9671)] = 431060,
  [SMALL_STATE(9672)] = 431101,
  [SMALL_STATE(9673)] = 431142,
  [SMALL_STATE(9674)] = 431183,
  [SMALL_STATE(9675)] = 431224,
  [SMALL_STATE(9676)] = 431265,
  [SMALL_STATE(9677)] = 431306,
  [SMALL_STATE(9678)] = 431347,
  [SMALL_STATE(9679)] = 431388,
  [SMALL_STATE(9680)] = 431429,
  [SMALL_STATE(9681)] = 431470,
  [SMALL_STATE(9682)] = 431511,
  [SMALL_STATE(9683)] = 431552,
  [SMALL_STATE(9684)] = 431593,
  [SMALL_STATE(9685)] = 431634,
  [SMALL_STATE(9686)] = 431675,
  [SMALL_STATE(9687)] = 431716,
  [SMALL_STATE(9688)] = 431757,
  [SMALL_STATE(9689)] = 431798,
  [SMALL_STATE(9690)] = 431839,
  [SMALL_STATE(9691)] = 431880,
  [SMALL_STATE(9692)] = 431921,
  [SMALL_STATE(9693)] = 431962,
  [SMALL_STATE(9694)] = 432003,
  [SMALL_STATE(9695)] = 432044,
  [SMALL_STATE(9696)] = 432085,
  [SMALL_STATE(9697)] = 432126,
  [SMALL_STATE(9698)] = 432167,
  [SMALL_STATE(9699)] = 432208,
  [SMALL_STATE(9700)] = 432249,
  [SMALL_STATE(9701)] = 432290,
  [SMALL_STATE(9702)] = 432331,
  [SMALL_STATE(9703)] = 432372,
  [SMALL_STATE(9704)] = 432413,
  [SMALL_STATE(9705)] = 432454,
  [SMALL_STATE(9706)] = 432495,
  [SMALL_STATE(9707)] = 432536,
  [SMALL_STATE(9708)] = 432577,
  [SMALL_STATE(9709)] = 432618,
  [SMALL_STATE(9710)] = 432659,
  [SMALL_STATE(9711)] = 432700,
  [SMALL_STATE(9712)] = 432741,
  [SMALL_STATE(9713)] = 432782,
  [SMALL_STATE(9714)] = 432823,
  [SMALL_STATE(9715)] = 432864,
  [SMALL_STATE(9716)] = 432905,
  [SMALL_STATE(9717)] = 432946,
  [SMALL_STATE(9718)] = 432987,
  [SMALL_STATE(9719)] = 433028,
  [SMALL_STATE(9720)] = 433069,
  [SMALL_STATE(9721)] = 433110,
  [SMALL_STATE(9722)] = 433151,
  [SMALL_STATE(9723)] = 433192,
  [SMALL_STATE(9724)] = 433233,
  [SMALL_STATE(9725)] = 433274,
  [SMALL_STATE(9726)] = 433315,
  [SMALL_STATE(9727)] = 433356,
  [SMALL_STATE(9728)] = 433397,
  [SMALL_STATE(9729)] = 433438,
  [SMALL_STATE(9730)] = 433479,
  [SMALL_STATE(9731)] = 433520,
  [SMALL_STATE(9732)] = 433561,
  [SMALL_STATE(9733)] = 433602,
  [SMALL_STATE(9734)] = 433643,
  [SMALL_STATE(9735)] = 433684,
  [SMALL_STATE(9736)] = 433725,
  [SMALL_STATE(9737)] = 433766,
  [SMALL_STATE(9738)] = 433807,
  [SMALL_STATE(9739)] = 433848,
  [SMALL_STATE(9740)] = 433889,
  [SMALL_STATE(9741)] = 433930,
  [SMALL_STATE(9742)] = 433971,
  [SMALL_STATE(9743)] = 434012,
  [SMALL_STATE(9744)] = 434053,
  [SMALL_STATE(9745)] = 434094,
  [SMALL_STATE(9746)] = 434135,
  [SMALL_STATE(9747)] = 434176,
  [SMALL_STATE(9748)] = 434217,
  [SMALL_STATE(9749)] = 434258,
  [SMALL_STATE(9750)] = 434299,
  [SMALL_STATE(9751)] = 434340,
  [SMALL_STATE(9752)] = 434381,
  [SMALL_STATE(9753)] = 434422,
  [SMALL_STATE(9754)] = 434463,
  [SMALL_STATE(9755)] = 434504,
  [SMALL_STATE(9756)] = 434545,
  [SMALL_STATE(9757)] = 434586,
  [SMALL_STATE(9758)] = 434627,
  [SMALL_STATE(9759)] = 434668,
  [SMALL_STATE(9760)] = 434709,
  [SMALL_STATE(9761)] = 434750,
  [SMALL_STATE(9762)] = 434791,
  [SMALL_STATE(9763)] = 434832,
  [SMALL_STATE(9764)] = 434873,
  [SMALL_STATE(9765)] = 434914,
  [SMALL_STATE(9766)] = 434955,
  [SMALL_STATE(9767)] = 434996,
  [SMALL_STATE(9768)] = 435037,
  [SMALL_STATE(9769)] = 435078,
  [SMALL_STATE(9770)] = 435119,
  [SMALL_STATE(9771)] = 435160,
  [SMALL_STATE(9772)] = 435201,
  [SMALL_STATE(9773)] = 435242,
  [SMALL_STATE(9774)] = 435283,
  [SMALL_STATE(9775)] = 435324,
  [SMALL_STATE(9776)] = 435365,
  [SMALL_STATE(9777)] = 435406,
  [SMALL_STATE(9778)] = 435447,
  [SMALL_STATE(9779)] = 435488,
  [SMALL_STATE(9780)] = 435529,
  [SMALL_STATE(9781)] = 435570,
  [SMALL_STATE(9782)] = 435611,
  [SMALL_STATE(9783)] = 435652,
  [SMALL_STATE(9784)] = 435693,
  [SMALL_STATE(9785)] = 435734,
  [SMALL_STATE(9786)] = 435775,
  [SMALL_STATE(9787)] = 435816,
  [SMALL_STATE(9788)] = 435857,
  [SMALL_STATE(9789)] = 435898,
  [SMALL_STATE(9790)] = 435939,
  [SMALL_STATE(9791)] = 435980,
  [SMALL_STATE(9792)] = 436021,
  [SMALL_STATE(9793)] = 436062,
  [SMALL_STATE(9794)] = 436103,
  [SMALL_STATE(9795)] = 436144,
  [SMALL_STATE(9796)] = 436185,
  [SMALL_STATE(9797)] = 436226,
  [SMALL_STATE(9798)] = 436267,
  [SMALL_STATE(9799)] = 436308,
  [SMALL_STATE(9800)] = 436349,
  [SMALL_STATE(9801)] = 436390,
  [SMALL_STATE(9802)] = 436431,
  [SMALL_STATE(9803)] = 436472,
  [SMALL_STATE(9804)] = 436513,
  [SMALL_STATE(9805)] = 436554,
  [SMALL_STATE(9806)] = 436595,
  [SMALL_STATE(9807)] = 436636,
  [SMALL_STATE(9808)] = 436677,
  [SMALL_STATE(9809)] = 436718,
  [SMALL_STATE(9810)] = 436759,
  [SMALL_STATE(9811)] = 436800,
  [SMALL_STATE(9812)] = 436841,
  [SMALL_STATE(9813)] = 436882,
  [SMALL_STATE(9814)] = 436923,
  [SMALL_STATE(9815)] = 436964,
  [SMALL_STATE(9816)] = 437005,
  [SMALL_STATE(9817)] = 437046,
  [SMALL_STATE(9818)] = 437087,
  [SMALL_STATE(9819)] = 437128,
  [SMALL_STATE(9820)] = 437169,
  [SMALL_STATE(9821)] = 437210,
  [SMALL_STATE(9822)] = 437251,
  [SMALL_STATE(9823)] = 437292,
  [SMALL_STATE(9824)] = 437333,
  [SMALL_STATE(9825)] = 437374,
  [SMALL_STATE(9826)] = 437415,
  [SMALL_STATE(9827)] = 437456,
  [SMALL_STATE(9828)] = 437497,
  [SMALL_STATE(9829)] = 437538,
  [SMALL_STATE(9830)] = 437579,
  [SMALL_STATE(9831)] = 437620,
  [SMALL_STATE(9832)] = 437661,
  [SMALL_STATE(9833)] = 437702,
  [SMALL_STATE(9834)] = 437743,
  [SMALL_STATE(9835)] = 437784,
  [SMALL_STATE(9836)] = 437825,
  [SMALL_STATE(9837)] = 437866,
  [SMALL_STATE(9838)] = 437907,
  [SMALL_STATE(9839)] = 437948,
  [SMALL_STATE(9840)] = 437989,
  [SMALL_STATE(9841)] = 438030,
  [SMALL_STATE(9842)] = 438071,
  [SMALL_STATE(9843)] = 438112,
  [SMALL_STATE(9844)] = 438153,
  [SMALL_STATE(9845)] = 438194,
  [SMALL_STATE(9846)] = 438235,
  [SMALL_STATE(9847)] = 438276,
  [SMALL_STATE(9848)] = 438317,
  [SMALL_STATE(9849)] = 438358,
  [SMALL_STATE(9850)] = 438399,
  [SMALL_STATE(9851)] = 438440,
  [SMALL_STATE(9852)] = 438481,
  [SMALL_STATE(9853)] = 438522,
  [SMALL_STATE(9854)] = 438563,
  [SMALL_STATE(9855)] = 438604,
  [SMALL_STATE(9856)] = 438645,
  [SMALL_STATE(9857)] = 438686,
  [SMALL_STATE(9858)] = 438727,
  [SMALL_STATE(9859)] = 438768,
  [SMALL_STATE(9860)] = 438809,
  [SMALL_STATE(9861)] = 438850,
  [SMALL_STATE(9862)] = 438891,
  [SMALL_STATE(9863)] = 438932,
  [SMALL_STATE(9864)] = 438973,
  [SMALL_STATE(9865)] = 439014,
  [SMALL_STATE(9866)] = 439055,
  [SMALL_STATE(9867)] = 439096,
  [SMALL_STATE(9868)] = 439137,
  [SMALL_STATE(9869)] = 439178,
  [SMALL_STATE(9870)] = 439219,
  [SMALL_STATE(9871)] = 439260,
  [SMALL_STATE(9872)] = 439301,
  [SMALL_STATE(9873)] = 439342,
  [SMALL_STATE(9874)] = 439383,
  [SMALL_STATE(9875)] = 439424,
  [SMALL_STATE(9876)] = 439465,
  [SMALL_STATE(9877)] = 439506,
  [SMALL_STATE(9878)] = 439547,
  [SMALL_STATE(9879)] = 439588,
  [SMALL_STATE(9880)] = 439629,
  [SMALL_STATE(9881)] = 439670,
  [SMALL_STATE(9882)] = 439711,
  [SMALL_STATE(9883)] = 439752,
  [SMALL_STATE(9884)] = 439793,
  [SMALL_STATE(9885)] = 439834,
  [SMALL_STATE(9886)] = 439875,
  [SMALL_STATE(9887)] = 439916,
  [SMALL_STATE(9888)] = 439957,
  [SMALL_STATE(9889)] = 439998,
  [SMALL_STATE(9890)] = 440039,
  [SMALL_STATE(9891)] = 440080,
  [SMALL_STATE(9892)] = 440121,
  [SMALL_STATE(9893)] = 440162,
  [SMALL_STATE(9894)] = 440203,
  [SMALL_STATE(9895)] = 440244,
  [SMALL_STATE(9896)] = 440285,
  [SMALL_STATE(9897)] = 440326,
  [SMALL_STATE(9898)] = 440367,
  [SMALL_STATE(9899)] = 440408,
  [SMALL_STATE(9900)] = 440449,
  [SMALL_STATE(9901)] = 440490,
  [SMALL_STATE(9902)] = 440531,
  [SMALL_STATE(9903)] = 440572,
  [SMALL_STATE(9904)] = 440613,
  [SMALL_STATE(9905)] = 440654,
  [SMALL_STATE(9906)] = 440695,
  [SMALL_STATE(9907)] = 440736,
  [SMALL_STATE(9908)] = 440777,
  [SMALL_STATE(9909)] = 440818,
  [SMALL_STATE(9910)] = 440859,
  [SMALL_STATE(9911)] = 440900,
  [SMALL_STATE(9912)] = 440941,
  [SMALL_STATE(9913)] = 440982,
  [SMALL_STATE(9914)] = 441023,
  [SMALL_STATE(9915)] = 441064,
  [SMALL_STATE(9916)] = 441105,
  [SMALL_STATE(9917)] = 441146,
  [SMALL_STATE(9918)] = 441187,
  [SMALL_STATE(9919)] = 441228,
  [SMALL_STATE(9920)] = 441269,
  [SMALL_STATE(9921)] = 441310,
  [SMALL_STATE(9922)] = 441351,
  [SMALL_STATE(9923)] = 441392,
  [SMALL_STATE(9924)] = 441433,
  [SMALL_STATE(9925)] = 441474,
  [SMALL_STATE(9926)] = 441515,
  [SMALL_STATE(9927)] = 441556,
  [SMALL_STATE(9928)] = 441597,
  [SMALL_STATE(9929)] = 441638,
  [SMALL_STATE(9930)] = 441679,
  [SMALL_STATE(9931)] = 441720,
  [SMALL_STATE(9932)] = 441761,
  [SMALL_STATE(9933)] = 441802,
  [SMALL_STATE(9934)] = 441843,
  [SMALL_STATE(9935)] = 441884,
  [SMALL_STATE(9936)] = 441925,
  [SMALL_STATE(9937)] = 441966,
  [SMALL_STATE(9938)] = 441970,
  [SMALL_STATE(9939)] = 441974,
  [SMALL_STATE(9940)] = 441978,
  [SMALL_STATE(9941)] = 441982,
  [SMALL_STATE(9942)] = 441986,
  [SMALL_STATE(9943)] = 441990,
  [SMALL_STATE(9944)] = 441994,
  [SMALL_STATE(9945)] = 441998,
  [SMALL_STATE(9946)] = 442002,
  [SMALL_STATE(9947)] = 442006,
  [SMALL_STATE(9948)] = 442010,
  [SMALL_STATE(9949)] = 442014,
  [SMALL_STATE(9950)] = 442018,
  [SMALL_STATE(9951)] = 442022,
  [SMALL_STATE(9952)] = 442026,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8724),
  [5] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8677),
  [7] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8306),
  [9] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8678),
  [11] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8662),
  [13] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9929),
  [15] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9926),
  [17] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9924),
  [19] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [21] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compilation_unit, 0, 0, 0),
  [23] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2733),
  [25] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4009),
  [27] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2732),
  [29] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2445),
  [31] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2884),
  [33] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3091),
  [35] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3837),
  [37] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4005),
  [39] = {.entry = {.count = 1, .reusable = true}}, SHIFT(513),
  [41] = {.entry = {.count = 1, .reusable = true}}, SHIFT(556),
  [43] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1130),
  [45] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6847),
  [47] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7344),
  [49] = {.entry = {.count = 1, .reusable = false}}, SHIFT(649),
  [51] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7341),
  [53] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7339),
  [55] = {.entry = {.count = 1, .reusable = true}}, SHIFT(30),
  [57] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7336),
  [59] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4311),
  [61] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7179),
  [63] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3788),
  [65] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2639),
  [67] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3983),
  [69] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2920),
  [71] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8597),
  [73] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1199),
  [75] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4255),
  [77] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1199),
  [79] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1202),
  [81] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3042),
  [83] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2725),
  [85] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2753),
  [87] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5430),
  [89] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9863),
  [91] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9862),
  [93] = {.entry = {.count = 1, .reusable = false}}, SHIFT(142),
  [95] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9861),
  [97] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9860),
  [99] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9859),
  [101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2848),
  [103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8703),
  [105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4252),
  [107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1124),
  [109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8710),
  [111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(360),
  [113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9845),
  [115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(712),
  [117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9840),
  [119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(267),
  [121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2372),
  [123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7828),
  [125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5132),
  [127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9701),
  [129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9821),
  [131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9814),
  [133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9809),
  [135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9808),
  [137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4217),
  [139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8740),
  [141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4217),
  [143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6239),
  [145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16),
  [147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9920),
  [149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9918),
  [151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9917),
  [153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3958),
  [155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2251),
  [157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2808),
  [159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3098),
  [161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3840),
  [163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(512),
  [165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(796),
  [167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6850),
  [169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7357),
  [171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(713),
  [173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7318),
  [175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7356),
  [177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(36),
  [179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7354),
  [181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4310),
  [183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7148),
  [185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3948),
  [187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8500),
  [189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9432),
  [191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9433),
  [193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(124),
  [195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9702),
  [197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9915),
  [199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9703),
  [201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2805),
  [203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8746),
  [205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(847),
  [207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8880),
  [209] = {.entry = {.count = 1, .reusable = false}}, SHIFT(358),
  [211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9668),
  [213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(701),
  [215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9704),
  [217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6202),
  [219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2196),
  [221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20),
  [223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6164),
  [225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6681),
  [227] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_top_level, 3, 0, 37),
  [229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2193),
  [231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2194),
  [233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2292),
  [235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19),
  [237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6140),
  [239] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_top_level, 4, 0, 37),
  [241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2701),
  [243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2483),
  [245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8772),
  [247] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compilation_unit, 2, 0, 0),
  [249] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compilation_unit, 1, 0, 0),
  [251] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0),
  [253] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2733),
  [256] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(4009),
  [259] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2732),
  [262] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2445),
  [265] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2884),
  [268] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(3091),
  [271] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(3837),
  [274] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(4005),
  [277] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(513),
  [280] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(556),
  [283] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1130),
  [286] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(6847),
  [289] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(7344),
  [292] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(649),
  [295] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(7341),
  [298] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(7339),
  [301] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(30),
  [304] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(7336),
  [307] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(4311),
  [310] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(7179),
  [313] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(3788),
  [316] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2639),
  [319] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(3983),
  [322] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2920),
  [325] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(8597),
  [328] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1199),
  [331] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(4255),
  [334] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1199),
  [337] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1202),
  [340] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(3042),
  [343] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2725),
  [346] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2753),
  [349] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(5430),
  [352] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(9863),
  [355] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(9862),
  [358] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(142),
  [361] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(9861),
  [364] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(9860),
  [367] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(9859),
  [370] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2848),
  [373] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(8703),
  [376] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(4252),
  [379] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1124),
  [382] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(8710),
  [385] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(360),
  [388] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(9845),
  [391] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(712),
  [394] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(9840),
  [397] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(267),
  [400] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2372),
  [403] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(7828),
  [406] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(5132),
  [409] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(9701),
  [412] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(9821),
  [415] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(9814),
  [418] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(9809),
  [421] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(9808),
  [424] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(4217),
  [427] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(8740),
  [430] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(4217),
  [433] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(6239),
  [436] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(9920),
  [439] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(9918),
  [442] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(9917),
  [445] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(2733),
  [448] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(3958),
  [451] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(2732),
  [454] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(2251),
  [457] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(2808),
  [460] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(3098),
  [463] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(3840),
  [466] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(4005),
  [469] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(512),
  [472] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(556),
  [475] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(796),
  [478] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(6850),
  [481] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(7357),
  [484] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(713),
  [487] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(7318),
  [490] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(7356),
  [493] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(36),
  [496] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(7354),
  [499] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(4310),
  [502] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(7148),
  [505] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(3788),
  [508] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(2639),
  [511] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(3948),
  [514] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(2920),
  [517] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(8500),
  [520] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(1199),
  [523] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(4255),
  [526] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(1199),
  [529] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(1202),
  [532] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(3042),
  [535] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(2725),
  [538] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(2753),
  [541] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(5430),
  [544] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(9432),
  [547] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(9433),
  [550] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(124),
  [553] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(9702),
  [556] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(9915),
  [559] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(9703),
  [562] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(2805),
  [565] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(8746),
  [568] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(4252),
  [571] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(847),
  [574] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(8880),
  [577] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(358),
  [580] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(9668),
  [583] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(701),
  [586] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(9704),
  [589] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(267),
  [592] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(2372),
  [595] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(7828),
  [598] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(5132),
  [601] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(9701),
  [604] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(9821),
  [607] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(9814),
  [610] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(9809),
  [613] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(9808),
  [616] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(4217),
  [619] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(8740),
  [622] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(4217),
  [625] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(6202),
  [628] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0),
  [630] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(9920),
  [633] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(9918),
  [636] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(9917),
  [639] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_else_in_top_level, 2, 0, 0),
  [641] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_else_in_top_level, 1, 0, 0),
  [643] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4533),
  [645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2702),
  [647] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3088),
  [649] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4341),
  [651] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4531),
  [653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(517),
  [655] = {.entry = {.count = 1, .reusable = false}}, SHIFT(913),
  [657] = {.entry = {.count = 1, .reusable = false}}, SHIFT(879),
  [659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(25),
  [661] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_section, 3, 0, 0),
  [663] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7950),
  [665] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2680),
  [667] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4537),
  [669] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3089),
  [671] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8499),
  [673] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9422),
  [675] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9410),
  [677] = {.entry = {.count = 1, .reusable = false}}, SHIFT(74),
  [679] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9411),
  [681] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9872),
  [683] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9412),
  [685] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2830),
  [687] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8915),
  [689] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_section, 3, 0, 0),
  [691] = {.entry = {.count = 1, .reusable = false}}, SHIFT(794),
  [693] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8882),
  [695] = {.entry = {.count = 1, .reusable = false}}, SHIFT(361),
  [697] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9930),
  [699] = {.entry = {.count = 1, .reusable = false}}, SHIFT(651),
  [701] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9413),
  [703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6163),
  [705] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(2733),
  [708] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(4533),
  [711] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(2732),
  [714] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(2702),
  [717] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(3088),
  [720] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(4341),
  [723] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(4531),
  [726] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(517),
  [729] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(556),
  [732] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(913),
  [735] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(879),
  [738] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(25),
  [741] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0),
  [743] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(7950),
  [746] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(2680),
  [749] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(4537),
  [752] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(3089),
  [755] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(8499),
  [758] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(1199),
  [761] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(4255),
  [764] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(1199),
  [767] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(1202),
  [770] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(3042),
  [773] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(2725),
  [776] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(2753),
  [779] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(5430),
  [782] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(9422),
  [785] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(9410),
  [788] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(74),
  [791] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(9411),
  [794] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(9872),
  [797] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(9412),
  [800] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(2830),
  [803] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(8915),
  [806] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0),
  [808] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(4252),
  [811] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(794),
  [814] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(8882),
  [817] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(361),
  [820] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(9930),
  [823] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(651),
  [826] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(9413),
  [829] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(267),
  [832] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(2372),
  [835] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(7828),
  [838] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(5132),
  [841] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(9701),
  [844] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(9821),
  [847] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(9814),
  [850] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(9809),
  [853] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(9808),
  [856] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(4217),
  [859] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(8740),
  [862] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(4217),
  [865] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(6163),
  [868] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(9920),
  [871] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(9918),
  [874] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(9917),
  [877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9456),
  [879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(553),
  [881] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1094),
  [883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6682),
  [885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2032),
  [887] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2032),
  [889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1827),
  [891] = {.entry = {.count = 1, .reusable = false}}, SHIFT(903),
  [893] = {.entry = {.count = 1, .reusable = false}}, SHIFT(366),
  [895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(241),
  [897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2197),
  [899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3743),
  [901] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_section, 5, 0, 0),
  [903] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_section, 5, 0, 0),
  [905] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_section, 2, 0, 0),
  [907] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_section, 2, 0, 0),
  [909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9667),
  [911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3703),
  [913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2195),
  [915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9341),
  [917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4655),
  [919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9453),
  [921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5595),
  [923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9914),
  [925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4136),
  [927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9759),
  [929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4064),
  [931] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_section, 4, 0, 0),
  [933] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_section, 4, 0, 0),
  [935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2192),
  [937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4540),
  [939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4044),
  [941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5440),
  [943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2637),
  [945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3644),
  [947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4320),
  [949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4321),
  [951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4071),
  [953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4070),
  [955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3528),
  [957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3642),
  [959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3530),
  [961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2274),
  [963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4651),
  [965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2237),
  [967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4045),
  [969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2206),
  [971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3225),
  [973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5558),
  [975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3230),
  [977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2205),
  [979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2638),
  [981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8874),
  [983] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3100),
  [985] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4374),
  [987] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1115),
  [989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(24),
  [991] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4622),
  [993] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8463),
  [995] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9893),
  [997] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9890),
  [999] = {.entry = {.count = 1, .reusable = false}}, SHIFT(67),
  [1001] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9630),
  [1003] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9903),
  [1005] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9631),
  [1007] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2864),
  [1009] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8727),
  [1011] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1114),
  [1013] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8694),
  [1015] = {.entry = {.count = 1, .reusable = false}}, SHIFT(359),
  [1017] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9725),
  [1019] = {.entry = {.count = 1, .reusable = false}}, SHIFT(693),
  [1021] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9632),
  [1023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6147),
  [1025] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3082),
  [1027] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4429),
  [1029] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4697),
  [1031] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3104),
  [1033] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4365),
  [1035] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4520),
  [1037] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6917),
  [1039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(187),
  [1041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4961),
  [1043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(216),
  [1045] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9565),
  [1047] = {.entry = {.count = 1, .reusable = false}}, SHIFT(716),
  [1049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(299),
  [1051] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4430),
  [1053] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1931),
  [1055] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1036),
  [1057] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9561),
  [1059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1411),
  [1061] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1411),
  [1063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1931),
  [1065] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2726),
  [1067] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2745),
  [1069] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1489),
  [1071] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1495),
  [1073] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4289),
  [1075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(271),
  [1077] = {.entry = {.count = 1, .reusable = false}}, SHIFT(438),
  [1079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6129),
  [1081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4611),
  [1083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(257),
  [1085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(186),
  [1087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2959),
  [1089] = {.entry = {.count = 1, .reusable = false}}, SHIFT(608),
  [1091] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4339),
  [1093] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6773),
  [1095] = {.entry = {.count = 1, .reusable = false}}, SHIFT(602),
  [1097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1679),
  [1099] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1679),
  [1101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1236),
  [1103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2769),
  [1105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2723),
  [1107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5353),
  [1109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1232),
  [1111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1231),
  [1113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8336),
  [1115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(239),
  [1117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(405),
  [1119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4286),
  [1121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(249),
  [1123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4010),
  [1125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(250),
  [1127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6783),
  [1129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5389),
  [1131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(248),
  [1133] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_range_expression, 2, 0, 0),
  [1135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(520),
  [1137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(543),
  [1139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(940),
  [1141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(638),
  [1143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8178),
  [1145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4403),
  [1147] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_range_expression, 2, 0, 0),
  [1149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9782),
  [1151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1771),
  [1153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1771),
  [1155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4001),
  [1157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1769),
  [1159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3183),
  [1161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6892),
  [1163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3984),
  [1165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1614),
  [1167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1618),
  [1169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(192),
  [1171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7859),
  [1173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5109),
  [1175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9751),
  [1177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9752),
  [1179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9779),
  [1181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9780),
  [1183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9480),
  [1185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3982),
  [1187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8950),
  [1189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3982),
  [1191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6233),
  [1193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9459),
  [1195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9457),
  [1197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9451),
  [1199] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_range_expression, 1, 0, 0),
  [1201] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_range_expression, 1, 0, 0),
  [1203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(215),
  [1205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3527),
  [1207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2936),
  [1209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3160),
  [1211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(515),
  [1213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(573),
  [1215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1035),
  [1217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(675),
  [1219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7929),
  [1221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4368),
  [1223] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9640),
  [1225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1258),
  [1227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1258),
  [1229] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3697),
  [1231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1391),
  [1233] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3006),
  [1235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6890),
  [1237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3695),
  [1239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1306),
  [1241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1304),
  [1243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(222),
  [1245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7893),
  [1247] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5115),
  [1249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9415),
  [1251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9416),
  [1253] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9635),
  [1255] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9636),
  [1257] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9695),
  [1259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3693),
  [1261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8720),
  [1263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3693),
  [1265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6151),
  [1267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9132),
  [1269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9131),
  [1271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9129),
  [1273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(189),
  [1275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(616),
  [1277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1859),
  [1279] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2756),
  [1281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1573),
  [1283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1572),
  [1285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(324),
  [1287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3526),
  [1289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(519),
  [1291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(568),
  [1293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1126),
  [1295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(681),
  [1297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7946),
  [1299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4428),
  [1301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9757),
  [1303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1415),
  [1305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3420),
  [1307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2156),
  [1309] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2155),
  [1311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(226),
  [1313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5129),
  [1315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9753),
  [1317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9754),
  [1319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9647),
  [1321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6215),
  [1323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(561),
  [1325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(797),
  [1327] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1775),
  [1329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1775),
  [1331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1776),
  [1333] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1858),
  [1335] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1857),
  [1337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(228),
  [1339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(523),
  [1341] = {.entry = {.count = 1, .reusable = false}}, SHIFT(843),
  [1343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1692),
  [1345] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1648),
  [1347] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1647),
  [1349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(229),
  [1351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(576),
  [1353] = {.entry = {.count = 1, .reusable = false}}, SHIFT(963),
  [1355] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1793),
  [1357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1793),
  [1359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1269),
  [1361] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1498),
  [1363] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1502),
  [1365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(230),
  [1367] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2792),
  [1369] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2784),
  [1371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(518),
  [1373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(558),
  [1375] = {.entry = {.count = 1, .reusable = false}}, SHIFT(832),
  [1377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(704),
  [1379] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8156),
  [1381] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4337),
  [1383] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9712),
  [1385] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1607),
  [1387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1607),
  [1389] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5427),
  [1391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2037),
  [1393] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3911),
  [1395] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2739),
  [1397] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2816),
  [1399] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6883),
  [1401] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5742),
  [1403] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2063),
  [1405] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2064),
  [1407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(235),
  [1409] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2722),
  [1411] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7886),
  [1413] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5162),
  [1415] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9705),
  [1417] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9706),
  [1419] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9707),
  [1421] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9708),
  [1423] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9664),
  [1425] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5740),
  [1427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8876),
  [1429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5740),
  [1431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6204),
  [1433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9800),
  [1435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9799),
  [1437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9797),
  [1439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(525),
  [1441] = {.entry = {.count = 1, .reusable = false}}, SHIFT(761),
  [1443] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4381),
  [1445] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1592),
  [1447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1592),
  [1449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1999),
  [1451] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2120),
  [1453] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2092),
  [1455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(236),
  [1457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(516),
  [1459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(554),
  [1461] = {.entry = {.count = 1, .reusable = false}}, SHIFT(996),
  [1463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(673),
  [1465] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4351),
  [1467] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1845),
  [1469] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1846),
  [1471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(245),
  [1473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(570),
  [1475] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1086),
  [1477] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1725),
  [1479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1725),
  [1481] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1826),
  [1483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1826),
  [1485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(563),
  [1487] = {.entry = {.count = 1, .reusable = false}}, SHIFT(862),
  [1489] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1720),
  [1491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1720),
  [1493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1554),
  [1495] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2093),
  [1497] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2094),
  [1499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(242),
  [1501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(540),
  [1503] = {.entry = {.count = 1, .reusable = false}}, SHIFT(975),
  [1505] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4422),
  [1507] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1687),
  [1509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1687),
  [1511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1744),
  [1513] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1461),
  [1515] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1460),
  [1517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(246),
  [1519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(541),
  [1521] = {.entry = {.count = 1, .reusable = false}}, SHIFT(827),
  [1523] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4389),
  [1525] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1988),
  [1527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1988),
  [1529] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2070),
  [1531] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2075),
  [1533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(270),
  [1535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(551),
  [1537] = {.entry = {.count = 1, .reusable = false}}, SHIFT(776),
  [1539] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1782),
  [1541] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1781),
  [1543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(251),
  [1545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(542),
  [1547] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1080),
  [1549] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1714),
  [1551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1714),
  [1553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1746),
  [1555] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1282),
  [1557] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1281),
  [1559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(253),
  [1561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(547),
  [1563] = {.entry = {.count = 1, .reusable = false}}, SHIFT(954),
  [1565] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1830),
  [1567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1830),
  [1569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1824),
  [1571] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1393),
  [1573] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1394),
  [1575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(266),
  [1577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(569),
  [1579] = {.entry = {.count = 1, .reusable = false}}, SHIFT(981),
  [1581] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2035),
  [1583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2035),
  [1585] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1351),
  [1587] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1356),
  [1589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(264),
  [1591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(538),
  [1593] = {.entry = {.count = 1, .reusable = false}}, SHIFT(918),
  [1595] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1995),
  [1597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1995),
  [1599] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2176),
  [1601] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2180),
  [1603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(256),
  [1605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(514),
  [1607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(552),
  [1609] = {.entry = {.count = 1, .reusable = false}}, SHIFT(722),
  [1611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(663),
  [1613] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8162),
  [1615] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4415),
  [1617] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9427),
  [1619] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1975),
  [1621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1975),
  [1623] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4628),
  [1625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1792),
  [1627] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3560),
  [1629] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6882),
  [1631] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4542),
  [1633] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1973),
  [1635] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1974),
  [1637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(265),
  [1639] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7791),
  [1641] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5133),
  [1643] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9633),
  [1645] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9634),
  [1647] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9417),
  [1649] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9418),
  [1651] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9931),
  [1653] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4543),
  [1655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8748),
  [1657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4543),
  [1659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6155),
  [1661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9816),
  [1663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9819),
  [1665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9823),
  [1667] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1843),
  [1669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1843),
  [1671] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2023),
  [1673] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2022),
  [1675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(574),
  [1677] = {.entry = {.count = 1, .reusable = false}}, SHIFT(735),
  [1679] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4366),
  [1681] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1969),
  [1683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1969),
  [1685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1734),
  [1687] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2175),
  [1689] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2177),
  [1691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(276),
  [1693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(534),
  [1695] = {.entry = {.count = 1, .reusable = false}}, SHIFT(780),
  [1697] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1810),
  [1699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1810),
  [1701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1811),
  [1703] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1651),
  [1705] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1655),
  [1707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(273),
  [1709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(575),
  [1711] = {.entry = {.count = 1, .reusable = false}}, SHIFT(844),
  [1713] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4407),
  [1715] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1807),
  [1717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1807),
  [1719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1788),
  [1721] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1617),
  [1723] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1616),
  [1725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(268),
  [1727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(560),
  [1729] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1123),
  [1731] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1777),
  [1733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1777),
  [1735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1774),
  [1737] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2105),
  [1739] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2104),
  [1741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(275),
  [1743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(559),
  [1745] = {.entry = {.count = 1, .reusable = false}}, SHIFT(813),
  [1747] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1500),
  [1749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1500),
  [1751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1676),
  [1753] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1871),
  [1755] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1870),
  [1757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(277),
  [1759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(564),
  [1761] = {.entry = {.count = 1, .reusable = false}}, SHIFT(955),
  [1763] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4412),
  [1765] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1780),
  [1767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1780),
  [1769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1798),
  [1771] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1361),
  [1773] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1373),
  [1775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(279),
  [1777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(545),
  [1779] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1064),
  [1781] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4375),
  [1783] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1821),
  [1785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1821),
  [1787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1819),
  [1789] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1204),
  [1791] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1205),
  [1793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(280),
  [1795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(546),
  [1797] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1113),
  [1799] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4338),
  [1801] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1981),
  [1803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1981),
  [1805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2031),
  [1807] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1947),
  [1809] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1948),
  [1811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(281),
  [1813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(530),
  [1815] = {.entry = {.count = 1, .reusable = false}}, SHIFT(869),
  [1817] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4414),
  [1819] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1790),
  [1821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1790),
  [1823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1805),
  [1825] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1532),
  [1827] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1535),
  [1829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(283),
  [1831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(539),
  [1833] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1081),
  [1835] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4364),
  [1837] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1818),
  [1839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1818),
  [1841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1815),
  [1843] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1268),
  [1845] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1267),
  [1847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(284),
  [1849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(555),
  [1851] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1085),
  [1853] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4406),
  [1855] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1423),
  [1857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1423),
  [1859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1717),
  [1861] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1541),
  [1863] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1512),
  [1865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(293),
  [1867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(550),
  [1869] = {.entry = {.count = 1, .reusable = false}}, SHIFT(977),
  [1871] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4419),
  [1873] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1682),
  [1875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1682),
  [1877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1808),
  [1879] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1445),
  [1881] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1444),
  [1883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(287),
  [1885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(557),
  [1887] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1065),
  [1889] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4405),
  [1891] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1747),
  [1893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1747),
  [1895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1772),
  [1897] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1189),
  [1899] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1190),
  [1901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(289),
  [1903] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_list_pattern_repeat1, 2, 0, 0),
  [1905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(577),
  [1907] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1110),
  [1909] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1813),
  [1911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1813),
  [1913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1791),
  [1915] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1160),
  [1917] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1159),
  [1919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(296),
  [1921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9035),
  [1923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(198),
  [1925] = {.entry = {.count = 1, .reusable = false}}, SHIFT(760),
  [1927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4698),
  [1929] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1972),
  [1931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1972),
  [1933] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2771),
  [1935] = {.entry = {.count = 1, .reusable = false}}, SHIFT(469),
  [1937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2674),
  [1939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(526),
  [1941] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_default_expression, 1, 0, 0),
  [1943] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_default_expression, 1, 0, 0),
  [1945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9028),
  [1947] = {.entry = {.count = 1, .reusable = false}}, SHIFT(901),
  [1949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3152),
  [1951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2285),
  [1953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8981),
  [1955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3688),
  [1957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9153),
  [1959] = {.entry = {.count = 1, .reusable = false}}, SHIFT(820),
  [1961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3515),
  [1963] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_default_expression, 4, 0, 15),
  [1965] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_default_expression, 4, 0, 15),
  [1967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9594),
  [1969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5604),
  [1971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9444),
  [1973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3004),
  [1975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9568),
  [1977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3517),
  [1979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(565),
  [1981] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1023),
  [1983] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1968),
  [1985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1968),
  [1987] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1992),
  [1989] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1991),
  [1991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(319),
  [1993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(548),
  [1995] = {.entry = {.count = 1, .reusable = false}}, SHIFT(851),
  [1997] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1916),
  [1999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1916),
  [2001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8835),
  [2003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(571),
  [2005] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1109),
  [2007] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1392),
  [2009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1392),
  [2011] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1786),
  [2013] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1785),
  [2015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(310),
  [2017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9709),
  [2019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4058),
  [2021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8982),
  [2023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3542),
  [2025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9871),
  [2027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4138),
  [2029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2444),
  [2031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(528),
  [2033] = {.entry = {.count = 1, .reusable = false}}, SHIFT(861),
  [2035] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1773),
  [2037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1773),
  [2039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1748),
  [2041] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1563),
  [2043] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1565),
  [2045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(323),
  [2047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(535),
  [2049] = {.entry = {.count = 1, .reusable = false}}, SHIFT(724),
  [2051] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1745),
  [2053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1745),
  [2055] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2048),
  [2057] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2050),
  [2059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(322),
  [2061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9391),
  [2063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3762),
  [2065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9584),
  [2067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2984),
  [2069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(532),
  [2071] = {.entry = {.count = 1, .reusable = false}}, SHIFT(886),
  [2073] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1731),
  [2075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1731),
  [2077] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1899),
  [2079] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1898),
  [2081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(343),
  [2083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3729),
  [2085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3761),
  [2087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3621),
  [2089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3513),
  [2091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3660),
  [2093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4606),
  [2095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5465),
  [2097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(524),
  [2099] = {.entry = {.count = 1, .reusable = false}}, SHIFT(947),
  [2101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4361),
  [2103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1741),
  [2105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1741),
  [2107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1726),
  [2109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1416),
  [2111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1417),
  [2113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(346),
  [2115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(537),
  [2117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(798),
  [2119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4376),
  [2121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1760),
  [2123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1760),
  [2125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1740),
  [2127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1691),
  [2129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1688),
  [2131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(334),
  [2133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4104),
  [2135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3516),
  [2137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3980),
  [2139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(527),
  [2141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1118),
  [2143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1580),
  [2145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1580),
  [2147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2067),
  [2149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2068),
  [2151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(339),
  [2153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(521),
  [2155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(987),
  [2157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4425),
  [2159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1237),
  [2161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1237),
  [2163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1579),
  [2165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1385),
  [2167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1384),
  [2169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(349),
  [2171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4546),
  [2173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4135),
  [2175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(566),
  [2177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(922),
  [2179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4410),
  [2181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1784),
  [2183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1784),
  [2185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1779),
  [2187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1497),
  [2189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1496),
  [2191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(345),
  [2193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(544),
  [2195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1054),
  [2197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4342),
  [2199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1738),
  [2201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1738),
  [2203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1721),
  [2205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1272),
  [2207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1273),
  [2209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(351),
  [2211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5438),
  [2213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3005),
  [2215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(567),
  [2217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1045),
  [2219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4411),
  [2221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1794),
  [2223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1794),
  [2225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1783),
  [2227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1312),
  [2229] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1311),
  [2231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(355),
  [2233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2990),
  [2235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3972),
  [2237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3097),
  [2239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3085),
  [2241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9652),
  [2243] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3086),
  [2245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9672),
  [2247] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3084),
  [2249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9398),
  [2251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3107),
  [2253] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9935),
  [2255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4254),
  [2257] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1121),
  [2259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(295),
  [2261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4117),
  [2263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(763),
  [2265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2731),
  [2267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4039),
  [2269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5445),
  [2271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4522),
  [2273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4956),
  [2275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5423),
  [2277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4585),
  [2279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5006),
  [2281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4016),
  [2283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(188),
  [2285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(197),
  [2287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(935),
  [2289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(305),
  [2291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1892),
  [2293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1892),
  [2295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2724),
  [2297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2728),
  [2299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2962),
  [2301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3952),
  [2303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(496),
  [2305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(202),
  [2307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2017),
  [2309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2017),
  [2311] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2730),
  [2313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2963),
  [2315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(459),
  [2317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(207),
  [2319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(771),
  [2321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(312),
  [2323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1743),
  [2325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1743),
  [2327] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2735),
  [2329] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2764),
  [2331] = {.entry = {.count = 1, .reusable = false}}, SHIFT(377),
  [2333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(209),
  [2335] = {.entry = {.count = 1, .reusable = false}}, SHIFT(378),
  [2337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(185),
  [2339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(210),
  [2341] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1694),
  [2343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1694),
  [2345] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2766),
  [2347] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3522),
  [2349] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4709),
  [2351] = {.entry = {.count = 1, .reusable = false}}, SHIFT(389),
  [2353] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1031),
  [2355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(199),
  [2357] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1330),
  [2359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1330),
  [2361] = {.entry = {.count = 1, .reusable = false}}, SHIFT(381),
  [2363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(200),
  [2365] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1917),
  [2367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1917),
  [2369] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2768),
  [2371] = {.entry = {.count = 1, .reusable = false}}, SHIFT(450),
  [2373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(212),
  [2375] = {.entry = {.count = 1, .reusable = false}}, SHIFT(757),
  [2377] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2164),
  [2379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2164),
  [2381] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2727),
  [2383] = {.entry = {.count = 1, .reusable = false}}, SHIFT(497),
  [2385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(195),
  [2387] = {.entry = {.count = 1, .reusable = false}}, SHIFT(388),
  [2389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(203),
  [2391] = {.entry = {.count = 1, .reusable = false}}, SHIFT(924),
  [2393] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2770),
  [2395] = {.entry = {.count = 1, .reusable = false}}, SHIFT(439),
  [2397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(219),
  [2399] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1490),
  [2401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1490),
  [2403] = {.entry = {.count = 1, .reusable = false}}, SHIFT(391),
  [2405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(208),
  [2407] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1166),
  [2409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1166),
  [2411] = {.entry = {.count = 1, .reusable = false}}, SHIFT(406),
  [2413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(220),
  [2415] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1305),
  [2417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1305),
  [2419] = {.entry = {.count = 1, .reusable = false}}, SHIFT(427),
  [2421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(194),
  [2423] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1538),
  [2425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1538),
  [2427] = {.entry = {.count = 1, .reusable = false}}, SHIFT(467),
  [2429] = {.entry = {.count = 1, .reusable = false}}, SHIFT(904),
  [2431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(206),
  [2433] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1345),
  [2435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1345),
  [2437] = {.entry = {.count = 1, .reusable = false}}, SHIFT(425),
  [2439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(221),
  [2441] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1156),
  [2443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1156),
  [2445] = {.entry = {.count = 1, .reusable = false}}, SHIFT(444),
  [2447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(190),
  [2449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(201),
  [2451] = {.entry = {.count = 1, .reusable = false}}, SHIFT(944),
  [2453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(306),
  [2455] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8045),
  [2457] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1459),
  [2459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1459),
  [2461] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2729),
  [2463] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2757),
  [2465] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3411),
  [2467] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5385),
  [2469] = {.entry = {.count = 1, .reusable = false}}, SHIFT(415),
  [2471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(217),
  [2473] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2172),
  [2475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2172),
  [2477] = {.entry = {.count = 1, .reusable = false}}, SHIFT(487),
  [2479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(204),
  [2481] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1203),
  [2483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1203),
  [2485] = {.entry = {.count = 1, .reusable = false}}, SHIFT(423),
  [2487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(213),
  [2489] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2077),
  [2491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2077),
  [2493] = {.entry = {.count = 1, .reusable = false}}, SHIFT(507),
  [2495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(184),
  [2497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(211),
  [2499] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1594),
  [2501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1594),
  [2503] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2772),
  [2505] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3537),
  [2507] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4988),
  [2509] = {.entry = {.count = 1, .reusable = false}}, SHIFT(471),
  [2511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(214),
  [2513] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1593),
  [2515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1593),
  [2517] = {.entry = {.count = 1, .reusable = false}}, SHIFT(484),
  [2519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(205),
  [2521] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2169),
  [2523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2169),
  [2525] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2780),
  [2527] = {.entry = {.count = 1, .reusable = false}}, SHIFT(458),
  [2529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(196),
  [2531] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1491),
  [2533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1491),
  [2535] = {.entry = {.count = 1, .reusable = false}}, SHIFT(470),
  [2537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(193),
  [2539] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1355),
  [2541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1355),
  [2543] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2775),
  [2545] = {.entry = {.count = 1, .reusable = false}}, SHIFT(468),
  [2547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(218),
  [2549] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1681),
  [2551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1681),
  [2553] = {.entry = {.count = 1, .reusable = false}}, SHIFT(475),
  [2555] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9425),
  [2557] = {.entry = {.count = 1, .reusable = false}}, SHIFT(662),
  [2559] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9566),
  [2561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7999),
  [2563] = {.entry = {.count = 1, .reusable = false}}, SHIFT(598),
  [2565] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2778),
  [2567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3929),
  [2569] = {.entry = {.count = 1, .reusable = false}}, SHIFT(640),
  [2571] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2863),
  [2573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3892),
  [2575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5358),
  [2577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3576),
  [2579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4446),
  [2581] = {.entry = {.count = 1, .reusable = false}}, SHIFT(660),
  [2583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4042),
  [2585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(998),
  [2587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6125),
  [2589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4675),
  [2591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5383),
  [2593] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_expression, 3, 0, 37),
  [2595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4112),
  [2597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3709),
  [2599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3737),
  [2601] = {.entry = {.count = 1, .reusable = false}}, SHIFT(758),
  [2603] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__parameter_type_with_modifiers_repeat1, 1, 0, 1),
  [2605] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1018),
  [2607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(697),
  [2609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3907),
  [2611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9900),
  [2613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4208),
  [2615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9731),
  [2617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3941),
  [2619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3985),
  [2621] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__parameter_type_with_modifiers_repeat1, 1, 0, 1),
  [2623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5360),
  [2625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3512),
  [2627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9213),
  [2629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4595),
  [2631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2971),
  [2633] = {.entry = {.count = 1, .reusable = false}}, SHIFT(679),
  [2635] = {.entry = {.count = 1, .reusable = false}}, SHIFT(854),
  [2637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9465),
  [2639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3747),
  [2641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9269),
  [2643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3671),
  [2645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5262),
  [2647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9531),
  [2649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5674),
  [2651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3610),
  [2653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3629),
  [2655] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7236),
  [2657] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7159),
  [2659] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7206),
  [2661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3702),
  [2663] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7176),
  [2665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3630),
  [2667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3998),
  [2669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4029),
  [2671] = {.entry = {.count = 1, .reusable = false}}, SHIFT(939),
  [2673] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2763),
  [2675] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7137),
  [2677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3956),
  [2679] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7150),
  [2681] = {.entry = {.count = 1, .reusable = false}}, SHIFT(952),
  [2683] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4757),
  [2685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(923),
  [2687] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7160),
  [2689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(858),
  [2691] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7277),
  [2693] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4722),
  [2695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2682),
  [2697] = {.entry = {.count = 1, .reusable = false}}, SHIFT(863),
  [2699] = {.entry = {.count = 1, .reusable = false}}, SHIFT(298),
  [2701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4093),
  [2703] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7192),
  [2705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4100),
  [2707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4586),
  [2709] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7134),
  [2711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3772),
  [2713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(814),
  [2715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3625),
  [2717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(866),
  [2719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4215),
  [2721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3742),
  [2723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8851),
  [2725] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1091),
  [2727] = {.entry = {.count = 1, .reusable = false}}, SHIFT(309),
  [2729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4526),
  [2731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3740),
  [2733] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_array_rank_specifier_repeat1, 1, 0, 0),
  [2735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4590),
  [2737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8914),
  [2739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2252),
  [2741] = {.entry = {.count = 1, .reusable = false}}, SHIFT(762),
  [2743] = {.entry = {.count = 1, .reusable = false}}, SHIFT(300),
  [2745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5682),
  [2747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2433),
  [2749] = {.entry = {.count = 1, .reusable = false}}, SHIFT(934),
  [2751] = {.entry = {.count = 1, .reusable = false}}, SHIFT(315),
  [2753] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7334),
  [2755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5505),
  [2757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5561),
  [2759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(31),
  [2761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(33),
  [2763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5644),
  [2765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(26),
  [2767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(29),
  [2769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5545),
  [2771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(101),
  [2773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(32),
  [2775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3727),
  [2777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(178),
  [2779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(176),
  [2781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(147),
  [2783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(143),
  [2785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3755),
  [2787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(160),
  [2789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(536),
  [2791] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4868),
  [2793] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2743),
  [2795] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4911),
  [2797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(79),
  [2799] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2838),
  [2801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(70),
  [2803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(107),
  [2805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(109),
  [2807] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4772),
  [2809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(136),
  [2811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(141),
  [2813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2679),
  [2815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2234),
  [2817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(752),
  [2819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4567),
  [2821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(76),
  [2823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(71),
  [2825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1120),
  [2827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1028),
  [2829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1017),
  [2831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(993),
  [2833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(34),
  [2835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4661),
  [2837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2249),
  [2839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(808),
  [2841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(732),
  [2843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4179),
  [2845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(744),
  [2847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4110),
  [2849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2645),
  [2851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(754),
  [2853] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4752),
  [2855] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2836),
  [2857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(790),
  [2859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(533),
  [2861] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4768),
  [2863] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2786),
  [2865] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3308),
  [2867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(766),
  [2869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(98),
  [2871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(161),
  [2873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(163),
  [2875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(114),
  [2877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(118),
  [2879] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_else_in_expression, 1, 0, 0),
  [2881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4022),
  [2883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4033),
  [2885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(130),
  [2887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(131),
  [2889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(157),
  [2891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3710),
  [2893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3645),
  [2895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8854),
  [2897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8867),
  [2899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(180),
  [2901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(183),
  [2903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(967),
  [2905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2442),
  [2907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2496),
  [2909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(529),
  [2911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(549),
  [2913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(522),
  [2915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(562),
  [2917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(572),
  [2919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(531),
  [2921] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 2, 0, 0),
  [2923] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 2, 0, 0),
  [2925] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_initializer_expression, 2, 0, 0),
  [2927] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initializer_expression, 2, 0, 0),
  [2929] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_top_level, 4, 0, 37),
  [2931] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_top_level, 4, 0, 37),
  [2933] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_expression, 4, 0, 37),
  [2935] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_expression, 4, 0, 37),
  [2937] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 3, 0, 7),
  [2939] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 3, 0, 7),
  [2941] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7900),
  [2943] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8831),
  [2945] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 2, 0, 7),
  [2947] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 2, 0, 7),
  [2949] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_try_statement_repeat1, 2, 0, 0),
  [2951] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_try_statement_repeat1, 2, 0, 0),
  [2953] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_try_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7900),
  [2956] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7826),
  [2958] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8920),
  [2960] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_try_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7826),
  [2963] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 2, 0, 7),
  [2965] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 2, 0, 7),
  [2967] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 3, 0, 0),
  [2969] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 3, 0, 0),
  [2971] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 3, 0, 55),
  [2973] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 3, 0, 55),
  [2975] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_try_statement_repeat1, 1, 0, 0),
  [2977] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_try_statement_repeat1, 1, 0, 0),
  [2979] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 4, 0, 77),
  [2981] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 4, 0, 77),
  [2983] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4443),
  [2985] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3779),
  [2987] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4433),
  [2989] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6730),
  [2991] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6771),
  [2993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5654),
  [2995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4639),
  [2997] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4704),
  [2999] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6842),
  [3001] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7303),
  [3003] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4459),
  [3005] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7310),
  [3007] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7312),
  [3009] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7313),
  [3011] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4563),
  [3013] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7132),
  [3015] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3414),
  [3017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7301),
  [3019] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6743),
  [3021] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4541),
  [3023] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4744),
  [3025] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5237),
  [3027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6090),
  [3029] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif, 4, 0, 37),
  [3031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2557),
  [3033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6213),
  [3035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3356),
  [3037] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif, 3, 0, 37),
  [3039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3330),
  [3041] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_checked_statement, 2, 0, 0),
  [3043] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_checked_statement, 2, 0, 0),
  [3045] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_local_declaration_statement, 2, 0, 0),
  [3047] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_local_declaration_statement, 2, 0, 0),
  [3049] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 10, 0, 205),
  [3051] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 10, 0, 205),
  [3053] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_foreach_statement, 9, 0, 181),
  [3055] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_foreach_statement, 9, 0, 181),
  [3057] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 9, 0, 180),
  [3059] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 9, 0, 180),
  [3061] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 9, 0, 179),
  [3063] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 9, 0, 179),
  [3065] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement, 1, 0, 0),
  [3067] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement, 1, 0, 0),
  [3069] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 9, 0, 178),
  [3071] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 9, 0, 178),
  [3073] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 9, 0, 177),
  [3075] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 9, 0, 177),
  [3077] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 9, 0, 176),
  [3079] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 9, 0, 176),
  [3081] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_local_function_statement, 8, 0, 150),
  [3083] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_local_function_statement, 8, 0, 150),
  [3085] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_foreach_statement, 8, 0, 144),
  [3087] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_foreach_statement, 8, 0, 144),
  [3089] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_foreach_statement, 8, 0, 143),
  [3091] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_foreach_statement, 8, 0, 143),
  [3093] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_labeled_statement, 3, 0, 0),
  [3095] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_labeled_statement, 3, 0, 0),
  [3097] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 8, 0, 142),
  [3099] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 8, 0, 142),
  [3101] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 8, 0, 141),
  [3103] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 8, 0, 141),
  [3105] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unsafe_statement, 2, 0, 0),
  [3107] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unsafe_statement, 2, 0, 0),
  [3109] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_finally_clause, 2, 0, 0),
  [3111] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_finally_clause, 2, 0, 0),
  [3113] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4443),
  [3116] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3779),
  [3119] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4433),
  [3122] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(6730),
  [3125] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(6771),
  [3128] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3788),
  [3131] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(5654),
  [3134] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4639),
  [3137] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4704),
  [3140] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(6842),
  [3143] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7303),
  [3146] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4459),
  [3149] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7310),
  [3152] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7312),
  [3155] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0),
  [3157] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7313),
  [3160] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4563),
  [3163] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7132),
  [3166] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3414),
  [3169] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7301),
  [3172] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(6743),
  [3175] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4541),
  [3178] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4744),
  [3181] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(5237),
  [3184] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(6090),
  [3187] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 2, 0, 0),
  [3189] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 2, 0, 0),
  [3191] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 8, 0, 140),
  [3193] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 8, 0, 140),
  [3195] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 8, 0, 139),
  [3197] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 8, 0, 139),
  [3199] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 4, 0, 7),
  [3201] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 4, 0, 7),
  [3203] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 8, 0, 138),
  [3205] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 8, 0, 138),
  [3207] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_local_function_statement, 7, 0, 118),
  [3209] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_local_function_statement, 7, 0, 118),
  [3211] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_goto_statement, 4, 0, 0),
  [3213] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_goto_statement, 4, 0, 0),
  [3215] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_local_function_statement, 7, 0, 117),
  [3217] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_local_function_statement, 7, 0, 117),
  [3219] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_local_function_statement, 7, 0, 112),
  [3221] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_local_function_statement, 7, 0, 112),
  [3223] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 7, 0, 107),
  [3225] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 7, 0, 107),
  [3227] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_foreach_statement, 7, 0, 106),
  [3229] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_foreach_statement, 7, 0, 106),
  [3231] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_statement, 2, 0, 0),
  [3233] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_statement, 2, 0, 0),
  [3235] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 3, 0, 0),
  [3237] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 3, 0, 0),
  [3239] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue_statement, 2, 0, 0),
  [3241] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_statement, 2, 0, 0),
  [3243] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_throw_statement, 2, 0, 0),
  [3245] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_throw_statement, 2, 0, 0),
  [3247] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_body, 1, 0, 0),
  [3249] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_body, 1, 0, 0),
  [3251] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_empty_statement, 1, 0, 0),
  [3253] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_empty_statement, 1, 0, 0),
  [3255] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_goto_statement, 2, 0, 0),
  [3257] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_goto_statement, 2, 0, 0),
  [3259] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 7, 0, 105),
  [3261] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 7, 0, 105),
  [3263] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 7, 0, 104),
  [3265] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 7, 0, 104),
  [3267] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 10, 0, 206),
  [3269] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 10, 0, 206),
  [3271] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_body, 1, 0, 39),
  [3273] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_body, 1, 0, 39),
  [3275] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_local_function_statement, 4, 0, 40),
  [3277] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_local_function_statement, 4, 0, 40),
  [3279] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 7, 0, 103),
  [3281] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 7, 0, 103),
  [3283] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_statement, 7, 0, 102),
  [3285] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_statement, 7, 0, 102),
  [3287] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_local_declaration_statement, 4, 0, 0),
  [3289] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_local_declaration_statement, 4, 0, 0),
  [3291] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_local_function_statement, 6, 0, 88),
  [3293] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_local_function_statement, 6, 0, 88),
  [3295] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_statement, 2, 0, 0),
  [3297] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_statement, 2, 0, 0),
  [3299] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_local_function_statement, 6, 0, 87),
  [3301] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_local_function_statement, 6, 0, 87),
  [3303] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_local_function_statement, 6, 0, 86),
  [3305] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_local_function_statement, 6, 0, 86),
  [3307] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_using_statement, 5, 0, 46),
  [3309] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_using_statement, 5, 0, 46),
  [3311] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_fixed_statement, 5, 0, 0),
  [3313] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fixed_statement, 5, 0, 0),
  [3315] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 10, 0, 207),
  [3317] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 10, 0, 207),
  [3319] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 5, 0, 53),
  [3321] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 5, 0, 53),
  [3323] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_local_function_statement, 6, 0, 80),
  [3325] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_local_function_statement, 6, 0, 80),
  [3327] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_top_level, 6, 0, 79),
  [3329] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_top_level, 6, 0, 79),
  [3331] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_using_statement, 6, 0, 76),
  [3333] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_using_statement, 6, 0, 76),
  [3335] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_local_declaration_statement, 3, 0, 0),
  [3337] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_local_declaration_statement, 3, 0, 0),
  [3339] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 11, 0, 220),
  [3341] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 11, 0, 220),
  [3343] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 6, 0, 76),
  [3345] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 6, 0, 76),
  [3347] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_body, 2, 0, 39),
  [3349] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_body, 2, 0, 39),
  [3351] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_throw_statement, 3, 0, 0),
  [3353] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_throw_statement, 3, 0, 0),
  [3355] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lock_statement, 5, 0, 0),
  [3357] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lock_statement, 5, 0, 0),
  [3359] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_statement, 5, 0, 54),
  [3361] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_statement, 5, 0, 54),
  [3363] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_body, 3, 0, 0),
  [3365] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_body, 3, 0, 0),
  [3367] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yield_statement, 4, 0, 0),
  [3369] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield_statement, 4, 0, 0),
  [3371] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_goto_statement, 3, 0, 0),
  [3373] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_goto_statement, 3, 0, 0),
  [3375] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_statement, 3, 0, 20),
  [3377] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_statement, 3, 0, 20),
  [3379] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yield_statement, 3, 0, 0),
  [3381] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield_statement, 3, 0, 0),
  [3383] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_local_declaration_statement, 5, 0, 0),
  [3385] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_local_declaration_statement, 5, 0, 0),
  [3387] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_local_function_statement, 5, 0, 62),
  [3389] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_local_function_statement, 5, 0, 62),
  [3391] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 5, 0, 56),
  [3393] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 5, 0, 56),
  [3395] = {.entry = {.count = 1, .reusable = false}}, SHIFT(173),
  [3397] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_top_level, 5, 0, 57),
  [3399] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_top_level, 5, 0, 57),
  [3401] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_top_level, 5, 0, 37),
  [3403] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_top_level, 5, 0, 37),
  [3405] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_body, 2, 0, 0),
  [3407] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_body, 2, 0, 0),
  [3409] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_local_function_statement, 5, 0, 61),
  [3411] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_local_function_statement, 5, 0, 61),
  [3413] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_local_function_statement, 5, 0, 66),
  [3415] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_local_function_statement, 5, 0, 66),
  [3417] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, 0, 82),
  [3419] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, 0, 82),
  [3421] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 8, 0, 146),
  [3423] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 8, 0, 146),
  [3425] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 5, 0, 50),
  [3427] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 5, 0, 50),
  [3429] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 5, 0, 48),
  [3431] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 5, 0, 48),
  [3433] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 9, 0, 116),
  [3435] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 9, 0, 116),
  [3437] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_declaration, 5, 0, 48),
  [3439] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 5, 0, 48),
  [3441] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_declaration, 5, 0, 49),
  [3443] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 5, 0, 49),
  [3445] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, 0, 48),
  [3447] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, 0, 48),
  [3449] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delegate_declaration, 9, 0, 149),
  [3451] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delegate_declaration, 9, 0, 149),
  [3453] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 9, 0, 184),
  [3455] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 9, 0, 184),
  [3457] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_using_directive, 5, 0, 14),
  [3459] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_using_directive, 5, 0, 14),
  [3461] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_using_directive, 5, 0, 0),
  [3463] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_using_directive, 5, 0, 0),
  [3465] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_declaration, 10, 0, 208),
  [3467] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 10, 0, 208),
  [3469] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 10, 0, 85),
  [3471] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 10, 0, 85),
  [3473] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 10, 0, 208),
  [3475] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 10, 0, 208),
  [3477] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 10, 0, 208),
  [3479] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 10, 0, 208),
  [3481] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_declaration, 10, 0, 209),
  [3483] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 10, 0, 209),
  [3485] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 10, 0, 116),
  [3487] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 10, 0, 116),
  [3489] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 10, 0, 209),
  [3491] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 10, 0, 209),
  [3493] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_declaration, 9, 0, 183),
  [3495] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 9, 0, 183),
  [3497] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_declaration, 11, 0, 221),
  [3499] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 11, 0, 221),
  [3501] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_global_attribute, 5, 0, 0),
  [3503] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_global_attribute, 5, 0, 0),
  [3505] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 9, 0, 182),
  [3507] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 9, 0, 182),
  [3509] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 11, 0, 116),
  [3511] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 11, 0, 116),
  [3513] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 11, 0, 221),
  [3515] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 11, 0, 221),
  [3517] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 9, 0, 182),
  [3519] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 9, 0, 182),
  [3521] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_file_scoped_namespace_declaration, 3, 0, 14),
  [3523] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_file_scoped_namespace_declaration, 3, 0, 14),
  [3525] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 9, 0, 85),
  [3527] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 9, 0, 85),
  [3529] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_declaration, 9, 0, 182),
  [3531] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 9, 0, 182),
  [3533] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 9, 0, 175),
  [3535] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 9, 0, 175),
  [3537] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 9, 0, 175),
  [3539] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 9, 0, 175),
  [3541] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 4, 0, 35),
  [3543] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 4, 0, 35),
  [3545] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 4, 0, 14),
  [3547] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 4, 0, 14),
  [3549] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 4, 0, 35),
  [3551] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 4, 0, 35),
  [3553] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 4, 0, 35),
  [3555] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 4, 0, 35),
  [3557] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_declaration, 4, 0, 35),
  [3559] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 4, 0, 35),
  [3561] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, 0, 35),
  [3563] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, 0, 35),
  [3565] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_declaration, 4, 0, 35),
  [3567] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_declaration, 4, 0, 35),
  [3569] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 9, 0, 29),
  [3571] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 9, 0, 29),
  [3573] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_using_directive, 4, 0, 0),
  [3575] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_using_directive, 4, 0, 0),
  [3577] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_declaration, 9, 0, 175),
  [3579] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 9, 0, 175),
  [3581] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delegate_declaration, 5, 0, 52),
  [3583] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delegate_declaration, 5, 0, 52),
  [3585] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 5, 0, 29),
  [3587] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 5, 0, 29),
  [3589] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 5, 0, 49),
  [3591] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 5, 0, 49),
  [3593] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 8, 0, 147),
  [3595] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 8, 0, 147),
  [3597] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 5, 0, 14),
  [3599] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 5, 0, 14),
  [3601] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 5, 0, 48),
  [3603] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 5, 0, 48),
  [3605] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extern_alias_directive, 4, 0, 29),
  [3607] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extern_alias_directive, 4, 0, 29),
  [3609] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 1, 0, 0),
  [3611] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 1, 0, 0),
  [3613] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 8, 0, 116),
  [3615] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 8, 0, 116),
  [3617] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delegate_declaration, 8, 0, 115),
  [3619] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delegate_declaration, 8, 0, 115),
  [3621] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delegate_declaration, 8, 0, 149),
  [3623] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delegate_declaration, 8, 0, 149),
  [3625] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 8, 0, 145),
  [3627] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 8, 0, 145),
  [3629] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 8, 0, 148),
  [3631] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 8, 0, 148),
  [3633] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_declaration, 8, 0, 147),
  [3635] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 8, 0, 147),
  [3637] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 8, 0, 145),
  [3639] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 8, 0, 145),
  [3641] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 8, 0, 145),
  [3643] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 8, 0, 145),
  [3645] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, 0, 49),
  [3647] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, 0, 49),
  [3649] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 5, 0, 49),
  [3651] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 5, 0, 49),
  [3653] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 5, 0, 49),
  [3655] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 5, 0, 49),
  [3657] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_using_directive, 6, 0, 0),
  [3659] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_using_directive, 6, 0, 0),
  [3661] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 8, 0, 85),
  [3663] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 8, 0, 85),
  [3665] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delegate_declaration, 8, 0, 111),
  [3667] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delegate_declaration, 8, 0, 111),
  [3669] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_using_directive, 6, 0, 29),
  [3671] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_using_directive, 6, 0, 29),
  [3673] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 9, 0, 183),
  [3675] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 9, 0, 183),
  [3677] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_declaration, 8, 0, 145),
  [3679] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 8, 0, 145),
  [3681] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, 0, 70),
  [3683] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, 0, 70),
  [3685] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 8, 0, 137),
  [3687] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 8, 0, 137),
  [3689] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 8, 0, 136),
  [3691] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 8, 0, 136),
  [3693] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 8, 0, 14),
  [3695] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 8, 0, 14),
  [3697] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_declaration, 6, 0, 71),
  [3699] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 6, 0, 71),
  [3701] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_declaration, 6, 0, 70),
  [3703] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 6, 0, 70),
  [3705] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 6, 0, 73),
  [3707] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 6, 0, 73),
  [3709] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 8, 0, 137),
  [3711] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 8, 0, 137),
  [3713] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(4443),
  [3716] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(4433),
  [3719] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__reserved_identifier, 1, 0, 0),
  [3721] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__reserved_identifier, 1, 0, 0),
  [3723] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(4639),
  [3726] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4633),
  [3728] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9572),
  [3730] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(4541),
  [3733] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(4744),
  [3736] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 6, 0, 70),
  [3738] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 6, 0, 70),
  [3740] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delegate_declaration, 6, 0, 75),
  [3742] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delegate_declaration, 6, 0, 75),
  [3744] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delegate_declaration, 6, 0, 52),
  [3746] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delegate_declaration, 6, 0, 52),
  [3748] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_global_attribute, 7, 0, 0),
  [3750] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_global_attribute, 7, 0, 0),
  [3752] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 8, 0, 29),
  [3754] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 8, 0, 29),
  [3756] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_using_directive, 3, 0, 0),
  [3758] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_using_directive, 3, 0, 0),
  [3760] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 6, 0, 29),
  [3762] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 6, 0, 29),
  [3764] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 6, 0, 71),
  [3766] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 6, 0, 71),
  [3768] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 6, 0, 14),
  [3770] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 6, 0, 14),
  [3772] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_declaration, 8, 0, 136),
  [3774] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 8, 0, 136),
  [3776] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 6, 0, 70),
  [3778] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 6, 0, 70),
  [3780] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_declaration, 8, 0, 137),
  [3782] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 8, 0, 137),
  [3784] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 8, 0, 136),
  [3786] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 8, 0, 136),
  [3788] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_global_attribute, 6, 0, 0),
  [3790] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_global_attribute, 6, 0, 0),
  [3792] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 7, 0, 113),
  [3794] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 7, 0, 113),
  [3796] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 7, 0, 116),
  [3798] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 7, 0, 116),
  [3800] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delegate_declaration, 7, 0, 115),
  [3802] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delegate_declaration, 7, 0, 115),
  [3804] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, 0, 71),
  [3806] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, 0, 71),
  [3808] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_declaration, 6, 0, 82),
  [3810] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 6, 0, 82),
  [3812] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 7, 0, 109),
  [3814] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 7, 0, 109),
  [3816] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 7, 0, 114),
  [3818] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 7, 0, 114),
  [3820] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 7, 0, 109),
  [3822] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 7, 0, 109),
  [3824] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_declaration, 1, 0, 0),
  [3826] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_declaration, 1, 0, 0),
  [3828] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_declaration, 7, 0, 113),
  [3830] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 7, 0, 113),
  [3832] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 6, 0, 71),
  [3834] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 6, 0, 71),
  [3836] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 6, 0, 83),
  [3838] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 6, 0, 83),
  [3840] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 6, 0, 71),
  [3842] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 6, 0, 71),
  [3844] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delegate_declaration, 6, 0, 84),
  [3846] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delegate_declaration, 6, 0, 84),
  [3848] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 6, 0, 85),
  [3850] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 6, 0, 85),
  [3852] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 6, 0, 82),
  [3854] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 6, 0, 82),
  [3856] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 5, 0, 48),
  [3858] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 5, 0, 48),
  [3860] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 6, 0, 82),
  [3862] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 6, 0, 82),
  [3864] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 6, 0, 82),
  [3866] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 6, 0, 82),
  [3868] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_using_directive, 7, 0, 85),
  [3870] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_using_directive, 7, 0, 85),
  [3872] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 7, 0, 97),
  [3874] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 7, 0, 97),
  [3876] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_declaration, 7, 0, 98),
  [3878] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 7, 0, 98),
  [3880] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_declaration, 7, 0, 97),
  [3882] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 7, 0, 97),
  [3884] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 7, 0, 100),
  [3886] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 7, 0, 100),
  [3888] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delegate_declaration, 7, 0, 75),
  [3890] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delegate_declaration, 7, 0, 75),
  [3892] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 7, 0, 29),
  [3894] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 7, 0, 29),
  [3896] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 7, 0, 98),
  [3898] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 7, 0, 98),
  [3900] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 7, 0, 14),
  [3902] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 7, 0, 14),
  [3904] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 7, 0, 97),
  [3906] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 7, 0, 97),
  [3908] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 7, 0, 109),
  [3910] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 7, 0, 109),
  [3912] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 7, 0, 109),
  [3914] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 7, 0, 109),
  [3916] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 7, 0, 85),
  [3918] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 7, 0, 85),
  [3920] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delegate_declaration, 7, 0, 84),
  [3922] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delegate_declaration, 7, 0, 84),
  [3924] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 7, 0, 98),
  [3926] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 7, 0, 98),
  [3928] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_declaration, 7, 0, 109),
  [3930] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 7, 0, 109),
  [3932] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 7, 0, 110),
  [3934] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 7, 0, 110),
  [3936] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 7, 0, 98),
  [3938] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 7, 0, 98),
  [3940] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delegate_declaration, 7, 0, 111),
  [3942] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delegate_declaration, 7, 0, 111),
  [3944] = {.entry = {.count = 1, .reusable = false}}, SHIFT(145),
  [3946] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7910),
  [3948] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8910),
  [3950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9188),
  [3952] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__top_level_item, 1, 0, 0),
  [3954] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__top_level_item, 1, 0, 0),
  [3956] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_compilation_unit_repeat1, 1, 0, 0),
  [3958] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 1, 0, 0),
  [3960] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_else, 1, 0, 0),
  [3962] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_global_statement, 1, 0, 0),
  [3964] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_global_statement, 1, 0, 0),
  [3966] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_try_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7910),
  [3969] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_else, 2, 0, 0),
  [3971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9529),
  [3973] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_modifier, 1, 0, 0), REDUCE(sym__reserved_identifier, 1, 0, 0),
  [3976] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_modifier, 1, 0, 0),
  [3978] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_modifier, 1, 0, 0), REDUCE(sym__reserved_identifier, 1, 0, 0),
  [3981] = {.entry = {.count = 1, .reusable = false}}, SHIFT(120),
  [3983] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 1, 0, 0),
  [3985] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 1, 0, 0),
  [3987] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__reserved_identifier, 1, 0, 0), REDUCE(aux_sym__parameter_type_with_modifiers_repeat1, 1, 0, 1), SHIFT(2733),
  [3991] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__reserved_identifier, 1, 0, 0), REDUCE(aux_sym__parameter_type_with_modifiers_repeat1, 1, 0, 1), SHIFT(2732),
  [3995] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__reserved_identifier, 1, 0, 0), REDUCE(aux_sym__parameter_type_with_modifiers_repeat1, 1, 0, 1),
  [3998] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(2914),
  [4001] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(2915),
  [4004] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4706),
  [4006] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(2733),
  [4009] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(2732),
  [4012] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4609),
  [4014] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4530),
  [4016] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_implicit_type, 1, 1, 0), REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(3908),
  [4020] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_implicit_type, 1, 1, 0), REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(3905),
  [4024] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_implicit_type, 1, 1, 0), REDUCE(sym__reserved_identifier, 1, 0, 0),
  [4027] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_implicit_type, 1, 1, 0), REDUCE(sym__reserved_identifier, 1, 0, 0),
  [4030] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_implicit_type, 1, 1, 0), REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(6837),
  [4034] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_implicit_type, 1, 1, 0), REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(4015),
  [4038] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(3163),
  [4041] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(3171),
  [4044] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4566),
  [4046] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_implicit_type, 1, 1, 0), REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(6871),
  [4050] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_implicit_type, 1, 1, 0), REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(4274),
  [4054] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4564),
  [4056] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_identifier, 1, 0, 0),
  [4058] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_identifier, 1, 0, 0),
  [4060] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_argument_list, 4, 0, 0),
  [4062] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_argument_list, 4, 0, 0),
  [4064] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4714),
  [4066] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_name, 2, 0, 0),
  [4068] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_name, 2, 0, 0),
  [4070] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_argument_list, 3, 0, 0),
  [4072] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_argument_list, 3, 0, 0),
  [4074] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__simple_name, 1, 0, 0),
  [4076] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_name, 1, 0, 0),
  [4078] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__simple_name, 1, 0, 0), SHIFT(4392),
  [4081] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__lambda_parameters, 1, 0, 3),
  [4083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7252),
  [4085] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_argument_list, 2, 0, 0),
  [4087] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_argument_list, 2, 0, 0),
  [4089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7245),
  [4091] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_implicit_type, 1, 1, 0), REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(3127),
  [4095] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_implicit_type, 1, 1, 0), REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(3146),
  [4099] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_qualified_name, 3, 0, 22),
  [4101] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_qualified_name, 3, 0, 22), REDUCE(sym_member_access_expression, 3, 0, 19),
  [4104] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_access_expression, 3, 0, 19),
  [4106] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualified_name, 3, 0, 22),
  [4108] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_name, 3, 0, 22), REDUCE(sym_member_access_expression, 3, 0, 19),
  [4111] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_access_expression, 3, 0, 19),
  [4113] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__name, 1, 0, 0),
  [4115] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__name, 1, 0, 0), REDUCE(sym_constant_pattern, 1, 0, 0),
  [4118] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lvalue_expression, 1, 0, 0),
  [4120] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__name, 1, 0, 0), REDUCE(sym_constant_pattern, 1, 0, 0), REDUCE(sym_lvalue_expression, 1, 0, 0),
  [4124] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__name, 1, 0, 0),
  [4126] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__name, 1, 0, 0), REDUCE(sym_constant_pattern, 1, 0, 0), REDUCE(sym_lvalue_expression, 1, 0, 0),
  [4130] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__name, 1, 0, 0), REDUCE(sym_constant_pattern, 1, 0, 0),
  [4133] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lvalue_expression, 1, 0, 0),
  [4135] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__name, 1, 0, 0), REDUCE(sym_lvalue_expression, 1, 0, 0),
  [4138] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__name, 1, 0, 0), REDUCE(sym_lvalue_expression, 1, 0, 0),
  [4141] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_implicit_type, 1, 1, 0), REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(5128),
  [4145] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_implicit_type, 1, 1, 0), REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(5130),
  [4149] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_implicit_type, 1, 1, 0), REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(6832),
  [4153] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_implicit_type, 1, 1, 0), REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(5390),
  [4157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3838),
  [4159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3850),
  [4161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4665),
  [4163] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(3850),
  [4166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7251),
  [4168] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3897),
  [4170] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3898),
  [4172] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4653),
  [4174] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_implicit_type, 1, 1, 0), REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(2914),
  [4178] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_implicit_type, 1, 1, 0), REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(2915),
  [4182] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_implicit_type, 1, 1, 0), REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(6810),
  [4186] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_implicit_type, 1, 1, 0), REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(4614),
  [4190] = {.entry = {.count = 1, .reusable = false}}, SHIFT(621),
  [4192] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_implicit_type, 1, 1, 0), REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(3897),
  [4196] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_implicit_type, 1, 1, 0), REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(3898),
  [4200] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_lvalue_expression, 1, 0, 0), REDUCE(aux_sym__parameter_type_with_modifiers_repeat1, 1, 0, 1),
  [4203] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_implicit_type, 1, 1, 0), REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(3558),
  [4207] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_implicit_type, 1, 1, 0), REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(3555),
  [4211] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_implicit_type, 1, 1, 0), REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(6872),
  [4215] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_implicit_type, 1, 1, 0), REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(4957),
  [4219] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__simple_name, 1, 0, 0), SHIFT(1985),
  [4222] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_parameter, 1, 0, 4), REDUCE(sym__simple_name, 1, 0, 0),
  [4225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3558),
  [4227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3555),
  [4229] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4610),
  [4231] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(3555),
  [4234] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__simple_name, 1, 0, 0), SHIFT(4377),
  [4237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7221),
  [4239] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_implicit_type, 1, 1, 0), REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(3568),
  [4243] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_implicit_type, 1, 1, 0), REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(3591),
  [4247] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__variable_designation, 1, 0, 4),
  [4249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3778),
  [4251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4691),
  [4253] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7289),
  [4255] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4447),
  [4257] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7343),
  [4259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7285),
  [4261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7282),
  [4263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4608),
  [4265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7190),
  [4267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7329),
  [4269] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6760),
  [4271] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3908),
  [4273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3905),
  [4275] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_pattern, 1, 0, 5),
  [4277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(320),
  [4279] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_pattern, 1, 0, 5),
  [4281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4015),
  [4283] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_is_expression, 3, 0, 23),
  [4285] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_is_expression, 3, 0, 23),
  [4287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3568),
  [4289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3591),
  [4291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4560),
  [4293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7151),
  [4295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4274),
  [4297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3588),
  [4299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7316),
  [4301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4466),
  [4303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7315),
  [4305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7311),
  [4307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4715),
  [4309] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7210),
  [4311] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7327),
  [4313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4478),
  [4315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7299),
  [4317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7352),
  [4319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4645),
  [4321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7218),
  [4323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1862),
  [4325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9464),
  [4327] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6757),
  [4329] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_recursive_pattern, 1, 0, 0),
  [4331] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_recursive_pattern, 1, 0, 0),
  [4333] = {.entry = {.count = 1, .reusable = false}}, SHIFT(172),
  [4335] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_recursive_pattern, 2, 0, 5),
  [4337] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_recursive_pattern, 2, 0, 5),
  [4339] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1889),
  [4341] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9330),
  [4343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1348),
  [4345] = {.entry = {.count = 1, .reusable = false}}, SHIFT(63),
  [4347] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ref_type, 2, 0, 6),
  [4349] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ref_type, 2, 0, 6),
  [4351] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4716),
  [4353] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7355),
  [4355] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4449),
  [4357] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7321),
  [4359] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7362),
  [4361] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7358),
  [4363] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4623),
  [4365] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7228),
  [4367] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6770),
  [4369] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1706),
  [4371] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9403),
  [4373] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_recursive_pattern, 2, 0, 0),
  [4375] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_recursive_pattern, 2, 0, 0),
  [4377] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1139),
  [4379] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1938),
  [4381] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9653),
  [4383] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_recursive_pattern, 3, 0, 5),
  [4385] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_recursive_pattern, 3, 0, 5),
  [4387] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_pointer_type, 6, 0, 74),
  [4389] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_pointer_type, 6, 0, 74),
  [4391] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5144),
  [4393] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5149),
  [4395] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4588),
  [4397] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4627),
  [4399] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(5149),
  [4402] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_pointer_type, 7, 0, 101),
  [4404] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_pointer_type, 7, 0, 101),
  [4406] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_pointer_type, 5, 0, 51),
  [4408] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_pointer_type, 5, 0, 51),
  [4410] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6763),
  [4412] = {.entry = {.count = 1, .reusable = false}}, SHIFT(85),
  [4414] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ref_type, 3, 0, 15),
  [4416] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ref_type, 3, 0, 15),
  [4418] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pointer_type, 2, 0, 5),
  [4420] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_type, 2, 0, 5),
  [4422] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type, 1, 0, 0),
  [4424] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type, 1, 0, 0),
  [4426] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__scoped_base_type, 1, 0, 0),
  [4428] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__scoped_base_type, 1, 0, 0),
  [4430] = {.entry = {.count = 1, .reusable = false}}, SHIFT(123),
  [4432] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_nullable_type, 2, 0, 5),
  [4434] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nullable_type, 2, 0, 5),
  [4436] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_scoped_type, 2, 0, 6),
  [4438] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scoped_type, 2, 0, 6),
  [4440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5472),
  [4442] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3776),
  [4444] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4577),
  [4446] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__simple_name, 1, 0, 0), SHIFT(4372),
  [4449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8490),
  [4451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(580),
  [4453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(622),
  [4455] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9874),
  [4457] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2793),
  [4459] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3579),
  [4461] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3633),
  [4463] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4618),
  [4465] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4548),
  [4467] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(3898),
  [4470] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_positional_pattern_clause, 4, 0, 0),
  [4472] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_positional_pattern_clause, 4, 0, 0),
  [4474] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_rank_specifier, 4, 0, 0),
  [4476] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_rank_specifier, 4, 0, 0),
  [4478] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_type, 2, 0, 8),
  [4480] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 8),
  [4482] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5128),
  [4484] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5130),
  [4486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(302),
  [4488] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5390),
  [4490] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2914),
  [4492] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2915),
  [4494] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4686),
  [4496] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_positional_pattern_clause, 2, 0, 0),
  [4498] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_positional_pattern_clause, 2, 0, 0),
  [4500] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_list, 2, 0, 0),
  [4502] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_type, 4, 0, 0),
  [4504] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_type, 4, 0, 0),
  [4506] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__simple_name, 1, 0, 0), SHIFT(4400),
  [4509] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7298),
  [4511] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4511),
  [4513] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7331),
  [4515] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7300),
  [4517] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7322),
  [4519] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4591),
  [4521] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7175),
  [4523] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3696),
  [4525] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_alias_qualified_name, 3, 0, 28),
  [4527] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alias_qualified_name, 3, 0, 28),
  [4529] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7279),
  [4531] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4480),
  [4533] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7291),
  [4535] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7267),
  [4537] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7268),
  [4539] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4612),
  [4541] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7164),
  [4543] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4616),
  [4545] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4532),
  [4547] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type, 1, 0, 0), REDUCE(sym__array_base_type, 1, 0, 0),
  [4550] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type, 1, 0, 0), SHIFT(2901),
  [4553] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type, 1, 0, 0), REDUCE(sym__pointer_base_type, 1, 0, 0),
  [4556] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7185),
  [4558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7185),
  [4560] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7197),
  [4562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7197),
  [4564] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_rank_specifier, 3, 0, 0),
  [4566] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_rank_specifier, 3, 0, 0),
  [4568] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_rank_specifier, 2, 0, 0),
  [4570] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_rank_specifier, 2, 0, 0),
  [4572] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4674),
  [4574] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4710),
  [4576] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_pattern_clause, 3, 0, 0),
  [4578] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_pattern_clause, 3, 0, 0),
  [4580] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_pattern_clause, 2, 0, 0),
  [4582] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_pattern_clause, 2, 0, 0),
  [4584] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4713),
  [4586] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4705),
  [4588] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pointer_indirection_expression, 2, 0, 0),
  [4590] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pointer_indirection_expression, 2, 0, 0),
  [4592] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4652),
  [4594] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_pattern_clause, 5, 0, 0),
  [4596] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_pattern_clause, 5, 0, 0),
  [4598] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4632),
  [4600] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7203),
  [4602] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7186),
  [4604] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parenthesized_lvalue_expression, 3, 0, 0),
  [4606] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parenthesized_lvalue_expression, 3, 0, 0),
  [4608] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7229),
  [4610] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4703),
  [4612] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(3591),
  [4615] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bracketed_argument_list, 3, 0, 0),
  [4617] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_bracketed_argument_list, 3, 0, 0),
  [4619] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4613),
  [4621] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7231),
  [4623] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lvalue_expression, 1, 0, 2),
  [4625] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lvalue_expression, 1, 0, 2),
  [4627] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_pattern_clause, 4, 0, 0),
  [4629] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_pattern_clause, 4, 0, 0),
  [4631] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bracketed_argument_list, 4, 0, 0),
  [4633] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_bracketed_argument_list, 4, 0, 0),
  [4635] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_element_access_expression, 2, 0, 10),
  [4637] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_element_access_expression, 2, 0, 10),
  [4639] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conditional_access_expression, 3, 0, 24),
  [4641] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conditional_access_expression, 3, 0, 24),
  [4643] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_expression, 4, 0, 0),
  [4645] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_expression, 4, 0, 0),
  [4647] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4614),
  [4649] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4957),
  [4651] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4596),
  [4653] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4629),
  [4655] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4578),
  [4657] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4576),
  [4659] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4605),
  [4661] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4568),
  [4663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(683),
  [4665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(636),
  [4667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(691),
  [4669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(669),
  [4671] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3813),
  [4673] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3809),
  [4675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(666),
  [4677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(667),
  [4679] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3827),
  [4681] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3834),
  [4683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(696),
  [4685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(645),
  [4687] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3871),
  [4689] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__simple_name, 1, 0, 0), SHIFT(4362),
  [4692] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__simple_name, 1, 0, 0), SHIFT(4378),
  [4695] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initializer_expression, 3, 0, 0),
  [4697] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_initializer_expression, 3, 0, 0),
  [4699] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7233),
  [4701] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7188),
  [4703] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7131),
  [4705] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_declaration, 3, 0, 68),
  [4707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1556),
  [4709] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 3, 0, 68),
  [4711] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7230),
  [4713] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_accessor_list, 3, 0, 0),
  [4715] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_accessor_list, 3, 0, 0),
  [4717] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_declaration, 5, 0, 121),
  [4719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1881),
  [4721] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 5, 0, 121),
  [4723] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_declaration, 6, 0, 161),
  [4725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1971),
  [4727] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 6, 0, 161),
  [4729] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_declaration, 4, 0, 93),
  [4731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1732),
  [4733] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 4, 0, 93),
  [4735] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_accessor_list, 2, 0, 0),
  [4737] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_accessor_list, 2, 0, 0),
  [4739] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_pattern, 1, 0, 0),
  [4741] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_constant_pattern, 1, 0, 0), REDUCE(sym_lvalue_expression, 1, 0, 0),
  [4744] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_constant_pattern, 1, 0, 0), REDUCE(sym_lvalue_expression, 1, 0, 0),
  [4747] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant_pattern, 1, 0, 0),
  [4749] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__simple_name, 1, 0, 0), SHIFT(4426),
  [4752] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_declaration, 5, 0, 131),
  [4754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1904),
  [4756] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 5, 0, 131),
  [4758] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_declaration, 4, 0, 90),
  [4760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1762),
  [4762] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 4, 0, 90),
  [4764] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conversion_operator_declaration, 6, 0, 151),
  [4766] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conversion_operator_declaration, 6, 0, 151),
  [4768] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 4, 0, 94),
  [4770] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 4, 0, 94),
  [4772] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if, 6, 0, 79),
  [4774] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if, 6, 0, 79),
  [4776] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator_declaration, 6, 0, 152),
  [4778] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_declaration, 6, 0, 152),
  [4780] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_declaration, 5, 0, 119),
  [4782] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_declaration, 5, 0, 119),
  [4784] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator_declaration, 7, 0, 186),
  [4786] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_declaration, 7, 0, 186),
  [4788] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 7, 0, 187),
  [4790] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 7, 0, 187),
  [4792] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_declaration, 7, 0, 188),
  [4794] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 7, 0, 188),
  [4796] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_declaration, 4, 0, 91),
  [4798] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_declaration, 4, 0, 91),
  [4800] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_indexer_declaration, 6, 0, 153),
  [4802] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_indexer_declaration, 6, 0, 153),
  [4804] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_declaration, 3, 0, 69),
  [4806] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_declaration, 3, 0, 69),
  [4808] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 3, 0, 0),
  [4810] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 3, 0, 0),
  [4812] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 6, 0, 154),
  [4814] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 6, 0, 154),
  [4816] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 6, 0, 155),
  [4818] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 6, 0, 155),
  [4820] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 6, 0, 157),
  [4822] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 6, 0, 157),
  [4824] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_declaration, 6, 0, 158),
  [4826] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 6, 0, 158),
  [4828] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_declaration, 4, 0, 95),
  [4830] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 4, 0, 95),
  [4832] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_destructor_declaration, 6, 0, 159),
  [4834] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_destructor_declaration, 6, 0, 159),
  [4836] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 4, 0, 0),
  [4838] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 4, 0, 0),
  [4840] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_declaration, 4, 0, 96),
  [4842] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_declaration, 4, 0, 96),
  [4844] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_indexer_declaration, 7, 0, 191),
  [4846] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_indexer_declaration, 7, 0, 191),
  [4848] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 7, 0, 192),
  [4850] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 7, 0, 192),
  [4852] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 7, 0, 193),
  [4854] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 7, 0, 193),
  [4856] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration, 1, 0, 0),
  [4858] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 1, 0, 0),
  [4860] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_event_field_declaration, 4, 1, 0),
  [4862] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_event_field_declaration, 4, 1, 0),
  [4864] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 7, 0, 194),
  [4866] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 7, 0, 194),
  [4868] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_declaration, 7, 0, 195),
  [4870] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 7, 0, 195),
  [4872] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_event_declaration, 7, 0, 196),
  [4874] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_event_declaration, 7, 0, 196),
  [4876] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_destructor_declaration, 5, 0, 119),
  [4878] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_destructor_declaration, 5, 0, 119),
  [4880] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_event_declaration, 5, 0, 120),
  [4882] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_event_declaration, 5, 0, 120),
  [4884] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 1, 0, 0),
  [4886] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 1, 0, 0),
  [4888] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_event_declaration, 5, 0, 121),
  [4890] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_event_declaration, 5, 0, 121),
  [4892] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_event_declaration, 6, 0, 160),
  [4894] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_event_declaration, 6, 0, 160),
  [4896] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_event_declaration, 6, 0, 161),
  [4898] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_event_declaration, 6, 0, 161),
  [4900] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conversion_operator_declaration, 5, 0, 122),
  [4902] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conversion_operator_declaration, 5, 0, 122),
  [4904] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_event_field_declaration, 5, 1, 0),
  [4906] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_event_field_declaration, 5, 1, 0),
  [4908] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_event_declaration, 7, 0, 197),
  [4910] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_event_declaration, 7, 0, 197),
  [4912] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator_declaration, 7, 0, 198),
  [4914] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_declaration, 7, 0, 198),
  [4916] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_declaration, 5, 0, 135),
  [4918] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_declaration, 5, 0, 135),
  [4920] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_declaration, 5, 0, 134),
  [4922] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 5, 0, 134),
  [4924] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 5, 0, 133),
  [4926] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 5, 0, 133),
  [4928] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_indexer_declaration, 5, 0, 125),
  [4930] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_indexer_declaration, 5, 0, 125),
  [4932] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type, 1, 0, 0), SHIFT(3377),
  [4935] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_indexer_declaration, 5, 0, 132),
  [4937] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_indexer_declaration, 5, 0, 132),
  [4939] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 2, 0, 0),
  [4941] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 2, 0, 0),
  [4943] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_indexer_declaration, 7, 0, 199),
  [4945] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_indexer_declaration, 7, 0, 199),
  [4947] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_indexer_declaration, 7, 0, 200),
  [4949] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_indexer_declaration, 7, 0, 200),
  [4951] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7224),
  [4953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7211),
  [4955] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_event_field_declaration, 3, 1, 0),
  [4957] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_event_field_declaration, 3, 1, 0),
  [4959] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 7, 0, 201),
  [4961] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 7, 0, 201),
  [4963] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_indexer_declaration, 4, 0, 92),
  [4965] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_indexer_declaration, 4, 0, 92),
  [4967] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if, 5, 0, 57),
  [4969] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if, 5, 0, 57),
  [4971] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_declaration, 7, 0, 202),
  [4973] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 7, 0, 202),
  [4975] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if, 5, 0, 37),
  [4977] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if, 5, 0, 37),
  [4979] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 7, 0, 203),
  [4981] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 7, 0, 203),
  [4983] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator_declaration, 5, 0, 123),
  [4985] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_declaration, 5, 0, 123),
  [4987] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7232),
  [4989] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_event_declaration, 5, 0, 131),
  [4991] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_event_declaration, 5, 0, 131),
  [4993] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 7, 0, 204),
  [4995] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 7, 0, 204),
  [4997] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_indexer_declaration, 5, 0, 124),
  [4999] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_indexer_declaration, 5, 0, 124),
  [5001] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator_declaration, 7, 0, 190),
  [5003] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_declaration, 7, 0, 190),
  [5005] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conversion_operator_declaration, 7, 0, 185),
  [5007] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conversion_operator_declaration, 7, 0, 185),
  [5009] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if, 4, 0, 37),
  [5011] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if, 4, 0, 37),
  [5013] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_event_declaration, 5, 0, 47),
  [5015] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_event_declaration, 5, 0, 47),
  [5017] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator_declaration, 6, 0, 162),
  [5019] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_declaration, 6, 0, 162),
  [5021] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 5, 0, 126),
  [5023] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 5, 0, 126),
  [5025] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_declaration, 5, 0, 127),
  [5027] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 5, 0, 127),
  [5029] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7174),
  [5031] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_indexer_declaration, 6, 0, 163),
  [5033] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_indexer_declaration, 6, 0, 163),
  [5035] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_indexer_declaration, 6, 0, 164),
  [5037] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_indexer_declaration, 6, 0, 164),
  [5039] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_destructor_declaration, 4, 0, 91),
  [5041] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_destructor_declaration, 4, 0, 91),
  [5043] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_event_declaration, 4, 0, 90),
  [5045] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_event_declaration, 4, 0, 90),
  [5047] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 6, 0, 165),
  [5049] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 6, 0, 165),
  [5051] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_declaration, 6, 0, 166),
  [5053] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 6, 0, 166),
  [5055] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 6, 0, 167),
  [5057] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 6, 0, 167),
  [5059] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 5, 0, 129),
  [5061] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 5, 0, 129),
  [5063] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conversion_operator_declaration, 8, 0, 210),
  [5065] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conversion_operator_declaration, 8, 0, 210),
  [5067] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7211),
  [5069] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator_declaration, 8, 0, 211),
  [5071] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_declaration, 8, 0, 211),
  [5073] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_event_declaration, 4, 0, 30),
  [5075] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_event_declaration, 4, 0, 30),
  [5077] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 8, 0, 212),
  [5079] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 8, 0, 212),
  [5081] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_declaration, 8, 0, 213),
  [5083] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 8, 0, 213),
  [5085] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7135),
  [5087] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator_declaration, 8, 0, 214),
  [5089] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_declaration, 8, 0, 214),
  [5091] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_indexer_declaration, 8, 0, 215),
  [5093] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_indexer_declaration, 8, 0, 215),
  [5095] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 8, 0, 216),
  [5097] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 8, 0, 216),
  [5099] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 6, 0, 168),
  [5101] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 6, 0, 168),
  [5103] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 8, 0, 217),
  [5105] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 8, 0, 217),
  [5107] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 8, 0, 218),
  [5109] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 8, 0, 218),
  [5111] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_declaration, 8, 0, 219),
  [5113] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 8, 0, 219),
  [5115] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conversion_operator_declaration, 9, 0, 222),
  [5117] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conversion_operator_declaration, 9, 0, 222),
  [5119] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator_declaration, 9, 0, 223),
  [5121] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_declaration, 9, 0, 223),
  [5123] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 9, 0, 224),
  [5125] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 9, 0, 224),
  [5127] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_declaration, 9, 0, 225),
  [5129] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 9, 0, 225),
  [5131] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_declaration, 6, 0, 174),
  [5133] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_declaration, 6, 0, 174),
  [5135] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_declaration, 6, 0, 173),
  [5137] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 6, 0, 173),
  [5139] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 6, 0, 172),
  [5141] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 6, 0, 172),
  [5143] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 5, 0, 130),
  [5145] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 5, 0, 130),
  [5147] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_event_declaration, 6, 0, 169),
  [5149] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_event_declaration, 6, 0, 169),
  [5151] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_event_declaration, 6, 0, 170),
  [5153] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_event_declaration, 6, 0, 170),
  [5155] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_indexer_declaration, 6, 0, 171),
  [5157] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_indexer_declaration, 6, 0, 171),
  [5159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7141),
  [5161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7213),
  [5163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7156),
  [5165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7173),
  [5167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7173),
  [5169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7144),
  [5171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7247),
  [5173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7177),
  [5175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7226),
  [5177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7216),
  [5179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7238),
  [5181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7149),
  [5183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7166),
  [5185] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_creation_expression, 2, 0, 6),
  [5187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(591),
  [5189] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_creation_expression, 2, 0, 6),
  [5191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7240),
  [5193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7216),
  [5195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7237),
  [5197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7153),
  [5199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7167),
  [5201] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_implicit_object_creation_expression, 2, 0, 0),
  [5203] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_implicit_object_creation_expression, 2, 0, 0),
  [5205] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_creation_expression, 3, 0, 17),
  [5207] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_creation_expression, 3, 0, 17),
  [5209] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__simple_name, 1, 0, 0), SHIFT(4409),
  [5212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5714),
  [5214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4393),
  [5216] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4316),
  [5218] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4168),
  [5220] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8536),
  [5222] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4201),
  [5224] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5253),
  [5226] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_stackalloc_expression, 2, 0, 6),
  [5228] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__array_base_type, 1, 0, 0), REDUCE(sym_stackalloc_expression, 2, 0, 6),
  [5231] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_stackalloc_expression, 2, 0, 6),
  [5233] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_await_expression, 2, 0, 0),
  [5235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(603),
  [5237] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_await_expression, 2, 0, 0),
  [5239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3701),
  [5241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3701),
  [5243] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_prefix_unary_expression, 2, 0, 0),
  [5245] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_prefix_unary_expression, 2, 0, 0),
  [5247] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2181),
  [5249] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression, 1, 0, 0),
  [5251] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0),
  [5253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2181),
  [5255] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cast_expression, 4, 1, 34),
  [5257] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cast_expression, 4, 1, 34),
  [5259] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__simple_name, 1, 0, 0), SHIFT(4353),
  [5262] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 2, 0, 0),
  [5264] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 2, 0, 0),
  [5266] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 3, 0, 0),
  [5268] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 3, 0, 0),
  [5270] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1653),
  [5272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1653),
  [5274] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type, 1, 0, 0), SHIFT(3571),
  [5277] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_class_declaration_repeat1, 2, 0, 0),
  [5279] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_declaration_repeat1, 2, 0, 0), SHIFT_REPEAT(5654),
  [5282] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_class_declaration_repeat1, 2, 0, 0),
  [5284] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5090),
  [5286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7222),
  [5288] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 4, 0, 0),
  [5290] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 4, 0, 0),
  [5292] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_literal, 2, 0, 0),
  [5294] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string_literal, 2, 0, 0),
  [5296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3619),
  [5298] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_type, 1, 0, 0), REDUCE(sym__array_base_type, 1, 0, 0), REDUCE(sym_array_creation_expression, 2, 17, 6),
  [5302] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type, 1, 0, 0), REDUCE(sym_array_creation_expression, 2, 17, 6),
  [5305] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type, 1, 0, 0), SHIFT(673),
  [5308] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type, 1, 0, 0), REDUCE(sym_array_creation_expression, 2, 17, 6),
  [5311] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_type, 1, 0, 0), REDUCE(sym_array_creation_expression, 2, 17, 6), SHIFT(3643),
  [5315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2024),
  [5317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2024),
  [5319] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_literal, 3, 0, 0),
  [5321] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string_literal, 3, 0, 0),
  [5323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3692),
  [5325] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_expression, 4, 0, 44),
  [5327] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_expression, 4, 0, 44),
  [5329] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_stackalloc_expression, 3, 0, 6),
  [5331] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_stackalloc_expression, 3, 0, 6),
  [5333] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_invocation_expression, 2, 0, 9),
  [5335] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_invocation_expression, 2, 0, 9),
  [5337] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_expression, 6, 0, 89),
  [5339] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_expression, 6, 0, 89),
  [5341] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_query_expression, 2, 0, 0),
  [5343] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_query_expression, 2, 0, 0),
  [5345] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_character_literal, 3, 0, 0),
  [5347] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_character_literal, 3, 0, 0),
  [5349] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_expression, 6, 0, 0),
  [5351] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_expression, 6, 0, 0),
  [5353] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_expression, 6, 0, 0),
  [5355] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_expression, 6, 0, 0),
  [5357] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_expression, 6, 0, 79),
  [5359] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_expression, 6, 0, 79),
  [5361] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_refvalue_expression, 6, 0, 78),
  [5363] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_refvalue_expression, 6, 0, 78),
  [5365] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpolated_string_expression, 3, 0, 0),
  [5367] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interpolated_string_expression, 3, 0, 0),
  [5369] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__query_body_repeat2, 3, 0, 0),
  [5371] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__query_body_repeat2, 3, 0, 0),
  [5373] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpolated_string_expression, 4, 0, 0),
  [5375] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interpolated_string_expression, 4, 0, 0),
  [5377] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 3, 0, 0),
  [5379] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 3, 0, 0),
  [5381] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_object_creation_expression, 6, 0, 0),
  [5383] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_object_creation_expression, 6, 0, 0),
  [5385] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_expression, 5, 0, 67),
  [5387] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_expression, 5, 0, 67),
  [5389] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type, 1, 0, 0), SHIFT(3643),
  [5392] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_method_expression, 3, 0, 16),
  [5394] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_method_expression, 3, 0, 16),
  [5396] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_expression, 5, 0, 65),
  [5398] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_expression, 5, 0, 65),
  [5400] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_expression, 5, 0, 0),
  [5402] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_expression, 5, 0, 0),
  [5404] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initializer_expression, 4, 0, 0),
  [5406] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_initializer_expression, 4, 0, 0),
  [5408] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_expression, 5, 0, 0),
  [5410] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_expression, 5, 0, 0),
  [5412] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_method_expression, 3, 0, 0),
  [5414] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_method_expression, 3, 0, 0),
  [5416] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__select_or_group_clause, 1, 0, 0),
  [5418] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__select_or_group_clause, 1, 0, 0),
  [5420] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_expression, 3, 0, 27),
  [5422] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_expression, 3, 0, 27),
  [5424] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_implicit_array_creation_expression, 4, 0, 0),
  [5426] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_implicit_array_creation_expression, 4, 0, 0),
  [5428] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_object_creation_expression, 4, 0, 0),
  [5430] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_object_creation_expression, 4, 0, 0),
  [5432] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_creation_expression, 4, 0, 36),
  [5434] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_creation_expression, 4, 0, 36),
  [5436] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_checked_expression, 4, 0, 0),
  [5438] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_checked_expression, 4, 0, 0),
  [5440] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__query_body_repeat2, 4, 0, 0),
  [5442] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__query_body_repeat2, 4, 0, 0),
  [5444] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_expression, 7, 0, 0),
  [5446] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_expression, 7, 0, 0),
  [5448] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_method_expression, 2, 0, 0),
  [5450] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_method_expression, 2, 0, 0),
  [5452] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_implicit_stackalloc_expression, 4, 0, 0),
  [5454] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_implicit_stackalloc_expression, 4, 0, 0),
  [5456] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4506),
  [5458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5422),
  [5460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3200),
  [5462] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4200),
  [5464] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7807),
  [5466] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sizeof_expression, 4, 0, 15),
  [5468] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sizeof_expression, 4, 0, 15),
  [5470] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_object_creation_expression, 3, 0, 0),
  [5472] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_object_creation_expression, 3, 0, 0),
  [5474] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_implicit_object_creation_expression, 3, 0, 0),
  [5476] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_implicit_object_creation_expression, 3, 0, 0),
  [5478] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_non_lvalue_expression, 1, 0, 0),
  [5480] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_non_lvalue_expression, 1, 0, 0),
  [5482] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_typeof_expression, 4, 0, 15),
  [5484] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_typeof_expression, 4, 0, 15),
  [5486] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression_statement_expression, 1, 0, 0),
  [5488] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression_statement_expression, 1, 0, 0),
  [5490] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_makeref_expression, 4, 0, 0),
  [5492] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_makeref_expression, 4, 0, 0),
  [5494] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_expression, 5, 0, 57),
  [5496] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_expression, 5, 0, 57),
  [5498] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_creation_expression, 3, 0, 18),
  [5500] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_creation_expression, 3, 0, 18),
  [5502] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_reftype_expression, 4, 0, 0),
  [5504] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_reftype_expression, 4, 0, 0),
  [5506] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_as_expression, 3, 0, 23),
  [5508] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_as_expression, 3, 0, 23),
  [5510] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_expression, 4, 0, 38),
  [5512] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_expression, 4, 0, 38),
  [5514] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_expression, 5, 0, 37),
  [5516] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_expression, 5, 0, 37),
  [5518] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_creation_expression, 3, 17, 6),
  [5520] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_creation_expression, 3, 17, 6),
  [5522] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_binding_expression, 2, 0, 14),
  [5524] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_binding_expression, 2, 0, 14),
  [5526] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_expression, 4, 0, 0),
  [5528] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_expression, 4, 0, 0),
  [5530] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_accessor_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2733),
  [5533] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_accessor_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4506),
  [5536] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_accessor_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2732),
  [5539] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_accessor_list_repeat1, 2, 0, 0), SHIFT_REPEAT(5422),
  [5542] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_accessor_list_repeat1, 2, 0, 0),
  [5544] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_accessor_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4200),
  [5547] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_accessor_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7807),
  [5550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3180),
  [5552] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2065),
  [5554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2065),
  [5556] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_literal, 4, 0, 0),
  [5558] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string_literal, 4, 0, 0),
  [5560] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_literal, 1, 0, 0),
  [5562] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_literal, 1, 0, 0),
  [5564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4799),
  [5566] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_modifier, 1, 0, 0),
  [5568] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_boolean_literal, 1, 0, 0),
  [5570] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_boolean_literal, 1, 0, 0),
  [5572] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_postfix_unary_expression, 2, 0, 0),
  [5574] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_postfix_unary_expression, 2, 0, 0),
  [5576] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_object_creation_expression, 5, 0, 0),
  [5578] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_object_creation_expression, 5, 0, 0),
  [5580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8691),
  [5582] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_expression, 4, 0, 0),
  [5584] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_expression, 4, 0, 0),
  [5586] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_method_expression, 4, 0, 45),
  [5588] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_method_expression, 4, 0, 45),
  [5590] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initializer_expression, 5, 0, 0),
  [5592] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_initializer_expression, 5, 0, 0),
  [5594] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conditional_access_expression, 3, 0, 25),
  [5596] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conditional_access_expression, 3, 0, 25),
  [5598] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_implicit_array_creation_expression, 5, 0, 0),
  [5600] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_implicit_array_creation_expression, 5, 0, 0),
  [5602] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1486),
  [5604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1486),
  [5606] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1201),
  [5608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1201),
  [5610] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute_list, 5, 0, 0),
  [5612] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_list, 5, 0, 0),
  [5614] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute_list, 4, 0, 0),
  [5616] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_list, 4, 0, 0),
  [5618] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1708),
  [5620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1708),
  [5622] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_class_declaration_repeat1, 1, 0, 0),
  [5624] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_class_declaration_repeat1, 1, 0, 0),
  [5626] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_class_declaration_repeat2, 2, 0, 0),
  [5628] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_declaration_repeat2, 2, 0, 0), SHIFT_REPEAT(3788),
  [5631] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_class_declaration_repeat2, 2, 0, 0),
  [5633] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute_list, 3, 0, 0),
  [5635] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_list, 3, 0, 0),
  [5637] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute_list, 6, 0, 0),
  [5639] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_list, 6, 0, 0),
  [5641] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7248),
  [5643] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1964),
  [5645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1964),
  [5647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7276),
  [5649] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_class_declaration_repeat2, 1, 0, 0),
  [5651] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_class_declaration_repeat2, 1, 0, 0),
  [5653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5741),
  [5655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8448),
  [5657] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4602),
  [5659] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9904),
  [5661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2741),
  [5663] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7363),
  [5665] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5205),
  [5667] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8180),
  [5669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(585),
  [5671] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7822),
  [5673] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1895),
  [5675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1895),
  [5677] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__simple_name, 1, 0, 0), SHIFT(4367),
  [5680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7205),
  [5682] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2123),
  [5684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2123),
  [5686] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6824),
  [5688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(600),
  [5690] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3968),
  [5692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3968),
  [5694] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type, 1, 0, 0), SHIFT(638),
  [5697] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_type, 1, 0, 0), REDUCE(sym_array_creation_expression, 2, 17, 6), SHIFT(3931),
  [5701] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1835),
  [5703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1835),
  [5705] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6867),
  [5707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(50),
  [5709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(58),
  [5711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(588),
  [5713] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__simple_name, 1, 0, 0), SHIFT(4352),
  [5716] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2136),
  [5718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2136),
  [5720] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1640),
  [5722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1640),
  [5724] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1567),
  [5726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1567),
  [5728] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__simple_name, 1, 0, 0), SHIFT(4417),
  [5731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3933),
  [5733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4014),
  [5735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7165),
  [5737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3935),
  [5739] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2088),
  [5741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2088),
  [5743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(604),
  [5745] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4213),
  [5747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4213),
  [5749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3967),
  [5751] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type, 1, 0, 0), SHIFT(3931),
  [5754] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7208),
  [5756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4708),
  [5758] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type, 1, 0, 0), SHIFT(4034),
  [5761] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern, 1, 0, 0),
  [5763] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pattern, 1, 0, 0),
  [5765] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7353),
  [5767] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_recursive_pattern, 3, 0, 64),
  [5769] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_recursive_pattern, 3, 0, 64),
  [5771] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7908),
  [5773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4625),
  [5775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4861),
  [5777] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type, 1, 0, 0), SHIFT(681),
  [5780] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_type, 1, 0, 0), REDUCE(sym_array_creation_expression, 2, 17, 6), SHIFT(4034),
  [5784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7193),
  [5786] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_constant_pattern, 1, 0, 0), REDUCE(sym_non_lvalue_expression, 1, 0, 0),
  [5789] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_constant_pattern, 1, 0, 0), REDUCE(sym_non_lvalue_expression, 1, 0, 0),
  [5792] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_constant_pattern, 1, 0, 0), REDUCE(sym__expression_statement_expression, 1, 0, 0),
  [5795] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_constant_pattern, 1, 0, 0), REDUCE(sym__expression_statement_expression, 1, 0, 0),
  [5798] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2083),
  [5800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2083),
  [5802] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2158),
  [5804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2158),
  [5806] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7278),
  [5808] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_pattern, 2, 0, 0),
  [5810] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list_pattern, 2, 0, 0),
  [5812] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_variable_designation, 4, 0, 108),
  [5814] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_variable_designation, 4, 0, 108),
  [5816] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__variable_designation, 1, 0, 0),
  [5818] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__variable_designation, 1, 0, 0),
  [5820] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_pattern, 5, 0, 0),
  [5822] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list_pattern, 5, 0, 0),
  [5824] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_var_pattern, 2, 0, 41),
  [5826] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_var_pattern, 2, 0, 41),
  [5828] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1598),
  [5830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1598),
  [5832] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__variable_designation, 1, 0, 4),
  [5834] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration_pattern, 2, 0, 42),
  [5836] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration_pattern, 2, 0, 42),
  [5838] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_recursive_pattern, 2, 0, 41),
  [5840] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_recursive_pattern, 2, 0, 41),
  [5842] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_recursive_pattern, 4, 0, 81),
  [5844] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_recursive_pattern, 4, 0, 81),
  [5846] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_variable_designation, 3, 0, 41),
  [5848] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_variable_designation, 3, 0, 41),
  [5850] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_pattern, 4, 0, 0),
  [5852] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list_pattern, 4, 0, 0),
  [5854] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_is_pattern_expression, 3, 0, 26),
  [5856] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_is_pattern_expression, 3, 0, 26),
  [5858] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_pattern, 3, 0, 0),
  [5860] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list_pattern, 3, 0, 0),
  [5862] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_pattern, 3, 0, 0),
  [5864] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_pattern, 3, 0, 0),
  [5866] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2066),
  [5868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2066),
  [5870] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_variable_designation, 2, 0, 0),
  [5872] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_variable_designation, 2, 0, 0),
  [5874] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_and_pattern, 3, 0, 23),
  [5876] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_and_pattern, 3, 0, 23),
  [5878] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_recursive_pattern, 3, 0, 58),
  [5880] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_recursive_pattern, 3, 0, 58),
  [5882] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4450),
  [5884] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5092),
  [5886] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5207),
  [5888] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8136),
  [5890] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7985),
  [5892] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8165),
  [5894] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8171),
  [5896] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7983),
  [5898] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8027),
  [5900] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1914),
  [5902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1914),
  [5904] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1817),
  [5906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1817),
  [5908] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8093),
  [5910] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7794),
  [5912] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4518),
  [5914] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8100),
  [5916] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9696),
  [5918] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7490),
  [5920] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4991),
  [5922] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type, 1, 0, 0), SHIFT(675),
  [5925] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_type, 1, 0, 0), REDUCE(sym_array_creation_expression, 2, 17, 6), SHIFT(3571),
  [5929] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1407),
  [5931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1407),
  [5933] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1867),
  [5935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1867),
  [5937] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1209),
  [5939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1209),
  [5941] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1244),
  [5943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1244),
  [5945] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_declaration_repeat1, 2, 0, 0), SHIFT_REPEAT(5422),
  [5948] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1253),
  [5950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1253),
  [5952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4737),
  [5954] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7155),
  [5956] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1422),
  [5958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1422),
  [5960] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1456),
  [5962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1456),
  [5964] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1140),
  [5966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1140),
  [5968] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_accessor_declaration, 4, 0, 189),
  [5970] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_accessor_declaration, 4, 0, 189),
  [5972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3023),
  [5974] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_accessor_list_repeat1, 1, 0, 0),
  [5976] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_accessor_list_repeat1, 1, 0, 0),
  [5978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(597),
  [5980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(47),
  [5982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8238),
  [5984] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1278),
  [5986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1278),
  [5988] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2153),
  [5990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2153),
  [5992] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1754),
  [5994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1754),
  [5996] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_accessor_declaration, 3, 0, 156),
  [5998] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_accessor_declaration, 3, 0, 156),
  [6000] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1994),
  [6002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1994),
  [6004] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1192),
  [6006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1192),
  [6008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(596),
  [6010] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1377),
  [6012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1377),
  [6014] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1396),
  [6016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1396),
  [6018] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1542),
  [6020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1542),
  [6022] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7180),
  [6024] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1672),
  [6026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1672),
  [6028] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_accessor_declaration, 2, 0, 128),
  [6030] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_accessor_declaration, 2, 0, 128),
  [6032] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_declaration_repeat1, 2, 0, 0), SHIFT_REPEAT(5472),
  [6035] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_declaration_repeat2, 2, 0, 0), SHIFT_REPEAT(4506),
  [6038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(609),
  [6040] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2116),
  [6042] = {.entry = {.count = 1, .reusable = false}}, SHIFT(690),
  [6044] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4570),
  [6046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4570),
  [6048] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2173),
  [6050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2171),
  [6052] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2171),
  [6054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2170),
  [6056] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2168),
  [6058] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2167),
  [6060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2165),
  [6062] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2165),
  [6064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2163),
  [6066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2116),
  [6068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9089),
  [6070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(262),
  [6072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2160),
  [6074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2154),
  [6076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2135),
  [6078] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4895),
  [6080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(428),
  [6082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9083),
  [6084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8388),
  [6086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(581),
  [6088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(625),
  [6090] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9923),
  [6092] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2872),
  [6094] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5146),
  [6096] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5293),
  [6098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(583),
  [6100] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2999),
  [6102] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2910),
  [6104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(41),
  [6106] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3067),
  [6108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2996),
  [6110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3894),
  [6112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3687),
  [6114] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary_expression, 3, 0, 23),
  [6116] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary_expression, 3, 0, 23),
  [6118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3563),
  [6120] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_range_expression, 3, 0, 0),
  [6122] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_range_expression, 3, 0, 0),
  [6124] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_declaration_repeat2, 2, 0, 0), SHIFT_REPEAT(4533),
  [6127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3069),
  [6129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3333),
  [6131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8561),
  [6133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(578),
  [6135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(614),
  [6137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9927),
  [6139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2981),
  [6141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3859),
  [6143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3918),
  [6145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8633),
  [6147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(584),
  [6149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(619),
  [6151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2961),
  [6153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2917),
  [6155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2973),
  [6157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3880),
  [6159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8460),
  [6161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(582),
  [6163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(623),
  [6165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9916),
  [6167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2774),
  [6169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3567),
  [6171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3583),
  [6173] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_relational_pattern, 2, 0, 0),
  [6175] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_relational_pattern, 2, 0, 0),
  [6177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3185),
  [6179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2953),
  [6181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2978),
  [6183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3074),
  [6185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2831),
  [6187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3210),
  [6189] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type, 1, 0, 0), SHIFT(663),
  [6192] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_type, 1, 0, 0), REDUCE(sym_array_creation_expression, 2, 17, 6), SHIFT(2901),
  [6196] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2873),
  [6198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3496),
  [6200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8475),
  [6202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(579),
  [6204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(613),
  [6206] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9925),
  [6208] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2954),
  [6210] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3928),
  [6212] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3962),
  [6214] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4324),
  [6216] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conditional_expression, 5, 0, 63),
  [6218] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conditional_expression, 5, 0, 63),
  [6220] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ref_expression, 2, 0, 0),
  [6222] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ref_expression, 2, 0, 0),
  [6224] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1685),
  [6226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1685),
  [6228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2998),
  [6230] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_expression, 3, 0, 23),
  [6232] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assignment_expression, 3, 0, 23),
  [6234] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2759),
  [6236] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_throw_expression, 2, 0, 0),
  [6238] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_throw_expression, 2, 0, 0),
  [6240] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3001),
  [6242] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2985),
  [6244] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2926),
  [6246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4973),
  [6248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3586),
  [6250] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3051),
  [6252] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3072),
  [6254] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2991),
  [6256] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1493),
  [6258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1493),
  [6260] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2989),
  [6262] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2933),
  [6264] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1308),
  [6266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1308),
  [6268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4037),
  [6270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3864),
  [6272] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2986),
  [6274] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_group_clause, 4, 0, 0),
  [6276] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_group_clause, 4, 0, 0),
  [6278] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2927),
  [6280] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1158),
  [6282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1158),
  [6284] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_select_clause, 2, 0, 0),
  [6286] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_select_clause, 2, 0, 0),
  [6288] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3060),
  [6290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3233),
  [6292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5315),
  [6294] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2765),
  [6296] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1619),
  [6298] = {.entry = {.count = 1, .reusable = false}}, SHIFT(642),
  [6300] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1620),
  [6302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1623),
  [6304] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1623),
  [6306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1624),
  [6308] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1625),
  [6310] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1626),
  [6312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1630),
  [6314] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1630),
  [6316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1633),
  [6318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1619),
  [6320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8987),
  [6322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(191),
  [6324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1641),
  [6326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1644),
  [6328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1645),
  [6330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4727),
  [6332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(395),
  [6334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8988),
  [6336] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2030),
  [6338] = {.entry = {.count = 1, .reusable = false}}, SHIFT(630),
  [6340] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2033),
  [6342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2036),
  [6344] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2036),
  [6346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2043),
  [6348] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2046),
  [6350] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2047),
  [6352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2049),
  [6354] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2049),
  [6356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2053),
  [6358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2030),
  [6360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(260),
  [6362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2056),
  [6364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2057),
  [6366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2058),
  [6368] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4881),
  [6370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(501),
  [6372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4592),
  [6374] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__query_body_repeat2, 2, 0, 0),
  [6376] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__query_body_repeat2, 2, 0, 0),
  [6378] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__query_body_repeat2, 2, 0, 0), SHIFT_REPEAT(7288),
  [6381] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__query_body, 3, 0, 0),
  [6383] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__query_body, 3, 0, 0),
  [6385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7288),
  [6387] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7304),
  [6389] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4517),
  [6391] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4764),
  [6393] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1586),
  [6395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1586),
  [6397] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_pointer_type_repeat1, 2, 0, 0), SHIFT_REPEAT(4443),
  [6400] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_pointer_type_repeat1, 2, 0, 0), SHIFT_REPEAT(4433),
  [6403] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_pointer_type_repeat1, 2, 0, 0), SHIFT_REPEAT(4639),
  [6406] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_pointer_type_repeat1, 2, 0, 0), SHIFT_REPEAT(5092),
  [6409] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_pointer_type_repeat1, 2, 0, 0), SHIFT_REPEAT(9572),
  [6412] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_pointer_type_repeat1, 2, 0, 0), SHIFT_REPEAT(5090),
  [6415] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_pointer_type_repeat1, 2, 0, 0), SHIFT_REPEAT(8314),
  [6418] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__query_body, 2, 0, 0),
  [6420] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__query_body, 2, 0, 0),
  [6422] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1989),
  [6424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1989),
  [6426] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7283),
  [6428] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1549),
  [6430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1549),
  [6432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4547),
  [6434] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1462),
  [6436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1462),
  [6438] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1354),
  [6440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1354),
  [6442] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1315),
  [6444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1315),
  [6446] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__query_body, 1, 0, 0),
  [6448] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__query_body, 1, 0, 0),
  [6450] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7272),
  [6452] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4747),
  [6454] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2095),
  [6456] = {.entry = {.count = 1, .reusable = false}}, SHIFT(715),
  [6458] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2097),
  [6460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2103),
  [6462] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2103),
  [6464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2121),
  [6466] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2122),
  [6468] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2124),
  [6470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2130),
  [6472] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2130),
  [6474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2131),
  [6476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2095),
  [6478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(317),
  [6480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2138),
  [6482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2150),
  [6484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2151),
  [6486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(443),
  [6488] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4538),
  [6490] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4782),
  [6492] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5236),
  [6494] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4631),
  [6496] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6515),
  [6498] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4528),
  [6500] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4781),
  [6502] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5304),
  [6504] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4885),
  [6506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4561),
  [6508] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2846),
  [6510] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4736),
  [6512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4694),
  [6514] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4751),
  [6516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4750),
  [6518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4600),
  [6520] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4719),
  [6522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4621),
  [6524] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4792),
  [6526] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3163),
  [6528] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3171),
  [6530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4556),
  [6532] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9928),
  [6534] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2855),
  [6536] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3168),
  [6538] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3436),
  [6540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4702),
  [6542] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4775),
  [6544] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_or_pattern, 3, 0, 23),
  [6546] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_or_pattern, 3, 0, 23),
  [6548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(511),
  [6550] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4851),
  [6552] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4726),
  [6554] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4789),
  [6556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4638),
  [6558] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4865),
  [6560] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4879),
  [6562] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4801),
  [6564] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__query_body_repeat2, 2, 0, 0), SHIFT_REPEAT(7307),
  [6567] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4905),
  [6569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7307),
  [6571] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4913),
  [6573] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4902),
  [6575] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4909),
  [6577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4535),
  [6579] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4910),
  [6581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4536),
  [6583] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4893),
  [6585] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4890),
  [6587] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4874),
  [6589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7139),
  [6591] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4835),
  [6593] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4809),
  [6595] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4841),
  [6597] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4654),
  [6599] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4822),
  [6601] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5015),
  [6603] = {.entry = {.count = 1, .reusable = false}}, SHIFT(508),
  [6605] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4826),
  [6607] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_negated_pattern, 2, 0, 0),
  [6609] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_negated_pattern, 2, 0, 0),
  [6611] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4823),
  [6613] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4748),
  [6615] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4803),
  [6617] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4758),
  [6619] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4738),
  [6621] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2760),
  [6623] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4810),
  [6625] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4828),
  [6627] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4891),
  [6629] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1484),
  [6631] = {.entry = {.count = 1, .reusable = false}}, SHIFT(629),
  [6633] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1482),
  [6635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1481),
  [6637] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1481),
  [6639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1475),
  [6641] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1473),
  [6643] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1470),
  [6645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1466),
  [6647] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1466),
  [6649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1465),
  [6651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1484),
  [6653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9902),
  [6655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(286),
  [6657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1458),
  [6659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1446),
  [6661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1438),
  [6663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4833),
  [6665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(432),
  [6667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9908),
  [6669] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1358),
  [6671] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1368),
  [6673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1371),
  [6675] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1371),
  [6677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1376),
  [6679] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1378),
  [6681] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1380),
  [6683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1381),
  [6685] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1381),
  [6687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1383),
  [6689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1358),
  [6691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(225),
  [6693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1387),
  [6695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4734),
  [6697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(436),
  [6699] = {.entry = {.count = 1, .reusable = false}}, SHIFT(714),
  [6701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1388),
  [6703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1389),
  [6705] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1250),
  [6707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1248),
  [6709] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1248),
  [6711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(321),
  [6713] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1254),
  [6715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1246),
  [6717] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1242),
  [6719] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1240),
  [6721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1235),
  [6723] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1235),
  [6725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1229),
  [6727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1254),
  [6729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(499),
  [6731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(409),
  [6733] = {.entry = {.count = 1, .reusable = false}}, SHIFT(672),
  [6735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1228),
  [6737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1225),
  [6739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1223),
  [6741] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__ordering, 1, 0, 0),
  [6743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7650),
  [6745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4408),
  [6747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(379),
  [6749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7314),
  [6751] = {.entry = {.count = 1, .reusable = false}}, SHIFT(476),
  [6753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(410),
  [6755] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__query_body_repeat2, 2, 0, 0), SHIFT_REPEAT(7314),
  [6758] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1977),
  [6760] = {.entry = {.count = 1, .reusable = false}}, SHIFT(692),
  [6762] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1978),
  [6764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1979),
  [6766] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1979),
  [6768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1984),
  [6770] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1990),
  [6772] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2007),
  [6774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2011),
  [6776] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2011),
  [6778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2018),
  [6780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1977),
  [6782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8966),
  [6784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(288),
  [6786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2019),
  [6788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2020),
  [6790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2021),
  [6792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4821),
  [6794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(489),
  [6796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9024),
  [6798] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__query_body_repeat2, 2, 0, 0), SHIFT_REPEAT(7320),
  [6801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7320),
  [6803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7335),
  [6805] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__query_body_repeat2, 2, 0, 0), SHIFT_REPEAT(7335),
  [6808] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7223),
  [6810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(325),
  [6812] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1886),
  [6814] = {.entry = {.count = 1, .reusable = false}}, SHIFT(710),
  [6816] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1885),
  [6818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1884),
  [6820] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1884),
  [6822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1883),
  [6824] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1882),
  [6826] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1880),
  [6828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1879),
  [6830] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1879),
  [6832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1878),
  [6834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1886),
  [6836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1877),
  [6838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1876),
  [6840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1875),
  [6842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(433),
  [6844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(472),
  [6846] = {.entry = {.count = 1, .reusable = false}}, SHIFT(473),
  [6848] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__join_body, 4, 0, 0),
  [6850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2099),
  [6852] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2099),
  [6854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(232),
  [6856] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2101),
  [6858] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2100),
  [6860] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2091),
  [6862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2090),
  [6864] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2090),
  [6866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2089),
  [6868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2101),
  [6870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(385),
  [6872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2098),
  [6874] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1758),
  [6876] = {.entry = {.count = 1, .reusable = false}}, SHIFT(650),
  [6878] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1755),
  [6880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1752),
  [6882] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1752),
  [6884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1750),
  [6886] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1749),
  [6888] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1742),
  [6890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1739),
  [6892] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1739),
  [6894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1736),
  [6896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1758),
  [6898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(344),
  [6900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1727),
  [6902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1722),
  [6904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1716),
  [6906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(503),
  [6908] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2096),
  [6910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2087),
  [6912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2086),
  [6914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2085),
  [6916] = {.entry = {.count = 1, .reusable = false}}, SHIFT(678),
  [6918] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_from_clause, 4, 0, 14),
  [6920] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__simple_name, 1, 0, 0), SHIFT(4427),
  [6923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7163),
  [6925] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2012),
  [6927] = {.entry = {.count = 1, .reusable = false}}, SHIFT(706),
  [6929] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2013),
  [6931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2014),
  [6933] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2014),
  [6935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2016),
  [6937] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2026),
  [6939] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2027),
  [6941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2029),
  [6943] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2029),
  [6945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2034),
  [6947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2012),
  [6949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9345),
  [6951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(227),
  [6953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2038),
  [6955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2039),
  [6957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2040),
  [6959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4723),
  [6961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(412),
  [6963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9338),
  [6965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7273),
  [6967] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let_clause, 4, 0, 0),
  [6969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(453),
  [6971] = {.entry = {.count = 1, .reusable = false}}, SHIFT(440),
  [6973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(586),
  [6975] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__query_body_repeat2, 2, 0, 0), SHIFT_REPEAT(7273),
  [6978] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_where_clause, 2, 0, 0),
  [6980] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_from_clause, 5, 0, 30),
  [6982] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8314),
  [6984] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1713),
  [6986] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1712),
  [6988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1711),
  [6990] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1711),
  [6992] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1707),
  [6994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1704),
  [6996] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1704),
  [6998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1703),
  [7000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1713),
  [7002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(233),
  [7004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(463),
  [7006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8983),
  [7008] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8572),
  [7010] = {.entry = {.count = 1, .reusable = false}}, SHIFT(654),
  [7012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1710),
  [7014] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1709),
  [7016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1702),
  [7018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1701),
  [7020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1700),
  [7022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(605),
  [7024] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2076),
  [7026] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5730),
  [7028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5730),
  [7030] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2073),
  [7032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2071),
  [7034] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2071),
  [7036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2054),
  [7038] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2054),
  [7040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2076),
  [7042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9690),
  [7044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(237),
  [7046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4746),
  [7048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(416),
  [7050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9689),
  [7052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2062),
  [7054] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2059),
  [7056] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2055),
  [7058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2052),
  [7060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2044),
  [7062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9898),
  [7064] = {.entry = {.count = 1, .reusable = false}}, SHIFT(688),
  [7066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2041),
  [7068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2010),
  [7070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9375),
  [7072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9189),
  [7074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9095),
  [7076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(231),
  [7078] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2107),
  [7080] = {.entry = {.count = 1, .reusable = false}}, SHIFT(637),
  [7082] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2109),
  [7084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2110),
  [7086] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2110),
  [7088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2111),
  [7090] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2112),
  [7092] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2113),
  [7094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2114),
  [7096] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2114),
  [7098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2115),
  [7100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2107),
  [7102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2117),
  [7104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2118),
  [7106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2119),
  [7108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(376),
  [7110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7280),
  [7112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9715),
  [7114] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type, 1, 0, 0), SHIFT(704),
  [7117] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_type, 1, 0, 0), REDUCE(sym_array_creation_expression, 2, 17, 6), SHIFT(5371),
  [7121] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__query_body_repeat2, 2, 0, 0), SHIFT_REPEAT(7280),
  [7124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(269),
  [7126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7323),
  [7128] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2191),
  [7130] = {.entry = {.count = 1, .reusable = false}}, SHIFT(670),
  [7132] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2190),
  [7134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2189),
  [7136] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2189),
  [7138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2188),
  [7140] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2187),
  [7142] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2186),
  [7144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2185),
  [7146] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2185),
  [7148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2184),
  [7150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2191),
  [7152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(243),
  [7154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2182),
  [7156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2179),
  [7158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2178),
  [7160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(500),
  [7162] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2080),
  [7164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2082),
  [7166] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2082),
  [7168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(234),
  [7170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2127),
  [7172] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2127),
  [7174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(272),
  [7176] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1795),
  [7178] = {.entry = {.count = 1, .reusable = false}}, SHIFT(644),
  [7180] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1796),
  [7182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1799),
  [7184] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1799),
  [7186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1800),
  [7188] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1801),
  [7190] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1802),
  [7192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1804),
  [7194] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1804),
  [7196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1806),
  [7198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1795),
  [7200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(261),
  [7202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1809),
  [7204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1814),
  [7206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1816),
  [7208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4784),
  [7210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(477),
  [7212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4098),
  [7214] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2079),
  [7216] = {.entry = {.count = 1, .reusable = false}}, SHIFT(668),
  [7218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2102),
  [7220] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2106),
  [7222] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2108),
  [7224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2129),
  [7226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2079),
  [7228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2132),
  [7230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2133),
  [7232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2141),
  [7234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4766),
  [7236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(506),
  [7238] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1440),
  [7240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1439),
  [7242] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1439),
  [7244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1432),
  [7246] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1432),
  [7248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4392),
  [7250] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__array_base_type, 1, 0, 0),
  [7252] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pointer_base_type, 1, 0, 0),
  [7254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2901),
  [7256] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1443),
  [7258] = {.entry = {.count = 1, .reusable = false}}, SHIFT(702),
  [7260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1437),
  [7262] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1436),
  [7264] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1434),
  [7266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1431),
  [7268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1443),
  [7270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1428),
  [7272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1426),
  [7274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1425),
  [7276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4827),
  [7278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(413),
  [7280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(494),
  [7282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(493),
  [7284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4027),
  [7286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5403),
  [7288] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type, 1, 0, 0), SHIFT(5371),
  [7291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7161),
  [7293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5386),
  [7295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1856),
  [7297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(703),
  [7299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1854),
  [7301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1853),
  [7303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1853),
  [7305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1852),
  [7307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1850),
  [7309] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1849),
  [7311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1848),
  [7313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1848),
  [7315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1847),
  [7317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1856),
  [7319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1840),
  [7321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1838),
  [7323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1836),
  [7325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(464),
  [7327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3715),
  [7329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3684),
  [7331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(393),
  [7333] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3127),
  [7335] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3146),
  [7337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(223),
  [7339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4521),
  [7341] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_expression, 4, 0, 37),
  [7343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9483),
  [7345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1390),
  [7347] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1515),
  [7349] = {.entry = {.count = 1, .reusable = false}}, SHIFT(671),
  [7351] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1518),
  [7353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1519),
  [7355] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1519),
  [7357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1531),
  [7359] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1534),
  [7361] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1536),
  [7363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1537),
  [7365] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1537),
  [7367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1539),
  [7369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1515),
  [7371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(255),
  [7373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1545),
  [7375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1548),
  [7377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1566),
  [7379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(492),
  [7381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8551),
  [7383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7227),
  [7385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(394),
  [7387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8250),
  [7389] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__query_body_repeat2, 2, 0, 0), SHIFT_REPEAT(7323),
  [7392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5556),
  [7394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7254),
  [7396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7172),
  [7398] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1207),
  [7400] = {.entry = {.count = 1, .reusable = false}}, SHIFT(652),
  [7402] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1212),
  [7404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1216),
  [7406] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1216),
  [7408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1227),
  [7410] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1230),
  [7412] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1233),
  [7414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1234),
  [7416] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1234),
  [7418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1238),
  [7420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1207),
  [7422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(294),
  [7424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1239),
  [7426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1241),
  [7428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1243),
  [7430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4759),
  [7432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(454),
  [7434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(240),
  [7436] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2008),
  [7438] = {.entry = {.count = 1, .reusable = false}}, SHIFT(676),
  [7440] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2006),
  [7442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2005),
  [7444] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2005),
  [7446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2004),
  [7448] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2003),
  [7450] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2002),
  [7452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2001),
  [7454] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2001),
  [7456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2000),
  [7458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2008),
  [7460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(238),
  [7462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1998),
  [7464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1997),
  [7466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1996),
  [7468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7342),
  [7470] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1868),
  [7472] = {.entry = {.count = 1, .reusable = false}}, SHIFT(639),
  [7474] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1869),
  [7476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1872),
  [7478] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1872),
  [7480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1891),
  [7482] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1893),
  [7484] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1897),
  [7486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1900),
  [7488] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1900),
  [7490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1902),
  [7492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1868),
  [7494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1909),
  [7496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1912),
  [7498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1913),
  [7500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(502),
  [7502] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__query_body_repeat2, 2, 0, 0), SHIFT_REPEAT(7342),
  [7505] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1610),
  [7507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1609),
  [7509] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1609),
  [7511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(290),
  [7513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1604),
  [7515] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1604),
  [7517] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2152),
  [7519] = {.entry = {.count = 1, .reusable = false}}, SHIFT(709),
  [7521] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2149),
  [7523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2148),
  [7525] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2148),
  [7527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2146),
  [7529] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2145),
  [7531] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2144),
  [7533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2143),
  [7535] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2143),
  [7537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2142),
  [7539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2152),
  [7541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(258),
  [7543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2140),
  [7545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2139),
  [7547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2137),
  [7549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(465),
  [7551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(504),
  [7553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(505),
  [7555] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1511),
  [7557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1510),
  [7559] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1510),
  [7561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1506),
  [7563] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1506),
  [7565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(278),
  [7567] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1513),
  [7569] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1507),
  [7571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1505),
  [7573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1513),
  [7575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4774),
  [7577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(400),
  [7579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1509),
  [7581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(486),
  [7583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(485),
  [7585] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1395),
  [7587] = {.entry = {.count = 1, .reusable = false}}, SHIFT(647),
  [7589] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1397),
  [7591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1398),
  [7593] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1398),
  [7595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1399),
  [7597] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1400),
  [7599] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1401),
  [7601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1402),
  [7603] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1402),
  [7605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1403),
  [7607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1395),
  [7609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(254),
  [7611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1404),
  [7613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1405),
  [7615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1406),
  [7617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(509),
  [7619] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1226),
  [7621] = {.entry = {.count = 1, .reusable = false}}, SHIFT(632),
  [7623] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1224),
  [7625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1222),
  [7627] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1222),
  [7629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1221),
  [7631] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1220),
  [7633] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1219),
  [7635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1218),
  [7637] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1218),
  [7639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1217),
  [7641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1226),
  [7643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(244),
  [7645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1215),
  [7647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1214),
  [7649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1213),
  [7651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4754),
  [7653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(488),
  [7655] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1508),
  [7657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1504),
  [7659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1503),
  [7661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1501),
  [7663] = {.entry = {.count = 1, .reusable = false}}, SHIFT(705),
  [7665] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1615),
  [7667] = {.entry = {.count = 1, .reusable = false}}, SHIFT(685),
  [7669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1608),
  [7671] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1606),
  [7673] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1605),
  [7675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1603),
  [7677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1615),
  [7679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1601),
  [7681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1600),
  [7683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1599),
  [7685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4889),
  [7687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(445),
  [7689] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1935),
  [7691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1934),
  [7693] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1934),
  [7695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1926),
  [7697] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1926),
  [7699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(274),
  [7701] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1940),
  [7703] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1929),
  [7705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1922),
  [7707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1940),
  [7709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(390),
  [7711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1932),
  [7713] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1930),
  [7715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1911),
  [7717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1910),
  [7719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1908),
  [7721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(422),
  [7723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7286),
  [7725] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__query_body_repeat2, 2, 0, 0), SHIFT_REPEAT(7286),
  [7728] = {.entry = {.count = 1, .reusable = false}}, SHIFT(687),
  [7730] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1266),
  [7732] = {.entry = {.count = 1, .reusable = false}}, SHIFT(657),
  [7734] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1265),
  [7736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1264),
  [7738] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1264),
  [7740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1263),
  [7742] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1262),
  [7744] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1261),
  [7746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1260),
  [7748] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1260),
  [7750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1259),
  [7752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1266),
  [7754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(285),
  [7756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1257),
  [7758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1256),
  [7760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1255),
  [7762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4878),
  [7764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(451),
  [7766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7169),
  [7768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7275),
  [7770] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__query_body_repeat2, 2, 0, 0), SHIFT_REPEAT(7275),
  [7773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(498),
  [7775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(740),
  [7777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3728),
  [7779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(419),
  [7781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2280),
  [7783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4740),
  [7785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(291),
  [7787] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1333),
  [7789] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1334),
  [7791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1336),
  [7793] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1336),
  [7795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1342),
  [7797] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1342),
  [7799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1343),
  [7801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1333),
  [7803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(282),
  [7805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4856),
  [7807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(452),
  [7809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1337),
  [7811] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1341),
  [7813] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument, 4, 0, 4),
  [7815] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 4, 0, 12),
  [7817] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 4, 0, 14),
  [7819] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_tuple_element, 1, 0, 5), REDUCE(sym_type_pattern, 1, 0, 5),
  [7822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2126),
  [7824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3887),
  [7826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1650),
  [7828] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1420),
  [7830] = {.entry = {.count = 1, .reusable = false}}, SHIFT(646),
  [7832] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1514),
  [7834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1516),
  [7836] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1516),
  [7838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1517),
  [7840] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1520),
  [7842] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1521),
  [7844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1522),
  [7846] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1522),
  [7848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1523),
  [7850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1420),
  [7852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1524),
  [7854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1525),
  [7856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1528),
  [7858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4870),
  [7860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(457),
  [7862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3694),
  [7864] = {.entry = {.count = 1, .reusable = false}}, SHIFT(648),
  [7866] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1339),
  [7868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1346),
  [7870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1347),
  [7872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1349),
  [7874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(263),
  [7876] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1181),
  [7878] = {.entry = {.count = 1, .reusable = false}}, SHIFT(653),
  [7880] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1180),
  [7882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1179),
  [7884] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1179),
  [7886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1178),
  [7888] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1176),
  [7890] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1174),
  [7892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1171),
  [7894] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1171),
  [7896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1170),
  [7898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1181),
  [7900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(292),
  [7902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1169),
  [7904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1168),
  [7906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1165),
  [7908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4769),
  [7910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(447),
  [7912] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1627),
  [7914] = {.entry = {.count = 1, .reusable = false}}, SHIFT(665),
  [7916] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1628),
  [7918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1632),
  [7920] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1632),
  [7922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1634),
  [7924] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1636),
  [7926] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1638),
  [7928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1639),
  [7930] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1639),
  [7932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1642),
  [7934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1627),
  [7936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1643),
  [7938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1646),
  [7940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1649),
  [7942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(466),
  [7944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3600),
  [7946] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1768),
  [7948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1767),
  [7950] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1767),
  [7952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1763),
  [7954] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1763),
  [7956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(259),
  [7958] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1770),
  [7960] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1764),
  [7962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1761),
  [7964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1770),
  [7966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1766),
  [7968] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument, 2, 0, 0),
  [7970] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1765),
  [7972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1759),
  [7974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1757),
  [7976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1756),
  [7978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2694),
  [7980] = {.entry = {.count = 1, .reusable = false}}, SHIFT(680),
  [7982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(840),
  [7984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4593),
  [7986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1941),
  [7988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(179),
  [7990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2042),
  [7992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(938),
  [7994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1635),
  [7996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1965),
  [7998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1530),
  [8000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1424),
  [8002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1352),
  [8004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7293),
  [8006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1661),
  [8008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1162),
  [8010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(721),
  [8012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5679),
  [8014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2025),
  [8016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(441),
  [8018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(446),
  [8020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(252),
  [8022] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1327),
  [8024] = {.entry = {.count = 1, .reusable = false}}, SHIFT(686),
  [8026] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1326),
  [8028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1325),
  [8030] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1325),
  [8032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1324),
  [8034] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1323),
  [8036] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1322),
  [8038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1321),
  [8040] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1321),
  [8042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1319),
  [8044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1327),
  [8046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1318),
  [8048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1317),
  [8050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1316),
  [8052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(421),
  [8054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1314),
  [8056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3396),
  [8058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(152),
  [8060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(479),
  [8062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1595),
  [8064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2147),
  [8066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(182),
  [8068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(247),
  [8070] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1949),
  [8072] = {.entry = {.count = 1, .reusable = false}}, SHIFT(658),
  [8074] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1950),
  [8076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1951),
  [8078] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1951),
  [8080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1952),
  [8082] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1953),
  [8084] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1954),
  [8086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1955),
  [8088] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1955),
  [8090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1956),
  [8092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1949),
  [8094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1957),
  [8096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1959),
  [8098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1960),
  [8100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4731),
  [8102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(411),
  [8104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(155),
  [8106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(148),
  [8108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(72),
  [8110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(75),
  [8112] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 5, 0, 30),
  [8114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(87),
  [8116] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument, 1, 0, 0),
  [8118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(420),
  [8120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1499),
  [8122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(171),
  [8124] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_member_declaration, 3, 0, 72),
  [8126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(115),
  [8128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(113),
  [8130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2009),
  [8132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1696),
  [8134] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_member_declaration, 4, 0, 99),
  [8136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(82),
  [8138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(78),
  [8140] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__query_body_repeat2, 2, 0, 0), SHIFT_REPEAT(7293),
  [8143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(817),
  [8145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(64),
  [8147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2081),
  [8149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1906),
  [8151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3936),
  [8153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(878),
  [8155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1002),
  [8157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3947),
  [8159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(481),
  [8161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(167),
  [8163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(165),
  [8165] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__query_body_repeat2, 2, 0, 0), SHIFT_REPEAT(7361),
  [8168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7305),
  [8170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1089),
  [8172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3634),
  [8174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1833),
  [8176] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__query_body_repeat2, 2, 0, 0), SHIFT_REPEAT(7305),
  [8179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1251),
  [8181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(810),
  [8183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2966),
  [8185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7361),
  [8187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1245),
  [8189] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_for_statement_repeat1, 2, 0, 0),
  [8191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1419),
  [8193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1408),
  [8195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(77),
  [8197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7292),
  [8199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(81),
  [8201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(92),
  [8203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5301),
  [8205] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__query_body_repeat2, 2, 0, 0), SHIFT_REPEAT(7292),
  [8208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7297),
  [8210] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__query_body_repeat2, 2, 0, 0), SHIFT_REPEAT(7297),
  [8213] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 6, 0, 47),
  [8215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(437),
  [8217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2157),
  [8219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5344),
  [8221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2061),
  [8223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(99),
  [8225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(100),
  [8227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(119),
  [8229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(121),
  [8231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(872),
  [8233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4212),
  [8235] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 3, 0, 4),
  [8237] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument, 3, 0, 4),
  [8239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(132),
  [8241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7249),
  [8243] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1298),
  [8245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(655),
  [8247] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1297),
  [8249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1296),
  [8251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1296),
  [8253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1295),
  [8255] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1294),
  [8257] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1293),
  [8259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1292),
  [8261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1292),
  [8263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1291),
  [8265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1298),
  [8267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(353),
  [8269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1289),
  [8271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1288),
  [8273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1287),
  [8275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4849),
  [8277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(397),
  [8279] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7840),
  [8281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7829),
  [8283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6263),
  [8285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6266),
  [8287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8143),
  [8289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8917),
  [8291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8065),
  [8293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1153),
  [8295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1151),
  [8297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1148),
  [8299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1148),
  [8301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1147),
  [8303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1145),
  [8305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1142),
  [8307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1141),
  [8309] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1141),
  [8311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1161),
  [8313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1153),
  [8315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(314),
  [8317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(483),
  [8319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(462),
  [8321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(461),
  [8323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(392),
  [8325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(399),
  [8327] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 3, 0, 4),
  [8329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(336),
  [8331] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 3, 0, 0),
  [8333] = {.entry = {.count = 1, .reusable = false}}, SHIFT(628),
  [8335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1175),
  [8337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1183),
  [8339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1184),
  [8341] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1669),
  [8343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(689),
  [8345] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1667),
  [8347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1665),
  [8349] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1665),
  [8351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1664),
  [8353] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1663),
  [8355] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1662),
  [8357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1660),
  [8359] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1660),
  [8361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1659),
  [8363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1669),
  [8365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1658),
  [8367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1657),
  [8369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1654),
  [8371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4844),
  [8373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(460),
  [8375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(442),
  [8377] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 4, 0, 0),
  [8379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(387),
  [8381] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 4, 0, 4),
  [8383] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__anonymous_object_member_declarator, 3, 0, 0),
  [8385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8823),
  [8387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8955),
  [8389] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__anonymous_object_member_declarator, 1, 0, 0),
  [8391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6871),
  [8393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(224),
  [8395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6148),
  [8397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6210),
  [8399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8179),
  [8401] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1480),
  [8403] = {.entry = {.count = 1, .reusable = false}}, SHIFT(659),
  [8405] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1479),
  [8407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1478),
  [8409] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1478),
  [8411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1477),
  [8413] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1476),
  [8415] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1474),
  [8417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1472),
  [8419] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1472),
  [8421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1471),
  [8423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1480),
  [8425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(348),
  [8427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1468),
  [8429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1467),
  [8431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1464),
  [8433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4848),
  [8435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(430),
  [8437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2262),
  [8439] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7170),
  [8441] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_array_rank_specifier_repeat1, 2, 0, 0),
  [8443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8890),
  [8445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(495),
  [8447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(375),
  [8449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7209),
  [8451] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpolation_alignment_clause, 2, 0, 0),
  [8453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7214),
  [8455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(386),
  [8457] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_using_variable_declarator, 3, 0, 4),
  [8459] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_argument, 3, 0, 0),
  [8461] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_argument, 1, 0, 0),
  [8463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(417),
  [8465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(414),
  [8467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7234),
  [8469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8953),
  [8471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(490),
  [8473] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_declaration_repeat1, 2, 0, 0), SHIFT_REPEAT(5714),
  [8476] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_expression_arm, 3, 0, 0),
  [8478] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_initializer, 3, 0, 0),
  [8480] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_expression_arm, 4, 0, 0),
  [8482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1303),
  [8484] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1564),
  [8486] = {.entry = {.count = 1, .reusable = false}}, SHIFT(682),
  [8488] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1562),
  [8490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1561),
  [8492] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1561),
  [8494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1560),
  [8496] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1559),
  [8498] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1558),
  [8500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1557),
  [8502] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1557),
  [8504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1555),
  [8506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1564),
  [8508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(308),
  [8510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1553),
  [8512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1552),
  [8514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1551),
  [8516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(402),
  [8518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2470),
  [8520] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1276),
  [8522] = {.entry = {.count = 1, .reusable = false}}, SHIFT(707),
  [8524] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1277),
  [8526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1279),
  [8528] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1279),
  [8530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1280),
  [8532] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1283),
  [8534] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1164),
  [8536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1301),
  [8538] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1301),
  [8540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1302),
  [8542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1276),
  [8544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(347),
  [8546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1307),
  [8548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1310),
  [8550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1313),
  [8552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4820),
  [8554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(403),
  [8556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(383),
  [8558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(384),
  [8560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4679),
  [8562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(449),
  [8564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(398),
  [8566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1589),
  [8568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(97),
  [8570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(73),
  [8572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(129),
  [8574] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1374),
  [8576] = {.entry = {.count = 1, .reusable = false}}, SHIFT(700),
  [8578] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1372),
  [8580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1369),
  [8582] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1369),
  [8584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1366),
  [8586] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1365),
  [8588] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1364),
  [8590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1363),
  [8592] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1363),
  [8594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1362),
  [8596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1374),
  [8598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(340),
  [8600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1360),
  [8602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1359),
  [8604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1357),
  [8606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1724),
  [8608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4853),
  [8610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(408),
  [8612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(135),
  [8614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7271),
  [8616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1022),
  [8618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(96),
  [8620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1154),
  [8622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1719),
  [8624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1730),
  [8626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(133),
  [8628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6953),
  [8630] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7364),
  [8632] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8843),
  [8634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2662),
  [8636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1386),
  [8638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2166),
  [8640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1982),
  [8642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1487),
  [8644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1737),
  [8646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1191),
  [8648] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1690),
  [8650] = {.entry = {.count = 1, .reusable = false}}, SHIFT(664),
  [8652] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1689),
  [8654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1683),
  [8656] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1683),
  [8658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1680),
  [8660] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1677),
  [8662] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1675),
  [8664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1674),
  [8666] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1674),
  [8668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1673),
  [8670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1690),
  [8672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(307),
  [8674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1670),
  [8676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1668),
  [8678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1666),
  [8680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(382),
  [8682] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7367),
  [8684] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8779),
  [8686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(792),
  [8688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4876),
  [8690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(164),
  [8692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1823),
  [8694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(759),
  [8696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1543),
  [8698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5622),
  [8700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2648),
  [8702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1698),
  [8704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(117),
  [8706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4224),
  [8708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9504),
  [8710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(128),
  [8712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2074),
  [8714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(768),
  [8716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7266),
  [8718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(134),
  [8720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1410),
  [8722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(102),
  [8724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(429),
  [8726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2284),
  [8728] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_when_clause, 2, 0, 0),
  [8730] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1418),
  [8732] = {.entry = {.count = 1, .reusable = false}}, SHIFT(708),
  [8734] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1421),
  [8736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1429),
  [8738] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1429),
  [8740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1430),
  [8742] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1435),
  [8744] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1442),
  [8746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1449),
  [8748] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1449),
  [8750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1452),
  [8752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1418),
  [8754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(333),
  [8756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1453),
  [8758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1455),
  [8760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1457),
  [8762] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__join_header, 4, 0, 5),
  [8764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4762),
  [8766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(510),
  [8768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(104),
  [8770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(106),
  [8772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(751),
  [8774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9656),
  [8776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1686),
  [8778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1550),
  [8780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7347),
  [8782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4687),
  [8784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2241),
  [8786] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__query_body_repeat2, 2, 0, 0), SHIFT_REPEAT(7347),
  [8789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2028),
  [8791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1195),
  [8793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1921),
  [8795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(127),
  [8797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1963),
  [8799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1597),
  [8801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4689),
  [8803] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1568),
  [8805] = {.entry = {.count = 1, .reusable = false}}, SHIFT(711),
  [8807] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1570),
  [8809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1571),
  [8811] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1571),
  [8813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1575),
  [8815] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1576),
  [8817] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1577),
  [8819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1578),
  [8821] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1578),
  [8823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1581),
  [8825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1568),
  [8827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(316),
  [8829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1582),
  [8831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1583),
  [8833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1584),
  [8835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(434),
  [8837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1247),
  [8839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(456),
  [8841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(455),
  [8843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(743),
  [8845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1671),
  [8847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5608),
  [8849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1958),
  [8851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(112),
  [8853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9094),
  [8855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(150),
  [8857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(156),
  [8859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9818),
  [8861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4887),
  [8863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(806),
  [8865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(995),
  [8867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2498),
  [8869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1167),
  [8871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1961),
  [8873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1274),
  [8875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3258),
  [8877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7359),
  [8879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9768),
  [8881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3949),
  [8883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(968),
  [8885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1335),
  [8887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(140),
  [8889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3427),
  [8891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1433),
  [8893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1338),
  [8895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1451),
  [8897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23),
  [8899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3468),
  [8901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(149),
  [8903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1249),
  [8905] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_else_in_expression, 2, 0, 0),
  [8907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2161),
  [8909] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__query_body_repeat2, 2, 0, 0), SHIFT_REPEAT(7271),
  [8912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2015),
  [8914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1197),
  [8916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1729),
  [8918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1622),
  [8920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(153),
  [8922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8839),
  [8924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1678),
  [8926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1844),
  [8928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1733),
  [8930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1621),
  [8932] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_expression_clause, 2, 0, 0),
  [8934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(491),
  [8936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8844),
  [8938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4589),
  [8940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1527),
  [8942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4771),
  [8944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1851),
  [8946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2084),
  [8948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3961),
  [8950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4785),
  [8952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4062),
  [8954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3957),
  [8956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2668),
  [8958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1966),
  [8960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3628),
  [8962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1596),
  [8964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(125),
  [8966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1919),
  [8968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(478),
  [8970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(474),
  [8972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(139),
  [8974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(480),
  [8976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1409),
  [8978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1331),
  [8980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1890),
  [8982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(482),
  [8984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5609),
  [8986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2247),
  [8988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1611),
  [8990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5680),
  [8992] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7365),
  [8994] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8679),
  [8996] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_attribute, 1, 0, 4), REDUCE(sym_type, 1, 0, 0),
  [8999] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type, 1, 0, 0), SHIFT(699),
  [9002] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__query_body_repeat2, 2, 0, 0), SHIFT_REPEAT(7266),
  [9005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1485),
  [9007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1983),
  [9009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1863),
  [9011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2128),
  [9013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3278),
  [9015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1569),
  [9017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3238),
  [9019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(69),
  [9021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1927),
  [9023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(448),
  [9025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2720),
  [9027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4834),
  [9029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1119),
  [9031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3771),
  [9033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3773),
  [9035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(151),
  [9037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7136),
  [9039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4908),
  [9041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1631),
  [9043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1928),
  [9045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2069),
  [9047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1454),
  [9049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1149),
  [9051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(80),
  [9053] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__join_header, 3, 0, 0),
  [9055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1469),
  [9057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3656),
  [9059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4159),
  [9061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4160),
  [9063] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__query_body_repeat2, 2, 0, 0), SHIFT_REPEAT(7359),
  [9066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1494),
  [9068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1492),
  [9070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(174),
  [9072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3458),
  [9074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1629),
  [9076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4172),
  [9078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(175),
  [9080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(170),
  [9082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(177),
  [9084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3714),
  [9086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8816),
  [9088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2467),
  [9090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(108),
  [9092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(137),
  [9094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(159),
  [9096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2159),
  [9098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1588),
  [9100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1332),
  [9102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1529),
  [9104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8809),
  [9106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(181),
  [9108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2078),
  [9110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(953),
  [9112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1526),
  [9114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1945),
  [9116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(764),
  [9118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(111),
  [9120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2481),
  [9122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(110),
  [9124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(162),
  [9126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3680),
  [9128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3677),
  [9130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2183),
  [9132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7207),
  [9134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7171),
  [9136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7215),
  [9138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7242),
  [9140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7241),
  [9142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7239),
  [9144] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1797),
  [9146] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 2, 0, 14),
  [9148] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__simple_name, 1, 0, 0), SHIFT(3640),
  [9151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1797),
  [9153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8725),
  [9155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6825),
  [9157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6175),
  [9159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8847),
  [9161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7152),
  [9163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7147),
  [9165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2480),
  [9167] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_enum_member_declaration, 3, 0, 37),
  [9169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7243),
  [9171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7199),
  [9173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1985),
  [9175] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_parameter, 1, 0, 4), SHIFT(7042),
  [9178] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_parameter, 1, 0, 4), SHIFT(7902),
  [9181] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 1, 0, 4),
  [9183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6745),
  [9185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4846),
  [9187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7182),
  [9189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7140),
  [9191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4824),
  [9193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9296),
  [9195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9301),
  [9197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6216),
  [9199] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__simple_name, 1, 0, 0), SHIFT(7042),
  [9202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7902),
  [9204] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 1, 0, 4),
  [9206] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4644),
  [9208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2376),
  [9210] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6819),
  [9212] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6774),
  [9214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4348),
  [9216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9743),
  [9218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3739),
  [9220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2386),
  [9222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4363),
  [9224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3766),
  [9226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4473),
  [9228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2576),
  [9230] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__parameter_type_with_modifiers_repeat1, 2, 0, 0),
  [9232] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__parameter_type_with_modifiers_repeat1, 2, 0, 0),
  [9234] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__parameter_type_with_modifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(6773),
  [9237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4500),
  [9239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6812),
  [9241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6778),
  [9243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4380),
  [9245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3746),
  [9247] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4529),
  [9249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6702),
  [9251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9856),
  [9253] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6794),
  [9255] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6779),
  [9257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7260),
  [9259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4448),
  [9261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2558),
  [9263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7264),
  [9265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7256),
  [9267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6679),
  [9269] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4683),
  [9271] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6833),
  [9273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6788),
  [9275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6678),
  [9277] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6859),
  [9279] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6851),
  [9281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6796),
  [9283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2072),
  [9285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1448),
  [9287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6811),
  [9289] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_element, 1, 0, 5),
  [9291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3640),
  [9293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2162),
  [9295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1652),
  [9297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3549),
  [9299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1187),
  [9301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1286),
  [9303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1705),
  [9305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1350),
  [9307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2134),
  [9309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4699),
  [9311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1613),
  [9313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1544),
  [9315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7250),
  [9317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1488),
  [9319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1574),
  [9321] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_else_in_enum_member_declaration, 1, 0, 0),
  [9323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1463),
  [9325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1976),
  [9327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5407),
  [9329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1441),
  [9331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1918),
  [9333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4056),
  [9335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1591),
  [9337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1873),
  [9339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1193),
  [9341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1751),
  [9343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7274),
  [9345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2174),
  [9347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1980),
  [9349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1300),
  [9351] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_lambda_expression_repeat1, 2, 0, 0),
  [9353] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_lambda_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(6917),
  [9356] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_lambda_expression_repeat1, 2, 0, 0),
  [9358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(303),
  [9360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1206),
  [9362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4103),
  [9364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4972),
  [9366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7189),
  [9368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7157),
  [9370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7133),
  [9372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7220),
  [9374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7195),
  [9376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7235),
  [9378] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_function_pointer_type_repeat1, 2, 0, 0),
  [9380] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_function_pointer_type_repeat1, 2, 0, 0),
  [9382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7183),
  [9384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7143),
  [9386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7200),
  [9388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2560),
  [9390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7162),
  [9392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7184),
  [9394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7191),
  [9396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2378),
  [9398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7217),
  [9400] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8374),
  [9402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7244),
  [9404] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8713),
  [9406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7138),
  [9408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7158),
  [9410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7194),
  [9412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7181),
  [9414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7201),
  [9416] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_explicit_interface_specifier, 2, 0, 0), SHIFT(2733),
  [9419] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_explicit_interface_specifier, 2, 0, 0), SHIFT(2732),
  [9422] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_explicit_interface_specifier, 2, 0, 0),
  [9424] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_lambda_expression_repeat1, 1, 0, 1),
  [9426] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_lambda_expression_repeat1, 1, 0, 1),
  [9428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7154),
  [9430] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8826),
  [9432] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_declaration_repeat1, 2, 0, 0), SHIFT_REPEAT(5741),
  [9435] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3195),
  [9437] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3197),
  [9439] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7350),
  [9441] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2827),
  [9443] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2818),
  [9445] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2799),
  [9447] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2806),
  [9449] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6696),
  [9451] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6694),
  [9453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4121),
  [9455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4052),
  [9457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4646),
  [9459] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7324),
  [9461] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7317),
  [9463] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3397),
  [9465] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3392),
  [9467] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7296),
  [9469] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7346),
  [9471] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3187),
  [9473] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3165),
  [9475] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7369),
  [9477] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8745),
  [9479] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7351),
  [9481] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8657),
  [9483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9952),
  [9485] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8724),
  [9487] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8677),
  [9489] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8306),
  [9491] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8678),
  [9493] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8662),
  [9495] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9929),
  [9497] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9926),
  [9499] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9924),
  [9501] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [9503] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7284),
  [9505] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3873),
  [9507] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3875),
  [9509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3749),
  [9511] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2993),
  [9513] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2987),
  [9515] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7309),
  [9517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5579),
  [9519] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7368),
  [9521] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8862),
  [9523] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7281),
  [9525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3705),
  [9527] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7366),
  [9529] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8789),
  [9531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8752),
  [9533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8797),
  [9535] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8790),
  [9537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7372),
  [9539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8790),
  [9541] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8860),
  [9543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7370),
  [9545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8860),
  [9547] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8693),
  [9549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7371),
  [9551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8693),
  [9553] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8683),
  [9555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7374),
  [9557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8683),
  [9559] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8897),
  [9561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7373),
  [9563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8897),
  [9565] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8852),
  [9567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7376),
  [9569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8852),
  [9571] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8814),
  [9573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8814),
  [9575] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8932),
  [9577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8932),
  [9579] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute_target_specifier, 2, 0, 0),
  [9581] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8895),
  [9583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8895),
  [9585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1822),
  [9587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4802),
  [9589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4572),
  [9591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7319),
  [9593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(902),
  [9595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1829),
  [9597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1831),
  [9599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1285),
  [9601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1483),
  [9603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1198),
  [9605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1718),
  [9607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1412),
  [9609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1328),
  [9611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1656),
  [9613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1915),
  [9615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1320),
  [9617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1353),
  [9619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1271),
  [9621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1695),
  [9623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1188),
  [9625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1735),
  [9627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1200),
  [9629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1987),
  [9631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1309),
  [9633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1208),
  [9635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1270),
  [9637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1587),
  [9639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1284),
  [9641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1590),
  [9643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1196),
  [9645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1723),
  [9647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1903),
  [9649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2125),
  [9651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1194),
  [9653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1728),
  [9655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1379),
  [9657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1993),
  [9659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1413),
  [9661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1602),
  [9663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1329),
  [9665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1547),
  [9667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1370),
  [9669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1753),
  [9671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1275),
  [9673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1684),
  [9675] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 1, 0, 4),
  [9677] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2045),
  [9679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3669),
  [9681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3781),
  [9683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1540),
  [9685] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__query_body_repeat1, 2, 0, 0), SHIFT_REPEAT(1822),
  [9688] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__query_body_repeat1, 2, 0, 0), SHIFT_REPEAT(4802),
  [9691] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__query_body_repeat1, 2, 0, 0), SHIFT_REPEAT(4572),
  [9694] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__query_body_repeat1, 2, 0, 0), SHIFT_REPEAT(7319),
  [9697] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__query_body_repeat1, 2, 0, 0), SHIFT_REPEAT(902),
  [9700] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__query_body_repeat1, 2, 0, 0),
  [9702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9228),
  [9704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6791),
  [9706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2510),
  [9708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6780),
  [9710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7269),
  [9712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9039),
  [9714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8967),
  [9716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9641),
  [9718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9376),
  [9720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9604),
  [9722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9658),
  [9724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9133),
  [9726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9372),
  [9728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9836),
  [9730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9362),
  [9732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9065),
  [9734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4903),
  [9736] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_parameter_constraint, 1, 0, 0), REDUCE(sym__reserved_identifier, 1, 0, 0),
  [9739] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_variable_declarator, 1, 0, 4), SHIFT(3499),
  [9742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2045),
  [9744] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_variable_declarator, 1, 0, 4), SHIFT(3358),
  [9747] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_variable_declarator, 1, 0, 4), SHIFT(3413),
  [9750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9675),
  [9752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9261),
  [9754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9012),
  [9756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8969),
  [9758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9798),
  [9760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8975),
  [9762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9368),
  [9764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9824),
  [9766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9546),
  [9768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9187),
  [9770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9526),
  [9772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9062),
  [9774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3142),
  [9776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(55),
  [9778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2466),
  [9780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2250),
  [9782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(937),
  [9784] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_order_by_clause, 2, 0, 0),
  [9786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2671),
  [9788] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_parameter, 1, 0, 4), REDUCE(sym__simple_name, 1, 0, 0),
  [9791] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_order_by_clause, 3, 0, 0),
  [9793] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_join_clause, 3, 0, 43),
  [9795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7326),
  [9797] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_order_by_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(937),
  [9800] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_order_by_clause_repeat1, 2, 0, 0),
  [9802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9851),
  [9804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9015),
  [9806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9552),
  [9808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9745),
  [9810] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__ordering, 2, 0, 0),
  [9812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9770),
  [9814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8787),
  [9816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8972),
  [9818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9308),
  [9820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9749),
  [9822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9220),
  [9824] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_base, 2, 0, 0),
  [9826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6845),
  [9828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9396),
  [9830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9076),
  [9832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9495),
  [9834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5645),
  [9836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8292),
  [9838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1907),
  [9840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3943),
  [9842] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_join_into_clause, 2, 0, 0),
  [9844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3627),
  [9846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4583),
  [9848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7754),
  [9850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8912),
  [9852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4648),
  [9854] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__query_clause, 1, 0, 0),
  [9856] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_interpolated_string_expression_repeat1, 2, 0, 0),
  [9858] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_interpolated_string_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(8292),
  [9861] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_interpolated_string_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(1907),
  [9864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4302),
  [9866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4261),
  [9868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3960),
  [9870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3624),
  [9872] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__query_body_repeat1, 1, 0, 0),
  [9874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5701),
  [9876] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_join_clause, 4, 0, 43),
  [9878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4825),
  [9880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9881),
  [9882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9838),
  [9884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9325),
  [9886] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter_constraints_clause, 4, 0, 0),
  [9888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4284),
  [9890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9829),
  [9892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4877),
  [9894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4805),
  [9896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9383),
  [9898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9292),
  [9900] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7754),
  [9903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1803),
  [9905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8416),
  [9907] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__ref_base_type, 1, 0, 0),
  [9909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8288),
  [9911] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_parameter_constraints_clause_repeat1, 2, 0, 0),
  [9913] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_parameter_constraints_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(4284),
  [9916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9177),
  [9918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8411),
  [9920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9273),
  [9922] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8673),
  [9924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8242),
  [9926] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8243),
  [9928] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8266),
  [9930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9858),
  [9932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9315),
  [9934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4867),
  [9936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9670),
  [9938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9614),
  [9940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9276),
  [9942] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3906),
  [9944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4728),
  [9946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9869),
  [9948] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4489),
  [9950] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter_constraint, 1, 0, 0),
  [9952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7923),
  [9954] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_interpolated_string_expression_repeat3, 2, 0, 0),
  [9956] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_interpolated_string_expression_repeat3, 2, 0, 0), SHIFT_REPEAT(1803),
  [9959] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_interpolated_string_expression_repeat3, 2, 0, 0), SHIFT_REPEAT(8416),
  [9962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9333),
  [9964] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_interpolated_string_expression_repeat2, 2, 0, 0),
  [9966] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_interpolated_string_expression_repeat2, 2, 0, 0), SHIFT_REPEAT(1907),
  [9969] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_interpolated_string_expression_repeat2, 2, 0, 0), SHIFT_REPEAT(8411),
  [9972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4886),
  [9974] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4435),
  [9976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4331),
  [9978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(43),
  [9980] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1812),
  [9982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9841),
  [9984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9429),
  [9986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9408),
  [9988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9346),
  [9990] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3882),
  [9992] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_pattern, 4, 0, 60),
  [9994] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_pattern, 4, 0, 58),
  [9996] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3609),
  [9998] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_base, 4, 0, 0),
  [10000] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5277),
  [10002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9079),
  [10004] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_pattern, 3, 0, 0),
  [10006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9354),
  [10008] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8685),
  [10010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4725),
  [10012] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3896),
  [10014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9598),
  [10016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9760),
  [10018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9826),
  [10020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9500),
  [10022] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 2, 0, 12),
  [10024] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_literal_repeat1, 2, 0, 0),
  [10026] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(8242),
  [10029] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(8243),
  [10032] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(8266),
  [10035] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5255),
  [10037] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_class_declaration_repeat3, 2, 0, 0),
  [10039] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_declaration_repeat3, 2, 0, 0), SHIFT_REPEAT(7269),
  [10042] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3883),
  [10044] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3599),
  [10046] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_pattern, 3, 0, 14),
  [10048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4845),
  [10050] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter_constraints_clause, 5, 0, 0),
  [10052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(365),
  [10054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4051),
  [10056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(404),
  [10058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(401),
  [10060] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter_constraint, 2, 0, 0),
  [10062] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6194),
  [10064] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6198),
  [10066] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6221),
  [10068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5),
  [10070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(370),
  [10072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4958),
  [10074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(42),
  [10076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(590),
  [10078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(46),
  [10080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2283),
  [10082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(380),
  [10084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9382),
  [10086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2717),
  [10088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4),
  [10090] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_switch_body_repeat1, 2, 0, 0),
  [10092] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_switch_body_repeat1, 2, 0, 0), SHIFT_REPEAT(380),
  [10095] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_switch_body_repeat1, 2, 0, 0), SHIFT_REPEAT(9382),
  [10098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1970),
  [10100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(396),
  [10102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(418),
  [10104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(589),
  [10106] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_base, 3, 0, 0),
  [10108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1925),
  [10110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1923),
  [10112] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 1, 0, 0),
  [10114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2),
  [10116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2293),
  [10118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6716),
  [10120] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_list, 4, 0, 31),
  [10122] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_list, 4, 0, 33),
  [10124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8259),
  [10126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2211),
  [10128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8155),
  [10130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6275),
  [10132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6222),
  [10134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6235),
  [10136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(371),
  [10138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5404),
  [10140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2051),
  [10142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2661),
  [10144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8881),
  [10146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6),
  [10148] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__preproc_expression, 1, 0, 0),
  [10150] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__preproc_expression, 1, 0, 0),
  [10152] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter_list, 3, 0, 0),
  [10154] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_list, 3, 0, 0),
  [10156] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_list, 3, 0, 13),
  [10158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(51),
  [10160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2212),
  [10162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(587),
  [10164] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_base, 5, 0, 0),
  [10166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(592),
  [10168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(699),
  [10170] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_unary_expression, 2, 0, 21),
  [10172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(372),
  [10174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4701),
  [10176] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_binary_expression, 3, 0, 23),
  [10178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(595),
  [10180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8784),
  [10182] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_enum_member_declaration, 4, 0, 37),
  [10184] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_constraint, 3, 0, 0),
  [10186] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_parenthesized_expression, 3, 0, 0),
  [10188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(40),
  [10190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8),
  [10192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3),
  [10194] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter_constraint, 1, 0, 5),
  [10196] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_unary_expression, 2, 0, 21),
  [10198] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter_list, 4, 0, 0),
  [10200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(53),
  [10202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8191),
  [10204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8815),
  [10206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(593),
  [10208] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_record_base_repeat1, 2, 0, 0),
  [10210] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_record_base_repeat1, 2, 0, 0), SHIFT_REPEAT(6845),
  [10213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(594),
  [10215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(362),
  [10217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4140),
  [10219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2499),
  [10221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1172),
  [10223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1173),
  [10225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(426),
  [10227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(424),
  [10229] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_parenthesized_expression, 3, 0, 0),
  [10231] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_binary_expression, 3, 0, 23),
  [10233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2485),
  [10235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6725),
  [10237] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subpattern, 1, 0, 0),
  [10239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(431),
  [10241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(435),
  [10243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2519),
  [10245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4301),
  [10247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8850),
  [10249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9510),
  [10251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2537),
  [10253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4258),
  [10255] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(8448),
  [10258] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_argument_list_repeat1, 2, 0, 0),
  [10260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2606),
  [10262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6793),
  [10264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4279),
  [10266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2598),
  [10268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3251),
  [10270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4720),
  [10272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6738),
  [10274] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subpattern, 3, 0, 0),
  [10276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4275),
  [10278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2323),
  [10280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4265),
  [10282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2338),
  [10284] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string_literal_content, 1, 0, 0),
  [10286] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_literal_content, 1, 0, 0),
  [10288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2534),
  [10290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2541),
  [10292] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpolation, 3, 0, 0),
  [10294] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_for_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1941),
  [10297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4130),
  [10299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2511),
  [10301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3334),
  [10303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4700),
  [10305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4230),
  [10307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2627),
  [10309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2628),
  [10311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3318),
  [10313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2305),
  [10315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3477),
  [10317] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_literal_repeat1, 1, 0, 0),
  [10319] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_string_literal_repeat1, 1, 0, 0),
  [10321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2582),
  [10323] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration_expression, 2, 1, 12),
  [10325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4195),
  [10327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3470),
  [10329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3469),
  [10331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1299),
  [10333] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 4, 0, 47),
  [10335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4187),
  [10337] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_base_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4837),
  [10340] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_base_list_repeat1, 2, 0, 0),
  [10342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1812),
  [10344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3498),
  [10346] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpolation, 4, 0, 0),
  [10348] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_interpolated_string_expression_repeat1, 1, 0, 0),
  [10350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2615),
  [10352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2348),
  [10354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2374),
  [10356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2375),
  [10358] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__interpolated_string_content, 1, 0, 0),
  [10360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3360),
  [10362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3361),
  [10364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2349),
  [10366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4837),
  [10368] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_base_list, 3, 0, 0),
  [10370] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpolation, 5, 0, 0),
  [10372] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_base_list, 2, 0, 0),
  [10374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2360),
  [10376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5406),
  [10378] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_class_declaration_repeat3, 1, 0, 0),
  [10380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1340),
  [10382] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 3, 0, 30),
  [10384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9623),
  [10386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9602),
  [10388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8380),
  [10390] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1340),
  [10392] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_bracketed_parameter_list_repeat1, 2, 0, 32), SHIFT_REPEAT(3730),
  [10395] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_bracketed_parameter_list_repeat1, 2, 0, 32),
  [10397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2389),
  [10399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2419),
  [10401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3417),
  [10403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4053),
  [10405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2568),
  [10407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2569),
  [10409] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1382),
  [10411] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_using_variable_declarator, 1, 0, 4), REDUCE(sym_tuple_element, 2, 0, 12),
  [10414] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_using_variable_declarator, 1, 0, 4),
  [10416] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_primary_constructor_base_type, 2, 0, 5),
  [10418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3270),
  [10420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2411),
  [10422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4984),
  [10424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1986),
  [10426] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_member_declaration, 2, 0, 14),
  [10428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1967),
  [10430] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_member_declaration, 1, 0, 4),
  [10432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2424),
  [10434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3442),
  [10436] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_parameter, 2, 0, 12), REDUCE(sym_tuple_element, 2, 0, 12), REDUCE(sym_declaration_expression, 2, 1, 12),
  [10440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2400),
  [10442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4527),
  [10444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3888),
  [10446] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_pattern_repeat1, 2, 0, 59), SHIFT_REPEAT(7042),
  [10449] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_tuple_pattern_repeat1, 2, 0, 59),
  [10451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6762),
  [10453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1367),
  [10455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6764),
  [10457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(611),
  [10459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5258),
  [10461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8824),
  [10463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(717),
  [10465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(326),
  [10467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6776),
  [10469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8170),
  [10471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(606),
  [10473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3000),
  [10475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6756),
  [10477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4474),
  [10479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(363),
  [10481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3288),
  [10483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(364),
  [10485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2928),
  [10487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(354),
  [10489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6891),
  [10491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4092),
  [10493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4756),
  [10495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3602),
  [10497] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_initializer, 3, 0, 0),
  [10499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3354),
  [10501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3604),
  [10503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(332),
  [10505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5549),
  [10507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(374),
  [10509] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_anonymous_object_creation_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(978),
  [10512] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_anonymous_object_creation_expression_repeat1, 2, 0, 0),
  [10514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6907),
  [10516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9747),
  [10518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7263),
  [10520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5543),
  [10522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9940),
  [10524] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9726),
  [10526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5121),
  [10528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3329),
  [10530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(95),
  [10532] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7852),
  [10534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9941),
  [10536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(86),
  [10538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3730),
  [10540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8080),
  [10542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3419),
  [10544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7852),
  [10546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8798),
  [10548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3760),
  [10550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8892),
  [10552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8837),
  [10554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3028),
  [10556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8083),
  [10558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3279),
  [10560] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_base_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4756),
  [10563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(718),
  [10565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5642),
  [10567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3174),
  [10569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6759),
  [10571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3758),
  [10573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5317),
  [10575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(731),
  [10577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(753),
  [10579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8043),
  [10581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4989),
  [10583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8038),
  [10585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8891),
  [10587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5319),
  [10589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(350),
  [10591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3578),
  [10593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4038),
  [10595] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__interpolated_verbatim_string_content, 1, 0, 0),
  [10597] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_interpolated_string_expression_repeat2, 1, 0, 0),
  [10599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5464),
  [10601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3631),
  [10603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3920),
  [10605] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__interpolated_raw_string_content, 1, 0, 0),
  [10607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6752),
  [10609] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_interpolated_string_expression_repeat3, 1, 0, 0),
  [10611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5321),
  [10613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(945),
  [10615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(158),
  [10617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3924),
  [10619] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_array, 4, 0, 47),
  [10621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4013),
  [10623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(62),
  [10625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(65),
  [10627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6768),
  [10629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(68),
  [10631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(66),
  [10633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3039),
  [10635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3611),
  [10637] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_pragma_repeat1, 2, 0, 0), SHIFT_REPEAT(7258),
  [10640] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_preproc_pragma_repeat1, 2, 0, 0),
  [10642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3007),
  [10644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3554),
  [10646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1382),
  [10648] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_using_variable_declaration_repeat1, 2, 0, 0), SHIFT_REPEAT(7255),
  [10651] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_using_variable_declaration_repeat1, 2, 0, 0),
  [10653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(116),
  [10655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6748),
  [10657] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attribute_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1003),
  [10660] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_attribute_argument_list_repeat1, 2, 0, 0),
  [10662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(84),
  [10664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(122),
  [10666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(89),
  [10668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1003),
  [10670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8795),
  [10672] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_argument_list_repeat1, 1, 0, 0),
  [10674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3860),
  [10676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6766),
  [10678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8896),
  [10680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2937),
  [10682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(818),
  [10684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3893),
  [10686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7255),
  [10688] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_using_variable_declaration, 3, 0, 5),
  [10690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8281),
  [10692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3978),
  [10694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(356),
  [10696] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7258),
  [10698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9946),
  [10700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8907),
  [10702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2734),
  [10704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3721),
  [10706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1693),
  [10708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3867),
  [10710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6767),
  [10712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7262),
  [10714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2934),
  [10716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(695),
  [10718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3725),
  [10720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4004),
  [10722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1052),
  [10724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(338),
  [10726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4018),
  [10728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3946),
  [10730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(83),
  [10732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(634),
  [10734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8689),
  [10736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4031),
  [10738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4461),
  [10740] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_parameter_list_repeat1, 2, 0, 0), SHIFT_REPEAT(6776),
  [10743] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_parameter_list_repeat1, 2, 0, 0),
  [10745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2947),
  [10747] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_variable_designation_repeat1, 2, 0, 59), SHIFT_REPEAT(6891),
  [10750] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_parenthesized_variable_designation_repeat1, 2, 0, 59),
  [10752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(631),
  [10754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3654),
  [10756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(635),
  [10758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4049),
  [10760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1011),
  [10762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(352),
  [10764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2994),
  [10766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4000),
  [10768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3190),
  [10770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8868),
  [10772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6994),
  [10774] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 2, 0, 5),
  [10776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8697),
  [10778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(168),
  [10780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(327),
  [10782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3734),
  [10784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(802),
  [10786] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_array_rank_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(697),
  [10789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5379),
  [10791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(144),
  [10793] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_variable_declaration_repeat1, 2, 0, 0),
  [10795] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_variable_declaration_repeat1, 2, 0, 0), SHIFT_REPEAT(7105),
  [10798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7042),
  [10800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7831),
  [10802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7835),
  [10804] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_member_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(6781),
  [10807] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enum_member_declaration_list_repeat1, 2, 0, 0),
  [10809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9843),
  [10811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3013),
  [10813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3209),
  [10815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4030),
  [10817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3012),
  [10819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8951),
  [10821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4565),
  [10823] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_switch_body_repeat1, 1, 0, 0),
  [10825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1122),
  [10827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(684),
  [10829] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_tuple_element, 2, 0, 12), REDUCE(sym_declaration_expression, 2, 1, 12),
  [10832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(169),
  [10834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3879),
  [10836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3910),
  [10838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3280),
  [10840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4993),
  [10842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(329),
  [10844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3219),
  [10846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6761),
  [10848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6701),
  [10850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6765),
  [10852] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_switch_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(357),
  [10855] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_switch_expression_repeat1, 2, 0, 0),
  [10857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3884),
  [10859] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_list_pattern_repeat1, 2, 0, 0), SHIFT_REPEAT(407),
  [10862] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_positional_pattern_clause_repeat1, 2, 0, 0),
  [10864] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_positional_pattern_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(364),
  [10867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7849),
  [10869] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_with_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(7263),
  [10872] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_with_expression_repeat1, 2, 0, 0),
  [10874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3529),
  [10876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4091),
  [10878] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_type_repeat1, 2, 0, 0), SHIFT_REPEAT(4527),
  [10881] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_tuple_type_repeat1, 2, 0, 0),
  [10883] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 2, 0, 0),
  [10885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1546),
  [10887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(154),
  [10889] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 3, 0, 5),
  [10891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7105),
  [10893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(373),
  [10895] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 2, 0, 4),
  [10897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1533),
  [10899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(331),
  [10901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5272),
  [10903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3336),
  [10905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3341),
  [10907] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_parameter, 2, 0, 12), REDUCE(sym_tuple_element, 2, 0, 12),
  [10910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4508),
  [10912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(633),
  [10914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3885),
  [10916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3895),
  [10918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(90),
  [10920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8764),
  [10922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2929),
  [10924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(328),
  [10926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3646),
  [10928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3212),
  [10930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3639),
  [10932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1252),
  [10934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(91),
  [10936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3668),
  [10938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3166),
  [10940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6747),
  [10942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9539),
  [10944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8778),
  [10946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(93),
  [10948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(94),
  [10950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6769),
  [10952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6744),
  [10954] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_calling_convention_repeat1, 2, 0, 0), SHIFT_REPEAT(6907),
  [10957] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_calling_convention_repeat1, 2, 0, 0),
  [10959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3539),
  [10961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3011),
  [10963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5426),
  [10965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8559),
  [10967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3658),
  [10969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5012),
  [10971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8071),
  [10973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(805),
  [10975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2737),
  [10977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3581),
  [10979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4125),
  [10981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5424),
  [10983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(368),
  [10985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(342),
  [10987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(694),
  [10989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4677),
  [10991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2814),
  [10993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4073),
  [10995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(88),
  [10997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(103),
  [10999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4664),
  [11001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(330),
  [11003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(369),
  [11005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(335),
  [11007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4088),
  [11009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4584),
  [11011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3620),
  [11013] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_variable_declaration_repeat1, 2, 0, 0), SHIFT_REPEAT(6994),
  [11016] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_bracketed_parameter_list_repeat1, 2, 0, 13),
  [11018] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_bracketed_parameter_list_repeat1, 2, 0, 0),
  [11020] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_array, 3, 0, 30),
  [11022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(656),
  [11024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3865),
  [11026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6758),
  [11028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2820),
  [11030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(105),
  [11032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3282),
  [11034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4968),
  [11036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8811),
  [11038] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(606),
  [11041] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2, 0, 0),
  [11043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6751),
  [11045] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_global_attribute_repeat1, 2, 0, 0), SHIFT_REPEAT(6787),
  [11048] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_global_attribute_repeat1, 2, 0, 0),
  [11050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8857),
  [11052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6753),
  [11054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2567),
  [11056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8909),
  [11058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(661),
  [11060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4174),
  [11062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3904),
  [11064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(885),
  [11066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5369),
  [11068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3172),
  [11070] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_positional_pattern_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(367),
  [11073] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_using_variable_declaration, 2, 0, 5),
  [11075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6749),
  [11077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2318),
  [11079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3421),
  [11081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4519),
  [11083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(60),
  [11085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6750),
  [11087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6772),
  [11089] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(611),
  [11092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(337),
  [11094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3518),
  [11096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8933),
  [11098] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_base_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4900),
  [11101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1942),
  [11103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8804),
  [11105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1943),
  [11107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9949),
  [11109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3594),
  [11111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3493),
  [11113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6746),
  [11115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4340),
  [11117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(698),
  [11119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8376),
  [11121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4900),
  [11123] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_for_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1635),
  [11126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3676),
  [11128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(341),
  [11130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4587),
  [11132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9729),
  [11134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2596),
  [11136] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9948),
  [11138] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9624),
  [11140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8819),
  [11142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8820),
  [11144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3704),
  [11146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(617),
  [11148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9936),
  [11150] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bracketed_parameter_list, 2, 0, 0),
  [11152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(601),
  [11154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(620),
  [11156] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9648),
  [11158] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 2, 0, 4),
  [11160] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9947),
  [11162] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9651),
  [11164] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_enum_member_declaration, 4, 0, 37),
  [11166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(599),
  [11168] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9242),
  [11170] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_declaration, 4, 0, 30),
  [11172] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_parenthesized_variable_designation_repeat1, 2, 0, 41),
  [11174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(610),
  [11176] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9477),
  [11178] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_declaration, 3, 0, 6),
  [11180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(615),
  [11182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1841),
  [11184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1842),
  [11186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(624),
  [11188] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 3, 0, 29),
  [11190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7828),
  [11192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(61),
  [11194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1920),
  [11196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1924),
  [11198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8687),
  [11200] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_argument_list, 4, 0, 0),
  [11202] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_preproc_pragma_repeat1, 2, 0, 0),
  [11204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8174),
  [11206] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bracketed_parameter_list, 3, 0, 0),
  [11208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(618),
  [11210] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bracketed_parameter_list, 3, 0, 13),
  [11212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7198),
  [11214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8008),
  [11216] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_tuple_pattern_repeat1, 2, 0, 14),
  [11218] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_tuple_pattern_repeat1, 2, 0, 0),
  [11220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1414),
  [11222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(612),
  [11224] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 2, 0, 14),
  [11226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2336),
  [11228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1944),
  [11230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6903),
  [11232] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_calling_convention, 1, 0, 0),
  [11234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1905),
  [11236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3399),
  [11238] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_argument_list, 3, 0, 0),
  [11240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2588),
  [11242] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9912),
  [11244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(626),
  [11246] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_enum_member_declaration, 5, 0, 37),
  [11248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8202),
  [11250] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_element, 2, 0, 12),
  [11252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1150),
  [11254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(627),
  [11256] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bracketed_parameter_list, 4, 0, 31),
  [11258] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bracketed_parameter_list, 4, 0, 33),
  [11260] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_enum_member_declaration, 5, 0, 57),
  [11262] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_enum_member_declaration, 6, 0, 79),
  [11264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8058),
  [11266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3313),
  [11268] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 1, 0, 4),
  [11270] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_argument_list, 2, 0, 0),
  [11272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(607),
  [11274] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9318),
  [11276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3226),
  [11278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2581),
  [11280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2308),
  [11282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1450),
  [11284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2358),
  [11286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3394),
  [11288] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9755),
  [11290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(801),
  [11292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1211),
  [11294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2300),
  [11296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2649),
  [11298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4599),
  [11300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2299),
  [11302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4581),
  [11304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2403),
  [11306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(318),
  [11308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2339),
  [11310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2340),
  [11312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2342),
  [11314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2343),
  [11316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3218),
  [11318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3222),
  [11320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1001),
  [11322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3221),
  [11324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3255),
  [11326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8777),
  [11328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8773),
  [11330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3678),
  [11332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3128),
  [11334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3543),
  [11336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8766),
  [11338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2355),
  [11340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2356),
  [11342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1005),
  [11344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(311),
  [11346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7145),
  [11348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1009),
  [11350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3699),
  [11352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2357),
  [11354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3462),
  [11356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1447),
  [11358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3415),
  [11360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1040),
  [11362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2361),
  [11364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1015),
  [11366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2364),
  [11368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1016),
  [11370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3408),
  [11372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3406),
  [11374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3400),
  [11376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6916),
  [11378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2368),
  [11380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2369),
  [11382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1025),
  [11384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2370),
  [11386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2373),
  [11388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3398),
  [11390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8220),
  [11392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2379),
  [11394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2380),
  [11396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(848),
  [11398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2381),
  [11400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3375),
  [11402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3374),
  [11404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3364),
  [11406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2383),
  [11408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3623),
  [11410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3622),
  [11412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(960),
  [11414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8750),
  [11416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7212),
  [11418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2514),
  [11420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8234),
  [11422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1092),
  [11424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3137),
  [11426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(973),
  [11428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2390),
  [11430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2391),
  [11432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(769),
  [11434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1093),
  [11436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1096),
  [11438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2397),
  [11440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2398),
  [11442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2399),
  [11444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2401),
  [11446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2692),
  [11448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2402),
  [11450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1108),
  [11452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2297),
  [11454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1111),
  [11456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9479),
  [11458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4579),
  [11460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2644),
  [11462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2708),
  [11464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1116),
  [11466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2405),
  [11468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2407),
  [11470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(799),
  [11472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(800),
  [11474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2406),
  [11476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2417),
  [11478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2304),
  [11480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2408),
  [11482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2409),
  [11484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3291),
  [11486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2410),
  [11488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3289),
  [11490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1032),
  [11492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3285),
  [11494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3276),
  [11496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1637),
  [11498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2307),
  [11500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2302),
  [11502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8149),
  [11504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8218),
  [11506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(930),
  [11508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1030),
  [11510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1026),
  [11512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3698),
  [11514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2412),
  [11516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3264),
  [11518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2413),
  [11520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2414),
  [11522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2415),
  [11524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(811),
  [11526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1021),
  [11528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7146),
  [11530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1020),
  [11532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3263),
  [11534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3262),
  [11536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3256),
  [11538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3243),
  [11540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(297),
  [11542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1019),
  [11544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3236),
  [11546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(819),
  [11548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(897),
  [11550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8738),
  [11552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8916),
  [11554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3235),
  [11556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2420),
  [11558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4177),
  [11560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(880),
  [11562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2421),
  [11564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4164),
  [11566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(916),
  [11568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2422),
  [11570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(793),
  [11572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2572),
  [11574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2423),
  [11576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2404),
  [11578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3446),
  [11580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1585),
  [11582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(914),
  [11584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(911),
  [11586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2371),
  [11588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4218),
  [11590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2416),
  [11592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2396),
  [11594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2394),
  [11596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(908),
  [11598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2393),
  [11600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(906),
  [11602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(789),
  [11604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(845),
  [11606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2392),
  [11608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(905),
  [11610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(892),
  [11612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(891),
  [11614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1117),
  [11616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4684),
  [11618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7862),
  [11620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(835),
  [11622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7877),
  [11624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7725),
  [11626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2388),
  [11628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4682),
  [11630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2387),
  [11632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(956),
  [11634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(957),
  [11636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(833),
  [11638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(830),
  [11640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(958),
  [11642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(961),
  [11644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(962),
  [11646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(964),
  [11648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2385),
  [11650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(823),
  [11652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1067),
  [11654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(822),
  [11656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1069),
  [11658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1070),
  [11660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(821),
  [11662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1074),
  [11664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1075),
  [11666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1077),
  [11668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1079),
  [11670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1078),
  [11672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1076),
  [11674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1071),
  [11676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1066),
  [11678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1062),
  [11680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(781),
  [11682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(782),
  [11684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(783),
  [11686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(786),
  [11688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(787),
  [11690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3674),
  [11692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(788),
  [11694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2384),
  [11696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3670),
  [11698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(972),
  [11700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(970),
  [11702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(966),
  [11704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(951),
  [11706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(948),
  [11708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(941),
  [11710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2382),
  [11712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2377),
  [11714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(870),
  [11716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(871),
  [11718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4680),
  [11720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(873),
  [11722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(875),
  [11724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(876),
  [11726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3664),
  [11728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(991),
  [11730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(877),
  [11732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2418),
  [11734] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration_list, 2, 0, 0),
  [11736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8922),
  [11738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(983),
  [11740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(984),
  [11742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(986),
  [11744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(988),
  [11746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(990),
  [11748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2366),
  [11750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1057),
  [11752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1132),
  [11754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1133),
  [11756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1136),
  [11758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1138),
  [11760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1137),
  [11762] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif, 4, 0, 57),
  [11764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(853),
  [11766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(842),
  [11768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(839),
  [11770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(838),
  [11772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(834),
  [11774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(829),
  [11776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2365),
  [11778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(828),
  [11780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2363),
  [11782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2298),
  [11784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1043),
  [11786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1042),
  [11788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1041),
  [11790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(166),
  [11792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1039),
  [11794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1038),
  [11796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2359),
  [11798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1037),
  [11800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3311),
  [11802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(920),
  [11804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(126),
  [11806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3301),
  [11808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(919),
  [11810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(915),
  [11812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3303),
  [11814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(912),
  [11816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2354),
  [11818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(910),
  [11820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2353),
  [11822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(909),
  [11824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(826),
  [11826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3305),
  [11828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(831),
  [11830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(837),
  [11832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(849),
  [11834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3306),
  [11836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2352),
  [11838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(855),
  [11840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4282),
  [11842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2351),
  [11844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3307),
  [11846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3229),
  [11848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(856),
  [11850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1128),
  [11852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3312),
  [11854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1010),
  [11856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1012),
  [11858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(926),
  [11860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2350),
  [11862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(925),
  [11864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(921),
  [11866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3231),
  [11868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1098),
  [11870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1099),
  [11872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1100),
  [11874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1104),
  [11876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1105),
  [11878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2347),
  [11880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1106),
  [11882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4154),
  [11884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(965),
  [11886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(969),
  [11888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2684),
  [11890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(971),
  [11892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(974),
  [11894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2590),
  [11896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2341),
  [11898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(976),
  [11900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2367),
  [11902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(980),
  [11904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2335),
  [11906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3240),
  [11908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2344),
  [11910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2327),
  [11912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2309),
  [11914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1056),
  [11916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1051),
  [11918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1050),
  [11920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2592),
  [11922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1048),
  [11924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1047),
  [11926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2326),
  [11928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2325),
  [11930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(933),
  [11932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(734),
  [11934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2599),
  [11936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2324),
  [11938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(932),
  [11940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(931),
  [11942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(929),
  [11944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2322),
  [11946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(720),
  [11948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2319),
  [11950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(927),
  [11952] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_member_declaration_list, 2, 0, 0),
  [11954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2316),
  [11956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2306),
  [11958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(850),
  [11960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(815),
  [11962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(807),
  [11964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(804),
  [11966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2301),
  [11968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2504),
  [11970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2362),
  [11972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(883),
  [11974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(746),
  [11976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(795),
  [11978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(770),
  [11980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2310),
  [11982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2311),
  [11984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2312),
  [11986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8113),
  [11988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(785),
  [11990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2593),
  [11992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2313),
  [11994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(784),
  [11996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(779),
  [11998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(778),
  [12000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2314),
  [12002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2611),
  [12004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1073),
  [12006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2315),
  [12008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(774),
  [12010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2654),
  [12012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2317),
  [12014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(772),
  [12016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2320),
  [12018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2321),
  [12020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9627),
  [12022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2337),
  [12024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(736),
  [12026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7142),
  [12028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(737),
  [12030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(816),
  [12032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(907),
  [12034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2509),
  [12036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2881),
  [12038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(313),
  [12040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2512),
  [12042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(755),
  [12044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(756),
  [12046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2513),
  [12048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6885),
  [12050] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_pointer_parameter, 1, 0, 5),
  [12052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(889),
  [12054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2516),
  [12056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2518),
  [12058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(893),
  [12060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(895),
  [12062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(896),
  [12064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2522),
  [12066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(874),
  [12068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3241),
  [12070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(898),
  [12072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2597),
  [12074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(899),
  [12076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2595),
  [12078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3327),
  [12080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2700),
  [12082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2328),
  [12084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2564),
  [12086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3315),
  [12088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3250),
  [12090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2535),
  [12092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2329),
  [12094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3267),
  [12096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(887),
  [12098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8690),
  [12100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3252),
  [12102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2330),
  [12104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3253),
  [12106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3254),
  [12108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9335),
  [12110] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_enum_member_declaration, 4, 0, 57),
  [12112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(28),
  [12114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1143),
  [12116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(825),
  [12118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1029),
  [12120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3666),
  [12122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2525),
  [12124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2331),
  [12126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(824),
  [12128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2460),
  [12130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2715),
  [12132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(812),
  [12134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2526),
  [12136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1046),
  [12138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2060),
  [12140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1049),
  [12142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2538),
  [12144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3494),
  [12146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2332),
  [12148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2474),
  [12150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9067),
  [12152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2542),
  [12154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2556),
  [12156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2573),
  [12158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2574),
  [12160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(809),
  [12162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2678),
  [12164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1887),
  [12166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1888),
  [12168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1894),
  [12170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2484),
  [12172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4729),
  [12174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4741),
  [12176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1896),
  [12178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1901),
  [12180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3723),
  [12182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(803),
  [12184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2575),
  [12186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2677),
  [12188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2578),
  [12190] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_top_level, 5, 0, 79),
  [12192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6785),
  [12194] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_expression, 5, 0, 79),
  [12196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1874),
  [12198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2583),
  [12200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2584),
  [12202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8899),
  [12204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2435),
  [12206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2246),
  [12208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2248),
  [12210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1053),
  [12212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3259),
  [12214] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_else_in_enum_member_declaration, 2, 0, 0),
  [12216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2215),
  [12218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(867),
  [12220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3580),
  [12222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(865),
  [12224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1125),
  [12226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2586),
  [12228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2983),
  [12230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1082),
  [12232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(859),
  [12234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2272),
  [12236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(860),
  [12238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2260),
  [12240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2333),
  [12242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7861),
  [12244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(868),
  [12246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1210),
  [12248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2303),
  [12250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7863),
  [12252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3473),
  [12254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7683),
  [12256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2334),
  [12258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(881),
  [12260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8496),
  [12262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2600),
  [12264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2287),
  [12266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(882),
  [12268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2604),
  [12270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2551),
  [12272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2608),
  [12274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2505),
  [12276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3283),
  [12278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(146),
  [12280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4297),
  [12282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3286),
  [12284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3295),
  [12286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4534),
  [12288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1055),
  [12290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9661),
  [12292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1290),
  [12294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1129),
  [12296] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9660),
  [12298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3298),
  [12300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3309),
  [12302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3652),
  [12304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2577),
  [12306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3387),
  [12308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2527),
  [12310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3381),
  [12312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1135),
  [12314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3321),
  [12316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3322),
  [12318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3323),
  [12320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3876),
  [12322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3328),
  [12324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3878),
  [12326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3332),
  [12328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(725),
  [12330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2687),
  [12332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4529),
  [12334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6986),
  [12336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1013),
  [12338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4231),
  [12340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8792),
  [12342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3881),
  [12344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2622),
  [12346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(726),
  [12348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(727),
  [12350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3338),
  [12352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3339),
  [12354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(728),
  [12356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3345),
  [12358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(138),
  [12360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3359),
  [12362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2629),
  [12364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2634),
  [12366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2636),
  [12368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3365),
  [12370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3246),
  [12372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3367),
  [12374] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration_list, 3, 0, 0),
  [12376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3372),
  [12378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2528),
  [12380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(730),
  [12382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2532),
  [12384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2561),
  [12386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(733),
  [12388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3861),
  [12390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3393),
  [12392] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_member_declaration_list, 3, 0, 0),
  [12394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2562),
  [12396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2563),
  [12398] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_pointer_parameter, 2, 0, 6),
  [12400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3395),
  [12402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2871),
  [12404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(994),
  [12406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2570),
  [12408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2571),
  [12410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(959),
  [12412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5613),
  [12414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5611),
  [12416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5655),
  [12418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2591),
  [12420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2601),
  [12422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1097),
  [12424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3402),
  [12426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3416),
  [12428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3752),
  [12430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3754),
  [12432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2427),
  [12434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2633),
  [12436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1101),
  [12438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1134),
  [12440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7375),
  [12442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6789),
  [12444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1131),
  [12446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3514),
  [12448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3596),
  [12450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(942),
  [12452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2456),
  [12454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1102),
  [12456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1427),
  [12458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(749),
  [12460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3368),
  [12462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2288),
  [12464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2291),
  [12466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3340),
  [12468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9937),
  [12470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(917),
  [12472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5550),
  [12474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2277),
  [12476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9938),
  [12478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3290),
  [12480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9939),
  [12482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(900),
  [12484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1044),
  [12486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(890),
  [12488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1058),
  [12490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1059),
  [12492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1068),
  [12494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1072),
  [12496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1008),
  [12498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2617),
  [12500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1103),
  [12502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1107),
  [12504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3244),
  [12506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2605),
  [12508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3423),
  [12510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1127),
  [12512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3213),
  [12514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3424),
  [12516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3425),
  [12518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1112),
  [12520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3426),
  [12522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2612),
  [12524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(888),
  [12526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3603),
  [12528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3431),
  [12530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3432),
  [12532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2619),
  [12534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(741),
  [12536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(884),
  [12538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5467),
  [12540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2621),
  [12542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5466),
  [12544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2270),
  [12546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9694),
  [12548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9944),
  [12550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(773),
  [12552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3371),
  [12554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8385),
  [12556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2620),
  [12558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2618),
  [12560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1962),
  [12562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1939),
  [12564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1937),
  [12566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4816),
  [12568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4819),
  [12570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1936),
  [12572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1933),
  [12574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2616),
  [12576] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif, 5, 0, 79),
  [12578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(739),
  [12580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1946),
  [12582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2613),
  [12584] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_enum_member_declaration, 5, 0, 79),
  [12586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2503),
  [12588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(985),
  [12590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2580),
  [12592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2579),
  [12594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1144),
  [12596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3617),
  [12598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2566),
  [12600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8280),
  [12602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9945),
  [12604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1146),
  [12606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8842),
  [12608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(894),
  [12610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3595),
  [12612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2259),
  [12614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3224),
  [12616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2545),
  [12618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9919),
  [12620] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpolation_format_clause, 2, 0, 0),
  [12622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9847),
  [12624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2559),
  [12626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3981),
  [12628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1152),
  [12630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4069),
  [12632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1155),
  [12634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9943),
  [12636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3433),
  [12638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9942),
  [12640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1157),
  [12642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9380),
  [12644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2631),
  [12646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2630),
  [12648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2625),
  [12650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2624),
  [12652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9909),
  [12654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2623),
  [12656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3223),
  [12658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3260),
  [12660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(729),
  [12662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8875),
  [12664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3274),
  [12666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4683),
  [12668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3953),
  [12670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7219),
  [12672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(304),
  [12674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(936),
  [12676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(723),
  [12678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(992),
  [12680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9045),
  [12682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1163),
  [12684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9070),
  [12686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3994),
  [12688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3951),
  [12690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(997),
  [12692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3265),
  [12694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4739),
  [12696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1865),
  [12698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1864),
  [12700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1861),
  [12702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4760),
  [12704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4761),
  [12706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1860),
  [12708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1855),
  [12710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4024),
  [12712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3475),
  [12714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1866),
  [12716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3945),
  [12718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(950),
  [12720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8830),
  [12722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8298),
  [12724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(949),
  [12726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3438),
  [12728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(999),
  [12730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9950),
  [12732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2897),
  [12734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(946),
  [12736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1004),
  [12738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3439),
  [12740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1177),
  [12742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9951),
  [12744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4287),
  [12746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(943),
  [12748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3440),
  [12750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(864),
  [12752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2555),
  [12754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1014),
  [12756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2553),
  [12758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(857),
  [12760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4525),
  [12762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2614),
  [12764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2515),
  [12766] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_member_declaration_list, 4, 0, 0),
  [12768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(846),
  [12770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3443),
  [12772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2517),
  [12774] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_calling_convention, 4, 0, 0),
  [12776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2877),
  [12778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2520),
  [12780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1033),
  [12782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4862),
  [12784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4863),
  [12786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1837),
  [12788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1834),
  [12790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3969),
  [12792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2521),
  [12794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1839),
  [12796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(841),
  [12798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2523),
  [12800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2609),
  [12802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1034),
  [12804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4026),
  [12806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2476),
  [12808] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__lambda_parameters, 1, 0, 0),
  [12810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3294),
  [12812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2524),
  [12814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2494),
  [12816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4304),
  [12818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2607),
  [12820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(836),
  [12822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(35),
  [12824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3444),
  [12826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3448),
  [12828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(928),
  [12830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(791),
  [12832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3460),
  [12834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(777),
  [12836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1828),
  [12838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1825),
  [12840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(775),
  [12842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1832),
  [12844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2603),
  [12846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(767),
  [12848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(765),
  [12850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8741),
  [12852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2554),
  [12854] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [12856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(719),
  [12858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(738),
  [12860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2529),
  [12862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2530),
  [12864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4271),
  [12866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2531),
  [12868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(742),
  [12870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2533),
  [12872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7758),
  [12874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2543),
  [12876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7841),
  [12878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7738),
  [12880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(745),
  [12882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(747),
  [12884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(748),
  [12886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(750),
  [12888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2544),
  [12890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2546),
  [12892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2548),
  [12894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1789),
  [12896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1787),
  [12898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2549),
  [12900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2587),
  [12902] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_expression, 4, 0, 57),
  [12904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4225),
  [12906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1820),
  [12908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2550),
  [12910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7689),
  [12912] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_top_level, 4, 0, 57),
  [12914] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_filter_clause, 4, 0, 0),
  [12916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7768),
  [12918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3463),
  [12920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4755),
  [12922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3467),
  [12924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7792),
  [12926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3471),
  [12928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2635),
  [12930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2506),
  [12932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1027),
  [12934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3476),
  [12936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3478),
  [12938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3479),
  [12940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2507),
  [12942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4191),
  [12944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2552),
  [12946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3485),
  [12948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3486),
  [12950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2585),
  [12952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2589),
  [12954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3488),
  [12956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3489),
  [12958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1778),
  [12960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2508),
  [12962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3490),
  [12964] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_calling_convention, 5, 0, 0),
  [12966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3491),
  [12968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1715),
  [12970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3495),
  [12972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9673),
  [12974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5359),
  [12976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1090),
  [12978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8848),
  [12980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3500),
  [12982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4095),
  [12984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4094),
  [12986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3214),
  [12988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3502),
  [12990] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_member_declaration_list, 5, 0, 0),
  [12992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5276),
  [12994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3503),
  [12996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1699),
  [12998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(643),
  [13000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1697),
  [13002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2455),
  [13004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2459),
  [13006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3504),
  [13008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3505),
  [13010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8893),
  [13012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1060),
  [13014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3506),
  [13016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3511),
  [13018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3509),
  [13020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(641),
  [13022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(979),
  [13024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8211),
  [13026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2594),
  [13028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4335),
  [13030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4097),
  [13032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2536),
  [13034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3507),
  [13036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(982),
  [13038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3497),
  [13040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5261),
  [13042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(989),
  [13044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1612),
  [13046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3326),
  [13048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3492),
  [13050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1061),
  [13052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3437),
  [13054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1000),
  [13056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8861),
  [13058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1063),
  [13060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1006),
  [13062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8863),
  [13064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1007),
  [13066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3351),
  [13068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3975),
  [13070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3971),
  [13072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8913),
  [13074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3970),
  [13076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1088),
  [13078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(301),
  [13080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(674),
  [13082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8276),
  [13084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1083),
  [13086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3376),
  [13088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2441),
  [13090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7246),
  [13092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1375),
  [13094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1087),
  [13096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1084),
  [13098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5401),
  [13100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(852),
  [13102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(677),
  [13104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8226),
  [13106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7800),
  [13108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7798),
  [13110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1344),
  [13112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7714),
  [13114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1024),
  [13116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3300),
  [13118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8219),
  [13120] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9581),
  [13122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8235),
  [13124] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9586),
  [13126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8269),
  [13128] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9588),
  [13130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1186),
  [13132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1185),
  [13134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1095),
  [13136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5364),
  [13138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9884),
  [13140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1182),
  [13142] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_undef, 3, 0, 0),
  [13144] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_define, 3, 0, 0),
  [13146] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_error, 3, 0, 0),
  [13148] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_nullable, 3, 0, 0),
  [13150] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_line, 3, 0, 0),
  [13152] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_line, 15, 0, 0),
  [13154] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_line, 14, 0, 0),
  [13156] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_endregion, 3, 0, 11),
  [13158] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_region, 3, 0, 11),
  [13160] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_pragma, 6, 0, 0),
  [13162] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_region, 2, 0, 0),
  [13164] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_endregion, 2, 0, 0),
  [13166] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_pragma, 5, 0, 0),
  [13168] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_line, 4, 0, 0),
  [13170] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_nullable, 4, 0, 0),
  [13172] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_pragma, 4, 0, 0),
};

enum ts_external_scanner_symbol_identifiers {
  ts_external_token__optional_semi = 0,
  ts_external_token_interpolation_regular_start = 1,
  ts_external_token_interpolation_verbatim_start = 2,
  ts_external_token_interpolation_raw_start = 3,
  ts_external_token_interpolation_start_quote = 4,
  ts_external_token_interpolation_end_quote = 5,
  ts_external_token_interpolation_open_brace = 6,
  ts_external_token_interpolation_close_brace = 7,
  ts_external_token_interpolation_string_content = 8,
};

static const TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__optional_semi] = sym__optional_semi,
  [ts_external_token_interpolation_regular_start] = sym_interpolation_regular_start,
  [ts_external_token_interpolation_verbatim_start] = sym_interpolation_verbatim_start,
  [ts_external_token_interpolation_raw_start] = sym_interpolation_raw_start,
  [ts_external_token_interpolation_start_quote] = sym_interpolation_start_quote,
  [ts_external_token_interpolation_end_quote] = sym_interpolation_end_quote,
  [ts_external_token_interpolation_open_brace] = sym_interpolation_open_brace,
  [ts_external_token_interpolation_close_brace] = sym_interpolation_close_brace,
  [ts_external_token_interpolation_string_content] = sym_interpolation_string_content,
};

static const bool ts_external_scanner_states[9][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__optional_semi] = true,
    [ts_external_token_interpolation_regular_start] = true,
    [ts_external_token_interpolation_verbatim_start] = true,
    [ts_external_token_interpolation_raw_start] = true,
    [ts_external_token_interpolation_start_quote] = true,
    [ts_external_token_interpolation_end_quote] = true,
    [ts_external_token_interpolation_open_brace] = true,
    [ts_external_token_interpolation_close_brace] = true,
    [ts_external_token_interpolation_string_content] = true,
  },
  [2] = {
    [ts_external_token_interpolation_regular_start] = true,
    [ts_external_token_interpolation_verbatim_start] = true,
    [ts_external_token_interpolation_raw_start] = true,
  },
  [3] = {
    [ts_external_token_interpolation_regular_start] = true,
    [ts_external_token_interpolation_verbatim_start] = true,
    [ts_external_token_interpolation_raw_start] = true,
    [ts_external_token_interpolation_close_brace] = true,
  },
  [4] = {
    [ts_external_token_interpolation_close_brace] = true,
  },
  [5] = {
    [ts_external_token_interpolation_open_brace] = true,
    [ts_external_token_interpolation_string_content] = true,
  },
  [6] = {
    [ts_external_token_interpolation_end_quote] = true,
    [ts_external_token_interpolation_open_brace] = true,
    [ts_external_token_interpolation_string_content] = true,
  },
  [7] = {
    [ts_external_token__optional_semi] = true,
  },
  [8] = {
    [ts_external_token_interpolation_start_quote] = true,
  },
};

#ifdef __cplusplus
extern "C" {
#endif
void *tree_sitter_c_sharp_external_scanner_create(void);
void tree_sitter_c_sharp_external_scanner_destroy(void *);
bool tree_sitter_c_sharp_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_c_sharp_external_scanner_serialize(void *, char *);
void tree_sitter_c_sharp_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef TREE_SITTER_HIDE_SYMBOLS
#define TS_PUBLIC
#elif defined(_WIN32)
#define TS_PUBLIC __declspec(dllexport)
#else
#define TS_PUBLIC __attribute__((visibility("default")))
#endif

TS_PUBLIC const TSLanguage *tree_sitter_c_sharp(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym__identifier_token,
    .external_scanner = {
      &ts_external_scanner_states[0][0],
      ts_external_scanner_symbol_map,
      tree_sitter_c_sharp_external_scanner_create,
      tree_sitter_c_sharp_external_scanner_destroy,
      tree_sitter_c_sharp_external_scanner_scan,
      tree_sitter_c_sharp_external_scanner_serialize,
      tree_sitter_c_sharp_external_scanner_deserialize,
    },
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
